              Text files distributed by AIPSSERV           01/30/90

     This file documents the various categories of text files
distributed by AIPSSERV.  In some of these cases these is a further text
file describing the details.  To obtain a text file in plain text form,
send AIPSSERV a message of the form:
sendplain logical:filename.ext
where "logical" is the logical name of the directory and "filename.ext"
is the name of the desired file.  Multiple files may be obtained by
multiple "sendplain" commands, one per line.  Sending AIPSSERV a
message:
help
will cause it to send you a complete description of its functions.

Installation Problems:
---------------------
   When problems with an installation of AIPS appear, a file will be
created named "DOC:VMSNOTES.yyn" and/or "DOC:UNIXNOTES.yyn" where "yy"
is the last two digits of the year number and "n" is "A", "B", "C" or
"D" for the 15JAN, 15APR, 15JUL or 15OCT release and "VMS" and "UNIX"
refer to the VMS and Unix versions.  These files will describe known
problems and fixes for these problems.  For example, to obtain the
VMSNOTES file for 15JAN90 send AIPSSERV the message:
sendplain doc:vmsnotes.90a

CHANGE.DOC:
----------
   The old versions of the software change documentation files,
CHANGE.DOC, will be kept in area AIPSPUBL with names of the form
"CHANGED.yyn" where "yy" is the last two digits of the year number
and "n" is "A", "B", "C" or "D" for the 15JAN, 15APR, 15JUL
or 15OCT release.  For example, to obtain the CHANGE.DOC file for
15JAN90 send AIPSSERV the message:
sendplain aipspubl:changed.90a
Note that we are no longer distributing CHANGE.DOC as part of the
AIPSLetter.

Ionospheric data:
----------------
   Polarization calibration of interferometric observations made at low
radio frequencies frequently need to have corrections applied for the
Faraday rotation of the signal through the ionosphere.  Measurments
suitable for the calibration of the VLA made at Boulder, Colorado
using the AIPS task FARAD will be made available using AIPSSERV.  These
files will be kept in a directory with logical name AIPSIONS.  These
files will be named TECB.yy where yy are the last two digits of the
year.  The data will be entered into the appropriate file as it becomes
available to the NRAO; this is typically several months  after the fact.
As an example, to fetch the file containing information for February
1989 send AIPSSERV the message:
sendplain aipsions:tecb.89
 

                 Instructions for LaTeXing Going AIPS
                          W. D. Cotton
                            02/05/90

Running Latex:
------- -----

   In the file gavol*.tex there is an includeonly statment which gives
the names of the files to actually include.  Only this statment needs to
be changed to process a limited number of chapters.  When making the
index file (gavol*.idx) all of the chapters, appendices etc. should be
included or they will not show up in the index.  On CVAX:

$ texini
$ latex gavol1
$ dviqms gavol1
$ las gavol1.bit

   On the Sun system the file can be LaTeXed and previewed but cannot be
printed on one of the normal NRAO printers.  LaTeX must be run on a
machine running version 4... of Sun OS.  To run Tex stuff one needs to
add the following to the .cshrc file in his home directory:

alias   tex             /home/ccc/local/bin/tex.3.5
alias   las             "lpr -d"
alias   preview         /home/ccc/local/bin/dvitool.3.5
alias   dviqms          /home/ccc/local/bin/dvips810
alias   addtex          "set path=($path /home/ccc/local/bin)"

Then saying addtex to the monitor will add the directory with the Tex
exectuables to your search path.  Note: do this in a window that you
don't mind having hung up when ccc goes down.  With the above
declarations, Tex and preview can be run on Suns under OS 3.5.  Latex
needs to be run under 4...

   To run LaTeX type:
% addtex                      (only needed once)
% latex gavol1

   To run the previewer (only works if you are running suntools on that
machine):

% addtex                      (only needed once)
% preview gavol1

    Unfortunately the .dvi files cannot be copied to CVAX and processed
there; latex has to be rerun.


Making the Index
------ --- -----

   Latex doesn't have a complete set of tools for making a complete
index.  LaTeX will make an .idx file with all of the index instructions
in it.  However, it contains no tools for translating this into a .tex
file that you need to actually make an index.  Chris Flatters has
written a korn shell script that will do this operation for a flat index
(i.e. no subindexing).   This is in a file named gaindex.ksh.  At
present this can only be from a Convex using the syntax:

% ksh gaindex.ksh gavol1.idx > index1.tex      ( for Going AIPS vol 1)

The resulting .tex file can then be included into the document.  Some
editing will be needed; see notes in gavol?.tex.

   The necessary korn shell script is:
# gaindex -- make an index for Going AIPS
# April 13, 1989
#-----------------------------------------------------------------------
#   A LaTeX .idx file is converted to the correct form to be used in
#   the LaTeX "theindex" environment.  The finished index is printed on
#   the standard output.  Note: the page numbers are sorted into
#   alphabetic rather than numeric order.
#
#   Usage: gaindex .idx_file
# from Bourne shell
#  %ksh gaindex file.idx > index.tex
#-----------------------------------------------------------------------
# Check number of arguments:
    if (($# != 1))
    then printf -u2 Usage: gaindex .idx_file
         exit 1
         fi

awk ' { startstr = index($0, "{") + 1
        endstr = index($0, "}")
        len = length($0)
        str = substr($0, startstr, endstr - startstr)
        rest = substr($0, endstr + 2, len - endstr - 1)
        endch = index(rest, "-")
        ch = substr(rest, 1, endch - 1)
        endpg = index(rest, "}")
        pg = substr(rest, endch + 2, endpg - endch - 2)
        printf "%s|%s|%s\n", str, ch, pg }' $1 |
    sort -nt\| +2 |
    sort -nt\| +1 |
    sort -ft\| +0 -1 |
    uniq |
    awk 'BEGIN	{ FS = "|"; oldstr = "" }
	        { if ($1 == oldstr)
                     printf ", %d--%d", $2, $3
                  else
                    {
                       oldstr = $1
                       printf "\n\\item %s %d--%d", $1, $2, $3
	            }
                 }'



Making figures
------ -------

   The program fig will allow you to make figures using a interactive
graphics tool.  An executable for Sun OS 3.5 of this program is on
gorilla in /usr/bin.  The source, icon etc are in ~bcotton/fig on
gorilla.  For Sun OS 4... there is an executable in /home/ccc/local/bin
(i.e. the addtex will add this directory to your search path).

   There doesn't seem to be any documentation for fig at nrao but with a
little playing around it is mostly obvious.  There are some bugs but
basically it works.  When you have what you want you should write the
result into a file name ending in .fig (it only seems to write into the
default directory).  Then you have to translate the .fig file into
something useful.

TransFig

   This program(s) translates .fig files into any of a number of
potentially useful forms.  Documentation for this may be obtained from
WDC or DCW.   The output formats that are available are: PicTeX,
postscript, LaTeX, epic, eepic and tpic.  Of these I have only tried the
Latex version.  This is probably the most restrictive of the set but for
the simple figures in Going AIPS it is sufficient.  (Only straight line
segments and text are likely to work.

   This is only available on Sun OS 4...  After the addtex command you
can run transfig to produce a latex file from a figure in myfig.fig with:

% transfig -L latex myfig.fig
% make -f Makefile myfig.tex

   The output of TransFig still needs a bit of work to make it useable.
In particular, the text is specified to be written as a font macro
\svtntt.  I couldn't find this so I changed it to \rm.  Unfortunately,
this font is not quite the right size and the text is written in blocks
of 3 letters.  This combination results in rather unpleasing figures so
I concatenated the blocks of text so that the spacing between characters
is OK.  Also, sometimes the text doesn't come out quite where you want
it so you can change the location in the put command used for text:
\put(xloc,yloc){\makebox......
Usually changing xloc by 5 or 10 units is sufficient; use the previewer
to check the results.
   Something in this procedure offends dviqms on CVAX and it claims
"checksum mismatch" but seems to produce the correct results.

   The figures for Going AIPS volumn 1 are: popsfig, aipsfig, sysfig,
aplfig, qfig, docfig, aplfig, incfig, qyfig and yfig.


Making the Shopping Lists
------ --- -------- -----

   The shopping lists can be made using the utility programs SHOPA
and SHOPB.  These tasks should work on either VMS or Unix but the
description given here is biased towards Unix.  In either case, a
logical/environment variable named MYDIR needes to be set to point to
the directory that you are working in
(e.g. %setenv MYDIR /mnt/myname/aips).
Both of these programs use AIPS i/O utilities so are excessively verbose
and hard to kill.

   SHOPA extracts the one liners from a list of files given in a file
in MYDIR named SHOPA.LIS one name per line, the first line of the
file should be the logical name of the directory being extracted.  Only
one directory per run of SHOPA may be processed.
   SHOPA opens its output file SHOPA.OUT with append so it mak be
run as many times as necessary.  The directories needed for the Appendix
to Going AIPS are APLSUB, APLNOT, APLGEN, AIPSUB, QPSAP, QNOT, QSUB,
YSUB, YNOT and YGEN.
   SHOPA.LIS can be formed under Unix as shown in the following
example for $APLSUB: (the initial directory is to be MYDIR)
%setenv MYDIR `pwd`
%echo APLSUB > SHOPA.LIS
%cd $APLSUB
%"ls" *.FOR *.C >> $MYDIR/SHOPA.LIS    (the double quotes may be
                                           necessary if you have ls
                                           aliased to some nonstandard)
%cd $MYDIR

   SHOPA.OUT needs to be sorted and merged to a file named
shopping.sort; this can be done under Unix using:
%sort +0 -4 -u -f -o shopping.sort SHOPA.OUT

   SHOPB can then be used to reformat this file.  SHOPB reads
MYDIR:shopping.sort and writes MYDIR:shopping.list.  This output file
will probably need some hand editing before putting into Going AIPS;
especially adding the \subsection{...} around the category names,
discarding the rest of the category line and putting \begin{verbatim}
and \end{verbatim} around the category listings.  This is easily done
with an emacs keyboard macro.

----------------------------------------------------------------------
;  Copyright (C) 1995
;  Associated Universities, Inc. Washington DC, USA.
;
;  This program is free software; you can redistribute it and/or
;  modify it under the terms of the GNU General Public License as
;  published by the Free Software Foundation; either version 2 of
;  the License, or (at your option) any later version.
;
;  This program is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU General Public License for more details.
;
;  You should have received a copy of the GNU General Public
;  License along with this program; if not, write to the Free
;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
;  MA 02139, USA.
;
;  Correspondence concerning AIPS should be addressed as follows:
;         Internet email: aipsmail@nrao.edu.
;         Postal address: AIPS Project Office
;                         National Radio Astronomy Observatory
;                         520 Edgemont Road
;                         Charlottesville, VA 22903-2475 USA
----------------------------------------------------------------------

    This directory contains the source files for the AIPS screen
servers for SunView and the X Window System.  The source files are
stored as self-extracting shell archives with the extension .SHR.
This form of distribution is intended to simplify the installation of
these servers on systems that do not have AIPS.  The shell archives
are created using the Unix Bourne shell script AIPSSHAR found in this
directory.

    To install one of the servers first identify the relevant archive
file (or files) from the list below.  Copy this file to the directory
in which you wish to build the server.  If you are installing the
server on a Unix system or any other system that has a Bourne shell
available you can unpack the archive by executing it within the shell.
On a Unix system you may type

    sh <archive>.SHR

or

    chmod +x <archive>.SHR
    <archive>.SHR

    If you do not have a Bourne (or compatible) shell available then
copy the FORTRAN program UNSHR.FOR from this directory to your
machine.  Rename the source file according to the conventions for
FORTRAN programs on your machine and compile and link it.  UNSHR is a
standalone program and is written in strict ANSI FORTRAN 77.  You may
then unpack the archives using UNSHR.  For example, on a VAX/VMS
system, you might type

    FORTRAN UNSHR
    LINK UNSHR
    RUN UNSHR
    Enter name of archive:             (UNSHR prompts for input)
    <archive>.SHR

Note that UNSHR requires the extension (.SHR) to be given explicitly
and that the input file name is case sensitive if your operating
system has case sensitive file names.  Also not that UNSHR will only
operate on AIPS shell archives generated with AIPSSHAR; it will not
handle other forms of Unix shell archive.

    In the unlikely event that you are trying to install a server on a
machine that has neither a Bourne shell nor a FORTRAN compiler you
can, as a last resort, pick the .SHR file apart using an editor.
Decoding the format of the archive (which is fairly trivial) is left
as an exercise.

    Once you have unpacked the archive you may delete the .SHR file.
Note that each archive contains a file named INSTALL.ME that contains
specific instructions for building that particular server.

    Finally, note that if you need to extract files from more than one
archive file you should unpack the archives in separate directories to
avoid files being overwritten in the event of a name clash.


                    FILES IN THIS DIRECTORY

AIPSSHAR        --    Unix shell script used to construct the .SHR
                      files.

README          --    You are reading it.

SSS.SHR         --    The SunView Screen Server source code and Makefile

TVOVER.TEX      --    An overview of the AIPS TV servers and their
                      installation (requires amemo.mac from DOCTXT)

XAS.SHR         --    The X-AIPS Server source code and Makefile

XASVMS.SHR      --    The original set of XAS Z-routines from NRL.
                      This contains support for VMS.
                      This code is not supported by NRAO: CAVEAT EMPTOR

XVSS.SHR        --    The XView Screen Server source code and Makefile

XVSS.UU         --    Uuencoded version of XVSS on-line help file
                      (use uudecode to restore).

UNSHR.FOR       --    Program to unpack .SHR files on antisocial
                      machines without Unix compatible shells.

$APLY
Lexidata Y routines...

YALUCT.c
YCHRW.c
YCNECT.c
YCRCTL.c
YCRCTL2.c
YCUCOR.FOR
YCURSE.c
YCURSE2.c
YFDBCK.c
YGRAPH.c
YIMGIO.c
YINIT.c
YLEXSUB.c
YLNCLR.FOR
YLUT.c
YOFM.c
YRHIST.c
YSCROL.c
YSLECT.c
YSPLIT.c
YTVCIN.FOR
YTVCLS.c
YTVMC.c
YTVOPN.c
YZERO.c
YZOOMC.c

The only unusual (i.e. not defined by AIPS) subroutine here is YLEXSUB.
This is the Lexidata subroutine library as defined by Haystack for a UNIX
based Lexidata.  It attempts to emulate the Lexidata VAX callable library
as supported by Lexidata.  There is one significant addition to these subroutines;
the reopen command 'dsreop_( fp)'.  This takes a file descriptor and passes it
to the Lexidata library (see YTVOPN).

Due to the problem with the Lexidata trackball (cannot assign it to a cursor),
there are two temporary files YCRCTL and YCURSE which read the keyboard for
cursor motion.  If and when the trackball IOP is cured, the routines marked
YCRCTL2 and YCURSE2 should be placed in YCRCTL and YCURSE, respectively.

      SUBROUTINE SETGDS (UVDISK, UVCNO, MODNAM, MODCLS, MODSEQ, MODVOL,
     *   NMOD, VER, NITER, BITER, MODEL, METHOD, BUFFER, IBUFF, ISTOKE,
     *   IERR)
C-----------------------------------------------------------------------
C! Sets up for UV model computation, fills common in DGDS.INC
C# UV Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999-2002, 2004-2005, 2008-2010, 2012,
C;  Copyright (C) 2020, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SETGDS fills in the common /MAPDES/ (include DGDS.INC) needed before
C   calling UVMDIV or UVMSUB.  Mostly it finds the catalog slot numbers
C   of the model files.  The name, class of the first file are given
C   explicitly; the subsequent files are specified by the same name,
C   sequence, disk etc and the same class except for the 5th and 6th
C   characters which will be '01','02'...'15' for the 2nd thru MAXFLD
C   files.  Files are marked 'READ' in catalog and the /CFILES/ common.
C   The DO3DIM parameter is set by comparing image header parameters
C   with the UV data header (include DUVH.INC set by UVPGET before
C   calling SETGDS).  It also resets the MAXABSU parameter if any in
C   the UV data header - this forces UVPROT to recompute it once with
C   the current set of model images.
C   Inputs:
C      UVDISK   I         Disk number of main UV file <= 0 => ignore
C      UVCNO    I         Catalog number of main UV file
C      MODNAM   C*12      Name of model file(s).
C      MODCLS   C*6       Class of first model file.
C      MODSEQ   I         Model file(s) sequence number.
C      MODVOL   I         Model file(s) disk number
C      NMOD     I         Number of model files
C      BITER    I(*)      Number of components to ignore per field.
C      METHOD   I         Modeling method, -1=>DFT, 0=>chose, 1=>gridded
C      BUFFER   R(1024)   Work buffer
C      IBUFF    I(512)    Work buffer
C   In/out:
C      VER      I         CC file(s) version number
C      MODEL    I         Model type 0 => choose, 1=>CC, 2=>image
C                            3 => subimage Changed if CC files not found
C      NITER    I(*)      Maximum number of components per field - out =
C                         actual number to be used.
C                         NITER(I) < 0 -> max (field(i))
C                         NITER(I) = = -> max (i) only if all NITER 0
C      METHOD   I         Modeling method, -1=>DFT, 0=>chose, 1=>gridded
C   Output:
C      ISTOKE   I         Stokes' type of first model file.
C      IERR     I         Return code, 0=>OK, otherwise failed.
C                            3 => CC requested and not found
C                            2 => status, 4 => I/O, 6 => open fails
C                            5 => mixed epoch
C-----------------------------------------------------------------------
      CHARACTER MODNAM*12, MODCLS*6
      INTEGER   UVDISK, UVCNO, MODSEQ, MODVOL, NMOD, VER, NITER(*),
     *   BITER(*), MODEL, METHOD, IBUFF(*), ISTOKE, IERR
      REAL      BUFFER(*)
C
      CHARACTER STOKES*8, CLAT*6, ITYPE*2, STAT*4, CHTEMP*8
      HOLLERITH CATCH(256)
      INTEGER   I, LUNC, CATCLN(256), ISOFF, JNREC, JLREC, NKEY, SUM2,
     *   I4T, NCEN, NOFF, ONCE, IRET, J0, JJ, LOCS(2), VALUES(2),
     *   KEYTYP(2), IRAOFF, IDECOF, ONCED, ONCEC, J, K, MX, MY, MXOFF,
     *   MYOFF, MSGSAV, CCMVER
      REAL      CATCR(256), PMAT(3,3), MAXBLN, UMATN(3,3), RVALS(2)
      DOUBLE PRECISION CATCD(128), CLNRA, CLNDEC
      LOGICAL   WASOME, OLDNAM, FORCED, LFORCE, DOUMAT, WASDIF, ISUV,
     *   WASOFF, IN3D, FIRST
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   CCNUMV(MAXCCC), CCKOLS(MAXCCC), CCNCOL, CCRNO
      EQUIVALENCE (RVALS, VALUES)
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INTEGER   TMPFLD(4,MAXFLD)
      EQUIVALENCE (CATCLN, CATCR, CATCH, CATCD)
      SAVE ONCE, ONCED, ONCEC
      DATA LUNC, ONCE, ONCED, ONCEC /29, -1, -1, -1/
      DATA STOKES /'STOKES  '/
C-----------------------------------------------------------------------
      FIRST = .TRUE.
      MSGSAV = MSGSUP
      WASDIF = .FALSE.
      IF ((UVDISK.LE.0) .OR. (UVCNO.LE.0)) THEN
         DOUMAT = .FALSE.
         UVROT = 0.0
      ELSE
         DOUMAT = (UVDISK.NE.ONCED) .OR. (UVCNO.NE.ONCEC)
         ONCED = UVDISK
         ONCEC = UVCNO
         END IF
      IN3D = DO3DIM
C                                       header of main UV: get rot
      IF (DOUMAT) THEN
         CALL CATIO ('READ', UVDISK, UVCNO, CATCLN, 'REST', IBUFF,
     *      IRET)
         IF ((IRET.NE.0) .AND. (IRET.NE.6)) THEN
            IERR = 4
            IF (IRET.GT.4) IERR = 2
            WRITE (MSGTXT,1015) IRET, UVDISK, UVCNO
            GO TO 990
            END IF
         CALL ROTFND (CATCR, UVROT, IRET)
         END IF
C                                       Other info
      MFIELD = NMOD
      SUM2 = 0
      CLAT = MODCLS
      NCEN = 0
      NOFF = 0
      IERR = 0
      WASOME = .FALSE.
      OLDNAM = (CLAT(4:4).LT.'0') .OR. (CLAT(4:4).GT.'9') .OR.
     *   (CLAT(5:5).LT.'0') .OR. (CLAT(5:5).GT.'9') .OR.
     *   (CLAT(6:6).LT.'0') .OR. (CLAT(6:6).GT.'9')
      IF (.NOT.OLDNAM) THEN
         IF ((CLAT(3:3).LT.'0') .OR. (CLAT(3:3).GT.'9')) THEN
            READ (CLAT(4:6),1009) J0
         ELSE
            READ (CLAT(3:6),1008) J0
            END IF
         END IF
      DO 20 I = 1,NMOD
         IF (NITER(I).GT.0) WASOME = .TRUE.
 20      CONTINUE
C                                       Loop thru other fields.
 25   WASOFF = .FALSE.
      CLAT = MODCLS
      DO 40 I = 1,NMOD
         IF (FIRST) THEN
            CCDISK(I) = MODVOL
            CCVER(I) = VER
            NCLNG(I) = NITER(I)
            NSUBG(I) = MAX (1, BITER(I))
            CCCNO(I) = 1
            END IF
C                                       Set class.
         IF (OLDNAM) THEN
            I4T = I - 1
            IF (I.NE.1) CALL ZEHEX (I4T, 2, CLAT(5:6))
         ELSE
            JJ = I - 1 + J0
            IF (JJ.LE.999) THEN
               WRITE (CLAT(4:6),1010) JJ
            ELSE
               WRITE (CLAT(3:6),1011) JJ
               END IF
            END IF
         ITYPE = '  '
         CALL CATDIR ('SRCH', CCDISK(I), CCCNO(I), MODNAM, CLAT, MODSEQ,
     *       ITYPE, NLUSER, STAT, IBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, MODNAM, CLAT, MODSEQ, ITYPE,
     *      CCDISK(I), NLUSER
            IERR = 2
            IF (IRET.EQ.5) IERR = 3
            IF (IRET.EQ.3) IERR = 4
            GO TO 990
            END IF
C                                       Read catalog block
         STAT = 'REST'
         IF (FIRST) STAT = 'READ'
         CALL CATIO ('READ', CCDISK(I), CCCNO(I), CATCLN, STAT, IBUFF,
     *      IRET)
         IF (IRET.NE.0) THEN
            IERR = 4
            IF (IRET.GT.4) IERR = 2
            WRITE (MSGTXT,1015) IRET, CCDISK(I), CCCNO(I)
            GO TO 990
            END IF
         IF (FIRST) THEN
            IF (I.EQ.1) ISUV = ITYPE.EQ.'UV'
            IF ((ISUV) .AND. (ITYPE.NE.'UV')) THEN
               MSGTXT = 'MODEL FILES OF MIXED MA AND UV TYPES' //
     *            ' NOT ALLOWED'
               IERR = 5
               GO TO 990
               END IF
C                                       Do NOT mark in /CFILES/
C                                       force tiny => DFT for UV
            IF (ITYPE.EQ.'UV') THEN
               TMPFLD(1,I) = 24
               TMPFLD(2,I) = 24
               TMPFLD(3,I) = 24
               TMPFLD(4,I) = 24
C                                       Check FLDSIZ
            ELSE
               CALL IMGSIZ (CATCLN, CATCR, MX, MY, MXOFF, MYOFF, IRET)
               IF (IRET.GT.0) WASOFF = .TRUE.
               TMPFLD(1,I) = MX
               TMPFLD(2,I) = MY
               TMPFLD(3,I) = CATCLN(KINAX)
               TMPFLD(4,I) = CATCLN(KINAX+1)
               END IF
C                                       Get stokes' type for first
            IF (I.EQ.1) THEN
               CALL AXEFND (8, STOKES, KICTPN, CATCH(KHCTP), ISOFF,
     *            IRET)
               IF (CATCD(KDCRV+ISOFF).GT.0.0D0) THEN
                  ISTOKE = CATCD(KDCRV+ISOFF) + 0.01D0
               ELSE
                  ISTOKE = CATCD(KDCRV+ISOFF) - 0.01D0
                  END IF
               END IF
C                                       epoch
            IF (DEQUIN.NE.CATCR(KREPO)) THEN
               IERR = 5
               WRITE (MSGTXT,1016) I, CATCR(KREPO), DEQUIN
               CALL MSGWRT (8)
               MSGTXT = 'USE UVFIX ON THE UV DATA OR EPOSW ON THE IMAGE'
               GO TO 990
               END IF
            END IF
C                                       3D image?
         CHTEMP = 'RA'
         CALL AXEFND (2, CHTEMP, KICTPN, CATCH(KHCTP), IRAOFF, IERR)
         CHTEMP = 'DEC'
         CALL AXEFND (3, CHTEMP, KICTPN, CATCH(KHCTP), IDECOF, IERR)
         IF (FIRST) THEN
            IF (((ABS(CATCR(KRCRP+IRAOFF)-CATCLN(KINAX+IRAOFF)/2.0).LT.
     *         0.01) .AND. (ABS(CATCR(KRCRP+IDECOF)-1.0-
     *         CATCLN(KINAX+IDECOF)/2.0).LT.0.01)) .OR.
     *         (CATCLN(KIITY).EQ.2) .OR. (ISUV)) NCEN = NCEN + 1
            IF ((ABS(CATCD(KDCRV+IRAOFF)-RA).GT.
     *         0.01*ABS(CATCR(KRCIC+IRAOFF))) .OR.
     *         (ABS(CATCD(KDCRV+IDECOF)-DEC).GT.
     *         0.01*ABS(CATCR(KRCIC+IDECOF)))) NOFF = NOFF + 1
            END IF
C                                       rotation matrix in case
         IF (DOUMAT) THEN
            IF (.NOT.WASDIF) CALL RCOPY (9, UMATS(1,1,I), UMATN)
            CLNRA = CATCD(KDCRV+IRAOFF)
            CLNDEC = CATCD(KDCRV+IDECOF)
            CALL ROTFND (CATCR, MAPROT, IRET)
            IF (DO3DIM) THEN
               CALL PRJMAT (RA, DEC, UVROT, CLNRA, CLNDEC, MAPROT,
     *            UMATS(1,1,I), PMAT)
            ELSE
               CALL P2DMAT (RA, DEC, UVROT, CLNRA, CLNDEC, MAPROT,
     *            UMATS(1,1,I), PMAT)
               END IF
            IF (.NOT.WASDIF) THEN
               DO 35 K = 1,3
                  DO 30 J = 1,3
                     IF (ABS(UMATS(J,K,I)-UMATN(J,K)).GT.3.0E-6)
     *                  WASDIF = .TRUE.
 30                  CONTINUE
 35               CONTINUE
               END IF
            END IF
C                                       Check model type.
         IF ((MODEL.LT.2) .AND. (FIRST)) THEN
C                                       Get number of CC.
            JNREC = 1
            JLREC = 3
            NKEY = 0
            CALL FNDEXT ('CC', CATCLN, CCMVER)
            IF (CCVER(I).LT.1) CCVER(I) = CCMVER
            IF ((CCVER(I).GT.CCMVER) .AND. (CCMVER.GT.0)) THEN
               WRITE (MSGTXT,1035) I, CCDISK(I), CCCNO(I), CCVER(I),
     *            CCMVER
               CALL MSGWRT (7)
               CCVER(I) = CCMVER
               END IF
            IF (MODEL.EQ.0) MSGSUP = 32000
            CALL CCMINI ('READ', IBUFF, CCDISK(I), CCCNO(I), CCVER(I),
     *         CATCLN, LUNC, CCRNO, CCKOLS, CCNUMV, CCNCOL, IRET)
            MSGSUP = MSGSAV
            IF (IRET.EQ.2) THEN
               IERR = 0
               NCLNG(I) = 0
               NITER(I) = 0
            ELSE IF (IRET.GT.0) THEN
               IERR = 4
               IF (IRET.EQ.2) IERR = 3
               IF (MODEL.EQ.0) IERR = 0
C                                       If problem, use image
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1020) IRET
                  CALL MSGWRT (6)
                  MSGTXT = '*** WARNING: OVERRIDING SPECIFIED' //
     *               ' COMPUTATION METHOD'
                  IF ((METHOD.NE.1) .AND. (METHOD.NE.0)) CALL MSGWRT (6)
                  END IF
               MODEL = 2
               METHOD = 1
C                                       Check number of components.
            ELSE
               I4T = IBUFF(5)
               IF (NCLNG(I).LT.0) NCLNG(I) = I4T
               IF ((.NOT.WASOME) .AND. (NCLNG(I).EQ.0)) NCLNG(I) = I4T
               IF (NCLNG(I).GT.I4T) NCLNG(I) = I4T
               IF (NCLNG(I).GE.NSUBG(I)) SUM2 = SUM2 +
     *            NCLNG(I) - NSUBG(I) + 1
C                                       Reset NITER to true value
               NITER(I) = NCLNG(I)
C                                       Close CLEAN components file.
               CALL TABIO ('CLOS', 1, I4T, BUFFER, IBUFF, IRET)
               IF ((METHOD.NE.-1) .AND. (CCNUMV(4).GT.0)) THEN
                  METHOD = -1
                  MSGTXT = 'SETGDS: forces DFT because of 3D CC table'
                  CALL MSGWRT (6)
                  END IF
               END IF
            END IF
 40      CONTINUE
C                                       Check that there are Comps.
      IF (FIRST) THEN
         IF (SUM2.LE.0) THEN
            IF (MODEL.EQ.1) THEN
               MSGTXT = 'NO CLEAN COMPONENTS, WILL USE IMAGE'
               CALL MSGWRT (6)
               IERR = 3
               END IF
            MODEL = 2
            METHOD = 1
            END IF
         MODEL = MAX (1, MODEL)
C                                       Check/set 3D
         DO3DIM = .FALSE.
         IF (NOFF.EQ.0) THEN
            MSGTXT = 'SETGDS: imaging done with one tangent plane'
            IF ((MFIELD.GT.1) .AND. (ONCE.NE.1)) THEN
               CALL MSGWRT (2)
               MSGTXT = 'SETGDS: WARNING, THIS HAS CHANGED'
               IF (ONCE.NE.-1) CALL MSGWRT (6)
               END IF
            ONCE = 1
            IF (ISUV) DO3DIM = .TRUE.
         ELSE IF (NCEN.EQ.NMOD) THEN
            DO3DIM = .TRUE.
            MSGTXT = 'SETGDS: imaging done with reprojected tangent'
     *         // ' point(s)'
            IF (ONCE.NE.2) THEN
               CALL MSGWRT (4)
               MSGTXT = 'SETGDS: WARNING, THIS HAS CHANGED'
               IF (ONCE.NE.-1) CALL MSGWRT (6)
               END IF
            ONCE = 2
         ELSE IF (NCEN.EQ.0) THEN
            MSGTXT = 'SETGDS: imaging done with one OFFSET' //
     *         ' tangent plane'
            IF (ONCE.NE.3) THEN
               CALL MSGWRT (2)
               MSGTXT = 'SETGDS: WARNING, THIS HAS CHANGED'
               IF (ONCE.NE.-1) CALL MSGWRT (6)
               END IF
            ONCE = 3
         ELSE
            WRITE (MSGTXT,1050) NCEN, NOFF, NMOD
            CALL MSGWRT (7)
            ONCE = 0
            END IF
         IF ((DO3DIM) .AND. (WASOFF)) THEN
            MSGTXT = 'DO3DIM SET TRUE, BUT REF PIXELS NOT ALL INTEGER!'
            CALL MSGWRT (8)
            MSGTXT = 'LIKELY TO CAUSE REAL PROBLEMS IN MODELING'
            CALL MSGWRT (8)
            END IF
         IF ((DO3DIM.NEQV.IN3D) .AND. (DOUMAT)) THEN
            FIRST = .FALSE.
            GO TO 25
            END IF
         END IF
C                                       set FLDSZ if needed
      DO 50 I = 1,NMOD
         IF (MODEL.EQ.3) THEN
            IF (FLDSZ(1,I).LE.0) FLDSZ(1,I) = TMPFLD(1,I)
            IF (FLDSZ(2,I).LE.0) FLDSZ(2,I) = TMPFLD(2,I)
         ELSE
            IF (FLDSZ(1,I).LE.0) FLDSZ(1,I) = TMPFLD(3,I)
            IF (FLDSZ(2,I).LE.0) FLDSZ(2,I) = TMPFLD(4,I)
            END IF
 50      CONTINUE
C                                       check DFT needed?
         LFORCE = FORCED (NMOD, FLDSZ(1,1))
C                                       forced method
         IF (LFORCE) THEN
            IF (METHOD.EQ.1) THEN
               MSGTXT = 'IMAGE SIZES => DFT IS MUCH BETTER THAN GRIDDED'
     *            // ' CONTINUING ANYWAY'
               CALL MSGWRT (8)
            ELSE IF (METHOD.EQ.0) THEN
               METHOD = -1
               END IF
            END IF
C                                       Header keyword
      IF ((DOUMAT) .AND. (WASDIF)) THEN
         CALL CATKEY ('REED', UVDISK, UVCNO, 'MAXABSU ', 1, LOCS,
     *      VALUES, KEYTYP, BUFFER, I)
         IF ((I.EQ.0) .AND. (LOCS(1).GT.0)) THEN
            CALL COPY (1, RVALS(LOCS(1)), MAXBLN)
            MAXBLN = -ABS(MAXBLN)
         ELSE
            MAXBLN = -1.0
            END IF
         LOCS(1) = 1
         CALL RCOPY (1, MAXBLN, RVALS(1))
C                                       Record Max Baseline in header
         KEYTYP(1) = 2
         CALL CATKEY ('WRIT', UVDISK, UVCNO, 'MAXABSU', 1, LOCS,
     *      VALUES, KEYTYP, BUFFER, I)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,2X,A2,' DISK=',
     *   I3,' USID=',I4)
 1008 FORMAT (I4)
 1009 FORMAT (I3)
 1010 FORMAT (I3.3)
 1011 FORMAT (I4.4)
 1015 FORMAT ('ERROR',I3,' COPYING CATBLK DISK,CNO',I3,I6)
 1016 FORMAT ('SETGDS: IMAGE',I5,' EPOCH',F7.1,' UV EPOCH',F7.1)
 1020 FORMAT ('PROBLEM WITH CC FILE(ERROR=',I3,'), WILL USE THE IMAGE')
 1035 FORMAT ('SETGDS FACET',I5,' DISK',I3,' CNO',I5,'  CC VER',I4,
     *   ' RESET TO',I4)
 1050 FORMAT ('SETGDS: CENTERED',I3,' OFFSET',I3,' IN',I3,' MODELS',
     *   ' 3DIMAG INCONSISTENT')
      END

      SUBROUTINE TABGN (OPCODE, BUFFER, GNROW, GNCOLS, GNNUMV, NUMPOL,
     *   ANTNUM, SUBARR, FREQID, TYPE, NTERM, XTYPE, YTYPE, XVALUE,
     *   YVALUE, GAIN, SENS, IRET)
C-----------------------------------------------------------------------
C! Read a record from a FITS interchange gain curve table
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1998, 2007, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Read a single record from a FITS interferometry data interchange
C   gain curve (GN) table that has been opened using GNINI or close a GN
C   table that was opened using GNINI.
C
C   Inputs:
C      OPCODE   C*4          Operation to perform:
C                              'READ' - read a record
C                              'CLOS' - close table
C      GNCOLS   I(MAXGNC)    Column index array from GNINI (ignored
C                              if OPCODE = 'CLOS')
C      GNNUMV   I(MAXGNC)    Column dimensions array from GNINI
C                              (ignored if OPCODE = 'CLOS')
C      NUMPOL    I           Number of polarizations from GNINI (ignored
C                              if OPCODE = 'CLOS').
C
C   Input/output:
C      BUFFER   I(512)       Table I/O control block and buffers
C                              (will be modified)
C      GNROW    I            Table row to be read if OPCODE = 'READ';
C                              incremented by 1 on exit if the record
C                              was read successfully. Ignored if
C                              OPCODE = 'CLOS'.
C
C   Output:
C      ANTNUM   I            Antenna number if OPCODE = 'READ'
C      SUBARR   I            Subarray number if OPCODE = 'READ'
C      FREQID   I            Frequency ID if OPCODE = 'READ'
C      TYPE     I(2, MAXIF)  Gain curve type for each polarization and
C                              IF if OPCODE = 'READ'
C      NTERM    I(2, MAXIF)  Number of terms for each polarization and
C                              IF if OPCODE = 'READ'
C      XTYPE    I(2, MAXIF)  X-value type for each polarization and
C                              IF if OPCODE = 'READ'
C      YTYPE    I(2, MAXIF)  Y-value type for each polarization and
C                              IF if OPCODE = 'READ'
C      XVALUE   R(2, MAXIF)  Tabulated x-values in degrees for each
C                              polarization and IF if OPCODE = 'READ'
C      YVALUE   R(2, MXTBGN, MAXIF)
C                            Tabulated y-values in degrees for each
C                              polarization and IF if OPCODE = 'READ'
C      GAIN     R(2, MXTBGN, MAXIF)
C                            Tabulated gains corresponding to
C                              tabulated y-values if OPCODE = 'READ'
C      SENS     R(2, MAXIF)  Sensitivities in K/Jy for each polarization
C                              and IF if OPCODE = 'READ'
C      IRET     I            Return code:
C                              0 - record read (OPCODE = 'READ') or
C                                  table closed (OPCODE = 'CLOS)
C                              1 - GNROW beyond end of table
C                                  (OPCODE = 'WRIT')
C                              2 - I/O error detected
C                            999 - Invalid call to TABGN
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PTAB.INC'
      INCLUDE 'INCS:PGNV.INC'
C
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), GNROW, GNCOLS(MAXGNC), GNNUMV(MAXGNC),
     *          NUMPOL, ANTNUM, SUBARR, FREQID, TYPE(2, MAXIF),
     *          NTERM(2, MAXIF), XTYPE(2, MAXIF), YTYPE(2, MAXIF), IRET
      REAL      XVALUE(2, MAXIF), YVALUE(2, MXTBGN, MAXIF),
     *          GAIN(2, MXTBGN, MAXIF), SENS(2, MAXIF)
C
C     Local Variables
C
C     IREC       Integer valued buffer
C     RREC       Real valued buffer
C     NUMIF      Number of IFs in table
C     NTABS      Number of tabulated vales in table
C     I          Loop index
C     J          Loop index
C
      INTEGER   IREC(GNRSIZ)
      REAL      RREC(GNRSIZ)
      INTEGER   NUMIF, NTABS, I, J
      EQUIVALENCE (IREC, RREC)
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (OPCODE .EQ. 'READ') THEN
         CALL TABIO (OPCODE, TIOROW, GNROW, IREC, BUFFER, IRET)
         IF (IRET.LE.0) THEN
            GNROW = GNROW + 1
            NUMIF = GNNUMV(4)
            NTABS = GNNUMV(9) / NUMIF
            ANTNUM = IREC(GNCOLS(1))
            SUBARR = IREC(GNCOLS(2))
            FREQID = IREC(GNCOLS(3))
            DO 20 I = 1,NUMIF
               TYPE(1,I)   = IREC(GNCOLS(4) + I - 1)
               NTERM(1,I)  = IREC(GNCOLS(5) + I - 1)
               XTYPE(1,I)  = IREC(GNCOLS(6) + I - 1)
               YTYPE(1,I)  = IREC(GNCOLS(7) + I - 1)
               XVALUE(1,I) = RREC(GNCOLS(8) + I - 1)
               DO 10 J = 1, NTABS
                  YVALUE(1,J,I) = RREC(GNCOLS(9) + NTABS * (I - 1)
     *               + J - 1)
                  GAIN(1,J,I)   = RREC(GNCOLS(10) + NTABS * (I - 1)
     *               + J - 1)
   10             CONTINUE
               SENS(1,I)   = RREC(GNCOLS(11) + I - 1)
   20          CONTINUE
            IF (NUMPOL.EQ.2) THEN
               DO 40 I = 1,NUMIF
                  TYPE(2,I)   = IREC(GNCOLS(12) + I - 1)
                  NTERM(2,I)  = IREC(GNCOLS(13) + I - 1)
                  XTYPE(2,I)  = IREC(GNCOLS(14) + I - 1)
                  YTYPE(2,I)  = IREC(GNCOLS(15) + I - 1)
                  XVALUE(2,I) = RREC(GNCOLS(16) + I - 1)
                  DO 30 J = 1, NTABS
                     YVALUE(2,J,I) = RREC(GNCOLS(17) + NTABS * (I - 1)
     *                  + J - 1)
                     GAIN(2,J,I)   = RREC(GNCOLS(18) + NTABS * (I - 1)
     *                  + J - 1)
   30                CONTINUE
                  SENS(2,I)   = RREC(GNCOLS(19) + I - 1)
   40             CONTINUE
               END IF
         ELSE IF (IRET.EQ.4) THEN
            WRITE (MSGTXT,9040) GNROW, BUFFER(5)
            CALL MSGWRT (6)
            IRET = 1
         ELSE
            CALL TABERR (OPCODE, 'TABIO ', 'TABGN ', IRET)
            IRET = 2
            END IF
      ELSE IF (OPCODE .EQ. 'CLOS') THEN
         CALL TABIO (OPCODE, 0, GNROW, IREC, BUFFER, IRET)
         IF (IRET .NE. 0) THEN
            CALL TABERR (OPCODE, 'TABIO ', 'TABGN ', IRET)
            IRET = 2
            END IF
      ELSE
         WRITE (MSGTXT, 9041) OPCODE
         CALL MSGWRT (8)
         IRET = 999
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 9040 FORMAT ('TABGN: ROW ', I6, ' BEYOND END OF TABLE AT ', I6,' ROWS')
 9041 FORMAT ('TABGN: UNRECOGNIZED OPCODE ''', A, '''')
      END

      SUBROUTINE CALRES (APCORE, JERR)
C-----------------------------------------------------------------------
C! Tim Cornwell routine to calculate the residuals of an image.
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2015, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C Calculate residuals of image. Be careful to do correlation step
C properly for optical images
C   Programmer =  T.J. Cornwell      January 1991
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER    JERR, IFIELD
      REAL       CHISAV, VAL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                        Find residuals of current guess
      CHISQ = 0.0
      DO 100 IFIELD = 1,NFIELD
         VAL = 1 / RVAR(IFIELD)
         CHISAV = CHISQ
C                                        Focal or aperture plane data ?
         IF (BEAMTP(IFIELD).GT.0) THEN
C                                        Primary beam correction ?
         IF (BMSIZE(IFIELD).GT.0) THEN
            CALL APPLPB(IFIELD, IMG, PRS, JERR)
            IF (JERR.NE.0) GO TO 990
            CALL CONV (APCORE, F, PRS, VAL, WT(IFIELD), PRS, JERR)
            IF (JERR.NE.0) GO TO 990
            CALL RESID (IFIELD, PRS, PRS, JERR)
            IF (JERR.NE.0) GO TO 990
            IF (IFIELD.EQ.1) THEN
               CALL APPLPB(IFIELD, PRS, RES, JERR)
               IF (JERR.NE.0) GO TO 990
            ELSE
               CALL APPLPB (IFIELD, PRS, PRS, JERR)
               IF (JERR.NE.0) GO TO 990
               CALL ADDMAP (PRS, RES, RES, 0.0, RESMAX, RESMIN, JERR)
               IF (JERR.NE.0) GO TO 990
               END IF
         ELSE
            CALL CONV (APCORE, F, IMG, VAL, WT(IFIELD), PRS, JERR)
            IF (JERR.NE.0) GO TO 990
            IF (IFIELD.EQ.1) THEN
               CALL RESID (IFIELD, PRS, RES, JERR)
               IF (JERR.NE.0) GO TO 990
            ELSE
               CALL RESID (IFIELD, PRS, PRS, JERR)
               IF (JERR.NE.0) GO TO 990
               CALL ADDMAP (PRS, RES, RES, 0.0, RESMAX, RESMIN, JERR)
               IF (JERR.NE.0) GO TO 990
               END IF
            END IF
         ELSE
C                                                Focal plane data
            CALL CONV (APCORE, T, IMG, VAL, WT(IFIELD), PRS, JERR)
            IF (JERR.NE.0) GO TO 990
            CALL RESID (IFIELD, PRS, PRS, JERR)
            IF (JERR.NE.0) GO TO 990
            IF (IFIELD.EQ.1) THEN
               CALL CORR (APCORE, T, PRS, VAL, WT(IFIELD), RES, JERR)
               IF (JERR.NE.0) GO TO 990
            ELSE
               CALL CORR (APCORE, T, PRS, VAL, WT(IFIELD), PRS, JERR)
               IF (JERR.NE.0) GO TO 990
               CALL ADDMAP (PRS, RES, RES, 0.0, RESMAX, RESMIN, JERR)
               IF (JERR.NE.0) GO TO 990
               END IF
            END IF
C                                                Save fit for this
C                                                field
         FFIT(IFIELD) = SQRT((CHISQ-CHISAV)/RWNXY)
  100    CONTINUE
C                                                Save overall fit
      FITRMS = SQRT(CHISQ/(NFIELD*RWNXY))
      GO TO 999
C
 990  WRITE (MSGTXT,1000)
      CALL MSGWRT (8)
      IERR = 1
C
 999  CONTINUE
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CALRES')
      END

      SUBROUTINE POP (STACK, SP, ITEM)
C-----------------------------------------------------------------------
C! pops item from stack
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   POP takes the last item on the stack STACK and places it in ITEM.
C   The stack pointer SP is decremented.
C   Inputs:
C      STACK   I(100)   stack (upper size not checked)
C      SP      I        current stack pointer
C   Outputs:
C      ITEM    I        last item on current stack
C      SP      I        revised stack pointer
C-----------------------------------------------------------------------
      INTEGER   STACK(*), SP, ITEM
C
      CHARACTER PRGNAM*6
      INCLUDE 'INCS:DERR.INC'
      DATA PRGNAM /'POP   '/
C-----------------------------------------------------------------------
      IF (SP.LE.0) GO TO 980
         ITEM = STACK(SP)
         SP = SP - 1
         GO TO 999
C                                      Error: stack pointer < 0
 980  ERRNUM = 7
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
      END

      SUBROUTINE TKSLPL (ISLUN, ISFIND, RANGE2, BLC, TRC, IERR)
C-----------------------------------------------------------------------
C! plot a slice on graphics device
C# Slice Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Given an open slice file and an open TEK device, TKSLPL will draw
C   the slice.
C   Inputs:
C      ISLUN   I       logical unit no. of open slice file.
C      ISFIND  I       FTAB index for slice file.
C      RANGE2  R(2)    min and max pixel value allowed for plot.
C      BLC     R(7)    bottom left corner of the plot.
C      TRC     R(7)    top right corner of plot; value 1 - 4000
C   Output:
C      IERR    I       error code: 0 = none.
C                         1 = error during graphing. Try finish.
C                         2 = fatal error. Give up.
C   Common
C      /WORK/ SBLK  R(256)  I/O buffer for slice file.
C-----------------------------------------------------------------------
      INTEGER   ISLUN, ISFIND, IERR
      REAL      RANGE2(2), BLC(7), TRC(7)
C
      REAL      X, Y, SCALEF, OFFSET, SBLK(1)
      INTEGER   ISTART, IEND, IRRN, IPOS, ILOW, INP, ISL, NRPBLK
      LOGICAL   BLAST, BNEXT
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /WORK/ SBLK
C-----------------------------------------------------------------------
C                                       Draw plot.
      NRPBLK = 256
      SCALEF = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      OFFSET = 40000.0 - SCALEF * CATR(IRRAN+1)
      ISTART = BLC(1) + .5
      IEND = TRC(1) + .5
      IRRN = 3 + (ISTART - 1) / NRPBLK
      IPOS = ISTART - ((IRRN - 3) * NRPBLK)
C                                       Set range parameters.
      ILOW = RANGE2(1) + .5
C                                       Read first data.
      CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, SBLK, IERR)
      IF (IERR.NE.0) GO TO 930
C                                       Draw first data pt.
      X = ISTART
      Y = SCALEF * SBLK(IPOS)  +  OFFSET
      BLAST = SBLK(IPOS).EQ.FBLANK
      Y = MIN (Y, RANGE2(2))
      Y = MAX (Y, RANGE2(1))
      CALL TEKVEC (X, Y, 1, IERR)
      IF (IERR.NE.0) GO TO 950
C                                       Do rest of data points.
      ISTART = ISTART + 1
      DO 20 ISL = ISTART,IEND
         IPOS = IPOS + 1
C                                       Read from slice file.
         IF (IPOS.LE.NRPBLK) GO TO 10
            IRRN = IRRN + 1
            CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, SBLK, IERR)
            IF (IERR.NE.0) GO TO 930
            IPOS = 1
C                                       Draw to next slice pt.
 10      X = ISL
         Y = SCALEF * SBLK(IPOS)  +  OFFSET
         BNEXT = SBLK(IPOS).EQ.FBLANK
         Y = MIN (Y, RANGE2(2))
         Y = MAX (Y, RANGE2(1))
         INP = 2
         IF ((BNEXT) .OR. (BLAST)) INP = 1
         BLAST = BNEXT
         CALL TEKVEC (X, Y, INP, IERR)
         IF (IERR.NE.0) GO TO 950
 20      CONTINUE
C                                       Force alpha mode to allow
C                                       screen to auto-dim
      ISTART = 31
      CALL ZTKBUF (ISTART, 1, IERR)
C                                       Write final TEK buffer.
      CALL TEKFLS (IERR)
      IF (IERR.EQ.0) GO TO 999
      GO TO 950
C                                       Slice read error.
 930  IERR = 1
      WRITE (MSGTXT,1930)
      CALL MSGWRT (6)
      GO TO 999
C                                       TEK write error.
 950  IERR = 2
      WRITE (MSGTXT,1950)
      CALL MSGWRT (7)
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1930 FORMAT ('SLICE FILE READ ERROR.')
 1950 FORMAT ('TEKTRONIX 4012 WRITE ERROR.')
      END

      LOGICAL FUNCTION REQBAS (I, J, DESEL, IANT, NANT, IBAS, NBAS)
C-----------------------------------------------------------------------
C! Apply ANTENNA and BASELINE selection adverbs to a baseline
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   REQBAS returns a value of .TRUE. if baseline I-J is in the set
C   defined by the ANTENNAS and BASELINE adverbs. On entry, IANT should
C   contain the absolute values of the ANTENNAS adverb values and IBAS
C   should contain the BASELINE adverb values; zeros may be removed from
C   the ANTENNAS and BASELINE adverb arrays as IANT and IBAS are
C   constructed and this practice is recommended for efficiency. The
C   exact selection rules are as follows:
C   NANT   NBAS      Result
C     0      0       T
C    >0      0       (I in IANT) .OR. (J in IANT)
C     0     >0       (I in IBAS) .OR. (J in IBAS)
C    >0     >0       ((I in IANT) .AND. (J in IBAS)) .OR.
C                    ((I in IBAS) .AND. (J in IANT))
C   If DESEL is True, .NOT.Result is returned instead.
C   Inputs:
C      I       I       Antenna number #1 (I .GT. 0)
C      J       I       Antenna number #2 (J .GT. 0)
C      DOSEL   L       .TRUE. if specified baseline are to be rejected
C      IANT    I(*)    Absolute values of ANTENNAS adverb list
C      NANT    I       Number of entries in IANT (NANT .GE. 0)
C      IBAS    I(*)    Absolute values of BASELINE adverb list
C      NBAS    I       Number of entries in IBAS (NBAS .GE. 0)
C-----------------------------------------------------------------------
      INTEGER   I, J, IANT(*), NANT, IBAS(*), NBAS
      LOGICAL   DESEL
C
      INTEGER   INDEX
      LOGICAL   IINANT, IINBAS, JINANT, JINBAS, RESULT
C-----------------------------------------------------------------------
C                                       both zero
      IF ((NANT.LE.0) .AND. (NBAS.LE.0)) THEN
         RESULT = .TRUE.
C                                       one or both non-zero
      ELSE
C                                       check ANTENNA array
         IINANT = .FALSE.
         JINANT = .FALSE.
         INDEX = 0
 10      IF (((.NOT.IINANT) .OR. (.NOT.JINANT)) .AND. (INDEX.LT.NANT))
     *      THEN
            INDEX = INDEX + 1
            IINANT = IINANT .OR. (I.EQ.IANT(INDEX))
            JINANT = JINANT .OR. (J.EQ.IANT(INDEX))
            GO TO 10
            END IF
C                                       check BASELINE array
         IINBAS = .FALSE.
         JINBAS = .FALSE.
         INDEX = 0
 20      IF (((.NOT.IINBAS) .OR. (.NOT.JINBAS)) .AND. (INDEX.LT.NBAS))
     *      THEN
            INDEX = INDEX + 1
            IINBAS = IINBAS .OR. (I.EQ.IBAS(INDEX))
            JINBAS = JINBAS .OR. (J.EQ.IBAS(INDEX))
            GO TO 20
            END IF
C                                       IINANT is true iff I occurs in
C                                       array section IANT(1:NANT) and
C                                       JINANT is true iff J occurs in
C                                       array section IANT(1:NANT).
         IF (NBAS.LE.0) THEN
            RESULT = IINANT .OR. JINANT
C                                       IINBAS is true iff I is in array
C                                       subsection IBAS(1:NBAS) and
C                                       JINBAS is true iff J is in array
C                                       subsection IBAS(1:NBAS).
         ELSE IF (NANT.LE.0) THEN
            RESULT = IINBAS .OR. JINBAS
C                                       require 1 in one and 1 in other
         ELSE
            RESULT = (IINANT.AND.JINBAS) .OR. (IINBAS.AND.JINANT)
            END IF
         END IF
C                                       return result or negative
      IF (DESEL) THEN
         REQBAS = .NOT.RESULT
      ELSE
         REQBAS = RESULT
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'CHKERR.INC'
      INTEGER   NERRS
      CHARACTER ERRNAM(4,1000)*10
      COMMON /ERRINT/ NERRS
      COMMON /ERRCHR/ ERRNAM
LOCAL END
      PROGRAM ADVCHK
C-----------------------------------------------------------------------
C! Extracts adverbs from help files
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Program to extract the adverb list from all task, verb, proc, etc
C   help files.  It writes a text file of the task name and the adverb
C   in 2 columns.
C      A logical or enviroment variable named MYDIR must be defined
C   before running ADVCHK.
C      The output will be written to a file named ADVCHK.OUT.
C-----------------------------------------------------------------------
      CHARACTER INLINE*100, LFIL*48, SUBNAM*12, ADVNAM*10,
     *   SUBS(1000)*12, LNAME*10
      INTEGER   IOERR, BUFFER(512), LUNL, FINDL, NCHK, I, LUNO, FINDO,
     *   IRET
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'CHKERR.INC'
      DATA LUNL, LUNO /18,11/
C-----------------------------------------------------------------------
C                                       AIPS system start up stuff
      TSKNAM ='ADVCHK'
      NPOPS = 1
      MSGKIL = 32000
      MSGSUP = 32000
      CALL ZDCHIN (.FALSE., BUFFER)
      MSGKIL = 32000
      MSGSUP = 32000
      DEVTAB(LUNL) = 3
      NLUSER = 1
      NERRS = 0
C                                       Get list of routines
      LFIL = 'MYDIR:ADVHLP.SRT'
      CALL ZTXOPN ('READ', LUNL, FINDL, LFIL, .FALSE., IOERR)
      IF (IOERR.NE.0) GO TO 999
      LFIL = 'MYDIR:ADVCHK.chk'
      CALL ZTXOPN ('WRIT', LUNO, FINDO, LFIL, .TRUE., IOERR)
      IF (IOERR.NE.0) GO TO 999
      NCHK = 0
      LNAME = ' '
C                                       Begin looping over files
 100     CALL ZTXIO ('READ', LUNL, FINDL, INLINE, IOERR)
         IF ((IOERR.NE.0) .AND. (IOERR.NE.2)) GO TO 890
         IF (INLINE.EQ.' ') GO TO 100
         SUBNAM = INLINE(:12)
         ADVNAM = INLINE(15:24)
         IF (IOERR.EQ.2) ADVNAM = ' '
         IF ((NCHK.GT.0) .AND. (ADVNAM.EQ.LNAME) .AND.
     *      (SUBNAM.EQ.SUBS(NCHK))) GO TO 100
         IF ((ADVNAM.NE.LNAME) .AND. (NCHK.GT.0)) THEN
            CALL CHKIT (LNAME, NCHK, SUBS, LUNO, FINDO, IRET)
            NCHK = 0
            END IF
         IF (IOERR.EQ.2) GO TO 900
         NCHK = NCHK + 1
         LNAME = ADVNAM
         SUBS(NCHK) = SUBNAM
         GO TO 100
C
 890  WRITE (6,1890) IOERR
C                                       Done - close files
 900  CALL ZTXCLS (LUNL, FINDL, IOERR)
      CALL ZTXCLS (LUNO, FINDO, IOERR)
      DO 910 I = 1,NERRS
         WRITE (MSGTXT,1900) ERRNAM(1,I), ERRNAM(2,I), ERRNAM(3,I),
     *      ERRNAM(4,I)
         CALL MSGWRT (5)
 910     CONTINUE
C
 999  STOP
C-----------------------------------------------------------------------
 1890 FORMAT (' ERROR READING FILE ',A)
 1900 FORMAT ('MISSING FILE ',A,' FROM',3(1X,A))
      END
      SUBROUTINE CHKIT (ADVNAM, NCHK, TASKS, LUNO, FINDO, IRET)
C-----------------------------------------------------------------------
C   check adverb help file ADVNAM for all tasks (verbs, procs,...)
C   in list
C   Inputs
C      ADVNAM   C*(*)      Adverb name
C      NCHK     I          Number of tasks
C      TASKS    C(*)*(*)   Task list
C-----------------------------------------------------------------------
      INTEGER   NCHK, LUNO, FINDO, IRET
      CHARACTER ADVNAM*(*), TASKS(*)*(*)
C
      INCLUDE 'INCS:DMSG.INC'
      INTEGER   LUNI, FINDI, J, JTRIM, IERR, K, I, L
      CHARACTER INLINE*100, LFIL*48, SYM*10, OUTLIN*512, LTASKS*400
      INCLUDE 'CHKERR.INC'
C-----------------------------------------------------------------------
      LUNI = 3
      J = JTRIM (ADVNAM)
      LFIL = 'HLPFIL:' // ADVNAM(:J) // '.HLP'
      CALL ZTXOPN ('QRED', LUNI, FINDI, LFIL, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         NERRS = NERRS + 1
         ERRNAM(1,NERRS) = ADVNAM
         ERRNAM(2,NERRS) = TASKS(1)
         ERRNAM(3,NERRS) = TASKS(2)
         ERRNAM(4,NERRS) = TASKS(3)
         GO TO 999
         END IF
 10   CALL ZTXIO ('READ', LUNI, FINDI, INLINE, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING ' // ADVNAM(:J)
         GO TO 990
         END IF
      IF (INLINE(:1).EQ.';') GO TO 10
      CALL GETADV (INLINE, SYM)
      IF (SYM.NE.' ') THEN
         K = JTRIM (SYM)
         DO 20 I = 1,NCHK
            IF (SYM(:K).EQ.TASKS(I)(:K)) THEN
               TASKS(I) = ' '
               GO TO 10
               END IF
 20         CONTINUE
         WRITE (MSGTXT,1020) ADVNAM(:J), SYM(:K)
         CALL MSGWRT (5)
         END IF
      GO TO 10
C
 990  IF (IERR.NE.2) THEN
         CALL MSGWRT (8)
      ELSE
         L = 0
         LTASKS = ' '
         DO 995 I = 1,NCHK
            WRITE (MSGTXT,1990) ADVNAM(:J), TASKS(I)
            IF (TASKS(I).NE.' ') THEN
               CALL MSGWRT (5)
               IF (L.GT.0) THEN
                  LTASKS(L+1:) = ','
                  L = L + 1
               END IF
               K = JTRIM (TASKS(I))
               LTASKS(L+1:) = TASKS(I)
               L = L + K
               END IF
 995        CONTINUE
         IF (L.GT.0) THEN
            WRITE (OUTLIN,1995) LTASKS(:L), ADVNAM(:J)
            K = JTRIM (OUTLIN)
            CALL ZTXIO ('WRIT', LUNO, FINDO, OUTLIN(:K), IRET)
            END IF
         END IF
      CALL ZTXCLS (LUNI, FINDI, I)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CHKIT ERROR',I4,' ON ',A)
 1020 FORMAT (A,' has symbol ',A,' not in task list')
 1990 FORMAT (A,' has task ',A,' not in help file')
 1995 FORMAT ('echo "',A,'" | chkout $HLPFIL/',A,'.HLP')
      END
      SUBROUTINE GETADV (INLINE, SYM)
C-----------------------------------------------------------------------
C   Looks for listing if task et al in adverb help file
C   Input
C      INLINE   C*(*)   line from help file
C   Output
C      SYM      C(*)   the task
C-----------------------------------------------------------------------
      CHARACTER INLINE*(*), SYM*(*)
C
      INTEGER   I, I1, IC
      CHARACTER LCH*1
C-----------------------------------------------------------------------
      SYM = ' '
C                                       find first non-blank
      DO 10 I = 1,2
         IF (INLINE(I:I).NE.' ') GO TO 999
 10      CONTINUE
      DO 15 I = 3,6
         IF (INLINE(I:I).NE.' ') GO TO 20
 15      CONTINUE
      GO TO 999
 20   I1 = I
      DO 30 I = I1,I1+9
         LCH = INLINE(I:I)
         IF (LCH.EQ.'.') THEN
            IF (I.GT.I1) SYM = INLINE(I1:I-1)
            GO TO 900
            END IF
         IC = ICHAR(LCH)
         IF ((IC.GE.ICHAR('A')) .AND. (IC.LE.ICHAR('Z'))) GO TO 30
         IF ((IC.GE.ICHAR('0')) .AND. (IC.LE.ICHAR('9'))) GO TO 30
         GO TO 999
 30      CONTINUE
      GO TO 999
C
 900  IC = ICHAR(SYM(1:1))
      IF ((IC.GE.ICHAR('0')) .AND. (IC.LE.ICHAR('9'))) SYM = ' '
C
 999  RETURN
      END
      SUBROUTINE GETSYM (LBUFF, NPNT, SYM, IERR)
C-----------------------------------------------------------------------
C   GETSYM scrutinizes a card image to look for the next symbol.  A
C   symbol begins with a letter and contains up to eight alpha-numeric
C   characters (A-Z,0-9,_).  This routine is used for interpreting a
C   FITS tape and for interpreting the HI files.
C   Inputs:
C      LBUFF  C*)*)   Loose packed card image
C      NPNT   I       Pointer to first character
C   Output:
C      NPNT   I       Pointer value after getting symbol
C      SYM    C*(*)   Symbol, padded with blanks
C      IERR   I       Return code
C                      0--> Found legal symbol followed by '='
C                      1--> Ran off the end of the card
C                      2--> Symbol had too many characters
C                      4--> Found a '/' symbol
C                      5--> Symbol contains an illegar char
C-----------------------------------------------------------------------
      CHARACTER LBUFF*(*), SYM*(*)
      INTEGER   NPNT, IERR
C
      CHARACTER LCH*1, TSYM*8
      INTEGER   LPNT, LIMIT, IC, NKAR, NKL
      DATA LIMIT /80/
C-----------------------------------------------------------------------
C                                       Initialization
      LIMIT = LEN (LBUFF)
      NKL = LEN (SYM)
      NKAR = 0
      IERR = 0
      SYM = ' '
C                                       Check card limit
 10   IF (NPNT.GT.LIMIT) GO TO 980
C                                       Skip leading blanks
         LCH = LBUFF(NPNT:NPNT)
         IF (LCH.NE.' ') GO TO 20
            NPNT = NPNT + 1
            GO TO 10
C                                       Is the first character legal?
 20   IC = ICHAR(LCH)
      IF ((IC.GE.ICHAR('A')) .AND. (IC.LE.ICHAR('Z'))) GO TO 40
C                                       If we find a '/', good bye
         IF (LCH.EQ.'/') GO TO 940
C                                       Not legal.  Skip to next blank
 30      NPNT = NPNT + 1
         IF (NPNT.GT.LIMIT) GO TO 980
            LCH = LBUFF(NPNT:NPNT)
            IF (LCH.NE.' ') GO TO 30
C                                       Found another blank. begin
C                                       searching again
         NPNT = NPNT + 1
         GO TO 10
C                                       Find rest of symbol
 40   LPNT = NPNT
 50   NKAR = NKAR + 1
      IF (NKAR.LE.NKL) TSYM(NKAR:NKAR) = LCH
         NPNT = NPNT + 1
         IF (NPNT.GT.LIMIT) GO TO 980
         LCH = LBUFF(NPNT:NPNT)
         IC = ICHAR(LCH)
C                                       Is the character legal?
         IF ((IC.GE.ICHAR('A')) .AND. (IC.LE.ICHAR('Z'))) GO TO 50
         IF ((IC.GE.ICHAR('0')) .AND. (IC.LE.ICHAR('9'))) GO TO 50
         IF (LCH.EQ.'_') GO TO 50
         IF (LCH.EQ.'-') GO TO 50
C                                       Have we hit a ' ' or
C                                          a '='?
      IF (LCH.EQ.'=') GO TO 70
      IF (LCH.EQ.' ') GO TO 65
C                                       Illegal char.  Look for
C                                          the next space.
 62   NPNT = NPNT + 1
      IF (NPNT.GT.LIMIT) GO TO 980
      IF (LBUFF(NPNT:NPNT).NE.' ') GO TO 62
      GO TO 930
C                                       Look for an '='
C                                         or an end of card
 65   NPNT = NPNT + 1
      IF (NPNT.GT.LIMIT) GO TO 67
      IF (LBUFF(NPNT:NPNT).EQ.' ') GO TO 65
      IF (LBUFF(NPNT:NPNT).EQ.'=') GO TO 70
C                                       Legal symbol with no '='
 67   NPNT = NPNT - 2
C                                      Legal symbol with an '='
 70   NPNT = NPNT + 1
      IF (NKAR.GT.NKL) GO TO 970
C                                       Pack symbol
      SYM = TSYM(1:NKAR)
      IF (IERR.NE.0) GO TO 999
C                                       Check for HISTORY =, etc.
      IF (SYM.EQ.'HISTORY ') GO TO 999
      IF (SYM.EQ.'COMMENT ') GO TO 999
      IERR = 0
      GO TO 999
C
C-----------------------------------------------------------------------
C
C                                       Symbol contains illegal char
 930  IERR = 5
      GO TO 999
C                                       Found a '/' symbol
 940  IERR = 4
      NPNT = NPNT + 1
      GO TO 999
C                                       Symbol has more than 8 char
 970  IERR = 2
      GO TO 999
C                                       Ran out of card
 980  IERR = 1
C
 999  RETURN
      END

       PROGRAM SLCOL
C-----------------------------------------------------------------------
C! Collates slice data and models
C# EXT-appl Text Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2001, 2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task to collate slice information.
C   Note: I believe that SLICEs are written to disk as floating point
C   numbers with the inverse of the image scale and offset factors
C   applied.  Thus, this program applies the image scale and offset
C   factors when reading in slice and model data.   If you rescale an
C   image, the new scale factors will therefore be applied to the slice.
C   Inputs:
C 1      USERID (1)      user no.
C 2-4    INNAME (3)      image name
C 5-6    INCLASS (2)     image class
C 7      INSEQ (1)       image sequence number
C 8      INDISK (1)      image disk number
C 9-20   OUTFILE (12)    output file name
C 21     INVERS (1)      start slice number
C 22     NFILES (1)      number of slices
C 23     ZINC (1)        save a slice point every ZINC asecs ('SLVL')
C 24-30  PIXXY (7)       x-y coordinate of reference pixel
C 31     OPCODE (1)      'MODL', AND 'SLVL'
C 32     APARM(1)        <=0 => don't output blank slice points
C                        ('SLVL')
C 33     APARM(2)        <=0 => Overwrite any existing text file
C                        >0  => Append to any existing text file
C
C   Neil Killeen, NRAO, June  1987
C                 UofIll, April 1988
C-----------------------------------------------------------------------
      REAL      RPARM(33)
      CHARACTER PRGNAM*6
      INTEGER   NPARMS, IER, IERR, IMSLOT, IMVOL
      INCLUDE 'INCS:DMSG.INC'
C                                       Fixed PPM 1996.09.30: was 33
      DATA NPARMS, PRGNAM /40, 'SLCOL '/
C-----------------------------------------------------------------------
C                                          start up task, get parameters
      CALL TSKBEG (PRGNAM, NPARMS, RPARM(2), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         END IF
      RPARM(1) = NLUSER
C                                          get header from image
      CALL IMHEAD (RPARM, IMSLOT, IMVOL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,2000) IERR
         GO TO 900
         END IF
C                                          collate slices
      CALL COLATE (RPARM, IMSLOT, IMVOL, IERR)
      IF (IERR.NE.0) WRITE (MSGTXT,3000) IERR
C-----------------------------------------------------------------------
 900  IF (IERR.NE.0) THEN
         IER = 1
         CALL MSGWRT (8)
         CALL CLENUP
      ELSE
         IER = 0
         END IF
      CALL TSKEND (IER)
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR GETTING INPUTS,  IERR=', I4)
 2000 FORMAT ('ERROR GETTING IMAGE HEADER, IERR=', I4)
 3000 FORMAT ('ERROR COLLATING SLICES, IERR=', I4)
      END
      SUBROUTINE IMHEAD (RPARM, SLOT, VOL, IERR)
C-----------------------------------------------------------------------
C   Get the header and catalog location of the associated image
C   Input:
C      RPARM     R       array of AIPS input parameters
C   Output:
C      SLOT      I       catalog slot of image
C      VOL       I       volume number (disk) of image
C      IERR      I       error status, 0=> OK
C-----------------------------------------------------------------------
      CHARACTER IMNAM*36
      HOLLERITH MAP
      REAL   RPARM(*)
      INTEGER   LUN, IERR, CATBLK(256), SLOT, VOL, I
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DITB.INC'
      COMMON /HEADS/ CATBLK
      DATA LUN /16/
C-----------------------------------------------------------------------
C                                           set up namestring
      CALL CHR2H (4, 'MA  ', 1, MAP)
      CALL H2WAWA (RPARM(2), RPARM(5), RPARM(7), MAP, RPARM(8),
     *   RPARM(1), IMNAM)
C                                           open file
      CALL OPENCF (LUN, IMNAM, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 900
         END IF
C                                           get header
      CALL GETHDR (LUN, CATBLK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,2000) IERR
         GO TO 900
         END IF
C                                           work out disk and cat slot
      DO 100 I = 1, EFIL
         IF (FILTAB(POLUN, I).EQ.LUN) THEN
            SLOT = FILTAB(POCAT,I)
            VOL  = FILTAB(POVOL,I)
            GO TO 900
         ELSE IF (I.EQ.EFIL) THEN
            WRITE (MSGTXT,3000)
            IERR = 1
            GO TO 900
            END IF
 100     CONTINUE
C                                           report error or
C                                           close image file
 900  IF (IERR.NE.0) THEN
         CALL MSGWRT (8)
      ELSE
         CALL FILCLS (LUN)
         END IF
C
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('IMHEAD: ERROR OPENING ASSOCIATED IMAGE, IERR=', I4)
 2000 FORMAT ('IMHEAD: ERROR GETTING FIRST GRADIENT IMAGE HEADER,',
     *        ' IERR=', I4)
 3000 FORMAT ('IMHEAD: ERROR FINDING IMAGE SLOT AND VOLUME')
      END
      SUBROUTINE COLATE (RPARM, SLOT, VOL, IERR)
C-----------------------------------------------------------------------
C     Collate the slice file information and write disk files if
C     requested
C     Input:
C       RPARM     R      AIPS input parameters
C       SLOT      I      cat slot of associated image
C       VOL       I      volume no. of associated image
C     Output:
C       IERR      I      0 => OK
C-----------------------------------------------------------------------
      CHARACTER MODL*4, OPCODE*4, FILNAM*48
      REAL      RPARM(*)
      REAL      ORIGIN(4), XINC, YINC, SINC
      INTEGER   IERR, ISTART, IEND, SLOT, VOL, LUN, IFIND, MSGSAV
      LOGICAL   IGBLA, TERM, APPEND
      INCLUDE 'INCS:DMSG.INC'
C                                           borrow LUN 10 for text file
      DATA LUN, MODL /10, 'MODL'/
C-----------------------------------------------------------------------
C                                           crunch inputs and header
      CALL EXTPAR (RPARM, XINC, YINC, ISTART, IEND, SINC, ORIGIN,
     *   OPCODE, TERM, IGBLA, APPEND, IERR)
      IF (IERR.NE.0) GO TO 990
C                                           open output text file ?
      IF (.NOT.TERM) THEN
         CALL H2CHR (48, 1, RPARM(9), FILNAM)
         IF (.NOT.APPEND) THEN
            MSGSAV = MSGSUP
            MSGSUP = 32000
            CALL ZTXZAP (LUN, FILNAM, IERR)
            MSGSUP = MSGSAV
            END IF
         CALL ZTXOPN ('WRIT', LUN, IFIND, FILNAM, APPEND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
            GO TO 990
            END IF
         END IF
C                                           now branch for OPCODE
      IF (OPCODE.EQ.MODL) THEN
         CALL DOMODL (SLOT, VOL, XINC, YINC, ISTART, IEND, ORIGIN, TERM,
     *      LUN, IFIND, IERR)
      ELSE
         CALL DOSLVL (SLOT, VOL, XINC, YINC, ISTART, IEND, SINC, ORIGIN,
     *      TERM, LUN, IFIND, IGBLA, IERR)
         END IF
C
 990  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('COLATE: ERROR OPENING OUTPUT TEXT FILE, IERR=', I3)
      END
      SUBROUTINE EXTPAR (RPARM, XINC, YINC, ISTART, IEND, SINC, ORIGIN,
     *   OPCODE, TERM, IGBLA, APPEND, IERR)
C-----------------------------------------------------------------------
C     Extract values from header and AIPS inputs
C     Input:
C       RPARM      R       AIPS parameters
C     Output:
C        XINC      R       X-axis increment (arcsec)
C        YINC      R       Y-axis increment (arcsec)
C        ISTART    I       First slice to collate
C        IEND      I       Last slice to collate
C        SINC      R       save a slice point every SINC arcsec
C        ORIGIN    R       x,y pixel coordinates of reference pixel
C        OPCODE    C*4     'MODL' or 'SLVL'
C        TERM      L       .true. if writing to terminal, else disk file
C        IGBLA     L       Ignore blanks ?
C        APPEND    L       Append or overwrite existing text file
C        IERR      I       0 => OK
C-----------------------------------------------------------------------
      REAL      RPARM(*), XINC, YINC, ORIGIN(4), SINC
      CHARACTER OPCODE*4
      INTEGER   SLMAX, IERR, ISTART, IEND
      LOGICAL   APPEND, IGBLA, TERM
C-----------------------------------------------------------------------
C                                           extract values from header
      CALL EXTHED (XINC, YINC, SLMAX, IERR)
C                                           extract AIPS inputs
      IF (IERR.EQ.0) CALL EXTINP (RPARM, SLMAX, ISTART, IEND, SINC,
     *   ORIGIN, OPCODE, TERM, IGBLA, APPEND, IERR)
C
 999  RETURN
      END
      SUBROUTINE EXTHED (XINC, YINC, SLMAX, IERR)
C-----------------------------------------------------------------------
C     Extract some parameters from the header and change the slice
C     start and end numbers from user given values if necessary
C     Output:
C        XINC      R       X-axis increment (arcsec)
C        YINC      R       Y-axis increment (arcsec)
C        SLMAX     I       maximum number of slices for image
C        IERR      I       0 => OK, else no slices
C-----------------------------------------------------------------------
      REAL      XINC, YINC, CATR(256)
      INTEGER   IERR, SLMAX
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMMON /HEADS/ CATR
C-----------------------------------------------------------------------
C                                          work out increments in arcsec
      XINC = CATR(KRCIC) * 3600.0
      YINC = CATR(KRCIC+1) * 3600.0
C                                          make sure there are slices
      CALL FNDEXT ('SL', CATR, SLMAX)
C                                          double check by looking at
C                                          number of slice files
      IF (SLMAX.LE.0) THEN
         MSGTXT = 'EXTHED: THERE ARE NO SLICES ASSOCIATED WITH THIS'
     *      // ' IMAGE'
         CALL MSGWRT (8)
         IERR = 1
      ELSE
         IERR = 0
         END IF
C
 999  RETURN
      END
      SUBROUTINE EXTINP (RPARM, SLMAX, ISTART, IEND, SINC, ORIGIN,
     *   OPCODE, TERM, IGBLA, APPEND, IERR)
C-----------------------------------------------------------------------
C     Extract parameters from AIPS inputs
C     Input:
C       RPARM    R       AIPS inputs
C       SLMAX    I       Maximum number of slices for image
C     Output:
C       ISTART   I       First slice to collate
C       IEND     I       Last slice to collate
C       SINC     R       save a slice point every SINC arcsec
C       ORIGIN   R       x,y pixel coordinates of reference pixel
C       OPCODE   C*4     'MODL' or 'SLVL'
C       TERM     L       If .true. send output to terminal rather than
C                        disk file.
C       IGBLA    L       Ignore blanks ?
C       APPEND   L       Overwrite or append existing text file
C       IERR     I       0 => OK
C
C AIPS parameters
C
C 1      USERID (1)      user no.
C 2-4    INNAME (3)      image name
C 5-6    INCLASS (2)     image class
C 7      INSEQ (1)       image sequence number
C 8      INDISK (1)      image disk number
C 9-20   OUTFILE (12)    output file name
C 21     INVERS (1)      start slice number
C 22     NFILES (1)      number of slices
C 23     ZINC (1)        save a slice point every ZINC arcsec
C 24-30  PIXXY (7)       x-y coordinate of reference pixel
C 31     OPCODE (1)      'MODL', AND 'SLVL'
C 32     APARM(1)        <=0 => don't output blank slice points ('SLVL'
C                        only)
C 33     APARM(2)        <=0 => Overwrite any existing text file
C                        >0  => Append to any existing text file
C-----------------------------------------------------------------------
      CHARACTER SLVL*4, MODL*4, OPCODE*4, CHTMP*4
      REAL      RPARM(*), ORIGIN(4), SINC, CATR(256)
      INTEGER   SLMAX, ISTART, IEND, NSLICE, IERR, CATBLK(256),
     *   IX, IY
      LOGICAL   IGBLA, TERM, APPEND
      EQUIVALENCE (CATBLK, CATR)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMMON /HEADS/ CATBLK
      DATA SLVL, MODL /'SLVL', 'MODL'/
C-----------------------------------------------------------------------
C                                          Start slice number
      ISTART = RPARM(21) + 0.01
C                                          Take all slices
      IF (ISTART.EQ.0) THEN
         ISTART = 1
         IEND = SLMAX
         WRITE (MSGTXT,1000)
         CALL MSGWRT (4)
C                                          Number of slices to collate
      ELSE
         NSLICE = RPARM(22) + 0.01
         IF (NSLICE.LE.0) NSLICE = 1
         IF (ISTART.LT.0) ISTART = 1
C                                          Make sure start slice exists
         IF (ISTART.GT.SLMAX) THEN
            WRITE (MSGTXT,2000) ISTART
            CALL MSGWRT (7)
            IERR = 1
            GO TO 990
            END IF
C                                          End slice number
         IEND = ISTART + NSLICE - 1
         IF (IEND.GT.SLMAX) THEN
            WRITE (MSGTXT,3000)
            CALL MSGWRT (4)
            IEND = SLMAX
            END IF
C                                          Tell user which slices used
         IF (ISTART.EQ.IEND) THEN
            WRITE (MSGTXT,4000) ISTART
         ELSE
            WRITE (MSGTXT,5000) ISTART, IEND
            END IF
         CALL MSGWRT (4)
         END IF
C                                          Slice point increment, 0=>all
      SINC = RPARM(23)
      IF (SINC.LT.0.0) SINC = 0.0
C                                          Reference position, allow it
C                                          off image, but warn user
      ORIGIN(1) = RPARM(24)
      ORIGIN(2) = RPARM(25)
      IF ((ORIGIN(1).EQ.0.0) .AND. (ORIGIN(2).EQ.0.0)) THEN
         ORIGIN(1) = CATR(KRCRP)
         ORIGIN(2) = CATR(KRCRP+1)
         END IF
      ORIGIN(3) = CATR(KRCRP)
      ORIGIN(4) = CATR(KRCRP+1)
      IX = CATBLK(KINAX)
      IY = CATBLK(KINAX+1)
      IF (ORIGIN(1).LT.1 .OR. ORIGIN(2).LT.1 .OR.
     *    ORIGIN(1).GT.IX .OR. ORIGIN(2).GT.IY) THEN
         WRITE (MSGTXT,6000)
         CALL MSGWRT (8)
         END IF
      WRITE (MSGTXT,6010) ORIGIN(1), ORIGIN(2)
      CALL MSGWRT (4)
      WRITE (MSGTXT,6011) ORIGIN(3), ORIGIN(4)
      CALL MSGWRT (4)
C                                          Make sure opcode OK
      IERR = 0
      CALL H2CHR (4, 1, RPARM(31), CHTMP)
      IF (CHTMP.EQ.MODL .OR. CHTMP.EQ.SLVL) THEN
         OPCODE = CHTMP
      ELSE IF (CHTMP.EQ.'    ') THEN
         OPCODE = SLVL
      ELSE
         WRITE (MSGTXT,7000)
         CALL MSGWRT (8)
         IERR = 1
         GO TO 990
         END IF
C                                          Output to disk or terminal ?
      CALL H2CHR (4, 1, RPARM(9), CHTMP)
      IF (CHTMP.EQ.'    ') THEN
         TERM = .TRUE.
      ELSE
         TERM = .FALSE.
         END IF
C                                          Ignore blanks in slice ?
      IF (RPARM(32).LE.0.0) THEN
         IGBLA = .TRUE.
      ELSE
         IGBLA = .FALSE.
         END IF
C                                          Append or overwrite
      IF (RPARM(33).GT.0.0) THEN
         APPEND = .FALSE.
      ELSE
         APPEND = .TRUE.
         END IF
C
 990  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('EXTINP: Selected all available slices')
 2000 FORMAT ('EXTINP: Start slice = ', I3, ' > actual number of ',
     *        'existing slices')
 3000 FORMAT ('EXTINP: reducing end slice number to maximum available')
 4000 FORMAT ('EXTINP: selected slice number ', I3)
 5000 FORMAT ('EXTINP: selected slice numbers ', I3, ' TO ', I3)
 6000 FORMAT ('EXTINP: WARNING, REFERENCE POSITION OFF IMAGE')
 6010 FORMAT ('Pixel origin X ',F9.2,'  Y',F9.2)
 6011 FORMAT ('Header origin X',F9.2,'  Y',F9.2)
 7000 FORMAT ('EXTINP: UNRECOGNIZED OPCODE')
      END
      SUBROUTINE DOMODL (SLOT, VOL, XINC, YINC, ISTART, IEND, ORIGIN,
     *   TERM, LUN, IFIND, IERR)
C-----------------------------------------------------------------------
C   Main subroutine for the 'MODL' opcode.
C   Input:
C      SLOT     I        Cat slot of associated image
C      VOL      I        Volume no. of associated image
C      XINC     R        x-axis increment (arcsec)
C      YINC     R        y-axis increment (arcsec)
C      ISTART   I        First slice to collate
C      IEND     I        Last slice to collate
C      ORIGIN   R        User suplied reference pixel
C      TERM     L        .true. => output to terminal, else disk file
C      LUN      I        LUN for disk file
C      IFIND    I        Index in FTAB for LUN
C   Output:
C      IERR     I        0 => OK
C-----------------------------------------------------------------------
      REAL   XINC, YINC, ORIGIN(4), SBLKR(256), BLC(2), TRC(2),
     *   PEAK(4), POS(3,4), FWHM(4)
      INTEGER   SLOT, VOL, ISTART, IEND, LUN, IERR, LUNSL, ISFIND,
     *   SBLKI(256), NMODS, NPTS, I, IFIND, MODREC, NGAUSS, J, K
      LOGICAL   TERM, WAIT, EXCL
      CHARACTER LINE*72
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (SBLKI, SBLKR)
      DATA LUNSL /27/
      DATA WAIT, EXCL /.TRUE., .TRUE./
C-----------------------------------------------------------------------
C                                           write output header
      IF (TERM) THEN
         WRITE (MSGTXT,1000)
         CALL MSGWRT (8)
      ELSE
         WRITE (LINE,1000)
         CALL ZTXIO ('WRIT', LUN, IFIND, LINE, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) IERR
            CALL MSGWRT (8)
            GO TO 990
            END IF
         END IF
C                                           loop over slices
      DO 100 I = ISTART,IEND
C                                           open slice
         CALL OPEXT ('SL', VOL, SLOT, I, LUNSL, EXCL, WAIT, ISFIND,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,3000) I, IERR
            CALL MSGWRT (8)
            GO TO 990
            END IF
C                                           read first info. record
         CALL ZFIO ('READ', LUNSL, ISFIND, 1, SBLKI, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,4000) I, IERR
            CALL MSGWRT (8)
            GO TO 990
            END IF
C                                           get data for last model
         NMODS = SBLKI(58)
         NPTS  = SBLKI(57)
         MODREC = SBLKI(59) - 1
C                                           read second info. record
         IF (NMODS.GT.0) THEN
            CALL ZFIO ('READ', LUNSL, ISFIND, 2, SBLKI, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,5000) I, IERR
               CALL MSGWRT (8)
               GO TO 990
               END IF
C                                       BLC and TRC of slice
            BLC(1) = SBLKR(19)
            BLC(2) = SBLKR(20)
            TRC(1) = SBLKR(26)
            TRC(2) = SBLKR(27)
C                                       read model data
            DO 60 K = 1,NMODS
               MODREC = MODREC + 1
               CALL ZFIO ('READ', LUNSL, ISFIND, MODREC, SBLKI, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,6000) I, MODREC, IERR
                  CALL MSGWRT (8)
                  GO TO 990
                  END IF
               NGAUSS = SBLKI(27)
C                                           work out model parameters
               CALL MODPAR (NGAUSS, BLC, TRC, XINC, YINC, ORIGIN, SBLKR,
     *            NPTS, PEAK, POS, FWHM)
C                                           write output model
               DO 50 J = 1,NGAUSS
                  WRITE (MSGTXT,8000) I, K, J, POS(1,J), POS(2,J),
     *               POS(3,J), PEAK(J), FWHM(J)
                  IF (TERM) THEN
                     CALL MSGWRT (4)
                  ELSE
                     LINE = MSGTXT
                     CALL ZTXIO ('WRIT', LUN, IFIND, LINE, IERR)
                     IF (IERR.NE.0) THEN
                        WRITE (MSGTXT,9000) I, IERR
                        CALL MSGWRT (8)
                        GO TO 990
                        END IF
                     END IF
 50               CONTINUE
 60            CONTINUE
            END IF
C                                           close slice file
         CALL ZCLOSE (LUNSL, ISFIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,10000) I, IERR
            CALL MSGWRT (8)
            GO TO 990
            END IF
 100     CONTINUE
C                                           close text file ?
      IF (.NOT.TERM) THEN
         CALL ZTXCLS (LUN, IFIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,11000) IERR
            CALL MSGWRT (8)
            END IF
         END IF
C
 990  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('isl m n  Xpos ''''',4X,'Ypos ''''',4X,'Dist ''''',4X,
     *   'Peak',7X,'FWHM ''''')
 2000 FORMAT ('DOMODL: ERROR WRITING HEADER TO OUTPUT FILE, IERR=', I3)
 3000 FORMAT ('DOMODL: ERROR OPENING SLICE FILE #', I3, ' IERR=', I3)
 4000 FORMAT ('DOMODL: ERROR READING REC. 1 OF SLICE #', I3,
     *        ' IERR=', I3)
 5000 FORMAT ('DOMODL: ERROR READING REC. 2 OF SLICE #', I3,
     *        ' IERR=', I3)
 6000 FORMAT ('DOMODL: ERROR READING SLICE RECORD #', I3, ' MODEL #',
     *        I3, ' IERR=', I3)
 7000 FORMAT ('DOMODL: WARNING, THERE ARE NO MODELS FOR SLICE #', I3)
 8000 FORMAT (I3,2I2,5(1PE11.3))
 9000 FORMAT ('DOMODL: ERROR WRITING SLICE #', I2, ' MODEL TO FILE,',
     *        ' IERR = ', I3)
10000 FORMAT ('DOMODL: ERROR CLOSING SLICE #', I3, ' IERR=', I3)
11000 FORMAT ('DOMODL: ERROR CLOSING OUTPUT TEXT FILE, IERR=', I3)
      END
      SUBROUTINE MODPAR (NGAUSS, BLC, TRC, XINC, YINC, ORIGIN, DATA,
     *   NPTS, PEAK, POS, FWHM)
C-----------------------------------------------------------------------
C   Work out model parameters
C   Inputs:
C      BLC       R       BLC of slice
C      TRC       R       TRC of slice
C      XINC      R       x-axis increment (arcsec)
C      YINC      R       y-axis increment (arcsec)
C      DATA      R       Model data
C      NPTS      I       Number of points in slice
C   Output:
C      PEAK      R       Model peak (disk units)
C      POS       R       Position of peak (arcsec) from slice centre
C      FWHM      R       FWHM (arcsec)
C-----------------------------------------------------------------------
      INTEGER   NGAUSS, NPTS
      REAL      BLC(2), TRC(2), XINC, YINC, ORIGIN(4), DATA(12),
     *   PEAK(4), POS(3,4), FWHM(4)
C
      REAL      WIDRAT, XSEC, YSEC, SLEN, FLOPTS
      INTEGER   I, J
C-----------------------------------------------------------------------
C                                           length of slice in arcsec
      XSEC = (TRC(1) - BLC(1)) * XINC
      YSEC = (TRC(2) - BLC(2)) * YINC
      SLEN = SQRT (XSEC**2.0 + YSEC**2.0)
      FLOPTS = REAL (NPTS - 1)
C                                       loop over Gaussians
      DO 20 I = 1,NGAUSS
         J = (I-1) * 3 + 1
         PEAK(I) = DATA(J)
         XSEC = BLC(1) + (TRC(1)-BLC(1)) * (DATA(J+1)-1) / FLOPTS
         YSEC = BLC(2) + (TRC(2)-BLC(2)) * (DATA(J+1)-1) / FLOPTS
         POS(1,I) = (XSEC - ORIGIN(1)) * XINC
         POS(2,I) = (YSEC - ORIGIN(2)) * YINC
         POS(3,I) = SQRT (POS(1,I)**2 + POS(2,I)**2)
         IF (TRC(1).EQ.BLC(1)) THEN
            IF (POS(2,I).LT.0.) POS(3,I) = -POS(3,I)
         ELSE
            IF (POS(1,I).LT.0.) POS(3,I) = -POS(3,I)
            END IF
         WIDRAT = DATA(J+2) / FLOPTS
         FWHM(I) = WIDRAT * SLEN
         POS(1,I) = (XSEC - ORIGIN(3)) * XINC
         POS(2,I) = (YSEC - ORIGIN(4)) * YINC
 20      CONTINUE
C
      RETURN
      END
      SUBROUTINE DOSLVL (SLOT, VOL, XINC, YINC, ISTART, IEND, SINC,
     *   ORIGIN, TERM, LUN, IFIND, IGBLA, IERR)
C-----------------------------------------------------------------------
C   Main subroutine for the 'SLVL' opcode.
C   Input:
C      SLOT     I        Cat slot of associated image
C      VOL      I        Volume no. of associated image
C      XINC     R        x-axis increment (arcsec)
C      YINC     R        y-axis increment (arcsec)
C      ISTART   I        First slice to collate
C      IEND     I        Last slice to collate
C      SINC     R        save a slice point every SINC arcsec
C      ORIGIN   R        User suplied reference pixel
C      TERM     L        .true. => output to terminal, else disk file
C      LUN      I        LUN for output file
C      IFIND    I        Index of LUN in FTAB
C      IGBLA    L        Ignore blanks ?
C   Output:
C      IERR     I        0 => OK
C-----------------------------------------------------------------------
      REAL      XINC, YINC, ORIGIN(4), SBLKR(256), XPSINC, YPSINC,
     *   SIGNX, SIGNY, BLC(2), TRC(2), IMVAL, DIST(3), SINC
      INTEGER   IREC, IFIND
      INTEGER   SLOT, VOL, ISTART, IEND, LUN, IERR, I, NRPBLK,
     *   LUNSL, ISFIND, SBLKI(256), NPTS, ISREC, IEREC, IWORD,
     *   IPTS, INC
      LOGICAL   IGBLA, TERM, WAIT, EXCL
      CHARACTER LINE*72
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (SBLKI, SBLKR)
      DATA LUNSL /27/
      DATA WAIT, EXCL /.TRUE., .TRUE./
C-----------------------------------------------------------------------
C                                           loop over slice files
      NRPBLK = 256
      DO 500 I = ISTART,IEND
         WRITE (MSGTXT,800) I
         CALL MSGWRT (4)
C                                           open slice file
         CALL OPEXT ('SL', VOL, SLOT, I, LUNSL, EXCL, WAIT, ISFIND,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) I, IERR
            CALL MSGWRT (8)
            GO TO 990
            END IF
C                                           read first info. record
         CALL ZFIO ('READ', LUNSL, ISFIND, 1, SBLKI, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) I, IERR
            CALL MSGWRT (8)
            GO TO 990
            END IF
         NPTS = SBLKI(57)
C                                           read second info. record
         CALL ZFIO ('READ', LUNSL, ISFIND, 2, SBLKI, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,3000) I, IERR
            CALL MSGWRT (8)
            GO TO 990
            END IF
C                                           pixels per slice point
C                                           conversion factors
         CALL CONFAC (SINC, XINC, YINC, SBLKR, NPTS, XPSINC, YPSINC,
     *      SIGNX, SIGNY, BLC, TRC, INC)
C                                           write output header
         IF (TERM) THEN
            WRITE (MSGTXT,3200)
            CALL MSGWRT (4)
         ELSE
            WRITE (LINE,3200)
            CALL ZTXIO ('WRIT', LUN, IFIND, LINE, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,3400) I
               CALL MSGWRT (8)
               GO TO 990
               END IF
            END IF
C                                           read in slice data records
         IPTS = 1
         ISREC = 3
         IEREC = ISREC - 1 + (NPTS / NRPBLK)
         DO 400 IREC = ISREC,IEREC
            CALL ZFIO ('READ', LUNSL, ISFIND, IREC, SBLKI, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,4000) I, IREC, IERR
               CALL MSGWRT (8)
               GO TO 990
               END IF
C                                            loop over slice points
C                                            in current record
            DO 300 IWORD = 1, NRPBLK
               IF (MOD(IPTS,INC).EQ.1 .OR. INC.EQ.1) THEN
C                                            work out results
                  IF ((SBLKR(IWORD).NE.FBLANK) .OR. (.NOT.IGBLA)) THEN
                     CALL VALPOS (SBLKR(IWORD), XINC, YINC, BLC, TRC,
     *                  SIGNX, SIGNY, XPSINC, YPSINC, ORIGIN, IPTS,
     *                  DIST, IMVAL)
C                                            write output
                     IF (TERM) THEN
                        WRITE (MSGTXT,6000) IPTS, DIST, IMVAL
                        CALL MSGWRT (4)
                     ELSE
                        WRITE (LINE,6000) IPTS, DIST, IMVAL
                        CALL ZTXIO ('WRIT', LUN, IFIND, LINE, IERR)
                        IF (IERR.NE.0) THEN
                           WRITE (MSGTXT,7000) I, IERR
                           CALL MSGWRT (8)
                           GO TO 990
                           END IF
                        END IF
                     END IF
                  END IF
               IPTS = IPTS + 1
 300           CONTINUE
 400        CONTINUE
C                                           close slice file
         CALL ZCLOSE (LUNSL, ISFIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,8000) I, IERR
            CALL MSGWRT (8)
            GO TO 990
            END IF
 500     CONTINUE
C                                           close output text file ?
      IF (.NOT.TERM) THEN
         CALL ZTXCLS (LUN, IFIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,9000) IERR
            CALL MSGWRT (8)
            END IF
         END IF
C
 990  RETURN
C-----------------------------------------------------------------------
  800 FORMAT ('DOSLVL: Processing SLice number', I4)
 1000 FORMAT ('DOSLVL: ERROR OPENING SLICE FILE #', I3, ' IERR=', I3)
 2000 FORMAT ('DOSLVL: ERROR READING REC. 1 OF SLICE #', I3,
     *        ' IERR=', I3)
 3000 FORMAT ('DOSLVL: ERROR READING REC. 2 OF SLICE #', I3,
     *        ' IERR=', I3)
 3100 FORMAT ('     Distance ''''      Value       Value/beam   No.')
 3200 FORMAT ('Number  X pos ''''',6X,'Y pos ''''',6X,'Distance ''''',
     *   3X,'Value')
 3400 FORMAT ('DOSLVL: ERROR WRITING HEADER INFORMATION TO OUTPUT',
     *        ' FOR SLICE # ', I3)
 4000 FORMAT ('DOSLVL: ERROR READING SLICE #', I3, ' RECORD #', I3,
     *        ' IERR=', I3)
 6000 FORMAT (I5,4(1PE14.5))
 7000 FORMAT ('DOSLVL: ERROR WRITING SLICE #', I2, ' TO OUTPUT FILE',
     *        ' IERR=', I3)
 8000 FORMAT ('DOSLVL: ERROR CLOSING SLICE #', I3, ' IERR=', I3)
 9000 FORMAT ('DOSLVL: ERROR CLOSING OUTPUT TEXT FILE, IERR=', I3)
      END
      SUBROUTINE CONFAC (SINC, XINC, YINC, SBLKR, NPTS, XPSINC, YPSINC,
     *   SIGNX, SIGNY, BLC, TRC, INC)
C-----------------------------------------------------------------------
C     Work out slope of slice (in pixels), no. pixels per slice point
C     and some direction signs.
C     Input:
C      SINC     R        save a slice point every SINC arcsec
C      XINC     R        x axis increment arcsec/pixel
C      YINC     R        y axis increment arcsec/pixel
C      SBLKR    R        Slice information records
C      NPTS     I        Number of points in slice
C     Output:
C      XPSINC   R        x increment (pixels) when step along slice by
C                        one point.
C      YPSINC   R        y increment (pixels) when step along slice by
C                        one point.
C      SIGNX    R        x direction sign, = +1.0 if slice from left to
C                        right
C      SIGNY    R        y direction sign, = +1.0 if slice from bottom
C                        to top
C      BLC      R        Slice BLC
C      TRC      R        Slice TRC
C      INC      I        Save a slice point every INC slice points
C-----------------------------------------------------------------------
      REAL   SBLKR(*), XPSINC, YPSINC, PSINC, SLOPE, YINT, BLC(2),
     *   TRC(2), XDIST, YDIST, DIST, SIGNX, SIGNY, SLOPSQ, PSINSQ, SINC,
     *   XINC, YINC, XDISQ, YDISQ, AXDISQ, AYDISQ, ADIST, RAT
      INTEGER   NPTS, INC
      LOGICAL   VERT
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                           direction signs
      BLC(1) = SBLKR(19)
      BLC(2) = SBLKR(20)
      TRC(1) = SBLKR(26)
      TRC(2) = SBLKR(27)
      IF (TRC(1).GE.BLC(1)) THEN
         SIGNX = 1.0
         IF (TRC(2).GE.BLC(2)) THEN
            SIGNY = 1.0
         ELSE
            SIGNY = -1.0
            END IF
      ELSE
         SIGNX = -1.0
         IF (TRC(2).GE.BLC(2)) THEN
            SIGNY = 1.0
         ELSE
            SIGNY = -1.0
            END IF
         END IF
C                                           find equation of slice
      YDIST = TRC(2) - BLC(2)
      XDIST = TRC(1) - BLC(1)
      XDISQ = XDIST * XDIST
      YDISQ = YDIST * YDIST
C
      IF (XDIST.NE.0.0) THEN
         SLOPE = YDIST / XDIST
         YINT = BLC(2) - (SLOPE * BLC(1))
         VERT = .FALSE.
      ELSE
         VERT = .TRUE.
         END IF
C                                           pixels / slice points
C                                           x and y conversion factors
      IF (.NOT.VERT) THEN
         SLOPSQ = SLOPE * SLOPE
         DIST = SQRT (XDISQ + YDISQ)
         PSINC = DIST / REAL (NPTS - 1)
         PSINSQ = PSINC * PSINC
         XPSINC = SQRT( PSINSQ / (1.0 + SLOPSQ) )
         YPSINC = ABS (SLOPE) * XPSINC
      ELSE
         DIST = ABS (YDIST)
         XPSINC = 0.0
         YPSINC = DIST / REAL (NPTS - 1)
         END IF
C     ENCODE (80, 1000, MSGTXT) XPSINC
C     CALL MSGWRT (8)
C     ENCODE (80, 2000, MSGTXT) YPSINC
C     CALL MSGWRT (8)
C                                           slice point increment
      AXDISQ = XINC * XINC * XDISQ
      AYDISQ = YINC * YINC * YDISQ
      ADIST = SQRT (AXDISQ + AYDISQ)
      RAT = NPTS * SINC / ADIST
      IF (RAT.LE.0.0) THEN
         INC = 1
      ELSE IF (RAT.LE.1.0) THEN
         INC = 1
         WRITE (MSGTXT,3000)
         CALL MSGWRT (6)
      ELSE IF (RAT.GT.FLOAT(NPTS)) THEN
         INC = 1
         WRITE (MSGTXT,4000)
         CALL MSGWRT (6)
      ELSE
         INC = RAT + 0.5
         END IF
      WRITE (MSGTXT,5000) INC
      CALL MSGWRT (4)
C
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CONFAC: ', 1PE12.5, ' X pixels per SLice point')
 2000 FORMAT ('CONFAC: ', 1PE12.5, ' Y pixels per SLice point')
 3000 FORMAT ('CONFAC: ZINC TOO SMALL')
 4000 FORMAT ('CONFAC: ZINC TOO LARGE')
 5000 FORMAT ('CONFAC: SLice point increment = ', I4)
      END
      SUBROUTINE VALPOS (SLDAT, XINC, YINC, BLC, TRC, SIGNX, SIGNY,
     *   XPSINC, YPSINC, ORIGIN, IPT, DIST, SLVAL)
C-----------------------------------------------------------------------
C   Work out value of current slice point and distance from reference
C   pos
C   Input:
C      SLDAT    R        Unscaled slice value
C      X,YINC   R        x- and y-axis coordiante increments
C                        (arcsec/pixel)
C      BLC      R        Slice BLC
C      TRC      R        Slice TRC
C      SIGNX    R        x direction sign, = +1.0 if slice from left to
C                        right
C      SIGNY    R        y direction sign, = +1.0 if slice from bottom
C                        to top
C      XPSINC   R        x increment (pixels) when step along slice by
C                        one point
C      YPSINC   R        y increment (pixels) when step along slice by
C                        one point
C      ORIGIN   R        Reference pixel coordinate
C      IPT      I        Current slice point number 1 : N
C   Output:
C      DIST     R(3)     X, Y, Distance ('') of slice point from reference
C                        pos.
C      SLVAL    R        Value of slice point
C-----------------------------------------------------------------------
      REAL      SLDAT, BLC(2), TRC(2), SIGNX, SIGNY, XPSINC, YPSINC,
     *   ORIGIN(4), DIST(3), SLVAL, X, Y, XINC, YINC, SLPOS
      INTEGER   IPT
C-----------------------------------------------------------------------
      SLPOS = REAL (IPT - 1)
      X = BLC(1) + (SIGNX * SLPOS * XPSINC)
      Y = BLC(2) + (SIGNY * SLPOS * YPSINC)
      DIST(1) = (X - ORIGIN(1)) * XINC
      DIST(2) = (Y - ORIGIN(2)) * YINC
C
      DIST(3) = SQRT (DIST(1)**2 + DIST(2)**2)
      IF (BLC(1).EQ.TRC(1)) THEN
         IF (DIST(2).LT.0.0) DIST(3) = -DIST(3)
      ELSE
         IF (DIST(1).LT.0.0) DIST(3) = -DIST(3)
         END IF
      DIST(1) = (X - ORIGIN(3)) * XINC
      DIST(2) = (Y - ORIGIN(4)) * YINC
      SLVAL = SLDAT
C
      RETURN
      END

      SUBROUTINE LAYOUT (CHAN, INFILE, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! Generates panel layout plot on the TV
C# Graphics Map-util TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Plot the boxes
C   Input:
C      CHAN     I        Channel to use (1-NGRAY+NGRAPH)
C      INFILE   C*48     In file name
C   Output:
C      SCRTCH   I(*)     Scratch
C      IERR     I        0 => OK
C   Common
C      DCAT.INC          Image header including TV corners
C-----------------------------------------------------------------------
      INTEGER   CHAN, SCRTCH(*), IERR
      CHARACTER INFILE*(*)
C
      INTEGER   JTRIM, MSGSAV, INC, LUN, FIND, KBPLIM, KBP, NC, I, NP,
     *   J, IP, VLNPL(6,2), VLNUM, K, IPX(2), IPY(2), IROUND
      CHARACTER LFILE*64, LINE*80
      DOUBLE PRECISION D, THETA, DTHETA
      REAL      R1, R2, X(5), Y(5), DX, DY, PX0, PY0, PX(2), PY(2),
     *   VLRPL(2,6,2), BLC(2), TRC(2), PP(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUN /3/
      DATA VLNPL /12,16,24,40,40,40, 20,20,40,40,40,40/
      DATA VLRPL /1.983,3.683, 3.683,5.563, 5.563,7.391, 7.391,9.144,
     *   9.144,10.87, 10.87,12.5,
     *   1.676,3.518, 3.518,5.423, 5.423,7.277, 7.277,9.081,
     *   9.081,10.808, 10.808,12.500/
C-----------------------------------------------------------------------
      IERR = 0
      IF ((CATR(KRCIC).EQ.0.0) .OR. (CATR(KRCIC+1).EQ.0.0)) GO TO 999
      PX0 = CATR(KRCRP)
      PY0 = CATR(KRCRP+1)
      DX = 1.0 / CATR(KRCIC)
      DY = 1.0 / CATR(KRCIC+1)
      MSGSAV = MSGSUP
      VLNUM = 0
      IF (INFILE.EQ.' ') VLNUM = 1
      IF (INFILE.EQ.'VLA') VLNUM = 1
      IF (INFILE.EQ.'VLBA') VLNUM = 2
      BLC(1) = CATBLK(IIWIN)
      BLC(2) = CATBLK(IIWIN+1)
      TRC(1) = CATBLK(IIWIN+2)
      TRC(2) = CATBLK(IIWIN+3)
C                                       open layout file
      IF (VLNUM.LE.0) THEN
         INC = JTRIM (INFILE)
         LFILE = INFILE(:INC) // '.layout'
         CALL ZTXOPN ('READ', LUN, FIND, LFILE, .FALSE., IERR)
C                                       panel layout
         IF (IERR.EQ.0) THEN
C                                       read number of cards
            CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'READ LAYOUT LINE 1'
               GO TO 990
               END IF
            KBPLIM = JTRIM (LINE)
            KBP = 1
            CALL GETNUM (LINE, KBPLIM, KBP, D)
            IF (D.EQ.DBLANK) GO TO 980
            NC = D
            DO 40 J = 1,NC
               CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ LAYOUT DATA LINE'
                  GO TO 990
                  END IF
               KBPLIM = JTRIM (LINE)
               KBP = 1
               CALL GETNUM (LINE, KBPLIM, KBP, D)
               IF (D.EQ.DBLANK) GO TO 980
               NP = D
               CALL GETNUM (LINE, KBPLIM, KBP, D)
               IF (D.EQ.DBLANK) GO TO 980
               R1 = D
               CALL GETNUM (LINE, KBPLIM, KBP, D)
               IF (D.EQ.DBLANK) GO TO 980
               R2 = D
               DTHETA = 360.0D0 / NP * DG2RAD
               THETA = 0.0
               DO 30 IP = 1,NP
                  X(1) = R1 * SIN (THETA)
                  X(2) = R2 * SIN (THETA)
                  X(3) = R2 * SIN (THETA+DTHETA)
                  X(4) = R1 * SIN (THETA+DTHETA)
                  X(5) = X(1)
                  Y(1) = R1 * COS (THETA)
                  Y(2) = R2 * COS (THETA)
                  Y(3) = R2 * COS (THETA+DTHETA)
                  Y(4) = R1 * COS (THETA+DTHETA)
                  Y(5) = Y(1)
                  DO 20 I = 1,4
                     PX(1) = PX0 + DX * X(I)
                     PX(2) = PX0 + DX * X(I+1)
                     PY(1) = PY0 - DY * Y(I)
                     PY(2) = PY0 - DY * Y(I+1)
                     CALL LINLIM (BLC, TRC, PX, PY, IERR)
                     IF (IERR.EQ.0) THEN
                        DO 10 K = 1,2
                           PP(1) = PX(K)
                           PP(2) = PY(K)
                           CALL MP2IMA (PP, PP)
                           IPX(K) = IROUND (PP(1))
                           IPY(K) = IROUND (PP(2))
 10                        CONTINUE
                        CALL IMVECT ('ONNN', CHAN, 2, IPX, IPY, SCRTCH,
     *                     IERR)
                        END IF
 20                  CONTINUE
                  THETA = THETA + DTHETA
 30               CONTINUE
 40            CONTINUE
            CALL ZTXCLS (LUN, FIND, IERR)
            END IF
C                                       known arrays
      ELSE
         NC = 6
         DO 240 J = 1,NC
            NP = VLNPL(J,VLNUM)
            THETA = 0.0
            DTHETA = 360.0D0 / NP * DG2RAD
            R1 = VLRPL(1,J,VLNUM)
            R2 = VLRPL(2,J,VLNUM)
            DO 230 IP = 1,NP
               X(1) = R1 * SIN (THETA)
               X(2) = R2 * SIN (THETA)
               X(3) = R2 * SIN (THETA+DTHETA)
               X(4) = R1 * SIN (THETA+DTHETA)
               X(5) = X(1)
               Y(1) = R1 * COS (THETA)
               Y(2) = R2 * COS (THETA)
               Y(3) = R2 * COS (THETA+DTHETA)
               Y(4) = R1 * COS (THETA+DTHETA)
               Y(5) = Y(1)
               DO 220 I = 1,4
                  PX(1) = PX0 + DX * X(I)
                  PX(2) = PX0 + DX * X(I+1)
                  PY(1) = PY0 - DY * Y(I)
                  PY(2) = PY0 - DY * Y(I+1)
                  CALL LINLIM (BLC, TRC, PX, PY, IERR)
                  IF (IERR.EQ.0) THEN
                     DO 210 K = 1,2
                        PP(1) = PX(K)
                        PP(2) = PY(K)
                        CALL MP2IMA (PP, PP)
                        IPX(K) = IROUND (PP(1))
                        IPY(K) = IROUND (PP(2))
 210                    CONTINUE
                     CALL IMVECT ('ONNN', CHAN, 2, IPX, IPY, SCRTCH,
     *                  IERR)
                     END IF
 220              CONTINUE
               THETA = THETA + DTHETA
 230           CONTINUE
 240        CONTINUE
         END IF
      GO TO 999
C                                       bad value
 980  IERR = 2
      MSGTXT = 'ILLEGAL VALUE READ'
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('LAYOUT ERROR',I3,' ON ',A)
      END

      SUBROUTINE GETSTR (KB, KBPLIM, NMAX, KBP, ISTR, NCHAR)
C-----------------------------------------------------------------------
C! returns a string value (was enclosed by quotes) from character buffer
C# Parsing FITS POPS-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GETSTR obtains a character value from a buffer
C   Inputs:
C      KB      C*(*)     character buffer
C      KBPLIM  I        size of buffer
C      NMAX    I        max string length in characters
C      KBP     I        start position in KB
C   Outputs:
C      KBP     I        start position in KB next field
C      ISTR    C*(*)    packed string, blank filled
C      NCHAR   I        # characters (0 => no string found)
C-----------------------------------------------------------------------
      CHARACTER KB*(*), ISTR*(*)
      INTEGER   NMAX, KBPLIM, KBP, NCHAR
C
      INTEGER   JB, JJ, LMAX
      INCLUDE 'INCS:DERR.INC'
C-----------------------------------------------------------------------
      NCHAR = 0
      LMAX = MIN (NMAX, LEN (ISTR))
      ISTR = ' '
      IF (KBP.GT.KBPLIM) GO TO 999
C                                        skip leading blanks
 10   IF (KB(KBP:KBP).EQ.'''') GO TO 15
         KBP = KBP + 1
         IF (KBP.GT.KBPLIM) GO TO 999
         GO TO 10
C                                        find end
 15   JB = KBP + 1
 20   KBP = KBP + 1
         IF (KBP.GT.KBPLIM) GO TO 25
         IF (KB(KBP:KBP).EQ.'''') GO TO 25
         GO TO 20
C                                        got it
 25   NCHAR = KBP - JB
      KBP = KBP + 1
      JJ = MIN (NCHAR, LMAX)
      IF (NCHAR.NE.0) ISTR(1:JJ) = KB(JB:JB+JJ-1)
      IF (NCHAR.GT.LMAX) GO TO 980
C                                        make null string ok
      IF (NCHAR.EQ.0) NCHAR = 1
      GO TO 999
C                                        error: too long
 980  ERRNUM = 13
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.10) PNAME(ERRLEV) = 'GETSTR'
C
 999  RETURN
      END

LOCAL INCLUDE 'TAPPE.INC'
C                                       Local include for TAPPE
      INTEGER   SEQI, SEQO, INVER1, INVER2, OUTVER, CNOI, CNOO, DISKI,
     *   DISKO, CATI(256), MAXVER, NROW1, NROW2, NROWO
      HOLLERITH XNAMEI(3), XCLASI(2), XXTYPE, XNAMEO(3), XCLASO(2)
      CHARACTER NAMEI*12, CLASSI*6, TTYPE*2, NAMEO*12, CLASSO*6
      REAL      XSEQI, XDISKI, XVER1, XSEQO, XDISKO, XVER2, BADD(10)
      COMMON /INPARM/ XNAMEI, XCLASI, XSEQI, XDISKI, XXTYPE, XVER1,
     *   XNAMEO, XCLASO, XSEQO, XDISKO, XVER2, BADD
      COMMON /OTHER/ CATI, SEQI, SEQO, INVER1, INVER2, OUTVER, CNOI,
     *   CNOO, DISKI, DISKO, MAXVER, NROW1, NROW2, NROWO
      COMMON /CHRCOM/ NAMEI, CLASSI, TTYPE, NAMEO, CLASSO
      INCLUDE 'INCS:DCAT.INC'
LOCAL END
      PROGRAM TAPPE
C-----------------------------------------------------------------------
C! Appends two tables and discards duplicates
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2007, 2011, 2015, 2017, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task TAPPE sorts AIPS tables to bring all rows at the same control
C   values together, then it sums them, and finally it resorts the file
C   into the original order.
C   Inputs:
C      AIPS Adverb   Prg. Name          Description
C      INNAME         NAMEI         File name.
C      INCLASS        CLASI         File class.
C      INSEQ          SEQI          File sequence number.
C      INDISK         DISKI         Disk volume on which file resides.
C      INEXT          TTYPE         Extension file type
C      INVER          INVER1        Input file input version number
C      OUTNAME        NAMEO         Output file name
C      OUTCLASS       CLASSO        Output file class
C      OUTSEQ         SEQO          Output file seq
C      OUTDISK        DISKO         Output file disk
C      IN2VER         INVER2        Output file 2nd input version #
C      OUTVER         OUTVER        Output file version number
C      BADDISK        IBADD(10)     Disks to avoid for scratch.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   IRET, SCRBUF(512)
      INCLUDE 'TAPPE.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C                                       Set file info
      CALL TAPPEI (SCRBUF, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Do operation
      CALL TAPPED (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       History and clean up
      CALL TAPPEH (IRET, SCRBUF)
C                                       Write end message
 990  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE TAPPEI (SCRBUF, IRET)
C-----------------------------------------------------------------------
C   TAPPEI performs initialization for TAPPE
C   Output:
C      SCRBUF   I(*)     Scratch
C      IRET     I        Error code: 0 -> okay
C-----------------------------------------------------------------------
      INTEGER   IRET, SCRBUF(*)
C
      CHARACTER PRGM*6, PTYPE*2, STAT*4
      INTEGER   NPARM, IROUND, I
      INCLUDE 'TAPPE.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA PRGM /'TAPPE'/
C-----------------------------------------------------------------------
C                                       Init I/O, parameters
      NPARM = 27
      CALL SETUP (PRGM, NPARM, XNAMEI, SCRBUF, IRET)
      IF (IRET.NE.0) GO TO 990
      SEQI = IROUND (XSEQI)
      DISKI = IROUND (XDISKI)
      INVER1 = IROUND (XVER1)
      SEQO = IROUND (XSEQO)
      DISKO = IROUND (XDISKO)
      INVER2 = IROUND (XVER2)
      OUTVER = 0
      CALL H2CHR (12, 1, XNAMEI, NAMEI)
      CALL H2CHR (6, 1, XCLASI, CLASSI)
      CALL H2CHR (12, 1, XNAMEO, NAMEO)
      CALL H2CHR (6, 1, XCLASO, CLASSO)
      CALL H2CHR (2, 1, XXTYPE, TTYPE)
      IF (TTYPE.EQ.'  ') TTYPE = 'TA'
C                                       Open file and get CATBLK.
C                                       Get CATBLK from old file.
      CNOI = 1
      PTYPE = '  '
      CALL CATDIR ('SRCH', DISKI, CNOI, NAMEI, CLASSI, SEQI, PTYPE,
     *   NLUSER, STAT, SCRBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, NAMEI, CLASSI, SEQI, DISKI, NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKI, CNOI, CATI, 'REST', SCRBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       BADDISK
      DO 10 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 10      CONTINUE
C                                       find version numbers
      CALL FXHDEX (CATI)
      CALL FNDEXT (TTYPE, CATI, MAXVER)
      IF ((INVER1.LE.0) .OR. (INVER1.GT.MAXVER)) INVER1 = MAXVER
C                                       output file
      IF (NAMEO.EQ.' ') NAMEO = NAMEI
      IF (CLASSO.EQ.' ') CLASSO = CLASSI
      IF (SEQO.LE.0) SEQO = SEQI
      IF (DISKO.LE.0) DISKO = DISKI
      CNOO = 1
      PTYPE = '  '
      CALL CATDIR ('SRCH', DISKO, CNOO, NAMEO, CLASSO, SEQO, PTYPE,
     *   NLUSER, STAT, SCRBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, NAMEO, CLASSO, SEQO, DISKO, NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKO, CNOO, CATBLK, 'WRIT', SCRBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Mark in /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CNOO
      FRW(NCFILE) = 1
C                                       output file versions
      CALL FXHDEX (CATBLK)
      CALL FNDEXT (TTYPE, CATBLK, MAXVER)
      IF ((INVER2.LE.0) .OR. (INVER2.GT.MAXVER)) INVER2 = MAXVER
      IF ((OUTVER.LE.0) .OR. (OUTVER.GT.MAXVER)) OUTVER = MAXVER + 1
C                                       input status?
      IF ((DISKI.NE.DISKO) .OR. (CNOI.NE.CNOO)) THEN
         CALL CATIO ('READ', DISKI, CNOI, CATI, 'READ', SCRBUF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET
            GO TO 990
            END IF
C                                       Mark in /CFILES/
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKI
         FCNO(NCFILE) = CNOI
         FRW(NCFILE) = 1
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1010 FORMAT ('ERROR',I3,' READ HEADER, SETTING STATUS')
      END
      SUBROUTINE TAPPED (IRET)
C-----------------------------------------------------------------------
C   TAPPED performs the operation: 2 copies, sort, merge
C   Output:
C      IRET     I        Error code: 0 -> okay
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   NSTD, NSCOL
      PARAMETER (NSTD=35, NSCOL=6)
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   TABUF1(512), TABUFO(512), DATP(128,2), NKEY, NCOL,
     *   NEXT, LUN1, LUN2, LUNO, IREC1, MREC, KLOCS(100), KEYTYP(100),
     *   NSEL, J, KEY(2,2), NWORDS, KEYSUB(2,2), STDCOL(NSTD,2),
     *   ANTCOL(NSCOL,3), HDRSRT(2), TABUF2(512), IREC2, IP1, IP2,
     *   IPCOL(2,2), STRLEN(2,2), COLTYP(2,2), IBUF1(UVBFSL),
     *   IBUF2(UVBFSL)
      CHARACTER KEYW(100)*8, STDTYP(NSTD)*2, ANTTYP(NSCOL)*2
      REAL      FKEY(2,2), DBUF1(UVBFSL), DBUF2(UVBFSL)
      LOGICAL   READ1, READ2
      EQUIVALENCE (IBUF1, DBUF1), (IBUF2, DBUF2)
      INCLUDE 'TAPPE.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LUN1, LUN2, LUNO /32, 33, 34/
      DATA KEYSUB /4*1/
      DATA STDTYP /'AT','BT','CA','CL','GA','IM','NX','OF','OT','PC',
     *   'PH','SN','TS','TY','CS', 'WX','CM','MC', 'FQ','PO','CQ','FR',
     *   'GC','GN','GP','SO','SU','CT', 'SY',
     *   'AN', 'CC', 'MF','AG', 'BP','OB'/
      DATA STDCOL /29*1, 4,2,4,5,1,3,  15*4, 3*3, 10*2, 5, 2,3,5,2,5,1/
      DATA ANTTYP /'FL','BS','BL','BC','FG','FC'/
      DATA ANTCOL /5,1,1,1,5,3, 3,3,4,4,4,4, 3,3,5,4,4,4/
C-----------------------------------------------------------------------
C                                       Open input file 1
      CALL TABINI ('READ', TTYPE, DISKI, CNOI, INVER1, CATI, LUN1, NKEY,
     *   MREC, NCOL, DATP, TABUF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN 1ST INPUT TABLE'
         GO TO 990
         END IF
      NROW1 = TABUF1(5)
      NWORDS = TABUF1(8) - 1
C                                       set sort info
      DO 10 J = 1,2
         FKEY(1,J) = 1.0
         FKEY(2,J) = 0.0
         IF (TABUF1(42+J).LT.0) THEN
            FKEY(1,J) = -1.0
            TABUF1(42+J) = -TABUF1(42+J)
            END IF
         KEY(1,J) = TABUF1(42+J)
         IF (KEY(1,J).GT.256) KEY(1,J) = 256 - TABUF1(42+J)
         KEY(2,J) = 0
 10      CONTINUE
C                                       override for standard types
      DO 15 J = 1,NSTD
         IF (TTYPE.EQ.STDTYP(J)) THEN
            KEY(1,1) = STDCOL(J,1)
            KEY(1,2) = STDCOL(J,2)
            FKEY(1,1) = 1.0
            FKEY(1,2) = 1.0
            END IF
 15      CONTINUE
      DO 20 J = 1,NSCOL
         IF (TTYPE.EQ.ANTTYP(J)) THEN
            KEY(1,1) = ANTCOL(J,1)
            FKEY(1,1) = 1.0
            KEY(1,2) = ANTCOL(J,2)
            FKEY(1,2) = 256.0
            KEY(2,2) = ANTCOL(J,3)
            FKEY(2,2) = 1.0
            IF (KEY(1,2).EQ.KEY(2,2)) KEYSUB(2,2) = 2
            END IF
 20      CONTINUE
C                                       Set sort order
      HDRSRT(1) = KEY(1,1)
      IF (HDRSRT(1).LT.0) HDRSRT(1) = 256 - KEY(1,1)
      HDRSRT(2) = KEY(1,2)
      IF (HDRSRT(2).LT.0) HDRSRT(2) = 256 - KEY(1,2)
      IF (FKEY(1,1).LT.0.0) HDRSRT(1) = -HDRSRT(1)
      IF (FKEY(1,2).LT.0.0) HDRSRT(2) = -HDRSRT(2)
C                                       Get column types
      DO 30 J = 1,2
         IP1 = ABS (KEY(1,J))
         IPCOL(1,J) = 1
         IF (IP1.GT.0) IPCOL(1,J) = DATP(IP1,1)
         IP2 = ABS (KEY(2,J))
         IPCOL(2,J) = 1
         IF (IP2.GT.0) IPCOL(2,J) = DATP(IP2,1)
C                                       Check factors.
         IF (FKEY(1,J).EQ.0.0) FKEY(1,J) = 1.0
         IF (FKEY(2,J).EQ.0.0) FKEY(2,J) = 1.0
C                                       Column out of range.
         IF (((IP1.GE.1) .AND. (IP1.LE.NCOL)) .AND.
     *      ((IP2.GE.0) .AND. (IP2.LE.NCOL))) GO TO 25
         IF ((J.EQ.2) .AND. (IP1.EQ.0)) GO TO 25
            IRET = 1
            WRITE (MSGTXT,1100) J, IP1, IP2
            GO TO 990
C                                       Get type (and length) of col.
 25      STRLEN(1,J) = DATP(IP1,2) / 10
         COLTYP(1,J) = DATP(IP1,2) - STRLEN(1,J) * 10
         IF (IP2.GT.0) STRLEN(2,J) = DATP(IP2,2) / 10
         IF (IP2.GT.0) COLTYP(2,J) = DATP(IP2,2) - STRLEN(2,J) * 10
C                                       Only 1 col. for strings.
         IF ((COLTYP(1,J).EQ.3) .OR. (COLTYP(2,J).EQ.3) .OR.
     *      (COLTYP(1,J).EQ.7) .OR. (COLTYP(2,J).EQ.7)) THEN
            KEY(2,J) = 0
            IP2 = 0
            END IF
         IF ((KEYSUB(1,J).GE.1) .AND. (KEYSUB(1,J).LE.STRLEN(1,J)) .AND.
     *      (COLTYP(1,J).NE.3) .AND. (COLTYP(1,J).NE.7)) IPCOL(1,J) =
     *      IPCOL(1,J) + KEYSUB(1,J) - 1
         IF ((KEYSUB(2,J).GE.1) .AND. (KEYSUB(2,J).LE.STRLEN(2,J)) .AND.
     *      (COLTYP(2,J).NE.3) .AND. (COLTYP(2,J).NE.7) .AND.
     *      (IP2.NE.0)) IPCOL(2,J) = IPCOL(2,J) + KEYSUB(2,J) - 1
 30      CONTINUE
C                                       sort it
      WRITE (MSGTXT,1050) KEY(1,1)
      CALL MSGWRT (3)
      IF (KEY(2,2).EQ.0) THEN
         WRITE (MSGTXT,1051) KEY(1,2)
      ELSE IF (KEY(1,2).NE.KEY(2,2)) THEN
         WRITE (MSGTXT,1052) KEY(1,2), KEY(2,2)
      ELSE
         WRITE (MSGTXT,1053) KEY(1,2)
         END IF
      CALL MSGWRT (3)
C                                       sort input table
      IF ((TABUF1(43).NE.HDRSRT(1)) .OR. (TABUF1(44).NE.HDRSRT(2))) THEN
         CALL TABIO ('CLOS', 0, NROWO, IBUF1, TABUF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSE 1ST TABLE'
            GO TO 990
            END IF
         CALL TABSRT (DISKI, CNOI, TTYPE, INVER1, INVER1, KEY, KEYSUB,
     *      FKEY, TABUF1, CATI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SORTING INPUT TABLE 1'
            GO TO 990
            END IF
         CALL TABINI ('READ', TTYPE, DISKI, CNOI, INVER1, CATI, LUN1,
     *      NKEY, MREC, NCOL, DATP, TABUF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN 1ST INPUT TABLE'
            GO TO 990
            END IF
         NROW1 = TABUF1(5)
         END IF
C                                       Copy file 2 to scr
      CALL TABINI ('READ', TTYPE, DISKO, CNOO, INVER2, CATBLK, LUN2,
     *   NKEY, MREC, NCOL, DATP, TABUF2, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN 2ND'
         GO TO 990
         END IF
      NROW2 = TABUF2(5)
C                                       sort input table
      IF ((TABUF2(43).NE.HDRSRT(1)) .OR. (TABUF2(44).NE.HDRSRT(2))) THEN
         CALL TABIO ('CLOS', 0, NROWO, IBUF2, TABUF2, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSE 2ND TABLE'
            GO TO 990
            END IF
         CALL TABSRT (DISKO, CNOO, TTYPE, INVER2, INVER2, KEY, KEYSUB,
     *      FKEY, TABUF2, CATBLK, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SORTING INPUT TABLE 2'
            GO TO 990
            END IF
         CALL TABINI ('READ', TTYPE, DISKO, CNOO, INVER2, CATBLK, LUN2,
     *      NKEY, MREC, NCOL, DATP, TABUF2, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN 1ST INPUT TABLE'
            GO TO 990
            END IF
         NROW2 = TABUF2(5)
         END IF
C                                       create scr table
      CALL TABINI ('WRIT', TTYPE, DISKO, CNOO, OUTVER, CATBLK, LUNO,
     *   NKEY, MREC, NCOL, DATP, TABUFO, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OUT SCR'
         GO TO 990
         END IF
C                                       col labels, units
      DO 100 IREC1 = 1,NCOL
         CALL TABIO ('READ', 3, IREC1, IBUF1, TABUF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ TYPE 3'
            GO TO 990
            END IF
         CALL TABIO ('WRIT', 3, IREC1, IBUF1, TABUFO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE TYPE 3'
            GO TO 990
            END IF
         CALL TABIO ('READ', 4, IREC1, IBUF1, TABUF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ TYPE 4'
            GO TO 990
            END IF
         CALL TABIO ('WRIT', 4, IREC1, IBUF1, TABUFO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE TYPE 4'
            GO TO 990
            END IF
 100     CONTINUE
C                                       keywords
      IF (NKEY.GT.0) THEN
         CALL TABKEY ('ALL ', KEYW, NKEY, TABUF1, KLOCS, DBUF1, KEYTYP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ KEYWORDS'
            GO TO 990
            END IF
         CALL TABKEY ('WRIT', KEYW, NKEY, TABUFO, KLOCS, DBUF1, KEYTYP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE KEYWORDS'
            GO TO 990
            END IF
         END IF
C                                       selection strings
      NSEL = TABUF1(61)
      DO 110 IREC1 = 1,NSEL
         CALL TABIO ('READ', 2, IREC1, IBUF1, TABUF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ TYPE 2'
            GO TO 990
            END IF
         CALL TABIO ('WRIT', 2, IREC1, IBUF1, TABUFO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE TYPE 2'
            GO TO 990
            END IF
 110     CONTINUE
C                                       data
      NROWO = 0
      IREC1 = 0
      IREC2 = 0
      READ1 = .TRUE.
      READ2 = .TRUE.
C                                       read loop
 200  IF ((IREC1.LT.NROW1) .OR. (IREC2.LT.NROW2)) THEN
         IF ((READ1) .AND. (IREC1.LT.NROW1)) THEN
            IREC1 = IREC1 + 1
            CALL TABIO ('READ', 0, IREC1, IBUF1, TABUF1, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ 1ST FILE DATA ROW'
               GO TO 990
            ELSE IF (IRET.LT.0) THEN
               GO TO 200
            ELSE
               READ1 = .FALSE.
               END IF
            END IF
         IF ((READ2) .AND. (IREC2.LT.NROW2)) THEN
            IREC2 = IREC2 + 1
            CALL TABIO ('READ', 0, IREC2, IBUF2, TABUF2, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ 2ND FILE DATA ROW'
               GO TO 990
            ELSE IF (IRET.LT.0) THEN
               GO TO 200
            ELSE
               READ2 = .FALSE.
               END IF
            END IF
C                                       compare
         IF ((IREC1.LE.NROW1) .AND. (IREC2.LE.NROW2)) THEN
            CALL GETNXT (NWORDS, KEY, FKEY, COLTYP, IPCOL, DBUF1, DBUF2,
     *         NEXT)
C                                       write from 1st file
            IF (NEXT.EQ.1) THEN
               NROWO = NROWO + 1
               CALL TABIO ('WRIT', 0, NROWO, IBUF1, TABUFO, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITE DATA ROW'
                  GO TO 990
                  END IF
               READ1 = .TRUE.
               IF (IREC1.GE.NROW1) IREC1 = NROW1 + 1
C                                       write from 2nd file
            ELSE IF (NEXT.EQ.2) THEN
               NROWO = NROWO + 1
               CALL TABIO ('WRIT', 0, NROWO, IBUF2, TABUFO, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITE DATA ROW'
                  GO TO 990
                  END IF
               READ2 = .TRUE.
               IF (IREC2.GE.NROW2) IREC2 = NROW2 + 1
C                                       if equal are rows identical?
            ELSE
               DO 210 J = 1,NWORDS
                  IF (IBUF1(J).NE.IBUF2(J)) GO TO 220
 210              CONTINUE
               IF (IREC1.LT.NROW1) THEN
                  READ1 = .TRUE.
               ELSE
                  READ2 = .TRUE.
                  END IF
               GO TO 200
C                                       differ write 1
 220           NROWO = NROWO + 1
               CALL TABIO ('WRIT', 0, NROWO, IBUF1, TABUFO, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITE DATA ROW'
                  GO TO 990
                  END IF
               READ1 = .TRUE.
               IF (IREC1.GE.NROW1) IREC1 = NROW1 + 1
               END IF
         ELSE IF (IREC1.LE.NROW1) THEN
            NROWO = NROWO + 1
            CALL TABIO ('WRIT', 0, NROWO, IBUF1, TABUFO, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITE DATA ROW'
               GO TO 990
               END IF
            READ1 = .TRUE.
            IF (IREC1.GE.NROW1) IREC1 = NROW1 + 1
         ELSE IF (IREC2.LE.NROW2) THEN
            NROWO = NROWO + 1
            CALL TABIO ('WRIT', 0, NROWO, IBUF2, TABUFO, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITE DATA ROW'
               GO TO 990
               END IF
            READ2 = .TRUE.
            IF (IREC2.GE.NROW2) IREC2 = NROW2 + 1
            END IF
         GO TO 200
         END IF
C                                       close file 1
      CALL TABIO ('CLOS', 0, IREC1, IBUF1, TABUF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSE 1ST TABLE'
         GO TO 990
         END IF
C                                       close file 2
      CALL TABIO ('CLOS', 0, IREC2, IBUF2, TABUF2, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSE 2ND TABLE'
         GO TO 990
         END IF
C                                       add sort info
      TABUFO(43) = KEY(1,1)
      IF (TABUFO(43).LT.0) TABUFO(43) = 256 - KEY(1,1)
      TABUFO(44) = KEY(1,2)
      IF (TABUFO(44).LT.0) TABUFO(44) = 256 - KEY(1,2)
      IF (FKEY(1,1).LT.0.0) TABUFO(43) = -TABUFO(43)
      IF (FKEY(1,2).LT.0.0) TABUFO(44) = -TABUFO(44)
C                                       close scr 1
      CALL TABIO ('CLOS', 0, NROWO, IBUF1, TABUFO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSE OUTPUT TABLE'
         GO TO 990
         END IF
      GO TO 999
C                                       error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TAPPED: ERROR',I4,' DOING ',A)
 1050 FORMAT ('Main sort on column',I4)
 1051 FORMAT ('Secondary sort on column',I4)
 1052 FORMAT ('Secondary sort on baseline code columns',2I4)
 1053 FORMAT ('Secondary sort on baseline from column',I4,' array')
 1100 FORMAT ('TAPPED: COLUMN OUT OF RANGE KEY',I3,' =',2I5)
      END
      SUBROUTINE TAPPEH (IRET, SCRBUF)
C-----------------------------------------------------------------------
C   TAPPEH cleans up after TAPPE -- deleting scratch extension files and
C   (on error) any other newly created ones.  It then adds information
C   to the history file.
C   Inputs:
C      IRET     I      Error code from previous routines
C   Output:
C      SCRBUF   I(*)   Scratch
C-----------------------------------------------------------------------
      INTEGER   IRET, SCRBUF(*)
C
      CHARACTER HILINE*72, ATIME*8, ADATE*12, CHTMP*2, PHNAME*48
      INTEGER   I, EMIN, EMAX, JP, IVER, IERR, ID(3), IT(3), HLUN
      LOGICAL   T
      INCLUDE 'TAPPE.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA T /.TRUE./
      DATA HLUN /27/
C-----------------------------------------------------------------------
C                                       extension file clean up
      EMAX = 0
      DO 10 I = 1,KIEXTN
         CALL H2CHR (2, 1, CATH(KHEXT+I-1), CHTMP)
         IF (CHTMP.EQ.TTYPE) THEN
            JP = KIVER + I - 1
            EMAX = CATBLK(JP)
            GO TO 20
            END IF
 10      CONTINUE
 20   EMIN = MAXVER + 1
      IF (IRET.EQ.0) EMIN = MAX (EMIN, OUTVER+1)
C                                       delete the extras
      IF (EMAX.GE.EMIN) THEN
         CATBLK(JP) = EMIN - 1
         DO 30 IVER = EMIN,EMAX
            CALL ZPHFIL (TTYPE, DISKO, CNOO, IVER, PHNAME, IERR)
            CALL ZDESTR (DISKO, PHNAME, IERR)
            IF (IERR.GT.1) CATBLK(JP) = IVER
 30         CONTINUE
C                                       Update catalog
         CALL CATIO ('UPDT', DISKO, CNOO, CATBLK, 'REST', SCRBUF, IERR)
         END IF
C                                       Do history
      IF (IRET.NE.0) GO TO 999
C                                       Open file
      CALL HIINIT (3)
      CALL HIOPEN (HLUN, DISKO, CNOO, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1100) IERR
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Version, date, time
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, ATIME, ADATE)
      WRITE (HILINE,1110) TSKNAM, RLSNAM, ADATE, ATIME
      CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       input file
      CALL HENCO1 (TSKNAM, NAMEI, CLASSI, SEQI, DISKI, HLUN, SCRBUF,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Input vers, number
      WRITE (MSGTXT,1111) NROW1, TTYPE, INVER1
      CALL MSGWRT (3)
      WRITE (HILINE,1112) TSKNAM, NROW1, TTYPE, INVER1
      CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCO1 (TSKNAM, NAMEO, CLASSO, SEQO, DISKO, HLUN, SCRBUF,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (MSGTXT,1111) NROW2, TTYPE, INVER2
      CALL MSGWRT (3)
      WRITE (HILINE,1112) TSKNAM, NROW2, TTYPE, INVER2
      CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Output vers, number
      WRITE (MSGTXT,1113) NROWO, TTYPE, OUTVER
      CALL MSGWRT (3)
      WRITE (HILINE,1114) TSKNAM, NROWO, TTYPE, OUTVER
      CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 200
C
 200  CALL HICLOS (HLUN, T, SCRBUF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ERROR:',I7,' OPENING HISTORY FILE')
 1110 FORMAT (A6,'Release =''',A7,' ''  /********* run ',A12,2X,A8)
 1111 FORMAT ('Read ',I10,' rows from ',A2,' file version',I5)
 1112 FORMAT (A6,'/ Read ',I10,' rows from ',A2,' file version',I5)
 1113 FORMAT ('Wrote',I10,' rows to ',A2,' file version',I5)
 1114 FORMAT (A6,'/ Wrote',I10,' rows to ',A2,' file version',I5)
      END
      SUBROUTINE GETNXT (NWORDS, KEY, FKEY, COLTYP, IPCOL, DBUF1, DBUF2,
     *   NEXT)
C-----------------------------------------------------------------------
C   GETNXT gets the sort keys from 2 data sets and compares the
C   values telling the calling task whether 1 or 2 is next or they are
C   equal.
C   Inputs:
C      NWORDS   I        size of DBUF1 and 2
C      KEY      I(2,2)   Keys
C      FKEY     R(2,2)   Multipliers
C      COLTYP   I(2,2)   Column type
C      IPCOL    I(2,2)   column pointers (includes subscripts)
C      DBUF1    R(*)     first file table row
C      DBUF2    R(*)     second file table row
C   Outputs:
C      NEXT     I        1, 2, or 0 => equal
C-----------------------------------------------------------------------
      INTEGER   NWORDS, KEY(2,2), COLTYP(2,2), IPCOL(2,2), NEXT
      REAL      FKEY(2,2), DBUF1(*), DBUF2(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MXREC
      PARAMETER (MXREC = XBPRSZ+2)
C
      INTEGER   JKEY, NOCOL, ICOL, IP, KKEY, LKEY, FFKEY, NCHR, INDEX,
     *   ICHA, IICHR, RECI1(MXREC), RECI2(MXREC)
      REAL      RECR1(MXREC), RECR2(MXREC)
      HOLLERITH RECH1(MXREC), RECH2(MXREC)
      DOUBLE PRECISION RECD1(MXREC/2), RECD2(MXREC/2), XVAL1(2,2),
     *   XVAL2(2,2)
      CHARACTER CHR1*32, CHR2*32
      EQUIVALENCE (RECI1, RECR1, RECH1, RECD1)
      EQUIVALENCE (RECI2, RECR2, RECH2, RECD2)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL COPY (NWORDS, DBUF1, RECI1)
      CALL COPY (NWORDS, DBUF2, RECI2)
      CALL DFILL (4, 0.0D0, XVAL1)
      CALL DFILL (4, 0.0D0, XVAL2)
      DO 100 JKEY = 1,2
         IF (KEY(1,JKEY).EQ.0) GO TO 100
         NOCOL = 2
         IF (KEY(2,JKEY).EQ.0) NOCOL = 1
         DO 80 ICOL = 1,NOCOL
C                                       Select key.
            IP = IPCOL(ICOL,JKEY)
            KKEY = COLTYP(ICOL,JKEY)
            LKEY = KEY(ICOL,JKEY)
            FFKEY = FKEY(ICOL,JKEY)
C                                       Double precision (1)
            IF (KKEY.EQ.1) THEN
               IF (LKEY.GT.0) THEN
                  XVAL1(ICOL,JKEY) = XVAL1(ICOL,JKEY) - RECD1(IP)*FFKEY
                  XVAL2(ICOL,JKEY) = XVAL2(ICOL,JKEY) - RECD2(IP)*FFKEY
               ELSE
                  XVAL1(ICOL,JKEY) = XVAL1(ICOL,JKEY) - ABS (RECD1(IP))
     *               * FFKEY
                  XVAL2(ICOL,JKEY) = XVAL2(ICOL,JKEY) - ABS (RECD2(IP))
     *               * FFKEY
                  END IF
C                                       Single precision (2)
            ELSE IF (KKEY.EQ.2) THEN
               IF (LKEY.GT.0) THEN
                  XVAL1(ICOL,JKEY) = XVAL1(ICOL,JKEY) - RECR1(IP)*FFKEY
                  XVAL2(ICOL,JKEY) = XVAL2(ICOL,JKEY) - RECR2(IP)*FFKEY
               ELSE
                  XVAL1(ICOL,JKEY) = XVAL1(ICOL,JKEY) - ABS (RECR1(IP))
     *               * FFKEY
                  XVAL2(ICOL,JKEY) = XVAL2(ICOL,JKEY) - ABS (RECR2(IP))
     *               * FFKEY
                  END IF
C                                       Char. string. (3)
            ELSE IF (KKEY.EQ.3) THEN
               NCHR = FKEY(2,JKEY) + 0.5
               INDEX = FKEY(1,JKEY) + 0.5
               ICHA = ICHAR ('A')
               CALL H2CHR (NCHR, INDEX, RECH1(IP), CHR1)
               CALL H2CHR (NCHR, INDEX, RECH2(IP), CHR2)
               DO 40 IICHR = 1,NCHR
C                                       Use char-"A" * 64**(NCHR-IICHR)
                  XVAL1(ICOL,JKEY) = XVAL1(ICOL,JKEY) -
     *               (ICHAR (CHR1(IICHR:IICHR)) - ICHA) *
     *               64 ** (NCHR-IICHR)
                  XVAL2(ICOL,JKEY) = XVAL2(ICOL,JKEY) -
     *               (ICHAR (CHR2(IICHR:IICHR)) - ICHA) *
     *               64 ** (NCHR-IICHR)
 40               CONTINUE
C                                       Integer (4)
            ELSE IF (KKEY.EQ.4) THEN
               IF (LKEY.GT.0) THEN
                  XVAL1(ICOL,JKEY) = XVAL1(ICOL,JKEY) - RECI1(IP)*FFKEY
                  XVAL2(ICOL,JKEY) = XVAL2(ICOL,JKEY) - RECI2(IP)*FFKEY
               ELSE
                  XVAL1(ICOL,JKEY) = XVAL1(ICOL,JKEY) - ABS (RECI1(IP))
     *               * FFKEY
                  XVAL2(ICOL,JKEY) = XVAL2(ICOL,JKEY) - ABS (RECI2(IP))
     *               * FFKEY
                  END IF
C                                       Logical (use I)   (5)
            ELSE IF (KKEY.EQ.5) THEN
               XVAL1(ICOL,JKEY) = XVAL1(ICOL,JKEY) - RECI1(IP)*FFKEY
               XVAL2(ICOL,JKEY) = XVAL2(ICOL,JKEY) - RECI2(IP)*FFKEY
C                                       Short integer (Illegal) (6)
            ELSE IF (KKEY.EQ.5) THEN
               MSGTXT = 'SHORT INTEGERS NOW ILLEGAL'
C                                       Bit array (7)
C                                       This doesn't make  much sense
C                                       use I   array.
            ELSE IF (KKEY.EQ.5) THEN
               XVAL1(ICOL,JKEY) = XVAL1(ICOL,JKEY) - RECI1(IP)*FFKEY
               XVAL2(ICOL,JKEY) = XVAL2(ICOL,JKEY) - RECI2(IP)*FFKEY
               END IF
 80         CONTINUE
 100     CONTINUE
C
      XVAL1(1,1) = XVAL1(1,1) + XVAL1(2,1)
      XVAL1(1,2) = XVAL1(1,2) + XVAL1(2,2)
      XVAL2(1,1) = XVAL2(1,1) + XVAL2(2,1)
      XVAL2(1,2) = XVAL2(1,2) + XVAL2(2,2)
      NEXT = 0
      IF (XVAL1(1,1).GT.XVAL2(1,1)) THEN
         NEXT = 1
      ELSE IF (XVAL1(1,1).LT.XVAL2(1,1)) THEN
         NEXT = 2
      ELSE IF (XVAL1(1,2).GT.XVAL2(1,2)) THEN
         NEXT = 1
      ELSE IF (XVAL1(1,2).LT.XVAL2(1,2)) THEN
         NEXT = 2
         END IF
C
 999  RETURN
      END

C   Array Class:  name ='ARRAY'
C-----------------------------------------------------------------------
C! Object Oriented AIPS Fortran "ARRAY" class library
C# Map-util Utility Object-Oriented
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2000, 2002, 2012, 2015, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   An array is a regular array of values with several descriptive base
C   classes. General access to members is through ARRGET and ARRPUT
C   although efficient access to the array may be had through ARREAD and
C   ARRWRI.  Access may be by element, row, plane or image.  Arrays may
C   contain either real of complex data type elements.  Blanking is also
C   allowed.
C
C   Class Public members:
C      array   R(*,*...)  Array of Pixel values.  May be memory or disk
C                         resident.
C      ARRAY_PNT  class   Array access pointer
C      ARRAY_DESC class   Array description
C      ARRAY_STAT class   Array statistical information
C
C   Private class data:
C      ARRFDV     I(*,MAXIO) Internal array for I/O routine
C      ARRTYP     I(MAXIO)   Access type: 1=pixel, 2=row, 3=plane,
C                            4=array.
C      ARRPT      I(MAXIO)   Row element pointer
C      ARRDIM     I(7,MAXIO) Dimension of window in array
C
C   Public functions:
C      ARRGET (name, keywrd, type, dim, value, valuec, ierr)
C         Return array subarray.  Access may be by pixel, row, plane or
C         array as determined from ARRAY_DESC.
C      ARRPUT (name, keywrd, type, dim, value, valuec, ierr)
C         Store array subarray.  Access may be by pixel, row, plane or
C         array as determined from ARRAY_DESC.
C      ARREAD (name, dim, data, ierr)
C         Read a section of an array
C      ARRWRI (name, dim, data, ierr)
C         Write a section of an array
C      ARDRED (name, dim, data, ierr)
C         Read a section of an array to double memory
C      ARDWRI (name, dim, data, ierr)
C         Write a section of an array from double memory
C      ARRCLO (name, ierr)
C         Close I/O to an array
C      ARROPN (name, status, ierr)
C         Setup for I/O to an array
C      ARSSET (name, ierr)
C         Determines array statistics and updates ARRAY_STAT
C      ARHIST (name, nhis, hmin, hmax, hist, ierr)
C         Return histogram of array.
C      CHKBLK (n, data, valid)
C         Checks an array for blanking and returns a validity array
C      SETBLK (n, valid, data)
C         Blanks an array on the basis of a validity array.
C      ARRNEG (in, out, ierr)
C         Negate the values of an input array and write an out out
C         array.
C      ARRFFT (dir, in, scr, out, ierr)
C         FFT an array.
C      ARRADD (in1, in2, out, ierr)
C         Adds two arrays.
C      ARRSUB (in1, in2, out, ierr)
C         Subtracts array in2 from array in1.
C      ARRMUL (in1, in2, out, ierr)
C         Multiplies two arrays.
C      ARRDIV (in1, in2, out, ierr)
C         Divides array in1 by array in2.
C      ARRPAD (in, out, ierr)
C         Copy one array to another with zero padding.
C      ARRSCL (in, factor, out, ierr)
C         Scale an array with a real factor.
C      ARRCOP (in, out, ierr)
C         Copy the element of an array
C      ARRFIL (scalar, out, ierr)
C         Fill an array with a real scalar
C      ARRSAD (in, scalar, out, ierr)
C         Add a scalar to the elements of an array.
C      ARRSMU (in, scalar, out, ierr)
C         Multiply a scalar times the elements of an array.
C      ARRBSC (plus, minus, out, ierr)
C         Combine beam-switched images
C
C   Private Function:
C      ARRCHK (in1, in2, ierr)
C         Check that two arrays are compatible.
C      ARRWIN (name, blc, trc, dim, ierr)
C         Returns window information about an array
C      ARRCWI (name, ierr)
C         Clears the window (BLC, TRC) for first two dimensions of an
C         array object.
C      ARRIO (opcode, name, fdvec, ibuff, ipnt, ierr)
C         Handles I/O to disk resident array
C      ARRMEM (????)  Not implemented
C         Handles access to memory resident array.
LOCAL INCLUDE 'ARRAY.INC'
C                                       ARRAY class include
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   NMEML, NBASE
C                                       NMEML=no. member names
      PARAMETER (NMEML = 1)
C                                       NBASE = .no. base classes.
      PARAMETER (NBASE = 3)
C
      CHARACTER MEMS(NMEML)*8, BASE(NBASE)*16, THSCLS*16
      INTEGER   ARRFDV(80,MAXIO), ARRTYP(MAXIO), ARRPT(MAXIO),
     *   ARRDIM(7,MAXIO)
      LOGICAL   VALID1(MAXIMG), VALID2(MAXIMG), VALID3(MAXIMG),
     *   VALIDX(MAXIMG)
      COMMON /ARRIOC/ ARRFDV, ARRTYP, ARRPT, ARRDIM,
     *   VALIDX, VALID1, VALID2, VALID3
C                                       Recognized member names
      DATA MEMS /'ARRAY'/
C                                       Recognized base classes
      DATA BASE /'ARRAY_PNT', 'ARRAY_DESC', 'ARRAY_STAT'/
C                                       Class name
      DATA THSCLS /'ARRAY'/
LOCAL END
LOCAL INCLUDE 'ARGFORT'
      DOUBLE PRECISION DDUM(40)
      INTEGER   IDUM(80)
      LOGICAL   LDUM(80)
      REAL      RDUM(80)
      EQUIVALENCE (DDUM, IDUM, LDUM, RDUM)
      COMMON /GFORTAR/ DDUM
LOCAL END
      SUBROUTINE ARRGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public
C   Return a portion of an array.
C   value (array) for a specified member
C   Inputs:
C      NAME    C*(*)  Object name
C      KEYWRD  C*(*)  Keyword in form 'mem1.mem2...'
C   Outputs:
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of the array.
C      VALUE   ?     associated value (non character)
C      VALUEC  C*?   associated value (character)
C      IERR    I     Error code, 0=OK.  1=> did not find.,
C                    2= Input error.
C-----------------------------------------------------------------------
      INTEGER   TYPE, DIM(*), IERR
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC(*)*(*)
      REAL      VALUE(*)
C
      INTEGER   IMEM, LOOP, OBJNUM, POINT, IBASE, JERR
      CHARACTER MEMBER*16, BASCLS*16
      INCLUDE 'ARRAY.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Lookup NAME
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Look for base class.member name
C                                       in KEYWRD.
      POINT = INDEX (KEYWRD, '.')
C                                       Call necessary base class
C                                       access function.
      IF (POINT.GE.1) THEN
         BASCLS = KEYWRD(1:POINT-1)
C                                       Search list of recognized
C                                       members.
         IBASE = -1
         DO 20 LOOP = 1,NBASE
            IF (BASCLS.EQ.BASE(LOOP)) IBASE = LOOP
 20         CONTINUE
C                                       Find it?
            IF (IBASE.LE.0) THEN
               IERR = 2
               MSGTXT = 'UNRECOGNIZED ' // THSCLS // ' BASE CLASS ' //
     *            BASCLS
               CALL MSGWRT (7)
               GO TO 999
            ELSE
C                                       Call access function:
               GO TO (110, 120, 130), IBASE
C                                       ARRAY_PNT
 110              CALL ARPGET (NAME, KEYWRD(POINT+1:), TYPE, DIM, VALUE,
     *               VALUEC, JERR)
                  GO TO 900
C                                       ARRAY_DESC
 120              CALL ARDGET (NAME, KEYWRD(POINT+1:), TYPE, DIM, VALUE,
     *               VALUEC, JERR)
                  GO TO 900
C                                       ARRAY_STAT
 130              CALL ARSGET (NAME, KEYWRD(POINT+1:), TYPE, DIM, VALUE,
     *               VALUEC, JERR)
                  GO TO 900
               END IF
            GO TO 999
         END IF
C                                       Save member name
      IF (POINT.LE.0) POINT = LEN (KEYWRD) + 1
      MEMBER = KEYWRD(1:POINT-1)
C                                       Search list of recognized
C                                       members.
      IMEM = -1
      DO 500 LOOP = 1,NMEML
         IF (MEMBER.EQ.MEMS(LOOP)) IMEM = LOOP
 500     CONTINUE
C                                       Find it?
      IF (IMEM.LE.0) THEN
         IERR = 2
         MSGTXT = 'UNRECOGNIZED ' // THSCLS // ' MEMBER ' // MEMBER
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Call I/O routine:
      CALL ARREAD (NAME, DIM, VALUE, IERR)
      TYPE = 2
      IF (IERR.NE.0) GO TO 999
 900  IERR = 0
      IF (JERR.NE.0) IERR = 2
C
 999  RETURN
      END
      SUBROUTINE ARRPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public
C   Stores a portion of an array.
C   value (array) for a specified member
C   Inputs:
C      NAME    C*(*)  Object name
C      KEYWRD  C*(*)  Keyword in form 'mem1.mem2...'
C   Outputs:
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of the array.
C      VALUE   ?     associated value (non character)
C      VALUEC  C*?   associated value (character)
C      IERR    I     Error code, 0=OK.  1=> did not find.,
C                    2= Input error.
C-----------------------------------------------------------------------
      INTEGER   TYPE, DIM(*), IERR
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC(*)*(*)
      REAL      VALUE(*)
C
      INTEGER   IMEM, LOOP, OBJNUM, POINT, IBASE, JERR
      CHARACTER MEMBER*16, BASCLS*16
      INCLUDE 'ARRAY.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Lookup NAME
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Look for base class.member name
C                                       in KEYWRD.
      POINT = INDEX (KEYWRD, '.')
C                                       Call necessary base class
C                                       access function.
      IF (POINT.GE.1) THEN
         BASCLS = KEYWRD(1:POINT-1)
C                                       Search list of recognized
C                                       members.
         IBASE = -1
         DO 20 LOOP = 1,NBASE
            IF (BASCLS.EQ.BASE(LOOP)) IBASE = LOOP
 20         CONTINUE
C                                       Find it?
            IF (IBASE.LE.0) THEN
               IERR = 2
               MSGTXT = 'UNRECOGNIZED ' // THSCLS // ' BASE CLASS ' //
     *            BASCLS
               CALL MSGWRT (7)
               GO TO 999
            ELSE
C                                       Call access function:
               GO TO (110, 120, 130), IBASE
C                                       ARRAY_PNT
 110              CALL ARPPUT (NAME, KEYWRD(POINT+1:), TYPE, DIM, VALUE,
     *               VALUEC, JERR)
                  GO TO 900
C                                       ARRAY_DESC
 120              CALL ARDPUT (NAME, KEYWRD(POINT+1:), TYPE, DIM, VALUE,
     *               VALUEC, JERR)
                  GO TO 900
C                                       ARRAY_STAT
 130              CALL ARSPUT (NAME, KEYWRD(POINT+1:), TYPE, DIM, VALUE,
     *               VALUEC, JERR)
                  GO TO 900
               END IF
            GO TO 999
         END IF
C                                       Save member name
      IF (POINT.LE.0) POINT = LEN (KEYWRD) + 1
      MEMBER = KEYWRD(1:POINT-1)
C                                       Search list of recognized
C                                       members.
      IMEM = -1
      DO 500 LOOP = 1,NMEML
         IF (MEMBER.EQ.MEMS(LOOP)) IMEM = LOOP
 500     CONTINUE
C                                       Find it?
      IF (IMEM.LE.0) THEN
         IERR = 2
         MSGTXT = 'UNRECOGNIZED ' // THSCLS // ' MEMBER ' // MEMBER
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Call I/O routine:
      CALL ARRWRI (NAME, DIM, VALUE, IERR)
      IF (IERR.NE.0) GO TO 999
 900  IERR = 0
      IF (JERR.NE.0) IERR = 2
C
 999  RETURN
      END
      SUBROUTINE ARREAD (NAME, DIM, DATA, IERR)
C-----------------------------------------------------------------------
C   Public
C   Reads a portion of an array.  Initiates I/O if necessary.
C   Access may be by pixel, row, plane or array as specified by
C   ARRAY_PNT.ACCESS. Default = 'row'
C   Inputs:
C      NAME  C*32  The name of the object.
C   Output:
C      DIM   I(*)  The dimensionality of the value returned in DATA
C      DATA  R(*)  The next row of the image
C      IERR  I     Error return code, 0=OK, -1 => I/O complete when done
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      REAL      DATA(*)
      INTEGER   DIM(*), IERR
C
      INTEGER   BUFNO, NROW, LOOP, PNT(7)
      CHARACTER CDUMMY*1
      INCLUDE 'INCS:IMGERR.INC'
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Need to initialize?
C                                       Check I/O stream pointer
      CALL OBINFO (NAME, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 995
      IF (BUFNO.LE.0) THEN
         CALL ARROPN (NAME, 'READ', IERR)
         IF (IERR.NE.0) GO TO 995
         CALL OBINFO (NAME, BUFNO, IERR)
         IF (IERR.NE.0) GO TO 995
         END IF
C                                       I/O by access type
      GO TO (100, 200, 300, 400), ARRTYP(BUFNO)
C                                       Pixel
 100     IF (ARRPT(BUFNO).GT.ARRDIM(1,BUFNO)) THEN
            CALL ARRIO ('READ', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *         BUFPNT(BUFNO), IERR)
            IF (IERR.NE.0) GO TO 980
            ARRPT(BUFNO) = 0
            END IF
C                                       Array pointer
         DIM(1) = 7
         DIM(2) = 1
         DIM(3) = 0
         CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
         PNT(1) = ARRPT(BUFNO) + 1
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, DIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
C                                       Return values
         DIM(1) = 1
         DIM(2) = 0
         DATA(1) = OBUFFR(BUFPNT(BUFNO)+ARRPT(BUFNO),BUFNO)
         ARRPT(BUFNO) = ARRPT(BUFNO) + 1
         GO TO 999
C                                       Row
 200     CALL ARRIO ('READ', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *      BUFPNT(BUFNO), IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Array pointer
         DIM(1) = 7
         DIM(2) = 1
         DIM(3) = 1
         CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, DIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
C                                       Return values
         DIM(1) = ARRDIM(1,BUFNO)
         DIM(2) = 0
         CALL RCOPY (ARRDIM(1,BUFNO), OBUFFR(BUFPNT(BUFNO),BUFNO), DATA)
         GO TO 999
C                                       Plane
 300     ARRPT(BUFNO) = 1
         DO 320 LOOP = 1,ARRDIM(2,BUFNO)
            CALL ARRIO ('READ', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *         BUFPNT(BUFNO), IERR)
            IF (IERR.NE.0) GO TO 980
            IF (LOOP.EQ.1) CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
            CALL RCOPY (ARRDIM(1,BUFNO), OBUFFR(BUFPNT(BUFNO),BUFNO),
     *         DATA(ARRPT(BUFNO)))
            ARRPT(BUFNO) = ARRPT(BUFNO) + ARRDIM(1,BUFNO)
 320        CONTINUE
C                                       Array pointer
         DIM(1) = 7
         DIM(2) = 1
         DIM(3) = 1
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, DIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
C                                       Return actual dimension
         DIM(1) = ARRDIM(1,BUFNO)
         DIM(2) = ARRDIM(2,BUFNO)
         DIM(3) = 0
         GO TO 999
C                                       Array
 400     ARRPT(BUFNO) = 1
C                                       Find total number of rows
         NROW = 1
         DO 420 LOOP = 2,7
            IF (ARRDIM(LOOP,BUFNO).GT.1) NROW = NROW *
     *         ARRDIM(LOOP,BUFNO)
 420        CONTINUE
         ARRPT(BUFNO) = 1
         DO 440 LOOP = 1,NROW
            CALL ARRIO ('READ', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *         BUFPNT(BUFNO), IERR)
            IF (IERR.NE.0) GO TO 980
            IF (LOOP.EQ.1) CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
            CALL RCOPY (ARRDIM(1,BUFNO), OBUFFR(BUFPNT(BUFNO),BUFNO),
     *         DATA(ARRPT(BUFNO)))
            ARRPT(BUFNO) = ARRPT(BUFNO) + ARRDIM(1,BUFNO)
 440        CONTINUE
C                                       Array pointer
         DIM(1) = 7
         DIM(2) = 1
         DIM(3) = 1
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, DIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
C                                       Return actual dimension
         CALL COPY (6, ARRDIM(1,BUFNO), DIM)
         DIM(7) = 0
         GO TO 999
C                                       I/O error
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (7)
 995  MSGTXT = 'ARREAD: OBJECT IS ' // NAME
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('ARREAD: I/O ERROR ',I4)
      END
      SUBROUTINE ARRWRI (NAME, DIM, DATA, IERR)
C-----------------------------------------------------------------------
C   Public
C   Stores a portion of an array.  Initiates I/O if necessary.
C   Access may be by pixel, row, plane or array as specified by
C   the value in DIM.  Mixed modes of access type are not allowed.
C   Inputs:
C      NAME  C*32  The name of the object.
C      DIM   I(*)  The dimensionality of the value in DATA.
C      DATA  R(*)  The portion of the array.
C   Output:
C      IERR  I     Error return code, 0=OK, -1 => I/O complete when done
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      REAL      DATA(*)
      INTEGER   DIM(*), IERR
C
      INTEGER   BUFNO, NROW, LOOP, PNT(7), IDIM(7)
      CHARACTER CDUMMY*1
      INCLUDE 'INCS:IMGERR.INC'
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Need to initialize?
C                                       Check I/O stream pointer
      CALL OBINFO (NAME, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 995
      IF (BUFNO.LE.0) THEN
         CALL ARROPN (NAME, 'WRIT', IERR)
         IF (IERR.NE.0) GO TO 995
         CALL OBINFO (NAME, BUFNO, IERR)
         IF (IERR.NE.0) GO TO 995
         END IF
C                                       I/O by access type
      GO TO (100, 200, 300, 400), ARRTYP(BUFNO)
C                                       Pixel
 100     IF (ARRPT(BUFNO).GE.ARRDIM(1,BUFNO)) THEN
            CALL ARRIO ('WRIT', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *         BUFPNT(BUFNO), IERR)
            IF (IERR.NE.0) GO TO 980
            ARRPT(BUFNO) = 0
            END IF
         OBUFFR(BUFPNT(BUFNO)+ARRPT(BUFNO),BUFNO) = DATA(1)
         ARRPT(BUFNO) = ARRPT(BUFNO) + 1
C                                       Array pointer
         IDIM(1) = 7
         IDIM(2) = 1
         IDIM(3) = 0
         CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
         PNT(1) = ARRPT(BUFNO) + 2
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, IDIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
         GO TO 999
C                                       Row
 200     CALL RCOPY (ARRDIM(1,BUFNO), DATA, OBUFFR(BUFPNT(BUFNO),BUFNO))
         CALL ARRIO ('WRIT', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *      BUFPNT(BUFNO), IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Array pointer
         IDIM(1) = 7
         IDIM(2) = 1
         IDIM(3) = 1
         CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, IDIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
         GO TO 999
C                                       Plane
 300     ARRPT(BUFNO) = 1
         DO 320 LOOP = 1,ARRDIM(2,BUFNO)
            IF (LOOP.EQ.1) CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
            CALL RCOPY (ARRDIM(1,BUFNO), DATA(ARRPT(BUFNO)),
     *         OBUFFR(BUFPNT(BUFNO),BUFNO))
            CALL ARRIO ('WRIT', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *         BUFPNT(BUFNO), IERR)
            IF (IERR.NE.0) GO TO 980
            ARRPT(BUFNO) = ARRPT(BUFNO) + ARRDIM(1,BUFNO)
 320        CONTINUE
C                                       Array pointer
         IDIM(1) = 7
         IDIM(2) = 1
         IDIM(3) = 1
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, IDIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
         GO TO 999
C                                       Array
 400     ARRPT(BUFNO) = 1
C                                       Find total number of rows
         NROW = 1
         DO 420 LOOP = 2,7
            IF (ARRDIM(LOOP,BUFNO).GT.1) NROW = NROW *
     *         ARRDIM(LOOP,BUFNO)
 420        CONTINUE
         ARRPT(BUFNO) = 1
         DO 440 LOOP = 1,NROW
            CALL RCOPY (ARRDIM(1,BUFNO), DATA(ARRPT(BUFNO)),
     *         OBUFFR(BUFPNT(BUFNO),BUFNO))
            CALL ARRIO ('WRIT', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *         BUFPNT(BUFNO), IERR)
            IF (IERR.NE.0) GO TO 980
            IF (LOOP.EQ.1) CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
            ARRPT(BUFNO) = ARRPT(BUFNO) + ARRDIM(1,BUFNO)
 440        CONTINUE
C                                       Array pointer
         IDIM(1) = 7
         IDIM(2) = 1
         IDIM(3) = 1
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, IDIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
         GO TO 999
C                                       I/O error
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (7)
 995  MSGTXT = 'ARRWRI: OBJECT IS ' // NAME
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('ARRWRI: I/O ERROR ',I4)
      END
      SUBROUTINE ARDRED (NAME, DIM, DATA, IERR)
C-----------------------------------------------------------------------
C   Public
C   Reads a portion of an array.  Initiates I/O if necessary.
C   Access may be by pixel, row, plane or array as specified by
C   ARRAY_PNT.ACCESS. Default = 'row'
C   Inputs:
C      NAME  C*32  The name of the object.
C   Output:
C      DIM   I(*)  The dimensionality of the value returned in DATA
C      DATA  D(*)  The next row of the image
C      IERR  I     Error return code, 0=OK, -1 => I/O complete when done
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      DOUBLE PRECISION DATA(*)
      INTEGER   DIM(*), IERR
C
      INTEGER   BUFNO, NROW, LOOP, PNT(7), IV
      CHARACTER CDUMMY*1
      INCLUDE 'INCS:IMGERR.INC'
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Need to initialize?
C                                       Check I/O stream pointer
      CALL OBINFO (NAME, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 995
      IF (BUFNO.LE.0) THEN
         CALL ARROPN (NAME, 'READ', IERR)
         IF (IERR.NE.0) GO TO 995
         CALL OBINFO (NAME, BUFNO, IERR)
         IF (IERR.NE.0) GO TO 995
         END IF
C                                       I/O by access type
      GO TO (100, 200, 300, 400), ARRTYP(BUFNO)
C                                       Pixel
 100     IF (ARRPT(BUFNO).GT.ARRDIM(1,BUFNO)) THEN
            CALL ARRIO ('READ', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *         BUFPNT(BUFNO), IERR)
            IF (IERR.NE.0) GO TO 980
            ARRPT(BUFNO) = 0
            END IF
C                                       Array pointer
         DIM(1) = 7
         DIM(2) = 1
         DIM(3) = 0
         CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
         PNT(1) = ARRPT(BUFNO) + 1
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, DIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
C                                       Return values
         DIM(1) = 1
         DIM(2) = 0
         DATA(1) = OBUFFR(BUFPNT(BUFNO)+ARRPT(BUFNO),BUFNO)
         ARRPT(BUFNO) = ARRPT(BUFNO) + 1
         GO TO 999
C                                       Row
 200     CALL ARRIO ('READ', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *      BUFPNT(BUFNO), IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Array pointer
         DIM(1) = 7
         DIM(2) = 1
         DIM(3) = 1
         CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, DIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
C                                       Return values
         DIM(1) = ARRDIM(1,BUFNO)
         DIM(2) = 0
         DO 210 IV = 1,ARRDIM(1,BUFNO)
            DATA(IV) = OBUFFR(BUFPNT(BUFNO)+IV-1,BUFNO)
 210        CONTINUE
         GO TO 999
C                                       Plane
 300     ARRPT(BUFNO) = 1
         DO 320 LOOP = 1,ARRDIM(2,BUFNO)
            CALL ARRIO ('READ', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *         BUFPNT(BUFNO), IERR)
            IF (IERR.NE.0) GO TO 980
            IF (LOOP.EQ.1) CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
            DO 310 IV = 1,ARRDIM(1,BUFNO)
               DATA(ARRPT(BUFNO)+IV-1) =
     *            OBUFFR(BUFPNT(BUFNO)+IV-1,BUFNO)
 310           CONTINUE
            ARRPT(BUFNO) = ARRPT(BUFNO) + ARRDIM(1,BUFNO)
 320        CONTINUE
C                                       Array pointer
         DIM(1) = 7
         DIM(2) = 1
         DIM(3) = 1
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, DIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
C                                       Return actual dimension
         DIM(1) = ARRDIM(1,BUFNO)
         DIM(2) = ARRDIM(2,BUFNO)
         DIM(3) = 0
         GO TO 999
C                                       Array
 400     ARRPT(BUFNO) = 1
C                                       Find total number of rows
         NROW = 1
         DO 420 LOOP = 2,7
            IF (ARRDIM(LOOP,BUFNO).GT.1) NROW = NROW *
     *         ARRDIM(LOOP,BUFNO)
 420        CONTINUE
         ARRPT(BUFNO) = 1
         DO 440 LOOP = 1,NROW
            CALL ARRIO ('READ', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *         BUFPNT(BUFNO), IERR)
            IF (IERR.NE.0) GO TO 980
            IF (LOOP.EQ.1) CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
            DO 410 IV = 1,ARRDIM(1,BUFNO)
               DATA(ARRPT(BUFNO)+IV-1) =
     *            OBUFFR(BUFPNT(BUFNO)+IV-1,BUFNO)
 410           CONTINUE
            ARRPT(BUFNO) = ARRPT(BUFNO) + ARRDIM(1,BUFNO)
 440        CONTINUE
C                                       Array pointer
         DIM(1) = 7
         DIM(2) = 1
         DIM(3) = 1
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, DIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
C                                       Return actual dimension
         CALL COPY (6, ARRDIM(1,BUFNO), DIM)
         DIM(7) = 0
         GO TO 999
C                                       I/O error
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (7)
 995  MSGTXT = 'ARDRED: OBJECT IS ' // NAME
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('ARDRED: I/O ERROR ',I4)
      END
      SUBROUTINE ARDWRI (NAME, DIM, DATA, IERR)
C-----------------------------------------------------------------------
C   Public
C   Stores a portion of an array.  Initiates I/O if necessary.
C   Access may be by pixel, row, plane or array as specified by
C   the value in DIM.  Mixed modes of access type are not allowed.
C   Inputs:
C      NAME  C*32  The name of the object.
C      DIM   I(*)  The dimensionality of the value in DATA.
C      DATA  D(*)  The portion of the array.
C   Output:
C      IERR  I     Error return code, 0=OK, -1 => I/O complete when done
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      DOUBLE PRECISION DATA(*)
      INTEGER   DIM(*), IERR
C
      INTEGER   BUFNO, NROW, LOOP, PNT(7), IDIM(7), IV
      CHARACTER CDUMMY*1
      INCLUDE 'INCS:IMGERR.INC'
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Need to initialize?
C                                       Check I/O stream pointer
      CALL OBINFO (NAME, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 995
      IF (BUFNO.LE.0) THEN
         CALL ARROPN (NAME, 'WRIT', IERR)
         IF (IERR.NE.0) GO TO 995
         CALL OBINFO (NAME, BUFNO, IERR)
         IF (IERR.NE.0) GO TO 995
         END IF
C                                       I/O by access type
      GO TO (100, 200, 300, 400), ARRTYP(BUFNO)
C                                       Pixel
 100     IF (ARRPT(BUFNO).GE.ARRDIM(1,BUFNO)) THEN
            CALL ARRIO ('WRIT', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *         BUFPNT(BUFNO), IERR)
            IF (IERR.NE.0) GO TO 980
            ARRPT(BUFNO) = 0
            END IF
         OBUFFR(BUFPNT(BUFNO)+ARRPT(BUFNO),BUFNO) = DATA(1)
         ARRPT(BUFNO) = ARRPT(BUFNO) + 1
C                                       Array pointer
         IDIM(1) = 7
         IDIM(2) = 1
         IDIM(3) = 0
         CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
         PNT(1) = ARRPT(BUFNO) + 2
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, IDIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
         GO TO 999
C                                       Row
 200     DO 210 IV = 1,ARRDIM(1,BUFNO)
            OBUFFR(BUFPNT(BUFNO)+IV-1,BUFNO) = DATA(IV)
 210        CONTINUE
         CALL ARRIO ('WRIT', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *      BUFPNT(BUFNO), IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Array pointer
         IDIM(1) = 7
         IDIM(2) = 1
         IDIM(3) = 1
         CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, IDIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
         GO TO 999
C                                       Plane
 300     ARRPT(BUFNO) = 1
         DO 320 LOOP = 1,ARRDIM(2,BUFNO)
            IF (LOOP.EQ.1) CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
            DO 310 IV = 1,ARRDIM(1,BUFNO)
               OBUFFR(BUFPNT(BUFNO)+IV-1,BUFNO) =
     *            DATA(ARRPT(BUFNO)+IV-1)
 310           CONTINUE
            CALL ARRIO ('WRIT', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *         BUFPNT(BUFNO), IERR)
            IF (IERR.NE.0) GO TO 980
            ARRPT(BUFNO) = ARRPT(BUFNO) + ARRDIM(1,BUFNO)
 320        CONTINUE
C                                       Array pointer
         IDIM(1) = 7
         IDIM(2) = 1
         IDIM(3) = 1
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, IDIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
         GO TO 999
C                                       Array
 400     ARRPT(BUFNO) = 1
C                                       Find total number of rows
         NROW = 1
         DO 420 LOOP = 2,7
            IF (ARRDIM(LOOP,BUFNO).GT.1) NROW = NROW *
     *         ARRDIM(LOOP,BUFNO)
 420        CONTINUE
         ARRPT(BUFNO) = 1
         DO 440 LOOP = 1,NROW
            DO 410 IV = 1,ARRDIM(1,BUFNO)
               OBUFFR(BUFPNT(BUFNO)+IV-1,BUFNO) =
     *            DATA(ARRPT(BUFNO)+IV-1)
 410           CONTINUE
            CALL ARRIO ('WRIT', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *         BUFPNT(BUFNO), IERR)
            IF (IERR.NE.0) GO TO 980
            IF (LOOP.EQ.1) CALL COPY (7, ARRFDV(FDIMPT,BUFNO), PNT)
            ARRPT(BUFNO) = ARRPT(BUFNO) + ARRDIM(1,BUFNO)
 440        CONTINUE
C                                       Array pointer
         IDIM(1) = 7
         IDIM(2) = 1
         IDIM(3) = 1
         CALL COPY (7, PNT, IDUM)
         CALL ARPPUT (NAME, 'POSN', OOAINT, IDIM, RDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 995
         GO TO 999
C                                       I/O error
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (7)
 995  MSGTXT = 'ARDWRI: OBJECT IS ' // NAME
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('ARDWRI: I/O ERROR ',I4)
      END
      SUBROUTINE ARRCLO (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Closes I/O associated with an object flushing the buffer on write.
C   Inputs:
C      NAME  C*32  The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INTEGER   BUFNO, DISK, CNO, TYPE, DIM(7)
      CHARACTER DATYPE*8
      LOGICAL   DOCMPL
      INCLUDE 'INCS:IMGERR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       I/O open
C                                       Check I/O stream pointer
      CALL OBINFO (NAME, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 995
      IF (BUFNO.LE.0) THEN
C                                       Do not bother if closed.
         IERR = 0
         GO TO 999
      END IF
C                                       Close
      CALL ARRIO ('CLOS', NAME, ARRFDV(1,BUFNO), OBUFFR(1,BUFNO),
     *   BUFPNT(BUFNO), IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Update disk header if write
      IF (ARRFDV(FDRW,BUFNO).EQ.1) THEN
C                                       Find disk and slot
         CALL OBDSKC (NAME, DISK, CNO, IERR)
         IF (IERR.NE.0) GO TO 995
         CALL OBHGET (NAME, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 995
C                                       Complex?
         CALL ARDGET (NAME, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
         DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
         IERR = 0
C                                       Reset if complex
         IF (DOCMPL) CATBLK(KINAX) = CATBLK(KINAX) * 2
         CALL OBHPUT (NAME, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 995
C                                       Store  CATBLK
         CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'REST', SBUFF, IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.4)) THEN
            WRITE (MSGTXT,1000) IERR
            GO TO 990
            END IF
         IERR = 0
         END IF
      CALL OBCLOS (NAME, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Deassign LUN
      CALL OBLUFR (ARRFDV(FDLUNI,BUFNO))
      GO TO 999
C                                       Error
 990  CALL MSGWRT (7)
 995  MSGTXT = 'ARRCLO: ERROR CLOSING ' // NAME
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ARRCLO: CATIO ERROR ',I3,' UPDATING CATALOG')
      END
      SUBROUTINE ARROPN (NAME, STATUS, IERR)
C-----------------------------------------------------------------------
C   Public
C   Sets up to open an array file
C   Inputs:
C      NAME   C*32  The name of the object.
C      STATUS C*4   'READ' or 'WRIT'
C   Output:
C      IERR   I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), STATUS*4
      INTEGER   IERR
C
      INTEGER   BUFNO, TYPE, DIM(7), BLC(7), TRC(7), DISK, CNO
      LOGICAL   DOCMPL
      CHARACTER ATYPE*8, DATYPE*8
      INCLUDE 'INCS:IMGERR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Open array
      CALL OBOPEN (NAME, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (NAME, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex?
      CALL ARDGET (NAME, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
      IERR = 0
C                                       Fetch disk header
C                                       Find disk and slot
      CALL OBDSKC (NAME, DISK, CNO, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Store  CATBLK
      CALL CATIO ('READ', DISK, CNO, CATBLK, 'REST', SBUFF, IERR)
      IF ((IERR.GE.1) .AND. (IERR.LE.4)) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
      IERR = 0
C                                       Reset if complex
      IF (DOCMPL) CATBLK(KINAX) = CATBLK(KINAX) / 2
      CALL OBHPUT (NAME, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Access type
      CALL ARPGET (NAME, 'ACCESS', TYPE, DIM, RDUM, ATYPE, IERR)
C                                       Default = 'ROW'
      IF (IERR.NE.0) THEN
         ATYPE = 'ROW'
         IERR = 0
         END IF
      IF (ATYPE.EQ.'PIXEL') ARRTYP(BUFNO) = 1
      IF (ATYPE.EQ.'ROW') ARRTYP(BUFNO) = 2
      IF (ATYPE.EQ.'PLANE') ARRTYP(BUFNO) = 3
      IF (ATYPE.EQ.'ARRAY') ARRTYP(BUFNO) = 4
C                                       Set buffer pointer for read or
C                                       write.
      IF (STATUS.EQ.'READ') THEN
         ARRPT(BUFNO) = ARRDIM(1,BUFNO) + 1
      ELSE IF (STATUS.EQ.'WRIT') THEN
         ARRPT(BUFNO) = 0
      ELSE
C                                       Unknown status
         MSGTXT = 'ARROPN: UNKNOWN STATUS= ' // STATUS
         IERR = 1
         GO TO 990
         END IF
C                                       Get size of the window
      CALL ARRWIN (NAME, BLC, TRC, ARRDIM(1,BUFNO), IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex?
      IF (DOCMPL) ARRDIM(1,BUFNO) = ARRDIM(1,BUFNO) * 2
C                                       Init FDV.
      CALL FILL (80, 0, ARRFDV(1,BUFNO))
C                                       Buffer size
      ARRFDV(FDSZIB,BUFNO) = BUFSIZ * 2
C                                       Read or write
      IF (STATUS.EQ.'READ') THEN
         ARRFDV(FDRW,BUFNO) = 0
      ELSE
         ARRFDV(FDRW,BUFNO) = 1
         END IF
C                                       Assign LUN
      CALL OBLUN (ARRFDV(FDLUNI,BUFNO), IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       error
 990  CALL MSGWRT (7)
 995  MSGTXT = 'ARROPN: ERROR OPENING ' // NAME
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ARROPN: CATIO ERROR ',I3,' READING CATBLK')
      END
      SUBROUTINE ARRCHK (IN1, IN2, IERR)
C-----------------------------------------------------------------------
C   Private
C   Check that two arrays have the same structure
C   Inputs:
C      IN1   C*32  The name of the first image object.
C      IN2   C*32  The name of the second image object.
C   Output:
C      IERR  I     Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER IN1*(*), IN2*(*)
      INTEGER   IERR
C
      INTEGER   NAXIS1(7), NAXIS2(7), BLC1(7), BLC2(7), TRC1(7),
     *   TRC2(7), LOOP, NDIM1, NDIM2, TYPE, DIM(7)
      CHARACTER CDUMMY*1
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Dimensionality
      CALL ARDGET (IN1, 'NDIM', TYPE, DIM, RDUM, CDUMMY, IERR)
      NDIM1 = IDUM(1)
      IF (IERR.NE.0) GO TO 995
      CALL ARDGET (IN2, 'NDIM', TYPE, DIM, RDUM, CDUMMY, IERR)
      NDIM2 = IDUM(1)
      IF (IERR.NE.0) GO TO 995
C                                       Axis dimensions, allow for
C                                       subimaging.
      CALL ARRWIN (IN1, BLC1, TRC1, NAXIS1, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRWIN (IN2, BLC2, TRC2, NAXIS2, IERR)
      IF (IERR.NE.0) GO TO 995
      DO 100 LOOP = 1,7
         IF (LOOP.GT.NDIM1) NAXIS1(LOOP) = 1
         IF (LOOP.GT.NDIM2) NAXIS2(LOOP) = 1
         IF (NAXIS1(LOOP).NE.NAXIS2(LOOP)) THEN
            IERR = 1
            WRITE (MSGTXT,1000) LOOP, NAXIS1(LOOP), NAXIS2(LOOP)
            GO TO 990
            END IF
 100     CONTINUE
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
 995  MSGTXT = 'ARRCHK: FIRST OBJECT IS ' // IN1
      CALL MSGWRT (6)
      MSGTXT = 'ARRCHK: SECOND OBJECT IS ' // IN2
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ARRCHK: ARRAY AXIS ',I3,' HAVE UNEQUAL SIZE ',2I5)
      END
      SUBROUTINE ARRWIN (NAME, BLC, TRC, NDIM, IERR)
C-----------------------------------------------------------------------
C   Private
C   Determine the specified window in an image
C   Inputs:
C      NAME  C*32  The name of the image object.
C   Output:
C      BLC   I(*)  Bottom left corner
C      TRC   I(*)  Top Right corner
C      NDIM  I(*)  Dimension of the window
C      IERR  I     Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   BLC(*), TRC(*), NDIM(*), IERR
C
      INTEGER   DIM(7), NAXIS(7), IBLC(7), ITRC(7), LOOP, TYPE, ND
      CHARACTER CDUMMY*1
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Dimensionality
      CALL ARDGET (NAME, 'NDIM', TYPE, DIM, RDUM, CDUMMY, IERR)
      ND = IDUM(1)
      IF (IERR.NE.0) GO TO 995
C                                       Axis dimensions
      CALL ARDGET (NAME, 'NAXIS', TYPE, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL COPY (DIM(1), IDUM, NAXIS)
C                                       Specified BLC
      CALL ARDGET (NAME, 'BLC', TYPE, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) THEN
         CALL FILL (7, 0, IBLC)
      ELSE
         CALL COPY (DIM(1), IDUM, IBLC)
         END IF
C                                       Specified TRC
      CALL ARDGET (NAME, 'TRC', TYPE, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) THEN
         CALL FILL (7, 0, ITRC)
      ELSE
         CALL COPY (DIM(1), IDUM, ITRC)
         END IF
C                                       Fill BLC, TRC
      DO 100 LOOP = 1,7
         IF (LOOP.GT.ND) NAXIS(LOOP) = 1
         BLC(LOOP) = MAX (1, IBLC(LOOP))
         BLC(LOOP) = MIN (BLC(LOOP), NAXIS(LOOP))
         TRC(LOOP) = ITRC(LOOP)
         IF (TRC(LOOP).LE.0) TRC(LOOP) = NAXIS(LOOP)
         TRC(LOOP) = MIN (TRC(LOOP), NAXIS(LOOP))
         NDIM(LOOP) = MAX (1, (TRC(LOOP) - BLC(LOOP) + 1))
 100     CONTINUE
      GO TO 999
C                                       Error
 995  MSGTXT = 'ARRWIN: ERROR WITH WINDOW FOR ' // NAME
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE ARRCWI (NAME, IERR)
C-----------------------------------------------------------------------
C   Private
C   Clears the window (BLC, TRC) for first two dimensions of an array
C   object
C   Inputs:
C      NAME  C*32  The name of the image object.
C   Output:
C      IERR  I     Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INTEGER   DIM(7), NAXIS(7), IBLC(7), ITRC(7), TYPE
      CHARACTER CDUMMY*1
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Axis dimensions
      CALL ARDGET (NAME, 'NAXIS', TYPE, DIM, RDUM, CDUMMY, IERR)
      CALL COPY (DIM(1), IDUM, NAXIS)
      IF (IERR.NE.0) GO TO 995
      CALL ARDGET (NAME, 'BLC', TYPE, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) THEN
         CALL FILL (7, 0, IBLC)
      ELSE
         CALL COPY (DIM(1), IDUM, IBLC)
         END IF
      CALL ARDGET (NAME, 'TRC', TYPE, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) THEN
         CALL FILL (7, 0, ITRC)
      ELSE
         CALL COPY (DIM(1), IDUM, ITRC)
         END IF
C                                       Set BLC
      IBLC(1) = 1
      IBLC(2) = 1
      CALL COPY (7, IBLC, IDUM)
      CALL ARDPUT (NAME, 'BLC', OOAINT, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Set TRC
      ITRC(1) = 0
      ITRC(2) = NAXIS(2)
      CALL COPY (7, ITRC,  IDUM)
      CALL ARDPUT (NAME, 'TRC', OOAINT, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  CALL MSGWRT (7)
 995  MSGTXT = 'ARRCWI: ERROR RESETTING WINDOW: ' // NAME
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE ARRIO (OPCODE, NAME, FDVEC, IBUFF, IPNT, IERR)
C-----------------------------------------------------------------------
C   Private
C   Reads or writes rows of a disk resident array.
C      Most of the necessary information needed to define the file,
C   windows etc. is saved in the array FDVEC.  A standard include
C   file IMGERR.INC defines pointers into this array and it is advised
C   to use these pointers rather than hardcoded subscripts.
C      Mixed reads and writes are not supported using the same LUNs and
C   buffers but ARRIO may be used with separate LUNs, buffers and FDVEC
C   to read and write the same file.
C      ARRIO keeps track of the max. and min. values when OPCODE='WRIT'.
C   Magic value blanking is supported and if ARRAY.ARRAY_DESC.BLANK is
C   non zero then the associated array contains blanked elements.
C   Usage notes:
C     2) Opening the file.  If ARRIO determines that the file is not
C        open it will do so.   Once the file is open the file
C        descriptor vector FDVEC must be used in each call.  No explicit
C        open call is needed.
C     3) Initialization.  ARRIO initializes the I/O using the values in
C        FDVEC when it opens the file.
C     4) Closing the file.  The file may be closed with a call with
C        opcode 'CLOS'.  If OPCODE is 'WRIT' then the buffers are
C        flushed before the file is closed.
C     5) Selecting a subset of the first axis is not allowed for
C        OPCODE='WRIT'.
C     6) Buffers will be flushed and files closed after the last call on
C        a specified subimage.
C     7) For OPCODE='WRIT' the initial values of IPNT is 1.
C   Inputs:
C      OPCODE C*4     Operation code: 'READ','WRIT','CLOS'
C      NAME   C*?     Name of object
C   Input/Output:
C      FDVEC  I(80)  File descriptor vector; indices are the pointers
C                    from IMGERR.INC. Used internally by ARRIO.
C                    FDDISK = Disk number to use.
C                    FDLUNI = LUN to use for image, set before first
C                             call.
C                    FDBLC = BLC of window in the image. 0's => all
C                            non-error axes. (array of 7 values)
C                    FDTRC = TRC of window in the image. 0's => all
C                            non-error axes. (array of 7 values)
C                    FDSZIB = Size of IBUFF in AIPS bytes (1/2 words)
C                    FDFTI = FTAB pointer for image I/O. > 0 =>file open
C                    FDERR = Subroutine error return code.
C                    FDPOS = pointer in image to word in image buffer
C                            pointed to by IPNT. (array of 7 values)
C                    FDNLEF = Number of rows left in current plane.
C                    FDRW   = 0 if read, 1 if write.
C                    FDIMSI = Image size (array of 7 values)
C                    FDIMPT = Plane pointer (array of 7 values)
C                    FDMAX  = Image max. value as REAL
C                    FDMIN  = Image min. value as REAL
C                    FDBLK  = 0 if no blanking, 1 if blanked.
C      IBUFF  R(*)   Buffer for Image I/O must be large enough for the
C                    largest transfer rounded up to the next larger
C                    number of disk blocks.
C   Outputs:
C      IPNT   I      The location in IBUFF of the start of the next
C                    record. Before the first write call this should
C                    be set to 1 to determine where to start filling
C                    IBUFF.
C     IERR    I      Error return: 0 => ok,
C                                  1 => Input error
C                                  2 => ZOPEN error
C                                  3 => ARDGET error
C                                  5 => MINIT error
C                                  6 => MDISK error
C                                  7 => ZCLOSE error
C                                  9 => COMOFF error
C                                  Subroutine error codes are returned
C                                  in FDVEC(FDERR).
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, NAME*(*)
      INTEGER   FDVEC(*), IPNT, IERR
      REAL      IBUFF(*)
C
      CHARACTER FNAME*48, OPTMP*4, DATYPE*8, CDUMMY*1
      INTEGER   BUFNO, BOI, WIN(4), LOOP, IMAXV, IMINV, NCHK, ITEMP,
     *   TYPE, DIM(7), NAXIS(7), BLC(7), TRC(7), IBLANK
      LOGICAL   DOCMPL
      REAL      MAXV, MINV, BLANK
      LOGICAL   NEXT, ISBLNK
      INCLUDE 'INCS:IMGERR.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (IMAXV, MAXV),  (IMINV, MINV), (BLANK, IBLANK)
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
C                                       Check OPCODE
      IF ((OPCODE.NE.'READ') .AND. (OPCODE.NE.'WRIT') .AND.
     *   (OPCODE.NE.'CLOS')) THEN
         IERR = 1
         MSGTXT = 'ARRIO: UNKNOWN OPCODE =' // OPCODE
         GO TO 990
         END IF
C                                       Close?
      IERR = 3
      CALL OBINFO (NAME, BUFNO, FDVEC(FDERR))
      IF (FDVEC(FDERR).NE.0) GO TO 995
C                                       Close?
      IF (OPCODE.EQ.'CLOS') GO TO 800
C                                       Need to Open?  Check if
C                                       file is already opened.
      IF (FDVEC(FDFTI).LE.0) THEN
C                                       Get array descriptive info
C                                       File name
         IERR = 3
         CALL ARDGET (NAME, 'FNAME', TYPE, DIM, RDUM, FNAME,
     *      FDVEC(FDERR))
         IF (FDVEC(FDERR).NE.0) GO TO 995
C                                       Disk number
         CALL ARDGET (NAME, 'FDISK', TYPE, DIM, RDUM, CDUMMY,
     *      FDVEC(FDERR))
         FDVEC(FDDISK) = IDUM(1)
         IF (FDVEC(FDERR).NE.0) GO TO 995
C                                       Complex?
         CALL ARDGET (NAME, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
         DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
         IERR = 0
C                                       Dimensions, window
         CALL ARRWIN (NAME, BLC, TRC, NAXIS, FDVEC(FDERR))
         IF (FDVEC(FDERR).NE.0) GO TO 995
         CALL ARDGET (NAME, 'NAXIS', TYPE, DIM, RDUM, CDUMMY,
     *      FDVEC(FDERR))
         IF (FDVEC(FDERR).NE.0) GO TO 995
         CALL COPY (DIM(1), IDUM, NAXIS)
         IF (DOCMPL) THEN
            NAXIS(1) = NAXIS(1) * 2
            TRC(1) = TRC(1) * 2
            END IF
         CALL COPY (7, BLC, FDVEC(FDBLC))
         CALL COPY (7, TRC, FDVEC(FDTRC))
         CALL COPY (7, NAXIS, FDVEC(FDIMSI))
C                                       Save info - image size
C                                       Set default window.
         DO 200 LOOP = 1,7
            FDVEC(FDIMSI+LOOP-1) = MAX (FDVEC(FDIMSI+LOOP-1), 1)
            FDVEC(FDBLC+LOOP-1) = MAX (FDVEC(FDBLC+LOOP-1), 1)
            IF (FDVEC(FDTRC+LOOP-1).LE.0) FDVEC(FDTRC+LOOP-1) =
     *         FDVEC(FDIMSI+LOOP-1)
C                                       Init plane pointers.
            FDVEC(FDIMPT+LOOP-1) = FDVEC(FDBLC+LOOP-1)
 200        CONTINUE
C                                       Max/min and blanking
C                                       Note use of EQUIVALENCE
         FDVEC(FDBLK) = 0
         IF ((FDVEC(FDBLC+2).GT.1) .OR. (FDVEC(FDBLC+3).GT.1) .OR.
     *      (FDVEC(FDBLC+4).GT.1). OR. (FDVEC(FDBLC+5).GT.1)) THEN
C                                       Use old values if starting in
C                                       middle of image.
            IERR = 3
            CALL ARSGET (NAME, 'DATAMAX', TYPE, DIM, RDUM, CDUMMY,
     *         FDVEC(FDERR))
            MAXV = RDUM(1)
            IF (FDVEC(FDERR).NE.0) GO TO 995
            CALL ARSGET (NAME, 'DATAMIN', TYPE, DIM, RDUM, CDUMMY,
     *         FDVEC(FDERR))
            MINV = RDUM(1)
            IF (FDVEC(FDERR).NE.0) GO TO 995
C                                       Blanking?
            CALL ARDGET (NAME, 'BLANK', TYPE, DIM, RDUM, CDUMMY,
     *         FDVEC(FDERR))
            BLANK = RDUM(1)
            IF (FDVEC(FDERR).NE.0) GO TO 995
            IF ((FDVEC(FDERR).EQ.0) .AND. (BLANK.NE.0.0))
     *         FDVEC(FDBLK) = 1
            FDVEC(FDERR) = 0
         ELSE
C                                       Init.
            MAXV = -1.0E20
            MINV = 1.0E20
            END IF
C                                       Save values (need only for
C                                       'WRIT')
         FDVEC(FDMAX) = IMAXV
         FDVEC(FDMIN) = IMINV
C                                       Open file as necessary
         IF (FDVEC(FDFTI).LE.0) THEN
            CALL ZOPEN (FDVEC(FDLUNI), FDVEC(FDFTI), FDVEC(FDDISK),
     *         FNAME, .TRUE., .FALSE., .TRUE., FDVEC(FDERR))
            IF (FDVEC(FDERR).NE.0) THEN
               IERR = 4
               WRITE (MSGTXT,1001) FDVEC(FDERR), NAME
               GO TO 990
               END IF
            END IF
C                                       Set values in FDVEC
C                                       Number of rows left - force init
         FDVEC(FDNLEF) = 0
C                                       Subroutine error
         FDVEC(FDERR) = 0
C                                       Read/write flag
         FDVEC(FDRW) = 0
         IF (OPCODE.EQ.'WRIT') FDVEC(FDRW) = 1
         END IF
C----------------------------------------------------------------------
C                                       Time to init files?
      IF (FDVEC(FDNLEF).LE.0) THEN
C                                       Done if pointer on 3rd axis .le.
C                                       0.
         IF (FDVEC(FDIMPT+2).LE.0) THEN
            MSGTXT = 'I/O FINISHED OR INACTIVE'
            GO TO 990
            END IF
C                                       Set window
         WIN(1) = FDVEC(FDBLC)
         WIN(2) = FDVEC(FDBLC+1)
         WIN(3) = FDVEC(FDTRC)
         WIN(4) = FDVEC(FDTRC+1)
C                                       Block offset for image
         CALL COMOFF (KICTPN, FDVEC(FDIMSI), FDVEC(FDIMPT+2), BOI,
     *      FDVEC(FDERR))
         BOI = BOI + 1
         IF (FDVEC(FDERR).NE.0) THEN
            IERR = 9
            MSGTXT = 'ARRIO: ERROR IN COMOFF COMPUTING BLOCK OFFSET'
            GO TO 990
            END IF
C                                       Init I/O
         CALL MINIT (OPCODE, FDVEC(FDLUNI), FDVEC(FDFTI), FDVEC(FDIMSI),
     *      FDVEC(FDIMSI+1), WIN, IBUFF, FDVEC(FDSZIB), BOI,
     *      FDVEC(FDERR))
         IF (FDVEC(FDERR).NE.0) THEN
            IERR = 5
            WRITE (MSGTXT,1002) FDVEC(FDERR) ,NAME
            GO TO 990
            END IF
C                                       Number of rows to read
         FDVEC(FDNLEF) = ABS (WIN(4) - WIN(2)) + 1
C                                       Set plane pointers for next
C                                       plane.
         NEXT = .TRUE.
         DO 300 LOOP = 3,7
            IF (NEXT .AND. (LOOP.NE.(FDVEC(FDERPL)+1))) THEN
               FDVEC(FDIMPT+LOOP-1) = FDVEC(FDIMPT+LOOP-1) + 1
               NEXT = FDVEC(FDIMPT+LOOP-1) .GT. FDVEC(FDTRC+LOOP-1)
               IF (NEXT) FDVEC(FDIMPT+LOOP-1) = FDVEC(FDBLC+LOOP-1)
               END IF
 300        CONTINUE
C                                       If NEXT still true then done
         IF (NEXT) FDVEC(FDIMPT+2) = -1
         FDVEC(FDIMPT+1) = FDVEC(FDBLC+1)
C                                       Dummy first write
         IF (FDVEC(FDRW).EQ.1) THEN
            CALL MDISK ('WRIT', FDVEC(FDLUNI), FDVEC(FDFTI), IBUFF,
     *         IPNT, FDVEC(FDERR))
            IF (FDVEC(FDERR).NE.0) THEN
               IERR = 6
               WRITE (MSGTXT,1003) FDVEC(FDERR), 'WRIT', NAME
               GO TO 990
               END IF
            END IF
         END IF
C-----------------------------------------------------------------------
C                                       Do I/O operations.
C                                       Check OPCODE
      IF (((OPCODE.EQ.'READ').AND.(FDVEC(FDRW).NE.0)) .OR.
     *   ((OPCODE.EQ.'WRIT').AND.(FDVEC(FDRW).NE.1))) THEN
         IERR = 1
         MSGTXT = 'ARRIO:OPCODE INCOMPATIBLE WITH PREVIOUS USAGE'
         GO TO 990
         END IF
      OPTMP = OPCODE
C                                       Max, min etc for WRIT
      IF (FDVEC(FDRW).EQ.1) THEN
         IMAXV = FDVEC(FDMAX)
         IMINV = FDVEC(FDMIN)
         ISBLNK = FDVEC(FDBLK).EQ.1
         END IF
C                                       Flush buffer?
      IF ((FDVEC(FDNLEF).LE.1) .AND. (OPCODE.EQ.'WRIT')) THEN
         OPTMP = 'FINI'
         END IF
C                                       I/O to image
      ITEMP = IPNT
      CALL MDISK (OPTMP, FDVEC(FDLUNI), FDVEC(FDFTI), IBUFF, IPNT,
     *   FDVEC(FDERR))
      IF (FDVEC(FDERR).NE.0) THEN
         IERR = 6
         WRITE (MSGTXT,1003) FDVEC(FDERR), OPTMP, NAME
         GO TO 990
         END IF
C                                       Max/min etc for 'WRIT'
      IF (FDVEC(FDRW).EQ.1) THEN
         NCHK = FDVEC(FDTRC) - FDVEC(FDBLC) + 1
         NCHK = MIN (NCHK, MAXIMG)
         CALL CHKBLK (NCHK, IBUFF(ITEMP), VALIDX)
         DO 500 LOOP = 1,NCHK
            IF (VALIDX(LOOP)) THEN
               MAXV = MAX (MAXV, IBUFF(ITEMP+LOOP-1))
               MINV = MIN (MINV, IBUFF(ITEMP+LOOP-1))
            ELSE
               ISBLNK = .TRUE.
               END IF
 500        CONTINUE
         END IF
C                                       Decrement line count
      FDVEC(FDNLEF) = FDVEC(FDNLEF) - 1
      FDVEC(FDIMPT+1) = FDVEC(FDIMPT+1) + 1
C                                       Save max, min etc for WRIT
      IF (FDVEC(FDRW).EQ.1) THEN
         FDVEC(FDMAX) = IMAXV
         FDVEC(FDMIN) = IMINV
         FDVEC(FDBLK) = 0
         IF (ISBLNK) FDVEC(FDBLK) = 1
         END IF
C                                       Reset pointers if flushed
C                                       buffers.
      IF (OPTMP.EQ.'FINI') THEN
         IPNT = 1
         FDVEC(FDNLEF) = -1
         END IF
      IERR = 0
      GO TO 999
C----------------------------------------------------------------------
C                                       Close files etc.  Make sure
C                                       actually opened.
 800  IF (FDVEC(FDFTI).GT.0) THEN
C                                       Flush buffer on write if not
C                                       already done.
         IF ((FDVEC(FDRW).EQ.1) .AND. (FDVEC(FDNLEF).GT.1)) THEN
            CALL MDISK ('FINI', FDVEC(FDLUNI), FDVEC(FDFTI), IBUFF,
     *         IPNT,  FDVEC(FDERR))
            IF (FDVEC(FDERR).NE.0) THEN
               IERR = 6
               WRITE (MSGTXT,1003) FDVEC(FDERR), 'FINI', NAME
               GO TO 990
            END IF
         END IF
         CALL  ZCLOSE (FDVEC(FDLUNI), FDVEC(FDFTI), FDVEC(FDERR))
         IF (FDVEC(FDERR).NE.0) THEN
            IERR = 7
            WRITE (MSGTXT,1801) FDVEC(FDERR)
            GO TO 990
            END IF
C                                       Update Statistics on 'WRIT'
         IF (FDVEC(FDRW).EQ.1) THEN
            IMAXV = FDVEC(FDMAX)
            IMINV = FDVEC(FDMIN)
            IERR = 3
            DIM(1) = 1
            DIM(2) = 1
            DIM(3) = 0
            RDUM(1) = MAXV
            CALL ARSPUT (NAME, 'DATAMAX', OOARE, DIM, RDUM, CDUMMY,
     *         FDVEC(FDERR))
            IF (FDVEC(FDERR).NE.0) GO TO 995
            RDUM(1) = MINV
            CALL ARSPUT (NAME, 'DATAMIN', OOARE, DIM, RDUM, CDUMMY,
     *         FDVEC(FDERR))
            IF (FDVEC(FDERR).NE.0) GO TO 995
C                                       Blanking?
            BLANK = 0.0
            IF (FDVEC(FDBLK).EQ.1) BLANK = FBLANK
            DIM(1) = 1
            RDUM(1) = BLANK
            CALL ARDPUT (NAME, 'BLANK', OOARE, DIM, RDUM, CDUMMY,
     *         FDVEC(FDERR))
            IF (FDVEC(FDERR).NE.0) GO TO 995
            END IF
C                                       Clear FDVEC FTAB pointer
         FDVEC(FDFTI) = 0
         END IF
C                                       Finished
      IERR = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (7)
 995  MSGTXT = 'ARRIO: ERROR WITH ' // NAME
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1001 FORMAT ('ARRIO: ERROR ',I3,' OPENING ',A)
 1002 FORMAT ('ARRIO: ERROR ',I3,' INITING ',A)
 1003 FORMAT ('ARRIO: ERROR ',I3,1X,A,'ING ',A)
 1801 FORMAT ('ARRIO: ZCLOSE ERROR ',I3)
      END
      SUBROUTINE ARRNEG (IN, OUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Negate an array and write another.
C   Inputs:
C      IN    C*32  The name of the input object.
C      OUT   C*32  The name of the output object
C   Output:
C      IERR  I     Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER IN*(*), OUT*(*)
      INTEGER   IERR
C
      INTEGER   BLC(7), TRC(7), LOOP2, LOOP3, LOOP4, LOOP5, LOOP6,
     *   LOOP7, LROW, LROWC, NDIM(7), DIM(7), TYPE, BUFNOI, BUFNOO,
     *   PNTI, PNTO
      CHARACTER DATYPE*8, TIN*32, CDUMMY*1
      REAL      BLANK
      LOGICAL   DOCMPL, ISBLNK
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       May need temporary object
      IF (IN.EQ.OUT) THEN
C                                       Create temporary output object
         TIN = 'Temporary IMAGE for ARRNEG'
         CALL IMGCOP (IN, TIN, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         TIN = IN
         END IF
C                                       Open array and get I/O stream
C                                       pointers
      PNTI = 1
      CALL ARROPN (TIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (TIN, BUFNOI, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Output
      PNTO = 1
      CALL ARROPN (OUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (OUT, BUFNOO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Clear output window
      CALL ARRCWI (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Check compatibility
      CALL ARRCHK (TIN, OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Window
      CALL ARRWIN (TIN, BLC, TRC, NDIM, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex?
      CALL ARDGET (TIN, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
      IERR = 0
C                                       Blanking?
      CALL ARDGET (TIN, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = (BLANK.NE.0.0) .AND. (IERR.EQ.0)
      IERR = 0
C                                       Loop over array
      LROW = TRC(1) - BLC(1) + 1
      LROWC = LROW
      IF (DOCMPL) LROWC = LROW * 2
      DO 700 LOOP7 = BLC(7),TRC(7)
         DO 600 LOOP6 = BLC(6),TRC(6)
            DO 500 LOOP5 = BLC(5),TRC(5)
               DO 400 LOOP4 = BLC(4),TRC(4)
                  DO 300 LOOP3 = BLC(3),TRC(3)
                     DO 200 LOOP2 = BLC(2),TRC(2)
C                                       Fetch input row
      CALL ARRIO ('READ', TIN, ARRFDV(1,BUFNOI), OBUFFR(1,BUFNOI),
     *    BUFPNT(BUFNOI), IERR)
      PNTI = BUFPNT(BUFNOI)
      IF (IERR.GT.0) GO TO 995
C                                       Blanking?
      IF (ISBLNK) THEN
C                                       Negate row with blanking
         CALL CHKBLK (LROWC, OBUFFR(PNTI,BUFNOI), VALID1)
         IF (DOCMPL) THEN
C                                       Complex
            CALL CVBNEG (OBUFFR(PNTI,BUFNOI), VALID1,
     *         OBUFFR(PNTO,BUFNOO), VALID3, LROW)
         ELSE
C                                       Real
            CALL RVBNEG (OBUFFR(PNTI,BUFNOI), VALID1,
     *         OBUFFR(PNTO,BUFNOO), VALID3, LROW)
            END IF
         CALL SETBLK (LROWC, VALID3, OBUFFR(PNTO,BUFNOO))
      ELSE
C                                       Negate row
         IF (DOCMPL) THEN
C                                       Complex
            CALL CVNEG (OBUFFR(PNTI,BUFNOI), OBUFFR(PNTO,BUFNOO), LROW)
         ELSE
C                                       Real
            CALL RVNEG (OBUFFR(PNTI,BUFNOI), OBUFFR(PNTO,BUFNOO), LROW)
            END IF
         END IF
      CALL ARRIO ('WRIT', OUT, ARRFDV(1,BUFNOO), OBUFFR(1,BUFNOO),
     *   BUFPNT(BUFNOO), IERR)
      PNTO = BUFPNT(BUFNOO)
      IF (IERR.GT.0) GO TO 995
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close files
      CALL ARRCLO (TIN, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Delete temporary if necessary
      IF (TIN(1:32).NE.IN(1:32)) CALL IMGDES (TIN, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 995  MSGTXT = 'ARRNEG: INPUT ' // IN
      CALL MSGWRT (7)
      MSGTXT = 'ARRNEG: OUTPUT ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE ARRADD (IN1, IN2, OUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Add two arrays and write a third.
C   Inputs:
C      IN1   C*32  The name of the first object.
C      IN2   C*32  The name of the second object.
C      OUT   C*32  The name of the output object
C   Output:
C      IERR  I     Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER IN1*(*), IN2*(*), OUT*(*)
      INTEGER   IERR
C
      INTEGER   BLC(7), TRC(7), LOOP2, LOOP3, LOOP4, LOOP5, LOOP6,
     *   LOOP7, LROW, LROWC, NDIM(7), DIM(7), TYPE, BUFNI1, BUFNI2,
     *   BUFNOO, PNTI1, PNTI2, PNTO
      CHARACTER DATYPE*8, TIN1*32, TIN2*32, CDUMMY*1
      REAL      BLANK
      LOGICAL   DOCMPL, ISBLNK
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       May need temporary object
      IF (IN1.EQ.OUT) THEN
C                                       Create temporary output object
         TIN1 = 'Temporary IMAGE 1 for ARRADD'
         CALL IMGCOP (IN1, TIN1, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         TIN1 = IN1
         END IF
      IF (IN1.EQ.IN2) THEN
C                                       Create temporary
         TIN2 = 'Temporary IMAGE 2 for ARRADD'
         CALL IMGCOP (IN2, TIN2, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         TIN2 = IN2
         END IF
C                                       Open array and get I/O stream
C                                       pointers
      CALL ARROPN (TIN1, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (TIN1, BUFNI1, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Second input
      CALL ARROPN (TIN2, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (TIN2, BUFNI2, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Output
      PNTO = 1
      CALL ARROPN (OUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (OUT, BUFNOO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Clear output window
      CALL ARRCWI (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Check compatibility
      CALL ARRCHK (TIN1, TIN2, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCHK (TIN1, OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Image window
      CALL ARRWIN (TIN1, BLC, TRC, NDIM, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex?
      CALL ARDGET (TIN1, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
      IERR = 0
C                                       Blanking?
      CALL ARDGET (TIN1, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = (BLANK.NE.0.0) .AND. (IERR.EQ.0)
      CALL ARDGET (TIN2, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = ISBLNK .OR. ((BLANK.NE.0.0) .AND. (IERR.EQ.0))
      IERR = 0
C                                       Loop over array
      LROW = TRC(1) - BLC(1) + 1
      LROWC = LROW
      IF (DOCMPL) LROWC = LROW * 2
      DO 700 LOOP7 = BLC(7),TRC(7)
         DO 600 LOOP6 = BLC(6),TRC(6)
            DO 500 LOOP5 = BLC(5),TRC(5)
               DO 400 LOOP4 = BLC(4),TRC(4)
                  DO 300 LOOP3 = BLC(3),TRC(3)
                     DO 200 LOOP2 = BLC(2),TRC(2)
C                                       Fetch input rows
      CALL ARRIO ('READ', TIN1, ARRFDV(1,BUFNI1), OBUFFR(1,BUFNI1),
     *    BUFPNT(BUFNI1), IERR)
      PNTI1 = BUFPNT(BUFNI1)
      IF (IERR.GT.0) GO TO 995
      CALL ARRIO ('READ', TIN2, ARRFDV(1,BUFNI2), OBUFFR(1,BUFNI2),
     *    BUFPNT(BUFNI2), IERR)
      PNTI2 = BUFPNT(BUFNI2)
      IF (IERR.GT.0) GO TO 995
C                                       Blanking?
      IF (ISBLNK) THEN
         CALL CHKBLK (LROWC, OBUFFR(PNTI1,BUFNI1), VALID1)
         CALL CHKBLK (LROWC, OBUFFR(PNTI2,BUFNI2), VALID2)
         IF (DOCMPL) THEN
C                                       Complex
            CALL CVBADD (OBUFFR(PNTI1,BUFNI1), VALID1,
     *         OBUFFR(PNTI2,BUFNI2), VALID2, OBUFFR(PNTO,BUFNOO),
     *         VALID3, LROW)
         ELSE
C                                       Real
            CALL RVBADD (OBUFFR(PNTI1,BUFNI1), VALID1,
     *         OBUFFR(PNTI2,BUFNI2), VALID2, OBUFFR(PNTO,BUFNOO),
     *         VALID3, LROW)
            END IF
         CALL SETBLK (LROWC, VALID3, OBUFFR(PNTO,BUFNOO))
      ELSE
C                                       No blanking
         IF (DOCMPL) THEN
C                                       Complex
            CALL CVADD (OBUFFR(PNTI1,BUFNI1), OBUFFR(PNTI2,BUFNI2),
     *         OBUFFR(PNTO,BUFNOO), LROW)
         ELSE
C                                       Real
            CALL RVADD (OBUFFR(PNTI1,BUFNI1), OBUFFR(PNTI2,BUFNI2),
     *         OBUFFR(PNTO,BUFNOO), LROW)
            END IF
         END IF
      CALL ARRIO ('WRIT', OUT, ARRFDV(1,BUFNOO), OBUFFR(1,BUFNOO),
     *   BUFPNT(BUFNOO), IERR)
      PNTO = BUFPNT(BUFNOO)
      IF (IERR.GT.0) GO TO 995
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close files
      CALL ARRCLO (TIN1, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (TIN2, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Delete temporary if necessary
      IF (TIN1(1:32).NE.IN1(1:32)) CALL IMGDES (TIN1, IERR)
      IF (IERR.NE.0) GO TO 995
      IF (TIN2(1:32).NE.IN2(1:32)) CALL IMGDES (TIN2, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 995  MSGTXT = 'ARRADD: FIRST INPUT ' // IN1
      CALL MSGWRT (7)
      MSGTXT = 'ARRADD: SECOND INPUT ' // IN2
      CALL MSGWRT (7)
      MSGTXT = 'ARRADD: OUTPUT ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE ARRSUB (IN1, IN2, OUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Subtracts array in2 from array in1.
C   Inputs:
C      IN1   C*32  The name of the first object.
C      IN2   C*32  The name of the second object.
C      OUT   C*32  The name of the output object
C   Output:
C      IERR  I     Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER IN1*(*), IN2*(*), OUT*(*)
      INTEGER   IERR
C
      INTEGER   BLC(7), TRC(7), LOOP2, LOOP3, LOOP4, LOOP5, LOOP6,
     *   LOOP7, LROW, LROWC, NDIM(7), DIM(7), TYPE, BUFNI1, BUFNI2,
     *   BUFNOO, PNTI1, PNTI2, PNTO
      CHARACTER DATYPE*8, TIN1*32, TIN2*32, CDUMMY*1
      REAL      BLANK
      LOGICAL   DOCMPL, ISBLNK
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       May need temporary object
      IF (IN1.EQ.OUT) THEN
C                                       Create temporary output object
         TIN1 = 'Temporary IMAGE 1 for ARRSUB'
         CALL IMGCOP (IN1, TIN1, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         TIN1 = IN1
         END IF
      IF (IN1.EQ.IN2) THEN
C                                       Create temporary
         TIN2 = 'Temporary IMAGE 2 for ARRSUB'
         CALL IMGCOP (IN2, TIN2, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         TIN2 = IN2
         END IF
C                                       Open array and get I/O stream
C                                       pointers
      CALL ARROPN (TIN1, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (TIN1, BUFNI1, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Second input
      CALL ARROPN (TIN2, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (TIN2, BUFNI2, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Output
      PNTO = 1
      CALL ARROPN (OUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (OUT, BUFNOO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Clear output window
      CALL ARRCWI (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Check compatibility
      CALL ARRCHK (TIN1, TIN2, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCHK (TIN1, OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Image window
      CALL ARRWIN (TIN1, BLC, TRC, NDIM, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex?
      CALL ARDGET (TIN1, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
      IERR = 0
C                                       Blanking?
      CALL ARDGET (TIN1, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = (BLANK.NE.0.0) .AND. (IERR.EQ.0)
      CALL ARDGET (TIN2, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = ISBLNK .OR. ((BLANK.NE.0.0) .AND. (IERR.EQ.0))
      IERR = 0
C                                       Loop over array
      LROW = TRC(1) - BLC(1) + 1
      LROWC = LROW
      IF (DOCMPL) LROWC = LROW * 2
      DO 700 LOOP7 = BLC(7),TRC(7)
         DO 600 LOOP6 = BLC(6),TRC(6)
            DO 500 LOOP5 = BLC(5),TRC(5)
               DO 400 LOOP4 = BLC(4),TRC(4)
                  DO 300 LOOP3 = BLC(3),TRC(3)
                     DO 200 LOOP2 = BLC(2),TRC(2)
C                                       Fetch input rows
      CALL ARRIO ('READ', TIN1, ARRFDV(1,BUFNI1), OBUFFR(1,BUFNI1),
     *    BUFPNT(BUFNI1), IERR)
      PNTI1 = BUFPNT(BUFNI1)
      IF (IERR.GT.0) GO TO 995
      CALL ARRIO ('READ', TIN2, ARRFDV(1,BUFNI2), OBUFFR(1,BUFNI2),
     *    BUFPNT(BUFNI2), IERR)
      PNTI2 = BUFPNT(BUFNI2)
      IF (IERR.GT.0) GO TO 995
C                                       Blanking?
      IF (ISBLNK) THEN
         CALL CHKBLK (LROWC, OBUFFR(PNTI1,BUFNI1), VALID1)
         CALL CHKBLK (LROWC, OBUFFR(PNTI2,BUFNI2), VALID2)
         IF (DOCMPL) THEN
C                                       Complex
            CALL CVBSUB (OBUFFR(PNTI1,BUFNI1), VALID1,
     *         OBUFFR(PNTI2,BUFNI2), VALID2, OBUFFR(PNTO,BUFNOO),
     *         VALID3, LROW)
         ELSE
C                                       Real
            CALL RVBSUB (OBUFFR(PNTI1,BUFNI1), VALID1,
     *         OBUFFR(PNTI2,BUFNI2), VALID2, OBUFFR(PNTO,BUFNOO),
     *         VALID3, LROW)
            END IF
         CALL SETBLK (LROWC, VALID3, OBUFFR(PNTO,BUFNOO))
      ELSE
C                                       No blanking
         IF (DOCMPL) THEN
C                                       Complex
            CALL CVSUB (OBUFFR(PNTI1,BUFNI1), OBUFFR(PNTI2,BUFNI2),
     *         OBUFFR(PNTO,BUFNOO), LROW)
         ELSE
C                                       Real
            CALL RVSUB (OBUFFR(PNTI1,BUFNI1), OBUFFR(PNTI2,BUFNI2),
     *         OBUFFR(PNTO,BUFNOO), LROW)
            END IF
         END IF
      CALL ARRIO ('WRIT', OUT, ARRFDV(1,BUFNOO), OBUFFR(1,BUFNOO),
     *   BUFPNT(BUFNOO), IERR)
      PNTO = BUFPNT(BUFNOO)
      IF (IERR.GT.0) GO TO 995
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close files
      CALL ARRCLO (TIN1, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (TIN2, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Delete temporary if necessary
      IF (TIN1(1:32).NE.IN1(1:32)) CALL IMGDES (TIN1, IERR)
      IF (IERR.NE.0) GO TO 995
      IF (TIN2(1:32).NE.IN2(1:32)) CALL IMGDES (TIN2, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 995  MSGTXT = 'ARRSUB: FIRST INPUT ' // IN1
      CALL MSGWRT (7)
      MSGTXT = 'ARRSUB: SECOND INPUT ' // IN2
      CALL MSGWRT (7)
      MSGTXT = 'ARRSUB: OUTPUT ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE ARRMUL (IN1, IN2, OUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Multiply two arrays and write a third.
C   Inputs:
C      IN1   C*32  The name of the first object.
C      IN2   C*32  The name of the second object.
C      OUT   C*32  The name of the output object
C   Output:
C      IERR  I     Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER IN1*(*), IN2*(*), OUT*(*)
      INTEGER   IERR
C
      INTEGER   BLC(7), TRC(7), LOOP2, LOOP3, LOOP4, LOOP5, LOOP6,
     *   LOOP7, LROW, LROWC, NDIM(7), DIM(7), TYPE, BUFNI1, BUFNI2,
     *   BUFNOO, PNTI1, PNTI2, PNTO
      CHARACTER DATYPE*8, TIN1*32, TIN2*32, CDUMMY*1
      REAL      BLANK
      LOGICAL   DOCMPL, ISBLNK
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       May need temporary object
      IF (IN1.EQ.OUT) THEN
C                                       Create temporary output object
         TIN1 = 'Temporary IMAGE 1 for ARRMUL'
         CALL IMGCOP (IN1, TIN1, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         TIN1 = IN1
         END IF
      IF (IN1.EQ.IN2) THEN
C                                       Create temporary
         TIN2 = 'Temporary IMAGE 2 for ARRMUL'
         CALL IMGCOP (IN2, TIN2, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         TIN2 = IN2
         END IF
C                                       Output
      PNTO = 1
      CALL ARROPN (OUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (OUT, BUFNOO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Open array and get I/O stream
C                                       pointers
      CALL ARROPN (TIN1, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (TIN1, BUFNI1, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Second input
      CALL ARROPN (TIN2, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (TIN2, BUFNI2, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Clear output window
      CALL ARRCWI (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Check compatibility
      CALL ARRCHK (TIN1, TIN2, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCHK (TIN1, OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Image window
      CALL ARRWIN (TIN1, BLC, TRC, NDIM, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex?
      CALL ARDGET (TIN1, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
      IERR = 0
C                                       Blanking?
      CALL ARDGET (TIN1, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = (BLANK.NE.0.0) .AND. (IERR.EQ.0)
      CALL ARDGET (TIN2, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = ISBLNK .OR. ((BLANK.NE.0.0) .AND. (IERR.EQ.0))
      IERR = 0
C                                       Loop over array
      LROW = TRC(1) - BLC(1) + 1
      LROWC = LROW
      IF (DOCMPL) LROWC = LROW * 2
      DO 700 LOOP7 = BLC(7),TRC(7)
         DO 600 LOOP6 = BLC(6),TRC(6)
            DO 500 LOOP5 = BLC(5),TRC(5)
               DO 400 LOOP4 = BLC(4),TRC(4)
                  DO 300 LOOP3 = BLC(3),TRC(3)
                     DO 200 LOOP2 = BLC(2),TRC(2)
C                                       Fetch input rows
      CALL ARRIO ('READ', TIN1, ARRFDV(1,BUFNI1), OBUFFR(1,BUFNI1),
     *    BUFPNT(BUFNI1), IERR)
      PNTI1 = BUFPNT(BUFNI1)
      IF (IERR.GT.0) GO TO 995
      CALL ARRIO ('READ', TIN2, ARRFDV(1,BUFNI2), OBUFFR(1,BUFNI2),
     *    BUFPNT(BUFNI2), IERR)
      PNTI2 = BUFPNT(BUFNI2)
      IF (IERR.GT.0) GO TO 995
C                                       Blanking?
      IF (ISBLNK) THEN
         CALL CHKBLK (LROWC, OBUFFR(PNTI1,BUFNI1), VALID1)
         CALL CHKBLK (LROWC, OBUFFR(PNTI2,BUFNI2), VALID2)
         IF (DOCMPL) THEN
C                                       Complex
            CALL CVBMUL (OBUFFR(PNTI1,BUFNI1), VALID1,
     *         OBUFFR(PNTI2,BUFNI2), VALID2, OBUFFR(PNTO,BUFNOO),
     *         VALID3, LROW)
         ELSE
C                                       Real
            CALL RVBMUL (OBUFFR(PNTI1,BUFNI1), VALID1,
     *         OBUFFR(PNTI2,BUFNI2), VALID2, OBUFFR(PNTO,BUFNOO),
     *         VALID3, LROW)
            END IF
         CALL SETBLK (LROWC, VALID3, OBUFFR(PNTO,BUFNOO))
      ELSE
C                                       No blanking
         IF (DOCMPL) THEN
C                                       Complex
            CALL CVMUL (OBUFFR(PNTI1,BUFNI1), OBUFFR(PNTI2,BUFNI2),
     *         OBUFFR(PNTO,BUFNOO), LROW)
         ELSE
C                                       Real
            CALL RVMUL (OBUFFR(PNTI1,BUFNI1), OBUFFR(PNTI2,BUFNI2),
     *         OBUFFR(PNTO,BUFNOO), LROW)
            END IF
         END IF
      CALL ARRIO ('WRIT', OUT, ARRFDV(1,BUFNOO), OBUFFR(1,BUFNOO),
     *   BUFPNT(BUFNOO), IERR)
      PNTO = BUFPNT(BUFNOO)
      IF (IERR.GT.0) GO TO 995
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close files
      CALL ARRCLO (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (TIN1, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (TIN2, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Delete temporary if necessary
      IF (TIN1(1:32).NE.IN1(1:32)) CALL IMGDES (TIN1, IERR)
      IF (IERR.NE.0) GO TO 995
      IF (TIN2(1:32).NE.IN2(1:32)) CALL IMGDES (TIN2, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 995  MSGTXT = 'ARRMUL: FIRST INPUT ' // IN1
      CALL MSGWRT (7)
      MSGTXT = 'ARRMUL: SECOND INPUT ' // IN2
      CALL MSGWRT (7)
      MSGTXT = 'ARRMUL: OUTPUT ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE ARRDIV (IN1, IN2, OUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Divides array in1 by array in2.
C   Inputs:
C      IN1   C*32  The name of the first object.
C      IN2   C*32  The name of the second object.
C      OUT   C*32  The name of the output object
C   Output:
C      IERR  I     Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER IN1*(*), IN2*(*), OUT*(*)
      INTEGER   IERR
C
      INTEGER   BLC(7), TRC(7), LOOP2, LOOP3, LOOP4, LOOP5, LOOP6,
     *   LOOP7, LROW, LROWC, NDIM(7), DIM(7), TYPE, BUFNI1, BUFNI2,
     *   BUFNOO, PNTI1, PNTI2, PNTO
      CHARACTER DATYPE*8, TIN1*32, TIN2*32, CDUMMY*1
      REAL      BLANK
      LOGICAL   DOCMPL, ISBLNK
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       May need temporary object
      IF (IN1.EQ.OUT) THEN
C                                       Create temporary output object
         TIN1 = 'Temporary IMAGE 1 for ARRDIV'
         CALL IMGCOP (IN1, TIN1, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         TIN1 = IN1
         END IF
      IF (IN1.EQ.IN2) THEN
C                                       Create temporary
         TIN2 = 'Temporary IMAGE 2 for ARRDIV'
         CALL IMGCOP (IN2, TIN2, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         TIN2 = IN2
         END IF
C                                       Output
      PNTO = 1
      CALL ARROPN (OUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (OUT, BUFNOO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Open array and get I/O stream
C                                       pointers
      CALL ARROPN (TIN1, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (TIN1, BUFNI1, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Second input
      CALL ARROPN (TIN2, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (TIN2, BUFNI2, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Clear output window
      CALL ARRCWI (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Check compatibility
      CALL ARRCHK (TIN1, TIN2, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCHK (TIN1, OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Image window
      CALL ARRWIN (TIN1, BLC, TRC, NDIM, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex?
      CALL ARDGET (TIN1, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
      IERR = 0
C                                       Blanking?
      CALL ARDGET (TIN1, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = (BLANK.NE.0.0) .AND. (IERR.EQ.0)
      CALL ARDGET (TIN2, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = ISBLNK .OR. ((BLANK.NE.0.0) .AND. (IERR.EQ.0))
      IERR = 0
C                                       Loop over array
      LROW = TRC(1) - BLC(1) + 1
      LROWC = LROW
      IF (DOCMPL) LROWC = LROW * 2
      DO 700 LOOP7 = BLC(7),TRC(7)
         DO 600 LOOP6 = BLC(6),TRC(6)
            DO 500 LOOP5 = BLC(5),TRC(5)
               DO 400 LOOP4 = BLC(4),TRC(4)
                  DO 300 LOOP3 = BLC(3),TRC(3)
                     DO 200 LOOP2 = BLC(2),TRC(2)
C                                       Fetch input rows
      CALL ARRIO ('READ', TIN1, ARRFDV(1,BUFNI1), OBUFFR(1,BUFNI1),
     *    BUFPNT(BUFNI1), IERR)
      PNTI1 = BUFPNT(BUFNI1)
      IF (IERR.GT.0) GO TO 995
      CALL ARRIO ('READ', TIN2, ARRFDV(1,BUFNI2), OBUFFR(1,BUFNI2),
     *    BUFPNT(BUFNI2), IERR)
      PNTI2 = BUFPNT(BUFNI2)
      IF (IERR.GT.0) GO TO 995
C                                       Blanking?
      IF (ISBLNK) THEN
         CALL CHKBLK (LROWC, OBUFFR(PNTI1,BUFNI1), VALID1)
         CALL CHKBLK (LROWC, OBUFFR(PNTI2,BUFNI2), VALID2)
         IF (DOCMPL) THEN
C                                       Complex
            CALL CVBDIV (OBUFFR(PNTI1,BUFNI1), VALID1,
     *         OBUFFR(PNTI2,BUFNI2), VALID2, OBUFFR(PNTO,BUFNOO),
     *         VALID3, LROW)
         ELSE
C                                       Real
            CALL RVBDIV (OBUFFR(PNTI1,BUFNI1), VALID1,
     *         OBUFFR(PNTI2,BUFNI2), VALID2, OBUFFR(PNTO,BUFNOO),
     *         VALID3, LROW)
            END IF
         CALL SETBLK (LROWC, VALID3, OBUFFR(PNTO,BUFNOO))
      ELSE
C                                       No blanking
         IF (DOCMPL) THEN
C                                       Complex
            CALL CVDIV (OBUFFR(PNTI1,BUFNI1), OBUFFR(PNTI2,BUFNI2),
     *         OBUFFR(PNTO,BUFNOO), LROW)
         ELSE
C                                       Real
            CALL RVDIV (OBUFFR(PNTI1,BUFNI1), OBUFFR(PNTI2,BUFNI2),
     *         OBUFFR(PNTO,BUFNOO), LROW)
            END IF
         END IF
      CALL ARRIO ('WRIT', OUT, ARRFDV(1,BUFNOO), OBUFFR(1,BUFNOO),
     *   BUFPNT(BUFNOO), IERR)
      PNTO = BUFPNT(BUFNOO)
      IF (IERR.GT.0) GO TO 995
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close files
      CALL ARRCLO (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (TIN1, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (TIN2, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Delete temporary if necessary
      IF (TIN1(1:32).NE.IN1(1:32)) CALL IMGDES (TIN1, IERR)
      IF (IERR.NE.0) GO TO 995
      IF (TIN2(1:32).NE.IN2(1:32)) CALL IMGDES (TIN2, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 995  MSGTXT = 'ARRDIV: FIRST INPUT ' // IN1
      CALL MSGWRT (7)
      MSGTXT = 'ARRDIV: SECOND INPUT ' // IN2
      CALL MSGWRT (7)
      MSGTXT = 'ARRDIV: OUTPUT ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE ARRPAD (IN, OUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Copy one array to another padding pixels outside of the input array
C   with PADVALUE (default 0.0) and replacing blanks with the pad value.
C   Inputs:
C      IN    C*?   The name of the input array.
C      OUT   C*?   The name of the output array.
C   Output:
C      IERR  I     Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER IN*(*), OUT*(*)
      INTEGER   IERR
C
      INTEGER   BLC(7), TRC(7), LOOP2, LOOP3, LOOP4, LOOP5, LOOP6,
     *   LOOP7, LROW, LROWC, NAXIS(7), BUFNOI, BUFNOO, PNTI, PNTO,
     *   NAXO(7), BLCO(7), TRCO(7), LOOP, OFF, MAXL(7), MINL(7), TYPE,
     *   DIM(7), MSGSAV
      LOGICAL   OK2, OK3, OK4, OK5, OK6, OK7, OKROW, DOCMPL, ISBLNK
      CHARACTER DATYPE*8, CDUMMY*1
      REAL      BLANK, PADVAL
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
      MSGSAV = MSGSUP
C                                       Open array and get I/O stream
C                                       pointers
      PNTI = 1
      CALL ARROPN (IN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (IN, BUFNOI, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Output
      PNTO = 1
      CALL ARROPN (OUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (OUT, BUFNOO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Windows
      CALL ARRWIN (IN, BLC, TRC, NAXIS, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRWIN (OUT, BLCO, TRCO, NAXO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex?
      CALL ARDGET (IN, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
      BLANK = RDUM(1)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
C                                       Blanking?
      CALL ARDGET (IN, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = (BLANK.NE.0.0) .AND. (IERR.EQ.0)
C                                       Pad value
      MSGSUP = 32000
      CALL OGET (IN, 'PADVALUE', TYPE, DIM, RDUM, CDUMMY, IERR)
      PADVAL = RDUM(1)
      MSGSUP = MSGSAV
      IF (IERR.EQ.1) THEN
         IERR = 0
         PADVAL = 0.0
         END IF
      IF (IERR.NE.0) GO TO 995
C                                       Check compatibility, OUT must be
C                                       at least as large as the window
C                                       in IN.
      DO 10 LOOP = 1,7
         IF (NAXO(LOOP).LT.NAXIS(LOOP)) THEN
            IERR = 2
            WRITE (MSGTXT,1000) LOOP
            GO TO 990
            END IF
C                                       Set max and min loop values to
C                                       copy data
         MINL(LOOP) = NAXO(LOOP)/2 + 1 - NAXIS(LOOP)/2
         MAXL(LOOP) = MINL(LOOP) + NAXIS(LOOP) - 1
 10      CONTINUE
C                                       Loop over array
      LROW = TRCO(1) - BLCO(1) + 1
      LROWC = LROW
      IF (DOCMPL) LROWC = LROW * 2
      DO 700 LOOP7 = 1,NAXO(7)
         OK7 = ((LOOP7.GE.MINL(7)) .AND. (LOOP7.LE.MAXL(7)))
         DO 600 LOOP6 = 1,NAXO(6)
            OK6 = ((LOOP6.GE.MINL(6)) .AND. (LOOP6.LE.MAXL(6)))
            DO 500 LOOP5 = 1,NAXO(5)
               OK5 = ((LOOP5.GE.MINL(5)) .AND. (LOOP5.LE.MAXL(5)))
               DO 400 LOOP4 = 1,NAXO(4)
                  OK4 = ((LOOP4.GE.MINL(4)) .AND. (LOOP4.LE.MAXL(4)))
                  DO 300 LOOP3 = 1,NAXO(3)
                     OK3 = ((LOOP3.GE.MINL(3)) .AND.
     *                  (LOOP3.LE.MAXL(3)))
                     DO 200 LOOP2 = 1,NAXO(2)
                        OK2 = ((LOOP2.GE.MINL(2)) .AND.
     *                     (LOOP2.LE.MAXL(2)))
                        OKROW = OK2 .AND. OK3 .AND. OK4 .AND. OK5 .AND.
     *                     OK6. AND. OK7
                        OFF = MINL(1) - 1
C                                       Zero fill output
      CALL RFILL (LROWC, PADVAL, OBUFFR(BUFPNT(BUFNOO),BUFNOO))
C                                       Fetch input row and copy
      IF (OKROW) THEN
         CALL ARRIO ('READ', IN, ARRFDV(1,BUFNOI), OBUFFR(1,BUFNOI),
     *      BUFPNT(BUFNOI), IERR)
         IF (IERR.GT.0) GO TO 995
         PNTI = BUFPNT(BUFNOI)
C                                       Copy
         IF (ISBLNK) THEN
            CALL RCOPYS (NAXIS(1), BLANK, PADVAL, OBUFFR(PNTI,BUFNOI),
     *         OBUFFR(PNTO+OFF,BUFNOO))
         ELSE
            CALL RCOPY (NAXIS(1), OBUFFR(PNTI,BUFNOI),
     *         OBUFFR(PNTO+OFF,BUFNOO))
            END IF
         END IF
C                                       Store
      CALL ARRIO ('WRIT', OUT, ARRFDV(1,BUFNOO), OBUFFR(1,BUFNOO),
     *   BUFPNT(BUFNOO), IERR)
      PNTO = BUFPNT(BUFNOO)
      IF (IERR.GT.0) GO TO 995
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close files
      CALL ARRCLO (IN, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 990  CALL MSGWRT (7)
 995  MSGTXT = 'ARRPAD: INPUT ' // IN
      CALL MSGWRT (7)
      MSGTXT = 'ARRPAD: OUTPUT ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ARRPAD: INPUT ARRAY SIZE LARGER THAN OUTPUT ON AXIS', I3)
      END
      SUBROUTINE ARRSCL (IN, FACTOR, OUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Scale an array with a constant real factor.
C   Inputs:
C      IN     C*32  The name of the input array object.
C      FACTOR R     Scaling factor
C      OUT    C*32  The name of the output array object.
C   Output:
C      IERR   I     Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER IN*(*), OUT*(*)
      REAL      FACTOR
      INTEGER   IERR
C
      INTEGER   BLC(7), TRC(7), LOOP2, LOOP3, LOOP4, LOOP5, LOOP6,
     *   LOOP7, LROW, LROWC, NAXIS(7), DIM(7), TYPE, BUFNOI, BUFNOO,
     *   PNTI, PNTO
      CHARACTER DATYPE*8, TIN*32, CDUMMY*1
      REAL      BLANK
      LOGICAL   DOCMPL, ISBLNK
      COMPLEX   CFACT
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       May need temporary object
      IF (IN.EQ.OUT) THEN
C                                       Create temporary output object
         TIN = 'Temporary IMAGE for ARRSCL'
         CALL IMGCOP (IN, TIN, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         TIN = IN
         END IF
C                                       Open array and get I/O stream
C                                       pointers
      PNTI = 1
      CALL ARROPN (TIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (TIN, BUFNOI, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Output
      PNTO = 1
      CALL ARROPN (OUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (OUT, BUFNOO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Clear output window
      CALL ARRCWI (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Check compatibility
      CALL ARRCHK (TIN, OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex factor
      CFACT = CMPLX (FACTOR, 0.0)
C                                       Window
      CALL ARRWIN (TIN, BLC, TRC, NAXIS, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex?
      CALL ARDGET (TIN, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
      IERR = 0
C                                       Blanking?
      CALL ARDGET (TIN, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = (BLANK.NE.0.0) .AND. (IERR.EQ.0)
      IERR = 0
C                                       Loop over array
      LROW = TRC(1) - BLC(1) + 1
      LROWC = LROW
      IF (DOCMPL) LROWC = LROW * 2
      DO 700 LOOP7 = BLC(7),TRC(7)
         DO 600 LOOP6 = BLC(6),TRC(6)
            DO 500 LOOP5 = BLC(5),TRC(5)
               DO 400 LOOP4 = BLC(4),TRC(4)
                  DO 300 LOOP3 = BLC(3),TRC(3)
                     DO 200 LOOP2 = BLC(2),TRC(2)
C                                       Fetch input row
      CALL ARRIO ('READ', TIN, ARRFDV(1,BUFNOI), OBUFFR(1,BUFNOI),
     *    BUFPNT(BUFNOI), IERR)
      PNTI = BUFPNT(BUFNOI)
      IF (IERR.GT.0) GO TO 995
C                                       Blanking?
      IF (ISBLNK) THEN
C                                       Scale row with blanking
         CALL CHKBLK (LROWC, OBUFFR(PNTI,BUFNOI), VALID1)
C                                       Complex
         IF (DOCMPL) THEN
            CALL CVBSCL (OBUFFR(PNTI,BUFNOI), VALID1, CFACT,
     *         OBUFFR(PNTO,BUFNOO), VALID3, LROW)
C                                       Real
         ELSE
            RDUM(1) = FACTOR
            CALL RVBSCL (OBUFFR(PNTI,BUFNOI), VALID1, RDUM,
     *         OBUFFR(PNTO,BUFNOO), VALID3, LROW)
            END IF
         CALL SETBLK (LROWC, VALID3, OBUFFR(PNTO,BUFNOO))
C                                       Scale row
      ELSE
C                                       Complex
         IF (DOCMPL) THEN
            CALL CVSCL (OBUFFR(PNTI,BUFNOI), CFACT,
     *         OBUFFR(PNTO,BUFNOO), LROW)
C                                       Real
         ELSE
            RDUM(1) = FACTOR
            CALL RVSCL (OBUFFR(PNTI,BUFNOI), RDUM,
     *         OBUFFR(PNTO,BUFNOO), LROW)
            END IF
         END IF
      CALL ARRIO ('WRIT', OUT, ARRFDV(1,BUFNOO), OBUFFR(1,BUFNOO),
     *   BUFPNT(BUFNOO), IERR)
      PNTO = BUFPNT(BUFNOO)
      IF (IERR.GT.0) GO TO 995
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close files
      CALL ARRCLO (TIN, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Delete temporary if necessary
      IF (TIN(1:32).NE.IN(1:32)) CALL IMGDES (TIN, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 995  MSGTXT = 'ARRSCL: INPUT ' // IN
      CALL MSGWRT (7)
      MSGTXT = 'ARRSCL: OUTPUT ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE ARSSET (IN, IERR)
C-----------------------------------------------------------------------
C   Public
C   Determines array statistics and updates ARRAY_STAT; any windowing
C   (BLC, TRC) and blanking are honored.
C      For complex arrays the statistics are for the modulus of the
C   values.
C   Inputs:
C      IN     C*32 The name of the input object
C   Output:
C      IERR   I    Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER IN*(*)
      INTEGER   IERR
C
      INTEGER   BLC(7), TRC(7), LOOP1, LOOP2, LOOP3, LOOP4, LOOP5,
     *   LOOP6, LOOP7, LROW, LROWC, NDIM(7), DIM(7), TYPE, BUFNOI, PNTI,
     *   NNDIM
      CHARACTER DATYPE*8, CDUMMY*1
      REAL      BLANK
      LOGICAL   DOCMPL, ISBLNK
      INTEGER   NUMPIX, PIXMAX(7), PIXMIN(7)
      REAL      VALUE, DATMAX, DATMIN, DATMEN, DATRMS
      DOUBLE PRECISION DATSUM, DATSU2
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Open array and get I/O stream
      PNTI = 1
      CALL ARROPN (IN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (IN, BUFNOI, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Window
      CALL ARRWIN (IN, BLC, TRC, NDIM, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Number of dimensions
      CALL ARDGET (IN, 'NDIM', TYPE, DIM, RDUM, CDUMMY, IERR)
      NNDIM = IDUM(1)
      IF (IERR.NE.0) GO TO 995
C                                       Complex?
      CALL ARDGET (IN, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
      IERR = 0
C                                       Blanking?
      CALL ARDGET (IN, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = (BLANK.NE.0.0) .AND. (IERR.EQ.0)
      IF (.NOT.ISBLNK) BLANK = FBLANK
      IERR = 0
C                                       Init statistics
      NUMPIX = 0
      CALL FILL (7, 0, PIXMAX)
      CALL FILL (7, 0, PIXMIN)
      DATMAX = -1.0E25
      DATMIN = 1.0E25
      DATSUM = 0.0D0
      DATSU2 = 0.0D0
C                                       Loop over array
      LROW = TRC(1) - BLC(1) + 1
      LROWC = LROW
      IF (DOCMPL) LROWC = LROW * 2
      DO 700 LOOP7 = BLC(7),TRC(7)
         DO 600 LOOP6 = BLC(6),TRC(6)
            DO 500 LOOP5 = BLC(5),TRC(5)
               DO 400 LOOP4 = BLC(4),TRC(4)
                  DO 300 LOOP3 = BLC(3),TRC(3)
                     DO 200 LOOP2 = BLC(2),TRC(2)
C                                       read row
      CALL ARRIO ('READ', IN, ARRFDV(1,BUFNOI), OBUFFR(1,BUFNOI),
     *   BUFPNT(BUFNOI), IERR)
      PNTI = BUFPNT(BUFNOI)
      IF (IERR.GT.0) GO TO 995
C                                       Do statistics
      IF (DOCMPL) THEN
C                                       Complex
         DO 110 LOOP1 = 1,LROW
            IF ((OBUFFR(PNTI,BUFNOI).NE.BLANK) .AND.
     *         (OBUFFR(PNTI+1,BUFNOI).NE.BLANK)) THEN
               VALUE = SQRT ((OBUFFR(PNTI,BUFNOI)**2) +
     *            (OBUFFR(PNTI+1,BUFNOI)**2))
               NUMPIX = NUMPIX + 1
               DATSUM = DATSUM + VALUE
               DATSU2 = DATSU2 + VALUE * VALUE
               IF (VALUE.GT.DATMAX) THEN
                  DATMAX = VALUE
                  PIXMAX(1) = LOOP1 + BLC(1) - 1
                  PIXMAX(2) = LOOP2
                  PIXMAX(3) = LOOP3
                  PIXMAX(4) = LOOP4
                  PIXMAX(5) = LOOP5
                  PIXMAX(6) = LOOP6
                  PIXMAX(7) = LOOP7
                  END IF
               IF (VALUE.LT.DATMIN) THEN
                  DATMIN = VALUE
                  PIXMIN(1) = LOOP1 + BLC(1) - 1
                  PIXMIN(2) = LOOP2
                  PIXMIN(3) = LOOP3
                  PIXMIN(4) = LOOP4
                  PIXMIN(5) = LOOP5
                  PIXMIN(6) = LOOP6
                  PIXMIN(7) = LOOP7
                  END IF
               END IF
            PNTI = PNTI + 2
 110        CONTINUE
      ELSE
C                                       Real
         DO 120 LOOP1 = 1,LROW
            IF (OBUFFR(PNTI,BUFNOI).NE.BLANK) THEN
               VALUE = OBUFFR(PNTI,BUFNOI)
               NUMPIX = NUMPIX + 1
               DATSUM = DATSUM + VALUE
               DATSU2 = DATSU2 + VALUE * VALUE
               IF (VALUE.GT.DATMAX) THEN
                  DATMAX = VALUE
                  PIXMAX(1) = LOOP1 + BLC(1) - 1
                  PIXMAX(2) = LOOP2
                  PIXMAX(3) = LOOP3
                  PIXMAX(4) = LOOP4
                  PIXMAX(5) = LOOP5
                  PIXMAX(6) = LOOP6
                  PIXMAX(7) = LOOP7
                  END IF
               IF (VALUE.LT.DATMIN) THEN
                  DATMIN = VALUE
                  PIXMIN(1) = LOOP1 + BLC(1) - 1
                  PIXMIN(2) = LOOP2
                  PIXMIN(3) = LOOP3
                  PIXMIN(4) = LOOP4
                  PIXMIN(5) = LOOP5
                  PIXMIN(6) = LOOP6
                  PIXMIN(7) = LOOP7
                  END IF
               END IF
            PNTI = PNTI + 1
 120        CONTINUE
         END IF
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close file
      CALL ARRCLO (IN, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Determine statistics
      IF (NUMPIX.GT.1) THEN
         DATMEN = DATSUM / NUMPIX
      ELSE
         DATMEN = 0.0
         DATMAX = 0.0
         DATMIN = 0.0
         END IF
      IF (NUMPIX.GT.3) THEN
         DATRMS = SQRT ((DATSU2 - (DATSUM*DATSUM/NUMPIX)) / (NUMPIX-1))
      ELSE
         DATRMS = 0.0
         END IF
C                                       Save values in ARRAY_STAT
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 3
      RDUM(1) = DATRMS
      CALL ARSPUT (IN, 'DATARMS', OOARE, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      RDUM(1) = DATMEN
      CALL ARSPUT (IN, 'DATAMEAN', OOARE, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      RDUM(1) = DATMAX
      CALL ARSPUT (IN, 'DATAMAX', OOARE, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      RDUM(1) = DATMIN
      CALL ARSPUT (IN, 'DATAMIN', OOARE, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      IDUM(1) = NUMPIX
      CALL ARSPUT (IN, 'NUMPIXEL', OOAINT, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      DIM(1) = NNDIM
      CALL COPY (NNDIM, PIXMAX, IDUM)
      CALL ARSPUT (IN, 'PIXMAX', OOAINT, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL COPY (NNDIM, PIXMIN, IDUM)
      CALL ARSPUT (IN, 'PIXMIN', OOAINT, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 995  MSGTXT = 'ARSSET: ERROR DETERMING STAT. FOR ' // IN
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE ARHIST (IN, NHIS, HMIN, HMAX, HIST, IERR)
C-----------------------------------------------------------------------
C   Public
C   Return histogram of array; any windowing (BLC, TRC) and blanking are
C   honored. For complex arrays the histogram is of the modulus of the
C   values. Values less than HMIN are included in HIST(1) and greater
C   than HMAX in HIST(NHIS).
C   Inputs:
C      IN     C*32 The name of the input object
C      NHIS   I    Number of elements in HIST.
C   Input/Output:
C      HMIN   R    Minimum value for histogram.
C      HMAX   R    Maximum value for histogram.  If HMIN=HMAX=0 then
C                  PIXMIN and PIXMAX from the ARRAY_STAT are used.
C   Output:
C      HIST   I    Histogram of pixel values.
C      IERR   I    Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER IN*(*)
      REAL      HMAX, HMIN
      INTEGER   NHIS, HIST(NHIS), IERR
C
      INTEGER   BLC(7), TRC(7), LOOP1, LOOP2, LOOP3, LOOP4, LOOP5,
     *   LOOP6, LOOP7, LROW, LROWC, NDIM(7), DIM(7), TYPE, BUFNOI, PNTI,
     *   NNDIM, INDX
      CHARACTER DATYPE*8, CDUMMY*1
      REAL      BLANK, DELTA, VALUE
      LOGICAL   DOCMPL, ISBLNK
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Open array and get I/O stream
      PNTI = 1
      CALL ARROPN (IN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (IN, BUFNOI, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Window
      CALL ARRWIN (IN, BLC, TRC, NDIM, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Number of dimensions
      CALL ARDGET (IN, 'NDIM', TYPE, DIM, RDUM, CDUMMY, IERR)
      NNDIM = IDUM(1)
      IF (IERR.NE.0) GO TO 995
C                                       Complex?
      CALL ARDGET (IN, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
      IERR = 0
C                                       Blanking?
      CALL ARDGET (IN, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = (BLANK.NE.0.0) .AND. (IERR.EQ.0)
      IF (.NOT.ISBLNK) BLANK = FBLANK
      IERR = 0
C                                       Set up for histogram
      CALL FILL (NHIS, 0, HIST)
C                                       Default range
      IF ((HMAX.EQ.HMIN) .AND. (HMAX.EQ.0.0)) THEN
         CALL ARSGET (IN, 'PIXMIN', TYPE, DIM, RDUM, CDUMMY, IERR)
         HMIN = RDUM(1)
         IF (IERR.NE.0) GO TO 995
         CALL ARSGET (IN, 'PIXMAX', TYPE, DIM, RDUM, CDUMMY, IERR)
         HMAX = RDUM(1)
         IF (IERR.NE.0) GO TO 995
         END IF
C                                       Check histogram size
      IF (NHIS.LE.1) THEN
         MSGTXT = 'ARHIST: BAD HISTOGRAM SIZE'
         IERR = 1
         GO TO 990
         END IF
C                                       Cellsize
      DELTA = (HMAX - HMIN) / NHIS
      IF (ABS (DELTA).GT.1.0E-20) THEN
         DELTA = 1.0 / DELTA
      ELSE
C                                       Bad range.
         MSGTXT = 'ARHIST: DEGENERATE, NONDEFAULT RANGE'
         IERR = 1
         GO TO 990
         END IF
C                                       Loop over array
      LROW = TRC(1) - BLC(1) + 1
      LROWC = LROW
      IF (DOCMPL) LROWC = LROW * 2
      DO 700 LOOP7 = BLC(7),TRC(7)
         DO 600 LOOP6 = BLC(6),TRC(6)
            DO 500 LOOP5 = BLC(5),TRC(5)
               DO 400 LOOP4 = BLC(4),TRC(4)
                  DO 300 LOOP3 = BLC(3),TRC(3)
                     DO 200 LOOP2 = BLC(2),TRC(2)
C                                       read row
      CALL ARRIO ('READ', IN, ARRFDV(1,BUFNOI), OBUFFR(1,BUFNOI),
     *   BUFPNT(BUFNOI), IERR)
      PNTI = BUFPNT(BUFNOI)
      IF (IERR.GT.0) GO TO 995
C                                       Do histogram
      IF (DOCMPL) THEN
C                                       Complex
         DO 110 LOOP1 = 1,LROW
            IF ((OBUFFR(PNTI,BUFNOI).NE.BLANK) .AND.
     *         (OBUFFR(PNTI+1,BUFNOI).NE.BLANK)) THEN
               VALUE = SQRT ((OBUFFR(PNTI,BUFNOI)**2) +
     *            (OBUFFR(PNTI+1,BUFNOI)**2))
               INDX = ((VALUE - HMIN) * DELTA) + 1
               INDX = MAX (1, MIN (NHIS, INDX))
               HIST(INDX) = HIST(INDX) + 1
               END IF
            PNTI = PNTI + 2
 110        CONTINUE
      ELSE
C                                       Real
         DO 120 LOOP1 = 1,LROW
            IF (OBUFFR(PNTI,BUFNOI).NE.BLANK) THEN
               VALUE = OBUFFR(PNTI,BUFNOI)
               INDX = ((VALUE - HMIN) * DELTA) + 1
               INDX = MAX (1, MIN (NHIS, INDX))
               HIST(INDX) = HIST(INDX) + 1
               END IF
            PNTI = PNTI + 1
 120        CONTINUE
         END IF
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close file
      CALL ARRCLO (IN, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 990  CALL MSGWRT (7)
 995  MSGTXT = 'ARHIST: ERROR IN HISTOGRAM FOR ' // IN
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE CHKBLK (N, DATA, VALID)
C-----------------------------------------------------------------------
C   Public
C   Returns a blanking array to indicate which elements of an array are
C   blanked.
C   Inputs:
C      N     I     Element count
C      DATA  R(*)  Data array
C   Output:
C      VALID L(*)  True if corresponding element in DATA is valid.
C-----------------------------------------------------------------------
      INTEGER   N
      REAL      DATA(*)
      LOGICAL   VALID(*)
C
      INTEGER   LOOP
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      DO 100 LOOP = 1,N
         VALID(LOOP) = DATA(LOOP).NE.FBLANK
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SETBLK (N, VALID, DATA)
C-----------------------------------------------------------------------
C   Public
C   Blanks elements of an array as indicated by a logical array.
C   Inputs:
C      N     I     Element count
C      VALID L(*)  True if corresponding element in DATA is valid.
C   Input/Output:
C      DATA  R(*)  Data array
C-----------------------------------------------------------------------
      INTEGER   N
      LOGICAL   VALID(*)
      REAL      DATA(*)
C
      INTEGER   LOOP
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      DO 100 LOOP = 1,N
         IF (.NOT.VALID(LOOP)) DATA(LOOP) = FBLANK
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE ARRCOP (IN, OUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Copy the elements of one array to another
C   Inputs:
C      IN    C*32  The name of the input object.
C      OUT   C*32  The name of the output object
C   Output:
C      IERR  I     Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER IN*(*), OUT*(*)
      INTEGER   IERR
C
      INTEGER   BLC(7), TRC(7), LOOP2, LOOP3, LOOP4, LOOP5, LOOP6,
     *   LOOP7, LROW, LROWC, NDIM(7), DIM(7), TYPE, BUFNOI, BUFNOO,
     *   PNTI, PNTO
      CHARACTER DATYPE*8, CDUMMY*1
      REAL      BLANK
      LOGICAL   DOCMPL, ISBLNK
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Open array and get I/O stream
C                                       pointers
      PNTI = 1
      CALL ARROPN (IN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (IN, BUFNOI, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Output
      PNTO = 1
      CALL ARROPN (OUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (OUT, BUFNOO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Clear output window
      CALL ARRCWI (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Check compatibility
      CALL ARRCHK (IN, OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Window
      CALL ARRWIN (IN, BLC, TRC, NDIM, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex?
      CALL ARDGET (IN, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
      IERR = 0
C                                       Blanking?
      CALL ARDGET (IN, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = (BLANK.NE.0.0) .AND. (IERR.EQ.0)
      IERR = 0
C                                       Loop over array
      LROW = TRC(1) - BLC(1) + 1
      LROWC = LROW
      IF (DOCMPL) LROWC = LROW * 2
      DO 700 LOOP7 = BLC(7),TRC(7)
         DO 600 LOOP6 = BLC(6),TRC(6)
            DO 500 LOOP5 = BLC(5),TRC(5)
               DO 400 LOOP4 = BLC(4),TRC(4)
                  DO 300 LOOP3 = BLC(3),TRC(3)
                     DO 200 LOOP2 = BLC(2),TRC(2)
C                                       Fetch input row
      CALL ARRIO ('READ', IN, ARRFDV(1,BUFNOI), OBUFFR(1,BUFNOI),
     *    BUFPNT(BUFNOI), IERR)
      PNTI = BUFPNT(BUFNOI)
      IF (IERR.GT.0) GO TO 995
C                                       Copy row
      IF (DOCMPL) THEN
C                                       Complex
         CALL CVCOPY (OBUFFR(PNTI,BUFNOI), OBUFFR(PNTO,BUFNOO), LROW)
      ELSE
C                                       Real
         CALL RVCOPY (OBUFFR(PNTI,BUFNOI), OBUFFR(PNTO,BUFNOO), LROW)
         END IF
      CALL ARRIO ('WRIT', OUT, ARRFDV(1,BUFNOO), OBUFFR(1,BUFNOO),
     *   BUFPNT(BUFNOO), IERR)
      PNTO = BUFPNT(BUFNOO)
      IF (IERR.GT.0) GO TO 995
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close files
      CALL ARRCLO (IN, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 995  MSGTXT = 'ARRCOP: INPUT ' // IN
      CALL MSGWRT (7)
      MSGTXT = 'ARRCOP: OUTPUT ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE ARRFIL (SCALAR, OUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Fill an array with a real scalar
C   Inputs:
C      SCALAR R    Scalar to fill
C      OUT    C*32 The name of the output object
C   Output:
C      IERR   I    Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      REAL      SCALAR
      CHARACTER OUT*(*)
      INTEGER   IERR
C
      INTEGER   BLC(7), TRC(7), LOOP2, LOOP3, LOOP4, LOOP5, LOOP6,
     *   LOOP7, LROW, LROWC, NDIM(7), DIM(7), TYPE, BUFNOO, PNTO
      CHARACTER DATYPE*8, CDUMMY*1
      COMPLEX   CSCLR
      REAL      BLANK
      LOGICAL   DOCMPL, ISBLNK
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Complex scalar
      CSCLR = CMPLX (SCALAR, 0.0)
C                                       Open array and get I/O stream
C                                       Output
      PNTO = 1
      CALL ARROPN (OUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (OUT, BUFNOO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Window
      CALL ARRWIN (OUT, BLC, TRC, NDIM, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex?
      CALL ARDGET (OUT, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
      IERR = 0
C                                       Blanking?
      CALL ARDGET (OUT, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = (BLANK.NE.0.0) .AND. (IERR.EQ.0)
      IERR = 0
C                                       Loop over array
      LROW = TRC(1) - BLC(1) + 1
      LROWC = LROW
      IF (DOCMPL) LROWC = LROW * 2
      DO 700 LOOP7 = BLC(7),TRC(7)
         DO 600 LOOP6 = BLC(6),TRC(6)
            DO 500 LOOP5 = BLC(5),TRC(5)
               DO 400 LOOP4 = BLC(4),TRC(4)
                  DO 300 LOOP3 = BLC(3),TRC(3)
                     DO 200 LOOP2 = BLC(2),TRC(2)
C                                       Fill row
      IF (DOCMPL) THEN
C                                       Complex
         CALL CVFILL (CSCLR, OBUFFR(PNTO,BUFNOO), LROW)
      ELSE
C                                       Real
         CALL RVFILL (SCALAR, OBUFFR(PNTO,BUFNOO), LROW)
         END IF
      CALL ARRIO ('WRIT', OUT, ARRFDV(1,BUFNOO), OBUFFR(1,BUFNOO),
     *   BUFPNT(BUFNOO), IERR)
      PNTO = BUFPNT(BUFNOO)
      IF (IERR.GT.0) GO TO 995
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close file
      CALL ARRCLO (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 995  MSGTXT = 'ARRFIL: OUTPUT ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE ARRSAD (IN, SCALAR, OUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Add a scalar to the elements of an array.  The scalar is expected to
C   be of the same type (real or complex) as the array
C   Inputs:
C      IN     C*32  The name of the input array object.
C      SCALAR R(?)  Scalar to add, (real, imaginary) for complex.
C      OUT    C*32  The name of the output array object.
C   Output:
C      IERR   I     Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER IN*(*), OUT*(*)
      REAL      SCALAR(*)
      INTEGER   IERR
C
      INTEGER   BLC(7), TRC(7), LOOP2, LOOP3, LOOP4, LOOP5, LOOP6,
     *   LOOP7, LROW, LROWC, NAXIS(7), DIM(7), TYPE, BUFNOI, BUFNOO,
     *   PNTI, PNTO
      CHARACTER DATYPE*8, TIN*32, CDUMMY*1
      REAL      BLANK
      LOGICAL   DOCMPL, ISBLNK
      COMPLEX   CSCLR
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       May need temporary object
      IF (IN.EQ.OUT) THEN
C                                       Create temporary output object
         TIN = 'Temporary IMAGE for ARRSAD'
         CALL IMGCOP (IN, TIN, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         TIN = IN
         END IF
C                                       Open array and get I/O stream
C                                       pointers
      PNTI = 1
      CALL ARROPN (TIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (TIN, BUFNOI, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Output
      PNTO = 1
      CALL ARROPN (OUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (OUT, BUFNOO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Clear output window
      CALL ARRCWI (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Check compatibility
      CALL ARRCHK (TIN, OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex factor
      CSCLR = CMPLX (SCALAR(1), SCALAR(2))
C                                       Window
      CALL ARRWIN (TIN, BLC, TRC, NAXIS, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex?
      CALL ARDGET (TIN, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
      IERR = 0
C                                       Blanking?
      CALL ARDGET (TIN, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = (BLANK.NE.0.0) .AND. (IERR.EQ.0)
      IERR = 0
C                                       Loop over array
      LROW = TRC(1) - BLC(1) + 1
      LROWC = LROW
      IF (DOCMPL) LROWC = LROW * 2
      DO 700 LOOP7 = BLC(7),TRC(7)
         DO 600 LOOP6 = BLC(6),TRC(6)
            DO 500 LOOP5 = BLC(5),TRC(5)
               DO 400 LOOP4 = BLC(4),TRC(4)
                  DO 300 LOOP3 = BLC(3),TRC(3)
                     DO 200 LOOP2 = BLC(2),TRC(2)
C                                       Fetch input row
      CALL ARRIO ('READ', TIN, ARRFDV(1,BUFNOI), OBUFFR(1,BUFNOI),
     *    BUFPNT(BUFNOI), IERR)
      PNTI = BUFPNT(BUFNOI)
      IF (IERR.GT.0) GO TO 995
C                                       Blanking?
      IF (ISBLNK) THEN
C                                       Scale row with blanking
         CALL CHKBLK (LROWC, OBUFFR(PNTI,BUFNOI), VALID1)
         IF (DOCMPL) THEN
C                                       Complex
            CALL CSVADB (OBUFFR(PNTI,BUFNOI), VALID1, CSCLR,
     *         OBUFFR(PNTO,BUFNOO), VALID3, LROW)
         ELSE
C                                       Real
            CALL RSVADB (OBUFFR(PNTI,BUFNOI), VALID1, SCALAR,
     *         OBUFFR(PNTO,BUFNOO), VALID3, LROW)
            END IF
         CALL SETBLK (LROWC, VALID3, OBUFFR(PNTO,BUFNOO))
      ELSE
C                                       Scale row
         IF (DOCMPL) THEN
C                                       Complex
            CALL CSVADD (OBUFFR(PNTI,BUFNOI), CSCLR,
     *         OBUFFR(PNTO,BUFNOO), LROW)
         ELSE
C                                       Real
            CALL RSVADD (OBUFFR(PNTI,BUFNOI), SCALAR,
     *         OBUFFR(PNTO,BUFNOO), LROW)
            END IF
         END IF
      CALL ARRIO ('WRIT', OUT, ARRFDV(1,BUFNOO), OBUFFR(1,BUFNOO),
     *   BUFPNT(BUFNOO), IERR)
      PNTO = BUFPNT(BUFNOO)
      IF (IERR.GT.0) GO TO 995
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close files
      CALL ARRCLO (TIN, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Delete temporary if necessary
      IF (TIN(1:32).NE.IN(1:32)) CALL IMGDES (TIN, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 995  MSGTXT = 'ARRSAD: INPUT ' // IN
      CALL MSGWRT (7)
      MSGTXT = 'ARRSAD: OUTPUT ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE ARRSMU (IN, SCALAR, OUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   MUltiply a scalar times the elements of an array.  The scalar is
C   expected to be of the same type (real or complex) as the array.
C   Inputs:
C      IN     C*32  The name of the input array object.
C      SCALAR R(?)  Scalar to add, (real, imaginary) for complex.
C      OUT    C*32  The name of the output array object.
C   Output:
C      IERR   I     Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER IN*(*), OUT*(*)
      REAL      SCALAR(*)
      INTEGER   IERR
C
      INTEGER   BLC(7), TRC(7), LOOP2, LOOP3, LOOP4, LOOP5, LOOP6,
     *   LOOP7, LROW, LROWC, NAXIS(7), DIM(7), TYPE, BUFNOI, BUFNOO,
     *   PNTI, PNTO
      CHARACTER DATYPE*8, TIN*32, CDUMMY*1
      REAL      BLANK
      LOGICAL   DOCMPL, ISBLNK
      COMPLEX   CSCLR
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       May need temporary object
      IF (IN.EQ.OUT) THEN
C                                       Create temporary output object
         TIN = 'Temporary IMAGE for ARRSMU'
         CALL IMGCOP (IN, TIN, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         TIN = IN
         END IF
C                                       Open array and get I/O stream
C                                       pointers
      PNTI = 1
      CALL ARROPN (TIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (TIN, BUFNOI, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Output
      PNTO = 1
      CALL ARROPN (OUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (OUT, BUFNOO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Clear output window
      CALL ARRCWI (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Check compatibility
      CALL ARRCHK (TIN, OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex factor
      CSCLR = CMPLX (SCALAR(1), SCALAR(2))
C                                       Window
      CALL ARRWIN (TIN, BLC, TRC, NAXIS, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Complex?
      CALL ARDGET (TIN, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
      IERR = 0
C                                       Blanking?
      CALL ARDGET (TIN, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = (BLANK.NE.0.0) .AND. (IERR.EQ.0)
      IERR = 0
C                                       Loop over array
      LROW = TRC(1) - BLC(1) + 1
      LROWC = LROW
      IF (DOCMPL) LROWC = LROW * 2
      DO 700 LOOP7 = BLC(7),TRC(7)
         DO 600 LOOP6 = BLC(6),TRC(6)
            DO 500 LOOP5 = BLC(5),TRC(5)
               DO 400 LOOP4 = BLC(4),TRC(4)
                  DO 300 LOOP3 = BLC(3),TRC(3)
                     DO 200 LOOP2 = BLC(2),TRC(2)
C                                       Fetch input row
      CALL ARRIO ('READ', TIN, ARRFDV(1,BUFNOI), OBUFFR(1,BUFNOI),
     *    BUFPNT(BUFNOI), IERR)
      PNTI = BUFPNT(BUFNOI)
      IF (IERR.GT.0) GO TO 995
C                                       Blanking?
      IF (ISBLNK) THEN
C                                       Scale row with blanking
         CALL CHKBLK (LROWC, OBUFFR(PNTI,BUFNOI), VALID1)
         IF (DOCMPL) THEN
C                                       Complex
            CALL CVBSCL (OBUFFR(PNTI,BUFNOI), VALID1, CSCLR,
     *         OBUFFR(PNTO,BUFNOO), VALID3, LROW)
         ELSE
C                                       Real
            CALL RVBSCL (OBUFFR(PNTI,BUFNOI), VALID1, SCALAR,
     *         OBUFFR(PNTO,BUFNOO), VALID3, LROW)
            END IF
         CALL SETBLK (LROWC, VALID3, OBUFFR(PNTO,BUFNOO))
      ELSE
C                                       Scale row
         IF (DOCMPL) THEN
C                                       Complex
            CALL CVSCL (OBUFFR(PNTI,BUFNOI), CSCLR,
     *         OBUFFR(PNTO,BUFNOO), LROW)
         ELSE
C                                       Real
            CALL RVSCL (OBUFFR(PNTI,BUFNOI), SCALAR,
     *         OBUFFR(PNTO,BUFNOO), LROW)
            END IF
         END IF
      CALL ARRIO ('WRIT', OUT, ARRFDV(1,BUFNOO), OBUFFR(1,BUFNOO),
     *   BUFPNT(BUFNOO), IERR)
      PNTO = BUFPNT(BUFNOO)
      IF (IERR.GT.0) GO TO 995
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close files
      CALL ARRCLO (TIN, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Delete temporary if necessary
      IF (TIN(1:32).NE.IN(1:32)) CALL IMGDES (TIN, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 995  MSGTXT = 'ARRSMU: INPUT ' // IN
      CALL MSGWRT (7)
      MSGTXT = 'ARRSMU: OUTPUT ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE ARRBSC (PLUS, MINUS, OUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Combine two beam-switched arrays
C   Inputs:
C      PLUS    C*32  The name of the first object.
C      MINUS   C*32  The name of the second object.
C      OUT     C*32  The name of the output object
C   Output:
C      IERR    I     Error return code, 0=OK, 1=do not match
C-----------------------------------------------------------------------
      CHARACTER PLUS*(*), MINUS*(*), OUT*(*)
      INTEGER   IERR
C
      INTEGER   BLC(7), TRC(7), LOOP2, LOOP3, LOOP4, LOOP5, LOOP6,
     *   LOOP7, LROW, NDIM(7), DIM(7), TYPE, BUFNI1, BUFNI2, BUFNOO,
     *   PNTI1, PNTI2, PNTO, BLORDR, BLWIND(2,10), MSGSAV, NWIND, IC,
     *   BUFCNV, NCROW
      CHARACTER TPLUS*32, TMINUS*32, CDUMMY*1, TCONV*32
      REAL      BLANK, FACTOR, REWT(2), THROWP, THROWM, AXV
      LOGICAL   ISBLNK, FIRST
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'ARRAY.INC'
      INCLUDE 'ARGFORT'
C-----------------------------------------------------------------------
      FIRST = .TRUE.
      MSGSAV = MSGSUP
C                                       Create temporary output object
      IF (PLUS.EQ.OUT) THEN
         TPLUS = 'Temporary PLUS image for ARRBSC'
         CALL IMGCOP (PLUS, TPLUS, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         TPLUS = PLUS
         END IF
C                                       Create temporary
      IF (PLUS.EQ.MINUS) THEN
         TMINUS = 'Temporary minus image for ARRBSC'
         CALL IMGCOP (MINUS, TMINUS, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         TMINUS = MINUS
         END IF
C                                       get another bit of memory
      TCONV = 'Temporary dummy for ARRBSC'
      CALL IMGCOP (PLUS, TCONV, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBOPEN (TCONV, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (TCONV, BUFCNV, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Open array and get I/O stream
C                                       pointers
      CALL ARROPN (TPLUS, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (TPLUS, BUFNI1, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Second input
      CALL ARROPN (TMINUS, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (TMINUS, BUFNI2, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Output
      PNTO = 1
      CALL ARROPN (OUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBINFO (OUT, BUFNOO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Clear output window
      CALL ARRCWI (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Check compatibility
      CALL ARRCHK (TPLUS, TMINUS, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCHK (TPLUS, OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Image window
      CALL ARRWIN (TPLUS, BLC, TRC, NDIM, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       BS correction parameters
      MSGSUP = 32000
      CALL OGET (TPLUS, 'FACTOR', TYPE, DIM, RDUM, CDUMMY, IERR)
      FACTOR = RDUM(1)
      IF (IERR.EQ.1) THEN
         IERR = 0
         FACTOR = 1.0
         END IF
      MSGSUP = MSGSAV
      IF (IERR.NE.0) GO TO 995
      IF (FACTOR.LE.0.0) FACTOR = 1.0
      MSGSUP = 32000
      CALL OGET (TPLUS, 'BLORDER', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLORDR = IDUM(1)
      IF (IERR.EQ.1) THEN
         IERR = 0
         BLORDR = 0
         END IF
      MSGSUP = MSGSAV
      IF (IERR.NE.0) GO TO 995
      BLORDR = MAX (0, MIN (1, BLORDR))
      MSGSUP = 32000
      CALL OGET (TPLUS, 'REWEIGHT', TYPE, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.EQ.1) THEN
         IERR = 0
         REWT(1) = 1.0
         REWT(2) = 1.0
      ELSE IF (IERR.EQ.0) THEN
         CALL RCOPY (DIM(1), RDUM, REWT)
         END IF
      MSGSUP = MSGSAV
      IF (IERR.NE.0) GO TO 995
      IF (REWT(1).LE.0.0) REWT(1) = 1.0
      IF (REWT(2).LE.0.0) REWT(2) = 1.0
      MSGSUP = 32000
      CALL OGET (TPLUS, 'BLWINDOW', TYPE, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.EQ.0) CALL COPY (DIM(1)*DIM(2), IDUM, BLWIND)
      IF (IERR.EQ.1) THEN
         IERR = 0
         DIM(1) = 0
         END IF
      MSGSUP = MSGSAV
      IF (IERR.NE.0) GO TO 995
      NWIND = DIM(1) / 2
      IF (NWIND.LE.0) THEN
         NWIND = 1
         BLWIND(1,1) = 1
         BLWIND(2,1) = 8192
         END IF
C                                       BS throws
      CALL OGET (TPLUS, 'BSTHROW', TYPE, DIM, RDUM, CDUMMY, IERR)
      THROWP = RDUM(1)
      IF (IERR.NE.0) GO TO 995
      CALL OGET (TMINUS, 'BSTHROW', TYPE, DIM, RDUM, CDUMMY, IERR)
      THROWM = RDUM(1)
      IF (IERR.NE.0) GO TO 995
      CALL OBHGET (OUT, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      AXV = CATR(KRCIC) * 3600
      IF (AXV.EQ.0.0) AXV = 1.0
      IC = CATR(KRCRP) + 0.5
      IC = 2 * IC
      THROWP = FACTOR * THROWP / AXV
      THROWM = FACTOR * THROWM / AXV
      LROW = TRC(1) - BLC(1) + 1
      NCROW = MAX (LROW*2, 1024)
      CALL BSCONV (NCROW, THROWP, THROWM, REWT(1), IC, OBUFFR(1,BUFCNV))
C                                       Blanking?
      CALL ARDGET (TPLUS, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = (BLANK.NE.0.0) .AND. (IERR.EQ.0)
      CALL ARDGET (TMINUS, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM(1)
      ISBLNK = ISBLNK .OR. ((BLANK.NE.0.0) .AND. (IERR.EQ.0))
      IERR = 0
C                                       Loop over array
      DO 700 LOOP7 = BLC(7),TRC(7)
         DO 600 LOOP6 = BLC(6),TRC(6)
            DO 500 LOOP5 = BLC(5),TRC(5)
               DO 400 LOOP4 = BLC(4),TRC(4)
                  DO 300 LOOP3 = BLC(3),TRC(3)
                     DO 200 LOOP2 = BLC(2),TRC(2)
C                                       Fetch input rows
      CALL ARRIO ('READ', TPLUS, ARRFDV(1,BUFNI1), OBUFFR(1,BUFNI1),
     *    BUFPNT(BUFNI1), IERR)
      PNTI1 = BUFPNT(BUFNI1)
      IF (IERR.GT.0) GO TO 995
      CALL ARRIO ('READ', TMINUS, ARRFDV(1,BUFNI2), OBUFFR(1,BUFNI2),
     *    BUFPNT(BUFNI2), IERR)
      PNTI2 = BUFPNT(BUFNI2)
      IF (IERR.GT.0) GO TO 995
C                                       Blanking?
      IF (ISBLNK) THEN
         CALL CHKBLK (LROW, OBUFFR(PNTI1,BUFNI1), VALID1)
         CALL CHKBLK (LROW, OBUFFR(PNTI2,BUFNI2), VALID2)
         IF (FIRST) THEN
            CALL RVBBLS (OBUFFR(PNTI1,BUFNI1), VALID1, LROW, BLORDR,
     *         NWIND, BLWIND)
            CALL RVBBLS (OBUFFR(PNTI2,BUFNI2), VALID2, LROW, BLORDR,
     *         NWIND, BLWIND)
            RDUM(1) = REWT(2)
            IF (REWT(2).NE.1.0) CALL RVBSCL (OBUFFR(PNTI1,BUFNI1),
     *         VALID1, RDUM, OBUFFR(PNTI1,BUFNI1), VALID1, LROW)
            CALL RVBSUB (OBUFFR(PNTI1,BUFNI1), VALID1,
     *         OBUFFR(PNTI2,BUFNI2), VALID2, OBUFFR(PNTI1,BUFNI1),
     *         VALID1, LROW)
            CALL RVBBSC (OBUFFR(PNTI1,BUFNI1), VALID1,
     *         OBUFFR(PNTO,BUFNOO), VALID3, LROW, IC, OBUFFR(1,BUFCNV))
         ELSE
            CALL RVBADD (OBUFFR(PNTI1,BUFNI1), VALID1,
     *         OBUFFR(PNTI2,BUFNI2), VALID2, OBUFFR(PNTO,BUFNOO),
     *         VALID3, LROW)
            RDUM(1) = 0.5
            CALL RVBSCL (OBUFFR(PNTO,BUFNOO), VALID3, RDUM,
     *         OBUFFR(PNTO,BUFNOO), VALID3, LROW)
            END IF
         CALL SETBLK (LROW, VALID3, OBUFFR(PNTO,BUFNOO))
C                                       No blanking
      ELSE
         IF (FIRST) THEN
            CALL RVBLS (OBUFFR(PNTI1,BUFNI1), LROW, BLORDR, NWIND,
     *         BLWIND)
            CALL RVBLS (OBUFFR(PNTI2,BUFNI2), LROW, BLORDR, NWIND,
     *         BLWIND)
            RDUM(1) = REWT(2)
            IF (REWT(2).NE.1.0) CALL RVSCL (OBUFFR(PNTI1,BUFNI1),
     *         RDUM, OBUFFR(PNTI1,BUFNI1), LROW)
            CALL RVSUB (OBUFFR(PNTI1,BUFNI1), OBUFFR(PNTI2,BUFNI2),
     *         OBUFFR(PNTI1,BUFNI1), LROW)
            CALL RVBSC (OBUFFR(PNTI1,BUFNI1), OBUFFR(PNTO,BUFNOO),
     *         LROW, IC, OBUFFR(1,BUFCNV))
         ELSE
            CALL RVADD (OBUFFR(PNTI1,BUFNI1), OBUFFR(PNTI2,BUFNI2),
     *         OBUFFR(PNTO,BUFNOO), LROW)
            RDUM(1) = 0.5
            CALL RVSCL (OBUFFR(PNTO,BUFNOO), RDUM, OBUFFR(PNTO,BUFNOO),
     *         LROW)
            END IF
         END IF
      CALL ARRIO ('WRIT', OUT, ARRFDV(1,BUFNOO), OBUFFR(1,BUFNOO),
     *   BUFPNT(BUFNOO), IERR)
      PNTO = BUFPNT(BUFNOO)
      IF (IERR.GT.0) GO TO 995
 200                    CONTINUE
                     FIRST = .FALSE.
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close files
      CALL ARRCLO (TPLUS, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (TMINUS, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBCLOS (TCONV, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OBFREE (TCONV, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Delete temporary if necessary
      IF (TPLUS(1:32).NE.PLUS(1:32)) CALL IMGDES (TPLUS, IERR)
      IF (IERR.NE.0) GO TO 995
      IF (TMINUS(1:32).NE.MINUS(1:32)) CALL IMGDES (TMINUS, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 995  MSGTXT = 'ARRBSC: FIRST INPUT ' // PLUS
      CALL MSGWRT (7)
      MSGTXT = 'ARRBSC: SECOND INPUT ' // MINUS
      CALL MSGWRT (7)
      MSGTXT = 'ARRBSC: OUTPUT ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
      END

      SUBROUTINE ZBKTP3 (ZLUN, ZBKNAM, IERR)
C-----------------------------------------------------------------------
C! clean up host environment at end of BAKTP
C# Z Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Clean up host environment after BAKTP execution.
C   Inputs:
C      ZLUN     I       LUN for command file
C      ZBKNAM   C*(*)   Name of command file
C   Output:
C      IERR     I       Error code: 0 => okay, else ZSHCMD
C   Unix version - removes the command file
C-----------------------------------------------------------------------
      INTEGER   ZLUN, IERR
      CHARACTER ZBKNAM*(*)
C
      CHARACTER COMMND*40
      INTEGER   CLEN, ITRIM
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       delete the command file:
      COMMND = 'rm ' // ZBKNAM
      CLEN = ITRIM (COMMND)
      CALL ZSHCMD (CLEN, COMMND, 8, 'TASK_OUT', IERR)
C
 999  RETURN
      END

      SUBROUTINE ZM70M2 (FCB, IERR)
C-----------------------------------------------------------------------
C! issues a master clear to an IIS Model 70 TV
C# Z2 IO-TV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Perform a master clear on an IIS model 70 TV device - second level z
C   Inputs:
C      FCB      I(*)        File control block in FTAB for TV device
C   VMS version
C-----------------------------------------------------------------------
      INTEGER   FCB(*), IERR
C
      INTEGER   SYS$QIOW, JERR, ITEMP, FCODE, BUFF
      INTEGER*2 I2TEMP(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE '($IODEF)'
      INCLUDE '($SSDEF)'
      EQUIVALENCE (I2TEMP, ITEMP)
C-----------------------------------------------------------------------
C                                       Read
      FCB(1+FCBREQ) = 0
      FCODE = IO$_REWIND
      FCB(1+FCBSP2) = 1
C                                       Do it
      JERR = SYS$QIOW (%VAL(FCB(1+FCBSP1)), %VAL(FCB(1+FCBFD)),
     *   %VAL(FCODE), FCB(1+FCBSP2), , , BUFF, %VAL(FCB(1+FCBREQ)),
     *   , , , )
C                                       error testing
      ITEMP = FCB(1+FCBSP2)
      IF (JERR.NE.1) THEN
         IERR = 3
         FCB(1+FCBERR) = JERR
         FCB(1+FCBXFR) = 0
      ELSE
         FCB(1+FCBXFR) = I2TEMP(2)
         IF (I2TEMP(1).NE.1) THEN
            FCB(1+FCBERR) = I2TEMP(1)
            IERR = 3
            IF (I2TEMP(1).EQ.SS$_ENDOFFILE) IERR = 4
         ELSE
            IERR = 0
            FCB(1+FCBERR) = 0
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE YLUT (OP, CHANNL, COLOR, VRTRTC, LUT, IERR)
C-----------------------------------------------------------------------
C! read/write channel-based look-up-table
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YLUT reads/writes full channel look up tables to TV.
C   Inputs:
C      OP      C*4    'READ' from TV, 'WRIT' to TV
C      CHANNL  I      channel select bit mask
C      COLOR   I      color select bit mask (RGB <-> 421)
C      VRTRTC  L      T => do it only during vertical retrace
C   In/Out:
C      LUT     I(*)   look up table (dimension = MAXINT+1, values to
C                     LUTOUT are used)
C   Out:
C      IERR    I      error code of Z...XF : 0 => ok, 2 => input error
C   VIRTUAL TV (by communication) version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   CHANNL, COLOR, LUT(*), IERR
      LOGICAL   VRTRTC
C
      INTEGER   I
      INCLUDE 'INCS:DVTV.INC'
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
      BUFFER(1) = CHANNL
      BUFFER(2) = COLOR
      BUFFER(3) = 0
      IF (VRTRTC) BUFFER(3) = 1
      I = MAXINT + 1
      IF (OP.NE.'READ') THEN
         CALL COPY (I, LUT, BUFFER(4))
         BUFSW = 3 + I
         BUFSR = 0
      ELSE
         BUFSW = 3
         BUFSR = 3 + I
         END IF
      CALL MKYBUF (OP, 'YLUT', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
      IF ((IERR.EQ.0) .AND. (OP.EQ.'READ')) THEN
         CALL UNYBUF (BUFSR, BUFFER, HEADER)
         CALL COPY (I, BUFFER(4), LUT)
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZXLX8 (NBIT, INB, OUTB)
C-----------------------------------------------------------------------
C! convert AIPS bit array to FITS binary table bit array
C# FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZXLX8 converts an AIPS table bit array to an FITS bit array. An AIPS
C   bit array has the bits in locations of increasing signifigance
C   NBITWD per short integer.  A FITS bit array has the bits in order of
C   decreasing signifigance with 8 bits per real world byte, zero filled
C   Inputs:
C      NBIT   I      Number of bits
C      INB    I(*)   Input buffer of AIPS bit array data.
C   Output:
C      OUTB   I(*)   Out buffer, note an integral number of 16-bit
C                    integers in OUTB are modified.  OUTB is left in
C                    the form of IEEE integers (i.e. ms byte first).
C   Generic version: works whenever local integer is a multiple of 16
C   bits and has no more than 64 bits.
C-----------------------------------------------------------------------
      INTEGER   NBIT, INB(*), OUTB(*)
C
C                                       NUMBIT = number of bits in
C                                       a local integer (max)
      INTEGER   NUMBIT
      PARAMETER (NUMBIT=64)
C
      INTEGER   IBITS(NUMBIT), OBITS(NUMBIT), IWORK(NUMBIT/16), J,
     *   NBITS, NCONV, NWORDS, NLEFT, LOOP, ILOOP, NLOOP, IPOINT
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      NWORDS = (NBIT-1) / NBITWD + 1
      NLEFT = NBIT
C                                       Loop over input words
      DO 100 LOOP = 1,NWORDS
         NBITS = NBITWD
         IF (NBITS.GT.NLEFT) NBITS = NLEFT
C                                       Input bits are NBITWD per
C                                       integer:
C                                       Extract the bits.
         CALL ZGTBIT (NBITS, INB(LOOP), IBITS)
C                                       Reverse bit order.
         DO 20 ILOOP = 1,NBITS
            OBITS(NBITWD-ILOOP+1) = IBITS(ILOOP)
 20         CONTINUE
C                                       Zero remaining output bits
         J = NBITS + 1
         DO 40 ILOOP = J, NBITWD
            OBITS(NBITWD-ILOOP+1) = 0
 40         CONTINUE
C                                       Output bytes are written 2 at a
C                                       time as 16 bit standard
C                                       integers:
C                                       Repack bits 16 per word
         IPOINT = NBITWD - 15
         NLOOP = (NBITS-1) / 16 + 1
         DO 60 ILOOP = 1,NLOOP
            CALL ZPTBIT (16, IWORK(ILOOP), OBITS(IPOINT))
            IPOINT = IPOINT - 16
C                                       Funny business to avoid
C                                       overflows.
            IF (IWORK(ILOOP).GT.32767)
     *         IWORK(ILOOP) = IWORK(ILOOP) - 65536
 60         CONTINUE
C                                       Convert to standard 16 bit
C                                       integers.
         NCONV = NLOOP
         CALL ZILI16 (NCONV, IWORK, 1, OUTB(LOOP))
         NLEFT = NLEFT - NBITS
 100     CONTINUE
C
 999  RETURN
      END

C   Generic object operations.  Class specific routines are called.
C-----------------------------------------------------------------------
C! Object Oriented AIPS Fortran Generic member functions
C# Map-util Utility Object-Oriented
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Available functions:
C      CREATE (name, class, ierr)
C         Creates an object of type class
C      DESTRY (name, ierr)
C         Destroys an object, permanent forms are not affected.
C      ZAP (name, ierr)
C         Zaps an object, permanent forms are destroyed.
C      OCOPY (namein, namout, ierr)
C         Copies an object, permanent forms are unaffected.
C      OCLONE (namein, namout, ierr)
C         Clones an object, new permanent forms are created.
C      OOPEN (name, status, ierr)
C         Opens an object for access.
C      OCLOSE (name, ierr)
C         Closes an object for access.
C      OGET (name, keywrd, type, dim, value, valuec, ierr)
C         Return value associated with keyword.
C      OPUT (name, keywrd, type, dim, value, valuec, ierr)
C         Store value associated with keyword.
C-----------------------------------------------------------------------
      SUBROUTINE CREATE (NAME, CLASS, IERR)
C-----------------------------------------------------------------------
C   Public
C   Creates an image object with name "name"
C   Inputs:
C      NAME  C*?   The name of the object.
C      CLASS C*8   Class of the object
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), CLASS*(*)
      INTEGER   IERR
C
C-----------------------------------------------------------------------
      IERR = 0
C                                       Class dependent create
C                                       Image
      IF (CLASS.EQ.'IMAGE') THEN
         CALL IMGCRE (NAME, IERR)
C                                       Uvdata
      ELSE IF (CLASS.EQ.'UVDATA  ') THEN
         CALL OUVCRE (NAME, IERR)
C                                       Table
      ELSE IF (CLASS.EQ.'TABLE   ') THEN
         CALL TABCRE (NAME, IERR)
C                                       CLEAN process
      ELSE IF (CLASS.EQ.'CLEAN   ') THEN
         CALL CLNCRE (NAME, IERR)
C                                       Complex Image
      ELSE IF (CLASS.EQ.'CX_IMAGE') THEN
         CALL CIMCRE (NAME, '        ', '        ', IERR)
C                                       Printer
      ELSE IF (CLASS.EQ.'PRINTER') THEN
         CALL PRTCRE (NAME, IERR)
C                                       Edit class
      ELSE IF (CLASS.EQ.'EDIT') THEN
         CALL EDICRE (NAME, IERR)
C                                       TV device
      ELSE IF (CLASS.EQ.'TVDEVICE') THEN
         CALL TVDCRE (NAME, IERR)
C                                       AP device
      ELSE IF (CLASS.EQ.'APDEVICE') THEN
         CALL APDCRE (NAME, IERR)
C                                       Generic create
      ELSE
         CALL OBCREA (NAME, CLASS, IERR)
         END IF
C
 999  RETURN
      END
      SUBROUTINE DESTRY (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Destroys the object with name "name"; quasi-permanent forms
C   are unaffected.
C   Inputs:
C      NAME  C*32  The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INTEGER  OBJNUM, CLASNO
      CHARACTER CNAME*8
C-----------------------------------------------------------------------
      IERR = 0
C                                       Object number
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Object class
      CALL OBCLAS (OBJNUM, CLASNO, CNAME, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Class dependent destroy
C                                       Image
      IF (CNAME.EQ.'IMAGE') THEN
         CALL IMGDES (NAME, IERR)
C                                       UV data
      ELSE IF (CNAME.EQ.'UVDATA  ') THEN
         CALL OUVDES (NAME, IERR)
C                                       Table
      ELSE IF (CNAME.EQ.'TABLE   ') THEN
         CALL TABDES (NAME, IERR)
C                                       CLEAN process
      ELSE IF (CNAME.EQ.'CLEAN   ') THEN
         CALL CLNDES (NAME, IERR)
C                                       Complex Image
      ELSE IF (CNAME.EQ.'CX_IMAGE') THEN
         CALL CIMDES (NAME, IERR)
C                                       Printer
      ELSE IF (CNAME.EQ.'PRINTER') THEN
         CALL PRTDES (NAME, IERR)
C                                       Edit clas
      ELSE IF (CNAME.EQ.'EDIT') THEN
         CALL EDIDES (NAME, IERR)
C                                       TV
      ELSE IF (CNAME.EQ.'TVDEVICE') THEN
         CALL TVDDES (NAME, IERR)
C                                       AP
      ELSE IF (CNAME.EQ.'APDEVICE') THEN
         CALL APDDES (NAME, IERR)
C                                       Generic destroy
      ELSE
         CALL OBFREE (NAME, IERR)
         END IF
C
 999  RETURN
      END
      SUBROUTINE ZAP (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Destroys the object with name "name"; quasi-permanent forms
C   are deleted.
C   Inputs:
C      NAME  C*32  The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INTEGER  OBJNUM, CLASNO
      CHARACTER CNAME*8
C-----------------------------------------------------------------------
      IERR = 0
C                                       Object number
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Object class
      CALL OBCLAS (OBJNUM, CLASNO, CNAME, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Class dependent zap
C                                       Image
      IF (CNAME.EQ.'IMAGE') THEN
         CALL IMGZAP (NAME, IERR)
C                                       UV data
      ELSE IF (CNAME.EQ.'UVDATA  ') THEN
         CALL OUVZAP (NAME, IERR)
C                                       Table
      ELSE IF (CNAME.EQ.'TABLE   ') THEN
         CALL TABZAP (NAME, IERR)
C                                       CLEAN process
      ELSE IF (CNAME.EQ.'CLEAN   ') THEN
         CALL CLNZAP (NAME, IERR)
C                                       Complex Image
      ELSE IF (CNAME.EQ.'CX_IMAGE') THEN
         CALL CIMZAP (NAME, IERR)
C                                       Printer
      ELSE IF (CNAME.EQ.'PRINTER') THEN
         CALL PRTZAP (NAME, IERR)
C                                       Edit class
      ELSE IF (CNAME.EQ.'EDIT') THEN
         CALL EDIZAP (NAME, IERR)
C                                       TV
      ELSE IF (CNAME.EQ.'TVDEVICE') THEN
         CALL TVDZAP (NAME, IERR)
C                                       AP
      ELSE IF (CNAME.EQ.'APDEVICE') THEN
         CALL APDZAP (NAME, IERR)
C                                       Generic destroy
      ELSE
         CALL OBFREE (NAME, IERR)
         END IF
C
 999  RETURN
      END
      SUBROUTINE OCOPY (NAMEIN, NAMOUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Copys one object to another.  The same quasi permanent forms are
C   used for both.
C   Inputs:
C      NAMEIN  C*32  The name of the input object.
C      NAMOUT  C*32  The name of the output object.
C   Output:
C      IERR    I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAMEIN*(*), NAMOUT*(*)
      INTEGER   IERR
C
      INTEGER  OBJNUM, CLASNO
      CHARACTER CNAME*8
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Object number
      CALL OBNAME (NAMEIN, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Object class
      CALL OBCLAS (OBJNUM, CLASNO, CNAME, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Class dependent copy
C                                       Image
      IF (CNAME.EQ.'IMAGE') THEN
         CALL IMGCOP (NAMEIN, NAMOUT, IERR)
C                                       UV data
      ELSE IF (CNAME.EQ.'UVDATA  ') THEN
         CALL OUVCOP (NAMEIN, NAMOUT, IERR)
C                                       Table
      ELSE IF (CNAME.EQ.'TABLE   ') THEN
         CALL TBCOPY (NAMEIN, NAMOUT, IERR)
C                                       CLEAN process - not defined
      ELSE IF (CNAME.EQ.'CLEAN   ') THEN
         MSGTXT = 'OCOPY: COPY NOT DEFINED FOR CLEAN CLASS'
         CALL MSGWRT (7)
         IERR = 1
C                                       Complex Image
      ELSE IF (CNAME.EQ.'CX_IMAGE') THEN
         CALL CIMCOP (NAMEIN, NAMOUT, IERR)
C                                       Generic copy
      ELSE
         CALL OBCOPY (NAMEIN, NAMOUT, IERR)
         END IF
C
 999  RETURN
      END
      SUBROUTINE OCLONE (NAMEIN, NAMOUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Clones an object.  A deep copy is made.
C   Inputs:
C      NAMEIN  C*?   The name of the input object.
C      NAMOUT  C*?   The name of the output object.
C   Output:
C      IERR    I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAMEIN*(*), NAMOUT*(*)
      INTEGER   IERR
C
      INTEGER  OBJNUM, CLASNO
      CHARACTER CNAME*8
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Object number
      CALL OBNAME (NAMEIN, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Object class
      CALL OBCLAS (OBJNUM, CLASNO, CNAME, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Class dependent clone
C                                       Image
      IF (CNAME.EQ.'IMAGE') THEN
         CALL IMGCLN (NAMEIN, NAMOUT, IERR)
C                                       UV data
      ELSE IF (CNAME.EQ.'UVDATA  ') THEN
         CALL OUVCLN (NAMEIN, NAMOUT, IERR)
C                                       Table
      ELSE IF (CNAME.EQ.'TABLE   ') THEN
         CALL TABCLN (NAMEIN, NAMOUT, IERR)
C                                       CLEAN process - not defined
      ELSE IF (CNAME.EQ.'CLEAN   ') THEN
         IERR = 1
         MSGTXT = 'OCLONE: CLONING NOT DEFINED FOR CLEAN CLASS'
         CALL MSGWRT (7)
C                                       Complex Image
      ELSE IF (CNAME.EQ.'CX_IMAGE') THEN
         CALL CIMCLN (NAMEIN, NAMOUT, IERR)
C                                       Generic copy
      ELSE
         CALL OBCOPY (NAMEIN, NAMOUT, IERR)
         END IF
C
 999  RETURN
      END
      SUBROUTINE OOPEN (NAME, STATUS, IERR)
C-----------------------------------------------------------------------
C   Public
C   Opens an object for access.  Obtains header info etc.
C   Inputs:
C      NAME   C*32  The name of the object.
C      STATUS C*4   'READ', 'WRIT', 'DEST' (write but destroy on
C                   failure).
C   Output:
C      IERR  I     Error return code, 0=OK, 5=data invalid
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), STATUS*4
      INTEGER   IERR
C
      INTEGER  OBJNUM, CLASNO
      CHARACTER CNAME*8
C-----------------------------------------------------------------------
      IERR = 0
C                                       Object number
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Object class
      CALL OBCLAS (OBJNUM, CLASNO, CNAME, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Class dependent open
C                                       Image
      IF (CNAME.EQ.'IMAGE') THEN
         CALL IMGOPN (NAME, STATUS, IERR)
C                                       UV data
      ELSE IF (CNAME.EQ.'UVDATA  ') THEN
         CALL OUVOPN (NAME, STATUS, IERR)
C                                       Table
      ELSE IF (CNAME.EQ.'TABLE   ') THEN
         CALL TABOPN (NAME, STATUS, IERR)
C                                       CLEAN process
      ELSE IF (CNAME.EQ.'CLEAN   ') THEN
         CALL CLNOPN (NAME, STATUS, IERR)
C                                       Complex Image
      ELSE IF (CNAME.EQ.'CX_IMAGE') THEN
         CALL CIMOPN (NAME, STATUS, IERR)
C                                       Printer
      ELSE IF (CNAME.EQ.'PRINTER') THEN
         CALL PRTOPN (NAME, STATUS, IERR)
C                                       Edit class
      ELSE IF (CNAME.EQ.'EDIT') THEN
         CALL EDIOPN (NAME, STATUS, IERR)
C                                       TV
      ELSE IF (CNAME.EQ.'TVDEVICE') THEN
         CALL TVDOPN (NAME, STATUS, IERR)
C                                       AP
      ELSE IF (CNAME.EQ.'APDEVICE') THEN
         CALL APDOPN (NAME, STATUS, IERR)
C                                       Generic open
      ELSE
         CALL OBOPEN (NAME, IERR)
         END IF
C
 999  RETURN
      END
      SUBROUTINE OCLOSE (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Closes object updating disk resident information.
C   Inputs:
C      NAME  C*?   The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INTEGER  OBJNUM, CLASNO
      CHARACTER CNAME*8
C-----------------------------------------------------------------------
      IERR = 0
C                                       Object number
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Object class
      CALL OBCLAS (OBJNUM, CLASNO, CNAME, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Class dependent close
C                                       Image
      IF (CNAME.EQ.'IMAGE') THEN
         CALL IMGCLO (NAME, IERR)
C                                       UV data
      ELSE IF (CNAME.EQ.'UVDATA') THEN
         CALL OUVCLO (NAME, IERR)
C                                       Table
      ELSE IF (CNAME.EQ.'TABLE   ') THEN
         CALL TABCLO (NAME, IERR)
C                                       CLEAN Process
      ELSE IF (CNAME.EQ.'CLEAN   ') THEN
         CALL CLNCLO (NAME, IERR)
C                                       Complex Image
      ELSE IF (CNAME.EQ.'CX_IMAGE') THEN
         CALL CIMCLO (NAME, IERR)
C                                       Printer
      ELSE IF (CNAME.EQ.'PRINTER') THEN
         CALL PRTCLO (NAME, IERR)
C                                       Edit class
      ELSE IF (CNAME.EQ.'EDIT') THEN
         CALL EDICLO (NAME, IERR)
C                                       TV
      ELSE IF (CNAME.EQ.'TVDEVICE') THEN
         CALL TVDCLO (NAME, IERR)
C                                       AP
      ELSE IF (CNAME.EQ.'APDEVICE') THEN
         CALL APDCLO (NAME, IERR)
C                                       Generic close
      ELSE
         CALL OBCLOS (NAME, IERR)
         END IF
C
 999  RETURN
      END
      SUBROUTINE OGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Returns the dimensionality and value(s) associated with a given
C   keyword.
C   Inputs:
C      NAME     C*?   The name of the object.
C      KEYWRD   C*?   The name of the keyword in form 'MEM1.MEM2...'
C   Outputs:
C      TYPE     I     Data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM      I(*)  Dimensionality of value, an axis dimension of zero
C                     means that that dimension and higher are
C                     undefined.
C      VALUE    ?(*)  The value associated with keyword.
C      VALUEC   C*?   Associated value (character)
C      IERR     I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC*(*)
      INTEGER   TYPE, DIM(*), VALUE(*), IERR
C
      INTEGER   OBJNUM, CLASNO
      CHARACTER CNAME*8
C-----------------------------------------------------------------------
      IERR = 0
C                                       Object number
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Object class
      CALL OBCLAS (OBJNUM, CLASNO, CNAME, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Class dependent close
C                                       Image
      IF (CNAME.EQ.'IMAGE') THEN
         CALL IMGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       UV data
      ELSE IF (CNAME.EQ.'UVDATA  ') THEN
         CALL OUVGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       CLEAN process
      ELSE IF (CNAME.EQ.'CLEAN   ') THEN
         CALL CLNGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       Complex Image
      ELSE IF (CNAME.EQ.'CX_IMAGE') THEN
         CALL CIGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       Table
      ELSE IF (CNAME.EQ.'TABLE   ') THEN
         CALL TABGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       Complex Image
      ELSE IF (CNAME.EQ.'CX_IMAGE') THEN
         CALL CIGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       Printer
      ELSE IF (CNAME.EQ.'PRINTER') THEN
         CALL PRTGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       Edit class
      ELSE IF (CNAME.EQ.'EDIT') THEN
         CALL EDIGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       TV
      ELSE IF (CNAME.EQ.'TVDEVICE') THEN
         CALL TVDGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       Generic get
      ELSE
         CALL OBGET (OBJNUM, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
         END IF
C
 999  RETURN
      END
      SUBROUTINE OPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Stores the dimensionality and value(s) associated with a given
C   keyword.
C   Inputs:
C      NAME     C*?   The name of the object.
C      KEYWRD   C*?   The name of the keyword in form 'MEM1.MEM2...'
C      TYPE     I     Data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM      I(*)  Dimensionality of value, an axis dimension of zero
C                     means that that dimension and higher are
C                     undefined.
C      VALUE    ?(*)  The value associated with keyword.
C      VALUEC   C*?   Associated value (character)
C   Outputs:
C      IERR     I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC*(*)
      INTEGER   TYPE, DIM(*), VALUE(*), IERR
C
      INTEGER   OBJNUM, CLASNO
      CHARACTER CNAME*8
C-----------------------------------------------------------------------
      IERR = 0
C                                       Object number
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Object class
      CALL OBCLAS (OBJNUM, CLASNO, CNAME, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Class dependent close
C                                       Image
      IF (CNAME.EQ.'IMAGE') THEN
         CALL IMPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       CLEAN process
      ELSE IF (CNAME.EQ.'CLEAN   ') THEN
         CALL CLNPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       Complex Image
      ELSE IF (CNAME.EQ.'CX_IMAGE') THEN
         CALL CIPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       Table
      ELSE IF (CNAME.EQ.'TABLE   ') THEN
         CALL TABPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       UV data
      ELSE IF (CNAME.EQ.'UVDATA  ') THEN
         CALL OUVPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       PRINTER
      ELSE IF (CNAME.EQ.'PRINTER') THEN
         CALL PRTPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       Edit class
      ELSE IF (CNAME.EQ.'EDIT') THEN
         CALL EDIPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       TV
      ELSE IF (CNAME.EQ.'TVDEVICE') THEN
         CALL TVDPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       Generic put
      ELSE
         CALL OBPUT (OBJNUM, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
         END IF
C
 999  RETURN
      END

      SUBROUTINE OPEXT (TYPE, IVOL, ISLOT, IVER, ILUN, EXCL, WAIT,
     *   IFIND, IERR)
C-----------------------------------------------------------------------
C! opens a specified extension file
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   OPEXT willl open a particular extension file.  If IVER is zero the
C   map file header willl be searched for the latest version no.  The
C   map header and parameters must be in common and the subroutine
C   VHDRIN must have been run.
C   Inputs:
C      TYPE   C*2  the extension file type (ie 'PL', 'SL', ect.).
C      IVOL   I    the disk volume no. of the extension file.
C      ISLOT  I    the catalog slot number of the map file.
C      ILUN   I    the logical unit number to use for the file.
C      EXCL   L    exclusive use flag.
C      WAIT   L    wait until available flag.
C   In/out:
C      IVER   I    the version number of the extension file ( 0
C                  means use latest in map header.) Returns used.
C   Outputs:
C      IFIND  I    the index to FTAB information.
C      IERR   I    error indicator. 0 = o.k.
C                     1 = could not build file name.
C                     2 = no extension file in map header.
C                     3 = could not open extension file: some error
C                     4 = could not open extension file: no file
C                     5 = could not open extension file: file too busy
C-----------------------------------------------------------------------
      CHARACTER TYPE*2
      INTEGER   IVOL, ISLOT, IVER, ILUN, IFIND, IERR
      LOGICAL   EXCL, WAIT
C
      INTEGER   I
      LOGICAL   NOMAP
      CHARACTER FILE*48
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA NOMAP /.FALSE./
C-----------------------------------------------------------------------
C                                       Find latest version no.
      IF (IVER.LE.0) CALL FNDEXT (TYPE, CATBLK, IVER)
C                                       Error Ext. file not in header.
      IF (IVER.LE.0) THEN
         WRITE (MSGTXT,1010)
         CALL MSGWRT (7)
         END IF
C                                       Build file name.
 20   CALL ZPHFIL (TYPE, IVOL, ISLOT, IVER, FILE, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) TYPE, IVOL, ISLOT, IVER
         CALL MSGWRT (7)
         IERR = 1
C                                       Open extension file.
      ELSE
         CALL ZOPEN (ILUN, IFIND, IVOL, FILE, NOMAP, EXCL, WAIT, I)
         IF (I.NE.0) THEN
            IERR = 3
            IF (I.EQ.2) IERR = 4
            IF (I.EQ.4) IERR = 5
            WRITE (MSGTXT,1030) I, TYPE, IVOL, ISLOT, IVER
            CALL MSGWRT (7)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ERROR. EXTENSION FILE NOT IN MAP HEADER.')
 1020 FORMAT ('ERROR. COULD NOT BUILD EXT. FILE NAME',A2,I4,I7,I7)
 1030 FORMAT ('ERROR',I4,' OPENING EXTENSION FILE ',A2,I1,I5,I4)
      END

      SUBROUTINE CHECK (SUBR, NUM, ASSERT, IRET)
C-----------------------------------------------------------------------
C! Assertion checking subroutine
C# UTIL
C-----------------------------------------------------------------------
C;  Copyright (C) 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Set IRET to 0 if ASSERT is true otherwise print a diagnostic
C   message and set IRET to a non-zero number.
C
C   Inputs:
C      SUBR     C*(*)       Name of subroutine in which assertion is
C                           made.
C      NUM      I           Checkpoint number
C      ASSERT   L           Assertion
C
C   Output:
C      IRET     I           Status: 0 - assertion true
C                                 999 - assertion false
C
C   Usage notes:
C      This subroutine is intended as a tool for uncovering logic flaws
C      in AIPS programs.  CHECK should be called with a boolean
C      expression that is assumed to hold at that point.  If the
C      expression evaluates to false then it can be inferred that there
C      is an error in the logic of the calling program.  To be of most
C      use in finding logic errors, each call to CHECK in a given
C      subroutine should be supplied with the name of the calling
C      subroutine and a unique checkpoint number, both of which will
C      be written to the message file should the assertion be false.
C
C      CHECK should not be used in computationally intensive code
C      neither should it be used to check conditions that may
C      legitimately be expected to be false during the normal
C      operation of a program (eg. ranges of user-supplied data).
C-----------------------------------------------------------------------
      CHARACTER SUBR*(*)
      INTEGER   NUM, IRET
      LOGICAL   ASSERT
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (ASSERT) THEN
         IRET = 0
      ELSE
         WRITE (MSGTXT, 1000) NUM, SUBR
         CALL MSGWRT (9)
         MSGTXT = 'An erroneous condition has been detected in this '
     *            // 'program. Report'
         CALL MSGWRT (9)
         MSGTXT = 'this message to the designated AIP and include '
     *            // 'the checkpoint'
         CALL MSGWRT (9)
         MSGTXT = 'information given above. Save the data on which '
     *            // 'you were working'
         CALL MSGWRT (9)
         MSGTXT = 'and record the task inputs in case they are needed '
     *            // 'to reproduce'
         CALL MSGWRT (9)
         MSGTXT = 'the problem.'
         CALL MSGWRT (9)
         IRET = 999
      END IF
C-----------------------------------------------------------------------
 1000 FORMAT ('ASSERTION ERROR: CHECKPOINT ', I3, ' IN ', A)
      END

      PROGRAM CLCOP
C-----------------------------------------------------------------------
C! Task to copy calibration in SN/CL tables between polarizations
C# EXT-util Utility Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2005, 2012, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  CLCOP copies AIPS SN/CL extension files, copying one polarization to
C  the other.  The specified output table should not exist before the
C  execution of CLCOP.
C  ADVERBS:
C    INNAME      Input image name (name)
C    INCLASS     Input image name (class)
C    INSEQ       Input image name (seq. #)
C    INDISK      Input image disk unit #
C    INEXT       Input table extension type
C    INVERS      Input table file version no.
C    OUTNAME     Output image name (name)
C    OUTCLASS    Output image name (class)
C    OUTSEQ      Output image name (seq. #)
C    OUTDISK     Output image disk unit #.
C    OUTVERS     Output table file version.
C    OPTYPE      'R2L', 'L2R', 'SWIT', 'AVER'
C    FPARM       IFs to average
C    VPARM       IFs to be replaced
C-----------------------------------------------------------------------
      HOLLERITH XNAMIN(3), XCLAIN(2), XNEXT(1), XOPTYP(1)
      CHARACTER NAMEIN*12, CLAIN*6, FTYPE*2, OPTYPE*4, PRGM*6, STAT*4,
     *   TABTYP*2, ATIME*8, ADATE*12, HILINE*72
      INTEGER  IRET, SEQIN, DISKIN, CNO, BUFF1(512), BUFF2(512), I,
     *   IERR, IVER, OVER, LUN1, LUN2, NPARM, IROUND, NOLDT, TIME(3),
     *   DATE(3), NA, NB, IA(30), IB(30), I1, I2
      REAL      XSEQIN, XDISKI, XIVER, FPARM(30), VPARM(30)
      LOGICAL   T
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /INPARM/ XNAMIN, XCLAIN, XSEQIN, XDISKI, XNEXT, XIVER,
     *   XOPTYP, FPARM, VPARM
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA PRGM /'CLCOP '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 70
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMIN, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMIN, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (2, 1, XNEXT, TABTYP)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      IF ((OPTYPE.NE.'R2L') .AND. (OPTYPE.NE.'L2R') .AND.
     *   (OPTYPE.NE.'SWIT') .AND. (OPTYPE.NE.'AVER')) THEN
         MSGTXT = '''' // OPTYPE // ''' UNRECOGNIZED - QUITTING'
         GO TO 990
         END IF
C                                       Crunch input parameters.
      SEQIN  = IROUND (XSEQIN)
      DISKIN = IROUND (XDISKI)
      IVER   = IROUND (XIVER)
      IF (TABTYP.NE.'CL') TABTYP = 'SN'
C                                       Find input
      CNO = 1
      FTYPE = ' '
      CALL CATDIR ('SRCH', DISKIN, CNO, NAMEIN, CLAIN, SEQIN, FTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read old CATBLK and mark 'WRIT'
      CALL CATIO ('READ', DISKIN, CNO, CATBLK, 'WRIT', BUFF1, IERR)
      IF ((IERR.GT.0) .AND. (IERR.LT.5)) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 1
C                                       Check number of tables
      CALL FNDEXT (TABTYP, CATBLK, NOLDT)
C                                       use highest version if IVER = 0
      IF (IVER.LE.0) IVER = NOLDT
      OVER = NOLDT + 1
C                                       Copy table: IF averaging
      IF (OPTYPE.EQ.'AVER') THEN
         NA = 30
         NB = 30
         DO 10 I = 1,30
            IA(I) = IROUND (FPARM(I))
            IB(I) = IROUND (VPARM(I))
            IF (IA(I).LE.0) NA = MIN (NA, I-1)
            IF (IB(I).LE.0) NB = MIN (NB, I-1)
 10         CONTINUE
         IF ((NA.LE.0) .OR. (NB.LE.0)) THEN
            MSGTXT = 'YOU MUST SPECIFY IFS IN APARM AND BPARM'
            IRET = 10
            GO TO 990
            END IF
         IF (TABTYP.EQ.'CL') THEN
            CALL CLAVR (NA, IA, NB, IB, IVER, OVER, LUN1, LUN2, DISKIN,
     *         CNO, BUFF1, BUFF2, IRET)
         ELSE
            CALL SNAVR (NA, IA, NB, IB, IVER, OVER, LUN1, LUN2, DISKIN,
     *         CNO, BUFF1, BUFF2, IRET)
            END IF
      ELSE
         IF (TABTYP.EQ.'CL') THEN
            CALL CLCOPR (OPTYPE, IVER, OVER, LUN1, LUN2, DISKIN, CNO,
     *         BUFF1, BUFF2, IRET)
         ELSE
            CALL SNCOPR (OPTYPE, IVER, OVER, LUN1, LUN2, DISKIN, CNO,
     *         BUFF1, BUFF2, IRET)
            END IF
         END IF
      IF (IRET.NE.0) THEN
         IF (IRET.EQ.1) THEN
            MSGTXT = 'INPUT AND OUTPUT TABLES ARE THE SAME.'
         ELSE IF (IRET.EQ.6) THEN
            MSGTXT = 'OUTPUT TABLE ALREADY EXISTS'
         ELSE
            WRITE (MSGTXT,1085) IRET, IVER
            END IF
         GO TO 990
         END IF
C                                       Finished copying tables
      IRET = 0
C                                       Add history to output
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN1, DISKIN, CNO, BUFF1, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1090) IERR
         CALL MSGWRT (6)
         GO TO 150
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
      WRITE (HILINE,1100) TSKNAM, RLSNAM, ADATE, ATIME
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
C                                       Input file
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN1, BUFF1,
     *   IERR)
      IF (IERR.NE.0) GO TO 150
C                                       Type and version
      WRITE (HILINE,2000) TSKNAM, TABTYP, IVER, OVER
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
C                                       OPTYPE
      WRITE (HILINE,2001) TSKNAM, OPTYPE
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
      IF (OPTYPE.EQ.'AVER') THEN
         HILINE = TSKNAM // '/  IFs averaged'
         CALL HIADD (LUN1, HILINE, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 150
         I1 = 1
 20      I2 = MIN (NA, I1+4)
         IF (I1.LE.I2) THEN
            WRITE (HILINE,2020) TSKNAM, (IA(I), I = I1,I2)
            CALL HIADD (LUN1, HILINE, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 150
            I1 = I2 + 1
            GO TO 20
            END IF
         HILINE = TSKNAM // '/  IFs replaced'
         CALL HIADD (LUN1, HILINE, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 150
         I1 = 1
 30      I2 = MIN (NB, I1+4)
         IF (I1.LE.I2) THEN
            WRITE (HILINE,2020) TSKNAM, (IB(I), I = I1,I2)
            CALL HIADD (LUN1, HILINE, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 150
            I1 = I2 + 1
            GO TO 30
            END IF
         END IF
C                                       Close HI file
 150  CALL HICLOS (LUN1, T, BUFF1, IERR)
      GO TO 995
C                                       Error
 990  CALL MSGWRT (8)
C                                       Close down files, etc
 995  CALL DIE (IRET, BUFF1)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' GETING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1085 FORMAT ('ERROR ',I4,' COPYING TABLE ',I5)
 1090 FORMAT ('ERROR',I3,' OPENING HISTORY FILE')
 1100 FORMAT (A6,'Release =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 2000 FORMAT (A6,'INEXT=''',A2,''' INVERS=',I4,' OUTVERS=', I4)
 2001 FORMAT (A6,'OPTYPE=''',A,''' / what was inverted')
 2020 FORMAT (A6,'FPARM=',5(I3,','))
      END
      SUBROUTINE CLCOPR (OP, INVER, OUTVER, LUNOLD, LUNNEW, VOL, CNO,
     *   BUFF1, BUFF2, IRET)
C-----------------------------------------------------------------------
C   Routine to invert the calibration of a CL table.
C   Inputs:
C      OP       C*4     What to invert 'BOTH', 'PHAS', 'AMPL'
C      INVER    I       Version number to copy.
C      OUTVER   I       Version number on output file
C      LUNOLD   I       LUN for old file
C      LUNNEW   I       LUN for new file
C      VOL      I       Disk number for both files.
C      CNO      I       Catalog slot number for both files
C   Output:
C      BUFF1    I(512)  Work buffer
C      BUFF2    I(512)  Work buffer
C      IRET     I       Return error code  0 => ok
C                          1 => files the same, no copy.
C                          2 => no input files exist
C                          3 => failed
C                          4 => no output files created.
C                          5 => failed to update CATNEW
C                          6 => output file exists
C-----------------------------------------------------------------------
      INTEGER   INVER, OUTVER, LUNOLD, LUNNEW, VOL, CNO, BUFF1(*),
     *   BUFF2(*), IRET
      CHARACTER OP*4
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ICLRNO, CLKOLS(MAXCLC), CLNUMV(MAXCLC), NUMANT, NPOLI,
     *   NUMIF, NTERM, OKOLS(MAXCLC), ONUMV(MAXCLC), NCLROW, I, SOURID,
     *   ANTNO, SUBA, FREQID, REFA(2,MAXIF), OCLRNO, IIF, NPOLO, IREF
      REAL      TIMEI, IFR, DOPOFF(MAXIF), ATMOS, DATMOS, MBDELY(2),
     *   CLOCK(2), DCLOCK(2), DISP(2), DDISP(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF),
     *   WEIGHT(2,MAXIF), GMMOD, CR, CI
      LOGICAL   TABLE, EXIST, FITASC
      DOUBLE PRECISION TIME, GEODLY(20)
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Check existance
      IF (OUTVER.GT.0) THEN
         CALL ISTAB ('CL', VOL, CNO, OUTVER, LUNNEW, BUFF2, TABLE,
     *      EXIST, FITASC, IRET)
         IF (EXIST) THEN
            IRET = 6
            GO TO 999
            END IF
         END IF
C                                       Open CL file
      CALL CALINI ('READ', BUFF1, VOL, CNO, INVER, CATBLK, LUNOLD,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NPOLI, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
      IF (NPOLI.NE.2) THEN
         MSGTXT = 'Input CL table only has one polarization -> R2L'
         CALL MSGWRT (6)
         OP = 'R2L'
         END IF
C                                       # rows in old table
      NCLROW = BUFF1(5)
      NPOLO = 2
C                                       Open up new CL table
      CALL CALINI ('WRIT', BUFF2, VOL, CNO, OUTVER, CATBLK, LUNNEW,
     *   OCLRNO, OKOLS, ONUMV, NUMANT, NPOLO, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 800 I = 1,NCLROW
         ICLRNO = I
         CALL TABCAL ('READ', BUFF1, ICLRNO, CLKOLS, CLNUMV, NPOLI,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
C                                       Deselected record.
         IF (IRET.LT.0) GO TO 800
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1030) IRET
            GO TO 990
            END IF
C                                       Switch
         IF (OP.EQ.'SWIT') THEN
            CR = MBDELY(1)
            MBDELY(1) = MBDELY(2)
            MBDELY(2) = CR
            CR = CLOCK(1)
            CLOCK(1) = CLOCK(2)
            CLOCK(2) = CR
            CR = DCLOCK(1)
            DCLOCK(1) = DCLOCK(2)
            DCLOCK(2) = CR
            CR = DISP(1)
            DISP(1) = DISP(2)
            DISP(2) = CR
            CR = DDISP(1)
            DDISP(1) = DDISP(2)
            DDISP(2) = CR
            DO 45 IIF = 1,NUMIF
               CR = CREAL(1,IIF)
               CI = CIMAG(1,IIF)
               CREAL(1,IIF) = CREAL(2,IIF)
               CIMAG(1,IIF) = CIMAG(2,IIF)
               CREAL(2,IIF) = CR
               CIMAG(2,IIF) = CI
               CR = DELAY(1,IIF)
               DELAY(1,IIF) = DELAY(2,IIF)
               DELAY(2,IIF) = CR
               CI = RATE(1,IIF)
               RATE(1,IIF) = RATE(2,IIF)
               RATE(2,IIF) = CI
               IREF = REFA(1,IIF)
               REFA(1,IIF) = REFA(2,IIF)
               REFA(2,IIF) = IREF
               CR = WEIGHT(1,IIF)
               WEIGHT(1,IIF) = WEIGHT(2,IIF)
               WEIGHT(2,IIF) = CR
 45            CONTINUE
C                                       right to left
         ELSE IF (OP.EQ.'R2L') THEN
            MBDELY(2) = MBDELY(1)
            CLOCK(2) = CLOCK(1)
            DCLOCK(2) = DCLOCK(1)
            DISP(2) = DISP(1)
            DDISP(2) = DDISP(1)
            DO 55 IIF = 1,NUMIF
               CREAL(2,IIF) = CREAL(1,IIF)
               CIMAG(2,IIF) = CIMAG(1,IIF)
               DELAY(2,IIF) = DELAY(1,IIF)
               RATE(2,IIF) = RATE(1,IIF)
               REFA(2,IIF) = REFA(1,IIF)
               WEIGHT(2,IIF) = WEIGHT(1,IIF)
 55            CONTINUE
C                                       left to right
         ELSE
            MBDELY(1) = MBDELY(2)
            CLOCK(1) = CLOCK(2)
            DCLOCK(1) = DCLOCK(2)
            DISP(1) = DISP(2)
            DDISP(1) = DDISP(2)
            DO 65 IIF = 1,NUMIF
               CREAL(1,IIF) = CREAL(2,IIF)
               CIMAG(1,IIF) = CIMAG(2,IIF)
               DELAY(1,IIF) = DELAY(2,IIF)
               RATE(1,IIF) = RATE(2,IIF)
               REFA(1,IIF) = REFA(2,IIF)
               WEIGHT(1,IIF) = WEIGHT(2,IIF)
 65            CONTINUE
            END IF
C                                       Write new table.
         CALL TABCAL ('WRIT', BUFF2, OCLRNO, OKOLS, ONUMV, NPOLO,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1040) IRET
            GO TO 990
            END IF
 800     CONTINUE
      IRET = 0
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ICLRNO, BUFF1, BUFF1, IRET)
      CALL TABIO ('CLOS', 0, OCLRNO, BUFF2, BUFF2, IRET)
      WRITE (MSGTXT,1050) OP, VOL, CNO, INVER, OUTVER
      CALL MSGWRT (3)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('CLCOPR: ERROR ',I3,' INITING OLD TABLE')
 1020 FORMAT ('CLCOPR: ERROR ',I3,' INITING NEW TABLE')
 1030 FORMAT ('CLCOPR: ERROR ',I3,' READING OLD TABLE')
 1040 FORMAT ('CLCOPR: ERROR ',I3,' WRITING NEW TABLE')
 1050 FORMAT ('CL copied ',A,' from vol,cno, vers',I3,I5,I4,
     *   ' to vers',I4)
      END
      SUBROUTINE SNCOPR (OP, INVER, OUTVER, LUNOLD, LUNNEW, VOL, CNO,
     *   BUFF1, BUFF2, IRET)
C-----------------------------------------------------------------------
C   Routine to invert the calibration of a SN table.
C   Inputs:
C      OP       C*4     What to invert 'BOTH', 'PHAS', 'AMPL'
C      INVER    I       Version number to copy.
C      OUTVER   I       Version number on output file
C      LUNOLD   I       LUN for old file
C      LUNNEW   I       LUN for new file
C      VOL      I       Disk number for both files.
C      CNO      I       Catalog slot number for both files
C   Output:
C      BUFF1    I(512)  Work buffer
C      BUFF2    I(512)  Work buffer
C      IRET     I       Return error code  0 => ok
C                          1 => files the same, no copy.
C                          2 => no input files exist
C                          3 => failed
C                          4 => no output files created.
C                          5 => failed to update CATNEW
C                          6 => output file exists
C-----------------------------------------------------------------------
      INTEGER   INVER, OUTVER, LUNOLD, LUNNEW, VOL, CNO, BUFF1(*),
     *   BUFF2(*), IRET
      CHARACTER OP*4
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ISNRNO, SNKOLS(MAXSNC), SNNUMV(MAXSNC), NUMANT, NPOLI,
     *   NUMIF, OKOLS(MAXSNC), ONUMV(MAXSNC), NSNROW, I, SOURID, NUMNOD,
     *   ANTNO, SUBA, FREQID, REFA(2,MAXIF), OSNRNO, IIF, NODENO, NPOLO,
     *   IREF
      REAL    GMMOD, RANOD(25), DECNOD(25), TIMEI, IFR, MBDELY(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), DISP(2),
     *   RATE(2,MAXIF), WEIGHT(2,MAXIF), CR, CI, DDISP(2)
      LOGICAL   TABLE, EXIST, FITASC, ISAPPL
      DOUBLE PRECISION TIME
      INCLUDE 'INCS:PSNTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Check existance
      IF (OUTVER.GT.0) THEN
         CALL ISTAB ('SN', VOL, CNO, OUTVER, LUNNEW, BUFF2, TABLE,
     *      EXIST, FITASC, IRET)
         IF (EXIST) THEN
            IRET = 6
            GO TO 999
            END IF
         END IF
C                                       Open SN file
      CALL SNINI ('READ', BUFF1, VOL, CNO, INVER, CATBLK, LUNOLD,
     *   ISNRNO, SNKOLS, SNNUMV, NUMANT, NPOLI, NUMIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
      IF (NPOLI.NE.2) THEN
         MSGTXT = 'Input SN table only has one polarization -> R2L'
         CALL MSGWRT (6)
         OP = 'R2L'
         END IF
C                                       # rows in old table
      NSNROW = BUFF1(5)
      npolo = 2
C                                       Open up new SN table
      CALL SNINI ('WRIT', BUFF2, VOL, CNO, OUTVER, CATBLK, LUNNEW,
     *   OSNRNO, OKOLS, ONUMV, NUMANT, NPOLO, NUMIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 800 I = 1,NSNROW
         ISNRNO = I
         CALL TABSN ('READ', BUFF1, ISNRNO, SNKOLS, SNNUMV, NPOLI,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
C                                       Deselected record.
         IF (IRET.LT.0) GO TO 800
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1030) IRET
            GO TO 990
            END IF
C                                       Switch
         IF (OP.EQ.'SWIT') THEN
            CR = MBDELY(1)
            MBDELY(1) = MBDELY(2)
            MBDELY(2) = CR
            CR = DISP(1)
            DISP(1) = DISP(2)
            DISP(2) = CR
            CR = DDISP(1)
            DDISP(1) = DDISP(2)
            DDISP(2) = CR
            DO 45 IIF = 1,NUMIF
               CR = CREAL(1,IIF)
               CI = CIMAG(1,IIF)
               CREAL(1,IIF) = CREAL(2,IIF)
               CIMAG(1,IIF) = CIMAG(2,IIF)
               CREAL(2,IIF) = CR
               CIMAG(2,IIF) = CI
               CR = DELAY(1,IIF)
               DELAY(1,IIF) = DELAY(2,IIF)
               DELAY(2,IIF) = CR
               CI = RATE(1,IIF)
               RATE(1,IIF) = RATE(2,IIF)
               RATE(2,IIF) = CI
               CI = WEIGHT(1,IIF)
               WEIGHT(1,IIF) = WEIGHT(2,IIF)
               WEIGHT(2,IIF) = CI
               IREF = REFA(1,IIF)
               REFA(1,IIF) = REFA(2,IIF)
               REFA(2,IIF) = IREF
 45            CONTINUE
C                                       right to left
         ELSE IF (OP.EQ.'R2L') THEN
            MBDELY(2) = MBDELY(1)
            DISP(2) = DISP(1)
            DDISP(2) = DDISP(1)
            DO 55 IIF = 1,NUMIF
               CREAL(2,IIF) = CREAL(1,IIF)
               CIMAG(2,IIF) = CIMAG(1,IIF)
               DELAY(2,IIF) = DELAY(1,IIF)
               RATE(2,IIF) = RATE(1,IIF)
               REFA(2,IIF) = REFA(1,IIF)
               WEIGHT(2,IIF) = WEIGHT(1,IIF)
 55            CONTINUE
C                                       left to right
         ELSE
            MBDELY(1) = MBDELY(2)
            DISP(1) = DISP(2)
            DDISP(1) = DDISP(2)
            DO 65 IIF = 1,NUMIF
               CREAL(1,IIF) = CREAL(2,IIF)
               CIMAG(1,IIF) = CIMAG(2,IIF)
               DELAY(1,IIF) = DELAY(2,IIF)
               RATE(1,IIF) = RATE(2,IIF)
               REFA(1,IIF) = REFA(2,IIF)
               WEIGHT(1,IIF) = WEIGHT(2,IIF)
 65            CONTINUE
            END IF
C                                       Write new table.
         CALL TABSN ('WRIT', BUFF2, OSNRNO, OKOLS, ONUMV, NPOLO,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1040) IRET
            GO TO 990
            END IF
 800     CONTINUE
      IRET = 0
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ISNRNO, BUFF1, BUFF1, IRET)
      CALL TABIO ('CLOS', 0, OSNRNO, BUFF2, BUFF2, IRET)
      WRITE (MSGTXT,1050) OP, VOL, CNO, INVER, OUTVER
      CALL MSGWRT (3)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SNINVR: ERROR ',I3,' INITING OLD TABLE')
 1020 FORMAT ('SNINVR: ERROR ',I3,' INITING NEW TABLE')
 1030 FORMAT ('SNINVR: ERROR ',I3,' READING OLD TABLE')
 1040 FORMAT ('SNINVR: ERROR ',I3,' WRITING NEW TABLE')
 1050 FORMAT ('SN copied ',A,' from vol, cno, vers',I3,I5,I4,
     *   ' to vers',I4)
      END
      SUBROUTINE CLAVR (NA, IA, NB, IB, INVER, OUTVER, LUNOLD, LUNNEW,
     *   VOL, CNO, BUFF1, BUFF2, IRET)
C-----------------------------------------------------------------------
C   Routine to invert the calibration of a CL table.
C   Inputs:
C      NA       I       Number in IA
C      IA       I(*)    IFs to average
C      NB       I       Number in IB
C      IB       I(*)    IFs to replace
C      INVER    I       Version number to copy.
C      OUTVER   I       Version number on output file
C      LUNOLD   I       LUN for old file
C      LUNNEW   I       LUN for new file
C      VOL      I       Disk number for both files.
C      CNO      I       Catalog slot number for both files
C   Output:
C      BUFF1    I(512)  Work buffer
C      BUFF2    I(512)  Work buffer
C      IRET     I       Return error code  0 => ok
C                          1 => files the same, no copy.
C                          2 => no input files exist
C                          3 => failed
C                          4 => no output files created.
C                          5 => failed to update CATNEW
C                          6 => output file exists
C-----------------------------------------------------------------------
      INTEGER   NA, IA(*), NB, IB(*), INVER, OUTVER, LUNOLD, LUNNEW,
     *   VOL, CNO, BUFF1(*), BUFF2(*), IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ICLRNO, CLKOLS(MAXCLC), CLNUMV(MAXCLC), NUMANT, NPOLI,
     *   NUMIF, NTERM, OKOLS(MAXCLC), ONUMV(MAXCLC), NCLROW, I, SOURID,
     *   ANTNO, SUBA, FREQID, REFA(2,MAXIF), OCLRNO, NPOLO, IREF,
     *   NS(5), J, K, IPOL
      REAL      TIMEI, IFR, DOPOFF(MAXIF), ATMOS, DATMOS, MBDELY(2),
     *   CLOCK(2), DCLOCK(2), DISP(2), DDISP(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF),
     *   WEIGHT(2,MAXIF), GMMOD, SUMS(5)
      LOGICAL   TABLE, EXIST, FITASC
      DOUBLE PRECISION TIME, GEODLY(20)
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Check existance
      IF (OUTVER.GT.0) THEN
         CALL ISTAB ('CL', VOL, CNO, OUTVER, LUNNEW, BUFF2, TABLE,
     *      EXIST, FITASC, IRET)
         IF (EXIST) THEN
            IRET = 6
            GO TO 999
            END IF
         END IF
C                                       Open CL file
      CALL CALINI ('READ', BUFF1, VOL, CNO, INVER, CATBLK, LUNOLD,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NPOLI, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       # rows in old table
      NCLROW = BUFF1(5)
      NPOLO = NPOLI
C                                       Open up new CL table
      CALL CALINI ('WRIT', BUFF2, VOL, CNO, OUTVER, CATBLK, LUNNEW,
     *   OCLRNO, OKOLS, ONUMV, NUMANT, NPOLO, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 100 K = 1,NCLROW
         ICLRNO = K
         CALL TABCAL ('READ', BUFF1, ICLRNO, CLKOLS, CLNUMV, NPOLI,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
C                                       Deselected record.
         IF (IRET.LT.0) GO TO 100
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1030) IRET
            GO TO 990
            END IF
C                                       sum
         DO 30 IPOL = 1,NPOLI
            CALL FILL (5, 0, NS)
            CALL RFILL (5, 0.0, SUMS)
            DO 10 I = 1,NA
               J = IA(I)
               IF ((WEIGHT(IPOL,J).GT.0.0) .AND.
     *            (WEIGHT(IPOL,J).NE.FBLANK)) THEN
                  IF (CREAL(IPOL,J).NE.FBLANK) THEN
                     SUMS(1) = SUMS(1) + CREAL(IPOL,J)
                     NS(1) = NS(1) + 1
                     END IF
                  IF (CIMAG(IPOL,J).NE.FBLANK) THEN
                     SUMS(2) = SUMS(2) + CIMAG(IPOL,J)
                     NS(2) = NS(2) + 1
                     END IF
                  IF (DELAY(IPOL,J).NE.FBLANK) THEN
                     SUMS(3) = SUMS(3) + DELAY(IPOL,J)
                     NS(3) = NS(3) + 1
                     END IF
                  IF (RATE(IPOL,J).NE.FBLANK) THEN
                     SUMS(4) = SUMS(4) + RATE(IPOL,J)
                     NS(4) = NS(4) + 1
                     END IF
                  SUMS(5) = SUMS(5) + WEIGHT(IPOL,J)
                  NS(5) = NS(5) + 1
                  END IF
 10            CONTINUE
C                                       average
            IF (NS(1).GT.0) THEN
               SUMS(1) = SUMS(1) / NS(1)
            ELSE
               SUMS(1) = FBLANK
               END IF
            IF (NS(2).GT.0) THEN
               SUMS(2) = SUMS(2) / NS(2)
            ELSE
               SUMS(2) = FBLANK
               END IF
            IF (NS(3).GT.0) THEN
               SUMS(3) = SUMS(3) / NS(3)
            ELSE
               SUMS(3) = FBLANK
               END IF
            IF (NS(4).GT.0) THEN
               SUMS(4) = SUMS(4) / NS(4)
            ELSE
               SUMS(4) = FBLANK
               END IF
            IF (NS(5).GT.0) THEN
               SUMS(5) = SUMS(5) / NS(5)
            ELSE
               SUMS(5) = FBLANK
               END IF
            IREF = REFA(IPOL,IA(1))
C                                       replace
            DO 20 I = 1,NB
               J = IB(I)
               REFA(IPOL,J) = IREF
               CREAL(IPOL,J) = SUMS(1)
               CIMAG(IPOL,J) = SUMS(2)
               DELAY(IPOL,J) = SUMS(3)
               RATE(IPOL,J)  = SUMS(4)
               WEIGHT(IPOL,J) = SUMS(5)
 20            CONTINUE
 30         CONTINUE
C                                       Write new table.
         CALL TABCAL ('WRIT', BUFF2, OCLRNO, OKOLS, ONUMV, NPOLO,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1040) IRET
            GO TO 990
            END IF
 100     CONTINUE
      IRET = 0
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ICLRNO, BUFF1, BUFF1, IRET)
      CALL TABIO ('CLOS', 0, OCLRNO, BUFF2, BUFF2, IRET)
      WRITE (MSGTXT,1050) 'AVER', VOL, CNO, INVER, OUTVER
      CALL MSGWRT (3)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('CLAVR: ERROR ',I3,' INITING OLD TABLE')
 1020 FORMAT ('CLAVR: ERROR ',I3,' INITING NEW TABLE')
 1030 FORMAT ('CLAVR: ERROR ',I3,' READING OLD TABLE')
 1040 FORMAT ('CLAVR: ERROR ',I3,' WRITING NEW TABLE')
 1050 FORMAT ('CL copied ',A,' from vol,cno, vers',I3,I5,I4,
     *   ' to vers',I4)
      END
      SUBROUTINE SNAVR (NA, IA, NB, IB, INVER, OUTVER, LUNOLD, LUNNEW,
     *   VOL, CNO, BUFF1, BUFF2, IRET)
C-----------------------------------------------------------------------
C   Routine to invert the calibration of a SN table.
C   Inputs:
C      NA       I       Number in IA
C      IA       I(*)    IFs to average
C      NB       I       Number in IB
C      IB       I(*)    IFs to replace
C      INVER    I       Version number to copy.
C      OUTVER   I       Version number on output file
C      LUNOLD   I       LUN for old file
C      LUNNEW   I       LUN for new file
C      VOL      I       Disk number for both files.
C      CNO      I       Catalog slot number for both files
C   Output:
C      BUFF1    I(512)  Work buffer
C      BUFF2    I(512)  Work buffer
C      IRET     I       Return error code  0 => ok
C                          1 => files the same, no copy.
C                          2 => no input files exist
C                          3 => failed
C                          4 => no output files created.
C                          5 => failed to update CATNEW
C                          6 => output file exists
C-----------------------------------------------------------------------
      INTEGER   NA, IA(*), NB, IB(*), INVER, OUTVER, LUNOLD, LUNNEW,
     *   VOL, CNO, BUFF1(*), BUFF2(*), IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ISNRNO, SNKOLS(MAXSNC), SNNUMV(MAXSNC), NUMANT, NPOLI,
     *   NUMIF, OKOLS(MAXSNC), ONUMV(MAXSNC), NSNROW, I, SOURID, NUMNOD,
     *   ANTNO, SUBA, FREQID, REFA(2,MAXIF), OSNRNO, NODENO, NPOLO,
     *   IREF, NS(5), J, K, IPOL
      REAL    GMMOD, RANOD(25), DECNOD(25), TIMEI, IFR, MBDELY(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), DISP(2),
     *   RATE(2,MAXIF), WEIGHT(2,MAXIF), SUMS(5), DDISP(2)
      LOGICAL   TABLE, EXIST, FITASC, ISAPPL
      DOUBLE PRECISION TIME
      INCLUDE 'INCS:PSNTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Check existance
      IF (OUTVER.GT.0) THEN
         CALL ISTAB ('SN', VOL, CNO, OUTVER, LUNNEW, BUFF2, TABLE,
     *      EXIST, FITASC, IRET)
         IF (EXIST) THEN
            IRET = 6
            GO TO 999
            END IF
         END IF
C                                       Open SN file
      CALL SNINI ('READ', BUFF1, VOL, CNO, INVER, CATBLK, LUNOLD,
     *   ISNRNO, SNKOLS, SNNUMV, NUMANT, NPOLI, NUMIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       # rows in old table
      NSNROW = BUFF1(5)
      NPOLO = NPOLI
C                                       Open up new SN table
      CALL SNINI ('WRIT', BUFF2, VOL, CNO, OUTVER, CATBLK, LUNNEW,
     *   OSNRNO, OKOLS, ONUMV, NUMANT, NPOLO, NUMIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 100 K = 1,NSNROW
         ISNRNO = K
         CALL TABSN ('READ', BUFF1, ISNRNO, SNKOLS, SNNUMV, NPOLI,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
C                                       Deselected record.
         IF (IRET.LT.0) GO TO 100
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1030) IRET
            GO TO 990
            END IF
C                                       sum
         DO 30 IPOL = 1,NPOLI
            CALL FILL (5, 0, NS)
            CALL RFILL (5, 0.0, SUMS)
            DO 10 I = 1,NA
               J = IA(I)
               IF ((WEIGHT(IPOL,J).GT.0.0) .AND.
     *            (WEIGHT(IPOL,J).NE.FBLANK)) THEN
                  IF (CREAL(IPOL,J).NE.FBLANK) THEN
                     SUMS(1) = SUMS(1) + CREAL(IPOL,J)
                     NS(1) = NS(1) + 1
                     END IF
                  IF (CIMAG(IPOL,J).NE.FBLANK) THEN
                     SUMS(2) = SUMS(2) + CIMAG(IPOL,J)
                     NS(2) = NS(2) + 1
                     END IF
                  IF (DELAY(IPOL,J).NE.FBLANK) THEN
                     SUMS(3) = SUMS(3) + DELAY(IPOL,J)
                     NS(3) = NS(3) + 1
                     END IF
                  IF (RATE(IPOL,J).NE.FBLANK) THEN
                     SUMS(4) = SUMS(4) + RATE(IPOL,J)
                     NS(4) = NS(4) + 1
                     END IF
                  SUMS(5) = SUMS(5) + WEIGHT(IPOL,J)
                  NS(5) = NS(5) + 1
                  END IF
 10            CONTINUE
C                                       average
            IF (NS(1).GT.0) THEN
               SUMS(1) = SUMS(1) / NS(1)
            ELSE
               SUMS(1) = FBLANK
               END IF
            IF (NS(2).GT.0) THEN
               SUMS(2) = SUMS(2) / NS(2)
            ELSE
               SUMS(2) = FBLANK
               END IF
            IF (NS(3).GT.0) THEN
               SUMS(3) = SUMS(3) / NS(3)
            ELSE
               SUMS(3) = FBLANK
               END IF
            IF (NS(4).GT.0) THEN
               SUMS(4) = SUMS(4) / NS(4)
            ELSE
               SUMS(4) = FBLANK
               END IF
            IF (NS(5).GT.0) THEN
               SUMS(5) = SUMS(5) / NS(5)
            ELSE
               SUMS(5) = FBLANK
               END IF
            IREF = REFA(IPOL,IA(1))
C                                       replace
            DO 20 I = 1,NB
               J = IB(I)
               REFA(IPOL,J) = IREF
               CREAL(IPOL,J) = SUMS(1)
               CIMAG(IPOL,J) = SUMS(2)
               DELAY(IPOL,J) = SUMS(3)
               RATE(IPOL,J)  = SUMS(4)
               WEIGHT(IPOL,J) = SUMS(5)
 20            CONTINUE
 30         CONTINUE
C                                       Write new table.
         CALL TABSN ('WRIT', BUFF2, OSNRNO, OKOLS, ONUMV, NPOLO,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1040) IRET
            GO TO 990
            END IF
 100     CONTINUE
      IRET = 0
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ISNRNO, BUFF1, BUFF1, IRET)
      CALL TABIO ('CLOS', 0, OSNRNO, BUFF2, BUFF2, IRET)
      WRITE (MSGTXT,1050) 'AVER', VOL, CNO, INVER, OUTVER
      CALL MSGWRT (3)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SNAVR: ERROR ',I3,' INITING OLD TABLE')
 1020 FORMAT ('SNAVR: ERROR ',I3,' INITING NEW TABLE')
 1030 FORMAT ('SNAVR: ERROR ',I3,' READING OLD TABLE')
 1040 FORMAT ('SNAVR: ERROR ',I3,' WRITING NEW TABLE')
 1050 FORMAT ('SN copied ',A,' from vol, cno, vers',I3,I5,I4,
     *   ' to vers',I4)
      END

LOCAL INCLUDE 'RSTOR.INC'
      INCLUDE 'INCS:PMAD.INC'
      INCLUDE 'INCS:PUVD.INC'
C                                       Local include for RSTOR
      REAL   GAIN, FMIN, FLUX, RESMAX, MAPLIM, GAUSA, GAUSB, GAUSC,
     *   GAUSAA, GAUSBB, GAUSCC, PHAT, FACTOR, XSPACE, YSPACE, MAPROT,
     *   SPEXP, TVFMAX, TVFMIN, TVREMX, TVREMN,
     *   BUFF1(MABFSL), BUFF2(MABFSL), BUFF3(MABFSL)
      CHARACTER BEMFIL*48, RESFIL*48, WTFIL*48, GRDFIL*48,
     *   DRTFIL*48, WRKFIL*48, CLNFIL*48
      LOGICAL   NOFIT
      INTEGER   PRECLN, CLNLST, CLNSTR, CLNLIM, PTRJ, PTRK,
     *   BMHIS(129), RESHIS(1050)
      INTEGER   NX, NY, PATCH, MAXPCH, MINPCH, NUMBIN, BPS, LUNBEM,
     *   WINB(4), WINM(4,10), NBOXS, LUNRES, LUNRS1, LUNWT, LUNGD1,
     *   LUNGD2, LUNDRT, LUNWRK, LUNCL1, LUNCL2, BEMVOL, RESVOL,
     *   WTVOL, GRDVOL, DRTVOL, WRKVOL, CLNVOL, ICENX, ICENY, CLNVER,
     *   BOBEM, BORES, BOWT, BOGRD, BODRT, BOWRK, CNODRT, CNOCLN,
     *   CNORES, CNOWT, CNOGRD, CNOWRK, BLC(7), BUFSZ1, BUFSZ2, BUFSZ3
      INTEGER   CCBUFF(512), CCKOLS(MAXCCC), CCNUMV(MAXCCC), CCRNO,
     *   CCNCOL, CCTYPE, IDUM(4)
      REAL      XX, YY, ZZ, CCFLUX, PARMS(3), RDUM(4)
      EQUIVALENCE (IDUM, RDUM)
      COMMON /CCFILE/ CCBUFF, CCKOLS, CCNUMV, CCRNO, CCNCOL, CCTYPE, XX,
     *   YY, ZZ, CCFLUX, PARMS
      COMMON /CLNCHR/ BEMFIL, RESFIL, WTFIL, GRDFIL, DRTFIL, WRKFIL,
     *   CLNFIL
      COMMON /CLNCOM/ BUFF1, BUFF2, BUFF3, GAIN, FMIN, FACTOR,
     *   FLUX, PHAT, RESMAX, MAPLIM, GAUSA, GAUSB, GAUSC,
     *   GAUSAA, GAUSBB, GAUSCC, XSPACE, YSPACE, MAPROT,
     *   SPEXP, TVFMAX, TVFMIN, TVREMX, TVREMN, PRECLN, CLNLST, CLNSTR,
     *   CLNLIM, PTRJ, PTRK, BMHIS, RESHIS,
     *   NOFIT,
     *   ICENX, ICENY, NX, NY, PATCH, MAXPCH, MINPCH, NUMBIN, WINB,
     *   WINM, NBOXS, BPS, LUNBEM, LUNRES, LUNRS1, LUNWT, LUNGD1,
     *   LUNGD2, LUNDRT, LUNWRK, LUNCL1, LUNCL2,
     *   BEMVOL, RESVOL, WTVOL, GRDVOL, DRTVOL, WRKVOL, CLNVOL,
     *   BOBEM, BORES, BOWT, BOGRD, BODRT, BOWRK,
     *   CNODRT, CNOCLN, CNORES, CNOWT, CNOGRD, CNOWRK, CLNVER, BLC,
     *   BUFSZ1, BUFSZ2, BUFSZ3
C                                                          End RSTOR
LOCAL END
      PROGRAM RSTOR
C-----------------------------------------------------------------------
C! Restores a CC file to a map with a gaussian beam.
C# Map AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2005-2006, 2008, 2019-2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   RSTOR is a gutted version of APCLN.
C   INPUTS    ALIAS   DIM(R)                COMMENTS
C   INNAME    NAME(1,1) 3           Input (residual) map name
C   INCLASS   CLASS(1,1)2           Input map class
C   INSEQ     SEQ(1)    1           Input map sequence number
C   INDISK    VOL(1)    1           Input map volume
C   BLC       BLC       7           Specifies the plane to Restore.
C   IN2NAME   NAME(1,2) 3           Map name for CC file
C   IN2CLASS  CLASS(1,2)2           CC map class
C   IN2SEQ    SEQ(2)    1           CC map sequence number
C   IN2DISK   VOL(2)    1           CC map volume
C   OUTNAME   NAME(1,3) 3           Restored map name
C   OUTCLASS  CLASS(1,3)2           Restored map class
C   OUTSEQ    SEQ(3)    1           Restored map sequence number
C   OUTDISK   VOL(3)    1           Restored map volume
C   INVER     CLNVER    1           CLEAN comp. file version #.
C   NITER     CLNLIM    1           Last CLEAN component to restore.
C   BMAJ      GAUSA     1           Major axis of CLEAN restoring beam
C                                   sigma of Gaussian in cells.
C   BMIN      GAUSB     1           Minor axis size of CLEAN beam.
C   BPA       GAUSC     1           Position angle (deg) of BMAJ
C   BADDISK   IBAD     10           Bad disk list.
C   Programmer = J. P. Leahy 1989.
C-----------------------------------------------------------------------
      INTEGER   IERR, IRET, USID, VOL(3), SEQ(3), KAP, NEED
      LOGICAL   OLD, T, ONEPLN, NOCON
      REAL      PLNMAX, PLNMIN
      DOUBLE PRECISION APCORE(2)
      CHARACTER HILINE*72, NAME(3)*12, CLASS(3)*6, REST*4
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'RSTOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DAPM.INC'
      DATA T /.TRUE./
      DATA REST /'REST'/
C-----------------------------------------------------------------------
C                                       Free AP memory
      CALL QRLSE
      NCFILE = 0
      NSCR = 0
      NOCON  = .FALSE.
      FLUX = 0.0
C                                       Get input values.
      CALL GETIN (USID, NAME, VOL, CLASS, SEQ, IRET)
C                                       Check for restart of AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 990
C                                       Get map files and create
C                                       output files if required.
      CALL FILES (USID, NAME, VOL, CLASS, SEQ, OLD, IRET)
      IF (IRET.NE.0) GO TO 990

      CLNLST = CLNLIM
      CLNSTR = CLNLIM
C                                       Decide if more than one plane
C                                       in image.
      ONEPLN = .NOT. ((CATBLK(KINAX+2).GT.1) .OR. (CATBLK(KINAX+3).GT.1)
     *   .OR. (CATBLK(KINAX+4).GT.1) .OR. (CATBLK(KINAX+5).GT.1)
     *   .OR. (CATBLK(KINAX+6).GT.1))
C                                       Get BEAM if not input.
      IF (GAUSA.LT.-0.5) THEN
         NOCON = T
         GAUSA = 0.0
         GAUSB = 0.0
         GAUSC = 0.0
      ELSE IF (GAUSA.LE.0.0) THEN
         IF (CATR(KRBMJ).GE.0.0) THEN
            GAUSA = CATR(KRBMJ) * 3600.
            GAUSB = CATR(KRBMN) * 3600.
            GAUSC = CATR(KRBPA)
         ELSE
C                                       No beam
            IRET = 8
            WRITE (MSGTXT,1400)
            GO TO 990
            END IF
         END IF
C                                       Write inputs to history and
C                                       log files.
      CALL RSTHIS (NAME, CLASS, SEQ, VOL, OLD)
C                                      Grid CCs, FFT, weight.
      NEED = 2 * NX * NY + NX + NY
      KAP = 8 * NY + 106 + 5 * CLNSTR
      NEED = MAX (NEED, KAP)
      NEED = NEED / 1024
      CALL QINIT (APCORE, NEED, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
         NEED = 8 * NY + 106 + 5 * CLNSTR + 4 * NX
         NEED = NEED / 1024
         NEED = MIN (32 * 1024, NEED) + 2
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            IRET = 8
            MSGTXT = 'UNABLE TO GET DESIRED MEMORY'
            CALL MSGWRT (8)
            GO TO 990
            END IF
         END IF
      CALL RESTOR (APCORE, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       FFT to map plane.
      CALL APDFFT (APCORE, IRET)
      CALL QRLSE
      IF (IRET.NE.0) GO TO 990
C                                       Reaquire AP
      CALL QINIT (APCORE, 0, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
         IRET = 8
         MSGTXT = 'UNABLE TO RE-ACQUIRE DESIRED MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       Subtract from dirty map.
      CALL ADDMAP (APCORE, PLNMAX, PLNMIN, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Determine RESMAX.
      RESMAX = MAX (ABS (PLNMAX), ABS (PLNMIN))

      CALL QRLSE
C                                       Update CLEAN catalog header
      CATBLK(KINIT) = CLNSTR
      CATR(KRBMJ) = GAUSA / 3600.
      CATR(KRBMN) = GAUSB / 3600.
      CATR(KRBPA) = GAUSC
      CATBLK(KITYP) = 1
      CATR(KRDMX) = MAX (CATR(KRDMX), PLNMAX)
      CATR(KRDMN) = MIN (CATR(KRDMN), PLNMIN)
      IF (ONEPLN) CATR(KRDMX) = PLNMAX
      IF (ONEPLN) CATR(KRDMN) = PLNMIN
      IF ((GAUSA.GT.0.0) .AND. (GAUSA.LT.1.E-5)) CATBLK(KITYP) = 4
      CALL CATIO ('UPDT', RESVOL, CNORES, CATBLK, REST, BUFF3, IERR)
      IF ((IERR.EQ.0) .OR. (IERR.GE.5)) GO TO 250
         WRITE (MSGTXT,1200) IERR
         CALL MSGWRT (8)
C                                       Clear  map files
 250  IRET = IERR
      IF ((IERR.NE.0) .AND. (IERR.LT.9)) GO TO 990
C                                       History
      CALL HIOPEN (LUNCL1, RESVOL, CNORES, BUFF1, IERR)
C                                       Plane number
      WRITE (HILINE,1254) TSKNAM, BLC(3)
      IF (BLC(3).GT.1) CALL HIADD (LUNCL1, HILINE, BUFF1, IERR)
C                                        Write total restored flux
      WRITE (HILINE,1250) TSKNAM, FLUX
      CALL HIADD (LUNCL1, HILINE, BUFF1, IERR)
C                                       Write number of iterations
C                                       actually done.
      WRITE (HILINE,1251) TSKNAM, CLNSTR
      CALL HIADD (LUNCL1, HILINE, BUFF1, IERR)
      CALL HICLOS (LUNCL1, T, BUFF1, IERR)
C                                        Finished.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
C-----------------------------------------------------------------------
 1200 FORMAT ('ERROR',I3,' UPDATING CLEAN HEADER ')
 1250 FORMAT (A6,' /Total Restored flux density = ',1PE12.4,' Jy')
 1251 FORMAT (A6,' /Number of CLEAN components =',I8)
 1254 FORMAT (A6,' / Clean of plane ',I4)
 1400 FORMAT ('ERROR: CAN''T FIND CLEAN BEAM')
      END
      SUBROUTINE ADDMAP (APCORE, RMAX, RMIN, IERR)
C-----------------------------------------------------------------------
C   ADDMAP adds the transformed GRID map to the input image prodicing
C   the restored image.
C   The transformed grid file is assumed to be in the WRK file.
C   Input:
C   Output:
C     RMAX    R   Maximum in residual/restored map.
C     RMIN    R   Minimum in residual/restored map.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   FIND1, FIND2, FIND3, BIND1, BIND2, BIND3, WIN(4),
     *   I, IERR
      INTEGER   IAPMAX, IAPMIN, IAPRES, SIZE, IAPSUM, ONENX
      LOGICAL   MAP, EXCL, WAIT
      REAL      RMAX, RMIN, TMAX, TMIN, YTEMP(3)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'RSTOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (TMAX, YTEMP(1)),      (TMIN, YTEMP(3))
      DATA MAP, EXCL, WAIT /.TRUE., 2*.TRUE./
      DATA IAPMAX, IAPMIN, IAPRES
     *   /   2,      4,      10/
C-----------------------------------------------------------------------
C                                       Initialize extrema.
      RMAX = -1.0E20
      RMIN =  1.0E20
C                                       Setup AP locations.
C                                         2 = MAX    (IAPMAX)
C                                         4 = MIN    (IAPMIN)
C                                        10 = Residual map (IAPRES)
C                                        IAPRES+NX+1 Dirty & Sum(IAPSUM)
      ONENX = NX
      SIZE = ONENX + 1
      IAPSUM = IAPRES + SIZE
C                                       Clear AP area for Residual
      CALL QVCLR (APCORE, IAPRES, 1, ONENX)
C                                       Open and INIT files.
      CALL ZOPEN (LUNDRT, FIND1, DRTVOL, DRTFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
      CALL ZOPEN (LUNWRK, FIND2, WRKVOL, WRKFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
      CALL ZOPEN (LUNRES, FIND3, RESVOL, RESFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         GO TO 990
         END IF
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NX
      WIN(4) = NY
      CALL MINIT ('READ', LUNDRT, FIND1, NX, NY, WIN, BUFF1, BUFSZ1,
     *   BODRT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      CALL MINIT ('READ', LUNWRK, FIND2, NX, NY, WIN, BUFF2, BUFSZ2,
     *   BOWRK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
      CALL MINIT ('WRIT', LUNRES, FIND3, NX, NY, WIN, BUFF3, BUFSZ3,
     *   BORES, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
C                                       Loop
      DO 150 I = 1,NY
C                                       Read dirty map.
         CALL MDISK ('READ', LUNDRT, FIND1, BUFF1, BIND1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1070) IERR,I
            GO TO 990
            END IF
C                                       Write output.
         CALL MDISK ('WRIT', LUNRES, FIND3, BUFF3, BIND3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR,I
            GO TO 990
            END IF
C                                       Read work file
         CALL MDISK ('READ', LUNWRK, FIND2, BUFF2, BIND2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1105) IERR,I
            GO TO 990
            END IF
         CALL QWR
C                                       Load input
         CALL QPUT (APCORE, BUFF1(BIND1), IAPSUM, ONENX, 2)
         CALL QWD
C                                       Load work file
         CALL QWR
         CALL QPUT (APCORE, BUFF2(BIND2), IAPRES, ONENX, 2)
         CALL QWD
C                                       Add rows.
         CALL QVADD (APCORE, IAPSUM, 1, IAPRES, 1, IAPSUM, 1, ONENX)
C                                       Find max and min in row.
         CALL QMAXV (APCORE, IAPSUM, 1, IAPMAX, ONENX)
         CALL QMINV (APCORE, IAPSUM, 1, IAPMIN, ONENX)
C                                       Read results.
         CALL QWR
         CALL QGET (APCORE, BUFF3(BIND3), IAPSUM, ONENX, 2)
         CALL QGET (APCORE, YTEMP, IAPMAX, 3, 2)
         CALL QWD
C                                       Note use of EQUIVALENCE.
C                                       Save max and min.
         RMAX = MAX (RMAX, TMAX)
         RMIN = MIN (RMIN, TMIN)
 150     CONTINUE
C                                       Finish write.
      CALL MDISK ('FINI', LUNRES, FIND3, BUFF3, BIND3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1150) IERR
         GO TO 990
         END IF
C                                       Close files.
      CALL ZCLOSE (LUNDRT, FIND1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1160) IERR
         CALL MSGWRT (8)
         END IF
      CALL ZCLOSE (LUNWRK, FIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1170) IERR
         CALL MSGWRT (8)
         END IF
      CALL ZCLOSE (LUNRES, FIND3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1180) IERR
         CALL MSGWRT (8)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ADDMAP: CANNOT OPEN DIRTY FILE, ERROR ',I3)
 1020 FORMAT ('ADDMAP: CANNOT OPEN FOR READ RESIDUAL MAP, ERROR ',I3)
 1030 FORMAT ('ADDMAP: CANNOT OPEN FOR WRITE RESIDUAL MAP, ERROR ',I3)
 1040 FORMAT ('ADDMAP: CANNOT INIT DIRTY MAP, ERROR ',I3)
 1050 FORMAT ('ADDMAP: CANNOT INIT READ RESIDUAL MAP, ERROR ',I3)
 1060 FORMAT ('ADDMAP: CANNOT INIT WRITE RESIDUAL MAP, ERROR ',I3)
 1070 FORMAT ('ADDMAP: READ ERROR ',I3,' DIRTY FILE ROW ',I6)
 1105 FORMAT ('ADDMAP: READ ERROR ',I3,' RESIDUAL MAP ROW ',I6)
 1100 FORMAT ('ADDMAP: WRITE ERROR ',I3,' RESIDUAL ROW ',I6)
 1150 FORMAT ('ADDMAP: FINISH ERROR ',I3,' RESIDUAL FILE')
 1160 FORMAT ('ADDMAP: CLOSE ERROR ',I3,' DIRTY MAP ')
 1170 FORMAT ('ADDMAP: CLOSE ERROR ',I3,' READ RESIDUAL FILE')
 1180 FORMAT ('ADDMAP: CLOSE ERROR ',I3,' WRITE RESIDUAL FILE ')
      END
      SUBROUTINE APDFFT (APCORE, IERR)
C-----------------------------------------------------------------------
C   APDFFT calls AP FFT routines PASS1 and PASS2.  If the transform
C   can be done all in the AP this is done; if not then a transpose
C   of the type designed by F. Schwab is done.
C   On the reverse transform the GRID file is transformed to the WORK
C   file. The contents of the GRID file are destroyed.
C   Input:
C     BOGRD      I    Block offset of beam map.
C     GRDVOL     I    Volume for beam map.
C     GRDFIL     C    Physical name of  Beam map.
C     LUNGD1     I    LUN for Beam map.
C     BOGRD      I    Block offset of GRID file.
C     GRDVOL     I    Volume for GRID file.
C     GRDFIL     C    Physical name of GRID file.
C     LUNGD1     I    LUN for GRID file.
C     BOWT       I    Block offset of weight file.
C     WTVOL      I    Volume for weight file.
C     WTFIL      C    Physical name of weight file.
C     LUNWT      I    LUN for weight file.
C     BORES      I    Block offset for residual map.
C     RESVOL     I    Volume for residual map.
C     RESFIL     C    Physical name of residual map.
C     LUNRES     I    LUN for residual map.
C     BOWRK      I    Block offset for WORK file.
C     WRKVOL     I    Volume for work file.
C     WRKFIL     C    Physical name of WORK file.
C     LUNWRK     I    LUN for WORK file.
C     BUFF1(),BUFF2()  I    Work buffers for I/O.
C     BUFSZ1,BUFSZ2    I    Size in bytes of BUFF1 and BUFF2.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   IERR
C
      INTEGER   JDIR, LUN(3), BO(3), VOL(3)
      LOGICAL   FULL
      REAL      SMAX, SMIN
      CHARACTER FIL(3)*48
      INCLUDE 'RSTOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA FULL /.FALSE./
C-----------------------------------------------------------------------
C                                       COMPLEX TO REAL
C                                       Set file information.
C                                       1 = Grid, 2 = Resid, 3 = Work
      BO(1) = BOGRD
      BO(2) = BORES
      BO(3) = BOWRK
      VOL(1) = GRDVOL
      VOL(2) = RESVOL
      VOL(3) = WRKVOL
      LUN(1) = LUNGD1
      LUN(2) = LUNWRK
      LUN(3) = LUNRES
      FIL(1) = GRDFIL
      FIL(2) = RESFIL
      FIL(3) = WRKFIL
      JDIR = -1
C                                       Do disk based FFT.
      CALL PASS1 (APCORE, JDIR, FULL, LUN, VOL, FIL, BO, BUFF1, BUFSZ1,
     *   BUFF2, BUFSZ2, NX, NY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL PASS2 (APCORE, JDIR, FULL, LUN, VOL, FIL, BO, BUFF1, BUFSZ1,
     *   BUFF2, BUFSZ2, NX, NY, SMAX, SMIN, IERR)
C
 999  RETURN
      END
      SUBROUTINE RSTHIS (NAME, CLASS, SEQ, VOL, OLD)
C-----------------------------------------------------------------------
C   RSTHIS copies the input map history if the output map does not
C   already have a history file.  Then the inputs to RSTOR with
C   the default values are added to the history file.
C   Inputs:
C     NAME(3)    C*12 Names of maps
C                      1 = Inputmap
C                      2 = CC map
C                      3 = Restored map
C     CLASS(3)    C*6  Classes of the map.
C     SEQ(3)      I    Sequence numbers of the maps.
C     VOL(3)      I    Original disk numbers
C     OLD         L    T => Clean map pre-exists & restart > 0
C   Input from common:
C     CNODRT      I    CNO of dirty image
C     CNORES      I    CNO of restored image
C     DRTVOL      I    VOL of dirty image
C     RESVOL      I    VOL of restored image
C   From common /MAPHDR/
C     CATBLK(256) I    Catalog header block for the CLEAN map.
C   From COMMON /CLN/
C     NX          I    Number of cell in the map in RA.
C     NY          I    Number of cells in the map in dec.
C     BLC(7)      I    Specifies plane.
C     CLNLIM      I    number of components restored.(NITER)
C     GAUSA       R    Major axis (FWHM) of CLEAN restoring beam
C     GAUSB       R    Minor axis (FWHM) of CLEAN restoring beam
C     GAUSC       R    Position angle of CLEAN restoring beam.
C     BUFF1(*)    R    Work buffer
C     BUFF2(*)    R    Work buffer
C     LUNCL1      I    LUN for CLEAN history file
C     LUNDRT      I    LUN for dirty history file
C     CLNVER      I    CLEAN comp. file version number.
C   OUTPUT:
C     The input parameters are written on the history file and the
C     log file.
C-----------------------------------------------------------------------
      CHARACTER NAME(3)*12, CLASS(3)*6, XCLS*8, XNAM*12, HILINE*72
      INTEGER   SEQ(3), VOL(3), IERR
      LOGICAL   T, OLD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'RSTOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Open old file: no copy old HI
      IF (OLD) THEN
         CALL HIOPEN (LUNCL1, RESVOL, CNORES, BUFF2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            CALL MSGWRT (6)
            GO TO 60
            END IF
         CALL ZDATE (BUFF1(1))
         CALL ZTIME (BUFF1(4))
         CALL TIMDAT (BUFF1(4), BUFF1(1), XCLS, XNAM)
         WRITE (HILINE,1000) TSKNAM, RLSNAM, XNAM, XCLS
         CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 50
      ELSE
C                                       Copy/open history files.
         CALL HISCOP (LUNDRT, LUNCL1, DRTVOL, RESVOL, CNODRT, CNORES,
     *      CATBLK, BUFF1, BUFF2, IERR)
C                                       Check if old file does not exist
         IF (IERR.GT.2) THEN
            IF (IERR.EQ.3) GO TO 50
            WRITE (MSGTXT,1020) IERR
            CALL MSGWRT (6)
            GO TO 60
            END IF
         END IF
C                                       Add to history file.
C                                       Input map name.
      WRITE (MSGTXT,2000) TSKNAM, NAME(1), CLASS(1), SEQ(1), DRTVOL
      CALL MSGWRT (3)
      CALL HENCO1 (TSKNAM, NAME(1), CLASS(1), SEQ(1), DRTVOL,
     *   LUNCL1, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       CC map name.
      WRITE (MSGTXT,2001) TSKNAM, NAME(2), CLASS(2), SEQ(2), VOL(2)
      CALL MSGWRT (3)
      CALL HENCO2 (TSKNAM, NAME(2), CLASS(2), SEQ(2), VOL(2),
     *   LUNCL1, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       Restored map name.
      WRITE (MSGTXT,2002) TSKNAM, NAME(3), CLASS(3), SEQ(3), RESVOL
      CALL MSGWRT (1)
      CALL HENCOO (TSKNAM, NAME(3), CLASS(3), SEQ(3), RESVOL,
     *   LUNCL1, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       BLC
      WRITE (HILINE,2015) TSKNAM, BLC
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (1)
      IF (IERR.NE.0) GO TO 50
C                                       CC file version number.
      WRITE (HILINE,2012) TSKNAM, CLNVER
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (1)
      IF (IERR.NE.0) GO TO 50
C                                       Maximum number of components.
      WRITE (HILINE,2003) TSKNAM, CLNLIM
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (1)
      IF (IERR.NE.0) GO TO 50
C                                       CLEAN restoring beam
      WRITE (HILINE,2008) TSKNAM, GAUSA, GAUSB, GAUSC
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (1)
      IF (IERR.EQ.0) GO TO 60
C                                       FACTOR
      WRITE (HILINE,2009) TSKNAM, FACTOR
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (1)
      IF (IERR.EQ.0) GO TO 60
C                                       Error has occured.
 50   WRITE (MSGTXT,1050) IERR
      CALL MSGWRT (6)
C                                       Close history files.
 60   CALL HICLOS (LUNCL1, T, BUFF2, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* RESTART ',
     *   A12,2X,A8)
 1010 FORMAT ('UNABLE TO OPEN OLD CLEAN-MAP HISTORY FILE')
 1020 FORMAT ('RSTHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1050 FORMAT ('RSTHIS: ERROR',I3,' WRITING HISTORY FILE')
 2000 FORMAT (A6,'/ INPUT MAP =''',A12,''' . ''',A6,
     *   ''' . ',2I4)
 2001 FORMAT (A6,'/ CC MAP = ''',A12,''' . ''',A6,
     *   ''' . ',2I4)
 2002 FORMAT (A6,'/ RESTORED MAP =''',A12,''' . ''',A6,
     *   ''' . ',2I4)
 2003 FORMAT (A6,'NITER = ',I8,' /No. components restored.')
 2008 FORMAT (A6,'BMAJ=',F10.5,' BMIN=',F10.5,' BPA=',F8.3,
     *   ' /CLEAN beam')
 2009 FORMAT (A6,'FACTOR=',F8.3,5X,'/ scall CCs by FACTOR')
 2012 FORMAT (A6,'OUTVER = ',I4,' /CLEAN comp. file version no.')
 2015 FORMAT (A6,'BLC =',7I5,' / Plane CLEANed')
      END
      SUBROUTINE FILES (USID, NAME, VOL, CLASS, SEQ, OLD, IERR)
C-----------------------------------------------------------------------
C   FILES creates the output (Restored) map, and copies the CC file
C   from the CC map to the output map. The location of the cataloged
C   "dirty map" file is left in the DRT file.
C   Dirty map and CC map in catalog are marked READ and restored map
C   is marked WRITE.
C   Input:
C     USID     I    User number.
C     NAME(3)  C*12 Names of maps
C                     1 = Dirty map
C                     2 = CC map
C                     3 = Restored map
C     CLASS(3)  C*6   Classes of the maps
C     VOL(3)     I    volumes of the maps.
C   Commons:
C     CATBLK(256) in /MAPHDR/ a preliminary header for the clean map
C        is returned.
C   Output in common:
C     CNODRT      I    CNO of dirty image
C     CNOCLN      I    CNO of CLEAN file
C     CNORES      I    CNO of restored image
C     DRTVOL      I    VOL of dirty image
C     CLNVOL      I    VOL of CLEAN file
C     RESVOL      I    VOL of restored image
C-----------------------------------------------------------------------
      CHARACTER NAME(3)*12, CLASS(3)*6, STAT*4, REST*4, TYPTMP*2
      INTEGER   ISIZE, LSIZE, IEQUIV, OUTVER, LUNDR2, LUNOLD
      INTEGER   USID, VOL(3), SEQ(3), CATOLD(256), OLDIM, OLDNAX(7), I,
     *   IER, IERR, IDEP(5), NOSCR, NPIX(2), NONOT, IX, IY
      LOGICAL   OLD
      DOUBLE PRECISION OLDCRV(7)
      REAL      XMAX, XMIN, REQUIV
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'RSTOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (IEQUIV, REQUIV)
      DATA REST /'REST'/
C-----------------------------------------------------------------------
C                                       Get catalog slot number for
C                                       the dirty map and CATBLK.
      CNODRT = 1
      DRTVOL = VOL(1)
      TYPTMP = 'MA'
      CALL CATDIR ('SRCH', DRTVOL, CNODRT, NAME(1), CLASS(1), SEQ(1),
     *   TYPTMP, USID, STAT, BUFF3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, NAME(1), CLASS(1), SEQ(1), DRTVOL,
     *      USID
         END IF
C                                       Get CATBLK for dirty map.
C                                       Leave file marked READ.
      CALL CATIO ('READ', DRTVOL, CNODRT, CATBLK, 'READ', BUFF3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1090) IERR
         END IF
C                                       Mark map READ in /CFILES/
C                                       Put into slot 2 for APCLN
C                                       compatibility
      NCFILE = 2
      FVOL(NCFILE) = DRTVOL
      FCNO(NCFILE) = CNODRT
      FRW(NCFILE) = 0
C                                       Get dirty scale,offset,max,min.
C                                       Set info into COMMON.
      XMAX = CATR(KRDMX)
      XMIN = CATR(KRDMN)
      RESMAX = MAX (ABS(XMAX) , ABS(XMIN))
      CALL ZPHFIL ('MA', DRTVOL, CNODRT, 1, DRTFIL, IER)
      VOL(1) = DRTVOL
C                                       Set BLKOF for plane.
      IDEP(1) = BLC(3)
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEP, BODRT, IERR)
      BODRT = BODRT + 1
C                                        RA spacing.
      XSPACE = CATR(KRCIC)
C                                        Dec spacing.
      YSPACE = CATR(KRCIC+1)
C                                        Map rotation.
      CALL ROTFND (CATR, MAPROT, IER)
C                                       Determine NX and NY
      NX = CATBLK(KINAX)
      NY = CATBLK(KINAX+1)
      CALL POWER2 (NX, IX)
      CALL POWER2 (NY, IY)
      IF ((NX.NE.IX) .OR. (NX.LT.32) .OR. (NX.GT.MAXIMG)) GO TO 980
      IF ((NY.NE.IY) .OR. (NY.LT.32) .OR. (NY.GT.MAXIMG)) GO TO 980

C                                       Set up output map
C                                       Put NAME in CATBLK
      CALL CHR2H (12, NAME(3), KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLASS(3), KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQ(3)
C                                       Create output map file.
      RESVOL = VOL(3)
      CALL MCREAT (RESVOL, CNORES, BUFF1, IERR)
      OLD = .FALSE.
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1190) IERR
            GO TO 990
C                                       Existing file: check it out
         ELSE IF ((CNORES.EQ.CNOCLN) .AND. (RESVOL.EQ.CLNVOL)) THEN
C                                       Cannot overwrite input map.
            IERR = 8
            WRITE (MSGTXT,1430)
            GO TO 990
         ELSE IF (CATBLK(KINAX+2).LE.1) THEN
C                                       Won't overwrite output map
C                                       unless it's a cube.
            IERR = 8
            WRITE (MSGTXT,1420)
            GO TO 990
         ELSE
            OLD = .TRUE.
            OLDIM = CATBLK(KIDIM)
            DO 205 I = 1,7
              OLDNAX(I) = CATBLK(KINAX+I-1)
              OLDCRV(I) = CATD(KDCRV+I-1)
 205          CONTINUE
            CALL CATIO('READ', RESVOL, CNORES, CATBLK, REST, BUFF3,
     *         IERR)
            IF (OLDIM.NE.CATBLK(KIDIM)) GO TO 215
            DO 210 I = 1, OLDIM
               IF (OLDNAX(I).NE.CATBLK(KINAX+I-1)) GO TO 215
               IF (ABS (OLDCRV(I)-CATD(KDCRV+I-1)) .GT. 0.05 *
     *             ABS (CATR(KRCIC+I-1))) GO TO 215
 210           CONTINUE
C                                       It matches, mark for write.
            CALL CATIO ('WRIT', RESVOL, CNORES, CATBLK, 'WRIT', BUFF3,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1210) IERR
               GO TO 990
               END IF
            END IF
         END IF
      GO TO 220
C                                       Output file wrong shape!
 215  CONTINUE
         IERR = 8
         WRITE (MSGTXT, 1215)
         GO TO 990
 220  CONTINUE
C                                       Actual seq #
      SEQ(3) = CATBLK(KIIMS)
C                                       Add to /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = RESVOL
      FCNO(NCFILE) = CNORES
      FRW(NCFILE) = 2
      VOL(3) = RESVOL
      CCNCOL = 3
C                                       Copy existing tables files
C                                       to output.
      IF (.NOT.OLD) THEN
         LUNDR2 = 29
         NONOT = 0
         TYPTMP = '  '
         CALL ALLTAB (NONOT, TYPTMP, LUNDR2, LUNCL2, DRTVOL, RESVOL,
     *      CNODRT, CNORES, CATBLK, BUFF1, BUFF2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1450) IERR
            GO TO 990
            END IF
C                                       copy keywords too
         CALL KEYPCP (DRTVOL, CNODRT, RESVOL, CNORES, 0, ' ', IERR)
         END IF
C                                       Open CC file.
C                                       Get catalog slot for CC map.
      CNOCLN = 1
      CLNVOL = VOL(2)
      TYPTMP = 'MA'
      CALL CATDIR ('SRCH', CLNVOL, CNOCLN, NAME(2), CLASS(2), SEQ(2),
     *   TYPTMP, USID, STAT, BUFF3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, NAME(1), CLASS(1), SEQ(2), CLNVOL,
     *      USID
         GO TO 990
         END IF
C                                       Copy CATBLK and mark CC map READ
      CALL CATIO ('READ', CLNVOL, CNOCLN, CATOLD, 'READ', BUFF3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         GO TO 990
         END IF
C                                       Update /CFILES/ N.B. For
C                                       compatibility with APCLN
C                                       subroutines, we use slot 1 in
C                                       /CFILES/ for the CC Map.
      NCFILE = 1
      FVOL(NCFILE) = CLNVOL
      FCNO(NCFILE) = CNOCLN
      FRW(NCFILE) = 0
      VOL(2) = CLNVOL
      NCFILE = 3
C                                       Create/get ver # for CC file.
      IF (CLNVER.EQ.0) CALL FNDEXT ('CC', CATOLD, CLNVER)
      IF (CLNVER.EQ.0) THEN
         WRITE (MSGTXT,1410)
         GO TO 990
         END IF
C                                        Copy CC file to output.
      OUTVER = 0
      LUNOLD = 28
C                                       If cube, override OUTVER w/
C                                       plane number.
      IF (CATBLK(KINAX+2).GT.1) OUTVER = BLC(3)
C                                       Get number of highest
C                                       existing CC file
      IF (OUTVER.EQ.0) CALL FNDEXT ('CC', CATBLK, OUTVER)
C                                       Write to next one.
      OUTVER = OUTVER + 1
C                                       Check limit of 46655
      IF (OUTVER.GT.46655) THEN
         IERR = 5
         WRITE (MSGTXT,1301) OUTVER
         GO TO 990
         END IF
      CALL TABCOP ('CC', CLNVER, OUTVER, LUNOLD, LUNCL2, CLNVOL, RESVOL,
     *   CNOCLN, CNORES, CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1400)
         GO TO 990
         END IF
C                                       From now on, use CC file
C                                       on output map:
      CLNVER = OUTVER
      CLNVOL = RESVOL
      CNOCLN = CNORES
      CALL CCMINI ('WRIT', CCBUFF, CLNVOL, CNOCLN, CLNVER, CATBLK,
     *   LUNCL2, CCRNO, CCKOLS, CCNUMV, CCNCOL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1300) IERR
         GO TO 990
         END IF
C                                       Check no. CC comps.
      CLNLIM = MIN (CLNLIM, CCBUFF(5))
      IF (CLNLIM.LE.0) CLNLIM = CCBUFF(5)
      CCBUFF(5) = CLNLIM
C                                       Close.
      CALL TABCCM ('CLOS', CCBUFF, CCRNO, CCKOLS, CCNUMV, CCNCOL, XX,
     *   YY, ZZ, CCFLUX, CCTYPE, PARMS, IERR)
C                                       Create scratch files.
C                                       Use output as residual file
C                                       Grid file
      NSCR = 0
      NPIX(1) = NX
      NPIX(2) = NY + 1
      CALL MAPSIZ (2, NPIX, ISIZE)
      NPIX(1) = 2 * NY
      NPIX(2) = NX/2 + 1
      CALL MAPSIZ (2, NPIX, LSIZE)
      IF (LSIZE.GT.ISIZE) ISIZE = LSIZE
      CALL SCREAT (ISIZE, BUFF2, IERR)
      IF (IERR.EQ.0) GO TO 25
         WRITE (MSGTXT,1020) IERR
         GO TO 990
C                                       Update from COMMON /FILES/
 25   GRDVOL = SCRVOL(NSCR)
      CNOGRD = SCRCNO(NSCR)
      CALL ZPHFIL ('SC', GRDVOL, CNOGRD, 1, GRDFIL, IERR)
      NOSCR = NSCR
C                                       Work file
      CALL SCREAT (ISIZE, BUFF2, IERR)
      IF (IERR.EQ.0) GO TO 30
         WRITE (MSGTXT,1025) IERR
         GO TO 990
C                                       Update from COMMON /FILES/
 30   WRKVOL = SCRVOL(NSCR)
      CNOWRK = SCRCNO(NSCR)
      CALL ZPHFIL ('SC', WRKVOL, CNOWRK, 1, WRKFIL, IERR)
C                                       Use output file as resid. file
      CALL ZPHFIL ('MA', RESVOL, CNORES, 1, RESFIL, IERR)
      BORES = BODRT

      GO TO 999
 980  WRITE (MSGTXT,1980) NX, NY
      IERR = 8
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FILES: ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,
     *   ' DISK=',I3,' USID=',I4)
 1010 FORMAT ('FILES: CANNOT COPY BEAM CATBLK, ERROR',I3)
 1020 FORMAT ('FILES: ERROR',I3,' CREATING GRID SCRATCH FILE')
 1025 FORMAT ('FILES: ERROR',I3,' CREATING WORK SCRATCH FILE')
 1090 FORMAT ('FILES: CANNOT COPY MAP CATBLK, ERROR',I3)
 1190 FORMAT ('FILES: COULD NOT CREATE OUTPUT MAP FILE, ERROR ',I3)
 1210 FORMAT ('FILES: CANNOT UPDATE OUTPUT CATBLK, ERROR',I3)
 1215 FORMAT ('OLD OUTPUT MAP NOT COMPATIBLE WITH INPUT MAP')
 1300 FORMAT ('FILES: UNABLE TO CREATE CLEAN COMP. FILE, ERROR',I3)
 1301 FORMAT ('COMPONENT FILE NO. TOO LARGE ',I3,' > 46655')
 1400 FORMAT ('FILES: CAN''T COPY CC FILE TO OUTPUT')
 1410 FORMAT ('FILES: CAN''T FIND CLEAN COMPONENT FILE')
 1420 FORMAT ('FILES: WON''T OVERWRITE EXISTING SINGLE-PLANE MAP')
 1430 FORMAT ('FILES: CAN''T OVERWRITE INPUT MAP')
 1450 FORMAT ('FILES: ERROR', I3, ' COPYING EXTENSION FILES')
 1980 FORMAT ('MAP DIMENSIONS:',2I5,' NOT INTEGER POWERS OF 2')
      END
      SUBROUTINE GETIN (USID, NAME, VOL, CLASS, SEQ, IERR)
C-----------------------------------------------------------------------
C   GETIN gets the input parameters for the program from AIPS
C  See Prologue for RSTOR for more details.
C-----------------------------------------------------------------------
      CHARACTER TYPTMP*2
      CHARACTER PRGNAM*6, NAME(3)*12, CLASS(3)*6, DEFCLS*6, BLANK*12,
     *   QM*4, UM*4, VM*4, RM*4, LM*4, ICLN*4, QCLN*4, UCLN*4,
     *   VCLN*4, RCLN*4, LCLN*4
      HOLLERITH XNAM1(3), XCLAS1(2), XNAM2(3), XCLAS2(2), XNAM3(3),
     *   XCLAS3(2)
      INTEGER   USID, SEQ(3), VOL(3), NPARMS, IERR, IND, I, IROUND,
     *   ITEMP
      REAL   XSEQ1, XSEQ2, XSEQ3, XVOL1, XVOL2, XVOL3, XBLC(7),
     *   XNI, XBMJ, XBMN, XBPA, XBAD(10), XVER, XFACT
      LOGICAL   T, F, EQUAL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'RSTOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /INPARM/ XNAM1, XCLAS1, XSEQ1, XVOL1, XBLC, XNAM2, XCLAS2,
     *   XSEQ2, XVOL2, XVER, XNAM3, XCLAS3, XSEQ3, XVOL3,
     *   XNI, XBMJ, XBMN, XBPA, XFACT, XBAD
      DATA BLANK /' '/
      DATA PRGNAM /'RSTOR '/
      DATA QM,    UM,    VM,    RM,    LM
     *   /'QMAP','UMAP','VMAP','RMAP','LMAP'/
      DATA ICLN,  QCLN,  UCLN,  VCLN,  RCLN,  LCLN
     *   /'IRST','QRST','URST','VRST','RRST','LRST'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                        Initialize common parameters.
C                                        global areas
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL HIINIT (3)
C                                        RSTOR common areas
      BOBEM = 1
      BORES = 1
      BOWT = 1
      BOGRD = 1
      BODRT = 1
      BOWRK = 1
      LUNBEM = 16
      LUNRES = 17
      LUNRS1 = 19
      LUNWT  = 20
      LUNGD1 = 19
      LUNGD2 = 21
      LUNDRT = 22
      LUNWRK = 23
      LUNCL1 = 26
      LUNCL2 = 27
      CLNLIM = 0
      CLNSTR = 0
      CLNLST = 0
      FLUX = 0
      NUMBIN = 1024
      ITEMP = 2  * MABFSL
      BUFSZ1 = ITEMP
      BUFSZ2 = ITEMP
      BUFSZ3 = ITEMP
      BPS = NBPS
C                                       Get AIPS adverbs.
      NPARMS = 44
      CALL GTPARM (PRGNAM, NPARMS, RQUICK, XNAM1, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         RQUICK = .FALSE.
         GO TO 999
         END IF
C                                       Convert names
      CALL H2CHR (12, 1, XNAM1, NAME(1))
      CALL H2CHR (6, 1, XCLAS1, CLASS(1))
      CALL H2CHR (12, 1, XNAM2, NAME(2))
      CALL H2CHR (6, 1, XCLAS2, CLASS(2))
      CALL H2CHR (12, 1, XNAM3, NAME(3))
      CALL H2CHR (6, 1, XCLAS3, CLASS(3))
C                                       Find desired plane no.
      BLC(1) = 1
      BLC(2) = 1
      DO 20 I = 3,7
         BLC(I) = MAX (1.0, XBLC(I)) + 0.5
 20      CONTINUE
C                                       get actual dirty map name
      VOL(1) = IROUND (XVOL1)
      SEQ(1) = IROUND (XSEQ1)
      USID = NLUSER
      CNODRT = 1
      TYPTMP = 'MA'
      CALL MAPOPN ('READ', VOL, NAME(1), CLASS(1), SEQ, TYPTMP, USID,
     *   LUNBEM, IND, CNODRT, CATBLK, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL MAPCLS ('READ', VOL, CNODRT, LUNBEM, IND, CATBLK, F, BUFF1,
     *   IERR)
C                                       Default name for Restored and
C                                       CC maps is Dirty map name.
      EQUAL = NAME(2) .EQ. BLANK(1:12)
      IF (EQUAL) NAME(2) = NAME(1)
C                                       Copy CLASSes or default.
      EQUAL = BLANK(1:6) .EQ. CLASS(2)
      IF (EQUAL) CLASS(2) = CLASS(1)
C                                       Use appropriate default for
C                                       polarization type.
      DEFCLS = '      '
      DEFCLS(1:4) = ICLN(1:4)
      EQUAL = QM(:1) .EQ. CLASS(1)(:1)
      IF (EQUAL) DEFCLS(1:4) = QCLN(1:4)
      EQUAL = UM(:1) .EQ. CLASS(1)(:1)
      IF (EQUAL) DEFCLS(1:4) = UCLN(1:4)
      EQUAL = VM(:1) .EQ. CLASS(1)(:1)
      IF (EQUAL) DEFCLS(1:4) = VCLN(1:4)
      EQUAL = RM(:1) .EQ. CLASS(1)(:1)
      IF (EQUAL) DEFCLS(1:4) = RCLN(1:4)
      EQUAL = LM(:1) .EQ. CLASS(1)(:1)
      IF (EQUAL) DEFCLS(1:4) = LCLN(1:4)
C                                       Get volume numbers
      VOL(2) = IROUND (XVOL2)
      VOL(3) = IROUND (XVOL3)
C                                       Get sequence numbers
      SEQ(2) = IROUND (XSEQ2)
      SEQ(3) = IROUND (XSEQ3)
      IF (SEQ(2).LE.0) SEQ(2) = SEQ(1)
      CALL MAKOUT (NAME, CLASS, SEQ, DEFCLS, NAME(3), CLASS(3),
     *   SEQ(3))
C                                       Get CC file version no.
      CLNVER = IROUND (XVER)
C                                       Get Restoring information
      CLNLIM = XNI + 0.5
      GAUSA = XBMJ
      GAUSB = XBMN
      GAUSC = XBPA
C                                       Check number of comps
C                                       subtracted from dirty map.
      PRECLN = 0
      IF (CATBLK(KINIT).GT.0) PRECLN = CATBLK(KINIT)
C                                       factor
      FACTOR = XFACT
      IF (FACTOR.EQ.0.0) FACTOR = 1.0
      IF (ABS(FACTOR).NE.1.0) THEN
         WRITE (MSGTXT,1020) FACTOR
         CALL MSGWRT (7)
         END IF
C                                       Get bad disks.
      DO 70 I = 1,10
         IBAD(I) = IROUND (XBAD(I))
 70      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1020 FORMAT ('WARNING: FACTOR=',F7.2,' NOT 1 OR -1')
      END
      SUBROUTINE RESTOR (APCORE, IERR)
C-----------------------------------------------------------------------
C   RESTOR restores CLEAN components to GRID file.  This is done by
C   transforming the CLEAN components, multiplying by the appropriate
C   Gaussian function and adding to the GRID file.
C   Output is to file WRK and then the names and addresses of the WRK
C   and GRID files are switched.
C   Input:
C     CLNSTR I   = highest number component to transform
C     CLEAN components from file CLNFIL.
C   Output:
C     Transform of CLEAN components times the restoring fn added to the
C     file GRDFIL.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   IERR
C
      INTEGER   FIND1, FIND2, BIND2, BIND3, WIN(4), NLOAD, I, JLIM
      INTEGER   FIRST, NUMCLN, MAXCMP, JNUM, IAPSIZ,
     *   WRK1, WRK2, NAPGAU, NAPEX1, NAPEXP, NAPRES, NAPGRD,
     *   NAPCMP, NAPCMS, NUMBER, APBUF, ONENY, TWONY
      LOGICAL   MAP, EXCL, WAIT, T, F, GETOLD
      REAL      TEMP, GBUFF(1), OBUFF(1)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'RSTOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DAPM.INC'
      EQUIVALENCE (OBUFF(1), BUFF1(1)),      (GBUFF(1), BUFF2(1))
      DATA APBUF / 1 /
      DATA EXCL, WAIT, MAP, T, F /4*.TRUE., .FALSE./
C-----------------------------------------------------------------------
C                                       Determine Area assignments in AP
      ONENY = NY
      TWONY = 2 * NY
      NAPRES = 100
      WRK1 = ONENY + 1
      WRK2 = TWONY + 1
      NAPEXP = NAPRES + WRK1
      NAPGRD = NAPEXP + WRK1
      NAPCMP = NAPGRD + WRK2
      NAPGAU = NAPCMP + WRK2
      NAPEX1 = NAPGAU + WRK1
      NAPCMS = NAPEX1 + WRK1
C                                       Set size of AP
      IAPSIZ = PSAPNW * 1024
C                                       Determine maximum number of comp
C                                       per pass.
      MAXCMP = (IAPSIZ - NAPCMS) / 5.0
      NUMCLN = CLNSTR
      CLNLST = 1
      APBUF = 2
C                                       Determine size of AP buffer for
      NLOAD = NAPGAU - 3
C                                       Prepare work arrays in AP.
      CALL INGAUS (APCORE)
C                                       Roll AP if necessary
      CALL QROLL (APCORE, NAPCMS, BUFF3, BUFSZ3, IERR)
      IF (IERR.NE.0) GO TO 999
      GETOLD = F
C                                       Begin component loop.
 10   CONTINUE
         NUMBER = MAXCMP
         IF (NUMCLN.LT.MAXCMP) NUMBER = NUMCLN
C                                       Load CLEAN components this pass.
         FIRST = CLNLST
         JNUM = NUMBER
         CALL CMPCRM (APCORE, NAPCMS, APBUF, FIRST, NUMBER, NLOAD, T,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         WIN(1) = 1
         WIN(2) = 1
         WIN(3) = NY * 2
         WIN(4) = NX / 2 + 1
         IF (GETOLD) THEN
C                                       Open and INIT GRID file for read
            CALL ZOPEN (LUNGD1, FIND2, GRDVOL, GRDFIL, MAP, EXCL, WAIT,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1010) IERR
               GO TO 990
               END IF
            CALL MINIT ('READ', LUNGD1, FIND2, WIN(3), WIN(4), WIN,
     *         GBUFF, BUFSZ2, BOGRD, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1050) IERR
               GO TO 990
               END IF
            END IF
C                                       Open and INIT WRK file for writ
         CALL ZOPEN (LUNWRK, FIND1, WRKVOL, WRKFIL, MAP, EXCL, WAIT,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
         CALL MINIT ('WRIT', LUNWRK, FIND1, WIN(3), WIN(4), WIN, OBUFF,
     *      BUFSZ1, BOWRK, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Prepare NAPEXP using weight left
C                                       in AP loc 0 by INGAUS.
         CALL QVCLR (APCORE, NAPEXP, 1, ONENY)
         CALL QVSADD (APCORE, NAPEXP, 1, 0, NAPEXP, 1, ONENY)
         CALL QWR
C                                       Begin loop thru map.
         JLIM = NX / 2 + 1
         DO 150 I = 1,JLIM
C                                        Generate restoring factors.
            TEMP = (-0.5 * GAUSCC * (I - 1.0) ** 2 )
            RDUM(1) = TEMP
            CALL QPUT (APCORE, RDUM , 1, 1, 2)
            CALL QWAIT
            CALL QVSADD (APCORE, NAPGAU, 1, 1, NAPRES, 1, ONENY)
            CALL QVADD (APCORE, NAPRES, 1, NAPEXP, 1, NAPRES, 1, ONENY)
            CALL QVEXP (APCORE, NAPRES, 1, NAPRES, 1, ONENY)
C                                       Read row from GRID file.
            IF (GETOLD) THEN
               CALL MDISK ('READ', LUNGD1, FIND2, GBUFF, BIND2, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1080) IERR,I
                  GO TO 990
                  END IF
C                                       Load row from GRID file.
               CALL QPUT (APCORE, GBUFF(BIND2), NAPGRD, TWONY, 2)
               CALL QWD
            ELSE
               CALL QVCLR (APCORE, NAPGRD, 1, TWONY)
               END IF
C                                       Write file back to disk.
            CALL MDISK ('WRIT', LUNWRK, FIND1, OBUFF, BIND3, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1090) IERR, I
               GO TO 990
               END IF
C                                       Prepare NAPEXP for next pass.
            CALL QVADD (APCORE, NAPEXP, 1, NAPEX1, 1, NAPEXP, 1, ONENY)
            CALL QWR
C                                       Clear NAPCMP.
            CALL QVCLR (APCORE, NAPCMP, 1, TWONY)
C                                       Do direct transform in X.
            CALL QDIRAD (APCORE, NAPCMS, 5, NAPCMP, NUMBER)
            CALL QWR
C                                       Do FFT in Y.
            CALL QCFFT (APCORE, NAPCMP, ONENY, 1)
            CALL QWR
C                                       Multiply by restoring function.
            CALL QCRVMU (APCORE, NAPCMP, 2, NAPRES, 1, NAPCMP, 2, ONENY)
            CALL QWR
C                                       Add to GRID file.
            IF (GETOLD) CALL QVADD (APCORE, NAPCMP, 1, NAPGRD, 1,
     *         NAPCMP, 1, TWONY)
C                                       Read results back out.
            CALL QWR
            CALL QGET (APCORE, OBUFF(BIND3), NAPCMP, TWONY, 2)
            CALL QWD
C                                       Rotate DFT for next pass.
            WRK1 = NAPCMS + 1
            WRK2 = NAPCMS + 3
            CALL QCVMUL (APCORE, WRK1, 5, WRK2, 5, WRK1, 5, NUMBER, 1)
            CALL QWR
 150        CONTINUE
C                                       Finish writing WRK file.
         CALL MDISK ('FINI', LUNWRK, FIND1, OBUFF, BIND3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1090) IERR, JLIM
            GO TO 990
            END IF
C                                       End of this pass, close files.
         CALL ZCLOSE (LUNWRK, FIND1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1160) IERR
            CALL MSGWRT (8)
            END IF
         IF (GETOLD) THEN
            CALL ZCLOSE (LUNGD1, FIND2, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1160) IERR
               CALL MSGWRT (8)
               END IF
            END IF
         CLNLST = CLNLST + JNUM
         NUMCLN = NUMCLN - JNUM
C                                       Switch WRK and GRID files.
         CALL FSWTCH (GRDFIL, WRKFIL, GRDVOL, WRKVOL, CNOGRD, CNOWRK,
     *      BOGRD, BOWRK)
C                                       Roll AP if necessary
         IF (CLNLST.LE.CLNSTR) CALL QROLL (APCORE, NAPCMS, BUFF3,
     *      BUFSZ3, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Check for more CLEAN components.
         GETOLD = T
         IF (CLNLST.LE.CLNSTR) GO TO 10
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('RESTOR: ERROR ',I3,' OPENING GRID FILE ')
 1050 FORMAT ('RESTOR: ERROR ',I3,' INIT GRID FILE')
 1090 FORMAT ('RESTOR: WRITE ERROR ',I3,' GRID ROW ',I6)
 1080 FORMAT ('RESTOR: ERROR ',I3,' READ GRID ROW ',I6)
 1160 FORMAT ('RESTOR: ERROR ',I3,' CLOSING GRID FILE')
      END
      SUBROUTINE CMPCRM (APCORE, APLO, APBUF, FIRST, NUMBER, NLOAD,
     *   LFIRST, IERR)
C-----------------------------------------------------------------------
C   CMPCRM loads CLEAN components into the Array Processor
C   in preparation for transformation to the data plane.
C   If CMPCRM starts from the first component, the flux density
C   of the CLEAN components is summed.
C   The signs of the cell offsets are adjusted for flips made to
C   the map.
C    Input:
C     APLO   I   = AP start location for the component array.
C     APBUF  I   = AP start location for the buffer.
C     FIRST  I   = First CLEAN component to be loaded.
C     NUMBER I   = Number of CLEAN components to be loaded.
C     NLOAD  I   = AP buffer size.
C     LFIRST L   = .TRUE. iff CLEAN components are to be summed.
C    Output:
C     NUMBER  I     Number of clean components loaded.
C     CLEAN components loaded into the AP in blocks of 5 words
C     arrainged as follows:
C         0 = Y (integer form)
C         1 = FLUX * cos(UX)
C         2 = FLUX * sin(UX)
C         3,4 = cos, sin(X)
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
C
      INTEGER   FIRST, NUMBER
      INTEGER   IBUFF(512), IERR, NLOAD, LIMIT, NCOUNT, I, APLOC,
     *   APLOC1, APLOC2, APLOC3, APLOC4, APBUF, APLO, NNCNT, JJCNT,
     *   IPOINT, ICOUNT, JCOUNT
      REAL      CFLUX(1), TEMP(6), TWOPIX, RAC(1), DECC(1), XCEN, YCEN
      LOGICAL   LFIRST, FA
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'RSTOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (BUFF1(1), IBUFF(1))
      EQUIVALENCE (BUFF2(1), CFLUX(1)),      (BUFF3(1), RAC(1)),
     *   (BUFF3(MABFSL/2+1), DECC(1))
      DATA FA /.FALSE./
C-----------------------------------------------------------------------
C                                       Determine beam center.
      XCEN = CATR (KRCRP)
      YCEN = CATR (KRCRP+1)
      XCEN = (XCEN - NX/2 - 1) * XSPACE
      YCEN = (YCEN - NY/2 - 1) * YSPACE
C                                       Open CLEAN component file.
      JCOUNT = 0
      CALL CCMINI ('READ', CCBUFF, CLNVOL, CNOCLN, CLNVER, CATBLK,
     *   LUNCL2, CCRNO, CCKOLS, CCNUMV, CCNCOL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
      APLOC = APLO
      ICOUNT = 0
      IPOINT = FIRST
C                                       Begin loading into computer buff
C                                       Make sure to load in small
C                                       enough pieces.
      LIMIT = BUFSZ1 / 8
      IF (LIMIT.GT.NUMBER) LIMIT = NUMBER
      LIMIT = MIN (LIMIT, NLOAD)
C                                       Jump to here if more passes nece
 30   CONTINUE
         NCOUNT = 0
         DO 50 I = 1,LIMIT
            CCRNO = IPOINT
            CALL TABCCM ('READ', CCBUFF, CCRNO, CCKOLS, CCNUMV, CCNCOL,
     *         XX, YY, ZZ, CCFLUX, CCTYPE, PARMS, IERR)
            IF (IERR.GT.0) THEN
               WRITE (MSGTXT,1030) IERR, IPOINT
               GO TO 990
               END IF
            IF (((CCNCOL.LE.3) .OR. (CCTYPE.EQ.0.0)) .AND. (IERR.EQ.0))
     *            THEN
               NCOUNT = NCOUNT + 1
               CFLUX(NCOUNT) = CCFLUX * FACTOR
               RAC(NCOUNT) = XX + XCEN
               DECC(NCOUNT) = YY + YCEN
               END IF
            IPOINT = IPOINT + 1
 50         CONTINUE
         IF (NCOUNT.LE.0) GO TO 55
         NNCNT = NCOUNT
C                                       Form AP indexes.
         APLOC1 = APLOC + 1
         APLOC2 = APLOC + 2
         APLOC3 = APLOC + 3
         APLOC4 = APLOC + 4
C                                       Load data into AP buffer APBUF.
C                                       Load flux density (FLUX*cos(ux))
         CALL QPUT (APCORE, CFLUX, APBUF, NNCNT, 2)
         CALL QWD
         CALL QVMOV (APCORE, APBUF, 1, APLOC1, 5, NNCNT)
C                                        Load and fix dec cell numbers.
         CALL QWR
         CALL QPUT (APCORE, DECC, APBUF, NNCNT, 2)
         CALL QWD
C                                       Move values before fixing.
         CALL QVMOV (APCORE, APBUF, 1, APLOC, 5, NNCNT)
         CALL QWR
C                                       Set constants in AP.
         TEMP(1) = (-NY/2.) * YSPACE
         TEMP(2) = (NY/2.0-1.0) * YSPACE
         TEMP(3) = NY * YSPACE
         TEMP(4) = 2.0 / YSPACE
         TEMP(5) = 0.0
         TEMP(6) = -0.5 * YSPACE
         CALL QPUT (APCORE, TEMP, 1, 6, 2)
         CALL QWD
C                                       Put declinations in the range
C                                       (0,NY-1) and multiply by 2,fix.
C                                       Use APLOC2 for temporary use.
         CALL QVFILL (APCORE, 6, APLOC2, 5, NNCNT)
         CALL QVCLIP (APCORE, APLOC, 5, 1, 2, APLOC, 5, NNCNT)
         CALL QLVGT (APCORE, APLOC2, 5, APLOC, 5, APLOC2, 5, NNCNT)
         CALL QVSMUL (APCORE, APLOC2, 5, 3, APLOC2, 5, NNCNT)
         CALL QVADD (APCORE, APLOC2, 5, APLOC, 5, APLOC, 5, NNCNT)
         CALL QVSMAF (APCORE, APLOC, 5, 4, 5, APLOC, 5, NNCNT)
C                                       Load and float RA cell numbers.
         CALL QWR
         CALL QPUT (APCORE, RAC, APBUF, NNCNT, 2)
         CALL QWD
         CALL QVMOV (APCORE, APBUF, 1, APLOC3, 5, NNCNT)
C                                       Store -2*PI/NX/XSPACE
         TWOPIX = (-6.283185/NX) / XSPACE
         CALL QWR
         RDUM(1) = TWOPIX
         CALL QPUT (APCORE, RDUM, 1, 1, 2)
         CALL QWD
C                                       Scale RAs by -2*PI/NX/XSPACE
         CALL QVSMUL (APCORE, APLOC3, 5, 1, APLOC3, 5, NNCNT)
C                                       Clear APLOC+2 (FLUX*sin(ux) ).
         CALL QVCLR (APCORE, APLOC2, 5, NNCNT)
C                                       Take sine and cosine of
C                                       RA to 3 and 4.
         CALL QVSIN (APCORE, APLOC3, 5, APLOC4, 5, NNCNT)
         CALL QVCOS (APCORE, APLOC3, 5, APLOC3, 5, NNCNT)
 55      ICOUNT = ICOUNT + LIMIT
         JCOUNT = JCOUNT + NCOUNT
C                                       If load complete close CLNFIL
C                                       and return.
         IF (ICOUNT.GE.NUMBER) GO TO 60
C                                       Update APLOC.
            APLOC = APLOC + NNCNT * 5
            IF (NUMBER-ICOUNT.LT.LIMIT) LIMIT = NUMBER - ICOUNT
C                                       Return for another load.
            GO TO 30
C                                       IF (LFIRST) sum fluxes.
 60   IF (.NOT.LFIRST) GO TO 65
         APLOC1 = APLO + 1
         JJCNT = JCOUNT
         CALL QSVE (APCORE, APLOC1, 5, 1, JJCNT)
         CALL QWR
         CALL QGET (APCORE, RDUM, 1, 1, 2)
         TEMP = RDUM(1)
         CALL QWD
         FLUX = FLUX + TEMP(1)
C                                     Make sure CC loaded.
 65   IF (JCOUNT.GT.0) GO TO 70
         WRITE (MSGTXT,1065)
         IERR = 1
         GO TO 990
 70   NUMBER = JCOUNT
C                                       Close CLNFIL.
      CALL TABCCM ('CLOS', CCBUFF, CCRNO, CCKOLS, CCNUMV, CCNCOL,
     *   XX, YY, ZZ, CCFLUX, CCTYPE, PARMS, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1070) IERR
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CMPCRM: ERROR',I3,' OPENING FILE ')
 1030 FORMAT ('CMPCRM: READ ERROR',I3,' RECORD ',I5)
 1065 FORMAT ('CMPCRM: NO POINT CLEAN COMPONENTS FOUND')
 1070 FORMAT ('CMPCRM: ERROR',I3,' CLOSING FILE ')
      END
      SUBROUTINE INGAUS (APCORE)
C-----------------------------------------------------------------------
C   INGAUS creates the arrays in the AP necessary for restoring with
C   an eliptical gaussian.
C    Input:
C     NX,NY     I    Number of map grid cells in X and Y.
C     GAUSA     R    Major Axis (FWHP in cells)
C     GAUSB     R    Minor axis size (FWHP in cells).
C     GAUSB     R    Position angle of restoring beam (deg ).
C     XSPACE    R    RA grid spacing (deg).
C     YSPACE    R    Dec grid spacing (deg).
C     MAPROT    R    Coordinate rotation (deg).
C    Output:
C     GAUSAA     R    Coefficient of u**2
C     GAUSBB     R    Coefficient of u*v
C     GAUSCC     R    Coefficient of v**2
C     Normalization constant for the restoring Gaussian left in
C                  AP location 0.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      REAL      COMP(1), WT, WT1, XNX2, XNY2, XNXNY, TEMP,
     *   AK, AM, AN, TA, TB, ARG
      INTEGER   I, JLIM, K, NAPRES, NAPGAU, NAPEXP, NAPEX1, NAPGRD,
     *   NAPCMP, NAPCMS, NAPRS1, ONENY, TWONY, WRK1, WRK2
      INCLUDE 'RSTOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (BUFF1(1), COMP(1))
C-----------------------------------------------------------------------
C                                       Set AP assignments.
      ONENY = NY
      TWONY = 2 * NY
      NAPRES = 100
      WRK1 = ONENY + 1
      WRK2 = TWONY + 1
      NAPEXP = NAPRES + WRK1
      NAPGRD = NAPEXP + WRK1
      NAPCMP = NAPGRD + WRK2
      NAPGAU = NAPCMP + WRK2
      NAPEX1 = NAPGAU + WRK1
      NAPCMS = NAPEX1 + WRK1
C                                       Do a little arithmetic to put
C                                       the beam parameters into useable
C                                       form. Convert to sigma, then to
C                                       coeficients of U**2, U*V, and
C                                       V**2 the last of which is return
C                                       for later use.
      TA = GAUSA * 3.1415927 / 1.1774
      TB = GAUSB * 3.1415927 / 1.1774
      AM = COS ((GAUSC + MAPROT) * 3.1415927 / 180.)
      AN = SIN ((GAUSC + MAPROT) * 3.1415927 / 180.)
      XNX2 = NX * XSPACE * 3600.
      XNY2 = NY * YSPACE * 3600.
      XNXNY = ABS (XNX2 * XNY2)
      XNX2 = XNX2 ** 2
      XNY2 = XNY2 ** 2
      GAUSAA = (TA*TA*AM*AM + TB*TB*AN*AN) / (XNY2)
      GAUSCC = (TA*TA*AN*AN + TB*TB*AM*AM) / (XNX2)
      GAUSBB = ((TB*TB-TA*TA) * AN*AM) / (XNXNY )
C                                       Create array NAPEX1.
      DO 10 I = 1,NY
         K = I - 1
         IF (I.GT.NY/2) K = K - NY
         COMP(I) = (-GAUSBB * K)
 10      CONTINUE
C                                       Load NAPEX1 into AP.
      CALL QPUT (APCORE, COMP, NAPEX1, ONENY, 2)
      CALL QWD
C                                       Create array NAPGAU.
      DO 20 I = 1,NY
         K = I - 1
         IF (I.GT.NY/2) K = K - NY
         AK = K
         COMP(I) = -0.5 * GAUSAA * AK * AK
 20      CONTINUE
C                                       Load NAPGAU into AP.
      CALL QPUT (APCORE, COMP, NAPGAU, ONENY, 2)
C                                       Initialize array NAPEXP.
      CALL QPUT (APCORE, 0.0, 0, 1, 2)
      CALL QWD
      CALL QVCLR (APCORE, NAPEXP, 1, ONENY)
      CALL QVSADD (APCORE, NAPEXP, 1, 0, NAPEXP, 1, ONENY)
C                                       Initialize NAPRES for summing
C                                       weights
      NAPRS1 = NAPRES - 1
      WRK1 = ONENY + 1
      CALL QVCLR (APCORE, NAPRS1, 1, WRK1)
      CALL QWR
C                                       Calculate sum of the weights.
      JLIM = NX / 2
      DO 40 I = 1,JLIM
         TEMP = -0.5 * GAUSCC * (I - 1.0) ** 2
         RDUM(1) = TEMP
         CALL QPUT (APCORE, RDUM, 1, 1, 2)
         CALL QWD
         CALL QVSADD (APCORE, NAPGAU, 1, 1, NAPRES, 1, ONENY)
         CALL QVADD (APCORE, NAPRES, 1, NAPEXP, 1, NAPRES, 1, ONENY)
         CALL QVEXP (APCORE, NAPRES, 1, NAPRES, 1, ONENY)
         CALL QSVE (APCORE, NAPRS1, 1, NAPRS1, WRK1)
C                                       Prepare NAPEXP for next pass.
         CALL QVADD (APCORE, NAPEXP, 1, NAPEX1, 1, NAPEXP, 1, ONENY)
         CALL QWR
C                                       Get intermediate sum.
         IF (I.EQ.1) THEN
            CALL QGET (APCORE, RDUM, NAPRS1, 1, 2)
            WT1 = RDUM(1)
            END IF
 40      CONTINUE
C                                       Get sum of the weights.
      CALL QGET (APCORE, RDUM, NAPRS1, 1, 2)
      WT = RDUM(1)
      CALL QWD
C                                       Compute weight over whole plane.
      WT = 2.0 * WT - WT1
      ARG = 1.0 / WT
      WT = LOG (ARG)
C                                       Store WT in AP loc 0.
      RDUM(1) = WT
      CALL QPUT (APCORE, RDUM, 0, 1, 2)
      CALL QWD
C
 999  RETURN
      END

      SUBROUTINE QIHIST (APCORE, A, I, C, N, NB, AMAX, AMIN)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Make histogram of an integer vector.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   QIHIST computes the histogram of an integer vector.
C   Histogram element DATA - MIN where DATA is the intger data value is
C   incremented.
C   Inputs:
C      A     I  Source vector base address.  INTGER valued
C      I     I  A address increment.
C      C     I  Histogram base address
C                 Histogram must be cleared before first call.
C      N     I  Element count for A
C      NB    I  Number of bins in histogram
C      AMAX  I  Address of histogram maximum.  INTEGER valued
C      AMIN  I  Address of histogram minimum.  INTEGER valued
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   A, I, C, N, NB, AMAX, AMIN
C
      LONGINT   JA, JC, JAMAX, JAMIN, INDEX, LOOP, LEND, ITEMP, LMAX,
     *   LMIN
      DOUBLE PRECISION DMAX, DMIN
      INTEGER   XMIN, NMSG, XMAX
      EQUIVALENCE (LMAX, DMAX), (LMIN, DMIN)
      INCLUDE 'INCS:DAPC.INC'
      INCLUDE 'INCS:DMSG.INC'
      SAVE NMSG
      DATA NMSG /0/
C-----------------------------------------------------------------------
C                                       Addresses to 1-rel
      JA = A + PSAPOF
      JC = C + PSAPOF
      JAMAX = AMAX + PSAPOF
      JAMIN = AMIN + PSAPOF
      DMAX = APCORE(JAMAX)
      DMIN = APCORE(JAMIN)
      XMIN = LMIN
      XMAX = LMAX
C                                        Compute histogram.
      IF (NB-1.NE.XMAX-XMIN) THEN
         WRITE (MSGTXT,1000) NB, XMIN, XMAX
         IF (NMSG.LT.4) CALL MSGWRT (6)
         NMSG = NMSG + 1
         END IF
      LEND = JA + (N-1) * I
      ITEMP = JC + NB - 1
      DO 100 LOOP = JA,LEND,I
         XMAX = APCORE(LOOP)
         INDEX = XMAX - XMIN + JC
         INDEX = MAX (JC, INDEX)
         INDEX = MIN (INDEX, ITEMP)
         APCORE(INDEX) = APCORE(INDEX) + 1.0
 100     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('QIHIST: # BINS',I9,' NOT EQUAL RANGE',2I9)
      END

      SUBROUTINE PLOTWO (BLC, TRC, BX, BY, TX, TY, BLACKN, COLOR, PLBUF,
     *   GERR)
C-----------------------------------------------------------------------
C! plot a line segment, limiting the end points to be within BLC,TRC
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2002-2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Plot two points of a line, limiting the lines to within BLC, TRC
C   Inputs:
C      BLC      R(2)      Plot lower left corner (pixels)
C      TRC      R(2)      Plot upper right corner (pixels)
C      BX       R(2)      X coordinates of two points
C      BY       R(2)      Y coordinates of two points
C      BLACKN   L         Write as a dark vector?
C      COLOR    L         Write as 3-color vector
C   In/Out:
C      TX       R         Last X coordinate
C      TY       R         Last Y coordinate
C      PLBUF    I(256)    Plot IO buffer
C   Output:
C      GERR     I         Plot error code: 0 => okay
C-----------------------------------------------------------------------
      REAL      BLC(2), TRC(2), BX(2), BY(2), TX, TY
      INTEGER   PLBUF(256), GERR
      LOGICAL   BLACKN, COLOR
C
      INTEGER   IER
      REAL      LX(2), LY(2)
C-----------------------------------------------------------------------
      GERR = 0
      LX(1) = BX(1)
      LX(2) = BX(2)
      LY(1) = BY(1)
      LY(2) = BY(2)
C                                       Limit lines to inside border
      CALL LINLIM (BLC, TRC, LX(1), LY(1), IER)
      IF (IER.EQ.0) THEN
C                                       Move to begin line, if needed
         IF ((TX.NE.LX(1)) .OR. (TY.NE.LY(1))) THEN
            CALL GPOS (LX(1), LY(1), PLBUF, GERR)
            IF (GERR.EQ.0) THEN
               TX = LX(1)
               TY = LY(1)
               END IF
            END IF
C                                       Draw line section
         IF (GERR.EQ.0) THEN
            IF (BLACKN) THEN
               CALL GDVEC (LX(2), LY(2), PLBUF, GERR)
            ELSE IF (COLOR) THEN
               CALL G3VEC (LX(2), LY(2), PLBUF, GERR)
            ELSE
               CALL GVEC (LX(2), LY(2), PLBUF, GERR)
               END IF
            IF (GERR.EQ.0) THEN
               TX = LX(2)
               TY = LY(2)
               END IF
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZMCACL (NBYTES, INBUF, OUTBUF, LASTCH)
C-----------------------------------------------------------------------
C! convert Modcomp compressed ASCII to Hollerith characters (for FILLR)
C# Z Binary Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Convert Modcomp compressed ASCII characters to local uncompressed
C   characters.  Successive calls will append data to the end of the
C   output buffer.  One compressed record is processed per call.
C
C   NOTE: this routine will not work inplace.
C
C   Modcomp compressed ASCII format for each logical record:
C      BYTE              Use
C       0     ASCII ETX (Hex 03)
C       1     checksum (optional)
C      2-3    byte count, negative => end of file (not on tape?)
C             (NOTE: may be bytes 1-2)
C      4-     Compressed ASCII characters.  A NULL (Hex 00) terminates.
C             A negative value (most significant bit on) indicates a
C             repetition of the previous character the number of times
C             indicated by the absolute value of the negative number.
C             Example: an ASCII 'C' followed by a byte with the HEX
C             value FF (2's complement -1) indicates two 'C's.
C
C   Inputs:
C      INBUF    I(*)   Input buffer of Modcomp compressed ASCII packed
C                      characters
C   In/out:
C      NBYTES   I      (In)  Maximum number of bytes to convert
C                      (Out) Number of bytes added to the output buffer
C      LASTCH   I      Position of the next character in the output
C                      buffer (zero before first call)
C   Output:
C      OUTBUF   H(*)   Output buffer containing packed characters (due
C                      to the expansion of the data, the size of the
C                      output buffer is not strictly predictable)
C
C   Convex version (should work for any machine supporting the BYTE
C   data type and on which a BYTE variable can be treated as a signed
C   integer).
C-----------------------------------------------------------------------
      INTEGER   NBYTES, LASTCH
      BYTE      INBUF(*), OUTBUF(*)
C
      INTEGER   LOOP, RPOINT, BYTCNT, REPEAT, I, OBCNT, INPNT
      BYTE      ETX, NULL, LAST
      DATA ETX, NULL /3, 0/
C-----------------------------------------------------------------------
      IF (NBYTES.LE.0) GO TO 999
C                                       Initialize pointers, etc.
         INPNT = 1
         IF (LASTCH.LE.0) LASTCH = 1
         RPOINT = LASTCH
         OBCNT = 0
C                                       First character should be ETX.
         IF (INBUF(INPNT).EQ.ETX) THEN
C                                       Skip check sum.
            INPNT = INPNT + 2
C                                       Get byte count.
            CALL ZI16IL (1, 1, INBUF(INPNT), BYTCNT)
            INPNT = INPNT + 2
C                                       Trap no data.
            IF (BYTCNT.LE.0) GO TO 100
C                                       Loop over record.
               DO 90 LOOP = 1,BYTCNT
C                                       Check for buffer exhausted or
C                                       next character NULL.
                  IF ((INPNT.GT.NBYTES) .OR. (INBUF(INPNT).EQ.NULL))
     *               GO TO 100
C                                       Expand repeated character.
                     IF (INBUF(INPNT).LE.0) THEN
                        REPEAT = INBUF(INPNT)
                        REPEAT = -REPEAT
                        LAST = OUTBUF(LASTCH-1)
                        DO 50 I = 1,REPEAT
                           OUTBUF(LASTCH) = LAST
                           LASTCH = LASTCH + 1
                           OBCNT = OBCNT + 1
 50                        CONTINUE
C                                       single character
                     ELSE
                        OUTBUF(LASTCH) = INBUF(INPNT)
                        LASTCH = LASTCH + 1
                        OBCNT = OBCNT + 1
                        END IF
                     INPNT = INPNT + 1
 90               CONTINUE
C                                       Convert to local characters.
 100        CALL ZC8CL (OBCNT, 1, OUTBUF(RPOINT), OUTBUF(RPOINT))
            NBYTES = OBCNT
C                                       Didn't find ETX as expected.
      ELSE
         NBYTES = 0
         END IF
C
 999  RETURN
      END

      SUBROUTINE MODPLT (NPLO, NPT, XDATA, YDATA, BUFFER, IERR)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Subroutine to plot model values obtained by MODEL
C   Inputs:
C      NPLO     I          type of y-axis
C                             1 --> amplitude
C                             2 --> phase
C                             3 --> u,v distance
C                             4 --> u,v p.a.
C                             5 --> time (iat days)
C                             6 --> u
C                             7 --> v
C                             8 --> w
C                             9 --> sine channel
C                            10 --> cosine channel
C                            11 --> GAST
C      NPT      I          Number of values
C      XDATA    R(NPT)     X values
C      YDATA    R(2,NPT)   Y values
C   In/Out
C      BUFFER   I(*)       Plot buffer
C   Outputs:
C      IERR     I          Error code
C   Programmer: L.B.Baath  Onsala Space Observatory  29 october 1982
C-----------------------------------------------------------------------
      INTEGER   NPLO, NPT, BUFFER(*), IERR
      REAL      XDATA(*), YDATA(*)
C
      LOGICAL   DOMDL
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 1
      DOMDL = (NPLO.EQ.1) .OR. (NPLO.EQ.2) .OR. (NPLO.EQ.9) .OR.
     *   (NPLO.EQ.10)
      IF (DOMDL) THEN
         CALL PLOTDA (XDATA, YDATA, NPT, NPLO, 0.0, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (6)
            END IF
C                                      error return
      ELSE
         WRITE (MSGTXT,1980) NPLO
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MODPLT: PLOTDA ERROR = ',I3)
 1980 FORMAT ('MODPLT: ERROR IN NPLO = ',I5)
      END

      SUBROUTINE YTVCL2 (LUN, IND, IERR)
C-----------------------------------------------------------------------
C! close actual TV device (called by YTVCLS)
C# Y3 TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YTVCL2 closes TV DEVICE associated with LUN removing any EXCLusive
C   use state and clears up the FTAB.
C   Inputs:
C      LUN    I   logical unit number
C      IND    I   pointer into FTAB
C   Output:
C      IERR   I   error code: 0 -> no error
C                    1 -> Deaccess or Deassign error
C                    2 -> file already closed in FTAB
C                    3 -> both errors
C                    4 -> erroneous LUN
C   Virtual TV version - TV by communication
C-----------------------------------------------------------------------
      INTEGER   LUN, IND, IERR
C-----------------------------------------------------------------------
C                                       Close the device
      CALL ZVTVCL (LUN, IND, IERR)
C
 999  RETURN
      END

      SUBROUTINE TBHEAD (OPER, IVOL, ISLOT, IERR)
C-----------------------------------------------------------------------
C! verbs to put/get table header values
C# POPS-appl Ext-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000, 2006, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This routine reads and writes values from/to an AIPS table header.
C   Keywords with names passed in KEYWRD are read or written.  The are
C   two special cases:
C      If KEYWORD='NUM ROW' then the number of rows in the table are
C   returned in KEYVAL.
C      If KEYWRD='FIND COL' then the column with the label given in
C   KEYSTR will be located and it's column number returned in KEYVAL.
C   The search will be only for the number of characters specified.
C   Inputs:
C      OPER    C*4  'READ' or 'WRIT' operation desired.
C      IVOL    I    Disk number
C      ISLOT   I    Catalog slot number
C   Common: (though adverbs in common)
C      INEXT     H*2  Table type (e.g. AN, SU)
C      INVER     R    the version number of the table.
C      KEYWORD  H*8   FITS keyword corresponding to a header value
C      KEYVALUE R(2)  Numeric value out/in
C      KEYSTRNG H*16  String value out/in
C   Output:
C      IERR     I     Error code, 0=> OK else failed
C-----------------------------------------------------------------------
      CHARACTER OPER*4
      INTEGER   IVOL, ISLOT, IERR
C
      CHARACTER PRGNAM*8, THEWRD*8, STVALU*16, TABTYP*2, KEYS*24,
     *   HILINE*72, HILIN2*72, NEWSTR*8, OLDSTR*8, CDUM, DATYPE*4
      INTEGER   POTERR, IROUND, VER, IBUFF2(512), TLUN, IKEY, NREC,
     *   NCOL, DATP(128,2), NKEY, KEYTYP, KEYLOC, KEYVI, LKEY,
     *   KOL, I, JERR, ITRIM, IERH, IHLUN, OLDVI, IDUM
      HOLLERITH KEYVH(2), OLDVH(2)
      REAL     KEYVR, OLDVR, RDUM(2), DOHI
      DOUBLE PRECISION D, TEMPD, KEYVD, OLDVD
      LOGICAL   KEYVL, OLDVL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHIS.INC'
      EQUIVALENCE (KEYVI, KEYVR, KEYVH, KEYVD, KEYVL)
      EQUIVALENCE (OLDVI, OLDVR, OLDVH, OLDVD, OLDVL)
      DATA TLUN, IHLUN /28,29/
      DATA PRGNAM /'TBHEAD'/
C-----------------------------------------------------------------------
      POTERR = 0
C                                       Read CATBLK
      CALL CATIO ('READ', IVOL, ISLOT, CATBLK, 'REST', IBUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         IF (IERR.EQ.5) MSGTXT = 'FILE IS BUSY'
         POTERR = 33
         GO TO 970
         END IF
C                                       Open table
      IKEY = 1
      NREC = 10
      NCOL = 0
      CALL ADVERB ('INEXT', 'C', 1, 2, IDUM, RDUM, TABTYP)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INVERS', 'I', 1, 0, VER, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
C                                       Find highest if no version given
      IF (VER.LE.0) CALL FNDEXT (TABTYP, CATBLK, VER)
C                                       Open table
      CALL TABINI (OPER, TABTYP, IVOL, ISLOT, VER, CATBLK, TLUN,
     *   IKEY, NREC, NCOL, DATP, IBUFF2, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1100) IERR, OPER, TABTYP, VER
         POTERR = 61
         GO TO 970
         END IF
      NKEY = 1
C                                       Decode KEYWORD
      CALL ADVERB ('KEYWORD', 'C', 1, 8, IDUM, RDUM, THEWRD)
      IF (ERRNUM.NE.0) GO TO 980
C                                       Trap special cases here
C                                       Number of rows in the table
      IF (THEWRD.EQ.'NUM ROW') THEN
         RDUM(1) = IBUFF2(5)
         RDUM(2) = 0.0
         CALL ADVRBS ('KEYVALUE', 'R', 2, 0, IDUM, RDUM, CDUM)
         GO TO 800
         END IF
C                                       Find column with label in KEYSTR
      IF (THEWRD.EQ.'FIND COL') THEN
         NKEY = 1
         KEYS = '  '
         CALL ADVERB ('KEYSTRNG', 'C', 1, 16, IDUM, RDUM, KEYS)
         IF (ERRNUM.NE.0) GO TO 800
         LKEY = ITRIM (KEYS)
         CALL FNDCOL (NKEY, KEYS, LKEY, .TRUE., IBUFF2, KOL, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1200) IERR, KEYS
            CALL MSGWRT (7)
            POTERR = 61
            GO TO 800
            END IF
         RDUM(1) = KOL
         RDUM(2) = 0.0
         CALL ADVRBS ('KEYVALUE', 'R', 2, 0, IDUM, RDUM, CDUM)
         GO TO 800
         END IF
C                                       Find Keyword to get type.
      IF (OPER.EQ.'WRIT') MSGSUP = 32000
      CALL TABKEY ('READ', THEWRD, NKEY, IBUFF2, KEYLOC, OLDVI, KEYTYP,
     *   IERR)
      MSGSUP = 0
      IF (IERR.NE.0) THEN
C                                       new keyword to write
         IF ((OPER.EQ.'WRIT') .AND. (IERR.GT.20)) THEN
C                                       KEYTYPE
            CALL ADVERB ('KEYTYPE', 'C', 1, 4, IDUM, RDUM, DATYPE)
            IF (ERRNUM.NE.0) GO TO 980
            KEYTYP = 0
            IF (DATYPE(:1).EQ.'D') KEYTYP = 1
C                                       Note R*4 deprecated
            IF (DATYPE(:1).EQ.'R') KEYTYP = 1
            IF (DATYPE(:1).EQ.'C') KEYTYP = 3
            IF (DATYPE(:1).EQ.'I') KEYTYP = 4
            IF (DATYPE(:1).EQ.'L') KEYTYP = 5
            IF (KEYTYP.EQ.0) THEN
               MSGTXT = 'NEW KEYWORD INVALID TYPE = ''' // DATYPE(:1) //
     *            ''''
               CALL MSGWRT (7)
               POTERR = 61
               GO TO 800
               END IF
         ELSE
            WRITE (MSGTXT,1300) IERR, THEWRD
            CALL MSGWRT (7)
            POTERR = 61
            GO TO 800
            END IF
         END IF
C                                       Get ready to write value
      IF (OPER.EQ.'WRIT') THEN
C                                       Enter data in VALUE via
C                                       EQUIVALENCE
         CALL ADVERB ('KEYSTRNG', 'C', 1, 16, IDUM, RDUM, STVALU)
         IF (ERRNUM.NE.0) GO TO 800
         CALL ADVERB ('KEYVALUE', 'R', 2, 0, IDUM, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 800
         KEYVD = 0.0D0
         CALL POPSRD ('R2D', RDUM, TEMPD)
         IF (KEYTYP.EQ.1) KEYVD = TEMPD
         IF (KEYTYP.EQ.2) KEYVR = RDUM(1)
         IF (KEYTYP.EQ.3) CALL CHR2H (8, STVALU, 1, KEYVH)
         IF (KEYTYP.EQ.4) KEYVI = IROUND (RDUM(1))
         IF (KEYTYP.EQ.5) KEYVL = STVALU(:1).EQ.'T'
         KEYLOC = 1
         END IF
C                                       Read/update keyword.
      CALL TABKEY (OPER, THEWRD, NKEY, IBUFF2, KEYLOC, KEYVI, KEYTYP,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1500) IERR, OPER
         CALL MSGWRT (7)
         POTERR = 61
         GO TO 800
         END IF
C                                       Put value back into adverbs
      IF (OPER.EQ.'READ') THEN
         IF (KEYTYP.EQ.1) THEN
            CALL RCOPY (NWDPDP, KEYVD, D)
            CALL POPSRD ('D2R', RDUM, D)
         ELSE IF (KEYTYP.EQ.2) THEN
            RDUM(1) = KEYVR
            RDUM(2) = 0.0
         ELSE IF (KEYTYP.EQ.3) THEN
            STVALU = ' '
            CALL H2CHR (8, 1, KEYVH, STVALU)
         ELSE IF (KEYTYP.EQ.4) THEN
            RDUM(1) = KEYVI
            RDUM(2) = 0.0
         ELSE IF (KEYTYP.EQ.5) THEN
            IF (KEYVL) THEN
               STVALU = 'T'
            ELSE
               STVALU = 'F'
               END IF
            END IF
         IF ((KEYTYP.EQ.3) .OR. (KEYTYP.EQ.5)) THEN
            CALL ADVRBS ('KEYSTRNG', 'C', 1, 16, IDUM, RDUM, STVALU)
            IF (ERRNUM.NE.0) GO TO 800
         ELSE IF ((KEYTYP.EQ.1) .OR. (KEYTYP.EQ.2) .OR. (KEYTYP.EQ.4))
     *      THEN
            CALL ADVRBS ('KEYVALUE', 'R', 2, 0, IDUM, RDUM, CDUM)
            IF (ERRNUM.NE.0) GO TO 800
            END IF
         END IF
C                                       Close table
 800  CALL TABIO ('CLOS', 1, I, IBUFF2, IBUFF2, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1800) JERR, TABTYP, VER
         IF (POTERR.EQ.0) POTERR = 61
         IF (IERR.EQ.0) IERR = JERR
         GO TO 970
         END IF
C                                       Any history
      CALL ADVERB ('DOHIST', 'R', 1, 0, IDUM, RDUM, CDUM)
      DOHI = RDUM(1)
      IF (ERRNUM.NE.0) GO TO 980
      IF ((OPER.EQ.'WRIT') .AND. (DOHI.GT.-1.5)) THEN
C                                       Open history file
         CALL HIOPEN (IHLUN, IVOL, ISLOT, IBUFF2, IERH)
         IF (IERH.NE.0) GO TO 980
C                                       Which table?
         WRITE (HILINE,2800) TSKNAM, 'PUTTHEAD', TABTYP, VER
         CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
C                                       Add entries by type
C                                       Double precision
         IF (KEYTYP.EQ.1) THEN
            WRITE (HILINE,2801) TSKNAM, 'PUTTHEAD', THEWRD, KEYVD
            WRITE (HILIN2,3801) TSKNAM, 'PUTTHEAD', OLDVD
C                                       Real
         ELSE IF (KEYTYP.EQ.2) THEN
            WRITE (HILINE,2802) TSKNAM, 'PUTTHEAD', THEWRD, KEYVR
            WRITE (HILIN2,3802) TSKNAM, 'PUTTHEAD', OLDVR
C                                       Character
         ELSE IF (KEYTYP.EQ.3) THEN
            CALL H2CHR (8, 1, KEYVH, NEWSTR)
            CALL H2CHR (8, 1, OLDVH, OLDSTR)
            WRITE (HILINE,2803) TSKNAM, 'PUTTHEAD', THEWRD, NEWSTR
            WRITE (HILIN2,3803) TSKNAM, 'PUTTHEAD', OLDSTR
C                                       Integer
         ELSE IF (KEYTYP.EQ.4) THEN
            WRITE (HILINE,2804) TSKNAM, 'PUTTHEAD', THEWRD, KEYVI
            WRITE (HILIN2,3804) TSKNAM, 'PUTTHEAD', OLDVI
C                                       Logical
         ELSE IF (KEYTYP.EQ.5) THEN
            CALL H2CHR (1, 1, KEYVH, NEWSTR)
            CALL H2CHR (1, 1, OLDVH, OLDSTR)
            WRITE (HILINE,2805) TSKNAM, 'PUTTHEAD', THEWRD, NEWSTR(1:1)
            WRITE (HILIN2,3805) TSKNAM, 'PUTTHEAD', OLDSTR(1:1)
            END IF
C                                       Add history entries
         IF (IERH.EQ.0) CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
         IF (IERH.EQ.0) CALL HIADD (IHLUN, HILIN2, IBUFF2, IERH)
         CALL HICLOS (IHLUN, .TRUE., IBUFF2, IERH)
         END IF
      GO TO 980
C-----------------------------------------------------------------------
C                                       Print error.
 970  CALL MSGWRT (8)
C                                       AIPS error management.
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CATALOG READ ERROR',I5)
 1100 FORMAT ('TABINI ERROR ',I3,' OPEN FOR ',A4,1X,A2,', TABLE ',
     *   ' VER=',I3)
 1200 FORMAT (' ERROR ',I4,' FINDING COLUMN ',A)
 1300 FORMAT (' ERROR ',I4,' FINDING HEADER KEYWORD ',A)
 1500 FORMAT ('TABKEY ERROR',I3,1X,A,'ING TABLE KEYWORD')
 1800 FORMAT ('TABIO ERROR ',I3,' CLOSING ',A2,' TABLE VER=',I3)
 2800 FORMAT (A,':',A,': INEXT=''',A,''', INVERS=',I3,' /Table edited')
 2801 FORMAT (A,':',A,': KEYWORD=''',A,''',KEYVALUE=', 1PD20.12)
 3801 FORMAT (A,':',A,': / Old value =',1PD20.12)
 2802 FORMAT (A,':',A,': KEYWORD =''',A,''',KEYVALUE(1)=',1PE15.5)
 3802 FORMAT (A,':',A,': / Old value =',1PE12.5)
 2803 FORMAT (A,':',A,': KEYWORD =''',A,''',KEYSTRNG=''',A,'''')
 3803 FORMAT (A,':',A,': / Old value =''',A,'''')
 2804 FORMAT (A,':',A,': KEYWORD =''',A,''', KEYVALUE(1)=',I10)
 3804 FORMAT (A,':',A,': / Old value = ',I10)
 2805 FORMAT (A,':',A,': KEYWORD =''',A,''', KEYSTRNG=''',A,'''')
 3805 FORMAT (A,':',A,': / Old value =''',A,'''')
      END

LOCAL INCLUDE 'VH2RL.INC'
C                                       Local include for VH2RL
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4,30), XCALC(1), XNAMOU(3),
     *   XCLAOU(2)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XANT(50), XBASE(50),  XSUBA, XBIF, XEIF, XBCHAN, XECHAN,
     *   XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER,
     *   XSMOTH(3), XDOAC, XSOUT, XDISO, XCENT, BADD(10),
     *   SCRBUF(256), BUFF2(UVBFSS), DIFPIX
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS, JBUFSZ, ILOCWT,
     *   CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO,
     *   LRECO, NRPRMI, NRPRMO, OLDCNO, NEWCNO, IXANT(50), IXBAS(50),
     *   NXANT, NXBAS
      LOGICAL   ISCOMP, DESEL, DOVHRL
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, HISCRD(10)*64
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XTIME, XBAND, XFREQ, XFQID, XANT, XBASE, XSUBA, XBIF, XEIF,
     *   XBCHAN, XECHAN, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG,
     *   XDOBND, XBPVER, XSMOTH, XDOAC, XNAMOU, XCLAOU, XSOUT, XDISO,
     *   XCENT, BADD
      COMMON /VH2RLP/ CATOLD, SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS,
     *   ILOCWT, INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECO,
     *   NRPRMI, NRPRMO, ISCOMP, OLDCNO, NEWCNO, DIFPIX, IXANT, IXBAS,
     *   NXANT, NXBAS, DESEL, DOVHRL
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, HISCRD
      COMMON /BUFRS/ SCRBUF, BUFF2, JBUFSZ
C                                       End local include for VH2RL
LOCAL END
      PROGRAM VH2RL
C-----------------------------------------------------------------------
C! Allows user to provide subroutine to operate on UV data base
C# Utility UV UV-util VLA VLB Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   VH2RL converts linear polarization into circular
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C   full set of calibration adverbs
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'VH2RL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'VH2RL '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL VH2RLI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL VH2RLD (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL VH2RLH
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE VH2RLI (PRGN, JERR)
C-----------------------------------------------------------------------
C   VH2RLI gets input parameters for VH2RL and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in VH2RL for more details.
C
C   To change the adverb list sent to this task change:
C   1)  the inputs file.
C   2)  the contents of COMMON /INPARM/.  Remember all adverbs are sent
C       as R, INNAME etc. are 12 char. 3 words;
C       INCLASS etc. are 6 char., 2 words.
C       Values will be filled into COMMON /INPARM/ in the order
C       specified in the inputs file.
C   3)  If the first adverb is not INNAME (NAMEIN) then replace
C       NAMEIN in the call to GTPARM with the name of the first
C       adverb.
C   4)  Change the value of NPARM sent to GTPARM to the number of
C       R words desired.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, DEFCLS*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, NFREQ, LUN
      LOGICAL   MATCH
      REAL      CATR(256), RPARM(20)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128), STK
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'VH2RL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 275
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      STOKES = 'FULL'
      DO 5 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 5       CONTINUE
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = XDOAC.GT.0.0
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       check polarization
      IF ((CATBLK(KINAX+JLOCS).NE.4) .OR.
     *   (ABS(CATR(KRCRP+JLOCS)-1.).GT.0.01) .OR.
     *   (ABS(CATR(KRCIC+JLOCS)+1.).GT.0.01)) THEN
         JERR = 10
         MSGTXT = 'STOKES AXIS VALUES NOT SUPPORTED'
         GO TO 990
         END IF
      STK = CATD(KDCRV+JLOCS) + (1.0 - CATR(KRCRP+JLOCS)) *
     *   CATR(KRCIC+JLOCS)
      IF ((ABS(STK+5.0).GT.0.001) .AND. (ABS(STK+1.0).GT.0.001)) THEN
         JERR = 10
         MSGTXT = 'DATA ARE NOT FULL LINEAR/CIRCULAR POLARIZATION'
         GO TO 990
         END IF
      DOVHRL = ABS(STK+5.0).LE.0.001
      IF (DOVHRL) THEN
         DEFCLS = 'VH2RL'
         MSGTXT = 'Converting linear to circular polarization'
      ELSE
         DEFCLS = 'RL2VH'
         MSGTXT = 'Converting circular to linear polarization'
         END IF
      CALL MSGWRT (2)
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NFREQ = CATBLK(KINAX+JLOCF)
      BCHAN = IROUND (XBCHAN)
      ECHAN = IROUND (XECHAN)
      IF ((BCHAN.LE.0) .OR. (BCHAN.GT.NFREQ)) BCHAN = 1
      IF ((ECHAN.LE.0) .OR. (ECHAN.GT.NFREQ)) ECHAN = NFREQ
      IF (BCHAN.GT.ECHAN) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       Find baselines to copy
      CALL SETANT (50, XANT, XBASE, NXANT, NXBAS, IXANT, IXBAS, DESEL)
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, SCRBUF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, SCRBUF, IERR)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       center frequency axis
      IF (JLOCF.LT.0) XCENT = -1.
      IF (XCENT.GT.0.0) THEN
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
      ELSE
         DIFPIX = 0.0
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, DEFCLS, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       read compressed => write compr.
      IF (ISCOMP) THEN
         CATBLK(KINAX) = 1
         I = CATBLK(KIPCN)
         CALL CHR2H (8, 'WEIGHT  ', 1, CATH(KHPTP+2*I))
         CALL CHR2H (8, 'SCALE   ', 1, CATH(KHPTP+2*I+2))
         CATBLK(KIPCN) = I + 2
         ILOCWT = I
         END IF
C                                       reset polarization
         IF (DOVHRL) THEN
            CATD(KDCRV+JLOCS)= -1.0D0
         ELSE
            CATD(KDCRV+JLOCS)= -5.0D0
            END IF
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((CCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', SCRBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
      NEWCNO = CCNO
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', SCRBUF, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       Copy any header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VH2RLI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('VH2RLI: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE VH2RLD (IRET)
C-----------------------------------------------------------------------
C   VH2RLD sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48
      INTEGER   IPTRO, LUNO, INDO, ILENBU, KBIND, NIOUT, NIOLIM, BO, VO,
     *   NUMVIS, XCOUNT, NCORO, NCOPY, CATMP(256), RNXRET, VISINC,
     *   VISMSG, IA1, IA2
      LOGICAL   T, F, REQBAS
      INCLUDE 'VH2RL.INC'
      REAL      BASEN, VIS(UVBFSS), RESULT(UVBFSS), RPARM(20)
      DOUBLE PRECISION UVSCAL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA LUNO /17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Number of visibilities in input
C                                       and output files.
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
      VISINC = CATBLK(KIGCN) / 20
      VISMSG = CATBLK(KIGCN) / 10
      VISINC = MAX (20000, MIN (200000,VISINC))
      VISMSG = (VISMSG / VISINC) * VISINC
      IF (VISMSG.LT.VISINC) VISMSG = 100 * VISINC
C                                       defend cat header from UVGET
      CALL COPY (256, CATBLK, CATMP)
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL COPY (256, CATMP, CATBLK)
      CALL UVPGET (IRET)
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
      NUMVIS = 0
      XCOUNT = 0
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
      IF ((FREQ.GT.0.0D0) .AND. (UVFREQ.GT.0.0D0)) THEN
         UVSCAL = FREQ / UVFREQ
      ELSE
         UVSCAL = 1.0D0
         END IF
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over buffer
      ELSE IF (IRET.EQ.0) THEN
         IF (ILOCB.GE.0) THEN
            BASEN = RPARM(1+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
            END IF
         IF (.NOT.REQBAS (IA1, IA2, DESEL, IXANT, NXANT, IXBAS, NXBAS))
     *      GO TO 100
         NUMVIS = NUMVIS + 1
         IF (MOD(NUMVIS-1,VISMSG).EQ.0) THEN
            WRITE (MSGTXT,1105) NUMVIS
            CALL MSGWRT (2)
         ELSE IF (MOD(NUMVIS-1,VISINC).EQ.0) THEN
            WRITE (MSGTXT,1105) NUMVIS
            CALL MSGWRT (1)
            END IF
         RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
         RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
         RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
C                                       call conversion routine
         IF (DOVHRL) THEN
            CALL DVH2RL (NUMVIS, VIS, RESULT, IRET)
         ELSE
            CALL DRL2VH (NUMVIS, VIS, RESULT, IRET)
            END IF
C                                       Error (fatal)
         IF (IRET.GT.0) THEN
            IF (DOVHRL) THEN
               WRITE (MSGTXT,1120) 'DVH2RL', IRET
            ELSE
               WRITE (MSGTXT,1120) 'DRL2VH', IRET
               END IF
            GO TO 990
C                                       Copy to output.
         ELSE IF (IRET.EQ.0) THEN
            XCOUNT = XCOUNT + 1.0D0
            CALL RCOPY (NRPRMI, RPARM, BUFF2(IPTRO))
C                                       update NX table
            CALL RNXUPD (RPARM, RNXRET)
C                                       Compressed
            IF (ISCOMP) THEN
               CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *            BUFF2(IPTRO+NRPRMO))
            ELSE
               CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
               END IF
            IPTRO = IPTRO + LRECO
            NIOUT = NIOUT + 1
            END IF
C                                       Write vis record.
         IF (NIOUT.GE.NIOLIM) THEN
            CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1150) IRET
               GO TO 990
               END IF
            IPTRO = KBIND
            NIOUT = 0
            END IF
C                                       Read next buffer.
         GO TO 100
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
C                                       close NX table
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VH2RLD: ERROR',I3,' OPEN/INIT INPUT VIS FILE')
 1105 FORMAT ('VH2RLD: at visibility record',I10)
 1010 FORMAT ('VH2RLD: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('VH2RLD: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1100 FORMAT ('VH2RLD: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('VH2RLD: ',A,' ERROR',I3)
 1150 FORMAT ('VH2RLD: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE VH2RLH
C-----------------------------------------------------------------------
C   VH2RLH copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, LABEL*8
      INTEGER   LUN1, LUN2, IERR, I
      INCLUDE 'VH2RL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1, LUN2 /27,28/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   SCRBUF, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
C                                       calibration history
      CALL CALHIS (LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Add any other history.
      IF (NUMHIS.GT.0) THEN
         LABEL = TSKNAM // '/'
         DO 10 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 100
 10         CONTINUE
         END IF
C                                       Close HI file
 100  CALL HICLOS (LUN2, .TRUE., BUFF2, IERR)
C                                       Copy tables
      CALL COPTAB (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'VH2RLH: ERROR COPYING TABLES TO OUTPUT UV'
         CALL MSGWRT (6)
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (DISKO, NEWCNO, DIFPIX, BUFF2(1025), BUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'CENTHI: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                       Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRBUF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VH2RLH: ERROR',I3,' COPY/OPEN HISTORY FILE')
      END
      SUBROUTINE DVH2RL (NUMVIS, VIS, RESULT, IRET)
C-----------------------------------------------------------------------
C   Converts linear polarization to circular
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      VIS     R(3,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C   Output:
C      RESULT     R(3,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IRET
      REAL      VIS(3,*), RESULT(3,*)
C
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXO, INDEXI
      LOGICAL   DOIT
      REAL      WTSUM
      COMPLEX   VISI(4), VISO(4), EYE
      INCLUDE 'VH2RL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
      EYE = CMPLX (0.0, 1.0)
      IF (NUMVIS.GT.0) THEN
C                                       pointers to traverse the data
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
         DO 40 JIF = 1,NIF
            DO 30 JF = 1,NF
               DOIT = .TRUE.
               WTSUM = 0.0
               DO 10 JS = 1,NS
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  VISI(JS) = CMPLX (VIS(1,INDEXI), VIS(2,INDEXI))
                  IF (VIS(3,INDEXI).LE.0.0) DOIT = .FALSE.
                  WTSUM = WTSUM + VIS(3,INDEXI)
 10               CONTINUE
               WTSUM = WTSUM / 4.0
               IF (.NOT.DOIT) WTSUM = 0.0
               DO 20 JS = 1,NS
                  INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *               (JS-1) * INCSO + 1
                  IF (JS.EQ.1) THEN
                     VISO(JS) = VISI(1) + VISI(2) - EYE*VISI(3) +
     *                  EYE*VISI(4)
                  ELSE IF (JS.EQ.2) THEN
                     VISO(JS) = VISI(1) + VISI(2) + EYE*VISI(3) -
     *                  EYE*VISI(4)
                  ELSE IF (JS.EQ.3) THEN
                     VISO(JS) = VISI(1) - VISI(2) + EYE*VISI(3) +
     *                  EYE*VISI(4)
                  ELSE
                     VISO(JS) = VISI(1) - VISI(2) - EYE*VISI(3) -
     *                  EYE*VISI(4)
                     END IF
                  RESULT(1,INDEXO) = REAL (VISO(JS)) / 2.0
                  RESULT(2,INDEXO) = IMAG (VISO(JS)) / 2.0
                  RESULT(3,INDEXO) = WTSUM
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE DRL2VH (NUMVIS, VIS, RESULT, IRET)
C-----------------------------------------------------------------------
C   Converts circular to linear polarization
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      VIS     R(3,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C   Output:
C      RESULT     R(3,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IRET
      REAL      VIS(3,*), RESULT(3,*)
C
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXO, INDEXI
      LOGICAL   DOIT
      REAL      WTSUM
      COMPLEX   VISI(4), VISO(4), EYE
      INCLUDE 'VH2RL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
      EYE = CMPLX (0.0, 1.0)
      IF (NUMVIS.GT.0) THEN
C                                       pointers to traverse the data
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
         DO 40 JIF = 1,NIF
            DO 30 JF = 1,NF
               DOIT = .TRUE.
               WTSUM = 0.0
               DO 10 JS = 1,NS
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  VISI(JS) = CMPLX (VIS(1,INDEXI), VIS(2,INDEXI))
                  IF (VIS(3,INDEXI).LE.0.0) DOIT = .FALSE.
                  WTSUM = WTSUM + VIS(3,INDEXI)
 10               CONTINUE
               WTSUM = WTSUM / 4.0
               IF (.NOT.DOIT) WTSUM = 0.0
               DO 20 JS = 1,NS
                  INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *               (JS-1) * INCSO + 1
                  IF (JS.EQ.1) THEN
                     VISO(JS) = VISI(1) + VISI(2) + VISI(3) + VISI(4)
                  ELSE IF (JS.EQ.2) THEN
                     VISO(JS) = VISI(1) + VISI(2) - VISI(3) - VISI(4)
                  ELSE IF (JS.EQ.3) THEN
                     VISO(JS) = EYE * (VISI(1) - VISI(2) - VISI(3) +
     *                  VISI(4))
                  ELSE
                     VISO(JS) = EYE * (-VISI(1) + VISI(2) - VISI(3) +
     *                  VISI(4))
                     END IF
                  RESULT(1,INDEXO) = REAL (VISO(JS)) / 2.0
                  RESULT(2,INDEXO) = IMAG (VISO(JS)) / 2.0
                  RESULT(3,INDEXO) = WTSUM
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'VLBRF.INC'
C                                       Local include for VLBRF
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4,30), XCALC(1), XSTOK(1),
     *   XOUTF(12)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XANT(50), XBIF, XEIF,
     *   XBCHAN, XECHAN, XFLAG, XSMOTH(3), DOALL, DOSCAN, DOPLOT,
     *   XPIXR(2), APARM(10), FACTOR, XDOTV, XGRCH, XNPLOT, XLABEL,
     *   BADD(10)
      REAL      SCRBUF(512), CATOR(256), PMEAN(MAXCIF,20),
     *   PMAX(MAXCIF,20), PMIN(MAXCIF,20), RMEAN(MAXCIF,20),
     *   RMAX(MAXCIF,20), RMIN(MAXCIF,20), MMEAN(MAXCIF,20),
     *   MMAX(MAXCIF,20), MMIN(MAXCIF,20), PMWT(MAXCIF,20), VIS(UVBFSS),
     *   RPARM(20)
      HOLLERITH CATOH(256)
      LOGICAL   GOTANT(20), FRQLAB
      INTEGER   SEQIN, DISKIN, JBUFSZ, ILOCWT, CATOLD(256), INCSI,
     *   INCFI, INCIFI, OLDCNO, NSAMP, GRCHAN, NPARM, NVAL, NFREQ,
     *   NIF, NANT, NANS, NUMT(MAXANT), MAXA, MAXT, NPLOTS, NXP, NYP
      DOUBLE PRECISION CATOD(128), FRQMIN, FRQMAX
      CHARACTER NAMEIN*12, CLAIN*6, LTITLE*80, OUTFIL*48
      EQUIVALENCE (CATOD, CATOH, CATOR, CATOLD)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XSTOK, XTIME, XANT, XBIF, XEIF, XBCHAN, XECHAN, XFLAG, XSMOTH,
     *   DOALL, DOSCAN, XOUTF, DOPLOT, XPIXR, APARM, FACTOR, XDOTV,
     *   XGRCH, XNPLOT, XLABEL, BADD
      COMMON /VLBRFS/ CATOLD, FRQMIN, FRQMAX, SEQIN, DISKIN, ILOCWT,
     *   INCSI, INCFI, INCIFI, OLDCNO, NSAMP, GRCHAN, NPARM, NVAL,
     *   NFREQ, NIF, NANT, NANS, FRQLAB, GOTANT, NUMT, MAXA, MAXT,
     *   NPLOTS, NXP, NYP
      COMMON /ANSWER/ PMEAN, PMIN, PMAX, RMEAN, RMIN, RMAX, MMEAN, MMIN,
     *   MMAX, PMWT
      COMMON /CHARPM/ LTITLE, NAMEIN, CLAIN, OUTFIL
      COMMON /BUFRS/ VIS, RPARM, SCRBUF, JBUFSZ
C                                       End local include for VLBRF
LOCAL END
      PROGRAM VLBRF
C-----------------------------------------------------------------------
C! Plots statistics of selected autocorrelation data for VLBA RFI tests
C# UV UV-util Calibration Plot Hardcopy VLBA
C-----------------------------------------------------------------------
C;  Copyright (C) 2022-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   VLBRF plots statistics from a sample of autocorrelation data
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, NS, JA, IP, NWORDS, MAXIP, I, MXPLOT, LX, LY
      REAL      DBUF(2), WBUF(2)
      LONGINT   PDBUF, PWBUF


C      REAL      SUM(2), SUMS(2), WGT(2)
C      DOUBLE PRECISION DSUM(2), DSUMS(2), DWGT(2)
C      LONGINT   PSUM, PSUMS, PWGT
C      EQUIVALENCE (DSUM, SUM), (DSUMS, SUMS), (DWGT, WGT)
      INCLUDE 'VLBRF.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA PRGM /'VLBRF '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL VLBRFI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       find # times for each antenna
      CALL VLBRFT (NS, IRET)
      IF (IRET.NE.0) GO TO 990

      NWORDS = NFREQ * NIF * NS * MAXT
      NWORDS = (NWORDS - 1) / 1024 + 4
      CALL ZMEMRY ('GET ', PRGM, NWORDS, DBUF, PDBUF, IRET)
      IF (IRET.EQ.0) THEN
         NWORDS = (MAXT - 1) / 1024 + 4
         CALL ZMEMRY ('GET ', PRGM, NWORDS, WBUF, PWBUF, IRET)
         END IF
      IF (IRET.NE.0) THEN
         MSGTXT = 'FAILED TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       read data
      CALL VLBRFR (NFREQ, NIF, NS, DBUF(1+PDBUF), WBUF(1+PWBUF), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       output text
      IF (OUTFIL.NE.' ') THEN
         CALL VLBRFC (IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
C                                       Plot mean, std spectra
      IF (DOPLOT.GT.0.0) THEN
         MAXIP = 0
         I = 0
         DO 10 JA = 1,4
            IF (APARM(5+JA).LE.0.0) THEN
               MAXIP = JA
               I = I + 1
               END IF
 10         CONTINUE
         MXPLOT = 0
         DO 20 JA = 1,20
            IF (GOTANT(JA)) THEN
               MXPLOT = MXPLOT + I
               END IF
 20         CONTINUE
         LX = 0
         LY = 1
         I = 0
         DO 30 JA = 1,20
            IF (GOTANT(JA)) THEN
               IP = 1
               IF ((IRET.EQ.0) .AND. (APARM(5+IP).LE.0.0)) THEN
                  I = I + 1
                  IF (MOD(I-1,NPLOTS).EQ.0) THEN
                     LX = 1
                     LY = 1
                  ELSE
                     LX = LX + 1
                     IF (LX.GT.NXP) THEN
                        LX = 1
                        LY = LY + 1
                        IF (LY.GT.NYP) LY = 1
                        END IF
                     END IF
                  IF (I.EQ.MXPLOT) IP = -IP
                  CALL VLBRFP (IP, LX, LY, PMEAN(1,JA), MMEAN(1,JA),
     *               RMEAN(1,JA), JA, IRET)
                  END IF
               IP = 2
               IF ((IRET.EQ.0) .AND. (APARM(5+IP).LE.0.0)) THEN
                  I = I + 1
                  IF (MOD(I-1,NPLOTS).EQ.0) THEN
                     LX = 1
                     LY = 1
                  ELSE
                     LX = LX + 1
                     IF (LX.GT.NXP) THEN
                        LX = 1
                        LY = LY + 1
                        IF (LY.GT.NYP) LY = 1
                        END IF
                     END IF
                  IF (I.EQ.MXPLOT) IP = -IP
                  CALL VLBRFP (IP, LX,LY, PMEAN(1,JA), PMIN(1,JA),
     *               PMAX(1,JA),JA, IRET)
                  END IF
               IP = 3
               IF ((IRET.EQ.0) .AND. (APARM(5+IP).LE.0.0)) THEN
                  I = I + 1
                  IF (MOD(I-1,NPLOTS).EQ.0) THEN
                     LX = 1
                     LY = 1
                  ELSE
                     LX = LX + 1
                     IF (LX.GT.NXP) THEN
                        LX = 1
                        LY = LY + 1
                        IF (LY.GT.NYP) LY = 1
                        END IF
                     END IF
                  IF (I.EQ.MXPLOT) IP = -IP
                  CALL VLBRFP (IP, LX, LY, RMEAN(1,JA), RMIN(1,JA),
     *               RMAX(1,JA), JA, IRET)
                  END IF
               IP = 4
               IF ((IRET.EQ.0) .AND. (APARM(5+IP).LE.0.0)) THEN
                  I = I + 1
                  IF (MOD(I-1,NPLOTS).EQ.0) THEN
                     LX = 1
                     LY = 1
                  ELSE
                     LX = LX + 1
                     IF (LX.GT.NXP) THEN
                        LX = 1
                        LY = LY + 1
                        IF (LY.GT.NYP) LY = 1
                        END IF
                     END IF
                  IF (I.EQ.MXPLOT) IP = -IP
                  CALL VLBRFP (IP, LX, LY, MMEAN(1,JA), MMIN(1,JA),
     *               MMAX(1,JA), JA, IRET)
                  END IF
               END IF
 30         CONTINUE
         END IF
      IRET = MAX (0, IRET)
      CALL VLBRFH
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE VLBRFI (PRGN, JERR)
C-----------------------------------------------------------------------
C   VLBRFI gets input parameters for VLBRF
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, PTYPE*2
      INTEGER   IROUND, IERR, INCX, I, LUN, VER
      REAL      CATR(256)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128), FF
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'VLBRF.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCHND.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
      CALL LFILL (20, .FALSE., GOTANT)
      NANT = 0
C                                       Get input parameters.
      NPARM = 238
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (48, 1, XOUTF, OUTFIL)
      DO 5 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 5       CONTINUE
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      DO 20 I = 1,50
         ANTENS(I) = IROUND (XANT(I))
 20      CONTINUE
      CALL RFILL (44, 0.0, XANT(7))
      CALL CHR2H (6, TSKNAM, 1, XANT(5))
      SELQUA = IROUND (XQUAL)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      IF (ABS(FACTOR).LE.0.01) THEN
         IF (FACTOR.GE.0.0) FACTOR = 1.0
         IF (FACTOR.LT.0.0) FACTOR = -1.0
         END IF
      NPLOTS = XNPLOT + 0.5
      NPLOTS = MAX (1, MIN (9, NPLOTS))
      NYP = SQRT (REAL(NPLOTS))
      IF (NYP*NYP.LT.NPLOTS) NYP = NYP + 1
      NXP = NPLOTS / NYP
      IF (NXP*NYP.LT.NPLOTS) NXP = NXP + 1
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOACOR = .TRUE.
      DOXCOR = .FALSE.
      CALL RCOPY (3, XSMOTH, SMOOTH)
C                                       Set time range.
      FGVER = IROUND (XFLAG)
      GRCHAN = IROUND (XGRCH)
      FRQLAB = APARM(5).LE.0.0
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      I = CATBLK(KINAX+JLOCS)
      CALL H2CHR (4, 1, XSTOK, STOKES)
      IF ((STOKES.NE.'RR') .AND. (STOKES.NE.'LL') .AND. (STOKES.NE.'VV')
     *   .AND. (STOKES.NE.'HH')) THEN
         IF (I.GE.2) THEN
            STOKES = 'HALF'
         ELSE
            IF (ICOR0.EQ.-1) STOKES = 'RR'
            IF (ICOR0.EQ.-2) STOKES = 'LL'
            IF (ICOR0.EQ.-5) STOKES = 'VV'
            IF (ICOR0.EQ.-6) STOKES = 'HH'
            END IF
         END IF
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NIF = EIF - BIF + 1
      NFREQ = CATBLK(KINAX+JLOCF)
      BCHAN = IROUND (XBCHAN)
      ECHAN = IROUND (XECHAN)
      IF ((BCHAN.LE.0) .OR. (BCHAN.GT.NFREQ)) BCHAN = 1
      IF ((ECHAN.LE.0) .OR. (ECHAN.GT.NFREQ)) ECHAN = NFREQ
      IF (BCHAN.GT.ECHAN) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
      NFREQ = ECHAN - BCHAN + 1
C                                       Freq id, antenna info
      FRQSEL = 1
      LUN = 28
      SUBARR = 1
      CALL GETANT (DISKIN, OLDCNO, SUBARR, CATBLK, SCRBUF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1000) JERR, 'READING ANTENNA DATA'
         GO TO 990
         END IF
C                                       time range
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, SCRBUF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, SCRBUF, IERR)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                        Fill defaults for plots
      XBCHAN = BCHAN
      XECHAN = ECHAN
      XBIF = BIF
      XEIF = EIF
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', SCRBUF, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       get frequencies
      VER = 1
      CALL CHNDAT ('READ', FQBUFF, IUDISK, IUCNO, VER, CATUV, IQLUN,
     *   CHNIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FINDING FREQUENCIES'
         GO TO 990
         END IF
      JERR = 0
C                                       init answers
      I = 20 * MAXCIF
      CALL RFILL (I, 0.0, PMEAN)
      CALL RFILL (I, 1.E10, PMIN)
      CALL RFILL (I, -1.E10, PMAX)
      CALL RFILL (I, 0.0, RMEAN)
      CALL RFILL (I, 1.E10, RMIN)
      CALL RFILL (I, -1.E10, RMAX)
      CALL RFILL (I, 0.0, MMEAN)
      CALL RFILL (I, 1.E10, MMIN)
      CALL RFILL (I, -1.E10, MMAX)
      CALL RFILL (I, 0.0, PMWT)
      NANS = 0
      FRQMIN = 1.E15
      FRQMAX = -1.E15
      DO 30 I = BIF,EIF
         FF = CATOD(KDCRV+JLOCF) + FOFF(I) +
     *      (BCHAN-1-CATOR(KRCRP+JLOCF)) * FINC(I)
         FRQMIN = MIN (FF, FRQMIN)
         FRQMAX = MAX (FF, FRQMAX)
         FF = FF + (ECHAN-BCHAN+2) * FINC(I)
         FRQMIN = MIN (FF, FRQMIN)
         FRQMAX = MAX (FF, FRQMAX)
 30      CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VLBRFI: ERROR',I3,' ON ',A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('VLBRFI: UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE VLBRFT (NS, IRET)
C-----------------------------------------------------------------------
C   Finds number of records for each antenna
C   Output:
C      NS     I   Number Stokes (1 or 2)
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   NS, IRET
C
      INCLUDE 'VLBRF.INC'
      INTEGER   I, IA1, IA2
      REAL      BASEN
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      CALL FILL (MAXANT, 0, NUMT)
      MAXA = 0
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT READ OF DATA'
         GO TO 990
         END IF
      CALL UVPGET (IRET)
      NS = 1
      IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
      NS = MIN (2, NS)
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ THE DATA'
         GO TO 990
C                                       Last or good
      ELSE IF (IRET.EQ.0) THEN
         IF (ILOCB.GE.0) THEN
            BASEN = RPARM(1+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
            END IF
         IF (IA1.EQ.IA2) THEN
            NUMT(IA1) = NUMT(IA1) + 1
            MAXA = MAX (MAXA, IA1)
            END IF
         GO TO 100
         END IF
C                                       close file
C                                       Close files
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      IRET = 0
      IF (MAXA.LE.0) THEN
         MSGTXT = 'NO AUTOCORRELATION DATA FOUND'
         IRET = 8
         GO TO 990
      ELSE
         MAXT = 0
         DO 120 I = 1,MAXA
            MAXT = MAX (MAXT, NUMT(I))
 120        CONTINUE
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VLBRFT ERROR',I4,' ON ',A)
      END
      SUBROUTINE VLBRFR (NC, NI, NS, DBUF, WBUF, IRET)
C-----------------------------------------------------------------------
C   VLBRFR reads the uv data and finds medians and MADs
C   Input:
C      NC      I      Number spectral channels
C      NI      I      Number IFs
C      NS      I      Number Stokes
C   Input in common:
C      INCSI   I      Input Stokes' increment in vis.
C      INCFI   I      Input frequency increment in vis.
C      INCIFI  I      Input IF increment in vis.
C   Out:
C      DBUF    R(*)   spectrum buffer
C      WBUF    R(*)   work buffer
C   Output:
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NC, NI, NS, IRET
      REAL      DBUF(NC,NI,NS,*), WBUF(*)
C
      INCLUDE 'VLBRF.INC'
      INTEGER   JI, JC, JS, IA1, IA2, I, INDEX, NN, IT, NCOUNT(MAXCIF),
     *   JST, LANT, MINRNO, MAXRNO, JNXRNO(86400), JNX, IT1, IT2
      REAL      BASEN, X, MEDIAN, XX, VR, VW
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      CALL FILL (MAXANT, 0, ANTENS)
      DO 100 LANT = 1,MAXA
         IF (NUMT(LANT).LE.0) GO TO 100
         ANTENS(1) = LANT
         CALL FILL (MAXCIF, 0, NCOUNT)
C                                       Open and init for read
         CALL UVGET ('INIT', RPARM, VIS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, LANT, 'INIT READ OF DATA'
            GO TO 990
            END IF
         CALL UVPGET (IRET)
         IT = 0
         MINRNO = 100000
         MAXRNO = 0
C                                       Loop
C                                       Read vis. record.
 10      CALL UVGET ('READ', RPARM, VIS, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, LANT, 'READ OF DATA'
            GO TO 990
C                                       Last or good
         ELSE IF (IRET.EQ.0) THEN
            IF (ILOCB.GE.0) THEN
               BASEN = RPARM(1+ILOCB)
               IA1 = BASEN / 256. + 0.1
               IA2 = BASEN - IA1*256. + 0.1
            ELSE
               IA1 = RPARM(1+ILOCA1) + 0.1
               IA2 = RPARM(1+ILOCA2) + 0.1
               END IF
            IF ((IA1.EQ.IA2) .AND. (IA1.EQ.LANT)) THEN
               IT = IT + 1
               IF (DOSCAN.GT.0.0) THEN
                  JNXRNO(IT) = INXRNO
                  MAXRNO = MAX (MAXRNO, INXRNO)
                  MINRNO = MIN (MINRNO, INXRNO)
               ELSE
                  JNXRNO(IT) = 1
                  END IF
               DO 40 JS = 1,NS
                  DO 30 JI = 1,NI
                     DO 20 JC = 1,NC
                        INDEX = ((JI-1) * INCIFI + (JC-1) * INCFI +
     *                     (JS-1) * INCSI) * 3
                        VR = VIS(1+INDEX)
                        VW = VIS(3+INDEX)
                        IF (VW.LE.0.0) THEN
                           DBUF(JC,JI,JS,IT) = FBLANK
                        ELSE
                           DBUF(JC,JI,JS,IT) = VR
                           END IF
 20                     CONTINUE
 30                  CONTINUE
 40               CONTINUE
               END IF
            GO TO 10
            END IF
C                                       Close files
         CALL UVGET ('CLOS', RPARM, VIS, IRET)
C                                       now find stats
         IF (DOSCAN.LE.0) THEN
            MINRNO = 1
            MAXRNO = 1
            END IF
         DO 85 JNX = MINRNO,MAXRNO
            IT1 = IT + 1
            IT2 = 0
            DO 84 I = 1,IT
               IF (JNXRNO(I).EQ.JNX) THEN
                  IT1 = MIN (IT1, I)
                  IT2 = MAX (IT2, I)
                  END IF
 84            CONTINUE
            IF (IT1.GT.IT2) GO TO 85
            DO 80 JST = 1,NS
               JS = 0
               DO 70 JI = 1,NI
                  DO 60 JC = 1,NC
                     JS = JS + 1
                     NN = 0
                     DO 50 I = IT1,IT2
                        IF (DBUF(JC,JI,JST,I).NE.FBLANK) THEN
                           NN = NN + 1
                           WBUF(NN) = DBUF(JC,JI,JST,I)
                           IF (DOALL.GT.0.0) THEN
                              PMIN(JS,LANT) = MIN (PMIN(JS,LANT),
     *                           WBUF(NN))
                              PMAX(JS,LANT) = MAX (PMAX(JS,LANT),
     *                           WBUF(NN))
                              END IF
                           END IF
 50                     CONTINUE
C                                       find median
                     IF (NN.GT.0) THEN
                        NCOUNT(JS) = NCOUNT(JS) + 1
                        X = MEDIAN (NN, WBUF)
                        PMEAN(JS,LANT) = PMEAN(JS,LANT) + X
                        IF (DOALL.LE.0.0) THEN
                           PMAX(JS,LANT) = MAX (PMAX(JS,LANT), X)
                           PMIN(JS,LANT) = MIN (PMIN(JS,LANT), X)
                           END IF
C                                       now mad
                        DO 55 I = 1,NN
                           WBUF(I) = ABS (WBUF(I) - X)
 55                        CONTINUE
                        XX = 1.4826 * MEDIAN (NN, WBUF)
                        RMEAN(JS,LANT) = RMEAN(JS,LANT) + XX
                        RMAX(JS,LANT) = MAX (RMAX(JS,LANT), XX)
                        RMIN(JS,LANT) = MIN (RMIN(JS,LANT), XX)
                        XX = XX / ABS (X)
                        MMEAN(JS,LANT) = MMEAN(JS,LANT) + XX
                        MMIN(JS,LANT) = MIN (MMIN(JS,LANT), XX)
                        MMAX(JS,LANT) = MAX (MMAX(JS,LANT), XX)
                        END IF
 60                  CONTINUE
 70               CONTINUE
 80            CONTINUE
 85         CONTINUE
         JS = NC * NI
         DO 90 JC = 1,JS
            IF (NCOUNT(JC).GT.0) THEN
               GOTANT(LANT) = .TRUE.
               NANT = MAX (NANT, LANT)
               PMEAN(JC,LANT) = PMEAN(JC,LANT) / NCOUNT(JC)
               RMEAN(JC,LANT) = RMEAN(JC,LANT) / NCOUNT(JC)
               MMEAN(JC,LANT) = MMEAN(JC,LANT) / NCOUNT(JC)
            ELSE IF (NCOUNT(JC).LE.0) THEN
               PMEAN(JC,LANT) = FBLANK
               RMEAN(JC,LANT) = FBLANK
               MMEAN(JC,LANT) = FBLANK
               END IF
            IF ((PMEAN(JC,LANT).EQ.0.0) .OR. (PMEAN(JC,LANT).EQ.FBLANK))
     *         THEN
               RMEAN(JC,LANT) = FBLANK
               RMAX(JC,LANT) = FBLANK
               RMIN(JC,LANT) = FBLANK
               MMEAN(JC,LANT) = FBLANK
               MMAX(JC,LANT) = FBLANK
               MMIN(JC,LANT) = FBLANK
               END IF
 90         CONTINUE
 100     CONTINUE
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VLBRFR: ERROR',I3,' ANT',I4,' ON ',A)
      END
      SUBROUTINE VLBRFC (IRET)
C-----------------------------------------------------------------------
C   VLBRFC writes out the results to a text file for the data base
C   Output:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'VLBRF.INC'
      INTEGER   TXLUN, TXIND, JI, JC, I, JT, JTRIM, JA, IDOSCN, IFMT, KT
      REAL      REFPIX, REFINC, YMIN, YMAX
      DOUBLE PRECISION REFREQ, F
      CHARACTER DATOBS*8, OUTLIN*256
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DCHND.INC'
      DATA TXLUN /3/
C-----------------------------------------------------------------------
      IDOSCN = 0
      IF (DOSCAN.GT.0.0) IDOSCN = 1
C                                       open output file
      CALL ZTXOPN ('WRIT', TXLUN, TXIND, OUTFIL, .TRUE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OUTPUT TEXT FILE'
         GO TO 990
         END IF
      REFREQ = CATOD(KDCRV+JLOCF)
      REFPIX = CATOR(KRCRP+JLOCF)
      REFINC = CATOR(KRCIC+JLOCF)
      CALL H2CHR (8, 1, CATOH(KHDOB), DATOBS)
C                                       loop over antennas
      DO 100 JA = 1,20
         IF (.NOT.GOTANT(JA)) GO TO 100
         JT = JTRIM (STNNAM(JA))
         KT = JTRIM (STOKES)
         WRITE (OUTLIN,2000) DATOBS, JA, STNNAM(JA)(:JT), IDOSCN,
     *      STOKES(:KT)
         JT = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:JT), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OBS DATE TO TEXT FILE'
            GO TO 990
            END IF
         WRITE (OUTLIN,2010)
         JT = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:JT), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING HEADER TO TEXT FILE'
            GO TO 990
            END IF
         WRITE (OUTLIN,2011)
         JT = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:JT), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING HEADER TO TEXT FILE'
            GO TO 990
            END IF
C                                       format?
         YMIN = 1.E10
         YMAX = -1.E10
         I = 0
         DO 30 JI = BIF,EIF
            DO 20 JC = BCHAN,ECHAN
               I = I + 1
               IF (PMEAN(I,JA).NE.FBLANK) THEN
                  YMIN = MIN (YMIN, PMIN(I,JA))
                  YMIN = MIN (YMIN, RMIN(I,JA))
                  YMAX = MAX (YMAX, PMAX(I,JA))
                  YMAX = MAX (YMAX, RMAX(I,JA))
                  END IF
 20            CONTINUE
 30         CONTINUE
         IFMT = 1
         IF (YMIN.GT.0.0995) IFMT = 0
         IF (YMAX.GT.1000.) IFMT = 0
C                                       now the data
         I = 0
         DO 50 JI = BIF,EIF
            DO 40 JC = BCHAN,ECHAN
               I = I + 1
               IF (PMEAN(I,JA).NE.FBLANK) THEN
                  F = (REFREQ + FOFF(JI) + (JC - REFPIX) * FINC(JI)) /
     *               1.D9
                  IF (IFMT.EQ.0) THEN
                     WRITE (OUTLIN,2020) JI, JC, F, PMEAN(I,JA),
     *                  PMIN(I,JA), PMAX(I,JA), RMEAN(I,JA),
     *                  RMIN(I,JA), RMAX(I,JA), MMEAN(I,JA)*1000.,
     *                  MMIN(I,JA)*1000., MMAX(I,JA)*1000.
                  ELSE
                     WRITE (OUTLIN,2021) JI, JC, F, PMEAN(I,JA),
     *                  PMIN(I,JA), PMAX(I,JA), RMEAN(I,JA),
     *                  RMIN(I,JA), RMAX(I,JA), MMEAN(I,JA)*1000.,
     *                  MMIN(I,JA)*1000., MMAX(I,JA)*1000.
                     END IF
                  JT = JTRIM (OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:JT), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET,
     *                  'WRITING RESULTS TO TEXT FILE'
                     GO TO 990
                     END IF
                  END IF
 40            CONTINUE
 50         CONTINUE
C                                       Tear off line
         DO 60 I = 1,JT
            OUTLIN(I:I) = '#'
 60         CONTINUE
         CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:JT), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING BREAK LINE TO TEXT FILE'
            GO TO 990
            END IF
 100     CONTINUE
      CALL ZTXCLS (TXLUN, TXIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING TEXT FILE'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VLBRFC ERROR',I4,' ON ',A)
 2000 FORMAT ('**** DATEOBS = ''',A,'''',3X,'ANTENNA=',I3,3X,
     *   'STATION = ''',A,'''  TASK=''VLBRF''  DOSCAN=',I1,
     *   '  STOKES=''',A,'''')
 2010 FORMAT ('# IF CHAN',4X,'FREQ',10X,'Pmean',10X,'Pmin',10X,'Pmax',
     *   10X,'Rmean',10X,'Rmin',10X,'Rmax',8X,'Mmean',6X,'Mmin',7X,
     *   'Mmax')
 2011 FORMAT ('#',12X,'GHz',88X,3(6X,'milli'))
 2020 FORMAT (I4,I5,F11.5,6F14.3,3F11.3)
 2021 FORMAT (I4,I5,F11.5,6F14.4,3F11.3)
      END
      SUBROUTINE VLBRFH
C-----------------------------------------------------------------------
C   Writes info into history file
C-----------------------------------------------------------------------
C
      INCLUDE 'VLBRF.INC'
      INTEGER   LUN, LUNTMP, TIME(3), DATE(3), IERR, BUFF2(256), JTRIM
      CHARACTER CTIME(2)*12, HILINE*72
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IF ((OUTFIL.EQ.' ') .AND. (DOPLOT.LE.0)) GO TO 999
C
      LUN = LUNTMP(1)
      CALL HIINIT (3)
C                                       Open old history
      CALL HIOPEN (LUN, DISKIN, OLDCNO, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,1000) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       calibration et al.
      CALL CALHIS (LUN, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C
      HILINE = TSKNAM // 'OUTFILE=''' // OUTFIL(1:JTRIM(OUTFIL)) //
     *   ''''
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      IF (DOALL.GT.0.0) THEN
         WRITE (HILINE,1010) TSKNAM, DOALL, 'max/min over all times'
      ELSE
         WRITE (HILINE,1010) TSKNAM, DOALL, 'max/min over pol averages'
         END IF
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Close HI file
 200  CALL HICLOS (LUN, .TRUE., BUFF2, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 1010 FORMAT (A6,'DOALL =',F4.1,'    / ',A)
      END
      SUBROUTINE VLBRFP (KTYPE, LPX, LPY, SP, SN, SX, JANT, IRET)
C-----------------------------------------------------------------------
C   VLBRFP plots the the mean and std spectra
C   Inputs:
C       KTYPE    I       1 all three, 2 mean, 3 std, 4 std/mean, - LAST
C       LPX      I       X panel number (1 to NXP)  left to right
C       LPY      I       Y panel number (1 to NYP)  top to bottom
C       SP       R(*)    spectrum mean to plot
C       SN       R(*)    spectrum min to plot
C       SX       R(*)    spectrum max to plot
C    Outputs:
C       IRET     I       > 0 => plot failure
C-----------------------------------------------------------------------
      INTEGER   KTYPE, LPX, LPY, JANT, IRET
      REAL      SP(*), SN(*), SX(*)
C
      INCLUDE 'VLBRF.INC'
      INTEGER   I, PLUN, PLBUFF(256), IVER, TVCHN, TVCORN(4), IDEPTH(5),
     *   J, LTYPE, LABEL, PIND, IROUND, NC, NI, JC, JI, NOFF(MAXIF),
     *   INCHAR, ITYPE, PLTYIN, PLTXIN, PLTYOF, PLTXOF
      LOGICAL   DOTV, GOOD, FIRST, DOSP, DOPLT(3)
      CHARACTER PFILE*48, CHT12*12, CHT6*6, CHTY*2, MSGBUF*24
      REAL      YMAX, YMIN, BLC(2), TRC(2), CH(4), X, FAC, XYRATO, DX,
     *   DY, XMIN, XMAX, LOCRAN(2), XYRAT, Y, XPSAVE(2), APSAVE(4), YP,
     *   SPDIFF, SPMEAN, NSP, REFPIX, REFINC, XBLC(2), XTRC(2), XSC, SPD
      DOUBLE PRECISION F, REFREQ
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCHND.INC'
      SAVE FIRST
      DATA TVCHN, TVCORN, IDEPTH /1, 4*0, 5*1/
      DATA FIRST /.TRUE./
C-----------------------------------------------------------------------
      I = APARM(10) + 0.1
      DOPLT(1) = MOD(I,2).EQ.0 .OR. (ABS(KTYPE).EQ.1)
      I = I/2
      DOPLT(2) = MOD(I,2).EQ.0
      I = I/2
      DOPLT(3) = MOD(I,2).EQ.0
      DOTV = XDOTV.GT.0.0
      CALL RCOPY (2, XPIXR, XPSAVE)
      CALL RCOPY (4, APARM, APSAVE)
      REFREQ = CATOD(KDCRV+JLOCF)
      REFPIX = CATOR(KRCRP+JLOCF)
      REFINC = CATOR(KRCIC+JLOCF)
C                                       for EXTLIST
      ITYPE = ABS (KTYPE)
      XANT(1) = JANT
      XANT(2) = ITYPE
      CALL CHR2H (8, STNNAM(JANT), 1, XANT(3))
C                                       Y scale
      YMAX = -1.E10
      YMIN = -YMAX
      NC = (ECHAN - BCHAN + 1)
      NI = (EIF - BIF + 1)
      JC = NC * NI
      SPMEAN = 0.0
      NSP = 0.0
      SPDIFF = 0.0
      SPD = 0.0
      DO 10 I = 1,JC
         IF (SP(I).NE.FBLANK) THEN
            YMIN = MIN (YMIN, SP(I))
            YMAX = MAX (YMAX, SP(I))
            END IF
         IF (ITYPE.NE.1) THEN
            IF ((SN(I).NE.FBLANK) .AND. (SX(I).NE.FBLANK) .AND.
     *         (SN(I).GT.SX(I))) THEN
               SN(I) = FBLANK
               SX(I) = FBLANK
               END IF
            IF (SN(I).NE.FBLANK) YMIN = MIN (YMIN, SN(I))
            IF (SX(I).NE.FBLANK) YMAX = MAX (YMAX, SX(I))
            IF ((SP(I).NE.FBLANK) .AND. (SN(I).NE.FBLANK) .AND.
     *         (SX(I).NE.FBLANK)) THEN
               SPDIFF = MAX (SPDIFF, ABS(2*SP(I)-SX(I)-SN(I)))
               SPMEAN = SPMEAN + SP(I)
               SPD = MAX (SPD, SX(I)-SN(I))
               NSP = NSP + 1.
               END IF
         ELSE
            IF (SN(I).NE.FBLANK) THEN
               YMIN = MIN (YMIN, SN(I))
               YMAX = MAX (YMAX, SN(I))
               END IF
            IF (SX(I).NE.FBLANK) THEN
               YMIN = MIN (YMIN, SX(I))
               YMAX = MAX (YMAX, SX(I))
               END IF
            END IF
 10      CONTINUE
      IF (ITYPE.EQ.1) SPDIFF = 1.
      IF (NSP.GT.0) SPMEAN = SPMEAN / NSP
      DOSP = (SPDIFF.GT.SPMEAN/1000.0) .AND. ((DOPLOT.LT.2.0) .OR.
     *   (ITYPE.EQ.1))
      DOSP = DOSP .OR. (SPDIFF.LT.1.E-6)
      SPD = SPD / SPMEAN
      IF (ITYPE.EQ.1) SPD = 1.
      IF (ITYPE.LE.2) THEN
         IF (XPIXR(2).GT.XPIXR(1)) THEN
            YMAX = XPIXR(2)
            YMIN = XPIXR(1)
         ELSE IF (XPIXR(2).EQ.0.0) THEN
            CALL DIDDLE (SP, SN, SX, YMIN, YMAX)
            END IF
      ELSE IF (ITYPE.EQ.3) THEN
         IF (APARM(2).GT.APARM(1)) THEN
            YMAX = APARM(2)
            YMIN = APARM(1)
         ELSE IF (APARM(2).EQ.0.0) THEN
            CALL DIDDLE (SP, SN, SX, YMIN, YMAX)
            END IF
      ELSE
         IF (APARM(4).GT.APARM(3)) THEN
            YMAX = APARM(4)
            YMIN = APARM(3)
         ELSE IF (APARM(4).EQ.0.0) THEN
            CALL DIDDLE (SP, SN, SX, YMIN, YMAX)
            END IF
         END IF
      IF (ITYPE.LE.2) THEN
         XPIXR(2) = YMAX + 0.04 * (YMAX - YMIN)
         XPIXR(1) = YMIN - 0.04 * (YMAX - YMIN)
         YMAX = XPIXR(2)
         YMIN = XPIXR(1)
      ELSE IF (ITYPE.EQ.3) THEN
         APARM(2) = YMAX + 0.04 * (YMAX - YMIN)
         APARM(1) = YMIN - 0.04 * (YMAX - YMIN)
         YMAX = APARM(2)
         YMIN = APARM(1)
      ELSE
         APARM(4) = YMAX + 0.04 * (YMAX - YMIN)
         APARM(3) = YMIN - 0.04 * (YMAX - YMIN)
         YMAX = APARM(4)
         YMIN = APARM(3)
         END IF
      XMIN = 0.0
      XMAX = (NC + 1) * NI
C                                       Add plot file to the image
C                                       catalog header.
      IF ((.NOT.DOTV) .AND. (LPX.EQ.1) .AND. (LPY.EQ.1)) THEN
         CHT12 = ' '
         CHT6 = ' '
         CHTY = ' '
         IVER = 0
         IF (FIRST) THEN
            CALL CATDIR ('CSTA', DISKIN, OLDCNO, CHT12, CHT6, 0, CHTY,
     *         0, 'CLRD', SCRBUF, IRET)
            IF (IRET.EQ.0) CALL CATDIR ('CSTA', DISKIN, OLDCNO, CHT12,
     *         CHT6, 0, CHTY, 0, 'WRIT', SCRBUF, IRET)
            FRW(NCFILE) = 1
            FIRST = .FALSE.
            END IF
         CALL MADDEX ('PL', DISKIN, OLDCNO, CATOLD, PLBUFF, .TRUE.,
     *      'WRIT', IVER, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'PLHGM: ERROR UPDATING CATALOGUE HEADER.'
            CALL MSGWRT (8)
            GO TO 999
            END IF
         END IF
C                                       Open the PLot file.
      IF ((LPX.EQ.1) .AND. (LPY.EQ.1)) THEN
         CALL ZPHFIL ('PL', DISKIN, OLDCNO, IVER, PFILE, IRET)
         CALL GINIT (DISKIN, OLDCNO, PFILE, 0, 76, NPARM, XNAMEI, DOTV,
     *      TVCHN, GRCHAN, TVCORN, CATOLD, PLBUFF, PLUN, PIND, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'VLBRFP: ERROR OPENING PLOT FILE.'
            CALL MSGWRT (8)
            IF (.NOT.DOTV) CALL DELEXT ('PL', DISKIN, OLDCNO, 'WRIT',
     *         CATOLD, PLBUFF, IVER, I)
            GO TO 999
            END IF
         END IF
C                                       Set character offsets.
      LABEL = IROUND (XLABEL)
      LTYPE = MOD (ABS (LABEL), 100)
      LOCRAN(2) = YMAX
      LOCRAN(1) = YMIN
      CALL GTICNT (LABEL, LOCRAN, I)
      CALL RFILL (4, 0.5, CH)
      IF (LTYPE.EQ.2) CH(1) = 3.5
      IF (LTYPE.GT.2) CH(1) = I + 4.0
      IF (LTYPE.GT.1) CH(2) = 2.0
      IF (LTYPE.GT.2) CH(2) = CH(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         CH(2) = CH(2) + 1.333
         CH(4) = 2.0
         IF (LABEL.GT.0) CH(4) = CH(4) + 1.333
         END IF
C                                       Set BLC, TRC, XYRATO.
      PLTXIN = 1000.0 / (NXP - 0.25)
      PLTYIN = 1000.0 / (NYP - 0.10)
      PLTXOF = NXP * PLTXIN - 1000.
      PLTYOF = NYP * PLTYIN - 1000.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      IF (DOTV) THEN
         DX = WINDTV(3) - WINDTV(1) + 1 - CSIZTV(1) * (CH(1) + CH(3))
         DY = WINDTV(4) - WINDTV(2) + 1 - CSIZTV(2) * (CH(2) + CH(4))
         XYRATO = 1.0
         IF (DY.GT.0.0) XYRATO = DX / DY
      ELSE
         XYRATO = 1.4
         END IF
      XYRAT = (TRC(1) - BLC(1)) / (TRC(2) - BLC(2))
      XYRAT = XYRATO / XYRAT
C                                       sub window parms
      XBLC(1) = BLC(1) + (LPX-1) * PLTXIN
      XTRC(1) = XBLC(1) + PLTXIN - 1.0 - PLTXOF
      XBLC(2) = BLC(2) + (NYP-LPY) * PLTYIN
      XTRC(2) = XBLC(2) + PLTYIN - 1.0 - PLTYOF
C                                       Initialize for line drawing
      IF ((LPX.EQ.1) .AND. (LPY.EQ.1)) THEN
         CALL GINITL (BLC, TRC, XYRAT, CH, IDEPTH, PLBUFF, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'DRWHGM: ERROR INITIALIZING FOR LINE DRAWING.'
            GO TO 950
            END IF
         END IF
      CALL GLTYPE (1, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 920
C                                       Draw borders.
      CALL GPOS (XBLC(1), XBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 910
      CALL GVEC (XTRC(1), XBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 920
      CALL GVEC (XTRC(1), XTRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 920
      CALL GVEC (XBLC(1), XTRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 920
      CALL GVEC (XBLC(1), XBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 920
C                                       dividers
      DO 25 I = 1,NI-1
         IF (FRQLAB) THEN
            F = (REFREQ + FOFF(BIF+I) - REFPIX * FINC(BIF+I))
            X = (F - FRQMIN) / (FRQMAX-FRQMIN) * (XTRC(1) - XBLC(1))
     *         + XBLC(1)
         ELSE
            X = (I * (NC+1.0)) / (NI * (NC+1.0)) * (XTRC(1)-XBLC(1)) +
     *         XBLC(1)
            END IF
         CALL GPOS (X, XTRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL GVEC (X, XBLC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
 25      CONTINUE
C                                       Labeling.
      CALL RMSLAB (ITYPE, XBLC, XTRC, FAC, XMIN, XMAX, YMIN, YMAX, NC,
     *   NI, BCHAN, BIF, IVER, LABEL, CATOLD, JANT, STNNAM(JANT),
     *   STOKES, APARM(5), FRQMAX, LPX, LPY, NYP, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Draw the data
      XSC = (XTRC(1) - XBLC(1)) / (NI * (NC+1.0))
      DO 26 I = 4,2,-1
         CALL GLTYPE (I, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 920
         IF (DOTV) THEN
            CALL GCINIT (GPHTVG(GPHLTY), 0, IRET)
            IF (IRET.NE.0) GO TO 920
            END IF
 26      CONTINUE
      CALL FILL (NI, 0, NOFF)
      IF ((FACTOR.LT.0.0) .AND. (DOSP) .AND. (DOPLT(1))) THEN
         I = 0
         J = 0
         DX = 0.5 * ABS(FACTOR)
         DY = 0.5 * (XTRC(2) - XBLC(2)) / ((NC + 1.0)* NI) * ABS(FACTOR)
         CALL GPOS (X, 1.0, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 910
         DO 40 JI = BIF,EIF
            DO 30 JC = BCHAN,ECHAN
               I = I + 1
               IF (FRQLAB) THEN
                  F = (REFREQ + FOFF(JI) + (JC - REFPIX) * FINC(JI))
                  X = (F - FRQMIN) / (FRQMAX-FRQMIN) * (XTRC(1)-XBLC(1))
     *               + XBLC(1)
               ELSE
                  X = I * XSC + XBLC(1)
                  END IF
               J = J + 1
               IF (SP(J).NE.FBLANK) THEN
                  Y = (SP(J) - YMIN) / (YMAX - YMIN) * (XTRC(2)-XBLC(2))
     *               + XBLC(2)
                  IF ((Y.LT.XBLC(2)) .OR. (Y.GT.XTRC(2))) THEN
                     NOFF(JI) = NOFF(JI) + 1
                     Y = MAX (XBLC(2), MIN (XTRC(2), Y))
                     END IF
                  CALL GPOS (X-DX, Y+DY, PLBUFF, IRET)
                  IF (IRET.NE.0) GO TO 910
                  CALL GVEC (X+DX, Y-DY, PLBUFF, IRET)
                  IF (IRET.NE.0) GO TO 920
                  CALL GPOS (X+DX, Y+DY, PLBUFF, IRET)
                  IF (IRET.NE.0) GO TO 910
                  CALL GVEC (X-DX, Y-DY, PLBUFF, IRET)
                  IF (IRET.NE.0) GO TO 920
                  END IF
  30           CONTINUE
            I = I + 1
  40        CONTINUE
      ELSE IF ((DOSP) .AND. (DOPLT(1))) THEN
         I = 0
         J = 0
         DO 50 JI = BIF,EIF
            GOOD = .FALSE.
            DO 45 JC = BCHAN,ECHAN
               I = I + 1
               IF (FRQLAB) THEN
                  F = (REFREQ + FOFF(JI) + (JC - REFPIX) * FINC(JI))
                  X = (F - FRQMIN) / (FRQMAX-FRQMIN) * (XTRC(1)-XBLC(1))
     *               + XBLC(1)
               ELSE
                  X = I * XSC + XBLC(1)
                  END IF
               J = J + 1
               IF (SP(J).NE.FBLANK) THEN
                  Y = (SP(J) - YMIN) / (YMAX - YMIN) * (XTRC(2)-XBLC(2))
     *               + XBLC(2)
                  IF ((Y.LT.XBLC(2)) .OR. (Y.GT.XTRC(2))) THEN
                     NOFF(JI) = NOFF(JI) + 1
                     Y = MAX (XBLC(2), MIN (XTRC(2), Y))
                     END IF
                  IF (GOOD) THEN
                     CALL GVEC (X, Y, PLBUFF, IRET)
                     IF (IRET.NE.0) GO TO 920
                  ELSE
                     CALL GPOS (X, Y, PLBUFF, IRET)
                     IF (IRET.NE.0) GO TO 910
                     END IF
                  GOOD = .TRUE.
               ELSE
                  GOOD = .FALSE.
                  END IF
 45            CONTINUE
            I = I + 1
 50         CONTINUE
         END IF
C                                       if max=min do not plot
      IF ((SPD.GE.1.E-4) .AND. (DOPLT(2))) THEN
         CALL GLTYPE (4, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 920
         IF (DOTV) THEN
            CALL GCINIT (GPHTVG(GPHLTY), 0, IRET)
            IF (IRET.NE.0) GO TO 920
            END IF
         I = 0
         J = 0
         DO 60 JI = BIF,EIF
            GOOD = .FALSE.
            DO 55 JC = BCHAN,ECHAN
               I = I + 1
               IF (FRQLAB) THEN
                  F = (REFREQ + FOFF(JI) + (JC - REFPIX) * FINC(JI))
                  X = (F - FRQMIN) / (FRQMAX-FRQMIN) * (XTRC(1)-XBLC(1))
     *               + XBLC(1)
               ELSE
                  X = I * XSC + XBLC(1)
                  END IF
               J = J + 1
               IF (SN(J).NE.FBLANK) THEN
                  Y = (SN(J) - YMIN) / (YMAX - YMIN) * (XTRC(2)-XBLC(2))
     *               + XBLC(2)
                  IF ((Y.LT.XBLC(2)) .OR. (Y.GT.XTRC(2))) THEN
                     NOFF(JI) = NOFF(JI) + 1
                     Y = MAX (XBLC(2), MIN (XTRC(2), Y))
                     END IF
                  IF (GOOD) THEN
                     CALL GVEC (X, Y, PLBUFF, IRET)
                     IF (IRET.NE.0) GO TO 920
                  ELSE
                     CALL GPOS (X, Y, PLBUFF, IRET)
                     IF (IRET.NE.0) GO TO 910
                     END IF
                  GOOD = .TRUE.
               ELSE
                  GOOD = .FALSE.
                  END IF
 55            CONTINUE
            I = I + 1
 60         CONTINUE
         END IF
      IF ((SPD.GE.1.E-4) .AND. (DOPLT(3))) THEN
         CALL GLTYPE (3, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 920
         IF (DOTV) THEN
            CALL GCINIT (GPHTVG(GPHLTY), 0, IRET)
            IF (IRET.NE.0) GO TO 920
            END IF
         I = 0
         J = 0
         DO 70 JI = BIF,EIF
            GOOD = .FALSE.
            DO 65 JC = BCHAN,ECHAN
               I = I + 1
               IF (FRQLAB) THEN
                  F = (REFREQ + FOFF(JI) + (JC - REFPIX) * FINC(JI))
                  X = (F - FRQMIN) / (FRQMAX-FRQMIN) * (XTRC(1)-XBLC(1))
     *               + XBLC(1)
               ELSE
                  X = I * XSC + XBLC(1)
                  END IF
               J = J + 1
               IF (SX(J).NE.FBLANK) THEN
                  YP = (XTRC(2) + XBLC(2)) / 2.0
                  IF (SP(J).NE.FBLANK) YP = (SP(J) - YMIN) / (YMAX -
     *               YMIN)* (XTRC(2)-XBLC(2)) + XBLC(2)
                  Y = (SX(J) - YMIN) / (YMAX - YMIN) * (XTRC(2)-XBLC(2))
     *               + XBLC(2)
                  IF ((Y.LT.XBLC(2)) .OR. (Y.GT.XTRC(2))) THEN
                     IF ((YP.GT.XBLC(2)) .AND. (YP.LT.XTRC(2))) NOFF(JI)
     *                  = NOFF(JI) + 1
                     Y = MAX (XBLC(2), MIN (XTRC(2), Y))
                     END IF
                  IF (GOOD) THEN
                     CALL GVEC (X, Y, PLBUFF, IRET)
                     IF (IRET.NE.0) GO TO 920
                  ELSE
                     CALL GPOS (X, Y, PLBUFF, IRET)
                     IF (IRET.NE.0) GO TO 910
                     END IF
                  GOOD = .TRUE.
               ELSE
                  GOOD = .FALSE.
                  END IF
 65            CONTINUE
            I = I + 1
 70         CONTINUE
         END IF
      DO 80 JI = 1,NI
         WRITE (MSGTXT,1065) JI+BIF-1, NOFF(JI)
         IF (NOFF(JI).GT.0) THEN
            CALL MSGWRT (3)
            IF (FRQLAB) THEN
               F = (REFREQ + FOFF(BIF+JI-1) - REFPIX * FINC(BIF+JI-1))
               X = (F - FRQMIN) / (FRQMAX-FRQMIN) * (XTRC(1) - XBLC(1))
     *            + XBLC(1)
            ELSE
               X = (JI-1) * (NC + 1.0) + XBLC(1)
               END IF
            CALL GPOS (X, XTRC(2), PLBUFF, IRET)
            IF (IRET.NE.0) GOTO 910
            WRITE (MSGBUF,1060) NOFF(JI)
            CALL CHTRIM (MSGBUF, 8, MSGBUF, INCHAR)
            CALL GLTYPE (1, PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 920
            IF (DOTV) THEN
               CALL GCINIT (GPHTVG(GPHLTY), 0, IRET)
               IF (IRET.NE.0) GO TO 920
               END IF
            CALL GICHAR (1, INCHAR, 0, 4.0, -3.5, MSGBUF, PLBUFF,
     *         IRET)
            IF (IRET.NE.0) GO TO 920
            IF (FRQLAB) THEN
               F = REFREQ + FOFF(BIF+JI) - REFPIX * FINC(BIF+JI)
               IF (BIF+JI.GT.EIF) F = FRQMAX
               X = (F - FRQMIN) / (FRQMAX-FRQMIN) * (XTRC(1) - XBLC(1))
     *            + XBLC(1)
            ELSE
               X = JI * (NC + 1.0) + XBLC(1)
               END IF
            CALL GPOS (X, XTRC(2), PLBUFF, IRET)
            IF (IRET.NE.0) GOTO 910
            DX = -4 - INCHAR
            CALL GICHAR (1, INCHAR, 0, DX, -3.5, MSGBUF, PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 920
            END IF
 80      CONTINUE
      IF (((LPY-1)*NXP + LPX.EQ.NPLOTS) .OR. (KTYPE.LT.0)) THEN
         WRITE (MSGTXT,1070) IVER
         IF (.NOT.DOTV) CALL MSGWRT (3)
         GPHPAG = KTYPE.GT.0
         CALL GFINIS (PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 950
         END IF
      CALL RCOPY (2, XPSAVE, XPIXR)
      CALL RCOPY (4, APSAVE, APARM)
      GO TO 999
C                                       Error return from GPOS.
 910  MSGTXT = 'VLBRFP: PLOT ERROR OCCURRED WHILE MOVING TO A POINT.'
      GO TO 940
C                                       Error return from GVEC.
 920  MSGTXT = 'VLBRFP: PLOT ERROR OCCURRED WHILE DRAWING A LINE.'
 940  CALL MSGWRT (8)
C                                       Destroy the PLot file on error.
 950  IF (.NOT.DOTV) THEN
         WRITE (MSGTXT,1950) IVER
         CALL MSGWRT (8)
         CALL ZCLOSE (PLUN, PIND, I)
         CALL ZDESTR (DISKIN, PFILE, I)
         CALL DELEXT ('PL', DISKIN, OLDCNO, 'WRIT', CATOLD, PLBUFF,
     *      IVER, I)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1060 FORMAT (I8)
 1065 FORMAT ('IF',I3,I7,' points off the plot')
 1070 FORMAT ('Created plot file version',I4)
 1950 FORMAT ('DESTROY PLOT VERSION',I4,' DUE TO ERRORS')
      END
      SUBROUTINE DIDDLE (SP, SN, SX, YMIN, YMAX)
C-----------------------------------------------------------------------
C   DIDDLE tries to find a revised YMAX s.t. the display range shows
C   most but not all points
C   Inputs:
C       SP       R(*)    spectrum mean to plot
C       SN       R(*)    spectrum min to plot
C       SX       R(*)    spectrum max to plot
C       YMIN     R       Low plot range
C   In/out:
C       YMAX     R       High plot range: in actual extreme, out revised
C-----------------------------------------------------------------------
      REAL      SP(*), SN(*), SX(*), YMIN, YMAX
C
      INCLUDE 'VLBRF.INC'
      INTEGER   NST
      PARAMETER (NST=200)
C
      INTEGER   I, NOUT(NST), J, NC, NI, JC, NTOT
      REAL      YMAXIN, YX(NST)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
      YMAXIN = YMAX
      YMAXIN = MIN (1.E6, YMAXIN)
      DO 10 I = 1,NST
         YX(I) = YMAXIN * I / REAL (NST)
 10      CONTINUE
      CALL FILL (NST, 0, NOUT)
      NTOT = 0
      NC = (ECHAN - BCHAN + 1)
      NI = (EIF - BIF + 1)
      JC = NC * NI
      DO 40 I = 1,JC
         IF ((SP(I).NE.FBLANK) .AND. (SX(I).NE.FBLANK)) THEN
            NTOT = NTOT + 1
            DO 20 J = 1,NST
               IF ((SP(I).GT.YX(J)) .OR. (SX(I).GT.YX(J))) NOUT(J) =
     *            NOUT(J) + 1
 20            CONTINUE
            END IF
 40      CONTINUE
      I = NST
      DO 50 J = NST,1,-1
         YX(J) = REAL (NOUT(J)) / REAL (NTOT)
         IF (YX(J).LT.0.05) I = J
 50      CONTINUE
      YMAX = YMAXIN * I / REAL (NST)
C
 999  RETURN
      END
      SUBROUTINE RMSLAB (ITY, BLC, TRC, FAC, XMIN, XMAX, YMIN, YMAX,
     *   NC, NI, LBCHAN, LBIF, IVER, LABEL, CATOLD, JANT, STN, STOKES,
     *   LABFRQ, FRQMAX, LPX, LPY, NYP, PLBUFF, IRET)
C-----------------------------------------------------------------------
C   Write labeling for VLBRF plots
C   Inputs:
C      ITY     I        Plot type: 1 all 3, 2 mean, 3 std, 4 std/mean
C      BLC     R(2)     bottom left corner of plot.
C      TRC     R(2)     top right hand corner of plot.
C      FAC     R        FAC*XYRATO = real XYRATIO.
C      IVER    I        plot file version number
C      LABEL   I        labeling type
C      LABFRQ  R        <= 0 label frequency else channels
C   In/out:
C      PLBUFF   I(256)   I/O buffer for plot file.
C   Output:
C      IRET    I        error code returned from GVEC.
C-----------------------------------------------------------------------
      REAL      BLC(2), TRC(2), FAC, XMIN, XMAX, YMIN, YMAX, LABFRQ
      INTEGER   ITY, NC, NI, LBCHAN, LBIF, IVER, LABEL, CATOLD(256),
     *   JANT, LPX, LPY, NYP, PLBUFF(256), IRET
      CHARACTER STN*(*), STOKES*(*)
      DOUBLE PRECISION FRQMAX
C
      CHARACTER PREFIX(2)*5, TIME*8, DATE*12, NAMSTR*18, MSGBUF*80
      LOGICAL   PFLAG
      REAL      XINTER(24), DCX, DCY, XNOINT, DIST, ODIST, TICSCL, XVAL,
     *   YTICEL, YTICER, YPOS, TICLEN, XINT, X, DCXM, XDIST, DEGL, DEGU,
     *   GTRC, GBLC, DEG
      INTEGER   INOINT, INCHAR, I, IXO, IANGL, IT(3), ID(3), ITMP, JT,
     *   LTYPE, LECHAN, JTRIM, IDUM(5), KT, IDEPTH(5)
      HOLLERITH HDUM(5)
      EQUIVALENCE (IDUM, HDUM)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      DATA TICSCL /70.0/
      DATA XINTER /.001, .002, .005, .01, .02, .05, .1, .2, .5,
     *   1., 2., 5., 10., 20., 50., 100., 200., 500.,
     *   1000., 2000., 5000., 10000., 20000., 50000./
C-----------------------------------------------------------------------
C                                        Set up the location common
C                                        for tick marks etc.
      CALL FILL (5, 1, IDEPTH)
      LOCNUM = 1
      CALL SETLOC (IDEPTH, .FALSE.)
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      AXFUNC(1,LOCNUM) = 0
      AXFUNC(2,LOCNUM) = 0
      CPREF(1,LOCNUM) = ' '
      CPREF(2,LOCNUM) = ' '
      LTYPE = MOD (ABS(LABEL), 100)
      IF (LTYPE.LE.1) GO TO 999
      LECHAN = LBCHAN + NC - 1
C                                       Tic positions.
      TICLEN = (TRC(1) - BLC(1)) / TICSCL
      YTICEL = BLC(1) + TICLEN
      YTICER = TRC(1) - TICLEN
C                                       Find vertical interval value.
      DIST = YMAX - YMIN
      ODIST = DIST
      CALL METSCL (LABEL, DIST, PREFIX(2), PFLAG)
      IF (PFLAG) GO TO 110
      XDIST = DIST / ODIST
      GTRC = YMAX * XDIST
      GBLC = YMIN * XDIST
      XINT = 8.0
      DO 20 I = 1,24
         DEG = XINTER(I)
         DEGU = AINT (GTRC/DEG) * DEG
         IF (DEGU.GT.GTRC) DEGU = DEGU - DEG
         DEGL = AINT (GBLC/DEG) * DEG
         IF (DEGL.LT.GBLC) DEGL = DEGL + DEG
         XNOINT = AINT ((DEGU-DEGL)/DEG) + 1.0
         IF (XNOINT.LE.XINT) GO TO 30
 20      CONTINUE
      GO TO 110
C                                       Interval and no of inter found.
 30   XINT = DEG
      INOINT = XNOINT + 2
      ODIST = XDIST * YMIN
      XVAL = AINT (ODIST/XINT) * XINT
      IF (XVAL.GE.ODIST) XVAL = XVAL - XINT
      IXO = I
      DCXM = -0.5
C                                       Loop for all tics.
      DO 100 I = 1,INOINT
         XVAL = XVAL + XINT
         YPOS = XVAL / XDIST
         YPOS = (YPOS - YMIN) / (YMAX - YMIN) * (TRC(2)-BLC(2)) + BLC(2)
         IF (YPOS.GT.TRC(2)) GO TO 110
C                                       right hand tic.
         CALL GPOS (TRC(1), YPOS, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL GVEC (YTICER, YPOS, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Left hand tic.
         CALL GPOS (YTICEL, YPOS, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL GVEC (BLC(1), YPOS, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Write value.
         IF (LTYPE.GT.2) THEN
            WRITE (MSGBUF,1030) XVAL
            CALL CHTRIM (MSGBUF, 14, MSGBUF, INCHAR)
            IF (IXO.GT.3) INCHAR = INCHAR - 1
            IF (IXO.GT.6) INCHAR = INCHAR - 1
            IF (IXO.GT.9) INCHAR = INCHAR - 2
            DCX = - INCHAR - 1.0
            DCY = -0.5
            DCXM = MIN (DCXM, DCX)
            CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
 100     CONTINUE
C                                       RMS
 110  DCX = DCXM - 2.0
      YPOS = (TRC(2) + BLC(2)) / 2.0
      CALL GPOS (BLC(1), YPOS, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (ITY.EQ.2) THEN
         MSGBUF = PREFIX(2) // ' Mean'
      ELSE IF (ITY.EQ.3) THEN
         MSGBUF = PREFIX(2) // ' RMS'
      ELSE IF (ITY.EQ.1) THEN
         MSGBUF = PREFIX(2) // ' All 3'
      ELSE
         MSGBUF = PREFIX(2) // ' ModIndx'
         END IF
      CALL CHTRIM (MSGBUF, 80, MSGBUF, INCHAR)
      MSGBUF(INCHAR+2:) = 'AutoCorr'
      CALL CHTRIM (MSGBUF, 80, MSGBUF, INCHAR)
      DCY = INCHAR / 2.0 - 1.0
      CALL GCHAR (INCHAR, 1, DCX, DCY, MSGBUF, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Nchan, BIF, EIF
      IF ((LTYPE.LT.7) .AND. (LPY.EQ.NYP)) THEN
         MSGBUF = 'IF'
         DCY = -2.833 - 1.333
         IF (LTYPE.EQ.2) DCY = -2.833
         XDIST = (TRC(1) - BLC(1)) / NI
         DO 120 I = 1,NI
            ITMP = LBIF + I - 1
            IF ((I.EQ.1) .OR. (NI.LE.4)) THEN
               IF (ITMP.LT.10) THEN
                  WRITE (MSGBUF(4:),1110) ITMP
               ELSE
                  WRITE (MSGBUF(4:),1111) ITMP
                  END IF
            ELSE
               IF (ITMP.LT.10) THEN
                  WRITE (MSGBUF(1:),1110) ITMP
               ELSE
                  WRITE (MSGBUF(1:),1111) ITMP
                  END IF
               END IF
            CALL REFRMT (MSGBUF, '_', INCHAR)
            X = (I - 0.5) * XDIST + BLC(1)
            CALL GPOS (X, BLC(2), PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 999
            DCX = -INCHAR/2.0
            CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 999
 120        CONTINUE
         END IF
C                                       Determine label range
      IF (LABFRQ.LE.0.0) THEN
         CALL FINLAB (BLC, TRC, LBCHAN, LECHAN, LBIF, NI, LABEL, PLBUFF,
     *      IRET)
         MSGBUF = 'Frequency (GHz)'
         IF (FRQMAX.LT.1.E9) MSGBUF = 'Frequency (MHz)'
      ELSE
         CALL PINLAB (BLC, TRC, LBCHAN, LECHAN, NI, LABEL, PLBUFF, IRET)
         MSGBUF = 'Spectral channels'
         END IF
      IF (IRET.NE.0) GO TO 999
C                                       Label with prefix
      DCY = -1.5
      IF (LTYPE.GT.2) DCY = -2.833
      X = (TRC(1) + BLC(1)) / 2.0
      CALL GPOS (X, BLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL CHTRIM (MSGBUF, 17, MSGBUF, INCHAR)
      DCX = 0.5 - INCHAR / 2.0
      CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (LTYPE.GE.7) GO TO 999
C                                       which axis is which?
C                                       Source name, stokes, freq.
      CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      DCX = 0.0
      DCY = 0.5
      IANGL = 0
      JT = JTRIM (STN)
      KT = JTRIM (STOKES)
      WRITE (MSGBUF,1200) JANT, STN(:JT), STOKES(:KT)
      INCHAR = JTRIM (MSGBUF)
C                                       image name
      INCHAR = INCHAR + 1
      IF (INCHAR.GT.1) THEN
         MSGBUF(INCHAR:INCHAR+2) = ' __'
         INCHAR = INCHAR + 3
         END IF
      CALL COPY (5, CATOLD(KHIMN), IDUM)
      CALL H2CHR (12, KHIMNO, HDUM, NAMSTR(1:12))
      CALL H2CHR (6, KHIMCO, HDUM, NAMSTR(13:18))
      CALL NAMEST (NAMSTR, CATOLD(KIIMS), MSGBUF(INCHAR:), ITMP)
      CALL REFRMT (MSGBUF, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       time/date, version
      IF ((LABEL.GT.0) .AND. (LPX.EQ.1) .AND. (LPY.EQ.1)) THEN
         CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, TIME, DATE)
         WRITE (MSGBUF,1210) IVER, DATE, TIME
         CALL REFRMT (MSGBUF, '_', INCHAR)
         DCY = DCY + 1.333
         CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, PLBUFF, IRET)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (F14.3)
 1110 FORMAT (I1)
 1111 FORMAT (I2)
 1200 FORMAT ('Antenna',I3,1X,'''',A,'''',2x,'___Stokes ''',A,'''')
 1210 FORMAT ('Plot file version',I4,'__created ',A,A)
      END
      SUBROUTINE PINLAB (BLC, TRC, BC, EC, NG, ILTYPE, PLBUFF, IERR)
C-----------------------------------------------------------------------
C   To do X axis where we have multiple sub panels with integer counts
C   Inputs:
C      BLC      R(2)    X, Y pixels to form bottom left hand corner
C      TRC      R(2)    X, Y pixels to form the top right hand corner
C      BC       I       Begin count
C      EC       I       End count
C      NG       I       Number of such groups
C      ILTYPE   I       label type: 1 none, 2 no ticks, 3 RA/DEC
C                          4 center relative
C   In/out:
C      PLBUFF   I(256)  the updated graphics output buffer.
C      IERR     I       error indicator: 0 = No error.
C-----------------------------------------------------------------------
      REAL      BLC(2), TRC(2)
      INTEGER   BC, EC, NG, ILTYPE, PLBUFF(*), IERR
C
      INTEGER   NINTER
      PARAMETER (NINTER=15)
C
      INTEGER   INCHAR, LTYPE, I, XINTER(NINTER), XINT, DIST, NOINT,
     *   NINT, IG, XVAL, DEGL, DEGU, DEG
      REAL      DCX, DCY, XL, XI, XPOS, XSC
      CHARACTER SPRTXT*8
      INCLUDE 'INCS:DMSG.INC'
      DATA XINTER /1, 2, 5, 10, 20, 50, 100, 200, 500, 1000,
     *   2000, 5000, 10000, 20000, 50000/
C-----------------------------------------------------------------------
      LTYPE = MOD (ABS (ILTYPE), 100)
      IF (LTYPE.EQ.1) GO TO 999
C                                       tick marks
      XINT = 32 / NG
      XINT = MAX (3, MIN (16, XINT))
      DIST = EC - BC + 2
      DO 20 I = 1,NINTER
         DEG = XINTER(I)
         DEGU = (EC / DEG) * DEG
         IF (DEGU.GT.EC) DEGU = DEGU - DEG
         DEGL = (BC / DEG) * DEG
         IF (DEGL.LT.BC) DEGL = DEGL + DEG
         NOINT = (DEGU - DEGL) / DEG + 1
         IF (NOINT.LE.XINT) GO TO 30
 20      CONTINUE
      MSGTXT = 'PINLAB: TICK MARK ALGORITHM FAILED'
      CALL MSGWRT (6)
      IERR = 0
      GO TO 999
C                                       plot tick marks
 30   XINT = DEG
      NINT = (NOINT * NG) / 16
      NINT = MAX (1, MIN (NINT, NOINT))
      NOINT = NOINT + 2
      DCX = -0.5
      XL = DIST * NG + 1
      XL = (TRC(1) - BLC(1)) / XL
      XI = (TRC(2) - BLC(2)) / 25.
      DCY = -1.5
      XSC = (TRC(1) - BLC(1)) / (NG * DIST)
      DO 50 IG = 1,NG
         XVAL = (BC / XINT) * XINT
         IF (XVAL.GE.BC) XVAL = XVAL - XINT
         DO 40 I = 1,NOINT
            XVAL = XVAL + XINT
            IF ((XVAL.GE.BC) .AND. (XVAL.LE.EC)) THEN
               XPOS = (XVAL-BC+1 + (IG-1)*DIST) * XSC + BLC(1)
               CALL GPOS (XPOS, TRC(2), PLBUFF, IERR)
               IF (IERR.NE.0) GO TO 999
               CALL GVEC (XPOS, TRC(2)-XI, PLBUFF, IERR)
               IF (IERR.NE.0) GO TO 999
               CALL GPOS (XPOS, BLC(2)+XI, PLBUFF, IERR)
               IF (IERR.NE.0) GO TO 999
               CALL GVEC (XPOS, BLC(2), PLBUFF, IERR)
               IF (IERR.NE.0) GO TO 999
               IF ((LTYPE.GT.2) .AND. (MOD(I,NINT).EQ.0)) THEN
                  WRITE (SPRTXT,1030) XVAL
                  CALL CHTRIM (SPRTXT, 6, SPRTXT, INCHAR)
                  DCX = 0.5 - INCHAR
                  CALL GCHAR (INCHAR, 0, DCX, DCY, SPRTXT, PLBUFF, IERR)
                  IF (IERR.NE.0) GO TO 999
                  END IF
               END IF
 40         CONTINUE
 50      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (I6)
      END
      SUBROUTINE FINLAB (BLC, TRC, BC, EC, BIF, NG, ILTYPE, PLBUFF,
     *   IERR)
C-----------------------------------------------------------------------
C   To do X axis in frequency over full plot ignorng sub-panels
C   Inputs:
C      BLC      R(2)    X, Y pixels to form bottom left hand corner
C      TRC      R(2)    X, Y pixels to form the top right hand corner
C      BC       I       Begin count
C      EC       I       End count
C      NG       I       Number of such groups
C      ILTYPE   I       label type: 1 none, 2 no ticks, 3 RA/DEC
C                          4 center relative
C   In/out:
C      PLBUFF   I(256)  the updated graphics output buffer.
C      IERR     I       error indicator: 0 = No error.
C-----------------------------------------------------------------------
      REAL      BLC(2), TRC(2)
      INTEGER   BC, EC, BIF, NG, ILTYPE, PLBUFF(*), IERR
C
      INTEGER   NINTER
      PARAMETER (NINTER=24)
C
      INCLUDE 'VLBRF.INC'
      INCLUDE 'INCS:DCHND.INC'
      INTEGER   INCHAR, LTYPE, I, NOINT, NINT, ITRY
      REAL      DCX, DCY, XI, XPOS, DEG, DEGU, DEGL, XVAL, XINT,
     *   XINTER(NINTER)
      DOUBLE PRECISION F1, F2
      CHARACTER SPRTXT*16
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA XINTER /0.001, 0.002, 0.005, 0.01, 0.02, 0.05, 0.1, 0.2, 0.5,
     *   1, 2, 5, 10, 20, 50, 100, 200, 500, 1000, 2000, 5000, 10000,
     *   20000, 50000/
C-----------------------------------------------------------------------
      LTYPE = MOD (ABS (ILTYPE), 100)
      IF (LTYPE.EQ.1) GO TO 999
      XI = (TRC(2) - BLC(2)) / 25.
C                                       CRP offset by BC
C                                       tick marks
      IF (FRQMAX.LT.1.E9) THEN
         F1 = FRQMIN / 1.D6
         F2 = FRQMAX / 1.E6
      ELSE
         F1 = FRQMIN / 1.D9
         F2 = FRQMAX / 1.E9
         END IF
      XINT = 32
      DO 20 ITRY = 1,NINTER
         DEG = XINTER(ITRY)
         DEGU = AINT (F2/DEG) * DEG
         IF (DEGU.GT.F2) DEGU = DEGU - DEG
         DEGL = AINT (F1/DEG) * DEG
         IF (DEGL.LT.F1) DEGL = DEGL + DEG
         NOINT = (DEGU - DEGL) / DEG + 1.001
         IF (NOINT.LE.XINT) GO TO 30
 20      CONTINUE
      MSGTXT = 'FINLAB: TICK MARK ALGORITHM FAILED'
      CALL MSGWRT (6)
      IERR = 0
      GO TO 999
C                                       plot tick marks
 30   XINT = DEG
      NOINT = NOINT + 2
      NINT = 1
      XVAL = AINT (F1/XINT) * XINT
      IF (XVAL.GE.F1) XVAL = XVAL - XINT
      DO 50 I = 1,NOINT
         XVAL = XVAL + XINT
         IF (XVAL.GT.DEGU) GO TO 999
         XPOS = (XVAL - F1) / (F2 - F1) * (TRC(1) - BLC(1)) + BLC(1)
         CALL GPOS (XPOS, TRC(2), PLBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (XPOS, TRC(2)-XI, PLBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GPOS (XPOS, BLC(2)+XI, PLBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (XPOS, BLC(2), PLBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         IF ((LTYPE.GT.2) .AND. (MOD(I,NINT).EQ.0)) THEN
            WRITE (SPRTXT,1030) XVAL
            CALL CHTRIM (SPRTXT, 10, SPRTXT, INCHAR)
            IF (ITRY.GT.9) THEN
               INCHAR = INCHAR - 4
            ELSE IF (ITRY.GT.6) THEN
               INCHAR = INCHAR - 2
            ELSE IF (ITRY.GT.3) THEN
               INCHAR = INCHAR - 1
               END IF
            DCX = 0.5 - INCHAR
            DCY = -1.5
            CALL GCHAR (INCHAR, 0, DCX, DCY, SPRTXT, PLBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 50      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (F10.3)
      END

      SUBROUTINE YTVOPN (BUF, IERR)
C-----------------------------------------------------------------------
C! open the TV device and the TV disk control/parameter file.
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YTVOPN opens the TV including TV lock/parameter file and reads the
C   parameters, placing them in commons.
C   Outputs:
C      BUF   I(256)   Scratch buffer
C      IERR  I        Error return from YTVOP2
C                        = 10 TV unavailable to this version
C   Version for no TV at all - stub.
C-----------------------------------------------------------------------
      INTEGER   BUF(256), IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 10
      MSGTXT = 'YTVOPN: THERE IS NO TV CONFIGURED'
      CALL MSGWRT (8)
C
 999  RETURN
      END

      SUBROUTINE WRIBOX (BOXFIL, NBOXES, NFIELD, WIN, IERR)
C-----------------------------------------------------------------------
C! Writes BOXFILE text file of Clean windows
C# Map-util Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1999-2002, 2009, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Writes a text file with the Clean boxes in a suitable format to be
C   put back into IMAGR et al
C   Inputs:
C      BOXFIL   C*48            File name - created if new,
C                               over-written if old
C      NBOXES   I(NFIELD)       Number of boxes in field
C      NFIELD   I               Number of fields
C      WIN      I(4,NFIELD,*)   Clean windows
C   Outputs:
C      IERR     I               Error code
C-----------------------------------------------------------------------
      CHARACTER BOXFIL*(*)
      INTEGER   NBOXES(*), NFIELD, WIN(4,NFIELD,*), IERR
C
      INTEGER   NF, NB, LUN, LUN2, FIND, FIND2, MSGSAV, ABOX(4), I, J,
     *   COLP, JTRIM, IROUND, KBP, II
      CHARACTER SCNAME*256, LINE*32, TXLINE*132, ULOG*24, UNAME*48,
     *   TMLINE*132
      LOGICAL   SAVEBU
      DOUBLE PRECISION X
      REAL      RDUM
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN, LUN2 /11, 10/
C-----------------------------------------------------------------------
      IERR = 0
      SCNAME = ' '
      IF ((NFIELD.GT.0) .AND. (BOXFIL.NE.' ')) THEN
         SAVEBU = .FALSE.
C                                       is there a file
         MSGSAV = MSGSUP
         MSGSUP = 32000
         CALL ZTXOPN ('QRED', LUN, FIND, BOXFIL, .FALSE., IERR)
         MSGSUP = MSGSAV
C                                       back it up
         IF (IERR.EQ.0) THEN
            COLP = INDEX (BOXFIL, ':')
            IF (COLP.LE.1) THEN
               CALL ZFULLN (' ', 'FITS', 'FILEBOX', SCNAME, IERR)
            ELSE
               ULOG = BOXFIL(:COLP-1)
               UNAME = BOXFIL(COLP+1:)
               CALL ZFULLN (' ', ULOG, UNAME, SCNAME, IERR)
               END IF
            IF (IERR.NE.0) GO TO 970
            CALL ZTXOPN ('QWRT', LUN2, FIND2, SCNAME, .FALSE., IERR)
            IF (IERR.NE.0) GO TO 970
            DO 10 I = 1,100000
               CALL ZTXIO ('READ', LUN, FIND, TXLINE, IERR)
               IF (IERR.EQ.2) GO TO 20
               IF (IERR.NE.0) GO TO 965
               J = JTRIM (TXLINE)
               J = MAX (1, J)
               CALL ZTXIO ('WRIT', LUN2, FIND2, TXLINE(:J), IERR)
               IF (IERR.NE.0) GO TO 965
 10           CONTINUE
 20        SAVEBU = .TRUE.
C                                       close both
           CALL ZTXCLS (LUN, FIND, IERR)
           CALL ZTXCLS (LUN2, FIND2, IERR)
C                                       this is less dangerous!
           CALL ZTXZAP (LUN, BOXFIL, IERR)
           CALL ZTXOPN ('WRIT', LUN, FIND, BOXFIL, .FALSE., IERR)
           IF (IERR.NE.0) GO TO 971
           CALL ZTXOPN ('QRED', LUN2, FIND2, SCNAME, .FALSE., IERR)
           IF (IERR.NE.0) GO TO 970
C                                       read back backup to new orig.
            DO 40 I = 1,100000
               CALL ZTXIO ('READ', LUN2, FIND2, TXLINE, IERR)
               IF (IERR.EQ.2) GO TO 50
               IF (IERR.NE.0) GO TO 965
               CALL CHTRIM (TXLINE, 132, TMLINE, J)
               KBP = 1
               IF (TMLINE(:1).EQ.' ') GO TO 30
               IF (TMLINE(:1).LT.'0') GO TO 30
               IF (TMLINE(:1).GT.'9') GO TO 30
               CALL GETNUM (TMLINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 965
               RDUM = X
               J = IROUND (RDUM)
               IF ((J.GE.1) .AND. (J.LE.NFIELD)) GO TO 40
C                                       write to output
 30            J = JTRIM (TXLINE)
               J = MAX (1, J)
               CALL ZTXIO ('WRIT', LUN, FIND, TXLINE(:J), IERR)
               IF (IERR.NE.0) GO TO 965
 40            CONTINUE
 50         CALL ZTXCLS (LUN2, FIND2, IERR)
C                                       create a new BOXFILE
         ELSE
            CALL ZTXOPN ('WRIT', LUN, FIND, BOXFIL, .FALSE., IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         DO 100 NF = 1,NFIELD
            II = 0
            DO 90 NB = 1,NBOXES(NF)
               CALL COPY (4, WIN(1,NF,NB), ABOX)
               IF ((ABOX(1).NE.0) .AND. (ABOX(2).GT.0) .AND.
     *            (ABOX(3).GT.0) .AND. (ABOX(4).GT.0)) THEN
                  WRITE (LINE,1010) NF, ABOX
                  CALL CHTRIM (LINE, 32, LINE, J)
                  CALL ZTXIO ('WRIT', LUN, FIND, LINE(:J), IERR)
                  IF (IERR.NE.0) GO TO 970
                  II = II + 1
                  END IF
 90            CONTINUE
C                                       null
            IF (II.LE.0) THEN
               CALL FILL (4, 0, ABOX)
               WRITE (LINE,1010) NF, ABOX
               CALL CHTRIM (LINE, 32, LINE, J)
               CALL ZTXIO ('WRIT', LUN, FIND, LINE(:J), IERR)
               IF (IERR.NE.0) GO TO 970
               END IF
 100        CONTINUE
         SAVEBU = .FALSE.
         GO TO 970
         END IF
      GO TO 999
C                                        Close downs
 965  CALL ZTXCLS (LUN2, FIND2, IERR)
 970  CALL ZTXCLS (LUN, FIND, IERR)
 971  IF (SCNAME.NE.' ') THEN
         IF (SAVEBU) THEN
            MSGTXT = 'OBOXFILE backup saved in file:'
            CALL MSGWRT (8)
            MSGTXT = SCNAME
            CALL MSGWRT (8)
         ELSE
            CALL ZTXZAP (LUN2, SCNAME, IERR)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (I4,4I7)
      END

LOCAL INCLUDE 'MATCH.INC'
C                                       Local include for MATCH
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXSOU
      PARAMETER (MAXSOU=512)
C
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAME2(3), XCLAS2(2), XNAMOU(3),
     *   XCLAOU(2)
      REAL      XSIN, XDISIN, XS2, XDISK2, XSOUT, XDISO, BUFF1(UVBFSS),
     *   BUFF2(UVBFSS), XFLAGS
      INTEGER   SEQ1, SEQ2, SEQO, DISK1, DISK2, DISKO, JBUFSZ, ILOCWT,
     *   CAT1(256), CAT2(256), INCSI, INCFI, INCIFI, INCSO, INCFO,
     *   INCIFO, LRECI, LRECO, NRPRMI, NRPRMO, CNO1, CNO2, CNOO,
     *   ANTS(MAXANT,100), SOURCS(MAXSOU), FQIDS(MAXFQ), WASA, WASS,
     *   WASF, IBUFF1(UVBFSS), IBUFF2(UVBFSS), RPROTA(14), SCRTCH(512)
      LOGICAL   ISCOMP, DOFR, DOAN, DOSO
      CHARACTER NAMEIN*12, CLAIN*6, NAME2*12, CLAS2*6, NAMOUT*12,
     *   CLAOUT*6, ANAMES(MAXANT,100)*8
      DOUBLE PRECISION FRQ1, FRQ2
      HOLLERITH CAT1H(256), CAT2H(256)
      EQUIVALENCE (CAT1, CAT1H),  (CAT2, CAT2H)
      EQUIVALENCE (IBUFF1, BUFF1), (IBUFF2, BUFF2)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAME2, XCLAS2,
     *   XS2, XDISK2, XNAMOU, XCLAOU, XSOUT, XDISO, XFLAGS
      COMMON /MATCHC/ CAT1, CAT2, FRQ1, FRQ2, SEQ1, SEQ2, SEQO, DISK1,
     *   DISK2, DISKO, ILOCWT, INCSI, INCFI, INCIFI, INCSO, INCFO,
     *   INCIFO, LRECI, LRECO, NRPRMI, NRPRMO, ISCOMP, JBUFSZ, CNO1,
     *   CNO2, CNOO, ANTS, SOURCS, FQIDS, WASA, WASS, WASF, DOFR, DOAN,
     *   DOSO, RPROTA
      COMMON /CHARPM/ NAMEIN, CLAIN, NAME2, CLAS2, NAMOUT, CLAOUT,
     *   ANAMES
      COMMON /BUFRS/ BUFF1, BUFF2, SCRTCH
      INCLUDE 'INCS:DCAT.INC'
C                                       End local include for MATCH
LOCAL END
      PROGRAM MATCH
C-----------------------------------------------------------------------
C! Converts antenna, source, FQ numbers of one data set to match 2nd
C# UV VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 2000-2001, 2007-2009, 2012, 2015, 2021, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MATCH renumbers the antennas, sources, and FQs of one data set to
C   match those of another.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQ1          Seq. of input UV data.
C      INDISK         DISK1         Disk number of input VU data.
C      IN2NAME        NAME2         Name of Master file.
C      IN2CLASS       CLAS2         Class of Master file.
C      IN2SEQ         SEQ2          Seq. no. of Master file.
C      IN2DISK        DISK2         Vol. no. of Master file.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQO          Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'MATCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'MATCH '/
C-----------------------------------------------------------------------
C                                       Get inputs create output file
      CALL MATCIN (PRGM, IRET)
C                                       Get table translations
      IF (IRET.EQ.0) CALL MATCTA (IRET)
C                                       Translate data to output file
      IF (IRET.EQ.0) CALL MATCUV (IRET)
C                                       Write HIstory info
      IF (IRET.EQ.0) CALL MATCHI
C                                       Close down files, etc.
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE MATCIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   MATCIN gets input parameters for MATCH and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, J
      LOGICAL   T
      INCLUDE 'MATCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK  /' '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      J = 100 * MAXANT
C                                       zero translation array
      CALL FILL (J, 0, ANTS)
      CALL FILL (MAXSOU, 0, SOURCS)
      CALL FILL (MAXFQ, 0, FQIDS)
      WASA = 0
      WASS = 0
      WASF = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 22
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRTCH, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAME2, NAME2)
      CALL H2CHR (6, 1, XCLAS2, CLAS2)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQ1 = IROUND (XSIN)
      SEQO = IROUND (XSOUT)
      SEQ2 = IROUND (XS2)
      DISK1 = IROUND (XDISIN)
      DISK2 = IROUND (XDISK2)
      DISKO = IROUND (XDISO)
C                                       flags
      J = IROUND (XFLAGS)
      IF (J.LE.0) J = 7
      DOAN = MOD(J,2).GT.0
      J = J / 2
      DOSO = MOD(J,2).GT.0
      J = J / 2
      DOFR = MOD(J,2).GT.0
C                                       Get CATBLK from Master file
      CNO2 = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISK2, CNO2, NAME2, CLAS2, SEQ2, PTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAME2, CLAS2, SEQ2, DISK2,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISK2, CNO2, CATBLK, 'REST', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save master CATBLK
      CALL COPY (256, CATBLK, CAT2)
      CALL UVPGET (IERR)
      FRQ2 = FREQ
C                                       Get CATBLK from old file.
      CNO1 = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISK1, CNO1, NAMEIN, CLAIN, SEQ1,
     *   PTYPE, NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQ1, DISK1,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISK1, CNO1, CATBLK, 'REST', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CAT1)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      FRQ1 = FREQ
      IF (DOFR) CATD(KDCRV+JLOCF) = FRQ2
C                                       check random parameters
      CALL CHKRAN
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQ1, BLANK, NAMOUT, CLAOUT, SEQO)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQO
C                                       Create output file.
      CNOO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CNOO, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((CNOO.NE.CNO1) .OR. (DISKO.NE.DISK1)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, CNOO, CATBLK, 'WRIT', SCRTCH, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CNOO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                       copy keywords
      CALL KEYCOP (DISK1, CNO1, DISKO, CNOO, IERR)
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISK1, CNO1, NAMEIN, CLAIN, SEQ1,
     *   PTYPE, NLUSER, 'READ', SCRTCH, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK1
      FCNO(NCFILE) = CNO1
      FRW(NCFILE) = 0
      JERR = 0
      SEQO = CATBLK(KIIMS)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MATCIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('MATCIN: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE CHKRAN
C-----------------------------------------------------------------------
C   CHKRAN prepares a set of pointers for where the random parameters
C   go
C   Output in COMMON
C      RPROTA
C-----------------------------------------------------------------------
      INCLUDE 'MATCH.INC'
      INTEGER   I, J, N1, N2, USED(14), NTOT
      CHARACTER RP1(14)*8, RP2(14)*8
      LOGICAL   DIFFER
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL FILL (14, 0, RPROTA)
      CALL FILL (14, 0, USED)
      N1 = CAT1(KIPCN)
      N2 = CAT2(KIPCN)
      DO 20 I = 1,N1
         J = KHPTP + 2 * (I-1)
         CALL H2CHR (8, 1, CAT1H(J), RP1(I))
 20      CONTINUE
      DO 25 I = 1,N2
         J = KHPTP + 2 * (I-1)
         CALL H2CHR (8, 1, CAT2H(J), RP2(I))
 25      CONTINUE
      WRITE (MSGTXT,1025) N1, N2
      IF (N1.NE.N2) CALL MSGWRT (7)
C                                       compare strings
      DIFFER = .FALSE.
      NTOT = 0
      DO 40 I = 1,N1
         DO 30 J = 1,MIN (N1,N2)
            IF (RP1(I).EQ.RP2(J)) THEN
               RPROTA(I) = J
               USED(J) = I
               IF (I.NE.J) DIFFER = .TRUE.
               NTOT = NTOT + 1
               GO TO 40
               END IF
 30         CONTINUE
         DIFFER = .TRUE.
         WRITE (MSGTXT,1030) RP1(I)
         CALL MSGWRT (6)
 40      CONTINUE
C                                       work only if differ
      IF (DIFFER) THEN
         IF (NTOT.LT.N1) THEN
            DO 50 I = 1,N1
               IF (RPROTA(I).EQ.0) THEN
                  DO 45 J = 1,N1
                     IF (USED(J).EQ.0) THEN
                        RPROTA(I) = J
                        USED(J) = I
                        GO TO 50
                        END IF
 45                  CONTINUE
                  END IF
 50            CONTINUE
            END IF
C                                       labels
         DO 60 I = 1,N1
            J = KHPTP + (RPROTA(I)-1) * 2
            CALL CHR2H (8, RP1(I), 1, CATH(J))
 60         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1025 FORMAT ('CHKRAN: WARNING NUMBER RANDOM PARAMETERS DIFFER!',2I3)
 1030 FORMAT ('CHKRAN: INPUT PARAMETER ''',A,''' NOT FOUND IN MASTER')
      END
      SUBROUTINE MATCTA (IRET)
C-----------------------------------------------------------------------
C   MATCTA determines the translation of antenna, source, FQ numbers
C   from input file 1 to match file 2
C   Outputs:
C      IRET     I      Error code: > 0 quit
C   Common output:
C      ANTS     I(*,*)   Antenna number out (ant # in, subarray)
C      SOURCS   I(*)     Source number out (source number in)
C      FQIDS    I(*)     FQ ID # out (FQ IF # in)
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'MATCH.INC'
      INTEGER   IV, NV, NV1, NV2, LUNI, LUNO, NREC, IREC, JREC, MAXA, I,
     *   J, IFQRNO, FQKOLS(MAXFQC), FQNUMV(MAXFQ), FQID, IFSIDE(MAXIF),
     *   FFSIDE(MAXIF,MAXFQ), NUMIF, ISURNO, SUKOLS(MAXSUC), LUN3,
     *   SUNUMV(MAXSUC), IBUFF3(512), ANKOL2(MAXANC), ANNUM2(MAXANC),
     *   ANKOL1(MAXANC), ANNUM1(MAXANC), NOPC2, NOPC1, RENUMB
      CHARACTER EXTYPE*2, STNAME(MAXANT)*8, SSNAME(MAXSOU)*16,
     *   BNDCOD(MAXIF)*8
      DOUBLE PRECISION SXYZ(3,MAXANT), AEPS, FEPS, IFFREQ(MAXIF),
     *   FFREQ(MAXIF,MAXFQ), SRA(MAXSOU), SDEC(MAXSOU), PEPS,
     *   ORA(MAXSOU), ODEC(MAXSOU)
      REAL      IFCHW(MAXIF), IFTBW(MAXIF), FFCHW(MAXIF,MAXFQ), FEPS2,
     *   BUFF3(512)
      LOGICAL   OPEN3
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSOU.INC'
      EQUIVALENCE (IBUFF3, BUFF3)
      DATA LUNI, LUNO, LUN3 /21,22,23/
      DATA AEPS, FEPS, FEPS2, PEPS /1.0D0, 1.0D2, 1.0E0, 2.778D-7/
C-----------------------------------------------------------------------
      RENUMB = 0
C                                       Antenna matching
      EXTYPE = 'AN'
      CALL FNDEXT (EXTYPE, CAT1, NV1)
      CALL FNDEXT (EXTYPE, CAT2, NV2)
      IF (DOAN) THEN
         IF (NV1.NE.NV2) THEN
            MSGTXT = 'WARNING: NUMBER OF SUBARRAYS DOES NOT MATCH'
            CALL MSGWRT (7)
            END IF
      ELSE
         MSGTXT = 'WARNING: ANTENNAS NOT MATCHED'
         CALL MSGWRT (7)
         NV2 = 0
         END IF
      NV = MAX (NV1, NV2)
C                                       Loop over all antenna files
      DO 90 IV = 1,NV
C                                       Open file to copy
         IF (IV.LE.NV2) THEN
            CALL ANTINI ('READ', IBUFF1, DISK2, CNO2, IV, CAT2, LUNI,
     *         IANRNO, ANKOL1, ANNUM1, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *         RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *         TFRAME, NUMORB, NOPC1, ANTNIF, ANFQID, IRET)
            IF (IRET.GT.0) GO TO 999
            CALL ANTINI ('READ', IBUFF3, DISK1, CNO1, IV, CAT1, LUN3,
     *         IANRNO, ANKOL2, ANNUM2, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *         RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *         TFRAME, NUMORB, NOPC2, ANTNIF, ANFQID, IRET)
            OPEN3 = .TRUE.
         ELSE
            CALL ANTINI ('READ', IBUFF1, DISK1, CNO1, IV, CAT1, LUNI,
     *         IANRNO, ANKOL1, ANNUM1, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *         RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *         TFRAME, NUMORB, NOPC1, ANTNIF, ANFQID, IRET)
            OPEN3 = .FALSE.
            END IF
         IF (IRET.GT.0) GO TO 999
         NREC = IBUFF1(5)
         CALL ANTINI ('WRIT', IBUFF2, DISKO, CNOO, IV, CATBLK, LUNO,
     *      IANRNO, ANKOL1, ANNUM1, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *      RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *      TFRAME, NUMORB, NOPC1, ANTNIF, ANFQID, IRET)
         IF (IRET.GT.0) GO TO 999
C                                       Copy file to output, common
         DO 10 NOSTA = 1,MAXANT
            STNAME(NOSTA) = 'EMPTYANT'
            ANTS(NOSTA,IV) = 0
            ANAMES(NOSTA,IV) = '????????'
 10         CONTINUE
         MAXA = 0
         DO 20 IREC = 1,NREC
            IANRNO = IREC
            CALL TABAN ('READ', IBUFF1, IANRNO, ANKOL1, ANNUM1, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
            IF (IRET.NE.0) GO TO 999
            IANRNO = IREC
            CALL TABAN ('WRIT', IBUFF2, IANRNO, ANKOL1, ANNUM1, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
            IF (IRET.NE.0) GO TO 999
            MAXA = MAX (MAXA, NOSTA)
            STNAME(NOSTA) = ANNAME
            ANAMES(NOSTA,IV) = ANNAME
            SXYZ(1,NOSTA) = STAXYZ(1)
            SXYZ(2,NOSTA) = STAXYZ(2)
            SXYZ(3,NOSTA) = STAXYZ(3)
 20         CONTINUE
C                                       close input
         CALL TABIO ('CLOS', 1, IANRNO, IBUFF1, IBUFF1, IRET)
         IF (IRET.GT.0) GO TO 999
C                                       non-matching: 1st has more
         IF (IV.GT.NV2) THEN
            DO 30 NOSTA = 1,MAXANT
               IF (STNAME(NOSTA).NE.'EMPTYANT') ANTS(NOSTA,IV) = NOSTA
 30            CONTINUE
C                                       read 1st and match
         ELSE
            JREC = IBUFF3(5)
            IF (JREC.NE.NREC) THEN
               WRITE (MSGTXT,1030) IV, JREC, NREC
               CALL MSGWRT (6)
               END IF
            DO 50 IREC = 1,JREC
               IANRNO = IREC
               CALL TABAN ('READ', IBUFF3, IANRNO, ANKOL2, ANNUM2,
     *            ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF,
     *            DIAMAN, FWHMAN, POLTYA, POLAA, POLCA, POLTYB, POLAB,
     *            POLCB, IRET)
               IF (IRET.NE.0) GO TO 999
               DO 40 I = 1,MAXA
                  IF ((ANNAME.EQ.STNAME(I)) .AND.
     *               (ABS(SXYZ(1,I)-STAXYZ(1)).LT.AEPS) .AND.
     *               (ABS(SXYZ(2,I)-STAXYZ(2)).LT.AEPS) .AND.
     *               (ABS(SXYZ(3,I)-STAXYZ(3)).LT.AEPS)) THEN
                     ANTS(NOSTA,IV) = I
                     IF (NOSTA.NE.I) RENUMB = RENUMB + 1
                     GO TO 50
                     END IF
 40               CONTINUE
C                                       append an extra antenna!
               WRITE (MSGTXT,1040) IREC, IV
               CALL MSGWRT (6)
               NREC = NREC + 1
               MAXA = MAXA + 1
               ANTS(NOSTA,IV) = MAXA
               ANAMES(MAXA,IV) = ANNAME
               IANRNO = NREC
               NOSTA = MAXA
               CALL TABAN ('WRIT', IBUFF2, IANRNO, ANKOL1, ANNUM1,
     *            ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN,
     *            FWHMAN, POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB,
     *            IRET)
               IF (IRET.NE.0) GO TO 999
               STNAME(NOSTA) = ANNAME
               SXYZ(1,NOSTA) = STAXYZ(1)
               SXYZ(2,NOSTA) = STAXYZ(2)
               SXYZ(3,NOSTA) = STAXYZ(3)
 50            CONTINUE
            END IF
C                                       close input
         IF (OPEN3) THEN
            CALL TABIO ('CLOS', 1, IANRNO, IBUFF3, IBUFF3, IRET)
            IF (IRET.GT.0) GO TO 999
            END IF
C                                       close output
         CALL TABIO ('CLOS', 1, IANRNO, IBUFF2, IBUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 90      CONTINUE
      WRITE (MSGTXT,1090) RENUMB
      IF (RENUMB.GT.0) CALL MSGWRT (5)
C                                       FQ tables
      EXTYPE = 'FQ'
      CALL FNDEXT (EXTYPE, CAT1, NV1)
      CALL FNDEXT (EXTYPE, CAT2, NV2)
      IF (DOFR) THEN
         IF (NV1.NE.NV2) THEN
            MSGTXT = 'WARNING: NUMBER OF FQ TABLES DOES NOT MATCH'
            CALL MSGWRT (7)
            END IF
      ELSE
         MSGTXT = 'WARNING: FREQUENCIES NOT MATCHED'
         CALL MSGWRT (7)
         NV2 = 0
         END IF
      NV = MIN (1, MAX (NV1, NV2))
C                                       Do 1 or 0 FQ tables
      DO 190 IV = 1,NV
C                                       Open file to copy
         IF (IV.LE.NV2) THEN
            CALL FQINI ('READ', IBUFF1, DISK2, CNO2, IV, CAT2, LUNI,
     *         IFQRNO, FQKOLS, FQNUMV, NUMIF, IRET)
            IF (IRET.GT.0) GO TO 999
            CALL FQINI ('READ', IBUFF3, DISK1, CNO1, IV, CAT1, LUN3,
     *         IFQRNO, FQKOLS, FQNUMV, NUMIF, IRET)
            OPEN3 = .TRUE.
         ELSE
            CALL FQINI ('READ', IBUFF1, DISK1, CNO1, IV, CAT1, LUNI,
     *         IFQRNO, FQKOLS, FQNUMV, NUMIF, IRET)
            OPEN3 = .FALSE.
            END IF
         IF (IRET.GT.0) GO TO 999
         NREC = IBUFF1(5)
         CALL FQINI ('WRIT', IBUFF2, DISKO, CNOO, IV, CATBLK, LUNO,
     *      IFQRNO, FQKOLS, FQNUMV, NUMIF, IRET)
         IF (IRET.GT.0) GO TO 999
C                                       Copy file to output, common
         DO 110 I = 1,MAXFQ
            FFREQ(1,I) = -1.0D0
            FQIDS(I) = 0
 110        CONTINUE
         MAXA = 0
         DO 120 IREC = 1,NREC
            IFQRNO = IREC
            CALL TABFQ ('READ', IBUFF1, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *         FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IRET)
            IF (IRET.NE.0) GO TO 999
            IFQRNO = IREC
            CALL TABFQ ('WRIT', IBUFF2, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *         FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IRET)
            IF (IRET.NE.0) GO TO 999
            MAXA = MAX (MAXA, FQID)
            CALL COPY (NUMIF, IFSIDE, FFSIDE(1,FQID))
            CALL DPCOPY (NUMIF, IFFREQ, FFREQ(1,FQID))
            CALL RCOPY (NUMIF, IFCHW, FFCHW(1,FQID))
 120        CONTINUE
C                                       close input
         CALL TABIO ('CLOS', 1, IFQRNO, IBUFF1, IBUFF1, IRET)
         IF (IRET.GT.0) GO TO 999
C                                       non-matching: 1st has more
         IF (IV.GT.NV2) THEN
            DO 130 I = 1,MAXFQ
               IF (FFREQ(1,I).GT.0.0D0) FQIDS(I) = I
 130           CONTINUE
C                                       read 1st and match
         ELSE
            JREC = IBUFF3(5)
            IF (JREC.NE.NREC) THEN
               WRITE (MSGTXT,1130) JREC, NREC
               CALL MSGWRT (6)
               END IF
            DO 150 IREC = 1,JREC
               IFQRNO = IREC
               CALL TABFQ ('READ', IBUFF3, IFQRNO, FQKOLS, FQNUMV,
     *            NUMIF, FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD,
     *            IRET)
               IF (IRET.NE.0) GO TO 999
               DO 133 J = 1,NUMIF
                  IFFREQ(J) = IFFREQ(J) + FRQ1 - FRQ2
 133              CONTINUE
               DO 140 I = 1,MAXA
                  DO 135 J = 1,NUMIF
                     IF (FFSIDE(J,I).NE.IFSIDE(J)) GO TO 140
                     IF (ABS(FFREQ(J,I)-IFFREQ(J)).GT.FEPS) GO TO 140
                     IF (ABS(FFCHW(J,I)-IFCHW(J)).GT.FEPS2) GO TO 140
 135                 CONTINUE
                  FQIDS(FQID) = I
                  GO TO 150
 140              CONTINUE
C                                       append an extra FQID!
               WRITE (MSGTXT,1140) IREC
               CALL MSGWRT (6)
               NREC = NREC + 1
               MAXA = MAXA + 1
               FQIDS(FQID) = MAXA
               IFQRNO = NREC
               FQID = MAXA
               CALL TABFQ ('WRIT', IBUFF2, IFQRNO, FQKOLS, FQNUMV,
     *            NUMIF, FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD,
     *            IRET)
               IF (IRET.NE.0) GO TO 999
               CALL COPY (NUMIF, IFSIDE, FFSIDE(1,FQID))
               CALL DPCOPY (NUMIF, IFFREQ, FFREQ(1,FQID))
               CALL RCOPY (NUMIF, IFCHW, FFCHW(1,FQID))
 150           CONTINUE
            END IF
C                                       close input
         IF (OPEN3) THEN
            CALL TABIO ('CLOS', 1, IFQRNO, IBUFF3, IBUFF3, IRET)
            IF (IRET.GT.0) GO TO 999
            END IF
C                                       close output
         CALL TABIO ('CLOS', 1, IFQRNO, IBUFF2, IBUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 190     CONTINUE
C                                       SU tables
      EXTYPE = 'SU'
      CALL FNDEXT (EXTYPE, CAT1, NV1)
      CALL FNDEXT (EXTYPE, CAT2, NV2)
      IF (DOSO) THEN
         IF (NV1.NE.NV2) THEN
            MSGTXT = 'WARNING: NUMBER OF SU TABLES DOES NOT MATCH'
            CALL MSGWRT (7)
            END IF
      ELSE
         MSGTXT = 'WARNING: SOURCES NOT MATCHED'
         CALL MSGWRT (7)
         NV2 = 0
         END IF
      NV = MIN (1, MAX (NV1, NV2))
C                                       Do 1 or 0 FQ tables
      DO 290 IV = 1,NV
C                                       Open file to copy
         IF (IV.LE.NV2) THEN
            CALL SOUINI ('READ', IBUFF1, DISK2, CNO2, IV, CAT2, LUNI,
     *         NUMIF, VELTYP, VELDEF, FQID, ISURNO, SUKOLS, SUNUMV,
     *         IRET)
            IF (IRET.GT.0) GO TO 999
            CALL SOUINI ('READ', IBUFF3, DISK1, CNO1, IV, CAT1, LUN3,
     *         NUMIF, VELTYP, VELDEF, FQID, ISURNO, SUKOLS, SUNUMV,
     *         IRET)
            OPEN3 = .TRUE.
         ELSE
            CALL SOUINI ('READ', IBUFF1, DISK1, CNO1, IV, CAT1, LUNI,
     *         NUMIF, VELTYP, VELDEF, FQID, ISURNO, SUKOLS, SUNUMV,
     *         IRET)
            OPEN3 = .FALSE.
            END IF
         IF (IRET.GT.0) GO TO 999
         NREC = IBUFF1(5)
         CALL SOUINI ('WRIT', IBUFF2, DISKO, CNOO, IV, CATBLK, LUNO,
     *      NUMIF, VELTYP, VELDEF, FQID, ISURNO, SUKOLS, SUNUMV, IRET)
         IF (IRET.GT.0) GO TO 999
C                                       Copy file to output, common
         DO 210 I = 1,MAXSOU
            SSNAME(I) = 'NOT A SOURCE'
            SOURCS(I) = 0
 210        CONTINUE
         MAXA = 0
         DO 220 IREC = 1,NREC
            ISURNO = IREC
            CALL TABSOU ('READ', IBUFF1, ISURNO, SUKOLS, SUNUMV, IDSOUR,
     *         SNAME, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *         EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ,
     *         PMRA, PMDEC, IRET)
            IF (IRET.NE.0) GO TO 999
            ISURNO = IREC
            CALL TABSOU ('WRIT', IBUFF2, ISURNO, SUKOLS, SUNUMV, IDSOUR,
     *         SNAME, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *         EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ,
     *         PMRA, PMDEC, IRET)
            IF (IRET.NE.0) GO TO 999
            MAXA = MAX (MAXA, IDSOUR)
            SSNAME(IDSOUR) = SNAME
            SRA(IDSOUR) = RAEPO
            SDEC(IDSOUR) = DECEPO
            ORA(IDSOUR) = RAOBS
            ODEC(IDSOUR) = DECOBS
 220        CONTINUE
C                                       close input
         CALL TABIO ('CLOS', 1, ISURNO, IBUFF1, IBUFF1, IRET)
         IF (IRET.GT.0) GO TO 999
C                                       non-matching: 1st has more
         IF (IV.GT.NV2) THEN
            DO 230 I = 1,MAXSOU
               IF (SSNAME(I).NE.'NOT A SOURCE') SOURCS(I) = I
 230           CONTINUE
C                                       read 1st and match
         ELSE
            JREC = IBUFF3(5)
            IF (JREC.NE.NREC) THEN
               WRITE (MSGTXT,1230) JREC, NREC
               CALL MSGWRT (6)
               END IF
            DO 250 IREC = 1,JREC
               ISURNO = IREC
               CALL TABSOU ('READ', IBUFF3, ISURNO, SUKOLS, SUNUMV,
     *            IDSOUR, SNAME, QUAL, CALCOD, FLUX, FREQO, BANDW,
     *            RAEPO, DECEPO, EPOCH, RAAPP, DECAPP, RAOBS, DECOBS,
     *            LSRVEL, RESTFQ, PMRA, PMDEC, IRET)
               IF (IRET.NE.0) GO TO 999
               DO 240 I = 1,MAXA
                  IF ((SSNAME(I).EQ.SNAME) .AND.
     *               (ABS(SRA(I)-RAEPO).LT.PEPS) .AND.
     *               (ABS(SDEC(I)-DECEPO).LT.PEPS) .AND.
     *               (ABS(ORA(I)-RAOBS).LT.PEPS) .AND.
     *               (ABS(ODEC(I)-DECOBS).LT.PEPS)) THEN
                     SOURCS(IDSOUR) = I
                     GO TO 250
                     END IF
 240              CONTINUE
C                                       append an extra Source ID!
               WRITE (MSGTXT,1240) IREC
               CALL MSGWRT (6)
               NREC = NREC + 1
               MAXA = MAXA + 1
               SOURCS(IDSOUR) = MAXA
               ISURNO = NREC
               IDSOUR = MAXA
               CALL TABSOU ('WRIT', IBUFF2, ISURNO, SUKOLS, SUNUMV,
     *            IDSOUR, SNAME, QUAL, CALCOD, FLUX, FREQO, BANDW,
     *            RAEPO, DECEPO, EPOCH, RAAPP, DECAPP, RAOBS, DECOBS,
     *            LSRVEL, RESTFQ, PMRA, PMDEC, IRET)
               IF (IRET.NE.0) GO TO 999
               SSNAME(IDSOUR) = SNAME
               SRA(IDSOUR) = RAEPO
               SDEC(IDSOUR) = DECEPO
 250           CONTINUE
            END IF
C                                       close input
         IF (OPEN3) THEN
            CALL TABIO ('CLOS', 1, ISURNO, IBUFF3, IBUFF3, IRET)
            IF (IRET.GT.0) GO TO 999
            END IF
C                                       close output
         CALL TABIO ('CLOS', 1, ISURNO, IBUFF2, IBUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 290     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('Subarray',I3,' no ants in file 1',I3,' file 2',I3,
     *   ' not same')
 1040 FORMAT ('ANT',I3,' SUBARR',I3,' HAS NO MATCH - APPEND IT')
 1090 FORMAT ('Total number antennas renumbered',I6)
 1130 FORMAT ('Warning: number FQIDs file 1',I4,' file 2',I4,
     *   ' not same')
 1140 FORMAT ('FQID',I4,' HAS NO MATCH - APPEND IT')
 1230 FORMAT ('Warning: number sources file 1',I4,' file 2',I4,
     *   ' not same')
 1240 FORMAT ('SUID',I4,' HAS NO MATCH - APPEND IT')
      END
      SUBROUTINE MATCUV (IRET)
C-----------------------------------------------------------------------
C   MATCUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48, IFILE*48
      INTEGER   INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, ILENBU,
     *   KBIND, NIOUT, NIOLIM, IBIND, I, IA1, IA2, INCX, BO, VO,
     *   NUMVIS, XCOUNT, NCORI, NCORO, NCOPY, ISUB, J
      LOGICAL   T, F
      INCLUDE 'MATCH.INC'
      REAL      BASEN, CBUFF(UVBFSS), RESULT(UVBFSS), UVMULT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNI, LUNO /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
      IF (ISCOMP) INCX = 3
      UVMULT = 1.0
      IF (DOFR) UVMULT = FRQ2 / FRQ1
C                                       Number of visibilities in input
C                                       and output files.
      NCORI = (LRECI - NRPRMI) / CAT1(KINAX)
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISK1, CNO1, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISK1, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CNOO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Out of data?
         IF (INIO.LE.0) GO TO 200
C                                       Loop over buffer
         DO 190 I = 1,INIO
            IF (ILOCB.GE.0) THEN
               BASEN = BUFF1(IPTRI+ILOCB)
               IA1 = BASEN / 256. + 0.1
               IA2 = BASEN - IA1*256. + 0.1
               ISUB = 100.0 * (BASEN - IA1*256 - IA2) + 1.5
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               ISUB = BUFF1(IPTRI+ILOCSA) + 0.1
               END IF
            NUMVIS = NUMVIS + 1
C                                       Compressed data.
            IF (ISCOMP) THEN
               CALL ZUVXPN (NCORI, BUFF1(IPTRI+NRPRMI),
     *            BUFF1(IPTRI+ILOCWT), CBUFF)
               CALL DIDDLE (NUMVIS, IA1, IA2, ISUB, CBUFF, BUFF1(IPTRI),
     *            INCX, RESULT, IRET)
C                                       Un compressed data
            ELSE
               CALL DIDDLE (NUMVIS, IA1, IA2, ISUB, BUFF1(IPTRI+NRPRMI),
     *            BUFF1(IPTRI), INCX, RESULT, IRET)
               END IF
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
C                                       Copy to output.
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1.0D0
               DO 110 J = 1,NRPRMO
                  IF (RPROTA(J).GT.0) BUFF2(IPTRO-1+J) =
     *               BUFF1(IPTRI-1+RPROTA(J))
 110              CONTINUE
C               CALL RCOPY (NRPRMO, BUFF1(IPTRI), BUFF2(IPTRO))
               BUFF2(IPTRO+ILOCU) = BUFF2(IPTRO+ILOCU) * UVMULT
               BUFF2(IPTRO+ILOCV) = BUFF2(IPTRO+ILOCV) * UVMULT
               BUFF2(IPTRO+ILOCW) = BUFF2(IPTRO+ILOCW) * UVMULT
               IF (ISCOMP) THEN
                  CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *               BUFF2(IPTRO+NRPRMO))
               ELSE
                  CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
                  END IF
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               END IF
C                                       OK: w or w/o output
            IPTRI = IPTRI + LRECI
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
C                                       Read next buffer.
         GO TO 100
C                                       Final call to DIDDLE.
 200     NUMVIS = -1
         CALL DIDDLE (NUMVIS, IA1, IA2, ISUB, BUFF1, BUFF1, INCX,
     *      RESULT, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
            END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CNOO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MATCUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1010 FORMAT ('MATCUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('MATCUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('MATCUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('MATCUV: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('MATCUV: DIDDLE ERROR',I3)
 1150 FORMAT ('MATCUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE MATCHI
C-----------------------------------------------------------------------
C   MATCHI copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP(3)*2, HILINE*72
      INTEGER   LUN1, LUN2, IERR, I, J, NONOT
      LOGICAL   T
      INCLUDE 'MATCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NONOT, NOTTYP /3, 'AN', 'FQ', 'SU'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISK1, DISKO, CNO1, CNOO, CATBLK, IBUFF1,
     *   IBUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQ1, DISK1, LUN2, IBUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCO2 (TSKNAM, NAME2, CLAS2, SEQ2, DISK2, LUN2, IBUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQO, DISKO, LUN2, IBUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
C                                       antenna translations
      DO 20 J = 1,100
         DO 10 I = 1,MAXANT
            IF ((ANTS(I,J).GT.0) .AND. (ANTS(I,J).NE.I)) THEN
               WRITE (HILINE,1010) TSKNAM, I, J, ANTS(I,J)
               CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 200
               END IF
 10         CONTINUE
 20      CONTINUE
C                                       source translations
      DO 30 I = 1,MAXSOU
         IF ((SOURCS(I).GT.0) .AND. (SOURCS(I).NE.I)) THEN
            WRITE (HILINE,1020) TSKNAM, I, SOURCS(I)
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
            END IF
 30      CONTINUE
C                                       FQ translations
      DO 40 I = 1,MAXFQ
         IF ((FQIDS(I).GT.0) .AND. (FQIDS(I).NE.I)) THEN
            WRITE (HILINE,1030) TSKNAM, I, FQIDS(I)
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
            END IF
 40      CONTINUE
C                                       Frequency
      IF ((ABS(FRQ1-FRQ2).GT.50.D0) .AND. (DOFR)) THEN
         WRITE (HILINE,1040) TSKNAM, FRQ1, FRQ2
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, IBUFF2, IERR)
C                                       Warnings
      IF (WASA.GT.0) THEN
         WRITE (MSGTXT,1200) WASA, 'ANTENNA'
         CALL MSGWRT (6)
         END IF
      IF (WASS.GT.0) THEN
         WRITE (MSGTXT,1200) WASS, 'SOURCE'
         CALL MSGWRT (6)
         END IF
      IF (WASF.GT.0) THEN
         WRITE (MSGTXT,1200) WASF, 'FQ ID'
         CALL MSGWRT (6)
         END IF
C                                       Copy other tables
      CALL ADJTAB (NONOT, NOTTYP, LUN1, LUN2, DISK1, DISKO, CNO1, CNOO,
     *   ANTS, ANAMES, SOURCS, FQIDS, CATBLK, IBUFF1, IBUFF2, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'MATCHI: ERROR COPYING TABLES'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, CNOO, CATBLK, 'REST', IBUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MATCHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,'/ Antenna',I3,' Subarray',I3,' becomes antenna',I3)
 1020 FORMAT (A6,'/ Source',I4,' becomes source number',I4)
 1030 FORMAT (A6,'/ FQ ID number',I4,' becomes FQ ID number',I4)
 1040 FORMAT (A6,'/ Freq',1PD17.9,' becomes freq',1PD17.9)
 1200 FORMAT (I8,' UNDEFINED TRANSLATIONS FOR ',A,'S')
      END
      SUBROUTINE ADJTAB (NONOT, NOTTYP, LUNOLD, LUNNEW, VOLOLD, VOLNEW,
     *   CNOOLD, CNONEW, ANTS, ANAMES, SOURCS, FQIDS, CATNEW, BUFF1,
     *   BUFF2, IRET)
C-----------------------------------------------------------------------
C   ADJTAB copies all Table extension file(s).  The output files must
C   be new - old ones cannot be rewritten.  The output file must be
C   opened WRIT in the catalog and will have its CATBLK updated on disk.
C   Source, FQ, and antenna numbers are renumbered.
C   Inputs:
C      NONOT   I       Number of "Forbidden" types to copy.
C      NOTTYP  C*2(*)  Table types to ignore.
C      LUNOLD  I       LUN for old file
C      LUNNEW  I       LUN for new file
C      VOLOLD  I       Disk number for old file.
C      VOLNEW  I       Disk number for new file.
C      CNOOLD  I       Catalog slot number for old file
C      CNONEW  I       Catalog slot number for new file
C      ANTS    I(*,*)  New antenna numbers
C      ANAMES  C(*,*)  New antenna names
C      SOURCS  I(*)    New source numbers
C      FQIDS   I(*)    New FQ numbers
C   In/out:
C      CATNEW  I(256)  Catalog header for new file.
C   Output:
C      BUFF1   I(1024) Work buffer
C      BUFF2   I(1024) Work buffer
C      IRET    I       Return error code  0 => ok, otherwise TABCOP
C                                             or 10*CATIO error.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER NOTTYP(*)*2, ANAMES(MAXANT,*)*8
      INTEGER   NONOT, LUNOLD, LUNNEW, VOLOLD, VOLNEW, CNOOLD, CNONEW,
     *   ANTS(MAXANT,*), SOURCS(*), FQIDS(*), BUFF1(*), BUFF2(*),
     *   CATNEW(256), IRET
C
      INCLUDE 'INCS:PHDR.INC'
      INTEGER   NKOLS
      PARAMETER (NKOLS=9)
      INTEGER   IVERI, IVERO, IER, NONON, IEXT, JEXT, OLDNUM(NIEXTN),
     *   NKEY, NCOL, DATP(128,2), NREC, KOLS(NKOLS), LKEY(NKOLS), RTYPE,
     *   VALUE(MAXIF), ISUB, LRNO, IREC, K, IANT, JTRIM, J, JJ,
     *   ROWB(XBPRSZ), IDUM(2)
      HOLLERITH HDUM(2)
      EQUIVALENCE (IDUM, HDUM)
      LOGICAL   TABLE, EXIST, FITASC, DOPUT, DIDSOM, DIDONE
      CHARACTER OLDTYP(NIEXTN)*2, NONTAB(20)*2, KEYS(NKOLS)*8, ANNAME*8
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C                                       Non table extension files
      DATA NONON /3/
      DATA NONTAB /'HI','PL','SL',17*'  '/
      DATA KEYS /'SOURCE', 'ANTENNA', 'REFANT 1', 'REFANT 2',
     *   'ANTS', 'ANNAME', 'FRQSEL','FREQID','FREQ ID'/
      DATA LKEY /6, 7, 8, 8, 8, 8, 8, 8, 8/
C-----------------------------------------------------------------------
C                                       Get old CATBLK in BUFF2.
      CALL CATIO ('READ', VOLOLD, CNOOLD, BUFF2, 'REST', BUFF1, IRET)
      IF ((IRET.GE.1) .AND. (IRET.LE.4)) THEN
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (6)
         IRET = 10 * IRET
         GO TO 999
         END IF
C                                       header ext format
      CALL FXHDEX (BUFF2)
C                                       Get extension file info
      DO 20 IEXT = 1,KIEXTN
         OLDTYP(IEXT) = ' '
         IDUM(1) = BUFF2(KHEXT+IEXT-1)
         CALL H2CHR (2, 1, HDUM, OLDTYP(IEXT))
         OLDNUM(IEXT) = BUFF2(KIVER+IEXT-1)
C                                       Check if on non table list
         DO 10 JEXT = 1,NONON
            IF (OLDTYP(IEXT).EQ.NONTAB(JEXT)) OLDNUM(IEXT) = 0
 10         CONTINUE
C                                       Check "forbidden" types
         IF (NONOT.GT.0) THEN
            DO 15 JEXT = 1,NONOT
               IF (OLDTYP(IEXT).EQ.NOTTYP(JEXT)) OLDNUM(IEXT) = 0
 15            CONTINUE
            END IF
 20      CONTINUE
C                                       Loop, copying tables.
      DO 100 IEXT = 1,KIEXTN
         IF (OLDNUM(IEXT).LE.0) GO TO 100
C                                       Copy each table independently
         DO 90 JEXT = 1,OLDNUM(IEXT)
C                                       See if files exist and are
C                                       wanted.
            CALL ISTAB (OLDTYP(IEXT), VOLOLD, CNOOLD, JEXT, LUNOLD,
     *         BUFF1, TABLE, EXIST, FITASC, IER)
            IF (TABLE .AND. EXIST .AND. (IER.EQ.0)) THEN
               IVERI = JEXT
               IVERO = JEXT
C                                       Copy
               CALL TABCOP (OLDTYP(IEXT), IVERI, IVERO, LUNOLD, LUNNEW,
     *            VOLOLD, VOLNEW, CNOOLD, CNONEW, CATNEW, BUFF1, BUFF2,
     *            IER)
               IRET = MAX (IER, IRET)
               IF (IER.NE.0) GO TO 90
C                                       Re-open output to update #s
               DIDSOM = .FALSE.
               NKEY = 0
               NCOL = 0
               CALL TABINI ('WRIT', OLDTYP(IEXT), VOLNEW, CNONEW, IVERO,
     *            CATNEW, LUNNEW, NKEY, NREC, NCOL, DATP, BUFF2, IER)
               IRET = MAX (IER, IRET)
               IF (IER.NE.0) GO TO 90
               NREC = BUFF2(5)
               CALL FILL (NKOLS, 0, KOLS)
               K = 0
               CALL FNDCOL (1, KEYS(1), LKEY(1), .TRUE., BUFF2, KOLS(1),
     *            IER)
               IF ((IER.GT.0) .AND. (IER.LE.10)) GO TO 85
               IF (IER.GT.10) K = K + IER - 10
               CALL FNDCOL (1, KEYS(2), LKEY(2), .TRUE., BUFF2, KOLS(2),
     *            IER)
               IF ((IER.GT.0) .AND. (IER.LE.10)) GO TO 85
               IF (IER.GT.10) K = K + IER - 10
               CALL FNDCOL (NKOLS-2, KEYS(3), LKEY(3), .TRUE., BUFF2,
     *            KOLS(3), IER)
               IF ((IER.GT.0) .AND. (IER.LE.10)) GO TO 85
               IER = IER + K
               IF (IER.GE.10+NKOLS) THEN
                  IER = 0
                  GO TO 85
                  END IF
C                                       Update needed
               IF (KOLS(7).EQ.0) KOLS(7) = KOLS(8)
               IF (KOLS(7).EQ.0) KOLS(7) = KOLS(9)
C                                       subarray too
               KOLS(NKOLS) = 0
               IF ((KOLS(2).GT.0) .OR. (KOLS(3).GT.0) .OR.
     *            (KOLS(4).GT.0) .OR. (KOLS(5).GT.0) .OR.
     *            (KOLS(6).GT.0)) THEN
                  CALL FNDCOL (1, 'SUBARRAY', 7, .TRUE., BUFF2,
     *               KOLS(NKOLS), IER)
                  IF ((IER.GT.0) .AND. (IER.LE.10)) GO TO 85
                  END IF
               DO 80 IREC = 1,NREC
                  LRNO = 0
                  DIDONE = .FALSE.
C                                       source number
                  IF (KOLS(1).GT.0) THEN
                     CALL GETCOL (IREC, KOLS(1), DATP, LRNO, BUFF2,
     *                  RTYPE, VALUE, ROWB, IER)
                     IF (IER.NE.0) GO TO 85
                     IF ((VALUE(1).GT.0) .AND. (SOURCS(VALUE(1)).GT.0)
     *                  .AND. (SOURCS(VALUE(1)).NE.VALUE(1))) THEN
                        VALUE(1) = SOURCS(VALUE(1))
                        CALL PUTCOL (IREC, KOLS(1), DATP, LRNO, BUFF2,
     *                     VALUE, ROWB, IER)
                        IF (IER.NE.0) GO TO 85
                        DIDSOM = .TRUE.
                        DIDONE = .TRUE.
                        END IF
                     END IF
C                                       FQ number
                  IF (KOLS(7).GT.0) THEN
                     CALL GETCOL (IREC, KOLS(7), DATP, LRNO, BUFF2,
     *                  RTYPE, VALUE, ROWB, IER)
                     IF (IER.NE.0) GO TO 85
                     IF ((VALUE(1).GT.0) .AND. (FQIDS(VALUE(1)).GT.0)
     *                  .AND. (FQIDS(VALUE(1)).NE.VALUE(1))) THEN
                        VALUE(1) = FQIDS(VALUE(1))
                        CALL PUTCOL (IREC, KOLS(7), DATP, LRNO, BUFF2,
     *                     VALUE, ROWB, IER)
                        IF (IER.NE.0) GO TO 85
                        DIDSOM = .TRUE.
                        DIDONE = .TRUE.
                        END IF
                     END IF
C                                       subarray number
                  IF (KOLS(NKOLS).GT.0) THEN
                     CALL GETCOL (IREC, KOLS(NKOLS), DATP, LRNO, BUFF2,
     *                  RTYPE, IDUM, ROWB, IER)
                     ISUB = IDUM(1)
                     IF (IER.NE.0) GO TO 85
                     ISUB = MAX (1, ISUB)
                  ELSE
                     ISUB = 1
                     END IF
C                                       antenna number(s)
                  IANT = 0
                  DO 30 K = 2,5
                     IF (KOLS(K).GT.0) THEN
                        CALL GETCOL (IREC, KOLS(K), DATP, LRNO, BUFF2,
     *                     RTYPE, VALUE, ROWB, IER)
                        IF (IER.NE.0) GO TO 85
                        JJ = RTYPE / 10
                        JJ = MAX (1, JJ)
                        DOPUT = .FALSE.
                        DO 25 J = 1,JJ
                           IF ((VALUE(J).GT.0) .AND.
     *                        (ANTS(VALUE(1),ISUB).GT.0) .AND.
     *                        (ANTS(VALUE(J),ISUB).NE.VALUE(J))) THEN
                              VALUE(J) = ANTS(VALUE(J),ISUB)
                              DOPUT = .TRUE.
                              END IF
 25                        CONTINUE
                        IF (DOPUT) THEN
                           CALL PUTCOL (IREC, KOLS(K), DATP, LRNO,
     *                        BUFF2, VALUE, ROWB, IER)
                           IF (IER.NE.0) GO TO 85
                           DIDSOM = .TRUE.
                           DIDONE = .TRUE.
                           END IF
                        IF (K.EQ.2) IANT = VALUE(1)
                        END IF
 30                  CONTINUE
C                                       Station name
                  IF ((KOLS(6).GT.0) .AND. (IANT.GT.0)) THEN
                     CALL GETCOL (IREC, KOLS(6), DATP, LRNO, BUFF2,
     *                  RTYPE, VALUE, ROWB, IER)
                     IF (IER.NE.0) GO TO 85
                     IDUM(1) = VALUE(1)
                     IDUM(2) = VALUE(2)
                     CALL H2CHR (8, 1, HDUM, ANNAME)
                     K = JTRIM (ANNAME)
                     IF (ANNAME.NE.ANAMES(IANT,ISUB)) THEN
                        CALL CHR2H (8, ANAMES(IANT,ISUB), 1, HDUM)
                        CALL COPY (2, IDUM, VALUE)
                        CALL PUTCOL (IREC, KOLS(6), DATP, LRNO, BUFF2,
     *                     VALUE, ROWB, IER)
                        IF (IER.NE.0) GO TO 85
                        DIDSOM = .TRUE.
                        DIDONE = .TRUE.
                        END IF
                     END IF
C                                       force write to disk
                  IF (DIDONE) THEN
                     CALL PUTCOL (0, KOLS, DATP, LRNO, BUFF2, VALUE,
     *                  ROWB, IER)
                     IF (IER.NE.0) GO TO 85
                     END IF
 80               CONTINUE
C                                       close table
 85            IRET = MAX (IRET, IER)
               CALL TABIO ('CLOS', 0, NREC, ROWB, BUFF2, IER)
               IRET = MAX (IRET, IER)
               IF (DIDSOM) THEN
                  WRITE (MSGTXT,1085) OLDTYP(IEXT), IVERO
                  CALL MSGWRT (2)
                  END IF
               END IF
 90         CONTINUE
 100     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ADJTAB: ERROR',I5,' READING OLD CATBLK')
 1085 FORMAT ('Source, FQ, and/or antenna #s adjusted in ',A,
     *   ' table version',I5)
      END
      SUBROUTINE DIDDLE (NUMVIS, IA1, IA2, ISUB, VIS, RPARM, INCX,
     *   RESULT, IRET)
C-----------------------------------------------------------------------
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      IA1     I    First antenna number
C      IA2     I    Second antenna number
C      ISUB    I    Subarray number
C      RPARM   R(*) Random parameter array which includes U,V,W etc
C                   but also any other random parameters.
C      VIS     R(INCX,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                   NOTE: INCX may be any value .GE. 2
C   Inputs from COMMON:
C      NAME2      C*12    Name of the aux. file
C      CLAS2      C*6     Class of the aux. file.
C      SEQ2       I       Sequence number of the aux. file.
C      DISK2      I       Volumn number of the aux. file.
C      RA         D       Right ascension (1950) of phase center. (deg)
C      DEC        D       Declination (1950) of phase center. (deg)
C      FREQ       D       Frequency of observation (Hz)
C      NRPARM     I       # random parameters.
C      NCOR       I       # correlators
C      CATBLK     I(256)  Catalog header record. See Going Aips for
C                         details.
C      LRECI      I    Input file record length
C      NRPRMI     I    Input number of random parameters.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
C      LRECO      I    Output file record length
C      NRPRMO     I    Output number of random parameters.
C      INCSO      I    Output Stokes' increment in vis.
C      INCFO      I    Output frequency increment in vis.
C      INCIFO     I    Output IF increment in vis.
C   Output:
C      RPARM      R    Modified random parameter array.
C      RESULT  R(INCX,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C   Output in COMMON:
C      CATBLK    I         Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IA1, IA2, ISUB, INCX, IRET
      REAL      VIS(INCX,*), RPARM(*), RESULT(INCX,*)
C
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXO, INDEXI, I, JA1, JA2,
     *   JFQ, JSU, IFQ, ISU, JJS, JJ(4)
      INCLUDE 'MATCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA JJ /1,2,4,3/
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.GT.0) THEN
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
         IF (ILOCSU.GE.0) THEN
            ISU = RPARM(1+ILOCSU) + 0.01
            JSU = SOURCS(ISU)
            IF ((ISU.GT.0) .AND. (JSU.GT.0)) THEN
               RPARM(1+ILOCSU) = JSU
            ELSE
               WASS = WASS + 1
               END IF
            END IF
         IF (ILOCFQ.GE.0) THEN
            IFQ = RPARM(1+ILOCFQ) + 0.01
            JFQ = FQIDS(IFQ)
            IF ((IFQ.GT.0) .AND. (JFQ.GT.0)) THEN
               RPARM(1+ILOCFQ) = JFQ
            ELSE
               WASF = WASF + 1
               END IF
            END IF
         JA1 = ANTS(IA1,ISUB)
         JA2 = ANTS(IA2,ISUB)
         IF (JA1.LE.0) THEN
            JA1 = IA1
            WASA = WASA + 1
            END IF
         IF (JA2.LE.0) THEN
            JA2 = IA2
            WASA = WASA + 1
            END IF
C                                       copy data only
         IF (JA1.LE.JA2) THEN
            IF (ILOCB.GE.0) THEN
               RPARM(1+ILOCB) = 256 * JA1 + JA2 + (ISUB-1)/100.0
            ELSE
               RPARM(1+ILOCA1) = JA1
               RPARM(1+ILOCA2) = JA2
               RPARM(1+ILOCSA) = ISUB
               END IF
            DO 40 JIF = 1,NIF
               DO 30 JF = 1,NF
                  DO 20 JS = 1,NS
                     INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *                  (JS-1) * INCSI + 1
                     INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *                  (JS-1) * INCSO + 1
                     DO 10 I = 1,INCX
                        RESULT(I,INDEXO) = VIS(I,INDEXI)
 10                     CONTINUE
 20                  CONTINUE
 30               CONTINUE
 40            CONTINUE
C                                       reverse things
         ELSE
            RPARM(1+ILOCU) = -RPARM(1+ILOCU)
            RPARM(1+ILOCV) = -RPARM(1+ILOCV)
            RPARM(1+ILOCW) = -RPARM(1+ILOCW)
            IF (ILOCB.GE.0) THEN
               RPARM(1+ILOCB) = 256 * JA2 + JA1 + (ISUB-1)/100.0
            ELSE
               RPARM(1+ILOCA1) = JA2
               RPARM(1+ILOCA2) = JA1
               RPARM(1+ILOCSA) = ISUB
               END IF
            DO 80 JIF = 1,NIF
               DO 70 JF = 1,NF
                  DO 60 JS = 1,NS
                     JJS = JJ(JS)
                     INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *                  (JS-1) * INCSI + 1
                     INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *                  (JJS-1) * INCSO + 1
                     RESULT(1,INDEXO) = VIS(1,INDEXI)
                     RESULT(2,INDEXO) = -VIS(2,INDEXI)
                     RESULT(3,INDEXO) = VIS(3,INDEXI)
 60                  CONTINUE
 70               CONTINUE
 80            CONTINUE
            END IF
C                                       Last call
      ELSE
         END IF
C
 999  RETURN
      END

      FUNCTION BESSJ1 (X)
C-----------------------------------------------------------------------
C! Computes the J1 Bessel function for argumanet X
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Compute the J1 Bessel function for a given argument
C   Inputs:
C      X     R    The argument of the J1 Bessel function desired
C   Output:
C            R    Returns the resultant J1 Bessel function
C   Method
C      from "Numerical Recipes" by Press et al.
C-----------------------------------------------------------------------
      REAL      BESSJ1, X
C
      DOUBLE PRECISION P1, P2, P3, P4, P5, Q1, Q2, Q3, Q4, Q5, R1, R2,
     *   R3, R4, R5, R6, S1, S2, S3, S4, S5, S6, Y, AX, XX, Z
      SAVE P1, P2, P3, P4, P5, Q1, Q2, Q3, Q4, Q5, R1, R2, R3, R4, R5,
     *   R6, S1, S2, S3, S4, S5, S6
      DATA R1, R2, R3, R4, R5, R6 /72362614232.D0, -7895059235.D0,
     *   242396853.1D0, -2972611.439D0, 15704.48260D0, -30.16036606D0/
      DATA S1, S2, S3, S4, S5, S6 /144725228442.D0, 2300535178.D0,
     *   18583304.74D0, 99447.43394D0, 376.9991397D0, 1.D0/
      DATA P1, P2, P3, P4, P5 /1.D0, .183105D-2, -.3516396496D-4,
     *   .2457520174D-5, -.240337019D-6/
      DATA Q1, Q2, Q3, Q4, Q5 /.04687499995D0, -.2002690873D-3,
     *   .8449199096D-5, -.88228987D-6, .105787412D-6/
C-----------------------------------------------------------------------
      IF (ABS(X).LT.8.) THEN
         Y = X**2
         BESSJ1 = X*(R1+Y*(R2+Y*(R3+Y*(R4+Y*(R5+Y*R6))))) /
     *      (S1+Y*(S2+Y*(S3+Y*(S4+Y*(S5+Y*S6)))))
      ELSE
         AX = ABS (X)
         Z = 8. / AX
         Y = Z**2
         XX = AX - 2.356194491
         BESSJ1 = SIGN (1., X) * SQRT (.636619772/AX) *
     *      (COS(XX)*(P1+Y*(P2+Y*(P3+Y*(P4+Y*P5)))) -
     *       Z*SIN(XX)*(Q1+Y*(Q2+Y*(Q3+Y*(Q4+Y*Q5)))))
         END IF
C
 999  RETURN
      END

      SUBROUTINE SETSM (IRET)
C-----------------------------------------------------------------------
C! Determines type of spectral smoothing and sets up look up table.
C# UV Spectral Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2004, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SETSM determines the type of spectral smoothing to be applied and
C   sets up the look up table to do it. The actual smoothing is done in
C   routine SMOSP
C   Inputs: (via common)
C      SMOOTH   R(3)   Array containing smoothing parms
C                         SMOOTH(1) = type of function
C                               (2) = width of function in channels
C                               (3) = support of function in channels
C                       Type of function supported are:
C                          0 => no smoothing
C                          1 => hanning
C                          2 => gaussian
C                          3 => boxcar
C                          4 => sin(x)/x
C   Output:
C     IRET           I     Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   I, N, LSPECT, IROUND, IT, SUPRAD, LT
      REAL      FX, X, W, WIDTHS(4), SUPS(4)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA WIDTHS /4.0, 2.0, 2.0, 3.0/
      DATA SUPS /1.0, 3.0, 1.0, 4.0/
C-----------------------------------------------------------------------
      IRET = 0
      DOSMTH = 0
      IT = IROUND (SMOOTH(1))
      IF (IT.LE.0) GO TO 999
      IF (IT.GT.8) IT = 1
      DOSMTH = (IT + 3) / 4
      LT = MOD (IT-1, 4) + 1
C                                       Convolution: parms & tables
      SMOOTH(1) = IT
      LSPECT = MAX (12, CATUV(KINAX+JLOCF))
      IF ((SMOOTH(2).LT.0.5) .OR. (SMOOTH(2).GT.LSPECT/3.))
     *   SMOOTH(2) = WIDTHS(LT)
      IF ((SMOOTH(3).GT.4.*SUPS(LT)*SMOOTH(2)) .OR.
     *   (SMOOTH(3).LT.SMOOTH(2)))SMOOTH(3) = SUPS(LT) * SMOOTH(2)
      SUPRAD = SMOOTH(3) / 2.0 + 0.1
      IF (SUPRAD+1.GT.MAXSMO) THEN
         SUPRAD = MAXSMO - 1
         SMOOTH(2) = (2. * SUPRAD) / SUPS(LT)
         END IF
      SMOOTH(3) = 2.0 * SUPRAD + 1.0
C                                       Channel ranges for smoothing
      BCHANS = MAX (1, BCHAN - SUPRAD)
      ECHANS = MIN (CATUV(KINAX+JLOCF), ECHAN + SUPRAD)
      CALL RFILL (MAXSMO, 0.0, SMTAB)
      N = 1 + SUPRAD
      FX = 2.0 / SMOOTH(2)
      SMTAB(1) = 1.0
C                                       Compute look-up tables
      W = SMTAB(1)
C                                       Hanning smooth
      IF (LT.EQ.1) THEN
         DO 20 I = 2,N
            X = I - 1.0
            SMTAB(I) = MAX (0.0, 1.0-FX*X)
            W = W + 2 * SMTAB(I)
 20         CONTINUE
C                                       Gaussian smooth
      ELSE IF (LT.EQ.2) THEN
         FX = -LOG(2.0) * FX * FX
         DO 30 I = 2,N
            X = I - 1.0
            SMTAB(I) = EXP (FX * X * X)
            W = W + 2 * SMTAB(I)
 30         CONTINUE
C                                       Boxcar smooth
      ELSE IF (LT.EQ.3) THEN
         N = IROUND (SMOOTH(2))
         SMOOTH(2) = N
         CALL RFILL (N, 1.0, SMTAB)
         W = N
         I = (N - 1) / 2
         BCHANS = MAX (1, BCHAN-I)
         I = N - 1 - I
         ECHANS = MIN (CATUV(KINAX+JLOCF), ECHAN+I)
C                                      Sinc smooth
      ELSE IF (LT.EQ.4) THEN
         FX = 3.14159 * FX
         DO 50 I = 2,N
            X = (I - 1.0) * FX
            SMTAB(I) = SIN(X) / X
            W = W + 2 * SMTAB(I)
 50         CONTINUE
         END IF
C                                       Normalize integral
      IF (W.LE.0.0) W = 1.0
      DO 70 I = 1,N
         SMTAB(I) = SMTAB(I) / W
 70      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE QPTDIV (APCORE, C, U, VS, INCVS, INCF, INCS, NCOMP,
     *   NVIS, NF, NS)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Divide point model visibility into uv data.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2000, 2006, 2008, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Vector compiler version
C   Divides the model visibility derived from CLEAN components into
C   visibility records.  Arbitrary numbers of frequencies and
C   polarizations can be processed.  The weights of the visibilities
C   are multiplied times  the amplitude of the model visibility.
C   Inputs:
C      C     I  Base address of CLEAN components, increment = 4
C               0 = Amplitude
C               1 = -2 * PI * X
C               2 = -2 * PI * Y
C               3 = -2 * PI * Z
C      U     I  Base address of U, assumed followed by V, W
C      VS    I  Base address of vis rec. (real, imag, wt)
C      INCVS I  Increment of VS for next visibility
C      INCF  I  Increment of VS for next frequency
C      INCS  I  Increment of VS for next IF (RR of LL)
C      NCOMP I  Number of CLEAN components.
C      NVIS  I  Number of visibilities.
C      NF    I  Number of frequencies.
C      NS    I  Number of IF (usually 1 or 2)
C   Also uses AP locations 0 and 1 and expects an array
C   beginning in location 2 should be an array of length NF :
C              Freq(0) / Freq(ref) - 1.0
C              Freq(1) / Freq(ref) - 1.0
C                      .
C                      .
C                      .
C              Freq(NF-1) / Freq(ref) - 1.0
C   Note: all addresses are 0 relative and needed to be incremented by
C   1 to work in Fortran.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   C, U, VS, INCVS, INCF, INCS, NCOMP, NVIS, NF, NS
C
      INTEGER   X, JVS, IVS, IF, IV, IS, ICOMP
      LONGINT   F, IU, JX, JAMP, JA
      DOUBLE PRECISION FREQF, SUMRE, SUMIM, REMOD, IMMOD, WT, TEMP, PHS
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                        Make sure that there is data.
      IF ((NCOMP.LE.0) .OR. (NVIS.LE.0) .OR. (NF.LE.0) .OR.
     *   (NS.LE.0))  GO TO 999
C                                       Setup array addresses
      X = C + 1
      IU = U + PSAPOF
      IVS = VS
C                                        Begin visibility loop
C$OMP PARALLEL DO PRIVATE (IV, JVS, F, S, IF, SUMRE, SUMIM, JX, JAMP,
C$OMP+                     FREQF, ICOMP, PHS, REMOD, IMMOD, WT, IS,
C$OMP+                     TEMP, JA, IVS, IU), SHARE(APCORE)
      DO 300 IV = 1,NVIS
C                                        Get ready for freq. loop
         JVS = IVS
         F = 1 + PSAPOF
C                                        Begin frequency loop
         DO 200 IF = 1,NF
C                                       Loop over component
            SUMRE = 0.0D0
            SUMIM = 0.0D0
            JX = X + PSAPOF
            JAMP = C + PSAPOF
            IF (ABS (APCORE(F+1)).GT.1.0D-20) THEN
               FREQF = 1.0D0 + APCORE(F+1)
            ELSE
               FREQF = 1.0D0
            END IF
            DO 100 ICOMP = 1, NCOMP
               PHS = FREQF * (APCORE(JX) * APCORE(IU)
     *                      + APCORE(JX+1) * APCORE(IU+1)
     *                      + APCORE(JX+2) * APCORE(IU+2))
               SUMRE = SUMRE + APCORE(JAMP) * COS(PHS)
               SUMIM = SUMIM + APCORE(JAMP) * SIN(PHS)
               JX = JX + 4
               JAMP = JAMP + 4
  100          CONTINUE
C                                       Correct visibility
            JA = JVS + PSAPOF
C                                        Setup
            WT = (SUMRE * SUMRE + SUMIM * SUMIM)
            WT = MAX (1.0D-15, WT)
            REMOD = SUMRE / WT
            IMMOD = SUMIM / WT
C                                       Loop over Stokes (1 or 2,
C                                       no point in vectorizing)
            DO 150 IS = 1,NS
C                                       Divide model
               TEMP = REMOD * APCORE(JA) + IMMOD * APCORE(JA+1)
               APCORE(JA+1) = REMOD * APCORE(JA+1) - IMMOD * APCORE(JA)
               APCORE(JA) = TEMP
C                                       Modify weight by amp squared
               APCORE(JA+2) = APCORE(JA+2) * WT
               JA = JA + INCS
 150           CONTINUE
C                                        Update vis pointer
            JVS = JVS + INCF
            F = F + 1
 200        CONTINUE
C                                        Update pointers
         IVS = IVS + INCVS
         IU = IU + INCVS
 300     CONTINUE
C$OMP END PARALLEL DO
C
 999  RETURN
      END

LOCAL INCLUDE 'PRRFI.INC'
C                                       Local include for PRRFI
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ANTMAX, MXF
      PARAMETER (ANTMAX = 50)
      PARAMETER (MXF = 100)
C
      HOLLERITH XINFIL(12), XOUFIL(12)
      REAL      XANT(50), XBCNT, XECNT, APARM(10)
      REAL      PMEAN(MAXCIF,ANTMAX), PMAX(MAXCIF,ANTMAX),
     *   PMIN(MAXCIF,ANTMAX), RMEAN(MAXCIF,ANTMAX), RMAX(MAXCIF,ANTMAX),
     *   RMIN(MAXCIF,ANTMAX), MMEAN(MAXCIF,ANTMAX), MMAX(MAXCIF,ANTMAX),
     *   MMIN(MAXCIF,ANTMAX)
      LOGICAL   GOTANT(ANTMAX), WANANT(ANTMAX), NEWFMT
      INTEGER   NSAMP, NPARM, NOFILE, BCOUNT, ECOUNT, SCRBUF(256),
     *   NR(ANTMAX)
      DOUBLE PRECISION FREQS(MAXCIF,ANTMAX)
      CHARACTER INFILE(MXF)*48,
     *   OUFILE*48, ANTDAT(ANTMAX)*8, ANTNAM(ANTMAX)*8, CINFIL*48
      COMMON /INPARM/ XANT, XINFIL, XBCNT, XECNT, XOUFIL, APARM
      COMMON /PRRFIV/ FREQS, NSAMP, NPARM, GOTANT, WANANT,
     *   NOFILE, BCOUNT, ECOUNT, NR, NEWFMT
      COMMON /ANSWER/ PMEAN, PMIN, PMAX, RMEAN, RMIN, RMAX, MMEAN, MMIN,
     *   MMAX
      COMMON /CHARPM/ INFILE, ANTDAT, ANTNAM, CINFIL, OUFILE
      COMMON /BUFRS/ SCRBUF
C                                       End local include for PRRFI
LOCAL END
      PROGRAM PRRFI
C-----------------------------------------------------------------------
C! Plots statistics of selected autocorrelation data from VBRFI output
C# UV UV-util Calibration Plot Hardcopy
C-----------------------------------------------------------------------
C;  Copyright (C) 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PRRFI plots statistics from a sample of uv data
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C   full set of calibration adverbs
C      OPTYPE         OPTYPE        Type of data to process
C      SOLINT         SOLINT        Averaging time (min)
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, JA
      INCLUDE 'PRRFI.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA PRGM /'PRRFI '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL PRRFII (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       read data
      CALL PRRFIR (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Print one antenna at a time
      DO 30 JA = 1,ANTMAX
         IF ((GOTANT(JA)) .AND. (IRET.EQ.0)) THEN
            CALL PRRFIP (JA, IRET)
            END IF
 30      CONTINUE
C                                       Close down files, etc.
 990  IRET = MAX (0, IRET)
      CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE PRRFII (PRGN, JERR)
C-----------------------------------------------------------------------
C   PRRFII gets input parameters for PRRFI
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      INTEGER   IROUND, IERR, I, J, ANTENS(50)
      LOGICAL   WASNEG
      INCLUDE 'PRRFI.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
      CALL LFILL (ANTMAX, .FALSE., GOTANT)
C                                       Get input parameters.
      NPARM = 86
      CALL GTPARM (PRGN, NPARM, RQUICK, XANT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (48, 1, XINFIL, CINFIL)
      CALL H2CHR (48, 1, XOUFIL, OUFILE)
      BCOUNT = XBCNT + 0.1
      ECOUNT = XECNT + 0.1
      BCOUNT = MAX (1, BCOUNT)
      ECOUNT = MAX (ECOUNT, BCOUNT)
      XBCNT = BCOUNT
      XECNT = ECOUNT
      NOFILE = ECOUNT - BCOUNT + 1
      WASNEG = .FALSE.
      J = 0
      DO 20 I = 1,50
         ANTENS(I) = IROUND (XANT(I))
         IF (ANTENS(I).LT.0) THEN
            WASNEG = .TRUE.
            ANTENS(I) = -ANTENS(I)
            END IF
         IF (ANTENS(I).NE.0) J = J + 1
 20      CONTINUE
      CALL RFILL (44, 0.0, XANT(7))
      CALL CHR2H (6, TSKNAM, 1, XANT(5))
      CALL LFILL (ANTMAX, .TRUE., WANANT)
      IF (WASNEG) THEN
         DO 25 I = 1,50
            IF (ANTENS(I).GT.0) WANANT(ANTENS(I)) = .FALSE.
 25         CONTINUE
      ELSE IF (J.GT.0) THEN
         CALL LFILL (ANTMAX, .FALSE., WANANT)
         DO 30 I = 1,50
            IF (ANTENS(I).GT.0) WANANT(ANTENS(I)) = .TRUE.
 30         CONTINUE
         END IF
C                                       init answers
      I = ANTMAX * MAXCIF
      CALL RFILL (I, FBLANK, PMEAN)
      CALL RFILL (I, FBLANK, PMIN)
      CALL RFILL (I, FBLANK, PMAX)
      CALL RFILL (I, FBLANK, RMEAN)
      CALL RFILL (I, FBLANK, RMIN)
      CALL RFILL (I, FBLANK, RMAX)
      CALL RFILL (I, FBLANK, MMEAN)
      CALL RFILL (I, FBLANK, MMIN)
      CALL RFILL (I, FBLANK, MMAX)
      JERR = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PRRFII: ERROR',I3,' ON ',A)
      END
      SUBROUTINE PRRFIR (IRET)
C-----------------------------------------------------------------------
C   PRRFIR reads the text data and prepares a list of values by antenna
C   Output:
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'PRRFI.INC'
      INTEGER   INDEX, TXLUN, TXIND, J, IP, LANT, LCH, LIF, LP, JTRIM,
     *   IFIL
      CHARACTER INLINE*256, DATE*8, STN*8
      DOUBLE PRECISION XX
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA TXLUN /3/
C-----------------------------------------------------------------------
      CALL DFILL (MAXCIF*ANTMAX, 0.0D0, FREQS)
      CALL FILL (ANTMAX, 0, NR)
C                                       find actual values
      CALL PRRFIF (IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINDING ACTUAL INPUT FILE NAMES'
         GO TO 990
         END IF
      DO 100 IFIL = 1,NOFILE
         CALL ZTXOPN ('READ', TXLUN, TXIND, INFILE(IFIL), .TRUE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN INTPUT TEXT FILE'
            GO TO 990
            END IF
         LANT = 0
C                                       read the data
 20      CALL ZTXIO ('READ', TXLUN, TXIND, INLINE, IRET)
         IF (IRET.EQ.2) THEN
            IRET = 0
            GO TO 90
         ELSE IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING TEXT FILE'
            GO TO 990
         ELSE IF ((INLINE(:11).EQ.'*** DATEOBS') .OR.
     *      (INLINE(:12).EQ.'**** DATEOBS')) THEN
            NEWFMT = INLINE(4:4).EQ.'*'
            IP = INDEX (INLINE, '''')
            DATE = INLINE(IP+1:IP+8)
            IP = INDEX (INLINE, 'ANTENNA=')
            LP = IP+8
            CALL GETNUM (INLINE, 256, LP, XX)
            LANT = XX + 0.1
            IF ((LANT.LT.1) .OR.(LANT.GT.ANTMAX)) THEN
               WRITE (MSGTXT,1020) LANT, ANTMAX
               CALL MSGWRT (7)
               LANT = 0
               GO TO 20
               END IF
            IF (.NOT.WANANT(LANT)) THEN
               LANT = 0
               GO TO 20
               END IF
            IP = INDEX (INLINE, 'STATION')
            IP = IP + 7
            LP = INDEX (INLINE(IP:), '''')
            LP = LP + IP
            IP = INDEX (INLINE(LP:), '''')
            STN = INLINE(LP:LP+IP)
            LP = JTRIM(STN)
            IF (STN(LP:LP).EQ.'''') STN(LP:) = ' '
            ANTDAT(LANT) = DATE
            ANTNAM(LANT) = STN
C                                       data row
         ELSE IF ((INLINE(:1).EQ.' ') .AND. (LANT.GT.0)) THEN
            LP = 1
            CALL GETNUM (INLINE, 256, LP, XX)
            IF (XX.EQ.DBLANK) GO TO 20
            LIF = XX + 0.1
            CALL GETNUM (INLINE, 256, LP, XX)
            IF (XX.EQ.DBLANK) GO TO 20
            LCH = XX + 0.1
            CALL GETNUM (INLINE, 256, LP, XX)
            IF (XX.EQ.DBLANK) GO TO 20
            GOTANT(LANT) = .TRUE.
            NR(LANT) = NR(LANT) + 1
            J = NR(LANT)
            FREQS(J,LANT) = XX
            CALL GETNUM (INLINE, 256, LP, XX)
            IF (XX.EQ.DBLANK) THEN
               PMEAN(J,LANT) = FBLANK
            ELSE
               PMEAN(J,LANT) = XX
               END IF
            CALL GETNUM (INLINE, 256, LP, XX)
            IF (XX.EQ.DBLANK) THEN
               PMIN(J,LANT) = FBLANK
            ELSE
               PMIN(J,LANT) = XX
               END IF
            CALL GETNUM (INLINE, 256, LP, XX)
            IF (XX.EQ.DBLANK) THEN
               PMAX(J,LANT) = FBLANK
            ELSE
               PMAX(J,LANT) = XX
               END IF
            IF (NEWFMT) THEN
               CALL GETNUM (INLINE, 256, LP, XX)
               IF (XX.EQ.DBLANK) THEN
                  RMEAN(J,LANT) = FBLANK
               ELSE
                  RMEAN(J,LANT) = XX
                  END IF
               CALL GETNUM (INLINE, 256, LP, XX)
               IF (XX.EQ.DBLANK) THEN
                  RMIN(J,LANT) = FBLANK
               ELSE
                  RMIN(J,LANT) = XX
                  END IF
               CALL GETNUM (INLINE, 256, LP, XX)
               IF (XX.EQ.DBLANK) THEN
                  RMAX(J,LANT) = FBLANK
               ELSE
                  RMAX(J,LANT) = XX
                  END IF
               END IF
            CALL GETNUM (INLINE, 256, LP, XX)
            IF (XX.EQ.DBLANK) THEN
               MMEAN(J,LANT) = FBLANK
            ELSE
               MMEAN(J,LANT) = XX / 1.D3
               END IF
            CALL GETNUM (INLINE, 256, LP, XX)
            IF (XX.EQ.DBLANK) THEN
               MMIN(J,LANT) = FBLANK
            ELSE
               MMIN(J,LANT) = XX / 1.D3
               END IF
            CALL GETNUM (INLINE, 256, LP, XX)
            IF (XX.EQ.DBLANK) THEN
               MMAX(J,LANT) = FBLANK
            ELSE
               MMAX(J,LANT) = XX / 1.D3
               END IF
            END IF
         GO TO 20
C                                       close
 90      CALL ZTXCLS (TXLUN, TXIND, J)
 100     CONTINUE
C                                       no straight rms
      IF (.NOT.NEWFMT) THEN
         APARM(3) = 0.0
         APARM(4) = 0.0
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PRRFIR: ERROR',I3,' ON ',A)
 1020 FORMAT ('PRRFIR: ANTENNA',I4,' OUTSIDE RANGE 1 -',I4)
      END
      SUBROUTINE PRRFIF (IRET)
C-----------------------------------------------------------------------
C   Finds actual file names
C   Output:
C      IRET    I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'PRRFI.INC'
      INTEGER   JTRIM, IFIL, TXLUN, TXIND, I, NC, MSGSAV
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA TXLUN /3/
C-----------------------------------------------------------------------
C                                       Prepare file names
      NC = JTRIM (CINFIL)
      INFILE(1) = CINFIL
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL ZTXOPN ('QRED', TXLUN, TXIND, INFILE(1), .TRUE., IRET)
      MSGSUP = MSGSAV
      IF (IRET.NE.0) THEN
         IFIL = BCOUNT
         IF (IFIL.LT.10) THEN
            WRITE (INFILE(1),1010) CINFIL(:NC), IFIL
         ELSE
            WRITE (INFILE(1),1011) CINFIL(:NC), IFIL
            END IF
         CALL ZTXOPN ('QRED', TXLUN, TXIND, INFILE(1), .TRUE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN INPUT TEXT FILE', BCOUNT
            GO TO 990
            END IF
         END IF
      CALL ZTXCLS (TXLUN, TXIND, IRET)
      DO 10 I = 2,NOFILE
         IFIL = I + BCOUNT - 1
         IF (IFIL.LT.10) THEN
            WRITE (INFILE(I),1010) CINFIL(:NC), IFIL
         ELSE
            WRITE (INFILE(I),1011) CINFIL(:NC), IFIL
            END IF
 10      CONTINUE
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PRRFIF: ERROR',I4,' ON ',A,' FILE',I2)
 1010 FORMAT (A,I1)
 1011 FORMAT (A,I2)
      END
      SUBROUTINE PRRFIP (LANT, IRET)
C-----------------------------------------------------------------------
C   Print over cutoffs
C   Input:
C      LANT   I   Desired antenna
C   Output
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   LANT, IRET
C
      INCLUDE 'PRRFI.INC'
      INTEGER   JTRIM, JT, J, I, TXLUN, TXIND, NP
      CHARACTER PRFILE*48, OUTLIN*256
      LOGICAL   FIRST
      REAL      CUT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA TXLUN /3/
C-----------------------------------------------------------------------
      JT = JTRIM (OUFILE)
      IF (OUFILE(JT:JT).NE.':') THEN
         JT = JT + 1
         OUFILE(JT:) = ':'
         END IF
      PRFILE = OUFILE(:JT) // ANTNAM(LANT)(:2) // ANTDAT(LANT) // '.txt'
      CALL ZTXOPN ('WRIT', TXLUN, TXIND, PRFILE, .TRUE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATE OUTPUT TEXT FILE', LANT
         GO TO 990
         END IF
C                                       Pmean autocorrelation values
      CUT = APARM(1)
      IF (CUT.GT.0.0) THEN
         NP = 0
         FIRST = .TRUE.
         DO 20 I = 1,NR(LANT)
            IF ((PMEAN(I,LANT).NE.FBLANK) .AND.
     *         ((PMEAN(I,LANT).GT.CUT) .OR. (PMEAN(I,LANT).LT.0.0)))
     *         THEN
               IF (FIRST) THEN
                  WRITE (OUTLIN,1010) ANTNAM(LANT)(:2), ANTDAT(LANT),
     *               'Pmean', CUT
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT FILE',
     *                  LANT
                     GO TO 990
                     END IF
                  FIRST = .FALSE.
                  IF (NEWFMT) THEN
                     WRITE (OUTLIN,1015)
                  ELSE
                     WRITE (OUTLIN,1011)
                     END IF
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET,
     *                  'WRITE OUTPUT TEXT FILE', LANT
                     GO TO 990
                     END IF
                  IF (NEWFMT) THEN
                     WRITE (OUTLIN,1016)
                  ELSE
                     WRITE (OUTLIN,1012)
                     END IF
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET,
     *                  'WRITE OUTPUT TEXT FILE', LANT
                     GO TO 990
                     END IF
                  END IF
               IF (NEWFMT) THEN
                  WRITE (OUTLIN,1021) FREQS(I,LANT), PMEAN(I,LANT),
     *               PMIN(I,LANT), PMAX(I,LANT), RMEAN(I,LANT),
     *               RMIN(I,LANT), RMAX(I,LANT), MMEAN(I,LANT)*1000.,
     *               MMIN(I,LANT)*1000., MMAX(I,LANT)*1000.
               ELSE
                  WRITE (OUTLIN,1020) FREQS(I,LANT), PMEAN(I,LANT),
     *               PMIN(I,LANT), PMAX(I,LANT), MMEAN(I,LANT)*1000.,
     *               MMIN(I,LANT)*1000., MMAX(I,LANT)*1000.
                  END IF
               JT = JTRIM (OUTLIN)
               CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:JT), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT FILE',
     *               LANT
                  GO TO 990
                  END IF
               NP = NP + 1
               END IF
 20         CONTINUE
         WRITE (MSGTXT,1025) 'Autocorrelation Pmean', CUT, NP
         CALL MSGWRT (3)
         END IF
C                                       Pmax autocorrelation values
      CUT = APARM(2)
      IF (CUT.GT.0.0) THEN
         NP = 0
         FIRST = .TRUE.
         DO 30 I = 1,NR(LANT)
            IF ((PMEAN(I,LANT).NE.FBLANK) .AND.
     *         ((PMAX(I,LANT).GT.CUT) .OR. (PMAX(I,LANT).LT.0.0)))
     *         THEN
               IF (FIRST) THEN
                  WRITE (OUTLIN,1010) ANTNAM(LANT)(:2), ANTDAT(LANT),
     *               'Pmax', CUT
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT FILE',
     *                  LANT
                     GO TO 990
                     END IF
                  FIRST = .FALSE.
                  IF (NEWFMT) THEN
                     WRITE (OUTLIN,1015)
                  ELSE
                     WRITE (OUTLIN,1011)
                     END IF
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET,
     *                  'WRITE OUTPUT TEXT FILE', LANT
                     GO TO 990
                     END IF
                  IF (NEWFMT) THEN
                     WRITE (OUTLIN,1016)
                  ELSE
                     WRITE (OUTLIN,1012)
                     END IF
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET,
     *                  'WRITE OUTPUT TEXT FILE', LANT
                     GO TO 990
                     END IF
                  END IF
               IF (NEWFMT) THEN
                  WRITE (OUTLIN,1021) FREQS(I,LANT), PMEAN(I,LANT),
     *               PMIN(I,LANT), PMAX(I,LANT), RMEAN(I,LANT),
     *               RMIN(I,LANT), RMAX(I,LANT), MMEAN(I,LANT)*1000.,
     *               MMIN(I,LANT)*1000., MMAX(I,LANT)*1000.
               ELSE
                  WRITE (OUTLIN,1020) FREQS(I,LANT), PMEAN(I,LANT),
     *               PMIN(I,LANT), PMAX(I,LANT), MMEAN(I,LANT)*1000.,
     *               MMIN(I,LANT)*1000., MMAX(I,LANT)*1000.
                  END IF
               JT = JTRIM (OUTLIN)
               CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:JT), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT FILE',
     *               LANT
                  GO TO 990
                  END IF
               NP = NP + 1
               END IF
 30         CONTINUE
         WRITE (MSGTXT,1025) 'Autocorrelation Pmax ', CUT, NP
         CALL MSGWRT (3)
         END IF
C                                       Rmean autocorrelation values
      CUT = APARM(3)
      IF (CUT.GT.0.0) THEN
         NP = 0
         FIRST = .TRUE.
         DO 40 I = 1,NR(LANT)
            IF ((PMEAN(I,LANT).NE.FBLANK) .AND.
     *         ((rMEAN(I,LANT).GT.CUT) .OR. (rMEAN(I,LANT).LT.0.0)))
     *         THEN
               IF (FIRST) THEN
                  WRITE (OUTLIN,1010) ANTNAM(LANT)(:2), ANTDAT(LANT),
     *               'Rmean', CUT
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT FILE',
     *                  LANT
                     GO TO 990
                     END IF
                  FIRST = .FALSE.
                  IF (NEWFMT) THEN
                     WRITE (OUTLIN,1015)
                  ELSE
                     WRITE (OUTLIN,1011)
                     END IF
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET,
     *                  'WRITE OUTPUT TEXT FILE', LANT
                     GO TO 990
                     END IF
                  IF (NEWFMT) THEN
                     WRITE (OUTLIN,1016)
                  ELSE
                     WRITE (OUTLIN,1012)
                     END IF
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET,
     *                  'WRITE OUTPUT TEXT FILE', LANT
                     GO TO 990
                     END IF
                  END IF
               IF (NEWFMT) THEN
                  WRITE (OUTLIN,1021) FREQS(I,LANT), PMEAN(I,LANT),
     *               PMIN(I,LANT), PMAX(I,LANT), RMEAN(I,LANT),
     *               RMIN(I,LANT), RMAX(I,LANT), MMEAN(I,LANT)*1000.,
     *               MMIN(I,LANT)*1000., MMAX(I,LANT)*1000.
               ELSE
                  WRITE (OUTLIN,1020) FREQS(I,LANT), PMEAN(I,LANT),
     *               PMIN(I,LANT), PMAX(I,LANT), MMEAN(I,LANT)*1000.,
     *               MMIN(I,LANT)*1000., MMAX(I,LANT)*1000.
                  END IF
               JT = JTRIM (OUTLIN)
               CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:JT), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT FILE',
     *               LANT
                  GO TO 990
                  END IF
               NP = NP + 1
               END IF
 40         CONTINUE
         WRITE (MSGTXT,1025) 'Autocorrelation Rmean', CUT, NP
         CALL MSGWRT (3)
         END IF
C                                       Rmax autocorrelation values
      CUT = APARM(4)
      IF (CUT.GT.0.0) THEN
         NP = 0
         FIRST = .TRUE.
         DO 50 I = 1,NR(LANT)
            IF ((PMEAN(I,LANT).NE.FBLANK) .AND.
     *         ((RMAX(I,LANT).GT.CUT) .OR. (RMAX(I,LANT).LT.0.0)))
     *         THEN
               IF (FIRST) THEN
                  WRITE (OUTLIN,1010) ANTNAM(LANT)(:2), ANTDAT(LANT),
     *               'Pmean', CUT
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT FILE',
     *                  LANT
                     GO TO 990
                     END IF
                  FIRST = .FALSE.
                  IF (NEWFMT) THEN
                     WRITE (OUTLIN,1015)
                  ELSE
                     WRITE (OUTLIN,1011)
                     END IF
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET,
     *                  'WRITE OUTPUT TEXT FILE', LANT
                     GO TO 990
                     END IF
                  IF (NEWFMT) THEN
                     WRITE (OUTLIN,1016)
                  ELSE
                     WRITE (OUTLIN,1012)
                     END IF
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET,
     *                  'WRITE OUTPUT TEXT FILE', LANT
                     GO TO 990
                     END IF
                  END IF
               IF (NEWFMT) THEN
                  WRITE (OUTLIN,1021) FREQS(I,LANT), PMEAN(I,LANT),
     *               PMIN(I,LANT), PMAX(I,LANT), RMEAN(I,LANT),
     *               RMIN(I,LANT), RMAX(I,LANT), MMEAN(I,LANT)*1000.,
     *               MMIN(I,LANT)*1000., MMAX(I,LANT)*1000.
               ELSE
                  WRITE (OUTLIN,1020) FREQS(I,LANT), PMEAN(I,LANT),
     *               PMIN(I,LANT), PMAX(I,LANT), MMEAN(I,LANT)*1000.,
     *               MMIN(I,LANT)*1000., MMAX(I,LANT)*1000.
                  END IF
               JT = JTRIM (OUTLIN)
               CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:JT), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT FILE',
     *               LANT
                  GO TO 990
                  END IF
               NP = NP + 1
               END IF
 50         CONTINUE
         WRITE (MSGTXT,1025) 'Autocorrelation Rmax', CUT, NP
         CALL MSGWRT (3)
         END IF
C                                       Mmean autocorrelation values
      CUT = APARM(5)
      IF (CUT.GT.0.0) THEN
         NP = 0
         FIRST = .TRUE.
         DO 60 I = 1,NR(LANT)
            IF ((PMEAN(I,LANT).NE.FBLANK) .AND.
     *         ((MMEAN(I,LANT).GT.CUT) .OR. (MMEAN(I,LANT).LT.0.0)))
     *         THEN
               IF (FIRST) THEN
                  WRITE (OUTLIN,1010) ANTNAM(LANT)(:2), ANTDAT(LANT),
     *               'Mmean', CUT
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT FILE',
     *                  LANT
                     GO TO 990
                     END IF
                  FIRST = .FALSE.
                  IF (NEWFMT) THEN
                     WRITE (OUTLIN,1015)
                  ELSE
                     WRITE (OUTLIN,1011)
                     END IF
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET,
     *                  'WRITE OUTPUT TEXT FILE', LANT
                     GO TO 990
                     END IF
                  IF (NEWFMT) THEN
                     WRITE (OUTLIN,1016)
                  ELSE
                     WRITE (OUTLIN,1012)
                     END IF
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET,
     *                  'WRITE OUTPUT TEXT FILE', LANT
                     GO TO 990
                     END IF
                  END IF
               IF (NEWFMT) THEN
                  WRITE (OUTLIN,1021) FREQS(I,LANT), PMEAN(I,LANT),
     *               PMIN(I,LANT), PMAX(I,LANT), RMEAN(I,LANT),
     *               RMIN(I,LANT), RMAX(I,LANT), MMEAN(I,LANT)*1000.,
     *               MMIN(I,LANT)*1000., MMAX(I,LANT)*1000.
               ELSE
                  WRITE (OUTLIN,1020) FREQS(I,LANT), PMEAN(I,LANT),
     *               PMIN(I,LANT), PMAX(I,LANT), MMEAN(I,LANT)*1000.,
     *               MMIN(I,LANT)*1000., MMAX(I,LANT)*1000.
                  END IF
               JT = JTRIM (OUTLIN)
               CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:JT), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT FILE',
     *               LANT
                  GO TO 990
                  END IF
               NP = NP + 1
               END IF
 60         CONTINUE
         WRITE (MSGTXT,1025) 'Autocorrelation Mmean', CUT, NP
         CALL MSGWRT (3)
         END IF
C                                       Pmean autocorrelation values
      CUT = APARM(6)
      IF (CUT.GT.0.0) THEN
         NP = 0
         FIRST = .TRUE.
         DO 70 I = 1,NR(LANT)
            IF ((PMEAN(I,LANT).NE.FBLANK) .AND.
     *         ((MMAX(I,LANT).GT.CUT) .OR. (MMAX(I,LANT).LT.0.0)))
     *         THEN
               IF (FIRST) THEN
                  WRITE (OUTLIN,1010) ANTNAM(LANT)(:2), ANTDAT(LANT),
     *               'Mmax', CUT
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT FILE',
     *                  LANT
                     GO TO 990
                     END IF
                  FIRST = .FALSE.
                  IF (NEWFMT) THEN
                     WRITE (OUTLIN,1015)
                  ELSE
                     WRITE (OUTLIN,1011)
                     END IF
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET,
     *                  'WRITE OUTPUT TEXT FILE', LANT
                     GO TO 990
                     END IF
                  IF (NEWFMT) THEN
                     WRITE (OUTLIN,1016)
                  ELSE
                     WRITE (OUTLIN,1012)
                     END IF
                  J = JTRIM(OUTLIN)
                  CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET,
     *                  'WRITE OUTPUT TEXT FILE', LANT
                     GO TO 990
                     END IF
                  END IF
               IF (NEWFMT) THEN
                  WRITE (OUTLIN,1021) FREQS(I,LANT), PMEAN(I,LANT),
     *               PMIN(I,LANT), PMAX(I,LANT), RMEAN(I,LANT),
     *               RMIN(I,LANT), RMAX(I,LANT), MMEAN(I,LANT)*1000.,
     *               MMIN(I,LANT)*1000., MMAX(I,LANT)*1000.
               ELSE
                  WRITE (OUTLIN,1020) FREQS(I,LANT), PMEAN(I,LANT),
     *               PMIN(I,LANT), PMAX(I,LANT), MMEAN(I,LANT)*1000.,
     *               MMIN(I,LANT)*1000., MMAX(I,LANT)*1000.
                  END IF
               JT = JTRIM (OUTLIN)
               CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:JT), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT FILE',
     *               LANT
                  GO TO 990
                  END IF
               NP = NP + 1
               END IF
 70         CONTINUE
         WRITE (MSGTXT,1025) 'Autocorrelation Mmax', CUT, NP
         CALL MSGWRT (3)
         END IF
C
      CALL ZTXCLS (TXLUN, TXIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OUTPUT TEXT FILE', LANT
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PRRFI ERROR',I4,' ON ',A,'  ANTENNA',I3)
 1010 FORMAT ('STATION = ''',A,'''   DATEOBS=',A,
     *      '  AUTOCORR ',A,'  CUTOFF=',F7.2)
 1011 FORMAT (3X,'FREQ',7X,'Pmean',4X,'Pmin',4X,'Pmax',3X,'Mmean',4X,
     *   'Mmin',5X,'Mmax')
 1012 FORMAT (4X,'GHz',28X,2(3X,'milli'),4X,'milli')
 1015 FORMAT (3X,'FREQ',7X,'Pmean',4X,'Pmin',4X,'Pmax',4X,'Rmean',4X,
     *   'Rmin',4X,'Rmax',3X,'Mmean',4X,'Mmin',5X,'Mmax')
 1016 FORMAT (4X,'GHz',52X,2(3X,'milli'),4X,'milli')
 1020 FORMAT (F11.5,3F8.3,2F8.2,F9.2)
 1021 FORMAT (F11.5,6F8.3,2F8.2,F9.2)
 1025 FORMAT (A,' cutoff',F8.3,' printed',I7,' lines')
      END

LOCAL INCLUDE 'PCLOD.INC'
C                                                          Include PCLOD
C                                       Local include for PCLOD
C                                       Requires PUVD.INC
      INTEGER   MXFQID, MAXNX
C                                       Max. # of FQ-IDs allowed
      PARAMETER (MXFQID = 28)
C                                       Max. # of NX entries allowed
      PARAMETER (MAXNX = 1024)
C                                       Inputs and general info
      INTEGER   SEQIN, DISKIN, ISUBA, LUNK, FINDK, OLDCNO, DROPED, ADDED
      LOGICAL   DOCONC
      REAL      XSIN, XDISIN, XSUBA, XFQTOL, XPCVER, DOKEEP, FQTOL,
     *   BADD(10)
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAME2(12)
      CHARACTER NAMEIN*12, CLAIN*6, NAME2*48
C                                       Buffers and file info
      INTEGER   DISKSC, CNOSC, LUNSC, INDSC, IBPSC, SCBUFF(256),
     *   SXBUFF(512), PCVER, JTABUF(512), PCTOT
      DOUBLE PRECISION DUMMY(2000000)
C                                       Inputs and general info
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAME2, XSUBA,
     *   XFQTOL, XPCVER, DOKEEP, BADD
      COMMON /TASKPM/ FQTOL, SEQIN, DISKIN, ISUBA, LUNK, FINDK, OLDCNO,
     *   PCTOT, DROPED, ADDED, DOCONC
C                                       CHARACTER info
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAME2
C                                       Buffers and file info
      COMMON /SCFILE/ DUMMY, SCBUFF, SXBUFF, DISKSC, CNOSC,
     *   LUNSC, INDSC, IBPSC, PCVER, JTABUF
C                                       NX, FQ table information
      DOUBLE PRECISION DFRQTB(MXFQID,MAXIF,2)
      REAL      TIMENX(2,MAXNX)
      INTEGER   INXSOU(MAXNX), INXFQ(MAXNX), IFQUV(MXFQID), NXDAT,
     *   NFQUV, NIFFQ
      LOGICAL   NEWFMT
      COMMON /NXFQIN/ DFRQTB, TIMENX, INXSOU, INXFQ, IFQUV, NFQUV,
     *   NXDAT, NIFFQ, NEWFMT
C                                                          End PCLOD
LOCAL END
      PROGRAM PCLOD
C-----------------------------------------------------------------------
C! Read in VLBA pulse-cal data from ascii file.
C# UV Calibration EXT-util VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1999, 2007, 2011-2012, 2015-2018, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task PCLOD reads an ascii file containing the pulse-cal, cable cal
C   and state count information generated by the VLBA monitoring system.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input UV data.
C      INFILE         INFIL         Name of aux. file.
C      SUBARRAY       ISUBA         Subarray number
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PCLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'PCLOD '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL PCRIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Read pulse-cal ascii file
      IF (NEWFMT) THEN
         CALL NEWFPC (IRET)
      ELSE
         CALL READPC (IRET)
         END IF
      IF (IRET.NE.0) GO TO 990
C                                       Copy and update HI file.
      CALL PCRHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCBUFF)
 999  STOP
      END
      SUBROUTINE PCRIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   PCRIN gets input parameters for PCLOD.
C   Inputs:  PRGN    C*6       Program name
C   Output:  JERR    I         Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   JERR
C
      CHARACTER STAT*4, ANTNAM(10)*2, UTYPE*2, LINE*80
      LOGICAL   T, F
      INTEGER   NPARM, IERR, LC, JTRIM, IROUND, I
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PCLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA ANTNAM /'BR','FD','HN','KP','LA','MK','NL','OV','PT','SC'/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      LUNK = 10
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 33
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCBUFF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
            END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCBUFF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
C                                       Convert characters
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (48, 1, XNAME2, NAME2)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      ISUBA = IROUND (XSUBA)
      ISUBA = MAX (ISUBA, 1)
      DROPED = 0
      ADDED = 0
C                                       Frequency tolerance in
C                                       IF match (kHz)
      FQTOL = MAX (0.0, XFQTOL) * 1000.0
C                                       Find file, read CATBLK
      OLDCNO = 1
      STAT = 'SRCH'
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, SCBUFF, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'WRIT', SCBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'COPYING CATBLK'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Open text file
      LC = JTRIM (NAME2)
      IF (NAME2(LC:LC).NE.'_') THEN
         CALL ZTXOPN ('QRED', LUNK, FINDK, NAME2, F, IERR)
      ELSE
         DO 40 I = 1,10
            NAME2(LC+1:) = ANTNAM(I)
            MSGSUP = 32000
            CALL ZTXOPN ('QRED', LUNK, FINDK, NAME2, F, IERR)
            MSGSUP = 0
            IF (IERR.EQ.0) GO TO 50
 40         CONTINUE
         END IF
 50   IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING TEXT FILE'
         JERR = IERR
         GO TO 990
         END IF

C                                       read first line
      CALL ZTXIO ('READ', LUNK, FINDK, LINE, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READ FIRST TEXT LINE'
         JERR = IERR
         GO TO 990
         END IF
      NEWFMT = LINE.EQ.'# DiFX-derived pulse cal data'
      CALL ZTXCLS (LUNK, FINDK, IERR)
      IF (.NOT.NEWFMT) THEN
         CALL ZTXOPN ('READ', LUNK, FINDK, NAME2, F, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'RE-OPENING TEXT FILE'
            JERR = IERR
            GO TO 990
            END IF
         END IF
      IF (NAME2(LC:LC).EQ.'_') NAME2(LC+1:) = '  '
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PCRIN: ERROR',I3,1X,A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
      END
      SUBROUTINE READPC (IERR)
C-----------------------------------------------------------------------
C   READPC reads the external text file containing the pulse cal and
C   associated information.
C   Output:
C      IERR       I    Error code, 0=OK, else failed.
C-----------------------------------------------------------------------
      INTEGER   IERR, IROUND
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INTEGER NPRM, MAXPCT
      PARAMETER (NPRM = 33, MAXPCT = 100)
C
      CHARACTER PARS(NPRM)*8, ENDMRK*8, VALCH(NPRM)*8, STAT*8,
     *   CHVAL(2000000)*8, CDUMMY(2000000)*8, CTEMP*2,
     *   OSTAT*8, OBSDAT*8, KEYS(2)*24
      INTEGER   KMODE, NPARS, NDUM, IVERS, IDUM, IPOL, TNUM, I,
     *   ITYP, ISTN, MAXT, KKEY(2,2), JSTN, SUBA, NVALS, IJUNK, NSTAT,
     *   NBITS, TBANDN, POLNO, NVARS, FQID, LUNFQ, BANDNO, KEYSUB(2,2),
     *   TONEN, IDAY, IMON, IYEAR, DAYN, MKEY, KOLS(2), NPC, TPC, NCHAN,
     *   TRSIDE(MAXIF), TRPOL(MAXPCT), IFMAP(MAXPCT), ISTAT(MAXPCT),
     *   IFCHAN(MAXPCT), IFTONE(MAXPCT), NPCAL(MAXIF), IDDAT(3)
      REAL      FKEY(2,2), BANDBW(MAXIF), AMP, PHS, RTIME
      DOUBLE PRECISION VALS(NPRM), DEFS(NPRM), FTONE(MAXPCT), OTIME,
     *   TTIME, BANDLO(MAXIF), DDTT, EPS
      LOGICAL FIRST, STATMS, ACCEPT
C
      INCLUDE 'INCS:PPCV.INC'
C
      INTEGER   IPCRNO, NOPOLZ, NTONES
      INTEGER   NOSTA, IARRAY, IFQID, ISRC
      REAL      TINT, PCREL(2, MAXTON, MAXIF),
     *   PCIMG(2,  MAXTON,MAXIF), PCRAT(2, MAXTON, MAXIF),
     *   STATE(2, 4, MAXIF)
      DOUBLE PRECISION TIME, CABLCL, PCFRQ(2, MAXTON, MAXIF)
      INTEGER   PCKOLS(MAXPCC), PCNUMV(MAXPCC)
C                                       SKIP - skip next pulse cal grp
      LOGICAL   SKIP
C
      INCLUDE 'PCLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DGLB.INC'
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
      DATA KEYS /'TIME', 'ANTENNA_NO ' /
      DATA PARS /'FREQUENC', 'PULSE-CA', 30*'********',
     *   'NTONES  ' /
      DATA ENDMRK /'/       '/
      DATA DEFS/33*-1.0D0/
      DATA NDUM /2000000/
C-----------------------------------------------------------------------
      EPS = 1.0E-10
      NPC = 0
      TPC = 0
      SKIP = .FALSE.
      NPARS = NPRM
      FIRST = .TRUE.
      DOCONC = .FALSE.
      MAXT = -1
      OSTAT = ' '
      CALL H2CHR (8, 1, CATH(KHDOB), OBSDAT)
C
      CALL DATEST (OBSDAT, IDDAT)
      IYEAR = IDDAT(1)
      IMON = IDDAT(2)
      IDAY = IDDAT(3)
      CALL DAYNUM (IYEAR, IDAY, IMON, DAYN)
C                                       Read NX table information
      LUNFQ = 40
      CALL NXREAD (DISKIN, OLDCNO, ISUBA, CATBLK, LUNFQ, JTABUF,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Read FQ table information
      CALL FQREAD (DISKIN, OLDCNO, CATBLK, JTABUF, LUNFQ,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Prepare to read KEYIN file.
C                                       Get list of station names
      SUBA = ISUBA
      CALL GETANT (DISKIN, OLDCNO, SUBA, CATBLK, SCBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         GO TO 990
         END IF
C                                       Load station names in STNNAM
C                                       from AN file into KEYIN parms
C                                       array PARS.
      DO 50 I = 1,NSTNS
         PARS(2+I) = STNNAM(I)
 50      CONTINUE
C
C                                      Read a complete text entry up to
C                                      the endmark '/'. Load defaults
C                                      into the KEYIN output buffer
C                                      first.
      ITYP = -1
 100  KMODE = 0
      DO 140 I = 1,NPARS
         VALS(I) = DEFS(I)
         VALCH(I) = '        '
 140     CONTINUE
      CALL KEYIN (PARS, VALS, VALCH, NPARS, ENDMRK, KMODE, LUNK, FINDK,
     *   IERR)
      IF (IERR.NE.0) THEN
C                                      Returns IERR=1 on EOF.
         IF (IERR.EQ.1) GO TO 700
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C
C                                      Which station name has KEYIN
C                                      just read ?
      DO 180 I = 1,NSTNS
         ISTN = TELNO(I)
         JSTN = TELNO(I)
         IF (VALS(I+2).NE.-1.0D0) THEN
            STAT = PARS(I+2)
            GO TO 190
            END IF
 180     CONTINUE
 190  STATMS = STAT.NE.OSTAT
      WRITE (MSGTXT,2000) STAT
      IF (STATMS) THEN
         CALL MSGWRT (3)
         NPC = 0
         END IF
      OSTAT = STAT
C                                      Which type of group has just been
C                                      read ?
      DO 160 I = 1,2
         ITYP  = I
         IF (VALS(I).NE.-1.D0) GO TO 170
 160     CONTINUE
C                                       If reading first frequency group
C                                       then set up the PC table
 170  IF ((ITYP.EQ.1) .AND. FIRST) THEN
         NTONES = -1
         CALL H2CHR (8, 1, CATH(KHOBS), OBSCOD)
         NOSTKD = CATBLK(KINAX+JLOCS)
         STK1 = CATD(KDCRV+JLOCS)
         NOBAND = CATBLK(KINAX+JLOCIF)
         NOCHAN = CATBLK(KINAX+JLOCF)
         REFFRQ = CATD(KDCRV+JLOCF)
         CHNBW = CATR(KRCIC+JLOCF)
         REFPIX = CATR(KRCRP+JLOCF)
         TABREV = 1
         IF (NOSTKD.EQ.4) NOPOLZ = 2
         IF (NOSTKD.EQ.2) NOPOLZ = 2
         IF (NOSTKD.LT.2) NOPOLZ = 1
         END IF
C                                       If reading FREQUENCY group then
C                                       load up the ftones array.
      IF (ITYP.EQ.1) THEN
C                                       Initialize
         ACCEPT = .TRUE.
         CALL FILL (MAXPCT, 0, TRPOL)
         CALL FILL (MAXPCT, 0, IFCHAN)
         CALL FILL (MAXPCT, 0, IFTONE)
         CALL FILL (MAXPCT, 0, ISTAT)
         CALL FILL (MAXIF, 0, NPCAL)
         CALL FILL (MAXIF, 0, TRSIDE)
         CALL RFILL (MAXIF, -1.0, BANDBW)
         CALL DFILL (MAXIF, -1.D0, BANDLO)
         CALL DFILL (MAXPCT, -1.D0, FTONE)
         OTIME = -1.D0
C
         KMODE = 3
         NVALS = NDUM
         CALL KEYIN (CDUMMY, DUMMY, CHVAL, NVALS, ENDMRK, KMODE, LUNK,
     *      FINDK, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1030) IERR
            GO TO 990
            END IF
C                                       Extract information required
C                                       to match the FQ-ID and IF nos.
         NCHAN = 0
         DO 182 IDUM = 1,NVALS,8
C                                       Tone number
            READ (CHVAL(IDUM),2010) CTEMP, TNUM
C                                       Channel number
            TBANDN = DUMMY(IDUM+1)
            NCHAN = MAX (NCHAN, TBANDN)
C                                       Polarization
            IPOL = 0
            IF (CHVAL(IDUM+3)(1:3).EQ.'RCP') IPOL = 1
            IF (CHVAL(IDUM+3)(1:3).EQ.'LCP') IPOL = 2
C                                       Sideband
            TRSIDE(TBANDN) = 0
            IF (CHVAL(IDUM+2)(1:1).EQ.'U') TRSIDE(TBANDN) = 1
            IF (CHVAL(IDUM+2)(1:1).EQ.'L') TRSIDE(TBANDN) = -1
C                                       Missing polzn. or sideband ?
            IF ((IPOL.EQ.0) .OR. (TRSIDE(TBANDN).EQ.0)) THEN
               MSGTXT = 'ILLEGAL ENTRY IN FREQUENCY GROUP'
               IERR = 2
               GO TO 990
               END IF
C                                       Otherwise valid ?
            IF ((NOPOLZ.EQ.1) .AND. (ABS(STK1).NE.IPOL)) THEN
               IERR = 3
               MSGTXT = 'INVALID POLARIZATION IN FREQUENCY GROUP'
               GO TO 990
               END IF
C                                       Check for case of LL only
            IF ((NOPOLZ.EQ.1) .AND. (STK1.EQ.-2) .AND. (IPOL.EQ.2))
     *         IPOL = 1
C
            TRPOL(TNUM) = IPOL
C                                       Bandwidth
            BANDBW(TBANDN) = DUMMY(IDUM+7) * 1.0D3
C                                       LO frequency
            BANDLO(TBANDN) = DUMMY(IDUM+6) * 1.0D6
C                                       Pcal tone frequency
            FTONE(TNUM) = DUMMY(IDUM+4) * 1.0D6
C                                       Map tone to channel
            IFCHAN(TNUM) = TBANDN
C                                       State count or Pcal ?
C                                       State count
            IF (DUMMY(IDUM+4).EQ.0.0D0) THEN
               ISTAT(TNUM) = 1
               NBITS = DUMMY(IDUM+5)
               NSTAT = 2 * NBITS
               WRITE (MSGTXT,2020) TNUM, NBITS, STAT
               IF (STATMS) CALL MSGWRT (3)
C                                        Pulse cal
            ELSE
               ISTAT(TNUM) = 0
               NPCAL(TBANDN) = NPCAL(TBANDN) + 1
               IFTONE(TNUM) = NPCAL(TBANDN)
C                                        Max. # tones
               MAXT = MAX (MAXT, IFTONE(TNUM))
               END IF
C
182         CONTINUE
C                                       Now match FQ-ID and IF's
         IF (FQTOL.LE.0) FQTOL = 0.1 * BANDBW(1)
         CALL MATFID (BANDLO, BANDBW, TRSIDE, NCHAN, FQID, IFMAP,
     *         FQTOL, IERR)
         IF (IERR.EQ.0) THEN
            SKIP = .FALSE.
C                                       No match - skip pulse cal
         ELSE IF (IERR.EQ.2) THEN
            IERR = 0
            SKIP = .TRUE.
            MSGTXT = 'Frequency group does not match an FQ ID'
            CALL MSGWRT (5)
            MSGTXT = 'Skipping pulse cal groups'
            CALL MSGWRT (5)
         ELSE
            IERR = 4
            WRITE (MSGTXT,1182)
            GO TO 990
            END IF
C                                       Open the table?
         IF (FIRST) THEN
            FIRST = .FALSE.
            NTONES = MAXT
            IF (NTONES.LE.0) THEN
               IERR = 5
               MSGTXT = '# TONES FROM FIRST FREQ GROUP IS ZERO'
               CALL MSGWRT (6)
               MSGTXT = 'PCLOD CANNOT OPEN THE PC TABLE - EDIT THE FILE'
               GO TO 990
               END IF
C                                       PC number
            PCVER = IROUND(XPCVER)
C                                       Check to see if PC table exists
            CALL FNDEXT ('PC', CATBLK, PCTOT)
            IF (PCVER.LE.0) PCVER = PCTOT + 1
C
            LUNSC = 30
            CALL PCINI ('WRIT', SXBUFF, DISKIN, OLDCNO, PCVER, CATBLK,
     *         LUNSC, IPCRNO, PCKOLS, PCNUMV, NOPOLZ, NOBAND, NTONES,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR
               GO TO 990
               END IF
C                                       warning of concatenation
            IF (PCVER.LE.PCTOT) THEN
               DOCONC = .TRUE.
               WRITE (MSGTXT,1080) PCVER
               CALL REFRMT (MSGTXT, '_', I)
               CALL MSGWRT (8)
               END IF
C                                       Update CATBLK
            CALL CATIO ('UPDT', DISKIN, OLDCNO, CATBLK, 'REST',
     *         SCBUFF,IERR)
            END IF
C
         DO 210 IDUM = 1,NVALS
            CHVAL(IDUM) = ' '
            DUMMY(IDUM) = 0.D0
 210        CONTINUE
         GO TO 100
         END IF
C                                       Read the pulse-cal group
      IF (ITYP.EQ.2) THEN
         KMODE = 3
         NVALS = NDUM
         CALL KEYIN (CDUMMY, DUMMY, CHVAL, NVALS, ENDMRK, KMODE, LUNK,
     *      FINDK, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1040) IERR
            GO TO 990
            END IF
C
         IDUM = 1
 300     IF ((IDUM.GE.NVALS) .OR. (.NOT.ACCEPT)) THEN
C                                       Write the final row
            IF (ACCEPT) THEN
               IF (ISRC.LE.0) DROPED = DROPED + 1
               IF ((ISRC.GT.0) .OR. (DOKEEP.GT.0.0)) THEN
                  CALL TABPC ('WRIT', SXBUFF, IPCRNO, PCKOLS, PCNUMV,
     *               NOPOLZ, TIME, TINT, ISRC, NOSTA, IARRAY, IFQID,
     *               CABLCL, STATE, PCFRQ, PCREL, PCIMG, PCRAT, IERR)
                  IF (IERR.NE.0) THEN
                     CALL TABERR ('WRIT', 'TABPC ', 'READPC', IERR)
                     GO TO 999
                     END IF
                  NPC = NPC + 1
                  ADDED = ADDED + 1
C
                  IF (DOCONC) THEN
                     WRITE (MSGTXT,2050) NPC, PCVER, STAT
                  ELSE
                     WRITE (MSGTXT,2060) NPC, PCVER, STAT
                     END IF
                  CALL MSGWRT (4)
                  TPC = TPC + NPC
                  END IF
               END IF
C
            DO 310 IDUM = 1,NVALS
               CHVAL(IDUM) = ' '
               DUMMY(IDUM) = 0.D0
  310          CONTINUE
            GO TO 100
            END IF
C                                       Skip processing if this doesn't
C                                       belong to an FQ-ID
         IF (SKIP) GO TO 100
C
         NVARS = 0
         TTIME = DUMMY(IDUM) + DUMMY(IDUM+1) / 24.D0
         DDTT = TTIME - OTIME
C
         IF (((DDTT.GT.EPS) .OR. (DDTT.LT.-EPS)) .AND.
     *      (OTIME.GT.-1.D0)) THEN
C                                       Write the row
            IF (ISRC.LE.0) DROPED = DROPED + 1
            IF ((ISRC.GT.0) .OR. (DOKEEP.GT.0.0)) THEN
               CALL TABPC ('WRIT', SXBUFF, IPCRNO, PCKOLS, PCNUMV,
     *            NOPOLZ, TIME, TINT, ISRC, NOSTA, IARRAY, IFQID,
     *            CABLCL, STATE, PCFRQ, PCREL, PCIMG, PCRAT, IERR)
               IF (IERR.NE.0) THEN
                  CALL TABERR ('WRIT', 'TABPC ', 'READPC', IERR)
                  GO TO 999
                  END IF
               NPC = NPC + 1
               ADDED = ADDED + 1
               END IF
            END IF
C
         TIME = TTIME - DAYN
         OTIME = TTIME
C                                       Get source id. for this time
         RTIME = TIME
         CALL NXSRCH (RTIME, ISRC, IJUNK)
C
         IFQID = FQID
         IARRAY = ISUBA
         NOSTA = ISTN
C
         NVARS = NVARS + 5
C                                       Cable cal value
         IF (CHVAL(IDUM+2)(1:1).EQ.'C') THEN
            CABLCL = DUMMY(IDUM+3) / 1.0D12
            TINT   = DUMMY(IDUM+4) / 86400.D0
            END IF
C
         IF (CHVAL(IDUM+2)(1:1).EQ.'T') THEN
            READ (CHVAL(IDUM+2),2010) CTEMP, TNUM
C                                       Determine the AIPS IF no.
            TBANDN = IFCHAN(TNUM)
            BANDNO = IFMAP(TBANDN)
C                                       Look only nonzero IFs
            IF (BANDNO.EQ.0) GO TO 600
C                                       AIPS polzn. number
            POLNO  = TRPOL(TNUM)
C                                       AIPS tone number
            TONEN  = IFTONE(TNUM)
C                                       State count or pulse cal ?
            IF (ISTAT(TNUM).EQ.1) THEN
C                                       State count
               IF (POLNO.EQ.1) THEN
                  IF (NSTAT.EQ.2) THEN
                     STATE(1, 1, BANDNO) = DUMMY(IDUM+3)
                     STATE(1, 2, BANDNO) = DUMMY(IDUM+4)
                  ELSE IF (NSTAT.EQ.4) THEN
                     NVARS = NVARS + 2
                     STATE(1, 1, BANDNO) = DUMMY(IDUM+3)
                     STATE(1, 2, BANDNO) = DUMMY(IDUM+4)
                     STATE(1, 3, BANDNO) = DUMMY(IDUM+5)
                     STATE(1, 4, BANDNO) = DUMMY(IDUM+6)
                     END IF
               ELSE IF (POLNO.EQ.2) THEN
                  IF (NSTAT.EQ.2) THEN
                     STATE(2, 1, BANDNO) = DUMMY(IDUM+3)
                     STATE(2, 2, BANDNO) = DUMMY(IDUM+4)
                  ELSE IF (NSTAT.EQ.4) THEN
                     NVARS = NVARS + 2
                     STATE(2, 1,BANDNO) = DUMMY(IDUM+3)
                     STATE(2, 2,BANDNO) = DUMMY(IDUM+4)
                     STATE(2, 3,BANDNO) = DUMMY(IDUM+5)
                     STATE(2, 4,BANDNO) = DUMMY(IDUM+6)
                     END IF
                  END IF
C
            ELSE IF (ISTAT(TNUM).EQ.0) THEN
C                                       Pulse-cal
C                                       Amplitudes in files are
C                                       percentages - convert to
C                                       fractions.
               AMP = DUMMY(IDUM+3) / 100.0
               PHS = DUMMY(IDUM+4) * DG2RAD
               IF (POLNO.EQ.1) THEN
                  PCREL(1, TONEN, BANDNO) = AMP * COS (PHS)
                  PCIMG(1, TONEN, BANDNO) = AMP * SIN (PHS)
                  PCFRQ(1, TONEN, BANDNO) = FTONE(TNUM)
                  PCRAT(1, TONEN, BANDNO) = 0.0
               ELSE IF (POLNO.EQ.2) THEN
                  PCREL(2, TONEN, BANDNO) = AMP * COS (PHS)
                  PCIMG(2, TONEN, BANDNO) = AMP * SIN (PHS)
                  PCFRQ(2, TONEN, BANDNO) = FTONE(TNUM)
                  PCRAT(2, TONEN, BANDNO) = 0.0
                  END IF
               END IF
            END IF
 600     CONTINUE
         IDUM = IDUM + NVARS
         GO TO 300
         END IF
C                                       Close up
 700  CALL TABIO ('CLOS', 0, IPCRNO, SXBUFF, SXBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZTXCLS (LUNK, FINDK, IERR)
      IF (TPC.EQ.0) THEN
         MSGTXT = 'NO PHASE-CAL ENTRIES WRITTEN - PROBLEM?'
         IERR = 7
         GO TO 990
         END IF
C                                       Sort PC table
      CALL PCINI ('WRIT', SXBUFF, DISKIN, OLDCNO, PCVER, CATBLK,
     *   LUNSC, IPCRNO, PCKOLS, PCNUMV, NOPOLZ, NOBAND, NTONES,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
C                                       Set column pointers for sort
      MKEY = 2
      CALL FNDCOL (MKEY, KEYS, 24, .TRUE., SXBUFF, KOLS, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
      CALL TABIO ('CLOS', 0, IPCRNO, SXBUFF, SXBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C
      IVERS = PCVER
      KKEY(1,1) = KOLS(1)
      KKEY(2,1) = KOLS(1)
      KKEY(1,2) = KOLS(2)
      KKEY(2,2) = KOLS(2)
      CALL TABSRT (DISKIN, OLDCNO, 'PC', IVERS, IVERS, KKEY, KEYSUB,
     *   FKEY, SXBUFF, CATBLK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1070) IERR
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('READPC: ERROR ',I3,' OPENING PC TABLE')
 1010 FORMAT ('READPC: ERROR ',I3,' READING AN TABLE')
 1020 FORMAT ('READPC: ERROR ',I3,' READING TEXT FILE WITH KEYIN')
 1030 FORMAT ('READPC: ERROR ',I3,' READING FREQUENCY GROUP')
 1040 FORMAT ('READPC: ERROR ',I3,' READING PULSE-CAL GROUP')
 1060 FORMAT ('READPC: ERROR ',I3,' RUNNING FNDCOL')
 1070 FORMAT ('READPC: ERROR ',I3,' SORTING PC TABLE')
 1080 FORMAT ('!! PC table', I3,' already exists !!')
 1182 FORMAT ('** ERROR - FQ table problem ***')
 2000 FORMAT ('Reading data for ',A2)
 2010 FORMAT (A1,I2)
 2020 FORMAT ('Tone ',I3,' carries the ',I1,' bit state count for ',A8)
 2050 FORMAT ('Added ',I5,' rows into PC table', I3, ' for ',A2)
 2060 FORMAT ('Wrote ',I5,' rows into PC table', I3, ' for ',A2)
      END
      SUBROUTINE NEWFPC (IERR)
C-----------------------------------------------------------------------
C   NEWFPC builds a PC table from the "new" DiFX ascii format file
C   Can loop over VLBA named files
C   Output:
C      IRET   I   > 0 -> failure of some sort
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'INCS:PPCV.INC'
      INCLUDE 'PCLOD.INC'
      INTEGER   LUNFQ, SUBA, LC, JTRIM, ILOOP, KBPLIM, KBP, SDAY,
     *   NTONES, NIFS, LIF, LPOL, NOBAND, LUNPC, PCBUFF(512), IPCRNO,
     *   PCKOLS(MAXPCC), PCNUMV(MAXPCC), I, ITONE, ISRC, IFQID, NOPOLZ,
     *   NOSTA, IROUND, IR, IL
      LOGICAL   DOLOOP, FIRST
      CHARACTER ANTNAM(10)*2, TELNAM*8, HLINE*40, LLINE*50000, NAMTEL*8,
     *   OBSDAT*8
      DOUBLE PRECISION  XX, TIME, CABLCL, PCFREQ(2,MAXTON,MAXIF), JD
      REAL      DTIME, PCREAL(2,MAXTON,MAXIF), PCIMAG(2,MAXTON,MAXIF),
     *   PCRATE(2,MAXTON,MAXIF), STATE(2,4,MAXIF), RTIME
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA ANTNAM /'BR','FD','HN','KP','LA','MK','NL','OV','PT','SC'/
      DATA FIRST /.TRUE./
C-----------------------------------------------------------------------
      CALL H2CHR (8, 1, CATH(KHDOB), OBSDAT)
      CALL JULDAY (OBSDAT, JD)
      JD = JD - 2400000.5D0
      SDAY = JD + 0.001
C                                       Make these not fatal errors
C                                       Read NX table information
      LUNFQ = 40
      CALL NXREAD (DISKIN, OLDCNO, ISUBA, CATBLK, LUNFQ, JTABUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING NX TABLE'
         CALL MSGWRT (7)
         END IF
C                                       Read FQ table information
      CALL FQREAD (DISKIN, OLDCNO, CATBLK, JTABUF, LUNFQ, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING FQ DATA'
         CALL MSGWRT (7)
         END IF
C                                       Get list of station names
      SUBA = ISUBA
      CALL GETANT (DISKIN, OLDCNO, SUBA, CATBLK, SCBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING ANTENNA DATA'
         CALL MSGWRT (7)
         END IF
C                                       file name
      LC = JTRIM (NAME2)
      DOLOOP = NAME2(LC:LC).EQ.'_'
      ILOOP = 0
 50   ILOOP = ILOOP + 1
      IF (DOLOOP) NAME2(LC+1:) = ANTNAM(ILOOP)
      CALL ZTXOPN ('READ', LUNK, FINDK, NAME2, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING TEXT FILE'
         IF (.NOT.DOLOOP) GO TO 990
         WRITE (MSGTXT,1000) IERR, 'OPENING TEXT FILE FOR ' //
     *      ANTNAM(ILOOP)
         CALL MSGWRT (7)
         GO TO 210
         END IF
C                                       read first lines, parse
      CALL ZTXIO ('READ', LUNK, FINDK, HLINE, IERR)
 55   IF (IERR.EQ.0) CALL ZTXIO ('READ', LUNK, FINDK, HLINE, IERR)
      IF (IERR.EQ.0) CALL ZTXIO ('READ', LUNK, FINDK, HLINE, IERR)
      IF (IERR.EQ.0) THEN
         KBPLIM = JTRIM (HLINE)
         KBP = 14
         CALL GETNUM (HLINE, KBPLIM, KBP, XX)
C         IF (FIRST) SDAY = XX + 0.1D0
         CALL ZTXIO ('READ', LUNK, FINDK, HLINE, IERR)
         IF (IERR.EQ.0) CALL ZTXIO ('READ', LUNK, FINDK, HLINE, IERR)
         IF (IERR.EQ.0) TELNAM = HLINE(20:)
         END IF
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING HEADER LINES'
         IF (.NOT.DOLOOP) GO TO 990
         WRITE (MSGTXT,1000) IERR, 'READING HEADER LINES FOR' //
     *      ANTNAM(ILOOP)
         CALL MSGWRT (7)
         GO TO 200
         END IF
      NOSTA = 0
      DO 60 I = 1,NSTNS
         IF (TELNAM.EQ.STNNAM(I)) NOSTA = TELNO(I)
 60      CONTINUE
      IF (NOSTA.LE.0) NOSTA = NSTNS + ILOOP
C                                       read a line
 100  CALL ZTXIO ('READ', LUNK, FINDK, LLINE, IERR)
      IF (IERR.EQ.2) THEN
         GO TO 200
      ELSE IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING TEXT FILE'
         IF (.NOT.DOLOOP) GO TO 990
         WRITE (MSGTXT,1000) IERR, 'READING TEXT FILE FOR' //
     *      ANTNAM(ILOOP)
         CALL MSGWRT (7)
         GO TO 200
      ELSE
         KBPLIM = JTRIM (LLINE)
         IF (LLINE.EQ.'# DiFX-derived pulse cal data') GO TO 55
C                                       parse start of line
         DO 105 KBP = 1,KBPLIM
            IF (LLINE(KBP:KBP).EQ.' ') GO TO 110
 105        CONTINUE
C                                       telescope name
 110     NAMTEL = LLINE(:KBP-1)
         IF (NAMTEL.NE.TELNAM) THEN
            NOSTA = 0
            DO 115 I = 1,NSTNS
               IF (NAMTEL.EQ.STNNAM(I)) NOSTA = TELNO(I)
 115           CONTINUE
            IF (NOSTA.LE.0) NOSTA = NSTNS + ILOOP
            MSGTXT = 'Data line changes telescope from ' //
     *         TELNAM(:JTRIM(TELNAM)) // ' to ' //
     *         NAMTEL(:JTRIM(NAMTEL))
            CALL MSGWRT (6)
            TELNAM = NAMTEL
            END IF
C                                       time
         CALL GETNUM (LLINE, KBPLIM, KBP, XX)
         TIME = XX - SDAY
C                                       Get source id. for this time
         RTIME = TIME
         CALL NXSRCH (RTIME, ISRC, IFQID)
C                                       time incr
         CALL GETNUM (LLINE, KBPLIM, KBP, XX)
         DTIME = XX
C                                       ???
         CALL GETNUM (LLINE, KBPLIM, KBP, XX)
C                                       NIFS * NPOL
         CALL GETNUM (LLINE, KBPLIM, KBP, XX)
         NIFS = XX + 0.1
C                                       NVAL per IF
         CALL GETNUM (LLINE, KBPLIM, KBP, XX)
         NTONES = XX + 0.1
C                                       FIRST: init arrays, open table
         IF (FIRST) THEN
            IR = INDEX (LLINE, ' R ')
            IL = INDEX (LLINE, ' L ')
            NOPOLZ = 0
            IF (IR.GT.0) NOPOLZ = NOPOLZ + 1
            IF (IL.GT.0) NOPOLZ = NOPOLZ + 1
            NOBAND = NIFS
            IF (NOPOLZ.GT.0) NOBAND = NIFS / NOPOLZ
            I = CATBLK(KINAX+JLOCS)
            I = MIN (I, 2)
            IF ((NOPOLZ.NE.I) .OR. (NOBAND.NE.CATBLK(KINAX+JLOCIF)))
     *         THEN
               WRITE (MSGTXT,1110) NOPOLZ, NOBAND, I,
     *            CATBLK(KINAX+JLOCIF)
               CALL MSGWRT (6)
               END IF
            I = 2 * MAXTON * MAXIF
            CALL RFILL (I, FBLANK, PCREAL)
            CALL RFILL (I, FBLANK, PCIMAG)
            CALL RFILL (I, FBLANK, PCRATE)
            CALL DFILL (I, 0.0D0, PCFREQ)
            CABLCL = 0.0D0
            I = 8 * MAXIF
            CALL RFILL (I, FBLANK, STATE)
C                                       PC number
            PCVER = IROUND(XPCVER)
C                                       Check to see if PC table exists
            CALL FNDEXT ('PC', CATBLK, PCTOT)
            IF (PCVER.LE.0) PCVER = PCTOT + 1
            LUNPC = 30
            CALL PCINI ('WRIT', PCBUFF, DISKIN, OLDCNO, PCVER, CATBLK,
     *         LUNPC, IPCRNO, PCKOLS, PCNUMV, NOPOLZ, NOBAND, NTONES,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPENING PC TABLE'
               GO TO 990
               END IF
C                                       warning of concatenation
            IF (PCVER.LE.PCTOT) THEN
               DOCONC = .TRUE.
               WRITE (MSGTXT,1111) PCVER
               CALL REFRMT (MSGTXT, '_', I)
               CALL MSGWRT (5)
               END IF
C                                       Update CATBLK
            CALL CATIO ('UPDT', DISKIN, OLDCNO, CATBLK, 'REST', SCBUFF,
     *         IERR)
            FIRST = .FALSE.
            END IF
C                                       sanity check
         IF (NIFS.NE.NOPOLZ*NOBAND) THEN
            WRITE (MSGTXT,1112) NIFS, NOPOLZ, NOBAND
            CALL MSGWRT (7)
         END IF
         NIFS = NIFS / NOPOLZ
         DO 140 LIF = 1,NIFS
            DO 130 LPOL = 1,NOPOLZ
               DO 120 ITONE = 1,NTONES
                  CALL GETNUM (LLINE, KBPLIM, KBP, XX)
                  PCFREQ(LPOL,ITONE,LIF) = XX * 1.D6
                  KBP = KBP + 2
                  CALL GETNUM (LLINE, KBPLIM, KBP, XX)
                  PCREAL(LPOL,ITONE,LIF) = XX
                  CALL GETNUM (LLINE, KBPLIM, KBP, XX)
                  PCIMAG(LPOL,ITONE,LIF) = XX
                  PCRATE(LPOL,ITONE,LIF) = 0.0
 120              CONTINUE
 130           CONTINUE
 140        CONTINUE
         IF (ISRC.LE.0) DROPED = DROPED + 1
         IF ((ISRC.GT.0) .OR. (DOKEEP.GT.0.0)) THEN
            CALL TABPC ('WRIT', PCBUFF, IPCRNO, PCKOLS, PCNUMV, NOPOLZ,
     *         TIME, DTIME, ISRC, NOSTA, ISUBA, IFQID, CABLCL, STATE,
     *         PCFREQ, PCREAL, PCIMAG, PCRATE, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'WRITING OUTPUT PC TABLE'
               GO TO 990
               END IF
             ADDED = ADDED + 1
             END IF
         GO TO 100
         END IF
C                                       close input text file
 200  CALL ZTXCLS (LUNK, FINDK, IERR)
 210  IF ((DOLOOP) .AND. (ILOOP.LT.10)) GO TO 50
      CALL TABPC ('CLOS', PCBUFF, IPCRNO, PCKOLS, PCNUMV, NOPOLZ,
     *   TIME, DTIME, ISRC, NOSTA, ISUBA, IFQID, CABLCL, STATE,
     *   PCFREQ, PCREAL, PCIMAG, PCRATE, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('NEWFPC ERROR',I4,' ON ',A)
 1110 FORMAT ('PC FILE Npol, Nif',I2,I4,' DO NOT MATCH UV DATA',I2,I4)
 1111 FORMAT ('NEWFPC: Cocatenating to PC table',I5)
 1112 FORMAT ('WARNING: NIFS',I4,' NOT NPOL*NBAND',I2,I4)
      END
      SUBROUTINE PCRHI
C-----------------------------------------------------------------------
C   PCRHI copies and updates history file.
C-----------------------------------------------------------------------
      INTEGER   LUN1, IERR, ITIME(3), DATE(3), I
      CHARACTER HILINE*72, CITIME*20
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PCLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1 /27/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HIOPEN (LUN1, DISKIN, FCNO(NCFILE), SCBUFF, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (ITIME)
      CALL TIMDAT (ITIME, DATE, CITIME(13:20), CITIME(1:12))
      WRITE (HILINE,1010) TSKNAM, RLSNAM, CITIME(1:12), CITIME(13:20)
      CALL HIADD (LUN1, HILINE, SCBUFF, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       File name
      WRITE (HILINE,2000) TSKNAM, NAME2
      CALL HIADD (LUN1, HILINE, SCBUFF, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Version #
      IF (DOCONC) THEN
         WRITE (HILINE,2001) TSKNAM, PCVER, ADDED
         CALL HIADD (LUN1, HILINE, SCBUFF, IERR)
         IF (IERR.NE.0) GO TO 100
         WRITE (MSGTXT,1020) ADDED, PCVER
         CALL REFRMT (MSGTXT, '_', I)
         CALL MSGWRT (4)
      ELSE
         WRITE (HILINE,2002) TSKNAM, PCVER, ADDED
         CALL HIADD (LUN1, HILINE, SCBUFF, IERR)
         IF (IERR.NE.0) GO TO 100
         WRITE (MSGTXT,1021) ADDED, PCVER
         CALL REFRMT (MSGTXT, '_', I)
         CALL MSGWRT (4)
         END IF
C                                       Dropped
      IF (DROPED.GT.0) THEN
         IF (DOKEEP.GT.0.0) THEN
            WRITE (HILINE,2003) TSKNAM, DROPED
         ELSE
            WRITE (HILINE,2004) TSKNAM, DROPED
            END IF
         CALL HIADD (LUN1, HILINE, SCBUFF, IERR)
         IF (IERR.NE.0) GO TO 100
         MSGTXT = HILINE(9:)
         CALL REFRMT (MSGTXT, '_', I)
         CALL MSGWRT (4)
         END IF
C                                       Close HI file
 100  CALL HICLOS (LUN1, .TRUE., SCBUFF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PCRHI: ERROR',I3,' OPENING HISTORY FILE')
 1010 FORMAT (A6,'RELEASE =''',A,' ''  /********* Start ',
     *   A12,2X,A8)
 1020 FORMAT (I10,' records added to old PC table version',I4)
 1021 FORMAT (I10,' records written to new PC table version',I4)
 2000 FORMAT (A6,'INFILE = ''',A48,'''')
 2001 FORMAT (A6,'PCVERS =',I4,'  / Concatenated',I8,
     *   ' records to existing table')
 2002 FORMAT (A6,'PCVERS =',I4,'  / Wrote',I8,
     *   ' records to new table')
 2003 FORMAT (A6,'/ Kept',I8,' records not in scans')
 2004 FORMAT (A6,'/ Dropped',I8,' records not in scans')
      END
      SUBROUTINE MATFID (DLOFRQ, BANDW, ISIDE, N, IFQID, IFMAP, TOL,
     *   IRET)
C-----------------------------------------------------------------------
C   Determine FQ-ID/IF matching a given set of Pcal channel frequencies
C   Inputs:
C      DLOFRQ     D(*)   LO sum for each Pcal channel (Hz)
C      BANDW      R(*)   Bandwidth for each Pcal channel (Hz)
C      ISIDE      I(*)   Sideband for each Pcal channel
C      N          I      Number of Pcal channels
C      TOL        R      Tolerance for match (Hz)
C   Inputs from common:
C      DFRQTB     D(*,*,2) Table of freqs. for each AIPS FQ-ID/IF.
C      IFQUV      I(*)     Array of FQ-IDs in data
C      NFQUV      I        Number of entries in IFQUV
C   Outputs:
C      IFQID      I      Matching FQ-ID (zero if no match)
C      IFMAP      I(*)   AIPS IF number for each pcal. channel
C      IRET       I      Return code (0 => ok)
C-----------------------------------------------------------------------
      INTEGER N, IFQID, IRET
      DOUBLE PRECISION DLOFRQ(N)
      REAL BANDW(N), TOL
      INTEGER ISIDE(N), IFMAP(N)
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PCLOD.INC'
      LOGICAL WMATCH
      DOUBLE PRECISION DFRQ1, DFRQ2, DEPS1, DEPS2
      INTEGER JFQ, ICHAN, IIF, J
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Initialisation
      IRET = 0
      IFQID = 0
C                                       Any FQ-IDs ?
      IF (NFQUV.LE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1000)
         GO TO 990
         END IF
C                                       Loop through all FQ-IDs in data
      WMATCH = .FALSE.
      JFQ = 0
C                                       Match found ?
C50    IF ((JFQ.GT.NFQUV).OR.(WMATCH)) GO TO 200
C
50    IF ((JFQ .GE. NFQUV) .OR. (WMATCH)) GO TO 200
C                                       Does this FQ-ID match Pcal
C                                       channel frequencies ?
      JFQ = JFQ + 1
C                                       Loop over all Pcal channels
      DO 100 ICHAN = 1, N
C                                       Freq. range of Pcal channel
         IF (ISIDE(ICHAN).LE.0) THEN
            DFRQ1 = DLOFRQ(ICHAN) - BANDW(ICHAN)
         ELSE
            DFRQ1 = DLOFRQ(ICHAN)
            END IF
         DFRQ2 = DFRQ1 + BANDW(ICHAN)
         IFMAP(ICHAN) = 0
C                                       Find matching AIPS IF number
         DO 75 IIF = 1, NIFFQ
            DEPS1 = ABS (DFRQ1 - DFRQTB(JFQ,IIF,1))
            DEPS2 = ABS (DFRQ2 - DFRQTB(JFQ,IIF,2))
C                                       Compare to within tolerance
            IF ((DEPS1.LE.TOL).AND.(DEPS2.LE.TOL)) THEN
              IFMAP(ICHAN) = IIF
              GO TO 100
              END IF
75          CONTINUE
100      CONTINUE
C                                       Was a match found at least
C                                       for one Pcal channel?
      WMATCH = .FALSE.
      DO 120 J = 1, N
         IF (IFMAP(J) .NE. 0) THEN
            WMATCH = .TRUE.
            GO TO 50
            END IF
120      CONTINUE
C
      GO TO 50
C                                       Endwhile
200   IF (WMATCH) THEN
         IFQID = IFQUV(JFQ)
      ELSE
         IRET = 2
         END IF
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Exit
999   RETURN
C----------------------------------------------------------------------
1000  FORMAT ('MATFID: No FQ table information; check FQ table')
      END
      SUBROUTINE NXREAD (INDISK, ICNO, ISUB, CATBLK, ILUN, JBUFF, IRET)
C-----------------------------------------------------------------------
C   Subroutine to read NX table information into memory
C   Inputs:
C      INDISK  I       Disk volume number
C      ICNO    I       Catalog slot number
C      ISUB    I       Subarray number
C      CATBLK  I(256)  Catalog header block
C      ILUN    I       LUN to use for table I/O
C      JBUFF   I(*)    Buffer for table I/O
C      MAXNX   I       Maximum dimension of TIMENX, INXSOU, INXFQ
C      MXFQID  I       Maximum dimension of IFQUV
C   Outputs to common:
C      TIMENX  R(2,*)  Scan start, stop times
C      INXSOU  I(*)    Source ID's from NX table
C      INXFQ   I(*)    FQ-ID's from NX table
C      NXDAT   I       Number of NX table entries read
C      IFQUV   I(*)    Array of FQ-ID's found
C      NFQUV   I       No. of entries in IFQUV
C   Outputs:
C      IRET    I       Return code (0 => ok)
C-----------------------------------------------------------------------
      INTEGER   INDISK, ICNO, ISUB, CATBLK(256), ILUN, JBUFF(*), IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PCLOD.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      LOGICAL   WTABLE, WEXIST, WFITS
      REAL      TIME, TINT, TEPS
      INTEGER    NXKOLS(MAXNXC), NXNUMV(MAXNXC), IERR, I, INXRNO,
     *   IDSOUR, ISUBNX, ISTART, IEND, IFQID, NROW, NVISMX, J
C-----------------------------------------------------------------------
C                                       Initialisation
      IRET = 0
      NXDAT = 0
      TEPS = 0.1 / (24.0 * 3600.0)
C                                       Does an NX table exist ?
      CALL ISTAB ('NX', INDISK, ICNO, 1, ILUN, JBUFF, WTABLE, WEXIST,
     *   WFITS, IERR)
      IF ((IERR.NE.0).OR.(.NOT.(WEXIST.AND.WTABLE))) THEN
         IRET = 1
         WRITE (MSGTXT,1020)
         GO TO 990
         END IF
C                                       Open the NX table
      CALL NDXINI ('READ', JBUFF, INDISK, ICNO, 1, CATBLK, ILUN,
     *   INXRNO, NXKOLS, NXNUMV, IERR)
      IF (IERR.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Read table into memory
      NROW = JBUFF(5)
      NVISMX = 0
      DO 100 I = 1, NROW
         CALL TABNDX ('READ', JBUFF, INXRNO, NXKOLS, NXNUMV, TIME,
     *      TINT, IDSOUR, ISUBNX, ISTART, IEND, IFQID, IERR)
C                                       Record de-selected ?
         IF (IERR.EQ.-1) GO TO 100
         IF (IERR.NE.0) THEN
            IRET = 3
            WRITE (MSGTXT,1100) IERR
            GO TO 990
            END IF
C                                       Update maximum vis. no.
         NVISMX = MAX (NVISMX, IEND)
C                                       Correct subarray ?
         IF (ISUBNX.NE.ISUB) GO TO 100
C                                       NX buffer too small ?
         NXDAT = NXDAT + 1
         IF (NXDAT.GT.MAXNX) THEN
            IRET = 4
            WRITE (MSGTXT,1120)
            GO TO 990
            END IF
C
         TIMENX(1,NXDAT) = TIME - TINT / 2.0 - TEPS
         TIMENX(2,NXDAT) = TIME + TINT / 2.0 + TEPS
         INXSOU(NXDAT) = IDSOUR
         INXFQ(NXDAT) = IFQID
100      CONTINUE
C                                       Close NX table
      CALL TABIO ('CLOS', 0, INXRNO, JBUFF, JBUFF, IERR)
      IF (IERR.NE.0) THEN
         IRET = 4
         WRITE (MSGTXT,1140) IERR
         GO TO 990
         END IF
C                                       Determine whether NX table is
C                                       current by matching Nvis in
C                                       catalog hdr. with NVISMX from
C                                       NX table.
      IF (NVISMX.NE.CATBLK(KIGCN)) THEN
         IRET = 5
         WRITE (MSGTXT,1160)
         GO TO 990
         END IF
C                                       Any valid scans found ?
      IF (NXDAT.EQ.0) THEN
         IRET = 6
         WRITE (MSGTXT,1180)
         GO TO 990
         END IF
C                                       Compile table of all unique
C                                       FQ_IDs in the data. Use
C                                       information read from the NX
C                                       table.
      NFQUV = 0
      DO 200 I = 1, NXDAT
         DO 150 J = 1, NFQUV
            IF (IFQUV(J).EQ.INXFQ(I)) GO TO 200
150         CONTINUE
C                                       New FQ-ID found
         NFQUV = NFQUV + 1
         IF (NFQUV.GT.MXFQID) THEN
            WRITE (MSGTXT,1150)
            IRET = 11
            GO TO 990
            END IF
         IFQUV(NFQUV) = INXFQ(I)
200      CONTINUE
C
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C
999   RETURN
C-----------------------------------------------------------------------
1020  FORMAT ('NXREAD: NO VALID NX TABLE FOUND - RUN INDXR')
1040  FORMAT ('NXREAD: ERR',I3,' OPENING NX TABLE')
1100  FORMAT ('NXREAD: ERR',I3,' READING NX TABLE')
1120  FORMAT ('NXREAD: INCREASE PARAMETER MAXNX')
1140  FORMAT ('NXREAD: ERR',I3,' CLOSING NX TABLE')
1160  FORMAT ('NXREAD: NX TABLE OLD - RUN INDXR')
1180  FORMAT ('NXREAD: NO SCANS FOR SUBARRAY',I4)
1150  FORMAT ('NXREAD: PARAMETER MXFQID NEEDS TO BE INCREASED')
      END
      SUBROUTINE FQREAD (INDISK, ICNO, CATBLK, JBUFF, ILUN, IRET)
C-----------------------------------------------------------------------
C   Subroutine to read parts of the FQ table into memory
C   Inputs:
C      INDISK  I        Disk volume
C      ICNO    I        Catalog slot number
C      CATBLK  I(256)   Catalog header block
C      JBUFF   I(*)     I/O table buffer
C      ILUN    I        LUN to use for table I/O
C   Outputs to common:
C      DFRQTB  D(*,*,2) Table of freq. values for each IF/FQ-ID
C   Outputs:
C      IRET    I    Return code (0 => ok)
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER INDISK, ICNO, CATBLK(256), ILUN, JBUFF(*), IRET
C
      INCLUDE 'PCLOD.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DOUBLE PRECISION DFOFF(MAXIF), DBAND, DEDGE, DREF
      REAL      CATR(256), FINC(MAXIF)
      INTEGER   ISBAND(MAXIF), NIF, I, J, IVER, IERR, NDIM
      CHARACTER BNDCOD(MAXIF)*8
C-----------------------------------------------------------------------
      IRET = 0
C                                       Initialization
      NDIM = 2 * MXFQID * MAXIF
      CALL DFILL (NDIM, 0.0D0, DFRQTB)
      CALL RCOPY (256, CATBLK, CATR)
C                                       Reference freq. at DC
      DREF = FREQ - (CATR(KRCRP+JLOCF) - 0.5) * CATR(KRCIC+JLOCF)
      NIFFQ = 0
C                                       Read FQ/CH data into memory
      DO 100 I = 1, NFQUV
         IVER = 1
         CALL CHNDAT ('READ', JBUFF, INDISK, ICNO, IVER, CATBLK,
     *      ILUN, NIF, DFOFF, ISBAND, FINC, BNDCOD, IFQUV(I), IERR)
         IF (IERR.NE.0) THEN
            IRET = 1
            WRITE (MSGTXT,1100) IERR
            GO TO 990
            END IF
C                                       Max. no. of IF's
         NIFFQ = MAX (NIF, NIFFQ)
C                                       Loop over the IFs
         DO 80 J = 1, NIF
            DBAND = FINC(J) * CATBLK(KINAX+JLOCF)
            DEDGE = DFOFF(J) + DREF
C
            DFRQTB(I,J,1) = DEDGE
            DFRQTB(I,J,2) = (DEDGE + DBAND)
80          CONTINUE
100      CONTINUE
C
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Exit
999   RETURN
C-----------------------------------------------------------------------
1100  FORMAT ('FQREAD: ERR',I3,' READING FQ/CH TABLE')
      END
      SUBROUTINE NXSRCH (RTIME, ISOUID, IFQID)
C----------------------------------------------------------------------
C   Search the NX table for the source and freq. ID. at a given time
C   Inputs:
C      RTIME   R   Input time relative to the ref. date (in days)
C   Outputs:
C      ISOUID  I   Source id. (0 if not found)
C      IFQID   I   FQ. id.
C---------------------------------------------------------------------
      REAL RTIME
      INTEGER ISOUID, IFQID
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PCLOD.INC'
      INTEGER I
C---------------------------------------------------------------------
      ISOUID = 0
      IFQID = 0
C                                       Search the NX table
      DO 100 I = 1, NXDAT
         IF ((RTIME.GE.TIMENX(1,I)).AND.(RTIME.LE.TIMENX(2,I))) THEN
            ISOUID = INXSOU(I)
            IFQID = INXFQ(I)
            END IF
100      CONTINUE
C                                       Exit
      RETURN
      END

      SUBROUTINE ZROPEN (LUN, FIND, SERVER, HOST, IRET)
C-----------------------------------------------------------------------
C! request a connection to a server
C# IO-remote Z
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Request a connection to a server on the given LUN.
C   Inputs:
C      LUN      I        Logical unit number to use.
C      SERVER   C*(*)    Name of server program.  This is actually a
C                        logical name which evaluates to a service
C                        specification is system dependent form.
C      HOST     C*(*)    Name of the machine on which the server is
C                        running.  This is actually a logical name which
C                        evaluates to a network address in system
C                        dependent form.
C   Outputs:
C      FIND     I        Index of the FTAB entry for the opened channel.
C      IRET     I        Error return status:
C                           0 => channel opened successfully
C                           1 => server unknown
C                           2 => host unknown
C                           3 => invalid LUN
C                           4 => no room for new FTAB entry
C                           5 => LUN already opened
C                           6 => system error
C                          99 => other error
C  Generic version.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IRET
      CHARACTER SERVER*(*), HOST*(*)
C
      CHARACTER CHNAME*256, SRVNAM*128, HOSTNM*128
      INTEGER   HSTLEN, SRVLEN, FCBOFF, ITYP, INUM, IERR, I, ITRIM
      HOLLERITH HHOST(32), HSERV(32)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INTEGER    MAXLUN
      PARAMETER (MAXLUN = 50)
C-----------------------------------------------------------------------
      IRET = 0
C                                       Translate the server name:
      CALL ZTRLOG (LEN (SERVER), SERVER, LEN (SRVNAM), SRVNAM, I, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT, 1000) SERVER
         CALL MSGWRT (6)
         END IF
C                                       Translate the host name:
      IF (IRET.EQ.0) THEN
         CALL ZTRLOG (LEN (HOST), HOST, LEN (HOSTNM), HOSTNM, I, IERR)
         IF (IERR.NE.0) THEN
            IRET = 2
            WRITE (MSGTXT,1001) HOST
            CALL MSGWRT (6)
            END IF
         END IF
C                                       Check LUN range:
      IF (IRET.EQ.0) THEN
         IF ((LUN.LT.1) .OR. (LUN.GT.MAXLUN)) THEN
            IRET = 3
            WRITE (MSGTXT, 1002) LUN, MAXLUN
            CALL MSGWRT (6)
            END IF
         END IF
C                                       Check device type for the
C                                       specified LUN (an FCB is
C                                       required):
      IF (IRET.EQ. 0)THEN
         IF ((DEVTAB(LUN).EQ.1) .OR. (DEVTAB(LUN).EQ.3)) THEN
            IRET = 3
            WRITE (MSGTXT, 1003) LUN, DEVTAB(LUN)
            CALL MSGWRT (6)
            END IF
         END IF
C                                       Form a name for the channel of
C                                       the form SERVER@HOST:
      IF (IRET.EQ.0) THEN
         SRVLEN = ITRIM (SERVER)
         HSTLEN = ITRIM (HOST)
C                                         Make sure that the channel
C                                         name will fit in the storage
C                                         allocated for it:
         IF ((SRVLEN+HSTLEN+1).GT.256) THEN
            IRET = 99
            WRITE (MSGTXT,1004)
            CALL MSGWRT (6)
         ELSE
            CHNAME = SERVER(1:SRVLEN) // '@' // HOST(1:HSTLEN)
            END IF
         END IF
C                                       Create an entry for the channel
C                                       in the AIPS common file table:
      IF (IRET.EQ.0) THEN
         CALL LSERCH ('OPEN', LUN, FIND, .FALSE., IERR)
C                                       Non-mapped (ie. single-buffered)
C                                       I/O is assumed.
         IF (IERR.EQ.3) THEN
            IRET = 4
            WRITE (MSGTXT, 1005)
            CALL MSGWRT (6)
         ELSE IF (IERR.EQ.2) THEN
            IRET = 5
            WRITE (MSGTXT, 1006) LUN
            CALL MSGWRT (6)
         ELSE IF (IERR.NE.0) THEN
            IRET = 99
            WRITE (MSGTXT, 1007) IERR
            CALL MSGWRT (6)
C                                       Calculate starting index of FCB:
         ELSE
            FCBOFF = FIND + NMOFF
            END IF
         END IF
C                                       Make the request:
      IF (IRET.EQ.0) THEN
         SRVLEN = ITRIM (SRVNAM)
         HSTLEN = ITRIM (HOSTNM)
         CALL CHR2H (128, SRVNAM, 1, HSERV)
         CALL CHR2H (128, HOSTNM, 1, HHOST)
         CALL ZROPN2 (FTAB(FCBOFF), SRVLEN, HSERV, HSTLEN, HHOST, IERR)
         IF (IERR.NE.0) THEN
            IRET = 6
            WRITE (MSGTXT, 1008)
            CALL MSGWRT (6)
            CALL ZERROR ('ZROPN2', FTAB(FCBOFF+FCBERR), CHNAME,
     *         FTAB(FCBOFF), .TRUE.)
            END IF
         END IF
C                                       Save the channel name:
      IF (IRET.EQ.0) THEN
         CALL FSERCH (FIND, ITYP, INUM, IERR)
         IF (IERR.NE.0) THEN
            IRET = 99
            WRITE (MSGTXT, 1009) IERR
            CALL MSGWRT (6)
         ELSE IF (ITYP.NE.2) THEN
            IRET = 99
            WRITE (MSGTXT, 1010) ITYP
            CALL MSGWRT (6)
         ELSE
            NONNAM(INUM) = CHNAME
            END IF
         END IF

C                                       If any errors occurred then
C                                       force the FTAB entry to be
C                                       cleared:
      IF (IRET.NE.0) THEN
         CALL LSERCH ('CLOS', LUN, FIND, .FALSE., IERR)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZROPEN: UNKNOWN SERVER ', A20)
 1001 FORMAT ('ZROPEN: UNKNOWN HOST ', A20)
 1002 FORMAT ('ZROPEN: LUN ', I4, ' IS OUT OF RANGE (1 TO ', I2, ')')
 1003 FORMAT ('ZROPEN: LUN ', I2, ' HAS WRONG TYPE (', I1, ')')
 1004 FORMAT ('ZROPEN: INSUFFICIENT STORAGE FOR CHANNEL NAME')
 1005 FORMAT ('ZROPEN: NO SPACE LEFT IN FILE TABLE')
 1006 FORMAT ('ZROPEN: LUN ', I2, ' ALREADY OPEN')
 1007 FORMAT ('ZROPEN: ERROR ', I3, ' FROM LSERCH')
 1008 FORMAT ('ZROPEN: COULD NOT OPEN CHANNEL')
 1009 FORMAT ('ZROPEN: ERROR ', I3, ' FROM FSERCH')
 1010 FORMAT ('ZROPEN: WRONG FILE TYPE (', I1, ')')
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QGET (HOST, AP, N, TYPE)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Move data from pseudo-AP memory to "host".
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Transfer data from pseudo-AP core to normal core
C   Inputs:
C      AP     I  Target area in AP; 0-relative
C      N      I  Number of elements
C      TYPE   I  Data type:
C                 0   data is I   in host
C                 1   data is I   in host
C                 2   data is R   in host
C   Output:
C      HOST   R/I(*)  Data array in "host"
C-----------------------------------------------------------------------
      INTEGER   AP, I, N, TYPE
      REAL      HOST(*)
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (TYPE.GT.2) GO TO 999
      IF (N.LE.0) GO TO 999
C                                       Real data
      IF (TYPE .EQ. 1) THEN
         CALL QGET2 (HOST, AP, N)
      ELSE
C        DO 50 I = 1, N
C           HOST(I) = APCORE(AP+I)
C50         CONTINUE
         CALL SCOPY(N,APCORE(AP+1),1,HOST,1)
       ENDIF
C
 999  RETURN
      END

      PROGRAM TVMON
C-----------------------------------------------------------------------
C! drives true TV device from a distant computer which uses VTV routines
C# TV-IO TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2008, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TVMON is a program to run stand-alone in the CPU which has a TV
C   connected directly to it.  TVMON receives TV commands over a
C   communication line (e.g. via a mailbox driven from some other
C   process perhaps on some other computer), parses them, calls the Y
C   routines appropriate to the local TV device, and returns over the
C   communication lines the requested parameters and an error code.
C   It chooses a local "TV number" by the process name under which it
C   finds itself running, i.e., if the process name is TVMON3 then it
C   calls for AIPS TV number 3.
C-----------------------------------------------------------------------
      INTEGER   IRET, LUN, FIND
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DVTV.INC'
      DATA LUN /16/
C-----------------------------------------------------------------------
C                                       Create communication channel
      BUFSW = 0
      BUFSR = 0
      CALL TVMINI (LUN, FIND, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Do the TV driving
      CALL TVMONI (LUN, FIND, IRET)
C                                       quit
 990  CALL TVMEXI (LUN, FIND, IRET)
C
 999  STOP
      END
      SUBROUTINE TVMINI (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C   TVMINI starts up TVMON setting up the commons and the communication
C   channel (e.g. creating and opening the mailbox).
C   Inputs:
C      LUN    I      LUN to use for socket to remote machine
C   Output:
C      FIND   I      FTAB location reserved
C      IERR   I      Error code: 0 => ok, keep going
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
C
      CHARACTER PGM*6
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DVTV.INC'
      DATA PGM /'TVMON '/
C-----------------------------------------------------------------------
C                                       AIPS init
      CALL ZDCHIN (.TRUE.)
      TSKNAM = PGM
      CALL ACOUNT (1)
      CALL VHDRIN
C                                       message
      WRITE (MSGTXT,1000)
      CALL MSGWRT (3)
      BUFSW = 0
      BUFSR = 0
C                                       call local, machine-dependent
C                                       routine: setup TV #, mailbox
      CALL ZVTVRO (LUN, FIND, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL YTVCIN
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Begins')
      END
      SUBROUTINE TVMEXI (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C   TVMEXI is a simple close down routine for TVMON.
C   Inputs:
C      LUN    I      LUN in use for socket to remote machine
C      FIND   I      FTAB location reserved
C      IERR   I      Error code from other main subroutines
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
C
      INTEGER   NLEV
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
C                                       message
      NLEV = 4
      IF (IERR.NE.0) THEN
         NLEV = 8
         WRITE (MSGTXT,1000) IERR
      ELSE
         NLEV = 4
         WRITE (MSGTXT,1001)
         END IF
      CALL MSGWRT (NLEV)
      CALL ZVTVRC (LUN, FIND, IERR)
      BUFSW = 0
      BUFSR = 0
C                                       accounting
      CALL ACOUNT (2)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DIES OF UNNATURAL CAUSE NUMBER',I7)
 1001 FORMAT ('Appears to have ended successfully')
      END
      SUBROUTINE TVMONI (LUN, FIND, IRET)
C-----------------------------------------------------------------------
C   TVMONI actually drives the TV device: read (wait) for command;
C   parse the opcode and routine name; call the appropriate routine to
C   decode the parameters, to call the Y routine, and to encode the
C   return parameters; send the parameters back, and loop.
C   Inputs:
C      LUN    I      LUN in use for socket to remote machine
C      FIND   I      FTAB location reserved
C   Output:
C      IRET   I      Error code: 0 => ok
C                       else transmission has failed
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IRET
C
      INCLUDE 'INCS:PTVC.INC'
      CHARACTER XT*10, NAMES(34)*6, SUBNAM*6, OP*4
      INTEGER   IERR, IBUF(8192), INAM, NNAM, I
      REAL      RBUF(TVMOFM)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DVTV.INC'
      DATA NNAM, NAMES /34, 'YALUCT', 'YCHRW ', 'YCINIT', 'YCNECT',
     *   'YCONST', 'YCOVER', 'YCRCTL', 'YCREAD', 'YCUCOR', 'YCURSE',
     *   'YCWRIT', 'YFDBCK', 'YFILL ', 'YFIND ', 'YGRAFX', 'YGRAPH',
     *   'YIFM  ', 'YIMGIO', 'YINIT ', 'YLOCAT', 'YLUT  ', 'YMNMAX',
     *   'YOFM  ', 'YRHIST', 'YSCROL', 'YSHIFT', 'YSLECT', 'YSPLIT',
     *   'YTVCLS', 'YTVMC ', 'YTVOPN', 'YWINDO', 'YZERO ', 'YZOOMC'/
C-----------------------------------------------------------------------
C                                       get assigned TV (TVMONn => n)
      CALL WHOAMI (TSKNAM, INAM, IERR)
      IF (IERR.EQ.0) THEN
         NTVDEV = INAM
      ELSE
         NTVDEV = 1
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (7)
         END IF
C                                       First time: skip return
      GO TO 50
C                                       return buffer, IERR
 10   CONTINUE
         I = BUFSR + 8
         CALL ZILI16 (1, IERR, 8, HEADER)
         CALL VTVRX (FIND, I, HEADER, IRET)
         IF (IRET.EQ.0) GO TO 50
            WRITE (MSGTXT,1010) SUBNAM, OP, IRET
            CALL MSGWRT (8)
            GO TO 999
C                                       read transmission
 50   I = 0
      CALL VTVRX (FIND, I, HEADER, IRET)
      IF (IRET.EQ.0) GO TO 60
         WRITE (MSGTXT,1050) IRET
         CALL MSGWRT (8)
         GO TO 999
C                                       unpack
 60   CALL ZI16IL (1, 6, HEADER, IBUF)
      BUFSW = IBUF(1)
      CALL ZI16IL (1, 7, HEADER, IBUF)
      BUFSR = IBUF(1)
      IF (BUFSW.GT.0) CALL ZI16IL (BUFSW, 9, HEADER, BUFFER)
      CALL ZC8CL (10, 1, HEADER, XT)
      OP = XT(1:4)
      SUBNAM = XT(5:)
      DO 70 INAM = 1,NNAM
         IF (SUBNAM.EQ.NAMES(INAM)) GO TO 80
 70      CONTINUE
      WRITE (MSGTXT,1070) SUBNAM, OP
      CALL MSGWRT (6)
      IERR = 2
      GO TO 10
C                                       branch to interpret each
 80   GO TO (110, 120, 130, 140, 150, 160, 170, 180, 190, 200, 210,
     *   220, 230, 240, 250, 260, 270, 280, 290, 300, 310, 320, 330,
     *   340, 350, 360, 370, 380, 390, 400, 410, 420, 430, 440), INAM
C-----------------------------------------------------------------------
 110  CONTINUE
         CALL AALUCT (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 120  CONTINUE
         CALL ACHRW (OP, BUFSW, BUFSR, IBUF, IERR)
         GO TO 10
 130  CONTINUE
         CALL ACINIT (OP, BUFSW, BUFSR, IBUF, IERR)
         GO TO 10
 140  CONTINUE
         CALL ACNECT (OP, BUFSW, BUFSR, IBUF, IERR)
         GO TO 10
 150  CONTINUE
         CALL ACONST (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 160  CONTINUE
         CALL ACOVER (OP, BUFSW, BUFSR, IBUF, IERR)
         GO TO 10
 170  CONTINUE
         CALL ACRCTL (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 180  CONTINUE
         CALL ACREAD (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 190  CONTINUE
         CALL ACUCOR (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 200  CONTINUE
         CALL ACURSE (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 210  CONTINUE
         CALL ACWRIT (OP, BUFSW, BUFSR, IBUF, IERR)
         GO TO 10
 220  CONTINUE
         CALL AFDBCK (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 230  CONTINUE
         CALL AFILL (OP, BUFSW, BUFSR, IBUF, IERR)
         GO TO 10
 240  CONTINUE
         CALL AFIND (OP, BUFSW, BUFSR, IBUF, IERR)
         GO TO 10
 250  CONTINUE
         CALL AGRAFX (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 260  CONTINUE
         CALL AGRAPH (OP, BUFSW, BUFSR, IBUF, IERR)
         GO TO 10
 270  CONTINUE
         CALL AIFM (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 280  CONTINUE
         CALL AIMGIO (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 290  CONTINUE
         CALL AINIT (OP, BUFSW, BUFSR, IBUF, IERR)
         GO TO 10
 300  CONTINUE
         CALL ALOCAT (OP, BUFSW, BUFSR, IBUF, RBUF, IERR)
         GO TO 10
 310  CONTINUE
         CALL ALUT (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 320  CONTINUE
         CALL AMNMAX (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 330  CONTINUE
         CALL AOFM (OP, BUFSW, BUFSR, RBUF, IERR)
         GO TO 10
 340  CONTINUE
         CALL ARHIST (OP, BUFSW, BUFSR, IBUF, IERR)
         GO TO 10
 350  CONTINUE
         CALL ASCROL (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 360  CONTINUE
         CALL ASHIFT (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 370  CONTINUE
         CALL ASLECT (OP, BUFSW, BUFSR, IBUF, IERR)
         GO TO 10
 380  CONTINUE
         CALL ASPLIT (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 390  CONTINUE
         CALL ATVCLS (OP, BUFSW, BUFSR, IBUF, IERR)
         GO TO 10
 400  CONTINUE
         CALL ATVMC (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 410  CONTINUE
         CALL ATVOPN (OP, BUFSW, BUFSR, IBUF, IERR)
         GO TO 10
 420  CONTINUE
         CALL AWINDO (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 430  CONTINUE
         CALL AZERO (OP, BUFSW, BUFSR, IERR)
         GO TO 10
 440  CONTINUE
         CALL AZOOMC (OP, BUFSW, BUFSR, IERR)
         GO TO 10
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('WHOAMI ERROR',I5,' MUST USE DEFAULTS INCL TV NUMBER 1')
 1010 FORMAT ('ON ',A6,' OP= ',A4,' VTV-WRITE ERROR',I7)
 1050 FORMAT ('VTV-READ ERROR',I7)
 1070 FORMAT ('ROUTINE ',A6,'  OP= ',A4,' UNKNOWN - CONTINUING')
      END
      SUBROUTINE AALUCT (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YALUCT reads / writes the TV arithmetic logic unit control
C   registers.  The actual feedback-ALU computation is performed only
C   upon a call to YFDBCK.
C   Inputs:
C      OP      C*4     'READ' from TV or 'WRIT' to TV
C   In/Out:
C      ARMODE  L       T => arithmetic mode F => logic mode
C      BFUNC   I       function number (1-16) in blotch
C      NFUNC   I       function number (1-16) outside blotch
C      CONSTS  I(8)    constant array (may select as ALU output)
C      OUTSEL  I(8)    lookup table selects output based on carry
C                      (lsb), equal, ROI (msb) input. values -
C                      0 - 7 : constants 1 - 8
C                      8     : accumulator channel pair
C                      9     : selected OFM
C                      10    : ALU
C                      11    : external
C      EXTOFM  L       T => extend sign of OFM on input to ALU
C      ESHIFT  L       T => extend sign of ALU output if SHIFT
C      SHIFT   L       T => right shift ALU output
C      CARYIN  L       T => add one to arithmetic results
C   Output:
C      CARRY   L       T => carry condition occurred in frame
C      EQUAL   L       T => equal condition occurred in frame
C      IERR    I       error code of Z...XF : 0 - ok
C                                             2 - input error
C   Virtual TV version
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      LOGICAL   ARMODE, EXTOFM, ESHIFT, SHIFT, CARYIN, CARRY, EQUAL
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
C                                       Bad op if no ALU units
      IERR = 2
      IF (TVALUS.LE.0) GO TO 999
      IF ((BUFSR.NE.25) .AND. (BUFSW.NE.25)) GO TO 999
C                                       interpret BUFFER
      IF (OP.EQ.'WRIT') THEN
         ARMODE = BUFFER(1).EQ.1
         EXTOFM = BUFFER(20).EQ.1
         ESHIFT = BUFFER(21).EQ.1
         SHIFT = BUFFER(22).EQ.1
         CARYIN = BUFFER(23).EQ.1
         CARRY = BUFFER(24).EQ.1
         EQUAL = BUFFER(25).EQ.1
         END IF
C                                       call Y
      CALL YALUCT (OP, ARMODE, BUFFER(2), BUFFER(3), BUFFER(4),
     *   BUFFER(12), EXTOFM, ESHIFT, SHIFT, CARYIN, CARRY, EQUAL, IERR)
C                                       read: return control parms
      IF (IERR.EQ.0) THEN
         BUFFER(24)  = 0
         IF (CARRY)  BUFFER(24) = 1
         BUFFER(25) = 0
         IF (EQUAL) BUFFER(25) = 1
C                                       set buffer
         IF (OP.NE.'WRIT') THEN
            BUFFER(1) = 0
            IF (ARMODE) BUFFER(1) = 1
            BUFFER(20) = 0
            IF (EXTOFM) BUFFER(20) = 1
            BUFFER(21) = 0
            IF (ESHIFT) BUFFER(21) = 1
            BUFFER(22) = 0
            IF (SHIFT) BUFFER(22) = 1
            BUFFER(23) = 0
            IF (CARYIN) BUFFER(23) = 1
            END IF
C                                       reset buffer
         CALL MKYBUF (OP, 'YALUCT', BUFSR, BUFSW, BUFFER, HEADER)
         END IF
C
 999  RETURN
      END
      SUBROUTINE ACHRW (OP, BUFSW, BUFSR, SCRTCH, IERR)
C-----------------------------------------------------------------------
C   YCHRW  writes characters into image planes of the TV.  The format is
C   5 by 7 with one blank all around: net 7 in X by 9 in Y. This version
C   will work on all TVs which allow horizontal writing to the right. It
C   is a Y routine to allow for hardware character generators on the TV.
C   Inputs:
C      CHAN    I       channel select  (1 to NGRAY + NGRAPH)
C      X       I       X position lower left corner first char.
C      Y       I       Y position lower left corner first char.
C      STRING  C*(*)   character string - length passed from Fortran
C                      VTV - passes length in BUFFER(4) **
C   Output:
C      SCRTCH  I(>)    scratch buffer (dim = 14*count+8 < 1031)
C      IERR    I       error code of Z...XF:0 - ok
C                                           2 - input error
C   Virtual TV version is for TV by COMMUNICATION.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR, SCRTCH(*)
C
      REAL      XT(20)
      CHARACTER STRING*256
      INTEGER   IXT(20), I
      INCLUDE 'INCS:DVTV.INC'
      EQUIVALENCE (XT, IXT)
C-----------------------------------------------------------------------
      IERR = 2
      IF ((BUFSW.LT.4) .OR. (OP.NE.'WRIT')) GO TO 999
C                                       get string
      I = (BUFFER(4) - 1) / 2 + 1
      IF (BUFSW.NE.4+I) GO TO 999
      CALL ZILI16 (I, BUFFER(5), 1, IXT)
      I = BUFFER(4)
      CALL ZC8CL (I, 1, IXT, STRING)
C                                       do Y function
      CALL YCHRW (BUFFER(1), BUFFER(2), BUFFER(3), STRING(:I), SCRTCH,
     *   IERR)
C
 999  RETURN
      END
      SUBROUTINE ACINIT (OP, BUFSW, BUFSR, IBUF, IERR)
C-----------------------------------------------------------------------
C   Initialize image catalog for plane IPLANE - TK now done with TKCATL
C   Input:
C      IPLANE   I        Image plane to initialize
C   Output:
C      BUFF     I(256)   Working buffer
C   VIRTUAL TV version for TV by communication.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IBUF(*), IERR
C
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'WRIT') .OR. (BUFSW.NE.1)) GO TO 999
C
      CALL YCINIT (BUFFER(1), IBUF)
      IERR = 0
C
 999  RETURN
      END
      SUBROUTINE ACNECT (OP, BUFSW, BUFSR, LBUFF, IERR)
C-----------------------------------------------------------------------
C   YCNECT writes a line segment on the TV.  This version will work on
C   all TVs.  It is called a Y routine to allow the use of hardware
C   vector generators on those TVs equiped with them.
C   Inputs:
C      X1      I      start X position
C      Y1      I      start Y position
C      X2      I      end X position
C      Y2      I      end Y position
C      IC      I      Channel (1 to NGRAY+NGRAPH)
C      LBUFF   I(*)   Buffer contains desired intensity (size > max
C                     horizontal or vertical line, e.g., 1280)
C   Output:
C      IERR    I      error code : 0 => ok
C   Virtual TV version for TV by COMMUNICATION
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   LBUFF(*), IERR
C
      REAL      R
      INTEGER   I
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF (BUFSW.NE.6) GO TO 999
      IF (OP.NE.'WRIT') GO TO 999
C                                       do Y function
      R = (BUFFER(3)-BUFFER(1)) ** 2 + (BUFFER(4) - BUFFER(2)) ** 2 + 1.
      I = SQRT (ABS(R)) + 0.99
      CALL FILL (I, BUFFER(6), LBUFF)
      CALL YCNECT (BUFFER(1), BUFFER(2), BUFFER(3), BUFFER(4),
     *   BUFFER(5), LBUFF, IERR)
C
 999  RETURN
      END
      SUBROUTINE ACONST (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YCONST reads/writes the constants which are added to the 3 sum
C   channels on the TV.
C   Inputs:
C      OP      C*4   'READ' from TV, 'WRIT' to TV
C   In/out:
C      RCONST  I     constant for red channel
C      GCONST  I     constant for green channel
C      BCONST  I     constant for blue channel
C      VRTRTC  L     (could be Vertical retrace)
C   Output:
C      IERR    I     error code of Z...XF : 0 => ok
C   Virtual TV version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      LOGICAL   VRTRTC
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((BUFSR.NE.4) .AND. (BUFSW.NE.4)) GO TO 999
C                                       do it
      VRTRTC = BUFFER(1).EQ.1
      CALL YCONST (OP, BUFFER(2), BUFFER(3), BUFFER(4), VRTRTC, IERR)
C                                        header & IO
      CALL MKYBUF (OP, 'YCONST', BUFSR, BUFSW, BUFFER, HEADER)
C
 999  RETURN
      END
      SUBROUTINE ACOVER (OP, BUFSW, BUFSR, IBUF, IERR)
C-----------------------------------------------------------------------
C   YCOVER checks to see if there are partially replaced images in any
C   of the TV planes currently visible by quadrant
C   Outputs:
C      OVER   L(4)     T => there are in quadr. I
C      BUF    I(512)   scratch
C      IERR   I        Error code: 0 => ok, other catlg IO error
C   Virtual TV version for TV by communication.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IBUF(*), IERR
C
      LOGICAL   OVER(4)
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'READ') .OR. (BUFSR.NE.4)) GO TO 999
      CALL YCOVER (OVER, IBUF, IERR)
      BUFFER(1) = 0
      IF (OVER(1)) BUFFER(1) = 1
      BUFFER(2) = 0
      IF (OVER(2)) BUFFER(2) = 1
      BUFFER(3) = 0
      IF (OVER(3)) BUFFER(3) = 1
      BUFFER(4) = 0
      IF (OVER(4)) BUFFER(4) = 1
      CALL MKYBUF ('READ', 'YCOVER', BUFSR, BUFSW, BUFFER, HEADER)
C
 999  RETURN
      END
      SUBROUTINE ACRCTL (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YCRCTL reads/writes the cursor/trackball control register of TV
C   Inputs:
C      OP      C*4   'READ' from TV or 'WRIT' to TV
C      VRTRTC  L     T => do on vertical retrace only
C   In/out:
C      ON      L     T => cursor visible, F => off
C      X       I     X position cursor center (1-512, 1 => LHS)
C      Y       I     Y position cursor center (1-512, 1 => bot)
C      LINKX   L     T => trackball moves cursor in X
C      LINKY   L     T => trackball moves cursor in Y
C      RBLINK  I     rate of cursor blink: 0-3 no-fast blink
C   Output:
C      BUTTON  I     button value (0 - 15)
C      IERR    I     error code of Z...XF : 0 => ok
C                                           2 => input error
C   Virtual TV (by communication) version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      LOGICAL   ON, LINKX, LINKY, VRTRTC
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((BUFSW.NE.8) .AND. (BUFSR.NE.8)) GO TO 999
C                                       parse input buffer
      VRTRTC = BUFFER(1).EQ.1
      IF (OP.EQ.'WRIT') THEN
         ON = BUFFER(2).EQ.1
         LINKX = BUFFER(5).EQ.1
         LINKY = BUFFER(6).EQ.1
         END IF
C                                       do Y function
      CALL YCRCTL (OP, ON, BUFFER(3), BUFFER(4), LINKX, LINKY,
     *   BUFFER(7), BUFFER(8), VRTRTC, IERR)
C                                        return answers
      IF ((IERR.EQ.0) .AND. (OP.NE.'WRIT')) THEN
         BUFFER(2) = 0
         IF (ON) BUFFER(2) = 1
         BUFFER(5) = 0
         IF (LINKX) BUFFER(5) = 1
         BUFFER(6) = 0
         IF (LINKY) BUFFER(6) = 1
         CALL MKYBUF (OP, 'YCRCTL', BUFSR, BUFSW, BUFFER, HEADER)
         END IF
C
 999  RETURN
      END
      SUBROUTINE ACREAD (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   Read image catalog block into CATBLK - TV only (TK in TKCATL)
C   Inputs:
C      IPLANE  I       plane containing image whose block is wanted
C      IX      I       X pixel coordinate of a point within image
C      IY      I       Y pixel coordinate of point within image
C   Outputs:
C      CATBLK  I(256)  Image catalog block
C      IERR    I       error codes: 0 => ok
C                         1 => IX, IY lies outside image
C                         2 => Catalog i/o errors
C                         3 => refers to TK device
C   VERSION for TV by COMMUNICATION
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      INTEGER   CATI(256)
      HOLLERITH CATH(256)
      REAL      CATR(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DVTV.INC'
      EQUIVALENCE (CATI, CATH, CATR, CATD, BUFFER(1025))
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'READ') .OR. (BUFSR.NE.302)) GO TO 999
C                                       do request
      CALL YCREAD (BUFFER(1), BUFFER(2), BUFFER(3), CATI, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       pack header
      CALL HDRBUF (1, CATI, CATH, CATR, CATD, BUFFER(4))
      CALL MKYBUF ('READ', 'YCREAD', BUFSR, BUFSW, BUFFER, HEADER)
C
 999  RETURN
      END
      SUBROUTINE ACUCOR (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YCUCOR takes a cursor position (corrected for zoom, but not scroll)
C   corrects it for scroll, determines the quadrant of the TV, and gets
C   the corresponding image header in common /MAPHDR/ and returns the
C   image coordinates.
C   NOTE WELL: RPOS ON INPUT MUST BE CORRECTED FOR ZOOM AND NOT SCROLL.
C   To get this from a raw TV position call YCURSE with OPCODE 'FXIT'
C   (or, of course, 'READ') and quadrant set to -1.    *************
C   Inputs:
C      RPOS    R(2)    X,Y screen pos before  zoom & scroll
C   Output:
C      QUAD    I       TV quadrant to use for scrolls
C                      Out: if in=-1, no scroll, else find quadrant
C                           (needs real TV pos)
C      CORN    R(7)    Image coordinates (pixels)
C      IERR    I       error code of Z...XF : 0 - ok
C                                             2 - input error
C   VIRTUAL TV version for TV by communication.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      REAL      RPOS(2), CORN(7)
      INTEGER   I, J
      INCLUDE 'INCS:DVTV.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'READ') .OR. (BUFSR.NE.318)) GO TO 999
      RPOS(1) = BUFFER(1) + BUFFER(2) / 1000.0
      RPOS(2) = BUFFER(3) + BUFFER(4) / 1000.0
      CALL YCUCOR (RPOS, BUFFER(5), CORN, IERR)
C                                       send back
      IF (IERR.EQ.0) THEN
         DO 10 I = 1,7
            J = 2 * I + 4
            BUFFER(J) = CORN(I)
            BUFFER(J+1) = 1000.0 * (CORN(I) - BUFFER(J))
 10         CONTINUE
         CALL HDRBUF (1, CATBLK, CATH, CATR, CATD, BUFFER(20))
         CALL MKYBUF ('READ', 'YCUCOR', BUFSR, BUFSW, BUFFER, HEADER)
         END IF
C
 999  RETURN
      END
      SUBROUTINE ACURSE (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YCURSE reads cursor positions and controls the blink and visibility
C   of the TV cursor.
C   Inputs:
C      OP      C*4     'READ' read cursor position
C                      'ONNN' place cursor at RPOS & leave on
C                      'OFFF' turn cursor off
C                      'BLNK' reverse sense of cursor blink
C                      'FXIT' fix RPOS for zoom scroll, no IO
C      WAIT    L       wait for event; then return RPOS & BUTTON
C                      (done on all OPs)
C      CORR    L       T => correct RPOS for zoom & scroll
C   In/Out:
C      RPOS    R(2)    X,Y screen pos before  zoom & scroll
C      QUAD    I       TV quadrant to use for scrolls
C                         In: if <1 >4, no scroll
C                         Out: if in=-1, no scroll, else find
C                              quadrant (needs real TV pos)
C   Output:
C      BUTTON  I       event # (0 none, 1-7 low buttons,
C                      8-15 the "quit" button)
C      IERR    I       error code of Z...XF : 0 - ok
C                                             2 - input error
C   Virtual TV version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      CHARACTER ROP*4, OPCODE(5)*4
      REAL      RPOS(2), T
      INTEGER   IROUND
      LOGICAL   WAIT, CORR
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DVTV.INC'
      DATA OPCODE /'READ','ONNN','OFFF','BLNK','FXIT'/
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'READ') .OR. (BUFSR.NE.9) .OR. (BUFSW.NE.9)) GO TO 999
C                                       do call
      ROP = OPCODE(BUFFER(1)+1)
      WAIT = BUFFER(2).GT.0
      CORR = BUFFER(3).GT.0
      RPOS(1) = BUFFER(4) + BUFFER(5) / 1000.0
      RPOS(2) = BUFFER(6) + BUFFER(7) / 1000.0
      CALL YCURSE (ROP, WAIT, CORR, RPOS, BUFFER(8), BUFFER(9), IERR)
      IF (IERR.NE.0) GO TO 999
C                                       returns
      BUFFER(4) = RPOS(1)
      T = 1000.0 * (RPOS(1) - BUFFER(4))
      BUFFER(5) = IROUND (T)
      BUFFER(6) = RPOS(2)
      T = 1000.0 * (RPOS(2) - BUFFER(6))
      BUFFER(7) = IROUND (T)
      CALL MKYBUF ('READ', 'YCURSE', BUFSR, BUFSW, BUFFER, HEADER)
C
 999  RETURN
      END
      SUBROUTINE ACWRIT (OP, BUFSW, BUFSR, IBUF, IERR)
C-----------------------------------------------------------------------
C   Write image catalog block in CATBLK into image catalog
C   Inputs:
C      IPLANE   I        image plane involved
C      IMAWIN   I(4)     Corners of image on screen
C      CATBLK   I(256)   Image catalog block
C  Outputs:
C      BUFF     I(256)   working buffer
C      IERR     I        error code: 0 => ok
C                           1 => no room in catalog
C                           2 => IO problems
C   Virtual TV version for TV by communication.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IBUF(256), IERR
C
      REAL      CATR(256)
      INTEGER   CATI(256), I
      DOUBLE PRECISION CATD(128)
      HOLLERITH CATH(256)
      INCLUDE 'INCS:DVTV.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (CATI, CATH, CATR, CATD, BUFFER(1025))
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'WRIT') .OR. (BUFSW.NE.304)) GO TO 999
C                                       unpack header
      CALL HDRBUF (2, CATI, CATH, CATR, CATD, BUFFER(6))
      CALL YCWRIT (BUFFER(1), BUFFER(2), CATI, IBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) (BUFFER(I), I = 1,5)
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ACWRIT: IPLANE, IMAWIN =',I5,2X,4I7)
      END
      SUBROUTINE AFDBCK (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YFDBCK sends a feedback command to the TV
C   Inputs:
C      COLOR   I    bit map of color to be fedback (RGB = 4,2,1)
C      CHANNL  I    bit map of channels to receive feedback
C      BITPL   I    bit map of bit planes to receive feedback
C      PIXOFF  I    offset fedback image to left by 0 - 1 pixels
C      BYPIFM  L    F => image goes thru IFM lookup before store
C      EXTERN  L    T => image from external input (iedigitizer)
C      ZERO    L    T => feed back all zeros
C      ACCUM   L    T => use 16-bit accumulator mode then CHANNL must
C                        give even-odd pair lsbyte goes to even (lower)
C                        # channel
C      ADDWRT  L    T => additive write  F => replace old data
C   Outputs:
C      IERR    I    error code of Z...XF: 0 -> ok
C                                         2 -> input error
C   Virtual TV version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      LOGICAL   BYPIFM, EXTERN, ZERO, ACCUM, ADDWRT
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'WRIT') .OR. (BUFSW.NE.9)) GO TO 999
      BYPIFM = BUFFER(5).GT.0
      EXTERN = BUFFER(6).GT.0
      ZERO = BUFFER(7).GT.0
      ACCUM = BUFFER(8).GT.0
      ADDWRT = BUFFER(9).GT.0
      CALL YFDBCK (BUFFER(1), BUFFER(2), BUFFER(3), BUFFER(4),
     *   BYPIFM, EXTERN, ZERO, ACCUM, ADDWRT, IERR)
C
 999  RETURN
      END
      SUBROUTINE AFILL (OP, BUFSW, BUFSR, IBLK, IERR)
C-----------------------------------------------------------------------
C   YFILL will write a constant in a given rectangle in a given graphics
C   or image plane.  It will use fast methods if full screen requested
C   with IVAL 0.
C   Inputs:
C      CHAN     I   Channel (1 to NGRAY+NGRAPH)
C      IX0      I   lower left X pixel (1 relative) of rectangle
C      IY0      I   lower left Y pixel of rectangle.
C      IXT      I   top right X pixel of rectangle.
C      IYT      I   top right Y pixel of rectangle.
C      IVAL     I   desired value: for graphics = 0 or 1
C                                  for grey scale = 0 - MAXINT
C   In/out:
C      IBLK     I(IXT-IX0+1)   work buffer.
C   Output:
C      IERR     I   error code of Z...XF: 0 ok, 2 input error
C   Virtual TV (by communication) version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IBLK(*), IERR
C
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'WRIT') .OR. (BUFSR.NE.0) .OR. (BUFSW.NE.6)) GO TO 999
C
      CALL YFILL (BUFFER(1), BUFFER(2), BUFFER(3), BUFFER(4), BUFFER(5),
     *   BUFFER(6), IBLK, IERR)
C
 999  RETURN
      END
      SUBROUTINE AFIND (OP, BUFSW, BUFSR, SCRTCH, IERR)
C-----------------------------------------------------------------------
C   YFIND determines which of the visible TV images the user wishes
C   to select.  The TV must already be open.
C   Inputs:
C      MAXPL   I        Highest plane number allowed (i.e. do graphics
C                       count?)
C      TYPE    C*2      2-char image type to restrict search
C   Output:
C      IPL     I        Plane number found
C      UNIQUE  L        T => only one image visible now
C                           (all types except zeroed ones ('ZZ'))
C      CATBLK  I(256)   Image catalog block found
C      SCRTCH  I(256)   Scratch buffer
C      IERR    I        Error code: 0 => ok
C                          1 => no image
C                          2 => IO error in image catalog
C                          3 => TV error
C                         10 => > 1 image of requested type
C   Virtual TV version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   SCRTCH(*), IERR
C
      CHARACTER TYPE*2
      LOGICAL   UNIQUE
      INTEGER   CATI(256), IXT(10)
      REAL      CATR(256)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DVTV.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (CATI, CATH, CATR, CATD, BUFFER(1025))
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'READ') .OR. (BUFSR.NE.303)) GO TO 999
C                                       set up write
      CALL ZILI16 (1, BUFFER(2), 1, IXT)
      CALL ZC8CL (2, 1, IXT, TYPE)
      CALL YFIND (BUFFER(1), TYPE, BUFFER(3), UNIQUE, CATI, SCRTCH,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) BUFFER(1), BUFFER(2), BUFFER(2), TYPE
         CALL MSGWRT (7)
C                                       return answers
      ELSE
         BUFFER(4) = 0
         IF (UNIQUE) BUFFER(4) = 1
         CALL HDRBUF (1, CATI, CATH, CATR, CATD, BUFFER(5))
         CALL MKYBUF ('READ', 'YFIND', BUFSR, BUFSW, BUFFER, HEADER)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AFIND ERR ON ',2I7,2(2X,'''',A2,''''))
      END
      SUBROUTINE AGRAFX (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YGRAFX modifies the colour of the graphics or cursor.
C   Inputs:
C      OP       C*4   READ or WRITE graphics colour assignment.
C      GRFX     I     Cursor (0), or graphics plane number.
C   In/Out:
C      RED      R     Red,   0.0 - 1.0
C      GREEN    R     Green, 0.0 - 1.0
C      BLUE     R     Blue,  0.0 - 1.0
C   Output:
C      IERR     I     Error status, 0 means success.
C   Version for Virtual TV devices.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      REAL      BLUE, GREEN, RED
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IF (OP.EQ.'WRIT') THEN
         RED = BUFFER(2) / 10000.0
         GREEN = BUFFER(3) / 10000.0
         BLUE = BUFFER(4) / 10000.0
         END IF
C                                       do it
      CALL YGRAFX (OP, BUFFER(1), RED, GREEN, BLUE, IERR)
C                                       return
      IF (IERR.EQ.0) THEN
         IF (OP.EQ.'WRIT') THEN
            BUFFER(2) = RED * 10000.0 + 0.5
            BUFFER(3) = GREEN * 10000.0 + 0.5
            BUFFER(4) = BLUE * 10000.0 + 0.5
            END IF
         CALL MKYBUF (OP, 'YGRAFX', BUFSR, BUFSW, BUFFER, HEADER)
         END IF
C
 999  RETURN
      END
      SUBROUTINE AGRAPH (OP, BUFSW, BUFSR, IBUF, IERR)
C-----------------------------------------------------------------------
C   YGRAPH is used to turn graphics overlay planes on & off by
C   altering the graphics color look up table.  The color pattern is:
C      CHAN = 1    insert   yellow            drawing plots
C             2    insert   green+.05 red     axis labels
C             3    insert   blue + 0.6 green  blotch
C                           + red
C             4    insert   black             label backgrounds
C             5-7  add      nothing           null channels
C             8    insert   purple            cursor
C   Inputs:
C      OP      C*4       'ONNN' or 'OFFF'
C                        'INIT' also allowed, though should only be
C                        secondary and hence not used in VTV
C      CHAN    I         channel number (1 - 8)
C   Output:
C      SCRTCH  I(256)    scratch buffer
C      IERR    I         error code of Z...XF: 0 => ok
C                                              2 => input error
C   Virtual TV version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IBUF(256), IERR
C
      CHARACTER ROP*4
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
C                                        check input
      IERR = 2
      IF ((OP.NE.'WRIT') .OR. (BUFSW.NE.2)) GO TO 999
C                                        do it
      IF (BUFFER(1).EQ.1) THEN
         ROP = 'ONNN'
      ELSE IF (BUFFER(1).EQ.2) THEN
         ROP = 'INIT'
      ELSE
         ROP = 'OFFF'
         END IF
      CALL YGRAPH (ROP, BUFFER(2), IBUF, IERR)
C
 999  RETURN
      END
      SUBROUTINE AIFM (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YIFM reads/writes a section of TV input function memory.  This
C   look up table takes 13 bits in and gives 8 bits out.
C   Inputs:
C      OP      C*4    'READ' from TV or 'WRIT' to TV
C      START   I      start address of IFM (1 - 8192)
C      COUNT   I      # elements of IFM to transfer (1-8192)
C      PACK    L      T => 2 values/word, F => 1 value/word
C      VRTRTC  L      T => do it only on vertical retrace
C   In/Out:
C      IFM     I(*)   function values (0-255)
C   Output:
C      IERR    I      error code of Z...XF: 0 - ok
C                                           2 - input error
C   Virtual TV version (TV by communication)
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      LOGICAL   PACK, VRTRTC
      INTEGER   I
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
C                                       check
      IERR = 2
C                                       Get parms
      PACK = BUFFER(3).EQ.1
      VRTRTC = BUFFER(4).EQ.1
      I = BUFFER(2) - BUFFER(1) + 1
      IF (PACK) I = (I + 1) / 2
      IF ((OP.EQ.'WRIT') .AND. (BUFSW.NE.4+I)) GO TO 999
      IF ((OP.NE.'WRIT') .AND. (BUFSR.NE.4+I)) GO TO 999
C                                       do it
      CALL YIFM (OP, BUFFER(1), BUFFER(2), PACK, VRTRTC, BUFFER(5),
     *   IERR)
C                                       return parms
      IF (IERR.EQ.0) CALL MKYBUF (OP, 'YIFM', BUFSR, BUFSW, BUFFER,
     *   HEADER)
C
 999  RETURN
      END
      SUBROUTINE AIMGIO (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YIMGIO reads/writes a line of image data to the TV screen.  For
C   graphics overlay planes, the data are solely 0's and 1's in the
C   least significant bit of IMAGE after a READ.  For 'WRIT', all bits
C   of each word should be equal (i.e. all 1's or all 0's for graphics).
C   NOTE***** on 'WRIT', the buffer may be altered by this routine for
C   some IANGLs.
C   Inputs:
C      OP      C*4       'READ' from TV or 'WRIT' to TV
C      CHAN    I         channel number (1 to NGRAY+NGRAPH)
C      X       I         start pixel position
C      Y       I         end pixel position
C      IANGL   I         = 0 => horizontal (to right)
C                        = 1 => vertical (up the screen)
C                        = 2 => horizontal (to left)
C                        = 3 => vertical (down the screen)
C      NPIX    I         number of pixels
C   In/Out:
C      IMAGE   I(NPIX)   data (only no header)
C   Output:
C      IERR    I         error code of Z...XF - 0 => ok
C                                                  2 => input err
C   Virtual TV version (for TV by communication).
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
C                                        check input
      IERR = 2
      IF ((OP.NE.'READ') .AND. (OP.NE.'WRIT')) GO TO 999
      IF ((OP.EQ.'WRIT') .AND. (BUFSW.NE.5+BUFFER(5))) GO TO 999
      IF ((OP.EQ.'READ') .AND. (BUFSR.NE.5+BUFFER(5))) GO TO 999
C                                       do I/O
      CALL YIMGIO (OP, BUFFER(1), BUFFER(2), BUFFER(3), BUFFER(4),
     *   BUFFER(5), BUFFER(6), IERR)
      IF ((IERR.EQ.0) .AND. (OP.NE.'WRIT')) CALL MKYBUF (OP, 'YIMGIO',
     *   BUFSR, BUFSW, BUFFER, HEADER)
C
 999  RETURN
      END
      SUBROUTINE AINIT (OP, BUFSW, BUFSR, IBUF, IERR)
C-----------------------------------------------------------------------
C   YINIT initializes the TV subunits: doing everything
C   Output:
C      SCRTCH  I(1024)    scratch buffer
C      IERR    I          error code of Z...XF - 0 => ok
C                                                2 => input error
C   Virtual TV version for TV by communication
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IBUF(*), IERR
C
      INTEGER   IDUM(256)
      INCLUDE 'INCS:DVTV.INC'
      INCLUDE 'INCS:DTVC.INC'
      EQUIVALENCE (NGRAY, IDUM)
C-----------------------------------------------------------------------
C                                       do it first
      IERR = 2
      IF ((BUFSR.NE.256) .OR. (OP.NE.'READ')) GO TO 999
      CALL YINIT (IBUF, IERR)
C                                       return the common
      CALL MKYBUF (OP, 'YINIT', BUFSR, BUFSW, IDUM, HEADER)
C
 999  RETURN
      END
      SUBROUTINE ALOCAT (OP, BUFSW, BUFSR, IBUF, RBUF, IERR)
C-----------------------------------------------------------------------
C   YLOCAT locates a set of image pixel positions on the TV for a
C   specified image using only those grey planes that are turned on.
C   Inputs:
C      NP      I         Number of pixel positions
C      XP      R(NP)     X image pixel positions
C      YP      R(NP)     Y image pixel positions
C      NAME    C*12      Packed image name (name) '    ' => any
C      CLASS   C*6       Packed image name (class) '    ' => any
C      SEQ     I         Image name (sequence #)  0 => any
C      DISK    I         Image file disk 0 => any
C      PTYP    C*2       Image type  '  ' => any
C   Output:
C      IX      I(NP)     TV x positions
C      IY      I(NP)     TV y positions
C      IQ      I(NP)     TV channels  0 => none this position
C      IERR    I         Error code: 0 -> ok
C                           2 -> input error
C                           3 -> IO error
C                          11 -> some positions bad
C                          12 -> no positions found
C   Uses common /MAPHDR/ results unpredictable except on IERR = 0
C   then = image catlg header of last position found.
C   Virtual TV version (TV by communication).
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IBUF(*), IERR
      REAL      RBUF(*)
C
      CHARACTER NAME*12, CLASS*6, XT*20, PTYP*2
      INTEGER   NP, I, IXT(10), IP
      INCLUDE 'INCS:DVTV.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF (OP.NE.'READ') GO TO 999
      NP = BUFFER(1)
      IF (BUFSR.NE.13+299+7*NP) GO TO 999
C                                       unpack inputs
      CALL ZILI16 (10, BUFFER(2), 1, IXT)
      CALL ZC8CL (20, 1, IXT, XT)
      NAME = XT(1:12)
      CLASS = XT(13:18)
      PTYP = XT(19:20)
      IP = 14
      DO 20 I = 1,NP
         RBUF(I) = BUFFER(IP) + BUFFER(IP+1) / 1000.0
         RBUF(I+NP) = BUFFER(IP+2) + BUFFER(IP+3) / 1000.0
         IP = IP + 4
 20      CONTINUE
      CALL YLOCAT (NP, RBUF(1), RBUF(NP+1), NAME, CLASS, BUFFER(12),
     *   BUFFER(13), PTYP, BUFFER(IP), BUFFER(IP+NP), BUFFER(IP+2*NP),
     *   IBUF, IERR)
C                                       pack returns
      IF ((IERR.EQ.0) .OR. (IERR.EQ.11)) THEN
         IP = IP + 3 * NP
         CALL HDRBUF (1, CATBLK, CATH, CATR, CATD, BUFFER(IP))
         CALL MKYBUF ('READ', 'YLOCAT', BUFSR, BUFSW, BUFFER, HEADER)
         END IF
C
 999  RETURN
      END
      SUBROUTINE ALUT (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YLUT reads/writes full channel look up tables to TV.
C   Inputs:
C      OP      C*4    'READ' from TV, 'WRIT' to TV
C      CHANNL  I      channel select bit mask
C      COLOR   I      color select bit mask (RGB <-> 421)
C      VRTRTC  L      T => do it only during vertical retrace
C   In/Out:
C      LUT     I(*)   look up table (dimension = MAXINT+1, values to
C                     LUTOUT are used)
C   Out:
C      IERR    I      error code of Z...XF : 0 => ok, 2 => input error
C   VIRTUAL TV (by communication) version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      INTEGER   I
      LOGICAL   VRTRTC
      INCLUDE 'INCS:DVTV.INC'
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
      IERR = 2
      I = MAXINT + 1
      IF ((OP.NE.'READ') .AND. (BUFSW.NE.3+I)) GO TO 999
      IF ((OP.EQ.'READ') .AND. (BUFSR.NE.3+I)) GO TO 999
C                                       do it
      VRTRTC = BUFFER(3).EQ.1
      CALL YLUT (OP, BUFFER(1), BUFFER(2), VRTRTC, BUFFER(4), IERR)
C                                       return
      IF (IERR.EQ.0) CALL MKYBUF (OP, 'YLUT', BUFSR, BUFSW, BUFFER,
     *   HEADER)
C
 999  RETURN
      END
      SUBROUTINE AMNMAX (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YMNMAX reads the min & max values put out by the 3 summers (before
C   application of constants, shifts and OFM) from the TV
C   Inputs:
C      VRTRTC  L    do it on vertical retrace only
C   Output:
C      RMIN    I    red minimum
C      RMAX    I    red maximum
C      GMIN    I    green minimum
C      GMAX    I    green maximum
C      BMIN    I    blue minimum
C      BMAX    I    blue maximum
C      IERR    I    error code of Z...XF : 0 => ok, 2 => input error
C   Virtual TV (by communication) version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      LOGICAL   VRTRTC
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'READ') .OR. (BUFSR.NE.7)) GO TO 999
C                                       do it
      VRTRTC = BUFFER(1).EQ.1
      CALL YMNMAX (BUFFER(2), BUFFER(3), BUFFER(4), BUFFER(5),
     *   BUFFER(6), BUFFER(7), VRTRTC, IERR)
      CALL MKYBUF ('READ', 'YMNMAX', BUFSR, BUFSW, BUFFER, HEADER)
C
 999  RETURN
      END
      SUBROUTINE AOFM (OP, BUFSW, BUFSR, RBUF, IERR)
C-----------------------------------------------------------------------
C   YOFM reads/writes full OFM look up tables to TV.
C   Inputs:
C      OP      C*4    'READ' from TV, 'WRIT' to TV
C      COLOR   I      color select bit mask (RGB <-> 421)
C      VRTRTC  L      T => do it only during vertical retrace
C   In/Out:
C      OFM     R(*)   look up table (dimension = OFMINP+1, values 0
C                     through 1 are used, others clipped)
C   Output:
C      IERR    I      error code of Z...XF : 0 => ok, 2 => input error
C   Virtual TV (by communication) version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
      REAL      RBUF(*)
C
      INTEGER   I, J
      LOGICAL   VRTRTC
      INCLUDE 'INCS:DVTV.INC'
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
      IERR = 2
      J = OFMINP + 1
      IF ((OP.EQ.'WRIT') .AND. (BUFSW.NE.J+2)) GO TO 999
      IF ((OP.NE.'WRIT') .AND. (BUFSR.NE.J+2)) GO TO 999
C                                       do it
      VRTRTC = BUFFER(2).EQ.1
      IF (OP.EQ.'WRIT') THEN
         DO 10 I = 1,J
            RBUF(I) = BUFFER(I+2) / 10000.0
 10         CONTINUE
         END IF
      CALL YOFM (OP, BUFFER(1), VRTRTC, RBUF, IERR)
      IF ((IERR.EQ.0) .AND. (OP.NE.'WRIT')) THEN
         DO 20 I = 1,J
             BUFFER(I+2) = MAX (0.0, MIN (1.0, RBUF(I))) * 10000.0
 20          CONTINUE
         CALL MKYBUF (OP, 'YOFM', BUFSR, BUFSW, BUFFER, HEADER)
         END IF
C
 999  RETURN
      END
      SUBROUTINE ARHIST (OP, BUFSW, BUFSR, SCRTCH, IERR)
C-----------------------------------------------------------------------
C   YRHIST reads the histogram of the output of a selected OFM of the
C   TV.   Intensity values 0 through OFMOUT may be read.
C   Inputs:
C      MODE    I         selects area to histogram: 0 blotch,
C                        1 not blotch, 2 all, 3 external blotch
C      COLOR   I         bit map of single color (RGB - 4,2,1)
C      INITI   I         first intensity to histo (1 - 1024)
C      NINT    I         # values to get
C   Output:
C      HISTOG  I(NINT)   histogram
C      IERR    I         error code of Z...XF : 0 => ok, 2 => input err
C   Virtual TV version (TV by communication).  Requires 2 words per
C   value in the transmission part since 16-bit integers are used there.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   SCRTCH(*), IERR
C
      INTEGER   J, ISC, NINT, I
      INCLUDE 'INCS:DVTV.INC'
      DATA ISC /16384/
C-----------------------------------------------------------------------
C                                        check errors
      IERR = 2
      NINT = BUFFER(4)
      IF ((OP.NE.'READ') .OR. (BUFSR.NE.2*NINT+4)) GO TO 999
      CALL YRHIST (BUFFER(1), BUFFER(2), BUFFER(3), NINT, SCRTCH, IERR)
C                                       return values (go in 16-bit int)
      IF (IERR.EQ.0) THEN
         J = 5
         DO 10 I = 1,NINT
            BUFFER(J) = SCRTCH(I) / ISC
            BUFFER(J+1) = MOD (SCRTCH(I), ISC)
            J = J + 2
 10         CONTINUE
         CALL MKYBUF ('READ', 'YRHSIT', BUFSR, BUFSW, BUFFER, HEADER)
         END IF
C
 999  RETURN
      END
      SUBROUTINE ASCROL (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YSCROL writes the scroll registers on the TV.
C   Inputs:
C      CHANNL   I   bit map channel select: bits 1-NGRAY gray channels,
C                   bit NGRAY+1 => all graphics
C      VRTRTC   L   T => do it on vertical retrace only
C   In/Out:
C      SCROLX   I   amount of X scroll (>0 to right)
C      SCROLY   I   amount of Y scroll (>0 upwards)
C   Output:
C      IERR     I   error from Z...XF : 0 => ok, 2 => input error
C   YSCROL updates the scroll variables in /TVDEV/ common
C   Virtual TV version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      LOGICAL   VRTRTC
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'READ') .OR. (BUFSR.NE.4)) GO TO 999
C                                        header & IO
      VRTRTC = BUFFER(4).EQ.1
      CALL YSCROL (BUFFER(1), BUFFER(2), BUFFER(3), VRTRTC, IERR)
      IF (IERR.EQ.0) CALL MKYBUF ('READ', 'YSCROL', BUFSR, BUFSW,
     *   BUFFER, HEADER)
C
 999  RETURN
      END
      SUBROUTINE ASHIFT (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YSHIFT reads/writes the TV shift registers - which shift the
C   13-bit output of the adders before entry into the 10-bit OFM
C   Inputs:
C      OP      C*4   'READ' from TV or 'WRIT' to TV
C      VRTRTC  L     T => do on vertical retrace only
C   In/Out:
C      SHIFTR  I     # bits to shift (right) red channel
C      SHIFTG  I     # bits to shift green channel
C      SHIFTB  I     # bits to shift blue channel
C   Output:
C      IERR    I     error code of Z...XF : 0 - ok, 2 - input error
C   TV by communication version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      LOGICAL   VRTRTC
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.EQ.'WRIT') .AND. (BUFSW.NE.4)) GO TO 999
      IF ((OP.NE.'WRIT') .AND. (BUFSR.NE.4)) GO TO 999
C                                       do it
      VRTRTC = BUFFER(1).EQ.1
      CALL YSHIFT (OP, BUFFER(2), BUFFER(3), BUFFER(4), VRTRTC, IERR)
      IF (IERR.EQ.0) CALL MKYBUF (OP, 'YSHIFT', BUFSR, BUFSW, BUFFER,
     *   HEADER)
C
 999  RETURN
      END
      SUBROUTINE ASLECT (OP, BUFSW, BUFSR, LBUFF, IERR)
C-----------------------------------------------------------------------
C   YSLECT enables and disables gray and graphics planes
C   Inputs:
C      OP       C*4      'ONNN' or 'OFFF'
C      CHAN     I        channel number ( 1 to NGRAY+NGRAPH)
C      COLOR    I        0 - all,   1,2,3 = R,G,B, resp.
C   Output:
C      LBUFF    I(256)   scratch buffer (for graphics only)
C      IERR     I        error code of Z...XF: 0 - ok, 2 - input error
C   YSLECT sets TVLIMG in the TV device parms common /TVDEV/
C   Virtual TV version (TV by communication).
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   LBUFF(*), IERR
C
      CHARACTER OPR*4
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
C                                        check input
      IERR = 2
      IF ((OP.NE.'WRIT') .OR. (BUFSW.NE.3)) GO TO 999
C                                       send parms
      OPR = 'OFFF'
      IF (BUFFER(1).EQ.1) OPR = 'ONNN'
      CALL YSLECT (OPR, BUFFER(2), BUFFER(3), LBUFF, IERR)
C
 999  RETURN
      END
      SUBROUTINE ASPLIT (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YSPLIT reads/writes the look up table/ split screen control
C   registers of the TV - turns channels on/off by quadrant
C   Inputs:
C      OP       C*4    'READ' from TV, 'WRIT' to TV
C      VRTRTC   L      T => do on vertical retrace only
C   In/Out:
C      XSPLT    I      X position of split (1-512, 1 => LHS)
C      YSPLT    I      Y position of split (1-512, 1 => bot)
C      RCHANS   I(4)   chan select bit mask 4 quadrants : red
C      GCHANS   I(4)   chan select bit mask 4 quadrants : green
C      BCHANS   I(4)   chan select bit mask 4 quadrants : blue
C   Output:
C      IERR     I      error code of Z...XF: 0 => ok, 2 => input error
C   Quadrants are numbered CCW from top right!!!!
C   Version for TV by communication
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      LOGICAL   VRTRTC
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.EQ.'WRIT') .AND. (BUFSW.NE.15)) GO TO 999
      IF ((OP.NE.'WRIT') .AND. (BUFSR.NE.15)) GO TO 999
C                                       do it
      VRTRTC = BUFFER(1).EQ.1
      CALL YSPLIT (OP, BUFFER(2), BUFFER(3), BUFFER(4), BUFFER(8),
     *   BUFFER(12), VRTRTC, IERR)
      IF ((IERR.EQ.0) .AND. (OP.NE.'WRIT')) CALL MKYBUF (OP, 'YSPLIT',
     *   BUFSR, BUFSW, BUFFER, HEADER)
C
 999  RETURN
      END
      SUBROUTINE ATVCLS (OP, BUFSW, BUFSR, BUF, IERR)
C-----------------------------------------------------------------------
C   YTVCLS closes the TV device and the TV status disk file, updating
C   the information on the disk.  Actual device call done by YTVCL2.
C   Outputs:
C      BUF   I(256)     Scratch buffer
C      IERR  I          Error code : 0 => ok
C                          else as returned by ZFIO
C                          11 => close disk error
C                          12 => close device error
C   Virtual TV (by communication) version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   BUF(*), IERR
C
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'WRIT') .OR. (BUFSW.NE.0)) GO TO 999
C                                       close disk and device
      CALL TVCLOS (BUF, IERR)
C
 999  RETURN
      END
      SUBROUTINE ATVMC (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YTVMC issues a "master clear" to the TV.  This resets the TV IO
C   system (if necessary) to expect a command record next.
C   YTVMC gets all needed parameters from the TV device common.
C   The TV must already be open.
C   Virtual TV (by communications) version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'WRIT') .OR. (BUFSR.NE.0) .OR. (BUFSW.NE.0)) GO TO 999
      CALL YTVMC
      IERR = 0
C
 999  RETURN
      END
      SUBROUTINE ATVOPN (OP, BUFSW, BUFSR, BUF, IERR)
C-----------------------------------------------------------------------
C   YTVOPN opens the TV including TV lock/parameter file and reads the
C   parameters, placing them in commons.
C   Outputs:
C      BUF   I(256)   Scratch buffer
C      IERR  I        Error return from YTVOP2
C                        = 10 TV unavailable to this version
C   Virtual TV version - from the wire.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   BUF(*), IERR
C
      INTEGER   IDUM(256)
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DVTV.INC'
      EQUIVALENCE (IDUM, NGRAY)
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'READ') .OR. (BUFSR.NE.256)) GO TO 999
      CALL TVOPEN (BUF, IERR)
      IF (IERR.EQ.0) CALL MKYBUF ('READ', 'YTVOPN', BUFSR, BUFSW, IDUM,
     *   HEADER)
C
 999  RETURN
      END
      SUBROUTINE AWINDO (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YWINDO reads the current viewport into the TV memory.  It is hoped
C   that someday we will also offer writing to force the size.
C   Inputs:
C      OPER   C*4    'READ', 'WRIT'
C   In/out:
C      WIND   I(4)   BLC x,y, TRC x,y of window in TV pixels
C                    In: desired window ('WRIT' only)
C                    Out: actual window given
C   Output:
C      IERR    I     error code of Z...XF: 0 -> ok, 2 -> input error
C   Virtual TV version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'READ') .AND. (OP.NE.'WRIT')) GO TO 999
      IF ((BUFSR.NE.4) .OR. (BUFSW.NE.4)) GO TO 999
C                                       do it
      CALL YWINDO (OP, BUFFER, IERR)
      IF (IERR.EQ.0) CALL MKYBUF (OP, 'YWINDO', BUFSR, BUFSW, BUFFER,
     *   HEADER)
C
 999  RETURN
      END
      SUBROUTINE AZERO (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YZERO fills an TV TV memory plane with zeros the fast way.
C   Inputs:
C      CHAN   I     channel # ( 1 - NGRAY+NGRAPH), 0 => all
C   Outputs:
C      IERR   I     error code of Z...XF: 0 - ok, 2 - input error
C   Virtual TV version
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'WRIT') .OR. (BUFSW.NE.1)) GO TO 999
C
      CALL YZERO (BUFFER(1), IERR)
C
 999  RETURN
      END
      SUBROUTINE AZOOMC (OP, BUFSW, BUFSR, IERR)
C-----------------------------------------------------------------------
C   YZOOM writes (ONLY!!!!) the zoom control registers of the TV
C   Inputs:
C      MAG     I     0-3 for magnification 1,2,4,8 times, resp.
C      XZOOM   I     X center of expansion (1-512, 1 => LHS)
C      YZOOM   I     Y center of expansion (1-512, 1 => bot)
C      VRTRTC  L     Do on vertical retrace only?
C   Output:
C      IERR    I     error code of Z...XF: 0 -> ok, 2 -> input error
C   YZOOMC updates the /TVDEV/ common TVZOOM parameter
C   Virtual TV version (for TV by communication).
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      LOGICAL   VRTRTC
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OP.NE.'WRIT') .OR. (BUFSW.NE.4)) GO TO 999
C                                        header + IO
      VRTRTC = BUFFER(1).EQ.1
      CALL YZOOMC (BUFFER(2), BUFFER(3), BUFFER(4), VRTRTC, IERR)
C
 999  RETURN
      END

      SUBROUTINE ZSHCMD (LCOM, COMMND, LTASK, OUTDEV, IERR)
C-----------------------------------------------------------------------
C! execute a job-control level command string
C# Z2 System
C-----------------------------------------------------------------------
C;  Copyright (C) 2004-2005, 2011, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Execute a "shell" (DCL or sh) command string below present task.
C   Inputs:
C      LCOM     I       Length of commnd
C      COMMND   C*(*)   The command line string
C      LTASK    I       Length of taskout
C      OUTDEV   C*(*)   File/device for standard output/error
C   Output:
C      IERR     I       Error return: 0 means okay
C                          1 input command too long
C                          2 some system error occurred
C   Generic version: calls ZSHCM2 with HOLLERITH conversion for all
C   but VMS COMMENTED OUT
C-----------------------------------------------------------------------
      INTEGER   LCOM, LTASK, IERR
      CHARACTER COMMND*(*), OUTDEV*(*)
C
      HOLLERITH HCOM(256), HDEV(256)
      INTEGER   I
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C     IF (SYSTYP.EQ.'VMS') THEN
C        CALL ZSHCM2 (LCOM, COMMND, LTASK, OUTDEV, IERR)
C     ELSE
         I = LEN (COMMND)
         CALL CHR2H (I, COMMND, 1, HCOM)
         I = LEN (OUTDEV)
         CALL CHR2H (I, OUTDEV, 1, HDEV)
         CALL ZSHCM2 (LCOM, HCOM, LTASK, HDEV, IERR)
C        END IF
C
 990  RETURN
      END

      SUBROUTINE DXYGET (VISIN, IND, IA1, IA2, VISOUT, DROP)
C-----------------------------------------------------------------------
C! Selects uv data and changes Stokes' type.
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2017-2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Gets requested data from XY Stokes visibility record, reformatting as
C   needed.  REQUIRES setup by DGINIT to set values in common DSEL.INC.
C   Inputs:
C      VISIN    R(IND,*)   Input visibility array
C      IND      I          First dimension of VISIN (CATBLK(KINAX))
C      IA1      I          Antenna 1 number
C      IA2      I          Antenna 2 number
C   Input from DSEL.INC
C      MVIS     I(8)       Number of visibilities in requested output
C                          format., # pol, BIF, EIF, BCH, ECH, JNCIF,
C                          JNCF
C      JADR     I(2,4)     Pointers to the first and second visibility
C                          input records to be used in the output
C                          record. If JADR(1,n) is negative use IABS
C                          (JADR(1,n)) and multiply the visibility by i
C                          (=SQRT(-1)).  If JADR(2,n) < 0, use IABS and
C                          construct (1) + i*(2)
C      SELFAC   R(2,4)     Factors to be multiplied by the first and
C                          second input vis's to make the output vis.
C      ALLWT    L          Flag, = .TRUE. if all visibilities must have
C                          positive weight.
C   Output:
C      VISOUT   R(3,*)     Output visibility record
C      DROP     L          .TRUE. if all data in record flaged.
C-----------------------------------------------------------------------
      INTEGER   IND, IA1, IA2
      LOGICAL   DROP
      REAL      VISIN(IND,*), VISOUT(3,*)
C
      INTEGER   I, LF, LC, LP, LFOFF, IOFF, K
      LOGICAL   GOOD, HASWT
      REAL      WT1, RV(4), IV(4), DCOS, DSIN, SCOS, SSIN
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DPDC.INC'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
      GOOD = .FALSE.
C                                       See if weight in data
      HASWT = IND.GE.3
C                                       Check input.
      IF (MVIS(1).LE.0) GO TO 999
C                                       zero output
      I = 3 * MVIS(2) * (MVIS(6)-MVIS(5)+1) * (MVIS(4)-MVIS(3)+1)
      CALL RFILL (I, 0.0, VISOUT)
C                                       Loop checking
C                                       and summing weights

      I = 0
      LFOFF = (MVIS(3) - 2) * MVIS(7) + (MVIS(5) - 2) * MVIS(8)
      DO 70 LF = MVIS(3),MVIS(4)
         LFOFF = LFOFF + MVIS(7)
         IOFF = LFOFF
         DO 60 LC = MVIS(5),MVIS(6)
            IOFF = IOFF + MVIS(8)
            WT1 = 0.0
C                                       advance output pointer
C                                       in case flagged
            I = I + MVIS(2)
            IF (HASWT) THEN
               DO 10 LP = 1,4
                  IF (VISIN(3,LP+IOFF).LE.0.0) GO TO 60
                  WT1 = WT1 + VISIN(3,LP+IOFF)
 10               CONTINUE
            ELSE
               DO 11 LP = 1,4
                  IF (VISIN(1,LP+IOFF).EQ.FBLANK) GO TO 60
                  IF (VISIN(2,LP+IOFF).EQ.FBLANK) GO TO 60
                  WT1 = WT1 + 1.0
 11               CONTINUE
               END IF
C                                       reset pointer
            I = I - MVIS(2)
C                                       pick up data: note reorder
            GOOD = .TRUE.
            WT1 = WT1 / 2.0
            RV(1) = VISIN(1,IOFF+1)
            RV(4) = VISIN(1,IOFF+2)
            RV(2) = VISIN(1,IOFF+3)
            RV(3) = VISIN(1,IOFF+4)
            IV(1) = VISIN(2,IOFF+1)
            IV(4) = VISIN(2,IOFF+2)
            IV(2) = VISIN(2,IOFF+3)
            IV(3) = VISIN(2,IOFF+4)
            DCOS = COS (PANGLE(IA1) - PANGLE(IA2))
            DSIN = SIN (PANGLE(IA1) - PANGLE(IA2))
            SCOS = COS (PANGLE(IA1) + PANGLE(IA2))
            SSIN = SIN (PANGLE(IA1) + PANGLE(IA2))
C                                       loop through request pols
            DO 40 LP = 1,MVIS(2)
               I = I + 1
C                                       Set visibility.
               VISOUT(3,I) = WT1
               K = -SELFAC(1,LP) - 9.95
C                                       I pol
               IF (K.EQ.1) THEN
                  VISOUT(1,I) = (DCOS*RV(1) + DSIN*RV(2) - DSIN*RV(3) +
     *               DCOS*RV(4)) / 2.0
                  VISOUT(2,I) = (DCOS*IV(1) + DSIN*IV(2) - DSIN*IV(3) +
     *               DCOS*IV(4)) / 2.0
C                                       Q pol
               ELSE IF (K.EQ.2) THEN
                  VISOUT(1,I) = (SCOS*RV(1) - SSIN*RV(2) - SSIN*RV(3) -
     *               SCOS*RV(4)) / 2.0
                  VISOUT(2,I) = (SCOS*IV(1) - SSIN*IV(2) - SSIN*IV(3) -
     *               SCOS*IV(4)) / 2.0
C                                       U pol
               ELSE IF (K.EQ.3) THEN
                  VISOUT(1,I) = (SSIN*RV(1) + SCOS*RV(2) + SCOS*RV(3) -
     *               SSIN*RV(4)) / 2.0
                  VISOUT(2,I) = (SSIN*IV(1) + SCOS*IV(2) + SCOS*IV(3) -
     *               SSIN*IV(4)) / 2.0
C                                       V pol
               ELSE IF (K.EQ.4) THEN
                  VISOUT(1,I) = (-DSIN*IV(1) + DCOS*IV(2) - DCOS*IV(3) -
     *               DSIN*IV(4)) / 2.0
                  VISOUT(2,I) =  (DSIN*RV(1) - DCOS*RV(2) + DCOS*RV(3) +
     *               DSIN*RV(4)) / 2.0
                  END IF
 40            CONTINUE
 60         CONTINUE
 70      CONTINUE
C                                       See if any good data.
      DROP = .NOT. GOOD
C
 999  RETURN
      END

      SUBROUTINE PRTNAM (NAMS, MSGPRI)
C-----------------------------------------------------------------------
C! prints the contents of a WaWa-IO file Namestring
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   WaWa IO system: Print a file NAMESTRING at priority MSGPRI
C   Inputs:
C      NAMS     C*36   a namestring
C      MSGPRI   I      priority
C   Written by WaWa (4/21/81)
C-----------------------------------------------------------------------
      CHARACTER NAMS*36
      INTEGER   MSGPRI
C
      CHARACTER DNAMS*36, STAT*4, CNAMS*18, NAME*12, CLASS*6, PTYPE*2
      INTEGER   ERROR, CNO, SEQ, USEID, DISK
      LOGICAL   LSC
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DBUF.INC'
C-----------------------------------------------------------------------
C                                      Copy into scratch
      CALL PRENAM (NAMS, DNAMS, LSC)
      CALL WAWA2A (DNAMS, NAME, CLASS, SEQ, PTYPE, DISK, USEID)
C                                      Look for cat slot
      CNO = 1
      CALL CATDIR ('SRCH', DISK, CNO, NAME, CLASS, SEQ, PTYPE, USEID,
     *   STAT, WBUFF, ERROR)
      IF (MSGPRI.GT.5) THEN
         WRITE (MSGTXT,1000) DISK, CNO, USEID, PTYPE
      ELSE
         WRITE (MSGTXT,1001) DISK, CNO, USEID, PTYPE
         END IF
C                                       Packed vers of name
      CNAMS = NAME // CLASS
      CALL NAMEST (CNAMS, SEQ, MSGTXT(40:), ERROR)
      CALL MSGWRT (MSGPRI)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DISK',I2,' SLOT',I4,'  USER',I6,'  (',A2,')FILE: ')
 1001 FORMAT ('Disk',I2,' slot',I4,'  user',I6,'  (',A2,')file: ')
      END

      SUBROUTINE DTBAND (INDX, JIF, TIME, DSHIFT, BAND)
C-----------------------------------------------------------------------
C! Compute simulated bandpass response
C# UV Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2007, 2015, 2017
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Compute simulated bandpass response
C   Inputs:
C      INDX    I      Index in cal. error arrays for this (ant, fqid)
C      JIF     I      IF number.
C      TIME    R      Time (days since reference day).
C      DSHIFT  D      Frequency shift (channels)
C   Output:
C      BAND    C(2,*) Complex bandpass response (RCP,LCP).
C----------------------------------------------------------------------
      DOUBLE PRECISION DSHIFT
      COMPLEX BAND(2,*)
      REAL TIME
      INTEGER INDX, JIF
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DTPM.INC'
      INCLUDE 'INCS:DDCH.INC'
      LOGICAL WVAR
      CHARACTER LTYPE*8
      COMPLEX ZSCALE
      DOUBLE PRECISION DA, DB, DX, DCHEB(100), DAMP, DFACT, DPHS,
     *   DRE, DIM, DSAMP, DSUMR, DSUMI, DTVAR, DFW
      REAL PARM(MAXERP), XRE(MAXCIF), XIM(MAXCIF), A, B
      INTEGER J, K, NBUTW, NCHEB, ITYPE, NMAX, IRET
      INTEGER IROUND
      SAVE XRE, XIM
C----------------------------------------------------------------------
C                                       Loop over (RCP, LCP)
      DO 500 J = 1, 2
C                                       Initialize
         DO 50 K = 1, NDTCHN
            BAND(J,K) = (1.0, 0.0)
50          CONTINUE
C                                       Compute BP response
         IF (INDX.LE.0) THEN
            CALL RFILL (MAXERP, 0.0, PARM)
         ELSE
            CALL RCOPY (MAXERP, RDTBP(1,JIF,J,INDX), PARM)
            END IF
         ITYPE = IROUND (PARM(1))
C                                       Case BP_type of:
C                                       1: Butterworth amplitude,
C                                          Chebyshev phase
         IF (ITYPE.EQ.1) THEN
C                                       Butterworth order
            NBUTW = IROUND (PARM(2))
C                                       Chebyshev order (phase)
            NCHEB = IROUND (PARM(3))
C                                       Compute sinusoidal time
C                                       and frequency variability
C                                       factor if requested
            WVAR = ((PARM(6).GT.0.0).AND.(PARM(7).GT.0.0)
     *         .AND.(PARM(8).GT.0.0).AND.(PARM(9).GT.0.0))
            IF (WVAR) THEN
               DFW = PARM(8) * SIN (TWOPI * TIME / PARM(9)) + 1.0D0
               DFW = DFW * PARM(7)
               END IF
C                                       Loop over freq. channel
            DSUMR = 0.0D0
            DSUMI = 0.0D0
            DSAMP = 0.0D0
            DO 200 K = 1, NDTCHN
C                                       BP amplitude
               DFACT = (K - DSHIFT) / DBLE (NDTCHN)
               DAMP =  1.0 / SQRT (1.0 + DFACT ** (2 * NBUTW))
C                                       BP phase
               DA = 0.0D0
               DB = NDTCHN
               DX = K - DSHIFT
               CALL CHEBY (DA, DB, DX, DCHEB, NCHEB, IRET)
               IF (IRET.NE.0) GO TO 200
               DPHS = DCHEB(NCHEB+1) * PARM(4) * DG2RAD
C                                       Time/freq. variability
               IF (WVAR) THEN
                  DTVAR = PARM(6) * SIN (TWOPI * K / DFW) + 1.0D0
                  DAMP = DAMP * DTVAR
                  DPHS = DPHS * DTVAR
                  END IF
C                                       Re, Im
               DRE = DAMP * COS (DPHS)
               DIM = DAMP * SIN (DPHS)
               BAND(J,K) = CMPLX (DRE, DIM)
               DSAMP = DSAMP + DAMP
               DSUMR = DSUMR + COS (DPHS)
               DSUMI = DSUMI + SIN (DPHS)
200            CONTINUE
C                                       Normalise to unit amplitude
C                                       and zero mean phase.
            IF (PARM(5).EQ.1) THEN
               DPHS = ATAN2 (DSUMI, DSUMR)
               ZSCALE = CMPLX (COS (DPHS), -SIN (DPHS))
               ZSCALE = ZSCALE * NDTCHN / DSAMP
               DO 220 K = 1, NDTCHN
                  BAND(J,K) = BAND(J,K) * ZSCALE
220               CONTINUE
               END IF
            END IF
C                                       2: Linear slope in time
C                                       and frequency
         IF (ITYPE.EQ.2) THEN
            DO 250 K = 1, NDTCHN
               DX = (K - DSHIFT) / NDTCHN
               DAMP = 1.0 - PARM(2) * DX - PARM(3) * TIME
               DPHS = PARM(2) * DX + PARM(3) * TIME
               DPHS = DPHS * 0.5
               DRE = DAMP * COS (DPHS)
               DIM = DAMP * SIN (DPHS)
               BAND(J,K) = CMPLX (DRE, DIM)
250            CONTINUE
            END IF
C                                       3: Polynomial BP (A&P)
         IF (ITYPE.EQ.3) THEN
            LTYPE = 'CHEB_AP'
            A = 1.0
            B = NDTCHN
            CALL BPCOEF (LTYPE, PARM(2), PARM(6), 1, 1, 4, FBLANK,
     *         DSHIFT, XRE, XIM, 1, 1, 1, NDTCHN, A, B, 0,
     *         .FALSE., DCHEB, 100, NMAX, .FALSE., IRET)
            IF (IRET.EQ.0) THEN
               DO 300 K = 1, NDTCHN
                  BAND(J,K) = CMPLX (XRE(K), XIM(K))
300               CONTINUE
               END IF
            END IF
C
500      CONTINUE
      RETURN
      END

      SUBROUTINE CHGRIP (ITYP, LUN, IND, GH, CB, STR, IERR)
C-----------------------------------------------------------------------
C! reads and writes strings to the Gripe file
C# Gripes
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CHGRIP reads or writes a string to the Gripe file.  When writing,
C   it looks for the strings '_END' and '_end' and replaces the
C   characters {, }, and \ with [, ], and |, respectively.  Then it
C   moves the string with a prefix and suffix to the file, writing
C   and expanding as needed.  When reading it returns the next
C   string in the file removing the prefixes and suffixes and appending
C   trailing blanks to fill the string.
C   Inputs: ITYP  I         0 -> bl { // STR // } bl (write 1 line)
C                           1 -> bl { // STR // crlf (write 1st of n)
C                           2 -> bl bl // STR // crlf (write m of n)
C                           unless end, then ... // }
C                           3 -> read next string
C           LUN   I(2)      Open file logical unit number, 2nd e-mail
C           IND   I(2)      FTAB pointer for open file
C   In/out: GH    I(256)    GH(1) : current file size in blocks
C                             (3) : current record number
C                             (4) : current character position
C           CB    H(256)    Character buffer (1024 chars)
C           STR   C*(*)     String (<= 1000 chars)
C   Output: IERR  I         Error code: 0 => ok and normal
C                              99 => _END found (type 1,2)
C                              -1 => _FORGET found (type 1,2)
C                             100 => string not done (reads)
C                             else serious error (from ZFIO,...)
C-----------------------------------------------------------------------
      INTEGER   ITYP, LUN(2), IND(2), GH(256), IERR
      HOLLERITH CB(256)
      CHARACTER STR*(*)
C
      CHARACTER TSTR*1024, PHNAME*48, IEND*4, LEND*4, IFORG*7, LFORG*7,
     *   IBSL*2, IT*1
      INTEGER   CPOS, CSIZ, CHLIM, JTRIM, IL, ILP, I2, J1, J2, I, JL,
     *   ICR, ILF, NREC, CREC
      LOGICAL   EQUAL
      INCLUDE 'INCS:DDCH.INC'
      DATA IEND, LEND /'_END','_end'/
      DATA IFORG, LFORG /'_FORGET','_forget'/
      DATA ICR, ILF /13, 10/
      DATA IBSL /'\\'/
C-----------------------------------------------------------------------
C                                       Check ITYP
      IERR = 2
      IF ((ITYP.LT.0) .OR. (ITYP.GT.3)) GO TO 999
      IERR = 0
C                                       Parms
      CREC = GH(3)
      CPOS = GH(4)
      CSIZ = GH(1)
      CHLIM = 1024
C                                       WRITE
      IF (ITYP.EQ.3) GO TO 100
C                                       Get actual length of STR
         IL = JTRIM (STR)
C                                       Check for _forget
         ILP = INDEX (STR(1:IL), IFORG)
         IF (ILP.EQ.0) ILP = INDEX (STR(1:IL), LFORG)
         IF (ILP.GT.0) THEN
            IERR = -1
            GO TO 999
            END IF
C                                       Check for _end
         ILP = INDEX (STR(1:IL), IEND)
         IF (ILP.EQ.0) ILP = INDEX (STR(1:IL), LEND)
         IF (ILP.GT.0) IL = ILP - 1
         DO 20 I = 1,IL
            IF (STR(I:I).EQ.IBSL(1:1)) STR(I:I) = '|'
            IF (STR(I:I).EQ.'{') STR(I:I) = '['
            IF (STR(I:I).EQ.'}') STR(I:I) = ']'
 20         CONTINUE
C                                       Build copy string
 30      TSTR = ' '
         IF (ITYP.NE.2) TSTR(2:2) = '{'
         IF (IL.GT.0) THEN
            TSTR(3:2+IL) = STR(1:IL)
         ELSE
            IL = 1
            TSTR(3:3) = ' '
            END IF
         IL = IL + 2
C                                       End with Cr Lf
         IF ((ITYP.NE.0) .AND. (ILP.LE.0)) THEN
            JL = IL
            IL = IL + 1
            TSTR(IL:IL) = CHAR (ICR)
            IL = IL + 1
            TSTR(IL:IL) = CHAR (ILF)
         ELSE
C                                       End with bracket
            I2 = IL + 1
            TSTR(I2:I2+1) = '} '
            JL = I2
            IL = IL + 2
            END IF
C                                       Write it out
         IF (LUN(2).GT.0) THEN
            CALL ZTXIO ('WRIT', LUN(2), IND(2), TSTR(2:JL), IERR)
            IF (IERR.NE.0) THEN
               CALL ZTXCLS (LUN(2), IND(2), IERR)
               LUN(2) = 0
               END IF
            END IF
         I = IL + CPOS - 1
         J1 = MIN (I, CHLIM) - CPOS + 1
         J2 = I - CHLIM
         CALL CHR2H (J1, TSTR, CPOS, CB)
         CPOS = CPOS + J1
         IF (CPOS.GT.CHLIM) THEN
            CALL ZFIO ('WRIT', LUN, IND, CREC, CB, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       Blank fill record
            CALL RFILL (256, HBLANK, CB)
            CREC = CREC + 1
            CPOS = 1
            J1 = J1 + 1
            CALL CHR2H (J2, TSTR(J1:), CPOS, CB)
            CPOS = CPOS + J2
C                                       Expand file to hold record
            IF (CREC.GT.CSIZ) THEN
               CALL ZPHFIL ('GR', 1, 0, 0, PHNAME, IERR)
               NREC = 1
               CALL ZEXPND (LUN, 1, PHNAME, NREC, IERR)
               IF (IERR.NE.0) GO TO 999
               CSIZ = CSIZ + NREC
               END IF
            END IF
         GH(3) = CREC
         GH(4) = CPOS
         GH(1) = CSIZ
C                                       Was an _end or _END found?
         IF (ILP.GT.0) IERR = 99
         GO TO 999
C                                       READ
 100  CONTINUE
         IL = 0
         ILP = LEN(STR)
         STR = ' '
 105     J1 = CPOS
         J2 = CHLIM
         DO 110 I = J1,J2
            CALL H2CHR (1, I, CB, IT)
            IF ((IL.EQ.0) .AND. ((IT.EQ.' ') .OR. (IT.EQ.'{')))
     *         GO TO 110
            IF (IT.EQ.'}') GO TO 120
            IF (IT.EQ.CHAR(ICR)) GO TO 125
            IF (IL.GE.ILP) GO TO 130
            IL = IL + 1
            STR(IL:IL) = IT
 110        CONTINUE
         CREC = CREC + 1
         CPOS = 1
         CALL ZFIO ('READ', LUN, IND, CREC, CB, IERR)
         IF (IERR.NE.0) GO TO 999
         GO TO 105
C                                       Got it with a }
 120     CONTINUE
            EQUAL = .FALSE.
            CPOS = I + 1
            GO TO 135
C                                       With a Cr Lf
 125     CONTINUE
            EQUAL = .TRUE.
            CPOS = I + 2
            GO TO 135
C                                       Overran output STR
 130     CONTINUE
            EQUAL = .TRUE.
            CPOS = I
C                                       Read next rec if needed
 135     IF (CPOS.LE.CHLIM) GO TO 140
            CREC = CREC + 1
            CALL ZFIO ('READ', LUN, IND, CREC, CB, IERR)
            IF (IERR.NE.0) GO TO 999
            CPOS = CPOS - CHLIM
C                                       Return pointers
 140     GH(3) = CREC
         GH(4) = CPOS
         IF (EQUAL) IERR = 100
C
 999  RETURN
      END

      SUBROUTINE CCMERG (DISK, CNO, INVER, OUTVER, INPCMP, OUTCMP,
     *   JBUFS, BUFFER, IRET)
C-----------------------------------------------------------------------
C! Compresses a CLEAN component (CC) table
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999, 2011, 2020
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CCMERG sorts AIPS CC tables to bring all components at the same
C   cell together, then it sums them, and finally it resorts the file
C   into the original order (by flux of the new components).
C   Inputs:
C      DISK     I      File disk number
C      CNO      I      File catalog number
C      JBUFS    I      Number words in BUFFER
C   In/out:
C      INVER    I      Input CC version number: 0 => MAXVER
C      OUTVER   I      Output CC version number: 0 => MAXVER+1
C   Output:
C      BUFFER   I(*)   sort buffer
C      INPCMP   I      Number components on input.
C      OUTCMP   I      Number components on output.
C      IRET     I      Error code
C   Common: /MAPHDR/ CATBLK for the affected image file
C   The routine assumes that the CATBLK is in this common already and
C   that the file has been opened in the catalog for WRITE.  (The image
C   file itself does not need to be open.)  The routine assumes that
C   the CFIL common is initialized especially IBAD (BADDISK).
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, INVER, OUTVER, JBUFS, INPCMP, OUTCMP, IRET
      REAL      BUFFER(*)
C
      CHARACTER CCTIT1(7)*8, CCTIT2(8)*8, TYPE*2, PHNAME*48, CHTMP*2
      INTEGER   SCVER(2), EQUKOL(10), SUMKOL(10), MAXVER, KEY(2,4),
     *   TABUFF(512), BUFSZ, I, LUN(2), JCOL1, JP, IERR, NKEY, NCOL,
     *   NREC, DATP(128,2), EMAX, EMIN, IVER, INSCR, CATSAV(256),
     *   KEYSUB(2,2)
      REAL      TSTKOL(10), FKEY(2,2), EPS
      LOGICAL   T
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA TYPE /'CC'/
      DATA EPS, T /0.05, .TRUE./
      DATA LUN /16,17/
      DATA KEYSUB /4*1/
      DATA CCTIT1 /'DELTAX  ', 'DELTAY  ', 'MAJOR AX',
     *   'MINOR AX', 'POSANGLE', 'TYPE OBJ', 'FLUX    '/
      DATA CCTIT2 /'DELTAX', 'DELTAY', 'DELTAZ', 'MAJOR AX',
     *   'MINOR AX', 'POSANGLE', 'TYPE OBJ', 'FLUX    '/
C-----------------------------------------------------------------------
      INSCR = NSCR + 1
      IF (INSCR.LE.0) NSCR = 0
      IF (INSCR.LE.0) INSCR = 1
C                                       find version numbers
      CALL FNDEXT (TYPE, CATBLK, MAXVER)
      IF (MAXVER.GT.0) GO TO 10
         WRITE (MSGTXT,1000)
         GO TO 990
 10   IF ((INVER.LE.0) .OR. (INVER.GT.MAXVER)) INVER = MAXVER
      IF (OUTVER.LE.0) OUTVER = MAXVER + 1
      SCVER(1) = MAX (OUTVER, MAXVER+1)
      SCVER(2) = SCVER(1) + 1
C                                       Open table file
      NKEY = 0
      NCOL = 0
      NREC = 0
      CALL TABINI ('READ', TYPE, DISK, CNO, INVER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, TABUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, TYPE, INVER
         GO TO 990
         END IF
C                                       Number input components
      INPCMP = TABUFF(5)
C                                       Find columns
      CALL FILL (10, 0, EQUKOL)
      CALL FILL (10, 0, SUMKOL)
      IF ((NCOL.EQ.3) .OR. (NCOL.EQ.7)) THEN
         JCOL1 = 2
         IF (TABUFF(10).GE.7) JCOL1 = 6
         CALL FNDCOL (JCOL1, CCTIT1(1), 8, T, TABUFF, EQUKOL, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR
            GO TO 990
            END IF
         CALL FNDCOL (1, CCTIT1(7), 8, T, TABUFF, SUMKOL, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR
            GO TO 990
            END IF
      ELSE IF ((NCOL.EQ.4) .OR. (NCOL.EQ.8)) THEN
         JCOL1 = 3
         IF (TABUFF(10).GE.7) JCOL1 = 7
         CALL FNDCOL (JCOL1, CCTIT2(1), 8, T, TABUFF, EQUKOL, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR
            GO TO 990
            END IF
         CALL FNDCOL (1, CCTIT2(8), 8, T, TABUFF, SUMKOL, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR
            GO TO 990
            END IF
         END IF
C                                       insort
      KEY(1,1) = EQUKOL(2)
      KEY(2,1) = 0
      KEY(1,2) = EQUKOL(1)
      KEY(2,2) = 0
C                                       outsort
      KEY(1,3) = -SUMKOL(1)
      KEY(2,3) = 0
      KEY(1,4) = EQUKOL(2)
      KEY(2,4) = 0
C                                       sort weights: not sum cols
      FKEY(1,1) = -1.0
      FKEY(2,1) = 0.0
      FKEY(1,2) = 1.0
      FKEY(2,2) = 0.0
C                                       tolerances
      TSTKOL(1) = EPS * ABS (CATR(KRCIC))
      TSTKOL(2) = EPS * ABS (CATR(KRCIC+1))
      TSTKOL(3) = MIN (TSTKOL(1), TSTKOL(2))
      TSTKOL(4) = TSTKOL(3)
      IF ((NCOL.EQ.4) .OR. (NCOL.EQ.8)) THEN
         TSTKOL(5) = TSTKOL(3)
         TSTKOL(6) = 1.0
         TSTKOL(7) = 0.0
      ELSE
         TSTKOL(5) = 1.0
         TSTKOL(6) = 0.0
         END IF
C                                       Close the table file
      CALL TABIO ('CLOS', 0, 0, DATP, TABUFF, IERR)
C                                       Sort: to scratch (1)
      IRET = 0
      IF (INPCMP.GT.0) THEN
         BUFSZ = JBUFS * 2
         WRITE (MSGTXT,1030) SCVER(1)
         CALL MSGWRT (2)
         CALL TABSRT (DISK, CNO, TYPE, INVER, SCVER(1), KEY, KEYSUB,
     *      FKEY, TABUFF, CATBLK, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Merge: scratch(2)
         WRITE (MSGTXT,1031) SCVER(2)
         CALL MSGWRT (2)
         CALL TABMRG (DISK, CNO, TYPE, SCVER(1), SCVER(2), EQUKOL,
     *      SUMKOL, TSTKOL, BUFFER, TABUFF, CATBLK, OUTCMP, IRET)
         IF (IRET.NE.0) GO TO 900
         CALL ZPHFIL (TYPE, DISK, CNO, OUTVER, PHNAME, IERR)
         CALL ZDESTR (DISK, PHNAME, IERR)
C                                       Sort to output
         WRITE (MSGTXT,1032) OUTVER
         CALL MSGWRT (2)
         CALL TABSRT (DISK, CNO, TYPE, SCVER(2), OUTVER, KEY(1,3),
     *      KEYSUB, FKEY, TABUFF, CATBLK, IRET)
C                                       empty table
      ELSE IF (INVER.NE.OUTVER) THEN
         CALL ZPHFIL (TYPE, DISK, CNO, OUTVER, PHNAME, IERR)
         CALL ZDESTR (DISK, PHNAME, IERR)
         CALL TABCOP ('CC', INVER, OUTVER, LUN(1), LUN(2), DISK, DISK,
     *      CNO, CNO, CATBLK, TABUFF, TABUFF(257), IRET)
         END IF
C                                       extension file clean up
C                                       FNDEXT, TABINI called FXHDEX
 900  DO 910 I = 1,KIEXTN
         CALL H2CHR (2, 1, CATH(KHEXT+I-1), CHTMP)
         IF (CHTMP.EQ.TYPE) THEN
            JP = KIVER + I - 1
            IF (CATBLK(JP).GT.MAXVER) THEN
               EMAX = CATBLK(JP)
               GO TO 920
               END IF
            END IF
 910     CONTINUE
      GO TO 999
 920  EMIN = MAXVER + 1
      IF (IRET.EQ.0) EMIN = MAX (EMIN, OUTVER+1)
C                                       delete the extras
      IF (EMIN.LE.EMAX) THEN
         CATBLK(JP) = EMIN - 1
         DO 930 IVER = EMIN,EMAX
            CALL ZPHFIL (TYPE, DISK, CNO, IVER, PHNAME, IERR)
            CALL ZDESTR (DISK, PHNAME, IERR)
            IF (IERR.GT.1) CATBLK(JP) = IVER
 930        CONTINUE
C                                       Update catalog
         CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'REST', TABUFF, IERR)
         END IF
C                                       Delete scratch files
      IF (NSCR.LT.INSCR) THEN
         EMIN = NSCR - INSCR + 1
         CALL FILL (EMIN, 2, DATP)
         CALL COPY (256, CATBLK, CATSAV)
         CALL MAPCLR (EMIN, SCRVOL(INSCR), SCRCNO(INSCR), DATP, TABUFF)
         CALL COPY (256, CATSAV, CATBLK)
         NSCR = INSCR - 1
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
      IRET = 8
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR: NO CC FILES ASSOCIATED WITH IMAGE')
 1010 FORMAT ('ERROR:',I7,' OPENING ',A2,' FILE VERSION',I3)
 1020 FORMAT ('ERROR:',I7,' FINDING NEEDED CC FILE COLUMNS')
 1030 FORMAT ('Start sort to CC file scratch version',I4)
 1031 FORMAT ('Start merge to CC file scratch version',I4)
 1032 FORMAT ('Start sort to CC file output version',I4)
      END

      SUBROUTINE H2WAWA (NAME, CLASS, SEQ, PTYPE, VOL, USID, NAMEST)
C-----------------------------------------------------------------------
C! packs AIPS adverb values into WaWa IO NameString
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   packs AIPS adverb values (Holleriths, floating points) into a WaWa
C   IO Namestring having format A12, A6, A2, I7, I2, I7 for name, class,
C   ptype, seq, vol, usid
C   Inputs:
C      NAME    H(3)   file name
C      CLASS   H(2)   file class (6 chars)
C      SEQ     R      file sequence number
C      PTYPE   H      file physical type (2 chars)
C      VOL     R      file disk number
C      USID    R      user number
C   Output:
C      NAMEST  C*36   WaWa Namestring
C-----------------------------------------------------------------------
      HOLLERITH NAME(3), CLASS(2), PTYPE(1)
      REAL      SEQ, VOL, USID
      CHARACTER NAMEST*36
C
      CHARACTER CNAME*12, CCLASS*6, CPTYPE*2
      INTEGER   IROUND, ISEQ, IVOL, IUSID
C-----------------------------------------------------------------------
      CALL H2CHR (12, 1, NAME, CNAME)
      CALL H2CHR (6, 1, CLASS, CCLASS)
      CALL H2CHR (2, 1, PTYPE, CPTYPE)
      ISEQ = IROUND (SEQ)
      IVOL = IROUND (VOL)
      IUSID = IROUND (USID)
      WRITE (NAMEST,1000,ERR=999) CNAME, CCLASS, CPTYPE, ISEQ, IVOL,
     *   IUSID
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A12,A6,A2,I7,I2,I7)
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QCVMMA (A, I, C, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Max. square of modulus of complex vector.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Find the maximum of the square modulus of a complex vector.
C      max (A(mI)**2 + A(mI+1)**2)      over m = 0 to N-1
C   Inputs:
C      A  I  Source vector base address
C      I  I  Increment of A (normally 2 * integer)
C      C  I  Destination vector.
C               0 = MAX(A ** 2) (real)
C               1  = location of max  (integer)
C      N  I  Element count
C   Also:
C            SPAD(15) = index of max.
C-----------------------------------------------------------------------
      INTEGER   A, II, I, C, N, JA, JC, JI, ONE
      REAL      VMAX, AMPL(1024)
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
      IF (N.GT.1024) THEN
         WRITE(*,*) '**************** ERROR *****************'
         WRITE(*,*) 'ARRAY AMPL IN QCVMMA TOO SMALL.  N =',N
         GOTO 999
      END IF
C                                       Addresses 1-rel
      JC = C + 1
      JA = A + 1
C                                       Init. max.
       VMAX = APCORE(JA)
       JI = JA
C                                       Find max.
C                                       Note: contains a dependency.
C      DO 100 II = 1, N
C         AMPL = APCORE(JA)*APCORE(JA) + APCORE(JA+1)*APCORE(JA+1)
C         IF (AMPL.LE.VMAX) GO TO 90
C            VMAX = AMPL
C            JI = JA
C            SPAD(15) = II
C 90      JA = JA + I
C 100     CONTINUE
      DO 10 II = 1, N
         AMPL(II) = APCORE(JA)**2 + APCORE(JA+1)**2
         JA = JA + I
 10      CONTINUE
C
      IMAX = ISMAX(N,AMPL,1)
      IF(AMPL(IMAX).GT.VMAX) THEN
        VMAX = AMPL(IMAX)
        JI = JI + (IMAX - 1) * I
        SPAD(15) = IMAX
      ENDIF
      APCORE(JC) = VMAX
      APCORI(JC+1) = JI - 1
C
 999  RETURN
      END

      SUBROUTINE ZVLBIN (NVAL, ARRAY, RARR, DARR, IARR, IRET)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  Routine to perform the equivalence necessary for NRAO/SAO DECODE
C  format VLBI data.
C
C    Inputs:
C      NVAL           I           No. integer*2 words in ARRAY
C      ARRAY(*)       I*2         Integer*2 array read from disc
C    Outputs:
C      DARR(*)        D           Double precision output array
C      RARR(*)        R           Real output array
C      IARR(*)        I           Integer output array
C      IRET           I           Error flag
C-----------------------------------------------------------------------
      INTEGER   NVAL, IRET, IARR(*)
      INTEGER*2 ARRAY(*)
      REAL      RARR(*)
      DOUBLE PRECISION DARR(*)
C
      INTEGER   I4, I8, I
      INTEGER*2 ITEMP(1024)
      REAL      TEMP(512)
      DOUBLE PRECISION DTEMP(256)
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (ITEMP, TEMP, DTEMP)
C-----------------------------------------------------------------------
      IRET = 0
      IF ((NVAL.LE.0) .OR. (NVAL.GT.1024)) THEN
         WRITE (MSGTXT,1000) NVAL
         IRET = 1
         GO TO 990
         END IF
C                                       Copy integer array
      DO 100 I = 1, NVAL
         ITEMP(I) = ARRAY(I)
         IARR(I) = ARRAY(I)
 100     CONTINUE
C                                       Copy real array
      I4 = NVAL / 2
      DO 200 I = 1, I4
         RARR(I) = TEMP(I)
 200     CONTINUE
C                                       Copy double precision array
      I8 = NVAL / 4
      DO 300 I = 1, I8
         DARR(I) = DTEMP(I)
 300     CONTINUE
      GO TO 999
C
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZVLBIN: ERROR, # I*2 VALUES INCORRECT: NVAL = ',I10)
      END

      SUBROUTINE PTF3D (FDVEC, TBIND, NEXT, LINE, BUFFER, NBYTE, IERR)
C-----------------------------------------------------------------------
C! Copies 8-bit bytes to tape.
C# Tape FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   copies the next NBYTE bytes (8-bit) from LINE to the
C   TAPIO stream pointed to by FDVEC.  A tape record will be written
C   if necessary.  The buffer is zeroed after the data is written.
C    Inputs:
C     FDVEC(50)   I    File Descriptor vector used by TAPIO.  File
C                      must be in active read state.
C     NBYTE       I    Number of bytes to move.
C   Input/Output:
C     TBIND       I    Pointer in BUFFER returned by TAPIO.
C     NEXT        I    Pointer in BUFFER for next read (bytes).
C     LINE(*)     I    Output byte stream
C     BUFFER(*)   I    TAPIO buffer
C   Output:
C     IERR        I    Error code, 0=> OK, else TAPIO error.
C                      10 => encountered problem with pointers
C-----------------------------------------------------------------------
      INTEGER   FDVEC(50), NBYTE, TBIND, NEXT, BUFFER(*), LINE(*),
     *   IERR
      INTEGER   NCOPY, NMOV, LOOP, NZERO, POINT, NBYTLF, EOB
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (NBYTE.LE.0) GO TO 999
C                                       Setup
      POINT = 1
      NMOV = NBYTE
C                                       Copy as many as needed
 10   EOB = 1 +  FDVEC(2)
         NBYTLF = EOB - NEXT
         NCOPY = NMOV
         IF (NBYTLF.LT.NCOPY) NCOPY = NBYTLF
C                                       Trap problem
         IF (NEXT.GT.EOB) GO TO 900
C                                       Copy bytes
         CALL ZBYMOV (NCOPY, POINT, LINE, NEXT, BUFFER(TBIND))
         NEXT = NEXT + NCOPY
         IF (NCOPY.GE.NMOV) GO TO 999
C                                       More to do
         POINT = POINT + NCOPY
         NMOV = NMOV - NCOPY
C                                       Write record
         CALL TAPIO ('WRIT', FDVEC, BUFFER, TBIND, IERR)
         NEXT = 1
C                                       Zero buffer.
         NZERO = (FDVEC(2) * 8 - 1) / NBITWD + 1
         DO 50 LOOP = 1,NZERO
            BUFFER(TBIND+LOOP-1) = 0
 50         CONTINUE
         IF (IERR.EQ.0) GO TO 10
      GO TO 999
C                                       Problem
 900  IERR = 10
      WRITE (MSGTXT,1900) NEXT, EOB
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('PTF3D: NEXT (',I6,') AND EOB (',I6,') ARE INCONSISTENT')
      END

      SUBROUTINE CALSEL (DISK, CNO, TYPE, VER, CATBLK, IBUFF, NSOUWD,
     *   SOUWAN, DOSWNT, NANTWD, ANTWAN, DOAWNT, TIMRA, SUBA, FREQID,
     *   IRET)
C-----------------------------------------------------------------------
C! Deletes a selected subset of a CL or SN table.
C# EXT-appl Calibration UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2003, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to flag a selected subset of a CL or SN table.
C   Input:
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      TYPE     C*2      Table type (CL or SN)
C      VER      I        Table version.
C      CATBLK   I(256)   Catalog header block.
C      NSOUWD   I        Number of sources included or excluded.
C      DOSWNT   L        If .TRUE. then sources in SOUWAN are
C                        included, if .FALSE. then excluded.
C      SOUWAN   I(*)     The source numbers of sources included or
C                        excluded.
C      NANTWD   I        Number of antennas included or excluded.
C      ANTWAN   I(*)     The antenna numbers of antennas included or
C                        excluded.
C      DOSWNT   L        If .TRUE. then antennas in ANTWAN are included
C                        else they are excluded.
C      TIMRA    D(2)     First and last times to be considered. (days)
C      SUBA     I        Desired subarray, 0=>all.
C      FREQID   I        Desired freq. id number. 0=>all
C   Input/Output:
C      IBUFF    I(512)   Buffer for TABIO use.
C   Output:
C      IRET     I        Return code 0=OK, else failed.
C   Note: uses LUN 28
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, VER, CATBLK(256), IBUFF(*), NSOUWD,
     *   SOUWAN(*), NANTWD, ANTWAN(*), SUBA, FREQID, IRET
      DOUBLE PRECISION TIMRA(2)
      LOGICAL   DOSWNT, DOAWNT
      CHARACTER TYPE*2
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IRCODE, RECI(XCLRSZ), LUN, JERR, IVER, KOLS(5), NDROP,
     *   NKEY, TIMKOL, SOUKOL, ANTKOL, SUBKOL, FRQKOL, IRNO, ORNO,
     *   NUMREC, LOOP, MSGSAV, I , NREC, NCOL, DATP(128,2)
      LOGICAL   ALLSEL, SELECT, GOTIT, TABLE, EXIST, FITASC
      REAL      RECR(XCLRSZ)
      DOUBLE PRECISION RECD(XCLRSZ/2)
      CHARACTER COLHED(5)*24
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (RECI, RECR, RECD)
      EQUIVALENCE (KOLS(1), TIMKOL), (KOLS(2), SOUKOL),
     *   (KOLS(3),ANTKOL), (KOLS(4), SUBKOL),   (KOLS(5),FRQKOL)
      DATA COLHED /'TIME ', 'SOURCE ID ', 'ANTENNA NO. ',
     *   'SUBARRAY ', 'FREQ ID '/
      DATA LUN /28/
      DATA IRCODE /0/
C-----------------------------------------------------------------------
      NDROP = 0
      IRET = 0
C                                       Does table exist?
      CALL ISTAB (TYPE, DISK, CNO, VER, LUN, IBUFF, TABLE, EXIST,
     *   FITASC, JERR)
      IF ((.NOT.EXIST) .OR. (.NOT.TABLE) .OR. (JERR.NE.0)) GO TO 999
C                                       Is all data selected?
C                                       Timerange
      ALLSEL = (TIMRA(1).LE.1.0D-10) .AND. (TIMRA(2).GE.1.0D10)
C                                       Subarray
      ALLSEL = ALLSEL .AND. (SUBA.LE.0)
C                                       Sources
      ALLSEL = ALLSEL .AND. (NSOUWD.LE.0)
C                                       Antennas
      ALLSEL = ALLSEL .AND. (NANTWD.LE.0)
C                                       FQ ID - have to check table
      IF (ALLSEL . AND. (FREQID.EQ.1)) THEN
         IVER = 1
         NKEY = 0
         NREC = 0
         NCOL = 0
         MSGSAV = MSGSUP
         MSGSUP = 32000
         CALL TABINI ('READ', 'FQ', DISK, CNO, IVER, CATBLK, LUN,
     *      NKEY, NREC, NCOL, DATP, IBUFF, JERR)
         IF (JERR.EQ.0) CALL TABIO ('CLOS', IRCODE, IRNO, RECI, IBUFF,
     *      JERR)
         MSGSUP = MSGSAV
         ALLSEL = (IBUFF(5).LE.1) .OR. (JERR.NE.0)
      ELSE
         ALLSEL = ALLSEL .AND. (FREQID.LE.0)
         END IF
C                                       If all selected simply remove
C                                       table.
      IF (ALLSEL) THEN
         MSGTXT = 'CALSEL: Making room for new ' // TYPE // ' data by '
         CALL MSGWRT (2)
         WRITE (MSGTXT,1000) TYPE, VER
         CALL MSGWRT (2)
         CALL RMEXT (DISK, CNO, TYPE, VER, CATBLK, IBUFF, IRET)
         GO TO 999
         END IF
C                                       Open table
      NKEY = 0
      NREC = 0
      NCOL = 0
      CALL TABINI ('WRIT', TYPE, DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, IBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Number of records
      NUMREC = IBUFF(5)
C                                       Find column pointers.
      NKEY = 5
      CALL FNDCOL (NKEY, COLHED, 24, .TRUE., IBUFF, KOLS, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'CALSEL: ERROR FINDING COLUMNS IN CAL TABLE'
         GO TO 990
         END IF
C                                       Convert pointers to something
C                                       useful.
      DO 50 LOOP = 1,NKEY
         KOLS(LOOP) = DATP(KOLS(LOOP),1)
 50      CONTINUE
C                                       Copy records which don't match
C                                       selection criteria.
      ORNO = 0
      DO 500 LOOP = 1,NUMREC
         IRNO = LOOP
C                                       Read input record
         CALL TABIO ('READ', IRCODE, IRNO, RECI, IBUFF, IRET)
         IF (IRET.LT.0) GO TO 500
         IF (IRET.NE.0) GO TO 900
C                                       Does this meet selection
C                                       criteria?
C                                       Subarray
         SELECT = ((SUBA.EQ.RECI(SUBKOL)) .OR. (RECI(SUBKOL).LE.0) .OR.
     *      (SUBA.LE.0))
C                                       FQ id.
         SELECT = SELECT .AND. ((RECI(FRQKOL).EQ.FREQID) .OR.
     *      (RECI(FRQKOL).LE.0) .OR. (FREQID.LE.0))
C                                       Timerange
         SELECT = SELECT .AND. ((RECD(TIMKOL).GE.TIMRA(1)) .AND.
     *      (RECD(TIMKOL).LE.TIMRA(2)))
C                                       Source
         IF (SELECT .AND. (NSOUWD.GT.0)) THEN
            GOTIT = .FALSE.
            DO 300 I = 1,NSOUWD
               GOTIT = GOTIT .OR. (RECI(SOUKOL).EQ.SOUWAN(I))
 300           CONTINUE
            IF (GOTIT .AND. (.NOT.DOSWNT)) SELECT = .FALSE.
            IF ((.NOT.GOTIT) .AND. DOSWNT) SELECT = .FALSE.
            END IF
C                                       Antenna
         IF (SELECT .AND. (NANTWD.GT.0)) THEN
            GOTIT = .FALSE.
            DO 350 I = 1,NANTWD
               GOTIT = GOTIT .OR. (RECI(ANTKOL).EQ.ABS(ANTWAN(I)))
 350           CONTINUE
            IF (GOTIT .AND. (.NOT.DOAWNT)) SELECT = .FALSE.
            IF ((.NOT.GOTIT) .AND. DOAWNT) SELECT = .FALSE.
            END IF
C                                       Copy to output
         IF (.NOT.SELECT) THEN
            ORNO = ORNO + 1
            IF (ORNO.LT.LOOP) THEN
               CALL TABIO ('WRIT', IRCODE, ORNO, RECI, IBUFF, IRET)
               IF (IRET.NE.0) GO TO 900
               END IF
            END IF
 500     CONTINUE
C                                       Close table
C                                       Number of records
      IBUFF(5) = ORNO
      CALL TABIO ('CLOS', IRCODE, LOOP, RECI, IBUFF, IRET)
      IF (IRET.NE.0) GO TO 900
C                                       Tell number dropped
      NDROP = NUMREC - ORNO
      IF (NDROP.GT.0) THEN
         MSGTXT = 'CALSEL: Making room for new ' // TYPE // ' data by '
         CALL MSGWRT (2)
         WRITE (MSGTXT,1500) NDROP, TYPE, VER
         CALL MSGWRT (2)
         END IF
      GO TO 999
C                                       TABIO error
 900  WRITE (MSGTXT,1900) IRET
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Deleting ',A,' table no. ',I4)
 1500 FORMAT ('Deleting ',I6,' records from ',A,' table no. ',I4)
 1900 FORMAT ('CALSEL: TABIO ERROR',I3)
      END

LOCAL INCLUDE 'ATMCA.INC'
C                                                          Include ATMCA
C                                       Local include for ATMCA
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MXSOU, MT, MAXFIT, MXAN, MXIFSO, MXANSO
      PARAMETER (MXSOU = 100)
      PARAMETER (MAXFIT = 100)
      PARAMETER (MXAN = 50)
      PARAMETER (MXIFSO = MAXIF*MXSOU)
C                                       MXSASO - product # antennas
C                                       and sources
      PARAMETER (MXANSO = MXAN*MXSOU)
      PARAMETER (MT = 10000)
      INTEGER NIDC, IDC(MXSOU), NIDS, IDS(MXSOU), NNIF, NS,
     *   NNNIF, SEQIN, SUBA, DISKIN, CNOIN, SNVER, SNOUT,
     *   CLVER, CLUSE, NANTSL, BIF, EIF, ISTOK, FREQID,
     *   NPARM, NSS, NUMHIS, NTERM, NFITA, KCLRNO, KSNRNO,
     *   NVALSO(MXANSO), RANT
      DOUBLE PRECISION RAC(MXSOU), DRAC(MXSOU), DECC(MXSOU),
     *   DDECC(MXSOU), RAS(MXSOU), DRAS(MXSOU), DECS(MXSOU),
     *   DDECS(MXSOU)
      LOGICAL    FIRSCL, FIRSSN, DOHIST, DOPLOT, DOUTFI, DOCL, DOSN,
     *   ENDSN, FSOUCL(MXSOU), FSOUSN(MXSOU), DOELRE, SNDELE
      REAL      XSIN, XDISIN, XFQID, XBAND, XFREQ, XBIF, XEIF, XTIME(8),
     *   XANT(50), XSUBA, XSNVER, XGVER, SOLINT, XDOHI, XBAD(10),
     *   APARM(10), SELBAN, TIMBEG, TIMEND, BUFF1(2048), FLUXX(MXIFSO),
     *   SOLANT(4*MXAN), TTARG, TSTART, TFINIS, VALSAN(MXANSO)
      DOUBLE PRECISION   SOL(MAXFIT), VX(MAXFIT), SSQRES, VARY, FIT,
     *   VARRES
      INTEGER   LESOL
      CHARACTER  HISCRD(1000)*64, NAMEIN*12, CLAIN*6, XSOUR(30)*16,
     *   XCALIB(30)*16, XSTOK*4, OPTYPE*4, OFILE*48,
     *   SOUS(30)*16, SOUC(30)*16, STOKK(2)*4
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XXCALB(4,30),
     *   XXSTOK(1), XOPTY(1), XOFILE(12)
      DOUBLE PRECISION FRQOFF(MAXIF), SELFRQ, LAMBDA(MAXIF)
C                                       cpecific CL data
      INTEGER   CLRECI(13+32*MAXIF), CLKOLS(MAXCLC), CLNUMV(MAXCLC),
     *   FIXCL, FIXSN,
     *   TIMCL,  INTCL, SOUCL, ANTCL, SUBCL, FRQCL, IFRCL,
     *   GDLCL, DOPCL, ATMCL, DATMCL,
     *   MBD1CL, CLK1CL, DCK1CL, DIS1CL, DDS1CL,
     *   RE1CL, IM1CL, DE1CL, RA1CL, WE1CL, RF1CL,
     *   MBD2CL, CLK2CL, DCK2CL, DIS2CL, DDS2CL,
     *   RE2CL, IM2CL, DE2CL, RA2CL, WE2CL, RF2CL
      REAL     CLRECR(13+32*MAXIF)
      DOUBLE PRECISION  CLRECD(13+32*MAXIF)
C                                       Buffers and file info
      INTEGER   BUFFER(1024)
C                                       Internal storage
      INTEGER   SNRECI(10+15*MAXIF), SNKOLS(MAXSNC), SNNUMV(MAXSNC),
     *   NUMANT, NUMPOL, NUMIF, ICODE, TIMSN, INTSN, SOUSN, ANTSN,
     *   SUBSN, FRQSN, IFRSN, NODSN, RE1SN, IM1SN, DL1SN, RA1SN,
     *   WT1SN, RF1SN, RE2SN, IM2SN, DL2SN, RA2SN, WT2SN, RF2SN
      REAL      GMMOD, SNRECR(10+15*MAXIF)
      DOUBLE PRECISION COSDEC, SINDEC, SNRECD(10+15*MAXIF)
C                                       Inputs and general info
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSNVER, XGVER,
     *   APARM, XXSOUR, XXCALB, XXSTOK, XBAND, XFREQ, XFQID,
     *   XBIF, XEIF, XTIME, XANT, XSUBA, SOLINT,
     *   XOPTY, XOFILE, XDOHI, XBAD
      COMMON /OTHPRM/ SELBAN, SEQIN, DISKIN, CNOIN, SUBA, SNVER,
     *   SNOUT, CLVER, CLUSE, NPARM, NUMHIS, DOHIST,
     *   DOPLOT, DOUTFI, DOCL, DOSN, NFITA, FIRSCL, FIRSSN,
     *   ENDSN, FSOUCL, FSOUSN, DOELRE, SNDELE
      COMMON /EL/  RAC, DRAC, RAS, DRAS, DECC, DDECC, DECS, DDECS,
     *   IDC, NIDC, IDS, NIDS, NNIF, NS, NNNIF, ICODE, NSS, FLUXX,
     *   SOLANT, TTARG, TSTART, TFINIS, KCLRNO, KSNRNO, NVALSO,
     *   VALSAN
      COMMON /LEASQ/   SOL, VX, SSQRES, VARY, FIT, VARRES, LESOL
      COMMON /CINFO/ FRQOFF, SELFRQ, NANTSL, RANT, BIF, EIF, ISTOK,
     *   FREQID, TIMBEG, TIMEND
      COMMON /CHRCOM/ HISCRD, NAMEIN, CLAIN, XSOUR, XCALIB,
     *   XSTOK, OPTYPE, SOUS, SOUC, STOKK, OFILE
C                                       Buffers and file info
      COMMON /BUFRS/ BUFFER, BUFF1
C                                       Important constants
C                                       Internal storage
      COMMON /SNRECC/ LAMBDA, COSDEC, SINDEC, SNRECD, GMMOD,
     *   SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF,
     *   TIMSN, INTSN, SOUSN, ANTSN, SUBSN, FRQSN, IFRSN, NODSN,
     *   RE1SN, IM1SN, DL1SN, RA1SN, WT1SN, RF1SN,
     *   RE2SN, IM2SN, DL2SN, RA2SN, WT2SN, RF2SN, FIXSN
      COMMON /CLRECC/  CLRECD, NTERM,
     *   FIXCL, CLKOLS, CLNUMV
      EQUIVALENCE (CLRECI, CLRECR, CLRECD)
      EQUIVALENCE (CLKOLS(CLDTIM), TIMCL), (CLKOLS(CLRTMI), INTCL),
     *   (CLKOLS(CLISID),SOUCL), (CLKOLS(CLIANT),ANTCL),
     *   (CLKOLS(CLISUB),SUBCL), (CLKOLS(CLIFQI),FRQCL),
     *   (CLKOLS(CLRIFR),IFRCL), (CLKOLS(CLDDEL),GDLCL),
     *   (CLKOLS(CLRDOP),DOPCL), (CLKOLS(CLRATM),ATMCL),
     *   (CLKOLS(CLRDAT),DATMCL)
      EQUIVALENCE (CLKOLS(CLRMD1),MBD1CL),
     *   (CLKOLS(CLRCK1),CLK1CL), (CLKOLS(CLRDC1),DCK1CL),
     *   (CLKOLS(CLRDS1),DIS1CL), (CLKOLS(CLRDD1),DDS1CL),
     *   (CLKOLS(CLRRE1),RE1CL), (CLKOLS(CLRIM1),IM1CL),
     *   (CLKOLS(CLRRA1),RA1CL), (CLKOLS(CLRDE1),DE1CL),
     *   (CLKOLS(CLRWE1),WE1CL), (CLKOLS(CLIRF1),RF1CL)
      EQUIVALENCE (CLKOLS(CLRMD2),MBD2CL),
     *   (CLKOLS(CLRCK2),CLK2CL), (CLKOLS(CLRDC2),DCK2CL),
     *   (CLKOLS(CLRDS2),DIS2CL), (CLKOLS(CLRDD2),DDS2CL),
     *   (CLKOLS(CLRRE2),RE2CL), (CLKOLS(CLRIM2),IM2CL),
     *   (CLKOLS(CLRRA2),RA2CL), (CLKOLS(CLRDE2),DE2CL),
     *   (CLKOLS(CLRWE2),WE2CL), (CLKOLS(CLIRF2),RF2CL)
C
      EQUIVALENCE (SNRECI, SNRECR, SNRECD)
C                                                          End ATMCA
LOCAL END
      PROGRAM ATMCA
C-----------------------------------------------------------------------
C! Determines delay to the target source observing nearby calibrators
C# UV Calibration EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2004-2005, 2011-2012, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task ATMCA provides estimation of the atmosphere delay towards
C   the target source using observation of several calibrators at its
C   vicinity
C   Inputs:
C      INNAME.....UV file name (name).       Standard defaults.
C      INCLASS....UV file name (class).      Standard defaults.
C      INSEQ......UV file name (seq. #).     0 => highest.
C      INDISK.....Disk unit #.               0 => any.
C      SNVER......The SN table version number - source of input data
C      GAINVER....Input CL table to copy to GAINUSE and then correct
C      GAINUSE....Output Cl table
C      APARM(10)..Control parameters
C      SOURCES....Source list to calibrate .
C                 ' ' = all; a "-" before a source
C                 name means all except ANY source named.
C                 The first in the list is the target source
C      CALSOUR....Calibrator list to select from the SN table
C                 ' ' = all; a "-" before a calibrator
C                 name means all except ANY calibrator named.
C      STOKES.....The desired Stokes type of the data:
C                 'R' = RCP, 'L' = LCP, 'other' = all available
C      SELBAN.....Bandwidth to select (kHz)
C      SELFREQ....Frequency to select (MHz)
C      FREQID.....Freq. ID to select, 0=>all
C      BIF........Lowest IF number, 0=>all
C      EIF........Highest IF number, 0=>all
C      TIMERANG...Time range of the data to be calibrateded. In order:
C                 Start day, hour, min. sec,
C                 end day, hour, min. sec. Days relative to ref.
C                 date.
C      ANTENNAS...A list of the antennas to be callibrated. All 0 => all.
C                 If any number is negative then all antennas listed
C                 are NOT to be callibrated and all others are.
C      SUBARRAY...The subarray to callibrate. Do only one at a time.
C      SOLINT.....Duration of time intervals to find the solutions,
C                 in min.
C      OPTYPE.....The SN table Data to be fitted:
C                 'MDEL' =>  multiband delay,
C                 'PHAS' or '    ' =>  = phase delay
C      OUTFILE....Output file name. The free term and slopes for each
C                 solution interval and antennas.
C      BADDISK....A list of disks on which scratch files are not to
C                 be placed.
C
C programmer: Leonia Kogan, May 2004
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'ATMCA.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'ATMCA '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL ATMCIN (PRGM, IRET)
C                                       read SN table, select
C                                       calibrators. Fits the plane,
C                                       correct CL table
      IF (IRET.EQ.0) CALL ATMAIN (IRET)
C                                       Copy and update HI file.
      IF (IRET.EQ.0) CALL ATMHIS
C                                       Close down files, etc.
      CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE ATMCIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   ATMCIN gets input parameters for ATMCA.
C   Inputs:  PRGN    C*6       Program name
C   Output:  JERR    I         Error code: 0 => ok
C                                1 => Invalid request
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   JERR, NSOUR
C
      CHARACTER STAT*4, BLANK*4, UTYPE*2, CODE(5)*4
      LOGICAL   T, MATCH
      INTEGER   IERR, I, IROUND, LUN, IIVER, NCODE, SNTOT,
     *   NIDCC, IS, SID, IEND, NUMCL, LUN2, TABUFF(512)
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'ATMCA.INC'
      INTEGER   DUMMY(MAXIF)
      REAL      FINC(MAXIF), TTIME
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DOTTV.INC'
C
      DATA NCODE, CODE /5, 'PHAS','MDEL','    ','    ','    '/
      DATA BLANK /'    '/
      DATA T /.TRUE./
      DATA LUN, LUN2  /29, 28/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T, BUFFER)
      CALL VHDRIN
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
C      NPARM = 353
C      NPARM = 354
C                                       removed NPLOTS, XINC, DOTV,
C                                       GRCHAN, PRTLEV
      NPARM = 349
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 10
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
C                                       Restart AIPS
 10   IF (RQUICK) CALL RELPOP (JERR, BUFFER, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      SUBA = XSUBA + 0.5
      IF (SUBA.LE.0) SUBA = 1
C
      DOHIST = XDOHI.GT.0.0
      DO 15 I = 1,10
         IBAD(I) = IROUND (XBAD(I))
 15      CONTINUE
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XXSTOK, XSTOK)
      CALL H2CHR (4, 1, XOPTY, OPTYPE)
      CALL H2CHR (48, 1, XOFILE, OFILE)
C                                       calculate the output file?
      DOUTFI = OFILE(1:1) .NE. ' '
C                                       OPTYPE ?
      ICODE = 1
      DO 20 I = 1,NCODE
         IF ((OPTYPE(1:3).EQ.CODE(I)(1:3)) .AND. (OPTYPE.NE.BLANK))
     *      ICODE = I
 20      CONTINUE
C
      DO 30 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
         CALL H2CHR (16, 1, XXCALB(1,I), XCALIB(I))
 30      CONTINUE
C                                       Timerange
      TIMBEG = XTIME(1) + XTIME(2) / 24.0 + XTIME(3) / (24.0*60.0) +
     *   (XTIME(4) / (24.0*60.0*60.0))
      TIMEND = XTIME(5) + XTIME(6) / 24.0 + XTIME(7) / (24.0*60.0) +
     *   (XTIME(8) / (24.0*60.0*60.0))
      IF ((TIMEND.LT.TIMBEG) .OR. (TIMEND.LT.1.0E-5)) TIMEND = 1.0E20
      IF ((TIMEND.LT.TIMBEG) .OR. (TIMBEG.LT.1.0E-5)) TIMBEG = 0.0
C                                       Find file, read CATBLK
      CNOIN = 1
      STAT = 'SRCH'
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 40
         WRITE (MSGTXT,1020) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
 40   CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'WRIT', BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 45
         WRITE (MSGTXT,1040) IERR
         GO TO 990
 45   NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Number of terms at the
C                                       fitting linear combination
      NFITA = APARM(1)
C                                       default NFITA=2
      IF (NFITA.LT.1) NFITA=2
C                                       fit elevations for ant and ref
      DOELRE = .FALSE.
      IF (NFITA .EQ. 5) THEN
         DOELRE = .TRUE.
         NFITA = 2
         END IF
C                                       Create CL table?
      DOCL = (APARM(2).GT.0.5)
C                                       Create output SN table?
C      DOSN = (APARM(3).GT.0.5 .AND. (NFITA.NE.1 .AND. .NOT.DOELRE))
      DOSN = (APARM(3).GT.0.5)
C                                       Table version numbers
      SNVER = IROUND (XSNVER)
      CLVER = IROUND (XGVER)
C                                       Defaults for CL tables
      CALL FNDEXT ('CL', CATBLK, NUMCL)
      IF (CLVER.LE.0 .OR. CLVER.GT.NUMCL) CLVER = NUMCL
      CLUSE = NUMCL + 1
C                                       Prohibit CLUSE=1
      IF (CLUSE.EQ.1) THEN
         JERR = 5
         MSGTXT = 'ERROR: IT IS FORBIDDEN TO MODIFY CL VERSION 1'
         GO TO 990
         END IF
C                                       copy CLVER table to CLUSE table
      IF (DOCL) THEN
         CALL TABCOP ('CL', CLVER, CLUSE, LUN, LUN2, DISKIN,DISKIN,
     *      CNOIN, CNOIN, CATBLK, BUFF1, TABUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR
            GO TO 990
            END IF
         END IF
C                                       determine number of SN tables
      CALL FNDEXT ('SN', CATBLK, SNTOT)
      IF (SNVER.EQ.0 .OR. SNVER.GT.SNTOT) SNVER = SNTOT
C                                       output SN table
      SNOUT = SNTOT + 1
C                                       IF range
      BIF = IROUND (XBIF)
      EIF = IROUND (XEIF)
      IF (BIF.LE.0) BIF = 1
      IF ((EIF.LE.0) .AND. (JLOCIF.GT.0)) EIF = CATBLK(KINAX+JLOCIF)
      IF (EIF.LE.0) EIF = 1
      IF ((JLOCIF.GT.0) .AND. (BIF.GT.CATBLK(KINAX+JLOCIF)))
     *   BIF = CATBLK(KINAX+JLOCIF)
      IF ((JLOCIF.GT.0) .AND. (EIF.GT.CATBLK(KINAX+JLOCIF)))
     *   EIF = CATBLK(KINAX+JLOCIF)
C                                       NNIF number of selected IFs
      NNIF = EIF - BIF + 1
C                                       NNNIF number of IFs in data
      NNNIF = CATBLK(KINAX+JLOCIF)
C                                       Select sources
      NIDS = MXSOU
      NSOUR = 30
      CALL SOUSEL (XSOUR, NSOUR, DISKIN, CNOIN, CATBLK, BIF, NNIF,
     *   BUFFER, IDS, NIDS, RAS, DECS, SOUS, FLUXX, JERR)
      IF (JERR.NE.0) GO TO 999
C                                       initiate the sources for future
C                                       using in ATMOCL
      DO 50 IS = 1, NIDS
         FSOUCL(IS) = .TRUE.
   50    CONTINUE
C                                       initiate the sources for future
C                                       using in ATMOSN
      DO 55 IS = 1, NIDS
         FSOUSN(IS) = .TRUE.
   55    CONTINUE
C                                       history: sources
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2350)
      NIDCC = (NIDS-0.1) / 3
      DO 60 IS = 1, NIDCC+1
         NUMHIS = NUMHIS + 1
         IF (NIDS.GE.3*IS) THEN
            IEND = 3
         ELSE
            IEND = NIDS - 3*(IS-1)
            END IF
         WRITE (HISCRD(NUMHIS),2400) (SOUS(3*(IS-1) + I), I = 1,IEND)
 60      CONTINUE
C                                       Select calibrators
      NIDC = MXSOU
      NSOUR = 30
      CALL SOUSEL (XCALIB, NSOUR, DISKIN, CNOIN, CATBLK, BIF, NNIF,
     *   BUFFER, IDC, NIDC, RAC, DECC, SOUC, FLUXX, JERR)
      IF (JERR.NE.0) GO TO 999
C                                       store the calibrator positions
C                                       relatively the first calibrator
      DO 65 SID  = 1, NIDC
         DDECC(SID) = DECC(SID) - DECC(1)
         DRAC(SID) = (RAC(SID) - RAC(1)) *
     *      DCOS( (DECC(SID) + DECC(1))/2 )
   65    CONTINUE
C                                       store the source  positions
C                                       relatively the first calibrator
      DO 68 SID  = 1, NIDS
         DDECS(SID) = DECS(SID) - DECC(1)
         DRAS(SID) = (RAS(SID) - RAC(1)) *
     *      DCOS( (DECS(SID) + DECC(1))/2 )
   68    CONTINUE
C                                       history: calibrators
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2550)
      NIDCC = (NIDC-0.1) / 3
      DO 70 IS = 1, NIDCC+1
         NUMHIS = NUMHIS + 1
         IF (NIDC.GE.3*IS) THEN
            IEND = 3
         ELSE
            IEND = NIDC - 3*(IS-1)
            END IF
         WRITE (HISCRD(NUMHIS),2600) (SOUC(3*(IS-1) + I), I = 1,IEND)
 70      CONTINUE
C                                       select antennas
      NANTSL = 50
      CALL ANTSEL (XANT, NANTSL, SUBA, DISKIN, CNOIN, CATBLK,
     *   BUFFER, JERR)
      IF (NSTNS.EQ.0) THEN
         WRITE (MSGTXT,1400)
         JERR = 5
         GO TO 990
         END IF
C                                       history: antennas
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2650)
      NIDCC = (NSTNS-0.1) / 10
      DO 80 IS = 1, NIDCC+1
         NUMHIS = NUMHIS + 1
         IF (NSTNS.GE.10*IS) THEN
            IEND = 10
         ELSE
            IEND = NSTNS - 10*(IS-1)
            END IF
         WRITE (HISCRD(NUMHIS),2700) (TELNO(10*(IS-1) + I), I = 1,IEND)
 80      CONTINUE
C
      NRPARM = CATBLK(KIPCN)
C                                       Freq id
      FREQID = IROUND (XFQID)
      IF (FREQID.LE.0) FREQID = -1
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FREQID, JERR)
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1060)
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       Stokes' type.
      STOKK(1) = 'Rpol'
      STOKK(2) = 'Lpol'
      IF ((CATBLK(KINAX+JLOCS).EQ.1) .AND.
     *   (ICOR0.EQ.-2)) STOKK(1) = 'Lpol'
      NSS = MIN (2, CATBLK(KINAX+JLOCS))
      NS = 1
      ISTOK = 0
      IF (XSTOK.EQ.'R   ') ISTOK = 1
      IF (XSTOK.EQ.'L   ') ISTOK = NSS
C                                       If none selected take what you
C                                       have.
      IF (ISTOK.EQ.0) THEN
         NS = NSS
         ISTOK = 1
C                                       Is selected Stokes' available?
      ELSE
         IF ((CATBLK(KINAX+JLOCS).EQ.1) .AND.
     *      ( (ICOR0.EQ.-1) .AND. (XSTOK.EQ.'L   ') .OR.
     *       (ICOR0.EQ.-2) .AND. (XSTOK.EQ.'R   '))) THEN
            JERR = 1
            MSGTXT = 'STOKES ' // XSTOK // ' UNAVAILABLE IN DATA'
            GO TO 990
            END IF
         END IF
      JERR = 0
C                                       history file
      NUMHIS = NUMHIS + 1
      TTIME = 0
      DO 90 I = 1, 8
         TTIME = TTIME + XTIME(I)
 90      CONTINUE
      IF (TTIME.EQ.0.0) THEN
         WRITE (HISCRD(NUMHIS),2100)
      ELSE
         WRITE (HISCRD(NUMHIS),2200) (XTIME(I),I=1,8)
         END IF
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2300) SNVER, CLVER, CLUSE
       NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2750) BIF, EIF, FREQID, SUBA
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2800) OPTYPE
      IF (NS.EQ.2) THEN
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2900)
      ELSE
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2950) STOKK(ISTOK)
         END IF
C
C                                       Get IF information
      IIVER = 1
      CALL CHNDAT ('READ', BUFFER, DISKIN, CNOIN, IIVER, CATBLK, LUN,
     *   NUMIF, FRQOFF, DUMMY, FINC, BNDCOD, FREQID, JERR)
      IF (JERR.NE.0) GO TO 999
C
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ATMCIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1020 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1060 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
 1100 FORMAT ('ERROR: COPYING INPUT CL TO OUTPUT:',I4)
 1400 FORMAT ('ANTSEL: NOONE ANTENNA SELECTED')

 2100 FORMAT ('TIMERANG = beginning to end')
 2200 FORMAT (F3.0,1X,F3.0,F3.0,F4.1,' - ',F3.0,1X,F3.0,F3.0,F4.1,
     *   '/ Time range')
 2300 FORMAT ('Input SN table =',I3, 5X, 'Input CL table =',I3,
     *   'Output CL table =',I3)
 2350 FORMAT (5X,'Selected sources')
 2400 FORMAT (3A16)
 2550 FORMAT (5X,'Selected calibrators')
 2600 FORMAT (3A16)
 2650 FORMAT (5X,'Selected antennas')
 2700 FORMAT (10I4)
 2750 FORMAT ('BIF =', I3,5X, 'EIF =', I3,5X,'FREQID =',
     *   I3,5X,'SUBARRAY =', I3)
 2800 FORMAT ('OPTYPE = ',A4)
 2900 FORMAT ('STOKES = Rpol and Lpol')
 2950 FORMAT ('STOKES = ', A4)
       END
      SUBROUTINE ATMAIN (IERR)
C-----------------------------------------------------------------------
C   ATMAIN is called from ATMCA. ATMAIN reads through the SN table,
C   fits the plain to the calibrator data, makes the corrections for
C   the  sources listed in SOURCES into the CL table.
C   Output: IERR  I    Return code, 0=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      LOGICAL   T, F
      CHARACTER COLHED(2)*24, IGFILE*48
      INTEGER   NKEY, LKEY, KEY(2,2), TAKOLS(2), TABUFF(512),
     *   KEYSUB(2,2)
      REAL      FKEY(2,2)
C
      INTEGER   LUN, LUN2, ISNRNO, NUMREC, NUMNOD, ISN, JIF, JS,
     *   SOUN, FREQN, MODENO, IANT, KS, KIF, LANT, SID, SIDSTA,
     *   SIDK, NFIT, IFIT, KFIT, IKFIT, IC, SNOUTP,
     *   KC, LFIT, LIFIT, IIFSTO, KANT, IFITA, IFIANT, ICLRNO
      LOGICAL   ISAPL, FIRST
      REAL      RANOD(25), DECNOD(25), ELEV, COSZ, DELEV, DELEVR,
     *   ELEREF
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'ATMCA.INC'
      INCLUDE 'INCS:PSNTAB.INC'
      REAL      REAL(2,MAXIF), IMAG(2,MAXIF), DELAY(2,MAXIF),
     *   RATE(2,MAXIF), WEIGHT(2,MAXIF), MBDELY(2), TIMINT, IFRM,
     *   HL, COEF(MAXFIT), MM2DEG, RMSD, DISP(2), DDISP(2)
      INTEGER   REFA(2,MAXIF), REFN, REFOLD, ISOLIN, IFSIDE(MAXIF), IIF,
     *   LUNPR, PFIND, NCH, ITRIM, TIME(3), NOBSSO(MXAN), NOBSS, INOBS,
     *   BUFF3(256), BUFF4(256)
      LOGICAL   YESSOU(MXANSO)
      REAL      SECNDS
      CHARACTER TSIGN, LINE*80, BNDCOD(MAXIF)*8

      DOUBLE PRECISION IFFREQ(MAXIF)
      DOUBLE PRECISION  R(MAXFIT), MATR(MAXFIT*MAXFIT),
     *   NOBSAN(MXAN), SUMANT(MXAN), SSQANT(MXAN),
     *   RRANT(MAXFIT), MTRANT(MAXFIT*MAXFIT), NOBS, SUM, SSQ
C
      DOUBLE PRECISION TCENTE
      REAL      IFCHW(MAXIF), IFTBW(MAXIF)
      REAL VALCUR
Ctemporal
      REAL PHAS0(10), SLRA(10), SLDEC(10), SLTIME(10)
      DOUBLE PRECISION CTIM, SIDT
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
C      INCLUDE 'INCS:ZPBUFSZ.INC'
      DATA LUN, LUN2  /29, 28/
      DATA SIDT /1.00273790935D0/
      DATA NKEY, LKEY /2,24/
      DATA T, F /.TRUE.,.FALSE./
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
      DATA COLHED /'TIME', 'ANTENNA NO.'/
C-----------------------------------------------------------------------
C                                       Edge time in days
C                                       Jumps accumulated until this
C                                       time
C      TCENTE = (4 + 40.0/60.0)/24.0
      TCENTE = APARM(5)
C                                       sort the CL table if required
      IF (DOCL) THEN
C                                       Open CL table
         CALL CALINI ('READ', BUFFER, DISKIN, CNOIN, CLUSE, CATBLK,
     *      LUN, ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF,
     *      NTERM, GMMOD, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Get number of records
         NUMREC = BUFFER(5)
         IF (NUMREC.LE.0) GO TO 999

C                                       Set column pointers for sort
         CALL FNDCOL (NKEY, COLHED, LKEY, T, BUFFER, TAKOLS, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR
            GO TO 990
            END IF
C                                       Close CL table.
         CALL TABIO ('CLOS', 0, ICLRNO, DELAY, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       Sort to time-ant order.
C                                       if necessary
         IF (BUFFER(43).NE.TAKOLS(1) .OR. BUFFER(44).NE.TAKOLS(2))
     *      THEN
            KEY(1,1) = TAKOLS(1)
            KEY(2,1) = TAKOLS(1)
            KEY(1,2) = TAKOLS(2)
            KEY(2,2) = TAKOLS(2)
            CALL TABSRT (DISKIN, CNOIN, 'CL', CLUSE, CLUSE, KEY, KEYSUB,
     *         FKEY, BUFFER, CATBLK, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1200) IERR
               GO TO 990
               END IF
            END IF
         END IF
C                                       end of CL table sort
      CALL GETFQ (FREQID, DISKIN, CNOIN, CATBLK, LUN, IFFREQ, IFTBW,
     *   IFCHW, IFSIDE, BNDCOD, IERR)
C
      DO 15 IIF = 1, NUMIF
C                                       Wavelength in mm
         LAMBDA(IIF) = VELITE / (SAFREQ + IFFREQ(IIF)) * 1000
   15    CONTINUE
      IF (IERR.NE.0) GO TO 900

C                                       solve the phase ambiguaty
C                                       if phase is used
      IF (ICODE.EQ.1) THEN
C                                       intermediate table next after
C                                       the last one
         SNOUTP = SNOUT
C                                       intermediate table next after
C                                       the output SN table if it
C                                       creates
         IF (DOSN) SNOUTP = SNOUT + 1
         CALL SNAMBG (DISKIN, CNOIN, SNVER, SNOUTP, TCENTE, IERR)
         WRITE (MSGTXT,1650) SNOUTP
         CALL MSGWRT (8)
C
         SNVER = SNOUTP
         END IF
C   --------------------------------------------------------------
C   |  Read the SN table the first time to sort it by ant-time   |
C   --------------------------------------------------------------
C                                       Open input SN table
      CALL SNINI ('READ', BUFFER, DISKIN, CNOIN, SNVER, CATBLK, LUN,
     *   ISNRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD,
     *   GMMOD, RANOD, DECNOD, ISAPL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get number of records
      NUMREC = BUFFER(5)
      IF (NUMREC.LE.0) GO TO 999
C                                       Set column pointers for sort
      CALL FNDCOL (NKEY, COLHED, LKEY, T, BUFFER, TAKOLS, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1100) IERR
         GO TO 990
         END IF
C                                       Close SN table.
      CALL TABIO ('CLOS', 0, ISNRNO, DELAY, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Sort to time-ant order.
C                                       if necessary
      IF (BUFFER(43).NE.TAKOLS(1) .OR. BUFFER(44).NE.TAKOLS(2))
     *   THEN
         KEY(1,1) = TAKOLS(1)
         KEY(2,1) = TAKOLS(1)
         KEY(1,2) = TAKOLS(2)
         KEY(2,2) = TAKOLS(2)
C                                       sort input SN table
         CALL TABSRT (DISKIN, CNOIN, 'SN', SNVER, SNVER, KEY, KEYSUB,
     *      FKEY, BUFFER, CATBLK, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1200) IERR
            GO TO 990
            END IF
         END IF
C                                       copy the sorted input SN table
C                                       to the output SN table
      IF (DOSN) THEN
         CALL TABCOP ('SN', SNVER, SNOUT, LUN, LUN2, DISKIN, DISKIN,
     *      CNOIN, CNOIN, CATBLK, BUFF1, TABUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1250) IERR, SNVER, SNOUT
            GO TO 990
            END IF
         END IF
C   -----------------------------------------------------------
C   |   Read the SN table the second time to store solutions  |
C   |           (delays) for each selected antenna            |
C   -----------------------------------------------------------
C
C                                       open the OUTFILE
      IF (DOUTFI) THEN
         LUNPR = 3
         CALL ZTXOPN ('WRIT', LUNPR, PFIND, OFILE, F, IERR)
         END IF
C                                       Open SN table
      CALL SNINI ('READ', BUFFER, DISKIN, CNOIN, SNVER, CATBLK, LUN,
     *   ISNRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPL, IERR)
      IF (IERR.NE.0) GO TO 999
C
      NFIT = NFITA*NSTNS
C
C                                       Force result vector R(NFIT),
C                                       matrice MATR, NOBS, SUM, SSQ
C                                       to zero
      DO 30 IANT = 1, NSTNS
         NOBSAN(IANT) = 0
         SUMANT(IANT) = 0
         SSQANT(IANT) = 0
         NOBSSO(IANT) = 0
C                                       Initiate all selected sources
C                                       appearence for antennas
C                                       in the solution interval
         DO 20 SID = 1, NIDC
            YESSOU(SID + NIDC*(IANT-1)) = T
            VALSAN(SID + NIDC*(IANT-1)) = 0
            NVALSO(SID + NIDC*(IANT-1)) = 0
   20       CONTINUE
   30    CONTINUE
      DO 50 IFIT = 1, NFIT
         R(IFIT) = 0.0
         DO 40 KFIT = 1, NFIT
            IKFIT = KFIT + (IFIT - 1)*NFIT
            MATR (IKFIT) = 0.0
   40       CONTINUE
   50    CONTINUE
      ISOLIN = 0
C                                       Get number of records
      NUMREC = BUFFER(5)
      IF (NUMREC.LE.0) GO TO 999
      FIRST = T
C                                       default of SOLIN is 30min
      IF (SOLINT .LT. 0.1) SOLINT = 30
C                                       SOLINT in days
      SOLINT = SOLINT/60.0/24.0
C                                       model to test
      DO 60 IANT = 1, NSTNS
         PHAS0(IANT) = 11 + (IANT-1)*5
         SLRA(IANT) = (5 + (IANT-1)*0.2) / DG2RAD
         SLDEC(IANT) = (3 + (IANT-1)*0.3) / DG2RAD
         SLTIME(IANT) = (2 + (IANT-1)*0.1) * 24.0 * 60.0
   60    CONTINUE
C                                       initial CL row number
      KCLRNO = 1
      KSNRNO = 1
      FIRSCL = .TRUE.
      FIRSSN = .TRUE.
C                                       conversion mm to degree
      MM2DEG = 360.0/LAMBDA(1)
C                                       Do not use the first(reference)
C                                       calibrator, if the only two
C                                       slopes are going to find.
C                                       (NFITA=APARM(1)=2)
C                                       Count of the calibrator list
C                                       will start with the second
C                                       calibrator (SIDSTA=2)
      IF (NFITA .EQ. 2) THEN
         SIDSTA = 2
      ELSE
         SIDSTA = 1
         END IF
C                                       Still use the first (reference)
C                                       calibrator points if APARM(4)=0
      IF (APARM(4) .EQ. 0 .AND. .NOT.DOELRE) SIDSTA = 1
C                                       delete? the intermediate SN
C                                       table
      SNDELE = APARM(6) .EQ. 0
C                                       RANOLD for checking if there is
C                                       only one reference antenna
      REFOLD = -10
C                                       cycle to NUMREC+1 to include
C                                       the last point to the solution
      DO 500 ISNRNO = 1, NUMREC+1
         ENDSN = ISNRNO.EQ.NUMREC+1
         IF (ENDSN) GO TO 115
C                                       read SN table
         ISN = ISNRNO
         CALL TABSN ('READ', BUFFER, ISN, SNKOLS, SNNUMV, NSS, CTIM,
     *      TIMINT, SOUN, LANT, SUBA, FREQN, IFRM, MODENO, MBDELY, DISP,
     *      DDISP, REAL, IMAG, DELAY, RATE, WEIGHT, REFA, IERR)
C                                       check if record is flagged
         IF (IERR.LT.0) GO TO 500
C                                       FREQID selection
         IF ((FREQN.NE.0) .AND. (FREQN.NE.FREQID)) GO TO 500
C                                       antennas selection
         DO 70 IANT = 1,NSTNS
            IF (TELNO(IANT).EQ.LANT) GO TO 80
   70       CONTINUE
         GO TO 500
C                                       calibrators selection
C                                       To use the first(reference)
C                                       calibrator or not to use?
C
   80    DO 90 SID = SIDSTA, NIDC
            IF (IDC(SID).EQ.SOUN) GO TO 110
   90       CONTINUE
         GO TO 500
  110    CONTINUE
C?????????????check comparison CTIM=D with TIMBEG=R
C                                       timerange selection
         IF (CTIM.LT.TIMBEG) THEN
            GO TO 500
         ELSE
            IF (FIRST) THEN
               TSTART = CTIM
               TFINIS = TSTART + SOLINT
C                                       time of target source  TTARG
C                                       as the center of the current
C                                       solint interval
               TTARG = (TSTART + TFINIS) / 2
               FIRST = F
               END IF
            END IF

C                                       timerange selection
         IF (CTIM.GT.TIMEND) GO TO 520
C                                       calculates elevations and
C                                       use the refer. antennas
C                                       only IF DOELRE=T
         IF (.NOT. DOELRE) GO TO 115
C                                       Exclude the rows IANT=REFN
         REFN = REFA(1,1)
C
C                                       Exclude the rows IANT=REFN
         IF (TELNO(IANT) .EQ. REFN) GO TO 500
C                                       calculate elevation of
C                                       the SN row antenna for
C                                       the SN row source
         HL = TWOPI*SIDT*CTIM + GSTIAT + STNLON(IANT) - RAC(SID)
         COSZ = DCOS(STNLAT(IANT))*DCOS(DECC(SID))*COS(HL) +
     *      DSIN(STNLAT(IANT))*DSIN(DECC(SID))
C                                       source is under horizon
         IF (COSZ.LT.0.0) GO TO 500
         ELEV = PI/2.0 - ACOS(COSZ)

C                                       calculate elevation of
C                                       the SN row antenna for
C                                       the reference calibrator
C                                       (first in the list)
         HL = TWOPI*SIDT*CTIM + GSTIAT + STNLON(IANT) - RAC(1)
         COSZ = DCOS(STNLAT(IANT))*DCOS(DECC(1))*COS(HL) +
     *      DSIN(STNLAT(IANT))*DSIN(DECC(1))
C                                       source is under horizon
         IF (COSZ.LT.0.0) GO TO 500
C                                       difference in elevation
C                                       for the antenna IANT:
C                                       given source - ref. source
         DELEV = ELEV -(PI/2.0 - ACOS(COSZ))
C                                       Is the reference antenna
C                                       in the selected antenna list?
         IF (REFOLD .EQ. -10) THEN
C                                       select the first line reference
C                                       antenna
            REFOLD = REFN
            DO 111 RANT = 1,NSTNS
               IF (TELNO(RANT).EQ.REFN) GO TO 112
  111       CONTINUE
C
            IERR = 1
            WRITE (MSGTXT,1040) REFN
            GO TO 990
C
  112       CONTINUE
         ELSE
            IF (REFN .EQ. REFOLD) THEN
               GO TO 113
            ELSE
               IERR = 1
               WRITE (MSGTXT,1050) ISN
               GO TO 990
               END IF
            END IF
C                                       calculate elevation of the
C                                       SN row reference antenna
C                                       for the SN row source
  113    HL = TWOPI*SIDT*CTIM + GSTIAT + STNLON(RANT) - RAC(SID)
         COSZ = DCOS(STNLAT(RANT))*DCOS(DECC(SID))*COS(HL) +
     *      DSIN(STNLAT(RANT))*DSIN(DECC(SID))
C                                       source is under horizon
         IF (COSZ.LT.0.0) GO TO 500
         ELEREF = PI/2.0 - ACOS(COSZ)
C                                       calculate elevation of
C                                       the refer. antenna for
C                                       the reference calibrator
C                                       (first in the list)
         HL = TWOPI*SIDT*CTIM + GSTIAT + STNLON(RANT) - RAC(1)
         COSZ = DCOS(STNLAT(RANT))*DCOS(DECC(1))*COS(HL) +
     *      DSIN(STNLAT(RANT))*DSIN(DECC(1))
C                                       source is under horizon
         IF (COSZ.LT.0.0) GO TO 500
C                                       difference in elevation
C                                       for the refer. antenna :
C                                       given source - ref. source
         DELEVR = ELEREF -(PI/2.0 - ACOS(COSZ))
C----------------begin of the current solution----------------------
  115    CONTINUE
C
         IF ((CTIM.GT.TFINIS) .OR. ENDSN) THEN
            IF (NFITA .EQ. 1) THEN
C                                       average phases/delays
               DO 118 KANT = 1, NSTNS
                  DO 117 SIDK = 1, NIDC
                     IF (NVALSO(SIDK + NIDC*(KANT-1)) .NE. 0)
     *                  VALSAN(SIDK + NIDC*(KANT-1)) =
     *                  VALSAN(SIDK + NIDC*(KANT-1)) /
     *                  NVALSO(SIDK + NIDC*(KANT-1))
  117                CONTINUE
  118             CONTINUE
               GO TO 205
               END IF
            ISOLIN = ISOLIN + 1
C                                       find the solition for each
C                                       selected antenna
            CALL TFDHMS (TTARG, 1, TSIGN, TIME, SECNDS)
C                                       header of the print out
            IF (ICODE.EQ.1) THEN
               WRITE (MSGTXT,1500)
            ELSE IF (ICODE.EQ.2) THEN
               WRITE (MSGTXT,1600)
               END IF
            CALL MSGWRT (8)
            IF (DOUTFI) THEN
C                                       header of the outfile
               IF (ICODE.EQ.1) THEN
                  WRITE (LINE, 1500)
               ELSE IF (ICODE.EQ.2) THEN
                  WRITE (LINE,1600)
                  END IF
               NCH = ITRIM(LINE)
               CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IERR)
               END IF
C
            DO 200 KANT = 1, NSTNS
               NOBS = NOBSAN(KANT)
               INOBS = NOBS
C                                       number of succesfully observed
C                                       calibrators
               NOBSS = NOBSSO(KANT)
C                                       allow the same source for
C                                       APARM(1) = 5
               IF (DOELRE) NOBSS = NOBS
C                                       Include all source observations
C                                       if time slope fit is included
               IF (NFITA .EQ. 4) NOBSS = NOBS
C                                       find solution only if number of
C                                       observed succesfully sources
C                                       .GE.NFITA
               IF (NOBSS.GE.NFITA) THEN
                  SUM =  SUMANT(KANT)
                  SSQ =  SSQANT(KANT)
                  DO 130 IC = 1, NFITA
                     IFIT = IC + NFITA*(KANT-1)
                     RRANT(IC) = R(IFIT)
                     DO 120 KC = 1, NFITA
                        LFIT = KC + NFITA*(KANT-1)
                        LIFIT = LFIT + (IFIT-1)*NFIT
                        MTRANT(KC + (IC-1)*NFITA) = MATR(LIFIT)
  120                   CONTINUE
  130                CONTINUE
C
                  CALL DLESQR (NFITA, NOBS, SUM, SSQ, RRANT, MTRANT,
     *                  SOL,VX, SSQRES, VARRES, VARY, FIT, LESOL)
                  RMSD = SQRT(VARRES)
C
                  IF (DOUTFI) THEN
C                                       record in the OUTFILE:
                     IF (ICODE.EQ.1) THEN
                        WRITE (LINE,1300) TSIGN, TIME, SECNDS,
     *                     TELNO(KANT), INOBS, SOL(3)*MM2DEG,
     *                     SOL(1)*DG2RAD*MM2DEG,
     *                     SOL(2)*DG2RAD*MM2DEG,
     *                     SOL(4)/24.0/60.0*MM2DEG, RMSD*MM2DEG
                     ELSE IF (ICODE.EQ.2) THEN
                        WRITE (LINE, 1350) TSIGN, TIME, SECNDS,
     *                     TELNO(KANT), INOBS, SOL(3),
     *                     SOL(1)*DG2RAD,
     *                     SOL(2)*DG2RAD, SOL(4)/24.0/60.0, RMSD
                        END IF

C
                     NCH = ITRIM(LINE)
                     CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH),
     *                  IERR)
                     END IF
               ELSE
                  DO 140 IFITA = 1, NFITA
                     SOL(IFITA)= 0
  140                CONTINUE
                  END IF
C
               IF (ICODE.EQ.1) THEN
                  WRITE (MSGTXT,1300) TSIGN, TIME, SECNDS,
     *               TELNO(KANT), INOBS, SOL(3)*MM2DEG,
     *               SOL(1)*DG2RAD*MM2DEG,
     *               SOL(2)*DG2RAD*MM2DEG,
     *               SOL(4)/24.0/60.0*MM2DEG, RMSD*MM2DEG
               ELSE IF (ICODE.EQ.2) THEN
                  WRITE (MSGTXT,1350) TSIGN, TIME, SECNDS,
     *               TELNO(KANT), INOBS, SOL(3), SOL(1)*DG2RAD,
     *               SOL(2)*DG2RAD, SOL(4)/24.0/60.0, RMSD
                  END IF
               CALL MSGWRT (8)
               DO 150 IFITA = 1, NFITA
                  IFIANT = IFITA + NFITA*(KANT-1)
                  SOLANT(IFIANT) = SOL(IFITA)
  150             CONTINUE
  200          CONTINUE
C                                       End of solution for both
C                                       NFITA.EQ.1 and NFITA.NE.1
  205       CONTINUE
C                                       update CL table
            IF(DOCL) CALL OUTCL(IERR)
C                                       update output SN table
            IF(DOSN) CALL OUTSN(IERR)
C                                       Force result vector R(NFIT),
C                                       matrice MATR, NOBS, SUM, SSQ
C                                       to zero
C
            DO 220 KANT = 1, NSTNS
               NOBSAN(KANT) = 0
               SUMANT(KANT) = 0
               SSQANT(KANT) = 0
               NOBSSO(KANT) = 0
C                                       Initiate all selected sources
C                                       appearence for antennas
C                                       in the solution interval
               DO 210 SIDK = 1, NIDC
                  YESSOU(SIDK + NIDC*(KANT-1)) = T
                  VALSAN(SIDK + NIDC*(KANT-1)) = 0
                  NVALSO(SIDK + NIDC*(KANT-1)) = 0
  210             CONTINUE
  220          CONTINUE
C
            DO 240 IFIT = 1, NFIT
               R(IFIT) = 0.0
               DO 230 KFIT = 1, NFIT
                  IKFIT = KFIT + (IFIT - 1)*NFIT
                  MATR (IKFIT) = 0.0
  230             CONTINUE
  240          CONTINUE
            TSTART = CTIM
            TFINIS = TSTART + SOLINT
C                                       time of target source
C                                       TTARG for the current solint
C                                       interval
            TTARG = (TSTART + TFINIS) / 2
            END IF
C----------------end of the current solution----------------------
C                                       finish if ISNRNO.EQ.NUMREC+1
         IF (ENDSN) GO TO 500
C
C                                       average VALs through all IFs
C                                       and stokes
         VALCUR = 0
         IIFSTO = 0
         DO 280 JIF = 1,NNIF
            KIF = BIF + JIF -1
            DO 270 JS = 1,NS
               KS = ISTOK + JS -1
C                                       chose a type of variable
C                                       phase / delay
               IF (ICODE.EQ.1) THEN
C                                       ICODE=1 corresponds to the
C                                       phase delay
                  IF ((REAL(KS,KIF).EQ.FBLANK) .OR.
     *               (IMAG(KS,KIF).EQ.FBLANK)) THEN
                     GO TO 270
                  ELSE
                     IIFSTO = IIFSTO + 1
C                                       phase delay in mm
C                     VALCUR = VALCUR +
C     *                  ATAN2(IMAG(KS,KIF), REAL(KS,KIF))
C     *                  / TWOPI * LAMBDA(KIF)
C                                       REAL is phase in degrees
C                                       solved by two pi ambiguaty
                     VALCUR = VALCUR +
     *                  REAL(KS,KIF) / 360.0 * LAMBDA(KIF)
                     END IF
               ELSE IF (ICODE.EQ.2) THEN
C                                       MBDELY should be identical
C                                       for all IFS. So use only
C                                       JIF=1
                  IF (JIF .GT. 1) GO TO 270
                  IF (MBDELY(KS).EQ.FBLANK) THEN
                     GO TO 270
                  ELSE
                     IIFSTO = IIFSTO + 1
C                                       delay in mm
                     VALCUR = VALCUR +
     *                  MBDELY(KS) *VELITE *1000
                     END IF
                  END IF
C
 270           CONTINUE
 280        CONTINUE
C
         IF (IIFSTO.GT.0) THEN
C                                       VALUE.NE.FBLANK at least
C                                       for one IF,STOKES
            VALCUR = VALCUR / IIFSTO
         ELSE
C                                       VALCUE.EQ.FBLANK for all
C                                       IF,STOKES
            VALCUR = FBLANK
            END IF
C
         IF (VALCUR.EQ.FBLANK) GOTO 500
C                                       accumulate the values for all
C                                       antennas and calibrators
         VALSAN(SID + NIDC*(IANT-1)) =
     *      VALSAN(SID + NIDC*(IANT-1)) + VALCUR
         NVALSO(SID + NIDC*(IANT-1)) =
     *      NVALSO(SID + NIDC*(IANT-1)) + 1
C                                       Go to the next line if
C                                       NFITA.EQ.1
         IF (NFITA .EQ. 1) THEN
            GO TO 500
            END IF
C                                       coefficients of linear
C                                       interpretation of VALCUR
C                                       in vicinity of the reference
C                                       source. The reference source
C                                       is the first source at the
C                                       CAIBRATOR list!!!!
         IF (NFITA .EQ. 2) THEN
            IF (DOELRE) THEN
C                                       elevation gradients for
C                                       the Antenna and Reference ant.
C                                       in radians

               COEF(1) =  DELEV
               COEF(2) = -DELEVR
               COEF(3) = 0
               COEF(4) = 0
C                                       for test
C               VALCUR = (5*COEF(1) + 2*COEF(2))*RAD2DG
            ELSE
C                                       Only two slopes (RA,DEC)
C                                       are found
C                                       No solution for the offset
C                                       (COEF(3)=0)
               COEF(1) = DRAC(SID)
               COEF(2) = DDECC(SID)
               COEF(3) = 0
               COEF(4) = 0
               END IF
            END IF
         IF (NFITA .EQ. 3) THEN
C                                       The two slopes plus offset are
C                                       found. Yes solution for the
C                                       offset (COEF(3)=1)
            COEF(1) = DRAC(SID)
            COEF(2) = DDECC(SID)
            COEF(3) = 1
            COEF(4) = 0
            END IF
         IF (NFITA .EQ. 4) THEN
C                                       The two space slopes plus
C                                       offset plus time slopes are
C                                       found.
            COEF(1) = DRAC(SID)
            COEF(2) = DDECC(SID)
            COEF(3) = 1
            COEF(4) = CTIM - TTARG
            END IF
C
         NOBSAN(IANT) = NOBSAN(IANT) + 1
         IF (YESSOU(SID + NIDC*(IANT-1))) THEN
            YESSOU(SID + NIDC*(IANT-1)) = F
            NOBSSO(IANT) = NOBSSO(IANT) + 1
            END IF

         SUMANT(IANT) = SUMANT(IANT) + VALCUR
         SSQANT(IANT) = SSQANT(IANT) + VALCUR*VALCUR
C                                       Prepare result vector R(NFIT)
C                                       and matrix MATR(NFIT*NFIT)
C                                       for routine LEASQR
C  --------------------------------------------------------------------
C I    Each measurement (the SN table row for IANT) is fitted as:      |
C |                                                                    |
C |       VALUE(IANT) = FIT(1)*COEF(1) + FIT(2)*COEF(2) +              |
C |                     FIT(3)*COEF(3) + FIT(4)*COEF(4)                |
C |     COEF(1)=1,  COEF(2)=DRA,  COEF(3)=DDEC,  COEF(4)=DTIM          |
C  --------------------------------------------------------------------
C
C                                       TEST model!
C         VALCUR = PHAS0(IANT)*COEF(3) + SLRA(IANT)*COEF(1) +
C     *      SLDEC(IANT)*COEF(2)
C         VALCUR = PHAS0(IANT)*COEF(3) + SLRA(IANT)*COEF(1) +
C     *      SLDEC(IANT)*COEF(2) + SLTIME(IANT)*COEF(4)
C-------------------------------
C                                       calculate matrix MATR
         DO 320 IC = 1, NFITA
C                                       IFIT,KFIT are column number
            IFIT = IC + NFITA*(IANT-1)
            R(IFIT) = R(IFIT) + VALCUR * COEF(IC)
            DO 310 KC = 1, NFITA
C                                       LFIT,MFIT are row number
               LFIT = KC + NFITA*(IANT-1)
C                                       LIFIT number of MATR element
C                                       counting starts along column
               LIFIT = LFIT + (IFIT-1)*NFIT
C
               MATR(LIFIT) = MATR(LIFIT) + COEF(IC)*COEF(KC)
  310          CONTINUE
  320       CONTINUE

  500    CONTINUE
  520 CONTINUE
C
      IF (DOUTFI) THEN
C                                       close the OUTFILE
         CALL ZTXCLS (LUNPR, PFIND, IERR)
         END IF
      CALL TABIO ('CLOS', 0, ISNRNO, DELAY, BUFFER, IERR)
C
      IF (SNDELE .AND. ICODE.EQ.1)  THEN
C                                       delete the SN table with solved
C                                       two pi ambiguity if required
C
C                                       Build file name.
         CALL ZPHFIL ('SN', DISKIN, CNOIN, SNOUTP, IGFILE, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1670)
            CALL MSGWRT (8)
            GO TO 999
            END IF
         CALL ZDESTR (DISKIN, IGFILE, IERR)
C
         CALL DELEXT ('SN', DISKIN, CNOIN, 'WRWR',
     *      BUFF3, BUFF4, SNOUTP, IERR)
         WRITE (MSGTXT,1700) SNOUTP
         CALL MSGWRT (8)
         IF (DOSN) THEN
C                                       delete the output SN table also
C
C                                       Build file name.
            CALL ZPHFIL ('SN', DISKIN, CNOIN, SNOUT, IGFILE, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1670)
               CALL MSGWRT (8)
               GO TO 999
               END IF
            CALL ZDESTR (DISKIN, IGFILE, IERR)
C
            CALL DELEXT ('SN', DISKIN, CNOIN, 'WRWR',
     *         BUFF3, BUFF4, SNOUT, IERR)
            WRITE (MSGTXT,1700) SNOUT
            CALL MSGWRT (8)
            END IF
         END IF
C
      IF (IERR.NE.0) GO TO 900
      GO TO 999
C                                       TABIO error
 900  WRITE (MSGTXT,1400) IERR
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('ANTENNAs do not include the reference ant.', I3)
 1050 FORMAT ('Reference antenna at row ', I5, ' is different')
 1100 FORMAT ('ERROR ',I5,' FINDING SN TABLE COLUMNS')
 1200 FORMAT ('TABSRT ERROR ',I5,' SORTING input SN TABLE')
 1250 FORMAT ('TABCOP ERROR ',I5,' COPIING',I3,' TO',I3,' SN TABLE')
 1300 FORMAT ( A1, 3I3, F5.1, I3, 3X, I3, 1X, F6.2,2X,F6.2,3X,F6.2,
     *            3X, F6.2, 1X, F6.2)
 1350 FORMAT ( A1, 3I3, F5.1, I3, 3X, I3, 1X, F6.2,2X,F6.3,3X,F6.3,
     *            3X, F6.3, 1X, F6.3)
 1400 FORMAT ('TABIO: ERROR = ', I3)
 1500 FORMAT ('    D:H:M:S', 5X, 'ANT',2X,'NOBS',3X,'deg',2X,
     *      'deg/deg',2X,'deg/deg',2X,'deg/min', 2X, 'rms')
 1600 FORMAT ('    D:H:M:S', 5X, 'ANT',2X,'NOBS',3X,'mm',3X,'mm/deg',
     *      3X,'mm/deg',3X,'mm/min', 2X, 'rms')
 1650 FORMAT ('!! Intermediate SN table ', I3, ' created !!')
 1670 FORMAT ('COULD NOT BUILD SN FILE NAME')
 1700 FORMAT ('!! Intermediate SN table ', I3, ' deleted !!')
      END
      SUBROUTINE SOUSEL (SOURCE, NSOUR, DISK, CNO, CAT, BIF, NNIF,
     *   BUFFER, ID, NID, RA, DEC, SOUS, FLUXS, IRET)
C-----------------------------------------------------------------------
C   Load all selected source identifiers from SU table.
C-----------------------------------------------------------------------
C   Inputs:
C      SOURCE  C*16(*)   List of source names.
C                        If the first character of any source names
C                        begins with a "-", all sources EXCEPT those
C                        named will be returned ( the "-" will be
C                        ignored in determining the source name).
C                        Blank source names are ignored.  Names should
C                        be left justified, blank filled
C      NSOUR     I       Number of entries in SOURCE
C      DISK      I       Disk number of the data set.
C      CNO       I       Catalog slot number of data set.
C      CAT       I(256)  Catalog header.
C      BIF       I       Beginning IF
C      NNIF      I       Number of selected IFs
C   Input/Output:
C      BUFFER    I(512)  Work buffer, used for I/O and manipulating
C                        source lists, should be at least min (512,NID)
C   Output:
C      ID        I(*)    Sources ID numbers of selected sources,
C      NID       I       Number of elements returned in ID.
C      RA        D(*)    Array of selected calibrators' RA
C      DEC       D(*)    Array of selected calibrators' declinations
C      SOUS      C*16(*) Names of selected sources
C      FLUXS     R(*)    Flux density of selected sources
C      IRET      I       Return code. 0 => OK; else failed.
C   Usage notes:
C       This routine uses AIPS LUN 27 which will be closed on normal
C       return. Version 1 of the source table is assumed.
C-----------------------------------------------------------------------
      CHARACTER SOURCE(*)*16, SOUS(*)*16, SOUST(50)*16
      INTEGER   DISK, CNO, NID, CAT(256), BUFFER(*), ID(*), KID, IID,
     *   IDT(50), BIF, NNIF, IRET
C
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4
      INTEGER   VER, LUN, IDKOL, SUKOL,IDSOU, SQUAL, MAXID,
     *   NUMIF, ISURNO, NUMREC, I4, SUFQID, NSOUR, I, J, SKIF, SIF
      LOGICAL   EQUAL, DESEL, ALLBL, GOTIT
      DOUBLE PRECISION    BANDW, RAEPO, DECEPO, EPOCH, RAAPP, DECAPP,
     *   PMRA, PMDEC, RA(*), DEC(*), PI, DEGRAD, RAT(50), DECT(50),
     *   RAOBS, DECOBS
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   SUKOLS(MAXSUC), SUNUMV(MAXSUC)
      REAL      FLUX(4,MAXIF), FREQO(MAXIF), RESTFQ(MAXIF), FLUXS(*),
     *   FLUXST(800)
      DOUBLE PRECISION LSRVEL(MAXIF)
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (IDKOL, SUKOLS(1)),   (SUKOL, SUKOLS(2))
      DATA VER, LUN /1, 27/
      DATA PI /3.14159265358979323846D0/
C-----------------------------------------------------------------------
      DEGRAD = PI/180.0D0
      MAXID = NID
      NID = 0
      IRET = 0
      DESEL = .FALSE.
      ALLBL = .TRUE.
      DO 10 I = 1,NSOUR
C                                       Check deselection
         DESEL = DESEL .OR. SOURCE(I)(1:1).EQ.'-'
C                                       Check if all blank, select
         ALLBL = ALLBL .AND. (SOURCE(I).EQ.'                ')
C
 10      CONTINUE
C                                       Initialize SOURCE table.
      CALL SOUINI ('READ', BUFFER, DISK, CNO, VER, CAT, LUN, NUMIF,
     *   VELTYP, VELDEF, SUFQID, ISURNO, SUKOLS, SUNUMV, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
         END IF
C                                       number of subrows (IFS)
C                                       Get number of entries
      NUMREC = BUFFER(5)
C                                       Loop through source records.
      DO 500 ISURNO = 1,NUMREC
C                                       Read record
         I4 = ISURNO
         CALL TABSOU ('READ', BUFFER, I4, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, SQUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA,
     *      PMDEC, IRET)
C                                       See is source record turned off
         IF (IRET.LT.0) GO TO 500
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
            END IF
C                                       Check if in list SOURCE.
         GOTIT = .FALSE.
         DO 300 J = 1,NSOUR
C                                       See if deselected.
            IF (.NOT.DESEL) THEN
C                                       Sources selected.
               EQUAL = SOURCE(J).EQ.SOUNAM
C                                       cover blank source
               EQUAL = EQUAL .OR. ALLBL
               IF (EQUAL) THEN
                  IF ((NID+1).LE.MAXID) THEN
                     NID = NID + 1
                     ID(NID) = IDSOU
                     RA(NID) = RAAPP*DEGRAD
                     DEC(NID) = DECAPP*DEGRAD
                     SOUS(NID) = SOUNAM
C                                       take IFLUX
                     DO 20 I = 1, NNIF
                        SIF = I + (NID-1)*NNIF
                        FLUXS(SIF) = FLUX(1,I +BIF -1)
                        IF (FLUXS(SIF).EQ.0.0) FLUXS(SIF) = 1.0
   20                   CONTINUE
                     GO TO 500
                  ELSE
C                                       Too many sources selected
                     WRITE (MSGTXT,1300) MAXID
                     IRET = 5
                     GO TO 990
                     END IF
                  END IF
            ELSE
C                                       Deselected
C                                       Check for leading "-"
               IF (SOURCE(J)(1:1).EQ.'-') THEN
                  EQUAL = SOURCE(J)(2:16).EQ.SOUNAM(1:15)
               ELSE
                  EQUAL = SOURCE(J).EQ.SOUNAM
                  END IF
               GOTIT = GOTIT .OR. EQUAL
               END IF
 300        CONTINUE
            IF (DESEL .AND. (.NOT.GOTIT)) THEN
C                                       Source not deselected
               IF ((NID+1).LE.MAXID) THEN
                  NID = NID + 1
                  ID(NID) = IDSOU
                  RA(NID) = RAAPP*DEGRAD
                  DEC(NID) = DECAPP*DEGRAD
                  SOUS(NID) = SOUNAM
                  DO 320 I = 1, NNIF
                     SIF = I + (NID-1)*NNIF
                     FLUXS(SIF) = FLUX(1,I +BIF -1)
 320                 CONTINUE
               ELSE
C                                       Too many sources selected
                  WRITE (MSGTXT,1300) MAXID
                  IRET = 5
                  GO TO 990
                  END IF
               END IF
 500     CONTINUE
C                                       Close Source table
      CALL TABIO ('CLOS', 0, I4, FLUX, BUFFER, IRET)

C                                       sort sources if they named
      IF ((.NOT.DESEL) .AND. (.NOT.ALLBL)) THEN
         KID = 0
         DO 580 J = 1, NSOUR
            DO 560 IID = 1, NID
               IF (SOURCE(J).EQ.SOUS(IID)) THEN
                  KID = KID + 1
                  IDT(KID) = ID(IID)
                  RAT(KID) = RA(IID)
                  DECT(KID) = DEC(IID)
                  SOUST(KID) = SOUS(IID)
                  DO 520 I = 1, NNIF
                     SKIF = I + (KID-1)*NNIF
                     SIF = I + (IID-1)*NNIF
                     FLUXST(SKIF) = FLUXS(SIF)
 520                 CONTINUE
                  END IF
 560           CONTINUE
 580        CONTINUE
         NID = KID
         DO 600 IID = 1, NID
            ID(IID) = IDT(IID)
            RA(IID) = RAT(IID)
            DEC(IID) = DECT(IID)
            SOUS(IID) = SOUST(IID)
            DO 590 I = 1, NNIF
               SIF = I + (IID-1)*NNIF
               FLUXS(SIF) = FLUXST(SIF)
 590          CONTINUE
 600        CONTINUE
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('SOUSEL: ERROR ',I3,' INITIALIZING SOURCE TABLE')
 1120 FORMAT ('SOUSEL: ERROR ',I3,' READING SOURCE TABLE')
 1300 FORMAT ('SOUSEL: MORE SOURCES SELECTED THAN MAX (',I5,')')
      END
      SUBROUTINE ANTSEL (XANT, NANTSL, SUBA, DISK, CNO, CAT,
     *   BUFFER, IRET)
C-----------------------------------------------------------------------
C   Select anntennas from AN file
C-----------------------------------------------------------------------
C   Inputs:
C      XANT      R(*)    List of antennas numbers.
C                        If any of the numbers is negative all antennas
C                        EXCEPT those named will be returned
C      NANTSL    I       Number of entries in XANT
C      DISK      I       Disk number of the data set.
C      CNO       I       Catalog slot number of data set.
C      CAT       I(256)  Catalog header.
C   Outputs sent to COMMON (DANS.INC):
C      NSTNS    I        Number of elements returned in TELNO
C      STNNAM   C(*)*8   Antenna names
C      TELNO    I(*)     Antennas numbers of selected antennas
C      STNX     D(*)     X (meters)
C      STNY     D(*)     Y (meters)
C      STNZ     D(*)     Z (meters)
C      STNLAT   D(*)     Antenna latitude (rad).
C      STNLON   D(*)     Antenna east longitude (rad).
C      STNRAD   D(*)     Antenna radius from earth center (meter)
C      STNEPL   R(2,*)   Feed real/elipticity (poln, IF)
C      STNORI   R(2,*)   Feed imag/orientation (poln, IF)
C      STNPST   C*8      Feed solution type:
C                           'APPROX  ' => linear approximation
C                           'ORI-ELP ' => orientation-ellipticity
C      TIMLAB   C*8      Time system label (e.g. 'IAT', 'UTC')
C      ANTUTC   R        UT1-UTC (time sec)
C      ANTIAT   R        Data time - UTC (sec)
C      GSTIAT   D        GST (rad) at IAT=0 on reference date.
C      ROTIAT   D        Rotation rate of the earth in IAT (Radians/day)
C      ANTUTC   R        UT1-UTC (time sec)
C      ANTIAT   R        Data time - UTC (sec)
C      FQIDAN   I        FQID for which polzn properties determined.
C   Output:
C      BUFFER    I(512)  Work buffer
C      IRET      I       Return code. 0 => OK; else failed.
C   Usage notes:
C       This routine uses AIPS LUN 27 which will be closed on normal
C       return. Version 1 of the source table is assumed.
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, IANT, CAT(256), BUFFER(*), I, J, MXAN,
     *   ANTENS(50), NANTSL, LIMIT, NEXT, SUBA, INTANT, IRET
      REAL      XANT(*)
      LOGICAL   EQUAL, DESEL, ALLANT, GOTIT
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      MXAN = NANTSL
C                                       Get antenna info
      CALL GETANT (DISK, CNO, SUBA, CAT, BUFFER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
         END IF
C                                       Antenna list
      ALLANT = .TRUE.
      DESEL = .FALSE.
      DO 10 I = 1, NANTSL
         ANTENS(I) = 0
         ALLANT = ALLANT .AND. (ABS (XANT(I)).LE.1.0E-10)
         DESEL = DESEL .OR. (XANT(I).LT.-0.5)
 10      CONTINUE
      IF (ALLANT) THEN
         NANTSL = NSTNS
         GO TO 60
         END IF
      NEXT = 1
C                                       Not all selected - make list
C                                       ANTENNAS array worriing repeating
         DO 50 I = 1,50
            IF (XANT(I).EQ.0) GO TO 50
C                                       See if already have
               INTANT = XANT(I)
               LIMIT = NEXT - 1
               IF (LIMIT.LT.1) GO TO 40
               DO 30 J = 1,LIMIT
                  IF (INTANT.EQ.ANTENS(J)) GO TO 50
 30               CONTINUE
C                                       New antenna
 40               ANTENS(NEXT) = XANT(I)
                  NEXT = NEXT + 1
 50            CONTINUE
      NANTSL = NEXT - 1
 60   CONTINUE
C                                       Setup
      IANT = 0
      IRET = 0
C                                       Loop through AN file records.
      DO 500 I = 1,NSTNS
C                                       Check if in list XANT.
         GOTIT = .FALSE.
         DO 300 J = 1, NANTSL
C                                       See if deselected.
            IF (.NOT.DESEL) THEN
C                                       Sources selected.
               EQUAL = ANTENS(J).EQ.TELNO(I)
C                                       cover blank antens
               EQUAL = EQUAL .OR. ALLANT
               IF (EQUAL) THEN
                  IF ((IANT+1).LE.MXAN) THEN
                     IANT = IANT + 1
                     STNNAM(IANT) = STNNAM(I)
                     TELNO(IANT) = TELNO(I)
                     STNX(IANT) = STNX(I)
                     STNY(IANT) = STNY(I)
                     STNZ(IANT) = STNZ(I)
                     STNLAT(IANT) = STNLAT(I)
                     STNLON(IANT) = STNLON(I)
                     STNRAD(IANT) = STNRAD(I)
                     GO TO 500
                  ELSE
C                                       Too many antenns selected
                     WRITE (MSGTXT,1300) MXAN
                     IRET = 5
                     GO TO 990
                     END IF
                  END IF
            ELSE
C                                       Deselected
               EQUAL = ABS(ANTENS(J)).EQ.TELNO(I)
               GOTIT = GOTIT .OR. EQUAL
               END IF
 300        CONTINUE
            IF (DESEL .AND. (.NOT.GOTIT)) THEN
C                                       Antens not deselected
               IF ((IANT+1).LE.MXAN) THEN
                  IANT = IANT + 1
                  STNNAM(IANT) = STNNAM(I)
                  TELNO(IANT) = TELNO(I)
                  STNX(IANT) = STNX(I)
                  STNY(IANT) = STNY(I)
                  STNZ(IANT) = STNZ(I)
                  STNLAT(IANT) = STNLAT(I)
                  STNLON(IANT) = STNLON(I)
                  STNRAD(IANT) = STNRAD(I)
                  GO TO 500
               ELSE
C                                       Too many antenns selected
                  WRITE (MSGTXT,1300) MXAN
                  IRET = 5
                  GO TO 990
                  END IF
               END IF
 500     CONTINUE
      NSTNS = IANT
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ANTSEL:',I3,' READING ANTENNA TABLE')
 1300 FORMAT ('ANTSEL: MORE ANTENS SELECTED THAN MAX (',I5,')')
      END
C
      SUBROUTINE OUTCL (IERR)
C-----------------------------------------------------------------------
C   OUTCL makes the corrections of the CL table No high+1
C   Output: IERR  I    Return code, 0=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER MAXLIN
      PARAMETER (MAXLIN=10000)
      INTEGER   LUN, IRCODE, THSOU, ANT, IANT, SID,
     *   ICLRNO, NUMREC
      INTEGER   BUFFCL(1024)
      DOUBLE PRECISION   TCLT
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'ATMCA.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN /27/
C-----------------------------------------------------------------------
C                                       Open CL table
      NUMPOL = 1
      IF (CATBLK(KINAX+JLOCS).GT.1) NUMPOL = 2
      NUMIF = 1
      IF (JLOCIF.GT.0) NUMIF = CATBLK(KINAX+JLOCIF)
C                                       Reformat table?
      IF (FIRSCL) THEN
         IF (NFITA .EQ. 1) THEN
            MSGTXT = '-----------CL table outputs warnings:-----------'
            CALL MSGWRT (8)
            END IF
         CALL CLREFM (DISKIN, CNOIN, CLUSE, CATBLK, LUN, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL CALINI ('WRIT', BUFFCL, DISKIN, CNOIN, CLUSE, CATBLK,
     *      LUN, ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF,
     *      NTERM, GMMOD, IERR)
         IF (IERR.NE.0) GO TO 999
         FIRSCL = .FALSE.
         FIXCL = 0
         END IF

C                                       Get number of records
      NUMREC = BUFFCL(5)
      IF (NUMREC.LE.0) GO TO 999
      IRCODE = 0
C
      ICLRNO = KCLRNO - 1
  500    CONTINUE
C
         ICLRNO = ICLRNO + 1
C
         IF (ICLRNO .GT. NUMREC) GO TO 520
         CALL TABIO ('READ', IRCODE, ICLRNO, CLRECR, BUFFCL, IERR)
C
         IF (IERR.GT.0) GO TO 900
         IF (IERR.LT.0) GO TO 500
C                                       Check data

C                                       Subarray
         IF ((CLRECI(SUBCL).NE.SUBA) .AND. (CLRECI(SUBCL).GT.0))
     *      GO TO 500
C                                       Freq id
         IF ((CLRECI(FRQCL).NE.FREQID) .AND. (CLRECI(FRQCL).GT.0) .AND.
     *      (FREQID.GT.0)) GO TO 500
C                                       Check source
         THSOU = CLRECI(SOUCL)
C                                       sources selection
         DO 10 SID = 1, NIDS
            IF (IDS(SID).EQ.THSOU) GO TO 20
   10       CONTINUE
         GO TO 500
   20    CONTINUE
C
C                                       Check antenna
         ANT = CLRECI(ANTCL)
         DO 30 IANT = 1, NSTNS
            IF (TELNO(IANT).EQ. ANT) GO TO 40
   30       CONTINUE
         GO TO 500
   40    CONTINUE

C                                       Time:
         IF (CLRECD(TIMCL).LE.TFINIS .OR. ENDSN) THEN
C                                       Correct record.
            FIXCL = FIXCL + 1
C                                       Correction of the CL row
C                                       based on PHAS0 and SLTIME
C
C                                       time at the CL table line,
C                                       in days
            TCLT = CLRECD(TIMCL)
C                                       calculate the corrections to
C                                       the CL table
            CALL ATMOCL (TCLT, IANT, SID, IERR)
            IF (IERR.NE.0) GO TO 500
C                                       Rewrite record
            IF (DOCL) CALL TABIO ('WRIT', IRCODE, ICLRNO, CLRECR, BUFFCL
     *         ,IERR)
            IF (IERR.GT.0) GO TO 900
            GO TO 500
         ELSE
            KCLRNO = ICLRNO
            GO TO 999
            END IF
C
  520 CONTINUE
C
      NUMHIS= NUMHIS + 1
      WRITE (HISCRD(NUMHIS),1100) FIXCL
      WRITE (MSGTXT,1200) FIXCL, CLUSE
      CALL MSGWRT (6)
C                                       Update GMMOD
C      IF (ABS (GMMOD-1.0).LE.1.0E-5) GO TO 600
C      CALL TABKEY ('WRIT', KEYWRD, 1, BUFFCL, 1, GMMOD, 2, IERR)
C                                       Close CL table.
C!!!!!!!!!!!!!!change LOOP for ICRNO
C      CALL TABIO ('CLOS', IRCODE, LOOP, CLRECR, BUFFCL, IERR)
      CALL TABIO ('CLOS', IRCODE, ICLRNO, CLRECR, BUFFCL, IERR)
      IF (IERR.NE.0) GO TO 900
      GO TO 999
C                                       TABIO error
 900  WRITE (MSGTXT,1300) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT (' / ',I6,' Records modified')
 1200 FORMAT (I6,' records of the CL table ', I2, ' modified')
 1300 FORMAT ('TABIO ERROR',I3,' CORRECTING CL TABLE')
      END
C
C
      SUBROUTINE OUTSN (IERR)
C-----------------------------------------------------------------------
C   OUTSN makes the corrections of the output SN  table No high+1
C   Output: IERR  I    Return code, 0=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   LUN, THSOU, ANT, IANT, SID,
     *   ISNRNO, NUMREC, LANT
      INTEGER   BUFFSN(1024)
      INTEGER   NUMNOD, SOUN, ISN, SUBOUT, FREQN, MODENO
C
      INTEGER   NKEY, LOCS, KEYTYP
C      CHARACTER KEYW*8
      DOUBLE PRECISION   TCLT
C
C(NOT)TEMPORALLY IT WAS PCLTAB
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'INCS:PSNTAB.INC'
      INCLUDE 'ATMCA.INC'
C
      REAL      RANOD(25), DECNOD(25), REAL(2,MAXIF), IMAG(2,MAXIF),
     *   DELAY(2,MAXIF), DISP(2), DDISP(2),
     *   RATE(2,MAXIF), WEIGHT(2,MAXIF), MBDELY(2), TIMINT, IFRM
      DOUBLE PRECISION CTIM
      LOGICAL   ISAPL
      INTEGER   REFA(2,MAXIF)

      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN /28/
C      DATA KEYW /'APPLIED '/
C-----------------------------------------------------------------------
      NUMPOL = 1
      IF (CATBLK(KINAX+JLOCS).GT.1) NUMPOL = 2
      NUMIF = 1
      IF (JLOCIF.GT.0) NUMIF = CATBLK(KINAX+JLOCIF)
      IF (FIRSSN) THEN
         IF (NFITA .EQ. 1) THEN
            MSGTXT = '-----------SN table outputs warnings:-----------'
            CALL MSGWRT (8)
            END IF
C                                       Open output SN table
         CALL SNINI ('WRIT', BUFFSN, DISKIN, CNOIN, SNOUT, CATBLK, LUN,
     *      ISNRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD,
     *      GMMOD, RANOD, DECNOD, ISAPL, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Mark output SN table APPLIED.
C                                       Having spoken with Eric it
C                                       is decided not changing
C                                       'APPLIED' to 'TRUE'
C                                       because the output SN table
C                                       is atmosphere residual and can
C                                       be applied .LK. 06/10/04
               NKEY = 1
               LOCS = 1
               KEYTYP = 5
C                                       Rewrite
C               CALL TABKEY ('WRIT', KEYW, NKEY, BUFFSN, LOCS, T, KEYTYP,
C     *            IERR)
C
         FIRSSN = .FALSE.
         FIXSN = 0
         END IF
C                                       Get number of records
      NUMREC = BUFFSN(5)
      IF (NUMREC.LE.0) GO TO 999
C
      ISNRNO = KSNRNO - 1
  500    CONTINUE
C
         ISNRNO = ISNRNO + 1
C
         IF (ISNRNO .GT. NUMREC) GO TO 520
C                                       read SN table
         ISN = ISNRNO
         CALL TABSN ('READ', BUFFSN, ISN, SNKOLS, SNNUMV, NSS, CTIM,
     *      TIMINT, SOUN, LANT, SUBOUT, FREQN, IFRM, MODENO, MBDELY,
     *      DISP, DDISP, REAL, IMAG, DELAY, RATE, WEIGHT, REFA, IERR)
C
         IF (IERR.GT.0) GO TO 900
         IF (IERR.LT.0) GO TO 500
C                                       Check data
C
C                                       Subarray
         IF ((SUBOUT.NE.SUBA) .AND. (SUBOUT.GT.0))
     *      GO TO 500
C                                       Freq id
         IF ((FREQN.NE.FREQID) .AND. (FREQN.GT.0) .AND.
     *      (FREQID.GT.0)) GO TO 500
C                                       Check source
         THSOU = SOUN
C                                       sources selection of the list
C                                       given in CALSOUR
         DO 10 SID = 1, NIDC
            IF (IDC(SID).EQ.THSOU) GO TO 20
   10       CONTINUE
         GO TO 500
   20    CONTINUE
C
C                                       Check antenna
         ANT = LANT
         DO 30 IANT = 1, NSTNS
            IF (TELNO(IANT).EQ. ANT) GO TO 40
   30       CONTINUE
         GO TO 500
   40    CONTINUE
C                                       Time:
         IF (CTIM.LE.TFINIS .OR. ENDSN) THEN
C                                       Correct record.
            FIXSN = FIXSN + 1
            TCLT = CTIM
            CALL ATMOSN (TCLT, IANT, SID, MBDELY, REAL, IMAG, DELAY,
     *         RATE, IERR)
            IF (IERR.NE.0) GO TO 500
C                                       Rewrite record
            ISN = ISNRNO
            CALL TABSN ('WRIT', BUFFSN, ISN, SNKOLS, SNNUMV, NSS, CTIM,
     *         TIMINT, SOUN, LANT, SUBOUT, FREQN, IFRM, MODENO, MBDELY,
     *         DISP, DDISP, REAL, IMAG, DELAY, RATE, WEIGHT, REFA, IERR)
            IF (IERR.GT.0) GO TO 900
            GO TO 500
         ELSE
            KSNRNO = ISNRNO
            GO TO 999
            END IF
C
  520 CONTINUE
C
      NUMHIS= NUMHIS + 1
      WRITE (HISCRD(NUMHIS),1100) FIXSN
      WRITE (MSGTXT,1200) FIXSN, SNOUT
      CALL MSGWRT (6)

C                                       Close SN table.
      CALL TABIO ('CLOS', 0, ISNRNO, DELAY, BUFFSN, IERR)
      IF (IERR.NE.0) GO TO 900
      GO TO 999
C                                       TABIO error
 900  WRITE (MSGTXT,1300) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT (' / ',I6,' Records modified')
 1200 FORMAT (I6,' records of the output SN table ', I2, ' modified')
 1300 FORMAT ('TABIO ERROR',I3,' CORRECTING SN TABLE')
      END
C
      SUBROUTINE ATMOCL (TCLT, IANT, SID, IERR)
C-----------------------------------------------------------------------
C   Routine to apply atmospheric  corrections to the
C   given CL table row on the basis of the fitted linear representation
C   of the atmosphere at the vicinity of the calibrators
C   INPUT:
C      TCLT      D    Time at the CL table
C      IANT      I    antenna number as it selected
C       SID      I    source  number as it selected
C   Control info from common:
C      ISTOK     I    Polarization to correct, 1=first, 2=second,
C                     0 = both
C   Output:
C      IERR      I    Return error code , 0=OK else failed.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   IANT, SID
      INTEGER   I, ITEMP, SIDK
      REAL      XT, YT, PDLY, DPDLY, CFAC, SFAC, FQFAC, DELMM0, SLRA,
     *   SLDEC, SLTIME, DELMM, RTARRE, RCALRE, COSCTA, TARCOR, DVALS,
     *   PROCTA, ANGL, WEIGH

      REAL      ELEV, COSZ, DELEV, DELEVR, ELEREF, HL, SLANT, SLREF
      REAL      CTIMR
      DOUBLE PRECISION FREQS, TCLT, SIDT
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'ATMCA.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA SIDT /1.00273790935D0/
C-----------------------------------------------------------------------
      IERR = 0
      FREQS = FREQ + FREQO(BIF)
C                                       REAL time of the CL table row
      CTIMR = TCLT
C
      IF (NFITA .EQ. 1) THEN
         DELMM = 0
         WEIGH = 0
C                                       distance target - reference
         RTARRE = SQRT (DRAS(SID)*DRAS(SID) +
     *                  DDECS(SID)*DDECS(SID))
C                                       Do not correct if the source
C                                       is the reference calibrator
         IF (RTARRE .EQ. 0) GO TO 250
         DO 200 SIDK = 2, NIDC
C                                       distance calibrator - reference
            RCALRE = SQRT (DRAC(SIDK)*DRAC(SIDK) +
     *                     DDECC(SIDK)*DDECC(SIDK))
C                                       difference of phase/delay
C                                       calibrator - reference
            DVALS = VALSAN(SIDK + NIDC*(IANT-1)) -
     *              VALSAN(1 + NIDC*(IANT-1))
C                                       COS [cal-ref, tar-ref]
            COSCTA = (DRAC(SIDK)*DRAS(SID) +
     *                DDECC(SIDK)*DDECS(SID)) / RTARRE / RCALRE

C                                       projection [cal-ref]
C                                       on [tar-ref]
C                                       PROCTA includes the sign!!!
            PROCTA = COSCTA * RCALRE
C
            IF (ABS(COSCTA) .GT. 0.71) THEN
C                                       use this calibrator, if
C                                       angle (tag-ref, cal-ref)
C                                       .LE. 45 degrees
               TARCOR = DVALS / PROCTA * RTARRE
C                                       weight the correction by the
C                                       projection of the distance C-R
               DELMM = DELMM + TARCOR * ABS(PROCTA)
               WEIGH = WEIGH + ABS(PROCTA)
            ELSE
C                                       type the warning if the given
C                                       calibrator is not used for the
C                                       given target source (SID)
               IF (FSOUCL(SID)) THEN
                  ANGL = ACOS(ABS(COSCTA)) * RAD2DG
                  WRITE (MSGTXT,1200) SOUS(SID)
                  CALL MSGWRT (8)
                  WRITE (MSGTXT,1300) SOUC(1), SOUC(SIDK)
                  CALL MSGWRT (8)
                  WRITE (MSGTXT,1400) ANGL
                  CALL MSGWRT (8)
                  WRITE (MSGTXT,1500)
                  CALL MSGWRT (8)
                  END IF
               TARCOR = 0
               END IF
  200       CONTINUE
         IF (FSOUCL(SID)) THEN
            MSGTXT = ' '
            CALL MSGWRT (8)
            END IF
C                                       prevent warning for a next
C                                       appearence of the source(SID)
         FSOUCL(SID) = .FALSE.
         IF ( WEIGH .GT. 0) DELMM = DELMM / WEIGH
C                                       add the phase/delay of
C                                       the reference calibrator
         DELMM = DELMM + VALSAN(1 + NIDC*(IANT-1))
  250    CONTINUE
C
      ELSE
         IF (DOELRE) THEN
C                                       fit gradients for the ANT and
C                                       REF along elevation
            SLANT =  SOLANT(1+NFITA*(IANT-1))
            SLREF =  SOLANT(2+NFITA*(IANT-1))
C                                       calculate elevation of
C                                       the CL row antenna for
C                                       the CL row source
            HL = TWOPI*SIDT*TCLT + GSTIAT + STNLON(IANT) - RAS(SID)
            COSZ = DCOS(STNLAT(IANT))*DCOS(DECS(SID))*COS(HL) +
     *         DSIN(STNLAT(IANT))*DSIN(DECS(SID))
C                                       source is under horizon
            IF (COSZ.LT.0.0) GO TO 999
            ELEV = PI/2.0 - ACOS(COSZ)

C                                       calculate elevation of
C                                       the CL row antenna for
C                                       the reference calibrator
C                                       (first in the list)
            HL = TWOPI*SIDT*TCLT + GSTIAT + STNLON(IANT) - RAC(1)
            COSZ = DCOS(STNLAT(IANT))*DCOS(DECC(1))*COS(HL) +
     *         DSIN(STNLAT(IANT))*DSIN(DECC(1))
C                                       source is under horizon
            IF (COSZ.LT.0.0) GO TO 999
C                                       difference in elevation
C                                       for the antenna IANT:
C                                       given source - ref. source
            DELEV = ELEV -(PI/2.0 - ACOS(COSZ))
C                                       calculate elevation of the
C                                       reference antenna
C                                       for the CL row source
            HL = TWOPI*SIDT*TCLT + GSTIAT + STNLON(RANT) - RAS(SID)
            COSZ = DCOS(STNLAT(RANT))*DCOS(DECS(SID))*COS(HL) +
     *         DSIN(STNLAT(RANT))*DSIN(DECS(SID))
C                                       source is under horizon
            IF (COSZ.LT.0.0) GO TO 999
            ELEREF = PI/2.0 - ACOS(COSZ)
C                                       calculate elevation of
C                                       the refer. antenna for
C                                       the reference calibrator
C                                       (first in the list)
            HL = TWOPI*SIDT*TCLT + GSTIAT + STNLON(RANT) - RAC(1)
            COSZ = DCOS(STNLAT(RANT))*DCOS(DECC(1))*COS(HL) +
     *      DSIN(STNLAT(RANT))*DSIN(DECC(1))
C                                       source is under horizon
            IF (COSZ.LT.0.0) GO TO 999
C                                       difference in elevation
C                                       for the refer. antenna :
C                                       given source - ref. source
            DELEVR = ELEREF -(PI/2.0 - ACOS(COSZ))
C
            DELMM = SLANT*DELEV - SLREF*DELEVR
C
         ELSE
            DELMM0 = 0
            IF (NFITA .GE. 3) DELMM0 = SOLANT(3+NFITA*(IANT-1))
            SLRA =   SOLANT(1+NFITA*(IANT-1))
            SLDEC =  SOLANT(2+NFITA*(IANT-1))
            SLTIME = 0
            IF (NFITA .GE. 4) SLTIME = SOLANT(4+NFITA*(IANT-1))
C                                       delays of the source
C                                       (calibrators)
C                                       in mm
            DELMM =  DELMM0 +
     *         SLRA   * DRAS(SID) +
     *         SLDEC  * DDECS(SID) +
     *            SLTIME * (TCLT - TTARG)
            END IF
         END IF
C                                       delays of the source
C                                       in second
      PDLY = DELMM / 1000 / VELITE
      DPDLY = 0
C
      IF (.NOT. DOCL) GO TO 999


C                                       Atmospheric group delay
      IF (CLRECR(ATMCL).NE.FBLANK) CLRECR(ATMCL) = CLRECR(ATMCL)
     *      - PDLY
C                                       multiband delay
      IF (CLRECR(MBD1CL).NE.FBLANK) CLRECR(MBD1CL) = CLRECR(MBD1CL)
     *      + PDLY
      IF (ISTOK.EQ.2) GO TO 650
C
      DO 600 I = BIF,EIF
         FQFAC = (FREQS+FRQOFF(I)) * PDLY
         ITEMP = FQFAC
         FQFAC = TWOPI * (FQFAC - ITEMP)
         CFAC = COS (FQFAC)
         SFAC = SIN (FQFAC)
C                                       Phase
         XT = CLRECR(RE1CL+I-1)
         YT = CLRECR(IM1CL+I-1)
         IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
            CLRECR(RE1CL+I-1) = XT * CFAC - YT * SFAC
            CLRECR(IM1CL+I-1) = XT * SFAC + YT * CFAC
            END IF
C                                       Delay
         IF (CLRECR(DE1CL+I-1).NE.FBLANK)
     *      CLRECR(DE1CL+I-1) = CLRECR(DE1CL+I-1) + PDLY
C                                       Phase rate
         IF (CLRECR(RA1CL+I-1).NE.FBLANK)
     *      CLRECR(RA1CL+I-1) = CLRECR(RA1CL+I-1) + DPDLY
 600     CONTINUE
C
 650     IF (ISTOK.EQ.1 .AND. NS.EQ.1) GO TO 999
C                                       multi delay
      IF (CLRECR(MBD2CL).NE.FBLANK) CLRECR(MBD2CL) = CLRECR(MBD2CL)
     *      + PDLY
      DO 700 I = BIF,EIF
C                                       PDLY => correct both atm.
C                                       delay and clock shift
         FQFAC = (FREQS+FRQOFF(I)) * PDLY
         ITEMP = FQFAC
         FQFAC = TWOPI * (FQFAC - ITEMP)
         CFAC = COS (FQFAC)
         SFAC = SIN (FQFAC)
C                                       Phase
         XT = CLRECR(RE2CL+I-1)
         YT = CLRECR(IM2CL+I-1)
         IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
            CLRECR(RE2CL+I-1) = XT * CFAC - YT * SFAC
            CLRECR(IM2CL+I-1) = XT * SFAC + YT * CFAC
            END IF
C                                       Delay
         IF (CLRECR(DE2CL+I-1).NE.FBLANK)
     *      CLRECR(DE2CL+I-1) = CLRECR(DE2CL+I-1) + PDLY
C                                       Phase rate
         IF (CLRECR(RA2CL+I-1).NE.FBLANK)
     *      CLRECR(RA2CL+I-1) = CLRECR(RA2CL+I-1) + DPDLY

 700     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1200 FORMAT ('| The angle Target ', A16, 27(' '), '|')
 1300 FORMAT ('| to Reference ', A16, ' to Calibrator ',
     *   A16, '|')
 1400 FORMAT ('| is ', F4.1,
     *   ' degrees and exceeds the threshold 30 degrees ',
     *   7(' '), '|')
 1500 FORMAT ('| So the CALIBRATOR is not used with the TARGET',
     *   15(' '),'|')
      END
C
      SUBROUTINE ATMOSN (TCLT, IANT, SID, MBDELY, REAL, IMAG, DELAY,
     *         RATE, IERR)
C-----------------------------------------------------------------------
C   Routine to apply atmospheric  corrections to the
C   given SN table row on the basis of the fitted linear representation
C   of the atmosphere at the vicinity of the calibrators
C   INPUT:
C      TCLT      D    Time at the SN table row
C      IANT      I    antenna number as it selected
C       SID      I    source  number as it selected
C   Control info from common:
C      ISTOK     I    Polarization to correct, 1=first, 2=second,
C                     0 = both
C   Output:
C      IERR      I    Return error code , 0=OK else failed.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   IANT, SID
      INTEGER   I, ITEMP, SIDK
      REAL      XT, YT, PDLY, DPDLY, CFAC, SFAC, FQFAC, DELMM0, SLRA,
     *   SLDEC, SLTIME, DELMM, RTARRE, RCALRE, COSCTA, TARCOR, DVALS,
     *   PROCTA, ANGL, WEIGH

      REAL      ELEV, COSZ, DELEV, DELEVR, ELEREF, HL, SLANT, SLREF
      REAL      CTIMR
      DOUBLE PRECISION FREQS, TCLT, SIDT
CTEMPORALLY(NOT) IT was PCLTAB?
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'INCS:PSNTAB.INC'
      INCLUDE 'ATMCA.INC'
C
      REAL     REAL(2,MAXIF), IMAG(2,MAXIF), DELAY(2,MAXIF),
     *   RATE(2,MAXIF), MBDELY(2)
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA SIDT /1.00273790935D0/
C-----------------------------------------------------------------------
C
      IERR = 0
      FREQS = FREQ + FREQO(BIF)
C                                       REAL time of the CL table row
      CTIMR = TCLT
C                                       begin of the (APARM(1) =1,5)
      IF (NFITA .EQ. 1) THEN
         DELMM = 0
         WEIGH = 0
C                                       distance selected calibrator
C                                       - reference calibrator
         RTARRE = SQRT (DRAC(SID)*DRAC(SID) +
     *                  DDECC(SID)*DDECC(SID))
C                                       Do not correct the reference
C                                       calibrator (the first in the
C                                       calibrator list)
         IF (RTARRE .EQ. 0) GO TO 250
         DO 200 SIDK = 2, NIDC
C                                       distance calibrator - reference
            RCALRE = SQRT (DRAC(SIDK)*DRAC(SIDK) +
     *                     DDECC(SIDK)*DDECC(SIDK))
C                                       difference of phase/delay
C                                       calibrator - reference
            DVALS = VALSAN(SIDK + NIDC*(IANT-1)) -
     *              VALSAN(1 + NIDC*(IANT-1))
C                                       COS [cal-ref, source-ref]
            COSCTA = (DRAC(SIDK)*DRAC(SID) +
     *                DDECC(SIDK)*DDECC(SID)) / RTARRE / RCALRE

C                                       projection [cal-ref]
C                                       on [source-ref]
C                                       PROCTA includes the sign!!!
            PROCTA = COSCTA * RCALRE
C
            IF (ABS(COSCTA) .GT. 0.87) THEN
C                                       use this calibrator, if
C                                       angle (source-ref, cal-ref)
C                                       .LE. 30 degrees
               TARCOR = DVALS / PROCTA * RTARRE
C                                       weight the correction by the
C                                       projection of the distance C-R
               DELMM = DELMM + TARCOR * ABS(PROCTA)
               WEIGH = WEIGH + ABS(PROCTA)
            ELSE
C                                       type the warning if the given
C                                       calibrator is not used for the
C                                       given  source (SID)
               IF (FSOUSN(SID)) THEN
C               IF (FSOUSN(SID) .AND. .NOT.DOCL) THEN
                  ANGL = ACOS(ABS(COSCTA)) * RAD2DG
                  WRITE (MSGTXT,1200) SOUC(SID)
                  CALL MSGWRT (8)
                  WRITE (MSGTXT,1300) SOUC(1), SOUC(SIDK)
                  CALL MSGWRT (8)
                  WRITE (MSGTXT,1400) ANGL
                  CALL MSGWRT (8)
                  WRITE (MSGTXT,1500)
                  CALL MSGWRT (8)
                  END IF
               TARCOR = 0
               END IF
  200       CONTINUE
         IF (FSOUSN(SID)) THEN
            MSGTXT = ' '
            CALL MSGWRT (8)
            END IF
C                                       prevent warning for a next
C                                       appearence of the source(SID)
         FSOUSN(SID) = .FALSE.
         IF ( WEIGH .GT. 0) DELMM = DELMM / WEIGH
C                                       add the phase/delay of
C                                       the reference calibrator
         DELMM = DELMM + VALSAN(1 + NIDC*(IANT-1))
  250    CONTINUE
C
      ELSE
         IF (DOELRE) THEN
C                                       fit gradients for the ANT and
C                                       REF along elevation
            SLANT =  SOLANT(1+NFITA*(IANT-1))
            SLREF =  SOLANT(2+NFITA*(IANT-1))
C                                       calculate elevation of
C                                       the SN row antenna for
C                                       the SN row source
            HL = TWOPI*SIDT*TCLT + GSTIAT + STNLON(IANT) - RAC(SID)
            COSZ = DCOS(STNLAT(IANT))*DCOS(DECC(SID))*COS(HL) +
     *         DSIN(STNLAT(IANT))*DSIN(DECC(SID))
C                                       source is under horizon
            IF (COSZ.LT.0.0) GO TO 999
            ELEV = PI/2.0 - ACOS(COSZ)

C                                       calculate elevation of
C                                       the SN row antenna for
C                                       the reference calibrator
C                                       (first in the list)
            HL = TWOPI*SIDT*TCLT + GSTIAT + STNLON(IANT) - RAC(1)
            COSZ = DCOS(STNLAT(IANT))*DCOS(DECC(1))*COS(HL) +
     *         DSIN(STNLAT(IANT))*DSIN(DECC(1))
C                                       source is under horizon
            IF (COSZ.LT.0.0) GO TO 999
C                                       difference in elevation
C                                       for the antenna IANT:
C                                       given source - ref. source
            DELEV = ELEV -(PI/2.0 - ACOS(COSZ))
C                                       calculate elevation of the
C                                       reference antenna
C                                       for the SN row source
            HL = TWOPI*SIDT*TCLT + GSTIAT + STNLON(RANT) - RAC(SID)
            COSZ = DCOS(STNLAT(RANT))*DCOS(DECC(SID))*COS(HL) +
     *         DSIN(STNLAT(RANT))*DSIN(DECC(SID))
C                                       source is under horizon
            IF (COSZ.LT.0.0) GO TO 999
            ELEREF = PI/2.0 - ACOS(COSZ)
C                                       calculate elevation of
C                                       the refer. antenna for
C                                       the reference calibrator
C                                       (first in the list)
            HL = TWOPI*SIDT*TCLT + GSTIAT + STNLON(RANT) - RAC(1)
            COSZ = DCOS(STNLAT(RANT))*DCOS(DECC(1))*COS(HL) +
     *      DSIN(STNLAT(RANT))*DSIN(DECC(1))
C                                       source is under horizon
            IF (COSZ.LT.0.0) GO TO 999
C                                       difference in elevation
C                                       for the refer. antenna :
C                                       given source - ref. source
            DELEVR = ELEREF -(PI/2.0 - ACOS(COSZ))
C
            DELMM = SLANT*DELEV - SLREF*DELEVR
C
         ELSE
            DELMM0 = 0
            IF (NFITA .GE. 3) DELMM0 = SOLANT(3+NFITA*(IANT-1))
            SLRA =   SOLANT(1+NFITA*(IANT-1))
            SLDEC =  SOLANT(2+NFITA*(IANT-1))
            SLTIME = 0
C                                       end  of the (APARM(1) =1,5)
            IF (NFITA .GE. 4) SLTIME = SOLANT(4+NFITA*(IANT-1))
C                                       delays of the source
C                                       in mm
            DELMM =  DELMM0 +
     *         SLRA   * DRAC(SID) +
     *         SLDEC  * DDECC(SID) +
     *         SLTIME * (TCLT - TTARG)
            END IF
         END IF
C                                       correcting delay of the source
C                                       in second
      PDLY = DELMM / 1000 / VELITE
      DPDLY = 0
C                                       multiband delay of the SNOUT
C                                       minus the correcting delay
      IF (MBDELY(1).NE.FBLANK) MBDELY(1) = MBDELY(1) - PDLY
      IF (ISTOK.EQ.2) GO TO 650
C
      DO 600 I = BIF,EIF
C                                       look in ICODE
         IF (ICODE .EQ. 1) THEN
C                                       input SN table has the phase
C                                       (degrees) in the column REAL
            REAL(1,I) = REAL(1,I) - DELMM / LAMBDA(I) * 360.0
         ELSE
C                                       input SN table has the phase
C                                       in the columns REAL, IMAGE
            FQFAC = (FREQS+FRQOFF(I)) * (-PDLY)
            ITEMP = FQFAC
            FQFAC = TWOPI * (FQFAC - ITEMP)
            CFAC = COS (FQFAC)
            SFAC = SIN (FQFAC)
C                                       Phase correction considering
C                                       -PDLY
            XT = REAL(1,I)
            YT = IMAG(1,I)
            IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
               REAL(1,I) = XT * CFAC - YT * SFAC
               IMAG(1,I) = XT * SFAC + YT * CFAC
               END IF
            END IF
C                                       Delay
         IF (DELAY(1,I).NE.FBLANK) DELAY(1,I) = DELAY(1,I) - PDLY
C                                       Phase rate
         IF (RATE(1,I).NE.FBLANK) RATE(1,I) = RATE(1,I) - DPDLY
 600     CONTINUE
C
 650     IF (ISTOK.EQ.1 .AND. NS.EQ.1) GO TO 999
C                                       correction of the second
C                                       polarization
C
C                                       multi delay
      IF (MBDELY(2).NE.FBLANK) MBDELY(2) = MBDELY(2) - PDLY
      DO 700 I = BIF,EIF
C                                       look in ICODE
         IF (ICODE .EQ. 1) THEN
C                                       input SN table has the phase
C                                       (degrees) in the column REAL
            REAL(2,I) = REAL(2,I) - DELMM / LAMBDA(I) * 360.0
         ELSE
C                                       input SN table has the phase
C                                       in the columns REAL, IMAGE
            FQFAC = (FREQS+FRQOFF(I)) * (-PDLY)
            ITEMP = FQFAC
            FQFAC = TWOPI * (FQFAC - ITEMP)
            CFAC = COS (FQFAC)
            SFAC = SIN (FQFAC)
C                                       Phase correction considering
C                                       -PDLY
            XT = REAL(2,I)
            YT = IMAG(2,I)
            IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
               REAL(2,I) = XT * CFAC - YT * SFAC
               IMAG(2,I) = XT * SFAC + YT * CFAC
               END IF
            END IF
C                                       Delay
         IF (DELAY(2,I).NE.FBLANK) DELAY(2,I) = DELAY(2,I) - PDLY
C                                       Phase rate
         IF (RATE(2,I).NE.FBLANK) RATE(2,I) = RATE(2,I) - DPDLY
 700     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1200 FORMAT ('| The angle Source ', A16, 27(' '), '|')
 1300 FORMAT ('| to Reference ', A16, ' to Calibrator ',
     *   A16, '|')
 1400 FORMAT ('| is ', F4.1,
     *   ' degrees and exceeds the threshold 30 degrees ',
     *   7(' '), '|')
 1500 FORMAT ('| So the CALIBRATOR is not used with the SOURCE',
     *   15(' '),'|')
      END
C
      SUBROUTINE ATMHIS
C-----------------------------------------------------------------------
C   ATMHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER CTIME(2)*12,  HILINE*72, LABEL*8
      INTEGER   LUN, IERR, TIM(3), DATE(3), I
      INTEGER   BUFFHI(1024)
      LOGICAL   T
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'ATMCA.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN /28/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN, DISKIN, FCNO(NCFILE), BUFFHI, IERR)
      IF (IERR.NE.0) GO TO 200
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIM)
      CALL TIMDAT (TIM, DATE, CTIME(2)(1:8), CTIME)
      WRITE (HILINE,1010) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN, HILINE, BUFFHI, IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any other history.
      IF (NUMHIS.LE.0) GO TO 200
         WRITE (LABEL,1020) TSKNAM
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN, HILINE, BUFFHI, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
C                                       Close HI file
 200   CALL HICLOS (LUN, T, BUFFHI, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ATMHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6, 'RELEASE =''',A7,' ''  /********* Start ',
     *   A12, 2X, A8)
 1020 FORMAT (A6)
      END
      SUBROUTINE DLESQR (NP, N, SUM, SSQ, R, M, X, VX, SSQRES,
     *   VARRES, VARY, FIT, IERR)
C-----------------------------------------------------------------------
C     LEASQR does the matrix inversion and other necessary tasks
C     involved in a least squares analysis.
C
C     Given:
C          NP        I     Number of parameters.
C          N         D     The number of observations.
C          SUM       D     Error sum.
C          SSQ       D     Square error sum.
C          R(NP)     D     Results vector.
C
C     Given and returned:
C          M(NP,NP)  D     On input, the upper triangular part contains
C                          the design matrix.  This is not changed.
C                          On output, the lower triangular part contains
C                          the covariance matrix.  Diagonal elements of
C                          the covariance matrix are stored in VX.
C
C     Returned:
C          X(NP)     D     Vector holding the least squares solution.
C          VX(NP)    D     Variance of the best fit parameters.
C          SSQRES    D     Sum of squares of the residuals.
C          VARRES    D     Variance of the residuals.
C          VARY      D     Variance of the error values.
C          FIT       D     Goodness of fit parameter, lies between 0
C                          and 1.
C          IERR      I     Error status, 0 means successful.
C                             1 - nonspecific error return,
C                             2 - insufficient degrees of freedom.
C
C     Called:
C          none
C
C     Algorithm:
C          LU-triangular factorization with scaled partial pivoting.
C          The sub-diagonal triangular matrix contains the scaling
C          factors used at each step in the Gaussian elimination.  Row
C          interchanges are recorded in vectors MXS and SXM.
C             During forward substitution, the pivoting and Gaussian
C          elimination operations performed on matrix M are applied to
C          vector R.  Vector X holds the intermediate result.
C             On backward substitution, successive elements of the
C          solution vector, X, are calculated by substitution of the
C          preceding elements into the equations of the upper triangular
C          factorization of the design matrix.
C
C     Notes:
C       1) Strictly speaking, the design matrix will usually contain
C          rows of zeroes and therefore be singular.  This arises if no
C          observations sensitive to a particular parameter have been
C          done.
C             In practice, any such singularities are ignored and the
C          associated parameters remain undetermined.
C
C       2) The covariance matrix is the inverse of M(i,j) multiplied by
C          the variance of the residuals.  It is obtained by forward and
C          backward substitution on the columns of the unit matrix.
C
C       3) Two statement functions, C, and SC have been employed to
C          partially alleviate the problems posed by passing arrays in
C          FORTRAN.  The design/covariance matrix m(i,j) is copied into
C          the working vector s(i).  This is addressed by using C, and
C          SC in an attempt to make it look like the matrix that it
C          actually represents.
C
C       4) The maximum size problem that LEASQR can handle is set by
C          parameter MX.
C
C     Author:
C          Mark Calabretta, Australia Telescope.
C          Origin; 1988/Sep/29. Code last modified; 1989/Nov/22.
C          Leonid Kogan modified the original version to
C          double precision; 2001/May/30.
C          This version allows number of observation to be equal
C          number of unknown parameters
C-----------------------------------------------------------------------
C     Parameter which determines the maximum size problem.
      INTEGER   MX
      PARAMETER (MX = 50)

      INTEGER   C, I, IERR, ITEMP, J, K, MXS(MX), NF, NP, PIVOT,
     *          SXM(MX)
      DOUBLE PRECISION   COLMAX, DTEMP, FIT, M(NP,NP), N, R(NP), RESIDU,
     *          RLEN, ROWMAX(MX), S(MX*MX), SC, RTEMP, SSQ, SSQRES, SUM,
     *          VARRES, VARY, VX(NP), W(MX), X(NP)

      INCLUDE 'INCS:DMSG.INC'

C     Statement functions for array manipulation, see note 3 above.
      C(I,J)  = NP*(I-1) + J
      SC(I,J) = S(C(I,J))
C-----------------------------------------------------------------------
C  Initialize.
C     Anticipate and return immediately on error.
      IERR = 1

C     Initialize arrays.
      DO 40 I = 1, NP
C        Vector which records row interchanges.
         MXS(I) = I

C        The solution and variance vectors.
         X(I)  = 0.0
         VX(I) = 0.0

C        Copy the design matrix and zero the covariance matrix.
         DO 10 J = 1, I-1
            M(I,J) = 0.0
            S(C(I,J)) = M(J,I)
 10      CONTINUE
         DO 20 J = I, NP
            S(C(I,J)) = M(I,J)
 20      CONTINUE

C        Find the maximum absolute element in each row.
         ROWMAX(I) = 0.0
         DO 30 J = 1, NP
            ROWMAX(I) = MAX(ROWMAX(I), ABS(SC(I,J)))
 30      CONTINUE
 40   CONTINUE

      VARY   = 0.0
      SSQRES = 0.0
      VARRES = 0.0
      FIT    = 0.0

C     Find the number of degrees of freedom.
      NF = N
      DO 60 I = 1, NP
         IF (ROWMAX(I).NE.0.0) THEN
            NF = NF - 1
         ELSE IF (R(I).NE.0.0) THEN
C           Any row of zeroes must extend to the results vector.
            WRITE (MSGTXT,50) I
 50         FORMAT ('LEASQR: Design matrix inconsistency in row',I4)
            CALL MSGWRT (6)
         END IF
 60   CONTINUE

C      IF (NF.LE.1) THEN
C      IF (NF.LT.1) THEN
C                                       LK, April 2004
      IF (NF.LT.0) THEN
         WRITE (MSGTXT,70)
 70      FORMAT ('LEASQR: Insufficient degrees of freedom.')
         CALL MSGWRT (6)
         IERR = 2
         RETURN
      END IF
C  Factorize the matrix.
      DO 120 K = 1, NP
C        Check for a row of zeroes.
         IF (ROWMAX(K).EQ.0.0) GO TO 120

C        A non-zero row maximum implies non-zero diagonal element.
         IF (SC(K,K).EQ.0.0) THEN
            WRITE (MSGTXT,50) MXS(K)
            CALL MSGWRT (6)
            GO TO 120
         END IF

C        Decide whether to pivot.
         COLMAX = ABS(SC(K,K))/ROWMAX(K)
         PIVOT = K
         DO 80 I = K+1, NP
            IF (ROWMAX(I).NE.0.0) THEN
               IF (ABS(SC(I,K))/ROWMAX(I).GT.COLMAX) THEN
                  COLMAX = ABS(SC(I,K))/ROWMAX(I)
                  PIVOT = I
               END IF
            END IF
 80      CONTINUE

         IF (PIVOT.GT.K) THEN
C           We must pivot, interchange the rows of the design matrix.
            DO 90 J = 1, NP
               DTEMP = SC(PIVOT,J)
               S(C(PIVOT,J)) = SC(K,J)
               S(C(K,J)) = DTEMP
 90         CONTINUE

C           Don't forget the vector of row maxima.
            DTEMP = ROWMAX(PIVOT)
            ROWMAX(PIVOT) = ROWMAX(K)
            ROWMAX(K) = DTEMP

C           Record the interchange for later use.
            ITEMP = MXS(PIVOT)
            MXS(PIVOT) = MXS(K)
            MXS(K) = ITEMP
         END IF

C        Gaussian elimination.
         DO 110 I = K+1, NP
C           Nothing to do if SC(i,k) is zero.
            IF (SC(I,K).NE.0.0) THEN
C              Save the scaling factor.
               S(C(I,K)) = SC(I,K)/SC(K,K)

C              Subtract rows.
               DO 100 J = K+1, NP
                  S(C(I,J)) = SC(I,J) - SC(I,K)*SC(K,J)
 100           CONTINUE
            END IF
 110     CONTINUE
 120  CONTINUE

C     MXS(i) records which row of M corresponds to row i of SC.
C     SXM(i) records which row of S corresponds to row i of M.
      DO 130 I = 1, NP
         SXM(MXS(I)) = I
 130  CONTINUE


C  Solve the normal equations.
      DO 150 I = 1, NP
C        Forward substitution.
         W(I) = R(MXS(I))
         DO 140 J = 1, I-1
            W(I) = W(I) - SC(I,J)*W(J)
 140     CONTINUE
 150  CONTINUE

      DO 170 I = NP, 1, -1
C        Backward substitution.
         IF (SC(I,I).NE.0.0) THEN
            DO 160 J = I+1, NP
               W(I) = W(I) - SC(I,J)*W(J)
 160        CONTINUE
            W(I) = W(I)/SC(I,I)
         END IF
         X(I) = W(I)
 170  CONTINUE

C     Check that the solution is acceptable.
      RLEN = 0.0
      RESIDU = 0.0
      DO 200 I = 1, NP
         RTEMP = 0.0
         DO 180 J = 1, I-1
            RTEMP = RTEMP + M(J,I)*X(J)
 180     CONTINUE
         DO 190 J = I, NP
            RTEMP = RTEMP + M(I,J)*X(J)
 190     CONTINUE

         RLEN = RLEN + R(I)**2
         RESIDU = RESIDU + (RTEMP - R(I))**2
 200  CONTINUE

      IF (RESIDU.GT.0.001*RLEN) THEN
         WRITE (MSGTXT,210) RESIDU/RLEN
 210     FORMAT ('LEASQR: The solution is discrepant at',E8.1)
         CALL MSGWRT (6)
         RETURN
      END IF
C  Determine goodness-of-fit estimates, and statistical errors.
      SSQRES = SSQ
      DO 220 I = 1, NP
         SSQRES = SSQRES - X(I)*R(I)
 220  CONTINUE
      IF (SSQRES.LT.0.0) SSQRES = 0.0

C      VARRES = SSQRES/NF
C                                       LK May 2004
      IF (NF .GT. 0) VARRES = SSQRES/NF
      VARY = (SSQ - SUM*SUM/N)/(N - 1.0)
      FIT = 1.0
      IF (VARY.NE.0.0) FIT = 1.0 - SSQRES/(SSQ - SUM*SUM/N)

C     Determine the covariance matrix.
      DO 280 K = 1, NP
C        Forward substitution affects only that part of W() below the
C        first non-zero entry.
         DO 230 I = 1, SXM(K)-1
            W(I) = 0.0
 230     CONTINUE
         W(SXM(K)) = 1.0
C
         DO 250 I = SXM(K)+1, NP
C           Forward substitution.
            W(I) = 0.0
            DO 240 J = SXM(K), I-1
               W(I) = W(I) - SC(I,J)*W(J)
 240        CONTINUE
 250     CONTINUE

         DO 270 I = NP, K, -1
            IF (SC(I,I).NE.0.0) THEN
C              Backward substitution.
               DO 260 J = I+1, NP
                  W(I) = W(I) - SC(I,J)*W(J)
 260           CONTINUE
               W(I) = W(I)/SC(I,I)
            END IF

            IF (I.NE.K) THEN
C              Off diagonal elements of the covariance matrix.
               M(I,K) = VARRES*W(I)
            ELSE IF (I.EQ.K) THEN
C              Diagonal elements of the covariance matrix.
               VX(K)  = VARRES*W(I)
            END IF
 270     CONTINUE
 280  CONTINUE
C  Successful completion.
      IERR = 0
      RETURN
      END

      SUBROUTINE AU2A (BRANCH)
C-----------------------------------------------------------------------
C! verb functions on task save and Save/Get files: TGET, SGdestr, index
C# POPS-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998-1999, 2002-2014, 2016-2018, 2020-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AU2A performs verb-like functions related to Task-save and Save/Get
C   files.
C   Input: BRANCH = 1  : TGET     get last adverbs for a task
C                   2  : SGDESTR  destroy 1 save file
C                   3  : TGINDEX  list tasks having saved parms
C                   4  : SGINDEX  list save/get files
C                   5  : VGINDEX  list VGET/VPUT contents
C                   6  : VGET     get last saved task adverbs in version
C                   7  : DEFAULT  reset task adverbs
C                   8  : SG2RUN   copy K array to run file
C                   9  : PLGET    get PL file adverb values
C                  10  : TUGET    get last adverbs from a user
C                  11  : SGUGET   get SG file to user's SG
C                  12  : TGUINDEX list tasks another user
C                  13  : SGUINDEX list Save/Get another user
C                  14  : CAT2LOG  list in2name catalog
C                  15  : CAT3LOG  list in3name catalog
C                  16  : CAT4LOG  list in4name catalog
C                  17  : CAT5LOG  list in5name catalog
C                  18  : CATOLOG  list outname catalog
C   Inputs file function codes are in column 10 as:
C      ' '   GO
C      '*'   GO  TELL
C      '?'       TELL
C      '&'   GO  TELL  GET
C      '%'       TELL  GET
C      '$'   GO        GET
C      '@'             GET
C      other -> error message
C   INPUTS, TPUT, TGET and GO only do the GO adverbs, OUTPUTS only does
C   the GET adverbs, SHOW and TELL only do the TELL adverbs
C
C   For PLGET:
C      Plot types supported: 1 Misc.   2 CNTR    3 greys   4 PROFL
C                            5 SL2PL   6 pcntr   7 IMEAN   8 UVPLT
C                          [ 9 gnplt][10 vbplt] 11 PFPLn [12 gaplt]
C                           13 PLCUB  14 IMVIM  15 TAPLT  16 POSSM
C                           17 SNPLT  18 kntr   19 UVHGM  20 ISPEC
C                           21 VPLOT  22 CLPLT  23 DFTPL  24 FRPLT
C                           25 FRMAP  26 PLOTR  27 GREYS  28 PCNTR
C                           29 KNTR   30 BPLOT  31 APCAL  32 ANBPL
C                           33 IRING  34 RSPEC  35 CAPLT  36 RFLAG
C                           37 CCNTR  38 SERCH  39 EVAUV  40 DELZN
C                           41 ELINT  42 FGPLT  43 GAL    44 SNIFS
C                           45 SOUSP  46 WETHR  47 RM2PL  48 XG2PL
C                           49 ALVAR  50 PCPLT  51 PLROW  52 PLOTC
C                           53 UVHOL  54 PBEAM  55 PEEK   56 LOCIT
C                           57 SNBLP, 58 SYVSN, 59 BLPLT  60 CONPL
C                           61 PRTAN  62 BLSUM  63 ELFIT  64 SNFIT
C                           65 PANEL  66 PCHIS  67 UVRMS  68 SPRMS
C                           69 PDPLT  70 TARPL  71 BPEPL  72 RIRMS
C                           73 VBRFI  74 PLRFI  75 CLOSE  76 VLBRF
C                           77 TEPLT  78 BPPLT  79 MARSP  80 QBEAM
C                           81 SYHIS  82 PRPLT
C       pcntr, greys, kntr (6, 3, 18) are old form replacd 2002-Nov
C       vbplt, gaplt, gnplt not supported 7/7/03
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      INTEGER   NADP1, NADM1, NADSP, NA, NPLOTS
      PARAMETER (NADP1=54, NADM1=31, NADSP=18, NA=500, NPLOTS=82)
C
      CHARACTER ATIME*8, ADATE*12, PHNAME*48, ITASK*16, LVERSN*48,
     *   AVERSN*48, JBUF*80, VERVER(10)*8, PRGNAM*6, CTEST*8, ANAME*16,
     *   OLNAME*48, CDUM*1, ADVP1(NADP1)*8, ADVM1(NADM1)*8,
     *   ADVSP(NADSP)*8, NAMES(NA)*16, PNAMES(NPLOTS)*5, NAME*12,
     *   CLASS*6, TYPE*2, XNAMES(NA)*16, DBG*1024
      INTEGER   POTERR, I, J, IERR, LUN, FIND, NTASK, IBLK(256), LUNIN,
     *   FINDIN, IPTR, ISIZE, IEOF, ITAG, ILOC, ITYPE, NWPL, NLPR, JJ,
     *   ITIME(6,NA), COLLBN, IUSER, IVER, ILVER, VERTYP, NMATCC, IOFF,
     *   NBLOCK, COLSHO, JOFF, IREC, LREC, JTRIM, IDUM, LUNDE, ALPHA,
     *   IVERS(NA), IVOL, ISEQ, IDATA(768), CATBLK(256), ISLOT, IMAXV,
     *   IPTYPE, NPARMS, PNPARM(NPLOTS), NAMTYP, JTYPE, JSIZE, NNAMES,
     *   MUSER, LUSER, INDISK, LUN2, FIND2, PSGV, QUICK
      REAL      PARBUF(256), RDUM, VADVSP(NADSP), RVALU
      LOGICAL   T, F, WASDEF, OLDTG, ISADV
      HOLLERITH HARBUF(256), HVALU, HADNAM(3), HDATA(768)
      DOUBLE PRECISION JDS(NA), JDM
      INCLUDE 'INCS:DSMS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DIO.INC'
      INCLUDE 'INCS:PKSZ.INC'
      COMMON /AIPSCR/ IBLK, IDATA, CATBLK
      COMMON /AIPCCR/ PHNAME, LVERSN, AVERSN, JBUF
      EQUIVALENCE (IDATA, HDATA)
      EQUIVALENCE (IBLK(1), PARBUF(1), HARBUF(1))
      EQUIVALENCE (NAMTYP, HADNAM(3))
      DATA PRGNAM /'AU2A  '/
      DATA COLLBN, COLSHO /11, 10/
      DATA LUN, LUNIN, LUN2 /13, 11, 84/
      DATA IEOF /2/
      DATA T, F /.TRUE.,.FALSE./
      DATA VERVER /'OLD ', 'NEW ', 'TST ', 'CVX', 'OLDPSAP',
     *   'NEWPSAP', 'TSTPSAP', 'CVXPSAP', 'LOCAL ', 'PRIVATE '/
      DATA ADVM1 /'FQTOL','FREQID','SELFREQ','SELBAND','BPVER','BLVER',
     *   'QUAL','DO3DIMAG','DOBAND','DOPOL','DODELAY','DOCALIB',
     *   'DOOUTPUT','DOCONCAT','DOCONFRM','DOALPHA','ERROR','DOCIRCLE',
     *   'DOARRAY','DOSTOKES','DOALL','DORESID','DOMODEL','DOHIST',
     *   'DOINVERS','DOTV','DOWAIT','DOEBAR','DOACOR','DOUVCOMP',
     *   'STVERS'/
      DATA ADVP1 /'DOWEIGHT','DELCORR','DIGICOR','UVBXFN','CBPLOT',
     *   'DOGREY','REMTAPE','DOWEDGE','SLOT','DONEWTAB',
     *   'NFIELD','DOTWO','DOTABLE','DOEOT','DOALIGN','NPOINTS',
     *   'DOSLICE','DOCAT','DOEOF','DOGRIDCR','DOCONT','DOVECT',
     *   'TVCHAN','OUTTAPE','INTAPE','OUT2DISK','OUTDISK',
     *   'DOPOS','DOMAX','DOWIDTH','CHINC','COPIES','BCOUNT','BCHAN',
     *   'XINC','YINC','ZINC','TXINC','TYINC','TZINC','ORDER',
     *   'NPLOTS','BPRINT','NCHAV','DODARK','DOBTWEEN',
     *   'VECTOR','HISTART','AXREF','DOHMS','AVGCHAN','DOROBUST',
     *   'FQCENTER', 'QCREATE'/
      DATA ADVSP /'MAXPIXEL','BLOCKING','DENSITY','DOCRT','NAXIS',
     *   'MINPATCH','DIST','ICUT','PCUT','SKEW','ZXRATIO','LTYPE',
     *   'BATQUE','GAIN','XTYPE','YTYPE','DARKLINE','LPEN'/
      DATA VADVSP /20000., 10., 6250., 132., 3., 51., 3., 0.1, 0.1, 45.,
     *   0.25, 3., 2., 0.1, 5., 5., 0.33, 3./
C                                       supported PLGET task names
C                                       must match AU8A (EXTLIST)
      DATA PNAMES /'    ', 'CNTR ', '     ', 'PROFL', 'SL2PL',
     *   '     ', 'IMEAN', 'UVPLT', '     ', '     ',
     *   '     ', '     ', 'PLCUB', 'IMVIM', 'TAPLT',
     *   'POSSM', 'SNPLT', '     ', 'UVHGM', 'ISPEC',
     *   'VPLOT', 'CLPLT', 'DFTPL', 'FRPLT', 'FRMAP',
     *   'PLOTR', 'GREYS', 'PCNTR', 'KNTR ', 'BPLOT',
     *   'APCAL', 'ANBPL', 'IRING', 'RSPEC', 'CAPLT',
     *   'RFLAG', 'CCNTR', 'SERCH', 'EVAUV', 'DELZN',
     *   'ELINT', 'FGPLT', 'GAL  ', 'SNIFS', 'SOUSP',
     *   'WETHR', 'RM2PL', 'XG2PL', 'ALVAR', 'PCPLT',
     *   'PLROW', 'PLOTC', 'UVHOL', 'PBEAM', 'PEEK',
     *   'LOCIT', 'SNBLP', 'SYVSN', 'BLPLT', 'CONPL',
     *   'PRTAN', 'BLSUM', 'ELFIT', 'SNFIT', 'PANEL',
     *   'PCHIS', 'UVRMS', 'SPRMS', 'PDPLT', 'TARPL',
     *   'BPEPL', 'RIRMS', 'VBRFI', 'PLRFI', 'CLOSE',
     *   'VLBRF', 'TEPLT', 'BPPLT', 'MARSP', 'QBEAM',
     *   'SYHIS', 'PRPLT'/
      DATA PNPARM /
     *     0,  63, 279,  39,  20,  87,  48, 307,   0,   0,
     *     0,   0,  39,  47,  83, 314, 244,  80, 213, 251,
     *   425, 329, 184, 198, 189, 128, 342, 209, 223,  85,
     *   342, 306,  62, 259, 212, 555,  70, 136, 454, 353,
     *   349, 127,  97, 210, 228, 113,  61,  62, 280,  85,
     *    29, 154, 391,  96, 152, 240, 242, 243,  80,  43,
     *    32,  90, 220, 228,  68,  35, 290, 288, 141,  69,
     *    99, 302, 237, 107, 127, 238, 232, 214,  44,  32,
     *   280, 28/
C-----------------------------------------------------------------------
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.18)) GO TO 999
      IF ((BRANCH.GE.14) .AND. (BRANCH.LE.18)) GO TO 500
      NBLOCK = 8
      FINDIN = 0
      FIND = 0
      OLDTG = .TRUE.
      MUSER = NLUSER
      INDISK = 1
C                                       Get immediate argument
      IF ((BRANCH.LE.2) .OR. (BRANCH.EQ.6) .OR. (BRANCH.EQ.7) .OR.
     *   (BRANCH.EQ.10) .OR. (BRANCH.EQ.11)) THEN
         POTERR = 7
         IF (SP.LT.4) GO TO 980
         POTERR = 8
         I = 8
         IF ((BRANCH.EQ.2) .OR. (BRANCH.EQ.11)) I = 16
         IF ((STACK(SP).NE.2) .OR. (STACK(SP-3).NE.14) .OR.
     *      (STACK(SP-2).NE.I)) GO TO 980
         WASDEF = HBLANK.EQ.CH(STACK(SP-1))
         SP = SP - 4
         ITASK = ' '
         IF (WASDEF) THEN
            CALL ADVERB ('TASK', 'C', 1, 8, IDUM, RDUM, ITASK)
            IF (ERRNUM.NE.0) GO TO 980
            IF (BRANCH.EQ.2) THEN
               WRITE (MSGTXT,1000)
               CALL MSGWRT (6)
               POTERR = 46
               GO TO 980
               END IF
         ELSE
            I = 8
            IF ((BRANCH.EQ.2) .OR. (BRANCH.EQ.11)) I = 16
            CALL H2CHR (I, 1, CH(STACK(SP+3)), ITASK)
            END IF
         END IF
C                                       alphabetize?
      CALL ADVERB ('DOALPHA', 'I', 1, 1, ALPHA, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      LUSER = 0
      IF (BRANCH.GE.10) THEN
         CALL ADVERB ('USERID', 'I', 1, 1, LUSER, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('INDISK', 'I', 1, 1, INDISK, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         IF (INDISK.LE.0) INDISK = 1
         END IF
      IF (LUSER.LE.0) LUSER = NLUSER

C                                       Skip on AIPSC
      IF ((TSKNAM(:5).EQ.'AIPSC') .AND. (BRANCH.GT.1) .AND.
     *   (BRANCH.LE.5)) GO TO 999
      IF ((BRANCH.LT.7) .OR. (BRANCH.GE.10)) THEN
C                                       Open required file
         IF ((BRANCH.EQ.2) .OR. (BRANCH.EQ.4) .OR. (BRANCH.EQ.11) .OR.
     *      (BRANCH.EQ.13)) THEN
            NLUSER = LUSER
            CALL ZPHFIL ('SG', INDISK, LUSER, 0, PHNAME, IERR)
            NLUSER = MUSER
         ELSE
            IF ((BRANCH.EQ.5) .OR. (BRANCH.EQ.6)) THEN
               CALL ADVERB ('VNUMBER', 'I', 1, 1, IVER, RDUM, CDUM)
               IF (ERRNUM.NE.0) GO TO 980
               IF ((IVER.LE.0) .OR. (IVER.GT.35)) IVER = 1
            ELSE
               IVER = 0
               END IF
            IUSER = 100 * NBLOCK
            IF ((NPOPS.GT.NINTRN) .OR. (TSKNAM(:5).EQ.'AIPSC')) THEN
               IUSER = IUSER + NPOPS
C                                       Check for old name and rename
            ELSE IF ((BRANCH.LT.4) .OR. (BRANCH.EQ.10) .OR.
     *            (BRANCH.EQ.12)) THEN
               NLUSER = LUSER
               CALL ZPHFIL ('TS', INDISK, NLUSER, NBLOCK, OLNAME, IERR)
               NLUSER = MUSER
               CALL ZEXIST (INDISK, OLNAME, I, IERR)
               IF (IERR.EQ.0) THEN
                  NLUSER = LUSER
                  CALL ZPHFIL ('TG', INDISK, 400, IVER, PHNAME, IERR)
                  NLUSER = MUSER
                  CALL ZEXIST (INDISK, PHNAME, I, IERR)
                  IF (IERR.EQ.1) CALL ZRENAM (INDISK, OLNAME, PHNAME,
     *               IERR)
                  END IF
               END IF
            NLUSER = LUSER
            CALL ZPHFIL ('TG', INDISK, IUSER, IVER, PHNAME, IERR)
            NLUSER = MUSER
            CALL ZEXIST (INDISK, PHNAME, I, IERR)
            IF (IERR.EQ.1) THEN
               NLUSER = LUSER
               CALL ZPHFIL ('TG', INDISK, 400, IVER, PHNAME, IERR)
               NLUSER = MUSER
               OLDTG = .TRUE.
            ELSE
               OLDTG = .FALSE.
               END IF
            END IF
         CALL ZOPEN (LUN, FIND, INDISK, PHNAME, F, T, T, IERR)
         IF (IERR.NE.0) THEN
            IF ((BRANCH.EQ.2) .OR. (BRANCH.EQ.4) .OR. (BRANCH.EQ.11)
     *         .OR. (BRANCH.EQ.13)) THEN
               WRITE (MSGTXT,1020) 'SG', 0, IERR
            ELSE
               WRITE (MSGTXT,1020) 'TG', IVER, IERR
               END IF
            CALL MSGWRT (6)
            POTERR = 101
            FIND = 0
            GO TO 980
            END IF
C                                       Read record 1
         POTERR = 50
         CALL ZFIO ('READ', LUN, FIND, 1, IBLK, IERR)
         IF (IERR.NE.0) GO TO 980
         IF ((BRANCH.EQ.2) .OR. (BRANCH.EQ.4) .OR. (BRANCH.EQ.11)
     *         .OR. (BRANCH.EQ.13)) THEN
            NTASK = IBLK(1)
         ELSE
            NTASK = IBLK(2)
            END IF
         END IF
C                                       Branch to OP
         GO TO (100, 200, 300, 400, 300, 100, 700, 800, 900, 100, 200,
     *      300, 400), BRANCH
C-----------------------------------------------------------------------
C                                       TGET
C                                       get task parameters back
C-----------------------------------------------------------------------
C                                       open inputs file
 100  CALL ZPHFIL ('HE', 1, 0, 0, PHNAME, IERR)
      POTERR = 101
C                                       Allow min match
C                                       Return true value
      CALL ADVERB ('VERSION', 'C', 1, 48, IDUM, RDUM, LVERSN)
      IF (ERRNUM.NE.0) GO TO 980
      CALL VERMAT (1, PHNAME, ITASK, LVERSN, VERTYP, AVERSN, IERROR)
      IF (IERROR(1).NE.0) GO TO 980
C                                      Set TASK adverb
      CALL ADVRBS ('TASK', 'C', 1, 8, IDUM, RDUM, ITASK)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ZTOPEN (LUNIN, FINDIN, 1, PHNAME, ITASK, AVERSN, T, IERROR)
      POTERR = 31
      IF (IERROR(1).NE.0) THEN
         FINDIN = 0
         GO TO 980
         END IF
C                                       Locate Task in TG file
      IF (BRANCH.NE.9) THEN
         POTERR = 50
 103     LREC = 0
         NWPL = 5
         NLPR = 256 / NWPL
         DO 110 I = 1,NTASK
            IREC = I / NLPR + 1
            IF (IREC.NE.LREC) THEN
               CALL ZFIO ('READ', LUN, FIND, IREC, IBLK, IERR)
               IF (IERR.NE.0) GO TO 980
               LREC = IREC
               IF (IREC.EQ.1) NBLOCK = MAX (4, IBLK(5))
               END IF
            IOFF = MOD (I, NLPR) * NWPL + 1
            CALL H2CHR (8, 1, HARBUF(IOFF), CTEST)
            ILVER = IBLK(IOFF+4)
            IF (ITASK.EQ.CTEST) GO TO 115
 110        CONTINUE
C                                       switch to old format
         IF ((.NOT.OLDTG) .AND. ((BRANCH.EQ.1) .OR. (BRANCH.EQ.6) .OR.
     *      (BRANCH.EQ.10))) THEN
            CALL ZCLOSE (LUN, FIND, IERR)
            OLDTG = .TRUE.
            CALL ZPHFIL ('TG', 1, 400, IVER, PHNAME, IERR)
            CALL ZEXIST (1, PHNAME, I, IERR)
            IF (IERR.EQ.0) THEN
               CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
               IF (IERR.EQ.0) THEN
                  POTERR = 50
                  CALL ZFIO ('READ', LUN, FIND, 1, IBLK, IERR)
                  IF (IERR.NE.0) GO TO 980
                  IF ((BRANCH.EQ.2) .OR. (BRANCH.EQ.4)) THEN
                     NTASK = IBLK(1)
                  ELSE
                     NTASK = IBLK(2)
                     END IF
                  GO TO 103
               ELSE
                  WRITE (MSGTXT,1020) 'TG', IVER, IERR
                  CALL MSGWRT (6)
                  POTERR = 101
                  FIND = 0
                  GO TO 980
                  END IF
            ELSE
               FIND = 0
               END IF
            END IF
C                                       task not found
         POTERR = 31
         GO TO 980
         END IF
C                                       Read first data block
 115  IF (BRANCH.NE.9) THEN
         IF (VERTYP.EQ.8) WRITE (MSGTXT,1115)
         IF (VERTYP.NE.ILVER) WRITE (MSGTXT,1116)
         IF ((VERTYP.EQ.8) .OR. (ILVER.NE.VERTYP)) CALL MSGWRT (6)
         JOFF = NBLOCK * (I-1) + 11
         IF (OLDTG) JOFF = 4 * (I-1) + 7
      ELSE
         JOFF = 1
         END IF
      CALL ZFIO ('READ', LUN, FIND, JOFF, IBLK, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Init pointer
      IPTR = 11
C                                       Old method
      IF (OLDTG) THEN
C                                       skip first 2 records
 116     CALL ZTREAD (LUNIN, FINDIN, JBUF, IERR)
         POTERR = 59
         IF (IERR.NE.0) GO TO 980
         IF (JBUF(1:1).EQ.';') GO TO 116
         IF (JBUF(1:8).EQ.'--------') THEN
            POTERR = 54
            GO TO 980
            END IF
 117     CALL ZTREAD (LUNIN, FINDIN, JBUF, IERR)
         IF (IERR.EQ.IEOF) GO TO 150
         IF (IERR.NE.0) GO TO 980
         IF (JBUF(1:1).EQ.';') GO TO 117
         IF (JBUF(1:8).EQ.'--------') THEN
            POTERR = 54
            GO TO 980
            END IF
C                                       loop for adverbs
 120     CALL ZTREAD (LUNIN, FINDIN, JBUF, IERR)
         IF (IERR.NE.IEOF) THEN
            POTERR = 59
            IF (IERR.NE.0) GO TO 980
            IF (JBUF(1:1).EQ.';') GO TO 120
            IF (JBUF(1:8).EQ.'--------') GO TO 150
            I = JTRIM (JBUF)
            IF (JBUF(COLSHO:COLSHO).EQ.'?') GO TO 120
            IF (JBUF(COLSHO:COLSHO).EQ.'%') GO TO 120
            IF (JBUF(COLSHO:COLSHO).EQ.'@') GO TO 120
            JBUF(COLSHO:COLSHO) = ' '
            KARBUF = JBUF
            KBPTR = NMATCC (1, ' ', KARBUF)
C                                       comment
            IF (KBPTR.GE.COLLBN) GO TO 120
C                                       adverb
            CALL GETFLD
            IF (ERRNUM.NE.0) GO TO 980
            ITAG = TAG
            ILOC = LOCSYM
            ITYPE = SYTYPE
C                                       Type 7 is a string.
            POTERR = 8
C                                       Type 1 is a scalar, 2=array.
            IF ((SYTYPE.NE.1) .AND. (SYTYPE.NE.2) .AND. (SYTYPE.NE.7))
     *         GO TO 980
            ISIZE = 1
            IF (ITYPE.NE.1) ISIZE = K(K(ILOC+3))
            DO 140 I = 1,ISIZE
               IF (ITYPE.EQ.7) THEN
                  CH(ITAG) = HARBUF(IPTR)
               ELSE
                  C(ITAG) = PARBUF(IPTR)
                  END IF
               ITAG = ITAG + 1
               IPTR = IPTR + 1
               IF (IPTR.GT.256) THEN
                  IPTR = 1
                  JOFF = JOFF + 1
                  CALL ZFIO ('READ', LUN, FIND, JOFF, IBLK, IERR)
                  IF (IERR.NE.0) THEN
                     POTERR = 50
                     GO TO 980
                     END IF
                  END IF
 140           CONTINUE
C                                       Check character strings
            IF (ITYPE.EQ.7) THEN
               CALL VERSTR (ILOC)
               IF (ERRNUM.NE.0) GO TO 980
               END IF
            GO TO 120
            END IF
C                                       Done !
 150     POTERR = 0
         GO TO 980
C                                       new method
      ELSE
         NNAMES = 0
C                                       get adverb and type
 160     IF (IBLK(IPTR).NE.0) THEN
            DO 165 I = 1,3
               HADNAM(I) = HARBUF(IPTR)
               IPTR = IPTR + 1
               IF (IPTR.GT.256) THEN
                  IPTR = 1
                  JOFF = JOFF + 1
                  CALL ZFIO ('READ', LUN, FIND, JOFF, IBLK, IERR)
                  IF (IERR.NE.0) THEN
                     POTERR = 50
                     GO TO 980
                     END IF
                  END IF
 165           CONTINUE
            CALL H2CHR (8, 1, HADNAM, KARBUF)
            JTYPE = MOD (NAMTYP, 10)
            JSIZE = NAMTYP / 10
            NNAMES = NNAMES + 1
            NAMES(NNAMES) = KARBUF(:8)
            KBPTR = 1
            CALL GETFLD
            IF (ERRNUM.NE.0) GO TO 980
            ITAG = TAG
            ILOC = LOCSYM
            ITYPE = SYTYPE
C                                       Type 7 is a string.
            POTERR = 8
C                                       Type 1 is a scalar, 2=array.
            IF ((SYTYPE.NE.1) .AND. (SYTYPE.NE.2) .AND. (SYTYPE.NE.7))
     *         GO TO 980
            ISIZE = 1
            IF (ITYPE.NE.1) ISIZE = K(K(ILOC+3))
            IF ((JSIZE.NE.ISIZE) .OR. (JTYPE.NE.ITYPE)) THEN
               WRITE (MSGTXT,1165) KARBUF(:8), JSIZE, JTYPE, ISIZE,
     *            ITYPE
               CALL MSGWRT (7)
               END IF
            DO 170 I = 1,JSIZE
               IF (I.LE.ISIZE) THEN
                  IF (JTYPE.EQ.7) THEN
                     CH(ITAG) = HARBUF(IPTR)
                  ELSE
                     C(ITAG) = PARBUF(IPTR)
                     END IF
                  END IF
               ITAG = ITAG + 1
               IPTR = IPTR + 1
               IF (IPTR.GT.256) THEN
                  IPTR = 1
                  JOFF = JOFF + 1
                  CALL ZFIO ('READ', LUN, FIND, JOFF, IBLK, IERR)
                  IF (IERR.NE.0) THEN
                     POTERR = 50
                     GO TO 980
                     END IF
                  END IF
 170           CONTINUE
C                                       Check character strings
            IF (JTYPE.EQ.7) THEN
               CALL VERSTR (ILOC)
               IF (ERRNUM.NE.0) GO TO 980
               END IF
            GO TO 160
            END IF
C                                       Now check against the INPUTS
C                                       skip first 2 records
 171     CALL ZTREAD (LUNIN, FINDIN, JBUF, IERR)
         POTERR = 59
         IF (IERR.NE.0) GO TO 980
         IF (JBUF(1:1).EQ.';') GO TO 171
         IF (JBUF(1:8).EQ.'--------') THEN
            POTERR = 54
            GO TO 980
            END IF
 172     CALL ZTREAD (LUNIN, FINDIN, JBUF, IERR)
         IF (IERR.EQ.IEOF) GO TO 185
         IF (IERR.NE.0) GO TO 980
         IF (JBUF(1:1).EQ.';') GO TO 172
         IF (JBUF(1:8).EQ.'--------') THEN
            POTERR = 54
            GO TO 980
            END IF
C                                       loop for adverbs
 175     CALL ZTREAD (LUNIN, FINDIN, JBUF, IERR)
         IF (IERR.NE.IEOF) THEN
            POTERR = 59
            IF (IERR.NE.0) GO TO 980
            IF (JBUF(1:1).EQ.';') GO TO 175
            IF (JBUF(1:8).EQ.'--------') GO TO 185
            I = JTRIM (JBUF)
            IF (JBUF(COLSHO:COLSHO).EQ.'?') GO TO 175
            IF (JBUF(COLSHO:COLSHO).EQ.'%') GO TO 175
            IF (JBUF(COLSHO:COLSHO).EQ.'@') GO TO 175
            JBUF(COLSHO:COLSHO) = ' '
            KARBUF = JBUF
            KBPTR = NMATCC (1, ' ', KARBUF)
C                                       comment
            IF (KBPTR.GE.COLLBN) GO TO 175
            DO 180 I = 1,NNAMES
               IF (KARBUF(:8).EQ.NAMES(I)) THEN
                  NAMES(I) = '--------'
                  GO TO 175
                  END IF
 180           CONTINUE
            WRITE (MSGTXT,1180) KARBUF(:8)
            CALL MSGWRT (6)
            GO TO 175
            END IF
C                                       any left"
 185     DO 190 I = 1,NNAMES
            IF ((NAMES(I).NE.' ') .AND. (NAMES(I).NE.'--------')) THEN
               WRITE (MSGTXT,1185) NAMES(I)(:8)
               CALL MSGWRT (6)
               END IF
 190        CONTINUE
         POTERR = 0
         GO TO 980
         END IF
C-----------------------------------------------------------------------
C                                       SGDESTR  < name >
C                                       destroy 1 Save/Get file
C                                       SGUGET  < name >
C                                       get SG from another user
C-----------------------------------------------------------------------
C                                       Locate the file
 200  LREC = 1
      POTERR = 50
      NWPL = 7
      NLPR = 256 / NWPL
      IF (NTASK.LE.0) GO TO 225
      DO 220 I = 1,NTASK
         IREC = I/NLPR + 1
         IF (IREC.NE.LREC) THEN
            LREC = IREC
            CALL ZFIO ('READ', LUN, FIND, IREC, IBLK, IERR)
            IF (IERR.NE.0) GO TO 980
            END IF
         IOFF = MOD (I, NLPR) * NWPL + 1
         IF (IBLK(IOFF).GT.0) THEN
            PSGV = IBLK(IOFF) / 32
            CALL H2CHR (16, 1, HARBUF(IOFF+3), ANAME)
            IF (ANAME.EQ.ITASK) GO TO 230
            END IF
 220     CONTINUE
 225  POTERR = 101
      WRITE (MSGTXT,1220) ITASK
      CALL MSGWRT (6)
      WRITE (MSGTXT,1000)
      CALL MSGWRT (6)
      GO TO 980
C                                       Found it: do destroy
 230  IF (BRANCH.EQ.2) THEN
         CALL ZPHFIL ('SG', 1, NLUSER, I, PHNAME, IERR)
         CALL ZDESTR (1, PHNAME, IERR)
         POTERR = 46
         IF (IERR.GT.1) GO TO 980
C                                       Clear entry
         IBLK(IOFF) = 0
         POTERR = 50
         IF (LREC.NE.1) THEN
            CALL ZFIO ('WRIT', LUN, FIND, LREC, IBLK, IERR)
            IF (IERR.NE.0) GO TO 980
            CALL ZFIO ('READ', LUN, FIND, 1, IBLK, IERR)
            IF (IERR.NE.0) GO TO 980
            END IF
C                                       Update control parms
         IF (I.LT.NTASK) IBLK(2) = IBLK(2) + 1
         IF (I.EQ.NTASK) IBLK(1) = IBLK(1) - 1
         CALL ZFIO ('WRIT', LUN, FIND, 1, IBLK, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Empty: delete directory
         POTERR = 0
         IF (IBLK(1).LE.IBLK(2)) THEN
            CALL ZCLOSE (LUN, FIND, IERR)
            FIND = 0
            CALL ZPHFIL ('SG', 1, NLUSER, 0, PHNAME, IERR)
            CALL ZDESTR (1, PHNAME, IERR)
            IF (IERR.GT.1) THEN
               WRITE (MSGTXT,1240) IERR
               CALL MSGWRT (6)
               END IF
            END IF
C                                       SGUGET
      ELSE
         CALL ZCLOSE (LUN, FIND, IERR)
         NLUSER = LUSER
         CALL ZPHFIL ('SG', INDISK, LUSER, I, PHNAME, IERR)
         NLUSER = MUSER
         CALL ZEXIST (INDISK, PHNAME, ISIZE, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1220) PHNAME
            CALL MSGWRT (6)
            GO TO 980
            END IF
C                                       name in user's SG dir
         CALL ADVERB ('KEYSTRNG', 'C', 1, 16, IDUM, RDUM, ANAME)
         IF (ERRNUM.NE.0) GO TO 980
         IF (ANAME.EQ.' ') ANAME = ITASK
         CALL ZPHFIL ('SG', 1, NLUSER, 0, OLNAME, IERR)
         CALL ZOPEN (LUN, FIND, 1, OLNAME, F, T, T, IERR)
         IF (IERR.NE.0) GO TO 980
         LREC = 1
         CALL ZFIO ('READ', LUN, FIND, LREC, IBLK, IERR)
         IF (IERR.NE.0) GO TO 980
         NTASK = IBLK(1)
         JJ = NTASK + 1
         DO 240 I = 1,NTASK
            IREC = I/NLPR + 1
            IF (IREC.NE.LREC) THEN
               LREC = IREC
               CALL ZFIO ('READ', LUN, FIND, IREC, IBLK, IERR)
               IF (IERR.NE.0) GO TO 980
               END IF
            IOFF = MOD (I, NLPR) * NWPL + 1
            IF (IBLK(IOFF).LE.0) THEN
               JJ = MIN (I, JJ)
            ELSE
               CALL H2CHR (16, 1, HARBUF(IOFF+3), NAMES(1))
               IF (ANAME.EQ.NAMES(1)) THEN
                  JJ = I
                  MSGTXT = 'Writing over ' // ANAME
                  CALL MSGWRT (5)
                  GO TO 250
                  END IF
               END IF
 240        CONTINUE
 250     IREC = JJ/NLPR + 1
         IF (IREC.NE.LREC) THEN
            LREC = IREC
            CALL ZFIO ('READ', LUN, FIND, IREC, IBLK, IERR)
            IF (IERR.NE.0) GO TO 980
            END IF
         IOFF = MOD (JJ, NLPR) * NWPL + 1
         IBLK(IOFF) = JTRIM (ANAME) + 32 * PSGV
         CALL CATIME (1, IBLK(IOFF+1), ITIME(1,1))
         CALL CHR2H (16, ANAME, 1, HARBUF(IOFF+3))
         IF (LREC.EQ.1) IBLK(1) = MAX (IBLK(1), JJ)
         CALL ZFIO ('WRIT', LUN, FIND, LREC, IBLK, IERR)
         IF (IERR.NE.0) GO TO 980
         IF (LREC.NE.1) THEN
            LREC = 1
            CALL ZFIO ('READ', LUN, FIND, LREC, IBLK, IERR)
            IF (IERR.NE.0) GO TO 980
            IF (LREC.EQ.1) IBLK(1) = MAX (IBLK(1), JJ)
            CALL ZFIO ('WRIT', LUN, FIND, LREC, IBLK, IERR)
            IF (IERR.NE.0) GO TO 980
            END IF
         CALL ZCLOSE (LUN, FIND, IERR)
C                                       create output file
         CALL ZPHFIL ('SG', 1, NLUSER, JJ, OLNAME, IERR)
         CALL ZEXIST (1, OLNAME, I, IERR)
         IF (IERR.EQ.0) CALL ZDESTR (1, OLNAME, IERR)
         CALL ZCREAT (1, OLNAME, ISIZE, F, I, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1250) IERR
            CALL MSGWRT (7)
            GO TO 980
            END IF
         NLUSER = LUSER
         CALL ZOPEN (LUN, FIND, INDISK, PHNAME, F, T, T, IERR)
         NLUSER = MUSER
         IF (IERR.NE.0) GO TO 980
         CALL ZOPEN (LUN2, FIND2, 1, OLNAME, F, T, T, IERR)
         IF (IERR.NE.0) GO TO 980
         DO 260 I = 1,ISIZE
            IREC = I
            CALL ZFIO ('READ', LUN, FIND, IREC, IBLK, IERR)
            IF (IERR.NE.0) GO TO 980
            IREC = I
            CALL ZFIO ('WRIT', LUN2, FIND2, IREC, IBLK, IERR)
            IF (IERR.NE.0) GO TO 980
 260        CONTINUE
         END IF
      POTERR = 0
      GO TO 980
C-----------------------------------------------------------------------
C                                       TGINDEX
C                                       TGUINDEX
C                                       index tasks w saved parms
C-----------------------------------------------------------------------
 300  NNAMES = 0
      IF (IVER.EQ.0) THEN
         WRITE (MSGTXT,1300) LUSER
      ELSE
         WRITE (MSGTXT,1301) IVER
         END IF
      CALL MSGWRT (2)
 305  LREC = 1
      POTERR = 50
      IF (NTASK.GT.0) THEN
         IF (NTASK.GT.NA) THEN
            WRITE (MSGTXT,1310) NTASK, NA
            CALL MSGWRT (6)
            NTASK = NA
            END IF
         NWPL = 5
         NLPR = 256 / NWPL
         JJ = 0
         DO 310 I = 1,NTASK
            IREC = I / NLPR + 1
            IF (IREC.NE.LREC) THEN
               CALL ZFIO ('READ', LUN, FIND, IREC, IBLK, IERR)
               IF (IERR.NE.0) GO TO 980
               LREC = IREC
               END IF
            IOFF = MOD (I, NLPR) * NWPL
            CALL H2CHR (8, 1, HARBUF(IOFF+1), CTEST)
            JJ = JJ + 1
            NAMES(JJ) = CTEST
            CALL CATIME (2, IBLK(IOFF+3), ITIME(1,JJ))
            CALL DAT2JD (ITIME(1,JJ), JDS(JJ))
            IVERS(JJ) = IBLK(IOFF+5)
            IF (.NOT.OLDTG) THEN
               NNAMES = NNAMES + 1
               XNAMES(NNAMES) = NAMES(JJ)
            ELSE
               DO 308 J = 1,NNAMES
                  IF (NAMES(JJ).EQ.XNAMES(J)) THEN
                     JJ = JJ - 1
                     GO TO 310
                     END IF
 308              CONTINUE
               END IF
 310        CONTINUE
         NTASK = JJ
         IF (NTASK.GT.0) THEN
            IF (OLDTG) THEN
               WRITE (MSGTXT,1315) 'Old'
            ELSE
               WRITE (MSGTXT,1315) 'New'
               END IF
            CALL MSGWRT (3)
            WRITE (MSGTXT,1316)
            CALL MSGWRT (3)
            END IF
         DO 340 I = 1,NTASK
            JJ = I
C                                       sort by date
            IF (ALPHA.EQ.0) THEN
               JDM = 0.0D0
               DO 320 J = 1,NTASK
                  IF (JDS(J).GT.JDM) THEN
                     JDM = JDS(J)
                     JJ = J
                     END IF
 320              CONTINUE
C                                       sort alphabetic
            ELSE IF (ALPHA.GT.0) THEN
               ANAME = 'ZZZZZZZZZZZZZZZZ'
               DO 330 J = 1,NTASK
                  IF (NAMES(J).NE.' ') THEN
                     IF (NAMES(J).LT.ANAME) THEN
                        JJ = J
                        ANAME = NAMES(J)
                        END IF
                     END IF
 330              CONTINUE
               END IF
            CTEST = NAMES(JJ)
            ILVER = IVERS(JJ)
            CALL TIMDAT (ITIME(4,JJ), ITIME(1,JJ), ATIME, ADATE)
            WRITE (MSGTXT,1330) CTEST, ADATE, ATIME, VERVER(ILVER)
            CALL MSGWRT (2)
            JDS(JJ) = -1.0D0
            NAMES(JJ) = ' '
 340        CONTINUE
         END IF
      IF (.NOT.OLDTG) THEN
         CALL ZCLOSE (LUN, FIND, IERR)
         CALL ZPHFIL ('TG', 1, 400, IVER, PHNAME, IERR)
         OLDTG = .TRUE.
         FIND = 0
         CALL ZEXIST (1, PHNAME, I, IERR)
         IF (IERR.EQ.0) THEN
            CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1020) 'TG', IVER, IERR
               CALL MSGWRT (6)
               POTERR = 101
               FIND = 0
               GO TO 980
            ELSE
               POTERR = 50
               CALL ZFIO ('READ', LUN, FIND, 1, IBLK, IERR)
               IF (IERR.NE.0) GO TO 980
               IF ((BRANCH.EQ.2) .OR. (BRANCH.EQ.4) .OR. (BRANCH.EQ.11)
     *            .OR. (BRANCH.EQ.13)) THEN
                  NTASK = IBLK(1)
               ELSE
                  NTASK = IBLK(2)
                  END IF
               GO TO 305
               END IF
            END IF
         END IF
      POTERR = 0
      GO TO 980
C-----------------------------------------------------------------------
C                                       SGINDEX
C                                       index Save/Get files
C-----------------------------------------------------------------------
 400  LREC = 1
      POTERR = 50
      NWPL = 7
      NLPR = 256 / NWPL
      IF (NTASK.GT.0) THEN
         JJ = 0
         DO 410 I = 1,NTASK
            IREC = I / NLPR + 1
            IF (IREC.NE.LREC) THEN
               CALL ZFIO ('READ', LUN, FIND, IREC, IBLK, IERR)
               IF (IERR.NE.0) GO TO 980
               LREC = IREC
               END IF
            IOFF = MOD (I, NLPR) * NWPL + 1
            IF (IBLK(IOFF).GT.0) THEN
               IF (JJ.GE.NA) THEN
                  WRITE (MSGTXT,1410) NA
                  CALL MSGWRT (6)
                  GO TO 415
                  END IF
               JJ = JJ + 1
               IVERS(JJ) = IBLK(IOFF) / 32
               CALL CATIME (2, IBLK(IOFF+1), ITIME(1,JJ))
               CALL DAT2JD (ITIME(1,JJ), JDS(JJ))
               CALL H2CHR (16, 1, HARBUF(IOFF+3), NAMES(JJ))
               END IF
 410        CONTINUE
 415     NTASK = JJ
         END IF
      IF (NTASK.GT.0) THEN
         WRITE (MSGTXT,1415) LUSER
         IF (LUSER.NE.MUSER) CALL MSGWRT (3)
         WRITE (MSGTXT,1416)
         CALL MSGWRT (3)
         DO 440 I = 1,NTASK
            JJ = I
C                                       sort by date
            IF (ALPHA.EQ.0) THEN
               JDM = 0.0D0
               DO 420 J = 1,NTASK
                  IF (JDS(J).GT.JDM) THEN
                     JDM = JDS(J)
                     JJ = J
                     END IF
 420              CONTINUE
C                                       sort alphabetic
            ELSE IF (ALPHA.GT.0) THEN
               ANAME = 'ZZZZZZZZZZZZZZZZ'
               DO 430 J = 1,NTASK
                  IF (NAMES(J).NE.' ') THEN
                     IF (NAMES(J).LT.ANAME) THEN
                        JJ = J
                        ANAME = NAMES(J)
                        END IF
                     END IF
 430              CONTINUE
               END IF
            CALL TIMDAT (ITIME(4,JJ), ITIME(1,JJ), ATIME, ADATE)
            ILVER = IVERS(JJ)
            ANAME = NAMES(JJ)
            IF (ILVER.EQ.SGVERS) ITASK = 'CURRENT'
            IF (ILVER.LT.SGVERS) ITASK = 'OUT DATED'
            IF (ILVER.GT.SGVERS) ITASK = 'TOO NEW'
            WRITE (MSGTXT,1430) ANAME, ADATE, ATIME, ITASK
            CALL MSGWRT (3)
            JDS(JJ) = -1.0D0
            NAMES(JJ) = ' '
 440        CONTINUE
         END IF
      POTERR = 0
      GO TO 980
C-----------------------------------------------------------------------
C                                       CATnLOG
C                                       list catalogs
C-----------------------------------------------------------------------
C                                       set common values
 500  IUSER = NLUSER
      QUICK = -1
      CALL ADVERB ('DOALPHA', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IF (RDUM.GT.0.0) QUICK = 2 * QUICK
      I = 0
      TYPE = ' '
C                                       get adverbs
      IF (BRANCH.EQ.14) THEN
         CALL ADVERB ('IN2DISK', 'I', 1, 0, IVOL, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN2SEQ', 'I', 1, 0, ISEQ, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN2NAME', 'C', 1, 12, IDUM, RDUM, NAME)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN2CLASS', 'C', 1, 6, IDUM, RDUM, CLASS)
         IF (ERRNUM.NE.0) GO TO 980
      ELSE IF (BRANCH.EQ.15) THEN
         CALL ADVERB ('IN3DISK', 'I', 1, 0, IVOL, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN3SEQ', 'I', 1, 0, ISEQ, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN3NAME', 'C', 1, 12, IDUM, RDUM, NAME)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN3CLASS', 'C', 1, 6, IDUM, RDUM, CLASS)
         IF (ERRNUM.NE.0) GO TO 980
      ELSE IF (BRANCH.EQ.16) THEN
         CALL ADVERB ('IN4DISK', 'I', 1, 0, IVOL, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN4SEQ', 'I', 1, 0, ISEQ, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN4NAME', 'C', 1, 12, IDUM, RDUM, NAME)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN4CLASS', 'C', 1, 6, IDUM, RDUM, CLASS)
         IF (ERRNUM.NE.0) GO TO 980
      ELSE IF (BRANCH.EQ.17) THEN
         CALL ADVERB ('IN5DISK', 'I', 1, 0, IVOL, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN5SEQ', 'I', 1, 0, ISEQ, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN5NAME', 'C', 1, 12, IDUM, RDUM, NAME)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN5CLASS', 'C', 1, 6, IDUM, RDUM, CLASS)
         IF (ERRNUM.NE.0) GO TO 980
      ELSE IF (BRANCH.EQ.18) THEN
         CALL ADVERB ('OUTDISK', 'I', 1, 0, IVOL, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('OUTSEQ', 'I', 1, 0, ISEQ, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('OUTNAME', 'C', 1, 12, IDUM, RDUM, NAME)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('OUTCLASS', 'C', 1, 6, IDUM, RDUM, CLASS)
         IF (ERRNUM.NE.0) GO TO 980
         END IF
C                                       do it
      CALL CATLST (IVOL, NAME, CLASS, ISEQ, TYPE, IUSER, QUICK, I, IBLK,
     *   IDATA, IERR)
      FINDIN = 0
      FIND2 = 0
      FIND = 0
      POTERR = 0
      IF (IERR.NE.0) POTERR = 33
      GO TO 980
C-----------------------------------------------------------------------
C                                       DEFAULT
C                                       reset task parameters
C-----------------------------------------------------------------------
C                                       open inputs file
 700  CALL ZPHFIL ('HE', 1, 0, 0, PHNAME, IERR)
      POTERR = 101
C                                       Allow min match
C                                       Return true value
      CALL ADVERB ('VERSION', 'C', 1, 48, IDUM, RDUM, LVERSN)
      IF (ERRNUM.NE.0) GO TO 980
      CALL VERMAT (1, PHNAME, ITASK, LVERSN, VERTYP, AVERSN, IERROR)
      IF (IERROR(1).NE.0) GO TO 980
C                                      Set TASK adverb
      CALL ADVRBS ('TASK', 'C', 1, 8, IDUM, RDUM, ITASK)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ZTOPEN (LUNIN, FINDIN, 1, PHNAME, ITASK, AVERSN, T, IERROR)
      POTERR = 31
      IF (IERROR(1).NE.0) THEN
         FINDIN = 0
         GO TO 980
         END IF
C                                       skip first 2 records
 705  CALL ZTREAD (LUNIN, FINDIN, JBUF, IERR)
      POTERR = 59
      IF (IERR.NE.0) GO TO 980
      IF (JBUF(1:1).EQ.';') GO TO 705
      IF (JBUF(1:8).EQ.'--------') THEN
         POTERR = 54
         GO TO 980
         END IF
 710  CALL ZTREAD (LUNIN, FINDIN, JBUF, IERR)
      IF (IERR.EQ.IEOF) GO TO 750
      IF (IERR.NE.0) GO TO 980
      IF (JBUF(1:1).EQ.';') GO TO 710
      IF (JBUF(1:8).EQ.'--------') THEN
         POTERR = 54
         GO TO 980
         END IF
C                                       loop for adverbs
 720  CALL ZTREAD (LUNIN, FINDIN, JBUF, IERR)
         IF (IERR.EQ.IEOF) GO TO 750
         POTERR = 59
         IF (IERR.NE.0) GO TO 980
         IF (JBUF(1:1).EQ.';') GO TO 720
         IF (JBUF(1:8).EQ.'--------') GO TO 750
         I = JTRIM (JBUF)
         IF (JBUF(COLSHO:COLSHO).EQ.'?') GO TO 720
         JBUF(COLSHO:COLSHO) = ' '
         KARBUF = JBUF
         KBPTR = NMATCC (1, ' ', KARBUF)
C                                       coment
         IF (KBPTR.GE.COLLBN) GO TO 720
C                                       adverb
         CTEST = JBUF(:8)
         CALL GETFLD
         IF (ERRNUM.NE.0) GO TO 980
         ITAG = TAG
         ILOC = LOCSYM
         ITYPE = SYTYPE
         IF (ITYPE.EQ.7) THEN
            HVALU = HBLANK
         ELSE
            RVALU = -1.0
            DO 725 I = 1,NADM1
               IF (CTEST.EQ.ADVM1(I)) GO TO 740
 725           CONTINUE
            RVALU = 1.0
            DO 730 I = 1,NADP1
               IF (CTEST.EQ.ADVP1(I)) GO TO 740
 730           CONTINUE
            DO 735 I = 1,NADSP
               RVALU = VADVSP(I)
               IF (CTEST.EQ.ADVSP(I)) GO TO 740
 735           CONTINUE
            RVALU = 0.0
            END IF
C                                       Type 7 is a string.
 740     POTERR = 8
C                                       Type 1 is a scalar, 2=array.
         IF ((SYTYPE.NE.1) .AND. (SYTYPE.NE.2) .AND. (SYTYPE.NE.7))
     *      GO TO 980
         ISIZE = 1
         IF (ITYPE.NE.1) ISIZE = K(K(ILOC+3))
         DO 745 I = 1,ISIZE
            IF (ITYPE.EQ.7) THEN
               CH(ITAG) = HVALU
            ELSE
               C(ITAG) = RVALU
               END IF
            ITAG = ITAG + 1
 745        CONTINUE
         ITAG = ITAG - ISIZE
C                                       Check character strings
         IF (ITYPE.EQ.7) THEN
            IF (CTEST.EQ.'OPTELL') CALL CHR2H (4, 'CHAN', 1, CH(ITAG))
            IF (CTEST.EQ.'BANDPOL') CALL CHR2H (8, '*(RL)', 1, CH(ITAG))
            CALL VERSTR (ILOC)
            IF (ERRNUM.NE.0) GO TO 980
            END IF
         GO TO 720
C                                       Done !
 750  POTERR = 0
      GO TO 980
C-----------------------------------------------------------------------
C                                       SG2RUN
C-----------------------------------------------------------------------
 800  CALL ADVERB ('OUTFILE', 'C', 1, 48, IDUM, RDUM, PHNAME)
      IF (ERRNUM.NE.0) GO TO 980
      LUNDE = 10
      CALL K2TEXT (LUNDE, .FALSE., PHNAME)
      GO TO 980
C-----------------------------------------------------------------------
C                                       PLGET
C-----------------------------------------------------------------------
C                                       Find start of real*4
C                                       parms in graph file.
 900  POTERR = 101
C                                       Create name string.
      CALL ADVERB ('INNAME', 'C', 1, 12, IDUM, RDUM, NAME)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INCLASS', 'C', 1, 6, IDUM, RDUM, CLASS)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INSEQ', 'I', 1, 0, ISEQ, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INDISK', 'I', 1, 0, IVOL, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      TYPE = ' '
      IUSER = NLUSER
C                                       Open map file, get header.
      CALL MAPOPN ('READ', IVOL, NAME, CLASS, ISEQ, TYPE, IUSER,
     *   LUN, FIND, ISLOT, CATBLK, IDATA, IERR)
      IF (IERR.GT.1) GO TO 980
C                                       Close map file.
      CALL MAPCLS ('READ', IVOL, ISLOT, LUN, FIND, CATBLK, F, IDATA,
     *   IERR)
      CALL FNDEXT ('PL', CATBLK, IMAXV)
      IF (IMAXV.LE.0) THEN
         MSGTXT = 'NO PLOT FILES IN THIS IMAGE/UV FILE'
         CALL MSGWRT (8)
         GO TO 980
         END IF
      CALL ADVERB ('PLVER', 'I', 1, 0, IVER, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IF ((IVER.LT.1) .OR. (IVER.GT.IMAXV)) IVER = 1
      CALL OPEXT ('PL', IVOL, ISLOT, IVER, LUN, F, F, FIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) 'PL', IVER, IERR
         CALL MSGWRT (8)
         GO TO 980
         END IF
      I = 1
      CALL ZFIO ('READ', LUN, FIND, I, IDATA, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1900) IERR, I
         CALL MSGWRT (8)
         GO TO 980
         END IF
      ISADV = IDATA(3).GT.0
      NPARMS = IDATA(10)
      I = (NPARMS + 9) / 256 + 2
      IF (ISADV) I = I + 1
C                                       first record of plot commands
      CALL ZFIO ('READ', LUN, FIND, I, IDATA, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1900) IERR, I
         CALL MSGWRT (8)
         GO TO 980
         END IF
      IPTYPE = IDATA(6)
      ITASK = ' '
      IF ((IPTYPE.GE.1) .AND. (IPTYPE.LE.NPLOTS)) ITASK = PNAMES(IPTYPE)
      IF (ITASK.EQ.' ') THEN
         WRITE (MSGTXT,1910) IPTYPE
         CALL MSGWRT (8)
         GO TO 980
         END IF
      IF (NPARMS.NE.PNPARM(IPTYPE)) THEN
         MSGTXT = 'WARNING: PLOT MAY BE FROM OLDER VERSION OF ' // ITASK
         CALL MSGWRT (6)
         IF (ISADV) THEN
            MSGTXT = 'BUT WE SHOULD RECOVER THE ADVERBS THAT WERE USED'
         ELSE
            MSGTXT = 'CHECK OUTPUT ADVERBS CLOSELY'
            END IF
         CALL MSGWRT (6)
         END IF
      POTERR = 0
      IF (.NOT.ISADV) GO TO 100
C                                       Have the adverb list
      I = (NPARMS+9)/256 + 2
      CALL ZFIO ('READ', LUN, FIND, I, IDATA(513), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1900) IERR, I
         CALL MSGWRT (8)
         GO TO 980
         END IF
C                                       get the start of the adverb data
      I = 1
      CALL ZFIO ('READ', LUN, FIND, I, IBLK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1900) IERR, I
         CALL MSGWRT (8)
         GO TO 980
         END IF
      JOFF = 1
      IPTR = 11
      DO 902 J = 1,256,2
         IF (IDATA(J+512).EQ.0) GO TO 902
         CALL H2CHR (8, 1, HDATA(J+512), DBG(8*J-7:))
 902     CONTINUE
      CALL ADVRBS ('TASK', 'C', 1, 8, IDUM, RDUM, ITASK)
      IF (ERRNUM.NE.0) GO TO 980
C                                       set adverb values
      KARBUF = ' '
      DO 920 J = 1,256,2
         IF (IDATA(J+512).EQ.0) GO TO 930
         CALL H2CHR (8, 1, HDATA(J+512), KARBUF)
         I = JTRIM (KARBUF)
         KBPTR = NMATCC (1, ' ', KARBUF)
C                                       adverb
         CALL GETFLD
         IF (ERRNUM.NE.0) GO TO 980
         ITAG = TAG
         ILOC = LOCSYM
         ITYPE = SYTYPE
C                                       Type 7 is a string.
         POTERR = 8
C                                       Type 1 is a scalar, 2=array.
         IF ((SYTYPE.NE.1) .AND. (SYTYPE.NE.2) .AND. (SYTYPE.NE.7))
     *      GO TO 980
         ISIZE = 1
         IF (ITYPE.NE.1) ISIZE = K(K(ILOC+3))
         DO 910 I = 1,ISIZE
            IF (ITYPE.EQ.7) THEN
               CH(ITAG) = HARBUF(IPTR)
            ELSE
               C(ITAG) = PARBUF(IPTR)
               END IF
            ITAG = ITAG + 1
            IPTR = IPTR + 1
            IF (IPTR.GT.256) THEN
               IPTR = 1
               JOFF = JOFF + 1
               CALL ZFIO ('READ', LUN, FIND, JOFF, IBLK, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1900) IERR, JOFF
                  CALL MSGWRT (8)
                  POTERR = 50
                  GO TO 980
                  END IF
               END IF
 910        CONTINUE
C                                       Check character strings
         IF (ITYPE.EQ.7) THEN
            CALL VERSTR (ILOC)
            IF (ERRNUM.NE.0) GO TO 980
            END IF
 920     CONTINUE
 930  POTERR = 0
      GO TO 980
C-----------------------------------------------------------------------
C                                       POPS errors
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C                                       Close downs
      IF (FINDIN.GT.0) CALL ZTCLOS (LUNIN, FINDIN, IERR)
      IF (FIND.GT.0) CALL ZCLOSE (LUN, FIND, IERR)
      IF (FIND2.GT.0) CALL ZCLOSE (LUN2, FIND2, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SGDESTR REQUIRES A FULL NAME: NO DEFAULTS AND NO ',
     *   'MIN-MATCH')
 1020 FORMAT ('YOU SEEM TO HAVE NO FILES OF TYPE ',A2,' VERSION',I3,
     *   ' OPEN ERR',I7)
 1115 FORMAT ('Warning: private versions being used - check adverbs',
     *   ' closely')
 1116 FORMAT ('VERSION ADVERB DOES NOT MATCH THAT',
     *   ' USED WHEN ADVERBS STORED')
 1165 FORMAT ('ADVERB ',A,' SIZE, TYPE MISMATCH',2(I6,I4))
 1180 FORMAT ('Adverb ',A,' is in INPUTS but not TGET file')
 1185 FORMAT ('Adverb ',A,' was in TGET but not INPUTS file')
 1220 FORMAT ('SG FILE ',A16,' NOT FOUND')
 1240 FORMAT ('FAILED TO DESTROY EMPTY DIRECTORY',I7)
 1250 FORMAT ('FAILED TO CREATE NEW SAVE/GET FILE',I5)
 1300 FORMAT ('Index of TGET/TPUT file user',I6)
 1301 FORMAT ('Index of VGET/VPUT file version',I3)
 1310 FORMAT ('LIST OF',I6,' NAMES LIMITED TO FIRST',I4)
 1315 FORMAT ('Reading ',A,' format TGET file')
 1316 FORMAT (3X,'Name',11X,'Last GO time',10X,'Version')
 1330 FORMAT (3X,A8,3X,A12,1X,A8,5X,A8)
 1410 FORMAT ('LIST LIMITED TO FIRST',I4,' NAMES')
 1415 FORMAT ('Listing for user',I6)
 1416 FORMAT (3X,'SAVE name',14X,'Last SAVE time',9X,'version')
 1430 FORMAT (2X,'''',A16,'''',3X,A12,1X,A8,5X,A9)
 1900 FORMAT ('ERROR',I4,' READING PL FILE RECORD',I4)
 1910 FORMAT ('PLOT TYPE',I4,' NOT SUPPORTED BY PLGET')
      END

      SUBROUTINE OFMCOL (NLEVS, OFM, IOFM, IERR)
C-----------------------------------------------------------------------
C! various standard OFMs with a stretch interaction
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Inputs:
C      NLEVS    I      color levels
C   Output:
C      BUFFER   I(*)   scratch * >= TVMOFM
C      IERR     I      error code
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PTVC.INC'
      INTEGER   NLEVS, IERR
      REAL      OFM(TVMOFM,3), IOFM(TVMOFM,3)
C
      INTEGER   IBUT, QUAD, ITW(3), ICOL, IMLEVS, CCOL(3), MX, MY,
     *   LX, LY, J0, I, J
      REAL      RPOS(2), PPOS(2), FK, X
      LOGICAL   F, DOIT
      CHARACTER ANAMES(10)*8, BNAMES(10)*8, CNAMES(10)*8, NAMES(10,3)*8,
     *   FILNAM*48
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (ANAMES, NAMES(1,1))
      EQUIVALENCE (BNAMES, NAMES(1,2))
      EQUIVALENCE (CNAMES, NAMES(1,3))
      DATA F /.FALSE./
      DATA ANAMES /'AMBER','CERRADO','FLAMINGO','FLARE','INFERNO',
     *   'LAJOLLA','MAGMA','OXY','ROCKET','TURBID'/
      DATA BNAMES /'ALGAE','CETCBL4','PARULA','PLASMA','RAIN',
     *   'TROPICAL','TURBO','ECTD1','TWILIGHT','VLAG'/
      DATA CNAMES /'ARAUCARI','CIVIDIS','CREST','ECLIPSE','FREEZE',
     *   'MAKO','PANTANAL','VIRIDIS','ICEFIRE','RAINBOW'/
C-----------------------------------------------------------------------
C                                        general parameters
      QUAD = -1
      RPOS(1) = 0.0
      RPOS(2) = 0.0
      IMLEVS = MAX (LUTOUT+1, NLEVS)
      IF (IMLEVS.GT.OFMINP+1) IMLEVS = OFMINP + 1
      CALL ZTIME (ITW)
C                                        TVCOLORS
C                                        Button A: red ofms
C                                        Button B: green ofms
C                                        Button C: blue ofms
      MSGTXT = 'Hit button A for reddish OFMs'
      CALL MSGWRT (1)
      MSGTXT = 'Hit button A for greenish & 2-color OFMs'
      CALL MSGWRT (1)
      MSGTXT = 'Hit button A for blueish OFMs'
      CALL MSGWRT (1)
      MSGTXT = 'Hit button D to exit'
      CALL MSGWRT (1)
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      ICOL = 0
      MX = WINDTV(3) - WINDTV(1) + 1
      MY = WINDTV(4) - WINDTV(2) + 1
      CALL FILL (3, 0, CCOL)
      IBUT = 1
      GO TO 30
C                                        init vals, on cursor
 10   RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
      RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2
      CALL RCOPY (2, RPOS, PPOS)
      MX = RPOS(1)
      MY = RPOS(2)
      CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IERR)
      IF (IERR.NE.0) GO TO 900
C                                        read until moves
 20   CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IERR)
         IF (IERR.NE.0) GO TO 900
         IF (IBUT.GT.7) GO TO 900
         IF (IBUT.EQ.0) GO TO 35
C                                       new OFM
 30         CALL YWINDO ('READ', WINDTV, IERR)
            IF (IERR.NE.0) GO TO 900
            MX = (WINDTV(1) + WINDTV(3)) / 2
            MY = (WINDTV(2) + WINDTV(4)) / 2
            LX = WINDTV(3) - WINDTV(1) + 1
            LY = WINDTV(4) - WINDTV(2) + 1
            ICOL = MIN (3, IBUT)
            CCOL(ICOL) = CCOL(ICOL) + 1
            IF (CCOL(ICOL).GT.10) CCOL(ICOL) = 1
            FILNAM = NAMES(CCOL(ICOL),ICOL)
            CALL OFMDIR ('QGET', FILNAM, TVMOFM, IOFM, IERR)
            IF (IERR.NE.0) GO TO 900
            CALL OFMIO ('WRIT', TVMOFM, IMLEVS, F, IOFM, IERR)
            IF (IERR.NE.0) GO TO 900
            MSGTXT = 'Doing ' // FILNAM
            CALL MSGWRT (2)
            GO TO 10
C                                       stretch current OFM
 35      CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
C                                        new color
         IF ((DOIT) .AND. (ICOL.GT.0)) THEN
            J0 = (IMLEVS * (RPOS(1)-WINDTV(1))) / LX
            FK = IMLEVS / (2.0 * J0)
            DO 40 I = 2,J0
               X = IMLEVS/2 + FK * (I-J0)
               J = X
               OFM(I,3) = (IOFM(J+1,3)-IOFM(J,3))*(X-J) + IOFM(J,3)
               OFM(I,2) = (IOFM(J+1,2)-IOFM(J,2))*(X-J) + IOFM(J,2)
               OFM(I,1) = (IOFM(J+1,1)-IOFM(J,1))*(X-J) + IOFM(J,1)
 40            CONTINUE
            FK = IMLEVS / (2.0 * (IMLEVS-J0))
            DO 50 I = J0+1,IMLEVS
               X = IMLEVS/2 + FK * (I-J0)
               J = X
               J = MIN (IMLEVS-1, J)
               OFM(I,3) = (IOFM(J+1,3)-IOFM(J,3))*(X-J) + IOFM(J,3)
               OFM(I,2) = (IOFM(J+1,2)-IOFM(J,2))*(X-J) + IOFM(J,2)
               OFM(I,1) = (IOFM(J+1,1)-IOFM(J,1))*(X-J) + IOFM(J,1)
 50            CONTINUE
C                                       Send to TV
            CALL OFMIO ('WRIT', TVMOFM, IMLEVS, F, OFM, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         GO TO 20
C                                        messages on error
 900  IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1910) IERR
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1910 FORMAT ('OFMCOL: TV ACTION ERROR CODE',I7)
      END

LOCAL INCLUDE 'LISUN.INC'
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER NAMEIN*12, CLAIN*6, XSOUR(30)*16, XCALCO*4, LPNAME*48,
     *   OULINE*132, TITL1*132, TITL2*132, SCRTCH*132
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOURC(4,30), XXCALC, XLPNAM(12)
      DOUBLE PRECISION  FREQIF(MAXIF), BFREQ
      REAL      XSIN, XDISIN, XTIME(8), XBAND, XFREQ, XFQID, DOCRT,
     *   XBADD(10)
      LOGICAL   ISINGL, VERBOS
      INTEGER   DISKIN, SEQIN, CNOIN, BUFFER(512), LUNP, FINDP, NACROS,
     *   IPCNT, PAGE, IXINC, NCOUNT, NSUB, PRTM
C
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOURC, XXCALC,
     *   XTIME, XBAND, XFREQ, XFQID, DOCRT, XLPNAM, XBADD
      COMMON /CHPARM/ NAMEIN, CLAIN, XSOUR, XCALCO, LPNAME, OULINE,
     *   TITL1, TITL2, SCRTCH
      COMMON /INFOLS/ FREQIF, BFREQ, ISINGL, VERBOS, DISKIN, SEQIN,
     *   CNOIN, BUFFER, NACROS, IPCNT, PAGE, LUNP, FINDP, IXINC, NCOUNT,
     *   NSUB, PRTM
LOCAL END
LOCAL INCLUDE 'LISUN.BUF'
      REAL   XXBUFF(10000)
      COMMON /BUFFRS/ XXBUFF
LOCAL END
      PROGRAM LISUN
C-----------------------------------------------------------------------
C! LISUN prints uv data scan info with Sun angle; lists antennas
C# Calibration UV VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 2023, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task LISUN prints data from uv data files in a variety of forms.
C   Inputs:
C      AIPS Adverb   Prg. Name          Description
C      INNAME         NAME          File name to be listed.
C      INCLASS        CLASS         File class to be listed.
C      INSEQ          SEQ           File sequence number.
C      INDISK         DISK          Disk volumn on which file resides.
C      SOURCES        XSOUR(4,30)   Sources selected
C      CALCODE        XCALCO        Calibrator source code
C      TIMERANG       XTIME(8)      Timerange
C      DOCRT          DOCRT         > 0 => use CRT, else line printer
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, IERR, CATSAV(256)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'LISUN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA PRGM /'LISUN '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL LISUNI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
      CALL COPY (256, CATBLK, CATSAV)
C                                       now actually print
      CALL COPY (256, CATSAV, CATBLK)
      CALL SCANUV (IRET)
C                                       Close printer
      IF (IPCNT.GE.0) CALL LPCLOS (LUNP, FINDP, IPCNT, IERR)
      GO TO 990
C                                       Close down files, etc.
 990  IRET = MAX (0, IRET)
      CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE LISUNI (PRGN, JERR)
C-----------------------------------------------------------------------
C   LISUNI gets input parameters for LISUN
C   Inputs:
C      PRGN    C*6       Program name (2 chars/word)
C   Output:
C      JERR    I         Error code: 0 => ok
C                           5 => catalog troubles
C                           8 => can't start
C   Commons:
C      /INPARM/ all input adverbs in order given by INPUTS file
C      /MAPHDR/ output file catalog header
C   See prologue comments in LISUN for more details.
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   JERR
C
      CHARACTER STAT*4, STATUS*4, UTYPE*2
      INTEGER   IROUND, NPARM, IERR, I, LUN, NIF, IIVER, MXIF
      REAL      CATR(256)
      LOGICAL   F, TABLE, EXIST, FITASC, MATCH
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ISBAND(MAXIF)
      DOUBLE PRECISION    FOFF(MAXIF)
      REAL      FINC(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'LISUN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
C      INCLUDE 'INCS:DANT.INC'
      EQUIVALENCE (CATR,CATBLK)
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
      NCOUNT = 0
C                                       Get input parameters.
      NPARM = 162
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFFER, IERR)
      IF ((IERR.NE.0) .OR. (NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   DOCRT = MIN (-1.0, DOCRT)
      CALL H2CHR (48, 1, XLPNAM, LPNAME)
      IF (DOCRT.GT.0.0) RQUICK = .FALSE.
      IF (RQUICK) RQUICK = LPNAME.NE.' '
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFFER, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XXCALC, XCALCO)
C                                       Calcode abreviations
      IF (XCALCO(1:2).EQ.'CA') XCALCO = '*   '
      IF (XCALCO(1:1).EQ.'-')  XCALCO = '-CAL'
      SELCOD = XCALCO
      DO 25 I = 1,30
         CALL H2CHR (16, 1, XSOURC(1,I), XSOUR(I))
 25      CONTINUE
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
C                                       Get CATBLK.
      CNOIN = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      STATUS = 'REST'
      STATUS = 'READ'
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, STATUS, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING DATA HEADER'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 0
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      BFREQ = FREQ
      CALL FNDEXT ('AN', CATBLK, NSUB)
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DO 70 I = 1,30
         SOURCS(I) = XSOUR(I)
 70      CONTINUE
      CALL RCOPY (8, XTIME, TIMRNG)
      DO 80 I = 1,10
         IBAD(I) = IROUND (XBADD(I))
 80      CONTINUE
      TSTART = ((TIMRNG(4)/60. + TIMRNG(3))/60. + TIMRNG(2))/24. +
     *   TIMRNG(1)
      TEND = ((TIMRNG(8)/60. + TIMRNG(7))/60. + TIMRNG(6))/24. +
     *   TIMRNG(5)
      IF (TEND.LE.TSTART) THEN
         TSTART = -1.0
         TEND = 1000.
         END IF
      JERR = 0
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      LUN = 28
      FRQSEL = MAX (1, FRQSEL)
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1070)
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
      CALL MULSDB (CATBLK, ISINGL)
C                                       Get IF freq offset.
      LUN = 28
      IIVER = 1
      CALL CHNDAT ('READ', BUFFER, DISKIN, CNOIN, IIVER, CATBLK, LUN,
     *   NIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, JERR)
      IF (JERR.GT.0) GO TO 999
      MXIF = MAXIF
      DO 100 I = 1, MXIF
         FREQIF(I) = FOFF(I)
 100     CONTINUE
C                                       See if a single source file.
      CALL MULSDB (CATBLK, ISINGL)
      IF (ISINGL) THEN
         CALL ISTAB ('SU', DISKIN, CNOIN, 1, LUN, BUFFER, TABLE, EXIST,
     *      FITASC, IERR)
         ISINGL = EXIST .AND. (IERR.EQ.0) .AND. TABLE
         END IF
      ISINGL = .NOT.ISINGL
      IF (ISINGL) THEN
         NSOUWD = 0
      ELSE
         CALL FNDSOU (DISKIN, CNOIN, SOURCS, BUFFER, NSOUWD, DOSWNT,
     *      SOUWAN, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'FINDING SOURCE LIST'
            GO TO 990
            END IF
         END IF
C                                       Init printer
      PAGE = 0
      IPCNT = 980
      TITL1 = ' '
      TITL2 = ' '
      OULINE = ' '
C                                       Open output device
      IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
      CALL LPOPEN (LPNAME, DOCRT, LUNP, FINDP, NACROS, BUFFER, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1080) JERR
         JERR = 1
         GO TO 990
      END IF
      IF (DOCRT.GT.0) THEN
         PRTM = ABS(CRTMAX)
      ELSE IF (DOCRT.GT.-2.5) THEN
         PRTM = PRTMAX
      ELSE
         PRTM = 100000
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('LISUNI: ERROR',I3,' ON',A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
 1080 FORMAT ('LISUNI: ERROR ',I3,' OPENING OUTPUT ''PRINT'' DEVICE')
      END
      SUBROUTINE SCANUV (IRET)
C-----------------------------------------------------------------------
C   Gives column listing of the index table and source info.
C   Output:
C      IRET   I    Return code, 0=OK, else failed
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXSOU
      PARAMETER (MAXSOU=10000)
      CHARACTER  CCODE*1, VELTYP*8, VELDEF*8, SUNAME*16, CALCOD*4,
     *   CH1*1, CH2*1, OBSDAT*8
      INTEGER   IRET, TIME(8), QUAL, NXSOUR, NXSUB, INXLUN, ISLUN, I, J,
     *   HMRA(2), DMDEC(2), SUKOLS(MAXSUC), SUNUMV(MAXSUC), IDSOU, IERR,
     *   NNIF, NSOURC, NDXRNO, SURNO, LOOP, NXVS, NXVE, MXSOU, IIVER,
     *   FQID, FQSIDE(MAXIF), NMFQIF, NUMFQE, NXFQI, NXVER, NLOOP,
     *   SUFQID, MAXSUB, DROUND, ISEP, OBSDAY(6), LONG(2), LAT(2)
      LOGICAL   FQEXIS, TABLE, FITASC, SAMEFQ, ISNX, ISSU
      REAL      T1, T2, NXTIME, NXDTIM, SECRA, SECDEC, FQTBW(MAXIF),
     *   FQCHBW(MAXIF), SLONG, SLAT
      DOUBLE PRECISION    BANDW, RAEPO, DECEPO, EPOCH, RAAPP, SFREQ,
     *   SLSRV, SRF, DECAPP, PMRA, PMDEC, FQFRQ(MAXIF), RAOBS, DECOBS,
     *   XRA(MAXSOU+1), XDEC(MAXSOU+1), SSEP
      INTEGER   XQUAL(MAXSOU+1), XSCNT(MAXSOU+1), KSID(MAXIF), KQUAL
      CHARACTER SXNAME(MAXSOU+1)*16, XCODE(MAXSOU+1)*4, BNDCOD(MAXIF)*8
      REAL      FLUX(4,MAXIF), FINC(MAXIF), CATR(256)
      DOUBLE PRECISION    LSRVEL(MAXIF), FREQO(MAXIF), RESTFQ(MAXIF),
     *   FOFF(MAXIF), CATD(128), REFF, FREQAS(MAXIF), VELOCS(MAXIF),
     *   FQREST(MAXIF)
      HOLLERITH CATH(256)
      INCLUDE 'LISUN.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DANS.INC'
      EQUIVALENCE (CATD, CATH, CATR, CATBLK)
      DATA MXSOU /MAXSOU/
      DATA ISLUN, INXLUN /27,28/
C-----------------------------------------------------------------------
C                                       Do NX, SU tables exist?
      CALL ISTAB ('NX', DISKIN, CNOIN, 1, INXLUN, BLBUFF, TABLE, ISNX,
     *   FITASC, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1001) IRET, 'NX'
         GO TO 990
         END IF
      IF (.NOT.ISNX) THEN
         MSGTXT = 'NX TABLE MISSING, SCAN OUTPUT WILL OMIT'
         CALL MSGWRT (6)
         END IF
      CALL ISTAB ('SU', DISKIN, CNOIN, 1, INXLUN, BLBUFF, TABLE, ISSU,
     *   FITASC, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1001) IRET, 'SU'
         GO TO 990
         END IF
      IF (.NOT.ISSU) THEN
         MSGTXT = 'NO SOURCE TABLE, SCAN OUTPUT WILL OMIT'
         CALL MSGWRT (6)
         END IF
C
      FREQ = BFREQ * 1.0D-9
      MAXSUB = 1
C                                       Initialize source info
      I = MXSOU + 1
      DO 10 LOOP = 1,I
         XSCNT(LOOP) = 0
         XQUAL(LOOP) = 0
         XCODE(LOOP) = 'HELP'
         SXNAME(LOOP) = 'Not in SU table'
 10      CONTINUE
      IF (NSOUWD.GT.0) THEN
         IF (DOSWNT) THEN
            CALL FILL (I, -999, XQUAL)
            DO 11 LOOP = 1,NSOUWD
               I = SOUWAN(LOOP)
               XQUAL(I) = 0
 11            CONTINUE
         ELSE
            DO 12 LOOP = 1,NSOUWD
               I = SOUWAN(LOOP)
               XQUAL(I) = -1
 12            CONTINUE
            END IF
         END IF
      SXNAME(I) = 'Too many sources'
      XSCNT(I) = -1
      EPOCH = CATR(KREPO)
      CALL H2CHR (8, 1, CATH(KHDOB), OBSDAT)
      READ (OBSDAT,1012) OBSDAY(1), OBSDAY(2), OBSDAY(3)
C                                       Get source info
      IF (ISSU) THEN
         CALL SOUINI ('READ', BLBUFF, DISKIN, CNOIN, 1, CATBLK, ISLUN,
     *      NUMIF, VELTYP, VELDEF, SUFQID, SURNO, SUKOLS, SUNUMV, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING SU TABLE'
            GO TO 990
            END IF
         SUFQID = MAX (1, SUFQID)
         NSOURC = BLBUFF(5)
         DO 30 LOOP = 1,NSOURC
            SURNO = LOOP
            CALL TABSOU ('READ', BLBUFF, SURNO, SUKOLS, SUNUMV, IDSOU,
     *         SUNAME, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *         EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ,
     *         PMRA, PMDEC, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING SU TABLE'
               GO TO 990
               END IF
            IF ((IDSOU.GT.0) .AND. (IDSOU.LE.MXSOU) .AND.
     *         (XQUAL(IDSOU).GE.0)) THEN
               SXNAME(IDSOU) = SUNAME
               XCODE(IDSOU) = CALCOD
               XQUAL(IDSOU) = QUAL
               XRA(IDSOU) = RAAPP
               XDEC(IDSOU) = DECAPP
               IF ((XRA(IDSOU).EQ.0.0D0) .AND. (XDEC(IDSOU).EQ.0.0D0))
     *            THEN
                  XRA(IDSOU) = RAEPO
                  XDEC(IDSOU) = DECEPO
                  END IF
               END IF
 30         CONTINUE
      ELSE
         SAMEFQ = .TRUE.
         NSOURC = 1
         XCODE(1) = ' '
         XQUAL(1) = 0
         CALL H2CHR (8, 1, CATH(KHOBJ), SXNAME(1))
         SUFQID = 1
         IF (CATBLK(KIALT).NE.0) THEN
            I = CATBLK(KIALT)/256 + 1
            VELTYP = 'RADIO'
            IF (I.EQ.1) VELTYP = 'OPTICAL'
            I = CATBLK(KIALT) - (I-1) * 256
            VELDEF = 'LSR'
            IF (I.EQ.2) VELDEF = 'BARYCENTR'
            IF (I.EQ.3) VELDEF = 'TOPOCENTR'
         ELSE
            VELTYP = ' '
            VELDEF = ' '
            END IF
         END IF
C                                       Initialize index table
      IF (ISNX) THEN
         NXVER = 1
         CALL NDXINI ('READ', NXBUFF, DISKIN, CNOIN, NXVER, CATBLK,
     *      INXLUN, NDXRNO, NXKOLS, NXNUMV, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING INDEX TABLE'
            GO TO 990
            END IF
         END IF
C                                       Initialize FQ table
      IQLUN = 44
      NXVER = 1
      CALL ISTAB ('FQ', DISKIN, CNOIN, NXVER, IQLUN, FQBUFF, TABLE,
     *   FQEXIS, FITASC, IRET)
      IF (FQEXIS) THEN
         CALL FQINI ('READ', FQBUFF, DISKIN, CNOIN, NXVER, CATBLK,
     *      IQLUN, IFQRNO, FQKOLS, FQNUMV, NMFQIF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING FQ TABLE'
            GO TO 990
            END IF
         NUMFQE = FQBUFF(5)
         END IF
C                                       Names for labels
C                                       first page & page titles
      WRITE (OULINE,1030) NAMEIN, CLAIN, SEQIN, DISKIN, NLUSER
      CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, OULINE,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 950
      TITL1 = OULINE
      WRITE (OULINE,1031) FREQ, NCOR, NVIS
      CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, OULINE,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 950
      IF (DOCRT.GT.-2.5) THEN
         OULINE = 'Scan summary listing'
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, OULINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         OULINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, OULINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
      WRITE (TITL2,1035)
      CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, TITL2,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 950
C                                       Get number of index records
      IF (ISNX) THEN
         NINDEX = NXBUFF(5)
C                                       Loop thru index table
         DO 50 LOOP = 1,NINDEX
C                                       Read index table
            NDXRNO = LOOP
            CALL TABNDX ('READ', NXBUFF, NDXRNO, NXKOLS, NXNUMV, NXTIME,
     *         NXDTIM, NXSOUR, NXSUB, NXVS, NXVE, NXFQI, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING INDEX TABLE'
               GO TO 990
               END IF
            MAXSUB = MAX (MAXSUB, NXSUB)
C                                       Convert time
            T1 = NXTIME - 0.5 * NXDTIM
            T2 = NXTIME + 0.5 * NXDTIM
            IF ((T2.LT.TSTART) .OR. (T1.GT.TEND)) GO TO 45
            IF (XQUAL(NXSOUR).EQ.-999) GO TO 45
C                                       To Days Hours Minutes Secs
            READ (OBSDAT,1012) OBSDAY(1), OBSDAY(2), OBSDAY(3)
            CALL TODHMS (NXTIME, TIME(1))
            CALL COPY (3, TIME(2), OBSDAY(4))
            OBSDAY(3) = OBSDAY(3) + TIME(1)
            CALL SUNANG (OBSDAY, XRA(NXSOUR), XDEC(NXSOUR), SSEP)
            ISEP = DROUND (SSEP)
            CALL TODHMS (T1, TIME(1))
            CALL TODHMS (T2, TIME(5))
C                                       Print line
            IF ((NXSOUR.LT.1) .OR. (NXSOUR.GT.MXSOU)) NXSOUR = MXSOU + 1
C                                       If calc code OK
            CCODE = XCODE(NXSOUR)(1:1)
            IF ((XCALCO(:1).EQ.' ') .OR. (CCODE.EQ.XCALCO(:1)) .OR.
     *         ((XCALCO(:1).EQ.'*') .AND. (CCODE.NE.' ')) .OR.
     *         ((XCALCO(:1).EQ.'-') .AND. (CCODE.EQ.' '))) THEN
               WRITE (OULINE,1040) LOOP, SXNAME(NXSOUR), XCODE(NXSOUR),
     *            TIME, NXVS, NXVE, ISEP
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            OULINE, IPCNT, PAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 950
               END IF
C                                       Sum visibilities
 45         J = NXVE - NXVS + 1
            XSCNT(NXSOUR) = XSCNT(NXSOUR) + J
 50         CONTINUE
C                                       Close  INDEX table
         CALL TABIO ('CLOS', 0, NDXRNO, NXBUFF, NXBUFF, IERR)
         END IF
C-----------------------------------------------------------------------
C                                       Source summary
      OULINE = ' '
      TITL2 = ' '
C                                       if page half full, new page
      IF ((ISSU) .AND. (IPCNT.GT.PRTM/2)) IPCNT = 980
      IF (DOCRT.GT.-2.5) THEN
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, OULINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
      WRITE (TITL2,1051) EPOCH, EPOCH
      IF (DOCRT.GT.-2.5) THEN
         OULINE = 'Source summary'
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *      OULINE, IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
C                                       Velocity type, defination
      OULINE = ' '
      CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, OULINE,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 950
      WRITE (OULINE,1060) VELTYP, VELDEF
      CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, OULINE,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 950
      IF (DOCRT.GT.-2.5) THEN
         IF (MAXSUB.GT.1) THEN
            WRITE (OULINE,1061) MAXSUB
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         OULINE, IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 950
            END IF
         OULINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, OULINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
      CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, TITL2,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 950
C                                       Loop over source table
      IF (ISSU) THEN
C                                       Position, flux
         DO 110 LOOP = 1,NSOURC
            SURNO = LOOP
            CALL TABSOU ('READ', BLBUFF, SURNO, SUKOLS, SUNUMV, IDSOU,
     *         SUNAME, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *         EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ,
     *         PMRA, PMDEC, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING SOURCE TABLE'
               GO TO 990
               END IF
            KQUAL = QUAL
C                                       for all IFs
            DO 105 I = 1,NUMIF
C                                       Calc freq, velocity and rest fq
               SFREQ = FREQ + FREQO(I) * 1.0D-9
               SLSRV = LSRVEL(I) * 1.0D-3
               SRF = RESTFQ(I) * 1.0D-9
C                                       store on first source
               IF (LOOP.EQ.1) THEN
                  FREQAS(I) = SFREQ
                  VELOCS(I) = SLSRV
                  FQREST(I) = SRF
                  SAMEFQ    = .TRUE.
C                                       check on rest of sources
               ELSE
                  IF ((FREQAS(I).NE.SFREQ) .OR. (VELOCS(I).NE.SLSRV)
     *               .OR.(FQREST(I).NE.SRF)) SAMEFQ = .FALSE.
                  END IF
C                                       end for all IFs loop
 105           CONTINUE
C                                       Convert RA, dec
            CALL COORDD (1, RAEPO, CH1, HMRA, SECRA)
            CALL COORDD (2, DECEPO, CH2, DMDEC, SECDEC)
            NXSOUR = IDSOU
            IF ((NXSOUR.LT.1) .OR. (NXSOUR.GT.MXSOU)) NXSOUR = MXSOU + 1
            IF (XQUAL(NXSOUR).EQ.-999) GO TO 110
C                                       If calc code OK
            CCODE = XCODE(NXSOUR)(1:1)
            IF ((XCALCO(:1).EQ.' ') .OR. (CCODE.EQ.XCALCO(:1)) .OR.
     *         ((XCALCO(:1).EQ.'*') .AND. (CCODE.NE.' ')) .OR.
     *         ((XCALCO(1:1).EQ.'-') .AND. (CCODE.EQ.' '))) THEN
C                                       Write row
               WRITE (OULINE,1110) IDSOU, SUNAME, KQUAL, CALCOD, CH1,
     *            HMRA, SECRA, CH2, DMDEC, SECDEC, XSCNT(NXSOUR)
               IF (OULINE(43:43).EQ.' ') OULINE(43:43) = '0'
               IF (OULINE(58:58).EQ.' ') OULINE(58:58) = '0'
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            OULINE, IPCNT, PAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 950
               END IF
 110        CONTINUE
      ELSE
         CALL AXEFND (2, 'RA', CATBLK(KIDIM), CATH(KHCTP), I, IERR)
         RAEPO = CATD(KDCRV+I)
         CALL AXEFND (3, 'DEC', CATBLK(KIDIM), CATH(KHCTP), I, IERR)
         DECEPO = CATD(KDCRV+I)
         CALL COORDD (1, RAEPO, CH1, HMRA, SECRA)
         CALL COORDD (2, DECEPO, CH2, DMDEC, SECDEC)
         WRITE (OULINE,1110) 1, SXNAME(1), XQUAL(1), XCODE(1), CH1,
     *      HMRA, SECRA, CH2, DMDEC, SECDEC, XSCNT(1)
         IF (OULINE(43:43).EQ.' ') OULINE(43:43) = '0'
         IF (OULINE(58:58).EQ.' ') OULINE(58:58) = '0'
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *      OULINE, IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
C-----------------------------------------------------------------------
C                                       Only once if FQ same for all
      OULINE = ' '
      TITL2 = ' '
C                                       if page half full, new page
      IF ((ISSU) .AND. (IPCNT.GT.PRTM/2)) IPCNT = 980
      IF (DOCRT.GT.-2.5) THEN
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, OULINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
      WRITE (TITL2,1050)
      CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, TITL2,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 950
C                                       Loop over source table
      IF (ISSU) THEN
C                                       flux
         DO 130 LOOP = 1,NSOURC
            SURNO = LOOP
            CALL TABSOU ('READ', BLBUFF, SURNO, SUKOLS, SUNUMV, IDSOU,
     *         SUNAME, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *         EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ,
     *         PMRA, PMDEC, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING SOURCE TABLE'
               GO TO 990
               END IF
            KQUAL = QUAL
C                                       for all IFs
            DO 115 I = 1,NUMIF
C                                       Calc freq, velocity and rest fq
               SFREQ = FREQ + FREQO(I) * 1.0D-9
               SLSRV = LSRVEL(I) * 1.0D-3
               SRF = RESTFQ(I) * 1.0D-9
C                                       store on first source
               IF (LOOP.EQ.1) THEN
                  FREQAS(I) = SFREQ
                  VELOCS(I) = SLSRV
                  FQREST(I) = SRF
                  SAMEFQ    = .TRUE.
C                                       check on rest of sources
               ELSE
                  IF ((FREQAS(I).NE.SFREQ) .OR. (VELOCS(I).NE.SLSRV)
     *               .OR.(FQREST(I).NE.SRF)) SAMEFQ = .FALSE.
                  END IF
C                                       end for all IFs loop
 115           CONTINUE
C                                       Convert RA, dec
            CALL COORDD (1, RAEPO, CH1, HMRA, SECRA)
            CALL COORDD (2, DECEPO, CH2, DMDEC, SECDEC)
            NXSOUR = IDSOU
            IF ((NXSOUR.LT.1) .OR. (NXSOUR.GT.MXSOU)) NXSOUR = MXSOU + 1
            IF (XQUAL(NXSOUR).EQ.-999) GO TO 130
C                                       If calc code OK
            CCODE = XCODE(NXSOUR)(1:1)
            IF ((XCALCO(:1).EQ.' ') .OR. (CCODE.EQ.XCALCO(:1)) .OR.
     *         ((XCALCO(:1).EQ.'*') .AND. (CCODE.NE.' ')) .OR.
     *         ((XCALCO(1:1).EQ.'-') .AND. (CCODE.EQ.' '))) THEN
C                                       Write row
               WRITE (OULINE,1111) IDSOU, SUNAME, KQUAL, CALCOD,
     *            FLUX(1,1), FLUX(2,1), FLUX(3,1), FLUX(4,1),
     *            XSCNT(NXSOUR)
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            OULINE, IPCNT, PAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 950
C                                       Other IF fluxes
               IF (NUMIF.GT.1) THEN
                  DO 120 I = 2,NUMIF
                     IF ((FLUX(1,I).GT.0.0) .OR. (DOCRT.GT.-2.5)) THEN
                        WRITE (OULINE,1112) I, FLUX(1,I), FLUX(2,I),
     *                     FLUX(3,I), FLUX(4,I)
                        CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *                     TITL2, OULINE, IPCNT, PAGE, SCRTCH, IERR)
                        IF (IERR.NE.0) GO TO 950
                        END IF
 120                 CONTINUE
                  END IF
               END IF
 130        CONTINUE
         END IF
C                                       Get IF frequency info
      IF (.NOT.FQEXIS) THEN
         IIVER = 1
         CALL CHNDAT ('READ', NXBUFF, DISKIN, CNOIN, IIVER, CATBLK,
     *      INXLUN, NNIF, FOFF, KSID, FINC, BNDCOD, FRQSEL, IRET)
      ELSE
         CALL TABFQ ('READ', FQBUFF, SUFQID, FQKOLS, FQNUMV, NMFQIF,
     *      FQID, FOFF, FQCHBW, FQTBW, FQSIDE, BNDCOD, IRET)
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ IF FREQ INFO'
         GO TO 990
         END IF
      IF (DOCRT.GT.-2.5) THEN
         OULINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, OULINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
      WRITE (TITL2,1130)
      CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, TITL2,
     *    IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 950
      NLOOP = NSOURC
C                                       Frequency, velocity, rest freq.
      IF (SAMEFQ) NLOOP = 1
      IF (ISSU) THEN
         DO 150 LOOP = 1,NLOOP
            SURNO = LOOP
            CALL TABSOU ('READ', BLBUFF, SURNO, SUKOLS, SUNUMV, IDSOU,
     *         SUNAME, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *         EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ,
     *         PMRA, PMDEC, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING SOURCE TABLE'
               GO TO 990
               END IF
            KQUAL = QUAL
            SFREQ = FREQ + (FOFF(1) + FREQO(1)) * 1.0D-9
            SLSRV = LSRVEL(1) * 1.0D-3
            SRF = RESTFQ(1) * 1.0D-9
C                                       If FQ info same for all sources
            IF (SAMEFQ) SUNAME = 'All Sources     '
C                                       If calc code OK
            CCODE = XCODE(IDSOU)(1:1)
            IF ((XCALCO(:1).EQ.' ') .OR. (CCODE.EQ.XCALCO(:1)) .OR.
     *         ((XCALCO(:1).EQ.'*') .AND. (CCODE.NE.' ')) .OR. (SAMEFQ)
     *         .OR. ((XCALCO(1:1).EQ.'-') .AND. (CCODE.EQ.' '))) THEN
               WRITE (OULINE,1131) IDSOU, SUNAME, SFREQ, SLSRV, SRF
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            OULINE, IPCNT, PAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 950
C                                       Rest of IF loop
               IF (NUMIF.GT.1) THEN
                  DO 140 I = 2,NUMIF
                     SFREQ = FREQ + (FOFF(I) + FREQO(I)) * 1.0D-9
                     SLSRV = LSRVEL(I) * 1.0D-3
                     SRF = RESTFQ(I) * 1.0D-9
                     WRITE (OULINE,1132) I, SFREQ, SLSRV, SRF
                     CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *                  TITL2, OULINE, IPCNT, PAGE, SCRTCH, IERR)
                     IF (IERR.NE.0) GO TO 950
 140                 CONTINUE
                  END IF
               END IF
 150        CONTINUE
C                                       Close source table
         CALL TABIO ('CLOS', 0, SURNO, BLBUFF, BLBUFF, IERR)
C                                       single source
      ELSE
         I = CATBLK(KIALT) / 256 + 1
         J = CATBLK(KIALT) - (I-1) * 256
         IF ((I.GE.1) .AND. (I.LE.2) .AND. (J.GE.1) .AND. (J.LE.3)) THEN
            SRF = CATD(KDRST) * 1.0D-9
            SLSRV = CATD(KDARV) * 1.0D-3
            SFREQ = CATD(KDCRV+JLOCF) * 1.0D-9
            WRITE (OULINE,1131) 1, SXNAME(1), SFREQ, SLSRV, SRF
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         OULINE, IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 950
            END IF
         END IF
C                                       FQ table stuff
C                                       New page
      IF (FQEXIS) THEN
C                                       if not enough room, new page
         IF ((IPCNT+(NUMFQE*NMFQIF)+3).GT.PRTM) IPCNT = 980
         OULINE = ' '
         TITL2 = ' '
         IF (DOCRT.GT.-2.5) THEN
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         OULINE, IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 950
C                                       FQ summary
            REFF = CATR(KRCRP+JLOCF)
            WRITE (OULINE,1150) REFF
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         OULINE, IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 950
            END IF
C                                       List the FQ entries
         OULINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, OULINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         WRITE (TITL2,1151)
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, TITL2,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         REFF = CATD(KDCRV+JLOCF)
         DO 170 LOOP = 1, NUMFQE
            CALL TABFQ ('READ', FQBUFF, IFQRNO, FQKOLS, FQNUMV, NMFQIF,
     *         FQID, FQFRQ, FQCHBW, FQTBW, FQSIDE, BNDCOD, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING FQ TABLE'
               GO TO 990
               END IF
            DO 160 I = 1,NMFQIF
               FQFRQ(I) = (FQFRQ(I)+REFF) * 1.0D-9
               FQTBW(I) = FQTBW(I) * 1.0E-3
               FQCHBW(I) = FQCHBW(I) * 1.0E-3
               IF (I.EQ.1) THEN
                  WRITE (OULINE,1152) FQID, I, FQFRQ(I), FQTBW(I),
     *               FQCHBW(I), FQSIDE(I), BNDCOD(I)
               ELSE
                  WRITE (OULINE,1153) I, FQFRQ(I), FQTBW(I), FQCHBW(I),
     *               FQSIDE(I), BNDCOD(I)
                  END IF
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            OULINE, IPCNT, PAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 950
 160           CONTINUE
 170        CONTINUE
         CALL TABFQ ('CLOS', FQBUFF, IFQRNO, FQKOLS, FQNUMV, NMFQIF,
     *      FQID, FQFRQ, FQCHBW, FQTBW, FQSIDE, BNDCOD, IRET)
         END IF
C                                       get full antenna info
      DO 200 SUBARR = 1,NSUB
         CALL GETANT (DISKIN, CNOIN, SUBARR, CATBLK, BUFFER, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING ANTENNA FILE'
            GO TO 990
            END IF
C                                       if not enough room, new page
         IF (IPCNT+NSTNS+4.GT.PRTM) IPCNT = 980
         OULINE = ' '
         TITL2 = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, OULINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         WRITE (OULINE,1170) SUBARR
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, OULINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         WRITE (OULINE,1175)
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, OULINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         DO 190 LOOP = 1,NSTNS
            CALL T2DMS (STNLON(LOOP), 2, LONG, SLONG, CH1)
            CALL T2DMS (STNLAT(LOOP), 2, LAT, SLAT, CH2)
            WRITE (OULINE,1180) TELNO(LOOP), STNNAM(LOOP), STNX(LOOP),
     *         STNY(LOOP), STNZ(LOOP), CH1, LONG, SLONG, CH2, LAT, SLAT
            IF (OULINE(58:58).EQ.' ') OULINE(58:58) = '0'
            IF (OULINE(71:71).EQ.' ') OULINE(71:71) = '0'
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         OULINE, IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 950
 190        CONTINUE
 200     CONTINUE
      IRET = 0
      GO TO 999
C                                       Close files.
 950  IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1950) IERR
         CALL MSGWRT (8)
         IRET = 1
      ELSE
         IRET = -1
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SCANUV: ERROR',I3,' ON ',A)
 1001 FORMAT ('SCANUV: ERROR ',I3,' CHECKING ',A2,' TABLE')
 1012 FORMAT (I4,2I2)
 1030 FORMAT ('File = ',A12,'.',A6,'.',I4,' Vol =',I2,'  Userid =',I5)
 1031 FORMAT ('Freq =',F13.9,' GHz   Ncor =',I3,'   No. vis =',I10)
 1035 FORMAT ('Scan  Source',10X,'Calc',10X,'Time range',12X,
     *   'Start - end vis   Sun')
C 1035 FORMAT ('Scan      Source      Qual  Calcode Sub',9X,'Timerange',
C     *   10X,'FrqID   START VIS  END VIS')
 1040 FORMAT (I4,2X,A16,2X,A2,I4,'/',I2.2,2(':',I2.2),' -',I3,'/',I2.2,
     *   2(':',I2.2),2I10,I6)
C 1040 FORMAT (I4,1X,A16,':',I5.4,2X,A4,2X,I4,I3,'/',I2.2,2(':',I2.2),
C     *   ' - ',I3,'/',I2.2,2(':',I2.2),2X,I4,I8, 3X, I8)
 1050 FORMAT ('  ID Source',11X,' Qual Calcode ',
     *   '  IFlux   QFlux   UFlux   VFlux   No. vis')
 1051 FORMAT ('  ID Source',12X,'Qual Calcode RA(',F6.1,')     Dec(',
     *   F6.1,')    No. vis')
 1060 FORMAT ('Velocity type = ''',A8,'''    Definition = ''',A8,'''')
 1061 FORMAT ('WARNING: File contains',I4,' subarrays - vis.',
     *   ' counts may not be accurate')
 1110 FORMAT (I4,1X,A16,':',I5.4,3X,A4,1X,A1,2(I2.2,':'),F7.4,1X,A1,
     *   2(I2.2,':'),F6.3,I10)
 1111 FORMAT (I4,1X,A16,':',I5.4,3X,A4,1X,4F8.3,I10)
 1112 FORMAT (13X,'IF(',I2,')',16X,4F8.3)
 1130 FORMAT ('  ID Source',12X,'Freq(GHz) Velocity(Km/s)',
     *   ' Rest freq (GHz)')
 1131 FORMAT (I4,1X,A16,2X,F9.4,F15.4,F16.4)
 1132 FORMAT (5X,'IF(',I3,')',11X,F9.4,F15.4,F16.4)
 1150 FORMAT ('Frequency Table summary uses reference channel',F9.2)
 1151 FORMAT ('FQID IF#      Freq(GHz)      BW(kHz)   Ch.Sep(kHz)',
     *   '  Sideband  Bandcode')
 1152 FORMAT (I4,2X,I2,2X,F15.8,2X,F11.4,2X,F10.4,5X,I2,5X,A)
 1153 FORMAT (6X,I2,2X,F15.8,2X,F11.4,2X,F10.4,5X,I2,5X,A)
 1170 FORMAT (15X,'**********',4X,'Subarray',I4,4X,'**********')
 1175 FORMAT ('Ant Station',9X,'Bx',10X,'By',10X,'Bz',4X,'E Longitude',
     *   4X,'Latitude')
 1180 FORMAT (I3,1X,A8,3F12.2,1X,A1,I3.3,':',I2.2,':',F5.2,1X,A1,I2.2,
     *   ':',I2.2,':',F5.2)
 1950 FORMAT ('SCANUV: ERROR',I5,' DOING I/O TO TERMINAL')
      END
      SUBROUTINE SUNANG (OBSDAY, RA0, DEC0, SEPN)
C-----------------------------------------------------------------------
C   compute Sun angle to source
C   Inputes:
C      OBSDAY   I(6)   Date of observation: YYY, MM, DD, HH, MM, SS
C      RA0      D      Right Ascension
C      DEC0     D      Declination
C   Output
C      SEPN     D      Separation in degrees
C-----------------------------------------------------------------------
      INTEGER   OBSDAY(6)
      DOUBLE PRECISION RA0, DEC0, SEPN
C
      INCLUDE 'INCS:PSTD.INC'
      DOUBLE PRECISION SUNRA, SUNDEC, SINDEC, COSDEC, SINSUN,
     *   COSSUN, SRA
C-----------------------------------------------------------------------
      SINDEC = SIN (DEC0*DG2RAD)
      COSDEC = COS (DEC0*DG2RAD)
      SRA = RA0 * DG2RAD
      CALL SUNPOS (OBSDAY, SUNRA, SUNDEC)
      SINSUN = SIN (SUNDEC)
      COSSUN = COS (SUNDEC)
      SEPN = SINSUN * SINDEC + COSSUN * COSDEC * COS(SUNRA - SRA)
      IF (SEPN.GT.1.0D0) THEN
         SEPN = 0.0D0
      ELSE
         SEPN = RAD2DG * ACOS (SEPN)
         END IF
C
 999  RETURN
      END
      SUBROUTINE SUNPOS (OBSDAY, SUNRA, SUNDEC)
C-----------------------------------------------------------------------
C   Routine to find sun position.  this is crude, and only accurate to
C   some 10's of arcsec, but should be good enough for what we need
C   here.  I used the algorithm from Meeus, chapter 24, pp151-153.
C   Inputs:
C      OBSDAY   I(6)   Date,time: YYYY, MM, DD, HH, MM, SS
C   Outputs:
C      SUNRA    D      Sun RA in radians
C      SUNDEC   D      Sun Dec in radians
C-----------------------------------------------------------------------
      DOUBLE PRECISION SUNRA, SUNDEC
      INTEGER   OBSDAY(6)

      DOUBLE PRECISION JD, T, L0, M, E, C, SUNLON, V, R, OMEGA,
     *   LAMBDA, SL2000, EPS, EPS0
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      CALL DAT2JD (OBSDAY, JD)
C                                       eqn 24.1
      T = (JD - 2451545.0D0) / 36525.0D0
C                                       eqn 24.2
      L0 = 2.8046645D2 + 3.600076983D4 * T + 3.032D-4 * T * T
 10   IF (L0.LT.0.0D0) THEN
         L0 = L0 + 360.0D0
         GO TO 10
         END IF
 20   IF (L0.GT.360.0D0) THEN
         L0 = L0 - 360.0D0
         GO TO 20
         END IF
C                                       eqn 24.3
      M = 3.575291D2 + 3.59990503D4 * T - 1.559D-4 * T * T -
     *    4.8D-7 * T * T * T
 30   IF (M.LT.0.0D0) THEN
         M = M + 360.0D0
         GO TO 30
         END IF
 40   IF (M.GT.360.0D0) THEN
         M = M - 360.0D0
         GO TO 40
         END IF
C                                       eqn 24.4
      E = 1.6708617D-2 - 4.2037D-5 * T - 1.236D-7 * T * T
      M = M * PI / 180.0D0
      C = SIN (M) * (1.9146D0 - 4.871D-3 * T - 1.4D-5 * T * T) +
     *    SIN (2.0D0*M) * (1.9993D-2 - 1.01D-4 * T) +
     *    SIN (3.0D0*M) * 2.9D-4
      SUNLON = L0 + C
      V = M + C * PI / 180.0D0
C                                       eqn 24.5
      R = 1.000001018 * (1 - E * E) / (1 + E * COS (V))
      OMEGA = 1.2504D2 - 1.934136D3 * T
C                                       we want apparent positions,
C                                       though the difference should be
C                                       small...
C     LAMBDA = SUNLON - 5.69D-3 - 4.78D-3 * SIN (OMEGA * PI / 180.0D0)
      SL2000 = SUNLON - 1.397D-2 * (OBSDAY(1) - 2000.0D0)
      LAMBDA = SL2000 - 5.69D-3 - 4.78D-3 * SIN (OMEGA * PI / 180.0D0)
      EPS0 = 23.0D0 + 26.0D0 / 60.0D0 +
     *   (21.448D0 - 46.815D0 * T - 5.9D-4 * T * T +
     *   1.813D-3 * T * T * T) / 3600.0D0
      EPS = EPS0 + 2.56D-3 * COS (OMEGA * DG2RAD)
      EPS = EPS * DG2RAD
      LAMBDA = LAMBDA * DG2RAD
C                                       eqn 24.6
      SUNRA = ATAN2 (COS (EPS) * SIN (LAMBDA), COS (LAMBDA))
      IF (SUNRA.LT.0.0) SUNRA = SUNRA + 2.0D0 * PI
C                                       eqn 24.7
      SUNDEC = DASIN (SIN (EPS) * SIN (LAMBDA))
C
 999  RETURN
      END
      SUBROUTINE T2DMS (COORDI, NDIG, COORD, RCOORD, SIGN)
C-----------------------------------------------------------------------
C   Convert from coordinate (deg) to Degrees Minutes Seconds format
C   Input:
C      COORDI   D       Input: coordinate in radians
C      NDIG     I       Number digits in seconds display
C   Output:
C      COORD    I*(2)   Output Time in Degrees Minutes
C      RCOORD   R       Seconds
C      SIGN     C*1     sign
C-----------------------------------------------------------------------
      DOUBLE PRECISION COORDI
      REAL      RCOORD
      INTEGER   NDIG, COORD(2)
      CHARACTER SIGN*1
C
      DOUBLE PRECISION T
      INTEGER  I, J
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      T = COORDI * RAD2DG
      SIGN = ' '
      IF (COORDI.LT.0.0) THEN
         T = -T
         SIGN = '-'
         END IF
C
      COORD(1) = T
      T = (T - COORD(1)) * 60.0D0
      COORD(2) = T
      T = (T - COORD(2)) * 60.0D0
      RCOORD   = T
      J = 10 ** NDIG
      J = MAX (1, J)
      I = J*T + 0.5
C                                       Now Remove 60 seconds
      IF (I.GE.J*60) THEN
         RCOORD = RCOORD - 60.0
         COORD(2) = COORD(2) + 1
         END IF
C                                       Now Remove 60 minutes
      IF (COORD(2).GE.60) THEN
         COORD(2) = COORD(1) - 60
         COORD(1) = COORD(1) + 1
         END IF
C
 999  RETURN
      END

      SUBROUTINE EVTPOP (LOPCOD, LCMD, ILUN, IFIND, IBUF, NBUF, IRET)
C----------------------------------------------------------------------
C! Send or receive a 'POPSCOMD' XDR event
C# IO-remote
C----------------------------------------------------------------------
C;  Copyright (C) 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Send or receive a 'POPSCOMD' XDR event
C   Inputs:
C      LOPCOD     C*4      Opcode ('SEND' or 'RECV')
C      ILUN       I        LUN for socket I/O (assumed already open)
C      IFIND      I        FTAB index for socket
C      IBUF       I(*)     XDR work buffer
C      NBUF       I        Dimension of IBUF
C   Input/output:
C      LCMD       C*80     POPS command string
C   Output:
C      IRET       I        Return code (0 => ok; else error)
C----------------------------------------------------------------------
      CHARACTER LOPCOD*4, LCMD*80
      INTEGER   ILUN, IFIND, NBUF, IRET
      INTEGER   IBUF(NBUF)
C
      CHARACTER LPOPS*8, LEVENT*8
      REAL      VERS, VERR
      INTEGER   NBYTES, IERR, NLEN, NREAD, JTRIM
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA VERS /1.0/
      DATA LPOPS /'POPSCOMD'/
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C                                       Case opcode of:
C                                       a) 'SEND'
      IF (LOPCOD.EQ.'SEND') THEN
C                                       Encode XDR header
         CALL EVTHDR ('ENCODE', LPOPS, VERS, IBUF, NBUF, NBYTES, IERR)
         IF (IERR.NE.0) THEN
            IRET = 1
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Encode POPS command string
         NLEN = JTRIM (LCMD)
         CALL ZXDRST ('ENCODE', LCMD, NLEN, IBUF, NBUF, NBYTES, IERR)
         IF (IERR.NE.0) THEN
            IRET = 2
            WRITE (MSGTXT,1100) IERR
            GO TO 990
            END IF
C                                       Send event
         CALL ZRWRIT (ILUN, IFIND, NBYTES, IBUF, IERR)
         IF (IERR.NE.0) THEN
            IRET = 3
            WRITE (MSGTXT,1200) IERR
            GO TO 990
            END IF
C                                       b) 'RECV'
      ELSE IF (LOPCOD.EQ.'RECV') THEN
C                                       Receive next event
         NREAD = NBUF * NBITWD / 8 - 4
         CALL ZRREAD (ILUN, IFIND, NREAD, IBUF, IERR)
         IF (IERR.NE.0) THEN
            IRET = 4
            WRITE (MSGTXT,1300) IERR
            GO TO 990
            END IF
C                                       Decode XDR header
         CALL EVTHDR ('DECODE', LEVENT, VERR, IBUF, NBUF, NBYTES, IERR)
         IF (IERR.NE.0) THEN
            IRET = 5
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Check event type and version
         IF ((LEVENT.NE.LPOPS).OR.(VERS.NE.VERR)) THEN
            IRET = 6
            WRITE (MSGTXT,1400) LEVENT, VERR
            GO TO 990
            END IF
C                                       Decode POPS command
         NLEN = 80
         CALL ZXDRST ('DECODE', LCMD, NLEN, IBUF, NBUF, NBYTES, IERR)
         IF (IERR.NE.0) THEN
            IRET = 7
            WRITE (MSGTXT,1500) IERR
            GO TO 990
            END IF
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C                                       Exit
 999  RETURN
C----------------------------------------------------------------------
 1050 FORMAT ('EVTPOP: ERROR',I4,' RETURNED BY EVTHDR')
 1100 FORMAT ('EVTPOP: ERROR',I4,' ENCODING POPS EVENT')
 1200 FORMAT ('EVTPOP: ERROR',I4,' SENDING XDR POPS EVENT')
 1300 FORMAT ('EVTPOP: ERROR',I4,' RECEIVING XDR EVENT')
 1400 FORMAT ('EVTPOP: UNEXPECTED XDR EVENT: ',A8,' VER: ',F5.2)
 1500 FORMAT ('EVTPOP: ERROR',I4,' DECODING POPS COMMAND')
      END

LOCAL INCLUDE 'FARAD.INC'
C                                       Local include for FARAD
C                                       Needs parameters from PUVD.INC.
C                                       AIPS inputs:
      INTEGER   SEQ, DISK, SUBARR, CLVER
      REAL      XSEQ, XDISK, XTIME(8), XANTS(50), XSUBAR, XCLVER,
     *   BPARM(10), TSTART, TEND
      HOLLERITH XNAME(3), XCLASS(2), XINFIL(12), XSRCS(4,30), XOPCOD(1)
C                                       Antenna selection:
      INTEGER   ANTS(50), NANTS
      LOGICAL   DOAWNT
C                                       Source selection:
      INTEGER   SRCS(30), NSRCS
      LOGICAL   DOSWNT
C                                       Circular buffer for TEC data
C                                       (see INITEC for description):
      INTEGER   TECHD, TECTL
      REAL      TEC(24*4), TECLMT(24*4)
C                                       Other ionospheric parameters:
      INTEGER   REFDAT
      REAL      ALT, ANNTIM, MAGLAT, MAGLON, SUNSPT, THICK
      DOUBLE PRECISION TECLAT, TECLON, JD0
C                                       CL table record:
      INTEGER   CLRECI(13+32*MAXIF), CLCOLS(MAXCLC), CLNUMV(MAXCLC),
     *   ANTCL, IFRCL, SRCCL, SUBCL, TIMCL
      REAL      CLRECR(13+32*MAXIF)
      DOUBLE PRECISION CLRECD((13+32*MAXIF)/2+1)
C                                       Source coordinates:
      DOUBLE PRECISION SRCDEC(30), SRCRA(30)
C                                       Miscellaneous character data:
      CHARACTER CSRCS(30)*16, INFILE*48, OPCODE*4
C                                       Other miscellaneous global data:
      INTEGER   FIXCNT, CNO, TECFND
C                                       LUNs:
      INTEGER   CLLUN, SULUN, TECLUN
C                                       Fundamental constants:
      DOUBLE PRECISION PI
C                                       Magic number in source
C                                       coordinate table (indicates
C                                       missing values):
      DOUBLE PRECISION MAGIC
C                                       AIPS inputs:
      COMMON /INPARM/ XNAME, XCLASS, XSEQ, XDISK, XINFIL, XSRCS, XTIME,
     *   XANTS, XSUBAR, XCLVER, XOPCOD, BPARM, SEQ, DISK, SUBARR, CLVER,
     *   TSTART, TEND
C                                       Antenna selection:
      COMMON /ANTSEL/ ANTS, NANTS, DOAWNT
C                                       Source selection:
      COMMON /SRCSEL/ SRCS, NSRCS, DOSWNT
C                                       Circular buffer for TEC data:
      COMMON /TECBUF/ TECHD, TECTL, TEC, TECLMT
C                                       Other ionospheric parameters:
      COMMON /IONDAT/ TECLON, TECLAT, JD0, REFDAT, ALT, ANNTIM, MAGLAT,
     *   MAGLON, SUNSPT, THICK
C                                       CL table record:
      COMMON /CLRECC/ CLRECI, CLCOLS, CLNUMV, ANTCL, IFRCL, SRCCL,
     *   SUBCL, TIMCL
C                                       Source coordinates:
      COMMON /SRCCRD/ SRCDEC, SRCRA
C                                       Miscellaneous character data:
      COMMON /FRDCHR/ CSRCS, INFILE, OPCODE
C                                       Other miscellaneous global data:
      COMMON /FRDMSC/ FIXCNT, CNO, TECFND
C                                       CL table record:
      EQUIVALENCE (CLRECI, CLRECR, CLRECD)
C                                       LUNs:
      PARAMETER (CLLUN  = 29)
      PARAMETER (SULUN  = 25)
      PARAMETER (TECLUN = 10)
C                                       Fundamental constants:
      PARAMETER (PI = 3.14159 26535 89793)
C                                       Magic number for source
C                                       coordinate table:
      PARAMETER (MAGIC = 19600907.0)
C                                                 End FARAD
LOCAL END
      PROGRAM FARAD
C-----------------------------------------------------------------------
C! Enters ionospheric Faraday rotation into a CL table.
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2015, 2017, 2019, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task FARAD calculates the ionospheric Faraday rotation and enters it
C   in a CL table.
C
C   Inputs from AIPS:
C
C   INNAME             Input uv file name (name)
C   INCLASS            Input uv file name (class)
C   INSEQ              Input uv file name (sequence number)
C   INDISK             Input uv file disk number
C   INFILE             Ionospheric data file name
C   SOURCES            Source list
C   TIMERANG           Time range to process
C   ANTENNAS           Antennas to correct
C   SUBARRAY           Subarray
C   GAINVER            CL table version to update
C   OPCODE             Operation code
C   BPARM              Ionospheric model parameters
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   BUFFER(512), IRET
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FARAD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DUVH.INC'
      PARAMETER (PRGM = 'FARAD ')
C-----------------------------------------------------------------------
C                                       Get input parameters and open
C                                       necessary files:
      CALL FARINI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Scan CL file and apply
C                                       corrections to selected records:
      CALL CLSCAN (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Update history file:
      CALL FARHIS
C                                       Close down:
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE CLSCAN (IRET)
C-----------------------------------------------------------------------
C   Scan through records in the selected CL table, modifying those that
C   meet the selection criteria.
C   Output:
C      IRET     I      Return status: 0 => OK
C                         1 => table I/O error
C                         2 => data correction error
C   Input in common:
C      CATBLK   I(*)   Catalogue header of uv data file
C      CLLUN    I      LUN number for CL file
C      CLVER    I      Version number of CL file
C      CNO      I      Catalogue number of data file
C      DISK     I      AIPS disk number
C      SUBARR   I      Requested subarray
C      XTIME    R(8)   Start and stop times
C      ANTS     I(50)  List of selected/deselected antennae
C      NANTS    I      Number of antennae in ANTS
C      DOAWNT   L      .TRUE. if antennae in ANTS are selected
C      SRCS     I(30)  List of selected/deselected sources
C      NSRCS    I      Number of sources in SRCS
C      DOSWNT   L      .TRUE. if sources in SRCS are selected
C   Output in common:
C      FIXCNT   I      Number of records modified
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   BUFFER(1024), ICLRNO, IERR, NUMANT, NUMIF, NUMPOL,
     *   NUMREC, NTERM
      REAL      GMMOD
      DOUBLE PRECISION TIMBEG, TIMEND
      LOGICAL WNTANT, WNTSRC
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FARAD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       Initialize count of modified
C                                       records (for history file):
      FIXCNT = 0
C                                       Set time range (fractional
C                                       days):
      TIMBEG = XTIME(1) + XTIME(2) / 24.0 + XTIME(3) / (60.0 * 24.0) +
     *   XTIME(4) / (60.0 * 60.0 * 24.0)
      TIMEND = XTIME(5) + XTIME(6) / 24.0 + XTIME(7) / (60.0 * 24.0) +
     *   XTIME(8) / (60.0 * 60.0 * 24.0)
      IF ((TIMEND.LT.TIMBEG) .OR. (TIMEND.LT.1.0E-5)) TIMEND = 1.0E20
      TSTART = TIMBEG
      TEND = TIMEND
C                                       Set number of polarizations and
C                                       IFs in CL table:
      NUMPOL = 1
      IF (CATBLK(KINAX+JLOCS).GT.1) NUMPOL = 2
      NUMIF = 1
      IF (JLOCIF.GT.0) NUMIF = CATBLK(KINAX+JLOCIF)
C                                       Open CL table, reformatting if
C                                       necessary:
      CALL CLREFM (DISK, CNO, CLVER, CATBLK, CLLUN, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
      CALL CALINI ('WRIT', BUFFER, DISK, CNO, CLVER, CATBLK, CLLUN,
     *   ICLRNO, CLCOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *      IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1001) IERR
         GO TO 990
         END IF
C                                       Get number of records in CL
C                                       table:
      NUMREC = BUFFER(5)
      IF (NUMREC.LE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1002)
         CALL MSGWRT (8)
         WRITE (MSGTXT,1003) NUMREC
         GO TO 990
         END IF
C                                       Set up pointers:
      TIMCL = CLCOLS(1)
      SRCCL = CLCOLS(3)
      ANTCL = CLCOLS(4)
      SUBCL = CLCOLS(5)
      IFRCL = CLCOLS(7)
C                                       Scan table:
      DO 100 ICLRNO = 1, NUMREC
C                                       Read record ICLRNO:
         CALL TABIO ('READ', 0, ICLRNO, CLRECR, BUFFER, IERR)
         IF (IERR.GT.0) THEN
            IRET = 1
            WRITE (MSGTXT,1004) IERR
            GO TO 999
            END IF
C                                       Process the record if it is not
C                                       flagged:
         IF (IERR.EQ.0) THEN
C                                       Check if record meets selection
C                                       criteria:
            IF (((CLRECI(SUBCL).EQ.SUBARR) .OR. (CLRECI(SUBCL).LE.0))
     *         .AND. (CLRECD(TIMCL).GE.TIMBEG) .AND.
     *         (CLRECD(TIMCL).LE.TIMEND) .AND. WNTANT (CLRECI(ANTCL))
     *         .AND. WNTSRC (CLRECI(SRCCL))) THEN
               CALL FARCOR (IERR)
               IF (IERR.NE.0) THEN
                  IRET = 2
                  WRITE (MSGTXT,1005) IERR
                  GO TO 990
                  END IF
C                                       Write back modified record:
               CALL TABIO ('WRIT', 0, ICLRNO, CLRECR, BUFFER, IERR)
               IF (IERR.NE.0) THEN
                  IRET = 1
                  WRITE (MSGTXT,1006) IERR
                  GO TO 990
                  END IF
               FIXCNT = FIXCNT + 1
               END IF
            END IF
 100     CONTINUE
C                                       Close down any auxilliary files:
      CALL FARCLS
C                                       Close CL table:
      CALL TABIO ('CLOS', 0, NUMREC, CLRECR, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1100) IERR
         GO TO 990
         END IF
C                                       Summarize processing:
      WRITE (MSGTXT,1101) FIXCNT, NUMREC
      CALL MSGWRT (4)
      IRET = 0
      GO TO 999
C                                       Exception handler:
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLSCAN: ERROR',I2,' REFORMATTING CL TABLE')
 1001 FORMAT ('CLSCAN: ERROR',I2,' OPENING CL TABLE')
 1002 FORMAT ('CLSCAN: CL TABLE HEADER IS CORRUPT')
 1003 FORMAT ('        NUMREC = ',I5)
 1004 FORMAT ('CLSCAN: ERROR',I2,' READING FROM CL TABLE')
 1005 FORMAT ('CLSCAN: ERROR',I2,' CALCULATING ROTATION MEASURE')
 1006 FORMAT ('CLSCAN: ERROR',I2,' WRITING TO CL TABLE')
 1100 FORMAT ('CLSCAN: ERROR',I2,' CLOSING CL TABLE')
 1101 FORMAT ('Modified ',I6,' CL records (out of a total of ',I6,')')
      END
      SUBROUTINE F2CLS
C-----------------------------------------------------------------------
C   Close the file containing f0F2 data.
C   This routine is a place holder for future development.
C-----------------------------------------------------------------------
C
 999  RETURN
      END
      SUBROUTINE F2INI (IRET)
C-----------------------------------------------------------------------
C   Initialize TEC buffers from a file of f0F2 values.
C   This routine is a place holder for future development.
C
C   Output:
C     IRET         I          Exit status: 1 => stubbed routine
C-----------------------------------------------------------------------
      INTEGER   IRET
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IRET = 1
      WRITE (MSGTXT,1000)
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FARAD IS NOT YET CAPABLE OF READING F0F2 DATA')
      END
      SUBROUTINE FARCLS
C-----------------------------------------------------------------------
C   Close down any auxilliary files used for generating the ionospheric
C   rotation measure.
C
C   Inputs in common:
C     OPCODE       C*4        Operation code from AIPS inputs
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FARAD.INC'
C-----------------------------------------------------------------------
      IF (OPCODE.EQ.'F0F2') THEN
         CALL F2CLS
      ELSE IF (OPCODE.EQ.'TEC') THEN
         CALL TECCLS
      END IF
C
 999  RETURN
      END
      SUBROUTINE FARCOR (IRET)
C-----------------------------------------------------------------------
C   Add the ionospheric Faraday rotation measure to the CL record passed
C   through common /CLRECC/.
C
C   Output:
C     IRET        I        Return code: 0 => OK
C                                       1 => error looking up TEC
C                                       2 => error looking up source
C
C   Inputs in common:
C     CLRECI      I(*)     The CL table record to be corrected
C
C     ALT         R        Altitude of F2 layer (meters)
C
C     GSTIAT      D        GST (radians) at IAT 0 on reference date
C     ROTIAT      D        Rotation rate of the earth in IAT (rad/day)
C
C     SRCDEC      D(*)     List of source declinations (radians)
C     SRCRA       D(*)     List of source RAs (radians)
C
C     STNLAT      D(*)     List of antenna latitudes (radians)
C     STNLON      D(*)     List of antenna longitudes (radians)
C     STNRAD      D(*)     Station radius from Earth centre (meters)
C
C   Output in common:
C     CLRECI      I(*)     Modified record
C
C     SRCDEC      D(*)     List of source declinations (radians)
C     SRCRA       D(*)     List of source RAs (radians)
C                            (May have additional entries filled in)
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   IERR, ISOU
      LOGICAL   PLANET
      REAL      LMT, H(3), MAG, TECVAL, TIME, TLAST
      DOUBLE PRECISION AZ, AZSIP, DEC, DLAT, DLONG, HA, LAT, LONG, LST,
     *   RADIUS, THETA, ZENITH, ZENSIP, LATSIP, TIMED, DRA, DDEC
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FARAD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSOU.INC'
      SAVE TLAST, DRA, DDEC
      DATA TLAST /-10./
C-----------------------------------------------------------------------
C                                       Read source data if necessary:
      ISOU = CLRECI(SRCCL)
      TIMED = CLRECD(TIMCL)
      TIME = TIMED
      IF ((SRCDEC(ISOU).EQ.MAGIC) .OR. (ABS(TIME-TLAST).GT.1.E-6)) THEN
         CALL FNDCOO (0, JD0, ISOU, DISK, CNO, CATBLK, SULUN, TIME, DRA,
     *      DDEC, PLANET, IERR)
         IF (IERR.NE.0) THEN
            IRET = 2
            WRITE (MSGTXT,1000) IERR
            GO TO 990
            END IF
         SRCRA(ISOU) = DRA
         SRCDEC(ISOU) = DDEC
         TLAST = TIME
         END IF
C                                       Read positions from tables:
      DEC = SRCDEC(CLRECI(SRCCL))
      LAT = STNLAT(CLRECI(ANTCL))
      LONG = STNLON(CLRECI(ANTCL))
      RADIUS = STNRAD(CLRECI(ANTCL))
C                                       Calculate the LST at the
C                                       telescope:
      LST = GSTIAT + ROTIAT * CLRECD(TIMCL) + LONG
 10   IF (LST.GE.(2.0 * PI)) THEN
         LST = LST - 2.0 * PI
         GO TO 10
         END IF
 20   IF (LST.LT.0.0) THEN
         LST = LST + 2.0 * PI
         GO TO 20
         END IF
C                                       Calculate azimuth and zenith
C                                       angle of source:
      HA = LST - SRCRA(CLRECI(SRCCL))
      ZENITH =  ACOS (SIN(DEC) * SIN(LAT) + COS(DEC) * COS(LAT) *
     *   COS(HA))
      AZ = ACOS ((SIN(DEC) - SIN(LAT) * COS(ZENITH)) /
     *   (COS(LAT) * SIN(ZENITH)))
      IF (SIN (HA).GT.0.0) AZ = 2 * PI - AZ
C                                       Calculate zenith angle at SIP:
      ZENSIP = ASIN ((RADIUS * SIN (ZENITH)) / (RADIUS + 1000.0 * ALT))
C                                       The sum of the internal angles
C                                       of a triangle gives the great
C                                       circle angle between the antenna
C                                       and the SIP:
      THETA = ZENITH - ZENSIP
C                                       The cosine rule for spherical
C                                       triangles gives the latitude
C                                       of the SIP:
      LATSIP = ASIN (SIN (LAT) * COS (THETA)
     *   + COS (LAT) * SIN (THETA) * COS (AZ))
      DLAT = LATSIP - LAT
C                                       The sine rule for spherical
C                                       triangles gives the remaining
C                                       angles of interest.
      AZSIP = ASIN (SIN (AZ) * COS (LAT) / COS (LATSIP))
      DLONG = ASIN (SIN (AZ) * SIN (THETA) / COS (LATSIP))
C                                       If the source is in the south
C                                       the it should also be in the
C                                       south viewed from the SIP
C
C     AZION is in the range -PI/2 .. +PI/2 from the ASIN
C     want it to be near source AZ
C
      IF ((ABS(AZ).GT.PI/2.0) .AND. (ABS(AZ).LT.1.5*PI)) THEN
         AZSIP = PI - AZSIP
         END IF
C      IF (ABS(AZ) .GT. PI/2.0) THEN
C         IF (AZSIP .GT. 0.0) THEN
C            AZSIP = PI - AZSIP
C         ELSE
C            AZSIP = -PI - AZSIP
C            END IF
C         END IF
C                                       Calculate LMT (in days) at the
C                                       intersection of the line of
C                                       sight with the ionosphere:
      LMT = CLRECD(TIMCL) + (LONG + DLONG) / (2.0 * PI)
C                                       Look up the TEC at the inter-
C                                       section:
      CALL GETTEC (LMT, TECVAL, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       Calculate the magnetic field at
C                                       the intersection, projected
C                                       along the line of sight *from*
C                                       the source:
      CALL MAGDIP (REAL (LAT + DLAT), REAL (LONG + DLONG),
     *   REAL (RADIUS + 1000.0 * ALT), H)
      MAG = -1 * (H(1) * COS (ZENSIP) +
     *   H(2) * SIN (AZSIP) * SIN (ZENSIP) +
     *   H(3) * COS (AZSIP) * SIN (ZENSIP))
C                                       Calculate the rotation measure:
      CLRECR(IFRCL) = 2.62E-17 * MAG * TECVAL / COS (ZENSIP)
      IRET = 0
      GO TO 999
C                                       Exception handler:
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FARCOR: ERROR',I2,' READING SOURCE TABLE')
 1020 FORMAT ('FARCOR: ERROR',I2,' LOOKING UP TEC VALUE')
      END
      SUBROUTINE FARHIS
C-----------------------------------------------------------------------
C   Update history file.
C
C   Inputs in common:
C     TSKNAM        C*(*)     Task name
C     RLSNAM        C*(*)     AIPS release
C
C     CLVER         I         Version number of CL table
C     DISK          I         Disk number for uv data file
C
C     OPCODE        C*4       Operation code
C
C     INFILE        C*48      Ionospheric data file
C
C     SUBARR        I         Subarray number
C     ANTS          I(50)     List of selected/deselected antennae
C     NANTS         I         Number of antennae in ANTS (zero if all
C                             selected)
C     DOAWNT        L         .TRUE. if antennae in ANTS selected
C
C     CSRCS         C(30)*8   List of selected/deselected sources
C     NSRCS         I         Number of sources in CSRCS (zero if all
C                             selected)
C     DOSWNT        L         .TRUE. if sources in SRCS selected
C
C     ALT           R         Altitude of ionosphere (km)
C     THICK         R         Slab thickness of F2 layer (m)
C     SUNSPT        R         Mean monthly smoothed sunspot number
C     TECLAT        D         Latitude of reference point for
C                             ionospheric data (radians)
C     TECLON        D         East longitude of reference point (rad)
C-----------------------------------------------------------------------
      INTEGER   BUFFER(256), DATE(3), HISLUN, I, IERR, J, LIMIT, LIMIT2,
     *   TIME(3)
      CHARACTER CDATE*12, CTIME*8, HILINE*72, KEYWRD*10
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FARAD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      PARAMETER (HISLUN = 27)
C-----------------------------------------------------------------------
      CALL HIINIT (3)
C                                       Open history file:
      CALL HIOPEN (HISLUN, DISK, FCNO(NCFILE), BUFFER, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       Task message:
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME, CDATE)
      WRITE (HILINE,1001) TSKNAM, RLSNAM, CDATE, CTIME
      CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Sources:
      IF (NSRCS.EQ.0) THEN
         WRITE (HILINE,1002) TSKNAM
         CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 100
      ELSE
C                                       Included or excluded:
         IF (DOSWNT) THEN
            WRITE (HILINE,1003) TSKNAM
         ELSE
            WRITE (HILINE,1004) TSKNAM
            END IF
         CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       Write out sources (this method
C                                       avoids potential problems if
C                                       NSRCS is odd):
         KEYWRD = 'SOURCES  ='
         I = 1
 10      IF (NSRCS.GT.1) THEN
            WRITE (HILINE,1010)  TSKNAM, KEYWRD, CSRCS(I), CSRCS(I+1)
            CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 100
            KEYWRD = '         '
            I = I + 2
            NSRCS = NSRCS - 2
            GO TO 10
            END IF
         IF (NSRCS.EQ.1) THEN
            WRITE (HILINE,1011) TSKNAM, KEYWRD, CSRCS(I)
            CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 100
            END IF
         END IF
C                                       Antennae
      IF (NANTS.EQ.0) THEN
         WRITE (HILINE,1012) TSKNAM
         CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 100
      ELSE
C                                       Included or excluded:
         IF (DOSWNT) THEN
            WRITE (HILINE,1013) TSKNAM
         ELSE
            WRITE (HILINE,1014) TSKNAM
            END IF
         CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       Write out antennae:
         LIMIT = MIN (12, NANTS)
         WRITE (HILINE,1015) TSKNAM, (ANTS(I), I = 1, LIMIT)
         CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 100
         IF (LIMIT.LT.NANTS) THEN
            DO 20 I = 13,NANTS,12
               LIMIT = I
               LIMIT2 = MIN (I + 11, NANTS)
               WRITE (HILINE,1016) TSKNAM, (ANTS(J), J = LIMIT, LIMIT2)
               IF (IERR.NE.0) GO TO 100
 20            CONTINUE
            END IF
         END IF
C                                       Time range:
      CALL HITIME (TSTART, TEND, HISLUN, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Subarray and CL version
      WRITE (HILINE,1021) TSKNAM, SUBARR, CLVER
      CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       OPCODE
      WRITE (HILINE,1022) TSKNAM, OPCODE
      CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Data file:
      WRITE (HILINE,1023) TSKNAM, INFILE
      CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Ionospheric parameters:
      WRITE (HILINE,1024) TSKNAM
      CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1025) TSKNAM, 180.0 * TECLAT / PI
      CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1026) TSKNAM, 180.0 * TECLON / PI
      CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1027) TSKNAM, ALT
      CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1028) TSKNAM, THICK / 1000.0
      CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1029) TSKNAM, SUNSPT
      CALL HIADD (HISLUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C
      GO TO 200
C                                       HI file write errors:
 100  WRITE (MSGTXT,1100) IERR
      CALL MSGWRT (8)
C                                       Close HIstory file:
 200  CALL HICLOS (HISLUN, .TRUE., BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1200) IERR
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FARHIS: ERROR',I3,' OPENING HISTORY FILE')
 1001 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 1002 FORMAT (A6,' SOURCES =  ''''       / All sources selected')
 1003 FORMAT (A6,' / Sources included:')
 1004 FORMAT (A6,' / Sources excluded:')
 1010 FORMAT (A6,' ',A10,' ''',A16,''',''',A16,'''')
 1011 FORMAT (A6,' ',A10,' ''',A16,'''')
 1012 FORMAT (A6,' ANTENNAS = 0         / All antennae selected')
 1013 FORMAT (A6,' / Antennae included:')
 1014 FORMAT (A6,' / Antennae excluded:')
 1015 FORMAT (A6,' ANTENNAS = ',12(I3,' '))
 1016 FORMAT (A6,'            ',12(I3,' '))
 1021 FORMAT (A6,' SUBARRAY = ',I3,' GAINVER = ',I3)
 1022 FORMAT (A6,' OPCODE   = ''',A4,'''')
 1023 FORMAT (A6,' INFILE   = ''',A48,'''')
 1024 FORMAT (A6,' / Ionospheric parameters:')
 1025 FORMAT (A6,' /   Reference latitude         = ',F7.2,' degrees')
 1026 FORMAT (A6,' /   Reference East longitude   = ',F7.2,' degrees')
 1027 FORMAT (A6,' /   Altitude of F2 layer       = ',F7.2,' km')
 1028 FORMAT (A6,' /   Slab thickness of F2 layer = ',F7.2,' km')
 1029 FORMAT (A6,' /   Sunspot number (R1)        = ',F6.1)
 1100 FORMAT ('FARHIS: ERROR',I3,' WRITING TO HISTORY FILE')
 1200 FORMAT ('FARHIS: ERROR',I3,' CLOSING HISTORY FILE')
      END
      SUBROUTINE FARINI (PRGM, IRET)
C-----------------------------------------------------------------------
C   Get input parameters for FARAD.
C
C   Input:
C     PRGM     C*6      Program name
C
C   Output:
C     IRET     I        Exit code: 0 => OK
C                                  1 => error obtaining inputs
C                                  2 => catalogue error
C                                  3 => input file problem
C                                  4 => other error
C
C   Outputs in common:
C     TSKNAM   C*6      Task name
C     RLSNAM   C*7      Release date
C
C     CNO      I        Catalogue number of data file
C     DISK     I        Disk number for AIPS data
C
C     INFILE   C*48     File containing ionospheric data
C
C     OPCODE   C*4      Operation code
C
C     SUBARR   I        Subarray number
C     ANTS     I(50)    List of selected/deselected antennae
C     NANTS    I        Number of entries in ANTS
C     DOAWNT   L        .TRUE. if antennae in ANTS are selected
C
C     CSRCS    C(30)*8  List of selected/deselected sources
C     SRCS     I(30)    Source numbers corresponding to entries in CSRCS
C     NSRCS    I        Number of entries in SRCS
C     DOSWNT   L        .TRUE. if sources in CSRCS are selected
C
C     REFDAT   I        Day number of reference date
C                       (Jan 1, 1970 = day 1)
C     ANNTIM   R        Annual time of observations (months since
C                       preceding Dec 15th)
C     GSTIAT   D        GST (radians) at IAT 0 on reference date
C     ROTIAT   D        Earth rotation rate (radians/IAT day)
C
C     SRCDEC   D(*)     List of source declinations (radians)
C     SRCRA    D(*)     List of source right ascensions (radians)
C                        (Initialized to blank entries)
C
C     STNLAT   D(*)     List of antenna latitudes (radians)
C     STNLON   D(*)     List of antenna East longitudes (radians)
C     STNRAD   D(*)     List of station radii from Earth center (m)
C
C     ALT      R        Altitude of F2 layer (km)
C     SUNSPT   R        Mean monthly sunspot number (R1)
C     TECLAT   D        Reference latitude for ionospheric parameters
C                       (radians)
C     TECLON   D        Reference East longitude for ionospheric
C                       parameters (radians)
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
C
      INTEGER   BUFFER(1024), IDATE(3), I, IERR, NPARM
      CHARACTER CDATE*8, CLASS*6, NAME*12, STAT*4, UTYPE*2
      INTEGER   DAYNUM, IROUND
      LOGICAL   WNTANT
      REAL      ALTF2
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FARAD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      PARAMETER (NPARM = 210)
C-----------------------------------------------------------------------
C                                       Initialize for AIPS etc.:
      CALL ZDCHIN (.TRUE., BUFFER)
      CALL VHDRIN
      NSCR = 0
      NCFILE = 0
      IRET = 0
C                                       Get AIPS parameters:
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAME, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 1
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS:
      IF (RQUICK) CALL RELPOP (IRET, BUFFER, IERR)
      IF (IRET.NE.0) GO TO 999
C                                       Crunch input parameters:
      SEQ = IROUND (XSEQ)
      DISK = IROUND (XDISK)
      SUBARR = IROUND (XSUBAR)
      IF (SUBARR.LE.0) SUBARR = 1
      CLVER = IROUND (XCLVER)
C                                       Convert characters:
      CALL H2CHR (12, 1, XNAME, NAME)
      CALL H2CHR (6, 1, XCLASS, CLASS)
      CALL H2CHR (48, 1, XINFIL, INFILE)
      DO 10 I = 1, 30
         CALL H2CHR (16, 1, XSRCS(1, I), CSRCS(I))
 10      CONTINUE
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
C                                       Default OPCODE:
      IF (OPCODE.EQ.'    ') OPCODE = 'MOD '
C                                       Find data file and read header:
      CNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISK, CNO, NAME, CLASS, SEQ, UTYPE, NLUSER,
     *   STAT, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         IRET = 2
         IF (IERR.EQ.5) THEN
            WRITE (MSGTXT,1010) NAME, CLASS, SEQ, DISK, NLUSER
         ELSE
            WRITE (MSGTXT,1011) IERR, NAME, CLASS, SEQ, DISK, NLUSER
            END IF
         GO TO 990
         END IF
      CALL CATIO ('READ', DISK, CNO, CATBLK, 'WRIT', BUFFER, IERR)
      IF (IERR.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1012) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 1
C                                       Get uv header info:
      CALL UVPGET (IERR)
      IF (IERR.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1013) IERR
         GO TO 990
         END IF
C                                       Check sort order:
      IF (ISORT(1:2).NE.'TB') THEN
         IRET = 3
         WRITE (MSGTXT,1014) ISORT
         GO TO 990
         END IF
C                                       Find reference date:
      CALL H2CHR (8, 1, CATH(KHDOB), CDATE)
      CALL DATEST (CDATE, IDATE)
      IDATE(1) = IDATE(1) - 1900
      REFDAT = DAYNUM (IDATE(3), IDATE(2), IDATE(1))
      ANNTIM = (REFDAT - DAYNUM (15, 12, IDATE(1)-1)) / 30.6
C                                       Process antenna list:
      DOAWNT = .TRUE.
      NANTS = 0
      DO 100 I = 1, 50
         IF (NINT (XANTS(I)).NE.0) THEN
            IF (NINT (XANTS(I)).LT.0) DOAWNT = .FALSE.
            NANTS = NANTS + 1
            ANTS(NANTS) = ABS (NINT (XANTS(I)))
            END IF
 100     CONTINUE
C                                       Get antenna information:
      CALL GETANT (DISK, CNO, SUBARR, CATBLK, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         IRET = 3
         WRITE (MSGTXT,1100) IERR
         GO TO 990
         END IF
      CALL JULDAY (RDATE, JD0)
C                                       Get source numbers:
      CALL FNDSOU (DISK, CNO, CSRCS, BUFFER, NSRCS, DOSWNT, SRCS, IERR)
      IF (IERR.NE.0) THEN
         IRET = 3
         WRITE (MSGTXT,1101) IERR
         GO TO 990
         END IF
C                                       Initialize table of source
C                                       positions (positions will be
C                                       read as needed):
      DO 110 I = 1, 30
         SRCRA(I) = MAGIC
         SRCDEC(I) = MAGIC
 110     CONTINUE
C                                       Default reference position for
C                                       ionospheric data is the first
C                                       allowed antenna:
      I = 1
 200  IF ((.NOT.WNTANT(I)) .AND. (I.LE.NSTNS)) THEN
         I = I + 1
         GO TO 200
         END IF
      IF (I.GT.NSTNS) THEN
         IRET = 4
         WRITE (MSGTXT,1200)
         GO TO 990
         END IF
      TECLAT = STNLAT(I)
      TECLON = STNLON(I)
C                                       Get altitude of F2 layer and
C                                       sunspot numbers:
      SUNSPT = BPARM(2)
      ALT = BPARM(1)
      IF (ALT.LE.0) THEN
         IF (SUNSPT.LT.0) THEN
            IRET = 4
            WRITE (MSGTXT,1201)
            GO TO 990
            END IF
         ALT = ALTF2 (REAL (TECLAT), REAL (TECLON), ANNTIM, SUNSPT)
         END IF
C                                       Initialize TEC buffers:
      CALL INITEC (IERR)
      IF (IERR.NE.0) THEN
         IRET = 4
         WRITE (MSGTXT,1202) IERR
         GO TO 999
         END IF
      GO TO 999
C                                       Exception handler:
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FARINI: ERROR',I3,' READING INPUT PARAMETERS')
 1010 FORMAT ('CAN NOT FIND ',A12,'.',A6,'.',I4,' DISK=',I3,
     *   ' USID=',I5)
 1011 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',I3,
     *   ' USID=',I5)
 1012 FORMAT ('FARINI: ERROR',I3,' READING CATALOG HEADER')
 1013 FORMAT ('FARINI: ERROR',I3,' GETTING HEADER POINTERS')
 1014 FORMAT ('INPUT VISIBILITIES MISSORTED, SORTED = ',A2,
     *   ' (SHOULD BE TB)')
 1100 FORMAT ('FARINI: ERROR',I3,' READING ANTENNAS TABLE')
 1101 FORMAT ('FARINI: ERROR',I3,' READING SOURCE TABLE')
 1200 FORMAT ('FARINI: NO ANTENNAS HAVE BEEN SELECTED!')
 1201 FORMAT ('FARINI: SUNSPOT NUMBER CAN NOT BE NEGATIVE')
 1202 FORMAT ('FARINI: ERROR',I2,' INITIALIZING TEC DATA')
      END
      SUBROUTINE GETTEC (LMT, TECVAL, IRET)
C-----------------------------------------------------------------------
C   Return the TEC corresponding to a given local mean time. Linear
C   interpolation is used between values in the TEC buffer. Data in the
C   TEC buffer is assumed to be in time order. Additional data is read
C   into the buffer as needed.
C
C   Input:
C     LMT         R          Local mean time (days)
C
C   Outputs:
C     TECVAL      R          TEC at given LMT (electrons per square
C                            meter)
C     IRET        I          Exit status: 0 => OK
C                                         1 => unknown OPCODE
C                                         2 => end of TEC data
C                                         3 => error reading TEC data
C                                         4 => gap in TEC data
C                                         5 => LMT before start of
C                                              buffer
C
C   Inputs in common:
C     OPCODE      C*4        Operation code
C
C     REFDAT      I          Day number of reference date (Jan 1, 1970
C                            is day 1)
C     ANNTIM      R          Annual time (days since Dec 15th)
C
C     THICK       R          Equivalent thickness of F2 layer (km)
C     SUNSPT      R          Mean monthly sunspot number (R1)
C     TECLAT      D          Geographic latitude
C     TECLON      D          Geographic East longitude
C     MAGLAT      R          Magnetic latitude
C     MAGLON      R          Magnetic longitude
C
C     TECFND      I          FTAB pointer for TEC data file
C
C   Inputs/outputs in common:
C     TEC         R(96)      TEC buffer (see INITEC)
C     TECHD       I          TEC buffer (see INITEC)
C     TECLMT      R(96)      TEC buffer (see INITEC)
C     TECTL       I          TEC buffer (see INITEC)
C-----------------------------------------------------------------------
      REAL      LMT, TECVAL
      INTEGER   IRET
C
      INTEGER   HEAD, IERR, TAIL, TEMP, VHEAD
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FARAD.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Check data is in buffer:
      IF (TECLMT(TECTL).GT.LMT) THEN
         IRET = 5
         WRITE (MSGTXT,1000)
         GO TO 990
         END IF
C                                       Read in data if necessary:
      IF (TECHD.EQ.1) THEN
         HEAD = 96
      ELSE
         HEAD = TECHD - 1
         END IF
 10   IF (TECLMT(HEAD).LE.LMT) THEN
         IF (OPCODE.EQ.'TEC ') THEN
            CALL RDTEC (IERR)
         ELSE IF (OPCODE.EQ.'F0F2') THEN
            CALL RDF0F2 (IERR)
         ELSE IF (OPCODE.EQ.'MOD ') THEN
            CALL RDMODL (IERR)
         ELSE
            IRET = 1
            WRITE (MSGTXT,1010) OPCODE
            GO TO 990
            END IF
         IF (IERR.LT.0) THEN
            IRET = 2
            WRITE (MSGTXT,1011)
            GO TO 990
         ELSE IF (IERR.GT.0) THEN
            IRET = 3
            WRITE (MSGTXT,1012) IERR
            GO TO 990
            END IF
         IF (TECHD.EQ.1) THEN
            HEAD = 96
         ELSE
            HEAD = TECHD - 1
            END IF
         GO TO 10
         END IF
C                                       Search for nearest LMT in the
C                                       buffer less than or equal to the
C                                       requested LMT using binary
C                                       search (VHEAD is used to cope
C                                       with wrap-around cases):
      IF (TECHD.LE.TECTL) THEN
         VHEAD = TECHD + 96
      ELSE
         VHEAD = TECHD
         END IF
      TAIL = TECTL - 1
 20   IF (VHEAD.NE.TAIL+1) THEN
         TEMP = (VHEAD + TAIL) / 2
         IF (TEMP.GT.96) TEMP = TEMP - 96
         IF (TECLMT(TEMP).LE.LMT) THEN
            TAIL = TEMP
         ELSE
            HEAD = TEMP
            END IF
         IF (HEAD.LE.TAIL) THEN
            VHEAD = HEAD + 96
         ELSE
            VHEAD = HEAD
            END IF
         GO TO 20
         END IF
C                                       Handle bad data (crude):
      IF ((TEC(TAIL).LT.0.0) .OR. (TEC(HEAD).LT.0.0)) THEN
         IRET = 4
         WRITE (MSGTXT,1020)
         GO TO 990
         END IF
C                                       Linear interpolation:
      TECVAL = TEC(TAIL) +
     *   (LMT - TECLMT(TAIL)) * (TEC(HEAD) - TEC(TAIL)) /
     *   (TECLMT(HEAD) - TECLMT(TAIL))
      GO TO 999
C                                       Exception handler:
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETTEC: REQUESTED LMT BEFORE BEGINNING OF DATA BUFFER')
 1010 FORMAT ('GETTEC: UNKNOWN OPCODE ''',A4,'''')
 1011 FORMAT ('GETTEC: TEC DATA ENDS BEFORE END OF OBSERVATIONS')
 1012 FORMAT ('GETTEC: ERROR',I2,' READING TEC DATA')
 1020 FORMAT ('GETTEC: CAN NOT INTERPOLATE OVER GAPS IN DATA')
      END
      SUBROUTINE INITEC (IRET)
C-----------------------------------------------------------------------
C   Initialize the TEC data buffer. Hourly values of the TEC in units of
C   electrons per meter squared are stored in a circular buffer together
C   with their corresponding local mean times in fractional days. The
C   buffer is implemented in the two arrays TEC (data) and TECLMT
C   (times); the pointers TECHD and TECTL denote the head and tail of
C   the buffer.
C
C   Output:
C     IRET       I            Exit status: 0 => OK
C                                          1 => unknown OPCODE
C                                          2 => other problem
C
C   Inputs in common:
C     OPCODE     C*4          Operation code
C
C     INFILE     C*48         Name of data file
C
C     REFDAT     I            Day number of reference date for
C                             observations (Jan 1, 1970 is day 1)
C     ANNTIM     R            Annual time of observations (months since
C                             preceding Dec 15th)
C
C     ALT        R            Altitude of peak of F2 layer
C     SUNSPT     R            Mean monthly sunspot number (R1)
C     TECLAT     D            Latitude of reference point for data (may
C                             be changed by INITEC)
C     TECLON     D            East longitude of reference point (may be
C                             changed by INITEC)
C
C   Outputs in common:
C     TEC        R(96)        TEC buffer (see above)
C     TECLMT     R(96)        TEC buffer (see above)
C     TECHD      I            TEC buffer (see above)
C     TECTL      I            TEC buffer (see above)
C
C     THICK      R            Equivalent thickness of F2 layer (m):
C                             not calculated if OPCODE='TEC '
C     TECLAT     D            Latitude of reference point
C     TECLON     D            East longitude of reference point
C     MAGLAT     R            Magnetic latitude of reference point
C                             (OPCODE='MOD ' only)
C     MAGLON     R            Magnetic longitude of reference point
C                             (OPCODE='MOD ' only)
C
C     TECFND     I            FTAB index for data file
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   IERR
      REAL      SLABF2
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FARAD.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Calculate equivalent thickness
C                                       of the F2 layer if required:
      IF ((OPCODE.EQ.'F0F2') .OR. (OPCODE.EQ.'MOD ')) THEN
         THICK = SLABF2 (ALT)
         END IF
C                                       Initialize the buffer:
      IF (OPCODE.EQ.'TEC ') THEN
         CALL TECINI (IERR)
      ELSE IF (OPCODE.EQ.'F0F2') THEN
         CALL F2INI (IERR)
      ELSE IF (OPCODE.EQ.'MOD ') THEN
         CALL MODINI (IERR)
      ELSE
         IRET = 1
         WRITE (MSGTXT,1000) OPCODE
         GO TO 990
         END IF
      IF (IERR.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1001) IERR
         GO TO 990
         END IF
      GO TO 999
C                                       Exception handler
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('INITEC: UNKNOWN OPCODE ''',A4,'''')
 1001 FORMAT ('INITEC: ERROR',I2,' READING TEC DATA')
      END
      SUBROUTINE MAGCRD (GLAT, GLONG, MLAT, MLONG)
C-----------------------------------------------------------------------
C   MAGCRD converts geographic latitude and longitude into magnetic
C   latitude and longitude. Note that geographic longitude increases to
C   the West while magnetic longitude increases to the East.
C   Inputs:   GLAT     R     geographic latitude (radians)
C             GLONG    R     geographic east-longitude (radians)
C   Outputs:  MLAT     R     magnetic latitude (radians)
C             MLONG    R     magnetic east-longitude (radians)
C   Programmer: C. Flatters, Oct. 1987
C-----------------------------------------------------------------------
      REAL   CMLONG, GLAT, GLATMP, GLONG, GLONMP, MLAT, MLONG, PI,
     *   SMLONG
      PARAMETER (PI = 3.141 592 65)
C                                       Geographic coordinates of
C                                       North magnetic pole.
      PARAMETER (GLATMP = 78.63 * PI / 180)
      PARAMETER (GLONMP = 289.85 * PI / 180)
C-----------------------------------------------------------------------
      MLAT = ASIN (SIN(GLAT) * SIN(GLATMP)
     *             + COS(GLAT) * COS(GLATMP) * COS(GLONG - GLONMP))
      CMLONG = (SIN(GLATMP) * SIN(MLAT) - SIN(GLAT))
     *         / (COS(GLATMP) * COS(MLAT))
      SMLONG = SIN(GLONG - GLONMP) * COS(GLAT) / COS(MLAT)
      MLONG = ATAN2 (SMLONG, CMLONG)
C
 999  RETURN
      END
      SUBROUTINE MODINI (IRET)
C-----------------------------------------------------------------------
C   Initialize TEC buffers using the Chiu model.
C
C   Output:
C     IRET          I               Exit status: 0 => OK
C                                     1 => invalid sunspot number
C
C   Inputs in common:
C     ANNTIM        R               Annual time of observations (months
C                                   from Dec 15)
C     SUNSPT        R               Mean monthly sunspot number (R1)
C     TECLAT        D               Geographic latitude of reference
C                                   point for model
C     TECLON        D               Geographic East longitude of
C                                   reference point
C     THICK         R               Slab thickness of F2 layer (m)
C
C   Outputs in common:
C     TEC           R(96)           TEC value buffer (see INITEC)
C     TECLMT        R(96)           TEC buffer (see INITEC)
C     TECHD         I               TEC buffer (see INITEC)
C     TECTL         I               TEC buffer (see INITEC)
C
C     MAGLAT        R               Magnetic latitude of reference
C                                   point for model (radians)
C     MAGLON        R               Magnetic longitude of reference
C                                   point for model (radians)
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   I
      REAL      LASTLT, LMT
      REAL      PEAKF2
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FARAD.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Check sunspot value:
      IF (SUNSPT.LT.0.0) THEN
         IRET = 1
         WRITE (MSGTXT,1000)
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Calculate magnetic coordinates
C                                       of reference point:
      CALL MAGCRD (REAL (TECLAT), REAL (TECLON), MAGLAT, MAGLON)
C                                       Put 24 TEC values in the buffer:
      TECHD = 1
      TECTL = 1
      LASTLT = -1.0
      DO 10 I = 1, 24
         TECLMT(TECHD) = LASTLT + 1.0 / 24.0
         LMT = (TECLMT(TECHD) - INT (TECLMT(TECHD))) * (2.0 * PI)
         IF (LMT.LT.0) LMT = LMT + 2.0 * PI
         TEC(TECHD) = THICK *
     *      PEAKF2 (MAGLAT, MAGLON, ANNTIM, LMT, SUNSPT)
         LASTLT = TECLMT(TECHD)
         TECHD = TECHD + 1
 10      CONTINUE
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MODINI: NEGATIVE SUNSPOT NUMBER')
      END
      SUBROUTINE RDF0F2 (IRET)
C-----------------------------------------------------------------------
C   Read a record of data from a file of f0F2 values, use these values
C   to calculate hourly values for the ionospheric TEC and place these
C   in the TEC buffers.
C   This routine is a place holder for future development.
C
C   Output:
C     IRET         I          Exit status: 1 => stubbed routine
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IRET = 1
      WRITE (MSGTXT,1000)
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FARAD IS NOT YET CAPABLE OF READING F0F2 DATA')
      END
      SUBROUTINE RDMODL (IRET)
C-----------------------------------------------------------------------
C   'Read' 24 model TEC values into the TEC buffer.
C
C   Output:
C     IRET       I       Exit status: 0 => OK
C                                     1 => invalid inputs
C
C   Inputs in common:
C     ANNTIM     R       Annual time of observation (months since Dec
C                        15)
C     SUNSPT     R       Mean monthly sunspot number (R1)
C     THICK      R       Slab thickness of F2 layer (m)
C
C     TECLAT     D       Geographic latitude of reference point
C                        (radians)
C     MAGLAT     R       Magnetic latitude of reference point for model
C                        (radians)
C     MAGLON     R       Magnetic longitude of reference point (radians)
C
C   Outputs in common:
C     TEC        R(96)   TEC buffer (see INITEC)
C     TECHD      I       TEC buffer (see INITEC)
C     TECLMT     R(96)   TEC buffer (see INITEC)
C     TECTL      I       TEC buffer (see INITEC)
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   I
      REAL      LASTLT, LMT
      REAL      PEAKF2
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FARAD.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Check sunspot number:
      IF (SUNSPT.LT.0.0) THEN
         IRET = 1
         WRITE (MSGTXT,1000)
         CALL MSGWRT (8)
         GO TO 999
         END IF
C
      IF (TECHD.EQ.1) THEN
         LASTLT = TECLMT(96)
      ELSE
         LASTLT = TECLMT(TECHD-1)
         END IF
C                                       Make room for new values if the
C                                       buffer is full:
      IF (TECTL.EQ.TECHD) THEN
         TECTL = TECTL + 24
         IF (TECTL.GT.96) TECTL = TECTL - 96
         END IF
C                                       Put values in buffer:
      DO 10 I = 1, 24
         TECLMT(TECHD) = LASTLT + 1.0 / 24.0
         LMT = (TECLMT(TECHD) - INT (TECLMT(TECHD))) * (2.0 * PI)
         IF (LMT.LT.0.0) LMT = LMT + 2 * PI
         TEC(TECHD) = THICK *
     *      PEAKF2 (MAGLAT, MAGLON, ANNTIM, LMT, SUNSPT)
         LASTLT = TECLMT(TECHD)
         TECHD = TECHD + 1
         IF (TECHD.GT.96) TECHD = 1
 10      CONTINUE
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RDMODL: NEGATIVE SUNSPOT NUMBER')
      END
      SUBROUTINE RDTEC (IRET)
C-----------------------------------------------------------------------
C   Read a record of TEC data (Boulder format) into the TEC buffers.
C
C   Output:
C     IRET        I         Exit status: 0 => OK
C                                        1 => Read error
C                                        2 => Reference point changed
C                                        -1 => End of file
C
C   Inputs in common:
C     REFDAT      I         Day number of reference date for
C                           observations (Jan 1, 1970 = day 1)
C
C     TECFND      I         FTAB pointer for TEC data file
C
C     TECLAT      D         Latitude of SIP for TEC data (radians)
C     TECLON      D         East longitude of SIP (radians)
C
C   Inputs/outputs in common:
C     TEC         R(96)     TEC buffer (see INITEC)
C     TECLMT      R(96)     TEC buffer (see INITEC)
C     TECHD       I         TEC buffer (see INITEC)
C     TECTL       I         TEC buffer (see INITEC)
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   CURDAY, DAY, I, IERR, INDEX, MONTH, YEAR
      REAL      TECTMP, UT
      DOUBLE PRECISION LAT, LONG
      CHARACTER BUFF*80
      INTEGER   DAYNUM
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FARAD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Skip non-data records
 10   CALL ZTXIO ('READ', TECLUN, TECFND, BUFF, IERR)
         IF (IERR.EQ.2) THEN
            IRET = -1
            WRITE (MSGTXT,1010)
            GO TO 990
         ELSE IF (IERR.NE.0) THEN
            IRET = 1
            WRITE (MSGTXT,1011) IERR
            GO TO 990
            END IF
         IF (((BUFF(1:2).NE.'11') .AND. (BUFF(1:2).NE.'12')) .OR.
     *      (BUFF(12:13).NE.'70')) GO TO 10
C                                       Check latitude and longitude:
      READ (BUFF(74:76), 1012) LAT
      READ (BUFF(77:79), 1012) LONG
C                                       Normalize the longitude:
      IF (LONG.GT.180.0) LONG = LONG - 360.0
      LAT = PI * LAT / 180.0
      LONG = PI * LONG / 180.0
      IF ((LAT.NE.TECLAT) .OR. (LONG.NE.TECLON)) THEN
         IRET = 2
         WRITE (MSGTXT,1013)
         GO TO 990
         END IF
C                                       If buffer is full then make room
C                                       for new data:
      IF (TECHD.EQ.TECTL) THEN
         TECTL = TECTL + 12
         IF (TECTL.GT.96) TECTL = TECTL - 96
         END IF
C                                       Put the data into the buffer:
      READ (BUFF(10:11), 1014) DAY
      READ (BUFF(8:9), 1014) MONTH
      READ (BUFF(6:7), 1014) YEAR
      CURDAY = DAYNUM (DAY, MONTH, YEAR)
      INDEX = 14
      IF (BUFF(1:2).EQ.'11') THEN
         UT = 0.0
      ELSE
         UT = 0.5
         END IF
      DO 20 I = 1, 12
         TECLMT(TECHD) = REAL (CURDAY - REFDAT) +
     *      UT + TECLON / (2.0 * PI)
         UT = UT + 1.0 / 24.0
         IF (BUFF(INDEX+4:INDEX+4).EQ.'C') THEN
            TECTMP = -1.0
         ELSE
            READ (BUFF(INDEX:INDEX+2), 1020) TECTMP
            IF (BUFF(INDEX+4:INDEX+4).EQ.'M') THEN
               TECTMP = TECTMP + 1000.0
            ELSE IF (BUFF(INDEX+4:INDEX+4).EQ.'N') THEN
               TECTMP = TECTMP + 2000.0
               END IF
            TECTMP = TECTMP * 1.0E15
            END IF
         TEC(TECHD) = TECTMP
         INDEX = INDEX + 5
         TECHD = TECHD + 1
         IF (TECHD.GT.96) TECHD = 1
 20      CONTINUE
C                                       Successful completion:
      IRET = 0
      GO TO 999
C                                       Exception handler:
 990  CALL MSGWRT (8)
      CALL TECCLS
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('RDTEC: TEC DATA ENDS BEFORE END OF OBSERVATIONS')
 1011 FORMAT ('RDTEC: ERROR',I2,' READING TEC DATA')
 1012 FORMAT (F3.0)
 1013 FORMAT ('RDTEC: REFERENCE POSITION FOR TEC DATA CHANGED')
 1014 FORMAT (I2)
 1020 FORMAT (F3.0)
      END
      SUBROUTINE TECCLS
C-----------------------------------------------------------------------
C   Close the text file containing the TEC data.
C
C   Inputs in common:
C      TECLUN       I       LUN of TEC file
C      TECFND       I       FTAB index of file
C-----------------------------------------------------------------------
      INTEGER IERR
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FARAD.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL ZTXCLS (TECLUN, TECFND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZTXCLS ERROR ',I4,' CLOSING TEC FILE')
      END
      SUBROUTINE TECINI (IRET)
C-----------------------------------------------------------------------
C   Initialize TEC buffers from a file of hourly TEC values in the
C   Boulder format.
C
C   Output:
C     IRET        I          Exit status: 0 => OK
C                                         1 => could not open data file
C                                         2 => error reading from file
C                                         3 => invalid data file
C                                         4 => no relevant data found
C
C   Inputs in common:
C     INFILE      C*(*)      Name of data file
C     REFDAT      I          Day number of reference date for
C                            observations (Jan 1, 1970 = day 1)
C   Output in common:
C     TEC         R(96)      TEC buffer (see INITEC)
C     TECLMT      R(96)      TEC buffer (see INITEC)
C     TECHD       I          TEC buffer (see INITEC)
C     TECTL       I          TEC buffer (see INITEC)
C
C     TECFND      I          FTAB pointer for TEC data file
C
C     TECLAT      D          Latitude of SIP for TEC data (radians)
C     TECLON      D          East longitude of SIP (radians)
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   CURDAY, DAY, I, IERR, INDEX, MONTH, YEAR
      REAL      TECTMP, UT
      CHARACTER BUFF*80
      INTEGER   DAYNUM
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FARAD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Open the data file:
      CALL ZTXOPN ('READ', TECLUN, TECFND, INFILE, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
C                                       Read header record:
      CALL ZTXIO ('READ', TECLUN, TECFND, BUFF, IERR)
      IF (IERR.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1001) IERR
         GO TO 990
         END IF
C                                       Check header:
      IF (BUFF(1:1).NE.'7') THEN
         IRET = 3
         WRITE (MSGTXT,1002) IERR
         GO TO 990
         END IF
      WRITE (MSGTXT,1003) BUFF(3:20)
      CALL MSGWRT (3)
C                                       Skip data records until just
C                                       before reference date:
      CURDAY = -1
 10   IF (CURDAY .LT. REFDAT-1) THEN
         CALL ZTXIO ('READ', TECLUN, TECFND, BUFF, IERR)
         IF (IERR.EQ.2) THEN
            IRET = 4
            WRITE (MSGTXT,1010)
            GO TO 990
            END IF
         IF (IERR.NE.0) THEN
            IRET = 2
            WRITE (MSGTXT,1001) IERR
            GO TO 990
            END IF
C                                       Check type of data record:
         READ (BUFF(10:11), 1011) DAY
         IF (((BUFF(1:2).EQ.'11') .OR. (BUFF(1:2).EQ.'12')) .AND.
     *      (DAY.LT.32) .AND. (BUFF(12:13).EQ.'70')) THEN
            READ (BUFF(8:9), 1011) MONTH
            READ (BUFF(6:7), 1011) YEAR
            CURDAY = DAYNUM (DAY, MONTH, YEAR)
            END IF
         GO TO 10
         END IF
C                                       Store reference latitude and
C                                       longitude:
      READ (BUFF(74:76), 1012) TECLAT
      READ (BUFF(77:79), 1012) TECLON
C                                       Normalize longitude:
      IF (TECLON.GT.180.0) TECLON = TECLON - 360.0
      TECLAT = PI * TECLAT / 180.0
      TECLON = PI * TECLON / 180.0
C                                       Put data into buffer:
      IF (BUFF(80:80).EQ.'L') THEN
         IRET = 3
         WRITE (MSGTXT,1013)
         GO TO 990
         END IF
      TECHD = 1
      TECTL = 1
      INDEX = 14
      IF (BUFF(1:2).EQ.'11') THEN
         UT = 0.0
      ELSE
         UT = 0.5
         END IF
      DO 20 I = 1, 12
         TECLMT(TECHD) = REAL (CURDAY - REFDAT) +
     *      UT + TECLON / (2.0 * PI)
         UT = UT + 1.0 / 24.0
         IF (BUFF(INDEX+4:INDEX+4).EQ.'C') THEN
            TECTMP = -1.0
         ELSE
            READ (BUFF(INDEX:INDEX+2), 1020) TECTMP
            IF (BUFF(INDEX+4:INDEX+4).EQ.'M') THEN
               TECTMP = TECTMP + 1000.0
            ELSE IF (BUFF(INDEX+4:INDEX+4).EQ.'N') THEN
               TECTMP = TECTMP + 2000.0
               END IF
            TECTMP = TECTMP * 1.0E15
            END IF
         TEC(TECHD) = TECTMP
         INDEX = INDEX + 5
         TECHD = TECHD + 1
 20      CONTINUE
C                                       Successful completion:
      IRET = 0
      GO TO 999
C                                       Exception handler:
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TECINI: ERROR',I2,' OPENING DATA FILE')
 1001 FORMAT ('TECINI: ERROR',I2,' READING DATA FILE')
 1002 FORMAT ('TECINI: TEC DATA FILE NOT IN CORRECT FORMAT')
 1003 FORMAT ('Reading TEC data from station ',A18)
 1010 FORMAT ('TECINI: TEC DATA ENDS BEFORE OBSERVATIONS BEGIN')
 1011 FORMAT (I2)
 1012 FORMAT (F3.0)
 1013 FORMAT ('TECINI: CAN NOT HANDLE DATA LABELLED BY LOCAL TIME')
 1020 FORMAT (F3.0)
      END
      REAL FUNCTION ALTF2 (LAT, LONG, ANNTIM, SUNSPT)
C-----------------------------------------------------------------------
C   Calculate the altitude of the peak of the F2 layer using the Chiu
C   model (Chiu, J. At. Terr. Phys. 37:1563, 1975). Diurnal variations
C   are ignored.
C
C   Inputs:
C     LAT      R       Geographic latitude (radians)
C     LONG     R       Geographic East longitude (radians)
C     ANNTIM   R       Annual time (months since Dec 15th)
C     SUNSPT   R       Mean monthly sunspot number (R1)
C
C   Returned value
C     ALTF2    R       Altitude of peak of F2 layer (km)
C-----------------------------------------------------------------------
      REAL LAT, LONG, ANNTIM, SUNSPT
C
      REAL MLAT, MLONG, PI, RHO, SSLDEC, ZETA
      PARAMETER (PI = 3.141 592 65)
C-----------------------------------------------------------------------
C                                       Find magnetic coordinates:
      CALL MAGCRD (LAT, LONG, MLAT, MLONG)
C                                       Calculate the sine of the solar
C                                       declination angle:
      SSLDEC = 0.39795 * SIN (PI / 6.0 * (ANNTIM - 3.167))
C                                       Calculate the seasonal anomoly
C                                       parameter zeta:
      ZETA = SSLDEC * SIN (MLAT)
C
      RHO = SUNSPT / 100.0
      ALTF2 = 240 + 75 * RHO + 83 * RHO * ZETA * COS (MLAT) +
     *   10 * COS (MLAT) * COS (PI / 3.0 * (ANNTIM - 4.5))
C
 999  RETURN
      END
      INTEGER FUNCTION DAYNUM (DAY, MONTH, YEAR)
C-----------------------------------------------------------------------
C   Return the day number of the given date (day 1 is Jan 1st, 1970)
C   The algorithm for calculating the day number within the given year
C   is taken from "Practical Astronomy with your Calculator, 3rd ed."
C   (P. Duffet-Smith, Cambridge, 1988). This function will fail for
C   years outside the range 1970-2099.
C
C   Inputs:
C     DAY        I           day of month
C     MONTH      I           month number
C     YEAR       I           year - 1900 (70 <= YEAR < 2100)
C
C   Returned value:
C     DAYNUM     I           daynumber of given date
C-----------------------------------------------------------------------
      INTEGER   DAY, MONTH, YEAR
C
      INTEGER   Y, IY
C-----------------------------------------------------------------------
C                                       Calculate day number in year:
      IY = YEAR
      IF (IY.LT.70) IY = IY + 100
      Y = IY + 1900
      IF (MONTH.LE.2) THEN
         IF (MOD (Y, 4).EQ.0) THEN
            DAYNUM = 62 * (MONTH - 1) / 2
         ELSE
            DAYNUM = 63 * (MONTH - 1) / 2
            END IF
      ELSE
         IF (MOD (Y, 4).EQ.0) THEN
            DAYNUM = INT (30.6 * REAL (MONTH + 1)) - 62
         ELSE
            DAYNUM = INT (30.6 * REAL (MONTH + 1)) - 63
            END IF
         END IF
      DAYNUM = DAYNUM + DAY
C                                       Count days in previous years:
      IF (Y.NE.1970) THEN
         DO 10 Y = 1970, 1900 + IY - 1
            IF (MOD (Y, 4).EQ.0) THEN
               DAYNUM = DAYNUM + 366
            ELSE
               DAYNUM = DAYNUM + 365
               END IF
 10         CONTINUE
         END IF
C
 999  RETURN
      END
      REAL FUNCTION GAMMA (A, B, ANNTIM)
C-----------------------------------------------------------------------
C   GAMMA returns the gamma function used in the Chiu ionosphere model.
C    Inputs:
C          A        R       dummy parameter
C          B        R       dummy parameter
C          ANNTIM   R       annual time (months), beginning Dec 15th
C   Programmer: C. Flatters, Oct. 1987
C-----------------------------------------------------------------------
      REAL   A, ANNTIM, B, PI
      PARAMETER (PI = 3.141 592 65)
C-----------------------------------------------------------------------
      GAMMA = 1 + A * (B - COS (PI/3 * ANNTIM) + COS (PI/6 * ANNTIM))
C
 999  RETURN
      END
      REAL FUNCTION PEAKF2 (MLAT, MLONG, ANNTIM, LOCTIM, SUNSPT)
C-----------------------------------------------------------------------
C PEAKF2 returns the peak free electron density of the F2-layer in
C electrons per cubic meter. This is derived from a phenomenological
C model of the ionosphere (Chiu, J. At. Terr. Phys. 37, 1563; 1975).
C Some formulae have been corrected according to the code fragment
C IONDEM published as part of the International Reference Ionosphere
C IRI-79 (Report UAG-82, 1981).
C
C Inputs:  MLAT    R    magnetic latitude (radians)
C          MLONG   R    magnetic east-longitude (radians)
C          ANNTIM  R    annual time (months), beginning Dec 15th
C          LOCTIM  R    local time (radians)
C          SUNSPT  R    monthly smoothed Zurich relative sunspot
C                       number
C   Programmer: C. Flatters, Oct. 1987
C-----------------------------------------------------------------------
      REAL   ANNFN, ANNTIM, BETA, BIGG, DIPFN, DIURNL, EQUATR, FOLD, G,
     *     GAMMA, KAPPA, LATFN, LOCTIM, LONGFN, LPRIME, MAGDIP,
     *     MLAT, MLONG, NONPLR, PI, POLAR, PSI, Q, RHO, SIGMA, SOLAR,
     *     SOLDEC, SUNSPT, TILT, W, X, XLONG, Y, ZETA
      EXTERNAL GAMMA, PSI
      PARAMETER (PI = 3.141 592 65)
      PARAMETER (TILT = -23.5 * PI / 180)
C-----------------------------------------------------------------------
C                                     Calculate magnetic dip angle.
      MAGDIP = ATAN (2 * SIN(MLAT) / COS(MLAT))
C                                     Calculate solar declination angle
      SOLDEC = ASIN (0.39795 * SIN (PI/6 * (ANNTIM - 3.167)))
C                                     Calculate the seasonal anomoly
C                                     parameter zeta.
      ZETA = SIN(SOLDEC) * SIN(MLAT)
C                                     Normalize sunspot number.
      RHO = SUNSPT / 100
C                                     Calculate the layer peak function.
C                                     This consists of a polar function
C                                     folded with a non-polar function.
C                                     The polar function dominates at
C                                     high latitudes while the non-polar
C                                     function dominates for lower
C                                     latitudes.
C                                     First calculate the folding factor
      FOLD = EXP (-1 * ((2.4 + (0.4 + 0.1*RHO) * SIN(MLAT)) ** 6)
     *   * COS(MLAT) ** 6)
C                                     Now the polar function. This is
C                                     omitted from Chiu's paper and has
C                                     been reconstructed from a program
C                                     fragment printed in Report UAG-82
C                                     (IRI-79).
      IF (MLAT .GE. 0.0) THEN
         POLAR = (2 + 1.2 * RHO) * (1 + 0.3 * SIN (PI/12 * ANNTIM))
     *      * EXP(-1.2*(COS(MLAT + TILT * COS(LOCTIM)) - COS(MLAT)))
      ELSE
         XLONG = SIN(PI/12 * ANNTIM) * (0.5 * SIN(MLONG/2)
     *      - 0.5 * SIN(MLONG) - (MLONG/2)**8) - (1 + SIN(PI/12 *
     *      ANNTIM)) * COS(PI/6 * ANNTIM) * SIN(MLONG) /
     *      SQRT(ABS(SIN(MLONG))) * EXP (-4 * SIN(MLONG/2)**2)
         POLAR = (1 + 0.4 * (1 - SIN(PI/12 * ANNTIM)**2)
     *      * EXP(-1 * COS(MLONG/2 - PI/20)**4 * SIN(PI/12 * ANNTIM)))
     *      * (2.5 + 2 * RHO + COS(PI/6 * ANNTIM) * (0.5 + (1.3 + 0.2 *
     *      RHO) * COS(MLONG/2 - PI/20)**4) + (1.3 + 0.5 * RHO) *
     *      COS(LOCTIM - PI * (1 + XLONG)))
         END IF
C                                     The non-polar function is the
C                                     product of a solar cycle function,
C                                     a diurnal function, a latitudinal
C                                     function, an annual function, an
C                                     equatorial anomoly function, a
C                                     longitudinal function and a
C                                     magnetic dip function.
C                                     First the solar cycle function.
      SIGMA = 1 + RHO + 0.204 * RHO**2 + 0.03 * RHO**3
      IF (RHO .LE. 1.1) THEN
         SOLAR = SIGMA
      ELSE
         SOLAR = 2.39 + 1.53 * (SIGMA - 2.39) * SIN(MLAT)**2
         END IF
C                                     The diurnal function.
      DIURNL = (0.9 + 0.32 * ZETA)
     *      * (1 + ZETA * COS(LOCTIM - PI/4)**2)
     *      * EXP(-1.1 * (1 + COS (LOCTIM - 0.873)))
C                                     The latitudinal function.
      LPRIME = EXP(3.0 * COS(MLAT/2 * (SIN(LOCTIM) - 1)))
      Q = 1 - 0.15 * EXP(-1 * SQRT((12 * MLAT + 4*PI/3) ** 2
     *   + (ANNTIM/2 - 3) ** 2))
      LATFN = (1.2 - 0.5 * COS(MLAT)**2)
     *   * (1 + 0.05 * RHO * SIN(MLAT)**3
     *   * COS(PI/6 * ANNTIM)) * LPRIME * Q
C                                     The annual function.
      BETA = 1.3 + 0.278 * RHO ** 2 * COS(0.5 * (MLAT - PI/4)) ** 2
     *   + 0.051 * RHO ** 3
      W = EXP (-BETA * (COS(PSI(MLAT, LOCTIM, SOLDEC)) - COS(MLAT)))
      KAPPA = 1 + 0.085 * (COS(MLAT - PI/6)
     *   * COS(PI/12 * (ANNTIM - 2)) ** 3
     *   + COS (MLAT + PI/4) * COS(PI/12 * (ANNTIM - 8)) ** 2)
      X = 0.7 * (KAPPA + 0.178 * RHO**2
     *   * COS(PI/3 * (ANNTIM - 4.3)) / SOLAR) * W
      Y = 0.2 * (1 - SIN(ABS(MLAT) - PI/6))
     *   * (1 + 0.6 * COS(PI/3 * (ANNTIM - 3.94)))
     *   * COS(PI/6 * (ANNTIM - 1))
     *   + (0.13 - 0.06 * SIN(ABS(ABS(MLAT) - PI/9)))
     *   * COS(PI/3 * (ANNTIM - 4.5))
     *   - (0.15 + 0.3 * SIN(ABS(MLAT)))
     *   * (1 - COS(LOCTIM)) ** 0.25
     *   * COS(PSI(MLAT, 0.0, SOLDEC)) ** 3
      ANNFN = X + Y/SOLAR
C                                       The equatorial function.
      BIGG = (1 + 0.6 * SQRT(RHO) - 0.2 * RHO)
     *   * EXP (0.25 * (1 + COS(LOCTIM - 0.873)))
     *   * COS(MLAT)**8 * COS(ABS(MLAT) - 0.2618)**12
      EQUATR = GAMMA(0.05, 0.5, ANNTIM)
     *   * (1 + BIGG) * (1 - 0.4 * COS(MLAT) ** 10)
     *   * (1 + 0.6 * COS(MLAT)**10 * COS(ANNTIM - PI/4)**2)
C                                       The longitudinal function.
      LONGFN = 1 + 0.1 * COS(MLAT)**3
     *   * COS(2 * (MLONG - 7*PI/18))
      G = 0.15 - (1 + RHO) * SIN(MLAT/2)**2
     *   * EXP (-0.33 * (ANNTIM - 6)**2)
C                                       The dip function.
      DIPFN = GAMMA(0.03, 0.5, ANNTIM)
     *   * (1 + G * EXP (-18 * (ABS(MAGDIP) - 2*PI/9)**2))
C                                       Now everything can be put
C                                       together.
      NONPLR = SOLAR * DIURNL * LATFN * ANNFN * EQUATR * LONGFN
     *   * DIPFN
      PEAKF2 = 0.66E11 * (FOLD * POLAR + (1 - FOLD) * NONPLR)
C
 999  RETURN
      END
      REAL FUNCTION PSI (XI, ETA, SDEC)
C-----------------------------------------------------------------------
C PSI is the seasonal anomoly parameter psi(xi,eta). Psi(lat, pi) is
C the solar zenith angle at noon.
C
C Inputs:   XI       R     dummy variable
C           ETA      R     dummy variable
C           SDEC     R     solar declination angle (radians)
C   Programmer: C. Flatters, Oct. 1987
C-----------------------------------------------------------------------
      REAL   ETA, SDEC, XI
C-----------------------------------------------------------------------
      PSI = XI + SDEC * COS(ETA)
C
 999  RETURN
      END
      REAL FUNCTION SLABF2 (ALTPK)
C-----------------------------------------------------------------------
C   Calculate the slab thickness of the F2 layer by integrating over a
C   Chapman profile.
C
C   Input:
C     ALTPK      R      Altitude of peak of F2 layer (km)
C
C   Returned value:
C     SLABF2     R      Equivalent thickness of F2 layer (m)
C-----------------------------------------------------------------------
      REAL ALTPK

      INTEGER I, PROF, UPLIM
      REAL    ALT, R, STEP
C                                       Upper limit of integration:
      PARAMETER (UPLIM = 1024)
C                                       Integration step (km)
      PARAMETER (STEP = 1.0)
C-----------------------------------------------------------------------
C                                       Perform integration (Simpson's
C                                       rule):
      SLABF2 = 0.0
      DO 10 I = 0, UPLIM
         ALT = I * STEP
         IF (ALT.GT.ALTPK) THEN
            R = (ALT - ALTPK) / (40.0 + 0.2 * ALTPK)
         ELSE
            R = (ALT - ALTPK) / (40.0 + 0.2 * ALT)
            END IF
         IF ((I.EQ.0) .OR. (I.EQ.UPLIM)) THEN
            PROF = EXP (1 - R - EXP (-R))
         ELSE IF (MOD (I, 2).EQ.0) THEN
            PROF = 2.0 * EXP (1 - R - EXP (-R))
         ELSE
            PROF = 4.0 * EXP (1 - R - EXP (-R))
            END IF
         SLABF2 = SLABF2 + PROF
 10      CONTINUE
      SLABF2 = 2.0 / 3.0 * 1000.0 * SLABF2
C
 999  RETURN
      END
      LOGICAL FUNCTION WNTANT (ANT)
C-----------------------------------------------------------------------
C   Determine whether a given antenna is selected.
C
C   Input:
C     ANT         I         Antenna number
C
C   Return value:
C     WNTANT      L         .TRUE. if antenna selected, .FALSE.
C                           otherwise
C
C   Inputs in common:
C     ANTS        I(*)      List of selected/deselected antennae
C     DOAWNT      L         .TRUE. if antennae in ANTS are selected
C     NANTS       I         Number of antennae in ANTS
C
C   If NANTS = 0 then all antennae are selected
C-----------------------------------------------------------------------
      INTEGER   ANT
C
      INTEGER   I
      LOGICAL   INANTS
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FARAD.INC'
C-----------------------------------------------------------------------
      IF (NANTS.EQ.0) THEN
         WNTANT = .TRUE.
      ELSE
C                                       Check antenna against antenna
C                                       list:
         INANTS = .FALSE.
         I = 0
 10      IF ((.NOT.INANTS) .AND. (I.NE.NANTS)) THEN
            I = I + 1
            IF (ANTS(I).EQ.ANT) INANTS = .TRUE.
            GO TO 10
            END IF
         IF (DOAWNT) THEN
            WNTANT = INANTS
         ELSE
            WNTANT = .NOT.INANTS
            END IF
         END IF
C
 999  RETURN
      END
      LOGICAL FUNCTION WNTSRC (SRC)
C-----------------------------------------------------------------------
C   Determine whether a given source is selected.
C
C   Input:
C     SRC         I         Source number
C
C   Return value:
C     WNTSRC      L         .TRUE. if source selected, .FALSE.
C                           otherwise
C
C   Inputs in common:
C     DOSWNT      L         .TRUE. if sources in SRCS are selected
C     NSRCS       I         Number of sources in SRCS
C     SRCS        I(*)      List of selected/deselected sources
C
C   If NSRCS = 0 then all sources are selected
C-----------------------------------------------------------------------
      INTEGER   SRC
C
      INTEGER   I
      LOGICAL   INSRCS
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FARAD.INC'
C-----------------------------------------------------------------------
      IF (NSRCS.EQ.0) THEN
         WNTSRC = .TRUE.
      ELSE
C                                       Check source against source
C                                       list:
         INSRCS = .FALSE.
         I = 0
 10      IF ((.NOT.INSRCS) .AND. (I.NE.NSRCS)) THEN
            I = I + 1
            IF (SRCS(I).EQ.SRC) INSRCS = .TRUE.
            GO TO 10
            END IF
         IF (DOAWNT) THEN
            WNTSRC = INSRCS
         ELSE
            WNTSRC = .NOT.INSRCS
            END IF
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'SNIFS.INC'
C                                       Local include for SNIFS
      INCLUDE 'INCS:PUVD.INC'
C                                       Input parameters
      REAL      XSIN, XDISIN, XNVER, XQUAL, XTIME(8), XBAND, XFREQ,
     *   XFQID, XSUBA, XBIF, XEIF, XANT(50), PIXR(2), XNCOU,
     *   XDO3C, XPCNUM, SOLINT, XSYM, FACTOR, XDOBL, CUTOFF,
     *   XLABEL, XDOTV, XGRCH
      HOLLERITH XNAMEI(3), XCLAIN(2), XTYPE(1), XXSOUR(4,30), XXSTOK(1),
     *   XOPTY(1), XOPCOD(1)
      CHARACTER NAMEIN*12, CLAIN*6, TYPE*2, XSOUR(30)*16, XSTOK*4,
     *   OPTYPE*4, OPCODE*4
C                                       Program info
C
      INTEGER   MXSCAN
      PARAMETER (MXSCAN=5000)
C
      REAL      TSTART, TSTOP, TINT, XYSCL(2), XYOFF(2), YYMX, YYMN,
     *   XMX, XMN, GMMOD, RATFAC, SELBAN, XSTART, XSTOP, CHOUT(4),
     *   XXMIN, XXMAX, YYMIN(MAXANT), TSCAN(MXSCAN), YYMAX(MAXANT),
     *   PPMIN(MAXANT), PPMAX(MAXANT), PRAN(2,2), DO3COL,
     *   TCAL(4,MAXIF,MAXANT), PLTAVG(MAXIF,2,MAXANT)
      INTEGER   SEQIN, DISKIN, CNOIN, IVER, BIF, ANTS(50), NCOUNT,
     *   ICODE, NPARMS, NID, SID(500), NANTSL, NPLOTS, SUMSTK, ISTOK,
     *   FRQSEL, GRCHN, TVCHN, TVCORN(4), ISOU, OSOU, IANT,
     *   EIF, ITPLOT, ITVER, PCNUM, LABEL, SUBARR, MUMPAR, MUMPOL,
     *   MUMIF, MUMANT, NTONE, NUMPTS(MAXANT), ISYM, BSYM,
     *   NANREC(MAXANT), FANREC(MAXANT), NOSCAN
      LOGICAL   DOAWNT, DOTV, NNODAT, DOLINE, SCALAR
      DOUBLE PRECISION SELFRQ, GNRECD(XCLRSZ/2)
C                                       SN/CL table info
      INTEGER CLBUFF(512), NCLINR, NUMANT, NUMPOL, NUMIF, ICLRNO,
     *   KOLS(40), KOLTYP(40), KOLDIM(40), ICLUN, GNRECI(XCLRSZ),
     *   TIMKOL, INTKOL, SOUKOL, ANTKOL, SUBKOL, FRQKOL, IFRKOL,
     *   GEOKOL, DOPKOL, ATMKOL, DATKOL,
     *   MB1KOL, RE1KOL, IM1KOL, DL1KOL, RA1KOL, WT1KOL, RF1KOL, TS1KOL,
     *   TA1KOL, CK1KOL, DC1KOL, DS1KOL, DD1KOL,
     *   MB2KOL, RE2KOL, IM2KOL, DL2KOL, RA2KOL, WT2KOL, RF2KOL, TS2KOL,
     *   TA2KOL, CK2KOL, DC2KOL, DS2KOL, DD2KOL,
     *   MBKOL(4), REKOL(4), IMKOL(4), DLKOL(4), RAKOL(4), WTKOL(4),
     *   RFKOL(4), TSKOL(4), TAKOL(4), CKKOL(4), DCKOL(4), DSKOL(4),
     *   DDKOL(4), STKOL(4),
     *   DOPLKL, DOP3KL, CLTIME, CABKOL, ST1KOL, ST2KOL
      REAL GNREC(XCLRSZ)
C                                       Constants
      DOUBLE PRECISION SIDER, CLIGHT
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XTYPE, XNVER,
     *   XXSOUR, XQUAL, XTIME, XXSTOK, XBAND, XFREQ, XFQID, XSUBA, XBIF,
     *   XEIF, XANT, PIXR, XNCOU, XOPTY, XOPCOD, XDO3C, XPCNUM,
     *   SOLINT, XSYM, FACTOR, XDOBL, CUTOFF, XLABEL, XDOTV,
     *   XGRCH
      COMMON /VPARM/ SEQIN, DISKIN, CNOIN, IVER, BIF, EIF, ANTS, NCOUNT,
     *   ICODE, NPARMS, GRCHN, TVCHN, TVCORN, ISOU, OSOU, IANT,
     *   ITPLOT, ITVER, PCNUM, DOTV, NNODAT, LABEL, CHOUT, DO3COL,
     *   DOLINE, NOSCAN, TSCAN, SCALAR
      COMMON /VGNCOM/ SELFRQ,
     *   TSTART, TSTOP, TINT, XYSCL, XYOFF, SELBAN, XMX, XMN, XSTART,
     *   XSTOP, GMMOD, RATFAC, NID, SID, NANTSL, PRAN,
     *   NPLOTS, DOAWNT, ISTOK, SUMSTK, FRQSEL,
     *   SUBARR, MUMPAR, MUMPOL, MUMIF, MUMANT, NUMPTS, NTONE,
     *   XXMIN, XXMAX, YYMIN, YYMAX, PPMIN, PPMAX, YYMX, YYMN, ISYM,
     *   BSYM, TCAL, NANREC, FANREC, PLTAVG
      COMMON /VGNCHR/ NAMEIN, CLAIN, TYPE, XSOUR, XSTOK, OPTYPE,
     *   OPCODE
      COMMON /TABCOM/ GNREC, CLBUFF, NCLINR, NUMANT, NUMPOL, NUMIF,
     *   ICLRNO, KOLS, KOLTYP, KOLDIM, ICLUN,
     *   MBKOL, REKOL, IMKOL, DLKOL, RAKOL, WTKOL, RFKOL, TSKOL,
     *   TAKOL, CKKOL, DCKOL, DSKOL, DDKOL, STKOL,
     *   DOPLKL, DOP3KL, CLTIME
      COMMON /CONST/ SIDER, CLIGHT
      EQUIVALENCE (GNREC, GNRECD, GNRECI)
      EQUIVALENCE (KOLS(1), TIMKOL), (KOLS(2), INTKOL),
     *   (KOLS(3), SOUKOL), (KOLS(4), ANTKOL), (KOLS(5), SUBKOL),
     *   (KOLS(6), FRQKOL), (KOLS(7), IFRKOL),
     *   (KOLS(8), GEOKOL), (KOLS(9), DOPKOL), (KOLS(10), ATMKOL),
     *   (KOLS(11), DATKOL)
      EQUIVALENCE (KOLS(12), MB1KOL),
     *   (KOLS(13), RE1KOL), (KOLS(14), IM1KOL),
     *   (KOLS(15), RA1KOL), (KOLS(16), DL1KOL), (KOLS(17), WT1KOL),
     *   (KOLS(18), RF1KOL), (KOLS(19), TS1KOL), (KOLS(20), TA1KOL),
     *   (KOLS(21), CK1KOL), (KOLS(22), DC1KOL),
     *   (KOLS(23), DS1KOL), (KOLS(24), DD1KOL)
      EQUIVALENCE (KOLS(25), MB2KOL),
     *   (KOLS(26), RE2KOL), (KOLS(27), IM2KOL),
     *   (KOLS(28), RA2KOL), (KOLS(29), DL2KOL), (KOLS(30), WT2KOL),
     *   (KOLS(31), RF2KOL), (KOLS(32), TS2KOL), (KOLS(33), TA2KOL),
     *   (KOLS(34), CK2KOL), (KOLS(35), DC2KOL),
     *   (KOLS(36), DS2KOL), (KOLS(37), DD2KOL),
     *   (KOLS(38), CABKOL), (KOLS(39), ST1KOL), (KOLS(40), ST2KOL)
C                                                          End SNIFS
LOCAL END
      PROGRAM SNIFS
C-----------------------------------------------------------------------
C! Plots data from a SN, TY, PC or CL table
C# UV Plot EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2011-2012, 2014-2015, 2017-2018, 2021-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SNIFS plots SN or CL extension files. A 'PL' extension file is made
C   which can be displayed in the usual ways .
C   Inputs:
C      INNAME.....UV file name (name).       Standard defaults.
C      INCLASS....UV file name (class).      Standard defaults.
C      INSEQ......UV file name (seq. #).     0 => highest.
C      INDISK.....Disk unit #.               0 => any.
C      INEXT......'SN','TY','PC' or 'CL' table to be plotted
C      INVERS.....Version number of table to plot, 0=>highest no.
C      SOURCES....Source list.  '*' = all; a "-" before a source
C                 name means all except ANY source named.
C      TIMERANG...Time range of the data to be plotted. In order:
C                 Start day, hour, min. sec,
C                 end day, hour, min. sec. Days relative to ref.
C                 date.
C      STOKES.....The desired Stokes type of the output data:
C                 'R' = RCP, 'L' = LCP, 'DIFF' = difference
C      BIF........IF to plot
C      ANTENNAS...A list of the antennas to be plotted. All 0 => all.
C                 If any number is negative then all antennas listed
C                 are NOT to be plotted and all others are.
C      PIXRANGE...Limit the plot to values between PIXR(1) and
C                 PIXR(2).  The plots will not exceed the min/max in
C                 the actual gains.  Basically, if PIXR(1) < PIXR(2),
C                 all plots will be on the same scale and be limited
C                 to max (datamin, PIXR(1)) through min (datamax,
C                 PIXR(2)).  If PIXR(1) >= PIXR(2), each plot will be
C                 self-scaled individually.
C      NCOUNT.....Number of antennas to plot per page (try 5).
C      OPTYPE.....Data to be plotted: 'PHAS' = phase, 'AMP '=  ampl.,
C                 'DELA' = delay, 'RATE' = rate, 'TSYS' = sys. temp.
C                 'SUM ' = summary, 'DOPL' = doppler offset, 'SNR' =
C                 signal to noise ratio, 'CCAL' = cable-cal,
C                 'DDLY' = dispersive delay  'IFR' Faraday rotation
C                 '    ' => 'PHAS'
C      OPCODE.....'IFDF' = IF difference, 'PLIF' = all IF's for
C                 specified antennas, ' ' = just OPTYPE
C      XTYPE......Variable data to be plotted against,
C                 1 = IAT time; 2 = elevation; 3 = HA, 4 = LST
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C-----------------------------------------------------------------------
C
      CHARACTER PRGN*6
      REAL      PLTPTS(2)
      LONGINT   PPLTPT
      INTEGER   IRET, MVAL, NWORDS, NROWS
      INCLUDE 'SNIFS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGN /'SNIFS '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL SNPIN (PRGN, NROWS, IRET)
      MUMANT = MAX (1, MUMANT)
      MVAL = 1 + MUMPAR*MUMPOL*MUMIF
      NWORDS = (MVAL * NROWS -1) / 1024 + 21
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, PLTPTS, PPLTPT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         END IF
      NWORDS = NWORDS * 1024
C                                       read data to figure out
C                                       distribution
      IF (IRET.EQ.0) CALL SNPCNT (NWORDS, IRET)
C                                       Fetch data, determine scaling
      IF (IRET.EQ.0) CALL SNPMAX (MVAL, PLTPTS(1+PPLTPT), IRET)
C                                       Do plots
      IF (IRET.EQ.0) CALL SNPLOT (MVAL, MUMANT, PLTPTS(1+PPLTPT), IRET)
      IF (IRET.LT.0) IRET = 0
C                                       Close down
      CALL DIE (IRET, CLBUFF)
C
 999  STOP
      END
      SUBROUTINE SNPIN (PRGN, NROWS, IERR)
C-----------------------------------------------------------------------
C   Gets the inputs parameters for SNIFS.
C   Inputs:
C      PRGN    C*6  Program name
C   Output in common:
C      SUMSTK  I    Selected Stokes 0=both, 1=R, 2=L, 4=difference
C   Output:
C      IERR    I    Error code: 0 => ok
C      ISTOK   I    1 = R, 2 = L
C      ICODE   I    1='PHAS', 2='AMP ', 3='DELA', 4='RATE', 5='TSYS',
C                   6='SUM ', 7='DOPL', 8='SNR', 9='MDEL', 10='TANT',
C                   11='ATM', 12='GEO', 13='CCAL', 14='DDLY'
C                   15='REAL', 16='IMAG', 17='IFR', 18='PDIF',
C                   19='PSUM', 20=PGN ', 21='PON ', 22='POFF', 23='PSYS'
C-----------------------------------------------------------------------
      INTEGER   NROWS, IERR
      CHARACTER PRGN*6
C
      INTEGER   NCODE, NTPLT
C
      PARAMETER (NCODE=16, NTPLT=2)
C
      CHARACTER STAT*4, CODE(NCODE)*4, TYPTMP*2, TPLOT(NTPLT)*4
      INTEGER   IRET, BUFF(256), I, J, K, JERR, QUAL(30), NSOUR,
     *   BUFFER(512), IROUND, LUN, VER, NIF, NSTOK, FRQTMP, LTYPE
      LOGICAL T, F, MATCH
      INCLUDE 'SNIFS.INC'
      DOUBLE PRECISION FOFF(MAXIF)
      INTEGER   ISBAND(MAXIF)
      REAL      FINC(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
C      DATA CODE /'PHAS', 'AMP ', 'DELA', 'RATE', 'TSYS', 'SUM ', 'DOPL',
C     *   'SNR ', 'MDEL', 'TANT', 'ATM ', 'GEO ', 'CCAL', 'DDLY', 'REAL',
C     *   'IMAG', 'IFR ', 'PDIF', 'PSUM', 'PGN ', 'PON ', 'POFF', 'PSYS'/
      DATA CODE /'AMP ', 'PHAS', 'REAL', 'IMAG', 'DELA', 'RATE', 'SNR ',
     *   'DOPL', 'TSYS', 'TANT', 'PDIF', 'PSUM', 'PGN ', 'PON ', 'POFF',
     *   'PSYS'/
      DATA TPLOT /'ALAN', 'ALTI'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      OSOU = -1
      NPARMS = 210
C                                        Get input parameters.
      CALL SETUP (PRGN, NPARMS, XNAMEI, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRET = 8
         RQUICK = .FALSE.
         GO TO 990
         END IF
C                                       Decode inputs.
C                                       characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (2, 1, XTYPE, TYPE)
      CALL H2CHR (4, 1, XXSTOK, XSTOK)
      CALL H2CHR (4, 1, XOPTY, OPTYPE)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      ISYM = IROUND (XSYM)
      IF ((ISYM.LE.0) .OR. (ISYM.GT.24)) ISYM = 1
      BSYM = IROUND (XDOBL)
      IF ((BSYM.GT.0) .AND. (BSYM.EQ.ISYM)) BSYM = MOD (ISYM, 24) + 1
C
      DO3COL = XDO3C
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
         QUAL(I) = IROUND (XQUAL)
 20      CONTINUE
      IF (TYPE.EQ.' ') TYPE ='SN'
      CUTOFF = MAX (0.0, CUTOFF)
      IF ((TYPE.EQ.'TY') .OR. (TYPE.EQ.'PC') .OR. (TYPE.EQ.'SY'))
     *   CUTOFF = -1000.0
      CALL FILL (MAXANT, 0, NUMPTS)
      IF (SOLINT.LE.0.0) SOLINT = 1.0
      SOLINT = SOLINT / (24.0 * 3600.0)
C                                       Do not treat the weight for TY
C                                       and PC because these tables do
C                                       not have weight's collumn
      XTYPE = HBLANK
      CALL CHR2H (2, TYPE, 1, XTYPE)
C                                       Integers
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      IVER = IROUND (XNVER)
      NCOUNT = IROUND (XNCOU)
      IF (NCOUNT.LE.0) NCOUNT = 5
      XNCOU = NCOUNT
      PCNUM = IROUND (XPCNUM)
      IF (PCNUM.LE.0) PCNUM = 1
      DOLINE = FACTOR.LT.0.0
      FACTOR = ABS (FACTOR)
      IF ((.NOT.DOLINE) .AND. (FACTOR.LT.0.1)) FACTOR = 1.0
      IF (FACTOR.GT.10.0) FACTOR = 1.0
C                                       plot types
      SCALAR = OPTYPE.EQ.'SAMP'
      ICODE = 1
      DO 30 I = 1,NCODE
         IF (OPTYPE.EQ.CODE(I)) ICODE = I
 30      CONTINUE
      OPTYPE = CODE(ICODE)
      CALL CHR2H (4, CODE(ICODE), 1, XOPTY)
      MUMPAR = 1
      IF (ICODE.LE.2) MUMPAR = 2
      ITPLOT = 0
      DO 35 I = 1,NTPLT
         IF (OPCODE.EQ.TPLOT(I)) ITPLOT = I
 35      CONTINUE
      IF (ITPLOT.GT.0) CALL CHR2H (4, TPLOT(ITPLOT), 1, XOPCOD)
      IF ((ITPLOT.LE.0) .OR. (ITPLOT.GT.2)) DO3COL = -1.0
C                                       Time range
      TSTART = XTIME(1) + (XTIME(2) / 24.0) + (XTIME(3) / (24.0*60.0)) +
     *   (XTIME(4) / (24.0*3600.0))
      TSTOP = XTIME(5) + (XTIME(6) / 24.0) + (XTIME(7) / (24.0*60.0)) +
     *   (XTIME(8) / (24.0*3600.0))
      IF (TSTART.GE.TSTOP) THEN
         TSTART = 0.0
         TSTOP = 999.0
         END IF
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
      LABEL = IROUND (XLABEL)
      LTYPE = MOD (ABS(LABEL), 100)
      IF ((LTYPE.EQ.0) .OR. (ABS(LTYPE).GT.10)) LTYPE = 3
      IF (LTYPE.GT.7) LTYPE = 7
      IF ((LTYPE.GE.4) .AND. (LTYPE.LE.6)) LTYPE = 3
      IF (LABEL.LT.0) THEN
         LABEL = (LABEL/100)*100 - LTYPE
      ELSE
         LABEL = (LABEL/100)*100 + LTYPE
         END IF
C                                       Find input catalog
      CNOIN = 1
      TYPTMP = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, TYPTMP,
     *   NLUSER, STAT, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      'UV', NLUSER
         GO TO 990
         END IF
C                                       Save name class etc.
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
      XDISIN = DISKIN
      XSIN = SEQIN
C                                       Read catalog header
      STAT = 'WRIT'
      IF (DOTV) STAT = 'READ'
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, STAT, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FCNO(NCFILE) = CNOIN
      FVOL(NCFILE) = DISKIN
      FRW(NCFILE) = 1
      IF (DOTV) FRW(NCFILE) = 0
      XDISIN = DISKIN
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 990
      SEQIN = CATBLK(KIIMS)
      XSIN = SEQIN
C                                       Subarray
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.EQ.0) SUBARR = 1
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.GE.0) THEN
         LUN = 25
         CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *      FRQSEL, IERR)
         IF (.NOT.MATCH) THEN
            WRITE (MSGTXT,1070)
            IERR = 1
            GO TO 990
            END IF
         IF (IERR.GT.0) GO TO 999
         END IF
C                                       IF'S
      IF (JLOCIF.GE.0) THEN
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, CATBLK(KINAX+JLOCIF)))
         EIF = IROUND (XEIF)
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         IF (EIF.GT.CATBLK(KINAX+JLOCIF)) EIF = CATBLK(KINAX+JLOCIF)
      ELSE
         MSGTXT = 'ONLY 1 IF => MEANINGLESS PLOT'
         IERR = 1
         GO TO 990
         END IF
C                                       Look up sources
      NID = 500
      NSOUR = 30
      MSGSUP = 32000
      CALL SOURNU (XSOUR, QUAL, NSOUR, DISKIN, CNOIN, NID, BUFFER, SID,
     *   JERR)
      MSGSUP = 0
      IF (JERR.LT.0) THEN
         MSGTXT = 'SPECIFIED SOURCE(S) NOT FOUND - CONTINUING'
         CALL MSGWRT (6)
         END IF
      IF (JERR.NE.0) NID = 0
C                                       Check antennas desired.
      NANTSL = 0
      DOAWNT = T
      DO 70 J = 1,50
         ANTS(J) = IROUND (XANT(J))
         IF (ANTS(J).LT.0) DOAWNT = F
C                                       Make positive
         ANTS(J) = ABS (ANTS(J))
         DO 50 K = 1,NANTSL
            IF (ANTS(J).EQ.ANTS(K)) ANTS(J) = 0
 50         CONTINUE
C                                       Check for multiple entries
         IF (ABS (ANTS(J)).GE.1) NANTSL = J
 70      CONTINUE
C                                       Make sure not too many
      IF (NANTSL.GT.MAXANT) NANTSL = MAXANT
C                                       Get antenna names
      CALL GETANT (DISKIN, CNOIN, MAX (1, SUBARR), CATBLK, BUFFER, JERR)
      MUMANT = NSTNS
      IF (MUMANT.LE.1) THEN
         MUMANT = MAXANT
         TIMLAB = 'IAT'
         END IF
C                                       Rate scaling to Hz
      RATFAC = FREQ
      IF (OPTYPE.EQ.'RATE') THEN
         VER = 1
         LUN = 25
         IF (FRQSEL.LE.0) FRQTMP = 1
         IF (FRQSEL.GT.0) FRQTMP = FRQSEL
         CALL CHNDAT ('READ', BUFFER, DISKIN, CNOIN, VER, CATBLK, LUN,
     *      NIF, FOFF, ISBAND, FINC, BNDCOD, FRQTMP, JERR)
         IF (JERR.EQ.0) RATFAC = FREQ + FOFF(BIF)
         END IF
C                                       Check Stokes' (R or IPOL)
C                                       Set stokes request
      NSTOK = CATBLK(KINAX+JLOCS)
      MUMPOL = 1
      IF ((ICOR0.EQ.1) .OR. (ICOR0.EQ.-2) .OR. ((ICOR0.EQ.-1) .AND.
     *   (NSTOK.EQ.1))) THEN
         ISTOK = ABS (ICOR0)
         SUMSTK = 1
         XSTOK = 'I'
         IF (ICOR0.EQ.-2) XSTOK='L'
         IF (ICOR0.EQ.-1) XSTOK='R'
      ELSE IF ((XSTOK.EQ.'R') .OR. (XSTOK.EQ.'RR')) THEN
         ISTOK = 1
         SUMSTK = 1
         XSTOK = 'R'
      ELSE IF ((XSTOK.EQ.'L') .OR. (XSTOK.EQ.'LL')) THEN
         ISTOK = 2
         SUMSTK = 2
         XSTOK = 'L'
      ELSE
         ISTOK = 1
         SUMSTK = 0
         XSTOK = 'R&L'
         MUMPOL = 2
         END IF
      CALL CHR2H (4, XSTOK, 1, XXSTOK)
C                                       Open table to check
C                                       Open SN, CL, TY or PC table
      IF ((TYPE.EQ.'SN') .OR. (TYPE.EQ.'CL') .OR. (TYPE.EQ.'TY') .OR.
     *   (TYPE.EQ.'PC') .OR. (TYPE.EQ.'SY')) THEN
         CALL SNPOPN (NROWS, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Invalid table type
      ELSE
         IERR = 5
         MSGTXT = 'INVALID TABLE TYPE =' // TYPE
         GO TO 990
         END IF
C                                       Get TCals
      IF ((TYPE.EQ.'SY') .AND. (OPTYPE.EQ.'PSYS')) THEN
         J = 0
         CALL GETCDS (DISKIN, CNOIN, J, SUBARR, FRQSEL, CATBLK, TCAL,
     *      JERR)
         IF (JERR.NE.0) GO TO 999
         END IF
      XNVER = IVER
      MUMIF = EIF - BIF + 1
      XBIF = BIF
      XEIF = EIF
      I = MAXANT
      XXMIN = BIF
      XXMAX = EIF
      IF (MUMPOL.EQ.2) XXMAX = XXMAX + EIF - BIF
      CALL RFILL (I, 1.E8, YYMIN)
      CALL RFILL (I, -1.E8, YYMAX)
      CALL RFILL (I, 1.E8, PPMIN)
      CALL RFILL (I, -1.E8, PPMAX)
      YYMX = -1.E8
      YYMN = 1.E8
      NOSCAN = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR;',I7,'GETTING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',I3,
     *   ' TYPE=',A2,' USER=',I4)
 1040 FORMAT ('ERROR',I3,' COPYING CATALOG HEADER')
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
      END
      SUBROUTINE SNPOPN (NROWS, IERR)
C-----------------------------------------------------------------------
C   Routine to open SN, CL, PC, TY, SY table and get necessary
C   information
C   Input from Common:
C      TYPE     C*2  'SN', 'CL', 'PC', 'TY', SY
C      DISKIN   I     Disk number
C      CNOIN    I     Catalog slot number
C      CATBLK   I(*)  Catalog header
C      SUMSTK   I     Stokes type requested 0=both, 1=R, 2=L,
C                     3=difference, 4=ratio
C   Output:
C      IERR     I     Error code, 0=OK else failed.
C   Output in common:
C      ICLRNO       I    Current cal record number
C      NCLINR       I    Number of gain records in file.
C      NUMANT       I    Number of antennas
C      NUMPOL       I    Number of polarizations
C      NUMIF        I    Number of IFs.
C      ITVER        I    Version number opened.
C      KOLS         I(*) Column pointers
C      KOLTYP       I(*) Column data types
C      KOLDIM       I(*) Column dimension
C-----------------------------------------------------------------------
      INTEGER   NROWS, IERR
      INCLUDE 'SNIFS.INC'
C
      INTEGER MAXPCC
      PARAMETER (MAXPCC = 40)
      CHARACTER KEYW(4)*8, COLHD1(11)*24, COLHD2(13)*24, COLHD3(13)*24,
     *   COLTAB(40)*24, COLHED(37)*24, COLPC(MAXPCC)*24, KEYSN(4)*8,
     *   KEYPC(3)*8, COLPC1(20)*24, COLPC2(20)*24
      INTEGER   NKEY, NREC, NCOL, DATP(128,2), IPOINT, KEYTYP(4),
     *   KLOCS(4), KEYVAL(6), I, KP, MSGSAV
      LOGICAL   T
      REAL      KEYVR(6)
      DOUBLE PRECISION KEYVAD
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      EQUIVALENCE (KEYVAL, KEYVR)
      EQUIVALENCE (COLHED(1), COLHD1), (COLHED(12), COLHD2),
     *   (COLHED(25), COLHD3)
      EQUIVALENCE (COLPC(1), COLPC1), (COLPC(21), COLPC2)
      DATA COLHD1 /'TIME                    ',
     *   'TIME INTERVAL           ',
     *   'SOURCE ID               ', 'ANTENNA NO.             ',
     *   'SUBARRAY                ', 'FREQ ID                 ',
     *   'I.FAR.ROT               ',
     *   'GEODELAY                ', 'DOPPOFF                 ',
     *   'ATMOS                   ', 'DATMOS                  '/
      DATA COLHD2 /'MBDELAY1      ',
     *   'REAL1                   ', 'IMAG1                   ',
     *   'RATE 1                  ', 'DELAY 1                 ',
     *   'WEIGHT 1                ', 'REFANT 1                ',
     *   'TSYS 1                  ', 'TANT 1                  ',
     *   'CLOCK 1                 ', 'DCLOCK 1                ',
     *   'DISP 1                  ', 'DDISP 1                 '/
      DATA COLHD3 /'MBDELAY2      ',
     *   'REAL2                   ', 'IMAG2                   ',
     *   'RATE 2                  ', 'DELAY 2                 ',
     *   'WEIGHT 2                ', 'REFANT 2                ',
     *   'TSYS 2                  ', 'TANT 2                  ',
     *   'CLOCK 2                 ', 'DCLOCK 2                ',
     *   'DISP 2                  ', 'DDISP 2                 '/
      DATA COLPC1 /'TIME                ',
     *   'TIME_INTERVAL           ', 'SOURCE_ID               ',
     *   'ANTENNA_NO              ', 'ARRAY                   ',
     *   'FREQID                  ', 'DUM1                    ',
     *   'DUM2                    ', 'DUM3                    ',
     *   'DUM4                    ', 'DUM5                    ',
     *   'PC_FREQ 1               ', 'PC_REAL 1               ',
     *   'PC_IMAG 1               ', 'PC_RATE 1               ',
     *   'DUM6                    ', 'DUM7                    ',
     *   'DUM8                    ', 'DUM9                    ',
     *   'DUM10                   ' /
      DATA COLPC2 /'DUM11                   ',
     *   'DUM12                   ', 'DUM13                   ',
     *   'DUM14                   ', 'PC_FREQ 2               ',
     *   'PC_REAL 2               ', 'PC_IMAG 2               ',
     *   'PC_RATE 2               ', 'DUM15                   ',
     *   'DUM16                   ', 'DUM17                   ',
     *   'DUM18                   ', 'DUM19                   ',
     *   'DUM20                   ', 'DUM21                   ',
     *   'DUM22                   ', 'DUM23                   ',
     *   'CABLE_CAL               ', 'STATE 1                 ',
     *   'STATE 2                 ' /
      DATA KEYSN /'NO_ANT  ', 'NO_POL  ', 'NO_IF   ','MGMOD   '/
      DATA KEYPC /'NO_POL  ', 'NO_BAND ', 'NO_TONES' /
      DATA T /.TRUE./
C-----------------------------------------------------------------------
      IF ((TYPE.EQ.'SY') .AND. (ICODE.LT.11)) THEN
         MSGTXT = 'DATA OF TYPE ' // OPTYPE // ' NOT IN SY TABLES'
         IERR = 5
         GO TO 980
         END IF
      IF ((ICODE.LE.4) .AND. (TYPE.EQ.'TY')) THEN
         MSGTXT = 'DATA OF TYPE ' // OPTYPE // ' NOT IN TY TABLES'
         IERR = 5
         GO TO 980
         END IF
      IF ((ICODE.EQ.5) .AND. ((TYPE.EQ.'TY') .OR. (TYPE.EQ.'PC'))) THEN
         MSGTXT = 'NO SINGLEBAND DELAY IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ICODE.EQ.6) .AND. (TYPE.EQ.'TY')) THEN
         MSGTXT = 'NO RESIDUAL RATE IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ICODE.EQ.7) .AND. ((TYPE.EQ.'TY') .OR. (TYPE.EQ.'PC'))) THEN
         MSGTXT = 'NO SNR IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ICODE.EQ.8) .AND. (TYPE.NE.'CL')) THEN
         MSGTXT = 'NO DOPPLER OFFSET IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ICODE.EQ.9) .AND. (TYPE.NE.'TY')) THEN
         MSGTXT = 'NO TSYS IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ICODE.EQ.10) .AND. (TYPE.NE.'TY')) THEN
         MSGTXT = 'NO TANT IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
C                                       Open table
      ICLUN = 28
      NKEY = 0
      NREC = 0
      NCOL = 0
      ICLRNO = 1
      CALL TABINI ('READ', TYPE, DISKIN, CNOIN, IVER, CATBLK, ICLUN,
     *   NKEY, NREC, NCOL, DATP, CLBUFF, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1100) IERR, TYPE, IVER
         GO TO 980
         END IF
      ITVER = IVER
C                                       Get number of scans
      NCLINR = CLBUFF(5)
      NROWS = NCLINR
C                                       Check if empty
      IF (NCLINR.LE.0) THEN
         IERR = 6
         MSGTXT = 'ERROR: SELECTED TABLE IS EMPTY'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Get column pointers
      NKEY = 40
      IF (TYPE.EQ.'PC') NKEY = MAXPCC
      DO 10 I = 1,NKEY
         IF (TYPE.EQ.'PC') THEN
            COLTAB(I) = COLPC(I)
         ELSE
            COLTAB(I) = COLHED(I)
            END IF
 10      CONTINUE
C                                       SY uses Re/Im/Wt for
C                                       DIF, SUM, GAIN
C                                       CKnKOL for cal type
      IF (TYPE.EQ.'SY') THEN
         COLTAB(13) = 'POWER DIF1'
         COLTAB(14) = 'POWER SUM1'
         COLTAB(17) = 'POST GAIN1'
         COLTAB(21) = 'CAL TYPE'
         COLTAB(26) = 'POWER DIF2'
         COLTAB(27) = 'POWER SUM2'
         COLTAB(30) = 'POST GAIN2'
         COLTAB(34) = 'CAL TYPE'
         END IF
      CALL FNDCOL (NKEY, COLTAB, 24, T, CLBUFF, KOLS, IERR)
      IF ((IERR.GE.1) .AND. (IERR.LE.10)) GO TO 999
      IERR = 0
C                                       Time column logical number
      CLTIME = KOLS(1)
C                                       Convert to pointers, types
      DO 20 I = 1,NKEY
         KP = KOLS(I)
         IF (KP.GT.0) THEN
            KOLS(I) = DATP(KP,1)
            KOLTYP(I) = MOD (DATP(KP,2), 10)
            KOLDIM(I) = DATP(KP,2) / 10
         ELSE
            KOLS(I) = -1
            KOLTYP(I) = -1
            KOLDIM(I) = 0
            END IF
 20      CONTINUE
C                                       Table keywords
      NKEY = 4
      IF (TYPE.EQ.'PC') NKEY = 3
      DO 30 I = 1,NKEY
         IF (TYPE .EQ. 'PC') THEN
            KEYW(I) = KEYPC(I)
         ELSE
            KEYW(I) = KEYSN(I)
            END IF
 30      CONTINUE
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL TABKEY ('READ', KEYW, NKEY, CLBUFF, KLOCS, KEYVAL, KEYTYP,
     *   IERR)
      MSGSUP = MSGSAV
      IF ((IERR.GE.1) .AND. (IERR.LE.20)) GO TO 999
      IERR = 0
C                                       Retrieve keyword values: PC
      IF (TYPE.EQ.'PC') THEN
         NUMANT = NSTNS
         GMMOD = 1.0
C                                       No. poln.
         NUMPOL = 1
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. IF
         NUMIF = 1
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       No. tones
         NTONE = 1
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) NTONE = KEYVAL(IPOINT)
C                                       Retrieve keyword values: other
      ELSE
         NTONE = 1
C                                       No. antennas.
         NUMANT = NSTNS
         IPOINT = KLOCS(1)
         IF (IPOINT.GT.0) NUMANT = KEYVAL(IPOINT)
C                                       No. poln.
         NUMPOL = 1
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. IF
         NUMIF = 1
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       Mean gain modulus
         GMMOD = 1.0
         IPOINT = KLOCS(4)
         IF (IPOINT.GT.0) THEN
            IF (KEYTYP(4).EQ.1) THEN
               CALL DPCOPY (1, KEYVR(IPOINT), KEYVAD)
            ELSE
               KEYVAD = KEYVR(IPOINT)
               END IF
            IF (KEYVAD.GT.0.0) GMMOD = 1.0 / KEYVAD
            END IF
         END IF
C                                       Set pointers
      DOPKOL = DOPKOL + BIF - 1
      DOP3KL = DOPKOL + EIF - 1
      DOPLKL = DOPKOL
      IF (TYPE.NE.'PC') PCNUM = 1
      IF (PCNUM.GT.NTONE) PCNUM = 1
      PCNUM = MAX (1, PCNUM)
C                                       1st poln
      IF (ISTOK.EQ.ABS (ICOR0)) THEN
         MBKOL(1) = MB1KOL
         REKOL(1) = RE1KOL + ((BIF-1) * NTONE) + PCNUM - 1
         IMKOL(1) = IM1KOL + ((BIF-1) * NTONE) + PCNUM - 1
         DLKOL(1) = DL1KOL + BIF - 1
         RAKOL(1) = RA1KOL + BIF - 1
         WTKOL(1) = WT1KOL + BIF - 1
         RFKOL(1) = RF1KOL + BIF - 1
         TSKOL(1) = TS1KOL + BIF - 1
         TAKOL(1) = TA1KOL + BIF - 1
         CKKOL(1) = CK1KOL
         DCKOL(1) = DC1KOL
         DSKOL(1) = DS1KOL
         DDKOL(1) = DD1KOL
         STKOL(1) = ST1KOL + BIF - 1
C                                       2nd poln
      ELSE
         MBKOL(1) = MB2KOL
         REKOL(1) = RE2KOL + ((BIF-1) * NTONE) + PCNUM - 1
         IMKOL(1) = IM2KOL + ((BIF-1) * NTONE) + PCNUM - 1
         DLKOL(1) = DL2KOL + BIF - 1
         RAKOL(1) = RA2KOL + BIF - 1
         WTKOL(1) = WT2KOL + BIF - 1
         RFKOL(1) = RF2KOL + BIF - 1
         TSKOL(1) = TS2KOL + BIF - 1
         TAKOL(1) = TA2KOL + BIF - 1
         CKKOL(1) = CK2KOL
         DCKOL(1) = DC2KOL
         DSKOL(1) = DS2KOL
         DDKOL(1) = DD2KOL
         STKOL(1) = ST2KOL + BIF - 1
         END IF
C                                       2nd Poln
      MBKOL(2) = MB2KOL
      REKOL(2) = RE2KOL + ((BIF-1) * NTONE) + PCNUM - 1
      IMKOL(2) = IM2KOL + ((BIF-1) * NTONE) + PCNUM - 1
      DLKOL(2) = DL2KOL + BIF - 1
      RAKOL(2) = RA2KOL + BIF - 1
      WTKOL(2) = WT2KOL + BIF - 1
      RFKOL(2) = RF2KOL + BIF - 1
      TSKOL(2) = TS2KOL + BIF - 1
      TAKOL(2) = TA2KOL + BIF - 1
      CKKOL(2) = CK2KOL
      DCKOL(2) = DC2KOL
      DSKOL(2) = DS2KOL
      DDKOL(2) = DD2KOL
      STKOL(2) = ST2KOL + BIF - 1
C                                       Phase, amplitude, summary
      IF ((ICODE.EQ.1) .OR. (ICODE.EQ.2) .OR. (ICODE.EQ.3) .OR.
     *   (ICODE.EQ.4) ) THEN
         IF ((REKOL(1).LT.0) .AND. (IMKOL(1).LT.0)) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. ((REKOL(2).LT.0) .OR. (IMKOL(2).LT.0)))
     *      GO TO 500
         IF (ICODE.EQ.1) THEN
            SUMSTK = MIN (SUMSTK, 3)
            END IF
C                                       Singleband Delay
      ELSE IF (ICODE.EQ.5) THEN
         IF (DLKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (DLKOL(2).LT.0)) GO TO 500
         SUMSTK = MIN (SUMSTK, 3)
C                                       Rate
      ELSE IF (ICODE.EQ.6) THEN
         IF (RAKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (RAKOL(2).LT.0)) GO TO 500
         SUMSTK = MIN (SUMSTK, 3)
C                                       SNR
      ELSE IF (ICODE.EQ.7) THEN
         IF (WTKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (WTKOL(2).LT.0)) GO TO 500
C                                       Doppler offset
      ELSE IF (ICODE.EQ.8) THEN
         IF (DOPLKL.LT.0) GO TO 500
C                                       Only 1 value
         MUMPOL = 1
         SUMSTK = 0
         CUTOFF = -1000.0
C                                       System temperature
      ELSE IF (ICODE.EQ.9) THEN
         IF (TSKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (TSKOL(2).LT.0)) GO TO 500
C                                       IF Antenna Temp
      ELSE IF (ICODE.EQ.10) THEN
         IF (TAKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (TAKOL(2).LT.0)) GO TO 500
C                                       SY Pdif
      ELSE IF (ICODE.EQ.11) THEN
         IF (REKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (REKOL(2).LT.0)) GO TO 500
C                                       SY Psum
      ELSE IF (ICODE.EQ.12) THEN
         IF (IMKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (IMKOL(2).LT.0)) GO TO 500
C                                       SY post gain
      ELSE IF (ICODE.EQ.13) THEN
         IF (WTKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (WTKOL(2).LT.0)) GO TO 500
C                                       SY Pon and Poff
      ELSE IF ((ICODE.EQ.14) .OR. (ICODE.EQ.15)) THEN
         IF (REKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (REKOL(2).LT.0)) GO TO 500
         IF (IMKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (IMKOL(2).LT.0)) GO TO 500
         IF (WTKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (WTKOL(2).LT.0)) GO TO 500
C                                       SY Pon and Poff
      ELSE IF (ICODE.EQ.16) THEN
         IF (REKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (REKOL(2).LT.0)) GO TO 500
         IF (IMKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (IMKOL(2).LT.0)) GO TO 500
C                                       OPCODE not okay
      ELSE
         IERR = 10
         MSGTXT = 'IMPROPER OPTYPE ''' // OPTYPE // ''''
         GO TO 980
         END IF
      GO TO 999
C                                       Requested data not in table
 500  WRITE(MSGTXT,1500) OPTYPE, TYPE
      IERR = 10
      GO TO 980
C                                       Error
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ERROR ',I3,' OPENING ',A,' TABLE NO. ',I3)
 1500 FORMAT (' REQUESTED DATA ',A,' NOT IN ',A,' TABLE ')
      END
      SUBROUTINE SNPCNT (NWORDS, IERR)
C-----------------------------------------------------------------------
C   SNPCNT reads the SN or CL table to find the number of samples for
C   each antenna
C   Input:
C      NA       I      Number antennas
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NWORDS, IERR
C
      LOGICAL   NODATA, OKAY
      INTEGER   I, NP, IFNUM
      REAL      TB, TE, GTIME
      INCLUDE 'SNIFS.INC'
      REAL      VALUE(2*MAXIF)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      CALL FILL (MAXANT, 0, NANREC)
      NODATA = .TRUE.
      TB = 1.0E5
      TE = -1.0E5
      IF ((TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TB = TSTART
         TE = TSTOP
         END IF
      XMX = TE
      XMN = TB
C                                       Loop thru data
      TINT = -1.0
      IF (INTKOL.LE.0) TINT = 10.0 / 86400.0
      NP = MUMPOL * MUMIF
      DO 100 ICLRNO = 1,NCLINR
         CALL TABIO ('READ', 0, ICLRNO, GNREC, CLBUFF, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
C                                       Solution interval
         IF (TINT.LE.0) TINT = GNREC(INTKOL)
C                                       Check weight per IF
C                                       If weight < CUTOFF them
C                                       set amp, phase, delay and
C                                       rate to FBLANK FOR EACH IF
         IF ((CUTOFF.GE.0.0) .AND. (WT1KOL.GT.0)) THEN
            IF (NUMPOL.EQ.2) THEN
               IF (SUMSTK.EQ.0) THEN
                  DO 5 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(1) + IFNUM) = FBLANK
                       GNREC(IMKOL(1) + IFNUM) = FBLANK
                       GNREC(DLKOL(1) + IFNUM) = FBLANK
                       GNREC(RAKOL(1) + IFNUM) = FBLANK
                       ENDIF
                    IF (GNREC(WTKOL(2) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(2) + IFNUM) = FBLANK
                       GNREC(IMKOL(2) + IFNUM) = FBLANK
                       GNREC(DLKOL(2) + IFNUM) = FBLANK
                       GNREC(RAKOL(2) + IFNUM) = FBLANK
                       ENDIF
5                 CONTINUE
               ELSE IF (SUMSTK.EQ.1) THEN
                  DO 15 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(1) + IFNUM) = FBLANK
                       GNREC(IMKOL(1) + IFNUM) = FBLANK
                       GNREC(DLKOL(1) + IFNUM) = FBLANK
                       GNREC(RAKOL(1) + IFNUM) = FBLANK
                       ENDIF
15                CONTINUE
               ELSE IF (SUMSTK.EQ.2) THEN
                  DO 25 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(2) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(2) + IFNUM) = FBLANK
                       GNREC(IMKOL(2) + IFNUM) = FBLANK
                       GNREC(DLKOL(2) + IFNUM) = FBLANK
                       GNREC(RAKOL(2) + IFNUM) = FBLANK
                       ENDIF
25                CONTINUE
                  END IF
               END IF
            IF (NUMPOL.EQ.1) THEN
                  DO 35 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(1) + IFNUM) = FBLANK
                       GNREC(IMKOL(1) + IFNUM) = FBLANK
                       GNREC(DLKOL(1) + IFNUM) = FBLANK
                       GNREC(RAKOL(1) + IFNUM) = FBLANK
                       ENDIF
35                CONTINUE
               END IF
            END IF
C                                       Record within specified
C                                       time range ?
         IF (KOLTYP(CLTIME).EQ.1) THEN
            GTIME = GNRECD(TIMKOL)
         ELSE
            GTIME = GNREC(TIMKOL)
            END IF
         IF ((GTIME.LT.TSTART) .OR. (GTIME.GT.TSTOP)) GO TO 100
C                                       Freq id
         IF ((GNRECI(FRQKOL).GT.0) .AND. (GNRECI(FRQKOL).NE.FRQSEL)
     *      .AND. (FRQSEL.GT.0)) GO TO 100
C                                       Subarray
         IF (TYPE.NE.'PC') THEN
            IF ((GNRECI(SUBKOL).GT.0) .AND. (SUBARR.GT.0) .AND.
     *         (GNRECI(SUBKOL).NE.SUBARR)) GO TO 100
            END IF
C                                       Antenna?
         IANT = GNRECI(ANTKOL)
         IF (NANTSL.GT.0) THEN
            DO 50 I = 1,NANTSL
               IF ((IANT.EQ.ANTS(I)).AND.DOAWNT) GO TO 60
               IF ((IANT.EQ.ANTS(I)).AND.(.NOT.DOAWNT)) GO TO 100
 50            CONTINUE
            IF (DOAWNT) GO TO 100
            END IF
C                                       Check source
 60      IF (NID.GT.0) THEN
            ISOU = GNRECI(SOUKOL)
            DO 70 I = 1,NID
               IF (ISOU.EQ.SID(I)) GO TO 80
 70            CONTINUE
            GO TO 100
            END IF
C                                      Get start, stop times
 80      TB = MIN (TB, GTIME)
         TE = MAX (TE, GTIME)
C                                       Get value
         CALL SNPDAT (VALUE, OKAY)
C                                       Max. - Min
         IF (((OKAY) .OR. (BSYM.GT.0))) THEN
            IF (OKAY) NODATA = .FALSE.
            NANREC(IANT) = NANREC(IANT) + 1
            END IF
 100     CONTINUE
      FANREC(1) = 1
      DO 120 I = 2,MAXANT
         FANREC(I) = FANREC(I-1) + NANREC(I-1)
 120     CONTINUE
      IF (NWORDS.LT.FANREC(MAXANT)+NANREC(MAXANT)) THEN
         MSGTXT = 'MEMORY TOO SMALL'
         IERR = 10
         END IF
C
 990  IF (IERR.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SNPCNT: ERROR =',I3,' FROM TABIO')
      END
      SUBROUTINE SNPMAX (NV, PLTPTS, IERR)
C-----------------------------------------------------------------------
C   SNPMAX reads the SN or CL table to find the max and min values for
C   each station or IF prior to plotting.
C   Input:
C      NV       I      Number values per time
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      PLTPTS   R(*)   Data to be plotted (NV, *)
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NV, IERR
      REAL      PLTPTS(NV,*)
C
      LOGICAL   NODATA, OKAY
      INTEGER   I, NP, NN, IP, IIF, IIS, IFNUM
      REAL      TB, TE, TMAX, TMIN, GTIME, PHASE, AMP
      INCLUDE 'SNIFS.INC'
      REAL      VALUE(2*MAXIF)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      NODATA = .TRUE.
      TB = 1.0E5
      TE = -1.0E5
      IF ((TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TB = TSTART
         TE = TSTOP
         END IF
      XMX = TE
      XMN = TB
C                                       Loop thru data
      TINT = -1.0
      IF (INTKOL.LE.0) TINT = 10.0 / 86400.0
      NP = MUMPAR * MUMPOL * MUMIF
      DO 100 ICLRNO = 1,NCLINR
         CALL TABIO ('READ', 0, ICLRNO, GNREC, CLBUFF, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
C                                       Solution interval
         IF (TINT.LE.0) TINT = GNREC(INTKOL)
C                                       Check weight per IF
C                                       If weight < CUTOFF them
C                                       set amp, phase, delay and
C                                       rate to FBLANK FOR EACH IF
         IF ((CUTOFF.GE.0.0) .AND. (WT1KOL.GT.0)) THEN
            IF (NUMPOL.EQ.2) THEN
               IF (SUMSTK.EQ.0) THEN
                  DO 5 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(1) + IFNUM) = FBLANK
                       GNREC(IMKOL(1) + IFNUM) = FBLANK
                       GNREC(DLKOL(1) + IFNUM) = FBLANK
                       GNREC(RAKOL(1) + IFNUM) = FBLANK
                       ENDIF
                    IF (GNREC(WTKOL(2) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(2) + IFNUM) = FBLANK
                       GNREC(IMKOL(2) + IFNUM) = FBLANK
                       GNREC(DLKOL(2) + IFNUM) = FBLANK
                       GNREC(RAKOL(2) + IFNUM) = FBLANK
                       ENDIF
5                 CONTINUE
               ELSE IF (SUMSTK.EQ.1) THEN
                  DO 15 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(1) + IFNUM) = FBLANK
                       GNREC(IMKOL(1) + IFNUM) = FBLANK
                       GNREC(DLKOL(1) + IFNUM) = FBLANK
                       GNREC(RAKOL(1) + IFNUM) = FBLANK
                       ENDIF
15                CONTINUE
               ELSE IF (SUMSTK.EQ.2) THEN
                  DO 25 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(2) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(2) + IFNUM) = FBLANK
                       GNREC(IMKOL(2) + IFNUM) = FBLANK
                       GNREC(DLKOL(2) + IFNUM) = FBLANK
                       GNREC(RAKOL(2) + IFNUM) = FBLANK
                       ENDIF
25                CONTINUE
                  END IF
               END IF
            IF (NUMPOL.EQ.1) THEN
                  DO 35 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(1) + IFNUM) = FBLANK
                       GNREC(IMKOL(1) + IFNUM) = FBLANK
                       GNREC(DLKOL(1) + IFNUM) = FBLANK
                       GNREC(RAKOL(1) + IFNUM) = FBLANK
                       ENDIF
35                CONTINUE
               END IF
            END IF
C                                       Record within specified
C                                       time range ?
         IF (KOLTYP(CLTIME).EQ.1) THEN
            GTIME = GNRECD(TIMKOL)
         ELSE
            GTIME = GNREC(TIMKOL)
            END IF
         IF ((GTIME.LT.TSTART) .OR. (GTIME.GT.TSTOP)) GO TO 100
C                                       Freq id
         IF ((GNRECI(FRQKOL).GT.0) .AND. (GNRECI(FRQKOL).NE.FRQSEL)
     *      .AND. (FRQSEL.GT.0)) GO TO 100
C                                       Subarray
         IF (TYPE.NE.'PC') THEN
            IF ((GNRECI(SUBKOL).GT.0) .AND. (SUBARR.GT.0) .AND.
     *         (GNRECI(SUBKOL).NE.SUBARR)) GO TO 100
            END IF
C                                       Antenna?
         IANT = GNRECI(ANTKOL)
         IF (NANTSL.GT.0) THEN
            DO 50 I = 1,NANTSL
               IF ((IANT.EQ.ANTS(I)).AND.DOAWNT) GO TO 60
               IF ((IANT.EQ.ANTS(I)).AND.(.NOT.DOAWNT)) GO TO 100
 50            CONTINUE
            IF (DOAWNT) GO TO 100
            END IF
C                                       Check source
 60      IF (NID.GT.0) THEN
            ISOU = GNRECI(SOUKOL)
            DO 70 I = 1,NID
               IF (ISOU.EQ.SID(I)) GO TO 80
 70            CONTINUE
            GO TO 100
            END IF
C                                      Get start, stop times
 80      TB = MIN (TB, GTIME)
         TE = MAX (TE, GTIME)
C                                       Get value
         CALL SNPDAT (VALUE, OKAY)
C                                       Max. - Min
         IF (((OKAY) .OR. (BSYM.GT.0))) THEN
            IF (OKAY) NODATA = .FALSE.
C                                       Put in array
            NUMPTS(IANT) = NUMPTS(IANT) + 1
            NN = FANREC(IANT) + NUMPTS(IANT) - 1
            PLTPTS(1,NN) = GTIME
            CALL RCOPY (NP, VALUE, PLTPTS(2,NN))
C                                       If not a summary plot
            IP = 1 - MUMPAR
            DO 90 IIF = 1,MUMIF
               DO 85 IIS = 1,MUMPOL
                  IP = IP + MUMPAR
                  IF (VALUE(IP).NE.FBLANK) THEN
                     IF (ICODE.EQ.1) THEN
                        AMP = SQRT (VALUE(IP)*VALUE(IP) +
     *                     VALUE(IP+1)*VALUE(IP+1))
                        YYMX = MAX (YYMX, AMP)
                        YYMN = MIN (YYMN, AMP)
                        YYMIN(IANT) = MIN (AMP, YYMIN(IANT))
                        YYMAX(IANT) = MAX (AMP, YYMAX(IANT))
                     ELSE IF (ICODE.EQ.2) THEN
                        PHASE = 57.296 *
     *                     ATAN2 (VALUE(IP+1), VALUE(IP) + 1.0E-20)
                        IF (PHASE.LE.-180.0) THEN
                           PHASE = PHASE + 360.
                        ELSE IF (PHASE.GT.180.) THEN
                           PHASE = PHASE - 360.
                           END IF
                        YYMX = MAX (YYMX, PHASE)
                        YYMN = MIN (YYMN, PHASE)
                        YYMIN(IANT) = MIN (PHASE, YYMIN(IANT))
                        YYMAX(IANT) = MAX (PHASE, YYMAX(IANT))
                        IF (PHASE.LT.0.0) PHASE = PHASE +
     *                     360.0
                        PPMIN(IANT) = MIN (PHASE, PPMIN(IANT))
                        PPMAX(IANT) = MAX (PHASE, PPMAX(IANT))
                     ELSE
                        YYMX = MAX (YYMX, VALUE(IP))
                        YYMN = MIN (YYMN, VALUE(IP))
                        YYMIN(IANT) = MIN (VALUE(IP), YYMIN(IANT))
                        YYMAX(IANT) = MAX (VALUE(IP), YYMAX(IANT))
                        END IF
                     END IF
 85               CONTINUE
 90            CONTINUE
            END IF
 100     CONTINUE
C                                       reset max min on fixed scale
      IF (PIXR(1).LT.PIXR(2)) THEN
         YYMX = PIXR(2)
         YYMN = PIXR(1)
         DO 120 IANT = 1,MUMANT
            IF (YYMAX(IANT).GE.YYMIN(IANT)) THEN
               YYMAX(IANT) = PIXR(2)
               YYMIN(IANT) = PIXR(1)
               IF (ICODE.EQ.2) THEN
                  PPMAX(IANT) = PIXR(2)
                  PPMIN(IANT) = PIXR(1)
                  END IF
               END IF
 120        CONTINUE
         END IF
C                                       Set actual X range
      XSTART = TB
      XSTOP = TE
C                                       Check for no data
      IF (NODATA) THEN
         IERR = 6
         MSGTXT = 'NO DATA SELECTED'
         GO TO 990
         END IF
      TSTART = TB
      TSTOP = TE
      TMIN = 0.0
      TMAX = MUMPOL * (MUMIF + 1)
      XYOFF(1) = TMIN
      XYSCL(1) = 1000.0 / (TMAX - TMIN)
      PRAN(1,1) = TMIN
      PRAN(2,1) = TMAX
C                                       Send back time range
      XTIME(1) = TSTART
      XTIME(2) = 0.0
      XTIME(3) = 0.0
      XTIME(4) = 0.0
      XTIME(5) = TSTOP
      XTIME(6) = 0.0
      XTIME(7) = 0.0
      XTIME(8) = 0.0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SNPMAX: ERROR =',I3,' FROM TABIO')
      END
      SUBROUTINE SNPDAT (VALUE, OKAY)
C-----------------------------------------------------------------------
C   Routine to get the specified value from a SN/CL/TY table entry
C   Input from common:
C      GNREC    R(*)  Table record
C      ICODE    I     Plot code
C      SUMSTK   I     Selected Stokes 0=both, 1=R, 2=L, 3=Difference
C   Also uses pointers etc. set in SNPOPN
C   Output:
C      VALUE    R(*)   Table value, magic value blanked (amp on ICODE 6)
C      OKAY     L      Some values are good
C-----------------------------------------------------------------------
      REAL      VALUE(*)
      LOGICAL   OKAY
C
      INTEGER   IIS, IIF, IP1, LP, JP1, KP1
      REAL      V, S, TC
      INCLUDE 'SNIFS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       In case the data is bad
      LP = MUMPAR * MUMPOL * MUMIF
      CALL RFILL (LP, FBLANK, VALUE)
C                                       Select data type
C                                       Phase (deg), ampl
C                                       return Re and Im
      IF (ICODE.LE.2) THEN
         DO 110 IIS = 1,MUMPOL
            LP = 2*IIS - 1 - 2*MUMPOL
            IP1 = REKOL(IIS) - NTONE
            JP1 = IMKOL(IIS) - NTONE
            DO 105 IIF = 1,MUMIF
               IP1 = IP1 + NTONE
               JP1 = JP1 + NTONE
               LP = LP + 2*MUMPOL
               IF ((GNREC(IP1).NE.FBLANK) .AND. (GNREC(JP1).NE.FBLANK))
     *            THEN
                  VALUE(LP) = GNREC(IP1)
                  VALUE(LP+1) = GNREC(JP1)
                  END IF
 105           CONTINUE
 110        CONTINUE
C                                       Delay (sec)
      ELSE IF (ICODE.EQ.5) THEN
         DO 150 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = DLKOL(IIS) - 1
            DO 145 IIF = 1,MUMIF
               IP1 = IP1 + 1
               LP = LP + MUMPOL
               IF (GNREC(IP1).NE.FBLANK) THEN
                  VALUE(LP) = GNREC(IP1)
                  END IF
 145           CONTINUE
 150        CONTINUE
C                                       Rate (Hz)
      ELSE IF (ICODE.EQ.6) THEN
         DO 170 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = RAKOL(IIS) - NTONE
            DO 165 IIF = 1,MUMIF
               IP1 = IP1 + NTONE
               LP = LP + MUMPOL
               IF (GNREC(IP1).NE.FBLANK) THEN
                  VALUE(LP) = GNREC(IP1) * RATFAC
                  END IF
 165           CONTINUE
 170        CONTINUE
C                                       System temperature (K)
      ELSE IF (ICODE.EQ.9) THEN
         DO 190 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = TSKOL(IIS) - 1
            DO 185 IIF = 1,MUMIF
               IP1 = IP1 + 1
               LP = LP + MUMPOL
               IF (ABS(GNREC(IP1)-999.0).LT.0.1) GNREC(IP1) = FBLANK
               IF (GNREC(IP1).NE.FBLANK) THEN
                  VALUE(LP) = GNREC(IP1)
                  END IF
 185           CONTINUE
 190        CONTINUE
C                                       SNR (no units)
      ELSE IF (ICODE.EQ.7) THEN
         DO 250 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = WTKOL(IIS) - 1
            DO 245 IIF = 1,MUMIF
               IP1 = IP1 + 1
               LP = LP + MUMPOL
               IF (GNREC(IP1).NE.FBLANK) THEN
                  VALUE(LP) = GNREC(IP1)
                  END IF
 245           CONTINUE
 250        CONTINUE
C                                       Doppler offset (Hz)
      ELSE IF (ICODE.EQ.8) THEN
         LP = IIS - 1
         IP1 = DOPLKL - 1
         DO 255 IIF = 1,MUMIF
            IP1 = IP1 + 1
            LP = LP + 1
            IF (GNREC(IP1).NE.FBLANK) VALUE(LP) = GNREC(IP1)
 255        CONTINUE
C                                       Tant (K)
      ELSE IF (ICODE.EQ.10) THEN
         DO 290 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = TAKOL(IIS) - 1
            DO 285 IIF = 1,MUMIF
               IP1 = IP1 + 1
               LP = LP + MUMPOL
               IF (ABS(GNREC(IP1)-999.0).LT.0.1) GNREC(IP1) = FBLANK
               IF (GNREC(IP1).NE.FBLANK) THEN
                  VALUE(LP) = GNREC(IP1)
                  END IF
 285           CONTINUE
 290        CONTINUE
C                                       REAL
      ELSE IF (ICODE.EQ.3) THEN
         DO 395 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = REKOL(IIS) - NTONE
            DO 390 IIF = 1,MUMIF
               IP1 = IP1 + NTONE
               LP = LP + MUMPOL
               IF ( GNREC(IP1).NE.FBLANK ) THEN
                  VALUE(LP) = GMMOD * GNREC(IP1)
                  END IF
 390           CONTINUE
 395        CONTINUE
C                                       IMAG
      ELSE IF (ICODE.EQ.4) THEN
         DO 420 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            JP1 = IMKOL(IIS) - NTONE
            DO 415 IIF = 1,MUMIF
               JP1 = JP1 + NTONE
               LP = LP + MUMPOL
               IF (GNREC(JP1).NE.FBLANK)
     *            THEN
                  VALUE(LP) = GMMOD * GNREC(JP1)
                  END IF
 415           CONTINUE
 420        CONTINUE
C                                       PDIF, PSUM, PGN
      ELSE IF ((ICODE.GE.11) .AND. (ICODE.LE.13)) THEN
         DO 430 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IF (ICODE.EQ.11) THEN
               IP1 = REKOL(IIS) - NTONE
            ELSE IF (ICODE.EQ.12) THEN
               IP1 = IMKOL(IIS) - NTONE
            ELSE
               IP1 = WTKOL(IIS) - NTONE
               END IF
            DO 425 IIF = 1,MUMIF
               IP1 = IP1 + NTONE
               LP = LP + MUMPOL
               IF (GNREC(IP1).NE.FBLANK) THEN
                  VALUE(LP) = GNREC(IP1)
                  END IF
 425           CONTINUE
 430        CONTINUE
C                                       PON, POFF
      ELSE IF ((ICODE.GE.14) .AND. (ICODE.LE.15)) THEN
         S = 1.0
         IF (ICODE.EQ.15) S = -1.0
         DO 440 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = REKOL(IIS) - NTONE
            JP1 = IMKOL(IIS) - NTONE
            KP1 = WTKOL(IIS) - NTONE
            DO 435 IIF = 1,MUMIF
               IP1 = IP1 + NTONE
               JP1 = JP1 + NTONE
               KP1 = KP1 + NTONE
               LP = LP + MUMPOL
               IF ((GNREC(IP1).NE.FBLANK) .AND. (GNREC(JP1).NE.FBLANK)
     *            .AND. (GNREC(KP1).NE.FBLANK) .AND.
     *            (GNREC(KP1).NE.0.0)) THEN
                  V = (GNREC(JP1) + S*GNREC(IP1)) / (2.0 * GNREC(KP1))
                  VALUE(LP) = V
                  END IF
 435           CONTINUE
 440        CONTINUE
C                                       PSUM / PDIF = Tsys/Tcal
      ELSE IF (ICODE.EQ.16) THEN
         DO 450 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = REKOL(IIS) - NTONE
            JP1 = IMKOL(IIS) - NTONE
            DO 445 IIF = 1,MUMIF
               IP1 = IP1 + NTONE
               JP1 = JP1 + NTONE
               LP = LP + MUMPOL
               IF ((CKKOL(1).GT.0) .AND. (GNRECI(CKKOL(1)).EQ.1)) THEN
                  TC = TCAL(ISTOK+IIS+1,IIF-1+BIF,IANT)
               ELSE
                  TC = TCAL(ISTOK+IIS-1,IIF-1+BIF,IANT)
                  END IF
               IF (TC.LE.0.0) TC = FBLANK
               IF ((GNREC(IP1).NE.FBLANK) .AND. (GNREC(JP1).NE.FBLANK)
     *            .AND. (GNREC(IP1).GT.0.0) .AND. (TC.NE.FBLANK)) THEN
                  V = GNREC(JP1) / GNREC(IP1) / 2.0 * TC
                  VALUE(LP) = V
                  END IF
 445           CONTINUE
 450        CONTINUE
         END IF
C
      OKAY = .TRUE.
      LP = MUMPAR * MUMPOL * MUMIF
      DO 910 IIS = 1,LP
         IF (VALUE(IIS).NE.FBLANK) GO TO 999
 910     CONTINUE
      OKAY = .FALSE.
C
 999  RETURN
      END
      SUBROUTINE SNPLOT (NV, NA, PLTPTS, IRET)
C-----------------------------------------------------------------------
C   SNPLOT plots the data thru calls to PLTSN.
C   Input:
C      NV       I      Number values per antenna
C      NA       I      Number antennas in data array
C      PLTPTS   R(*)   Data (NV,*)
C   Output:
C      IRET     I      Return code, 0=OK else failed
C-----------------------------------------------------------------------
      INTEGER   NV, NA, IRET
      REAL      PLTPTS(NV,*)
C
      INTEGER   IPLOT, NPLT, MANT, IA, NTIMES, IT
      REAL      TRA(2)
      LOGICAL   DOIT
      INCLUDE 'SNIFS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      INTEGER   STREC(MAXANT), INREC(MAXANT), ENREC(MAXANT)
C-----------------------------------------------------------------------
      IRET = 0
      IPLOT = 0
      MANT = NA
      IF (ITPLOT.EQ.1) MANT = 1
      DO 10 IA = 1,NA
         ENREC(IA) = FANREC(IA) + NANREC(IA) - 1
 10      CONTINUE
C                                       count the plots
      NPLOTS = 0
      NTIMES = 0
      CALL COPY (NA, FANREC, STREC)
 50   NTIMES = NTIMES + 1
         CALL FILL (NA, 0, INREC)
         CALL FINDNR (ITPLOT, NA, NV, PLTPTS, STREC, ENREC, SOLINT,
     *      INREC, DOIT)
         IF (DOIT) THEN
            DO 60 IA = 1,MANT
               IF (ITPLOT.EQ.1) THEN
                  NPLOTS = NPLOTS + 1
               ELSE IF (INREC(IA).GT.0) THEN
                  NPLOTS = NPLOTS + 1
                  END IF
 60            CONTINUE
            DO 70 IA = 1,NA
               IF (INREC(IA).GT.0) STREC(IA) = INREC(IA) + 1
 70            CONTINUE
            GO TO 50
            END IF
C                                       Now plot
      NPLT = 0
      CALL COPY (NA, FANREC, STREC)
 100  CALL FILL (NA, 0, INREC)
         CALL FINDNR (ITPLOT, NA, NV, PLTPTS, STREC, ENREC, SOLINT,
     *      INREC, DOIT)
         IF (DOIT) THEN
            DO 120 IA = 1,MANT
               DOIT = .FALSE.
               IF (ITPLOT.EQ.1) THEN
                  CALL GETSCL (NA, NV, PLTPTS, STREC, INREC, TRA, DOIT)
               ELSE IF (INREC(IA).GT.0) THEN
                  CALL GETSCL (1, NV, PLTPTS, STREC(IA), INREC(IA), TRA,
     *               DOIT)
                  END IF
               IF (DOIT) THEN
                  NPLT = NPLT + 1
                  IPLOT = MOD (NPLT-1, NCOUNT) + 1
                  IF (NPLT.EQ.NPLOTS) IPLOT = -IPLOT
                  IF (ITPLOT.EQ.2) THEN
                     IT = INREC(IA) - STREC(IA) + 1
                  ELSE IF (ITPLOT.EQ.1) THEN
                     IT = NA
                  ELSE
                     IT = 1
                     END IF
                  CALL PLTSN (IPLOT, IT, IA, TRA, IRET)
                  IF (IRET.NE.0) GO TO 999
                  END IF
 120           CONTINUE
            DO 130 IA = 1,NA
               IF (INREC(IA).GT.0) STREC(IA) = INREC(IA) + 1
 130           CONTINUE
            GO TO 100
            END IF
C
 999  RETURN
      END
      SUBROUTINE FINDNR (ITPLOT, NA, NV, PLTPTS, STREC, ENREC, SOLINT,
     *   INREC, DOIT)
C-----------------------------------------------------------------------
C   FINDNR lookes in the data for the next solint interval
C   Inputs:
C      ITPLOT   I      =2 : limit to <= MAXANT times
C      NA       I      Number antennas
C      NV       I      Number values per data sample
C      PLTPTS   R(*)   Data sample array (1,*) is time
C      STREC    I(*)   Start point in array for each antenna
C      ENREC    I(*)   Max rec number allowed for each antenna
C      SOLINT   R      Averaging interval in days
C   Output:
C      INREC    I(*)   Highest record this integration
C      DOIT     L      False => we are all the way done
C-----------------------------------------------------------------------
      INTEGER   ITPLOT, NA, NV, STREC(*), ENREC(*), INREC(*)
      REAL      PLTPTS(NV,*), SOLINT
      LOGICAL   DOIT
C
      INTEGER   IA, IREC
      REAL      TMIN, TT, TE
      INCLUDE 'INCS:PUVD.INC'
C-----------------------------------------------------------------------
C                                       find min time in data set
      TMIN = 1.E10
      DO 20 IA = 1,NA
         IF (STREC(IA).LE.ENREC(IA)) THEN
            TT = PLTPTS(1,STREC(IA))
            TMIN = MIN (TT, TMIN)
            END IF
 20      CONTINUE
      DOIT = .FALSE.
      IF (TMIN.LE.1.E9) THEN
         TE = TMIN + SOLINT
         DO 40 IA = 1,NA
            INREC(IA) = 0
            DO 30 IREC = STREC(IA),ENREC(IA)
               TT = PLTPTS(1,IREC)
               IF (TT.GE.TE) GO TO 40
               INREC(IA) = IREC
               DOIT = .TRUE.
               IF ((ITPLOT.EQ.2) .AND.
     *            (INREC(IA)-STREC(IA)+1.EQ.MAXANT)) GO TO 40
 30            CONTINUE
 40         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE GETSCL (NA, NV, PLTPTS, STREC, INREC, TRA, DOIT)
C-----------------------------------------------------------------------
C   GETSCL looks at the data for the next plot - prepares time averages
C   if needed and sets the plot scale
C   Inputs:
C      NA       I      Number of antennas to do
C      NV       I      Number of values per sample
C      PLTPTS   R(*)   Data array (NV,*)
C      STREC    I(*)   record number to start
C      INREC    I(*)   record number to end
C   Output:
C      TRA      R(2)   Time range of data
C      DOIT     L      There were valid values
C   Output in common
C      PLTAVG  R(*)    Data to plot (maxif,2,maxant)
C      XYSCL   R(2)    Scaling - only 2nd one changed
C      XYOFF   R(2)    Offset  - only second one changed
C-----------------------------------------------------------------------
      INTEGER   NA, NV, STREC(*), INREC(*)
      LOGICAL   DOIT
      REAL      PLTPTS(NV,*), TRA(2)
C
      INCLUDE 'SNIFS.INC'
      INTEGER   IIS, IIF, IP, IREC, IA
      REAL      SR, SI, SW, V, P, YMX, YMN, PMX, PMN, TMAX, TMIN, TDIF,
     *   TOLER(16), SIZEY, SA
      INCLUDE 'INCS:DDCH.INC'
C                                       Minimum value range for each
C                                       ICODE
C                  amp     phs   real   imag   delay    rate    snr
      DATA TOLER /0.001, 0.001, 0.001, 0.001, 1.0E-12, 1.0E-8, 0.001,
C                  dopl   Tsys   Tant      Pdif   Psum   Pgn    Pon
     *            0.001, 0.001, 0.000001, 0.001, 0.001, 1.E-5, 0.01,
C                 Poff  Psys
     *            0.01, 0.01/
C-----------------------------------------------------------------------
      DOIT = .FALSE.
      YMX = -1.E8
      YMN = -YMX
      PMX = YMX
      PMN = YMN
      TRA(1) = 1.E8
      TRA(2) = -1.E8
C                                       plot several times
      IF (ITPLOT.EQ.2) THEN
         IP = 2 - MUMPAR
         DO 30 IIF = 1,MUMIF
            DO 20 IIS = 1,MUMPOL
               IP = IP + MUMPAR
               DO 10 IREC = STREC(1),INREC(1)
                  V = PLTPTS(IP,IREC)
                  IF (V.NE.FBLANK) THEN
                     TRA(1) = MIN (TRA(1), PLTPTS(1,IREC))
                     TRA(2) = MAX (TRA(2), PLTPTS(1,IREC))
                     IF (ICODE.EQ.1) THEN
                        V = SQRT (V*V + PLTPTS(IP+1,IREC)**2)
                     ELSE IF (ICODE.EQ.2) THEN
                        V = 57.296 * ATAN2 (PLTPTS(IP+1,IREC), V+1.E-20)
                        IF (V.GT.180.0) V = V - 360.
                        IF (V.LE.-180.0) V = V + 360.
                        P = V
                        IF (P.LT.0.0) P = P + 360.
                        PMX = MAX (PMX, P)
                        PMN = MIN (PMN, P)
                        END IF
                     YMX = MAX (YMX, V)
                     YMN = MIN (YMN, V)
                     END IF
                  PLTAVG(IIF,IIS,IREC-STREC(1)+1) = V
 10               CONTINUE
 20            CONTINUE
 30         CONTINUE
C                                       average over time
      ELSE
         DO 100 IA = 1,NA
            IP = 2 - MUMPAR
            DO 90 IIF = 1,MUMIF
               DO 80 IIS = 1,MUMPOL
                  IP = IP + MUMPAR
                  SR = 0.0
                  SI = 0.0
                  SW = 0.0
                  SA = 0.0
                  DO 50 IREC = STREC(IA),INREC(IA)
                     V = PLTPTS(IP,IREC)
                     IF (V.NE.FBLANK) THEN
                        TRA(1) = MIN (TRA(1), PLTPTS(1,IREC))
                        TRA(2) = MAX (TRA(2), PLTPTS(1,IREC))
                        IF (ICODE.LE.2) SI = SI + PLTPTS(IP+1,IREC)
                        IF (ICODE.EQ.1) SA = SA + SQRT (V*V +
     *                     PLTPTS(IP+1,IREC)*PLTPTS(IP+1,IREC))
                        SR = SR + V
                        SW = SW + 1.0
                        END IF
 50                  CONTINUE
                  IF (SW.GT.0.0) THEN
                     SR = SR / SW
                     SI = SI / SW
                     SA = SA / SW
                     IF (ICODE.EQ.1) THEN
                        IF (SCALAR) THEN
                           V = SA
                        ELSE
                           V = SQRT (SR*SR + SI*SI)
                           END IF
                     ELSE IF (ICODE.EQ.2) THEN
                        V = 57.296 * ATAN2 (SI, SR+1.E-20)
                        IF (V.GT.180.0) V = V - 360.
                        IF (V.LE.-180.0) V = V + 360.
                        P = V
                        IF (P.LT.0.0) P = P + 360.
                        PMX = MAX (PMX, P)
                        PMN = MIN (PMN, P)
                     ELSE
                        V = SR
                        END IF
                     YMX = MAX (YMX, V)
                     YMN = MIN (YMN, V)
                  ELSE
                     V = FBLANK
                     END IF
                  PLTAVG(IIF,IIS,IA) = V
 80               CONTINUE
 90            CONTINUE
 100        CONTINUE
         END IF
C
      DOIT = YMX.GE.YMN
      IF (PIXR(2).GT.PIXR(1)) THEN
         YMX = PIXR(2)
         YMN = PIXR(1)
      ELSE IF (ICODE.EQ.2) THEN
         IF (PMX-PMN.LT.YMX-YMN) THEN
            YMX = PMX
            YMN = PMN
            END IF
         END IF
      SIZEY = 1000.0 / NCOUNT
      TMAX = YMX + 0.1 * (YMX - YMN)
      TMIN = YMN - 0.1 * (YMX - YMN)
      IF (ABS (TMAX-TMIN) .LT. TOLER(ICODE)) THEN
         TMAX = TMAX + TOLER(ICODE)
         TMIN = TMIN - TOLER(ICODE)
         END IF
      TDIF = TMAX - TMIN
      IF (ABS (TDIF).LE.1.0E-25) TDIF = 1.0E-25
      XYOFF(2) = TMIN
      XYSCL(2) = 1000.0 / TDIF / NCOUNT
      PRAN(1,2) = TMIN
      PRAN(2,2) = TMAX
C
 999  RETURN
      END
      SUBROUTINE PLTSN (IPLOT, NA, IA, TRA, IRET)
C-----------------------------------------------------------------------
C   PLTSN actually plots data.
C   Input:
C      IPLOT    I      Plot number on current page. If neg. then this is
C                      last plot.
C      NA       I      Number of antennas or times to plot
C      IA       I      antenna number to label
C   Output:
C      IRET     I      Return code, 0 => OK, otherwise abort.
C                       -1 => user request termination
C                        1 => failed to add to catalog
C                        2 => failed to create
C                        3 => graph file write error
C                        4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   IPLOT, NA, IA, IRET
      REAL      TRA(2)
C
      CHARACTER TEXT*132, PFILE*48, ATIME*8, ADATE*12, AUNITS(18)*8,
     *   CHTYPE(18)*16, CHTMP*18, TSIGN*1, STRNG*32
      INTEGER   BUFFER(256), VER, IERR, ITYPE, IPSIZE, LUNPL, LTYPE,
     *   FINDPL, DEPTH(5), INCHAR, INP, IT(3), ID(3), IAXLAB, IAPLOT,
     *   I, NGOOD, NNOFIT, JCODE, IIF, ILITY, TIME(3,2), JA, IIP
      REAL      BLC(2), TRC(2), XYRATO, DX, DY, TR, VALUE, TI, XY(2),
     *   XTRC(2), XBLC(2), TLC(2), PLTINC, YYOFF(2), SIZE, XMULT(2),
     *   DBY, COLV, COL(3), COLR, AX(5), AY(5), XL, TSEC(2)
      LOGICAL   T, F, GOOD, CATUP, DONEG, DO3C, BLNKD
      SAVE BUFFER
      INCLUDE 'SNIFS.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA LUNPL /26/
      DATA DEPTH /5*1/
      DATA T, F /.TRUE.,.FALSE./
      DATA CHTYPE /'Gain amp', 'Gain phs', 'Real', 'Imag', 'Delay',
     *             'Rate', 'SNR', 'Doppler offset', 'Tsys', 'Tant',
     *             'Power difference', 'Power sum', 'Post gain',
     *             'Power NT on', 'Power NT off', 'Tsys',
     *             'Phase-cal Phase', 'Phase-cal Ampl'/
      DATA AUNITS /'Gain', 'Degrees', 'Gain', 'Gain', 'Seconds',
     *             'Hz', 'SNR', 'Hz', 'Kelvin', 'Kelvin',
     *             'Counts', 'Counts', 'Gain',
     *             'Counts', 'Counts', 'Kelvin',
     *             'Degrees', 'PCamp'/
C-----------------------------------------------------------------------
      NGOOD = 0
      NNOFIT = 0
      IRET = 3
      CATUP = T
C
      JCODE = ICODE
      IF (TYPE.EQ.'PC') THEN
         IF (JCODE.EQ.2) JCODE = 17
         IF (JCODE.EQ.1) JCODE = 18
         END IF
C                                       Create plot file
      IF (ABS (IPLOT).EQ.1) THEN
C                                       Update catalog header.
         VER = 0
         IRET = 1
         IF (.NOT.DOTV) THEN
            CALL MADDEX ('PL', DISKIN, CNOIN, CATBLK, BUFFER, CATUP,
     *         'WRIT', VER, IERR)
            IF (IERR.NE.0) THEN
               NCFILE = NCFILE - 1
               GO TO 999
               END IF
            END IF
         CALL ZPHFIL ('PL', DISKIN, CNOIN, VER, PFILE, IERR)
         IF (IERR.NE.0) GO TO 960
         IPSIZE = 0
         ITYPE = 44
         SOLINT = SOLINT * (24.0 * 3600.0)
         CALL GINIT (DISKIN, CNOIN, PFILE, IPSIZE, ITYPE, NPARMS,
     *      XNAMEI, DOTV, TVCHN, GRCHN, TVCORN, CATBLK, BUFFER, LUNPL,
     *      FINDPL, IERR)
         SOLINT = SOLINT / (24.0 * 3600.0)
         IRET = 2
         IF (IERR.NE.0) GO TO 960
         END IF
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      IF (DOTV) THEN
         TRC(1) = WINDTV(3) - WINDTV(1)
         TRC(2) = WINDTV(4) - WINDTV(2)
         IF (DO3COL.LE.0.0) THEN
            CALL GCINIT (GPHTVG(4), 0, IERR)
            IF (IERR.NE.0) GO TO 960
            CALL GCINIT (GPHTVG(3), 0, IERR)
            IF (IERR.NE.0) GO TO 960
            END IF
         END IF
      XYRATO = 1.0
      PLTINC = TRC(2) / NCOUNT
C                                       Set window for current plot.
      XBLC(1) = BLC(1)
      XBLC(2) = TRC(2) - ABS (IPLOT) * PLTINC
      XTRC(1) = TRC(1)
      XTRC(2) = XBLC(2) + PLTINC - 1.0
      TLC(1) = XBLC(1)
      TLC(2) = XTRC(2)
C                                       Offsets for current plot.
      YYOFF(1) = XBLC(1)
      YYOFF(2) = XBLC(2)
C                                       fool with location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      TR = 1.2 * (YYMX - YYMN)
      IF (TR.LE.0.0) TR = 1.0
      TI = TR
      CALL METSCL (LABEL, TR, CPREF(2,LOCNUM), GOOD)
      XMULT(2) = TR / TI
      CPREF(1,LOCNUM) = ' '
      XMULT(1) = 1.0
      DO 50 I = 1,2
         SIZE = XTRC(I) - XBLC(I) + 1
         TR = PRAN(2,I) - PRAN(1,I)
         XYSCL(I) = (XTRC(I) - XBLC(I)) / TR
         RPLOC(I,LOCNUM) = XBLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I) * XMULT(I)
         AXINC(I,LOCNUM) = TR * XMULT(I) / (XTRC(I) - XBLC(I))
 50      CONTINUE
      CTYP(2,LOCNUM) = AUNITS(JCODE)
C                                       Init plot calls again
C                                       Number of characters on each
C                                       side of the plot
      IF (ABS (IPLOT).EQ.1) THEN
         CALL RFILL (4, 0.5, CHOUT)
C                                       Not fully initialized, may make
C                                       INP too large which is okay.
         CALL CHNTIC (XBLC, XTRC, INP)
         INP = MAX (INP, 3)
         LTYPE = MOD (ABS (LABEL), 100)
         IF (LTYPE.EQ.2) CHOUT(1) = 2.5
         IF (LTYPE.GT.2) CHOUT(1) = INP + 4
         IF (LTYPE.GT.1) CHOUT(2) = 2.0
         IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
         IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = 3.333
         IF ((LABEL.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7))
     *      CHOUT(4) = CHOUT(4) + 1.333
C                                       Init for line drawing.
         CALL GINITL (BLC, TRC, XYRATO, CHOUT, DEPTH, BUFFER, IERR)
         IRET = 3
         IF (IERR.NE.0) GO TO 970
         IF (.NOT.DOTV) THEN
            WRITE (MSGTXT,1000) VER
            CALL MSGWRT (2)
            END IF
         END IF
      IRET = 3
      CATUP = T
C                                       Draw border
      CALL GLTYPE (1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Top labels: type & name
      IF ((ABS(IPLOT).EQ.1) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DX = 0.0
         DY = 1.833
C                                       The second line of the header
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         INCHAR = 16
         INP = 1
         TEXT = CHTYPE(JCODE)
         CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
         INP = INP + 1
         TEXT(INP:) = ' vs IF for '
         INP = INP + 11
C                                       File name
         CALL H2CHR (18, KHIMNO, CATH(KHIMN), CHTMP)
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), CHTMP(13:18))
         CALL NAMEST (CHTMP, CATBLK(KIIMS), TEXT(INP:), INCHAR)
         CALL REFRMT (TEXT, ' ', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       the third line of header
         DY = 0.5
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         INP = 1
C
         WRITE (TEXT(INP:),1010) TYPE, ITVER
         INP = INP + 8
         IF (TYPE.EQ.'PC') THEN
            WRITE (TEXT(INP:),1015) PCNUM
            INP = INP + 9
            END IF
C                                       Stokes
         IF (SUMSTK.GT.0) THEN
            TEXT(INP:) = XSTOK(:1) // 'pol_'
            INP = INP + 7
         ELSE
            TEXT(INP:) = 'Rpol & Lpol_'
            INP = INP + 14
            END IF
C                                       Phase-cal tone
         IF ((TYPE.EQ.'PC') .AND. ((JCODE.EQ.24) .OR.
     *         (JCODE.EQ.25))) THEN
            WRITE (TEXT(INP:),1060) PCNUM
            END IF
C                                       time range
         IF (ITPLOT.NE.1) THEN
            TEXT(INP:) = 'Time'
            INP = INP + 5
            CALL TFDHMS (TRA(1), 1, TSIGN, TIME(1,1), TSEC(1))
            CALL TFDHMS (TRA(2), 1, TSIGN, TIME(1,2), TSEC(2))
            WRITE (STRNG,1020) TIME(1,1), TIME(2,1), TIME(3,1),
     *         TSEC(1), TIME(1,2), TIME(2,2), TIME(3,2), TSEC(2)
            IF (TIME(1,1)+TIME(1,2).LE.0) THEN
               STRNG(1:3) = ' '
               STRNG(16:18) = ' '
               END IF
            IF (STRNG(10:10).EQ.' ') STRNG(10:10) = '0'
            IF (STRNG(25:25).EQ.' ') STRNG(25:25) = '0'
            TEXT(INP:) = STRNG
            END IF
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Date/time/version
         IF ((LABEL.GT.0) .AND. (LTYPE.GT.1)) THEN
            DY = 0.5 + 2 * 1.333
C                                       the first line of the header
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (TEXT,1030) VER, ADATE, ATIME
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
         END IF
C                                       station ID, not on ALAN
      CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      DX =  3.0
      DY = -2.5
      IF (ITPLOT.NE.1) THEN
         WRITE (TEXT,1040) IA
         INP = 4
         IF (MUMPOL.LE.1) THEN
            TEXT(INP:) = XSTOK(:1)
            INP = INP + 1
            END IF
         TEXT(INP+1:) = STNNAM(IA)
         CALL CHTRIM (TEXT, 132, TEXT, INCHAR)
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       time range
      ELSE
         INP = 1
         TEXT(INP:) = 'Time'
         INP = INP + 5
         CALL TFDHMS (TRA(1), 1, TSIGN, TIME(1,1), TSEC(1))
         CALL TFDHMS (TRA(2), 1, TSIGN, TIME(1,2), TSEC(2))
         WRITE (STRNG,1020) TIME(1,1), TIME(2,1), TIME(3,1),
     *      TSEC(1), TIME(1,2), TIME(2,2), TIME(3,2), TSEC(2)
         IF (TIME(1,1)+TIME(1,2).LE.0) THEN
            STRNG(1:3) = ' '
            STRNG(16:18) = ' '
            END IF
         IF (STRNG(10:10).EQ.' ') STRNG(10:10) = '0'
         IF (STRNG(25:25).EQ.' ') STRNG(25:25) = '0'
         TEXT(INP:) = STRNG
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Set up location common
C                                       Blank bottom label.
      CPREF(1,LOCNUM) = ' '
      CTYP(1,LOCNUM) = 'NO TICKS'
C                                       Only label Y axis once.
      IAXLAB = NCOUNT / 2 + 1
      IAPLOT = ABS (IPLOT)
      IF ((IAPLOT.NE.IAXLAB) .AND. ((IPLOT.GE.0) .OR.
     *   (IAPLOT.GT.IAXLAB))) CPREF(2,LOCNUM) = '-1'
C                                       Put on labels and ticks
      CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XYRATO, F, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       x axis ticks
      IF ((IPLOT.GE.0) .AND. (ABS (IPLOT).NE.NCOUNT)) THEN
         CTYP(1,LOCNUM) = ' '
      ELSE
         CTYP(1,LOCNUM) = 'IFS'
         END IF
      CALL SNIFT (XBLC, XTRC, BIF, EIF, MUMPOL, LABEL, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       center line
      XL = (MUMIF + 1) * MUMPOL
      XL = (XTRC(1) - XBLC(1)) / XL
      IF (MUMPOL.GT.1) THEN
         XY(1) = (MUMIF+1) * XL + XBLC(1)
         CALL GPOS (XY, BLC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (XY, TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Size of symbol.
      DBY = 0.5 * FACTOR
C                                       Loop
      ILITY = 4
      CALL GLTYPE (ILITY, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      DO3C = (DO3COL.GT.0.0) .AND. (NA.GT.1)
      COLR = NA - 1.0
C                                       Outer loop: IF, stokes
      COLV = 0.0
      DO 200 JA = 1,NA
         IF (DO3C) THEN
            CALL COLOR3 (COLV, .FALSE., COL)
            CALL G3VCOL (COL(1), COL(2), COL(3), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            COLV = COLV + 0.97 / COLR
            END IF
         DO 130 IIP = 1,MUMPOL
            DO 120 IIF = 1,MUMIF
               DONEG = (ICODE.EQ.2)
               XY(1) = (IIF + (IIP-1) * (MUMIF+1)) * XL + XBLC(1)
               VALUE = PLTAVG(IIF,IIP,JA)
               IF (VALUE.NE.FBLANK) THEN
 110              XY(2) = VALUE
                  XY(2) = XYSCL(2) * (XY(2) - XYOFF(2)) + YYOFF(2)
                  IF ((XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2))) THEN
                     IF (DONEG) THEN
                        IF (VALUE.LT.0.) THEN
                           VALUE = VALUE + 360.
                        ELSE
                           VALUE = VALUE - 360.
                           END IF
                        DONEG = .FALSE.
                        GO TO 110
                     ELSE
                        NNOFIT = NNOFIT + 1
                        END IF
                  ELSE
                     NGOOD = NGOOD + 1
C                                       Mark point
                     DY = 5.0 * FACTOR
                     DX = 5.0 * FACTOR
                     IF (XYRATO.GT.1.0) THEN
                        DY = DY * XYRATO
                     ELSE
                        DX = DX / XYRATO
                        END IF
                     AX(1) = XY(1)
                     AY(1) = XY(2)
                     AX(2) = AX(1)
                     AX(3) = AX(1)
                     AX(4) = AX(1) - DX
                     AX(5) = AX(1) + DX
                     AY(2) = AY(1) + DY
                     AY(3) = AY(1) - DY
                     AY(4) = AY(1)
                     AY(5) = AY(1)
                     IF ((.NOT.DO3C) .AND. (ILITY.NE.4)) THEN
                        ILITY = 4
                        CALL GLTYPE (ILITY, BUFFER, IERR)
                        IF (IERR.NE.0) GO TO 970
                        END IF
                     CALL PNTPLT (ISYM, AX, AY, XBLC, XTRC, .FALSE.,
     *                  DO3C, BUFFER, IERR)
                     IF (IERR.NE.0) GO TO 970
                     END IF
               ELSE IF (BSYM.GT.0) THEN
                  DY = 5.0 * FACTOR
                  DX = 5.0 * FACTOR
                  IF (XYRATO.GT.1.0) THEN
                     DY = DY * XYRATO
                  ELSE
                     DX = DX / XYRATO
                     END IF
                  XY(2) = XBLC(2) + DY
                  AX(1) = XY(1)
                  AY(1) = XY(2)
                  AX(2) = AX(1)
                  AX(3) = AX(1)
                  AX(4) = AX(1) - DX
                  AX(5) = AX(1) + DX
                  AY(2) = AY(1) + DY
                  AY(3) = AY(1) - DY
                  AY(4) = AY(1)
                  AY(5) = AY(1)
                  IF ((.NOT.DO3C) .AND. (ILITY.NE.3)) THEN
                     ILITY = 3
                     CALL GLTYPE (ILITY, BUFFER, IERR)
                     IF (IERR.NE.0) GO TO 970
                     END IF
                  CALL PNTPLT (BSYM, AX, AY, XBLC, XTRC, .FALSE.,
     *               DO3C, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  END IF
 120           CONTINUE
 130        CONTINUE
C                                       Line plot
         IF (DOLINE) THEN
            DO 160 IIP = 1,MUMPOL
               BLNKD = .TRUE.
               DO 150 IIF = 1,MUMIF
                  DONEG = (ICODE.EQ.2)
                  XY(1) = (IIF + (IIP-1) * (MUMIF+1)) * XL + XBLC(1)
                  VALUE = PLTAVG(IIF,IIP,JA)
                  IF (VALUE.EQ.FBLANK) THEN
                     BLNKD = .TRUE.
                  ELSE
 140                 XY(2) = VALUE
                     XY(2) = XYSCL(2) * (XY(2) - XYOFF(2)) + YYOFF(2)
                     IF ((XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2)))
     *                  THEN
                        IF (DONEG) THEN
                           IF (VALUE.LT.0.) THEN
                              VALUE = VALUE + 360.
                           ELSE
                              VALUE = VALUE - 360.
                              END IF
                           DONEG = .FALSE.
                           GO TO 140
                           END IF
C                                       Mark point
                     ELSE
                        IF (BLNKD) THEN
                           CALL GPOS (XY(1), XY(2), BUFFER, IERR)
                           BLNKD = .FALSE.
                        ELSE IF (DO3C) THEN
                           CALL G3VEC (XY(1), XY(2), BUFFER, IERR)
                        ELSE
                           CALL GVEC (XY(1), XY(2), BUFFER, IERR)
                           END IF
                        IF (IERR.NE.0) GO TO 970
                        END IF
                     END IF
 150              CONTINUE
 160           CONTINUE
            END IF
 200     CONTINUE
C                                       Done: finish plot
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      IF ((IPLOT.LE.0) .OR. (ABS(IPLOT).GE.NCOUNT)) THEN
         GPHPAG = IPLOT.GT.0
         CALL GFINIS (BUFFER, IERR)
         IF (IERR.GT.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
            IERR = 0
            END IF
         END IF
      IF (IERR.GT.0) GO TO 975
         IRET = MIN (IERR, 0)
         GO TO 999
C                                       ZPHFIL or GINIT failure.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      IF (.NOT.DOTV) THEN
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
      GO TO 999
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      GPHPAG = IPLOT.GT.0
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.EQ.0) THEN
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
            IERR = 0
            END IF
         GO TO 999
         END IF
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Plot file version',I4,'  created.')
 1010 FORMAT (A2,I4,'_')
 1015 FORMAT ('NTONE ',I2)
 1020 FORMAT (I2,'/',2(I2.2,':'),F4.1,' -',I2,'/',2(I2.2,':'),F4.1)
 1030 FORMAT ('Plot file version',I4,'__created ',A, A)
 1040 FORMAT (I3)
 1060 FORMAT ('_Phase tone ',I2)
 1200 FORMAT ('PLTSN:',I9,' points plotted')
 1202 FORMAT ('PLTSN:',I9,' points did not fit')
 1960 FORMAT ('PLTSN: ERROR DURING GRAPH FILE CREATION')
 1970 FORMAT ('PLTSN: ERROR DURING GRAPHING. WILL TRY TO FINISH ',
     *   'PARTIAL GRAPH')
      END
      SUBROUTINE SNIFT (BLC, TRC, BC, EC, NG, ILTYPE, BUFFER, IERR)
C-----------------------------------------------------------------------
C   To do X axis where we have multiple sub panels with integer counts
C   Inputs:
C      BLC      R(2)    X, Y pixels to form bottom left hand corner
C      TRC      R(2)    X, Y pixels to form the top right hand corner
C      BC       I       Begin count
C      EC       I       End count
C      NG       I       Number of such groups
C      ILTYPE   I       label type: 1 none, 2 no ticks, 3 RA/DEC
C                          4 center relative
C   In/out:
C      BUFFER   I(256)  the updated graphics output buffer.
C      IERR     I       error indicator: 0 = No error.
C-----------------------------------------------------------------------
      REAL      BLC(2), TRC(2)
      INTEGER   BC, EC, NG, ILTYPE, BUFFER(256), IERR
C
      INTEGER   NINTER
      PARAMETER (NINTER=15)
C
      INTEGER   INCHAR, IANGL, LTYPE, I, XINTER(NINTER), XINT, DIST,
     *   NOINT, NINT, IG, XVAL, DU, DL, DEG
      REAL      X, DCX, DCY, XL, XI, XPOS
      CHARACTER SPRTXT*20
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA XINTER /1, 2, 5, 10, 20, 50, 100, 200, 500, 1000,
     *   2000, 5000, 10000, 20000, 50000/
C-----------------------------------------------------------------------
      CALL CHECKL ('SNIFT')
      LTYPE = MOD (ABS (ILTYPE), 100)
      IF (LTYPE.EQ.1) GO TO 999
C                                       axis type
      IF (CTYP(1,LOCNUM).NE.' ') THEN
         X = (BLC(1) + TRC(1)) / 2.0
         CALL GPOS (X, BLC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
         SPRTXT = CTYP(1,LOCNUM)
         CALL CHTRIM (SPRTXT, 20, SPRTXT, INCHAR)
         IANGL = 0
         DCX = -INCHAR / 2.0
         DCY = -2.83
         IF (LTYPE.EQ.2) DCY = -1.5
         CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPRTXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       tick marks
      XINT = 32 / NG
      XINT = MAX (3, MIN (16, XINT))
      DIST = EC - BC + 2
      DO 20 I = 1,NINTER
         DEG = XINTER(I)
         DU = (EC / DEG) * DEG
         IF (DU.GT.EC) DU = DU - DEG
         DL = (BC / DEG) * DEG
         IF (DL.LT.BC) DL = DL + DEG
         NOINT = (DU - DL) / DEG + 1
         IF (NOINT.LE.XINT) GO TO 30
 20      CONTINUE
      MSGTXT = 'SNIFT: TICK MARK ALGORITHM FAILED'
      CALL MSGWRT (6)
      IERR = 0
      GO TO 999
C                                       plot tick marks
 30   XINT = DEG
      NINT = (NOINT * NG) / 16
      NINT = MAX (1, MIN (NINT, NOINT))
      NOINT = NOINT + 2
      DCX = -0.5
      XL = DIST * NG
      XL = (TRC(1) - BLC(1)) / XL
      XI = (TRC(2) - BLC(2)) / 25.
      DCY = -1.5
      DO 50 IG = 1,NG
         XVAL = (BC / XINT) * XINT
         IF (XVAL.EQ.BC) XVAL = XVAL - XINT
         DO 40 I = 1,NOINT
            XVAL = XVAL + XINT
            IF ((XVAL.GE.BC) .AND. (XVAL.LE.EC)) THEN
               XPOS = (XVAL-BC+1 + (IG-1)*DIST) * XL + BLC(1)
               CALL GPOS (XPOS, TRC(2), BUFFER, IERR)
               IF (IERR.NE.0) GO TO 999
               CALL GVEC (XPOS, TRC(2)-XI, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 999
               CALL GPOS (XPOS, BLC(2)+XI, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 999
               CALL GVEC (XPOS, BLC(2), BUFFER, IERR)
               IF (IERR.NE.0) GO TO 999
               IF ((LTYPE.GT.2) .AND. (MOD(I,NINT).EQ.0) .AND.
     *            (CTYP(1,LOCNUM).NE.' ')) THEN
                  WRITE (SPRTXT,1030) XVAL
                  CALL CHTRIM (SPRTXT, 6, SPRTXT, INCHAR)
                  DCX = 0.5 - INCHAR
                  CALL GCHAR (INCHAR, 0, DCX, DCY, SPRTXT, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 999
                  END IF
               END IF
 40         CONTINUE
 50      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (I6)
      END

      SUBROUTINE YSCROL (CHANNL, SCROLX, SCROLY, VRTRTC, IERR)
C-----------------------------------------------------------------------
C! write the scroll registers (shift location of 1 or more TV channels)
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YSCROL writes the scroll registers on the TV.
C   Inputs:
C      CHANNL   I   bit map channel select: bits 1-NGRAY gray channels,
C                   bit NGRAY+1 => all graphics
C      VRTRTC   L   T => do it on vertical retrace only
C   In/Out:
C      SCROLX   I   amount of X scroll (>0 to right)
C      SCROLY   I   amount of Y scroll (>0 upwards)
C   Output:
C      IERR     I   error from Z...XF : 0 => ok, 2 => input error
C   YSCROL updates the scroll variables in /TVDEV/ common
C   Version of IIS Model 75
C-----------------------------------------------------------------------
      INTEGER   CHANNL, SCROLX, SCROLY, IERR
      LOGICAL   VRTRTC
C
      INTEGER   UNIT, HEADER(8), BUFFER(2), BUFSIZ, NB, BITS(16), I,
     *   ITEMP, BIT16, IC, TMASK, ISCX, ISCY, MAGPOW, ZMASK, ZOR, ZAND
      LOGICAL   COMAND
      INCLUDE 'INCS:DTVC.INC'
      DATA UNIT, COMAND, BUFSIZ / 6, .FALSE., 2/
      DATA BIT16 /-32768/
C-----------------------------------------------------------------------
C                                       TMASK = 1201 hex
      TMASK = 4609
C                                       Set buffer
      ISCX = MOD (16*MAXXTV(1)-SCROLX, MAXXTV(1))
      ISCY = MOD (16*MAXXTV(2)+SCROLY, MAXXTV(2))
      ISCX = (ISCX / SCXINC) * SCXINC
      ISCY = (ISCY / SCYINC) * SCYINC
      MAGPOW = 2 ** TVZOOM(1)
      BUFFER(1) = (TVZOOM(2)-1.0) * (MAGPOW-1.0) / REAL(MAGPOW)
      BUFFER(2) = (MAXXTV(2) - TVZOOM(3)) * (MAGPOW-1.0) / REAL(MAGPOW)
      BUFFER(1) = BUFFER(1) + ISCX
      BUFFER(2) = BUFFER(2) + ISCY
      IF (BUFFER(1).LT.0) BUFFER(1) = BUFFER(1) + MAXXTV(1)
      IF (BUFFER(2).LT.0) BUFFER(2) = BUFFER(2) + MAXXTV(2)
      IF (BUFFER(1).GT.MAXXTV(1)) BUFFER(1) = BUFFER(1) - MAXXTV(1)
      IF (BUFFER(2).GT.MAXXTV(2)) BUFFER(2) = BUFFER(2) - MAXXTV(2)
      BUFFER(1) = BUFFER(1) + 4096 * TVZOOM(1)
      BUFFER(2) = BUFFER(2) + 4096 * TVZOOM(1)
      ITEMP = 2 ** NGRAY - 1
      IC = ZAND (CHANNL, ITEMP)
      ZMASK = IC
C                                       Header & IO
C                                       The LSB of T register is set to
C                                       update scroll on M75.
      CALL YMKHDR ('WRIT', UNIT, COMAND, BUFSIZ, 0, 0, ZMASK, TMASK,
     *   VRTRTC, HEADER)
      NB = 2 * BUFSIZ
      CALL ZM70XF ('WRIT', NB, HEADER, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Wrap around graphics channel
C                                       to display graphics.
      IF (IC.NE.CHANNL) IC = ZOR (IC, BIT16)
      CALL ZGTBIT (16, IC, BITS)
      IF (BITS(16).EQ.1) THEN
         ZMASK = 128
C                                       Increment BUFFER(1) and
C                                       BUFFER(2) by 800 hex
         BUFFER(1) = BUFFER(1) + 2048
         BUFFER(2) = BUFFER(2) + 2048
C                                       The LSB of T register is set to
C                                       update scroll on M75.
         CALL YMKHDR ('WRIT', UNIT, COMAND, BUFSIZ, 0, 0, ZMASK, TMASK,
     *      VRTRTC, HEADER)
         NB = 2 * BUFSIZ
         CALL ZM70XF ('WRIT', NB, HEADER, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Reset common scroll record
      DO 10 I = 1,NGRAY
         IF (BITS(I).EQ.1) THEN
            TVSCRX(I) = -ISCX
            TVSCRY(I) = ISCY
            END IF
 10      CONTINUE
      IF (BITS(16).EQ.1) THEN
         TVSCRX(NGRAY+1) = -ISCX
         TVSCRY(NGRAY+1) = ISCY
         END IF
C
 999  RETURN
      END

      SUBROUTINE ICOPEN (IPLANE, LUN, IND, IERR)
C-----------------------------------------------------------------------
C! opens image catalog for the specified image plane (call from Y only)
C# Catalog
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Open the image catalog file appropriate to TV plane IPLANE:
C   This routine should only be called by YC.... routines since the
C   image catalog may not be on the local computer (as assumed by this
C   routine).  ONLY FOR TVs - no longer for TK devices.
C   Inputs:
C      IPLANE   I     Image plane # = 1 to NGRAY + NGRAPH + NTKDEV
C      LUN      I     Logical unit no. to use for file
C   Outputs:
C      IND      I     Pointer to FTAB for this file
C      IERR     I     Error return:  0 => o.k.
C                         10 => access not allowed for this POPS #
C                         11 => not for TK devices
C                         > 0 => error return from ZOPEN
C-----------------------------------------------------------------------
      INTEGER   IPLANE, LUN, IND, IERR
C
      CHARACTER INAME*48
      INTEGER   NC
      LOGICAL   T, F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA T, F /.TRUE., .FALSE./
C-----------------------------------------------------------------------
C                                       Is access allowed?
      IERR = 10
      NC = NGRAY + NGRAPH
      IF ((NTVDEV.LE.0) .AND. (IPLANE.LE.NC)) GO TO 999
      IF ((NTKDEV.LE.0) .AND. (IPLANE.GT.NC)) GO TO 999
C                                       Open TV image catalog
      IF (IPLANE.LE.NC) THEN
         NC = NTVDEV
         CALL ZPHFIL ('IC', 1, 0, NC, INAME, IERR)
         CALL ZOPEN (LUN, IND, 1, INAME, F, T, T, IERR)
      ELSE
         IERR = 11
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZCMPR2 (FCB, PNAME, NBLCKS, MAP, SYSERR, IERR)
C-----------------------------------------------------------------------
C! truncate a disk file, returning blocks to the system
C# Z2 IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Truncates a disk file.  It is assumed that the file is open.
C   Inputs:
C      FCB     I(*)   File descriptor from FTAB file control block
C      PNAME   H*48   File name (Hollerith for Macro, C, ...)
C      MAP     I      I/O type: 0 => non-map (single buffered)
C                               1 => map (double buffered)
C   In/out:
C      NBLCKS  I      Desired/actual size in 256-integer blocks
C   Output:
C      IERR    I      Error code: 0 = success
C                        1 = file name translation fails
C                        2 = error occurred
C                        3 = temporary file not deleted
C   Generic version - stub
C-----------------------------------------------------------------------
      INTEGER   FCB(*), MAP, NBLCKS, SYSERR, IERR
      HOLLERITH PNAME(12)
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'ZCMPR2 REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (9)
C
 999  RETURN
      END

      SUBROUTINE YINIT (SCRTCH, IERR)
C-----------------------------------------------------------------------
C! initialize everything about the TV
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YINIT initializes the TV subunits and image catalog
C   Output:
C      SCRTCH  I(1024)    scratch buffer
C      IERR    I          error code of Z...XF - 0 => ok
C                                                2 => input error
C   DeAnza version
C-----------------------------------------------------------------------
      INTEGER   SCRTCH(*), IERR
C
      LOGICAL   T, F
      INTEGER   I, J, K, KOFF, IC, IB, ICRED(4), NWORD, NCON,
     *   VOCWRD, TRESET, TRSET, ITEMP
      REAL      RBUF(256)
C                                       Memory LUT control reg
      INTEGER   GRALUT, GRFLUT
C                                       For cursor definition
      INTEGER   TYPCUR, CURPAR(5)
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:YDEA.INC'
      DATA T, F /.TRUE.,.FALSE./
C                                       VOC control word: Cursor enable
C                                       Graphics enable, XY hardware
C                                       split screen enable = Z4103
      DATA NCON, VOCWRD /10, 16643/
C                                       Memory LUT control word: Gray
C                                       scale-enable LUT, no graphics
C                                       Graphics-disable LUT, graphics
C                                       bit on = Z1000, Z0400
      DATA GRALUT, GRFLUT /4096, 1024/
C                                       Track ball reset, set
C     DATA TRESET, TRSET /Z0040, Z0061/
      DATA TRESET, TRSET /64, 97/
C-----------------------------------------------------------------------
C                                       setup non-channel units
C                                       Initialize interface registers
      NWORD = IRBYTE / 2
      CALL FILL (NWORD, 0, YBUFF(INTREG))
C                                       Resolution reg: single byte xfer
      YBUFF(RES) = 64
C                                       Max registers, full size
      YBUFF(XMAX)  = MAXXTV(1) - 1
      YBUFF(XAMAX) = YBUFF(XMAX)
      YBUFF(DX)    = YBUFF(XMAX)
      YBUFF(YMAX)  = MAXXTV(2) - 1
      YBUFF(YAMAX) = YBUFF(YMAX)
      YBUFF(DY)    = YBUFF(YMAX)
C                                       Write it out
      CALL ZDEAXF ('LR  ', YBUFF(INTREG), IRBYTE, 1, NCON, T, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Set up VOC
C                                       XY split=0
      CALL FILL (4, 0, YBUFF(VOCREG))
      YBUFF(VOCCON) = VOCWRD
      CALL ZDEAXF ('LVR ', YBUFF(VOCREG), VCBYTE, 0, 0, T, IERR)
C                                       cursor off but linked
      CALL YCRCTL ('WRIT', F, 256, 256, T, T, 0, I, F, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       OFM
      DO 10 I = 1,256
         RBUF(I) = (I - 1) / 255.0
 10      CONTINUE
      CALL YOFM ('WRIT', 7, F, RBUF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       zoom to null
      CALL YZOOMC (0, 256, 256, F, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Connect cursor to trackball
      CALL ZDEAXF ('LPR ', TRESET, 2, 0, 1, T, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZDEAXF ('LPR ', TRSET,  2, 0, 1, T, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       build plus sign cursor
      TYPCUR = 1
      CALL FILL (5, 0, CURPAR)
      CURPAR(1) = 64
      CURPAR(2) = 64
      CALL YMKCUR (TYPCUR, CURPAR, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       channel level
C                                       construct bit mask
C                                       CHAN: luts and scroll
C                                       Set up bit mask
      I = 1
      J = NGRAY + NGRAPH
      IC = 2**J - 1
C                                       Reset memory registers,
      DO 20 K = 1,J
         IF (K.GT.NGRAY+1) GO TO 15
            KOFF = 4 * (K - 1)
C                                       Scroll zero
            YBUFF(KOFF+XSCZ) = 0
            YBUFF(KOFF+YSCZ) = 511
C                                       All bit planes enabled
            YBUFF(KOFF+BITPL) = -1
C                                       LUT control gray or graph
            IF (K.LE.NGRAY) THEN
               YBUFF(KOFF+MEMLUT) = GRALUT
            ELSE
               YBUFF(KOFF+MEMLUT) = GRFLUT
               END IF
C                                       Write it
            ITEMP = K - 1
            CALL ZDEAXF ('LMC ', YBUFF(KOFF+XSCZ), 8, ITEMP, 0, T, IERR)
            IF (IERR.NE.0) GO TO 999
            TVSCRX(K) = 0
            TVSCRY(K) = 0
C                                       ZERO memory
 15      CALL YZERO (K, IERR)
         IF (IERR.NE.0) GO TO 999
 20      CONTINUE
C                                       Fill LUTs, IC=channel bit mask
      DO 30 I = 1,256
         SCRTCH(I) = I - 1
 30      CONTINUE
      CALL YLUT ('WRIT', IC, 7, F, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL MOVIST ('OFFF', IC, 0, 0, 0, IERR)
C                                       RESTore common values
C                                       zoom, scroll, split pts
      CALL YGRAPH ('INIT', 8, SCRTCH, IERR)
      CALL FILL (256, 0, SCRTCH)
      CALL YGGRAM ('WRIT', F, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL YGRAPH ('ONNN', 8, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       split pts and chan 1 on
      CALL FILL (4, 1, ICRED)
      TVSPLT(1) = MAXXTV(1)/2
      TVSPLT(2) = MAXXTV(2)/2
      CALL YSPLIT ('WRIT', TVSPLT(1), TVSPLT(2), ICRED, ICRED, ICRED, F,
     *   IERR)
      CALL FILL (4, 1, TVLIMG)
      TVSPLM = 0
      TVSPLC = 0
C                                       Clear image catalog
      IB = NGRAY + NGRAPH
      DO 40 IC = 1,IB
         CALL YCINIT (IC, SCRTCH)
 40      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ZPASWD (PASS, BUFF, IERR)
C-----------------------------------------------------------------------
C! prompt user and read 12-character password (invisible) from CRT
C# Z Terminal System
C-----------------------------------------------------------------------
C;  Copyright (C) 2004, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZPASWD prompts the user on his terminal with the prompt string
C   "Password: " and then reads back a 12-character "password" without
C   anything being visible on the screen.
C   Outputs:
C      PASS   C*12     Password - 12 unpacked characters: left
C                                 justigied and blank filled.
C      BUFF   I(256)   Scratch buffer (if needed)
C      IERR   I        Error code: 0 => ok
C                         ??? => I/O error of some sort
C   Generic version - calls ZPRPAS with HOLLERITH or CHARACTER (VMS)
C      VMS COMMENTED OUT
C-----------------------------------------------------------------------
      CHARACTER PASS*12
      INTEGER   BUFF(256), IERR
C
      HOLLERITH HPASS(3)
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C     IF (SYSTYP.EQ.'VMS') THEN
C        CALL ZPRPAS (PASS, BUFF, IERR)
C     ELSE
         CALL ZPRPAS (HPASS, BUFF, IERR)
         CALL H2CHR (12, 1, HPASS, PASS)
C        END IF
C
 999  RETURN
      END

      SUBROUTINE GCALC2 (VOBS, IS, JS, WT, NUMBL, REFANT, MODE, MINNO,
     *   G, GSOLV, NREF, WORK, PRTLV, FFLIM, FFLAST, FRAC, RMS, IERR)
C-----------------------------------------------------------------------
C! Gain Soln: Compute least squares gains for a subset of the data
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2004-2005
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GCALC computes antenna gains given visibilities divided by the
C   model values.
C   Inputs:
C      VOBS     R(2,*)   Averaged visibility (real, imaginary)
C      IS       I(*)     Array of first antenna numbers.
C      JS       I(*)     Array of second antenna numbers.
C      NUMBL    I        Number of observations.
C      REFANT   I        Desired reference antenna.
C      MODE     I        Solution mode: 0 = full gain soln.
C                           1 = phase only keep ampl. info.
C                           2 = phase only discard ampl. info.
C                           4-6 => 0-2 with robustness
C                        + 10 * weight func (1 sqrt, 2 4th root, 3 -> 1
C      MINNO    I        Min. number of antennas acceptable.
C      GSOLV    L(*)     Array of antenna subset to solve for.
C      PRTLV    I        Print level,   0 = none
C                           1 = print (MSGWRT) soln.
C                           2 = print RMS at each iteration
C                           3 = print data plus soln.
C      FFLIM    R        Limit clip to max (std, FFLIM) * rms
C      FFLAST   R        Mark bad those data with closure error >
C                        FFLAST * rms closure error on last iteration
C   In/out:
C      WT       R(*)     Array of visibility weights - adjusted for
C                        amplitude normalizations and weight function
C   Outputs:
C      G        R(2,*)   Antenna gains to be applied (real, imaginary)
C      WORK     R(*)     Work array the size of VOBS
C      NREF     I        Reference antenna used.
C      FRAC     R        Fraction of data excluded in robust solution
C      RMS      R        RMS closure error
C      IERR     I        Return error code 0 = OK
C                           1 = no valid data
C                           2 = didn't converge
C                           3 = too few antennas
C-----------------------------------------------------------------------
      INTEGER   IS(*), JS(*), NUMBL, REFANT, MODE, MINNO, NREF, PRTLV,
     *   IERR
      LOGICAL   GSOLV(*)
      REAL      VOBS(2,*), WT(*), G(2,*), WORK(2,*), FFLIM, FFLAST,
     *   FRAC, RMS
C
      INTEGER   ITRMAX
      PARAMETER (ITRMAX = 10)
C
      REAL      GNG(2), Z(2), ZR, ZI, AMP, GD, PH, QQ, S, SUMWT, TOL, W,
     *   X, XX, XXX, YY, ARG, XFAIL, XFAIL1, XFAIL2, FF(ITRMAX),
     *   GG(ITRMAX)
      INTEGER   I, II, IT, J, JJ, K, NIT, NT, NTD, LMODE, LWT, MAXANS,
     *   ITMAX, NFAIL, LIMIT, LOOP, ITRMIN, ITER
      LOGICAL   CONVGD, T, F, DORMS
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ANDX1(MAXANT,MAXANT), ANDX2(MAXANT,MAXANT),
     *   ACNT1(MAXANT), ACNT2(MAXANT)
      REAL      GN(2,MAXANT), GLAST(2,MAXANT), SWT(MAXANT), TEMP2,
     *   TEMP3, GRREAL, GRIMAG
      INCLUDE 'INCS:DMSG.INC'
      COMMON /GLASTS/ GLAST
      DATA T, F /.TRUE.,.FALSE./
      DATA GG /7.0, 5.0, 4.0, 3.5, 3.0, 2.8, 2.6, 2.4, 2.2, 2.5/
C-----------------------------------------------------------------------
      IERR = 1
      IF (NUMBL.LE.0) GO TO 999
      CALL RCOPY (ITRMAX, GG, FF)
      DO 5 I = 1,ITRMAX
         FF(I) = MAX (FF(I), FFLIM)
 5       CONTINUE
      IF (FFLAST.GE.1.0) FF(ITRMAX) = FFLAST
C                                       interpret mode
      LMODE = MOD (MODE, 10)
      ITRMIN = ITRMAX
      IF (LMODE.GT.3) THEN
         ITRMIN = 1
         LMODE = LMODE - 4
         END IF
      LWT = MODE / 10
C                                       inits
      MAXANS = MAXANT
      ITMAX = 60
      TOL = 5.0E-6
      NT = 0
      NTD = 0
      SUMWT = 0.0
      DO 10 I = 1,MAXANS
         SWT(I) = 0.0
         ACNT1(I) = 0
         ACNT2(I) = 0
 10      CONTINUE
C                                       Find which antennae have data
C                                       and normalize to unit amplitude
C                                       if requested.
      DO 20 K = 1,NUMBL
         I = IS(K)
         J = JS(K)
         NT = MAX (NT, J)
         XXX = SQRT ((VOBS(1,K)*VOBS(1,K)) + (VOBS(2,K)*VOBS(2,K)))
         IF (XXX.LE.1.0E-20) WT(K) = 0.
         IF (WT(K).GT.1.0E-20) THEN
            IF (LMODE.EQ.2) THEN
               VOBS(1,K) = VOBS(1,K) / XXX
               VOBS(2,K) = VOBS(2,K) / XXX
               WT(K) = WT(K) * XXX * XXX
               END IF
            CALL REWAIT (LWT, WT(K))
            SWT(I) = SWT(I) + WT(K)
            SWT(J) = SWT(J) + WT(K)
            SUMWT = SUMWT + WT(K)
C                                       Save weighted data in WORK
            WORK(1,K) = WT(K) * VOBS(1,K)
            WORK(2,K) = WT(K) * VOBS(2,K)
C                                       Antenna index tables
            ACNT1(I) = ACNT1(I) + 1
            II = ACNT1(I)
            ANDX1(II,I) = K
            ACNT2(J) = ACNT2(J) + 1
            JJ = ACNT2(J)
            ANDX2(JJ,J) = K
         ELSE
            WT(K) = 0.0
            WORK(1,K) = 0.0
            WORK(2,K) = 0.0
            END IF
 20      CONTINUE
C                                       No data
      IF (SUMWT.LE.1.0E-20) GO TO 999
C                                       Print data if nec.
      IF (PRTLV.GE.3) THEN
         DO 30 K = 1,NUMBL
            IF (WT(K).GT.1.0E-20) THEN
               AMP = SQRT (VOBS(1,K)*VOBS(1,K) + VOBS(2,K)*VOBS(2,K))
               PH = 57.296 * ATAN2 (VOBS(2,K), VOBS(1,K)+1.0E-20)
               WRITE (MSGTXT,1000) K, AMP, PH, IS(K), JS(K), WT(K)
               CALL MSGWRT (3)
               END IF
 30         CONTINUE
         END IF
C                                       Initialize solutions
      DO 40 I = 1,MAXANS
         G(1,I) = 1.0
         G(2,I) = 0.0
         GLAST(1,I) = 1.0
         GLAST(2,I) = 0.0
         IF (SWT(I).GT.1.0E-20) NTD = NTD + 1
 40      CONTINUE
      DORMS = (2.5*(NTD-1).LE.NUMBL)
C                                       Pick reference ant.
C                                       Require the ref.ant. to be
C                                       selected via ANTENNAS
      NREF = REFANT
      IF ((NREF.GE.1) .AND. (NREF.LE.MAXANS) .AND. (GSOLV(NREF)))
     *   NREF = 0
      IF ((NREF.LT.1) .OR. (NREF.GT.MAXANS) .OR. (SWT(NREF).LE.0.))
     *   THEN
         NREF = 0
         XX = 0.0
         DO 50 I = 1,NT
            IF ((.NOT.GSOLV(I)) .AND. (SWT(I).GT.XX)) THEN
               XX = SWT(I)
               NREF = I
               END IF
 50         CONTINUE
C                                       If nothing made it through,
C                                       then all good antennas are being
C                                       solved for, choose the one
C                                       with the most weight and un-choose
C                                       that one
         IF (NREF.LE.0) THEN
            XX = 0.0
            DO 55 I = 1,NT
               IF (SWT(I).GT.XX) THEN
                  XX = SWT(I)
                  NREF = I
                  END IF
 55            CONTINUE
            GSOLV(NREF) = .FALSE.
            END IF
         END IF
C                                       Robust iteration
 100  IF (.NOT.DORMS) ITRMIN = ITRMAX
      DO 400 ITER = ITRMIN,ITRMAX
C                                       Too few antennas
         IF (NTD.LT.MINNO) THEN
            IERR = 3
            GO TO 999
            END IF
C                                       Print statistics
         IF (PRTLV.GE.2) THEN
C                                       Sum chi squares
            S = 0.0
            XXX = 1.0
            DO 110 K = 1,NUMBL
               IF (WT(K).GT.0.0) THEN
                  II = IS(K)
                  JJ = JS(K)
                  Z(1) = G(1,JJ)
                  Z(2) = - G(2,JJ)
                  ZR = G(1,II) * Z(1) - G(2,II) * Z(2)
                  ZI = G(1,II) * Z(2) + G(2,II) * Z(1)
                  IF (LMODE.EQ.1) XXX = SQRT ((VOBS(1,K)*VOBS(1,K)) +
     *               (VOBS(2,K)*VOBS(2,K)))
                  Z(1) = VOBS(1,K)/XXX - ZR
                  Z(2) = VOBS(2,K)/XXX - ZI
                  QQ = Z(1) * Z(1) + Z(2) * Z(2)
                  S = S + WT(K) * QQ
                  END IF
 110           CONTINUE
            RMS = SQRT (S/SUMWT)
            IT = 0
            WRITE (MSGTXT,1110) IT, S, RMS
            CALL MSGWRT (3)
            END IF
C                                       Begin solution iteration
         DO 290 IT = 1,ITMAX
            IF (IT.GT.15) TOL = (IT - 10) * 1.0E-6
            NIT = IT
C                                       Following for amplitude and
C                                       phase solution.
            IF (LMODE.LE.0) THEN
               IF (IT.EQ.1) W = .5
               IF (IT.EQ.2) W = .75
               IF (IT.GT.2) W = .9
               IF (IT.GT.10) W = .5
               IF (NTD.LE.6) W = .25
               DO 150 I = 1,NT
                  IF ((SWT(I).EQ.0) .OR. (.NOT.GSOLV(I))) GO TO 150
                  GNG(1) = 0.
                  GNG(2) = 0.
                  GD = 0.
C                                       I is first antenna
                  LIMIT = ACNT1(I)
                  DO 120 LOOP = 1,LIMIT
                     K = ANDX1(LOOP,I)
                     IF (WT(K).GT.0.0) THEN
                        JJ = JS(K)
                        Z(1) = G(1,JJ)
                        Z(2) = G(2,JJ)
                        QQ = Z(1) * Z(1) + Z(2) * Z(2)
                        GD = GD + WT(K) * QQ
                        GNG(1) = GNG(1) +
     *                     (G(1,JJ) * WORK(1,K) - G(2,JJ) * WORK(2,K))
                        GNG(2) = GNG(2) +
     *                     (G(1,JJ) * WORK(2,K) + G(2,JJ) * WORK(1,K))
                        END IF
 120                 CONTINUE
C                                       I is second antenna:
                  LIMIT = ACNT2(I)
                  DO 130 LOOP = 1,LIMIT
                     K = ANDX2(LOOP,I)
                     IF (WT(K).GT.0.0) THEN
                        II = IS(K)
                        Z(1) = G(1,II)
                        Z(2) = G(2,II)
                        QQ = Z(1) * Z(1) + Z(2) * Z(2)
                        GD = GD + WT(K) * QQ
                        GNG(1) = GNG(1) +
     *                     (G(1,II) * WORK(1,K) + G(2,II) * WORK(2,K))
                        GNG(2) = GNG(2) +
     *                     (G(2,II) * WORK(1,K) - G(1,II) * WORK(2,K))
                        END IF
 130                 CONTINUE
                  G(1,I) = G(1,I) + W * (GNG(1) / GD - G(1,I))
                  G(2,I) = G(2,I) + W * (GNG(2) / GD - G(2,I))
 150              CONTINUE
C                                       Following for phase only.
            ELSE
               DO 210 I = 1,NT
                  GN(1,I) = 0.0
                  GN(2,I) = 0.0
 210              CONTINUE
               W = .8
               IF (NTD.LE.6) W = .25
C                                       do sums
               DO 220 K = 1,NUMBL
C                                       Z = G(II) * CONJG (G(JJ)) *
C                                           CONJG (WORK(K))
                  IF (WT(K).GT.0.0) THEN
                     II = IS(K)
                     JJ = JS(K)
                     ZR = G(1,II) * G(1,JJ) + G(2,II) * G(2,JJ)
                     ZI = G(2,II) * G(1,JJ) - G(1,II) * G(2,JJ)
                     TEMP2 = ZR * WORK(1,K) + ZI * WORK(2,K)
                     TEMP3 = ZI * WORK(1,K) - ZR * WORK(2,K)
C                                       GN(II) = GN(II) + Z
                     GN(1,II) = GN(1,II) + TEMP2
                     GN(2,II) = GN(2,II) + TEMP3
C                                       GN(JJ) = GN(JJ) + CONJG (Z)
                     GN(1,JJ) = GN(1,JJ) + TEMP2
                     GN(2,JJ) = GN(2,JJ) - TEMP3
                     END IF
 220              CONTINUE
C                                       Update solutions
               DO 230 I = 1,NT
                  IF ((GSOLV(I)) .AND. (SWT(I).GT.0.0)) THEN
                     XX = ATAN2 (G(2,I), G(1,I))
                     YY = ATAN2 (GN(2,I), GN(1,I)+1.0E-30)
                     ARG = XX - YY
                     G(1,I) = COS (ARG)
                     G(2,I) = SIN (ARG)
                     END IF
 230              CONTINUE
               END IF
C                                       Convergence test
            CONVGD = T
            NFAIL = 0
            XFAIL = TOL
            DO 250 I = 1,NT
               IF ((SWT(I).GT.0.) .AND. (GSOLV(I))) THEN
                  IF (IT.LE.30) THEN
                     IF (CONVGD) THEN
                        X = TOL * (5.0E-7 + SQRT (G(1,I)*G(1,I) +
     *                     G(2,I)*G(2,I)))
                        IF (ABS (G(1,I)-GLAST(1,I)).GT.X) CONVGD = F
                        IF (ABS (G(2,I)-GLAST(2,I)).GT.X) CONVGD = F
                        END IF
C                                       Use different criteria after
C                                       30 iterations
                  ELSE
                     XFAIL1 = ABS (G(1,I) - GLAST(1,I))
                     XFAIL2 = ABS (G(2,I) - GLAST(2,I))
                     XFAIL1 = MAX (XFAIL1, XFAIL2)
                     X = TOL * (5.0E-7 + SQRT (G(1,I)*G(1,I) +
     *                  G(2,I)*G(2,I)))
                     IF (XFAIL1.GT.X) THEN
                        CONVGD = F
                        NFAIL = NFAIL + 1
                        IF ((XFAIL1/X).GE.XFAIL) XFAIL = XFAIL1 / X
                        END IF
                     END IF
                  END IF
               GLAST(1,I) = G(1,I)
               GLAST(2,I) = G(2,I)
 250           CONTINUE
C                                       Find statistics
            S = 0.0
            XXX = 1.0
            DO 260 K = 1,NUMBL
               IF (WT(K).GT.0.0) THEN
                  II = IS(K)
                  JJ = JS(K)
                  Z(1) = G(1,JJ)
                  Z(2) = - G(2,JJ)
                  ZR = G(1,II) * Z(1) - G(2,II) * Z(2)
                  ZI = G(1,II) * Z(2) + G(2,II) * Z(1)
                  IF (LMODE.EQ.1) XXX = SQRT ((VOBS(1,K)*VOBS(1,K)) +
     *               (VOBS(2,K)*VOBS(2,K)))
                  Z(1) = VOBS(1,K)/XXX - ZR
                  Z(2) = VOBS(2,K)/XXX - ZI
                  QQ = Z(1) * Z(1) + Z(2) * Z(2)
                  S = S + WT(K) * QQ
                  END IF
 260           CONTINUE
            RMS = SQRT (S/SUMWT)
            IF (PRTLV.GE.2) THEN
               WRITE (MSGTXT,1110) IT, S, RMS
               CALL MSGWRT (3)
               END IF
            IF (CONVGD) GO TO 300
            IF ((IT.GT.30) .AND. (NFAIL.LE.1) .AND. (XFAIL.LE.10.))
     *         GO TO 300
C                                       End of iteration loop
 290        CONTINUE
C                                       Didn't converge
         IERR = 2
         GO TO 999
C                                       converged: what to use this time
 300     SUMWT = 0.0
         CALL RFILL (MAXANS, 0.0, SWT)
         XXX = 1.0
         IF (.NOT.DORMS) RMS = 1.0E10
         DO 310 K = 1,NUMBL
            II = IS(K)
            JJ = JS(K)
            IF (WT(K).NE.0.0) THEN
               WT(K) = ABS (WT(K))
               Z(1) = G(1,JJ)
               Z(2) = - G(2,JJ)
               ZR = G(1,II) * Z(1) - G(2,II) * Z(2)
               ZI = G(1,II) * Z(2) + G(2,II) * Z(1)
               IF (LMODE.EQ.1) XXX = SQRT ((VOBS(1,K)*VOBS(1,K)) +
     *            (VOBS(2,K)*VOBS(2,K)))
               Z(1) = ABS (VOBS(1,K)/XXX - ZR) / RMS
               Z(2) = ABS (VOBS(2,K)/XXX - ZI) / RMS
               IF (((Z(1).GT.FF(ITER)) .OR. (Z(2).GT.FF(ITER))) .AND.
     *            (DORMS)) THEN
                  WT(K) = -WT(K)
               ELSE
                  SWT(II) = SWT(II) + WT(K)
                  SWT(JJ) = SWT(JJ) + WT(K)
                  SUMWT = SUMWT + WT(K)
                  END IF
               END IF
 310        CONTINUE
 400     CONTINUE
      IERR = 0
      IF (.NOT.DORMS) RMS = 0.0
C                                       fraction excluded
      XX = 0.0
      YY = 0.0
      DO 410 K = 1,NUMBL
         IF (WT(K).NE.0.0) THEN
            XX = XX + 1.0
            IF (WT(K).LT.0.0) YY = YY + 1.0
            END IF
 410     CONTINUE
      FRAC = 1.0
      IF (XX.GT.0.0) FRAC = YY / XX
C                                       Refer solutions to reference
C                                       antenna.
      GRREAL = G(1,NREF)
      GRIMAG = G(2,NREF)
      XXX = SQRT (GRREAL*GRREAL + GRIMAG*GRIMAG)
      GRREAL = GRREAL / XXX
      GRIMAG = GRIMAG / XXX
      DO 420 I = 1,NT
         IF ((GSOLV(I)) .AND. (SWT(I).GT.1.0E-20)) THEN
            ZR = G(1,I) * GRREAL + G(2,I) * GRIMAG
            ZI = G(2,I) * GRREAL - G(1,I) * GRIMAG
            G(1,I) = ZR
            G(2,I) = ZI
         ELSE
            G(1,I) = 1.0
            G(2,I) = 0.0
            END IF
 420     CONTINUE
      G(1,NREF) = XXX
      G(2,NREF) = 0.0
C                                       Print results.
      IF (PRTLV.GE.1) THEN
         DO 430 I = 1,NT
            IF (SWT(I).GT.1.0E-20) THEN
               AMP = SQRT (G(1,I)*G(1,I) + G(2,I)*G(2,I))
               PH = 57.2958 * ATAN2 (G(2,I), G(1,I))
               WRITE (MSGTXT,1420) I, AMP, PH
               CALL MSGWRT (3)
               END IF
 430        CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I4,' Amp =',1PE12.3,' Phase =',0PF7.1,2I3,1PE12.3)
 1110 FORMAT ('Iter=',I5,' s=',1PE15.5,' RMS=',1E15.5)
 1420 FORMAT ('Ant=',I5,' Amp=',F12.5,' Phase=',F12.2)
      END

      SUBROUTINE YDTVC (OP, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! Read/write TV parameter common
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1996-1997, 2008
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   YDTVC gets or saves the TV device parameter common
C   Input:
C      OP      C*4      'READ' parameters, comment if changed
C                       'GET ' = 'READ' with no comments
C                       'WRIT' parameters to save area (disk or TV)
C                       'OPEN' open access to TV (disk lock or ..)
C                       'CLOS' clsoe access to TV
C   Output:
C      SCRTCH  I(256)   scratch buffer
C      IERR    I          error code of Z...XF - 0 => ok
C                                                2 => input error
C                                                4 => in use on open
C   In/out:
C      DTVC.INC common
C   XAS (SSS) Version - parameters are in XAS, locking done by daemon
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   SCRTCH(*), IERR
C
      INTEGER   I, OPCODE, DAT(4), NWSD, TVT(256)
      CHARACTER PARTYP(21)*6
      REAL      TEMP
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (TVT(1), NGRAY)
      DATA PARTYP /'NGrey','NGraph','NImage','MaxinX','MaxinY','MxGrey',
     *   'LUTout','OFMin','OFMout','ScrinX','ScrinY','MxZoom','Split?',
     *   'ALUnum','WriteX','WriteY','ISUnum','TV3col','XAScat','ChrinX',
     *   'ChrinY'/
C-----------------------------------------------------------------------
C                                       permission to continue?
      IF (OP.EQ.'OPEN') THEN
         CALL ZSSSLK ('LOCK', IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.4)) THEN
            WRITE (MSGTXT,1000) 'LOCK', IERR
            CALL MSGWRT (6)
            END IF
C                                       give it up
      ELSE IF (OP.EQ.'CLOS') THEN
         CALL ZSSSLK ('UNLK', IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) 'UNLOCK', IERR
            CALL MSGWRT (6)
            IERR = 0
            END IF
C                                       request the status
      ELSE IF ((OP.EQ.'READ') .OR. (OP.EQ.'GET ')) THEN
C                                       was 13
         OPCODE = 10
         CALL FILL (4, 0, DAT)
         CALL ZSSSXF (OPCODE, DAT, 0, SCRTCH, NWSD, IERR)
         IF ((NWSD.NE.1024) .AND. (IERR.EQ.0)) IERR = 11
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            IF (IERR.EQ.11) WRITE (MSGTXT,1011) NWSD
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       any changes in 1-21 ?
         IF (OP.EQ.'READ') THEN
            CALL ZI32IL (256, 1, SCRTCH, SCRTCH)
            DO 10 I = 1,21
               IF ((SCRTCH(I).LT.0) .AND. (I.NE.12)) GO TO 10
               IF ((SCRTCH(I).EQ.0) .AND. (I.LE.14)) GO TO 10
               IF (SCRTCH(I).NE.TVT(I)) THEN
                  WRITE (MSGTXT,1015) PARTYP(I), TVT(I), SCRTCH(I)
                  CALL MSGWRT (6)
                  TVT(I) = SCRTCH(I)
                  END IF
 10            CONTINUE
            CALL COPY (235, SCRTCH(22), TVT(22))
         ELSE
            CALL ZI32IL (256, 1, SCRTCH, TVT)
            END IF
         IF (TVT(22).GT.0) THEN
            TEMP = TVT(22) / 1000.0
            TVGAMA = TEMP
            IF (TVGAMA.LT.0.1) TVGAMA = 2.2
         ELSE
            TVGAMA = 2.2
            END IF
C                                       send the status
      ELSE IF (OP.EQ.'WRIT') THEN
C                                       was 17
         OPCODE = 36
         CALL FILL (4, 0, DAT)
         CALL COPY (256, TVT, SCRTCH)
         SCRTCH(22) = TVGAMA * 1000.0 + 0.5
         CALL ZILI32 (256,  SCRTCH, 1, SCRTCH)
         CALL ZSSSXF (OPCODE, DAT, 1024, SCRTCH, NWSD, IERR)
C                                       bad op
      ELSE
         IERR = 2
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ON ',A,' ERROR',I5,' FROM ZSSSLK')
 1010 FORMAT ('ERROR',I5,' REQUESTING PARAMETERS FROM SCREEN SERVER')
 1011 FORMAT ('ONLY',I4,' PARAMETERS RETURNED FROM SCREEN SERVER!')
 1015 FORMAT ('TV parameter ',A,' has changed from',I5,' to',I5)
      END

      SUBROUTINE TABERR (OPCODE, ROUTIN, CALLRT, IERR)
C-----------------------------------------------------------------------
C! provides a standard error message for the table routines
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2001, 2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Provides a standard error message for the temporary table routines.
C   Messages will be suppressed if MSGSUP=32000 has been set
C   Inputs:
C      OPCODE   C*4   OPCODE being used in the table handling routine.
C      ROUTIN   C*6   Subroutine which returned the error code.
C      CALLRT   C*6   Name of calling subroutine
C      IERR     I     The error code returned by said subroutine.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*(*), ROUTIN*(*), CALLRT*(*)
      INTEGER   IERR
C
C     INTEGER   MSGKEP
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C     MSGKEP = MSGSUP
C     MSGSUP = 0
      WRITE (MSGTXT,1000) CALLRT, IERR, ROUTIN, OPCODE
      CALL MSGWRT (6)
C     MSGSUP = MSGKEP
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A,': ERROR ',I3,' FROM ',A,' OPCODE = ',A4)
      END

      SUBROUTINE ALSKEY (ALIST, KEYWRD, KEYPNT, IERR)
C-----------------------------------------------------------------------
C! PRIVATE: Lookup keyword in value from Associative list (ALIST)
C# Utility 
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Private to ALIST manager
C   Lookup keyword in ALIST; called by ALSGET and ALSPUT.
C   See ALSINI for details of the package.
C   Inputs:
C      ALIST   I(*)  ALIST
C      KEYWRD C*16   Keyword
C   Outputs:
C      KEYPNT  I     Address in ALIST array for keyword
C      IERR    I     Error code, 0=OK, 1=couldn't find
C-----------------------------------------------------------------------
      CHARACTER KEYWRD*(*)
      INTEGER   ALIST(*), KEYPNT, IERR
C
      INTEGER   ADDR, ITEST(4)
      HOLLERITH TEST(4)
      EQUIVALENCE (TEST, ITEST)
      INCLUDE 'INCS:PALIST.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Don't look if none exist.
      IF (ALIST(ALSEND).GT.1) THEN
C                                       Convert KEYWRD to HOLLERITH
         CALL CHR2H (16, KEYWRD, 1, TEST)
C                                       Find KEYWORD in ALIST, loop
C                                       until end of list.
         ADDR = ALIST(ALSBEG)
 50         KEYPNT = ADDR
            IF ((ITEST(1).EQ.ALIST(ADDR+ALSKWD))
     *         .AND. (ITEST(2).EQ.ALIST(ADDR+ALSKWD+1)).AND.
     *         (ITEST(3).EQ.ALIST(ADDR+ALSKWD+2)).AND.
     *         (ITEST(4).EQ.ALIST(ADDR+ALSKWD+3)))  GO TO 999 
C                                       End of list?
            ADDR = ALIST(ADDR)
            IF ((ADDR.GT.0) .AND. (ADDR.LT.ALIST(ALSIZE)) .AND.
     *         (ALIST(ADDR).GT.ADDR)) GO TO 50
            END IF
C                                       Not found
      IERR = 1
      GO TO 999
C
 999  RETURN
      END

LOCAL INCLUDE 'SYPRT.INC'
      HOLLERITH XNAMIN(3), XCLSIN(2), XSOUR(4,30), XCALC(1), XLPNAM(12),
     *   XOPTYP(1)
      REAL      DSKIN, SEQIN, XINVER, XQUAL, XBAND, XFREQ, XFQID, XSUBA,
     *   XTIME(8), XANT(50), XFGVER, DOCRT, XBIF, XEIF, XNDIG, FACTOR,
     *   DOSCAL, BADD(10)
      COMMON /INPARM/ XNAMIN, XCLSIN, SEQIN, DSKIN, XINVER, XSOUR,
     *   XQUAL, XCALC, XBAND, XFREQ, XFQID, XSUBA, XTIME, XANT, XFGVER,
     *   DOCRT, XLPNAM, XBIF, XEIF, XOPTYP, XNDIG, FACTOR, DOSCAL, BADD
      INTEGER   INDISK, INCNO, INVER, INSEQ, CDVER, DTYPE, CTYPE,
     *   LFGVER, SCRTCH(256), BUFFI(512), LUNP, FINDP, IPCNT, JP0,
     *   NACROS, MXS, NDIG
      REAL      BTIME, ETIME
      CHARACTER NAMEIN*12, CLASIN*6, LPNAME*48, OPTYPE*4,
     *   SRCS(1000)*16
      COMMON /PARMS/ INDISK, INCNO, INSEQ, INVER, CDVER, DTYPE, CTYPE,
     *   BTIME, ETIME, SCRTCH, BUFFI, LFGVER, LUNP, FINDP, IPCNT, JP0,
     *   NACROS, MXS, NDIG
      COMMON /PARMC/ NAMEIN, CLASIN, LPNAME, OPTYPE, SRCS
LOCAL END
LOCAL INCLUDE 'REPSYTAB.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NRECSY, ISYRNO, SYKOLS(MAXSYC), SYNUMV(MAXSYC), LUNSY,
     *   SSYVER
      REAL      PDIFF(2,MAXIF), PSUM(2,MAXIF), PGAIN(2,MAXIF),
     *   TCAL(4,MAXIF,MAXANT), VMIN(MAXANT), VMAX(MAXANT)
      COMMON /REPSYT/ NRECSY, ISYRNO, SYKOLS, SYNUMV, LUNSY, SSYVER,
     *   PDIFF, PSUM, PGAIN, TCAL, VMIN, VMAX
LOCAL END
      PROGRAM SYPRT
C-----------------------------------------------------------------------
C! Task to print values from SY table
C# EXT-util Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 2020, 2022, 2024-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SYPRT will convert an EVLA SY (SysPower) table plus the CalDevice
C   CD table into a Tsys column in a TY table.
C   Inputs:   (from AIPS)
C      INNAME    R(3)   name of primary file.
C      INCLASS   R(2)   class of primary file.
C      INSEQ     R      sequence number of primary file.
C      INDISK    R      disk volume number. 0 means try all.
C      INVERS    R      MF file version number
C      OUTVERS   R      ST file version number
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   IRET
C
      INTEGER   I
      CHARACTER SYNAME*48
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'SYPRT.INC'
      INCLUDE 'REPSYTAB.INC'
      DATA PRGNAM /'SYPRT'/
C-----------------------------------------------------------------------
C                                       start up
      CALL SYPRTI (PRGNAM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Read data 4 scale, print check
      CALL SYPRTA (NUMPOL, NUMIF, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Now do it
      CALL SYPRT2 (NUMPOL, NUMIF, IRET)
C                                       Clean up
      CALL FNDEXT ('SY', CATBLK, I)
      IF ((SSYVER.EQ.I) .AND. (SSYVER.NE.INVER)) THEN
         CALL ZPHFIL ('SY', INDISK, INCNO, SSYVER, SYNAME, I)
         CALL ZDESTR (INDISK, SYNAME, I)
         CALL DELEXT ('SY', INDISK, INCNO, 'WRWR', BUFFI, SCRTCH,
     *      SSYVER, I)
         END IF
C
C                                       close LP
 990  IF (LUNP.GT.0) THEN
         CALL LPCLOS (LUNP, FINDP, IPCNT, I)
         IF (I.GT.0) IRET = MAX (I, IRET)
         END IF
      IRET = MAX (0, IRET)
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE SYPRTI (PRGNAM, IRET)
C-----------------------------------------------------------------------
C   Inputs
C      PRGNAM   C*6   Task name
C   Outputs:
C      IRET     I     > 0 +> die on error
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*(*)
      INTEGER   IRET
C
      INTEGER   NTYPE
      PARAMETER (NTYPE=6)
C
      INTEGER   NPARMS, IERR, I, IROUND, LUN, LUNTMP, SUBA, FREQID, NIF,
     *   J, K, JTRIM
      LOGICAL   MATCH
      CHARACTER TYPIN*2, STAT*4, TYPES(NTYPE)*4
      INCLUDE 'SYPRT.INC'
      INCLUDE 'REPSYTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA TYPES /'DIFS', 'SUMS', 'TSYS', 'PDIF', 'PSUM', 'PSYS'/
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      LUNP = -1
C                                       get parameters, resume aips
      NPARMS = 222
      IRET = 0
      CALL GTPARM (PRGNAM, NPARMS, RQUICK, XNAMIN, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'GETTING ADVERBS'
         CALL MSGWRT (8)
         IRET = 8
         END IF
      IF ((IRET.NE.0) .OR. (NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   DOCRT = MIN (-1.0, DOCRT)
      CALL H2CHR (48, 1, XLPNAM, LPNAME)
      IF (DOCRT.GT.0.0) RQUICK = .FALSE.
      IF (RQUICK) RQUICK = LPNAME.NE.' '
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 990
      IRET = 8
C                                       interpret parameters
      CALL H2CHR (12, 1, XNAMIN, NAMEIN)
      CALL H2CHR (6, 1, XCLSIN, CLASIN)
      INSEQ = SEQIN + 0.1
      INDISK = DSKIN + 0.1
      INVER = XINVER + 0.1
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      CALL H2CHR (4, 1, XCALC, SELCOD)
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      SUBARR = IROUND (XSUBA)
      SUBARR = MAX (1, SUBARR)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      DTYPE = 0
      DO 20 I = 1,NTYPE
         IF (OPTYPE.EQ.TYPES(I)) DTYPE = I
 20      CONTINUE
      IF (DTYPE.GT.3) DTYPE = DTYPE - 3
      OPTYPE = TYPES(DTYPE)
      BTIME = ((XTIME(4)/60.+XTIME(3))/60.0 + XTIME(2))/24.0 + XTIME(1)
      ETIME = ((XTIME(8)/60.+XTIME(7))/60.0 + XTIME(6))/24.0 + XTIME(5)
      IF (BTIME.EQ.0.0) BTIME = -1000.
      IF (ETIME.EQ.0.0) ETIME = 10000.
C                                       antennas
      NANTSL = 0
      DOAWNT = .TRUE.
      DO 30 I = 1,50
         J = IROUND (XANT(I))
         IF (J.LT.0) DOAWNT = .FALSE.
         J = ABS (J)
         IF (J.NE.0) THEN
            DO 25 K = 1,NANTSL
               IF (J.EQ.ANTENS(K)) GO TO 30
 25            CONTINUE
            NANTSL = NANTSL + 1
            ANTENS(NANTSL) = J
            END IF
 30      CONTINUE
C                                       Get CATBLK from old file.
      INCNO = 1
      TYPIN = 'UV'
      CALL CATDIR ('SRCH', INDISK, INCNO, NAMEIN, CLASIN, INSEQ, TYPIN,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLASIN, INSEQ, INDISK, NLUSER
         GO TO 990
         END IF
      STAT = 'WRIT'
      CALL CATIO ('READ', INDISK, INCNO, CATBLK, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'GETTING CATBLK'
         GO TO 990
         END IF
      NCFILE = 1
      FCNO(NCFILE) = INCNO
      FVOL(NCFILE) = INDISK
      FRW(NCFILE) = 1
      CALL UVPGET (IRET)
      CALL COPY (256, CATBLK, CATUV)
      CALL FNDEXT ('FG', CATBLK, I)
      LFGVER = IROUND (XFGVER)
      IF (I.LE.0) FGVER = 0
      LFGVER = MIN (LFGVER, I)
      JP0 = 0
      IF (ICOR0.EQ.-2) JP0 = 1
      IF (ICOR0.EQ.-5) JP0 = 2
      IF (ICOR0.EQ.-6) JP0 = 3
C                                       IF'S
      IF (JLOCIF.GE.0) THEN
         NIF = CATBLK(KINAX+JLOCIF)
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, NIF))
         EIF = IROUND (XEIF)
         IF (EIF.LT.BIF) EIF = NIF
         IF (EIF.GT.NIF) EIF = NIF
      ELSE
         BIF = 1
         EIF = 1
         END IF
C                                       Save relevant pointers for
C                                       flagging
      KLOCFQ = ILOCFQ
      KLOCIF = JLOCIF
      KLOCFY = JLOCF
      LRECIN = LREC
      CALL FNDEXT ('AN', CATBLK, I)
      IF ((SUBARR.GT.I) .OR. (SUBARR.LT.0)) SUBARR = 0
      IUDISK = INDISK
      IUCNO = INCNO
      IFLUN = 30
      KNCOR = NCOR
      KCOR0 = ICOR0
      KNCF = INCF / CATUV(KINAX)
      KNCIF = INCIF / CATUV(KINAX)
      KNCS = INCS / CATUV(KINAX)
      UBUFSZ = UVBFSL * 2
C                                       DSEL common
      UNAME = NAMEIN
      UCLAS = CLASIN
      UDISK = INDISK
      IUDISK = INDISK
      USEQ = INSEQ
      IUSEQ = INSEQ
      IUCNO = INCNO
      IXLUN = LUNTMP (1)
      CALL SOUFIL (IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'GETTING SOURCE LIST'
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
C                                       Find specified FQ id
      CALL FQMATC (INDISK, INCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, IERR)
      IF ((.NOT.MATCH) .OR. (IERR.NE.0)) THEN
         WRITE (MSGTXT,1000) IERR, 'GETTING DESIRED FREQID'
         GO TO 990
         END IF
C                                       version numbers
      CALL FNDEXT ('SY', CATBLK, I)
      IF ((INVER.LE.0) .OR. (INVER.GT.I)) INVER = I
      CALL FNDEXT ('CD', CATBLK, CDVER)
      IF ((INVER.LE.0) .OR. (CDVER.LE.0)) THEN
         MSGTXT = 'YOU MUST HAVE AN SY AND CD TABLE TO RUN THIS TASK'
         GO TO 990
         END IF
C                                       get Tcal values
      SUBA = SUBARR
      FREQID = 1
      CALL GETCDS (INDISK, INCNO, CDVER, SUBA, FREQID, CATBLK, TCAL,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING THE TCAL VALUES'
         GO TO 990
         END IF
C                                       open SY table to read
      LUNSY = 29
      CALL SYINI ('READ', BUFFI, INDISK, INCNO, INVER, CATBLK, LUNSY,
     *   ISYRNO, SYKOLS, SYNUMV, NUMANT, NUMPOL, NUMIF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING THE SY TABLE FOR READ'
         GO TO 990
         END IF
      NRECSY = BUFFI(5)
C                                       prepare for detailed
      CALL SYPREP (IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'PREPING THE SY TABLE FOR REPORTS'
         GO TO 990
         END IF
      CALL SYSORC (IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING THE SOURCE TABLE'
         GO TO 990
         END IF
C                                       Open output device
      IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
      CALL LPOPEN (LPNAME, DOCRT, LUNP, FINDP, NACROS, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING THE PRINTER'
         GO TO 990
         END IF
C                                       length of source name
      MXS = 0
      DO 40 I = 1,1000
         J = JTRIM (SRCS(I))
         MXS = MAX (MXS, J)
 40      CONTINUE
C
 990  IF (IRET.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SYPRTI: ERROR',I4,1X,A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
      END
      SUBROUTINE SYPREP (IRET)
C-----------------------------------------------------------------------
C   SYPREP makes a sorted copy of the SY table, reads it counting the
C   number of records for each antenna, and returns the count array as
C   well as its maximum.  It also reads the NX table getting scan info.
C   Outputs:
C      IRET   I   Error code: > 0 -> quit
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'SYPRT.INC'
      INCLUDE 'REPSYTAB.INC'
      INTEGER   KEY(2,2), KEYSUB(2,2),  BUFFER(512), FGKEY(2,2), K
      REAL      FKEY(2,2), TEPS
      CHARACTER ANTCOL*24
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      DATA FGKEY /5,0, 1,0/
      DATA KEY  /5,0, 1,0/
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
      DATA ANTCOL /'ANTENNA'/
C                                       8 milliseconds
      DATA TEPS /9.E-8/
C-----------------------------------------------------------------------
C                                       find antenna col
      CALL FNDCOL (1, ANTCOL, 7, .TRUE., BUFFI, K, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINDING ANTENNA COLUMN'
         GO TO 990
         END IF
      FGKEY(1,1) = K
      KEY(1,1) = K
C                                       close the SY table to sort it
      CALL TABIO ('CLOS', 0, ISYRNO, BUFFI, BUFFI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT CLOSING OF INPUT SY TABLE'
         GO TO 990
         END IF
      CALL FNDEXT ('SY', CATBLK, SSYVER)
      SSYVER = SSYVER + 1
C                                       flag in copy init
      IF (LFGVER.GT.0) THEN
         FGVER = LFGVER
         IFLUN = 30
         CALL FLGINI ('READ', FGBUFF, INDISK, INCNO, FGVER, CATUV,
     *      IFLUN, IFGRNO, FGKOLS, FGNUMV, K)
         IF (K.NE.0) LFGVER = 0
C                                       Resort if necessary.
         IF ((LFGVER.GT.0) .AND. (FGBUFF(43).NE.FGKEY(1,1))) THEN
C                                       Sort to time order.
            CALL TABIO ('CLOS', 0, K, FGBUFF, FGBUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'CLOSE FG TABLE TO SORT'
               GO TO 990
               END IF
            CALL TABSRT (IUDISK, IUCNO, 'FG', FGVER, FGVER, FGKEY,
     *         KEYSUB, FKEY, FGBUFF, CATUV, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'SORT FG TABLE'
               GO TO 990
               END IF
C                                       Re initialize.
            CALL FLGINI ('READ', FGBUFF, INDISK, INCNO, FGVER, CATUV,
     *         IFLUN, IFGRNO, FGKOLS, FGNUMV, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'RE-OPEN FLAG TABLE'
               GO TO 990
               END IF
            END IF
         END IF
C                                       flag in copy, sort in place
      IF (LFGVER.GT.0) THEN
         CALL SYFSEL (INDISK, INCNO, INDISK, INCNO, INVER, SSYVER,
     *      CATUV, CATBLK, BTIME, ETIME, BUFFI, BUFFER, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'COPY/FLAG SY TABLE'
            GO TO 990
            END IF
         CALL TABSRT (INDISK, INCNO, 'SY', SSYVER, SSYVER, KEY, KEYSUB,
     *      FKEY, BUFFI, CATBLK, IRET)
C                                       no flag, sort in copy
      ELSE
         CALL TABSRT (INDISK, INCNO, 'SY', INVER, SSYVER, KEY, KEYSUB,
     *      FKEY, BUFFI, CATBLK, IRET)
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'SORTING INPUT SY TABLE'
         GO TO 990
         END IF
C                                       reopen
      CALL SYINI ('READ', BUFFI, INDISK, INCNO, SSYVER, CATBLK, LUNSY,
     *   ISYRNO, SYKOLS, SYNUMV, NUMANT, NUMPOL, NUMIF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING SORTED SY TABLE FOR READ'
         GO TO 990
         END IF
      NRECSY = BUFFI(5)
      GO TO 999
C                                       SY table error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SYPREP: ERROR',I4,' ON ',A)
      END
      SUBROUTINE SYSORC (IRET)
C-----------------------------------------------------------------------
C   SYSORC gets the list of source names (if any)
C   Outputs
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'SYPRT.INC'
      INTEGER   VERS, BUFFER(512), LUN, NUMIF, LUNTMP, FREQID, ISURNO,
     *   SUKOLS(MAXSUC), SUNUMV(MAXSUC), IREC, NREC, IDSOU, QUAL, I
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4
      REAL      FLUX(4,MAXIF)
      DOUBLE PRECISION FREQO(MAXIF), BANDW, RAEPO, DECEPO, EPOCH, RAAPP,
     *   DECAPP, RAOBS, DECOBS, LSRVEL(MAXIF), LRESTF(MAXIF), PMRA,
     *   PMDEC
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IRET = 0
      DO 10 I = 1,1000
         SRCS(I) = ' '
 10      CONTINUE
C                                       single source?
      CALL FNDEXT ('SU', CATBLK, VERS)
      IF (VERS.LE.0) THEN
         CALL H2CHR (8, 1, CATH(KHOBJ), SRCS(1))
C                                       real source table
      ELSE
         LUN = LUNTMP (1)
         CALL SOUINI ('READ', BUFFER, INDISK, INCNO, VERS, CATBLK, LUN,
     *      NUMIF, VELTYP, VELDEF, FREQID, ISURNO, SUKOLS, SUNUMV, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING THE SU TABLE'
            GO TO 990
            END IF
         NREC = BUFFER(5)
         DO 20 IREC = 1,NREC
            CALL TABSOU ('READ', BUFFER, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *         SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *         EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF,
     *         PMRA, PMDEC, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING THE SU TABLE'
               GO TO 999
               END IF
            IF ((IDSOU.GT.0) .AND. (IDSOU.LE.1000) .AND. (IRET.EQ.0))
     *         SRCS(IDSOU) = SOUNAM
 20         CONTINUE
         CALL TABSOU ('CLOS', BUFFER, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF,
     *      PMRA, PMDEC, IRET)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SYSORC: ERROR',I4,' ON ',A)
      END
      SUBROUTINE SYPRTA (NP, NIF, IRET)
C-----------------------------------------------------------------------
C   SYPRTA finds the max min and checks printed lines of direct to line
C   printer
C   Inputs:
C      NP       I      Number polarizations
C      NIF      I      Number IFs
C   Outputs:
C      IRET     I      Error code (-1 decided not to waste trees)
C-----------------------------------------------------------------------
      INTEGER   NP, NIF, IRET
C
      INCLUDE 'SYPRT.INC'
      INCLUDE 'REPSYTAB.INC'
      INTEGER   IREC, SOURID, ANTNO, SUBA, FREQID, J, JP, JIF, I,
     *   CALTYP, NLINES, CANT, CSOU, TTY(2), LIF, M, LI1, LI2, LP1, LP2,
     *   LDTYPE
      LOGICAL   WANT, GOOD
      REAL      TIMEI, VD, VS, TT, V, VN, VX
      DOUBLE PRECISION TIME
      CHARACTER SCRSTR*132, CTEMP*4
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
      ISYRNO = 1
      CALL RFILL (MAXANT, 1.E10, VMIN)
      CALL RFILL (MAXANT, -1.E10, VMAX)
      NLINES = 0
      CSOU = 0
      CANT = 0
      NDIG = XNDIG + 0.1
      IF  ((NDIG.LT.3) .OR. (NDIG.GT.7)) NDIG = 4
      LIF = (NACROS - MXS - 10) / (NDIG + 1)
      IF (LIF.GT.EIF-BIF+1) THEN
         M = (EIF-BIF+LIF) / LIF
         M = M * NP
      ELSE
         M = NP
         IF (2*(EIF-BIF+1).LE.LIF) M = 1
         END IF
      LDTYPE = MAX (1, DTYPE)
      LI2 = BIF - 1
      LP2 = 0
C                                       multiple passes
 10   LP1 = LP2 + 1
      LI1 = LI2 + 1
      LI2 = MIN (LI1 + LIF -1, EIF)
      LP2 = MIN (LP1 + NP - 1, NP)
      IF ((LP2-LP1+1)*(LI2-lI1+1).GT.LIF) LP2 = LP1
 11   CONTINUE
C                                       read SY table
      DO 100 IREC = 1,NRECSY
         ISYRNO = IREC
         CALL TABSY ('READ', BUFFI, ISYRNO, SYKOLS, SYNUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA, FREQID,
     *      PDIFF, PSUM, PGAIN, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING THE SORTED SY TABLE'
            GO TO 990
C                                       include?
         ELSE IF (IRET.EQ.0) THEN
            WANT = (TIME.GE.BTIME) .AND. (TIME.LE.ETIME)
            IF ((SOURID.GT.0) .AND. (NSOUWD.GT.0)) THEN
               WANT = .NOT.DOSWNT
               DO 12 J = 1,NSOUWD
                  IF (SOUWAN(J).EQ.SOURID) WANT = DOSWNT
 12               CONTINUE
               END IF
            IF ((TIME.LT.BTIME) .OR. (TIME.GT.ETIME)) WANT = .FALSE.
            IF ((SUBA.GT.0) .AND. (SUBARR.GT.0) .AND.
     *         (SUBA.NE.SUBARR)) WANT = .FALSE.
            IF ((FREQID.GT.0) .AND. (FRQSEL.GT.0) .AND.
     *         (FRQSEL.NE.FREQID)) WANT = .FALSE.
            IF (NANTSL.GT.0) THEN
               DO 15 I = 1,NANTSL
                  IF (ANTNO.EQ.ANTENS(I)) GO TO 20
 15               CONTINUE
               IF (DOAWNT) WANT = .FALSE.
               GO TO 25
 20            IF (.NOT.DOAWNT) WANT = .FALSE.
               END IF
 25         IF (WANT) THEN
               GOOD = .FALSE.
               DO 40 JIF = BIF,EIF
                  DO 30 JP = 1,NP
                     IF (LDTYPE.EQ.1) THEN
                        V = PDIFF(JP,JIF)
                     ELSE IF (LDTYPE.EQ.2) THEN
                        V = PSUM(JP,JIF)
                     ELSE
                        V = FBLANK
                        IF (CALTYP.EQ.1) THEN
                           TT = TCAL(JP+2,JIF,ANTNO)
                        ELSE
                           TT = TCAL(JP,JIF,ANTNO)
                           END IF
                        IF (TT.EQ.FBLANK) TT = 1.0
                        VD = PDIFF(JP,JIF)
                        VS = PSUM(JP,JIF)
                        IF ((VD.NE.FBLANK) .AND. (VS.NE.FBLANK) .AND.
     *                     (VD.GT.0.0) .AND. (VD.LT.VS)) THEN
                           V = TT * VS / (2.0 * VD)
                           END IF
                        END IF
                     IF (V.NE.FBLANK) THEN
                        GOOD = .TRUE.
                        VMAX(ANTNO) = MAX (V, VMAX(ANTNO))
                        VMIN(ANTNO) = MIN (VMIN(ANTNO), V)
                        END IF
 30                  CONTINUE
 40               CONTINUE
               IF (GOOD) THEN
                  NLINES = NLINES + M
                  IF (CANT.NE.ANTNO) THEN
                     NLINES = NLINES + 3*M
                     CANT = ANTNO
                     CSOU = SOURID
                  ELSE IF (CSOU.NE.SOURID) THEN
                     NLINES = NLINES + 2*M
                     CSOU = SOURID
                     END IF
                  END IF
               END IF
            END IF
 100     CONTINUE
      IF (DTYPE.EQ.0) THEN
         LDTYPE = LDTYPE + 1
         IF (LDTYPE.LE.3) GO TO 11
         LDTYPE = 1
         END IF
      IF ((LI2.LT.EIF) .OR. (LP2.LT.NP)) THEN
         IF (LI2.EQ.EIF) LI2 = BIF - 1
         GO TO 10
         END IF
      IF ((NLINES.GT.500) .AND. (DOCRT.LE.0.0) .AND. (LPNAME.EQ.' '))
     *   THEN
         TTY(1) = 5
         CALL ZOPEN (TTY(1), TTY(2), 1, SCRSTR, .FALSE., .FALSE.,
     *      .TRUE., IRET)
         MSGTXT = 'PROBLEM OPENING TERMINAL'
         IF (IRET.GT.0) GO TO 990
         WRITE (SCRSTR,1270) NLINES
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRSTR, IRET)
         MSGTXT = 'PROBLEM DOING IO TO TERMINAL'
         IF (IRET.GT.0) GO TO 990
         SCRSTR = 'Do you really want to print this much??' //
     *      ' Enter Y or y if so'
         CALL INQSTR (TTY, SCRSTR, 1, CTEMP, IRET)
         IF (IRET.GT.0) GO TO 990
         IF ((CTEMP(:1).NE.'y') .AND. (CTEMP(:1).NE.'Y')) THEN
            SCRSTR = 'Good choice - save trees'
            IRET = -1
         ELSE
            SCRSTR = 'OKAY, printing anyway'
            END IF
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRSTR, I)
         CALL ZCLOSE (TTY(1), TTY(2), I)
         END IF
      IF (DOSCAL.LE.0.0) THEN
         VX = -1.E10
         VN = 1.E10
         DO 110 I = 1,MAXANT
            VX = MAX (VX, VMAX(I))
            VN = MIN (VN, VMIN(I))
 110        CONTINUE
         CALL RFILL (MAXANT, VN, VMIN)
         CALL RFILL (MAXANT, VX, VMAX)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SYPRTA: ERROR',I4,' ON ',A)
 1270 FORMAT ('Requested print job is',I10,' lines long!')
      END
      SUBROUTINE SYPRT2 (NP, NIF, IRET)
C-----------------------------------------------------------------------
C   SYPRT2 does the display of the data: by ant, IF across, time down
C   Inputs:
C      NP       I      Number polarizations
C      NIF      I      Number IFs
C   Output:
C      IRET     I      Error code
C-----------------------------------------------------------------------
      INTEGER   NP, NIF, IRET
C
      INCLUDE 'REPSYTAB.INC'
      INCLUDE 'SYPRT.INC'
      INTEGER   JP, JIF, PAGE, K, I, J, LIF, LI1, LI2, ITT(4), PMAX,
     *   IROUND, IP, ICOUNT, LP, LP1, LP2, IREC, SOURID, ANTNO, SUBA,
     *   FREQID, CALTYP, LANT, L, LDTYPE
      CHARACTER TITL1*132, TITL2*132, LINE*132, SRC*16, CSCR*132,
     *   POLS(4)*1, TYPES(3)*4, FORM1*11, FORM2*4, DASH*10
      LOGICAL   WANT
      REAL      MAXV, T, V, SCL, X, TIMEI, TT, VD, VS
      DOUBLE PRECISION TIME
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA POLS /'R', 'L', 'X', 'Y'/
      DATA TYPES /'Pdif', 'Psum', 'Psys'/
      DATA DASH /'----------'/
C-----------------------------------------------------------------------
C                                       init printer
      PAGE = 0
      LIF = (NACROS - MXS - 10) / (NDIG + 1)
      IF (LIF.GE.2*(EIF-BIF+1)) THEN
         LP = MIN (2, NP)
      ELSE
         LP = 1
         END IF
      LI2 = BIF - 1
      LP2 = 0
      WRITE (FORM1,1010) NDIG
      WRITE (FORM2,1011) (NDIG+1)
      PMAX = 10.0**NDIG + 0.1
      ICOUNT = 0
      LDTYPE = MAX (1, DTYPE)
      IPCNT = 999
C                                       multiple passes
 10   LP1 = LP2 + 1
      LI1 = LI2 + 1
      LI2 = MIN (LI1 + LIF -1, EIF)
      LP2 = MIN (LP1 + NP - 1, NP)
      IF ((LP2-LP1+1)*(LI2-lI1+1).GT.LIF) LP2 = LP1
C                                       read SY table
 11   LANT = -1
      DO 100 IREC = 1,NRECSY
         ISYRNO = IREC
         CALL TABSY ('READ', BUFFI, ISYRNO, SYKOLS, SYNUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA, FREQID,
     *      PDIFF, PSUM, PGAIN, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING THE SORTED SY TABLE'
            GO TO 990
C                                       include?
         ELSE IF (IRET.EQ.0) THEN
            WANT = (TIME.GE.BTIME) .AND. (TIME.LE.ETIME)
            IF ((SOURID.GT.0) .AND. (NSOUWD.GT.0)) THEN
               WANT = .NOT.DOSWNT
               DO 15 J = 1,NSOUWD
                  IF (SOUWAN(J).EQ.SOURID) WANT = DOSWNT
 15               CONTINUE
               END IF
            IF ((TIME.LT.BTIME) .OR. (TIME.GT.ETIME)) WANT = .FALSE.
            IF ((SUBA.GT.0) .AND. (SUBARR.GT.0) .AND.
     *         (SUBA.NE.SUBARR)) WANT = .FALSE.
            IF ((FREQID.GT.0) .AND. (FRQSEL.GT.0) .AND.
     *         (FRQSEL.NE.FREQID)) WANT = .FALSE.
            IF (NANTSL.GT.0) THEN
               DO 16 I = 1,NANTSL
                  IF (ANTNO.EQ.ANTENS(I)) GO TO 20
 16               CONTINUE
               IF (DOAWNT) WANT = .FALSE.
               GO TO 25
 20            IF (.NOT.DOAWNT) WANT = .FALSE.
               END IF
 25         IF (WANT) THEN
               IF (ANTNO.NE.LANT) THEN
C                                       find scaling
                  IF (VMIN(ANTNO).LT.0) THEN
                     X = MAX (-10.0*VMIN(ANTNO), ABS(VMAX(ANTNO)))
                  ELSE
                     X = VMAX(ANTNO)
                  END IF
                  I = LOG10 (X) + 10.0 - NDIG
                  MAXV = 10.0 ** (9-I)
                  IF (FACTOR.NE.0.0) MAXV = MAXV * FACTOR
                  SCL = PMAX / MAXV
C                                       titles
                  WRITE (TITL1,1050) TYPES(LDTYPE), ANTNO, PMAX, SCL
                  IP = 10 + MXS
                  WRITE (TITL2,1055)
                  WRITE (TITL2(IP:),FORM1) ((K, POLS(L+JP0), K=LI1,LI2),
     *               L = LP1,LP2)
                  LINE = ' '
                  CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *               LINE, IPCNT, PAGE, CSCR, IRET)
                  IF (IRET.NE.0) GO TO 960
                  IF (ICOUNT.NE.0) THEN
                     CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *                  TITL2, TITL1, IPCNT, PAGE, CSCR, IRET)
                     IF (IRET.NE.0) GO TO 960
                     CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *                  TITL2, TITL2, IPCNT, PAGE, CSCR, IRET)
                     IF (IRET.NE.0) GO TO 960
                     END IF
                  LANT = ANTNO
                  END IF
C                                       write line
               ICOUNT = ICOUNT + 1
               SRC = SRCS(SOURID)
               T = TIME
               CALL TODHMS (T, ITT)
               WRITE (LINE,1060) ITT(2), ITT(3), ITT(4), SRC(:MXS)
               IP = 10 + MXS
               DO 40 JP = LP1,LP2
                  DO 30 JIF = LI1,LI2
                     IF (LDTYPE.EQ.1) THEN
                        V = PDIFF(JP,JIF)
                     ELSE IF (LDTYPE.EQ.2) THEN
                        V = PSUM(JP,JIF)
                     ELSE
                        V = FBLANK
                        IF (CALTYP.EQ.1) THEN
                           TT = TCAL(JP+2,JIF,ANTNO)
                        ELSE
                           TT = TCAL(JP,JIF,ANTNO)
                           END IF
                        IF (TT.EQ.FBLANK) TT = 1.0
                        VD = PDIFF(JP,JIF)
                        VS = PSUM(JP,JIF)
                        IF ((VD.NE.FBLANK) .AND. (VS.NE.FBLANK) .AND.
     *                     (VD.GT.0.0) .AND. (VD.LT.VS))
     *                     V = TT * VS / (2.0 * VD)
                        END IF
                     IF (V.NE.FBLANK) THEN
                        K = IROUND (V * MAXV)
                        WRITE (LINE(IP:),FORM2) K
                     ELSE
                        LINE(IP:) = ' ' // DASH(:NDIG)
                        END IF
                     IP = IP + NDIG + 1
 30                  CONTINUE
 40               CONTINUE
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            LINE,IPCNT, PAGE, CSCR, IRET)
               IF (IRET.NE.0) GO TO 960
               END IF
            END IF
 100     CONTINUE
      IF (DTYPE.EQ.0) THEN
         LDTYPE = LDTYPE + 1
         IF (LDTYPE.LE.3) GO TO 11
         LDTYPE = 1
         END IF
      IF ((LI2.LT.EIF) .OR. (LP2.LT.NP)) THEN
         IF (LI2.EQ.EIF) LI2 = BIF - 1
         GO TO 10
         END IF
C
 960  IF (IRET.LT.0) THEN
         MSGTXT = 'Stopping at your request'
         CALL MSGWRT (6)
         IRET = 0
      ELSE IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'PRINTER ERROR'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SYPRT2: ERROR',I4,' ON ',A)
 1010 FORMAT ('(34(I',I1,',A1))')
 1011 FORMAT ('(I',I1,')')
 1050 FORMAT ('*******  Printing ',A,' for antenna',I3,2X,I8,' =',
     *   F11.4,'  *******')
 1055 FORMAT ('  Time   Source')
C 1056 FORMAT (25(I4,A1))
 1060 FORMAT (2(I2.2,':'),I2.2,1X,A)
C 1061 FORMAT (I5)
      END
      SUBROUTINE SYFSEL (DISKI, CNOI, DISKO, CNOO, VERI, VERO, CATIN,
     *   CATOUT, TB, TE, BUFFER, OBUFF, IRET)
C-----------------------------------------------------------------------
C   Copies a subset of IFs in a SY table, can also modify the FQ ID
C   Inputs:
C      DISKI    I        Input volume number
C      CNOI     I        Input catalog number
C      DISKO    I        Output volume number
C      CNOO     I        Output catalog number
C      VER      I        Version to check/modify
C      CATIN    I(256)   Input catalog header
C      CATOUT   I(256)   Output catalog header
C      TB       R        Beginning time in days
C      TE       R        Ending time in days
C   Input/Output:
C      BUFFER   I(*)     Work buffer
C      OBUFF    I(*)     Work buffer
C   Output:
C      IRET     I        Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER   DISKI, CNOI, DISKO, CNOO, VERI, VERO, CATIN(256),
     *   CATOUT(256), BUFFER(*), OBUFF(*), IRET
      REAL      TB, TE
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ISYRNO, SYKOLS(MAXSYC), SYNUMV(MAXSYC), NUMANT, NUMPOL,
     *   NUMIF, OKOLS(MAXSYC), ONUMV(MAXSYC), NSYROW, I, SOURID, ANTNO,
     *   SUBA, FREQID, OSYRNO, JIF, IPOL, OVER, NDEL, NTOT, JRET, NPART,
     *   LUNI, LUNO, LUNTMP, CALTYP
      REAL      PDIFF(2,MAXIF), PSUM(2,MAXIF), PGAIN(2,MAXIF), TIMEI
      DOUBLE PRECISION TIME
      LOGICAL   REFMT, GOTONE
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
C-----------------------------------------------------------------------
C                                       open flag table
      TMFLST = -1.E20
      NUMFLG = 0
      IFGRNO = 1
      NDEL = 0
      NTOT = 0
      NPART = 0
C                                       Open SY file
      LUNI = LUNTMP (1)
      CALL SYINI ('READ', BUFFER, DISKI, CNOI, VERI, CATIN, LUNI,
     *   ISYRNO, SYKOLS, SYNUMV, NUMANT, NUMPOL, NUMIF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       # rows in old table
      NSYROW = BUFFER(5)
      REFMT = .FALSE.
C                                       Open up new SY table
      OVER = VERO
      LUNO = LUNTMP (1)
      CALL SYINI ('WRIT', OBUFF, DISKO, CNOO, OVER, CATOUT, LUNO,
     *   OSYRNO, OKOLS, ONUMV, NUMANT, NUMPOL, NUMIF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 100 I = 1,NSYROW
         CALL TABSY ('READ', BUFFER, ISYRNO, SYKOLS, SYNUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA, FREQID,
     *      PDIFF, PSUM, PGAIN, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1030) IRET
            GO TO 990
            END IF
C                                       flag info
         CALL SYFLG (NUMPOL, NUMIF, TIME, SOURID, ANTNO, SUBA, FREQID,
     *      PDIFF, PSUM, PGAIN, NPART, JRET)
         IF (JRET.GT.0) THEN
            IRET = JRET
            GO TO 999
            END IF
C                                       Time selection
         IF ((TIME.LT.TB) .OR. (TIME.GT.TE)) IRET = -1
         IF ((JRET.EQ.-1) .AND. (IRET.EQ.0)) THEN
            IRET = -1
            NDEL = NDEL + 1
            END IF
C                                       Is this record selected ?
         IF (IRET.LT.0) THEN
            REFMT = .TRUE.
C                                       Re-number IF's
         ELSE
            GOTONE = .FALSE.
            DO 90 JIF = 1,NUMIF
               DO 80 IPOL = 1,NUMPOL
                  IF (PDIFF(IPOL,JIF).NE.FBLANK) GOTONE = .TRUE.
                  IF (PSUM(IPOL,JIF).NE.FBLANK) GOTONE = .TRUE.
 80               CONTINUE
 90            CONTINUE
            IF (GOTONE) THEN
               NTOT = NTOT + 1
               CALL TABSY ('WRIT', OBUFF, OSYRNO, OKOLS, ONUMV, NUMPOL,
     *            NUMIF, TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA,
     *            FREQID, PDIFF, PSUM, PGAIN, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1040) IRET
                  GO TO 990
                  END IF
            ELSE
               REFMT = .TRUE.
               END IF
            END IF
 100     CONTINUE
      IRET = 0
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ISYRNO, BUFFER, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OSYRNO, OBUFF, OBUFF, IRET)
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         IF (REFMT) THEN
            WRITE (MSGTXT,1100) 'Reformatted SY', DISKI, CNOI, VERI,
     *         DISKO, CNOO, OVER
         ELSE
            WRITE (MSGTXT,1100) 'Copied SY', DISKI, CNOI, VERI, DISKO,
     *         CNOO, OVER
            END IF
         CALL MSGWRT (3)
         NTOT = NTOT + NDEL
         WRITE (MSGTXT,1101) NDEL, NTOT
         CALL REFRMT (MSGTXT, '_', I)
         CALL MSGWRT (3)
         WRITE (MSGTXT,1102) NPART
         CALL REFRMT (MSGTXT, '_', I)
         IF (NPART.GT.0) CALL MSGWRT (3)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SYFSEL: ERROR ',I3,' INITING OLD TABLE')
 1020 FORMAT ('SYFSEL: ERROR ',I3,' INITING NEW TABLE')
 1030 FORMAT ('SYFSEL: ERROR ',I3,' READING OLD TABLE')
 1040 FORMAT ('SYFSEL: ERROR ',I3,' WRITING NEW TABLE')
 1100 FORMAT (A,' file from vol/cno/vers',I3,I5,I4,' to',I3,I5,I4)
 1101 FORMAT ('__Fully deleted',I10,' of',I12,' SY records applying',
     *   ' flag table')
 1102 FORMAT ('__Partly flagged',I10,' SY records applying flag table')
      END
      SUBROUTINE SYFLG (NPOL, NIF, TIME, SOURID, ANTNO, SUBA, FREQID,
     *   PDIFF, PSUM, PGAIN, NPART, IRET)
C-----------------------------------------------------------------------
C   Flags a TY table row based on the flags in FG table loaded to Common
C   Inputs:
C      NPOL     I      Number polarizations in TY data
C      NIF      I      Number of IFs in those data
C      TIME     R      Time of table row
C      SOURID   I      Source number of row
C      ANTNO    I      Antenna number of row
C      SUBA     I      Subarray of row
C      FREQID   I      Frequency ID if row
C   In/Out:
C      PDIFF    R(*)   Pon-Poff
C      PSUM     R(*)   Pon+Poff
C      PGAIN    R(*)   Post detection gains
C      NPART    I      count of partly flagged records
C   Inputs from include DSEL.INC:
C      NUMFLG     I    Number of flagging entries.
C      TMFLST     R    Time of last visibility for which flagging
C                      was checked.
C      FLGSOU(*)  I    Source id numbers to flag, 0=all.
C      FLGANT(*)  I    Antenna numbers to flag, 0=all.
C      FLGBAS(*)  I    Baseline (A1*32768+A2) numbers to flag, 0=all.
C      FLGSUB(*)  I    Subarray numbers to flag, 0=all.
C      FLGFQD(*)  I    Freqid numbers to flag, <=0=all.
C                      Following should have defaults filled in.
C      FLGBIF(*)  I    First IF to flag.
C      FLGEIF(*)  I    Highest IF to flag.
C      FLGBCH(*)  I    First channel to flag.
C      FLGECH(*)  I    Highest channel to flag.
C      FLGPOL(4,*)L    Flags for the polarizations, should correspond
C                      to selected polarization types.
C   Output:
C      IRET     I      0 -> okay, -1 -> all flagged
C-----------------------------------------------------------------------
      INTEGER   NPOL, NIF, SOURID, ANTNO, SUBA, FREQID, NPART, IRET
      REAL      PDIFF(2,*), PSUM(2,*), PGAIN(2,*)
      DOUBLE PRECISION TIME
C
      INTEGER   IFLAG, FLGA, JPOLN, JIF, LIMF1, LIMF2, IPOLPT
      REAL      RTIME
      LOGICAL   PART
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
      RTIME = TIME
      IF (TMFLST.LT.TIME) CALL NXTFLG (RTIME, .TRUE., IRET)
      IF (IRET.NE.0) GO TO 999
      IF (NUMFLG.LE.0) GO TO 999
      PART = .FALSE.
C                                       loop over current flags
      DO 50 IFLAG = 1,NUMFLG
C                                       Check time if needed
         IF ((TIME.LT.FLGTST(IFLAG)) .OR. (TIME.GT.FLGTND(IFLAG)))
     *      GO TO 50
C                                       Check source
         IF ((FLGSOU(IFLAG).NE.SOURID) .AND. (FLGSOU(IFLAG).NE.0) .AND.
     *      (SOURID.NE.0)) GO TO 50
C                                       Check antenna
         FLGA = FLGANT(IFLAG)
         IF ((FLGA.NE.0) .AND. (FLGA.NE.ANTNO)) GO TO 50
C                                       Check subarray
         IF ((FLGSUB(IFLAG).GT.0) .AND. (FLGSUB(IFLAG).NE.SUBA))
     *      GO TO 50
C                                       Check freqid.: may be changed
C                                       from input to 1 already
         IF ((FLGFQD(IFLAG).GT.0) .AND. (FLGFQD(IFLAG).NE.FREQID) .AND.
     *      (FREQID.GT.0)) GO TO 50
C                                       Some data to be flagged
C                                       Set limits
         LIMF1 = FLGBIF(IFLAG)
         LIMF2 = FLGEIF(IFLAG)
C                                       Loop over polarizations
         IPOLPT = ABS(KCOR0) - 1
         IF (KCOR0.LT.-4) IPOLPT = IPOLPT - 4
         DO 40 JPOLN = 1,NPOL
            IF (FLGPOL(JPOLN+IPOLPT,IFLAG)) THEN
               PART = .TRUE.
C                                       Loop over IF
               DO 30 JIF = LIMF1,LIMF2
                  PDIFF(JPOLN,JIF) = FBLANK
                  PSUM(JPOLN,JIF) = FBLANK
                  PGAIN(JPOLN,JIF) = FBLANK
 30               CONTINUE
               END IF
 40         CONTINUE
 50      CONTINUE
C                                       Check if data all flagged
      IF (PART) NPART = NPART + 1
      DO 70 JPOLN = 1,NPOL
         DO 60 JIF = 1,NIF
            IF ((PDIFF(JPOLN,JIF).NE.FBLANK) .OR.
     *         (PSUM(JPOLN,JIF).NE.FBLANK)) GO TO 999
 60         CONTINUE
 70      CONTINUE
      IF (PART) NPART = NPART - 1
      IRET = -1
C
 999  RETURN
      END

LOCAL INCLUDE 'BSMAP.INC'
C                                       Local include for BSMAP
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS, JBUFSZ,
     *   OLDCNO
      LOGICAL   DOUNIF
      CHARACTER HISCRD(10)*64, NAMEIN*12, CLAIN*6, NAMOUT*12, UNIF*4
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XUNIF(1)
      REAL      XSIN, XDISIN, XSOUT, XDISO, IMSIZE(2), CELLS(2),
     *   BUFF1(UVBFSS), BUFF2(UVBFSS), ERROR, DETIME
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XSOUT,
     *   XDISO, IMSIZE, CELLS, ERROR, XUNIF, DETIME, SEQIN, SEQOUT,
     *   DISKIN, DISKO, DOUNIF, NUMHIS, OLDCNO
      COMMON /CHRCOM/ HISCRD, NAMEIN, CLAIN, NAMOUT, UNIF
LOCAL END
      PROGRAM BSMAP
C-----------------------------------------------------------------------
C! Computes image from bi-spectrum analysis of uv data.
C# UV Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000, 2006, 2008, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C Experimental Bi-spectrum analysis program.
C  Tim Cornwell                                               July 1986
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'BSMAP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'BSMAP '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL BSIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Do it.
      CALL BSSEND (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE BSIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   BSIN gets input parameters for BS.
C   Inputs:  PRGN    C*6       Program name
C   Output:  JERR    I         Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, UTYPE*2
      INTEGER   IROUND, NPARM, IERR
      LOGICAL   T, EQUAL
      INCLUDE 'BSMAP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = 2 * UVBFSS
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 20
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (4, 1, XUNIF, UNIF)
C                                       Integration time
      IF (DETIME.LE.0.0) DETIME = 1.0/6.0
C                                       Weighting
      DOUNIF = UNIF(1:2) .EQ. 'UN'
      IF (ERROR.EQ.0.0) ERROR = 0.025
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Disallow packed uv data
      IF (CATBLK(KINAX).EQ.1) THEN
         JERR = 9
         MSGTXT = 'ERROR: I cannot process packed UV data, use SPLIT'
         GO TO 990
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Check sort order
      EQUAL = ISORT(1:2) .EQ.'TB'
      IF (.NOT.EQUAL) THEN
          WRITE (MSGTXT,1070)
          JERR = 10
          GO TO 990
       END IF
C                                       Set to READ status
      UTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BSIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1070 FORMAT ('BSIN: SORT ORDER NOT TB, QUITTING')
      END
      SUBROUTINE BSSEND (IRET)
C-----------------------------------------------------------------------
C   BSSEND sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   INIO, IPTRI, LUNI, INDI, ILENBU, IBIND, I, IA1,
     *   IA2, INCX, BO, VO, NUMVIS, XCOUNT
      LOGICAL   T, F
      REAL      DUM
      CHARACTER IFILE*48
      INCLUDE 'BSMAP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNI /16/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.LE.0) GO TO 20
         WRITE (MSGTXT,1000) IRET
         GO TO 990
C                                       Init vis file for read.
 20   ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.EQ.0) GO TO 40
         WRITE (MSGTXT,1030) IRET
         GO TO 990
 40   NUMVIS = 0
      XCOUNT = 0
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
         DO 190 I = 1,INIO
            IF (ILOCB.GT.0) THEN
               IA1 = BUFF1(IPTRI+ILOCB) / 256. + 0.1
               IA2 = BUFF1(IPTRI+ILOCB) - IA1*256. + 0.1
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               END IF
            NUMVIS = NUMVIS + 1
C                                      Call user routine.
            CALL BSWORK (NUMVIS, BUFF1(IPTRI+ILOCU),
     *         BUFF1(IPTRI+ILOCV), BUFF1(IPTRI+ILOCT), IA1, IA2,
     *         BUFF1(IPTRI+NRPARM), INCX, BUFF2, JBUFSZ, IRET)
C                                       Branch on his return
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
               END IF
C                                       OK, but no output please
            IPTRI = IPTRI + LREC
C
 190        CONTINUE
         IF (INIO.GT.0) GO TO 100
C                                       Final call to BSWORK.
      NUMVIS = -1
      CALL BSWORK (NUMVIS, DUM, DUM, DUM, IA1, IA2, BUFF1,
     *   INCX, BUFF2, JBUFSZ, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
         END IF
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BSSEND: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1030 FORMAT ('BSSEND: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('BSSEND: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('BSSEND: BSWORK ERROR',I3)
      END
      SUBROUTINE BSWORK (NUMVIS, U, V, T, IA1, IA2, VIS, INCX, BUFFER,
     *   KBUFSZ, IRET)
C-----------------------------------------------------------------------
C   Inputs:
C      NUMVIS     I    Visibility number, -1 => final call, no data
C                      passed but allows any operations to be completed.
C      U          R    U in wavelengths
C      V          R    V in wavelengths
C      T          R    Time in days since 0 IAT on the first day for
C                      which there is data, the julian day corresponding
C                      to this day can be obtained in D   form by:
C                      CALL JULDAY (CATR(KHDOB),XDAY) where XDAY will
C                      be the Julian day number.
C      IA1        I    First antenna number
C      IA2        I    Second antenna number
C      VIS(INCX,*) R    Visibilities in order real, imaginary, weight
C                      (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                      NOTE: INCX may be any value .GE. 2
C   Inputs from COMMON
C      IMSIZE(2)  R    User array.
C      CELLS(2)  R    User array.
C      RA         D    Right ascension (1950) of phase center. (deg)
C      DEC        D    Declination (1950) of phase center. (deg)
C      FREQ       D    Frequency of observation (Hz)
C      NRPARM     I    # random parameters.
C      NCOR       I    # correlators
C      CATBLK(256)I    Catalog header record. See Going Aips for
C                      details.
C
C   Output:
C      U          R    U in wavelengths
C      V          R    V in wavelengths
C      T          R    Time in same units as input.
C      VIS        R    Visibilities
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C
C   Output in COMMON
C      NUMHIS            I    # history entries (max. 10)
C      HISCRD(NUMHIS)*64 C    History records
C      CATBLK            I    Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IA1, IA2, INCX, KBUFSZ, IRET
      REAL      U, V, T, VIS(INCX,10), BUFFER(*)
      INCLUDE 'BSMAP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
C
      INTEGER MAXANT, MXUBSA, MXVBSA, MAXNX, MAXNY
      PARAMETER (MAXANT=28)
      PARAMETER (MXUBSA=10)
      PARAMETER (MXVBSA=MXUBSA)
      PARAMETER (MAXNX=32)
      PARAMETER (MAXNY=32)
C                                       Arguments
      INTEGER   NANT, NUBSA, NVBSA, NX, NY, NPCALL, IERR, IS1, IS2
      REAL   UCELL(MAXANT,MAXANT), VCELL(MAXANT,MAXANT)
      REAL   BSWT(MAXANT,MAXANT), WAVE
      COMPLEX BSVIS(MAXANT,MAXANT), BS
C                                       Don't try to use these in
C                                       this subroutine, go down
C                                       one level.
      COMPLEX   BSARRY((2*MXUBSA+1)**2*(2*MXVBSA+1)**2)
      REAL      BSWTS ((2*MXUBSA+1)**2*(2*MXVBSA+1)**2)
      INTEGER   BSNUM ((2*MXUBSA+1)**2*(2*MXVBSA+1)**2)
      COMPLEX   BSAINV((2*MXUBSA+1)*(2*MXVBSA+1))
      COMPLEX   BSAWT ((2*MXUBSA+1)*(2*MXVBSA+1))
C
      COMPLEX   WK1((2*MXUBSA+1)*(2*MXVBSA+1))
      COMPLEX   WK2((2*MXUBSA+1)*(2*MXVBSA+1))
C
      COMPLEX   WK3((2*MAXNX+1)*(2*MAXNY+1))
      REAL      BSIMAG((2*MAXNX+1)*(2*MAXNY+1))
      REAL      BSBEAM((2*MAXNX+1)*(2*MAXNY+1))
C
      CHARACTER IMCLAS*6, BMCLAS*6
      REAL   USCALE, VSCALE, WT, S2R, TLAST, UMAX, VMAX, DELT, BANDW
      REAL   IMMAX, IMMIN, BMMAX, BMMIN, VISVAR, FLUX, WT1, WT2
      INTEGER   NNGRID, NSGRID, SIZFFT, ITEMP, ITNX, ITNY
C
      SAVE TLAST, DELT, NPCALL, USCALE, VSCALE, UCELL, VCELL, BSVIS,
     *   BSWT, NX, NY, NUBSA, NVBSA, S2R, UMAX, VMAX, BS, WAVE, VISVAR,
     *   NANT
      DATA TLAST/-1E20/
      DATA NPCALL/0/
      DATA BANDW /1.0/
      DATA NSGRID, NNGRID/0,0/
      DATA IMCLAS /'BSMAP '/
      DATA BMCLAS /'BSBEAM'/
C-----------------------------------------------------------------------
      IRET = -1
C                                       Initialize
      IF (NUMVIS.EQ.1) THEN
C                                       Variance of I data
         VISVAR = 2.0 * ERROR**2
C                                       Length of scan
         DELT = DETIME / (60.0 * 24.0)
         TLAST = T
         WRITE (MSGTXT,2100) DETIME
         CALL MSGWRT (4)
C                                       Number of antennae
         NANT = MAXANT
C                                       Size of image grid, etc
         NX = MIN (NINT((IMSIZE(1) - 1.0) / 2.0) , MAXNX)
         NY = MIN (NINT((IMSIZE(2) - 1.0) / 2.0) , MAXNY)
         WRITE (MSGTXT,1100) 2*NX+1, 2*NY+1
         CALL MSGWRT (4)
C                                       Size of u,v grid, etc
         S2R = 4*ATAN(1.0)/(180.0*3600.0)
         NUBSA = MIN (NX, MXUBSA)
         NVBSA = MIN (NY, MXVBSA)
         UMAX = 1/(S2R*2.0*CELLS(1))
         VMAX = 1/(S2R*2.0*CELLS(2))
C                                       Remember extra padding and
C                                       remember to flip U axis
         ITEMP = SIZFFT(NUBSA)
         USCALE = - REAL(ITEMP) / UMAX
         ITEMP = SIZFFT(NVBSA)
         VSCALE = REAL(ITEMP) / VMAX
C                                       Write into history file
         NUMHIS = 1
         WRITE (HISCRD(NUMHIS),1700) ERROR
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2100) DETIME
         IF (DOUNIF) THEN
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),1800)
            WRITE (MSGTXT,1800)
            CALL MSGWRT (4)
         ELSE
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),1900)
            WRITE (MSGTXT,1900)
            CALL MSGWRT (4)
         END IF
C                                       Reset arrays
         DO 10 IS2 = 1, NANT
            DO 11 IS1 = 1, NANT
               UCELL(IS1,IS2) = 0.0
               VCELL(IS1,IS2) = 0.0
               BSVIS(IS1,IS2) = 0.0
               BSWT(IS1,IS2)  = 0.0
 11         CONTINUE
 10      CONTINUE
      END IF
C-----------------------------------------------------------------------
C                                       Must be end of current
C                                       time-stamp
      IF ((T.GT.(TLAST+1.05*DELT)).OR.(NUMVIS.LT.0)) THEN
         TLAST = T
C                                       Correct for weighting
         DO 90 IS2 = 1, NANT
            DO 80 IS1 = 1, NANT
               IF (BSWT(IS1,IS2).GT.0.0) THEN
                  UCELL(IS1,IS2) = UCELL(IS1,IS2) / BSWT(IS1,IS2)
                  VCELL(IS1,IS2) = VCELL(IS1,IS2) / BSWT(IS1,IS2)
                  BSVIS(IS1,IS2) = BSVIS(IS1,IS2) / BSWT(IS1,IS2)
               END IF
  80        CONTINUE
  90     CONTINUE
C                                       Grid current lot of data
         CALL BSGRID(NPCALL.EQ.0, NANT, UCELL, VCELL, BSVIS, BSWT,
     *      VISVAR, NUBSA, NVBSA, BSARRY, BSWTS, BSNUM, BS, WAVE,
     *      IERR)
         NPCALL = NPCALL + 1
C                                       Reset arrays
         DO 100 IS2 = 1, NANT
            DO 110 IS1 = 1, NANT
               UCELL(IS1,IS2) = 0.0
               VCELL(IS1,IS2) = 0.0
               BSVIS(IS1,IS2) = 0.0
               BSWT(IS1,IS2)  = 0.0
 110        CONTINUE
 100     CONTINUE
C                                       If last point then we should
C                                       make images
         IF (NUMVIS.LT.0) THEN
C                                       How many timestamps were there?
            WRITE (MSGTXT,1200) NPCALL
            CALL MSGWRT (4)
C                                       How many points fell off grid?
            WRITE (MSGTXT,1300) NSGRID, NNGRID
            CALL MSGWRT (4)
C                                       Point source estimation
            FLUX = REAL(BS**(1.0/3.0))
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),2000) FLUX
            WRITE (MSGTXT,2000) FLUX
            CALL MSGWRT (4)
C                                       Invert to find Vis. fn.
            CALL BSINV (FLUX, NUBSA, NVBSA, BSARRY, BSWTS, BSNUM,
     *         BSAINV, BSAWT, DOUNIF, WK1, WK2, IERR)
C                                       Check for failure to converge
            IF (IERR.EQ.1) THEN
               IERR = 0
               WRITE (MSGTXT,2200)
               NUMHIS = NUMHIS + 1
               WRITE (HISCRD(NUMHIS),2200)
            END IF
C                                       FT to get image
            CALL FTUVIM (NX, NY, NUBSA, NVBSA, BSAINV, WK3, BSIMAG,
     *         IMMAX, IMMIN)
C                                       FT to get beam
            CALL FTUVIM (NX, NY, NUBSA, NVBSA, BSAWT,  WK3, BSBEAM,
     *         BMMAX, BMMIN)
C                                       Write out peak flux
            IF (BMMAX.NE.0.0) THEN
               WRITE (MSGTXT,1400) IMMAX/BMMAX
               CALL MSGWRT (4)
            ELSE
               WRITE (MSGTXT,1600)
               CALL MSGWRT (4)
               IERR = 2
               GO TO 999
            END IF
C                                       Renormalise map and beam
            ITNX = 2*NX+1
            ITNY = 2*NY+1
            CALL RENORM (ITNX * ITNY, BSIMAG, 1 / BMMAX)
            CALL RENORM (ITNX * ITNY, BSBEAM, 1 / BMMAX)
C                                       Write out map and beam
            CALL DMPMAP (DISKIN, OLDCNO, BSIMAG, ITNX, ITNY, SOURCE,
     *         CELLS, RA, DEC, FREQ, BANDW, 1.0D0, NAMOUT,
     *         IMCLAS, SEQOUT, DISKO, NUMHIS, HISCRD, BUFFER, KBUFSZ,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1500) IERR
               CALL MSGWRT (4)
               GO TO 999
            END IF
            CALL DMPMAP (DISKIN, OLDCNO, BSBEAM, ITNX, ITNY, SOURCE,
     *         CELLS, RA, DEC, FREQ, BANDW, 0.0D0, NAMOUT,
     *         BMCLAS, SEQOUT, DISKO, NUMHIS, HISCRD, BUFFER, KBUFSZ,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1500) IERR
               CALL MSGWRT (4)
               GO TO 999
            END IF
            GO TO 999
         END IF
C
      END IF
C                                       More of same time-stamp
C                                       so add to current lot
      IF (ABS(T-TLAST).LE.1.05*DELT) THEN
C                                       Calculate weight
            WT1 = MAX(VIS(3,1),0.0)
            WT2 = MAX(VIS(3,2),0.0)
            WT = WT1 + WT2
            IF ((ABS(U).LE.UMAX).AND.(ABS(V).LE.VMAX).AND.
     *          (WT.GT.0.0)) THEN
C                                       Form weighted sum
               BSVIS(IA1,IA2) = BSVIS(IA1,IA2) +
     *            CMPLX(WT1*VIS(1,1)+WT2*VIS(1,2),
     *            WT1*VIS(2,1)+WT2*VIS(2,2))
               UCELL(IA1,IA2) = UCELL(IA1,IA2) + USCALE * U * WT
               VCELL(IA1,IA2) = VCELL(IA1,IA2) + VSCALE * V * WT
               BSWT(IA1,IA2)  = BSWT(IA1,IA2) + WT
               NSGRID = NSGRID + 1
            ELSE
               NNGRID = NNGRID + 1
            END IF
      END IF
C
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('   Size of image = (',I2,',',I2,')')
 1200 FORMAT ('   Number of integration periods = ',I5)
 1300 FORMAT ('   Number of vis. gridded = ',I7,', not gridded = ',I7)
 1400 FORMAT ('   Peak flux = ',1PE11.3,' Jy/beam')
 1500 FORMAT ('BSINV: ERROR',I3,' WRITING ARRAY TO AIPS FILES')
 1600 FORMAT ('BSINV: ERROR: BEAM PEAK IS ZERO')
 1700 FORMAT ('ERROR = ',1PE11.3,' / Specified noise per weight')
 1800 FORMAT ('/ Uniform weighting')
 1900 FORMAT ('/ Natural weighting')
 2000 FORMAT ('/ Estimated point source flux = ',
     *   1PE11.3,' Jy')
 2100 FORMAT ('/ Integration time = ',F7.3,' minutes')
 2200 FORMAT ('/ BSINV DID NOT CONVERGE: DUBIOUS IMAGES ')
      END
      SUBROUTINE BSGRID (DOINIT, NANT, UCELL, VCELL, BSVIS, BSWT,
     *      VISVAR, NUBSA, NVBSA, BSARRY, BSWTS, BSNUM, BS, WAVE, IERR)
C-----------------------------------------------------------------------
C Grids U,V data for Bi-spectrum analysis.
C
C Inputs:
C     DOINIT L     Initialise BSARRY and BSWTS
C     NANT   I     Maximum number of antennas
C     UCELL  R     Array of U coordinates, in units of cells
C     VCELL  R     Array of V coordinates, in units of cells
C     BSVIS  C*8   Array of visibilities.
C     BSWT   R     Array of weights.
C     VISVAR R     Variance of one weights worth of data
C     NUBSA  I     Size of BSARRY
C     NVBSA  I     Size of BSARRY
C
C Output:
C     BSARRY C*8   Gridded data
C     BSWTS  R     Variance
C     BSNUM  I     Number of samples
C     BS     C*8   Averaged Bi-spectrum
C     WAVE   R     Weight for BS
C     IERR   I     Error status
C
C  Programmer: T.J. Cornwell July 1986
C-----------------------------------------------------------------------
      INTEGER MAXANT
      PARAMETER (MAXANT=28)
C                                       Arguments
      LOGICAL   DOINIT
      INTEGER   IERR, NANT
      INTEGER NUBSA, NVBSA
      REAL   VISVAR, WAVE
      REAL   UCELL(MAXANT,*), VCELL(MAXANT,*)
      REAL   BSWT(MAXANT,*)
      COMPLEX BSVIS(MAXANT,MAXANT)
      COMPLEX BSARRY(-NUBSA:NUBSA,-NVBSA:NVBSA,-NUBSA:NUBSA,
     *   -NVBSA:NVBSA)
      INTEGER    BSNUM (-NUBSA:NUBSA,-NVBSA:NVBSA,-NUBSA:NUBSA,
     *   -NVBSA:NVBSA)
      REAL    BSWTS (-NUBSA:NUBSA,-NVBSA:NVBSA,-NUBSA:NUBSA,
     *   -NVBSA:NVBSA)
C                                       Local variables
      INTEGER   IA1, IA2, IA3, IU1, IU2, IV1, IV2
      REAL   VARBS, AMP1, AMP2, AMP3, VAR1, VAR2, VAR3
      COMPLEX BS, BSAVE
      SAVE BSAVE
C
C-----------------------------------------------------------------------
C
      IERR = 0
C                                       Set initial values
      IF (DOINIT) THEN
         WAVE = 0.0
         BSAVE = 0.0
         DO 40 IV2 = -NVBSA, NVBSA
            DO 30 IU2 = -NUBSA, NUBSA
               DO 20 IV1 = -NVBSA, NVBSA
                  DO 10 IU1 = -NUBSA, NUBSA
                     BSARRY(IU1,IV1,IU2,IV2) = 0.0
                     BSWTS (IU1,IV1,IU2,IV2) = 0.0
                     BSNUM(IU1,IV1,IU2,IV2) = 0
  10              CONTINUE
  20           CONTINUE
  30        CONTINUE
  40     CONTINUE
      END IF
C
      DO 130 IA1 = 1, NANT
         DO 120 IA2 = IA1+1, NANT
            IF (BSWT(IA1, IA2).GT.0.0) THEN
C                                       Simple cell summing
            IU1 = NINT(UCELL(IA1,IA2))
            IV1 = NINT(VCELL(IA1,IA2))
C                                       Check for spillover
            IF ((ABS(IU1).LE.NUBSA).AND.(ABS(IV1).LE.NVBSA)) THEN
            AMP1 = ABS(BSVIS(IA1, IA2))**2
            VAR1 = VISVAR/BSWT(IA1, IA2)
            DO 110 IA3 = IA2+1, NANT
               IF ((BSWT(IA2,IA3).GT.0.0).AND.(BSWT(IA1,IA3).GT.0.0))
     *            THEN
C                                       Simple cell summing only
               IU2 = NINT(UCELL(IA2,IA3))
               IV2 = NINT(VCELL(IA2,IA3))
               IF ((ABS(IU2).LE.NUBSA).AND.(ABS(IV2).LE.NVBSA)) THEN
               AMP2 = ABS(BSVIS(IA2, IA3))**2
               AMP3 = ABS(BSVIS(IA1, IA3))**2
               VAR2 = VISVAR/BSWT(IA2, IA3)
               VAR3 = VISVAR/BSWT(IA1, IA3)
C                                       Variance of bi-spectrum
               VARBS = VAR1*AMP2*AMP3 + AMP1*VAR2*AMP3 + AMP1*AMP2*VAR3
     *            +    VAR1*VAR2*AMP3 + AMP1*VAR2*VAR3 + VAR1*AMP2*VAR3
     *            +    VAR1*VAR2*VAR3
               IF(VARBS.GT.0.0) THEN
                  BS = BSVIS(IA1,IA2) * BSVIS(IA2,IA3) *
     *               CONJG(BSVIS(IA1,IA3))
                  BSAVE = BSAVE + BS
                  WAVE  = WAVE  + 1.0
                  BSARRY(IU1,IV1,IU2,IV2) =
     *               BSARRY (IU1,IV1,IU2,IV2) + BS
                  BSWTS(IU1,IV1,IU2,IV2)  =
     *               BSWTS (IU1,IV1,IU2,IV2) + VARBS
                  BSNUM(IU1,IV1,IU2,IV2) =
     *               BSNUM (IU1,IV1,IU2,IV2) + 1
               END IF
               END IF
               END IF
  110       CONTINUE
         END IF
         END IF
  120    CONTINUE
  130 CONTINUE
C
      IF (WAVE.GT.0.0) THEN
         BS = BSAVE/WAVE
      ELSE
         BS = 0.0
      END IF
C
  999 RETURN
      END
      SUBROUTINE BSINV (FLUX, NUBSA, NVBSA, BSARRY, BSWTS, BSNUM,
     *   BSAINV, BSAWT, DOUNIF, DAINV, HAINV, IERR)
C-----------------------------------------------------------------------
C Solves for gridded u,v data from Bi-spectrum.
C Inputs:
C     FLUX   R     Initial guess will be point source of strength FLUX
C     NUBSA  I     Size of BSARRY
C     NVBSA  I     Size of BSARRY
C     BSARRY C*8   Gridded Bi-spectrum
C     BSWTS  R     Weights
C     BSNUM  I     Number of samples
C     DOUNIF L     Apply uniform weighting
C Outputs:
C     BSAINV C*8   Gridded u,v data
C     BSAWT  R     Weights of gridded u,v data
C     IERR   I     Error status
C  Programmer: T.J. Cornwell July 1986
C-----------------------------------------------------------------------
C                                       Arguments
      INTEGER   IERR
      LOGICAL   DOUNIF
      INTEGER NUBSA, NVBSA
      COMPLEX BSARRY(-NUBSA:NUBSA,-NVBSA:NVBSA,-NUBSA:NUBSA,
     *   -NVBSA:NVBSA)
      REAL    BSWTS (-NUBSA:NUBSA,-NVBSA:NVBSA,-NUBSA:NUBSA,
     *   -NVBSA:NVBSA)
      INTEGER    BSNUM (-NUBSA:NUBSA,-NVBSA:NVBSA,-NUBSA:NUBSA,
     *   -NVBSA:NVBSA)
      COMPLEX BSAINV(-NUBSA:NUBSA,-NVBSA:NVBSA)
      COMPLEX BSAWT (-NUBSA:NUBSA,-NVBSA:NVBSA)
      COMPLEX BSAERR
C
      COMPLEX DAINV(-NUBSA:NUBSA,-NVBSA:NVBSA)
      COMPLEX HAINV(-NUBSA:NUBSA,-NVBSA:NVBSA)
C                                       Local variables
      INTEGER   IU1, IU2, IV1, IV2, IU3, IV3
      INTEGER   ITER, NITER
      REAL   S, OLDN, N, EPS, GAIN, SUMWT, FLUX, CHISQ,
     *   ERROR
      COMPLEX BSTMP
      INCLUDE 'INCS:DMSG.INC'
      DATA NITER /100/
      DATA GAIN /0.5/
      DATA EPS / 1E-4/
C-----------------------------------------------------------------------
      IERR = 0
C                                       Correct weighting. Set initial
C                                       guess, etc.
      N = 0.0
      S = 0.0
      SUMWT = 0.0
      DO 9 IV2 = -NVBSA, NVBSA
         DO 8 IU2 = -NUBSA, NUBSA
            DO 7 IV1 = -NVBSA, NVBSA
               DO 6 IU1 = -NUBSA, NUBSA
                  IF (BSNUM(IU1,IV1,IU2,IV2).GT.0.0) THEN
C                                       Correct for summation
                     BSARRY(IU1,IV1,IU2,IV2) =
     *                  BSARRY(IU1,IV1,IU2,IV2)/BSNUM (IU1,IV1,IU2,IV2)
C                                       Convert to inverse variance
                     BSWTS(IU1,IV1,IU2,IV2) =
     *                  BSNUM(IU1,IV1,IU2,IV2)/BSWTS (IU1,IV1,IU2,IV2)
C                                       Initial guess is a point source
C                                       of strength FLUX. Only fill in
C                                       those points with data.
                     BSAINV(IU1,IV1) = FLUX
                     BSAINV(IU2,IV2) = FLUX
                     IU3 = - IU1 - IU2
                     IV3 = - IV1 - IV2
                     BSAINV(IU3,IV3) = FLUX
                  END IF
C                                       Accumulate signal
                  S = S + ABS(BSARRY(IU1,IV1,IU2,IV2))**2 *
     *               BSWTS (IU1,IV1,IU2,IV2)
                  SUMWT = SUMWT + BSWTS(IU1,IV1,IU2,IV2)
C                                       Error in bi-spectrum
                  BSAERR = BSAINV(IU1,IV1) * BSAINV(IU2, IV2) *
     *               BSAINV(IU3,IV3) - BSARRY(IU1,IV1,IU2,IV2)
C                                       Accumulate error
                  N = N + ABS(BSAERR)**2 * BSWTS (IU1,IV1,IU2,IV2)
  6            CONTINUE
  7          CONTINUE
  8       CONTINUE
  9    CONTINUE
C                                       Write initial misfit
      ERROR = (N/SUMWT)**(1.0/6.0)
      WRITE (MSGTXT,1000) ERROR
      CALL MSGWRT (4)
C                                       Initialise arrays
      DO 20 IV1 = -NVBSA, NVBSA
         DO 10 IU1 = -NUBSA, NUBSA
            DAINV(IU1,IV1) = 0.0
            HAINV(IU1,IV1) = 0.0
  10     CONTINUE
  20  CONTINUE
C                                       Iterate to find result
      DO 700 ITER = 1, NITER
C                                       Find suggested changes.
C                                       Also accumulate current errors
      OLDN = N
      N = 0.0
      DO 240 IV2 = -NVBSA, NVBSA
         DO 230 IU2 = -NUBSA, NUBSA
            DO 220 IV1 = -NVBSA, NVBSA
               IV3 = - IV1 - IV2
               IF ((IV3.GE.-NVBSA).AND.(IV3.LE.NVBSA)) THEN
               DO 210 IU1 = -NUBSA, NUBSA
                  IF (BSWTS (IU1,IV1,IU2,IV2).GT.0.0) THEN
                     IU3 = - IU1 - IU2
                     IF ((IU3.GE.-NUBSA).AND.(IU3.LE.NUBSA)) THEN
C                                       Error in bi-spectrum
                        BSAERR = BSAINV(IU1,IV1) * BSAINV(IU2, IV2) *
     *                     BSAINV(IU3,IV3) - BSARRY(IU1,IV1,IU2,IV2)
C                                       Accumulate error
                        N = N + ABS(BSAERR)**2 * BSWTS (IU1,IV1,IU2,IV2)
                        BSTMP = BSAERR * BSWTS(IU1,IV1,IU2,IV2)
C                                       First derivative
                        DAINV(IU1,IV1) = DAINV(IU1,IV1) + BSTMP *
     *                     CONJG(BSAINV(IU2,IV2) * BSAINV(IU3,IV3))
                        DAINV(IU2,IV2) = DAINV(IU2,IV2) + BSTMP *
     *                     CONJG(BSAINV(IU1,IV1) * BSAINV(IU3,IV3))
                        DAINV(IU3,IV3) = DAINV(IU3,IV3) + BSTMP *
     *                     CONJG(BSAINV(IU1,IV1) * BSAINV(IU2,IV2))
C                                       Second derivative
                        HAINV(IU1,IV1) = HAINV(IU1,IV1) +
     *                     ABS(BSAINV(IU2,IV2) * BSAINV(IU3,IV3))**2 *
     *                     BSWTS(IU1,IV1,IU2,IV2)
                        HAINV(IU2,IV2) = HAINV(IU2,IV2) +
     *                     ABS(BSAINV(IU1,IV1) * BSAINV(IU3,IV3))**2 *
     *                     BSWTS(IU1,IV1,IU2,IV2)
                        HAINV(IU3,IV3) = HAINV(IU3,IV3) +
     *                     ABS(BSAINV(IU1,IV1) * BSAINV(IU2,IV2))**2
     *                     * BSWTS(IU1,IV1,IU2,IV2)
C
                     END IF
                  END IF
 210           CONTINUE
            END IF
 220        CONTINUE
 230     CONTINUE
 240  CONTINUE
C                                       Stop if current solution OK or
C                                       if convergence has ceased
      IF ((N.LE.EPS**2*S).OR.ABS(N-OLDN).LT.EPS*OLDN) THEN
         IF (ITER.GT.1) GO TO 900
      END IF
C                                       Take damped step using
C                                       approximate Newton-Raphson
C                                       method.
      DO 520 IV1 = -NVBSA, NVBSA
         DO 510 IU1 = -NUBSA, NUBSA
            IF (CABS(HAINV(IU1,IV1)).NE.0.0) THEN
               BSAINV(IU1,IV1) = BSAINV(IU1,IV1) -
     *            GAIN * DAINV(IU1,IV1)/HAINV(IU1,IV1)
               BSAWT (IU1,IV1) = HAINV(IU1,IV1)
            ELSE
               BSAWT(IU1,IV1) = 0.0
            END IF
            DAINV(IU1,IV1) = 0.0
            HAINV(IU1,IV1) = 0.0
 510     CONTINUE
 520  CONTINUE
C
  700 CONTINUE
C                                       If we got here then the fit
C                                       did not converge
      IERR = 1
C                                       If we jumped directly here
C                                       then the fit did converge
  900 CONTINUE
C                                       Apply weighting
      IF (.NOT.DOUNIF) THEN
         DO 720 IV1 = -NVBSA, NVBSA
            DO 710 IU1 = -NUBSA, NUBSA
               BSAINV(IU1,IV1) = BSAWT(IU1,IV1) * BSAINV(IU1,IV1)
 710        CONTINUE
 720     CONTINUE
      ELSE
         DO 740 IV1 = -NVBSA, NVBSA
            DO 730 IU1 = -NUBSA, NUBSA
               IF (ABS(BSAWT(IU1,IV1)).GT.0.0) THEN
                  BSAWT(IU1,IV1) = 1.0
               END IF
 730        CONTINUE
 740     CONTINUE
      END IF
C
      ITER = MIN (ITER, NITER)
      ERROR = (N/SUMWT)**(1.0/6.0)
      CHISQ = N
      WRITE (MSGTXT,1100) ITER, ERROR
      CALL MSGWRT (4)
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('   Initial misfit = ',1PE11.3,' Jy')
 1100 FORMAT ('  ',I3,' Iterations, misfit = ',1PE11.3,' Jy')
      END
      SUBROUTINE FTUVIM (NX, NY, NU, NV, UVFN, TIMFN, IMFN, RMAX, RMIN)
C-----------------------------------------------------------------------
C Transform from U,V plane to image plane using full-plane transform
C Programmer: T.J. Cornwell July 1986
C-----------------------------------------------------------------------
      INTEGER MAXFFT
C                                       MAX. SIZE OF FFT REQUIRED
      PARAMETER (MAXFFT = 128)
C
      INTEGER NX, NY, IX, IY, NU, NV, IU, IV
      COMPLEX  UVFN(-NU:NU,-NV:NV)
      COMPLEX TIMFN(2*NX+1, 2*NY+1)
      REAL     IMFN(2*NX+1, 2*NY+1)
C                                       BUFFER FOR FFTS
      COMPLEX FFTBUF(MAXFFT)
      REAL   RMAX, RMIN, SINC
      INTEGER SIZFFT, FFTSZU, PWR2X, IFFT, FFTSZV, PWR2Y
C-----------------------------------------------------------------------
C
      RMAX = -1E20
      RMIN =  1E20
      FFTSZU = SIZFFT(2*NX)
      FFTSZV = SIZFFT(2*NY)
      PWR2X = NINT(LOG(REAL(FFTSZU))/LOG(2.0))
      PWR2Y = NINT(LOG(REAL(FFTSZV))/LOG(2.0))
C
C DO ROW TRANSFORMS FIRST
C
      DO 20 IV = -NV, NV
C
      DO 10 IFFT = 1, FFTSZU
      FFTBUF(IFFT) = 0.0
   10 CONTINUE
      DO 30 IU = -NU, -1
      FFTBUF(FFTSZU+IU+1) = UVFN(IU, IV)
   30 CONTINUE
      DO 40 IU = 0, NU
      FFTBUF(IU+1) = UVFN(IU, IV)
   40 CONTINUE
C
      CALL FFT(FFTBUF, PWR2X, FFTSZU, -1)
C
      DO 50 IX = -NX, -1
      TIMFN(IX, IV) = FFTBUF(FFTSZU+IX+1)
   50 CONTINUE
      DO 60 IX = 0, NX
      TIMFN(IX, IV) = FFTBUF(IX+1)
   60 CONTINUE
   20 CONTINUE
C
C NOW DO COLUMNS. NOTE BRUTE FORCE TRANSPOSE !
C
      DO 120 IX = -NX, NX
C
      DO 110 IFFT = 1, FFTSZV
      FFTBUF(IFFT) = 0.0
  110 CONTINUE
      DO 130 IV = -NV, -1
      FFTBUF(FFTSZV+IV+1) = TIMFN(IX, IV)
  130 CONTINUE
      DO 140 IV = 0, NV
      FFTBUF(IV+1) = TIMFN(IX, IV)
  140 CONTINUE
C
      CALL FFT(FFTBUF, PWR2Y, FFTSZV, -1)
C
      DO 150 IY = -NY, -1
      IMFN(IX+NX+1, IY+NY+1) =
     *   REAL(FFTBUF(FFTSZV+IY+1))/(REAL(FFTSZU)*REAL(FFTSZV))
     *   / (SINC (REAL(IX)/REAL(2*NX)) * SINC (REAL(IY)/REAL(2*NY)))
      RMAX = MAX(RMAX, IMFN(IX+NX+1, IY+NY+1))
      RMIN = MIN(RMIN, IMFN(IX+NX+1, IY+NY+1))
  150 CONTINUE
      DO 160 IY = 0, NY
      IMFN(IX+NX+1, IY+NY+1) =
     *   REAL(FFTBUF(IY+1))/(REAL(FFTSZU)*REAL(FFTSZV))
     *   / (SINC (REAL(IX)/REAL(2*NX)) * SINC (REAL(IY)/REAL(2*NY)))
      RMAX = MAX(RMAX, IMFN(IX+NX+1, IY+NY+1))
      RMIN = MIN(RMIN, IMFN(IX+NX+1, IY+NY+1))
  160 CONTINUE
  120 CONTINUE
C
      RETURN
      END
      SUBROUTINE FFT (A,M,N,IDIR)
C-----------------------------------------------------------------------
C Does in-place complex FFT using decimation-in-time routine due
C to Cooley, Lewis and Welch
C-----------------------------------------------------------------------
      INTEGER M, N, IDIR
      COMPLEX A(N),U,W,T
      REAL PI
      INTEGER NV2, NM1, I, J, K, L, LE, LE1, IP
C-----------------------------------------------------------------------
      PI = 3.141592653589793*IDIR
      N = 2**M
      NV2 = N/2
      NM1 = N - 1
      J = 1
      DO 7 I = 1,NM1
         IF (I.LT.J) THEN
            T = A(J)
            A(J) = A(I)
            A(I) = T
            END IF
         K = NV2
 6       IF (K .LT. J) THEN
            J = J - K
            K = K/2
            GO TO 6
            END IF
         J = J + K
 7       CONTINUE
      DO 20 L = 1,M
         LE = 2**L
         LE1 = LE/2
         U = (1.,0.)
         W = CMPLX(COS(PI/LE1),SIN(PI/LE1))
         DO 19 J = 1,LE1
            DO 10 I = J,N,LE
               IP = I + LE1
               T = A(IP) * U
               A(IP) = A(I) - T
               A(I) = A(I) + T
 10            CONTINUE
            U = U * W
 19         CONTINUE
 20      CONTINUE
C
      RETURN
      END
      INTEGER FUNCTION SIZFFT (N)
C
C RETURNS SMALLEST POWER OF 2 GREATER THAN N
C
      INTEGER N, I
C-----------------------------------------------------------------------
C
      SIZFFT = 2
      DO 10 I = 1, 20
      IF (SIZFFT.GE.N) RETURN
      SIZFFT = SIZFFT * 2
   10      CONTINUE
      WRITE (6, *) 'ERROR : CANNOT FIND FFT SIZE FOR N = ',N
      SIZFFT = 4
      RETURN
      END
      SUBROUTINE DMPMAP (DISKIN, OLDCNO, MAPARY, NX, NY, SOURCE, CELLS,
     *   RA, DEC, FREQ, BANDW, STKTYP, NAMOUT,
     *   CLAOUT, SEQOUT, DISKO, NUMHIS, HISCRD, BUFFER, JBUFSZ,
     *   IERR)
C-----------------------------------------------------------------------
C These routines will dump an Fortran array into an AIPS image file.
C The image header is only filled in with the most basic parameters. You
C should call CATIO, etc properly afterwards.
C Inputs:
C  MAPARY(NX,*)      C*4   Map array to be dumped
C  NX                I
C  NY                I
C  SOURCE            C*8   Source name
C  XMSIZE(2)         R     Output image Size
C  CELLS(2)          R     Output cell size in arcseconds
C  RA                D     Right Ascension
C  DEC               D     Declination
C  FREQ              D     Frequency in Hz
C  BANDW             R     Bandwidth in Hz
C  STPTYP            D     Stokes type
C  NAMOUT            C*12  Name of output image
C  CLAOUT            C*6   Class of output image
C  SEQOUT            I     Sequence of output image
C  DISKO             I     Disk of output image
C  NUMHIS            I     Number of history cards
C  HISCRD(*)*64      C     History cards
C
C Output:
C  IERR              I     Error status
C                              = 0 then OK
C                              > 0 then error
C Freely adapted from CANDY by Tim Cornwell, July 1986.
C-----------------------------------------------------------------------
      CHARACTER OLDNAM*12, BLANK*6, NAMOUT*12, CLAOUT*6, DEFNAM*12,
     *   SOURCE*8
      INTEGER   DISKIN, OLDCNO, IRET
C
      INTEGER   IERR
      INTEGER   SEQOUT, DISKO, NEWCNO, NUMHIS, JBUFSZ
      INTEGER   NX, NY
      REAL      XMSIZE(2), CELLS(2), BANDW, BUFFER(*), MAPARY(NX, *),
     *   INDEF
      CHARACTER HISCRD(10)*64
      DOUBLE PRECISION RA, DEC, FREQ, STKTYP
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
C                                       Change this default output name
      DATA DEFNAM, BLANK /'DMP   MAP   ','      '/
C-----------------------------------------------------------------------
      INDEF = FBLANK
C                                       create output file if nec.
      IRET = 0
C                                       Init CATBLK.
      CALL FILL (256, 0, CATBLK)
C                                       Create new file.
C                                       Put values in CATBLK.
      OLDNAM = DEFNAM
      CALL MAKOUT (OLDNAM, BLANK, 0, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
      CATBLK(KIIMS) = SEQOUT
C
      XMSIZE(1) = REAL(NX)
      XMSIZE(2) = REAL(NY)
C                                       Get user modification to CATBLK
      IRET = 4
      CALL DMPHED (SOURCE, CELLS, XMSIZE, RA, DEC, FREQ, BANDW,
     *   STKTYP, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create output file.
      NEWCNO = 1
      IRET = 4
      CALL MCREAT (DISKO, NEWCNO, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 70
         WRITE (MSGTXT,1060) IERR
         GO TO 990
 70   NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
C                                       Set obs. date=current date.
      CATH(KHDOB) = CATH(KHDMP)
      CATH(KHDOB+1) = CATH(KHDMP+1)
C                                       Call routine that sends data
C                                       to the user routine.
      IF (IRET.EQ.0) CALL DMPIT (MAPARY, NX, DISKO, NEWCNO, BUFFER,
     *   JBUFSZ, IRET)
C                                       History
      IF (IRET.EQ.0) CALL DMPHIS (SOURCE, CELLS, NAMOUT,
     *   CLAOUT, SEQOUT, DISKO, NEWCNO, NUMHIS, HISCRD, BUFFER,
     *   IRET)
C
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1060 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE DMPIT (MAPARY, NX, DISKO, NEWCNO, BUFFER, JBUFSZ,
     *   IRET)
C-----------------------------------------------------------------------
C   DMPIT actually writes the output file.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET, LUNO,  NX,
     *   NXO, NYO, WINO(4), BOO, LIM2, LIM3, LIM4,
     *   LIM5, LIM6, LIM7, I1, I2, I3, I4, I5, I6, I7, IPOS(7),
     *   LIMO, LIMIT, OBIND, INDO, LIM1
      INTEGER   NEWCNO, DISKO, JBUFSZ, BOTEMP
      REAL   BUFFER(*), OUTMAX, OUTMIN, MAPARY(NX, *)
      CHARACTER IFILE*48
      LOGICAL   T, F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNO /17/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Create scratch file.
C                                       Open vis file for write
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, F, F, IRET)
      IF (IRET.LE.0) GO TO 30
         WRITE (MSGTXT,1020) IRET
         GO TO 990
C                                       Setup for I/O
 30   NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      OUTMAX = -1.0E20
      OUTMIN = 1.0E20
C                                       Setup for looping
      LIM1 = MAX (1, CATBLK(KINAX))
      LIM2 = MAX (1, CATBLK(KINAX+1))
      LIM3 = MAX (1, CATBLK(KINAX+2))
      LIM4 = MAX (1, CATBLK(KINAX+3))
      LIM5 = MAX (1, CATBLK(KINAX+4))
      LIM6 = MAX (1, CATBLK(KINAX+5))
      LIM7 = MAX (1, CATBLK(KINAX+6))
      IPOS(1) = 1
      LIMO = CATBLK(KINAX) - 1
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = I4
                  DO 300 I3 = 1,LIM3
      IPOS(3) = I3
C                                       Init output file.
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IPOS(3),
     *   BOTEMP, IRET)
      BOO = BOTEMP + 1
      CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO, BUFFER, JBUFSZ,
     *   BOO, IRET)
      IF (IRET.EQ.0) GO TO 120
         WRITE (MSGTXT,1100) 'WRIT', IRET
         GO TO 990
 120  DO 250 I2 = 1,LIM2
         IPOS(2) = I2
C                                       Write.
         CALL MDISK ('WRIT', LUNO, INDO, BUFFER, OBIND, IRET)
         OBIND = OBIND - 1
         IF (IRET.EQ.0) GO TO 180
            WRITE (MSGTXT,1120) 'WRIT', IRET
            GO TO 990
C                                       Fill in array
 180     OBIND = OBIND + 1
         CALL RCOPY (LIM1, MAPARY(1,I2), BUFFER(OBIND))
C                                       Check max, min, blanking.
         LIMIT = OBIND + LIMO
         DO 200 I1 = OBIND,LIMIT
            OUTMAX = MAX (OUTMAX, BUFFER(I1))
            OUTMIN = MIN (OUTMIN, BUFFER(I1))
 200        CONTINUE
 250     CONTINUE
C                                       Dump plane to output.
C                                       Flush buffer.
      CALL MDISK ('FINI', LUNO, INDO, BUFFER, OBIND, IRET)
      IF (IRET.EQ.0) GO TO 260
         WRITE (MSGTXT,1120) 'FINI', IRET
         GO TO 990
C                                       Update CATBLK.
 260  CATR(KRDMX) = OUTMAX
      CATR(KRDMN) = OUTMIN
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', BUFFER, IRET)
      IF (IRET.EQ.0) GO TO 300
         WRITE (MSGTXT,1260) IRET
         GO TO 990
 300  CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Mark blanking in CATBLK.
      CATR(KRBLK) = 0.0
C
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('DMPIT: ERROR',I3,' OPENING SCRATCH FILE')
 1100 FORMAT ('DMPIT: INIT-FOR-',A4,' ERROR',I3)
 1120 FORMAT ('DMPIT: ',A4,' ERROR',I3)
 1260 FORMAT ('DMPIT: CATIO ERROR',I3,' UPDATING CATBLK')
      END
      SUBROUTINE DMPHIS (SOURCE, CELLS, NAMOUT, CLAOUT, SEQOUT, DISKO,
     *   NEWCNO, NUMHIS, HISCRD, BUFFER, IERR)
C-----------------------------------------------------------------------
C   DMPHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER   NAMOUT*12, CLAOUT*6, ATIME*8, ADATE*12, SOURCE*8
      INTEGER   LUN, IERR, I
      INTEGER   SEQOUT, DISKO, NEWCNO, NUMHIS, TIME(3), DATE(3)
      REAL      XMSIZE(2), CELLS(2), BUFFER(*)
      CHARACTER LABEL*8, HILINE*72, HISCRD(10)*64
      LOGICAL   T
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Create/open hist. file.
      CALL HICREA (LUN, DISKO, NEWCNO, CATBLK, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 999
C                                       Get current date/time.
 10   CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
C                                       Write first record.
      WRITE (HILINE,1010) TSKNAM, NLUSER, ADATE, ATIME
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       New history
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN,
     *   BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       SOURCE
      WRITE (HILINE,2000) TSKNAM, SOURCE
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       IMSIZE
      WRITE (HILINE,2001) TSKNAM, XMSIZE
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       CELLSIZE
      WRITE (HILINE,2002) TSKNAM, CELLS
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       AIPS release
      WRITE (HILINE,2004) TSKNAM, RLSNAM
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                      Add any user supplied history.
      IF (NUMHIS.LE.0) GO TO 20
         WRITE (LABEL,1011) TSKNAM
         DO 15 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 20
 15         CONTINUE
C                                       Close HI file
 20   CALL HICLOS (LUN, T, BUFFER, IERR)
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', BUFFER, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DMPHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,'/ Image created by user',I5,' at ',A12,2X,A8)
 1011 FORMAT (A6,' /')
 2000 FORMAT (A6,' SOURCE = ''',A8,'''')
 2001 FORMAT (A6,' IMSIZE = ', 2F8.0)
 2002 FORMAT (A6,' CELLSIZE = ',2F10.5)
 2004 FORMAT (A6,' RELEASE = ''',A7,' ''')
      END
      SUBROUTINE DMPHED (SOURCE, CELLS, XMSIZE, RA, DEC, FREQ,
     *   BANDW, STKTYP, IRET)
C-----------------------------------------------------------------------
C    Input:
C     CATBLK(256)    I     Output catalog header, also CATR, CATD
C                          The OUTNAME, OUTCLASS, OUTSEQ are entered
C                          elsewhere.
C  RA                D     Right Ascension
C  DEC               D     Declination
C  FREQ              D     Frequency in Hz
C  BANDW             R     Bandwidth in Hz
C    Output:
C     CATBLK(256)    I     Modified output catalog header.
C     IRET           I     Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER BLANK*8, UNITS(10)*8, ATYPES(7)*8, SOURCE*8
      INTEGER   I, NAXIS, IRET, IROUND, INDEX
      REAL      CELLS(2), XMSIZE(2), BANDW
      DOUBLE PRECISION RA, DEC, FREQ, STKTYP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA BLANK /' '/
C                                       User definable values
C                                       Two R   words with 4 char. ea.
      DATA UNITS /'JY/BEAM ',9*'        '/
C                                       Number of axes and types.
C                                       (Set for two axes = Ra, Dec.)
      DATA NAXIS  /4/
      DATA ATYPES /'RA---SIN', 'DEC--SIN',
     *   'STOKES  ', 'FREQ    ', 3*'        '/
C-----------------------------------------------------------------------
C                                       Set output units.
      CALL CHR2H (8, UNITS(1), 1, CATH(KHBUN))
C                                       Fill axis arrays.
      DO 30 I = 1,KICTPN
C                                       Init dimension
         CATBLK(KINAX+I-1) = 1
C                                       Init. increment.
         CATR(KRCIC+I-1) = 0.0
C                                       Init. ref pixel.
         CATR(KRCRP+I-1) = 1.0
C                                       Init. ref value.
         CATD(KDCRV+I-1) = 0.0D0
C                                       Fill axis type from
C                                       ATYPES or BLANK.
         INDEX = KHCTP + (I-1) * 2
         CALL CHR2H (8, BLANK, 1, CATH(INDEX))
         IF (I.LE.NAXIS)
     *      CALL CHR2H (8, ATYPES(I), 1, CATH(INDEX))
C                                       Blank Random axes.
         INDEX = KHPTP + (I-1) * 2
         CALL CHR2H (8, BLANK, 1, CATH(INDEX))
 30      CONTINUE
C                                       Fill in values.
      CATBLK(KINAX) = MAX (IROUND (XMSIZE(1)), 1)
      CATBLK(KINAX+1) = MAX (IROUND (XMSIZE(2)), 1)
C                                       Axis values
      CATD(KDCRV)   = RA
      CATD(KDCRV+1) = DEC
C                                       Stokes
      CATD(KDCRV+2) = STKTYP
      CATR(KRCIC+2) = 1.0
C                                       Frequency
      CATD(KDCRV+3) = FREQ
      CATR(KRCIC+3) = BANDW
C                                       Assume CELLS in sec.
C                                       NOTE: Ra decreases with
C                                       grid number.
      CATR(KRCIC) = - CELLS(1) / 3600.
      CATR(KRCIC+1) = CELLS(2) / 3600.
C                                       Fill other character strings.
C                                       Object.
      CALL CHR2H (8, SOURCE, 1, CATH(KHOBJ))
C                                       Observation date.
      CALL CHR2H (8, BLANK, 1, CATH(KHDOB))
C                                       Telescope.
      CALL CHR2H (8, BLANK, 1, CATH(KHTEL))
C                                       Receiver
      CALL CHR2H (8, BLANK, 1, CATH(KHINS))
C                                       Observer's name.
      CALL CHR2H (8, BLANK, 1, CATH(KHOBS))
C                                       Set number of axes.
      CATBLK(KIDIM) = NAXIS
      CATBLK(KIPCN) = 0
C                                       User ID
      CATBLK(KIIMU) = NLUSER
C                                       Miscellaneous items.
C                                       Epoch.
      CATR(KREPO) = 0.0
C                                       Convolving beam
      CATR(KRBMJ) = 0.0
      CATR(KRBMN) = 0.0
      CATR(KRBPA) = 0.0
C                                       Max. min.
      CATR(KRDMX) = 0.0
      CATR(KRDMN) = 0.0
C                                       Put other checks here.
C                                       Finished.
      IRET = 0
      GO TO 999
C
 999  RETURN
      END
      SUBROUTINE RENORM (N, A, FACT)
C-----------------------------------------------------------------------
C Normalise an array
C-----------------------------------------------------------------------
      INTEGER N, I
      REAL   A(N)
      REAL   FACT
C-----------------------------------------------------------------------
      DO 10 I = 1,N
         A(I) = A(I) * FACT
  10  CONTINUE
C
      RETURN
      END
      REAL FUNCTION SINC(X)
C-----------------------------------------------------------------------
C   Compute Sin(x) / x function
C-----------------------------------------------------------------------
      REAL X, PI
      DATA PI /3.141592653589793/
C-----------------------------------------------------------------------
      IF (X.EQ.0.0) THEN
         SINC = 1.0
      ELSE
         SINC = SIN(PI*X) / (PI*X)
         END IF
 999  RETURN
      END

      SUBROUTINE B2J (R1950, D1950, BEPOCH, R2000, D2000)
C-------------------------------------------------------------------
C! Convert B1950 to J2000 positions of the source
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to convert B1950.0 coordinates to J2000
C   Input:
C      R1950,D1950 D     B1950.0 RA, Dec (rad)
C      BEPOCH      D     Besselian epoch (e.g. 1979.3D0)
C   Output:
C      R2000,D2000 D     J2000.0 RA, Dec (rad)
C
C   This subroutine is a modified verion of the SLALIB routine FK45Z
C   written by P.T.Wallace   Starlink   10 April 1990,
C   Rutherford Appleton Laboratory
C-----------------------------------------------------------------------
      DOUBLE PRECISION R1950, D1950, BEPOCH, R2000, D2000
      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925287D0)
      DOUBLE PRECISION W, EPB2D
      INTEGER I,J
C                                       Position and position+velocity
C                                       vectors
      DOUBLE PRECISION R0(3),A1(3),V1(3),V2(6)
C                                       Radians per year to arcsec per
C                                       century
      DOUBLE PRECISION PMF
      PARAMETER (PMF=100D0*60D0*60D0*360D0/D2PI)
C
      DOUBLE PRECISION A(3), AD(3), EM(6,3), R, COSB
      DATA A, AD/ -1.62557D-6,  -0.31919D-6, -0.13843D-6,
     *           +1.245D-3,    -1.580D-3,   -0.659D-3/
C
      DATA (EM(I,1),I=1,6) / +0.9999256782D0,
     *                       +0.0111820610D0,
     *                       +0.0048579479D0,
     *                       -0.000551D0,
     *                       +0.238514D0,
     *                       -0.435623D0 /
C
      DATA (EM(I,2),I=1,6) / -0.0111820611D0,
     *                       +0.9999374784D0,
     *                       -0.0000271474D0,
     *                       -0.238565D0,
     *                       -0.002667D0,
     *                       +0.012254D0 /
C
      DATA (EM(I,3),I=1,6) / -0.0048579477D0,
     *                       -0.0000271765D0,
     *                       +0.9999881997D0,
     *                       +0.435739D0,
     *                       -0.008541D0,
     *                       +0.002117D0 /
C-----------------------------------------------------------------------
C                                       Spherical to Cartesian
      COSB = COS(D1950)
      R0(1) = COS(R1950) * COSB
      R0(2) = SIN(R1950) * COSB
      R0(3) = SIN(D1950)
C                                       Adjust vector A to give zero
C                                       proper motion in FK5
      W=(BEPOCH - 1950D0) / PMF
      DO 10, I = 1, 3
         A1(I) = A(I) + W * AD(I)
   10    CONTINUE

C                                       Remove e-terms
      W = R0(1) * A1(1) + R0(2) * A1(2) + R0(3) * A1(3)
      DO 20 I = 1, 3
         V1(I) = R0(I) - A1(I) + W * R0(I)
   20    CONTINUE
C                                       Convert position vector to
C                                       Fricke system
      DO 40 I = 1, 6
         W = 0.0D0
         DO 30 J = 1,3
            W = W + EM(I,J) * V1(J)
   30       CONTINUE
         V2(I)=W
   40    CONTINUE
C                                       Allow for fictitious proper
C                                       motion in FK4
      EPB2D = 15019.81352D0 + (BEPOCH - 1900D0) * 365.242198781D0
C
      W = ((EPB2D - 51544.5D0) / 365.25D0) / PMF
      DO 50 I=1,3
         V2(I) =V2(I) + W * V2(I + 3)
   50    CONTINUE
C                                       Revert to spherical coordinates
      R = SQRT(V2(1) * V2(1) + V2(2) * V2(2))
      IF (R .EQ. 0D0) THEN
         W = 0D0
      ELSE
         W = ATAN2(V2(2),V2(1))
         END IF
      IF (V2(3) .EQ. 0D0) THEN
         D2000 = 0D0
      ELSE
         D2000 = ATAN2(V2(3), R)
         END IF
      R2000 = MOD(W, D2PI)
      IF (R2000 .LT. 0D0) R2000 = R2000 + D2PI
C
 999  RETURN
      END

      SUBROUTINE DATPAR (TIME, ISUB, IERR)
C-----------------------------------------------------------------------
C! updates the parallactic angles if needed
C# Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2017, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
      INTEGER   ISUB, IERR
      REAL      TIME
C
      INTEGER   LUN, I
      LOGICAL   PLANET
      DOUBLE PRECISION DRA, DDEC, JD0
      REAL      TINC
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DPDC.INC'
C                                       Time increment (days) to update
C                                       correction matrices (0.1 sec.)
      DATA TINC /1.15E-6/
      DATA LUN /49/
C-----------------------------------------------------------------------
C                                       subarray changing?
      IF (ISUB.NE.PARSUB) THEN
         CALL GETANT (IUDISK, IUCNO, ISUB, CATUV, ANBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'GETTING UPDATED ANTENNA INFO'
            GO TO 990
            END IF
         PARSUB = ISUB
         END IF
C                                       See if parallactic angles
C                                       current
      IF ((CURSOU.NE.PARSOU) .OR. (ABS(TIME-PARTIM).GT.TINC)) THEN
C                                       Source info
         CALL JULDAY (RDATE, JD0)
         CALL FNDCOO (0, JD0, CURSOU, IUDISK, IUCNO, CATUV, LUN, TIME,
     *      DRA, DDEC, PLANET, IERR)
C        IF ((CURSOU.NE.PARSOU) .OR. (CURSOU.NE.IDSOUR)) THEN
C           CALL GETSOU (CURSOU, IUDISK, IUCNO, CATUV, LUN, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'GETTING UPDATED SOURCE INFO'
            GO TO 990
            END IF
         PARSOU = CURSOU
C                                       Parallactic angles
         CALL PARACO (TIME, DRA, DDEC, PANGLE)
         DO 10 I = 1,NSTNS
            PARAGL(1,I) = COS (PANGLE(I))
            PARAGL(2,I) = -SIN (PANGLE(I))
 10         CONTINUE
C                                       Update par. angle time
         PARTIM = TIME
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DATPAR ERROR',I5,' ON ',A)
      END

      SUBROUTINE ZTAPR (OP, LUN, FIND, COUNT, IERR)
C-----------------------------------------------------------------------
C! mount, dismount, position, write EOF, etc. for remote tapes
C# Z2 Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Performs standard tape manipulating functions - remote tapes
C   Inputs:
C       OP      C*4   Operation to be performed. 4 characters ASCII.
C                     'ADVF' = advance file marks
C                     'ADVR' = advance records
C                     'BAKF' = backspace file marks.
C                     'BAKR' = backspace records.
C                     'REWI' = rewind the tape on unit LUN
C                     'WEOF' = write end of file on unit LUN: writes 4
C                              EOFs, positions tape after first one
C                     'MEOF' = write 4 EOF marks on tape, position tape
C                              before the first one
C       LUN     I     logical unit number == 30 + DriveNumber
C       FIND    I     FTAB pointer.  Drive number for MOUNT/DISMOUNT.
C   In/out:
C       COUNT   I     In: Number of records or file marks to skip.
C                     Out: (AEOI) > 0 EOI after COUNT files
C                                 < 0 EOI after skipping -COUNT files
C   Outputs:
C       IERR  I       Error return: 0 => ok
C                        1 = File not open
C                        2 = Input specification error.
C                        3 = I/O error.
C                        4 = End Of File
C                        5 = Beginning Of Medium
C                        6 = End Of Medium
C   Generic version - calls ZVTPX2.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   LUN, FIND, COUNT, IERR
C
      HOLLERITH HBUF(10)
      INTEGER   IBUF(10), NBACK, NBACKE
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
      EQUIVALENCE (HBUF, IBUF)
      DATA NBACKE /1/
C-----------------------------------------------------------------------
C                                       pack buffer: header
      CALL ZCLC8 (8, 'ZTAPE   ', 1, HBUF)
      CALL ZILI32 (1, 3, 3, IBUF)
      CALL ZILI32 (1, 1, 4, IBUF)
      CALL ZILI32 (1, 0, 5, IBUF)
C                                       pack buffer: data
      CALL ZCLC8 (4, OP, 21, HBUF)
      CALL ZILI32 (1, LUN, 7, IBUF)
      CALL ZILI32 (1, COUNT, 8, IBUF)
      CALL ZILI32 (1, 0, 9, IBUF)
      CALL ZILI32 (1, 0, 10, IBUF)
C
      NBACK = NBACKE
      CALL ZVTPX2 (FTAB(FIND+MOFF), 3, NBACK, IBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (7)
      ELSE
         CALL ZI32IL (1, 6, IBUF, COUNT)
         CALL ZI32IL (1, 5, IBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            CALL MSGWRT (7)
            END IF
         END IF
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) OP, COUNT, LUN
         CALL MSGWRT (7)
         END IF
      IF ((IERR.EQ.0) .AND. (NBACK.NE.NBACKE)) THEN
         WRITE (MSGTXT,1025) NBACK, NBACKE
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZTAPR: ZVTPX2 RETURNS ERROR CODE',I7)
 1010 FORMAT ('ZTAPR: REMOTE TAPE SYSTEM RETURNS ERROR CODE',I7)
 1020 FORMAT ('ZTAPR: ERROR WAS ON OP =''',A,''' COUNT=',I3,' LUN=',I3)
 1025 FORMAT ('ZTAPR: WARNING - GOT BACK',I3,' WORDS, EXPECTED',I3)
      END

      SUBROUTINE AVGSMO (VIS, NUMPOL, NUMIF, NUMFRQ, NCHAVG, CHINC,
     *   JNCS, JNCIF, VISOUT)
C-----------------------------------------------------------------------
C;  Copyright (C) 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to boxcar average a spectrum in frequency to produce a
C   lower resolution spectrum.
C   Inputs:
C      VIS      R(*)      Array containing the input visibility data
C                         (Re, Im, Wt)
C      NUMPOL   I         Number of polarizations
C      NUMIF    I         Number of IF's
C      NUMFRQ   I         Number of spectral channels
C      NCHAVG   I         Number channels to average
C      CHINC    I         Increment in input channels between output
C      JNCS     I         Index for polzn in output array
C      JNCIF    I         Index for IF in output array
C   Output:
C      VISOUT   R(*)      Pseudo-continuum visibility
C-----------------------------------------------------------------------
      INTEGER   NUMPOL, NUMIF, NUMFRQ, NCHAVG, CHINC, JNCS, JNCIF
      REAL      VIS(*), VISOUT(*)
C
      INTEGER   LOOPS, LOOPIF, LOOPF, INDEX, I, OUTDEX, LOOPOF, NN
      REAL      SUMWT, SUMRE, SUMIM, WT, XNORM
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       Average
      DO 40 LOOPS = 1,NUMPOL
         DO 30 LOOPIF = 1,NUMIF
            LOOPOF = 0
            DO 20 LOOPF = 1,NUMFRQ,CHINC
               LOOPOF = LOOPOF + 1
               SUMWT = 0.0
               SUMRE = 0.0
               SUMIM = 0.0
               INDEX = 1 + (LOOPS-1)*INCS + (LOOPIF-1)*INCIF +
     *            (LOOPF-1) * INCF
               OUTDEX = 1 + (LOOPS-1)*JNCS + (LOOPIF-1)*JNCIF +
     *            (LOOPOF-1) * INCF
               NN = MIN (NCHAVG, NUMFRQ+1-LOOPF)
               DO 10 I = 1,NN
                  WT = VIS(INDEX+2)
                  IF (WT.GT.0.0) THEN
                     SUMRE = SUMRE + VIS(INDEX)*WT
                     SUMIM = SUMIM + VIS(INDEX+1)*WT
                     SUMWT = SUMWT + WT
                     END IF
                  INDEX = INDEX + INCF
 10               CONTINUE
               XNORM = 1.0
               IF (SUMWT.GT.1.0E-10) XNORM = 1.0 / SUMWT
               VISOUT(OUTDEX) = SUMRE * XNORM
               VISOUT(OUTDEX+1) = SUMIM * XNORM
               VISOUT(OUTDEX+2) = SUMWT
 20            CONTINUE
 30         CONTINUE
 40      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE APROLL (APCORE, LUN, NWORD, BUFFER, BUFSZ, DELAY, IRET)
C-----------------------------------------------------------------------
C! Copies AP "memory" to disk, gives up AP then reloads AP
C# AP-util IO-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2006, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   APROLL copies the first NWORDs of AP MD memory to a scratch file,
C   gives up the AP, does a task delay for DELAY, grabs an AP and loads
C   the scratch file back into the AP.  NOTE: this subroutine uses
C   commom /CFILES/ for the scratch file.  Scratch file of "type" 'SC'
C   created on the first call and used in subsequent calls, thus NWORD
C   on the first call should be the largest value to be encountered.
C***********************************************************************
C   IMPORTANT NOTE:   APROLL works properly only for floating point
C   data.  Integer values rolled will not be restored correctly.
C***********************************************************************
C   Inputs: LUN     I       LUN to use for I/O
C           NWORD   I       Number of words of AP memory to save.
C                           IF <= 0, just give up AP, delay, grab it.
C           BUFFER  R(*)    Work buffer.  Should be > 6*NBPS.
C           BUFSZ   I       Size of BUFFER in bytes.
C           DELAY   R       Task delay time (sec)
C   Output: IRET    I       Return error code: 0 => OK
C                              1 => couldn't roll - data still in AP
C                              2 => couldn't reload AP.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   LUN, NWORD, BUFSZ, IRET
      REAL      BUFFER(*), DELAY
C
      CHARACTER NAME*48
      INTEGER   NSAVE, VO, BO, ISIZE, IAPLEN, IAPLOC
      INTEGER   LRECL, LENBU, NLOOP, ILOOP, NIO, J, I, IERR,
     *   FIND, BIND
      LOGICAL   T, F
      DOUBLE PRECISION    XSIZE, XTEMP
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA BO, VO /1, 0/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IF (NWORD.LE.0) GO TO 100
      IRET = 1
C                                       Determine size of transfer.
C                                       Single buffer.
      LENBU = (BUFSZ / (2.0)) - (NBPS / 2.0)
      LRECL = 1
C                                       Check number of scratch files.
      IF (NSCR.LT.20) GO TO 10
         WRITE (MSGTXT,1000) NSCR
         GO TO 990
C                                       Create scratch file.
 10   ISIZE = (NWORD - 1) /256 + 3
      CALL SCREAT (ISIZE, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 20
         WRITE (MSGTXT,1010) IERR
         GO TO 990
C                                       Initialize disk I/O.
 20   CALL ZPHFIL ('SC', SCRVOL(NSCR), SCRCNO(NSCR), 1, NAME, IERR)
      CALL ZOPEN (LUN, FIND, SCRVOL(NSCR), NAME, T, F, F, IERR)
         IF (IERR.EQ.0) GO TO 50
            WRITE (MSGTXT,1020) IERR
            GO TO 990
C                                       Initialize
 50   CALL UVINIT ('WRIT', LUN, FIND, NWORD, VO, LRECL, LENBU, BUFSZ,
     *   BUFFER, BO, BIND, IERR)
      IF (IERR.EQ.0) GO TO 60
         WRITE (MSGTXT,1050) IERR
         GO TO 990
C                                       Loop thru AP.
 60   NLOOP = (NWORD - 1) / LENBU + 1
      XSIZE = NWORD
      IAPLOC = 0
      IAPLEN = LENBU
      DO 70 ILOOP = 1,NLOOP
C                                       Get data from AP.
         XTEMP = XSIZE - (ILOOP - 1.0) * LENBU
         NIO = MIN (XTEMP, 32000.0D0)
         NIO = MIN (NIO, LENBU)
         IAPLEN = NIO
         CALL QGET (APCORE, BUFFER(BIND), IAPLOC, IAPLEN, 2)
         IAPLOC = IAPLOC + IAPLEN
C                                       Write to scratch file.
         CALL QWD
         CALL UVDISK ('WRIT', LUN, FIND, BUFFER, NIO, BIND, IERR)
         IF (IERR.EQ.0) GO TO 70
            WRITE (MSGTXT,1060) 'WRIT', IERR
            GO TO 990
 70      CONTINUE
C                                       Flush buffer
      NIO = 0
      CALL UVDISK ('FLSH', LUN, FIND, BUFFER, NIO, BIND, IERR)
      IF (IERR.EQ.0) GO TO 100
         WRITE (MSGTXT,1060) 'FLSH', IERR
         GO TO 990
C                                       Release AP
 100  NSAVE = PSAPNW
      CALL QRLSE
      IRET = 0
C                                       Task delay.
      CALL ZDELAY (DELAY, IERR)
C                                       Grab AP
      CALL QINIT (APCORE, NSAVE, 0, IAPLOC)
      IF (NWORD.LE.0) GO TO 999
C                                       Write it all back.
      IRET = 2
      CALL UVINIT ('READ', LUN, FIND, NWORD, VO, LRECL, LENBU, BUFSZ,
     *   BUFFER, BO, BIND, IERR)
      IF (IERR.EQ.0) GO TO 110
         WRITE (MSGTXT,1050) IERR
         GO TO 990
C                                       Loop thru AP load.
 110  IAPLOC = 0
      DO 130 ILOOP = 1, NLOOP
C                                       Read data.
         CALL UVDISK ('READ', LUN, FIND, BUFFER, NIO, BIND, IERR)
         IF (IERR.EQ.0) GO TO 120
            WRITE (MSGTXT,1060) 'READ', IERR
            GO TO 990
C                                       Stuff into AP
 120     IAPLEN = NIO
         CALL QPUT (APCORE, BUFFER(BIND), IAPLOC, IAPLEN, 2)
         IAPLOC = IAPLOC + IAPLEN
         CALL QWD
 130     CONTINUE
C                                       Delete scratch file
      CALL ZCLOSE (LUN, FIND, IERR)
      J = 256  + 1
      CALL COPY (256, CATR, BUFFER)
      I = 1
      CALL MAPCLR (I, SCRVOL(NSCR), SCRCNO(NSCR), 2, BUFFER(J))
      NSCR = NSCR - 1
      CALL COPY (256, BUFFER, CATR)
C                                       Finished
      IRET = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('APROLL: TOO MANY SCRATCH FILES =',I5)
 1010 FORMAT ('APROLL: CANNOT CREATE SCRATCH FILE TO ROLL AP, IERR=',I5)
 1020 FORMAT ('APROLL: CANNOT OPEN SCRATCH FILE TO ROLL AP, IERR=',I5)
 1050 FORMAT ('APROLL: CANNOT INIT SCRATCH FILE TO ROLL AP, IERR=',I5)
 1060 FORMAT ('APROLL: FAILED ',A4,'ING SCRATCH FILE, IERR=',I5)
      END

      PROGRAM FIXCAT
C-----------------------------------------------------------------------
C! FIXCAT deletes entries in map catalogs
C# Utility Catalog
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   A service routine to delete entries in map catalogs.
C-----------------------------------------------------------------------
      CHARACTER NAME*12, CLAS*6, PTYPE*2, STAT*4, MSGBUF*80, PRGNAM*6
      INTEGER   IVOL, ICNO, ISEQ, IUSER, IBUF(256), TTYLUN, TTYIND,
     *   IERR, ICNO1, ICNO2, I, TTY(2), IARR(4)
      LOGICAL   T, F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (TTY(1), TTYLUN),  (TTY(2), TTYIND)
      DATA PRGNAM /'FIXCAT'/
      DATA T, F /.TRUE.,.FALSE./
      DATA TTYLUN /5/
C-----------------------------------------------------------------------
      CALL AIPINI (TTY, PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       require password
      CALL PASWRD (IBUF, IERR)
      IF (IERR.NE.0) GO TO 995
      WRITE (MSGTXT,1000)
      CALL MSGWRT (2)
C                                       Loop to ask for vol, cat #
 10   WRITE (MSGBUF,1010)
      CALL INQINT (TTY, MSGBUF, 4, IARR, IERR)
      IF (IERR.GT.0) GO TO 990
      IF (IERR.LT.0) GO TO 995
      IVOL = IARR(1)
      NLUSER = IARR(2)
      ICNO1 = IARR(3)
      ICNO2 = IARR(4)
      IF (ICNO1.LE.0) GO TO 995
      IF (ICNO2.LT.ICNO1) ICNO2 = ICNO1
      DO 50 ICNO = ICNO1,ICNO2
         CALL CATDIR ('INFO', IVOL, ICNO, NAME, CLAS, ISEQ, PTYPE,
     *      IUSER, STAT, IBUF, IERR)
         IF (IERR.EQ.0) GO TO 20
            IF (IERR.EQ.6) GO TO 50
            WRITE (MSGTXT,1012) IERR
            CALL MSGWRT (7)
            GO TO 10
C                                       clear status
 20      IF (STAT.EQ.'REST') GO TO 30
            CALL CATDIR ('CSTA', IVOL, ICNO, NAME, CLAS, ISEQ, PTYPE,
     *         IUSER, 'CLWR', IBUF, IERR)
            DO 25 I = 1,100
               CALL CATDIR ('CSTA', IVOL, ICNO, NAME, CLAS, ISEQ, PTYPE,
     *             IUSER, 'CLRD', IBUF, IERR)
               IF (IERR.NE.0) GO TO 30
 25            CONTINUE
C                                       close it
 30      WRITE (MSGTXT,1030) IVOL, ICNO, NAME, CLAS, ISEQ, IUSER, PTYPE
         CALL MSGWRT (4)
         CALL CATDIR ('CLOS', IVOL, ICNO, NAME, CLAS, ISEQ, PTYPE,
     *      IUSER, STAT, IBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1031) IERR
            CALL MSGWRT (6)
            END IF
 50      CONTINUE
      GO TO 10
C                                       Terminal error
 990  WRITE (MSGTXT,1990) IERR
      CALL MSGWRT (8)
C
 995  NLUSER = 1
      CALL ZCLOSE (TTYLUN, TTYIND, IERR)
      CALL ACOUNT (2)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('I close catalog entries')
 1010 FORMAT ('Enter Vol#, User, Cat# range (4 of I)  Q to quit')
 1012 FORMAT ('CATDIR INFO ERROR',I7)
 1030 FORMAT ('Closing vol,cno',I2,I4,4X,A12,'.',A6,'.',I4,
     *   2X,I4,1X,A2)
 1031 FORMAT ('CATDIR CLOSE ERROR',I7)
 1990 FORMAT ('ERROR',I7,' IN TERMINAL IO')
      END

LOCAL INCLUDE 'UVFRE.INC'
C                                       Local include for UVFRE
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAME2(3), XCLAI2(2), XSOUR(4,30),
     *   XCALC(1), XNAMOU(3), XCLAOU(2)
      REAL      XSIN, XDISIN, XSEQ2, XDISK2, XQUAL, XTIME(8), XBAND,
     *   XFREQ, XFQID, XSUBA, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER,
     *   XFLAG, XDOBND, XBPVER, XSMOTH(3), XDOAC, XSOUT, XDISO,
     *   XINTP(3), BADD(10)
      REAL      REFPXO, REFPXI, SCRBUF(256), BUFF2(UVBFSS)
      INTEGER   SEQIN, SEQ2, SEQOUT, DISKIN, DISK2, DISKO, JBUFSZ,
     *   ILOCWT, CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO,
     *   INCIFO, LRECO, NRPRMI, NRPRMO, OLDCNO, CNO2, NEWCNO,
     *   CAT2(256), CATOUT(256), NUMIFO, NCHANO, NUMIFI, NCHANI, NFRX
      LOGICAL   ISCOMP
      CHARACTER NAMEIN*12, CLAIN*6, NAME2*12, CLAS2*6, NAMOUT*12,
     *   CLAOUT*6
      DOUBLE PRECISION REFRQI, REFRQO, FOFFO(MAXIF), FINCO(MAXIF),
     *   FRQO(2,MAXIF)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAME2, XCLAI2,
     *   XSEQ2, XDISK2, XSOUR, XQUAL, XCALC,XTIME, XBAND, XFREQ, XFQID,
     *   XSUBA, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND,
     *   XBPVER, XSMOTH, XDOAC, XINTP, XNAMOU, XCLAOU, XSOUT, XDISO,
     *   BADD
      COMMON /UVFREP/ CATOLD, CATOUT, CAT2, FOFFO, FINCO, REFRQI,
     *   REFRQO, FRQO, REFPXI, REFPXO, SEQIN, SEQ2, SEQOUT, DISKIN,
     *   DISK2, DISKO, ILOCWT, INCSI, INCFI, INCIFI, INCSO, INCFO,
     *   INCIFO, LRECO, NRPRMI, NRPRMO, ISCOMP, OLDCNO, NEWCNO, CNO2,
     *   NUMIFI, NUMIFO, NFRX, NCHANI, NCHANO
      COMMON /CHARPM/ NAMEIN, CLAIN, NAME2, CLAS2, NAMOUT, CLAOUT
      COMMON /BUFRS/ SCRBUF, BUFF2, JBUFSZ
C                                       End local include for UVFRE
LOCAL END
      PROGRAM UVFRE
C-----------------------------------------------------------------------
C! Regrids one data set on the frequency structure of another
C# Utility UV
C-----------------------------------------------------------------------
C;  Copyright (C) 2015, 2018, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVFRE replaces all IFs with a single UV spectrum, averaging
C   overlapped channels and flagging missing ones.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C   full set of calibration adverbs
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, N, NWORDS, IHSTRT(2)
      REAL      WEIGHT(2), CHSTRT(2)
      LONGINT   PWGHT, PCHST
      EQUIVALENCE (IHSTRT, CHSTRT)
      INCLUDE 'UVFRE.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'UVFRE '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL UVFRIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       dynamic memory
      N = CATBLK(KINAX+JLOCF) * CATBLK(KINAX+JLOCIF)
      NWORDS = (N - 1) / 1024 + 2
      CALL ZMEMRY ('GET ', PRGM, NWORDS, CHSTRT, PCHST, IRET)
      IF (IRET.EQ.0) THEN
         NWORDS = (N * NFRX - 1) / 1024 + 4
         CALL ZMEMRY ('GET ', PRGM, NWORDS, WEIGHT, PWGHT, IRET)
         END IF
      IF (IRET.NE.0) THEN
         MSGTXT = 'CANNOT GET NEEDED DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       get weight arrays
      CALL UVFRWT (N, IHSTRT(1+PCHST), WEIGHT(1+PWGHT), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL UVFRUV (N, IHSTRT(1+PCHST), WEIGHT(1+PWGHT), IRET)
      IF (IRET.NE.0) GO TO 990
      CALL UVFRHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE UVFRIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   UVFRIN gets input parameters for UVFRE and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               5 => catalog troubles
C                               8 => can't start
C   Output in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, LUN, VER, LUNTMP, FREQID
      LOGICAL   MATCH
      REAL      CATR(256), RPARM(20), DEF1(5), DEF2(5)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'UVFRE.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCHND.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      DATA BLANK  /' '/
      DATA DEF1 /4., 2., 2., 3., 1.99/
      DATA DEF2 /1., 3., 1., 4., 1./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
C                                       Get input parameters.
      NPARM = 180
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRBUF, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAME2, NAME2)
      CALL H2CHR (6, 1, XCLAI2, CLAS2)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      STOKES = ' '
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      SEQIN = IROUND (XSIN)
      SEQ2 = IROUND (XSEQ2)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISK2 = IROUND (XDISK2)
      DISKO = IROUND (XDISO)
C                                       interp function
      I = IROUND (XINTP(1))
      IF ((I.LT.0) .OR. (I.GT.5)) I = 0
      XINTP(1) = I
      IF (XINTP(2).LT.0.1) XINTP(2) = DEF1(I)
      IF (XINTP(3).LT.XINTP(2)) XINTP(3) = DEF2(I) * XINTP(2)
C                                       get master freq info
C                                       Get CATBLK from old file.
      CNO2 = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISK2, CNO2, NAME2, CLAS2, SEQ2, PTYPE,
     *   NLUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAME2, CLAS2, SEQ2, DISK2, NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISK2, CNO2, CATBLK, 'REST', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'GETTING MASTER DATA SET HEADER'
         GO TO 990
         END IF
      CALL UVPGET (IERR)
      REFRQO = CATD(KDCRV+JLOCF)
      NCHANO = CATBLK(KINAX+JLOCF)
      REFPXO = CATR(KRCRP+JLOCF)
      CALL COPY (256, CATBLK, CAT2)
C                                       get FQ settings first
      LUN = LUNTMP (1)
      VER = 1
      CALL CHNDAT ('READ', BUFF2, DISK2, CNO2, VER, CATBLK, LUN,
     *   NUMIFO, FOFF, ISBAND, FINC, BNDCOD, FREQID, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING FQ TABLE FOR VELOCITIES'
         GO TO 990
         END IF
      DO 15 I = 1,NUMIFO
         FOFFO(I) = FOFF(I) + REFRQO
         FINCO(I) = FINC(I)
         FRQO(1,I) = FOFFO(I) + FINCO(I) * (0.5 - REFPXO)
         FRQO(2,I) = FOFFO(I) + FINCO(I) * (NCHANO+0.5 - REFPXO)
 15      CONTINUE
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = XDOAC.GT.0.0
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'GETTING INPUT DATA SET HEADER'
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Get uv header info.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = 1
         EIF = CATBLK(KINAX+JLOCIF)
         END IF
      BCHAN = 1
      ECHAN = CATBLK(KINAX+JLOCF)
      REFRQI = CATD(KDCRV+JLOCF)
      NCHANI = ECHAN
      REFPXI = CATR(KRCRP+JLOCF)
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, IRET)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         IRET = 1
         GO TO 990
         END IF
      IF (IRET.GT.0) GO TO 999
C                                       get freq information
      VER = 1
      CALL CHNDAT ('READ', BUFF2, DISKIN, OLDCNO, VER, CATBLK, LUN,
     *   NUMIFI, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IRET)
      IF (IRET.NE.0) GO TO 999
      CATD(KDCRV+JLOCF) = REFRQO
      CATR(KRCRP+JLOCF) = REFPXI
      CATBLK(KINAX+JLOCF) = NCHANO
      CATBLK(KINAX+JLOCIF) = NUMIFO
      CALL COPY (256, CATBLK, CATOUT)
      DO 20 I = 1,NUMIFI
         FOFF(I) = FOFF(I) + REFRQI
 20      CONTINUE
      IF (XINTP(1).EQ.0.0) THEN
         NFRX = ABS (FINC(1) / FINCO(1)) + 2.0D0
      ELSE
         NFRX = XINTP(3) * ABS (FINC(1) / FINCO(1)) + 2.0D0
         END IF
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, SCRBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1035) IRET
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, SCRBUF, IERR)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       replace with our header
      CALL COPY (256, CATOUT, CATBLK)
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       read compressed => write compr.
      IF (ISCOMP) THEN
         CATBLK(KINAX) = 1
         I = CATBLK(KIPCN)
         CALL CHR2H (8, 'WEIGHT  ', 1, CATH(KHPTP+2*I))
         CALL CHR2H (8, 'SCALE   ', 1, CATH(KHPTP+2*I+2))
         CATBLK(KIPCN) = I + 2
         ILOCWT = I
         END IF
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      IRET = 4
      CALL UVCREA (DISKO, CCNO, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
         ELSE
            WRITE (MSGTXT,1060)
            END IF
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
      NEWCNO = CCNO
C                                       Save output file info
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', SCRBUF, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
C                                       Copy any header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      CALL COPY (256, CATBLK, CATOUT)
      CALL COPY (256, CATOLD, CATBLK)
      CALL UVPGET (IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVFRIN: ERROR',I3,' ON ',A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY NOT OVERWRITE EXISTING FILE.  QUITTING')
      END
      SUBROUTINE UVFRWT (N, CHSTRT, WEIGHT, IRET)
C-----------------------------------------------------------------------
C   UBGRWT determines the weight of the convolution of each input
C   channel to a number of output channels
C   Inputs;
C      N        I      number input channels
C   Outputs:
C      CHSTRT   I(*)   initial output channel for each input channel
C      WEIGHT   R(*)   weights of each input channel to outputs channels
C      IRET     I      error code
C-----------------------------------------------------------------------
      INTEGER   N, CHSTRT(*), IRET
      REAL      WEIGHT(N,*)
C
      INCLUDE 'UVFRE.INC'
      INTEGER   I, J, IIF, ICH, ITYPE, J1, J2, K, L
      DOUBLE PRECISION FF, FI1, FI2, FO1, FO2, DOS, DOF, DP
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DCHND.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      ITYPE = XINTP(1) + 0.01
      CALL FILL (N, 0, CHSTRT)
      I = N * NFRX
      CALL RFILL (I, 0.0, WEIGHT)
      I = NUMIFO * NCHANO
      CALL RFILL (I, 0.0, BUFF2)
C                                       simplistic
      IF (ITYPE.EQ.0) THEN
         DO 25 I = 1,N
            IIF = (I - 1) / NCHANI + 1
            ICH = I - (IIF - 1) * NCHANI
            FI1 =  FOFF(IIF) + FINC(IIF) * (ICH - 0.5D0 - REFPXI)
            FI2 =  FI1 + FINC(IIF)
            J1 = 0
            J2 = 0
C                                       find output IF(s)
            DO 10 J = 1,NUMIFO
               IF ((FI1.GE.FRQO(1,J)) .AND. (FI1.LE.FRQO(2,J))) J1 = J
               IF ((FI2.GE.FRQO(1,J)) .AND. (FI2.LE.FRQO(2,J))) J2 = J
 10            CONTINUE
            IF ((J2.GT.0) .AND. (J1.EQ.0)) J1 = 1
            IF ((J1.GT.0) .AND. (J2.EQ.0)) J2 = NUMIFO
            L = 0
            IF ((J1.GT.0) .AND. (J2.GT.0)) THEN
               DO 20 J = J1,J2
                  DO 15 K = 1,NCHANO
                     FO1 = FOFFO(J) + (K - 0.5D0 - REFPXO) * FINCO(J)
                     FO2 = FO1 + FINCO(J)
                     IF (FI2.LE.FO1) THEN
                        GO TO 20
                     ELSE IF (FI1.LT.FO2) THEN
                        L = L + 1
                        IF (L.EQ.1) CHSTRT(I) = (J-1) * NCHANO + K
                        IF (FI1.GT.FO1) THEN
                           WEIGHT(I,L) = (FI1 - FO1) / (FO2 - FO1)
                        ELSE IF (FI2.LT.FO2) THEN
                           WEIGHT(I,L) = (FI2 - FO1) / (FO2 - FO1)
                        ELSE
                           WEIGHT(I,L) = 1.0
                           END IF
                        END IF
 15                  CONTINUE
 20               CONTINUE
               END IF
 25         CONTINUE
C                                       convolution
      ELSE
         DO 75 I = 1,N
            IIF = (I - 1) / NCHANI + 1
            ICH = I - (IIF - 1) * NCHANI
            FF =  FOFF(IIF) + FINC(IIF) * (ICH - REFPXI)
            DOS = XINTP(3) * FINC(IIF) / 2.0D0
            DOF = XINTP(2) * FINC(IIF) / 2.0D0
C                                       parm
            IF (ITYPE.EQ.2) THEN
               DP = -LOG (2.0D0) / (DOF * DOF)
            ELSE IF (ITYPE.EQ.4) THEN
               DP = PI / (2.0D0 * DOF)
            ELSE IF (ITYPE.EQ.5) THEN
               DP = -LOG (2.0D0) / DOF
               END IF
            FI1 = FF - DOS
            FI2 = FF + DOS
            J1 = 0
            J2 = 0
C                                       find output IF(s)
            DO 40 J = 1,NUMIFO
               IF ((FI1.GE.FRQO(1,J)) .AND. (FI1.LE.FRQO(2,J))) J1 = J
               IF ((FI2.GE.FRQO(1,J)) .AND. (FI2.LE.FRQO(2,J))) J2 = J
 40            CONTINUE
            IF ((J2.GT.0) .AND. (J1.EQ.0)) J1 = 1
            IF ((J1.GT.0) .AND. (J2.EQ.0)) J2 = NUMIFO
            L = 0
            IF ((J1.GT.0) .AND. (J2.GT.0)) THEN
               DO 70 J = J1,J2
                  DO 65 K = 1,NCHANO
                     FO1 = FOFFO(J) + (K - REFPXO) * FINCO(J)
                     IF (FO1.GT.FI2) THEN
                        GO TO 70
                     ELSE IF ((FO1.GE.FI1) .AND. (FO2.LE.FI2)) THEN
                        L = L + 1
                        IF (L.EQ.1) CHSTRT(I) = (J-1)*NCHANO + K
C                                       Hanning
                        IF (ITYPE.EQ.1) THEN
                           WEIGHT(I,L) = 1.0 - ABS (FO1-FF) / DOF
                           WEIGHT(I,L) = MAX (0.0, WEIGHT(I,L))
C                                       Gaussian
                        ELSE IF (ITYPE.EQ.2) THEN
                           WEIGHT(I,L) = EXP (DP * ((FO1-FF)**2))
C                                       Boxcar
                        ELSE IF (ITYPE.EQ.3) THEN
                           IF (ABS(FO1-FF).LE.DOF) WEIGHT(I,L) = 1.0
C                                       Sinc
                        ELSE IF (ITYPE.EQ.4) THEN
                           IF (FO1.EQ.FF) THEN
                              WEIGHT(I,L) = 1.0
                           ELSE
                              WEIGHT(I,L) = SIN (DP * (FO1-FF)) /
     *                           (DP * (FO1-FF))
                              END IF
C                                       exponential
                        ELSE IF (ITYPE.EQ.5) THEN
                           WEIGHT(I,L) = EXP (DP * ABS(FO1-FF))
                           END IF
                        END IF
 65                  CONTINUE
 70               CONTINUE
               END IF
 75         CONTINUE
         END IF
C                                       normalize: sum
      DO 120 I = 1,N
         IF (CHSTRT(I).GT.0) THEN
            J1 = CHSTRT(I)
            J2 = J1 + NFRX - 1
            L = 0
            DO 110 J = J1,J2
               L = L + 1
               BUFF2(J) = BUFF2(J) + WEIGHT(I,L)
 110           CONTINUE
            END IF
 120     CONTINUE
C                                       normalize: divide
      DO 140 I = 1,N
         IF (CHSTRT(I).GT.0) THEN
            J1 = CHSTRT(I)
            J2 = J1 + NFRX - 1
            L = 0
            DO 130 J = J1,J2
               L = L + 1
               IF (BUFF2(J).GT.0.0) WEIGHT(I,L) = WEIGHT(I,L) / BUFF2(J)
 130           CONTINUE
            END IF
 140     CONTINUE
C                                       count
      L = NUMIFO * NCHANO
      DP = 0.0D0
      DO 150 I = 1,L
         IF (BUFF2(I).GT.0) DP = DP + 1.0D0
 150     CONTINUE
      IF (DP.LE.0.0D0) THEN
         IRET = 8
         MSGTXT = 'NO CHANNELS WILL BE WRITTEN'
         CALL MSGWRT (8)
      ELSE
         IRET = 0
         DP = 1.D2 * DP / L
         WRITE (MSGTXT,1150) DP
         CALL MSGWRT (3)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1150 FORMAT (F8.3,' per cent of the output channels will contain data')
      END
      SUBROUTINE UVFRUV (N, CHSTRT, WEIGHT, IRET)
C-----------------------------------------------------------------------
C   UVFRUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Inputs:
C      N        I      number input channels
C      CHSTRT   I(*)   initial output channel for each input channel
C      WEIGHT   R(*)   weights of each input channel to outputs channels
C   Input in common:
C      NRPRMI   I      Input number of random parameters.
C      INCSI    I      Input Stokes' increment in vis.
C      INCFI    I      Input frequency increment in vis.
C      INCIFI   I      Input IF increment in vis.
C      LRECO    I      Output file record length
C      NRPRMO   I      Output number of random parameters.
C      INCSO    I      Output Stokes' increment in vis.
C      INCFO    I      Output frequency increment in vis.
C      INCIFO   I      Output IF increment in vis.
C      ISCOMP   L      If true data is compressed
C   Output:
C      IRET     I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   N, CHSTRT(*), IRET
      REAL      WEIGHT(N,*)
C
      CHARACTER OFILE*48
      INTEGER   IPTRO, LUNO, INDO, ILENBU, KBIND, NIOUT, NIOLIM, BO, VO,
     *   NUMVIS, XCOUNT, NCORO, NCOPY, RNXRET
      LOGICAL   T, F
      INCLUDE 'UVFRE.INC'
      REAL      VIS(UVBFSS), RESULT(UVBFSS), RPARM(20)
      DOUBLE PRECISION UVSCAL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA LUNO /17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN/INIT INPUT VIS FILE'
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN-FOR-WRITE VIS FILE'
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT-FOR-WRITE VIS FILE'
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
      NUMVIS = 0
      XCOUNT = 0
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO, CATOUT, RNXRET)
      UVSCAL = REFRQO / REFRQI
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING VIS FILE'
         GO TO 990
C                                       Loop over buffer
      ELSE IF (IRET.EQ.0) THEN
         NUMVIS = NUMVIS + 1
         RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
         RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
         RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
C                                       call user routine
         CALL UVFREO (N, CHSTRT, WEIGHT, VIS, RESULT)
C                                       Copy to output.

         XCOUNT = XCOUNT + 1.0D0
         CALL RCOPY (NRPRMI, RPARM, BUFF2(IPTRO))
C                                       update NX table
         CALL RNXUPD (RPARM, RNXRET)
C                                       Compressed
         IF (ISCOMP) THEN
            CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *         BUFF2(IPTRO+NRPRMO))
         ELSE
            CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
            END IF
         IPTRO = IPTRO + LRECO
         NIOUT = NIOUT + 1
C                                       Write vis record.
         IF (NIOUT.GE.NIOLIM) THEN
            CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITING VIS FILE'
               GO TO 990
               END IF
            IPTRO = KBIND
            NIOUT = 0
            END IF
C                                       Read next buffer.
         GO TO 100
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITING VIS FILE'
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATOUT, IRET)
C                                       Close files
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
C                                       close NX table
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVFRUV: ERROR',I3,' ON ',A)
      END
      SUBROUTINE UVFRHI
C-----------------------------------------------------------------------
C   UVFRHI copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, WHAT(6)*12
      INTEGER   LUN1, LUN2, IERR, I
      INCLUDE 'UVFRE.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA LUN1, LUN2 /27,28/
      DATA WHAT /'Simple', 'Hanning', 'Gaussian', 'Boxcar', 'Sinc',
     *   'Exponential'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATOUT,
     *   SCRBUF, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCO2 (TSKNAM, NAME2, CLAS2, SEQ2, DISK2, LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
C                                       calibration history
      CALL CALHIS (LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       INTPARM
      I = XINTP(1) + 0.1
      WRITE (HILINE,1011) TSKNAM, I, WHAT(I+1)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      IF (I.GT.0) THEN
         WRITE (HILINE,1012) TSKNAM, XINTP(2)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
         WRITE (HILINE,1013) TSKNAM, XINTP(3)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
         END IF
C                                       Close HI file
 100  CALL HICLOS (LUN2, .TRUE., BUFF2, IERR)
C                                       Copy tables: local version
      CALL COPTAB (DISKIN, OLDCNO, DISK2, CNO2, DISKO, NEWCNO, CATOUT,
     *   IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'UVFRHI: ERROR COPYING TABLES TO OUTPUT UV'
         CALL MSGWRT (6)
         END IF
C                                       Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATOUT, 'REST', SCRBUF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVFRHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1011 FORMAT (A,'INTPARM(1)=',I2,10X,'/ function: ',A)
 1012 FORMAT (A,'INTPARM(2)=',F6.2,6X,'/ function width')
 1013 FORMAT (A,'INTPARM(3)=',F6.2,6X,'/ function support')
      END
      SUBROUTINE UVFREO (N, CHSTRT, WEIGHT, VIS, RESULT)
C-----------------------------------------------------------------------
C   This does the spectral building
C   Inputs:
C      N        I      number input channels
C      CHSTRT   I(*)   initial output channel for each input channel
C      WEIGHT   R(*)   weights of each input channel to outputs channels
C      VIS      R(3,*) Visibilities in order real, imaginary, weight
C                      (Jy, Jy, unitless).  Weight <= 0 => flagged.
C   Inputs from COMMON:
C      CATBLK   I(256) Catalog header record
C      INCSI    I      Input Stokes' increment in vis.
C      INCFI    I      Input frequency increment in vis.
C      INCIFI   I      Input IF increment in vis.
C   Output:
C      RESULT   R(3,*) Output visibilities gridded in frequency.
C-----------------------------------------------------------------------
      INTEGER   N, CHSTRT(*)
      REAL      WEIGHT(N,*), VIS(3,*), RESULT(3,*)
C
      INCLUDE 'UVFRE.INC'
      INTEGER   JIF, JF, JS, NS, INDEXO, INDEXI, NT, KF, KIF, K1, K2, I,
     *   K
      REAL      W, WT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       pointers to traverse the data
      NS = 1
      IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
      NT = NS * NCHANO * NUMIFO
      CALL RFILL (3*NT, 0.0, RESULT)
      DO 40 JS = 1,NS
         I = 0
         DO 30 JIF = 1,NUMIFI
            DO 20 JF = 1,NCHANI
               I = I + 1
               INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *            (JS-1) * INCSI + 1
               W = VIS(3,INDEXI)
               IF (W.GT.0.0) THEN
                  K1 = CHSTRT(I)
                  K2 = K1 + NFRX - 1
                  DO 10 K = K1,K2
                     KIF = (K - 1) / NCHANO + 1
                     KF = K - (KIF - 1) * NCHANO
                     INDEXO = JS + (KIF - 1) * INCIFO + (KF - 1) * INCFO
                     WT = WEIGHT(I,K-K1+1) * W
                     RESULT(1,INDEXO) = RESULT(1,INDEXO) +
     *                  WT * VIS(1,INDEXI)
                     RESULT(2,INDEXO) = RESULT(2,INDEXO) +
     *                  WT * VIS(2,INDEXI)
                     RESULT(3,INDEXO) = RESULT(3,INDEXO) + WT
 10                  CONTINUE
                  END IF
 20            CONTINUE
 30         CONTINUE
 40      CONTINUE
      DO 50 INDEXO = 1,NT
         W = RESULT(3,INDEXO)
         IF (W.GT.0) THEN
            RESULT(1,INDEXO) = RESULT(1,INDEXO) / W
            RESULT(2,INDEXO) = RESULT(2,INDEXO) / W
            END IF
 50      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE COPTAB (DISKIN, CNOIN, DISK2, CNO2, DISKOU, CNOOUT,
     *   CATO, IRET)
C-----------------------------------------------------------------------
C   Updates tables for selection by IF etc
C   UVFRE version changes a lot!
C   Inputs:
C      DISKIN   I   Input disk number
C      CNOIN    I   Input catalog number
C      DISKOU   I   Output disk number
C      CNOOUT   I   Output catalog number
C   Inputs in common:
C      BIF   I  First IF
C      EIF   I  Highest IF selected
C      FQOFF D  Frequency offset
C   Output:
C      IRET  I  Return code, 0=>OK
C-----------------------------------------------------------------------
      INTEGER   DISKIN, CNOIN, DISK2, CNO2, DISKOU, CNOOUT, CATO(256),
     *   IRET
C
      INCLUDE 'INCS:DSEL.INC'
      REAL      CATOR(256)
      LOGICAL   TABLE, EXIST, FITASC, MULTI
      CHARACTER NOTTYP(22)*2
      INTEGER   IERR, LUN1, LUN2, VER, NVER, OFQID, ISUB, JSUB, AN(50),
     *   NA, BUFF1(512), BUFF2(512),
     *   NONOT, EIFSAV, CATOUT(256), BPOL, EPOL
      DOUBLE PRECISION TIME1, TIME2, FQOFF, CATOD(128)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATOUT, CATOR, CATOD)
      DATA LUN1, LUN2 /28, 29/
      DATA NONOT, NOTTYP /22, 'NX','FQ','CH','CL','SN','SU','FG','BP',
     *   'IM','CQ','PC','TY','GC','MC','WX','BL','AN','CP','PD','SY',
     *   'CD','PP'/
C-----------------------------------------------------------------------
C                                       Single source now?
      CALL COPY (256, CATO, CATOUT)
      CALL COPY (256, CATO, CATBLK)
      CALL UVPGET (IRET)
      MULTI = ILOCSU.GT.0
      EIF = CATBLK(KINAX+JLOCIF)
      BIF = 1
      EIFSAV = EIF
C                                       Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKOU, CNOIN,
     *   CNOOUT, CATOUT, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'FLGIHI: ERROR COPYING TABLES'
         CALL MSGWRT (6)
         END IF
C                                       more complex tables
      MSGTXT = 'Updating tables for IF/FREQID/channel selection'
      CALL MSGWRT (4)
      ISUB = 0
      JSUB = -1
      NA = 0
C                                       STOKES selection not allowed
C                                       these ok even for 1 pol data
      BPOL = 1
      EPOL = 2
C                                       allow 15 min extra to be sure
C                                       that one gets all needed rows
      TIME1 = TSTART - 0.0104D0
      TIME2 = TEND + 0.0104D0
      CALL FILL (50, 0, AN)
C                                       FQ table
      IF (JLOCIF.GT.0) THEN
         VER = 1
         CALL TABCOP ('FQ', VER, VER, LUN1, LUN2, DISK2, DISKOU, CNO2,
     *      CNOOUT, CATOUT, BUFF1, BUFF2, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Reference frequency in AN table
C                                       IF selection
      CALL FNDEXT ('AN', CATUV, NVER)
      DO 100 VER = 1,NVER
         CALL ISTAB ('AN', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF ((EXIST) .AND. (IERR.EQ.0)) CALL ANSEL (DISKIN, CNOIN,
     *      DISKOU, CNOOUT, VER, VER, CATUV, CATOUT, LUN1, LUN2, BIF,
     *      EIF, FQOFF, DOPOL, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 100     CONTINUE
C                                       Revise tables:
      OFQID = FRQSEL
C                                       CL tables
      CALL FNDEXT ('CL', CATUV, NVER)
      IF (.NOT.MULTI) NVER = 0
C                                       write null table
      VER = 1
      CALL ISTAB ('CL', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *   EXIST, FITASC, IERR)
C                                       do NOT select on sources
      IF (EXIST .AND. (IERR.EQ.0)) THEN
         IF (MULTI) THEN
            CALL CLNULL (DISKIN, CNOIN, DISKOU, CNOOUT, VER, CATUV,
     *         CATOUT, LUN1, LUN2, BPOL, EPOL, BIF, EIF, OFQID, TIME1,
     *         TIME2, 0, SOUWAN, AN, NA, ISUB, JSUB, BUFF1, BUFF2, IRET)
         ELSE
            CALL CL2FO (DISKIN, CNOIN, VER, LUN1, CATUV, DISKOU, CNOOUT,
     *         LUN2, CATOUT, SOUWAN, BUFF1, BUFF2, IRET)
            END IF
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       CP tables: none
      CALL FNDEXT ('CP', CATUV, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'CP TABLES NOT COPIED'
         CALL MSGWRT (6)
         END IF
C                                       CQ tables
      CALL FNDEXT ('CQ', CATUV, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'CQ TABLES NOT COPIED'
         CALL MSGWRT (6)
         END IF
C                                       FG tables
      CALL FNDEXT ('FG', CATUV, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'FLAG TABLES NOT COPIED'
         CALL MSGWRT (6)
         END IF
C                                       GC tables
      CALL FNDEXT ('GC', CATUV, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'GC TABLES NOT COPIED'
         CALL MSGWRT (6)
         END IF
C                                       IM tables
      CALL FNDEXT ('IM', CATUV, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'IM TABLES NOT COPIED'
         CALL MSGWRT (6)
         END IF
C                                       MC tables
      CALL FNDEXT ('MC', CATUV, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'MC TABLES NOT COPIED'
         CALL MSGWRT (6)
         END IF
C                                       PC tables
      CALL FNDEXT ('PC', CATUV, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'PC TABLES NOT COPIED'
         CALL MSGWRT (6)
         END IF
C                                       PD tables
      CALL FNDEXT ('PD', CATUV, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'PD TABLES NOT COPIED'
         CALL MSGWRT (6)
         END IF
C                                       PP tables
      CALL FNDEXT ('PP', CATUV, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'PP TABLES NOT COPIED'
         CALL MSGWRT (6)
         END IF
C                                       SU tables
      IF (ILOCSU.GE.0) THEN
         CALL FNDEXT ('SU', CATUV, NVER)
         DO 300 VER = 1,NVER
            CALL ISTAB ('SU', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *         EXIST, FITASC, IERR)
            IF (EXIST .AND. (IERR.EQ.0)) CALL SUSEL (DISKIN, CNOIN,
     *         DISKOU, CNOOUT, VER, CATUV, CATOUT, LUN1, LUN2, BIF, EIF,
     *         OFQID, BUFF1, BUFF2, IRET)
            IF (IRET.GT.0) GO TO 999
 300        CONTINUE
         END IF
C                                       SY tables
      CALL FNDEXT ('SY', CATUV, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'SY TABLES NOT COPIED'
         CALL MSGWRT (6)
         END IF
C                                       TY tables
      CALL FNDEXT ('TY', CATUV, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'TY TABLES NOT COPIED'
         CALL MSGWRT (6)
         END IF
C                                       WX tables
      CALL FNDEXT ('WX', CATUV, NVER)
      DO 340 VER = 1,NVER
         CALL ISTAB ('WX', DISKIN, FCNO(2), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL WXSEL (DISKIN, CNOIN,
     *      DISKOU, CNOOUT, VER, CATUV, CATOUT, LUN1, LUN2, TIME1,
     *      TIME2, AN, NA, ISUB, JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 340     CONTINUE
C
      EIF = EIFSAV
      CALL COPY (256, CATOUT, CATO)
C
 999  RETURN
      END

      SUBROUTINE ZBKLD3 (IERR)
C-----------------------------------------------------------------------
C! clean up system things for BAKLD ending
C# Z Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Routine to clean up host environment after executing task BAKLD.
C   Output:
C      IERR   I   Error code: 0 => okay
C                    1 => can't open command file
C   Generic UNIX version.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   ITEMP, ITRIM, CLEN
      CHARACTER COMMND*40, HTEMP*1, TEXT*128
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DBKL.INC'
C-----------------------------------------------------------------------
      IERR = 0
      OPEN (ZLUN2, FILE=ZBKNAM, STATUS='UNKNOWN', ERR=900)
C                                       generate command file:
      REWIND ZLUN2
C                                       delete our DA00 subdirectory
C                                       plus dd/tar/ls scratches
      CALL ZEHEX (NPOPS, 1, HTEMP)
      TEXT = 'rm -r ' // ZDA00(1:LZDA00) // '/BAKLD' // HTEMP // '.*'
      ITEMP = ITRIM (TEXT)
      WRITE (ZLUN2,1000,ERR=900) TEXT(1:ITEMP)
      CLOSE (ZLUN2)
      COMMND = ZBKNAM
      CLEN = ITRIM (COMMND)
      CALL ZSHCMD (CLEN, COMMND, 8, 'TASK_OUT', IERR)
C                                       delete command file
      IF (IERR.EQ.0) THEN
         COMMND = 'rm ' // ZBKNAM
         CLEN = ITRIM (COMMND)
         CALL ZSHCMD (CLEN, COMMND, 8, 'TASK_OUT', IERR)
         END IF
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (8)
         MSGTXT = 'ZBKLD3: ' // COMMND
         GO TO 990
         END IF
      GO TO 999
C                                       can't open, fatal error:
 900  MSGTXT = 'ZBKLD3: CANNOT OPEN ' // ZBKNAM
      IERR = 1
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A)
 1010 FORMAT ('ZBKLD3: ZSHCMD ERROR',I7,'  COMMAND=')
      END

      SUBROUTINE TVFIDL (LCHAN, NLEVS, INBUF, IERR)
C-----------------------------------------------------------------------
C! standard, simple interactive B&W LUT and color enhancements, zooming
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2008, 2015, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TVFIDL does an interactive run with button A selecting alternately
C   TVTRANSF and TVPSEUDO (color contour type 2 only), button B
C   incrementing the zoom and C decrementing the zoom.
C   Inputs:
C      LCHAN    I      Selected gray-scale channels: bit mask
C      NLEVS    I      Number of gray levels (usually LUTOUT+1)
C   Output:
C      INBUF    I      Scratch buffer >3072
C      IERR     I      Error code: 0 -> ok;  else set by ZM70XF
C-----------------------------------------------------------------------
      INTEGER   LCHAN, NLEVS, INBUF(*), IERR
C
      INCLUDE 'INCS:PTVC.INC'
      INTEGER   JERR, TYPE, I, IZX, IZY, ITW(3), ITRTYP, IBUT, QUAD,
     *   ICONT, NCONT, ITYCON, IMAG, J, MAG, IT, II, JJ
      LOGICAL   T, F, DOIT, SWITCH, DOZOOM
      REAL      X, RPOS(2), PPOS(2), RZPOS(2), PZPOS(2), PGAMMA,
     *    RBPOS(2), RSZX, RSZY, OFMBUF(TVMOFM)
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IF (NLEVS.LE.10) NLEVS = LUTOUT + 1
      IF (NLEVS.GT.OFMINP) NLEVS = OFMINP + 1
C                                       initial zoom parameters
      IZX = (WINDTV(1) + WINDTV(3)) / 2 + 1
      IZY = (WINDTV(2) + WINDTV(4)) / 2
      IMAG = TVZOOM(1)
      IMAG = MAX (0, MIN (IMAG, ABS(MXZOOM)))
      MAG = 1 + IMAG
      IF (MXZOOM.GT.0) MAG = 2 ** IMAG
      RZPOS(1) = ((TVZOOM(2) - 1.) * (MAG - 1.) + IZX) / MAG + 1.
      RZPOS(2) = MAXXTV(2) - ((MAXXTV(2) - TVZOOM(3)) * (MAG - 1.) +
     *   IZY) / MAG
      IF ((RZPOS(1).LE.WINDTV(1)) .OR. (RZPOS(1).GE.WINDTV(3)))
     *   RZPOS(1) = IZX
      IF ((RZPOS(2).LE.WINDTV(2)) .OR. (RZPOS(2).GE.WINDTV(4)))
     *   RZPOS(2) = IZY
      PZPOS(1) = RZPOS(1)
      PZPOS(2) = RZPOS(2)
C                                       Interactive section
      WRITE (MSGTXT,1200)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1201)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1202)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1203)
      CALL MSGWRT (1)
      RSZX = WINDTV(3) - WINDTV(1) + 1
      RSZY = WINDTV(4) - WINDTV(2) + 1
C                                       initial color cursor
      RPOS(1) = 7.0 + WINDTV(1)
      RPOS(2) = WINDTV(4) - 7.0
      PPOS(1) = 0.
      PPOS(2) = 0.
      RBPOS(1) = 0.
      RBPOS(2) = 0.
      CALL ZTIME (ITW)
C                                       Wait for initial button
      ITRTYP = 1
      SWITCH = F
      DOZOOM = IMAG.EQ.0
      QUAD = -1
      CALL YCURSE ('ONNN', T, F, RZPOS, QUAD, IBUT, IERR)
      IF (IERR.EQ.2) THEN
         RZPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
         RZPOS(2) = (WINDTV(2) + WINDTV(4)) / 2
         CALL YCURSE ('ONNN', T, F, RZPOS, QUAD, IBUT, IERR)
         END IF
 210  IF (IERR.NE.0) GO TO 900
      IF (IBUT.GT.7) GO TO 900
      IF (IBUT.GT.0) THEN
         CALL YWINDO ('READ', WINDTV, IERR)
         IF (IERR.NE.0) GO TO 900
         RSZX = WINDTV(3) - WINDTV(1) + 1
         RSZY = WINDTV(4) - WINDTV(2) + 1
         END IF
C                                       Transfer functions
      IF (IBUT.LE.1) THEN
         IF (SWITCH) ITRTYP = MOD (ITRTYP, 2) + 1
C                                       Black and white: clear colors
         IF (ITRTYP.NE.2) THEN
            IT = OFMINP + 1
            CALL RFILL (IT, 0.0, OFMBUF)
            X = 1.0 / REAL(NLEVS-1)
            DO 215 I = 1,NLEVS
               OFMBUF(I) = (I-1) * X
 215           CONTINUE
            JJ = NLEVS
            IT = IT / JJ
            DO 216 II = 2,IT
               CALL RCOPY (NLEVS, OFMBUF, OFMBUF(JJ+1))
               JJ = JJ + NLEVS
 216           CONTINUE
            CALL YOFM ('WRIT', 7, F, OFMBUF, IERR)
            PPOS(1) = 0.0
            PPOS(2) = 0.0
            WRITE (MSGTXT,1215)
            CALL MSGWRT (1)
            WRITE (MSGTXT,1216)
            CALL MSGWRT (1)
            TYPE = 3
            CALL IENHNS (LCHAN, 7, TYPE, RBPOS, INBUF, IERR)
            IBUT = TYPE
            SWITCH = T
            DOZOOM = IMAG.EQ.0
C                                       Color: clear LUT
         ELSE
            J = MAXINT + 1
            X = REAL (LUTOUT) / REAL (MAXINT)
            DO 220 I = 1,J
               INBUF(I) = (I-1) * X + 0.5
 220           CONTINUE
            CALL YLUT ('WRIT', LCHAN, 7, F, INBUF, IERR)
            IF (IERR.NE.0) GO TO 900
            WRITE (MSGTXT,1220)
            CALL MSGWRT (1)
            WRITE (MSGTXT,1221)
            CALL MSGWRT (1)
C                                        init vals, on cursor:
C                                        PPOS 0 forces action 1st time
            CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IERR)
            IF (IERR.EQ.2) THEN
               RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
               RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2
               CALL YCURSE ('ONNN', T, F, RPOS, QUAD, IBUT, IERR)
               END IF
            IF (IERR.NE.0) GO TO 900
            SWITCH = T
            DOZOOM = IMAG.EQ.0
            PPOS(2) = RPOS(2) - 3.
            PPOS(1) = RPOS(1) - 1.
C                                        read loop
 235        CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IERR)
            IF ((IERR.NE.0) .OR. (IBUT.GT.7)) GO TO 900
            IF (IBUT.EQ.0) THEN
               CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
               IF (DOIT) THEN
C                                        cursor moved: do it
                  ITYCON = 1
                  PGAMMA = 1.0
                  ICONT = ((RPOS(1) - WINDTV(1) + 1.) / RSZX) * NLEVS
                  ICONT = MAX (0, ICONT)
                  NCONT = NLEVS * (RPOS(2) - WINDTV(2) + 1.0) / RSZY
                  CALL COLORC (ITYCON, NLEVS, ICONT, NCONT, PGAMMA,
     *               OFMBUF, IERR)
                  IF (IERR.NE.0) GO TO 900
                  END IF
               GO TO 235
               END IF
            END IF
      ELSE
         DOIT = (DOZOOM) .AND. ((IBUT.EQ.2) .OR. (IBUT.EQ.4))
         IF ((IBUT.EQ.2) .AND. (DOZOOM)) IMAG = IMAG + 1
         IF ((IBUT.EQ.4) .AND. (DOZOOM)) IMAG = IMAG - 1
         IMAG = MAX (0, MIN (IMAG, ABS(MXZOOM)))
         QUAD = -1
         CALL YCURSE ('ONNN', F, T, RZPOS, QUAD, IBUT, IERR)
         IF (IERR.EQ.2) THEN
            RZPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
            RZPOS(2) = (WINDTV(2) + WINDTV(4)) / 2
            CALL YCURSE ('ONNN', T, F, RZPOS, QUAD, IBUT, IERR)
            END IF
         IF (IERR.NE.0) GO TO 900
         IF (DOIT) GO TO 255
C                                       read cursor until moves
 250     CALL YCURSE ('READ', F, T, RZPOS, QUAD, IBUT, IERR)
         IF ((IBUT.GT.7) .OR. (IERR.NE.0)) GO TO 900
         IF (IBUT.EQ.1) GO TO 210
         CALL DLINTR (RZPOS, IBUT, PZPOS, ITW, DOIT)
         DOIT = DOIT .AND. ((IMAG.GT.0) .OR. (IBUT.GT.0))
C                                       new zoom center & factor
 255     IF (DOIT) THEN
            IF ((IBUT.EQ.2) .AND. (DOZOOM)) IMAG = IMAG + 1
            IF ((IBUT.EQ.4) .AND. (DOZOOM)) IMAG = IMAG - 1
            IMAG = MAX (0, MIN (IMAG, ABS(MXZOOM)))
            IF (IBUT.GT.0) THEN
               CALL YWINDO ('READ', WINDTV, IERR)
               IF (IERR.NE.0) GO TO 900
               RSZX = WINDTV(3) - WINDTV(1) + 1
               RSZY = WINDTV(4) - WINDTV(2) + 1
               END IF
            IZX = (WINDTV(1) + WINDTV(3)) / 2
            IZY = (WINDTV(2) + WINDTV(4)) / 2
            IF (IMAG.EQ.0) THEN
               MAG = 1
               IZX = IZX + 1
            ELSE
               MAG = 1 + IMAG
               IF (MXZOOM.GT.0) MAG = 2 ** IMAG
               IZX = (MAG * (RZPOS(1)-1.0) - IZX) / (MAG-1) + 1.0
               IZX = MAX (1, MIN (MAXXTV(1), IZX))
               IZY = MAXXTV(2) - (MAG * (MAXXTV(2)-RZPOS(2)) - IZY)
     *            / (MAG-1)
               IZY = MAX (1, MIN (MAXXTV(2), IZY))
               END IF
C                                        reset zoom and cursor so that
C                                        cursor is centered and on the
C                                        zoom center
            CALL YZOOMC (IMAG, IZX, IZY, F, IERR)
            IF (IERR.NE.0) GO TO 900
            SWITCH = F
            DOZOOM = T
            QUAD = -1
            CALL YCURSE ('ONNN', F, T, RZPOS, QUAD, IBUT, IERR)
            IF (IERR.EQ.2) THEN
               RZPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
               RZPOS(2) = (WINDTV(2) + WINDTV(4)) / 2
               CALL YCURSE ('ONNN', T, F, RZPOS, QUAD, IBUT, IERR)
               END IF
            IF ((IBUT.GT.7) .OR. (IERR.NE.0)) GO TO 900
            END IF
         GO TO 250
         END IF
      GO TO 210
C-----------------------------------------------------------------------
C                                        close down
C                                        cursor off, TV closed
 900  CALL YCURSE ('OFFF', F, F, RZPOS, QUAD, IBUT, JERR)
C                                        messages on error
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1900) IERR
         CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1200 FORMAT ('Hit button A to enhance B/W or color alternately')
 1201 FORMAT ('Hit button B to increment zoom & set zoom center')
 1202 FORMAT ('Hit button C to decrement zoom & set zoom center')
 1203 FORMAT ('Hit button D to exit')
 1215 FORMAT ('Cursor X controls intercept')
 1216 FORMAT ('Cursor Y controls slope')
 1220 FORMAT ('Cursor X controls position of first contour')
 1221 FORMAT ('Cursor Y controls width of color contours')
 1900 FORMAT ('ERROR WITH TV: CODE #',I7)
      END

      SUBROUTINE SAVHDR (LUN, CATBLK, ERROR)
C-----------------------------------------------------------------------
C! Save catalog header for an open file.
C# Map IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   WaWa IO system: Save the catalog header block for a file that
C   is already open (via FILOPN or OPENCF)
C   Inputs:
C      LUN      I        Logical Unit No. of file
C      CATBLK   I(256)   Saved Header block
C   Outputs:
C      ERROR    I        Error code: 0 => ok
C                           1 => file not open
C                          10 => catlg error
C-----------------------------------------------------------------------
      INTEGER   LUN, CATBLK(256), ERROR
C
      INTEGER   CATER, NOTOPN, WARN, NSUB, IERR, IFIL
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DBUF.INC'
      DATA NOTOPN, CATER, WARN /1, 10, 6/
C-----------------------------------------------------------------------
C                                       Is file open: get ID
      ERROR = NOTOPN
      DO 10 IFIL = 1,EFIL
         IF (FILTAB(POLUN,IFIL).EQ.LUN) GO TO 20
 10      CONTINUE
      GO TO 999
C                                       Read catalog block
 20   NSUB = 2
      ERROR = 0
      CALL CATIO ('UPDT', FILTAB(POVOL,IFIL), FILTAB(POCAT,IFIL),
     *   CATBLK, 'REST', WBUFF, IERR)
      IF ((IERR.EQ.0) .OR. (IERR.EQ.WARN)) GO TO 999
         ERROR = CATER
         WRITE (MSGTXT,1020) SUBNAM(NSUB), 'UPDT',
     *       FILTAB(POVOL,IFIL), FILTAB(POCAT,IFIL), IERR
         CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('SAVHDR: ',A6,1X,A4,' ERROR VOL',I2,' SLOT',I4,
     *   ' ERROR',I6)
      END

      SUBROUTINE FMATCH (NS, AS, NL, AL, IL)
C-----------------------------------------------------------------------
C! returns pointer to location of small array in a bigger array
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FMATCH returns a pointer to the location in a large array at which a
C   given smaller array begins.  NOTE: do not use Hollerith.
C   Inputs: NS    I        number words in smaller array
C           AS    I(NS)    smaller "search" array
C           NL    I        number of words in larger array
C           AL    I(NL)    larger "test" array
C   Output: IL    I        index in larger array (0 if no match)
C-----------------------------------------------------------------------
      INTEGER   NS, AS(*), NL, AL(*), IL
C
      INTEGER   I, J, N
C-----------------------------------------------------------------------
      IL = 0
      IF (NL.LT.NS) GO TO 999
         N = NL - NS + 1
         DO 20 I = 1,N
            DO 10 J = 1,NS
               IF (AS(J).NE.AL(I+J-1)) GO TO 20
 10            CONTINUE
            IL = I
            GO TO 999
 20         CONTINUE
C
 999  RETURN
      END

      SUBROUTINE QTAPER (APCORE, GPARMS, UU, DV, N, CMG)
C-----------------------------------------------------------------------
C! Pseudo AP routine: prepare Gaussian taper
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1999, 2002, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version.
C   QTAPER is a utility routine for model subtraction of Gaussian
C   components.  It computes the Gaussian taper for a row at UU and V
C   pixels from -n/2*DV to n/2*dv.
C   Inputs:
C      GPARMS   R(3)   Bmaj, Bmin, Bpa in degrees
C      UU       R      U value in wavelengths
C      DV       R      V increment per pixel
C      N        I      Number of Y pixels
C      CMG      I      Base address of multiplier vector
C   Output: APCORE(CMG and up) taper multiplier
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   N, CMG
      REAL      GPARMS(3), UU, DV
C
      DOUBLE PRECISION VV, B1, B2, B3, CPA, SPA, XMAJ, XMIN, CONST, TEXP
      INTEGER   NY, I
      LONGINT   CM
      INCLUDE 'INCS:DAPC.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Setup pointers etc.
      NY = N + 1
      CM = CMG + PSAPOF
C                                       compute beam constants
      CONST = DG2RAD * PI * SQRT (0.5D0) / 1.17741022D0
      XMAJ = GPARMS(1) * CONST
      XMIN = GPARMS(2) * CONST
      CPA = COS (DG2RAD * GPARMS(3))
      SPA = SIN (DG2RAD * GPARMS(3))
      B1 = -(((CPA*XMAJ)**2) + ((SPA*XMIN)**2))
      B2 = -(((SPA*XMAJ)**2) + ((CPA*XMIN)**2))
      B3 = - 2.0D0 * SPA * CPA * (XMAJ*XMAJ - XMIN*XMIN)
C                                       loop to compute
      B2 = B2 * UU * UU
      B3 = B3 * UU
      VV = - N * DV / 2.0D0
      DO 10 I = 1,NY
         TEXP = B1 * VV * VV + B2 + B3 * VV
         IF (TEXP.GT.-14.0D0) THEN
            APCORE(CM) = EXP (TEXP)
         ELSE
            APCORE(CM) = 0.0D0
            END IF
         CM = CM + 1
         VV = VV + DV
 10      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE YSPLIT (OP, XSPLT , YSPLT , RCHANS, GCHANS, BCHANS,
     *   VRTRTC, IERR)
C-----------------------------------------------------------------------
C! set channel selection by split-screen quadrant
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YSPLIT reads/writes the look up table/ split screen control
C   registers of the TV - turns channels on/off by quadrant
C   Inputs:
C      OP       C*4    'READ' from TV, 'WRIT' to TV
C      VRTRTC   L      T => do on vertical retrace only
C   In/Out:
C      XSPLT    I      X position of split (1-512, 1 => LHS)
C      YSPLT    I      Y position of split (1-512, 1 => bot)
C      RCHANS   I(4)   chan select bit mask 4 quadrants : red
C      GCHANS   I(4)   chan select bit mask 4 quadrants : green
C      BCHANS   I(4)   chan select bit mask 4 quadrants : blue
C   Output:
C      IERR     I      error code of Z...XF: 0 => ok, 2 => input error
C   Quadrants are numbered CCW from top right!!!!
C   Version for IIS IVAS - uses split 2 and 4 vertically as quadrants
C   1 and 2 resp.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   XSPLT, YSPLT, RCHANS(4), GCHANS(4), BCHANS(4), IERR
      LOGICAL   VRTRTC
C
      INTEGER   MASK, ZAND, JERR, J4A, J4B, J4C, JR, JB, JG
      INTEGER   FIVASGMFREEZE, FIVASGPHSPLIT, FIVASGMDEFIMAGE,
     *   FIVASGMSELIMAGE
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
C                                        write: set buffer
      IF (OP.EQ.'WRIT') THEN
         IERR = 2
         IF ((XSPLT.LT.1) .OR. (XSPLT.GT.MAXXTV(1))) GO TO 999
         IF ((YSPLT.LT.1) .OR. (YSPLT.GT.MAXXTV(2))) GO TO 999
         CALL YVRTR (VRTRTC, IERR)
         IF (IERR.NE.0) GO TO 999
         JERR = FIVASGMFREEZE (1)
         IF (JERR.NE.0) GO TO 900
         J4A = 1024 - YSPLT
         JERR = FIVASGPHSPLIT (0, J4A, 0, YSPLT, 1)
         IF (JERR.NE.0) GO TO 850
         YBUFF(10) = YSPLT
         MASK = 2 ** NGRAY - 1
         DO 20 J4A = 1,3,2
            RCHANS(J4A) = ZAND (RCHANS(J4A), MASK)
            GCHANS(J4A) = ZAND (GCHANS(J4A), MASK)
            BCHANS(J4A) = ZAND (BCHANS(J4A), MASK)
            J4B = 1
            IF ((RCHANS(J4A).EQ.0) .AND. (BCHANS(J4A).EQ.0) .AND.
     *         (GCHANS(J4A).EQ.0)) J4B = -1
C                                       try
            IF ((RCHANS(J4A).EQ.0) .AND. (BCHANS(J4A).EQ.0) .AND.
     *         (GCHANS(J4A).EQ.0)) J4B = 0
            CALL YLOWON (RCHANS(J4A), JR)
            JG = JR
            JB = JR
            IF (NGRAY.GT.2) THEN
               CALL YLOWON (GCHANS(J4A), JG)
               CALL YLOWON (BCHANS(J4A), JB)
               END IF
            J4C = (5-J4A)/2
            JERR = FIVASGMDEFIMAGE (JR, JG, JB, J4B, J4C)
            IF (JERR.NE.0) GO TO 850
            JERR = FIVASGMSELIMAGE (J4B, J4C)
            IF (JERR.NE.0) GO TO 850
            J4C = (J4A+1)/2
            YBUFF(3+J4C) = RCHANS(J4A)
            YBUFF(5+J4C) = GCHANS(J4A)
            YBUFF(7+J4C) = BCHANS(J4A)
 20         CONTINUE
         JERR = FIVASGMFREEZE (0)
         IF (JERR.NE.0) GO TO 900
         TVSPLT(1) = XSPLT
         TVSPLT(2) = YSPLT
C                                        return data
      ELSE
         IERR = 0
         XSPLT = MAXXTV(1) / 2
         YSPLT = YBUFF(10)
         RCHANS(1) = YBUFF(4)
         RCHANS(2) = YBUFF(4)
         RCHANS(3) = YBUFF(5)
         RCHANS(4) = YBUFF(5)
         GCHANS(1) = YBUFF(6)
         GCHANS(2) = YBUFF(6)
         GCHANS(3) = YBUFF(7)
         GCHANS(4) = YBUFF(7)
         BCHANS(1) = YBUFF(8)
         BCHANS(2) = YBUFF(8)
         BCHANS(3) = YBUFF(9)
         BCHANS(4) = YBUFF(9)
         END IF
      GO TO 999
C                                       Errors
 850  CALL YDOERR ('YSPLIT', JERR, IERR)
      JERR = FIVASGMFREEZE (0)
      IF (JERR.EQ.0) GO TO 999
C
 900  CALL YDOERR ('YSPLIT', JERR, IERR)
C
 999  RETURN
      END

      SUBROUTINE KWIKHD
C-----------------------------------------------------------------------
C! list header contents in abbreviated, image centered form
C# Header
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2014, 2021-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   KWIKHD lists the contents of a standard header using MSGWRT.
C   Unlike LSTHDR, this routine does not try to list everything and
C   does convert the coordinates to the image numeric center.
C   Common input:
C      /MAPHDR/ image catalog block
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PHDR.INC'
      CHARACTER BTEMP*8, CPTYPE*2, CNAME*12, CCLASS*6, NPRT*1, CTEMP*8,
     *   CHSTOK(20)*4, PRODUC(5)*8, CHSIGN*1, TEXT(NIEXTN)*2
      INTEGER   I, J, J1, J2, NAX, HM(2), INC, INP, NEXT(NIEXTN), IN,
     *   IROUND, MSLEV, IDEPTH(7), NNOT, IERR, IBS, ITRIM
      REAL      TEMP, SEC, DEC, RDX, RDY
      DOUBLE PRECISION X(7), DX, DY, DT, COSR, SINR
      LOGICAL   ISUV, DONEIT, OKFLAG, NOSWAP
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA CHSTOK /'BEAM','IPOL','QPOL','UPOL','VPOL','PPOL','FPOL',
     *   'PANG','SPIX','OPTD','ROTM','????','RR','LL','RL','LR','VV',
     *   'HH','VH','HV'/
      DATA PRODUC /'NORMAL  ','COMPNTS ','RESIDUAL','POINTS  ',
     *   'DIRTY   '/
      DATA MSLEV /2/
      DATA NOSWAP /.FALSE./
C-----------------------------------------------------------------------
      NNOT = 0
C                                       Image name and file name
      CALL H2CHR (8, 1, CATH(KHOBJ), BTEMP)
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), CNAME)
      CALL H2CHR (6, KHIMCO, CATH(KHIMN), CCLASS)
      CALL H2CHR (2, KHPTYO, CATH(KHIMN), CPTYPE)
      ISUV = CPTYPE.EQ.'UV'
      WRITE (MSGTXT,1010) BTEMP, CPTYPE, CNAME, CCLASS, CATBLK(KIIMS)
      CALL MSGWRT (MSLEV)
C                                       Blanking information
      IF (CATR(KRBLK).NE.0.0) THEN
         WRITE (MSGTXT,1020)
         IF (CATR(KRBLK).NE.FBLANK) WRITE (MSGTXT,1021) CATR(KRBLK)
         CALL MSGWRT (MSLEV)
         END IF
C                                       Real minimum and maximum
      IF (ISUV) GO TO 40
         CALL H2CHR (8, 1, CATH(KHBUN), BTEMP)
         SEC = CATR(KRDMX)
         DEC = CATR(KRDMN)
         TEMP = MAX (ABS(SEC), ABS(DEC))
         CTEMP = ' '
         IF (TEMP.EQ.0.0) GO TO 35
            CALL METSCA (TEMP, CTEMP, OKFLAG)
            IF (.NOT.OKFLAG) GO TO 34
               WRITE (MSGTXT,1030) DEC, SEC, BTEMP
               CALL MSGWRT (MSLEV)
               GO TO 40
 34         CONTINUE
               TEMP = TEMP / MAX (ABS(SEC), ABS(DEC))
               SEC = SEC * TEMP
               DEC = DEC * TEMP
 35      WRITE (MSGTXT,1035) DEC, SEC, CTEMP, BTEMP
         CALL MSGWRT (MSLEV)
C                                       Random axes
 40   IBS = CATBLK(KIGCN)
      J = CATBLK(KIPCN)
      IF ((IBS.LT.1) .OR. (J.LE.0)) GO TO 50
         IF (.NOT.ISUV) WRITE (MSGTXT,1040) IBS, J
         IF (ISUV) WRITE (MSGTXT,1041) IBS, CATBLK(KITYP)
         CALL MSGWRT (MSLEV)
         MSGTXT = 'Rand axes:'
         IF (ISUV) GO TO 50
            INC = 2
            INP = 12
            J = MIN (J, KIPTPN)
            DO 45 I = 1,J
               CALL H2CHR (8, 1, CATH(KHPTP+(I-1)*INC), MSGTXT(INP:))
               INP = ITRIM (MSGTXT) + 3
               IF (INP.GE.58) THEN
                  CALL MSGWRT (MSLEV)
                  INP = 12
                  MSGTXT = ' '
                  END IF
 45            CONTINUE
            IF (INP.GT.12) CALL MSGWRT (MSLEV)
C                                       Set up loop for axes
 50   NAX = CATBLK(KIDIM)
      WRITE (MSGTXT,1050)
      CALL MSGWRT (MSLEV)
      WRITE (MSGTXT,1051)
      CALL MSGWRT (MSLEV)
      INC = 2
C                                       Get values at center pixels
      IF (ISUV) THEN
         KLOCS(LOCNUM) = -1
         DO 55 I = 1,NAX
            J = I - 1
            X(I) = CATD(KDCRV+J) + CATR(KRCIC+J) * (1.0 - CATR(KRCRP+J))
            IDEPTH(I) = 1
            CALL H2CHR (8, 1, CATH(KHCTP+J*INC), CTEMP)
            IF (CTEMP.EQ.'STOKES') KLOCS(LOCNUM) = J
 55         CONTINUE
         GO TO 100
         END IF
C                                       Maps
      DO 65 I = 1,NAX
         IDEPTH(I) = (CATBLK(KINAX+I-1) + 1) / 2
 65      CONTINUE
      LOCNUM = 1
      CALL SETLOC (IDEPTH(3), NOSWAP)
      RDX = IDEPTH(1)
      RDY = IDEPTH(2)
      CALL XYVAL (RDX, RDY, X(1), X(2), X(KLOCA(LOCNUM)+1), IERR)
      IF (NAX.LT.3) GO TO 100
         DONEIT = AXTYP(LOCNUM).NE.4
         DO 95 I = 3,NAX
            J = I - 1
            IF (((AXTYP(LOCNUM).EQ.2) .OR. (AXTYP(LOCNUM).EQ.3)) .AND.
     *         (KLOCA(LOCNUM).EQ.J)) GO TO 95
            IF (AXFUNC(I,LOCNUM).GT.0) GO TO 70
               X(I) = (IDEPTH(I)-CATR(KRCRP+J))*CATR(KRCIC+J) +
     *            CATD(KDCRV+J)
               GO TO 95
 70         IF (AXFUNC(I,LOCNUM).GT.1) GO TO 75
               X(I) = IDEPTH(I) - CATR(KRCRP+J)
               X(I) = CATD(KDCRV+J) + X(I) * CATR(KRCIC+J) /
     *            (1.D0 + AXDENU(LOCNUM)*X(I))
               GO TO 95
 75         IF (AXTYP(LOCNUM).EQ.4) GO TO 80
               WRITE (MSGTXT,1075) I
               CALL MSGWRT (8)
               X(I) = (IDEPTH(I)-CATR(KRCRP+J))*CATR(KRCIC+J) +
     *            CATD(KDCRV+J)
               GO TO 95
 80         IF (DONEIT) GO TO 95
               DONEIT = .TRUE.
               DX = (ZDEPTH(KLOCL(LOCNUM)-1,LOCNUM) - RPLOC(3,LOCNUM)) *
     *            AXINC(3,LOCNUM)
               DY = (ZDEPTH(KLOCM(LOCNUM)-1,LOCNUM) - RPLOC(4,LOCNUM)) *
     *            AXINC(4,LOCNUM)
               COSR = COS (ROT(LOCNUM) * COND2R)
               SINR = SGNROT(LOCNUM) * SIN (ROT(LOCNUM) * COND2R)
               DT = (DX * COSR - DY * SINR) * COND2R
               DY = (DY * COSR + DX * SINR) * COND2R
               DX = DT
               COSR = RPVAL(3,LOCNUM) * COND2R
               SINR = RPVAL(4,LOCNUM) * COND2R
               CALL NEWPOS (AXFUNC(KLOCL(LOCNUM)+1,LOCNUM), COSR, SINR,
     *            DX, DY, X(KLOCL(LOCNUM)+1), X(KLOCM(LOCNUM)+1), IERR)
               X(KLOCL(LOCNUM)+1) = X(KLOCL(LOCNUM)+1) / COND2R
               X(KLOCM(LOCNUM)+1) = X(KLOCM(LOCNUM)+1) / COND2R
 95         CONTINUE
C                                       Loop to display axes
 100  DO 150 I = 1,NAX
         NPRT = ' '
         IF (ABS(IDEPTH(I)-CATR(KRCRP+I-1)).GT.0.05) THEN
            NPRT = '*'
            NNOT = NNOT + 1
            END IF
         J = I - 1
         CALL H2CHR (8, 1, CATH(KHCTP+J*INC), BTEMP)
C                                       Check axis type
         IF ((BTEMP(1:4).NE.'LL  ') .AND. (BTEMP(1:4).NE.'RA  ') .AND.
     *      (BTEMP(1:4).NE.'RA--')) GO TO 110
            CALL COORDD (1, X(I), CHSIGN, HM, SEC)
            DEC = CATR(KRCIC-1+I) * 3600.
            IF (ABS(DEC).GE.1.0) WRITE (MSGTXT,1100) BTEMP,
     *         CATBLK(KINAX-1+I), CHSIGN, HM, SEC, IDEPTH(I), NPRT, DEC,
     *         CATR(KRCRT-1+I)
            IF (ABS(DEC).LT.1.0) WRITE (MSGTXT,1101) BTEMP,
     *         CATBLK(KINAX-1+I), CHSIGN, HM, SEC, IDEPTH(I), NPRT, DEC,
     *         CATR(KRCRT-1+I)
            GO TO 145
 110     IF ((BTEMP(1:4).NE.'MM  ') .AND. (BTEMP(1:4).NE.'DEC ') .AND.
     *      (BTEMP(1:4).NE.'DEC-')) GO TO 120
            CALL COORDD (2, X(I), CHSIGN, HM, SEC)
            DEC = CATR(KRCIC-1+I) * 3600.
            GO TO 140
C                                       No RA or DEC axis
 120     IF (J.EQ.KLOCS(LOCNUM)) GO TO 130
            WRITE (MSGTXT,1120) BTEMP, CATBLK(KINAX-1+I), X(I),
     *         IDEPTH(I), NPRT, CATR(KRCIC-1+I), CATR(KRCRT-1+I)
            CALL MSGWRT (MSLEV)
            GO TO 150
C                                       Stokes axis
 130     CONTINUE
            TEMP = X(I)
            J1 = IROUND(TEMP) + 1
            J2 = J1
            IF ((J1.LE.0) .OR. (J1.GT.11)) J2 = 12
            IF ((J1.LE.0) .AND. (J1.GE.-7)) J2 = 13 - J1
            WRITE (MSGTXT,1130) BTEMP, CATBLK(KINAX-1+I), CHSTOK(J2),
     *         IDEPTH(I), NPRT, CATR(KRCIC-1+I), CATR(KRCRT-1+I)
            CALL MSGWRT (MSLEV)
            GO TO 150
C                                       RA or DEC axis
 140     IF (ABS(DEC).GE.1.0) WRITE (MSGTXT,1140) BTEMP,
     *      CATBLK(KINAX-1+I), CHSIGN, HM, SEC, IDEPTH(I), NPRT, DEC,
     *      CATR(KRCRT-1+I)
         IF (ABS(DEC).LT.1.0) WRITE (MSGTXT,1141) BTEMP,
     *      CATBLK(KINAX-1+I), CHSIGN, HM, SEC, IDEPTH(I), NPRT, DEC,
     *      CATR(KRCRT-1+I)
 145     IF (MSGTXT(25:25).EQ.' ') MSGTXT(25:25) = '0'
         CALL MSGWRT (MSLEV)
 150     CONTINUE
      WRITE (MSGTXT,1050)
      CALL MSGWRT (MSLEV)
C                                       Maptype and iterations
      IF ((CATBLK(KINIT).GT.0) .OR. (CATR(KRBMJ).GT.0.) .OR.
     *   (CATR(KRBMN).GT.0.)) THEN
         IF (.NOT.ISUV) THEN
            I = MAX (1, CATBLK(KITYP))
            IF (I.GT.4) I = 1
            IF (CATBLK(KINIT).LE.0) I = 5
            WRITE (MSGTXT,1160) PRODUC(I), CATBLK(KINIT)
            CALL MSGWRT (MSLEV)
            END IF
C                                       Beam Parameters
         TEMP = CATR(KRBMJ) * 3600.
         SEC = CATR(KRBMN) * 3600.
         DEC = CATR(KRBPA)
         WRITE (MSGTXT,1161) TEMP, SEC, DEC
         IF ((TEMP.LT.0.5) .AND. (SEC.LT.0.5)) WRITE (MSGTXT,1162)
     *      TEMP, SEC, DEC
         CALL MSGWRT (MSLEV)
         END IF
C                                       Extension files
      IN = 0
      CALL FXHDEX (CATBLK)
      DO 175 I = 1,KIEXTN
         J1 = KIVER - 1 + I
         IF ((CATBLK(J1).LE.0) .OR. (IN.EQ.50)) GO TO 175
            IN = IN + 1
            J2 = KHEXT - 1 + I
            CALL H2CHR (2, 1, CATH(J2), TEXT(IN))
            NEXT(IN) = CATBLK(J1)
 175     CONTINUE
      J1 = 1
 176  IF (J1.GT.IN) GO TO 180
         J2 = MIN (J1+4, IN)
         WRITE (MSGTXT,1175) (TEXT(I), NEXT(I), I = J1,J2)
         CALL MSGWRT (MSLEV)
         J1 = J2 + 1
         GO TO 176
C                                       Not reference pixel
 180  IF (NNOT.LE.0) GO TO 999
         WRITE (MSGTXT,1180)
         CALL MSGWRT (MSLEV)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('Image=',A8,'  (',A2,')',9X,'Filename=',A12,'.',A6,'.',I4)
 1020 FORMAT ('Magic value blanking')
 1021 FORMAT ('Illegal blanking',1PE15.7)
 1030 FORMAT ('Minimum=',1PE13.5,8X,'Maximum=',1PE13.5,1X,A8)
 1035 FORMAT ('Minimum=',F9.4,12X,'Maximum=',F9.4,1X,A5,A8)
 1040 FORMAT ('Group count',I10,8X,'# Random axes',I2)
 1041 FORMAT ('# visibilities',I10,5X,'Sort order  ',A2)
 1050 FORMAT (2('-------------------------------'))
 1051 FORMAT ('Type    Pixels   Coord value  at Pixel',
     *   '    Coord incr   Rotat')
 1075 FORMAT ('ERROR IN TYPE POINTERS, AXIS NUMBER',I6)
 1100 FORMAT (A8,I6,2X,A1,1X,I2.2,I3.2,F7.3,I8,A1,F13.3,F8.2)
 1101 FORMAT (A8,I6,2X,A1,1X,I2.2,I3.2,F7.3,I8,A1,F13.6,F8.2)
 1120 FORMAT (A8,I6,2X,1PE14.6,I8,A1,1PE13.4,0PF8.2)
 1130 FORMAT (A8,I6,4X,A4,8X,I8,A1,F13.4,F8.2)
 1140 FORMAT (A8,I6,3X,A1,I2.2,I3.2,F7.3,I8,A1,F13.3,F8.2)
 1141 FORMAT (A8,I6,3X,A1,I2.2,I3.2,F7.3,I8,A1,F13.6,F8.2)
 1160 FORMAT ('Map type=',A8,12X,'Number of iterations=',I8)
 1161 FORMAT ('Conv size=',F7.2,' X',F7.2,3X,'Position angle=',F7.2)
 1162 FORMAT ('Conv size=',F8.5,' X',F8.5,3X,'Position angle=',F7.2)
 1175 FORMAT ('Max ext file #:',5(1X,A2,I4,3X))
 1180 FORMAT ('* => NOT the formal reference pixel on this axis')
      END

LOCAL INCLUDE 'CUBSIZ.INC'
      INTEGER   MAXPRM
      PARAMETER (MAXPRM = 15)
LOCAL END
LOCAL INCLUDE 'CUBIT.INC'
      INCLUDE 'CUBSIZ.INC'
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO, JBUFSZ,
     *   CATOLD(256), FIX(MAXPRM), FPNUM(MAXPRM)
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOT(2), XVCODE(1),
     *   XDCODE(1)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, VCODE*4,
     *   DCODE*4, FSTRNG(MAXPRM)*24, PSTRNG(MAXPRM)*24
      REAL      XSEQIN, XDISKI, XSEQO, XDISKO, BLC(7), TRC(7), TOL,
     *   FPARM(30), CPARM(10), DPARM(10), VPARM(30), ERRV,
     *   RPARM(30), XCUT, OLDR(256)
      HOLLERITH OLDH(256)
      DOUBLE PRECISION OLDD(128)
      EQUIVALENCE (CATOLD, OLDR, OLDH, OLDD)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XNAMOU, XCLAOT,
     *   XSEQO, XDISKO, BLC, TRC, TOL, XVCODE, XDCODE, FPARM, CPARM,
     *   DPARM, VPARM, RPARM, XCUT, ERRV
      COMMON /CHPARM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, VCODE, DCODE,
     *   FSTRNG, PSTRNG
      COMMON /PARMS/ CATOLD, SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO,
     *   OLDCNO, JBUFSZ, FIX, FPNUM
LOCAL END
LOCAL INCLUDE 'CUBPRM.INC'
      REAL      BUFF1(16384), BUFF2(16384), DSKMAX, DSKMIN, COSMIN,
     *   COSMAX, SINMIN, SINMAX, CONST, DELVEL, WIDTH
      COMMON /PARM1/ CONST, DELVEL, WIDTH
      COMMON /BUFRS/ BUFF1, BUFF2
      COMMON /LIMITS/ DSKMIN, DSKMAX, COSMIN, COSMAX, SINMIN, SINMAX
LOCAL END
LOCAL INCLUDE 'CUBDIM.INC'
      INTEGER   NXOUT, NYOUT, NVOUT
      COMMON /ALSMTH/ NXOUT, NYOUT, NVOUT
LOCAL END
      PROGRAM CUBIT
C-----------------------------------------------------------------------
C!  Task to model the HI velocity and density dist'ns in galaxies
C#  Map-util Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 2007, 2010, 2012, 2015, 2017, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;  Developed by Judith Irwin, University of Toronto  1989-2000
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CUBIT was developed from the AIPS template program, TAFFY.   If
C   pixel blanking is desired it should first be done in BLANK or some
C   other appropriate task.  The  image should then be transposed (eg.
C   task TRANS) if necessary such that the first axis is VELO in m/s
C   and second and third axes are RA and DEC, respectively.
C
C   CUBIT is linked with the same subroutines as TAFFY but
C   in addition, the subroutines LSTSQ1 and LSTSQ need to be
C   added to the appropriate apl sublibrary and several other
C   subroutines need to be recompiled -- see README.DOC for
C   directions.  There are also currently, limits on the size
C   of the cube which can be inputted. To increase the size of the
C   input cube, see README.DOC as well.
C
C   Aug/89 version changes made -- fixed up problem with gaussian
C          when z (see FCN) boundaries are both +ve and -ve --
C          turned back on the JJ=2 switch which had accidentally
C          been turned off.
C   November/89 changes made -- Fixed up problem along minor axis
C          which didn't allow +ve RX to correspond to -ve vel.
C   December/89 version -- Completely revamped subroutine Density
C          to correctly  deal with multiplication of R fcn by
C          z fcn.  An approximation is required for the integration.
C          Changes have been made to the Deltas which determine the
C          Derivatives.  Also, when incrementing the FPARMs to
C          calculate the derivatives, checks have been installed
C          to ensure that they are still in bounds. The rotation
C          curve maximum position has been constrained to be within
C          three times the disk radius.
C   January/90 version -- Fixed up RC case to allow a declining
C          rotation curve.
C   June/91 modifications -- readjusted boundaries when value is
C          out of bounds -- both for FPARM and derivative
C          -- adjusted code to avoid underflows in computing density
C          -- changed logistics of code for IFLAG >1 such that out
C          of bounds criteria are applied only once
C          -- adjusted acceptance criteria in density subroutine
C          to allow new value when increments small -- depends on
C          PIXSTD
C          -- tweaked the increments for derivative calculations
C          again
C          -- adjusted output format to allow an extra figure
C          -- changed connection between LSTSQ and FCN for a case
C          with blanking to ensure that on the first call the deltas
C          are set even if IFLAG .ne. 2.
C          -- in incrementing for derivatives, included code which
C          avoids round off errors near boundaries
C          -- Adjusted upper limit on rmax to be 10*dskmax
C          -- Corrected derp/derm error which divided by different
C          increments
C          -- Ensured that FPARM(10) and FPARM(11) are fixed if
C          the density is constant
C     1May/92 version (Queen's University) -- modifications to work
C          with AIPS versions 15OCT89 or later.  Modified the cal-
C          culation for the case close to the minor axis so that
C          emission can extend into two rather than just one channel.
C     15May92 version -- made modifications so that a ring density
C          distribution can be included (like sept91 in old aips).
C          Different scale lengths are allowed for radii on either
C          side of the ring.  Another FPARM is needed for this.
C          Added additional constraint that FPARM(10) should not be
C          greater than 10*DSKMAX.
C          In DENSTY:  constrained ZINC so that it doesn't fall below
C          1e-30
C     1June92 version -- added velocity smoothing option - UNFINISHED
C     1Aug92 version -- After CUBIT.FOR deleted accidentally!  Start
C          with unfinished vel smoothing version.  Made improvements
C          to the selection criteria in subroutine DENSTY
C     Dec/92 -- starting again to check vel smoothing
C     Feb/93 -- corrected error in subroutine SMOOTH/SMTH1.  A scaling
C          factor was required to get the intensity correct.  The error
C          related to the fact that I is in Jy/beam, whereas the cal-
C          culation was done per pixel and then smoothed to the beam
C          area.  Consequently a multiplicative factor of beam area(in
C          pixels) was introduced erroneously during smoothing.  All
C          was introduced erroneously during smoothing.  All previous
C          CUBIT's have been in error by this amount.  The only
C          affected value is density which would have been low by
C          this same factor.
C      **TO CORRECT DENSITY VALUES FROM PREVIOUS VERIONS, MULTIPLY BY
C          BMAJ*BMIN (IN PIXELS^2)  (NO FACTOR OF PI)**
C      Aug/93 -- introduced a velocity dispersion option
C      Apr/95 -- introduced a flux cutoff so that low level emission
C          could be ignored in the model
C          Also included an exponential ring distribution
C      Jun/00 -- fixing up some syntax, (one comma was omitted which
C        only produced a warning previously but caused the compile
C        to fail under linux g77)
C        Fixed up the warning (now a fail) about differing buffr lengths
C        for the array WA and BUFFR1 -- this was done by eliminating
C        the equivalence between WA and BUFF1 in SENDMA
C        Had to change the length of BUFF1, BUFF2, XBUFF1, AND XBUFF2
C        to 16384 to be compatible with new aips.  Also changed JBUFSZ.
C        Finally, note that LSTSQ could not recognize FBLANK.  had to
C        replace the previous ddch.inc with the new one in LSTSQ
C      Jul/00 -- this version attempts to model a 2-component vertical
C        distribution of density,
C       i.e. n(R,z)=n(R,0)*[fn1 exp(-h/b1) + fn2 exp(-h^2/b2^2)] fn1+fn2=1
C       so we are adding 3 new parameters
C       Also fixed a little problem with the velocity smoothing (VSMTH)
C       -- i.e. some forbidden velocities are allowed after vel. smoothing
C      Aug/00 -- fixed some boundary problems near vsys and fixed a
C           problem with sb
C
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLAOUT        Class of the output image.
C                                   Default is input class.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      FACTOR         TOL           Convergence criterion to stop
C                                   iteration (0 => .001)
C      VCODE          VCODE         Velocity code 'CV','SB','BR','RC'
C      DCODE          DCODE         Density code 'CD','EX','GS','RG'
C      FPARM(MAXPRM)  FPARM         Initial guesses to parameters.
C                                   Parameters to be fitted
C                                   1: central X pixel position (RA)
C                                   2: central Y pixel position (DEC)
C                                   3: position angle of receding
C                                      major axis (degrees)
C                                   4: inclination angle (degrees)
C                                   5: systemic velocity (km/s)
C                                        (should be positive)
C                                   6: Vmax - max rotation velocity
C                                      (km/s)-OR-scale factor for RC
C                                      (for RC, 0=>1)
C                                   7: Rmax - R at which Vmax occurs
C                                             (arcsec) 0 => dparm(2)
C                                   8: m - Brandt index 0 => 1
C                                   9: max density (/cm**3)
C                                   10: radial density scale length
C                                       (arcsec)
C                                   11: perp EX density scale length
C                                       (") 0 => DPARM(7) if
C                                       cparm(4)=1,2
C                                   12: radial density scale length
C                                       for r<r0 (DCODE=RG only)
C                                   13. perp GS dens scale length
C                                      (") 0 => DPARM(7) if
C                                       cparm(4)=3
C                                   14. nf1 - fractional EX perp
C                                       dens (0=>1 if cparm(4)=1,2)
C                                   15. nf2 - fractional GS perp
C                                       dens (0=>1 if cparm(4)=3)
C
C      CPARM(10)      CPARM         1: 0 => write residuals
C                                      1 => write model
C                                   2: Distance to galaxy (Mpc)
C                                   3: Parameters to be held fixed
C                                      (Sum of 2**i), where i is
C                                      the parameter number. eg.
C                                      Parameters 1,2,5 fixed =>
C                                      CPARM(3)=2**1+2**2+2**5=37
C                                   4: Perpendicular density dist'n
C                                      number (1,2,3,4) 0=>1
C                                   5: Positon of ring center for RG
C                                   6: FWHM of gaussian for velocity
C                                      smoothing (km/s)
C                                   7: In case of RG, 2==> Exp
C                                      3==> Gauss and 0==> Gauss
C      DPARM(10)      DPARM         1: minimum limit to radius (arcsec)
C                                   2: maximum limit to radius  "
C                                      must be < or = R(disk).
C                                   3: min limit to cos(psi) (measured
C                                      from receding major axis)
C                                   4: max limit to cos(psi)
C                                   5: min limit to sin(psi)
C                                   6: max limit to sin(psi)
C                                      all 0 => all quadrants
C                                   7: height cutoff (arcsec)
C                                      specify!
C      VPARM(30)      VPARM         User specified rotation curve(km/s)
C                                   Use if VCODE='RC'
C      RPARM(30)      RPARM         Radii corresponding to specified
C                                   rotation curve (arcsec)
C      ICUT           XCUT          Cutoff (Jy/beam) for ignoring
C                                   input data
C      PIXSTD         ERRV          Estimated rms uncertainty at each
C                                   pixel. (Jy/ba) 0 => .001
C
C   Programmer J. A. Irwin - for CUBIT
C              E. W. Greisen - overhaul to modern practises (2007)
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   N, IRET, IT
      LONGINT   LPDATA, LPBLNK, LPARRA, IPARRA
      REAL      DATA(2), RBLANK(2), RARRAY(4)
      INTEGER   JBLANK(2), NWRDAT, NWRDAR, IERR
      DOUBLE PRECISION DARRAY(2)
      EQUIVALENCE (JBLANK, RBLANK), (DARRAY, RARRAY)
      INCLUDE 'CUBIT.INC'
      INCLUDE 'CUBPRM.INC'
      INCLUDE 'CUBDIM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /LEAST/ IT
      DATA PRGM /'CUBIT '/
C-----------------------------------------------------------------------
C                                       get inputs, create output
      IT = 0
      CALL CUBITI (PRGM, N, IRET)
C                                       get memory as needed
      IF (IRET.EQ.0) THEN
         NWRDAT = (NVOUT * NXOUT * NYOUT + 10) / 1024 + 1
         NWRDAR = (2 * 3 * NXOUT * NYOUT + 10) / 1024 + 1
         CALL ZMEMRY ('GET ', PRGM, NWRDAT, DATA, LPDATA, IRET)
         IF (IRET.EQ.0) CALL ZMEMRY ('GET ', PRGM, NWRDAT, RBLANK,
     *      LPBLNK, IRET)
         IF (IRET.EQ.0) CALL ZMEMRY ('GET ', PRGM, NWRDAR, RARRAY,
     *      IPARRA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, NWRDAT, NWRDAR
            CALL MSGWRT (8)
         ELSE
            IF (IPARRA.GE.0) THEN
               LPARRA = 1 + (IPARRA+1)/2
            ELSE
               LPARRA = 1 + IPARRA / 2
               END IF
            END IF
         END IF
C                                       Call routine that reads input
C                                       file, sends data to the least
C                                       squares subroutine and writes
C                                       output file
      IF (IRET.EQ.0) THEN
         CALL CUBITM (N, DATA(1+LPDATA), JBLANK(1+LPBLNK), NXOUT, NYOUT,
     *      DARRAY(LPARRA), IRET)
         CALL ZMEMRY ('FREE', PRGM, NWRDAT, DATA, LPDATA, IERR)
         CALL ZMEMRY ('FREE', PRGM, NWRDAT, RBLANK, LPBLNK, IERR)
         CALL ZMEMRY ('FREE', PRGM, NWRDAR, RARRAY, IPARRA, IERR)
C                                       history update subprogram
         IF (IRET.EQ.0) CALL CUBITH (IRET)
         END IF
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' GETTING',2I9,' KILOWORDS OF MEMORY')
      END
      SUBROUTINE CUBITI (PRGN, N, IRET)
C-----------------------------------------------------------------------
C   CUBITI gets input parameters for CUBIT, creates an output file,
C   and sets some of the default parameters.
C   Input:
C      PRGN   C*6   Program name
C   Output:
C      N      I     Number of free parameters for later fit.
C      IRET   I     Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C   Subprograms called:
C      AIPS sublibraries....ZDCHIN, VHDRIN, GTPARM, MSGWRT, RELPOP,
C                           CATDIR, CATIO, COPY, MAKOUT, CHR2H, H2CHR,
C                           WINDOW, MCREAT
C      CUBIT subroutine.....NEWHED
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   N, IRET
C
      CHARACTER STAT*4, MTYPE*2, CODESV(4)*4, CODESD(4)*4
      INTEGER   I, L, NFIX, IERR, NPARM, IROUND
      DOUBLE PRECISION SFREQ, CMASEC, JY2DEG
      INCLUDE 'CUBIT.INC'
      INCLUDE 'CUBSIZ.INC'
      INCLUDE 'CUBPRM.INC'
      INCLUDE 'CUBDIM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA CODESV /'CV  ', 'SB  ', 'BR  ', 'RC  '/
      DATA CODESD /'CD  ', 'EX  ', 'GS  ', 'RG  '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * 16384
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 143
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.EQ.0) GO TO 10
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
C                                       Restart AIPS
 10   IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOT, CLAOUT)
      CALL H2CHR (4, 1, XVCODE, VCODE)
      CALL H2CHR (4, 1, XDCODE, DCODE)
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO = IROUND (XDISKO)
C                                       Rename and check limits,
C                                       Set defaults.
C                                       (Dparm 1,2 will be checked
C                                       after new cat header is
C                                       generated)
      IF (FPARM(8).EQ.0.0) FPARM(8) = 1.0
      COSMIN = DPARM(3)
      COSMAX = DPARM(4)
      SINMIN = DPARM(5)
      SINMAX = DPARM(6)
      IF ((COSMIN.EQ.0.0) .AND. (COSMAX.EQ.0.0) .AND. (SINMIN.EQ.0.0)
     *   .AND. (SINMAX.EQ.0.0)) THEN
          COSMAX = 1.0
          COSMIN = -1.0
          SINMAX = 1.0
          SINMIN = -1.0
          END IF
      IF (DPARM(7).EQ.0.0) THEN
         MSGTXT = 'MUST SPECIFY DPARM(7)'
         IRET = -1
         GO TO 990
         END IF
C                                       Set some defaults
C                                       Make constant dens the default
      IF ((CPARM(4).NE.2.0) .AND. (CPARM(4).NE.3.0) .AND.
     *   (CPARM(4).NE.4.0)) CPARM(4) = 1.0
      IF ((DCODE.NE.CODESD(2)) .AND. (DCODE.NE.CODESD(3)) .AND.
     *   (DCODE.NE.CODESD(4))) DCODE = CODESD(1)
      IF (FPARM(11).EQ.0.0) FPARM(11) = DPARM(7)
      IF (FPARM(13).EQ.0.0) FPARM(13) = DPARM(7)
      IF (CPARM(4).EQ.4.0) THEN
         IF (FPARM(14).EQ.0.0) FPARM(14)=0.5
         IF (FPARM(15).EQ.0.0) FPARM(15)=0.5
         IF (ABS(FPARM(14)+FPARM(15)-1.0).GE.1E-6) THEN
            MSGTXT = '*WARNING* FPARM(14)+FPARM(15).NE.1.0'
            CALL MSGWRT (8)
            END IF
         END IF
      IF ((FPARM(14).EQ.0.0) .OR. (FPARM(14).GT.1.0)) FPARM(14) = 1.0
      IF ((FPARM(15).EQ.0.0) .OR. (FPARM(15).GT.1.0)) FPARM(15) = 1.0
      IF (DPARM(7).LT.FPARM(11)) THEN
         MSGTXT = '*WARNING* MAX 1/2 DISK THICKNESS IS < FPARM(11)'
         CALL MSGWRT (8)
         END IF
      IF (TOL.EQ.0.0)  TOL  = 0.001
      IF (ERRV.EQ.0.0) ERRV = 0.001
C                                       Check if there's a flux cutoff
       IF (XCUT.NE.0.0) THEN
         XCUT = ABS (XCUT)
         WRITE (MSGTXT,1411) XCUT
         CALL MSGWRT (8)
         MSGTXT = ' but included in output cube'
         CALL MSGWRT (8)
         END IF
C                                       Determine which parameters
C                                       are to be held fixed. If
C                                       FIX(L)=1, then parameter L
C                                       is fixed.  If FIX(L)=0, the
C                                       parameter is allowed to vary
C                                       N is the number of free parms
      NFIX = CPARM(3) + .01
      N = MAXPRM
      DO 20 I = 1,N
         FIX(I) = 0
 20      CONTINUE
      DO 25 I = 1,N
         L = MAXPRM - I + 1
         IF (NFIX.GE.2**L) THEN
            FIX(L) = 1
            N = N - 1
            NFIX = NFIX - 2**L
            END IF
 25      CONTINUE
C                                      Check that Cparm(3) was okay
      IF (NFIX.NE.0) THEN
         MSGTXT = 'ILLEGAL VALUE OF CPARM(3)'
         IRET = -1
         GO TO 990
         END IF
C                                    If one of fparm 14,15 are fixed
C                                    then the other must also be fixed
      IF ((CPARM(4).EQ.4.0) .AND. (FIX(14).NE.FIX(15)) .AND.
     *   ((FIX(14).EQ.1) .OR. (FIX(15).EQ.1))) THEN
         FIX(14) = 1
         FIX(15) = 1
         N = N - 1
         END IF
C                                      If vcode is RC ensure that
C                                      FPARM7 and FPARM8 are fixed
      IF (VCODE.EQ.CODESV(4)) THEN
C                                      Factor = 1 by default
         IF (FPARM(6).EQ.0.0) FPARM(6) = 1.0
         IF (FIX(7).EQ.0) THEN
            FIX(7) = 1
            N = N - 1
            I = 7
            WRITE (MSGTXT,1190) I
            CALL MSGWRT (3)
            END IF
         IF (FIX(8).EQ.0) THEN
            FIX(8) = 1
            N = N - 1
            I = 8
            WRITE (MSGTXT,1190) I
            CALL MSGWRT (3)
            END IF
         END IF
C                                      Fix FPARM(10) if
C                                      RADIAL density is constant
      IF ((DCODE.EQ.CODESD(1)) .AND. (FIX(10).EQ.0)) THEN
         FIX(10) = 1
         N = N - 1
         I = 10
         WRITE (MSGTXT,1190) I
         CALL MSGWRT (3)
         END IF
C                                      Fix FPARM(11,13,14,15) if
C                                      VERT density is constant
      IF (CPARM(4).LT.4) THEN
         DO 30 I = 11,15
            IF (FIX(I).EQ.0) THEN
               IF (((CPARM(4).EQ.1) .AND. (I.GE.11)) .OR.
     *            ((CPARM(4).EQ.2) .AND. (I.GE.13)) .OR.
     *            ((CPARM(4).EQ.3) .AND. ((I.EQ.11) .OR. (I.GE.14))))
     *            THEN
                  FIX(I) = 1
                  N = N - 1
                  WRITE (MSGTXT,1190) I
                  CALL MSGWRT (3)
                  END IF
               END IF
 30         CONTINUE
         END IF
C                                      Fix FPARM(12) if dcode.ne.rg
      IF ((DCODE.NE.CODESD(4)) .AND. (FIX(12).EQ.0)) THEN
         FIX(12) = 1
         N = N - 1
         I = 12
         WRITE (MSGTXT,1190) I
         CALL MSGWRT (3)
         END IF
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE='MA'
C
      CALL CATDIR  ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,MTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, 'READ', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Copy old CATBLK to new.
      CALL COPY (256, CATOLD, CATBLK)
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN,'      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATOLD(KIDIM), CATOLD(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Set up some defaults for
C                                       ring distribution
      IF (DCODE.EQ.CODESD(4)) THEN
         IF (FPARM(12).EQ.0.0) FPARM(12) = FPARM(10)
         IF (CPARM(7).EQ.0.0) CPARM(7) = 3.0
         END IF
C
C                                        Check dparm 1,2 now
      DSKMIN = DPARM(1)
      DSKMAX = DPARM(2)
      IF (DPARM(2).EQ.0.0) DSKMAX = ABS (1024.0*CATR(KRCIC+1)*3600.0)
      IF ((DSKMAX.LE.DSKMIN) .OR. (DSKMIN.LT.0.0)) THEN
         IRET = 4
         MSGTXT = 'ILLEGAL VALUES OF DPARM(1) AND/OR DPARM(2)'
         GO TO 990
         END IF
      IF (FPARM(7).EQ.0.0) FPARM(7) = DSKMAX
      IF (DSKMAX.LT.FPARM(7)) THEN
         MSGTXT = '*WARNING* MAX DISK RADIUS IS < FPARM(7)'
         CALL MSGWRT (6)
         END IF
C                                      Check Rparms, Vparms
      IF (VCODE.EQ.CODESV(4)) THEN
         DO 40 I = 1,29
            IF ((RPARM(I).GE.RPARM(I+1)) .AND. (RPARM(I).LT.DSKMAX))
     *         THEN
               IRET = 4
               MSGTXT = 'RPARM MUST INCREASE OUT TO DPARM(2)'
               GO TO 990
               END IF
            IF ((VPARM(I).EQ.0.0) .AND. (RPARM(I).GT.0.0)) IRET = 100
            IF ((RPARM(I+1).EQ.0.0) .AND. (I.GT.1)) GO TO 50
 40         CONTINUE
 50      IF (IRET.EQ.100) THEN
            MSGTXT = '*WARNING* YOU MAY HAVE OMITTED SOME VPARMS'
            CALL MSGWRT (8)
            IRET = 0
            END IF
         END IF
C
      IRET = 4
      WRITE (MSGTXT,1105) (DPARM(I), I = 1,5)
      CALL MSGWRT (5)
      WRITE (MSGTXT,1106) (DPARM(I), I = 6,7)
      CALL MSGWRT (5)
      WRITE (MSGTXT,1100) (CPARM(I), I = 1,5)
      CALL MSGWRT (5)
      WRITE(MSGTXT,1101) (CPARM(I), I = 6,7)
      CALL MSGWRT (5)
C                                       Get user modification to CATBLK
      CALL NEWHED (IRET)
      IF (IRET.NE.0) GO TO 999
      MSGTXT = 'Initial FPARM:'
      CALL MSGWRT (5)
      FSTRNG(1) = 'X center pixel'
      FSTRNG(2) = 'Y center pixel'
      FSTRNG(3) = 'Position angle'
      FSTRNG(4) = 'Inclination'
      FSTRNG(5) = 'System velocity'
      FSTRNG(6) = 'Max rotation velocity'
      FSTRNG(7) = 'Radius of Vmax "'
      FSTRNG(8) = 'Brandt index'
      FSTRNG(9) = 'Max density'
      FSTRNG(10) = 'Radial dens scale lng " '
      FSTRNG(11) = 'Perp EX dens scale lng "'
      FSTRNG(12) = 'RG inner scale length " '
      FSTRNG(13) = 'Perp GS dens scale lng "'
      FSTRNG(14) = 'nf1 EX fraction density '
      FSTRNG(15) = 'nf2 GS fraction density '
      DO 60 I = 1,MAXPRM
         WRITE (MSGTXT,1090) I, FSTRNG(I), FPARM(I)
         CALL MSGWRT (5)
 60      CONTINUE
      WRITE (MSGTXT,1070) (BLC(I), I = 1,7)
      CALL MSGWRT (5)
      WRITE (MSGTXT,1080) (TRC(I), I = 1,7)
      CALL MSGWRT (5)
      WRITE (MSGTXT,1110) DSKMAX, DSKMIN
      CALL MSGWRT (5)
      WRITE (MSGTXT,1050) TOL
      CALL MSGWRT (5)
      WRITE (MSGTXT,1060) VCODE
      CALL MSGWRT (5)
      WRITE (MSGTXT,1290) DCODE
      CALL MSGWRT (5)
      IF (DCODE.EQ.CODESD(4)) THEN
         IF (CPARM(7).GT.2.8) THEN
            MSGTXT = '     ring is Gaussian'
            CPARM(7) = 3.0
         ELSE
            MSGTXT = '     ring is exponential'
            CPARM(7) = 2.0
            END IF
         CALL MSGWRT (5)
         END IF
      IF (CPARM(4).GE.4.0) THEN
         WRITE (MSGTXT,1305) CODESD(2), CODESD(3)
         CALL MSGWRT (5)
      ELSE
         WRITE (MSGTXT,1300) CODESD(IFIX(CPARM(4)))
         CALL MSGWRT (5)
         END IF
      WRITE (MSGTXT,1220) (MAXPRM-N)
      CALL MSGWRT (5)
      IF (VCODE.EQ.CODESV(4)) THEN
         MSGTXT = 'Rotation curve specified by VPARM, RPARM'
         CALL MSGWRT (5)
         END IF
C                                       Calculate the constant for
C                                       converting from n(cm**-3),
C                                       dz(arcsec), dV(km/s), to I
C                                       [ Jy/(pixel area)]
      IF (CPARM(2).EQ.0.0) THEN
         IRET = -1
         WRITE (MSGTXT,1250) CPARM(2)
         GO TO 990
         END IF
      CMASEC = CPARM(2) * 1.4959459E19
      SFREQ     = 1420.40575E6 - ((CATD(KDCRV)/2.997924562E8)
     *           *1420.40575E6)
      JY2DEG = (CATR(KRBMJ)*3600.0*CATR(KRBMN)*3600.0*SFREQ**2)
     *           /1.22214E24
      CONST    = CMASEC * JY2DEG / 1.823E18
      WRITE (MSGTXT,1120) CONST
      CALL MSGWRT (5)
C                                       Determine the velocity in-
C                                       crement in km/s from the
C                                       catalog header
      DELVEL = ABS (CATR(KRCIC)) / 1000.0
      WRITE (MSGTXT,1230) DELVEL
      CALL MSGWRT (5)
C                                       Check to see if velocity
C                                       smoothing is required
C                                       and convert to pixels to
C                                       access VSMTH
      IF (CPARM(6).GT.0.0) THEN
         WIDTH = CPARM(6) / DELVEL
         IF ((WIDTH.LT.0.1) .OR. (WIDTH.LE.((TRC(1)-BLC(1)+1.0)/3.0)))
     *      THEN
            MSGTXT = 'Vel FWHM must be > 0.1 or < [row_out/3] channels'
            CALL MSGWRT (5)
            CPARM(6) = 0.0
            MSGTXT = '*WARNING* VELOCITY SMOOTHING IGNORED*'
            CALL MSGWRT (6)
         ELSE
            WRITE (MSGTXT,1237) WIDTH
            CALL MSGWRT (5)
C                                       Print a warning if FWHM is
C                                       less than the channel width
            IF (WIDTH.LT.1.0) THEN
               MSGTXT = '*WARNING* Vel smoothing is < one channel'
               CALL MSGWRT (6)
               END IF
            END IF
         END IF
C                                       Ensure that size of each
C                                       RA-DEC plane is less than
C                                       maximum allowed.
C     IF ((CATBLK(KINAX+1).GT.MAXXPT) .OR. (CATBLK(KINAX+2).GT.MAXYPT))
C    *   THEN
C        WRITE (MSGTXT,1010) MAXXPT, MAXYPT
C        GO TO 990
C        END IF
C                                       Create output file.
      NEWCNO = 1
      IRET = 4
      CALL MCREAT (DISKO, NEWCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
C                                       Lengths of output array
      NXOUT = CATBLK(KINAX+1)
      NYOUT = CATBLK(KINAX+2)
      NVOUT = CATBLK(KINAX)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CUBITI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1020 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1030 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1040 FORMAT ('CUBITI: ERROR',I3,' CREATING OUTPUT FILE')
 1050 FORMAT ('Convergence criterion = ', E10.3)
 1060 FORMAT ('Form of rotation curve is ',A4)
 1070 FORMAT ('BLC = ',7(F5.1,2X))
 1080 FORMAT ('TRC = ',7(F5.1,2X))
 1090 FORMAT ('(',I2,')  ',A,F10.4)
 1100 FORMAT ('Initial CPARM: ',5(F9.3,1X))
 1101 FORMAT ('               ',2(F9.3,1X))
 1105 FORMAT ('Initial DPARM: ',5(F9.3,1X))
 1106 FORMAT ('               ',2(F9.3,1X))
 1110 FORMAT ('DSKMAX = ',F10.2,3X,'DSKMIN = ',F9.2,3X,'arcsec')
 1120 FORMAT ('[cm**-3 arcsec]/[km/s] X',1PE12.4,' = Jy/beam')
 1190 FORMAT ('FPARM(',I2,') is fixed and not used')
 1220 FORMAT (I3,' parameters are fixed')
 1230 FORMAT ('Incremental velocity is ',F8.4,1X,'km/s')
 1237 FORMAT ('FWHM of vel smoothing Gaussian = ',F8.3,' channels')
 1250 FORMAT ('Is the galaxy really',1X,F3.1,1X,'Mpc away??')
 1290 FORMAT ('Radial density distribution is ',1X,A4)
 1300 FORMAT ('Perpendicular density distribution is ',1X,A4)
 1305 FORMAT ('Perpendicular density distribution is ',1X,A4,'+',2X,A4)
 1411 FORMAT ('Ignoring all ABS(DATA) <  ', F8.4, 2X, 'Jy/beam in fit')
      END
      SUBROUTINE CUBITM (N, DATA, JBLANK, MX, MY, DARRAY, IRET)
C-----------------------------------------------------------------------
C   CUBITM reads a cube into an array, DATA, calls the subroutine
C   LSTSQ1 (which has been modified from LMSTR1) to do a least squares
C   fit to the data using input parameters and then writes either the
C   residuals or the model (RESULT(J)) into a new cube.
C   Input :
C      N        I      Number of free parameters
C      MX       I      X output dimension
C      MY       I      Y output dimension
C   Output:
C      DATA     R(*)   Input data
C      JBLANK   I(*)   # blanked points before pixel of interest
C      DARRAY   D(*)   Work array (MX,MY,3)
C      IRET     I      Return code, 0 => OK, otherwise abort.
C   Subprograms called:
C      AIPS sublibraries...ZPHFIL, ZOPEN, COMOF3, MINI3, MDISK,
C                          MSGWRT, ZCLOSE, CATIO
C                          QRFAC, COVAR
C      CUBIT subroutine....FCN,.LSTSQ1
C-----------------------------------------------------------------------
      INTEGER   N, JBLANK(*), MX, MY, IRET
      REAL      DATA(*)
      DOUBLE PRECISION DARRAY (MX,MY,3)
C
      INCLUDE 'CUBSIZ.INC'
      CHARACTER IFILE*48
      INTEGER   J, JM, M, MTOT, JBL, IFLAG, K, NICT, NICTP, IROUND,
     *   LUNI, LUNO, NYI, NXI, WINI(4),NXO, NYO, WINO(4), BOI,
     *   BOO, LIM2, LIM3, LIM4, LIM5, LIM6,LIM7, I1, I2, I3, I4, I5, I6,
     *   I7, IPOS(7), CORN(7), BOTEMP,LIMO, LIMIT, IBIND, OBIND, INDI,
     *   INDO, LIM1, I, L, IT, IM1,OUTCNT, INFO, IPVT(MAXPRM),
     *   IPVT2(MAXPRM), NWRDRE
      REAL      OUTMAX, OUTMIN, XBUFF1(16384), XBUFF2(16384),
     *   RAD, ERROR(MAXPRM), PI, ZSUM, ERF, ZE, ZG, RRSULT(4)
      DOUBLE PRECISION X(MAXPRM), DERP(MAXPRM), DERM(MAXPRM),
     *   FJAC(MAXPRM,MAXPRM), WA1(MAXPRM), WA2(MAXPRM), WA3(MAXPRM),
     *   RESULT(2), STOL
      LONGINT   LPRESU, IPRESU, LP
      LOGICAL   T, F, BLNKD
      INCLUDE 'CUBIT.INC'
      INCLUDE 'CUBPRM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /LEAST/ IT
      COMMON /JLEAST/ JBL, NICT, NICTP, MTOT
      EQUIVALENCE  (BUFF1, XBUFF1), (BUFF2, XBUFF2), (RESULT, RRSULT)
      DATA LUNI, LUNO /16,17/
      DATA ERROR /MAXPRM*0.0/
      DATA T, F /.TRUE.,.FALSE./
      DATA PI /3.1415926536/
C-----------------------------------------------------------------------
C     SECTION A -- READ INPUT CUBE INTO ARRAY, DATA.
C
C                                       Open and init for read
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.GT.1) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Setup for I/O
      NXI = CATOLD(KINAX)
      NYI = CATOLD(KINAX+1)
      NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      OUTMAX = -1.0E20
      OUTMIN = 1.0E20
      BLNKD = .FALSE.
      RAD   = 180.0 / PI
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
      CORN(7) = 1
      LIMO = CATBLK(KINAX) - 1
C                                      Initialize counters
C                                      M, J, # unblanked pts.
C                                      MTOT, JM, total # pts.
      M    = 0
      MTOT = 0
      J    = 0
      JM   = 0
C                                       Loop
      DO 700 I7 = 1,LIM7
         CORN(7) = I7
         IPOS(7) = BLC(7) + I7 - 0.9
         DO 600 I6 = 1,LIM6
            CORN(6) = I6
            IPOS(6) = BLC(6) + I6 - 0.9
            DO 500 I5 = 1,LIM5
               CORN(5) = I5
               IPOS(5) = BLC(5) + I5 - 0.9
               DO 400 I4 = 1,LIM4
                  CORN(4) = I4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  DO 300 I3 = 1,LIM3
                     CORN(3) = I3
                     IPOS(3) = BLC(3) + I3 - 0.9
C                                       Init. files, first input.
                     CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IPOS(3),
     *                  BOTEMP, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1099) IRET
                        GO TO 990
                        END IF
                     BOI = BOTEMP + 1
                     CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI,
     *                  BUFF1, JBUFSZ, BOI, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1100) 'READ', IRET
                        GO TO 990
                        END IF
                     OUTCNT = NYO
C                                       Start to loop over the plane
                     DO 220 I2 = 1,LIM2
                        CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND,
     *                     IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1120) 'READ', IRET
                           GO TO 990
                           END IF
                        DO 165 I1 = 1,LIM1
                           JM = JM + 1
C                          IF (JM.GT.MAXTOT) THEN
C                             IRET = -1
C                             WRITE (MSGTXT,1300) MAXTOT
C                             GO TO 990
C                             END IF
                           DATA(JM) = XBUFF1(IBIND+I1-1)
                           IF (DATA(JM).NE.FBLANK) J = J + 1
 165                       CONTINUE
                        OUTCNT = OUTCNT - 1
                        IF (OUTCNT.LT.0) THEN
                           MSGTXT = 'CUBITM: OUTCNT.LT.0! TOO MANY'
     *                        // ' OUTPUT ROWS RETURNED'
                           GO TO 990
                           END IF
 220                    CONTINUE
                     IF (OUTCNT.GT.0) THEN
                        MSGTXT = 'CUBITM: NOT ENOUGH ROWS RETURNED'
                        GO TO 990
                        END IF
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
      MSGTXT = 'Input cube read'
      CALL MSGWRT (5)
C                                       Close input map.
      CALL ZCLOSE (LUNI, INDI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1180) IRET
         GO TO 990
         END IF
      M    = J
      MTOT = JM
C                                       Write total # pts and
C                                       # unblanked pts.
      WRITE (MSGTXT,1280) MTOT, M
      CALL MSGWRT (5)
C                                       get memory for RESULT
      NWRDRE = (2 * M + 10) / 1024 + 1
      CALL ZMEMRY ('GET ', 'CUBITM', NWRDRE, RRSULT, IPRESU, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1700) IRET, NWRDRE
         GO TO 990
         END IF
      IF (IPRESU.GE.0) THEN
         LPRESU = 1 + (IPRESU+1)/2
      ELSE
         LPRESU = 1 + IPRESU / 2
         END IF
C-----------------------------------------------------------------------
C
C     SECTION B - DO LEAST SQUARES FIT
C
      IF (N.GT.0) THEN
C                                       Initialize X's
         DO 720 L = 1,N
            X(L) = 0.0D0
 720        CONTINUE
C
C                                       Put FPARM's to be fitted
C                                       into X(I).  Index I: parms
C                                       to be fitted.  Index L:
C                                       total # parameters.
         L = 0
         DO 730 I = 1,N
 725        L = L + 1
            IF (FIX(L).EQ.1) THEN
               WRITE (MSGTXT,1390) L, FSTRNG(L), FPARM(L)
               CALL MSGWRT (5)
               GO TO 725
            ELSE
               X(I) = FPARM(L)
               PSTRNG(I) = FSTRNG(L)
               FPNUM(I) = L
               END IF
 730        CONTINUE
         DO 735 I = L+1,MAXPRM
            WRITE (MSGTXT,1390) I, FSTRNG(I), FPARM(I)
            CALL MSGWRT (5)
 735        CONTINUE
C                                       let someone else do the work
         IFLAG = 0
         STOL = TOL * 1.0D0
         CALL LSTSQ1 (M, N, X, RESULT(LPRESU), FJAC, MAXPRM, STOL, INFO,
     *      IPVT, DATA, JBLANK, MX, MY, DARRAY)
         IF (INFO.EQ.-100) THEN
            MSGTXT = 'LSTSQ1 (FCN) ERROR'
            GO TO 990
            END IF
         MSGTXT = 'Least squares fit completed'
         CALL MSGWRT (5)
C                                       Put final fitted X(I)'s back
C                                       into FPARM's
         L = 0
         DO 750 I = 1,N
 740        L = L + 1
            IF (FIX(L).EQ.1) GO TO 740
            FPARM(L) = X(I)
 750        CONTINUE
         END IF
C                                        Final call to FCN with
C                                        FLAG=-1 computes model
C                                        or residuals.
      NICT = 0
      NICTP = 0
      IFLAG = -1
      K = N
      IF (N.EQ.0) K = MAXPRM
      CALL FCN (M, K, X, RESULT(LPRESU), DERP, DERM, IFLAG, DATA,
     *   JBLANK, MX, MY, DARRAY)
      IF (IFLAG.EQ.-100) THEN
         MSGTXT = 'FINAL CALL FCN ERROR'
         GO TO 990
         END IF
C                                       Print out no. of problem
C                                       iterations for RC case
      IF (NICT.NE.0) THEN
         WRITE (MSGTXT,1460) NICT
         CALL MSGWRT (8)
         END IF
      IF (NICTP.NE.0) THEN
         WRITE (MSGTXT,1470) NICTP
         CALL MSGWRT (8)
         END IF
C                                       Don't print out solutions
C                                       if no fit is being done
C                                       Print out the solution
      IF (N.NE.0) THEN
         WRITE (MSGTXT,1400) INFO
         CALL MSGWRT (5)
C-----------------------------------------------------------------------
C
C     SECTION C - ERROR ANALYSIS
C
C
C                                        Computation covariance
C                                        matrix, prepare calling of
C                                        COVAR, zero lower triangle
C                                        of FJAC
         DO 760 I = 2,N
            IM1 = I - 1
            DO 755 L = 1,IM1
               FJAC(I,L) = 0.0
 755           CONTINUE
 760        CONTINUE
         CALL QRFAC (N, N, FJAC, MAXPRM, T, IPVT2, N, WA1, WA2, WA3)
         DO 765 I = 1,N
            FJAC(I,I) = WA1(I)
            L = IPVT2(I)
            IPVT2(I) = IPVT(L)
 765        CONTINUE
         STOL = 1.0D-6
         CALL COVAR (N, FJAC, MAXPRM, IPVT2, STOL, WA1)
         DO 770 I = 1,N
            FJAC(I,I) = ERRV * SQRT(FJAC(I,I))
 770        CONTINUE
C                                        Associate correct error values
C                                        with FPARMs
         L = 0
         DO 780 I = 1,N
 775        L = L + 1
            ERROR(L) = 0.0
            IF (FIX(L).EQ.1) GO TO 775
            ERROR(L) = FJAC(I,I)
 780        CONTINUE
C                                        Print out values w errors
         WRITE (MSGTXT,1410) IT
         CALL MSGWRT (5)
         DO 790 I = 1,MAXPRM
            WRITE (MSGTXT,1440) I, FSTRNG(I), FPARM(I), ERROR(I)
            IF (FIX(I).EQ.1) MSGTXT(43:51) = '   fixed '
            CALL MSGWRT (5)
 790        CONTINUE
         END IF
      ZSUM = PI * 0.3086 * CPARM(2) * FPARM(9) / 1.8 / 3.6
      IF (CPARM(4).EQ.1.0) THEN
         ZSUM = ZSUM * 2.0 * DPARM(7)
      ELSE
         ZE = 2.0 * FPARM(11) * FPARM(14) *
     *      (1.0 - EXP (-DPARM(7)/FPARM(11)))
         ZG = SQRT (PI) * FPARM(13) * FPARM(15) *
     *      ERF (DPARM(7)/FPARM(13))
         IF (CPARM(4).EQ.2.0) THEN
            ZSUM = ZSUM * ZE
         ELSE IF (CPARM(4).EQ.3.0) THEN
            ZSUM = ZSUM * ZG
         ELSE IF (CPARM(4).EQ.4.0) THEN
            ZSUM = ZSUM * (ZE + ZG)
            END IF
         END IF
      WRITE (MSGTXT,1790) ZSUM
      CALL MSGWRT (5)
      IF (DCODE.EQ.'CD') THEN
         MSGTXT = 'times  1.0      independent of radius'
      ELSE IF (DCODE.EQ.'EX') THEN
         WRITE (MSGTXT,1791) FPARM(10)
      ELSE IF (DCODE.EQ.'GS') THEN
         WRITE (MSGTXT,1792) FPARM(10)
      ELSE IF ((DCODE.EQ.'RG') .AND. (CPARM(7).EQ.2.0)) THEN
         WRITE (MSGTXT,1793) CPARM(5), FPARM(12), '< ', CPARM(5)
         CALL MSGWRT (5)
         WRITE (MSGTXT,1794) CPARM(5), FPARM(10), '>=', CPARM(5)
         CALL MSGWRT (5)
         MSGTXT = '    where R=radius in asec'
      ELSE IF ((DCODE.EQ.'RG') .AND. (CPARM(7).EQ.3.0)) THEN
         WRITE (MSGTXT,1795) CPARM(5), FPARM(12), '< ', CPARM(5)
         CALL MSGWRT (5)
         WRITE (MSGTXT,1795) CPARM(5), FPARM(10), '>=', CPARM(5)
         CALL MSGWRT (5)
         MSGTXT = '    where R=radius in asec'
         END IF
      CALL MSGWRT (5)
      MSGTXT = 'If you use the results of this task in a paper, please'
     *   // ' reference'
      CALL MSGWRT (5)
      MSGTXT = 'Irwin, J. A. 1994, ApJ, 429, 618'
      CALL MSGWRT (5)
C-----------------------------------------------------------------------
C
C     SECTION D - WRITE RESULT INTO OUTPUT CUBE
C
C                                        Open and init output file
C                                        for write
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Initialize counters
      J  = 0
      JM = 0
      JBL= 0
C                                       Loop
      DO 870 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         CORN(7) = I7
         DO 860 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            CORN(6) = I6
            DO 850 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               CORN(5) = I5
               DO 840 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  CORN(4) = I4
                  DO 830 I3 = 1,LIM3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     CORN(3) = I3
C                                       Initialize output file
                     CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORN(3),
     *                  BOTEMP, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1099) IRET
                        GO TO 990
                        END IF
                     BOO = BOTEMP + 1
                     CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO,
     *                  BUFF2, JBUFSZ, BOO, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1100) 'WRIT', IRET
                        GO TO 990
                        END IF
C                                       Loop over the plane
                     DO 820 I2 = 1,LIM2
                        IPOS(2) = BLC(2) + I2 - 0.9
                        IPOS(1) = IROUND(BLC(1))
C
                        CALL MDISK ('WRIT', LUNO, INDO, XBUFF2, OBIND,
     *                     IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1120) 'WRIT', IRET
                           GO TO 990
                           END IF
                        DO 810 I1 = 1,LIM1
                           JM = JBL + J + 1
                           IF (DATA(JM).NE.FBLANK) THEN
                              J = J + 1
                              LP = J - 1 + LPRESU
                              XBUFF2(OBIND+I1-1) = RESULT(LP)
                           ELSE
                              XBUFF2(OBIND+I1-1) = FBLANK
                              JBL = JBL + 1
                              END IF
 810                       CONTINUE
C                                       Check max, min, blanking.
                        LIMIT = OBIND + LIMO
                        DO 815 I1 = OBIND,LIMIT
                           IF (XBUFF2(I1).EQ.FBLANK) THEN
                              BLNKD = .TRUE.
                           ELSE
                              OUTMAX = MAX (OUTMAX, XBUFF2(I1))
                              OUTMIN = MIN (OUTMIN, XBUFF2(I1))
                              END IF
 815                       CONTINUE
 820                    CONTINUE
C                                       Flush buffer.
                     CALL MDISK ('FINI', LUNO, INDO, XBUFF2, OBIND,
     *                  IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1120) 'FINI', IRET
                        GO TO 990
                        END IF
 830                 CONTINUE
 840              CONTINUE
 850           CONTINUE
 860        CONTINUE
 870     CONTINUE
      MSGTXT = 'Output cube written'
      CALL MSGWRT (5)
C                                      Write total # output pts and #
C                                      unblanked output pts
      WRITE (MSGTXT,1290) JM, J
      CALL MSGWRT (5)
C                                      Update CATBLK
      CATR(KRDMX) = OUTMAX
      CATR(KRDMN) = OUTMIN
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', DATA, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1260) IRET
         GO TO 990
         END IF
C                                       Mark blanking in CATBLK
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
C                                       Close output map
      CALL ZCLOSE (LUNO, INDO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1180)IRET
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
      IRET = -1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CUBITM: ERROR',I3,' OPENING INPUT FILE')
 1020 FORMAT ('CUBITM: ERROR',I5,' OPENING OUTPUT FILE')
 1099 FORMAT ('CUBITM: COMOF3 ERROR',I3)
 1100 FORMAT ('CUBITM: INIT-FOR-',A4,' ERROR',I3)
 1120 FORMAT ('CUBITM: ',A4,' ERROR',I3)
 1180 FORMAT ('CUBITM: ZCLOSE ERROR',I3)
 1260 FORMAT ('CUBITM: CATIO ERROR',I3,' UPDATING CATBLK')
 1280 FORMAT ('#  input pts =',I8,1X,'# unblanked input pts =',I8)
 1290 FORMAT ('# output pts =',I8,1X,'# unblanked output pts =',I8)
 1390 FORMAT ('Fixed FPARM(',I2,') (',A,') =',F12.3)
 1400 FORMAT ('LMSTR INFORMATION PARAMETER =',I4)
 1410 FORMAT ('After',I4,' iterations the solution is FPARM (Errors)')
 1440 FORMAT (I2,2X,A,F11.4,'  (',F9.4,')')
 1460 FORMAT ('** Rot curve fit is only approximate for',I8,'pts')
 1470 FORMAT ('Rot curve fit is accurate for',I8,'pts')
 1700 FORMAT ('CUBITM: ERROR',I3,' GETTING',I10,' KILOWORDS OF MEMORY')
 1790 FORMAT ('Vertical column density',F8.4,' * 10^20 /cm^2')
 1791 FORMAT ('times  exp (-R/',F9.4,')  where R=radius in asec')
 1792 FORMAT ('times  exp (-(R/',F9.4,')^2)  where R=radius in asec')
 1793 FORMAT ('times  exp (-(',F9.4,'-R)/',F9.4,')    R ',A,F9.4)
 1794 FORMAT ('times  exp (-(R-',F9.4,')/',F9.4,')    R ',A,F9.4)
 1795 FORMAT ('times  exp (-((R-',F9.4,')/',F9.4,')^2)    R ',A,F9.4)
      END
      SUBROUTINE CUBITH (IRET)
C-----------------------------------------------------------------------
C   CUBITH will update
C   the history of the output map.
C
C   Output: IRET     I     Error code. 0=ok
C   Subprograms called:
C      AIPS SUBLIBRARIES...HIINIT, HISCOP, MSGWRT, HENCO1, HENCOO,
C                          HIADD, HICLOS, CATIO
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER CODESV(4)*4, NOTTYP*2
      INTEGER   JBL, NICT, NICTP, MTOT, LUN1, LUN2, IERR, I, IT, ICOUNT,
     *   I1
      REAL      XBUFF2(256), OUTPUT(5)
      LOGICAL   T
      INCLUDE 'CUBIT.INC'
      INCLUDE 'CUBPRM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /LEAST/ IT
      COMMON /JLEAST/ JBL, NICT, NICTP, MTOT
      EQUIVALENCE (BUFF2, XBUFF2)
      DATA CODESV /'CV  ', 'SB  ', 'BR  ', 'RC  '/
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NOTTYP /'CC'/
C-----------------------------------------------------------------------
      IRET = 0
C                                       WRITE HISTORY.
      CALL HIINIT (3)
C                                       COPY/OPEN HISTORY FILE.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 20
         END IF
C                                       NEW HISTORY
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       BLC, TRC
      WRITE (MSGTXT,2000)TSKNAM,(BLC(I),I=1,3),(TRC(I),I=1,3)
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       VCODE, DCODE
      WRITE (MSGTXT,2002) TSKNAM, VCODE, DCODE
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                      LIST ALL CPARM'S
      WRITE (MSGTXT,2006) TSKNAM, (CPARM(I),I=1,5)
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
      WRITE (MSGTXT,2006) TSKNAM, (CPARM(I),I=6,10)
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                      LIST ALL DPARM'S
      WRITE (MSGTXT,2008) TSKNAM, (DPARM(I),I=1,5)
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
      WRITE (MSGTXT,2008) TSKNAM, (DPARM(I),I=6,10)
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                      SHOW VALUE of ICUT
      WRITE (MSGTXT,2009) TSKNAM, XCUT
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                      NOTE ROTATION CURVE FOR
C                                      VCODE=RC
      IF (VCODE.EQ.CODESV(4)) THEN
         DO 15 ICOUNT = 1,2
            IF (ICOUNT.EQ.1) WRITE (MSGTXT,1050) TSKNAM
            IF (ICOUNT.EQ.2) WRITE (MSGTXT,1060) TSKNAM
            CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 20
            DO 10 I1 = 1,30,5
               IF (ICOUNT.EQ.1) CALL RCOPY (5, VPARM(I1), OUTPUT)
               IF (ICOUNT.EQ.2) CALL RCOPY (5, RPARM(I1), OUTPUT)
               WRITE (MSGTXT,1070) TSKNAM, (OUTPUT(I), I = 1,5)
               CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
               IF (IERR.NE.0) GO TO 20
 10            CONTINUE
 15         CONTINUE
         END IF
C                                      Write number of iterations
      WRITE (MSGTXT,2010) TSKNAM, IT
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                      List final fitted parameters
      WRITE (MSGTXT,2011) TSKNAM
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
      WRITE (MSGTXT,2012) TSKNAM, (FPARM(I), I = 1,4)
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
      WRITE (MSGTXT,2012) TSKNAM, (FPARM(I), I = 5,8)
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
      WRITE (MSGTXT,2012) TSKNAM, (FPARM(I), I = 9,12)
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
      WRITE (MSGTXT,2013) TSKNAM, (FPARM(I), I = 13,15)
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
      GO TO 25
C                                       HI error
 20   MSGTXT = 'HISTORY UPDATE ERROR'
      CALL MSGWRT (7)
C                                       Close HI file
 25   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (1, NOTTYP, LUN1, LUN2, DISKIN, DISKO, OLDCNO,
     *   NEWCNO, CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TAFHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1050 FORMAT (A6,'USER SPECIFIED ROTATION CURVE--VPARMS:')
 1060 FORMAT (A6,'RPARMS:')
 1070 FORMAT (A6,5(F8.2))
 2000 FORMAT (A6,'BLC =',3(F6.0,','),1X,'TRC =',3(F6.0,','))
 2002 FORMAT (A6,'VCODE = ''',A4,'''',1X,' DCODE = ''',A4,'''')
 2006 FORMAT (A6,'CPARM = ',5(F8.1))
 2008 FORMAT (A6,'DPARM = ',5(F8.1))
 2009 FORMAT (A6,'ICUT = ', F8.4)
 2010 FORMAT (A6,'/ FINAL SOLUTION REQUIRED',I4,1X,'ITERATIONS')
 2011 FORMAT (A6,'FPARM = ',5X,'/  FINAL VALUES')
 2012 FORMAT (A6,4(F10.4,1X))
 2013 FORMAT (A6,3(F10.4,1X))
      END
      SUBROUTINE NEWHED (IRET)
C-----------------------------------------------------------------------
C   The following functions are performed in NEWHED:
C       1) Modifying the catalog header block to represent the output
C            CATBLK(KIDIM)   = the number of axes,
C            CATBLK(KINAX+i) = the dimension of each axis
C       2) Checking the input image and/or input parameters.
C             For example, checking that the first axis is velocity.
C       3) Setting default values of some of the input parameters
C          Most of the defaults are set in CUBITI.  Here, the default
C          VCODE, and DCODE are set
C   The catalog block is updated when the history file is written.
C   Output:
C     IRET      I        Return error code, 0=>OK, otherwise abort.
C   Input (COMMON):
C      CATBLK   I(256)   Output catalog header, also CATR,CATD,CATH
C      CATOLD   I(256)   Input catalog header, also OLDR,OLDD,OLDH
C   Output:
C      CATBLK   I(256)   Modified output catalog header.
C   Subprograms called:
C      AIPS sublibraries...CHPACK, AXEFND, CHR2H, MSGWRT
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER ATYPES(3)*8, FCHARS(3)*4, CODESV(4)*4, CODESD(4)*4,
     *   UNITS*8, TEMP*8
      INTEGER   LIMIT, I, FIRSTI, FIRSTO, NTYPES, IOFF, IERR,
     *   INC, INDEX, NCHTYP(3)
      INCLUDE 'CUBIT.INC'
      INCLUDE 'CUBPRM.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA FCHARS /'VELO','VELO','FELO'/
C                                       value of VCODEs and DCODEs
      DATA CODESV /'CV  ','SB  ','BR  ','RC  '/
      DATA CODESD /'CD  ','EX  ','GS  ','RG  '/
C                                       Output units
      DATA UNITS /'JY/BEAM '/
C                                       Allowed number of axis types
C                                       and types. NCHTYP refers to the
C                                       number of characters which need
C                                     to match the specified axis type.
      DATA NTYPES /3/
      DATA ATYPES /'VELOCITY','VELO    ','FELO    '/
      DATA NCHTYP /3*3/
C-----------------------------------------------------------------------
C                                       Set default VCODE
      IF ((VCODE.NE.CODESV(2)) .AND. (VCODE.NE.CODESV(3)) .AND.
     *   (VCODE.NE.CODESV(4))) VCODE = CODESV(1)
C                                       check parameters
      IF ((VCODE.NE.CODESV(1)) .AND. ((FPARM(6).EQ.0.0) .OR.
     *   (FPARM(7).EQ.0.0))) THEN
         MSGTXT = 'FPARM(6) OR FPARM(7) NOT SPECIFIED'
         IRET = -1
         GO TO 990
         END IF
      IF ((VCODE.EQ.CODESV(4)) .AND. (RPARM(2).EQ.0.0) .AND.
     *   (VPARM(2).EQ.0.0)) THEN
          MSGTXT = 'USER SPECIFIED ROT CURVE REQUIRES VPARM, ' //
     *       'RPARM.NE.0'
          IRET=-1
          GO TO 990
          END IF
       IF ((DCODE.NE.CODESD(1)) .AND. (FPARM(10).EQ.0.0)) THEN
          WRITE (MSGTXT,1070) DCODE
          IRET = -1
          GO TO 990
          END IF
C                                       Set output units.
      CALL CHR2H (8, UNITS, 1, CATH(KHBUN))
C                                       Check allowed axis types
      DO 30 I = 1,NTYPES
         CALL AXEFND (NCHTYP(I), ATYPES(I), KICTPN, OLDH(KHCTP),
     *      IOFF, IERR)
         IF (IERR.EQ.0) GO TO 40
 30      CONTINUE
      IOFF = -1
C                                       IOFF is axis number
C                                       Check if axis first
 40   IF (IOFF.NE.0) THEN
         IRET = 1
         IF (IOFF.GT.0) MSGTXT = 'VELOCITY IS NOT FIRST AXIS, ' //
     *      'TRANSPOSE IMAGE'
         IF (IOFF.LT.0) MSGTXT = 'REQUIRED FIRST AXIS (VELOCITY)' //
     *      ' NOT FOUND IN IMAGE'
         GO TO 990
         END IF
C                                       Set axes in output CATBLK.
      FIRSTI = -1
      FIRSTO = -1
      LIMIT = CATOLD(KIDIM)
      INC = 2
C                                       Copy/update axis values
      DO 80 I = 1,LIMIT
         CATBLK(KINAX-1+I) = TRC(I) - BLC(I) + 1.01
         CATR(KRCRP-1+I) = OLDR(KRCRP-1+I) - BLC(I) + 1.0
         CATR(KRCIC-1+I) = CATR(KRCIC-1+I)
         CATD(KDCRV-1+I) = OLDD(KDCRV-1+I)
         IF (CATBLK(KIALT).NE.0) THEN
            INDEX = KHCTP + (I-1) * INC
            CALL H2CHR (4, 1, CATH(INDEX), TEMP)
            IF ((TEMP(1:4).EQ.FCHARS(1)) .OR. (TEMP(1:4).EQ.FCHARS(2))
     *         .OR. (TEMP(1:4).EQ.FCHARS(3)))
     *         CATR(KRARP) = CATR(KRARP) - BLC(I) + 1.0
            END IF
 80      CONTINUE
C                                       Put other checks here.
C                                       Check inclination range.
      IF ((FPARM(4).GE.89.1) .OR. (FPARM(4).LE.0.9)) THEN
         IRET = -1
         MSGTXT = 'REQUIRE 1 <= FPARM(4) <= 89'
         GO TO 990
         END IF
C                                       Ensure that the central
C                                       position specified is
C                                       inside the subimage window.
      IF ((FPARM(1).LT.BLC(2)) .OR. (FPARM(1).GT.TRC(2)) .OR.
     *   (FPARM(2).LT.BLC(3)) .OR. (FPARM(2).GT.TRC(3))) THEN
         MSGTXT = 'CENTER POSITION IS OUTSIDE OF WINDOW'
         IRET = -1
         GO TO 990
         END IF
      IF ((DCODE.EQ.CODESD(4)) .AND. (CPARM(5).EQ.0.0)) THEN
         MSGTXT = '**WARNING** CPARM(5) NOT SPECIFIED'
         CALL MSGWRT (6)
         DCODE = CODESD(3)
         MSGTXT = '*CHANGING DCODE TO GS*'
         IRET = 0
         GO TO 990
         END IF
C                                       Finished.
      IRET = 0
      GO TO 999
C                                       Error or warning
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1070 FORMAT ('SPECIFY FPM(10) FOR',1X,A4)
      END
      SUBROUTINE FCN (M, N, X, RESULT, DERP, DERM, IFLAG, DATA, JBLANK,
     *   MX, MY, DARRAY)
C-----------------------------------------------------------------------
C   FCN calculates the model (or residual) using parameters passed to
C   it via LSTSQ or CUBITM.  When called from LSTSQ, the non-linear
C   least squares fit routine, with IFLAG = 1, one call to FCN results
C   in a return of M values of the residuals, RESULT(J) (the loop over
C   M points is done in FCN).  When IFLAG is greater than 1, one call
C   to FCN results in a return of N values of DER(K) for a single point
C   (the loop over M points is done in LSTSQ).  After the least squares
C   fit is completed a final call to FCN occurs from CUBITM (in this
C   case, IFLAG = -1).
C   Input :
C      M         I      Number of unblanked data points
C      N         I      Number of free parameters
C      X         D(N)   Value of each parameter
C      IFLAG     I      =  1 to compute residuals
C                       >  1 to compute derivatives
C                            for calls through LSTSQ
C                       = -1 to compute residuals or model depending
C                            on CPARM(1) for final call through CUBITM
C      DATA     R(M)    Input data
C      JBLANK   I(*)    # blanked points before pixel of interest
C      MX       I       Output X dimension
C      MY       I       Output Y dimension
C   Output:
C      DARRAY   D(*)    (MX,MY,3) arrays for smoothing
C      RESULT   D(M)    RESULT contains the residuals (model - data)
C                       for the purposes of the least squares fit.
C                       or the model on the final call if CPARM(1)=1
C      DERP     D(15)   Model value + increment in pt IFLAG-1
C      DERM(    D(15)   Model value - increment in pt IFLAG-1
C      IFLAG    I       = -100 => ERROR
C   Subprograms called:
C      AIPS sublibraries...MSGWRT
C      CUBIT subroutines....VELITY, DENSTY
C   *NOTE* Z is a line of sight distance -
C   not a distance perpendicular to the plane.
C-----------------------------------------------------------------------
      INCLUDE 'CUBSIZ.INC'
      INTEGER   M, N, MX, MY, JBLANK(*), IFLAG
      REAL      DATA(*)
      DOUBLE PRECISION X(N), RESULT(M), DERP(MAXPRM), DERM(MAXPRM),
     *   DARRAY(MX,MY,3)
C
      CHARACTER CODESV(4)*4
      INTEGER   J, JM, JBL, JTOT, NAXIS1, NAXIS2, NAXIS3, NICT, NICTP,
     *   KM, KBL, MTOT, IHOLD, ITRACK(5), IRET, I, II, JJ, ISWCH, IT,
     *   IROUND, MMM, L, K, KX, LX, IDER, KSWCH, INTLIN, IIJJ, LE, LG,
     *   KK
      REAL      SINI, COSI, COS2I, SINPSI, COSPSI, SINPA, COSPA,
     *   RRA, RDEC, R, RX, RY, RAD, VMAXLM, VTEMP, DZDRVL(2), ZMAXIT,
     *   ZLIM(2,2), RVEL, Z(3,2), DELTAZ(2), VELIM(3), DELTAX, A, B,
     *   ALPHA, XP, YP, RYMAX(2), RYMIN(2), SAVE1, SAVE2, FACT
      DOUBLE PRECISION DENS(2), PI, DELTA(MAXPRM), DELTP, DELTM, BMODEL,
     *   XIN
      DOUBLE PRECISION ROWIN(2048), ROWOUT(2048)
      INCLUDE 'CUBIT.INC'
      INCLUDE 'CUBPRM.INC'
      INCLUDE 'CUBDIM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      SAVE KSWCH
      COMMON /LEAST/ IT
      COMMON /JLEAST/ JBL, NICT, NICTP, MTOT
      COMMON /DEL/ DELTA
      COMMON /JBLK/ IHOLD
      DATA KSWCH /0/
      DATA CODESV /'CV  ', 'SB  ', 'BR  ', 'RC  '/
      DATA PI /3.1415926536/
C-----------------------------------------------------------------------
      IRET = 0
C                                       Lengths of output array
      NXOUT = CATBLK(KINAX+1)
      NYOUT = CATBLK(KINAX+2)
      NVOUT = CATBLK(KINAX)
      IF (IFLAG.LE.1) INTLIN = NVOUT
C                                       Skip this setup if it's already
C                                       been done once
      IF (KSWCH.EQ.0) THEN
C                                       Create an array to remember how;
C                                       many blanked pts came before the
C                                       pixel of interest. Must be done
C                                       in same order as data read in.
         JM = 0
         JBL = 0
         DO 3 JJ = 1,NYOUT
            DO 2 II = 1,NXOUT
               DO 1 KK = 1,NVOUT
                  JM = JM + 1
                  IF (DATA(JM).EQ.FBLANK) JBL = JBL + 1
                  JBLANK(JM) = JBL
 1                CONTINUE
 2             CONTINUE
 3          CONTINUE
C                                       Check
         IF (JM.NE.MTOT) THEN
            IRET = -1
            WRITE (MSGTXT,1005) JM
            END IF
C                                       Check
         IF (JBL+M.NE.JM) THEN
            IRET = -1
            WRITE (MSGTXT,1005) JBL+JM
            GO TO 990
            END IF
         KSWCH = 1
         END IF
      RAD = 180.0 / PI
      IDER = 0
C                                       Check for error condition
      IF (IFLAG.EQ.-100) GO TO 999
C                                       On last call, just apply the
C                                       fitted FPARMs in the COMMON
      IF (IFLAG.EQ.-1) GO TO 70
C                                  If this is a derivative computation
C                                      skip to the derivative section
      IF (IFLAG.LT.2) THEN
C                                      Check for out of bounds FPARMs at
C                                      each iteration
C                                      LX loops over parameters(N=#FREE)
         L  = 0
         LE = 0
         LG = 0
         DO 10 LX = 1,N
 9          L = L + 1
            IF (FIX(L).EQ.1) GO TO 9
            XIN = X(LX)
            IF (L.EQ.4) THEN
               IF (X(LX).GT.89.05) X(LX) = 89.05
               IF (X(LX).LT.0.001) X(LX) = 0.001
            ELSE IF ((L.EQ.7) .OR. (L.EQ.8)) THEN
               X(LX) = MAX (1.0D-3, X(LX))
            ELSE IF ((L.EQ.7) .OR. (L.EQ.10)) THEN
               X(LX) = MIN (10.0D0*DSKMAX, X(LX))
            ELSE IF ((L.EQ.10).OR. (L.EQ.12)) THEN
               X(LX) = MAX (1.0D-3, X(LX))
            ELSE IF ((L.EQ.14) .OR. (L.EQ.15)) THEN
               X(LX) = MIN (1.0D0, X(LX))
            ELSE IF (L.NE.3) THEN
               X(LX) = MAX (1.0D-5, X(LX))
               END IF
            IF (XIN.NE.X(LX)) THEN
               WRITE (MSGTXT,1030) IFLAG, L, X(LX)
               CALL MSGWRT (8)
               END IF
            IF (CPARM(4).EQ.4.0) THEN
               IF (L.EQ.14) LE = LX
               IF (L.EQ.15) LG = LX
               END IF
 10         CONTINUE
C                                       Ensure that fp14+fp15=1, (recall
C                                       that either f14,f15 are both
C                                       fixed or they are both free)
         IF ((LE.NE.0) .OR. (LG.NE.0)) THEN
C                                       Take the larger value and ensure
C                                       that it stays larger. If they're
C                                       equal, let the exp disk dominate
            IF (X(LE).GE.X(LG)) X(LE) = 1.0 - X(LG)
            IF (X(LE).LT.X(LG)) X(LG) = 1.0 - X(LE)
            END IF
C                                      Update FPARM.  FPARM is used for
C                                      calculations.  X is used to com-
C                                      municate with LMSTR, and for in-
C                                      termediate output.
C                                      I: number of parameters to be
C                                         fitted
C                                      L: total number of parameters
         L = 0
         DO 20 I = 1,N
 15         L = L + 1
            IF (FIX(L).EQ.1) GO TO 15
            FPARM(L) = X(I)
 20         CONTINUE
         GO TO 70
         END IF
C                                      Start derivative computation
C                                      Initialize DERP,DERM
      DO 30 LX = 1,N
         DERP(LX) = 0.0D0
         DERM(LX)  = 0.0D0
 30      CONTINUE
C                                      On the first call for derivatives
C                                      set the values of DELTA
C                                      There are N values of DELTA(LX)
      L  = 0
      DO 35 LX = 1,N
 34      L  = L  + 1
         IF (FIX(L).EQ.1) GO TO 34
C                                     Skip this section if you've
C                                     already hit it once
C                                     Adjusting Deltas (June/91)
C                                     Try to make each delta meaningful
C                                     Position-want total increment to
C                                     be a pixel
         IF (DELTA(LX).EQ.0.0) THEN
            IF ((L.EQ.1) .OR. (L.LE.2)) THEN
               DELTA(LX) = 0.5D0
C                                     Angles - 3deg in PA, 1deg in i
            ELSE IF (L.EQ.3) THEN
               DELTA(LX) = 3.0D0
            ELSE IF (L.EQ.4) THEN
               DELTA(LX) = 1.0D0
C                                     Vsys, Vmax-incr. less than
C                                     half a channel, or f=0.005
            ELSE IF (L.EQ.5) THEN
               DELTA(LX) = DELVEL / 3.0D0
            ELSE IF ((L.EQ.6) .AND. (VCODE.NE.CODESV(4))) THEN
               DELTA(LX) = DELVEL / 5.0D0
            ELSE IF ((L.EQ.6) .AND. (VCODE.EQ.CODESV(4))) THEN
               DELTA(LX) = 0.005
C                                     Rmax->avg pixel sep in arcsec
            ELSE IF (L.EQ.7) THEN
               DELTA(LX) = (ABS (CATR(KRCIC+1)) + ABS (CATR(KRCIC+2)))
     *            * 3600.0 / 1.5
C                                     m - 0.4 of value to lower lim.
            ELSE IF (L.EQ.8) THEN
               DELTA(LX) = MAX( 0.4 * FPARM(L), 0.075 )
C                                     no-10% of value
            ELSE IF (L.EQ.9) THEN
               DELTA(LX) = 0.1D0 * FPARM(L)
C                                     ro-1 pixel separation
            ELSE IF (L.EQ.10) THEN
               DELTA(LX) = (ABS (CATR(KRCIC+1)) + ABS (CATR(KRCIC+2)))
     *            * 3600.0 / 2.0
C                                     zo-less than half of avg
C                                     pixel separation
            ELSE IF ((L.EQ.11) .OR. (L.EQ.13)) THEN
               DELTA(LX) = (ABS (CATR(KRCIC+1)) + ABS (CATR(KRCIC+2)))
     *            * 3600.0 / 5.0
C                                     r1 - 1 pixel separation
            ELSE IF (L.EQ.12) THEN
               DELTA(LX) = (ABS (CATR(KRCIC+1)) + ABS (CATR(KRCIC+2)))
     *            * 3600.0 / 2.0
C                                July/00, extra increments for new
C                                parms 14 and 15
C                                make the increment 10% of value
            ELSE IF ((L.EQ.14) .OR. (L.EQ.15)) THEN
               DELTA(LX) = 0.1D0 * FPARM(L)
               END IF
            END IF
 35      CONTINUE
      J  = IFLAG - 1
C                                      KX is deriv # of X
      KX = 0
C                                      Increment counters once per
C                                      call for derivative calc
      JM  = J + JBLANK(IHOLD)
      IF (DATA(JM).EQ.FBLANK) THEN
         IRET = -1
         WRITE (MSGTXT,1050) JM, J
         GO TO 990
         END IF
C                                      Begin loop for derivatives
C*********************************************************************
 50   DELTP = 0.0D0
      DELTM = 0.0D0
C                                      KX is the deriv # corresponding
C                                      to the X's (ie. the FPARMs to be
C                                      varied)
      KX = KX + 1
C                                      Only one FPARM is incremented
C                                      at a time to calc derivatives.
C                                      Increment FPARM's by +
C                                      or - the corresponding DELTA.
C                                      IDER keeps track of # of passes
C                                      through the code (twice for one
C                                      derivative).
  52  IDER = IDER + 1
C                                      K is the derivative number cor-
C                                      responding to the FPARMs
      K = (IDER-1)/2 + 1
      IF (FIX(K).EQ.1) GO TO 52
C                                      Increment up first
      IF (MOD(IDER,2).EQ.1) THEN
         FPARM(K) = FPARM(K) + DELTA(KX)
         DELTP = DELTA(KX)
C                                      Check for out of bounds values
C                                      and adjust if necessary
         IF ((K.EQ.4) .AND. (FPARM(K).GT.89.05)) THEN
            DELTP = DELTA(KX)-(FPARM(K)-89.05)
            FPARM(K) = 89.05
C                                     Avoid round off errors
            IF ((DELTP.LT.0.0) .AND. (ABS(DELTP/FPARM(K)).LT.1.0E-4))
     *         DELTP = 0.0
         ELSE IF ((K.EQ.7) .AND. (FPARM(K).GT.10.0*DSKMAX)) THEN
            DELTP = DELTA(KX) - (FPARM(K) - 10.0*DSKMAX)
            FPARM(K) = 10.0*DSKMAX
C                                     Avoid round off errors
            IF ((DELTP.LT.0.0) .AND. (ABS(DELTP/FPARM(K)).LT.1.0E-4))
     *         DELTP = 0.0
         ELSE IF ((K.EQ.8) .AND. (FPARM(K).GT.15.5)) THEN
            DELTP = DELTA(KX) - (FPARM(K) - 15.5)
            FPARM(K) = 15.5
            IF ((DELTP.LT.0.0) .AND. (ABS(DELTP/FPARM(K)).LT.1.0E-4))
     *         DELTP = 0.0
            END IF
C                                     Now increment down
      ELSE
         FPARM(K) = FPARM(K) - DELTP - DELTA(KX)
         DELTM = DELTA(KX)
C                                     Check again -- out of bounds
C                                     no boundary on position angle
         IF ((K.EQ.4) .OR. (K.EQ.7) .OR. (K.EQ.8)) THEN
            IF (FPARM(K).LT.1E-4 ) THEN
               DELTM = FPARM(K) + DELTA(KX) - 1.E-4
               FPARM(K) = 1E-4
               IF (DELTM.LT.0.0 .AND. ABS(DELTM/FPARM(K)).LT.1.0E-4)
     *             DELTM = 0.0
               END IF
         ELSE IF (K.NE.3) THEN
            IF (FPARM(K).LE.1E-8) THEN
               DELTM = FPARM(K) + DELTA(KX) - 1.0E-8
               FPARM(K) = 1.0E-8
               IF ((DELTM.LT.0.0) .AND. (ABS(DELTM/FPARM(K)).LT.1.0E-4))
     *            DELTM = 0.0
               END IF
            END IF
         END IF
C                     NOTE; do not need boundaries on fparm14,15
C                     derivative calc should be okay. just need
C                     to ensure that the central values themselves
C                     have f14+f15=1
C                                    Check that deltas are okay
      IF ((DELTM.LT.0.0) .OR. (DELTP.LT.0.0)) THEN
         IRET = -1
         WRITE (MSGTXT,1070) K, DELTP, DELTM
         GO TO 990
         END IF
C                                       Calculate sin and cos of
C                                       the position angle
  70  SINPA = SIN (FPARM(3)/RAD)
      COSPA = COS (FPARM(3)/RAD)
C                                    Determine trig fcns of inclination
      COSI = COS (FPARM(4)/RAD)
      COS2I = COSI**2
      SINI = SIN (FPARM(4)/RAD)
C                                       Determine max line of sight dis-
C                                       tance based on inclination and
C                                       disk thickness (arcsec).
      ZMAXIT = ABS(DPARM(7)/COSI)
C                                       Calculate the resolution in the
C                                       major axis direction (arcsec).
      ALPHA  = FPARM(3) - CATR(KRBPA)
      A      = (CATR(KRBMJ) * 3600.0) / 2.0
      B      = (CATR(KRBMN) * 3600.0) / 2.0
      XP     = A * COS (ALPHA/RAD)
      YP     = B * SIN (ALPHA/RAD)
      DELTAX = SQRT (XP**2 + YP**2)
C                                       Don't initialize counters or
C                                       increment again when calculating
C                                       derivatives.
      IF (IFLAG.GE.2) GO TO 90
C                                       Only work with unblanked points
C                                       J counts unblanked points to M
C                                       JM counts total # pts
C                                       JBL counts blanked pts
C                                       JTOT keeps track of # pts for
C                                       which intensities are actually
C                                       calculated
         JM   = 0
         JBL  = 0
         JTOT = 0
         J = 0
C                                        Initialize counters to find
C                                        the number of intervals (for
C                                        DENSITY) > 10, 100, 500
         DO 81 MMM = 1,5
            ITRACK(MMM) = 0
 81         CONTINUE
C                                        Begin loop for calc of RESULT
C**********************************************************************
 80   CONTINUE
      J = J + 1
  82     JM = J + JBL
         IF (DATA(JM).EQ.FBLANK) THEN
            JBL = JBL + 1
            GO TO 82
            END IF
C                                       Find plane, column and row #
C                                       (in pixels) of the pt at JM.
C                                       Note integer arithmetic.
  90     NAXIS3 = ((JM - 1)/(NVOUT * NXOUT)) + 1
         NAXIS2 = (((JM - ((NAXIS3 - 1) * NXOUT * NVOUT))-1) / NVOUT)+1
         NAXIS1 = JM - ((NAXIS3 - 1) * NXOUT * NVOUT) - ((NAXIS2 - 1)*
     *     NVOUT)
C                                       Convert to 'distance' from
C                                       specified center position in
C                                       real units.
         NAXIS3 = NAXIS3 + IROUND(BLC(3)) - 1
         NAXIS2 = NAXIS2 + IROUND(BLC(2)) - 1
C                                        DEC and RA offset s in arcsec
         RDEC = REAL(NAXIS3) - FPARM(2)
         RDEC = RDEC * CATR(KRCIC+2) * 3600.0
         RRA  = REAL(NAXIS2) - FPARM(1)
         RRA  = RRA * CATR(KRCIC+1) * (-3600.0)
         R = SQRT((RRA**2) + (RDEC**2))
C                                        VEL offset in km/s for input
C                                        map in m/s and parameter VSYS
C                                        in km/s.
         RVEL = (REAL(NAXIS1) - CATR(KRCRP)) * CATR(KRCIC)
     *           + CATD(KDCRV)
         RVEL = (RVEL/1000.0) - FPARM(5)
C                                       If the point is at the center
C                                       use the minor axis calculation.
         IF ((ABS(RDEC).LE.1E-37) .AND. (ABS(RRA).LE.1E-37)) THEN
            RX = 0.0
            RY = 0.0
         ELSE
C                                       Rotate the X (positional) axis
C                                       so that the X axis (starting pt)
C                                       is the receding major axis of
C                                       the galaxy as specified through
C                                       the parameter, FPARM3 (position
C                                       angle).  Angles, PSI, are
C                                       CCW, like the unit circle from
C                                       the receding maj axis.
            COSPSI = (COSPA * RDEC/R) - (SINPA * RRA/R)
            SINPSI = -((COSPA * RRA/R) + (SINPA * RDEC/R))
C                                       Only deal with the quadrant
C                                       specified. (Round off errors
C                                       must be dealt with)
            IF ((COSPSI.LT.COSMIN-1.E-7) .OR. (COSPSI.GT.COSMAX+1.E-7)
     *        .OR. (SINPSI.LT.SINMIN-1.E-7) .OR.
     *         (SINPSI.GT.SINMAX+1.E-7)) GO TO 499
            RX = R * COSPSI
            RY = R * SINPSI
            END IF
C                                       RX can't be > DSKMAX
         IF (ABS(RX).GT.DSKMAX) GO TO 499
C                                       RY can't be > the projected disk
C                                       width + an amt. for the disk
C                                       thickness
         IF (ABS(RY).GT.(DPARM(7)*SINI + SQRT(DSKMAX**2-RX**2)*COSI))
     *      GO TO 499
C                                       Exclude centrally located points
C                                       if less than dskmin in plane of
C                                       galaxy
         IF ((ABS(RX).LT.DSKMIN) .AND. (ABS(RY/COSI).LT.DSKMIN))
     *      GO TO 499
C                                       Even though RX,RY are in right
C                                       range, a large Z value could
C                                       put the pt. outside of the disk.
C                                       So limits must be set on Z
C                                       depending on whether the line of
C                                       sight distance 'emerges out' of
C                                       the disk through the thickness
C                                       or along the length.
C                                       ZMAXIT: Z has emerged through
C                                       the disk thickness (height
C                                       important)
C                                       OTHER: Z has emerged through
C                                       the disk end (DSKMAX important)
         RYMAX(1) = SQRT (DSKMAX**2 - RX**2)
         RYMIN(1) = 0.0
         IF (ABS(RX).LT.DSKMIN) RYMIN(1) = SQRT (DSKMIN**2 - RX**2)
         RYMAX(2) = - RYMAX(1)
         RYMIN(2) = - RYMIN(1)
         DO 118 JJ = 1,2
            ZLIM(1,JJ) = (RYMAX(JJ) - ABS(RY/COSI)) / SINI
            ZLIM(2,JJ) = (RYMIN(JJ) - ABS(RY/COSI)) / SINI
            DO 117 II = 1,2
               FACT = -1.0
               IF (ZLIM(II,JJ).GE.0.0) FACT = 1.0
               ZLIM(II,JJ) = FACT * MIN(ZMAXIT, ABS(ZLIM(II,JJ)))
 117           CONTINUE
C                                      Make sure the max value has
C                                      II=1, min has II=2
            SAVE1 = MAX(ZLIM(1,JJ), ZLIM(2,JJ))
            SAVE2 = MIN(ZLIM(1,JJ), ZLIM(2,JJ))
            ZLIM(1,JJ) = SAVE1
            ZLIM(2,JJ) = SAVE2
 118        CONTINUE
C                                      Define velocity values for points
C                                     (1 & 3) on either side of point of
C                                      interest (2).
         VELIM(1) = RVEL + DELVEL/2.0
         VELIM(2) = RVEL
         VELIM(3) = RVEL - DELVEL/2.0
C                                      For the minor axis (ie. if pt is
C                                      within 1/2 a half-max beam width
C                                      from RX=0) use the case where all
C                                      the gas is within one channel
         IF (ABS(RX).LT.DELTAX/2.0) GO TO 400
C                                      Can't have +ve velocities
C                                      with -ve RX's and vice versa
C                                      Allow for channel straddling
C                                      Vsys later
         IF (VELIM(1).GE.0.0 .AND. VELIM(3).GE.0.0 .AND. RX.LT.0.0)
     *       GO TO 499
         IF (VELIM(1).LE.0.0 .AND. VELIM(3).LE.0.0 .AND. RX.GT.0.0)
     *       GO TO 499
C                                      Call VELITY to determine the
C                                      max limiting velocity at an RX.
C                                      ISWCH=1 => return VMAXLM
C                                      ISWCH=2 => return Z(II,JJ)
         ISWCH = 1
         CALL VELITY (ISWCH, RX, RY, VELIM, VMAXLM, Z, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'VELITY ERROR'
            GO TO 990
            END IF
C                                      'Solid body' case requires a
C                                       different route. V is inde-
C                                       pendent of Z.
         IF (ISWCH.EQ.10) THEN
C                                       This part for 'SB' has been
C                                       changed in aug/00 ver
            IF (RX.GE.0.0) THEN
               VTEMP = VMAXLM
            ELSE
               VTEMP = VMAXLM*(-1.0)
               END IF
            IF (((VELIM(1).LE.VTEMP) .AND. (VELIM(3).GT.VTEMP)) .OR.
     *         ((VELIM(3).LE.VTEMP) .AND. (VELIM(1).GT.VTEMP)))
     *         GO TO 410
         ELSE
C                                       Subscripts II denote the point
C                                       of interest (II=2) and points
C                                       (II=1,3) correspond to a half
C                                       channel width on either side of
C                                       it.  Velocities should be in
C                                       range 0 < RVEL <or= VMAXLM
            DO 125 II = 1,3
C              IF ((ABS(VELIM(II)).GT.0.1) .AND.(ABS(VELIM(II))
C    *            .LE.VMAXLM)) GO TO 130
C                      Changed the boundary in the aug/00 version
               IF ((ABS(VELIM(II)).GT.0.0) .AND.
     *            (ABS(VELIM(II)).LE.VMAXLM)) GO TO 130
 125           CONTINUE
            END IF
         GO TO 440
C                                       Set limits for cases near the
C                                       'edge' and allow for channel
C                                       which straddles Vsys.
C                                       Adjusted boundaries slightly in
C                                       aug/00 ver - Doesn't work
C                                       perfectly yet for RC
 130     DO 140 II = 1,3
            IF (RX.LE.0.0) THEN
               VELIM(II) = MAX (-VMAXLM, MIN (-1.0E-5, VELIM(II)))
               IF ((VELIM(II).GT.-1.0) .AND. (VCODE.EQ.CODESV(4)))
     *            VELIM(II) = -DELVEL/4.0
            ELSE
               VELIM(II) = MIN (VMAXLM, MAX (1.0E-5, VELIM(II)))
               IF ((VELIM(II).LT.1.0) .AND. (VCODE.EQ.CODESV(4)))
     *            VELIM(II) = DELVEL/4.0
               END IF
 140        CONTINUE
C                                       Call to calculate Z(II,JJ) =
C                                       distance along line of sight +ve
C                                       or -ve from centre of disk for a
C                                       given VELIM(II)
C                                         ISWCH=1 => VMAXLM returned
C                                         ISWCH=2 => Z(II,JJ) returned
C                                       Two values of Z are possible for
C                                       a given VELIM (JJ=1,2)
         ISWCH = 2
         CALL VELITY (ISWCH, RX, RY, VELIM, VMAXLM, Z, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'VELITY ERROR'
            GO TO 990
            END IF
C                                       If both points straddling the
C                                       point of interest (2) are
C                                       outside of the disk, then the
C                                       intensity will be zero.
         DO 190 JJ = 1,2
C                                       If all pts (1 to 3) are out of
C                                       range, zero the pt.
            IF ((ZLIM(1,JJ).NE.ZLIM(2,JJ)) .AND. (ISWCH.NE.-3) .AND.
     *         (ISWCH.NE.(-JJ))) THEN
               DO 160 II = 1,3
                  IF ((Z(II,JJ).LE.ZLIM(1,JJ)) .AND.
     *               (Z(II,JJ).GE.ZLIM(2,JJ))) GO TO 170
 160              CONTINUE
               IF ((Z(1,JJ).GT.ZLIM(1,JJ)) .AND.
     *            (Z(3,JJ).LT.ZLIM(2,JJ))) GO TO 170
               IF ((Z(3,JJ).GT.ZLIM(1,JJ)) .AND.
     *            (Z(1,JJ).LT.ZLIM(2,JJ))) GO TO 170
               END IF
            DO 165 II = 1,3
               Z(II,JJ) = 0.0
 165           CONTINUE
            DZDRVL(JJ) = 0.0
            GO TO 190
C                                      Calculate dz/drvel
C                                      Constrain the straddling points
C                                      to be within the disk and cal-
C                                      culate the radial distance at
C                                      the center of the plane.
 170        DO 180 II = 1,3
               IF (Z(II,JJ).GT.ZLIM(1,JJ)) Z(II,JJ) = ZLIM(1,JJ)
               IF (Z(II,JJ).LT.ZLIM(2,JJ)) Z(II,JJ) = ZLIM(2,JJ)
 180           CONTINUE
            DELTAZ(JJ) = ABS(Z(1,JJ) - Z(3,JJ))
C                                      Calculate the derivative dz/dv
            DZDRVL(JJ) = DELTAZ(JJ) / DELVEL
 190        CONTINUE
         IF ((DZDRVL(1) + DZDRVL(2)).EQ.0.0) GO TO 440
         GO TO 430
C-----------------------------------------------------------------------
C                                       CALCULATION FOR CASE WHERE
C                                       ALL GAS IS NEAR VSYS
C
C                                       All gas along minor axis should
C                                       be near Vsys.
 400     IF (ABS(RVEL).GT.DELVEL/2.0) GO TO 440
C                                      Calculation for all emission
C                                      in a single channel
 410     CONTINUE
         DO 420 JJ = 1,2
            Z(1,JJ) = ZLIM(1,JJ)
            Z(3,JJ) = ZLIM(2,JJ)
            DELTAZ(JJ) = ABS(Z(1,JJ) - Z(3,JJ))
            DZDRVL(JJ) = DELTAZ(JJ) / DELVEL
 420        CONTINUE
C-----------------------------------------------------------------------
C                                       Determine the density at the
C                                       point
 430     CONTINUE
            CALL DENSTY (RX, RY, Z, DENS, IRET, ITRACK)
            IF (IRET.NE.0) THEN
               MSGTXT = 'DENSTY ERROR'
               GO TO 990
               END IF
C                                      Determine the model intensity
C                                      and/or residual in Jy/beam
C                                   If there are two points within the
C                                   disk for a given rvel (ie. if both
C                                      +ve and -ve sqrts result in z's
C                                within the disk) then the intensities
C                                      are additive.
            BMODEL = CONST * (DENS(1)*DZDRVL(1) + DENS(2)*DZDRVL(2))
C                                       Smoothing done in LSTSQ when
C                                       calculating derivatives
            IF (IFLAG.GE.2) GO TO 600
C                                       Count up pts where the intensity
C                                       is actually calculated
            JTOT = JTOT + 1
            GO TO 450
C                                       Set bmodel to a distinguishing
C                                       value so that it can be included
C                                       in the residual calc. later.
 440        BMODEL = 1.0E35
C                                       If this is the last pass through
C                                       and we want model only, let
C                                       bmodel be zero.
C                                       Smoothing in LSTSQ for deriv-
C                                       atives
            IF (IFLAG.GE.2) GO TO 600
C                                       Store BMODEL in RESULT before
C                                       smoothing
 450     RESULT(J) = BMODEL
         GO TO 500
C
 499     IF (IFLAG.GE.2) GO TO 580
         RESULT(J) = 0.0

C                                      Put some checks in here
 500     IF (J.LT.M) GO TO 80
C*********************************************************************
C                                       Print warning if there were too
C                                       many density intervals
      IF (ITRACK(4).GE.200) THEN
         WRITE (MSGTXT,1080) ITRACK(4)
         CALL MSGWRT (8)
         END IF
C                                       After RESULT has been calculated
C                                       for all pts, do the smoothing
      CALL SMOOTH (M, RESULT, IFLAG, DATA, JBLANK, MX, MY, DARRAY, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'SPATIAL SMOOTHING ERROR'
         GO TO 990
         END IF
C                                      Skip vel smoothing if desired
      IF (CPARM(6).GT.0.0) THEN
C                                      VEL smoothing, prepare to send
C                                      rows to vsmth
         JM = 0
 489     IF (J.LT.M) THEN
            DO 490 IIJJ = 1,NVOUT
               JM = JM + 1
               J = JM - JBLANK(JM)
               IF (DATA(JM).EQ.FBLANK) THEN
                  ROWIN(IIJJ) = FBLANK
C                                     there are additional blanks in
C                                     RESULT after SMOOTH
               ELSE
                  ROWIN(IIJJ) = RESULT(J)
                  END IF
 490           CONTINUE
            CALL VSMTH (NVOUT, ROWIN, ROWOUT, IFLAG, IRET)
            IF (IRET.NE.0) THEN
               MSGTXT = 'VELOCITY SMOOTHING ERROR'
               GO TO 990
               END IF
C                                    Set the pointer at the beginning
C                                    of the row again
            JM = JM - NVOUT
            DO 495 IIJJ = 1,NVOUT
               JM = JM + 1
               J = JM - JBLANK(JM)
               IF (DATA(JM).NE.FBLANK) RESULT(J) = ROWOUT(IIJJ)
 495           CONTINUE
            GO TO 489
            END IF
         END IF
C
C                                       If it's the last pass through
C                                       and we want the model only,
C                                       we're finished now
      IF ((CPARM(1).EQ.1) .AND. (IFLAG.EQ.-1)) GO TO 999
C
C                                       Compute residuals using smoothed
C                                       data
C
      KM = 0
      KBL = 0
      KK = 0
      DO 507 KK = 1,M
 504     KM = KK + KBL
         IF (DATA(KM).EQ.FBLANK) THEN
            KBL = KBL+1
            GO TO 504
            END IF
C                                       Compute residuals (MODEL-DATA)
C                                       Any newly blanked value of
C                                       RESULT from SMOOTH should
C                                       be set to zero to send back
C                                       to the least squares routine
         IF (RESULT(KK).EQ.FBLANK) THEN
C                                       Don't want to pass blanks back
C                                       to the least squares routine
            IF (IFLAG.NE.-1) RESULT(KK) = 0.0
         ELSE IF (RESULT(KK).NE.0.0) THEN
            IF ((RESULT(KK).GT.1.0E34) .AND.
     *         (RESULT(KK).LT.1.0E36)) RESULT(KK) = 0.0
C                                       Calculate residuals
            RESULT(KK) = RESULT(KK) - DATA(KM)
C
C                                       If there's a flux cutoff and
C                                       it's not the last pass through
C                                       then set the residual to zero
C                                       if it's less than the cutoff
            IF ((ABS(DATA(KM)).LT.XCUT) .AND. (IFLAG.NE.-1))
     *         RESULT(KK) = 0.0
            END IF
 507     CONTINUE
C                                       If it's the last pass through
C                                       we're finished
      IF (IFLAG.NE.-1) THEN
C                                       After RESULT loop, set JBL to
C                                       zero for beginning of der calc
         JBL = 0
C                                       Increment the iteration counter
         IT = IT + 1
C                                       Print out solutions after each
C                                       iteration
         WRITE (MSGTXT,2000) IT, JTOT
         CALL MSGWRT (5)
         DO 550 L = 1,N
            WRITE (MSGTXT,2010) FPNUM(L), PSTRNG(L), X(L)
            CALL MSGWRT (5)
 550        CONTINUE
         END IF
      GO TO 999
C                                       Calculate derivatives
 580  BMODEL = 0.0
 600  CONTINUE
C                                       Make sure there are no huge
C                                       values when calculating ders
      IF ((BMODEL.GT.1.0E34) .AND. (BMODEL.LT.1.0E36)) BMODEL = 0.0
      IF (K.NE.(IDER-2)/2 +1) THEN
         DERP(KX)= BMODEL
C                                       Loop back for a second pass
C                                       through (same derivative #)
         GO TO 52
C      ************
      ELSE
         DERM(KX) = BMODEL
C                                       Now divide by the sum of the
C                                       increments
         DERP(KX) = DERP(KX)/(DELTP+DELTM)
         DERM(KX) = DERM(KX)/(DELTP+DELTM)
C                                       Put FPARM back to its ori-
C                                       ginal value before the incre-
C                                       ments
         FPARM(K) = FPARM(K) + DELTM
         IF (KX.LT.N) GO TO 50
         END IF
C**********************************************************************
C                                       End derivative loop
C
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
      IFLAG = -100
C
 999  RETURN
C-----------------------------------------------------------------------
 1005 FORMAT ('# OF PTS=',I7,1X,'.NEQ. ORIGINAL')
 1030 FORMAT ('IFLAG=',I6,'  *WARNING*CHANGING FPARM(',I2,') TO',E12.4)
 1050 FORMAT ('DATA(',I7,') IS BLANKED WHEN J=',I7)
 1070 FORMAT ('DER',I4,'HAS INCREMENTS',E14.3,2X,E14.3)
 1080 FORMAT ('*WARNING*',I6,1X,'PTS REQUIRED >500 DENSTY INTERVALS')
 2000 FORMAT ('*** ',I3,1X,'iterations',I8,
     *   ' non-zero points in model ***')
 2010 FORMAT (I2,2X,A,1X,F12.5)
      END
      SUBROUTINE VELITY (ISWCH, RX, RY, VELIM, VMAXLM, Z, IRET)
C-----------------------------------------------------------------------
C   VELITY calculates the maximum velocity permissible for a given
C   X axis distance (RX) (ie. the value from the assumed rotation curve
C   when RY=0), VMAXLM, when ISWCH = 1.This subroutine also calculates
C   the LINE OF SIGHT distance, Z(II,JJ), from Z=0 at the center of the
C   disk for a given VELIM(II), RX and RY, when ISWCH=2.  Note that
C   two values of Z may exist for any VELIM if the disk is inclined
C   enough or thick enough.
C   Inputs:
C      ISWCH     I        1 => return VMAXLM
C                         2 => return Z(II,JJ)
C                         anything else => terminate
C      RX        R        Distance along major axis (arcsec) to
C                         pt of interest
C      RY        R        Distance along minor axis
C      VELIM     R(3)     Radial velocity of pt (2) and points (1) and
C                         (3) half a channel width on either side of
C                         it.  Velocities are relative to Vsys.
C   Outputs:
C      VMAXLM    R        Max limiting velocity from the rotation curve
C                         for a given RX.  (corresponds to RY=0, Z=0)
C      Z         R(3,2)   Line of sight distance from disk center
C                         corresponding to VELIM(II) using the +ve
C                         (JJ=1) and -ve (JJ=2) sqrts.
C      ISWCH     I        ISWCH = 10 for SB rotation curve.
C                         If out of bounds (for RC) return ISWCH as
C                         negative.
C       IRET     I        Error code - 0 = okay, anything else = DIE
C   Subprograms called:
C      AIPS sublibraries......MSGWRT
C-----------------------------------------------------------------------
      INTEGER   ISWCH, IRET
      REAL      RX, RY, VELIM(3), VMAXLM, Z(3,2)
C
      CHARACTER CODESV(4)*4
      INTEGER   JBL, NICT,NICTP, MTOT, II, JJ, ICT, I
      REAL      RAD, SINI, COSI, PI, RR, VRSAVE, VR, FRAC, RRSAVE, DIFF
      DOUBLE PRECISION FSQRT(3,2)
      INCLUDE 'CUBIT.INC'
      INCLUDE 'CUBPRM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /JLEAST/ JBL, NICT, NICTP,MTOT
      DATA PI /3.1415926536/
      DATA CODESV /'CV  ','SB  ','BR  ','RC  '/
C-----------------------------------------------------------------------
      RAD = 180.0/PI
      SINI = SIN(FPARM(4)/RAD)
      COSI = COS(FPARM(4)/RAD)
C                                        ISWCH = 1
C                                        Calculate VMAXLM
      IF (ISWCH.EQ.1) THEN
C                                        Constant velocity case
         IF (VCODE.EQ.CODESV(1)) THEN
            VMAXLM = ABS(FPARM(6))
C                                        Solid body case
         ELSE IF (VCODE.EQ.CODESV(2)) THEN
C                                        Change the switch to re-
C                                        route the code for SB case.
            ISWCH = 10
            VMAXLM = ABS (FPARM(6) * RX / FPARM(7))
C                                        Brandt curve case
         ELSE IF (VCODE.EQ.CODESV(3)) THEN
            IF (FPARM(8).LT.1.0E-30) FPARM(8) = 0.0
            IF (FPARM(8).GT.15) THEN
               FPARM(8) = 15
               WRITE(MSGTXT,1045) FPARM(8)
               CALL MSGWRT (8)
               END IF
            VMAXLM = (ABS(RX) / FPARM(7)) ** FPARM(8)
            VMAXLM = 1.0/3.0 + (2.0/3.0) * VMAXLM
            VMAXLM = VMAXLM ** (3.0 / (2.0 * FPARM(8)))
            VMAXLM = ABS(FPARM(6) * RX) / (FPARM(7) * VMAXLM)
C                                        User specified rotation curve
C                                        VMAXLM cannot be rigorous
C                                        at this point because R is
C                                        unknown
         ELSE
            VMAXLM = 0.0
            DO 10 I = 1,30
               VMAXLM = MAX (VMAXLM, ABS(VPARM(I)))
 10            CONTINUE
            VMAXLM = VMAXLM * FPARM(6)
            END IF
         VMAXLM = VMAXLM * SINI
C                                        ISWCH = 2
C                                        Calculate Z(II,JJ)
      ELSE IF (ISWCH.EQ.2) THEN
         DO 200 JJ = 1,2
            DO 195 II = 1,3
C                                        Constant velocity case
               IF (VCODE.EQ.CODESV(1)) THEN
                  IF (JJ.EQ.1) THEN
                     FSQRT(II,JJ) = SQRT ((FPARM(6) * SINI / VELIM(II))
     *                  ** 2 - 1.0)
                  ELSE
                     FSQRT(II,2) = -1.0 * FSQRT(II,1)
                     END IF
                  Z(II,JJ) = (ABS(RX)*FSQRT(II,JJ)-ABS(RY/COSI))/SINI
                  GO TO 195
C                                        Solid body case
C                                        V is independent of Z so
C                                        Z can't be calculated.
               ELSE IF (VCODE.EQ.CODESV(2)) THEN
                  MSGTXT = 'VELITY: SB CASE SHOULD NOT GET HERE'
                  GO TO 990
C                                        Brandt curve case
               ELSE IF (VCODE.EQ.CODESV(3)) THEN
C                                        A small round off error
C                                        necessitates the next step
                  IF (ABS(ABS(VELIM(II)/VMAXLM)-1.0).LE.1.0E-3) THEN
                     FSQRT(II,JJ) = 0.0
                  ELSE IF (JJ.NE.1) THEN
                     FSQRT(II,2) = -1.0 * FSQRT(II,1)
                  ELSE
                     FSQRT(II,JJ) = ((ABS(FPARM(6) * SINI) / VELIM(II))
     *                  * (RX / FPARM(7))) ** (2 * FPARM(8) / 3.0)
                     FSQRT(II,JJ) = (ABS(3.0/2.0 * FSQRT(II,JJ) - 0.5))
     *                  ** (2.0 / FPARM(8))
                     IF ((FPARM(7)**2*FSQRT(II,JJ)-(RX**2)).GE.0.0) THEN
                        FSQRT(II,JJ) = SQRT ((FPARM(7) ** 2 / (RX **2))
     *                     * FSQRT(II,JJ) - 1.0)
                     ELSE
                        FSQRT(II,JJ) = 0.0
                        END IF
                     END IF
C                                       Calculate Z
                  Z(II,JJ) = (ABS(RX)*FSQRT(II,JJ)-ABS(RY/COSI))/SINI
                  GO TO 195
C                                       User specified rotation curve
               ELSE
                  ICT = 0
                  Z(II,JJ) = 0.0
                  VRSAVE = 0.0
                  RRSAVE = 0.0
                  VR = 0.0
C                                       Must iterate to find correct R
C                                       Start by assuming Z=0
                  RR = SQRT (RX**2 + (RY/COSI)**2)
 130              ICT = ICT + 1
                  DIFF = ABS (RR-RRSAVE)
C                                       Assume no solution if > 200
C                                       iterations required
                  IF (ICT.GT.200) GO TO 142
 142              NICT = NICT + 1
                  GO TO 144
C                                       Stop iterations if change in
C                                       RR is less than half the average
C                                       beam resolution AND change in
C                                       VR is less than half the
C                                       channel separation
                  IF ((DIFF.LT.(CATR(KRBMJ)+CATR(KRBMN))*3600.0/4.0)
     *              .AND. (ICT.GT.2) .AND.
     *              (ABS(VR-VRSAVE)*FPARM(6).LT.ABS(CATR(KRCIC)/2000.)))
     *              GO TO 143
C                                       Stop iterations if iteration
C                                       no. is > 50 and vel change is
C                                       better than vel res. and RR
C                                       change is better than spatial
C                                       resolution
                  IF ((DIFF.LT.(CATR(KRBMJ)+CATR(KRBMN))*3600.0/2.0)
     *               .AND. (ABS(VR-VRSAVE)*FPARM(6).LT.ABS(CATR(KRCIC)
     *               /1000.0)) .AND. (ICT.GT.50)) GO TO 143
                  RRSAVE = RR
                  VRSAVE = VR
C                                       Find VR from RR
                  VR = (RR/RPARM(1)) * VPARM(1)
                  IF (RR.GE.RPARM(1)) THEN
                     DO 135 I = 1,30
                        IF ((I.EQ.30) .OR. (RPARM(I+1).EQ.0.0)) THEN
                           VR = VPARM(I)
                           GO TO 140
                        ELSE IF (RR.GE.RPARM(I) .AND. RR.LT.RPARM(I+1))
     *                        THEN
                           FRAC = (RR-RPARM(I))/(RPARM(I+1)-RPARM(I))
                           VR = (VPARM(I+1)-VPARM(I))*FRAC + VPARM(I)
                           IF (ABS(VR-VPARM(I)).GT.
     *                        ABS(VPARM(I+1)-VPARM(I))) THEN
                              MSGTXT =
     *                           'ROTATION CURVE INTERPOLATION ERROR'
                              GO TO 990
                              END IF
                           GO TO 140
                           END IF
 135                    CONTINUE
                     END IF
 140                 VR = VR * FPARM(6)
C                                       Compute RR from VR
                  RR = VR * SINI * ABS (RX/VELIM(II))
C                                       Continue iterating
                  GO TO 130
C                                       a solution
 143              NICTP = NICTP + 1
C                                       Let final RR be average of
C                                       current RR and previous RR
 144              RR = (RR+RRSAVE) / 2.0
C                                       Save RR in FSQRT
                  FSQRT(II,JJ) = RR
C
                  END IF
 195           CONTINUE
 200        CONTINUE
C                                       Need to check vel limits
C                                       for RC case
         IF (VCODE.EQ.CODESV(4)) THEN
            ISWCH = 0
            DO 400 JJ = 1,2
               DO 300 II = 1,3
C                                       RR was stored in FSQRT.
C                                       If any RR of the 3 is
C                                       within range, then
C                                       continue
                  IF (FSQRT(II,JJ).GE.ABS(RX) .AND.
     *               FSQRT(II,JJ).LE.DSKMAX) GO TO 330
 300              CONTINUE
C                                        If ALL RR of the 3 are
C                                        smaller than RX, then
C                                        pt is out of range.
C                                        Set iswch so that pt in
C                                        FCN goes to zero.
               ISWCH = ISWCH - JJ
               GO TO 400
C                                        Set limits for cases near
C                                        the edge as before in FCN
C                                        only work with RR,RX rather
C                                        than VELIM VMAXLM
 330           DO 350 II = 1,3
                  IF (FSQRT(II,JJ).LT.ABS(RX)) FSQRT(II,JJ) = ABS(RX)
                  IF (FSQRT(II,JJ).GT.DSKMAX) FSQRT(II,JJ) = DSKMAX
 350              CONTINUE
C                                        Now calculate Z
               DO 370 II = 1,3
                  FSQRT(II,JJ) = FSQRT(II,JJ)**2 - RX**2
C                                        A small roundoff error
C                                        necessitates the next step
                  IF (FSQRT(II,JJ).LT.0.0) FSQRT(II,JJ) = 0.0
                  FSQRT(II,JJ) = SQRT (FSQRT(II,JJ))
                  IF (JJ.EQ.2) FSQRT(II,JJ) = -FSQRT(II,JJ)
                  Z(II,JJ) = (FSQRT(II,JJ)-ABS(RY/COSI))/SINI
 370              CONTINUE
 400           CONTINUE
            END IF
      ELSE
         MSGTXT = 'ILLEGAL VALUE OF ISWCH'
         GO TO 990
         END IF
      GO TO 999
C                                        Error
 990  IRET = -1
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1045 FORMAT ('**WARNING** CHANGING FPARM(8) TO ',F10.4)
      END
      SUBROUTINE DENSTY (RX, RY, Z, DENS, IRET, ITRACK)
C-----------------------------------------------------------------------
C   DENSTY computes the density at the radial distance, RZ, and height
C   above or below the plane, ZCOSI.  Options include constant density,
C   exponential density (with scale length), gaussian density (with
C   scale length) and a ring distribution which can either be an
C   exponential on both sides or gaussian on both sides.
C   The density is computed by integrating the fcn over
C   the line of sight distance, Z, where the 'fcn' refers to the radial
C   and perpendicular fcns multiplied together.  eg.  EXGS case:
C   take the integral from z1 to z2 of exp(-RZ/FPARM(10))*exp(-ZCOSI**
C   2/FPARM(11)**2) and then divide by z2-z1.  The integration is
C   done numerically -- z is integrated in steps such that no change
C   in the fcn is greater than 10%. ie. z can stretch or shrink to
C   ensure that the change in fcn is not more than 10%
C   Inputs:
C      RX       R        Distance along major axis (arcsec) to point
C                        of interest.
C      RY       R        Distance along minor axis.
C      Z        R(3,2)   Distance along the line of sight from the
C                        center of the galaxy's plane.  May be +ve
C                        or -ve.
C   Outputs:
C      DENS     D(2)     Density corresponding to the above positions
C                        depending on the density dist'ns chosen in
C                        the input parameters.
C      IRET     I        Error code - 0 = okay, anything else = die
C      ITRACK   I(5)     Keeps track of how many points required
C                        more than 10, 100 or 500 intervals in z.
C   Subprograms called:
C      AIPS sublibraries......MSGWRT
C-----------------------------------------------------------------------
      REAL      RX, RY, Z(3,2)
      INTEGER   IRET, ITRACK(5)
      DOUBLE PRECISION   DENS(2)
C
      CHARACTER CODESD(4)*4
      INTEGER   JJ, ICOUNT, ISIDE, ICSAVE, LAST, ICHECK, IRNEW, IROLD
      REAL      RZ, SINI, COSI, PI, RAD
      DOUBLE PRECISION ZDENS, RDENS, SUMT, RX2, ARYC, ZLO, ZHI, ZINC,
     *   ZSIDE, ZINCT, FUNCO, FUNCN, FUNC, ZNEW, AREA, RSCALE, EDENS,
     *   GDENS
      INCLUDE 'CUBIT.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA PI /3.1415926536/
      DATA CODESD /'CD  ','EX  ','GS  ','RG  '/
C-----------------------------------------------------------------------
C
      RAD  = 180.0 / PI
      SINI = SIN (FPARM(4)/RAD)
      COSI = COS (FPARM(4)/RAD)
      RX2 = RX**2
      ARYC = ABS (RY/COSI)
C                                      Start loop over JJ
      DO 300 JJ = 1,2
C                                      Initialize some counters
         ICOUNT = 0
         ISIDE = 0
         SUMT = 0.0
         IRNEW = 0
         IROLD = 0
         DENS(JJ) = 0.0
C                                       Density is zero if point is
C                                       degenerate
         IF (Z(1,JJ).EQ.Z(3,JJ)) GO TO 300
C                                       Take a different route if
C                                       the Z limits are of different
C                                       sign ie. the Z interval cross
C                                       es the center of the plane
         IF (Z(1,JJ)*Z(3,JJ).LT.0.0) THEN
            ISIDE = 1
            ZLO = MIN(Z(1,JJ),0.0)
            ZHI = MAX(Z(1,JJ),0.0)
         ELSE
            ZLO = MIN(Z(1,JJ),Z(3,JJ))
            ZHI = MAX(Z(1,JJ),Z(3,JJ))
            END IF
C                                       Initial Z increment and
C                                       initialize other values
 5       ZINC = ABS(ZHI-ZLO)
         IF (ISIDE.EQ.1) ZSIDE = ZINC
         ZINCT = ZINC
         FUNCO = 0.0
         FUNCN = 0.0
         ZNEW = ZLO
         ICOUNT = 0
         LAST = 0
C                                       This starts the looping
C                                       Save the old Fcn to compare
 10      FUNCO = FUNCN
         IROLD = IRNEW
         ICHECK = 0
C                                       Compute radial distance
 20      RZ = SQRT(RX2+(ARYC+ZNEW*SINI)**2)
C                                       Compute radial fcn
         RDENS = 0.0
         IF (DCODE.EQ.CODESD(1)) THEN
             RDENS = 1.0
         ELSE IF (DCODE.EQ.CODESD(2)) THEN
             IF (RZ.LE.34.0*FPARM(10)) RDENS = EXP (-RZ/FPARM(10))
         ELSE IF (DCODE.EQ.CODESD(3)) THEN
            IF (RZ**2.LE.34.0*(FPARM(10)**2)) RDENS =
     *         EXP (-(RZ**2)/(FPARM(10))**2)
         ELSE IF (DCODE.EQ.CODESD(4)) THEN
            IF (RZ.LT.CPARM(5)) THEN
               RSCALE = FPARM(12)
               IRNEW = -1
            ELSE
               RSCALE = FPARM(10)
               IRNEW = 1
               END IF
C                                       CPARM(7) distinguishes
C                                       between a gaussian or
C                                       an exponential ring
C                                       CPARM(7)=2==> EXP
C                                       CPARM(7)=3==> GAUSS
C                                       If more than 34 scale
C                                       lengths, set to zero
C                                       Gaussian ring
            IF (CPARM(7).GT.2.5) THEN
               IF ((RZ-CPARM(5))**2.LE.(34.0*(RSCALE**2))) RDENS =
     *            EXP(-((RZ-CPARM(5))**2)/(RSCALE**2))
C                                       Exponential ring
            ELSE
               IF (ABS(RZ-CPARM(5)).LE.34.0*ABS(RSCALE)) RDENS =
     *            EXP(-(ABS(RZ-CPARM(5)))/ABS(RSCALE))
               END IF
         ELSE
            MSGTXT = 'DCODE ''' // DCODE // ''' NOT PROGRAMMED YET'
            GO TO 995
            END IF
C                                      Compute perp. fcn
 50      IF (CPARM(4).EQ.1.0) THEN
            ZDENS = 1.0
         ELSE
            EDENS = 0.0
            GDENS = 0.0
            IF (ABS(ZNEW*COSI).LE.34.0*FPARM(11)) EDENS = FPARM(14) *
     *         EXP (-ABS (ZNEW*COSI) / FPARM(11))
            IF ((ZNEW*COSI)**2.LE.34.0*(FPARM(11)**2)) GDENS = FPARM(15)
     *         * EXP (-((ZNEW*COSI)**2) / (FPARM(13))**2)
            IF (CPARM(4).EQ.2) ZDENS = EDENS
            IF (CPARM(4).EQ.3) ZDENS = GDENS
            IF (CPARM(4).EQ.4) ZDENS = EDENS+GDENS
            END IF
C                                      Compute the fcn
         FUNCN = RDENS * ZDENS
C                                       If it's the first time
C                                       through, fcn must be
C                                       calculated again
         IF (ICOUNT.GT.0) THEN
C                                     Test acceptance criteria
C                                     if previous and new values are
C                                     on same 'side' of fcn OR if
C                                     they are on opposide sides but
C                                     close to R0
            IF ((DCODE.EQ.CODESD(4)) .AND. (IRNEW.NE.IROLD)) THEN
               IF ((ABS(RZ-CPARM(5)).LT.RSCALE/1000.0) .OR.
     *            (ZINC.LT.(ABS(ZHI-ZLO)/200.0))) THEN
                  RDENS = 1.0
                  IRNEW = -1.0 * IRNEW
                  GO TO 50
                  END IF
C                                      If new and old funcs are zero,
C                                      accept them and carry on
            ELSE
               IF ((FUNCN.EQ.0.0) .AND. (FUNCO.EQ.0.0)) GO TO 100
C                                      If new and old funcs are both
C                                      non-zero, use acceptance crit.
               IF ((FUNCN.EQ.0.0) .OR. (FUNCO.EQ.0.0)) THEN
C                                      If one is zero and one isn't,
C                                      accept them only if the last
C                                      Zinc is less than 1/200 of the
C                                      total range.
                  IF (ZINC.LE.ABS((ZHI-ZLO)/200.0)) GO TO 100
C                                      Criteria for
C                                      accepting the fcn value
C                                      a) if new fcn differs from
C                                         old fcn by less than 5%
               ELSE
                  IF ((2.0*ABS(FUNCN-FUNCO)/(FUNCN+FUNCO).LE.0.05) .OR.
C                                      Don't allow ZINC to go below
C                                      1/200 of ZHI-ZLO
     *               (ZINC.LT.(ABS(ZHI-ZLO)/200.0))) GO TO 100
                  END IF
               END IF
C                                      If fcn has changed too much
C                                      decrement zinc and try again
            ZINC = ZINC/2.0
            ZNEW = ZNEW-ZINC
            ICHECK = ICHECK + 1
            IF (ICHECK.GT.3000) GO TO 989
            GO TO 20

C                                      It's only the last point
C                                      if the above condition is met
C                                      Compute area and sum with
C                                      previous area
 100        IF (ZNEW.EQ.ZHI) LAST = 1
            AREA = ((FUNCN+FUNCO)/2.0)*ZINC
            SUMT = SUMT+AREA
            IF (DCODE.EQ.CODESD(4) .AND. RDENS.EQ.1.0) IRNEW = -1.0
     *         *IRNEW
            END IF
         ICOUNT = ICOUNT + 1

         IF ((ICOUNT.EQ.1) .OR. (LAST.NE.1)) THEN
C                                      If successful, increment zinc
C                                      and try again
            IF (ICOUNT.NE.1) ZINC = ZINC * 2.0
            ZNEW = ZNEW + ZINC
            IF (ABS((ZNEW-ZHI)/(ZHI-ZLO)).LT.1.0E-5) THEN
               ZNEW = ZHI
C                                      If it's out of bounds modify
C                                      ZINC and ZNEW
            ELSE IF (ZNEW.GT.ZHI) THEN
               ZINC = ZINC-(ZNEW-ZHI)
               ZNEW = ZHI
               END IF
           GO TO 10
           END IF
C                                      If the integration is done in
C                                      2 sections, keep track of sums
         ISIDE = ISIDE+2
         IF (ISIDE.EQ.3) THEN
            ICSAVE = ICOUNT
            ZLO = MIN(Z(3,JJ),0.0)
            ZHI = MAX(Z(3,JJ),0.0)
            GO TO 5
            END IF
         IF (ISIDE.NE.2) THEN
            ZINCT = ZSIDE+ZINCT
            ICOUNT = ICOUNT+ICSAVE
            END IF
C                                      Compute total integral divided
C                                      by total z distance+final value
         FUNC = SUMT/ZINCT
C                                      Avoid underflows
         IF ((FUNC.GT.0.0) .AND.
     *      ((LOG10(FPARM(9))+LOG10(FUNC)).GE.-15.0))
     *      DENS(JJ) = FPARM(9)*FUNC
 300     CONTINUE
C                                      Keep track of counter values
      IF (ICOUNT.GT.10) ITRACK(1) = ITRACK(1) + 1
      IF (ICOUNT.GT.50) ITRACK(2) = ITRACK(2) + 1
      IF (ICOUNT.GT.100) ITRACK(3) = ITRACK(3) + 1
      IF (ICOUNT.GE.500) ITRACK(4) = ITRACK(4) + 1
      IF (ICOUNT.GE.1000) THEN
         MSGTXT = '>1000 LOS INTERVALS REQUIRED TO COMPUTE DENS'
         GO TO 995
         END IF
      GO TO 999
C
 989  WRITE (MSGTXT,1030) FUNCN, FUNCO, ZINC, ZNEW
      CALL MSGWRT (8)
      WRITE (MSGTXT,1035) Z(1,JJ), Z(3,JJ), ZLO, ZHI
      CALL MSGWRT (8)
      WRITE (MSGTXT,1040) ZDENS, RDENS, RZ, FPARM(11)
C                                      ERROR
 995  CALL MSGWRT (8)
      IRET = -1
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('FN=',E11.3,'FO=',E11.3,'ZI=',E11.3,'ZN=',E11.3)
 1035 FORMAT ('Z(1)=',E11.3,'Z(3)=',E11.3,'ZL=',E11.3,'ZH=',E11.3)
 1040 FORMAT ('ZD=',E11.3,'RD=',E11.3,'RZ=',E11.3,'F11=',E11.3)
      END
      SUBROUTINE SMOOTH (M, RESULT, IFLAG, DATA, JBLANK, MX, MY,
     *   DARRAY, IRET)
C-----------------------------------------------------------------------
C   SMOOTH takes all the modelled values calculated at each pixel and
C   smooths them spatially with the beam specified in the (output =
C   input) header.  The *input* pixel diameter is actually assumed to
C   be an input gaussian beam instead of a square pixel in order to
C   compute the convolving size.  This doesn't matter since the kernel
C   is properly normalized.  The factors are okay and no approximation
C   has been made.
C   Inputs:
C      M        I      Number of unblanked input pts
C      RESULT   D(M)   Array containing modelled values for each pixel
C      IFLAG    I      Flag indicated whether this is the 1st or last
C                      pass through
C      DATA     R(M)   Input data
C      JBLANK   I(*)   # blanked points before pixel of interest
C      MX       I      Output X dimension
C      MY       I      Output Y dimension
C   Outputs:
C      RESULT   D(M)   Array containing the smoothed modelled values
C                      for each pixel
C      DARRAY   D(*)   (MX,MY,3) arrays for smoothing
C      IRET     I      Error code - 0 = okay
C                                           - anything else = terminate
C   Subprograms called:
C        CUBIT subroutine.......GDECON, GASTPX, KERNEL
C-----------------------------------------------------------------------
      INTEGER   M, IFLAG, MX, MY, JBLANK(*), IRET
      REAL      DATA(*)
      DOUBLE PRECISION RESULT(M), DARRAY(MX,MY,3)
C
      INCLUDE 'CUBSIZ.INC'
      INTEGER   NX, NY, J, JMC, IHOLD, IT, I0, I1, I2, I3, J0, J1, J2,
     *   J3, NX2, NY2, II, JJ, KK
      REAL      DEGRA, AMAJ, AMIN, APA, DMAJ, DMIN, DPA, DX, DY, ARB, X,
     *   CMAJ, CMIN, CPA, BMAJ, BMIN, BPA, XK(25,25)
      INCLUDE   'CUBIT.INC'
      INCLUDE   'CUBDIM.INC'
      INCLUDE   'INCS:DHDR.INC'
      INCLUDE   'INCS:DMSG.INC'
      INCLUDE   'INCS:DCAT.INC'
      INCLUDE   'INCS:DDCH.INC'
      COMMON /LEAST/ IT
      COMMON /JBLK/  IHOLD
      COMMON /SMTH/  NY, NX, NY2, NX2, I1, I2, J1, J2, XK
      DATA DEGRA /57.2957795/
C-----------------------------------------------------------------------
C                                       Initialize
      IF (IT.LE.0) THEN
C                                       Desired beamsize:
C                                       Convert from header values in
C                                       degrees to arcsec and radians +
C                                       pixel increment from degrees to
C                                       radians
         AMAJ = CATR(KRBMJ) * 3600.0
         AMIN = CATR(KRBMN) * 3600.0
         APA  = CATR(KRBPA) / DEGRA
         DX   = -CATR(KRCIC+1)/DEGRA
         DY   = CATR(KRCIC+2)/DEGRA
C                                       Check ra axis sign
         IF (CATR(KRCIC+1).GE.0.0) THEN
            MSGTXT = '**WARNING** RA AXIS HAS WRONG SIGN'
            CALL MSGWRT (8)
            END IF
C                                       "BEAMSIZE"  = pixel size
         BMAJ = ABS (CATR(KRCIC+1)*3600.0)
         BMIN = ABS (CATR(KRCIC+2)*3600.0)
         BPA  = 3.1415926536
         IF (BMAJ.LT.BMIN) THEN
            X = BMAJ
            BMAJ = BMIN
            BMIN = X
            BPA = 0.0
            END IF
C                                       Deconvolve present beam from
C                                       desired beam to get convolution
C                                       size
         CALL GDECON (AMAJ, AMIN, APA, BMAJ, BMIN, BPA, CMAJ, CMIN, CPA)
         IF ((CMAJ.LE.0.0) .OR. (CMIN.LE.0.0)) THEN
            IRET = -1
            MSGTXT = 'OUTPUT BEAM SMALLER THAN PIXEL SIZE'
            GO TO 990
            END IF
C                                       Convert from arcsec,rad, to
C                                       pixels,rad
         CALL GASTPX (AMAJ, AMIN, APA, DMAJ, DMIN, DPA, DX, DY)
C                                       in original SMOTH, everything is
C                                       eventually scaled by the ratios
C                                       of the new to the old beam areas
C                                       This does not apply here since
C                                       the pixel units are Jy/new-beam
         ARB = 1.0
         CALL GASTPX (CMAJ, CMIN, CPA, DMAJ, DMIN, DPA, DX, DY)
         IF (ABS(DMAJ/DMIN-1.0).LE.0.01) DPA = 0.0
C                                       Compute kernel
         CALL KERNEL (XK, NX, NY, ARB, DMAJ, DMIN, DPA, IRET)
         IF (IRET.NE.0) THEN
            IF (IRET.EQ.-100) MSGTXT = 'CONVOLVING FCN TOO SMALL'
            IF (IRET.EQ.100)  MSGTXT = 'CONVOLVING FCN TOO BIG'
            GO TO 990
            END IF
         MSGTXT = 'Spatial smoothing kernel computed'
         CALL MSGWRT (5)
C                                       Compute half size of kernel
         NX2 = NX/2
         NY2 = NY/2
C                                       Lengths of output array
         NXOUT = CATBLK(KINAX+1)
         NYOUT = CATBLK(KINAX+2)
         NVOUT = CATBLK(KINAX)
C                                       Determine start, stop pixel #
         I1 = NX2 + 1
         I2 = NXOUT - NX2
         I0 = I1 - 1
         I3 = I2 + 1
         J1 = NY2 + 1
         J2 = NYOUT - NY2
         J0 = J1 - 1
         J3 = J2 + 1
C                                       Check
         IF ((I1.GT.I2) .OR. (J1.GT.J2)) THEN
            IRET = -1
            MSGTXT = 'OUTPUT WINDOW SMALLER THAN BEAM SIZE'
            GO TO 990
            END IF
         END IF
C                                       Begin loop for convolution
      DO 100 KK = 1,NVOUT
C                                       Insert RESULT into TRESLT
         DO 40 JJ = 1,NYOUT
            DO 30 II = 1,NXOUT
               JMC = KK + ((II-1) + (JJ-1)*NXOUT) * NVOUT
               IF (DATA(JMC).NE.FBLANK) THEN
                  J = JMC - JBLANK(JMC)
                  DARRAY(II,JJ,1) = RESULT(J)
               ELSE
                  DARRAY(II,JJ,1) = 0.0D0
                  END IF
 30           CONTINUE
 40        CONTINUE
C                                       Smooth TRESLT
         CALL SMTH1 (KK, DARRAY, DATA, MX, MY, DARRAY(1,1,3), IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'SMTH1 ERROR'
            GO TO 990
            END IF
C                                       Put TRESLT back into RESULT
         DO 60 JJ = 1,NYOUT
            DO 50 II = 1,NXOUT
               JMC = KK + ((II-1) + (JJ-1)*NXOUT) * NVOUT
               IF (DATA(JMC).NE.FBLANK) THEN
                  J = JMC - JBLANK(JMC)
                  RESULT(J) = DARRAY(II,JJ,1)
C                                       Get rid of high values for last
C                                       pass through of model only if
C                                       there will be no Vel smoothing
                  IF ((RESULT(J).GT.1.0E34) .AND. (RESULT(J).LT.1.0E36)
     *               .AND. (CPARM(1).EQ.1) .AND. (IFLAG.EQ.-1) .AND.
     *               (CPARM(6).EQ.0.0)) RESULT(J) = 0.0
                  END IF
 50            CONTINUE
 60         CONTINUE
C                                       End plane convolution.
 100     CONTINUE
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE SMTH1 (KK, TRESLT, DATA, MX, MY, DARRAY, IRET)
C-----------------------------------------------------------------------
C   SMTH1 does the smoothing over a single plane.
C   Inputs:
C      KK                  I   pixel value of plane (V)
C      TRESLT(NXOUT,NYOUT) D   Array containing unsmoothed input pts
C   Outputs:
C      TRESLT(NXOUT,NYOUT) D   Array containing smoothed output pts
C      IRET                I   Error code - 0=okay
C                                 anything else=terminate
C-----------------------------------------------------------------------
      INCLUDE 'CUBSIZ.INC'
      INTEGER   KK, MX, MY, IRET
      REAL      DATA(*)
      DOUBLE PRECISION TRESLT(MX,MY), DARRAY(MX,MY)
C
      INTEGER   JMC, JM, NX, NY, II, JJ, MJ, LI, NX2, NY2, LL, MM, NT,
     *   I1, I2, J1, J2
      REAL      XK(25,25), X, Y
      INCLUDE 'CUBDIM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /SMTH/ NY, NX, NY2, NX2, I1, I2, J1, J2, XK
C-----------------------------------------------------------------------
      IRET = 0
C                                       Initialize DARRAY for each plane
      DO 20 JJ = 1,NYOUT
         DO 10 II = 1,NXOUT
            DARRAY(II,JJ) = 0.0D0
 10         CONTINUE
 20      CONTINUE
C                                       Start loop over plane
      DO 200 JJ = J1,J2
         DO 195 II = I1,I2
C                                       Index for point of interest
            JMC = KK + ((II-1) + (JJ-1)*NXOUT) * NVOUT
            IF (DATA(JMC).NE.FBLANK) THEN
               X = 0.0
C                                       Start sum over kernel
               MJ = JJ - NY2 - 1
C                                       Keep track of the number of
C                                       times result is 1.0e35
C                                       (ie. bmodel is zero) in NT
               NT = 0
               DO 190 MM = 1,NY
                  MJ = MJ + 1
                  LI = II - NX2 - 1
                  DO 180 LL = 1,NX
                     LI = LI + 1
                     JM = KK + ((LI-1) + (MJ-1)*NXOUT) * NVOUT
C                                       If any pt within kernel
C                                       area is blanked, blank
C                                       the pt of interest
                     IF (DATA(JM).EQ.FBLANK) THEN
                        DARRAY(II,JJ) = FBLANK
                        GO TO 195
                        END IF
C                                       We don't want to convolve a
C                                       value of 1.0e35 so change to
C                                       zero and keep track
                     IF ((TRESLT(LI,MJ).GT.1.0E34) .AND.
     *                  (TRESLT(LI,MJ).LT.1.0E36)) THEN
                        Y = 0
                        NT = NT+1
                     ELSE
                        Y = TRESLT(LI,MJ)
                        END IF
                     X = X + XK(LL,MM) * Y
 180                 CONTINUE
 190              CONTINUE
C                                       Store the final value in
C                                       DARRAY for each plane
               DARRAY(II,JJ) = X

C                                       If every pt within convolving
C                                       kernel was 1.0e35,
C                                       then make the result 1.0e35
               IF (NT.EQ.NY*NX) DARRAY(II,JJ) = 1.0D35
               END IF
 195        CONTINUE
 200     CONTINUE
C                                       After convolving each plane
C                                       put DARRAY back into TRESLT
C                                       Remember there will be more
C                                       blanked values of RESULT
C                                       than before smoothing
      DO 250 JJ = 1,NYOUT
         DO 240 II = 1,NXOUT
            JMC = KK + ((II-1) + (JJ-1)*NXOUT) * NVOUT
C                                       If the value was converted
C                                       to zero BECAUSE of the
C                                       smoothing, ensure that it
C                                       will still be subtracted
C                                       from the data in FCN
            IF (DATA(JMC).NE.FBLANK) THEN
               IF ((TRESLT(II,JJ).NE.0.0) .AND. (DARRAY(II,JJ).EQ.0.0))
     *            THEN
                  TRESLT(II,JJ) = 1.0E35
               ELSE
                  TRESLT(II,JJ) = DARRAY(II,JJ)
                  END IF
               END IF
 240        CONTINUE
 250     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE KERNEL (XK, NX, NY, AREA, DMAJ, DMIN, DPA, ERROR)
C-----------------------------------------------------------------------
C   KERNEL calculates the convolution kernel for SMOTH.
C   Inputs:
C      AREA    R         Scaling factor for kernel
C      DMAJ    R          FWHM major axis of Gaussian
C      DMIN    R          FWHM minor axis of Gaussian
C      DPA     R          Position angle of Gaussian (radians)
C   Outputs:
C      XK      R(25,25)   Kernel
C      NX      I          Length of kernel in X (adj. array dim.)
C      NY      I          Length of kernel in Y (adj. array dim.)
C      ERROR   I          Error code:   0 => OK
C                            100 => Convolving function too big
C                                   for 25x25 kernel
C                           -100 => Convolving function too small
C   EPS contains the criterion for setting the size of the kernel, and
C   for deciding when the 25x25 kernel is too small.  The convolving
C   function is considered too small if the size of the kernel is
C   reduced to 1 in either direction.
C-----------------------------------------------------------------------
      INTEGER   NX, NY
      REAL      XK(25,25), AREA, DMAJ, DMIN, DPA
C
      REAL      X, Y, Z, SP, CP, L1, L2, A, B, TC, BYS, TCY, EPS,
     *   TENEPS, XMI(12), XMA(12), YMI(12), YMA(12), SUM
      INTEGER   NXR, NYR, ERROR, I, J, K, JJ, NXMIN, NXMAX, NYMIN, NYMAX
      DATA EPS /0.01/
C-----------------------------------------------------------------------
C                                       Set constants
      NX = 25
      NY = 25
      TENEPS = 10.0 * EPS
      SP = SIN (DPA)
      CP = COS (DPA)
      L1 = 4.0 * LOG(2.0) / (DMAJ*DMAJ)
      L2 = 4.0 * LOG(2.0) / (DMIN*DMIN)
      TC = 2.0 * SP * CP * (L2-L1)
      SP = SP*SP
      CP = CP*CP
      A = L1*SP + L2*CP
      B = L1*CP + L2*SP
C                                       Fill full kernel (symmetric)
C
      DO 20 J = 1,13
         Y = J - 13
         BYS = B * Y * Y
         TCY = TC * Y
         DO 10 I = 1,25
            X = I - 13
            Z = A*X*X + TCY*X + BYS
            XK(I,J) = 0.0
            IF (Z.LT.70.0) XK(I,J) = EXP (-Z)
            XK(26-I,26-J) = XK(I,J)
 10         CONTINUE
 20      CONTINUE
C                                       Determine size of kernel
      CALL KEREXT (XK, NX, NY, XMI, XMA, YMI, YMA)
      NXMAX = 0
      NXMIN = 0
      NXMAX = 0
      NYMIN = 0
      NYMAX = 0
      DO 110 K = 1,12
         IF (XMI(K).LT.TENEPS) NXMIN = K
         IF (XMA(K).LT.EPS) NXMAX = K
         IF (YMI(K).LT.TENEPS) NYMIN = K
         IF (YMA(K).LT.EPS) NYMAX = K
 110     CONTINUE
      NXR = MIN(NXMIN,NXMAX)
      NYR = MIN(NYMIN,NYMAX)
      ERROR = 0
      IF ((NXR.GE.12) .OR. (NYR.GE.12)) ERROR = -100
      IF ((NXMIN.LE.0) .OR. (NYMIN.LE.0)) ERROR = 100
      IF (ERROR.NE.0) GO TO 999
      NX = NX - 2*NXR
      NY = NY - 2*NYR
C                                       Reduce size of kernel
      SUM = 0.0
      DO 130 J = 1,NY
         JJ = J + NYR
         DO 120 I = 1,NX
            XK(I,J) = XK(I+NXR,JJ)
            SUM = SUM + XK(I,J)
 120        CONTINUE
 130     CONTINUE
C                                 SCALE KERNEL
C                                 the kernel is properly normalized
C                                 AREA=1
C
      SUM = AREA / SUM
      DO 150 J = 1,NY
         DO 140 I = 1,NX
            XK(I,J) = XK(I,J)*SUM
 140        CONTINUE
 150     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE KEREXT (XK, NX, NY, XMI, XMA, YMI, YMA)
C-----------------------------------------------------------------------
C   KEREXT finds the min and max along rows and columns in the kernel
C   Copied from the AIPS task 'SMOTH'
C   Inputs:
C      XK    R(NX,NY)   Kernel
C      NX    I          Size of kernel in X (adj. array dim.)
C      NY    I          Size of kernel in Y (adj. array dim.)
C   Outputs:
C      XMI   R(?)       Minima along columns
C      XMA   R(?)       Maxima along columns
C      YMI   R(?)       Minima along rows
C      YMA   R(?)       Maxima along rows
C-----------------------------------------------------------------------
      INTEGER   NX, NY
      REAL      XK(NX,NY), XMI(*), XMA(*), YMI(*), YMA(*)
C
      INTEGER   NX2, NY2, I, J
      REAL      X, Y, Z
C-----------------------------------------------------------------------
      NX2 = NX/2
      NY2 = NY/2
C                                       First, the columns
      DO 20 I = 1,NX2
         X = 1.0
         Y = 0.0
         DO 10 J = 1,NY
            Z = XK(I,J)
            IF (Z.LT.X) X = Z
            IF (Z.GT.Y) Y = Z
 10         CONTINUE
         XMI(I) = X
         XMA(I) = Y
 20      CONTINUE
C                                       Then, the rows
      DO 40 J = 1,NY2
         X = 1.0
         Y = 0.0
         DO 30 I = 1,NX
            Z = XK(I,J)
            IF (Z.LT.X) X = Z
            IF (Z.GT.Y) Y = Z
 30         CONTINUE
         YMI(J) = X
         YMA(J) = Y
 40      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE GPXTAS (BA1, BB1, BP1, BA2, BB2, BP2, DX, DY)
C-----------------------------------------------------------------------
C   GPXTAS converts a Gaussian with parameters in pixels (cells)
C      - Halfwidths BA1, BB1; position angle BP1 (radians) -
C   to one with parameters in arcseconds
C      - Halfwidths BA2, BB2; position angle BP2 (radians) -
C   DX and DY are the cell sizes in RADIANS.
C   It has been coded by Arnold Rots in September 1980.
C-----------------------------------------------------------------------
      REAL      BA1, BB1, BP1, BA2, BB2, BP2, DX, DY
C
      REAL      T, L1, L2, M1, M2, SP, CP, C, U, V, W, PI, ARSRAD
      INTEGER   IPA, I1000, I500
      DATA PI /3.141592654/, ARSRAD /206264.8062/
      DATA I1000 /1000/
C-----------------------------------------------------------------------
      BP2 = BP1
      I500 = I1000 / 2
      IPA = NINT(BP1 / PI * REAL(I1000))
      IF (MOD(IPA,I1000).EQ.0) THEN
         BA2 = BA1 * DY * ARSRAD
         BB2 = BB1 * DX * ARSRAD
      ELSE IF (MOD(IPA,I500).EQ.0) THEN
         BA2 = BA1 * DX * ARSRAD
         BB2 = BB1 * DY * ARSRAD
      ELSE
         T = DX / DY
         CP = COS (BP1)
         SP = SIN (BP1)
         L1 = 1.0 / (BA1 * BA1)
         L2 = 1.0 / (BB1 * BB1)
         C = T * SP * CP * (L2-L1)
         SP = SP * SP
         CP = CP * CP
         T = T * T
C                                       THE REAL WORK
         U = (SP + T*CP) * L1
         V = (CP + T*SP) * L2
         W = SQRT ((U-V) * (U-V) + 4.0*SP*CP*(1.0-T)*(1.0-T)*L1*L2)
         M1 = 0.5 * (U + V - W)
         M2 = 0.5 * (U + V + W)
         BA2 = SQRT (1.0 / M1) * DX * ARSRAD
         BB2 = SQRT (1.0 / M2) * DX * ARSRAD
         BP2 = BP1
         M1 = SP * L1 + CP * L2 - M1
         IF ((C.NE.0.0) .OR. (M1.NE.0.0)) BP2 = ATAN2 (C, M1)
         IF (BP2.LT.0.0) BP2 = BP2 + PI
         END IF
C
 999  RETURN
      END
      SUBROUTINE GDECON (BA1, BB1, BP1, BA2, BB2, BP2, BA3, BB3, BP3)
C-----------------------------------------------------------------------
C   GDECON deconvolves one gaussian (e.g. observed; parameters BA1,BB1,
C   BP1) with another (e.g. beam; parameters BA2,BB2,BP2).  The result
C   is a new gaussian (e.g. true source; parameters BA3,BB3,BP3).
C   It has been coded by Arnold Rots in September 1980; copied from the
C   AIPS task 'SMOTH'
C-----------------------------------------------------------------------
      REAL   BA1, BB1, BP1, BA2, BB2, BP2, BA3, BB3, BP3
C
      REAL   D0, D1, D2, A, B
C-----------------------------------------------------------------------
      D0 = BA1*BA1 - BB1*BB1
      D2 = BA2*BA2 - BB2*BB2
      D1 = MAX (0.0, D0*D0+D2*D2-2.0*D0*D2*COS(2.0*(BP1-BP2)))
      D1 = SQRT (D1)
      BP3 = 0.0
      A = D0 * SIN (2.0*BP1) - D2 * SIN (2.0*BP2)
      B = D0 * COS (2.0*BP1) - D2 * COS (2.0*BP2)
      IF ((A.NE.0.0) .OR. (B.NE.0.0)) BP3 = 0.5 * ATAN2 (A, B)
      A = BA1*BA1 + BB1*BB1 - BA2*BA2 - BB2*BB2
      BA3 = MAX (0.0, 0.5*(A+D1))
      BA3 = SQRT (BA3)
      BB3 = MAX (0.0, 0.5*(A-D1))
      BB3 = SQRT (BB3)
      IF (BP3.LT.0.0) BP3 = BP3 + 3.141592654
C
 999  RETURN
      END
      SUBROUTINE GASTPX (BA1, BB1, BP1, BA2, BB2, BP2, DX, DY)
C---------------------------------------------------------------
C   Converts Gaussian in arc seconds to one in cells
C   Inputs:
C      BA1   R   Input Gaussian: Major axis in arc sec
C      BB1   R                   Minor axis in arc sec
C      BP1   R                   Position angle in radians
C      DX    R   X pixel separation in radians
C      DY    R   Y pixel separation in radians
C   Outputs
C      BA2   R   Output Gaussian: Major axis in cells
C      BB2   R                    Minor axis in cells
C      BP2   R                    Position angle in radians
C   It has been coded by Arnold Rots in September 1980; copied
C   from the AIPS task 'SMOTH'
C-----------------------------------------------------------------------
      REAL       BA1, BB1, BP1, BA2, BB2, BP2, DX, DY
C
      REAL       RASA
      DATA RASA /206264.8062/
C-----------------------------------------------------------------------
      BA2 = BA1 / (RASA*DX)
      BB2 = BB1 / (RASA*DX)
      BP2 = BP1
      CALL GPXTAS (BA2, BB2, BP2, BA2, BB2, BP2, DY, DX)
C   NOTE : THE ARGUMENTS IN THIS PARAMETER LIST ARE CORRECT!!
      BA2 = BA2 / (DY*RASA)
      BB2 = BB2 / (DY*RASA)
      RETURN
      END
      SUBROUTINE VSMTH (LROW, DATIN, DATOUT, IFLAG, IRET)
C-----------------------------------------------------------------------
C   VSMTH convolves an input row with a convolving look up table
C   established in common.
C   Inputs:
C      DATIN    D(*)    Input row, magic value blanked.
C   Values from commons:
C      FBLANK   R         Value of blanked pixel.
C      CPARM    R(10)     Input adverb array.
C      TAB      R(5000)   Convolution look-up table
C      SUPRAD   R         Conv. function support radius (old cells)
C      IXDIV    I         # divisions / old cell in look-up table
C      IFLAG    I         flag to indicate whether this is the last
C                         pass through of (all) the data (not just the
C                         row)
C   Output:
C      DATOUT   D(*)      Output row.
C      IRET     I         Return code   0 => OK
C                            >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   LROW, IFLAG, IRET
      DOUBLE PRECISION DATIN(LROW), DATOUT(LROW)
C
      INTEGER   TABSIZ, IXDIV, N, I, L, J, J1, J2, NT, IT
      REAL      CONST, DELVEL, TAB(5000), WCUTOF, FX, Y, W, S, XJ, X,
     *   XDIV, SUPRAD, WIDTH
      DOUBLE PRECISION TEMP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'CUBIT.INC'
      COMMON /LEAST/ IT
      COMMON /PARM1/ CONST, DELVEL, WIDTH
      COMMON /VPARM1/ TAB, WCUTOF, SUPRAD, IXDIV
      DATA TABSIZ /5000/
C-----------------------------------------------------------------------
      IRET = 0
C                                      If tables, etc, have already
C                                      been set up, don't do it again
      IF ((IT.LE.0) .AND. ((WCUTOF.GE.0.015) .OR. (WCUTOF.LE.0.005)))
     *   THEN
C                                       Convolution: parms & tables
C                                       Set window over which the
C                                       gaussian has meaning to 3 X
C                                       the HWHM of the gaussian
         SUPRAD = 3.0 * WIDTH / 2.0
C
         IXDIV = (TABSIZ - 1) / (SUPRAD + 0.1)
         IF (IXDIV.GT.500) IXDIV = 500
C                                       WCUTOF = .99 demands a true
C                                       convolution.  .01 smooths over
C                                       blanked pixels
C                                     Set it for smoothing over blanks
         WCUTOF = 0.01
         CALL RFILL (TABSIZ, 0.0, TAB)
         N = 1 + SUPRAD*IXDIV + 0.99
         FX = 2.0 / WIDTH
         Y = 1.0 / IXDIV
         TAB(1) = 1.0
C                                       Compute look-up table
C                                       for gaussian
         FX = -LOG(2.0) * FX * FX
         DO 10 I = 2,N
            X = Y * (I - 1)
            TAB(I) = EXP(FX * X * X)
 10      CONTINUE
C                                       Normalize integral
         W = -TAB(1)
         DO 15 I = 1,N,IXDIV
            W = W + 2.0 * TAB(I)
 15         CONTINUE
         DO 20 I = 1,N
            TAB(I) = TAB(I) / W
 20         CONTINUE
         MSGTXT = 'Lookup table for velocity smoothing computed'
         CALL MSGWRT (5)
         END IF
C                                        Start the convolution
      XJ = 0.0
      XDIV = IXDIV
      DO 100 I = 1,LROW
         XJ = XJ + 1.0
         J1 = XJ - SUPRAD + 0.9999
         J2 = XJ + SUPRAD
         J1 = MAX (1, J1)
         J2 = MIN (LROW, J2)
         S = 0.0
         W = 0.0
C                                    keep track of how many times
C                                    result is 1e35
         NT = 0
C                **NB** DO NOT automatically skip zeroed points
C                because after velocity smoothing there could
C                be some emission at forbidden velocities
C            But skip zeroed points if there's no velocity smoothing
         IF ((DATIN(I).EQ.0.0) .AND. (CPARM(6).EQ.0.0)) THEN
            DATOUT(I) = 0.0
         ELSE
C                                    if input=blank, output=blank
            IF (DATIN(I).NE.FBLANK) THEN
               DO 30 J = J1,J2
                  TEMP = DATIN(J)
                  IF (TEMP.EQ.FBLANK) THEN
                     NT = NT + 1
                  ELSE
                     IF ((TEMP.GT.1.0E34) .AND. (TEMP.LT.1.0E36)) TEMP
     *                  = 0.0
                     IF (TEMP.EQ.0.0) NT = NT + 1
                     L = ABS (XJ-J) * XDIV + 1.5
                     S = TEMP * TAB(L) + S
                     W = TAB(L) + W
                     END IF
 30               CONTINUE
               END IF
C                                        blank the pts which fall
C                                        below the cutoff
            DATOUT(I) = FBLANK
            IF (W.GT.WCUTOF) DATOUT(I) = S / W
C                                        *All* pts in kernel=zero or
C                                        blank => output to 1e35
C                                        to be subtracted in FCN
            IF (NT.EQ.(J2-J1+1)) DATOUT(I)=1.0E35
C                                        Any newly zero'd pts should be
C                                        set high for subtraction later
            IF (DATOUT(I).EQ.0.0) DATOUT(I)=1.0E35
C                                        If it's the last pass through,
C                                        zero the high points
            IF ((DATOUT(I).GT.1.0E34) .AND. (DATOUT(I).LT.1.0E36) .AND.
     *         (IFLAG.EQ.-1) .AND. (CPARM(1).EQ.1)) DATOUT(I) = 0.0
C                                         Velocity smoothing decreases
C                                         I and spreads it out over a
C                                         larger V. However, since the
C                                         density, n, is calculated for
C                                         the presmoothed data, there is
C                                         no need to compensate here.
C                                         ..so the next lines are
C                                         commented out.
C            IF ((DATOUT(I).GT.1.0E34 .AND. DATOUT(I).LT.1.0E36)
C     *          .OR. DATOUT(I).EQ.FBLANK) GO TO 30
C                                         The factor 1.06892 is the
C                                         difference between the inte-
C                                         gral of a gaussian over its
C                                         FWHM and the integral of a
C                                         gaussian from -infty to +infty
C            IF (WIDTH.GT.1.0) DATOUT(I) = DATOUT(I) * WIDTH * 1.06892
C            IF (WIDTH.LE.1.0 .AND. WIDTH.GE.0.83) DATOUT(I)
C     *            = DATOUT(I) * 1.06892
            END IF
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE LSTSQ1 (M, N, X, FVEC, FJAC, LDFJAC, TOL, INFO, IPVT,
     *   DATA, JBLANK, MX, MY, DARRAY)
C-----------------------------------------------------------------------
C     The purpose of LSTSQ1 is to minimize the sum of the squares of
C     M nonlinear functions in N variables by a modification of the
C     Levenberg-Marquardt algorithm which users minimum storage.
C     This is done by using the more general least-squares solver
C     LSTSQ. The user must provide a subroutine which calculates the
C     functions and the rows of Jacobian.
C
C     Subprograms called:
C        User-supplied ...... FCN
C                      ...... SMTH1
C        Minpack-supplied ... LSTSQ (LMSTR modified by user)
C
C     Argonne National Laboratory. Minpack project. March 1980.
C     Burton S. Garbow, Kenneth E. Hillstrom, Jorge J. More
C   Functions:
C      INPUTS:  FCN     The user-supplied subroutine which calculates
C                       the functions and the rows of the Jacobian.
C               SMTH1   The user supplied subroutine which smooths over
C                       an RA/DEC plane of the cube
C         SUBROUTINE FCN (M, N, X, FVEC, FJROW1, FJROW2, IFLAG)
C         SUBROUTINE SMTH1 (KK, ARRAYP, IRET)
C
C         INTEGER M,N, IFLAG
C         DOUBLE PRECISION X(N),FVEC(M),FJROW(N)
C         ----------
C         IF IFLAG = 1 CALCULATE THE FUNCTIONS AT X AND
C         RETURN THIS VECTOR IN FVEC.
C         IF IFLAG <> 1 CALCULATE THE (IFLAG - 1) ST ROW OF THE
C         JACOBIAN AT X AND RETURN THIS VECTOR IN FJROW.
C         ----------
C         RETURN
C         END
C
C         THE VALUE OF IFLAG SHOULD NOT BE CHANGED BY FCN UNLESS
C         THE USER WANTS TO TERMINATE EXECUTION OF LMSTR1.
C         IN THIS CASE SET IFLAG TO A NEGATIVE INTEGER.
C**********************************************************************
C           M       I The number of functions (adj. array dim.).
C
C           N       I The number of variables. N must not exceed M
C                   (adj. array dim.).
C
C           X       D(N)   contains an initial estimate of the
C                   solution vector.
C
C           TOL     D   termination occurs when the algorithm
C                   estimates either that the relative
C                   error in the sum of squares is at most TOL or that
C                   the relative error between X and the solution is at
C                   most TOL.
C
C  OUTPUTS: X       D(N)   contains the final estimate of the
C                   solution vector.
C
C           FVEC    D(M)   contains the functions evaluated at
C                   the output X.
C
C           FJAC    D(N,N)   The upper N by N submatrix of FJAC
C                   contains an upper triangular matrix R
C                   such that
C
C                    T     T           T
C                   P *(JAC *JAC)*P = R *R,
C
C                   where P is a permutation matrix and JAC is the final
C                   calculated Jacobian. Column J of P is column IPVT(J)
C                   (see below) of the identity matrix. The lower
C                   triangular part of FJAC contains information
C                   generated during the computation of R.
C
C          LDFJAC   I variable not less than N which specifies the
C                   leading dimension of the array FJAC (adj. array
C                   dim.)
C
C          INFO     I   If the user has terminated execution, INFO is
C                   set to the (negative) value of IFLAG. SEE
C                   description of FCN. otherwise, INFO is set
C                   as follows:
C
C                   INFO = 0  Improper input parameters.
C
C                   INFO = 1  Algorithm estimates that the relative
C                   error in the sum of squares is at most TOL.
C
C                   INFO = 2  Algorithm estimates that the relative
C                   error between X and the solution is at most TOL.
C
C                   INFO = 3  Conditions for INFO = 1 and INFO = 2
C                   both hold.
C
C                   INFO = 4  FVEC is orthogonal to the columns of the
C                   Jacobian to machine precision.
C
C                   INFO = 5  Number of calls to FCN with IFLAG = 1 HAS
C                   reached 100*(N+1).
C
C                   INFO = 6  TOL is too small. No further reduction in
C                   the sum of squares is possible.
C
C                   INFO = 7  TOL is too small. no further improvement
C                   in the approximate solution X is possible.
C
C          IPVT     I(N)   Defines a permutation matrix P such that
C                   JAC*P = Q*R,
C                   where JAC is the final calculated Jacobian, Q is
C                   orthogonal (not stored), and R is upper triangular.
C                   Column J of P is column IPVT(J) of the identity
C                   matrix.
C-----------------------------------------------------------------------
      INTEGER   M, N, LDFJAC, INFO, IPVT(N), MX, MY, JBLANK(*)
      REAL      DATA(*)
      DOUBLE PRECISION X(N), FVEC(M), FJAC(LDFJAC,N), TOL,
     *   DARRAY(MX,MY,3)
C
      INCLUDE 'CUBSIZ.INC'
      LONGINT   LPWA, IPWA, LPHA
      INTEGER   MAXFEV, MODE, NFEV, NJEV, NPRINT, NWRDWA, IERR, NWRDHA
      DOUBLE PRECISION FACTOR, FTOL, GTOL, XTOL, ZERO, WA1(MAXPRM),
     *   WA2(MAXPRM), WA3(MAXPRM), WA4(MAXPRM), WA5(MAXPRM), WA(2)
      REAL      HARRAY(2), RWA(4)
      EQUIVALENCE (WA, RWA)
      INCLUDE 'CUBDIM.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA FACTOR, ZERO /1.0D2, 0.0D0/
C-----------------------------------------------------------------------
      INFO = 0
C                                       Check the input parameters for
C                                       for errors.
      IF ((N.LE.0) .OR. (M.LT.N) .OR. (LDFJAC.LT.N) .OR. (TOL.LT.ZERO))
     *   THEN
         MSGTXT = 'LSTSQ1 INPUT PARAMETER ERROR'
         CALL MSGWRT (8)
         WRITE (MSGTXT,1000) N, M, LDFJAC, TOL
         CALL MSGWRT (8)
C                                       okay - do it
      ELSE
C                                       Get scratch memory
         NWRDWA = (2 * M + 10) / 1024 + 1
         CALL ZMEMRY ('GET ', 'LSTSQ1', NWRDWA, RWA, IPWA, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, NWRDWA
            CALL MSGWRT (8)
            GO TO 999
            END IF
         IF (IPWA.GE.0) THEN
            LPWA = 1 + (IPWA+1)/2
         ELSE
            LPWA = 1 + IPWA / 2
            END IF
         NWRDHA = (NXOUT * NYOUT * 30) / 1024 + 1
         CALL ZMEMRY ('GET ', 'LSTSQ1', NWRDHA, HARRAY, LPHA, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, NWRDWA
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       Call LSTSQ.
         MAXFEV = 100*(N + 1)
         FTOL = TOL
         XTOL = TOL
         GTOL = ZERO
         MODE = 1
         NPRINT = 0
         CALL LSTSQ (M, N, X, FVEC, FJAC, LDFJAC, FTOL, XTOL, GTOL,
     *      MAXFEV, WA1, MODE, FACTOR, NPRINT, INFO, NFEV, NJEV, IPVT,
     *      WA2, WA3, WA4, WA5, WA(LPWA), NXOUT, NYOUT, HARRAY(1+LPHA),
     *      HARRAY(1+LPHA+NWRDHA/3), DATA, JBLANK, DARRAY)
         IF (INFO.EQ.8) INFO = 4
C                                       free memory
         CALL ZMEMRY ('FREE', 'LSTSQ1', NWRDWA, RWA, IPWA, IERR)
         CALL ZMEMRY ('FREE', 'LSTSQ1', NWRDHA, HARRAY, LPHA, IERR)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('  N, M, LDFJAC, TOL =',I3,I10,I4,1PE10.3)
 1010 FORMAT ('LSTSQ1: ERROR',I3,' GETTING',I10,' WORDS OF MEMORY')
      END
      SUBROUTINE LSTSQ (M, N, X, FVEC, FJAC, LDFJAC, FTOL, XTOL, GTOL,
     *   MAXFEV, DIAG, MODE, FACTOR, NPRINT, INFO, NFEV, NJEV, IPVT,
     *   QTF, WA1, WA2, WA3, WA4, MX, MY, HARAYP, HARAYM, DATA, JBLANK,
     *   DARRAY)
C-----------------------------------------------------------------------
C   The purpose of LSTSQ is to minimize the sum of the squares of
C   M nonlinear functions in N variables by a modification of
C   the Levenberg-Marquardt algorithm which uses minimum storage.
C   The user must provide a subroutine which calculates the functions
C   and the rows of the Jacobian.
C   June/91 -- added the criterion that if all derivatives are zero,
C     the residual value should be as well.
C   Subprograms called
C       User-supplied ...... FCN
C                     ...... SMTH1
C       Minpack-supplied ... DPMPAR,ENORM,LMPAR,QRFAC
C       FORTRAN-supplied ... DABS,DMAX1,DMIN1,DSQRT,MOD
C   Argonne National Laboratory. Minpack project. March 1980.
C   Burton S. Garbow, Kenneth E. Hillstrom, Jorge J. More
C   Inputs:
C      M        I      The number of functions (adj. array dim.).
C      N        I      The number of variables. N must not exceed M
C      X        D(N)   Contains an initial estimate of solution vector.
C      FTOL     D      Termination occurs when both the actual and
C                      predicted relative reductions in the sum of
C                      squares are at most FTOL.  Therefore, FTOL
C                      measures the relative error desired in the sum
C                      of squares.
C      XTOL     D      Termination occurs when the relative error
C                      between two consecutive iterates is at most XTOL
C                      Therefore, XTOL measures the relative error
C                      desired in the approximate solution.
C      GTOL     D      Termination occurs when the cosine of the angle
C                      between FVEC and any column of the Jacobian is at
C                      most GTOL in absolute value. Therefore, GTOL
C                      measures the orthogonality desired between the
C                      function vector and the columns of the Jacobian.
C      MAXFEV   I      Termination occurs when the number of calls to
C                      FCN with IFLAG = 1 has reached MAXFEV.
C      DIAG     D(N)   If MODE = 1 (see below), DIAG is internally set.
C                      If MODE = 2, DIAG must contain positive entries
C                      that serve as multiplicative scale factors for
C                      the variables.
C      MODE     I      If MODE = 1, the variables will be scaled
C                      internally.  If MODE = 2, the scaling is
C                      specified by the input DIAG. Other values of mode
C                      are equivalent to MODE = 1.
C      FACTOR   D      Used in determining the initial step bound.  This
C                      bound is set to the product of FACTOR and the
C                      Euclidean norm of DIAG*X if nonzero, or else to
C                      FACTOR itself. In most cases FACTOR should lie in
C                      the interval (.1,100.0).  100.0 is a generally
C                      recommended value.
C      NPRINT   I      Enables controlled printing of iterates if it is
C                      positive. In this case, FCN is called with IFLAG
C                      = 0 at the beginning of the first iteration and
C                      every NPRINT iterations thereafter and
C                      immediately prior to return, with X, FVEC, and
C                      FJAC available for printing. FVEC and FJAC should
C                      not be altered. If NPRINT is not positive, no
C                      special calls of FCN with IFLAG = 0 are made.
C      LDFJAC   I      Variable not less than N which specifies the
C                      leading dimension of the array FJAC
C      DATA     R(*)   Input data (NVOUT, NXOUT, NYOUT)
C      JBLANK   I(*)   # blanked points before pixel of interest,
C                      alligned with DATA
C   Outputs:
C      X        D(N)   Contains the final estimate of solution vector.
C      FVEC     D(M)   Contains the functions evaluated at the output X
C      FJAC     D(N,N) The N by N matrix FJAC contains an upper
C                      triangular matrix R with diagonal elements of
C                      nonincreasing magnitude such that
C
C                          T     T           T
C                         P *(JAC *JAC)*P = R *R,
C
C                      where P is a permutation matrix and JAC is the
C                      final calculated Jacobian. Column J of P is
C                      column IPVT(J) (see below) of the identity
C                      matrix. The lower trapezoidal part of FJAC
C                      contains information generated during the
C                      computation of R.
C      INFO     I      If the user has terminated execution, INFO is
C                      set to the (negative) value of IFLAG. SEE
C                      description of FCN. otherwise, INFO is set as:
C                      = 0  Improper input parameters.
C                      = 1  Algorithm estimates that the relative
C                           error in the sum of squares is at most FTOL
C                      = 2  Algorithm estimates that the relative error
C                           between X and the solution is at most XTOL.
C                      = 3  Conditions for INFO = 1 and INFO = 2 both
C                           hold.
C                      = 4  The cosine of the angle between FVEC and
C                           any column of the Jacobian is at most GTOL
C                           in absolute value.
C                      = 5  Number of calls to FCN with IFLAG = 1 has
C                           reached MAXFEV.
C                      = 6  FTOL is too small. No further reduction in
C                           the sum of squares is possible.
C                      = 7  XTOL is too small. No further improvement
C                           in the approximate solution X is possible.
C                      = 8  GTOL is too small. FVEC is orthogonal to
C                           the columns of the Jacobian to machine
C                           precision.
C      NFEV     I      Number of calls to FCN with IFLAG = 1.
C      NJEV     I      The number of calls to FCN with IFLAG = 2.
C      IPVT     I(N)   Defines a permutation matrix P such that
C                          JAC*P = Q*R,
C                      where JAC is the final calculated Jacobian, Q is
C                      orthogonal (not stored), and R is upper
C                      triangular with diagonal elements of
C                      nonincreasing magnitude.  Column J of P is column
C                      IPVT(J) of the identity matrix.
C
C      QTF      D(N)   contains the first N elements of the vector
C                      (Q transpose)*FVEC.
C      WA1      D(N)   work array.
C      WA2      D(N)   work array.
C      WA3      D(N)   work array.
C      WA4      D(M)   work array.
C      DARRAY   D(*)   work array (NXOUT, NYOUT, 3)
C      HARAYP   R(*)   work array (NXOUT, NYOUT, Nmax)
C      HARAYM   R(*)   work array (NXOUT, NYOUT, Nmax)
C-----------------------------------------------------------------------
      INCLUDE 'CUBSIZ.INC'
      INTEGER   M, N, LDFJAC, MAXFEV, MODE, NPRINT, INFO, NFEV, NJEV,
     *   IPVT(N), MX, MY, JBLANK(*)
      DOUBLE PRECISION X(N), FVEC(M), FJAC(LDFJAC,N), FTOL, XTOL, GTOL,
     *   DIAG(N), FACTOR, QTF(N), WA1(N), WA2(N), WA3(N), WA4(M),
     *   DARRAY(MX,MY,3)
      REAL      HARAYP(MX,MY,MAXPRM), HARAYM(MX,MY,MAXPRM), DATA(*)
     *
C
      INCLUDE 'CUBDIM.INC'
      INTEGER   IJ, I, IFLAG, JMC, J0, IHOLD, ITER, J, L, IRET, KK, NNN,
     *   JJ, II
      LOGICAL   SING, T
      DOUBLE PRECISION ACTRED, DELTA, DIRDER, EPSMCH, FNORM, FNORM1,
     *   GNORM, ONE, PAR, PNORM, PRERED, P1, P5, P25, P75, P0001, RATIO,
     *   SUM, TEMP, TEMP1, TEMP2, XNORM, ZERO
      DOUBLE PRECISION    DPMPAR, ENORM
      DOUBLE PRECISION    DERP(MAXPRM), DERM(MAXPRM)
      INCLUDE 'INCS:DDCH.INC'
      COMMON /JBLK/ IHOLD
      DATA T /.TRUE./
      DATA ONE, P1, P5, P25, P75, P0001, ZERO
     *   /1.0D0, 1.0D-1, 5.0D-1, 2.5D-1, 7.5D-1, 1.0D-4, 0.0D0/
C-----------------------------------------------------------------------
C                                       EPSMCH is the machine precision
      EPSMCH = DPMPAR(1)
C
      INFO = 0
      IFLAG = 0
      NFEV = 0
      NJEV = 0
C                                       Check the input parameters for
C                                       errors.
      IF ((N.LE.0) .OR. (M.LT.N) .OR. (LDFJAC.LT.N) .OR. (FTOL.LT.ZERO)
     *   .OR. (XTOL.LT.ZERO) .OR. (GTOL.LT.ZERO) .OR. (MAXFEV.LE.0) .OR.
     *   (FACTOR.LE.ZERO)) GO TO 980
      IF (MODE.EQ.2) THEN
         DO 10 J = 1,N
            IF (DIAG(J).LE.ZERO) GO TO 980
 10         CONTINUE
         END IF
C                                       Evaluate the function at the
C                                       starting point and calculate
C                                       its norm.
      IFLAG = 1
C                                       Nothing happens with DERP or
C                                       DERM on this call
      CALL FCN (M, N, X, FVEC, DERP, DERM, IFLAG, DATA, JBLANK, MX, MY,
     *   DARRAY)
      IF (IFLAG.EQ.-100) GO TO 980
      NFEV = 1
      IF (IFLAG.LT.0) GO TO 980
      FNORM = ENORM (M, FVEC)
C                                       Initialize Levenberg-Marquardt
C                                       parameter and iteration counter
      PAR = ZERO
      ITER = 1
C                                       Beginning of the outer loop.
 30   CONTINUE
C                                       If requested, call FCN to
C                                       enable printing of iterates.
         IF (NPRINT.GT.0) THEN
            IFLAG = 0
            IF (MOD(ITER-1,NPRINT).EQ.0) CALL FCN (M, N, X, FVEC,
     *         DERP,DERM, IFLAG, DATA, JBLANK, MX, MY, DARRAY)
            IF (IFLAG.LT.0) GO TO 980
            END IF
C                                       Compute the QR factorization
C                                       of the Jacobian matrix
C                                       calculated one row at a time,
C                                       while simultaneously
C                                       forming (Q transpose)*FVEC
C                                       and storing the first
C                                       N components in QTF.
         DO 60 J = 1,N
            QTF(J) = ZERO
            DO 50 I = 1,N
               FJAC(I,J) = ZERO
 50            CONTINUE
 60         CONTINUE
         IFLAG = 2
C*******************************************sectioning off new part
C                                      Start loop over cube
         DO 800 KK = 1,NVOUT
C                                      Compute model over plane
            DO 400 JJ = 1,NYOUT
               DO 390 II = 1,NXOUT
                  JMC = KK + ((II-1) + (JJ-1)*NXOUT) * NVOUT
                  IF (DATA(JMC).NE.FBLANK) THEN
                     J0 = JMC - JBLANK(JMC)
                     IFLAG = J0 + 1
C                                      Return N 'plus values' in
C                                      DERP and N 'minus values'
C                                      in DERM for a single pt.
C                                      FVEC shouldn't change from
C                                      before.
                     IHOLD = JMC
                     IF (IHOLD.EQ.0) IFLAG = -100
                     CALL FCN (M, N, X, FVEC, DERP, DERM, IFLAG, DATA,
     *                  JBLANK, MX, MY, DARRAY)
                     IF (IFLAG.EQ.-100) GO TO 980
C                                      Store the values in an array.
                     DO 380 NNN=1,N
                        HARAYP(II,JJ,NNN) = DERP(NNN)
                        HARAYM(II,JJ,NNN) = DERM(NNN)
 380                    CONTINUE
                     END IF
 390              CONTINUE
 400           CONTINUE
C                                      Start loop for smoothing
            DO 475 NNN = 1,N
               DO 430 JJ = 1,NYOUT
                  DO 425 II = 1,NXOUT
                     DARRAY(II,JJ,1) = HARAYP(II,JJ,NNN)
                     DARRAY(II,JJ,2) = HARAYM(II,JJ,NNN)
 425                 CONTINUE
 430              CONTINUE
C                                       Smooth over the plane and
C                                       for a single parameter
               CALL SMTH1 (KK, DARRAY(1,1,1), DATA, MX, MY,
     *            DARRAY(1,1,3), IRET)
C                                       CHECK FOR ERROR CONDITION
               CALL SMTH1 (KK, DARRAY(1,1,2), DATA, MX, MY,
     *            DARRAY(1,1,3), IRET)
C                                       CHECK FOR ERROR CONDITION
C                                       Compute the derivatives
C                                       for each pt in the plane
C                                       and a single parameter
               DO 450 JJ = 1,NYOUT
                  DO 445 II = 1,NXOUT
                     JMC = KK + ((II-1) + (JJ-1)*NXOUT) * NVOUT
                     J0 = JMC - JBLANK(JMC)
                     IF (DATA(JMC).NE.FBLANK) THEN
C                                      Blanks could have been
C                                      returned in ARRAY so change
C                                      them to zeros.
                        IF (DARRAY(II,JJ,1).EQ.FBLANK) DARRAY(II,JJ,1) =
     *                     0.0D0
                        IF (DARRAY(II,JJ,2).EQ.FBLANK) DARRAY(II,JJ,2) =
     *                     0.0D0
C                                      High values could have been
C                                      returned so change them
C                                      to zeros.
                        IF ((DARRAY(II,JJ,1).GT.1.0E34) .AND.
     *                     (DARRAY(II,JJ,1).LT.1.0E36)) DARRAY(II,JJ,1)
     *                     = 0.0D0
                        IF ((DARRAY(II,JJ,2).GT.1.0E34) .AND.
     *                     (DARRAY(II,JJ,2).LT.1.0E36)) DARRAY(II,JJ,2)
     *                     = 0.0D0
C                                      Put computed derivative
C                                      into HARAYP
                        HARAYP(II,JJ,NNN) = DARRAY(II,JJ,1) -
     *                     DARRAY(II,JJ,2)
C                                      If either value was zero
C                                      set the deriv to zero
                        IF ((DARRAY(II,JJ,1).EQ.0.0D0) .OR.
     *                     (DARRAY(II,JJ,2).EQ.0.0D0)) HARAYP(II,JJ,NNN)
     *                     = 0.0
                        END IF
 445                 CONTINUE
 450              CONTINUE
 475           CONTINUE
C                                      Now all derivatives have been
C                                      calculated for every pt in
C                                      a single plane.
C                                      We now want to enter ALL
C                                      derivatives into RWUPDT
C                                      pt by pt.
            DO 500 JJ = 1,NYOUT
               DO 495 II = 1,NXOUT
                  JMC = KK + ((II-1) + (JJ-1)*NXOUT) * NVOUT
                  IF (DATA(JMC).NE.FBLANK) THEN
                     J0 = JMC - JBLANK(JMC)
                     DO 480 NNN = 1,N
                        WA3(NNN) = HARAYP(II,JJ,NNN)
 480                    CONTINUE
C                                  Make the derivative zero
C                                  if the residual (FVEC) is zero
C                                  Don't let the residual
C                                  have a value if all derivatives
C                                  are zero
                     TEMP = 0.0
                     DO 485 NNN = 1,N
                        IF (WA3(NNN).NE.0.0) THEN
                           IF (FVEC(J0).EQ.0.0) THEN
                              WA3(NNN)=0.0
                           ELSE
                              TEMP=FVEC(J0)
                              GO TO 490
                              END IF
                           END IF
 485                    CONTINUE
 490                 CALL RWUPDT (N, FJAC, LDFJAC, WA3, QTF, TEMP, WA1,
     *                  WA2)
                     END IF
 495              CONTINUE
 500           CONTINUE
C                                      Finished.  Now go back and
C                                      start on next plane
 800        CONTINUE
C*******************************************sectioning off new part
         NJEV = NJEV + 1
C                                       If the Jacobian is rank
C                                       deficient, call QRFAC to
C                                       reorder its columns and update
C                                       the components of QTF.
         SING = .FALSE.
         DO 80 J = 1,N
            IF (FJAC(J,J).EQ.ZERO) SING = .TRUE.
            IPVT(J) = J
            IJ = J
            WA2(J) = ENORM (IJ, FJAC(1,J))
 80         CONTINUE
         IF (SING) THEN
            CALL QRFAC (N, N, FJAC, LDFJAC, T, IPVT, N, WA1, WA2, WA3)
            DO 120 J = 1,N
               IF (FJAC(J,J).NE.ZERO) THEN
                  SUM = ZERO
                  DO 90 I = J,N
                     SUM = SUM + FJAC(I,J) * QTF(I)
 90                  CONTINUE
                  TEMP = -SUM / FJAC(J,J)
                  DO 100 I = J,N
                     QTF(I) = QTF(I) + FJAC(I,J) * TEMP
 100                 CONTINUE
                  END IF
               FJAC(J,J) = WA1(J)
 120           CONTINUE
            END IF
C                                       On the first iteration and if
C                                       mode is 1, scale according
C                                       to the norms of the columns
C                                       of the initial Jacobian.
C
         IF (ITER.EQ.1) THEN
            IF (MODE.NE.2) THEN
               DO 140 J = 1,N
                  DIAG(J) = WA2(J)
                  IF (WA2(J).EQ.ZERO) DIAG(J) = ONE
 140              CONTINUE
               END IF
C                                       On the first iteration,
C                                       calculate the norm of the scaled
C                                       X and initialize the step bound
C                                       DELTA.
            DO 160 J = 1,N
               WA3(J) = DIAG(J) * X(J)
 160           CONTINUE
            XNORM = ENORM (N, WA3)
            DELTA = FACTOR * XNORM
            IF (DELTA.EQ.ZERO) DELTA = FACTOR
            END IF
C                                       Compute the norm of the scaled
C                                       gradient.
         GNORM = ZERO
         IF (FNORM.NE.ZERO) THEN
            DO 200 J = 1,N
               L = IPVT(J)
               IF (WA2(L).NE.ZERO) THEN
                  SUM = ZERO
                  DO 180 I = 1,J
                     SUM = SUM + FJAC(I,J) * (QTF(I)/FNORM)
 180                 CONTINUE
                  GNORM = MAX (GNORM, ABS (SUM/WA2(L)))
                  END IF
 200           CONTINUE
            END IF
C                                       Test for convergence of the
C                                       gradient norm.
         IF (GNORM.LE.GTOL) INFO = 4
         IF (INFO.NE.0) GO TO 980
C                                       Rescale if necessary.
         IF (MODE.NE.2) THEN
            DO 220 J = 1,N
               DIAG(J) = MAX (DIAG(J), WA2(J))
 220           CONTINUE
            END IF
C                                       Beginning of the inner loop.
 240     CONTINUE
C                                       Determine the Levenberg-
C                                       Marquardt parameter.
            CALL LMPAR (N, FJAC, LDFJAC, IPVT, DIAG, QTF, DELTA, PAR,
     *         WA1, WA2, WA3, WA4)
C                                       Store the direction P and
C                                       X + P. Calculate the norm of P.
            DO 250 J = 1,N
               WA1(J) = -WA1(J)
               WA2(J) = X(J) + WA1(J)
               WA3(J) = DIAG(J)*WA1(J)
 250           CONTINUE
            PNORM = ENORM(N,WA3)
C                                       On the first iteration, adjust
C                                       the initial step bound.
            IF (ITER.EQ.1) DELTA = MIN (DELTA, PNORM)
C                                       Evaluate the function at X + P
C                                       and calculate its norm.
            IFLAG = 1
C                                       There should be no change to
C                                       DERP, DERM on this call
            CALL FCN (M, N, WA2, WA4, DERP, DERM, IFLAG, DATA, JBLANK,
     *         MX, MY, DARRAY)
            NFEV = NFEV + 1
            IF (IFLAG.LT.0) GO TO 980
            FNORM1 = ENORM (M, WA4)
C                                       Compute the scaled actual
C                                       reduction.
            ACTRED = -ONE
            IF (P1*FNORM1.LT.FNORM) ACTRED = ONE - (FNORM1/FNORM)**2
C                                       Compute the scaled predicted
C                                       reduction and the scaled
C                                       directional derivative.
            DO 270 J = 1,N
               WA3(J) = ZERO
               L = IPVT(J)
               TEMP = WA1(L)
               DO 260 I = 1,J
                  WA3(I) = WA3(I) + FJAC(I,J) * TEMP
 260              CONTINUE
 270           CONTINUE
            TEMP1 = ENORM (N, WA3) / FNORM
            TEMP2 = (SQRT(PAR) * PNORM) / FNORM
            PRERED = TEMP1**2 + TEMP2**2 / P5
            DIRDER = -(TEMP1**2 + TEMP2**2)
C                                       Compute the ratio of the actual
C                                       to the predicted reduction.
            RATIO = ZERO
            IF (PRERED.NE.ZERO) RATIO = ACTRED / PRERED
C                                       Update the step bound.
            IF (RATIO.LE.P25) THEN
               IF (ACTRED.GE.ZERO) TEMP = P5
               IF (ACTRED.LT.ZERO)
     *            TEMP = P5 * DIRDER / (DIRDER + P5*ACTRED)
               IF ((P1*FNORM1.GE.FNORM) .OR. (TEMP.LT.P1)) TEMP = P1
               DELTA = TEMP * MIN (DELTA, PNORM/P1)
               PAR = PAR / TEMP
            ELSE IF ((PAR.EQ.ZERO) .OR. (RATIO.GE.P75)) THEN
               DELTA = PNORM / P5
               PAR = P5 * PAR
               END IF
C                                       Test for successful iteration.
            IF (RATIO.GE.P0001) THEN
C                                       Successful iteration. update X,
C                                       FVEC, and their norms.
               DO 310 J = 1,N
                  X(J) = WA2(J)
                  WA2(J) = DIAG(J) * X(J)
 310              CONTINUE
               DO 320 I = 1,M
                  FVEC(I) = WA4(I)
 320              CONTINUE
               XNORM = ENORM (N, WA2)
               FNORM = FNORM1
               ITER = ITER + 1
               END IF
C                                       Tests for convergence.
            IF ((ABS(ACTRED).LE.FTOL) .AND. (PRERED.LE.FTOL) .AND.
     *         (P5*RATIO.LE.ONE)) INFO = 1
            IF (DELTA.LE.XTOL*XNORM) INFO = 2
            IF ((ABS(ACTRED).LE.FTOL) .AND. (PRERED.LE.FTOL) .AND.
     *         (P5*RATIO.LE.ONE) .AND. (INFO.EQ.2)) INFO = 3
            IF (INFO.NE.0) GO TO 980
C                                       Tests for termination and
C                                       stringent tolerances.
            IF (NFEV.GE.MAXFEV) INFO = 5
            IF ((ABS(ACTRED).LE.EPSMCH) .AND. (PRERED.LE.EPSMCH)
     *         .AND. (P5*RATIO.LE.ONE)) INFO = 6
            IF (DELTA.LE.EPSMCH*XNORM) INFO = 7
            IF (GNORM.LE.EPSMCH) INFO = 8
            IF (INFO.NE.0) GO TO 980
C                                       End of the inner loop.  Repeat
C                                       if iteration unsuccessful.
            IF (RATIO.LT.P0001) GO TO 240
C                                       End of the outer loop.
         GO TO 30
C                                       Termination, either normal or
C                                       user imposed.
 980  IF (IFLAG.LT.0) INFO = IFLAG
      IFLAG = 0
      IF (NPRINT.GT.0) CALL FCN (M, N, X, FVEC, DERP, DERM, IFLAG, DATA,
     *   JBLANK, MX, MY, DARRAY)
C
 999  RETURN
      END

      SUBROUTINE DETRAT (TIME, RA, DEC, X, Y, Z, FREQ, FR)
C-----------------------------------------------------------------------
C! Determines natural fringe rate of an antenna
C# Calibration VLBI Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to determine the natural fringe rate for an antenna
C   Input:
C      TIME   R   UT (days) at which rate is to be determined
C      RA     D   RA (rads) at epoch
C      DEC    D   Dec (rads) at epoch
C      X      D   ntenna x-coord (m)
C      Y      D   antenna y-coord (m)
C      Z      D   antenna z-coord (m)
C      FREQ   D   reference frequency (Hz)
C   Output:
C      FR     D   natural fringe rate (Hz)
C   Converted from left-hand "VLBI" antenna system 21 Feb 2015
C-----------------------------------------------------------------------
      REAL     TIME
      DOUBLE PRECISION RA, DEC, X, Y, Z, FREQ, FR
C
      INCLUDE 'INCS:PSTD.INC'
      DOUBLE PRECISION SHA, BHA, CDEC, SDEC, CSHA, SSHA, SX, SY, SZ,
     *   U, V, DEL, OMEG, GSEC, GST
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA GSEC /1.0027375D0/
C-----------------------------------------------------------------------
      OMEG = TWOPI / (24.D0 * 3600.D0)
      GST = GSTIAT + ((TIME * TWOPI) * GSEC)
      GST = MOD (GST, TWOPI)
C                                       Hour angle of source wrt x axis
      SHA = GST - RA
C                                       Hour angle of baseline wrt x
C                                       axis
      BHA = ATAN2(Y,X)
C                                       Calculate needed cos and sin
C                                       values
      CDEC = DCOS(DEC)
      SDEC = DSIN(DEC)
      CSHA = DCOS(SHA)
      SSHA = DSIN(SHA)
C                                       Source vector coordinates
      SZ = SDEC
      SX = CDEC * CSHA
      SY = CDEC * SSHA
C                                       Calculate u and v
      U = (X * SY + Y * SX) / CDEC
      V = Z * CDEC - (SX * X - SY * Y) * SDEC / CDEC
C                                       Calculate delay and fringe rate
      DEL = (X*SX + Y*SY + Z*SZ) / VELITE
      FR = U * OMEG * CDEC * FREQ / VELITE
C
      RETURN
      END

      SUBROUTINE TABGP (OPCODE, BUFFER, GPROW, GPCOLS, TIME, PRN, AZ,
     *   ELEV, TECTAU, TECPHS, IRET)
C-----------------------------------------------------------------------
C! Does I/O to GP table opened by GPINI
C# EXT-util UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1996, 2007, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to GPS delay (GP) extention tables. Usually used after
C   setup by GPINI.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'READ' = read entry from table.
C                        'WRIT' = write entry in table.
C                        'CLOS' = close file, flush on write
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open. Should have been returned by
C                        GPINI or TABINI.
C      GPROW    I        Next entry number to read or write.
C      GPCOLS   I(6)     The column pointer array in order,
C                        TIME, PRN, AZ, ELEV, TECTAU, TECPHS
C   Input/output: (written to or read from baseline file)
C      TIME    D        Time of measurement (days)
C      PRN     I        Satellite PRN (an id number)
C      AZ      R        Azimuth of satellite (degrees)
C      ELEV    R        Elevation of satellite
C      TECTAU  R        TEC along the line of sight derived from delay
C                       (electrons/m^2)
C      TECPHS  R        TEC along the line of sight derived from phase
C                       (electrons/m^2)
C   Output:
C      GPROW    I      Next solution number.
C      IRET     I      Error code, 0=>OK
C                                  < 0 => row flagged
C                                  > 0 => TABIO error
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   BUFFER(*), GPROW, GPCOLS(6), PRN, IRET
      DOUBLE PRECISION TIME
      REAL      AZ, ELEV, TECTAU, TECPHS
C
      INTEGER   RECI(7)
      REAL      RECORD(7)
      DOUBLE PRECISION RECD(1)
C
      INCLUDE 'INCS:DMSG.INC'
C
      EQUIVALENCE (RECD, RECORD, RECI)
C-----------------------------------------------------------------------
C                                       Check opcode:
      IF ((OPCODE.NE.'CLOS') .AND. (OPCODE.NE.'READ') .AND.
     *   (OPCODE.NE.'WRIT')) THEN
         MSGTXT = 'TABGP: UNRECOGNIZED OPCODE ' // OPCODE
         CALL MSGWRT (9)
         IRET = 99
         GO TO 999
         END IF
C                                       Close
      IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, GPROW, RECORD, BUFFER, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET
            CALL MSGWRT (9)
            END IF
         GO TO 999
         END IF
C                                       If write fill RECORD
      IF (OPCODE.NE.'READ') THEN
         RECD(GPCOLS(1))   = TIME
         RECI(GPCOLS(2))   = PRN
         RECORD(GPCOLS(3)) = AZ
         RECORD(GPCOLS(4)) = ELEV
         RECORD(GPCOLS(5)) = TECTAU
         RECORD(GPCOLS(6)) = TECPHS
         END IF
C                                       Process record.
      CALL TABIO (OPCODE, 0, GPROW, RECORD, BUFFER, IRET)
      GPROW = GPROW + 1
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (9)
C                                       If READ pick data from RECORD.
      ELSE IF (OPCODE.EQ.'READ') THEN
         TIME   = RECD(GPCOLS(1))
         PRN    = RECI(GPCOLS(2))
         AZ     = RECORD(GPCOLS(3))
         ELEV   = RECORD(GPCOLS(4))
         TECTAU = RECORD(GPCOLS(5))
         TECPHS = RECORD(GPCOLS(6))
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TABGP: TABIO ERROR ',I3)
      END

LOCAL INCLUDE 'VBCAL.INC'
C                                       Local include for VBCAL
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS, JBUFSZ, INCSI,
     *   INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI, LRECO, NRPRMI,
     *   NRPRMO, CATOLD(256), ILOCWT
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, HISCRD(20)*64
      REAL   XSIN, XDISIN, XSOUT, XDISO, APARM(10), BPARM(90), DOWEI,
     *   XCENT, BUFF1(UVBFSS), BUFF2(UVBFSS), DIFPIX
      DOUBLE PRECISION UVSCAL
      LOGICAL   ISCOMP
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
      COMMON /INPTS/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XCLAOU,
     *   XSOUT, XDISO, APARM, BPARM, DOWEI, XCENT
      COMMON /VBCALP/ UVSCAL, CATOLD, SEQIN, SEQOUT, DISKIN, DISKO,
     *   INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI, LRECO,
     *   NRPRMI, NRPRMO, ISCOMP, NUMHIS, ILOCWT, DIFPIX
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, HISCRD
      INCLUDE 'INCS:DCAT.INC'
LOCAL END
      PROGRAM VBCAL
C-----------------------------------------------------------------------
C! Applies antenna based amplitude gain factors.
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000-2001, 2008-2009, 2012, 2014-2015,
C;  Copyright (C) 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   VBCAL applies antenna based amplitude calibration factors
C   to a uv data set.  Data to be calibrated can be selected by
C   antenna, IF, array and time range. Up to 90 antennas can be
C   calibrated at once.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input UV data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      APARM(10)      APARM         Control info
C                                   1-4 => start day, hr, min, sec.
C                                   5-8 => End day, hr, min, sec.
C                                          0's => all.
C                                   9   => first ant. no + (array-1)*100
C                                       0=all first subarray,
C                                       .lt. 0=> all subarrays.
C                                   10  => 0 for RCP, 1 for LCP.,2=both.
C      BPARM(90)      BPARM         1-90 => antenna cal. factor.
C                                        baseline factor=SQRT(fac1*fac2)
C                                        0 => 1.0
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'VBCAL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'VBCAL '/
C-----------------------------------------------------------------------
C                                       Initialize I/O
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      TSKNAM = PRGM
C                                       Get input parameters and
C                                       create output file if nec.
      IRET = 0
      CALL VBCLIN (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL VBCLUV (IRET)
      IF (IRET.EQ.0) CALL VBCLHI
C                                       Close down
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE VBCLIN (JERR)
C-----------------------------------------------------------------------
C   VBCLIN gets input parameters for VBCAL and creates an output file
C   if necessary.
C   Inputs:
C   See prologue comments in VBCAL for more details.
C-----------------------------------------------------------------------
      CHARACTER STAT*4, BLANK*6, UTYPE*2
      INTEGER   JERR, OLDCNO, IROUND, NPARM, IERR, INCX, I
      INCLUDE 'VBCAL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK /' '/
C-----------------------------------------------------------------------
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 116
      CALL GTPARM (TSKNAM, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         JERR = 8
         RQUICK = .FALSE.
         GO TO 990
         END IF
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      DO 20 I = 1,90
         IF (BPARM(I).LE.0.0) BPARM(I) = 1.0
 20      CONTINUE
C                                       Restart AIPS.
      IERR = 0
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (6)
         END IF
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1015) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         JERR = 5
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         JERR = 5
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Find weight and scale.
      IF (ISCOMP) THEN
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       center frequencies
      IF (JLOCF.LT.0) XCENT = -1.
      IF (XCENT.GE.0.0) THEN
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
         UVSCAL = CATD(KDCRV+JLOCF) / FREQ
      ELSE
         UVSCAL = 1.0D0
         DIFPIX = 0.0
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1060) IERR
            JERR = 8
            GO TO 990
         ELSE
C                                        Update existing CATBLK
            FRW(NCFILE+1) = 2
            CALL CATIO ('WRIT', DISKO, CCNO, CATBLK, 'WRIT', BUFF1,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1070) IERR
               CALL MSGWRT (6)
               END IF
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      UTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('VBCLIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' RESTARTING AIPS')
 1015 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1020 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1060 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1070 FORMAT ('VBCLIN: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE VBCLUV (IRET)
C-----------------------------------------------------------------------
C   VBCLUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Output:
C      IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER PHNAME*48
      INTEGER   IRET, INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO,
     *   ILENBU, KBIND, NIOLIM, IBIND, I, IA1, IA2, NIOUT, VO, BO,
     *   NUMVIS, XCOUNT, NCORI, NCORO, NCOPY
      LOGICAL   T, F
      INCLUDE 'VBCAL.INC'
      REAL      CBUFF(UVBFSS), RESULT(UVBFSS)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA VO, BO /0,1/
      DATA LUNI, LUNO /16,17/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, PHNAME, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, PHNAME, T, F, F, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, PHNAME, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, PHNAME, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
C                                       LRECO = length of output rec.
      LRECO = LREC
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
      NCORI = (LRECI - NRPRMI) / CATOLD(KINAX)
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       Loop Read vis. record.
 50   CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1050) IRET
         GO TO 990
      ELSE IF (INIO.GT.0) THEN
         IPTRI = IBIND
         DO 90 I = 1,INIO
            BUFF1(IPTRI+ILOCU) = BUFF1(IPTRI+ILOCU) * UVSCAL
            BUFF1(IPTRI+ILOCV) = BUFF1(IPTRI+ILOCV) * UVSCAL
            BUFF1(IPTRI+ILOCW) = BUFF1(IPTRI+ILOCW) * UVSCAL
            IF (ILOCB.GE.0) THEN
               IA1 = BUFF1(IPTRI+ILOCB) / 256. + 0.1
               IA2 = BUFF1(IPTRI+ILOCB) - IA1*256. + 0.1
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               END IF
            NUMVIS = NUMVIS + 1
C                                      Call user routine.
            IF (ISCOMP) THEN
C                                       Compressed data.
               CALL ZUVXPN (NCORI, BUFF1(IPTRI+NRPRMI),
     *            BUFF1(IPTRI+ILOCWT), CBUFF)
               CALL CALIB (NUMVIS, BUFF1(IPTRI+ILOCT), IA1, IA2, CBUFF,
     *            BUFF1(IPTRI), RESULT, IRET)
            ELSE
               CALL CALIB (NUMVIS, BUFF1(IPTRI+ILOCT), IA1, IA2,
     *            BUFF1(IPTRI+NRPARM), BUFF1(IPTRI), RESULT, IRET)
               END IF
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1060) IRET
               GO TO 990
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1
C                                       Copy to output.
               CALL RCOPY (NRPRMO, BUFF1(IPTRI), BUFF2(IPTRO))
               IF (ISCOMP) THEN
C                                       Compressed
                  CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *               BUFF2(IPTRO+NRPRMO))
               ELSE
                  CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
                  END IF
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               END IF
            IPTRI = IPTRI+LREC
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1070) IRET
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 90         CONTINUE
         GO TO 50
         END IF
C                                       Final call to CALIB.
      NUMVIS = -1
      CALL CALIB (NUMVIS, BUFF2(IPTRO+ILOCT), IA1, IA2,
     *   BUFF2(IPTRO+NRPARM), BUFF2(IPTRO), RESULT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1060) IRET
         GO TO 990
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1070) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VBCLUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('VBCLUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('VBCLUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1050 FORMAT ('VBCLUV: ERROR',I3,' READING VIS FILE')
 1060 FORMAT ('VBCLUV: CALIB ERROR',I3)
 1070 FORMAT ('VBCLUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE VBCLHI
C-----------------------------------------------------------------------
C   VBCLHI copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP(1)*2, HILINE*72, LABEL*8
      INTEGER   LUN1, LUN2, IBUFF(512), NONOT, IERR, I
      LOGICAL   T
      INCLUDE 'VBCAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (IBUFF,BUFF2)
      DATA LUN1, LUN2 /27,28/
      DATA  T /.TRUE./
      DATA NONOT, NOTTYP /0,'  '/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 20
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                      Add any user supplied history.
      IF (NUMHIS.GT.0) THEN
         WRITE (LABEL,1010) TSKNAM
         DO 15 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 20
 15         CONTINUE
         END IF
C
 20   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO,
     *   FCNO(2), FCNO(1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1020)
         CALL MSGWRT (6)
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (DISKO, FCNO(1), DIFPIX, BUFF1, BUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'VBCLHI: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST', BUFF1,
     *   IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VBCLHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,' /')
 1020 FORMAT ('VBCLHI: ERROR COPYING TABLES')
      END
      SUBROUTINE CALIB (NUMVIS, T, IA1, IA2, VIS, RPARM, RESULT, IRET)
C-----------------------------------------------------------------------
C  CALIB does antenna based amplitude calibration using antenna
C  gain factors passed in BPARM.
C
C  Inputs:
C  NUMVIS     I    Visibility number, -1 => final call, no data
C                  passed but allows any operations to be completed.
C                  Data sent back will be wirtten to output file.
C  T          R    Time in days since 0 IAT on the first day for which
C                  there is data.
C  IA1        I    First antenna number
C  IA2        I    Second antenna number
C  RPARM(*)   I    Random parameter array which includes U,V,W etc
C                  but also any other random parameters.
C  VIS(3,*)   R    Visibilities in order real, imaginary, weight (Jy)
C
C  Inputs from COMMON
C  APARM(10)  R    Control info. See VBCAL comments for details.
C  BPARM(90)  R    Antenna calibration factors.
C  NRPARM     I    # random parameters.
C  NCOR       I    # correlators
C  CATBLK(256)I    Catalog header record. See [DOC]HEADER for details
C
C  Output:
C  RPARM      R    Modified random parameter array. NB U,V,W,
C                  time and baseline should not be modified in RPARM
C  VIS        R    Visibilities
C  IRET       I    Return code  -1 => don't write
C                                0 => OK
C                               >0 => error, terminate.
C
C  Output in COMMON
C  NUMHIS     I    # history entries (max. 10)
C  HISCRD(16,NUMHIS) R   History records
C  CATBLK     I    Catalog header block
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER CHRL(3)*2
      INTEGER   NUMVIS, IA1, IA2, IRET, NS, NIF, NF, INDEXI, INDEXO,
     *   IAFRST, IP1(4), IP2(4), IRL, JRL, IARR, I, NFREQ, ISADD, JARR,
     *   IV, JP1, JP2, JIF, JF, JS
      REAL      T, RPARM(*), VIS(3,*), TFIRST, TLAST, TIME,
     *   CALIF(2,MAXANT), CALWT(2,MAXANT), FACTOR, TEMP, RESULT(3,*)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'VBCAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      SAVE CALIF, IARR, IAFRST, TFIRST, TLAST, IRL, JRL, NFREQ, ISADD,
     *   NS, NIF, NF, CALWT
      DATA IP1 /1,2,1,2/
      DATA IP2 /1,2,2,1/
      DATA CHRL /'R ','L ','RL'/
C-----------------------------------------------------------------------
      IRET = 0
C                                        Construct table.
      IF (NUMVIS.EQ.1) THEN
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
         IF (APARM(9).LT.0.0) THEN
            IARR = 0
            IAFRST = 1
         ELSE
            IARR = APARM(9)*0.01 + 1.01
            IAFRST = APARM(9) - (IARR-1)*100. + 0.01
            IF (IAFRST.LE.0) IAFRST = 1
            END IF
         TFIRST = APARM(1) + APARM(2)/24. + APARM(3)/(24.*60.) +
     *      APARM(4)/(24.*3600.)
         TLAST = APARM(5) + APARM(6)/24. + APARM(7)/(24.*60.) +
     *      APARM(8)/(24.*3600.)
         IF (TLAST.LE.TFIRST) APARM(5) = 300.
         IF (TLAST.LE.TFIRST) TLAST = 300.
         IRL = APARM(10) + 1.01
         IF (IRL.LE.0) IRL = 1
         IF (IRL.GT.2) IRL = 2
         JRL = IRL
         IF (APARM(10).GT.1.9) JRL = 3 - IRL
         CALL RFILL (2*MAXANT, 1.0, CALIF)
         CALL RFILL (2*MAXANT, 1.0, CALWT)
         IF (APARM(9).LE.0.0) THEN
            IF (BPARM(1).LE.0.0) BPARM(1) = 1.0
            TEMP = SQRT (BPARM(1))
            DO 10 I = 1,MAXANT
               CALIF(IRL,I) = TEMP
               CALIF(JRL,I) = TEMP
               CALWT(IRL,I) = 1.0 / BPARM(1)
               CALWT(JRL,I) = 1.0 / BPARM(1)
 10            CONTINUE
         ELSE
            DO 20 I = 1,90
               IF (BPARM(I).GT.0.0) THEN
                  CALIF(IRL,IAFRST+I-1) = SQRT (BPARM(I))
                  CALIF(JRL,IAFRST+I-1) = SQRT (BPARM(I))
                  CALWT(IRL,IAFRST+I-1) = 1.0 / BPARM(I)
                  CALWT(JRL,IAFRST+I-1) = 1.0 / BPARM(I)
                  END IF
 20            CONTINUE
            END IF
         IF (DOWEI.LE.0.0) CALL RFILL (2*MAXANT, 1.0, CALWT)
         NFREQ = CATBLK(KINAX+JLOCF)
         ISADD = ABS (ICOR0) - 1
         END IF
C                                        Process record.
      IF (NUMVIS.GE.1) THEN
C                                        Determine array.
         IF (ILOCB.GE.0) THEN
            JARR = RPARM(ILOCB+1) + 0.1
            JARR = 100. * (RPARM(ILOCB+1) - JARR) + 1.5
         ELSE
            JARR = RPARM(ILOCSA+1) + 0.1
            END IF
         IF ((JARR.NE.IARR) .AND. (IARR.GT.0)) GO TO 999
         TIME = T - 5. * (JARR - 1)
         IF ((TIME.LT.TFIRST).OR.(TIME.GT.TLAST)) GO TO 999
C                                        Loop thru frequency.
         DO 50 JIF = 1,NIF
            DO 40 JF = 1,NF
               DO 30 JS = 1,NS
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *               (JS-1) * INCSO + 1
                  JP1 = IP1(JS+ISADD)
                  JP2 = IP2(JS+ISADD)
                  FACTOR = CALIF(JP1,IA1) * CALIF(JP2,IA2)
                  RESULT(1,INDEXO) = VIS(1,INDEXI) * FACTOR
                  RESULT(2,INDEXO) = VIS(2,INDEXI) * FACTOR
                  FACTOR = CALWT(JP1,IA1) * CALWT(JP2,IA2)
                  RESULT(3,IV) = VIS(3,INDEXI) * FACTOR
 30               CONTINUE
 40            CONTINUE
 50         CONTINUE
C                                         Write history.
      ELSE
         WRITE (HISCRD(1),2000) (APARM(I),I=1,8)
         IF (IRL.NE.JRL) IRL = 3
         WRITE (HISCRD(2),2001) IARR, IAFRST, CHRL(IRL)
C                                       All antenna calibration.
         IF (APARM(9).LE.0.0) THEN
            WRITE (HISCRD(3),2004) BPARM(1)
            NUMHIS = 3
         ELSE
            WRITE (HISCRD(3),2002) (BPARM(I),I=1,5)
            WRITE (HISCRD(4),2003) (BPARM(I),I=6,10)
            WRITE (HISCRD(5),2002) (BPARM(I),I=11,15)
            WRITE (HISCRD(6),2003) (BPARM(I),I=16,20)
            WRITE (HISCRD(7),2002) (BPARM(I),I=21,25)
            WRITE (HISCRD(8),2003) (BPARM(I),I=26,30)
            WRITE (HISCRD(9),2002) (BPARM(I),I=31,35)
            WRITE (HISCRD(10),2003) (BPARM(I),I=36,40)
            WRITE (HISCRD(11),2002) (BPARM(I),I=41,45)
            WRITE (HISCRD(12),2003) (BPARM(I),I=46,50)
            WRITE (HISCRD(13),2002) (BPARM(I),I=51,55)
            WRITE (HISCRD(14),2003) (BPARM(I),I=56,60)
            WRITE (HISCRD(15),2002) (BPARM(I),I=61,65)
            WRITE (HISCRD(16),2003) (BPARM(I),I=66,70)
            WRITE (HISCRD(17),2002) (BPARM(I),I=71,75)
            WRITE (HISCRD(18),2003) (BPARM(I),I=76,80)
            WRITE (HISCRD(19),2002) (BPARM(I),I=81,85)
            WRITE (HISCRD(20),2003) (BPARM(I),I=86,90)
            NUMHIS = 20
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 2000 FORMAT ('/ Timerange ',4F5.0,' to ',4F5.0)
 2001 FORMAT ('/ Array=',I3,' First ant.=',I3,' Polarization=',1A2)
 2002 FORMAT ('BPARM=',5(F10.5,','))
 2003 FORMAT (6X,5(F10.5,','))
 2004 FORMAT ('/ All antennas multiplied by ',F10.5)
      END

      SUBROUTINE VEC2OE (POS, VEL, SEMIMA, ECCEN, INCLIN, RAANOD,
     *                   APERIG, MANMLY, IRET)
C-----------------------------------------------------------------------
C! Convert position and velocity vectors to orbital elements
C# Util Orbits
C-----------------------------------------------------------------------
C;  Copyright (C) 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Convert a Cartesian position and velocity vector for a satellite in
C   a bound Earth orbit to a set of Keplerian elements referenced to the
C   same inertial frame.  The coordinate axes should form a right handed
C   set with axis 1 defined by RA = 0, Dec = 0 and with axis 3 defined
C   by the North celestial pole.
C
C   Inputs:
C      POS       D(3)       Position vector (m)
C      VEL       D(3)       Velocity vector (m s**-1)
C
C   Outputs:
C      SEMIMA    D          Semimajor axis (m)
C      ECCEN     D          Eccentricity
C      INCLIN    D          Inclination (radians)
C      RAANOD    D          Right ascension of ascending node (radians)
C      APERIG    D          Argument of perigee (radians)
C      MANMLY    D          Mean anomaly (radians)
C      IRET      I          Status: 0 implies elements are valid
C                                   1 implies orbit is hyperbolic or
C                                             parabolic
C                                 999 implies a logic error
C
C   References:
C     "Orbital Motion", A.E. Roy, Institute of Physics Press, 1988
C     (Chapter 4)
C-----------------------------------------------------------------------
      DOUBLE PRECISION POS(3), VEL(3), SEMIMA, ECCEN, INCLIN, RAANOD,
     *                 APERIG, MANMLY
      INTEGER          IRET
C
C     Local variables
C
C     V2        The square of the magnitude of the velocity (m**2 s**-2)
C     R         The length of the radius vector (m)
C     H         The angular momentum vector
C     C         Orbital energy (Joules)
C     WF        Sum of argument of perigee and true anomaly (omega + f)
C     SINWF     Sine of WF
C     COSWF     Cosine of WF
C     F         True anomaly
C     E         Eccentric anomaly
C
      DOUBLE PRECISION V2, R, H(3), P, C, WF, SINWF, COSWF, F, E
C
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PEARTH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      V2 = VEL(1) ** 2 + VEL(2) ** 2 + VEL(3) ** 2
      R = SQRT (POS(1) ** 2 + POS(2) ** 2 + POS(3) ** 2)
      H(1) = POS(2) * VEL(3) - POS(3) * VEL(2)
      H(2) = POS(3) * VEL(1) - POS(1) * VEL(3)
      H(3) = POS(1) * VEL(2) - POS(2) * VEL(1)
      P = (H(1) ** 2 + H(2) ** 2 + H(3) ** 2) / EMU
      C = 0.5D0 * V2 - EMU / R
C                                       Energy negative for a bound
C                                       orbit.
      IF (C .LT. 0.0D0) THEN
         SEMIMA = 1.0D0 / (2.0D0 / R - V2 / EMU)
         CALL CHECK ('VEC2OE', 1, ((P / SEMIMA) .LE. 1.0D0), IRET)
         IF (IRET .NE. 0) GO TO 999
         ECCEN = SQRT (1.0D0 - P / SEMIMA)
         INCLIN = ACOS (H(3) / SQRT (H(1) ** 2 + H(2) ** 2 + H(3) ** 2))
         IF (H(3) .GE. 0.0D0) THEN
            RAANOD = ATAN2 (H(1), -H(2))
         ELSE
            RAANOD = ATAN2 (-H(1), H(2))
         END IF
C
C        Normalize to the range 0 to 2 pi:
C
         IF (RAANOD .LT. 0.0D0) THEN
            RAANOD = RAANOD + TWOPI
         END IF
C
         IF (INCLIN .EQ. 0.0D0) THEN
            SINWF = POS(2) * COS (RAANOD) - POS(1) * SIN (RAANOD)
         ELSE
            SINWF = POS(3) / SIN (INCLIN)
         END IF
         COSWF = POS(1) * COS (RAANOD) + POS(2) * SIN (RAANOD)
         WF = ATAN2 (SINWF, COSWF)
         IF (ECCEN .EQ. 0.0) THEN
C                                       Argument of perigee is arbitrary
C                                       for a circular orbit.
            APERIG = 0.0D0
            MANMLY = WF
         ELSE
            E = ACOS ((1.0D0 - R / SEMIMA) / ECCEN)
            F = ACOS (((H(1) ** 2 + H(2) ** 2 + H(3) ** 2) / (EMU * R)
     *                - 1.0D0) / ECCEN)
C
C           Remove ambiguities using the constraint that the cosine
C           of the angle between the velocity vector and the radius
C           vector has the same sign as the sine of the eccentric
C           anomaly:
C
            IF ((POS(1) * VEL(1) + POS(2) * VEL(2) + POS(3) * VEL(3))
     *          .LT. 0.0D0) THEN
               E = TWOPI - E
               F = TWOPI - F
            END IF
            APERIG = WF - F
            MANMLY = E - ECCEN * SIN (E)
         END IF
         IRET = 0
      ELSE
         MSGTXT = 'VEC2OE: VECTORS SPECIFY UNBOUND ORBIT'
         CALL MSGWRT (7)
      END IF
C
  999 RETURN
      END

      SUBROUTINE TABINI (OPCODE, PTYP, VOL, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
C-----------------------------------------------------------------------
C! create/open a table extension file
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2000, 2007, 2011, 2018, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TABINI creates/opens a table extension file.  If a file is created,
C   it is cataloged by a call to CATIO which saves the updated CATBLK.
C   Input:
C      OPCODE   C*4       Operation code, 'READ' => read only,
C                                         'WRIT' => read/write
C      PTYP     I         Physical extension type (eg. 'CC')
C      VOL      I         Disk volume number
C      CNO      I         Catalog slot number
C      CATBLK   I(256)    Catalog block of cataloged file.
C      LUN      I         Logical unit number to use.
C   In/out:
C      VER      I         Version number: (<= 0 => write a new one,
C                         read the latest one), returns one used.
C      NKEY     I         Maximum number of keyword/value pairs
C                         input: used in create, checked on write old
C                         (0 => any, <= actual ok); output: actual
C      NREC     I         Number of logical rec. for create/extend
C                         if 0 on write, reset to 100.
C      NCOL     I         Number of logical columns (does not include
C                         selection column).  Input: used in create,
C                         checked on write old (0=>any, <= actual ok);
C                         output: actual
C      DATP     I(128,2)  DATP(*,1) address pointers (output only)
C                         DATP(*,2) column data type codes. Input:
C                         used in create only; output: actual.
C      BUFFER   I(512)    Work buffer: only 512 now needed
C   Output:
C      IERR     I         Return error code. 0 => OK
C                                        -1 => OK, created new file
C                                         1 => bad input.
C                                         2 => could not find or open
C                                         3 => I/O problem.
C                                         4 => create problem.
C                                         5 => not a table file
C   Usage notes:
C   For sequential access, TABINI leaves pointers for TABIO such that,
C   if IRNO <= 0, reads will begin at the start of the file and writes
C   will begin after the last previous record.  Cataloged file should
C   be marked 'WRIT' if the file is to be created.
C
C   Header record:
C   Each extension file using this system must have the first physical
C   (512 bytes) record containing necessary information. The full table
C   file format is described in Going AIPS.  The user must read this
C   section to understand fully how to use such files.  The header
C   record contains the following:
C
C  I   word(s)          Description
C  1              Number 256-word records now in file
C  2
C  3              Max number rows allowed in current file
C  4
C  5              Number rows (logical records) now in file
C  6
C  7              Number of bytes/value (2 for TA files)
C  8              Number values / logical (# Is / row for TA)
C  9              > 0 => number rows / physical record
C                 < 0 => number physical records / row
C 10              Number logical columns / row
C 11 - 16         Creation date: ZDATE(11), ZTIME(14)
C 17 - 28     H   Physical file name (set on each TABINI call)
C 29 - 30     H   Creation task name
C 31
C 32              Disk number
C 33 - 38         Last access date: ZDATE(33), ZTIME(36)
C 39 - 40     H   Last access task name
C 42              Number logical records to extend file if needed
C 43              Sort order: logical column # of primary sorting
C 44              Sort order: logical column # of secondary sorting
C                      0 => unknown, < 0 => descending order
C 45              Disk record number for column data pointers (2)
C 46              Disk record number for row selection strings (3)
C 47              Disk record number for 1st record of titles (5)
C 48              Disk record number for 1st record of units
C 49              Disk record number for 1st record of keywords
C 50              Disk record number for 1st record of table data
C 51              DATPTR (row selection column)
C 52              Maximum number of keyword/value pairs allowed
C 53              Current number of keyword/value pairs in file
C 54 - 56         "*AIPS TABLE*" packed string to verify that table.
C 57 - 59
C 60              If 1 then then table cannot be written as FITS ASCII
C 61              Number of selection strings now in file
C 62              Next available R   address for a selection string
C 63              First R   address of selection string 1
C 64              First R   address of selection string 2
C 65              First R   address of selection string 3
C 66              First R   address of selection string 4
C 67              First R   address of selection string 5
C 68              First R   address of selection string 6
C 69              First R   address of selection string 7
C 70              First R   address of selection string 8
C********** for TABIO / TABINI use only **********
C 71              IOP : 1 => read, 2 => writ
C 72              Number I   words per logical record
C 73              Current table row physical record in BUFFER
C 74
C 75              Current table row logical record in BUFFER
C 76
C 77              Type of current record in BUFFER
C 78              Current control physical record number in BUFFER
C 79              Current control logical record number in BUFFER
C 80              Type of current control record in BUFFER
C 81              LUN
C 82              FTAB pointer of open file
C***********
C 83 -100         Reserved
C***********
C101 -128     H   Table title
C129 -256         lookup table as COLPTR(logical column) = phys column
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, PTYP*2
      INTEGER   VOL, CNO, VER, CATBLK(256), LUN, NKEY, NREC, NCOL,
     *   DATP(128,2), BUFFER(512), IERR
C
      LOGICAL   EQUAL, OLD, TABLE, EXIST, FITASC, FORGOT
      CHARACTER ATLAB*12, CHTEMP*2, PHNAME*48, OP*4, FNAME*12, FCLASS*6,
     *   FTYPE*2, STATUS*4
      INTEGER   IND, IOP, NEXT, I, J, L, NVER, IP, LP, LREC, NLPR,
     *   IER, JERR, I4T, KREC, ISIZE, LSIZE, FSEQ, FUSID, MSGSAV
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA ATLAB /'*AIPS TABLE*'/
C-----------------------------------------------------------------------
      OLD = .TRUE.
      TABLE = .TRUE.
      EXIST = .FALSE.
      IND = 0
      MSGSAV = MSGSUP
C                                       Check OPCODE
      IOP = 0
      IERR = 1
      IF (OPCODE.EQ.'READ') IOP = 1
      IF (OPCODE.EQ.'WRIT') IOP = 2
      IF (IOP.EQ.0) THEN
         WRITE (MSGTXT,1010) OPCODE
         GO TO 990
         END IF
C                                       Check if file exists.
      CALL FXHDEX (CATBLK)
      NEXT = KIEXTN + 1
      IERR = 2
      DO 20 I = 1,KIEXTN
         CALL H2CHR (2, 1, CATBLK(KHEXT+I-1), CHTEMP)
         IF (PTYP.EQ.CHTEMP) THEN
            NEXT = I
            GO TO 50
         ELSE
            IF ((CHTEMP.EQ.' ') .OR. (CATBLK(KHEXT+I-1).EQ.0)) NEXT =
     *         MIN (NEXT, I)
            END IF
 20      CONTINUE
C                                       Catalog block full?
      IF (NEXT.GT.KIEXTN) THEN
         MSGTXT = 'TABINI: EXTENSION FILE LIST FULL'
         GO TO 990
         END IF
C                                       Some old version exists.
 50   CONTINUE
         NVER = CATBLK(KIVER+NEXT-1)
         IF (VER.LE.0) VER = NVER + IOP - 1
C                                       See if requested version exists
         CALL ISTAB (PTYP, VOL, CNO, VER, LUN, BUFFER, TABLE, EXIST,
     *      FITASC, JERR)
         IF (JERR.NE.0) THEN
            IERR = 3
            MSGTXT = 'TABINI: I/O ERROR FROM ISTAB ON ' // PTYP
            GO TO 990
            END IF
C                                       Forgotten version?
C                                       Delete forgotten file if
C                                       writing, keep if reading.
         FORGOT = EXIST .AND. ((VER.GT.NVER) .OR. (JERR.NE.0))
         EXIST = EXIST .AND. (JERR.EQ.0)
         IF (EXIST .AND. ((OPCODE.EQ.'READ') .OR. (.NOT.FORGOT)))
     *      GO TO 140
C                                       None exist: ok on write only
            IF (OPCODE.EQ.'READ') THEN
               WRITE (MSGTXT,1060) PTYP, VER
               GO TO 990
               END IF
C                                       write any ver
C            IF (VER.GT.NVER) VER = NVER + 1
            IF (VER.GT.46655) THEN
               MSGTXT = 'CANNOT CREATE MORE THAN 46655 VERSIONS OF' //
     *            ' AN EXT. FILE'
               GO TO 990
               END IF
C                                       CREATE new file.
C                                       Parse the data structure
      CALL FILL (256, 0, BUFFER)
      CALL FILL (128, 0, DATP)
C                                       Add AIPS table label
      CALL CHR2H (12, ATLAB, 1, BUFFER(54))
      IP = 1
      LP = 1
      DO 120 I = 1,7
         IF (I.EQ.6) GO TO 120
         DO 110 J = 1,NCOL
C                                       Found column of right type
            IF (MOD(DATP(J,2), 10).EQ.I) THEN
C                                       DATP(J,1) = Pointer in array
C                                       of appropriate type.
               DATP(J,1) = IP
               BUFFER(128+J) = LP
               LP = LP + 1
C                                       Get length of array.
               L = DATP(J,2) / 10
               IF (I.EQ.3) L = (L-1) / 4 + 1
               IF (I.EQ.7) L = (L-1) / NBITWD + 1
               IF (DATP(J,2).LT.10) L = 0
C                                       Set pointer for next entry.
               IP = IP + L
C                                       If L>1 and I .NE. 3 then the
C                                       file cannot be written as
C                                       FITS ASCII
               IF ((L.GT.1) .AND. (I.NE.3)) BUFFER(60) = 1
               END IF
 110        CONTINUE
C                                       Set pointer for next type.
         IF (I.EQ.1) IP = (IP-1) * NWDPDP + 1
 120     CONTINUE
C                                       error in data types
      IF (LP.EQ.NCOL+1) GO TO 130
         WRITE (MSGTXT,1120)
         IERR = 1
         GO TO 990
C                                       select column pointers
 130  LREC = 2 * IP
      BUFFER(128+LP) = LP
      DATP(LP,1) = IP
      DATP(LP,2) = 9
C                                       record pointers
      BUFFER(45) = 2
      BUFFER(46) = 3
      BUFFER(47) = 5
      BUFFER(48) = 6 + (NCOL - 1) / (256 / 6)
      BUFFER(49) = BUFFER(48) + 1 + (NCOL - 1) / (256 / 2)
      BUFFER(50) = BUFFER(49) + 1 + (NKEY - 1) / (256 / 5)
      KREC = BUFFER(50) - 1
C                                       file size
      IF ((NREC.LE.0) .OR. (NREC.GT.10000)) NREC = 100
      NLPR = 512.0 / LREC
      IF (NLPR.LE.0) NLPR = -(LREC / 512.0 + 0.9999)
      IF (NLPR.GT.0) ISIZE = KREC + 1 + (NREC-1)/NLPR
      IF (NLPR.LE.0) ISIZE = KREC - NLPR * NREC
      IERR = 4
      CALL ZPHFIL (PTYP, VOL, CNO, VER, PHNAME, IER)
      CALL CHR2H (48, PHNAME, 1, BUFFER(17))
C                                       Delete forgotten old file on
C                                       write.
      IF (FORGOT .AND. (OPCODE.EQ.'WRIT')) THEN
         WRITE (MSGTXT,1125) PTYP, VER
         CALL MSGWRT (6)
         CALL ZDESTR (VOL, PHNAME, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1126) IER, PTYP, VER
            GO TO 990
            END IF
         END IF
C                                       Create file
      CALL ZCREAT (VOL, PHNAME, ISIZE, .FALSE., LSIZE, IER)
      IF (IER.EQ.0) OLD = .FALSE.
      IF (IER.LE.1) GO TO 140
         WRITE (MSGTXT,1130) IER, PTYP, VER
         IF (IER.EQ.5) WRITE (MSGTXT,1131) PTYP, VER, VOL
         GO TO 990
 140  ISIZE = LSIZE
C                                       Catalog ext. file
      IF ((.NOT.OLD) .OR. FORGOT) THEN
C                                       Correct max table number in
C                                       header .
         CALL CHR2H (2, PTYP, 1, CATBLK(KHEXT+NEXT-1))
         CATBLK(KIVER+NEXT-1) = MAX (VER, CATBLK(KIVER+NEXT-1))
         IF (OPCODE.EQ.'WRIT') THEN
            MSGSUP = 32000
            CALL CATIO ('UPDT', VOL, CNO, CATBLK, 'REST', BUFFER(257),
     *         IER)
            MSGSUP = MSGSAV
            IF (IER.EQ.4) THEN
               MSGTXT = 'FILE TOO BUSY TO WRITE, WILL PAUSE AND RETRY'
               CALL MSGWRT (7)
               CALL ZDELAY (2.0, IER)
               CALL CATIO ('UPDT', VOL, CNO, CATBLK, 'REST',
     *            BUFFER(257), IER)
            ELSE IF (IER.NE.0) THEN
               CALL MSGWRT (7)
               END IF
C                                       File being read; some trickery
C                                       is called for here.
         ELSE
            CALL H2CHR (12, KHIMNO, CATBLK(KHIMN), FNAME)
            CALL H2CHR (6, KHIMCO, CATBLK(KHIMC), FCLASS)
            CALL H2CHR (2, KHPTYO, CATBLK(KHPTY), FTYPE)
            FSEQ = CATBLK(KIIMS)
            FUSID = CATBLK(KIIMU)
            STATUS = 'CLRD'
            CALL CATDIR ('CSTA', VOL, CNO, FNAME, FCLASS, FSEQ, FTYPE,
     *         FUSID, STATUS, BUFFER(257), IER)
            STATUS = 'READ'
            IF (IER.EQ.0)
     *         CALL CATIO ('UPDT', VOL, CNO, CATBLK, STATUS,
     *            BUFFER(257), IER)
            END IF
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1140) IER, PTYP, VER
            GO TO 990
            END IF
         END IF
C                                       OPEN file.
      CALL ZPHFIL (PTYP, VOL, CNO, VER, PHNAME, IER)
      CALL CHR2H (48, PHNAME, 1, BUFFER(17))
      EQUAL = IOP.EQ.2
      IERR = 2
      CALL ZOPEN (LUN, IND, VOL, PHNAME, .FALSE., EQUAL, .TRUE., IER)
      IF (IER.GT.0) THEN
         IND = 0
         WRITE (MSGTXT,1200) IER, PTYP, VER
         GO TO 990
         END IF
C                                       Message about recovering old file
      IF (FORGOT .AND. (OPCODE.EQ.'READ')) THEN
         WRITE (MSGTXT,1201) PTYP, VER
         CALL MSGWRT (6)
         END IF
C                                       If new file, fill in header.
      IF (OLD) GO TO 220
         BUFFER(1) = ISIZE
C                                       determine # log. max in file
         IF (NLPR.GE.0) THEN
            BUFFER(3) = NLPR * (ISIZE - KREC)
         ELSE
            BUFFER(3) = (ISIZE - KREC) / ABS(NLPR)
            END IF
         BUFFER(5) = 0
         CALL CHR2H (6, TSKNAM, 1, BUFFER(29))
         BUFFER(7) = 2
         BUFFER(8) = DATP(NCOL+1,1)
         BUFFER(9) = NLPR
         BUFFER(10) = NCOL
         CALL ZDATE (BUFFER(11))
         CALL ZTIME (BUFFER(14))
         BUFFER(32) = VOL
         BUFFER(42) = NREC
         BUFFER(51) = BUFFER(8)
         LP = 256 / 5
         BUFFER(52) = LP * (BUFFER(50) - BUFFER(49))
         BUFFER(62) = 1
         BUFFER(63) = 1
         I = 28
         CALL RFILL (I, HBLANK, BUFFER(101))
C                                       Write header.
         IERR = 3
         OP = 'WRIT'
         CALL ZFIO ('WRIT', LUN, IND, 1, BUFFER, IER)
         IF (IER.NE.0) GO TO 980
         CALL ZFIO ('WRIT', LUN, IND, BUFFER(45), DATP, IER)
         IF (IER.NE.0) GO TO 980
C                                       write null records
         CALL RFILL (256, HBLANK, BUFFER(257))
         I4T = BUFFER(46)
         IP = BUFFER(50) - BUFFER(46)
         DO 215 I = 1,IP
            CALL ZFIO ('WRIT', LUN, IND, I4T, BUFFER(257), IER)
            IF (IER.NE.0) GO TO 980
            I4T = I4T + 1
 215        CONTINUE
         GO TO 230
C                                       Read header, pointers
 220  CONTINUE
         IERR = 3
         OP = 'READ'
         CALL ZFIO ('READ', LUN, IND, 1, BUFFER, IER)
         IF (IER.NE.0) GO TO 980
C                                       Not table format
         IF (.NOT.TABLE) THEN
            IERR = 5
            MSGTXT = 'TABINI: FILE NOT A TABLE FILE'
            GO TO 990
            END IF
         CALL ZFIO ('READ', LUN, IND, BUFFER(45), DATP, IER)
         IF (IER.NE.0) GO TO 980
         CALL CHR2H (48, PHNAME, 1, BUFFER(17))
C                                       If write - fill info
 230  IF (OPCODE.EQ.'WRIT') THEN
         BUFFER(32) = VOL
         CALL ZDATE (BUFFER(33))
         CALL ZTIME (BUFFER(36))
         CALL CHR2H (6, TSKNAM, 1, BUFFER(39))
         IF ((NREC.LE.0) .OR. (NREC.GT.10000)) NREC = 100
         BUFFER(42) = NREC
C                                       Check structure parms
         IF (OLD) THEN
            IF ((NKEY.GT.BUFFER(52)) .OR. (NCOL.GT.BUFFER(10))) THEN
               WRITE (MSGTXT,1230) NKEY, BUFFER(52), NCOL, BUFFER(10)
               IERR = 1
               GO TO 990
               END IF
            END IF
         END IF
C                                       Check record length.
      NLPR = BUFFER(9)
C                                       return parms
      NKEY = BUFFER(52)
      NCOL = BUFFER(10)
C                                       set up I/O
      BUFFER(71) = IOP
      BUFFER(72) = BUFFER(8)
      BUFFER(73) = 0
      BUFFER(75) = BUFFER(5)
      IF (IOP.EQ.1) BUFFER(75) = 0
      BUFFER(77) = -1
      BUFFER(78) = 0
      BUFFER(79) = 0
      BUFFER(80) = -1
      BUFFER(81) = LUN
      BUFFER(82) = IND
      IERR = 0
      IF (.NOT.OLD) IERR = -1
      GO TO 999
C                                       Error
 980  WRITE (MSGTXT,1980) OP, IER
 990  CALL MSGWRT (6)
      WRITE (MSGTXT,1990) PTYP, VOL, CNO, VER
      CALL MSGWRT (6)
      IF (IND.GT.0) CALL ZCLOSE (LUN, IND, IER)
      IF (.NOT.OLD) THEN
         CALL H2CHR (48, 1, BUFFER(17), PHNAME)
         CALL ZDESTR (VOL, PHNAME, IER)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('TABINI: UNKNOWN OPCODE: ',A4)
 1060 FORMAT ('TABINI: REQUESTED ',A2,' FILE ',I3,' DOES NOT EXIST')
 1120 FORMAT ('TABINI: SOME ERROR IN LIST OF TABLE DATA TYPES')
 1125 FORMAT ('TABINI: Deleting old ',A,' table version',I4)
 1126 FORMAT ('TABINI: ERROR ',I3,' DELETING OLD ',A,
     *   ' TABLE VERSION',I4)
 1130 FORMAT ('TABINI: ERROR',I3,' CREATING FILE ',A2,' NO ',I3)
 1131 FORMAT ('TABINI: PROHIBITED FROM CREATING FILE ',A2,' NO ',I3,
     *   ' ON DISK',I3)
 1140 FORMAT ('TABINI: ERROR',I3,' CATALOGING FILE ',A2,' NO ',I3)
 1200 FORMAT ('TABINI: ERROR',I3,' OPENING FILE ',A2,' NO. ',I3)
 1201 FORMAT ('TABINI: Recovering old ',A,' table version',I4)
 1230 FORMAT ('TABINI: KEY COUNTS',2I7,' OR COLS',2I7,' DON''T MATCH')
 1980 FORMAT ('TABINI: ',A4,' ERROR',I5)
 1990 FORMAT ('TABINI: ERROR ON TYPE ',A2,' DISK',I3,' CNO',I7,
     *   ' VERSION',I6)
      END

      SUBROUTINE FXLEVS (LUN, FIND, CATBLK, BLC, TRC, ZMIN, ZMAX, ZINC,
     *   XMULT, LEVS, RMIN, RMAX, BUFFER, JBUFSZ, IRET)
C-----------------------------------------------------------------------
C! Finds the actual LEVS that will be used - note does image I/O
C# Graphics Map-util Plot-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2021, 2024, 2026
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Finds max, min in a data cube and then checks the contour levels
C   returning only those that will be used.
C   Inputs:
C      LUN      I       LUN of open file
C      FIND     I       pointer to open file
C      CATBLK   I(256)  Contour image header
C      BLC      R(7)    Bottom left corner
C      TRC      R(7)    Top right corner
C      ZMIN     I       First plane to use
C      ZMAX     I       Last plane to use
C      ZINC     I       Increment in planes
C      XMULT    R       Factor in front of LEVS
C      JBUFSZ   I       Size of buffer in AIPS bytes
C   In/Out
C      LEVS     R(30)   Contour levels = LEVS(i)*XMULT
C   Outputs
C      RMIN     R       Minimum brightness in the contouring images
C      RMAX     R       Maximum brightness in the contouring images
C      BUFFER   R(*)    I/O work buffer
C      IRET     I       Error code
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, CATBLK(256), ZMIN, ZMAX, ZINC, JBUFSZ, IRET
      REAL      BLC(7), TRC(7), XMULT, LEVS(30), RMIN, RMAX, BUFFER(*)
C
      INTEGER   IX1, IX2, IY1, IY2, IX, IY, IZ, IDEPTH(5), IWIN(4), IZ1,
     *   IZ2, IZ3, NX, NY, IOF, NLEVS, IPOS, LZ
      REAL      V, ALEVS(30)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      NX = CATBLK(KINAX)
      NY = CATBLK(KINAX+1)
      LZ = TRC(3) + 0.01
      IX1 = BLC(1) + 0.01
      IX2 = TRC(1) + 0.01
      IY1 = BLC(2) + 0.01
      IY2 = TRC(2) + 0.01
      IWIN(1) = IX1
      IWIN(2) = IY1
      IWIN(3) = IX2
      IWIN(4) = IY2
      RMIN = 1.E10
      RMAX = -1.E10
      IF ((ZMAX.GE.ZMIN) .AND. (ZMIN.GE.1)) THEN
         IZ1 = ZMIN
         IZ2 = MIN (LZ, ZMAX)
         IZ3 = MAX (1, ABS(ZINC))
      ELSE IF ((ZMAX.LE.ZMIN) .AND. (ZMAX.GE.1)) THEN
         IZ1 = ZMAX
         IZ2 = MIN (LZ, ZMIN)
         IZ3 = MAX (1, ABS(ZINC))
      ELSE
         IZ1 = BLC(3) + 0.01
         IZ2 = IZ1
         IZ3 = 1
         END IF
      IDEPTH(2) = BLC(4) + 0.01
      IDEPTH(3) = BLC(5) + 0.01
      IDEPTH(4) = BLC(6) + 0.01
      IDEPTH(5) = BLC(7) + 0.01
C                                       do the I/O
      DO 40 IZ = IZ1,IZ2,IZ3
         IDEPTH(1) = IZ
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH, IOF, IRET)
         IF (IRET.NE.0) GO TO 999
         IOF = IOF + 1
C                                       Init for double buff read.
         CALL MINIT ('READ', LUN, FIND, NX, NY, IWIN, BUFFER, JBUFSZ,
     *      IOF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT THE I/O'
            GO TO 980
            END IF
         DO 30 IY = IY1,IY2
            CALL MDISK ('READ', LUN, FIND, BUFFER, IPOS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ IMAGE ROW'
               GO TO 980
               END IF
            DO 20 IX = IX1,IX2
               V = BUFFER(IPOS+IX-IX1)
               IF (V.NE.FBLANK) THEN
                  RMIN = MIN (RMIN, V)
                  RMAX = MAX (RMAX, V)
                  END IF
 20            CONTINUE
 30         CONTINUE
 40      CONTINUE
C                                       now the levs
      CALL RFILL (30, 0.0, ALEVS)
      ALEVS(1) = XMULT * LEVS(1)
      DO 50 IX = 2,30
         IF (LEVS(IX).GT.LEVS(IX-1)) THEN
            ALEVS(IX) = XMULT * LEVS(IX)
         ELSE
            NLEVS = IX - 1
            GO TO 60
            END IF
 50      CONTINUE
      NLEVS = 30
C                                       now check them out
 60   CALL RFILL (30, 0.0, LEVS)
      IY = 0
      DO 70 IX = 1,NLEVS
         IF ((ALEVS(IX).GE.RMIN) .AND. (ALEVS(IX).LE.RMAX)) THEN
            IY = IY + 1
            LEVS(IY) = ALEVS(IX) / XMULT
            END IF
 70      CONTINUE
      IF (IY.LE.0) THEN
         IRET = 10
         MSGTXT = 'FXLEVS: NO VALID LEVS FOUND'
         GO TO 980
         END IF
      GO TO 999
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FXLEVS: ERROR',I4,' ON ',A)
      END

LOCAL INCLUDE 'FIXWT.INC'
      REAL      SOLINT, AVG, LIMITS(10), WTMAX
      INTEGER   CCHAN, CIF, CANT, CPOL, FLAGS, DOALL
      COMMON /FXWT/ SOLINT, CCHAN, CIF, CANT, CPOL, DOALL, AVG, FLAGS,
     *   LIMITS, WTMAX
LOCAL END
LOCAL INCLUDE 'XXTAB.INC'
C                                       Column indices
C                                         (1) time
C                                         (2) baseline
C                                         (3) weight
      INTEGER   COLIDX(3), NWEIGH
C
      COMMON /TABXX/ COLIDX, NWEIGH
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(10)
      LOGICAL   LDUM(1)
      REAL      RDUM(10)
      DOUBLE PRECISION DDUM
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
      COMMON /FIXWTG/ DDUM
LOCAL END
      PROGRAM FIXWT
C-----------------------------------------------------------------------
C! Task to fix uv data weights based on amplitude std. deviations
C# UV Calibration OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1999, 2003, 2005, 2012, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Select data for a single channel and IF and sort into BT order.
C   Run a filter of width 2 * XINC + 1 over the data for each baseline,
C   breaking at source changes, frequency ID changes and gaps longer
C   than the filter half-width and calculate new weights using a MAD
C   estimate of the noise; weights are replicated for data points at
C   the beginning and end of a filtered subsection.  Sort the weights
C   into TB order and merge them into the original data.
C-----------------------------------------------------------------------
C                                       Inputs
      CHARACTER INPUTS*6
      PARAMETER (INPUTS = 'Inputs')
C                                       Original data
      CHARACTER IDATA*15
      PARAMETER (IDATA = 'Input Data File')
C                                       Weights scratch file
      CHARACTER WTFILE*12
      PARAMETER (WTFILE = 'Weights File')
C                                       Output data file
      CHARACTER OUTFIL*11
      PARAMETER (OUTFIL = 'Output File')
C                                       Return status
      INTEGER   IRET, IERR
C                                       Scratch buffer, sum arrays
      INTEGER   BUFFER(256), NWORDS, COUNT(2)
      LONGINT   COFF, SOFF, SQOFF, WOFF, SWOFF
      REAL      SUM(2), SUMSQ(2), SUMWT(2), WEIGHT(2), RCOUNT(2)
      EQUIVALENCE (COUNT, RCOUNT)
C
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'FIXWT.INC'
      INCLUDE 'XXTAB.INC'
C-----------------------------------------------------------------------
C                                       Initialize task and read inputs:
      CALL FIXWIN (INPUTS, IDATA, OUTFIL, IRET)
      IF (IRET.NE.0) GO TO 900
C                                       Prepare summing arrays
      NWEIGH = CPOL * CIF * CANT
      NWORDS = (CANT * NWEIGH - 1) / 1024 + 1
      NWEIGH = (NWEIGH - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', 'FIXWT', NWORDS, SUM, SOFF, IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', 'FIXWT', NWORDS, SUMSQ, SQOFF,
     *   IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', 'FIXWT', NWORDS, RCOUNT, COFF,
     *   IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', 'FIXWT', NWORDS, SUMWT, SWOFF,
     *   IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', 'FIXWT', NWEIGH, WEIGHT,
     *   WOFF, IRET)
      IF (IRET.NE.0) GO TO 900
      NWEIGH = NWEIGH * 1024
C                                       Calculate weights:
      MSGTXT = 'Calculating weights'
      CALL MSGWRT (4)
      CALL CALCWT (IDATA, WTFILE, CPOL, CIF, CANT, SUM(1+SOFF),
     *   SUMSQ(1+SQOFF), SUMWT(1+SWOFF), COUNT(1+COFF), WEIGHT(1+WOFF),
     *   IRET)
      IF (IRET.NE.0) GO TO 900
      CALL ZMEMRY ('FREE', 'FIXWT', NWORDS, SUM, SOFF, IERR)
      CALL ZMEMRY ('FREE', 'FIXWT', NWORDS, SUMSQ, SQOFF, IERR)
      CALL ZMEMRY ('FREE', 'FIXWT', NWORDS, RCOUNT, COFF, IERR)
      CALL ZMEMRY ('FREE', 'FIXWT', NWORDS, SUMWT, SWOFF, IERR)
C                                       Apply weights:
      IF (DOALL.GT.0) THEN
         MSGTXT = 'Averaging weights for re-scale factor'
         CALL MSGWRT (4)
         CALL AVGWTS (IDATA, WTFILE, CPOL, CIF, CANT, WEIGHT(1+WOFF),
     *      IRET)
         IF (IRET.NE.0.0) GO TO 900
         END IF
C                                       Apply weights:
      MSGTXT = 'Merging weights into data'
      CALL MSGWRT (4)
      CALL MRGWTS (INPUTS, IDATA, WTFILE, CIF, CANT, OUTFIL,
     *   WEIGHT(1+WOFF), IRET)
      NWEIGH = NWEIGH / 1024
      CALL ZMEMRY ('FREE', 'FIXWT', NWEIGH, WEIGHT, WOFF, IERR)
      IF (IRET.NE.0) GO TO 900
C                                       Update history file:
      CALL FWTHIS (INPUTS, IDATA, OUTFIL, IRET)
      IF (IRET.NE.0) GO TO 900
C                                       Finish task:
 900  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE FIXWIN (INPUTS, IDATA, OUTFIL, IRET)
C-----------------------------------------------------------------------
C   Initialize the FIXWT task and read its input adverbs.
C   Inputs:
C      INPUTS   C*(*)   Name of inputs object
C      IDATA    C*(*)   Name of UVDATA object for input file
C      OUTFIL   C*(*)   Name of UVDATA object for output file
C   Outputs:
C      IRET     I       Return code: 0 => successful
C-----------------------------------------------------------------------
      CHARACTER INPUTS*(*), IDATA*(*), OUTFIL*(*)
      INTEGER   IRET
C                                       Reference channel number.
      INTEGER   BCHAN, ECHAN
C                                       Reference IF number.
      INTEGER   BIF, EIF
C                                       Maximum channel number.
      INTEGER   MXCHNO
C                                       Maximum IF number (-1 if no IF
C                                       axis is present).
      INTEGER   MXIFNO
C                                       Input data sort order
      CHARACTER SRTORD*2
C                                       Task name.
      CHARACTER TNAME*6
      PARAMETER (TNAME = 'FIXWT ')
C                                       Number of adverbs.
      INTEGER   NUMADV
      PARAMETER (NUMADV = 16)
C                                       Adverb names.
      CHARACTER AVNAME(NUMADV)*8
C                                       Adverb types.
      INTEGER   AVTYPE(NUMADV)
C                                       Adverb dimensions.
      INTEGER   AVDIM(2,NUMADV)
C                                       Number of adverb values to
C                                       transfer directly to UVDATA
C                                       object.
      INTEGER   NKEY
      PARAMETER (NKEY = 4)
C                                       Adverb values to transfer to
C                                       the input and output file and
C                                       their corresponding attributes.
      CHARACTER INKEY(NKEY)*8, INKEY2(NKEY)*8, OUTKEY(NKEY)*32
C                                       Input file name, output file
C                                       name and output file class:
      CHARACTER INNAME*12, OUTNAM*12, OUTCLA*6, TABLE*30
C                                       Data array dimensions
      INTEGER   NAXIS(16)
C                                       Object attribute type
      INTEGER   TYPE
C                                       Object attribute dimensions
      INTEGER   DIM(3)
C                                       Axis index
      INTEGER   INDEX
      LOGICAL   CMPRS
C
      CHARACTER CDUMMY*1, UVTYPE*2, STOKES*4
      INTEGER   IDUMMY, FGVER, ANVER, MXA
      LOGICAL   EXISTS
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'GFORT'
      INCLUDE 'FIXWT.INC'
C
      DATA AVNAME /'INNAME  ', 'INCLASS ', 'INSEQ   ', 'INDISK  ',
     *             'OUTNAME ', 'OUTCLASS', 'OUTSEQ  ', 'OUTDISK ',
     *             'DOUVCOMP', 'FLAGVER ', 'BCHAN   ', 'ECHAN   ',
     *             'SOLINT  ', 'DOALL   ', 'CPARM   ','BADDISK '/
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT,
     *             OOACAR, OOACAR, OOAINT, OOAINT,
     *             OOALOG, OOAINT, OOAINT, OOAINT,
     *             OOARE,  OOAINT, OOARE,  OOAINT/
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 12,1, 6,1, 1,1, 1,1,
     *   1,1, 1,1, 1,1, 1,1, 1,1, 1,1, 10,1, 10,1/
      DATA INKEY /'INNAME', 'INCLASS', 'INSEQ', 'INDISK'/
      DATA INKEY2 /'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK'/
      DATA OUTKEY /'NAME', 'CLASS', 'IMSEQ', 'DISK'/
C-----------------------------------------------------------------------
C                                       Initialize the task and read
C                                       the input adverb values:
      CALL AV2INP (TNAME, NUMADV, AVNAME, AVTYPE, AVDIM, INPUTS, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create a UVDATA object for the
C                                       input data:
      CALL OUVCRE (IDATA, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OUVCRE (OUTFIL, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Transfer file name information
C                                       to the input file:
      CALL IN2OBJ (INPUTS, NKEY, INKEY, OUTKEY, IDATA, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Open the data file and obtain
C                                       the number of channels and IFs:
      DIM(1) = 4
      DIM(2) = 1
      STOKES = ' '
      CALL OPUT (IDATA, 'STOKES', OOACAR, DIM, IDUM, STOKES, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OUVOPN (IDATA, 'READ', IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO OPEN INPUT FILE'
         CALL MSGWRT (8)
         IRET = 1
         GO TO 999
         END IF
      CALL UVDGET (IDATA, 'NAXIS', TYPE, DIM, NAXIS, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL UVDFND (IDATA, 2, 'STOKES', INDEX, IRET)
      IF (IRET.NE.0) GO TO 999
      CPOL = NAXIS(INDEX)
      CPOL = MIN (2, CPOL)
      CALL UVDFND (IDATA, 2, 'FREQ', INDEX, IRET)
      IF (IRET.NE.0) GO TO 999
      MXCHNO = NAXIS(INDEX)
      CALL UVDFND (IDATA, 2, 'IF', INDEX, IRET)
      IF ((IRET.NE.0).AND.(IRET.NE.1)) GO TO 999
C                                       IF axis is present.
      IF (IRET.EQ.0) THEN
         MXIFNO = NAXIS(INDEX)
C                                       No IF axis is present.
      ELSE
         MXIFNO = 1
         END IF
C                                       Check the sort order: the merge
C                                       step will fail if the data are
C                                       not in TB order.
      CALL UVDGET (IDATA, 'SORTORD', TYPE, DIM, IDUM, SRTORD, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (SRTORD(:2).NE.'TB') THEN
         MSGTXT = 'INPUT DATA IS NOT IN ''TB'' ORDER'
         CALL MSGWRT (9)
         MSGTXT = 'RUN UVSRT WITH SORT = ''TB'' FIRST'
         CALL MSGWRT (9)
         IRET = 1
         GO TO 999
         END IF
C                                       check compression - SB not allow
      CALL UVDGET (IDATA, 'TYPEUVD', TYPE, DIM, IDUM, UVTYPE, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL INGET (INPUTS, 'DOUVCOMP', TYPE, DIM, IDUM, CDUMMY, IRET)
      CMPRS = LDUM(1)
      IF (IRET.NE.0) GO TO 999
      IF (UVTYPE.EQ.'SB') CMPRS = .FALSE.
      LDUM(1) = CMPRS
      CALL INPUTT (INPUTS, 'DOUVCOMP', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL INGET (INPUTS, 'CPARM', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, LIMITS)
      IF (LIMITS(2).LE.0.0) LIMITS(2) = 1.E20
      IF (LIMITS(4).LE.0.0) LIMITS(4) = 1.E20
      IF (LIMITS(2).LE.LIMITS(1)) LIMITS(2) = 1.E20
      IF (LIMITS(4).LE.LIMITS(3)) LIMITS(4) = 1.E20
      LIMITS(5) = MAX (0.0, MIN (1.0, LIMITS(5)))
      CALL RCOPY (DIM(1), LIMITS, RDUM)
      CALL OPUT (INPUTS, 'CPARM', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      LIMITS(1) = LIMITS(1) * LIMITS(1)
      LIMITS(2) = LIMITS(2) * LIMITS(2)
C                                       close uv object
      CALL OUVCLO (IDATA, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Fill in defaults for the output
C                                       file name if needed:
      CALL FNAGET (IDATA, 'NAME', TYPE, DIM, IDUM, INNAME, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL INGET (INPUTS, 'OUTNAME', TYPE, DIM, IDUM, OUTNAM, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (OUTNAM.EQ.' ') THEN
         CALL INPUTT (INPUTS, 'OUTNAME', TYPE, DIM, IDUM, INNAME,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      CALL INGET (INPUTS, 'OUTCLASS', TYPE, DIM, IDUM, OUTCLA, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (OUTCLA.EQ.' ') THEN
         CALL INPUTT (INPUTS, 'OUTCLASS', TYPE, DIM, IDUM, 'FIXWT ',
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Transfer output file name
C                                       adverbs to output file:
      CALL IN2OBJ (INPUTS, NKEY, INKEY2, OUTKEY, OUTFIL, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Select the channel range
      CALL INGET (INPUTS, 'DOALL', TYPE, DIM, IDUM, CDUMMY, IRET)
      DOALL = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL INGET (INPUTS, 'BCHAN', TYPE, DIM, IDUM, CDUMMY, IRET)
      BCHAN = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL INGET (INPUTS, 'ECHAN', TYPE, DIM, IDUM, CDUMMY, IRET)
      ECHAN = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      BCHAN = MAX (BCHAN, 1)
      IF (ECHAN.LT.BCHAN) ECHAN = MXCHNO
      IF (ECHAN.LT.BCHAN) THEN
         WRITE (MSGTXT,1000)
         CALL MSGWRT (4)
         BCHAN = 1
         END IF
      TYPE = OOAINT
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      IDUM(1) = BCHAN
      CALL SECPUT (IDATA, 'BCHAN', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = ECHAN
      CALL SECPUT (IDATA, 'ECHAN', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CCHAN = ECHAN - BCHAN + 1
C                                       Change all IFs
      BIF = 1
      EIF = MXIFNO
      CIF = EIF -  BIF + 1
      TYPE = OOAINT
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      IDUM(1) = BIF
      CALL SECPUT (IDATA, 'BIF', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = EIF
      CALL SECPUT (IDATA, 'EIF', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CIF = EIF - BIF + 1
C                                       Turn off flagging for input
C                                       file:
      CALL INGET (INPUTS, 'FLAGVER', TYPE, DIM, IDUM, CDUMMY, IRET)
      FGVER = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      TYPE = OOAINT
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      CALL SECPUT (IDATA, 'FGVER', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Get the filter width:
      CALL INGET (INPUTS, 'SOLINT', TYPE, DIM, IDUM, CDUMMY, IRET)
      SOLINT = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      IF (SOLINT.LE.0.0) SOLINT = 1.0
      SOLINT = SOLINT / (24.0 * 60.0)
C                                       Get bad disk numbers:
      CALL INGET (INPUTS, 'BADDISK', TYPE, DIM, IBAD, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       max ant no
      TABLE = 'Temporary AN table for FIXWT'
      CANT = 0
      DO 20 ANVER = 1,99
         CALL UV2TAB (IDATA, TABLE, 'AN', ANVER, IRET)
         EXISTS = .FALSE.
         IF (IRET.EQ.0) CALL TABEXI (TABLE, EXISTS, IRET)
         MXA = 0
         IF ((IRET.EQ.0) .AND. (EXISTS)) CALL ANTNO (TABLE, ANVER, MXA,
     *      IRET)
         CALL TABDES (TABLE, IDUMMY)
         IF ((IRET.EQ.0) .AND. (EXISTS)) THEN
            CANT = MAX (CANT, MXA)
         ELSE
            GO TO 999
            END IF
 20      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Changing begin channel number to 1')
      END
      SUBROUTINE CALCWT (IDATA, WTFILE, NPOL, NIF, NANT, SUM, SUMSQ,
     *   SUMWT, COUNT, WEIGHT, IRET)
C-----------------------------------------------------------------------
C   Calculate new weights and write them to a second scratch file,
C   deleting the first on completion.
C   Inputs:
C      IDATA    C*(*)   Name of object for input data
C      WTFILE   C*(*)   Name of object for weights file
C   Output:
C      IRET     I       Return code: 0 => successful
C-----------------------------------------------------------------------
      CHARACTER IDATA*(*), WTFILE*(*)
      INTEGER   NPOL, NIF, NANT, COUNT(NANT,NANT,NIF,NPOL), IRET
      REAL      SUM(NANT,NANT,NIF,NPOL), SUMSQ(NANT,NANT,NIF,NPOL),
     *   SUMWT(NANT,NANT,NIF,NPOL), WEIGHT(NANT,NIF,NPOL)
C
      INTEGER   ILOCU, ILOCV, ILOCW, ILOCT, ILOCB, ILOCSU, ILOCFQ,
     *   ILOCA1, ILOCA2, ILOCSA
C                                       Numbers of data axes
      INTEGER   JLOCC, JLOCS, JLOCF, JLOCR, JLOCD, JLOCIF
C                                       Increments in data
      INTEGER   INCS, INCF, INCIF
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FIXWT.INC'
      INTEGER   IANT, JANT, LCHAN, LP, LIF, LASTSU, LASTFQ, IP, XXROW
      REAL      TB, TE, RP(20), VIS(3,MAXCIF), TEMP
      LOGICAL   FINISH, RESTRT
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Retrieve pointers into the data:
C                                       pointers into the data:
      CALL UVDPNT (IDATA, ILOCU, ILOCV, ILOCW, ILOCT, ILOCB, ILOCSU,
     *   ILOCFQ, ILOCA1, ILOCA2, ILOCSA, JLOCC, JLOCS, JLOCF, JLOCR,
     *   JLOCD, JLOCIF, INCS, INCF, INCIF, IRET)
      IF (IRET.NE.0) GO TO 999
      INCS = INCS / 3
      INCF = INCF / 3
      INCIF = INCIF / 3
C                                       Check that the COMPLEX axis
C                                       comes first, as assumed:
      IF (JLOCC.NE.1) THEN
         MSGTXT = 'COMPLEX AXIS IS NOT FIRST AXIS - TOO WIERD FOR ME'
         CALL MSGWRT (10)
         IRET = 1
         GO TO 999
         END IF
C                                       Create and open a scratch table:
      CALL UV2TAB (IDATA, WTFILE, 'XX', 1, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OXXINI (WTFILE, 'WRIT', XXROW, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Open the data file:
      CALL OUVOPN (IDATA, 'READ', IRET)
      IF (IRET.NE.0) GO TO 999
      TB = 0.0
      TE = -10000.
      LASTSU = -100
      LASTFQ = -100
      WTMAX = 0.0
C                                       Start the filter:
 10   CONTINUE
         CALL UVREAD (IDATA, RP, VIS, IRET)
         IF (IRET.EQ.-1) THEN
            FINISH = .TRUE.
            IRET = 0
            END IF
         IF (IRET.NE.0) GO TO 999
         RESTRT = FINISH
         IF (.NOT.FINISH) THEN
            RESTRT = RP(ILOCT).GT.TE
            IF (ILOCSU.GT.0) THEN
               IF (RP(ILOCSU).NE.LASTSU) RESTRT = .TRUE.
               END IF
            IF (ILOCFQ.GT.0) THEN
               IF (RP(ILOCFQ).NE.LASTFQ) RESTRT = .TRUE.
               END IF
            END IF
C                                       interval is done
         IF (RESTRT) THEN
C                                       have data ready to analyze
            IF (TB.LT.TE) THEN
               DO 30 LP = 1,NPOL
                  DO 25 LIF = 1,NIF
                     DO 20 JANT = 1,NANT
                        DO 15 IANT = 1,NANT
                           IF (COUNT(IANT,JANT,LIF,LP).LT.5) THEN
                              SUMSQ(IANT,JANT,LIF,LP) = FBLANK
                           ELSE
                              TEMP =  SUM(IANT,JANT,LIF,LP) /
     *                           SUMWT(IANT,JANT,LIF,LP)
                              SUMSQ(IANT,JANT,LIF,LP) =
     *                           SUMSQ(IANT,JANT,LIF,LP) /
     *                           SUMWT(IANT,JANT,LIF,LP) - TEMP*TEMP
                              END IF
 15                        CONTINUE
 20                     CONTINUE
                     CALL WTSOLV (NANT, SUMSQ(1,1,LIF,LP), LIMITS,
     *                  WEIGHT(1,LIF,LP))
 25                  CONTINUE
 30               CONTINUE
               CALL OTABXX (WTFILE, 'WRIT', XXROW, TB, TE, WEIGHT, IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
C                                       zero summing arrays
            DO 50 LP = 1,NPOL
               DO 45 LIF = 1,NIF
                  DO 40 JANT = 1,NANT
                     WEIGHT(JANT,LIF,LP) = FBLANK
                     DO 35 IANT = 1,NANT
                        COUNT(IANT,JANT,LIF,LP) = 0
                        SUM(IANT,JANT,LIF,LP) = 0.0
                        SUMWT(IANT,JANT,LIF,LP) = 0.0
                        SUMSQ(IANT,JANT,LIF,LP) = 0.0
 35                     CONTINUE
 40                  CONTINUE
 45               CONTINUE
 50            CONTINUE
            TB = RP(ILOCT)
            TE = TB + SOLINT
            IF (ILOCSU.GT.0) LASTSU = RP(ILOCSU)
            IF (ILOCFQ.GT.0) LASTFQ = RP(ILOCFQ)
            END IF
C                                       add in record
         IF (.NOT.FINISH) THEN
            IF (ILOCB.GT.0) THEN
               JANT = RP(ILOCB) + 0.001
               IANT = JANT / 256
               JANT = JANT - 256 * IANT
            ELSE
               IANT = RP(ILOCA1) + 0.1
               JANT = RP(ILOCA2) + 0.1
               END IF
            DO 70 LP = 1,NPOL
               DO 65 LIF = 1,NIF
                  IP = (LP-1) * INCS + (LIF-1) * INCIF - INCF + 1
                  DO 60 LCHAN = 1,CCHAN
                     IP = IP + INCF
C                                       real part in I < J
                     IF (VIS(3,IP).GT.0.0) THEN
                        WTMAX = MAX (WTMAX, VIS(3,IP))
                        COUNT(IANT,JANT,LIF,LP) =
     *                     COUNT(IANT,JANT,LIF,LP) + 1
                        SUM(IANT,JANT,LIF,LP) = SUM(IANT,JANT,LIF,LP) +
     *                     VIS(1,IP)*VIS(3,IP)
                        SUMSQ(IANT,JANT,LIF,LP) =
     *                     SUMSQ(IANT,JANT,LIF,LP) +
     *                     VIS(1,IP)*VIS(1,IP)*VIS(3,IP)
                        SUMWT(IANT,JANT,LIF,LP) =
     *                     SUMWT(IANT,JANT,LIF,LP) + VIS(3,IP)
                        END IF
C                                       imag part in I > J
                     IF ((VIS(3,IP).GT.0.0) .AND. (IANT.NE.JANT)) THEN
                        COUNT(JANT,IANT,LIF,LP) =
     *                     COUNT(JANT,IANT,LIF,LP) + 1
                        SUM(JANT,IANT,LIF,LP) = SUM(JANT,IANT,LIF,LP) +
     *                     VIS(2,IP)*VIS(3,IP)
                        SUMSQ(JANT,IANT,LIF,LP) =
     *                     SUMSQ(JANT,IANT,LIF,LP) +
     *                     VIS(2,IP)*VIS(2,IP)*VIS(3,IP)
                        SUMWT(JANT,IANT,LIF,LP) =
     *                     SUMWT(JANT,IANT,LIF,LP) + VIS(3,IP)
                        END IF
 60                  CONTINUE
 65               CONTINUE
 70            CONTINUE
C                                       loop for more data
            GO TO 10
            END IF
C                                       Close files:
      CALL TABCLO (WTFILE, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OUVCLO (IDATA, IRET)
      IF (IRET.NE.0) GO TO 999
      WRITE (MSGTXT,1070) WTMAX
      CALL MSGWRT (4)
C
  999 RETURN
C-----------------------------------------------------------------------
 1070 FORMAT ('Maximum data weight read =',1PE12.4)
      END
      SUBROUTINE AVGWTS (IDATA, WTFILE, NPOL, NIF, NANT, WEIGHT, IRET)
C-----------------------------------------------------------------------
C   Compare new weights to old and get scaling factors
C   Inputs:
C      IDATA      C*(*)   Name of UVDATA object for input data
C      WTFILE     C*(*)   Name of TABLE object for weights file
C      NPOL       I       Number polarizations
C      NIF        I       Number IFs
C      NANT       I       Number antennas
C   Output:
C      WEIGHT     R(*)    Work buffer
C      IRET       I       Return code: 0 => successful
C-----------------------------------------------------------------------
      CHARACTER WTFILE*(*), IDATA*(*)
      INTEGER   NPOL, NIF, NANT, IRET
      REAL      WEIGHT(NANT,NIF,NPOL)
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FIXWT.INC'
      REAL      TB, TE, RP(20), VIS(3,MAXCIF)
      INTEGER   XXROW, NGROUP
C                                       Pointers to random parameters
      INTEGER   ILOCU, ILOCV, ILOCW, ILOCT, ILOCB, ILOCSU, ILOCFQ,
     *   ILOCA1, ILOCA2, ILOCSA, JLOCC, JLOCS, JLOCF, JLOCR, JLOCD,
     *   JLOCIF, INCS, INCF, INCIF
C                                       Counters
      INTEGER   DIM(3), TYPE, NFLAG, NSKIP, COUNT, IP, IANT, JANT, LP,
     *   LIF, LCHAN, ITER
      CHARACTER CDUMMY*1
      REAL      WT, PRVTIM, AVGSQ, V, VAVG, VDIF, SUMWT
C                                       DEBUG
      INTEGER   HISTO(1000), IH
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      VAVG = 1.0
      VDIF = 100000.
C                                       Self-consistent average
      DO 100 ITER = 1,8
         NFLAG = 0
         NSKIP = 0
         CALL OUVOPN (IDATA, 'READ', IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OXXINI (WTFILE, 'READ', XXROW, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Get axis sizes and pointers:
         CALL UVDPNT (IDATA, ILOCU, ILOCV, ILOCW, ILOCT, ILOCB, ILOCSU,
     *      ILOCFQ, ILOCA1, ILOCA2, ILOCSA, JLOCC, JLOCS, JLOCF, JLOCR,
     *      JLOCD, JLOCIF, INCS, INCF, INCIF, IRET)
         IF (IRET.NE.0) GO TO 999
         INCS = INCS / 3
         INCF = INCF / 3
         INCIF = INCIF / 3
         CALL TABGET (WTFILE, 'NROW', TYPE, DIM, IDUM, CDUMMY, IRET)
         NGROUP = IDUM(1)
         IF (IRET.NE.0) GO TO 999
         TE = -1.E10
         PRVTIM = TE
         COUNT = 0
         AVG = 0.0
         AVGSQ = 0.0
         SUMWT = 0.0
         CALL FILL (1000, 0, HISTO)
C                                       Read loop
 10      CALL UVREAD (IDATA, RP, VIS, IRET)
         IF (IRET.GT.0) THEN
            GO TO 999
         ELSE IF (IRET.EQ.0) THEN
C                                       Check for bad sort order.
            IF (RP(ILOCT).LT.PRVTIM)THEN
               MSGTXT='INCORRECT SORT ORDER GIVEN IN INPUT FILE HEADER'
               CALL MSGWRT (8)
               MSGTXT = 'DATA IS NOT IN T* ORDER --- ABORTING'
               CALL MSGWRT (8)
               MSGTXT = 'RUN UVSRT WITH SORT = ''TB'' AND TRY AGAIN'
               CALL MSGWRT (8)
               IRET = 1
               GO TO 999
               END IF
            PRVTIM = RP(ILOCT)
            IF (RP(ILOCT).GT.TE) THEN
               IF (XXROW.GT.NGROUP) THEN
                  MSGTXT = 'AVGWTS: READ OF END OF WT TABLE'
                  CALL MSGWRT (8)
                  IRET = 1
                  GO TO 999
                  END IF
               CALL OTABXX (WTFILE, 'READ', XXROW, TB, TE, WEIGHT, IRET)
               IF (IRET.NE.0) GO TO 999
               IF (RP(ILOCT).LT.TB) THEN
                  NSKIP = NSKIP + 1
                  GO TO 10
                  END IF
               END IF
            IF (ILOCB.GT.0) THEN
               JANT = RP(ILOCB) + 0.001
               IANT = JANT / 256
               JANT = JANT - 256 * IANT
            ELSE
               IANT = RP(ILOCA1) + 0.1
               JANT = RP(ILOCA2) + 0.1
               END IF
            DO 50 LP = 1,NPOL
               DO 40 LIF = 1,NIF
                  IP = (LP-1) * INCS + (LIF-1) * INCIF - INCF + 1
                  WT = WEIGHT(IANT,LIF,LP) * WEIGHT(JANT,LIF,LP)
                  IF (WT.LE.0) THEN
C                                       were any data good?
                     DO 25 LCHAN = 1,CCHAN
                        IP = IP + INCF
                        IF (VIS(3,IP).GT.0.0) THEN
                           NFLAG = NFLAG + 1
                           GO TO 40
                           END IF
 25                     CONTINUE
                  ELSE
                     DO 30 LCHAN = 1,CCHAN
                        IP = IP + INCF
C                                       average
                        IF (VIS(3,IP).GT.0.0) THEN
                           V = SQRT (VIS(3,IP) / WT)
                           IF ((ITER.EQ.1) .OR. (ABS(V-VAVG).LT.VDIF))
     *                        THEN
                              IH = 200*V + 1.5
                              IH = MAX (1, MIN (1000, IH))
                              HISTO(IH) = HISTO(IH) + 1
                              AVG = AVG + V * VIS(3,IP)
                              AVGSQ = AVGSQ + V * V * VIS(3,IP)
                              COUNT = COUNT + 1
                              SUMWT = SUMWT + VIS(3,IP)
                              END IF
                           END IF
 30                     CONTINUE
                     END IF
 40               CONTINUE
 50            CONTINUE
            GO TO 10
            END IF
C                                       Close files:
         CALL OUVCLO (IDATA, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL TABCLO (WTFILE, IRET)
         IF (IRET.NE.0) GO TO 999
         IF (COUNT.GT.0) THEN
            AVG = AVG / SUMWT
            AVGSQ = AVGSQ / SUMWT - AVG*AVG
            AVGSQ = SQRT (MAX (0.0, AVGSQ))
            WRITE (MSGTXT,1000) ITER, AVG, AVGSQ
            CALL MSGWRT (4)
            IF (ABS((AVG-VAVG)/AVG).LT.0.02) GO TO 110
            VAVG = AVG
            VDIF = 2.5 * AVGSQ
         ELSE
            GO TO 110
            END IF
 100     CONTINUE
C                                       EOF in data reached
 110  IF (XXROW.LE.NGROUP) THEN
         MSGTXT = 'AVGWTS: DID NOT READ ALL WEIGHT TABLE'
         CALL MSGWRT (7)
         END IF
C                                       Report problems
      WRITE (MSGTXT,1050) NSKIP
      IF (NSKIP.GT.0) CALL MSGWRT (6)
      WRITE (MSGTXT,1051) NFLAG
      IF (NFLAG.GT.0) CALL MSGWRT (6)
C                                       average weights
C                                       for 1/sqrt
      VAVG = 2.0 / (AVG*AVG*AVG) * AVGSQ
      AVGSQ = 2.0 * AVG * AVGSQ
      AVG = AVG * AVG
      WRITE (MSGTXT,1110) AVG, AVGSQ
      CALL MSGWRT (4)
      AVG = 1.0 / AVG
      WRITE (MSGTXT,1111) AVG, VAVG
      CALL MSGWRT (4)
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AVGWTS: ITER',I2,' avg rms fac',1PE12.4,' +-',1PE12.4)
 1050 FORMAT ('AVGWTS:',I7,
     *   ' visibilities fell between weight table rows')
 1051 FORMAT ('AVGWTS:',I7,' visibilities did not have table weights')
 1110 FORMAT ('AVGWTS: average rms**2 factor',1PE12.4,' +-',1PE12.4)
 1111 FORMAT ('AVGWTS: weights will be multiplied by',1PE12.4,
     *   ' +-',1PE12.4)
      END
      SUBROUTINE MRGWTS (INPUTS, IDATA, WTFILE, NIF, NANT, OUTFIL,
     *   WEIGHT, IRET)
C-----------------------------------------------------------------------
C   Merge original data with new weights and write the results to
C   OUTFIL, which should be already created.
C   Inputs:
C      INPUTS     C*(*)   Name of INPUTS object
C      IDATA      C*(*)   Name of UVDATA object for input data
C      WTFILE     C*(*)   Name of TABLE object for weights file
C      NIF        I       Number IFs
C      NANT       I       Number antennas
C      OUTFIL     C*(*)   Name of output UV data object
C   Output:
C      WEIGHT     R(*)    Work buffer
C      IRET       I       Return code: 0 => successful
C-----------------------------------------------------------------------
      CHARACTER INPUTS*(*), WTFILE*(*), IDATA*(*), OUTFIL*(*)
      INTEGER   NIF, NANT, IRET
      REAL      WEIGHT(NANT,NIF,*)
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FIXWT.INC'
      REAL      RP(20), VIS(3,MAXCIF), TB, TE, PRVTIM, WT
      INTEGER   XXROW, ILOCU, ILOCV, ILOCW, ILOCT, ILOCB, ILOCSU,
     *   ILOCFQ, ILOCA1, ILOCA2, ILOCSA, JLOCC, JLOCS, JLOCF, JLOCR,
     *   JLOCD, JLOCIF, INCS, INCF, INCIF, NGROUP, DIM(3), TYPE,
     *   NFLAG, NSKIP, IP, IANT, JANT, LP, LIF, LCHAN, NCHAN, NAXIS(7),
     *   COUNT, NPOL, IA(4), JB(4)
      LOGICAL   COMPRS, ONEOK, DOMSG1, DOMSG3
      CHARACTER CDUMMY*1
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      DATA IA, JB /1,2,1,2, 1,2,2,1/
C-----------------------------------------------------------------------
      DOMSG1 = .TRUE.
      DOMSG3 = .TRUE.
      COUNT = 0
      FLAGS = 0
C                                       full channel selection
      CALL SECINI (IDATA, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Flagging must be off for input
C                                       file.
      TYPE = OOAINT
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 1
      IDUM(1) = -1
      CALL SECPUT (IDATA, 'FGVER', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      NFLAG = 0
      NSKIP = 0
C                                       Open files:
      CALL OUVOPN (IDATA, 'READ', IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OXXINI (WTFILE, 'READ', XXROW, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL UVDCOP (IDATA, OUTFIL, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Set compression
      CALL INGET (INPUTS, 'DOUVCOMP', TYPE, DIM, IDUM, CDUMMY, IRET)
      COMPRS = LDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL UVDPUT (OUTFIL, 'ISCOMP', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C
      CALL OUVOPN (OUTFIL, 'WRIT', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Get axis sizes and pointers:
      CALL UVDPNT (IDATA, ILOCU, ILOCV, ILOCW, ILOCT, ILOCB, ILOCSU,
     *   ILOCFQ, ILOCA1, ILOCA2, ILOCSA, JLOCC, JLOCS, JLOCF, JLOCR,
     *  JLOCD, JLOCIF, INCS, INCF, INCIF, IRET)
      IF (IRET.NE.0) GO TO 999
      INCS = INCS / 3
      INCF = INCF / 3
      INCIF = INCIF / 3
      CALL TABGET (WTFILE, 'NROW', TYPE, DIM, IDUM, CDUMMY, IRET)
      NGROUP = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL UVDGET (IDATA, 'NAXIS', TYPE, DIM, NAXIS, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      NCHAN = NAXIS(JLOCF)
      NPOL = NAXIS(JLOCS)
C                                       if overall scale, need no times
C                                       or table here
      PRVTIM = -9.99E+10
      IF (DOALL.GT.0) THEN
         TE = 1.E10
         TB = -TE
C                                       else set up for reading table
      ELSE
         TE = -1.E10
         END IF
C                                       Merge data loop
 10   CALL UVREAD (IDATA, RP, VIS, IRET)
      IF (IRET.GT.0) THEN
         GO TO 999
      ELSE IF (IRET.EQ.0) THEN
C                                       Check for bad sort order.
         IF (RP(ILOCT).LT.PRVTIM) THEN
            IF (DOMSG1) THEN
               MSGTXT = 'INCORRECT SORT ORDER IN INPUT FILE HEADER'
               CALL MSGWRT (8)
               MSGTXT = 'DATA IS NOT IN T* ORDER --- SKIPPING'
               CALL MSGWRT (8)
               DOMSG1 = .FALSE.
               END IF
            NSKIP = NSKIP + 1
            GO TO 10
            END IF
         PRVTIM = RP(ILOCT)
         IF (RP(ILOCT).GT.TE) THEN
            IF (XXROW.GT.NGROUP) THEN
               MSGTXT = 'AVGWTS: READ OF END OF WT TABLE'
               IF (DOMSG3) CALL MSGWRT (8)
               DOMSG3 = .FALSE.
               NSKIP = NSKIP + 1
               GO TO 10
            ELSE
               CALL OTABXX (WTFILE, 'READ', XXROW, TB, TE, WEIGHT, IRET)
               IF (IRET.NE.0) GO TO 999
               IF (RP(ILOCT).LT.TB) THEN
                  NSKIP = NSKIP + 1
                  GO TO 10
                  END IF
               END IF
            END IF
         IF (ILOCB.GT.0) THEN
            JANT = RP(ILOCB) + 0.001
            IANT = JANT / 256
            JANT = JANT - 256 * IANT
         ELSE
            IANT = RP(ILOCA1) + 0.1
            JANT = RP(ILOCA2) + 0.1
            END IF
C                                       Scale weights
         ONEOK = .FALSE.
         IF (DOALL.GT.0) THEN
            WT = AVG
            IF (WT.LE.0.0) THEN
               NFLAG = NPOL * NIF
            ELSE
               DO 30 LP = 1,NPOL
                  DO 20 LIF = 1,NIF
                     IP = (LP-1) * INCS + (LIF-1) * INCIF - INCF + 1
                     DO 15 LCHAN = 1,NCHAN
                        IP = IP + INCF
                        IF (VIS(3,IP).GT.0.0) ONEOK = .TRUE.
                        VIS(3,IP) = VIS(3,IP) * WT
 15                     CONTINUE
 20                  CONTINUE
 30               CONTINUE
               END IF
C                                       Copy new weights to vis
         ELSE
            DO 60 LP = 1,NPOL
               DO 50 LIF = 1,NIF
                  IP = (LP-1) * INCS + (LIF-1) * INCIF - INCF + 1
                  WT = WEIGHT(IANT,LIF,IA(LP)) * WEIGHT(JANT,LIF,JB(LP))
                  IF (WT.LE.0) THEN
                     DO 35 LCHAN = 1,NCHAN
                        IP = IP + INCF
                        IF (VIS(3,IP).GT.0.0) THEN
                           NFLAG = NFLAG + 1
                           GO TO 50
                           END IF
 35                     CONTINUE
                  ELSE
                     DO 40 LCHAN = 1,NCHAN
                        IP = IP + INCF
                        IF (VIS(3,IP).GT.0.0) THEN
                           VIS(3,IP) = WT*((VIS(3,IP)/WTMAX)**LIMITS(5))
                           ONEOK = .TRUE.
                           END IF
 40                     CONTINUE
                     END IF
 50               CONTINUE
 60            CONTINUE
            END IF
         IF (ONEOK) THEN
            CALL UVWRIT (OUTFIL, RP, VIS, IRET)
            IF (IRET.NE.0) GO TO 999
            COUNT = COUNT + 1
         ELSE
            FLAGS = FLAGS + 1
            END IF
         GO TO 10
         END IF
C                                       Set sort order for output file:
      TYPE = OOACAR
      DIM(1) = 2
      DIM(2) = 1
      DIM(3) = 0
      CALL UVDPUT (OUTFIL, 'SORTORD', TYPE, DIM, IDUM, 'TB', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Close files:
      CALL OUVCLO (IDATA, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OUVCLO (OUTFIL, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL TABCLO (WTFILE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy tables:
      CALL UVCALT (IDATA, OUTFIL, IRET)
      IF (IRET.NE.0) GO TO 999
      WRITE (MSGTXT,1110) NSKIP
      IF (NSKIP.GT.0) CALL MSGWRT (6)
      WRITE (MSGTXT,1111) NFLAG
      IF (NFLAG.GT.0) CALL MSGWRT (6)
      WRITE (MSGTXT,1000) COUNT
      CALL MSGWRT (2)
      FLAGS = FLAGS + NSKIP
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I9,' visibilities written to output file')
 1110 FORMAT (I9,' visibilities omitted from output')
 1111 FORMAT (I9,' polarizations * IFs flagged on output')
      END
      SUBROUTINE FWTHIS (INPUTS, IDATA, OUTFIL, IRET)
C-----------------------------------------------------------------------
C   Update history file and display summary.
C
C   Inputs:
C      INPUTS C*(*)    Name of INPUTS object
C      IDATA   C*(*)    Name of UVDATA object for input file
C      OUTFIL C*(*)    Name of UVDATA object for output file
C
C   Output:
C      IRET   I        Return code: 0 => successful
C-----------------------------------------------------------------------
      CHARACTER INPUTS*(*), IDATA*(*), OUTFIL*(*)
      INTEGER   IRET
C                                       Adverbs to record
      INTEGER   NADVRB
      PARAMETER (NADVRB = 13)
      CHARACTER ADVRBS(NADVRB)*8
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'FIXWT.INC'
      DATA ADVRBS /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'OUTNAME',
     *   'OUTCLASS', 'OUTSEQ', 'OUTDISK', 'BCHAN', 'ECHAN', 'SOLINT',
     *   'DOALL','CPARM'/
C-----------------------------------------------------------------------
      CALL OHCOPY (IDATA, OUTFIL, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OHTIME (OUTFIL, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OHLIST (INPUTS, ADVRBS, NADVRB, OUTFIL, IRET)
      IF (IRET.NE.0) GO TO 999
C
      IF (FLAGS.GT.0) THEN
         WRITE (MSGTXT,1000) FLAGS
         CALL MSGWRT (5)
         CALL OHWRIT (MSGTXT, OUTFIL, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C
      IF (DOALL.GT.0) THEN
         WRITE (MSGTXT,1010) AVG
         CALL OHWRIT (MSGTXT, OUTFIL, IRET)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('/ Flagged', I8, ' points for undetermined weights')
 1010 FORMAT ('/ Weights multiplied by',1PE12.4)
      END
      SUBROUTINE WTSOLV (NANT, SSQ, LIMITS, WT)
C-----------------------------------------------------------------------
C   Converts array of baseline sigma**2 to antenna weights
C   Inputs:
C      NANT   I      Number antennas
C   In/Out
C      SSQ    R(*)   Sigma**2 by baseline
C   Outputs
C      WT     R(*)   Antenna weights
C-----------------------------------------------------------------------
      INTEGER   NANT
      REAL      SSQ(NANT,NANT), LIMITS(*), WT(NANT)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   I, J, NRMS, IT, NODATA(MAXANT)
      REAL      ARMS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      CALL RFILL (NANT, 0.0, WT)
C                                       sum in Re and Im
      NRMS = 0
      ARMS = 0.0
      DO 20 I = 1,NANT
         NODATA(I) = 0
         DO 10 J = I+1,NANT
            IF (SSQ(I,J).NE.FBLANK) THEN
               IF (SSQ(J,I).NE.FBLANK) SSQ(I,J) =
     *            (SSQ(I,J) + SSQ(J,I)) / 2.0
            ELSE
               IF (SSQ(J,I).NE.FBLANK) SSQ(I,J) = SSQ(J,I)
               END IF
            IF (SSQ(I,J).LE.0.0) SSQ(I,J) = FBLANK
            IF (SSQ(I,J).NE.FBLANK) THEN
               SSQ(I,J) = MAX (LIMITS(1), MIN (LIMITS(2), SSQ(I,J)))
               NRMS = NRMS + 1
               ARMS = ARMS + 1 / SSQ(I,J)
               END IF
 10         CONTINUE
 20      CONTINUE
      IF (ARMS.LE.0.0) GO TO 900
      ARMS = NRMS / ARMS
      ARMS = SQRT (ARMS)
      WRITE (MSGTXT,1020) ARMS
      CALL MSGWRT (2)
      CALL RFILL (NANT, ARMS, WT)
C                                       iterate
      DO 90 IT = 1,5
         DO 50 I = 1,NANT
            ARMS = 0.0
            NRMS = 0
            DO 30 J = I+1,NANT
               IF (SSQ(I,J).NE.FBLANK) THEN
                  NRMS = NRMS + 1
                  ARMS = ARMS + WT(J) / SSQ(I,J)
                  END IF
 30            CONTINUE
            DO 40 J = 1,I
               IF (SSQ(J,I).NE.FBLANK) THEN
                  NRMS = NRMS + 1
                  ARMS = ARMS + WT(J) / SSQ(J,I)
                  END IF
 40            CONTINUE
            IF (ARMS.GT.0.0) THEN
               WT(I) = NRMS / ARMS
            ELSE
               NODATA(I) = 1
               END IF
 50         CONTINUE
 90      CONTINUE
      DO 100 I = 1,NANT
         IF (NODATA(I).LE.0) THEN
            IF (WT(I).GT.0.0) THEN
               WT(I) = 1.0 / WT(I)
               WT(I) = MAX (LIMITS(3), MIN (LIMITS(4), WT(I)))
               END IF
         ELSE
            WT(I) = 0.0
            END IF
 100     CONTINUE
      GO TO 999
C
 900  MSGTXT = 'WTSOLV FAILS'
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('WTSOLV: average rms =',1PE12.4)
      END
      SUBROUTINE OXXINI (TABLE, OPCODE, XXROW, IRET)
C-----------------------------------------------------------------------
C   Initialize a weights scratch table (type XX) for reading or writing,
C   creating it if necessary.
C
C   Inputs:
C      TABLE  C*(*)     Name of table object:  NAME, CLASS, IMSEQ, DISK
C                       and VER should be set.
C      OPCODE C*4       Operation code
C                         'READ' - open for reading
C                         'WRIT' - open for writing (create if
C                                  necessary)
C
C   Outputs:
C      XXROW  I         Next row to read or write
C      IRET   I         Return code: 0 => successful
C-----------------------------------------------------------------------
      CHARACTER TABLE*(*), OPCODE*4
      INTEGER   XXROW, IRET
C                                       Table label, column labels
      CHARACTER LABEL*56, COLLAB(3)*24, COLUNT(3)*8
      INTEGER   COLTYP(3), COLDIM(3)
      INTEGER   TYPE, DIM(3)
      CHARACTER CDUMMY
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'GFORT'
      INCLUDE 'XXTAB.INC'
      DATA LABEL / 'WEIGHTS SCRATCH TABLE'/
      DATA COLLAB / 'TIME1', 'TIME2', 'WEIGHT' /
      DATA COLUNT / 'DAYS', 'DAYS', ' ' /
      DATA COLTYP / OOARE, OOARE, OOARE /
      DATA COLDIM / 1, 1, 1 /
C-----------------------------------------------------------------------
C                                       Fill in table type:
      TYPE = OOACAR
      DIM(1) = 2
      DIM(2) = 1
      DIM(3) = 0
      CALL TABPUT (TABLE, 'TBLTYPE', TYPE, DIM, IDUM, 'XX', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Initialize table data if
C                                       writing:
      IF (OPCODE.EQ.'WRIT') THEN
         TYPE = OOACAR
         DIM(1) = 56
         DIM(2) = 1
         DIM(3) = 0
         CALL TABPUT (TABLE, 'LABEL', TYPE, DIM, IDUM, LABEL, IRET)
         IF (IRET.NE.0) GO TO 999
         TYPE = OOAINT
         DIM(1) = 1
         IDUM(1) = 3
         CALL TABPUT (TABLE, 'NCOL', TYPE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         IDUM(1) = 0
         CALL TABPUT (TABLE, 'VER', TYPE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         TYPE = OOACAR
         DIM(1) = 24
         DIM(2) = 3
         CALL TABPUT (TABLE, 'COLABEL', TYPE, DIM, IDUM, COLLAB, IRET)
         IF (IRET.NE.0) GO TO 999
         DIM(1) = 8
         CALL TABPUT (TABLE, 'COLUNIT', TYPE, DIM, IDUM, COLUNT, IRET)
         IF (IRET.NE.0) GO TO 999
         TYPE = OOAINT
         DIM(1) = 3
         DIM(2) = 1
         CALL TABPUT (TABLE, 'COLTYPE', TYPE, DIM, COLTYP, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         COLDIM(3) = NWEIGH
         CALL TABPUT (TABLE, 'COLDIM', TYPE, DIM, COLDIM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Initialize table:
      CALL TABOPN (TABLE, OPCODE, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'CANNOT OPEN WEIGHTS SCRATCH (XX) TABLE'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Get column indices
      CALL TABCOL (TABLE, 3, COLLAB, COLIDX, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Get next row:
      IF (OPCODE.EQ.'READ') THEN
         XXROW = 1
      ELSE
         TYPE = OOAINT
         DIM(1) = 1
         DIM(2) = 1
         DIM(3) = 0
         CALL TABGET (TABLE, 'NROW', TYPE, DIM, IDUM, CDUMMY, IRET)
         XXROW = IDUM(1)
         IF (IRET.NE.0) GO TO 999
         XXROW = XXROW + 1
         END IF
C
 999  RETURN
      END
      SUBROUTINE OTABXX (TABLE, OPCODE, XXROW, TB, TE, WEIGHT, IRET)
C-----------------------------------------------------------------------
C   Read or write a record to a weights scratch table.
C
C   Inputs:
C      TABLE   C*(*)   Name of table object
C      OPCODE  C*4     Operation code: 'READ' or 'WRIT'
C   Input/output:
C      XXROW   I       Row number to read or write (incremented on exit)
C      TB      R       Start time
C      TE      R       End time
C      WEIGHT  R(*)    Weight (Npol, Nif, Nant)
C   Output:
C      IRET    I       Return code: 0 => successful
C-----------------------------------------------------------------------
      CHARACTER TABLE*(*), OPCODE*4
      INTEGER   XXROW, IRET
      REAL      TB, TE, WEIGHT(*)
C
      INTEGER   TYPE, DIM(3)
      CHARACTER CDUMMY*4
      REAL      RDUM(2)
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'XXTAB.INC'
C-----------------------------------------------------------------------
      IF (OPCODE.EQ.'WRIT') THEN
         TYPE = OOARE
         DIM(1) = 1
         DIM(2) = 1
         DIM(3) = 0
         RDUM(1) = TB
         CALL TABDPT (TABLE, XXROW, COLIDX(1), TYPE, DIM, RDUM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         RDUM(1) = TE
         CALL TABDPT (TABLE, XXROW, COLIDX(2), TYPE, DIM, RDUM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         DIM(1) = NWEIGH
         CALL TABDPT (TABLE, XXROW, COLIDX(3), TYPE, DIM, WEIGHT,
     *      CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
      ELSE
         CALL TABDGT (TABLE, XXROW, COLIDX(1), TYPE, DIM, RDUM, CDUMMY,
     *      IRET)
         TB = RDUM(1)
         IF (IRET.NE.0) GO TO 999
         CALL TABDGT (TABLE, XXROW, COLIDX(2), TYPE, DIM, RDUM, CDUMMY,
     *      IRET)
         TE = RDUM(1)
         IF (IRET.NE.0) GO TO 999
         CALL TABDGT (TABLE, XXROW, COLIDX(3), TYPE, DIM, WEIGHT,
     *      CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C
      XXROW = XXROW + 1
C
 999  RETURN
      END

LOCAL INCLUDE 'UVRMS.INC'
C                                       Local include for UVRMS
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4,30), XCALC(1), XXSTOK(1),
     *   XOPTYP(1), XFUNC(1)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XANT(50), XBASE(50), XUVRA(2),  XSUBA, XBIF, XEIF, XBCHAN,
     *   XECHAN, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND,
     *   XBPVER, XSMOTH(3), DOWGT, SOLINT, DOPLOT, XBOXES, XPIXR(2),
     *   APARM(10), XDOTV, XGRCHN, XLABEL, BADD(10), UVAVG, UVSTD
      REAL      FITPAR(10), HISTOG(0:1025), CATOR(256)
      HOLLERITH CATOH(256)
      INTEGER   SEQIN, DISKIN, JBUFSZ, ILOCWT, CATOLD(256), INCSI,
     *   INCFI, INCIFI, OLDCNO, IXANT(50), IXBAS(50), NXANT, NXBAS,
     *   NSAMP, MAXSAM, NBOXES, GRCHAN, NPARM, IOPT, IDOPLT, SCRBUF(256)
      LOGICAL   DESEL
      DOUBLE PRECISION VSUM, VSUMS, NSUMS, CATOD(128)
      CHARACTER NAMEIN*12, CLAIN*6, OPTYPE*4, FUNTYP*2, LTITLE*80
      EQUIVALENCE (CATOD, CATOH, CATOR, CATOLD)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XXSTOK, XTIME, XBAND, XFREQ, XFQID, XANT, XBASE, XUVRA, XSUBA,
     *   XBIF, XEIF, XBCHAN, XECHAN, XDOCAL, XGUSE, XDOPOL, XPDVER,
     *   XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH, XOPTYP, DOWGT, SOLINT,
     *   DOPLOT, XBOXES, XPIXR, XFUNC, APARM, XDOTV, XGRCHN, XLABEL,
     *   BADD, UVAVG,  UVSTD
      COMMON /UVRMSS/ CATOLD, VSUM, VSUMS, NSUMS, SEQIN, DISKIN, ILOCWT,
     *   INCSI, INCFI,INCIFI, OLDCNO, IXANT, IXBAS,
     *   NXANT, NXBAS, DESEL, NSAMP, MAXSAM, NBOXES, GRCHAN, FITPAR,
     *   HISTOG, NPARM, IOPT, IDOPLT
      COMMON /CHARPM/ LTITLE, NAMEIN, CLAIN, OPTYPE, FUNTYP
      COMMON /BUFRS/ SCRBUF, JBUFSZ
C                                       End local include for UVRMS
LOCAL END
      PROGRAM UVRMS
C-----------------------------------------------------------------------
C! Prints statistics of selected uv data and plots them
C# UV UV-util Calibration Plot
C-----------------------------------------------------------------------
C;  Copyright (C) 2020, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVRMS prints statistics from a sample of uv data and plots
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C   full set of calibration adverbs
C      OPTYPE         OPTYPE        Type of data to process
C      SOLINT         SOLINT        Averaging time (min)
C   returns
C      PIXAVG         UVAVG
C      PIXSTD         UVRMS
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, NWORDS, I
      LONGINT   PVALL, PVLO, PVHI, PVTIM
      REAL      VALL(2), VLO(2), VHI(2), VTIM(2)
      INCLUDE 'UVRMS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA PRGM /'UVRMS '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL UVRMSI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       dynamic memory excessive
      NWORDS = (NVIS - 1) / 1024 + 1
      MAXSAM = NWORDS * 1024
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, VALL, PVALL, IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, VTIM, PVTIM,
     *   IRET)
      NWORDS = (NWORDS + 1) / 2
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, VLO, PVLO,
     *   IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, VHI, PVHI,
     *   IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET NEEDED DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       read data
      CALL UVRMSR (VALL(1+PVALL), VTIM(1+PVTIM), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Plot vs time
      IF (IDOPLT.GT.1) CALL UVRMST (VALL(1+PVALL), VTIM(1+PVTIM),
     *   STOKES, IRET)
      IF (IRET.GT.0) GO TO 990
      IF (IRET.LT.0) IDOPLT = 0
C                                       analyze data
      CALL UVRMSA (VALL(1+PVALL), VLO(1+PVLO), VHI(1+PVHI), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Plot histogram
      IF (MOD(IDOPLT,2).EQ.1) CALL UVRMSP (STOKES, IRET)
C                                       return answers
 900  CALL PTPARM (2, UVAVG, SCRBUF, I)
      IF (I.NE.0) THEN
         WRITE (MSGTXT,1010) I
         CALL MSGWRT (8)
         END IF
C                                       Close down files, etc.
 990  IRET = MAX (0, IRET)
      CALL DIE (IRET, SCRBUF)
C
 999  STOP
C-----------------------------------------------------------------------
 1010 FORMAT ('ERROR',I5,' RETURNING ANSWERS TO AIPS')
      END
      SUBROUTINE UVRMSI (PRGN, JERR)
C-----------------------------------------------------------------------
C   UVRMSI gets input parameters for UVRMS
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, PTYPE*2
      INTEGER   IROUND, IERR, INCX, I, NFREQ, LUN
      LOGICAL   MATCH
      REAL      CATR(256), RPARM(20)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'UVRMS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 290
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      RQUICK = .FALSE.
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (4, 1, XXSTOK, STOKES)
      CALL H2CHR (2, 1, XFUNC, FUNTYP)
      DO 5 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 5       CONTINUE
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      IDOPLT = IROUND (DOPLOT)
      IF (DOPLOT.GT.0) IDOPLT = MAX (1, IDOPLT)
      UVSTD = 0.0
      UVAVG = 0.0
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      IF (OPTYPE.EQ.'AUTO') THEN
         DOACOR = .TRUE.
         DOXCOR = .FALSE.
         OPTYPE = 'AMP'
         END IF
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      UVRNG(1) = XUVRA(1)
      UVRNG(2) = XUVRA(2)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
      GRCHAN = XGRCHN + 0.1
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Test OPTYPE, STOKES
      IF ((OPTYPE.NE.'AMP') .AND. (OPTYPE.NE.'PHAS') .AND.
     *   (OPTYPE.NE.'REAL') .AND. (OPTYPE.NE.'IMAG') .AND.
     *   (OPTYPE.NE.'SAMP')) THEN
         OPTYPE = 'AMP'
         MSGTXT = 'SETTING OPTYPE TO AMP'
         CALL MSGWRT (6)
         END IF
      IOPT = 1
      IF (OPTYPE.EQ.'REAL') IOPT = 2
      IF (OPTYPE.EQ.'IMAG') IOPT = 3
      IF (OPTYPE.EQ.'PHAS') IOPT = 4
      IF (OPTYPE.EQ.'SAMP') IOPT = 5
      IF (STOKES.EQ.' ') STOKES = 'I'
      IF ((STOKES.EQ.'I') .OR. (STOKES.EQ.'Q') .OR. (STOKES.EQ.'U') .OR.
     *   (STOKES.EQ.'V')) GO TO 20
      IF (CATD(KDCRV+JLOCS).LE.-5.0) THEN
         IF ((STOKES.EQ.'VV') .OR. (STOKES.EQ.'HH') .OR.
     *      (STOKES.EQ.'VH') .OR. (STOKES.EQ.'HV')) GO TO 20
      ELSE IF (CATD(KDCRV+JLOCS).LE.-1.0) THEN
         IF ((STOKES.EQ.'RR') .OR. (STOKES.EQ.'LL') .OR.
     *      (STOKES.EQ.'RL') .OR. (STOKES.EQ.'LR')) GO TO 20
         END IF
      MSGTXT = 'ONLY ONE POLARIZATION ALLOWED: NOT ' // STOKES
      JERR = 10
      GO TO 990
C                                       Channel selection?
 20   IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NFREQ = CATBLK(KINAX+JLOCF)
      BCHAN = IROUND (XBCHAN)
      ECHAN = IROUND (XECHAN)
      IF ((BCHAN.LE.0) .OR. (BCHAN.GT.NFREQ)) BCHAN = 1
      IF ((ECHAN.LE.0) .OR. (ECHAN.GT.NFREQ)) ECHAN = NFREQ
      IF (BCHAN.GT.ECHAN) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       Find baselines to copy
      CALL SETANT (50, XANT, XBASE, NXANT, NXBAS, IXANT, IXBAS, DESEL)
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, HISTOG, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, HISTOG, IERR)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                        Fill defaults for plots
      CALL RCOPY (8, TIMRNG, XTIME)
      CALL RCOPY (2, UVRNG, XUVRA)
      XBCHAN = BCHAN
      XECHAN = ECHAN
      XBIF = BIF
      XEIF = EIF
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', SCRBUF, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVRMSI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVRMSI: UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE UVRMSR (VALL, VTIM, IRET)
C-----------------------------------------------------------------------
C   UVRMSR reads the uv data and prepares a list of values with time
C   averaging (one or multiple times)
C   Input in common:
C      INCSI   I      Input Stokes' increment in vis.
C      INCFI   I      Input frequency increment in vis.
C      INCIFI  I      Input IF increment in vis.
C   Output:
C      VALL    R(*)   List of data values
C      VTIM    R(*)   List of data times
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
      REAL      VALL(*), VTIM(*)
C
      INTEGER   IA1, IA2, NV
      LOGICAL   T, F, REQBAS
      INCLUDE 'UVRMS.INC'
      REAL      BASEN, VIS(UVBFSS), RR, RI, RPARM(20), LTIME, TIME, VS,
     *   TS, SR, SI, SW, RW, SA
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL UVPGET (IRET)
      IF (SOLINT.LE.0.0) SOLINT = 0.007
      SOLINT = SOLINT / (60.0 * 24.0)
      LTIME = -100.
      NV = 0
      SR = 0.0
      SI = 0.0
      SW = 0.0
      SA = 0.0
      TS = 0.0
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over buffer
      ELSE IF (IRET.EQ.0) THEN
         IF (ILOCB.GE.0) THEN
            BASEN = RPARM(1+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
            END IF
         IF (.NOT.REQBAS (IA1, IA2, DESEL, IXANT, NXANT, IXBAS, NXBAS))
     *      GO TO 100
         TIME = RPARM(1+ILOCT)
         IF (TIME.GT.LTIME+SOLINT) THEN
            IF (NV.GT.0.0) THEN
               IF (NSAMP.GE.MAXSAM) GO TO 900
               NSAMP = NSAMP + 1
               CALL FIXIT (OPTYPE, SW, SR, SI, SA, VS)
               VTIM(NSAMP) = TS / NV
               VALL(NSAMP) = VS
               END IF
            TS = 0.0
            NV = 0
            LTIME = TIME
            END IF
C                                       call user routine
         CALL UVRMSG (VIS, RR, RI, RW, IRET)
C                                       Copy to output.
         IF (IRET.EQ.0) THEN
            NV = NV + 1
            SR = SR + RR
            SI = SI + RI
            SA = SA + SQRT (RR*RR + RI*RI)
            SW = SW + RW
            TS = TS + TIME
            END IF
C                                       Read next buffer.
         IRET = 0
         GO TO 100
         END IF
C                                       Final value
      IF (NV.GT.0) THEN
         IF (NSAMP.GE.MAXSAM) GO TO 900
         NSAMP = NSAMP + 1
         CALL FIXIT (OPTYPE, SW, SR, SI, SA, VS)
         VALL(NSAMP) = VS
         VTIM(NSAMP) = TS / NV
         END IF
C                                       Close files
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
C                                       close NX table
      IRET = 0
      IF (NSAMP.LE.0) THEN
         IRET = 10
         MSGTXT = 'NO DATA SAMPLES FOUND'
         GO TO 990
         END IF
      GO TO 999
C
 900  WRITE (MSGTXT,1900) MAXSAM
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVRMSR: ERROR',I3,' OPEN/INIT INPUT VIS FILE')
 1100 FORMAT ('UVRMSR: ERROR',I3,' READING VIS FILE')
 1900 FORMAT ('UVRMSR: MAXIMUM NUMBER SAMPLES REACHED',I12)
      END
      SUBROUTINE UVRMSG (VIS, RR, RI, RW, IRET)
C-----------------------------------------------------------------------
C   Finds the requested value from the current data
C     Inputs:
C      VIS     R(3,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C   Inputs from COMMON:
C      CATBLK     I(256)  Catalog header record. See Going Aips for
C                         details.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
C      DOWGT      R    > 0 do not average the output
C   Output:
C      RR         R    Output weighted summed value real part
C      RI         R    Output weighted summed value imag part
C      RW         R    Output summed weights
C      IRET       I    Return code  -1 => don't include
C                                    0 => OK
C-----------------------------------------------------------------------
      INTEGER   IRET
      REAL      VIS(3,*), RR, RI, RW
C
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXI
      REAL      VR, VI, VW
      INCLUDE 'UVRMS.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       pointers to traverse the data
      NS = 1
      NIF = 1
      NF = 1
      IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
      IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
      IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
      RW = 0.0
      RR = 0.0
      RI = 0.0
      DO 40 JIF = 1,NIF
         DO 30 JF = 1,NF
            DO 20 JS = 1,NS
               INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *            (JS-1) * INCSI + 1
               VR = VIS(1,INDEXI)
               VI = VIS(2,INDEXI)
               VW = VIS(3,INDEXI)
               IF (VW.GT.0.0) THEN
                  RW = RW + VW
                  RR = RR + VW * VR
                  RI = RI + VW * VI
                  END IF
 20            CONTINUE
 30         CONTINUE
 40      CONTINUE
         IF (RW.LE.0.0) THEN
            IRET = -1
         ELSE IF (DOWGT.LE.0.0) THEN
            RR = RR / RW
            RI = RI / RW
            RW = 1.0
            END IF
C
 999  RETURN
      END
      SUBROUTINE FIXIT (OPTYPE, SW, SR, SI, SA, VS)
C-----------------------------------------------------------------------
C    FIXIT averages the real and imag sums and returns the desired value
C    Input
C       OPTYPE   C*4   AMP, {HAS, REAL, IMAG
C    In/out
C       SW       R     Sum of weights       returns 0.0
C       SR       R     Sum of real          returns 0.0
C       SI       R     Sum of imaginary     returns 0.0
C       SA       R     Sum of amplitudes    returns 0.0
C    Output:
C       VS       R     Desired parameter
C-----------------------------------------------------------------------
      CHARACTER OPTYPE*4
      REAL      SW, SR, SI, SA, VS
C
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      SR = SR / SW
      SI = SI / SW
      IF (OPTYPE.EQ.'AMP') THEN
         VS = SQRT (SR*SR + SI*SI)
      ELSE IF (OPTYPE.EQ.'PHAS') THEN
         VS = 0.0
         IF ((SR.NE.0.0) .OR. (SI.NE.0.0)) VS = ATAN2 (SI, SR) * RAD2DG
      ELSE IF (OPTYPE.EQ.'REAL') THEN
         VS = SR
      ELSE IF (OPTYPE.EQ.'IMAG') THEN
         VS = SI
      ELSE IF (OPTYPE.EQ.'SAMP') THEN
         VS = SA / SW
         END IF
      SW = 0.0
      SR = 0.0
      SI = 0.0
      SA = 0.0
C
 999  RETURN
      END
      SUBROUTINE UVRMSA (VALL, VLO, VHI, IRET)
C-----------------------------------------------------------------------
C   UVRMSA analyzes the data list for statistical parameters and then
C   displays them
C   In/Out:
C      VALL    R(*)   List of data values - rearranged, destroyed
C   Output:
C      VLO     R(*)   Work list
C      VHI     R(*)   Work list
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
      REAL      VALL(*), VLO(*), VHI(*)
C
      INTEGER   I, NLO, NHI, I1, I2, IT1(3), IT2(3), IBOX
      INCLUDE 'UVRMS.INC'
      REAL      MEDIAN, XMIN, XQ1, XMED, XQ3, XMAX, XVAR, XSTD, XRMS,
     *   XMEAN, XMAD, T1, T2, FACT, RBOX
      CHARACTER XTYPE(13)*20
      INCLUDE 'UVRMS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (FITPAR(1), XMIN)
      EQUIVALENCE (FITPAR(2), XQ1)
      EQUIVALENCE (FITPAR(3), XMED)
      EQUIVALENCE (FITPAR(4), XQ3)
      EQUIVALENCE (FITPAR(5), XMAX)
      EQUIVALENCE (FITPAR(6), XMAD)
      EQUIVALENCE (FITPAR(7), XMEAN)
      EQUIVALENCE (FITPAR(8), XVAR)
      EQUIVALENCE (FITPAR(9), XSTD)
      EQUIVALENCE (FITPAR(10), XRMS)
      DATA XTYPE /'Minimum', '1st quartile', 'Median', '3rd quartile',
     *   'Maximum', 'Median abs deviation', 'Mean', 'Variance',
     *   'Standard deviation', 'Value rms', 'Value sum',
     *   'Value sum squared', 'Number samples'/
C-----------------------------------------------------------------------
      IRET = 0
C                                       get median
      XMED = MEDIAN (NSAMP, VALL)
C                                       now analyze
      VSUM = 0.0D0
      VSUMS = 0.0D0
      NSUMS = 0.0D0
      NLO = 0
      NHI = 0
      XMIN = 1.E15
      XMAX = -XMIN
      DO 20 I = 1,NSAMP
         IF (VALL(I).LT.XMED) THEN
            NLO = NLO + 1
            VLO(NLO) = VALL(I)
         ELSE IF (VALL(I).GT.XMED) THEN
            NHI = NHI + 1
            VHI(NHI) = VALL(I)
         END IF
         VSUM = VSUM + VALL(I)
         VSUMS = VSUMS + VALL(I) * VALL(I)
         NSUMS = NSUMS + 1.0D0
         XMIN = MIN (XMIN, VALL(I))
         XMAX = MAX (XMAX, VALL(I))
 20      CONTINUE
      XMEAN = VSUM / NSUMS
      XVAR = VSUMS / NSUMS - XMEAN * XMEAN
      XSTD = SQRT (MAX (0.0, XVAR))
      XQ1 = MEDIAN (NLO, VLO)
      XQ3 = MEDIAN (NHI, VHI)
      XRMS = SQRT (VSUMS / NSUMS)
C                                       histogram
      IF (MOD(IDOPLT,2).EQ.1) THEN
         NBOXES = XBOXES + 0.1
         IF (NBOXES.LT.16) NBOXES = 256
         NBOXES = MIN (NBOXES, 1024)
         IF (XPIXR(2).LE.XPIXR(1)) THEN
            XPIXR(2) = XMAX
            XPIXR(1) = XMIN
            END IF
         FACT = NBOXES / (XPIXR(2) - XPIXR(1))
         CALL RFILL (1026, 0.0, HISTOG)
         DO 30 I = 1,NSAMP
            RBOX = FACT * (VALL(I) - XPIXR(1)) + 1.0000
            RBOX = MAX (0.0, MIN (RBOX, NBOXES+1.0))
            IF (ABS(1.0-RBOX).LT.0.01) THEN
               IBOX = 1
            ELSE IF (ABS(RBOX-NBOXES-1).LT.0.01) THEN
               IBOX = NBOXES
            ELSE
               IBOX = RBOX
               END IF
            HISTOG(IBOX) = HISTOG(IBOX) + 1.0
 30         CONTINUE
         END IF
C                                       MAD
      DO 40 I = 1,NSAMP
         VALL(I) = ABS (VALL(I) - XMED)
 40      CONTINUE
      XMAD = MEDIAN (NSAMP, VALL)
C                                       prepare plot line
      LTITLE = ' '
      IF ((JLOCIF.GE.0) .AND. (CATBLK(KINAX+JLOCIF).GT.1)) THEN
         IF (CATBLK(KINAX+JLOCF).GT.1) THEN
            WRITE (LTITLE,2020) BIF, EIF, BCHAN, ECHAN
         ELSE
            WRITE (LTITLE,2021) BIF, EIF
            END IF
      ELSE
         IF (CATBLK(KINAX+JLOCF).GT.1) WRITE (LTITLE,2022) BCHAN, ECHAN
         END IF
      CALL REFRMT (LTITLE, '_', I)
C                                       now report
      WRITE (MSGTXT,1000) BIF, EIF, BCHAN, ECHAN
      CALL MSGWRT (5)
      IF ((NXANT.LE.0) .AND. (NXBAS.LE.0)) THEN
         MSGTXT = 'All baselines'
         CALL MSGWRT (5)
      ELSE
         IF (DESEL) THEN
            MSGTXT = 'Exclude:'
         ELSE
            MSGTXT = 'Include:'
            END IF
         CALL MSGWRT (5)
         IF (NXANT.LE.0) THEN
            MSGTXT = '  All antennas'
            CALL MSGWRT (5)
         ELSE
            MSGTXT = '  Antennas='
            I2 = 0
 21         I1 = I2 + 1
            I2 = MIN (I1 + 9, NXANT)
            WRITE (MSGTXT(13:),1005) (IXANT(I), I = I1,I2)
            CALL MSGWRT (5)
            MSGTXT = ' '
            IF (I2.LT.NXANT) GO TO 21
            END IF
         IF (NXBAS.LE.0) THEN
            MSGTXT = '  with all antennas'
            CALL MSGWRT (5)
         ELSE
            MSGTXT = '  Baseline='
            I2 = 0
 22         I1 = I2 + 1
            I2 = MIN (I1 + 9, NXBAS)
            WRITE (MSGTXT(13:),1005) (IXBAS(I), I = I1,I2)
            CALL MSGWRT (5)
            MSGTXT = ' '
            IF (I2.LT.NXBAS) GO TO 22
            END IF
         END IF
      IF (NSOUWD.LE.0) THEN
         MSGTXT = 'Include all sources'
         CALL MSGWRT (5)
      ELSE
         IF (DOSWNT) THEN
            MSGTXT = 'Include:'
         ELSE
            MSGTXT = 'Exclude:'
            END IF
         CALL MSGWRT (5)
         I2 = 0
 23      I1 = I2 + 1
         I2 = MIN (I1+2, NSOUWD)
         WRITE (MSGTXT(13:),1010) (SOURCS(I)(:12), I = I1,I2)
         CALL MSGWRT (5)
         MSGTXT = ' '
         IF (I2.LT.NSOUWD) GO TO 23
      END IF

      IF (TSTART.GT.0.0) THEN
         T1 = TSTART
         IT1(1) = T1
         T1 = 24.0 * (T1 - IT1(1))
         IT1(2) = T1
         T1 = 60.0 * (T1 - IT1(2))
         IT1(3) = T1
         T1 = 60.0 * (T1 - IT1(3))
         END IF
      IF (TEND.LT.1.0E4) THEN
         T2 = TEND
         IT2(1) = T2
         T2 = 24.0 * (T2 - IT2(1))
         IT2(2) = T2
         T2 = 60.0 * (T2 - IT2(2))
         IT2(3) = T2
         T2 = 60.0 * (T2 - IT2(3))
         END IF
C                                       Man-readable form
      IF (TSTART.LE.0.0) THEN
         IF (TEND.GE.1.0E4) THEN
            MSGTXT = 'All times included'
         ELSE
            WRITE (MSGTXT,1015) IT2, T2
            IF (MSGTXT(37:37).EQ.' ') MSGTXT(37:37) = '0'
            END IF
      ELSE
         IF (TEND.GE.1.0E4) THEN
            WRITE (MSGTXT,1016) IT1, T1
            IF (MSGTXT(24:24).EQ.' ') MSGTXT(24:24) = '0'
         ELSE
            WRITE (MSGTXT,1017) IT1, T1, IT2, T2
            IF (MSGTXT(24:24).EQ.' ') MSGTXT(24:24) = '0'
            IF (MSGTXT(44:44).EQ.' ') MSGTXT(44:44) = '0'
            END IF
         END IF
      CALL MSGWRT (5)
      MSGTXT = '-------------------------------------------------------'
      CALL MSGWRT (5)
C                                       now report results
      WRITE (MSGTXT,1020) XTYPE(1), XMIN
      CALL MSGWRT (5)
      WRITE (MSGTXT,1020) XTYPE(2), XQ1
      CALL MSGWRT (5)
      WRITE (MSGTXT,1020) XTYPE(3), XMED
      CALL MSGWRT (5)
      WRITE (MSGTXT,1020) XTYPE(4), XQ3
      CALL MSGWRT (5)
      WRITE (MSGTXT,1020) XTYPE(5), XMAX
      CALL MSGWRT (5)
      WRITE (MSGTXT,1020) XTYPE(6), XMAD
      CALL MSGWRT (5)
      WRITE (MSGTXT,1020) XTYPE(7), XMEAN
      CALL MSGWRT (5)
      UVAVG = XMEAN
      WRITE (MSGTXT,1020) XTYPE(8), XVAR
      CALL MSGWRT (5)
      WRITE (MSGTXT,1020) XTYPE(9), XSTD
      CALL MSGWRT (5)
      UVSTD = XSTD
      WRITE (MSGTXT,1020) XTYPE(10), XRMS
      CALL MSGWRT (5)
      WRITE (MSGTXT,1025) XTYPE(11), VSUM
      CALL MSGWRT (5)
      WRITE (MSGTXT,1025) XTYPE(12), VSUMS
      CALL MSGWRT (5)
      WRITE (MSGTXT,1030) XTYPE(13), NSAMP
      CALL MSGWRT (5)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Samples limited to IFs',I3,' -',I3,' channels',I6,' -',
     *   I6)
 1005 FORMAT (10I5)
 1010 FORMAT (3(1X,'''',A,'''',1X))
 1015 FORMAT ('Timerange = beginning to',I5,'/',2(I2.2,':'),F5.2)
 1016 FORMAT ('Timerange =',I5,'/',2(I2.2,':'),F5.2,' to end')
 1017 FORMAT ('Timerange =',I5,'/',2(I2.2,':'),F5.2,' to',
     *   I5,'/',2(I2.2,':'),F5.2)
 1020 FORMAT (A,F13.6)
 1025 FORMAT (A,1PE13.6)
 1030 FORMAT (A,I13)
 2020 FORMAT ('IF number',2I3,'__Spectral channel',2I5)
 2021 FORMAT ('IF number',2I3)
 2022 FORMAT ('Spectral channel',2I5)
      END
      SUBROUTINE UVRMSP (STOKES, IRET)
C-----------------------------------------------------------------------
C    UVRMSP plots the histogram
C    Outputs:
C       IRET   I   > 0 => plot failure
C-----------------------------------------------------------------------
      CHARACTER STOKES*4
      INTEGER   IRET
C
      INCLUDE 'UVRMS.INC'
      INTEGER   I, PLUN, PLBLK(256), IVER, TVCHN, TVCORN(4), IDEPTH(5),
     *   J, NCHAR, IT(3), ID(3), JTRIM, LTYPE, LABEL, NOUT(2), PIND,
     *   IROUND
      LOGICAL   DOTV, FLAG
      CHARACTER PFILE*48, CHT12*12, CHT6*6, CHTY*2, UNITS(5)*20,
     *   STRING*80, CHT8*8, NS*18, ADATE*12, ATIME*8
      REAL      YMAX, YMIN, BLC(2), TRC(2), CH(4), X, X2, Y1, Y2,
     *   XYRATO, DX, DY, XSCALE, YSCALE
      DOUBLE PRECISION XX
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA TVCHN, TVCORN, IDEPTH /1, 4*0, 5*1/
      DATA UNITS /'Amplitude (Jy)', 'Real part (Jy)', 'Imaginary (Jy)',
     *   'Phase (degrees)', 'Scalar amp (Jy)'/
C-----------------------------------------------------------------------
      DOTV = XDOTV.GT.0.0
      NOUT(1) = HISTOG(0) + 0.1
      NOUT(2) = HISTOG(NBOXES+1) + 0.1
C                                       Logarithm, y scale
      IF (FUNTYP.EQ.'LG') THEN
         DO 10 I = 1,NBOXES
            IF (HISTOG(I).LE.0.0) THEN
               HISTOG(I) = LOG10 (0.5)
            ELSE
               HISTOG(I) = LOG10 (HISTOG(I))
               END IF
 10         CONTINUE
         END IF
      YMAX = -1.E10
      YMIN = -YMAX
      DO 20 I = 1,NBOXES
         YMIN = MIN (YMIN, HISTOG(I))
         YMAX = MAX (YMAX, HISTOG(I))
 20      CONTINUE
C                                       Add plot file to the image
C                                       catalog header.
      IF (.NOT.DOTV) THEN
         CHT12 = ' '
         CHT6 = ' '
         CHTY = ' '
         IF (IDOPLT.LT.2) THEN
            CALL CATDIR ('CSTA', DISKIN, OLDCNO, CHT12, CHT6, 0, CHTY,
     *         0, 'CLRD', SCRBUF, IRET)
            IF (IRET.EQ.0) CALL CATDIR ('CSTA', DISKIN, OLDCNO, CHT12,
     *         CHT6, 0, CHTY, 0, 'WRIT', SCRBUF, IRET)
            FRW(NCFILE) = 1
            END IF
         CALL MADDEX ('PL', DISKIN, OLDCNO, CATOLD, SCRBUF, .TRUE.,
     *      'WRIT', IVER, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'UVRMSP: ERROR UPDATING CATALOG HEADER.'
            CALL MSGWRT (8)
            GO TO 999
            END IF
         END IF
C                                       Open the PLot file.
      CALL ZPHFIL ('PL', DISKIN, OLDCNO, IVER, PFILE, IRET)
      APARM(10) = 2
      SOLINT = SOLINT * 24.0 * 60.0
      CALL GINIT (DISKIN, OLDCNO, PFILE, 0, 67, NPARM, XNAMEI, DOTV,
     *   TVCHN, GRCHAN, TVCORN, CATOLD, PLBLK, PLUN, PIND, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UVRMSP: ERROR OPENING PLOT FILE FOR THE HISTOGRAM.'
         CALL MSGWRT (8)
         IF (.NOT.DOTV) CALL DELEXT ('PL', DISKIN, OLDCNO, 'WRIT',
     *      CATOLD, SCRBUF, IVER, I)
         GO TO 999
         END IF
      SOLINT = SOLINT / (24.0 * 60.0)
C                                       Set BLC, TRC, XYRATO.
      BLC(1) = -1.0
      BLC(2) = -1.0
      TRC(1) = 102.0
      TRC(2) = 102.0
C                                       Set coordinate common
      LOCNUM = 1
      RPVAL(1,LOCNUM) = XPIXR(1)
      RPVAL(2,LOCNUM) = YMIN
      RPLOC(1,LOCNUM) = 1.0
      RPLOC(2,LOCNUM) = 1.0
      AXINC(1,LOCNUM) = (XPIXR(2) - XPIXR(1)) / 99.0
      AXINC(2,LOCNUM) = (YMAX - YMIN) / 99.0
      ROT(LOCNUM) = 0.0
      NCHLAB(1,LOCNUM) = 0
      NCHLAB(2,LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      CORTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 4
      AXFUNC(1,LOCNUM) = 0
      AXFUNC(2,LOCNUM) = 0
      NCHLAB(1,LOCNUM) = 0
      NCHLAB(2,LOCNUM) = 0
      CTYP(1,LOCNUM) = UNITS(IOPT)
      IF (FUNTYP.EQ.'LG') THEN
         CTYP(2,LOCNUM) = 'LOG10 (counts)'
      ELSE
         CTYP(2,LOCNUM) = 'Counts'
         END IF
C                                       metric scaling
      LABEL = IROUND (XLABEL)
      DO 30 I = 1,2
         Y1 = ABS (AXINC(I,LOCNUM) * (TRC(I) - BLC(I)))
         Y2 = Y1
         CALL METSCL (LABEL, Y2, CPREF(I,LOCNUM), FLAG)
         IF ((.NOT.FLAG) .AND. (Y1.NE.0.0)) THEN
            RPVAL(I,LOCNUM) = RPVAL(I,LOCNUM) * Y2 / Y1
            AXINC(I,LOCNUM) = AXINC(I,LOCNUM) * Y2 / Y1
         ELSE
            CPREF(I,LOCNUM) = ' '
            END IF
 30      CONTINUE
C                                       Set character offsets.
      LTYPE = MOD (ABS (LABEL), 100)
      CALL RFILL (4, 0.5, CH)
      CALL CHNTIC (BLC, TRC, J)
      IF (LTYPE.EQ.2) CH(1) = 2.5
      IF (LTYPE.GT.2) CH(1) = J + 4.0
      IF (LTYPE.GT.1) CH(2) = 2.0
      IF (LTYPE.GT.2) CH(2) = CH(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         CH(2) = CH(2) + 1.333
         IF (LTITLE.NE.' ') CH(2) = CH(2) + 1.333
         IF ((NOUT(1).GT.0) .OR. (NOUT(2).GT.0)) CH(2) = CH(2) + 1.333
         CH(4) = 2.0
         IF (LABEL.GT.0) CH(4) = CH(4) + 1.333
         END IF
      IF (DOTV) THEN
         DX = WINDTV(3) - WINDTV(1) + 1 - CSIZTV(1) * (CH(1) + CH(3))
         DY = WINDTV(4) - WINDTV(2) + 1 - CSIZTV(2) * (CH(2) + CH(4))
         XYRATO = 1.0
         IF (DY.GT.0.0) XYRATO = DX / DY
      ELSE
         XYRATO = 1.0
         END IF
C                                       Initialize for line drawing
      CALL GINITL (BLC, TRC, XYRATO, CH, IDEPTH, PLBLK, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UVRMSP: ERROR INITIALIZING FOR LINE DRAWING.'
         GO TO 950
         END IF
      CALL GLTYPE (1, PLBLK, IRET)
      IF (IRET.NE.0) GO TO 920
C                                       Draw borders.
      CALL GPOS (BLC(1), BLC(2), PLBLK, IRET)
      IF (IRET.NE.0) GO TO 910
      CALL GVEC (TRC(1), BLC(2), PLBLK, IRET)
      IF (IRET.NE.0) GO TO 920
      CALL GVEC (TRC(1), TRC(2), PLBLK, IRET)
      IF (IRET.NE.0) GO TO 920
      CALL GVEC (BLC(1), TRC(2), PLBLK, IRET)
      IF (IRET.NE.0) GO TO 920
      CALL GVEC (BLC(1), BLC(2), PLBLK, IRET)
      IF (IRET.NE.0) GO TO 920
C                                       Calculate range and scales.
      XSCALE = 99.0 / NBOXES
      YSCALE = 99.0 / (YMAX - YMIN)
C                                       Labeling: source, freq, etc
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DX = 0.0
         DY = 0.5
         CALL H2CHR (8, 1, CATOH(KHOBJ), CHT8)
         XX = (CATOD(KDCRV+JLOCF) + CATOR(KRCIC+JLOCF)
     *      * (1.0 - CATOR(KRCRP+JLOCF))) / 1.0E6
         WRITE (STRING,1030) CHT8, XX, STOKES
         NS = NAMEIN // CLAIN
         CALL NAMEST (NS, CATOLD(KIIMS), STRING(31:), I)
         CALL REFRMT (STRING, '_', NCHAR)
         CALL GPOS (BLC(1), TRC(2), PLBLK, IRET)
         IF (IRET.NE.0) GO TO 910
         CALL GCHAR (NCHAR, 0, DX, DY, STRING, PLBLK, IRET)
         IF (IRET.NE.0) GO TO 930
         END IF
C                                       Labeling: date
      IF ((LABEL.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, ATIME, ADATE)
         WRITE (STRING,1031) IVER, ADATE, ATIME
         DY = DY + 1.333
         CALL REFRMT (STRING, '_', NCHAR)
         CALL GPOS (BLC(1), TRC(2), PLBLK, IRET)
         IF (IRET.NE.0) GO TO 910
         CALL GCHAR (NCHAR, 0, DX, DY, STRING, PLBLK, IRET)
         IF (IRET.NE.0) GO TO 930
         END IF
C                                       Labeling: bin stuff
      WRITE (STRING,1035) NBOXES
      CALL CHTRIM (STRING, 10, STRING, NCHAR)
      NCHAR = NCHAR + 2
      STRING(NCHAR-1:) = ' '
      STRING(NCHAR:) = ' bins of width '
      NCHAR = NCHAR + 15
      X = (XPIXR(2) - XPIXR(1)) / (NBOXES - 1)
      WRITE (ADATE,1036) X
      STRING(NCHAR:) = ADATE(2:10)
      NCHAR = JTRIM (STRING)
      MSGTXT = 'Plot ' // STRING
      CALL MSGWRT (4)
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DY = -1.5 - 1.333
         IF (LTYPE.GT.2) DY = DY - 1.333
         CALL GPOS (BLC(1), BLC(2), PLBLK, IRET)
         IF (IRET.NE.0) GO TO 910
         CALL GCHAR (NCHAR, 0, DX, DY, STRING, PLBLK, IRET)
         IF (IRET.NE.0) GO TO 930
C                                       samples outside
         IF ((NOUT(1).GT.0) .OR. (NOUT(2).GT.0)) THEN
            WRITE (STRING,1040) NOUT
            CALL REFRMT (STRING, '_', NCHAR)
            DY = DY - 1.333
            CALL GPOS (BLC(1), BLC(2), PLBLK, IRET)
            IF (IRET.NE.0) GO TO 910
            CALL GCHAR (NCHAR, 0, DX, DY, STRING, PLBLK, IRET)
            IF (IRET.NE.0) GO TO 930
            END IF
C                                       lower title: chan, IF
         IF (LTITLE.NE.' ') THEN
            NCHAR = JTRIM (LTITLE)
            DY = DY - 1.333
            CALL GPOS (BLC(1), BLC(2), PLBLK, IRET)
            IF (IRET.NE.0) GO TO 910
            CALL GCHAR (NCHAR, 0, DX, DY, LTITLE, PLBLK, IRET)
            IF (IRET.NE.0) GO TO 930
            END IF
         END IF
C                                       tick marks, labels, ...
      CALL CLAB1 (BLC, TRC, CH, LABEL, XYRATO, .FALSE., PLBLK, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UVRMSP: PLOT ERROR OCCURRED WHILE DRAWING TICKS.'
         GO TO 950
         END IF
C                                       Draw the histogram
      CALL GLTYPE (2, PLBLK, IRET)
      IF (IRET.NE.0) GO TO 920
      X = 1.0
      CALL GPOS (X, 1.0, PLBLK, IRET)
      IF (IRET.NE.0) GO TO 910
      DO 40 I = 1,NBOXES
         Y1 = HISTOG(I)
         Y1 = (Y1 - YMIN) * YSCALE + 1.0
         CALL GVEC (X, Y1, PLBLK, IRET)
         IF (IRET.NE.0) GO TO 920
         X2 = X + XSCALE
         CALL GVEC (X2, Y1, PLBLK, IRET)
         IF (IRET.NE.0) GO TO 920
         X = X2
 40      CONTINUE
C                                       Mark quartiles
      CALL GLTYPE (4, PLBLK, IRET)
      IF (IRET.NE.0) GO TO 920
      DY = BLC(2) + 0.07 * (TRC(2) - BLC(2))
      DX = 99.0 / (XPIXR(2) - XPIXR(1))
      IF ((FITPAR(2).GT.XPIXR(1)) .AND. (FITPAR(2).LT.XPIXR(2))) THEN
         X = DX * (FITPAR(2) - XPIXR(1)) + 1.0
         CALL GPOS (X, BLC(2), PLBLK, IRET)
         IF (IRET.NE.0) GO TO 920
         CALL GVEC (X, DY, PLBLK, IRET)
         IF (IRET.NE.0) GO TO 920
         END IF
      IF ((FITPAR(4).GT.XPIXR(1)) .AND. (FITPAR(4).LT.XPIXR(2))) THEN
         X = DX * (FITPAR(4) - XPIXR(1)) + 1.0
         CALL GPOS (X, BLC(2), PLBLK, IRET)
         IF (IRET.NE.0) GO TO 920
         CALL GVEC (X, DY, PLBLK, IRET)
         IF (IRET.NE.0) GO TO 920
         END IF
      DY = BLC(2) + 0.14 * (TRC(2) - BLC(2))
      IF ((FITPAR(3).GT.XPIXR(1)) .AND. (FITPAR(3).LT.XPIXR(2))) THEN
         X = DX * (FITPAR(3) - XPIXR(1)) + 1.0
         CALL GPOS (X, BLC(2), PLBLK, IRET)
         IF (IRET.NE.0) GO TO 920
         CALL GVEC (X, DY, PLBLK, IRET)
         IF (IRET.NE.0) GO TO 920
         END IF
      CALL GFINIS (PLBLK, IRET)
      IF (IRET.NE.0) GO TO 950
      WRITE (MSGTXT,1050) IVER
      IF (.NOT.DOTV) CALL MSGWRT (3)
      GO TO 999
C                                       Error return from GPOS.
 910  MSGTXT = 'UVRMSP: PLOT ERROR OCCURRED WHILE MOVING TO A POINT.'
      GO TO 940
C                                       Error return from GVEC.
 920  MSGTXT = 'UVRMSP: PLOT ERROR OCCURRED WHILE DRAWING A LINE.'
      GO TO 940
C                                       error return from GCHAR
 930  MSGTXT = 'UVRMSP: PLOT ERROR OCCURRED WHILE DRAWING CHARACTERS.'
 940  CALL MSGWRT (8)
C                                       Destroy the PLot file on error.
 950  IF (.NOT.DOTV) THEN
         WRITE (MSGTXT,1950) IVER
         CALL MSGWRT (8)
         CALL ZCLOSE (PLUN, PIND, I)
         CALL ZDESTR (DISKIN, PFILE, I)
         CALL DELEXT ('PL', DISKIN, OLDCNO, 'WRIT', CATOLD, SCRBUF,
     *      IVER, I)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (A8,1X,F10.3,' MHz__',A4)
 1031 FORMAT ('PLot file version',I4,'__created ',A12,A8)
 1035 FORMAT (I8)
 1036 FORMAT (1PE10.3)
 1040 FORMAT ('Samples outside plot:',I8,' below,_',I8,' above')
 1050 FORMAT ('Successful  plot version',I4,' created')
 1950 FORMAT ('DESTROY PLOT VERSION',I4,' DUE TO ERRORS')
      END
      SUBROUTINE UVRMST (VALL, VTIM, STOKES, IRET)
C-----------------------------------------------------------------------
C    UVRMST plots the data vs time
C    Inputs:
C       VALL   R(*)   Data samples
C       VTIM   R(*)   Data times
C    Outputs:
C       IRET   I   > 0 => plot failure
C-----------------------------------------------------------------------
      REAL      VALL(*), VTIM(*)
      CHARACTER STOKES*4
      INTEGER   IRET
C
      INCLUDE 'UVRMS.INC'
      INTEGER   I, PLUN, PLBLK(256), IVER, TVCHN, TVCORN(4), IDEPTH(5),
     *   J, NCHAR, IT(3), ID(3), JTRIM, LTYPE, LABEL, PIND, IROUND
      LOGICAL   DOTV, FLAG
      CHARACTER PFILE*48, CHT12*12, CHT6*6, CHTY*2, UNITS(5)*20,
     *   STRING*80, CHT8*8, NS*18, ADATE*12, ATIME*8
      REAL      YMAX, YMIN, BLC(2), TRC(2), CH(4), X, Y, Y1, Y2,
     *   XYRATO, DX, DY, XSCALE, YSCALE, XMIN, XMAX
      DOUBLE PRECISION XX
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA TVCHN, TVCORN, IDEPTH /1, 4*0, 5*1/
      DATA UNITS /'Amplitude (Jy)', 'Real part (Jy)', 'Imaginary (Jy)',
     *   'Phase (degrees)', 'Scalar amp (Jy)'/
C-----------------------------------------------------------------------
      DOTV = XDOTV.GT.0.0
      YMAX = -1.E10
      YMIN = -YMAX
      XMAX = YMAX
      XMIN = YMIN
      DO 10 I = 1,NSAMP
         XMIN = MIN (XMIN, VTIM(I))
         XMAX = MAX (XMAX, VTIM(I))
         YMIN = MIN (YMIN, VALL(I))
         YMAX = MAX (YMAX, VALL(I))
 10      CONTINUE
      IF (APARM(2).GT.APARM(1)) THEN
         YMIN = APARM(1)
         YMAX = APARM(2)
         END IF
      APARM(1) = YMIN
      APARM(2) = YMAX
C                                       Add plot file to the image
C                                       catalog header.
      IF (.NOT.DOTV) THEN
         CHT12 = ' '
         CHT6 = ' '
         CHTY = ' '
         CALL CATDIR ('CSTA', DISKIN, OLDCNO, CHT12, CHT6, 0, CHTY, 0,
     *      'CLRD', SCRBUF, IRET)
         IF (IRET.EQ.0) CALL CATDIR ('CSTA', DISKIN, OLDCNO, CHT12,
     *      CHT6, 0, CHTY, 0, 'WRIT', SCRBUF, IRET)
         FRW(NCFILE) = 1
         CALL MADDEX ('PL', DISKIN, OLDCNO, CATOLD, SCRBUF, .TRUE.,
     *      'WRIT', IVER, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'UVRMST: ERROR UPDATING CATALOG HEADER.'
            CALL MSGWRT (8)
            GO TO 999
            END IF
         END IF
C                                       Open the PLot file.
      CALL ZPHFIL ('PL', DISKIN, OLDCNO, IVER, PFILE, IRET)
      APARM(10) = 1
      SOLINT = SOLINT * 24.0 * 60.0
      CALL GINIT (DISKIN, OLDCNO, PFILE, 0, 67, NPARM, XNAMEI, DOTV,
     *   TVCHN, GRCHAN, TVCORN, CATOLD, PLBLK, PLUN, PIND, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UVRMST: ERROR OPENING PLOT FILE FOR TIME PLOT'
         CALL MSGWRT (8)
         IF (.NOT.DOTV) CALL DELEXT ('PL', DISKIN, OLDCNO, 'WRIT',
     *      CATOLD, PLBLK, IVER, I)
         GO TO 999
         END IF
      SOLINT = SOLINT / (24.0 * 60.0)
      IF (GRCHAN.LE.0) CALL GCINIT (GPHTVG(4), 0, IRET)
C                                       Set BLC, TRC, XYRATO.
      BLC(1) = -1.0
      BLC(2) = -1.0
      TRC(1) = 102.0
      TRC(2) = 102.0
C                                       Set coordinate common
      LOCNUM = 1
      RPVAL(1,LOCNUM) = XMIN * 360.0
      RPVAL(2,LOCNUM) = YMIN
      RPLOC(1,LOCNUM) = 1.0
      RPLOC(2,LOCNUM) = 1.0
      AXINC(1,LOCNUM) = (XMAX - XMIN) / 99.0 * 360
      AXINC(2,LOCNUM) = (YMAX - YMIN) / 99.0
      ROT(LOCNUM) = 0.0
      NCHLAB(1,LOCNUM) = 0
      NCHLAB(2,LOCNUM) = 0
      LABTYP(LOCNUM) = 7
      CORTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 4
      AXFUNC(1,LOCNUM) = 0
      AXFUNC(2,LOCNUM) = 0
      NCHLAB(1,LOCNUM) = 0
      NCHLAB(2,LOCNUM) = 0
      CTYP(1,LOCNUM) = 'Time (hours)'
      CTYP(2,LOCNUM) = UNITS(IOPT)
C                                       metric scaling
      LABEL = IROUND (XLABEL)
      CPREF(1,LOCNUM) = ' '
      DO 30 I = 2,2
         Y1 = ABS (AXINC(I,LOCNUM) * (TRC(I) - BLC(I)))
         Y2 = Y1
         CALL METSCL (LABEL, Y2, CPREF(I,LOCNUM), FLAG)
         IF ((.NOT.FLAG) .AND. (Y1.NE.0.0)) THEN
            RPVAL(I,LOCNUM) = RPVAL(I,LOCNUM) * Y2 / Y1
            AXINC(I,LOCNUM) = AXINC(I,LOCNUM) * Y2 / Y1
         ELSE
            CPREF(I,LOCNUM) = ' '
            END IF
 30      CONTINUE
C                                       Set character offsets.
      LTYPE = MOD (ABS (LABEL), 100)
      CALL RFILL (4, 0.5, CH)
      CALL CHNTIC (BLC, TRC, J)
      IF (LTYPE.EQ.2) CH(1) = 2.5
      IF (LTYPE.GT.2) CH(1) = J + 4.0
      IF (LTYPE.GT.1) CH(2) = 2.0
      IF (LTYPE.GT.2) CH(2) = CH(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         CH(2) = CH(2) + 1.333
         IF (LTITLE.NE.' ') CH(2) = CH(2) + 1.333
         CH(4) = 2.0
         IF (LABEL.GT.0) CH(4) = CH(4) + 1.333
         END IF
      IF (DOTV) THEN
         DX = WINDTV(3) - WINDTV(1) + 1 - CSIZTV(1) * (CH(1) + CH(3))
         DY = WINDTV(4) - WINDTV(2) + 1 - CSIZTV(2) * (CH(2) + CH(4))
         XYRATO = 1.0
         IF (DY.GT.0.0) XYRATO = DX / DY
      ELSE
         XYRATO = 1.0
         END IF
C                                       Initialize for line drawing
      CALL GINITL (BLC, TRC, XYRATO, CH, IDEPTH, PLBLK, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UVRMST: ERROR INITIALIZING FOR LINE DRAWING.'
         GO TO 950
         END IF
      CALL GLTYPE (1, PLBLK, IRET)
      IF (IRET.NE.0) GO TO 920
C                                       Draw borders.
      CALL GPOS (BLC(1), BLC(2), PLBLK, IRET)
      IF (IRET.NE.0) GO TO 910
      CALL GVEC (TRC(1), BLC(2), PLBLK, IRET)
      IF (IRET.NE.0) GO TO 920
      CALL GVEC (TRC(1), TRC(2), PLBLK, IRET)
      IF (IRET.NE.0) GO TO 920
      CALL GVEC (BLC(1), TRC(2), PLBLK, IRET)
      IF (IRET.NE.0) GO TO 920
      CALL GVEC (BLC(1), BLC(2), PLBLK, IRET)
      IF (IRET.NE.0) GO TO 920
C                                       Calculate range and scales.
      XSCALE = 99.0 / (XMAX - XMIN)
      YSCALE = 99.0 / (YMAX - YMIN)
C                                       Labeling: source, freq, etc
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DX = 0.0
         DY = 0.5
         CALL H2CHR (8, 1, CATOH(KHOBJ), CHT8)
         XX = (CATOD(KDCRV+JLOCF) + CATOR(KRCIC+JLOCF)
     *      * (1.0 - CATOR(KRCRP+JLOCF))) / 1.0E6
         WRITE (STRING,1030) CHT8, XX, STOKES
         NS = NAMEIN // CLAIN
         CALL NAMEST (NS, CATOLD(KIIMS), STRING(31:), I)
         CALL REFRMT (STRING, '_', NCHAR)
         CALL GPOS (BLC(1), TRC(2), PLBLK, IRET)
         IF (IRET.NE.0) GO TO 910
         CALL GCHAR (NCHAR, 0, DX, DY, STRING, PLBLK, IRET)
         IF (IRET.NE.0) GO TO 930
         END IF
C                                       Labeling: date
      IF ((LABEL.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, ATIME, ADATE)
         WRITE (STRING,1031) IVER, ADATE, ATIME
         DY = DY + 1.333
         CALL REFRMT (STRING, '_', NCHAR)
         CALL GPOS (BLC(1), TRC(2), PLBLK, IRET)
         IF (IRET.NE.0) GO TO 910
         CALL GCHAR (NCHAR, 0, DX, DY, STRING, PLBLK, IRET)
         IF (IRET.NE.0) GO TO 930
         END IF
C                                       Labeling:
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DY = -1.5
C                                       lower title: chan, IF
         IF (LTITLE.NE.' ') THEN
            NCHAR = JTRIM (LTITLE)
            DY = DY - 1.333
            CALL GPOS (BLC(1), BLC(2), PLBLK, IRET)
            IF (IRET.NE.0) GO TO 910
            CALL GCHAR (NCHAR, 0, DX, DY, LTITLE, PLBLK, IRET)
            IF (IRET.NE.0) GO TO 930
            END IF
         END IF
C                                       tick marks, labels, ...
      CALL CLAB1 (BLC, TRC, CH, LABEL, XYRATO, .FALSE., PLBLK, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UVRMST: PLOT ERROR OCCURRED WHILE DRAWING TICKS.'
         GO TO 950
         END IF
C                                       Draw the data
      CALL GLTYPE (2, PLBLK, IRET)
      IF (IRET.NE.0) GO TO 920
      DX = 0.1
      DO 40 I = 1,NSAMP
         X = (VTIM(I) - XMIN) * XSCALE + 1.0
         Y = (VALL(I) - YMIN) * YSCALE + 1.0
         CALL GPOS (X-DX, Y+DX, PLBLK, IRET)
         IF (IRET.NE.0) GO TO 910
         CALL GVEC (X+DX, Y-DX, PLBLK, IRET)
         IF (IRET.NE.0) GO TO 920
         CALL GPOS (X+DX, Y+DX, PLBLK, IRET)
         IF (IRET.NE.0) GO TO 910
         CALL GVEC (X-DX, Y-DX, PLBLK, IRET)
         IF (IRET.NE.0) GO TO 920
 40      CONTINUE
      GPHPAG = MOD(IDOPLT,2).EQ.1
      CALL GFINIS (PLBLK, IRET)
      IF (IRET.NE.0) GO TO 950
      WRITE (MSGTXT,1050) IVER
      IF (.NOT.DOTV) CALL MSGWRT (3)
      GO TO 999
C                                       Error return from GPOS.
 910  MSGTXT = 'UVRMST: PLOT ERROR OCCURRED WHILE MOVING TO A POINT.'
      GO TO 940
C                                       Error return from GVEC.
 920  MSGTXT = 'UVRMST: PLOT ERROR OCCURRED WHILE DRAWING A LINE.'
      GO TO 940
C                                       error return from GCHAR
 930  MSGTXT = 'UVRMST: PLOT ERROR OCCURRED WHILE DRAWING CHARACTERS.'
 940  CALL MSGWRT (8)
C                                       Destroy the PLot file on error.
 950  IF (.NOT.DOTV) THEN
         WRITE (MSGTXT,1950) IVER
         CALL MSGWRT (8)
         CALL ZCLOSE (PLUN, PIND, I)
         CALL ZDESTR (DISKIN, PFILE, I)
         CALL DELEXT ('PL', DISKIN, OLDCNO, 'WRIT', CATOLD, SCRBUF,
     *      IVER, I)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (A8,1X,F10.3,' MHz__',A4)
 1031 FORMAT ('PLot file version',I4,'__created ',A12,A8)
 1050 FORMAT ('Successful  plot version',I4,' created')
 1950 FORMAT ('DESTROY PLOT VERSION',I4,' DUE TO ERRORS')
      END

      SUBROUTINE ZSSSO2 (FCB, PNAME, IERR)
C-----------------------------------------------------------------------
C! Open SUN-Screen-Server device, set-up any buffer
C# TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Assign an i/o channel (i.e., open) for SSS TV device.  Uses BSD
C   sockets
C   Inputs:
C      PNAME  H*48  'logical' name of TV device. Contains a pathname
C                   for Unix domain sockets or a name of the form
C                   sssin:machine_name for Internet domain sockets.
C                   Must begin with the string "TVDEV".
C   Outputs:
C      FCB    I(*)  File descriptor (part of FTAB).
C      IERR   I     Error code: 0 => success
C                      1 => failure
C                      2 => invalid device name
C   Generic stub
C-----------------------------------------------------------------------
      INTEGER   FCB(*), IERR
      HOLLERITH PNAME(*)
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 8
      MSGTXT = 'ZSSSO2: REQUIRES DEVELOPMENT; GENERIC IS A STUB'
      CALL MSGWRT (8)
C
 999  RETURN
      END

      SUBROUTINE QGRD1 (APCORE, UV, VIS, WT, GRID, CONX, CONY, NO2, M,
     *   LROW)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Convolves visibility data onto a grid.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Convolves visibility data onto a grid.
C   Works for total intensity mapping, accumulating weighted
C   gridded visibility values, weights and the number of times
C   a given cell has been accumulated into.
C   Inputs:
C      UV    I  Location of (u,v) values in cells.
C      VIS   I  Location of (complex) visibilities.
C      WT    I  Weight for data. Assumes any tapering
C               has already been done.
C      GRID  I  base address of gridded data.
C               Order assumed to be the following
C               for each of the M rows:
C                1) 2 * LROW visibilities
C                2) 2*LROW (count,sum weights)
C      CONX  I  base address of X convolving fn.
C      CONY  I  base address of Y convolving fn.
C      NO2   I  INT( (# cells used on a row) / 2 )
C      M     I  number of rows kept in the AP.
C      LROW  I  length of a row ( max. X).
C      In the above, X refers to rows and y to columns
C      in the gridded data, NOT on the sky.  The total
C      numbers of rows and cells used on a row should
C      be odd.
C   All AP memory I/O values are assumed floating.
C   It is assumed that all values of v correspond to row M/2.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   UV, VIS, WT, GRID, CONX, CONY, NO2, M, LROW
C
      INTEGER   JJCX, IRND, N, INCR, IADD, IX, IY
      LONGINT   JUV, JVIS, JWT, JGRID, JCONX, JCONY, JCX, JCY, JG, JA
      DOUBLE PRECISION AIM, CWT, RE, X, Y, XX, XWT, TCWT
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IRND(XX) = INT (XX + SIGN (0.5D0, XX))
C-----------------------------------------------------------------------
C                                        Convert addresses to 1 rel.
      JUV = UV + PSAPOF
      JVIS = VIS + PSAPOF
      JWT = WT + PSAPOF
      JGRID = GRID + PSAPOF
      JCONX = CONX + PSAPOF
      JCONY = CONY + PSAPOF
      N = NO2 * 2 + 1
C                                        Check weight.
      XWT = APCORE(JWT)
      IF (XWT.LE.0.0D0) GO TO 999
C                                        Determine location.
      X = APCORE(JUV+1)
      Y = APCORE(JUV)
C                                        Deter. conv. fn loc.
      JCX = IRND (100.D0 * (IRND (X)-X-0.5D0))
      JCY = IRND (100.D0 * (IRND (Y)-Y-0.5D0))
      JCX = JCX + JCONX + 100
      JCY = JCY + JCONY + 100
C                                        Determine grid loc.
      JG = JGRID
      JA = JGRID + 2 * LROW
C                                        Check end of row.
      IX = IRND (X) + LROW / 2 + 1
      IADD = LROW - NO2 - IX
C                                        Will hit end of row.
      IF (IADD.LT.0) THEN
         N = N + IADD
         IF (N.LE.0) GO TO 999
         END IF
C                                        Check front of row.
      IX = IX - NO2 - 1
C                                        Will hit front of row
      IF (IX.LT.0) THEN
         N = N + IX
         IF (N.LE.0) GO TO 999
         JCX = JCX - IX * 100
C                                        Finish grid address.
      ELSE
         JA = JA + 2 * IX
         JG = JG + 2 * IX
         END IF
C                                        Save JCX
      JJCX = JCX
C                                        Get visibility
      RE = APCORE(JVIS)
      AIM = APCORE(JVIS+1)
      INCR = 4 * LROW - 2 * N
C                                        Gridding loop
      INCLUDE 'INCS:ZVND.INC'
      DO 200 IY = 1,M
         JCX = JJCX
         TCWT = APCORE(JCY) * XWT
      INCLUDE 'INCS:ZVND.INC'
         DO 100 IX = 1,N
C                                        Compute weight.
            CWT = APCORE(JCX) * TCWT
C                                        Sum to grid.
            APCORE(JG) = APCORE(JG) + CWT * RE
            APCORE(JG+1) = APCORE(JG+1) + CWT * AIM
            APCORE(JA) = APCORE(JA) + 1.0
            APCORE(JA+1) = APCORE(JA+1) + CWT
C                                        Update pointers.
            JCX = JCX + 100
            JG = JG + 2
            JA = JA + 2
 100        CONTINUE
C                                        Update pointers.
         JCY = JCY + 100
         JG = JG + INCR
         JA = JA + INCR
 200     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE SATPRS (TEMP, PRESS, SATP)
C-----------------------------------------------------------------------
C! Calculate saturation water pressure
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Function to calculate saturation vapor pressure over water or ice,
C   in millibar, given temperature (temp) in degrees C, and pressure
C   (press) in millibar.  Taken from:
C      Buck, A.L., New Equations for Computing Vapor Pressure and
C        Enhancement Factor, J. Appl. Met., v.20, pp. 1527-1532, 1981
C   who references:
C      Wexler, A., Vapor Pressure Formulation for Water in the Range
C         0C to 100C - A Revision, J. Res. Natl. Bur. Stand., v.80A,
C         pp. 775 ff, 1976
C   and
C      Wexler, A., Vapor Pressure Formulation for Ice, J. Res. Natl.
C        Bur. Stand., v.81A, pp. 5-20, 1977
C   for the "exact" formulations - which are reworks of the Goff-Gratch
C   formulation:
C      Goff, J.A., and S. Gratch, Low-pressure Properties of Water from
C        -160F to 212F. Trans. Am. Soc. Heat. Vent. Eng., v. 52, 95-121,
C        1946
C   note that i use the fw5 and fi5 coefficients for the "enhancement
C   factor" from Table 3 of Buck.
C   Bryan Butler, NRAO
C-----------------------------------------------------------------------
      REAL      TEMP, PRESS, SATP
C
      DOUBLE PRECISION THETA, EW, EI, FW, FI, AOW, AOI, BOW, BOI, COW,
     *   COI, DOW, DOI, EOW, EOI
      DATA AOW, BOW, COW, DOW, EOW / 4.1D-4, 3.48D-6, 7.4D-10, 30.6D0,
     *                               -3.8D-2 /
      DATA AOI, BOI, COI, DOI, EOI / 4.8D-4, 3.47D-6, 5.9D-10, 23.8D0,
     *                               -3.1D-2 /
C-----------------------------------------------------------------------
      THETA = TEMP + 273.15D0
C                                       !!! water !!!
      IF (TEMP.GT.0.01D0) THEN
         EW = (-2991.2729D0 / THETA**2) + (-6017.0128 / THETA) +
     *      (18.87643854D0) + (-0.028354721D0 * THETA) +
     *      (0.17838301D-4 * THETA**2) +
     *      (-0.84150417D-9 * THETA**3) +
     *      (0.44412543D-12 * THETA**4) +
     *      (2.858487D0 * DLOG(THETA))
         EW = 0.01D0 * DEXP (EW)
         FW = 1.0D0 + AOW +
     *      PRESS * (BOW + COW * (TEMP + DOW + EOW * PRESS)**2)
         SATP = EW * FW
C                                       !!! ice !!!
      ELSE
         EI = (-5865.3696D0 / THETA) +
     *      (22.241033D0) + (0.013749042D0 * THETA) +
     *      (-0.34031775D-4 * THETA**2) +
     *      (0.26967687D-7 * THETA**3) +
     *      (0.6918651D0 * DLOG(THETA))
         EI = 0.01D0 * DEXP (EI)
         FI = 1.0D0 + AOI +
     *      PRESS * (BOI + COI * (TEMP + DOI + EOI * PRESS)**2)
         SATP = EI * FI
         END IF
C
 999  RETURN
      END

      SUBROUTINE YGRAFX (OP, GRFX, RED, GREEN, BLUE, IERR)
C-----------------------------------------------------------------------
C! read/write TV graphics colors
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YGRAFX modifies the colour of the graphics or cursor.
C   Inputs:
C      OP       C*4   READ or WRITE graphics colour assignment.
C      GRFX     I     Cursor (0), or graphics plane number.
C   In/Out:
C      RED      R     Red,   0.0 - 1.0
C      GREEN    R     Green, 0.0 - 1.0
C      BLUE     R     Blue,  0.0 - 1.0
C   Output:
C      IERR     I     Error status, 0 means success.
C   Version for Virtual TV devices.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   GRFX, IERR
      REAL      BLUE, GREEN, RED
C
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
C                                       Check inputs.
      IERR = 0
      IF ((GRFX.LT.0) .OR. (GRFX.GT.NGRAPH)) THEN
         WRITE (MSGTXT,1000) GRFX
         IERR = 2
         GO TO 990
         END IF
C                                       Unrecognized OP.
      IF ((OP.NE.'READ') .AND. (OP.NE.'WRIT')) THEN
         MSGTXT = 'YGRAFX: Unrecognized OP code - ' // OP
         IERR = 2
         GO TO 990
         END IF
C                                       Change colors
      BUFFER(1) = GRFX
      IF (OP.EQ.'WRIT') THEN
         BUFFER(2) = MAX (0.0, MIN (1.0, RED)) * 10000.0 + 0.5
         BUFFER(3) = MAX (0.0, MIN (1.0, GREEN)) * 10000.0 + 0.5
         BUFFER(4) = MAX (0.0, MIN (1.0, BLUE)) * 10000.0 + 0.5
         BUFSW = 4
         BUFSR = 0
C                                       RGRFX opcode.
      ELSE
         BUFSW = 1
         BUFSR = 4
         END IF
C                                       Do IO
      CALL MKYBUF (OP, 'YGRAFX', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
      IF ((IERR.EQ.0) .AND. (OP.EQ.'READ')) THEN
         CALL UNYBUF (BUFSR, BUFFER, HEADER)
         RED = BUFFER(2) / 10000.0
         GREEN = BUFFER(3) / 10000.0
         BLUE = BUFFER(4) / 10000.0
         END IF
      GO TO 999
C
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('YGRAFX: INVALID GRAPHICS PLANE NUMBER',I4)
      END

      SUBROUTINE PLINIT (IGTYPE, IVOL, ICNO, CATBLK, NP, RPARM, WDOTV,
     *   IGRCHN, ITVCHN, ITVORG, PLTBUF, IERR)
C-----------------------------------------------------------------------
C! initialize plotting commons
C# Utility Plot
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 2002, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This routine will initialise plotting to a TV device or a plot
C   file. The PL file is opened if necessary and the catalog header
C   updated. The catalog header needs previously to have been read
C   and the status marked as 'WRIT'.
C   Input parameters:
C      IVOL     I       Disk volume number.
C      ICNO     I       Catalog slot number.
C      CATBLK   I(256)  Catalog header.
C      NP       I       Number of floating point words in parameter
C                       list received from AIPS.
C      RPARM    R(NP)   AIPS parameters.
C      WDOTV    L       True to use TV, else write to PL file.
C      IGRCHN   I       TV Grey channel to use (0 => 1)
C      ITVCHN   I       TV graphics channel to use (0 => 1)
C      ITVORG   I(2)    X,Y TV pixel to put plot origin (0=> centre)
C   Input/ output:
C      IGTYPE   I       Task specific plot file type: 1=misc.; else
C                       consult AIPSUB:AU8A.
C      PLTBUF   I(256)  Work Buffer
C   Output parameters:
C      IERR     I       Error code (0 => ok)
C   Output via common:
C      JPLVER     I       PL file version created.
C      GPHIND   I       in /GPHCOM/.
C      TVCORN   I(4)    Set to zeroes.
C      WPDOTV   L       Plot on TV device ?
C      GRCHN    I       Graphics channel.
C      IGFIND   I       Location in FTAB for graphics file.
C      IGLUN    I       Graphics LU number.
C      TVCHN    I       TV channel.
C      LPLNAM   C*48    Physical filename PL file.
C      IPLSTA   I       Plot file status (1=>open; 0=> closed)
C-----------------------------------------------------------------------
      LOGICAL   WDOTV
      INTEGER   CATBLK(256), PLTBUF(256), IGTYPE, IVOL, ICNO, NP,
     *   IGRCHN, ITVCHN, ITVORG(2), IERR
      REAL      RPARM(*)
C
      INTEGER   IGSIZE, IER
      LOGICAL   WTRUE
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DPLD.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA IGSIZE /0/
      DATA WTRUE /.TRUE./
C-----------------------------------------------------------------------
C                                       Set common variables in DPLT
      WPDOTV = WDOTV
      TVCHN = ITVCHN
      GRCHN = IGRCHN
      CALL COPY (2, ITVORG, TVCORN)
C                                       Check range of plot type
      IF (IGTYPE.LT.1) IGTYPE = 1
C                                       Add plot file to header
      JPLVER = 0
      IF (.NOT.WDOTV) THEN
         CALL MADDEX ('PL', IVOL, ICNO, CATBLK, PLTBUF, WTRUE, 'READ',
     *      JPLVER, IERR)
         IF (IERR.NE.0) GO TO 999
         WRITE (MSGTXT,1020) JPLVER
         CALL MSGWRT (6)
         END IF
C                                       Construct physical filename
      CALL ZPHFIL ('PL', IVOL, ICNO, JPLVER, LPLNAM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open plot file
      CALL GINIT (IVOL, ICNO, LPLNAM, IGSIZE, IGTYPE, NP, RPARM, WDOTV,
     *   TVCHN, GRCHN, TVCORN, CATBLK, PLTBLK, IGLUN, IGFIND, IERR)
      IF (IERR.NE.0) THEN
         GPHIND = 0
         IPLSTA = 0
         IF (.NOT.WDOTV) CALL DELEXT ('PL', IVOL, ICNO, 'WRIT', CATBLK,
     *      PLTBUF, JPLVER, IER)
      ELSE
         IPLSTA = 1
         END IF
C                                       Exit
 999  RETURN
C-----------------------------------------------------------------------
1020  FORMAT ('Plot file version',I5,' created')
      END

      SUBROUTINE DLESQR (NP, N, SUM, SSQ, R, M, X, VX, SSQRES, VARRES,
     *   VARY, FIT, IERR)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2001, 2010, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DLESQR does the matrix inversion and other necessary tasks involved
C   in a least squares analysis.
C   Inputs:
C      NP       I          Number of parameters.
C      N        D          The number of observations.
C      SUM      D          Error sum.
C      SSQ      D          Square error sum.
C      R        D(NP)      Results vector.
C   In/out:
C      M        D(NP,NP)   On input, the upper triangular part contains
C                            the design matrix.  This is not changed.
C                          On output, the lower triangular part contains
C                            the covariance matrix.  Diagonal elements of
C                            the covariance matrix are stored in VX.
C   Output:
C      X        D(NP)      Vector holding the least squares solution.
C      VX       D(NP)      Variance of the best fit parameters.
C      SSQRES   D          Sum of squares of the residuals.
C      VARRES   D          Variance of the residuals.
C      VARY     D          Variance of the error values.
C      FIT      D          Goodness of fit parameter, lies between 0 & 1
C      IERR     I          Error status, 0 means successful.
C                             1 - nonspecific error return,
C                             2 - insufficient degrees of freedom.
C     Called:
C          none
C     Algorithm:
C          LU-triangular factorization with scaled partial pivoting.
C          The sub-diagonal triangular matrix contains the scaling
C          factors used at each step in the Gaussian elimination.  Row
C          interchanges are recorded in vectors MXS and SXM.
C             During forward substitution, the pivoting and Gaussian
C          elimination operations performed on matrix M are applied to
C          vector R.  Vector X holds the intermediate result.
C             On backward substitution, successive elements of the
C          solution vector, X, are calculated by substitution of the
C          preceding elements into the equations of the upper triangular
C          factorization of the design matrix.
C
C     Notes:
C       1) Strictly speaking, the design matrix will usually contain
C          rows of zeroes and therefore be singular.  This arises if no
C          observations sensitive to a particular parameter have been
C          done.
C             In practice, any such singularities are ignored and the
C          associated parameters remain undetermined.
C
C       2) The covariance matrix is the inverse of M(i,j) multiplied by
C          the variance of the residuals.  It is obtained by forward and
C          backward substitution on the columns of the unit matrix.
C
C       3) Two statement functions, C, and SC have been employed to
C          partially alleviate the problems posed by passing arrays in
C          FORTRAN.  The design/covariance matrix m(i,j) is copied into
C          the working vector s(i).  This is addressed by using C, and
C          SC in an attempt to make it look like the matrix that it
C          actually represents.
C
C       4) The maximum size problem that DLESQR can handle is set by
C          parameter MX.
C
C     Author:
C          Mark Calabretta, Australia Telescope.
C          Origin; 1988/Sep/29. Code last modified; 1989/Nov/22.
C          Leonid Kogan modified the original version to
C          double precision; 2001/May/30.
C-----------------------------------------------------------------------
      INTEGER   NP, IERR
      DOUBLE PRECISION N, SUM, SSQ, R(NP), M(NP,NP), X(NP), VX(NP),
     *   SSQRES, VARRES, VARY, FIT
C                                       Maximum size problem.
      INTEGER   MX
      PARAMETER (MX = 500)

      INTEGER   C, I, ITEMP, J, K, MXS(MX), NF, PIVOT, SXM(MX)
      DOUBLE PRECISION   COLMAX, DTEMP, RESIDU, RLEN, ROWMAX(MX),
     *   S(MX*MX), SC, RTEMP, W(MX), ZERO, ONE
      INCLUDE 'INCS:DMSG.INC'
      DATA ZERO, ONE /0.0D0, 1.0D0/
C-----------------------------------------------------------------------
C                                       Statement functions for array
C                                       manipulation, see note 3 above.
      C(I,J)  = NP*(I-1) + J
      SC(I,J) = S(C(I,J))
C-----------------------------------------------------------------------
C                                       Initialize.
C                                       return immediately on error.
      IERR = 1
      DO 40 I = 1,NP
C                                       records row interchanges.
         MXS(I) = I
C                                       solution and variance vectors.
         X(I)  = ZERO
         VX(I) = ZERO
C                                       Copy the design matrix and zero
C                                       the covariance matrix.
         DO 10 J = 1,I-1
            M(I,J) = ZERO
            S(C(I,J)) = M(J,I)
 10         CONTINUE
         DO 20 J = I,NP
            S(C(I,J)) = M(I,J)
 20         CONTINUE
C                                       Find the maximum absolute
C                                       element in each row.
         ROWMAX(I) = ZERO
         DO 30 J = 1, NP
            ROWMAX(I) = MAX (ROWMAX(I), ABS (SC(I,J)))
 30         CONTINUE
 40      CONTINUE
      VARY   = ZERO
      SSQRES = ZERO
      VARRES = ZERO
      FIT    = ZERO
C                                       Find number of degrees freedom
      NF = N
      DO 60 I = 1,NP
         IF (ROWMAX(I).NE.ZERO) THEN
            NF = NF - 1
C                                       Any row of zeroes must extend
C                                       to the results vector.
         ELSE IF (R(I).NE.ZERO) THEN
            WRITE (MSGTXT,1050) I
            CALL MSGWRT (6)
            END IF
 60      CONTINUE
C                                       insufficient deg of freesom
      IF (NF.LE.1) THEN
         WRITE (MSGTXT,1070)
         CALL MSGWRT (6)
         IERR = 2
         GO TO 999
         END IF
C                                       Factorize the matrix.
      DO 120 K = 1,NP
C                                       Check for a row of zeroes.
         IF (ROWMAX(K).NE.ZERO) THEN
C                                       A non-zero row maximum =>
C                                       non-zero diagonal element.
            IF (SC(K,K).EQ.ZERO) THEN
               WRITE (MSGTXT,1050) MXS(K)
               CALL MSGWRT (6)
               GO TO 120
               END IF
C                                       Decide whether to pivot.
            COLMAX = ABS(SC(K,K)) / ROWMAX(K)
            PIVOT = K
            DO 80 I = K+1,NP
               IF (ROWMAX(I).NE.ZERO) THEN
                  IF (ABS(SC(I,K))/ROWMAX(I).GT.COLMAX) THEN
                     COLMAX = ABS(SC(I,K))/ROWMAX(I)
                     PIVOT = I
                     END IF
                  END IF
 80            CONTINUE
C                                       We must pivot, interchange the
C                                       rows of the design matrix.
            IF (PIVOT.GT.K) THEN
               DO 90 J = 1, NP
                  DTEMP = SC(PIVOT,J)
                  S(C(PIVOT,J)) = SC(K,J)
                  S(C(K,J)) = DTEMP
 90               CONTINUE
C                                       Don't forget the vector of
C                                       row maxima.
               DTEMP = ROWMAX(PIVOT)
               ROWMAX(PIVOT) = ROWMAX(K)
               ROWMAX(K) = DTEMP
C                                       Record the interchange for later
               ITEMP = MXS(PIVOT)
               MXS(PIVOT) = MXS(K)
               MXS(K) = ITEMP
               END IF
C                                       Gaussian elimination.
            DO 110 I = K+1, NP
C                                       Nothing to do if SC(i,k) is 0
               IF (SC(I,K).NE.ZERO) THEN
C                                       Save the scaling factor.
                  S(C(I,K)) = SC(I,K)/SC(K,K)
C                                       Subtract rows.
                  DO 100 J = K+1,NP
                     S(C(I,J)) = SC(I,J) - SC(I,K)*SC(K,J)
 100                 CONTINUE
                  END IF
 110           CONTINUE
            END IF
 120     CONTINUE
C                                       MXS(i) records which row of M
C                                          corresponds to row i of SC.
C                                       SXM(i) records which row of S
C                                           corresponds to row i of M.
      DO 130 I = 1, NP
         SXM(MXS(I)) = I
 130     CONTINUE
C                                       Solve the normal equations.
      DO 150 I = 1,NP
C                                       Forward substitution.
         W(I) = R(MXS(I))
         DO 140 J = 1,I-1
            W(I) = W(I) - SC(I,J)*W(J)
 140        CONTINUE
 150     CONTINUE
      DO 170 I = NP,1,-1
C                                       Backward substitution.
         IF (SC(I,I).NE.ZERO) THEN
            DO 160 J = I+1,NP
               W(I) = W(I) - SC(I,J)*W(J)
 160           CONTINUE
            W(I) = W(I)/SC(I,I)
            END IF
         X(I) = W(I)
 170     CONTINUE
C                                       Check if solution is acceptable.
      RLEN = ZERO
      RESIDU = ZERO
      DO 200 I = 1,NP
         RTEMP = ZERO
         DO 180 J = 1,I-1
            RTEMP = RTEMP + M(J,I)*X(J)
 180        CONTINUE
         DO 190 J = I, NP
            RTEMP = RTEMP + M(I,J)*X(J)
 190        CONTINUE
         RLEN = RLEN + R(I)**2
         RESIDU = RESIDU + (RTEMP - R(I))**2
 200     CONTINUE
C                                       fails
      IF (RESIDU.GT.0.001*RLEN) THEN
         WRITE (MSGTXT,1210) RESIDU/RLEN
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Determine goodness-of-fit
C                                       estimates and statistical errors
      SSQRES = SSQ
      DO 220 I = 1, NP
         SSQRES = SSQRES - X(I)*R(I)
 220     CONTINUE
      SSQRES = MAX (ZERO, SSQRES)
      VARRES = SSQRES/NF
      VARY = (SSQ - SUM*SUM/N)/(N - ONE)
      FIT = ONE
      IF (VARY.NE.ZERO) FIT = ONE - SSQRES / (SSQ - SUM*SUM/N)
C                                       Determine the covariance matrix.
      DO 280 K = 1, NP
C                                       Forward substitution affects
C                                       only that part of W() below the
C                                       first non-zero entry.
         DO 230 I = 1,SXM(K)-1
            W(I) = ZERO
 230        CONTINUE
         W(SXM(K)) = ONE
C                                       Forward substitution.
         DO 250 I = SXM(K)+1,NP
            W(I) = 0.0
            DO 240 J = SXM(K),I-1
               W(I) = W(I) - SC(I,J)*W(J)
 240           CONTINUE
 250        CONTINUE
         DO 270 I = NP,K, -1
            IF (SC(I,I).NE.ZERO) THEN
C                                       Backward substitution.
               DO 260 J = I+1,NP
                  W(I) = W(I) - SC(I,J)*W(J)
 260              CONTINUE
               W(I) = W(I)/SC(I,I)
               END IF
C                                       Off diagonal elements of the
C                                       covariance matrix.
            IF (I.NE.K) THEN
               M(I,K) = VARRES*W(I)
C                                       Diagonal elements of the
C                                       covariance matrix.
            ELSE IF (I.EQ.K) THEN
               VX(K)  = VARRES*W(I)
               END IF
 270        CONTINUE
 280     CONTINUE
C                                       Successful completion.
      IERR = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('DLESQR: Design matrix inconsistency in row',I4)
 1070 FORMAT ('DLESQR: Insufficient degrees of freedom.')
 1210 FORMAT ('DLESQR: The solution is discrepant at',E8.1)
      END

      SUBROUTINE YOFM (OP, COLOR, VRTRTC, OFM, IERR)
C-----------------------------------------------------------------------
C! read/write all-channel look-up-table ("output function memory")
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YOFM reads/writes full OFM look up tables to TV.
C   Inputs:
C      OP      C*4    'READ' from TV, 'WRIT' to TV
C      COLOR   I      color select bit mask (RGB <-> 421)
C      VRTRTC  L      T => do it only during vertical retrace
C   In/Out:
C      OFM     R(*)   look up table (dimension = OFMINP+1, values 0
C                     through 1 are used, others clipped)
C   Output:
C      IERR    I      error code of Z...XF : 0 => ok, 2 => input error
C   Virtual TV (by communication) version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   COLOR, IERR
      REAL      OFM(*)
      LOGICAL   VRTRTC
C
      INTEGER   I, J
      INCLUDE 'INCS:DVTV.INC'
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
      BUFFER(1) = COLOR
      BUFFER(2) = 0
      IF (VRTRTC) BUFFER(2) = 1
      J = OFMINP + 1
      IF (OP.EQ.'WRIT') THEN
         DO 10 I = 1,J
            BUFFER(I+2) = MAX (0.0, MIN (1.0, OFM(I))) * 10000.0
 10         CONTINUE
         BUFSW = 2 + J
         BUFSR = 0
      ELSE
         BUFSW = 2
         BUFSR = 2 + J
         END IF
      CALL MKYBUF (OP, 'YOFM', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
      IF ((IERR.EQ.0) .AND. (OP.NE.'WRIT')) THEN
         CALL UNYBUF (BUFSR, BUFFER, HEADER)
         DO 20 I = 1,J
            OFM(I) = BUFFER(I+2) / 10000.0
 20         CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE EXTREQ (FDVEC, TBIND, TAPBUF, FITBLK, ICARD, EXTEN,
     *   EOF, UNKNWN, IERR)
C-----------------------------------------------------------------------
C! parse FITS tape record for required extension file FITS keywords
C# FITS tape EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This routine will parse a block from a FITS tape and look for the
C   required cards of a FITS extension header block, namely XTENSION,
C   BITPIX, NAXIS, NAXISn, PCOUNT, GCOUNT.
C   Inputs:
C      FDVEC     I(50)   File descriptor for TAPIO input stream
C   Input/Output:
C      TBIND     I       Pointer in FITBLK
C      TAPBUF    I(*)    TAPIO i/o buffer
C      FITBLK    C*2880  a block of FITS header data.
C      UNKNWN    I       Number unknown records skipped looking for next
C                        extension
C   Outputs:
C      ICARD     I       The number of the last card parsed.
C      EXTEN     L       T means extension record, F means no.
C      EOF       L       T means end of file on 1st record.
C      IERR      I       0=ok, 1=messed up. An error message will
C                                be printed.
C-----------------------------------------------------------------------
      CHARACTER FITBLK*2880
      INTEGER   FDVEC(50), TBIND, TAPBUF(*), ICARD, UNKNWN, IERR
      LOGICAL   EXTEN, EOF
C
      DOUBLE PRECISION X
      CHARACTER EWORD(6)*8, STRING*80, CARD*80, SYMBOL*8, CVER*1
      INTEGER   IKEYWD, NPNT, ITABNO, NCHAR, I, NLEN, TERR, IFOUND,
     *   NFOUND
      LOGICAL   ATEND
      INCLUDE 'INCS:DEHD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA EWORD /'XTENSION', 'BITPIX  ',  'NAXIS   ', 'PCOUNT  ',
     *   'GCOUNT  ', ' '/
C-----------------------------------------------------------------------
C                                       Read 1st block.
 10   CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, TERR)
      IF (TERR.NE.0) THEN
         IF (TERR.EQ.4) GO TO 940
         WRITE (MSGTXT,1000)
         GO TO 980
         END IF
      EOF = .FALSE.
      CALL ZC8CL (2880, 1, TAPBUF(TBIND), FITBLK)
      IF (FITBLK(:8).NE.EWORD(1)) THEN
         IF (FITBLK(:7).EQ.'TABNAME') GO TO 950
         IF (FITBLK(:8).EQ.'SIMPLE  ') THEN
            MSGTXT = 'EXTREQ: NEW FITS FILE FOUND WHILE LOOKING FOR'
     *         // ' TABLE EXTENSION'
            CALL MSGWRT (8)
            GO TO 950
            END IF
         UNKNWN = UNKNWN + 1
         GO TO 10
         END IF
C                                       Look for XTENSION= 'type' card
      ICARD = 1
      IKEYWD = 1
      NPNT = 1
      EXTEN = .TRUE.
      CALL GTWCRD (ICARD, 1, 0, EWORD(IKEYWD), FITBLK, NPNT, CARD,
     *   SYMBOL, ITABNO, NFOUND, IFOUND, CVER, ATEND, IERR)
      IF (IERR.NE.0) GO TO 950
      NLEN = 16
      CALL GETSTR (CARD, 80, NLEN, NPNT, STRING, NCHAR)
      EXTTYP = STRING(1:NCHAR)
C
      ICARD = ICARD + 1
      IKEYWD = IKEYWD + 1
      NPNT = 1
      CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GTWCRD (ICARD, 1, 0, EWORD(IKEYWD), FITBLK, NPNT,
     *   CARD, SYMBOL, ITABNO, NFOUND, IFOUND, CVER, ATEND, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Get value of BITPIX
      CALL GETNUM (CARD, 80, NPNT, X)
      IF (X.EQ.DBLANK) GO TO 975
      IF (X.GE.0.0) BITPIX = X + 0.1
      IF (X.LT.0.0) BITPIX = X - 0.1
C                                       Warning-Non standard bits/pixel
      IF ((BITPIX.EQ.8) .OR. (BITPIX.EQ.16) .OR. (BITPIX.EQ.32) .OR.
     *   (BITPIX.EQ.-32)) GO TO 20
         WRITE (MSGTXT,1010) BITPIX
         CALL MSGWRT (5)
C                                       Get NAXIS
 20   ICARD = ICARD + 1
      IKEYWD = IKEYWD + 1
      NPNT = 1
      CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GTWCRD (ICARD, 1, 0, EWORD(IKEYWD), FITBLK, NPNT, CARD,
     *   SYMBOL, ITABNO, NFOUND, IFOUND, CVER, ATEND, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GETNUM (CARD, 80, NPNT, X)
      IF (X.EQ.DBLANK) GO TO 975
      NAXIS = X + .01
C                                       Check for invalid no. of axis
C                                       for our buffer.
      IF (NAXIS.GT.50) GO TO 960
C                                       Find NAXISi
      DO 50 I = 1,NAXIS
         ICARD = ICARD + 1
         NPNT = 1
         CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) GO TO 999
         STRING = ' '
         IF (I.LT.10) THEN
            WRITE (STRING,1020) I
         ELSE
            WRITE (STRING,1030) I
            END IF
         CALL GTWCRD (ICARD, 1, 0, STRING, FITBLK, NPNT, CARD,
     *      SYMBOL, ITABNO, NFOUND, IFOUND, CVER, ATEND, IERR)
         IF (IERR.NE.0) THEN
            IKEYWD = 6
            EWORD(IKEYWD) = STRING(1:8)
            GO TO 970
            END IF
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 975
         NAXISI(I) = X + .01
 50      CONTINUE
C                                       PCOUNT
      ICARD = ICARD + 1
      IKEYWD = IKEYWD + 1
      NPNT = 1
      CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GTWCRD (ICARD, 1, 0, EWORD(IKEYWD), FITBLK, NPNT, CARD,
     *   SYMBOL, ITABNO, NFOUND, IFOUND, CVER, ATEND, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GETNUM (CARD, 80, NPNT, X)
      IF (X.EQ.DBLANK) GO TO 975
      PCOUNT = X + 0.01
C                                       Get GCOUNT
      ICARD = ICARD + 1
      IKEYWD = IKEYWD + 1
      NPNT = 1
      CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GTWCRD (ICARD, 1, 0, EWORD(IKEYWD), FITBLK, NPNT, CARD,
     *   SYMBOL, ITABNO, NFOUND, IFOUND, CVER, ATEND, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GETNUM (CARD, 80, NPNT, X)
      IF (X.EQ.DBLANK) GO TO 975
      GCOUNT = X + 0.01
      GO TO 999
C                                       End of file.
 940  IERR = 0
      EOF = .TRUE.
      GO TO 999
C                                       Not extension record.
 950  IERR = 0
      EXTEN = .FALSE.
      GO TO 999
C                                       Invalid number of axis.
 960  WRITE (MSGTXT,1960) NAXIS
      GO TO 980
C                                       Expected keyword not found.
 970  WRITE (MSGTXT,1970) EWORD(IKEYWD), SYMBOL
      GO TO 980
C                                       number out of range
 975  MSGTXT = 'EXTREQ: VALUE OUT OF RANGE ON ' // SYMBOL
C                                       Print error message set flag.
 980  CALL MSGWRT (6)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR READING FITS TABLE')
 1010 FORMAT ('INVALID TABLE BITS PER PIXEL =',I6)
 1020 FORMAT ('NAXIS',I1)
 1030 FORMAT ('NAXIS',I2)
 1960 FORMAT ('NUMBER OF TABLE AXIS TOO LARGE FOR BUFFER =',I6)
 1970 FORMAT ('EXPECTED TABLE KEYWORD ',A8,'. FOUND ',A8,'.')
      END

      SUBROUTINE GETROW (IMSTUF, IOBLK, ROW, EOF, IERR)
C-----------------------------------------------------------------------
C! Read row of an image opened with INTMIO
C# Map IO-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  This routine will read a row of an image file that has been opened
C  with and initialized with INTMIO.  The routine will copy the
C  row from the IO buffer to the user buffer.
C  Inputs:
C     IMSTUF    I(37)   IO pointers, LUNs, counters and such. They are
C                       set in INTMIO.
C  In/out:
C     IOBLK     R(*)   IO buffer.
C  Outputs:
C     ROW       R(*)   Output row of image.
C     EOF       L      TRUE means last row specified in INTMIO by the
C                      BLC, TRC arguments has been read.
C     IERR      I      Error code, 0=ok, others from MDISK.
C-----------------------------------------------------------------------
      REAL   ROW(*), IOBLK(*)
      LOGICAL   EOF
      INTEGER   IMSTUF(37), IERR,
     *   IBLKOF, IWIN(4), IMPOS, IVALS, I, K, NDIMS, I0, ISGN
C-----------------------------------------------------------------------
      EOF = .FALSE.
C                                       Update counters.
      IMSTUF(31) = IMSTUF(31) + IMSTUF(37)
      IF ((IMSTUF(37)*IMSTUF(31)).LE.(IMSTUF(37)*IMSTUF(20))) GO TO 100
C                                       We are at the end of a plane.
         NDIMS = IMSTUF(8)
         I0 = 22
C                                       Update current plane counters.
         DO 20 I = 1, NDIMS
            IMSTUF(30+I) = IMSTUF(I0-3)
            ISGN = 1
            IF (IMSTUF(I0-1).GT.IMSTUF(I0)) ISGN = -1
            IMSTUF(31+I) = IMSTUF(31+I) + ISGN
            IF ((ISGN*IMSTUF(31+I)).LE.(ISGN*IMSTUF(I0))) GO TO 30
            I0 = I0 + 2
 20         CONTINUE
C                                       We have finished all planes
            EOF = .TRUE.
            IERR = 0
            GO TO 999
C                                       Do MINI3 for this plane.
 30      CALL COMOFF (IMSTUF(8), IMSTUF(10), IMSTUF(32), IBLKOF, IERR)
         IF (IERR.NE.0) GO TO 999
         IBLKOF = IBLKOF + 1
         IWIN(1) = IMSTUF(17)
         IWIN(2) = IMSTUF(19)
         IWIN(3) = IMSTUF(18)
         IWIN(4) = IMSTUF(20)
         CALL MINIT ('READ', IMSTUF(1), IMSTUF(2), IMSTUF(10),
     *      IMSTUF(11), IWIN, IOBLK, IMSTUF(6), IBLKOF, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Do actual read.
 100  CALL MDISK ('READ', IMSTUF(1), IMSTUF(2), IOBLK, IMPOS, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy values into user buffer.
      K = IMPOS - 1
      IVALS = IMSTUF(9)
      DO 200 I = 1,IVALS
         ROW(I) = IOBLK(K+I)
 200     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE HIIO (OP, HPTR, NREC, BUFFER, IERR)
C-----------------------------------------------------------------------
C! does IO and file expansion (if needed) on HI files
C# History
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2005, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   HIIO performs IO on history files including manual expand of file
C   size when required.
C   Inputs:
C      OP      C*4       'READ' or 'WRIT'
C      HPTR    I         pointer to entry in HITAB
C      NREC    I         record number (512-byte records)
C   In/Out:
C      BUFFER  I(256)    HI work buffer
C   Out:
C      IERR    I         as ZFI3
C   Common:
C      Can reset HITAB(HPTR + 3 and 6) = max size, current rec #
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   HPTR, NREC, BUFFER(256), IERR
C
      INTEGER   LUN, IND, NSIZ, NMAX, NEWREC, LSIZE, IER
      CHARACTER HNAME*48
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                        get parms from HITAB
      LUN = HITAB (HPTR)
      IND = HITAB (HPTR+1)
      NSIZ = (HITAB(HPTR+3) - 1) / NHILPR + 1
      NMAX = (HITAB(HPTR+2) - 1) / NHILPR + 1
C                                        test 456 => EOF,BOM,EOM
      IERR = 5
      IF (NREC.LE.0) GO TO 900
      IERR = 6
      IF (NREC.GT.NSIZ+1) GO TO 900
      IF ((OP.EQ.'READ') .AND. (NREC.GT.NSIZ)) GO TO 900
C                                        Is IO justified by current
C                                        logical count (NMAX > NSIZ)
      IERR = 4
      IF (NREC.GT.NMAX) GO TO 900
C                                        expand
      IF (NREC.GT.NSIZ) THEN
         NEWREC = 69/NHILPR + 1
         CALL ZPHFIL ('HI', HITAB(HPTR+4), HITAB(HPTR+5), 1, HNAME,
     *      IERR)
         CALL ZEXPND (LUN, HITAB(HPTR+4), HNAME, NEWREC, IERR)
C                                       real error?
         IF (IERR.NE.0) THEN
            CALL ZEXIST (HITAB(HPTR+4), HNAME, LSIZE, IER)
            IF (IER.EQ.0) THEN
               IF (LSIZE.GT.NSIZ) THEN
                  MSGTXT = 'Odd - the HI file got bigger, ' //
     *               'guess it is okay'
                  CALL MSGWRT (7)
                  IERR = 0
                  NEWREC = LSIZE - NSIZ
                  END IF
               END IF
            END IF
         IF (IERR.NE.0) GO TO 910
         HITAB(HPTR+3) = HITAB(HPTR+3) + NEWREC * NHILPR
         END IF
C                                        do IO
 20   CALL ZFIO (OP, LUN, IND, NREC, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 920
      HITAB(HPTR+6) = NREC
      GO TO 999
C                                        inputs error
 900  WRITE (MSGTXT,1900) LUN, NREC, NSIZ, NMAX, IERR
      GO TO 990
C                                        expand error
 910  WRITE (MSGTXT,1910) LUN, NREC, IERR
      GO TO 990
C                                        IO error
 920  WRITE (MSGTXT,1910) LUN, NREC, IERR
 990  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('HIIO LUN, NREC, NSIZ, NMAX',4I7,' ERR',I7)
 1910 FORMAT ('HIIO ON LUN, NREC',2I7,' EXPAND ERROR',I7)
 1920 FORMAT ('HIIO ON LUN, NREC',2I7,' IO ERROR',I7)
      END

      SUBROUTINE UVSETB( VSOFF, LVIS, UMAX, UMIN, USCALE, NCHGRD, BUFF)
C-----------------------------------------------------------------------
C! Set Beam values for a visibility, Real=1, Imaginary=0.
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C UV SET Beam: Sets UV point values for creating a BEAM.
C Weight is not checked.  Also checks sort on U and prints error
C messages for miss sorted data.
C Band width synthesis is handled by this routine
C Inputs:
C  VSOFF      I     Offset to UV Visibility record
C  LVIS       I     Length of Visibility record
C  UMAX       R     MAx U value allowed for data.
C  UMIN       R     Min U value allowed for data.
C  UMAX       R     U value of output Vis record.
C  USCALE     R     U scale value to kilo lambda
C  NCHGRD     I     Number of channels to Grid
C Output:
C  BUFF       R(*)  Visibility record
C-----------------------------------------------------------------------
      INTEGER VSOFF, LVIS, NCHGRD
      REAL UMAX, UMIN, USCALE, BUFF(*)
C-----------------------------------------------------------------------
      INTEGER JJ, JNDX, BITCNT
      REAL UU1, UU2, UU3
      INCLUDE 'INCS:DMSG.INC'
      SAVE BITCNT
      DATA BITCNT/0/
C-----------------------------------------------------------------------
C                                       set index to start of vis rec
C                                       for first channel to average
      JNDX = 1 + VSOFF
C                                       for all channels to average
      DO 145 JJ = 1,NCHGRD
C                                       BEAM replace data with (1,0)
         BUFF(JNDX)   = 1.0
         BUFF(JNDX+1) = 0.0
C                                       index to start of next channel
         JNDX = JNDX + LVIS
 145     CONTINUE
C                                       Check if data sorted by U
      IF (ABS (BUFF(1)).GT.UMAX) THEN
C                                       print only a few error messages
         IF (BITCNT.LE.10) THEN
            BITCNT = BITCNT + 1
            UU1 = BUFF(1) * USCALE
            UU2 = UMIN * USCALE
            UU3 = UMAX * USCALE
            WRITE (MSGTXT,1125) UU1, UU2, UU3
            CALL MSGWRT (6)
            END IF
         END IF
      RETURN
C-----------------------------------------------------------------------
 1125 FORMAT ('IU=ABS(',F10.3,') NOT IN RANGE ',2F8.2,', MISSORTED')
      END

      SUBROUTINE CONV4 (APCORE, LUN, VOL, FIL, BO, XBUFF1, BUFSZ1,
     *   XBUFF2, BUFSZ2, NX, NY, FMAX, FMIN, IERR)
C-----------------------------------------------------------------------
C! Fourth of four routines to convolve two real images.
C# AP-FFT Math Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2006, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CONV4 = last of four routines to convolve two real images.
C   Finishes the transpose of the COMPLEX to REAL transform
C   getting the data from either the scratch file (no. 4) of the AP
C   memory.  Only the inner quarter of the transform is fully processed.
C   results are written to file no. 5.
C   Input:
C     LUN(5)      I    LUNs for files
C     VOL(5)      I    Volume numbers for the files.
C     FIL(5)      C*12 Physical names for the files.
C     BO(5)       I    Block offsets for the files.
C     XBUFF1(),XBUFF2()  R    Work buffers for I/O
C     BUFSZ1,BUFSZ2  I    Size in bytes for XBUFF1 and XBUFF2
C     NX,NY          I    Number of grid cells in X and Y of maps.
C   Output:
C     FMAX           R    Maximum value in output file.
C     FMIN           R    Minimum value in output file.
C     IERR           I    Return error code, 0=>OK, otherwise failed.
C                         3=>Size less than 4 in one dimension.
C   The Transformed Map/File will be left in File 4.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      CHARACTER FIL(5)*48, BADOP*4
      INTEGER   LUN(5), VOL(5), BO(5), BUFSZ1, BUFSZ2, NX, NY, IERR
      REAL      XBUFF1(*), XBUFF2(*), FMAX, FMIN, TMAX(3)
      INTEGER   FIND2, FIND3, BIND2, BIND3, BADFIL, WIN(4),  NBUF,
     *   MPASS, IFIN, IER, I, IC, J, K, LROW, NCOL, NROW, JAPWRD, NSKIP,
     *   IFIRST, NOROW, NX2, NY2, KROW, KOFF, NUMGOT, KNDEX, QUATNX,
     *   HALFNY, QUATNY, NWORD, HALFNX, ONENX, TWONX, ONENY, TWONY,
     *   ONECOL, TWOCOL, ONEROW, TWOROW, NSHOV, OMPASS, INDEX2, APSIZ,
     *   INDEX
      LOGICAL   MAP, WAIT, EXCL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DAPM.INC'
      DATA MAP, WAIT, EXCL /2*.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IERR = 0
C                                       Determine power of 2 AP size.
      JAPWRD = PSAPNW
      CALL AP2SIZ (JAPWRD, APSIZ)
C                                       Make sure min. dim .ge. 4
      IF ((NX.LT.4) .OR. (NY.LT.4)) THEN
           WRITE (MSGTXT,1000) NX,NY
           CALL MSGWRT (8)
           IERR = 3
           GO TO 999
           END IF
C                                       Set a few parameters.
      NX2 = NX * 2
      NY2 = NY * 2
      NCOL = APSIZ / (NY2 * 2.0)
      NCOL = MIN (NCOL, NX)
      NROW = APSIZ / NX2
      NROW = MIN (NROW, NY2)
      MPASS = NY2 / NROW
      MPASS = MAX (MPASS, 1)
      QUATNX = NX / 2
      HALFNX = NX
      QUATNY = NY / 2
      HALFNY = NY
      ONENX = NX*2
      TWONX = 2 * NX2
      ONENY = NY2
      TWONY = 2 * NY2
      OMPASS = MPASS
      ONECOL = NCOL
      TWOCOL = 2 * NCOL
      ONEROW = NROW
      TWOROW = 2 * NROW
      FMAX = -1.0E6
      FMIN = 1.0E6
C                                       Open files
      BADOP = 'OPEN'
      BADFIL = 2
C                                       Read only for multiple AP loads
      IF (MPASS.GT.1) THEN
         CALL ZOPEN (LUN(2), FIND2, VOL(2), FIL(2), MAP, EXCL, WAIT,
     *      IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
 10   CALL ZOPEN (LUN(3), FIND3, VOL(4), FIL(4), MAP, EXCL, WAIT, IERR)
      BADFIL = 3
      IF (IERR.NE.0) GO TO 900
      BADOP = 'INIT'
C                                       Determine length of read
      LROW = NROW * 2 * NCOL
C                                       COMPLEX to REAL transform
C                                       INIT output file.
         WIN(1) = 1
         WIN(2) = 1
         WIN(3) = NX
         WIN(4) = NY
         CALL MINIT ('WRIT', LUN(3), FIND3, NX, NY, WIN, XBUFF2, BUFSZ2,
     *      BO(3), IERR)
         BADFIL = 3
         IF (IERR.NE.0) GO TO 900
C                                       Begin reading and processing.
         DO 600 I = 1,MPASS
C                                       Unscramble.
            IFIRST = I - MPASS / 2
            IF (IFIRST.LE.0) IFIRST = IFIRST + MPASS
            KOFF = (IFIRST-1) * NROW
C                                       Do not do passes with no output
            IF ((MPASS.GE.4) .AND. ((I.LE.MPASS/4).OR.(I.GT.3*MPASS/4)))
     *         GO TO 600
C                                       Read only for multiple AP loads
            IF (MPASS.LE.1) GO TO 570
C                                       Initialize read with skip.
               NBUF = 1
               NOROW = MPASS * MPASS
               NSKIP = MPASS
               CALL MINSK (LUN(2), FIND2, LROW, NOROW, IFIRST, NSKIP,
     *            XBUFF1, BUFSZ1, BO(2), NBUF, IERR)
               BADFIL = 2
               BADOP = 'INIT'
               IF (IERR.NE.0) GO TO 900
C                                       Determine number of words per
C                                       read.
               NSHOV = LROW / NBUF
               DO 560 J = 1,MPASS
C                                       Load NROW rows into the AP
C                                       Return to here if multiple reads
                  IC = -1
 540                 CALL MSKIP (LUN(2), FIND2, XBUFF1, BIND2, IFIN,
     *                  IERR)
                     IC = IC + 1
                     IF (IERR.NE.0) THEN
                        BADOP = 'READ'
                        GO TO 900
                        END IF
 550                 INDEX = (J-1) * LROW + NSHOV * IC
                     CALL QPUT (APCORE, XBUFF1(BIND2), INDEX, NSHOV, 2)
                     CALL QWD
C                                       If read not finished, Loop.
                     IF (IFIN.NE.0) GO TO 540
 560              CONTINUE
C                                       Finish transpose.
               CALL QVTRAN (APCORE, OMPASS, ONEROW, 0, TWOCOL)
 570        CONTINUE
C                                       Do row transform and unscramble
C                                       data to disk.
            NUMGOT = 0
            DO 590 J = 1,NROW
               K = J
C                                       Following to scramble if MPASS=1
               IF (MPASS.LE.1) THEN
                  K = J - NY
                  IF (J.LE.NY) K = J + NY
                  END IF
 580           INDEX = (K - 1) * ONENX
C                                       Process/write inner quarter
               KROW = K + KOFF
               IF ((KROW.GT.QUATNY) .AND. (KROW.LE.HALFNY+QUATNY))
     *            GO TO 590
                  NUMGOT = NUMGOT + 1
C                                       Do FFT.
                  CALL QRFFT (APCORE, INDEX, ONENX, -1)
C                                        Unscramble.
                  INDEX2 = INDEX + QUATNX
                  CALL QVMOV (APCORE, INDEX, 1, INDEX2, 1, QUATNX)
                  KNDEX = INDEX2 + HALFNX
                  CALL QVMOV (APCORE, KNDEX, 1, INDEX, 1, QUATNX)
                  CALL MDISK ('WRIT', LUN(3), FIND3, XBUFF2, BIND3,
     *               IERR)
                  IF (IERR.NE.0) THEN
                     BADOP = 'WRIT'
                     BADFIL = 3
                     GO TO 900
                     END IF
C                                       Get row.
 585              CALL QWR
                  CALL QGET (APCORE, XBUFF2(BIND3), INDEX, HALFNX, 2)
                  CALL QWD
C                                        Find row max.-min.
                  INDEX2 = INDEX + 2
                  CALL QMAXMI (APCORE, INDEX, 1, INDEX, INDEX2, HALFNX)
                  CALL QWR
                  CALL QGET (APCORE, TMAX, INDEX, 3, 2)
                  CALL QWD
                  FMAX = MAX (TMAX(1), FMAX)
                  FMIN = MIN (TMAX(3), FMIN)
C
 590           CONTINUE
C                                       Roll AP if necessary.
C                                       Since NWORD = 0 will
C                                       at most release/assign AP
            NWORD = 0
            IF (MPASS.GT.I)
     *         CALL QROLL (APCORE, NWORD, XBUFF1, BUFSZ1, IERR)
            IF (IERR.NE.0) GO TO 999
 600        CONTINUE
C                                       Finish write.
         BADOP = 'FINI'
         CALL MDISK ('FINI', LUN(3), FIND3, XBUFF2, BIND3, IERR)
         IF (IERR.EQ.0) GO TO 990
            BADOP = 'FINI'
            BADFIL = 3
C                                       Error report
 900  WRITE (MSGTXT,1900) BADOP, IERR, FIL(BADFIL)
      IF ((BADOP.EQ.'READ') .OR. (BADOP.EQ.'WRIT')) THEN
         WRITE (MSGTXT,1901) BADOP, IERR, I, J
         CALL MSGWRT (8)
         WRITE (MSGTXT,1902) FIL(BADFIL)
         END IF
      CALL MSGWRT (8)
C                                       Close files
 990  IF ((MPASS.GT.1) .AND. ((BADOP.NE.'OPEN') .OR. (BADFIL.NE.2)))
     *   CALL ZCLOSE (LUN(2), FIND2, IER)
      IF (BADOP.NE.'OPEN') CALL ZCLOSE (LUN(3), FIND3, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CONV4: NX OR NY (',I5,',',I5,') LESS THAN 4')
 1900 FORMAT ('CONV4: ',A4,' ERROR',I7,' FILE ',A)
 1901 FORMAT ('CONV4: ',A4,' ERROR',I7,' I,J=',I3,I5)
 1902 FORMAT ('      FILE ',A)
      END

      SUBROUTINE CONVFN (APCORE, APLOC, TYPE, PARM, BUFFER)
C-----------------------------------------------------------------------
C! Computes convolving fn. kernels and stores them in "AP memory"
C# AP-util Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CONVFN computes the convolving functions and stores them in the
C   array processor.  Values are tabulated every 1/XPARM(5) cell.
C   Inputs:
C      APLOC    I       AP base address of convolving function.
C      TYPE     I       Convolving function type:
C                          1 - 6  x, y separable functions
C                          11 - 16  radial functions
C      PARM     R(10)   Convolving function parameters.
C                       PARM(1) = radius of support, PARM(5) increment
C   Output:
C      BUFFER   R(*)    Work buffer - 1 full row = (2*PARM(1)+1)*100
C                       plus second (size XPARM(5) rather than 100)
C                       for circular grid types
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   APLOC, TYPE
      REAL      PARM(10), BUFFER(*)
C
      INTEGER   LIM, IM, NMAX, NROW, I, IALF, IER, LIMIT, IRAD,
     *   LLIM, LINC, J, APL1, APL2, LTYPE, BIAS, BBIAS
      REAL      P1, P2, U, UMAX, ABSU, ETA, PSI, XINC, RADIUS, V, PI,
     *   BESSJ1
      INCLUDE 'INCS:DMSG.INC'
      DATA PI /3.1415926536/
C-----------------------------------------------------------------------
C                                       Determine number of rows necessa
      LTYPE = ABS (TYPE)
      IF (LTYPE.GT.10) LTYPE = LTYPE - 10
C                                       Check function types.
      IF ((LTYPE.LT.1) .OR. (LTYPE.GT.6)) THEN
         TYPE = 4
         PARM(1) = 3.0
         PARM(2) = 1.55
         PARM(3) = 2.52
         PARM(4) = 2.00
         PARM(5) = 100.0
         WRITE (MSGTXT,1000) TYPE, PARM(1), PARM(2), PARM(3)
         CALL MSGWRT (1)
         LTYPE = 4
         END IF
C                                       Set parameters
      NROW = MAX (PARM(1) , 1.0)
      NROW = NROW * 2 + 1
      LINC = 100
      LINC = (LINC/2) * 2
      LIM = NROW * LINC + 1
      BIAS = (LINC/2) * NROW + 1
      UMAX = PARM(1)
      XINC = 1.0 / LINC
C                                       Pill box function
      IF (LTYPE.EQ.1) THEN
         DO 10 I = 1,LIM
            U = (I-BIAS) * XINC
            ABSU = ABS (U)
            BUFFER(I) = 1.0
            IF (ABSU.EQ.UMAX) THEN
               BUFFER(I) = 0.5
            ELSE IF (ABSU.GT.UMAX) THEN
               BUFFER(I) = 0.0
               END IF
 10         CONTINUE
C                                       Exponential function.
      ELSE IF (LTYPE.EQ.2) THEN
         P1 = 1.0 / PARM(2)
         DO 20 I = 1,LIM
            U = (I-BIAS) * XINC
            ABSU = ABS (U)
            BUFFER(I) = 0.0
            IF (ABSU.LE.UMAX) BUFFER(I) = EXP (-((P1*ABSU) ** PARM(3)))
 20         CONTINUE
C                                       Sinc function.
      ELSE IF (LTYPE.EQ.3) THEN
         P1 = PI / PARM(2)
         DO 30 I = 1,LIM
            U = (I-BIAS) * XINC
            ABSU = ABS (U)
            BUFFER(I) = 0.0
            IF (ABSU.EQ.0) THEN
               BUFFER(I) = 1.0
            ELSE IF (ABSU.LE.UMAX) THEN
               BUFFER(I) = SIN (P1*ABSU) / (P1*ABSU)
               END IF
 30         CONTINUE
C                                       EXP * SINC convolving fn.
      ELSE IF (LTYPE.EQ.4) THEN
         P1 = PI / PARM(2)
         P2 = 1.0 / PARM(3)
         DO 40 I = 1,LIM
            U = (I - LIM/2 - 1) * XINC
            ABSU = ABS (U)
            BUFFER(I) = 0.0
C                                       Check for central point.
            IF (ABSU.LT.XINC) THEN
               BUFFER(I) = 1.0
            ELSE IF (ABSU.LE.UMAX) THEN
               BUFFER(I) = SIN(U*P1) / (U*P1) *
     *            EXP (-((ABSU * P2) ** PARM(4)))
               END IF
 40         CONTINUE
C                                       Spherodial wave function
      ELSE IF (LTYPE.EQ.5) THEN
         NMAX = PARM(1)/XINC + 0.1
C                                       Zero table
         DO 50 I = 1,LIM
            BUFFER(I) = 0.0
 50         CONTINUE
C                                       Compute function
         IALF = 2.0 * PARM(2) + 1.1
         IM = 2.0 * PARM(1) + 0.1
         IALF = MAX (1, MIN (5, IALF))
         IM = MAX (4, MIN (8, IM))
         DO 51 I = 1,NMAX
            ETA = REAL (I-1) / REAL (NMAX-1)
            CALL SPHFN (IALF, IM, 0, ETA, PSI, IER)
            BUFFER(BIAS+I-1) = PSI
 51         CONTINUE
C                                       Fill in other half
         LIMIT = BIAS-1
         DO 52 I = 1,LIMIT
            BUFFER(BIAS-I) = BUFFER(BIAS+I)
 52         CONTINUE
C                                       EXP * SINC convolving fn.
      ELSE IF (LTYPE.EQ.6) THEN
         P1 = PI / PARM(2)
         P2 = 1.0 / PARM(3)
         DO 60 I = 1,LIM
            U = (I - LIM/2 - 1) * XINC
            ABSU = ABS (U)
            BUFFER(I) = 0.0
C                                       Check for central point.
            IF (ABSU.LT.XINC) THEN
               BUFFER(I) = 1.0
            ELSE IF (ABSU.LE.UMAX) THEN
               BUFFER(I) = 2.0 * BESSJ1(U*P1) / (U*P1) *
     *            EXP (-((ABSU * P2) ** PARM(4)))
               END IF
 60         CONTINUE
C
C                                       Put further functions here.
C
         END IF
C                                       Load function into AP.
      IF (ABS(TYPE).LE.10) THEN
         CALL QWR
         LLIM = LIM
         CALL QPUT (APCORE, BUFFER, APLOC, LLIM, 2)
         CALL QWD
C                                       Circular: compute & load rows
       ELSE
         LINC = PARM(5)
         LINC = (LINC/2) * 2
         LLIM = NROW * LINC + 1
         BBIAS = (LINC/2) * NROW + 1
         XINC = 100.0 / LINC
         APL1 = APLOC
         APL2 = APLOC + (LLIM - 1) * LLIM
         LIMIT = LLIM / 2 + 1
         CALL QWR
         DO 120 J = 1,LIMIT
            V = BBIAS - J
            DO 110 I = 1,LIMIT
               U = BBIAS - I
               RADIUS = SQRT (U*U + V*V)
               IRAD = RADIUS * XINC + 0.5 + BIAS
               BUFFER(I+LIM) = 0.0
               IF (IRAD.LE.LIM) BUFFER(I+LIM) = BUFFER(IRAD)
               BUFFER(LIM+LLIM+1-I) = BUFFER(I+LIM)
 110           CONTINUE
            CALL QPUT (APCORE, BUFFER(LIM+1), APL1, LLIM, 2)
            IF (APL2.GT.APL1) CALL QPUT (APCORE, BUFFER(LIM+1), APL2,
     *         LLIM, 2)
            CALL QWD
            APL1 = APL1 + LLIM
            APL2 = APL2 - LLIM
 120        CONTINUE
         END IF
C
 999   RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CONVFN: Convolving fn =',I3,' parm =',5F8.5)
      END

      PROGRAM SUMSQ
C-----------------------------------------------------------------------
C! Does root sum squares of the pixels in a set of images.
C# Map Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2008-2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SUMSQ squares each of a number of maps, pixel by pixel,
C   and, to produce its output map, sums these squared values.
C   The input maps must be described by
C   the same name & class and by sequence numbers from n1 thru n2 by n3
C   For meaningful results, the maps must be precisely registered.
C   Inputs: adverbs from AIPS -
C      INNAME(3)          Input map name
C      INCLASS(2)         Input map class
C      INSEQ              First input map seq no.
C      IN2SEQ             Seq # of last map to add
C      IN3SEQ             Increment of seq #s for maps to add
C      INDISK             Input map disk: 0 = any
C      OUTNAME(3)         Output map name default INNAME
C      OUTCLASS(2)        Output map class default INCLASS
C      OUTSEQ             Output map seq no. 0 => lowest unique
C      OUTDISK            Output map disk
C      BLC(7)             Bottom left corner all input maps
C      TRC(7)             Top right corner all input maps
C      FACTOR             Multiplier for added maps: 0 => 1 / (# summed)
C      XPARM(10)          If XPARM(1)>0 and FACTOR.GE.0 then
C                         square root[factor*(sum of squares)] is
C                         computed.
C      BADDISK(10)        Disks to avoid for scratch files.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER PRGNAM*6, NAMS(4)*36, HILINE*72, SUBS(7)*6, NAME*12,
     *   CLASS*6, PTYPE*2
      HOLLERITH CATIH(256), MAP, TYPE
      REAL      RPARM(52), IN(MAXIMG), OUT(MAXIMG), CATIR(256), WT, XX,
     *   RTEMP1, RTEMP2
      LOGICAL   EQUAL, ROOT
      INTEGER   ERROR, NSUB, JFIL, IROUND, CATIN(256), NRET, EOM, ASEQ,
     *   LMAP, LUNSL(2), HLUN(2), INVOL, INCNO, OUTVOL, OUTCNO, S1, S2,
     *   S3, NPARM, I, J, LX, I1, I2, IERR, SEQ, DISK, USID
      DOUBLE PRECISION CATID(128)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (CATIN, CATIR, CATIH, CATID)
      DATA PRGNAM /'SUMSQ '/
      DATA LMAP, LUNSL, HLUN /17, 18,19, 27,28/
      DATA EOM /9/
      DATA SUBS /'GTPARM', 'OPENCF', 'GETHDR', 'MAPCR ',
     *           'MAPIO ', 'MAPCOP', 'WINDOW'/
C-----------------------------------------------------------------------
C                                       Task init, get parms
      NRET = 0
      NPARM = 51
      NSUB = 1
      JFIL = 1
      CALL TSKBEG (PRGNAM, NPARM, RPARM(2), ERROR)
      IF (ERROR.NE.0) GO TO 980
      RPARM(1) = NLUSER
C                                       Set up file NAMEstrings for
C                                       input & output maps & 2
C                                       scratch files.
      CALL CHR2H (4, 'MA  ', 1, MAP)
      CALL H2WAWA (RPARM(2), RPARM(5), RPARM(7), MAP, RPARM(10),
     *   RPARM(1), NAMS(1))
      CALL H2WAWA (RPARM(11), RPARM(14), RPARM(16), MAP, RPARM(17),
     *   RPARM(1), NAMS(2))
      CALL CHR2H (4, 'SC  ', 1, TYPE)
      J = IROUND (RPARM(10))
      RTEMP1 = 1.0
      RTEMP2 = MOD (J, NVOL) + 1
      CALL H2WAWA (RPARM(11), RPARM(14), RTEMP1, TYPE, RTEMP2,
     *   RPARM(1), NAMS(3))
      RTEMP1 = 2.0
      RTEMP2 = MOD (J+1, NVOL) + 1
      CALL H2WAWA (RPARM(11), RPARM(14), RTEMP1, TYPE, RTEMP2,
     *   RPARM(1), NAMS(4))
      DO 15 I = 1,10
         IBAD(I) = IROUND (RPARM(42+I))
 15      CONTINUE
C                                       Open first input map to get
C                                       header, then close again
      NSUB = 2
      CALL OPENCF (LMAP, NAMS(1), ERROR)
      IF (ERROR.NE.0) GO TO 980
      NSUB = 3
      CALL GETHDR (LMAP, CATIN, ERROR)
      IF (ERROR.NE.0) GO TO 980
      INVOL = FILTAB(POVOL,6)
      INCNO = FILTAB(POCAT,6)
      ASEQ = CATIN(KIIMS)
      CALL FILCLS (LMAP)
C                                       Messages
      WRITE (MSGTXT,1010)
      CALL MSGWRT (3)
      CALL PRTNAM (NAMS(1), 3)
C                                       Create R   scratch files
      NSUB = 7
      CALL COPY (256, CATIN, CATBLK)
      CALL HDRWIN (RPARM(18), RPARM(25), CATBLK, ERROR)
      IF (ERROR.NE.0) GO TO 980
      NSUB = 4
      DO 20 J = 3,4
         JFIL = J
         CALL MAPCR (NAMS(1), NAMS(J), CATBLK, ERROR)
         IF (ERROR.NE.0) GO TO 980
 20      CONTINUE
C                                       Zero the 1st scratch file
      LX = CATBLK(KINAX)
      CALL RFILL (LX, 0.0, OUT)
      NSUB = 2
      JFIL = 3
C                                       Open file
      CALL OPENCF (LUNSL(1), NAMS(3), ERROR)
      IF (ERROR.NE.0) GO TO 980
      NSUB = 5
      JFIL = 3
C                                       Loop to write zeros in file
 100  CALL MAPIO ('WRIT', LUNSL(1), OUT, ERROR)
         IF (ERROR.EQ.0) GO TO 100
         IF (ERROR.NE.EOM) GO TO 980
C                                       Open second scratch file
      NSUB = 2
      JFIL = 4
      CALL OPENCF (LUNSL(2), NAMS(4), ERROR)
      IF (ERROR.NE.0) GO TO 980
C                                       Set up I   looping indicies
      S1 = IROUND (RPARM(7))
      S2 = IROUND (RPARM(8))
      S3 = IROUND (RPARM(9))
      IF (S2.GE.S1) GO TO 110
         I = S2
         S2 = S1
         S1 = I
         S3 = -S3
 110  IF (S3.LE.0) S3 = 1
      ROOT = (RPARM(32).GE.0.) .AND. (RPARM(33).GT.0.)
      S2 = ((S2 - S1) / S3) * S3 + S1
      WT = RPARM(32)
      IF (WT.NE.0.0) GO TO 160
         I = 1 + ((S2 - S1)/S3)
         WT = 1.0 / I
 160  I2 = 1
C                                       Loop over input maps
      DO 300 I = S1,S2,S3
C                                       Switch scratch files
         I1 = I2
         I2 = 3 - I2
C                                       Set input file
         CALL WAWA2A (NAMS(1), NAME, CLASS, SEQ, PTYPE, DISK, USID)
         SEQ = I
         CALL A2WAWA (NAME, CLASS, SEQ, PTYPE, DISK, USID, NAMS(1))
C                                       Open input map
         NSUB = 2
         JFIL = 1
         CALL OPENCF (LMAP, NAMS(1), ERROR)
         IF (ERROR.NE.0) GO TO 980
         WRITE (MSGTXT,1160) I
         CALL MSGWRT (2)
C                                       Check dimensions
         NSUB = 7
         CALL MAPWIN (LMAP, RPARM(18), RPARM(25), ERROR)
         IF (ERROR.NE.0) GO TO 980
         NSUB = 5
         CALL COMPAR (CATIN(KIDIM), CATIN(KINAX), CATBLK(KINAX), EQUAL)
         IF (EQUAL) GO TO 200
            NSUB = 2
            ERROR = 2
            WRITE (MSGTXT,1161)
            CALL MSGWRT (8)
            GO TO 980
C                                       Read line loop
 200     CONTINUE
            JFIL = 1
C                                       Read an input line
            CALL MAPIO ('READ', LMAP, IN, ERROR)
C                                       On End of Map skip to loop end
            IF (ERROR.EQ.EOM) GO TO 290
            IF (ERROR.NE.0) GO TO 980
C                                       Read present accumlator file
            JFIL = 2 + I1
            CALL MAPIO ('READ', LUNSL(I1), OUT, ERROR)
            IF (ERROR.NE.0) GO TO 980
C                                       Add new data to old
            DO 250 J = 1,LX
               XX = IN(J)
               IF (XX.EQ.FBLANK) OUT(J) = FBLANK
               IF (OUT(J).NE.FBLANK) OUT(J) = OUT(J) + WT * XX**2
               IF ((ROOT) .AND. (I.EQ.S2) .AND. (OUT(J).NE.FBLANK))
     *            OUT(J) = SQRT(OUT(J))
 250           CONTINUE
C                                       Write into new accumlator file
            JFIL = 2 + I2
            CALL MAPIO ('WRIT', LUNSL(I2), OUT, ERROR)
            IF (ERROR.NE.0) GO TO 980
            GO TO 200
C                                       Map loop; close input map
 290     CALL FILCLS (LMAP)
 300     CONTINUE
C                                       Close scratch files
      CALL FILCLS (LUNSL(I1))
      CALL FILCLS (LUNSL(I2))
C                                       Convert R   scratch file
C                                       to output file
      NSUB = 6
      WRITE (MSGTXT,1300)
      CALL MSGWRT (2)
      CALL WAWA2A (NAMS(1), NAME, CLASS, SEQ, PTYPE, DISK, USID)
      SEQ = ASEQ
      CALL A2WAWA (NAME, CLASS, SEQ, PTYPE, DISK, USID, NAMS(1))
      CALL MAPCOP (NAMS(2+I2), NAMS(1), NAMS(2), ERROR)
      IF (ERROR.NE.0) GO TO 980
C                                       Open output file to get
C                                       header, then close
      NSUB = 2
      CALL OPENCF (LMAP, NAMS(2), ERROR)
      IF (ERROR.NE.0) GO TO 330
      NSUB = 3
      CALL GETHDR (LMAP, CATBLK, ERROR)
      IF (ERROR.NE.0) GO TO 330
      OUTVOL = FILTAB(POVOL,6)
      OUTCNO = FILTAB(POCAT,6)
      CALL FILCLS (LMAP)
C                                       copy some keywords
      CALL KEYPCP (INVOL, INCNO, OUTVOL, OUTCNO, 0, ' ', IERR)
C                                       Create history file and
C                                       copy HI of INSEQ
 310  CALL HIINIT (3)
      CALL HISCOP (HLUN(1), HLUN(2), INVOL, OUTVOL, INCNO, OUTCNO,
     *   CATIN, WBUFF, IBUF, ERROR)
      IF (ERROR.GT.2) GO TO 320
C                                       Add SUMSQ history
      CALL WAWA2A (NAMS(1), NAME, CLASS, SEQ, PTYPE, DISK, USID)
      CALL HENCO1 (PRGNAM, NAME, CLASS, ASEQ, INVOL, HLUN(2),
     *   IBUF, ERROR)
      IF (ERROR.NE.0) GO TO 320
      CALL WAWA2A (NAMS(2), NAME, CLASS, SEQ, PTYPE, DISK, USID)
      CALL HENCOO (PRGNAM, NAME, CLASS, SEQ, DISK, HLUN(2),
     *   IBUF, ERROR)
      IF (ERROR.NE.0) GO TO 320
      WRITE (HILINE,1310) PRGNAM, S1, S2, S3
      CALL HIADD (HLUN(2), HILINE, IBUF, ERROR)
      IF (ERROR.NE.0) GO TO 320
      WRITE (HILINE,1311) PRGNAM, WT
      CALL HIADD (HLUN(2), HILINE, IBUF, ERROR)
      IF (ROOT) THEN
         WRITE (HILINE,1314)
         CALL HIADD (HLUN(2), HILINE, IBUF, ERROR)
         IF (ERROR.NE.0) GO TO 320
         END IF
      WRITE (HILINE,1312) PRGNAM, (RPARM(I), I = 18,24)
      CALL HIADD (HLUN(2), HILINE, IBUF, ERROR)
      IF (ERROR.NE.0) GO TO 320
      WRITE (HILINE,1313) PRGNAM, (RPARM(I), I = 25,31)
      CALL HIADD (HLUN(2), HILINE, IBUF, ERROR)
C                                       Close HI file
 320  CALL HICLOS (HLUN(2), .TRUE., IBUF, IERR)
C                                       Report any errors
      IF (ERROR.EQ.0) ERROR = IERR
      IF (ERROR.EQ.0) GO TO 990
 330     WRITE (MSGTXT,1330) ERROR
         CALL MSGWRT (8)
         GO TO 990
C                                       Print error message
 980  WRITE (MSGTXT,1980) SUBS(NSUB), ERROR
      CALL MSGWRT (8)
C                                       Print offending file
      CALL PRTNAM (NAMS(JFIL), 8)
      NRET = 16
C                                       go home
 990  CALL TSKEND (NRET)
C
 999  STOP
C-----------------------------------------------------------------------
 1010 FORMAT ('Input map')
 1011 FORMAT ('Output map')
 1160 FORMAT ('Open map with seq. no.',I5)
 1161 FORMAT ('BUT ITS AXES DO NOT MATCH THE OUTPUT')
 1300 FORMAT ('Copy scratch to output image')
 1310 FORMAT (A6,'/ Seq. number from',I4,' to',I4,' by',I4)
 1311 FORMAT (A6,' FACTOR = ',1PE13.5,10X,'/ Multiplier')
 1312 FORMAT (A6,' BLC =',6(F5.0,','),F5.0)
 1313 FORMAT (A6,' TRC =',6(F5.0,','),F5.0)
 1314 FORMAT ('Took square root.')
 1330 FORMAT ('WARNING: HI FILE HAD PROBLEMS.  ERROR=',I7)
 1980 FORMAT (A6,' ERROR NO ',I6)
         END

      INTEGER FUNCTION LUNTMP (TYPE)
C-----------------------------------------------------------------------
C! Finds an available LUN for temporary use
C# IO
C-----------------------------------------------------------------------
C;  Copyright (C) 2010, 2013-2014. 2017-2018
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Finds an unused LUN of a type legitimate for your use
C   It should be closed in the calling routine since others may need it
C   Inputs:
C      TYPE     I   Type code: 0 map I/o to disk, 1 non-map I/O to disk
C                   2 => text I/O  may change DEVTAB
C                   3 as 2 but do NOT use standard text LUNs
C   Output:
C      LUNTMP   I   LUN to use - 0 => error
C-----------------------------------------------------------------------
      INTEGER   TYPE
C
      INTEGER   I, MLUN, LUN, IERR, FIND
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      LUNTMP = 0
      IF ((TYPE.LT.0) .OR. (TYPE.GT.3)) GO TO 999
      MLUN = 128 - NTAPED
      IF (MLUN.GT.120) MLUN = 120
C                                       binary disk file
      IF (TYPE.LT.2) THEN
         DO 10 I = 1,MLUN
            LUN = MLUN + 1 - I
            IF (DEVTAB(LUN).EQ.0) THEN
               CALL LSERCH ('SRCH', LUN, FIND, .TRUE., IERR)
               IF (IERR.EQ.1) THEN
                  CALL LSERCH ('SRCH', LUN, FIND, .FALSE., IERR)
                  IF (IERR.EQ.1) THEN
                     LUNTMP = LUN
                     GO TO 999
                     END IF
                  END IF
               END IF
 10         CONTINUE
C                                       text file
      ELSE
         MLUN = MIN (MLUN, 99)
C                                       try reserved ones
         IF (TYPE.LT.3) THEN
            DO 20 I = 1,MLUN
               LUN = MLUN + 1 - I
               IF (DEVTAB(LUN).EQ.3) THEN
                  CALL LSERCH ('SRCH', LUN, FIND, .FALSE., IERR)
                  IF (IERR.EQ.1) THEN
                     LUNTMP = LUN
                     GO TO 999
                     END IF
                  END IF
 20            CONTINUE
            END IF
C                                       force one
         DO 30 I = 1,MLUN
            LUN = MLUN + 1 - I
            IF (DEVTAB(LUN).EQ.0) THEN
               CALL LSERCH ('SRCH', LUN, FIND, .TRUE., IERR)
               IF (IERR.EQ.1) THEN
                  CALL LSERCH ('SRCH', LUN, FIND, .FALSE., IERR)
                  IF (IERR.EQ.1) THEN
                     DEVTAB(LUN) = 3
                     LUNTMP = LUN
                     GO TO 999
                     END IF
                  END IF
               END IF
 30         CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C! closes open devices: disk, line printer, terminal
C# Z IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2004, 2015, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Close the file associated with LUN removing any exclusive use state
C   and clear the FTAB entry for the LUN.
C   Inputs:
C      LUN      I           Logical unit number
C      FIND     I           Index in FTAB to file control block for LUN
C   Output:
C      IERR     I           Error return code: 0 => no error
C                              1 => close error
C                              2 => file already closed in FTAB
C                              3 => both errors
C                              4 => erroneous LUN
C   Generic version.
C   No longer closes TV devices as of the 15OCT87 release.
C   No longer closes tape devices as of the 15APR87 release.
C   No longer closes Tektronix devices as of the 15OCT87 release.
C   No longer closes text files as of the 15OCT87 release.
C   No longer closes line printer as of the 15JAN91 release.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
C
      INTEGER   ERRLUN, ERRTER, JERR, FCBOFF, IMAP, I, J
      LOGICAL   T, F, MAP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA T, F /.TRUE., .FALSE./
      DATA ERRLUN, ERRTER /12, 6/
C-----------------------------------------------------------------------
C                                       Check inputs.
      IERR = 4
C                                       Valid LUN?
      IF ((LUN.LE.0) .OR. (LUN.GT.120) .OR. (LUN.EQ.ERRLUN) .OR.
     *   (LUN.EQ.ERRTER)) THEN
         WRITE (MSGTXT,1000) LUN
         GO TO 995
         END IF
C                                       Does not handle TV
      IF (DEVTAB(LUN).EQ.4) THEN
         MSGTXT = 'ZCLOSE: DOES NOT PERFORM TV CLOSES AS OF 15OCT87'
         GO TO 995
         END IF
C                                       Does not handle tape
      IF (LUN.GE.129-NTAPED) THEN
         MSGTXT = 'ZCLOSE: DOES NOT PERFORM TAPE CLOSES AS OF 15APR87'
         GO TO 995
         END IF
C                                       Does not handle Tektronix
      IF (LUN.EQ.7) THEN
         MSGTXT = 'ZCLOSE: DOES NOT PERFORM TEKTRONIX CLOSES AS OF '
     *      // '15OCT87'
         GO TO 995
         END IF
C                                       not line printer 15JAN91
      IF (LUN.EQ.1) THEN
         MSGTXT = 'ZCLOSE: DOES NOT PERFORM LINE PRINTER CLOSES AS OF '
     *      // '15JAN91'
         GO TO 995
         END IF
C                                       Does not handle text files
      IF (DEVTAB(LUN).EQ.3) THEN
         MSGTXT = 'ZCLOSE: DOES NOT PERFORM TEXT FILE CLOSES AS OF '
     *      // '15OCT87'
         GO TO 995
         END IF
C                                       Locate LUN in FTAB.
      IERR = 0
      MAP = F
      CALL LSERCH ('SRCH', LUN, I, MAP, JERR)
      IF (JERR.EQ.0) THEN
         FCBOFF = NMOFF
         IMAP = 0
      ELSE
         MAP = T
         CALL LSERCH ('SRCH', LUN, I, MAP, JERR)
         IF (JERR.EQ.0) THEN
            FCBOFF = MOFF
            IMAP = 1
C                                       LUN already closed in FTAB.
         ELSE
            IERR = 2
            WRITE (MSGTXT,1050) LUN
            GO TO 995
            END IF
         END IF
      IF (I.NE.FIND) THEN
         WRITE (MSGTXT,1055) LUN, I, FIND
         CALL MSGWRT (6)
         FIND = I
         END IF
C                                       Close a binary disk file here.
      IF (MOD (DEVTAB(LUN), 2).EQ.0) THEN
         FCBOFF = FCBOFF + FIND
         CALL ZDACLS (FTAB(FCBOFF), IMAP, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1060) IERR
            CALL MSGWRT (7)
            CALL ZERROR ('ZDACLS', FTAB(FCBOFF+FCBERR), ' ',
     *         FTAB(FCBOFF), MAP)
            END IF
C                                       Close a Fortran device here.
C                                       Terminal?
      ELSE IF (LUN.EQ.5) THEN
         CALL ZTTCLS (LUN, FIND, IERR)
         IF (IERR.NE.0) THEN
            IF (FTAB(FIND+1+NFCBER).GT.0) THEN
               CALL ZERROR ('ZTTCLS', FTAB(FIND+1+NFCBER), ' ', -999,
     *            .FALSE.)
            ELSE
               WRITE (MSGTXT,1080) IERR, LUN
               CALL MSGWRT (7)
               END IF
            IERR = 1
            END IF
C                                       Unknown Fortran device LUN.
      ELSE
         WRITE (MSGTXT,1090) LUN
         IERR = 4
         GO TO 995
         END IF
C                                       Clear FTAB entry for LUN.
      CALL LSERCH ('CLOS', LUN, FIND, MAP, JERR)
      IF (JERR.NE.0) THEN
         IERR = IERR + 2
         WRITE (MSGTXT,1100) LUN
         GO TO 995
         END IF
      CALL FSERCH (FIND, I, J, JERR)
      IF (JERR.EQ.0) THEN
         IF (I.EQ.1) DEVNAM(J) = ' '
         IF (I.EQ.2) NONNAM(J) = ' '
         IF (I.EQ.3) MAPNAM(J) = ' '
         END IF
      GO TO 999
C
 995  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZCLOSE: INVALID LUN = ',I3)
 1050 FORMAT ('ZCLOSE: LUN = ',I3,' ALREADY CLOSED IN FTAB ON SEARCH')
 1055 FORMAT ('ZCLOSE: LUN = ',I3,' FIND VALUES',2I5,' DISAGREE')
 1060 FORMAT ('ZCLOSE: ZDACLS RETURNS ERROR = ',I1)
 1080 FORMAT ('ZCLOSE: ZTTCLS RETURNS ERROR ',I2,' FOR LUN = ',I6)
 1090 FORMAT ('ZCLOSE: UNKNOWN FORTRAN DEVICE.  LUN = ',I3)
 1100 FORMAT ('ZCLOSE: LUN = ',I3,' ALREADY CLOSED IN FTAB ON CLOSE')
      END

      PROGRAM GRADDR
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C     Program to read a gripe file and produce a list of the
C     gripers to aid in readying gripes for distribution.
C     "Spawned" from PROGRAM GETTBC (DCW, 30Sep84)
C
C     - NDW, 9Mar86 (with assistance from EWG & GAF)
C-----------------------------------------------------------------------
      IMPLICIT    NONE
      INTEGER     NGRIPE, LIN, LOUT, L5, L6, NIN, NOUT, K,
     *   NFIRST, NLAST, NSPLIT, ASPLIT, ITRIM
      CHARACTER   GRIPE*5000, NEWLIN*3, INFIL*30, OUTFIL*30,
     *   SPLIT*20, STAT*6, GRARGS(9)*5000, FNLOUT*1, FNLTBC*1,
     *   FNLIN*1, NAMES(300)*132, ADDRS(300)*264
      DATA        LIN, LOUT, L5, L6 /1, 2, 5, 6/
      DATA        NEWLIN /'|||'/
C-----------------------------------------------------------------------
C                                       initialize: infile
 10   CONTINUE
         WRITE (L6,1010) ' INFIL'
         READ (L5,1015) INFIL
         IF (INFIL.EQ.' ') GO TO 15
            CALL PADTEX (L6, INFIL)
            OPEN (UNIT=LIN, FILE=INFIL, STATUS='OLD', ERR=10)
            GO TO 20
 15      CONTINUE
            OPEN (UNIT=LIN, FILE='GRINFIL', STATUS='OLD', ERR=10)
 20   CONTINUE
         WRITE (L6, 1010) 'OUTFIL'
         READ (L5, 1015) OUTFIL
         IF (OUTFIL.EQ.' ') GO TO 25
            CALL PADTEX (L6, OUTFIL)
            OPEN (UNIT=LOUT, FILE=OUTFIL, STATUS='NEW',
     *         CARRIAGECONTROL='LIST', ERR=20)
            GO TO 30
 25      CONTINUE
            OPEN (UNIT=LOUT, FILE='GROUTFIL', STATUS='NEW',
     *         CARRIAGECONTROL='LIST', ERR=20)
 30   NIN = 0
      NOUT = 0
C                                       big loop:
 50   CONTINUE
         CALL GETGRI (L6, LIN, NEWLIN, NGRIPE, GRIPE, GRARGS)
         IF (GRIPE.EQ.' ') GO TO 900
         NIN = NIN + 1
         IF (NIN.EQ.1) NFIRST = NGRIPE
C                                       print names & addresses:
 60         CONTINUE
            NSPLIT=ITRIM(GRARGS(3))
            ASPLIT=ITRIM(GRARGS(4))
            DO 65 K=1,NOUT
               IF((NAMES(K) .EQ. GRARGS(3)(1:NSPLIT))
     *           .AND. (ADDRS(K) .EQ. GRARGS(4)(1:ASPLIT)))
     *           GO TO 70
 65            CONTINUE
            WRITE (LOUT, '(A)') GRARGS(3)(1:NSPLIT)
            WRITE (LOUT, '(A)') GRARGS(4)(1:ASPLIT)
            WRITE (LOUT,1020)
            NOUT = NOUT + 1
            NAMES(NOUT)=GRARGS(3)(1:NSPLIT)
            ADDRS(NOUT)=GRARGS(4)(1:ASPLIT)
 70      CONTINUE
         NLAST = NGRIPE
         GO TO 50
C                                       that's all, folks:
 900  CONTINUE
      WRITE (L6, 1900) NIN, NFIRST, NLAST
      CLOSE (UNIT=LIN)
C                                       close LOUT:
 920  CLOSE (UNIT=LOUT)
C-----------------------------------------------------------------------
 1010 FORMAT (' GRADDR: enter name for file ', A6, ': ', $)
 1015 FORMAT (A30)
 1020 FORMAT (' ')
 1900 FORMAT (' GRADDR:', I5, ' gripes in (', I4, ' to', I5, ')')
      END

LOCAL INCLUDE 'FIXBX.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCLN.INC'
      HOLLERITH XNAMEI(3), XCLASI(2), XXSOUR(4), XINFIL(12),
     *   XBXFIL(12), XOUFIL(12)
      REAL       DISKIN, XSEQ, XNOLD, ORASH(MAXAFL), ODECSH(MAXAFL),
     *   XNNEW, NRASH(MAXAFL), NDECSH(MAXAFL), XNBOX, CLBOX(4,50),
     *   CELSIZ(2), XSIZE(2), ROTATE, BPARM(10), XGAUSS
      COMMON /INPARM/ XNAMEI, XCLASI, XSEQ, DISKIN, XXSOUR, XINFIL,
     *   XNOLD, XGAUSS, ORASH, ODECSH, XNBOX, CLBOX, XBXFIL, XNNEW,
     *   NRASH, NDECSH, XOUFIL, CELSIZ, XSIZE, ROTATE, BPARM
C
      DOUBLE PRECISION RA0, DEC0, RAI(MAXFLD), DECI(MAXFLD),
     *   RAO(MAXFLD), DECO(MAXFLD)
      REAL      EDGSKP
      INTEGER   NFLDI, NFLDO, NGAUSS, WINI(4,MXNBFL), WINO(4,MXNBFL),
     *   IMSI(2,MAXFLD), IMSO(2,MAXFLD), NBOXI(MAXFLD), NBOXO(MAXFLD),
     *   IMSIZE(2), OLDSIZ(2), CATNO, SEQIN, IDISK, LUNBX, INDBX,
     *   SCRTCH(256)
      LOGICAL   RQUICK
      CHARACTER INFIL*48, BOXFIL*48, NAMEIN*12, CLASIN*6, OBOXF*48
      COMMON /FIXBXP/ RA0, DEC0, RAI, DECI, RAO, DECO, SCRTCH, NFLDI,
     *   NFLDO, WINI, WINO, IMSI, IMSO, NBOXI, NBOXO, IMSIZE, OLDSIZ,
     *   EDGSKP, CATNO, SEQIN, IDISK, LUNBX, RQUICK, INDBX, NGAUSS
      COMMON /FIXBXC/ INFIL, BOXFIL, OBOXF, NAMEIN, CLASIN
      INCLUDE 'INCS:DANT.INC'
LOCAL END
      PROGRAM FIXBX
C-----------------------------------------------------------------------
C! convert a BOXFILE to another for input to IMAGR
C# Imaging
C-----------------------------------------------------------------------
C;  Copyright (C) 2004-2005, 2008, 2011-2012, 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FIXBX makes a file which can then be used as an input BOXFILE
C   for IMAGR.  This is intended for wide-field imaging nd to cope with
C   interfering sources including the Sun.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME       XNAMEI/NAMEIN    Name of input UV data.
C      INCLASS      XCLASI/CLASIN    Class of input UV data.
C      INSEQ        SEQ/SEQIN        Seq. of input UV data.
C      INDISK       DISKIN/IDISK     Disk number of input UV data.
C      SOURCES      XXSOUR/SOURCE    Source which will be mapped.
C      BOXFILE      INFILE           old BOXFILE
C      OBOXFILE     OUFILE           new BOXFILE
C      CELLSIZE     CELSIZ           new pixel size in image.
C      IMSIZE       XSIZE/IMSIZE     new image size, also field size.
C      ROTATE       ROTATE           new image rotation
C      BPARM        BPARM            1. old CELLS(1)
C                                    2. old CELLS(2)
C                                    3. old IMSIZE(1)
C                                    4. old IMSIZE(2)
C                                    5. old ROTATE
C                                    6  edgskp
C-----------------------------------------------------------------------
      CHARACTER PNAM*6
C
      INTEGER   IRET
      INCLUDE 'FIXBX.INC'
      DATA PNAM /'FIXBX'/
C-----------------------------------------------------------------------
C                                       init
      CALL FIXBXI (PNAM, IRET)
C                                       do it
      IF (IRET.EQ.0) CALL FIXBXD (IRET)
C
      CALL DIETSK (IRET, RQUICK, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE FIXBXI (PNAM, IRET)
C-----------------------------------------------------------------------
C   starts up FIXBX, reads the input text files
C-----------------------------------------------------------------------
      CHARACTER PNAM*(*)
      INTEGER   IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER MTYPE*2, STAT*4
      INTEGER   NPARMS, IROUND, IBUFF(512), LUNSU, SQUAL, SOUID, NID,
     *   IERR, I, J, NF
      REAL      CATR(256)
      DOUBLE PRECISION CATD(128)
      HOLLERITH CATH(256)
      LOGICAL   MULTI
      INCLUDE 'FIXBX.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (CATH, CATD, CATR, CATBLK)
      DATA LUNSU /27/
      DATA NID, SQUAL /1, -1/
      DATA MTYPE /'UV'/
C-----------------------------------------------------------------------
C                                       initialize
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
C                                       get the input parameters
      NPARMS = 66 + 4 * MAXAFL + 200
      CALL GTPARM (PNAM, NPARMS, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         RQUICK = .FALSE.
         IF (IERR.EQ.1) THEN
            MSGTXT = 'CANNOT FIND INITIATOR IN GTPARM'
            CALL MSGWRT (1)
            GO TO 999
         ELSE
            MSGTXT= 'DISK PROBLEMS IN GTPARM'
            GO TO 980
            END IF
         END IF
      IRET = 0
      IF (RQUICK) CALL RELPOP (IRET, IBUFF, IERR)
C                                       set parameters
      IMSIZE(1) = IROUND (XSIZE(1))
      IMSIZE(2) = IROUND (XSIZE(2))
      IF (BPARM(1).LE.0.0) BPARM(1) = CELSIZ(1)
      IF (BPARM(2).LE.0.0) BPARM(2) = CELSIZ(2)
      IF (BPARM(3).LE.0.5) BPARM(3) = XSIZE(1)
      IF (BPARM(4).LE.0.5) BPARM(4) = XSIZE(2)
      OLDSIZ(1) = IROUND (BPARM(3))
      OLDSIZ(2) = IROUND (BPARM(4))
      EDGSKP = BPARM(6)
      IF (EDGSKP.LT.0.01) EDGSKP = 3.0
      BPARM(6) = EDGSKP
      IF ((BPARM(7).LT.0.1) .OR. (BPARM(7).GT.10.0)) BPARM(7) = 1.0
      CALL H2CHR (48, 1, XBXFIL, BOXFIL)
      CALL H2CHR (48, 1, XOUFIL, OBOXF)
      CALL H2CHR (48, 1, XINFIL, INFIL)
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLASI, CLASIN)
      SEQIN = IROUND (XSEQ)
      IDISK = IROUND (DISKIN)
C                                       locate map in directory
      CATNO = 1
      CALL CATDIR ('SRCH', IDISK, CATNO, NAMEIN, CLASIN, SEQIN,
     *   MTYPE, NLUSER, STAT, IBUFF, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'REQUESTED DATA NOT FOUND IN CATALOG DIRECTORY'
         GO TO 980
         END IF
C                                       read catalog block
      CALL CATIO ('READ', IDISK, CATNO, CATBLK, 'REST', IBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 980
         END IF
      WRITE (MSGTXT,1010) NAMEIN, CLASIN, SEQIN, IDISK, CATNO
      CALL MSGWRT (3)
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
      UNAME = NAMEIN
      UCLAS = CLASIN
      UDISK = IDISK
      USEQ = SEQIN
C                                       single-source use UVPGET output
      CALL MULSDB (CATBLK, MULTI)
      IF (.NOT.MULTI) THEN
         SOUID = -1
         RA0 = RA
         DEC0 = DEC
         IF ((RA0.EQ.0.0D0) .AND. (DEC0.EQ.0.0D0)) THEN
            MSGTXT = 'CANNOT FIND SOURCE POSITION'
            GO TO 980
            END IF
C                                       multi-source get 1 source
      ELSE
         CALL H2CHR (16, 1, XXSOUR, SOURCS(1))
C                                       multi-source file, but no source
C                                       specified...
         IF (SOURCS(1).EQ.' ') THEN
            MSGTXT = 'MULTI SOURCE FILE BUT NO SOURCE SPECIFIED!'
            GO TO 980
C                                       find source...
         ELSE
            CALL SOURNU (SOURCS(1), SQUAL, 1, IDISK, CATNO, NID, IBUFF,
     *         SOUID, IRET)
            IF (IRET.EQ.0) THEN
               CALL GETSOU (SOUID, IDISK, CATNO, CATBLK, LUNSU, IRET)
               IF (IRET.EQ.0) THEN
                  DEC0 = DECEPO * RAD2DG
                  RA0 = RAEPO * RAD2DG
               ELSE
                  MSGTXT = 'ERROR ACCESSING SU EXTENSION'
                  GO TO 980
                  END IF
            ELSE
               MSGTXT = 'ERROR FINDING REQUESTED SOURCE'
               GO TO 980
               END IF
            END IF
         END IF
C                                       read box files for field parms
      CALL FIELDF (INFIL, RA0, DEC0, XNOLD, ORASH, ODECSH, BPARM(5),
     *   OLDSIZ, NF, NFLDI, IMSI, RAI, DECI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) IRET, BOXFIL
         GO TO 980
         END IF
      IF (NFLDI.LT.1) THEN
         NGAUSS = 1
         NFLDI = NF
      ELSE
         NGAUSS = XGAUSS + 0.1
         NGAUSS = MAX (1, NGAUSS)
         END IF
      IF (NFLDI.LT.1) THEN
         NFLDI = 1
         IMSI(1,1) = OLDSIZ(1)
         IMSI(2,1) = OLDSIZ(2)
         END IF
      CALL FIELDF (BOXFIL, RA0, DEC0, XNNEW, NRASH, NDECSH, ROTATE,
     *   IMSIZE, NF, NFLDO, IMSO, RAO, DECO, IRET)
      IF ((IRET.NE.0) .AND. (IRET.NE.5)) THEN
         WRITE (MSGTXT,1100) IRET, OBOXF
         GO TO 980
         END IF
      IF (NFLDO.LT.1) NFLDO = NF
      IF (NFLDO.LT.1) THEN
         NFLDO = 1
         IMSO(1,1) = IMSIZE(1)
         IMSO(2,1) = IMSIZE(2)
         END IF
C                                       read windows
      I = NFLDI * NGAUSS
      CALL FILL (I, 0, NBOXI)
      IF (INFIL.NE.' ') THEN
         CALL WINDF (WINI, NBOXI, I, NGAUSS, IMSI, INFIL, .TRUE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1110) IRET, BOXFIL
            GO TO 980
            END IF
         END IF
      IF (NBOXI(1).LE.0) THEN
         NBOXI(1) = XNBOX + 0.5
         DO 10 I = 1,NBOXI(1)
            J = (I - 1) * NFLDI + 1
            WINI(1,J) = IROUND (CLBOX(1,I))
            WINI(2,J) = IROUND (CLBOX(2,I))
            WINI(3,J) = IROUND (CLBOX(3,I))
            WINI(4,J) = IROUND (CLBOX(4,I))
 10         CONTINUE
         END IF
      IF (NBOXI(1).LE.0) THEN
         NBOXI(1) = 1
         WINI(1,1) = 11
         WINI(2,1) = 11
         WINI(3,1) = OLDSIZ(1) - 10
         WINI(4,1) = OLDSIZ(2) - 10
         END IF
C                                       output windows
      I = NFLDO * NGAUSS
      CALL FILL (I, 0, NBOXO)
C     IF (BOXFIL.NE.' ') THEN
C        CALL WINDF (WINO, NBOXO, I, NGAUSS, IMSO, BOXFIL, .FALSE.,
C    *      IRET)
C        IF ((IRET.NE.0) .AND. (IRET.NE.5)) THEN
C           WRITE (MSGTXT,1110) IRET, OBOXF
C           GO TO 980
C           END IF
C        END IF
      IRET = 0
      GO TO 999
C                                       Error
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CATIO ERROR NO', I5)
 1010 FORMAT ('Found ', A12, A6, ' Seq', I4, ' Disk:', I3,' in slot',
     *   I5)
 1100 FORMAT ('ERROR',I5,' field reading ',A)
 1110 FORMAT ('ERROR',I5,' window reading ',A)
      END
      SUBROUTINE FIXBXD (IRET)
C-----------------------------------------------------------------------
C   Fixes the windows
C   Output:
C      IRET    I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   I, J1, J, NERR, IERR, LERR, LFERR, NTOT, K, K1, IROUND,
     *   NF(3), FF(10,3), IW(4), JJ, NG, KK
      REAL      DX, DY, TX(4), TY(4), EX, EY, XF(4,10,3), YF(4,10,3),
     *   CX, CY
      DOUBLE PRECISION TRA(4), TDEC(4), Z
      LOGICAL   CIRCLE
      INCLUDE 'FIXBX.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       mark as untouched
C     DO 10 I = 1,NFLDO
C        NBOXO(I) = -ABS (NBOXO(I))
C10      CONTINUE
C                                       Default output boxes
      DO 10 I = 1,NFLDO
         WINO(1,I) = -1
         WINO(2,I) = MIN (IMSO(1,I), IMSO(2,I)) / 2 - MAX (5., EDGSKP)
         WINO(3,I) = IMSO(1,I)/2
         WINO(4,I) = IMSO(2,I)/2 + 1
 10      CONTINUE
C                                       loop over input fields
      NTOT = 0
      LOCNUM = 1
      AXTYP(LOCNUM) = 1
      CORTYP(LOCNUM) = 1
      LABTYP(LOCNUM) = 65
      AXFUNC(1,LOCNUM) = 2
      AXFUNC(2,LOCNUM) = 2
      KLOCL(LOCNUM) = 0
      KLOCM(LOCNUM) = 1
      AXINC(1,LOCNUM) = -CELSIZ(1) / 3600.0
      AXINC(2,LOCNUM) = CELSIZ(2) / 3600.0
      ROT(LOCNUM) = ROTATE
      LOCNUM = 2
      AXTYP(LOCNUM) = 1
      CORTYP(LOCNUM) = 1
      LABTYP(LOCNUM) = 65
      AXFUNC(1,LOCNUM) = 2
      AXFUNC(2,LOCNUM) = 2
      KLOCL(LOCNUM) = 0
      KLOCM(LOCNUM) = 1
      AXINC(1,LOCNUM) = -BPARM(1) / 3600.0
      AXINC(2,LOCNUM) = BPARM(2) / 3600.0
      ROT(LOCNUM) = BPARM(5)
      COND2R = DG2RAD
      IRET = 0
      DO 100 I = 1,NFLDI
         DO 95 NG = 1,NGAUSS
            JJ = (NG - 1) * NFLDI + I
C                                       init location common
            LOCNUM = 2
            RPVAL(1,LOCNUM) = RAI(I)
            RPVAL(2,LOCNUM) = DECI(I)
            RPLOC(1,LOCNUM) = IMSI(1,I) / 2
            RPLOC(2,LOCNUM) = IMSI(2,I) / 2 + 1
C                                       loop over boxes
            DO 90 J = 1,NBOXI(JJ)
               IRET = IRET + 1
               NTOT = NTOT + 1
               LOCNUM = 2
               J1 = NGAUSS * NFLDI * (J - 1) + JJ
               CIRCLE = WINI(1,J1).EQ.-1
C                                       get corner coords
               IF (CIRCLE) THEN
                  DX = WINI(3,J1)
                  DY = WINI(4,J1) + WINI(2,J1) * BPARM(7)
                  CALL XYVAL (DX, DY, TRA(1), TDEC(1), Z, IERR)
                  DX = WINI(3,J1) - WINI(2,J1) * BPARM(7)
                  DY = WINI(4,J1)
                  CALL XYVAL (DX, DY, TRA(2), TDEC(2), Z, IERR)
                  DX = WINI(3,J1)
                  DY = WINI(4,J1) - WINI(2,J1) * BPARM(7)
                  CALL XYVAL (DX, DY, TRA(3), TDEC(3), Z, IERR)
                  DX = WINI(3,J1) + WINI(2,J1) * BPARM(7)
                  DY = WINI(4,J1)
                  CALL XYVAL (DX, DY, TRA(4), TDEC(4), Z, IERR)
               ELSE
                  CX = (WINI(1,J1) + WINI(3,J1)) / 2.0
                  CY = (WINI(2,J1) + WINI(4,J1)) / 2.0
                  DX = CX + BPARM(7) * (WINI(1,J1) - CX)
                  DY = CY + BPARM(7) * (WINI(4,J1) - CY)
                  CALL XYVAL (DX, DY, TRA(1), TDEC(1), Z, IERR)
                  DX = CX + BPARM(7) * (WINI(1,J1) - CX)
                  DY = CY + BPARM(7) * (WINI(2,J1) - CY)
                  CALL XYVAL (DX, DY, TRA(2), TDEC(2), Z, IERR)
                  DX = CX + BPARM(7) * (WINI(3,J1) - CX)
                  DY = CY + BPARM(7) * (WINI(2,J1) - CY)
                  CALL XYVAL (DX, DY, TRA(3), TDEC(3), Z, IERR)
                  DX = CX + BPARM(7) * (WINI(3,J1) - CX)
                  DY = CY + BPARM(7) * (WINI(4,J1) - CY)
                  CALL XYVAL (DX, DY, TRA(4), TDEC(4), Z, IERR)
                  END IF
C                                       loop over output fields
               LERR = 5
               NF(1) = 0
               NF(2) = 0
               NF(3) = 0
               DO 30 K = 1,NFLDO
                  KK = (NG - 1) * NFLDO + K
C                                       init location common
                  LOCNUM = 1
                  RPVAL(1,LOCNUM) = RAO(K)
                  RPVAL(2,LOCNUM) = DECO(K)
                  RPLOC(1,LOCNUM) = IMSO(1,K) / 2
                  RPLOC(2,LOCNUM) = IMSO(2,K) / 2 + 1
                  NERR = 0
                  CALL RFILL (4, -10000.0, TX)
                  CALL RFILL (4, -100000.0, TY)
                  DO 20 K1 = 1,4
                     CALL XYPIX (TRA(K1), TDEC(K1), DX, DY, IERR)
                     IF (IERR.NE.0) THEN
                        NERR = NERR + 4
                     ELSE IF ((DX.LT.EDGSKP+0.5) .OR. (DY.LT.EDGSKP+0.5)
     *                  .OR. (DX.GT.IMSO(1,K)-EDGSKP+0.5) .OR.
     *                  (DY.GT.IMSO(2,K)-EDGSKP+0.5)) THEN
                        TX(K1) = DX
                        TY(K1) = DY
                        NERR = NERR + 1
                     ELSE
                        TX(K1) = DX
                        TY(K1) = DY
                        END IF
 20                  CONTINUE
                  IF (NERR.LT.LERR) THEN
                     LERR = NERR
                     LFERR = K
                     END IF
C                                       put window in output
                  IF (NERR.EQ.0) THEN
                     NBOXO(KK) = MAX (0, NBOXO(KK)) + 1
                     K1 = (NBOXO(KK) - 1) * NFLDO * NGAUSS + KK
                     DX = MIN (TX(1), TX(2), TX(3), TX(4))
                     EX = MAX (TX(1), TX(2), TX(3), TX(4))
                     DY = MIN (TY(1), TY(2), TY(3), TY(4))
                     EY = MAX (TY(1), TY(2), TY(3), TY(4))
                     IF (CIRCLE) THEN
                        WINO(1,K1) = -1
                        WINO(2,K1) = (EX + EY - DX - DY) / 4.0  + 0.7
                        WINO(3,K1) = IROUND ((EX+DX)/2.0)
                        WINO(4,K1) = IROUND ((EY+DY)/2.0)
                     ELSE
                        WINO(1,K1) = IROUND (DX)
                        WINO(2,K1) = IROUND (DY)
                        WINO(3,K1) = IROUND (EX)
                        WINO(4,K1) = IROUND (EY)
                        END IF
C                                       remember possibles
                  ELSE IF ((NERR.LT.4) .AND. (NF(NERR).LT.10)) THEN
                     NF(NERR) = NF(NERR) + 1
                     FF(NF(NERR),NERR) = K
                     CALL RCOPY (4, TX, XF(1,NF(NERR),NERR))
                     CALL RCOPY (4, TY, YF(1,NF(NERR),NERR))
                     END IF
 30               CONTINUE
C                                       message rather than try for now
               IF (LERR.GT.0) THEN
                  WRITE (MSGTXT,1030) I, J, (WINI(K,J1), K = 1,4)
                  CALL MSGWRT (7)
                  K1 = 0
                  IF (NF(3).GT.0) K1 = 3
                  IF (NF(2).GT.0) K1 = 2
                  IF (NF(1).GT.0) K1 = 1
                  IF (K1.NE.0) THEN
                     DO 40 K = 1,NF(K1)
                        CALL RCOPY (4, XF(1,K,K1), TX)
                        CALL RCOPY (4, YF(1,K,K1), TY)
                        DX = MIN (TX(1), TX(2), TX(3), TX(4))
                        EX = MAX (TX(1), TX(2), TX(3), TX(4))
                        DY = MIN (TY(1), TY(2), TY(3), TY(4))
                        EY = MAX (TY(1), TY(2), TY(3), TY(4))
                        IW(1) = IROUND (DX)
                        IW(2) = IROUND (DY)
                        IW(3) = IROUND (EX)
                        IW(4) = IROUND (EY)
                        WRITE (MSGTXT,1035) FF(K,K1), IW
                        CALL MSGWRT (6)
 40                     CONTINUE
                     END IF
               ELSE
                  IRET = IRET - 1
                  END IF
 90            CONTINUE
 95         CONTINUE
 100     CONTINUE
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET, NTOT
         CALL MSGWRT (7)
      ELSE
         WRITE (MSGTXT,1101) NTOT
         CALL MSGWRT (3)
         END IF
C                                       copy to output
      CALL FIXBXO (BOXFIL, OBOXF, NFLDO*NGAUSS, NBOXO, WINO, IRET)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('FIELD',I5,' BOX',I5,' (',4I6,') NOT FOUND')
 1035 FORMAT ('   BUT new field',I5,' had corners',4I7)
 1100 FORMAT (I6,' BOXES OF',I7,' NOT COPIED TO OUTPUT')
 1101 FORMAT ('All',I7,' boxes copied to output')
      END
      SUBROUTINE FIXBXO (IBOXF, OBOXF, NFL, NBOX, WIN, IRET)
C-----------------------------------------------------------------------
C   Copies the control cards from IBOXF to OBOXF and then adds the
C   windows.
C   Inputs:
C      IBOXF   C*(*)   Input box file
C      OBOXF   C*(*)   Output box file
C      NFL     I       Number of fields
C      NBOX    I(*)    Number of boxes / field
C      WIN     I(*)    Windows(4,nfl,*)
C   Outputs
C      IRET    I       Error code
C-----------------------------------------------------------------------
      CHARACTER IBOXF*(*), OBOXF*(*)
      INTEGER   NFL, NBOX(*), WIN(4,NFL,*), IRET
C
      INTEGER   LUNI, INDI, LUNO, INDO, I, J, KBP, BX(4), IROUND, JTRIM,
     *   K
      REAL      RDUM
      DOUBLE PRECISION X
      CHARACTER LINE*132
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       open files
      LUNO = 11
      CALL ZTXOPN ('WRIT', LUNO, INDO, OBOXF, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OUTPUT'
         GO TO 980
         END IF
      LUNI = 10
      IRET = 5
      IF (IBOXF.NE.' ') THEN
         CALL ZTXOPN ('READ', LUNI, INDI, IBOXF, .FALSE., IRET)
         IF ((IRET.NE.0) .AND. (IRET.NE.5)) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN INPUT'
            GO TO 980
            END IF
         END IF
C                                       copy non-box lines
      IF (IRET.NE.5) THEN
 10      CALL ZTXIO ('READ', LUNI, INDI, LINE, IRET)
         IF ((IRET.NE.0) .AND. (IRET.NE.2)) THEN
            WRITE (MSGTXT,1000) IRET, 'READ INPUT'
            GO TO 980
         ELSE IF (IRET.NE.2) THEN
            I = JTRIM (LINE)
            J = 0
            IF ((LINE(:1).NE.' ') .AND. (LINE(:1).GE.'0') .AND.
     *         (LINE(:1).LE.'9')) THEN
               KBP = 1
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.NE.DBLANK) THEN
                  RDUM = X
                  J = IROUND (RDUM)
                  END IF
               END IF
            IF ((J.LT.1) .OR. (J.GT.NFL)) THEN
               CALL ZTXIO ('WRIT', LUNO, INDO, LINE(:I), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'COPY TO OUTPUT'
                  GO TO 980
                  END IF
               END IF
            GO TO 10
            END IF
         CALL ZTXCLS (LUNI, INDI, IRET)
         END IF
C                                       write windows
      DO 50 I = 1,NFL
         K = 0
         DO 40 J = 1,MAX(1,NBOX(I))
            CALL COPY (4, WIN(1,I,J), BX)
            IF ((BX(1).NE.0) .AND. (BX(2).GT.0) .AND. (BX(3).GT.0) .AND.
     *         (BX(4).GT.0)) THEN
               K = K + 1
               WRITE (LINE,1010) I, BX
               CALL CHTRIM (LINE, 32, LINE, KBP)
               CALL ZTXIO ('WRIT', LUNO, INDO, LINE(:KBP), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITE WINDOW'
                  GO TO 980
                  END IF
               END IF
 40         CONTINUE
         IF (K.EQ.0) THEN
            WRITE (MSGTXT,1005) I
            CALL MSGWRT (6)
            END IF
 50      CONTINUE
      CALL ZTXCLS (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' DOING ',A)
 1005 FORMAT ('OUTPUT FIELD',I5,' HAS NO CLEAN BOXES')
 1010 FORMAT (I4,4I7)
      END
      SUBROUTINE FIELDF (BOXFIL, RA, DEC, XNF, RASH, DECSH, MROTAT,
     *   IMSIZE, NF, NFIELD, FLDSIZ, RAS, DECS, IERR)
C-----------------------------------------------------------------------
C   Fills field parameters from the user test file F lines
C   Local version for finding # fields, RAs, DECs rather than shifts
C   Inputs:
C      BOXFIL   C*48     User provided file name containing box defs
C                        ' ' => none which is okay
C      RA       D        UV data set RA in degrees
C      DEC      D        UV data set Dec in degrees
C      XNF      R        Number of shifts to start with
C      RASH     R(*)     RAshift asec
C      DECSH    R(*)     DECshift asec
C      MROTAT   R        Total rotation in degrees CCW from North
C      IMSIZE   I(2)     Basic image size
C   In/Out:
C      NFIELD   I        Number of fields defined for field parms
C      NF       I        Number of fields with field or Clean lines
C      FLDSIZ   I(2,*)   image sizes
C      RAS      D(*)     Center RAs
C      DECS     D(*)     Center Declinations
C   Outputs:
C      IERR     I        Error return code: 0 => no error
C-----------------------------------------------------------------------
      CHARACTER BOXFIL*48
      DOUBLE PRECISION RA, DEC, RAS(*), DECS(*)
      INTEGER   NFIELD, NF, IMSIZE(2), FLDSIZ(2,*), IERR
      REAL      XNF, RASH(*), DECSH(*), MROTAT
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   LUN, I, J, FIND, KBP, I1, I2, NPTWO
      CHARACTER LINE*132, SIGN*1
      REAL      ARASH, ADECSH
      DOUBLE PRECISION X, XRA, XDEC
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Initial parameters
      NFIELD = XNF + 0.5
      IF (NFIELD.LE.0) THEN
         NFIELD = 0
         RAS(1) = RA
         DECS(1) = DEC
         FLDSIZ(1,1) = IMSIZE(1)
         FLDSIZ(2,1) = IMSIZE(2)
      ELSE
         DO 10 I1 = 1,NFIELD
            CALL XYSHFT (RA, DEC, RASH(I1), DECSH(I1), MROTAT, RAS(I1),
     *         DECS(I1))
            FLDSIZ(1,I1) = IMSIZE(1)
            FLDSIZ(2,I1) = IMSIZE(2)
 10         CONTINUE
         END IF
C                                        Open clean box file
      IF (BOXFIL.NE.' ') THEN
         LUN = 11
         CALL ZTXOPN ('READ', LUN, FIND, BOXFIL, .FALSE., IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPEN'
            CALL MSGWRT (6)
            GO TO 999
            END IF
C                                        Enter parameters from file
         I2 = 0
         NF = 0
         DO 50 I = 1,500000
            CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
            IF (IERR.EQ.2) GO TO 60
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN'
               CALL MSGWRT (6)
               GO TO 999
               END IF
            CALL CHTRIM (LINE, 132, LINE, J)
C                                       parse for field:
C                                       #, fldsiz, rash, decsh
            IF ((LINE(:1).EQ.'F') .OR. (LINE(:1).EQ.'f')) THEN
               KBP = 2
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 50
               IF (X.GE.0.0D0) THEN
                  I1 = X + 0.50D0
               ELSE
                  I1 = X - 0.50D0
                  END IF
               IF ((I1.GE.1) .AND. (I1.LE.MAXFLD)) THEN
                  NF = MAX (NF, I1)
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  FLDSIZ(1,I1) = X + 0.50D0
                  IF (X.LT.0.0D0) FLDSIZ(1,I1) = -1
                  FLDSIZ(1,I1) = MAX (FLDSIZ(1,I1), IMSIZE(1))
                  FLDSIZ(1,I1) = NPTWO (FLDSIZ(1,I1))
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  FLDSIZ(2,I1) = X + 0.50D0
                  IF (X.LT.0.0D0) FLDSIZ(2,I1) = -1
                  FLDSIZ(2,I1) = MAX (FLDSIZ(2,I1), IMSIZE(2))
                  FLDSIZ(2,I1) = NPTWO (FLDSIZ(2,I1))
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  ARASH = X
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  ADECSH = X
                  CALL XYSHFT (RA, DEC, ARASH, ADECSH, MROTAT, RAS(I1),
     *               DECS(I1))
                  I2 = I2 + 1
                  END IF
C                                       parse for ra/dec field
C                                       # fldsiz ra (HH MM SS) Dec (+-
C                                       DD MM SS)
            ELSE IF ((LINE(:1).EQ.'C') .OR. (LINE(:1).EQ.'c')) THEN
               KBP = 2
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 50
               IF (X.GE.0.0D0) THEN
                  I1 = X + 0.50D0
               ELSE
                  I1 = X - 0.50D0
                  END IF
               IF ((I1.GE.1) .AND. (I1.LE.MAXFLD)) THEN
                  NF = MAX (NF, I1)
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  FLDSIZ(1,I1) = X + 0.50D0
                  FLDSIZ(1,I1) = MAX (FLDSIZ(1,I1), IMSIZE(1))
                  FLDSIZ(1,I1) = NPTWO (FLDSIZ(1,I1))
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  FLDSIZ(2,I1) = X + 0.50D0
                  FLDSIZ(2,I1) = MAX (FLDSIZ(2,I1), IMSIZE(2))
                  FLDSIZ(2,I1) = NPTWO (FLDSIZ(2,I1))
C                                       RA
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  XRA = X
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  XRA = XRA + X/60.0D0
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  XRA = XRA + X/3600.0D0
                  XRA = XRA * 15.0D0
C                                       Sign
                  J = KBP
 40               IF (J.GT.132) GO TO 990
                  IF (LINE(J:J).EQ.' ') THEN
                     J = J + 1
                     GO TO 40
                     END IF
                  SIGN = LINE(J:J)
C                                       DEC
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  XDEC = ABS(X)
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  XDEC = XDEC + X/60.0D0
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  XDEC = XDEC + X/3600.0D0
                  IF (SIGN.EQ.'-') XDEC = -XDEC
                  RAS(I1) = XRA
                  DECS(I1) = XDEC
                  I2 = I2 + 1
                  END IF
            ELSE IF ((LINE(:1).GE.'0') .AND. (LINE(:1).LE.'9')) THEN
               KBP = 1
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 50
               IF (X.GE.0.0D0) THEN
                  I1 = X + 0.50D0
               ELSE
                  I1 = X - 0.50D0
                  END IF
               IF ((I1.GE.1) .AND. (I1.LE.MAXFLD)) NF = MAX (NF, I1)
               END IF
 50         CONTINUE
C
 60      CALL ZTXCLS (LUN, FIND, I)
         END IF
      IERR = 0
      GO TO 999
C
 990  WRITE (MSGTXT,1990) I
      CALL MSGWRT (6)
      IERR = 1

 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FIELDF: ERROR',I4,1X,A,'ING BOXFILE')
 1990 FORMAT ('FIELDF: PARSING ERROR ON LINE',I4)
      END
      INTEGER FUNCTION NPTWO (N)
C-----------------------------------------------------------------------
C   Function to determine the next highest power of two for an integer.
C   Input:
C      N       I  Integer
C   Output:
C      NPTWO   I  Next highest power of two
C-----------------------------------------------------------------------
      INTEGER   N
C
      INTEGER   IPOW
      REAL      POW
C-----------------------------------------------------------------------
      POW = LOG (1.0*N) / LOG (2.0) + 0.99999
      IPOW = POW
      NPTWO = 2 ** IPOW
C
 999  RETURN
      END
      SUBROUTINE DTRANS (ABSVAL, DEGHR, MINUTE, SECOND)
C-----------------------------------------------------------------------
C   translates coordinate into sexagesimal
C   Inputs:
C      ABSVAL   D   Coordinate (with sign)
C   Outputs:
C      DEGHR    I   Degrees (or hours if ABSVAL so scaled) with sign
C      MINUTE   I   Minutes (no sign)
C      SECOND   I   Seconds (no sign)
C-----------------------------------------------------------------------
      DOUBLE PRECISION ABSVAL
      INTEGER   DEGHR, MINUTE
C
      DOUBLE PRECISION SECOND, VALCOP
C-----------------------------------------------------------------------
      VALCOP = ABSVAL
      DEGHR = INT (VALCOP)
      VALCOP = 60.0D0 * DABS (VALCOP - DEGHR)
      MINUTE = INT (VALCOP)
      SECOND = 60.0D0 * (VALCOP - MINUTE)
C
 999  RETURN
      END
      SUBROUTINE WINDF (WIN, NBOXES, MFIELD, NGAUSS, IMSIZE, BOXFIL,
     *   PRT, IERR)
C-----------------------------------------------------------------------
C   Fills the WIN array with clean box definitions taken from BOXFIL
C   Inputs:
C      BOXFIL   C*48        User provided file name containing box defs
C      MFIELD   I           Number of fields defined
C      NGAUSS   I           Number Gaussians
C      PRT      L           Do printing?
C   In/Out:
C      WIN      I(4,*,*)    clean boxes - defaulted on in (4,FIELD,BOX)
C      NBOXES   I*(*)       Array containing number of boxes/field
C   Outputs:
C      IERR     I           Error return code:
C                              0 => no error
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCLN.INC'
      CHARACTER BOXFIL*48
      INTEGER   MFIELD, NGAUSS, WIN(4,MFIELD,*), NBOXES(*), IMSIZE(2,*),
     *   IERR
      LOGICAL   PRT
C
      INTEGER   LUN, I, J, ISUBF(MXNBOX), IFIELD, FIND, IPARM(5), KBP,
     *   I1, I2, IDD, LIMIT, JFIELD, NFIELD
      CHARACTER LINE*132
      DOUBLE PRECISION X
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      LIMIT = MIN (MXNBOX, MXNBFL / MAX(1,MFIELD))
C                                        Open clean box file
      LUN = 11
      CALL ZTXOPN ('READ', LUN, FIND, BOXFIL, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN'
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                        Enter box parameters from file
      CALL FILL (MXNBOX, 0, ISUBF)
      IDD = 0
      DO 50 I = 1,100000
         CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
         IF (IERR.EQ.2) GO TO 60
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPEN'
            CALL MSGWRT (6)
            GO TO 999
            END IF
C                                       check for comments
         CALL CHTRIM (LINE, 132, LINE, J)
         IF (LINE(:1).LT.'0') GO TO 50
         IF (LINE(:1).GT.'9') GO TO 50
C                                       parse for 5 integers
C                                       field, blc, trc
         KBP = 1
         CALL FILL (5, 0, IPARM)
         DO 30 J = 1,5
            CALL GETNUM (LINE, 132, KBP, X)
            IF (X.EQ.DBLANK) THEN
               IF (J.EQ.1) GO TO 50
               WRITE (MSGTXT,1020) I, J
               CALL MSGWRT (6)
               IERR = 1
               GO TO 999
            ELSE
               IF (X.GE.0.0D0) THEN
                  IPARM(J) = X + 0.50D0
               ELSE
                  IPARM(J) = X - 0.50D0
                  END IF
               END IF
 30         CONTINUE
         IFIELD = IPARM(1)
         NFIELD = MFIELD / NGAUSS
         JFIELD = MOD (IFIELD-1, NFIELD) + 1
         IF ((IFIELD.GE.1) .AND. (IFIELD.LE.MFIELD)) THEN
            IDD = IDD + 1
            ISUBF(IFIELD) = ISUBF(IFIELD) + 1
            IF (ISUBF(IFIELD).LE.LIMIT) THEN
               J = ISUBF(IFIELD)
C                                       circular
               IF (IPARM(2).LT.0) THEN
                  WIN(1,IFIELD,J) = -1
                  WIN(3,IFIELD,J) = MAX (1+IPARM(3), MIN (IPARM(4),
     *               IMSIZE(1,JFIELD)-IPARM(3)))
                  WIN(4,IFIELD,J) = MAX (1+IPARM(3), MIN (IPARM(5),
     *               IMSIZE(2,JFIELD)-IPARM(3)))
                  WIN(2,IFIELD,J) = IPARM(3)
C                                       rectangular
               ELSE
                  WIN(1,IFIELD,J) = MAX (1, MIN (IPARM(2),
     *               IMSIZE(1,JFIELD)))
                  WIN(3,IFIELD,J) = MAX (1, MIN (IPARM(4),
     *               IMSIZE(1,JFIELD)))
                  IF (WIN(3,IFIELD,J).LT.WIN(1,IFIELD,J)) THEN
                     I1 = WIN(3,IFIELD,J)
                     WIN(3,IFIELD,J) = WIN(1,IFIELD,J)
                     WIN(1,IFIELD,J) = I1
                     END IF
                  WIN(2,IFIELD,J) = MAX (1, MIN (IPARM(3),
     *               IMSIZE(2,JFIELD)))
                  WIN(4,IFIELD,J) = MAX (1, MIN (IPARM(5),
     *               IMSIZE(2,JFIELD)))
                  IF (WIN(4,IFIELD,J).LT.WIN(2,IFIELD,J)) THEN
                     I1 = WIN(4,IFIELD,J)
                     WIN(4,IFIELD,J) = WIN(2,IFIELD,J)
                     WIN(2,IFIELD,J) = I1
                     END IF
                  END IF
               END IF
            END IF
 50      CONTINUE
 60   DO 70 I = 1,MFIELD
         IF (ISUBF(I).GT.0) NBOXES(I) = MIN (LIMIT, ISUBF(I))
         IF (ISUBF(I).GT.LIMIT) THEN
            WRITE (MSGTXT,1060) I, LIMIT, ISUBF(I)
            CALL MSGWRT (6)
            END IF
 70      CONTINUE
      CALL ZTXCLS (LUN, FIND, I)
      IERR = 0
C
      IF ((IDD.GT.0) .AND. (PRT)) THEN
         MSGTXT = 'WINDF: Number of clean boxes/field read as follows:'
         CALL MSGWRT(7)
         DO 80 J = 1,MFIELD,4
            I1 = J
            I2 = MIN (MFIELD, I1+3)
            WRITE (MSGTXT,1070) ('Field', I, NBOXES(I), I = I1,I2)
            CALL MSGWRT (3)
 80         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('WINDF: ERROR',I4,1X,A,'ING THE CLEAN BOXES TEXT FILE')
 1020 FORMAT ('WINDF: PARSING ERROR ON LINE',I4,' FIELD',I2)
 1060 FORMAT ('WARNING: FIELD',I4,' USED FIRST',I5,' OF',I6,
     *   ' BOXES IN FILE')
 1070 FORMAT (4(A5,I3.2,':',I4,2X))
      END

      SUBROUTINE AUA (BRANCH)
C-----------------------------------------------------------------------
C! verb to submit batch jobs to AIPSC and the QMNGR queues
C# POPS-appl Batch
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2007, 2010, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AUA handles activating batch checker task (AIPSCn)
C   Input: BRANCH = 1 activate AIPSCn
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      CHARACTER PRGNAM*6, PHNAME*48, LVERSN*48, AVERSN*48, CVER(4)*4,
     *   CTASK*8, ANAME*8, CDUM*1, RHOST*24
      INTEGER   POTERR, FINDTD, FINDTT, LUNTTY, IPRBUF(256), IERR,
     *   IRETCD, J, LUNTD, NBLOCK, I, ITEMP, PID(4), IPTR, JOFF, IDUM
      REAL      PARBUF(128), TDL, RDUM
      LOGICAL   T, F, ACTIVE, LDOWT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (IPRBUF(1), PARBUF(1))
      DATA PRGNAM /'AUA '/
      DATA LUNTD, LUNTTY /13,5/
      DATA CTASK /'AIPSC '/
      DATA T, F /.TRUE.,.FALSE./
      DATA CVER /'OLD:','NEW:','TST:','CVX:'/
C-----------------------------------------------------------------------
      IF (BRANCH.NE.1) GO TO 999
      NBLOCK = 4
      GO TO (100), BRANCH
C-----------------------------------------------------------------------
C                                       SUBMIT
C                                       start AIPSC
C-----------------------------------------------------------------------
 100  CALL ADVERB ('BATQUE', 'I', 1, 0, J, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IF ((J.LT.1) .OR. (J.GT.NBATQS)) THEN
         POTERR = 40
         WRITE (MSGTXT,1100) J, NBATQS
         CALL MSGWRT (7)
         GO TO 980
         END IF
C                                       open output file
      CALL ZPHFIL ('TD', 1, 0, 4, PHNAME, IERR)
      CALL ZOPEN (LUNTD, FINDTD, 1, PHNAME, F, T, T, IERR)
      POTERR = 101
      IF (IERR.NE.0) GO TO 980
      CALL ZFIO ('READ', LUNTD, FINDTD, 1, IPRBUF, IERR)
      POTERR = 50
      IF (IERR.NE.0) GO TO 960
      NBLOCK = MAX (4, IPRBUF(256))
C                                      initial values
      JOFF = (NPOPS-1)*NBLOCK + 2
      CALL ADVERB ('VERSION', 'C', 1, 48, IDUM, RDUM, LVERSN)
      IF (ERRNUM.NE.0) GO TO 960
      CALL ZPHFIL ('HE', 1, 0, 0, PHNAME, IERR)
      CALL VERMAT (1, PHNAME, CTASK, LVERSN, I, AVERSN, IERR)
      IF (IERR.NE.0) GO TO 960
      CALL FILL (256, 0, IPRBUF)
      IPTR = 11
      IPRBUF(1) = NLUSER
      IPRBUF(2) = 0
      IPRBUF(3) = 0
      IPRBUF(4) = MSGKIL
      IPRBUF(5) = ISBTCH
      IPRBUF(6) = DBGAIP
      IPRBUF(7) = 0
      IPRBUF(8) = 0
      CALL ADVERB ('DOWAIT', 'R', 1, 0, IDUM, PARBUF(IPTR-2), CDUM)
      IF (ERRNUM.NE.0) GO TO 960
      CALL CHR2H (4, VERNAM, 1, PARBUF(IPTR-1))
      IF ((I.GE.1) .AND. (I.LE.4)) CALL CHR2H (4, CVER(I), 1,
     *    PARBUF(IPTR-1))
      IF ((I.GE.5) .AND. (I.LE.8)) CALL CHR2H (4, CVER(I-3), 1,
     *    PARBUF(IPTR-1))
      CALL ADVERB ('BATQUE', 'R', 1, 0, IDUM, PARBUF(IPTR), CDUM)
      IF (ERRNUM.NE.0) GO TO 960
      CALL ADVERB ('DETIME', 'R', 1, 0, IDUM, PARBUF(IPTR+1), CDUM)
      IF (ERRNUM.NE.0) GO TO 960
      CALL CHR2H (48, AVERSN, 1, PARBUF(IPTR+2))
      CALL ADVERB ('REMHOST', 'C', 1, 24, IDUM, RDUM, RHOST)
      IF (ERRNUM.NE.0) GO TO 960
      CALL CHR2H (24, RHOST, 1, PARBUF(IPTR+14))
      CALL ADVERB ('REMQUE', 'R', 1, 0, IDUM, PARBUF(IPTR+20), CDUM)
      IF (ERRNUM.NE.0) GO TO 960
      CALL ZFIO ('WRIT', LUNTD, FINDTD, JOFF, IPRBUF, IERR)
      POTERR = 50
      IF (IERR.NE.0) GO TO 960
C                                        pointer block (#1)
      CALL ZFIO ('READ', LUNTD, FINDTD, 1, IPRBUF, IERR)
      POTERR = 50
      IF (IERR.NE.0) GO TO 960
      ITEMP = 5*(NPOPS-1)
      CALL CHR2H (8, CTASK, 1, PARBUF(ITEMP+1))
      IPRBUF(3+ITEMP) = -999
      IPRBUF(4+ITEMP) = 0
      IPRBUF(5+ITEMP) = 0
      IPRBUF(256) = NBLOCK
      CALL ZFIO ('WRIT', LUNTD, FINDTD, 1, IPRBUF, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       close files
      CALL ZCLOSE (LUNTD, FINDTD, IERR)
C                                       task already running
      CALL BLDTNM (CTASK, NPOPS, ANAME, IERR)
      POTERR = 43
      IF (IERR.NE.0) GO TO 980
      CALL FILL (4, 0, PID)
      PID(1) = NLUSER
      CALL ZTACTQ (ANAME, PID, ACTIVE, IERR)
      IF (IERR.NE.0) GO TO 980
      POTERR = 42
      IF (ACTIVE) GO TO 980
C                                        close message file
      CALL MSGWRT (-1)
C                                        close input terminal
      IF ((NPOPS.GT.NINTRN+1) .OR. (ISBTCH.EQ.32000)) GO TO 155
         CALL LSERCH ('SRCH', LUNTTY, FINDTT, F, IERR)
         POTERR = 58
         IF (IERR.NE.0) GO TO 980
         CALL ZCLOSE (LUNTTY, FINDTT, IERR)
         IF (IERR.NE.0) GO TO 980
C                                        activate the task
 155  CALL ZACTV8 (CTASK, NPOPS, AVERSN, PID, IERR)
      POTERR = 101
      IF (IERR.NE.0) GO TO 950
C                                       Wait for resumption through
C                                       TD file or abort of task
      TDL = 3.
      CALL ADVERB ('DOWAIT', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 950
      IF (RDUM.GT.0.0) TDL = 8.
      IF (NPOPS.GT.NINTRN+1) TDL = 20.
      IF (ISBTCH.GT.32000) TDL = 20.
      LDOWT = TDL.GT.4.0
      IF (AIPSMK.GT.0.3) TDL = TDL / AIPSMK
      CALL TASKWT (ANAME, NPOPS, PID, LDOWT, TDL, IPRBUF, IRETCD, IERR)
C                                        reopen terminal
      IF ((NPOPS.LE.NINTRN+1) .AND. (ISBTCH.NE.32000)) CALL ZOPEN
     *   (LUNTTY, FINDTT, 1, PHNAME, F, T, T, IERR)
C                                       resumption message
      WRITE (MSGTXT,1180)
      CALL MSGWRT (2)
      IF (IRETCD.EQ.0) GO TO 999
         POTERR = 101
C                                       abort batch
         IF (NPOPS.GT.NINTRN+1) POTERR = 100
         IF (ISBTCH.EQ.32000) POTERR = 100
         WRITE (MSGTXT,1185) IRETCD
         IF (IRETCD.NE.-999) CALL MSGWRT (9)
         GO TO 980
C                                       errors: close files
 950  IF ((NPOPS.LE.NINTRN+1) .AND. (ISBTCH.NE.32000)) CALL ZOPEN
     *   (LUNTTY, FINDTT, 1, PHNAME, F, T, T, IERR)
      GO TO 980
 960  CALL ZCLOSE (LUNTD, FINDTD, IERR)
C                                       POPS error management
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.EQ.0) GO TO 999
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('BATQUE',I6,' OUTSIDE RANGE 1 -',I2)
 1180 FORMAT ('Resumes')
 1185 FORMAT ('RETURN CODE',I7,' RECEIVED: STOPPING')
      END

      SUBROUTINE RNXCLS (IRET)
C-----------------------------------------------------------------------
C! Indexes a uv data file while writing it: empty memory and close file
C# UV EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2007, 2010-2011, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Updates NX table on disk and closes file
C   In/output:
C     IRET     I      Error code: input IRET unchanged if failure flag
C                     is set  (RNXRNO < 0)
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   CURSUB
      REAL      CTIME, DTIME
      INCLUDE 'INCS:DRNX.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       leave if not doing
      IF (RNXRNO.LE.0) GO TO 999
      IRET = 0
C                                       write all out
      DO 10 CURSUB = 1,MAXSUB
         IF (RNXANT(CURSUB).GT.0) THEN
            CTIME = (ETIME(CURSUB) + STIME(CURSUB)) / 2.0
            DTIME = ETIME(CURSUB) - STIME(CURSUB)
            CALL TABNDX ('WRIT', RNXBUF, RNXRNO, RNXKOL, RNXNUM, CTIME,
     *         DTIME, SRC(CURSUB), CURSUB, VSTART(CURSUB), VEND(CURSUB),
     *         FQID(CURSUB), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITE NX TABLE'
               GO TO 990
               END IF
            END IF
 10      CONTINUE
C                                       close
      CURSUB = 1
      CALL TABNDX ('CLOS', RNXBUF, RNXRNO, RNXKOL, RNXNUM, CTIME, DTIME,
     *   SRC(CURSUB), CURSUB, VSTART(CURSUB), VEND(CURSUB),
     *   FQID(CURSUB), IRET)
      RNXRNO = -1
      GO TO 999
C
 990  CALL MSGWRT (8)
      RNXRNO = -1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RNXUPD: ERROR',I3,' DOING ',A)
      END

      SUBROUTINE GRLUTS (PMAX, IG, IC, IL, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! interactive piecewise linear LUT using graphic plane and cursor
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GRLUTS implements an interactive piecewise linear LUT dialed in
C   by the user using the cursor and a graphics plane.
C   Inputs:
C      PMAX    I          Max number segments: 0 => any number
C      IG      I          Graphics plane to use (1 - NGRAPH)
C      IC      I          TV channels to set LUT (bit mask)
C      IL      I          Colors to set LUT (bit mask)
C   Output:
C      SCRTCH  I(2048)    Scratch buffer (IVAS needs 2048 min)
C      IERR    I          Error code
C-----------------------------------------------------------------------
      INTEGER   PMAX, IG, IC, IL, SCRTCH(*), IERR
C
      INTEGER   IGC, I, J, IX0, IX1, IY0, IY1, IX(129), IY(129), IPO,
     *   QUAD, IBUT, IP, MP, ITW(3), LZOOM(3), JERR, MX, IXL, IYL, IXH,
     *   IYH, NP, ISZX, ISZY
      LOGICAL   T, F, DOIT, ONGR, DOON, DOLIM, FIRST
      REAL      PPOS(2), RPOS(2), DLIM, XSCALE, YSCALE
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Check parms
      IERR = 2
      IF ((IG.LT.1) .OR. (IG.GT.NGRAPH)) GO TO 999
      IF ((IC.LT.1) .OR. (IC.GE.2**NGRAY)) GO TO 999
      IF ((IL.LE.0) .OR. (IL.GT.7)) GO TO 999
      DOLIM = (PMAX.GE.3) .AND. (PMAX.LE.127)
      FIRST = DOLIM
C                                       Off any zoom
      CALL YHOLD ('ONNN', IERR)
      CALL COPY (3, TVZOOM, LZOOM)
      CALL YZOOMC (0, 1, 1, T, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Clear graphics
      IGC = IG + NGRAY
      CALL YZERO (IGC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       On graphics
      I = 2 ** (IGC-1)
      ONGR = MOD (TVLIMG(1)/I, 2) .EQ. 1
      IPO = 1
      CALL YSLECT ('ONNN', IGC, 0, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Coordinates
      ISZX = WINDTV(3) - WINDTV(1) + 1
      ISZY = WINDTV(4) - WINDTV(2) + 1
      XSCALE = REAL (ISZX) / (MAXINT+1.0) / 2.0
      YSCALE = REAL (ISZY) / (LUTOUT+1.0) / 2.0
      IX0 = (ISZX - (MAXINT+1) * XSCALE) / 2 + WINDTV(1) - 1
      IY0 = (ISZY - (LUTOUT+1) * YSCALE) / 2 + WINDTV(2) - 1
      IX1 = IX0 + MAXINT * XSCALE
      IY1 = IY0 + LUTOUT * YSCALE
C                                       Border
      IX(1) = IX0 - 1
      IX(2) = IX1 + 1
      IX(3) = IX(2)
      IX(4) = IX(1)
      IX(5) = IX(1)
      IY(1) = IY0 - 1
      IY(2) = IY(1)
      IY(3) = IY1 + 1
      IY(4) = IY(3)
      IY(5) = IY(1)
      CALL IMVECT ('ONNN', IGC, 5, IX, IY, SCRTCH, IERR)
      IPO = 2
      IF (IERR.NE.0) GO TO 900
C                                       Ticks
      IY(1) = IY0 - 6
      IY(2) = IY(1) + 10
      IY(3) = IY1 + 6
      IY(4) = IY(3) - 10
      IX(5) = IX0 - 6
      IX(6) = IX(5) + 10
      IX(7) = IX1 + 6
      IX(8) = IX(7) - 10
      DO 20 I = 1,3
         IX(1) = (I / 4.0) * (IX1 - IX0) + IX0
         IX(2) = IX(1)
         IX(3) = IX(1)
         IX(4) = IX(1)
         IY(5) = (I / 4.0) * (IY1 - IY0) + IY0
         IY(6) = IY(5)
         IY(7) = IY(5)
         IY(8) = IY(5)
         DO 15 J = 1,8,2
            CALL IMVECT ('ONNN', IGC, 2, IX(J), IY(J), SCRTCH, IERR)
            IPO = 3
            IF (IERR.NE.0) GO TO 900
 15         CONTINUE
 20      CONTINUE
C                                       Labels
      IX(1) = (IX1 + IX0) / 2
      IY(1) = IY0 - 6 - CSIZTV(2) * 1.2
      CALL IMCHAR (IGC, IX, IY, 0, 1, 'INPUT', SCRTCH, IERR)
      IPO = 4
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 900
      IX(1) = IX0 - 6 - CSIZTV(1) * 1.2
      IY(1) = (IY1 + IY0) / 2
      CALL IMCHAR (IGC, IX, IY, 3, 1, 'OUTPUT', SCRTCH, IERR)
      IPO = 5
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 900
C                                       Init for interaction
      IX(1) = IX0
      IY(1) = IY0
      IX(2) = IX(1)
      IY(2) = IY(1)
      IX(3) = IX1
      IY(3) = IY1
      QUAD = -1
      IP = 2
      MP = 3
      CALL ZTIME (ITW)
C                                       Basic instructions
 30   IF (.NOT.DOLIM) GO TO 40
         IF (FIRST) WRITE (MSGTXT,1030)
         IF (.NOT.FIRST) WRITE (MSGTXT,1031)
         CALL MSGWRT (1)
         IF (FIRST) GO TO 45
            WRITE (MSGTXT,1032)
            CALL MSGWRT (1)
            GO TO 45
 40   CONTINUE
         WRITE (MSGTXT,1040)
         CALL MSGWRT (1)
         WRITE (MSGTXT,1041)
         CALL MSGWRT (1)
         WRITE (MSGTXT,1032)
         CALL MSGWRT (1)
C                                       reposition & on cursor
 45   RPOS(1) = IX(IP)
      RPOS(2) = IY(IP)
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      CALL YHOLD ('OFFF', IERR)
      CALL YCURSE ('ONNN', FIRST, F, RPOS, QUAD, IBUT, IERR)
      IPO = 6000 + IP
      IF (IERR.NE.0) GO TO 900
      IF (IBUT.NE.0) GO TO 55
C                                       read loop
 50   CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IERR)
         IPO = 7000 + IP
         IF (IERR.NE.0) GO TO 900
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF (.NOT.DOIT) GO TO 50
C                                       Erase 2 segments
 55      CALL YHOLD ('ONNN', IERR)
         CALL IMVECT ('OFFF', IGC, 3, IX(IP-1), IY(IP-1), SCRTCH, IERR)
         IPO = 8000 + IP
         IF (IERR.NE.0) GO TO 900
C                                       new point
         IX(IP) = RPOS(1) + 0.01
         IY(IP) = RPOS(2) + 0.01
         DOON = (IX(IP).LT.IX(IP-1)) .OR. (IX(IP).GT.IX(IP+1)) .OR.
     *      (IY(IP).LT.IY0) .OR. (IY(IP).GT.IY1)
         IF (DOON) THEN
            IX(IP) = MAX (IX(IP-1), MIN (IX(IP), IX(IP+1)))
            IY(IP) = MAX (IY0, MIN (IY(IP), IY1))
            END IF
C                                       draw new segments
         CALL IMVECT ('ONNN', IGC, 3, IX(IP-1), IY(IP-1), SCRTCH, IERR)
         IPO = 9000 + IP
         IF (IERR.NE.0) GO TO 900
C                                       Compute new LUT
         NP = 1
         MX = MP - 1
         IXH = (IX(1) - IX0) / XSCALE
         IYH = (IY(1) - IY0) / YSCALE
         DO 70 I = 1,MX
            IXL = IXH
            IYL = IYH
            IXH = (IX(I+1) - IX0) / XSCALE
            IYH = (IY(I+1) - IY0) / YSCALE
            CALL STRLIN (IXL, IYL, IXH, IYH, SCRTCH)
 70         CONTINUE
         SCRTCH(1) = 0
         DO 75 I = 1,MAXINT
            SCRTCH(I+1) = MAX (0, MIN (LUTOUT, SCRTCH(I+1)))
 75         CONTINUE
         CALL YLUT ('WRIT', IC, IL, T, SCRTCH, IERR)
         IPO = 10000 + IP
         IF (IERR.NE.0) GO TO 900
         CALL YHOLD ('OFFF', IERR)
C                                       Respond to buttons
         IF ((IBUT.GT.7) .AND. (.NOT.FIRST)) GO TO 900
         IF ((IBUT.EQ.0) .AND. (DOON)) GO TO 45
         IF (IBUT.EQ.0) GO TO 50
C                                       Create new vertex
         IF ((DOLIM) .AND. (MP.EQ.PMAX)) FIRST = F
         IF ((DOLIM) .AND. (.NOT.FIRST)) GO TO 100
         IF ((IBUT.GT.3) .AND. (MP.GT.3) .AND. (.NOT.DOLIM)) GO TO 100
            IX(MP+1) = IX(MP)
            IY(MP+1) = IY(MP)
            IX(MP) = IX(MP-1)
            IY(MP) = IY(MP-1)
            IP = MP
            MP = MP + 1
            IF (MP.EQ.129) DOLIM = T
            GO TO 45
C                                       User points at old vertex
 100     WRITE (MSGTXT,1100)
         CALL MSGWRT (1)
         CALL YCURSE ('READ', T, F, RPOS, QUAD, IBUT, IERR)
         IPO = 11000 + IP
         IF (IERR.NE.0) GO TO 900
         IF (IBUT.GT.7) GO TO 900
C                                       Find nearest
         DLIM = 0.5
         NP = MP - 1
 105     DO 110 I = 2,NP
            IF ((ABS(RPOS(1)-IX(I)).LE.DLIM) .AND. (ABS(RPOS(2)-
     *         IY(I)).LE.DLIM)) GO TO 120
 110        CONTINUE
         DLIM = DLIM + 1.5
         IF (DLIM.LE.6.0) GO TO 105
         GO TO 100
C                                       Set point and do it
 120     IP = I
         GO TO 30
C                                       DONE !!!
 900  CALL YCURSE ('OFFF', F, F, RPOS, QUAD, IBUT, JERR)
      CALL YZOOMC (LZOOM(1), LZOOM(2), LZOOM(3), T, JERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1900) IERR, IPO
         CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('Hit button A, B, or C to mark vertex & go on to next',
     *   ' new segment')
 1031 FORMAT ('Hit button A, B, or C to mark vertex & go on to next',
     *   ' old vertex')
 1032 FORMAT ('Hit button D to exit')
 1040 FORMAT ('Hit button A or B to create new segment')
 1041 FORMAT ('Hit button C to reset old vertex')
 1100 FORMAT ('Move cursor to desired vertex and then hit button ',
     *   'A, B, or, C')
 1900 FORMAT ('GRLUTS: ERROR CODE',I7,' AT',I7)
      END

LOCAL INCLUDE 'SNP2D.INC'
      HOLLERITH XNAMIN(3), XCLAIN(2), XNMOUT(3), XCLOUT(2)
      REAL      XSEQIN, XDISKI, XIVER, XSEQO, XDISKO, XBIF, XBCHAN,
     *   XDOAPP
      COMMON /INPARM/ XNAMIN, XCLAIN, XSEQIN, XDISKI, XIVER, XNMOUT,
     *   XCLOUT, XSEQO, XDISKO, XBIF, XBCHAN, XDOAPP
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      INTEGER   CATOLD(256), SEQIN, DISKIN, SEQOUT, DISKOU, OLDCNO,
     *   NEWCNO, BCHAN, BIF, IVER, OVER
      REAL      OLDR(256)
      COMMON /OTHERP/ CATOLD, SEQIN, DISKIN, SEQOUT, DISKOU, OLDCNO,
     *   NEWCNO, BCHAN, BIF, IVER, OVER
      COMMON /OTHERC/ NAMEIN, CLAIN, NAMOUT, CLAOUT
      EQUIVALENCE (CATOLD, OLDR)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
LOCAL END
      PROGRAM SNP2D
C-----------------------------------------------------------------------
C! Task to copy SN table converting phase to delay
C# EXT-util Utility Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2013-2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  SNP2D copies AIPS an SN extension tables file averaging IFs.
C  Adverbs:
C    INNAME      Input image name (name)
C    INCLASS     Input image name (class)
C    INSEQ       Input image name (seq. #)
C    INDISK      Input image disk unit #
C    INVERS      Input table file version no.
C    OUTNAME     Output image name (name)
C    OUTCLASS    Output image name (class)
C    OUTSEQ      Output image name (seq. #)
C    OUTDISK     Output image disk unit #.
C    BIF         IF of cal channel
C    BCHAN       channel of cal in BIF
C    DOAPPLY     > 0 =< cary amplitude, else make ampl 1.0
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'SNP2D.INC'
      CHARACTER FTYPE*2, STAT*4, XEXT*2, PRGM*6, TABTYP*2, ATIME*8,
     *   ADATE*12, HILINE*72
      INTEGER  IRET, BUFF1(512), BUFF2(512), IERR, LUN1, LUN2, NPARM,
     *   IROUND,  NTAB, NOLDT, TIME(3), DATE(3), NIF, NIFO
      LOGICAL   EXIST, TABLE, FITASC
      LOGICAL   T, SAME
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA PRGM /'SNP2D '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 18
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMIN, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMIN, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNMOUT, NAMOUT)
      CALL H2CHR (6, 1, XCLOUT, CLAOUT)
      XEXT = 'SN'
C                                       Crunch input parameters.
      SEQIN  = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKOU = IROUND (XDISKO)
      IVER   = IROUND (XIVER)
      OVER = 0
      TABTYP = XEXT
C                                       Find input
      OLDCNO = 1
      FTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, FTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Default output = input.
      IF (NAMOUT.EQ.' ') NAMOUT = NAMEIN
      IF (CLAOUT.EQ.' ') CLAOUT = CLAIN
      IF (SEQOUT.LE.0) SEQOUT = SEQIN
      IF (DISKOU.EQ.0) DISKOU = DISKIN
C                                       Find output
      NEWCNO = 1
      FTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKOU, NEWCNO, NAMOUT, CLAOUT, SEQOUT,
     *    FTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, NAMOUT, CLAOUT, SEQOUT, DISKOU,
     *      NLUSER
         GO TO 990
         END IF
      SAME = (DISKIN.EQ.DISKOU) .AND. (OLDCNO.EQ.NEWCNO)
      STAT = 'READ'
      IF (SAME) STAT = 'REST'
C                                       Read old CATBLK and mark 'READ'
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, STAT, BUFF1, IERR)
      IF ((IERR.GT.0) .AND. (IERR.LT.5)) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
      CALL COPY (256, CATBLK, CATOLD)
      CALL UVPGET (IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UVPGET FAILS ON INPUT UV DATA SET'
         GO TO 990
         END IF
      IF (JLOCIF.GE.0) THEN
         NIF = CATBLK (KINAX+JLOCIF)
      ELSE
         NIF = 1
         END IF
      BIF = XBIF + 0.1
      BCHAN = XBCHAN + 0.1
      BIF = MAX (1, MIN (NIF, BIF))
      BCHAN = MAX (1, MIN (CATBLK(KINAX+JLOCF), BCHAN))
      IF (.NOT.SAME) THEN
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKIN
         FCNO(NCFILE) = OLDCNO
         FRW(NCFILE) = 0
         END IF
C                                       Read new CATBLK and mark 'WRIT'
      CALL CATIO ('READ', DISKOU, NEWCNO, CATBLK, 'WRIT', BUFF1, IERR)
      IF ((IERR.GT.0) .AND. (IERR.LT.5)) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKOU
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 1
C                                       Check number of tables
      CALL FNDEXT (TABTYP, CATOLD, NOLDT)
C                                       use highest version when IVER = 0
      IF (IVER.LE.0) IVER = NOLDT
      XIVER = IVER
      NTAB = 1
C                                       Is it a table
      CALL ISTAB (TABTYP, DISKIN, OLDCNO, IVER, LUN1, BUFF1, TABLE,
     *   EXIST, FITASC, IERR)
      IF (IERR.NE.0) THEN
         IRET = 5
         WRITE (MSGTXT,1030) IERR
         GO TO 990
         END IF
      IF (.NOT.EXIST) THEN
         IRET = 5
         WRITE (MSGTXT,1031) TABTYP, IVER
         GO TO 990
         END IF
      CALL UVPGET (IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UVPGET FAILS ON OUTPUT UV DATA SET'
         GO TO 990
         END IF
      IF (JLOCIF.GE.0) THEN
         NIFO = CATBLK (KINAX+JLOCIF)
      ELSE
         NIFO = 1
         END IF
C                                       Copy table
      CALL SNP2DY (LUN1, LUN2, NIFO, BUFF1, BUFF2, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Add history to output
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN1, DISKOU, NEWCNO, BUFF1, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1090) IERR
         CALL MSGWRT (6)
         GO TO 150
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
      WRITE (HILINE,1100) TSKNAM, RLSNAM, ADATE, ATIME
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
C                                       Input file
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN1, BUFF1,
     *   IERR)
      IF (IERR.NE.0) GO TO 150
C                                       Type and version
      WRITE (HILINE,2000) TSKNAM, TABTYP, IVER, OVER
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
      WRITE (HILINE,2020) TSKNAM, NIFO
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
      IF (XDOAPP.GT.0.0) THEN
         HILINE = TSKNAM // '/ amplitudes preserved'
      ELSE
         HILINE = TSKNAM // '/ amplitudes set to 1.0'
         END IF
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
C                                       Close HI file
 150  CALL HICLOS (LUN1, T, BUFF1, IERR)
      GO TO 995
C                                       Error
 990  CALL MSGWRT (8)
C                                       Close down files, etc
 995  CALL DIE (IRET, BUFF1)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' GETING INPUT PARAMETERS')
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1020 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1030 FORMAT ('ISTAB ERROR ',I3,' CHECKING FILE')
 1031 FORMAT ('Extension file ',A2,' version',I5,' missing')
 1086 FORMAT ('TBLCOP ERROR ',I4,' COPYING EXT FILE ',A2,I5)
 1090 FORMAT ('ERROR',I3,' OPENING HISTORY FILE')
 1100 FORMAT (A6,'Release =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 2000 FORMAT (A6,'INEXT=''',A2,''' INVERS=',I4,' OUTVERS=', I4)
 2020 FORMAT (A6,'NIFOUT =',I3,' / Number output IFs')
      END
      SUBROUTINE SNP2DY (LUNOLD, LUNNEW, NIFO, BUFOLD, BUFNEW, IRET)
C-----------------------------------------------------------------------
C   SNP2DY copies an SN table averaging specified IFs.
C   Inputs:
C      LUNOLD   I       LUN for old file
C      LUNNEW   I       LUN for new file
C      NIFO     I       Number of IFs out
C   Output:
C      BUFOLD   I(512)  Work buffer
C      BUFNEW   I(512)  Work buffer
C      IRET     I       Return error code  0 => ok
C                          1 => files the same, no copy.
C                          2 => no input files exist
C                          3 => failed
C                          4 => no output files created.
C                          5 => failed to update CATNEW
C                          6 => output file exists
C   Inputs from MSG common:
C      MSGSUP   I       If 31990 < MSGSUP < 32000, the file copied
C                       message is suppressed.
C-----------------------------------------------------------------------
      INTEGER   LUNOLD, LUNNEW, BUFOLD(512), BUFNEW(512), NIFO, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'SNP2D.INC'
      INTEGER   I, NREC, SNKOLS(MAXSNC), SNNUMV(MAXSNC), SNKOLO(MAXSNC),
     *   SNNUMO(MAXSNC), ISNRNO, OSNRNO, NUMANT, NUMPOL, NUMIF, NUMNOD,
     *   SOURID, ANTNO, SUBA, FREQID, NODENO, REFA(2,MAXIF), REF, IREC,
     *   LSTSOU, GUSE, J, LUN, LUNTMP, VER, NIF
      LOGICAL   ISAPPL, CLSORT
      DOUBLE PRECISION TIME, THEFRQ, FRQOFF(MAXIF), FREQ0
      REAL      TIMEI, IFR, MBDELY(2), CREAL(2,MAXIF), CIMAG(2,MAXIF),
     *   DELAY(2,MAXIF), RATE(2,MAXIF), WEIGHT(2,MAXIF), GMMOD, UT,
     *   RANOD(25), DECNOD(25), APARM(10), PHASE, AMP, WT, DDELAY,
     *   DISP(2), DDISP(2)
      INCLUDE 'INCS:DCVL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DCHND.INC'
      DATA APARM /10 * 0.0/
C-----------------------------------------------------------------------
C                                       get output FREQS
      CALL FNDEXT ('FQ', CATBLK, VER)
      LUN = LUNTMP (1)
      FQCHND = 1
      CALL CHNDAT ('READ', BUFNEW, DISKOU, NEWCNO, VER, CATBLK, LUN,
     *   NIF, FOFF, ISBAND, FINC, BNDCOD, FQCHND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING OUTPUT FREQUENCY TABLE'
         GO TO 990
         END IF
      FREQ0 = CATD(KDCRV+JLOCF)
C                                       highest CL/FO
      GUSE = 0
C                                       Open input
      CALL SNINI ('READ', BUFOLD, DISKIN, OLDCNO, IVER, CATOLD, LUNOLD,
     *   ISNRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT SN TABLE'
         GO TO 990
         END IF
C                                       create output
      OVER = 0
      CALL SNINI ('WRIT', BUFNEW, DISKOU, NEWCNO, OVER, CATBLK,
     *   LUNNEW, OSNRNO, SNKOLO, SNNUMO, NUMANT, NUMPOL, NIFO, NUMNOD,
     *   GMMOD, RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT SN TABLE'
         GO TO 990
         END IF
      NREC = BUFOLD(5)
      LSTSOU = -1
C                                       read/write loop
      DO 50 IREC = 1,NREC
         ISNRNO = IREC
         CALL TABSN ('READ', BUFOLD, ISNRNO, SNKOLS, SNNUMV, NUMPOL,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
         IF (IRET.NE.0) THEN
            IF (IRET.LT.0) GO TO 50
            WRITE (MSGTXT,1000) IRET, 'READING INPUT SN TABLE'
            GO TO 990
            END IF
C                                       get current freq info
         IF (LSTSOU.NE.SOURID) THEN
            I = MSGKIL
            MSGKIL = 32005
            CALL GETFRQ (DISKIN, OLDCNO, APARM, LSTSOU, SOURID, FREQID,
     *         CATOLD, IRET)
            MSGKIL = I
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'GETTING BASIC FREQ INFO'
               GO TO 990
               END IF
            END IF
         LSTSOU= SOURID
C                                       Obtain any other frq. offsets
C                                       hiding in the CL table
         UT = TIME - (IATUT/86400.0D0)
         I = MSGKIL
         MSGKIL = 32005
         CALL FRQUPD (DISKIN, OLDCNO, GUSE, ANTNO, UT, LSTSOU, SUBA,
     *      FREQID, CATOLD, CLSORT, FRQOFF, IRET)
         CLSORT = .TRUE.
         MSGKIL = I
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'GETTING DOPPLER FREQ OFFSET'
            GO TO 990
            END IF
         THEFRQ = REFFRQ(BIF) + FRQOFF(BIF) + (BCHAN-OLDR(KRCRP+JLOCF))
     *      * CFINC(BIF)
C                                       get values
         DO 40 I = 1,2
            REF = REFA(I,BIF)
            IF ((CREAL(I,BIF).EQ.FBLANK) .OR. (CIMAG(I,BIF).EQ.FBLANK))
     *         THEN
               DDELAY = FBLANK
               AMP   = FBLANK
               WT = 0.0
            ELSE
               WT = WEIGHT(I,BIF)
               PHASE = ATAN2 (CIMAG(I,BIF), CREAL(I,BIF))
               DDELAY = PHASE / TWOPI / THEFRQ
               IF (XDOAPP.GT.0.0) THEN
                  AMP = SQRT (CREAL(I,BIF)*CREAL(I,BIF) +
     *               CIMAG(I,BIF)*CIMAG(I,BIF))
               ELSE
                  AMP = 1.0
                  END IF
               END IF
            PHASE = 0.0
            DO 30 J = 1,NIFO
               IF (AMP.NE.FBLANK) THEN
                  PHASE = TWOPI * (FOFF(J) + FREQ0) * DDELAY
                  CREAL(I,J) = AMP * COS (PHASE)
                  CIMAG(I,J) = AMP * SIN (PHASE)
               ELSE
                  CREAL(I,J) = AMP
                  CIMAG(I,J) = 0.0
                  END IF
               DELAY(I,J) = DDELAY
               RATE(I,J) = 0.0
               WEIGHT(I,J) = WT
               REFA(I,J) = REF
 30            CONTINUE
 40         CONTINUE
         OSNRNO = IREC
         CALL TABSN ('WRIT', BUFNEW, OSNRNO, SNKOLO, SNNUMO, NUMPOL,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT SN TABLE'
            GO TO 990
            END IF
 50      CONTINUE
      CALL TABSN ('CLOS', BUFOLD, ISNRNO, SNKOLS, SNNUMV, NUMPOL,
     *   TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *   MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING INPUT SN TABLE'
         CALL MSGWRT (8)
         END IF
      CALL TABSN ('CLOS', BUFNEW, OSNRNO, SNKOLO, SNNUMO, NUMPOL,
     *   TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *   MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OUTPUT SN TABLE'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SNP2DY ERROR',I4,' DOING ',A)
      END

      SUBROUTINE QVSMSA (APCORE, A, I, B, C, D, L, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Vector scalar multiply and scalar add.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Vector Scalar multiply, scalar add:
C        D(mL) = (A(mI) * B) + C    for m=0,N-1
C   Inputs:
C      A  I  First source vector base address
C      I  I  A address increment
C      B  I  Source multiplicative scalar address
C      C  I  Source additive scalar address
C      D  I  Destination vector base address
C      L  I  D address increment
C      N  I  Element count
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   A, I, B, C, D, L, N
C
      INTEGER   LOOP
      LONGINT   JA, JD
      DOUBLE PRECISION XMULT, XADD
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Addresses 1-rel
      JA = A + PSAPOF
      JD = D + PSAPOF
      XMULT = APCORE(B+PSAPOF)
      XADD = APCORE(C+PSAPOF)
C                                       Loop
      INCLUDE 'INCS:ZVND.INC'
      DO 100 LOOP = 1,N
         APCORE(JD) = (APCORE(JA) * XMULT) + XADD
         JA = JA + I
         JD = JD + L
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE IWEDGE (TYPE, SIDE, CHAN, IX0, IY0, NCOL, NROW, DRANGE,
     *   RBUFF, IBUFF, IERR)
C-----------------------------------------------------------------------
C! draw wedges (incl zeros) on TV
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2011
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   draws wedges on the TV using values that are all 0 or are part or
C   all of an images intensity range.
C   Inputs:
C      TYPE     I      0 => zero the wedge
C                      1 => use full range of image intensities
C                      2 => use clipped range of image intensities
C      SIDE     I      0, 1, 2, 3 -> left, bottom, right, top
C      CHAN     I      TV channel to use
C      IX0      I      BLC on TV of wedge in X
C      IY0      I      BLC on TV of wedge in Y
C      NCOL     I      Number of columns in wedge: X extent
C      NROW     I      Number of rows in wedge: Y extent
C      DRANGE   R(2)   Intensity range to display: 0,0 => use type
C                        drange(1) <= drange(2) => use values
C   Output:
C      RBUFF    R(*)   Scratch buffer
C      IBUFF    I(*)   Scratch buffer - may be same as RBUFF IF and only
C                      IF TYPE >= 0.
C      IERR     I      Error code
C   In/out in common:
C      CATBLK (DCAT.INC) TV image header in, wedge image header out
C-----------------------------------------------------------------------
      INTEGER   TYPE, SIDE, CHAN, IX0, IY0, NCOL, NROW, IERR
      REAL      DRANGE(2), RBUFF(*), IBUFF(*)
C
      CHARACTER LINTYP*2, WETYP(4)*4
      LOGICAL   WASYNC, VERTCL
      INTEGER   IPL, I, IER, JJ
      REAL      X, Y
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA WETYP /'WELL', 'WEBB', 'WERR', 'WETT'/
C-----------------------------------------------------------------------
      IF (NCOL.LE.1) NCOL = 2
      IF (NROW.LE.1) NROW = 2
      WASYNC = ISYNCH.EQ.0
      VERTCL = (SIDE.EQ.0) .OR. (SIDE.EQ.2)
      JJ = NCOL
      IF (VERTCL) JJ = NROW
C                                       zero:
      IF (TYPE.EQ.0) THEN
         CALL FILL (NCOL, 0, IBUFF)
C                                       Wedge
      ELSE
         IF (CATR(IRRAN).EQ.CATR(IRRAN+1)) THEN
            CATR(IRRAN) = CATR(IRRAN) - 0.5
            CATR(IRRAN+1) = CATR(IRRAN+1) + 0.5
            END IF
C                                       IMPWEDGE: clip min/max
         IF (TYPE.EQ.2) THEN
            CATR(KRDMN) = CATR(IRRAN)
            CATR(KRDMX) = CATR(IRRAN+1)
            END IF
C                                       DRANGE argument
         IF (((DRANGE(1).NE.0.0) .OR. (DRANGE(2).NE.0.0)) .AND.
     *      (DRANGE(1).LE.DRANGE(2))) THEN
            IF (DRANGE(1).EQ.DRANGE(2)) THEN
               CATR(KRDMN) = 0.999 * DRANGE(1)
               CATR(KRDMX) = 1.001 * DRANGE(2)
            ELSE
               CATR(KRDMN) = DRANGE(1)
               CATR(KRDMX) = DRANGE(2)
               END IF
            END IF
C                                       avoid zero divide
         IF (CATR(KRDMX).EQ.CATR(KRDMN)) THEN
            CATR(KRDMX) = CATR(IRRAN+1)
            CATR(KRDMN) = CATR(IRRAN)
            END IF
C                                       Numbers into pixel form
         X = CATR(KRDMN)
         Y = CATR(KRDMX)
         Y = (Y - X)
         IF (JJ.GT.1) Y = Y / (JJ - 1)
         IF (Y.EQ.0.0) THEN
            CATR(IRRAN) = 0.0
            CATR(IRRAN+1) = 10.0
            END IF
         DO 20 I = 1,JJ
            RBUFF(I) = X + (I-1.0)*Y
 20         CONTINUE
C                                        Scale buffer like image
         CALL H2CHR (2, 1, CATH(IITRA), LINTYP)
         CALL ISCALE (LINTYP, MAXINT, CATR(IRRAN), JJ, 1, RBUFF, IBUFF)
         END IF
C                                        Reset Catlg record
C                                        meaningful part
      CATBLK(IICOR  ) = IX0
      CATBLK(IICOR+1) = IY0
      CATBLK(IICOR+2) = IX0 + NCOL - 1
      CATBLK(IICOR+3) = IY0 + NROW - 1
      CALL COPY (4, CATBLK(IICOR), CATBLK(IIWIN))
C                                        clear rest for zeroing
      IF (TYPE.EQ.0) THEN
         CALL RFILL (5, HBLANK, CATH(KHIMN))
         CATBLK(KIIMS) = 0
         CATBLK(IIVOL) = 0
         CATBLK(IICNO) = 0
         CATR(KRDMX) = 0.0
         CATR(KRDMN) = 0.0
         CATR(IRRAN) = 0.0
         CATR(IRRAN+1) = 0.0
         CALL RFILL (2, HBLANK, CATH(KHBUN))
         CATBLK(KINIT) = 0
         CALL CHR2H (2, 'ZZ', KHPTYO, CATH(KHPTY))
C                                        except for image wedge
      ELSE
         CALL CHR2H (2, 'WE', KHPTYO, CATH(KHPTY))
         END IF
      JJ = 0
      IF (VERTCL) JJ = 1
      I = 2 * KICTPN
      CALL RFILL (I, HBLANK, CATH(KHCTP))
      CALL CHR2H (4, WETYP(SIDE+1), 1, CATH(KHCTP+I-2))
      CALL RCOPY (2, CATH(KHBUN), CATH(KHCTP+2*JJ))
      CATR(KRCRP+JJ) = (CATBLK(IICOR+JJ) + CATBLK(IICOR+JJ+2)) / 2.0
      CATD(KDCRV+JJ) = (CATR(KRDMX) + CATR(KRDMN)) / 2.0
      CATR(KRCIC+JJ) = (CATR(KRDMX) - CATR(KRDMN)) / (CATBLK(IICOR+JJ+2)
     *   - CATBLK(IICOR+JJ))
      CATR(KRCIC+1-JJ) = 0.0
      CATR(KRCRP+1-JJ) = CATBLK(IICOR+1-JJ) - 1
      CATD(KDCRV+1-JJ) = 0.0
C                                       Load to TV
      IF (WASYNC) CALL YHOLD ('ONNN', IER)
      IPL = IY0 - 1
      IF (TYPE.EQ.0) THEN
         IPL = IPL + NROW
         I = IX0 + NCOL - 1
         CALL YFILL (CHAN, IX0, IY0, I, IPL, 0, IBUFF, IERR)
C                                       horizontal wedge
      ELSE IF (.NOT.VERTCL) THEN
         DO 30 I = 1,NROW
            IPL = IPL + 1
            CALL YIMGIO ('WRIT', CHAN, IX0, IPL, 0, NCOL, IBUFF, IERR)
            IF (IERR.NE.0) GO TO 50
 30        CONTINUE
      ELSE
         DO 40 I = 1,NROW
            IPL = IPL + 1
            CALL RFILL (NCOL, IBUFF(I), RBUFF)
            CALL YIMGIO ('WRIT', CHAN, IX0, IPL, 0, NCOL, RBUFF, IERR)
            IF (IERR.NE.0) GO TO 50
 40         CONTINUE
         END IF
C                                       resume display
 50   IF (WASYNC) CALL YHOLD ('OFFF', IER)
C                                        Update catalog
      IF ((I.GT.1) .OR. (IERR.EQ.0)) CALL YCWRIT (CHAN, CATBLK(IICOR),
     *   CATBLK, IBUFF, IER)
C
 999  RETURN
      END

      PROGRAM UPDAT
C-----------------------------------------------------------------------
C! Stand-alone task to update AIPS data files to a new format.
C# Service Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2002, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  UPDAT will update AIPS data files starting with the 15OCT85 AIPS
C  to the latest AIPS data format.  The AIPS data file versions are
C  now encoded in the AIPS file names.  This permits UPDAT to be
C  run more than once on a set of data without causing files to be
C  updated twice.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   USERS(1000), DISKS(2), VERNUM(2), IERR
      INTEGER   TTY(2)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA TTY /5,0/, PRGNAM /'UPDAT '/
C-----------------------------------------------------------------------
C                                       Standard AIPS inits.
      CALL AIPINI (TTY, PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get users input.
      CALL GETRNG (TTY, USERS, DISKS, VERNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Change all data.
      CALL DOCHNG (USERS, DISKS, VERNUM, IERR)
C
 999  STOP
      END
      SUBROUTINE GETRNG (TTY, USERS, DISKS, VERNUM, IERR)
C-----------------------------------------------------------------------
C  Get user input for the range of users, disks and version updates.
C  Input:
C     TTY     I(2)   LUN and FTAB of open terminal.
C  Output:
C     USERS   I(3)   USERS(1) is type of user number entry, 1 means
C                    use a range of user numbers, the first one is in
C                    USERS(2) and the last user number is in USERS(3).
C                    If USERS(1) is a 2, then the user numbers are in
C                    a text file HLPFIL:USERLIST.HLP.  In this 2nd case
C                    USERS(4) through USERS(N) contains the user
C                    numbers.  USERS(3) is N.
C     DISKS   I(2)   First and last disk for update.
C     VERNUM  I(2)   First and last version numbers for update.
C     IERR    I      Error code. 0 = ok.
C-----------------------------------------------------------------------
      INTEGER   TTY(2), USERS(1000), DISKS(2), VERNUM(2), IERR
C
      CHARACTER PROMPT*80, OLDDAT*8, PHFILE*48, MNAME*8, VERSON*48,
     *   LINE*80, DEFDAT*8, BLANK*4
      INTEGER   IANS, LUN, IND, IEOF, I, I1, I2, IDUM(2)
      LOGICAL   F
      INCLUDE 'INCS:DDCH.INC'
      DATA I1, I2 /1, 2/
      DATA IEOF, LUN /2, 10/
      DATA DEFDAT, MNAME, VERSON /'15JUL93', 'USERLIST', ' '/
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                       Loop until user gets it right.
 100  CONTINUE
C                                       How do they want user numbers
C                                       determined.
         WRITE (PROMPT,1100)
         CALL INQINT (TTY, PROMPT, I1, USERS, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) GO TO 999
C                                       Get users from a text file.
         IF (USERS(1).EQ.2) THEN
             CALL ZPHFIL ('HE', 1, 0, 0, PHFILE, IERR)
             CALL ZTOPEN (LUN, IND, 1, PHFILE, MNAME, VERSON, F, IERR)
             IF (IERR.NE.0) GO TO 999
C                                       Get range of user numbers.
         ELSE IF (USERS(1).EQ.1) THEN
 105        WRITE (PROMPT,1105) 1, USELIM
            CALL INQINT (TTY, PROMPT, I2, USERS(2), IERR)
            IF (IERR.LT.0) GO TO 105
            IF (IERR.GT.0) GO TO 999
            IF (USERS(2).LE.0) USERS(2) = 1
            IF (USERS(3).LE.0) USERS(3) = USELIM
         ELSE
            GO TO 100
            END IF
C                                       Disks.
 120     WRITE (PROMPT,1120) 1, NVOL
         CALL INQINT (TTY, PROMPT, I2, DISKS, IERR)
         IF (IERR.LT.0) GO TO 120
         IF (IERR.GT.0) GO TO 999
         IF (DISKS(1).LE.0) DISKS(1) = 1
         IF (DISKS(2).LE.0) DISKS(2) = NVOL
C                                       Oldest data.
 140     WRITE (PROMPT,1140) DEFDAT
            CALL INQSTR (TTY, PROMPT, 7, OLDDAT, IERR)
            IF (IERR.NE.0) GO TO 999
            IF (OLDDAT(1:1).EQ.' ') OLDDAT = DEFDAT
            CALL FNDDAT (TTY, OLDDAT, VERNUM, IERR)
            IF (IERR.NE.0) GO TO 140
C                                       tell choices
         BLANK = ' '
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 1, BLANK, IERR)
         IF (USERS(1).EQ.1) WRITE (PROMPT,1150) USERS(2), USERS(3)
         IF (USERS(1).EQ.2) WRITE (PROMPT,1155)
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, PROMPT, IERR)
         WRITE (PROMPT,1160) DISKS
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, PROMPT, IERR)
         WRITE (PROMPT,1170) OLDDAT
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, PROMPT, IERR)
C                                       Chance to change.
 180     WRITE (PROMPT,1180)
            CALL INQINT (TTY, PROMPT, I1, IDUM, IERR)
            IANS = IDUM(1)
            IF (IERR.LT.0) GO TO 180
            IF (IERR.GT.0) GO TO 999
            IF (IANS.EQ.1) GO TO 100
            IF (IANS.NE.2) GO TO 180
C                                       Read user numbers.
      IF (USERS(1).EQ.2) THEN
         IERR = 1
         DO 250 I = 4,1000
            CALL ZTREAD (LUN, IND, LINE, IERR)
            IF (IERR.EQ.IEOF) THEN
               IERR = 0
               USERS(2) = 4
               USERS(3) = I - 1
               CALL ZTCLOS (LUN, IND, IERR)
               GO TO 999
               END IF
            IF (IERR.NE.0) GO TO 970
            READ (LINE,1200,ERR=980) USERS(I)
 250        CONTINUE
C                                       Too large a help file.
         WRITE (PROMPT,1250)
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, PROMPT, IERR)
         END IF
      GO TO 999
C                                       Error reading file.
 970  WRITE (PROMPT,1970)
      CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, PROMPT, IERR)
      GO TO 999
C                                       Bad number in file.
 980  WRITE (PROMPT,1980)
      CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, PROMPT, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('Enter : 1=range of users, 2=user nums in text file :')
 1105 FORMAT ('Enter user number range.(Default=',2I5,')  :')
 1120 FORMAT ('Enter AIPS disk num range (Default=',2I3,')  :')
 1140 FORMAT ('Enter oldest version date as 15MMMYY (Default= ',
     *   A8,') :')
 1150 FORMAT ('User number range : ',2I5)
 1155 FORMAT ('Get user numbers from help file "USERLIST"')
 1160 FORMAT ('Disk range        : ',2I5)
 1170 FORMAT ('Oldest data       : ',A8)
 1180 FORMAT ('Enter : 1=I made a mistake, reenter; 2=continue :')
 1200 FORMAT (I4)
 1250 FORMAT ('Too many users in the help file (Max=100)')
 1970 FORMAT ('ERROR READING HELP FILE "USERLIST"')
 1980 FORMAT ('ERROR DECODING USER NUMBER : ',A4)
      END
      SUBROUTINE DOCHNG (USERS, DISKS, VERNUM, IERR)
C-----------------------------------------------------------------------
C  Loop through all version updates for all users on all disks.
C  Inputs:
C     USERS  I(2)    If USERS(1) is 1 then USERS(2) is the first user
C                    number and USERS(3) is the last user number.  If
C                    USERS(1) is 2 then USERS(2) is 4 and USERS(3) is N
C                    and USERS(4) through USERS(N) contain the valid
C                    user numbers.
C                    open text file containing user numbers.
C     DISKS  I(2)    First and last disks.
C     VERNUM I(2)    First and last version numbers.
C     IERR   I       Error code. 0=ok.
C-----------------------------------------------------------------------
      INTEGER   USERS(1000), DISKS(2), VERNUM(2)
      INTEGER   IERR
C
      INTEGER   IVER, ISU, IEU, ISV, IEV, ISD, IED, IDISK, IUSER, I
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      ISU = USERS(2)
      IEU = USERS(3)
      ISV = VERNUM(1)
      IEV = VERNUM(2)
      ISD = DISKS(1)
      IED = DISKS(2)
      DO 400 IVER = ISV,IEV
         DO 300 IDISK = ISD,IED
            IUSER = USERS(2) - 1
            DO  200 I = ISU,IEU
               IF (USERS(1).EQ.1) IUSER = I
               IF (USERS(1).EQ.2) IUSER = USERS(I)
C                                       1990
               GO TO (400, 400, 400, 400,
C                                       1991
     *            400, 400,
C                                       1992
     *            400, 400,
C                                       1993
     *            400,
C                                       1994
     *            400, 100,
C                                       1995
     *            400), IVER
C                                       Convert 15JUL94 to 15JAN95
C                                       (ver C -> ver D)
 100              CALL JAN95 (IUSER, IDISK, IERR)
                  GO TO 200
C
 200           CONTINUE
 300        CONTINUE
 400     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE FNDDAT (TTY, OLDDAT, VERNUM, IERR)
C-----------------------------------------------------------------------
C  FNDDAT figures out what changes are needed to update a given AIPS
C  release.
C  Inputs:
C     TTY     I(2)     LUN and FTAB of open terminal.
C     OLDDAT  C*8      Old release date such as 15OCT85.
C  Output:
C     VERNUM  I(2)     Element one is the number of first update needed
C                      (15JAN90 is 1).  Element two is the number of
C                      the latest update.
C     IERR    I        Error code, 0 = ok.
C-----------------------------------------------------------------------
      INTEGER   TTY(2), VERNUM(2), IERR
      CHARACTER OLDDAT*8
C
      INTEGER   I, NUMDAT
      PARAMETER (NUMDAT=12)
      CHARACTER MSG*80, DATES(NUMDAT)*8
      DATA DATES /'15JAN90 ', '15APR90 ', '15JUL90 ', '15OCT90 ',
     *   '15JAN91 ', '15APR91 ', '15APR92 ', '15OCT92 ',
     *   '15JUL93 ', '15JAN94 ', '15JUL94 ', '15JAN95 '/
C-----------------------------------------------------------------------
C                                       Find OLDDAT in list of dates.
      VERNUM(2) = NUMDAT
      DO 100 I = 1,NUMDAT
         IF (DATES(I).EQ.OLDDAT) THEN
            VERNUM(1) = I
            IERR = 0
            GO TO 999
            END IF
 100     CONTINUE
C                                       Unknown date.
      WRITE (MSG,1100) OLDDAT
      CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, MSG, IERR)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('VERSION ',A8,' CANNOT BE UPDATED BY THIS PROGRAM')
      END
      SUBROUTINE JAN95 (IUSER, IDISK, IERR)
C-----------------------------------------------------------------------
C  Update 15JUL94 to 15JAN95: version C goes to D, the number base goes
C  from 16 to 36, and the file name length increases by 1.
C  Inputs:
C     IUSER  I   User number to update.
C     IDISK  I   Disk to update.
C  Output:
C     IERR   I   Error code. 0=ok.
C-----------------------------------------------------------------------
      INTEGER   IUSER, IDISK, IERR
C
      CHARACTER PHNAME*48, OLNAME*48, EXTYP*2, ATYPE*2
      REAL      CBBLKR(256), PCMAT(7,7)
      INTEGER   ICALUN, ICAIND, ICBLUN, ICBIND, CABLK(256), IMLUN, ISEQ,
     *   IMIND, LREC, IVER, CBBLK(256), IMBLK(256), I, NVER, NSEQ, NTSS,
     *   NWPL, NLPR, NMSG, ICMAX, IREC, NN, NMAX, ICNO, NSGS,
     *   NCERR, NCUPD, NEUPD
      LOGICAL   T, F
      DOUBLE PRECISION CBBLKD(128)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (CBBLK, CBBLKR, CBBLKD)
      DATA ICALUN, ICBLUN, IMLUN /15, 27, 28/
      DATA T, F /.TRUE., .FALSE./
C-----------------------------------------------------------------------
      CALL RFILL (49, 0.0, PCMAT)
      DO 10 I = 1,7
         PCMAT(I,I) = 1.0
 10      CONTINUE
C                                       Open old catlg file
      NLUSER = IUSER
      CALL ZPHOLV ('C', 'C', 'CA', IDISK, 0, 0, PHNAME, IERR)
      NLUSER = 1
C                                       Turn off error messages. A not
C                                       found catalog means no user.
      MSGSUP = 32000
      CALL ZOPEN (ICALUN, ICAIND, IDISK, PHNAME, F, T, T, IERR)
      MSGSUP = 0
C                                       Err 2 must be not found.
      IF (IERR.EQ.2) GO TO 200
      IF (IERR.NE.0) GO TO 980
C
      NWPL = 10
      NLPR = 256 / NWPL
      NMAX = NWPL * NLPR
C                                       Read 1st cat record.
      IREC = 1
      CALL ZFIO ('READ', ICALUN, ICAIND, IREC, CABLK, IERR)
      IF (IERR.NE.0) GO TO 980
      ICMAX = CABLK(3)
      NN = 999
      NCERR = 0
      NCUPD = 0
      NEUPD = 0
C                                       Loop over all catalog entries
      DO 170 ICNO = 1,ICMAX
         NN = NN + NWPL
C                                       Read another cat dir rec.
         IF (NN.LT.NMAX) GO TO 120
C                                       put back catalog rec
            IF (IREC.GT.1) THEN
               CALL ZFIO ('WRIT', ICALUN, ICAIND, IREC, CABLK, IERR)
               IF (IERR.NE.0) GO TO 980
               END IF
C                                       point to next
            NN = 1
            IREC = IREC + 1
            CALL ZFIO ('READ', ICALUN, ICAIND, IREC, CABLK, IERR)
            IF (IERR.NE.0) GO TO 980
C                                       See if this slot empty/illegal.
 120     IF (CABLK(NN).EQ.IUSER) THEN
C                                       Open catalog block.
            NLUSER = CABLK(NN)
            CALL ZPHOLV ('C', 'C', 'CB', IDISK, ICNO, 1, PHNAME, IERR)
            NLUSER = 1
            MSGSUP = 32000
            CALL ZOPEN (ICBLUN, ICBIND, IDISK, PHNAME, F, T, T, IERR)
            MSGSUP = 0
            IF (IERR.NE.0) THEN
               NCERR = NCERR + 1
               IF (IERR.EQ.2) THEN
                  WRITE (MSGTXT,1120) ICNO, IUSER
                  CABLK(NN) = 0
               ELSE
                  WRITE (MSGTXT,1121) ICNO, CABLK(NN), 'OPEN'
                  END IF
               CALL MSGWRT (7)
               GO TO 170
               END IF
            CALL ZFIO ('READ', ICBLUN, ICBIND, 1, CBBLK, IERR)
            IF (IERR.NE.0) THEN
               NCERR = NCERR + 1
               IF (IERR.EQ.4) THEN
                  WRITE (MSGTXT,1120) ICNO, IUSER
                  CABLK(NN) = 0
               ELSE
                  WRITE (MSGTXT,1121) ICNO, CABLK(NN), 'READ'
                  END IF
               CALL MSGWRT (7)
               CALL ZCLOSE (ICBLUN, ICBIND, IERR)
               GO TO 170
               END IF
C                                       Update header new WCS
C            CBBLKR(KRCOK) = 32000.0
C            CBBLKD(KDLON) = 180.0D0
C            CALL DFILL (9, 0.0D0, CBBLKD(KDPRJ))
C            CALL RCOPY (49, PCMAT, CBBLKR(KRPCM))
            CALL FXHDEX (CBBLK)
            CALL ZFIO ('WRIT', ICBLUN, ICBIND, 1, CBBLK, IERR)
            IF (IERR.NE.0) GO TO 980
            CALL ZCLOSE (ICBLUN, ICBIND, IERR)
            CALL H2CHR (2, KHPTYO, CBBLKR(KHPTY), ATYPE)
C                                       Update tables
            NLUSER = IUSER
C                                       Rename extension files
            DO 155 I = 1,KIEXTN
               NVER = MIN (255, CBBLK(KIVER+I-1))
               IF (NVER.LE.0) GO TO 155
                  CALL H2CHR (2, 1, CBBLKR(KHEXT+I-1), EXTYP)
                  DO 150 IVER = 1,NVER
                     NLUSER = IUSER
                     CALL ZPHOLV ('C', 'C', EXTYP, IDISK, ICNO, IVER,
     *                  OLNAME, IERR)
                     CALL ZPHOLV ('D', 'D', EXTYP, IDISK, ICNO, IVER,
     *                  PHNAME, IERR)
                     NLUSER = 1
C                                       Rename extension file if exists.
                     MSGSUP = 32000
                     CALL ZRENAM (IDISK, OLNAME, PHNAME, IERR)
                     MSGSUP = 0
                     IF (IERR.EQ.0) NEUPD = NEUPD + 1
 150                 CONTINUE
 155           CONTINUE
C                                       Rename cat block file (header).
            NLUSER = IUSER
            CALL ZPHOLV ('C', 'C', 'CB', IDISK, ICNO, 1, OLNAME, IERR)
            CALL ZPHOLV ('D', 'D', 'CB', IDISK, ICNO, 1, PHNAME, IERR)
            NLUSER = 1
            CALL ZRENAM (IDISK, OLNAME, PHNAME, IERR)
            IF (IERR.NE.0) GO TO 170
C                                       Rename data file.
            NLUSER = IUSER
            CALL ZPHOLV ('C', 'C', ATYPE, IDISK, ICNO, 1, OLNAME, IERR)
            CALL ZPHOLV ('D', 'D', ATYPE, IDISK, ICNO, 1, PHNAME, IERR)
            NLUSER = 1
            CALL ZRENAM (IDISK, OLNAME, PHNAME, IERR)
            IF (IERR.EQ.0) NCUPD = NCUPD + 1
            END IF
 170     CONTINUE
C                                       update and close CA file
      CALL ZFIO ('WRIT', ICALUN, ICAIND, IREC, CABLK, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL ZCLOSE (ICALUN, ICAIND, IERR)
      ICAIND = 0
C                                       Rename Catalog file, this user
      NLUSER = IUSER
      CALL ZPHOLV ('D', 'D', 'CA', IDISK, 0, 0, PHNAME, IERR)
      CALL ZPHOLV ('C', 'C', 'CA', IDISK, 0, 0, OLNAME, IERR)
      NLUSER = 1
      CALL ZRENAM (IDISK, OLNAME, PHNAME, IERR)
      IF (IERR.NE.0) GO TO 980
      WRITE (MSGTXT,1175) IUSER, IDISK, NCUPD, NEUPD, NCERR
      CALL MSGWRT (7)
C-----------------------------------------------------------------------
C                                       Do system files - disk one only
 200  IF (IDISK.NE.1) GO TO 999
         NSGS = 0
         NTSS = 0
         NMSG = 0
C                                       Rename Message file.
         NLUSER = IUSER
         CALL ZPHOLV ('C', 'C', 'MS', 1, IUSER, 0, OLNAME, IERR)
         CALL ZPHOLV ('D', 'D', 'MS', 1, IUSER, 0, PHNAME, IERR)
         NLUSER = 1
         MSGSUP = 32000
         CALL ZRENAM (1, OLNAME, PHNAME, IERR)
         MSGSUP = 0
         IF (IERR.EQ.0) NMSG = 1
C                                       Rename Save/Get file.
         NLUSER = IUSER
         CALL ZPHOLV ('C', 'C', 'SG', 1, IUSER, 0, OLNAME, IERR)
         NLUSER = 1
         MSGSUP = 32000
         CALL ZOPEN (IMLUN, IMIND, 1, OLNAME, F, T, T, IERR)
         MSGSUP = 0
         IF (IERR.NE.0) GO TO 300
         CALL ZFIO ('READ', IMLUN, IMIND, 1, IMBLK, IERR)
         IF (IERR.NE.0) GO TO 300
            LREC = 1
            NSEQ = IMBLK(1)
            IF (NSEQ.LE.0) GO TO 300
               NWPL = 7
               NLPR = 256 / NWPL
               DO 220 ISEQ = 1,NSEQ
                  IREC = ISEQ/NLPR + 1
                  IF (IREC.NE.LREC) THEN
                     LREC = IREC
                     CALL ZFIO ('READ', IMLUN, IMIND, IREC, IMBLK, IERR)
                     IF (IERR.NE.0) GO TO 240
                     END IF
                  IREC = MOD (ISEQ, NLPR) * NWPL + 1
                  IF (IMBLK(IREC).GT.0) THEN
                     NLUSER = IUSER
                     CALL ZPHOLV ('C', 'C', 'SG', IDISK, IUSER, ISEQ,
     *                  OLNAME, IERR)
                     CALL ZPHOLV ('D', 'D', 'SG', IDISK, IUSER, ISEQ,
     *                  PHNAME, IERR)
                     NLUSER = 1
                     CALL ZRENAM (IDISK, OLNAME, PHNAME, IERR)
                     IF (IERR.EQ.0) NSGS = NSGS + 1
                     END IF
 220              CONTINUE
            CALL ZCLOSE (IMLUN, IMIND, IERR)
            NLUSER = IUSER
            CALL ZPHOLV ('C', 'C', 'SG', IDISK, IUSER, 0, OLNAME, IERR)
            CALL ZPHOLV ('D', 'D', 'SG', IDISK, IUSER, 0, PHNAME, IERR)
            NLUSER = 1
            CALL ZRENAM (IDISK, OLNAME, PHNAME, IERR)
            IF (IERR.EQ.0) NSGS = NSGS + 1
            GO TO 300
 240        CALL ZCLOSE (IMLUN, IMIND, IERR)
 300     CONTINUE
C                                       Rename TGet file.
      NLUSER = IUSER
      CALL ZPHOLV ('C', 'C', 'TS', 1, IUSER, 0, OLNAME, IERR)
      CALL ZPHOLV ('D', 'D', 'TS', 1, IUSER, 0, PHNAME, IERR)
      NLUSER = 1
      MSGSUP = 32000
      CALL ZRENAM (1, OLNAME, PHNAME, IERR)
      MSGSUP = 0
      IF (IERR.EQ.0) NTSS = 1
      IF (NSGS+NTSS+NMSG.GT.0) THEN
         WRITE (MSGTXT,1360) IUSER, NMSG, NSGS, NTSS
         CALL MSGWRT (2)
         END IF
      GO TO 999
C                                       Serious error.
 980  IF (ICAIND.GT.0) CALL ZCLOSE (ICALUN, ICAIND, IERR)
      WRITE (MSGTXT,1980) IUSER, IDISK
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1120 FORMAT ('FILE FOR CATALOG SLOT ',I5,' USER',I5,
     *   ' IS MISSING OR EMPTY')
 1121 FORMAT ('ERROR UPDATING SLOT ',I5,' USER',I5,' OPER= ',A)
 1175 FORMAT ('Updated user',I5,' disk',I3,' with',I5,' files,',I5,
     *   ' exts,',I3,' errors')
 1360 FORMAT ('For user',I5,' renamed',I2,' message,',I4,' save/get,',
     *   I2,' tget files')
 1980 FORMAT ('SERIOUS ERROR CONVERTING USER',I5,' ON DISK',I3)
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QCSQTR (CORNER, SIZE, ROW)
C-----------------------------------------------------------------------
C! Pseudo AP routine: inplace transpose of square, complex matrix.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Vectorizing compiler version
C   QCSQTR does an inplace transpose of square matrices of complex
C   values.
C   Inputs:
C      CORNER  I  AP location of first corner of matrix encountered.
C      SIZE    I  Size (number of reals) of a row or column.
C      ROW     I  Number of locations in AP between beginnings
C                 of the rows.
C-----------------------------------------------------------------------
      INTEGER   CORNER, SIZE, ROW, II, JJ, JK, LIMIT1, LIMIT2, JCORN,
     *   INDEX1, INDEX2
      REAL      RTEMP,ITEMP
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                       Address to 1-rel.
      JCORN = CORNER + 1
C                                        Begin loop thru rows
      LIMIT1 = SIZE - 1
C@DIR IGNORE RECRDEPS(APCORE)
      DO 100 II = 1,LIMIT1
C                                        Loop down row exchanging
C                                        values with col.
         INDEX1 = JCORN
         INDEX2 = JCORN
         LIMIT2 = SIZE - II + 1
C@DIR IGNORE RECRDEPS(APCORE)
         DO 50 JK = 1,LIMIT2
            RTEMP = APCORE(INDEX1)
            ITEMP = APCORE(INDEX1+1)
            APCORE(INDEX1) = APCORE(INDEX2)
            APCORE(INDEX1+1) = APCORE(INDEX2+1)
            APCORE(INDEX2) = RTEMP
            APCORE(INDEX2+1) = ITEMP
            INDEX1 = INDEX1 + 2
            INDEX2 = INDEX2 + ROW
 50         CONTINUE
C                                        Update current corner.
         JCORN = JCORN + ROW + 2
 100     CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'MOD3D.INC'
C                                                          Include MOD3D
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
C                                       NOTE: uses PARAMETER in DGDS.INC
      INTEGER   NCOMP(MAXFLD), BCOMP(MAXFLD)
      INTEGER   UVBLK(256), DISKIN, DISKO, DISK2, OLDCNO, CLNCNO,
     *   NEWCNO, SEQIN, SEQ2, SEQOUT, VER, ISTOKE, METHOD, MODEL, BIF,
     *   EIF, CH1, FRQSEL, BUFF3(UVBFSS), SCRTCH(512)
      REAL   XSIN, XDISIN, XS2, XDISK2, XSOUT, XDISO, XVER, XNMAPS,
     *   XBCOMP(MAXAFL), XNCOMP(MAXAFL), XFLUX, BLC(7), TRC(7),
     *   BUFF1(UVBFSS), BUFF2(UVBFSS)
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAME2(3), XCLAS2(2), XNAMOU(3),
     *   XCLAOU(2)
      CHARACTER NAMEIN*12, CLAIN*6, NAME2*12, CLAS2*6, NAMOUT*12,
     *   CLAOUT*6
      COMMON /INFO/ UVBLK,
     *   BCOMP, NCOMP,
     *   DISKIN, DISKO, DISK2, OLDCNO, CLNCNO, NEWCNO, ISTOKE,
     *   SEQIN, SEQOUT, SEQ2, VER, METHOD, MODEL,
     *   BIF, EIF, CH1, FRQSEL
      COMMON /BUFRS/ BUFF1, BUFF2, BUFF3, SCRTCH
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAME2, XCLAS2, XS2,
     *   XDISK2, XVER, XNMAPS, XNAMOU, XCLAOU, XSOUT, XDISO, XBCOMP,
     *   XNCOMP, XFLUX, BLC, TRC
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAME2, CLAS2, NAMOUT, CLAOUT
C                                                          End MOD3D
LOCAL END
LOCAL INCLUDE 'MOD3DI.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   CCBUFF(512), CCKOLS(MAXCCC), CCNUMV(MAXCCC), CCRNO,
     *   CCLUN, NCOL, CCOUNT
      COMMON /MOD3DI/ CCBUFF, CCKOLS, CCNUMV, CCRNO, CCLUN, NCOL, CCOUNT
LOCAL END
      PROGRAM MOD3D
C-----------------------------------------------------------------------
C! Forms a single 3D CC file from a set of facets
C# UV AP-appl Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MOD3D is an AIPS task to form a 3D CC file from a set of facet
C   image files' CC tables.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLASIN        Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input UV data.
C      IN2NAME        NAME2         Name of map with CLEAN components.
C      IN2CLASS       CLAS2         Class of map with CLEAN components.
C      IN2SEQ         SEQ2          Seq. of map with CLEAN components.
C      IN2DISK        DISK2         Vol. of map with CLEAN components.
C      INVER          VER           Version no. of CC file.
C      NMAPS          NMAPS         Number of input images.
C      OUTNAME        NAMOUT        Name of the output image file.
C      OUTCLASS       CLAOUT        Class of the output image file.
C      OUTSEQ         SEQOUT        Seq. number of output file
C      OUTDISK        DISKO         Disk number of the output file.
C      BCOMP(64)      BCOMP         Start clean component to sub.
C                                   1 per field.
C      NCOMP(64)      NCOMP         Last Clean component no to sub.
C                                      1 per field, 0 => all
C      BLC/TRC        BLC, TRC      subimage window of CC file 1 -> out
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, CATSAV(256)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'MOD3D.INC'
      INCLUDE 'MOD3DI.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DSCD.INC'
      DATA PRGM /'MOD3D '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL MOD3IN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
      CALL COPY (256, CATBLK, CATSAV)
      DATDIV = .FALSE.
C                                       Process data
C                                       Else Subtraction
      CALL MOD3DS (MODEL, METHOD, UVBLK, BUFF1, BUFF2, BUFF3, IRET)
      CALL UNSETG (BUFF2)
C                                       If no error, update history
      CALL COPY (256, CATSAV, CATBLK)
      CATBLK(KINIT) = CCOUNT
      IF (IRET.EQ.0) CALL SUBHIS
C                                       Close down
 990  CALL DIE (IRET, SCRTCH)
C
      STOP
      END
      SUBROUTINE MOD3IN (PRGN, IERR)
C-----------------------------------------------------------------------
C   MOD3IN gets input parameters for MOD3D and creates an output file
C   if necessary.
C   Inputs: PRGN   C*6       Task name
C   Output: IERR   I         Error code: non-zero => quit
C-----------------------------------------------------------------------
      CHARACTER STAT*4, PRGN*6, BLANK*6, UTYPE*2
      INTEGER   JERR
      INTEGER   INMETH, NPARM, IERR, I, IBUFF(512), IROUND, MXFLD
      LOGICAL   T, F, WASOME
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'MOD3D.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (IBUFF, BUFF2)
      DATA BLANK /' '/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Initialize I/O
      CALL ZDCHIN (T, SCRTCH)
      CALL VHDRIN
      MXFLD = MAXAFL
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IERR = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 38 + 2 * MXFLD
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRTCH, IERR)
      IF (JERR.NE.0) GO TO 999
      IERR = 5
C                                       Crunch input parameters.
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAME2, NAME2)
      CALL H2CHR (6, 1, XCLAS2, CLAS2)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       File sequence numbers
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      SEQ2 = IROUND (XS2)
C                                       File disk numbers
      DISKIN = IROUND (XDISIN)
      DISK2 = IROUND (XDISK2)
      DISKO = IROUND (XDISO)
C                                       CC file version number
      VER = IROUND (XVER)
C                                       IFs
      BIF = 1
C                                       Default EIF when have CATBLK
C                                       Number of fields
      MFIELD = 1
      IF (XNMAPS.GT.0.0) MFIELD = IROUND (XNMAPS)
      LIMFLX = XFLUX
C                                       Start component number
      NONEG = F
      WASOME = F
      DO 8 I = 1,MFIELD
         IF (I.LE.MAXAFL) THEN
            BCOMP(I) = XBCOMP(I) + 0.1
            BCOMP(I) = MAX (BCOMP(I), 1)
            NCOMP(I) = ABS (XNCOMP(I)) + 0.1
            IF (XNCOMP(I).LE.-0.5) NONEG = T
            IF (NCOMP(I).GT.0) WASOME = T
         ELSE
            BCOMP(I) = 1
            NCOMP(I) = 0
            IF (WASOME) NCOMP(I) = 1000000000
            END IF
 8       CONTINUE
C                                       Factor
      FACGRD(1) = 1.0
      FACGRD(2) = 1.0
C                                       Get  modeling method
      METHOD = -1
C                                       Get  model type
      MODEL = 1
C                                       Get CATBLK from old file.
      OLDCNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, NAMEIN, CLAIN, SEQIN, 'UV',
     *      DISKIN, NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Get uv header info.
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Reject multisource files (it is
C                                       not strictly necessary to do
C                                       this but input files can not
C                                       contain more than one source
C                                       and MOD3D would need to verify
C                                       this here)
      IF (ILOCSU.GE.0) THEN
         MSGTXT = 'INPUT FILE MUST BE A SINGLE-SOURCE FILE.'
         CALL MSGWRT (8)
         MSGTXT = 'USE SPLIT TO EXTRACT DESIRED DATA.'
         CALL MSGWRT (8)
         IERR = 1
         GO TO 999
         END IF
C                                       Setup common for modeling
C                                       routines
C                                       Uv header block
      CALL COPY  (256, CATBLK, UVBLK)
      INMETH = METHOD
      ISTOKE = 1
      DOPTMD = .FALSE.
C                                       If NONEG or DOPTMD use DFT
C                                       Warn user if changing METHOD
C                                       Get info on model file(s)
      CALL SETGDS (DISKIN, OLDCNO, NAME2, CLAS2, SEQ2, DISK2, MFIELD,
     *   VER, NCOMP, BCOMP, MODEL, METHOD, BUFF1, BUFF2, ISTOKE, IERR)
      IF (IERR.NE.0) GO TO 999
      MSGTXT = 'Using Clean Component source model'
      CALL MSGWRT (3)
      CALL FACSET (DISKIN, OLDCNO, 1, 0, MODEL, FACGRD, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       make the image
      CALL MOD3IM (IERR)
      IF (IERR.NE.0) GO TO 999
C                                        Put input file in READ
      STAT = 'READ'
      UTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy keywords ??
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      GO TO 999
C                                       Error messages output
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MOD3IN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,' . ',A6,' . ',
     *   I3,2X,A2,' DISK=',I3,' USID=',I4)
 1020 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE MOD3IM (IERR)
C-----------------------------------------------------------------------
C   MOD3IM subimages the first Clean image and writes the output image
C   It opens the output CC file
C   Output
C      IERR   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   IDIMS(7), ISLUN, ISIND, IDLUN, IDIND, IROUND, ISWIN(4),
     *   IDWIN(4), ISPOS, IDPOS, NX, NY, IX, IY, CATCLN(256), IBLKOF,
     *   NBY, OVER, KLNBL2(256), LFIELD
      REAL      RMIN, RMAX
      LOGICAL   WASBLK
      CHARACTER MATYPE*2, STAT*4, CBLANK*6
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'MOD3D.INC'
      INCLUDE 'MOD3DI.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA IDIMS /7*1/
      DATA ISLUN, IDLUN /17, 18/
      DATA CBLANK /' '/
C-----------------------------------------------------------------------
      WASBLK = .FALSE.
      RMAX = -1.E10
      RMIN = -RMAX
      NBY = 2 * UVBFSS
C                                       get clean map header
      CLNCNO = 1
      MATYPE = 'MA'
      CALL CATDIR ('SRCH', DISK2, CLNCNO, NAME2, CLAS2, SEQ2, MATYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FINDING CLEAN IMAGE IN CATALOG'
         GO TO 980
         END IF
      CALL CATIO ('READ', DISK2, CLNCNO, CATBLK, 'REST', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING CLEAN IMAGE HEADER'
         GO TO 980
         END IF
      CALL COPY (2, CATBLK(KINAX), IDIMS)
      CALL WINDOW (CATBLK(KIDIM), IDIMS, BLC, TRC, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'SETTING IMAGE WINDOW'
         GO TO 980
         END IF
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, CBLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
      CATBLK(KIIMS) = SEQOUT
      CALL SUBHDR (BLC, TRC, 1.0, 1.0)
      CALL MCREAT (DISKO, NEWCNO, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CREATING OUTPUT IMAGE'
         GO TO 980
         END IF
      CALL KEYCOP (DISK2, CLNCNO, DISKO, NEWCNO, IERR)
C                                       Open files
      CALL MAPOPN ('READ', DISK2, NAME2, CLAS2, SEQ2, MATYPE, NLUSER,
     *   ISLUN, ISIND, CLNCNO, CATCLN, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING CLEAN IMAGE FOR READ'
         GO TO 980
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK2
      FCNO(NCFILE) = CLNCNO
      FRW(NCFILE) = 0
      CALL MAPOPN ('INIT', DISKO, NAMOUT, CLAOUT, SEQOUT, MATYPE,
     *   NLUSER, IDLUN, IDIND, NEWCNO, CATBLK, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING OUTPUT IMAGE'
         GO TO 980
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      ISWIN(1) = IROUND (BLC(1))
      ISWIN(2) = IROUND (BLC(2))
      ISWIN(3) = IROUND (TRC(1))
      ISWIN(4) = IROUND (TRC(2))
      NX = ISWIN(3) - ISWIN(1) + 1
      NY = ISWIN(4) - ISWIN(2) + 1
      IDWIN(1) = 1
      IDWIN(2) = 1
      IDWIN(3) = NX
      IDWIN(4) = NY
      IBLKOF = 1
      CALL MINIT ('READ', ISLUN, ISIND, IDIMS(1), IDIMS(2), ISWIN,
     *   BUFF1, NBY, IBLKOF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INIT READ OF CLEAN IMAGE'
         GO TO 980
         END IF
      CALL MINIT ('WRIT', IDLUN, IDIND, NX, NY, IDWIN, BUFF2, NBY,
     *   IBLKOF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INIT WRITE OF OUTPUT IMAGE'
         GO TO 980
         END IF
      DO 100 IY = 1,NY
         CALL MDISK ('READ', ISLUN, ISIND, BUFF1, ISPOS, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'R5EADING CLEAN IMAGE'
            GO TO 980
            END IF
         CALL MDISK ('WRIT', IDLUN, IDIND, BUFF2, IDPOS, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT IMAGE'
            GO TO 980
            END IF
         DO 50 IX = 1,NX
            IF (BUFF1(ISPOS+IX-1).EQ.FBLANK) THEN
               WASBLK = .TRUE.
            ELSE
               RMAX = MAX (RMAX, BUFF1(ISPOS+IX-1))
               RMIN = MIN (RMIN, BUFF1(ISPOS+IX-1))
            END IF
            BUFF2(IDPOS+IX-1) = BUFF1(ISPOS+IX-1)
 50         CONTINUE
 100     CONTINUE
      CALL MDISK ('FINI', IDLUN, IDIND, BUFF2, IDPOS, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FINISH OUTPUT IMAGE'
         GO TO 980
         END IF
      CATR(KRDMX) = RMAX
      CATR(KRDMN) = RMIN
      CATR(KRBLK) = 0.0
      IF (WASBLK) CATR(KRBLK) = FBLANK
C                                       Clean comp files
      CCLUN = 91
      NY = 0
      DO 120 LFIELD = 1,MFIELD
C                                       Make sure this header applies
C                                       to this image
         CALL CATIO ('READ', CCDISK(LFIELD), CCCNO(LFIELD), KLNBL2,
     *      'REST', SCRTCH, IERR)
         IF ((IERR.NE.0) .AND. (IERR.LT.5)) THEN
            WRITE (MSGTXT,1000) IERR, 'READ HEADER WITH CATIO'
            GO TO 980
            END IF
C                                       Tabini can update header on disk
         CALL CCMINI ('READ', CCBUFF, CCDISK(LFIELD), CCCNO(LFIELD),
     *      CCVER(LFIELD), KLNBL2, CCLUN, CCRNO, CCKOLS, CCNUMV, NCOL,
     *      IERR)
         IF (IERR.GT.1) THEN
            WRITE (MSGTXT,1000) IERR, 'OPENING CLEAN COMPS FILE'
            GO TO 980
            END IF
         NY = MAX (NY, NCOL)
         CALL TABIO ('CLOS', 0, CCRNO, BUFF1, CCBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'CLOSING CC TABLE'
            GO TO 980
            END IF
 120     CONTINUE
      CCLUN = 91
      NCOL = NY + 1
      OVER = 1
      CALL CCMINI ('WRIT', CCBUFF, DISKO, NEWCNO, OVER, CATBLK,
     *   CCLUN, CCRNO, CCKOLS, CCNUMV, NCOL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING OUTPUT CC TABLE'
         GO TO 980
         END IF
      GO TO 999
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MOD3IM: ERROR',I4,' ON ',A)
      END
      SUBROUTINE SUBHIS
C-----------------------------------------------------------------------
C  SUBHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER AMETH*4, AMODL*4, HILINE*72
      INTEGER   LUN1, LUN2, IERR, I
      LOGICAL   T
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'MOD3D.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   BUFF1, BUFF3, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF3,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Model file(s)
      CALL HENCO2 (TSKNAM, NAME2, CLAS2, SEQ2, DISK2, LUN2, BUFF3,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1020) TSKNAM, VER
      IF (MODEL.EQ.1) CALL HIADD (LUN2, HILINE, BUFF3, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Number of input images
      WRITE (HILINE,1025) TSKNAM, MFIELD
      CALL HIADD (LUN2, HILINE, BUFF3, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Add no. clean comps.
      DO 25 I = 1,MFIELD
         NCOMP(I) = NSUBG(I) - 1
         WRITE (HILINE,1021) TSKNAM, I, BCOMP(I), I, NCOMP(I)
         IF (MODEL.EQ.1) CALL HIADD (LUN2, HILINE, BUFF3, IERR)
         IF (IERR.NE.0) GO TO 100
 25      CONTINUE
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, CATBLK(KIIMS), DISKO, LUN2,
     *   BUFF3, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Modeling method
      AMETH = 'DFT '
      WRITE (HILINE,1027) TSKNAM, AMETH
      CALL HIADD (LUN2, HILINE, BUFF3, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Model type
C                                       CC or image
      AMODL = 'COMP'
      WRITE (HILINE,1028) TSKNAM, AMODL
      CALL HIADD (LUN2, HILINE, BUFF3, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Close history file.
 100  CALL HICLOS (LUN2, T, BUFF3, IERR)
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SUBHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1020 FORMAT (A6,'VER     = ',I6,' / CC file ver. no.')
 1021 FORMAT (A6,'BCOMP(',I2,')=',I6,', NCOMP(',I3,') =',I6,
     *   ' / First-last comp. no.')
 1025 FORMAT (A6,'NMAPS   = ',I6,' / Number of model images')
 1027 FORMAT (A6,'CMETHOD = ',1H',A4,1H',' / Model method')
 1028 FORMAT (A6,'CMODEL  = ',1H',A4,1H',' / Model type')
      END
      SUBROUTINE MOD3DS (MODEL, METHOD, CATBLK, BUFF1, BUFF2, BUFF3,
     *   IRET)
C-----------------------------------------------------------------------
C   MOD3DS calls MOD3DV to project CC coordinates and save in output.
C   Inputs:
C      MODEL    I        1=> clean components, 2=>image.
C      METHOD   I        1=>gridded, -1=>DFT, 0=>chose.
C      CATBLK   I(256)   UV data catalog header record.
C   Inputs from COMMON /MAPDES/:
C      MFIELD   I        Number of fields
C      NSUBG    I(*)     Number of components already sub.
C      NCLNG    I(*)     Number of components per field.
C      CCDISK   I(*)     Disk numbers for CC files
C      CCCNO    I(*)     Catalog slot numbers for CC files.
C      CCVER    I(*)     CC file version number for each field.
C      FACGRD   R(2)     Value to multiply clean component fluxes
C                        by before subtraction (negative for sum).
C                        FACGRD(2) is for data and 0 or 1 only values
C                        used.  Model added not subtracted when data are
C                        ignored.
C      NONEG    L        Stop reading comps. from a file past the first
C                        negative component.
C      LIMFLX   R        Stop reading comps < LIMFLX in abs value
C   Output:
C      BUFF1    R(*)     Work buffers.
C      BUFF2    R(*)     Work buffers.
C      BUFF3    I(*)     Work buffers.
C      IRET     I        Return error code. 0=>OK, otherwise failed.
C-----------------------------------------------------------------------
      INTEGER   MODEL, METHOD, CATBLK(256), BUFF3(*), IRET
      REAL      BUFF1(*), BUFF2(*)
C
      INTEGER   SCRGRD, SCRWRK, LUN, INMETH, OUMETH
      LOGICAL   DODFT
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSCD.INC'
      SAVE LUN, SCRGRD, SCRWRK
      DATA SCRGRD, SCRWRK /0, 0/, LUN /27/
C-----------------------------------------------------------------------
      IRET = 0
      NGRDAT = .FALSE.
C                                       Store CATBLK for later use
      IF (.NOT.DATDIV) THEN
         CALL COPY (256, CATBLK, SCRCAT)
         SCLREC = LREC
         SCRPRM = NRPARM
         COMPDT = CATBLK(KINAX).EQ.1
         END IF
C                                       Decide model computation method.
      INMETH = METHOD
      DODFT = (METHOD.LT.0) .AND. (MODEL.EQ.1)
      IF (DODFT) OUMETH = -1
      CALL MOD3DV ('SUB ', CATBLK, BUFF1, BUFF2, BUFF3, IRET)
C
 999  RETURN
      END
      SUBROUTINE MOD3DV (OPCODE, CATBLK, BUFF1, BUFF2, IBUFF, IRET)
C-----------------------------------------------------------------------
C   MOD3DV subtracts/divides CLEAN components from/into ungridded
C   visibility data by a DFT model computation.  Only model components
C   of a single type are processed.  Point components will be taken as
C   Gaussians or Spheres as needed if some of the fields are extended
C   and some not.
C   All un subtracted data processed in one call.
C   Inputs:
C      OPCODE   C*4      Opcode 'SUB ', or 'DIV '
C      CATR     R(256)   UV data catalog header record.
C   Inputs: from commons
C      MODMAX   I        DMOD.INC - if set, this controls facets/chans
C      MFIELD   I        Number of fields
C      NCLNG    I(16)    Number of components per field. -
C                        changed if flux limit hit
C      NSUBG    I(16)    The next component to subtract.
C      CCDISK   I(16)    Disk numbers of the clean images.
C      CCCNO    I(16)    Catalog slot numbers of clean images.
C      CCVER    I(*)     CC file version number for each field.
C      NGRDAT   L        If FALSE get map size, scaling etc. parms
C                        from the model map cat. header. If TRUE
C                        then the values filled in by GRDAT must
C                        already be filled into the common.
C      LREC     I        Length in words of vis record.
C      NVIS     I        Number of vis. records
C      NONEG    L        Stop reading comps. from a file past the first
C                        negative component.
C      LIMFLX   R        Stop if abs(flux) < LIMFLX
C      DOPTMD   L        Use the point model specified by PTFLX, PTRAOF,
C                        PTDCOF
C      PTFLX    R        Point model flux density (Jy) (I pol. only)
C      PTRAOF   R        Point model RA offset from uv phase center
C                        (asec)
C      PTDCOF   R        Point model Dec. offset from uv phase center
C      PARMOD   R(6)     Model parameters for non point models; used
C                        only if DOPTMOD is true.
C                        1=> model type, 0=point, 1=gaussian, 3=sphere
C                        Gaussian: (2)=major axis(asec), (3)=minor axis
C                                  (4)=PA (degrees)
C                        Sphere: (2)=radius (asec).
C      KSTOK    I        (DGDS.INC) If a point model is specified a
C                        value of 2 indicates a Q pol model, 3 U and
C                        4 V pol.AC
C   In/out:
C      CNOSCO   I        IN: output file catalog slot number or /CFILES/
C                        scratch file number. Will create a scratch file
C                        if CNOSCO and DISKO .le. 0.
C                        Out: file /CFILES/ number if created.
C   Output:
C      BUFF1    R(*)     I/O buffers.
C      BUFF2    R(*)     I/O buffers.
C      IBUFF    I(*)     I/O Buffer.
C      IRET     I        Return code, 0 => ok, otherwise not.
C                            8 => model types not compatible/illegal
C                            9 => Buffers too small to load AP.
C                           10 => Too many components for division.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   CATBLK(256), IBUFF(*), IRET
      REAL      BUFF1(*), BUFF2(*)
C
      CHARACTER MDTYP(4)*8, ERRTXT*40, UMET*4
      INTEGER   JCOMP, XNCOMP, JT, LUNC, ITYPE, LENMOD, CCTYPE, JLREC,
     *   JNREC, I, LFIELD, LMOD(4), I2, MODTYP, KLNBL2(256), CLTYPE
      REAL      XXOFF, YYOFF, ZZOFF, XYZ(3), XP(3), UMAT(3,3),
     *   PMAT(3,3), PARMS(3), XX, YY, ZZ, FLUX
      DOUBLE PRECISION XRA, XDEC, CONST
      LOGICAL   T, F
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMOD.INC'
      LOGICAL   DONE(MAXFLD), ONZE
      INTEGER   LFR, CLKOLS(MAXCCC), CLNUMV(MAXCCC), CLBUFF(512), CLRNO
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMPR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      INCLUDE 'MOD3DI.INC'
      PARAMETER (CONST = DG2RAD * TWOPI)
      SAVE ONZE
      DATA LMOD /4, 7, 7, 6/
      DATA MDTYP /'Point   ', 'Gaussian', 'Unknown ', 'Sphere  '/
      DATA LUNC /29/
      DATA T, F /.TRUE.,.FALSE./, ONZE/.FALSE./
C-----------------------------------------------------------------------
      UMET = 'DFT'
      LFIELD = 0
      CCOUNT = 0
      TFLUXG = 0.0
      MODMAX = MFIELD
C                                       Decide component type.
C                                       From CC model passed
      LFIELD = 1
C                                       Get field info. if nec.
      IF (.NOT.NGRDAT) THEN
         CALL GRDAT (F, LFIELD, CATBLK, IBUFF(2049), IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       If NGRDAT read CLEAN CATBLK.
      IF (NGRDAT) THEN
         ERRTXT = 'READING CLEAN CATBLK'
         CALL CATIO ('READ', CCDISK(LFIELD), CCCNO(LFIELD), KLNBLK,
     *      'REST', IBUFF(2049), IRET)
         IF ((IRET.GT.0) .AND. (IRET.LT.5)) GO TO 990
         END IF
C                                       For point model
      MODTYP = 0
      XNCOMP = 0
C                                       check all CC files
      LFR = 0
      DO 10 I = 1,MODMAX
         LFIELD = I
         JNREC = 1
         JLREC = 0
C                                       Make sure this header applies
C                                       to this image
         CALL CATIO ('READ', CCDISK(LFIELD), CCCNO(LFIELD), KLNBL2,
     *      'REST', IBUFF(2049), IRET)
         IF ((IRET.NE.0) .AND. (IRET.LT.5)) THEN
            ERRTXT =  'READ HEADER WITH CATIO'
            GO TO 990
            END IF
C                                       Tabini can update header on disk
         ERRTXT = 'OPENING CLEAN COMPS FILE'
         CALL CCMINI ('READ', CLBUFF, CCDISK(LFIELD), CCCNO(LFIELD),
     *      CCVER(LFIELD), KLNBL2, LUNC, CLRNO, CLKOLS, CLNUMV, JLREC,
     *      IRET)
         IF (IRET.GT.1) GO TO 990
         IF (NCLNG(LFIELD).LE.0) NCLNG(LFIELD) = CLBUFF(5)
         DONE(I) = F
         XNCOMP = XNCOMP + NCLNG(LFIELD)
C                                       More complex models
C                                       Find columns (physical)
         IF (JLREC.GT.4) THEN
C                                       Read 1st record
            CALL TABCCM ('READ', CLBUFF, CLRNO, CLKOLS, CLNUMV, JLREC,
     *         XX, YY, ZZ, FLUX, CLTYPE, PARMS, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1090) IRET, CLRNO
               GO TO 995
               END IF
            IF ((JLREC.EQ.4) .OR. (JLREC.EQ.8)) THEN
               MSGTXT = 'THIS TASK FOR CC FILES WITH NO Z COLUMN'
               IRET = 10
               GO TO 995
               END IF
C                                       Get model type.
            ITYPE = CLTYPE
            IF (LFIELD.EQ.1) MODTYP = ITYPE
            IF (MODTYP.NE.ITYPE) THEN
               IF ((MODTYP.EQ.0) .OR. (ITYPE.EQ.0)) THEN
                  MSGTXT = 'MOD3DV: will treat points as extended'
                  CALL MSGWRT(6)
                  MODTYP = MAX (MODTYP, ITYPE)
               ELSE
                  WRITE (MSGTXT,1000) MODTYP, ITYPE
                  IRET = 8
                  GO TO 995
                  END IF
               END IF
            END IF
C                                       Close CLEAN components file.
         CALL TABCCM ('CLOS', CLBUFF, CLRNO, CLKOLS, CLNUMV, JLREC,
     *      XX, YY, ZZ, FLUX, CLTYPE, PARMS, IRET)
 10      CONTINUE
C                                       Bad model type.
      IF ((MODTYP.NE.0) .AND. (MODTYP.NE.1) .AND. (MODTYP.NE.3)) THEN
         IRET = 8
         WRITE (MSGTXT,1002) MODTYP
         GO TO 995
         END IF
C                                       Tell model type once
      IF (.NOT.ONZE) THEN
         MSGTXT = 'MOD3DV: Model components of type '//MDTYP(MODTYP+1)
         CALL MSGWRT (2)
         ONZE = .NOT. ONZE
         END IF
C                                       Set model length
      LENMOD = LMOD(MODTYP+1)
C                                       If Not single component model.
      DO 150 LFIELD = 1,MODMAX
C                                       Get field info. if nec.
         IF (.NOT.NGRDAT) THEN
            CALL GRDAT (F, LFIELD, CATBLK, IBUFF(2049), IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
C                                       If NGRDAT read CLEAN CATBLK.
         IF (NGRDAT) THEN
            ERRTXT = 'READING CLEAN CATBLK'
            CALL CATIO ('READ', CCDISK(LFIELD), CCCNO(LFIELD),
     *         KLNBLK, 'REST', IBUFF(2049), IRET)
            IF ((IRET.GT.0) .AND. (IRET.LT.5)) GO TO 990
            END IF
C                                       Set field center offsets.
         XXOFF = DXCG(LFIELD) * CCROT + DYCG(LFIELD) * SSROT
         YYOFF = DYCG(LFIELD) * CCROT - DXCG(LFIELD) * SSROT
         ZZOFF = DZCG(LFIELD)
         CALL XYSHFT (RA, DEC, XSHIFT(LFIELD), YSHIFT(LFIELD),
     *      MAPROT, XRA, XDEC)
         IF (DO3DIM) THEN
            CALL PRJMAT (RA, DEC, UVROT, XRA, XDEC, MAPROT, UMAT,
     *         PMAT)
         ELSE
            CALL P2DMAT (RA, DEC, UVROT, XRA, XDEC, MAPROT, UMAT,
     *         PMAT)
            END IF
C                                       Load CLEAN components
C                                       Open components file.
         JNREC = 1
         JLREC = 0
         ERRTXT = 'OPENING CLEAN COMPS FILE'
         CALL CCMINI ('READ', CLBUFF, CCDISK(LFIELD), CCCNO(LFIELD),
     *      CCVER(LFIELD), KLNBL2, LUNC, CLRNO, CLKOLS, CLNUMV, JLREC,
     *      IRET)
         IF (IRET.GT.1) GO TO 990
         JCOMP = 1
C                                       Make sure that there are some
         IF (CLBUFF(5).LE.0) GO TO 140
         IF (NCLNG(LFIELD).LE.0) NCLNG(LFIELD) = CLBUFF(5)
C                                       Loop loading components.
C                                       Check next component
         JCOMP = 1
         DO 110 I = 1,NCLNG(LFIELD)
            CALL TABCCM ('READ', CLBUFF, CLRNO, CLKOLS, CLNUMV, JLREC,
     *         XX, YY, ZZ, FLUX, CLTYPE, PARMS, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1090) IRET, JCOMP
               GO TO 995
               END IF
C                                        Check that point comp.
            JCOMP = JCOMP + 1
            JT = JT + 1
            IF (JLREC.LE.4) THEN
               ITYPE = 0
            ELSE
               ITYPE = CLTYPE
               END IF
            IF ((ITYPE.NE.MODTYP) .AND. (ITYPE.NE.0)) THEN
               WRITE (MSGTXT,1070) LFIELD, JCOMP-1
               CALL MSGWRT (6)
               END IF
            IF (((ITYPE.EQ.MODTYP) .OR. (ITYPE.EQ.0)) .AND.
     *         (IRET.EQ.0)) THEN
C                                       If req. sum flux
               TFLUXG = TFLUXG + FLUX
               CCOUNT = CCOUNT + 1
               XP(1) = (XX + XPOFF(LFIELD)) * CONST
               XP(2) = (YY + YPOFF(LFIELD)) * CONST
               XP(3) = 0.0
               CALL PRJMUL (2, XP, UMAT, XYZ)
               XYZ(1) = (XYZ(1) + XXOFF) / CONST
               XYZ(2) = (XYZ(2) + YYOFF) / CONST
               XYZ(3) = (XYZ(3) + ZZOFF) / CONST
               IF (NCOL.LE.4) THEN
                  CCTYPE = 0
                  CALL RFILL (3, 0.0, PARMS)
               ELSE
                  CCTYPE = ITYPE
                  END IF
               CALL TABCCM ('WRIT', CCBUFF, CCRNO, CCKOLS, CCNUMV, NCOL,
     *               XYZ(1), XYZ(2), XYZ(3), FLUX, CCTYPE, PARMS,
     *            IRET)
               IF (IRET.NE.0) THEN
                  ERRTXT = 'WRITING OUTPUT CC TABLE'
                  GO TO 990
                  END IF
               END IF
 110        CONTINUE
C                                       Close CLEAN components file.
 140     CALL TABCCM ('CLOS', CLBUFF, CLRNO, CLKOLS, CLNUMV, JLREC,
     *      XX, YY, ZZ, FLUX, CLTYPE, PARMS, IRET)
 150     CONTINUE
      CALL TABCCM ('CLOS', CCBUFF, CCRNO, CCKOLS, CCNUMV, NCOL,
     *   XYZ(1), XYZ(2), XYZ(3), FLUX, CCTYPE, PARMS, IRET)
      IF (IRET.NE.0) THEN
         ERRTXT = 'CLOSING OUTPUT CC TABLE'
         GO TO 990
         END IF
C                                       summary
      WRITE (MSGTXT,1150) TFLUXG, CCOUNT
      CALL MSGWRT (4)
      IRET = 0
      GO TO 999
C                                       Error
 990  WRITE(MSGTXT,1990,ERR=999) IRET, ERRTXT
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MOD3DV: MODEL TYPES =',I2,I2,' INCOMPATIBLE')
 1002 FORMAT ('MOD3DV: ILLEGAL MODEL TYPE =',I3)
 1070 FORMAT ('MOD3DV WRONG MODTYP AT FIELD, COMP',I5,I9)
 1090 FORMAT ('MOD3DV: ERROR',I5,' READING CLEAN COMPS REC',I5)
 1150 FORMAT ('MOD3DV found',F9.3,' Jy in',I8,' components')
 1990 FORMAT ('MOD3DV: ERROR',I5,' ',A)
      END

      SUBROUTINE ZROPN2 (FCB, SRVLEN, SRVNAM, HSTLEN, HOSTNM, IRET)
C-----------------------------------------------------------------------
C! request a connection to a server -- generic version
C# IO-remote Z2
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Request a connection to a server.
C   Inputs:
C      FCB         I(*)          File control block.
C      SRVLEN      I             Length of server name including
C                                trailing blanks.
C      SRVNAM      H*(*)         Server name.
C      HSTLEN      I             Length of host name including trailing
C                                blanks.
C      HOSTNM      H*(*)         Host name.
C   Output:
C      IERR        I             Error return status:
C                                   0 => channel opened successfully
C                                   1 => request failed
C   Generic version (stubbed)
C-----------------------------------------------------------------------
      INTEGER   FCB(*), SRVLEN , HSTLEN, IRET
      HOLLERITH SRVNAM(*), HOSTNM(*)
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IRET = 1
      MSGTXT = 'ZROPN2 REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (6)
C
 999  RETURN
      END

      SUBROUTINE ZPUTCH (ICHAR, WORD, NCHAR)
C----------------------------------------------------------------------
C! inserts 8-bit "character" into a word
C# Z Binary
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C----------------------------------------------------------------------
C   Inserts the character contained in the least significant bits of
C   the INTEGER argument ICHAR into the NCHAR position of the HOLLERITH
C   argument WORD.  It should also work for INTEGER WORD as long as
C   NCHAR is valid.  Characters are numbered from 1 in the order in
C   which they would be printed by a Fortran "A" format specifier.
C   Inputs:
C      ICHAR   I   Character to insert in LS bits
C      NCHAR   I   Position in WORD to store character
C   Output:
C      WORD    H   Word into which character is to be inserted
C   Generic version - stub
C----------------------------------------------------------------------
      INTEGER   ICHAR, NCHAR
      HOLLERITH WORD
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      WRITE (6,1000)
      IF (NLUSER.GT.0) STOP 'ZPUTCH missing'
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (' ZPUTCH REQUIRES LOCAL DEVELOPMENT')
      END

      SUBROUTINE RWUPDT (N, R, LDR, W, B, ALPHA, COS, SIN)
C-----------------------------------------------------------------------
C! computes the QR decomposition of an upper triangular matrix + a row
C# Math Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Given an N by N upper triangular matrix R, this subroutine computes
C   the QR decomposition of the matrix formed when a row is added to R.
C   If the row is specified by the vector W, then RWUPDT determines an
C   orthogonal matrix Q such that when the N+1 by N matrix composed of R
C   augmented by W is premultiplied by (Q transpose), the resulting
C   matrix is upper trapezoidal.  The matrix (Q transpose) is the
C   product of N transformations
C
C           G(N)*G(N-1)* ... *G(1)
C
C   where G(I) is a Givens rotation in the (I,N+1) plane which
C   eliminates elements in the (N+1)-st plane. RWUPDT also computes the
C   product (Q transpose)*C where C is the (N+1)-vector (B,ALPHA). Q
C   itself is not accumulated, rather the information to recover the G
C   rotations is supplied.
C   Argonne National Laboratory. Minpack Project. March 1980.
C   Burton S. Garbow, Dudley V. Goetschel, Kenneth E. Hillstrom,
C   Jorge J. More
C   Inputs:
C      N      I       the order of R (adj. array dim.).
C      LDR    I       positive variable not less than N which
C                     specifies the leading dimension of the array R
C                     (adj. array dim.).
C      W      D(N)    contains the row vector to be added to R.
C  In/out:
C      R      D(N,N)  On input the upper triangular part must contain
C                     the matrix to be updated. On output, R contains
C                     the updated triangular matrix.
C      B      D(N)    On input B contains the first N elements
C                     of the vector C. On output B contains the first N
C                     elements of the vector (Q transpose)*C.
C      ALPHA  D       On input ALPHA contains the (n+1)st element
C                     of the vector C. On output ALPHA contains the
C                     The (N+1)-st element of the vector (Q transpose)*C
C   Outputs:
C      COS    D(N)    contains the cosines of the transforming
C                     Givens rotations.
C      SIN    D(N)    contains the sines of the transforming
C                     Givens rotations.
C-----------------------------------------------------------------------
      INTEGER   N, LDR
      DOUBLE PRECISION ALPHA, R(LDR,N), W(N), B(N), COS(N), SIN(N)
C
      INTEGER   I, J, JM1
      DOUBLE PRECISION COTAN, ONE, P5, P25, ROWJ, TAN, TEMP, ZERO
      DATA ONE, P5, P25, ZERO /1.0D0, 5.0D-1, 2.5D-1, 0.0D0/
C-----------------------------------------------------------------------
C
      DO 60 J = 1,N
         ROWJ = W(J)
         JM1 = J - 1
C                                       Apply the previous
C                                       transformations to
C                                       R(I,J), I=1,2,...,J-1,
C                                       and to W(J).
         IF (JM1.GE.1) THEN
            DO 10 I = 1,JM1
               TEMP = COS(I)*R(I,J) + SIN(I)*ROWJ
               ROWJ = -SIN(I)*R(I,J) + COS(I)*ROWJ
               R(I,J) = TEMP
   10          CONTINUE
            END IF
C                                       Determine a Givens rotation
C                                       which eliminates W(J).
         COS(J) = ONE
         SIN(J) = ZERO
         IF (ROWJ.EQ.0) GO TO 60
            IF (ABS(R(J,J)).LT.ABS(ROWJ)) THEN
               COTAN = R(J,J) / ROWJ
               SIN(J) = P5 / SQRT (P25+P25*COTAN**2)
               COS(J) = SIN(J) * COTAN
            ELSE
               TAN = ROWJ / R(J,J)
               COS(J) = P5 / SQRT (P25+P25*TAN**2)
               SIN(J) = COS(J) * TAN
               END IF
C                                       Apply the current transformation
C                                       to R(J,J), B(J), and ALPHA.
            R(J,J) = COS(J)*R(J,J) + SIN(J)*ROWJ
            TEMP = COS(J)*B(J) + SIN(J)*ALPHA
            ALPHA = -SIN(J)*B(J) + COS(J)*ALPHA
            B(J) = TEMP
   60    CONTINUE
C
 999  RETURN
      END

      SUBROUTINE SKYFRM (DPOS, PREFIX, CTYPE, IACC, STRING, ILEN, ITYP)
C-----------------------------------------------------------------------
C! returns string with character representation of a corrdinate
C# Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   SKYFRM will figure out the type (RA, DEC, OTHER) of a sky coordinate
C   and format, zero fill, and interpret the prefix to provide a string
C   representation suitable for printing.
C   Inputs:
C      DPOS    D     coordinate value in degrees.
C      PREFIX  L     T means include prefix in sting, F means no.
C      CTYPE   C*8   axis type
C      IACC    I     accuracy of seconds (types 1 and 2 only). 0
C                    means no decimal fraction. > 0 => # decimal places
C                    for RA (one fewer for DEC)
C   Outputs:
C      STRING  C*80  string containing packed character representation
C                    of the coordinate.
C      ILEN    I     length in characters of STRING.
C      ITYP    I     1 = RA; 2 = DEC; 3 = other.
C-----------------------------------------------------------------------
      DOUBLE PRECISION DPOS
      LOGICAL   PREFIX
      CHARACTER CTYPE*8, STRING*(*)
C
      CHARACTER FORM2*20, SPTXT*20, CTEMP*4, RA(2)*4, DEC(2)*4,
     *   CHSIGN*1
      REAL      SEC, TEMP
      INTEGER   IACC, ILEN, ITYP, HM(3), IACC2, IFLEN, IFLDLN, ITRY,
     *   FRMT
      DATA RA, DEC /'RA  ','RA--', 'DEC ','DEC-'/
C-----------------------------------------------------------------------
C                                       Figure out which coordinate.
      ITYP = 3
      CTEMP = CTYPE(1:4)
      IF ((CTEMP.EQ.RA(1)) .OR. (CTEMP.EQ.RA(2))) ITYP = 1
      IF (CTEMP.EQ.'LL') ITYP = 1
      IF ((CTEMP.EQ.DEC(1)) .OR. (CTEMP.EQ.DEC(2))) ITYP = 2
      IF (CTEMP.EQ.'MM') ITYP = 2
C                                       Generate prefix.
      ILEN = 1
      IF (.NOT.PREFIX) GO TO 20
         ILEN = ITYP + 1
         IF (ITYP.EQ.1) STRING = RA(1)
         IF (ITYP.EQ.2) STRING = DEC(1)
         IF (ITYP.EQ.3) STRING = CTYPE
         IF (ITYP.EQ.3) CALL CHTRIM (STRING, 8, STRING, ILEN)
C                                       Put blank after prefix.
         ILEN = ILEN + 1
         STRING(ILEN:ILEN) = ' '
         ILEN = ILEN + 1
C                                       Convert degrees.
C                                       RA or DEC type.
 20   IF (ITYP.EQ.3) GO TO 40
         CALL COORDD (ITYP, DPOS, CHSIGN, HM, SEC)
C                                       No decimal.
         IACC2 = MIN (IACC + 1 - ITYP, 9)
         IF (IACC2.LE.0) THEN
            HM(3) = SEC + .5
            WRITE (SPTXT,1020) CHSIGN, HM
C                                       Decimal point.
         ELSE
            IFLDLN = IACC2 + 4
            WRITE (FORM2,1025) IFLDLN, IACC2
            IFLDLN = IFLDLN + 6
            WRITE (SPTXT,FORM2) CHSIGN, HM(1), HM(2), SEC
            END IF
         GO TO 50
C                                       Not ra, dec.
 40   CONTINUE
         IFLDLN = 16
         TEMP = DPOS
         ITRY = FRMT (IFLDLN, 4, TEMP, SPTXT)
C                                       Put pieces together.
 50   CALL CHTRIM (SPTXT, IFLDLN, SPTXT, IFLEN)
      STRING(ILEN:ILEN+IFLEN-1) = SPTXT(1:IFLEN)
      ILEN = ILEN + IFLEN - 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT (A1,I2.2,2I3.2)
 1025 FORMAT ('(A1,I2.2,I3.2,F',I2,'.',I1,')')
      END

      SUBROUTINE MASSGN
C-----------------------------------------------------------------------
C! handles array = value(s) constructs
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2007, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MASSGN alters stacks to handle ARRAY = v1,v2,v3,...
C   Commons alterred: K array; SP and TAG in /POPS/ & /SMSTUF/,resp.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   STEMP(100), LHSPTR, LHSDSC, LHSLEN, LHSNEL, RHSDSC,
     *   RHSLEN, RHSNEL, NVALS, REST, SIZE, WORKSP, RHSTAG, III, ITAG,
     *   J, JJJ, POTERR
      REAL      VTEMP(100), RM
      HOLLERITH HM
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DSMS.INC'
      EQUIVALENCE (RM, HM)
      DATA PRGNAM /'MASSGN'/
C-----------------------------------------------------------------------
C                                       Save copies of STACK and V.
      CALL RCOPY (100, V, VTEMP)
      CALL COPY (100, STACK, STEMP)
C                                       NVALS is no. of RHS items.
      POTERR = 8
      IF (SP.LE.0) GO TO 980
      NVALS = STEMP(SP)
      WORKSP = SP - 1
      POTERR = 23
C                                       Work down stack to LHS values.
C                                       Test for RHS type
      DO 20 III = 1,NVALS
         IF (STEMP(WORKSP).EQ.2) WORKSP = WORKSP - 3
         WORKSP = WORKSP - 1
 20      CONTINUE
      IF (WORKSP.LT.4) GO TO 980
C                                       Set LHS values
      SIZE = 0
      LHSPTR = WORKSP - 3
      LHSDSC = STEMP(LHSPTR+1)
      TAG = STEMP(LHSPTR+2)
      POTERR = 25
      IF (TAG.LE.K(KXORG+7-1)) GO TO 980
      LHSNEL = K(LHSDSC)
C                                       Zero stack.
      J = SP - LHSPTR + 1
      CALL FILL (J, 0, STACK(LHSPTR))
C                                       WORKSP = beg of RHS list.
      WORKSP = WORKSP + 1
C                                       Check on LHS data type.
      POTERR = 8
      IF (STEMP(LHSPTR).EQ.2) THEN
C                                       LHS numeric array.
         DO 40 III = 1,NVALS
            POTERR = 23
C                                       RHS item is constant or scalar
            IF ((STEMP(WORKSP).NE.2) .AND. (STEMP(WORKSP).NE.12)) THEN
               IF ((STEMP(WORKSP).LT.16) .AND. (STEMP(WORKSP).GT.0))
     *            GO TO 980
               SIZE = SIZE + 1
               POTERR = 6
               IF (SIZE.GT.LHSNEL) GO TO 980
               C(TAG) = VTEMP(WORKSP)
               WORKSP = WORKSP + 1
               TAG = TAG + 1
C                                       RHS is an array.
            ELSE
               IF (STEMP(WORKSP+3).NE.2) GO TO 980
               RHSDSC = STEMP(WORKSP+1)
               RHSNEL = RHSDSC
               IF (STEMP(WORKSP).EQ.2) RHSNEL = K(RHSNEL)
               SIZE = SIZE + RHSNEL
               POTERR = 6
               IF (SIZE.GT.LHSNEL) GO TO 980
               ITAG = STEMP (WORKSP+2)
               DO 35 J = 1,RHSNEL
                  C(TAG) = C(ITAG)
                  TAG = TAG + 1
                  ITAG = ITAG + 1
 35               CONTINUE
               WORKSP = WORKSP + 4
               END IF
 40         CONTINUE
C                                       Fill rest of array with zero.
         RM = 0.0
         REST = LHSNEL - SIZE
C                                       LHS is an alpha array
      ELSE IF (STEMP(LHSPTR).EQ.7) THEN
         LHSLEN = K(LHSDSC+3)
         IF (LHSLEN.LE.0) GO TO 980
         LHSLEN = (LHSLEN+3) / 4
         LHSNEL = LHSNEL / LHSLEN
         DO 80 III = 1,NVALS
            POTERR = 23
            IF (STEMP(WORKSP+3).NE.2) GO TO 980
            IF (STEMP(WORKSP).EQ.7) GO TO 70
               IF ((STEMP(WORKSP).NE.8) .AND. (STEMP(WORKSP).NE.14)
     *            .AND. (STEMP(WORKSP).NE.9)) GO TO 980
C                                       RHS is holerith or scalar.
               SIZE = SIZE + 1
               POTERR = 6
               IF (SIZE.GT.LHSNEL) GO TO 980
C                                       Put RHS discriptors on stack.
               CALL COPY (4, STEMP(WORKSP), STACK(LHSPTR+4))
C                                       Put LHS discriptors on stack.
               STACK(LHSPTR) = 8
               STACK(LHSPTR+1) = K(LHSDSC+3)
               STACK(LHSPTR+2) = TAG
               STACK(LHSPTR+3) = 2
               SP = LHSPTR + 7
               CALL ASSGN
               IF (ERRNUM.NE.0) GO TO 980
               TAG = TAG + LHSLEN
               WORKSP = WORKSP + 4
               GO TO 80
C                                       RHS is alpha array.
 70         CONTINUE
               RHSDSC = STEMP(WORKSP+1)
               RHSLEN = K(RHSDSC+3)
               IF (RHSLEN.LE.0) GO TO 980
               RHSLEN = (RHSLEN+3) / 4
               RHSNEL = K(RHSDSC) / RHSLEN
               RHSTAG = STEMP(WORKSP+2)
C                                       Set up LHS discriptor.
               STACK(LHSPTR) = 8
               STACK(LHSPTR+1) = K(LHSDSC+3)
               STACK(LHSPTR+3) = 2
C                                       Set up RHS discriptor.
               STACK(LHSPTR+4) = 8
               STACK(LHSPTR+5) = K(RHSDSC+3)
               STACK(LHSPTR+7) = 2
               POTERR = 6
               DO 75 JJJ = 1,RHSNEL
                  SP = LHSPTR + 7
                  SIZE = SIZE + 1
                  IF (SIZE.GT.LHSNEL) GO TO 980
                  STACK(LHSPTR+2) = TAG
                  STACK(LHSPTR+6) = RHSTAG
                  CALL ASSGN
                  TAG = TAG + LHSLEN
                  RHSTAG = RHSTAG + RHSLEN
                  IF (ERRNUM.NE.0) GO TO 980
 75              CONTINUE
               WORKSP = WORKSP + 4
 80         CONTINUE
C                                       Fill in with blanks.
         HM = HBLANK
         REST = (LHSNEL-SIZE) * LHSLEN
C                                       illegal
      ELSE
         GO TO 980
         END IF
C                                       Fill out array
      CALL RFILL (REST, RM, C(TAG))
      SP = LHSPTR - 1
      GO TO 999
C
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
      END

LOCAL INCLUDE 'UVLIN.INC'
C                                               Local include for UVLIN
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4), XCALC(1), XINFIL(12),
     *   XNAMOU(3), XCLAOU(2)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XSUBA, XBIF, XEIF, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER,
     *   XFLAG, XDOBND, XBPVER, XSMOTH(3), XDOAC, XSOUT, XDISO, DOCONT,
     *   RMS, SHIFT(2), XCHNS(4,20), XORD, PRTLEV, XCENT, BADD(10),
     *   BUFF1(UVBFSS), BUFF2(UVBFSS), FINC(MAXIF), DIFPIX
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, JBUFSZ, ILOCWT, LBIF,
     *   CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI,
     *   LRECO, NRPRMI, NRPRMO, FITWTS(MAXCIF), NBDCOR, NORDER, NCHAN,
     *   NIF, NPOLN, NANT, ISBAND(MAXIF), NEWCNO, OLDCNO, VISINC, VISMSG
      LOGICAL   ISCOMP
      CHARACTER NAMEIN*12, CLAIN*6, INFILE*48, NAMOUT*12, CLAOUT*6
      DOUBLE PRECISION FOFF(MAXIF)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XTIME, XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF, XDOCAL, XGUSE,
     *   XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH, XDOAC,
     *   XINFIL, XNAMOU, XCLAOU, XSOUT, XDISO, SHIFT, RMS, DOCONT,
     *   XCHNS, XORD, PRTLEV, XCENT, BADD
      COMMON /CHARPM/ NAMEIN, CLAIN, INFILE, NAMOUT, CLAOUT
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
      COMMON /INFO/ CATOLD, FOFF, ISBAND, FINC, LBIF, SEQIN, SEQOUT,
     *   DISKIN, DISKO, ILOCWT, INCSI, INCFI, INCIFI, INCSO, INCFO,
     *   INCIFO, LRECI, LRECO, NRPRMI, NRPRMO, ISCOMP, NBDCOR, NORDER,
     *   NCHAN, NIF, NPOLN, NANT, NEWCNO, OLDCNO, DIFPIX, VISINC, VISMSG
      COMMON /WEIGHT/ FITWTS
LOCAL END
      PROGRAM UVLIN
C-----------------------------------------------------------------------
C! Fits and optionally removes continuum contribution to the visibility
C# Utility UV UV-util VLA VLB SPECTRAL
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999-2000, 2005, 2008-2012, 2014-2016,
C;  Copyright (C) 2018, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVLIN averages a set of channels and subtracts them from another
C   range of channels.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input UV data.
C      INFILE         INFILE        Disk file containing channel weights
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      SHIFT          SHIFT         shift in arcsec
C      DOCONT         DOCONT        Retain continuum if > 0
C      FLUX           RMS           Max deviation for unity weight
C      NBOX           XNB           Number of boxes
C      BOX            XBOXES        Boxes (start-stop pairs)
C      PRTLEV         PRTLEV        > 0 => write flagging info to the
C                                   message file
C   Programmers: J.M. Uson and T.J. Cornwell (with help from R. Braun).
C      J. M. Uson (7/1/93) (cleanup, report info for VLA)
C      EWG overhauled all the vla-specific junk
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INCLUDE 'UVLIN.INC'
      INTEGER   MALL(2), MBAD(2), MCHAN(2), NWORDS, IRET, I
      LONGINT   OFFALL, OFFBAD, OFFCHN
C     INTEGER   MALL(MAXANT,MAXANT,4*MAXIF), MCHAN(4*MAXCIF),
C    *   MBAD(MAXANT,MAXANT,4*MAXIF)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'UVLIN '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL UVLIIN (PRGM, IRET)
C                                       Allocate memory
      NWORDS = (NANT * NANT * NPOLN * NIF - 1) / 1024 + 1
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, MALL, OFFALL,
     *   IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, MBAD, OFFBAD,
     *   IRET)
      IF (IRET.EQ.0) THEN
         NWORDS = 1024 * NWORDS
         CALL FILL (NWORDS, 0, MALL(1+OFFALL))
         CALL FILL (NWORDS, 0, MBAD(1+OFFBAD))
         END IF
      NWORDS = (NPOLN * NCHAN * NIF - 1) / 1024 + 1
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, MCHAN, OFFCHN,
     *   IRET)
      IF (IRET.EQ.0) CALL FILL (1024*NWORDS, 0, MCHAN(1+OFFCHN))
C                                       Filter data.
      IF (IRET.EQ.0) CALL UVLIUV (NANT, NPOLN, NCHAN, NIF,
     *   MALL(1+OFFALL), MBAD(1+OFFBAD), MCHAN(1+OFFCHN), IRET)
C                                       Write history
      IF (IRET.EQ.0) CALL UVLIHI
C                                       report results
      IF ((IRET.EQ.0) .AND. (PRTLEV.GT.0)) CALL REPORT (NANT, NPOLN,
     *   NCHAN, NIF, MALL(1+OFFALL), MBAD(1+OFFBAD), MCHAN(1+OFFCHN))
C                                       Close down files, etc.
      CALL ZMEMRY ('FRAL', TSKNAM, NWORDS, MCHAN, OFFCHN, I)
C
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE UVLIIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   UVLIIN gets input parameters for UVLIN and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      ISCOMP  L  If true data is compressed
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C-----------------------------------------------------------------------
      CHARACTER PRGN*6, STAT*4, BLANK*6, PTYPE*2, LINE*80
      INTEGER   IROUND, NPARM, IERR, INCX, I, TLUN, TFIND, JERR, LUN,
     *   FITCH, FITWT, FITWTT, NDX, J, MPR, IOFF, NVER, JJ, NUMAN(513),
     *   JT, JTRIM
      DOUBLE PRECISION DP, CATD(128)
      LOGICAL   T, MATCH
      REAL      RPARM(20), CATR(256)
      HOLLERITH CATH(256)
      INCLUDE 'UVLIN.INC'
      INTEGER   CHNSEL(3,20,MAXIF), NW(MAXIF), K, K1, K2
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATH, CATR, CATD)
      DATA BLANK  /'      '/
      DATA T /.TRUE./
      DATA TLUN /10/
      DATA MPR /4/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 155
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1010) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (16, 1, XSOUR, SOURCS(1))
      SELQUA = IROUND (XQUAL)
      CALL H2CHR (48, 1, XINFIL, INFILE)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
      NORDER = XORD + 0.1
      NORDER = MAX (0, MIN (1, NORDER))
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = XDOAC.GT.0.0
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      VISINC = CATBLK(KIGCN) / 20
      VISMSG = CATBLK(KIGCN) / 10
      VISINC = MAX (10000, MIN (50000,VISINC))
      VISMSG = (VISMSG / VISINC) * VISINC
      IF (VISMSG.LT.VISINC) VISMSG = 100 * VISINC
C                                       Save input file info
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NIF = EIF - BIF + 1
      LBIF = BIF
      NCHAN = CATBLK(KINAX+JLOCF)
      NPOLN = CATBLK(KINAX+JLOCS)
C                                       Max antenna number
      NANT = MAXANT
      CALL FNDEXT ('AN', CATBLK, NVER)
      IF (NVER.GT.0) THEN
         LUN = 27
         CALL GETNAN (DISKIN, OLDCNO, CATBLK, LUN, BUFF1, NUMAN, JERR)
         IF ((NVER.GT.0) .AND. (JERR.EQ.0)) THEN
            JJ = NUMAN(1)
            NANT = 0
            DO 37 J = 1,JJ
               NANT = MAX (NANT, NUMAN(J+1))
 37            CONTINUE
            END IF
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       get freq info
      I = 1
      CALL CHNDAT ('READ', BUFF1, DISKIN, OLDCNO, I, CATBLK, LUN, K,
     *   FOFF, ISBAND, FINC, BNDCOD, FRQSEL, JERR)
      IF (JERR.GT.0) THEN
         MSGTXT = 'ERROR READING FQ FILE'
         GO TO 990
         END IF
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, BUFF1, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, BUFF1, IERR)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
      NRPRMI = NRPARM
C                                       center frequencies
      IF (JLOCF.LT.0) XCENT = -1.
      IF (XCENT.GT.0.0) THEN
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
      ELSE
         DIFPIX = 0.0
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       read compressed => write compr.
      IF (ISCOMP) THEN
         CATBLK(KINAX) = 1
         I = CATBLK(KIPCN)
         CALL CHR2H (8, 'WEIGHT  ', 1, CATH(KHPTP+2*I))
         CALL CHR2H (8, 'SCALE   ', 1, CATH(KHPTP+2*I+2))
         CATBLK(KIPCN) = I + 2
         ILOCWT = I
         END IF
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1040) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file, do
C                                       not destroy existing otherwise
         IF ((CCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1050)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1060) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
      NEWCNO = CCNO
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                       copy header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, PTYPE,
     *   NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                        Get and report parameters
      WRITE (MSGTXT,1070) NAMEIN, CLAIN
      CALL MSGWRT (MPR)
      I = NCHAN * NIF
C                                       Get channel weights
      CALL FILL (I, 0, FITWTS)
      CALL FILL (MAXIF, 0, NW)
      IF (INFILE.EQ.' ') THEN
         MSGTXT = 'No name given for weight file, using ICHANSEL'
         CALL MSGWRT (MPR)
         I = 60 * MAXIF
         CALL FILL (I, 0, CHNSEL)
         DO 90 J = 1,20
            K = IROUND (XCHNS(2,J))
            IF (K.LE.0) GO TO 100
            K = IROUND (XCHNS(4,J))
            IF ((K.LE.0) .OR. (K.GT.NIF)) THEN
               K1 = 1
               K2 = NIF
            ELSE
               K1 = K
               K2 = K
               END IF
            DO 80 K = K1,K2
               NW(K) = NW(K) + 1
               CHNSEL(1,NW(K),K) = MAX (0, IROUND (XCHNS(1,J)))
               CHNSEL(2,NW(K),K) = MAX (0, IROUND (XCHNS(2,J)))
               CHNSEL(3,NW(K),K) = MAX (1, IROUND (XCHNS(3,J)))
 80            CONTINUE
 90         CONTINUE
C                                       If no channel selection
C                                       use 1 - NCHAN
 100     DO 130 K = 1,NIF
            IOFF = (K - 1) * NCHAN
            IF (NW(K).LE.0) THEN
               NW(K) = 1
               CHNSEL(1,1,K) = 1
               CHNSEL(2,1,K) = NCHAN
               CHNSEL(3,1,K) = 1
               END IF
            DO 120 I = 1,NW(K)
               CHNSEL(1,I,K) = MAX (1, MIN (CHNSEL(1,I,K), NCHAN))
               IF (CHNSEL(2,I,K).LT.CHNSEL(1,I,K)) CHNSEL(2,I,K) = NCHAN
               CHNSEL(2,I,K) = MAX (1, MIN (CHNSEL(2,I,K), NCHAN))
               DO 110 J = CHNSEL(1,I,K),CHNSEL(2,I,K),CHNSEL(3,I,K)
                  FITWTS(J+IOFF) = 1
 110              CONTINUE
 120           CONTINUE
 130        CONTINUE
      ELSE
         WRITE (MSGTXT,1110) INFILE
         CALL MSGWRT (MPR)
         CALL ZTXOPN ('READ', TLUN, TFIND, INFILE, .FALSE., IERR)
         IF (IERR.NE.0) GO TO 700
         FITWTT = 0
 200     CONTINUE
            CALL ZTXIO ('READ', TLUN, TFIND, LINE, IERR)
            IF (IERR.EQ.2) GO TO 220
            IF (IERR.NE.0) GO TO 800
            JT = JTRIM (LINE)
            NDX = 1
            CALL GETNUM (LINE, 80, NDX, DP)
            IF (DP.EQ.DBLANK) GO TO 975
            FITCH = NINT (DP)
            CALL GETNUM (LINE, 80, NDX, DP)
            IF (DP.EQ.DBLANK) GO TO 975
            K = NINT (DP)
            CALL GETNUM (LINE, 80, NDX, DP)
            IF (DP.EQ.DBLANK) GO TO 975
            FITWT = NINT (DP)
            FITWT = MAX (FITWT, 0)
            IF (K.LE.0) THEN
               K1 = 1
               K2 = NIF
            ELSE
               K1 = K
               K2 = K
               END IF
            DO 210 K = K1,K2
               NW(K) = NW(K) + 1
               FITWTS(FITCH+(K-1)*NCHAN) = FITWT
 210           CONTINUE
            GO TO 200
 220     CALL ZTXCLS (TLUN, TFIND, IERR)
         DO 225 K = 1,NIF
            IF (NW(K).LE.0) CALL FILL (NCHAN, 1, FITWTS(1+(K-1)*NCHAN))
 225        CONTINUE
         END IF
C
      IF (RMS.LE.0.0) RMS = 1.0E20
      WRITE (MSGTXT, 1220) RMS
      CALL MSGWRT (4)
C
      IF (DOCONT.GT.0.0) THEN
         MSGTXT = 'Writing data with continuum retained'
      ELSE
         MSGTXT = 'Writing data with best continuum fit subtracted'
         END IF
      CALL MSGWRT (4)
C
      WRITE (MSGTXT,1240) SHIFT(1), SHIFT(2)
      CALL MSGWRT (4)
C                                       Report on weights used
      IF (PRTLEV.GT.1.5) THEN
         DO 270 K = 1,NIF
            IOFF = (K-1)*NCHAN
            DO 260 I = 1,NCHAN,20
               K1 = I
               K2 = MIN (I+19, NCHAN)
               WRITE (MSGTXT,1250) K, I, (FITWTS(J+IOFF),J = K1,K2)
               CALL MSGWRT (MPR)
 260           CONTINUE
 270        CONTINUE
         END IF
      GO TO 999
C                                       Did not find file with weights
 700  WRITE (MSGTXT,1700) INFILE
      GO TO 990
C                                       Error reading file with weights
 800  WRITE (MSGTXT,1800) INFILE
      GO TO 990
 975  MSGTXT = 'ERROR PARSING LINE ' // LINE(:61)
      JERR = 1
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('UVLIIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1020 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1030 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1035 FORMAT ('This program can only handle', I5, ' channels, sorry')
 1040 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1050 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1060 FORMAT ('UVLIIN: ERROR',I3,' UPDATING NEW CATBLK')
 1070 FORMAT ('UV input file: ',A16,'.',A6)
 1110 FORMAT ('Reading weights file: ',A48)
 1220 FORMAT ('Flagging threshold for unit weight = ',1PE12.3,' Jy')
 1240 FORMAT ('Continuum SHIFT =',F11.2,2X,F11.2,' arcsec')
 1250 FORMAT ('Weights (',I3,'/',I5,') ',20I2)
 1700 FORMAT ('Could not open weights file:', A48)
 1800 FORMAT ('Error reading weights file:', A48)
      END
      SUBROUTINE UVLIUV (NA, NP, NC, NI, MALL, MBAD, MCHAN, IRET)
C-----------------------------------------------------------------------
C   UVLIUV sends uv data one point at a time to the filtering
C   routine and then writes the modified data if requested.
C   Inputs:
C      NA      I      Number of antennas
C      NP      I      Number of polarizations
C      NC      I      Number of channels
C      NI      I      Number of IFs
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true, data is compressed
C   Output:
C      MALL    I(*)   Counts samples by baseline etc
C      MBAD    I(*)   Counts full bad spectra by baseline
C      MCHAN   I(*)   Counts flags by channel
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NA, NP, NC, NI, MALL(NA,NA,NP,NI), MBAD(NA,NA,NP,NI),
     *   MCHAN(NP,NC,NI), IRET
C
      CHARACTER OFILE*48
      INTEGER   IPTRI, IPTRO, LUNO, INDO, ILENBU, KBIND, NIOUT, NIOLIM,
     *   IA1, IA2, BO, VO, NUMVIS, XCOUNT, NCORO, NCOPY, CATMP(256),
     *   RNXRET
      LOGICAL   T, F
      INCLUDE 'UVLIN.INC'
      REAL      VIS(UVBFSS), RESULT(UVBFSS), RPARM(20)
      DOUBLE PRECISION UVSCAL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (BUFF1, VIS)
      DATA LUNO /17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Number of visibilities in input
C                                       and output files.
      NCORO = (LRECO - NRPRMO)
      IF (.NOT.ISCOMP) NCORO = NCORO / 3
      NCOPY = LRECO - NRPRMO
C                                       Open and init for read
C                                       defend cat header from UVGET
      CALL COPY (256, CATBLK, CATMP)
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL COPY (256, CATMP, CATBLK)
      CALL UVPGET (IRET)
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
      NUMVIS = 0
      XCOUNT = 0
      IF ((FREQ.GT.0.0D0) .AND. (UVFREQ.GT.0.0D0)) THEN
         UVSCAL = FREQ / UVFREQ
      ELSE
         UVSCAL = 1.0D0
         END IF
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over
      ELSE IF (IRET.EQ.0) THEN
         IF (ILOCB.GE.0) THEN
            IA2 = BUFF1(IPTRI+ILOCB) + 0.1
            IA1 = IA2 / 256
            IA2 = IA2 - IA1*256
         ELSE
            IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
            IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
            END IF
         NUMVIS = NUMVIS + 1
C                                      Call filtering routine.
         CALL UVLINF (NUMVIS, RPARM(1+ILOCU), RPARM(1+ILOCV),
     *      RPARM(1+ILOCW), IA1, IA2, NA, NP, NC, NI, MALL, MBAD, MCHAN,
     *      VIS, RESULT, IRET)
C                                       Branch upon return of UVLINF
C                                       Error (fatal)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
C                                       Copy to output.
         ELSE IF (IRET.EQ.0) THEN
            XCOUNT = XCOUNT + 1.0D0
            CALL RNXUPD (RPARM, RNXRET)
            RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
            RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
            RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
            CALL RCOPY (NRPRMI, RPARM, BUFF2(IPTRO))
C                                       Compressed
            IF (ISCOMP) THEN
               CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *            BUFF2(IPTRO+NRPRMO))
            ELSE
               CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
               END IF
            IPTRO = IPTRO + LRECO
            NIOUT = NIOUT + 1
            END IF
C                                       Write vis record.
         IF (NIOUT.GE.NIOLIM) THEN
            CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1150) IRET
               GO TO 990
               END IF
            IPTRO = KBIND
            NIOUT = 0
            END IF
C                                       Read next buffer.
         GO TO 100
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       close NX table
      CALL RNXCLS (RNXRET)
C                                       Close files
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVLIUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1010 FORMAT ('UVLIUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('UVLIUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1100 FORMAT ('UVLIUV: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('UVLIUV: UVBASE ERROR',I3)
 1150 FORMAT ('UVLIUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE REPORT (NA, NP, NC, NI, MALL, MBAD, MCHAN)
C-----------------------------------------------------------------------
C   Print the reports
C   Inputs:
C      NA      I      Number of antennas
C      NP      I      Number of polarizations
C      NC      I      Number of channels
C      NI      I      Number of IFs
C      MALL    I(*)   Counts samples by baseline etc
C      MBAD    I(*)   Counts full bad spectra by baseline
C      MCHAN   I(*)   Counts flags by channel
C-----------------------------------------------------------------------
      INTEGER   NA, NP, NC, NI, MALL(NA,NA,NP,NI), MBAD(NA,NA,NP,NI),
     *   MCHAN(NP,NC,NI)
C
      INTEGER   I, J, K, L, TOTALA, TOTALB, MMAX, MXA, I1, I2, MPR
      INCLUDE 'UVLIN.INC'
      INCLUDE 'INCS:DSEL.INC'
      INTEGER   MAUX(MAXANT)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA MPR /4/
C-----------------------------------------------------------------------
      DO 90 L = 1,NI
         DO 80 K = 1,NP
C                                       First add the totals
            TOTALA = 0
            TOTALB = 0
            MMAX = 0
            DO 20 I = 1,NA
               DO 10 J = 1,NA
                  IF (MALL(I,J,K,L).GT.0) THEN
                     MXA = MAX (MXA, I)
                     MXA = MAX (MXA, J)
                     TOTALA = TOTALA + MALL(I,J,K,L)
                     IF (MALL(I,J,K,L).GT.MMAX) MMAX = MALL(I,J,K,L)
                     END IF
                  TOTALB = TOTALB + MBAD(I,J,K,L)
 10               CONTINUE
 20            CONTINUE
C                                       Now report on all visibilities
            IF (TOTALA.GT.0) THEN
               WRITE (MSGTXT,1020) TOTALB, TOTALA, K, L
               CALL MSGWRT (MPR)
               WRITE (MSGTXT,1021) MMAX
               CALL MSGWRT (MPR)
               I1 = 1
 25            I2 = MIN (I1+27, MXA)
               IF (I2.GE.I1) THEN
                  WRITE (MSGTXT,1025) (J, J = I1,I2)
                  CALL MSGWRT (MPR)
                  DO 35 I= 1,MXA
                     DO 30 J= I1,I2
                        MAUX(J) = NINT ((10. * MALL(I,J,K,L)) / MMAX)
 30                     CONTINUE
                     WRITE (MSGTXT,1030) I, (MAUX(J), J = I1,I2)
                     CALL MSGWRT (MPR)
 35                  CONTINUE
                  I1 = I2 + 1
                  GO TO 25
                  END IF
C                                       Now report percentage flagged
               MSGTXT = 'Visibilities flagged (percent):'
               CALL MSGWRT (MPR)
               I1 = 1
 40            I2 = MIN (I1+27, MXA)
               IF (I2.GE.I1) THEN
                  WRITE (MSGTXT,1025) (J, J = I1,I2)
                  CALL MSGWRT (MPR)
                  DO 50 I = 1,MXA
                     DO 45 J = I1,I2
                        MAUX(J) = 0
                        IF (MALL(I,J,K,L).GT.0) THEN
                           MAUX(J) = NINT ((100. * MBAD(I,J,K,L)) /
     *                        MALL(I,J,K,L))
                        ELSE
                           MAUX(J) = 0
                           END IF
 45                     CONTINUE
                     WRITE (MSGTXT,1030) I, (MAUX(J), J = I1,I2)
                     CALL MSGWRT (MPR)
 50                  CONTINUE
                  I1 = I2 + 1
                  GO TO 40
                  END IF
C                                       Now report on channel triggers
               IF (PRTLEV.GT.1.5) THEN
                  DO 60 I = 1,NCHAN
                     IF (MCHAN(K,I,L).GT.0) THEN
                        WRITE (MSGTXT,1050) I, MCHAN(K,I,L)
                        CALL MSGWRT (MPR)
                        END IF
 60                  CONTINUE
                  END IF
               END IF
 80         CONTINUE
 90      CONTINUE
C                                       Report total of flagged corrs.
      WRITE (MSGTXT,1090) NBDCOR
      CALL MSGWRT (MPR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('Flagged ',I8,' of',I8,' correlators for corr IF',I2,I3)
 1021 FORMAT ('Visibilities per baseline (tens of percent of ',I8,'):')
 1025 FORMAT (7X,28(I2))
 1030 FORMAT ('Ant',I3,1X,28(I2))
 1050 FORMAT ('Channel:',I4,'; ',I8,' flags')
 1090 FORMAT ('Flagged ',I8,' correlators')
      END
      SUBROUTINE UVLIHI
C-----------------------------------------------------------------------
C   UVLIHI copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72
      INTEGER   LUN1, LUN2, IERR, I, J, K, K1, K2
      LOGICAL   T
      INCLUDE 'UVLIN.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
C                                       calibration adverbs
      CALL CALHIS (LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       INFILE
      IF (INFILE.NE.' ') THEN
         WRITE (HILINE,1010) TSKNAM, INFILE
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       Weights used
      DO 30 K = 1,NIF
         DO 25 I = 1,NCHAN,20
            K1 = I
            K2 = MIN (I+19, NCHAN)
            WRITE (HILINE,1020) TSKNAM, K, I, (FITWTS(J),J = K1,K2)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
 25         CONTINUE
 30      CONTINUE
C                                       Threshold
      WRITE (HILINE,1030) TSKNAM, RMS
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C
      IF (DOCONT.LE.0) THEN
         WRITE (HILINE,1040) TSKNAM
      ELSE
         WRITE (HILINE,1041) TSKNAM
         END IF
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Number flagged correlators
      WRITE (HILINE,1050) TSKNAM, NBDCOR
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       SHIFT
      WRITE (HILINE,1060) TSKNAM, SHIFT(1), SHIFT(2)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       ORDER
      WRITE (HILINE,1065) TSKNAM, NORDER
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                       Copy tables
      CALL COPTAB (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'UVLIHI: ERROR COPYING TABLES TO OUTPUT'
         CALL MSGWRT (6)
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (DISKO, NEWCNO, DIFPIX, BUFF2(1025), BUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'UVLIHI: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                       Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVLIHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,'/ Weights from: ',A48)
 1020 FORMAT (A6,'/ Weights (',I3,'/',I5,') ',20I2)
 1030 FORMAT (A6,'/ Flagging threshold for unit weight = ',F8.2,' Jy')
 1040 FORMAT (A6,'/ Best continuum subtracted')
 1041 FORMAT (A6,'/ Kept continuum')
 1050 FORMAT (A6,'/ Correlators flagged:', I8)
 1060 FORMAT (A6,'/ Continuum SHIFT =',F11.2,2X,F11.2,' arcsec')
 1065 FORMAT (A6,'ORDER =',I3,10X,'/ order of polynomial fit')
      END
      SUBROUTINE UVLINF (NUMVIS, U, V, W, IA1, IA2, NA, NP, NC, NI,
     *   MALL, MBAD, MCHAN, VIS, RESULT, IRET)
C-----------------------------------------------------------------------
C   Routine to fit straight line to chosen channels and subtract.
C   *** IT FITS TO REAL AND IMAGINARY COMPONENTS ***
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      U       R    U in wavelengths
C      V       R    V in wavelengths
C      W       R    W in wavelengths
C      IA1     I    First antenna number
C      IA2     I    Second antenna number
C      NA      I      Number of antennas
C      NP      I      Number of polarizations
C      NC      I      Number of channels
C      NI      I      Number of IFs
C      VIS     R(3,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C   Inputs from COMMON:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      FITWT   I(MAXCHA)  Weights for fitting
C   Output:
C      MALL    I(*)   Counts samples by baseline etc
C      MBAD    I(*)   Counts full bad spectra by baseline
C      MCHAN   I(*)   Counts flags by channel
C      RESULT  R(3,*) Output visibilities selected in frequency.
C      IRET    I  Return code  -1 => don't write
C                               0 => OK
C                              >0 => error, terminate.
C   Output in COMMON:
C      CATBLK    I         Catalog header block
C   Auxiliary variables for info (VLA only, change dimensions for other)
C      MALL     I         28 by 28 by 8 matrix for all visibilities
C      MBAD     I         28 by 28 by 8 matrix for bad visibilities
C      MCHAN    I         512 by 8 matrix to keep track of flag triggers
C
C-----------------------------------------------------------------------
      INCLUDE 'UVLIN.INC'
      INTEGER   NUMVIS, IA1, IA2, NA, NP, NC, NI, MALL(NA,NA,NP,NI),
     *   MBAD(NA,NA,NP,NI), MCHAN(NP,NC,NI), IRET
      REAL      U, V, W, VIS(3,*), RESULT(3,*)
C
      INTEGER   LOOP, INDEX, OFF, IS, IIF, FITNUM, IOFF
      REAL      AVGR, AVGI, AMPLIT, XX, CATR(256), FITRE(MAXCHA),
     *   FITIM(MAXCHA), FITCHA(MAXCHA), AR, BR, AI, BI
      COMPLEX   ZZ, VS
      DOUBLE PRECISION RA0, DEC0, RFREQ, DFREQ, CFREQ, TRUEF, DXC, DYC,
     *   DZC
      LOGICAL   T, F, ALLBAD, RESCON, GOODDT, DOSHIF, REPORT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (CATR, CATBLK)
      SAVE RFREQ, DXC, DYC, DZC, REPORT, RESCON, DOSHIF
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Set up on first call
      IF (NUMVIS.EQ.1) THEN
         REPORT = F
         NBDCOR = 0
         RESCON = DOCONT.GT.0.0
         RFREQ = CATR(KRCRP+JLOCF)
         DOSHIF = (ABS(SHIFT(1)).GT.1E-6) .OR.
     *            (ABS(SHIFT(2)).GT.1E-6)
         RA0 = RA
         DEC0 = DEC
         IF (COS(DG2RAD*DEC0).NE.0.0D0) RA = RA0 + SHIFT(1) / 3600.D0
     *      / COS(DG2RAD * DEC0)
         DEC = DEC + SHIFT(2) / 3600.D0
         DXC = SIN (DG2RAD * (RA-RA0)) * COS (DEC * DG2RAD)
         DYC = COS (DEC0 * DG2RAD) * SIN (DEC * DG2RAD) -
     *      SIN (DEC0 * DG2RAD) * COS (DEC * DG2RAD) *
     *      COS ((RA - RA0) * DG2RAD)
         DZC = SIN (DG2RAD * DEC0) * SIN (DG2RAD * DEC) +
     *      COS (DG2RAD * DEC0) * COS (DG2RAD * DEC) *
     *      COS (DG2RAD * (RA - RA0)) - 1.0D0
         DXC = TWOPI * DXC
         DYC = TWOPI * DYC
         DZC = TWOPI * DZC
C                                        if PRTLEV>0
         IF (PRTLEV.GT.0.) THEN
            REPORT = T
            END IF
         END IF
C                                       End if first vis
      IRET = 0
      IF (NUMVIS.GT.0) THEN
         IF (MOD(NUMVIS-1,VISMSG).EQ.0) THEN
            WRITE (MSGTXT,1000) NUMVIS
            CALL MSGWRT (2)
         ELSE IF (MOD(NUMVIS-1,VISINC).EQ.0) THEN
            WRITE (MSGTXT,1000) NUMVIS
            CALL MSGWRT (1)
            END IF
C                                       Loop over IF
         DO 400 IIF = 1,NIF
            IOFF = (IIF - 1) * NCHAN
            TRUEF = 1.0D0 + FOFF(IIF+LBIF-1) / UVFREQ
            DFREQ = FINC(IIF+LBIF-1) / UVFREQ
C                                       Loop over Stokes
            DO 350 IS = 1,NPOLN
               ALLBAD = F
               GOODDT = T
C                                       Offset in Stokes and IF
               OFF = (IS - 1) * INCSI + (IIF - 1) * INCIFI
C
               IF (DOSHIF) THEN
                  INDEX = OFF + 1
                  DO 60 LOOP = 1, NCHAN
                     CFREQ = TRUEF + DFREQ * (LOOP - RFREQ)
                     XX = (U*DXC + V*DYC + W*DZC) * CFREQ
                     ZZ = CMPLX (COS(XX), -SIN(XX))
                     VS = CMPLX (VIS(1,INDEX), VIS(2,INDEX)) * ZZ
                     VIS(1,INDEX) = REAL(VS)
                     VIS(2,INDEX) = AIMAG(VS)
                     INDEX = INDEX + INCFI
 60                  CONTINUE
                  END IF
C                                       Index for this channel, IF
               INDEX = OFF + 1
C                                       Get arrays for line fitting
               FITNUM = 0
               DO 100 LOOP = 1,NCHAN
                  IF (VIS(3,INDEX).GT.0.0) THEN
                      IF (FITWTS(LOOP+IOFF).GT.0) THEN
                          FITNUM = FITNUM + 1
                          FITRE(FITNUM) = VIS(1,INDEX)
                          FITIM(FITNUM) = VIS(2,INDEX)
                          FITCHA(FITNUM) = LOOP
                          END IF
                      END IF
                  INDEX = INDEX + INCFI
 100              CONTINUE
C                                       Check that some data are ok
            IF (FITNUM.GT.0) THEN
               CALL LINFIT (NORDER, FITCHA, FITRE, FITNUM, AR, BR)
               CALL LINFIT (NORDER, FITCHA, FITIM, FITNUM, AI, BI)
            ELSE
               AR = 0.0
               BR = 0.0
               AI = 0.0
               BI = 0.0
               GOODDT = F
               END IF
C                                       Now subtract from data
C                                       Actual offset in Stokes and IF
               INDEX = OFF + 1
      INCLUDE 'INCS:ZVND.INC'
               DO 200 LOOP = 1,NCHAN
C                                       Get interpolated value (re, im)
                  AVGR = AR + BR * LOOP
                  AVGI = AI + BI * LOOP
C                                       Subtract from vis.
                  RESULT(1,INDEX) = VIS(1,INDEX) - AVGR
                  RESULT(2,INDEX) = VIS(2,INDEX) - AVGI
                  AMPLIT = RESULT(1,INDEX)**2 + RESULT(2,INDEX)**2
C                                       Scale residual-squared by
C                                       integration time, take sq. root
                  AMPLIT = SQRT ( AMPLIT * ABS (VIS(3,INDEX) ) )
C                                       Do check if this is a test chan.
                  IF ((FITWTS(LOOP+IOFF).EQ.1).AND. (AMPLIT.GT.RMS))
     *               THEN
                     ALLBAD = T
C                                       Accumulate for statistics
C                                       if report wanted
                     IF (REPORT) MCHAN(IS,LOOP,IIF) = MCHAN(IS,LOOP,IIF)
     *                  + 1
                     END IF
C                                       Make output with or without
C                                       continuum
                  IF (RESCON) THEN
                     RESULT(1,INDEX) = VIS(1,INDEX)
                     RESULT(2,INDEX) = VIS(2,INDEX)
                     END IF
C                                       Copy original weight
                  RESULT(3,INDEX) = VIS(3,INDEX)
                  INDEX = INDEX + INCFI
 200              CONTINUE
C                                       If reporting, increase
C                                       corresponding counter
               IF (GOODDT.AND.REPORT) MALL(IA1,IA2,IS,IIF) =
     *            MALL(IA1,IA2,IS,IIF) + 1
C                                       Now flag everything if needed
               IF (ALLBAD)  THEN
                  INDEX = OFF + 1
                  DO 250 LOOP = 1,NCHAN
                     IF (RESULT(3,INDEX).GT.0) RESULT(3,INDEX) =
     *                  -RESULT(3,INDEX)
                     INDEX = INDEX + INCFI
250                  CONTINUE
C                                       Increase corresponding counters
                  IF (GOODDT) THEN
                     NBDCOR = NBDCOR + 1
                     IF (REPORT) MBAD(IA1,IA2,IS,IIF) =
     *                  MBAD(IA1,IA2,IS,IIF) + 1
                     END IF
                  END IF
C                                       Shift back if needed
               IF (DOSHIF) THEN
                  INDEX = OFF + 1
                  DO 300 LOOP = 1,NCHAN
                     CFREQ = TRUEF + DFREQ * (LOOP - RFREQ)
                     XX = (U*DXC + V*DYC + W*DZC) * CFREQ
                     ZZ = CMPLX (COS(XX), SIN(XX))
                     VS = CMPLX (RESULT(1,INDEX), RESULT(2,INDEX)) * ZZ
                     RESULT(1,INDEX) = REAL(VS)
                     RESULT(2,INDEX) = AIMAG(VS)
                     INDEX = INDEX + INCFI
 300                 CONTINUE
                  END IF
 350           CONTINUE
 400        CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Working on visibility record ', I8)
      END
      SUBROUTINE LINFIT (N, X, Y, NDATA, A, B)
C-----------------------------------------------------------------------
C     Routine to fit straight line
C-----------------------------------------------------------------------
      DOUBLE PRECISION SX, SY, SXY, SYY, SXX
      INTEGER   N, NDATA, I
      REAL      X(*), Y(*), A, B, DELTA
C-----------------------------------------------------------------------
      SX = 0.D0
      SY = 0.D0
      SXX = 0.D0
      SXY = 0.D0
      SYY = 0.D0
      DO 100 I = 1,NDATA
         SY = SY + Y(I)
         IF (N.GT.0) THEN
            SX = SX + X(I)
            SXX = SXX + X(I) * X(I)
            SXY = SXY + X(I) * Y(I)
            SYY = SYY + Y(I) * Y(I)
            END IF
 100     CONTINUE
      A = 0.0
      B = 0.0
      IF ((NDATA.GE.2) .AND. (N.GT.0)) THEN
         DELTA = NDATA * SXX - SX * SX
         IF (DELTA.GT.0) THEN
            A = ( SXX * SY - SX * SXY ) / DELTA
            B = ( SXY * NDATA - SX * SY ) / DELTA
            END IF
      ELSE IF ((NDATA.GE.1) .AND. (N.EQ.0)) THEN
         A = SY / NDATA
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'RESOU.INC'
C                                       Local include for RESOU
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      REAL      XSIN, XDISIN, XSOUT, XDISO, FPARM(30), RPARM(30)
      REAL       BUFF1(UVBFSS), BUFF2(UVBFSS)
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, JBUFSZ, ILOCWT,
     *   CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI,
     *   LRECO, NRPRMI, NRPRMO, OLDCNO, NEWCNO, NUMSOU, INSOU(30),
     *   OUSOU(30)
      LOGICAL   ISCOMP
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XCLAOU,
     *   XSOUT, XDISO, FPARM, RPARM
      COMMON /TPARMS/ CATOLD, SEQIN, SEQOUT, DISKIN, DISKO, ILOCWT,
     *   INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI, LRECO,
     *   NRPRMI, NRPRMO, ISCOMP, OLDCNO, NEWCNO, NUMSOU, INSOU,
     *   OUSOU
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
C                                       End local include for RESOU
LOCAL END
      PROGRAM RESOU
C-----------------------------------------------------------------------
C! Renumbers sources
C# Utility UV UV-util VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   RESOU copies a data set renumbering sources
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      FPARM(30)      INSOU         Input source numbers
C      RPARM(30)      OUSOU         Output source numbers
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'RESOU.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'RESOU '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL RESOIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL RESOUV (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL RESOHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE RESOIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   RESOIN gets input parameters for RESOU and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, J
      LOGICAL   T, F
      INCLUDE 'RESOU.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK  /'      '/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 74
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Get antenna list
      NUMSOU = 0
      DO 20 I = 1,30
         INSOU(I) = IROUND (FPARM(I))
         OUSOU(I) = IROUND (RPARM(I))
         IF ((INSOU(I).LE.0) .OR. (OUSOU(I).LE.0)) GO TO 30
         DO 10 J = 1,NUMSOU
            IF (INSOU(J).EQ.INSOU(I)) THEN
               MSGTXT = 'SOURCE NUMBERS REPEATED IN FPARM'
               GO TO 990
               END IF
 10         CONTINUE
         NUMSOU = NUMSOU + 1
 20      CONTINUE
C                                       Create new file.
C                                       Get CATBLK from old file.
 30   IF (NUMSOU.LE.0) THEN
         MSGTXT = 'NO SOURCE NUMBERS SPECIFIED'
         GO TO 990
         END IF
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Find weight and scale.
      IF (ISCOMP) THEN
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      NEWCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, NEWCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      IF (ILOCSU.LT.0) THEN
         MSGTXT = 'MULTI-SOURCE DATA SET REQUIRED'
         GO TO 990
         END IF
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RESOIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE RESOUV (IRET)
C-----------------------------------------------------------------------
C   RESOUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48, IFILE*48
      INTEGER   INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, ILENBU,
     *   KBIND, NIOUT, NIOLIM, IBIND, I, INCX, BO, VO, J, NUMVIS,
     *   XCOUNT, NCORI, NCORO, NCOPY, RNXRET, VISINC, VISMSG
      LOGICAL   T, F
      INCLUDE 'RESOU.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI, LUNO /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
      IF (ISCOMP) INCX = 3
      VISINC = CATBLK(KIGCN) / 20
      VISMSG = CATBLK(KIGCN) / 10
      VISINC = MAX (20000, MIN (200000,VISINC))
      VISMSG = (VISMSG / VISINC) * VISINC
      IF (VISMSG.LT.VISINC) VISMSG = 100 * VISINC
C                                       Number of visibilities in input
C                                       and output files.
      NCORI = (LRECI - NRPRMI) / CATOLD(KINAX)
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, NEWCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Out of data?
         IF (INIO.LE.0) GO TO 200
C                                       Loop over buffer
         DO 190 I = 1,INIO
            NUMVIS = NUMVIS + 1
            IF (MOD(NUMVIS-1,VISMSG).EQ.0) THEN
               WRITE (MSGTXT,1105) NUMVIS
               CALL MSGWRT (2)
            ELSE IF (MOD(NUMVIS-1,VISINC).EQ.0) THEN
               WRITE (MSGTXT,1105) NUMVIS
               CALL MSGWRT (1)
               END IF
C                                      Call uv routine.
            J = BUFF1(IPTRI+ILOCSU) + 0.1
            CALL NEWSOU (J)
            BUFF1(IPTRI+ILOCSU) = J
            XCOUNT = XCOUNT + 1.0D0
            CALL RCOPY (NCOPY, BUFF1(IPTRI), BUFF2(IPTRO))
C                                       update NX table
            CALL RNXUPD (BUFF1(IPTRI), RNXRET)
            IPTRO = IPTRO + LRECO
            NIOUT = NIOUT + 1
C                                       OK, but no output please
            IPTRI = IPTRI + LRECI
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
C                                       Read next buffer.
         GO TO 100
C                                       Finish write
 200  NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, NEWCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RESOUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1010 FORMAT ('RESOUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('RESOUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('RESOUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('RESOUV: ERROR',I3,' READING VIS FILE')
 1105 FORMAT ('RESOUV: at visibility record',I10)
 1150 FORMAT ('RESOUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE NEWSOU (SOUNUM)
C-----------------------------------------------------------------------
C   NEWSOU converts the source number
C   In/out
C      SOUNUM   I   Source number
C-----------------------------------------------------------------------
      INTEGER   SOUNUM
C
      INCLUDE 'RESOU.INC'
C
      INTEGER   I
C-----------------------------------------------------------------------
      DO 20 I = 1,NUMSOU
         IF (SOUNUM.EQ.INSOU(I)) THEN
            SOUNUM = OUSOU(I)
            GO TO 999
            END IF
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE RESOHI
C-----------------------------------------------------------------------
C   RESOHI copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP*2, HILINE*72
      INTEGER   LUN1, LUN2, IERR, I, NONOT, I1, I2, JTRIM
      LOGICAL   T, F
      INCLUDE 'RESOU.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T, F /.TRUE.,.FALSE./
      DATA NONOT /0/
      DATA NOTTYP /'  '/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      HILINE = TSKNAM // '/ Input source numbers'
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      I2 = 0
 10   I1 = I2 + 1
      IF (I1.LE.NUMSOU) THEN
         I2 = MIN (NUMSOU, I1+9)
         WRITE (HILINE,1010) TSKNAM, 'F', (INSOU(I), I=I1,I2)
         IF (I1.GT.1) HILINE(7:13) = ' '
         IF (I2.EQ.NUMSOU) HILINE(JTRIM(HILINE):) = ' '
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         GO TO 10
         END IF
      HILINE = TSKNAM // '/ Output source numbers'
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      I2 = 0
 20   I1 = I2 + 1
      IF (I1.LE.NUMSOU) THEN
         I2 = MIN (NUMSOU, I1+9)
         WRITE (HILINE,1010) TSKNAM, 'R', (OUSOU(I), I=I1,I2)
         IF (I1.GT.1) HILINE(7:13) = ' '
         IF (I2.EQ.NUMSOU) HILINE(JTRIM(HILINE):) = ' '
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         GO TO 20
         END IF
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy non-source tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO,
     *   FCNO(2), FCNO(1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1200)
         CALL MSGWRT (6)
         END IF
      CALL RESTAB (IERR)
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST',
     *   BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RESOHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,A1,'PARM =',10(I4,','))
 1200 FORMAT ('RESOHI: ERROR COPYING TABLES')
      END
      SUBROUTINE RESTAB (IERR)
C-----------------------------------------------------------------------
C   Since there are so many tables that need operating on this will
C   do it in a generic sense.  Changes source ID column only
C   Output:
C      IERR   I   Error code, 0 => OK
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'RESOU.INC'
      INTEGER   TABDO, MAXIFV, MAXKEY, MAXTWO, MAXIDC, MAXTIM
      PARAMETER (TABDO = 28, MAXIFV = 16, MAXKEY = 50)
      PARAMETER (MAXTWO = 10, MAXIDC = 6)
      PARAMETER (MAXTIM = 4)
C
      CHARACTER DOTYP(TABDO)*2
      INTEGER   II, VER, LUNIN, NKEY, NREC, NCOL, DATP(256), NROWS,
     *   BUFFER(512), IDUM, LVER, NVER, BIGBUF(100000), IRNO, SKOL,
     *   SOUNUM, IPTR
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA DOTYP /'FO', 'PO', 'SU', 'TE', 'BC', 'BD', 'BL', 'BP',
     *   'BS', 'BT', 'CA', 'CL', 'CM', 'CP', 'FG', 'FL', 'GA', 'IM',
     *   'MC', 'OF', 'OT', 'PC', 'PH', 'SN', 'SO',  'SY', 'TS', 'TY'/
C-----------------------------------------------------------------------
C                                       Loop over file types
      DO 100 II = 1,TABDO
         CALL FNDEXT (DOTYP(II), CATBLK, NVER)
C                                       Loop over version
         DO 90 LVER = 1,NVER
            WRITE (MSGTXT,1005) DOTYP(II), LVER
            CALL MSGWRT (2)
            VER = LVER
            LUNIN = 41
            CALL TABINI ('READ', DOTYP(II), DISKO, NEWCNO, VER, CATBLK,
     *         LUNIN, NKEY, NREC, NCOL, DATP, BUFFER, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1010) DOTYP(II), VER, IERR,
     *            'OPENING TABLE FILE'
               CALL MSGWRT (7)
               GO TO 90
               END IF
            CALL TABIO ('CLOS', IDUM, NROWS, BUFFER, BUFFER, IERR)
            CALL TABINI ('WRIT', DOTYP(II), DISKO, NEWCNO, VER, CATBLK,
     *         LUNIN, NKEY, NREC, NCOL, DATP, BUFFER, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1010) DOTYP(II), VER, IERR,
     *            'OPENING TABLE FILE'
               CALL MSGWRT (7)
               GO TO 90
               END IF
C                                       # rows in table
            NROWS = BUFFER(5)
C                                       Find column
            CALL FNDCOL (1, 'ID. NO. ', 8, .TRUE., BUFFER, SKOL, IERR)
            IF (IERR.GT.10) THEN
               CALL FNDCOL (1, 'SOURCE_ID', 9, .TRUE., BUFFER, SKOL,
     *            IERR)
               IF (IERR.GT.10) THEN
                  CALL FNDCOL (1, 'SOURCE ID', 9, .TRUE., BUFFER, SKOL,
     *               IERR)
                  IF ((IERR.GT.10) .AND. (DOTYP(II).EQ.'FG')) THEN
                     CALL FNDCOL (1, 'SOURCE', 6, .TRUE., BUFFER, SKOL,
     *                  IERR)
                     END IF
                  END IF
               END IF
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1010) DOTYP(II), VER, IERR,
     *            'FINDING COLUMN'
               GO TO 80
               END IF
            IPTR = DATP(SKOL)
            DO 20 IRNO = 1,NROWS
               CALL TABIO ('READ', 0, IRNO, BIGBUF, BUFFER, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1010) DOTYP(II), VER, IERR,
     *               'READING SOURCE NUMBER'
                  GO TO 80
               END IF
               SOUNUM = BIGBUF(IPTR)
               CALL NEWSOU (SOUNUM)
               BIGBUF(IPTR) = SOUNUM
               CALL TABIO ('WRIT', 0, IRNO, BIGBUF, BUFFER, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1010) DOTYP(II), VER, IERR,
     *               'WRITING SOURCE NUMBER'
                  GO TO 80
                  END IF
 20            CONTINUE
            IDUM = 0
            CALL TABIO ('CLOS', IDUM, NROWS, BUFFER, BUFFER, IERR)
            GO TO 90
C
 80         CALL MSGWRT (8)
            CALL TABIO ('CLOS', IDUM, NROWS, BUFFER, BUFFER, IERR)
 90         CONTINUE
 100     CONTINUE
      IERR = 0
C
  999 RETURN
C-----------------------------------------------------------------------
 1005 FORMAT ('RESTAB processing table ',A2,' version',I4)
 1010 FORMAT ('RESTAB 'A,' TABLE VERSION',I4,' ERROR',I4,' ON ',A)
      END

      SUBROUTINE ZTQSP2 (DOALL, MSLEV, NPROC)
C-----------------------------------------------------------------------
C! display AIPS account or all processes running on the system
C# Z2 System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Displays information on the user's terminal regarding AIPS account
C   originated processes or all processes running on the system.
C   Inputs:
C      DOALL   R   > 0.0 => display all processes
C      MSLEV   I   Message level to use in calling MSGWRT.
C      NPROC   I   Max POPS number (#interactive + #batch + 1)
C   Generic version - stub.
C-----------------------------------------------------------------------
      REAL      DOALL
      INTEGER   MSLEV, NPROC
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Requires local development.
      WRITE (MSGTXT,9999)
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 9999 FORMAT ('ZTQSP2: ROUTINE REQUIRES LOCAL DEVELOPMENT')
      END

      SUBROUTINE YWINDO (OPER, WIND, IERR)
C-----------------------------------------------------------------------
C! set the current window (viewport) into the TV memory
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YWINDO reads the current viewport into the TV memory.
C   Inputs:
C      OPER   C*4    'READ', 'WRIT'
C   In/out:
C      WIND   I(4)   BLC x,y, TRC x,y of window in TV pixels
C                    In: desired window ('WRIT' only)
C                    Out: actual window given
C   Output:
C      IERR    I     error code of Z...XF: 0 -> ok, 2 -> input error
C                       -1 => writes not allowed on this TV device
C   Generic version - returns full memory size.
C   'WRIT' =>  error = -1
C-----------------------------------------------------------------------
      CHARACTER OPER*(*)
      INTEGER   WIND(4), IERR
C
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
      IF (OPER.EQ.'READ') THEN
         IERR = 0
      ELSE IF (OPER.EQ.'WRIT') THEN
         IERR = -1
      ELSE
         IERR = 2
         MSGTXT = 'YWINDO: SUPPORTS READ/WRIT ONLY, NOT ' // OPER
         CALL MSGWRT (8)
         END IF
C                                       Full screen always
      WIND(1) = 1
      WIND(2) = 1
      WIND(3) = MAXXTV(1)
      WIND(4) = MAXXTV(2)
C
 999  RETURN
      END

      SUBROUTINE ZRHPRL (NVAL, NP, INB, OUTB)
C-----------------------------------------------------------------------
C! convert 32-bit HP floating buffer to local REAL values
C# Binary
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Converts from 32 bit Hewitt-Packard floating format to local single
C   precision.
C      HP R*4 format:
C                1         2         3
C      01234567890123456789012345678901
C      smmmmmmmmmmmmmmmmmmmmmmmeeeeeeez
C   The value can be determined as follows:
C      man = smmmmmmmmmmmmmmmmmmmmmmm is a two's complement signed
C            integer.
C      exp = zeeeeeee is a two's complement signed integer.
C      value = man * 2.0 ** (exp - 23)
C   Inputs:
C      NVAL   I      Number of values to convert
C      NP     I      First value in INB to convert
C      INB    R(*)   32-bit HP format values
C   Output:
C      OUTB   R(*)   Local format values.
C   Generic version; should work on any machine.
C-----------------------------------------------------------------------
      INTEGER   NVAL, NP
      REAL      INB(*), OUTB(*)
C
      INTEGER LOOP, NB, L24, IEXP, IEX, IEXMAX, IEXMIN, ITEMP(4), IESIGN
      REAL    HPV4
      DATA IEXMAX, IEXMIN /103, -103/
C-----------------------------------------------------------------------
      NB = NP
      DO 500 LOOP = 1,NVAL
         HPV4 = 0.0
C                                       mantissa
         CALL ZI8IL (4, 1, INB(NB), ITEMP)
         IF (ITEMP(1).GE.128) THEN
C                                       Negative
            L24 = ((ITEMP(1)-255) * 65536) + ((ITEMP(2)-255) * 256) +
     *         (ITEMP(3)-255) - 1
         ELSE
C                                       Positive
            L24 = ((ITEMP(1) * 65536) + (ITEMP(2) * 256) + ITEMP(3))
            END IF
         IF (L24.NE.0) THEN
C                                       exponent
            IEXP = ITEMP(4) / 2
C                                       exponent sign
            IESIGN = ITEMP(4) - (ITEMP(4)/2) * 2
            IF (IESIGN.NE.0) IEXP = IEXP - 128
C                                       Correct for radix point in
C                                       mantessa.
            IEX = IEXP - 23
C                                       Set to zero when an overflow or
C                                       underflow occures.
            IF ((IEX.GT.IEXMAX) .OR. (IEX.LT.IEXMIN)) GO TO 490
            HPV4 = L24 * (2.0**IEX)
            END IF
 490     NB = NB + 1
         OUTB(LOOP) = HPV4
 500     CONTINUE
 999  RETURN
      END

LOCAL INCLUDE 'PCDIV.INC'
C                                                          Include PCDIV
C                                       Local include for PCDIV
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XINEXT(1), XOPTYP(1)
      CHARACTER NAMEIN*12, CLAIN*6, INEXT*2, OPTYPE*4
      REAL      XSIN, XDISIN, XINVER, XTYVER, DETIME, BADD(10)
      INTEGER   DISKIN, SEQIN, CNOIN, INVER, OUTVER, ITYVER,
     *   BUFFER(512), RECMAX(MAXANT), NIF, NANT, MREC, NPOL, NTIME
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XINVER, XINEXT,
     *   XTYVER, DETIME, XOPTYP, BADD
      COMMON /CHRCOM/ NAMEIN, CLAIN, INEXT, OPTYPE
      COMMON /INFOLS/ DISKIN, SEQIN, CNOIN, INVER, OUTVER, ITYVER,
     *   NIF, NANT, MREC, BUFFER, RECMAX, NPOL, NTIME
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
C                                                          End PCDIV
LOCAL END
LOCAL INCLUDE 'TYDATA.INC'
      INTEGER   TYBUFF(512), ITYRNO, TYKOLS(MAXTYC), TYNUMV(MAXTYC),
     *   SOURID, ANTNO, SUBA, FREQID, SYKOLS(MAXSYC), SYNUMV(MAXSYC)
      REAL      TIMEI, TSYS(2,MAXIF), TANT(2,MAXIF), PSUM(2,MAXIF),
     *   PDIF(2,MAXIF), PGAIN(2,MAXIF)
      DOUBLE PRECISION TIME
      EQUIVALENCE (PSUM, TSYS), (PDIF, TANT)
      COMMON /TYDATA/ TIME, TYBUFF, ITYRNO, TYKOLS, TYNUMV, SOURID,
     *   ANTNO, SUBA, FREQID, TIMEI, TSYS, TANT, SYKOLS, SYNUMV,
     *   PGAIN
LOCAL END
LOCAL INCLUDE 'PCDATA.INC'
      INCLUDE 'INCS:PPCV.INC'
      DOUBLE PRECISION TIME, CABCAL, PCFREQ(2,MAXTON,MAXIF)
      INTEGER   PCNPOL, PCNIF, NUMTON, PCBUFF(512), PCNUMV(MAXPCC),
     *   PCKOLS(MAXPCC), PCROW, OUTROW
      REAL      TIMINT, STATE(2,4,MAXIF), PCREAL(2,MAXTON,MAXIF),
     *   PCIMAG(2,MAXTON,MAXIF), PCRATE(2,MAXTON,MAXIF)
      COMMON /PCDATA/ PCFREQ, TIME, CABCAL, STATE, PCREAL, PCIMAG,
     *   PCRATE, PCBUFF, TIMINT, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON,
     *   PCROW, OUTROW
LOCAL END
      PROGRAM PCDIV
C-----------------------------------------------------------------------
C! scale a PC table by the TY Tsys values
C# UV Calibration EXT-appl VLBI
C-----------------------------------------------------------------------
C;  Copyright (C) 2021-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task PCDIV sorts a PC table into time-antenna order and then
C   writes a new table with PC amplitudes divided by Tsys
C   Inputs:
C      AIPS Adverb   Prg. Name          Description
C      INNAME         NAMEIN        File name to be imaged
C      INCLASS        CLAIN         File class to be imaged
C      INSEQ          SEQIN         File sequence number
C      INDISK         DISKIN        Disk volume on which file resides
C      INVERS         INVER         Input version
C      INEXT          INEXT         'TY' or 'SY'
C      TYVER          ITYVER        TY / SY version
C      DETIME         DETIME        In seconds, treat times as equal
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, NWORDS, ND
      REAL      TYDATA(2)
      LONGINT   PTYDAT
      INCLUDE 'PCDIV.INC'
      DATA PRGM /'PCDIV '/
C-----------------------------------------------------------------------
C                                       get inputs, ...
      CALL PCDIVI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       dynamic memory for TY data
      ND = 2 + NANT * NPOL * NIF
      NWORDS = ND * NTIME
      NWORDS = (NWORDS - 1) / 1024 + 4
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, TYDATA, PTYDAT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'FAILED TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
      IF (INEXT.EQ.'TY') THEN
         CALL PCDITY (ND, TYDATA(1+PTYDAT), IRET)
      ELSE
         CALL PCDISY (ND, TYDATA(1+PTYDAT), IRET)
         END IF
      IF (IRET.NE.0) GO TO 990
      CALL PCDIPC (ND, TYDATA(1+PTYDAT), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Do history
      CALL PCDIHI
C                                       close down
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE PCDIVI (PRGM, IRET)
C-----------------------------------------------------------------------
C   PCDIVI gets the inputs for PCDIV.
C   Inputs:
C      PRGM   C*6   Task name
C   Output:
C      ONEIF  L     T => input has <= 1 IF
C      IRET   I     Error code: 0 ok, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
C
      CHARACTER STAT*4, UTYPE*2
      INTEGER   NPARM, IERR, IROUND, I, KEY(2,2), KEYSUB(2,2), LUN,
     *   LUNTMP, IREC, NREC, CALTYP
      REAL      FKEY(2,2), RTIME, LTIME
      INCLUDE 'PCDIV.INC'
      INCLUDE 'TYDATA.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA FKEY /1.0,0.0,1.0,0.0/
      DATA KEYSUB, KEY /4*1, 4*0/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
C                                       Get input parameters.
      NPARM = 22
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMEI, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFFER, IERR)
      IRET = 5
C                                       Crunch input parameters.
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
C                                       Get CATBLK.
      CNOIN = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.5) THEN
            WRITE (MSGTXT,1015) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *         NLUSER
         ELSE
            WRITE (MSGTXT,1016) NAMEIN, CLAIN, SEQIN, DISKIN, NLUSER
            END IF
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'WRIT', BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 1
C                                       Get uv header info.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       size, sort TY table
      ITYVER = XTYVER + 0.1
      IF (DETIME.LE.0.0) DETIME = 1.0
      DETIME = DETIME / (24.0 * 3600.0)
      CALL H2CHR (2, 1, XINEXT, INEXT)
      IF ((INEXT.NE.'TY') .AND. (INEXT.NE.'SY')) INEXT = 'TY'
      LUN = LUNTMP (1)
      LTIME = -100.
      NTIME = 0
      NANT = 0
      IF (INEXT.EQ.'TY') THEN
         CALL TYINI ('READ', TYBUFF, DISKIN, CNOIN, ITYVER, CATBLK, LUN,
     *      ITYRNO, TYKOLS, TYNUMV, NPOL, NIF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING TY TABLE'
            GO TO 990
            END IF
         IF ((TYBUFF(43).NE.1) .OR. (TYBUFF(44).NE.4)) THEN
            CALL TABIO ('CLOS', 0, ITYRNO, TYBUFF, TYBUFF, IRET)
            MSGTXT = 'Sorting input TY table'
            CALL MSGWRT (2)
            KEY(1,1) = 1
            KEY(1,2) = 4
            CALL TABSRT (DISKIN, CNOIN, 'TY', ITYVER, ITYVER, KEY,
     *         KEYSUB,FKEY, TYBUFF, CATBLK, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'SORTING TY TABLE'
               GO TO 990
               END IF
            CALL TYINI ('READ', TYBUFF, DISKIN, CNOIN, ITYVER, CATBLK,
     *         LUN,ITYRNO, TYKOLS, TYNUMV, NPOL, NIF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'RE-OPENING TY TABLE'
               GO TO 990
               END IF
            END IF
         NREC = TYBUFF(5)
         DO 20 IREC = 1,NREC
            CALL TABTY ('READ', TYBUFF, ITYRNO, TYKOLS, TYNUMV, NPOL,
     *         NIF, RTIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, TSYS,
     *         TANT, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING TY TABLE'
               GO TO 990
            ELSE IF (IRET.EQ.0) THEN
               IF (RTIME.GT.LTIME) THEN
                  NTIME = NTIME + 1
                  LTIME = RTIME + DETIME
                  END IF
               NANT = MAX (NANT, ANTNO)
               END IF
 20         CONTINUE
         CALL TABTY ('CLOS', TYBUFF, ITYRNO, TYKOLS, TYNUMV, NPOL, NIF,
     *      RTIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, TSYS, TANT, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING TY TABLE'
            GO TO 990
            END IF
C                                       SY table
      ELSE
         CALL SYINI ('READ', TYBUFF, DISKIN, CNOIN, ITYVER, CATBLK, LUN,
     *      ITYRNO, SYKOLS, SYNUMV, NANT, NPOL, NIF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING SY TABLE'
            GO TO 990
            END IF
         IF ((TYBUFF(43).NE.1) .OR. (TYBUFF(44).NE.5)) THEN
            CALL TABIO ('CLOS', 0, ITYRNO, TYBUFF, TYBUFF, IRET)
            MSGTXT = 'Sorting input SY table'
            CALL MSGWRT (2)
            KEY(1,1) = 1
            KEY(1,2) = 5
            CALL TABSRT (DISKIN, CNOIN, 'SY', ITYVER, ITYVER, KEY,
     *         KEYSUB,FKEY, TYBUFF, CATBLK, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'SORTING SY TABLE'
               GO TO 990
               END IF
            CALL SYINI ('READ', TYBUFF, DISKIN, CNOIN, ITYVER, CATBLK,
     *         LUN, ITYRNO, SYKOLS, SYNUMV, NANT, NPOL, NIF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'RE-OPENING SY TABLE'
               GO TO 990
               END IF
            END IF
         NREC = TYBUFF(5)
         NANT = 0
         DO 30 IREC = 1,NREC
            CALL TABSY ('READ', TYBUFF, ITYRNO, SYKOLS, SYNUMV, NPOL,
     *         NIF, TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA, FREQID,
     *         PDIF, PSUM, PGAIN, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING SY TABLE'
               GO TO 990
            ELSE IF (IRET.EQ.0) THEN
               IF (TIME.GT.LTIME) THEN
                  NTIME = NTIME + 1
                  LTIME = TIME + DETIME
                  END IF
               NANT = MAX (NANT, ANTNO)
               END IF
 30         CONTINUE
         CALL TABSY ('CLOS', TYBUFF, ITYRNO, SYKOLS, SYNUMV, NPOL,
     *      NIF, TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA, FREQID,
     *      PDIF, PSUM, PGAIN, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING SY TABLE'
            GO TO 990
            END IF
         END IF
      GO TO 999
C                                       message
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PCDIVI: ERROR',I3,' ON ',A)
 1015 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I5,' DISK=',
     *   I3,' USID=',I5)
 1016 FORMAT (A12,'.',A6,'.',I5,' DISK=',I3,' USID=',I5,' NOT FOUND')
 1020 FORMAT ('PCDIVI: ERROR',I3,' READING CATBLK ')
      END
      SUBROUTINE PCDITY (ND, TYDAT, IRET)
C-----------------------------------------------------------------------
C   Reads in the TY data
C   Inputs:
C      ND      I      Number data = time, source, Nant*2*Nif
C   Outputs:
C      TYDAT   R(*)   Tsys (nd, ntime)
C      IRET    I      error code
C-----------------------------------------------------------------------
      INTEGER   ND, IRET
      REAL      TYDAT(ND,*)
C
      INCLUDE 'PCDIV.INC'
      INCLUDE 'TYDATA.INC'
      INTEGER   NP, IP, IREC, NREC, LUN, LUNTMP, IT
      REAL      RTIME, LTIME
C-----------------------------------------------------------------------
      LUN  = LUNTMP (1)
      CALL TYINI ('READ', TYBUFF, DISKIN, CNOIN, ITYVER, CATBLK, LUN,
     *   ITYRNO, TYKOLS, TYNUMV, NPOL, NIF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING TY TABLE'
         GO TO 990
         END IF
      LTIME = -100.
      NREC = TYBUFF(5)
      NP = NPOL * NIF
      IT = 0
      DO 20 IREC = 1,NREC
         CALL TABTY ('READ', TYBUFF, ITYRNO, TYKOLS, TYNUMV, NPOL, NIF,
     *      RTIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, TSYS, TANT, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING TY TABLE'
            GO TO 990
            END IF
         IF (RTIME.GT.LTIME) THEN
            IT = IT + 1
            LTIME = RTIME + DETIME
            CALL RFILL (ND, 0.0, TYDAT(1,IT))
            TYDAT(1,IT) = RTIME
            TYDAT(2,IT) = SOURID
            END IF
         IP = 3 + (ANTNO-1) * NP
         CALL RCOPY (NP, TSYS, TYDAT(IP,IT))
 20      CONTINUE
      CALL TABTY ('CLOS', TYBUFF, ITYRNO, TYKOLS, TYNUMV, NPOL, NIF,
     *   RTIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, TSYS, TANT, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING TY TABLE'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PCDITY ERROR',I4,' ON ',A)
      END
      SUBROUTINE PCDISY (ND, TYDAT, IRET)
C-----------------------------------------------------------------------
C   Reads in the SY data
C   Inputs:
C      ND      I      Number data = time, source, Nant*2*Nif
C   Outputs:
C      TYDAT   R(*)   Tsys (nd, ntime)
C      IRET    I      error code
C-----------------------------------------------------------------------
      INTEGER   ND, IRET
      REAL      TYDAT(ND,*)
C
      INCLUDE 'PCDIV.INC'
      INCLUDE 'TYDATA.INC'
      INTEGER   NP, IP, IREC, NREC, LUN, LUNTMP, IT, NA, CALTYP
      DOUBLE PRECISION LTIME
C-----------------------------------------------------------------------
      LUN  = LUNTMP (1)
      CALL SYINI ('READ', TYBUFF, DISKIN, CNOIN, ITYVER, CATBLK, LUN,
     *   ITYRNO, SYKOLS, SYNUMV, NA, NPOL, NIF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING SY TABLE'
         GO TO 990
         END IF
      LTIME = -100.D0
      NREC = TYBUFF(5)
      NP = NPOL * NIF
      IT = 0
      DO 20 IREC = 1,NREC
         CALL TABSY ('READ', TYBUFF, ITYRNO, SYKOLS, SYNUMV, NPOL, NIF,
     *      TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA, FREQID, PDIF,
     *      PSUM, PGAIN, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING TY TABLE'
            GO TO 990
         ELSE IF (IRET.EQ.0) THEN
            IF (TIME.GT.LTIME) THEN
               IT = IT + 1
               LTIME = TIME + DETIME
               CALL RFILL (ND, 0.0, TYDAT(1,IT))
               TYDAT(1,IT) = TIME
               TYDAT(2,IT) = SOURID
               END IF
            IP = 3 + (ANTNO-1) * NP
            CALL RCOPY (NP, PSUM, TYDAT(IP,IT))
            END IF
 20      CONTINUE
      CALL TABSY ('CLOS', TYBUFF, ITYRNO, SYKOLS, SYNUMV, NPOL, NIF,
     *   TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA, FREQID, PDIF,
     *   PSUM, PGAIN, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING SY TABLE'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PCDITY ERROR',I4,' ON ',A)
      END
      SUBROUTINE PCDIPC (ND, TYDAT, IRET)
C-----------------------------------------------------------------------
C   PCDIPC sorts the input table if needed and does the scaling by an
C   interpolated set of TY values
C   Output:
C      IRET     I      Error code: 0 => okay, else die.
C-----------------------------------------------------------------------
      INTEGER   ND, IRET
      REAL      TYDAT(ND,*)
C
      INCLUDE 'PCDIV.INC'
      INCLUDE 'PCDATA.INC'
      INTEGER   I, ISUB, PCLUN, KEY(2,2), KEYSUB(2,2), NXVER, ANTNUM,
     *   FREQID, IROW, NSCAN, NUMPC, NXLUN, SOUNUM, PC2LUN, OUBUFF(512),
     *   LANT, LSOUR, LIF, LP, LCH, IP, IT,NP, NT0, NT1
      REAL      FKEY(2,2), STIMES(2000), TSYS(2), W0, W1
      DOUBLE PRECISION LTIME
      DATA FKEY /1.0,0.0,1.0,0.0/
      DATA KEYSUB, KEY /4*1, 4*0/
      DATA PCLUN, PC2LUN, NXLUN /43,44,45/
C-----------------------------------------------------------------------
C                                       open PC table
      INVER = XINVER + 0.1
      CALL FNDEXT ('PC', CATBLK, I)
      IF (INVER.LE.0) INVER = I
      IF (INVER.GT.I) INVER = I
      OUTVER = I + 1
      CALL PCINI ('READ', PCBUFF, DISKIN, CNOIN, INVER, CATBLK, PCLUN,
     *   PCROW, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT PC TABLE'
         GO TO 990
         END IF
      XINVER = INVER
C                                       sort to output PC table
      CALL TABIO ('CLOS', 0, PCROW, PCBUFF, PCBUFF, IRET)
      IF ((PCBUFF(43).NE.1) .OR. (PCBUFF(44).NE.4)) THEN
         MSGTXT = 'Sorting input table'
         CALL MSGWRT (2)
         KEY(1,1) = 1
         KEY(1,2) = 4
         CALL TABSRT (DISKIN, CNOIN, 'PC', INVER, INVER, KEY, KEYSUB,
     *      FKEY, PCBUFF, CATBLK, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SORTING PC TABLE'
            GO TO 990
            END IF
         END IF
      CALL PCINI ('READ', PCBUFF, DISKIN, CNOIN, INVER, CATBLK, PCLUN,
     *   PCROW, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'RE-OPENING INPUT PC TABLE'
         GO TO 990
         END IF
      CALL PCINI ('WRIT', OUBUFF, DISKIN, CNOIN, OUTVER, CATBLK, PC2LUN,
     *   OUTROW, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT PC TABLE'
         GO TO 990
         END IF
      OUBUFF(43) = PCBUFF(43)
      OUBUFF(44) = PCBUFF(44)
C                                       scan list
      CALL FNDEXT ('NX', CATBLK, NXVER)
      IF (NXVER.LE.0) THEN
         NSCAN = 0
         MSGTXT = 'NO INDEX TABLE SO NO SCAN BREAKS'
         CALL MSGWRT (6)
      ELSE
         ISUB = 0
         CALL GETNX (NXLUN, DISKIN, CNOIN, CATBLK, ISUB, BUFFER,
     *      NSCAN, STIMES)
         IF (NSCAN.LE.0) THEN
            MSGTXT = 'INDEX TABLE TROUBLES, SO NO SCAN BREAKS'
            CALL MSGWRT (6)
            END IF
         END IF
C                                       prepare for averaging
      MSGTXT = 'Scaling input table'
      CALL MSGWRT (2)
      NUMPC = PCBUFF(5)
      LANT = 0
      LSOUR = 0
      LTIME = -1000.
      NT0 = 1
      NT1 = NTIME
      NP = NPOL * NIF
      DO 100 IROW = 1,NUMPC
         PCROW = IROW
         CALL TABPC ('READ', PCBUFF, PCROW, PCKOLS, PCNUMV, PCNPOL,
     *      TIME, TIMINT, SOUNUM, ANTNUM, ISUB, FREQID, CABCAL,
     *      STATE, PCFREQ, PCREAL, PCIMAG, PCRATE, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING PC TABLE'
            GO TO 990
            END IF
         IF (IRET.LT.0) GO TO 100
C                                       find TY time
         IF (TIME.GT.LTIME) THEN
            NT0 = MAX (1, NT0-2)
            LTIME = TIME + DETIME
            DO 20 IT = NT0,NTIME
               IF (TYDAT(1,IT).GT.TIME) THEN
                  NT0 = MAX (1, IT-1)
                  NT1 = IT
                  GO TO 25
                  END IF
 20            CONTINUE
            NT0 = NTIME
            NT1 = NTIME
            END IF
 25      W0 = 1.0
         IF (NT1.GT.NT0) W0 = (TYDAT(1,NT1) - TIME) /
     *      (TYDAT(1,NT1) - TYDAT(1,NT0))
         W1 = 1 - W0
         IF (ABS(SOUNUM-TYDAT(2,NT0)).GT.0.5) THEN
            W0 = 0.0
            W1 = 1.0
         ELSE IF (ABS(SOUNUM-TYDAT(2,NT1)).GT.0.5) THEN
            W0 = 1.0
            W1 = 0.0
            END IF
          IP = 3 + (ANTNUM -1) * NP
          DO 50 LIF = 1,NIF
             IF (TYDAT(IP,NT0).LE.0.0) THEN
                IF (TYDAT(IP,NT1).LE.0.0) THEN
                   TSYS(1) = FBLANK
                ELSE
                   TSYS(1) = TYDAT(IP,NT1)
                   END IF
             ELSE IF (TYDAT(IP,NT1).LE.0.0) THEN
                TSYS(1) = TYDAT(IP,NT0)
             ELSE
                TSYS(1) = W0*TYDAT(IP,NT0) + W1*TYDAT(IP,NT1)
                END IF
             IF (TYDAT(IP+1,NT0).LE.0.0) THEN
                IF (TYDAT(IP+1,NT1).LE.0.0) THEN
                   TSYS(2) = FBLANK
                ELSE
                   TSYS(2) = TYDAT(IP+1,NT1)
                   END IF
             ELSE IF (TYDAT(IP+1,NT1).LE.0.0) THEN
                TSYS(2) = TYDAT(IP+1,NT0)
             ELSE
                TSYS(2) = W0*TYDAT(IP+1,NT0) + W1*TYDAT(IP+1,NT1)
                END IF
             IP = IP + NPOL
             DO 40 LP = 1,NPOL
                DO 30 LCH = 1,NUMTON
                   IF (TSYS(LP).NE.FBLANK) THEN
                      IF (OPTYPE.EQ.'MULT') THEN
                         PCREAL(LP,LCH,LIF) = PCREAL(LP,LCH,LIF) *
     *                      TSYS(LP)
                         PCIMAG(LP,LCH,LIF) = PCIMAG(LP,LCH,LIF) *
     *                      TSYS(LP)
                      ELSE
                         PCREAL(LP,LCH,LIF) = PCREAL(LP,LCH,LIF) /
     *                      TSYS(LP)
                         PCIMAG(LP,LCH,LIF) = PCIMAG(LP,LCH,LIF) /
     *                      TSYS(LP)
                         END IF
                   ELSE
                      PCREAL(LP,LCH,LIF) = FBLANK
                      PCIMAG(LP,LCH,LIF) = FBLANK
                      END IF
 30                CONTINUE
 40             CONTINUE
 50          CONTINUE
         CALL TABPC ('WRIT', OUBUFF, OUTROW, PCKOLS, PCNUMV, PCNPOL,
     *      TIME, TIMINT, SOUNUM, ANTNUM, ISUB, FREQID, CABCAL,
     *      STATE, PCFREQ, PCREAL, PCIMAG, PCRATE, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT PC TABLE'
            GO TO 990
            END IF
 100     CONTINUE
C                                       done - close up files
      CALL TABPC ('CLOS', PCBUFF, PCROW, PCKOLS, PCNUMV, PCNPOL, TIME,
     *   TIMINT, SOUNUM, ANTNUM, ISUB, FREQID, CABCAL,STATE, PCFREQ,
     *   PCREAL, PCIMAG, PCRATE, IRET)
      CALL TABPC ('CLOS', OUBUFF, OUTROW, PCKOLS, PCNUMV, PCNPOL, TIME,
     *   TIMINT, SOUNUM, ANTNUM, ISUB, FREQID, CABCAL,STATE, PCFREQ,
     *   PCREAL, PCIMAG, PCRATE, IRET)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PCDIPC: ERROR',I5,' ON ',A)
      END
      SUBROUTINE PCDIHI
C-----------------------------------------------------------------------
C   PCDIHI adds to the history file of the input UV data set.
C-----------------------------------------------------------------------
C
      CHARACTER HILINE*72, CTIME(2)*12
      INTEGER   HLUNI, IERR, ITIME(3), DATE(3)
      INCLUDE 'PCDIV.INC'
      INCLUDE 'PCDATA.INC'
      INCLUDE 'INCS:DHIS.INC'
      DATA HLUNI /28/
C-----------------------------------------------------------------------
      CALL HIINIT (3)
      CALL HIOPEN (HLUNI, DISKIN, CNOIN, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (ITIME)
      CALL TIMDAT (ITIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,1000) TSKNAM, RLSNAM, CTIME
      CALL HIADD (HLUNI, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       TY/SY version
      WRITE (HILINE,1010) TSKNAM, INEXT
      CALL HIADD (HLUNI, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1011) TSKNAM, ITYVER
      CALL HIADD (HLUNI, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       equal time range
      DETIME = DETIME * 24.0 * 3600.0
      WRITE (HILINE,1012) TSKNAM, DETIME
      CALL HIADD (HLUNI, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       input version
      WRITE (HILINE,1013) TSKNAM, INVER
      CALL HIADD (HLUNI, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       output version
      WRITE (HILINE,1014) TSKNAM, OUTVER
      CALL HIADD (HLUNI, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      MSGTXT = HILINE(7:)
      CALL MSGWRT (2)
C                                       records written
      WRITE (HILINE,1020) TSKNAM, OUTROW-1
      CALL HIADD (HLUNI, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      MSGTXT = HILINE(7:)
      CALL MSGWRT (2)
C                                       Close HI file
 100  CALL HICLOS (HLUNI, .TRUE., BUFFER, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A9,2X,A8)
 1010 FORMAT (A6,'INEXT = ''',A,'''  Tsys or Psum divides PC amp')
 1011 FORMAT (A6,'TYVER=',I5,'  / TY or SY table version used')
 1012 FORMAT (A6,'DETIME=',F6.2,'  / interval of equal times in sec.')
 1013 FORMAT (A6,'INVERS=',I4,'  / PC table input version')
 1014 FORMAT (A6,'OUTVERS=',I5,'  / output PC table version')
 1020 FORMAT (A6,'/  wrote',I8,' records in the output PC table')
      END

      SUBROUTINE AN10RS (NUMAN, ISUB, ANTENN, BASELN, NBASE, ANT1, ANT2)
C-----------------------------------------------------------------------
C! Determines a list of antenna pairs from adverbs ANTENNA, BASELINE
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2006, 2016
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Determine a list of selected antenna pairs from the standard ANTENNA
C   and BASELINE adverbs.  There are a number of cases.
C
C   1 - All elements of both ANTENN and BASELN are zero.  All baselines
C       are selected.  In this case NBASE is set to 1 and the first
C       elements of both ANT1 and ANT2 are set to 0.
C
C   2 - All elements of ANTENN are positive or zero with at least one
C       positive value and all elements of BASELN are zero.  All
C       baselines containing antennae with numbers corresponding to the
C       non-zero elements of ANTENN are selected.  NBASE is set to the
C       number of unique non-zero entries in ANTENN, the first NBASE
C       entries of ANT1 list the unique non-zero elements of ANTENN and
C       the first NBASE elements of ANT2 are zero.  If all ANTENN are 0
C       but some of BASELN are not, their roles are reversed.
C
C   3 - All elements of ANTENN are positive or zero with at least one
C       positive value and at least one element of BASELN is non-zero.
C       All baselines that can be formed from one non-zero element of
C       ANTENN and the absolute value of one non-zero element of BASELN
C       are selected.  NBASE is the number of unique baselines that can
C       be formed in this way and the first NBASE elements of ANT1 and
C       ANT2 list the first and second elements of each of these
C       baselines respectively.
C
C   4 - At least one element of ANTENN is negative and all elements of
C       BASELN are zero.  All baselines that do not include antennae
C       corresponding to the absolute values of the non-zero elements of
C       ANTENN are selected.  NBASE is the number of such baseline and
C       the first NBASE elements of ANT1 and ANT2 list the first and
C       second elements of each of these baselines respectively.
C
C   5 - At least one element of ANTENN is negative and at least one
C       element of BASELN is non-zero.  All baselines that can not be
C       formed from the absolute value of one non-zero element of ANTENN
C       and the absolute value of one non-zero element of BASELN are
C       selected.  NBASE is the number of such baselines and the first
C       NBASE elements of ANT1 and ANT2 list the first and second
C       elements of each of these baselines respectively.
C
C   6 - The number of selected baselines, determined by any of the above
C       rules, exceeds the size of ANT1 and ANT2.  An error message is
C       emitted and NBASE is set to zero.
C
C   On entry NBASE should be the dimension of ANT1 and ANT2 and should
C   be greater than 50.
C
C   If neither ANT1(i) nor ANT2(i) are zero for any i in the range 1 to
C   NBASE inclusive than ANT2(i) > ANT1(i).
C
C   If NUMAN contains no useful information a default maximum antenna
C   number of 28 is assumed.
C   Inputs:
C      NUMAN    I(513)   NUMAN(1) is the number of subarrays present.
C                        NUMAN(i) where i > 1 is the maximum antenna
C                        number for subarray i - 1.
C      ISUB     I        the subarray number for which a list of
C                        baselines is required; if ISUB is less than or
C                        equal to zero generate a list valid for all
C                        subarrays.
C      ANTENN   R(50)    the value list of the ANTENNA adverb; assumed
C                        to contain integer values.
C      BASELN   R(50)    the value list of the BASELINE adverb; assumed
C                         to contain integer values.
C   Input/Output:
C      NBASE    I        on input: the maximum number of baselines to
C                                  list;
C                        on output: the number of valid elements in ANT1
C                                   and ANT2.
C   Output:
C      ANT1     I(*)     see above.
C      ANT2     I(*)     see above.
C   Local variables:
C      NUNANT  I        number of unique antennae in ANTENN
C      UNQANT  I(50)    list of unique antennae in ANTENN
C
C      NUNBAS  I        number of unique antennae in BASELN
C      UNQBAS  I(50)    list of unique antennae in BASELN
C
C      REJECT  L        true if listed baselines are to be rejected
C                       (case 4 and 5 above); false otherwise.
C
C      MAXANT  I        maximum antenna number for subarray ISUB or, if
C                       ISUB is zero or negative, the largest maximum
C                       antenna number for all subarrays.
C
C      MXBASE  I        maximum number of baselines allowed in output
C
C-----------------------------------------------------------------------
      INTEGER   NUMAN(*), ISUB, NBASE, ANT1(*), ANT2(*)
      REAL      ANTENN(50), BASELN(50)
C
      INTEGER   NUNANT, UNQANT(50), NUNBAS, UNQBAS(50), MAXANT, MXBASE,
     *   I, J, K
      LOGICAL   REJECT, REQBAS, LT
      EXTERNAL  REQBAS
      INCLUDE   'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Establish the definitions of
C                                       local variables NUNANT, UNQANT
C                                       and REJECT:
      CALL SETANT (50, ANTENN, BASELN, NUNANT, NUNBAS, UNQANT, UNQBAS,
     *   REJECT)
C                                       Make lists
C                                       Case 1.
      IF ((NUNANT.EQ.0) .AND. (NUNBAS.EQ.0)) THEN
         NBASE   = 1
         ANT1(1) = 0
         ANT2(1) = 0
      ELSE IF (.NOT.REJECT) THEN
C                                       Case 2.
         IF (NUNBAS.EQ.0) THEN
            NBASE = NUNANT
            DO 100 I = 1, NUNANT
               ANT1(I) = UNQANT(I)
               ANT2(I) = 0
 100           CONTINUE
         ELSE IF (NUNANT.EQ.0) THEN
            NBASE = NUNBAS
            DO 110 I = 1,NUNBAS
               ANT1(I) = UNQBAS(I)
               ANT2(I) = 0
 110           CONTINUE
C                                       Case 3.
         ELSE
C                                       Construct the list of baselines
C                                       that can be made by pairing
C                                       elements of UNQANT with elements
C                                       of UNQBAS excluding null
C                                       baselines:
            NBASE = 0
            DO 210 I = 1, NUNANT
               DO 200 J = 1,NUNBAS
                  NBASE = NBASE + 1
                  ANT1(NBASE) = MIN (UNQANT(I), UNQBAS(J))
                  ANT2(NBASE) = MAX (UNQANT(I), UNQBAS(J))
 200              CONTINUE
 210           CONTINUE
C                                       NBASE is at least one.
C
C                                       Remove duplicate baselines:
            K = 1
            DO 230 I = 2,NBASE
               DO 220 J = 1,I-1
                  IF ((ANT1(I).EQ.ANT1(J)) .AND. (ANT2(I).EQ.ANT2(J)))
     *               GO TO 230
 220              CONTINUE
               K = K + 1
               ANT1(K) = ANT1(I)
               ANT2(K) = ANT2(I)
 230           CONTINUE
C                                       recount NBASE
            NBASE = K
            END IF
C                                       Case 4 or 5.
      ELSE
C                                       Find the maximum antenna number
C                                       for subarray ISUB or, if ISUB is
C                                       zero or negative find the
C                                       largest maximum antenna number:
         IF (ISUB.GT.0) THEN
            MAXANT = NUMAN(ISUB+1)
         ELSE
            MAXANT = 0
            DO 300 I = 2, NUMAN(1) + 1
               MAXANT = MAX (MAXANT, NUMAN(I))
 300           CONTINUE
            IF (MAXANT.EQ.0) THEN
               MAXANT = 28
               END IF
            END IF

C                                       Save the maximum number of
C                                       allowed baselines:
         MXBASE = NBASE
C                                       (The fact that this is necessary
C                                       indicates some degree of
C                                       sloppiness in the specifications
C                                       for this routine.)

C                                       Generate a complete list of
C                                       baselines and save those that
C                                       meet our criteria:
         NBASE = 0
         DO 320 I = 1,MAXANT
            DO 310 J = I,MAXANT
               LT = REQBAS (I, J, .TRUE., UNQANT, NUNANT, UNQBAS,
     *            NUNBAS)
               IF (LT) THEN
                  IF (NBASE.LT.MXBASE) THEN
                     NBASE = NBASE + 1
                     ANT1(NBASE) = I
                     ANT2(NBASE) = J
C                                       Case 6 (overflow)
                  ELSE
                     NBASE = 0
                     MSGTXT = 'AN10RS: TOO MANY BASELINES IN ' //
     *                  'SELECTION LIST'
                     CALL MSGWRT (6)
                     WRITE (MSGTXT,1300) MXBASE
                     CALL MSGWRT (6)
                     GO TO 999
                     END IF
                  END IF
 310           CONTINUE
 320        CONTINUE
         END IF

 999  RETURN
C-----------------------------------------------------------------------
 1300 FORMAT (8X,'BREAK INTO SUBSETS OF ', I5, ' BASELINES OR LESS')
      END

LOCAL INCLUDE 'HOCLN.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQI(4), SEQO(2), DISKI(4), DISKO(2), CNOO(2), CNOI(4),
     *   CATOLD(256,4), CATNEW(256,2), NUMHIS, JBUFSZ
      HOLLERITH XNAME1(3), XCLAS1(2), XNAME2(3), XCLAS2(2), XNAME3(3),
     *   XCLAS3(2), XNAME4(3), XCLAS4(2), XNAMOU(3), CATOH(256,4),
     *   CATNH(256,2)
      CHARACTER NAME(4)*12, CLASS(4)*6, NAMEO(2)*12, CLASSO(2)*6,
     *   HISCRD(2)*64
      REAL      XSEQ1, XDISK1, XSEQ2, XDISK2, XSEQ3, XDISK3, XSEQ4,
     *   XDISK4, XSEQO, XDISKO, XNIT, GAIN, BMAJ, XDOTV,
     *   BUFFI(MABFSS), BUFFO(MABFSS), CATOR(256,4), CATNR(256,2)
      COMMON /INPARM/ XNAME1, XCLAS1, XSEQ1, XDISK1, XNAME2, XCLAS2,
     *   XSEQ2, XDISK2, XNAME3, XCLAS3, XSEQ3, XDISK3, XNAME4, XCLAS4,
     *   XSEQ4, XDISK4, XNAMOU, XSEQO, XDISKO, XNIT, GAIN, BMAJ, XDOTV
      COMMON /CHPARM/ NAME, CLASS, NAMEO, CLASSO, HISCRD
      COMMON /PARMS/ CATOLD, CATNEW, SEQI, SEQO, DISKI, DISKO, CNOI,
     *   CNOO, JBUFSZ, NUMHIS
      COMMON /BUFRS/ BUFFI, BUFFO
      EQUIVALENCE (CATOLD, CATOH, CATOR)
      EQUIVALENCE (CATNEW, CATNH, CATNR)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
LOCAL END
      PROGRAM HOCLN
C-----------------------------------------------------------------------
C! weighted sum of two or more data cubes with weight sum also output
C# Map
C-----------------------------------------------------------------------
C;  Copyright (C) 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does a complex Clean of holography images
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAME(1)      Name of input image.
C      INCLASS        CLASS(1)     Class of input image.
C      INSEQ          SEQI(1)      Seq. of input image.
C      INDISK         DISKI(1)     Disk number of input image.
C      IN2NAME        NAME(2)      Name of 2nd input image.
C                                  ' ' => loop inseq:in2seq
C                                  and in3seq:(in2seq-inseq+in3seq)
C      IN2CLASS       CLASS(2)     Class of 2nd input image.
C      IN2SEQ         SEQI(2)      Seq. of 2nd input image.
C      IN2DISK        DISKI(2)     Disk number of 2nd input image.
C      IN3NAME        NAME(3)      Name of 1st weight image.
C      IN3CLASS       CLASS(3)     Class of 1st weight image.
C      IN3SEQ         SEQI(3)      Seq. of 1st weight image.
C      IN3DISK        DISKI(3)     Disk number of 1st weight image.
C      IN4NAME        NAME(4)      Name of 2nd weight image.
C      IN4CLASS       CLASS(4)     Class of 2nd weight image.
C      IN4SEQ         SEQI(4)      Seq. of 2nd weight image.
C      IN4DISK        DISKI(4)     Disk number of 2nd weight image.
C      OUTNAME        NAMEO        Name of the output image
C                                  Default output is input image.
C      OUTCLASS       CLASSO       Class of the output image.
C                                  Default is HOCLN
C                                  weight sum image is WHOCLN
C      OUTSEQ         SEQO         Seq. number of output image.
C      OUTDISK        DISKO        Disk number of the output image.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, NI, NB
      COMPLEX   IMAGE(512,512), BEAM(512,512), CSCR1(512,512),
     *   CSCR2(512,512)
      REAL      SCR1(512,512,2), SCR2(512,512,2)
      INCLUDE 'HOCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'HOCLN '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output files
      CALL HOCLIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Read in and format images
      NI = CATOLD(KINAX,1)
      NB = CATOLD(KINAX,3)
      CALL HOCLRD (NI, IMAGE, SCR1, NB, BEAM, SCR2, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Clean
      CALL HOCLCL (NI, IMAGE, CSCR1, CSCR2, NB, BEAM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Write out answer
      CALL HOCLWR (NI, IMAGE, SCR1, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       History
      CALL HOCLHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFFI)
C
 999  STOP
      END
      SUBROUTINE HOCLIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   HOCLIN gets input parameters for HOCLN and creates an output file.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      CHARACTER  STAT*4, MTYPE*2
      INTEGER   IERR, NPARM, IROUND, II
      LOGICAL   NOMATC
      INCLUDE 'HOCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 37
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAME1, BUFFI, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFFI, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAME1, NAME(1))
      CALL H2CHR (12, 1, XNAME2, NAME(2))
      CALL H2CHR (12, 1, XNAME3, NAME(3))
      CALL H2CHR (12, 1, XNAME4, NAME(4))
      CALL H2CHR (6, 1, XCLAS1, CLASS(1))
      CALL H2CHR (6, 1, XCLAS2, CLASS(2))
      CALL H2CHR (6, 1, XCLAS3, CLASS(3))
      CALL H2CHR (6, 1, XCLAS4, CLASS(4))
      CALL H2CHR (12, 1, XNAMOU, NAMEO(1))
C                                       Crunch input parameters.
      SEQI(1) = IROUND (XSEQ1)
      SEQI(2) = IROUND (XSEQ2)
      SEQI(3) = IROUND (XSEQ3)
      SEQI(4) = IROUND (XSEQ4)
      SEQO(1) = IROUND (XSEQO)
      SEQO(2) = IROUND (XSEQO)
      DISKI(1) = IROUND (XDISK1)
      DISKI(2) = IROUND (XDISK2)
      DISKI(3) = IROUND (XDISK3)
      DISKI(4) = IROUND (XDISK4)
      DISKO(1) = IROUND (XDISKO)
C                                       Create new file.
C                                       Get CATBLK from old files
      DO 10 II = 1,4
         CNOI(II) = 1
         MTYPE = 'MA'
         CALL CATDIR ('SRCH', DISKI(II), CNOI(II), NAME(II), CLASS(II),
     *      SEQI(II), MTYPE, NLUSER, STAT, BUFFI, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR, NAME(II), CLASS(II), SEQI(II),
     *         DISKI(II), NLUSER
            GO TO 990
            END IF
C                                       Read CATBLK and mark 'READ'.
         CALL CATIO ('READ', DISKI(II), CNOI(II), CATOLD(1,II), 'READ',
     *      BUFFI, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1040) IERR
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKI(II)
         FCNO(NCFILE) = CNOI(II)
         FRW(NCFILE) = 0
 10      CONTINUE
C                                       Checks
      NOMATC = .FALSE.
      IF ((CATOLD(KINAX,1).NE.256) .AND. (CATOLD(KINAX,1).NE.512))
     *   NOMATC = .TRUE.
      IF ((CATOLD(KINAX,2).NE.CATOLD(KINAX,1)) .AND.
     *   (CATOLD(KINAX,2).NE.CATOLD(KINAX,1))) NOMATC = .TRUE.
      IF ((CATOLD(KINAX+1,1).NE.CATOLD(KINAX,1)) .AND.
     *   (CATOLD(KINAX+1,1).NE.CATOLD(KINAX,1))) NOMATC = .TRUE.
      IF ((CATOLD(KINAX+1,2).NE.CATOLD(KINAX,2)) .AND.
     *   (CATOLD(KINAX+1,2).NE.CATOLD(KINAX,2))) NOMATC = .TRUE.
      IF (NOMATC) THEN
         MSGTXT = 'IMAGES DO NOT MATCH EXPECTATIONS'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      IF ((CATOLD(KINAX,3).NE.256) .AND. (CATOLD(KINAX,3).NE.512))
     *   NOMATC = .TRUE.
      IF ((CATOLD(KINAX,4).NE.CATOLD(KINAX,3)) .AND.
     *   (CATOLD(KINAX,4).NE.CATOLD(KINAX,3))) NOMATC = .TRUE.
      IF ((CATOLD(KINAX+1,3).NE.CATOLD(KINAX,3)) .AND.
     *   (CATOLD(KINAX+1,3).NE.CATOLD(KINAX,3))) NOMATC = .TRUE.
      IF ((CATOLD(KINAX+1,4).NE.CATOLD(KINAX,4)) .AND.
     *   (CATOLD(KINAX+1,4).NE.CATOLD(KINAX,4))) NOMATC = .TRUE.
      IF (NOMATC) THEN
         MSGTXT = 'BEAMS DO NOT MATCH EXPECTATIONS'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Copy old CATBLK to new.
      CALL COPY (256, CATOLD(1,1), CATBLK)
C                                       Put new values in CATBLK.
      CLASSO = 'C_AMP'
      CALL MAKOUT (NAME, CLASS, SEQI, '      ', NAMEO, CLASSO, SEQO)
      CALL CHR2H (12, NAMEO(1), KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLASSO(1), KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQO(1)
C                                       Create output file.
      CNOO(1) = 1
      IRET = 4
      CALL MCREAT (DISKO(1), CNOO(1), BUFFI, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO(1)
      FCNO(NCFILE) = CNOO(1)
      FRW(NCFILE) = 2
      SEQO(1) = CATBLK(KIIMS)
      CALL COPY (256, CATBLK, CATNEW(1,1))
C                                       copy most keywords
      CALL KEYPCP (DISKI(1), CNOI(1), DISKO(1), CNOO(1), 0, ' ', IERR)
C                                       make second output
      NAMEO(2) = NAMEO(1)
      CLASSO(2) = 'C_PHA'
      DISKO(2) = DISKO(1)
      CALL COPY (256, CATOLD(1,3), CATBLK)
C                                       Put new values in CATBLK.
      CALL CHR2H (12, NAMEO(2), KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLASSO(2), KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQO(2)
      CALL RCOPY (2, CATOH(KHBUN,2), CATH(KHBUN))
C                                       Create output file.
      CNOO(2) = 1
      IRET = 4
      CALL MCREAT (DISKO(2), CNOO(2), BUFFI, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO(2)
      FCNO(NCFILE) = CNOO(2)
      FRW(NCFILE) = 2
      SEQO(2) = CATBLK(KIIMS)
C                                       copy most keywords
      CALL KEYPCP (DISKI(1), CNOI(1), DISKO(2), CNOO(2), 0, ' ', IERR)
      CALL COPY (256, CATBLK, CATNEW(1,2))
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('HOCLIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1060 FORMAT ('HOCLIN: ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE HOCLRD (NI, IMAGE, WORK1, NB, BEAM, WORK2, IRET)
C-----------------------------------------------------------------------
C   HOCLRD reads the input files and makes image in ram for cleaning
C   Inputs:
C      NI      I      Size of images
C   Output:
C      IMAGE   C(*)   Real, imaginary  of image
C      BEAM    C(*)   Real, imaginary  of beam
C      WORK1   R(*)   real work array
C      WORK2   R(*)   real work array
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NI, NB, IRET
      COMPLEX   IMAGE(NI,NI), BEAM(NB,NB)
      REAL      WORK1(NI,NI,2), WORK2(NB,NB,2)
C
      CHARACTER IFILE*48
      INTEGER   LUNI, NYI, NXI, WINI(4), BOI, I1, I2, IPOS(7),
     *   II, BOTEMP, IBIND, INDI, NPIX
      REAL      BMAX, AMP, PHS
      LOGICAL   T, F
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'HOCLN.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUNI /16/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Setup for I/O
      NXI = CATOLD(KINAX,1)
      NYI = CATOLD(KINAX+1,1)
      WINI(1) = 1
      WINI(2) = 1
      WINI(3) = NXI
      WINI(4) = NYI
C                                       LOOP POINT:
C                                       Open and init for read
      DO 30 II = 1,4
         CALL ZPHFIL ('MA', DISKI(II), CNOI(II), 1, IFILE, IRET)
         CALL ZOPEN (LUNI, INDI, DISKI(II), IFILE, T, F, T, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, II, 'OPEN FILE'
            GO TO 990
            END IF
         CALL FILL (7, 1, IPOS)
C                                       Init. files, 1st & 2nd input.
         CALL COMOFF (CATOLD(KIDIM,II), CATOLD(KINAX,II), IPOS(3),
     *      BOTEMP, IRET)
         BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFFI, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, II, 'INIT READ'
            GO TO 990
            END IF
         DO 20 I2 = 1,NYI
            IPOS(2) = I2
            IPOS(1) = 1
C                                       Read.
            CALL MDISK ('READ', LUNI, INDI, BUFFI, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, II, 'READ ROW'
               GO TO 990
               END IF
C                                       Check max, min, blanking.
            IF (II.LE.2) THEN
               CALL RCOPY (NXI, BUFFI(IBIND), WORK1(1,I2,II))
            ELSE
               CALL RCOPY (NXI, BUFFI(IBIND), WORK2(1,I2,II-2))
               END IF
 20         CONTINUE
         IF (II.EQ.2) THEN
            NXI = CATOLD(KINAX,3)
            NYI = CATOLD(KINAX+1,3)
            WINI(3) = NXI
            WINI(4) = NYI
            END IF
C                                       Close input map.
         CALL ZCLOSE (LUNI, INDI, IRET)
 30      CONTINUE
C                                       Find max min
      BMAX = 0.0
      DO 50 I2 = 1,NB
         DO 40 I1 = 1,NB
            IF ((WORK2(I1,I2,1).NE.FBLANK) .AND.
     *         (WORK2(I1,I2,2).NE.FBLANK)) BMAX = MAX (BMAX,
     *         WORK2(I1,I2,1))
 40         CONTINUE
 50      CONTINUE
      WRITE (MSGTXT,1050) BMAX
      CALL MSGWRT (2)
C                                       To real/imaginary
      NPIX = 0
      DO 70 I2 = 1,NI
         DO 60 I1 = 1,NI
            IF ((WORK1(I1,I2,1).NE.FBLANK) .AND.
     *         (WORK1(I1,I2,2).NE.FBLANK)) THEN
               AMP = WORK1(I1,I2,1)
               PHS = DG2RAD * WORK1(I1,I2,2)
               IMAGE(I1,I2) = AMP * CMPLX (COS(PHS), SIN(PHS))
               NPIX = NPIX + 1
            ELSE
               IMAGE(I1,I2) = CMPLX (FBLANK, FBLANK)
               END IF
 60         CONTINUE
 70      CONTINUE
      WRITE (MSGTXT,1070) 'IMAGE', NPIX
      CALL MSGWRT (2)
      NPIX = 0
      DO 90 I2 = 1,NB
         DO 80 I1 = 1,NB
            IF ((WORK2(I1,I2,1).NE.FBLANK) .AND.
     *         (WORK2(I1,I2,2).NE.FBLANK)) THEN
               AMP = WORK2(I1,I2,1) / BMAX
               PHS = DG2RAD * WORK2(I1,I2,2)
               BEAM(I1,I2) = AMP * CMPLX (COS(PHS), SIN(PHS))
               NPIX = NPIX + 1
            ELSE
               BEAM(I1,I2) = CMPLX (FBLANK, FBLANK)
               END IF
 80         CONTINUE
 90      CONTINUE
      WRITE (MSGTXT,1070) 'BEAM ', NPIX
      CALL MSGWRT (2)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('HOCLDO: ERROR',I3,' FILE',I2,' ON ',A)
 1050 FORMAT ('Scaling beam by maximum',F10.4)
 1070 FORMAT (A,' image has',I8,' unblanked pixels')
      END
      SUBROUTINE HOCLWR (NI, IMAGE, WORK, IRET)
C-----------------------------------------------------------------------
C   HOCLWR write out the answer
C   Inputs
C      NI      I      Number pixels on axis
C      IMAGE   C(*)   Image
C   Outputs
C      WORK    R(*)   Work array
C      IRET    I      Error code
C-----------------------------------------------------------------------
      INTEGER   NI, IRET
      COMPLEX   IMAGE(NI,NI)
      REAL      WORK(NI,NI,2)
C
      INTEGER   IX, IY, WINO(4), LUNO, INDO, BOO, BOTEMP, II, OBIND,
     *   CORN(5)
      REAL      AMAX, AMIN, PMAX, PMIN
      LOGICAL   BLNKD, T
      CHARACTER IFILE*48
      INCLUDE 'HOCLN.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA T /.TRUE./,   CORN /5*0/
      DATA LUNO /16/
C-----------------------------------------------------------------------
C                                       convert to amplitude/phase
      AMAX = -1.E10
      AMIN = -AMAX
      PMAX = AMAX
      PMIN = AMIN
      BLNKD = .FALSE.
      DO 20 IY = 1,NI
         DO 10 IX = 1,NI
            IF (REAL(IMAGE(IX,IY)).EQ.FBLANK) THEN
               WORK(IX,IY,1) = FBLANK
               WORK(IX,IY,2) = FBLANK
               BLNKD = .TRUE.
            ELSE
               WORK(IX,IY,1) = CABS (IMAGE(IX,IY))
               WORK(IX,IY,2) = RAD2DG *
     *            ATAN2 (IMAG(IMAGE(IX,IY)), REAL(IMAGE(IX,IY)))
               AMAX = MAX (AMAX, WORK(IX,IY,1))
               AMIN = MIN (AMIN, WORK(IX,IY,1))
               PMAX = MAX (PMAX, WORK(IX,IY,2))
               PMIN = MIN (PMIN, WORK(IX,IY,2))
               END IF
 10         CONTINUE
 20      CONTINUE
      CATNR(KRDMX,1) = AMAX
      CATNR(KRDMX,2) = PMAX
      CATNR(KRDMN,1) = AMIN
      CATNR(KRDMN,2) = PMIN
      WRITE (MSGTXT,2000) AMIN, AMAX
      CALL MSGWRT (2)
      WRITE (MSGTXT,2001) PMIN, PMAX
      CALL MSGWRT (2)
C                                       Mark blanking in CATBLK.
      CATNR(KRBLK,1) = 0.0
      IF (BLNKD) CATNR(KRBLK,1) = FBLANK
      CATNR(KRBLK,2) = 0.0
      IF (BLNKD) CATNR(KRBLK,2) = FBLANK
C                                       Now write them out
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NI
      WINO(4) = NI
C                                       Open and init for output
      DO 100 II = 1,2
         CALL ZPHFIL ('MA', DISKO(II), CNOO(II), 1, IFILE, IRET)
         CALL ZOPEN (LUNO, INDO, DISKO(II), IFILE, T, T, T, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, II, 'OPENING FILE'
            GO TO 990
            END IF
         CALL COMOFF (CATNEW(KIDIM,II), CATNEW(KINAX,II), CORN, BOTEMP,
     *      IRET)
         BOO = BOTEMP + 1
         CALL MINIT ('WRIT', LUNO, INDO, NI, NI, WINO, BUFFO, JBUFSZ,
     *      BOO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, II, 'INIT I/O'
            GO TO 990
            END IF
         DO 40 IY = 1,NI
            CALL MDISK ('WRIT', LUNO, INDO, BUFFO, OBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, II, 'WRITE FILE'
               GO TO 990
               END IF
            CALL RCOPY (NI, WORK(1,IY,II), BUFFO(OBIND))
 40         CONTINUE
C                                       Flush buffer.
         CALL MDISK ('FINI', LUNO, INDO, BUFFO, OBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, II, 'FLUSH OUTPUT BUFFER'
            GO TO 990
            END IF
         CALL ZCLOSE (LUNO, INDO, IRET)
C                                       update catalog
         CALL CATIO ('UPDT', DISKO(1), CNOO(1), CATNEW(1,1), 'REST',
     *      BUFFI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, II, 'UPDATING CATALOG HEADER'
            GO TO 990
            END IF
 100     CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('HOCLWR: ERROR',I4,' FILE',I2,' ON ',A)
 2000 FORMAT ('Writing amplitude range',2(1PE12.4))
 2001 FORMAT ('Writing phase range    ',2F7.1)
      END
      SUBROUTINE HOCLTV (ITER, NI, IMAGE, SCRTCH, IRET)
C-----------------------------------------------------------------------
C   Displays residual on TV - gets quit command
C   Inputs
C      ITER     I      Iteration number: 0 at start, -1 final image
C                         -99 component sum image
C      NI       I      Image size
C      IMAGE    R(*)   Image(NI,NI,2)
C   Outputs
C      SCRTCH   R(*)   Scratch image
C      IRET     I      Error code
C-----------------------------------------------------------------------
      INTEGER   ITER, NI, IRET
      COMPLEX   IMAGE(NI,NI)
      REAL      SCRTCH(*)
C
      INTEGER   IX, IY, I, ICH, TVWIN(4), IBUFF(1024), IQ, IB, HORIZ,
     *   IYTV, VX(5), VY(5), IGR, NSUM, INCHAR
      REAL      IMAX(2), TD, RPOS(2), SUM, SUMS
      CHARACTER TRANFN*2, STRING*48
      LOGICAL   F
      INCLUDE 'HOCLN.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      HORIZ = 0
      IMAX(1) = 0.0
      IMAX(2) = 0.0
      NSUM = 0
      SUM = 0.0
      SUMS = 0.0
      DO 20 IY = 1,NI
         DO 10 IX = 1,NI
            I = I + 1
            IF (REAL(IMAGE(IX,IY)).NE.FBLANK) THEN
               SCRTCH(I) = CABS (IMAGE(IX,IY))
               NSUM = NSUM + 1
               SUM = SUM + SCRTCH(I)
               SUMS = SUMS + SCRTCH(I) * SCRTCH(I)
               IMAX(2) = MAX (IMAX(2), SCRTCH(I))
            ELSE
               SCRTCH(I) = FBLANK
               END IF
 10         CONTINUE
 20      CONTINUE
      IF (NSUM.GT.0) THEN
         SUM = SUM / NSUM
         SUMS = SUMS/NSUM - SUM*SUM
         IF (SUMS.GT.0.0) SUMS = SQRT (SUMS)
         END IF
      IF (ITER.GE.0) THEN
         WRITE (MSGTXT,1010) ITER, IMAX(2), SUMS
         WRITE (STRING,2010) ITER, IMAX(2), SUMS
      ELSE IF (ITER.EQ.-1) THEN
         WRITE (MSGTXT,1011) IMAX(2), SUMS
         WRITE (STRING,2011) IMAX(2), SUMS
      ELSE
         WRITE (MSGTXT,1012) IMAX(2), SUMS
         WRITE (STRING,2012) IMAX(2), SUMS
         END IF
      CALL MSGWRT (2)
      IRET = 0
      IF (XDOTV.LE.0.0) GO TO 999
      CALL REFRMT (STRING, '_', INCHAR)
C                                       open TV
      CALL TVOPEN (BUFFI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING TV'
         GO TO 990
         END IF
      ICH = 1
      CALL TVSET (ICH, BUFFI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT TV'
         GO TO 980
         END IF
      IGR = 2 + NGRAY
      CALL YZERO (IGR, IRET)
      TVWIN(1) = (MAXXTV(1) - NI) / 2
      TVWIN(2) = (MAXXTV(2) - NI) / 2
      TVWIN(3) = TVWIN(1) + NI - 1
      TVWIN(4) = TVWIN(2) + NI - 1
C                                       image catalog
      CALL COPY (256, CATNEW(1,1), CATBLK)
      CALL COPY (4, TVWIN, CATBLK(IICOR))
      CATBLK(IIWIN) = 1
      CATBLK(IIWIN+1) = 1
      CATBLK(IIWIN+2) = NI
      CATBLK(IIWIN+3) = NI
      CALL CHR2H (2, TRANFN, 1, CATH(IITRA))
      CATR(IRRAN) = IMAX(1)
      CATR(IRRAN+1) = IMAX(2)
      CALL CHR2H (8, 'Holorast', 1, CATH(KHOBJ))
      CALL FILL (5, 1, CATBLK(IIDEP))
      CATR(KRDMX) = IMAX(2)
      CALL YCWRIT (ICH, TVWIN, CATBLK, IBUFF, IRET)
C                                       label
      IYTV = TVWIN(4) + 2.5 * CSIZTV(2) + 0.5
      CALL IMANOT ('ONNN', 2, TVWIN(1), IYTV, 0, 0, STRING(:INCHAR),
     *   SCRTCH, IRET)
      CALL IMANOT ('WRIT', 2, TVWIN(1), IYTV, 0, 0, STRING(:INCHAR),
     *   SCRTCH, IRET)
      VX(1) = TVWIN(1) - 1
      VY(1) = TVWIN(2) - 1
      VX(2) = TVWIN(3) + 1
      VY(2) = VY(1)
      VX(3) = VX(2)
      VY(3) = TVWIN(4) + 1
      VX(4) = VX(1)
      VY(4) = VY(3)
      VX(5) = VX(1)
      VY(5) = VY(1)
      CALL IMVECT ('ONNN', IGR, 6, VX, VY, SCRTCH, IRET)
      CALL IAXIS1 (SCRTCH, 3, 2, 0, .FALSE., IRET)
C
      IYTV = TVWIN(2) - 1
      I = 1 - NI
      TRANFN = 'LN'
      DO 40 IY = 1,NI
         IYTV = IYTV + 1
         I = I + NI
         CALL ISCALE (TRANFN, MAXINT, IMAX, NI, 1, SCRTCH(I), IBUFF)
         CALL YIMGIO ('WRIT', ICH, TVWIN(1), IYTV, HORIZ, NI, IBUFF,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'LOADING TV'
            GO TO 980
            ENDIF
 40      CONTINUE
C                                       stop now?
      IY = XNIT + 0.1
      IF (ITER.EQ.-1) GO TO 150
      MSGTXT = 'Hit button D within 15 seconds to stop cleaning now'
      IF (ITER.LT.0) MSGTXT = 'Hit button D to see restored image now'
      IF (ITER.EQ.IY) MSGTXT =
     *   'Hit button D to see components image now'
      CALL MSGWRT (1)
      MSGTXT = 'Hit buttons A, B, or C to continue sooner'
      CALL MSGWRT (1)
      RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2.0
      RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2.0
      TD = 0.4
      CALL YCURSE ('ONNN', F, F, RPOS, IQ, IB, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CALLING YCURSE'
         GO TO 980
         END IF
      DO 130 I = 1,75
         CALL ZDELAY (TD, IRET)
         CALL YCURSE ('READ', F, F, RPOS, IQ, IB, IRET)
         IF (IB.GT.7) GO TO 140
         IF (IB.GT.0) GO TO 135
         IF (IRET .NE.0) GO TO 135
 130     CONTINUE
 135  MSGTXT = 'Continuing'
      CALL MSGWRT (1)
      IRET = 0
      GO TO 150
C                                       Wants to quit
 140  MSGTXT = 'TV Button D hit: have done enough I guess'
      CALL MSGWRT (3)
      IRET = -1
 150  CALL TVCLOS (BUFFI, I)
      GO TO 999
C
 980  CALL MSGWRT (8)
      CALL TVCLOS (BUFFI, I)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('HOCLTV ERROR',I4,' ON ',A)
 1010 FORMAT ('At iteration',I4,' pixel max',1PE12.4,'  rms',1PE12.4)
 1011 FORMAT ('Final image, pixel max',1PE12.4,'  rms',1PE12.4)
 1012 FORMAT ('Component image, pixel max',1PE12.4,'  rms',1PE12.4)
 2010 FORMAT ('ITER',I3,'____ MAX',F7.2,'___  RMS',F8.3)
 2011 FORMAT ('FINAL IMAGE MAX',F7.2,'___ RMS',F8.3)
 2012 FORMAT ('COMPONENT IMAGE MAX',F7.2,'___ RMS',F8.3)
      END
      SUBROUTINE HOCLHI
C-----------------------------------------------------------------------
C   HOCLHI copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER LABEL*8, LINE*80, NOTTYP*2
      INTEGER   LUN1, LUN2, IERR, I
      LOGICAL   T
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'HOCLN.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NOTTYP /'CC'/
C-----------------------------------------------------------------------
      CALL HIINIT (3)
C                                       Write History: output 1
C                                       Copy/open history file.
      CALL COPY (256, CATNEW(1,1), CATBLK)
      CALL HISCOP (LUN1, LUN2, DISKI(1), DISKO(1), CNOI(1), CNOO,
     *   CATBLK, BUFFI, BUFFO, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) 1, IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAME(1), CLASS(1), SEQI(1), DISKI(1), LUN2,
     *   BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCO2 (TSKNAM, NAME(2), CLASS(2), SEQI(2), DISKI(2), LUN2,
     *   BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCO3 (TSKNAM, NAME(3), CLASS(3), SEQI(3), DISKI(3), LUN2,
     *   BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCO4 (TSKNAM, NAME(4), CLASS(4), SEQI(4), DISKI(4), LUN2,
     *   BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCOO (TSKNAM, NAMEO(1), CLASSO(1), SEQO(1), DISKO(1), LUN2,
     *   BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (LINE,2000) TSKNAM, GAIN
      CALL HIADD (LUN2, LINE, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (LINE,2001) TSKNAM, BMAJ
      CALL HIADD (LUN2, LINE, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
      I = XNIT + 0.1
      WRITE (LINE,2002) TSKNAM, I
      CALL HIADD (LUN2, LINE, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
C                                      Add any user supplied history.
      IF (NUMHIS.GT.0) THEN
         WRITE (LABEL,1010) TSKNAM
         LINE(1:8) = LABEL(1:8)
         DO 50 I = 1,NUMHIS
            LINE(9:64) = HISCRD(I)(1:64)
            CALL HIADD (LUN2, LINE, BUFFO, IERR)
            IF (IERR.NE.0) GO TO 100
 50         CONTINUE
         END IF
C                                       Close HI file
 100  CALL HICLOS (LUN2, T, BUFFO, IERR)
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO(1), CNOO(1), CATBLK, 'REST', BUFFI,
     *   IERR)
C                                       Write History: output 1
C                                       Copy/open history file.
      CALL COPY (256, CATNEW(1,2), CATBLK)
      CALL HISCOP (LUN1, LUN2, DISKI(3), DISKO(2), CNOI(3), CNOO(2),
     *   CATBLK, BUFFI, BUFFO, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) 2, IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO3 (TSKNAM, NAME(3), CLASS(3), SEQI(3), DISKI(3), LUN2,
     *   BUFFO, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCO4 (TSKNAM, NAME(4), CLASS(4), SEQI(4), DISKI(4), LUN2,
     *   BUFFO, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMEO(2), CLASSO(2), SEQO(2), DISKO(2), LUN2,
     *   BUFFO, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (LINE,2000) TSKNAM, GAIN
      CALL HIADD (LUN2, LINE, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (LINE,2001) TSKNAM, BMAJ
      CALL HIADD (LUN2, LINE, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
      I = XNIT + 0.1
      WRITE (LINE,2002) TSKNAM, I
      CALL HIADD (LUN2, LINE, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
C                                      Add any user supplied history.
      IF (NUMHIS.GT.0) THEN
         WRITE (LABEL,1010) TSKNAM
         LINE(1:8) = LABEL(1:8)
         DO 150 I = 1,NUMHIS
            LINE(9:64) = HISCRD(I)(1:64)
            CALL HIADD (LUN2, LINE, BUFFO, IERR)
            IF (IERR.NE.0) GO TO 200
 150        CONTINUE
         END IF
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, BUFFO, IERR)
C                                        Copy tables
      CALL ALLTAB (1, NOTTYP, LUN1, LUN2, DISKI, DISKO, CNOI, CNOO,
     *   CATBLK, BUFFI, BUFFO, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO(2), CNOO(2), CATBLK, 'REST', BUFFI,
     *   IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('HOCLHI: COPY/OPEN HISTORY FILE #',I2,' ERROR',I3)
 1010 FORMAT (A6,' /')
 2000 FORMAT (A6,'GAIN =',F6.3,'   / Clean loop gain')
 2001 FORMAT (A6,'BMAJ =',F6.3,'   / Restoring beam FWHN pixels')
 2002 FORMAT (A6,'NITER =',I5,'   / Number major cycles used')
      END
      SUBROUTINE HOCLCL (NI, IMAGE, WORK, CSUM, NB, BEAM, IRET)
C-----------------------------------------------------------------------
C   HOCLCL does the actual Clean operation
C   Inputs:
C      NI      I      Size of image
C      NB      I      Size of beam
C      BEAM    C(*)   Beam
C   In/out:
C      IMAGE   C(*)   image
C   Output
C      WORK    C(*)   work array
C      CSUM    C(*)   sum of Clean comps
C      IRET    I      Error code
C-----------------------------------------------------------------------
      INTEGER   NI, NB, IRET
      COMPLEX   IMAGE(NI,NI), WORK(NI,NI), CSUM(NI,NI), BEAM(NB,NB)
C
      INCLUDE 'HOCLN.INC'
      INTEGER   CX, CY, BX, BY, IX, IY, JX, JY, ITER, NITER, KX, KY,
     *   CBL, CBH, NPIX
      COMPLEX   PIXVAL
      REAL      PEAK, CB(25,25), F, R, SCRTCH(512,512), TOT
      LONGINT   NTOT
C-----------------------------------------------------------------------
C                                       zero CSUM
      DO 20 IY = 1,NI
         DO 10 IX = 1,NI
            CSUM(IX,IY) = CMPLX (0.0, 0.0)
 10         CONTINUE
 20      CONTINUE
C                                       init display
      CALL HOCLTV (0, NI, IMAGE, SCRTCH, IRET)
      IF (IRET.LT.0) THEN
         IRET = 0
         GO TO 999
      ELSE IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT DISPLAY ON TV'
         GO TO 990
         END IF
C                                       Outer loop
      NITER = XNIT + 0.1
      CX = NI / 2
      CY = NI /2 + 1
      BX = NB / 2
      BY = NB / 2 + 1
      DO 100 ITER = 1,NITER
         WRITE (MSGTXT,1010) ITER
         CALL MSGWRT (2)
         IX = 2 * NI * NI
         CALL CXCOPY (IX, IMAGE, WORK)
C                                       loop over current resid
         NPIX = 0
         NTOT = 0
         DO 60 IY = 1,NI
            DO 50 IX = 1,NI
               IF (REAL(WORK(IX,IY)).NE.FBLANK) THEN
                  PIXVAL = GAIN * WORK(IX,IY)
                  NPIX = NPIX + 1
                  DO 40 JY = 1,NB
                     DO 30 JX = 1,NB
                        KX = JX - BX + IX
                        KY = JY - BY + IY
                        IF ((KX.GE.1) .AND. (KX.LE.NI) .AND. (KY.GE.1)
     *                     .AND. (KY.LE.NI)) THEN
                           IF (REAL(IMAGE(KX,KY)).NE.FBLANK) THEN
                              IMAGE(KX,KY) = IMAGE(KX,KY) -
     *                           PIXVAL * BEAM(JX,JY)
                              NTOT = NTOT + 1
                              END IF
                           END IF
 30                     CONTINUE
 40                  CONTINUE
                  END IF
 50            CONTINUE
 60         CONTINUE
         WRITE (MSGTXT,1060) NPIX, NTOT
         CALL MSGWRT (2)
C                                       add to CCs
         DO 80 IY = 1,NI
            DO 70 IX = 1,NI
               IF (REAL(IMAGE(IX,IY)).NE.FBLANK) THEN
                  CSUM(IX,IY) = CSUM(IX,IY) + WORK(IX,IY)
                  END IF
 70            CONTINUE
 80         CONTINUE
C                                       TV display
         CALL HOCLTV (ITER, NI, IMAGE, SCRTCH, IRET)
         IF (IRET.LT.0) THEN
            IRET = 0
            GO TO 110
         ELSE IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'DISPLAY ON TV'
            GO TO 990
            END IF
 100     CONTINUE
C                                       restore CCs
C                                       get the beam
 110  MSGTXT = 'Restoring components'
      CALL MSGWRT (2)
      XNIT = MIN (ITER, NITER)
      IF (BMAJ.LE.0.0) THEN
         PEAK = CABS (BEAM(BX,BY))
         DO 120 IX = 1,12
            IF (CABS(BEAM(BX-IX,BY)).LT.PEAK/2.) THEN
               BMAJ = IX - (PEAK/2.-BEAM(BX-IX+1,BY)) / (BEAM(BX-IX,BY)
     *            - BEAM(BX-IX+1,BY))
               BMAJ = 2 * BMAJ
               GO TO 130
               END IF
 120        CONTINUE
         BMAJ = 8.
         END IF
 130  F = 2 * LOG(2.0) / (BMAJ * BMAJ)
      DO 145 IX = 1,25
         DO 140 IY = 1,25
            R = (IX-13)**2 + (IY-13)**2
            CB(IX,IY) = EXP (-F * R)
 140        CONTINUE
 145     CONTINUE
      DO 150 IX = 1,25
         IF (CB(IX,13).GT.0.001) GO TO 155
 150     CONTINUE
 155  CBL = IX
      CBH = 26 - IX
C                                       scale
      TOT = 0.0
      DO 165 JY = CBL,CBH
         DO 160 JX = CBL,CBH
            TOT = TOT + CB(JX,JY)
 160        CONTINUE
 165     CONTINUE
      DO 175 JY = 1,25
         DO 170 JX = 1,25
            CB(JX,JY) = CB(JX,JY) / TOT
 170        CONTINUE
 175     CONTINUE
C                                       now restore
      DO 250 IY = 1,NI
         DO 240 IX = 1,NI
            IF (REAL(IMAGE(IX,IY)).NE.FBLANK) THEN
               PIXVAL = CSUM(IX,IY)
               DO 220 JY = CBL,CBH
                  DO 210 JX = CBL,CBH
                     KX = JX - 13 + IX
                     KY = JY - 13 + IY
                     IF ((KX.GE.1) .AND. (KX.LE.NI) .AND. (KY.GE.1)
     *                  .AND. (KY.LE.NI)) THEN
                        IF (REAL(IMAGE(KX,KY)).NE.FBLANK) THEN
                           IMAGE(KX,KY) = IMAGE(KX,KY) + CB(JX,JY) *
     *                        PIXVAL
                           END IF
                        END IF
 210                 CONTINUE
 220              CONTINUE
               END IF
 240        CONTINUE
 250     CONTINUE
C                                       final displays
      CALL HOCLTV (-99, NI, CSUM, SCRTCH, IRET)
      CALL HOCLTV (-1, NI, IMAGE, SCRTCH, IRET)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('HOCLCL: ERRIR',I4,' ON ',A)
 1010 FORMAT ('Start major cycle',I4)
 1060 FORMAT (I6,' pixels with',I14,' total subtractions')
      END

LOCAL INCLUDE 'SNBLP.INC'
      INTEGER   NCODE
      PARAMETER (NCODE=4)
C                                       Local include for SNBLP
      INCLUDE 'INCS:PUVD.INC'
C                                       Input parameters
      REAL      XSIN, XDISIN, XNVER, XQUAL, XTIME(8), XBAND, XFREQ,
     *   XFQID, XSUBA, XBIF, XEIF, XANT(50), PIXR(2), XNCOU, XXINC,
     *   APARM(10), BPARM(10), CPARM(10), XDO3C, XPCNUM, XSYM,
     *   FACTOR, XDOBL, CUTOFF, XSCAN, XLABEL, XDOTV, XGRCH, XYRATO
      HOLLERITH XNAMEI(3), XCLAIN(2), XTYPE(1), XXSOUR(4,30), XXSTOK(1),
     *   XOPTY(1), XOPCOD(1)
      CHARACTER NAMEIN*12, CLAIN*6, TYPE*2, XSOUR(30)*16, XSTOK*4,
     *   OPTYPE*4, OPCODE*4
C                                       Program info
C
      INTEGER   MXSCAN
      PARAMETER (MXSCAN=5000)
C
      REAL      TSTART, TSTOP, XYSCL(2), XYOFF(2), XMX, XMN, XMXW, XMNW,
     *   GMMOD, RATFAC(MAXIF), SELBAN,XSTART, XSTOP, CHOUT(4), XXMIN,
     *   XXMAX, YYMIN, TSCAN(MXSCAN), PPMAX, YYMAX, PPMIN, PRAN(2,2),
     *   DO3COL, CSMIN, CSMAX
      INTEGER   SEQIN, DISKIN, CNOIN, IVER, BIF, ANTS(50), NCOUNT,
     *   ICODES(4), NCODES, NPARMS, NID, SID(500), NANTSL, NPLOTS,
     *   SUMSTK, ISTOK, FRQSEL, XINC, GRCHN, TVCHN, TVCORN(4),
     *   ISOU, OSOU, IANT, EIF, ITPLOT, ITVER, PCNUM, LABEL, SUBARR,
     *   MUMPOL, MUMIF, MUMANT, MTIMES, ISYM,
     *   BSYM, NANREC(MAXANT), ANTNUM(MAXANT), ANTNNN(MAXANT), NOSCAN,
     *   STRANS(MXSCAN)
      LOGICAL   DOAWNT, DOTV, NNODAT, DOLINE, SWAP
      DOUBLE PRECISION SELFRQ, GNRECD(XCLRSZ/2)
C                                       SN/CL table info
      INTEGER CLBUFF(512), NCLINR, NUMANT, NUMPOL, NUMIF, ICLRNO,
     *   KOLS(40), KOLTYP(40), KOLDIM(40), ICLUN, GNRECI(XCLRSZ),
     *   TIMKOL, INTKOL, SOUKOL, ANTKOL, SUBKOL, FRQKOL, IFRKOL,
     *   GEOKOL, DOPKOL, ATMKOL, DATKOL,
     *   MB1KOL, RE1KOL, IM1KOL, DL1KOL, RA1KOL, WT1KOL, RF1KOL,
     *   CK1KOL, DC1KOL, DS1KOL, DD1KOL,
     *   MB2KOL, RE2KOL, IM2KOL, DL2KOL, RA2KOL, WT2KOL, RF2KOL,
     *   CK2KOL, DC2KOL, DS2KOL, DD2KOL,
     *   REKOL(4), IMKOL(4), DLKOL(4), RAKOL(4), WTKOL(4),
     *   DOPLKL, DOP3KL, CLTIME
      REAL GNREC(XCLRSZ)
C                                       Constants
      DOUBLE PRECISION SIDER, CLIGHT
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XTYPE, XNVER,
     *   XXSOUR, XQUAL, XTIME, XXSTOK, XBAND, XFREQ, XFQID, XSUBA, XBIF,
     *   XEIF, XANT, PIXR, XNCOU, XXINC, XOPTY, XOPCOD, APARM, BPARM,
     *   CPARM, XDO3C, XPCNUM, XSYM, FACTOR, XDOBL, CUTOFF,
     *   XSCAN, XLABEL, XDOTV, XGRCH, XYRATO
      COMMON /VPARM/ SEQIN, DISKIN, CNOIN, IVER, BIF, EIF, ANTS, NCOUNT,
     *   ICODES, NCODES, NPARMS, GRCHN, TVCHN, TVCORN, ISOU, OSOU,
     *   IANT, ITPLOT, ITVER, PCNUM, DOTV, NNODAT, LABEL, CHOUT, DO3COL,
     *   DOLINE, NOSCAN, TSCAN, STRANS, SWAP
      COMMON /VGNCOM/ SELFRQ,
     *   TSTART, TSTOP, XYSCL, XYOFF, SELBAN, XMX, XMN, XMXW,
     *   XMNW, XSTART, XSTOP, GMMOD, RATFAC, NID, SID, NANTSL, PRAN,
     *   NPLOTS, DOAWNT, ISTOK, SUMSTK, FRQSEL, XINC,
     *   SUBARR, MUMPOL, MUMIF, MUMANT, MTIMES,
     *   XXMIN, XXMAX, YYMIN, YYMAX, PPMIN, PPMAX, ISYM,
     *   BSYM, NANREC, ANTNUM, ANTNNN, CSMIN, CSMAX
      COMMON /VGNCHR/ NAMEIN, CLAIN, TYPE, XSOUR, XSTOK, OPTYPE,
     *   OPCODE
      COMMON /TABCOM/ GNREC, CLBUFF, NCLINR, NUMANT, NUMPOL, NUMIF,
     *   ICLRNO, KOLS, KOLTYP, KOLDIM, ICLUN,
     *   REKOL, IMKOL, DLKOL, RAKOL, WTKOL,
     *   DOPLKL, DOP3KL, CLTIME
      COMMON /CONST/ SIDER, CLIGHT
      EQUIVALENCE (GNREC, GNRECD, GNRECI)
      EQUIVALENCE (KOLS(1), TIMKOL), (KOLS(2), INTKOL),
     *   (KOLS(3), SOUKOL), (KOLS(4), ANTKOL), (KOLS(5), SUBKOL),
     *   (KOLS(6), FRQKOL), (KOLS(7), IFRKOL),
     *   (KOLS(8), GEOKOL), (KOLS(9), DOPKOL), (KOLS(10), ATMKOL),
     *   (KOLS(11), DATKOL)
      EQUIVALENCE (KOLS(12), MB1KOL),
     *   (KOLS(13), RE1KOL), (KOLS(14), IM1KOL),
     *   (KOLS(15), RA1KOL), (KOLS(16), DL1KOL), (KOLS(17), WT1KOL),
     *   (KOLS(18), RF1KOL), (KOLS(19), CK1KOL), (KOLS(20), DC1KOL),
     *   (KOLS(21), DS1KOL), (KOLS(22), DD1KOL)
      EQUIVALENCE (KOLS(23), MB2KOL),
     *   (KOLS(24), RE2KOL), (KOLS(25), IM2KOL),
     *   (KOLS(26), RA2KOL), (KOLS(27), DL2KOL), (KOLS(28), WT2KOL),
     *   (KOLS(29), RF2KOL), (KOLS(30), CK2KOL), (KOLS(31), DC2KOL),
     *   (KOLS(32), DS2KOL), (KOLS(33), DD2KOL)
C                                                          End SNBLP
LOCAL END
      PROGRAM SNBLP
C-----------------------------------------------------------------------
C! Plots data from a SN or CL table in baseline form
C# UV Plot EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2018, 2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SNBLP plots SN or CL extension files. A 'PL' extension file is made
C   which can be displayed in the usual ways .
C   Inputs:
C      INNAME.....UV file name (name).       Standard defaults.
C      INCLASS....UV file name (class).      Standard defaults.
C      INSEQ......UV file name (seq. #).     0 => highest.
C      INDISK.....Disk unit #.               0 => any.
C      INEXT......'SN','TY','PC' or 'CL' table to be plotted
C      INVERS.....Version number of table to plot, 0=>highest no.
C      SOURCES....Source list.  '*' = all; a "-" before a source
C                 name means all except ANY source named.
C      TIMERANG...Time range of the data to be plotted. In order:
C                 Start day, hour, min. sec,
C                 end day, hour, min. sec. Days relative to ref.
C                 date.
C      STOKES.....The desired Stokes type of the output data:
C                 'R' = RCP, 'L' = LCP, 'DIFF' = difference
C      BIF........IF to plot
C      ANTENNAS...A list of the antennas to be plotted. All 0 => all.
C                 If any number is negative then all antennas listed
C                 are NOT to be plotted and all others are.
C      PIXRANGE...Limit the plot to values between PIXR(1) and
C                 PIXR(2).  The plots will not exceed the min/max in
C                 the actual gains.  Basically, if PIXR(1) < PIXR(2),
C                 all plots will be on the same scale and be limited
C                 to max (datamin, PIXR(1)) through min (datamax,
C                 PIXR(2)).  If PIXR(1) >= PIXR(2), each plot will be
C                 self-scaled individually.
C      NCOUNT.....Number of antennas to plot per page (try 5).
C      OPTYPE.....Data to be plotted: 'PHAS' = phase, 'AMP '=  ampl.,
C                 'DELA' = delay, 'RATE' = rate
C                 '    ' => 'PHAS'
C      OPCODE.....'IFDF' = IF difference, 'PLIF' = all IF's for
C                 specified antennas, ' ' = just OPTYPE
C      XTYPE......Variable data to be plotted against,
C                 1 = IAT time; 2 = elevation; 3 = HA, 4 = LST
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C-----------------------------------------------------------------------
C
      CHARACTER PRGN*6
      REAL      PLTPTS(2), TABPTS(2)
      LONGINT   PPLTPT, PTABPT
      INTEGER   IRET, MVAL, NWORDS, NROWS
      INCLUDE 'SNBLP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGN /'SNBLP '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL SNPIN (PRGN, NROWS, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       read data to figure out
C                                       distribution
      CALL SNPCNT (IRET)
C                                       allocate memory to hold table
      MUMANT = MAX (1, MUMANT)
      MVAL = 2 + MUMPOL*MUMIF*NCODES
      NWORDS = (MVAL * MUMANT * MTIMES - 1) / 1024  + 21
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, TABPTS, PTABPT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
      NWORDS = (MVAL * MTIMES - 1) / 1024  + 21
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, PLTPTS, PPLTPT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       Fetch data, determine scaling
      CALL SNPGET (MVAL, TABPTS(1+PTABPT), IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Do plots
      CALL SNPLOT (MVAL, MTIMES, TABPTS(1+PTABPT), PLTPTS(1+PPLTPT),
     *   IRET)
      IF (IRET.LT.0) IRET = 0
C                                       Close down
 990  CALL DIE (IRET, CLBUFF)
C
 999  STOP
      END
      SUBROUTINE SNPIN (PRGN, NROWS, IERR)
C-----------------------------------------------------------------------
C   Gets the inputs parameters for SNBLP.
C   Inputs:
C      PRGN    C*6  Program name
C   Output in common:
C      SUMSTK  I    Selected Stokes 0=both, 1=R, 2=L, 4=difference
C   Output:
C      IERR    I    Error code: 0 => ok
C      ISTOK   I    1 = R, 2 = L
C      ICODE   I    1='PHAS', 2='AMP ', 3='DELA', 4='RATE', 5='TSYS',
C                   6='SUM ', 7='DOPL', 8='SNR', 9='MDEL', 10='TANT',
C                   11='ATM', 12='GEO', 13='CCAL', 14='DDLY'
C                   15='REAL', 16='IMAG', 17='IFR', 18='PDIF',
C                   19='PSUM', 20=PGN ', 21='PON ', 22='POFF', 23='PSYS'
C                   24='PDGN', 25='PSGN', 26='POWR', 27='PODB'
C-----------------------------------------------------------------------
      INTEGER   NROWS, IERR
      CHARACTER PRGN*6
C
      INTEGER   NTPLT
      PARAMETER (NTPLT=5)
C
      INCLUDE 'SNBLP.INC'
      CHARACTER STAT*4, CODE(NCODE)*4, TYPTMP*2, TPLOT(NTPLT)*4
      INTEGER   IRET, BUFF(256), I, J, K, JERR, QUAL(30), NSOUR, LTYPE,
     *   BUFFER(512), IROUND, LUN, VER, NIF, NSTOK, FRQTMP, ICODE
      LOGICAL T, F, MATCH, ISTYPE
      DOUBLE PRECISION FOFF(MAXIF)
      INTEGER   ISBAND(MAXIF)
      REAL      FINC(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA CODE /'PHAS', 'AMP ', 'DELA', 'RATE'/
      DATA TPLOT /'ALIF', 'ALST', 'ALSI', 'IFDF', 'IFRA'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      OSOU = -1
      NPARMS = 242
C                                        Get input parameters.
      CALL SETUP (PRGN, NPARMS, XNAMEI, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRET = 8
         RQUICK = .FALSE.
         GO TO 990
         END IF
C                                       Decode inputs.
C                                       characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (2, 1, XTYPE, TYPE)
      CALL H2CHR (4, 1, XXSTOK, XSTOK)
      CALL H2CHR (4, 1, XOPTY, OPTYPE)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      ISYM = IROUND (XSYM)
      IF ((ISYM.LE.0) .OR. (ISYM.GT.24)) ISYM = 1
      BSYM = IROUND (XDOBL)
      IF ((BSYM.GT.0) .AND. (BSYM.EQ.ISYM)) BSYM = MOD (ISYM, 24) + 1
C
      DO3COL = XDO3C
      IF (XDO3C.GT.1.5) DO3COL = -1.
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
         QUAL(I) = IROUND (XQUAL)
 20      CONTINUE
      IF (TYPE.EQ.' ') TYPE ='SN'
      CUTOFF = MAX (0.0, CUTOFF)
      XTYPE = HBLANK
      CALL CHR2H (2, TYPE, 1, XTYPE)
C                                       Integers
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      IVER = IROUND (XNVER)
      NCOUNT = IROUND (XNCOU)
      IF (NCOUNT.LE.0) NCOUNT = 5
      XNCOU = NCOUNT
      XINC = IROUND (XXINC)
      IF (XINC.LE.0) XINC = 1
      PCNUM = IROUND (XPCNUM)
      IF (PCNUM.LE.0) PCNUM = 1
      XXINC = XINC
      DOLINE = FACTOR.LT.0.0
      FACTOR = ABS (FACTOR)
      IF ((.NOT.DOLINE) .AND. (FACTOR.LT.0.1)) FACTOR = 1.0
      IF (FACTOR.GT.10.0) FACTOR = 1.0
C                                       plot types
      IF (OPTYPE.EQ.'MULT') THEN
         NCODES = 0
         DO 25 I = 1,4
            ICODE = IROUND (APARM(I))
            IF ((ICODE.LT.1) .OR. (ICODE.GT.NCODE)) GO TO 26
            NCODES = NCODES + 1
            ICODES(NCODES) = ICODE
 25         CONTINUE
 26      IF (NCODES.LE.0) THEN
            MSGTXT = 'OPTYPE ''MULT'' HAS NO VALID TYPE CODES'
            CALL MSGWRT (8)
            IERR = 10
            GO TO 999
            END IF
      ELSE
         ICODE = 1
         DO 30 I = 1,NCODE
            IF (OPTYPE.EQ.CODE(I)) ICODE = I
 30         CONTINUE
         CALL CHR2H (4, CODE(ICODE), 1, XOPTY)
         NCODES = 1
         ICODES(1) = ICODE
         BPARM(1) = PIXR(1)
         CPARM(1) = PIXR(2)
         END IF
      ITPLOT = 0
      DO 35 I = 1,NTPLT
         IF (OPCODE.EQ.TPLOT(I)) ITPLOT = I
 35      CONTINUE
      IF (ITPLOT.GT.0) CALL CHR2H (4, TPLOT(ITPLOT), 1, XOPCOD)
      IF ((ITPLOT.LE.0) .OR. (ITPLOT.GT.3)) DO3COL = -1.0
C                                       Time range
      TSTART = XTIME(1) + (XTIME(2) / 24.0) + (XTIME(3) / (24.0*60.0)) +
     *   (XTIME(4) / (24.0*3600.0))
      TSTOP = XTIME(5) + (XTIME(6) / 24.0) + (XTIME(7) / (24.0*60.0)) +
     *   (XTIME(8) / (24.0*3600.0))
      IF (TSTART.GE.TSTOP) THEN
         TSTART = 0.0
         TSTOP = 999.0
         END IF
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
      LABEL = IROUND (XLABEL)
      LTYPE = MOD (ABS(LABEL), 100)
      IF ((LTYPE.EQ.0) .OR. (LTYPE.GT.10)) LTYPE = 3
      IF (LTYPE.GT.7) LTYPE = 7
      IF ((LTYPE.GE.4) .AND. (LTYPE.LE.6)) LTYPE = 3
      IF (LABEL.LT.0) THEN
         LABEL = (LABEL/100)*100 - LTYPE
      ELSE
         LABEL = (LABEL/100)*100 + LTYPE
         END IF
C                                       Find input catalog
      CNOIN = 1
      TYPTMP = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, TYPTMP,
     *   NLUSER, STAT, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      'UV', NLUSER
         GO TO 990
         END IF
C                                       Save name class etc.
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
      XDISIN = DISKIN
      XSIN = SEQIN
C                                       Read catalog header
      STAT = 'WRIT'
      IF (DOTV) STAT = 'READ'
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, STAT, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FCNO(NCFILE) = CNOIN
      FVOL(NCFILE) = DISKIN
      FRW(NCFILE) = 1
      IF (DOTV) FRW(NCFILE) = 0
      XDISIN = DISKIN
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 990
      SEQIN = CATBLK(KIIMS)
      XSIN = SEQIN
C                                       Subarray
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.EQ.0) SUBARR = 1
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.GE.0) THEN
         LUN = 25
         CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *      FRQSEL, IERR)
         IF (.NOT.MATCH) THEN
            WRITE (MSGTXT,1070)
            IERR = 1
            GO TO 990
            END IF
         IF (IERR.GT.0) GO TO 999
         END IF
C                                       IF'S
      IF (JLOCIF.GE.0) THEN
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, CATBLK(KINAX+JLOCIF)))
         EIF = IROUND (XEIF)
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         IF (EIF.GT.CATBLK(KINAX+JLOCIF)) EIF = CATBLK(KINAX+JLOCIF)
      ELSE
         BIF = 1
         EIF = 1
         END IF
      IF ((ITPLOT.GE.4) .AND. (EIF.LE.BIF)) THEN
         MSGTXT = 'OPCODE IFDF/IFRA REQUESTED WITH 1 IF - CONTINUING'
         CALL MSGWRT (6)
         ITPLOT = 0
         OPCODE = ' '
         END IF
C                                       Look up sources
      NID = 500
      NSOUR = 30
      MSGSUP = 32000
      CALL SOURNU (XSOUR, QUAL, NSOUR, DISKIN, CNOIN, NID, BUFFER, SID,
     *   JERR)
      MSGSUP = 0
      IF (JERR.LT.0) THEN
         MSGTXT = 'SPECIFIED SOURCE(S) NOT FOUND - CONTINUING'
         CALL MSGWRT (6)
         END IF
      IF (JERR.NE.0) NID = 0
C                                       Check antennas desired.
      NANTSL = 0
      DOAWNT = T
      DO 70 J = 1,50
         ANTS(J) = IROUND (XANT(J))
         IF (ANTS(J).LT.0) DOAWNT = F
C                                       Make positive
         ANTS(J) = ABS (ANTS(J))
         IF (NANTSL.LT.1) GO TO 60
            DO 50 K = 1,NANTSL
               IF (ANTS(J).EQ.ANTS(K)) ANTS(J) = 0
 50            CONTINUE
C                                       Check for multiple entries
 60      IF (ABS (ANTS(J)).GE.1) NANTSL = J
 70      CONTINUE
C                                       Make sure not too many
      IF (NANTSL.GT.MAXANT) NANTSL = MAXANT
C                                       Get antenna names
      CALL GETANT (DISKIN, CNOIN, MAX (1, SUBARR), CATBLK, BUFFER, JERR)
      MUMANT = NSTNS
      IF (MUMANT.LE.1) THEN
         MUMANT = MAXANT
         TIMLAB = 'IAT'
         END IF
C                                       Rate scaling to Hz
      DO 71 I = BIF,EIF
         RATFAC(I-BIF+1) = FREQ
 71      CONTINUE
      IF ((OPTYPE.EQ.'RATE') .OR. (ISTYPE(4))) THEN
         VER = 1
         LUN = 25
         IF (FRQSEL.LE.0) FRQTMP = 1
         IF (FRQSEL.GT.0) FRQTMP = FRQSEL
         CALL CHNDAT ('READ', BUFFER, DISKIN, CNOIN, VER, CATBLK, LUN,
     *      NIF, FOFF, ISBAND, FINC, BNDCOD, FRQTMP, JERR)
         IF (JERR.EQ.0) THEN
            DO 72 I = BIF,EIF
               RATFAC(I-BIF+1) = FREQ + FOFF(I)
 72            CONTINUE
            END IF
         END IF
C                                       Check Stokes' (R or IPOL)
C                                       Set stokes request
      NSTOK = CATBLK(KINAX+JLOCS)
      MUMPOL = 1
      IF ((ICOR0.EQ.1) .OR. (ICOR0.EQ.-2) .OR. (ICOR0.EQ.-6) .OR.
     *   (((ICOR0.EQ.-1) .OR. (ICOR0.EQ.-5)) .AND. (NSTOK.EQ.1))) THEN
         ISTOK = ABS (ICOR0)
         SUMSTK = 1
         XSTOK = 'I'
         IF (ICOR0.EQ.-2) XSTOK='L'
         IF (ICOR0.EQ.-1) XSTOK='R'
      ELSE IF (XSTOK.EQ.'DIFF') THEN
         ISTOK = 1
         SUMSTK = 3
      ELSE IF (XSTOK.EQ.'RATO') THEN
         ISTOK = 1
         SUMSTK = 4
      ELSE IF (ICOR0.EQ.-1) THEN
         IF ((XSTOK.EQ.'R') .OR. (XSTOK.EQ.'RR')) THEN
            ISTOK = 1
            SUMSTK = 1
            XSTOK = 'R'
         ELSE IF ((XSTOK.EQ.'L') .OR. (XSTOK.EQ.'LL')) THEN
            ISTOK = 2
            SUMSTK = 2
            XSTOK = 'L'
         ELSE
            ISTOK = 1
            SUMSTK = 0
            XSTOK = 'R&L'
            MUMPOL = 2
            END IF
      ELSE IF (ICOR0.EQ.-5) THEN
         IF ((XSTOK.EQ.'V') .OR. (XSTOK.EQ.'VV')) THEN
            ISTOK = 1
            SUMSTK = 1
            XSTOK = 'V'
         ELSE IF ((XSTOK.EQ.'H') .OR. (XSTOK.EQ.'HH')) THEN
            ISTOK = 2
            SUMSTK = 2
            XSTOK = 'N'
         ELSE
            ISTOK = 1
            SUMSTK = 0
            XSTOK = 'V&H'
            MUMPOL = 2
            END IF
         END IF
      CALL CHR2H (4, XSTOK, 1, XXSTOK)
      IF ((SUMSTK.GE.3) .AND. (ITPLOT.GE.4)) THEN
         MSGTXT = 'CANNOT DIFFERENCE POLARIZATIONS AND IFS TOGETHER'
         CALL MSGWRT (6)
         ITPLOT = 0
         END IF
C                                       Open table to check
C                                       Open SN, CL, TY or PC table
      IF ((TYPE.EQ.'SN') .OR. (TYPE.EQ.'CL')) THEN
         CALL SNPOPN (NROWS, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Invalid table type
      ELSE
         IERR = 5
         MSGTXT = 'INVALID TABLE TYPE =' // TYPE
         GO TO 990
         END IF
      XNVER = IVER
      MUMIF = EIF - BIF + 1
      IF (ITPLOT.GE.4) MUMIF = 1
      XBIF = BIF
      XEIF = EIF
      CSMAX = -100000
      CSMIN = 1000000
      XXMIN = 1.E5
      XXMAX = -1.E5
      I = 2 * MAXIF * MAXANT
      PPMIN = 1.E8
      PPMAX = -PPMIN
      YYMIN = PPMIN
      YYMAX = PPMAX
      IF ((TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         XXMIN = TSTART
         XXMAX = TSTOP
         END IF
      IF (XSCAN.GT.0.0) THEN
         LUN = 25
         CALL GETNX (LUN, DISKIN, CNOIN, CATBLK, SUBARR, BUFFER, NOSCAN,
     *      TSCAN)
      ELSE
         NOSCAN = 0
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR;',I7,'GETTING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',I3,
     *   ' TYPE=',A2,' USER=',I4)
 1040 FORMAT ('ERROR',I3,' COPYING CATALOG HEADER')
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
      END
      SUBROUTINE SNPOPN (NROWS, IERR)
C-----------------------------------------------------------------------
C   Routine to open SN, CL table and get necessary information
C   Input from Common:
C      TYPE     C*2  'SN', 'CL'
C      DISKIN   I     Disk number
C      CNOIN    I     Catalog slot number
C      CATBLK   I(*)  Catalog header
C      SUMSTK   I     Stokes type requested 0=both, 1=R, 2=L,
C                     3=difference, 4=ratio
C   Output:
C      IERR     I     Error code, 0=OK else failed.
C   Output in common:
C      ICLRNO       I    Current cal record number
C      NCLINR       I    Number of gain records in file.
C      NUMANT       I    Number of antennas
C      NUMPOL       I    Number of polarizations
C      NUMIF        I    Number of IFs.
C      ITVER        I    Version number opened.
C      KOLS         I(*) Column pointers
C      KOLTYP       I(*) Column data types
C      KOLDIM       I(*) Column dimension
C-----------------------------------------------------------------------
      INTEGER   NROWS, IERR
      INCLUDE 'SNBLP.INC'
C
      INTEGER MAXPCC
      PARAMETER (MAXPCC = 33)
      CHARACTER KEYW(4)*8, COLHD1(11)*24, COLHD2(11)*24, COLHD3(11)*24,
     *   COLTAB(40)*24, COLHED(37)*24, KEYSN(4)*8
      INTEGER   NKEY, NREC, NCOL, DATP(128,2), IPOINT, KEYTYP(4),
     *   KLOCS(4), KEYVAL(6), I, KP, MSGSAV, KEYSUB(2,2), KEY(2,2),
     *   CLANT
      LOGICAL   T, ISTYPE, DOM
      REAL      KEYVR(6), FKEY(2,2)
      DOUBLE PRECISION KEYVAD
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      EQUIVALENCE (KEYVAL, KEYVR)
      EQUIVALENCE (COLHED(1), COLHD1), (COLHED(12), COLHD2),
     *   (COLHED(23), COLHD3)
      DATA COLHD1 /'TIME                    ',
     *   'TIME INTERVAL           ',
     *   'SOURCE ID               ', 'ANTENNA NO.             ',
     *   'SUBARRAY                ', 'FREQ ID                 ',
     *   'I.FAR.ROT               ',
     *   'GEODELAY                ', 'DOPPOFF                 ',
     *   'ATMOS                   ', 'DATMOS                  '/
      DATA COLHD2 /'MBDELAY1      ',
     *   'REAL1                   ', 'IMAG1                   ',
     *   'RATE 1                  ', 'DELAY 1                 ',
     *   'WEIGHT 1                ', 'REFANT 1                ',
     *   'CLOCK 1                 ', 'DCLOCK 1                ',
     *   'DISP 1                  ', 'DDISP 1                 '/
      DATA COLHD3 /'MBDELAY2      ',
     *   'REAL2                   ', 'IMAG2                   ',
     *   'RATE 2                  ', 'DELAY 2                 ',
     *   'WEIGHT 2                ', 'REFANT 2                ',
     *   'CLOCK 2                 ', 'DCLOCK 2                ',
     *   'DISP 2                  ', 'DDISP 2                 '/
      DATA KEYSN /'NO_ANT  ', 'NO_POL  ', 'NO_IF   ','MGMOD   '/
      DATA T /.TRUE./
      DATA FKEY /1.0,0.0,1.0,0.0/
      DATA KEYSUB /4*1/
C-----------------------------------------------------------------------
C                                       Open table
      ICLUN = 28
      NKEY = 0
      NREC = 0
      NCOL = 0
      ICLRNO = 1
      CALL TABINI ('READ', TYPE, DISKIN, CNOIN, IVER, CATBLK, ICLUN,
     *   NKEY, NREC, NCOL, DATP, CLBUFF, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1100) IERR, TYPE, IVER
         GO TO 980
         END IF
      ITVER = IVER
C                                       Get number of scans
      NCLINR = CLBUFF(5)
      NROWS = NCLINR
C                                       Check if empty
      IF (NCLINR.LE.0) THEN
         IERR = 6
         MSGTXT = 'ERROR: SELECTED TABLE IS EMPTY'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Get column pointers
      NKEY = 33
      DO 10 I = 1,NKEY
         COLTAB(I) = COLHED(I)
 10      CONTINUE
      CALL FNDCOL (NKEY, COLTAB, 24, T, CLBUFF, KOLS, IERR)
      IF ((IERR.GE.1) .AND. (IERR.LE.10)) GO TO 999
      IERR = 0
C                                       Time column logical number
      CLTIME = KOLS(1)
      CLANT = KOLS(4)
C                                       Convert to pointers, types
      DO 20 I = 1,NKEY
         KP = KOLS(I)
         IF (KP.GT.0) THEN
            KOLS(I) = DATP(KP,1)
            KOLTYP(I) = MOD (DATP(KP,2), 10)
            KOLDIM(I) = DATP(KP,2) / 10
         ELSE
            KOLS(I) = -1
            KOLTYP(I) = -1
            KOLDIM(I) = 0
            END IF
 20      CONTINUE
C                                       Sort to time-ant if necessary
      IF ((CLBUFF(43).NE.KOLS(1)) .OR. (CLBUFF(44).NE.KOLS(4))) THEN
         MSGTXT = 'Sorting the ' // TYPE // ' table'
         CALL MSGWRT (3)
C                                       Close table
         CALL TABIO ('CLOS', 0, ICLRNO, KEYVR, CLBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         KEY(1,1) = CLTIME
         KEY(2,1) = 0
         KEY(1,2) = CLANT
         KEY(2,2) = 0
C                                       Sort
         CALL TABSRT (DISKIN, CNOIN, TYPE, IVER, IVER, KEY, KEYSUB,
     *      FKEY, CLBUFF, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Reopen table
         CALL TABINI ('READ', TYPE, DISKIN, CNOIN, IVER, CATBLK,
     *      ICLUN, NKEY, NREC, NCOL, DATP, CLBUFF, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1100) IERR, TYPE, IVER
            GO TO 980
            END IF
         END IF
C                                       Table keywords
      NKEY = 4
      DO 30 I = 1,NKEY
         KEYW(I) = KEYSN(I)
 30      CONTINUE
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL TABKEY ('READ', KEYW, NKEY, CLBUFF, KLOCS, KEYVAL, KEYTYP,
     *   IERR)
      MSGSUP = MSGSAV
      IF ((IERR.GE.1) .AND. (IERR.LE.20)) GO TO 999
      IERR = 0
C                                       Retrieve keyword values: other
C                                       No. antennas.
      NUMANT = NSTNS
      IPOINT = KLOCS(1)
      IF (IPOINT.GT.0) NUMANT = KEYVAL(IPOINT)
C                                       No. poln.
      NUMPOL = 1
      IPOINT = KLOCS(2)
      IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. IF
      NUMIF = 1
      IPOINT = KLOCS(3)
      IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       Mean gain modulus
      GMMOD = 1.0
      IPOINT = KLOCS(4)
      IF (IPOINT.GT.0) THEN
         IF (KEYTYP(4).EQ.1) THEN
            CALL DPCOPY (1, KEYVR(IPOINT), KEYVAD)
         ELSE
            KEYVAD = KEYVR(IPOINT)
            END IF
         IF (KEYVAD.GT.0.0) GMMOD = 1.0 / KEYVAD
         END IF
C                                       Set pointers
      DOPKOL = DOPKOL + BIF - 1
      DOP3KL = DOPKOL + EIF - 1
      DOPLKL = DOPKOL
C                                       1st poln
      IF ((ISTOK.EQ.ABS (ICOR0)) .OR. (ISTOK.EQ.ABS (ICOR0+4)) .OR.
     *   (SUMSTK.GE.3)) THEN
         REKOL(1) = RE1KOL + BIF - 1
         IMKOL(1) = IM1KOL + BIF - 1
         DLKOL(1) = DL1KOL + BIF - 1
         RAKOL(1) = RA1KOL + BIF - 1
         WTKOL(1) = WT1KOL + BIF - 1
         IF (ITPLOT.GE.4) THEN
            REKOL(3) = RE1KOL + EIF - 1
            IMKOL(3) = IM1KOL + EIF - 1
            DLKOL(3) = DL1KOL + EIF - 1
            RAKOL(3) = RA1KOL + EIF - 1
            WTKOL(3) = WT1KOL + EIF - 1
            END IF
C                                       2nd poln
      ELSE
         REKOL(1) = RE2KOL + BIF - 1
         IMKOL(1) = IM2KOL + BIF - 1
         DLKOL(1) = DL2KOL + BIF - 1
         RAKOL(1) = RA2KOL + BIF - 1
         WTKOL(1) = WT2KOL + BIF - 1
         IF (ITPLOT.GE.4) THEN
            REKOL(3) = RE2KOL + EIF - 1
            IMKOL(3) = IM2KOL + EIF - 1
            DLKOL(3) = DL2KOL + EIF - 1
            RAKOL(3) = RA2KOL + EIF - 1
            WTKOL(3) = WT2KOL + EIF - 1
            END IF
         END IF
C                                       2nd Poln
      REKOL(2) = RE2KOL + BIF - 1
      IMKOL(2) = IM2KOL + BIF - 1
      DLKOL(2) = DL2KOL + BIF - 1
      RAKOL(2) = RA2KOL + BIF - 1
      WTKOL(2) = WT2KOL + BIF - 1
      IF (ITPLOT.GE.4) THEN
         REKOL(4) = RE2KOL + EIF - 1
         IMKOL(4) = IM2KOL + EIF - 1
         DLKOL(4) = DL2KOL + EIF - 1
         RAKOL(4) = RA2KOL + EIF - 1
         WTKOL(4) = WT2KOL + EIF - 1
         END IF
C                                       Phase and amplitude
      DOM = .FALSE.
      IF ((ISTYPE(1)) .OR. (ISTYPE(2))) THEN
         IF ((REKOL(1).LT.0) .AND. (IMKOL(1).LT.0)) GO TO 500
         IF (((SUMSTK.GE.3) .OR. (MUMPOL.EQ.2)) .AND. ((REKOL(2).LT.0)
     *      .OR. (IMKOL(2).LT.0))) GO TO 500
         IF (ISTYPE(1)) THEN
            IF ((SUMSTK.GT.3) .OR. (ITPLOT.GT.4)) DOM = .TRUE.
            SUMSTK = MIN (SUMSTK, 3)
            ITPLOT = MIN (ITPLOT, 4)
            END IF
         END IF
C                                       Singleband Delay
      IF (ISTYPE(3)) THEN
         IF (DLKOL(1).LT.0) GO TO 500
         IF ((SUMSTK.GE.3) .AND. (DLKOL(2).LT.0)) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (DLKOL(2).LT.0)) GO TO 500
         IF ((SUMSTK.GT.3) .OR. (ITPLOT.GT.4)) DOM = .TRUE.
         SUMSTK = MIN (SUMSTK, 3)
         ITPLOT = MIN (ITPLOT, 4)
         END IF
C                                       Rate
      IF (ISTYPE(4)) THEN
         IF (RAKOL(1).LT.0) GO TO 500
         IF ((SUMSTK.GE.3) .AND. (RAKOL(2).LT.0)) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (RAKOL(2).LT.0)) GO TO 500
         IF ((SUMSTK.GT.3) .OR. (ITPLOT.GT.4)) DOM = .TRUE.
         SUMSTK = MIN (SUMSTK, 3)
         ITPLOT = MIN (ITPLOT, 4)
         END IF
      IF ((ITPLOT.LE.0) .OR. (ITPLOT.GE.4)) DO3COL = -1.0
      IF (DOM) THEN
         MSGTXT = '***  RATIO PLOT CHANGED TO DIFFERENCE PLOT'
         CALL MSGWRT (7)
         MSGTXT = '***  RATIO PLOTS DONE FOR AMPLITUDE ONLY'
         CALL MSGWRT (7)
         END IF
      GO TO 999
C                                       Requested data not in table
 500  WRITE(MSGTXT,1500) OPTYPE, TYPE
      IERR = 10
      GO TO 980
C                                       Error
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ERROR ',I3,' OPENING ',A,' TABLE NO. ',I3)
 1500 FORMAT (' REQUESTED DATA ',A,' NOT IN ',A,' TABLE ')
      END
      LOGICAL FUNCTION ISTYPE (FTYPE)
C-----------------------------------------------------------------------
C   ISTYPE inquires if type in list of requested types
C   Inputs:
C      FTYPE    I   Test type
C   Output:
C      ISTYPE   L   T => TYPE in ICODES
C-----------------------------------------------------------------------
      INTEGER   FTYPE
C
      INTEGER   I
      INCLUDE 'SNBLP.INC'
C-----------------------------------------------------------------------
      ISTYPE = .FALSE.
      DO 10 I = 1,NCODES
         IF (ICODES(I).EQ.FTYPE) ISTYPE = .TRUE.
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SNPCNT (IERR)
C-----------------------------------------------------------------------
C   SNPCNT reads the SN or CL table to find the number of samples for
C   each antenna
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'SNBLP.INC'
      LOGICAL   NODATA, OKAY
      INTEGER   I, NP, SCNT(MXSCAN)
      REAL      TB, TE, GTIME, XVARIB, CSOU, LTIME, TEPS
      REAL      VALUE(2*MAXIF,10)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA TEPS /1.E-6/
C-----------------------------------------------------------------------
      CALL FILL (MAXANT, 0, NANREC)
      CALL FILL (MXSCAN, 0, SCNT)
      NODATA = .TRUE.
      TB = 1.0E5
      TE = -1.0E5
      IF ((TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TB = TSTART
         TE = TSTOP
         END IF
      XMX = TE
      XMN = TB
      XMXW = TE
      XMNW = TB
      MTIMES = 0
      LTIME = -1000.
C                                       Loop thru data
      NP = MUMPOL * MUMIF
      DO 100 ICLRNO = 1,NCLINR,XINC
         CALL TABIO ('READ', 0, ICLRNO, GNREC, CLBUFF, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
         CALL CHKREC (XVARIB, VALUE, CSOU, OKAY)
C                                       okay
         IF (OKAY) THEN
            IANT = GNRECI(ANTKOL)
            GTIME = XVARIB
            IF (GTIME-LTIME.GT.TEPS) THEN
               MTIMES = MTIMES + 1
               LTIME = GTIME
               END IF
C                                      Get start, stop times
            TB = MIN (TB, GTIME)
            TE = MAX (TE, GTIME)
            NODATA = .FALSE.
            NANREC(IANT) = NANREC(IANT) + 1
            I = CSOU + 0.1
            IF ((I.GT.0) .AND. (I.LE.MXSCAN)) SCNT(I) = SCNT(I) + 1
            END IF
 100     CONTINUE
      IERR = MAX (0, IERR)
      CALL FILL (MAXANT, 0, ANTNUM)
      CALL FILL (MAXANT, 0, ANTNNN)
      MUMANT = 0
      DO 120 I = 1,MAXANT
         IF (NANREC(I).GT.0) THEN
            MUMANT = MUMANT + 1
            ANTNUM(MUMANT) = I
            ANTNNN(I) = MUMANT
            END IF
 120     CONTINUE
C                                       source number translation
      NP = 0
      CALL FILL (MXSCAN, 0, STRANS)
      DO 130 I = 1,MXSCAN
         IF (SCNT(I).GT.0) THEN
            NP = NP + 1
            STRANS(I) = NP
            END IF
 130     CONTINUE
C
 990  IF (IERR.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SNPCNT: ERROR =',I3,' FROM TABIO')
      END
      SUBROUTINE CHKREC (XVARIB, VALUE, CSOU, OKAY)
C-----------------------------------------------------------------------
C   do standard process on SN/CL record
C   In/out in common
C      GNREC    R(*)   SN/CL record
C   Outputs:
C      XVARIB   R      Time
C      VALUE    R(*)   Data values
C      CSOU     R      Source number
C      OKAY     L      true => there is something to plot
C-----------------------------------------------------------------------
      INCLUDE 'SNBLP.INC'
      REAL    XVARIB, VALUE(2*MAXIF,*), CSOU
      LOGICAL OKAY
C
      INTEGER   I, IFNUM
      REAL      GTIME
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      OKAY = .FALSE.
C                                       Check weight per IF
C                                       If weight < CUTOFF them
C                                       set amp, phase, delay and
C                                       rate to FBLANK FOR EACH IF
      IF ((CUTOFF.GE.0.0) .AND. (WT1KOL.GT.0)) THEN
         IF (NUMPOL.EQ.2) THEN
            IF ((SUMSTK.EQ.0) .OR. (SUMSTK.GE.3)) THEN
               DO 5 IFNUM = 0, MUMIF - 1
                 IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                    GNREC(REKOL(1) + IFNUM) = FBLANK
                    GNREC(IMKOL(1) + IFNUM) = FBLANK
                    GNREC(DLKOL(1) + IFNUM) = FBLANK
                    GNREC(RAKOL(1) + IFNUM) = FBLANK
                    END IF
                 IF (GNREC(WTKOL(2) + IFNUM).LE.CUTOFF) THEN
                    GNREC(REKOL(2) + IFNUM) = FBLANK
                    GNREC(IMKOL(2) + IFNUM) = FBLANK
                    GNREC(DLKOL(2) + IFNUM) = FBLANK
                    GNREC(RAKOL(2) + IFNUM) = FBLANK
                    END IF
 5               CONTINUE
            ELSE IF (SUMSTK.EQ.1) THEN
               DO 15 IFNUM = 0, MUMIF - 1
                  IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                     GNREC(REKOL(1) + IFNUM) = FBLANK
                     GNREC(IMKOL(1) + IFNUM) = FBLANK
                     GNREC(DLKOL(1) + IFNUM) = FBLANK
                     GNREC(RAKOL(1) + IFNUM) = FBLANK
                     END IF
15                CONTINUE
            ELSE IF (SUMSTK.EQ.2) THEN
               DO 25 IFNUM = 0, MUMIF - 1
                 IF (GNREC(WTKOL(2) + IFNUM).LE.CUTOFF) THEN
                    GNREC(REKOL(2) + IFNUM) = FBLANK
                    GNREC(IMKOL(2) + IFNUM) = FBLANK
                    GNREC(DLKOL(2) + IFNUM) = FBLANK
                    GNREC(RAKOL(2) + IFNUM) = FBLANK
                    END IF
25                CONTINUE
               END IF
            END IF
         IF (NUMPOL.EQ.1) THEN
            DO 35 IFNUM = 0, MUMIF - 1
              IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                 GNREC(REKOL(1) + IFNUM) = FBLANK
                 GNREC(IMKOL(1) + IFNUM) = FBLANK
                 GNREC(DLKOL(1) + IFNUM) = FBLANK
                 GNREC(RAKOL(1) + IFNUM) = FBLANK
                 END IF
 35           CONTINUE
            END IF
         END IF
C                                       Record within specified
C                                       time range ?
      IF (KOLTYP(CLTIME).EQ.1) THEN
         GTIME = GNRECD(TIMKOL)
      ELSE
         GTIME = GNREC(TIMKOL)
         END IF
      IF ((GTIME.LT.TSTART) .OR. (GTIME.GT.TSTOP)) GO TO 999
C                                       Freq id
      IF ((GNRECI(FRQKOL).GT.0) .AND. (GNRECI(FRQKOL).NE.FRQSEL)
     *    .AND. (FRQSEL.GT.0)) GO TO 999
C                                       Subarray
      IF ((GNRECI(SUBKOL).GT.0) .AND. (SUBARR.GT.0) .AND.
     *   (GNRECI(SUBKOL).NE.SUBARR)) GO TO 999
C                                       Antenna?
      IANT = GNRECI(ANTKOL)
      IF (NANTSL.GT.0) THEN
         DO 50 I = 1,NANTSL
            IF ((IANT.EQ.ANTS(I)).AND.DOAWNT) GO TO 60
            IF ((IANT.EQ.ANTS(I)).AND.(.NOT.DOAWNT)) GO TO 999
 50         CONTINUE
         IF (DOAWNT) GO TO 999
         END IF
C                                       Check source
 60   IF (NID.GT.0) THEN
         ISOU = GNRECI(SOUKOL)
         DO 70 I = 1,NID
            IF (ISOU.EQ.SID(I)) GO TO 80
 70         CONTINUE
         GO TO 999
         END IF
C                                       Get value
 80   CALL SNPDAT (VALUE, XVARIB, CSOU, OKAY)
      IF (XVARIB.EQ.FBLANK) OKAY = .FALSE.
C
 999  RETURN
      END
      SUBROUTINE SNPGET (NV, TABPTS, IERR)
C-----------------------------------------------------------------------
C   SNPGET reads the SN or CL table to load the memory
C   Input:
C      NV       I      Number values per time (source, X, n*Y)
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      TABPTS   R(*)   Data to be plotted (NV, *)
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NV, IERR
      REAL      TABPTS(NV,*)
C
      LOGICAL   NODATA, OKAY
      INTEGER   I, NP, NN, IS, KK, NTIMES
      REAL      TB, TE, TMAX, TMIN, GTIME, XVARIB, CSOU, TEPS, LTIME
      INCLUDE 'SNBLP.INC'
      REAL      VALUE(2*MAXIF,10)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA TEPS /1.E-6/
C-----------------------------------------------------------------------
      NODATA = .TRUE.
      TB = 1.0E5
      TE = -1.0E5
      IF ((TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TB = TSTART
         TE = TSTOP
         END IF
      XMX = TE
      XMN = TB
      XMXW = TE
      XMNW = TB
C                                       Loop thru data
      NP = MUMPOL * MUMIF
      NTIMES = 0
      LTIME = -1000.
      DO 100 ICLRNO = 1,NCLINR,XINC
         CALL TABIO ('READ', 0, ICLRNO, GNREC, CLBUFF, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
         CALL CHKREC (XVARIB, VALUE, CSOU, OKAY)
C                                       okay
         IF (OKAY) THEN
            IANT = GNRECI(ANTKOL)
            GTIME = XVARIB
            IF (GTIME-LTIME.GT.TEPS) THEN
               NTIMES = NTIMES + 1
               LTIME = GTIME
               END IF
C                                      Get start, stop times
            TB = MIN (TB, GTIME)
            TE = MAX (TE, GTIME)
            NODATA = .FALSE.
C                                       Put in array
            NN = NTIMES + (ANTNNN(IANT) - 1) * MTIMES
            IS = CSOU + 0.1
            IF ((IS.GT.0) .AND. (IS.LE.MXSCAN)) CSOU = STRANS(IS)
            TABPTS(1,NN) = CSOU
            TABPTS(2,NN) = XVARIB
            KK = 3
            DO 81 I = 1,NCODES
               CALL RCOPY (NP, VALUE(1,I), TABPTS(KK,NN))
               KK = KK + NP
 81            CONTINUE
            IF (ICODES(1).EQ.6) CALL RCOPY (NP, VALUE(1,2),
     *         TABPTS(KK,NN))
            XMX = MAX (XMX, XVARIB)
            XMN = MIN (XMN, XVARIB)
            XXMAX = MAX (XXMAX, XVARIB)
            XXMIN = MIN (XXMIN, XVARIB)
            CSMIN = MIN (CSMIN, CSOU)
            CSMAX = MAX (CSMAX, CSOU)
            END IF
 100     CONTINUE
      IERR = MAX (0, IERR)
C                                       Set actual X range
      SWAP = .FALSE.
      XSTART = TB
      XSTOP = TE
C                                       Check for no data
      IF (NODATA) THEN
         IERR = 6
         MSGTXT = 'NO DATA SELECTED'
         GO TO 990
         END IF
C                                       check and set scaling
      IF ((TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TMAX = (XSTOP + 0.03 * (XSTOP - XSTART)) * 360.0
         TMIN = (XSTART- 0.03 * (XSTOP - XSTART)) * 360.0
      ELSE
         TMAX = (XSTOP + 0.1 * (XSTOP - XSTART)) * 360.0
         TMIN = (XSTART- 0.1 * (XSTOP - XSTART)) * 360.0
         END IF
C                                       If start time is stop time,
      IF (ABS (TMAX-TMIN) .LT. 0.01) THEN
         TMIN = MAX( TMIN-0.005, 0.0)
         TMAX = TMIN + 0.01
         END IF
      TSTART = TB
      TSTOP = TE
      XYOFF(1) = TMIN
      XYSCL(1) = 1000.0 / (TMAX - TMIN)
      PRAN(1,1) = TMIN
      PRAN(2,1) = TMAX
C                                       Send back time range
      XTIME(1) = TSTART
      XTIME(2) = 0.0
      XTIME(3) = 0.0
      XTIME(4) = 0.0
      XTIME(5) = TSTOP
      XTIME(6) = 0.0
      XTIME(7) = 0.0
      XTIME(8) = 0.0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SNPGET: ERROR =',I3,' FROM TABIO')
      END
      SUBROUTINE SNPDAT (VALUE, XVARIB, CSOU, OKAY)
C-----------------------------------------------------------------------
C   Routine to get the specified value from a SN/CL/TY table entry
C   Input from common:
C      GNREC    R(*)  Table record
C      ICODE    I     Plot code
C      SUMSTK   I     Selected Stokes 0=both, 1=R, 2=L, 3=Difference
C   Also uses pointers etc. set in SNPOPN
C   Output:
C      VALUE    R(*)   Table value, magic value blanked (amp on ICODE 6)
C      XVARIB   R      Value of associated x-axis variable
C      CSOU     R      source number
C      OKAY     L      Some values are good
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      REAL      VALUE(2*MAXIF,*), XVARIB, CSOU
      LOGICAL   OKAY
C
      INTEGER   IIS, IIF, IP1, IP2, LP, JP1, JP2, KK, ICODE, JIF
      LOGICAL   T, DORATO, DODIFF
      INCLUDE 'SNBLP.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       In case the data is bad
      LP = MUMPOL * MUMIF
      CALL XCALC (XVARIB, CSOU)
      DO 900 KK = 1,NCODES
         ICODE = ICODES(KK)
         CALL RFILL (LP, FBLANK, VALUE(1,KK))
         DODIFF = (ITPLOT.EQ.4) .OR. (SUMSTK.EQ.3)
         DORATO = (ITPLOT.EQ.5) .OR. (SUMSTK.EQ.4)
C                                       Select data type
C                                       Phase (deg)
         IF (ICODE.EQ.1) THEN
            DO 110 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = REKOL(IIS) - 1
               JP1 = IMKOL(IIS) - 1
               IF (ITPLOT.GE.4) THEN
                  IP2 = REKOL(IIS+2) - 1
                  JP2 = IMKOL(IIS+2) - 1
               ELSE
                  IP2 = REKOL(2) - 1
                  JP2 = IMKOL(2) - 1
                  END IF
               DO 105 IIF = 1,MUMIF
                  IP1 = IP1 + 1
                  JP1 = JP1 + 1
                  IP2 =  IP2 + 1
                  JP2 = JP2 + 1
                  LP = LP + MUMPOL
                  IF ((GNREC(IP1).NE.FBLANK) .AND.
     *               (GNREC(JP1).NE.FBLANK)) THEN
                     IF (DODIFF) THEN
                        IF ((GNREC(IP2).NE.FBLANK) .AND.
     *                     (GNREC(JP2).NE.FBLANK)) THEN
                           VALUE(LP,KK) = 57.296 *
     *                        (ATAN2 (GNREC(JP1), GNREC(IP1) + 1.0E-20)
     *                        -ATAN2 (GNREC(JP2), GNREC(IP2) + 1.0E-20))
                           IF (VALUE(LP,KK).LE.-180.0) VALUE(LP,KK) =
     *                        VALUE(LP,KK) + 360.0
                           IF (VALUE(LP,KK).GT.+180.0) VALUE(LP,KK) =
     *                        VALUE(LP,KK) - 360.0
                           END IF
                     ELSE
                        VALUE(LP,KK) = 57.296 *
     *                     ATAN2 (GNREC(JP1), GNREC(IP1) + 1.0E-20)
                        END IF
                     END IF
 105              CONTINUE
 110           CONTINUE
C                                       Amplitude
         ELSE IF (ICODE.EQ.2) THEN
            DO 130 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = REKOL(IIS) - 1
               JP1 = IMKOL(IIS) - 1
               IF (ITPLOT.GE.4) THEN
                  IP2 = REKOL(IIS+2) - 1
                  JP2 = IMKOL(IIS+2) - 1
               ELSE
                  IP2 = REKOL(2) - 1
                  JP2 = IMKOL(2) - 1
                  END IF
               DO 125 IIF = 1,MUMIF
                  IP1 = IP1 + 1
                  JP1 = JP1 + 1
                  IP2 =  IP2 + 1
                  JP2 = JP2 + 1
                  LP = LP + MUMPOL
                  IF ((GNREC(IP1).NE.FBLANK) .AND.
     *               (GNREC(JP1).NE.FBLANK)) THEN
                     IF (DORATO) THEN
                        IF ((GNREC(IP2).NE.FBLANK) .AND.
     *                     (GNREC(JP2).NE.FBLANK)) VALUE(LP,KK) =
     *                     SQRT ((GNREC(IP1)**2 + GNREC(JP1)**2) /
     *                     (GNREC(IP2)**2 + GNREC(JP2)**2+1.E-10))
                     ELSE IF (DODIFF) THEN
                        IF ((GNREC(IP2).NE.FBLANK) .AND.
     *                     (GNREC(JP2).NE.FBLANK)) VALUE(LP,KK) = GMMOD
     *                     * SQRT ((GNREC(IP1)-GNREC(IP2))**2  +
     *                     (GNREC(JP1)-GNREC(JP2))**2)
                     ELSE
                        VALUE(LP,KK) = GMMOD *
     *                     SQRT ((GNREC(IP1)**2) + (GNREC(JP1)**2))
                        END IF
                     END IF
 125              CONTINUE
 130           CONTINUE
C                                       Delay (sec)
         ELSE IF (ICODE.EQ.3) THEN
            DO 150 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = DLKOL(IIS) - 1
               IF (ITPLOT.GE.4) THEN
                  IP2 = DLKOL(IIS+2) - 1
               ELSE
                  IP2 = DLKOL(2) - 1
                  END IF
               DO 145 IIF = 1,MUMIF
                  IP1 = IP1 + 1
                  IP2 =  IP2 + 1
                  LP = LP + MUMPOL
                  IF (GNREC(IP1).NE.FBLANK) THEN
                     IF (DODIFF) THEN
                        IF (GNREC(IP2).NE.FBLANK)
     *                     VALUE(LP,KK) = GNREC(IP1) - GNREC(IP2)
                     ELSE
                        VALUE(LP,KK) = GNREC(IP1)
                        END IF
                     END IF
 145              CONTINUE
 150           CONTINUE
C                                       Rate (Hz)
         ELSE IF (ICODE.EQ.4) THEN
            DO 170 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = RAKOL(IIS) - 1
               IF (ITPLOT.GE.4) THEN
                  IP2 = RAKOL(IIS+2) - 1
                  JIF = IP2 - IP1 + 1
               ELSE
                  IP2 = RAKOL(2) - 1
                  END IF
               DO 165 IIF = 1,MUMIF
                  IP1 = IP1 + 1
                  IP2 = IP2 + 1
                  LP = LP + MUMPOL
                  IF (SUMSTK.EQ.3) JIF = IIF
                  IF (GNREC(IP1).NE.FBLANK) THEN
                     IF (DODIFF) THEN
                        IF (GNREC(IP2).NE.FBLANK) VALUE(LP,KK) =
     *                     RATFAC(IIF) * GNREC(IP1) -
     *                     RATFAC(JIF) * GNREC(IP2)
                     ELSE
                        VALUE(LP,KK) = GNREC(IP1) * RATFAC(IIF)
                        END IF
                     END IF
 165              CONTINUE
 170           CONTINUE
            END IF
 900     CONTINUE
C
      OKAY = .TRUE.
      LP = MUMPOL * MUMIF
      DO 910 IIS = 1,LP
         IF (VALUE(IIS,KK).NE.FBLANK) GO TO 999
 910     CONTINUE
      OKAY = .FALSE.
C
 999  RETURN
      END
      SUBROUTINE SNPLOT (NV, NT, TABPTS, PLTPTS, IRET)
C-----------------------------------------------------------------------
C   SNPLOT plots the data thru calls to PLTSN.
C   Input:
C      NV       I      Number values per antenna
C      NT       I      Number times in data array
C      TABPTS   R(*)   Data (NV,NT,*)
C   Output:
C      IRET     I      Return code, 0=OK else failed
C-----------------------------------------------------------------------
      INTEGER   NV, NT, IRET
      REAL      TABPTS(NV,NT,*), PLTPTS(NV,*)
C
      INTEGER   IPLOT, JPLT, IPLT, NPLT, DIFF, LUMIF, LIF1, LIF2, KK,
     *   LUMST, LST1, LST2, IIF, IIS, IA1, IA2
      LOGICAL   ONEIF, ONEST, DOIT
      INCLUDE 'SNBLP.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IPLOT = 0
      DIFF = MAX (1, SUMSTK-1)
      IF ((DIFF.EQ.1) .AND. (ITPLOT.GE.4)) DIFF = ITPLOT - 2
C                                       Loop thru stations to plot
      ONEST = (OPCODE.EQ.'ALST') .OR. (OPCODE.EQ.'ALSI')
      ONEIF = (OPCODE.EQ.'ALIF') .OR. (OPCODE.EQ.'ALSI')
      IF (ONEIF) THEN
         LUMIF = 1
         LIF1 = 1
         LIF2 = MUMIF
      ELSE
         LUMIF = MUMIF
         END IF
      IF (ONEST) THEN
         LUMST = 1
         LST1 = 1
         LST2 = MUMPOL
      ELSE
         LUMST = MUMPOL
         END IF
C                                       count the plots
      NPLOTS = 0
      IPLT = 0
      DO 50 IA1 = 1,MUMANT-1
         DO 40 IA2 = IA1+1,MUMANT
            DO 35 IIF = 1,LUMIF
               IF (.NOT.ONEIF) THEN
                  LIF1 = IIF
                  LIF2 = IIF
                  END IF
               DO 30 IIS = 1,LUMST
                  IF (.NOT.ONEST) THEN
                     LST1 = IIS
                     LST2 = IIS
                     END IF
                  DO 25 KK = 1,NCODES
                     CALL GETPLT (NV, NT, TABPTS, KK, IA1, IA2, LST1,
     *                  LST2, LIF1, LIF2, PLTPTS, DOIT)
                     IF (DOIT) THEN
                        CALL GETSCL (KK, LST1, LST2, LIF1, LIF2)
                        NPLOTS = NPLOTS + 1
                        END IF
 25                  CONTINUE
 30               CONTINUE
 35            CONTINUE
 40         CONTINUE
 50      CONTINUE
C                                       Now plot
      NPLT = 0
      DO 100 IA1 = 1,MUMANT-1
         DO 90 IA2 = IA1+1,MUMANT
            DO 80 IIF = 1,LUMIF
               IF (.NOT.ONEIF) THEN
                  LIF1 = IIF
                  LIF2 = IIF
                  END IF
               DO 70 IIS = 1,LUMST
                  IF (.NOT.ONEST) THEN
                     LST1 = IIS
                     LST2 = IIS
                     END IF
                  DO 60 KK = 1,NCODES
                     CALL GETPLT (NV, NT, TABPTS, KK, IA1, IA2, LST1,
     *                  LST2, LIF1, LIF2, PLTPTS, DOIT)
                     IF (DOIT) THEN
                        CALL GETSCL (KK, LST1, LST2, LIF1, LIF2)
                        NPLT = NPLT + 1
                        JPLT = NPLT
                        IPLOT = MOD (NPLT-1, NCOUNT) + 1
                        IF (NPLT.EQ.NPLOTS) IPLOT = -IPLOT
                        CALL PLTSN (IPLOT, KK, LST1, LST2, LIF1, LIF2,
     *                     IA1, IA2, DIFF, NV, PLTPTS, IRET)
                        IF (IRET.NE.0) GO TO 999
                        END IF
 60                  CONTINUE
 70               CONTINUE
 80            CONTINUE
 90         CONTINUE
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE GETPLT (NV, NT, TABPTS, KK, IA1, IA2, LST1, LST2, LIF1,
     *   LIF2, PLTPTS, DOIT)
C-----------------------------------------------------------------------
C   GETPLT converts selected table data to baseline form
C   Inputs:
C      NV       I      number values per sample
C      NT       I      number times
C      TABPTS   R(*)   table data
C      KK       I      parameter number
C      IA1      I      antenna relative number 1
C      IA2      I      antenna relative number 2
C      LST1     I      start Stokes this plot
C      LST2     I      end Stokes this plot
C      LIF1     I      start IF this plot
C      LIF2     I      end IF this plot
C   Outputs
C      PLTPTS   R(*)   plot array
C      DOIT     L      True -> valid data
C-----------------------------------------------------------------------
      INTEGER   NV, NT, KK, IA1, IA2, LST1, LST2, LIF1, LIF2
      REAL      TABPTS(NV,NT,*), PLTPTS(NV,*)
      LOGICAL   DOIT
C
      INCLUDE 'SNBLP.INC'
      INTEGER   IP, IST, IIF, IT
      REAL      X, YMX, YMN, PMX, PMN
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      DOIT = .FALSE.
      YMX = -1.E8
      YMN = -YMX
      PMX = YMX
      PMN = YMN
      DO 100 IT = 1,NT
         PLTPTS(1,IT) = TABPTS(1,IT,IA1)
         PLTPTS(2,IT) = TABPTS(2,IT,IA1)
         DO 90 IIF = LIF1,LIF2
            DO 80 IST = LST1,LST2
               IP = (IIF-1) * MUMPOL + IST + 2 + (KK-1) * MUMPOL * MUMIF
               IF ((TABPTS(IP,IT,IA1).EQ.FBLANK) .OR.
     *            (TABPTS(IP,IT,IA2).EQ.FBLANK)) THEN
                  PLTPTS(IP,IT) = FBLANK
C                                       amplitude
               ELSE
                  DOIT = .TRUE.
                  IF (ICODES(KK).EQ.2) THEN
                     X = TABPTS(IP,IT,IA1) * TABPTS(IP,IT,IA2)
                     PLTPTS(IP,IT) = X
                     YMX = MAX (YMX, X)
                     YMN = MIN (YMN, X)
                  ELSE
                     X = TABPTS(IP,IT,IA1) - TABPTS(IP,IT,IA2)
                     IF (ICODES(KK).EQ.1) THEN
                        IF (X.LT.-180.0) X = X + 360.0
                        IF (X.GT.180.0) X = X - 360.0
                        PLTPTS(IP,IT) = X
                        YMX = MAX (YMX, X)
                        YMN = MIN (YMN, X)
                        IF (X.LT.0.0) X = X + 360.0
                        PMX = MAX (PMX, X)
                        PMN = MIN (PMN, X)
                     ELSE
                        PLTPTS(IP,IT) = X
                        YMX = MAX (YMX, X)
                        YMN = MIN (YMN, X)
                        END IF
                     END IF
                  END IF
 80            CONTINUE
 90         CONTINUE
 100     CONTINUE
      YYMAX = YMX
      YYMIN = YMN
      PPMAX = PMX
      PPMIN = PMN
C
 999  RETURN
      END
      SUBROUTINE GETSCL (KK, LST1, LST2, LIF1, LIF2)
C-----------------------------------------------------------------------
C   GETSCL converts a number of max/min's to a scale
C   Inputs:
C      KK      I   parameter number
C      LST1    I   1st Stokes
C      LST2    I   Upper Stokes
C      LIF1    I   1st IF number
C      LIF2    I   1st IF number
C   Output in common
C      XYSCL   R(2)   Scaling - only 2nd one changed
C      XYOFF   R(2)   Offset  - only second one changed
C-----------------------------------------------------------------------
      INTEGER   KK, LST1, LST2, LIF1, LIF2
C
      INCLUDE 'SNBLP.INC'
      REAL      YMX, YMN, PMX, PMN, TMAX, TMIN, TDIF, TOLER(4), SIZEY
C                                       Minimum value range for each
C                                       ICODE
C                  phs    amp    delay    rate
      DATA TOLER /0.001, 0.001, 1.0E-12, 1.0E-8/
C-----------------------------------------------------------------------
      YMX = YYMAX
      YMN = YYMIN
      PMX = PPMAX
      PMN = PPMIN
      IF ((ICODES(KK).EQ.1) .AND. (PMX-PMN.LT.YMX-YMN)) THEN
         YMX = PMX
         YMN = PMN
         END IF
      SIZEY = 1000.0 / NCOUNT
      TMAX = YMX + 0.1 * (YMX - YMN)
      TMIN = YMN - 0.1 * (YMX - YMN)
      IF (ABS (TMAX-TMIN) .LT. TOLER(ICODES(KK))) THEN
         TMAX = TMAX + TOLER(ICODES(KK))
         TMIN = TMIN - TOLER(ICODES(KK))
         END IF
      TDIF = TMAX - TMIN
      IF (ABS (TDIF).LE.1.0E-25) TDIF = 1.0E-25
      XYOFF(2) = TMIN
      XYSCL(2) = 1000.0 / TDIF / NCOUNT
      PRAN(1,2) = TMIN
      PRAN(2,2) = TMAX
C
 999  RETURN
      END
      SUBROUTINE PLTSN (IPLOT, KK, LST1, LST2, LIF1, LIF2, IA1, IA2,
     *   DIFF, NV, PLTPTS, IRET)
C-----------------------------------------------------------------------
C   PLTSN actually plots data.
C   Input:
C      IPLOT    I      Plot number on current page. If neg. then this is
C                      last plot.
C      KK       I      Parameter number
C      LST1     I      1st Stokes this plot
C      LST2     I      last Stokes this plot
C      LIF1     I      1st IF this plot
C      LIF2     I      last IF this plot
C      ANTNO    I      Antenna number
C      DIFF     I      3/2 if plotting ratio/difference between Stokes
C                      parameters , 1 otherwise
C      NV       I      Number values
C      PLTPTS   R(*)   Data to plot (NV,*)
C   Output:
C      IRET     I      Return code, 0 => OK, otherwise abort.
C                       -1 => user request termination
C                        1 => failed to add to catalog
C                        2 => failed to create
C                        3 => graph file write error
C                        4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   IPLOT, KK, LST1, LST2, LIF1, LIF2, IA1, IA2, DIFF, NV,
     *   IRET
      REAL      PLTPTS(NV,*)
C
      INCLUDE 'SNBLP.INC'
C
      CHARACTER TEXT*132, PFILE*48, ATIME*8, ADATE*12, CHTMP*18,
     *   AUNITS(NCODE,3)*8, CHTYPE(NCODE,3)*20, XUNITS*20,
     *   TXTMSG*80, CSAVE*5
      INTEGER   BUFFER(256), VER, IERR, ITYPE, IPSIZE, LUNPL, LTYPE,
     *   FINDPL, DEPTH(5), INCHAR, INP, IT(3), ID(3), IAXLAB, IAPLOT,
     *   I, NGOOD, NNOFIT, JCODE, NN, IP, IST, IIF, LDIFF, ILITY,
     *   JA1, JA2
      REAL      BLC(2), TRC(2), DX, DY, TR, VALUE, TI, XY(2),
     *   XTRC(2), XBLC(2), TLC(2), PLTINC, YYOFF(2), SIZE, XMULT(2),
     *   DBY, COLV, COL(3), COLR, AX(5), AY(5), OLDSRC
      LOGICAL   T, F, GOOD, CATUP, DONEG, DO3C, BLNKD, SCOLOR, DOCOLR
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      SAVE XMULT, CSAVE, LTYPE, BUFFER
      DATA LUNPL /26/
      DATA DEPTH /5*1/
      DATA T, F /.TRUE.,.FALSE./
      DATA AUNITS /'Degrees','Gain','Seconds','Hz',
     *             'Degrees','Gain','Seconds','Hz',
     *             'Degrees','Ratio','Seconds','Hz'/
      DATA CHTYPE /'Gain phase', 'Gain amplitude', 'Delay', 'Rate',
C                                       differences
     *             'R-L phase diff','R-L amp diff','R-L delay diff',
     *             'R-L rate diff',
C                                       ratios
     *             ' ','R/L amp ratio',' ', ' '/
      DATA XUNITS /'IAT (hours)'/
C-----------------------------------------------------------------------
C                                       Time system from AN table
      SCOLOR = (XDO3C.GT.1.5) .AND. (CSMAX-CSMIN.GT.0.99)
      OLDSRC = -1000.0
      XUNITS(:3) = TIMLAB(1:3)
      NGOOD = 0
      NNOFIT = 0
      IRET = 3
      CATUP = T
      JA1 = ANTNUM(IA1)
      JA2 = ANTNUM(IA2)
C
      JCODE = ICODES(KK)
C                                       Create plot file
      IF (ABS (IPLOT).EQ.1) THEN
C                                       Update catalog header.
         VER = 0
         IRET = 1
         IF (.NOT.DOTV) THEN
            CALL MADDEX ('PL', DISKIN, CNOIN, CATBLK, BUFFER, CATUP,
     *         'WRIT', VER, IERR)
            IF (IERR.NE.0) THEN
               NCFILE = NCFILE - 1
               GO TO 999
               END IF
            END IF
         CALL ZPHFIL ('PL', DISKIN, CNOIN, VER, PFILE, IERR)
         IF (IERR.NE.0) GO TO 960
         IPSIZE = 0
         ITYPE = 57
         CALL GINIT (DISKIN, CNOIN, PFILE, IPSIZE, ITYPE, NPARMS,
     *      XNAMEI, DOTV, TVCHN, GRCHN, TVCORN, CATBLK, BUFFER, LUNPL,
     *      FINDPL, IERR)
         IRET = 2
         IF (IERR.NE.0) GO TO 960
         END IF
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      IF (DOTV) THEN
         TRC(1) = WINDTV(3) - WINDTV(1)
         TRC(2) = WINDTV(4) - WINDTV(2)
         IF (DO3COL.LE.0.0) THEN
            CALL GCINIT (GPHTVG(4), 0, IERR)
            IF (IERR.NE.0) GO TO 960
            CALL GCINIT (GPHTVG(3), 0, IERR)
            IF (IERR.NE.0) GO TO 960
            END IF
         END IF
      PLTINC = TRC(2) / NCOUNT
      IF (XYRATO.LT.0.01) XYRATO = 1.0
C                                       Set window for current plot.
      XBLC(1) = BLC(1)
      XBLC(2) = TRC(2) - ABS (IPLOT) * PLTINC
      XTRC(1) = TRC(1)
      XTRC(2) = XBLC(2) + PLTINC - 1.0
      TLC(1) = XBLC(1)
      TLC(2) = XTRC(2)
C                                       Offsets for current plot.
      YYOFF(1) = XBLC(1)
      YYOFF(2) = XBLC(2)
C                                       fool with location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 7
      AXTYP(LOCNUM) = 0
      TR = 1.1 * (PRAN(2,2)-PRAN(1,2))
      IF (TR.LE.0.0) TR = 1.0
      IF ((ABS(IPLOT).EQ.1) .OR. (NCODES.GT.1)) THEN
         TI = TR
         CALL METSCL (LABEL, TR, CPREF(2,LOCNUM), GOOD)
         XMULT(2) = TR / TI
         CSAVE = CPREF(2,LOCNUM)
         END IF
      CPREF(1,LOCNUM) = ' '
      XMULT(1) = 1.0
      DO 50 I = 1,2
         SIZE = XTRC(I) - XBLC(I) + 1
         TR = PRAN(2,I) - PRAN(1,I)
         XYSCL(I) = (XTRC(I) - XBLC(I)) / TR
         RPLOC(I,LOCNUM) = XBLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I) * XMULT(I)
         AXINC(I,LOCNUM) = TR * XMULT(I) / (XTRC(I) - XBLC(I))
 50      CONTINUE
      CTYP(1,LOCNUM) = XUNITS
      CTYP(2,LOCNUM) = AUNITS(JCODE, DIFF)
      LDIFF = DIFF
      IF (ITPLOT.GE.4) LDIFF = 1
C                                       Init plot calls again
C                                       Number of characters on each
C                                       side of the plot
      IF (ABS (IPLOT).EQ.1) THEN
         CALL RFILL (4, 0.5, CHOUT)
C                                       Not fully initialized, may make
C                                       INP too large which is okay.
         CALL CHNTIC (XBLC, XTRC, INP)
         INP = MAX (INP, 3)
         IF (NCODES.GT.1) INP = MAX (INP, 7)
         LTYPE = MOD (ABS (LABEL), 100)
         IF (LTYPE.EQ.2) CHOUT(1) = 2.5
         IF (LTYPE.GT.2) CHOUT(1) = INP + 4
         IF (LTYPE.GT.1) CHOUT(2) = 2.0
         IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
         IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = 3.333
         IF ((LABEL.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7))
     *      CHOUT(4) = CHOUT(4) + 1.333
C                                       Init for line drawing.
         CALL GINITL (BLC, TRC, XYRATO, CHOUT, DEPTH, BUFFER, IERR)
         IRET = 3
         IF (IERR.NE.0) GO TO 970
         IF (.NOT.DOTV) THEN
            WRITE (MSGTXT,1000) VER
            CALL MSGWRT (2)
            END IF
         END IF
      IRET = 3
      CATUP = T
C                                       Draw border
      CALL GLTYPE (1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Top labels: type & name
      IF ((ABS(IPLOT).EQ.1) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DX = 0.0
         DY = 1.833
C                                       The second line of the header
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         INCHAR = 16
         INP = 1
         TEXT = CHTYPE(JCODE,LDIFF)
         IF (NCODES.GT.1) TEXT = 'Multiple'
         IF (ICOR0.LT.-4) THEN
            IF (TEXT(1:3).EQ.'R-L') THEN
               TEXT(1:3) = 'V-H'
            ELSE IF (TEXT(:3).EQ.'R/L') THEN
               TEXT(1:3) = 'V/H'
               END IF
            END IF
         CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
         IF (ITPLOT.GE.4) THEN
            TEXT(INP+1:) = ' IF diff'
            IF (ITPLOT.EQ.5) TEXT(INP+1:) = ' IF ratio'
            INCHAR = 132
            CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
            END IF
         INP = INP + 1
         TEXT(INP:INP+16) = ' vs '// TIMLAB(1:3) // ' time for '
         INP = INP + 17
C                                       File name
         CALL H2CHR (18, KHIMNO, CATH(KHIMN), CHTMP)
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), CHTMP(13:18))
         CALL NAMEST (CHTMP, CATBLK(KIIMS), TEXT(INP:), INCHAR)
         CALL REFRMT (TEXT, ' ', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       the third line of header
         DY = 0.5
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         INP = 1
C
         WRITE (TEXT(INP:),1010) TYPE, ITVER
         INP = INP + 8
         IF (TYPE .EQ. 'PC') THEN
            WRITE (TEXT(INP:),1015) PCNUM
            INP = INP + 9
            END IF
C                                       Stokes and IF
         IF (LDIFF.EQ.1) THEN
            IF (SUMSTK.GT.0) THEN
               TEXT(INP:) = XSTOK(:1) // 'pol_'
               INP = INP + 7
            ELSE
               TEXT(INP:) = 'Rpol & Lpol_'
               IF (ICOR0.LT.-4) TEXT(INP:) = 'Vpol & Hpol_'
               INP = INP + 14
               END IF
            END IF
         IF (ITPLOT.GE.4) THEN
            WRITE (TEXT(INP:),1020) BIF, EIF
            INP = INP + 12
         ELSE IF (BIF.EQ.EIF) THEN
            WRITE (TEXT(INP:),1021) BIF
            INP = INP + 6
         ELSE
            WRITE (TEXT(INP:),1022) BIF, EIF
            INP = INP + 11
            END IF
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Date/time/version
         IF ((LABEL.GT.0) .AND. (LTYPE.GT.1)) THEN
            DY = 0.5 + 2 * 1.333
C                                       the first line of the header
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (TEXT,1030) VER, ADATE, ATIME
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
         END IF
C                                       station ID
      CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      DX =  1.5
      DY = -1.8
      WRITE (TEXT,1040) JA1
      INP = 4
      TEXT(INP+1:) = STNNAM(JA1)
      CALL CHTRIM (TEXT, 132, TEXT, INP)
      INP = INP + 3
      WRITE (TEXT(INP:),1040) JA2
      INP = INP + 4
      TEXT(INP+1:) = STNNAM(JA2)
      CALL CHTRIM (TEXT, 132, TEXT, INP)
      INP = INP + 2
      IF (MUMPOL.LE.1) THEN
         TEXT(INP:) = XSTOK(:1)
         INP = INP + 1
      ELSE IF ((MUMIF.LE.1) .OR. (LIF1.NE.LIF2)) THEN
         IF (ICOR0.LT.-4) THEN
            TEXT(INP:) = 'VV'
            IF (LST1.EQ.2) TEXT(INP:) = 'HH'
         ELSE
            TEXT(INP:) = 'RR'
            IF (LST1.EQ.2) TEXT(INP:) = 'LL'
            END IF
         INP = INP + 2
         END IF
      CALL CHTRIM (TEXT, 132, TEXT, INCHAR)
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Stokes, IF
      IF ((MUMIF.GT.1) .AND. (LIF1.EQ.LIF2)) THEN
         INP = 1
         WRITE (TEXT(INP:),1021) LIF1 + BIF - 1
         INP = INP + 5
         IF ((MUMPOL.GT.1) .AND. (LST1.EQ.LST2)) THEN
            IF (ICOR0.LT.-4) THEN
               TEXT(INP:) = 'VV'
               IF (LST1.EQ.2) TEXT(INP:) = 'HH'
            ELSE
               TEXT(INP:) = 'RR'
               IF (LST1.EQ.2) TEXT(INP:) = 'LL'
               END IF
            INP = INP + 2
            END IF
         CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         DX =  1.5
         DY = -3.133
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       type of plot
      IF (NCODES.GT.1) THEN
         TEXT = CHTYPE(JCODE,LDIFF)
         CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
         CALL GPOS (XTRC(1), XTRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         DX = -INP - 3.0
         DY = -2.8
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Set up location common
C                                       Blank bottom label.
      IF ((IPLOT.GE.0) .AND. (ABS (IPLOT).NE.NCOUNT)) THEN
         CPREF(1,LOCNUM) = ' '
         CTYP(1,LOCNUM) = ' '
         END IF
C                                       Only label Y axis once.
      IAXLAB = NCOUNT / 2 + 1
      IAPLOT = ABS (IPLOT)
      IF (NCODES.LE.1) THEN
         CPREF(2,LOCNUM) = CSAVE
         IF ((IAPLOT.NE.IAXLAB) .AND. ((IPLOT.GE.0) .OR.
     *      (IAPLOT.GT.IAXLAB))) CPREF(2,LOCNUM) = '-1'
         END IF
C                                       Put on labels and ticks
      CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XYRATO, F, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Size of symbol.
      DBY = 0.5 * FACTOR
C                                       Loop
      ILITY = 4
      CALL GLTYPE (ILITY, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      COLR = (LIF2 - LIF1 + 1.0) * (LST2 - LST1 + 1.0) - 1.0
      DO3C = (DO3COL.GT.0.0) .AND. (COLR.GE.0.9)
      DOCOLR = DO3C .OR. SCOLOR
C                                       Outer loop: IF, stokes
      COLV = 0.0
      DO 200 IIF = LIF1,LIF2
         DO 190 IST = LST1,LST2
            IF (DO3COL.GT.0.0) THEN
               IF (DO3C) THEN
                  CALL COLOR3 (COLV, .FALSE., COL)
                  CALL G3VCOL (COL(1), COL(2), COL(3), BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  COLV = COLV + 0.97 / COLR
               ELSE IF (2+IST.NE.ILITY) THEN
                  ILITY = 2 + IST
                  CALL GLTYPE (ILITY, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  END IF
               END IF
            IP = (IIF-1) * MUMPOL + IST + 2 + (KK-1) * MUMPOL * MUMIF
C                                       Point plot
            DO 120 NN = 1,MTIMES
               DONEG = JCODE.EQ.1
C                                       Scale X
               XY(1) = PLTPTS(2,NN)
               IF ((SWAP) .AND. (XY(1).GT.180.0)) XY(1) = XY(1) - 360.0
               XY(1) = XY(1) * 360.0
               XY(1) = XYSCL(1) * (XY(1) - XYOFF(1)) + YYOFF(1)
               IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1))) THEN
                  NNOFIT = NNOFIT + (LST2-LST1+1)*(LIF2-LIF1+1)
                  GO TO 120
                  END IF
C                                       source color
               IF ((SCOLOR) .AND. (ABS(PLTPTS(1,NN)-OLDSRC).GT.0.1))
     *            THEN
                  COLV = 0.97 * (PLTPTS(1,NN)-CSMIN) / (CSMAX-CSMIN)
                  CALL COLOR3 (COLV, .FALSE., COL)
                  CALL G3VCOL (COL(1), COL(2), COL(3), BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  OLDSRC = PLTPTS(1,NN)
                  END IF
C                                       loop for points
               VALUE = PLTPTS(IP,NN)
C                                       ?????????????????
               IF (VALUE.NE.FBLANK) THEN
 110              XY(2) = VALUE
                  XY(2) = XYSCL(2) * (XY(2) - XYOFF(2)) + YYOFF(2)
                  IF ((XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2))) THEN
                     IF (DONEG) THEN
                        IF (VALUE.LT.0.) THEN
                           VALUE = VALUE + 360.
                        ELSE
                           VALUE = VALUE - 360.
                           END IF
                        DONEG = .FALSE.
                        GO TO 110
                     ELSE
                        NNOFIT = NNOFIT + 1
                        END IF
                  ELSE
                     NGOOD = NGOOD + 1
C                                       Mark point
                     DY = 5.0 * FACTOR
                     DX = 5.0 * FACTOR
                     IF (XYRATO.GT.1.0) THEN
                        DY = DY * XYRATO
                     ELSE
                        DX = DX / XYRATO
                        END IF
                     AX(1) = XY(1)
                     AY(1) = XY(2)
                     AX(2) = AX(1)
                     AX(3) = AX(1)
                     AX(4) = AX(1) - DX
                     AX(5) = AX(1) + DX
                     AY(2) = AY(1) + DY
                     AY(3) = AY(1) - DY
                     AY(4) = AY(1)
                     AY(5) = AY(1)
                     IF ((DO3COL.LE.0) .AND. (ILITY.NE.4)) THEN
                        ILITY = 4
                        CALL GLTYPE (ILITY, BUFFER, IERR)
                        IF (IERR.NE.0) GO TO 970
                        END IF
                     CALL PNTPLT (ISYM, AX, AY, XBLC, XTRC, .FALSE.,
     *                  DOCOLR, BUFFER, IERR)
                     IF (IERR.NE.0) GO TO 970
                     END IF
               ELSE IF (BSYM.GT.0) THEN
                  DY = 5.0 * FACTOR
                  DX = 5.0 * FACTOR
                  IF (XYRATO.GT.1.0) THEN
                     DY = DY * XYRATO
                  ELSE
                     DX = DX / XYRATO
                     END IF
                  XY(2) = XBLC(2) + DY
                  AX(1) = XY(1)
                  AY(1) = XY(2)
                  AX(2) = AX(1)
                  AX(3) = AX(1)
                  AX(4) = AX(1) - DX
                  AX(5) = AX(1) + DX
                  AY(2) = AY(1) + DY
                  AY(3) = AY(1) - DY
                  AY(4) = AY(1)
                  AY(5) = AY(1)
                  IF ((DO3COL.LE.0) .AND. (ILITY.NE.3)) THEN
                     ILITY = 3
                     CALL GLTYPE (ILITY, BUFFER, IERR)
                     IF (IERR.NE.0) GO TO 970
                     END IF
                  CALL PNTPLT (BSYM, AX, AY, XBLC, XTRC, .FALSE.,
     *               DOCOLR, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  END IF
 120           CONTINUE
C                                       Line plot
            IF (DOLINE) THEN
               BLNKD = .TRUE.
               DO 140 NN = 1,MTIMES
                  DONEG = JCODE.EQ.1
C                                       Scale X
                  XY(1) = PLTPTS(2,NN)
                  XY(1) = XY(1) * 360.0
                  XY(1) = XYSCL(1) * (XY(1) - XYOFF(1)) + YYOFF(1)
                  IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1)))
     *               GO TO 140
C                                       loop for points
                  VALUE = PLTPTS(IP,NN)
                  IF (VALUE.EQ.FBLANK) THEN
                     BLNKD = .TRUE.
                  ELSE
 130                 XY(2) = VALUE
                     XY(2) = XYSCL(2) * (XY(2) - XYOFF(2)) + YYOFF(2)
                     IF ((XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2)))
     *                  THEN
                        IF (DONEG) THEN
                           IF (VALUE.LT.0.) THEN
                              VALUE = VALUE + 360.
                           ELSE
                              VALUE = VALUE - 360.
                              END IF
                           DONEG = .FALSE.
                           GO TO 130
                           END IF
                     ELSE
                        NGOOD = NGOOD + 1
C                                       Mark point
                        IF (BLNKD) THEN
                           CALL GPOS (XY(1), XY(2), BUFFER, IERR)
                           BLNKD = .FALSE.
                        ELSE IF (DOCOLR) THEN
                           CALL G3VEC (XY(1), XY(2), BUFFER, IERR)
                        ELSE
                           CALL GVEC (XY(1), XY(2), BUFFER, IERR)
                           END IF
                        IF (IERR.NE.0) GO TO 970
                        END IF
                     END IF
 140              CONTINUE
               END IF
C                                       plot scan boundaries
            IF ((XSCAN.GT.0.0) .AND. (NOSCAN.GT.0)) THEN
               WRITE (TXTMSG,1150) NOSCAN
               CALL GCOMNT (-1, TXTMSG, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               I = 3
               CALL GLTYPE (I, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               AY(1) = XYSCL(2) * (PRAN(1,2)-XYOFF(2)) + YYOFF(2)
               AY(2) = XYSCL(2) * (PRAN(2,2)-XYOFF(2)) + YYOFF(2)
               IF (XSCAN.GE.1.5) AY(2) = AY(1) + 0.1*(AY(2)-AY(1))
               DO 160 I = 1,NOSCAN
                  AX(1) = XYSCL(1) * (TSCAN(I)*360.-XYOFF(1)) + YYOFF(1)
                  IF ((AX(1).GE.XBLC(1)) .AND. (AX(1).LE.XTRC(1))) THEN
                     CALL GPOS (AX(1), AY(1), BUFFER, IERR)
                     IF (IERR.NE.0) GO TO 970
                     CALL GVEC (AX(1), AY(2), BUFFER, IERR)
                     IF (IERR.NE.0) GO TO 970
                     END IF
 160              CONTINUE
               END IF
 190        CONTINUE
 200     CONTINUE
C                                       Done: finish plot
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      IF ((IPLOT.GT.0) .AND. (ABS(IPLOT).LT.NCOUNT)) GO TO 210
         GPHPAG = IPLOT.GT.0
         CALL GFINIS (BUFFER, IERR)
         IF (IERR.GT.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
            IERR = 0
            END IF
 210  IF (IERR.GT.0) GO TO 975
         IRET = MIN (IERR, 0)
         GO TO 999
C                                       ZPHFIL or GINIT failure.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      IF (.NOT.DOTV) THEN
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
      GO TO 999
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      GPHPAG = IPLOT.GT.0
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.NE.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
            IERR = 0
            END IF
         GO TO 999
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Plot file version',I4,'  created.')
 1010 FORMAT (A2,I4,'_')
 1015 FORMAT ('NTONE ',I2)
 1020 FORMAT ('IF ',I2,' vs',I3)
 1021 FORMAT ('IF ',I2)
 1022 FORMAT ('IF ',I2,' - ',I2)
 1030 FORMAT ('Plot file version',I4,'__created ',A, A)
 1040 FORMAT (I3)
 1150 FORMAT ('Plotting',I4,' scan breaks')
 1200 FORMAT ('PLTSN:',I9,' points plotted')
 1202 FORMAT ('PLTSN:',I9,' points did not fit')
 1960 FORMAT ('PLTSN: ERROR DURING GRAPH FILE CREATION')
 1970 FORMAT ('PLTSN: ERROR DURING GRAPHING. WILL TRY TO FINISH ',
     *   'PARTIAL GRAPH')
      END
      SUBROUTINE XCALC (XVARIB, XSOU)
C-----------------------------------------------------------------------
C  Routine to use the source and antenna geometry information in order
C  to return the requested value of the x-variable against which the
C  data is to be plotted.
C  Inputs (in common):
C    XVAR        I       Type of variable to calculate:
C                        1 = time (easy)
C  Output:
C    XVARIB      R       Value of requested variable
C                        Time, LST (days)
C                        Elevation, HA (degrees)
C    XSOU        I       source number
C----------------------------------------------------------------------
      REAL    XVARIB, XSOU
C
      INTEGER CSOU
      DOUBLE PRECISION TIME
      INCLUDE 'SNBLP.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      CSOU = GNRECI(SOUKOL)
      XSOU = CSOU
C                                      Time
      IF (KOLTYP(CLTIME).EQ.1) THEN
         TIME = GNRECD(TIMKOL)
      ELSE
         TIME = GNREC(TIMKOL)
         END IF
      XVARIB = TIME
C
 999  RETURN
      END

      SUBROUTINE ALGSTB (APCORE, IFIELD, SCRGRD, DISKI, CNOSCI, DISKO,
     *   CNOSCO, CHANEL, NCHAN, CATR, JBUFSZ, BUFF1, BUFF2, BUFF3, IRET)
C-----------------------------------------------------------------------
C! Interpolates model visibility from a grid and subtracts from uv data.
C# UV Modeling AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 1999-2001, 2003, 2006, 2008-2010, 2012,
C;  Copyright (C) 2014-2015, 2018-2019, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ALGSTB interpolates model visibility data from a grid and subtracts
C   it from the observed visibilities.  UV data may be in any sort order
C   If AP memory is large enough to hold all gridded model, ALGSTB runs
C   much faster.
C   Inputs:
C      IFIELD   I       Field number.
C      SCRGRD   I       /CFILES/ file number for grid file.
C      DISKI    I       Input file disk number for catalogd files,
C                       .LE. 0 => /CFILES/ scratch file.
C      CNOSCI   I       Input file catalog slot number or /CFILES/
C                       scratch file number.
C      DISKO    I       Output file disk number for catalogd files,
C                       .LE. 0 => /CFILES/ scratch file.
C      CNOSCO   I       Output file catalog slot number or /CFILES/
C                       scratch file number.
C      CHANEL   I       First channel number.
C      NCHAN    I       Number of channels to process.
C      CATR     R(256)  UV data catalog header record.
C      JBUFSZ   I       Size in bytes of buffers. Dimension of
C                       BUFF1,2,3  must be at least 4096 words.
C   Inputs: from commons
C      LREC     I       length in words of vis record.
C      NVIS     I       number of vis records
C      FREQG    D(*)    Frequencies of IF and channels in same order
C                       as occurs in the data.
C      FACGRD   R(2)    (1) Value to multiply Clean fluxes
C                       (2) > 0 normal, 0 model with flagging,
C                           < 0 model weights all -> 1.0
C   Output:
C      BUFF1    R(*)    Working buffer
C      BUFF2    R(*)    Working buffer
C      BUFF3    R(*)    Working buffer
C      IRET     I       Return code, 0 => ok, otherwise not.
C   The AP grid file must contain the gridded UV model for this pass.
C   The UV points are read in and the model is subtracted from them.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   IFIELD, SCRGRD, DISKI, CNOSCI, DISKO, CNOSCO, CHANEL,
     *   NCHAN, JBUFSZ, IRET
      REAL       BUFF1(*), BUFF2(*), BUFF3(*)
C
      INTEGER   CJTBSZ, MINT, TPBFMX
C                                       CJTBSZ = conj. table size
C                                       MINT   = Interpol. support size.
C                                       TPBFMX = Temp Buffer size
      PARAMETER (CJTBSZ=4000, MINT=11, TPBFMX=20000)
      INTEGER   VISRED, NIOUT, IDISK, ICNOSC, INDS(3), NX, NY, ILENBU,
     *   IUMIN, IUMAX, USTOP, USTRT, IU, U, IVIS, ICONJ, I, NIO, LENBU,
     *   FLIST(22), CNJPTR(CJTBSZ), M, MO2, LOCHAN, NCHGRD, MSGINC,
     *   NROGRD, MXROGD, KAP, CX, VIS, UV, LLREC, MM, WORK, INDEX, LROW,
     *   FLAG, VISOFF, NS, APSIZE, MAXREC, CNT, IFACT, ITEMP1, ITEMP2,
     *   INPTR, OUTPTR, JNPTR, KNPTR, LNPTR, NPOINT, JNCS, EXCESS,
     *   LOGRID, JNCF, LRPARM, ROWSIZ, IDATA, MAXU, RPASS, NRPASS,
     *   NROWS, NXO2, EROW, ERRCNT, IXTEMP(3), MSGSAV, HIC, LOC, J, K,
     *   IUFMAX, IULO, IUHI, LSTRT, LSTOP, NROW, END1, LUMAX, LUMIN,
     *   NEED, UCOUNT, UTARG, II, JJ, KK
      LOGICAL   ALLROW, ONCE, DOROT, DOFLAG
      REAL      XTEMP(7), FACT2(4), CATR(256), ZSCLV, ZSCLW, ZSCLU,
     *   SCALU, SCALV, FFRAC, FRSTU, UUMAX, VVMAX, UIN, VIN, UMIN, UMAX,
     *   TEMPBF(TPBFMX), UUU, UMAT(3,3), PMAT(3,3), DDX(3),
     *   RMAT(3,3), DMAT(3,3), RULO, RUHI, UVWS(3,TPBFMX), RXTEMP(3)
      DOUBLE PRECISION GFACT, MAXFRQ, XRA, XDEC, MINFRQ, MXFACT, MNFACT
      CHARACTER CSTOK*1
      EQUIVALENCE (IXTEMP, RXTEMP)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMPR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSCD.INC'
      INCLUDE 'INCS:DAPM.INC'
      SAVE ONCE, ERRCNT
      DATA ONCE /.FALSE./, ERRCNT /0/
C-----------------------------------------------------------------------
      IRET = 0
      DOFLAG = ERRCNT.EQ.0
C                                       Rotate?
      DOROT = (ABS (SSROT).GT.1.0E-10) .OR. (ABS (CCROT-1.0).GT.1.0E-4)
      APSIZE = PSAPNW * 1024
      NX = ABS (FLDSZ(1,IFIELD) * OSFX) + 0.1
      NY = ABS (FLDSZ(2,IFIELD) * OSFY) + 0.1
      ZSCLU = SCLUG(IFIELD) * OSFX
      ZSCLV = SCLVG(IFIELD) * OSFY
      ZSCLW = SCLWG(IFIELD)
      NXO2 = NX / 2
C                                       Set AP Pointers; IFACT=cellsiz
      IFACT = 2
      LROW = NY
      ROWSIZ = IFACT * LROW
C                                       Set up for APIO
      CALL FILL (22, 0, FLIST)
      FLIST(1) = LUNS(4)
      FLIST(2) = SCRGRD
      FLIST(5) = ROWSIZ
      FLIST(6) = NXO2 + 1
      FLIST(9) = 1
      FLIST(11) = FLIST(5)
      FLIST(12) = 1
      FLIST(13) = JBUFSZ
C                                       Get un-compressed UV increments
      IF (DATDIV) CALL PRMUPD
      IF (COMPDT) THEN
         ITEMP1 = LREC
         ITEMP2 = NRPARM
         LREC = SCLREC
         NRPARM = SCRPRM
         END IF
C                                       Correlator scaling table.
      MSGSAV = MSGSUP
      MSGSUP = 31900
      CALL GETCTL (CATR, FACT2, IRET)
      MSGSUP = MSGSAV
      IF (IRET.NE.0) GO TO 999
      CSTOK = MSGTXT(1:1)
      NS = NSTOK
      CALL UVINCS (INCS, INCF, INCIF, NRPARM, LREC, JNCS, JNCF,
     *   LRPARM, LLREC)
C                                       Set I/O visibility count
      ILENBU = ((MIN(JBUFSZ,TPBFMX*2) - 2 * NBPS) / 2) / LLREC - 2
      ILENBU = MAX (ILENBU, 1)
      LENBU  = ILENBU
      IDISK = DISKI
      ICNOSC = CNOSCI
C                                       Grab ap
      M = MINT
      MAXREC = 256
      NEED = MAXREC*(LLREC+4) + 200*M + 30 + NCHAN + (NXO2+M)*ROWSIZ
      NEED = NEED / 1024 + 2
      CALL QINIT (APCORE, NEED, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
         IRET = 8
         MSGTXT = 'ALGSTB UNABLE TO GET DESIRED MEMORY'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      APSIZE = 1024 * PSAPNW
C                                       Calc extra ap for interp func
      MAXREC = MIN (2048, (APSIZE/30)/(LLREC+4)) + 5
      MAXREC = MAX (15, MAXREC)
      EXCESS = APSIZE - MAXREC*(LLREC+4) - 200*MINT - 30 - NCHAN
C                                       How big can interp func be?
      M = EXCESS / (ROWSIZ + 200)
C                                       M between mint/2 and mint
      M = MAX (MINT/2, MIN (M, MINT))
C                                       M must be odd, round down
      M = (2 * ((M-1)/2)) + 1
      MO2 = M / 2
C                                       Extra ap goes to extra rows
      EXCESS = APSIZE - MAXREC*(LLREC+4) - 200*M - 30 - NCHAN
      MXROGD = (EXCESS/ROWSIZ) - 1
      IF (MXROGD.LT.M) THEN
         IRET = 8
         MSGTXT = 'ALGSTB UNABLE TO GET ENOUGH MEMORY'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Grid no more than all rows
      MXROGD = MIN (MXROGD, NXO2+M)
C                                       Set ap pointers
      LOGRID = APSIZE - ((MXROGD+1) * ROWSIZ) - 1
      CX = LOGRID - (200 * (M+1)) - 1
      MM = M
      FLAG = 1
      IF ((KSTOK.EQ.3) .AND. (ICOR0.LE.0)) FLAG = -1
C                                       model only
      IF (FACGRD(2).LE.0.0) THEN
         UUU = 0.0
         FACT2(1) = FACT2(1) * FACGRD(1)
         FACT2(2) = FACT2(2) * FACGRD(1)
         FACT2(3) = FACT2(3) * FACGRD(1)
         FACT2(4) = FACT2(4) * FACGRD(1)
C                                       Scale FACT2 by -FACGRD
C                                       data - model
      ELSE
         UUU = 1.0
         FACT2(1) = -FACT2(1) * FACGRD(1)
         FACT2(2) = -FACT2(2) * FACGRD(1)
         FACT2(3) = -FACT2(3) * FACGRD(1)
         FACT2(4) = -FACT2(4) * FACGRD(1)
         END IF
C                                       If fft scale by 0.5
      IF (DOFFT) THEN
         FACT2(1) = FACT2(1) * 0.5
         FACT2(2) = FACT2(2) * 0.5
         FACT2(3) = FACT2(3) * 0.5
         FACT2(4) = FACT2(4) * 0.5
         END IF
C                                       Prepare for bs loop
      DDX(1) = DXCG(IFIELD)
      DDX(2) = DYCG(IFIELD)
      DDX(3) = DZCG(IFIELD)
      CALL XYSHFT (RA, DEC, XSHIFT(IFIELD), YSHIFT(IFIELD), MAPROT,
     *   XRA, XDEC)
      IF (DO3DIM) THEN
         CALL PRJMAT (RA, DEC, UVROT, XRA, XDEC, MAPROT, UMAT, PMAT)
         CALL RFILL (9, 0.0, RMAT)
         CALL RFILL (9, 0.0, DMAT)
         RMAT(1,1) = CCROT
         RMAT(1,2) = SSROT
         RMAT(2,1) = -SSROT
         RMAT(2,2) = CCROT
         RMAT(3,3) = 1
         DO 20 I = 1,3
            DO 15 J = 1,3
               DO 10 K = 1,3
                  DMAT(I,J) = DMAT(I,J) + PMAT(I,K) * RMAT(K,J)
 10               CONTINUE
 15            CONTINUE
 20         CONTINUE
         CALL PRJMUL (2, DDX, DMAT, DDX)
      ELSE
         CALL P2DMAT (RA, DEC, UVROT, XRA, XDEC, MAPROT, UMAT, PMAT)
         END IF
C                                       self defense
      DO 30 I = 1,3
         DO 25 J = 1,3
            IF (UMATS(I,J,1).NE.0.0) GO TO 35
 25         CONTINUE
 30      CONTINUE
      MSGTXT = 'ALGSTB: ROTATION MATRIX UMATS IS 0, FIELD 1'
      CALL MSGWRT (6)
      MSGTXT = 'ALGSTB: THIS IS A SERIOUS ERROR SINCE MFIELD > 1'
      IF (MFIELD.GT.1) CALL MSGWRT (7)
      CALL RCOPY (9, UMAT, UMATS)
C                                       Get maximum u
 35   CALL UVPROT ('READ', IDISK, ICNOSC, LUNS(2), INDS(2), MFIELD,
     *   UMATS, CCROT, SSROT, NVIS, LREC, ILENBU, JBUFSZ, BUFF1, NIO,
     *   INPTR, FRSTU, DISKO, CNOSCO, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL ZCLOSE (LUNS(2), INDS(2), IRET)
C                                       Find Max Frequency
      MAXFRQ = FREQG(CHANEL)
      MINFRQ = FREQG(CHANEL)
      DO 40 I = 2,NCHAN
         BUFF3(I-1) = 0.0
         IF (FREQG(CHANEL+I-1).GT.0.0D0) THEN
            MAXFRQ = MAX (MAXFRQ, FREQG(CHANEL+I-1))
            MINFRQ = MIN (MINFRQ, FREQG(CHANEL+I-1))
            BUFF3(I-1) = FREQG(CHANEL+I-1)/FREQG(CHANEL+I-2) - 1.0D0
            END IF
 40      CONTINUE
C                                       Scale by Max Freq. to cells
      MAXU   = ABS (FRSTU * MAXFRQ / FREQ * ZSCLU) + 0.99
C                                       Limit u to max that will fit
      MAXU   = MIN (MAXU, NXO2)
C                                       Calc number needed
      NROGRD = MAXU + M
C                                       Do all rows fit in ap?
      ALLROW = MXROGD.GE.NROGRD
C                                       Number of rows in a pass
      NROWS  = MIN (NROGRD, MXROGD)
C                                       If all rows fit, 1 pass
      IF (ALLROW) THEN
         NRPASS = 1
         WRITE (MSGTXT,1040) NROWS, MXROGD
C                                       Else, how many row passes?
      ELSE
         NRPASS = (MAXU + 1)/(NROWS - M + 1)
         IF (NRPASS*(NROWS-M+1).LT.(MAXU+1)) NRPASS = NRPASS + 1
         WRITE (MSGTXT,1041) NROWS, NROGRD
         END IF
      IF (.NOT.ONCE) CALL MSGWRT (2)
      VISRED = 0
      LOCHAN = 1
      NCHGRD = NCHAN
      LOC = CHANEL + LOCHAN - 1
      HIC = LOC + NCHGRD - 1
      IF (MFIELD.LE.1) THEN
         WRITE (MSGTXT,1045) CSTOK, LOC, HIC
      ELSE
         WRITE (MSGTXT,1046) IFIELD, CSTOK, LOC, HIC
         END IF
      CALL MSGWRT (2)
C                                       Determine where data starts.
      FLIST(10) = MIN (MAXU+MO2+1, NXO2+1)
C                                       Get frequency scaling factors.
      FFRAC = (MINFRQ / FREQ) - 1.0D0
      GFACT = 1.0D0 / ((1.0D0 + FFRAC) * ZSCLU)
      MNFACT = ZSCLU * MINFRQ / FREQ
      MXFACT = ZSCLU * MAXFRQ / FREQ
      FFRAC = (MAXFRQ / FREQ) - 1.0D0
      SCALU = FFRAC * ZSCLU + ZSCLU
      SCALV = FFRAC * ZSCLV + ZSCLV
C                                       Set limits on u,v - do not get
C                                       Within mint/2+1 of edge.
      UUMAX = ABS (((NX/2) - (MINT/2+1)) / SCALU)
      VVMAX = ABS (((NY/2) - (MINT/2+1)) / SCALV)
C                                       Setup ap griding constants
      FFRAC = (FREQG(LOCHAN+CHANEL-1) / FREQ) - 1.0D0
      XTEMP(1) = (ZSCLU + FFRAC * ZSCLU)
      XTEMP(2) = (ZSCLV + FFRAC * ZSCLV)
      XTEMP(3) = DDX(1) / ZSCLU
      XTEMP(4) = DDX(2) / ZSCLV
      XTEMP(5) = DDX(3) + DDX(3)*FFRAC
      XTEMP(6) = 0.0
      XTEMP(7) = 0.0
      IXTEMP(1) = 0
      IXTEMP(2) = LOGRID
      IXTEMP(3) = CX
      CALL QPUT (APCORE, XTEMP, 0, 7, 2)
      CALL QPUT (APCORE, RXTEMP, 7, 3, 1)
C                                       Correlator scaling table.
      CALL QPUT (APCORE, FACT2, 16, NS, 2)
      RXTEMP(1) = 1.0
      CALL QPUT (APCORE, RXTEMP, 15, 1, 2)
C                                       Frequency scaling table.
      BUFF3(NCHGRD) = 0.0
      CALL QPUT (APCORE, BUFF3, 20, NCHGRD, 2)
C                                       Set interpolation tables
      CALL INTPFN (APCORE, CX, M, BUFF3, JBUFSZ, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Save space for 4 word work array.
      MAXREC = (CX - 20 - NS - NCHGRD) / (LLREC+4) - 5
C                                       No more recs than conj table.
      IF (MAXREC.GT.CJTBSZ) MAXREC = CJTBSZ
C                                       More ap pointers.
      WORK = 20 + NCHGRD
      UV = WORK + 4 + (MAXREC * 4)
C                                       Correction for stokes.
      VISOFF = LRPARM + ((CHANEL-1) + (LOCHAN-1))*JNCF + (VOFF / INCS) *
     *   JNCS
      VIS = UV + VISOFF
C                                       Set location of data inp ap
      IDATA = UV
      IUMAX = MAXU
      RPASS = 0
      LUMAX = 10 * MAXU
      LUMIN = LUMAX + 1
C                                       Row pass loop point
 50   RPASS = RPASS + 1
         IUMIN = MAX (IUMAX - (NROWS-M), 0)
         IUFMAX = -1000
         LSTRT = USTRT
         LSTOP = USTOP
C                                       Load ALL rows
         USTRT = MAX (IUMIN - MO2, 0)
         USTOP = MIN (IUMAX+MO2, NXO2)
C                                       move ones previously loaded
         IF ((RPASS.GT.1) .AND. (USTOP.GE.LSTRT)) THEN
C                                       wait for AP to FINISH
            CALL QWAIT
C                                       must move from top to bottom
            NROW = USTOP - LSTRT + 1
            DO 60 I = 1,NROW
               END1 = LOGRID + ((NROW-I)*ROWSIZ)
               EROW = LOGRID + ((USTOP-(IUMIN-MO2))*ROWSIZ)
               CALL QVMOV (APCORE, END1, 1, EROW, 1, ROWSIZ)
               CALL QWAIT
               USTOP = USTOP - 1
 60            CONTINUE
C                                       clear rest for gridding
            CALL QVCLR (APCORE, LOGRID, 1, EROW-LOGRID)
            CALL QWAIT
            END IF
C                                       Load grided uv values in ap
         CALL APLOAD (APCORE, USTRT, USTOP, IUMIN-MO2, ROWSIZ, LOGRID,
     *      APSIZE, FLIST, BUFF2, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       When near end of rows
         IF (IUMIN.EQ.0) THEN
            DO 90 IU = 1, MO2
C                                       Convert to decreasing u
               U = MO2 - IU + 1
C                                       U=0 at lrow/2
C                                       U<0 rows from complex cong u>0
C                                       Index points to end of u row
               INDEX = LOGRID + ((U+MO2+1)*ROWSIZ) - IFACT
C                                       Erow points to start of -u row
               EROW  = LOGRID + ((MO2-U)*ROWSIZ)
               CALL QCVCON (APCORE, INDEX, -IFACT, EROW+IFACT, IFACT,
     *            LROW-1)
C                                       Index points to start same u row
               INDEX = INDEX - ROWSIZ + IFACT
C                                       Conjugate a single pixel
               CALL QCVCON (APCORE, INDEX, IFACT, EROW, IFACT, 1)
 90            CONTINUE
            END IF
C                                       Set min and max this pass
         UMAX = (IUMAX + 0.5) * GFACT
         UMIN = (IUMIN - 0.5) * GFACT
         OUTPTR = 1
         INPTR  = 1
         ILENBU = MIN (LENBU, MAXREC)
C                                       Set output file name.
         CALL UVPREP ('WRIT', DISKO, CNOSCO, LUNS(3), INDS(3), NVIS,
     *      LREC, ILENBU, JBUFSZ, BUFF3, NIOUT, OUTPTR, FRSTU, IRET)
         IF (IRET.NE.0) GO TO 999
         NIOUT = ILENBU
         ILENBU = MIN (LENBU, MAXREC)
C                                       Prepare to read through data
         CALL UVPREP ('READ', IDISK, ICNOSC, LUNS(2), INDS(2), NVIS,
     *      LREC, ILENBU, JBUFSZ, BUFF1, NIO, INPTR, FRSTU, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Reset input to output file.
         IDISK = DISKO
         ICNOSC = CNOSCO
C                                       Count points this pass
         NPOINT = 0
         UCOUNT = NIO
         UTARG = 1
C                                       Loop forever, read all uvdata
 100     CONTINUE
            IF (UCOUNT.GT.UTARG) THEN
               WRITE (MSGTXT,1100) UTARG
               CALL MSGWRT (2)
               UTARG = UTARG + 200000
               END IF
C                                       Rotate, save init u,v,w
            JNPTR = INPTR
            DO 110 I =1,NIO
               UVWS(1,I) = BUFF1(JNPTR+ILOCU)
               UVWS(2,I) = BUFF1(JNPTR+ILOCU+1)
               UVWS(3,I) = BUFF1(JNPTR+ILOCU+2)
               CALL PRJMUL (1, BUFF1(JNPTR+ILOCU), UMAT,
     *            BUFF1(JNPTR+ILOCU))
               JNPTR = JNPTR + LREC
 110           CONTINUE
C                                       Start read from beginning of uvs
            JNPTR = INPTR
C                                       Put uvdata back at beginning
            KNPTR = INPTR
C                                       Use start of output buffer
            LNPTR = OUTPTR
C                                       Count points this buffer
            CNT = 0
C                                       Do all points in buffer
            DO 200 IVIS = 1,NIO
C                                       Input u, v values
               UIN = ABS (BUFF1(JNPTR+ILOCU))
               VIN = ABS (BUFF1(JNPTR+ILOCV))
               IULO = MNFACT * UIN + 0.5
               IUHI = MXFACT * UIN + 0.5
               RULO = MNFACT * UIN
               RUHI = MXFACT * UIN
C                                       uv outside range.
               IF ((UIN.GT.UUMAX) .OR. (VIN.GT.VVMAX)) THEN
                  CALL UVLIMT (0.0, 1.0E20, UUMAX, VVMAX, IVIS,
     *               UIN, VIN, ERRCNT)
C                                       Reset u to within range
                  UIN = MAXU * GFACT
                  UIN = MIN (UUMAX, UIN) * 0.99
C                                       Put location back in buffer
                  BUFF1(JNPTR+ILOCU) = UIN
                  BUFF1(JNPTR+ILOCV) = 0.0
C                                       Zero data
                  CALL RFILL (LREC-VISOFF, 0.0, BUFF1(JNPTR+VISOFF))
C                                       Zero data leave weights
               ELSE IF (UUU.EQ.0.0) THEN
                  KK = JNPTR + VISOFF - 1
                  JJ = LREC - VISOFF
C                                       compressed
                  IF (LREC.LT.LLREC) THEN
                     CALL RFILL (LREC-NRPARM, 0.0, BUFF1(JNPTR+NRPARM))
                  ELSE
                     DO 120 II = 1,JJ,3
                        BUFF1(KK+II) = 0.0
                        BUFF1(KK+II+1) = 0.0
                        IF (FACGRD(2).LT.0.0) BUFF1(KK+II+2) = 1.0
 120                    CONTINUE
                     END IF
                  END IF
C                                       If datum on current rows
C              IF (UIN.GT.UMIN .AND. (UIN.LE.UMAX.OR.RPASS.EQ.1)) THEN
               IF (((IUHI.LE.IUMAX) .OR. (RPASS.EQ.1)) .AND.
     *            (IULO.GE.IUMIN) .AND. ((RPASS.EQ.1) .OR.
     *            (IUHI.GT.LUMAX) .OR. (IULO.LT.LUMIN))) THEN
C                                       Keep count of number to process
                  CNT = CNT + 1
C                                       Store output point location
                  CNJPTR(CNT) = LNPTR
C                                       If u neg. then flip
                  IF (BUFF1(JNPTR+ILOCU).LT.0.0) THEN
C                                       Enter in cnjptr table.
                     CNJPTR(CNT) = -LNPTR
C                                       Flip u, v, w, conjugate data.
                     CALL UVCONJ (VISOFF, JNCF, NCHGRD, NSTOK,
     *                  JNCS, BUFF1(JNPTR))
C                                       End if u < 0, conjugate
                     END IF
C                                       If more than 1 pass
                  IF (.NOT.ALLROW) THEN
C                                       Put data in buff for processing
                     CALL COPY (LREC, BUFF1(JNPTR), BUFF1(KNPTR))
C                                       Update output pointer
                     KNPTR = KNPTR + LREC
                     END IF
C                                       Else not in current rows
               ELSE
                  IF (IULO.LT.IUMIN) IUFMAX = MAX (IUFMAX, IUHI)
C                                       Put in output buffer
                  CALL COPY (LREC, BUFF1(JNPTR), BUFF3(LNPTR))
C                                       End if on current rows
                  END IF
C                                       Set new input and output pos
               JNPTR = JNPTR + LREC
               LNPTR = LNPTR + LREC
C                                       End for all vis recs read
 200           CONTINUE
C                                       Keep track of total
            VISRED = VISRED + CNT
C                                       Count points in range each pass
            NPOINT = NPOINT + CNT
C                                       If points were found
            IF (CNT.GT.0) THEN
C                                       Wait for ap, then load into ap
               CALL QWR
C                                       Uncompress Vis and put in AP
               CALL BUFPUT (APCORE, CNT, NRPARM, LREC, LLREC, IDATA,
     *            BUFF1(INPTR), TEMPBF(1))
C                                       Low row to ap
               IXTEMP(1) = IUMIN
               IXTEMP(2) = LOGRID
               CALL QPUT (APCORE, RXTEMP, 7, 3, 1)
               CALL QWAIT
               CALL QUVIN (APCORE, UV, VIS, WORK, LLREC, MM, LROW, NS,
     *            JNCS, NCHGRD, JNCF, CNT, FLAG)
               CALL QWR
C                                       Read out interpolated data
C                                       If all data in ap
               IF (ALLROW) THEN
C                                       Get UVs from AP (maybe pack UV)
                  CALL BUFGET (APCORE, CNT, NRPARM, LREC, LLREC, IDATA,
     *               BUFF3(OUTPTR), TEMPBF(1))
C                                       Else get some data
               ELSE
C                                       Get UVs from AP (maybe pack UV)
                  CALL BUFGET (APCORE, CNT, NRPARM, LREC, LLREC, IDATA,
     *               BUFF1(INPTR), TEMPBF(1))
                  JNPTR = INPTR
C                                       For all points
                  DO 400 I = 1,CNT
C                                       Get output location of data
                     LNPTR = ABS(CNJPTR(I))
C                                       Move from input to output
                     CALL COPY (LREC, BUFF1(JNPTR), BUFF3(LNPTR))
C                                       Start location of next vis rec.
                     JNPTR = JNPTR + LREC
 400                 CONTINUE
C                                       End if not all in ap
                  END IF
C                                       For all points, conjugate
               DO 500 ICONJ = 1, CNT
C                                       If point was conjugated
                  IF (CNJPTR(ICONJ).LT.0) THEN
C                                       Get position
                     LNPTR = -CNJPTR(ICONJ)
C                                       Flip u, v, w, conjugate data.
                     CALL UVCONJ (VISOFF, JNCF, NCHGRD, NSTOK, JNCS,
     *                  BUFF3(LNPTR))
                     END IF
 500              CONTINUE
C                                       End if points this pass
               END IF
C                                       restore u,v,w
            JNPTR = OUTPTR
            DO 520 I = 1,NIO
               BUFF3(JNPTR+ILOCU) = UVWS(1,I)
               BUFF3(JNPTR+ILOCU+1) = UVWS(2,I)
               BUFF3(JNPTR+ILOCU+2) = UVWS(3,I)
               JNPTR = JNPTR + LREC
 520           CONTINUE
C                                       Write all nio points read
            NIOUT = NIO
C                                       Write data to disk
            CALL UVDISK ('WRIT', LUNS(3), INDS(3), BUFF3, NIOUT,
     *         OUTPTR, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1200) IRET
               GO TO 995
               END IF
C                                       Read a new uvdata buffer
            CALL UVDISK ('READ', LUNS(2), INDS(2), BUFF1, NIO, INPTR,
     *         IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1300) IRET
               GO TO 995
               END IF
            UCOUNT = UCOUNT + NIO
C                                       If more data, loop
            IF (NIO.GT.0) GO TO 100
C                                       Jump here on end uv data
C                                       Write Diag messages ONLY once
C                                       Print only 10 Messages
         IF (.NOT.ONCE) THEN
            WRITE(MSGTXT,1104,ERR=680) RPASS, IUMAX, IUMIN, NPOINT
            MSGINC = (NRPASS/10) + 1
 680        IF (((RPASS/MSGINC)*MSGINC).EQ.RPASS) CALL MSGWRT (2)
            END IF
C                                       Finish write.
         NIOUT = 0
         CALL UVDISK ('FLSH', LUNS(3), INDS(3), BUFF3, NIOUT, OUTPTR,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1500) IRET, I
            GO TO 995
            END IF
C                                       Close files
         CALL ZCLOSE (LUNS(2), INDS(2), IRET)
         CALL ZCLOSE (LUNS(3), INDS(3), IRET)
         LUMIN = IUMIN
         LUMAX = IUMAX
C                                       end of rows loop: do more?
         IF (IUFMAX.GT.0) THEN
            IUMAX = IUFMAX
            GO TO 50
            END IF
C                                       Check that written all data read
      IF (NVIS.NE.VISRED) THEN
         WRITE (MSGTXT,1600) NVIS, VISRED
         CALL MSGWRT (8)
         END IF
      IF ((DOFLAG) .AND. (ERRCNT.GT.0)) THEN
         MSGTXT = '**************************************************'
     *     // '*****'
         CALL MSGWRT (8)
         WRITE (MSGTXT,1601) ERRCNT
         CALL MSGWRT (8)
         MSGTXT = '**************************************************'
     *     // '*****'
         CALL MSGWRT (8)
         END IF
C                                       re-set pointers to beginning
C                                       of the grid file.
      CALL APIO (APCORE, 'INIT', FLIST, LOGRID, BUFF2, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1400) IRET
         GO TO 995
         END IF
C                                       Give up AP.
      CALL QRLSE
C                                       write diag messages once only
C                                       DEBUG
C     ONCE = .TRUE.
C                                       Close grid file.
      CALL APIO (APCORE, 'CLOS', FLIST, LOGRID, BUFF2, IRET)
      IF (COMPDT) THEN
         LREC = ITEMP1
         NRPARM = ITEMP2
         END IF
      GO TO 999
C                                       Error
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('ALGSTB: All ',I5,' Rows In AP (Max  ',I5,')')
 1041 FORMAT ('ALGSTB: Only',I5,' Rows In AP (Need ',I5,')')
 1045 FORMAT ('ALGSTB: ',A1,'pol gridded model subtraction, chans',I5,
     *   ' through',I5)
 1046 FORMAT ('ALGSTB field',I5,1X,A1,'pol gridded model subtraction',
     *   ' chns',I5,'-',I5)
 1100 FORMAT ('ALGSTB: at visibility number',I12)
 1104 FORMAT ('ALGSTB: Pass',I4,';',I5,'-',I4,' Cells, with',I9,
     *        ' Pts')
 1200 FORMAT ('ALGSTB: WRITE ERROR IN VISIBILITY FILE, IER=',I6)
 1300 FORMAT ('ALGSTB: READ  ERROR IN VISIBILITY FILE, IER=',I6)
 1400 FORMAT ('ALGSTB: TROUBLE INIT GRID FILE, IER=',I5)
 1500 FORMAT ('ALGSTB: ERROR',I5,' READING GRID ROW ',I5)
 1600 FORMAT ('ALGSTB: WARNING! Misplaced Data, NVIS = ',I8,
     *   ' WRITTEN =',I8)
 1601 FORMAT ('ALGSTB:',I10,' POINTS FLAGGED FOR BEING OFF THE GRID')
      END

      PROGRAM GRITP
C-----------------------------------------------------------------------
C! GRITP writes contents of a Gripe file on to a FITS-like tape.
C# Utility Service TApe Gripe
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2004, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GRITP is an AIPS system service program which writes the contents
C   of a Gripe file on to a FITS-like tape.  The tape will be solely
C   a FITS header of the form
C          SIMPLE  =                      T
C          BITPIX  =                     16
C          NAXIS   =                      0
C                  comments = Gripes in cols 9-80, blank in cols 1-8
C          END
C   End of lines are represented by '\\' rather than CrLf.
C-----------------------------------------------------------------------
      CHARACTER TEMP*4, OBUF*2880, PHNAME*48, BKSL*2, CTEMP*80, M*1,
     *   MSGBUF*72, PRGNAM*6, LF*1, CR*1, OPER*4, REMHOS*24, LMSG*80
      HOLLERITH LBUF(256), HOBUF(720)
      INTEGER   SCR(256), HBUF(256), LUN, IND, IERR,TTYLUN, JTRIM,
     *   TTYIND, TLUN, TIND, TVOL, LREC, LPOS, NCHPR, IPOS, LBYTES,
     *   OPOS, ILBUF(256), J1, J2, K1, K2, IILF, IICR, IDENS, IFILE,
     *   I2TMP1, I, LFITS, IREC, TTY(2), REMTAP, SYSERR
      LOGICAL   T, F, EQUAL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (TTY(1), TTYLUN),  (TTY(2), TTYIND)
      EQUIVALENCE (ILBUF, LBUF)
      DATA LFITS /2880/
      DATA LUN, TTYLUN /27, 5/
      DATA T, F /.TRUE.,.FALSE./
      DATA PRGNAM /'GRITP '/
      DATA IILF, IICR /10, 13/
      DATA BKSL /'\\'/
C-----------------------------------------------------------------------
C                                       Only ASCII
      LF = CHAR(IILF)
      CR = CHAR(IICR)
C                                       AIPS init
      CALL AIPINI (TTY, PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 980
      TIND = 0
C                                       Open gripe file
      CALL ZPHFIL ('GR', 1, 0, 0, PHNAME, IERR)
      CALL ZOPEN (LUN, IND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL ZFIO ('READ', LUN, IND, 1, HBUF, IERR)
      IF (IERR.NE.0) GO TO 980
      IF (HBUF(2).LE.0) THEN
         MSGTXT = 'There are no gripes, exiting'
         CALL MSGWRT (6)
         GO TO 980
         END IF
C                                       Tape volume #
 10   MSGBUF = 'Tape drive number ?;    0 => none'
      CALL INQINT (TTY, MSGBUF, 1, TVOL, IERR)
      IF (IERR.LT.0) GO TO 10
      IF (IERR.GT.0) GO TO 970
      IF (TVOL.GT.NTAPED) TVOL = 1
      TLUN = 129 - TVOL
      IF (TVOL.EQ.0) GO TO 200
C                                       Mount the tape?
 15   MSGBUF = 'Mount at density = ????;   0 or N => don''t mount'
      CALL INQINT (TTY, MSGBUF, 1, IDENS, IERR)
      IF (IERR.GT.0) GO TO 970
      IF ((IERR.LT.0) .OR. (IDENS.LE.0)) GO TO 20
         IF ((IDENS.NE.800) .AND. (IDENS.NE.1600) .AND. (IDENS.NE.6250))
     *      GO TO 15
         MSGBUF = 'Enter remote host name - just hit return if local'
         CALL INQSTR (TTY, MSGBUF, 24, REMHOS, IERR)
         IF (IERR.GT.0) GO TO 970
         IF (REMHOS(1:1).NE.' ') THEN
            MSGBUF = 'Remote host tape drive number:'
            CALL INQINT (TTY, MSGBUF, 1, REMTAP, IERR)
            IF (IERR.GT.0) GO TO 970
            IF (IERR.LT.0) THEN
               REMHOS = ' '
               REMTAP = 0
               END IF
            END IF
C                                       Mount
         CALL ZMOUNT (.TRUE., TVOL, IDENS, REMHOS, REMTAP, LMSG, SYSERR,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1015) IERR
            CALL MSGWRT (8)
            GO TO 980
            END IF
C                                       OP code: WRITE VERIFY
 20   MSGBUF = 'Write or verify? (A4)'
      CALL INQSTR (TTY, MSGBUF, 4, TEMP, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL CHLTOU (4, TEMP)
      IF ((TEMP.NE.'WRIT') .AND. (TEMP.NE.'VERI')) GO TO 20
C                                       Open tape
      OPER = 'WRIT'
      IF (TEMP.EQ.'VERI') OPER = 'READ'
      CALL ZPHFIL ('MT', TVOL, 0, 0, PHNAME, IERR)
      CALL ZTPOPN (TLUN, TIND, TVOL, PHNAME, OPER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (8)
         TIND = 0
         GO TO 980
         END IF
C                                       Position tape at BOF
 25   MSGBUF = 'Write in file # ?;  <= 0 => current file'
      CALL INQINT (TTY, MSGBUF, 1, IFILE, IERR)
      IF (IERR.LT.0) GO TO 25
      IF (IERR.GT.0) GO TO 970
      I = 1
      IF (IFILE.LE.0) THEN
         CALL ZTAPE ('BAKF', TLUN, TIND, I, IERR)
      ELSE
         CALL ZTAPE ('REWI', TLUN, TIND, I, IERR)
         IF (IERR.NE.0) GO TO 980
         IREC = IFILE - 1
         IF (IREC.GT.0) THEN
            CALL ZTAPE ('ADVF', TLUN, TIND, IREC, IERR)
            IF ((IERR.EQ.4) .OR. (IERR.EQ.6)) THEN
               MSGTXT = 'END OF TAPE HIT: WRITING THERE'
               CALL MSGWRT (6)
               IERR = 0
               END IF
            END IF
         END IF
      IF (IERR.NE.0) GO TO 980
      LREC = HBUF(3)
      LPOS = HBUF(4)
      NCHPR = 256 * 4
      IREC = 2
      IPOS = 1
      OPOS = 1
C                                       Read first disk record
      CALL ZFIO ('READ', LUN, IND, IREC, ILBUF, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Write the tape
      IF (TEMP.EQ.'VERI') GO TO 100
C                                       FITS commands onto tape
C                                       SIMPLE = T
         WRITE (MSGBUF,1030)
         I = JTRIM (MSGBUF)
         OBUF(OPOS:OPOS+79) = MSGBUF
         OPOS = OPOS + 80
C                                       BITPIX = 16
         WRITE (MSGBUF,1031)
         I = JTRIM (MSGBUF)
         OBUF(OPOS:OPOS+79) = MSGBUF
         OPOS = OPOS + 80
C                                       NAXIS = 0
         WRITE (MSGBUF,1032)
         I = JTRIM (MSGBUF)
         OBUF(OPOS:OPOS+79) = MSGBUF
         OPOS = OPOS + 80
C                                       GRIPES = nnn
         WRITE (MSGBUF,1033) HBUF(2)
         I = JTRIM (MSGBUF)
         OBUF(OPOS:OPOS+79) = MSGBUF
         OPOS = OPOS + 80
C                                       Card image loop
C                                       Blank keyword field
 50      OBUF(OPOS:OPOS+7) = ' '
            OPOS = OPOS + 8
            J1 = MIN (72, NCHPR+1-IPOS)
            IF (IREC.EQ.LREC) J1 = MIN (J1, LPOS-IPOS)
            J2 = 72 - J1
            CALL H2CHR (J1, IPOS, LBUF, OBUF(OPOS:))
            IPOS = IPOS + J1
            OPOS = OPOS + J1
            IF ((IREC.GE.LREC) .AND. (IPOS.GE.LPOS)) GO TO 80
C                                       Read new record
            IF (IPOS.LE.NCHPR) GO TO 55
               IREC = IREC + 1
               CALL ZFIO ('READ', LUN, IND, IREC, ILBUF, IERR)
               IF (IERR.NE.0) GO TO 980
               IPOS = 1
C                                       More copy - finish card
 55         IF (J2.LE.0) GO TO 60
               IF ((IREC.EQ.LREC) .AND. (J2+IPOS.GT.LPOS)) J2 = LPOS -
     *            IPOS
               CALL H2CHR (J2, IPOS, LBUF, OBUF(OPOS:))
               IPOS = IPOS + J2
               OPOS = OPOS + J2
               IF ((IREC.GE.LREC) .AND. (IPOS.GE.LPOS)) GO TO 80
C                                       Write tape record
 60         IF (OPOS.LE.2880) GO TO 50
C                                       Convert CrLf -> \\
               DO 70 I = 1,2880
                  M = OBUF(I:I)
                  IF (M.EQ.CR) OBUF(I:I) = BKSL(1:1)
                  IF (M.EQ.LF) OBUF(I:I) = BKSL(1:1)
 70               CONTINUE
               CALL ZCLC8 (2880, OBUF, 1, HOBUF)
               CALL ZTPMIO ('WRIT', TLUN, TIND, LFITS, HOBUF, 1, IERR)
               IF (IERR.EQ.0) CALL ZTPWAT (TLUN, TIND, 1, LBYTES, IERR)
               IF (IERR.NE.0) GO TO 980
               OPOS = 1
               GO TO 50
C                                       Finish last record
 80      J1 = 2881 - OPOS
         OBUF(OPOS:OPOS+J1-1) = ' '
         OPOS = ((OPOS+78) / 80) * 80 + 1
         OBUF(OPOS:OPOS+3) = 'END '
C                                       Convert CrLf -> \\
         DO 90 I = 1,2880
            M = OBUF(I:I)
            IF (M.EQ.CR) OBUF(I:I) = BKSL(1:1)
            IF (M.EQ.LF) OBUF(I:I) = BKSL(1:1)
 90         CONTINUE
         CALL ZCLC8 (2880, OBUF, 1, HOBUF)
         CALL ZTPMIO ('WRIT', TLUN, TIND, LFITS, HOBUF, 1, IERR)
         IF (IERR.EQ.0) CALL ZTPWAT (TLUN, TIND, 1, LBYTES, IERR)
         IF (IERR.NE.0) GO TO 980
         I = 1
         CALL ZTAPE ('WEOF', TLUN, TIND, I, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Do VERIfy too - ask user
         MSGBUF = 'Do a verify pass? (A4)'
         CALL INQSTR (TTY, MSGBUF, 4, TEMP, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL CHLTOU (4, TEMP)
         IF ((TEMP.NE.'YES ') .AND. (TEMP.NE.'VERI')) GO TO 180
C                                       Reposition the tape
         I = 2
         CALL ZTAPE ('BAKF', TLUN, TIND, I, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Reposition disk
         IREC = 2
         CALL ZFIO ('READ', LUN, IND, IREC, ILBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         IPOS = 1
C                                       VERIfy the tape vs disk
 100  CONTINUE
C                                       Read first tape record
         CALL ZTPMIO ('READ', TLUN, TIND, LFITS, HOBUF, 1, IERR)
         IF (IERR.EQ.0) CALL ZTPWAT (TLUN, TIND, 1, LBYTES, IERR)
         IF (IERR.NE.0) GO TO 980
         CALL ZC8CL (2880, 1, HOBUF, OBUF)
         OPOS = 321
C                                       Convert first disk record
C                                       to CrLf -> \\
         DO 110 I = 1,NCHPR
            K1 = (I-1) / 4 + 1
            DO 105 K2 = 1,4
               CALL H2CHR (1, K2, LBUF(K1), M)
               IF (M.EQ.LF) CALL CHR2H (1, BKSL(1:1), K2, LBUF(K1))
               IF (M.EQ.CR) CALL CHR2H (1, BKSL(1:1), K2, LBUF(K1))
 105           CONTINUE
 110        CONTINUE
C                                       Card image loop
C                                       Blank keyword field skip
 120     OPOS = OPOS + 8
            J1 = MIN (72, NCHPR+1-IPOS)
            IF (IREC.EQ.LREC) J1 = MIN (J1, LPOS-IPOS)
            J2 = 72 - J1
            CALL H2CHR (J1, IPOS, LBUF, CTEMP)
            EQUAL = CTEMP(1:J1) .EQ. OBUF(OPOS:OPOS+J1-1)
            IF (.NOT.EQUAL) GO TO 165
            IPOS = IPOS + J1
            OPOS = OPOS + J1
            IF ((IREC.GE.LREC) .AND. (IPOS.GE.LPOS)) GO TO 150
C                                       Read next disk record
            IF (IPOS.LE.NCHPR) GO TO 135
               IREC = IREC + 1
               CALL ZFIO ('READ', LUN, IND, IREC, ILBUF, IERR)
               IF (IERR.NE.0) GO TO 980
               IPOS = 1
C                                       CrLf -> \\
               DO 130 I = 1,NCHPR
                  K1 = (I-1) / 4 + 1
                  DO 125 K2 = 1,4
                     CALL H2CHR (1, K2, LBUF(K1), M)
                     IF (M.EQ.LF) CALL CHR2H (1, BKSL(1:1), K2,
     *                  LBUF(K1))
                     IF (M.EQ.CR) CALL CHR2H (1, BKSL(1:1), K2,
     *                  LBUF(K1))
 125                 CONTINUE
 130              CONTINUE
 135        IF (J2.LE.0) GO TO 140
               IF ((IREC.EQ.LREC) .AND. (J2+IPOS.GT.LPOS)) J2 = LPOS -
     *            IPOS
               CALL H2CHR (J2, IPOS, LBUF, CTEMP)
               EQUAL = CTEMP(1:J2) .EQ. OBUF(OPOS:OPOS+J2-1)
               IF (.NOT.EQUAL) GO TO 160
               IPOS = IPOS + J2
               OPOS = OPOS + J2
               IF ((IREC.GE.LREC) .AND. (IPOS.GE.LPOS)) GO TO 150
C                                       Read next tape record
 140        IF (OPOS.LE.2880) GO TO 120
               CALL ZTPMIO ('READ', TLUN, TIND, LFITS, HOBUF, 1, IERR)
               IF (IERR.EQ.0) CALL ZTPWAT (TLUN, TIND, 1, LBYTES, IERR)
               IF (IERR.NE.0) GO TO 980
               OPOS = 1
               CALL ZC8CL (2880, 1, HOBUF, OBUF)
               GO TO 120
C                                       Done and ok
 150     MSGTXT = 'Tape seems to be OK'
         CALL MSGWRT (4)
         GO TO 180
C                                       Error - bad compare
 160     J1 = J2
 165     WRITE (MSGTXT,1165) IREC
         CALL MSGWRT (8)
         CALL H2CHR (J1, IPOS, LBUF, MSGTXT)
         I2TMP1 = J1 + 1
         MSGTXT(I2TMP1:I2TMP1+1) = '  '
         CALL MSGWRT (6)
         MSGTXT(1:J1) = OBUF(OPOS:OPOS+J1-1)
         I2TMP1 = J1 + 1
         MSGTXT(I2TMP1:I2TMP1+1) = '  '
         CALL MSGWRT (6)
         GO TO 980
C                                       Dismount the tape?
 180  MSGBUF = 'Do you wish to dismount the tape? Yes or no (A4)'
      CALL INQSTR (TTY, MSGBUF, 4, TEMP, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL CHLTOU (4, TEMP)
C                                       Close and dismount
      IF (TEMP.EQ.'YES ') THEN
         CALL ZTPCLS (TLUN, TIND, IERR)
         TIND = 0
         I = 1
         CALL ZTAPE ('DMNT', TLUN, TVOL, I, IERR)
         END IF
C                                       Initialize the file
 200  MSGBUF = 'Init the file? Yes or no (A4)'
      CALL INQSTR (TTY, MSGBUF, 4, TEMP, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL CHLTOU (4, TEMP)
C                                       Go ahead
      IF (TEMP.EQ.'YES ') THEN
C                                       require password
         CALL PASWRD (SCR, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       do init
         HBUF(2) = 0
         HBUF(3) = 2
         HBUF(4) = 1
         CALL ZFIO ('WRIT', LUN, IND, 1, HBUF, IERR)
         END IF
      GO TO 980
C                                       TTY error
 970  WRITE (MSGTXT,1970) IERR
      CALL MSGWRT (8)
C                                       Close Gripe file
 980  CALL ZCLOSE (LUN, IND, IERR)
      IF (TIND.GT.0) CALL ZTPCLS (TLUN, TIND, IERR)
      IF (TTYIND.GT.0) CALL ZCLOSE (TTYLUN, TTYIND, IERR)
C                                       Close accounting
 990  CALL ACOUNT (2)
C
 999  STOP
C-----------------------------------------------------------------------
 1015 FORMAT ('ERROR',I5,' MOUNTING TAPE')
 1020 FORMAT ('TAPE OPEN ERROR',I7)
 1030 FORMAT ('SIMPLE  =',20X,'T')
 1031 FORMAT ('BITPIX  =',19X,'16')
 1032 FORMAT ('NAXIS   =',20X,'0',10X,'/ No binary image')
 1033 FORMAT ('GRIPES  =',18X,I3,10X,'/ # AIPS gripe texts')
 1165 FORMAT ('VERIFY FAILS IN DISK RECORD',I6,' DISK, TAPE =')
 1970 FORMAT ('IO ERROR TO TERMINAL',I7)
      END

      SUBROUTINE ZTACT2 (ILEN, NAME, PID, IERR)
C-----------------------------------------------------------------------
C! inquires if a task is currently active on the local computer
C# Z2 System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZTACTQ/ZTACT2 determines if a specified task is active.
C   Inputs:
C      ILEN   I      length used in NAME (for C or Macro...)
C      NAME   C*6    Actual task name.
C   In/out:
C      PID    I(3)   Process "ID" code
C                    In:  PID(1-3) process #  0 => unknown
C                    Out: PID(1-3) the ID determined here from NAME
C   Output:
C      IERR   I      Error return code: 0 => ok, task active
C                       1 => task not active
C                       2 => invalid task name.
C                       3 => other
C   VMS version
C-----------------------------------------------------------------------
      CHARACTER NAME*6
      INTEGER   ILEN, PID(3), IERR
C
      INTEGER   SYS$GETJPIW, ITEM4(4), JERR, PPID
      INTEGER*2 ITEM2(8)
      INCLUDE '($SSDEF)'
      INCLUDE '($JPIDEF)'
      EQUIVALENCE (ITEM2, ITEM4)
C-----------------------------------------------------------------------
      CALL FILL (3, 0, PID)
C                                       make list of operation
      ITEM2(1) = 4
      ITEM2(2) = JPI$_PID
      ITEM4(2) = %LOC (PPID)
      ITEM4(3) = 0
      ITEM4(4) = 0
      JERR = SYS$GETJPIW ( , , NAME(:ILEN), ITEM2, , , )
      IF (JERR.EQ.1) THEN
         IERR = 0
         PID(1) = PPID
      ELSE
         IERR = 3
         IF (JERR.EQ.SS$_IVLOGNAM) IERR = 2
         IF (JERR.EQ.SS$_NONEXPR) IERR = 1
         IF (JERR.EQ.SS$_SUSPENDED) IERR = 0
         END IF
C
 999  RETURN
      END

      SUBROUTINE TVSCRL (IC, IERR)
C-----------------------------------------------------------------------
C! interactive TV scroll
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998-1999, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TVSCRL does the simple TV interactive scrolling operation
C   Inputs:
C      IC     I   Channel bit mask 1-NGREY, any larger => graphics too
C   Output
C      IERR   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IC, IERR
C
      INTEGER   IX, IY, IBUT, QUAD, ITW(3)
      REAL      RPOS(2), PPOS(2)
      LOGICAL   T, F, DOIT
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      MSGTXT = 'Cursor position controls image position'
      CALL MSGWRT (1)
      MSGTXT = 'Hit any button to exit'
      CALL MSGWRT (1)
      IX = 0
      IY = 0
      RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
      RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2
      CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL ZTIME (ITW)
C                                        force scroll
 10   CALL YSCROL (IC, IX, IY, T, IERR)
      IF (IERR.NE.0) GO TO 900
         PPOS(1) = RPOS(1)
         PPOS(2) = RPOS(2)
C                                        read until cursor moves
 20      CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF (.NOT.DOIT) GO TO 20
            IX = RPOS(1) - (WINDTV(1) + WINDTV(3)) / 2
            IY = RPOS(2) - (WINDTV(2) + WINDTV(4)) / 2
            IF (IBUT.EQ.0) GO TO 10
C                                        close down
C                                        cursor off, TV closed
 900  CALL YCURSE ('OFFF', F, F, RPOS, QUAD, IBUT, IX)
C
 999  RETURN
      END

      SUBROUTINE YSTCUR (OP, X, Y, NPOINT, PACK, VRTRTC, BUFFER, IERR)
C-----------------------------------------------------------------------
C! reads/writes the cursor pattern array
C# Y3 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YSTCUR reads/writes the TV cursor array which has the pattern
C   exhibited when the cursor is visible.  NOTE: if more than one
C   row is read/written at a time, then the Y value decreases!!!
C   Inputs:
C      OP      C*4    'READ' from TV or 'WRIT' to TV
C      X       I      initial X position (1-64, 1 => LHS)
C      Y       I      initial Y position (1-64, 1 => bot)
C      NPOINT  I      # pixel values in BUFFER
C      PACK    L      T => 2 values/word, F => 1 value/word
C      VRTRTC  L      T => do it on vertical retrace only
C   In/Out:
C      BUFFER  I(*)   data array (lsb's used only)
C   Output:
C      IERR    I      error code of Z...XF : 0 => ok, 2 => input error
C   Version for IIS Model 75  (use only X register)
C-----------------------------------------------------------------------
      CHARACTER OP*4
      LOGICAL   PACK, VRTRTC
      INTEGER   X, Y, NPOINT, BUFFER(*), IERR
C
      LOGICAL   COMAND
      INTEGER   UNIT, HEADER(8), BITS(16), MSB, LSB, NB, I, IX, IY
      DATA UNIT, COMAND /10, .FALSE./
C-----------------------------------------------------------------------
C                                       Error tests
      IERR = 2
      IF ((X.LT.1) .OR. (X.GT.64)) GO TO 999
      IF ((Y.LT.1) .OR. (Y.GT.64)) GO TO 999
      IF (NPOINT.LT.1) GO TO 999
      IX = X - 1
      IY = 64 - Y
      I = 64*IY + IX
      IF (I+NPOINT.GT.4096) GO TO 999
C                                       Address in subunit
C      MSB = I / 512
C      LSB = I - 512 * MSB
C                                       Header
      CALL YMKHDR (OP, UNIT, COMAND, NPOINT, I, 0, 0, 0, VRTRTC, HEADER)
      NB = 2 * NPOINT
      IF (PACK) THEN
         CALL ZGTBIT (16, HEADER(1), BITS)
         BITS(15) = 1
         CALL ZPTBIT (16, HEADER(1), BITS)
         NB = ((NPOINT+1)/2) * 2
         END IF
C                                       IO
      CALL ZM70XF (OP, NB, HEADER, BUFFER, IERR)
C
 999  RETURN
      END

      SUBROUTINE GETSIP (LAT, AZ, ZA, ALT, DLAT, DLONG, AZION, ZAION)
C-----------------------------------------------------------------------
C! Calculate geometry of sub-ionospheric point.
C# Util
C-----------------------------------------------------------------------
C;  Copyright (C) 1998-1999, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Given the azimuth and zenith angle of the line of sight, determine
C   the offsets of the intersection of the line of site with the
C   ionosphere in latitude and longitude relative to the observing site
C   and the azimuth and zenith angle of the line of sight at the point
C   of intersection.
C
C   The ionsphere is assumed to approximated by a thin shell at a
C   uniform altitude.
C
C   Numeric overflow will occur for extreme Northern latitudes.
C
C   Inputs:
C      LAT       R    Latitude of observer (radians)
C      AZ        R    Azimuth (radians)
C      ZA        R    Zenith angle (radians)
C      ALT       R    Altitude of ionosphere (metres)
C
C   Outputs:
C      DLAT      R    Latitude offset of subionospheric point (rad)
C      DLONG     R    Longitude offset of SIP (radians)
C      AZION     R    Azimuth at intersection (radians)
C      ZAION     R    Zenith angle at intersection (radians)
C-----------------------------------------------------------------------
      REAL    LAT, AZ, ZA, ALT, DLAT, DLONG, AZION, ZAION
C
C   Local variables:
C      RADIUS    Earth radius (m)
C      THETA     Great circle distance from observer to SIP (radians)
C      LATION    Latitude of the sub-ionospheric point (radians)
C
      REAL    RADIUS, THETA, LATION, SAZION
      PARAMETER (RADIUS = 6378000.0)
C
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C
C     The two-dimensional sine rule gives the zenith angle at the
C     intersection of the line of sight with the ionosphere:
C
      ZAION = ASIN ((RADIUS * SIN (ZA)) / (RADIUS + ALT))
C
C     Use the sum of the internal angles of a triange to determine THETA
C
      THETA = ZA - ZAION
C
C     The cosine rule for spherical triangles gives us the latitude of
C     the sub-ionospheric point.
C
      LATION = ASIN (SIN (LAT) * COS (THETA)
     *         + COS (LAT) * SIN (THETA) * COS (AZ))
      DLAT = LATION - LAT
C
C     This gives us enough information to bootstrap the remaining angles
C     using the sine rule for spherical triangles. The AZION calculation
C     can yield a sine with an absolute value greater than 1 due to
C     finite precision calculations and so needs to be protected. This
C     is not necessary for DLONG.
C
      SAZION = SIN (AZ) * COS (LAT) / COS (LATION)
      IF (SAZION .GE. 1.0) THEN
         AZION = +PI / 2.0
      ELSE IF (SAZION .LE. -1.0) THEN
         AZION = -PI / 2.0
      ELSE
         AZION = ASIN (SAZION)
         END IF
      DLONG = ASIN (SIN (AZ) * SIN (THETA) / COS (LATION))
C
C     AZION is in the range -PI/2 .. +PI/2 from the ASIN
C     want it to be near source AZ
C
      IF ((ABS(AZ).GT.PI/2.0) .AND. (ABS(AZ).LT.1.5*PI)) THEN
         AZION = PI - AZION
         END IF
C
      END

      SUBROUTINE CITEXP (S, IMAX, I, ZVALUE, IERR)
C-----------------------------------------------------------------------
C! KEYIN routine: evaluate an expression in a character string
C# Parsing
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Function to evaluate arithmetic expressions.
C   Inputs:
C      S(IMAX)   C     Expression in char.
C      IMAX      I     Max. number of characters
C      I         I     Pointer in S,  updated by CITEXP
C   Outputs:
C      ZVALUE    D     Result of expression evaluation.
C      IERR      I     = 0  : success
C                        11 : too many parentheses
C                        12 : expecting ')'
C                        13 : missing value after operator
C                        14 : divide by zero
C-----------------------------------------------------------------------
      CHARACTER S*(*), PLUS*1, MINUS*1, STAR*1, SLASH*1, BRA*1, KET*1,
     *   OP(10)*1
      INTEGER   SIGN(10), IERR, IMAX, I, LEVEL, IP
      DOUBLE PRECISION    ZVALUE, RESULT(10), TERM(10), FACTOR(10),
     *   XVALUE
      DATA      PLUS, MINUS, STAR, SLASH, BRA, KET
     *         / '+',  '-',   '*',  '/',  '(', ')'/
C-----------------------------------------------------------------------
      IERR = 0
      LEVEL = 1
C                                       Evaluate 'expression'
  100 RESULT(LEVEL) = 0.0
  110 SIGN(LEVEL) = +1
      IF (S(I:I).NE.PLUS) GO TO 120
          I = I + 1
  120 IF (S(I:I).NE.MINUS) GO TO 130
          I = I + 1
          SIGN(LEVEL) = -1
  130 CONTINUE
C                                       Evaluate 'term'
      TERM(LEVEL) = 1.0
      OP(LEVEL) = STAR
  200 CONTINUE
C                                       Evaluate 'factor'
C                                       Parenthesized expression  =
C                                        'expression' at next level
      IF (S(I:I).NE.BRA) GO TO 330
         I = I + 1
         LEVEL = LEVEL + 1
         IF (LEVEL.LE.10) GO TO 100
             IERR = 11
             GO TO 999
  310    FACTOR(LEVEL-1) = RESULT(LEVEL)
         LEVEL = LEVEL - 1
         IF (S(I:I).EQ.KET) GO TO 320
              IERR = 12
              GO TO 999
  320     I = I + 1
          GO TO 340
  330  IP = I
      CALL CITC2R (S, IMAX, I, XVALUE)
      FACTOR(LEVEL) = XVALUE
       IF (I.NE.IP) GO TO 340
          IERR = 13
          GO TO 999
 340  CONTINUE
C                                       End 'factor'
      IF (OP(LEVEL).EQ.STAR)
     *   TERM(LEVEL) = TERM(LEVEL) * FACTOR(LEVEL)
      IF (OP(LEVEL).EQ.SLASH .AND. FACTOR(LEVEL).EQ.0.0) THEN
         IERR = 14
         GO TO 999
         END IF
      IF (OP(LEVEL).EQ.SLASH .AND. FACTOR(LEVEL).NE.0.0)
     *   TERM(LEVEL) = TERM(LEVEL) / FACTOR(LEVEL)
      IF (S(I:I).NE.SLASH.AND.S(I:I).NE.STAR) GO TO 350
          OP(LEVEL) = S(I:I)
          I = I + 1
          GO TO 200
  350 CONTINUE
C                                       End 'term'
      RESULT(LEVEL) = RESULT(LEVEL)+SIGN(LEVEL)*TERM(LEVEL)
      IF (S(I:I).EQ.PLUS.OR.S(I:I).EQ.MINUS) GO TO 110
C                                       End 'expression'
      IF (LEVEL.GT.1) GO TO 310
      ZVALUE = RESULT(LEVEL)
C
 999  RETURN
      END

      SUBROUTINE FNDXY (RANDP, BUFR, IAD, TYPCOR, TYPEAX, FRQSCL, XY)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FNDXY extracts the desired X and Y values from the Vis record.
C   Inputs:  RANDP  R(*)     Random parameters
C            BUFR   R(*)     Visibility record
C            IAD    I        Address in BUFR for first desired corr.
C            TYPCOR I        Type of Correlation record
C            TYPEAX I(*)     Array of Axis types (valid values 1-12)
C            FRQSCL R        Frequency Scale
C   Outputs: XY     R(2)     X, Y values
C-----------------------------------------------------------------------
      REAL      RANDP(*), BUFR(*), XY(2), FRQSCL
      INTEGER   IAD, TYPCOR, TYPEAX(*)
C                                      Epsilon is 1/5 second (in days)
      REAL      EPSLN
      PARAMETER (EPSLN=2.0E-6)
      REAL      TR, TI, R2D, LASTT, T
      INTEGER   NV, I, J, LASTSC
      INCLUDE 'INCS:DUVH.INC'
      SAVE LASTT, LASTSC
      DATA R2D /57.29578/, LASTT/0.0/, LASTSC/0/
C-----------------------------------------------------------------------
C                                       Loop over axes
      DO 900 I = 1,2
         NV = 0
         TR = 0.0
         TI = 0.0
         XY(I) = 0.0
         J = TYPEAX(I)
         GO TO (10, 10, 30, 40, 50, 60, 70, 80, 10, 10, 50, 120) J
C                                       amplitudes and phases
 10     CONTINUE
C                                       calc amplitude based on
C                                       Correlator Type
            IF (TYPCOR.LE.4) THEN
               TR = BUFR(IAD)
               TI = BUFR(IAD+1)
               END IF
            IF (TYPCOR.EQ.5) THEN
               IF (BUFR(IAD+2).GT.0.0) THEN
                  TR = BUFR(IAD)
                  TI = BUFR(IAD+1)
                  NV = NV + 1
                  END IF
               IF (BUFR(IAD+2+INCS).GT.0.0) THEN
                  TR = TR + BUFR(IAD+INCS)
                  TI = TI + BUFR(IAD+1+INCS)
                  NV = NV + 1
                  END IF
               TR = TR / NV
               TI = TI / NV
               END IF
            IF (TYPCOR.EQ.6) THEN
               TR = (BUFR(IAD) - BUFR(IAD+INCS)) / 2.0
               TI = (BUFR(IAD+1) - BUFR(IAD+INCS+1)) / 2.0
               END IF
            IF (TYPCOR.EQ.7) THEN
               TR = (BUFR(IAD) + BUFR(IAD+INCS)) / 2.0
               TI = (BUFR(IAD+1) + BUFR(IAD+INCS+1)) / 2.0
               END IF
            IF (TYPCOR.EQ.8) THEN
               TR = (BUFR(IAD+1) - BUFR(IAD+INCS+1)) / 2.0
               TI = (BUFR(IAD+INCS) - BUFR(IAD)) / 2.0
               END IF
            IF (TYPCOR.EQ.9) THEN
               TR = BUFR(IAD) + BUFR(IAD+3*INCS)
               TI = BUFR(IAD+1) + BUFR(IAD+1+3*INCS)
               END IF
            IF (TYPCOR.EQ.10) THEN
               TR = BUFR(IAD) - BUFR(IAD+3*INCS)
               TI = BUFR(IAD+1) - BUFR(IAD+1+3*INCS)
               END IF
            IF (TYPCOR.EQ.11) THEN
               TR = BUFR(IAD) - BUFR(IAD+1+INCS)
               TI = BUFR(IAD+1) + BUFR(IAD+INCS)
               END IF
            IF (TYPCOR.GE.12) THEN
               TR = BUFR(IAD) + BUFR(IAD+1+INCS)
               TI = BUFR(IAD+1) - BUFR(IAD+INCS)
               END IF
C                                       amplitude
            IF (J.LE.1) XY(I) = SQRT (TR*TR + TI*TI)
C                                       phase
            IF (J.EQ.2) THEN
               IF ((TI.NE.0.0) .OR. (TR.NE.0.0)) XY(I) = R2D *
     *           ATAN2 (TI, TR)
               END IF
C                                       Real , Imag parts
            IF (J.EQ.9)  XY(I) = TR
            IF (J.EQ.10) XY(I) = TI
            GO TO 900
C                                       U, V distance
 30     CONTINUE
            XY(I) = SQRT (RANDP(1+ILOCU)**2 + RANDP(1+ILOCV)**2)
            XY(I) = XY(I) * FRQSCL
            GO TO 900
C                                       U, V position angle
 40     CONTINUE
            TR = RANDP(1+ILOCU)
            TI = RANDP(1+ILOCV)
            IF ((TI.NE.0.0) .OR. (TR.NE.0.0)) XY(I) = R2D *
     *         ATAN2 (TI, TR)
            GO TO 900
C                                       Time
 50     CONTINUE
            XY(I) = RANDP(1+ILOCT)
            GO TO 900
C                                       U projected spacing
 60     CONTINUE
            XY(I) = RANDP(1+ILOCU) * FRQSCL
            GO TO 900
C                                       V projected spacing
 70     CONTINUE
            XY(I) = RANDP(1+ILOCV) * FRQSCL
            GO TO 900
C                                       W projected spacing
 80     CONTINUE
            XY(I) = RANDP(1+ILOCW) * FRQSCL
            GO TO 900
C                                       Scan Number
 120    CONTINUE
C                                       Get current time
            T = RANDP(1+ILOCT)
C                                       If Time is not last time
            IF (T-LASTT .GT. EPSLN) THEN
C                                       increment integration number
               LASTSC = LASTSC + 1
C                                       save last time
               LASTT  = T
               END IF
C                                       If Time is before last time
            IF (LASTT-T .GT. EPSLN) THEN
C                                       reset integration number
               LASTSC = 1
C                                       save last time
               LASTT  = T
               END IF
C                                       return last integration number
            XY(I) = LASTSC
 
 900     CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'CHKFC.INC'
      INCLUDE 'INCS:PCLN.INC'
      HOLLERITH XNAMEO(3), XBXFIL(12)
      REAL      XDISKO, XSEQO, XCOORD(6), CELSIZ(2), XSIZE(2),
     *   XFIELD, XRASH(MAXAFL), XDECSH(MAXAFL), XBOXES, XCLBOX(4,50),
     *   DOBLNK, DONUMB
      COMMON /INPARM/ XNAMEO, XSEQO, XDISKO, XBXFIL, XCOORD, CELSIZ,
     *   XSIZE, XFIELD, XRASH, XDECSH, XBOXES, XCLBOX, DOBLNK, DONUMB
C
      DOUBLE PRECISION RA0, DEC0
      INTEGER   IMSIZE(2), SEQOU, DISKOU, SCRTCH(256)
      LOGICAL   RQUICK
      CHARACTER BOXFIL*48, NAMEOU*12, CLASOU*6
      COMMON /SETFCP/ RA0, DEC0, IMSIZE, SEQOU, DISKOU, RQUICK
      COMMON /SETFCC/ BOXFIL, NAMEOU, CLASOU
LOCAL END
      PROGRAM CHKFC
C-----------------------------------------------------------------------
C! read a BOXFILE to make images of the Clean boxes
C# Imaging
C-----------------------------------------------------------------------
C;  Copyright (C) 2001, 2005, 2009, 2012, 2020
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CHKFC makes images from an input BOXFILE of Clean boxes
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME       XNAMEI/NAMEIN    Name of input UV data.
C      INSEQ        SEQ/SEQIN        Seq. of input UV data.
C      INDISK       DISKIN/IDISK     Disk number of input UV data.
C      BOXFILE      XBXFIL/BOXFIL    BOXFILE output file name.
C      CELLSIZE     CELSIZ           pixel size in image.
C      IMSIZE       XSIZE/IMSIZE     image size, also field size.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PCLN.INC'
      INCLUDE 'CHKFC.INC'
      INTEGER   IRET, NFIELD, NBOXES(MAXFLD), WIN(4,MXNBFL),
     *   FLDSIZ(2,MAXFLD)
      DOUBLE PRECISION RAF(MAXFLD), DECF(MAXFLD)
C-----------------------------------------------------------------------
C                                       init and read BOXFILE
      CALL CHKFIN (NFIELD, NBOXES, WIN, FLDSIZ, RAF, DECF, IRET)
C                                       make images
      IF (IRET.EQ.0) CALL CHKFDO (NFIELD, NBOXES, WIN, FLDSIZ, RAF,
     *   DECF, IRET)
C
      CALL DIETSK (IRET, RQUICK, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE CHKFIN (NFIELD, NBOXES, WIN, FLDSIZ, RAF, DECF, IRET)
C-----------------------------------------------------------------------
C   Input routine - reads BOXFILE returning parameters
C   Output:
C      NFIELD   I        Max field number
C      NBOXES   I(*)     Max box number in field
C      WIN      I(4,*)   Box pixel numbers
C      FLDSIZ   I(2,*)   Field sizes
C      RAF      D(*)     Center RA of field
C      DECF     D(*)     Center DEC of field
C-----------------------------------------------------------------------
      INTEGER   NFIELD, NBOXES(*), WIN(4,*), FLDSIZ(2,*), IRET
      DOUBLE PRECISION RAF(*), DECF(*)
C
      INTEGER   NPARMS, IERR, IROUND, I
      CHARACTER PNAM*6
      INCLUDE 'CHKFC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA PNAM /'CHKFC'/
C-----------------------------------------------------------------------
C                                       initialize
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Initialize HITAB
      CALL HIINIT (3)
C                                       get the input parameters
      NPARMS = 231 + 2 * MAXAFL
      CALL GTPARM (PNAM, NPARMS, RQUICK, XNAMEO, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         RQUICK = .FALSE.
         IF (IERR.EQ.1) THEN
            MSGTXT = 'CANNOT FIND INITIATOR IN GTPARM'
            CALL MSGWRT (1)
            GO TO 999
         ELSE
            MSGTXT= 'DISK PROBLEMS IN GTPARM'
            CALL MSGWRT (6)
            GO TO 999
            END IF
         END IF
      IRET = 0
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
C                                       set parameters
      IMSIZE(1) = IROUND (XSIZE(1))
      IMSIZE(2) = IROUND (XSIZE(2))
      CALL H2CHR (48, 1, XBXFIL, BOXFIL)
      CALL H2CHR (12, 1, XNAMEO, NAMEOU)
      SEQOU = XSEQO + 0.5
      DISKOU = XDISKO + 0.5
      IF ((CELSIZ(1).LE.0.0) .OR. (CELSIZ(2).LE.0.0)) THEN
         MSGTXT = 'MUST SET CELLSIZE'
         CALL MSGWRT (8)
         IRET = 8
         GO TO 999
         END IF
C                                       center coord
      I = 1
      IF ((XCOORD(1).LT.0.0) .OR. (XCOORD(2).LT.0.0) .OR.
     *   (XCOORD(3).LT.0.0)) I = -1
      RA0 = ABS(XCOORD(1))*15.0D0 + ABS(XCOORD(2))/4.0D0 +
     *   ABS(XCOORD(3))/240.0D0
      RA0 = I * RA0
      I = 1
      IF ((XCOORD(4).LT.0.0) .OR. (XCOORD(5).LT.0.0) .OR.
     *   (XCOORD(6).LT.0.0)) I = -1
      DEC0 = ABS(XCOORD(4)) + ABS(XCOORD(5))/60.0D0 +
     *   ABS(XCOORD(6))/3.6D3
      DEC0 = DEC0 * I
C                                       more adverbs
      NFIELD = XFIELD + 0.5
      DO 10 I = 1,NFIELD
         RAF(I) = RA0 + XRASH(I) / COS(DG2RAD*DEC0) / 3.6D3
         DECF(I) = DEC0 + XDECSH(I) / 3.6D3
 10      CONTINUE
C                                       read boxfile for nboxes, coords
      CALL FIELDF (BOXFIL, RA0, DEC0, NFIELD, FLDSIZ, RAF, DECF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       read boxfile for Clean windows
      CALL CWINDF (NFIELD, IMSIZE, BOXFIL, FLDSIZ, XBOXES, XCLBOX, WIN,
     *   NBOXES, IRET)
C
 999  RETURN
      END
      SUBROUTINE CHKFDO (NFIELD, NBOXES, WIN, FLDSIZ, RAF, DECF, IRET)
C-----------------------------------------------------------------------
C   Makes images
C   Input:
C      NFIELD   I        Max field number
C      NBOXES   I(*)     Max box number in field
C      WIN      I(4,*)   Box pixel numbers
C      FLDSIZ   I(2,*)   Field sizes
C      RAF      D(*)     Center RA of field
C      DECF     D(*)     Center DEC of field
C   Output:
C      IRET     I        Error code
C-----------------------------------------------------------------------
      INTEGER   NFIELD, NBOXES(*), WIN(4,NFIELD,*), FLDSIZ(2,*), IRET
      DOUBLE PRECISION RAF(*), DECF(*)
C
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   NX, NY, IY, IFIELD, I, SLOT, LUN, FIND, IWIN(4), NBY,
     *   IBLKOF, POS, J, JO, HLUN, HBUF(256), DATE(3), TIME(3), NC, IXC,
     *   IYC, LF
      CHARACTER OBJ*8, OBS*8, MTYPE*2, CDATE*12, CTIME*8, HILINE*72,
     *   BUN*8, TEL*8, FLDC*4
      REAL      BUFF(MABFSS), X, S, EDGE
      INCLUDE 'CHKFC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA OBJ, OBS, BUN, TEL /'TESTFACE','CHKFC','JY/BEAM','AIPS'/
      DATA LUN, IBLKOF, HLUN /16, 1, 17/
C-----------------------------------------------------------------------
      EDGE = 2.0
      IF (DONUMB.LT.-1.0) EDGE = 1.0
C                                       General header parms
      CALL CATINI (CATBLK)
      CALL CHR2H (8, OBJ, 1, CATH(KHOBJ))
      CALL CHR2H (8, OBS, 1, CATH(KHOBS))
      CALL CHR2H (8, BUN, 1, CATH(KHBUN))
      CALL CHR2H (8, TEL, 1, CATH(KHTEL))
      CALL CHR2H (8, 'RA---SIN', 1, CATH(KHCTP))
      CALL CHR2H (8, 'DEC--SIN', 1, CATH(KHCTP+2))
      CATR(KRCIC) = -CELSIZ(1) / 3600.0
      CATR(KRCIC+1) = CELSIZ(2) / 3600.0
      CATBLK(KIDIM) = 2
      CATR(KREPO) = 2000.0
      IF (NAMEOU.EQ.' ') NAMEOU = 'CHKFC images'
      CALL CHR2H (12, NAMEOU, KHIMNO, CATH(KHIMN))
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
      NBY = 2 * MABFSS
      CATR(KRDMN) = 0.0
      CATR(KRDMX) = 2.0
      IF (DONUMB.GT.0.0) CATR(KRDMX) = 3.0
      IF (DONUMB.LT.-1.0) CATR(KRDMX) = 1.0
      S = FBLANK
      IF (DOBLNK.LE.0.0) S = 0.0
      CATR(KRBLK) = S
      LF = 0
      IF (DONUMB.GT.0) LF = 1
      IF (DONUMB.GT.1.5) THEN
         I = (MAX (IMSIZE(1), FLDSIZ(1,1)) * 2) - 1
         CALL POWER2 (I, NX)
         I = (MAX (IMSIZE(2), FLDSIZ(2,1)) * 2) - 1
         CALL POWER2 (I, NY)
         I = MIN (NX/21, NY/9)
         LF = MAX (1, MIN (12, I/2))
         END IF
C                                       loop over fields (images)
      DO 100 IFIELD = 1,NFIELD
         WRITE (FLDC,1005) IFIELD
         CALL CHTRIM (FLDC, 4, FLDC, NC)
         I = (MAX (IMSIZE(1), FLDSIZ(1,IFIELD)) * 2) - 1
         CALL POWER2 (I, NX)
         CATBLK(KINAX) = NX
         I = (MAX (IMSIZE(2), FLDSIZ(2,IFIELD)) * 2) - 1
         CALL POWER2 (I, NY)
         CATBLK(KINAX+1) = NY
         CATD(KDCRV) = RAF(IFIELD)
         CATD(KDCRV+1) = DECF(IFIELD)
         CATR(KRCRP) = NX / 2
         CATR(KRCRP+1) = NY / 2 + 1
         WRITE (CLASOU,1010) IFIELD
         CALL CHR2H (6, CLASOU, KHIMCO, CATH(KHIMC))
         CATBLK(KIIMS) = SEQOU
C                                       Create new cataloged file.
         CALL MCREAT (DISKOU, SLOT, SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREAT', IFIELD
            GO TO 990
            END IF
         SEQOU = CATBLK(KIIMS)
C                                       Open new file.
         MTYPE = 'MA'
         CALL MAPOPN ('INIT', DISKOU, NAMEOU, CLASOU, SEQOU, MTYPE,
     *      NLUSER, LUN, FIND, SLOT, CATBLK, SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN', IFIELD
            GO TO 990
            END IF
C                                       Window for output file
         IWIN(1) = 1
         IWIN(2) = 1
         IWIN(3) = NX
         IWIN(4) = NY
         CALL MINIT ('WRIT', LUN, FIND, NX, NY, IWIN, BUFF, NBY,
     *      IBLKOF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INITIALIZ', IFIELD
            GO TO 990
            END IF
         DO 50 IY = 1,NY
C                                       "write" before data
            CALL MDISK ('WRIT', LUN, FIND, BUFF, POS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRIT', IFIELD
               GO TO 980
               END IF
            CALL RFILL (NX, S, BUFF(POS))
            DO 30 I = 1,NBOXES(IFIELD)
C                                       rectangles
               IF (WIN(1,IFIELD,I).GT.0) THEN
                  IF ((IY.GE.WIN(2,IFIELD,I)) .AND.
     *               (IY.LE.WIN(4,IFIELD,I))) THEN
                     JO = WIN(1,IFIELD,I)
                     J = WIN(3,IFIELD,I) - JO + 1
                     IYC = (WIN(2,IFIELD,I) + WIN(4,IFIELD,I)) / 2
                     IXC = (WIN(1,IFIELD,I) + WIN(3,IFIELD,I)) / 2
                  ELSE
                     J = 0
                     END IF
C                                       circles
               ELSE
                  J = ABS(IY-WIN(4,IFIELD,I))
                  IF (J.LE.WIN(2,IFIELD,I)) THEN
                     X = SQRT (REAL(WIN(2,IFIELD,I))**2 - J*J)
                     IXC = WIN(3,IFIELD,I)
                     IYC = WIN(4,IFIELD,I)
                     J = IXC + X
                     JO = 2 * IXC - J
                     J = J - JO + 1
                  ELSE
                     J = 0
                     END IF
                  END IF
               IF (J.GT.0) THEN
                  JO = JO  + POS - 1
                  CALL RFILL (J, 1.0, BUFF(JO))
                  BUFF(JO) = EDGE
                  BUFF(JO+J-1) = EDGE
                  IF ((WIN(1,IFIELD,I).GT.0) .AND.
     *               ((IY.EQ.WIN(2,IFIELD,I)) .OR.
     *               (IY.EQ.WIN(4,IFIELD,I))))
     *               CALL RFILL (J, EDGE, BUFF(JO))
                  IF (DONUMB.GT.0.0) THEN
                     IF ((ABS(IY-IYC)/LF.LE.3) .AND. (J.GE.7*NC*LF)
     *                  .AND. (JO-POS+1.LE.IXC-(7*NC*LF)/2)) THEN
                        JO = IXC - (7*NC*LF)/2 + POS - 1
                        J = (IY - IYC + 4*LF + 1) / LF
                        CALL CHKCHR (FLDC, NC, LF, J, BUFF(JO))
                     ELSE IF ((ABS(IY-IYC).LE.3) .AND. (J.GE.7*NC)
     *                  .AND. (JO-POS+1.LE.IXC-(7*NC)/2)) THEN
                        JO = IXC - (7*NC)/2 + POS - 1
                        J = (IY - IYC + 4 + 1)
                        CALL CHKCHR (FLDC, NC, 1, J, BUFF(JO))
                        END IF
                     END IF
                  END IF
 30            CONTINUE
 50         CONTINUE
C                                       write last of data
         CALL MDISK ('FINI', LUN, FIND, BUFF, POS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'FINISH', IFIELD
            GO TO 980
            END IF
C                                       Fake up history
         CALL HICREA (HLUN, DISKOU, SLOT, CATBLK, HBUF, IRET)
C                                       Write time and date on new file
         IF (IRET.EQ.0) THEN
            CALL ZDATE (DATE)
            CALL ZTIME (TIME)
            CALL TIMDAT (TIME, DATE, CTIME, CDATE)
            WRITE (HILINE,1050) TSKNAM, RLSNAM, CDATE, CTIME
            CALL HIADD (HLUN, HILINE, HBUF, IRET)
            END IF
         IF (IRET.EQ.0) CALL HENCOO (TSKNAM, NAMEOU, CLASOU, SEQOU,
     *      DISKOU, HLUN, HBUF, IRET)
         IF (IRET.EQ.0) THEN
            WRITE (HILINE,1055) TSKNAM, IFIELD, BOXFIL(:47)
            CALL HIADD (HLUN, HILINE, HBUF, IRET)
            END IF
         CALL HICLOS (HLUN, .TRUE., HBUF, IRET)
         IRET = 0
C                                       Close image
         CALL MAPCLS ('INIT', DISKOU, SLOT, LUN, FIND, CATBLK, .TRUE.,
     *      BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOS', IFIELD
            GO TO 990
            END IF
 100     CONTINUE
      GO TO 999
C
 980  CALL ZCLOSE (LUN, FIND, I)
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I6,1X,A,'ING IMAGE',I4)
 1005 FORMAT (I4)
 1010 FORMAT ('IIM',I3.3)
 1050 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',A12,2X,A8)
 1055 FORMAT (A6,'FIELD=',I4,' BOXFILE=',A)
      END
      SUBROUTINE FIELDF (BOXFIL, RA0, DEC0, NFIELD, FLDSIZ, RAF, DECF,
     *   IERR)
C-----------------------------------------------------------------------
C   Fills field parameters from the user test file C lines
C   Inputs:
C      BOXFIL   C*48     User provided file name containing box defs
C      RA0      D        Center RA
C      DEC0     D        Center Dec - used with F cards
C   Output:
C      NFIELD   I        Number of fields defined for field parms
C      FLDSIZ   I(2,*)   Field size parameter
C      RAF      D(*)     RA of fields
C      DEC      D(*)     Dec of fields
C      IERR     I        Error return code: 0 => no error
C-----------------------------------------------------------------------
      CHARACTER BOXFIL*48
      INTEGER   NFIELD, FLDSIZ(2,*), IERR
      DOUBLE PRECISION RA0, DEC0, RAF(*), DECF(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   LUN, I, J, FIND, KBP, I1, I2, JT, JTRIM
      CHARACTER LINE*132, SIGN*1
      DOUBLE PRECISION X, XRA, XDEC
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                        Open clean box file
      IF (BOXFIL.NE.' ') THEN
         LUN = 11
         CALL ZTXOPN ('READ', LUN, FIND, BOXFIL, .FALSE., IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPEN'
            CALL MSGWRT (6)
            GO TO 999
            END IF
C                                        Enter parameters from file
         I2 = 0
         DO 50 I = 1,50000
            CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
            IF (IERR.EQ.2) GO TO 60
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN'
               CALL MSGWRT (6)
               GO TO 999
               END IF
            JT = JTRIM (LINE)
C                                       parse for field:
C                                       #, fldsiz, rash, decsh
            IF ((LINE(:1).EQ.'F') .OR. (LINE(:1).EQ.'f')) THEN
               KBP = 2
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 50
               IF (X.GE.0.0D0) THEN
                  I1 = X + 0.50D0
               ELSE
                  I1 = X - 0.50D0
                  END IF
               IF ((I1.GE.1) .AND. (I1.LE.MAXFLD)) THEN
                  NFIELD = MAX (NFIELD, I1)
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  FLDSIZ(1,I1) = X + 0.50D0
                  IF (X.LT.0.0D0) FLDSIZ(1,I1) = -1
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  FLDSIZ(2,I1) = X + 0.50D0
                  IF (X.LT.0.0D0) FLDSIZ(2,I1) = -1
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  RAF(I1) = RA0 + X / COS(DG2RAD*DEC0) / 3.6D3
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  DECF(I1) = DEC0 + X / 3.6D3
                  I2 = I2 + 1
                  END IF
C                                       parse for ra/dec field
C                                       # fldsiz ra (HH MM SS) Dec (+-
C                                       DD MM SS)
            ELSE IF ((LINE(:1).EQ.'C') .OR. (LINE(:1).EQ.'c')) THEN
               KBP = 2
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 50
               IF (X.GE.0.0D0) THEN
                  I1 = X + 0.50D0
               ELSE
                  I1 = X - 0.50D0
                  END IF
               IF ((I1.GE.1) .AND. (I1.LE.MAXFLD)) THEN
                  NFIELD = MAX (NFIELD, I1)
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  FLDSIZ(1,I1) = X + 0.50D0
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  FLDSIZ(2,I1) = X + 0.50D0
C                                       RA
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  XRA = X
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  XRA = XRA + X/60.0D0
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  XRA = XRA + X/3600.0D0
                  XRA = XRA * 15.0D0
C                                       Sign
                  J = KBP
 40               IF (J.GT.132) GO TO 990
                  IF (LINE(J:J).EQ.' ') THEN
                     J = J + 1
                     GO TO 40
                     END IF
                  SIGN = LINE(J:J)
C                                       DEC
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  XDEC = ABS(X)
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  XDEC = XDEC + X/60.0D0
                  CALL GETNUM (LINE, 132, KBP, X)
                  IF (X.EQ.DBLANK) GO TO 990
                  XDEC = XDEC + X/3600.0D0
                  IF (SIGN.EQ.'-') XDEC = -XDEC
                  RAF(I1) = XRA
                  DECF(I1) = XDEC
                  I2 = I2 + 1
                  END IF
               END IF
 50         CONTINUE
 60      CALL ZTXCLS (LUN, FIND, I)
         END IF
      IERR = 0
C
      IF (I2.GT.0) THEN
         MSGTXT = 'FIELDF: Final field parameters and # read are:'
         CALL MSGWRT (2)
         DO 80 J = 1,NFIELD
            WRITE (MSGTXT,1070) 'Field', J, FLDSIZ(1,J), FLDSIZ(2,J),
     *         RAF(J), DECF(J)
            CALL MSGWRT (2)
 80         CONTINUE
         END IF
      GO TO 999
C
 990  WRITE (MSGTXT,1990) I
      CALL MSGWRT (6)
      IERR = 1

 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FIELDF: ERROR',I4,1X,A,'ING BOXFILE')
 1070 FORMAT (A5,I3,2I5,2F11.5)
 1990 FORMAT ('FIELDF: PARSING ERROR ON LINE',I4)
      END
      SUBROUTINE CWINDF (NFIELD, IMSIZE, BOXFIL, FLDSIZ, XBOXES, XCLBOX,
     *   WIN, NBOXES, IERR)
C-----------------------------------------------------------------------
C   Fills the WIN array with clean box definitions taken from BOXFIL
C   Inputs:
C      BOXFIL   C*48        User provided file name containing box defs
C      NFIELD   I           Number of fields defined
C   Outputs:
C      WIN      I(4,*,*)    clean boxes - defaulted on in (4,FIELD,BOX)
C      NBOXES   I*(*)       Array containing number of boxes/field
C      IERR     I           Error return code:
C                              0 => no error
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCLN.INC'
      CHARACTER BOXFIL*48
      INTEGER   NFIELD, FLDSIZ(2,*), WIN(4,NFIELD,*), NBOXES(*)
      INTEGER   IMSIZE(2), IERR
      REAL      XBOXES, XCLBOX(4,50)
C
      INTEGER   LUN, I, J, ISUBF(MXNBOX), IFIELD, FIND, IPARM(5), KBP,
     *   I1, I2, IDD, LIMIT, NX, NY, II, IROUND, JT, JTRIM
      CHARACTER LINE*132
      DOUBLE PRECISION X
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      LIMIT = MIN (MXNBOX, MXNBFL / MAX(1,NFIELD))
C                                        Open clean box file
      IF (BOXFIL.NE.' ') THEN
         LUN = 11
         CALL ZTXOPN ('READ', LUN, FIND, BOXFIL, .FALSE., IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPEN'
            CALL MSGWRT (6)
            GO TO 999
            END IF
C                                        Enter box parameters from file
         CALL FILL (MXNBOX, 0, ISUBF)
         IDD = 0
         DO 50 I = 1,100000
            CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
            IF (IERR.EQ.2) GO TO 60
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN'
               CALL MSGWRT (6)
               GO TO 999
               END IF
            JT = JTRIM (LINE)
C                                       check for comments
            IF (LINE.EQ.' ') GO TO 50
            IF (LINE(:1).NE.' ') THEN
               IF (LINE(:1).LT.'0') GO TO 50
               IF (LINE(:1).GT.'9') GO TO 50
               END IF
C                                       parse for 5 integers
C                                       field, blc, trc
            KBP = 1
            CALL FILL (5, 0, IPARM)
            DO 30 J = 1,5
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) THEN
                  IF (J.EQ.1) GO TO 50
                  WRITE (MSGTXT,1020) I, J
                  CALL MSGWRT (6)
                  IERR = 1
                  GO TO 999
               ELSE
                  IF (X.GE.0.0D0) THEN
                     IPARM(J) = X + 0.50D0
                  ELSE
                     IPARM(J) = X - 0.50D0
                     END IF
                  END IF
 30            CONTINUE
            IFIELD = IPARM(1)
            IF ((IFIELD.GE.1) .AND. (IFIELD.LE.NFIELD)) THEN
               IDD = IDD + 1
               ISUBF(IFIELD) = ISUBF(IFIELD) + 1
               II = (MAX (IMSIZE(1), FLDSIZ(1,IFIELD)) * 2) - 1
               CALL POWER2 (II, NX)
               II = (MAX (IMSIZE(2), FLDSIZ(2,IFIELD)) * 2) - 1
               CALL POWER2 (II, NY)
               IF (ISUBF(IFIELD).LE.LIMIT) THEN
                  J = ISUBF(IFIELD)
C                                       circular
                  IF (IPARM(2).LT.0) THEN
                     WIN(1,IFIELD,J) = -1
                     WIN(3,IFIELD,J) = MAX (1+IPARM(3), MIN (IPARM(4),
     *                  NX-IPARM(3)))
                     WIN(4,IFIELD,J) = MAX (1+IPARM(3), MIN (IPARM(5),
     *                  NY-IPARM(3)))
                     WIN(2,IFIELD,J) = IPARM(3)
C                                       rectangular
                  ELSE
                     WIN(1,IFIELD,J) = MAX (1, MIN (IPARM(2), NX))
                     WIN(3,IFIELD,J) = MAX (1, MIN (IPARM(4), NX))
                     IF (WIN(3,IFIELD,J).LT.WIN(1,IFIELD,J)) THEN
                        I1 = WIN(3,IFIELD,J)
                        WIN(3,IFIELD,J) = WIN(1,IFIELD,J)
                        WIN(1,IFIELD,J) = I1
                        END IF
                     WIN(2,IFIELD,J) = MAX (1, MIN (IPARM(3), NY))
                     WIN(4,IFIELD,J) = MAX (1, MIN (IPARM(5), NY))
                     IF (WIN(4,IFIELD,J).LT.WIN(2,IFIELD,J)) THEN
                        I1 = WIN(4,IFIELD,J)
                        WIN(4,IFIELD,J) = WIN(2,IFIELD,J)
                        WIN(2,IFIELD,J) = I1
                        END IF
                     END IF
                  END IF
               END IF
 50         CONTINUE
 60      CALL ZTXCLS (LUN, FIND, I)
         END IF
C                                       defaults
      DO 70 I = 1,NFIELD
         IF ((I.EQ.1) .AND. (ISUBF(I).LE.0)) THEN
            I1 = XBOXES + 0.5
            DO 65 J = 1,I1
               WIN(1,1,J) = IROUND (XCLBOX(1,J))
               WIN(2,1,J) = IROUND (XCLBOX(2,J))
               WIN(3,1,J) = IROUND (XCLBOX(3,J))
               WIN(4,1,J) = IROUND (XCLBOX(4,J))
 65            CONTINUE
            ISUBF(1) = I1
            END IF
         IF (ISUBF(I).LE.0) THEN
            II = (MAX (IMSIZE(1), FLDSIZ(1,I)) * 2) - 1
            CALL POWER2 (II, NX)
            II = (MAX (IMSIZE(2), FLDSIZ(2,I)) * 2) - 1
            CALL POWER2 (II, NY)
            ISUBF(I) = 1
            WIN(1,I,1) = (NX - FLDSIZ(1,I)) / 2 + 1
            WIN(2,I,1) = (NY+1 - FLDSIZ(2,I)) / 2 + 1
            WIN(3,I,1) = WIN(1,I,1) + FLDSIZ(1,I) - 1
            WIN(4,I,1) = WIN(2,I,1) + FLDSIZ(2,I) - 1
            END IF
         IF (ISUBF(I).GT.0) NBOXES(I) = MIN (LIMIT, ISUBF(I))
         IF (ISUBF(I).GT.LIMIT) THEN
            WRITE (MSGTXT,1060) I, LIMIT, ISUBF(I)
            CALL MSGWRT (6)
            END IF
 70      CONTINUE
      IERR = 0
C
      IF (IDD.GT.0) THEN
         MSGTXT = 'WINDF: Number of clean boxes/field read as follows:'
         CALL MSGWRT(7)
         DO 80 J = 1,NFIELD,4
            I1 = J
            I2 = MIN (NFIELD, I1+3)
            WRITE (MSGTXT,1070) ('Field', I, NBOXES(I), I = I1,I2)
            CALL MSGWRT (3)
 80         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('WINDF: ERROR',I4,1X,A,'ING THE CLEAN BOXES TEXT FILE')
 1020 FORMAT ('WINDF: PARSING ERROR ON LINE',I4,' FIELD',I2)
 1060 FORMAT ('WARNING: FIELD',I4,' USED FIRST',I5,' OF',I6,
     *   ' BOXES IN FILE')
 1070 FORMAT (4(A5,I3.2,':',I4,2X))
      END
      SUBROUTINE CHKCHR (STR, NC, LF, IY, BUFF)
C-----------------------------------------------------------------------
C   CHKCHR inserts characters into the data buffer 1 pixel row at a
C   time
C   Inputs:
C      STR    C*(*)   Character string
C      NC     I       Number of characters in STR
C      LF     I       Repetition factor
C      IY     I       Pixel number vertically within character string
C   Output:
C      BUFF   R(*)    Data buffer
C-----------------------------------------------------------------------
      CHARACTER STR*(*)
      INTEGER   NC, LF, IY
      REAL      BUFF(*)
C
      INTEGER   I, JT, LT, KT, BITS(15), SCRTCH(20), IDX, II, JJ,
     *   MASK, ZAND, TABLE(5,97), TAB2(5,17), TAB3(5,16), TAB4(5,16),
     *   TAB5(5,16), TAB6(5,16), TAB7(5,16), IT, IC, J
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE  (TABLE(1, 1), TAB2),  (TABLE(1,18), TAB3),
     *             (TABLE(1,34), TAB4),  (TABLE(1,50), TAB5),
     *             (TABLE(1,66), TAB6),  (TABLE(1,82), TAB7)
C                                        control chars all ?
C                                        blank !"#$%&'()*+,-./
      DATA TAB2/  32,  64,  69,  72,  48,
     *             0,   0,   0,   0,   0,
     *             0,   0, 121,   0,   0,
     *             0, 112,   0, 112,   0,
     *            20,  62,  20,  62,  20,
     *            18,  42, 127,  42,  36,
     *             2,  36,   8,  18,  32,
     *            54,  73,  85,  34,   5,
     *             0,   0, 112,   0,   0,
     *             0,  28,  34,  65,   0,
     *             0,  65,  34,  28,   0,
     *            20,   8,  62,   8,  20,
     *             8,   8,  62,   8,   8,
     *             0,   1,   6,   0,   0,
     *             0,   8,   8,   8,   0,
     *             0,   0,   1,   0,   0,
     *             2,   4,   8,  16,  32/
C                                        0123456789:;<=>?
      DATA TAB3/  62,  69,  73,  81,  62,
     *             0,  33, 127,   1,   0,
     *            35,  69,  73,  73,  49,
     *            66,  65,  73,  89, 102,
     *            12,  20,  36, 127,   4,
     *           114,  81,  81,  81,  78,
     *            30,  41,  73,  73,  70,
     *            64,  71,  72,  80,  96,
     *            54,  73,  73,  73,  54,
     *            49,  73,  73,  74,  60,
     *             0,   0,  18,   0,   0,
     *             0,   1,  22,   0,   0,
     *             8,  20,  34,  65,   0,
     *            20,  20,  20,  20,   0,
     *            65,  34,  20,   8,   0,
     *            32,  64,  69,  72,  48/
C
C                                       ABCDEFGHIJKLMNO
      DATA TAB4/  18,  37,  37,  37,  30,
     *            31,  36,  68,  36,  31,
     *           127,  73,  73,  73,  34,
     *            62,  65,  65,  65,  34,
     *            65, 127,  65,  65,  62,
     *           127,  73,  73,  73,  65,
     *           127,  72,  72,  64,  64,
     *            62,  65,  65,  69,  39,
     *           127,   8,   8,   8, 127,
     *             0,  65, 127,  65,   0,
     *             2,   1,   1,   1, 126,
     *           127,   8,  20,  34,  65,
     *           127,   1,   1,   1,   1,
     *           127,  32,  24,  32, 127,
     *           127,  16,   8,   4, 127,
     *            62,  65,  65,  65,  62/
C                                        PQRSTUVWXYZ[\]^_
      DATA TAB5/ 127,  72,  72,  72,  48,
     *            62,  65,  69,  66,  61,
     *           127,  72,  76,  74,  49,
     *            50,  73,  73,  73,  38,
     *            64,  64, 127,  64,  64,
     *           126,   1,   1,   1, 126,
     *           112,  12,   3,  12, 112,
     *           126,   1,  14,   1, 126,
     *            99,  20,   8,  20,  99,
     *            96,  16,  15,  16,  96,
     *            67,  69,  73,  81,  97,
     *             0,   0, 127,  65,   0,
     *            32,  16,   8,   4,   2,
     *             0,  65, 127,   0,   0,
     *            16,  32,  64,  32,  16,
     *             1,   1,   1,   1,   1/
C                                        `abcdefghijklmno
      DATA TAB6/   0,  64,  32,  16,  0,
     *            31,  36,  68,  36,  31,
     *           127,  73,  73,  73,  34,
     *            62,  65,  65,  65,  34,
     *            65, 127,  65,  65,  62,
     *           127,  73,  73,  73,  65,
     *           127,  72,  72,  64,  64,
     *            62,  65,  65,  69,  39,
     *           127,   8,   8,   8, 127,
     *            65,  65, 127,  65,  65,
     *             2,   1,   1,   1, 126,
     *           127,   8,  20,  34,  65,
     *           127,   1,   1,   1,   1,
     *           127,  32,  24,  32, 127,
     *           127,  16,   8,   4, 127,
     *            62,  65,  65,  65,  62/
C                                        pqrstuvwxyz{ }~?
      DATA TAB7/ 127,  72,  72,  72,  48,
     *            62,  65,  69,  66,  61,
     *           127,  72,  76,  74,  49,
     *            50,  73,  73,  73,  38,
     *            64,  64, 127,  64,  64,
     *           126,   1,   1,   1, 126,
     *           112,  12,   3,  12, 112,
     *           126,   1,  14,   1, 126,
     *            99,  20,   8,  20,  99,
     *            96,  16,  15,  16,  96,
     *            67,  69,  73,  81,  97,
     *             0,   8,  54,  65,   0,
     *             0,   0, 127,   0,   0,
     *             0,  65,  54,   8,   0,
     *             4,   8,   4,   2,   4,
     *            32,  64,  69,  72,  48/
C-----------------------------------------------------------------------
      IDX = 1
      DO 20 I = 1,NC
C                                       get standard ASCII char
C                                       in highly machine independent
         JT = NBITWD / 8
         CALL ZCLC8 (1, STR(I:I), JT, LT)
         CALL ZI32IL (1, 1, LT, KT)
         IT = NBITWD - (JT-1)*8
         CALL ZGTBIT (IT, KT, BITS)
         CALL ZPTBIT (8, IC, BITS(IT-7))
C                                       all CTRL characters to 1
         IC = MAX (1, IC-30)
         CALL COPY (5, TABLE(1,IC), SCRTCH(IDX))
         IDX = IDX + 5
 20      CONTINUE
C                                       just the selected row
      MASK = 2 ** (IY-1)
      JJ = 1
      IDX = 1
C                                        if mask bit on in char value
C                                        then set to -1 else to 0
      DO 40 J = 1,NC
         IDX = IDX + LF
         DO 35 II = 1,5
            IC = ZAND (MASK, SCRTCH(JJ))
            DO 30 I = 1,LF
               IF ((IC.NE.0) .AND. (BUFF(IDX).NE.FBLANK)) BUFF(IDX) =
     *            3.0 * BUFF(IDX)
               IDX = IDX + 1
 30            CONTINUE
            JJ = JJ + 1
 35         CONTINUE
         IDX = IDX + LF
 40      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE YSCROL (CHANNL, SCROLX, SCROLY, VRTRTC, IERR)
C-----------------------------------------------------------------------
C! write the scroll registers (shift location of 1 or more TV channels)
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YSCROL writes the scroll registers on the TV.
C   Inputs:
C      CHANNL   I   bit map channel select: bits 1-NGRAY gray channels,
C                   bit NGRAY+1 => all graphics
C      VRTRTC   L   T => do it on vertical retrace only
C   In/Out:
C      SCROLX   I   amount of X scroll (>0 to right)
C      SCROLY   I   amount of Y scroll (>0 upwards)
C   Output:
C      IERR     I   error from Z...XF : 0 => ok, 2 => input error
C   YSCROL updates the scroll variables in /TVDEV/ common
C   Modified Nov-83 for DeAnza by Jaffe, corrected EWG 12/85.
C-----------------------------------------------------------------------
      INTEGER   CHANNL, SCROLX, SCROLY, IERR
      LOGICAL   VRTRTC
C
      INCLUDE 'INCS:YDEA.INC'
      INTEGER   IX, BUFFER(2), BITS(16), I, J, ZREG(2), SHIFT, IMAG,
     *   JMAG, KOFF, SCMASK, ITEMP, IC, IXSCRL, IYSCRL, ZAND
      LOGICAL   UPDATE, WAIT
      INCLUDE 'INCS:DTVC.INC'
      DATA WAIT /.TRUE./
C     DATA SHIFT, SCMASK /Z0020, Z03FF/
      DATA SHIFT, SCMASK /32,    1023/
C-----------------------------------------------------------------------
      IXSCRL = MOD (SCROLX, MAXXTV(1))
      IYSCRL = MOD (SCROLY, MAXXTV(2))
      BUFFER(1) = - IXSCRL
      BUFFER(2) = - IYSCRL
      BUFFER(1) = (BUFFER(1) / SCXINC) * SCXINC
      BUFFER(2) = (BUFFER(2) / SCYINC) * SCYINC
C                                       scroll equiv of current zoom
      IMAG = 1 + TVZOOM(1)
      IF (MXZOOM.GT.0) IMAG = 2**TVZOOM(1)
C                                       Shift zoom factor to high byte
      JMAG = SHIFT * (IMAG - 1)
      DO 10 I = 1,2
         ZREG(I) = 0
         CALL ZPUTCH (JMAG, ZREG(I), 2)
 10      CONTINUE
C
      IX = REAL(TVZOOM(2)-1) * REAL(IMAG-1) /REAL(IMAG)
C                                       Add scroll &
C                                       clear high order bits
      ITEMP = BUFFER(1) + IX
      BUFFER(1) = ZAND (ITEMP, SCMASK)
      IX = (REAL (TVZOOM(3)-1) * REAL(IMAG-1) + REAL(MAXXTV(2) - 1))
     *   / REAL(IMAG)
C                                       Add scroll &
C                                       clear high order bits
      ITEMP = BUFFER(2) + IX
      BUFFER(2) = ZAND (ITEMP, SCMASK)
C                                       Loop over channels
      ITEMP = 2 ** NGRAY - 1
      IC = ZAND (CHANNL, ITEMP)
      CALL ZGTBIT (16, IC, BITS)
      IF (IC.NE.CHANNL) BITS(NGRAY+1) = 1
      IC = NGRAY + 1
      DO 20 I = 1,IC
         IF (BITS(I).NE.1) GO TO 20
            TVSCRX(I) = IXSCRL
            TVSCRY(I) = IYSCRL
            UPDATE = .FALSE.
            KOFF = 4 *(I-1)
C                                        Have I changed X or Y ?
            DO 15 J = 1,2
               ITEMP = BUFFER(J) + ZREG(J)
               CALL YTCOMP (YBUFF(XSCZ+KOFF+J-1), ITEMP, UPDATE)
 15            CONTINUE
C                                        If so write it into memory LUT
            ITEMP = I - 1
            IF (UPDATE) CALL ZDEAXF ('LMC ', YBUFF(XSCZ+KOFF), 8,
     *         ITEMP, 0, WAIT, IERR)
            IF (IERR.NE.0) GO TO 999
 20      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE IOSET
C-----------------------------------------------------------------------
C! initialize tables and set buffer space for WaWa IO
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   WaWa IO package: Establish buffer space and initialize tables
C   for "hidden" i/o operations with 5 simultaneous maps open
C   Written by WaWA (Last Rev  : 4/21/81)
C-----------------------------------------------------------------------
      CHARACTER COMAND(12)*4, WNAMS(8)*6, RD1(12)*4
      INTEGER   POINT(13), NCOM, NPOINT, I
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (RD1, WRIT)
      DATA NCOM, NPOINT /12, 13/
C                                       Standard character opcodes
      DATA COMAND /'WRIT', 'READ', 'CLWR', 'CLRD', 'REST', 'OPEN',
     *   'CLOS', 'SRCH', 'INFO', 'UPDT', 'FINI', 'CSTA'/
C                                       Defs of pointers to FILTAB
      DATA POINT /1, 2, 3, 4, 5, 6, 7, 8, 9, 16, 23, 30, 37/
C                                       Defs of subroutine names
      DATA WNAMS /'CATDIR', 'CATIO ', 'MINIT ', 'MDISK ',
     *            'ZCLOSE', 'ZCREAT', 'ZDESTR', 'ZOPEN '/
C-----------------------------------------------------------------------
C                                       How many map files?
      NFIL = 5
C                                       Initialize CDCH tables
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       How long is one hidden buffer?
      LREAL = MABFSS
C                                       Same number in integer form
      LINT  = LREAL
C                                       Clear all LUN slots
      EFIL = 5 + NFIL
      DO 10 I = 1,EFIL
         FILTAB(1,I) = 0
 10      CONTINUE
C                                       Transfer opcodes to common
      DO 15 I = 1,NCOM
         RD1(I) = COMAND(I)
 15      CONTINUE
      INDEF = FBLANK
C                                       Transfer subroutine names
      DO 20 I = 1,8
         SUBNAM(I) = WNAMS(I)
 20      CONTINUE
C                                       Transfer pointers to common
      CALL COPY (NPOINT, POINT, POLUN)
C                                       Initialize 'DIE' common.
      NCFILE = 0
      NSCR = 0
      CALL FILL (10, 0, IBAD)
C
 999  RETURN
      END

      SUBROUTINE OFMCON (DOWEDG, IG, NLEVS, DONEW, RPOS, N, OFM, BUFFER,
     *   IERR)
C-----------------------------------------------------------------------
C! interactive making of OFM as step/flat color contours
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2002, 2009, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   interactive creation/modification of color OFMs as step wedge or
C   flat intensity contours
C   Inputs:
C      DOWEDG   R        Number of wedges or contours:
C                           <= 0 => contours; -1,0,1 => use 8
C      IG       I        Graphics channel to use (1 - NGRAPH)
C      NLEVS    I        Number of OFM levels actually used
C      DONEW    R        > 0 => do a new OFM, <= 0 => use old
C      N        I        First dimension of OFM
C   In/out:
C      OFM      R(N,3)   Initial OFM in, Final OFM out
C   Output:
C      RPOS     R(2)     Final cursor position
C      BUFFER   I(*)     scratch buffer
C      IERR     I        error code suitable for POPS
C-----------------------------------------------------------------------
      INTEGER   IG, NLEVS, N, BUFFER(*), IERR
      REAL      DOWEDG, OFM(N,3), RPOS(2), DONEW
C
      INTEGER   QUAD, ITW(3), I, J, IBUT, LG, LMODE,
     *   NEDGE, MAG, IX0, IY0, IX1, IY1, POTERR, IX, IY, IXP(9), IYP(9),
     *   THEWED, NVAL, INCR, MODE, INWEDG, IYR, IYG, IYB, NXP, LXR,
     *   LXG, LXB, IXR, IXG, IXB, IYV, IXV, IXC, IYC, MXP
      REAL      PPOS(2), RBUF(2048), FR, FG, FB, PI, WEDLEV(100), D60,
     *   WEDR(100), WEDG(100), WEDB(100), XC, YC, ALPHA, RC, RR, THETA,
     *   XPOS(2)
      LOGICAL   T, F, DOIT, INVERS, DOPLOT, NOPLOT
      CHARACTER STRING*20, BARS*80
      INCLUDE 'INCS:DCNT.INC'
      INTEGER   BUF0(MAXIMG), BUF1(MAXIMG)
      EQUIVALENCE (BUF0, ILROW), (BUF1, IBLROW)
C
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA T, F /.TRUE., .FALSE./
C-----------------------------------------------------------------------
C                                        Common TV parms
      BARS = '----------------------------------------------------'
      LXR = 0
      LXG = 0
      LXB = 0
      QUAD = -1
      INWEDG = ABS (DOWEDG) + 0.1
      IF (INWEDG.LT.2) INWEDG = 8
      IF (INWEDG.GT.99) INWEDG = 99
      POTERR = 49
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      CALL ZTIME (ITW)
      CALL RFILL (100, 1.0, WEDLEV)
      CALL RFILL (100, 1.0, WEDR)
      CALL RFILL (100, 1.0, WEDG)
      CALL RFILL (100, 1.0, WEDB)
      CALL IMANOT ('INIT', IG, IX, IY, 0, 0, 'GREEN', BUFFER, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
      LG = IG + NGRAY
C                                       get visible corners
      MAG = 1 + TVZOOM(1)
      IF (MXZOOM.GT.0) MAG = 2 ** TVZOOM(1)
      IX0 = WINDTV(1) - (MAG-1)/2
      IX1 = WINDTV(3) - (MAG-1)/2
      IY0 = WINDTV(2) - (MAG-1)/2
      IY1 = WINDTV(4) - (MAG-1)/2
      IF (MAG.GT.1) IY0 = IY0 + MAG
      IF (MAG.GT.1) IY1 = IY1 + MAG
      IX0 = (IX0 - TVZOOM(2))/MAG + TVZOOM(2)
      IX1 = (IX1 - TVZOOM(2))/MAG + TVZOOM(2)
      IY0 = (IY0 - TVZOOM(3))/MAG + TVZOOM(3)
      IY1 = (IY1 - TVZOOM(3))/MAG + TVZOOM(3)
      IX0 = MAX (1, MIN (MAXXTV(1), IX0))
      IX1 = MAX (1, MIN (MAXXTV(1), IX1))
      IY0 = MAX (1, MIN (MAXXTV(1), IY0))
      IY1 = MAX (1, MIN (MAXXTV(1), IY1))
C                                       Color points
      INVERS = F
      DOPLOT = F
      PI = 3.14159265358
      D60 = PI / 3.0
      ALPHA = 0.80
      XC = (IX0 + IX1) / 2.0
      YC = (IY0 + IY1) / 2.0
      RC = 0.45 * MIN (IX1-IX0, IY1-IY0)
      IXP(1) = XC + 0.5
      IYP(1) = YC + RC + 0.5
      IXP(2) = XC - RC * SIN (D60) + 0.5
      IYP(2) = YC + RC * COS (D60) + 0.5
      IXP(3) = IXP(2)
      IYP(3) = YC - RC * COS (D60) + 0.5
      IXP(4) = IXP(1)
      IYP(4) = YC - RC + 0.5
      IXP(5) = XC + RC * SIN (D60) + 0.5
      IYP(5) = IYP(3)
      IXP(6) = IXP(5)
      IYP(6) = IYP(2)
      IXP(7) = IXP(1)
      IYP(7) = IYP(1)
      IXP(8) = XC + 0.5
      IYP(8) = YC + 0.5
      IXP(9) = IXP(2)
      IYP(9) = IYP(2)
C                                        Graphics drawing: colors
      IX = IXP(1) - 2.5 * CSIZTV(1)
      IY = IYP(1) - 0.5 * CSIZTV(2)
      IX = MAX (1, MIN (MAXXTV(1)-5*CSIZTV(1), IX))
      IY = MAX (1, MIN (MAXXTV(2) - CSIZTV(2), IY))
      CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'GREEN', BUFFER, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
      IX = IXP(2) - 2.0 * CSIZTV(1)
      IY = IYP(2) - 0.5 * CSIZTV(2)
      IX = MAX (1, MIN (MAXXTV(1)-4*CSIZTV(1), IX))
      IY = MAX (1, MIN (MAXXTV(2) - CSIZTV(2), IY))
      CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'CYAN', BUFFER, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
      IX = IXP(3) - 2 * CSIZTV(1)
      IY = IYP(3) - 0.5 * CSIZTV(2)
      IX = MAX (1, MIN (MAXXTV(1)-4*CSIZTV(1), IX))
      IY = MAX (1, MIN (MAXXTV(2) - CSIZTV(2), IY))
      CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'BLUE', BUFFER, IERR)
      IX = IXP(4) - 3.5 * CSIZTV(1)
      IY = IYP(4) - 0.5 * CSIZTV(2)
      IX = MAX (1, MIN (MAXXTV(1)-7*CSIZTV(1), IX))
      IY = MAX (1, MIN (MAXXTV(2) - CSIZTV(2), IY))
      CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'MAGENTA', BUFFER, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
      IX = IXP(5) - 0.5 * CSIZTV(1)
      IY = IYP(5) - 0.5 * CSIZTV(2)
      IX = MAX (1, MIN (MAXXTV(1)-3*CSIZTV(1), IX))
      IY = MAX (1, MIN (MAXXTV(2) - CSIZTV(2), IY))
      CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'RED', BUFFER, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
      IX = IXP(6) - 3.0 * CSIZTV(1)
      IY = IYP(6) - 0.5 * CSIZTV(2)
      IX = MAX (1, MIN (MAXXTV(1)-6*CSIZTV(1), IX))
      IY = MAX (1, MIN (MAXXTV(2) - CSIZTV(2), IY))
      CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'YELLOW', BUFFER, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
C                                        Graphics drawing: lines
      CALL IMVECT ('ONNN', LG, 9, IXP, IYP, BUFFER, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
      IXP(2) = IXP(8)
      IYP(2) = IYP(8)
      IXP(1) = IXP(3)
      IYP(1) = IYP(3)
      IXP(3) = IXP(4)
      IYP(3) = IYP(4)
      CALL IMVECT ('ONNN', LG, 3, IXP, IYP, BUFFER, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
      IXP(1) = IXP(5)
      IYP(1) = IYP(5)
      IXP(3) = IXP(6)
      IYP(3) = IYP(6)
      CALL IMVECT ('ONNN', LG, 3, IXP, IYP, BUFFER, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
C                                        Graphics drawing: numbers
      NEDGE = (4 / MAG) * MAXXTV(1) / 480
      NEDGE = MAX (1, NEDGE)
      INCR = (IY1 - IY0 + 1 - 2*NEDGE - CSIZTV(2)) / MAX (1, INWEDG-1)
      DOIT = INCR.LE.(CSIZTV(2)+1)
      DO 10 I = 1,INWEDG
         IX = IX0 + NEDGE
         IF ((DOIT) .AND. ((I/2)*2.EQ.I)) IX = IX + 2.2*CSIZTV(1)
         IY = IY0 + NEDGE + (I-1) * INCR
         WRITE (STRING,1000) I
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, STRING(:2), BUFFER,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
 10      CONTINUE
C                                        Prepare plot
      CALL FILL (MAXIMG, 0, BUF0)
      CALL FILL (MAXIMG, 255, BUF1)
      IYB = IY1 - 4 * (NEDGE + CSIZTV(2)) + 1
      IYG = IYB + NEDGE + CSIZTV(2)
      IYR = IYG + NEDGE + CSIZTV(2)
      IYV = IYR + NEDGE + CSIZTV(2)
      IXC = IX0 + NEDGE + 4 * CSIZTV(1)
      IYC = IYG
      IX = IXC + 3 * CSIZTV(1)
      NXP = IX + 2 * CSIZTV(1) - CSIZTV(1)/2
      MXP = IX1 - NEDGE - CSIZTV(1) + 1
      IXV = MXP - 4.5 * CSIZTV(1)
      NOPLOT = (MXP.LT.NXP+10) .OR. (IYB.LT.2) .OR.
     *   (IXV.LE.NXP+CSIZTV(1))
      DOPLOT = .NOT.NOPLOT
      IF (DOPLOT) THEN
         I = (MXP - NXP - (IX1-IX0)*0.5) / 2
         IF (I.GT.2) THEN
            IXC = IXC + I
            IX = IX + I
            NXP = NXP + I
            MXP = MXP - I
            IXV = IXV - I
            END IF
         IXP(1) = MXP
         IXP(2) = MXP
         IYP(1) = IYB
         IYP(2) = IYR + CSIZTV(2) - 1
         CALL IMVECT ('ONNN', LG, 2, IXP, IYP, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IXP(1) = NXP + 0.75 * (MXP - NXP) + 0.5
         IXP(2) = IXP(1)
         CALL IMVECT ('ONNN', LG, 2, IXP, IYP, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IXP(1) = NXP + 0.50 * (MXP - NXP) + 0.5
         IXP(2) = IXP(1)
         CALL IMVECT ('ONNN', LG, 2, IXP, IYP, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IXP(1) = NXP + 0.25 * (MXP - NXP) + 0.5
         IXP(2) = IXP(1)
         CALL IMVECT ('ONNN', LG, 2, IXP, IYP, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IXP(1) = NXP
         IXP(2) = NXP
         CALL IMVECT ('ONNN', LG, 2, IXP, IYP, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         CALL IMANOT ('WRIT', IG, IX, IYB, 0, 0, 'B', BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         CALL IMANOT ('WRIT', IG, IX, IYG, 0, 0, 'G', BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         CALL IMANOT ('WRIT', IG, IX, IYR, 0, 0, 'R', BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IYB = IYB + CSIZTV(2) / 2
         IYG = IYG + CSIZTV(2) / 2
         IYR = IYR + CSIZTV(2) / 2
         IX = NXP - CSIZTV(1) + CSIZTV(1) / 2
         CALL IMANOT ('WRIT', IG, IX, IYV, 0, 0, '0', BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         END IF
C                                        Initial OFMs
      NVAL = NLEVS / INWEDG
      IF (DOWEDG.GT.0.0) THEN
         DO 15 I = 1,NVAL
            RBUF(I) = (I - 1.0) / (NVAL - 1.0)
 15         CONTINUE
      ELSE
         CALL RFILL (NVAL, 1.0, RBUF)
         END IF
      IF (DONEW.GT.0.0) THEN
         J = OFMINP + 1
         CALL RFILL (J, 1.0, OFM(1,1))
         DO 20 I = 1,INWEDG
            IX = (I-1) * NVAL + 1
            CALL RCOPY (NVAL, RBUF, OFM(IX,1))
 20         CONTINUE
         CALL RCOPY (J, OFM(1,1), OFM(1,2))
         CALL RCOPY (J, OFM(1,1), OFM(1,3))
         CALL OFMIO ('WRIT', N, NLEVS, F, OFM, IERR)
         IF (IERR.NE.0) GO TO 980
         END IF
C                                        Instructions
 25   MSGTXT = BARS
      CALL MSGWRT (1)
      MSGTXT = 'Hit button A to select a contour to color'
      CALL MSGWRT (1)
      MSGTXT = 'Hit button B to select a contour to vary intensity'
      CALL MSGWRT (1)
      MSGTXT = 'Hit button C to set a contour to black & white'
      CALL MSGWRT (1)
      MSGTXT = 'Hit button D to exit'
      CALL MSGWRT (1)
      XPOS(1) = XC
      XPOS(2) = YC
C                                       turn on cursor
      RPOS(1) = (IX0 + IX1) / 2.0
      RPOS(2) = (IY0 + IY1) / 2.0
      CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IERR)
      IF (IERR.NE.0) GO TO 980
      THEWED = 0
      MODE = 0
C                                       init plot
      IF (.NOT.NOPLOT) THEN
         STRING = ' '
         CALL IMANOT ('WRIT', IG, IXC, IYC, 0, 0, STRING(:2), BUFFER,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         CALL IMANOT ('WRIT', IG, IXV, IYV, 0, 0, STRING(:5), BUFFER,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IF (LXB.GT.0) THEN
            CALL YIMGIO ('WRIT', LG, NXP, IYB, 0, LXB, BUF0, IERR)
            IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
            END IF
         IF (LXG.GT.0) THEN
            CALL YIMGIO ('WRIT', LG, NXP, IYG, 0, LXG, BUF0, IERR)
            IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
            END IF
         IF (LXR.GT.0) THEN
            CALL YIMGIO ('WRIT', LG, NXP, IYR, 0, LXR, BUF0, IERR)
            IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
            END IF
         LXR = 0
         LXG = 0
         LXB = 0
         END IF
C                                       read loop
 30   CALL YCURSE ('READ', F, T, RPOS, QUAD, IBUT, IERR)
         IF (IERR.NE.0) GO TO 980
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
C                                       set a gamma
         LMODE = MODE
         IF (DOIT) THEN
            IF (IBUT.GT.0) THEN
C                                       select a step
               IF (MODE.LE.0) THEN
                  THEWED = (RPOS(2) - IY0 - 1) /INCR + 1
                  THEWED = MAX (1, MIN (INWEDG, THEWED))
                  END IF
               IF (IBUT.EQ.1) THEN
C                                       start hue and saturation
                  IF (MODE.NE.1) THEN
                     MSGTXT = BARS
                     CALL MSGWRT (1)
                     MSGTXT = 'Cursor position sets hue and saturation'
                     CALL MSGWRT (1)
                     MSGTXT = 'Hit button A to invert the colors''' //
     *                   ' intensities'
                     CALL MSGWRT (1)
                     MSGTXT = 'Hit button B to change intensity instead'
                     CALL MSGWRT (1)
                     MSGTXT = 'Hit button C to stop changing the ' //
     *                  'contour'
                     CALL MSGWRT (1)
                     MODE = 1
                     RPOS(1) = XPOS(1)
                     RPOS(2) = XPOS(2)
                     CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IERR)
                     IF (IERR.NE.0) GO TO 980
                     PPOS(1) = 0.0
                     PPOS(2) = 0.0
C                                       invert center: black vs white
                  ELSE
                     INVERS = .NOT.INVERS
                     PPOS(1) = 0.0
                     PPOS(2) = 0.0
                     END IF
C                                       start intensity changing
               ELSE IF (IBUT.LE.3) THEN
                  IF (MODE.NE.2) THEN
                     MSGTXT = BARS
                     CALL MSGWRT (1)
                     MSGTXT = 'Cursor Y position controls intensity'
                     CALL MSGWRT (1)
                     MSGTXT = 'Hit button A to do hue/saturation ' //
     *                  ' instead'
                     CALL MSGWRT (1)
                     MSGTXT = 'Hit button C to stop changing the ' //
     *                  'contour'
                     CALL MSGWRT (1)
                     MODE = 2
                     RPOS(1) = XC
                     RPOS(2) = IY0 + WEDLEV(THEWED) * (IY1 - IY0)
                     CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IERR)
                     IF (IERR.NE.0) GO TO 980
                     PPOS(1) = 0.0
                     PPOS(2) = 0.0
                     END IF
               ELSE IF (IBUT.LE.7) THEN
C                                       revert to black and white
                  IF (MODE.LE.0) THEN
                     IX = (THEWED - 1) * NVAL + 1
                     WEDR(THEWED) = 1.0
                     WEDG(THEWED) = 1.0
                     WEDB(THEWED) = 1.0
                     FG = WEDLEV(THEWED)
                     IX = (THEWED - 1) * NVAL
                     DO 40 I = 1,NVAL
                        OFM(IX+I,1) = FG * RBUF(I)
                        OFM(IX+I,2) = FG * RBUF(I)
                        OFM(IX+I,3) = FG * RBUF(I)
 40                     CONTINUE
                     CALL OFMIO ('WRIT', N, NLEVS, F, OFM, IERR)
                     IF (IERR.NE.0) GO TO 980
C                                       freeze the contour
                  ELSE
                     MODE  = 0
                     PPOS(1) = 0.0
                     PPOS(2) = 0.0
                     END IF
               ELSE
                  POTERR = 0
                  GO TO 980
                  END IF
C                                       init the plot
               IF ((DOPLOT) .AND. (LMODE.LE.0)) THEN
                  WRITE (STRING,1000) THEWED
                  CALL IMANOT ('WRIT', IG, IXC, IYC, 0, 0, STRING(:2),
     *               BUFFER, IERR)
                  IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
                  WRITE (STRING,1040) WEDLEV(THEWED)
                  CALL IMANOT ('WRIT', IG, IXV, IYV, 0, 0, STRING(:5),
     *               BUFFER, IERR)
                  IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
                  IXB = WEDB(THEWED) * (MXP - NXP) + 1
                  CALL YIMGIO ('WRIT', LG, NXP, IYB, 0, IXB, BUF1, IERR)
                  IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
                  IXG = WEDG(THEWED) * (MXP - NXP) + 1
                  CALL YIMGIO ('WRIT', LG, NXP, IYG, 0, IXG, BUF1, IERR)
                  IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
                  IXR = WEDR(THEWED) * (MXP - NXP) + 1
                  CALL YIMGIO ('WRIT', LG, NXP, IYR, 0, IXR, BUF1, IERR)
                  IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
                  LXB = IXB
                  LXG = IXG
                  LXR = IXR
                  END IF
            ELSE IF (MODE.EQ.1) THEN
               XPOS(1) = RPOS(1)
               XPOS(2) = RPOS(2)
               RR = SQRT ((RPOS(1)-XC)**2 + (RPOS(2)-YC)**2) / RC
               IF (RR.LE.0.0) THEN
                  FR = 1.0
                  FG = 1.0
                  FB = 1.0
               ELSE
                  RR = RR ** ALPHA
                  FR = MAX (0.0, 1.0 - RR)
                  FG = FR
                  FB = FR
                  THETA = ATAN2 (XC - RPOS(1), RPOS(2) - YC)
                  IF (INVERS) THETA = THETA - PI
                  IF (THETA.LT.0.0) THETA = THETA + 2.0 * PI
                  IF (THETA.LE.D60) THEN
                     THETA = THETA * 1.5
                     FG = 1.0
                     FB = MAX (0.0, MIN (1.0, FB + RR * SIN (THETA)))
                  ELSE IF (THETA.LE.2.*D60) THEN
                     THETA = (THETA - D60) * 1.5
                     FG = MAX (0.0, MIN (1.0, FG + RR * COS (THETA)))
                     FB = 1.0
                  ELSE IF (THETA.LE.3.*D60) THEN
                     THETA = (THETA - 2.*D60) * 1.5
                     FB = 1.0
                     FR = MAX (0.0, MIN (1.0, FR + RR * SIN (THETA)))
                  ELSE IF (THETA.LE.4.*D60) THEN
                     THETA = (THETA - 3.*D60) * 1.5
                     FB = MAX (0.0, MIN (1.0, FB + RR * COS (THETA)))
                     FR = 1.0
                  ELSE IF (THETA.LE.5.*D60) THEN
                     THETA = (THETA - 4.*D60) * 1.5
                     FR = 1.0
                     FG = MAX (0.0, MIN (1.0, FG + RR * SIN (THETA)))
                  ELSE
                     THETA = (THETA - 5.*D60) * 1.5
                     FR = MAX (0.0, MIN (1.0, FR + RR * COS (THETA)))
                     FG = 1.0
                     END IF
                  END IF
               IF (INVERS) THEN
                  WEDR(THEWED) = 1. - FR
                  WEDG(THEWED) = 1. - FG
                  WEDB(THEWED) = 1. - FB
               ELSE
                  WEDR(THEWED) = FR
                  WEDG(THEWED) = FG
                  WEDB(THEWED) = FB
                  END IF
               IF (DOPLOT) THEN
                  IXB = WEDB(THEWED) * (MXP - NXP) + 1
                  IF (IXB.GT.LXB) THEN
                     IX = NXP + LXB - 1
                     IY = IXB - LXB
                     CALL YIMGIO ('WRIT', LG, IX, IYB, 0, IY, BUF1,
     *                  IERR)
                  ELSE IF (IXB.LT.LXB) THEN
                     IX = NXP + IXB - 1
                     IY = LXB - IXB
                     CALL YIMGIO ('WRIT', LG, IX, IYB, 0, IY, BUF0,
     *                  IERR)
                     END IF
                  IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
                  IXG = WEDG(THEWED) * (MXP - NXP) + 1
                  IF (IXG.GT.LXG) THEN
                     IX = NXP + LXG - 1
                     IY = IXG - LXG
                     CALL YIMGIO ('WRIT', LG, IX, IYG, 0, IY, BUF1,
     *                  IERR)
                  ELSE IF (IXG.LT.LXG) THEN
                     IX = NXP + IXG - 1
                     IY = LXG - IXG
                     CALL YIMGIO ('WRIT', LG, IX, IYG, 0, IY, BUF0,
     *                  IERR)
                     END IF
                  IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
                  IXR = WEDR(THEWED) * (MXP - NXP) + 1
                  IF (IXR.GT.LXR) THEN
                     IX = NXP + LXR - 1
                     IY = IXR - LXR
                     CALL YIMGIO ('WRIT', LG, IX, IYR, 0, IY, BUF1,
     *                  IERR)
                  ELSE IF (IXR.LT.LXR) THEN
                     IX = NXP + IXR - 1
                     IY = LXR - IXR
                     CALL YIMGIO ('WRIT', LG, IX, IYR, 0, IY, BUF0,
     *                  IERR)
                     END IF
                  IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
                  LXB = IXB
                  LXG = IXG
                  LXR = IXR
                  END IF
            ELSE IF (MODE.EQ.2) THEN
               WEDLEV(THEWED) = MAX (0., MIN (1., (RPOS(2) - IY0) /
     *               (IY1 - IY0)))
               IF (DOPLOT) THEN
                  WRITE (STRING,1040) WEDLEV(THEWED)
                  CALL IMANOT ('WRIT', IG, IXV, IYV, 0, 0, STRING(:5),
     *               BUFFER, IERR)
                  IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
                  END IF
               END IF
            IF (MODE.GT.0) THEN
               FR = WEDR(THEWED) * WEDLEV(THEWED)
               FG = WEDG(THEWED) * WEDLEV(THEWED)
               FB = WEDB(THEWED) * WEDLEV(THEWED)
               IX = (THEWED - 1) * NVAL
               DO 50 I = 1,NVAL
                  OFM(IX+I,1) = FB * RBUF(I)
                  OFM(IX+I,2) = FG * RBUF(I)
                  OFM(IX+I,3) = FR * RBUF(I)
 50               CONTINUE
               CALL OFMIO ('WRIT', N, NLEVS, F, OFM, IERR)
               IF (IERR.NE.0) GO TO 980
               END IF
            END IF
C                                       loop
         IF ((MODE.EQ.0) .AND. (LMODE.NE.0)) GO TO 25
         GO TO 30
C                                       close down
C                                       messages on TV error
 980  IF (IERR.EQ.0) GO TO 990
         WRITE (MSGTXT,1980) IERR
         CALL MSGWRT (7)
C                                       error management
 990  IERR = POTERR
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I2.2)
 1040 FORMAT (F5.3)
 1980 FORMAT ('TV ACTION ERROR CODE',I5,' RETURNED')
      END

      SUBROUTINE APPEEK(BUFFER)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C     APPEEK allows the debug examination of ap varaibles.
c     variables are set by the debugger.
C
C      LOOP = Loop counter
C      NLOOP = Maximum number of loops
C      APLOC = Start address
C      NUM =  Number of locations to read
C      ITYP = 1 for I*2 values, 2 for real values, 3 to dump SPAD
C            SPAD dump will be to SPDUMP.
C     the results are returned in BUFFER
C      Programmer = W. D. Cotton, August 1980.
C----------------------------------------------------------------------
      INTEGER LOOP,NLOOP,APLOC,NUB,ITYP,SPDUMP(16),NUM,I,II
      REAL    BUFFER(*)
C----------------------------------------------------------------------
      CALL QWR
      NLOOP = 50
      APLOC = 0
      NUM = 0
      ITYP = 2
      DO 100 LOOP = 1,NLOOP
C                                     Change values here
   50    CONTINUE
         IF (NUM .LE. 0) GO TO 100
            IF (ITYP.LE.2) CALL APGET(BUFFER,APLOC,NUM,ITYP)
            CALL APWD
C                                       Read SPADS if requested
      IF (ITYP .NE. 3) GO TO 60
      DO 65 I = 1,16
         CALL QGSP(II,I-1)
         CALL QWD
         SPDUMP(I) = II
   65    CONTINUE
C                                      Examine results here
   60       CONTINUE
  100       CONTINUE
C
  999 RETURN
      END

      SUBROUTINE ZDCHI2
C-----------------------------------------------------------------------
C! initialize device and Z-routine characteristics commons - local vals
C# System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Initialize the device characteristics common - ZDCHIN does the
C   generic ones and ZDCHI2 does the few peculiar ones.
C
C   Solaris version - set system type.
C-----------------------------------------------------------------------
C
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
C-----------------------------------------------------------------------
C                                       Byte flip indicator code:
C                                          1 => bytes flipped
C                                          2 => words flipped (I*4 only)
C                                          3 => both
C                                          (3 for VAXes, 0 almost
C                                          everywhere else).
      BYTFLP = 3
C                                       Floating-point format code
C                                          0 => OTHER
C                                          1 => IEEE
C                                          2 => VAX F
C                                          3 => VAX G
C                                          4 => IBM (not supported yet)
C                                       Single precision
      SPFRMT = 1
C                                       Double precision
      DPFRMT = 1
C                                       # iterations considered a short
C                                       loop (if less than this, branch
C                                       to scalar code).
      NSHORT = 3
C                                       1 => TTY i/o uses carriage cntrl
C                                       0 => TTY writes with no carriage
C                                            control character
      TTYCAR = 0
C                                       System type ('UNIX', 'VMS')
      SYSTYP = 'SOL '
C                                       System version ('4.5','BSD 4.2')
      SYSVER = 'Solaris '
C
 999  RETURN
      END

      SUBROUTINE YMKCUR (TYPE, CURPAR, IERR)
C-----------------------------------------------------------------------
C! selects the form of the cursor to be displayed
C# Y3 TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Create and load into the programmable cursor memory an array to
C   generate a desired cursor form.
C   Inputs:
C      TYPE    I       Cursor shape. For now 1 = cross only
C      CURPAR  I(?)    Parameters defining size & orientation of cursor
C                      pattern
C   Output:
C      IERR    I       Error code: 0 =>okay, 2 => input error
C   Written NOV-83 for DeAnza by W. Jaffe for cross form cursor only
C-----------------------------------------------------------------------
      INTEGER   TYPE, CURPAR(*), IERR
C
      INCLUDE 'INCS:YDEA.INC'
      LOGICAL   T
      INTEGER   NBYTE, PACK(16), I, J, IX, IY, CUR0, CLUT, PROC1,
     *   AGCUR, FANG(4), ZOR
      INCLUDE 'INCS:DTVC.INC'
      DATA T /.TRUE./
C                               Cursor LUT register is #5
C                               Byte Array group for cursor is #3
C                               CUR0 points to 1st cursor board
C                               1st prog cursor is channel addr 0
      DATA CLUT, CUR0, AGCUR, PROC1 /5, 0, 3, 0/
C                               Bits pairs corresponding to the four
C                               cursor pixels contained in each byte
C     DATA FANG /Z3, ZC, Z30, ZC0/
      DATA FANG /3, 12, 48, 192/
      DATA NBYTE /32/
C-----------------------------------------------------------------------
C                                       error tests
      IERR = 2
C                                       max cursor xy size for deanza
      IF ((TYPE.NE.1) .OR. (CURPAR(1).LE.0) .OR. (CURPAR(1).GT.64) .OR.
     *    (CURPAR(2).LE.0) .OR. (CURPAR(2).GT.64)) GO TO 999
C                                       Zero a line
      CALL FILL (16, 0, PACK)
C                                       Write in Y-stripe
      DO 10 IY = 1,64
C                                       Cursor LUT address of this line
         YBUFF(CURLUT) = 16 * (IY-1)
C                                       Load into cursor LUT address reg
         CALL ZDEAXF ('LCR ', YBUFF(CURLUT), 2, CUR0, CLUT, T, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Set 2-byte fang of central pixel
C                                       off for lines out of range; on
C                                       for rest
         IF ((IY.LT.33-CURPAR(2)/2) .OR. (IY.GT.32+CURPAR(2)/2)) THEN
            PACK(8) = 0
         ELSE
            PACK(8) = FANG(4)
            END IF
C                                       Load values
         CALL ZDEAXF ('LPA ', PACK, NBYTE, PROC1, AGCUR, T, IERR)
 10      CONTINUE
C                                       Write in X-stripe at center
C                                       The central pixel is blank
      DO 20 I = 1,16
         PACK(I) = 0
         DO 15 J = 1,4
            IX = 4 * I + J - 4
            IF ((IX.GE.32-CURPAR(1)/2) .AND. (IX.LT.31+CURPAR(1)/2)
     *          .AND. (IX.NE.32)) PACK(I) = ZOR (PACK(I), FANG(J))
 15         CONTINUE
 20      CONTINUE
C                                       Write it
      YBUFF(CURLUT) = 32 * 16
      CALL ZDEAXF ('LCR ', YBUFF(CURLUT), 2, CUR0, CLUT, T, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZDEAXF ('LPA ', PACK, NBYTE, PROC1, AGCUR, T, IERR)
C
 999  RETURN
      END

      SUBROUTINE GEOXYZ( MODE, LONG, LAT, HT, X, Y, Z, IERR )
C-----------------------------------------------------------------------
C! Make conversions between geodetic and geocentric coordinates.
C# Math Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to make conversions between geodetic and geocentric
C   coordinates.
C   Algorithms from the 1992 Astronomical Almanac Explanatory
C   Supplement, Chapter 4, are used.  The IERS 1989 ellipsoid
C   is used (Semi-major axis and inverse flattening).
C   The routine results are at the cm level accuracy.
C   This routine is based on a SCHED routine written by Craig Walker.
C
C   Inputs:
C     MODE     I  0 => Input data are longitude, latitude and height,
C                 either geocentric or geodetic (height < 1E6)
C                 Output data are geodetic long, lat, and height and
C                 geocentric X, Y, and Z.
C                 1 => Input data are geocentric X, Y, and Z.
C                 Output data are geodetic long, lat, and height
C                 above the geoid.
C   Input/Output:
C     LONG     D  Geodetic(geocentric) longitude; positive to west,
C                 in radians
C     LAT      D  Geodetic(geocentric) latitude, in radians
C     HT       D  Height above the geoid, in meters
C                 If (at input) HT.GT.1E6, LONG, LAT are geocentric
C     X,Y,Z    D  Geocentric equatorial coordinates at the right hand
C                 coordinate system
C   Output:
C     IERR     I  Return code.  0 => ok.  1 => bad mode.
C-----------------------------------------------------------------------
      INTEGER           MODE, IERR
      DOUBLE PRECISION  LONG, LAT, HT, X, Y, Z
      DOUBLE PRECISION  SMAXIS, FLATEN, C, S
      PARAMETER         (SMAXIS=6378137.D0)
      PARAMETER         (FLATEN=1.D0/298.257223563D0)
      DOUBLE PRECISION  SLAT, CLAT, SLONG, CLONG
      DOUBLE PRECISION  B, R, E, F, P, Q, D, NU, G, T, PI
      LOGICAL           MAKEGD
C ----------------------------------------------------------------------
      PI = DATAN( 1.0D0 ) * 4.D0
      MAKEGD = MODE .EQ. 1
      IERR = 1
      IF( MODE .EQ. 0 ) THEN
C
C        Input is long, lat, and ht of some sort.
C
         IF( HT .LT. 1.D6 ) THEN
C
C           Input coordinates are geodetic long, lat, ht.
C
            SLAT = DSIN( LAT )
            CLAT = DCOS( LAT )
            SLONG = DSIN( -LONG )
            CLONG = DCOS( -LONG )
            C = CLAT**2 + ( 1.D0 - FLATEN )**2 * SLAT**2
            C = 1.D0 / SQRT( C )
            S = ( 1.D0 - FLATEN )**2 * C
            X = ( SMAXIS * C + HT ) * CLAT * CLONG
            Y = ( SMAXIS * C + HT ) * CLAT * SLONG
            Z = ( SMAXIS * S + HT ) * SLAT
            IERR = 0
         ELSE
C
C           Input coordinates are geocentric long, lat, ht.
C           Derive X, Y, and Z.  Then convert angles to
C           geodetic in section for data starting with X, Y, Z.
C
            X = HT * COS( LAT ) * COS( -LONG )
            Y = HT * COS( LAT ) * SIN( -LONG )
            Z = HT * SIN( LAT )
            MAKEGD = .TRUE.
            END IF
         END IF
C
C     Now do any required geocentric to geodetic conversion.
C
      IF( MAKEGD ) THEN
         R = SQRT( X**2 + Y**2 )
C
C        Deal with singular cases.
C
         IF( Z .EQ. 0.D0 .AND. R .NE. 0.D0 ) THEN
C
C           On equitorial plane.
C
            LAT = 0.D0
            LONG = -DATAN2( Y, X )
            HT = SQRT( X**2 + Y**2 ) - SMAXIS
C
         ELSE IF( R .EQ. 0.D0 .AND. Z .NE. 0.D0 ) THEN
C
C           On Z axis.
C
            LAT = DSIGN( PI / 2.D0, Z )
            LONG = 0.D0
            HT = Z - SMAXIS * ( 1.D0 - FLATEN )
C
         ELSE IF( R .EQ. 0.D0 .AND. Z .EQ. 0.D0 ) THEN
C
C           Center of earth.
C
            LAT = 0.D0
            LONG = 0.D0
            HT = -SMAXIS
         ELSE
C
C           Reasonable range.
C
            B = DSIGN( SMAXIS * ( 1.D0 - FLATEN ), Z )
            E = ( B * Z - ( SMAXIS**2 - B**2 ) ) / ( SMAXIS * R )
            F = ( B * Z + ( SMAXIS**2 - B**2 ) ) / ( SMAXIS * R )
            P = ( 4.0D0 / 3.0D0 ) * ( E * F + 1.D0 )
            Q = 2.D0 * ( E**2 - F**2 )
            D = P**3 + Q**2
            IF( D .LT. 0.D0 ) THEN
               NU = 2.D0 * SQRT( -P ) * COS( (1.D0/3.D0) *
     1              ACOS( Q / ( P * SQRT( -P ) ) ) )
            ELSE
               NU = ( SQRT( D ) - Q )**(1.D0/3.D0) -
     1              ( SQRT( D ) + Q )**(1.D0/3.D0)
            END IF
C
C           Deal with cases near singularities as per Almanac.
C           The criteria are a wild guess.
C
            IF( Z .LT. SMAXIS / 1.D5 .OR. R .LT. SMAXIS / 1.D5 ) THEN
               NU = (-1.D0) * ( NU**3 + 2.D0 * Q ) / ( 3.D0 * P )
            END IF
            G = 0.5D0 * ( SQRT( E**2 + NU ) + E )
            T = SQRT( G**2 + ( F - NU * G ) / ( 2.D0 * G - E ) ) - G
            LAT = DATAN( SMAXIS * ( 1.D0 - T**2 ) / ( 2.D0 * B * T ) )
            HT = ( R - SMAXIS * T ) * COS( LAT ) +
     1           ( Z - B ) * SIN( LAT )
            LONG = -DATAN2( Y, X )
         END IF
         IERR = 0
      END IF
C
      RETURN
      END

      SUBROUTINE AEGRID (APCORE, OLUN, ILUN, MIDSK, MIFIL, MODSK,
     *   MOFIL, RWT, BLC, TRC, CATIN, JBUFSZ, BUFF1, BUFF2, MBUFSZ,
     *   BUFFM, OBUFSZ, OUTBUF, MAXCWT, XNLIM, IRET)
C-----------------------------------------------------------------------
C! Regrids image having coordinates in an image
C# Singledish AP
C-----------------------------------------------------------------------
C;  Copyright (C) 1997-1998, 2000, 2006, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AEGRID regrids an image using images of the relative RA and Dec of
C   the input pixels.  It assumes that the DSDG common has been prepared
C   for the gridding.
C   Inputs:
C      OLUN     I      LUN to use for output
C      ILUN     I      LUN to use for input
C      MIDSK    I      > 0 => Disk # of cataloged input file
C                      = 0 => SC file read with MINIT/MDISK
C      MIFIL    I      CNO for cataloged or SC index
C      MODSK    I      > 0 => disk # for cataloged MA, else SC
C      MOFIL    I      CNO for cataloged, index to SC
C      RWT      R      Fractional cutoff level
C      BLC      I(7)   BLC of input image
C      TRC      I(7)   TRC of input image - see note below
C      CATIN    I(256) Header of input image
C      JBUFSZ   I      Size of BUFF1, BUFF2 in AIPS bytes (2*UVBFSS)
C      MBUFSZ   I      Size of BUFFM in AIPS bytes (2*4*MAXCIF)
C      OBUFSZ   I      Size of OUTBUF in AIPS bytes (2*8192)
C   Outputs:
C      BUFF1    R(*)   UV buffer
C      BUFF2    R(*)   UV buffer scratch
C      BUFFM    R(*)   Data load buffer
C      OUTBUF   R(*)   Image output buffer
C      MAXCWT   R      Maximum convolved weight
C      XNLIM    R      Cutoff on sum of convolved weights
C      IRET     I      Error code: 0 -> ok
C   Common inputs:
C      NX       I      X dimension out
C      NY       I      Y dimension
C      SDBCHN   I      Begin channel
C      SDECHN   I      End channel
C      CATMAP   I(256) Image header
C      CXTYPE   I      X convolution type
C      XPARM    R(10)  X convolution parameters
C      CYTYPE   I      Y convolution type
C      YPARM    R(10)  Y convolution parameters
C   coordinate data are assumed to be in planes TRC(3)+1 and +2.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   ILUN, OLUN, MIDSK, MIFIL, MODSK, MOFIL, BLC(7), TRC(7),
     *   CATIN(256), JBUFSZ, MBUFSZ, OBUFSZ, IRET
      REAL      RWT, MAXCWT, XNLIM, BUFF1(*), BUFF2(*), BUFFM(*),
     *   OUTBUF(*)
C
      INTEGER   NCHAN, IC, IERR, IG, BO, BLKOF, DEPTH(5), WIN(4), IFACT,
     *   DIND, NO2, M, LAPREC, INCNT, GRID(3), IY, IDATA, II, UVPTR,
     *   VISPTR, WTPTR, BIND, TOLROW, INC, APSIZ, KAP, CX, CY, CINC,
     *   MAXREC, KNPTR, JJ, KK, ITEMP, INDL, NUMKEP, NUMOFF, PRJERR,
     *   IDEP(5), I1, I2, I3, I4, I5, I6, I7, INX, INY, OWIN(4), NEED,
     *   CATTMP(256)
      REAL      DMAX, DMIN, CATMAR(256), XPIX, YPIX
      DOUBLE PRECISION XX, YY, RA0, DEC0
      LOGICAL   T, F, DOABS, WASBLK
      CHARACTER PHNAME*48
      INCLUDE 'INCS:DSDG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DAPM.INC'
      EQUIVALENCE (CATMAP, CATMAR)
      DATA T, F /.TRUE.,.FALSE./
      DATA BO, UVPTR /1, 16/
C-----------------------------------------------------------------------
      IF (IRET.NE.0) GO TO 999
      WASBLK = .FALSE.
      MAXCWT = 0.0
      PRJERR = 0
C                                       Make sure an ODD number of rows
C                                       is being kept in the AP.
      NO2 = MAX (XPARM(1), 1.0) + 0.1
      M = MAX (YPARM(1), 1.0) + 0.1
      M = M * 2 + 1
      IFACT = 2
      IF (CXTYPE.LE.10) THEN
         INC = 100 * (M + 1 + 2*NO2) + 2
      ELSE
         INC = XPARM(5) + 0.1
         INC = INC * M + 1
         INC = INC * INC
         END IF
      INX = TRC(1) - BLC(1) + 1
      INY = TRC(2) - BLC(2) + 1
      IG = INX * INY
      NEED = INC + 16 + MBUFSZ/4 + 2 * IG + IFACT*NX*NY + 100
      NEED = NEED / 1024 + 4
      CALL QINIT (APCORE, NEED, 0, KAP)
      APSIZ = PSAPNW * 1024
      INC = APSIZ - INC - 16 - MBUFSZ/4 - 2 * IG - IFACT*NX*NY
      IF (INC.LE.100) THEN
         MSGTXT = 'AEGRID: AP MEMORY TOO SMALL FOR SUCH LARGE PLANES'
         IRET = 1
         GO TO 990
         END IF
C                                       Open files - output image
      NCHAN = CATMAP(KINAX+2)
      IF (MODSK.LE.0) THEN
         CALL ZPHFIL ('SC', SCRVOL(MOFIL), SCRCNO(MOFIL), 1, PHNAME,
     *      IERR)
         CALL ZOPEN (OLUN, INDL, SCRVOL(MOFIL), PHNAME, T, F, T, IRET)
      ELSE
         CALL ZPHFIL ('MA', MODSK, MOFIL, 1, PHNAME, IERR)
         CALL ZOPEN (OLUN, INDL, MODSK, PHNAME, T, F, T, IRET)
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, 'OPEN'
         GO TO 990
         END IF
C                                       Open input image
      IF (MIDSK.LE.0) THEN
         CALL ZPHFIL ('SC', SCRVOL(MIFIL), SCRCNO(MIFIL), 1, PHNAME,
     *      IERR)
         CALL ZOPEN (ILUN, DIND, SCRVOL(MIFIL), PHNAME, T, T, T, IRET)
      ELSE
         CALL ZPHFIL ('MA', MIDSK, MIFIL, 1, PHNAME, IERR)
         CALL ZOPEN (ILUN, DIND, MIDSK, PHNAME, T, F, T, IRET)
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN'
         GO TO 990
         END IF
C                                       Setup for AP griding
C                                       Set AP pointers
      IG = INX * INY
      GRID(3) = APSIZ - IG - 1
      GRID(2) = GRID(3) - IG
      IG = IFACT * NX * NY
      GRID(1) = GRID(2) - IG
C                                       Clear AP
      IF (CXTYPE.LE.10) THEN
         CINC = 100
         CX = GRID(1) - CINC * (2 * NO2 + 1) - 1
         CY = CX - CINC * M - 1
      ELSE
         CINC = XPARM(5) + 0.1
         CX = GRID(1) - (CINC * M + 1) * (CINC * M + 1) - 1
         CY = CX
         END IF
      DOABS = RWT.LE.0.0
C                                       Determine the maximum number
C                                       of visibility points which
C                                       fit in the AP.
      LAPREC = 3 + 2
      MAXREC = (CY - 16) / LAPREC - 5
C                                       Be sure MAXREC.GT.0
      IF (MAXREC.LE.0) THEN
         IG = - MAXR EC * LAPREC
         WRITE (MSGTXT,1020) IG
         IRET = 1
         GO TO 990
         END IF
C                                       Set gridding convolution tables
      CALL CONVFN (APCORE, CX, CXTYPE, XPARM, BUFF2)
      IF (CXTYPE.LE.10) CALL CONVFN (APCORE, CY, CYTYPE, YPARM, BUFF2)
      TOLROW = 2 * NX
      WIN(1) = BLC(1)
      WIN(2) = BLC(2)
      WIN(3) = TRC(1)
      WIN(4) = TRC(2)
      OWIN(1) = 1
      OWIN(2) = 1
      OWIN(3) = NX
      OWIN(4) = NY
      DMAX = -1.0E20
      DMIN = 1.0E20
      NUMKEP = 0
      NUMOFF = 0
C                                       Loop over input cube
      DO 700 I7 = BLC(7),TRC(7)
      DO 699 I6 = BLC(6),TRC(6)
      DO 698 I5 = BLC(5),TRC(5)
      DO 697 I4 = BLC(4),TRC(4)
C                                       Read RA, dec images
         IDEP(2) = I4
         IDEP(3) = I5
         IDEP(4) = I6
         IDEP(5) = I7
         DO 30 IC = 1,2
            IDEP(1) = TRC(3) + IC
            CALL COMOFF (CATIN(KIDIM), CATIN(KINAX), IDEP, BLKOF, IERR)
            BLKOF = BLKOF + BO
            CALL MINIT ('READ', ILUN, DIND, CATIN(KINAX),
     *         CATIN(KINAX+1), WIN, BUFF1, JBUFSZ, BLKOF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'INIT'
               GO TO 990
               END IF
            IDATA = GRID(1+IC)
            DO 20 IY = 1,INY
               CALL MDISK ('READ', ILUN, DIND, BUFF1, BIND, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITE'
                  GO TO 990
                  END IF
C                                       Read out gridded data.
               CALL QPUT (APCORE, BUFF1(BIND), IDATA, INX, 2)
               IDATA = IDATA + INX
               CALL QWAIT
 20            CONTINUE
 30         CONTINUE
C                                       Set coordinate computation
         DEPTH(1) = 1
         DEPTH(2) = I4 - BLC(4) + 1
         DEPTH(3) = I5 - BLC(5) + 1
         DEPTH(4) = I6 - BLC(6) + 1
         DEPTH(5) = I7 - BLC(7) + 1
         CALL COPY (256, CATBLK, CATTMP)
         CALL COPY (256, CATMAP, CATBLK)
         IF (LOCNUM.LE.0) LOCNUM = 1
         CALL SETLOC (DEPTH, .FALSE.)
         CALL COPY (256, CATIN, CATBLK)
         RA0 = CATD(KDORA)
         DEC0 = CATD(KDODE)
         CALL COPY (256, CATTMP, CATBLK)
         IDATA = GRID(2)
         IY = GRID(3)
C                                       The divide by COS(DEC) was done
C                                       by OTFBS, not needed here.
         DO 50 I2 = 1,INY
            CALL QGET (APCORE, BUFF1, IDATA, INX, 2)
            CALL QGET (APCORE, BUFF2, IY, INX, 2)
            CALL QWAIT
            DO 40 I1 = 1,INX
               IF ((BUFF1(I1).NE.FBLANK) .AND. (BUFF2(I1).NE.FBLANK))
     *            THEN
                  XX = RA0 + BUFF1(I1)
                  YY = DEC0 + BUFF2(I1)
                  CALL XYPIX (XX, YY, BUFF1(I1), BUFF2(I1), IRET)
                  IF (IRET.NE.0) THEN
                     PRJERR = PRJERR + 1
                     IF (PRJERR.LE.1) THEN
                        WRITE (MSGTXT,1100) IRET
                        CALL MSGWRT (7)
                        END IF
                     NUMOFF = NUMOFF + 1
                     BUFF1(I1) = FBLANK
                     BUFF2(I1) = FBLANK
                     END IF
                  END IF
 40            CONTINUE
            CALL QPUT (APCORE, BUFF1, IDATA, INX, 2)
            CALL QPUT (APCORE, BUFF2, IY, INX, 2)
            CALL QWAIT
            IDATA = IDATA + INX
            IY = IY + INX
 50         CONTINUE
C                                       Loop over channels
         DO 300 I3 = BLC(3),TRC(3)
            IDEP(1) = I3
            DEPTH(1) = I3 - BLC(3) + 1
            CALL QVCLR (APCORE, GRID(1), 1, IG)
            LAPREC = 2 + 3
            MAXREC = (CY - 16) / LAPREC - 5
            IC = MBUFSZ / (2 * LAPREC)
            MAXREC = MIN (MAXREC, IC)
C                                       Init input read
            CALL COMOFF (CATIN(KIDIM), CATIN(KINAX), IDEP, BLKOF, IERR)
            BLKOF = BLKOF + BO
            CALL MINIT ('READ', ILUN, DIND, CATIN(KINAX),
     *         CATIN(KINAX+1), WIN, BUFF1, JBUFSZ, BLKOF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'INIT'
               GO TO 990
               END IF
            INCNT = 0
            KNPTR = 1
            DO 70 I2 = 1,INY
C                                       Get coordinates
               IDATA = GRID(2) + (I2 - 1) * INX
               CALL QGET (APCORE, BUFF2(1), IDATA, INX, 2)
               IDATA = GRID(3) + (I2 - 1) * INX
               CALL QGET (APCORE, BUFF2(INX+1), IDATA, INX, 2)
               CALL MDISK ('READ', ILUN, DIND, BUFF1, BIND, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'READ'
                  GO TO 990
                  END IF
               CALL QWAIT
C                                       Move to buffer
               DO 60 I1 = 1,INX
                  XPIX = BUFF2(I1)
                  YPIX = BUFF2(I1+INX)
                  IF ((BUFF1(BIND+I1-1).NE.FBLANK) .AND.
     *               (XPIX.NE.FBLANK) .AND. (YPIX.NE.FBLANK)) THEN
C                                       Does not fit
                     IF ((XPIX.LT.0.5+XPARM(1)) .OR.
     *                  (XPIX.GT.NX+0.5-XPARM(1)) .OR.
     *                  (YPIX.LT.0.5+YPARM(1)) .OR.
     *                  (YPIX.GT.NY+0.5-YPARM(1))) THEN
                        NUMOFF = NUMOFF + 1
                     ELSE
                        NUMKEP = NUMKEP + 1
C                                       Y in u position
                        BUFFM(KNPTR) = YPIX
C                                       X offset in v position
                        BUFFM(KNPTR+1) = XPIX - NX/2 - 1.
                        BUFFM(KNPTR+2) = 1.0
                        KNPTR = KNPTR + 3
                        BUFFM(KNPTR) = BUFF1(BIND+I1-1)
                        BUFFM(KNPTR+1) = 1.0
                        KNPTR = KNPTR + 2
                        INCNT = INCNT + 1
C                                       Load into AP.
                        IF (INCNT.GE.MAXREC) THEN
                           ITEMP = KNPTR - 1
                           CALL QWR
                           CALL QPUT (APCORE, BUFFM, UVPTR, ITEMP, 2)
                           CALL QWAIT
C                                       Do the gridding
                           VISPTR = UVPTR + 2 + 1
                           WTPTR = VISPTR + 1
                           CALL QGRD6 (APCORE, UVPTR, VISPTR, WTPTR,
     *                        GRID(1), CY, CX, CINC, NO2, M, NX, LAPREC,
     *                        INCNT)
                           CALL QWR
                           INCNT = 0
                           KNPTR = 1
                           END IF
                        END IF
                     END IF
 60               CONTINUE
 70            CONTINUE
C                                       Finish last buffer
C                                       Load into AP.
            IF (INCNT.GT.0) THEN
               ITEMP = INCNT * LAPREC
               CALL QWR
               CALL QPUT (APCORE, BUFFM, UVPTR, ITEMP, 2)
               CALL QWAIT
C                                       Do the gridding
               VISPTR = UVPTR + 2 + 1
               WTPTR = VISPTR + 1
               CALL QGRD6 (APCORE, UVPTR, VISPTR, WTPTR, GRID(1), CY,
     *            CX, CINC, NO2, M, NX, LAPREC, INCNT)
               CALL QWR
               END IF
C                                       Summary
            WRITE (MSGTXT,1125) NUMKEP, NUMOFF
            IF (I3.EQ.BLC(3)) CALL MSGWRT (4)
            WRITE (MSGTXT,1126) PRJERR
            IF (PRJERR.GT.0) CALL MSGWRT (7)
            IF (NUMKEP.LE.0.0) IRET = 9
            IF (IRET.NE.0) GO TO 999
C                                       Done gridding find max cwt
            CALL QWAIT
C                                       Loop over plane
            IDATA = GRID(1)
            DO 80 IY = 1,NY
C                                       Read out gridded data.
               CALL QGET (APCORE, BUFF2, IDATA, TOLROW, 2)
               IDATA = IDATA + TOLROW
               CALL QWAIT
C                                       Max weight
               KK = 0
               DO 75 II = 1,NX
                  KK = KK + 2
                  MAXCWT = MAX (MAXCWT ,ABS(BUFF2(KK)))
 75               CONTINUE
 80            CONTINUE
            IF (MAXCWT.LE.0.0) MAXCWT = 1.0
            XNLIM = ABS (RWT) * MAXCWT
C                                       Done gridding, write planes
            CALL QWAIT
            CALL COMOFF (CATMAP(KIDIM), CATMAP(KINAX), DEPTH, BLKOF,
     *         IERR)
            BLKOF = BLKOF + BO
            CALL MINIT ('WRIT', OLUN, INDL, NX, NY, OWIN, OUTBUF,
     *         OBUFSZ, BLKOF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'INIT'
               GO TO 990
               END IF
C                                       Loop over plane
            IDATA = GRID(1)
            DO 190 IY = 1,NY
C                                       Write
               CALL MDISK ('WRIT', OLUN, INDL, OUTBUF, BIND, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1010) IRET, 'WRITE'
                  GO TO 990
                  END IF
C                                       Read out gridded data.
               CALL QGET (APCORE, BUFF2, IDATA, TOLROW, 2)
               IDATA = IDATA + TOLROW
               CALL QWAIT
C                                       Move data: validity image
               JJ = BIND - 1
               KK = -1
C                                       Move data: Interpolation
               IF (DOABS) THEN
                  DO 160 II = 1,NX
                     JJ = JJ + 1
                     KK = KK + 2
                     IF (ABS(BUFF2(KK+1)).GE.XNLIM) THEN
                        OUTBUF(JJ) = BUFF2(KK) / BUFF2(KK+1)
                        DMAX = MAX (DMAX, OUTBUF(JJ))
                        DMIN = MIN (DMIN, OUTBUF(JJ))
                     ELSE
                        OUTBUF(JJ) = FBLANK
                        WASBLK = .TRUE.
                        END IF
 160                 CONTINUE
               ELSE
                  DO 165 II = 1,NX
                     JJ = JJ + 1
                     KK = KK + 2
                     IF (BUFF2(KK+1).GE.XNLIM) THEN
                        OUTBUF(JJ) = BUFF2(KK) / BUFF2(KK+1)
                        DMAX = MAX (DMAX, OUTBUF(JJ))
                        DMIN = MIN (DMIN, OUTBUF(JJ))
                     ELSE
                        OUTBUF(JJ) = FBLANK
                        WASBLK = .TRUE.
                        END IF
 165                 CONTINUE
                  END IF
 190           CONTINUE
            CALL MDISK ('FINI', OLUN, INDL, OUTBUF, BIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'FINISH'
               GO TO 990
               END IF
 300        CONTINUE
 697     CONTINUE
 698     CONTINUE
 699     CONTINUE
 700     CONTINUE
C                                       Close files
      CALL QRLSE
      CATMAR(KRDMX) = DMAX
      CATMAR(KRDMN) = DMIN
      IF (WASBLK) THEN
         CATMAR(KRBLK) = FBLANK
      ELSE
         CATMAR(KRBLK) = 0.0
         END IF
      CALL ZCLOSE (ILUN, DIND, IERR)
      CALL ZCLOSE (OLUN, INDL, IERR)
      WRITE (MSGTXT,1315) MAXCWT
      CALL MSGWRT (5)
      WRITE (MSGTXT,1316) XNLIM
      CALL MSGWRT (5)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AEGRID: ERROR',I4,1X,A,'ING INPUT')
 1010 FORMAT ('AEGRID: ERROR',I4,1X,A,'ING OUTPUT')
 1020 FORMAT ('AEGRID:',I8,' TOO FEW AP WORDS AVAILABLE')
 1100 FORMAT ('AEGRID: ERROR',I5,' PROJECTING POSITION')
 1125 FORMAT ('AEGRID:',I9,' points kept;',I9,
     *   ' others fell off the grid')
 1126 FORMAT ('AEGRID:',I9,' ERRORS PROJECTING COORDINATES')
 1315 FORMAT ('AEGRID: Maximum convolved weight =',1PE12.4)
 1316 FORMAT ('AEGRID;    used to scale cutoff to',1PE12.4)
      END

      PROGRAM IMPFIT
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  Read an AIPS source tape written in compresses ascii FITS format via
C  the program EXPFIT.  IMPFIT requires three operating-system-specific
C  subroutines:
C
C     ZTAPIO.....performs tape opening, reading and closing
C
C     ZCRDIR.....creates directories as required
C
C     ZFLOPN.....creates and opens a Fortran-77 text file
C
C   The UNIX versions of these Z routines are appended to this file.
C   ZTAPIO and ZCRDIR are written in C and hence are appended as
C   comments to this Fortran file.
C
C   Since the Fortran code of IMPFIT has only been tested under UNIX, it
C   is not certain to be operating system independent at this time
C   although it is believed to be in compliance with the ANSI Fortran 77
C   standard.
C-----------------------------------------------------------------------
      INTEGER   CMD, FILCNT, IP, IERR, LD, LO, NFILES
      LOGICAL   LDIR, COPY, CRT, TPOPN, EOFLG
      CHARACTER TPNAM*24, ANSWR*5, CC*1, B(36)*80, S*256
      INTEGER   FD, IR, IC, IO, NBYTE
      COMMON /CTRLC/ B, S, TPNAM
      COMMON /CTRLI/ FD, IR, IC, IO, EOFLG
      DATA LD, LO, FILCNT /3,4,1/
      DATA TPOPN /.FALSE./
C-----------------------------------------------------------------------
C                                       Initialize
      CMD = 0
      FD = -1
      IR = 999
      IC = 999
      IO = 0
      IERR = 0
      EOFLG = .FALSE.
C                                       Get input from terminal
 5    WRITE (6,'('' ENTER THE TAPE NAME'')')
      READ (5, '(A)') TPNAM
C                                       Do more: ask operation
 6    WRITE (6,'('' DO YOU WANT TO MAKE AN INDEX OF THE TAPE? (Y/N)'')')
      READ (5, '(A1)') ANSWR
      IF (ANSWR.EQ.'Q') GO TO 999
      LDIR = (ANSWR.EQ.'Y')
      WRITE (6, '('' DO YOU WANT TO COPY THE FILES TO DISK? (Y/N)'')')
      READ (5, '(A1)') ANSWR
      COPY = (ANSWR.EQ.'Y')
      WRITE (6,'('' DO YOU WANT FILENAMES LISTED ON THE CRT? (Y/N)'')')
      READ (5,'(A1)') ANSWR
      CRT = (ANSWR.EQ.'Y')
      WRITE (6, '('' ENTER THE NUMBER OF FILES TO PROCESS. (I3)'')')
      READ (5, '(I3)') NFILES
      WRITE (6,'('' TYPE   GO, RESTART, OR QUIT'')')
      READ (5,'(A)') ANSWR
      IF (ANSWR.EQ.'GO') GO TO 8
      IF (ANSWR.EQ.'QUIT') GO TO 999
      GO TO 5
C                                       DO it
C                                       Set terminal carriage control
C                                       character
 8    IF (CRT) THEN
         CC = '-'
      ELSE
         CC = ' '
         END IF
C                                       Open tape file
      IF (.NOT.TPOPN) CALL ZTAPIO ('OPEN', 24, TPNAM, FD, 2880, NBYTE,
     *   B, IERR)
      IF ((FD.LT.0) .OR. (IERR.NE.0)) GO TO 900
      TPOPN = .TRUE.
C                                       Open tape index output file
      IF (LDIR) THEN
         OPEN (UNIT=LD, FILE='IMPFIT.INX', STATUS='NEW', ERR=920)
         REWIND (LD)
         WRITE (6,*) 'TAPE INDEX FILE = IMPFIT.INX'
         END IF
C                                       Process the tape
 10   CONTINUE
         CALL GNXT (CMD, IP, IERR)
         CMD = 0
         IF (IERR.EQ.0) THEN
            IF (COPY) THEN
               IF (B(IR)(IC:IC) .EQ. '!') THEN
                  CALL SPCIAL()
               ELSE
                  CALL PNXT (0, B(IR)(IC:IC), 1)
                  END IF
               END IF
         ELSE IF (IERR.EQ.1) THEN
            CALL HDR (LDIR, COPY, CRT, CMD)
         ELSE IF (IERR.EQ.2) THEN
            CLOSE (LO)
            FILCNT = FILCNT + 1
            IF (FILCNT.GT.NFILES) GO TO 850
            IF (LDIR) WRITE (LD,'(''-FILE NUMBER '',I4)') FILCNT
         ELSE IF (IERR.EQ.3) THEN
            GO TO 800
         ELSE
            GO TO 950
            END IF
         GO TO 10
C                                       End of volume
 800  CALL ZTAPIO ('CLOS', 24, TPNAM, FD, 2880, NBYTE, B, IERR)
      WRITE (6, '('' END OF TAPE REACHED - PROGRAM ENDING'')')
      GO TO 999
C                                       Requested number of files
C                                       processed
 850  FILCNT = FILCNT - 1
      WRITE (6, '(1X,I4, '' FILES PROCESSED'')') FILCNT
      FILCNT = 1
      GO TO 6
C                                       Tape open error
 900  WRITE (6, '('' TAPE OPEN FAILED - PROGRAM ENDING'')')
      GO TO 999
C                                       Index file open error
 920  WRITE (6, '('' UNABLE TO OPEN LISTING FILE '')')
      GO TO 5
C                                       Tape i/o error
 950  WRITE (6, '('' TAPE I/O ERROR - PROGRAM ENDING'')')
C
 999  STOP
      END
      SUBROUTINE GDNA (STR, NBEG, NEND, LENTH, IERR)
C-----------------------------------------------------------------------
C  Find the end of the next part of the pathname contained in the string
C  "STR" assuming that NBEG is the character position of the first "/".
C  "NEND" will be the character position for the last valid character.
C       IERR:  0 - Valid name. Is not the last one.
C              1 - Valid name. Nothing follows.
C              2 - Error.
C-----------------------------------------------------------------------
      INTEGER NBEG, NEND, IERR, LENTH, ND1, ND2, ND, N
      CHARACTER STR*(*)
C-----------------------------------------------------------------------
C                                       Find the first delimiter (blank
C                                       or apostrophe)
      ND1 = INDEX (STR(NBEG+1:80), ' ')
      ND2 = INDEX (STR(NBEG+1:80), '''')
      ND = MIN (ND1, ND2)
      IF (ND.EQ.0) ND = ND1 + ND2
C
      N = INDEX (STR(NBEG+1:80), '/')
      IF ((N.GT.0) .AND. (N.LT.ND)) THEN
         NEND = NBEG + N - 1
         IERR = 0
      ELSE
         NEND = NBEG + ND - 1
         IERR = 1
         END IF
C
      LENTH = NEND - NBEG + 1
C
 999  RETURN
      END
      SUBROUTINE GNXT (CMD, IP, IERR)
C-----------------------------------------------------------------------
C   Set the column (IC) and the row (IR) of the next character in the
C   tape buffer, staying always in the data area (columns 9-80) except
C   for "control" lines, in which case IP points to column 1 of that
C   line. Use CMD=1 to go immeditaely to the next line (like after a
C   command if need be, read another tape block into the buffer).
C   Inputs:
C      CMD      INTEGER  0 get next char; 1 get next char in next line;
C                        2 read until EOF.
C      B        CHAR     Tape char buffer (in commons).
C   Outputs:
C      IP       INTEGER  Position (1:2880) of next useful character in
C                        the tape buffer (not used).
C      IC       INTEGER  In commons - Column number in current line.
C      IR       INTEGER  In commons - Record number of current line.
C      IERR     INTEGER  0 - char is good; 1 - first char of a control
C                        line; 2 - EOF; 3 - EOV; 4 - i/o error
C-----------------------------------------------------------------------
      INTEGER CMD, IP, IERR
      INTEGER FD, IR, IC, IO
      LOGICAL EOFLG
      CHARACTER B(36)*80, S*256, TPNAM*24
      COMMON /CTRLC/ B, S, TPNAM
      COMMON /CTRLI/ FD, IR, IC, IO, EOFLG
C-----------------------------------------------------------------------
      IF ((CMD.EQ.0) .AND. (IC.LT.80)) THEN
         IC = IC + 1
         IP = (IR - 1)*80 + IC
         IERR = 0
      ELSE IF (((CMD.EQ.0) .AND. (IC.GE.80)) .OR. (CMD.EQ.1)) THEN
         IC = 1
         IF (IR.LT.36) THEN
            IR = IR + 1
         ELSE
            IR = 1
            IP = 1
            CALL RDTP (IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         IP = (IR - 1)*80 + IC
         IF (B(IR)(IC:IC).EQ.' ') THEN
            IERR = 0
            IP = IP + 8
            IC = 9
         ELSE
            IERR = 1
            END IF
      ELSE IF (CMD.EQ.2) THEN
 10      CONTINUE
            CALL RDTP (IERR)
            IF (IERR.EQ.0) GO TO 10
         GO TO 900
         END IF
      GO TO 999
C                                       Error
 900  IERR = IERR + 1
      IC = 999
      IR = 999
C
 999  RETURN
      END
      SUBROUTINE HDR (LDIR, COPY, CRT, CMD)
C-----------------------------------------------------------------------
C   Process the FITS header record pointed to by B(IR)(IC:IC+79).
C   LDIR = .TRUE. to cause listing of directory names and filenames to
C   be written to the output file UNIT 3. Files are dumped to disk when
C   COPY=.TRUE. . File names and directory names are written to the CRT
C   when CRT = .TRUE. "CMD" = 2 when an "END" header record is found so
C   that the remainder of the file may be ignored. The current directory
C   is used.
C-----------------------------------------------------------------------
      INTEGER LO, LD, CMD
      LOGICAL LDIR, COPY, CRT
      CHARACTER FNA*80, DNA*80, DNA0*80
      INTEGER FD, IR, IC, IO, NB, ITRIMS, MB, IERR, IERR2, LN, ME, LDNA
      LOGICAL EOFLG
      CHARACTER B(36)*80, S*256, TPNAM*24
      COMMON /CTRLC/ B, S, TPNAM
      COMMON /CTRLI/ FD, IR, IC, IO, EOFLG
      DATA LD, LO /3,4/
C-----------------------------------------------------------------------
      CMD = 0
      IF (B(IR)(1:8).EQ.'FILENAME') THEN
         CALL ITRIM (B(IR), ITRIMS)
         IF (CRT) WRITE (6, '(1X,A)') B(IR)(1:ITRIMS)
         IF (LDIR) WRITE (LD, '(1X,A)') B(IR)(1:ITRIMS)
         IF (COPY) THEN
            FNA = DNA(1:NB-1) // '/' // B(IR)(12:ITRIMS-1)
            CALL ZFLOPN (LO, FNA, IERR)
            IF (IERR.NE.0) GO TO 950
            REWIND (LO)
            IO = 0
            END IF
      ELSE IF (B(IR)(1:8).EQ.'DIRECTOR') THEN
         CALL ITRIM (B(IR), ITRIMS)
         IF (CRT) WRITE (6, '(''0'',A)') B(IR)(1:ITRIMS)
         IF (LDIR) WRITE (LD, '(''0'',A)') B(IR)(1:ITRIMS)
         DNA = ' '
         DNA0 = ' '
         DNA0 = B(IR)(12:80)
C                                       Construct the directory name
         IF (COPY) THEN
            MB = 1
            NB = 1
            MB = NB
            IERR = 0
 20         IF (IERR.NE.0) GO TO 30
               CALL GDNA (DNA0, MB, ME, LN, IERR)
               DNA(NB:NB+LN-1) = DNA0(MB:ME)
               IF ((IERR.EQ.0) .OR. (IERR.EQ.1)) NB = NB + LN
               IF (IERR.EQ.0) MB = ME + 1
               CALL ITRIM (DNA, LDNA)
               CALL ZCRDIR (LDNA, DNA, IERR2)
               IF (IERR2.EQ.1) WRITE (6,*) DNA,' ALREADY EXISTS BUT ',
     *            'IS NOT A DIRECTORY'
               IF (IERR2.EQ.2) WRITE (6,*) 'FAILED TO CREATE ',DNA
               GO TO 20
 30         CONTINUE
            END IF
      ELSE IF (B(IR)(1:8).EQ.'END     ') THEN
         CMD = 2
         END IF
      GO TO 990
C                                       Open error
 950  WRITE (6,'('' OPEN ERROR FOR'', A)') FNA
C                                       Point end of card
 990  IC = 80
C
 999  RETURN
      END
      SUBROUTINE ITRIM (STRING, ITRIMS)
C-----------------------------------------------------------------------
C  Function to determine length of a string (i.e., it trims trailing
C  blanks).
C-----------------------------------------------------------------------
      CHARACTER STRING*(*)
      INTEGER ITRIMS
C
C-----------------------------------------------------------------------
      ITRIMS = LEN (STRING)
 10   CONTINUE
         ITRIMS = ITRIMS - 1
         IF (ITRIMS.LT.1) GO TO 999
         IF (STRING(ITRIMS:ITRIMS).EQ.' ') GO TO 10
C
 999  RETURN
      END
      SUBROUTINE PNXT (CMD, C, N)
C-----------------------------------------------------------------------
C   If CMD = 0 transfer N copies of the char C to the output buffer.
C   Write the buffer when already full or when CMD = 1.
C   Inputs:
C      CMD     INTEGER  0 - transfer 1 char to output buffer.
C                       1 - write out the buffer.
C      C       CHAR*1   the character to be transferred.
C      N       INTEGER  repitition count for char C.
C   Outputs:
C      S       CHAR*256  the output buffer
C-----------------------------------------------------------------------
      INTEGER CMD, LO, N
      CHARACTER C*1
      INTEGER FD, IR, IC, IO, I
      LOGICAL EOFLG
      CHARACTER B(36)*80, S*256, TPNAM*24
      COMMON /CTRLC/ B, S, TPNAM
      COMMON /CTRLI/ FD, IR, IC, IO, EOFLG
C-----------------------------------------------------------------------
      LO = 4
      IF (CMD.EQ.0) THEN
         DO 10 I = 1,N
            IF (IO.LT.256) THEN
               IO = IO + 1
               S(IO:IO) = C
            ELSE
               WRITE (LO,'(A)') S(1:IO)
               IO = 1
               S = ' '
               S(IO:IO) = C
               END IF
 10         CONTINUE
      ELSE
         WRITE (LO,'(A)') S(1:IO)
         S = ' '
         IO = 0
         END IF
C
 999  RETURN
      END
      SUBROUTINE RDTP (IERR)
C-----------------------------------------------------------------------
C   Read an AIPS FITS tape into the 2880 char array in commons.
C   Inputs:
C      FD     the integer file descriptor in commons.
C      EOFLG  end of file logical flag.
C   Outputs:
C      B      the CHAR*2880 array in commons is the buffer.
C      EOFLG  the end of file flag in commons(coordinates EOF/EOV).
C      IERR   the integer return code
C             0  - no problems
C             1  - first end of file mark for the current file.
C             2  - end of volume. (two consecutive EOF's).
C             3  - not 2880 blocks or some other i/o error.
C-----------------------------------------------------------------------
      INTEGER IERR, NBYTE
      INTEGER FD, IR, IC, IO
      LOGICAL EOFLG
      CHARACTER B(36)*80, S*256, TPNAM*24
      COMMON /CTRLC/ B, S, TPNAM
      COMMON /CTRLI/ FD, IR, IC, IO, EOFLG
C-----------------------------------------------------------------------
      CALL ZTAPIO ('READ', 24, TPNAM, FD, 2880, NBYTE, B, IERR)
      IERR = 0
      IF (NBYTE.GT.0) THEN
         EOFLG = .FALSE.
         IF (NBYTE.NE.2880) IERR = 3
      ELSE
         IERR = 1
         IF (EOFLG) IERR = 2
         EOFLG = .TRUE.
         END IF
C
 999  RETURN
      END
      SUBROUTINE SPCIAL ()
C-----------------------------------------------------------------------
C   The escape char "!" has been read. Read the next character and take
C   the action indicated by it.
C      !!         =  a single exclamation point.
C      !,         =  tab (DEC 8-col convention).
C      !;         =  newline.
C      !+         =  form feed  ( = newline for now).
C      !.         =  end of information for current file.
C      !c - !f    =  3 to 26 blanks.
C      !A - !Z    =  27 to 52 blanks
C-----------------------------------------------------------------------
      INTEGER N, LO, IP
      INTEGER FD, IR, IC, IO, IERR, NR
      LOGICAL EOFLG
      CHARACTER B(36)*80, S*256, TPNAM*24
      COMMON /CTRLC/ B, S, TPNAM
      COMMON /CTRLI/ FD, IR, IC, IO, EOFLG
      DATA LO /4/
C-----------------------------------------------------------------------
C                                       get next character
      CALL GNXT (0, IP, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       what to do
      IF (B(IR)(IC:IC) .EQ. ';') THEN
         CALL PNXT (1, ' ', 1)
      ELSE IF (B(IR)(IC:IC) .EQ. '.') THEN
         IF (IO.GT.0) CALL PNXT (1, ' ', 1)
         CLOSE (LO)
         IC = 999
      ELSE IF (B(IR)(IC:IC) .EQ. '+') THEN
         CALL PNXT (1, ' ', 1)
      ELSE IF (B(IR)(IC:IC) .EQ. ',') THEN
         NR = MOD(IO, 8)
         N = 8 - NR
         CALL PNXT (0, ' ', N)
      ELSE IF (B(IR)(IC:IC) .EQ. '!') THEN
         CALL PNXT (0, '!', 1)
      ELSE
         CALL NBLNK (B(IR)(IC:IC), N)
         CALL PNXT (0, ' ', N)
         END IF
      GO TO 999
C                                       error exit
 900  WRITE (6,'('' SPCIAL: ERROR FROM GNXT ='', I6)') IERR
C
 999  RETURN
      END
      SUBROUTINE NBLNK (X, NBLNKS)
C-----------------------------------------------------------------------
C   Decode the number of blanks to be inserted.
C-----------------------------------------------------------------------
      INTEGER NX, NC, NZ, NUA, NUZ, NBLNKS
      CHARACTER X
C-----------------------------------------------------------------------
      NX = ICHAR(X)
      NC = ICHAR('c')
      NZ = ICHAR('z')
      NUA = ICHAR('A')
      NUZ = ICHAR('Z')
C
      IF ((NC.LE.NX) .AND. (NX.LE.NZ)) THEN
         NBLNKS = NX -NC + 3
      ELSE IF ((NUA.LE.NX) .AND. (NX.LE.NUZ)) THEN
         NBLNKS = NX - NUA + 27
      ELSE
         NBLNKS = 1
         END IF
C
 999  RETURN
      END
C***********************************************************************
C               UNIX Z ROUTINES
C***********************************************************************
      SUBROUTINE ZFLOPN (LO, FNA, IERR)
C-----------------------------------------------------------------------
C   ZFLOPN creates a text file of name FNA (includes full directory path
C   as well as the file name and extension) and opens it with UNIT = LO.
C   Note: this is a Z routine because FNA is expressed in UNIX notation
C   and may be inappropriate for other systems.
C   UNIX version
C-----------------------------------------------------------------------
      INTEGER LO, IERR
      CHARACTER FNA*80
C-----------------------------------------------------------------------
      IERR = 0
C                                       open it
C                                       no name conversion needed
      OPEN (UNIT=LO, FILE=FNA, STATUS='NEW', ERR=950)
      GO TO 999
C                                       Error
 950  IERR = 1
C
 999  RETURN
      END
C***********************************************************************
C
C THE SOURCE CODE FOR THE UNIX C VERSIONS OF ZTAPIO & ZCRDIR FOLLOWS:
C
C-----------------------------------------------------------------------
C #include <stdio.h>
C #include <sys/types.h>
C #include <sys/stat.h>
C #define MAXL 80
C
C zcrdir_(len, name, ierr)
C /*------------------------------------------------------------------*/
C /*! create the specified disk directory                             */
C /*# IO-basic                                                        */
C /*   This software is the subject of a User agreement and is        */
C /*   confidential in nature. It shall not be sold or otherwise made */
C /*   available or disclosed to third parties.                       */
C /*------------------------------------------------------------------*/
C /*  Create the directory specified in the character string "name".  */
C /*  Inputs:                                                         */
C /*     len    I       string length of name (at least to last char) */
C /*     name   C*(*)   directory name                                */
C /*  Output:                                                         */
C /*     ierr   I       Error code:                                   */
C /*                       0  directory already existed or creation ok*/
C /*                       1  if exists but is not a directory        */
C /*                       2  if creation failed                      */
C /*------------------------------------------------------------------*/
C int *ierr, *len ;
C char name[] ;
C {
C    char st[100], nam[MAXL];
C    int i, mlen, ret;
C    struct stat stbuf;
C
C    mlen = (len > MAXL) ? MAXL : len;
C    for (i=0; i < mlen; i++) {
C       if (name[i] != ' ')
C          nam[i] = name[i];
C       else
C          nam[i] = '\0';
C       }
C
C    ret = stat(nam, &stbuf);
C    if (ret == 0) {
C       if (stbuf.st_mode & 0040000)
C          *ierr = 0;
C       else
C          *ierr = 1;
C       }
C    else {
C       sprintf(st,"mkdir %s",nam);
C       *ierr = system(st);
C       if (*ierr != 0)
C          *ierr = 2;
C       }
C
C    return;
C }
C-----------------------------------------------------------------------
C ztapio_(oper, ln, name, fd, bytreq, bytread, buf, syserr)
C --------------------------------------------------------------------*/
C ! tape operations for IMPFIT (compressed FITS transport tape)       */
C # Tape                                                              */
C   This software is the subject of a User agreement and is           */
C   confidential in nature. It shall not be sold or otherwise made    */
C   available or disclosed to third parties.                          */
C --------------------------------------------------------------------*/
C   tape operations for IMPFIT (compressed FITS transport tape)       */
C   Inputs:                                                           */
C      oper     C*4    'OPEN', 'READ', 'CLOS'                         */
C      name     C*(*)  physical file name                             */
C      bytreq   I      bytes to be read                               */
C      ln       I      length of name                                 */
C   In/out:                                                           */
C      fd       I(*)   file descriptor (set on OPEN, else used)       */
C   Output:                                                           */
C      bytread  I      Bytes read on READ                             */
C      buf      I(*)   Data buffer read                               */
C      syserr   I      System error code                              */
C   Generic UNIX version.                                             */
C --------------------------------------------------------------------*/
C int *ln, *fd, *bytreq, *bytread, *syserr;
C char oper[], name[], buf[];
C --------------------------------------------------------------------*/
C {
C    char nam[65], op[5];
C    int i;
C    extern int errno ;
C --------------------------------------------------------------------*/
C                                         /* get operation */
C    for (i=0; (i < 4) && (oper[i] != ' '); i++)
C       op[i] = oper[i];
C    op[i] = '\0';
C
C    errno = 0 ;
C    if (strcmp (op, "READ") == 0) {
C       *bytread = read(*fd,buf,*bytreq);
C       }
C
C    else if (strcmp (op, "OPEN") == 0) {
C       for (i=0; (i < *ln) && (name[i] != ' ') ; i++)
C          nam[i] = name[i];
C       nam[i] = '\0';
C       *fd = open (nam, 0);
C       }
C
C    else if (strcmp (op, "CLOS") == 0) {
C       close (*fd);
C       }
C
C    *syserr = errno ;
C
C    return;
C }
C-----------------------------------------------------------------------
C***********************************************************************
C            Samples for other systems should go here too
C***********************************************************************

      SUBROUTINE ZDHPRL (NVAL, NP, INB, OUTB)
C-----------------------------------------------------------------------
C! convert 64-bit HP floating buffer to local DOUBLE PRECISION values
C# Z Binary
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Converts from 64 bit Hewitt-Packard floating format to local double
C   precision.
C      HP R*8 format:
C                1         2         3         4         5         6
C      0123456789012345678901234567890123456789012345678901234567890123
C      smmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmnnnnnnnnnnnnnnnnnnnnnnnneeeeeeez
C   The value can be determined as follows:
C      man1 = smmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm is a two's complement
C             signed integer.
C      man2 = nnnnnnnnnnnnnnnnnnnnnnnn is a POSITIVE unsigned integer.
C      exp = zeeeeeee is a two's complement signed integer.
C      value = (man1 * 16777216 + man2) * 2.0D0 ** (exp - 55)
C   Inputs:
C      NVAL   I      Number of values to convert
C      NP     I      First value in INB to convert
C      INB    D(*)   64-bit HP format values
C   Output:
C      OUTB   D(*)   Local format values.
C   Generic version; should work on any machine.
C-----------------------------------------------------------------------
      INTEGER   NVAL, NP
      DOUBLE PRECISION INB(*), OUTB(*)
C
      INTEGER   LOOP, NB, L24, L32, IEXP, IEX, IEXMAX, ITEMP(4), IESIGN
      DOUBLE PRECISION HPV8, MAN, F32, F24, DFLOAT
      DATA IEXMAX /72/
C-----------------------------------------------------------------------
      NB = NP
      DO 500 LOOP = 1,NVAL
         HPV8 = 0.0D0
C                                       mantissa (msb)
         CALL ZI32IL (1, 1, INB(NB), ITEMP)
         L32 = ITEMP(1)
C                                       (lsb)
         CALL ZI8IL (4, 5, INB(NB), ITEMP)
         L24 = (ITEMP(1) * 65536) + (ITEMP(2) * 256) + ITEMP(3)
         F32 = DFLOAT (L32)
         F24 = DFLOAT (L24)
C                                       This really is right!
         MAN = F32 * 16777216.0D0  + F24
         IF (MAN.NE.0.0D0) THEN
C                                       exponent
            IEXP = ITEMP(4) / 2
C                                       exponent sign
            IESIGN = ITEMP(4) - (ITEMP(4)/2) * 2
            IF (IESIGN.NE.0) IEXP = IEXP - 128
C                                       Correct for radix point in
C                                       mantessa.
            IEX = IEXP - 55
C                                       Set to zero when an overflow
C                                       occures.
            IF (IEX.GT.IEXMAX) GO TO 490
            HPV8 = MAN * (2.0**IEX)
            END IF
 490     NB = NB + 1
         OUTB(LOOP) = HPV8
 500     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE SDTCRD (ICARD, FITBLK, MAXKEY, NUMKEY, KEYWRD, KEYVAL,
     *   KEYCHR, KEYTYP, WARN, NRCX)
C-----------------------------------------------------------------------
C! Parse 'SINGLDSH' FITS table headers, get some keywords.
C# Parsing FITS SDish Tape IO-appl EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SDTCRD process a 'SINGLDSH' FITS table entry and return keywords
C   and values for selected keywords.  Receiver dependent values will
C   have the last two characters of the keyword replaced with the
C   receiver number.
C   Inputs:
C      ICARD    I        the card image (1-36) in FITS data block.
C      FITBLK   C*2880   the block of FITS header cards.
C      MAXKEY   I        maximum number of keywords allowed.
C   Input/Output:
C      NUMKEY   I        The number of keywords already in KEYVAL.
C      KEYWRD   C(*)*8   Keywords
C      KEYVAL   D(*)     List of arbitrary numeric, keyword values:
C                           KEYVAL(n) => Value in D.
C      KEYCHR   C(*)*8   List of character keyword values.
C      KEYTYP   I(*)     Type code: 1=>Double, 2=>single, 3=>char.
C                           4=>integer, 5=>logical
C      WARN     L        True if user needs to be warned about
C                           exceeding MAXKEY.
C      NRCX     I        Current receiver number.
C-----------------------------------------------------------------------
      CHARACTER FITBLK*(*), KEYWRD(*)*8, KEYCHR(*)*8
      INTEGER   ICARD, MAXKEY, NUMKEY, KEYTYP(*), NRCX
      LOGICAL   WARN
      DOUBLE PRECISION KEYVAL(*)
C
      CHARACTER SYMBOL*8, SNGDSH*8, SDWORD(34)*8, CARD*80, ITEMP*2
      INTEGER   NSD, NSDCOM, TABNO, IERR, INC, ITYP, I, NPNT, LIM1, IP
      INCLUDE 'INCS:DMSG.INC'
      DATA SNGDSH /'SINGLDSH'/
C                                       Recognized single dish keywords
C                                       Receiver dependent ones follow
C                                       'RCVR' which must be no.
C                                       NSDCOM+1
      DATA NSD, NSDCOM /34,26/
      DATA SDWORD      /'SCAN    ', 'UTDATE  ', 'HOURUT  ',
     *   'CYCLLEN ', 'EPOCH   ', 'TELESCOP', 'OBSERVER',
     *   'OBJECT  ', 'SAMPRAT ', 'EPOCRA  ', 'EPOCDEC ',
     *   'ORIENT  ', 'EXPT1   ', 'EXPT2   ', 'EXPT3   ',
     *   'EXPT4   ', 'BFWHM   ', 'OFFSCAN ', 'VELOCTY ',
     *   'VELDEF  ', 'FRONTEND', 'PTCON1  ', 'PTCON2  ',
     *   'PTCON3  ', 'INDX    ', 'INDY    ',
     *   'RCVR    ', 'OBSFREQ ', 'CALVOLTS', 'TCAL    ',
     *   'RHO     ', 'THETA   ', 'POLARIZ ', 'BW      '/
C-----------------------------------------------------------------------
      INC = (ICARD - 1) * 80 + 1
C                                       Verify Single dish
      IF (FITBLK(INC:INC+7).NE.SNGDSH) GO TO 999
C                                       get new card.
      CARD = FITBLK(INC:INC+79)
C                                       Get keyword (3rd item)
      NPNT = 19
      CALL GETSYM (CARD, NPNT, SYMBOL, ITYP)
C                                       Make sure = is there
      IF (ITYP.NE.0) GO TO 999
C                                       Search for recognized keyword
C                                       Shorter search if in rcx
C                                       dependent.
      LIM1 = 1
      IF (NRCX.GT.1) LIM1 = NSDCOM+1
      DO 100 I = LIM1,NSD
         TABNO = I
         IF (SYMBOL.EQ.SDWORD(I)) GO TO 110
 100     CONTINUE
C                                       No match
      GO TO 999
C                                       Match - Check keyword limit
 110  IF (NUMKEY.LT.MAXKEY) THEN
         CALL GETKEY (SYMBOL, CARD, NPNT, NUMKEY, KEYWRD, KEYVAL,
     *      KEYCHR, KEYTYP, IERR)
C                                       Check valid type - ignore
C                                       invalid ones.
         IF ((KEYTYP(NUMKEY).LE.0) .OR. (KEYTYP(NUMKEY).GT.5)) THEN
            WRITE (MSGTXT,1001) SYMBOL
            CALL MSGWRT (6)
            NUMKEY = NUMKEY - 1
            GO TO 999
            END IF
C                                       Blew limit
      ELSE
         IF (WARN) THEN
            WRITE (MSGTXT,1002) MAXKEY
            CALL MSGWRT (6)
            WARN = .FALSE.
            END IF
         GO TO 999
         END IF
      IF (TABNO.LE.NSDCOM) GO TO 900
C                                       Handle receiver dependent
C                                       keywords
      IF (TABNO.EQ.(NSDCOM+1)) THEN
C                                       Receiver number - save
         NRCX = KEYVAL(NUMKEY) + 0.1
         IF (NRCX.GT.99) NRCX = 99
C                                       Drop as keyword
         NUMKEY = NUMKEY - 1
         GO TO 999
         END IF
C                                       Add rcx no. to keyword.
      WRITE (ITEMP,1100) NRCX
C                                       Trim off blanks
      CALL CHTRIM (KEYWRD(NUMKEY), 8, KEYWRD(NUMKEY), IP)
      IP = IP + 1
      IF (IP.GT.7) IP = 7
      KEYWRD(NUMKEY)(IP:IP+1) = ITEMP(1:2)
      GO TO 999
C                                       Tell scan number
 900  IF (TABNO.EQ.1) THEN
         WRITE (MSGTXT,1900) KEYVAL(NUMKEY)
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1001 FORMAT ('SDTCRD: KEYWORD ',A8,' OF INDETERMINATE DATA TYPE')
 1002 FORMAT ('SDTCRD: BLEW NO. OF KEYWORD LIMIT OF ',I5,' IGNORE REST')
 1100 FORMAT (I2.2)
 1900 FORMAT ('Scan number =',F10.0)
      END

LOCAL INCLUDE 'UVSIM.INC'
C                                       Local include for UVSIM
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   NMAX
      PARAMETER (NMAX = 100)
      INTEGER   CATBLK(256), SEQOUT, DISKO, NUMHIS, JBUFSZ, N
      HOLLERITH XINFIL(12), XNAMOU(3), XCLAOU(2)
      CHARACTER INFILE*48, NAMOUT*12, CLAOUT*6,
     *   HISCRD(NMAX+11)*64
      REAL      XSOUT, XDISO, APARM(10), BUFFER(UVBFSS)
      DOUBLE PRECISION SITELA, DELTA, HMIN, HMAX, ELMIN, BLKMAX,
     *   TAU, BLKREJ, FREQNM, LX(NMAX), LY(NMAX), LZ(NMAX), DIAM(NMAX)
      COMMON /BUFRS/ BUFFER, JBUFSZ
      COMMON /INPARM/ XINFIL, XNAMOU, XCLAOU, XSOUT, XDISO,
     *   APARM, SEQOUT, DISKO, NUMHIS
      COMMON /CHRCOM/ INFILE, NAMOUT, CLAOUT, HISCRD
      COMMON /MAPHDR/ CATBLK
      COMMON /FRED/ SITELA, DELTA, HMIN, HMAX, ELMIN, BLKMAX, TAU,
     *   LX, LY, LZ, DIAM, BLKREJ, FREQNM, N
LOCAL END
      PROGRAM UVSIM
C-----------------------------------------------------------------------
C! Simulates uv coverage of an arbitrary interferometer array.
C# UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999-2000, 2003, 2007, 2009, 2012, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVSIM creates an AIPS uv data base and fills with simulated data.
C   See the UVSIM EXPLAIN file or Going AIPS for better descriptions
C   of the UV data file and catalog header structure and the contents
C   and structure of the antenna (AN) table.
C   There are sufficient comments in NEWHED to describe simple cases.
C   See Going AIPS for assistance in compiling and linking this task
C   onn your system.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INFILE         INFILE        Input file name. (antenna info.)
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is source name
C      OUTCLASS       CLAOUT        Class of the output uv file.
C                                   Default 'UVDATA'
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      APARM(10)      APARM         User specified array.
C                                   1:  nominal frequency  (optional)
C                                   2:  nominal wavelength      "
C                                   3-4: Bx of array
C                                   5-6: By of array
C                                   7-8: Bz of array
C   Programmer W. D. Cotton and F. R. Schwab, March 1988.
C   Updated by A. J. Mioduszewski, March 2003
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'UVSIM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'UVSIM '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL UVFILN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Get the array parameters and
C                                       write antenna table.
      CALL ANTFIL
C                                       Calculate and write out UV data
      CALL GETUV (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL FILHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE UVFILN (PRGN, JERR)
C-----------------------------------------------------------------------
C   UVFILN gets input parameters for UVSIM and creates an output file.
C   Inputs:  PRGN    C*6       Program name
C   Output:  JERR    I         Error code: 0 => ok
C                                4 => error creating output file.
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in UVSIM for more details.
C
C-----------------------------------------------------------------------
      CHARACTER PRGN*6, OLDNAM*12, DEFNAM*12
      HOLLERITH CATH(256)
      INTEGER  JERR, IERR, IROUND, NPARM
      REAL      CATR(256)
      INCLUDE 'UVSIM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATR, CATH, CATBLK)
      DATA DEFNAM /'UV DATA FILE'/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 51
      CALL GTPARM (PRGN, NPARM, RQUICK, XINFIL, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 10
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
C                                       Characters
 10   CALL H2CHR (48, 1, XINFIL, INFILE)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       Get other input
      CALL GETINP (IERR)
      IF (IERR.NE.0) JERR = IERR
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFFER, IERR)
      IF (JERR.NE.0) GO TO 999
C                                       Crunch input parameters.
      SEQOUT = IROUND (XSOUT)
      DISKO = IROUND (XDISO)
C                                       Create new header.
      CALL NEWHED (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Get uv header info and
C                                       verify header structure.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Put new values in CATBLK.
C                                       Get naming defaults
      OLDNAM = DEFNAM
      CALL MAKOUT (OLDNAM, '      ', 0, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
C                                       Image type ='UV'
      CALL CHR2H (2, 'UV', KHPTYO, CATH(KHPTY))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      CCNO = 1
      CALL UVCREA (DISKO, CCNO, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 70
         WRITE (MSGTXT,1050) IERR
         JERR = 4
         GO TO 990
 70   NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = 2
C                                       Get SEQ. no. used.
      SEQOUT = CATBLK(KIIMS)
      JERR = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVFILN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE GETUV (IRET)
C-----------------------------------------------------------------------
C   GETUV reads uv data one point at a time from the user supplied
C   routine FIDDLE and then writes the data.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER OFILE*48
      INTEGER   IRET, IPTRO, LUNO, LENBU, IA1, IA2, NIOUT, INDO, LRECO,
     *   KBIND, VO, BO, NUMVIS, XCOUNT
      LOGICAL   T, F
      INCLUDE 'UVSIM.INC'
C                                       Local variables
      DOUBLE PRECISION H, ANBMAX(NMAX), AZ, EL, PARANG, FI, FJ, TWOPI,
     *   UANT(NMAX), VANT(NMAX), WANT(NMAX), SITELO, TIME, GSTIAT
      REAL      U, V, W
      INTEGER   I, J
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANT.INC'
      DATA LUNO /16/
      DATA VO, BO, LENBU /0, 1, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Convert GSTIA0 to rad/day
      GSTIAT=GSTIA0*4.0D0*ATAN(1.0)/180.0D0
C                                       Calculate site lat and long(east)
      IF(ARRAYC(1) .NE. 0.0D0) THEN
         SITELO = -ATAN2(-ARRAYC(2),ARRAYC(1))
         SITELA = SQRT (ARRAYC(1)*ARRAYC(1) + ARRAYC(2)*ARRAYC(2))
         SITELA = ATAN2 (ARRAYC(3), SITELA)
         WRITE (MSGTXT,1160) SITELA/3.14159265*180.0D0
         CALL MSGWRT (9)
      ELSE
         WRITE (MSGTXT,1170)
         CALL MSGWRT (9)
         WRITE (MSGTXT,1175)
         CALL MSGWRT (9)
      ENDIF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.LE.0) GO TO 20
         WRITE (MSGTXT,1000) IRET
         GO TO 990
C                                       Init vis file for write
C                                       LRECO = length of output rec.
 20   LRECO = LREC
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, LENBU, JBUFSZ,
     *   BUFFER, BO, KBIND, IRET)
      IF (IRET.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) IRET
         GO TO 990
 30   IPTRO = KBIND
      NIOUT = 0
      NUMVIS = 0
      XCOUNT = 0
      TWOPI = 8.0D0 * ATAN (1.0D0)
      H = HMIN - TAU
 40   H = H + TAU
      IF (H.LE.HMAX) THEN
         DO 50 I = 1,N
            ANBMAX(I) = 0.0D0
 50         CONTINUE
         CALL GETANG (H, DELTA, SITELA, AZ, EL, PARANG)
         IF (EL.GE.ELMIN) THEN
            CALL UVANT (H, DELTA, N, LX, LY, LZ, UANT, VANT, WANT)
            DO 70 I = 1,N-1
               DO 60 J = I+1,N
                  CALL BLOCK (I, J, UANT, VANT, WANT, DIAM, FI, FJ)
                  ANBMAX(I) = MAX (ANBMAX(I), FI)
                  ANBMAX(J) = MAX (ANBMAX(J), FJ)
 60               CONTINUE
 70            CONTINUE
            DO 90 I = 1,N-1
               DO 80 J = I+1,N
                  IF ((ANBMAX(I).LE.BLKREJ) .AND.
     *               (ANBMAX(J).LE.BLKREJ)) THEN
                     U = (UANT(I)-UANT(J)) * FREQNM/2.997924562D8
                     V = (VANT(I)-VANT(J)) * FREQNM/2.997924562D8
                     W = (WANT(I)-WANT(J)) * FREQNM/2.997924562D8
                     NUMVIS = NUMVIS+1
                     IF(ARRAYC(1) .NE. 0.0D0) THEN
                        TIME = (H-GSTIAT-SITELO) * 360.0D0/TWOPI/DEGPDY
                     ELSE
                        TIME = 1.5D0 + H/TWOPI/1.00274D0
                     ENDIF
                     BUFFER(IPTRO+ILOCU) = U
                     BUFFER(IPTRO+ILOCV) = V
                     BUFFER(IPTRO+ILOCW) = W
                     BUFFER(IPTRO+ILOCT) = 1.D0 + TIME
                     IA1 = I
                     IA2 = J
                     BUFFER(IPTRO+NRPARM) = 1.0
                     BUFFER(IPTRO+NRPARM+1) = 0.0
                     BUFFER(IPTRO+NRPARM+2) = 1.0
                     BUFFER(IPTRO+ILOCA1) = IA1
                     BUFFER(IPTRO+ILOCA2) = IA2
                     BUFFER(IPTRO+ILOCSA) = 1.0
                     XCOUNT = XCOUNT + 1
                     IPTRO = IPTRO + LRECO
                     NIOUT = NIOUT + 1
                     CALL UVDISK('WRIT',LUNO,INDO,BUFFER,NIOUT,KBIND,
     *                  IRET)
                     IPTRO = KBIND
                     NIOUT = 0
                     END IF
 80               CONTINUE
 90            CONTINUE
            END IF
         GO TO 40
         END IF
C                                       Do history file entries:
      NUMHIS = N + 11
      WRITE (HISCRD(1),2001) N
      WRITE (HISCRD(2),2002) DELTA/TWOPI*360.0D0
      WRITE (HISCRD(3),2003) HMIN/TWOPI*48.0D0, HMAX/TWOPI*48.0D0
      WRITE (HISCRD(4),2004) TAU/TWOPI*86400.0D0
      WRITE (HISCRD(5),2005) ELMIN/TWOPI*360.0D0
      WRITE (HISCRD(6),2006) BLKREJ
      WRITE (HISCRD(7),2007) SITELA/TWOPI*360.0D0
      WRITE (HISCRD(8),2008) FREQNM
      WRITE (HISCRD(9),2009) 2.997924562D8/FREQNM
      WRITE (HISCRD(10),2012)
      WRITE (HISCRD(11),2010)
      DO  200 I = 1,N
         WRITE (HISCRD(I+11),2011) I, LX(I), LY(I), LZ(I), DIAM(I)
 200     CONTINUE
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFFER, NIOUT, KBIND, IRET)
      IF (IRET.EQ.0) GO TO 210
         WRITE (MSGTXT,1150) IRET
         GO TO 990
C                                       Compress output file.
 210  NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close file
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('GETUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1150 FORMAT ('GETUV: ERROR',I3,' WRITING VIS FILE')
 1160 FORMAT ('SITE LATITUDE HAS BEEN RECALULATED. NEW LAT=',F10.5)
 1170 FORMAT ('THE TIME STAMPS IN THE DATAFILE ARE INCORRECT')
 1175 FORMAT ('FOR CORRECT TIME STAMPS INPUT APARM(3-8)')
 2001 FORMAT (' Number of antennas:  ',I3)
 2002 FORMAT (' Declination:  ',F10.5,' degrees')
 2003 FORMAT (' Hour-angle coverage:  ',F10.5,' to ',F10.5,' hours')
 2004 FORMAT (' Integration time:  ',F10.3,' seconds')
 2005 FORMAT (' Minimum allowed elevation angle:  ',F10.5,' degrees')
 2006 FORMAT (' Maximum allowed fractional blockage:  ',F10.5)
 2007 FORMAT (' Site latitude:  ',F20.14,' degrees')
 2008 FORMAT (' Nominal frequency:  ',1PE20.12,' Hz')
 2009 FORMAT (' Nominal wavelength:  ',1PE20.12,' meters')
 2010 FORMAT (' Antenna x-y-z coordinates and diameters (all in ',
     *   'meters):')
 2011 FORMAT (I3,3G16.7,G12.5)
 2012 FORMAT (' Points are spaced at uniform time increments.')
      END
      SUBROUTINE FILHIS
C-----------------------------------------------------------------------
C   FILHIS creates and fills a history file.
C-----------------------------------------------------------------------
      CHARACTER   HILINE*72, ATIME*8, ADATE*12, LABEL*8, TELE*8, OBSR*8
      HOLLERITH CATH(256)
      INTEGER   LUN, I, IERR, TIME(3), DATE(3)
      REAL      CATR(256)
      DOUBLE PRECISION CATD(128)
      LOGICAL   T
      INCLUDE 'UVSIM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATBLK, CATH, CATR, CATD)
      DATA LUN /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Create/open hist. file.
      CALL HICREA (LUN, DISKO, CCNO, CATBLK, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 999
C                                       Get current date/time.
 10   CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
C                                       Write first record.
      WRITE (HILINE,1010) TSKNAM, NLUSER, ADATE, ATIME
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       New history
      WRITE (HILINE,1011) TSKNAM, INFILE
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN,
     *   BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       SOURCE
      WRITE (HILINE,2000) TSKNAM, SOURCE
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       Number of visibilities
      WRITE (HILINE,2001) TSKNAM, CATBLK(KIGCN)
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       Telescope, observer name.
      CALL H2CHR (8, 1, CATH(KHTEL), TELE)
      CALL H2CHR (8, 1, CATH(KHOBS), OBSR)
      WRITE (HILINE,2002) TSKNAM, TELE, OBSR
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       AIPS release
      WRITE (HILINE,2003) TSKNAM, RLSNAM
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                      Add any other history.
      IF (NUMHIS.LE.0) GO TO 20
         WRITE (LABEL,1015) TSKNAM
         DO 15 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 20
 15         CONTINUE
C                                       Close HI file
 20   CALL HICLOS (LUN, T, BUFFER, IERR)
C                                       Update CATBLK.
      CALL CATIO ('UPDT', DISKO, CCNO, CATBLK, 'REST', BUFFER, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FILHIS: ERROR',I3,' CREATE/OPEN HISTORY FILE')
 1010 FORMAT (A6,'/ Image created by user',I5,' at ',A12,2X,A8)
 1011 FORMAT (A6,'INFILE =''',A,'''')
 1015 FORMAT (A6,' /')
 2000 FORMAT (A6,' SOURCE = ''',A8,'''')
 2001 FORMAT (A6,' / Number of visibilities copied=',I9)
 2002 FORMAT (A6,' / Telescope = ',A8,' Observer = ',A8)
 2003 FORMAT (A6,' RELEASE = ''',A7,' ''')
      END
      SUBROUTINE ANTFIL
C-----------------------------------------------------------------------
C   ANTFIL creates and fills the antenna file.
C-----------------------------------------------------------------------
      HOLLERITH CATH(256)
      INTEGER   IERR, VER, LUN, I
      REAL      CATR(256)
      DOUBLE PRECISION JD, GMSTM, GASTM, RATE
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'UVSIM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATH, CATR)
      DATA LUN /27/
C-----------------------------------------------------------------------
C                                       Make sure there is antenna info
      IF (N.LE.0) GO TO 999
C                                       Setup for AN table initization
         NUMORB = 0
         NOPCAL = 2
         ANTNIF = 1
C                                       Position of the earth's pole
         POLRXY(1) = 0.0
         POLRXY(2) = 0.0
         UT1UTC = 0.0
         DATUTC = 0.0
         TIMSYS = 'UTC'
C                                       Array name
         ANAME = '        '
C                                       Array center (rel to center of
C                                       earth)
         ARRAYC(1) = APARM(3)+APARM(4)
         ARRAYC(2) = APARM(5)+APARM(6)
         ARRAYC(3) = APARM(7)+APARM(8)
C                                       Get GST0 and Earth rotation rate
         CALL H2CHR (8, 1, CATH(KHDOB), RDATE)
         CALL JULDAY (RDATE, JD)
         CALL GSTROT (JD, GMSTM, GASTM, RATE)
         GSTIA0 = GMSTM
         DEGPDY = RATE
         SAFREQ = FREQ
         ANFQID = -1
         VER = 1
         XYZHAN = ' '
         TFRAME = ' '
C                                       Create/init file
         CALL ANTINI ('WRIT', BUFFER, DISKO, CCNO, VER, CATBLK, LUN,
     *      IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *      RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *      TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       init basic AN record
         ANNAME = ' '
         STAXOF = 0.0
         STAXYZ(1) = 0.0D0
         STAXYZ(2) = 0.0D0
         STAXYZ(3) = 0.0D0
         ORBPRM(1) = 0.0D0
         NOSTA = 0
         MNTSTA = 0
         POLAA = 0.0
         POLAB = 0.0
         CALL RFILL (3, 0.0, POLCA)
         CALL RFILL (3, 0.0, POLCB)
         POLTYA = 'R'
         POLTYB = 'L'
         DIAMAN = 0.0
         CALL RFILL (MAXIF, 0.0, FWHMAN)
C                                       AN records
         DO 20 I = 1,N
            STAXYZ(1) = LX(I)
            STAXYZ(2) = LY(I)
            STAXYZ(3) = LZ(I)
            NOSTA = I
            IANRNO = I
            CALL TABAN ('WRIT', BUFFER, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
            IF (IERR.NE.0) GO TO 990
 20         CONTINUE
C                                       Fill in header and close
         CALL TABIO ('CLOS', 1, IANRNO, ANNAME, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 990
         GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1020) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('ERROR ',I3,' OCCURED WRITING ANTENNA FILE')
      END
      SUBROUTINE NEWHED (IRET)
C-----------------------------------------------------------------------
C   NEWHED is a routine in which the catalog header is constructed.
C   Necessary values can be read in in the areas markes "USER CODE
C   GOES HERE".
C
C   NOTE: the AIPS convention for the coordinate reference value
C   for the STOKES axis is that 1,2,3,4 represent I, Q, U, V
C   stokes' parameters and -1,-2,-3,-4 represent RR, LL, RL and
C   LR correlator values.  Currently set for R and L polarization
C   ie Ref. value = -1 and increment = -1.
C
C   The MINIMUM information required here is that
C   required to define the size of the output file; ie.
C      CATBLK(KIGCN)   = I   number of visibility records
C      CATBLK(KIPCN) = Number of random parameters.
C      CATBLK(KIDIM)= the number of axes,
C      CATBLK(KINAX+i) = the dimension of each axis.
C    Input:
C     CATBLK(256)    I     Output catalog header, also CATR, CATD
C                          The OUTNAME, OUTCLASS, OUTSEQ are entered
C                          elsewhere.
C    Output:
C     CATBLK(256)    I     Modified output catalog header.
C     IRET           I     Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER RTYPES(9)*8, TYPES(7)*8, UNITS*8, OBSDAT*8,
     *   TELE*8, OBSR*8, INSTR*8
      HOLLERITH CATH(256)
      INTEGER   I, NAXIS, NRAN, NCHAN, NPOLN, NDIM(7), INDEX, IRET,
     *   XCOUNT
      REAL      CATR(256), CRPIX(7), CRINC(7), BANDW, EPOCH
      DOUBLE PRECISION    CATD(128), CRVAL(7), TWOPI
      INCLUDE 'UVSIM.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE  (CATBLK, CATH, CATR, CATD)
C                                       User definable values
C                                       Random parameters.
C                                         No. random parameters.
      DATA NRAN /7/
C                                         Rand. parm. names.
      DATA RTYPES /'UU-L', 'VV-L', 'WW-L', 'TIME1', 'SUBARRAY',
     *   'ANTENNA1', 'ANTENNA2', 2*' '/
C                                       Uniform axes.
C                                         No. axes.
      DATA NAXIS /5/
C                                         Axes names.
      DATA TYPES /'COMPLEX ','STOKES  ','FREQ    ',
     *   'RA      ','DEC     ',2*'        '/
C                                         Axis dimensions
      DATA NDIM /3,1,1,1,1,0,0/
C                                         Reference values
      DATA CRVAL /1.0D0, -1.0D0, 5*0.0D0/
C                                         Reference pixel.
      DATA CRPIX /7*1.0/
C                                         Coordinate increment.
      DATA CRINC /1.0, -1.0, 0.0, 0.0, 0.0, 2*0.0/
C                                       Epoch of position.
      DATA EPOCH /2000.0/
C                                       Units
      DATA UNITS /'JY      '/
C                                       "Observing" date
      DATA OBSDAT /'20000101'/
C-----------------------------------------------------------------------
C                                       Zero fill CATBLK
      CALL CATINI (CATBLK)
C                                       Fill axis arrays.
C                                       Random axis names
      DO 10 I = 1,NRAN
         INDEX = KHPTP + (I-1) * 2
         CALL CHR2H (8, RTYPES(I), 1, CATH(INDEX))
 10      CONTINUE
C                                       Uniform axes
      DO 30 I = 1,KICTPN
C                                       Init dimension
         CATBLK(KINAX+I-1) = NDIM(I)
C                                       Init. increment.
         CATR(KRCIC+I-1) = CRINC(I)
C                                       Init. rotation.
         CATR(KRCRT+I-1) = 0.0
C                                       Init. ref pixel.
         CATR(KRCRP+I-1) = CRPIX(I)
C                                       Init. ref value.
         CATD(KDCRV+I-1) = CRVAL(I)
C                                       Fill axis type from
C                                       TYPES
         INDEX = KHCTP + (I-1) * 2
         CALL CHR2H (8, TYPES(I), 1, CATH(INDEX))
 30      CONTINUE
C                                       Fill in values.
C                                       Fill other character strings.
C                                       Source name
      SOURCE = ' '
C                                       Telescope.
      TELE = ' '
C                                       Receiver
      INSTR = ' '
C                                       Observer's name.
      OBSR = ' '
C                                       Set number of axes.
      CATBLK(KIDIM) = NAXIS
      CATBLK(KIPCN) = NRAN
C                                       User ID
      CATBLK(KIIMU) = NLUSER
C                                       Miscellaneous items.
C                                       Epoch.
      CATR(KREPO) = EPOCH
C                                       Convolving beam
      CATR(KRBMJ) = 0.0
      CATR(KRBMN) = 0.0
      CATR(KRBPA) = 0.0
      CATBLK(KINIT) = 0
C                                       Max. min.
      CATR(KRDMX) = 0.0
      CATR(KRDMN) = 0.0
C                                       Shift
      CATR(KRXSH) = 0.0
      CATR(KRYSH) = 0.0
C                                       "Old" (observed) position.
      CATD(KDORA) = 0.0D0
      CATD(KDODE) = 0.0D0
C                                       Rest Frequency
      CATD(KDRST) = 0.0D0
C                                       Alternate ref. value & pixel
      CATD(KDARV) = 0.0D0
      CATR(KRARP) = 0.0
      CATBLK(KIALT) = 0
C                                       Sort order ('**'=>unsorted)
      CALL CHR2H (2, 'TB', 1, CATH(KITYP))
C                                       No magic value blanking.
      CATR(KRBLK) = 0.0
C                                       Units
      CALL CHR2H (8, UNITS, 1, CATH(KHBUN))
C-----------------------------------------------------------------------
C                                       Enter values for data:
C                                       XCOUNT = number of vis. record.
C                                       RA = Right ascension (1950)
C                                          in degrees.
C                                       DEC = Declination in degrees.
C                                       FREQ = frequency of obs in Hz.
C                                       BANDW = bandwidth or channel
C                                           separation.
C                                       NCHAN = Number of freq chan.
C                                       NPOLN = number of polarization
C                                            correlators.
C                                       OBSDAT = Reference date of time
C                                          tags for data as "yyyymmdd"
C                                       SOURCE = source name (8 char)
C                                       TELE = telescope name (8 char)
C                                       INSTR = Receiver name (8 char)
C                                       OBSR = Observers name (8 char)
      FREQ = 1.0D0
      BANDW = 0.0
      NCHAN = 1
      NPOLN = 1
      TWOPI = 8.0D0 * ATAN (1.0D0)
C                                       Figure out file size:
      XCOUNT = ((HMAX-HMIN) / TAU + 1.0D0) * (N * (N-1) / 2)
      RA = 0.0D0
      DEC = DELTA / TWOPI * 360.0D0
C                                       Use a nominal wavelength of 1mm
C                                       if both APARM(1) and APARM(2)
C                                       are less than or equal to zero.
C                                       Otherwise, if APARM(1) is
C                                       greater than zero then use a
C                                       nominal frequency of APARM(1)
C                                       Hz; otherwise, if APARM(2) is
C                                       greater than zero then use a
C                                       nominal wavelength of APARM(2)
C                                       meters:
      IF ((APARM(1).LE.0.0) .AND. (APARM(2).LE.0.0)) THEN
         FREQNM = 299.7924562D9
      ELSE
         IF (APARM(1).GT.0.) THEN
            FREQNM = APARM(1)
         ELSE
            FREQNM = 2.997924562D8 / APARM(2)
            END IF
         END IF
      FREQ = FREQNM
C                                       Insert values in header.
C                                       Number of vis.
      CATBLK(KIGCN) = XCOUNT
C                                       Position.
      CATD(KDCRV+3) = RA
      CATD(KDCRV+4) = DEC
C                                       Frequency
      CATD(KDCRV+2) = FREQ
C                                       Bandwidth.
      CATR(KRCIC+2) = BANDW
C                                       Number of frequencies.
      CATBLK(KINAX+2) = NCHAN
C                                       Number of polarizations.
      CATBLK(KINAX+1) = NPOLN
C                                       Observing date.
      CALL CHR2H (8, OBSDAT, 1, CATH(KHDOB))
C                                       Object.
      CALL CHR2H (8, SOURCE, 1, CATH(KHOBJ))
C                                       Telescope.
      CALL CHR2H (8, TELE, 1, CATH(KHTEL))
C                                       Receiver
      CALL CHR2H (8, INSTR, 1, CATH(KHINS))
C                                       Observer's name.
      CALL CHR2H (8, OBSR, 1, CATH(KHOBS))
C
C                                       Finished.
      IRET = 0
C
 999  RETURN
      END
      SUBROUTINE GETINP (IERR)
C-----------------------------------------------------------------------
C   Routine to ask user for information
C   Input from common:  INFILE  C*48 File name.
C   Output: IERR                I    Return code 0=>OK
C-----------------------------------------------------------------------
      CHARACTER PHNAME*48, LINE*80
      INTEGER   IERR
      INTEGER   LUN, FIND, NBYTES, KBP
      DOUBLE PRECISION    X, TWOPI, A, B
      LOGICAL   T, F
      INCLUDE 'UVSIM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      TWOPI = 8.0D0 * ATAN(1.0D0)
      N = 0
C                                       Read antenna info from file
      CALL GETANT (INFILE, N, LX, LY, LZ, DIAM, SITELA, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Ask user for info.
C                                       Defaults
      DELTA = 45.0
      HMIN = -6.0
      HMAX = 6.0
      ELMIN = 10.0
      TAU = 60.0
      BLKREJ = 0.0
C                                       Open terminal
      LUN = 5
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, F, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
C                                       Declination
 100  WRITE (LINE,2000)
      NBYTES = 72
      CALL ZTTYIO ('WRIT', LUN, FIND, NBYTES, LINE, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL ZTTYIO ('READ', LUN, FIND, NBYTES, LINE, IERR)
      IF (IERR.EQ.3) GO TO 100
      IF (IERR.NE.0) GO TO 970
C                                       Decode LINE
      KBP = 1
      CALL GETNUM (LINE, NBYTES, KBP, X)
      IF (X.EQ.DBLANK) GO TO 975
      DELTA = X
      WRITE (LINE,2001) DELTA
      NBYTES = 72
      CALL ZTTYIO ('WRIT', LUN, FIND, NBYTES, LINE, IERR)
      IF (IERR.NE.0) GO TO 970
      DELTA = TWOPI * DELTA / 360D0
C                                       Hour angle range
 150  WRITE (LINE,2002)
      NBYTES = 72
      CALL ZTTYIO ('WRIT', LUN, FIND, NBYTES, LINE, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL ZTTYIO ('READ', LUN, FIND, NBYTES, LINE, IERR)
      IF (IERR.EQ.3) GO TO 150
      IF (IERR.NE.0) GO TO 970
C                                       Decode LINE
      KBP = 1
      CALL GETNUM (LINE, NBYTES, KBP, X)
      IF (X.EQ.DBLANK) GO TO 975
      A = X
      CALL GETNUM (LINE, NBYTES, KBP, X)
      IF (X.EQ.DBLANK) GO TO 975
      B = X
      WRITE (LINE,2003) A, B
      NBYTES = 72
      CALL ZTTYIO ('WRIT', LUN, FIND, NBYTES, LINE, IERR)
      IF (IERR.NE.0) GO TO 970
      HMIN = MIN (A,B) * TWOPI / 24.0D0
      HMAX = MAX (A,B) * TWOPI / 24.0D0
C                                       Elevation limit
 200  WRITE (LINE,2004)
      NBYTES = 72
      CALL ZTTYIO ('WRIT', LUN, FIND, NBYTES, LINE, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL ZTTYIO ('READ', LUN, FIND, NBYTES, LINE, IERR)
      IF (IERR.EQ.3) GO TO 200
      IF (IERR.NE.0) GO TO 970
C                                       Decode LINE
      KBP = 1
      CALL GETNUM (LINE, NBYTES, KBP, X)
      IF (X.EQ.DBLANK) GO TO 975
      ELMIN = X
      WRITE (LINE,2005) ELMIN
      NBYTES = 72
      CALL ZTTYIO ('WRIT', LUN, FIND, NBYTES, LINE, IERR)
      IF (IERR.NE.0) GO TO 970
      ELMIN = TWOPI * ELMIN / 360.0D0
C                                       Integration time
 250  WRITE (LINE,2006)
      NBYTES = 72
      CALL ZTTYIO ('WRIT', LUN, FIND, NBYTES, LINE, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL ZTTYIO ('READ', LUN, FIND, NBYTES, LINE, IERR)
      IF (IERR.EQ.3) GO TO 250
      IF (IERR.NE.0) GO TO 970
C                                       Decode LINE
      KBP = 1
      CALL GETNUM (LINE, NBYTES, KBP, X)
      IF (X.EQ.DBLANK) GO TO 975
      TAU = X
      WRITE (LINE,2007) TAU
      NBYTES = 72
      CALL ZTTYIO ('WRIT', LUN, FIND, NBYTES, LINE, IERR)
      IF (IERR.NE.0) GO TO 970
      TAU = TAU * TWOPI / 86400.0D0
C                                       Blockage limit
 300  WRITE (LINE,2008)
      NBYTES = 72
      CALL ZTTYIO ('WRIT', LUN, FIND, NBYTES, LINE, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL ZTTYIO ('READ', LUN, FIND, NBYTES, LINE, IERR)
      IF (IERR.EQ.3) GO TO 300
      IF (IERR.NE.0) GO TO 970
C                                       Decode LINE
      KBP = 1
      CALL GETNUM (LINE, NBYTES, KBP, X)
      IF (X.EQ.DBLANK) GO TO 975
      BLKREJ = X
      WRITE (LINE,2009) BLKREJ
      NBYTES = 72
      CALL ZTTYIO ('WRIT', LUN, FIND, NBYTES, LINE, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Close terminal
      CALL ZCLOSE (LUN, FIND, IERR)
      GO TO 999
C                                       ZTTYIO write error
 970  WRITE (MSGTXT,1970) IERR
      GO TO 990
 975  MSGTXT = 'NUMBER PARSING ERROR ONN ' // LINE
      IERR = 1
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETINP: ERROR',I3,' OPENING TERMINAL FOR INSTRUCTIONS')
 1970 FORMAT ('GETINP: ERROR',I3,' WRITING TO TERMINAL')
 2000 FORMAT ('Type source declination, in degrees:')
 2001 FORMAT ('Source declination = ',F8.4,' degrees')
 2002 FORMAT ('Type the two extremes of the hour-angle coverage, in',
     *   ' hours:')
 2003 FORMAT ('Hour-angle coverage is',F9.4,' hours to ',F8.4,' hours.')
 2004 FORMAT ('What is the minimum allowable elevation angle, in deg.?')
 2005 FORMAT ('Minimum elevation angle=',F8.4,' degrees.')
 2006 FORMAT ('Specify the integration time, in seconds.')
 2007 FORMAT ('Integration time=',F12.4,' seconds.')
 2008 FORMAT ('What is the maximum allowable fractional blockage of',
     *   ' an antenna?')
 2009 FORMAT ('Maximum fractional blockage=',F8.4)
      END
      SUBROUTINE GETANT (FILE, N, LX, LY, LZ, DIAM, SITELA, IERR)
C-----------------------------------------------------------------------
C  This subroutine reads, from an input file specified by name "fln",
C  the antenna information.
C  The first (ascii) data record should specify n, the number of
C  elements.
C  The second data record should specify the site latitude, in degrees.
C  The third record must specify two conversion factors: first,
C  a multiplicative factor for converting antenna coordinates to meters,
C  and, second, a factor for converting antenna diameters to meters.
C  (E.g., if the station coordinates are in nanoseconds and the antenna
C  diameters are in feet, then the two factors that need to be supplied
C  are 0.2997924562 (approximately) and 0.3048 (exactly).)
C  Then, n records must follow, each with four numbers:  the three
C  earth-based Cartesian coordinates of the antenna location, and the
C  antenna diameter.
C   Inputs:
C    FILE     C*48  File name
C   Outputs:
C    N        I     Number of antennas
C    LX(*)    D     "X" coordinate of antennas (m)
C    LY(*)    D     "Y" coordinate of antennas (m)
C    LZ(*)    D     "Z" coordinate of antennas (m)
C    DIAM(*)  D     Antenna diameters (m)
C    SITELA   D     Site latidude (rad?)
C    IERR     I     Return code, 0=>OK
C-----------------------------------------------------------------------
      CHARACTER FILE*48
      INTEGER   N, IERR
      DOUBLE PRECISION LX(*), LY(*), LZ(*), DIAM(*), SITELA
      INTEGER   LUN, FIND, NBYTES, KBP, I, JT, JTRIM
      LOGICAL   F
      CHARACTER LINE*80
      DOUBLE PRECISION CONST1, CONST2, X
      INCLUDE 'INCS:DMSG.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                       Open text file
      LUN = 10
      CALL ZTXOPN ('READ', LUN, FIND, FILE, F, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1001)
         GO TO 990
         END IF
C                                       Get number of antennas
      CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
      IF (IERR.NE.0) GO TO 980
      JT = JTRIM (LINE)
C                                       Get value
      KBP = 1
      NBYTES = 80
      CALL GETNUM (LINE, NBYTES, KBP, X)
      N = X + 0.1
C                                       Tell user
      WRITE (MSGTXT,2000) N
      CALL MSGWRT (6)
C                                       get site latitude
      CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
      IF (IERR.NE.0) GO TO 980
      JT = JTRIM (LINE)
C                                       Get value
      KBP = 1
      CALL GETNUM (LINE, NBYTES, KBP, X)
      SITELA = X
C                                       Tell user
      WRITE (MSGTXT,2001) SITELA
      CALL MSGWRT (6)
      SITELA = SITELA * ATAN (1.0D0) / 45.0D0
C                                       Get conversion constants
      CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
      IF (IERR.NE.0) GO TO 980
      JT = JTRIM (LINE)
C                                       Get values
      KBP = 1
      CALL GETNUM (LINE, NBYTES, KBP, X)
      CONST1 = X
      CALL GETNUM (LINE, NBYTES, KBP, X)
      CONST2 = X
C                                       Tell user
      WRITE (MSGTXT,2002) CONST1
      CALL MSGWRT (6)
      WRITE (MSGTXT,2003) CONST2
      CALL MSGWRT (6)
C                                       Read antenna info
      DO 100 I = 1,N
         CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
         IF (IERR.NE.0) GO TO 980
         JT = JTRIM (LINE)
C                                       Get values
         KBP = 1
         CALL GETNUM (LINE, NBYTES, KBP, X)
         LX(I) = X * CONST1
         CALL GETNUM (LINE, NBYTES, KBP, X)
         LY(I) = X * CONST1
         CALL GETNUM (LINE, NBYTES, KBP, X)
         LZ(I) = X * CONST1
         CALL GETNUM (LINE, NBYTES, KBP, X)
         DIAM(I) = X * CONST2
         WRITE (MSGTXT,2004) I, LX(I), LY(I), LZ(I), DIAM(I)
         CALL MSGWRT (6)
 100     CONTINUE
      CALL ZTXCLS (LUN, FIND, IERR)
      GO TO 999
C                                       Read error
 980  WRITE (MSGTXT,1980) IERR
      GO TO 990
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1001 FORMAT ('ERROR ',I3,' OPENING ANTENNA INFO TEXT FILE')
 1980 FORMAT ('ERROR ',I3,' READING ANTENNA INFO TEXT FILE')
 2000 FORMAT ('Number of antennas = ',I4)
 2001 FORMAT ('Site latitude = ',F8.3,' degrees')
 2002 FORMAT ('Coordinate conversion factor to meters =',1PE12.5)
 2003 FORMAT ('Diameter conversion factor to meters =',1PE12.5)
 2004 FORMAT ('Ant(',I2,')=',1PE13.5,2E13.5,', dia=',0PF7.2,' m')
      END
      SUBROUTINE GETANG (H, DELTA, SLAT, AZ, EL, PARANG)
C-----------------------------------------------------------------------
C   Given the hour-angle h, the source declination delta, and the
C   geographic latitude, slat, of the site, this subroutine computes
C   the azimuth, the elevation, and the parallactic angle.
C   Inputs:
C    H        D    Hour angle (rad)
C    DELTA    D    Source declination (rad)
C    SLAT     D    Site latitude (rad)
C   Outputs:
C    AZ       D    Azimuth (rad)
C    EL       D    Elevation (rad)
C    PARANG   D    Parallactic angle (rad)
C-----------------------------------------------------------------------
      DOUBLE PRECISION H, DELTA, SLAT, AZ, EL, PARANG
      DOUBLE PRECISION PI, Z, SINQ, COSQ, SINA, COSA
C-----------------------------------------------------------------------
      PI = 4.0D0 * ATAN (1.0D0)
      Z = ACOS (SIN (DELTA) * SIN (SLAT) + COS (DELTA) * COS (SLAT) *
     *   COS (H))
      EL = PI / 2.0D0 - Z
      IF (Z.EQ.0D0) THEN
         PARANG = 0.0D0
         AZ = 0.0D0
      ELSE
         SINQ = SIN (H) * COS (SLAT) / SIN (Z)
         COSQ = SIN (SLAT) / SIN (Z) / COS (DELTA) - TAN (DELTA) /
     *      TAN (Z)
         PARANG = ATAN2 (SINQ, COSQ)
         SINA = -COS (DELTA) * SIN (H) / SIN (Z)
         COSA = (SIN (DELTA) * COS (SLAT) - COS (DELTA) * COS (H) *
     *      SIN (SLAT)) / SIN (Z)
         AZ = ATAN2 (SINA, COSA)
         IF (AZ.LT.0.0D0) AZ = AZ + 2.0D0 * PI
         END IF
C
 999  RETURN
      END
      SUBROUTINE BLOCK (I, J, UANT, VANT, WANT, DIAM, FI, FJ)
C-----------------------------------------------------------------------
C  Subroutine to compute geometric shadowing.
C  Given i and j, antenna-based (u,v,w), and the antenna diameters,
C  this subroutine computes the fractional blockage fi of antenna i by
C  antenna j, and the fractional blockage fj of antenna j by antenna i.
C  Whenever blockage occurs, if w<0 then it is the case that antenna j
C  is blocked by antenna i, if w>0 then antenna i has been blocked by
C  antenna j, and if w = 0 then the antennas have run into each other.
C  So generally, on return, one - but not both - of fi and fj may be
C  nonzero.
C  The antenna profiles are assumed to be circular, and the antennas
C  are assumed to be pointed the same way (a reasonably valid
C  assumption for the case of a compact array configuration, which
C  is the only case where one generally worries about shadowing).
C   Inputs:
C    I       I    First antenna number
C    J       I    Second antenna number
C    UANT(*) D    Array of U values (m)
C    VANT(*) D    Array of V values (m)
C    WANT(*) D    Array of W values (m)
C    DIAM(*) D    Array of diameters (m)
C   Outputs:
C    FI      D    Fractional blockage of antenna I
C    FJ      D    Fractional blockage of antenna J
C-----------------------------------------------------------------------
      INTEGER   I, J
      DOUBLE PRECISION    UANT(*), VANT(*), WANT(*), DIAM(*), FI, FJ
      DOUBLE PRECISION    PI, U, V, W, SEP, RMIN, RMAX, SINA, SINB,
     *   AREA, S, C, A, B
C-----------------------------------------------------------------------
      PI = 4.0D0 * ATAN(1.0D0)
      U = UANT(J)-UANT(I)
      V = VANT(J)-VANT(I)
      W = WANT(J)-WANT(I)
      SEP = SQRT (U**2 + V**2)
      RMIN = 0.5D0 * MIN (DIAM(I), DIAM(J))
      RMAX = 0.5D0 * MAX (DIAM(I), DIAM(J))
      IF (SEP.GE.RMIN+RMAX) THEN
         FI = 0.0D0
         FJ = 0.0D0
      ELSE IF (SEP+RMIN.LE.RMAX) THEN
         FI = MIN (1.0D0, (DIAM(J) / DIAM(I))**2)
         FJ = MIN (1.0D0, (DIAM(I) / DIAM(J))**2)
      ELSE
         C = SEP / (0.5D0*DIAM(I))
         S = DIAM(J) / DIAM(I)
         SINB = SQRT ((S+C+1.0D0) * (S+C-1.0D0) * (S-C+1.0D0) *
     *      (C-S+1.0D0)) / (2.0D0*C)
C  Or,
C        SINB = SQRT(2D0*((C*S)**2+C**2+S**2)-C**4-S**4-1D0)/(2D0*C)
C
         SINA = SINB / S
C                                       Due to roundoff, sina or sinb
C                                       might be ever so slightly larger
C                                       than 1. In the case of unequal
C                                       radii, with the center of one
C                                       antenna pattern inside the
C                                       other:
         SINB = MIN (1.0D0, SINB)
         SINA = MIN (1.0D0, SINA)
C
         B = ASIN (SINB)
         A = ASIN (SINA)
         AREA = (S**2*A+B) - (S**2*SINA*COS (A)+SINB*COS (B))
         FI = AREA / PI
         FJ = FI / S**2
      END IF
      IF (W.LT.0.0D0) FI = 0.0D0
      IF (W.GT.0.0D0) FJ = 0.0D0
 999  RETURN
      END
      SUBROUTINE UVANT (H, DELTA, N, LX, LY, LZ, UANT, VANT, WANT)
C-----------------------------------------------------------------------
C  Given the hour-angle h, the source declination delta, the number
C  of elements n, and the element locations (lx(i),ly(i),lz(i)),
C  i = 1,...,n, this subroutine computes the antenna-based spatial
C  frequency coordinates (uant(i),vant(i),want(i)), i = 1,...,n.
C   Inputs:
C    H        D    Hour angle (rad)
C    DELTA    D    Source declination (rad)
C    N        I    Number of antennas
C    LX(*)    D    "X" component of antenna position (m)
C    LY(*)    D    "Y" component of antenna position (m)
C    LZ(*)    D    "Z" component of antenna position (m)
C   Outputs:
C    UANT(*)  D    "U" component of project coordinate (m)
C    VANT(*)  D    "V" component of project coordinate (m)
C    WANT(*)  D    "W" component of project coordinate (m)
C-----------------------------------------------------------------------
      INTEGER   N
      DOUBLE PRECISION H, DELTA, LX(*), LY(*), LZ(*), UANT(*),
     *   VANT(*), WANT(*)
      INTEGER   I
      DOUBLE PRECISION SH, CH, SD, CD
C-----------------------------------------------------------------------
      SH = SIN (H)
      CH = COS (H)
      SD = SIN (DELTA)
      CD = COS (DELTA)
      DO 100 I = 1,N
         UANT(I) = SH * LX(I) + CH * LY(I)
         VANT(I) = -SD * (CH * LX(I) - SH * LY(I)) + CD * LZ(I)
         WANT(I) = CD * (CH * LX(I) - SH * LY(I)) + SD * LZ(I)
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE QPERMA (A, LDA, N, M, IOPT, IP, WK)
C-----------------------------------------------------------------------
C! permutes rows or columns of matrix according to permutation vector
C# Sort Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   QPERMA permutes either the rows or the columns of an NxM real*4
C   matrix, A, according to a user-supplied permutation vector IP.
C   When IOPT is less than or equal to zero, the column ordering is
C   permuted, otherwise the row order.
C   Input:
C      LDA    I          the leading dimension of A
C      N      I          number of rows in A
C      M      I          number of columns in A (must be <=LDA)
C      IOPT   I          > 0 implies permutation of column ordering
C                        <=0 implies permutation of row ordering
C      IP     I(N or M)  the permutation vector.
C   In/out:
C      A      R(M,N)     the matrix
C   Output:
C      WK     R(M or N)  a work array
C-----------------------------------------------------------------------
      INTEGER   LDA, M, N, IOPT
      LONGINT   IP(*)
      DOUBLE PRECISION A(LDA,N), WK(*)
C
      INTEGER   IPTR, K, I, L, LN, LM, LOOP
C-----------------------------------------------------------------------
      LN = N
      LM = M
      IPTR = 0
C                                       Permute rows
      IF (IOPT.GT.0) GO TO 100
 10      IPTR = IPTR + 1
            IF (IPTR.GE.LN) GO TO 999
            IF ((IP(IPTR).EQ.0) .OR. (IP(IPTR).EQ.IPTR)) GO TO 10
C                                       Save row at IPTR
               K = IPTR
               DO 20 LOOP = 1,LM
                  WK(LOOP) = A(LOOP,K)
 20               CONTINUE
C                                       Move row to destination
C                                       Look for place to put row in WK
 30            L = IP(K)
               IF (L.EQ.IPTR) GO TO 50
               DO 40 LOOP = 1,LM
                  A(LOOP,K) = A(LOOP,L)
 40               CONTINUE
                  IP(K) = 0
                  K = L
                  GO TO 30
C                                       Have place for row in WK
 50            DO 60 LOOP = 1,LM
                  A(LOOP,K) = WK(LOOP)
 60               CONTINUE
               IP(K) = 0
               GO TO 10
C-----------------------------------------------------------------------
C                                       Permute columns
 100  CONTINUE
         IPTR = IPTR + 1
            IF (IPTR.GE.LM) GO TO 999
            IF ((IP(IPTR).EQ.0) .OR. (IP(IPTR).EQ.IPTR)) GO TO 100
C                                       save col at IPTR
               K = IPTR
               DO 120 I = 1,LN
                  WK(I) = A(K,I)
 120              CONTINUE
C                                       move col to output area
C                                       look for col saved in WK
 130           L = IP(K)
               IF (L.EQ.IPTR) GO TO 150
                  DO 140 I = 1,LN
                     A(K,I) = A(L,I)
 140                 CONTINUE
                  IP(K) = 0
                  K = L
                  GO TO 130
C                                       Move col initially at IPTR
 150           DO 160 I = 1,LN
                  A(K,I) = WK(I)
 160              CONTINUE
               IP(K) = 0
               GO TO 100
C
 999  RETURN
      END

      SUBROUTINE TABFC (OPCODE, BUF, IFCRNO, FCKOLS, FCNUMV, FLGTIM,
     *   FLGANT, FLGSOR, FLGCHN, FLGIF, FLGSTK, FLGSUB, FLGFQ, FLGNUM,
     *   FLGOP, FLGIT, DTYPE, DTIMES, DFLUXS, FLGREA, IERR)
C-----------------------------------------------------------------------
C! REads/writes FC (Flag Command) tables used by OOP EDIT class
C# EXT-util UV Calibration OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1996, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   creates and/or opens for writing (and reading) a specified FC table
C   for Flag Commands from OOP EDIT class
C   Inputs:
C      OPCODE   C*4      READ or WRIT (create only if none previously)
C      FCKOLS   I(11)    Column pointers
C      FCNUMV   I(11)    Coumn counts
C   In/out: (basic)
C      IFCRNO   I        Record number
C      BUF      I(512)   TABIO control buffer
C   In/out: (refer to specific uv data to be flagged)
C      FLGTIM   R(2)     time range (days)
C      FLGANT   I(2)     antenna 1 (0 -> all), 2 (0 -> all w 1)
C      FLGSOR   I        source number (0 -> all)
C      FLGCHN   I(2)     channel number range
C      FLGIF    I(2)     IF number range
C      FLGSTK   C*4      Stokes flag pattern
C      FLGSUB   I        Subarray
C      FLGFQ    I        FQ id number
C      FLGREA   C*24     User reason for flag
C   In/out: (refer to general flag command in EDITA...)
C      FLGNUM   I        FC command number
C      FLGOP    C*8      flagging operation type
C      FLGIT    I(2)     Time range in editor pixels on "time" axis
C      DTYPE    C*8      Type of data referenced in FLGOP
C      DTIMES   R(2)     Time range referenced in FLGOP
C      DFLUXS   R(2)     Flux (or phase, Tsys, ..) range in FLGOP
C   Output:
C      IERR     I        Error codes from TABINI or TABIO
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, FLGOP*8, FLGSTK*4, DTYPE*8, FLGREA*24
      INTEGER   IFCRNO, FCKOLS(*), FCNUMV(*), BUF(512), FLGNUM,
     *   FLGANT(2), FLGSOR, FLGCHN(2), FLGIF(2), FLGSUB, FLGFQ,
     *   FLGIT(2), IERR
      REAL      FLGTIM(2), DTIMES(2), DFLUXS(2)
C
      INTEGER   NCOLS, NVALS
      PARAMETER (NCOLS = 15)
      PARAMETER (NVALS = 29)
      INTEGER   KOLS(NCOLS), NUMKOL, ANTKOL, SORKOL, CHNKOL, IFKOL,
     *   SUBKOL, FQKOL, OPKOL, STKKOL, TIMKOL, DATKOL, CLPKOL, DTSKOL,
     *   ITSKOL, REAKOL, RECI(NVALS)
      REAL      RECR(NVALS)
      HOLLERITH RECH(NVALS)
      EQUIVALENCE (RECR, RECI, RECH)
      EQUIVALENCE (KOLS(1), NUMKOL), (KOLS(2), OPKOL),
     *   (KOLS(3), TIMKOL), (KOLS(4), ANTKOL), (KOLS(5), SORKOL),
     *   (KOLS(6), CHNKOL), (KOLS(7), IFKOL), (KOLS(8), SUBKOL),
     *   (KOLS(9), FQKOL), (KOLS(10), STKKOL), (KOLS(11), DATKOL),
     *   (KOLS(12), CLPKOL), (KOLS(13), DTSKOL), (KOLS(14), ITSKOL),
     *   (KOLS(15), REAKOL)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Close
      IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, IFCRNO, RECR, BUF, IERR)
         IF (IERR.GT.0) GO TO 980
         GO TO 999
         END IF
C                                       local copy column pointers
      CALL COPY (NCOLS, FCKOLS, KOLS)
C                                       fill record
      IF (OPCODE.EQ.'WRIT') THEN
         RECI(NUMKOL)   = FLGNUM
         CALL CHR2H (8, FLGOP, 1, RECH(OPKOL))
         RECR(TIMKOL)   = FLGTIM(1)
         RECR(TIMKOL+1) = FLGTIM(2)
         RECI(ANTKOL)   = FLGANT(1)
         RECI(ANTKOL+1) = FLGANT(2)
         RECI(SORKOL)   = FLGSOR
         RECI(CHNKOL)   = FLGCHN(1)
         RECI(CHNKOL+1) = FLGCHN(2)
         RECI(IFKOL)    = FLGIF(1)
         RECI(IFKOL+1)  = FLGIF(2)
         RECI(SUBKOL)   = FLGSUB
         RECI(FQKOL)    = FLGFQ
         CALL CHR2H (4, FLGSTK, 1, RECH(STKKOL))
         CALL CHR2H (8, DTYPE, 1, RECH(DATKOL))
         RECR(CLPKOL)   = DFLUXS(1)
         RECR(CLPKOL+1) = DFLUXS(2)
         RECR(DTSKOL)   = DTIMES(1)
         RECR(DTSKOL+1) = DTIMES(2)
         RECI(ITSKOL)   = FLGIT(1)
         RECI(ITSKOL+1) = FLGIT(2)
         CALL CHR2H (24, FLGREA, 1, RECH(REAKOL))
         END IF
C                                       Process record.
 10   CALL TABIO (OPCODE, 0, IFCRNO, RECR, BUF, IERR)
      IFCRNO = IFCRNO + 1
      IF (IERR.GT.0) GO TO 980
C                                       If READ pick data from RECR.
      IF (OPCODE.EQ.'READ') THEN
         FLGNUM    = RECI(NUMKOL)
         CALL H2CHR (8, 1, RECH(OPKOL), FLGOP)
         FLGTIM(1) = RECR(TIMKOL)
         FLGTIM(2) = RECR(TIMKOL+1)
         FLGANT(1) = RECI(ANTKOL)
         FLGANT(2) = RECI(ANTKOL+1)
         FLGSOR    = RECI(SORKOL)
         FLGCHN(1) = RECI(CHNKOL)
         FLGCHN(2) = RECI(CHNKOL+1)
         FLGIF(1)  = RECI(IFKOL)
         FLGIF(2)  = RECI(IFKOL+1)
         FLGSUB    = RECI(SUBKOL)
         FLGFQ     = RECI(FQKOL)
         CALL H2CHR (4, 1, RECH(STKKOL), FLGSTK)
         CALL H2CHR (8, 1, RECH(DATKOL), DTYPE)
         DFLUXS(1) = RECR(CLPKOL)
         DFLUXS(2) = RECR(CLPKOL+1)
         DTIMES(1) = RECR(DTSKOL)
         DTIMES(2) = RECR(DTSKOL+1)
         FLGIT(1)  = RECI(ITSKOL)
         FLGIT(2)  = RECI(ITSKOL+1)
         CALL H2CHR (24, 1, RECH(REAKOL), FLGREA)
         END IF
      GO TO 999
C                                       Error
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('TABFC: TABIO ERROR',I3)
      END

LOCAL INCLUDE 'SHAHO.INC'
C                                       Local include for SHAHO
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   MXSOU
      PARAMETER (MXSOU = XSTBSZ)
C
      INTEGER   SEQ, DISK, LUN2, FIND2, FGVER, NFLAG, NID, ID(MXSOU),
     *   NUMAN(513), CNOIN, WFLAG, KUAL, IBUFF(UVBFSS)
      LOGICAL   MULTI, ISREF(MAXANT)
      HOLLERITH XNAME(3), XCLASS(2), XXSOUR(4,30)
      CHARACTER NAME*12, CLASS*6, XSOUR(30)*16, REASON*24, STOKES*4
      REAL      XSEQIN, XVIN, XANT(50), XFGVER, APARM(10), BUFF(UVBFSS)
      DOUBLE PRECISION JD0
      EQUIVALENCE (BUFF, IBUFF)
      INCLUDE 'INCS:DCAT.INC'
C
      COMMON /FLAGS/ NFLAG, NID, ID, NUMAN, WFLAG, KUAL, ISREF
      COMMON /BUFRS/ BUFF
      COMMON /INPARM/ XNAME, XCLASS, XSEQIN, XVIN, XXSOUR, XANT, XFGVER,
     *   APARM
      COMMON /CHRCOM/ NAME, CLASS, XSOUR, REASON, STOKES
      COMMON /FQCRAP/ JD0, SEQ, DISK, CNOIN, LUN2, FIND2, FGVER, MULTI
LOCAL END
      PROGRAM SHAHO
C-----------------------------------------------------------------------
C! Flag selected holography data for shadowing
C# UV Calibration Editing
C-----------------------------------------------------------------------
C;  Copyright (C) 2021-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task SHAHO flags selected portions of a uv data base.
C   Data either flagged directly or an entry is made in the flagging
C   table.
C   Inputs:
C      AIPS Adverb  Prg. Name      Description
C      INNAME       NAME        File name of data base to be flagged
C      INCLASS      CLASS       Input file class.
C      INSEQ        SEQ         Input file sequence number.
C      INDISK       DISK        Disk volumn on which file resides.
C      SOURCES      XSOUR(4,30) Names of sources specified.
C      TIMERANG     TIMER(8)    Time range
C      FLAGVER      FGVER       Flag file version.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'SHAHO.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA PRGM /'SHAHO '/
C-----------------------------------------------------------------------
C                                       Get inputs.
      CALL UVFGIN (PRGM, IRET)
      IF (IRET.GT.0) GO TO 990
C                                       Write history
      CALL UVFGHS
C                                       Close down
 990  CALL DIE (IRET, BUFF)
C
 999  STOP
      END
      SUBROUTINE UVFGIN (PRGM, IRET)
C-----------------------------------------------------------------------
C   UVFGIN does the startup bookeeping and reads the flagging table
C   from the specified text file if necessary.
C   Input:
C   PRGM       C*6  Task name.
C   Output:
C     IRET         I    Return error code, 0=> OK, otherwise failed.
C   Output to common /FLAGS/:
C     NFLAG        I   Number of flagging criteria in common.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
C                                       Max. no. of time intervals on
C                                       any given baseline for elev.
C                                       flagging.
      INTEGER   MXTIM
      PARAMETER (MXTIM = 10)
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NPARM, I, IERR, NSOUR, LUN, LUNAN, XA1, XA2, NBASE,
     *   MAXBAS, KBCH, KECH, KBIF, KEIF, NOCHAN, NOIF, IFGRNO, LUNFQ,
     *   SUBA, FQD, IFGVER, FGBUFF(512), IERANT
      REAL      STARTD, STOPD, SHMIN, CTMIN, FLAGT1, FLAGT2
      LOGICAL   WSBLNK, FGOPEN, T, F
      INCLUDE 'SHAHO.INC'
      INTEGER   FGKOLS(MAXFGC), FGNUMV(MAXFGC)
      CHARACTER UTYPE*2
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUN, LUNAN, LUNFQ /27, 30, 40/
      DATA MAXBAS /MXBASE/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IRET = 0
C                                       Init I/O
      CALL ZDCHIN (T)
      CALL VHDRIN
      LUN2 = 17
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      NFLAG = 0
      WFLAG = 0
C                                       Get input parameters.
      NPARM = 189
      IRET = 0
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAME, IBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         RQUICK = F
         IRET = 8
         GO TO 990
         END IF
C                                       Decode input.
      SEQ = XSEQIN + 0.1
      DISK = XVIN + 0.1
C                                       Characters
      CALL H2CHR (12, 1, XNAME, NAME)
      CALL H2CHR (6, 1, XCLASS, CLASS)
      REASON = 'Shadowing holography'
C
      WSBLNK = T
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
         IF (XSOUR(I).NE.' ') WSBLNK = F
 20      CONTINUE
      IF (WSBLNK) XSOUR(1) = 'HOLORASTER'
      STOKES = '1111'
      CALL LFILL (MAXANT, .FALSE., ISREF)
      DO 25 I = 1,50
         XA1 = XANT(I) + 0.1
         IF ((XA1.GT.0) .AND. (XA1.LE.MAXANT)) ISREF(XA1) = .TRUE.
 25      CONTINUE
C                                       Open file and get CATBLK.
C                                       open file non-excl to allow
C                                       a second open as well:
      UTYPE = 'UV'
      CALL MAPOPN ('HDWR', DISK, NAME, CLASS, SEQ, UTYPE, NLUSER, LUN2,
     *   FIND2, CNOIN, CATBLK, IBUFF, IERR)
      IF (IERR.GT.1) THEN
         WRITE (MSGTXT,1010) IERR
         RQUICK = F
         IRET = 8
         GO TO 990
         END IF
C                                       Mark in /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 1
C                                       Restart AIPS.
      IF (RQUICK) CALL RELPOP (IRET, IBUFF, IERR)
      IF (IRET.NE.0) GO TO 990
      IRET = 8
C                                       Get info from CATBLK.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Check if multi source file
      CALL MULSDB (CATBLK, MULTI)
C                                       Write table
      CALL FNDEXT ('FG', CATBLK, IFGVER)
      FGVER = XFGVER + 0.1
      IF (FGVER.LE.0) FGVER = MAX (1, IFGVER)
C                                       Get number(s) of antennas.
C                                       Since GETNAN will return
C                                       a reasonable default -
C                                       ignore error code.
      CALL GETNAN (DISK, CNOIN, CATBLK, LUNAN, IBUFF, NUMAN, IERANT)
C                                       Also get antenna names &
C                                       numbers
      SUBA = 1
      IF (IERANT.EQ.0) THEN
         CALL GETANT (DISK, CNOIN, SUBA, CATBLK, IBUFF, IERANT)
         IF (IERANT.NE.0) THEN
            WRITE (MSGTXT,1030) IERANT
            CALL MSGWRT (6)
            IRET = 7
            GO TO 999
            END IF
         END IF
C                                       If multi-source get numbers.
C                                       Set max. no sources named.
      NSOUR = 30
C                                       shadowing
      IF (APARM(5).LE.0.0) APARM(5) = 25.
C                                       Set max. no. sources sel.
      NID = 1
      ID(1) = 0
      IF (MULTI) THEN
         NID = MXSOU
         KUAL = -1
         CALL SOURNU (XSOUR, KUAL, NSOUR, DISK, CNOIN, NID, IBUFF, ID,
     *      IRET)
         IF (IRET.LT.0) THEN
            MSGTXT = 'SOURCE(S) NOT FOUND IN SU TABLE'
            CALL MSGWRT (7)
            IRET = 5
            END IF
         IF (IRET.NE.0) GO TO 999
         IF (NID.EQ.0) NID = 1
         END IF
C                                       IF, channel limits
      KBCH = 1
      NOCHAN = CATBLK(KINAX+JLOCF)
      KECH = NOCHAN
      IF (JLOCIF.GE.0) THEN
         NOIF = CATBLK(KINAX+JLOCIF)
         KBIF = 1
         KEIF = CATBLK(KINAX+JLOCIF)
      ELSE
         NOIF = 1
         KBIF = 1
         KEIF = 1
         END IF
C                                       Convert to baseline numbers.
C                                       Flagging on shadowing
      FQD = -1
      SHMIN = APARM(5) * CATD(KDCRV+JLOCF) / VELITE
      CTMIN = APARM(6) * CATD(KDCRV+JLOCF) / VELITE
      STARTD = 0.
      STOPD = 9999.
      CALL FLAGSH (LUN, FGBUFF, IFGRNO, FGKOLS, FGNUMV, SUBA,
     *   STARTD, STOPD, FQD, FGOPEN, SHMIN, CTMIN, IRET)
      IF (IRET.GT.0) GO TO 999
C                                       Close FG table
      IF (FGOPEN) THEN
         CALL FLAGUP ('CLOS', LUN, DISK, CNOIN, FGVER, FGBUFF,
     *      IFGRNO, FGKOLS, FGNUMV, ID, NID, SUBA, 1,
     *      NBASE, XA1, XA2, FLAGT1, FLAGT2, KBIF, KEIF, KBCH,
     *      KECH, STOKES, REASON, I, IRET)
         IF (WFLAG.LE.0) THEN
            WRITE (MSGTXT,1211) FGVER
            CALL MSGWRT (7)
         ELSE
            WRITE (MSGTXT,1210) WFLAG, FGVER
            CALL MSGWRT (4)
            END IF
C                                       Nothing was added to the FG
C                                       table
      ELSE
         WRITE (MSGTXT,1215) FGVER
         CALL MSGWRT (7)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR:',I7,'GETTING INPUT PARAMETERS')
 1010 FORMAT ('ERROR:',I7,' FINDING UV FILE')
 1030 FORMAT ('ERROR:',I3,' READING ANTENNA TABLE')
 1210 FORMAT ('Wrote ',I8,' flags to flag table version',I3)
 1211 FORMAT ('WARNING: DID NOT WRITE/CHANGE ANY RECORDS IN FG VERSION',
     *   I4)
 1215 FORMAT ('NOTHING WAS ADDED TO FG TABLE ',I3)
      END
      SUBROUTINE UVFGHS
C-----------------------------------------------------------------------
C   UVFGHS writes the flagging information in the history file
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, CTIME*8, CDATE*12
      INTEGER   IRET, LUNH, DATE(3), TIME(3)
      LOGICAL   T
      INCLUDE 'SHAHO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      DATA T /.TRUE./
      DATA LUNH /27/
C-----------------------------------------------------------------------
C                                       Open history file
      CALL HIINIT (2)
      CALL HIOPEN (LUNH, DISK, FCNO(1), IBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Write time and date on old file
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME, CDATE)
      WRITE (HILINE,1000) TSKNAM, RLSNAM, CDATE, CTIME
      CALL HIADD (LUNH, HILINE, IBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
      WRITE (HILINE,1012) TSKNAM, APARM(5), APARM(6)
      CALL HIADD (LUNH, HILINE, IBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
      WRITE (HILINE,1030) TSKNAM, FGVER
      CALL HIADD (LUNH, HILINE, IBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
      WRITE (HILINE,1031) TSKNAM, WFLAG
      CALL HIADD (LUNH, HILINE, IBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C
 100  CALL HICLOS (LUNH, T, IBUFF, IRET)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',A12,2X,A8)
 1012 FORMAT (A6,'MINBASLN=',F6.1,' ,',F6.1,'  / min baseline',
     *   ' shadow, crosstalk')
 1030 FORMAT (A6,'OUTFGVER=',I5,'  / output FG table version')
 1031 FORMAT (A6,'NFLAG =',I9,'   / number flag commands written')
      END
      SUBROUTINE FLAGSH (FGLUN, FGBUFF, IFGRNO, FGKOLS, FGNUMV, SUBA,
     *   STARTD, STOPD, FQID, FGOPEN, SHMIN, CTMIN, IRET)
C-----------------------------------------------------------------------
C   Updates the flag table (FG) to flag all shadowed data
C   Inputs:
C      FGLUN    I        Logical unit number to use
C      SUBA     I        Subarray number.
C      STARTD   R        Start of the data (days)
C      STOPD    R        Stop  of the data (days)
C      FQID     I        Freqid number
C      SHMIN    R        Min baseline in lambda at ref freq shadowing
C      CTMIN    R        Min baseline in lambda for cross talk
C   Input from common:
C      STOKES   C*4      Stokes parameter desired
C      DISK     I        Disk to use.
C      CNOIN    I        Catalog slot number
C      FGVER    I        FG file version
C      XANTS    R(50)    List of antennas
C   Input/Output:
C      FGBUFF   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      IFGRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      FGKOLS   I(8)     The column pointer array in order, SOURCE,
C                        SUBARRAY, ANTS, TIMERANG, IFS, CHANS, PFLAGS,
C                        REASON
C      FGNUMV   I(*)     Element count in each column.
C   Output:
C      FGOPEN   L        FG table was open
C      IRET     I        Error code, 0=>OK else TABIO error.
C                        Note: -1 => read, but record deselected.
C-----------------------------------------------------------------------
      INTEGER   FGLUN, FGBUFF(*), IFGRNO, FGKOLS(*), FGNUMV(*), SUBA,
     *   FQID, IRET
      REAL      STARTD, STOPD, SHMIN, CTMIN
      LOGICAL   FGOPEN
C
      CHARACTER FILE*48
      CHARACTER LREAS1*24, LREAS2*24, OPCODE*4
      INTEGER   SOUID, OLDSOU(2), IA1, IA2, IROUND, SID, XCOUNT, IVER,
     *   VO, BO, LENBU, NMCOR, ISUBA, LUNSS, LUNUV, LANT, JSUB, JSUB1,
     *   JSUB2, LFQID, NFL, NB, LA1, LA2, VCOUNT, CATSAV(256)
      LOGICAL   T, F
      REAL      TIME, TIMOLD, BLTEMP, TIMST, TIMEN, TINT, TDIF,
     *   RPARM(20)
      DOUBLE PRECISION DRA, DDEC
      INCLUDE 'SHAHO.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXB
      PARAMETER (MAXB = MAXANT*MAXANT)
      REAL      TBEG(MAXANT), TEND(MAXANT), TBB(MAXB), TBE(MAXB)
      LOGICAL   ANTBAD(MAXANT), BASBAD(MAXB), PLANET
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA LUNSS /25/
      DATA LUNUV, BO, VO /16, 1, 0/
C-----------------------------------------------------------------------
      OPCODE = 'FLAG'
      TINT = 0.09/24.0/3.6E3
      TDIF = TINT
      FGOPEN = .FALSE.
      LREAS1 = 'antenna shadowing'
      LREAS2 = 'possible cross-talk'
      IF (REASON.NE.' ') LREAS1 = REASON
      CALL FNDEXT ('AN', CATBLK, ISUBA)
      IF ((SUBA.GT.0) .AND. (SUBA.LE.ISUBA)) THEN
         JSUB1 = SUBA
         JSUB2 = SUBA
      ELSE
         JSUB1 = 1
         JSUB2 = ISUBA
         END IF
C                                       Open for Read.
      LENBU = 450
      LENBU = 0
      LFQID = 1
      IVER = 1
      CALL CATDIR ('CSTA', DISK, FCNO(1), NAME, CLASS, SEQ, 'UV',
     *   NLUSER, 'CLWR', BUFF, IRET)
      CALL ZPHFIL ('UV', DISK, FCNO(1), IVER, FILE, IRET)
C      CALL ZOPEN (LUNUV, FIND, DISK, FILE, T, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
      DO 200 JSUB = JSUB1,JSUB2
         WRITE (MSGTXT,1000) JSUB
         CALL MSGWRT (2)
         CALL SEDSEL (NAME, CLASS, SEQ, DISK, JSUB)
C                                       get antenna info this subarray
         CALL GETANT (DISK, CNOIN, JSUB, CATBLK, IBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1015) IRET, JSUB
            GO TO 990
            END IF
         CALL JULDAY (RDATE, JD0)
C                                       protect header
         CALL COPY (256, CATBLK, CATSAV)
         CALL UVGET ('INIT', RPARM, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1001) IRET, JSUB, 'OPEN FOR READ'
            CALL MSGWRT (6)
            GO TO 200
            END IF
         CALL COPY (256, CATSAV, CATBLK)
         CALL CATDIR ('CSTA', DISK, FCNO(1), NAME, CLASS, SEQ, 'UV',
     *      NLUSER, 'CLRD', BUFF, IRET)
         XCOUNT = 0
         VCOUNT = 0
         NMCOR = LREC - NRPARM
         NB = NSTNS * NSTNS
C                                       initialize the begin of flag
C                                       intervals
         CALL RFILL (MAXANT, -1000.0, TBEG)
         CALL RFILL (MAXB, -1000.0, TBB)
         CALL LFILL (NSTNS, .FALSE., ANTBAD)
         CALL LFILL (MAXB, .FALSE., BASBAD)
         TIMOLD = -1.E6
         OLDSOU(1) = -1
C                                       Start looping thru data.
C                                       Read buffer.
 50      XCOUNT = XCOUNT + 1
         CALL UVGET ('READ', RPARM, BUFF, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1001) IRET, JSUB, 'READING DATA'
            GO TO 990
         ELSE IF (IRET.EQ.0) THEN
            VCOUNT = VCOUNT + 1
            IF (MOD(VCOUNT,100000).EQ.0) THEN
               WRITE (MSGTXT,1055) VCOUNT
               CALL MSGWRT (2)
               END IF
C                                       Decode time.
            TIME = RPARM(1+ILOCT)
C                                       Determine FQ ID
            IF (ILOCFQ.GT.-1) LFQID = IROUND (RPARM(1+ILOCFQ))
C                                       Determine subarray
            IF (ILOCB.GE.0) THEN
               BLTEMP = RPARM(1+ILOCB)
               IA1 = BLTEMP / 256. + 0.1
               BLTEMP = BLTEMP - IA1 * 256
               IA2 = BLTEMP + 0.1
               ISUBA = 100.0 * (BLTEMP - IA2) + 1.5
            ELSE
               IA1 = RPARM(1+ILOCA1) + 0.1
               IA2 = RPARM(1+ILOCA2) + 0.1
               ISUBA = RPARM(1+ILOCSA) + 0.1
               END IF
C                                       check time range, etc
            IF ((TIME.GE.STARTD) .AND. (TIME.LE.STOPD+1.16D-4) .AND.
     *         ((ISUBA.LE.0) .OR. (ISUBA.EQ.JSUB)) .AND.
     *         ((FQID.LE.0) .OR. (LFQID.EQ.FQID))) THEN
C                                       get source
               SOUID = 0
               IF (ILOCSU.GT.-1) SOUID = RPARM(1+ILOCSU)
C                                       Clear pending time intervals
               IF (SOUID.NE.OLDSOU(1)) THEN
                  DO 60 LANT = 1,NSTNS
                     IF (TBEG(LANT).GT.-999.0) THEN
                        TIMST = TBEG(LANT)
                        TIMEN = TEND(LANT)
                        CALL FLAGUP (OPCODE, FGLUN, DISK, CNOIN, FGVER,
     *                     FGBUFF, IFGRNO, FGKOLS, FGNUMV, OLDSOU, 1,
     *                     JSUB, FQID, 1, LANT, 0, TIMST, TIMEN, 1, 0,
     *                     1, 0, STOKES, LREAS1, NFL, IRET)
                        IF (IRET.NE.0) GO TO 999
                        TBEG(LANT) = -1000.0
                        FGOPEN = .TRUE.
                        WFLAG = WFLAG + NFL
                        END IF
 60                  CONTINUE
                  DO 65 LANT = 1,NB
                     IF (TBB(LANT).GT.-999.0) THEN
                        TIMST = TBB(LANT)
                        TIMEN = TBE(LANT)
                        LA1 = (LANT-1) / NSTNS + 1
                        LA2 = LANT - NSTNS * (LA1-1)
                        CALL FLAGUP (OPCODE, FGLUN, DISK, CNOIN, FGVER,
     *                     FGBUFF, IFGRNO, FGKOLS, FGNUMV, OLDSOU, 1,
     *                     JSUB, FQID, 1, LA1, LA2, TIMST, TIMEN, 1, 0,
     *                     1, 0, STOKES, LREAS2, NFL, IRET)
                        IF (IRET.NE.0) GO TO 999
                        TBB(LANT) = -1000.0
                        FGOPEN = .TRUE.
                        WFLAG = WFLAG + NFL
                        END IF
 65                  CONTINUE
C                                       Check sources
                  IF (ID(1).GT.0) THEN
                     DO 70 SID = 1,NID
                        IF (SOUID.EQ.ID(SID)) GO TO 75
 70                     CONTINUE
                     GO TO 50
                     END IF
                  END IF
C                                       new time interval
C                                       stuff old into time arrays
 75            IF ((TIME-TIMOLD.GT.TDIF) .OR. (OLDSOU(1).NE.SOUID)) THEN
C                                       pick up the source coordinates
C                                       only when a new source appears
                  CALL FNDCOO (0, JD0, SOUID, DISK, CNOIN, CATBLK,
     *               LUNSS, TIME, DRA, DDEC, PLANET, IRET)
                  IF (IRET.GT.0) GO TO 999
                  OLDSOU(1) = SOUID
                  TIMOLD = TIME
C                                       is this point good or no?
                  CALL ISSHAD (RPARM, JSUB, SHMIN, CTMIN, DRA, DDEC,
     *               ISREF, ANTBAD, BASBAD)
                  DO 80 LANT = 1,NSTNS
C                                       interval bad
                     IF (ANTBAD(LANT)) THEN
                        IF (TBEG(LANT).LT.-999.0) TBEG(LANT) =
     *                     TIMOLD - TINT
                        TEND(LANT) = TIMOLD + TINT
                        ANTBAD(LANT) = .FALSE.
C                                       interval now good, was not
                     ELSE IF (TBEG(LANT).GT.-999.0) THEN
                        TIMST = TBEG(LANT)
                        TIMEN = TEND(LANT)
                        CALL FLAGUP (OPCODE, FGLUN, DISK, CNOIN, FGVER,
     *                     FGBUFF, IFGRNO, FGKOLS, FGNUMV, OLDSOU, 1,
     *                     JSUB, FQID, 1, LANT, 0, TIMST, TIMEN, 1, 0,
     *                     1, 0, STOKES, LREAS1, NFL, IRET)
                        IF (IRET.NE.0) GO TO 999
                        TBEG(LANT) = -1000.0
                        FGOPEN = .TRUE.
                        WFLAG = WFLAG + NFL
                        END IF
 80                  CONTINUE
                  DO 85 LANT = 1,NB
C                                       interval bad
                     IF (BASBAD(LANT)) THEN
                        IF (TBB(LANT).LT.-999.0) TBB(LANT) =
     *                     TIMOLD - TINT
                        TBE(LANT) = TIMOLD + TINT
                        BASBAD(LANT) = .FALSE.
C                                       interval now good, was not
                     ELSE IF (TBB(LANT).GT.-999.0) THEN
                        TIMST = TBB(LANT)
                        TIMEN = TBE(LANT)
                        LA1 = (LANT-1) / NSTNS + 1
                        LA2 = LANT - NSTNS * (LA1-1)
                        CALL FLAGUP (OPCODE, FGLUN, DISK, CNOIN, FGVER,
     *                     FGBUFF, IFGRNO, FGKOLS, FGNUMV, OLDSOU, 1,
     *                     JSUB, FQID, 1, LA1, LA2, TIMST, TIMEN, 1, 0,
     *                     1, 0, STOKES, LREAS2, NFL, IRET)
                        IF (IRET.NE.0) GO TO 999
                        TBB(LANT) = -1000.0
                        FGOPEN = .TRUE.
                        WFLAG = WFLAG + NFL
                        END IF
 85                  CONTINUE
                  END IF
               END IF
            GO TO 50
         ELSE
            CALL CATDIR ('CSTA', DISK, FCNO(1), NAME, CLASS, SEQ, 'UV',
     *         NLUSER, 'READ', BUFF, IRET)
            CALL UVGET ('CLOS', RPARM, BUFF, IRET)
            END IF
C                                       Clear pending time intervals
         DO 110 LANT = 1,NSTNS
            IF (TBEG(LANT).GT.-999.0) THEN
               TIMST = TBEG(LANT)
               TIMEN = TEND(LANT)
               CALL FLAGUP (OPCODE, FGLUN, DISK, CNOIN, FGVER, FGBUFF,
     *            IFGRNO, FGKOLS, FGNUMV, OLDSOU, 1, JSUB, FQID, 1,
     *            LANT, 0, TIMST, TIMEN, 1, 0, 1, 0, STOKES, LREAS1,
     *            NFL, IRET)
               IF (IRET.NE.0) GO TO 999
               TBEG(LANT) = -1000.0
               FGOPEN = .TRUE.
               WFLAG = WFLAG + NFL
               END IF
 110        CONTINUE
         DO 120 LANT = 1,NB
            IF (TBB(LANT).GT.-999.0) THEN
               TIMST = TBB(LANT)
               TIMEN = TBE(LANT)
               LA1 = (LANT-1) / NSTNS + 1
               LA2 = LANT - NSTNS * (LA1-1)
               CALL FLAGUP (OPCODE, FGLUN, DISK, CNOIN, FGVER, FGBUFF,
     *            IFGRNO, FGKOLS, FGNUMV, OLDSOU, 1, JSUB, FQID, 1, LA1,
     *            LA2, TIMST, TIMEN, 1, 0, 1, 0, STOKES, LREAS2, NFL,
     *            IRET)
               IF (IRET.NE.0) GO TO 999
               TBB(LANT) = -1000.0
               FGOPEN = .TRUE.
               WFLAG = WFLAG + NFL
               END IF
 120        CONTINUE
 200     CONTINUE
      CALL CATDIR ('CSTA', DISK, FCNO(1), NAME, CLASS, SEQ, 'UV',
     *   NLUSER, 'WRIT', BUFF, IRET)
      IRET = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Begin flagging due to shadowing in subarray',I3)
 1001 FORMAT ('ERROR',I4,' SUBARRAY',I2,' ON ',A)
 1010 FORMAT ('ERROR:',I7,' OPENING UV FILE TO READ')
 1015 FORMAT ('ERROR:',I4,' READING ANTENNA FILE',I4)
 1055 FORMAT ('FLAGSH: at vis record',I10)
      END
      SUBROUTINE SEDSEL (NAME, CLASS, SEQ, DISK, JSUB)
C-----------------------------------------------------------------------
C   puts parameters in DSEL.INC (many conflicts with local common)
C   Inputs:
C      NAME     C*12   File name
C      CLASS    C*6    File class
C      SEQ      I      File seq number
C      DISK     I      File disk number
C      JSUB     I      Subbary
C-----------------------------------------------------------------------
      CHARACTER NAME*12, CLASS*6
      INTEGER   SEQ, DISK, JSUB
C
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
C                                       Info for UVGET:
      CALL SELINI
      UNAME = NAME
      UCLAS = CLASS
      UDISK = DISK
      USEQ = SEQ
      SUBARR = JSUB
C
 999  RETURN
      END
      SUBROUTINE ISSHAD (RPARM, ISUB, SHMIN, CTMIN, DRA, DDEC, ISREF,
     *   ANTBAD, BASBAD)
C-----------------------------------------------------------------------
C   Finds shadowed data.  If an antenna is shadowed by any other antenna
C   it is flagged.
C   Inputs:
C      RPARM    R(*)   Random parameters - uses time
C      ISUB     I      Subarray number
C      SHMIN    R      Min baseline allowed shadowing
C      CTMIN    R      Min baseline allowed cross talk
C      DRA      D      Apparent RA
C      DDEC     D      Apparent Dec
C   Outputs:
C      ANTBAD   L(*)   T => antenna shadowed
C      BASBAD   L(*)   T => baseline cross talk
C-----------------------------------------------------------------------
      REAL      RPARM(*), SHMIN, CTMIN
      DOUBLE PRECISION DRA, DDEC
      LOGICAL   ISREF(*), ANTBAD(*), BASBAD(*)
      INTEGER   ISUB
C
      INTEGER   IA1, IA2, LSUB, IBL
      REAL      AZ, EL, HA, LL, MM, H2
      DOUBLE PRECISION X(2), Y(2), Z(2), BX, BY, BZ, B1, B2, GH, UR, VR,
     *   WR, JDREF, GMST, GAST, RATE, HR, GSEC, HTR, ARRLON, XDEC, XRA,
     *   TIME, RR, UM, VM, WM, RM, HM
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DMSG.INC'
      SAVE LSUB, JDREF
      DATA LSUB /-1/
      DATA GSEC /1.0027375D0/
C-----------------------------------------------------------------------
      IF (LSUB.NE.ISUB) THEN
         LSUB = ISUB
         CALL JULDAY (RDATE, JDREF)
         END IF
      HTR = PI / 12.D0
      CALL GSTROT (JDREF, GMST, GAST, RATE)
      GAST = GAST * (24.D0/360.D0)
      GAST = GAST + (((RPARM(1+ILOCT)-(LSUB-1)*5)*24.D0) * GSEC)
      GAST = MOD (GAST, 24.D0)
      CALL LFILL (NSTNS, .FALSE., ANTBAD)
C                                       adjust "source position"
      TIME = RPARM(1+ILOCT)
      IA1 = 1
      CALL SOUELV (IA1, TIME, HA, EL, AZ)
      LL = ASIN (RPARM(1+ILOCU))
      MM = ASIN (RPARM(1+ILOCV))
      EL = EL - MM
C                                       L > 0 lower RA
      AZ = AZ - LL
      CALL ELVSOU (IA1, TIME, EL, AZ, XRA, XDEC, H2)
C                                              Calculate array longitude
C                                              Array BX= ARRAYC(1)
C                                               Array BY= ARRAYC(2)
C                                              Array BZ= ARRAYC(3)
      ARRLON = 0.0D0
      IF ((ABS(ARRAYC(1)).GT.1.D2) .AND. (ABS(ARRAYC(2)).GT.1.D2) .AND.
     *      (ABS(ARRAYC(3)).GT.1.D2))
     *      ARRLON = ATAN2 (ARRAYC(2), ARRAYC(1))
      DO 100 IA1 = 1,NSTNS-1
         X(1) = STNX(IA1)
         Y(1) = STNY(IA1)
         Z(1) = STNZ(IA1)
         DO 90 IA2 = IA1+1,NSTNS
            IBL = (IA1-1) * NSTNS + IA2
            BASBAD(IBL) = .FALSE.
            X(2) = STNX(IA2)
            Y(2) = STNY(IA2)
            Z(2) = STNZ(IA2)
            IF (((X(1).GT.1.D2) .OR. (Y(1).GT.1.0D2) .OR.
     *         (Z(1).GT.1.0D2)) .AND. ((X(2).GT.1.0D2) .OR.
     *         (Y(2).GT.1.0D2) .OR. (Z(2).GT.1.0D2))) THEN
               CALL BASLIN (2, X, Y, Z, CATD(KDCRV+JLOCF), ARRLON,
     *            BX, BY, BZ, B1, B2, GH)
               HM = GAST*HTR - XRA - GH
               UM = B2 * SIN(HM)
               VM = B1 * COS(XDEC) - B2 * SIN(XDEC) * COS(HM)
               WM = B1 * SIN(XDEC) + B2 * COS(XDEC) * COS(HM)
               RM = SQRT (UM*UM + VM*VM)
               HR = GAST*HTR - DRA - GH
               UR = B2 * SIN(HR)
               VR = B1 * COS(DDEC) - B2 * SIN(DDEC) * COS(HR)
               WR = B1 * SIN(DDEC) + B2 * COS(DDEC) * COS(HR)
               RR = SQRT (UR*UR + VR*VR)
C                                       both reference
               IF ((ISREF(IA1)) .AND. (ISREF(IA2))) THEN
                  IF (RR.LT.SHMIN) THEN
                     IF (WR.GT.0.0) THEN
                        ANTBAD(IA2) = .TRUE.
                     ELSE
                        ANTBAD(IA1) = .TRUE.
                        END IF
                  ELSE IF (RR.LT.CTMIN) THEN
                     BASBAD(IBL) = .TRUE.
                     END IF
C                                       both moving
               ELSE IF ((.NOT.ISREF(IA1)) .AND. (.NOT.ISREF(IA2))) THEN
                  IF (RM.LT.SHMIN) THEN
                     IF (WM.GT.0.0) THEN
                        ANTBAD(IA2) = .TRUE.
                     ELSE
                        ANTBAD(IA1) = .TRUE.
                        END IF
                  ELSE IF (RM.LT.CTMIN) THEN
                     BASBAD(IBL) = .TRUE.
                     END IF
C                                       one of each
               ELSE IF ((RR.LT.CTMIN) .OR. (RM.LT.CTMIN)) THEN
                  IF (RM.LT.SHMIN) THEN
                     IF (WM.GT.0.0) THEN
                        IF (.NOT.ISREF(IA2)) ANTBAD(IA2) = .TRUE.
                     ELSE
                        IF (.NOT.ISREF(IA1)) ANTBAD(IA1) = .TRUE.
                        END IF
                     END IF
                  IF (RR.LT.SHMIN) THEN
                     IF (WR.GT.0.0) THEN
                        IF (ISREF(IA2)) ANTBAD(IA2) = .TRUE.
                     ELSE
                        IF (ISREF(IA1)) ANTBAD(IA1) = .TRUE.
                        END IF
                     END IF
                  IF ((.NOT.ANTBAD(IA1)) .AND. (.NOT.ANTBAD(IA2)))
     *               BASBAD(IBL) = .TRUE.
                  END IF
               END IF
 90         CONTINUE
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE DIE (ICODE, BUFF)
C-----------------------------------------------------------------------
C! closes down tasks which use DFIL.INC to maintain status of files
C# System IO-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   DIE does the housekeeping necessary for an orderly death of the
C   task.  Primarily clearing catalog flags and destroying scratch
C   files.  It also calls RELPOP if RQUICK is false.
C   Inputs:
C      ICODE    I        Return code: 0 => good, other => bad end
C      BUFF     I(256)   Work buffer
C   Locations in catalog are communicated by COMMON /CFILES/:
C      NCFILE     I    Number of files marked in catalog.
C      FVOL       I    Volumn numbers of the maps.
C      FCNO       I    Slot numbers of the maps.
C      FRW        I    A 0 if READ , 1 if WRITE clear desired,
C                      a 2 if a new file with Write, destroy on ICODE
C                      bad;  other values => file already closed.
C      NSCR       I    Number of scratch files to be destroyed
C      SCRVOL     I    Scratch file volumn numbers
C      SCRCNO     I    Scratch file catalog numbers.
C   Programmer: W. D. Cotton  June,1980.
C-----------------------------------------------------------------------
      INTEGER   ICODE, BUFF(256)
C
      INTEGER   IND, I, IERR, J, K
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Close all files (except msg)
      BUFF(1) = NTAB1
      BUFF(2) = NTAB2
      BUFF(3) = NTAB3
      BUFF(4) = NBTB1 / 2
      BUFF(5) = NBTB2 / 2
      BUFF(6) = NBTB3 / 2
      IND = 1
      DO 10 I = 1,3
         IF (BUFF(I).LE.0) GO TO 10
            K = BUFF(I)
            DO 5 J = 1,K
               IF ((FTAB(IND).NE.0) .AND. (FTAB(IND).NE.6) .AND.
     *            (FTAB(IND).NE.12)) CALL ZCLOSE (FTAB(IND), IND, IERR)
               IND = IND + BUFF(I+3)
 5             CONTINUE
 10      CONTINUE
C                                       Prevent destroy on normal end
      IF ((ICODE.GT.0) .OR. (NCFILE.LE.0)) GO TO 20
         DO 15 I = 1,NCFILE
            IF (FRW(I).EQ.2) FRW(I) = 1
 15         CONTINUE
C                                       Clear catalog flags.
 20   CALL MAPCLR (NCFILE, FVOL, FCNO, FRW, BUFF)
C                                       Destroy scratch files.
      IF (NSCR.LE.0) GO TO 40
         DO 25 I = 1,NSCR
            FRW(I) = 2
 25         CONTINUE
 30      CALL MAPCLR (NSCR, SCRVOL, SCRCNO, FRW, BUFF)
C                                       If RQUICK = F restart AIPS.
C                                       Send message to user.
 40   CALL DIETSK (ICODE, RQUICK, BUFF)
C
  999 RETURN
      END

      SUBROUTINE ZMSGCL (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C! close Message file or terminal
C# Z IO-basic Messages
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Close a message file associated with LUN removing any exclusive use
C   state and clear the FTAB entry for the LUN (much like ZCLOSE but
C   does not call MSGWRT to avoid recursion).
C   Inputs:
C      LUN     I   Logical unit number
C      FIND    I   Index in FTAB to file control block for LUN
C   Output:
C      IERR    I   Error return code: 0 => no error
C                     1 => close error
C                     2 => file already closed in FTAB
C                     3 => both errors
C                     4 => erroneous LUN
C   Generic version - uses ZDACLS and ZTTCLS.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
C
      INTEGER   ERRLUN, ERRTER, JERR, IMAP, I, J
      LOGICAL   F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA F /.FALSE./
      DATA ERRTER, ERRLUN /6, 12/
C-----------------------------------------------------------------------
C                                       Check inputs.
      IERR = 4
      IF ((LUN.EQ.ERRTER) .OR. (LUN.EQ.ERRLUN)) GO TO 10
         WRITE (ERRTER,1000) LUN
         GO TO 999
C                                       Locate file in FTAB.
 10   CALL LSERCH ('SRCH', LUN, FIND, F, JERR)
      IF (JERR.EQ.0) GO TO 20
         IERR = 2
         WRITE (ERRTER,1010) LUN
         GO TO 999
C                                       Okay, so far.
 20   IERR = 0
      IMAP = 0
C                                       Close disk message file.
      IF (LUN.EQ.ERRLUN) THEN
         CALL ZDACLS (FTAB(FIND+1), IMAP, IERR)
         IF (IERR.NE.0) WRITE (ERRTER,1020) IERR
C                                       Close terminal message file.
      ELSE
         CALL ZTTCLS (LUN, FIND, IERR)
         IF (IERR.NE.0) THEN
            IERR = 1
            IF (FTAB(FIND+1+NFCBER).GT.0) THEN
               CALL ZMSGWR ('ZTTCLS', FTAB(FIND+1+NFCBER), ' ', -999,
     *            .FALSE.)
            ELSE
               WRITE (ERRTER,1030) IERR, LUN
               END IF
            END IF
         END IF
C                                       Clear FTAB entry.
 900  CALL LSERCH ('CLOS', LUN, FIND, F, JERR)
      IF (JERR.NE.0) THEN
         IERR = IERR + 2
         WRITE (ERRTER,1900) LUN
         END IF
      CALL FSERCH (FIND, I, J, JERR)
      IF (JERR.EQ.0) THEN
         IF (I.EQ.1) DEVNAM(J) = ' '
         IF (I.EQ.2) NONNAM(J) = ' '
         IF (I.EQ.3) MAPNAM(J) = ' '
         END IF
C
 999   RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (' ZMSGCL: INVALID LUN = ',I2)
 1010 FORMAT (' ZMSGCL: LUN = ',I2,' ALREADY CLOSED IN FTAB ON SEARCH')
 1020 FORMAT (' ZMSGCL: ZDACLS RETURNS ERROR = ',I1)
 1030 FORMAT (' ZMSGCL: FORTRAN ERROR ',I4,' ON CLOSE OF LUN ',I2)
 1900 FORMAT (' ZMSGCL: LUN = ',I2,' ALREADY CLOSED IN FTAB ON CLOSE')
      END

      SUBROUTINE RNGSET (IR, MMAX, MMIN, RANG)
C-----------------------------------------------------------------------
C! set plat intensity range from image header and user parameters
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   RNGSET calculates range parameters for displaying a map using the
C   IRANGE adverb supplied by POPS plus scaling information derived
C   from the map header.
C   Inputs:
C      IR     R(2)   Range values specified by user
C      MMAX   R      Map maximum value from header
C      MMIN   R      Map minimum value from header
C   Outputs:
C      RANG   R(2)   Output range values calculated using defaults
C                    including an expansion outward of 0.5 %
C-----------------------------------------------------------------------
      REAL      IR(2), MMAX, MMIN, RANG(2)
C
      REAL      LIMIT, RM
      DATA LIMIT /100.0/
C-----------------------------------------------------------------------
C                                       general default: map range
      IF (IR(2).LE.IR(1)) THEN
         RANG(2) = MMAX
         RANG(1) = MMIN
C                                       limit to reasonable range
      ELSE
         RANG(2) = IR(2)
         RANG(1) = IR(1)
         RM = LIMIT * ABS (MMAX - MMIN)
         IF ((RANG(2).LT.MMIN) .OR. (RANG(2)-MMAX.GE.RM)) RANG(2) = MMAX
         IF ((RANG(1).GT.MMAX) .OR. (MMIN-RANG(1).GE.RM)) RANG(1) = MMIN
         END IF
      RM = 0.005 * (RANG(2) - RANG(1))
      RANG(2) = RANG(2) + RM
      RANG(1) = RANG(1) - RM
C
 999  RETURN
      END

       SUBROUTINE AP2SIZ (KAPWRD, BPSIZE)
C-----------------------------------------------------------------------
C! returns largest power of 2 not exceeding 1024 times first argument
C# AP-fft utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   AP2SIZ determines the largest power of 2 not exceeding
C   1024 * KAPWRD and returns it in BPSIZE.
C   Input:
C     KAPWRD    I    Multiple of 1024
C   Output:
C     BPSIZE    I    Largest power of 2 not exceeding 1024*KAPWRD
C-----------------------------------------------------------------------
       INTEGER   KAPWRD, BPSIZE, I, SIZE
C-----------------------------------------------------------------------
       SIZE = 1
       DO 10 I = 1, 20
          IF ((SIZE*2).GT.KAPWRD) GO TO 20
             SIZE = SIZE * 2
 10          CONTINUE
 20   BPSIZE = SIZE * 1024
C
 999  RETURN
      END

      SUBROUTINE ZTXCLS (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C! clos text file opened via ZTXOPN
C# Z Text
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2013, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Close the text file and clear the FTAB entry associated with LUN.
C   Inputs:
C      LUN    I   Logical unit number
C      FIND   I   Index in FTAB for LUN
C   Output:
C      IERR   I   Error return code: 0 => no error
C                    1 => close error
C                    2 => file already closed in FTAB
C                    3 => both errors
C                    4 => inputs error
C   Generic version: uses Fortran CLOSE
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
C
      INTEGER   JERR, IOSVAL, I, J
      LOGICAL   F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                       Valid LUN?
      IERR = 4
      IF ((LUN.LE.0) .OR. (LUN.GT.99)) THEN
         WRITE (MSGTXT,1000) LUN
         GO TO 995
         END IF
C                                       Valid device type?
      IF (MOD (DEVTAB(LUN), 2).NE.1) THEN
         WRITE (MSGTXT,1010) LUN, DEVTAB(LUN)
         GO TO 995
         END IF
C                                       Locate file in FTAB.
      IERR = 0
      CALL LSERCH ('SRCH', LUN, FIND, F, JERR)
      IF (JERR.NE.0) THEN
         IERR = 2
         WRITE (MSGTXT,1020) LUN
         GO TO 995
         END IF
C                                       Close the text file.
      CLOSE (UNIT=LUN, IOSTAT=IOSVAL)
      IF (IOSVAL.NE.0) THEN
         WRITE (MSGTXT,1030) IOSVAL, LUN
         CALL MSGWRT (7)
         CALL ZERROR ('ZTXCLS', IOSVAL, ' ', -999, .FALSE.)
         IERR = 1
         END IF
C                                       Clear FTAB entry. any case
      CALL LSERCH ('CLOS', LUN, FIND, F, JERR)
      IF (JERR.EQ.0) THEN
         CALL FSERCH (FIND, I, J, JERR)
         IF (JERR.EQ.0) THEN
            IF (I.EQ.1) DEVNAM(J) = ' '
            IF (I.EQ.2) NONNAM(J) = ' '
            IF (I.EQ.3) MAPNAM(J) = ' '
            END IF
         GO TO 999
      ELSE
         IERR = IERR + 2
         WRITE (MSGTXT,1040) LUN
         END IF
C
 995   CALL MSGWRT (7)
C
 999   RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZTXCLS: INVALID LUN = ',I3)
 1010 FORMAT ('ZTXCLS: INVALID DEVTAB(',I2,') = ',I1)
 1020 FORMAT ('ZTXCLS: LUN = ',I3,' ALREADY CLOSED IN FTAB ON SEARCH')
 1030 FORMAT ('ZTXCLS: FORTRAN ERROR ',I6,' ON CLOSE FOR LUN = ',I3)
 1040 FORMAT ('ZTXCLS: LUN = ',I3,' ALREADY CLOSED IN FTAB ON CLOSE')
      END

      SUBROUTINE QBAKSU (B, D, E, CI, N)
C-----------------------------------------------------------------------
C! FPS AP version: Back substitution
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FPS AP version
C   Does the following loop:
C       DO K = N-2,1,-1
C          B(K) = (B(K)-D(K)*B(K+1)-E(K)*B(K+2))*CI(K)
C   Inputs:
C     B   I First vector base address (incr=1) also destination.
C     D   I Second vector base address (incr=1)
C     E   I Third vector base address (incr=1)
C     CI  I Fourth vector base address (incr=1)
C     N   I Element count
C-----------------------------------------------------------------------
      INTEGER B, D, E, CI, N
      INTEGER*2 IB, ID, IE, ICI, IN
C-----------------------------------------------------------------------
C                                        Convert inputs to unsigned I*2
      IF (B.LT.32768) IB = B
      IF (B.GE.32768) IB = B - 65536
      IF (D.LT.32768) ID = D
      IF (D.GE.32768) ID = D - 65536
      IF (E.LT.32768) IE = E
      IF (E.GE.32768) IE = E - 65536
      IF (CI.LT.32768) ICI = CI
      IF (CI.GE.32768) ICI = CI - 65536
      IF (N.LT.32768) IN = N
      IF (N.GE.32768) IN = N - 65536
C                                        Call FPS routine.
      CALL BAKSUB (IB, ID, IE, ICI, IN)
C
 999  RETURN
      END

      SUBROUTINE GETKEY (SYMBOL, KL, NPNT, NUMKEY, KEYWRD, KEYVAL,
     *   KEYCHR, KEYTYP, IERR)
C-----------------------------------------------------------------------
C! Parses symbol = value from a character string.
C# Parsing
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2000, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Given a character string of the form: "SYMBOL = some_value",
C   determine the type of some_value, its value, and put all of this
C   stuff in KEYVAL.
C   Inputs:
C      SYMBOL   C*8      Characters from KL. "SYMBOL = ..."
C      KL       C*(*)    Input line of the form "SYMBOL = some_value"
C   In/Out:
C      NPNT     I        The character position after the "="
C      NUMKEY   I        The number of keywords already in KEYVAL etc.
C      KEYWRD   C(*)*8   Keywords
C      KEYVAL   D(*)     List of arbitrary keyword numeric values:
C                           KEYVAL(n) => Value in D.
C      KEYCHR   C(*)*8   List of arbitrary keyword character values:
C                           KEYCHR(n) => string if KEYTYP(n)=3.
C      KEYTYP   I(*)     Type code: 1=>Double, 2=>single, 3=>char.
C                           4=>long integer, 5=>logical
C      IERR     I        Error code. 0=ok.
C-----------------------------------------------------------------------
      CHARACTER SYMBOL*8, KL*(*), KEYWRD(*)*8, KEYCHR(*)*8
      INTEGER   NPNT, NUMKEY, KEYTYP(*), IERR
      DOUBLE PRECISION KEYVAL(*)
C
      CHARACTER CHR*32, TIC*1, DOT*1, EE*2, DD*2, T*1, F*1, FSTCHR*1
      INTEGER   INB, NCHAR, TYPCOD, INDEX
      DOUBLE PRECISION X
      INCLUDE 'INCS:DDCH.INC'
      DATA TIC,  DOT,  EE,  DD,  T,   F
     *   / '''', '.', 'Ee','Dd','T', 'F'/
C-----------------------------------------------------------------------
      NUMKEY = NUMKEY + 1
      X = 0.0D0
      CHR = ' '
C                                       Guess data type
C                                       Find 1st character.
      DO 20 INB = NPNT,80
         IF (KL(INB:INB).NE.' ') GO TO 30
 20      CONTINUE
C                                       First non blank found.
C                                       Can tell a lot from 1st char.
 30   FSTCHR = KL(INB:INB)
C                                       Character.
      IF (FSTCHR.EQ.TIC) THEN
         TYPCOD = 3
         CALL GETSTR (KL, 80, 32, NPNT, CHR, NCHAR)
         IF (INDEX (SYMBOL,'DATE').NE.0) CALL DATFST ('F2L', CHR)
C                                       Logical?
      ELSE IF (FSTCHR.EQ.T) THEN
         X = 1.0D0
         TYPCOD = 5
      ELSE IF (FSTCHR.EQ.F) THEN
         X = -1.0D0
         TYPCOD = 5
C                                       Must be a number.
      ELSE
         NPNT = INB
         CALL GETNUM (KL, 80, NPNT, X)
         IF (X.EQ.DBLANK) THEN
            NUMKEY = NUMKEY - 1
            IERR = 1
            GO TO 999
            END IF
C                                       Determine: Real, Double, Integer
         TYPCOD = 4
C                                       Look for ".", "E", "D", "e" or
C                                       "d"
         IF (INDEX (KL(INB:NPNT), DOT).GT.0) TYPCOD = 2
         IF (INDEX (KL(INB:NPNT), EE(1:1)).GT.0) TYPCOD = 2
         IF (INDEX (KL(INB:NPNT), EE(2:2)).GT.0) TYPCOD = 2
         IF (INDEX (KL(INB:NPNT), DD(1:1)).GT.0) TYPCOD = 1
         IF (INDEX (KL(INB:NPNT), DD(2:2)).GT.0) TYPCOD = 1
         END IF
C                                       Save type, put values in KEYVAL
      KEYWRD(NUMKEY) = SYMBOL
      KEYVAL(NUMKEY) = X
      KEYCHR(NUMKEY) = CHR
      KEYTYP(NUMKEY) = TYPCOD
C
 999  RETURN
      END

      SUBROUTINE SUBMAP (IN1, IN2, OUT, INDEF, IERR)
C-----------------------------------------------------------------------
C! Tim Cornwell Routine: Subtract two images.
C# IO-appl Map Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  Subtracts IN2 from IN1 putting the answer into OUT
C   Programmer =  R. Braun                            November 1987
C-----------------------------------------------------------------------
      INTEGER   IN1, IN2, OUT
      REAL      INDEF
      INTEGER   AKOPEN, AKCESS, AKCLOS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C
      IERR = 0
      IF (AKOPEN (IN1, 1, 'READ', BUFFR1) .NE.0) GO TO 990
      IF (AKOPEN (IN2, 2, 'READ', BUFFR2) .NE.0) GO TO 990
      IF (AKOPEN (SCR, 3, 'WRIT', BUFFR3) .NE.0) GO TO 990
C                                       Loop through map
      DO 250 IY = 1,HNY
C
         IF (AKCESS (SCR, BUFFR3) .NE.0) GO TO 990
C                                        Do calculations
         IF ((IY.LT.YBEG) .OR. (IY.GT.YEND)) GO TO 250
            IF (AKCESS (IN1, BUFFR1) .NE.0) GO TO 990
            IF (AKCESS (IN2, BUFFR2) .NE.0) GO TO 990
            I1 = BIND(1)
            I2 = BIND(2)
            I3 = BIND(3) + XBEG - 1
            CALL RFILL (HNX, INDEF, BUFFR3(BIND(3)))
            DO 190 IX = XBEG, XEND
               IF (BUFFR1(I1).NE.INDEF) THEN
                  BUFFR3(I3) = 0.0
                  IF (BUFFR2(I2).NE.0.0)
     *              BUFFR3(I3) = BUFFR1(I1) - BUFFR2(I2)
               END IF
               I1 = I1 + 1
               I2 = I2 + 1
               I3 = I3 + 1
 190           CONTINUE
 250     CONTINUE
      IF (AKCLOS (IN1, BUFFR1) .NE.0) GO TO 990
      IF (AKCLOS (IN2, BUFFR2) .NE.0) GO TO 990
      IF (AKCLOS (SCR, BUFFR3) .NE.0) GO TO 990
C
      CALL FILSWP(OUT, SCR)
      GO TO 999
C
 990  WRITE (MSGTXT,1000)
      CALL MSGWRT (8)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SUBMAP')
      END

      SUBROUTINE SKPBLK (FITBLK, ICARD, FDVEC, TAPBLK, TBIND, IERR)
C-----------------------------------------------------------------------
C! find next non-blank card image in a FITS header, read tape if needed
C# FITS tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Routine to skip blank cards in a buffer.  Cards and buffer are FITS
C   type, i.e. 80 byte cards and 36 card buffer.  It will read more tape
C   records (and convert to local characters) as needed.
C   In/Out:
C      FITBLK   C*2880       FITS record (36 local character cards).
C      ICARD    I            Current card number (starts at 1).  Will
C                            be next non blank card on output.
C      FDVEC    I(*)         TAPIO control buffer
C      TAPBLK   I(*)         Tape I/O buffer
C      TBIND    I            Tape I/O buffer pointer.
C   Output:
C      IERR     I            0=OK, else TAPIO error
C-----------------------------------------------------------------------
      CHARACTER FITBLK*2880
      INTEGER   ICARD, IERR, TBIND, TAPBLK(*), FDVEC(*)
C
      INTEGER   IC, IS, IE
C-----------------------------------------------------------------------
      IERR = 0
C                                       loop on tape records
 10   CONTINUE
C                                       read new record
         IF ((ICARD.GT.0) .AND. (ICARD.LE.36)) GO TO 20
            CALL TAPIO ('READ', FDVEC, TAPBLK, TBIND, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL ZC8CL (2880, 1, TAPBLK(TBIND), FITBLK)
            ICARD = 1
C                                       look for non-blank card
 20      IC = ICARD
         DO 50 ICARD = IC,36
            IS = 80 * (ICARD - 1) + 1
            IE = IS + 79
            IF (FITBLK(IS:IE).NE.' ') GO TO 999
 50         CONTINUE
         ICARD = 37
         GO TO 10
C
 999  RETURN
      END

      PROGRAM ZSTOPA
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  Changes current process name to the name of the users terminal
C  (_TTA3:) by translating the logical name for TT. In the case the
C  login procedure is initiated through DECNET, the assignment of
C  TT is to a FAL.LOG file. In this case no rename is attempted.
C-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER   I4ERR, SYS$TRNLOG, SYS$SETPRN
      INTEGER   I, II
      CHARACTER*16 MYNAME
      CHARACTER*2 TT
      CHARACTER*1 NULL
      DATA TT /'TT'/
C-----------------------------------------------------------------------
C                                       Translate log name TT:
      NULL = CHAR (0)
      I4ERR = SYS$TRNLOG (TT, , MYNAME, , , ,)
      IF (I4ERR.NE.1) GO TO 999
C                                       Skip underscores.
      I = 1
      DO WHILE (MYNAME(I:I).EQ.'_')
         I = I + 1
         END DO
C                                       Change the process name.
      II = INDEX (MYNAME, NULL) - 1
      I4ERR = SYS$SETPRN (MYNAME(I:II) )
 999  CONTINUE
      END

      SUBROUTINE OBREFM (DISK, CNO, VER, NEWVER, CATBLK, LUN1, LUN2,
     *   IROWF, DJULDY, IRET)
C----------------------------------------------------------------------
C! Converts input VLBA OB table (ver 1) to version 2 used by AIPS
C# EXT-appl
C----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2007, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C----------------------------------------------------------------------
C   Converts input VLBA OB table to version 2 used by AIPS
C   Inputs:
C      DISK     I      Volume number
C      CNO      I      Catalog slot number
C      VER      I      Version # of table in old format
C      NEWVER   I      Version # of output table; may equal VER
C      CATBLK   I(256) Catalog header block
C      LUN1     I      LUN for table I/O
C      LUN2     I      LUN for table I/O
C      DJULDY   D      Reference Julian day number (only v.1=>v.2)
C   Output:
C      IROWF    I      Start row in output table
C      IRET     I      Return code (0=>ok; else error)
C----------------------------------------------------------------------
      DOUBLE PRECISION DJULDY
      INTEGER DISK, CNO, VER, NEWVER, CATBLK(256), LUN1, LUN2, IROWF,
     *   IRET
C
      INCLUDE 'INCS:POBV.INC'
      LOGICAL WTABLE, WEXIST, WFITS, WSTAT
      CHARACTER LTYPE*2, LTEMP*12, LSTAT*4
      DOUBLE PRECISION DXYZOB(3), DVELOB(3), DTIMOB, DMJD
      REAL ANGLOB(3), ECLPOB(4), ORIOB
      INTEGER JBUFF1(512), JBUFF2(512), IOUTVR, I, J, IDUMMY, NKEY,
     *   NCOL, NREC, DATP(128,2), NROW, IERR, IREV, IPT, IPOINT,
     *   IOBRNO, OBKOLS(MAXOBC), OBNUMV(MAXOBC), IRNO, K, IANTOB,
     *   ISUBOB
      INCLUDE 'INCS:DMSG.INC'
C                                       Define table format OB ver #1
      INTEGER NOBKEY, MOBAXC, MOBXSP, MOBXDP
C                                       # keywords
      PARAMETER (NOBKEY = 1)
C                                       # columns
      PARAMETER (MOBAXC = 4)
C                                       Logical record length in
C                                       single precision words
      PARAMETER (MOBXSP = 30)
C                                       in double precision words
      PARAMETER (MOBXDP = MOBXSP / 2)
C                                       Parameters specifying the
C                                       position of variables within
C                                       a table row. Third character
C                                       gives variable type (D=double)
      INTEGER OBDTI1, OBDXY1, OBDVE1
C                                       Time
      PARAMETER (OBDTI1 = 2)
C                                       Spacecraft position (x, y, z)
      PARAMETER (OBDXY1 = 3)
C                                       Spacecraft velocity (vx,vy,vz)
      PARAMETER (OBDVE1 = 4)
C
      CHARACTER LKEYW(NOBKEY)*8
      DOUBLE PRECISION RECD(MOBXDP)
      REAL RECORD(MOBXSP)
      INTEGER KLOCS(NOBKEY), KEYVAL(NOBKEY), KEYTYP(NOBKEY),
     *   KOLS(MOBAXC), NUMV(MOBAXC), RECI(MOBXSP)
      EQUIVALENCE (RECD, RECORD, RECI)
      DATA LKEYW /'TABREV  '/
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C                                       Compute modified Julian dayno
      DMJD = DJULDY - 2400000.5D0
C                                       Check for valid input table
      CALL ISTAB ('OB', DISK, CNO, VER, LUN1, JBUFF1, WTABLE, WEXIST,
     *   WFITS, IERR)
      IF (.NOT.WEXIST) GO TO 999
C                                       Read input table keywords
      CALL TABINI ('READ', 'OB', DISK, CNO, VER, CATBLK, LUN1,
     *   NKEY, NREC, NCOL, DATP, JBUFF1, IERR)
      IF (IERR.GT.0) THEN
         IRET = 4
         CALL TABERR ('READ', 'TABINI', 'OBREFM', IERR)
         GO TO 990
         END IF
C
      I = MSGSUP
      MSGSUP = 32000
      CALL TABKEY ('READ', LKEYW, NOBKEY, JBUFF1, KLOCS, KEYVAL, KEYTYP,
     *   IERR)
      MSGSUP = I
      IF ((IERR.GE.1).AND.(IERR.LE.20)) THEN
         IRET = 5
         CALL TABERR ('READ', 'TABKEY', 'OBREFM', IERR)
         GO TO 990
         END IF
C                                       Revision number
      IPT = 1
      IPOINT = 1
      IREV = KEYVAL(IPOINT)
C                                       Get table column indices
C                                       and lengths
      DO 40 I = 1, NCOL
         KOLS(I) = DATP(I,1)
         NUMV(I) = DATP(I,2) / 10
40       CONTINUE
C
      CALL TABIO ('CLOS', 0, 0, JBUFF1, JBUFF1, IERR)
C                                       Only convert v.1 -> v.2
C                                       (no other versions exist)
      IF (IREV.NE.1) GO TO 999
C                                       Copy input file
      IOUTVR = 0
      I = MSGSUP
      MSGSUP = 31999
      CALL TABCOP ('OB', VER, IOUTVR, LUN1, LUN2, DISK, DISK, CNO,
     *   CNO, CATBLK, JBUFF1, JBUFF2, IERR)
      MSGSUP = I
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1010) IERR
         GO TO 990
         END IF
C                                       Delete old version
      CALL RMEXT (DISK, CNO, 'OB', VER, CATBLK, JBUFF1, IERR)
      IF (IERR.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       Update CATBLK
      CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'REST', JBUFF1, IERR)
C                                       Determine file status
      LTYPE = 'UV'
      WSTAT = .FALSE.
      CALL CATDIR ('INFO', DISK, CNO, LTEMP, LTEMP, IDUMMY, LTYPE,
     *   IDUMMY, LSTAT, JBUFF1, IERR)
C                                       Change status
      IF (LSTAT.NE.'WRIT') THEN
         CALL STATCH (LSTAT, 'WRIT', DISK, CNO, LTYPE, JBUFF1, IERR)
         IF (IERR.NE.0) THEN
            IRET = 3
            WRITE (MSGTXT,1080) IERR
            GO TO 990
            END IF
         WSTAT = .TRUE.
         END IF
C                                       Open input table
      CALL TABINI ('READ', 'OB', DISK, CNO, IOUTVR, CATBLK, LUN2,
     *   NKEY, NREC, NCOL, DATP, JBUFF1, IERR)
      IF (IERR.GT.0) THEN
         IRET = 4
         CALL TABERR ('READ', 'TABINI', 'OBREFM', IERR)
         GO TO 990
         END IF
C                                       # rows in output table
      NROW = JBUFF1(5)
C                                       Create output table
      CALL OBINI ('WRIT', JBUFF2, DISK, CNO, NEWVER, CATBLK, LUN1,
     *   IOBRNO, OBKOLS, OBNUMV, IERR)
      IF (IERR.GT.0) THEN
         IRET = 6
         CALL TABERR ('WRIT', 'OBINI', 'OBREFM', IERR)
         GO TO 990
         END IF
      IROWF = IOBRNO
C                                       Loop and translate each row
      DO 300 J = 1, NROW
         IRNO = J
C                                       Read input row
         CALL TABIO ('READ', 0, IRNO, RECI, JBUFF1, IERR)
         IF (IERR.GT.0) THEN
            IRET = 7
            CALL TABERR ('READ', 'TABIO', 'OBREFM', IERR)
            GO TO 990
            END IF
C                                       Time (subtract MJD)
         DTIMOB = RECD(KOLS(OBDTI1)) - DMJD
C                                       Spacecraft position and
C                                       velocity
         DO 100 K = 1, 3
            DXYZOB(K) = RECD(KOLS(OBDXY1) + K - 1)
            DVELOB(K) = RECD(KOLS(OBDVE1) + K - 1)
100         CONTINUE
C                                       Initialize missing fields
         IANTOB = 0
         ISUBOB = 0
         CALL RFILL (3, 0.0, ANGLOB)
         CALL RFILL (4, 0.0, ECLPOB)
         ORIOB = 0
C                                       Write output row
         CALL TABOB ('WRIT', JBUFF2, IOBRNO, OBKOLS, OBNUMV, IANTOB,
     *      ISUBOB, DTIMOB, DXYZOB, DVELOB, ANGLOB, ECLPOB, ORIOB,
     *      IERR)
         IF (IERR.GT.0) THEN
            IRET = 8
            CALL TABERR ('WRIT', 'TABOB', 'OBREFM', IERR)
            GO TO 990
            END IF
300      CONTINUE
C                                       Close tables
      CALL TABIO ('CLOS', 0, IRNO, JBUFF1, JBUFF1, IERR)
      CALL TABIO ('CLOS', 0, IOBRNO, JBUFF2, JBUFF2, IERR)
C                                       Delete copy
      CALL RMEXT (DISK, CNO, 'OB', IOUTVR, CATBLK, JBUFF1, IERR)
      IF (IERR.NE.0) THEN
         IRET = 9
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       Check if changed status
C                                       Change status
      IF (WSTAT) THEN
         CALL STATCH ('WRIT', LSTAT, DISK, CNO, LTYPE, JBUFF1, IERR)
         IF (IERR.NE.0) THEN
            IRET = 10
            WRITE (MSGTXT,1400) IERR
            GO TO 990
            END IF
         END IF
C                                       Update CATBLK
      CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'REST', JBUFF1, IERR)
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C
999   RETURN
C----------------------------------------------------------------------
1010  FORMAT ('OBREFM: ERROR',I3,' COPYING OLD TABLE')
1020  FORMAT ('OBREFM: ERROR',I3,' DELETING OLD TABLE')
1080  FORMAT ('OBREFM: ERROR',I3,' CHANGING CLRD STATUS')
1400  FORMAT ('OBREFM: ERROR',I3,' CHANGING CLWR STATUS')
      END

LOCAL INCLUDE 'SLICE.INC'
C                                       Local include for SLICE
      INCLUDE 'INCS:PMAD.INC'
      REAL      PRUSER, SEQIN, DSKIN, BLC(7), TRC(7), KEEP
      HOLLERITH XNAMIN(3), XCLSIN(2), XOFILE(12)
      CHARACTER NAMIN*12, CLSIN*6, OFILE*48
      INTEGER   MORD, MORD1, MORD12, MORD21, LUNPR, PFIND, IDEPTH(5),
     *   ISBLK(256)
      REAL      SBLK(256)
      LOGICAL   WFILE, ISFQID
      DOUBLE PRECISION ZZ, FRQS(MAXIMG)
      EQUIVALENCE (ISBLK,SBLK)
      COMMON /INPARM/ PRUSER, XNAMIN, XCLSIN, SEQIN, DSKIN, BLC, TRC,
     *   XOFILE, KEEP
      COMMON /CHRCOM/ NAMIN, CLSIN, OFILE
      COMMON /STCOM/ FRQS, ZZ, SBLK, MORD, MORD1, MORD12, MORD21, LUNPR,
     *   PFIND, WFILE, IDEPTH, ISFQID
LOCAL END
LOCAL INCLUDE 'SLICE2.INC'
C                             Everett Interpolation internal variables:
      REAL      BCOEF(49), SV(14), SAVWTS(8,61)
      INTEGER   MORD2, IS0, NVALS
      LOGICAL   LRECUR
      COMMON /CEVI/ BCOEF, SV, SAVWTS, LRECUR, MORD2, IS0, NVALS
LOCAL END
      PROGRAM SLICE
C-----------------------------------------------------------------------
C! Interpolates image values along a slice and writes an SL file.
C# Map EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2005, 2009, 2011-2012, 2015-2017, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SLICE will create an extension file of type SL containing a set
C   of interpolated pixel values on the line between a given BLC and
C   TRC.  These values are stored as floating pt numbers.  Fractional
C   BLC and TRCs are allowed.  "Almost standard" extension file
C   header format is used.
C   Inputs:   (from AIPS)
C              INNAME   R(3)   name of primary file.
C              INCLASS  R(2)   class of primary file.
C              INSEQ    R   sequence number of primary file.
C              INDISK   R   disk volume number. 0 means try all.
C              BLC      R(7)   the coordinate in the input file to
C                       become the left hand coordinate of the slice.
C                       BLC(1) is the X coordinate and
C                       BLC(2) is the Y coordinate.  The first
C                       coordinate in the input image is (1,1).
C              TRC      R(7)   the coordinate in the input file to
C                       become the top right hand corner of the
C                       slice.
C              OUTFILE  H(12) File name to write slice output.
C                       Blank for default (no file written).
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   IOBLK(MAXIMG), IMSTUF(37), ISSTUF(6), IMLUN, ISLUN,
     *   IBSIZE, INOSL, IERR, IORD, I0, I1
      LOGICAL   TWODIM
      INCLUDE 'SLICE.INC'
      INCLUDE 'SLICE2.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA IMLUN, ISLUN /16, 27/
C-----------------------------------------------------------------------
C                                       Order of interpolation.
      IORD = 3
C                                       Get parms, open map, create sli
      IBSIZE = MAXIMG
      CALL SLIINI (IORD, IMLUN, ISLUN, IBSIZE, I0, I1, INOSL, TWODIM,
     *   IMSTUF, ISSTUF, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Call 2D or 3D slice subroutine.
      IF (TWODIM) THEN
         CALL SLTTWO (INOSL, BLC, TRC, IMSTUF, ISSTUF, I0, I1, IOBLK,
     *      IERR)
      ELSE
         CALL SLTHRE (INOSL, BLC, IMSTUF, ISSTUF, IOBLK, IERR)
         END IF
C                                       Shutdown
 900  CALL DIE (IERR, IOBLK)
C
 999  STOP
      END
      SUBROUTINE SLIINI (IORD, IMLUN, ISLUN, IBSIZE, I0, I1, INOSL,
     *   TWODIM, IMSTUF, ISSTUF, IERR)
C-----------------------------------------------------------------------
C   This routine does some of the initial processing for the slice
C   file creation routine.  Get the input parameters, resume AIPS if
C   RQUICK, set up the IO and header commons, open the map file and
C   create and open the slice file.
C   Inputs:
C      IORD   I       Order of the interpolation.
C      IMLUN  I       LUN to use for image file.
C      ISLUN  I       LUN to use for slice file.
C      IBSIZE I       Size of image IO buffer in INTEGER*2.
C   Outputs:
C      I0     I       Number of values per row in map window needed
C                     for interpolation.
C      I1     I       Number of rows needed at one time to interpolate
C                     one point.
C      INOSL  I       Number of points in slice.
C      TWODIM L       T if slice two dimensional, else F
C      IMSTUF I(37)   IO LUNs, counters, etc. for image file.
C      ISSTUF I(6)    LUN, FIND, ., ., ., vers # for slice file.
C      IERR   I       Error code, 0=ok.
C      OFILE  C(48)   File name for output file.
C-----------------------------------------------------------------------
      INTEGER   IORD, IMLUN, ISLUN, IBSIZE, I0, I1, INOSL, IMSTUF(37),
     *   ISSTUF(6), IERR
      LOGICAL   TWODIM
C
      CHARACTER NAME*36, TYPIN*2, PRGNAM*6, CTEMP*8
      HOLLERITH MAP
      INTEGER   NPARMS, I, IBLCX, IBLCY, ITRCX, ITRCY, NX, NY, INODIM,
     *   NFQ, ORDER, NZI, J, J1, J2
      REAL      SVX(14), RPARMS(34)
      DOUBLE PRECISION DTEMP
      INCLUDE 'SLICE.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (PRUSER, RPARMS)
      DATA PRGNAM /'SLICE '/
C-----------------------------------------------------------------------
C                                       Get parms, set IO & hdr vals.
      NPARMS = 34
      CALL TSKBEG (PRGNAM, NPARMS, XNAMIN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
      CALL H2CHR (48, 1, XOFILE, OFILE)
      TYPIN = 'MA'
      PRUSER = NLUSER
      NPARMS = NPARMS + 1
C                                       Open the map file.
      CALL CHR2H (4, 'MA  ', 1, MAP)
      CALL H2WAWA (XNAMIN, XCLSIN, SEQIN, MAP, DSKIN, PRUSER, NAME)
C                                       Open input map
      CALL OPENCF (IMLUN, NAME, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING INPUT IMAGE'
         GO TO 990
         END IF
      IMSTUF(1) = FILTAB(POLUN,6)
      IMSTUF(2) = FILTAB(POFIN,6)
      IMSTUF(5) = FILTAB(POCAT,6)
      IMSTUF(7) = FILTAB(POVOL,6)
C                                       Set up info used by DIE.
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = IMSTUF(7)
      FCNO(NCFILE) = IMSTUF(5)
      FRW(NCFILE) = 0
C                                       Get header
      CALL GETHDR (IMLUN, CATBLK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING HEADER'
         GO TO 990
         END IF
C                                       set windows
      CALL SLNDOW (FILTAB(PODIM,6), FILTAB(PONAX,6), KEEP, BLC, TRC,
     *   IERR)
      IF (IERR.EQ.0) THEN
         DO 10 I = 1,7
            FILTAB(POBLC+I-1,6) = BLC(I) + 0.001
            FILTAB(POTRC+I-1,6) = TRC(I) + 0.999
 10         CONTINUE
         FILTAB(POIOP,6) = -ABS (FILTAB(POIOP,6))
         CALL COPY (6, FILTAB(POBLC+1,6), FILTAB(PODEP,6))
C                                       Compute Block offset to start
C                                       of windowed region
         CALL COMOFF (FILTAB(PODIM,6), FILTAB(PONAX,6),
     *      FILTAB(POBLC+2,6), FILTAB(POBL,6), IERR)
         FILTAB(POBL,6) = 1 + FILTAB(POBL,6)
      ELSE
         WRITE (MSGTXT,1000) IERR, 'SETTING WINDOWS'
         GO TO 990
         END IF
C                                       See if two dim slice.
      INODIM = CATBLK(KIDIM)
      CTEMP = ' '
      NZI = 0
      J = 0
      DO 30 I = 1,INODIM
         IF (I.GT.2) IDEPTH(I-2) = BLC(I) + 0.01
         IF (ABS(TRC(I)-BLC(I)).GT.0.1) THEN
            IF (I.GT.2) J = J + 1
            NZI = I
            END IF
 30      CONTINUE
      TWODIM = NZI.LE.2
      NX = ABS (TRC(1) - BLC(1)) + 0.01
      NY = ABS (TRC(2) - BLC(2)) + 0.01
C                                       re-open w special I/O
      IF (TWODIM) THEN
         CALL FILCLS (IMLUN)
         NCFILE = NCFILE - 1
         CALL INTMIO (IMLUN, 'WRIT', NAME, BLC, TRC, IBSIZE, CATBLK,
     *      IMSTUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'RE-OPENING INPUT IMAGE'
            GO TO 990
            END IF
         IF ((NX.GT.0) .AND. (NY.GT.0)) KEEP = -1.0
C                                       3D - allow only simple slice
      ELSE
         IF ((NX.GT.0) .OR. (NY.GT.0)) THEN
            IERR = 1
            MSGTXT = 'CANNOT DO TRUE 3+ DIMENSIONS'
            GO TO 990
         ELSE IF (J.GT.1) THEN
            IERR = 1
            MSGTXT = 'CANNOT SLICE IN > 1 DIMENSION ABOVE X,Y'
            GO TO 990
            END IF
         END IF
C                                       FQID problem?
      CALL H2CHR (8, 1, CATH(KHCTP+2*(NZI-1)), CTEMP)
      ISFQID = CTEMP.EQ.'FQID'
C                                       init coordinates
      LOCNUM = 1
      CALL SETLOC (IDEPTH, .FALSE.)
      IF (AXTYP(LOCNUM).LE.1) ZZ = CATD(KDCRV+2) + CATR(KRCIC+2) *
     *   (IDEPTH(1) - CATR(KRCRP+2))
C                                       Set initial values for interpo
      CALL INITEI (IORD)
C                                       Adjust windows to get neighbor
C                                       pixels needed for interpolation.
      CALL IEVERT (BLC(1), IBLCX, SVX)
      CALL IEVERT (BLC(2), IBLCY, SVX)
      CALL IEVERT (TRC(1), ITRCX, SVX)
      CALL IEVERT (TRC(2), ITRCY, SVX)
C                                       Left to right.
      IF (TRC(1)-BLC(1).GT.-0.5) THEN
         IMSTUF(17) = MAX (IBLCX + 1, 1)
         IMSTUF(18) = MIN (ITRCX + MORD12, IMSTUF(10))
C                                       Right to left
      ELSE
         IMSTUF(17) = MAX (ITRCX + 1, 1)
         IMSTUF(18) = MIN (IBLCX + MORD12, IMSTUF(10))
         END IF
C                                       Reading file forward.
      IF (BLC(2).LE.TRC(2)) THEN
         IMSTUF(19) = MAX (IBLCY + 1, 1)
         IMSTUF(20) = MIN (ITRCY + MORD12, IMSTUF(11) )
C                                       Reading file backward.
      ELSE
         IMSTUF(19) = MIN (IBLCY + MORD12, IMSTUF(11) )
         IMSTUF(20) = MAX (ITRCY + 1, 1)
         END IF
C
      IMSTUF(31) = IMSTUF(20)
      I0 = IMSTUF(18) - IMSTUF(17) + 1
      I1 = MORD12
      IMSTUF(9) = I0
C                                       FQID values
      IF (ISFQID) THEN
         CALL FRQGET (IMSTUF(7), IMSTUF(5), NFQ, ORDER, FRQS, IERR)
         IF (ABS(ORDER).NE.1) THEN
            MSGTXT = 'FQID FREQUENCIES NOT IN ORDER'
            CALL MSGWRT (6)
            ISFQID = .FALSE.
            END IF
         END IF
C                                       apply BLC/TRC to FQID freqs
      IF (ISFQID) THEN
         J1 = MIN (BLC(NZI), TRC(NZI)) + 0.1
         J2 = MAX (BLC(NZI), TRC(NZI)) + 0.1
         IF (J1.GT.1) THEN
            I = 0
            DO 50 J = J1,J2
               I = I + 1
               FRQS(I) = FRQS(J)
 50            CONTINUE
            END IF
C                                       reverse order
         IF (BLC(NZI).GT.TRC(NZI)) THEN
            J2 = J2 - J1 + 1
            J1 = J2/2
            DO 60 J = 1,J1
               DTEMP = FRQS(J2-J+1)
               FRQS(J2-J+1) = FRQS(J)
               FRQS(J) = DTEMP
 60            CONTINUE
            END IF
         END IF
C                                       Create and open slice file.
      ISSTUF(1) = ISLUN
      CALL MAKSLI (PRGNAM, RPARMS, NZI, IMSTUF, ISSTUF, CATBLK, INOSL,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING THE SLICE FILE'
         GO TO 990
         END IF
C
 990  IF (IERR.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SLIINI ERROR',I4,' ON ',A)
      END
      SUBROUTINE MAKSLI (PRGNAM, FIRST, NZI, IMSTUF, ISSTUF, CATBLK,
     *   INOSL, IERR)
C-----------------------------------------------------------------------
C   This routine will create, open and initialize a slice file, update
C   the header for the map, and set up an array containing values needed
C   to access a map.
C   Inputs:
C      PRGNAM  C*6      Program name.  This is put in SL file header.
C      FIRST   R        First parameter in common block containing
C                       inputs from AIPS.
C      NZI     I        Relevant axis number if > 2
C      IMSTUF  I(37)    IO info for map file.  Volume all that's used.
C   In/Out:
C      ISSTUF  I(6)     IO pointers for slice file.  Input 1-LUN.
C                       output: 2-FIND, 3-?, 6-version number,
C                       4- last element updated in io buffer (0).
C                       5 - The block in slice file to write current
C                       IO buffer.
C      CATBLK    I(256)   The map header. Will be updated to show slice
C   Outputs:
C      INOSL   I        The number of points in slice.
C      IERR    I        Error code. 0=ok.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   NZI, IMSTUF(37), ISSTUF(6), CATBLK(256), INOSL, IERR
      REAL      FIRST(*)
C
      CHARACTER SFILE*48, LINE*80
      REAL      X, Y, RWBLK(512)
      INTEGER   ITRIM, IWBLK(512), IER2, IMAX, NRPBLK, NREC, IVER
      HOLLERITH HWBLK(512)
      DOUBLE PRECISION DWBLK(256), FQFINC
      INCLUDE 'SLICE.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (IWBLK, HWBLK, RWBLK, DWBLK)
C-----------------------------------------------------------------------
      LUNPR = 10
C                                       Determine number of slice points
      IF (NZI.LE.2) THEN
         X = ABS(TRC(1) - BLC(1)) + 1.0
         Y = ABS(TRC(2) - BLC(2)) + 1.0
         IMAX = SQRT (X*X + Y*Y) + 0.5
      ELSE
         IMAX = ABS (TRC(NZI)-BLC(NZI)) + 1.01
         END IF
      IF (ISFQID) THEN
         INOSL = 4 * IMAX - 3
      ELSE IF ((NZI.GT.2) .OR. (KEEP.GT.0.0)) THEN
         INOSL = IMAX
      ELSE IF (IMAX.GT.2048) THEN
         INOSL = MAX (IMAX, 8192)
      ELSE IF (IMAX.GT.1024) THEN
         INOSL = 4096
      ELSE IF (IMAX.GT.512) THEN
         INOSL = 2048
      ELSE IF (IMAX.GT.256) THEN
         INOSL = 1024
      ELSE
         INOSL = 512
         END IF
C                                       Create slice file.
      NRPBLK = 256
      NREC = (INOSL - 1) / NRPBLK  +  2
      CALL FILL (256, 0, IWBLK)
      CALL FNDEXT ('SL', CATBLK, IVER)
      IVER = IVER + 1
      CALL EXTINI ('WRIT', 'SL', IMSTUF(7), IMSTUF(5), IVER, CATBLK,
     *   ISSTUF(1), ISSTUF(2), NRPBLK, NREC, IWBLK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Create output text file,
C                                       if needed.
      WFILE = OFILE(1:1) .NE. ' '
      IF (WFILE) THEN
         CALL ZTXOPN ('WRIT', LUNPR, PFIND, OFILE, .TRUE., IERR)
         IF (IERR.NE.0) THEN
            WRITE(MSGTXT, 1020) IERR
            CALL MSGWRT(7)
            GO TO 999
            END IF
         WRITE (LINE,1045)
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:ITRIM(LINE)), IERR)
         END IF
C                                       Finish ISSTUF
      ISSTUF(3) = 0
      ISSTUF(4) = 0
      ISSTUF(5) = 3
      ISSTUF(6) = IVER
C                                       Save parameters in first record
      CALL ZFIO ('READ', ISSTUF(1), ISSTUF(2), 1, IWBLK, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       # of slice pts, # of models,
C                                       1st avail block for next model.
      IWBLK(57) = INOSL
      IWBLK(58) = 0
      IWBLK(59) = IWBLK(1) + 1
      CALL ZFIO ('WRIT', ISSTUF(1), ISSTUF(2), 1, IWBLK, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Put inputs in 2nd record.
      CALL CHR2H (6, PRGNAM, 1, HWBLK(1))
      CALL ZDATE (IWBLK(4))
      CALL ZTIME (IWBLK(7))
      IWBLK(10) = 23
      CALL RCOPY (22, FIRST, RWBLK(11))
      CALL CHR2H (4, 'AVER', 1, HWBLK(33))
      IF (ISFQID) THEN
         FQFINC = (FRQS(IMAX) - FRQS(1)) / (INOSL-1)
         RWBLK(36) = FQFINC
         DWBLK(19) = FRQS(1)
         END IF
      CALL ZFIO ('WRIT', ISSTUF(1), ISSTUF(2), 2, IWBLK, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Slice file created message.
      WRITE (MSGTXT,1050) IVER
      CALL MSGWRT (5)
      GO TO 999
C                                       destroy the slice
 990  CALL ZCLOSE (ISSTUF(1), ISSTUF(2), IER2)
      CALL ZPHFIL ('SL', IMSTUF(7), IMSTUF(5), IVER, SFILE, IER2)
      CALL ZDESTR (IMSTUF(7), SFILE, IER2)
      CALL DELEXT ('SL', IMSTUF(7), IMSTUF(5), 'WRIT', CATBLK, IWBLK,
     *   IVER, IER2)
      NCFILE = NCFILE - 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('MAKSLI: ERROR ',I3, ' RECEIVED FRO ZTXOPN')
 1040 FORMAT ('COULD NOT BUILD SLICE FILE. ZCREA3 ERR =',I6)
 1045 FORMAT (4X,'Xpix',6X,'Ypix',3X,'Slice value',5X,'X',14X,'Y',14X,
     *   'Z')
 1050 FORMAT ('SLice file version ',I5,' created.')
      END
      SUBROUTINE SLTTWO (INOSL, BBLC, TTRC, IMSTUF, ISSTUF, I0, I1,
     *   IOBLK, IERR)
C-----------------------------------------------------------------------
C   SLTTWO will write to a slice file for a given portion of a map.
C   SLTTWO is a buffer declaring and checking routine and calls
C   SLTWO.
C   Inputs:  INOSL   I   No. of slice pts.
C            BBLC    R(2)    First slice point (X Y).
C            TTRC    R(2)    Last slice point (X Y).
C            IMSTUF  I(37)   IO counters, pointers, etc. for map.
C                            initialized by INTMIO.
C            ISSTUF  I(6)    LUN, FIND, ., ., ., vers #, for slice file
C            I0      I       Row length needed for interpolation.
C            I1      I       Number of rows needed for interpolation.
C   Output:  IOBLK   I(?)    IO buffer big enough to hold at least one
C                            row of the image.
C            IERR    I       Error indicator. 0 = none.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER SFILE*48
      INTEGER   I0, I1
      REAL      ROWS(MAXIMG,9), BBLC(2), TTRC(2)
      INTEGER   INOSL, IMSTUF(37), ISSTUF(6), IOBLK(*), IERR, IER2,
     *   ISCR(256)
      INCLUDE 'SLICE.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (ISCR, ROWS)
C-----------------------------------------------------------------------
      IF (I0*I1.GT.9*MAXIMG) THEN
         IERR = 8
         WRITE (MSGTXT,1000) I0, I1
         CALL MSGWRT (8)
C                                       regular & FQID types
      ELSE
         CALL SLTWO (INOSL, BBLC, TTRC, IMSTUF, ISSTUF, ROWS, I0, I1,
     *      IOBLK, IERR)
         END IF
C                                       destroy the slice
      IF (IERR.GT.0) THEN
         CALL ZCLOSE (ISSTUF(1), ISSTUF(2), IER2)
         CALL ZPHFIL ('SL', IMSTUF(7), IMSTUF(5), ISSTUF(6), SFILE,
     *      IER2)
         CALL ZDESTR (IMSTUF(7), SFILE, IER2)
         CALL DELEXT ('SL', IMSTUF(7), IMSTUF(5), 'WRIT', ISCR, IOBLK,
     *      ISSTUF(6), IER2)
         NCFILE = NCFILE - 1
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CANNOT HANDLE X,Y SIZE = ',2I7)
      END
      SUBROUTINE SLTWO (INOSL, BBLC, TTRC, IMSTUF, ISSTUF, ROWS,
     *   I0, I1, IOBLK, IERR)
C-----------------------------------------------------------------------
C   SLTWO will write to a slice file for a given portion of a map.
C   Inputs:  INOSL   I       No. of slice pts.
C            BBLC    R(2)    First slice point (X Y).
C            TTRC    R(2)    Last slice point (X Y).
C            IMSTUF  I(37)   IO counters, pointers, etc. for map.
C                            initialized by INTMIO.
C            ISSTUF  I(6)    LUN, FIND, ., ., ., vers # for slice file
C            ROWS    R(I0,   I1) Buffer holding rows of image needed
C                            for interpolation.
C            I0      I       Row length needed for interpolation.
C            I1      I       Number of rows needed for interpolation.
C   Output:  IOBLK   I(?)    IO buffer big enough to hold at least one
C                            row of the image.
C            IERR    I       Error indicator. 0 = none.
C-----------------------------------------------------------------------
      INTEGER   INOSL, IMSTUF(37), ISSTUF(6), I0, I1, IOBLK(*), IERR
      REAL      BBLC(2), TTRC(2), ROWS(I0,I1)
C
      REAL      DX, DY, X, Y, MINMAX(2)
      INTEGER   I, ROWPTR(15), ITRIM, LNOSL
      DOUBLE PRECISION FINC, F0
      CHARACTER LINE*80
      INCLUDE 'SLICE.INC'
      REAL      SLROW(MAXIMG)
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IF (ISFQID) THEN
         LNOSL = (INOSL + 3) / 4
      ELSE
         LNOSL = INOSL
         END IF
C                                       X and Y distances per slice pt.
      DX = (TTRC(1) - BBLC(1)) / (LNOSL - 1)
      DY = (TTRC(2) - BBLC(2)) / (LNOSL - 1)
C                                       Set initial values for min max.
      MINMAX(1) = 1.0E30
      MINMAX(2) = - MINMAX(1)
C                                       Set up row pointers to force
C                                       first reads.
      ROWPTR(1) = IMSTUF(17)
      ROWPTR(3) = IMSTUF(18)
      ROWPTR(5) = IMSTUF(37)
C                                       Reading forward
      IF (IMSTUF(19).LE.IMSTUF(20)) THEN
         ROWPTR(2) = IMSTUF(19) - MORD12
         ROWPTR(4) = IMSTUF(19) - 1
C                                       Backward read
      ELSE
         ROWPTR(2) = IMSTUF(19) + 1
         ROWPTR(4) = IMSTUF(19) + MORD12
         END IF
C
      DO 10 I = 6,14
         ROWPTR(I) = I - 5
 10      CONTINUE
C
      DO 30 I = 1,LNOSL
C                                       Calculate X and Y
         X = (I - 1) * DX  +  BBLC(1)
         Y = (I - 1) * DY  +  BBLC(2)
C                                       See if correct row is in core,
C                                       if not read.
         CALL FNDROW (IMSTUF, Y, I0, I1, ROWPTR, IOBLK, ROWS, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Interpolate.
         CALL ETERP (X, Y, I0, I1, ROWPTR, ROWS, SLROW(I))
C                                       Set slice value, write if needed
         IF (.NOT.ISFQID) THEN
            CALL SLPUT (X, Y, ISSTUF, SLROW(I), MINMAX, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 30      CONTINUE
C                                       FQID interpolation needed
      IF (ISFQID) THEN
         CALL FQTERP (LNOSL, SLROW, FRQS)
         FINC = (FRQS(LNOSL) - FRQS(1)) / (INOSL - 1)
         F0 = FRQS(1) - FINC
         DO 40 I = 1,INOSL
            F0 = F0 + FINC
            ISSTUF(4) = ISSTUF(4) + 1
            SBLK(ISSTUF(4)) = SLROW(I)
C                                       Write to text file
C                                       Update the max and min.
            IF (SLROW(I).NE.FBLANK) THEN
               MINMAX(1) = MIN (MINMAX(1), SLROW(I))
               MINMAX(2) = MAX (MINMAX(2), SLROW(I))
               IF (WFILE) THEN
                  WRITE(LINE,1010) SLROW(I), F0
                  CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:ITRIM(LINE)),
     *               IERR)
                  IF (IERR.NE.0) GO TO 999
                  END IF
               END IF
C                                       Write this buffer.
            IF (ISSTUF(4).GE.256) THEN
               CALL ZFIO ('WRIT', ISSTUF(1), ISSTUF(2), ISSTUF(5),
     *            ISBLK, IERR)
               IF (IERR.NE.0) GO TO 999
               ISSTUF(5) = ISSTUF(5) + 1
               ISSTUF(4) = 0
               END IF
 40         CONTINUE
         END IF
C                                       Slice file cleanup, write last
C                                       buffer, etc.
      CALL SLCLS (ISSTUF, MINMAX, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (19X,1PE15.6,1PE15.7)
      END
      SUBROUTINE FNDROW (IMSTUF, Y, I0, I1, ROWPTR, IOBLK, ROWS, IERR)
C-----------------------------------------------------------------------
C   This routine will calculate the rows needed in ROWS to interpolate
C   at a given row.  If the correct row is not in ROWS, the
C   routine will read in the next rows, reading over the oldest rows,
C   until the correct rows are available.  The routine uses a rotating
C   buffer concept using information in ROWPTR to keep track of which
C   rows are where.
C   Inputs:
C     IMSTUF    I(4)    Vector containing all the information needed by
C                       the AIPS IO system for the image, i.e.
C                       LUN, FIND, ... This is initialized by INTMIO.
C     Y         R       Y position of point.
C     I0        I       Length of rows of ROWS.
C     I1        I       Number of rows in ROWS.
C  In/Out:
C     ROWPTR    I(15)   BLCX, BLCY, TRCX, TRCY of plane in ROWS, fwd
C                       backward flag (1 or -1)
C                       Elements 6-? are pointers to rows in ROWS
C                       starting with the bottomest.
C     IOBLK     I(?)    IO buffer, big enough for at least 1 row,
C                       two rows if you want double buffering.
C     ROWS      R(I0,   I1)
C-----------------------------------------------------------------------
      INTEGER   I0, I1
      REAL      ROWS(I0,I1)
      REAL      Y
      INTEGER   IMSTUF(37), ROWPTR(15), IOBLK(*), IERR, IY, IYNEED,
     *   IYGOT, I, IOLDST, IUSED, ISAVE, II, ISGN, ICTR
      LOGICAL   EOF, OFFEDG
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
      IY = Y
      ISGN = ROWPTR(5)
      IF (ISGN.GT.0) IYNEED = IY + (I1 / 2)
      IF (ISGN.LT.0) IYNEED = IY - (I1 / 2) + 1
      IYGOT = ROWPTR(3+ISGN)
C                                       FORTRAN 66 DO WHILE
      DO 500 I = 1,9999
C                                       See if we have enough pts or
C                                       points we need are off map.
         OFFEDG = ISGN*ROWPTR(3-ISGN) .LT. ISGN*IMSTUF(19)
         IF ( ((ISGN*IYNEED).LE.(ISGN*IYGOT)) .AND. (.NOT.OFFEDG))
     *      GO TO 999
C                                       See if at edge of map.
         IYGOT = IYGOT + ISGN
         IF ( (ISGN*IYGOT).GT.(ISGN*IMSTUF(20))) GO TO 999
         IUSED = ROWPTR(4) - ROWPTR(2) + 6
         IOLDST = ROWPTR(6)
         IF (ISGN.LT.0) IOLDST = ROWPTR(IUSED)
         CALL GETROW (IMSTUF, IOBLK, ROWS(1,IOLDST), EOF, IERR)
         IF (EOF) GO TO 980
         IF (IERR.NE.0) GO TO 999
C                                       Update pointers
         ROWPTR(4) = ROWPTR(4) + ISGN
         ROWPTR(2) = ROWPTR(2) + ISGN
C                                       Reading forward.
         IF (ISGN.GE.0) THEN
            ISAVE = ROWPTR(6)
            DO 100 II = 7,IUSED
               ROWPTR(II-1) = ROWPTR(II)
 100           CONTINUE
            ROWPTR(IUSED) = ISAVE
C                                       Reading backward.
         ELSE
            ISAVE = ROWPTR(IUSED)
            ICTR = IUSED - 6
            DO 400 II = 1,ICTR
               ROWPTR(IUSED-II+1) = ROWPTR(IUSED-II)
 400           CONTINUE
            ROWPTR(6) = ISAVE
            END IF
 500     CONTINUE
      IERR = 1
      WRITE (MSGTXT,1500)
      CALL MSGWRT (8)
      GO TO 999
C                                       Premature EOF
 980  CONTINUE
      WRITE (MSGTXT,1980)
      CALL MSGWRT (8)
      IERR = 4
C
 999  RETURN
C-----------------------------------------------------------------------
 1500 FORMAT ('FNDROW: FATAL ERROR COUNTING ROWS!')
 1980 FORMAT ('FNDROW: UNEXPECTED END OF FILE ON MAP')
      END
      SUBROUTINE SLTHRE (INOSL, BBLC, IMSTUF, ISSTUF, IOBLK, IERR)
C-----------------------------------------------------------------------
C   SLTHRE will write to a slice file for a given portion of a map
C   One X,Y pixel per plane.
C   Inputs:
C      INOSL    I       No. of slice pts.
C      BBLC     R(7)    First slice point (X Y).
C      IMSTUF   I(37)   IO counters, pointers, etc. for map.
C                       initialized by INTMIO.
C      ISSTUF   I(6)    LUN, FIND, ., ., ., vers # for slice file
C   Output:
C      IOBLK    I(*)    IO buffer big enough to hold at least one row of
C                       the image.
C      IERR     I       Error indicator. 0 = none.
C-----------------------------------------------------------------------
      INTEGER   INOSL, IMSTUF(37), ISSTUF(6), IOBLK(*), IERR
      REAL      BBLC(7)
C
      REAL      X, Y, MINMAX(2), WT(4), VALS(4)
      INTEGER   I, ITRIM, LNOSL, IER2, NX, NY
      DOUBLE PRECISION FINC, F0
      CHARACTER LINE*80, SFILE*48
      INCLUDE 'SLICE.INC'
      REAL      SLROW(MAXIMG)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
      IF (ISFQID) THEN
         LNOSL = (INOSL + 3) / 4
      ELSE
         LNOSL = INOSL
         END IF
C                                       interpolate
      NX = FILTAB(POTRC,6) - FILTAB(POBLC,6) + 1
      NY = FILTAB(POTRC+1,6) - FILTAB(POBLC+1,6) + 1
      CALL RFILL (4, 0.0, VALS)
      X = BBLC(1) - FILTAB(POBLC,6)
      Y = BBLC(2) - FILTAB(POBLC+1,6)
      WT(1) = (1.0 - X) * (1.0 - Y)
      WT(2) = X * (1.0 - Y)
      WT(3) = (1.0 - X) * Y
      WT(4) = X * Y
C                                       Set initial values for min max.
      MINMAX(1) = 1.0E30
      MINMAX(2) = - MINMAX(1)
      X = BBLC(1)
      Y = BBLC(2)
C                                       read data
      DO 30 I = 1,LNOSL
         IF (NX*NY.EQ.1) THEN
            CALL MAPIO ('READ', IMSTUF(1), SLROW(I), IERR)
            IF (IERR.NE.0) GO TO 900
         ELSE
            CALL MAPIO ('READ', IMSTUF(1), VALS(1), IERR)
            IF (IERR.NE.0) GO TO 900
            IF (NY.EQ.2) THEN
               CALL MAPIO ('READ', IMSTUF(1), VALS(3), IERR)
               IF (IERR.NE.0) GO TO 900
               END IF
            SLROW(I) = WT(1)*VALS(1) + WT(2)*VALS(2) + WT(3)*VALS(3)
     *         + WT(4)*VALS(4)
            END IF
C                                       Set slice value, write if needed
         IF (.NOT.ISFQID) THEN
            CALL SLPUT (X, Y, ISSTUF, SLROW(I), MINMAX, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
 30      CONTINUE
C                                       FQID interpolation needed
      IF (ISFQID) THEN
         CALL FQTERP (LNOSL, SLROW, FRQS)
         FINC = (FRQS(LNOSL) - FRQS(1)) / (INOSL - 1)
         F0 = FRQS(1) - FINC
         DO 40 I = 1,INOSL
            F0 = F0 + FINC
            ISSTUF(4) = ISSTUF(4) + 1
            SBLK(ISSTUF(4)) = SLROW(I)
C                                       Write to text file
C                                       Update the max and min.
            IF (SLROW(I).NE.FBLANK) THEN
               MINMAX(1) = MIN (MINMAX(1), SLROW(I))
               MINMAX(2) = MAX (MINMAX(2), SLROW(I))
               IF (WFILE) THEN
                  WRITE(LINE,1010) SLROW(I), F0
                  CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:ITRIM(LINE)),
     *               IERR)
                  IF (IERR.NE.0) GO TO 900
                  END IF
               END IF
C                                       Write this buffer.
            IF (ISSTUF(4).GE.256) THEN
               CALL ZFIO ('WRIT', ISSTUF(1), ISSTUF(2), ISSTUF(5),
     *            ISBLK, IERR)
               IF (IERR.NE.0) GO TO 900
               ISSTUF(5) = ISSTUF(5) + 1
               ISSTUF(4) = 0
               END IF
 40         CONTINUE
         END IF
C                                       Slice file cleanup, write last
C                                       buffer, etc.
      CALL SLCLS (ISSTUF, MINMAX, IERR)
C                                       destroy the slice
 900  IF (IERR.GT.0) THEN
         CALL ZCLOSE (ISSTUF(1), ISSTUF(2), IER2)
         CALL ZPHFIL ('SL', IMSTUF(7), IMSTUF(5), ISSTUF(6), SFILE,
     *      IER2)
         CALL ZDESTR (IMSTUF(7), SFILE, IER2)
         CALL DELEXT ('SL', IMSTUF(7), IMSTUF(5), 'WRIT', ISBLK, IOBLK,
     *      ISSTUF(6), IER2)
         NCFILE = NCFILE - 1
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (19X,1PE15.6,1PE15.7)
      END
      SUBROUTINE ETERP (DX, DY, I0, I1, ROWPTR, ROWS, OUTVAL)
C-----------------------------------------------------------------------
C  Subroutine to do Everett interpolation.  INITEI should be called once
C  with the order of the interpolation desired to set up variables in
C  common before any subsequent calls to this routine.
C  Inputs:
C    DX      R        X position.
C    DY      R        Y position.
C    I0      I        Number of X pts in ROWS.
C    I1      I        Number of Y pts in ROWS.
C    ROWPTR  I(14)    Array components 1, 2, 3, 4, 5 contain the X BLC,
C                     Y BLC, X TRC, YTRC of the elements contained in
C                     array ROWS and the forward (1) backward (-1)
C                     read flag. Components 6 though (XTRC - XBLC + 6)
C                     contain indices into ROWS ordered from bottom to
C                     top, that is if ROWPTR(6) equals 4, then ROWS(*,4)
C                     contains the bottomest row of the map that can be
C                     found in ROWS.
C    ROWS    R(I0,   I1) Data grid used in interpolation.  Rows are in
C                     the order specified by ROWPTR (see above).
C-----------------------------------------------------------------------
      INTEGER   I0, I1
      REAL      DX, DY, ROWS(I0,I1), SVX(14), SVY(14), OUTVAL, XSUM,
     *   ZIKP, OUTWT, XWT
      INTEGER   IXI, IYI, K, J, JP, JPZI, ROWPTR(14), KP
      INCLUDE 'SLICE.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      OUTVAL = 0.0
      OUTWT = 0.0
      CALL IEVERT (DX, IXI, SVX)
      CALL IEVERT (DY, IYI, SVY)
C                                       Loop on y-interpolation:
      DO 130 J = 1,MORD12
         JP = J + IYI
         IF (JP.LT.ROWPTR(2)) JP = ROWPTR(2) + ROWPTR(2) - JP - 1
         IF (JP.GT.ROWPTR(4)) JP = ROWPTR(4) + ROWPTR(4) - JP + 1
         JPZI = ROWPTR(JP-ROWPTR(2)+6)
         XSUM = 0.0
         XWT = 0.0
C                                       Do an x-interpolation:
         DO 120 K = 1,MORD12
            KP = K + IXI
            IF ((KP.GE.ROWPTR(1)) .AND. (KP.LE.ROWPTR(3))) GO TO 115
               IF ((KP.LT.ROWPTR(1)-MORD1) .OR. (KP.GT.ROWPTR(3)+MORD1))
     *            GO TO 130
                  IF (KP.LT.ROWPTR(1)) KP = ROWPTR(1) + ROWPTR(1) -
     *               KP - 1
                  IF (KP.GT.ROWPTR(3)) KP = ROWPTR(3) + ROWPTR(3) -
     *               KP + 1
 115        ZIKP = ROWS((KP-ROWPTR(1)+1),JPZI)
            IF (ZIKP.NE.FBLANK) THEN
               XSUM = XSUM + (ZIKP * SVX(K))
               XWT = XWT + SVX(K)
               END IF
 120        CONTINUE
         OUTVAL = OUTVAL + (XSUM * SVY(J))
         OUTWT = OUTWT + (XWT * SVY(J))
 130     CONTINUE
C                                       Use well determined points
      IF (OUTWT.LE.0.5) THEN
         OUTVAL = FBLANK
      ELSE
         OUTVAL = OUTVAL / OUTWT
         END IF
C
 999  RETURN
      END
      SUBROUTINE INITEI (IORD)
C-----------------------------------------------------------------------
C   INITEI computes certain quantities which are needed by IEVERT
C   when it computes the actual weights for an interpolation. The
C   result produced by INITEI is in the BCOEF array in the COMMON
C   block, and is based on binomial coefficients computed by BINOM.
C   From the Everett interpolation package originally coded by
C   Larry Goad at KPNO.
C   Input:
C      IORD    I    The order of the interpolation, 0 = linear,
C                   1 = cubic, 2 = quintic, 3 = septic.
C-----------------------------------------------------------------------
      INTEGER   IORD
      INTEGER   IN, NT, M, N
      REAL      XT
      INCLUDE 'SLICE.INC'
      INCLUDE 'SLICE2.INC'
C-----------------------------------------------------------------------
      MORD = IORD
      MORD1 = MORD + 1
      MORD21 = MORD + MORD1
      MORD12 = MORD1 + MORD1
      MORD2 = MIN (IORD, 6)
      IN = 1
      NT = 0
      BCOEF(1) = 1.
C                                   Compute the BCOEF array:
      DO 50 M = 1,MORD2
         IN = IN + NT + 1
         NT = M + M
         XT = NT
         CALL BINOM (XT, NT, BCOEF(IN))
C
         DO 40 N = 1,NT,2
            BCOEF(IN+N) = -BCOEF(IN+N)
 40         CONTINUE
 50      CONTINUE
C                                    Set up pointer constants:
      IS0   = MORD2 + 1
      NVALS = IS0  + IS0
C
 999  RETURN
      END
      SUBROUTINE IEVERT (DX, IX, SVECT)
C-----------------------------------------------------------------------
C   Compute subscript offset and weights for interpolating at a
C   specified position in a vector.  Interpolation is done using a
C   group of pixels centered on the specified position. The order of
C   interpolation is specified by integer MORD in subroutine SETCOF.
C   We do linear interpolation for MORD=0, cubic for 1, and quintic
C   for 2. If MORD=1 (i.e., cubic interpolation) we will be using
C   four pixels in the interpolation.  From the Everett interpolation
C   package originally coded by Larry Goad at KPNO.
C   Inputs:  DX     R       Position in vector
C   Outputs: IX     I       Offset to start
C            SVECT  R(*)    Weights
C-----------------------------------------------------------------------
      INTEGER   IX
      REAL      SVECT(*), DX
      INTEGER   NR, IR0, IV0, MC, IR
      REAL      U, W, CW, CU, W2, U2
      INCLUDE 'SLICE2.INC'
C-----------------------------------------------------------------------
      IX = DX
      U  = DX - IX
      IX = IX - IS0
      CALL RFILL (NVALS, 0.0, SVECT)
C                                       distance of point from cells
      W  = 1.0 - U
      CW = W
      CU = U
      W2 = W * W
      U2 = U * U
      SVECT(IS0)   = W
      SVECT(IS0+1) = U
C                                       leave if on cell or linear
      IF ((U.EQ.0) .OR. (MORD2.EQ.0)) GO TO 999
      NR  = 1
      IR0 = 0
      IV0 = IS0 - 1
      DO 20 MC = 1,MORD2
C                                       (IR0=MC*MC):
         IR0 = IR0 + NR
C                                       (NR=2*MC+1):
         NR  = NR  + 2
C                                       (IV0=IS0-MC-1):
         IV0 = IV0 - 1
         CU  = CU * (U2 - IR0) / ((IR0 + IR0 + MC) + (IR0 + IR0 + MC))
         CW  = CW * (W2 - IR0) / ((IR0 + IR0 + MC) + (IR0 + IR0 + MC))
         DO 10 IR = 1,NR
            SVECT(IV0+IR)   = SVECT(IV0+IR)   + CW * BCOEF(IR0+IR)
            SVECT(IV0+IR+1) = SVECT(IV0+IR+1) + CU * BCOEF(IR0+IR)
 10         CONTINUE
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE BINOM (X, M, VAL)
C-----------------------------------------------------------------------
C   BINOM generates binomial coefficients for use in the Everett
C   interpolation routines. It is called only by SETCOF.  From the
C   Everett interpolation package originally coded by Larry Goad, KPNO.
C-----------------------------------------------------------------------
      INTEGER    M
      REAL       X, VAL(*)
      INTEGER    I
      REAL       R, XL
C-----------------------------------------------------------------------
      VAL(1) = 1.
      R = 0.
      XL = X + 1.
C
      DO 20 I = 1,M
         XL = XL - 1.
         R = R + 1.
         VAL(I+1) = VAL(I) * XL / R
 20      CONTINUE
C
      RETURN
      END
      SUBROUTINE SLPUT (DX, DY, ISTUF, SLVAL, MINMAX, IERR)
C-----------------------------------------------------------------------
C   This routine will sequentialy write to a slice file created
C   with MAKSLI.  The routine will update counters in ISTUF and keep
C   track of the min and max.
C   Inputs:
C      DX       R        X position.
C      DY       R        Y position.
C      ISTUF    I(6)     (1) is the LUN.
C                        (2) is the FTAB index.
C                        (3) ...
C                        (4) is the last element used in SBLK. 0= none.
C                        (5) is the block in file to write current SBLK.
C                        (6) is the slice version number
C      SLVAL    R        Value of next slice point.
C   In/Out:
C      MINMAX   R(2)     minimum and maximum value in slice.
C      SBLK     R(256)   IO buffer.
C   Output:
C      IERR     I        Error code 0=ok.
C-----------------------------------------------------------------------
      REAL      DX, DY, SLVAL, MINMAX(2)
      INTEGER   ISTUF(5), IERR
C
      INTEGER   I, ITRIM
      CHARACTER LINE*80
      DOUBLE PRECISION X, Y, Z
      INCLUDE 'SLICE.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
C-----------------------------------------------------------------------
      ISTUF(4) = ISTUF(4) + 1
      I = ISTUF(4)
      SBLK(I) = SLVAL
C                                       Write to text file
      IF (WFILE) THEN
         CALL XYVAL (DX, DY, X, Y, Z, I)
         IF (AXTYP(LOCNUM).LE.1) Z = ZZ
         WRITE(LINE,1010) DX, DY, SLVAL, X, Y, Z
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:ITRIM(LINE)), IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Write this buffer.
      IF (ISTUF(4).GE.256) THEN
         CALL ZFIO ('WRIT', ISTUF(1), ISTUF(2), ISTUF(5), ISBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         ISTUF(5) = ISTUF(5) + 1
         ISTUF(4) = 0
         END IF
C                                       Update the max and min.
      IF (SLVAL.NE.FBLANK) THEN
         MINMAX(1) = MIN (MINMAX(1), SLVAL)
         MINMAX(2) = MAX (MINMAX(2), SLVAL)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (F9.3,F10.3,1PE15.6,3(1PE15.7))
      END
      SUBROUTINE SLCLS (ISTUF, MINMAX, IERR)
C-----------------------------------------------------------------------
C   This routine will perform some cleanup functions for a new slice
C   file created with MAKSLI and written into with SLPUT.  This routine
C   will write the last buffer if needed, update the max and min in the
C   slice file header (block two), close the file.
C   Inputs:
C      ISTUF    I(6)     (1) is the LUN.
C                        (2) is the FTAB index.
C                        (3)
C                        (4) is the last element used in SBLK. 0= none.
C                        (5) is the block in file to write current SBLK.
C                        (6) slice version number.
C      MINMAX   R(2)     minimum and maximum value in slice.
C   In/Out:
C      SBLK     R(256)   IO buffer.
C   Output:
C      IERR     I        Error code 0=ok.
C-----------------------------------------------------------------------
      REAL      MINMAX(2)
      INTEGER   ISTUF(6), IERR
      INCLUDE 'SLICE.INC'
C-----------------------------------------------------------------------
C                                       Save last buffer.
      IF (ISTUF(4).GT.0) THEN
         CALL ZFIO ('WRIT', ISTUF(1), ISTUF(2), ISTUF(5), ISBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Update the max and min.
      CALL ZFIO ('READ', ISTUF(1), ISTUF(2), 2, ISBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Max-min after 11+NPARM
      SBLK(34) = MINMAX(1)
      SBLK(35) = MINMAX(2)
      CALL ZFIO ('WRIT', ISTUF(1), ISTUF(2), 2, ISBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Close file.
      CALL ZCLOSE (ISTUF(1), ISTUF(2), IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Close text file
      IF (WFILE) THEN
         CALL ZTXCLS (LUNPR, PFIND, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C
 999  RETURN
      END
      SUBROUTINE FQTERP (IFQN, SLROW, FRQS)
C-----------------------------------------------------------------------
C   Smooths data from irregular grid to regular one
C   Inputs:
C      IFQN    I      Number input FQID points
C      FRQS    D(*)   Frequencies
C   In/out:
C      SLROW   R(*)   In: IFQN values
C                     Out: 4*IFQN-3 values on regular grid
C-----------------------------------------------------------------------
      INTEGER   IFQN
      REAL      SLROW(*)
      DOUBLE PRECISION FRQS(*)
C
      INCLUDE 'INCS:PMAD.INC'
      REAL      SB(MAXIMG), WT(MAXIMG), W
      INTEGER   NG(MAXIMG), NB(MAXIMG), IN, OUT, LNZI
      DOUBLE PRECISION FQFINC, FW, FR, F
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      LNZI = 4 * IFQN - 3
      FQFINC = (FRQS(IFQN) - FRQS(1)) / (LNZI - 1)
      CALL RFILL (LNZI, 0.0, SB)
      CALL RFILL (LNZI, 0.0, WT)
      CALL FILL (LNZI, 0, NG)
      CALL FILL (LNZI, 0, NB)
      FW = 2.5D0 * FQFINC
C                                       convolve
      DO 30 IN = 1,IFQN
         FR = FRQS(IN)
         F = FRQS(1) - FQFINC
         DO 20 OUT = 1,LNZI
            F = F + FQFINC
            W = ((FR - F) / FW) ** 2
            IF (W.LT.10.D0) THEN
               IF (SLROW(IN).NE.FBLANK) THEN
                  W = EXP(-W)
                  WT(OUT) = WT(OUT) + W
                  SB(OUT) = SB(OUT) + W * SLROW(IN)
                  NG(OUT) = NG(OUT) + 1
               ELSE
                  NB(OUT) = NB(OUT) + 2
                  END IF
               END IF
 20         CONTINUE
 30      CONTINUE
C                                       average
      DO 40 OUT = 1,LNZI
         IF ((WT(OUT).GT.0.0) .AND. (NB(OUT).LT.NG(OUT))) THEN
            SLROW(OUT) = SB(OUT) / WT(OUT)
         ELSE
            SLROW(OUT) = FBLANK
            END IF
 40      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SLNDOW (NAX, NPTS, KEEP, BLC, TRC, IERR)
C-----------------------------------------------------------------------
C   WINDOW interprets user window BLC, TRC into usable values
C   special version allows TRC < BLC
C   Inputs:
C      NAX   I        Number of axes
C      NPTS  I(7)     Number of points / axis
C   In/out:
C      BLC   R(7)     Bottom left corner
C      TRC   R(7)     Top right corner
C   Output:
C      IERR  I        Number of bad axes (0 => ok)
C-----------------------------------------------------------------------
      INTEGER    NAX, NPTS(7), IERR
      REAL       KEEP, BLC(7), TRC(7)
C
      LOGICAL    BEQU
      INTEGER    I, N, J
C-----------------------------------------------------------------------
C                                        BLC = const (all same?)
      BEQU = .TRUE.
      DO 10 I = 1,7
         IF (BLC(I).NE.BLC(1)) BEQU = .FALSE.
 10      CONTINUE
C                                        Set null axes
      IF (NAX.LT.7) THEN
         N = NAX + 1
         DO 15 I = N,7
            BLC(I) = 1.0
            TRC(I) = 1.0
 15         CONTINUE
         END IF
C                                        In range: set,check
      IERR = 0
      DO 30 I = 1,NAX
         IF (NPTS(I).LE.1) THEN
            BLC(I) = 1.0
            TRC(I) = 1.0
            END IF
         IF (TRC(I).LE.0.89) TRC(I) = NPTS(I)
         IF (TRC(I).GT.NPTS(I)) TRC(I) = NPTS(I)
         IF (BLC(I).LT.1.0) BLC(I) = 1.0
         IF (BLC(I).GT.NPTS(I)) BLC(I) = NPTS(I)
 30      CONTINUE
C                                       round off to integer
      IF ((KEEP.GT.0.0) .AND. ((TRC(1)-BLC(1).EQ.0.0) .OR.
     *   (TRC(2)-BLC(2).EQ.0.0))) THEN
         DO 45 I = 1,2
            J = BLC(I) + 0.01
            BLC(I) = J
            J = TRC(I) + 0.89
            TRC(I) = J
 45         CONTINUE
         END IF
      DO 50 I = 3,NAX
         N = BLC(I) + 0.5
         J = TRC(I) + 0.5
         IF (N.LE.J) THEN
            BLC(I) = N
            TRC(I) = J
         ELSE
            BLC(I) = J
            TRC(I) = N
            END IF
 50      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE GETBND (NUMIF, FREQS, BNDCOD, IBANDF, CHBAND)
C-----------------------------------------------------------------------
C! find the bandcode to apply with these data
C# Utility UV VLA Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2014
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Finds the band code number
C   Inputs:
C      NUMIF    I        Number frequencies
C      FREQS    D(*)     Frequencies: ones < 1000 -> GHz, else Hz
C      BNDCOD   C(*)*8   band codes
C   Output:
C      IBANDF   I        band number 1-10 - message if confusion
C      CHBAND   C*(*)    1-character code for IBANDF
C-----------------------------------------------------------------------
      INTEGER   NUMIF, IBANDF
      DOUBLE PRECISION FREQS(*)
      CHARACTER BNDCOD(*)*(*), CHBAND*(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   I, J, K, L, LBAND(MAXIF), LERR(MAXIF)
      DOUBLE PRECISION FORMAL(10), SAFE(10,2), EXTREM(10,2), DM
      CHARACTER CODES(10)*1, LCODE*1
      INCLUDE 'INCS:DMSG.INC'
      DATA CODES / '4', 'P', 'L', 'S', 'C', 'X', 'U', 'K', 'A', 'Q'/
      DATA FORMAL /0.15D9, 0.7D9, 2.0D9, 4.D0, 8.D9, 12.D9, 18.D9,
     *   26.5D9, 40.0D9, 56.0D9/
      DATA EXTREM /0.0D0, 0.15D9, 0.7D9, 2.0D9, 4.0D0, 8.0D9, 12.D9,
     *   18.D9,  26.5D9, 38.5D9,
     *            0.15D9, 0.7D9,  2.0D9, 4.0D0, 8.0D9, 12.D9, 18.D9,
     *   26.5D9, 40.5D9, 60.0D9/
      DATA SAFE /0.0D0, 0.15D9, 0.7D9, 2.0D9, 4.0D0, 8.0D9, 12.D9,
     *   18.D9,  26.5D9, 40.5D9,
     *            0.15D9, 0.7D9,  2.0D9, 4.0D0, 8.0D9, 12.D9, 18.D9,
     *   26.5D9, 38.5D9, 56.0D9/
C-----------------------------------------------------------------------
      IBANDF = 0
      DM = 1.0D0
      IF (FREQS(1).LE.1.D3) DM = 1.0D9
C                                       loop for each IF
      DO 30 I = 1,NUMIF
         LBAND(I) = 0
         LERR(I) = 0
C                                       did they tell us?
         IF (BNDCOD(I).NE.' ') THEN
            IF (BNDCOD(I)(:5).EQ.'EVLA_') THEN
               LCODE = BNDCOD(I)(6:6)
            ELSE
               LCODE = BNDCOD(I)(:1)
               END IF
            DO 10 J = 1,10
               IF (LCODE.EQ.CODES(J)) THEN
                  LBAND(I) = J
                  IBANDF = J
                  IF ((DM*FREQS(I).GE.SAFE(J,1)) .AND.
     *               (DM*FREQS(I).LE.SAFE(J,2))) LERR(I) = -1
                  IF ((DM*FREQS(I).LT.EXTREM(J,1)) .AND.
     *               (DM*FREQS(I).GT.EXTREM(J,2))) LERR(I) = 1
                  END IF
 10            CONTINUE
            END IF
C                                       no - look at formal boundaries
         IF (LBAND(I).LE.0) THEN
            DO 20 J = 1,10
               IF (DM*FREQS(I).LT.FORMAL(J)) THEN
                  LBAND(I) = J
                  IF ((DM*FREQS(I).GE.SAFE(J,1)) .AND.
     *               (DM*FREQS(I).LE.SAFE(J,2))) LERR(I) = -1
                  GO TO 30
                  END IF
 20            CONTINUE
            END IF
 30      CONTINUE
C                                       now what is the single answer
      J = NUMIF / 2
      J = MAX (1, J)
      IF ((LBAND(J).GT.0) .AND. (LERR(J).LT.0)) THEN
         IBANDF = LBAND(J)
      ELSE
         DO 35 K = 1,J
            L = J + K
            IF ((L.LE.NUMIF) .AND. (LBAND(L).GT.0) .AND. (LERR(L).LT.0))
     *         THEN
               IBANDF = LBAND(L)
               GO TO 50
               END IF
            L = J - K
            IF ((L.GE.1) .AND. (LBAND(L).GT.0) .AND. (LERR(L).LT.0))
     *         THEN
               IBANDF = LBAND(L)
               GO TO 50
               END IF
 35         CONTINUE
         DO 40 K = 1,J
            L = J - K + 1
            IF ((L.GE.1) .AND. (LBAND(L).GT.0) .AND. (LERR(L).LE.0))
     *         THEN
               IBANDF = LBAND(L)
               GO TO 50
               END IF
            L = J + K
            IF ((L.LE.NUMIF) .AND. (LBAND(L).GT.0) .AND. (LERR(L).LE.0))
     *         THEN
               IBANDF = LBAND(L)
               GO TO 50
               END IF
 40         CONTINUE
         MSGTXT = 'GETBND: NO OBVIOUS BAND IDENTIFICATION'
         CALL MSGWRT (7)
         IF (IBANDF.LE.0) GO TO 999
         END IF
C                                       is it consistent?
 50   DO 70 I = 1,NUMIF
         IF (LBAND(I).NE.IBANDF) THEN
            IF ((DM*FREQS(I).LT.EXTREM(IBANDF,1)) .OR.
     *         (DM*FREQS(I).GT.EXTREM(IBANDF,2))) THEN
               WRITE (MSGTXT,1050) I, CODES(LBAND(I)), CODES(IBANDF)
               CALL MSGWRT (6)
               END IF
            END IF
 70      CONTINUE
      CHBAND = CODES(IBANDF)
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('GETBND IF',I3,' APPARENT BAND ID ',A1,
     *   ' INCONSISTENT WITH SELECTED BAND ',A1)
      END

LOCAL INCLUDE 'RFARS.INC'
      INCLUDE 'INCS:PMAD.INC'
      HOLLERITH XNAM1(3), XCLS1(2), XNAM2(3), XCLS2(2), XNAM3(3),
     *   XCLS3(2), ONAM1(3), OCLS1(2), ONAM2(3), OCLS2(2)
      REAL      XS1, XD1, XS2, XD2, XS3, XD3, OS1, OD1, OS2, OD2,
     *   BLC(7), TRC(7)
      COMMON /INPARM/ XNAM1, XCLS1, XS1, XD1, XNAM2, XCLS2, XS2, XD2,
     *   XNAM3, XCLS3, XS3, XD3, ONAM1, OCLS1, OS1, OD1, ONAM2, OCLS2,
     *   OS2, OD2, BLC, TRC
      CHARACTER NAMIN(3)*12, CLSIN(3)*6, NAMOUT(2)*12, CLSOUT(2)*6
      COMMON /CHPARM/ NAMIN, CLSIN, NAMOUT, CLSOUT
C
      INTEGER   CATSI(256,5)
      REAL      CATSR(256,5)
      HOLLERITH CATSH(256,5)
      DOUBLE PRECISION CATSD(128,5)
      EQUIVALENCE (CATSD, CATSH, CATSR, CATSI)
      INTEGER   SEQI(3), DISKI(3), SEQO(2), DISKO(2), SCRTCH(512),
     *   LUNI(3), LUNO(2), INDI(3), INDO(2), CNOI(3), CNOO(2), JBUFSZ
      DOUBLE PRECISION LAMBS(MAXIMG)
      REAL      BUFF1(MABFSS), BUFF2(MABFSS), BUFF3(MABFSS),
     *   BUFF4(MABFSS)
      COMMON /OTPARM/ CATSD, LAMBS, BUFF1, BUFF2, BUFF3, BUFF4, SCRTCH,
     *   SEQI, DISKI, SEQO, DISKO, LUNI, INDI, LUNO, INDO, CNOI, CNOO,
     *   JBUFSZ
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
LOCAL END
      PROGRAM RFARS
C-----------------------------------------------------------------------
C! Correct inputs to FARS for maximum RM found by AFARS from FARS output
C# POLARIZATION ANALYSIS
C-----------------------------------------------------------------------
C;  Copyright (C) 2011-2012, 2017
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   RFARS corrects the Q,U cubes read into FARS with an image of RM
C   usually made by AFARS from the outputs of FARS.
C   Inputs:
C       in 1 - Q
C       in 2 - U
C       in 3 - RM
C       out 1 - Q corrected
C       out 2 - U corrected
C       BLC for in 1 and 2
C       TRC for in 1 and 2
C   1 and 2 may be in freq-RA-Dec or RA-Dec-freq transpositions but
C   they must be the same
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   IRET, ITYPE, NX, NY, NWORDS
      LONGINT   PRM
      REAL      RM(2)
      INCLUDE 'RFARS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA PRGNAM /'RFARS '/
C-----------------------------------------------------------------------
C                                       get inputs, create outputs
      CALL RFARSI (PRGNAM, ITYPE, NX, NY, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       memory for RM image
      NWORDS = (NX * NY - 1) / 1024 + 3
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, RM, PRM, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'CANNOT GET DYNAMIC MEMORY FOR RM'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       read RM
      CALL RFARSR (ITYPE, NX, NY, RM(1+PRM), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       FREQ-RA-DEC
      IF (ITYPE.EQ.1) THEN
         CALL RFARSF (NX, NY, RM(1+PRM), IRET)
         IF (IRET.NE.0) GO TO 990
C                                       RA-DEC-FREQ
      ELSE
         CALL RFARSP (NX, NY, RM(1+PRM), IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
C                                       HI, etc
      CALL RFARSH
C
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE RFARSI (PRGNAM, ITYPE, NX, NY, IRET)
C-----------------------------------------------------------------------
C   RFARSI gets input parameters for RFARS and creates the output images
C   and reads the FREQ axis or FQ table to get the list of frequencies.
C   Inputs:
C      PRGNAM   C*6   task name
C   Outputs:
C      ITYPE    I     1 => freq or freqid axis first
C      NX       I     Number RA axis points in output
C      NY       I     Number Dec axis points in output
C      IRET     I     Error code
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   ITYPE, NX, NY, IRET
C
      INCLUDE 'RFARS.INC'
      INTEGER   IERR, NPARMS, I, IUSER
      CHARACTER INTYPE*2, CTEMP*8, DEFC(2)*6

      INCLUDE 'INCS:DFIL.INC'
      DATA DEFC /'RFARSQ','RFARSU'/
C-----------------------------------------------------------------------
C                                       init aips
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NSCR = 0
      NCFILE = 0
C                                       get adverbs
      NPARMS = 49
      CALL GTPARM (PRGNAM, NPARMS, RQUICK, XNAM1, SCRTCH, IERR)
      IRET = IERR
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING ADVERB VALUES'
         CALL MSGWRT (8)
         END IF
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
C                                       convert adverbs
      CALL H2CHR (12, 1, XNAM1, NAMIN(1))
      CALL H2CHR (12, 1, XNAM2, NAMIN(2))
      CALL H2CHR (12, 1, XNAM3, NAMIN(3))
      CALL H2CHR (12, 1, ONAM1, NAMOUT(1))
      CALL H2CHR (12, 1, ONAM2, NAMOUT(2))
      CALL H2CHR (6, 1, XCLS1, CLSIN(1))
      CALL H2CHR (6, 1, XCLS2, CLSIN(2))
      CALL H2CHR (6, 1, XCLS3, CLSIN(3))
      CALL H2CHR (6, 1, OCLS1, CLSOUT(1))
      CALL H2CHR (6, 1, OCLS2, CLSOUT(2))
      SEQI(1) = XS1 + 0.1
      SEQI(2) = XS2 + 0.1
      SEQI(3) = XS3 + 0.1
      SEQO(1) = OS1 + 0.1
      SEQO(2) = OS2 + 0.1
      DISKI(1) = XD1 + 0.1
      DISKI(2) = XD2 + 0.1
      DISKI(3) = XD3 + 0.1
      DISKO(1) = OD1 + 0.1
      DISKO(2) = OD2 + 0.1
      LUNI(1) = 17
      LUNI(2) = 18
      LUNI(3) = 19
      LUNO(1) = 20
      LUNO(2) = 21
      JBUFSZ = MABFSS / 2
C                                       open inputs
      INTYPE = 'MA'
      IUSER = NLUSER
      DO 30 I = 1,3
         CALL MAPOPN ('READ', DISKI(I), NAMIN(I), CLSIN(I), SEQI(I),
     *      INTYPE, IUSER, LUNI(I), INDI(I), CNOI(I), CATSI(1,I),
     *      SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN INPUT IMAGE', I
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FRW(NCFILE) = 0
         FVOL(NCFILE) = DISKI(I)
         FCNO(NCFILE) = CNOI(I)
 30      CONTINUE
C                                       check window
      CALL WINDOW (CATSI(KIDIM,1), CATSI(KINAX,1), BLC, TRC, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       do first 2 match enough?
      IF ((CATSI(KIDIM,1).NE.CATSI(KIDIM,2)) .OR.
     *   (CATSI(KINAX,1).NE.CATSI(KINAX,2)) .OR.
     *   (CATSI(KINAX+1,1).NE.CATSI(KINAX+1,2)) .OR.
     *   (CATSI(KINAX+2,1).NE.CATSI(KINAX+2,2)) .OR.
     *   (CATSI(KINAX+3,1).NE.CATSI(KINAX+3,2))) THEN
         MSGTXT = 'Q AND U DO NOT MATCH IN HEADER PIXEL COUNTS'
         IRET = 10
         GO TO 990
         END IF
      IF ((CATSH(KHCTP,1).NE.CATSH(KHCTP,2)) .OR.
     *   (CATSH(KHCTP+1,1).NE.CATSH(KHCTP+1,2)) .OR.
     *   (CATSH(KHCTP+2,1).NE.CATSH(KHCTP+2,2)) .OR.
     *   (CATSH(KHCTP+3,1).NE.CATSH(KHCTP+3,2)) .OR.
     *   (CATSH(KHCTP+4,1).NE.CATSH(KHCTP+4,2)) .OR.
     *   (CATSH(KHCTP+5,1).NE.CATSH(KHCTP+5,2))) THEN
         MSGTXT = 'Q AND U DO NOT MATCH IN AXIS LABELS'
         IRET = 10
         GO TO 990
         END IF
C                                       close enough, what type?
      CALL H2CHR (8, 1, CATSH(KHCTP,1), CTEMP)
      IF ((CTEMP(:4).EQ.'FREQ') .OR. (CTEMP(:4).EQ.'FQID')) THEN
         ITYPE = 1
         NX = TRC(2) - BLC(2) + 1.1
         NY = TRC(3) - BLC(3) + 1.1
      ELSE
         CALL H2CHR (8, 1, CATSH(KHCTP+4,1), CTEMP)
         IF ((CTEMP(:4).EQ.'FREQ') .OR. (CTEMP(:4).EQ.'FQID')) THEN
            ITYPE = 2
            NX = TRC(1) - BLC(1) + 1.1
            NY = TRC(2) - BLC(2) + 1.1
         ELSE
            MSGTXT = 'NEITHER AXIS 1 NOR 3 IS FREQ OR FQID'
            IRET = 10
            GO TO 990
            END IF
         END IF
C                                       get frequencies
      CALL RFARSL (ITYPE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       create output files
      DO 50 I = 1,2
         CALL COPY (256, CATSI(1,I), CATBLK)
         CALL SUBHDR (BLC, TRC, 1.0, 1.0)
         CALL MAKOUT (NAMIN(I), CLSIN(I), SEQI(I), DEFC(I), NAMOUT(I),
     *      CLSOUT(I), SEQO(I))
         CALL CHR2H (12, NAMOUT(I), KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, CLSOUT(I), KHIMCO, CATH(KHIMC))
         CATBLK(KIIMS) = SEQO(I)
         CATBLK(KIIMU) = NLUSER
         CALL MCREAT (DISKO(I), CNOO(I), SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATING OUTPUT IMAGE', I
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FRW(NCFILE) = 2
         FVOL(NCFILE) = DISKO(I)
         FCNO(NCFILE) = CNOO(I)
C                                       copy header keywords
         CALL KEYPCP (DISKI(I), CNOI(I), DISKO(I), CNOO(I), 0, ' ',
     *      IERR)
         CALL COPY (256, CATBLK, CATSI(1,3+I))
C                                       open
         CALL MAPOPN ('INIT', DISKO(I), NAMOUT(I), CLSOUT(I), SEQO(I),
     *      INTYPE, IUSER, LUNO(I), INDO(I), CNOO(I), CATSI(1,3+I),
     *      SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OUTPUT IMAGE', I
            GO TO 990
            END IF
 50      CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RFARSI: ERROR',I4,' ON ',A,I3)
      END
      SUBROUTINE RFARSL (ITYPE, IRET)
C-----------------------------------------------------------------------
C   RFARSL computes or reads the frequencies compute lambda**2
C   Inputs:
C      ITYPE   I   1 => x axis is freq, 2 => z axis
C   Outputs:
C      IRET    I   error code
C-----------------------------------------------------------------------
      INTEGER   ITYPE, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IBLC, ITRC, NZ, FQAX, I, J, VER, IFQRNO, FQKOLS(MAXFQC),
     *   FQNUMV(MAXFQC), NUMIF, IFSIDE, FREQAX, LUN, NUMREC, FQID
      CHARACTER CTEMP*4
      DOUBLE PRECISION IFFREQ
      REAL      IFCHW, IFTBW
      CHARACTER BNDCOD*8
      INCLUDE 'RFARS.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      IF (ITYPE.EQ.1) THEN
         FQAX = 0
         IBLC = BLC(1) + 0.1
         ITRC = TRC(1) + 0.1
      ELSE
         FQAX = 2
         IBLC = BLC(3) + 0.1
         ITRC = TRC(3) + 0.1
         END IF
      NZ = ITRC - IBLC + 1
      CALL DFILL (NZ, 0.0D0, LAMBS)
C                                       frequency axis
      CALL H2CHR (4, 1, CATSH(KHCTP+2*FQAX,1), CTEMP)
      IF (CTEMP.NE.'FQID') THEN
         DO 20 I = IBLC,ITRC
            LAMBS(I-IBLC+1) = CATSD(KDCRV+FQAX,1) + CATSR(KRCIC+FQAX,1)
     *         * (I - CATSR(KRCRP+FQAX,1))
 20         CONTINUE
C                                       FREQ ID table
      ELSE
         CALL AXEFND (4, 'FREQ', CATSI(KIDIM,1), CATSH(KHCTP,1), FREQAX,
     *      IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'NO FREQUENCY AXIS FOUND: QUITTING'
            GO TO 990
            END IF
         VER = 1
         LUN = 31
         CALL FQINI ('READ', SCRTCH, DISKI(1), CNOI(1), VER, CATSI(1,1),
     *      LUN, IFQRNO, FQKOLS, FQNUMV, NUMIF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING THE FQ TABLE'
            GO TO 990
            END IF
         NUMREC = SCRTCH(5)
         DO 40 I = 1,NUMREC
            CALL TABFQ ('READ', SCRTCH, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *         FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING FQ TABLE'
               GO TO 990
               END IF
            J = (FQID - CATSD(KDCRV+FQAX,1)) / CATSR(KRCIC+FQAX,1) +
     *         CATSR(KRCRP+FQAX,1)
            IF ((J.GE.IBLC) .AND .(J.LE.ITRC)) THEN
               J = J - IBLC + 1
               LAMBS(J) = IFFREQ + CATSD(KDCRV+FREQAX,1)
               END IF
 40         CONTINUE
         CALL TABFQ ('CLOS', SCRTCH, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *      FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IRET)
         IRET = 0
         END IF
C                                       convert to lambda*2
      DO 60 I = 1,NZ
         IF (LAMBS(I).LE.0.0D0) THEN
            IRET = 10
            MSGTXT = 'NOT ALL FREQUENCIES HAVE VALUE'
            GO TO 990
         ELSE
            LAMBS(I) = (VELITE / LAMBS(I)) ** 2
            END IF
 60      CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RFARSL: ERROR',I4,' ON ',A)
      END
      SUBROUTINE RFARSR (ITYPE, NX, NY, RM, IRET)
C-----------------------------------------------------------------------
C   RFARSR reads the RM image plane into memory
C   Inputs:
C      ITYPE   I      Type: 1 freq axis first
C      NX      I      Number X pixels in output
C      NY      I      Number Y pixels in output
C   Outputs
C      RM      R(*)   RM image
C      IRET    I      Error code
C-----------------------------------------------------------------------
      INTEGER   ITYPE, NX, NY, IRET
      REAL      RM(NX,*)
C
      INCLUDE 'RFARS.INC'
      INTEGER   IWIN(4), IBLKOF, IY, BIND
C-----------------------------------------------------------------------
      IF (ITYPE.EQ.1) THEN
         IWIN(1) = BLC(2) + 0.1
         IWIN(2) = BLC(3) + 0.1
         IWIN(3) = TRC(2) + 0.1
         IWIN(4) = TRC(3) + 0.1
      ELSE
         IWIN(1) = BLC(1) + 0.1
         IWIN(2) = BLC(2) + 0.1
         IWIN(3) = TRC(1) + 0.1
         IWIN(4) = TRC(2) + 0.1
         END IF
      IBLKOF = 1
      CALL MINIT ('READ', LUNI(3), INDI(3), NX, NY, IWIN, BUFF1, JBUFSZ,
     *   IBLKOF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT I/O TO RM IMAGE'
         GO TO 990
         END IF
      DO 20 IY = 1,NY
         CALL MDISK ('READ', LUNI(3), INDI(3), BUFF1, BIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING RM IMAGE'
            GO TO 990
            END IF
         CALL RCOPY (NX, BUFF1(BIND), RM(1,IY))
 20      CONTINUE
C                                       done with RM image
      CALL ZCLOSE (LUNI(3), INDI(3), IY)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RFARSR: ERROR',I4,' ON ',A)
      END
      SUBROUTINE RFARSF (NX, NY, RM, IRET)
C-----------------------------------------------------------------------
C   RFARSF does the correction for freq-RA-Dec images
C   Inputs:
C      NX     I      Number X pixels
C      NY     I      Number Y pixels
C      RM     R(*)   Image of rotation measure
C   Outputs:
C      IRET   I      Error code
C-----------------------------------------------------------------------
      INTEGER   NX, NY, IRET
      REAL      RM(NX,*)
C
      INCLUDE 'RFARS.INC'
      INTEGER   IX, IY, I4, I5, I6, I7, N4, N5, N6, N7, IC, IBIND1, NC,
     *   IBIND2, OBIND1, OBIND2, IWIN(4), IBLKOF, IDEPTH(5), OWIN(4),
     *   INC, INX
      REAL      QI, UI, QO, UO, RI, SS, CC, RMAXQ, RMAXU, RMINQ, RMINU
      LOGICAL   WASBLK
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      NC = TRC(1) - BLC(1) + 1.1
      N4 = TRC(4) - BLC(4) + 1.1
      N5 = TRC(5) - BLC(5) + 1.1
      N6 = TRC(6) - BLC(6) + 1.1
      N7 = TRC(7) - BLC(7) + 1.1
      IWIN(1) = BLC(1) + 0.1
      IWIN(2) = BLC(2) + 0.1
      IWIN(3) = TRC(1) + 0.1
      IWIN(4) = TRC(2) + 0.1
      OWIN(1) = 1
      OWIN(2) = 1
      OWIN(3) = NC
      OWIN(4) = NX
      INC = CATSI(KINAX,1)
      INX = CATSI(KINAX+1,1)
      RMAXQ = -1.E10
      RMINQ = 1.E10
      RMAXU = -1.E10
      RMINU = 1.E10
      WASBLK = .FALSE.
      DO 100 I7 = 1,N7
         DO 90 I6 = 1,N6
            DO 80 I5 = 1,N5
               DO 70 I4 = 1,N4
                  DO 60 IY = 1,NY
C                                       init reads of plane
                     IDEPTH(1) = IY + BLC(3) - 0.9
                     IDEPTH(2) = I4 + BLC(4) - 0.9
                     IDEPTH(3) = I5 + BLC(5) - 0.9
                     IDEPTH(4) = I6 + BLC(6) - 0.9
                     IDEPTH(5) = I7 + BLC(7) - 0.9
                     CALL COMOFF (CATSI(KIDIM,1), CATSI(KINAX,1),
     *                  IDEPTH, IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'COMOFF INPUT'
                        GO TO 990
                        END IF
                     IBLKOF = IBLKOF + 1
                     CALL MINIT ('READ', LUNI(1), INDI(1), INC, INX,
     *                  IWIN, BUFF1, JBUFSZ, IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'INIT Q INPUT'
                        GO TO 990
                        END IF
                     CALL MINIT ('READ', LUNI(2), INDI(2), INC, INX,
     *                  IWIN, BUFF2, JBUFSZ, IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'INIT U INPUT'
                        GO TO 990
                        END IF
C                                       init writes
                     IDEPTH(1) = IY
                     IDEPTH(2) = I4
                     IDEPTH(3) = I5
                     IDEPTH(4) = I6
                     IDEPTH(5) = I7
                     CALL COMOFF (CATSI(KIDIM,4), CATSI(KINAX,4),
     *                  IDEPTH, IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'COMOFF INPUT'
                        GO TO 990
                        END IF
                     IBLKOF = IBLKOF + 1
                     CALL MINIT ('WRIT', LUNO(1), INDO(1), NC, NX, OWIN,
     *                  BUFF3, JBUFSZ, IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'INIT Q OUTPUT'
                        GO TO 990
                        END IF
                     CALL MINIT ('WRIT', LUNO(2), INDO(2), NC, NX, OWIN,
     *                  BUFF4, JBUFSZ, IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'INIT U OUTPUT'
                        GO TO 990
                        END IF
                     DO 50 IX = 1,NX
                        CALL MDISK ('READ', LUNI(1), INDI(1), BUFF1,
     *                     IBIND1, IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET,
     *                        'READING INPUT Q IMAGE'
                           GO TO 990
                           END IF
                        CALL MDISK ('READ', LUNI(2), INDI(2), BUFF2,
     *                     IBIND2, IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET,
     *                        'READING INPUT U IMAGE'
                           GO TO 990
                           END IF
                        CALL MDISK ('WRIT', LUNO(1), INDO(1), BUFF3,
     *                     OBIND1, IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET,
     *                        'WRITING OUTPUT Q IMAGE'
                           GO TO 990
                           END IF
                        CALL MDISK ('WRIT', LUNO(2), INDO(2), BUFF4,
     *                     OBIND2, IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET,
     *                        'WRITING OUTPUT U IMAGE'
                           GO TO 990
                           END IF
                        DO 30 IC = 1,NC
                           QI = BUFF1(IBIND1+IC-1)
                           UI = BUFF2(IBIND2+IC-1)
                           RI = RM(IX,IY)
                           IF ((QI.EQ.FBLANK) .OR. (UI.EQ.FBLANK) .OR.
     *                        (RI.EQ.FBLANK)) THEN
                              QO = FBLANK
                              UO = FBLANK
                              WASBLK = .TRUE.
                           ELSE IF ((QI.EQ.0.0) .AND. (UI.EQ.0.0)) THEN
                              QO = 0.0
                              UO = 0.0
                              RMAXQ = MAX (QO, RMAXQ)
                              RMAXU = MAX (UO, RMAXU)
                              RMINQ = MIN (QO, RMINQ)
                              RMINU = MIN (UO, RMINU)
                           ELSE
                              RI = 2.0 * RI * LAMBS(IC)
                              SS = SIN (RI)
                              CC = COS (RI)
                              QO = QI * CC + UI * SS
                              UO = UI * CC - QI * SS
                              RMAXQ = MAX (QO, RMAXQ)
                              RMAXU = MAX (UO, RMAXU)
                              RMINQ = MIN (QO, RMINQ)
                              RMINU = MIN (UO, RMINU)
                              END IF
                           BUFF3(OBIND1+IC-1) = QO
                           BUFF4(OBIND2+IC-1) = UO
 30                        CONTINUE
 50                     CONTINUE
                     CALL MDISK ('FINI', LUNO(1), INDO(1), BUFF3,
     *                  OBIND1, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET,
     *                     'FINISHING OUTPUT Q IMAGE'
                        GO TO 990
                        END IF
                     CALL MDISK ('FINI', LUNO(2), INDO(2), BUFF4,
     *                  OBIND2, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET,
     *                     'FINISHING OUTPUT U IMAGE'
                        GO TO 990
                        END IF
 60                  CONTINUE
 70               CONTINUE
 80            CONTINUE
 90         CONTINUE
 100     CONTINUE
C                                       done
      CALL ZCLOSE (LUNI(1), INDI(1), I7)
      CALL ZCLOSE (LUNI(2), INDI(2), I7)
      CALL ZCLOSE (LUNO(1), INDO(1), I7)
      CALL ZCLOSE (LUNO(2), INDO(2), I7)
      CATSR(KRDMX,4) = RMAXQ
      CATSR(KRDMN,4) = RMINQ
      CATSR(KRDMX,5) = RMAXU
      CATSR(KRDMN,5) = RMINU
      IF (WASBLK) THEN
         CATSR(KRBLK,4) = FBLANK
         CATSR(KRBLK,5) = FBLANK
      ELSE
         CATSR(KRBLK,4) = 0.0
         CATSR(KRBLK,5) = 0.0
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RFARSF: ERROR',I4,' ON ',A)
      END
      SUBROUTINE RFARSP (NX, NY, RM, IRET)
C-----------------------------------------------------------------------
C   RFARSP does the correction for RA-Dec-FREQ images
C   Inputs:
C      NX     I      Number X pixels
C      NY     I      Number Y pixels
C      RM     R(*)   Image of rotation measure
C   Outputs:
C      IRET   I      Error code
C-----------------------------------------------------------------------
      INTEGER   NX, NY, IRET
      REAL      RM(NX,*)
C
      INCLUDE 'RFARS.INC'
      INTEGER   IX, IY, I4, I5, I6, I7, N4, N5, N6, N7, IC, IBIND1, NC,
     *   IBIND2, OBIND1, OBIND2, IWIN(4), IBLKOF, IDEPTH(5), OWIN(4),
     *   INX, INY
      REAL      QI, UI, QO, UO, RI, SS, CC, RMAXQ, RMAXU, RMINQ, RMINU
      LOGICAL   WASBLK
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      NC = TRC(3) - BLC(3) + 1.1
      N4 = TRC(4) - BLC(4) + 1.1
      N5 = TRC(5) - BLC(5) + 1.1
      N6 = TRC(6) - BLC(6) + 1.1
      N7 = TRC(7) - BLC(7) + 1.1
      IWIN(1) = BLC(1) + 0.1
      IWIN(2) = BLC(2) + 0.1
      IWIN(3) = TRC(1) + 0.1
      IWIN(4) = TRC(2) + 0.1
      OWIN(1) = 1
      OWIN(2) = 1
      OWIN(3) = NX
      OWIN(4) = NY
      INX = CATSI(KINAX,1)
      INY = CATSI(KINAX+1,1)
      RMAXQ = -1.E10
      RMINQ = 1.E10
      RMAXU = -1.E10
      RMINU = 1.E10
      WASBLK = .FALSE.
      DO 100 I7 = 1,N7
         DO 90 I6 = 1,N6
            DO 80 I5 = 1,N5
               DO 70 I4 = 1,N4
                  DO 60 IC = 1,NC
C                                       init reads of plane
                     IDEPTH(1) = IC + BLC(3) - 0.9
                     IDEPTH(2) = I4 + BLC(4) - 0.9
                     IDEPTH(3) = I5 + BLC(5) - 0.9
                     IDEPTH(4) = I6 + BLC(6) - 0.9
                     IDEPTH(5) = I7 + BLC(7) - 0.9
                     CALL COMOFF (CATSI(KIDIM,1), CATSI(KINAX,1),
     *                  IDEPTH, IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'COMOFF INPUT'
                        GO TO 990
                        END IF
                     IBLKOF = IBLKOF + 1
                     CALL MINIT ('READ', LUNI(1), INDI(1), INX, INY,
     *                  IWIN, BUFF1, JBUFSZ, IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'INIT Q INPUT'
                        GO TO 990
                        END IF
                     CALL MINIT ('READ', LUNI(2), INDI(2), INX, INY,
     *                  IWIN, BUFF2, JBUFSZ, IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'INIT U INPUT'
                        GO TO 990
                        END IF
C                                       init writes
                     IDEPTH(1) = IC
                     IDEPTH(2) = I4
                     IDEPTH(3) = I5
                     IDEPTH(4) = I6
                     IDEPTH(5) = I7
                     CALL COMOFF (CATSI(KIDIM,4), CATSI(KINAX,4),
     *                  IDEPTH, IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'COMOFF INPUT'
                        GO TO 990
                        END IF
                     IBLKOF = IBLKOF + 1
                     CALL MINIT ('WRIT', LUNO(1), INDO(1), NX, NY, OWIN,
     *                  BUFF3, JBUFSZ, IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'INIT Q OUTPUT'
                        GO TO 990
                        END IF
                     CALL MINIT ('WRIT', LUNO(2), INDO(2), NX, NY, OWIN,
     *                  BUFF4, JBUFSZ, IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'INIT U OUTPUT'
                        GO TO 990
                        END IF
                     DO 50 IY = 1,NY
                        CALL MDISK ('READ', LUNI(1), INDI(1), BUFF1,
     *                     IBIND1, IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET,
     *                        'READING INPUT Q IMAGE'
                           GO TO 990
                           END IF
                        CALL MDISK ('READ', LUNI(2), INDI(2), BUFF2,
     *                     IBIND2, IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET,
     *                        'READING INPUT U IMAGE'
                           GO TO 990
                           END IF
                        CALL MDISK ('WRIT', LUNO(1), INDO(1), BUFF3,
     *                     OBIND1, IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET,
     *                        'WRITING OUTPUT Q IMAGE'
                           GO TO 990
                           END IF
                        CALL MDISK ('WRIT', LUNO(2), INDO(2), BUFF4,
     *                     OBIND2, IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET,
     *                        'WRITING OUTPUT U IMAGE'
                           GO TO 990
                           END IF
                        DO 30 IX = 1,NX
                           QI = BUFF1(IBIND1+IX-1)
                           UI = BUFF2(IBIND2+IX-1)
                           RI = RM(IX,IY)
                           IF ((QI.EQ.FBLANK) .OR. (UI.EQ.FBLANK) .OR.
     *                        (RI.EQ.FBLANK)) THEN
                              QO = FBLANK
                              UO = FBLANK
                              WASBLK = .TRUE.
                           ELSE IF ((QI.EQ.0.0) .AND. (UI.EQ.0.0)) THEN
                              QO = 0.0
                              UO = 0.0
                              RMAXQ = MAX (QO, RMAXQ)
                              RMAXU = MAX (UO, RMAXU)
                              RMINQ = MIN (QO, RMINQ)
                              RMINU = MIN (UO, RMINU)
                           ELSE
                              RI = 2.0 * RI * LAMBS(IC)
                              SS = SIN (RI)
                              CC = COS (RI)
                              QO = QI * CC + UI * SS
                              UO = UI * CC - QI * SS
                              RMAXQ = MAX (QO, RMAXQ)
                              RMAXU = MAX (UO, RMAXU)
                              RMINQ = MIN (QO, RMINQ)
                              RMINU = MIN (UO, RMINU)
                              END IF
                           BUFF3(OBIND1+IX-1) = QO
                           BUFF4(OBIND2+IX-1) = UO
 30                        CONTINUE
 50                     CONTINUE
                     CALL MDISK ('FINI', LUNO(1), INDO(1), BUFF3,
     *                  OBIND1, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET,
     *                     'FINISHING OUTPUT Q IMAGE'
                        GO TO 990
                        END IF
                     CALL MDISK ('FINI', LUNO(2), INDO(2), BUFF4,
     *                  OBIND2, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET,
     *                     'FINISHING OUTPUT U IMAGE'
                        GO TO 990
                        END IF
 60                   CONTINUE
 70                CONTINUE
 80             CONTINUE
 90          CONTINUE
 100     CONTINUE
C                                       done
      CALL ZCLOSE (LUNI(1), INDI(1), I7)
      CALL ZCLOSE (LUNI(2), INDI(2), I7)
      CALL ZCLOSE (LUNO(1), INDO(1), I7)
      CALL ZCLOSE (LUNO(2), INDO(2), I7)
      CATSR(KRDMX,4) = RMAXQ
      CATSR(KRDMN,4) = RMINQ
      CATSR(KRDMX,5) = RMAXU
      CATSR(KRDMN,5) = RMINU
      IF (WASBLK) THEN
         CATSR(KRBLK,4) = FBLANK
         CATSR(KRBLK,5) = FBLANK
      ELSE
         CATSR(KRBLK,4) = 0.0
         CATSR(KRBLK,5) = 0.0
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RFARSP: ERROR',I4,' ON ',A)
      END
      SUBROUTINE RFARSH
C-----------------------------------------------------------------------
C   RFARSH writes history information to the output images
C   and copies non-CC tables
C-----------------------------------------------------------------------
      INCLUDE 'RFARS.INC'
      INTEGER   HLUN1, HLUN2, IERR, I, J, JTRIM, IC(7), INODIM
      CHARACTER HILINE*72, NOTTYP*2
      DATA HLUN1, HLUN2 /27, 28/
      DATA NOTTYP /'CC'/
C-----------------------------------------------------------------------
      CALL HIINIT (2)
C                                       2 output files
      DO 100 I = 1,2
         CALL COPY (256, CATSI(1,I+3), CATBLK)
         CALL HISCOP (HLUN1, HLUN2, DISKI(I), DISKO(I), CNOI(I),
     *      CNOO(I), CATBLK, BUFF1, BUFF2, IERR)
         IF (IERR.GT.3) GO TO 100
         IF (I.EQ.1) THEN
            CALL HENCO1 (TSKNAM, NAMIN(I), CLSIN(I), SEQI(I), DISKI(I),
     *         HLUN2, BUFF2, IERR)
         ELSE
            CALL HENCO2 (TSKNAM, NAMIN(I), CLSIN(I), SEQI(I), DISKI(I),
     *         HLUN2, BUFF2, IERR)
            END IF
         IF (IERR.NE.0) GO TO 90
         CALL HENCO3 (TSKNAM, NAMIN(3), CLSIN(3), SEQI(3), DISKI(3),
     *      HLUN2, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 90
         CALL HENCOO (TSKNAM, NAMOUT(I), CLSOUT(I), SEQO(I), DISKO(I),
     *      HLUN2, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 90
C                                       corners
         INODIM = CATSI(KIDIM,I)
         DO 10 J = 1,INODIM
            IC(J) = BLC(J) + 0.5
 10         CONTINUE
         WRITE (HILINE,1010) TSKNAM, 'BLC', (IC(J), J = 1,INODIM)
         J = JTRIM (HILINE)
         IF (HILINE(J:J).EQ.',') HILINE(J:J) = ' '
         CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 90
         DO 15 J = 1,INODIM
            IC(J) = TRC(J) + 0.5
 15         CONTINUE
         WRITE (HILINE,1010) TSKNAM, 'TRC', (IC(J), J = 1,INODIM)
         J = JTRIM (HILINE)
         IF (HILINE(J:J).EQ.',') HILINE(J:J) = ' '
         CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 90
C                                       update header
  90     CALL HICLOS (HLUN2, .TRUE., BUFF2, IERR)
C                                       copy tables, not CC
 95      CALL ALLTAB (1, NOTTYP, HLUN1, HLUN2, DISKI(I), DISKO(I),
     *      CNOI(I), CNOO(I), CATBLK, BUFF1, BUFF2, IERR)
 100     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (A,A,' =',2(I6,','),4(I5,','),I5)
      END

      SUBROUTINE YGGRAM (OP, VRTRTC, RGBBUF, IERR)
C-----------------------------------------------------------------------
C! controls the TV graphics color assignments
C# Y3 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YGGRAM reads/writes the TV graphics color assignment RAM.  The
C   data are packed in this look up table for colors as:
C         bit 15 (msb)   :   1 - graphics replace 0 - add to image
C         bits 10-14     :   red value for this graphics value
C         bits  5- 9     :   green
C         bits  0- 4     :   blue
C   Inputs:
C      OP      C*4       'READ' from TV or 'WRIT' to TV
C      VRTRTC  L         T => do it only on vertical retrace
C   In/Out:
C      RGBBUF  I(256)    data array
C   Out:
C      IERR    I         error code of Z...XF : 0 => ok
C   NO TV VERSION - this is a level 3 IIS M70 function.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   RGBBUF(256), IERR
      LOGICAL   VRTRTC
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'THERE IS NO TV CONFIGURED WITH A GRAPHICS COLOR RAM'
      CALL MSGWRT (8)
C
 999  RETURN
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QGRDFI (U, ROW, M, LROW, TYPE)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Finish griding a row of uv data.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   QGRDFI Does various tasks assiciated with completion of gridding
C   a row.  If U is within 1/2 support of 0 the symmetric row is
C   conjugated, flipped and added.  Next
C   any taper is applied followed (for IPOL maps only) by the
C   addition of the weighting function to the gridded visibilities
C   to produce the beam map.  Finally rows are rotated so that
C   zero column (assumed LROW/2+1) goes to the first column.
C   If U=0 the space for the next row down is used.
C   Inputs:
C      U      I  U in cells (non-negative)
C      ROW    I  Base address of Grid row of interest
C      M      I  Number of rows kept in the AP.
C      LROW   I  Length of row (no. reals)
C      TYPE   I  1 for IPOL,IBEM maps
C                2 for Q, U maps
C                3 for V maps.
C   Also expects necessary constants in following AP locations:
C           0 = COS(PHASE0)           to shift map center
C           1 = SIN(PHASE0)
C           2 = COS(DELPHR)           for rotating down rows
C           3 = SIN(DELPHR)
C           4 = COS(DELPHC)           for rotationg down columns
C           5 = SIN(DELPHC)
C           6 = 1.0
C           7 = 0.0
C-----------------------------------------------------------------------
      INTEGER   U, ROW, M, LROW, TYPE, STCNT, STWT,
     *   MO2, SYM, REND, LROW1, STCNT2, STWT2, JROW, ROW1, LROWT4,
     *   LROWT2
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                       Set pointers etc.
      JROW = ROW
      LROWT2 = LROW + LROW
      LROWT4 = LROWT2 + LROWT2
      STCNT = JROW + LROWT2
      STWT = STCNT + 1
      STCNT2 = STCNT + 2
      STWT2 = STWT + 2
      MO2 = M / 2
      LROW1 = LROW - 1
      ROW1 = JROW + 2
C                                         Check if Q,U maps
      IF (TYPE.EQ.2) GO TO 500
C                                        Check if IMAP and near orig.
      IF (U.GT.MO2) GO TO 100
C                                        Near orig. add sym pts.
         SYM = JROW - 4 * LROWT2 * U
         REND = SYM + LROWT2
C                                        If u=0 move 0 row 1 slot
C                                        lower and work from there.
         IF (U.GT.0) GO TO 50
            SYM = JROW - LROWT4
            REND = SYM + LROWT2
            LROW1 = LROWT2
            CALL QVMOV (JROW, 1, SYM, 1, LROW1)
            CALL QVMOV (STCNT, 1, REND, 1, LROW1)
            LROW1 = LROW - 1
 50         CONTINUE
C                                        Add rows
         REND = REND - 2
         CALL QCVJAD (ROW1, 2, REND, -2, ROW1, 2, LROW1)
         CALL QCVJAD (JROW, 2, SYM, 2, JROW, 2, 1)
         REND = REND + LROWT2
C                                         Add counts.
         CALL QVADD (REND, -2, STCNT2, 2, STCNT2, 2, LROW1)
         SYM = SYM + LROWT2
         CALL QVADD (SYM, 2, STCNT, 2, STCNT, 2, 1)
C                                        Add weights
         REND = REND + 1
         CALL QVADD (REND, -2, STWT2, 2, STWT2, 2, LROW1)
         SYM = SYM + 1
         CALL QVADD (SYM, 2, STWT, 2, STWT, 2, 1)
 100     CONTINUE
      ROW1 = JROW + 1
C                                        Form conjugate row for IBEM
C                                        maps. Add weights to imag.
C                                        Move weights to STCNT
      CALL QVMOV (STWT, 2, STCNT, 2, LROW)
C                                        Sub. imag. from conj. wt.
      CALL QVSUB (ROW1, 2, STCNT, 2, STCNT, 2, LROW)
C                                         Add weight to imag.
      CALL QVADD (STWT, 2, ROW1, 2, ROW1, 2, LROW)
C                                        Move conj imag to correct loc
      CALL QVMOV (STCNT, 2, STWT, 2, LROW)
C                                       Copy real to conj. row
      CALL QVMOV (JROW, 2, STCNT, 2, LROW)
C                                       Rotate zero to first col
      SYM = STCNT + LROW
      CALL QVSWAP (STCNT, 1, SYM, 1, LROW)
      SYM = JROW + LROW
      CALL QVSWAP (JROW, 1, SYM, 1, LROW)
C                                       Rotate map center.
      CALL QPHSRO (JROW, 2, JROW, 2, 0, 2, LROW)
C                                       Conj. phase rotation
      APCORE(2) = -APCORE(2)
      APCORE(4) = -APCORE(4)
C                                       Rotate conjugate row
      CALL QPHSRO (STCNT, 2, STCNT, 2, 0, 2, LROW)
C                                       Reverse conj. row -real
      CALL QVRVRS (STCNT2, 2, LROW1)
C                                       Imag.
      CALL QVRVRS (STWT2, 2, LROW1)
C                                       Undo conj of phase.
      APCORE(2) = -APCORE(2)
      APCORE(4) = -APCORE(4)
C                                       Rotate phase0 for next row
      CALL QPHSRO (0, 2, 0, 2, 4, 6, 1)
      GO TO 999
C                                       Q and U map.
C                                       Use ROW for QPOL
C                                       Use STCNT for UPOL
 500  CONTINUE
C                                       Rotate zero to first col.
      SYM = STCNT + LROW
C                                       Switch UPOL.
      CALL QVSWAP (STCNT, 1, SYM, 1, LROW)
      SYM = JROW + LROW
C                                       Switch QPOL
      CALL QVSWAP (JROW, 1, SYM, 1, LROW)
C                                       Rotate map center, QPOL
      CALL QPHSRO (JROW, 2, JROW, 2, 0, 2, LROW)
C                                       Negate phase.
      APCORE(2) = -APCORE(2)
      APCORE(4) = -APCORE(4)
C                                       Rotate UPOL
      CALL QPHSRO (STCNT, 2, STCNT, 2, 0, 2, LROW)
C                                       Unnegate phase.
      APCORE(2) = -APCORE(2)
      APCORE(4) = -APCORE(4)
C                                       Rotate phase0 for next row.
      CALL QPHSRO (0, 2, 0, 2, 4, 6, 1)
C                                       Flip VIS2 row, real
      CALL QVRVRS (STCNT2, 2, LROW1)
      STCNT2 = STCNT2 + 1
C                                       Flip imag.
      CALL QVRVRS (STCNT2, 2, LROW1)
C
 999  RETURN
      END

      SUBROUTINE ZDICCL (LUN, FNAME, IRET)
C-----------------------------------------------------------------------
C! Close a Dicomed image file and (optionally) spool it
C# Z
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Close a Dicomed image file and save it under a user-specified name
C   or spool it to the film recorder and delete it.
C
C   Input:
C      LUN       I       The logical unit number for the file.
C      FNAME     C*(*)   The name the file will be stored under; if
C                        no name is given the file will be placed in
C                        the film recorder queue automatically and
C                        not stored.
C
C   Output:
C      IRET      I       Return status:
C                          0 -> success
C
C   Generic version: stubbed.
C-----------------------------------------------------------------------
      INTEGER   LUN, IRET
      CHARACTER FNAME*(*)
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IRET = 0
      WRITE (MSGTXT, 1000)
      CALL MSGWRT (8)
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZDICCL REQUIRES LOCAL DEVELOPMENT')
      END

      SUBROUTINE LXYPOL (IERR)
C-----------------------------------------------------------------------
C! Fills polarization correction table for AT like linear polarization.
C# UV EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2010, 2012, 2014, 2017-2018
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Fills polarization correction table from info in AN table for Linear
C   polarization feeds (XY).
C   Inputs:
C      PANGLE  R(*)      Parallactic angles of the antennas (Rad)
C   Output:
C      IERR    I         Return error code, 0=>OK else error.
C                        1=table too small, 2=multiple subarrays,
C                        10 = unknown polarization parameterization,
C                        otherwise GETANT error.
C   Output to common /SELCAL/:
C      PARTIM  R         Time of current parallactic angles. (-1.0E10)
C      PARSOU  I         Source ID for current parallactic angles. (-10)
C      POLCAL  R(2,*)    Polarization correction
C                        Values in order:
C                        By baseline
C                           By IF (EIF-BIF+1)
C                              A 4x4 complex matrix to be multiplied by
C                                  the observed polarization vector
C                                  (RR,LL,RL,LR) to produce the
C                                  corrected data.
C                       Indexing scheme: an entry defined by ant1<ant2
C                       starts in element:
C         (((ant1-1)*numant-((ant1+1)*ant1)/2 + ant2) - 1) + 1
C-----------------------------------------------------------------------
C      REAL      PANGLE(*)
      INTEGER   IERR
C
      INTEGER   IIF, IPOL, IANT1, IANT2, LIMIT, BLNDX, LIMIT2, BLPNT,
     *   IBLPNT, IPOFF(4,2), IP1, IP2, LENTRY, II, JJ, LDA, N, IPVT(4),
     *   JOB, INFO, ICH, IC1, IC2, KX1, KX2, KY1, KY2, IFQ, KK
      REAL    PDIF, PSUM, TDIF, TSUM, SPDIF, CPDIF, SPSUM, STDIF,
     *   STSUM, CTDIF, CTSUM, CPSUM, PA1, PA2, XMAT(2,16)
      COMPLEX   WORK(4), DET(2), DX1, DX2, DY1, DY2, BLMAT(4,4),
     *   DMAT(4,4), TMAT1(4,4), TMAT2(4,4), TMAT3(4,4)
      LONGINT   POLPTR
      LOGICAL   FLAGED
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DPDC.INC'
      EQUIVALENCE (DMAT, XMAT)
      DATA IPOFF /1,2,1,2, 1,2,2,1/
C     DATA ORIFAC /-1.0, 1.0/
C-----------------------------------------------------------------------
C                                       Initialize parallactic angle
C                                       time, source
      IERR = 0
      PA1 = -1.0E10
      PA2 = -1.0E10
      PARTIM = -1.0E10
      PARSOU = -10
C                                       Only 1 subarray
      IF (SUBARR.EQ.0) THEN
         IERR = 2
         MSGTXT = 'ERROR: CAN ONLY DO POLARIZATION CORRECTION FOR 1 '
     *      // 'SUBARRAY'
         GO TO 990
         END IF
      IF (PDVER.GT.0) THEN
         IC1 = BCHAN
         IC2 = ECHAN
      ELSE
         IC1 = 1
         IC2 = 1
         IFQ = (BCHAN + ECHAN) / 2
         END IF
C                                       Compute correction matrices.
      LENTRY = 32 * PCLCH * PCLIF
      LIMIT = NSTNS - 1
      DO 600 IANT1 = 1,LIMIT
         LIMIT2 = IANT1 + 1
         DO 590 IANT2 = LIMIT2,NSTNS
C                                       Set baseline index
            BLNDX = ((IANT1-1)*NSTNS) - (((IANT1-1)*IANT1)/2) + IANT2
C                                       Compute matrix to convert
C                                       XX,YY,XY,YX to RR,LL.RL,LR
C                                       Don't redo if within 1 deg.
            IF ((ABS ((PANGLE(IANT1)-PA1)).GT.0.017) .OR.
     *          (ABS ((PANGLE(IANT2)-PA2)).GT.0.017)) THEN
               CPSUM = COS (PANGLE(IANT1) + PANGLE(IANT2))
               CPDIF = COS (PANGLE(IANT1) - PANGLE(IANT2))
               SPSUM = SIN (PANGLE(IANT1) + PANGLE(IANT2))
               SPDIF = SIN (PANGLE(IANT1) - PANGLE(IANT2))
C                                       Matrix to convert from I etc to
C                                       XX,YY etc.
               TMAT1(1,1) = CMPLX (CPDIF, 0.0)
               TMAT1(2,1) = CMPLX (SPSUM, 0.0)
               TMAT1(3,1) = CMPLX (-CPSUM, 0.0)
               TMAT1(4,1) = CMPLX (0.0, -SPDIF)
               TMAT1(1,2) = CMPLX (CPDIF, 0.0)
               TMAT1(2,2) = CMPLX (-SPSUM, 0.0)
               TMAT1(3,2) = CMPLX (CPSUM, 0.0)
               TMAT1(4,2) = CMPLX (0.0, -SPDIF)
               TMAT1(1,3) = CMPLX (-SPDIF, 0.0)
               TMAT1(2,3) = CMPLX (-CPSUM, 0.0)
               TMAT1(3,3) = CMPLX (-SPSUM, 0.0)
               TMAT1(4,3) = CMPLX (0.0, -CPDIF)
               TMAT1(1,4) = CMPLX (SPDIF, 0.0)
               TMAT1(2,4) = CMPLX (-CPSUM, 0.0)
               TMAT1(3,4) = CMPLX (-SPSUM, 0.0)
               TMAT1(4,3) = CMPLX (0.0, CPDIF)
C                                       Invert
               LDA = 4
               N = 4
C                                       Factorize matrix
               CALL CGEFA (TMAT1, LDA, N, IPVT, INFO)
C                                       Check for singularity
               IF (INFO.EQ.0) THEN
                  JOB = 1
                  CALL CGEDI (TMAT1, LDA, N, IPVT, DET, WORK, JOB)
C                                       Deal with singular matrix
               ELSE
                  IERR = 9
                  WRITE (MSGTXT,1500) IANT1, IANT2, IIF
                  CALL MSGWRT (8)
                  GO TO 999
                  END IF
C                                       Matrix to convert I,Q,U and V to
C                                       RR,LL,RL,LR that would have been
C                                       observed including the effects
C                                       of phase calibration.
C                                       NOTE: CPSUM and SPSUM should be
C                                       the cosine and sine of twice the
C                                       parallactic angle of the
C                                       reference antenna used for phase
C                                       calibrations.
               CPSUM = COS (2.0*PANGLE(IANT1))
               SPSUM = SIN (2.0*PANGLE(IANT1))
               TMAT2(1,1) = CMPLX (0.5, 0.0)
               TMAT2(2,1) = CMPLX (0.0, 0.0)
               TMAT2(3,1) = CMPLX (0.0, 0.0)
               TMAT2(4,1) = CMPLX (0.5, 0.0)
               TMAT2(1,2) = CMPLX (0.5, 0.0)
               TMAT2(2,2) = CMPLX (0.0, 0.0)
               TMAT2(3,2) = CMPLX (0.0, 0.0)
               TMAT2(4,2) = CMPLX (-0.5, 0.0)
               TMAT2(1,3) = CMPLX (0.0, 0.0)
               TMAT2(2,3) = CMPLX (0.5*CPSUM, -0.5*SPSUM)
               TMAT2(3,3) = CMPLX (0.5*SPSUM, 0.5*CPSUM)
               TMAT2(4,3) = CMPLX (0.0, 0.0)
               TMAT2(1,4) = CMPLX (0.0, 0.0)
               TMAT2(2,4) = CMPLX (0.5*CPSUM, 0.5*SPSUM)
               TMAT2(3,4) = CMPLX (0.5*SPSUM, -0.5*CPSUM)
               TMAT2(4,4) = CMPLX (0.0, 0.0)
C                                       Multiply TMAT2 by TMAT1
               DO 60 II = 1,4
                  DO 50 JJ = 1,4
                     TMAT3(II,JJ) = TMAT2(1,JJ)*TMAT1(II,1) +
     *                  TMAT2(2,JJ)*TMAT1(II,2) +
     *                  TMAT2(3,JJ)*TMAT1(II,3) +
     *                  TMAT2(4,JJ)*TMAT1(II,4)
 50                  CONTINUE
 60               CONTINUE
               END IF
C                                       Loop over IF, channel
            DO 580 IIF = BIF,EIF
               BLPNT = LENTRY * (BLNDX-1) + (IIF-BIF)*32*PCLCH
               POLPTR = PPOLCL + BLPNT + 1 - 32
               IF (PDVER.GT.0) THEN
                  KX1 = (4 * PDNUMF * PDNUMI) * (IANT1 - 1) +
     *               2 * PDNUMF * (IIF - 1) + 2 * (BCHAN -1) + 1
                  KX2 = (4 * PDNUMF * PDNUMI) * (IANT2 - 1) +
     *               2 * PDNUMF * (IIF - 1) + 2 * (BCHAN -1) + 1
                  KY1 = KX1 + (2 * PDNUMF * PDNUMI)
                  KY2 = KX2 + (2 * PDNUMF * PDNUMI)
                  END IF
               DO 570 ICH = IC1,IC2
                  IF (PDVER.GT.0) IFQ = ICH
                  FLAGED = .FALSE.
                  POLPTR = POLPTR + 32
C                                       Linear approximation:
                  IF (SOLTYP.EQ.1) THEN
                     IF (PDVER.LE.0) THEN
                        IF ((STNELP(1,IIF,IANT1).EQ.FBLANK) .OR.
     *                     (STNELP(2,IIF,IANT1).EQ.FBLANK) .OR.
     *                     (STNELP(1,IIF,IANT2).EQ.FBLANK) .OR.
     *                     (STNELP(2,IIF,IANT2).EQ.FBLANK) .OR.
     *                     (STNORI(1,IIF,IANT1).EQ.FBLANK) .OR.
     *                     (STNORI(2,IIF,IANT1).EQ.FBLANK) .OR.
     *                     (STNORI(1,IIF,IANT2).EQ.FBLANK) .OR.
     *                     (STNORI(2,IIF,IANT2).EQ.FBLANK)) THEN
                           FLAGED = .TRUE.
                           DX1 = CMPLX (0.0, 0.0)
                           DY1 = CMPLX (0.0, 0.0)
                           DX2 = CMPLX (0.0, 0.0)
                           DY2 = CMPLX (0.0, 0.0)
                        ELSE
                           DX1 = CMPLX (STNELP(1,IIF,IANT1),
     *                        STNORI(1,IIF,IANT1))
                           DY1 = CMPLX (STNELP(2,IIF,IANT1),
     *                        STNORI(2,IIF,IANT1))
                           DX2 = CMPLX (STNELP(1,IIF,IANT2),
     *                        STNORI(1,IIF,IANT2))
                           DY2 = CMPLX (STNELP(2,IIF,IANT2),
     *                        STNORI(2,IIF,IANT2))
                           END IF
                     ELSE
                        IF ((DTERMS(PDTERM+KX1).EQ.FBLANK) .OR.
     *                     (DTERMS(PDTERM+KX1+1).EQ.FBLANK) .OR.
     *                     (DTERMS(PDTERM+KY1).EQ.FBLANK) .OR.
     *                     (DTERMS(PDTERM+KY1+1).EQ.FBLANK) .OR.
     *                     (DTERMS(PDTERM+KX2).EQ.FBLANK) .OR.
     *                     (DTERMS(PDTERM+KX2+1).EQ.FBLANK) .OR.
     *                     (DTERMS(PDTERM+KY2).EQ.FBLANK) .OR.
     *                     (DTERMS(PDTERM+KY2+1).EQ.FBLANK)) THEN
                           FLAGED = .TRUE.
                           DX1 = CMPLX (0.0, 0.0)
                           DY1 = CMPLX (0.0, 0.0)
                           DX2 = CMPLX (0.0, 0.0)
                           DY2 = CMPLX (0.0, 0.0)
                        ELSE
                           DX1 = CMPLX (DTERMS(PDTERM+KX1),
     *                        DTERMS(PDTERM+KX1+1))
                           DY1 = CMPLX (DTERMS(PDTERM+KY1),
     *                        DTERMS(PDTERM+KY1+1))
                           DX2 = CMPLX (DTERMS(PDTERM+KX2),
     *                        DTERMS(PDTERM+KX2+1))
                           DY2 = CMPLX (DTERMS(PDTERM+KY2),
     *                        DTERMS(PDTERM+KY2+1))
                           END IF
                        KX1 = KX1 + 2
                        KY1 = KY1 + 2
                        KX2 = KX2 + 2
                        KY2 = KY2 + 2
                        END IF
                     CALL RFILL (32, 0.0, DMAT)
                     DO 70 II = 1,4
                        DMAT(II,II) = (1.0, 0.0)
 70                     CONTINUE
C                                       Instrumental terms
                     IF (FLAGED) THEN
                        DMAT(3,1) = CMPLX (FBLANK, 0.0)
                        DMAT(3,2) = CMPLX (FBLANK, 0.0)
                        DMAT(4,1) = CMPLX (FBLANK, 0.0)
                        DMAT(4,2) = CMPLX (FBLANK, 0.0)
                     ELSE
                        DMAT(3,1) = (DX1 + CONJG (DY2))
                        DMAT(3,2) = DMAT(3,1)
                        DMAT(4,1) = (DY1 + CONJG (DX2))
                        DMAT(4,2) = DMAT(4,1)
                        END IF
                  ELSE
C                                       Orientation - ellipticity:
                     IBLPNT = 1
                     DO 100 IPOL = 1,4
                        IP1 = IPOFF(IPOL,1)
                        IP2 = IPOFF(IPOL,2)
C                                       Feed constants
                        IF (PDVER.LE.0) THEN
                           IF ((STNELP(IP1,IIF,IANT1).EQ.FBLANK) .OR.
     *                        (STNELP(IP2,IIF,IANT1).EQ.FBLANK) .OR.
     *                        (STNELP(IP1,IIF,IANT2).EQ.FBLANK) .OR.
     *                        (STNELP(IP2,IIF,IANT2).EQ.FBLANK) .OR.
     *                        (STNORI(IP1,IIF,IANT1).EQ.FBLANK) .OR.
     *                        (STNORI(IP2,IIF,IANT1).EQ.FBLANK) .OR.
     *                        (STNORI(IP1,IIF,IANT2).EQ.FBLANK) .OR.
     *                        (STNORI(IP2,IIF,IANT2).EQ.FBLANK)) THEN
                              FLAGED = .TRUE.
                           ELSE
                              PDIF = STNORI(IP1,IIF,IANT1) -
     *                           STNORI(IP2,IIF,IANT2)
                              PSUM = STNORI(IP1,IIF,IANT1) +
     *                           STNORI(IP2,IIF,IANT2)
                              TDIF = STNELP(IP1,IIF,IANT1) -
     *                           STNELP(IP2,IIF,IANT2)
                              TSUM = STNELP(IP1,IIF,IANT1) +
     *                           STNELP(IP2,IIF,IANT2)
                              END IF
                        ELSE
                           IF (IP1.EQ.1) THEN
                              KK = KX1
                           ELSE
                              KK = KY1
                              END IF
                           IF (IP2.EQ.1) THEN
                              JJ = KX2
                           ELSE
                              JJ = KY2
                              END IF
                           IF ((DTERMS(PDTERM+KK).EQ.FBLANK) .OR.
     *                        (DTERMS(PDTERM+KK+1).EQ.FBLANK) .OR.
     *                        (DTERMS(PDTERM+JJ).EQ.FBLANK) .OR.
     *                        (DTERMS(PDTERM+JJ+1).EQ.FBLANK) .OR.
     *                        (DTERMS(PDTERM+KK).EQ.FBLANK) .OR.
     *                        (DTERMS(PDTERM+KK+1).EQ.FBLANK) .OR.
     *                        (DTERMS(PDTERM+JJ).EQ.FBLANK) .OR.
     *                        (DTERMS(PDTERM+JJ+1).EQ.FBLANK)) THEN
                              FLAGED = .TRUE.
                           ELSE
                              PDIF = DTERMS(PDTERM+KK+1) -
     *                           DTERMS(PDTERM+JJ+1)
                              PSUM = DTERMS(PDTERM+KK+1) +
     *                           DTERMS(PDTERM+JJ+1)
                              TDIF = DTERMS(PDTERM+KK) -
     *                           DTERMS(PDTERM+JJ)
                              TSUM = DTERMS(PDTERM+KK) +
     *                           DTERMS(PDTERM+JJ)
                              END IF
                           END IF
                        IF (.NOT.FLAGED) THEN
                           SPDIF = 0.5 * SIN (PDIF)
                           CPDIF = 0.5 * COS (PDIF)
                           SPSUM = 0.5 * SIN (PSUM)
                           CPSUM = 0.5 * COS (PSUM)
                           STDIF = SIN (TDIF)
                           CTDIF = COS (TDIF)
                           STSUM = SIN (TSUM)
                           CTSUM = COS (TSUM)
C                                       Matrix terms
                           XMAT(1,IBLPNT) =   CPDIF * (CTDIF - STSUM)
                           XMAT(2,IBLPNT) =   SPDIF * (STSUM - CTDIF)
                           XMAT(1,IBLPNT+4) = CPDIF * (CTDIF + STSUM)
                           XMAT(2,IBLPNT+4) = SPDIF * (CTDIF + STSUM)
                           XMAT(1,IBLPNT+8) = CPSUM * (CTSUM - STDIF)
                           XMAT(2,IBLPNT+8) = SPSUM * (STDIF - CTSUM)
                           XMAT(1,IBLPNT+12) = CPSUM * (CTSUM +
     *                        STDIF)
                           XMAT(2,IBLPNT+12) = SPSUM * (STDIF +
     *                        CTSUM)
                           END IF
                        IBLPNT = IBLPNT + 1
 100                    CONTINUE
C                                       Invert baseline-IF matrix.
                     IF (.NOT.FLAGED) THEN
                        LDA = 4
                        N = 4
C                                       Factorize matrix
                        CALL CGEFA (DMAT, LDA, N, IPVT, INFO)
C                                       Check for singularity
                        IF (INFO.EQ.0) THEN
                           JOB = 1
                           CALL CGEDI (DMAT, LDA, N, IPVT, DET, WORK,
     *                        JOB)
C                                       Deal with singular matrix
                        ELSE
                           WRITE (MSGTXT,1500) IANT1, IANT2, IIF
                           CALL MSGWRT (8)
C                                       Zero matrix
                           CALL RFILL (32, FBLANK, DMAT)
                           END IF
C                                       Add corrections for
C                                       orientation angle removed in
C                                       calibration
C                    DO 120 IPOL = 1,4
C                       IP1 = IPOFF(IPOL,1)
C                       IP2 = IPOFF(IPOL,2)
C                       PDIF = ORIFAC(IP1) * STNORI(IP1,IIF,IANT1) -
C    *                     ORIFAC(IP2) * STNORI(IP2,IIF,IANT2)
C                       CPDIF = COS (PDIF)
C                       SPDIF = SIN (PDIF)
C                                       Correct column of matrix
C                       JP = BLPNT + (IPOL - 1) * 4
C                       DO 110 LOOP = 1,4
C                          TEMPR = POLCAL(1,JP)
C                          TEMPI = POLCAL(2,JP)
C                          POLCAL(1,JP) = TEMPR * CPDIF - TEMPI * SPDIF
C                          POLCAL(2,JP) = TEMPR * SPDIF + TEMPI * CPDIF
C                          JP = JP + 1
C110                       CONTINUE
C120                    CONTINUE
C                                       End of solution type specific
C                                       parameterization.
                        END IF
                     END IF
C                                       Multiply TMAT3 by DMAT to
C                                       produce properly modified
C                                       RR,LL,RL,LR
                  IF (.NOT.FLAGED) THEN
                     DO 220 II = 1,4
                        DO 210 JJ = 1,4
                           BLMAT(II,JJ) = TMAT3(1,JJ)*DMAT(II,1) +
     *                        TMAT3(2,JJ)*DMAT(II,2) +
     *                        TMAT3(3,JJ)*DMAT(II,3) +
     *                        TMAT3(4,JJ)*DMAT(II,4)
 210                       CONTINUE
 220                    CONTINUE
                  ELSE
                     CALL RFILL (32, FBLANK, BLMAT)
                     END IF
                  CALL RCOPY (32, BLMAT, POLCAL(POLPTR))
C
 570              CONTINUE
 580           CONTINUE
 590        CONTINUE
 600     CONTINUE
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1500 FORMAT ('SINGULAR MATRIX ON ',I3,' - ',I3,' IF =',I3,' WILL ZERO')
      END

      SUBROUTINE FILDES (NAMS, ASSOC, TYPE, VER, ERROR)
C-----------------------------------------------------------------------
C! destroy the specified file or associated file
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   WaWa IO system: Destroy the file specified by NAMS, TYPE, VER
C   Inputs:
C      NAMS      C*36  NAMESTRING specifying catalog block to which
C                      file is associated: NAME,CLASS,CATTYPE,SEQ,VOL,
C                      USID.  NAME,CLASS,USID ignored for scratch files.
C      ASSOC     L     File is an associated file,i.e. not catalogd
C                      ASSOC will be taken as FALSE if NAMS(8)='SCxx'
C      TYPE      C*2   Associated file type; ignored if ASSOC is false
C      VER       I     Associated file version; ignored if ASSOC is fal
C   Outputs:
C      ERROR     I      Error code:  0 => o.k.
C                          10 => catalog error
C                          11 => map too busy to destroy
C                          12 => map not found in catalog
C                          13 => extension file not in catalog
C                          25 => other destroy errors
C   Written by WaWa (4/21/81)
C-----------------------------------------------------------------------
      CHARACTER NAMS*36, TYPE*2
      LOGICAL ASSOC
      INTEGER VER, ERROR
C
      CHARACTER OPER*4, DNAMS*36, STAT*4, PNAM*48, DNAME*12, DCLASS*6,
     *   DPTYPE*2, CTEMP*2
      INTEGER   SEQ, USID, NSUB, CNO, DVOL, STAR, CATER, NOEXT, EFIND,
     *   STAERR, DESER, WARN, I, IERR, J, NOFIND
      LOGICAL   LSCR, MAIN
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA EFIND, NOEXT, STAR, CATER, NOFIND, STAERR /12,13,11,10,5,4/
      DATA DESER, WARN /25, 6/
C-----------------------------------------------------------------------
      MAIN = .NOT.ASSOC
      ERROR = CATER
C                                       Prepare NAME (scratch?,pack)
      CALL PRENAM (NAMS, DNAMS, LSCR)
      MAIN = MAIN .OR. LSCR
C                                       Make Namestr intelligble
      CALL WAWA2A (DNAMS, DNAME, DCLASS, SEQ, DPTYPE, DVOL, USID)
C                                       Look for catalog block
      OPER = 'SRCH'
      CNO = 1
      CALL CATDIR ('SRCH', DVOL, CNO, DNAME, DCLASS, SEQ, DPTYPE, USID,
     *   STAT, WBUFF, IERR)
      IF (IERR.EQ.0) GO TO 100
         IF (IERR.NE.NOFIND) GO TO 20
            WRITE (MSGTXT,1000)
            ERROR = EFIND
            GO TO 990
 20      CONTINUE
            NSUB = 1
            GO TO 980
C                                       Destroy an extension file
 100  IF (MAIN) GO TO 200
C                                       Get catalog block
         OPER = 'READ'
         NSUB = 2
         CALL CATIO ('READ', DVOL, CNO, CATBLK, 'REST', WBUFF, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.WARN)) GO TO 980
C                                       Look for EXT
         CALL FXHDEX (CATBLK)
         DO 110 I = 1,KIEXTN
            CALL H2CHR (2, 1, CATH(KHEXT+I-1), CTEMP)
            IF (TYPE.EQ.CTEMP) GO TO 120
 110        CONTINUE
         GO TO 150
C                                       Look for VER
 120     J = KIVER + I - 1
         IF ((VER.LE.0) .OR. (VER.GT.CATBLK(J))) GO TO 150
         IF (VER.EQ.CATBLK(J)) CATBLK(J) = VER - 1
         IF (CATBLK(J).EQ.0) CALL CHR2H (2, '  ', 1, CATH(KHEXT+I-1))
C                                       Update cat, check status
         OPER = 'WRIT'
         CALL CATIO ('WRIT', DVOL, CNO, CATBLK, 'REST', WBUFF, IERR)
         IF (IERR.EQ.0) GO TO 130
            IF (IERR.NE.STAERR) GO TO 125
               ERROR = STAR
               WRITE (MSGTXT,1120)
               GO TO 990
 125        CONTINUE
               NSUB = 2
               GO TO 980
C                                       Do destroy
 130     CALL ZPHFIL (TYPE, DVOL, CNO, VER, PNAM, IERR)
         CALL ZDESTR (DVOL, PNAM, IERR)
         ERROR = 0
         IF (IERR.LE.1) GO TO 999
            NSUB = 7
            OPER = 'DEST'
            ERROR = DESER
            GO TO 980
C                                       Ext not found
 150     ERROR = NOEXT
         WRITE (MSGTXT,1150) TYPE, VER
         GO TO 990
C                                       Delete whole file set
 200  CONTINUE
         I = -32000
         CALL MDESTR (DVOL, CNO, CATBLK, WBUFF, I, IERR)
         ERROR = 0
         IF (IERR.EQ.0) GO TO 999
            ERROR = DESER
            IF (IERR.NE.2) GO TO 995
               ERROR = STAR
               GO TO 999
C                                       Errors
 980  WRITE (MSGTXT,1980) SUBNAM(NSUB), OPER, IERR
C
 990  CALL MSGWRT (8)
C
 995  CALL A2WAWA (DNAME, DCLASS, SEQ, DPTYPE, DVOL, USID, DNAMS)
      CALL PRTNAM (DNAMS, 8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FILDES: CAN''T FIND CATALOG BLOCK ')
 1120 FORMAT ('FILDES: CAN''T DESTROY, MAIN FILE BUSY ')
 1150 FORMAT ('FILDES: CAN''T FIND EXT ',A2,' VER ',I5)
 1980 FORMAT ('FILDES: ',A6,2X,A4,' ERROR',I7)
      END

      SUBROUTINE ZADDR (ADDR1, ADDR2, IERR)
C-----------------------------------------------------------------------
C! determine if 2 addresses inside computer are the same
C# Z Service
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Determine if two addresses are the same.
C   Inputs:
C      addr1   I(*)   Address 1
C      addr2   I(*)   Address 2
C   Output:
C      ierr    I      Error return code:
C                        0 => addresses are the same
C                        1 => addresses are different
C   Generic version - stub
C-----------------------------------------------------------------------
      INTEGER   ADDR1(*), ADDR2(*)
      INTEGER   IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'ZADDR: REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (9)
C
 999  RETURN
      END

      SUBROUTINE  QHIST (A, I, C, N, NB, AMAX, AMIN)
C-----------------------------------------------------------------------
C! FPS AP version: Histogram of values in a vector
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FPS AP version
C   Computes the histogram of a vector.
C   Histogram element (NB-1)*(DATA-MIN)/(MAX-MIN) where DATA
C   is the data value is incremented.
C    Inputs:
C     A     I  Source vector base address.
C     I     I  A address increment.
C     C     I  Histogram base address
C                  Histogram must be cleared before first call.
C     N     I  Element count for A
C     NB    I  Number of bins in histogram
C     AMAX  I  Address of histogram maximum.
C     AMIN  I  Address of histogram minimum.
C-----------------------------------------------------------------------
      INTEGER A, I, C, N, NB, AMAX, AMIN
      INTEGER*2 IA, II, IC, IN, INB, IAMAX, IAMIN
C-----------------------------------------------------------------------
C                                        Convert inputs to unsigned I*2
      IF (A.LT.32768) IA = A
      IF (A.GE.32768) IA = A - 65536
      IF (I.LT.32768) II = I
      IF (I.GE.32768) II = I - 65536
      IF (C.LT.32768) IC = C
      IF (C.GE.32768) IC = C - 65536
      IF (N.LT.32768) IN = N
      IF (N.GE.32768) IN = N - 65536
      IF (NB.LT.32768) INB = NB
      IF (NB.GE.32768) INB = NB - 65536
      IF (AMAX.LT.32768) IAMAX = AMAX
      IF (AMAX.GE.32768) IAMAX = AMAX - 65536
      IF (AMIN.LT.32768) IAMIN = AMIN
      IF (AMIN.GE.32768) IAMIN = AMIN - 65536
C                                        Call FPS routine.
      CALL HIST (IA, II, IC, IN, INB, IAMAX, IAMIN)
C
 999  RETURN
      END

      SUBROUTINE GETNUM (KB, KBPLIM, KBP, X)
C-----------------------------------------------------------------------
C! returns numeric field from character buffer
C# Parsing FITS POPS-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GETNUM converts ASCII numeric field into double precision number.
C   Inputs:
C      KB      C*(*)   character buffer
C      KBPLIM  I       max character position in buffer to examine
C      KBP     I       start of numeric field
C   Outputs:
C      KBP     I       start of next field (incl blanks)
C      X       D       numerical value: sets to magic indef = DBLANK
C                      from DDCH.INC when overflow exponent or value or
C                      when there are no numeric characters found
C   Common:
C      DERR.INC        Sets ERRNUM to 27 on failures
C   Note that a value of 'INDE' returns X = DBLANK, ERRNUM = 0
C   Other missing numeric values, excessive exponents return X = DBLANK,
C   ERRNUM = 27.
C-----------------------------------------------------------------------
      CHARACTER KB*(*)
      INTEGER   KBP, KBPLIM
      DOUBLE PRECISION X
C
      INTEGER   EXSIGN, IEXP, IT, LEADER, IDEC, NC
      DOUBLE PRECISION    SIGN, TEN
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      X = 0.0D0
      IF (KBP.GT.KBPLIM) GO TO 980
      LEADER = 0
      IDEC = 0
      SIGN = 1.0D0
      EXSIGN = 1
      TEN = 10.0D0
      IEXP = 0
      NC = 0
C                                        skip leading blank,comma,+
 10   IF ((KB(KBP:KBP).NE.' ') .AND. (KB(KBP:KBP).NE.',') .AND.
     *   (KB(KBP:KBP).NE.'+')) GO TO 15
         KBP = KBP + 1
         IF (KBP.GT.KBPLIM) GO TO 999
         GO TO 10
C                                        allow blank
 15   IF ((KBP+9.LE.KBPLIM) .AND. (KB(KBP:KBP+9).EQ.'''INDEFINT'''))
     *   THEN
         KBP = KBP + 10
         GO TO 990
         END IF
      IF ((KBP+5.LE.KBPLIM) .AND. (KB(KBP:KBP+5).EQ.'''INDE''')) THEN
         KBP = KBP + 6
         GO TO 990
         END IF
      KBP = KBP - 1
C                                        get chars
 20   KBP = KBP + 1
         IF (KBP.GT.KBPLIM) GO TO 90
         IF (KB(KBP:KBP).NE.'.') GO TO 25
            IDEC = 1
            GO TO 20
C                                        unary minus
 25      IF (KB(KBP:KBP).NE.'-') GO TO 30
            IF (LEADER.NE.0) GO TO 40
            SIGN = -SIGN
            GO TO 20
C                                        other: leave if not num
 30      CONTINUE
            LEADER = 1
            IT = ICHAR(KB(KBP:KBP)) - ICHAR('0')
            IF ((IT.LT.0) .OR. (IT.GT.9)) GO TO 40
            NC = NC + 1
            X = X * TEN + IT
            IF (IDEC.NE.0) IDEC = IDEC + 1
            GO TO 20
C                                        exponential notation E or D
C                                        then (optional) blank,+,-
C                                        then integer number
 40   IF ((KB(KBP:KBP).NE.'E') .AND. (KB(KBP:KBP).NE.'D') .AND.
     *   (KB(KBP:KBP).NE.'e') .AND. (KB(KBP:KBP).NE.'d')) GO TO 90
         KBP = KBP + 1
         IF (KBP.GT.KBPLIM) GO TO 90
         IF ((KB(KBP:KBP).NE.'-') .AND. (KB(KBP:KBP).NE.'+') .AND.
     *      (KB(KBP:KBP).NE.' ')) GO TO 50
            IF (KB(KBP:KBP).EQ.'-') EXSIGN = -1
 45         KBP = KBP + 1
            IF (KBP.GT.KBPLIM) GO TO 90
 50            IT = ICHAR(KB(KBP:KBP)) - ICHAR('0')
               IF ((IT.LT.0) .OR. (IT.GT.9)) GO TO 90
                  IEXP = 10*IEXP + IT
                  NC = NC + 1
                  GO TO 45
C                                        got it: apply sign, decimal pl
 90   IF (NC.LE.0) GO TO 980
         IDEC = MAX (0, IDEC-1)
         IDEC = EXSIGN*IEXP - IDEC
         IF (IDEC.GT.38) GO TO 980
            IF (IDEC.GT.-34) THEN
               X = X * SIGN / (TEN**(-IDEC))
C                                       actual IEEE limit around 2.0e38
C                                       for single precision storage
               IF (ABS(X).GT.1.E35) GO TO 980
            ELSE
               X = 0.0
               END IF
            GO TO 999
C                                        error
 980  ERRNUM = 27
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.10) PNAME(ERRLEV) = 'GETNUM'
C                                        allow blank
 990  X = DBLANK
C
 999  RETURN
      END

      SUBROUTINE IMSEL (INDSK, INCNO, OUTDSK, OUTCNO, VERS, INCB, OUTCB,
     *   INLUN, OUTLUN, BPOL, EPOL, BIF, EIF, FREQID, START, FINISH,
     *   NUMSRC, SOURCS, ANTENS, NUMANT, INSUB, OUTSUB, INBUF, OUTBUF,
     *   IRET)
C-----------------------------------------------------------------------
C! Copies an IM table with data selection
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2000, 2011
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Copies data from selected IFs that lie within a specified time
C   range from one interferometer model (IM) table to another. Data may
C   also be filtered using the source ID, subarray number, or antenna
C   number.
C
C   If FREQID is positive then only data for frequency ID FREQID or
C   frequency ID zero  will be copied to the output table and these data
C   will be assigned frequency ID 1. If FREQID is not positive then data
C   will not be restricted by frequency ID and frequency IDs will be
C   unchanged in the output table.
C
C   If NUMSRC is positive then only data for sources listed in the
C   first NUMSRC elements of SOURCS or for source ID zero will be copied
C   to the output table. If NUMSRC is not positive then data will not be
C   restricted by source.
C
C   If NUMANT is positive then only data for antennas listed in the
C   first NUMANT elements of ANTENS or for antenna number zero will be
C   copied to the output table. If NUMANT is not positive then data will
C   not be restricted by antenna.
C
C   If INSUB is positive then only data for subarray INSUB or subarray
C   zero will be copied to the output table. If INSUB is not positive
C   then data will not be restricted by subarray.
C
C   If OUTSUB is positive then all data written to the output table
C   will be assigned to subarray OUTSUB. If OUTSUB is not positive then
C   subarray numbers will not be changed in the output table.
C
C   Writes an informational message at priority level 3 if the data are
C   copied successfully. Writes at least one error message at priority
C   level 6 or higher if the data are not copied successfully.
C
C   The input and output tables must be attached to different files.
C
C   Inputs:
C      INDSK    I        Disk number for input table
C      INCNO    I        Catalogue number for input table
C      OUTDSK   I        Disk number for output table
C      OUTCNO   I        Catalogue number for output table
C      VERS     I        Version number of input and output tables; if
C                        0 the highest version number of an IM table
C                        attached to the input file will be used
C      INCB     I(256)   Catalogue block of parent data file for
C                           the input table
C      INLUN    I        AIPS LUN used for input table
C      OUTLUN   I        AIPS LUN used for output table
C      BIF      I        Lowest numbered IF to copy
C      EIF      I        Highest numbered IF to copy
C      FREQID   I        Selected frequency ID (see above)
C      START    D        Earliest time to copy (days)
C      FINISH   D        Latest time to copy (days)
C      NUMSRC   I        Number of sources selected (see above)
C      SOURCS   I(*)     List of source IDs selected (see above)
C      ANTENS   I(*)     List of antenna numbers selected
C      NUMANT   I        Number of antennas selected (see above)
C      INSUB    I        Subarray number selected (see above)
C      OUTSUB   I        Output subarray number (see above)
C
C   Input/Output:
C      OUTCB    I(256)   Catalogue block of parent data file for
C                           the output table
C      INBUF    I(512)   Buffer for input table
C      OUTBUF   I(512)   Buffer for output table
C
C   Output:
C      IRET         I            Return status:
C                                  0 if selected data copied;
C                                  non-zero if not all data copied
C-----------------------------------------------------------------------
      INTEGER   INDSK, INCNO, OUTDSK, OUTCNO, VERS, INCB(256),
     *   OUTCB(256), INLUN, OUTLUN, BPOL, EPOL, BIF, EIF, FREQID,
     *   NUMSRC, SOURCS(*), ANTENS(*), NUMANT, INSUB, OUTSUB, INBUF(*),
     *   OUTBUF(*), IRET
      DOUBLE PRECISION START, FINISH
C
      INCLUDE 'INCS:PUVD.INC'
C
C     Local variables:
C
C     INVER     input table version number
C     INROW     input table row number
C     INCIDX    input row column index array
C     INCDIM    input row column dimensions array
C     OBSCOD    observing code
C     RDATE     reference date
C     NUMSTK    number of Stokes parameters
C     STK1      first Stokes parameter code
C     INNIF     number of IFs in input table
C     NUMCHN    number of channels
C     REFFRQ    reference frequency
C     CHANBW    channel bandwidth
C     REFPIX    reference pixel on frequency axis
C     NUMPOL    number of polarizations in table
C     NUMPLY    number of polynomial terms in table
C     CORREV    correlator software revision code
C
C     NUMROW    number of rows in input table
C
C     LOIF      first IF to copy
C     HIIF      last IF to copy
C     OUTNIF    number of IFs to copy
C
C     REFORM    is output data reformatted rather than copied?
C
C     OUTVER    output table version number
C     OUTROW    output row number
C     OUCIDX    output column index array
C     OUCDIM    output column dimensions array
C
C     ROW       number of rows from input file examined so far
C
C     MAXPLY    maximum number of terms in delay rate polynomials
C
C     TIME      reference time of current row
C     TIMINT    time interval covered by current row
C     SOURID    source ID of current row
C     ANTNUM    antenna number of current row
C     SUBARR    subarray number of current row
C     FQID      frequency ID of current row
C     IFR       ionospheric Faraday rotation
C     INFVR     input frequency offsets
C     INPD      input phase delay polynomials
C     GDELAY    group delay polynomials
C     INPR      input phase rate polynomials
C     GRATE     group rate polynomials
C     DISP      dispersive delay
C     DDISP     rate of change of dispersive delay
C
C     SRCSEL    is current source selected?
C     ANTSEL    is current antenna selected?
C     SRC       index into SOURCS
C     ANT       index into ANTENS
C
C     POL       polarization index
C     INBND     input band index
C     OUTBND    output band index
C     TERM      polynomial term
C     OUTFVR    output frequency offsets
C     OUTPD     output phase delay polynomials
C     OUTPR     output phase rate polynomials
C
C     IRET1     disposable return status
C
      INTEGER   INVER
      INTEGER   INROW
      INTEGER   INCIDX(20)
      INTEGER   INCDIM(20)
      CHARACTER OBSCOD*8
      CHARACTER RDATE*8
      INTEGER   NUMSTK
      INTEGER   STK1
      INTEGER   INNIF
      INTEGER   NUMCHN
      DOUBLE PRECISION REFFRQ
      DOUBLE PRECISION CHANBW
      DOUBLE PRECISION REFPIX
      INTEGER   NUMPOL
      INTEGER   NUMPLY
      DOUBLE PRECISION CORREV
C
      INTEGER   NUMROW
C
      INTEGER   LOIF
      INTEGER   HIIF
      INTEGER   OUTNIF
C
      LOGICAL   REFORM
C
      INTEGER   OUTVER
      INTEGER   OUTROW
      INTEGER   OUCIDX(20)
      INTEGER   OUCDIM(20)
C
      INTEGER   ROW
C
      INTEGER   MAXPLY
      PARAMETER (MAXPLY = 20)
C
      DOUBLE PRECISION TIME
      REAL      TIMINT
      INTEGER   SOURID
      INTEGER   ANTNUM
      INTEGER   SUBARR
      INTEGER   FQID
      REAL      IFR
      REAL      INFVR(MAXIF)
      DOUBLE PRECISION INPD(2, MAXIF, MAXPLY)
      DOUBLE PRECISION GDELAY(2, MAXPLY)
      DOUBLE PRECISION INPR(2, MAXIF, MAXPLY)
      DOUBLE PRECISION GRATE(2, MAXPLY)
      REAL      DISP
      REAL      DDISP
C
      LOGICAL   SRCSEL
      LOGICAL   ANTSEL
      INTEGER   SRC
      INTEGER   ANT
C
      INTEGER   POL, LBPOL, NEWPOL, K
      INTEGER   INBND
      INTEGER   OUTBND
      INTEGER   TERM
      REAL      OUTFVR(MAXIF)
      DOUBLE PRECISION OUTPD(2, MAXIF, MAXPLY)
      DOUBLE PRECISION OUTPR(2, MAXIF, MAXPLY)
C
      INTEGER   IRET1
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      INVER = VERS
      CALL IMINIT ('READ', INBUF, INDSK, INCNO, INVER, INCB, INLUN,
     *   INROW, INCIDX, INCDIM, OBSCOD, RDATE, NUMSTK, STK1, INNIF,
     *   NUMCHN, REFFRQ, CHANBW, REFPIX, NUMPOL, NUMPLY, CORREV, IRET)
      IF (IRET.EQ.0) THEN
         NUMROW = INBUF(5)
C                                       Set IF range:
         LOIF = MAX (1, BIF)
         HIIF = MIN (INNIF, EIF)
         OUTNIF = HIIF - LOIF + 1
         IF (OUTNIF.LE.0) THEN
            OUTNIF = INNIF
            LOIF = 1
            END IF
C                                       set pol range
         LBPOL = MAX (1, BPOL)
         NEWPOL = MIN (2, MIN (NUMPOL, EPOL)) - LBPOL + 1
         IF (NEWPOL.LE.0) THEN
            NEWPOL = NUMPOL
            LBPOL = 1
            END IF
         REFORM = (OUTNIF.NE.INNIF) .OR. (NEWPOL.NE.NUMPOL)
C
         OUTVER = INVER
         CALL IMINIT ('WRIT', OUTBUF, OUTDSK, OUTCNO, OUTVER, OUTCB,
     *      OUTLUN, OUTROW, OUCIDX, OUCDIM, OBSCOD, RDATE, NUMSTK, STK1,
     *      OUTNIF, NUMCHN, REFFRQ, CHANBW, REFPIX, NEWPOL, NUMPLY,
     *      CORREV, IRET)
         IF (IRET.EQ.0) THEN
            ROW = 0
C
C           Invariant: IRET = 0 implies that selected data from the
C                      first ROW rows of the input table has been
C                      written to the output table and REFORM = false
C                      implies that all of the data in the first ROW
C                      rows has been copied
C           Bound: NUMROW - ROW when IRET = 0; 0 otherwise
C
 10         IF ((IRET.EQ.0) .AND. (ROW.NE.NUMROW)) THEN
               INROW = ROW + 1
               CALL TABIM ('READ', INBUF, INROW, INCIDX, INCDIM, NUMPOL,
     *            TIME, TIMINT, SOURID, ANTNUM, SUBARR, FQID, IFR,
     *            INFVR, INPD, GDELAY, INPR, GRATE, DISP, DDISP, IRET)
               IF (IRET.EQ.0) THEN
C                                       check source
                  IF ((NUMSRC.GT.0) .AND. (SOURID.NE.0)) THEN
                     SRCSEL = .FALSE.
                     DO 20 SRC = 1,NUMSRC
                        IF (SOURCS(SRC).EQ.SOURID) SRCSEL = .TRUE.
 20                     CONTINUE
                  ELSE
                     SRCSEL = .TRUE.
                     END IF
C                                       check ant
                  IF ((NUMANT.GT.0) .AND. (ANTNUM.NE.0)) THEN
                     ANTSEL = .FALSE.
                     DO 30 ANT = 1,NUMANT
                        IF (ANTENS(ANT).EQ.ANTNUM) ANTSEL = .TRUE.
 30                     CONTINUE
                  ELSE
                     ANTSEL = .TRUE.
                     END IF
C
                  IF ((START.LE.TIME) .AND. (TIME.LE.FINISH) .AND.
     *               ((FREQID.LE.0) .OR. (FQID.EQ.0) .OR.
     *               (FQID.EQ.FREQID)) .AND. SRCSEL .AND. ANTSEL .AND.
     *               ((INSUB.LE.0) .OR. (SUBARR.LE.0) .OR.
     *               (SUBARR.EQ.INSUB))) THEN
C
C                    This record is selected so copy the data to
C                    the output table:
C
                     DO 60 POL = 1,NEWPOL
                        K = POL + LBPOL - 1
                        DO 50 INBND = LOIF, HIIF
                           OUTBND = INBND - LOIF + 1
                           OUTFVR(OUTBND) = INFVR(INBND)
                           DO 40 TERM = 1,NUMPLY
                              OUTPD(POL,OUTBND,TERM) =
     *                           INPD(K,INBND,TERM)
                              OUTPR(POL,OUTBND,TERM) =
     *                           INPR(K,INBND,TERM)
   40                         CONTINUE
   50                      CONTINUE
   60                   CONTINUE
                     IF (FREQID.GT.0) FQID = 1
                     IF (OUTSUB.GT.0) SUBARR = OUTSUB
                     CALL TABIM ('WRIT', OUTBUF, OUTROW, OUCIDX, OUCDIM,
     *                  NEWPOL, TIME, TIMINT, SOURID, ANTNUM, SUBARR,
     *                  FQID, IFR, OUTFVR, OUTPD, GDELAY, OUTPR, GRATE,
     *                  DISP, DDISP,  IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT, 9060) IRET
                        CALL MSGWRT (6)
                        END IF
C                    This record is not selected so output table will
C                    not be an exact copy of the input table.
                  ELSE
                     REFORM = .TRUE.
                     END IF
C                 This record is flagged and will not be copied so the
C                 output table will not be an exact copy of the input
C                 table.
               ELSE IF (IRET.LT.0) THEN
                  REFORM = .TRUE.
                  IRET = 0
C                                       read failed
               ELSE
                  WRITE (MSGTXT, 9061) IRET
                  CALL MSGWRT (6)
                  END IF
C
               ROW = ROW + 1
               GO TO 10
               END IF
C
            CALL TABIM ('CLOS', OUTBUF, OUTROW, OUCIDX, OUCDIM, NEWPOL,
     *         TIME, TIMINT, SOURID, ANTNUM, SUBARR, FQID, IFR, OUTFVR,
     *         OUTPD, GDELAY, OUTPR, GRATE, DISP, DDISP, IRET1)
            IF (IRET1.NE.0) THEN
               WRITE (MSGTXT, 9062) IRET1
               CALL MSGWRT (6)
               IRET = IRET1
               END IF
C                                       failed to open output table
         ELSE
            WRITE (MSGTXT, 9063) IRET
            CALL MSGWRT (6)
            END IF
C
         CALL TABIM ('CLOS', INBUF, INROW, INCIDX, INCDIM, NUMPOL, TIME,
     *         TIMINT, SOURID, ANTNUM, SUBARR, FQID, IFR, INFVR,
     *         INPD, GDELAY, INPR, GRATE, DISP, DDISP, IRET1)
         IF (IRET1.NE.0) THEN
            WRITE (MSGTXT, 9064) IRET1
            CALL MSGWRT (6)
            IRET = IRET1
            END IF
      ELSE
C
C        Failed to open input table
C
         WRITE (MSGTXT, 9065) IRET
         CALL MSGWRT (6)
         END IF
C
      IF (IRET.EQ.0) THEN
C
C        Issue summary message:
C
         IF (REFORM) THEN
            WRITE (MSGTXT, 1060) INDSK, INCNO, INVER, OUTDSK, OUTCNO,
     *                           OUTVER
         ELSE
            WRITE (MSGTXT, 1061) INDSK, INCNO, INVER, OUTDSK, OUTCNO,
     *                           OUTVER
         END IF
         CALL MSGWRT (3)
         END IF
C-----------------------------------------------------------------------
 1060 FORMAT ('Reformatted IM file from vol/cno/vers ', I2, I5, I4,
     *        ' to ', I2, I5, I4)
 1061 FORMAT ('Copied IM file from vol/cno/vers ', I2, I5, I4, ' to ',
     *        I2, I5, I4)
 9060 FORMAT ('IMSEL: ERROR ', I3, ' WRITING TO NEW TABLE')
 9061 FORMAT ('IMSEL: ERROR ', I3, ' READING FROM OLD TABLE')
 9062 FORMAT ('IMSEL: ERROR ', I3, ' CLOSING NEW TABLE')
 9063 FORMAT ('IMSEL: ERROR ', I3, ' OPENING NEW TABLE')
 9064 FORMAT ('IMSEL: ERROR ', I3, ' CLOSING OLD TABLE')
 9065 FORMAT ('IMSEL: ERROR ', I3, ' OPENING OLD TABLE')
      END

      SUBROUTINE SIDERL (REFEP, IAT, IATUTC, GMST, GAST)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  Subroutine to calculate Greenwich Sidereal Time for a given UT
C  Inputs:   REFEP          D    reference date
C            IAT            R    IAT in days from reference date
C            IATUTC         R    difference between IAT and UTC
C  Outputs:  GMST           D    Greenwich mean sidereal time (hours)
C            GAST           D    Greenwich apparent sidereal time (hours
C  Comment:  All real variables as double precision
C  Programmer: L.B.Baath  Onsala Space Observatory   29 october 1982
C-----------------------------------------------------------------------
      DOUBLE PRECISION PI, TWOPI, DTR, HTR, T, GMST, ZETA, REFEP,
     *   THETA,EPS, DELPSI, DELEPS, GAST, EQEQ, Z
      DOUBLE PRECISION JD
      REAL   IATUTC, IAT
C-----------------------------------------------------------------------
C                                     get julian date
      JD = REFEP
      JD = JD + IAT + IATUTC/24.D0/3600.D0 - 0.5D0
C                                     program constants
      PI = 3.14159265358979D0
      TWOPI = 2.D0 * PI
      DTR = PI/180.D0
      HTR = PI/12.D0
C                                     Tropical century from jan 0.5, 190
      T = (JD-2415020.D0) / 36525.D0
      GMST = 23925.836D0 + 8640184.542D0*T + 0.0929D0*T*T
      GMST = GMST / 3600.D0
      GMST = MOD (GMST, 24.0D0) + MOD (JD, 1.0D0) * 24.D0
      GMST = MOD (GMST, 24.0D0)
      CALL VBPREC (JD, ZETA, Z, THETA, EPS)
      CALL NUTATE (JD, DELPSI, DELEPS)
      EQEQ = DELPSI*COS(EPS)
      GAST = GMST + EQEQ/HTR
      IF (GMST.GT.24.D0) GMST = GMST - 24.D0
      IF (GMST.LT.0.D0) GMST = GMST + 24.D0
      IF (GAST.GT.24.D0) GAST = GAST - 24.D0
      IF (GAST.LT.0.D0) GAST = GAST + 24.D0
 999  RETURN
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER   NPARMS
      PARAMETER (NPARMS=12)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
      INCLUDE 'INCS:PAOOF.INC'
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'NFIELD',
     *   'NGAUSS', 'BLC', 'TRC', 'BOXFILE', 'OBOXFILE', 'APARM',
     *   'BADDISK'/
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOAINT,
     *   OOAINT, OOAINT, OOAINT, OOACAR, OOACAR, OOARE, OOAINT/
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 1,1,
     *   1,1, 7,1, 7,1, 48,1, 48,1, 10,1, 10,1/
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(10)
      LOGICAL   LDUM(10)
      REAL      RDUM(10)
      DOUBLE PRECISION DDUM(5)
      EQUIVALENCE (DDUM, RDUM, IDUM, LDUM)
      COMMON /SABOXG/ DDUM
LOCAL END
      PROGRAM SABOX
C-----------------------------------------------------------------------
C! find boxes to clean existing images
C# Task IMAGING OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 2009, 2012, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCLN.INC'
      CHARACTER PRGM*6, IN(MAXFLD)*32
      INTEGER   NIMAGE, IRET, BUFF1(256), FNUM(MAXFLD), NBOX(MAXFLD),
     *   MAXDIM, I, WIN(4,MXNBFL)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'SABOX '/
C-----------------------------------------------------------------------
C                                       Startup
      I = MAXFLD
      CALL SABXIN (PRGM, I, IN, NIMAGE, FNUM, MAXDIM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       find boxes
      CALL SABOXD (IN, NIMAGE, FNUM, MAXDIM, NBOX, WIN, IRET)
      IF (IRET.NE.0) GO TO 990
      IRET = 0
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE SABXIN (PRGN, NMMAX, IN, NIMAGE, FNUM, MAXDIM, IRET)
C-----------------------------------------------------------------------
C   SABXIN gets input parameters for SABOX.
C   Inputs:
C      PRGN     C*6      Program name
C      NMMAX    I        Max dimension of IN
C   Output:
C      IN       C(*)*?   Input object
C      NIMAGE   I        Number of images in IN
C      FNUM     I(*)     Facet numbers of images in IN
C      MAXDIM   I        Maximum X*Y dimension of window
C      IRET     I        Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   NMMAX, NIMAGE, FNUM(*), MAXDIM, IRET
      CHARACTER PRGN*6, IN(*)*(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NKEY1
C                                       NKEY1=no. adverbs for inname
      PARAMETER (NKEY1=5)
      INTEGER   DIM(7), TYPE, BLC(7), TRC(7), NAXIS(7), NFIELD, LFIELD,
     *   MSGSAV, EDGSKP, J0, KFIELD, NP, NGAUSS, NMAPS
      REAL      APARM(10), ACTN
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, CLASS*6, CDUMMY*1,
     *   CFIELD*11, CNAME*8, KEYW*8, TEST*32, ICLASS*6
      LOGICAL   OLDNAM
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs for IN
      DATA INK1 /'INNAME', 'INDISK', 'INSEQ', 'BLC', 'TRC'/
C                                       Rename
      DATA OUTK1 /'NAME', 'DISK', 'SEQ', 'BLC', 'TRC'/
C-----------------------------------------------------------------------
      NIMAGE = 0
      MAXDIM = 0
C                                       Startup
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Declare 'ACTNOISE' a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'ACTNOISE'
      CALL OBVHKW (CNAME, KEYW, OOARE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       other inputs
      CALL OGET ('Input', 'BADDISK', TYPE, DIM, IBAD, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'NFIELD', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      NFIELD = IDUM(1)
      CALL OGET ('Input', 'NGAUSS', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      NGAUSS = IDUM(1)
      NMAPS = MAX (1, NFIELD) * MAX (1, NGAUSS)
      NMAPS = MAX (1, MIN (MAXFLD, NMAPS))
      CALL OGET ('Input', 'INCLASS', TYPE, DIM, IDUM, CLASS, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       parms. defaults
      CALL OGET ('Input', 'APARM', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, APARM)
      EDGSKP = ABS (APARM(2))
      IF (EDGSKP.EQ.0) THEN
         EDGSKP = 5
         APARM(2) = EDGSKP
         END IF
      IF (APARM(1).LE.0.0) APARM(1) = 3.0
      CALL RCOPY (DIM(1), APARM, RDUM)
      CALL OPUT ('Input', 'APARM', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       allowed class types
      IF (CLASS.EQ.' ') CLASS = 'ICL001'
      OLDNAM = (CLASS(4:4).LT.'0') .OR. (CLASS(4:4).GT.'9') .OR.
     *   (CLASS(5:5).LT.'0') .OR. (CLASS(5:5).GT.'9') .OR.
     *   (CLASS(6:6).LT.'0') .OR. (CLASS(6:6).GT.'9')
      J0 = 1
      IF (.NOT.OLDNAM) READ (CLASS(4:6),1001) J0
      ICLASS = CLASS
      DO 20 KFIELD = 1,NMAPS
         LFIELD = KFIELD - 1 + J0
         WRITE (CFIELD,1000) LFIELD
         TEST = 'Input image object ' // CFIELD
         CALL CREATE (TEST, 'IMAGE', IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
         CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, TEST, IRET)
         IF (IRET.NE.0) GO TO 999
         DIM(1) = 6
         DIM(2) = 1
         IF (OLDNAM) THEN
            CALL ZEHEX (LFIELD-1, 2, CFIELD(:2))
            IF (LFIELD.GT.1) ICLASS(5:6) = CFIELD(:2)
         ELSE IF (LFIELD.LT.1000) THEN
            ICLASS(4:6) = CFIELD(2:4)
         ELSE
            ICLASS(3:6) = CFIELD(1:4)
            END IF
         CALL OPUT (TEST, 'CLASS', OOACAR, DIM, IDUM, ICLASS, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Open and close to check
         MSGSAV = MSGSUP
         MSGSUP = 32000
         CALL OOPEN (TEST, 'READ', IRET)
         MSGSUP = MSGSAV
C                                       skip missing ones
         IF (IRET.NE.0) THEN
            IRET = 0
C                                       got it - continue
         ELSE
            IF (NIMAGE.EQ.NMMAX) THEN
               MSGTXT = 'TOO MANY FIELDS*POINTINGS !!!!'
               CALL MSGWRT (8)
               IRET = 8
               GO TO 999
               END IF
            NIMAGE = NIMAGE + 1
            IN(NIMAGE) = TEST
            FNUM(NIMAGE) = LFIELD
C                                       accept header noise if available
            IF (APARM(5).LE.0.0) THEN
               MSGSUP = 32000
               CALL IMGET (TEST, 'ACTNOISE', TYPE, DIM, IDUM, CDUMMY,
     *            IRET)
               ACTN = RDUM(1)
               MSGSUP = MSGSAV
               IF ((IRET.NE.0) .OR. (ACTN.LE.0.0)) THEN
                  ACTN = 0.0
                  IRET = 0
                  END IF
C                                       force noise computation
            ELSE
               ACTN = 0.0
               END IF
            DIM(1) = 1
            DIM(2) = 1
            RDUM(1) = ACTN
            CALL OPUT (TEST, 'NOISE', OOARE, DIM, IDUM, CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Input subimage dimension
            CALL ARRWIN (TEST, BLC, TRC, NAXIS, IRET)
            IF (IRET.NE.0) GO TO 999
            NP = (TRC(1)-BLC(1)+1) * (TRC(2)-BLC(2)+1)
            MAXDIM = MAX (MAXDIM, NP)
            CALL COPY (5, BLC(3), TRC(3))
            DIM(1) = 7
            DIM(2) = 1
            CALL OPUT (TEST, 'BLC', OOAINT, DIM, BLC, CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OPUT (TEST, 'TRC', OOAINT, DIM, TRC, CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OCLOSE (TEST, IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
 20      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I4.4)
 1001 FORMAT (I3)
      END
      SUBROUTINE SABOXD (IN, NIMAGE, FNUM, MAXDIM, NBOX, WIN, IRET)
C-----------------------------------------------------------------------
C   Loops over input fields: load memory, find rms, find islands,
C   write boxes.
C   Inputs:
C      IN       C(*)*?   Input image(s)
C      NIMAGE   I        Number images in IN
C      FNUM     I(*)     Facet number of each image
C      MAXDIM   I        Maximum image area in pixels
C   Output:
C      NBOX     I(*)     Number boxes written
C      IRET     I        Error code: 0 okay
C-----------------------------------------------------------------------
      CHARACTER IN(*)*(*)
      INTEGER   NIMAGE, FNUM(*), MAXDIM, NBOX(*), WIN(4,NIMAGE,*), IRET
C
      LONGINT   PIMAGE
      REAL      IMAGE(2), APARM(10), CXI, CXJ, CYI, CYJ, XI, XJ
      CHARACTER IBXFIL*48, OBXFIL*48, LINE*132
      INTEGER   TYPE, DIM(7), ILUN, OLUN, IIND, OIND, J, I, NAXIS(7),
     *   NX, NY, BLC(7), TRC(7), MBOX, MSGSAV, LOV, NOV, FOV(5,2000), K,
     *   IB, JB, NGAUSS, NWORDS
      LOGICAL   CHANGED
      INCLUDE 'INCS:PCLN.INC'
      INTEGER   WINS(4,MXNBOX), IMSIZE(2,MAXFLD)
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA ILUN, OLUN /10,11/
C-----------------------------------------------------------------------
      MBOX = MIN (MXNBOX, MXNBFL/NIMAGE)
      CHANGED = .FALSE.
C                                       allocate memory for work
      NWORDS = (MAXDIM - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', 'SABOXD', NWORDS, IMAGE, PIMAGE, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'DYNAMIC MEMORY INADEQUATE: USE SUBIMAGES'
         GO TO 990
         END IF
C                                       box file names
      CALL OGET ('Input', 'NGAUSS', TYPE, DIM, IDUM, IBXFIL, IRET)
      IF (IRET.NE.0) GO TO 999
      NGAUSS = MAX (1, IDUM(1))
      CALL OGET ('Input', 'APARM', TYPE, DIM, IDUM, IBXFIL, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (10, RDUM, APARM)
      CALL OGET ('Input', 'BOXFILE', TYPE, DIM, IDUM, IBXFIL, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'OBOXFILE', TYPE, DIM, IDUM, OBXFIL, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (OBXFIL.EQ.' ') OBXFIL = IBXFIL
      IF (OBXFIL.EQ.' ') THEN
         IRET = 8
         MSGTXT = 'OBOXFILE MUST BE SPECIFIED'
         GO TO 990
         END IF
C                                       open output text file
      CALL ZTXOPN ('WRIT', OLUN, OIND, OBXFIL, .TRUE., IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'OPEN OF OBOXFILE FAILS'
         GO TO 990
         END IF
C                                       copy input boxfile if diff
      IF ((IBXFIL.NE.' ') .AND. (IBXFIL.NE.OBXFIL)) THEN
         CALL ZTXOPN ('READ', ILUN, IIND, IBXFIL, .FALSE., IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'OPEN OF INPUT BOXFILE FAILS'
            GO TO 990
            END IF
C                                       read loop
 10      CALL ZTXIO ('READ', ILUN, IIND, LINE, IRET)
         IF (IRET.EQ.0) THEN
            CALL CHTRIM (LINE, 132, LINE, J)
C                                       copy non-box lines
            IF ((LINE(:1).LT.'0') .OR. (LINE(:1).GT.'9')) THEN
               CALL ZTXIO ('WRIT', OLUN, OIND, LINE(:J), IRET)
               IF (IRET.NE.0) THEN
                  MSGTXT = 'WRITE ERROR TO OBOXFILE'
                  GO TO 990
                  END IF
               END IF
            GO TO 10
         ELSE IF (IRET.NE.2) THEN
            MSGTXT = 'READ ERROR IN BOXFILE'
            GO TO 990
            END IF
C                                       end of file: close input
         CALL ZTXCLS (ILUN, IIND, IRET)
         END IF
C                                       loop through input images
      DO 100 I = 1,NIMAGE
         CALL OOPEN (IN(I), 'READ', IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) 'OPEN', FNUM(I)
            GO TO 990
            END IF
C                                       Input subimage dimension
         CALL ARRWIN (IN(I), BLC, TRC, NAXIS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) 'WINDOW', FNUM(I)
            GO TO 990
            END IF
         NX = TRC(1) - BLC(1) + 1
         NY = TRC(2) - BLC(2) + 1
         IMSIZE(1,I) = NAXIS(1)
         IMSIZE(2,I) = NAXIS(2)
C                                       next level does real work
         J = 4 * MXNBOX
         CALL FILL (J, 0, WINS)
         CALL SABOXW (IN(I), FNUM(I), NX, NY, MBOX, IMAGE(1+PIMAGE),
     *      NBOX(I), WINS, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OCLOSE (IN(I), IRET)
C                                       copy boxes to output
         DO 20 J = 1,MAX(1,NBOX(I))
C                                       correct for blc
            IF (NBOX(I).GT.0) THEN
               IF (WINS(1,J).NE.-1) THEN
                  WINS(1,J) = WINS(1,J) + BLC(1) - 1
                  WINS(2,J) = WINS(2,J) + BLC(2) - 1
                  END IF
               WINS(3,J) = WINS(3,J) + BLC(1) - 1
               WINS(4,J) = WINS(4,J) + BLC(2) - 1
               END IF
            CALL COPY (4, WINS(1,J), WIN(1,FNUM(I),J))
 20         CONTINUE
         NBOX(I) = MAX (1, NBOX(I))
 100     CONTINUE
C                                       Beware of overlaps
      IF ((NIMAGE.GT.1) .AND. (APARM(8).LE.0.0)) THEN
         LOV = 2000
         MSGSAV = MSGSUP
 110     MSGSUP = 1
         IF (.NOT.CHANGED) MSGSUP = 0
         NOV = LOV
         CALL BOXCHK (NIMAGE, NGAUSS, IN, IMSIZE, NBOX, WIN, NOV, FOV,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
C                                       clean up overlapped windows
         IF (NOV.GT.0) THEN
            DO 140 K = 1,NOV
               IB = FOV(1,K)
               I  = FOV(2,K)
               JB = FOV(3,K)
               J  = FOV(4,K)
               IF ((WIN(1,I,IB).GT.-99) .AND. (WIN(1,J,JB).GT.-99) .AND.
     *            (FOV(5,K).GT.1)) THEN
                  IF (WIN(1,I,IB).LT.0) THEN
                     XI = PI * WIN(2,I,IB) * WIN(2,I,IB)
                     CXI = WIN(3,I,IB)
                     CYI = WIN(4,I,IB)
                  ELSE
                     XI = (WIN(3,I,IB) - WIN(1,I,IB) + 1.) *
     *                  (WIN(4,I,IB) - WIN(2,I,IB) + 1.)
                     CXI = (WIN(1,I,IB) + WIN(3,I,IB)) / 2.0
                     CYI = (WIN(2,I,IB) + WIN(4,I,IB)) / 2.0
                     END IF
                  IF (WIN(1,J,JB).LT.0) THEN
                     XJ = PI * WIN(2,J,JB) * WIN(2,J,JB)
                     CXJ = WIN(3,J,JB)
                     CYJ = WIN(4,J,JB)
                  ELSE
                     XJ = (WIN(3,J,JB) - WIN(1,J,JB) + 1.) *
     *                  (WIN(4,J,JB) - WIN(2,J,JB) + 1.)
                     CXJ = (WIN(1,J,JB) + WIN(3,J,JB)) / 2.0
                     CYJ = (WIN(2,J,JB) + WIN(4,J,JB)) / 2.0
                     END IF
                  IF (XJ.GT.1.1*XI) THEN
                     WIN(1,I,IB) = -999
                  ELSE IF (XI.GT.1.1*XJ) THEN
                     WIN(1,J,JB) = -999
                  ELSE
                     XI = (IMSIZE(1,I)/2.0-CXI)**2 +
     *                  (IMSIZE(2,I)/2.0-CYI)**2
                     XJ = (IMSIZE(1,J)/2.0-CXJ)**2 +
     *                  (IMSIZE(2,J)/2.0-CYJ)**2
                     IF (XJ.LT.0.90*XI) THEN
                        WIN(1,I,IB) = -999
                     ELSE IF (XI.LT.0.9*XJ) THEN
                        WIN(1,J,JB) = -999
                     ELSE IF (I.GT.J) THEN
                        WIN(1,I,IB) = -999
                     ELSE
                        WIN(1,J,JB) = -999
                        END IF
                     END IF
                  END IF
 140           CONTINUE
            DO 160 I = 1,NIMAGE
               JB = 0
               DO 150 IB = 1,NBOX(I)
                  IF (WIN(1,I,IB).GT.-99) THEN
                     JB = JB + 1
                     IF (JB.LT.IB) THEN
                        WIN(1,I,JB) = WIN(1,I,IB)
                        WIN(2,I,JB) = WIN(2,I,IB)
                        WIN(3,I,JB) = WIN(3,I,IB)
                        WIN(4,I,JB) = WIN(4,I,IB)
                        END IF
                     END IF
 150              CONTINUE
               WRITE (MSGTXT,1150) I, NBOX(I), JB
               IF (NBOX(I).NE.JB) THEN
                  CHANGED = .TRUE.
                  CALL MSGWRT (4)
                  END IF
               NBOX(I) = JB
 160           CONTINUE
            IF (NOV.EQ.LOV) GO TO 110
            END IF
C                                       repeat for 1-pt overlaps
         MSGSUP = 1
         NOV = LOV
         CALL BOXCHK (NIMAGE, NGAUSS, IN, IMSIZE, NBOX, WIN, NOV, FOV,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
C                                       report overlaps left
         DO 170 K = 1,NOV
            IB = FOV(1,K)
            I  = FOV(2,K)
            JB = FOV(3,K)
            J  = FOV(4,K)
            IF ((WIN(1,I,IB).GT.-99) .AND. (WIN(1,J,JB).GT.-99) .AND.
     *         (FOV(5,K).GE.1)) THEN
               WRITE (MSGTXT,1160) IB, I, JB, J, FOV(5,K)
               IF ((I.NE.J) .OR. (FOV(5,K).GT.1)) CALL MSGWRT (4)
               END IF
 170        CONTINUE
         END IF
C                                       write out windows
      DO 210 I = 1,NIMAGE
         IF (NBOX(I).LE.0) THEN
            CALL FILL (4, 0, WIN(1,FNUM(I),1))
            NBOX(I) = 1
            END IF
         DO 200 J = 1,NBOX(I)
            WRITE (LINE,1010) FNUM(I), WIN(1,FNUM(I),J),
     *         WIN(2,FNUM(I),J), WIN(3,FNUM(I),J), WIN(4,FNUM(I),J)
            CALL ZTXIO ('WRIT', OLUN, OIND, LINE(:40), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) 'WRITE OBOXFILE', FNUM(I)
               GO TO 990
               END IF
 200        CONTINUE
 210     CONTINUE
C                                       close down
      CALL ZTXCLS (OLUN, OIND, IRET)
      CALL ZMEMRY ('FREE', 'SABOXD', NWORDS, IMAGE, PIMAGE, IRET)
      IRET = 0
      GO TO 999
C                                       error message printed
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR ON ',A,' IMAGE',I5)
 1010 FORMAT (I6.4,2X,4I8)
 1150 FORMAT ('BOXFIX: Field',I5,' number boxes reduced from',I5,' to',
     *   I5)
 1160 FORMAT ('Box',I5,' facet',I5,' overlaps box',I5,' facet',I5,' at',
     *   I2,' points')
      END
      SUBROUTINE SABOXW (IN, FNUM, NX, NY, MBOX, IMAGE, NBOX, WINS,
     *   IRET)
C-----------------------------------------------------------------------
C   SABOXW does the hard work: reads the image, finds the rms, finds
C   the islands, and fits the boxes
C   Inputs:
C      IN      C*(*)    Input image object already open
C      FNUM    I        Facet number
C      NX      I        Number X pixels
C      NY      I        Number Y pixels (rows)
C      MBOX    I        Max number boxes allowed
C   Outputs:
C      IMAGE   R(*,*)   Memory to use for image
C      NBOX    I        Number boxes found
C      WINS    I(4,*)   Boxes
C      IRET    I        Error code
C-----------------------------------------------------------------------
      CHARACTER IN*(*)
      INTEGER   FNUM, NX, NY, MBOX, NBOX, WINS(4,*), IRET
      REAL      IMAGE(NX,NY)
C
      INTEGER   MAXISL
      PARAMETER (MAXISL = 50000)
      INTEGER   IX, IY, DIM(7), TYPE, NPASS, NPK, PKWIN(4,MAXISL),
     *   NISLND, IPK, II, CX, CY, IROUND, JJ
      CHARACTER CDUMMY*1
      REAL      ACTN, SS, SQ, SN, T, RM, RS, RSP, RSM, X, Y, R,
     *   APARM(10)
      LOGICAL   DOMSG
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      NBOX = 0
      II = 4 * MAXISL
      CALL FILL (II, 0, PKWIN)
      DOMSG = .TRUE.
C                                       read the image
      DO 10 IY = 1,NY
         CALL ARREAD (IN, DIM, IMAGE(1,IY), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) 'READ', IY, FNUM
            GO TO 990
            END IF
 10      CONTINUE
      CALL ARRCLO (IN, IRET)
C                                       get rms
      CALL OGET (IN, 'NOISE', TYPE, DIM, IDUM, CDUMMY, IRET)
      ACTN = RDUM(1)
      IF (IRET.NE.0) THEN
         ACTN = 0.0
         IRET = 0
         END IF
C                                       get parameters
      CALL OGET ('Input', 'APARM', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (10, RDUM, APARM)
C                                       blank outside ellipse
      IF (APARM(2).GT.0.0) THEN
         R = (NX - 2.*APARM(2)) * (NY - 2.*APARM(2)) / 2.0
         R = R * R
         DO 20 IY = 1,NY
            Y = (IY - NY/2.0) * NX
            Y = Y * Y
            DO 15 IX = 1,NX
               X = (IX - NX/2.0) * NY
               X = X * X
               IF (X+Y.GT.R) IMAGE(IX,IY) = FBLANK
 15            CONTINUE
 20         CONTINUE
C                                       blank edgskip edge pixels
      ELSE
         JJ = -APARM(2) + 0.1
         DO 30 IY = 1,NY
            IF ((IY.LE.JJ) .OR. (IY.GT.NY-JJ)) THEN
               CALL RFILL (NX, FBLANK, IMAGE(1,IY))
            ELSE
               CALL RFILL (JJ, FBLANK, IMAGE(1,IY))
               CALL RFILL (JJ, FBLANK, IMAGE(NX+1-JJ,IY))
               END IF
 30         CONTINUE
         END IF
C                                       we need to find it
      IF (ACTN.LE.0.0) THEN
         RSP = 1.E10
         RSM = -1.E10
         DO 60 NPASS = 1,10
            SS = 0.0
            SQ = 0.0
            SN = 0.0
            DO 50 IY = 1,NY
               DO 40 IX = 1,NX
                  T = IMAGE(IX,IY)
                  IF (T.NE.FBLANK) THEN
                     IF ((T.LT.RSP) .AND. (T.GT.RSM)) THEN
                        SS = SS + T
                        SQ = SQ + T * T
                        SN = SN + 1.0
                        END IF
                     END IF
 40               CONTINUE
 50            CONTINUE
            IF (SN.LE.0.0) THEN
               RSP = RSP + 3.0 * RS
               RSM = RSP - 3.0 * RS
            ELSE
               RM = SS / SN
               SQ = SQ / SN
               RS = SQ - RM * RM
               RS = SQRT (MAX (0.0, RS))
               RS = MAX (RS, 0.01*RM)
               RSP = RM + 3.0 * RS
               RSM = RM - 4.0 * RS
               END IF
 60         CONTINUE
         ACTN = RS
         END IF
      WRITE (MSGTXT,1060) FNUM, ACTN
      CALL MSGWRT (3)
C                                       find islands a la SAD
      ACTN = ACTN * APARM(1)
      NISLND = MAXISL
      IF (APARM(6).GT.0) NISLND = -NISLND
      CALL ISLAND (NISLND, NX, NY, IMAGE, ACTN, PKWIN, NPK)
C                                       how to turn into boxes??
      II = IROUND (APARM(3))
      JJ = IROUND (APARM(7))
      IF (JJ.LE.0) JJ = 2
      DO 100 IPK = 1,NPK
         IF ((PKWIN(1,IPK).LE.0) .OR. (PKWIN(2,IPK).LE.0) .OR.
     *      (PKWIN(3,IPK).GT.NX) .OR. (PKWIN(3,IPK).LT.PKWIN(1,IPK))
     *      .OR. (PKWIN(4,IPK).LT.PKWIN(2,IPK)) .OR.
     *      (PKWIN(4,IPK).GT.NY)) GO TO 100
         IX = PKWIN(3,IPK) - PKWIN(1,IPK) + 1
         IY = PKWIN(4,IPK) - PKWIN(2,IPK) + 1
         CX = (PKWIN(3,IPK) + PKWIN(1,IPK)) / 2
         CY = (PKWIN(4,IPK) + PKWIN(2,IPK)) / 2
C                                       drop single points unless strong
         IF (((IX.LT.JJ) .OR. (IY.LT.JJ)) .AND.
     *      (IMAGE(CX,CY).LT.3.*ACTN)) GO TO 100
C                                       circle
         IF (NBOX.LT.MBOX) THEN
            NBOX = NBOX + 1
            IF (((APARM(4).EQ.0.0) .AND. (ABS(IX-IY).LE.1) .AND.
     *         (MIN(IX,IY).LE.8)) .OR. (APARM(4).GT.0.0)) THEN
               IX = (MAX (IX,IY) + 1) / 2 + II
               WINS(1,NBOX) = -1
               WINS(2,NBOX) = IX
               WINS(3,NBOX) = CX
               WINS(4,NBOX) = CY
C                                       rectangle
            ELSE
               WINS(1,NBOX) = MAX (1, PKWIN(1,IPK) - II)
               WINS(2,NBOX) = MAX (1, PKWIN(2,IPK) - II)
               WINS(3,NBOX) = MIN (NX, PKWIN(3,IPK) + II)
               WINS(4,NBOX) = MIN (NY, PKWIN(4,IPK) + II)
               END IF
         ELSE
            MSGTXT = 'TOO MANY WINDOWS FOR ALLOWED BOX LIST'
            IF (DOMSG) CALL MSGWRT (7)
            DOMSG = .FALSE.
            END IF
 100     CONTINUE
      WRITE (MSGTXT,1100) FNUM, NBOX, NPK
      CALL MSGWRT (4)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SABOXW: ERROR DOING ',A,' AT ROW',I7,' FACET',I7)
 1060 FORMAT ('Facet',I5,' using RMS',1PE12.4)
 1100 FORMAT ('Facet',I5,' found ',I5,' boxes in',I5,' islands')
      END

      SUBROUTINE FSERCH (FIND, ITYP, INUM, IERR)
C-----------------------------------------------------------------------
C! determines type and number of entries in the common file table (FTAB)
C# IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Finds entry in FTAB and returns file type and number of type
C   Inputs:
C      FIND   I   Index in FTAB where file has been opened
C   Outputs:
C      ITYP  I    Type of file: 1 device, 2 FCB single buffer,
C                 3 FCB double buffer
C      INUM  I    File number within ITYP
C      IERR  I    Error: 0 = OK
C                    1 = FIND doesn't point at legit location
C                    2 = FIND out of range
C-----------------------------------------------------------------------
      INTEGER   FIND, ITYP, INUM, IERR
C
      INTEGER   NMAX, NOFF, NINC, I, IOP
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      INUM = 0
      ITYP = 0
      IERR = 2
      IF (FIND.LE.0) GO TO 999
C                                        non-FTAB files
      NOFF = 1
      NINC = NBTB1/2
      NMAX = NTAB1
      IOP = 1
C                                       full FTAB part table?
      IF (FIND.GE.NOFF+NMAX*NINC) THEN
         NOFF = NOFF + NINC*NMAX
         NINC = NBTB2/2
         NMAX = NTAB2
         IOP = 2
C                                        map type FTAB
         IF (FIND.GE.NOFF+NMAX*NINC) THEN
            NOFF = NOFF + NINC*NMAX
            NINC = NBTB3/2
            NMAX = NTAB3
            IOP = 3
C                                       error
            IF (FIND.GE.NOFF+NMAX*NINC) GO TO 999
            END IF
         END IF
C                                       lands on correct spot?
      I = (FIND - NOFF) / NINC + 1
      IERR = 1
      IF ((I-1)*NINC+NOFF.EQ.FIND) THEN
         IERR = 0
         ITYP = IOP
         INUM = I
         END IF
C
 999  RETURN
      END

      SUBROUTINE DTPARM (LFILE, JLUN, IPRT, IRET)
C----------------------------------------------------------------------
C! Read simulation parameters from an external KEYIN text file
C# Utility Parsing
C----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2007, 2012, 2016, 2018
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C----------------------------------------------------------------------
C   Read data simulation parameters from an external text file
C   Input:
C      LFILE     C*48      External text file name.
C      JLUN      I         LUN for text file I/O.
C      IPRT      I         Print level.
C   Output:
C      IRET      I         Return code (0=> ok; else error)
C----------------------------------------------------------------------
      CHARACTER LFILE*48
      INTEGER JLUN, IPRT, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXIF2
      PARAMETER (MAXIF2 = 2 * MAXIF)
      INCLUDE 'INCS:DTPM.INC'
      INTEGER   NPARS, NANTAB, NFQTAB, NSUTAB, NCATAB, NCETAB,
     *   NCEKEY, NSMTAB, NSHTAB, NFGTAB, NBPTAB, NMAX
      PARAMETER (NPARS = 14, NANTAB = 20, NFQTAB = 2 + 4*MAXIF)
      PARAMETER (NSUTAB = 6 + 2*MAXIF, NCATAB = 10)
      PARAMETER (NCEKEY = 8, NCETAB = 3 + 2*MAXIF*MAXERP*NCEKEY)
      PARAMETER (NSMTAB = 21, NSHTAB = 11, NFGTAB = 16)
      PARAMETER (NBPTAB = 18 + 4*MAXIF)
      PARAMETER (NMAX = NCETAB)
      LOGICAL   WFALSE, WTRUE, WEOF, WERROR, WEND, WSERR
      CHARACTER LPARS(NPARS)*8, LVALS(NMAX)*8, LANTAB(NANTAB)*8,
     *   LFQTAB(NFQTAB)*8, LSUTAB(NSUTAB)*8, LCATAB(NCATAB)*8,
     *   LCETAB(NCETAB)*8, LCEKEY(NCEKEY)*4, LCESTK(2),
     *   LSMTAB(NSMTAB)*8, LSHTAB(NSHTAB)*8, LFGTAB(NFGTAB)*8,
     *   LBPTAB(NBPTAB)*8, LMARK*8, LKEY*8, LWORK*4, LPRE*1
      CHARACTER ANTNAM*8, VNAME(87)*8
      DOUBLE PRECISION VCPOS(3,87), ALLPOS(261)
      INTEGER   YARRAY(9,4), CSARRY(27)
      EQUIVALENCE (VCPOS(1,1), ALLPOS(1))
      DOUBLE PRECISION DVALS(NMAX), DJD, DTLONG, DTLAT, DTELEV
      INTEGER   IFINDF, IERR, KMODE, J, ISUBA, N, K, I, NPP, JJ, KK, JA,
     *   IDAY, IMTH, IYEAR, M, NFILL, NCH, NCHA, IT(6), IOFF, OFF, II
      INTEGER IKEY, ITRIM
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LMARK /'/       '/
      DATA LPARS /'AN_TABLE', 'SU_TABLE', 'FQ_TABLE', 'CL_TABLE',
     *   'SN_TABLE', 'VER     ', 'CAT_HDR ', 'CAL_ERR ', 'CORREL  ',
     *   'SU_MODEL', 'SCHEDULE', 'FLAG    ', 'BP_TABLE', 'LINPOL  '/
      DATA LANTAB /'STATION ', 'LONG    ', 'LAT     ', 'MNT     ',
     *   'NO      ', 'ELEV    ', 6*'ORBPARM ', 'KEY     ', 'ARRNAM  ',
     *   'CAL_ERR ', 'POLTYPE ', 'END     ', 3*'CARTPOS '/
      DATA LFQTAB /'FQID    ', MAXIF*'FREQ    ', MAXIF*'TOTBW   ',
     *   MAXIF*'CHANBW  ', MAXIF*'SIDE    ', 'END     '/
      DATA LSUTAB /'SU_ID   ', 'NAME    ', 'RAEPO   ', 'DECEPO  ',
     *   'EPOCH   ', MAXIF*'REST_FQ ', MAXIF*'LSR_VEL ', 'END     ' /
      DATA LCATAB /'REF_FREQ', 'NO_IF   ', 'NO_CHAN ',
     *   4 * 'STOKES  ', 'REF_DATE', 'COMPRESS', 'REST_FQ '/
      DATA LCEKEY /'BP', 'RATE', 'DELA', 'PHAS', 'FEED', 'GAIN',
     *   'TSYS', 'GERR'/
      DATA LCESTK /'R', 'L'/
      DATA LSMTAB /'SOURCE  ', 12*'TYPE    ', 5*'SPEC    ',
     *   2*'VEL     ', 'END     '/
      DATA LSHTAB /'DAY     ', 'MONTH   ', 'YEAR    ', 'START   ',
     *   'STOP    ', 'SOURCE  ', 'SUBA    ', 'FQID    ',
     *   'TINT    ', 'SELECT  ', 'END     '/
      DATA LFGTAB /'DAY     ', 'MONTH   ', 'YEAR    ', 'START   ',
     *   'STOP    ', 'ANT_1   ', 'ANT_2   ', 'BIF     ', 'EIF     ',
     *   'BCHAN   ', 'ECHAN   ', 'SOURCE  ', 'FQID    ', 'SUBA    ',
     *   'PFLAG   ', 'END     '/
      DATA LBPTAB /'DAY     ', 'MONTH   ', 'YEAR    ', 'BPTYPE  ',
     *   'XC      ', 'AC      ', 'NANT    ', 'STATION ', 'FQID    ',
     *   'SUBA    ', 'START   ', 'STOP    ', 'INTERV  ', 'TINT    ',
     *   'CAL_ERR ', MAXIF*'FLAGPOL ', MAXIF*'FLAGIF  ',
     *   MAXIF2*'FLAGCHAN', 'KEY     ', 'NUMSHF  ', 'END     '/
      DATA WFALSE /.FALSE./, WTRUE /.TRUE./
C                                             hard code VLBA,VLA names
C                                             positions [VLBA memo 644]
      DATA VNAME / 'VLBA_BR ', 'VLBA_FD ', 'VLBA_HN ', 'VLBA_KP ',
     *   'VLBA_LA ', 'VLBA_MK ', 'VLBA_NL ', 'VLBA_OV ', 'VLBA_PT ',
     *   'VLBA_SC ',
     *   'VLBA_GB ', 'VLBA_AR ', 'VLBA_EB ', 'VLBA_Y  ', 'VLBA_Y1 ',
     *     'VLA_1N  ','VLA_2N  ','VLA_3N  ','VLA_4N  ','VLA_5N ',
     *     'VLA_6N  ','VLA_7N  ','VLA_8N  ','VLA_9N  ','VLA_10N',
     *     'VLA_12N ','VLA_14N ','VLA_16N ','VLA_18N ','VLA_20N',
     *     'VLA_24N ','VLA_28N ','VLA_32N ','VLA_36N ','VLA_40N',
     *     'VLA_48N ','VLA_56N ','VLA_64N ','VLA_72N ',
     *     'VLA_1E  ','VLA_2E  ','VLA_3E  ','VLA_4E  ','VLA_5E ',
     *     'VLA_6E  ','VLA_7E  ','VLA_8E  ','VLA_9E  ','VLA_10E',
     *     'VLA_12E ','VLA_14E ','VLA_16E ','VLA_18E ','VLA_20E',
     *     'VLA_24E ','VLA_28E ','VLA_32E ','VLA_36E ','VLA_40E',
     *     'VLA_48E ','VLA_56E ','VLA_64E ','VLA_72E ',
     *     'VLA_1W  ','VLA_2W  ','VLA_3W  ','VLA_4W  ','VLA_5W ',
     *     'VLA_6W  ','VLA_7W  ','VLA_8W  ','VLA_9W  ','VLA_10W',
     *     'VLA_12W ','VLA_14W ','VLA_16W ','VLA_18W ','VLA_20W',
     *     'VLA_24W ','VLA_28W ','VLA_32W ','VLA_36W ','VLA_40W',
     *     'VLA_48W ','VLA_56W ','VLA_64W ','VLA_72W ' /
C     ALL THESE POSITIONS ARE SPECIFIED IN A RIGHT-HANDED-COORDINATE
C     SYSTEM.
C                                       VLBA positions
C                                       GSFC 26-Apr-2011
      DATA (ALLPOS(I), I=1,30) /
     *    -2112065.1313 , -3705356.5045 ,  4726813.7063 ,
     *    -1324009.2612 , -5332181.9533 ,  3231962.4105 ,
     *     1446374.9448 , -4447939.6659 ,  4322306.1584 ,
     *    -1995678.7713 , -5037317.6975 ,  3357328.0501 ,
     *    -1449752.5106 , -4975298.5744 ,  3709123.8629 ,
     *    -5464075.1116 , -2495248.4197 ,  2148297.1963 ,
     *     -130872.4205 , -4762317.0969 ,  4226851.0067 ,
     *    -2409150.3086 , -4478573.1493 ,  3838617.3503 ,
     *    -1640953.8646 , -5014816.0199 ,  3575411.8106 ,
     *     2607848.6046 , -5488069.5793 ,  1932739.6674 /
C                                       HSA etc Y1 = E8
      DATA (ALLPOS(I), I=31,45) /
     *      882589.4924 , -4924872.3457 ,  3943729.4016 ,
     *     2390486.9000 , -5564731.4400 ,  1994720.4500 ,
     *     4033947.3416 ,   486990.7044 ,  4900430.9260 ,
     *    -1601185.3299 , -5041977.1588 ,  3554875.6285 ,
     *    -1600799.7785 , -5042219.6974 ,  3554706.6858 /
C                                       VLA inner north arm
      DATA (ALLPOS(I), I=46,81) /
     *    -1601185.5812,  -5041977.8184,   3554876.1628,
     *    -1601180.8273,  -5041947.1012,   3554921.3595,
     *    -1601177.3375,  -5041924.7150,   3554954.3143,
     *    -1601173.9462,  -5041902.3088,   3554987.2614,
     *    -1601168.7298,  -5041868.7140,   3555036.6760,
     *    -1601162.5571,  -5041828.6487,   3555095.6305,
     *    -1601155.5900,  -5041783.4940,   3555162.1179,
     *    -1601147.8964,  -5041733.4948,   3555235.6912,
     *    -1601139.4359,  -5041678.7067,   3555316.2864,
     *    -1601130.2876,  -5041619.4312,   3555403.4716,
     *    -1601110.0050,  -5041487.7382,   3555597.1744,
     *    -1601087.1199,  -5041339.5191,   3555815.6049/
C    *     -1601162.375 ,  -5042002.500 ,   3554915.500 ,
C    *     -1601148.500 ,  -5042007.000 ,   3554960.750 ,
C    *     -1601138.375 ,  -5042010.500 ,   3554993.750 ,
C    *     -1601128.250 ,  -5042014.000 ,   3555026.750 ,
C    *     -1601113.125 ,  -5042019.000 ,   3555076.000 ,
C    *     -1601095.000 ,  -5042025.500 ,   3555135.000 ,
C    *     -1601074.625 ,  -5042032.500 ,   3555201.500 ,
C    *     -1601052.125 ,  -5042040.000 ,   3555275.250 ,
C    *     -1601027.250 ,  -5042048.500 ,   3555355.750 ,
C    *     -1601000.625 ,  -5042057.500 ,   3555443.000 ,
C    *     -1600941.250 ,  -5042078.000 ,   3555636.750 ,
C    *     -1600874.375 ,  -5042101.000 ,   3555855.250 /
C                                       VLA outer north arm
      DATA (ALLPOS(I), I=82,117) /
     *    -1601061.9090,  -5041175.5469,   3556057.7648,
     *    -1601034.3510,  -5040996.2032,   3556322.6715,
     *    -1601004.6596,  -5040802.4683,   3556609.8682,
     *    -1600930.0335,  -5040316.0602,   3557330.1202,
     *    -1600863.6317,  -5039884.9779,   3557965.0546,
     *    -1600780.9844,  -5039347.1157,   3558761.2772,
     *    -1600690.5491,  -5038758.3945,   3559631.7967,
     *    -1600592.6887,  -5038121.0119,   3560574.5855,
     *    -1600374.8345,  -5036703.8597,   3562667.6277,
     *    -1600128.3280,  -5035103.8101,   3565024.4053,
     *    -1599855.5942,  -5033332.0436,   3567636.3647,
     *    -1599557.8510,  -5031396.0417,   3570494.4958/
C    *     -1600800.250 ,  -5042126.000 ,   3556097.750 ,
C    *     -1600719.250 ,  -5042153.500 ,   3556362.750 ,
C    *     -1600631.750 ,  -5042183.500 ,   3556650.000 ,
C    *     -1600412.000 ,  -5042258.000 ,   3557370.500 ,
C    *     -1600217.375 ,  -5042324.500 ,   3558005.750 ,
C    *     -1599974.500 ,  -5042407.000 ,   3558802.250 ,
C    *     -1599708.250 ,  -5042497.000 ,   3559673.250 ,
C    *     -1599420.625 ,  -5042595.500 ,   3560616.500 ,
C    *     -1598780.750 ,  -5042813.500 ,   3562710.500 ,
C    *     -1598058.500 ,  -5043060.000 ,   3565068.250 ,
C    *     -1597258.750 ,  -5043333.000 ,   3567681.250 ,
C    *     -1596384.500 ,  -5043630.500 ,   3570540.750 /
C                                       VLA inner east arm
      DATA (ALLPOS(I), I=118,153) /
     *    -1601192.4234,  -5042022.5130,   3554810.1800,
     *    -1601150.0244,  -5042000.2842,   3554860.4667,
     *    -1601114.3092,  -5042022.8016,   3554844.6845,
     *    -1601068.7433,  -5042051.5795,   3554824.5717,
     *    -1601014.4053,  -5042085.8973,   3554800.5249,
     *    -1600951.5325,  -5042125.5656,   3554772.7441,
     *    -1600880.5328,  -5042170.0473,   3554741.1933,
     *    -1600801.8818,  -5042219.0267,   3554706.1834,
     *    -1600715.9086,  -5042272.8495,   3554667.9202,
     *    -1600622.8853,  -5042331.4260,   3554626.7754,
     *    -1600416.4667,  -5042462.1118,   3554535.7763,
     *    -1600183.9146,  -5042609.6470,   3554433.3630/
C    *     -1601182.500 ,  -5041995.500 ,   3554849.500 ,
C    *     -1601204.375 ,  -5042038.000 ,   3554899.750 ,
C    *     -1601246.500 ,  -5042073.500 ,   3554884.000 ,
C    *     -1601300.375 ,  -5042119.000 ,   3554863.750 ,
C    *     -1601364.625 ,  -5042173.500 ,   3554839.750 ,
C    *     -1601438.875 ,  -5042236.500 ,   3554812.000 ,
C    *     -1601522.500 ,  -5042307.500 ,   3554780.500 ,
C    *     -1601615.125 ,  -5042386.000 ,   3554745.500 ,
C    *     -1601716.375 ,  -5042472.000 ,   3554707.250 ,
C    *     -1601826.250 ,  -5042565.000 ,   3554666.000 ,
C    *     -1602070.000 ,  -5042771.500 ,   3554575.000 ,
C    *     -1602345.500 ,  -5043004.500 ,   3554472.500 /
C                                       VLA outer east arm
      DATA (ALLPOS(I), I=154,189) /
     *    -1599926.0619,  -5042772.6307,   3554319.5244,
     *    -1599644.8216,  -5042953.3317,   3554196.7704,
     *    -1599340.7593,  -5043150.6305,   3554064.9546,
     *    -1598663.0503,  -5043581.0597,   3553766.7640,
     *    -1597899.8656,  -5044068.3468,   3553432.1801,
     *    -1597053.0803,  -5044604.3606,   3553058.7225,
     *    -1596127.6963,  -5045193.4207,   3552652.1544,
     *    -1595124.8912,  -5045829.1386,   3552210.4204,
     *    -1592894.0481,  -5047228.8143,   3551220.9383,
     *    -1590380.5737,  -5048809.9468,   3550108.1957,
     *    -1587600.1820,  -5050575.5756,   3548885.1338,
     *    -1584460.8785,  -5052385.3277,   3547599.7478/
C    *     -1602650.250 ,  -5043262.500 ,   3554358.750 ,
C    *     -1602984.375 ,  -5043543.500 ,   3554235.750 ,
C    *     -1603346.750 ,  -5043848.000 ,   3554104.000 ,
C    *     -1604149.000 ,  -5044526.000 ,   3553805.500 ,
C    *     -1605053.875 ,  -5045289.500 ,   3553471.000 ,
C    *     -1606055.250 ,  -5046136.500 ,   3553097.250 ,
C    *     -1607151.375 ,  -5047062.500 ,   3552690.500 ,
C    *     -1608337.750 ,  -5048065.500 ,   3552248.500 ,
C    *     -1610968.500 ,  -5050297.500 ,   3551258.750 ,
C    *     -1600360.750 ,  -5033712.000 ,   3559007.250 ,
C    *     -1617226.125 ,  -5055593.500 ,   3548921.750 ,
C    *     -1620836.000 ,  -5058734.500 ,   3547636.000 /
C                                       VLA inner west arm
      DATA (ALLPOS(I), I=190,225) /
     *    -1601188.9836,  -5042000.1464,   3554843.1582,
     *    -1601225.2315,  -5041980.0245,   3554855.4252,
     *    -1601265.1006,  -5041982.2205,   3554834.5976,
     *    -1601315.8491,  -5041984.9771,   3554808.0410,
     *    -1601376.9668,  -5041988.3305,   3554776.1345,
     *    -1601447.1640,  -5041992.1443,   3554739.4378,
     *    -1601526.3193,  -5041996.5036,   3554698.0586,
     *    -1601614.0472,  -5042001.3101,   3554652.2461,
     *    -1601709.9765,  -5042006.5803,   3554602.0873,
     *    -1601814.0100,  -5042012.5537,   3554547.9577,
     *    -1602044.8585,  -5042025.4792,   3554427.5721,
     *    -1602304.8793,  -5042039.4921,   3554291.4700/
C    *     -1601172.375 ,  -5041999.000 ,   3554882.500 ,
C    *     -1601131.250 ,  -5041962.500 ,   3554894.750 ,
C    *     -1601099.875 ,  -5041922.500 ,   3554874.000 ,
C    *     -1601060.000 ,  -5041872.000 ,   3554847.250 ,
C    *     -1601012.000 ,  -5041811.000 ,   3554815.500 ,
C    *     -1600956.875 ,  -5041740.500 ,   3554778.750 ,
C    *     -1600894.625 ,  -5041661.500 ,   3554737.250 ,
C    *     -1600825.750 ,  -5041573.500 ,   3554691.500 ,
C    *     -1600750.375 ,  -5041477.500 ,   3554641.250  ,
C    *     -1600750.375 ,  -5041477.500 ,   3554641.250 ,
C    *     -1600668.875 ,  -5041373.500 ,   3554587.250 ,
C    *     -1600487.625 ,  -5041142.500 ,   3554466.750 /
C                                       VLA outer west arm
      DATA (ALLPOS(I), I=226,261) /
     *    -1602592.8098,  -5042054.6569,   3554140.4391,
     *    -1602908.1440,  -5042071.9526,   3553975.6447,
     *    -1603249.6404,  -5042091.0551,   3553797.5387,
     *    -1604008.6973,  -5042135.4759,   3553403.4420,
     *    -1604865.6058,  -5042189.6940,   3552962.1040,
     *    -1605808.6140,  -5042229.7332,   3552458.9416,
     *    -1606841.9203,  -5042279.3368,   3551912.7595,
     *    -1607962.4132,  -5042337.8463,   3551324.6843,
     *    -1610451.8862,  -5042470.7602,   3550020.7970,
     *    -1613255.3656,  -5042612.7083,   3548545.6456,
     *    -1616361.5422,  -5042770.1300,   3546911.1800,
     *    -1619757.2674,  -5042937.2680,   3545120.1265/
C    *     -1600283.250 ,  -5040882.500 ,   3554330.500 ,
C    *     -1600056.750 ,  -5040594.500 ,   3554179.500 ,
C    *     -1599809.125 ,  -5040279.000 ,   3554014.500 ,
C    *     -1599541.000 ,  -5039937.500 ,   3553836.500 ,
C    *     -1598946.375 ,  -5039178.000 ,   3553442.250 ,
C    *     -1598277.500 ,  -5038320.500 ,   3553000.500 ,
C    *     -1597530.000 ,  -5037377.000 ,   3552497.250 ,
C    *     -1596714.375 ,  -5036343.500 ,   3551950.750 ,
C    *     -1595832.500 ,  -5035222.500 ,   3551362.500 ,
C    *     -1593875.000 ,  -5032732.000 ,   3550058.000 ,
C    *     -1591666.125 ,  -5029927.000 ,   3548582.250 ,
C    *     -1589218.750 ,  -5026819.500 ,   3546947.000 /
C     specify antennas corresponding to VLA arm position ordering
      DATA YARRAY / 8, 13, 16, 18, 20, 21, 22, 23, 24,
     *              4,  8, 11, 13, 15, 16, 17, 18, 19,
     *              2,  4,  6,  8, 10, 11, 12, 13, 14,
     *              1,  2,  3,  4,  5,  6,  7,  8,  9 /
C  this is just C array, need to move some in to make CS, ask
C  MRUPEN about this....
      DATA CSARRY /12, 14, 16, 18, 20, 21, 22, 23, 24,
     *             36, 38, 40, 42, 44, 45, 46, 47, 48,
     *             60, 62, 64, 66, 68, 69, 70, 71, 72 /
C---------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C                                       Intialize DTPM.INC
      NDTSUB = 0
      NDTMSB = 0
      NDTFQD = 0
      NDTSID = 0
      WDTCAT = WFALSE
      NDTAER = 0
      NDTSMD = 0
      NDTSCH = 0
      NDTFG = 0
      NDTBPD = 0
C                                       Fill CAL_ERR keyword array
      LCETAB(1) = 'STATION'
      LCETAB(2) = 'FQID'
      DO 15 J = 1, NCEKEY
         DO 10 K = 1, 2
            DO 7 M = 1, MAXIF
               DO 5 KK = 1, MAXERP
                  JJ = (J - 1) * 2 * MAXPRD + (K - 1) * MAXPRD +
     *               (M - 1) * MAXERP + KK + 2
                  IF (M.LE.10) WRITE (LWORK,9007) M, LCESTK(K)
                  IF (M.GE.10) WRITE (LWORK,9010) M, LCESTK(K)
                  LCETAB(JJ) = LCEKEY(J)(1:ITRIM(LCEKEY(J))) // LWORK
5                 CONTINUE
7              CONTINUE
10          CONTINUE
15       CONTINUE
      LCETAB(JJ+1) = 'END'
C                                       Open the external text file
      CALL ZTXOPN ('READ', JLUN, IFINDF, LFILE, WFALSE, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR, LFILE
         IRET = 1
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Print level
      KMODE = 0
      IF (IPRT.GT.0) KMODE = 1
C                                       Repeat (read keyin_record)
C                                       until (EOF or ERROR)
C                                       Set defaults
50    DO 60 J = 1, NMAX
         DVALS(J) = DBLANK
         LVALS(J) = '        '
60       CONTINUE
C
      CALL KEYIN (LPARS, DVALS, LVALS, NPARS, LMARK, KMODE, JLUN,
     *   IFINDF, IERR)
      WEOF = (IERR.EQ.1)
      WERROR = (IERR.NE.0).AND.(.NOT.WEOF)
      IF (WERROR) WRITE (MSGTXT,1060) IERR
C                                       If (NOT EOF or ERROR) then
C                                       process keyin_record.
      IF (WEOF.OR.WERROR) GO TO 1900
C                                       Case group_id of:
C======================================================================
C                                       1: AN_TABLE entry
      LKEY = 'AN_TABLE'
      J = IKEY (LKEY, LPARS, NPARS)
      IF (DVALS(J).NE.DBLANK) THEN
C                                       Process AN table data:
C                                       Extract table version no.
         LKEY = 'VER'
         J = IKEY (LKEY, LPARS, NPARS)
         NDTSUB = NDTSUB + 1
         IF (DVALS(J).EQ.DBLANK) THEN
            NDTMSB = NDTMSB + 1
            IDTSUB(NDTSUB) = NDTMSB
         ELSE
            IDTSUB(NDTSUB) = DVALS(J)
            NDTMSB = MAX (NDTMSB, IDTSUB(NDTSUB))
            END IF
         ISUBA = IDTSUB(NDTSUB)
C                                       Reset antenna count and
C                                       keyword values
         NDTANT(ISUBA) = 0
         LDTARR(ISUBA) = ' '
         WDTPOL(ISUBA) = WFALSE
         LDTPOL(ISUBA) = ' '
C                                       Repeat (read keyin_record)
C                                       until (EOF or ERROR or ENDCAT)
C                                       Set KEYIN defaults.
75       DO 80 J = 1, NMAX
            DVALS(J) = DBLANK
            LVALS(J) = '        '
80          CONTINUE
C
         CALL KEYIN (LANTAB, DVALS, LVALS, NANTAB, LMARK, KMODE, JLUN,
     *      IFINDF, IERR)
         WEOF = (IERR.EQ.1)
         WERROR = (IERR.NE.0).AND.(.NOT.WEOF)
         IF (WERROR) WRITE (MSGTXT,1060) IERR
C                                       ENDCAT ?
         LKEY = 'END'
         J = IKEY (LKEY, LANTAB, NANTAB)
         WEND = (DVALS(J).NE.DBLANK)
C                                       If NOT (ENDCAT or ERROR or EOF)
C                                       then process record
         IF (.NOT.(WEND.OR.WERROR.OR.WEOF)) THEN
C                                       Case record_type of:
C                                       i) KEY record
            LKEY = 'KEY'
            J = IKEY (LKEY, LANTAB, NANTAB)
            IF (DVALS(J).NE.DBLANK) THEN
C                                       Include polzn. errors ?
               LKEY = 'CAL_ERR'
               J = IKEY (LKEY, LANTAB, NANTAB)
               WDTPOL(ISUBA) = (DVALS(J).NE.DBLANK)
C                                       Polzn. solution type
               LKEY = 'POLTYPE'
               J = IKEY (LKEY, LANTAB, NANTAB)
               IF (DVALS(J).NE.DBLANK) LDTPOL(ISUBA) = LVALS(J)
C                                       Keyword record
C                                       Extract array name
               LKEY = 'ARRNAM'
               J = IKEY (LKEY, LANTAB, NANTAB)
               LDTARR(ISUBA) = ' '
               IF (DVALS(J).NE.DBLANK) LDTARR(ISUBA) = LVALS(J)
C                                       ii) Antenna record
            ELSE
               LKEY = 'STATION'
               J = IKEY (LKEY, LANTAB, NANTAB)
               IF (DVALS(J).NE.DBLANK) THEN
C                                          Get Antenna name
                  ANTNAM = LVALS(J)
C                                          Load default array configurations
                  IF ((ANTNAM(1:4).EQ.'ALL_') .OR.
     *               (ANTNAM(:5).EQ.'VLA_Y'))THEN
C     entire VLBA is specified using 'ALL_VLBA'
                     IF ((ANTNAM(:8).EQ.'ALL_VLBA') .OR.
     *                  (ANTNAM(:7).EQ.'ALL_HSA')) THEN
                        II = 10
                        IF (ANTNAM(:7).EQ.'ALL_HSA') II = 14
                        DO 86 I = 1,II
                           NDTANT(ISUBA) = NDTANT(ISUBA)+1
                           N = NDTANT(ISUBA)
C     set antenna number
                           IDTANO(N,ISUBA) = N
                           DTCPOS(1,N,ISUBA) = VCPOS(1,I)
                           DTCPOS(2,N,ISUBA) = VCPOS(2,I)
                           DTCPOS(3,N,ISUBA) = VCPOS(3,I)
C     zero orbital elements
                           CALL DFILL (6, 0.0D0, DTORB(1,N,ISUBA))
C     set mount type to AZEL
                           IDTMNT(N,ISUBA) = 0
C     use default station name
                           LDTANT(N,ISUBA) = VNAME(I)
 86                        CONTINUE
                     ELSE IF (ANTNAM(5:8).EQ.'YCS') THEN
                        DO 2010 M = 1,27
C     pick up CS array antennas only
                           JJ = 15 + CSARRY(M)
                           NDTANT(ISUBA) = NDTANT(ISUBA)+1
                           N=NDTANT(ISUBA)
                           IDTANO(N,ISUBA) = N
                           DTCPOS(1,N,ISUBA) = VCPOS(1,JJ)
                           DTCPOS(2,N,ISUBA) = VCPOS(2,JJ)
                           DTCPOS(3,N,ISUBA) = VCPOS(3,JJ)
                           CALL DFILL (6, 0.0D0, DTORB(1,N,ISUBA))
                           IDTMNT(N,ISUBA) = 0
                           LDTANT(N,ISUBA) = VNAME(JJ)
 2010                      CONTINUE
C     VLA arrays are specified using 'ALL_Y*', where '*' = A,B,C,D
                     ELSE IF ((ANTNAM(5:6).EQ.'YA') .OR.
     *                  (ANTNAM(5:6).EQ.'YB') .OR. (ANTNAM(5:6).EQ.'YC')
     *                  .OR. (ANTNAM(5:6).EQ.'YD'))  THEN
                        IF (ANTNAM(5:8).EQ.'YA') OFF = 1
                        IF (ANTNAM(5:8).EQ.'YB') OFF = 2
                        IF (ANTNAM(5:8).EQ.'YC') OFF = 3
                        IF (ANTNAM(5:8).EQ.'YD') OFF = 4
                        DO 2000, M=1,9
C     north arm antenna
                           JJ = 15 + YARRAY(M,OFF)
                           NDTANT(ISUBA) = NDTANT(ISUBA)+1
                           N=NDTANT(ISUBA)
                           IDTANO(N,ISUBA) = N
                           DTCPOS(1,N,ISUBA) = VCPOS(1,JJ)
                           DTCPOS(2,N,ISUBA) = VCPOS(2,JJ)
                           DTCPOS(3,N,ISUBA) = VCPOS(3,JJ)
                           CALL DFILL (6, 0.0D0, DTORB(1,N,ISUBA))
                           IDTMNT(N,ISUBA) = 0
                           LDTANT(N,ISUBA) = VNAME(JJ)
C     east arm antenna
                           JJ = 39 + YARRAY(M,OFF)
                           NDTANT(ISUBA) = NDTANT(ISUBA)+1
                           N=NDTANT(ISUBA)
                           IDTANO(N,ISUBA) = N
                           DTCPOS(1,N,ISUBA) = VCPOS(1,JJ)
                           DTCPOS(2,N,ISUBA) = VCPOS(2,JJ)
                           DTCPOS(3,N,ISUBA) = VCPOS(3,JJ)
                           CALL DFILL (6, 0.0D0, DTORB(1,N,ISUBA))
                           IDTMNT(N,ISUBA) = 0
                           LDTANT(N,ISUBA) = VNAME(JJ)
C     west arm antenna
                           JJ = 63 + YARRAY(M,OFF)
                           NDTANT(ISUBA) = NDTANT(ISUBA)+1
                           N=NDTANT(ISUBA)
                           IDTANO(N,ISUBA) = N
                           DTCPOS(1,N,ISUBA) = VCPOS(1,JJ)
                           DTCPOS(2,N,ISUBA) = VCPOS(2,JJ)
                           DTCPOS(3,N,ISUBA) = VCPOS(3,JJ)
                           CALL DFILL (6, 0.0D0, DTORB(1,N,ISUBA))
                           IDTMNT(N,ISUBA) = 0
                           LDTANT(N,ISUBA) = VNAME(JJ)
 2000                      CONTINUE
                        END IF
                  ELSE
                     NDTANT(ISUBA) = NDTANT(ISUBA) + 1
                     N = NDTANT(ISUBA)
C                                       Station name.
                     LDTANT(N,ISUBA) = ANTNAM
C                                       Default station info
                     IDTANO(N,ISUBA) = N
                     DTCPOS(1,N,ISUBA) = 0.0D0
                     DTCPOS(2,N,ISUBA) = 0.0D0
                     DTCPOS(3,N,ISUBA) = 0.0D0
                     CALL DFILL (6, 0.0D0, DTORB(1,N,ISUBA))
                     IDTMNT(N,ISUBA) = 0
C                                       Try to match individual
C                                       VLBA or VLA antennas
                     DO 87 I = 1,87
                        IF (ANTNAM.EQ.VNAME(I)) THEN
                           DTCPOS(1,N,ISUBA) = VCPOS(1,I)
                           DTCPOS(2,N,ISUBA) = VCPOS(2,I)
                           DTCPOS(3,N,ISUBA) = VCPOS(3,I)
                           END IF
 87                     CONTINUE
C                                       Antenna number
                     LKEY = 'NO'
                     J = IKEY (LKEY, LANTAB, NANTAB)
                     IF (DVALS(J).NE.DBLANK) IDTANO(N,ISUBA) = DVALS(J)
C                                       Mount type
                     LKEY = 'MNT'
                     J = IKEY (LKEY, LANTAB, NANTAB)
                     IF (DVALS(J).NE.DBLANK) THEN
                        IF (LVALS(J).EQ.'AZEL') IDTMNT(N,ISUBA) = 0
                        IF (LVALS(J).EQ.'HADC') IDTMNT(N,ISUBA) = 1
                        IF (LVALS(J).EQ.'ORB') IDTMNT(N,ISUBA) = 2
                        IF (LVALS(J).EQ.'NASR') IDTMNT(N,ISUBA) = 4
                        IF (LVALS(J).EQ.'NASL') IDTMNT(N,ISUBA) = 5
                        END IF
C                                       Longitude and latitude
                     LKEY = 'LONG'
                     J = IKEY (LKEY, LANTAB, NANTAB)
                     DTLONG = 0.0D0
                     IF (DVALS(J).NE.DBLANK) DTLONG = DVALS(J)
C
                     LKEY = 'LAT'
                     J = IKEY (LKEY, LANTAB, NANTAB)
                     DTLAT = 0.0D0
                     IF (DVALS(J).NE.DBLANK) DTLAT = DVALS(J)
C                                       Elevation
                     LKEY = 'ELEV'
                     J = IKEY (LKEY, LANTAB, NANTAB)
                     DTELEV = 0.0D0
                     IF (DVALS(J).NE.DBLANK) DTELEV = DVALS(J)
                     LKEY = 'CARTPOS'
                     J = IKEY (LKEY, LANTAB, NANTAB)
C                                       If one element of CARTPOS is
C                                       specified, assume all are valid
                     IF (DVALS(J).NE.DBLANK) THEN
                        DTCPOS(1,N,ISUBA) = DVALS(J)
                        DTCPOS(2,N,ISUBA) = DVALS(J+1)
                        DTCPOS(3,N,ISUBA) = DVALS(J+2)
C                                       Convert Long, Lat, and Elev into
C                                       XYZ positions
                     ELSE IF ((DTLAT.NE.0.0D0) .OR. (DTLONG.NE.0.0D0)
     *                  .OR. (DTELEV.NE.0.0D0)) THEN
                        CALL GEOPOS (DTLONG, DTLAT, DTELEV,
     *                     DTCPOS(1,N,ISUBA), DTCPOS(2,N,ISUBA),
     *                     DTCPOS(3,N,ISUBA))
                        END IF
C                                       Orbital elements
                     LKEY = 'ORBPARM'
                     J = IKEY (LKEY, LANTAB, NANTAB)
                     DO 88 K = 1, 6
                        I = J + K - 1
                        IF (DVALS(I).NE.DBLANK)
     *                     DTORB(K,N,ISUBA) = DVALS(I)
 88                     CONTINUE
                     END IF
C                                       iii) other: error
               ELSE
                  WERROR = WTRUE
                  WRITE (MSGTXT,1085)
                  END IF
               END IF
C                                       Endcase (AN record_type)
            END IF
C                                       Read next record
         IF (.NOT.(WEOF.OR.WERROR.OR.WEND)) GO TO 75
         GO TO 1890
         END IF
C======================================================================
C                                       2: FQ_TABLE entry
      LKEY = 'FQ_TABLE'
      J = IKEY (LKEY, LPARS, NPARS)
      IF (DVALS(J).NE.DBLANK) THEN
C                                       Process FQ table data
         NDTFID = 0
C                                       Repeat (read keyin_record)
C                                       until (EOF or ERROR or ENDCAT)
110      DO 115 J = 1, NMAX
            DVALS(J) = DBLANK
            LVALS(J) = '        '
115         CONTINUE
C
         CALL KEYIN (LFQTAB, DVALS, LVALS, NFQTAB, LMARK, KMODE,
     *     JLUN, IFINDF, IERR)
         WEOF = (IERR.EQ.1)
         WERROR = (IERR.NE.0).AND.(.NOT.WEOF)
         IF (WERROR) WRITE (MSGTXT,1060) IERR
C                                       ENDCAT ?
         LKEY = 'END'
         J = IKEY (LKEY, LFQTAB, NFQTAB)
         WEND = (DVALS(J).NE.DBLANK)
C                                       If (not(END or ERR or EOF))
C                                       then process record.
         IF (.NOT.(WEND.OR.WERROR.OR.WEOF)) THEN
            NDTFQD = NDTFQD + 1
            NPP = NDTFQD
C                                       Initialize FQ record
            IDTFQD(NPP) = NPP
            CALL DFILL (MAXIF, 0.0D0, DTFREQ(1,NPP))
            CALL RFILL (MAXIF, 0.0, RDTCHW(1,NPP))
            CALL RFILL (MAXIF, 0.0, RDTTBW(1,NPP))
            CALL FILL (MAXIF, 0, IDTSDB(1,NPP))
C                                       Extract freqid.
            LKEY = 'FQID'
            J = IKEY (LKEY, LFQTAB, NFQTAB)
            IF (DVALS(J).NE.DBLANK) IDTFQD(NPP) = DVALS(J)
C                                       Frequency (Hz)
            LKEY = 'FREQ'
            J = IKEY (LKEY, LFQTAB, NFQTAB)
            DO 120 K = 1, MAXIF
               I = J + (K - 1)
               IF (DVALS(I).NE.DBLANK) THEN
                  DTFREQ(K,NPP) = DVALS(I) * 1.0D6
                  NDTFID = MAX (NDTFID, K)
                  END IF
120            CONTINUE
C                                       Total bandwidth
            LKEY = 'TOTBW'
            J = IKEY (LKEY, LFQTAB, NFQTAB)
            DO 125 K = 1, MAXIF
               I = J + (K - 1)
               IF (DVALS(I).NE.DBLANK) RDTTBW(K,NPP) = DVALS(I) * 1.0D6
125            CONTINUE
C                                       Channel bandwidth (Hz)
            LKEY = 'CHANBW'
            J = IKEY (LKEY, LFQTAB, NFQTAB)
            DO 130 K = 1, MAXIF
               I = J + (K - 1)
               IF (DVALS(I).NE.DBLANK) RDTCHW(K,NPP) = DVALS(I) * 1.0D6
130            CONTINUE
C                                       Sideband
            LKEY = 'SIDE'
            J = IKEY (LKEY, LFQTAB, NFQTAB)
            DO 135 K = 1, MAXIF
               I = J + (K - 1)
               IF (DVALS(I).NE.DBLANK) IDTSDB(K,NPP) = DVALS(I)
135            CONTINUE
            END IF
C                                       Read next FQ record
         IF (.NOT.(WEND.OR.WERROR.OR.WEOF)) GO TO 110
         GO TO 1890
         END IF
C======================================================================
C                                       3: SU_TABLE entry
      LKEY = 'SU_TABLE'
      J = IKEY (LKEY, LPARS, NPARS)
      IF (DVALS(J).NE.DBLANK) THEN
C                                       Repeat (read keyin_record)
C                                       until (EOF or ERR or ENDCAT)
210      DO 215 J = 1, NMAX
            DVALS(J) = DBLANK
            LVALS(J) = '        '
215         CONTINUE
C
         CALL KEYIN (LSUTAB, DVALS, LVALS, NSUTAB, LMARK, KMODE,
     *      JLUN, IFINDF, IERR)
         WEOF = (IERR.EQ.1)
         WERROR = (IERR.NE.0).AND.(.NOT.WEOF)
         IF (WERROR) WRITE (MSGTXT,1060) IERR
C                                       ENDCAT ?
         LKEY = 'END'
         J = IKEY (LKEY, LSUTAB, NSUTAB)
         WEND = (DVALS(J).NE.DBLANK)
C                                       If (NOT (END or ERR or EOF))
C                                       then process record
         IF (.NOT.(WEND.OR.WERROR.OR.WEOF)) THEN
C                                       Initialize SU record
            NDTSID = NDTSID + 1
            NPP = NDTSID
            IDTSID(NPP) = NPP
            LDTSOU(NPP) = ' '
            DTSRA(NPP) = 0.0D0
            DTSDEC(NPP) = 0.0D0
            DTEPOC(NPP) = 0.0D0
            NFILL = MAXIF * MAXSID
            CALL DFILL (NFILL, 0.0D0, DTSUFQ)
            CALL DFILL (NFILL, 0.0D0, DTSLSR)
C                                       Source ID
            LKEY = 'SU_ID'
            J = IKEY (LKEY, LSUTAB, NSUTAB)
            IF (DVALS(J).NE.DBLANK) IDTSID(NPP) = DVALS(J)
C                                       Source name
            LKEY = 'NAME'
            J = IKEY (LKEY, LSUTAB, NSUTAB)
            IF (DVALS(J).NE.DBLANK) LDTSOU(NPP) = LVALS(J)
C                                       RA of epoch
            LKEY = 'RAEPO'
            J = IKEY (LKEY, LSUTAB, NSUTAB)
            IF (DVALS(J).NE.DBLANK) DTSRA(NPP) = DVALS(J)*15.0D0
C                                       DEC of epoch
            LKEY = 'DECEPO'
            J = IKEY (LKEY, LSUTAB, NSUTAB)
            IF (DVALS(J).NE.DBLANK) DTSDEC(NPP) = DVALS(J)
C                                       Coordinate epoch
            LKEY = 'EPOCH'
            J = IKEY (LKEY, LSUTAB, NSUTAB)
            IF (DVALS(J).NE.DBLANK) DTEPOC(NPP) = DVALS(J)
C                                       Rest frequency (Hz)
            LKEY = 'REST_FQ'
            J = IKEY (LKEY, LSUTAB, NSUTAB)
            DO 230 K = 1, MAXIF
               I = J + (K - 1)
               IF (DVALS(I).NE.DBLANK) THEN
                  DTSUFQ(K,NPP) = DVALS(I) * 1.0D6
                  END IF
230            CONTINUE
C                                       LSR velocity (m/s)
            LKEY = 'LSR_VEL'
            J = IKEY (LKEY, LSUTAB, NSUTAB)
            DO 240 K = 1, MAXIF
               I = J + (K - 1)
               IF (DVALS(I).NE.DBLANK) THEN
                  DTSLSR(K,NPP) = DVALS(I) * 1.0D3
                  END IF
240            CONTINUE
C                                       Valid record ? Check for
C                                       non-blank source name.
            CALL CHBLNK (16, 1, LDTSOU(NPP), NCH)
            IF (NCH.EQ.0) THEN
               WRITE (MSGTXT,1220)
               WERROR = WTRUE
               END IF
            END IF
C                                       Read next SU table record
         IF (.NOT.(WEND.OR.WERROR.OR.WEOF)) GO TO 210
         GO TO 1890
         END IF
C======================================================================
C                                       4: Catalog header
      LKEY = 'CAT_HDR'
      J = IKEY (LKEY, LPARS, NPARS)
      IF (DVALS(J).NE.DBLANK) THEN
C                                       Read keyin_record
         DO 315 J = 1, NMAX
            DVALS(J) = DBLANK
            LVALS(J) = '        '
315         CONTINUE
C
         CALL KEYIN (LCATAB, DVALS, LVALS, NCATAB, LMARK, KMODE, JLUN,
     *      IFINDF, IERR)
         WEOF = (IERR.EQ.1)
         WERROR = (IERR.NE.0).AND.(.NOT.WEOF)
         IF (WERROR) WRITE (MSGTXT,1060) IERR
C                                       If (NOT (ERROR or EOF))
C                                       then process record.
         IF (.NOT.(WERROR.OR.WEOF)) THEN
C                                       Initialize catalog hdr. record
            DTRFRQ = 0.0D0
            DTLRFQ = 0.0D0
            NDTIF = 0
            NDTCHN = 0
            NDTSTK = 0
            CALL FILL (4, 0, IDTSTK)
            IDTCMP = 0
            LDTDAT = ' '
C                                       Reference frequency (Hz)
            LKEY = 'REF_FREQ'
            J = IKEY (LKEY, LCATAB, NCATAB)
            IF (DVALS(J).NE.DBLANK) DTRFRQ = DVALS(J) * 1.0D6
C                                       Line rest frequency (Hz)
            LKEY = 'REST_FQ'
            J = IKEY (LKEY, LCATAB, NCATAB)
            IF (DVALS(J).NE.DBLANK) DTLRFQ = DVALS(J) * 1.0D6
C                                       No. IF's
            LKEY = 'NO_IF'
            J = IKEY (LKEY, LCATAB, NCATAB)
            IF (DVALS(J).NE.DBLANK) NDTIF = DVALS(J)
C                                       No. channels
            LKEY = 'NO_CHAN'
            J = IKEY (LKEY, LCATAB, NCATAB)
            IF (DVALS(J).NE.DBLANK) NDTCHN = DVALS(J)
C                                       Stokes
            LKEY = 'STOKES'
            J = IKEY (LKEY, LCATAB, NCATAB)
            DO 325 K = 1, 4
               M = J + (K - 1)
               IF (DVALS(M).NE.DBLANK) THEN
                  NDTSTK = NDTSTK + 1
                  IF (LVALS(M).EQ.'RR') IDTSTK(NDTSTK) = -1
                  IF (LVALS(M).EQ.'LL') IDTSTK(NDTSTK) = -2
                  IF (LVALS(M).EQ.'RL') IDTSTK(NDTSTK) = -3
                  IF (LVALS(M).EQ.'LR') IDTSTK(NDTSTK) = -4
                  IF (LVALS(M).EQ.'I') IDTSTK(NDTSTK) = 1
                  IF (LVALS(M).EQ.'Q') IDTSTK(NDTSTK) = 2
                  IF (LVALS(M).EQ.'U') IDTSTK(NDTSTK) = 3
                  IF (LVALS(M).EQ.'V') IDTSTK(NDTSTK) = 4
                  END IF
325            CONTINUE
C                                       Sort Stokes array in order
C                                       of increasing absolute value
            DO 335 I = 1, (NDTSTK - 1)
               DO 330 J = (I + 1), NDTSTK
                  IF (ABS(IDTSTK(I)).GT.ABS(IDTSTK(J))) THEN
                     M = IDTSTK(I)
                     IDTSTK(I) = IDTSTK(J)
                     IDTSTK(J) = M
                     END IF
330               CONTINUE
335            CONTINUE
C                                       Reference date
            LKEY = 'REF_DATE'
            J = IKEY (LKEY, LCATAB, NCATAB)
            IF (DVALS(J).NE.DBLANK) LDTDAT = LVALS(J)
C                                       Compressed data ?
            LKEY = 'COMPRESS'
            J = IKEY (LKEY, LCATAB, NCATAB)
            IF (DVALS(J).NE.DBLANK) IDTCMP = 1
C                                       Valid record ?
            CALL CHBLNK (8, 1, LDTDAT, NCH)
            IF ((NCH.EQ.0).OR.(NDTIF.EQ.0).OR.(NDTCHN.EQ.0)) THEN
               WRITE (MSGTXT,1325)
               WERROR = WTRUE
            ELSE
               WDTCAT = WTRUE
               END IF
            END IF
         GO TO 1890
         END IF
C======================================================================
C                                       5: CAL_ERR entry
      LKEY = 'CAL_ERR'
      J = IKEY (LKEY, LPARS, NPARS)
      IF (DVALS(J).NE.DBLANK) THEN
C                                       Check if linearized polzn.
C                                       model is requested
         LKEY = 'LINPOL'
         J = IKEY (LKEY, LPARS, NPARS)
         WDTLIN = (DVALS(J).NE.DBLANK)
C                                       Repeat (read keyin_record)
C                                       until (EOF or ERR or ENDCAT)
410      DO 415 J = 1, NMAX
            DVALS(J) = DBLANK
            LVALS(J) = '        '
415         CONTINUE
C
         CALL KEYIN (LCETAB, DVALS, LVALS, NCETAB, LMARK, KMODE,
     *      JLUN, IFINDF, IERR)
         WEOF = (IERR.EQ.1)
         WERROR = (IERR.NE.0).AND.(.NOT.WEOF)
         IF (WERROR) WRITE (MSGTXT,1060) IERR
C                                       END CAT ?
         LKEY = 'END'
         J = IKEY (LKEY, LCETAB, NCETAB)
         WEND = (DVALS(J).NE.DBLANK)
C                                       If (not (ERR or EOF or END))
C                                       then process record
         IF (.NOT.(WEOF.OR.WERROR.OR.WEND)) THEN
C                                       Initialize record
            NDTAER = NDTAER + 1
            NPP = NDTAER
            LDTAER(NPP) = ' '
            IDTEFQ(NPP) = 0
            NFILL = 2 * MAXPRD
            CALL RFILL (NFILL, 0.0, RDTBP(1,1,1,NPP))
            CALL RFILL (NFILL, 0.0, RDTRAT(1,1,1,NPP))
            CALL RFILL (NFILL, 0.0, RDTDEL(1,1,1,NPP))
            CALL RFILL (NFILL, 0.0, RDTPHS(1,1,1,NPP))
            CALL RFILL (NFILL, 0.0, RDTFED(1,1,1,NPP))
            CALL RFILL (NFILL, 0.0, RDTGAN(1,1,1,NPP))
            CALL RFILL (NFILL, 0.0, RDTTSY(1,1,1,NPP))
            CALL RFILL (NFILL, 0.0, RDTGER(1,1,1,NPP))
C                                       Extract ant. name, FQ_ID
            LKEY = 'STATION'
            J = IKEY (LKEY, LCETAB, NCETAB)
            IF (DVALS(J).NE.DBLANK) LDTAER(NPP) = LVALS(J)
C
            LKEY = 'FQID'
            J = IKEY (LKEY, LCETAB, NCETAB)
            IF (DVALS(J).NE.DBLANK) IDTEFQ(NPP) = DVALS(J)
C                                       Extract the other fields
C                                       in the cal. error record.
            DO 430 J = 1, NCEKEY
               LKEY = LCEKEY(J)(1:ITRIM(LCEKEY(J))) // '_1R'
               JA = IKEY (LKEY, LCETAB, NCETAB)
C                                       Loop over Stokes (R,L)
               DO 425 K = 1, 2
C                                       Loop over IF
                  DO 422 M = 1, MAXIF
C                                       Loop over parameter index
                     DO 420 KK = 1, MAXERP
                        JJ = (JA - 1) + (K - 1) * MAXPRD +
     *                     (M - 1) * MAXERP + KK
                        IF (DVALS(JJ).NE.DBLANK) THEN
                           IF (LCEKEY(J).EQ.'BP')
     *                        RDTBP(KK,M,K,NPP) = DVALS(JJ)
                           IF (LCEKEY(J).EQ.'RATE')
     *                        RDTRAT(KK,M,K,NPP) = DVALS(JJ)
                           IF (LCEKEY(J).EQ.'DELA')
     *                        RDTDEL(KK,M,K,NPP) = DVALS(JJ)
                           IF (LCEKEY(J).EQ.'PHAS')
     *                        RDTPHS(KK,M,K,NPP) = DVALS(JJ)
                           IF (LCEKEY(J).EQ.'FEED')
     *                        RDTFED(KK,M,K,NPP) = DVALS(JJ)
                           IF (LCEKEY(J).EQ.'GAIN')
     *                        RDTGAN(KK,M,K,NPP) = DVALS(JJ)
                           IF (LCEKEY(J).EQ.'TSYS')
     *                        RDTTSY(KK,M,K,NPP) = DVALS(JJ)
                           IF (LCEKEY(J).EQ.'GERR')
     *                        RDTGER(KK,M,K,NPP) = DVALS(JJ)
                           END IF
420                     CONTINUE
422                  CONTINUE
425               CONTINUE
430            CONTINUE
C                                       Valid record ?
            CALL CHBLNK (16, 1, LDTAER(NPP), NCH)
            IF ((NCH.EQ.0).OR.(IDTEFQ(NPP).EQ.0)) THEN
               WERROR = WTRUE
               WRITE (MSGTXT,1430)
               END IF
C
            END IF
C                                       Read next keyin_record
         IF (.NOT.(WERROR.OR.WEOF.OR.WEND)) GO TO 410
         GO TO 1890
         END IF
C======================================================================
C                                       6: SU_MODEL entry
      LKEY = 'SU_MODEL'
      J = IKEY (LKEY, LPARS, NPARS)
      IF (DVALS(J).NE.DBLANK) THEN
C                                       Repeat (read keyin_record)
C                                       until (EOF or ERROR or END)
510      DO 515 J = 1, NMAX
            DVALS(J) = DBLANK
            LVALS(J) = '        '
515         CONTINUE
C
         CALL KEYIN (LSMTAB, DVALS, LVALS, NSMTAB, LMARK, KMODE, JLUN,
     *      IFINDF, IERR)
         WEOF = (IERR.EQ.1)
         WERROR = (IERR.NE.0).AND.(.NOT.WEOF)
         IF (WERROR) WRITE (MSGTXT,1060) IERR
C                                       END ?
         LKEY = 'END'
         J = IKEY (LKEY, LSMTAB, NSMTAB)
         WEND = (DVALS(J).NE.DBLANK)
C                                       If (NOT (EOF or ERR or END))
C                                       then process record
         IF (.NOT.(WEOF.OR.WEND.OR.WERROR)) THEN
C                                       Initialize SU_MODEL record
            NDTSMD = NDTSMD + 1
            NPP = NDTSMD
            LDTSMD(NPP) = ' '
            CALL RFILL (12, 0.0, RDTSPM(1,NPP))
            CALL RFILL (5, 0.0, RDTSPC(1,NPP))
            CALL RFILL (2, 0.0, RDTVEL(1,NPP))
C                                       Extract source name
            LKEY = 'SOURCE'
            J = IKEY (LKEY, LSMTAB, NSMTAB)
            IF (DVALS(J).NE.DBLANK) LDTSMD(NPP) = LVALS(J)
C                                       Component parameters
            LKEY = 'TYPE'
            J = IKEY (LKEY, LSMTAB, NSMTAB)
            DO 520 K = 1, 12
               M = J + (K - 1)
               IF (DVALS(M).NE.DBLANK) RDTSPM(K,NPP) = DVALS(M)
520            CONTINUE
C                                       Spectral index
            LKEY = 'SPEC'
            J = IKEY (LKEY, LSMTAB, NSMTAB)
            DO 530 K = 1, 5
               M = J + (K - 1)
               IF (DVALS(M).NE.DBLANK) RDTSPC(K,NPP) = DVALS(M)
530            CONTINUE
C                                       Velocity information
            LKEY = 'VEL'
            J = IKEY (LKEY, LSMTAB, NSMTAB)
            DO 540 K = 1, 2
               M = J + (K - 1)
               IF (DVALS(M).NE.DBLANK) RDTVEL(K,NPP) = DVALS(M)
540            CONTINUE
C                                       Valid record ?
            CALL CHBLNK (16, 1, LDTSMD(NPP), NCH)
            IF (NCH.EQ.0) THEN
               WERROR = WTRUE
               WRITE (MSGTXT,1540)
               END IF
            END IF
C                                       Read next keyin record
         IF (.NOT.(WEOF.OR.WERROR.OR.WEND)) GO TO 510
         GO TO 1890
         END IF
C======================================================================
C                                       7: Schedule entry
      LKEY = 'SCHEDULE'
      J = IKEY (LKEY, LPARS, NPARS)
      IF (DVALS(J).NE.DBLANK) THEN
C
         IDAY = DDAY
         IMTH = DMONTH
         IYEAR = DYEAR
C                                       Repeat (read keyin_record)
C                                       until (EOF or ERROR or END)
610      DO 615 J = 1, NMAX
            DVALS(J) = DBLANK
            LVALS(J) = '        '
615         CONTINUE
C
         CALL KEYIN (LSHTAB, DVALS, LVALS, NSHTAB, LMARK, KMODE,
     *      JLUN, IFINDF, IERR)
         WEOF = (IERR.EQ.1)
         WERROR = (IERR.NE.0).AND.(.NOT.WEOF)
         IF (WERROR) WRITE (MSGTXT,1060) IERR
C                                       END CAT ?
         LKEY = 'END'
         J = IKEY (LKEY, LSHTAB, NSHTAB)
         WEND = (DVALS(J).NE.DBLANK)
C                                       If (NOT (ERR or EOF or END))
C                                       then process record
         IF (.NOT.(WEND.OR.WERROR.OR.WEOF)) THEN
C                                       Initialize schedule record
            NDTSCH = NDTSCH + 1
            NPP = NDTSCH
            LDTSCH(NPP) = ' '
            LDTSEL(NPP) = ' '
            IDTDAY(NPP) = IDAY
            IDTMTH(NPP) = IMTH
            IDTYR(NPP) = IYEAR
            IDTSSB(NPP) = 1
            IDTSFQ(NPP) = 1
            RDTSTT(NPP) = 0.0
            RDTEND(NPP) = 0.0
            RDTINT(NPP) = 1.0
C                                       Day, month, year
            LKEY = 'DAY'
            J = IKEY (LKEY, LSHTAB, NSHTAB)
            IF (DVALS(J).NE.DBLANK) THEN
               IDTDAY(NPP) = DVALS(J)
               IDAY = IDTDAY(NPP)
               END IF
C
            LKEY = 'MONTH'
            J = IKEY (LKEY, LSHTAB, NSHTAB)
            IF (DVALS(J).NE.DBLANK) THEN
               IDTMTH(NPP) = DVALS(J)
               IMTH = IDTMTH(NPP)
               END IF
C
            LKEY = 'YEAR'
            J = IKEY (LKEY, LSHTAB, NSHTAB)
            IF (DVALS(J).NE.DBLANK) THEN
               IDTYR(NPP) = DVALS(J)
               IYEAR = IDTYR(NPP)
               END IF
C                                       Start time / days
            LKEY = 'START'
            J = IKEY (LKEY, LSHTAB, NSHTAB)
            IF (DVALS(J).NE.DBLANK) RDTSTT(NPP) = DVALS(J) / 24.0D0
C                                       Stop time / days
            LKEY = 'STOP'
            J = IKEY (LKEY, LSHTAB, NSHTAB)
            IF (DVALS(J).NE.DBLANK) RDTEND(NPP) = DVALS(J) / 24.0D0
C                                       Source name
            LKEY = 'SOURCE'
            J = IKEY (LKEY, LSHTAB, NSHTAB)
            IF (DVALS(J).NE.DBLANK) LDTSCH(NPP) = LVALS(J)
C                                       Subarray
            LKEY = 'SUBA'
            J = IKEY (LKEY, LSHTAB, NSHTAB)
            IF (DVALS(J).NE.DBLANK) IDTSSB(NPP) = DVALS(J)
C                                       Freqid
            LKEY = 'FQID'
            J = IKEY (LKEY, LSHTAB, NSHTAB)
            IF (DVALS(J).NE.DBLANK) IDTSFQ(NPP) = DVALS(J)
C                                       Integration time / days
            LKEY = 'TINT'
            J = IKEY (LKEY, LSHTAB, NSHTAB)
            IF (DVALS(J).NE.DBLANK) RDTINT(NPP) = DVALS(J) / 86400.0D0
C                                       Baseline selection
            WSERR = WFALSE
            LKEY = 'SELECT'
            J = IKEY (LKEY, LSHTAB, NSHTAB)
            IF (DVALS(J).NE.DBLANK) THEN
               LDTSEL(NPP) = LVALS(J)
               LPRE = LVALS(J)(1:1)
               WSERR = ((LPRE.NE.'*').AND.(LPRE.NE.'-').AND.
     *            (LPRE.NE.' '))
               END IF
C                                       Valid record ?
            CALL CHBLNK (16, 1, LDTSCH(NPP), NCH)
            IF ((RDTSTT(NPP).GE.RDTEND(NPP)) .OR. (NCH.EQ.0) .OR.
     *         (IDAY.EQ.0) .OR. (IMTH.EQ.0) .OR. (IYEAR.EQ.0) .OR.
     *         WSERR) THEN
               WERROR = WTRUE
               WRITE (MSGTXT,1680)
               END IF
            END IF
C                                       Read next keyin_record
         IF (.NOT.(WERROR.OR.WEOF.OR.WEND)) GO TO 610
         GO TO 1890
         END IF
C======================================================================
C                                       8: FLAG entry
      LKEY = 'FLAG'
      J = IKEY (LKEY, LPARS, NPARS)
      IF (DVALS(J).NE.DBLANK) THEN
C
         IDAY = DDAY
         IMTH = DMONTH
         IYEAR = DYEAR
C                                       Repeat (read keyin_record)
C                                       until (EOF or ERROR or END)
710      DO 715 J = 1, NMAX
            DVALS(J) = DBLANK
            LVALS(J) = '        '
715         CONTINUE
C
         CALL KEYIN (LFGTAB, DVALS, LVALS, NFGTAB, LMARK, KMODE,
     *      JLUN, IFINDF, IERR)
         WEOF = (IERR.EQ.1)
         WERROR = (IERR.NE.0).AND.(.NOT.WEOF)
         IF (WERROR) WRITE (MSGTXT,1060) IERR
C                                       END CAT ?
         LKEY = 'END'
         J = IKEY (LKEY, LFGTAB, NFGTAB)
         WEND = (DVALS(J).NE.DBLANK)
C                                       If (not (ERR or EOF or END))
C                                       then process record
         IF (.NOT.(WEND.OR.WEOF.OR.WERROR)) THEN
C                                       Initialize flag record
            NDTFG = NDTFG + 1
            NPP = NDTFG
            LDTFGA(NPP) = ' '
            LDTFGB(NPP) = ' '
            LDTFGS(NPP) = ' '
            IDTFDY(NPP) = IDAY
            IDTFMH(NPP) = IMTH
            IDTFYR(NPP) = IYEAR
            RDTSFG(NPP) = 0.0
            RDTEFG(NPP) = 0.0
            IDTBIF(NPP) = 0
            IDTEIF(NPP) = 0
            IDTBCH(NPP) = 0
            IDTECH(NPP) = 0
            IDTFFQ(NPP) = 0
            IDTSBF(NPP) = 0
            CALL FILL (4, 0, IDTSKF(1,NPP))
C                                       Ant_1
            LKEY = 'ANT_1'
            J = IKEY (LKEY, LFGTAB, NFGTAB)
            IF (DVALS(J).NE.DBLANK) LDTFGA(NPP) = LVALS(J)
C                                       Ant_2
            LKEY = 'ANT_2'
            J = IKEY (LKEY, LFGTAB, NFGTAB)
            IF (DVALS(J).NE.DBLANK) LDTFGB(NPP) = LVALS(J)
C                                       Source
            LKEY = 'SOURCE'
            J = IKEY (LKEY, LFGTAB, NFGTAB)
            IF (DVALS(J).NE.DBLANK) LDTFGS(NPP) = LVALS(J)
C                                       Day, month, year
            LKEY = 'DAY'
            J = IKEY (LKEY, LFGTAB, NFGTAB)
            IF (DVALS(J).NE.DBLANK) THEN
               IDTFDY(NPP) = DVALS(J)
               IDAY = IDTFDY(NPP)
               END IF
            LKEY = 'MONTH'
            J = IKEY (LKEY, LFGTAB, NFGTAB)
            IF (DVALS(J).NE.DBLANK) THEN
               IDTFMH(NPP) = DVALS(J)
               IMTH = IDTFMH(NPP)
               END IF
            LKEY = 'YEAR'
            J = IKEY (LKEY, LFGTAB, NFGTAB)
            IF (DVALS(J).NE.DBLANK) THEN
               IDTFYR(NPP) = DVALS(J)
               IYEAR = IDTFYR(NPP)
               END IF
C                                       Start, stop time / days
            LKEY = 'START'
            J = IKEY (LKEY, LFGTAB, NFGTAB)
            IF (DVALS(J).NE.DBLANK) RDTSFG(NPP) = DVALS(J) / 24.0D0
            LKEY = 'STOP'
            J = IKEY (LKEY, LFGTAB, NFGTAB)
            IF (DVALS(J).NE.DBLANK) RDTEFG(NPP) = DVALS(J) / 24.0D0
C                                       BIF, EIF
            LKEY = 'BIF'
            J = IKEY (LKEY, LFGTAB, NFGTAB)
            IF (DVALS(J).NE.DBLANK) IDTBIF(NPP) = DVALS(J)
            LKEY = 'EIF'
            J = IKEY (LKEY, LFGTAB, NFGTAB)
            IF (DVALS(J).NE.DBLANK) IDTEIF(NPP) = DVALS(J)
C                                       BCHAN, ECHAN
            LKEY = 'BCHAN'
            J = IKEY (LKEY, LFGTAB, NFGTAB)
            IF (DVALS(J).NE.DBLANK) IDTBCH(NPP) = DVALS(J)
            LKEY = 'ECHAN'
            J = IKEY (LKEY, LFGTAB, NFGTAB)
            IF (DVALS(J).NE.DBLANK) IDTECH(NPP) = DVALS(J)
C                                       Frequency ID
            LKEY = 'FQID'
            J = IKEY (LKEY, LFGTAB, NFGTAB)
            IF (DVALS(J).NE.DBLANK) IDTFFQ(NPP) = DVALS(J)
C                                       Subarray
            LKEY = 'SUBA'
            J = IKEY (LKEY, LFGTAB, NFGTAB)
            IF (DVALS(J).NE.DBLANK) IDTSBF(NPP) = DVALS(J)
C                                       Stokes PFLAG
            LKEY = 'PFLAG'
            J = IKEY (LKEY, LFGTAB, NFGTAB)
            IF (DVALS(J).NE.DBLANK) THEN
               DO 740 K = 1, MIN (4, ITRIM(LVALS(J)))
                  IF (LVALS(J)(K:K).EQ.'1') IDTSKF(K,NPP) = 1
740            CONTINUE
               END IF
C                                       Valid record ?
            CALL CHBLNK (8, 1, LDTFGA(NPP), NCH)
            CALL CHBLNK (8, 1, LDTFGS(NPP), NCHA)
            IF ((RDTSFG(NPP).GE.RDTEFG(NPP)).OR.(NCH.EQ.0).OR.
     *         (NCHA.EQ.0)) THEN
               WERROR = WTRUE
               WRITE (MSGTXT,1740)
               END IF
            END IF
C                                       Read next keyin_record
         IF (.NOT.(WERROR.OR.WEOF.OR.WEND)) GO TO 710
         GO TO 1890
         END IF
C======================================================================
C                                       9: BP_TABLE entry
      LKEY = 'BP_TABLE'
      J = IKEY (LKEY, LPARS, NPARS)
      IF (DVALS(J).NE.DBLANK) THEN
C                                       Initialize BP table keywords
         LDTBPT = '        '
         NDTBPA = 0
         IDTBPN = 0
         IDTBPV = 0
         IDAY = DDAY
         IMTH = DMONTH
         IYEAR = DYEAR
C                                       Extract table version no.
         LKEY = 'VER'
         J = IKEY (LKEY, LPARS, NPARS)
         IF (DVALS(J).NE.DBLANK) IDTBPV = DVALS(J)
C                                       Repeat (read keyin_record)
C                                       until (EOF or ERROR or END)
 810     DO 815 J = 1, NMAX
            DVALS(J) = DBLANK
            LVALS(J) = '        '
 815        CONTINUE
C
         CALL KEYIN (LBPTAB, DVALS, LVALS, NBPTAB, LMARK, KMODE, JLUN,
     *      IFINDF, IERR)
         WEOF = (IERR.EQ.1)
         WERROR = (IERR.NE.0).AND.(.NOT.WEOF)
         IF (WERROR) WRITE (MSGTXT,1060) IERR
C                                       END CAT ?
         LKEY = 'END'
         J = IKEY (LKEY, LBPTAB, NBPTAB)
         WEND = (DVALS(J).NE.DBLANK)
C                                       If (not (ERR or EOF or END))
C                                       then process record.
         IF (.NOT.(WEND.OR.WEOF.OR.WERROR)) THEN
C                                       Case record_type of:
C                                       i) KEY record
            LKEY = 'KEY'
            J = IKEY (LKEY, LBPTAB, NBPTAB)
            IF (DVALS(J).NE.DBLANK) THEN
C                                       Keyword record:
C                                       Extract bp_type
               LKEY = 'BPTYPE'
               J = IKEY (LKEY, LBPTAB, NBPTAB)
               IF (DVALS(J).NE.DBLANK) LDTBPT = LVALS(J)
C                                       Extract no_ant
               LKEY = 'NANT'
               J = IKEY (LKEY, LBPTAB, NBPTAB)
               IF (DVALS(J).NE.DBLANK) NDTBPA = DVALS(J)
C                                       Numshf
               LKEY = 'NUMSHF'
               J = IKEY (LKEY, LBPTAB, NBPTAB)
               IF (DVALS(J).NE.DBLANK) IDTBPN = DVALS(J)
C                                       ii) BP entry
            ELSE
               LKEY = 'STATION'
               J = IKEY (LKEY, LBPTAB, NBPTAB)
               IF (DVALS(J).NE.DBLANK) THEN
C                                       Initialization
                  NDTBPD = NDTBPD + 1
                  NPP = NDTBPD
                  IDTBPY(NPP) = IYEAR
                  IDTBPM(NPP) = IMTH
                  IDTBPD(NPP) = IDAY
                  RDTBPT(NPP) = 0.0
                  RDTBPI(NPP) = 0.0
                  RDTBPS(NPP) = 0.0
                  IDTBPX(NPP) = 0
                  IDTBPC(NPP) = 0
                  IDTBFQ(NPP) = 0
                  IDTBSB(NPP) = 0
                  CALL FILL (MAXIF, 0, IDTBFI(1,NPP))
                  CALL FILL (MAXIF, 0, IDTBFP(1,NPP))
                  CALL FILL (2*MAXIF, 0, IDTBFC(1,NPP))
C                                       Station name
                  LDTBAN(NPP) = LVALS(J)
C                                       Freq. id.
                  LKEY = 'FQID'
                  J = IKEY (LKEY, LBPTAB, NBPTAB)
                  IF (DVALS(J).NE.DBLANK) IDTBFQ(NPP) = DVALS(J)
C                                       Subarray
                  LKEY = 'SUBA'
                  J = IKEY (LKEY, LBPTAB, NBPTAB)
                  IF (DVALS(J).NE.DBLANK) IDTBSB(NPP) = DVALS(J)
C                                       Day, month, year
                  LKEY = 'DAY'
                  J = IKEY (LKEY, LBPTAB, NBPTAB)
                  IF (DVALS(J).NE.DBLANK) THEN
                     IDTBPD(NPP) = DVALS(J)
                     IDAY = IDTBPD(NPP)
                     END IF
                  LKEY = 'MONTH'
                  J = IKEY (LKEY, LBPTAB, NBPTAB)
                  IF (DVALS(J).NE.DBLANK) THEN
                     IDTBPM(NPP) = DVALS(J)
                     IMTH = IDTBPM(NPP)
                     END IF
                  LKEY = 'YEAR'
                  J = IKEY (LKEY, LBPTAB, NBPTAB)
                  IF (DVALS(J).NE.DBLANK) THEN
                     IDTBPY(NPP) = DVALS(J)
                     IYEAR = IDTBPY(NPP)
                     END IF
C                                       Start time (days)
                  LKEY = 'START'
                  J = IKEY (LKEY, LBPTAB, NBPTAB)
                  IF (DVALS(J).NE.DBLANK) RDTBPT(NPP) = DVALS(J)/24.0D0
C                                       End time
                  LKEY = 'STOP'
                  J = IKEY (LKEY, LBPTAB, NBPTAB)
                  IF (DVALS(J).NE.DBLANK) RDTBPE(NPP) = DVALS(J)/24.0D0
C                                       Integration time of each entry
C                                       (convert from sec to days)
                  LKEY = 'TINT'
                  J = IKEY (LKEY, LBPTAB, NBPTAB)
                  IF (DVALS(J).NE.DBLANK) RDTBPS(NPP) = DVALS(J)
                  RDTBPS(NPP) = RDTBPS(NPP) / 86400.0D0
C                                       BP spacing in time (convert
C                                       to days from minutes)
                  LKEY = 'INTERV'
                  J = IKEY (LKEY, LBPTAB, NBPTAB)
                  IF (DVALS(J).NE.DBLANK) RDTBPI(NPP) = DVALS(J)
                  RDTBPI(NPP) = RDTBPI(NPP) / 1440.0D0
C                                       BP type (only calibration
C                                       errors supported at present)
                  LKEY = 'CAL_ERR'
                  J = IKEY (LKEY, LBPTAB, NBPTAB)
                  IF (DVALS(J).NE.DBLANK) IDTBPC(NPP) = 1
C                                       XC or AC ?
                  LKEY = 'AC'
                  J = IKEY (LKEY, LBPTAB, NBPTAB)
                  IF (DVALS(J).NE.DBLANK) IDTBPX(NPP) = 1
                  LKEY = 'XC'
                  J = IKEY (LKEY, LBPTAB, NBPTAB)
                  IF (DVALS(J).NE.DBLANK) IDTBPX(NPP) = 0
C                                       Flagged channels/IF/polzn.
                  LKEY = 'FLAGPOL'
                  J = IKEY (LKEY, LBPTAB, NBPTAB)
                  DO 830 K = 1,MAXIF
                     I = J + K - 1
                     IF (DVALS(I).NE.DBLANK) IDTBFP(K,NPP) = DVALS(I)
 830                 CONTINUE
C
                  LKEY = 'FLAGIF'
                  J = IKEY (LKEY, LBPTAB, NBPTAB)
                  DO 835 K = 1, MAXIF
                     I = J + K - 1
                     IF (DVALS(I).NE.DBLANK) IDTBFI(K,NPP) = DVALS(I)
 835                 CONTINUE
C
                  LKEY = 'FLAGCHAN'
                  J = IKEY (LKEY, LBPTAB, NBPTAB)
                  DO 840 K = 1, 2*MAXIF
                     I = J + K - 1
                     IF (DVALS(I).NE.DBLANK) IDTBFC(K,NPP) = DVALS(I)
 840                 CONTINUE
C                                       iii) Other: error
               ELSE
                  WERROR = WTRUE
                  WRITE (MSGTXT,1870)
                  END IF
C                                       Endcase (BP record_type)
               END IF
            END IF
C                                       Read next keyin_record
         IF (.NOT.(WERROR.OR.WEOF.OR.WEND)) GO TO 810
         GO TO 1890
         END IF
C======================================================================
C                                       10: Other: error
      WERROR = WTRUE
      WRITE (MSGTXT, 1810)
C                                       Endcase
 1890 CONTINUE
C                                       Until (EOF or ERROR)
 1900 IF (.NOT.(WEOF.OR.WERROR)) GO TO 50
C                                       Print any error messages
      IF (WERROR) THEN
         CALL MSGWRT (8)
         GO TO 1999
         END IF
C                                       Check for missing data
C                                       in DTPM.INC.
      WERROR = ((NDTSUB.EQ.0).OR.(NDTFQD.EQ.0).OR.
     *   (NDTSID.EQ.0).OR.(.NOT.WDTCAT))
      IF (WERROR) THEN
         WRITE (MSGTXT,1905)
      ELSE
C                                       Consolidate the common
C                                       block data in DTPM.INC.
C                                       Julian day no. of ref. date
         CALL DATEST (LDTDAT, IT)
         WRITE (LDTDAT,1915) IT(1), IT(2), IT(3)
         CALL FILL (3, 0, IT(4))
         CALL DAT2JD (IT, DTJDAT)
C                                       Adjust all schedule times
C                                       wrt reference date.
         DO 1910 K = 1, NDTSCH
            IT(1) = IDTYR(K)
            IT(2) = IDTMTH(K)
            IT(3) = IDTDAY(K)
            CALL FILL (3, 0, IT(4))
            CALL DAT2JD (IT, DJD)
            IOFF = DJD - DTJDAT + 0.5
            RDTSTT(K) = RDTSTT(K) + IOFF
            RDTEND(K) = RDTEND(K) + IOFF
 1910       CONTINUE
C                                       Consolidate FLAG records
         DO 1920 K = 1, NDTFG
C                                       Adjust all FLAG times wrt
C                                       reference date.
            IT(1) = IDTFYR(K)
            IT(2) = IDTFMH(K)
            IT(3) = IDTFDY(K)
            CALL FILL (3, 0, IT(4))
            CALL DAT2JD (IT, DJD)
            IOFF = DJD - DTJDAT + 0.5D0
            RDTSFG(K) = RDTSFG(K) + IOFF
            RDTEFG(K) = RDTEFG(K) + IOFF
C                                       Convert BIF,EIF defaults.
            IF (IDTBIF(K).LE.0) IDTBIF(K) = 1
            IF (IDTEIF(K).LE.0) IDTEIF(K) = NDTIF
C                                       Convert BCHAN, ECHAN defaults.
            IF (IDTBCH(K).LE.0) IDTBCH(K) = 1
            IF (IDTECH(K).LE.0) IDTECH(K) = NDTCHN
 1920       CONTINUE
C                                       Consolidate BP records.
         DO 1925 K = 1, NDTBPD
C                                       Adjust all BP times wrt
C                                       reference date
            IT(1) = IDTBPY(K)
            IT(2) = IDTBPM(K)
            IT(3) = IDTBPD(K)
            CALL FILL (3, 0, IT(4))
            CALL DAT2JD (IT, DJD)
            IOFF = DJD - DTJDAT + 0.5D0
            RDTBPT(K) = RDTBPT(K) + IOFF
            RDTBPE(K) = RDTBPE(K) + IOFF
 1925       CONTINUE
         END IF
C                                       Exit
C                                       Hard close: text file
 1999 CALL ZTXCLS (JLUN, IFINDF, IERR)
C
 999  RETURN
C----------------------------------------------------------------------
1050  FORMAT ('DTPARM: ERR',I4,' OPENING ',A48)
1060  FORMAT ('DTPARM: ERR',I4,' READING TEXT FILE')
1085  FORMAT ('DTPARM: INVALID AN TABLE ENTRY')
1220  FORMAT ('DTPARM: INVALID SU TABLE ENTRY')
1325  FORMAT ('DTPARM: INVALID CATALOG HDR RECORD')
1430  FORMAT ('DTPARM: INVALID CAL_ERR RECORD')
1540  FORMAT ('DTPARM: INVALID SU_MODEL RECORD')
1680  FORMAT ('DTPARM: INVALID SCHEDULE RECORD')
1740  FORMAT ('DTPARM: INVALID FLAG RECORD')
1810  FORMAT ('DTPARM: UNIDENTIFIED GROUP')
1870  FORMAT ('DTPARM: INVALID BP TABLE ENTRY')
1905  FORMAT ('DTPARM: MISSING GROUPS IN EXTERNAL FILE')
1915  FORMAT (I4,I2.2,I2.2)
9007  FORMAT ('_',I1,A1)
9010  FORMAT ('_',I2,A1)
      END

      PROGRAM UNCAL
C-----------------------------------------------------------------------
C! Task to copy 'uncal' table from the AT to 'cal' tables
C# EXT-util Utility Calibration AT
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  UNCAL copies either CU or BU tables to specified CL and BP
C  tables in order to be able to remove the calibration applied
C  on-line to AT data.
C   ADVERBS:
C    INNAME      Input image name (name)
C    INCLASS     Input image name (class)
C    INSEQ       Input image name (seq. #)
C    INDISK      Input image disk unit #
C    INEXT       Input table extension type
C    INVERS      Input table file version no.
C-----------------------------------------------------------------------
      CHARACTER  NAMEIN*12, CLAIN*6, FTYPE*2, STAT*4, XEXT*2, OEXT*2,
     *   PRGM*6, ATIME*8, ADATE*12
      HOLLERITH XNAMIN(3), XCLAIN(2), XNEXT(1)
      INTEGER  IRET, SEQIN, DISKIN, OLDCNO, BUFF1(256), IVER, OVER,
     *   LUN1, LUN2, NPARM, IROUND, TIME(3), DATE(3)
      REAL      XSEQIN, XDISKI, XIVER
      LOGICAL   T
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /INPARM/ XNAMIN, XCLAIN, XSEQIN, XDISKI, XNEXT, XIVER
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA PRGM /'UNCAL '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 9
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMIN, BUFF1, IRET)
      IF (IRET.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IRET.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IRET
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IRET)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMIN, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (2, 1, XNEXT, XEXT)
      IF ((XEXT.EQ.'CU') .OR. (XEXT.EQ.'  ')) THEN
         OEXT = 'CL'
      ELSE IF (XEXT.EQ.'BU') THEN
         OEXT = 'BP'
      ELSE
         WRITE (MSGTXT,1010) XEXT
         IRET = 1
         GO TO 990
         END IF
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      DISKIN = IROUND (XDISKI)
      IVER = IROUND (XIVER)
      IF (IVER.LT.1) IVER = 1
      OVER = 0
      XIVER = IVER
C                                       Find input
      OLDCNO = 1
      FTYPE = ' '
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, FTYPE,
     *   NLUSER, STAT, BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read old CATBLK and mark 'WRIT'
      STAT = 'WRIT'
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, STAT, BUFF1, IRET)
      IF ((IRET.GT.0) .AND. (IRET.LT.5)) THEN
         WRITE (MSGTXT,1040) IRET
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 1
C                                       Copy the tables
      IF (OEXT.EQ.'CL') THEN
         CALL CUTAB (DISKIN, OLDCNO, IVER, OVER, CATBLK, LUN2, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1050) IRET
            GO TO 990
            END IF
      ELSE IF (OEXT.EQ.'BP') THEN
         CALL BUTAB (DISKIN, OLDCNO, IVER, OVER, CATBLK, LUN2, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1060) IRET
            GO TO 990
            END IF
         END IF
C                                       Finished copying tables
C                                       Add history to output
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN1, DISKIN, OLDCNO, BUFF1, IRET)
      IF (IRET.GT.2) THEN
         WRITE (MSGTXT,1090) IRET
         CALL MSGWRT (6)
         GO TO 150
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
      WRITE (MSGTXT,1100) TSKNAM, RLSNAM, ADATE, ATIME
      CALL HIADD (LUN1, MSGTXT, BUFF1, IRET)
      IF (IRET.NE.0) GO TO 150
C                                       Input file
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN1, BUFF1,
     *   IRET)
      IF (IRET.NE.0) GO TO 150
C                                       Type and version
      WRITE (MSGTXT,2000) TSKNAM, XEXT, IVER, OEXT, OVER
      CALL HIADD (LUN1, MSGTXT, BUFF1, IRET)
      IF (IRET.NE.0) GO TO 150
C                                       Close HI file
 150  CALL HICLOS (LUN1, T, BUFF1, IRET)
      GO TO 995
C                                       Error
 990  CALL MSGWRT (8)
C                                       Close down files, etc
 995  CALL DIE (IRET, BUFF1)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' GETING INPUT PARAMETERS')
 1010 FORMAT ('ERROR: UNKNOWN TABLE TYPE ',A2,' CHECK INPUT PARMS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('CUTAB ERROR ',I3)
 1060 FORMAT ('BUTAB ERROR ',I3)
 1090 FORMAT ('ERROR ',I3,' OPENING HISTORY TABLE')
 1100 FORMAT (A6,'Release = ''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 2000 FORMAT (A6,' Copied ''',A2,''' INVERS=',I4,' to ''',A2,
     *   ''' OUTVERS=', I4)
      END
      SUBROUTINE CUTAB (DISK, CNO, VER, OVER, CATBLK, LUN, IRET)
C-----------------------------------------------------------------------
C   Routine to copy a CU table to a CL table
C   NOTE: routine uses LUN 45 as a temporary logical unit number.
C
C   Inputs:
C      DISK            I       Volume number
C      CNO             I       Catalogue number
C      VER             I       Version to copy from
C      OVER            I       Version to copy to
C      CATBLK(256)     I       Catalogue header
C      LUN             I       LUN to use
C   Output:
C      IRET            I       Error, 0 => OK
C
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, VER, OVER, CATBLK(256), LUN, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   BUFFER(512), ICLRNO, NUMANT, NUMPOL, NUMIF, OLUN,
     *   OBUFF(512), OKOLS(MAXCLC), ONUMV(MAXCLC), NCLROW, I, SOURID,
     *   ANTNO, SUBA, FREQID, REFA(2,MAXIF), OCLRNO, NTERM, CUKOLS(50),
     *   CUNUMV(50)
      REAL      DOPOFF(MAXIF), ATMOS, DATMOS, MBDELY(2), CLOCK(2),
     *   DCLOCK(2), DISP(2), DDISP(2), CREAL(2,MAXIF), CIMAG(2,MAXIF),
     *   DELAY(2,MAXIF), RATE(2,MAXIF), WEIGHT(2,MAXIF)
      REAL    CLKGD(2,MAXIF), DCLKGD(2,MAXIF), CLKPD(2,MAXIF),
     *   DCLKPD(2,MAXIF), ATMGD(2,MAXIF), DATMGD(2,MAXIF),
     *   ATMPD(2,MAXIF),  DATMPD(2,MAXIF), TSYS(2,MAXIF)
      DOUBLE PRECISION    GEODLY(3), GEOPHA, GEORAT
      REAL    GMMOD, TIMEI, IFR
      DOUBLE PRECISION TIME
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA OLUN /45/
      DATA GEODLY /3*0.0D0/
      DATA DOPOFF, MBDELY, CLOCK, DCLOCK /MAXIF*0.0, 6*0.0/
      DATA ATMOS, DATMOS, DISP, DDISP /6*0.0/
C-----------------------------------------------------------------------
C                                       Open CU file
      CALL CUINI ('READ', BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   ICLRNO, CUKOLS, CUNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.EQ.2) THEN
         IRET = 0
         GO TO 999
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       # rows in old table
      NCLROW = BUFFER(5)
C                                       Open up new CL table
      CALL CALINI ('WRIT', OBUFF, DISK, CNO, OVER, CATBLK, OLUN,
     *   OCLRNO, OKOLS, ONUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      WRITE (MSGTXT,1000) VER, OVER
      CALL MSGWRT (6)
C                                       Loop and copy
      DO 100 I = 1, NCLROW
         ICLRNO = I
         CALL TABCU ('READ', BUFFER, ICLRNO, CUKOLS, CUNUMV,
     *      NUMPOL, NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID,
     *      IFR, GEODLY(1), GEOPHA, GEORAT, DOPOFF, CLKGD, DCLKGD,
     *      CLKPD, DCLKPD, ATMGD, DATMGD, ATMPD, DATMPD, CREAL, CIMAG,
     *      DELAY, RATE, TSYS, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1030) IRET
            GO TO 990
            END IF
         OCLRNO = I
         CALL TABCAL ('WRIT', OBUFF, OCLRNO, OKOLS, ONUMV,
     *      NUMPOL, NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID,
     *      IFR, GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK,
     *      DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1040) IRET
            GO TO 990
            END IF
 100     CONTINUE
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ICLRNO, BUFFER, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OCLRNO, OBUFF, OBUFF, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Copying CU table #',I3,' to CL table #',I3)
 1010 FORMAT ('CUTAB: ERROR ',I3,' INITING CU TABLE')
 1020 FORMAT ('CUTAB: ERROR ',I3,' INITING CL TABLE')
 1030 FORMAT ('CUTAB: ERROR ',I3,' READING CU TABLE')
 1040 FORMAT ('CUTAB: ERROR ',I3,' WRITING CL TABLE')
      END
      SUBROUTINE BUTAB (DISK, CNO, VER, OVER, CATBLK, LUN, IRET)
C-----------------------------------------------------------------------
C   Routine to copy a BU table to a BP table
C   NOTE: routine uses LUN 45 as a temporary logical unit number.
C
C   Inputs:
C      DISK            I       Volume number
C      CNO             I       Catalogue number
C      VER             I       Version to copy from
C      OVER            I       Version to copy to
C      CATBLK(256)     I       Catalogue header
C      LUN             I       LUN to use
C   Output:
C      IRET            I       Error, 0 => OK
C
C   NOTE: routine uses LUN 45 as a temporary logical unit number.
C-----------------------------------------------------------------------
      INTEGER DISK, CNO, VER, OVER, CATBLK(256), LUN, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER LBPKEY*8, LEIGHT*8
      INTEGER BUFFER(512), IBPRNO, BPKOLS(MAXBPC), BPNUMV(MAXBPC),
     *   NUMANT, NUMPOL, NUMIF, NUMFRQ, BCHAN, OLUN, OBUFF(512),
     *   OKOLS(MAXBPC), ONUMV(MAXBPC), NBPROW, I, SOURID, ANTNO, SUBA,
     *   FREQID, REFANT(2), OBPRNO, NUMSHF
      REAL    TIMEI, BNDPAS(2,MAXCIF), WEIGHT(2*MAXIF), BANDW, LOWSHF,
     *   DELSHF
      DOUBLE PRECISION TIME, IFFREQ(MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA OLUN /45/, LEIGHT /'        '/
C-----------------------------------------------------------------------
C                                       Open BU file
      CALL BUINI ('READ', BUFFER, DISK, CNO, VER, CATBLK, LUN, IBPRNO,
     *   BPKOLS, BPNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ, BCHAN, IRET)
      IF (IRET.EQ.2) THEN
         IRET = 0
         GO TO 999
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       # rows in old table
      NBPROW = BUFFER(5)
      LBPKEY = LEIGHT
C                                       Open up new BP table
      CALL BPINI ('WRIT', OBUFF, DISK, CNO, OVER, CATBLK, OLUN, OBPRNO,
     *   OKOLS, ONUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ, BCHAN, NUMSHF,
     *   LOWSHF, DELSHF, LBPKEY, IRET)
      IF (IRET.NE.0) GO TO 999
      WRITE (MSGTXT,1000) VER, OVER
      CALL MSGWRT (6)
C                                       Loop and copy
      DO 100 I = 1, NBPROW
         IBPRNO = I
         CALL TABBU ('READ', BUFFER, IBPRNO, BPKOLS, BPNUMV, NUMIF,
     *      NUMFRQ, NUMPOL, TIME, TIMEI, SOURID, SUBA, ANTNO, BANDW,
     *      IFFREQ, FREQID, REFANT, WEIGHT, BNDPAS, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1030) IRET
            GO TO 990
            END IF
         IF (IRET.LT.0) IRET = 0
         OBPRNO = I
         CALL TABBP ('WRIT', OBUFF, OBPRNO, OKOLS, ONUMV, NUMIF, NUMFRQ,
     *      NUMPOL, TIME, TIMEI, SOURID, SUBA, ANTNO, BANDW, IFFREQ,
     *      FREQID, REFANT, WEIGHT, BNDPAS, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1040) IRET
            GO TO 990
            END IF
         IF (IRET.LT.0) IRET = 0
 100     CONTINUE
C                                       Close both tables
      CALL TABIO ('CLOS', 0, IBPRNO, BUFFER, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OBPRNO, OBUFF, OBUFF, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Copying BU table #',I3,' to BP table #',I3)
 1010 FORMAT ('BUTAB: ERROR ',I3,' RETURNED FROM BUINI')
 1030 FORMAT ('BUTAB: ERROR ',I3,' READING BU TABLE')
 1040 FORMAT ('BUTAB: ERROR ',I3,' WRITING BP TABLE')
      END
      SUBROUTINE CUINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   ICLRNO, CUKOLS, CUNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
C-----------------------------------------------------------------------
C   Creates and initializes UNcalibration extension tables. Slightly
C   modified version of CALINI, used to read the CU tables written
C   by the AT.
C    Inputs:
C     OPCODE       C*4 Operation code:
C                      'WRIT' = create/init for write or read
C                      'READ' = open for read only
C     BUFFER(512)  I   I/O buffer and related storage, also defines file
C                      if open.
C     DISK         I   Disk to use.
C     CNO          I   Catalog slot number
C     VER          I   CL file version
C     CATBLK(256)  I   Catalog header block.
C     LUN          I   Logical unit number to use
C    Input/output
C     NUMANT       I    Number of antennas
C     NUMPOL       I    Number of IFs per pair
C     NUMIF        I    Number of IF pairs
C     NTERM        I    Number of terms is model polynomial
C     GMMOD        R    Mean gain modulus
C    Output:
C     ICLRNO       I   Next scan number, start of the file if 'READ',
C                      the last+1 if WRITE
C     CUKOLS(MAXCLC) I   The column pointer array in order, TIME,
C                        TIME INT., SOURCE ID., ANTENNA NO., SUBARRAY,
C                        FREQID, IFR (Ionesph. Faraday Rot.),
C                        GEODELAY, GEOPHASE, GEORATE, DOPPOFF,
C                        CLKGD 1, DCLKGD 1, CLKPD 1, DCLKPD 1,
C                        ATMGD 1, DATMGD 1, ATMPD 1, DATPGD 1,
C                        REAL1, IMAG1, RATE 1, DELAY 1, TSYS1, WEIGHT1,
C                        REFANT 1
C                        Following used if 2 polarizations per IF
C                        CLKGD 2, DCLKGD 2, CLKPD 2, DCLKPD 2,
C                        ATMGD 2, DATMGD 2, ATMPD 2, DATPGD 2,
C                        REAL2, IMAG2, RATE 2, DELAY 2, TSYS2, WEIGHT2,
C                        REFANT 2
C     CUNUMV(MAXCLC) I   Element count in each column.
C     IRET         I   Return error code, 0=>OK, else TABINI or TABIO
C                      error.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH HOLTMP(14)
      CHARACTER OPCODE*4, TTITLE*56, TITLE1(15)*24, TITLE2(13)*24,
     *   TITLE3(13)*24, TITLE(41)*24, UNITS(41)*8, KEYW(4)*8
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, IRET,
     *   NKEY, NREC, DATP(128,2), NCOL, CUKOLS(41), NTT, DTYP(41),
     *   NDATA, KLOCS(4), KEYVAL(6), IPOINT, NUMANT, NUMPOL, NUMIF,
     *   NTERM, CUNUMV(41), KEYTYP(4), ITMP(14)
      LOGICAL   T, F, DOREAD, NEWFIL
      INTEGER   ICLRNO, I
      REAL      GMMOD, KEYR(6), KEYRD(2)
      DOUBLE PRECISION KEYVAD
      EQUIVALENCE (HOLTMP, ITMP), (KEYVAD, KEYRD)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (TITLE(1), TITLE1), (TITLE(16), TITLE2),
     *   (TITLE(29), TITLE3)
      EQUIVALENCE (KEYVAL, KEYR)
      DATA T, F /.TRUE.,.FALSE./
      DATA NTT /56/
      DATA TTITLE /'AIPS UV DATA FILE CALIBRATION TABLE        '/
      DATA DTYP /11,12,4*14,12,3*11,2,8*2,6*2,4,8*2,6*2,4/
      DATA TITLE1 /'TIME                    ',
     *   'TIME INTERVAL           ',
     *   'SOURCE ID               ', 'ANTENNA NO.             ',
     *   'SUBARRAY                ', 'FREQ ID                 ',
     *   'I.FAR.ROT               ',
     *   'GEODELAY                ', 'GEOPHASE                ',
     *   'GEORATE                 ', 'DOPPOFF                 ',
     *   'CLKGD 1                 ', 'DCLKGD 1                ',
     *   'CLKPD 1                 ', 'DCLKPD 1                '/
      DATA TITLE2 /'ATMGD 1                 ',
     *   'DATMGD 1                ',
     *   'ATMPD 1                 ', 'DATMPD 1                ',
     *   'REAL1                   ', 'IMAG1                   ',
     *   'RATE 1                  ', 'DELAY 1                 ',
     *   'TSYS 1                  ', 'WEIGHT 1                ',
     *   'REFANT 1                ',
     *   'CLKGD 2                 ', 'DCLKGD 2                '/
      DATA TITLE3 /'CLKPD 2                 ',
     *   'DCLKPD 2                ',
     *   'ATMGD 2                 ', 'DATMGD 2                ',
     *   'ATMPD 2                 ', 'DATMPD 2                ',
     *   'REAL2                   ', 'IMAG2                   ',
     *   'RATE 2                  ', 'DELAY 2                 ',
     *   'TSYS 2                  ', 'WEIGHT 2                ',
     *   'REFANT 2                '/
      DATA KEYW /'NO_ANT  ', 'NO_POL  ', 'NO_IF   ', 'MGMOD   '/
      DATA UNITS /'DAYS    ','DAYS    ', 4*'        ', 'RAD/M**2',
     *   'SECONDS ', 'TURNS   ', 'HZ      ','HZ      ',
     *   'SECONDS ', 'SEC/SEC ', 'SECONDS ', 'SEC/SEC ',
     *   'SECONDS ', 'SEC/SEC ', 'SECONDS ', 'SEC/SEC ',
     *   2*'        ', 'SEC/SEC ', 'SECONDS ', 'KELVINS ',2*'        ',
     *   'SECONDS ', 'SEC/SEC ', 'SECONDS ', 'SEC/SEC ',
     *   'SECONDS ', 'SEC/SEC ', 'SECONDS ', 'SEC/SEC ',
     *   2*'        ', 'SEC/SEC ', 'SECONDS ', 'KELVINS ',
     *   2*'        '/
C-----------------------------------------------------------------------
C                                       Assume no real polynomial
      NTERM = 1
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NREC = 1000
      NCOL = 11 + NUMPOL * 15
      IF (DOREAD) NCOL = 0
      NKEY = 4
      NEWFIL = F
      NDATA = MAXCLC
      CALL FILL (NDATA, 0, CUKOLS)
      CALL FILL (NDATA, 0, CUNUMV)
      IF (DOREAD) GO TO 20
C                                       Fill in types
         CALL COPY (NDATA, DTYP, DATP(1,2))
         DO 10 I = 11,NDATA
            DATP(I,2) = DTYP(I) + 10 * NUMIF
 10         CONTINUE
C                                       Create/open file
 20   CALL TABINI (OPCODE, 'CL', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IRET)
      IF (IRET.GT.0) GO TO 990
      NKEY = 4
C                                       See if file exists.
      IF (IRET.EQ.0) GO TO 100
      NEWFIL = T
C                                       File created, initialize
         DO 40 I = 1,NCOL
C                                       Col. labels.
            CALL CHR2H (24, TITLE(I), 1, HOLTMP)
            CALL TABIO ('WRIT', 3, I, ITMP, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 990
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, HOLTMP)
            CALL TABIO ('WRIT', 4, I, ITMP, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 990
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, HOLTMP)
         CALL COPY (14, ITMP, BUFFER(101))
C                                       Get number of scans
 100  ICLRNO = BUFFER(5)
C                                       Set ICLRNO
      ICLRNO = ICLRNO + 1
      IF (DOREAD) ICLRNO = 1
C                                       Read/write keywords
C                                       Set keyword values
      IF (DOREAD) GO TO 120
C                                       No. antennas.
         KLOCS(1) = 1
         KEYTYP(1) = 4
         KEYVAL(1) = NUMANT
C                                       No. IFs per pair.
         KLOCS(2) = 2
         KEYTYP(2) = 4
         KEYVAL(2) = NUMPOL
C                                       No. IF pairs.
         KLOCS(3) = 3
         KEYTYP(3) = 4
         KEYVAL(3) = NUMIF
C                                       Gain modulus
         KLOCS(4) = 4
         KEYTYP(4) = 1
         KEYVAD = GMMOD
         CALL RCOPY (NWDPDP, KEYRD, KEYR(4))
C                                       Only write if just created.
 120  IF (DOREAD.OR.NEWFIL) CALL TABKEY (OPCODE, KEYW, NKEY, BUFFER,
     *   KLOCS, KEYVAL, KEYTYP, IRET)
      IF ((IRET.GE.1) .AND. (IRET.LE.20)) GO TO 990
C                                       Read keywords
      CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *   IRET)
      IF ((IRET.GE.1) .AND. (IRET.LE.20)) GO TO 990
C                                       Retrieve keyword values
C                                       No. antennas.
      IPOINT = KLOCS(1)
      IF (IPOINT.GT.0) NUMANT = KEYVAL(IPOINT)
C                                       No. IFs per pair.
      IPOINT = KLOCS(2)
      IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. IF pairs.
      IPOINT = KLOCS(3)
      IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       Gain modulus
      IPOINT = KLOCS(4)
      IF (IPOINT.GT.0) THEN
         IF (KEYTYP(4).EQ.1) THEN
            CALL RCOPY (NWDPDP, KEYR(IPOINT), KEYRD)
            GMMOD = KEYVAD
         ELSE
            GMMOD = KEYR(IPOINT)
            END IF
         END IF
C                                       Get array indices
      DO 150 I = 1,NDATA
         CUKOLS(I) = DATP(I,1)
         CUNUMV(I) = DATP(I,2) / 10
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1150) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1150 FORMAT ('CUINI: ERROR INITIALIZING CU TABLE FOR ',A4)
      END
      SUBROUTINE TABCU (OPCODE, BUFFER, ICLRNO, CUKOLS, CUNUMV,
     *   NUMPOL, NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *   GEODLY, GEOPHA, GEORAT, DOPOFF, CLKGD, DCLKGD, CLKPD, DCLKPD,
     *   ATMGD, DATMGD, ATMPD, DATMPD, CREAL, CIMAG, DELAY, RATE, TSYS,
     *   WEIGHT, REFA, IRET)
C-----------------------------------------------------------------------
C   Does I/O to UNCALIBRATION extention tables.
C    Inputs:
C     OPCODE       C*4 Operation code:
C                      'READ' = read entry from table.
C                      'WRIT' = write entry in table.
C                      'CLOS' = close file, flush on write
C     BUFFER(512)  I   I/O buffer and related storage, also defines file
C                      if open. Should have been returned by TABINI or
C                      TABINI.
C     ICLRNO       I   Next scan number to read or write.
C     CUKOLS(MAXCLC) I   The column pointer array in order, TIME,
C                        TIME INT., SOURCE ID., ANTENNA NO., SUBARRAY,
C                        FREQID, IFR (Ionesph. Faraday Rot.),
C                        GEODELAY, GEOPHASE, GEORATE, DOPPOFF,
C                        CLKGD 1, DCLKGD 1, CLKPD 1, DCLKPD 1,
C                        ATMGD 1, DATMGD 1, ATMPD 1, DATPGD 1,
C                        REAL1, IMAG1, RATE 1, DELAY 1, TSYS1, WEIGHT1,
C                        REFANT 1
C                        Following used if 2 polarizations per IF
C                        CLKGD 2, DCLKGD 2, CLKPD 2, DCLKPD 2,
C                        ATMGD 2, DATMGD 2, ATMPD 2, DATPGD 2,
C                        REAL2, IMAG2, RATE 2, DELAY 2, TSYS2, WEIGHT2,
C                        REFANT 2
C     CUNUMV(MAXCLC) I   Element count in each column.
C     NUMPOL       I   Number of polarizations per IF.
C     NUMIF        I   Number of IFs.
C    Input/output: (written to or read from CAL file)
C     TIME         D   Center time of CAL record (Days)
C     TIMEI        R   Time interval covered by record (days)
C     SOURID       I   Source ID as defined in the SOURCE table.
C     ANTNO        I   Antenna number.
C     SUBA         I   Subarray number.
C     FREQID       I   Freqid #
C     IFR          R   Ionospheric Faraday Rotation (rad/m**2)
C     GEODLY       D   Geometric delay at TIME (sec)
C     GEOPHA       D   Phase of sinusoid (turns)
C     GEORAT       D   Time rate of change of GEOPHA (Hz)
C     DOPOFF(*)    R   Doppler offset for each IF (Hz)
C     CLKGD(2,*)   R   "Clock" Group delay (sec) 1/poln/IF
C     DCLKGD(2,*)  R   Time derivative of "Clock" Group delay (sec/sec)
C     CLKPD(2,*)   R   "Clock" Phase delay (sec) 1/poln/IF
C     DCLKPD(2,*)  R   Time derivative of "Clock" Phase delay (sec/sec)
C     ATMGD(2,*)   R   "Atmos" Group delay (sec) 1/poln/IF
C     DATMGD(2,*)  R   Time derivative of "Atmos" Group delay (sec/sec)
C     ATMPD(2,*)   R   "Atmos" Phase delay (sec) 1/poln/IF
C     DATMPD(2,*)  R   Time derivative of "Atmos" Phase delay (sec/sec)
C     CREAL(2,*)   R   Real part of the complex gain, 1/poln/IF
C     CIMAG(2,*)   R   Imag part of the complex gain, 1/poln/IF
C     DELAY(2,*)   R   Residual group delay (sec), 1/poln/IF
C     RATE(2,*)    R   Residual fringe rate (Hz), 1/poln/IF
C     TSYS(2,*)    R   System temperature (K), 1/poln/IF
C     WEIGHT(2,*)  R   Weight of solution, 1/poln/IF
C     REFA(2,*)    I   Reference antenna use for cal. solution.
C    Output:
C     ICLRNO       I   Next CAL number.
C     IRET         I   Error code, 0=>OK else TABIO error.
C                      Note: -1=> read but record deselected.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), CUKOLS(*), CUNUMV(*), NUMPOL,
     *   NUMIF, SOURID, ANTNO, SUBA, FREQID, REFA(2,MAXIF), IRET,
     *   RECI(11+32*MAXIF), POINT, LOOP, TYPE, IPT,
     *   DOPKOL, CGDKOL, DCGKOL, CPDKOL, DCPKOL, AGDKOL, DAGKOL,
     *   APDKOL, DAPKOL, REAKOL, IMAKOL, DELKOL, RATKOL, TSYKOL,
     *   WEIKOL, REFKOL, ICLRNO
      LOGICAL   DOREAD, DOCLOS
      REAL      TIMEI, IFR, DOPOFF(MAXIF), CLKGD(2,MAXIF),
     *   DCLKGD(2,MAXIF), CLKPD(2,MAXIF), DCLKPD(2,MAXIF),
     *   ATMGD(2,MAXIF), DATMGD(2,MAXIF), ATMPD(2,MAXIF),
     *   DATMPD(2,MAXIF), CREAL(2,MAXIF), CIMAG(2,MAXIF),
     *   DELAY(2,MAXIF), RATE(2,MAXIF), TSYS(2,MAXIF), WEIGHT(2,MAXIF),
     *   RECORD(11+32*MAXIF)
      DOUBLE PRECISION TIME, GEODLY, GEOPHA, GEORAT, RECD(1)
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (RECD, RECORD, RECI)
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
      DOCLOS = OPCODE.EQ.'CLOS'
C                                       Branch for CLOS
      IF (DOCLOS) GO TO 800
C                                       If write fill RECORD
      IF (DOREAD) GO TO 50
         POINT = CUKOLS(1)
         RECD(POINT) = TIME
         POINT = CUKOLS(2)
         RECORD(POINT) = TIMEI
         POINT = CUKOLS(3)
         RECI(POINT) = SOURID
         POINT = CUKOLS(4)
         RECI(POINT) = ANTNO
         POINT = CUKOLS(5)
         RECI(POINT) = SUBA
         POINT = CUKOLS(6)
         RECI(POINT) = FREQID
         POINT = CUKOLS(7)
         RECORD(POINT) = IFR
         POINT = CUKOLS(8)
         RECD(POINT) = GEODLY
         POINT = CUKOLS(9)
         RECD(POINT) = GEOPHA
         POINT = CUKOLS(10)
         RECD(POINT) = GEORAT
C                                       Setup for looping over IF
         DOPKOL = CUKOLS(11)
         CGDKOL = CUKOLS(12)
         DCGKOL = CUKOLS(13)
         CPDKOL = CUKOLS(14)
         DCPKOL = CUKOLS(15)
         AGDKOL = CUKOLS(16)
         DAGKOL = CUKOLS(17)
         APDKOL = CUKOLS(18)
         DAPKOL = CUKOLS(19)
         REAKOL = CUKOLS(20)
         IMAKOL = CUKOLS(21)
         RATKOL = CUKOLS(22)
         DELKOL = CUKOLS(23)
         TSYKOL = CUKOLS(24)
         WEIKOL = CUKOLS(25)
         REFKOL = CUKOLS(26)
C                                       First polarization
         DO 10 LOOP = 1,NUMIF
            RECORD(DOPKOL) = DOPOFF(LOOP)
            RECORD(CGDKOL) = CLKGD(1,LOOP)
            RECORD(DCGKOL) = DCLKGD(1,LOOP)
            RECORD(CPDKOL) = CLKPD(1,LOOP)
            RECORD(DCPKOL) = DCLKPD(1,LOOP)
            RECORD(AGDKOL) = ATMGD(1,LOOP)
            RECORD(DAGKOL) = DATMGD(1,LOOP)
            RECORD(APDKOL) = ATMPD(1,LOOP)
            RECORD(DAPKOL) = DATMPD(1,LOOP)
            RECORD(REAKOL) = CREAL(1,LOOP)
            RECORD(IMAKOL) = CIMAG(1,LOOP)
            RECORD(DELKOL) = DELAY(1,LOOP)
            RECORD(RATKOL) = RATE(1,LOOP)
            RECORD(TSYKOL) = TSYS(1,LOOP)
            RECORD(WEIKOL) = WEIGHT(1,LOOP)
            RECI(REFKOL) = REFA(1,LOOP)
            IF (LOOP.GE.NUMIF) GO TO 10
               DOPKOL = DOPKOL+1
               CGDKOL = CGDKOL+1
               DCGKOL = DCGKOL+1
               CPDKOL = CPDKOL+1
               DCPKOL = DCPKOL+1
               AGDKOL = AGDKOL+1
               DAGKOL = DAGKOL+1
               APDKOL = APDKOL+1
               DAPKOL = DAPKOL+1
               REAKOL = REAKOL+1
               IMAKOL = IMAKOL+1
               DELKOL = DELKOL+1
               RATKOL = RATKOL+1
               TSYKOL = TSYKOL+1
               WEIKOL = WEIKOL+1
               REFKOL = REFKOL+1
 10         CONTINUE
         IF (NUMPOL.LT.2) GO TO 50
C                                       Two polarizations
C                                       Setup for looping over IF
            CGDKOL = CUKOLS(27)
            DCGKOL = CUKOLS(28)
            CPDKOL = CUKOLS(29)
            DCPKOL = CUKOLS(30)
            AGDKOL = CUKOLS(31)
            DAGKOL = CUKOLS(32)
            APDKOL = CUKOLS(33)
            DAPKOL = CUKOLS(34)
            REAKOL = CUKOLS(35)
            IMAKOL = CUKOLS(36)
            RATKOL = CUKOLS(37)
            DELKOL = CUKOLS(38)
            TSYKOL = CUKOLS(39)
            WEIKOL = CUKOLS(40)
            REFKOL = CUKOLS(41)
            DO 20 LOOP = 1,NUMIF
               RECORD(CGDKOL) = CLKGD(2,LOOP)
               RECORD(DCGKOL) = DCLKGD(2,LOOP)
               RECORD(CPDKOL) = CLKPD(2,LOOP)
               RECORD(DCPKOL) = DCLKPD(2,LOOP)
               RECORD(AGDKOL) = ATMGD(2,LOOP)
               RECORD(DAGKOL) = DATMGD(2,LOOP)
               RECORD(APDKOL) = ATMPD(2,LOOP)
               RECORD(DAPKOL) = DATMPD(2,LOOP)
               RECORD(REAKOL) = CREAL(2,LOOP)
               RECORD(IMAKOL) = CIMAG(2,LOOP)
               RECORD(DELKOL) = DELAY(2,LOOP)
               RECORD(RATKOL) = RATE(2,LOOP)
               RECORD(TSYKOL) = TSYS(2,LOOP)
               RECORD(WEIKOL) = WEIGHT(2,LOOP)
               RECI(REFKOL) = REFA(2,LOOP)
               IF (LOOP.GE.NUMIF) GO TO 20
                  CGDKOL = CGDKOL+1
                  DCGKOL = DCGKOL+1
                  CPDKOL = CPDKOL+1
                  DCPKOL = DCPKOL+1
                  AGDKOL = AGDKOL+1
                  DAGKOL = DAGKOL+1
                  APDKOL = APDKOL+1
                  DAPKOL = DAPKOL+1
                  REAKOL = REAKOL+1
                  IMAKOL = IMAKOL+1
                  DELKOL = DELKOL+1
                  RATKOL = RATKOL+1
                  TSYKOL = TSYKOL+1
                  WEIKOL = WEIKOL+1
                  REFKOL = REFKOL+1
 20               CONTINUE
C                                       Process record.
 50   CALL TABIO (OPCODE, 0, ICLRNO, RECI, BUFFER, IRET)
      ICLRNO = ICLRNO + 1
      IF (IRET.GT.0) GO TO 990
      IF (IRET.LT.0) GO TO 50
C                                       If READ pick data from RECORD.
      IF (.NOT.DOREAD) GO TO 999
C                                       Determine how many columns we
C                                       have
         TYPE = 1
         IF ((BUFFER(10).EQ.41) .OR. (BUFFER(10).EQ.26)) TYPE = 2
         IPT = 1
         POINT = CUKOLS(IPT)
         TIME = RECD(POINT)
         IPT = IPT + 1
         POINT = CUKOLS(IPT)
         TIMEI = RECORD(POINT)
         IPT = IPT + 1
         POINT = CUKOLS(IPT)
         SOURID = RECI(POINT)
         IPT = IPT + 1
         POINT = CUKOLS(IPT)
         ANTNO = RECI(POINT)
         IPT = IPT + 1
         POINT = CUKOLS(IPT)
         SUBA = RECI(POINT)
         IF (TYPE.EQ.2) THEN
            IPT = IPT + 1
            POINT = CUKOLS(IPT)
            FREQID = RECI(POINT)
            IPT = IPT + 1
            POINT = CUKOLS(IPT)
            IFR = RECORD(POINT)
            END IF
         IF (TYPE.EQ.1) THEN
            FREQID = 1
            IFR = 0.0
            END IF
         IPT = IPT + 1
         POINT = CUKOLS(IPT)
         GEODLY = RECD(POINT)
         IPT = IPT + 1
         POINT = CUKOLS(IPT)
         GEOPHA = RECD(POINT)
         IPT = IPT + 1
         POINT = CUKOLS(IPT)
         GEORAT = RECD(POINT)
C                                       Setup for looping over IF
         IPT = IPT + 1
         DOPKOL = CUKOLS(IPT)
         CGDKOL = CUKOLS(IPT+1)
         DCGKOL = CUKOLS(IPT+2)
         CPDKOL = CUKOLS(IPT+3)
         DCPKOL = CUKOLS(IPT+4)
         AGDKOL = CUKOLS(IPT+5)
         DAGKOL = CUKOLS(IPT+6)
         APDKOL = CUKOLS(IPT+7)
         DAPKOL = CUKOLS(IPT+8)
         REAKOL = CUKOLS(IPT+9)
         IMAKOL = CUKOLS(IPT+10)
         RATKOL = CUKOLS(IPT+11)
         DELKOL = CUKOLS(IPT+12)
         TSYKOL = CUKOLS(IPT+13)
         WEIKOL = CUKOLS(IPT+14)
         REFKOL = CUKOLS(IPT+15)
C                                       First polarization
         DO 60 LOOP = 1,NUMIF
            DOPOFF(LOOP) = RECORD(DOPKOL)
            CLKGD(1,LOOP) = RECORD(CGDKOL)
            DCLKGD(1,LOOP) = RECORD(DCGKOL)
            CLKPD(1,LOOP) = RECORD(CPDKOL)
            DCLKPD(1,LOOP) = RECORD(DCPKOL)
            ATMGD(1,LOOP) = RECORD(AGDKOL)
            DATMGD(1,LOOP) = RECORD(DAGKOL)
            ATMPD(1,LOOP) = RECORD(APDKOL)
            DATMPD(1,LOOP) = RECORD(DAPKOL)
            CREAL(1,LOOP) = RECORD(REAKOL)
            CIMAG(1,LOOP) = RECORD(IMAKOL)
            DELAY(1,LOOP) = RECORD(DELKOL)
            RATE(1,LOOP) = RECORD(RATKOL)
            TSYS(1,LOOP) = RECORD(TSYKOL)
            WEIGHT(1,LOOP) = RECORD(WEIKOL)
            REFA(1,LOOP) = RECI(REFKOL)
            IF (LOOP.GE.NUMIF) GO TO 60
               DOPKOL = DOPKOL+1
               CGDKOL = CGDKOL+1
               DCGKOL = DCGKOL+1
               CPDKOL = CPDKOL+1
               DCPKOL = DCPKOL+1
               AGDKOL = AGDKOL+1
               DAGKOL = DAGKOL+1
               APDKOL = APDKOL+1
               DAPKOL = DAPKOL+1
               REAKOL = REAKOL+1
               IMAKOL = IMAKOL+1
               DELKOL = DELKOL+1
               RATKOL = RATKOL+1
               TSYKOL = TSYKOL+1
               WEIKOL = WEIKOL+1
               REFKOL = REFKOL+1
 60         CONTINUE
         IF (NUMPOL.LT.2) GO TO 999
C                                       Two polarizations
C                                       Setup for looping over IF
            CGDKOL = CUKOLS(IPT+16)
            DCGKOL = CUKOLS(IPT+17)
            CPDKOL = CUKOLS(IPT+18)
            DCPKOL = CUKOLS(IPT+19)
            AGDKOL = CUKOLS(IPT+20)
            DAGKOL = CUKOLS(IPT+21)
            APDKOL = CUKOLS(IPT+22)
            DAPKOL = CUKOLS(IPT+23)
            REAKOL = CUKOLS(IPT+24)
            IMAKOL = CUKOLS(IPT+25)
            RATKOL = CUKOLS(IPT+26)
            DELKOL = CUKOLS(IPT+27)
            TSYKOL = CUKOLS(IPT+28)
            WEIKOL = CUKOLS(IPT+29)
            REFKOL = CUKOLS(IPT+30)
            DO 70 LOOP = 1,NUMIF
               CLKGD(2,LOOP) = RECORD(CGDKOL)
               DCLKGD(2,LOOP) = RECORD(DCGKOL)
               CLKPD(2,LOOP) = RECORD(CPDKOL)
               DCLKPD(2,LOOP) = RECORD(DCPKOL)
               ATMGD(2,LOOP) = RECORD(AGDKOL)
               DATMGD(2,LOOP) = RECORD(DAGKOL)
               ATMPD(2,LOOP) = RECORD(APDKOL)
               DATMPD(2,LOOP) = RECORD(DAPKOL)
               CREAL(2,LOOP) = RECORD(REAKOL)
               CIMAG(2,LOOP) = RECORD(IMAKOL)
               DELAY(2,LOOP) = RECORD(DELKOL)
               RATE(2,LOOP) = RECORD(RATKOL)
               TSYS(2,LOOP) = RECORD(TSYKOL)
               WEIGHT(2,LOOP) = RECORD(WEIKOL)
               REFA(2,LOOP) = RECI(REFKOL)
               IF (LOOP.GE.NUMIF) GO TO 70
                  CGDKOL = CGDKOL+1
                  DCGKOL = DCGKOL+1
                  CPDKOL = CPDKOL+1
                  DCPKOL = DCPKOL+1
                  AGDKOL = AGDKOL+1
                  DAGKOL = DAGKOL+1
                  APDKOL = APDKOL+1
                  DAPKOL = DAPKOL+1
                  REAKOL = REAKOL+1
                  IMAKOL = IMAKOL+1
                  DELKOL = DELKOL+1
                  RATKOL = RATKOL+1
                  TSYKOL = TSYKOL+1
                  WEIKOL = WEIKOL+1
                  REFKOL = REFKOL+1
 70               CONTINUE
            GO TO 999
C                                       Close
 800  CALL TABIO ('CLOS', 0, ICLRNO, RECI, BUFFER, IRET)
      IF (IRET.GT.0) GO TO 990
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1800) IRET
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1800 FORMAT ('TABCU: TABIO ERROR',I3)
      END
      SUBROUTINE BUINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IBPRNO, BPKOLS, BPNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ, BCHAN,
     *   IRET)
C-----------------------------------------------------------------------
C   Creates and initializes UNbandpass (BU) extension tables. Slightly
C   modified from BPINI for AT data.
C   Inputs:
C     OPCODE       C*4 Operation code:
C                      'WRIT' = create/init for write or read
C                      'READ' = open for read only
C     DISK         I   Disk to use.
C     CNO          I   Catalog slot number
C     VER          I   BL file version
C     CATBLK(256)  I   Catalog header block.
C     LUN          I   Logical unit number to use
C   Input/output
C     NUMANT       I    Number of antennas
C     NUMPOL       I    Number of polarizations.
C     NUMIF        I    Number of IFs
C     NUMFRQ       I    Number of frequency channels
C     BCHAN        I    Start channel number
C   Output:
C     BUFFER   I(512)   I/O buffer and related storage, also defines
C                       file if open.
C     IBPRNO       I   Next scan number, start of the file if 'READ',
C                      the last+1 if WRITE
C     BPKOLS(MAXBPC) I   The column pointer array in order:
C                        TIME, INTERVAL, SOURID,
C                        SUBARRAY, ANTENNA,
C                        BANDW (of individual channel), IFFREQ,
C                        FREQ. ID,
C                        REFANT1, REAL1, IMAG1,
C                        Following used if 2 polarizations per IF
C                        REFANT2, REAL2, IMAG2.
C     BPNUMV(MAXBPC) I   Element count in each column.
C     IRET         I   Return error code, 0=>OK, else TABINI or TABIO
C                      error.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH HOLTMP(14)
      CHARACTER OPCODE*4, TTITLE*56, TITLE(MAXBPC)*24, UNITS(MAXBPC)*8,
     *   KEYW(5)*8, ATITLE(MAXBPC)*24
      INTEGER   BUFFER(*), DISK, CNO, VER, CATBLK(256), LUN, IRET, J,
     *   NKEY, NREC, DATP(128,2), NCOL, BPKOLS(MAXBPC), BPNUMV(MAXBPC),
     *   NTT, DTYP(MAXBPC), NDATA, KLOCS(5), KEYVAL(5), KEYTYP(5),
     *   IPOINT, NUMANT, NUMPOL, NUMIF, NUMFRQ, BCHAN, ITMP(14)
      LOGICAL   T, F, DOREAD, NEWFIL
      INTEGER   IBPRNO, I
      EQUIVALENCE (HOLTMP, ITMP)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA NTT /56/
      DATA TTITLE /'AIPS UV DATA FILE BANDPASS TABLE            '/
      DATA DTYP /11, 12, 3*14, 12, 1, 14, 14, 3*2, 14, 3*2/
      DATA TITLE /'TIME ', 'INTERVAL ', 'SOURCE ID ', 'SUBARRAY ',
     *   'ANTENNA ', 'BANDWIDTH ', 'IF FREQ ', 'FREQ ID ',
     *   'REFANT 1 ', 'WEIGHT 1', 'REAL 1 ', 'IMAG 1 ',
     *   'REFANT 2 ', 'WEIGHT 2', 'REAL 2 ', 'IMAG 2 '/
      DATA KEYW /'NO_ANT', 'NO_POL', 'NO_IF', 'NO_CHAN', 'STRT_CHN'/
      DATA UNITS /'DAYS ', 'DAYS ',3*' ','HZ ','HZ ',9*' '/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NREC = 500
      NCOL = 8 + NUMPOL * 4
      IF (DOREAD) NCOL = 0
      NKEY = 5
      NEWFIL = F
      NDATA = MAXBPC
      CALL FILL (NDATA, 0, BPKOLS)
      CALL FILL (NDATA, 0, BPNUMV)
C                                       Fill in types
      CALL COPY (NDATA, DTYP, DATP(1,2))
C                                       IF freq. type
      DATP(7,2) = DTYP(7) + 10*NUMIF
C                                       Correct for real/imag
      DATP(10,2) = DTYP(10) + 10*NUMIF
      DATP(11,2) = DTYP(11) + 10*NUMFRQ*NUMIF
      DATP(12,2) = DTYP(12) + 10*NUMFRQ*NUMIF
      DATP(14,2) = DTYP(14) + 10*NUMIF
      DATP(15,2) = DTYP(15) + 10*NUMFRQ*NUMIF
      DATP(16,2) = DTYP(16) + 10*NUMFRQ*NUMIF
C                                       Create/open file
      CALL TABINI (OPCODE, 'BP', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IRET)
      IF (IRET.GT.0) GO TO 990
      NKEY = 5
C                                       See if file exists.
      IF (IRET.EQ.0) GO TO 100
      NEWFIL = T
C                                       File created, initialize
         DO 40 I = 1,NCOL
C                                       Col. labels.
            CALL CHR2H (24, TITLE(I), 1, HOLTMP)
            CALL TABIO ('WRIT', 3, I, ITMP, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 990
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, HOLTMP)
            CALL TABIO ('WRIT', 4, I, ITMP, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 990
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, HOLTMP)
         CALL COPY (14, ITMP, BUFFER(101))
C                                       Get number of scans
 100  IBPRNO = BUFFER(5)
C                                       Set IBPRNO
      IBPRNO = IBPRNO + 1
      IF (DOREAD) IBPRNO = 1
C                                       Read/write keywords
C                                       Set keyword values
      IF (.NOT.DOREAD) THEN
C                                       No. antennas.
         KLOCS(1) = 1
         KEYTYP(1) = 4
         KEYVAL(1) = NUMANT
C                                       No. Polarizations
         KLOCS(2) = 2
         KEYTYP(2) = 4
         KEYVAL(2) = NUMPOL
C                                       No. IFs
         KLOCS(3) = 3
         KEYTYP(3) = 4
         KEYVAL(3) = NUMIF
C                                       No. CHAN
         KLOCS(4) = 4
         KEYTYP(4) = 4
         KEYVAL(4) = NUMFRQ
C                                       Start CHAN
         KLOCS(5) = 5
         KEYTYP(5) = 4
         KEYVAL(5) = BCHAN
         END IF
C                                       Only write if just created.
      IF (NEWFIL) THEN
         CALL TABKEY (OPCODE, KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IRET)
         IF ((IRET.GE.1) .AND. (IRET.LE.20)) GO TO 990
         END IF
C                                       Read keywords
      CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *   IRET)
      IF ((IRET.GE.1) .AND. (IRET.LE.20)) GO TO 990
C                                       Retrieve keyword values
C                                       No. antennas.
      IPOINT = KLOCS(1)
      IF (IPOINT.GT.0) NUMANT = KEYVAL(IPOINT)
C                                       No. polarizations
      IPOINT = KLOCS(2)
      IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. IFs
      IPOINT = KLOCS(3)
      IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       No. CHAN
      IPOINT = KLOCS(4)
      IF (IPOINT.GT.0) NUMFRQ = KEYVAL(IPOINT)
C                                       Start chan
      IPOINT = KLOCS(5)
      IF (IPOINT.GT.0) BCHAN = KEYVAL(IPOINT)
C                                       Get array indices
      IF ((NEWFIL) .OR. (NCOL.EQ.NDATA)) THEN
         DO 120 I = 1,NDATA
            BPKOLS(I) = DATP(I,1)
            BPNUMV(I) = DATP(I,2) / 10
 120        CONTINUE
C                                       some are missing
      ELSE
C                                       read column labels
         DO 130 J = 1,NCOL
            CALL TABIO ('READ', 3, J, ITMP, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 990
            CALL H2CHR (24, 1, HOLTMP, ATITLE(J))
 130        CONTINUE
         DO 150 I = 1,NDATA
            DO 140 J = 1,NCOL
               IF (ATITLE(J).EQ.TITLE(I)) THEN
                  BPKOLS(I) = DATP(J,1)
                  BPNUMV(I) = DATP(J,2) / 10
                  GO TO 150
                  END IF
 140           CONTINUE
 150        CONTINUE
         END IF
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1150) OPCODE
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1150 FORMAT ('BUINI: ERROR INITIALIZING BANDPASS TABLE FOR ',A)
      END
      SUBROUTINE TABBU (OPCODE, BUFFER, IBPRNO, BPKOLS, BPNUMV, NUMIF,
     *   NUMFRQ, NUMPOL, TIME, INTERV, SOURID, SUBA, ANT, BANDW, IFFREQ,
     *   FREQID, REFANT, WEIGHT, BNDPAS, IRET)
C-----------------------------------------------------------------------
C   Does I/O to bandpass (BU) extention tables. Usually used after
C   setup by BUINI.
C   Inputs:
C     OPCODE       C*4 Operation code:
C                      'READ' = read entry from table.
C                      'WRIT' = write entry in table.
C                      'CLOS' = close file, flush on write
C     IBPRNO       I   Next entry number to read or write.
C     BPKOLS(MAXBPC) I   The column pointer array in order,
C                        TIME, INTERVAL, SOURID,
C                        SUBARRAY, ANTENNA,
C                        BANDW (of individual channel), IFREQ, FREQID,
C                        REFANT1, REAL1, IMAG1, .. etc for all channels
C                        Following used if 2 polarizations per IF
C                        REFANT2, REAL2, IMAG2.
C     BPNUMV(MAXBPC) I   Element count in each column.
C     NUMIF        I   Number of IF's
C     NUMFRQ       I   Number of chns
C     NUMPOL       I   Number of polarizations per IF.
C    Input/output: (written to or read from baseline file)
C     BUFFER(512)  I   I/O buffer and related storage, also defines file
C                      if open. Should have been returned by BPINI or
C                      TABINI.
C     TIME         D   Center time of record (Days)
C     INTERV       R   Time interval of record (Days)
C     SOURID       I   Source ID number.
C     SUBA         I   Subarray number.
C     ANT          I   Antenna number.
C     BANDW        R   Bandwidth of an individual channel (Hz)
C     IFFREQ(m)    D   Reference frequency for each IF (Hz)
C     FREQID       I   Freq. id number
C     REFANT(2)    I   Reference Antenna; one for each poln
C     WEIGHT(m,2)  R   Weights (IFs, polns)
C     BNDPAS(n,m,2) C  Complex bandpass: n channels; m IFS; 2 polns
C    Output:
C     IBPRNO       I   Next solution number.
C     IRET         I   Error code, 0=>OK else TABIO error.
C                      Note: -1=> read but polzn #1 flagged
C                            -2=> read but polzn #2 flagged
C                            -3=> both flagged
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER OPCODE*4
      INTEGER   BUFFER(*), BPKOLS(MAXBPC), BPNUMV(MAXBPC), NUMPOL, IRET,
     *   SOURID, ANT, SUBA,  RECI(XBPRSZ), KOLS(MAXBPC), NUMIF, NUMFRQ,
     *   TIMKOL, SOUKOL, SUBKOL, ANTKL, INTKOL, BWKOL, IFKOL, FRQKOL,
     *   REF1KL, REF2KL, RE1KL, IM1KL, RE2KL, IM2KL, REFANT(2), LOOP,
     *   IFLP, IBPRNO, FREQID, NDATA, INDX, NNDX, BDCNT1, BDCNT2,
     *   WT1KL, WT2KL
      REAL      INTERV, RECORD(XBPRSZ), BNDPAS(2,*), WEIGHT(*), BANDW,
     *   WT
      DOUBLE PRECISION TIME, IFFREQ(MAXIF), RECD(XBPRSZ/2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (KOLS(1), TIMKOL), (KOLS(2), INTKOL),
     *   (KOLS(3), SOUKOL), (KOLS(4), SUBKOL), (KOLS(5), ANTKL),
     *   (KOLS(6), BWKOL),  (KOLS(7), IFKOL), (KOLS(8), FRQKOL),
     *   (KOLS(9), REF1KL), (KOLS(10), WT1KL),  (KOLS(11), RE1KL),
     *   (KOLS(12), IM1KL), (KOLS(13), REF2KL), (KOLS(14), WT2KL),
     *   (KOLS(15),RE2KL), (KOLS(16),IM2KL)
      EQUIVALENCE (RECD, RECORD, RECI)
C-----------------------------------------------------------------------
      BDCNT1 = 0
      BDCNT2 = 0
      NDATA = MAXBPC
C                                       Branch for CLOS
C                                       Close
      IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, IBPRNO, RECI, BUFFER, IRET)
         IF (IRET.GT.0) GO TO 990
         GO TO 999
         END IF
C                                       Set pointers
      CALL COPY (NDATA, BPKOLS, KOLS)
C                                       If write fill RECORD
      NNDX = NUMFRQ * NUMIF
      IF (OPCODE.NE.'READ') THEN
         RECD(TIMKOL) = TIME
         RECORD(INTKOL) = INTERV
         RECI(SOUKOL) = SOURID
         RECI(SUBKOL) = SUBA
         RECI(ANTKL) = ANT
         RECORD(BWKOL) = BANDW
         DO 10 IFLP = 1,NUMIF
            RECD(IFKOL) = IFFREQ(IFLP)
            IFKOL = IFKOL + 1
            IF (WT1KL.GT.0) THEN
               RECORD(WT1KL) = WEIGHT(IFLP)
               WT1KL = WT1KL + 1
               END IF
            IF (NUMPOL.GT.1) THEN
               IF (WT2KL.GT.0) THEN
                  RECORD(WT2KL) = WEIGHT(IFLP+NUMIF)
                  WT2KL = WT2KL + 1
                  END IF
               END IF
 10         CONTINUE
         IF (FRQKOL.GT.0) RECI(FRQKOL) = FREQID
         RECI(REF1KL) = REFANT(1)
C                                       First polarization
         INDX = 0
         DO 20 LOOP = 1,NNDX
            INDX = INDX + 1
            RECORD(RE1KL) = BNDPAS(1,INDX)
            RECORD(IM1KL) = BNDPAS(2,INDX)
            RE1KL = RE1KL + 1
            IM1KL = IM1KL + 1
 20         CONTINUE
         IF (NUMPOL.GT.1) THEN
            RECI(REF2KL) = REFANT(2)
            DO 30 LOOP = 1,NNDX
               INDX = INDX + 1
               RECORD(RE2KL) = BNDPAS(1,INDX)
               RECORD(IM2KL) = BNDPAS(2,INDX)
               RE2KL = RE2KL + 1
               IM2KL = IM2KL + 1
 30            CONTINUE
            END IF
         END IF
C                                       Process record.
 60   CALL TABIO (OPCODE, 0, IBPRNO, RECI, BUFFER, IRET)
      IBPRNO = IBPRNO + 1
      IF (IRET.GT.0) GO TO 990
      IF (IRET.LT.0) GO TO 60
C                                       If READ pick data from RECORD.
      IF (OPCODE.EQ.'READ') THEN
         TIME      = RECD(TIMKOL)
         INTERV   = RECORD(INTKOL)
         SOURID    = RECI(SOUKOL)
         SUBA      = RECI(SUBKOL)
         ANT       = RECI(ANTKL)
         BANDW     = RECORD(BWKOL)
         WT = INTERV * 24. * 60. * 6.
         DO 70 IFLP = 1,NUMIF
            IFFREQ(IFLP) = RECD(IFKOL)
            IFKOL = IFKOL + 1
            IF (WT1KL.GT.0) THEN
               WEIGHT(IFLP) = RECORD(WT1KL)
               WT1KL = WT1KL + 1
            ELSE
               WEIGHT(IFLP) = WT
               END IF
            IF (NUMPOL.GT.1) THEN
               IF (WT2KL.GT.0) THEN
                  WEIGHT(IFLP+NUMIF) = RECORD(WT2KL)
                  WT2KL = WT2KL + 1
               ELSE
                  WEIGHT(IFLP+NUMIF) = WT
                  END IF
               END IF
 70         CONTINUE
         IF (FRQKOL.LE.0) THEN
            FREQID = 1
         ELSE
            FREQID = RECI(FRQKOL)
            END IF
         REFANT(1) = RECI(REF1KL)
C                                       First polarization
         INDX = 0
         DO 80 LOOP = 1,NNDX
            INDX = INDX + 1
            BNDPAS(1,INDX) = RECORD(RE1KL)
            BNDPAS(2,INDX) = RECORD(IM1KL)
            IF ((RECORD(RE1KL).EQ.FBLANK) .OR.
     *         (RECORD(IM1KL).EQ.FBLANK)) BDCNT1 = BDCNT1 + 1
            RE1KL = RE1KL + 1
            IM1KL = IM1KL + 1
 80         CONTINUE
         IF (NUMPOL.GT.1) THEN
            REFANT(2) = RECI(REF2KL)
            DO 90 LOOP = 1,NNDX
               INDX = INDX + 1
               BNDPAS(1,INDX) = RECORD(RE2KL)
               BNDPAS(2,INDX) = RECORD(IM2KL)
               IF ((RECORD(RE2KL).EQ.FBLANK) .OR.
     *             (RECORD(IM2KL).EQ.FBLANK)) BDCNT2 = BDCNT2 + 1
               RE2KL = RE2KL + 1
               IM2KL = IM2KL + 1
 90            CONTINUE
            END IF
         END IF
      IF (BDCNT1.EQ.(NUMIF*NUMFRQ)) IRET = -1
      IF (BDCNT2.EQ.(NUMIF*NUMFRQ)) IRET = -2
      IF ((BDCNT1.EQ.(NUMIF*NUMFRQ)) .AND.
     *   (BDCNT2.EQ.(NUMIF*NUMFRQ))) IRET = -3
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1800) IRET
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1800 FORMAT ('TABBU: TABIO ERROR',I3)
      END

LOCAL INCLUDE 'TYSMO.INC'
C                                                          Include TYSMO
C                                       Local include for TYSMO
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XXINTP(1), XYTYPE(1)
      REAL      XSIN, XDISIN, DOBTWN, XBAND, XFREQ, XFQID, XBIF, XEIF,
     *   XTIME(8), XANT(50), XSUBA, XFLAG, XINVER, XOUTVR, APARM(10),
     *   DOSCAL, CPARM(10), XIPARM(10), CUTOFF, XDOBLK, XBAD(10), SELBAN
      CHARACTER NAMEIN*12, CLAIN*6, XSOUR(30)*16, XINTP*4, YTYPE*2
      INTEGER   SEQIN, SUBA, DISKIN, CNOIN, TYVER, ITYIN, ITYOUT,
     *   NSOUWD, SOUWAN(30), NANTSL, ANTENS(50), BIF, EIF, FREQID,
     *   NUMAN(513), FGVER
      LOGICAL   DOSWNT, DOAWNT
      DOUBLE PRECISION FRQOFF(MAXIF), SELFRQ, TSTART, TEND
C                                       Buffers and file info
      INTEGER   XTYRSZ
      PARAMETER (XTYRSZ = 6 + 4*MAXIF)
      INTEGER   BUFFO(512), BUFFI(512), RECORD(XCLRSZ)
      REAL      RECR(XCLRSZ)
      DOUBLE PRECISION RECD(XCLRSZ/2)
      EQUIVALENCE (RECORD, RECR, RECD)
C                                       MXTIME = dim work arrays
      INTEGER   MXTIME
      PARAMETER (MXTIME = 110000)
      REAL      WRKTIM(MXTIME), WORK1(MXTIME), WORK2(MXTIME),
     *   WORK3(MXTIME), WORK4(MXTIME), WORK5(MXTIME), WORK6(MXTIME),
     *   WORK7(MXTIME), WORK8(MXTIME), WORK9(MXTIME), VSCAL1(MXTIME),
     *   VSCAL2(MXTIME), VSCAL3(MXTIME), VSCAL4(MXTIME), VSCAL5(MXTIME),
     *   VSCAL6(MXTIME), VSCAL7(MXTIME), VSCAL8(MXTIME),
     *   TCAL(4,MAXIF,MAXANT)
      INTEGER   WRKREC(MXTIME), WRKSRC(MXTIME), WRKTYP(MXTIME)
C                                       Inputs and general info
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XXSOUR, DOBTWN,
     *   XBAND, XFREQ, XFQID, XBIF, XEIF, XTIME, XANT, XSUBA, XFLAG,
     *   XYTYPE, XINVER, XOUTVR, APARM, DOSCAL, CPARM, XXINTP, XIPARM,
     *   CUTOFF, XDOBLK, XBAD
      COMMON /CINFO/ FRQOFF, SELFRQ, TSTART, TEND, DOSWNT, DOAWNT,
     *   NSOUWD, SOUWAN, NANTSL, ANTENS, BIF, EIF, FREQID, SELBAN,
     *   SEQIN, DISKIN, CNOIN, SUBA, TYVER, ITYIN, ITYOUT, NUMAN,
     *   TCAL, FGVER
      COMMON /CHRCOM/ NAMEIN, CLAIN, XSOUR, XINTP, YTYPE
C                                       Buffers and file info
      COMMON /BUFRS/ BUFFO, BUFFI, RECORD
C                                       Align WRK* in memory
      COMMON /XXYYZZ/ WRKTIM, WORK1, WORK2, WORK3, WORK4, WORK5,
     *   WORK6, WORK7, WORK8, WORK9, WRKREC, WRKSRC, WRKTYP, VSCAL1,
     *   VSCAL2, VSCAL3, VSCAL4, VSCAL5, VSCAL6, VSCAL7, VSCAL8
C                                                          End TYSMO
LOCAL END
      PROGRAM TYSMO
C-----------------------------------------------------------------------
C! Smooths a TY or SY table
C# UV Calibration EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2007, 2010-2012, 2014-2017, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task TYSMO smooths a TY table.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'TYSMO.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'TYSMO '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL TYSMIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Clip
      CALL TYCLIP (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Smooth
      CALL TYSMOO (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Copy and update HI file.
      CALL TYSMHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFFO)
C
 999  STOP
      END
      SUBROUTINE TYSMIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   TYSMIN gets input parameters for TYSMO.
C   Inputs:
C      PRGN   C*6   Program name
C   Output:
C      JERR   I     Error code: 0 => ok
C                               1 => Invalid request
C                               5 => catalog troubles
C                               8 => can't start
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   JERR
C
      CHARACTER STAT*4, UTYPE*2
      LOGICAL   T, F, ALLANT, DESEL, MATCH, WTABLE, WEXIST, WFITS
      INTEGER   NPARM, IERR, I, NEXT, IARG, LIMIT, J, IROUND, LUN,
     *   LUN2, IIVER, NUMIF, ITY, ISY
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   DUMMY(MAXIF)
      REAL      FINC(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'TYSMO.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA LUN /29/, LUN2 /31/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 240
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFFO, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFFO, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      SUBA = XSUBA + 0.5
      ITYIN = MAX (IROUND (XINVER), 0)
      ITYOUT = MAX (IROUND (XOUTVR), 0)
      DO 20 I = 1,10
         IBAD(I) = IROUND (XBAD(I))
 20      CONTINUE
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XXINTP, XINTP)
      DO 25 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
 25      CONTINUE
      CALL H2CHR (2, 1, XYTYPE, YTYPE)
C                                       Find file, read CATBLK
      CNOIN = 1
      STAT = 'SRCH'
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFFO, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK, mark "WRIT"
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'WRIT', BUFFO, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Register in DFIL.INC
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       flagver
      CALL FNDEXT ('FG', CATBLK, I)
      J = IROUND (XFLAG)
      IF (J.EQ.0) J = I
      FGVER = J
      IF ((XFLAG.LT.0.0) .OR. (J.LE.0)) FGVER = 0
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FREQID = IROUND (XFQID)
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FREQID, JERR)
C                                       No match
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1070)
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       antenna count
      CALL GETNAN (DISKIN, CNOIN, CATBLK, LUN, WRKTIM, NUMAN, JERR)
      IF (JERR.NE.0) GO TO 999
C                                       IF range
      BIF = IROUND (XBIF)
      EIF = IROUND (XEIF)
      IF (BIF.LE.0) BIF = 1
      IF ((EIF.LE.0) .AND. (JLOCIF.GT.0)) EIF = CATBLK(KINAX+JLOCIF)
      IF (EIF.LE.0) EIF = 1
      IF ((JLOCIF.GT.0) .AND. (BIF.GT.CATBLK(KINAX+JLOCIF)))
     *   BIF = CATBLK(KINAX+JLOCIF)
      IF ((JLOCIF.GT.0) .AND. (EIF.GT.CATBLK(KINAX+JLOCIF)))
     *   EIF = CATBLK(KINAX+JLOCIF)
      JERR = 0
C                                       Antenna list
      ALLANT = T
      NANTSL = 0
      DESEL = F
      DO 100 I = 1,50
         ANTENS(I) = 0
         ALLANT = ALLANT .AND. (ABS (XANT(I)).LE.1.0E-10)
         DESEL = DESEL .OR. (XANT(I).LT.-0.5)
 100     CONTINUE
      NEXT = 1
C                                       Not all selected - make list
C                                       ANTENNAS array.
      IF (.NOT.ALLANT) THEN
         DO 150 I = 1,50
            IARG = ABS (XANT(I)) + 0.5
C                                       See if already have
            IF (IARG.NE.0) THEN
               LIMIT = NEXT - 1
               IF (LIMIT.GE.1) THEN
                  DO 130 J = 1,LIMIT
                     IF (IARG.EQ.ANTENS(J)) GO TO 150
 130                 CONTINUE
                  END IF
C                                       New antenna
               ANTENS(NEXT) = IARG
               NEXT = NEXT + 1
               END IF
 150        CONTINUE
         END IF
      DOAWNT = .NOT. DESEL
      NANTSL = NEXT - 1
C                                       Get source numbers.
C                                       Check if single-source file.
      CALL ISTAB ('SU', DISKIN, CNOIN, 1, LUN, BUFFO, WTABLE, WEXIST,
     *   WFITS, JERR)
      IF ((JERR.EQ.0).AND.WEXIST.AND.WTABLE) THEN
         CALL FNDSOU (DISKIN, CNOIN, XSOUR, BUFFO, NSOUWD, DOSWNT,
     *      SOUWAN, JERR)
         IF (JERR.NE.0) GO TO 999
      ELSE
         NSOUWD = 0
         END IF
C                                       Get IF information
      IIVER = 1
      CALL CHNDAT ('READ', BUFFO, DISKIN, CNOIN, IIVER, CATBLK, LUN,
     *   NUMIF, FRQOFF, DUMMY, FINC, BNDCOD, FREQID, JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Timerange
      TSTART = XTIME(1) + XTIME(2) / 24.0D0 + XTIME(3) / (24.0D0*60.0D0)
     *   + (XTIME(4) / (24.0D0*60.0D0*60.0D0))
      TEND = XTIME(5) + XTIME(6) / 24.0D0 + XTIME(7) / (24.0D0*60.0D0) +
     *   (XTIME(8) / (24.0D0*60.0D0*60.0D0))
      IF ((TEND.LT.TSTART) .OR. (TEND.LT.1.0D-5)) TEND = 1.0D20
C                                       scaling not used
      IF (DOSCAL.LE.0.0) THEN
         CALL RFILL (MXTIME, 1.0, VSCAL1)
         CALL RFILL (MXTIME, 1.0, VSCAL2)
         CALL RFILL (MXTIME, 1.0, VSCAL3)
         CALL RFILL (MXTIME, 1.0, VSCAL4)
         CALL RFILL (MXTIME, 1.0, VSCAL5)
         CALL RFILL (MXTIME, 1.0, VSCAL6)
         CALL RFILL (MXTIME, 1.0, VSCAL7)
         CALL RFILL (MXTIME, 1.0, VSCAL8)
         END IF
C                                       which type
      CALL FNDEXT ('TY', CATBLK, ITY)
      CALL FNDEXT ('SY', CATBLK, ISY)
      IF (YTYPE.EQ.'TY') THEN
         IF (ITY.LE.0) THEN
            MSGTXT = 'REQUESTED TY TABLE TYPE NOT FOUND IN DATA'
            JERR = 10
            GO TO 990
            END IF
         IF (ITYIN.LE.0) ITYIN = ITY
      ELSE IF (YTYPE.EQ.'SY') THEN
         IF (ISY.LE.0) THEN
            MSGTXT = 'REQUESTED SY TABLE TYPE NOT FOUND IN DATA'
            JERR = 10
            GO TO 990
            END IF
         IF (ITYIN.LE.0) ITYIN = ISY
      ELSE
         IF ((ISY.GT.0) .AND. (ITY.GT.0)) THEN
            MSGTXT = 'BOTH TY AND SY FOUND: SPECIFY INEXT'
            JERR = 10
            GO TO 990
         ELSE IF (ISY.GT.0) THEN
            YTYPE = 'SY'
            IF (ITYIN.LE.0) ITYIN = ISY
         ELSE IF (ITY.GT.0) THEN
            YTYPE = 'TY'
            IF (ITYIN.LE.0) ITYIN = ITY
         ELSE
            MSGTXT = 'NEITHER TY NOR SY FOUND IN DATA'
            JERR = 10
            GO TO 990
            END IF
         END IF
C                                       Copy input TY table version
C                                       to output version. Smoothing
C                                       is carried out on the output
C                                       table in place.
      TYVER = ITYOUT
      IF ((ITYIN.NE.ITYOUT) .AND. (FGVER.LE.0)) THEN
         CALL TABCOP (YTYPE, ITYIN, ITYOUT, LUN, LUN2, DISKIN, DISKIN,
     *      CNOIN, CNOIN, CATBLK, BUFFO, BUFFI, JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1200) JERR, 'TABCOP'
            GO TO 990
            END IF
C                                       copy and flag
      ELSE IF (FGVER.GT.0) THEN
         CALL TYFLAG (LUN, LUN2, JERR)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TYSMIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
 1200 FORMAT ('TYSMIN: ERROR',I4,' RETURNED BY ',A)
      END
      SUBROUTINE TYCLIP (IERR)
C-----------------------------------------------------------------------
C   Clips selected portions of TY tables.
C   Leaves the output table sorted in antenna-time order.
C   Inputs from common:
C      TYVER        I    Cal (TY) file version number.
C      TSTART       R    First time to process (days) (no default)
C      TEND         R    Last time to process (days) (no default)
C   Output:
C      IERR         I    Return code, 0=>OK, otherwise failed.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER  COLHED(2)*24
      INTEGER   IRET, KEY(2,2), ICLUN, TYANT, TYTIM, ITYRNO,  NKEY, I,
     *   KOLS(2), TYNUMV(MAXSYC), TYKOLS(MAXSYC), NUMPOL, NUMIF, SUB,
     *   TYPKOL, NUMSUB, TIMKOL, SOUKOL, ANTKOL, SUBKOL, FRQKOL, TA1KOL,
     *   TS1KOL, TG1KOL, TA2KOL, TS2KOL, TG2KOL, NUMANT, J, KEYSUB(2,2)
      LOGICAL   T, DOTSYS, DOTANT, DOTRAT, DOTGAI
      REAL      FKEY(2,2), STTSYS(3), STTANT(3), MXTSYS, MXTANT,
     *   MNXSYS(2), MNXANT(2), MNXRAT(2), STTRAT(3), MXTRAT, MNXGAI(2),
     *   STTGAI(3), MXTGAI
      INCLUDE 'TYSMO.INC'
      INCLUDE 'INCS:PTYTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
      DATA COLHED /'TIME ', 'ANTENNA NO. '/
      DATA T /.TRUE./
      DATA ICLUN /30/
C-----------------------------------------------------------------------
      IERR = 0
C                                       Sort TY table to antenna-time.
C                                       Need col. pointers, sort order.
      IF (YTYPE.EQ.'TY') THEN
         CALL TYINI ('READ', BUFFO, DISKIN, CNOIN, TYVER, CATBLK,
     *      ICLUN, ITYRNO, TYKOLS, TYNUMV, NUMPOL, NUMIF, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Get column pointers
         NKEY = 2
         CALL FNDCOL (NKEY, COLHED, 24, T, BUFFO, KOLS, IRET)
         IF ((IRET.GE.1) .AND. (IRET.LE.10)) GO TO 999
         IRET = 0
         TYTIM = KOLS(1)
         TYANT = KOLS(2)
         TYPKOL = -1
         TIMKOL = TYKOLS(TYRTIM)
         SOUKOL = TYKOLS(TYISID)
         ANTKOL = TYKOLS(TYIANT)
         SUBKOL = TYKOLS(TYISUB)
         FRQKOL = TYKOLS(TYIFQI)
         TS1KOL = TYKOLS(TYRTS1)
         TA1KOL = TYKOLS(TYRTA1)
         IF (NUMPOL.GT.1) THEN
            TS2KOL = TYKOLS(TYRTS2)
            TA2KOL = TYKOLS(TYRTA2)
         ELSE
            TS2KOL = -1000
            TA2KOL = -1000
            END IF
C                                       SY table
      ELSE
         CALL SYINI ('READ', BUFFO, DISKIN, CNOIN, TYVER, CATBLK,
     *      ICLUN, ITYRNO, TYKOLS, TYNUMV, NUMANT, NUMPOL, NUMIF, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Get column pointers
         NKEY = 2
         CALL FNDCOL (NKEY, COLHED, 24, T, BUFFO, KOLS, IRET)
         IF ((IRET.GE.1) .AND. (IRET.LE.10)) GO TO 999
         IRET = 0
         TYTIM = KOLS(1)
         TYANT = KOLS(2)
         TIMKOL = TYKOLS(1)
         TYPKOL = TYKOLS(3)
         SOUKOL = TYKOLS(4)
         ANTKOL = TYKOLS(5)
         SUBKOL = TYKOLS(6)
         FRQKOL = TYKOLS(7)
         TS1KOL = TYKOLS(8)
         TA1KOL = TYKOLS(9)
         TG1KOL = TYKOLS(10)
         IF (NUMPOL.GT.1) THEN
            TS2KOL = TYKOLS(11)
            TA2KOL = TYKOLS(12)
            TG2KOL = TYKOLS(13)
         ELSE
            TS2KOL = -1000
            TA2KOL = -1000
            TG2KOL = -1000
            END IF
         END IF
C                                       Close table
      CALL TABIO ('CLOS', 0, ITYRNO, BUFFO, BUFFO, IERR)
      IF ((IERR.NE.0) .OR. (IRET.NE.0)) GO TO 999
      KEY(1,1) = TYANT
      KEY(1,2) = TYTIM
      KEY(2,1) = 0
      KEY(2,2) = 0
C                                       Sort to antenna time order.
      IF (((BUFFO(43).NE.TYANT) .OR. (BUFFO(44).NE.TYTIM))) THEN
         CALL TABSRT (DISKIN, CNOIN, YTYPE, TYVER, TYVER, KEY, KEYSUB,
     *      FKEY, BUFFO, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Reopen write
      IF (YTYPE.EQ.'TY') THEN
         CALL TYINI ('WRIT', BUFFO, DISKIN, CNOIN, TYVER, CATBLK,
     *      ICLUN, ITYRNO, TYKOLS, TYNUMV, NUMPOL, NUMIF, IRET)
      ELSE
         CALL SYINI ('WRIT', BUFFO, DISKIN, CNOIN, TYVER, CATBLK,
     *      ICLUN, ITYRNO, TYKOLS, TYNUMV, NUMANT, NUMPOL, NUMIF, IRET)
         END IF
      IF (IRET.NE.0) GO TO 999
C                                       Find number of subarrays.
      CALL FNDEXT ('AN', CATBLK, NUMSUB)
      NUMSUB = MAX (NUMSUB, 1)
C                                       Determine smoothing parameters.
      MNXSYS(1) = APARM(1)
      MNXSYS(2) = APARM(6)
      IF (MNXSYS(2).LE.MNXSYS(1)) MNXSYS(2) = 99999.
      MNXANT(1) = APARM(2)
      MNXANT(2) = APARM(7)
      IF (MNXANT(2).LE.MNXANT(1)) MNXANT(2) = 99999.
      IF (YTYPE.EQ.'SY') THEN
         MNXRAT(1) = APARM(3)
         MNXRAT(2) = APARM(8)
         MNXGAI(1) = APARM(4)
         MNXGAI(2) = APARM(9)
      ELSE
         MNXRAT(1) = 0.0
         MNXRAT(2) = 0.0
         MNXGAI(1) = 0.0
         MNXGAI(2) = 0.0
         END IF
      IF (MNXRAT(2).LE.MNXRAT(1)) MNXRAT(2) = 99999.
      IF (MNXGAI(2).LE.MNXGAI(1)) MNXGAI(2) = 99999.
      APARM(6) = MNXSYS(2)
      APARM(7) = MNXANT(2)
      APARM(8) = MNXRAT(2)
      APARM(9) = MNXGAI(2)
      STTSYS(1) = CPARM(1) / 1440.0
      STTANT(1) = CPARM(2) / 1440.0
      STTRAT(1) = CPARM(3) / 1440.0
      STTGAI(1) = CPARM(4) / 1440.0
      MXTSYS = ABS (CPARM(6))
      MXTANT = ABS (CPARM(7))
      MXTRAT = ABS (CPARM(8))
      MXTGAI = ABS (CPARM(8))
      DOTSYS =  (MXTSYS.GE.1.0E-10) .OR. (MNXSYS(1).GT.0.0) .OR.
     *   (MNXSYS(2).LT.99999.)
      DOTANT =  (MXTANT.GE.1.0E-10) .OR. (MNXANT(1).GT.0.0) .OR.
     *   (MNXANT(2).LT.99999.)
      DOTRAT =  (MXTRAT.GE.1.0E-10) .OR. (MNXRAT(1).GT.0.0) .OR.
     *   (MNXRAT(2).LT.99999.)
      DOTGAI =  (MXTGAI.GE.1.0E-10) .OR. (MNXGAI(1).GT.0.0) .OR.
     *   (MNXGAI(2).LT.99999.)
      DOTRAT =  (DOTRAT) .AND. (YTYPE.EQ.'SY')
      DOTGAI =  (DOTGAI) .AND. (YTYPE.EQ.'SY')
      IF (MXTSYS.LT.1.0E-10) MXTSYS = 1.0E20
      IF (MXTANT.LT.1.0E-10) MXTANT = 1.0E20
      IF (MXTRAT.LT.1.0E-10) MXTRAT = 1.0E20
      IF (MXTGAI.LT.1.0E-10) MXTGAI = 1.0E20
C                                       Inform user of smoothing:
      IF ((DOTSYS) .OR. (DOTANT) .OR. (DOTRAT) .OR. (DOTGAI)) THEN
         MSGTXT ='TYSMTH: Clipping ' // YTYPE // ' table'
         CALL MSGWRT (4)
C                                       Loop over subarrays
         DO 200 SUB = 1,NUMSUB
C                                       Want this subarray?
            IF ((SUBA.LE.0) .OR. (SUB.EQ.SUBA)) THEN
C                                       If SY, need CalDevice values
               IF (YTYPE.EQ.'SY') THEN
                  J = 0
                  CALL GETCDS (DISKIN, CNOIN, J, SUB, FREQID, CATBLK,
     *               TCAL, IRET)
                  IF (IRET.NE.0) GO TO 999
                  END IF
C                                       Clip TY/SY
               DO 100 I = BIF,EIF
                  CALL CLPTY (MNXSYS, MNXANT, MNXRAT, MNXGAI, STTSYS,
     *               STTANT, STTRAT, STTGAI, MXTSYS, MXTANT, MXTRAT,
     *               MXTGAI, DOTSYS, DOTANT, DOTRAT, DOTGAI, SUB,
     *               NUMAN(SUB+1), TYPKOL, TIMKOL, SUBKOL, ANTKOL,
     *               SOUKOL, FRQKOL, TS1KOL+I-1, TA1KOL+I-1, TG1KOL+I-1,
     *               TS2KOL+I-1, TA2KOL+I-1, TG2KOL+I-1, I, IRET)
                  IF (IRET.NE.0) GO TO 999
 100              CONTINUE
               END IF
 200        CONTINUE
         END IF
C                                       Close table
      CALL TABIO ('CLOS', 0, ITYRNO, BUFFO, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE CLPTY (MNXSYS, MNXANT, MNXRAT, MNXGAI, STTSYS, STTANT,
     *   STTRAT, STTGAI, MXTSYS, MXTANT, MXTRAT, MXTGAI, DOTSYS, DOTANT,
     *   DOTRAT, DOTGAI, SUB, NUMANT, TYPKOL, TIMKOL, SUBKOL, ANTKOL,
     *   SOUKOL, FRQKOL, TS1KOL, TA1KOL, TG1KOL, TS2KOL, TA2KOL, TG2KOL,
     *   BEGIF, IRET)
C-----------------------------------------------------------------------
C   Routine to clip Tsys and Tant by comparison with a median window
C   filter.  All poln present and the range of IF specified by IFBEG
C   and IFEND are clipped.  The values in a single polarization are
C   averaged.
C   Inputs:
C      MNXSYS   R(2)    Min/max Tsys
C      MNXANT   R(2)    Min/max Tant
C      STTSYS   R       Tsys smoothing time (days)
C      STTANT   R       Tant smoothing time (days)
C      MXTSYS   R       Max. Tsys residual
C      MXTANT   R       Max. Tant residual (rad)
C      DOTSYS   L       Smooth Tsys
C      DOTANT   L       Smooth Tant
C      SUB      I       Desired subarray
C      NUMANT   I       Number of antennas
C      TIMKOL   I       Time column pointer.
C      SUBKOL   I       Subarray column pointer
C      ANTKOL   I       Antenna column pointer
C      FRQKOL   I       FQ id column pointer
C      SOUKOL   I       Source ID column pointer
C      TS1KOL   I       Tsys pol 1  column pointer
C      TA1KOL   I       Tant 1  column pointer
C      TS2KOL   I       Tsys pol 2 pointer <1 => not present
C      TA2KOL   I       Tant 2  column pointer <1 => not present
C      BEGIF    I       IF for display purposes only
C   Inputs from common:
C      I/O buffer etc.
C      Other data selection criteria.
C   Output:
C      IRET     I  Error code, 0=OK else failed.
C-----------------------------------------------------------------------
      REAL      MNXSYS(2), MNXANT(2), MNXRAT(2), MNXGAI(2), STTSYS(*),
     *   STTANT(*), STTRAT(*), STTGAI(*), MXTSYS, MXTANT, MXTRAT, MXTGAI
      LOGICAL   DOTSYS, DOTANT, DOTRAT, DOTGAI
      INTEGER   SUB, NUMANT, TYPKOL, TIMKOL, SUBKOL, ANTKOL, SOUKOL,
     *   FRQKOL, TS1KOL, TA1KOL, TG1KOL, TS2KOL, TA2KOL, TG2KOL, BEGIF,
     *   IRET
C
      INTEGER   LOOPR, LOOPA, IRCODE, NUMTIM, ANT, NUMREC, FSTREC,
     *   NLEFT, SAVE, ITYRNO, ITIME, NRECS, NTANT(3), NTSYS(3),
     *   NSYVAL, NTRAT(3), NTGAI(3), ITC
      LOGICAL   SLCTD, TYWANT, BAD, WANT
      REAL      DIFF, RTIME
      DOUBLE PRECISION TIMOFF
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'TYSMO.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA IRCODE /0/
C-----------------------------------------------------------------------
C                                       Get number of records in table
      NUMREC = BUFFO(5)
      IF (NUMREC.LE.0) GO TO 999
      IF ((.NOT.DOTSYS) .AND. (.NOT.DOTANT) .AND. (.NOT.DOTRAT))
     *   GO TO 999
      FSTREC = 0
      NRECS = 0
      CALL FILL (3, 0, NTANT)
      CALL FILL (3, 0, NTSYS)
      CALL FILL (3, 0, NTRAT)
      CALL FILL (3, 0, NTGAI)
      NSYVAL = 0
C                                       Loop over antenna
      DO 600 LOOPA = 1,NUMANT
         ANT = LOOPA
C                                       Want this antenna?
         IF (.NOT.SLCTD (ANT, ANTENS, NANTSL, DOAWNT)) GO TO 600
C                                       Set pointers, counters
         NUMTIM = 0
         NLEFT = NUMREC - FSTREC
C                                       Loop in time, reading
         DO 100 LOOPR = 1,NLEFT
            ITYRNO = FSTREC + LOOPR
            CALL TABIO ('READ', IRCODE, ITYRNO, RECORD, BUFFO, IRET)
            IF (IRET.LT.0) THEN
               IRET = 0
               GO TO 100
               END IF
            IF (IRET.NE.0) GO TO 900
C                                       Finished antenna?
            IF (RECORD(ANTKOL).GT.ANT) GO TO 110
            IF (YTYPE.EQ.'SY') THEN
               RTIME = RECD(TIMKOL)
            ELSE
               RTIME = RECR(TIMKOL)
               END IF
C                                       See if wanted.
            WANT = TYWANT (RECORD(SOUKOL), RECORD(FRQKOL),
     *         RECORD(ANTKOL), RECORD(SUBKOL), RTIME)
C                                       Check subarray
            WANT = WANT .AND. (RECORD(SUBKOL).EQ.SUB)
C                                       Not all antennas wanted
            WANT = WANT .AND. (RECORD(ANTKOL).EQ.ANT)
            IF (WANT) THEN
               IF (NUMTIM.EQ.MXTIME) THEN
                  MSGTXT = 'NUMBER OF TIMES EXCESSIVE, OPERATION' //
     *               ' TRUNCATED'
                  CALL MSGWRT (8)
                  END IF
               IF (NUMTIM.LT.MXTIME) THEN
                  NUMTIM = NUMTIM + 1
                  IF (NUMTIM.EQ.1) TIMOFF = RTIME
                  WRKTIM(NUMTIM) = RTIME - TIMOFF
                  WRKREC(NUMTIM) = ITYRNO
                  IF (TYPKOL.GT.0) THEN
                     WRKTYP(NUMTIM) = RECORD(TYPKOL)
                  ELSE
                     WRKTYP(NUMTIM) = 0
                     END IF
C                                       basic clipping included
                  WORK2(NUMTIM) = RECR(TS1KOL)
                  IF ((YTYPE.EQ.'TY') .AND.
     *               (ABS(WORK2(NUMTIM)-999.0).LT.0.1))
     *               WORK2(NUMTIM) = FBLANK
                  IF ((WORK2(NUMTIM).NE.FBLANK) .AND.
     *               ((WORK2(NUMTIM).LE.MNXSYS(1)) .OR.
     *               (WORK2(NUMTIM).GE.MNXSYS(2)))) WORK2(NUMTIM)=FBLANK
                  WORK4(NUMTIM) = RECR(TA1KOL)
                  IF ((YTYPE.EQ.'TY') .AND.
     *               (ABS(WORK4(NUMTIM)-999.0).LT.0.1))
     *               WORK4(NUMTIM) = FBLANK
                  IF ((WORK4(NUMTIM).NE.FBLANK) .AND.
     *               ((WORK4(NUMTIM).LE.MNXANT(1)) .OR.
     *               (WORK4(NUMTIM).GE.MNXANT(2)))) WORK4(NUMTIM)=FBLANK
                  WORK6(NUMTIM) = FBLANK
                  IF (YTYPE.EQ.'SY') THEN
C                                       Psys 1
                     IF (DOTRAT) THEN
                        IF (WRKTYP(NUMTIM).EQ.1) THEN
                           ITC = 3
                        ELSE
                           ITC = 1
                           END IF
                        IF ((WORK2(NUMTIM).LE.0.0) .OR.
     *                     (WORK4(NUMTIM).EQ.FBLANK) .OR.
     *                     (WORK2(NUMTIM).EQ.FBLANK) .OR.
     *                     (TCAL(ITC,BEGIF,ANT).EQ.FBLANK)) THEN
                           WORK2(NUMTIM) = FBLANK
                           WORK4(NUMTIM) = FBLANK
                        ELSE
                           WORK6(NUMTIM) = WORK4(NUMTIM)/WORK2(NUMTIM) /
     *                        2.* TCAL(ITC,BEGIF,ANT)
                           IF ((WORK6(NUMTIM).LE.MNXRAT(1)) .OR.
     *                        (WORK6(NUMTIM).GE.MNXRAT(2))) THEN
                              WORK2(NUMTIM) = FBLANK
                              WORK4(NUMTIM) = FBLANK
                              WORK6(NUMTIM) = FBLANK
                              END IF
                           END IF
                        END IF
C                                       Pgain 1
                     WORK8(NUMTIM) = RECR(TG1KOL)
                     IF ((WORK8(NUMTIM).NE.FBLANK) .AND.
     *                  ((WORK8(NUMTIM).LE.MNXGAI(1)) .OR.
     *                  (WORK8(NUMTIM).GE.MNXGAI(2))))
     *                  WORK8(NUMTIM) = FBLANK
                     END IF
                  IF (TS2KOL.GT.0) THEN
                     WORK3(NUMTIM) = RECR(TS2KOL)
                     IF ((YTYPE.EQ.'TY') .AND.
     *                  (ABS(WORK3(NUMTIM)-999.0).LT.0.1))
     *                  WORK3(NUMTIM) = FBLANK
                     IF ((WORK3(NUMTIM).NE.FBLANK) .AND.
     *                  ((WORK3(NUMTIM).LE.MNXSYS(1)) .OR.
     *                  (WORK3(NUMTIM).GE.MNXSYS(2)))) WORK3(NUMTIM) =
     *                  FBLANK
                     WORK5(NUMTIM) = RECR(TA2KOL)
                     IF ((YTYPE.EQ.'TY') .AND.
     *                  (ABS(WORK5(NUMTIM)-999.0).LT.0.1))
     *                  WORK5(NUMTIM) = FBLANK
                     IF ((WORK5(NUMTIM).NE.FBLANK) .AND.
     *                  ((WORK5(NUMTIM).LE.MNXANT(1)) .OR.
     *                  (WORK5(NUMTIM).GE.MNXANT(2)))) WORK5(NUMTIM) =
     *                  FBLANK
                     WORK7(NUMTIM) = FBLANK
                     IF (YTYPE.EQ.'SY') THEN
                        IF (DOTRAT) THEN
                           IF (WRKTYP(NUMTIM).EQ.1) THEN
                              ITC = 4
                           ELSE
                              ITC = 2
                              END IF
C                                       Psys 2
                           IF ((WORK3(NUMTIM).LE.0.0) .OR.
     *                        (WORK5(NUMTIM).EQ.FBLANK) .OR.
     *                        (WORK3(NUMTIM).EQ.FBLANK) .OR.
     *                        (TCAL(ITC,BEGIF,ANT).EQ.FBLANK)) THEN
                              WORK3(NUMTIM) = FBLANK
                              WORK5(NUMTIM) = FBLANK
                           ELSE
                              WORK7(NUMTIM) = WORK5(NUMTIM) /
     *                           WORK3(NUMTIM)*  TCAL(ITC,BEGIF,ANT) /
     *                           2.0
                              IF ((WORK7(NUMTIM).LE.MNXRAT(1)) .OR.
     *                           (WORK7(NUMTIM).GE.MNXRAT(2))) THEN
                                 WORK3(NUMTIM) = FBLANK
                                 WORK5(NUMTIM) = FBLANK
                                 WORK7(NUMTIM) = FBLANK
                                 END IF
                              END IF
                           END IF
C                                       Pgain 1
                        WORK9(NUMTIM) = RECR(TG2KOL)
                        IF ((WORK9(NUMTIM).NE.FBLANK) .AND.
     *                     ((WORK9(NUMTIM).LE.MNXGAI(1)) .OR.
     *                     (WORK9(NUMTIM).GE.MNXGAI(2))))
     *                     WORK9(NUMTIM) = FBLANK
                        END IF
                  ELSE
                     WORK3(NUMTIM) = FBLANK
                     WORK5(NUMTIM) = FBLANK
                     WORK7(NUMTIM) = FBLANK
                     WORK9(NUMTIM) = FBLANK
                     END IF
                  IF ((DOBTWN.LE.0.0) .OR. (DOSCAL.GT.0.0)) THEN
                     WRKSRC(NUMTIM) = RECORD(SOUKOL) + 0.5
                  ELSE
                     WRKSRC(NUMTIM) = -1
                     END IF
                  END IF
               END IF
 100        CONTINUE
 110     SAVE = ITYRNO - 1
         IF (NUMTIM.LE.0) GO TO 590
C                                       Tsys smooth as requested
         IF (DOTSYS) THEN
            IF (DOSCAL.GT.0.0) CALL TYNORM (WORK2, FBLANK, NUMTIM,
     *         WRKSRC, VSCAL1)
            CALL TYSMSM ('MWF ', STTSYS, WRKTIM, WORK2, FBLANK, NUMTIM,
     *         WRKSRC, WORK1)
C                                       Second Poln?
            IF (TS2KOL.GT.0) THEN
               IF (DOSCAL.GT.0.0) CALL TYNORM (WORK3, FBLANK, NUMTIM,
     *            WRKSRC, VSCAL2)
               CALL TYSMSM ('MWF ', STTSYS, WRKTIM, WORK3, FBLANK,
     *            NUMTIM, WRKSRC, WORK2)
               END IF
         ELSE
            CALL RCOPY (NUMTIM, WORK2, WORK1)
            CALL RCOPY (NUMTIM, WORK3, WORK2)
            END IF
C                                       Tant
         IF (DOTANT) THEN
            IF (DOSCAL.GT.0.0) CALL TYNORM (WORK4, FBLANK, NUMTIM,
     *         WRKSRC, VSCAL3)
            CALL TYSMSM ('MWF ', STTANT, WRKTIM, WORK4, FBLANK, NUMTIM,
     *         WRKSRC, WORK3)
C                                       Second Poln?
            IF (TS2KOL.GT.0) THEN
               IF (DOSCAL.GT.0.0) CALL TYNORM (WORK5, FBLANK, NUMTIM,
     *            WRKSRC, VSCAL4)
               CALL TYSMSM ('MWF ', STTANT, WRKTIM, WORK5, FBLANK,
     *            NUMTIM, WRKSRC, WORK4)
               END IF
         ELSE
            CALL RCOPY (NUMTIM, WORK4, WORK3)
            CALL RCOPY (NUMTIM, WORK5, WORK4)
            END IF
C                                       Ratio Psum/Pdif
         IF (DOTRAT) THEN
            IF (DOSCAL.GT.0.0) CALL TYNORM (WORK6, FBLANK, NUMTIM,
     *         WRKSRC, VSCAL5)
            CALL TYSMSM ('MWF ', STTRAT, WRKTIM, WORK6, FBLANK, NUMTIM,
     *         WRKSRC, WORK5)
C                                       Second Poln?
            IF (TS2KOL.GT.0) THEN
               IF (DOSCAL.GT.0.0) CALL TYNORM (WORK7, FBLANK, NUMTIM,
     *            WRKSRC, VSCAL6)
               CALL TYSMSM ('MWF ', STTRAT, WRKTIM, WORK7, FBLANK,
     *            NUMTIM, WRKSRC, WORK6)
               END IF
         ELSE
            CALL RCOPY (NUMTIM, WORK6, WORK5)
            CALL RCOPY (NUMTIM, WORK7, WORK6)
            END IF
C                                       Tsys smooth as requested
         IF (DOTGAI) THEN
            IF (DOSCAL.GT.0.0) CALL TYNORM (WORK8, FBLANK, NUMTIM,
     *         WRKSRC, VSCAL7)
            CALL TYSMSM ('MWF ', STTGAI, WRKTIM, WORK8, FBLANK, NUMTIM,
     *         WRKSRC, WORK7)
C                                       Second Poln?
            IF (TS2KOL.GT.0) THEN
               IF (DOSCAL.GT.0.0) CALL TYNORM (WORK9, FBLANK, NUMTIM,
     *            WRKSRC, VSCAL8)
               CALL TYSMSM ('MWF ', STTGAI, WRKTIM, WORK9, FBLANK,
     *            NUMTIM, WRKSRC, WORK8)
               END IF
         ELSE
            CALL RCOPY (NUMTIM, WORK8, WORK7)
            CALL RCOPY (NUMTIM, WORK9, WORK8)
            END IF
C                                       Clip
         DO 200 ITIME = 1,NUMTIM
            ITYRNO = WRKREC(ITIME)
            CALL TABIO ('READ', IRCODE, ITYRNO, RECORD, BUFFO, IRET)
            IF (IRET.GT.0) GO TO 900
            IF (IRET.LT.0) THEN
               IRET = 0
               GO TO 200
               END IF
            BAD = .FALSE.
C                                       test SY again
            IF (YTYPE.EQ.'SY') THEN
C                                       Psum > Pdif: 1
               IF ((RECR(TA1KOL).NE.FBLANK) .AND.
     *            (RECR(TS1KOL).NE.FBLANK) .AND.
     *            (RECR(TA1KOL).LE.RECR(TS1KOL))) THEN
                  RECR(TS1KOL) = FBLANK
                  RECR(TA1KOL) = FBLANK
                  BAD = .TRUE.
                  NSYVAL = NSYVAL + 1
                  END IF
C                                       blank on Psum/Pdif: 1
               IF ((DOTRAT) .AND. (RECR(TS1KOL).NE.FBLANK) .AND.
     *            (RECR(TS1KOL).NE.0.0) .AND.
     *            (RECR(TA1KOL).NE.FBLANK)) THEN
                  IF ((TYPKOL.GT.0) .AND. (RECORD(TYPKOL).EQ.1)) THEN
                     ITC = 3
                  ELSE
                     ITC = 1
                     END IF
                  DIFF = RECR(TA1KOL)/RECR(TS1KOL) / 2. *
     *               TCAL(ITC,BEGIF,ANT)
                  IF ((DIFF.LE.MNXRAT(1)) .OR. (DIFF.GT.MNXRAT(2))) THEN
                     RECR(TA1KOL) = FBLANK
                     RECR(TS1KOL) = FBLANK
                     BAD = .TRUE.
                     NTRAT(1) = NTRAT(1) + 1
                  ELSE IF ((WORK5(ITIME).NE.FBLANK) .AND.
     *               (TCAL(ITC,BEGIF,ANT).NE.FBLANK)) THEN
                     DIFF = ABS (VSCAL5(ITIME)*DIFF - WORK5(ITIME))
                     IF (DIFF.GT.MXTRAT) THEN
                        RECR(TA1KOL) = FBLANK
                        RECR(TS1KOL) = FBLANK
                        BAD = .TRUE.
                        NTRAT(2) = NTRAT(2) + 1
                        END IF
                  ELSE
                     RECR(TA1KOL) = FBLANK
                     RECR(TS1KOL) = FBLANK
                     BAD = .TRUE.
                     NTRAT(3) = NTRAT(3) + 1
                     END IF
                  END IF
C                                       IF 2 Psum > Pdif
               IF (TS2KOL.GT.0) THEN
                  IF ((RECR(TA2KOL).NE.FBLANK) .AND.
     *               (RECR(TS2KOL).NE.FBLANK) .AND.
     *               (RECR(TA2KOL).LE.RECR(TS2KOL))) THEN
                     RECR(TS2KOL) = FBLANK
                     RECR(TA2KOL) = FBLANK
                     BAD = .TRUE.
                     NSYVAL = NSYVAL + 1
                     END IF
C                                       blank on Psum/Pdif: 2
                  IF ((DOTRAT) .AND. (RECR(TS2KOL).NE.FBLANK) .AND.
     *               (RECR(TS2KOL).NE.0.0) .AND.
     *               (RECR(TA2KOL).NE.FBLANK)) THEN
                     IF ((TYPKOL.GT.0) .AND. (RECORD(TYPKOL).EQ.1)) THEN
                        ITC = 4
                     ELSE
                        ITC = 2
                        END IF
                     DIFF = RECR(TA2KOL)/RECR(TS2KOL) / 2. *
     *                  TCAL(ITC,BEGIF,ANT)
                     IF ((DIFF.LE.MNXRAT(1)) .OR. (DIFF.GT.MNXRAT(2)))
     *                  THEN
                        RECR(TA2KOL) = FBLANK
                        RECR(TS2KOL) = FBLANK
                        BAD = .TRUE.
                        NTRAT(1) = NTRAT(1) + 1
                     ELSE IF ((WORK6(ITIME).NE.FBLANK) .AND.
     *                  (TCAL(ITC,BEGIF,ANT).NE.FBLANK)) THEN
                        DIFF = ABS (VSCAL6(ITIME)*DIFF - WORK6(ITIME))
                        IF (DIFF.GT.MXTRAT) THEN
                           RECR(TA2KOL) = FBLANK
                           RECR(TS2KOL) = FBLANK
                           BAD = .TRUE.
                           NTRAT(2) = NTRAT(2) + 1
                           END IF
                     ELSE
                        RECR(TA2KOL) = FBLANK
                        RECR(TS2KOL) = FBLANK
                        BAD = .TRUE.
                        NTRAT(3) = NTRAT(3) + 1
                        END IF
                     END IF
                  END IF
C                                       Pgain
               IF ((RECR(TG1KOL).NE.FBLANK) .AND. (DOTGAI)) THEN
                  IF ((RECR(TG1KOL).LE.MNXGAI(1)) .OR.
     *               (RECR(TG1KOL).GE.MNXGAI(2))) THEN
                     RECR(TG1KOL) = FBLANK
                     BAD = .TRUE.
                     NTGAI(1) = NTGAI(1) + 1
                  ELSE IF (WORK7(ITIME).NE.FBLANK) THEN
                     DIFF = ABS (VSCAL7(ITIME)*RECR(TG1KOL) -
     *                  WORK7(ITIME))
                     IF (DIFF.GT.MXTGAI) THEN
                        RECR(TG1KOL) = FBLANK
                        BAD = .TRUE.
                        NTGAI(2) = NTGAI(2) + 1
                        END IF
                  ELSE
                     RECR(TG1KOL) = FBLANK
                     BAD = .TRUE.
                     NTGAI(3) = NTGAI(3) + 1
                     END IF
                  END IF
               IF ((DOTGAI) .AND. (TG2KOL.GT.0)) THEN
                  IF (RECR(TG2KOL).NE.FBLANK) THEN
                     IF ((RECR(TG2KOL).LE.MNXGAI(1)) .OR.
     *                  (RECR(TG2KOL).GE.MNXGAI(2))) THEN
                        RECR(TG2KOL) = FBLANK
                        BAD = .TRUE.
                        NTGAI(1) = NTGAI(1) + 1
                     ELSE IF (WORK8(ITIME).NE.FBLANK) THEN
                        DIFF = ABS (VSCAL8(ITIME)*RECR(TG2KOL) -
     *                     WORK8(ITIME))
                        IF (DIFF.GT.MXTGAI) THEN
                           RECR(TG2KOL) = FBLANK
                           BAD = .TRUE.
                           NTGAI(2) = NTGAI(2) + 1
                           END IF
                     ELSE
                        RECR(TG2KOL) = FBLANK
                        BAD = .TRUE.
                        NTGAI(3) = NTGAI(3) + 1
                        END IF
                     END IF
                  END IF
               END IF
C                                       Pdif or Tsys
            IF (DOTSYS) THEN
               IF ((YTYPE.EQ.'TY') .AND.
     *            (ABS(RECR(TS1KOL)-999.0).LT.0.1)) RECR(TS1KOL)=FBLANK
               IF (RECR(TS1KOL).NE.FBLANK) THEN
                  IF ((RECR(TS1KOL).LE.MNXSYS(1)) .OR.
     *               (RECR(TS1KOL).GE.MNXSYS(2))) THEN
                     RECR(TS1KOL) = FBLANK
                     BAD = .TRUE.
                     NTSYS(1) = NTSYS(1) + 1
                  ELSE IF (WORK1(ITIME).NE.FBLANK) THEN
                     DIFF = ABS (VSCAL1(ITIME)*RECR(TS1KOL) -
     *                  WORK1(ITIME))
                     IF (DIFF.GT.MXTSYS) THEN
                        RECR(TS1KOL) = FBLANK
                        BAD = .TRUE.
                        NTSYS(2) = NTSYS(2) + 1
                        END IF
                  ELSE
                     RECR(TS1KOL) = FBLANK
                     BAD = .TRUE.
                     NTSYS(3) = NTSYS(3) + 1
                     END IF
                  END IF
               END IF
C                                       Psum or Tant
            IF (DOTANT) THEN
               IF ((YTYPE.EQ.'TY') .AND.
     *            (ABS(RECR(TA1KOL)-999.0).LT.0.1)) RECR(TA1KOL)=FBLANK
               IF (RECR(TA1KOL).NE.FBLANK) THEN
                  IF ((RECR(TA1KOL).LE.MNXANT(1)) .OR.
     *               (RECR(TA1KOL).GE.MNXANT(2))) THEN
                     RECR(TA1KOL) = FBLANK
                     BAD = .TRUE.
                     NTANT(1) = NTANT(1) + 1
                  ELSE IF (WORK3(ITIME).NE.FBLANK) THEN
                     DIFF = ABS (VSCAL3(ITIME)*RECR(TA1KOL) -
     *                  WORK3(ITIME))
                     IF (DIFF.GT.MXTANT) THEN
                        RECR(TA1KOL) = FBLANK
                        BAD = .TRUE.
                        NTANT(2) = NTANT(2) + 1
                        END IF
                  ELSE
                     RECR(TA1KOL) = FBLANK
                     BAD = .TRUE.
                     NTANT(3) = NTANT(3) + 1
                     END IF
                  END IF
               END IF
C                                       Second polarization?
            IF ((DOTSYS) .AND. (TS2KOL.GT.0)) THEN
C                                       Pdif or Tsys
               IF ((YTYPE.EQ.'TY') .AND.
     *            (ABS(RECR(TS2KOL)-999.0).LT.0.1))
     *            RECR(TS2KOL) = FBLANK
               IF (RECR(TS2KOL).NE.FBLANK) THEN
                  IF ((RECR(TS2KOL).LE.MNXSYS(1)) .OR.
     *               (RECR(TS2KOL).GE.MNXSYS(2))) THEN
                     RECR(TS2KOL) = FBLANK
                     BAD = .TRUE.
                     NTSYS(1) = NTSYS(1) + 1
                  ELSE IF (WORK2(ITIME).NE.FBLANK) THEN
                     DIFF = ABS (VSCAL2(ITIME)*RECR(TS2KOL) -
     *                  WORK2(ITIME))
                     IF (DIFF.GT.MXTSYS) THEN
                        RECR(TS2KOL) = FBLANK
                        BAD = .TRUE.
                        NTSYS(2) = NTSYS(2) + 1
                        END IF
                  ELSE
                     RECR(TS2KOL) = FBLANK
                     BAD = .TRUE.
                     NTSYS(3) = NTSYS(3) + 1
                     END IF
                  END IF
               END IF
C                                       Psum or Tant
            IF ((DOTANT) .AND. (TA2KOL.GT.0)) THEN
               IF ((YTYPE.EQ.'TY') .AND.
     *            (ABS(RECR(TA2KOL)-999.0).LT.0.1))
     *            RECR(TA2KOL) = FBLANK
               IF (RECR(TA2KOL).NE.FBLANK) THEN
                  IF ((RECR(TA2KOL).LE.MNXANT(1)) .OR.
     *               (RECR(TA2KOL).GE.MNXANT(2))) THEN
                     RECR(TA2KOL) = FBLANK
                     BAD = .TRUE.
                     NTANT(1) = NTANT(1) + 1
                  ELSE IF (WORK4(ITIME).NE.FBLANK) THEN
                     DIFF = ABS (VSCAL4(ITIME)*RECR(TA2KOL) -
     *                  WORK4(ITIME))
                     IF (DIFF.GT.MXTANT) THEN
                        RECR(TA2KOL) = FBLANK
                        BAD = .TRUE.
                        NTANT(2) = NTANT(2) + 1
                        END IF
                  ELSE
                     RECR(TA2KOL) = FBLANK
                     BAD = .TRUE.
                     NTANT(3) = NTANT(3) + 1
                     END IF
                  END IF
               END IF
C                                       Rewrite record
            IF (BAD) THEN
               CALL TABIO ('WRIT', IRCODE, ITYRNO, RECORD, BUFFO, IRET)
               IF (IRET.NE.0) GO TO 900
               NRECS = NRECS + 1
               END IF
 200        CONTINUE
 590     FSTREC = SAVE
C                                       End of antenna loop
 600     CONTINUE
      IF (NRECS.GT.0) THEN
         IF (YTYPE.EQ.'TY') THEN
            WRITE (MSGTXT,1600) BEGIF, NTSYS, 'Tsys'
            CALL MSGWRT (4)
            WRITE (MSGTXT,1600) BEGIF, NTANT, 'Tant'
            CALL MSGWRT (4)
            WRITE (MSGTXT,1602) BEGIF, NRECS
            CALL MSGWRT (4)
         ELSE
            WRITE (MSGTXT,1605)
            IF (BEGIF.EQ.BIF) CALL MSGWRT (4)
            WRITE (MSGTXT,1601) BEGIF, NSYVAL
            CALL MSGWRT (4)
            WRITE (MSGTXT,1600) BEGIF, NTSYS, 'Pdif'
            IF (DOTSYS) CALL MSGWRT (4)
            WRITE (MSGTXT,1600) BEGIF, NTANT, 'Psum'
            IF (DOTANT) CALL MSGWRT (4)
            WRITE (MSGTXT,1600) BEGIF, NTRAT, 'Tcal*Psum/Pdif/2'
            IF (DOTRAT) CALL MSGWRT (4)
            WRITE (MSGTXT,1600) BEGIF, NTGAI, 'Pgain'
            IF (DOTGAI) CALL MSGWRT (4)
            WRITE (MSGTXT,1602) BEGIF, NRECS
            CALL MSGWRT (4)
            END IF
         END IF
      GO TO 999
C                                       TABIO error
 900  WRITE (MSGTXT,1900) IRET
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1600 FORMAT ('IF',I3,' clipped',3I10,1X,A)
 1601 FORMAT ('IF',I3,' blanked',I10,' improper SY values Psum<=Pdif')
 1602 FORMAT ('IF',I3,' changed',I10,' table records due to clipping')
 1605 FORMAT (14X,'clip APARM',' MWF CPARM','   flagged')
 1900 FORMAT ('CLIPTY: TABIO ERROR',I3,' CLIPPING DELAYS')
      END
      SUBROUTINE TYNORM (WORK, BLANK, NUMTIM, WRKSRC, VSCAL)
C-----------------------------------------------------------------------
C   Normalizes by the median in each source group (scan)
C   Inputs
C      BLANK    R      Blanked value
C      NUMTIM   I      Number samples in WORK, WRKSRC
C      WRKSRC   I(*)   Source numbers (must be filled in)
C   In/Out
C      WORK     R(*)   Data to be normalized
C   Output:
C      VSCAL    R(*)   Scaling used
C-----------------------------------------------------------------------
      REAL      BLANK, WORK(*), VSCAL(*)
      INTEGER   NUMTIM, WRKSRC(*)
C
      INTEGER   SSIZE
      PARAMETER (SSIZE=5000)
C
      INTEGER   I, I1, I2, N
      REAL      SCRTCH(SSIZE), MEDIAN, VAL
C-----------------------------------------------------------------------

      I1 = 1
C                                       loop point for scans
C                                       find upper bound of scan
 20   I2 = I1
      DO 30 I = I1+1,NUMTIM
         IF (WRKSRC(I).EQ.WRKSRC(I1)) THEN
            I2 = I
         ELSE
            GO TO 50
            END IF
 30      CONTINUE
C                                       Find median
 50   N = 0
      DO 60 I = I1,I2
         IF (WORK(I).NE.BLANK) THEN
            N = N + 1
            SCRTCH(N) = WORK(I)
            IF (N.EQ.SSIZE) GO TO 70
            END IF
 60      CONTINUE
 70   VAL = 0.0
      IF (N.GT.1) VAL = MEDIAN (N, SCRTCH)
C                                       Divide if good
      IF (VAL.NE.0.0) THEN
         VAL = 1.0 / VAL
         N = I2 - I1 + 1
         CALL RFILL (N, VAL, VSCAL(I1))
         DO 80 I = I1,I2
            IF (WORK(I).NE.BLANK) WORK(I) = WORK(I) * VAL
 80         CONTINUE
         END IF
C                                       loop
      I1 = I2 + 1
      IF (I1.LE.NUMTIM) GO TO 20
C
 999  RETURN
      END
      SUBROUTINE TYSMOO (IERR)
C-----------------------------------------------------------------------
C   Smooths selected portions of TY tables.
C   Leaves the output table sorted in antenna-time order.
C    Inputs from common:
C      TYVER        I    Cal (TY) file version number.
C      TSTART       R    First time to process (days) (no default)
C      TEND         R    Last time to process (days) (no default)
C    Output:
C      IERR         I    Return code, 0=>OK, otherwise failed.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER COLHED(2)*24
      INTEGER   IRET, KEY(2,2), ICLUN, TYANT, TYTIM, ITYRNO, NKEY, I,
     *   KOLS(2), TYNUMV(MAXSYC), TYKOLS(MAXSYC), NUMPOL, NUMIF, SUB,
     *   TIMKOL, SOUKOL, ANTKOL, SUBKOL, FRQKOL, TS1KOL, TA1KOL, TG1KOL,
     *   TS2KOL, TA2KOL, TG2KOL, NUMANT, KEYSUB(2,2), TYPKOL, NUMSUB
      LOGICAL   T, DOTANT, DOTSYS, DOTGAI
      REAL      FKEY(2,2), STTSYS(3), STTANT(3), STTGAI(3)
      INCLUDE 'TYSMO.INC'
      INCLUDE 'INCS:PTYTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
      DATA COLHED /'TIME ', 'ANTENNA NO. '/
      DATA T /.TRUE./
      DATA ICLUN /30/
C-----------------------------------------------------------------------
      IERR = 0
C                                       Sort TY table to antenna-time.
C                                       Need col. pointers, sort order.
      IF (YTYPE.EQ.'TY') THEN
         CALL TYINI ('READ', BUFFO, DISKIN, CNOIN, TYVER, CATBLK,
     *   ICLUN, ITYRNO, TYKOLS, TYNUMV, NUMPOL, NUMIF, IRET)
C                                       Get column pointers
         NKEY = 2
         CALL FNDCOL (NKEY, COLHED, 24, T, BUFFO, KOLS, IRET)
         IF ((IRET.GE.1) .AND. (IRET.LE.10)) GO TO 999
         IRET = 0
         TYTIM = KOLS(1)
         TYANT = KOLS(2)
         TYPKOL = -1
         TIMKOL = TYKOLS(TYRTIM)
         SOUKOL = TYKOLS(TYISID)
         ANTKOL = TYKOLS(TYIANT)
         SUBKOL = TYKOLS(TYISUB)
         FRQKOL = TYKOLS(TYIFQI)
         TS1KOL = TYKOLS(TYRTS1)
         TA1KOL = TYKOLS(TYRTA1)
         TG1KOL = -1
         TG2KOL = -1
         IF (NUMPOL.GT.1) THEN
            TS2KOL = TYKOLS(TYRTS2)
            TA2KOL = TYKOLS(TYRTA2)
         ELSE
            TS2KOL = -1000
            TA2KOL = -1000
            END IF
      ELSE
         CALL SYINI ('READ', BUFFO, DISKIN, CNOIN, TYVER, CATBLK,
     *      ICLUN, ITYRNO, TYKOLS, TYNUMV, NUMANT, NUMPOL, NUMIF, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Get column pointers
         NKEY = 2
         CALL FNDCOL (NKEY, COLHED, 24, T, BUFFO, KOLS, IRET)
         IF ((IRET.GE.1) .AND. (IRET.LE.10)) GO TO 999
         IRET = 0
         TYTIM = KOLS(1)
         TYANT = KOLS(2)
         TIMKOL = TYKOLS(1)
         TYPKOL = TYKOLS(3)
         SOUKOL = TYKOLS(4)
         ANTKOL = TYKOLS(5)
         SUBKOL = TYKOLS(6)
         FRQKOL = TYKOLS(7)
         TS1KOL = TYKOLS(8)
         TA1KOL = TYKOLS(9)
         TG1KOL = TYKOLS(10)
         IF (NUMPOL.GT.1) THEN
            TS2KOL = TYKOLS(11)
            TA2KOL = TYKOLS(12)
            TG2KOL = TYKOLS(13)
         ELSE
            TS2KOL = -1000
            TA2KOL = -1000
            TG2KOL = -1000
            END IF
         END IF
C                                       Close table
      CALL TABIO ('CLOS', 0, ITYRNO, BUFFO, BUFFO, IERR)
      IF ((IERR.NE.0) .OR. (IRET.NE.0)) GO TO 999
C                                       Sort to antenna time order.
      KEY(1,1) = TYANT
      KEY(1,2) = TYTIM
      IF (((BUFFO(43).NE.TYANT) .OR. (BUFFO(44).NE.TYTIM))) THEN
         CALL TABSRT (DISKIN, CNOIN, 'TY', TYVER, TYVER, KEY, KEYSUB,
     *      FKEY, BUFFO, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Reopen write
      IF (YTYPE.EQ.'TY') THEN
         CALL TYINI ('WRIT', BUFFO, DISKIN, CNOIN, TYVER, CATBLK,
     *      ICLUN, ITYRNO, TYKOLS, TYNUMV, NUMPOL, NUMIF, IRET)
      ELSE
         CALL SYINI ('WRIT', BUFFO, DISKIN, CNOIN, TYVER, CATBLK,
     *      ICLUN, ITYRNO, TYKOLS, TYNUMV, NUMANT, NUMPOL, NUMIF, IRET)
         END IF
      IF (IRET.NE.0) GO TO 999
C                                       Find number of subarrays.
      CALL FNDEXT ('AN', CATBLK, NUMSUB)
      NUMSUB = MAX (NUMSUB, 1)
C                                       Determine smoothing parameters.
      STTSYS(1) = XIPARM(1) / 1440.0
      STTANT(1) = XIPARM(2) / 1440.0
      STTGAI(1) = XIPARM(4) / 1440.0
      STTSYS(2) = XIPARM(6) / 1440.0
      STTANT(2) = XIPARM(7) / 1440.0
      STTGAI(2) = XIPARM(9) / 1440.0
      STTSYS(3) = CUTOFF
      STTANT(3) = CUTOFF
      STTGAI(3) = CUTOFF
      DOTSYS =  STTSYS(1) .GE. 1.0E-10
      DOTANT =  STTANT(1) .GE. 1.0E-10
      DOTGAI =  (STTGAI(1) .GE. 1.0E-10) .AND. (YTYPE.EQ.'SY')
C                                       Inform user of smoothing:
      MSGTXT ='TYSMTH: Smoothing ' // YTYPE // ' table'
      CALL MSGWRT (4)
C                                       Loop over subarrays
      DO 200 SUB = 1,NUMSUB
C                                       Want this subarray?
         IF ((SUBA.LE.0) .OR. (SUB.EQ.SUBA)) THEN
C                                       Smooth amp/phase
C                                       Loop over IF
            DO 100 I = BIF,EIF
               CALL SMOTY (STTSYS, STTANT, STTGAI, DOTSYS, DOTANT,
     *            DOTGAI, SUB, NUMAN(SUB+1), TYPKOL, TIMKOL, SUBKOL,
     *            ANTKOL,SOUKOL, FRQKOL, TS1KOL+I-1, TA1KOL+I-1,
     *            TG1KOL+I-1,TS2KOL+I-1, TA2KOL+I-1, TG2KOL+I-1, IRET)
               IF (IRET.NE.0) GO TO 999
 100           CONTINUE
            END IF
 200     CONTINUE
C                                       Close table
      CALL TABIO ('CLOS', 0, ITYRNO, BUFFO, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE SMOTY (STTSYS, STTANT, STTGAI, DOTSYS, DOTANT, DOTGAI,
     *   SUB, NUMANT, TYPKOL, TIMKOL, SUBKOL, ANTKOL, SOUKOL, FRQKOL,
     *   TS1KOL, TA1KOL, TG1KOL, TS2KOL, TA2KOL, TG2KOL, IRET)
C-----------------------------------------------------------------------
C   Routine to smooth TYs in an open table in antenna-time order.
C   Inputs:
C      STTSYS   R    Tsys smoothing time (days)
C      STTANT   R    Tant smoothing time (days)
C      DOTSYS   L    Smooth Tsys?
C      DOTANT   L    Smooth Tant?
C      SUB      I    Desired subarray
C      NUMANT   I    Number of antennas
C      TIMKOL   I    Time column pointer.
C      SUBKOL   I    Subarray column pointer
C      ANTKOL   I    Antenna column pointer
C      FRQKOL   I    FQ id column pointer
C      SOUKOL   I    Source ID column pointer
C      TS1KOL   I    Tsys 1 column pointer
C      TA1KOL   I    Tant 1 column pointer
C      TS2KOL   I    Tsys 2 column pointer <1 => not present
C      TA2KOL   I    Tant 2 pointer <1 => not present
C   Inputs from common:
C      I/O buffer etc.
C      Other data selection criteria.
C   Output:
C      IRET     I  Error code, 0=OK else failed.
C-----------------------------------------------------------------------
      REAL      STTSYS(*), STTANT(*), STTGAI(*)
      LOGICAL   DOTSYS, DOTANT, DOTGAI
      INTEGER   SUB, NUMANT, TYPKOL, TIMKOL, SUBKOL, ANTKOL, SOUKOL,
     *   FRQKOL, TS1KOL, TA1KOL, TG1KOL, TS2KOL, TA2KOL, TG2KOL, IRET
C
      INTEGER   LOOPR, LOOPA, IRCODE, NUMTIM, ANT, NUMREC, FSTREC,
     *   NLEFT, SAVE, ITYRNO, ITIME
      LOGICAL   SLCTD, TYWANT, WANT
      DOUBLE PRECISION TIMOFF
      REAL      RTIME
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'TYSMO.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA IRCODE /0/
C-----------------------------------------------------------------------
C                                       Get number of records in table
      NUMREC = BUFFO(5)
      IF (NUMREC.LE.0) GO TO 999
      IF ((.NOT.DOTSYS) .AND. (.NOT.DOTANT) .AND. (.NOT.DOTGAI))
     *   GO TO 999
      FSTREC = 0
C                                       Loop over antenna
      DO 600 LOOPA = 1,NUMANT
         ANT = LOOPA
C                                       Want this antenna?
         IF (.NOT.SLCTD (ANT, ANTENS, NANTSL, DOAWNT)) GO TO 600
C                                       Set pointers, counters
         NUMTIM = 0
         NLEFT = NUMREC - FSTREC
C                                       Loop in time, reading
         DO 100 LOOPR = 1,NLEFT
            ITYRNO = FSTREC + LOOPR
            CALL TABIO ('READ', IRCODE, ITYRNO, RECORD, BUFFO, IRET)
            IF (IRET.LT.0) THEN
               IRET = 0
               GO TO 100
               END IF
            IF (IRET.NE.0) GO TO 900
C                                       Finished antenna?
            IF (RECORD(ANTKOL).GT.ANT) GO TO 110
            IF (YTYPE.EQ.'SY') THEN
               RTIME = RECD(TIMKOL)
            ELSE
               RTIME = RECR(TIMKOL)
               END IF
C                                       See if wanted.
            WANT = TYWANT (RECORD(SOUKOL), RECORD(FRQKOL),
     *         RECORD(ANTKOL), RECORD(SUBKOL), RTIME)
C                                       Check subarray
            WANT = WANT .AND. (RECORD(SUBKOL).EQ.SUB)
C                                       Not all antennas wanted
            WANT = WANT .AND. (RECORD(ANTKOL).EQ.ANT)
            IF ((WANT) .AND. (NUMTIM.EQ.MXTIME)) THEN
               MSGTXT = 'NUMBER OF TIMES EXCESSIVE, OPERATION' //
     *            ' TRUNCATED'
               CALL MSGWRT (8)
               END IF
            IF ((WANT) .AND. (NUMTIM.LT.MXTIME)) THEN
               NUMTIM = NUMTIM + 1
               IF (NUMTIM.EQ.1) TIMOFF = RTIME
               WRKTIM(NUMTIM) = RTIME - TIMOFF
               WRKREC(NUMTIM) = ITYRNO
               IF (YTYPE.EQ.'TY') THEN
                  IF (ABS(RECR(TS1KOL)-999.0).LT.0.1)
     *               RECR(TS1KOL) = FBLANK
                  IF (ABS(RECR(TA1KOL)-999.0).LT.0.1)
     *               RECR(TA1KOL) = FBLANK
                  IF (TS2KOL.GT.0) THEN
                     IF (ABS(RECR(TS2KOL)-999.0).LT.0.1)
     *                  RECR(TS2KOL) = FBLANK
                     IF (ABS(RECR(TA2KOL)-999.0).LT.0.1)
     *                  RECR(TA2KOL) = FBLANK
                     END IF
                  END IF
               WORK2(NUMTIM) = RECR(TS1KOL)
               WORK3(NUMTIM) = RECR(TA1KOL)
               IF (TG1KOL.GT.0) WORK6(NUMTIM) = RECR(TG1KOL)
               IF (TS2KOL.GT.0) THEN
                  WORK4(NUMTIM) = RECR(TS2KOL)
                  WORK5(NUMTIM) = RECR(TA2KOL)
                  IF (TG2KOL.GT.0) WORK7(NUMTIM) = RECR(TG2KOL)
                  END IF
               IF (DOBTWN.LE.0.0) THEN
                  WRKSRC(NUMTIM) = RECORD(SOUKOL) + 0.5
               ELSE
                  WRKSRC(NUMTIM) = -1
                  END IF
               IF (TYPKOL.GT.0) THEN
                  WRKTYP(NUMTIM) = RECORD(TYPKOL)
               ELSE
                  WRKTYP(NUMTIM) = 0
                  END IF
               END IF
 100        CONTINUE
 110     SAVE = ITYRNO - 1
         IF (NUMTIM.LE.0) GO TO 590
C                                       Smooth as requested
         IF (DOTSYS) CALL TYSMSM (XINTP, STTSYS, WRKTIM, WORK2, FBLANK,
     *      NUMTIM, WRKSRC, WORK1)
         IF (DOTANT) CALL TYSMSM (XINTP, STTANT, WRKTIM, WORK3, FBLANK,
     *      NUMTIM, WRKSRC, WORK2)
C                                       Second Poln?
         IF (TS2KOL.GT.0) THEN
            IF (DOTSYS) CALL TYSMSM (XINTP, STTSYS, WRKTIM, WORK4,
     *         FBLANK, NUMTIM, WRKSRC, WORK3)
C                                       Second Poln?
            IF (DOTANT) CALL TYSMSM (XINTP, STTANT, WRKTIM, WORK5,
     *         FBLANK, NUMTIM, WRKSRC, WORK4)
            END IF
C                                       Pgain
         IF (DOTGAI) THEN
            CALL TYSMSM (XINTP, STTGAI, WRKTIM, WORK6,
     *         FBLANK, NUMTIM, WRKSRC, WORK5)
            IF (TG2KOL.GT.0) CALL TYSMSM (XINTP, STTGAI, WRKTIM, WORK7,
     *         FBLANK, NUMTIM, WRKSRC, WORK6)
            END IF

C                                       Replace with smoothed values
         DO 200 ITIME = 1,NUMTIM
            ITYRNO = WRKREC(ITIME)
            CALL TABIO ('READ', IRCODE, ITYRNO, RECORD, BUFFO, IRET)
            IF (IRET.NE.0) GO TO 900
            IF (IRET.LT.0) THEN
               IRET = 0
               GO TO 200
               END IF
            IF (YTYPE.EQ.'TY') THEN
               IF (ABS(RECR(TS1KOL)-999.0).LT.0.1) RECR(TS1KOL) = FBLANK
               IF (ABS(RECR(TA1KOL)-999.0).LT.0.1) RECR(TA1KOL) = FBLANK
               IF (TS2KOL.GT.0) THEN
                  IF (ABS(RECR(TS2KOL)-999.0).LT.0.1)
     *               RECR(TS2KOL) = FBLANK
                  IF (ABS(RECR(TA2KOL)-999.0).LT.0.1)
     *               RECR(TA2KOL) = FBLANK
                  END IF
               END IF
C                                       Update if desired
            IF (DOTSYS) THEN
               IF (RECR(TS1KOL).EQ.FBLANK) THEN
                  IF (XDOBLK.GE.0.0) RECR(TS1KOL) = WORK1(ITIME)
               ELSE
                  IF (XDOBLK.LE.0.0) RECR(TS1KOL) = WORK1(ITIME)
                  END IF
C                                       Second polarization?
               IF (TS2KOL.GT.0) THEN
                  IF (RECR(TS2KOL).EQ.FBLANK) THEN
                     IF (XDOBLK.GE.0.0) RECR(TS2KOL) = WORK3(ITIME)
                  ELSE
                     IF (XDOBLK.LE.0.0) RECR(TS2KOL) = WORK3(ITIME)
                     END IF
                  END IF
               END IF
            IF (DOTANT) THEN
               IF (RECR(TA1KOL).EQ.FBLANK) THEN
                  IF (XDOBLK.GE.0.0) RECR(TA1KOL) = WORK2(ITIME)
               ELSE
                  IF (XDOBLK.LE.0.0) RECR(TA1KOL) = WORK2(ITIME)
                  END IF
C                                       Second polarization?
               IF (TA2KOL.GT.0) THEN
                  IF (RECR(TA2KOL).EQ.FBLANK) THEN
                     IF (XDOBLK.GE.0.0) RECR(TA2KOL) = WORK4(ITIME)
                  ELSE
                     IF (XDOBLK.LE.0.0) RECR(TA2KOL) = WORK4(ITIME)
                     END IF
                  END IF
               END IF
C                                       Pgain
            IF (DOTGAI) THEN
               IF (RECR(TG1KOL).EQ.FBLANK) THEN
                  IF (XDOBLK.GE.0.0) RECR(TG1KOL) = WORK5(ITIME)
               ELSE
                  IF (XDOBLK.LE.0.0) RECR(TG1KOL) = WORK5(ITIME)
                  END IF
C                                       Second polarization?
               IF (TG2KOL.GT.0) THEN
                  IF (RECR(TG2KOL).EQ.FBLANK) THEN
                     IF (XDOBLK.GE.0.0) RECR(TG2KOL) = WORK6(ITIME)
                  ELSE
                     IF (XDOBLK.LE.0.0) RECR(TG2KOL) = WORK6(ITIME)
                     END IF
                  END IF
               END IF
C                                       Rewrite record
            CALL TABIO ('WRIT', IRCODE, ITYRNO, RECORD, BUFFO, IRET)
            IF (IRET.NE.0) GO TO 900
 200        CONTINUE
 590     FSTREC = SAVE
C                                       End of antenna loop
 600     CONTINUE
      GO TO 999
C                                       TABIO error
 900  WRITE (MSGTXT,1900) IRET
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('SMOTY: TABIO ERROR',I3,' SMOOTHING TYS')
      END
      SUBROUTINE TYSMSM (SMMETH, SMOTIM, TIME, IN, BLANK, NUMTIM, S,
     *   OUT)
C-----------------------------------------------------------------------
C   Routine to call appropriate smoothing routine.  Magic value blanking
C   is supported.
C   Inputs:
C      SMMETH   C*4    Method 'BOX','MWF', unknown = 'BOX'
C      SMOTIM   R(*)   Smoothing time (days)
C      TIME     R(*)   Times (days)
C      IN       R(*)   Input values.
C      BLANK    R      Magic blank value.
C      NUMTIM   I      Number of time/values
C      S        I(*)   Source number list
C   Output:
C      OUT      R(*)   Output array
C-----------------------------------------------------------------------
      CHARACTER SMMETH*4
      REAL      SMOTIM(*), TIME(*), IN(*), BLANK, OUT(*)
      INTEGER   NUMTIM, S(*)
C-----------------------------------------------------------------------
C                                       Any work to do?
      IF (NUMTIM.LE.0) GO TO 999
C                                       Median window filter
      IF (SMMETH.EQ.'MWF') THEN
         CALL MWFBSM (SMOTIM, TIME, IN, S, BLANK, NUMTIM, OUT)
C                                       function types
      ELSE IF (SMMETH.EQ.'GAUS') THEN
         CALL FUNBSM (SMMETH, SMOTIM(3), SMOTIM, TIME, IN, S, BLANK,
     *      NUMTIM, OUT)
      ELSE IF (SMMETH.EQ.'EXP ') THEN
         CALL FUNBSM (SMMETH, SMOTIM(3), SMOTIM, TIME, IN, S, BLANK,
     *      NUMTIM, OUT)
      ELSE IF (SMMETH.EQ.'LINE') THEN
         CALL FUNBSM (SMMETH, SMOTIM(3), SMOTIM, TIME, IN, S, BLANK,
     *      NUMTIM, OUT)
C                                       2-point
      ELSE IF (SMMETH.EQ.'2PT ') THEN
         CALL TPTBSM (SMOTIM, TIME, IN, S, BLANK, NUMTIM, .FALSE., OUT)
C                                       2-point - hanning
      ELSE IF (SMMETH.EQ.'2PTH') THEN
         CALL TPTBSM (SMOTIM, TIME, IN, S, BLANK, NUMTIM, .TRUE., OUT)
C                                       Default = Boxcar
      ELSE
         CALL BOXBSM (SMOTIM, TIME, IN, S, BLANK, NUMTIM, OUT)
         END IF
C
 999  RETURN
      END
      SUBROUTINE TYSMHI
C-----------------------------------------------------------------------
C   TYSMHI copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, CTIME(2)*12
      INTEGER   LUN1, IERR, I, TIME(3), DATE(3), LIMIT, LIMIT2, J
      REAL      TIMBEG, TIMEND
      LOGICAL   T
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'TYSMO.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1 /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HIOPEN (LUN1, DISKIN, FCNO(NCFILE), BUFFO, IERR)
      IF (IERR.LE.2) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
C                                       Task message
 10   CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,1010) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN1, HILINE, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Sources
      IF (NSOUWD.LE.0) THEN
         WRITE (HILINE,3000) TSKNAM
         CALL HIADD (LUN1, HILINE, BUFFO, IERR)
      ELSE
C                                       Included or excluded?
         WRITE (HILINE,3001) TSKNAM
         IF (DOSWNT) WRITE (HILINE,3002) TSKNAM
         CALL HIADD (LUN1, HILINE, BUFFO, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       1st 2 and label.
         WRITE (HILINE,3003) TSKNAM, XSOUR(1), XSOUR(2)
         CALL HIADD (LUN1, HILINE, BUFFO, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       Rest of sources
         DO 20 I = 3,NSOUWD,2
            WRITE (HILINE,3004) TSKNAM, XSOUR(I), XSOUR(I+1)
            CALL HIADD (LUN1, HILINE, BUFFO, IERR)
            IF (IERR.NE.0) GO TO 100
 20         CONTINUE
         END IF
C                                       Antennas
      IF (NANTSL.LE.0) THEN
         WRITE (HILINE,3005) TSKNAM
         CALL HIADD (LUN1, HILINE, BUFFO, IERR)
      ELSE
C                                       Included or excluded?
         WRITE (HILINE,3006) TSKNAM
         IF (DOAWNT) WRITE (HILINE,3007) TSKNAM
         CALL HIADD (LUN1, HILINE, BUFFO, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       1st 12 and label.
         LIMIT = MIN (12, NANTSL)
         WRITE (HILINE,3008) TSKNAM, (ANTENS(J),J=1,LIMIT)
         CALL HIADD (LUN1, HILINE, BUFFO, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       Rest of antennas
         DO 30 I = 13,NANTSL,12
            LIMIT = I
            LIMIT2 = I + 11
            LIMIT2 = MIN (NANTSL, LIMIT2)
            WRITE (HILINE,3009) TSKNAM, (ANTENS(J),J=LIMIT,LIMIT2)
            CALL HIADD (LUN1, HILINE, BUFFO, IERR)
            IF (IERR.NE.0) GO TO 100
 30         CONTINUE
         END IF
C                                       Timerange
      TIMBEG = XTIME(1) + XTIME(2) / 24.0 + XTIME(3) / (24.0*60.0) +
     *   (XTIME(4) / (24.0*60.0*60.0))
      TIMEND = XTIME(5) + XTIME(6) / 24.0 + XTIME(7) / (24.0*60.0) +
     *   (XTIME(8) / (24.0*60.0*60.0))
      IF ((TIMEND.LT.TIMBEG) .OR. (TIMEND.LT.1.0E-5)) TIMEND = 1.0E20
      CALL HITIME (TIMBEG, TIMEND, LUN1, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       IF range
      WRITE (HILINE,2004) TSKNAM, BIF, EIF
      CALL HIADD (LUN1, HILINE, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       SUBARRAY, TYVER
      WRITE (HILINE,2002) TSKNAM, SUBA, YTYPE, TYVER, YTYPE
      CALL HIADD (LUN1, HILINE, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Interpolation fn
      WRITE (HILINE,2006) TSKNAM, XINTP
      CALL HIADD (LUN1, HILINE, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       SY
      IF (YTYPE.EQ.'SY') THEN
         HILINE = TSKNAM // '/ Improper SY values blanked'
         CALL HIADD (LUN1, HILINE, BUFFO, IERR)
         IF (IERR.NE.0) GO TO 100
         END IF
C                                       what was changed
      IF (XDOBLK.GT.0.0) THEN
         HILINE = TSKNAM // '/ Only blanked solutions changed'
      ELSE IF (XDOBLK.EQ.0.0) THEN
         HILINE = TSKNAM // '/ Blanked and good solutions changed'
      ELSE
         HILINE = TSKNAM // '/ Only good solutions changed'
         END IF
      CALL HIADD (LUN1, HILINE, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Interpolation parms
      WRITE (HILINE,2007) TSKNAM, XIPARM(1), XIPARM(2), 'support'
      CALL HIADD (LUN1, HILINE, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       extra parms
      IF ((XINTP.EQ.'GAUS') .OR. (XINTP.EQ.'EXP ') .OR.
     *   (XINTP.EQ.'LINE')) THEN
         WRITE (HILINE,2007) TSKNAM, XIPARM(6), XIPARM(7), 'FWHM'
         CALL HIADD (LUN1, HILINE, BUFFO, IERR)
         IF (IERR.NE.0) GO TO 100
         WRITE (HILINE,4008) TSKNAM, CUTOFF
         CALL HIADD (LUN1, HILINE, BUFFO, IERR)
         IF (IERR.NE.0) GO TO 100
         END IF
C                                       straight clipping parms
      WRITE (HILINE,4010) TSKNAM, APARM(1), APARM(6)
      CALL HIADD (LUN1, HILINE, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,4011) TSKNAM, APARM(2), APARM(7)
      CALL HIADD (LUN1, HILINE, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 100
      IF (YTYPE.EQ.'SY') THEN
         WRITE (HILINE,4012) TSKNAM, APARM(3), APARM(8)
         CALL HIADD (LUN1, HILINE, BUFFO, IERR)
         IF (IERR.NE.0) GO TO 100
         WRITE (HILINE,4013) TSKNAM, APARM(4), APARM(9)
         CALL HIADD (LUN1, HILINE, BUFFO, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       MWF Clipping parameters
         WRITE (HILINE,4015) TSKNAM, CPARM(1), CPARM(2), CPARM(3),
     *      CPARM(4), 'smooth'
         CALL HIADD (LUN1, HILINE, BUFFO, IERR)
         IF (IERR.NE.0) GO TO 100
         WRITE (HILINE,4015) TSKNAM, CPARM(6), CPARM(7), CPARM(8),
     *      CPARM(9), 'clip'
         CALL HIADD (LUN1, HILINE, BUFFO, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       MWF Clipping parameters
      ELSE
         WRITE (HILINE,4009) TSKNAM, CPARM(1), CPARM(2), 'smooth'
         CALL HIADD (LUN1, HILINE, BUFFO, IERR)
         IF (IERR.NE.0) GO TO 100
         WRITE (HILINE,4009) TSKNAM, CPARM(6), CPARM(7), 'clip'
         CALL HIADD (LUN1, HILINE, BUFFO, IERR)
         IF (IERR.NE.0) GO TO 100
         END IF
C                                       Close HI file
 100  CALL HICLOS (LUN1, T, BUFFO, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TYSMHI: ERROR',I3,' OPENING HISTORY FILE')
 1010 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 2002 FORMAT (A6,'SUBARRAY =',I3,1X,A2,'VER =',I4,' /',A2,' table')
 2004 FORMAT (A6,'BIF =',I4,', EIF =',I4,'/ IF range')
 2006 FORMAT (A6,'INTERPOL = ''',A4,''' / Interpolation type')
 2007 FORMAT (A6,'INTPARM = ',2F10.5,' / Interpolation',A)
 4008 FORMAT (A6,'CUTOFF =',F8.5,'  / sum of weights cutoff')
 4009 FORMAT (A6,'CPARM: ',2F10.5,' / MWF clipping parms: ',A)
 4010 FORMAT (A6,'APARM: ',2F12.5,' / Clip min/max Tsys/Pdif')
 4011 FORMAT (A6,'APARM: ',2F12.5,' / Clip min/max Tant/Psum')
 4012 FORMAT (A6,'APARM: ',2F12.5,' / Clip min/max Tcal*Psum/Pdif/2')
 4013 FORMAT (A6,'APARM: ',2F12.5,' / Clip min/max Pgain')
 4015 FORMAT (A6,'CPARM:',4F8.3,' / MWF clip parms: ',A)
 3000 FORMAT (A6,'SOURCES = ''''     /All sources selected')
 3001 FORMAT (A6,'/Sources excluded:')
 3002 FORMAT (A6,'/Sources included:')
 3003 FORMAT (A6,'SOURCES = ''',A16,''',''',A16,'''')
 3004 FORMAT (A6,'         ,''',A16,''',''',A16,'''')
 3005 FORMAT (A6,'ANTENNAS = 0     /All antennas selected')
 3006 FORMAT (A6,'/Antennas excluded:')
 3007 FORMAT (A6,'/Antennas included:')
 3008 FORMAT (A6,'ANTENNAS = ',12(I3,' '))
 3009 FORMAT (A6,'           ',12(I3,' '))
      END
      LOGICAL FUNCTION TYWANT (SOUR, FQID, ANT, SUB, TIME)
C-----------------------------------------------------------------------
C   Function to determine if a source, FQid, antenna, subarray and time
C   have been selected.  Returns .TRUE. if task selection criteria are
C   met else .FALSE.
C   Inputs
C      SOUR     I    Source Id
C      FQID     I    FQ id
C      ANT      I    Antenna number
C      SUB      I    Subarray number
C      TIME     R    Time
C   Inputs from common:
C      SOUWAN   I(*)  List of selected source IDs.
C      NSOUWD   I     Number of values in SOUWAN, 0=any source
C      DOSWNT   L     If .TRUE. values in SOUWAN are selected else
C                     deselected.
C      FREQID   I     Selected FQ id, .le. 0 => any
C      SUBA     I     Selected subarray, .le. 0 => any
C      ANTENS   I(*)  List of selected antennas
C      NANTSL   I     Number of values in ANTENS, 0=any antenna
C      DOAWNT   L     If .TRUE. values in ANTENS are selected else
C                     deselected.
C      TSTART   D     Start time
C      TEND     D     End time
C-----------------------------------------------------------------------
      INTEGER   SOUR, FQID, ANT, SUB
      REAL      TIME
C
      LOGICAL WANT, SLCTD
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'TYSMO.INC'
C-----------------------------------------------------------------------
C                                       Want this source?
      WANT = SLCTD (SOUR, SOUWAN, NSOUWD, DOSWNT)
C                                       Want this FQ id?
      WANT = WANT .AND.
     *   ((FQID.EQ.FREQID) .OR. (FREQID.LE.0) .OR. (FQID.LE.0))
C                                       Check subarray
      WANT = WANT .AND.
     *   ((SUB.EQ.SUBA) .OR. (SUBA.LE.0) .OR. (SUB.LE.0))
C                                       Want this antenna?
      WANT = WANT .AND.
     *   SLCTD (ANT, ANTENS, NANTSL, DOAWNT)
C                                       Check time
      WANT = WANT .AND.
     *   ((TIME.GE.TSTART) .AND. (TIME.LE.TEND))
      TYWANT = WANT
C
 999  RETURN
      END
      SUBROUTINE TYFLAG (LUNI, LUNO, IRET)
C-----------------------------------------------------------------------
C   TVFLAG copies the TY/SY table applying flags to it
C   Inputs:
C      LUNI   I   LUN to use on read
C      LUNO   I   LUN to use on write
C   Outputs:
C      IRET   I   > 0 => quit
C-----------------------------------------------------------------------
      INTEGER   LUNI, LUNO, IRET
C
      INCLUDE 'TYSMO.INC'
      INTEGER   IERR, TIMKOL, SOUKOL, ANTKOL, SUBKOL, FRQKOL, TA1KOL,
     *   TS1KOL, TA2KOL, TS2KOL, NKEY, TYNUMV(MAXSYC), TYKOLS(MAXSYC),
     *   KEY(2,2), KEYSUB(2,2), NUMPOL, NUMIF, NUMANT, ITYRNO, ITYRNI,
     *   NUMREC, IRCODE, PARTFL, FULLFL, NDROP, I, LIMIT, FSOUR, FSUBA,
     *   FFREQI, FANTS(2), FIFS(2), FCHANS(2), IFLAG, IT, TYTIM, TYANT,
     *   NFGREC, FGLUN, TG1KOL, TG2KOL, KOLS(2)
      LOGICAL   TABLE, EXIST, FITASC, PFLAGS(4), WAS1
      REAL      FKEY(2,2), FTIMER(2), TIME
      CHARACTER COLHED(2)*24, REASON*24
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PTYTAB.INC'
      DATA FKEY /1.0, 0.0, 1.0, 0.0/
      DATA KEYSUB /4*1/
      DATA COLHED /'TIME ', 'ANTENNA NO. '/
      DATA IRCODE /0/
C-----------------------------------------------------------------------
      FGLUN = 30
C                                       do not overwrite
      IF (ITYIN.NE.ITYOUT) THEN
         CALL ISTAB (YTYPE, DISKIN, CNOIN, ITYOUT, LUNO, BUFFI, TABLE,
     *      EXIST, FITASC, IERR)
         IF ((EXIST) .OR. (IERR.NE.0)) THEN
            IRET = 1
            MSGTXT = 'CANNOT OVERWRITE A PRE-EXISTING TABLE OTHER' //
     *         ' THAN INPUT'
            GO TO 990
            END IF
         END IF
C                                       Sort TY table to time-antenna
C                                       Need col. pointers, sort order.
      IF (YTYPE.EQ.'TY') THEN
         CALL TYINI ('READ', BUFFO, DISKIN, CNOIN, ITYIN, CATBLK,
     *      LUNI, ITYRNO, TYKOLS, TYNUMV, NUMPOL, NUMIF, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Get column pointers
         NKEY = 2
         CALL FNDCOL (NKEY, COLHED, 24, .TRUE., BUFFO, KOLS, IRET)
         IF ((IRET.GE.1) .AND. (IRET.LE.10)) GO TO 999
         IRET = 0
         TYTIM = KOLS(1)
         TYANT = KOLS(2)
         TIMKOL = TYKOLS(TYRTIM)
         SOUKOL = TYKOLS(TYISID)
         ANTKOL = TYKOLS(TYIANT)
         SUBKOL = TYKOLS(TYISUB)
         FRQKOL = TYKOLS(TYIFQI)
         TS1KOL = TYKOLS(TYRTS1)
         TA1KOL = TYKOLS(TYRTA1)
         TG1KOL = -1
         TG2KOL = -1
         IF (NUMPOL.GT.1) THEN
            TS2KOL = TYKOLS(TYRTS2)
            TA2KOL = TYKOLS(TYRTA2)
         ELSE
            TS2KOL = -1000
            TA2KOL = -1000
            END IF
C                                       SY table
      ELSE
         CALL SYINI ('READ', BUFFO, DISKIN, CNOIN, ITYIN, CATBLK,
     *      LUNI, ITYRNO, TYKOLS, TYNUMV, NUMANT, NUMPOL, NUMIF, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Get column pointers
         NKEY = 2
         CALL FNDCOL (NKEY, COLHED, 24, .TRUE., BUFFO, KOLS, IRET)
         IF ((IRET.GE.1) .AND. (IRET.LE.10)) GO TO 999
         IRET = 0
         TYTIM = KOLS(1)
         TYANT = KOLS(2)
         TIMKOL = TYKOLS(1)
         SOUKOL = TYKOLS(4)
         ANTKOL = TYKOLS(5)
         SUBKOL = TYKOLS(6)
         FRQKOL = TYKOLS(7)
         TS1KOL = TYKOLS(8)
         TA1KOL = TYKOLS(9)
         TG1KOL = TYKOLS(10)
         IF (NUMPOL.GT.1) THEN
            TS2KOL = TYKOLS(11)
            TA2KOL = TYKOLS(12)
            TG2KOL = TYKOLS(13)
         ELSE
            TS2KOL = -1000
            TA2KOL = -1000
            TG2KOL = -1000
            END IF
         END IF
C                                       Close table
      CALL TABIO ('CLOS', 0, ITYRNO, BUFFO, BUFFO, IERR)
      IF ((IERR.NE.0) .OR. (IRET.NE.0)) GO TO 999
      KEY(1,1) = TYTIM
      KEY(1,2) = TYANT
      KEY(2,1) = 0
      KEY(2,2) = 0
C                                       Sort to time-antenna order.
      IF (((BUFFO(43).NE.TYTIM) .OR. (BUFFO(44).NE.TYANT))) THEN
         CALL TABSRT (DISKIN, CNOIN, YTYPE, ITYIN, ITYIN, KEY, KEYSUB,
     *      FKEY, BUFFO, CATBLK, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       sort FG table?
      CALL FGREFM (DISKIN, CNOIN, FGVER, CATBLK, LUNI, IERR)
      CALL FLGINI ('READ', FGBUFF, DISKIN, CNOIN, FGVER, CATBLK, FGLUN,
     *   IFGRNO, FGKOLS, FGNUMV, IERR)
      IF (IERR.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1000) IERR, 'OPENING FLAG TABLE'
         GO TO 990
         END IF
      KEY(1,1) = 5
      KEY(1,2) = 1
      IF (((FGBUFF(43).NE.5) .OR. (FGBUFF(44).NE.1))) THEN
         CALL TABIO ('CLOS', 0, IFGRNO, FGBUFF, FGBUFF, IERR)
         CALL TABSRT (DISKIN, CNOIN, 'FG', FGVER, FGVER, KEY, KEYSUB,
     *      FKEY, BUFFO, CATBLK, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL FLGINI ('READ', FGBUFF, DISKIN, CNOIN, FGVER, CATBLK,
     *      FGLUN, IFGRNO, FGKOLS, FGNUMV, IERR)
         IF (IERR.NE.0) THEN
            IRET = 2
            WRITE (MSGTXT,1000) IERR, 'OPENING FLAG TABLE'
            GO TO 990
            END IF
         END IF
      NFGREC = FGBUFF(5)
      NUMFLG = 0
      TMFLST = -1.E6
C                                       Open files
      IF (YTYPE.EQ.'TY') THEN
         CALL TYINI ('READ', BUFFI, DISKIN, CNOIN, ITYIN, CATBLK, LUNI,
     *      ITYRNI, TYKOLS, TYNUMV, NUMPOL, NUMIF, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL TYINI ('WRIT', BUFFO, DISKIN, CNOIN, ITYOUT, CATBLK,
     *      LUNO, ITYRNO, TYKOLS, TYNUMV, NUMPOL, NUMIF, IRET)
      ELSE
         CALL SYINI ('READ', BUFFI, DISKIN, CNOIN, ITYIN, CATBLK, LUNI,
     *      ITYRNI, TYKOLS, TYNUMV, NUMANT, NUMPOL, NUMIF, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL SYINI ('WRIT', BUFFO, DISKIN, CNOIN, ITYOUT, CATBLK,
     *      LUNO, ITYRNO, TYKOLS, TYNUMV, NUMANT, NUMPOL, NUMIF, IRET)
         END IF
      IF (IRET.NE.0) GO TO 999
      NUMREC = BUFFI(5)
      PARTFL = 0
      FULLFL = 0
      DO 90 ITYRNI = 1,NUMREC
         CALL TABIO ('READ', IRCODE, ITYRNI, RECORD, BUFFI, IRET)
         IF (IRET.LT.0) THEN
            IRET = 0
            GO TO 90
            END IF
         IF (IRET.GT.0) GO TO 900
         IF (YTYPE.EQ.'SY') THEN
            TIME = RECD(TIMKOL)
         ELSE
            TIME = RECR(TIMKOL)
            END IF
C                                       new time: NXTFLG clone
         IF (TMFLST.LT.TIME) THEN
            TMFLST = TIME
C                                       any to drop from list?
 10         NDROP = 0
            IF ((NUMFLG.GT.0) .AND. (TIMORD)) THEN
               DO 20 I = 1,NUMFLG
                  IF (FLGTND(I).LT.TIME) NDROP = I
 20               CONTINUE
               END IF
C                                       Compress, dropping flag.
            IF (NDROP.GT.0) THEN
               IF (NDROP.LT.NUMFLG) THEN
                  LIMIT = NDROP + 1
                  DO 30 I = LIMIT,NUMFLG
                     IT = I - 1
                     FLGTST(IT) = FLGTST(I)
                     FLGTND(IT) = FLGTND(I)
                     FLGSOU(IT) = FLGSOU(I)
                     FLGANT(IT) = FLGANT(I)
                     FLGFQD(IT) = FLGFQD(I)
                     FLGSUB(IT) = FLGSUB(I)
                     FLGBIF(IT) = FLGBIF(I)
                     FLGEIF(IT) = FLGEIF(I)
                     FLGPOL(1,IT) = FLGPOL(1,I)
                     FLGPOL(2,IT) = FLGPOL(2,I)
                     FLGPOL(3,IT) = FLGPOL(3,I)
                     FLGPOL(4,IT) = FLGPOL(4,I)
 30                  CONTINUE
                  END IF
               NUMFLG = NUMFLG - 1
               GO TO 10
               END IF
C                                       read FG table
 40         LIMIT = IFGRNO
            DO 50 I = LIMIT,NFGREC
               IFGRNO = I
               CALL TABFLG ('READ', FGBUFF, IFGRNO, FGKOLS, FGNUMV,
     *            FSOUR, FSUBA, FFREQI, FANTS, FTIMER, FIFS, FCHANS,
     *            PFLAGS, REASON, IERR)
               IF (IERR.GT.0) GO TO 900
               IF (IERR.EQ.0) THEN
                  IF (TIME.LT.FTIMER(1)) GO TO 55
                  IF (TIME.GT.FTIMER(2)) GO TO 50
                  IF ((FFREQI.GT.0) .AND. (FREQID.GT.0) .AND.
     *               (FFREQI.NE.FREQID)) GO TO 50
                  IF ((FIFS(1).GT.0) .AND. (FIFS(1).GT.EIF)) GO TO 50
                  IF ((FIFS(2).GT.0) .AND. (FIFS(2).LT.BIF)) GO TO 50
                  IF ((FSUBA.GT.0) .AND. (SUBA.GT.0) .AND.
     *               (FSUBA.NE.SUBA)) GO TO 50
                  IF ((.NOT.PFLAGS(1)) .AND. (.NOT.PFLAGS(2))) GO TO 50
                  IF ((FANTS(1).GT.0) .AND. (FANTS(2).GT.0)) GO TO 50
C                                       ignore channel dependent
                  IF (FCHANS(1).LE.0) FCHANS(1) = 1
                  IF (FCHANS(2).LE.0) FCHANS(2) = CATBLK(KINAX+JLOCF)
                  IF ((FCHANS(1).GT.1) .OR.
     *               (FCHANS(2).LT.CATBLK(KINAX+JLOCF))) GO TO 50
                  IF (NUMFLG.EQ.MAXFLG) THEN
                     MSGTXT = 'NUMBER OF FLAGS AT 1 TIME EXCEEDS LIMIT'
                     CALL MSGWRT (7)
                     MSGTXT = 'NOT ALL TABLE ROWS PROPERLY FLAGGED'
                     CALL MSGWRT (7)
                     GO TO 60
                     END IF
                  NUMFLG = NUMFLG + 1
C                                       Fill in tables
                  FLGTST(NUMFLG) = FTIMER(1)
                  FLGTND(NUMFLG) = FTIMER(2)
                  FLGSOU(NUMFLG) = FSOUR
                  FLGFQD(NUMFLG) = FFREQI
                  FLGANT(NUMFLG) = MAX (FANTS(1), FANTS(2))
                  FLGSUB(NUMFLG) = FSUBA
                  FLGBIF(NUMFLG) = FIFS(1)
                  FLGEIF(NUMFLG) = FIFS(2)
                  IF (FLGBIF(NUMFLG).LE.0) FLGBIF(NUMFLG) = 1
                  IF (FLGEIF(NUMFLG).LE.0) THEN
                     IF (JLOCIF.GT.0) FLGEIF(NUMFLG) =
     *                  CATBLK(KINAX+JLOCIF)
                     IF (JLOCIF.LE.0) FLGEIF(NUMFLG) = 1
                     END IF
C
                  CALL COPY (4, PFLAGS, FLGPOL(1,NUMFLG))
                  GO TO 40
                  END IF
 50            CONTINUE
 55         IFGRNO = IFGRNO - 1
            END IF
C                                       end get new flags
C                                       check flags to see if apply
 60      WAS1 = .FALSE.
         DO 70 IFLAG = 1,NUMFLG
            IF ((TIME.LT.FLGTST(IFLAG)) .OR. (TIME.GT.FLGTND(IFLAG)))
     *         GO TO 70
            I = RECORD(SOUKOL)
            IF ((FLGSOU(IFLAG).GT.0) .AND. (I.NE.FLGSOU(IFLAG)) .AND.
     *         (I.GT.0)) GO TO 70
            I = RECORD(ANTKOL)
            IF ((FLGANT(IFLAG).NE.I) .AND. (FLGANT(IFLAG).GT.0) .AND.
     *         (I.GT.0)) GO TO 70
            I = RECORD(SUBKOL)
            IF ((FLGSUB(IFLAG).NE.I) .AND. (FLGSUB(IFLAG).GT.0) .AND.
     *         (I.GT.0)) GO TO 70
            I = RECORD(FRQKOL)
            IF ((FLGFQD(IFLAG).NE.I) .AND. (FLGFQD(IFLAG).GT.0) .AND.
     *         (I.GT.0)) GO TO 70
            CALL COPY (4, FLGPOL(1,IFLAG), PFLAGS)
C                                       something to be flagged w this
            DO 65 I = FLGBIF(IFLAG),FLGEIF(IFLAG)
               IF (PFLAGS(1)) THEN
                  RECR(TS1KOL+I-1) = FBLANK
                  RECR(TA1KOL+I-1) = FBLANK
                  IF (TG1KOL.GT.0) RECR(TG1KOL+I-1) = FBLANK
                  END IF
               IF ((NUMPOL.GT.1) .AND. (PFLAGS(2))) THEN
                  RECR(TS2KOL+I-1) = FBLANK
                  RECR(TA2KOL+I-1) = FBLANK
                  IF (TG2KOL.GT.0) RECR(TG2KOL+I-1) = FBLANK
                  END IF
 65            CONTINUE
            WAS1 = .TRUE.
 70         CONTINUE
C                                       all bad?
         IF (WAS1) THEN
            PARTFL = PARTFL + 1
            DO 75 I = BIF,EIF
               IF (RECR(TS1KOL+I-1).NE.FBLANK) GO TO 80
               IF (RECR(TA1KOL+I-1).NE.FBLANK) GO TO 80
               IF (TG1KOL.GT.0) THEN
                  IF (RECR(TG1KOL+I-1).NE.FBLANK) GO TO 80
                  END IF
               IF (TG2KOL.GT.0) THEN
                  IF (RECR(TG2KOL+I-1).NE.FBLANK) GO TO 80
                  END IF
               IF (NUMPOL.GT.1) THEN
                  IF (RECR(TS2KOL+I-1).NE.FBLANK) GO TO 80
                  IF (RECR(TA2KOL+I-1).NE.FBLANK) GO TO 80
                  END IF
 75            CONTINUE
            FULLFL = FULLFL + 1
            GO TO 90
            END IF
 80      CALL TABIO ('WRIT', IRCODE, ITYRNO, RECORD, BUFFO, IRET)
         IF (IRET.GT.0) GO TO 900
         ITYRNO = ITYRNO + 1
 90      CONTINUE
      PARTFL = PARTFL - FULLFL
      WRITE (MSGTXT,1090) ITYRNO, ITYIN, ITYOUT
      CALL MSGWRT (3)
      WRITE (MSGTXT,1091) PARTFL
      IF (PARTFL.GT.0) CALL MSGWRT (3)
      WRITE (MSGTXT,1092) FULLFL
      IF (FULLFL.GT.0) CALL MSGWRT (3)
C
 900  CALL TABIO ('CLOS', 0, NUMREC, BUFFI, BUFFI, IERR)
      CALL TABIO ('CLOS', 0, ITYRNO, BUFFO, BUFFO, IERR)
      CALL TABIO ('CLOS', 0, IFGRNO, FGBUFF, FGBUFF, IERR)
      GO TO 999
C
 990  IF (IRET.GT.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TYFLAG: ERROR',I5,1X,A)
 1090 FORMAT ('TYFLAG: wrote',I9,' records from table',I3,' to table',
     *   I3)
 1091 FORMAT ('TYFLAG:      ',I9,' records were partly flagged')
 1092 FORMAT ('TYFLAG:      ',I9,' records were omitted since',
     *   ' fully flagged')
      END

LOCAL INCLUDE 'MARSP.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQ(2), DISK(2), OLDCNO(2), CATOLD(256), JBUFSZ,
     *   SCRTCH(256), NPARM, NBOXES, NPIX(3)
      LOGICAL   ISQU
      HOLLERITH XNAME1(3), XCLAS1(2), XNAME2(3), XCLAS2(2), XFUNC(1)
      CHARACTER NAMEIN(2)*12, CLAIN(2)*6
      REAL      XSEQ1, XDISK1, XSEQ2, XDISK2, BLC(7), TRC(7),
     *   CPARM(10), DOPLOT, XNBOX, XPIXR(2), XGRCH, XDOTV,
     *   BUFF1(MABFSS), HISTO(1801)
      COMMON /INPARM/ XNAME1, XCLAS1, XSEQ1, XDISK1, XNAME2, XCLAS2,
     *   XSEQ2, XDISK2, BLC, TRC, CPARM, DOPLOT, XNBOX, XPIXR, XGRCH,
     *   XFUNC, XDOTV
      COMMON /CHPARM/ NAMEIN, CLAIN
      COMMON /PARMS/ CATOLD, SEQ, DISK, OLDCNO, JBUFSZ, ISQU, NPARM,
     *   HISTO, NBOXES, NPIX
      COMMON /BUFRS/ BUFF1, SCRTCH
LOCAL END
      PROGRAM MARSP
C-----------------------------------------------------------------------
C! Measure MARS polarization
C# Map-util Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 2012, 2021-2022, 2024-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image. POLI or Q
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      IN2NAME        NAMOUT        Name of the input image POLA or U
C      IN2CLASS       CLAOUT        Class of the input image.
C      IN2SEQ         SEQIN2        Seq. number of input image.
C      IN2DISK        DISK2         Disk number of input image.
C      BLC(7)         BLC           Bottom left corner of subimage
C      TRC(7)         TRC           Top right corner of subimage.
C      CPARM(10)      CPARM         User specified array.
C      DOPLOT         DOPLOT        > Make histogram plot
C      FUNCTYPE       XFUNC         'LG'
C      DOTV           DOTV          > 0 on the TV, else plot file
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, NWORDS
      REAL      POLI(2), POLA(2)
      LONGINT   PPOLI, PPOLA
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'MARSP.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'MARSP '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL MARSPI (PRGM, IRET)
C                                       dynamic memory
      IF (IRET.EQ.0) THEN
         NWORDS = (CATBLK(KINAX) * CATBLK(KINAX+1) - 1) / 1024 + 5
         CALL ZMEMRY ('GET ', TSKNAM, NWORDS, POLI, PPOLI, IRET)
         IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, POLA,
     *      PPOLA, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'FAILED TO GET DYNAMIC MEMORY'
            CALL MSGWRT (8)
            END IF
         END IF
C                                       read images, analyze
      IF (IRET.EQ.0) CALL MARSPD (CATBLK(KINAX), CATBLK(KINAX+1),
     *      POLI(1+PPOLI), POLA(1+PPOLA), IRET)
      IF ((IRET.EQ.0) .AND. (DOPLOT.GT.0.0)) CALL MARSPL (IRET)
C                                       Close down files, etc.
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE MARSPI (PRGN, IRET)
C-----------------------------------------------------------------------
C   MARSPI gets input parameters for MARSP and creates an output file.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, MTYPE*2
      INTEGER   IERR, IROUND, I, IOFF
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'MARSP.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 45
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAME1, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAME1, NAMEIN(1))
      CALL H2CHR (12, 1, XNAME2, NAMEIN(2))
      CALL H2CHR (6, 1, XCLAS1, CLAIN(1))
      CALL H2CHR (6, 1, XCLAS2, CLAIN(2))
C                                       Crunch input parameters.
      SEQ(1) = IROUND (XSEQ1)
      SEQ(2) = IROUND (XSEQ2)
      DISK(1) = IROUND (XDISK1)
      DISK(2) = IROUND (XDISK2)
      NBOXES = IROUND (XNBOX) + 1
      NBOXES = MAX (10, MIN (1801, NBOXES))
      XNBOX = NBOXES - 1
      IF (XPIXR(1).GE.XPIXR(2)) THEN
         XPIXR(1) = -90.
         XPIXR(2) = 90.
         END IF
      CALL FILL (3, 0, NPIX)
C                                       Create new file.
C                                       Get CATBLK from old file.
      DO 20 I = 1,2
         OLDCNO(I) = 1
         MTYPE = 'MA'
         CALL CATDIR ('SRCH', DISK(I), OLDCNO(I), NAMEIN(I), CLAIN(I),
     *      SEQ(I), MTYPE, NLUSER, STAT, SCRTCH, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR, NAMEIN(I), CLAIN(I), SEQ(I),
     *         DISK(I), NLUSER
            GO TO 990
            END IF
C                                       Read CATBLK and mark 'READ'.
         STAT = 'READ'
         IF ((I.EQ.1) .AND. (XDOTV.LE.0.0) .AND. (DOPLOT.GT.0.0))
     *      STAT = 'WRIT'
         CALL CATIO ('READ', DISK(I), OLDCNO(I), CATBLK, STAT, SCRTCH,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1040) IERR
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISK(I)
         FCNO(NCFILE) = OLDCNO(I)
         FRW(NCFILE) = 0
         IF (STAT.EQ.'WRIT') FRW(NCFILE) = 1
C                                       Copy old CATBLK to new.
         IF (I.EQ.1) CALL COPY (256, CATBLK, CATOLD)
 20      CONTINUE
C                                       is it Q and U
      CALL AXEFND (6, 'STOKES', CATBLK(KIDIM), CATH(KHCTP), IOFF, IERR)
      IF (IERR.EQ.0) THEN
         ISQU = ABS (CATD(KDCRV+IOFF)-3.0D0).LT.0.1
      ELSE
         MSGTXT = 'NO STOKES AXIS!  ASSUMING POLI AND POLA'
         CALL MSGWRT (8)
         END IF
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IERR)
      IF (IERR.EQ.0) IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MARSPI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE MARSPD (NX, NY, POLI, POLA, IRET)
C-----------------------------------------------------------------------
C   MARSPD reads in 2 images and analyzes them
C   Input:
C      NX     I      X dimension (full)
C      NY     I      Y dimension
C   Output:
C      POLI   R(*)   POLI image
C      POLA   R(*)   POLA image
C      IRET   I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NX, NY, IRET
      REAL      POLA(NX,*), POLI(NX,*)
C
      CHARACTER IFILE*48
      INTEGER   LUNI, WINI(4), I, IY, BOI, IPOS(7), BOTEMP, IBIND, INDI,
     *   IBLC(2), ITRC(2)
      REAL      OLD4(256)
      DOUBLE PRECISION OLD8(128)
      LOGICAL   T, F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'MARSP.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (CATOLD, OLD4, OLD8)
      DATA LUNI /16/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       read in two images
      DO 50 I = 1,2
C                                       Open and init for read
         CALL ZPHFIL ('MA', DISK(I), OLDCNO(I), 1, IFILE, IRET)
         CALL ZOPEN (LUNI, INDI, DISK(I), IFILE, T, F, T, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN INPUT FILE', I
            GO TO 990
            END IF
C                                       Setup for I/O
         WINI(1) = 1
         WINI(2) = 1
         WINI(3) = NX
         WINI(4) = NY
C                                       Loop
         IPOS(7) = BLC(7) + 0.1
         IPOS(6) = BLC(6) + 0.1
         IPOS(5) = BLC(5) + 0.1
         IPOS(4) = BLC(4) + 0.1
         IPOS(3) = BLC(3) + 0.1
C                                       Init. files, first input.
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI, INDI, NX, NY, WINI, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT READ INPUT', I
            GO TO 990
            END IF
         DO 20 IY = 1,NY
C                                       Read.
            CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ INPUT IMAGE', I
               GO TO 990
               END IF
C                                       save
            IF (I.EQ.1) THEN
               CALL RCOPY (NX, BUFF1(IBIND), POLI(1,IY))
            ELSE
               CALL RCOPY (NX, BUFF1(IBIND), POLA(1,IY))
               END IF
 20         CONTINUE
         CALL ZCLOSE (LUNI, INDI, IRET)
 50      CONTINUE
      IF (ISQU) THEN
         CALL POLFND (NX, NY, POLI, POLA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET, 'CONVERTING Q AND U'
            GO TO 990
            END IF
         END IF
C                                       window
      IBLC(1) = BLC(1) + 0.1
      IBLC(2) = BLC(2) + 0.1
      ITRC(1) = TRC(1) + 0.1
      ITRC(2) = TRC(2) + 0.1
C                                       default cutoff
      IF (CPARM(1).LE.0.0) THEN
         CALL FNDRMS (NX, NY, POLI, CPARM(1), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET, 'FINDING RMS FOR CPARM(1)'
            GO TO 990
            END IF
         CPARM(1) = 3.0 * CPARM(1)
         END IF
      IF ((CPARM(2).LT.IBLC(1)) .OR. (CPARM(2).GT.ITRC(1)) .OR.
     *   (CPARM(3).LT.IBLC(2)) .OR. (CPARM(3).GT.ITRC(2))) THEN
         CALL FNDCEN (NX, NY, IBLC, ITRC, POLI, CPARM(2), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET, 'FINDING CENTROID'
            GO TO 990
            END IF
         END IF
      CPARM(4) = MAX (0.0, CPARM(4))
      IF (CPARM(5).LE.CPARM(4)) CPARM(5) = 100000.

C                                       tell adverbs
      WRITE (MSGTXT,1110) CPARM(1), CPARM(2), CPARM(3), CPARM(4)
      CALL MSGWRT (5)
C                                       do it
      CALL FNDANS (NX, NY, IBLC, ITRC, POLI, POLA, CPARM, DOPLOT,
     *   NBOXES, XPIXR, HISTO, NPIX, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) IRET, 'FINDING ANSWER'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MARSPD: ERROR',I3,' ON ',A,' FILE',I2)
 1100 FORMAT ('MARSPD: ERROR',I3,' ON ',A)
 1110 FORMAT ('Using CPARM=',F10.6,3F9.3)
      END
      SUBROUTINE POLFND (NX, NY, POLIQ, POLAU, IRET)
C-----------------------------------------------------------------------
C   Inputs
C      NX      I      X dimension
C      NY      I      Y dimension
C   In/out:
C      POLIQ   R(*)   Image: in Q out POLA
C      POLAU   R(*)   Image: in U out POLi
C   Outputs
C      IRET    I      > 0 if fails
C-----------------------------------------------------------------------
      INTEGER   NX, NY, IRET
      REAL      POLIQ(NX,*), POLAU(NX,*)
C
      INTEGER   IX, IY
      REAL      AMP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      DO 30 IY = 1,NY
         DO 20 IX = 1,NX
            IF ((POLIQ(IX,IY).EQ.FBLANK) .OR. (POLAU(IX,IY).EQ.FBLANK))
     *         THEN
               POLIQ(IX,IY) = FBLANK
               POLAU(IX,IY) = FBLANK
            ELSE IF ((POLIQ(IX,IY).EQ.0.0) .AND. (POLAU(IX,IY).EQ.0.0))
     *         THEN
               POLIQ(IX,IY) = FBLANK
               POLAU(IX,IY) = FBLANK
            ELSE
               AMP = SQRT (POLIQ(IX,IY)**2 + POLAU(IX,IY)**2)
               POLAU(IX,IY) = ATAN2 (POLAU(IX,IY), POLIQ(IX,IY)) *
     *            RAD2DG / 2.0
               POLIQ(IX,IY) = AMP
               END IF
 20         CONTINUE
 30      CONTINUE
      IRET = 0
C
 999  RETURN
      END
      SUBROUTINE FNDRMS (NX, NY, IMAGE, RMS, IRET)
C-----------------------------------------------------------------------
C   Inputs
C      NX      I      X dimension
C      NY      I      Y dimension
C      IMAGE   R(*)   Image
C   Outputs
C      RMS     R      RMS
C      IRET    I      > 0 if fails
C-----------------------------------------------------------------------
      INTEGER   NX, NY, IRET
      REAL      IMAGE(NX,*), RMS
C
      INTEGER   IX, IY, NPASS, SN
      DOUBLE PRECISION RSP, RSM, SS, SQ, RM, RS, T
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      RSP = 1.D10
      RSM = -1.D10
      IRET = 0
      DO 50 NPASS = 1,7
         SS = 0.0D0
         SQ = 0.0D0
         SN = 0
         DO 20 IY = 1,NY
            DO 10 IX = 1,NX
               IF (IMAGE(IX,IY).NE.FBLANK) THEN
                  T = IMAGE(IX,IY)
                  IF ((T.LT.RSP) .AND. (T.GT.RSM)) THEN
                     SS = SS + T
                     SQ = SQ + T * T
                     SN = SN + 1
                     END IF
                  END IF
 10            CONTINUE
 20         CONTINUE
         IF (SN.LE.0) THEN
            RSP = RSP + 3.0D0 * RS
            RSM = RSM - 3.0D0 * RS
         ELSE
            RM = SS / SN
            SQ = SQ / SN
            RS = SQ - RM * RM
            RS = SQRT (MAX (0.0D0, RS))
            RS = MAX (RS, 0.001D0*RM)
            RSP = RM + 3.0D0 * RS
            RSM = RM - 3.0D0 * RS
            END IF
 50      CONTINUE
      IF (SN.LE.0) THEN
         IRET = 1
         RMS = 0.0
      ELSE
         IRET = 0
         RMS = RS
         END IF
C
 999  RETURN
      END
      SUBROUTINE FNDCEN (NX, NY, IBLC, ITRC, IMAGE, CENT, IRET)
C-----------------------------------------------------------------------
C   Inputs
C      NX      I      X dimension
C      NY      I      Y dimension
C      IBLC    I(2)   blc of computation
C      ITRC    I(2)   trc of computation
C      IMAGE   R(*)   Image
C   Outputs
C      CENT    R(2)   Centroid X,Y
C      IRET    I      > 0 if fails
C-----------------------------------------------------------------------
      INTEGER   NX, NY, IBLC(2), ITRC(2), IRET
      REAL      IMAGE(NX,*), CENT(2)
C
      INTEGER   IX, IY
      DOUBLE PRECISION XCEN, YCEN, TSUM, T
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
      XCEN = 0.0D0
      YCEN = 0.0D0
      TSUM = 0.0D0
      DO 20 IY = IBLC(2),ITRC(2)
         DO 10 IX = IBLC(1),ITRC(1)
            IF (IMAGE(IX,IY).NE.FBLANK) THEN
               T = IMAGE(IX,IY)
               XCEN = XCEN + T * IX
               YCEN = YCEN + T * IY
               TSUM = TSUM + T
               END IF
 10         CONTINUE
 20      CONTINUE
C                                       answer
      IF (TSUM.LE.0.0D0) THEN
         IRET = 2
      ELSE
         CENT(1) = XCEN / TSUM
         CENT(2) = YCEN / TSUM
         END IF
C
 999  RETURN
      END
      SUBROUTINE FNDANS (NX, NY, IBLC, ITRC, POLI, POLA, CPARM, DOPLOT,
     *   NBOXES, XPIXR, HISTO, NPIX, IRET)
C-----------------------------------------------------------------------
C   Does computation, prints answer
C   Inputs:
C      NX       I      Number X pixels
C      NY       I      Number Y pixels
C      IBLC     I(2)   BLC to examine
C      ITRC     I(2)   TRC to examine
C      POLI     R(*)   Polarization intensity image
C      POLA     R(*)   Polarization angle image
C      CPARM    R(5)   (1) POLI cutoff, (2,3) X,Y center pixel
C                      (4,5) inner, outer radisu in pixels
C      DOPLOT   R      > 1.5 sum weights, else count
C      XPIXR    R(2)   plot range
C   Output
C      HISTO    R(*)   histogram (0.5 degree cells
C      CPARM    R(2)   (9,10) mean, rms
C      NPIX     i(3)   # below, #in, #above
C      IRET     I      error code: 0 okay
C-----------------------------------------------------------------------
      INTEGER   NX, NY, IBLC(2), ITRC(2), NBOXES, NPIX(3), IRET
      REAL      POLI(NX,*), POLA(NX,*), CPARM(10), DOPLOT, XPIXR(2),
     *   HISTO(*)
C
      INTEGER   IX, IY, SN, DROUND, IA
      DOUBLE PRECISION SS, SST, SQ, SQT, ST, T, X, Y, ANG, PA, DIF,
     *   AREA, RAD, OFFS, A, SCAL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      CALL RFILL (1801, 0.0, HISTO)
      SS = 0.0D0
      SQ = 0.0D0
      ST = 0.0D0
      SST = 0.0D0
      SQT = 0.0D0
      SN = 0
      SCAL = (NBOXES-1.0) / (XPIXR(2) - XPIXR(1))
      OFFS = 0.0D0
      DO 100 IY = IBLC(2),ITRC(2)
         DO 90 IX = IBLC(1),ITRC(1)
            IF ((POLI(IX,IY).NE.FBLANK) .AND. (POLA(IX,IY).NE.FBLANK))
     *         THEN
               IF (POLI(IX,IY).GT.CPARM(1)) THEN
                  X = CPARM(2) - IX
                  Y = IY - CPARM(3)
                  RAD = SQRT (X*X + Y*Y)
                  IF ((RAD.GT.CPARM(4)) .AND. (RAD.LT.CPARM(5))) THEN
                     ANG = RAD2DG * ATAN2 (X, Y)
                     IF (ANG.LT.-180.0D0) ANG = ANG + 360.0D0
                     IF (ANG.GT.180.0D0) ANG = ANG - 360.0D0
                     IF (ANG.LT.-90.0D0) ANG = ANG + 180.0D0
                     IF (ANG.GT.90.0D0) ANG = ANG - 180.0D0
                     PA = POLA(IX,IY) + OFFS
                     DIF = PA - ANG
                     IF (DIF.GT.90.0) DIF = DIF - 180.0
                     IF (DIF.LT.-90.0) DIF = DIF + 180.0
                     A = (DIF -XPIXR(1)) * SCAL + 1.0D0
                     IA = DROUND (A)
                     IF (IA.LT.1) THEN
                        NPIX(1) = NPIX(1) + 1
                     ELSE IF (IA.GT.NBOXES) THEN
                        NPIX(3) = NPIX(3) + 1
                     ELSE IF (DOPLOT.GT.1.5) THEN
                        NPIX(2) = NPIX(2) + 1
                        HISTO(IA) = HISTO(IA) + T
                     ELSE
                        NPIX(2) = NPIX(2) + 1
                        HISTO(IA) = HISTO(IA) + 1.0
                        END IF
                     T = POLI(IX,IY)
                     SS = SS + DIF
                     SQ = SQ + DIF * DIF
                     SN = SN + 1
                     SST = SST + T * DIF
                     SQT = SQT + T * DIF * DIF
                     ST = ST + T
                     END IF
                  END IF
               END IF
 90         CONTINUE
 100     CONTINUE
C                                       answer
      IF (SN.LE.0) THEN
         MSGTXT = 'NO POINTS FOUND'
         CALL MSGWRT (8)
         IRET = 10
      ELSE
         IRET = 0
         SST = SST / ST
         SQT = SQT / ST - SST * SST
         SQT = SQRT (MAX (0.0D0, SQT))
         MSGTXT = 'Observed angle minus radial angle:'
         CALL MSGWRT (5)
         WRITE (MSGTXT,1100) 'Weighted', SST, SQT, SN
         CALL MSGWRT (5)
         AREA = 1.1331 * CATR(KRBMJ) * CATR(KRBMN) / (CATR(KRCIC) *
     *      CATR(KRCIC+1))
         AREA = SN / ABS (AREA)
         CPARM(10) = SQT
         SQT = SQT / SQRT (AREA)
         WRITE (MSGTXT,1110) 'Weighted', SST, SQT, AREA
         CALL MSGWRT (5)
         CPARM(9) = SST
         SS = SS / SN
         SQ = SQ / SN - SS * SS
         SQ = SQRT (MAX (0.0D0, SQ))
         WRITE (MSGTXT,1100) 'NoWeight', SS, SQ, SN
         CALL MSGWRT (5)
         SQ = SQ / SQRT (AREA)
         WRITE (MSGTXT,1110) 'NoWeight', SS, SQ, AREA
         CALL MSGWRT (5)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT (A,' angl diff',F8.2,' +-',F8.2,' (rms ) deg',I9,
     *   ' pixels')
 1110 FORMAT (A,' mean diff',F8.2,' +-',F8.2,' (p.e.) deg',F9.2,
     *   ' beams')
      END
      SUBROUTINE MARSPL (IRET)
C-----------------------------------------------------------------------
C   Makes a histogram plot
C   Outputs
C     IRET   I   Error code: > 0 error
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'MARSP.INC'
      INTEGER   I, ILO, IHI, PVER, PLBUFF(256), TVCHN, GRCHN, TVCORN(2),
     *   PLUN, PIND, ID(3), IT(3), NCHAR, IDEPTH(5), LABEL, JTRIM, IC
      LOGICAL   DOTV
      CHARACTER FUNCTY*4, PNAME*48, CHT8*8, STRING*80, ADATE*12, NS*18,
     *   ATIME*8
      REAL      XRANGE(2), YRANGE(2), X, Y, DX, DY, CATOR(256), XSCALE,
     *   YSCALE, XBLC(2), XTRC(2), CH(4), XYRATO, IMAX
      DOUBLE PRECISION CATOD(128), XX
      HOLLERITH CATOH(256)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DTVC.INC'
      EQUIVALENCE (CATOLD, CATOH, CATOR, CATOD)
      DATA TVCHN, TVCORN /3*0/
      DATA PLUN, IDEPTH, LABEL /23, 5*1, 3/
C-----------------------------------------------------------------------
      GRCHN = XGRCH
C                                       find range, values
      ILO = 0
      IHI = 0
      IMAX = 0
      DO 20 I = 1,1801
         IF (HISTO(I).GT.0.0) THEN
            IF (ILO.LE.0) ILO = I
            IHI = I
            IMAX = MAX (IMAX, HISTO(I))
            END IF
 20      CONTINUE
C                                       set ranges
      CALL H2CHR (4, 1, XFUNC, FUNCTY)
      IF (DOPLOT.GT.1.5) FUNCTY = ' '
      IF (FUNCTY.EQ.'LG') THEN
         YRANGE(1) = LOG10 (0.5)
         YRANGE(2) = LOG10 (IMAX+0.0)
      ELSE
         YRANGE(1) = 0.0
         YRANGE(2) = IMAX
         END IF
      ILO = MAX (1, ILO-1)
      IHI = MIN (NBOXES, IHI+1)
      IC = (NBOXES-1) / 2 + 1
      XRANGE(1) = (ILO-1) * (XPIXR(2)-XPIXR(1)) / (NBOXES-1.) + XPIXR(1)
      XRANGE(2) = (IHI-1) * (XPIXR(2)-XPIXR(1)) / (NBOXES-1.) + XPIXR(1)
      DOTV = XDOTV.GT.0.0
C                                       not doing METSCA
C     CALL GTICNT (3, YRANGE, I)
      I = LOG10 (YRANGE(2)) + 1.0
      CH(1) = I + 4.0
      CH(2) = 2.0 + 3 * 1.333
      CH(3) = 0.5
      CH(4) = 2.0 + 2 * 1.333
C                                       Add plot file to CATBLK
      PVER = 0
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', DISK(1), OLDCNO(1), CATOLD, PLBUFF, .TRUE.,
     *      'WRIT', PVER, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATING PLOT FILE'
            GO TO 990
         END IF
      END IF
C                                       Open the plot file
      CALL ZPHFIL ('PL', DISK(1), OLDCNO(1), PVER, PNAME, IRET)
      CALL GINIT (DISK(1), OLDCNO(1), PNAME, 0, 79, NPARM, XNAME1, DOTV,
     *   TVCHN, GRCHN, TVCORN, CATOLD, PLBUFF, PLUN, PIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT THE PLOT FILE'
         GO TO 990
         END IF
C                                       Set XBLC, XTRC, XYRATO.
      XBLC(1) = -1.0
      XBLC(2) = -1.0
      XTRC(1) = 102.0
      XTRC(2) = 102.0
C                                       Set coordinate common
      LOCNUM = 1
      RPVAL(1,LOCNUM) = XRANGE(1)
      RPVAL(2,LOCNUM) = YRANGE(1)
      RPLOC(1,LOCNUM) = 1.0
      RPLOC(2,LOCNUM) = 1.0
      AXINC(1,LOCNUM) = (XRANGE(2) - XRANGE(1)) / 99.0
      AXINC(2,LOCNUM) = (YRANGE(2) - YRANGE(1)) / 99.0
      ROT(LOCNUM) = 0.0
      NCHLAB(1,LOCNUM) = 0
      NCHLAB(2,LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      CORTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 4
      AXFUNC(1,LOCNUM) = 0
      AXFUNC(2,LOCNUM) = 0
      NCHLAB(1,LOCNUM) = 0
      NCHLAB(2,LOCNUM) = 0
      CTYP(1,LOCNUM) = 'Degrees'
      IF (FUNCTY.EQ.'LG') THEN
         CTYP(2,LOCNUM) = 'LOG10 (counts)'
      ELSE IF (DOPLOT.GT.1.5) THEN
         CTYP(2,LOCNUM) = 'Sum brightness'
      ELSE
         CTYP(2,LOCNUM) = 'Counts'
         END IF
      CPREF(1,LOCNUM) = ' '
      CPREF(2,LOCNUM) = ' '
      IF (DOTV) THEN
         DX = WINDTV(3) - WINDTV(1) + 1 - CSIZTV(1) * (CH(1) + CH(3))
         DY = WINDTV(4) - WINDTV(2) + 1 - CSIZTV(2) * (CH(2) + CH(4))
         XYRATO = 1.0
         IF (DY.GT.0.0) XYRATO = DX / DY
      ELSE
         XYRATO = 1.0
         END IF
C                                       Initialize for line drawing
      CALL GINITL (XBLC, XTRC, XYRATO, CH, IDEPTH, PLBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT FOR LINE DRAWING'
         GO TO 990
         END IF
      CALL GLTYPE (1, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                       Draw borders.
      CALL GPOS (XBLC(1), XBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (XTRC(1), XBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (XTRC(1), XTRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (XBLC(1), XTRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (XBLC(1), XBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                       Calculate range and scales.
      XSCALE = 99.0 / (XRANGE(2) - XRANGE(1))
      YSCALE = 99.0 / (YRANGE(2) - YRANGE(1))
C                                       Labeling: source, freq, etc
      DX = 0.0
      DY = 0.5
      CALL H2CHR (8, 1, CATOH(KHOBJ), CHT8)
      XX = (CATOD(KDCRV+2) + CATOR(KRCIC+2) * (1.0 - CATOR(KRCRP+2)))
     *   / 1.0E6
      WRITE (STRING,1030) CHT8, XX
      NS = NAMEIN(1) // CLAIN(1)
      CALL NAMEST (NS, CATOLD(KIIMS), STRING(31:), I)
      CALL REFRMT (STRING, '_', NCHAR)
      CALL GPOS (XBLC(1), XTRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GCHAR (NCHAR, 0, DX, DY, STRING, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                       Labeling: date
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, ATIME, ADATE)
      WRITE (STRING,1031) PVER, ADATE, ATIME
      DY = DY + 1.333
      CALL REFRMT (STRING, '_', NCHAR)
      CALL GPOS (XBLC(1), XTRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GCHAR (NCHAR, 0, DX, DY, STRING, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                       what is plotted
      STRING = 'Observed position angle minus radial position angle'
      NCHAR = JTRIM (STRING)
      CALL GPOS (XBLC(1), XBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      DY = -1.5 - 2 * 1.333
      CALL GCHAR (NCHAR, 0, DX, DY, STRING, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      DY = DY - 1.333
      WRITE (STRING,1035) NPIX
      CALL REFRMT (STRING, '_', NCHAR)
      CALL GCHAR (NCHAR, 0, DX, DY, STRING, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                       tick marks, labels, ...
      CALL CLAB1 (XBLC, XTRC, CH, LABEL, XYRATO, .FALSE., PLBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'DRAWING TICK MARKS'
         GO TO 990
         END IF
C                                       Draw the fit
      CALL GLTYPE (3, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      X = (CPARM(9) - XRANGE(1)) * XSCALE
      Y = 0.0
      CALL GPOS (X, Y, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      Y = (YRANGE(2) - YRANGE(1)) * 0.1
      Y = Y * YSCALE
      CALL GVEC (X, Y, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      X = (CPARM(9) - CPARM(10) - XRANGE(1)) * XSCALE
      Y = 0.0
      CALL GPOS (X, Y, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      Y = (YRANGE(2) - YRANGE(1)) * 0.05
      Y = Y * YSCALE
      CALL GVEC (X, Y, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      X = (CPARM(9) + CPARM(10) - XRANGE(1)) * XSCALE
      Y = 0.0
      CALL GPOS (X, Y, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      Y = (YRANGE(2) - YRANGE(1)) * 0.05
      Y = Y * YSCALE
      CALL GVEC (X, Y, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                       Draw the histogram
      CALL GLTYPE (2, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      DO 40 I = ILO,IHI
         X = (I-1) * (XPIXR(2)-XPIXR(1)) / (NBOXES-1.) + XPIXR(1)
         X = (X - XRANGE(1)) * XSCALE
         IF (FUNCTY.EQ.'LG') THEN
            Y = HISTO (I)
            IF (Y.LE.0.0) THEN
               Y = LOG10 (0.5)
            ELSE
               Y = LOG10 (Y)
               END IF
         ELSE
            Y = HISTO(I)
            END IF
         Y = (Y - YRANGE(1)) * YSCALE
         IF (I.EQ.ILO) THEN
            CALL GPOS (X, Y, PLBUFF, IRET)
         ELSE
            CALL GVEC (X, Y, PLBUFF, IRET)
            END IF
         IF (IRET.NE.0) GO TO 980
 40      CONTINUE
      CALL GFINIS (PLBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINISHING THE PLOT'
         GO TO 990
         END IF
      WRITE (MSGTXT,1040) PVER
      IF (.NOT.DOTV) CALL MSGWRT (3)
      GO TO 999
C
 980  WRITE (MSGTXT,1000) IRET, 'PLOTTING LINES AND THE LIKE'
 990  CALL MSGWRT (8)
C                                       Destroy the PLot file on error.
      IF (PVER.GT.0) THEN
         WRITE (MSGTXT,1990) PVER
         CALL MSGWRT (8)
         CALL ZCLOSE (PLUN, PIND, I)
         CALL ZDESTR (DISK(1), PNAME, I)
         CALL DELEXT ('PL', DISK(1), OLDCNO(1), 'WRIT', CATOLD, SCRTCH,
     *      PVER, I)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MARSPL ERROR:',I4,' ON ',A)
 1030 FORMAT (A8,1X,F10.3,' MHz')
 1031 FORMAT ('PLot file version',I4,'__created ',A12,A8)
 1035 FORMAT ('Pixels_below',I6,'_in_plot',I6,'_above',I6)
 1040 FORMAT ('Successful  plot version',I4,' created')
 1990 FORMAT ('DESTROY PLOT VERSION',I4,' DUE TO ERRORS')
      END

LOCAL INCLUDE 'APVC.INC'
      INCLUDE 'INCS:PMAD.INC'
C                                       Local include for APVC
      DOUBLE PRECISION PTRJ, PTRK
      REAL      SCRAT(6), GAIN, FLUX, MAPLIM, GAUSA, GAUSB, GAUSC,
     *   GAUSAA, GAUSBB, GAUSCC, ALPHA, XSPACE, YSPACE, MAPROT, SPEXP,
     *   TVFMAX, APARM(10), PHAT, RESMAX, RESMIN, RESRMS, HATMAX,
     *   HATMIN, BUFF1(MABFSS), BUFF2(MABFSS), BUFF3(MABFSS)
      INTEGER   NX, NY, NUMBIN, VCLST, VCSTR, NBOXS, WINM(4,10), VCLIM,
     *   BPS, LUNBEM, WINB(4), LUNHAT, LUNRES, LUNRS1, LUNWT, LUNGD1,
     *   LUNGD2, LUNDRT, LUNWRK, LUNCL1, LUNCL2, BEMVOL, RESVOL, WTVOL,
     *   GRDVOL, DRTVOL, WRKVOL, VCVOL, HATVOL, BPBEM, BPRES, BPWT,
     *   BPGRD, BPDRT, BPWRK, BPHAT, ICENX, ICENY, BOBEM, BORES, BOWT,
     *   BOGRD, BODRT, BOWRK, BOHAT, CNORES, CNOGRD, CNOWRK, CNOWT,
     *   CNOHAT, BUFSZ1, BUFSZ2, BUFSZ3, HATSCR, ICODE
      LOGICAL   FIRST
      CHARACTER BEMFIL*48, RESFIL*48, HATFIL*48, WTFIL*48, GRDFIL*48,
     *   DRTFIL*48, WRKFIL*48, VCFIL*48
      COMMON /VCCOM/ PTRJ, PTRK, GAIN, FLUX, SCRAT,
     *   MAPLIM, GAUSA, GAUSB, GAUSC, GAUSAA, GAUSBB, GAUSCC,
     *   XSPACE, YSPACE, MAPROT, SPEXP,
     *   TVFMAX, APARM, PHAT, RESMAX, RESMIN, RESRMS, HATMAX, HATMIN,
     *   ALPHA,      FIRST,
     *   ICENX, ICENY, NX, NY, NBOXS, WINM, NUMBIN, ICODE, VCLST, VCSTR,
     *   VCLIM, WINB, BPS, LUNBEM, LUNRES, LUNRS1, LUNWT, LUNGD1,
     *   LUNGD2, LUNDRT, LUNWRK, LUNCL1, LUNCL2, LUNHAT, BEMVOL, RESVOL,
     *   WTVOL, GRDVOL, DRTVOL, WRKVOL, VCVOL, HATVOL, CNORES, CNOGRD,
     *   CNOWRK, CNOWT, CNOHAT, BPBEM, BPRES, BPWT, BPGRD, BPDRT, BPWRK,
     *   BPHAT, BOBEM, BORES, BOWT, BOGRD, BODRT, BOWRK, BOHAT, HATSCR
      COMMON /VCCHR/ BEMFIL, RESFIL, HATFIL, WTFIL, GRDFIL, DRTFIL,
     *   WRKFIL, VCFIL
      COMMON /BUFRS/ BUFF1, BUFF2, BUFF3,
     *   BUFSZ1, BUFSZ2, BUFSZ3
C                                                          End APVC
LOCAL END
      PROGRAM APVC
C-----------------------------------------------------------------------
C! van Cittert image deconvolution
C# Map AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2000, 2003, 2006, 2008, 2015, 2019,
C;  Copyright (C) 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Use a generalized van Cittert iteration to deconvolve a map. A
C   positivity contraint is possible, but often not wanted.
C     INPUTS    ALIAS   DIM(R)   COMMENTS
C     INNAME    NAME(1,1) 3      Dirty map name
C     INCLASS   CLASS(1,1)2      Dirty map class
C     INSEQ     SEQ(1)    1      Dirty map sequence number
C     INDISK    VOL(1)    1      Dirty map volumn
C     IN2NAME   NAME(1,2) 3      Beam map name
C     IN2CLASS  CLASS(1,2)2      Beam map class
C     IN2SEQ    SEQ(2)    1      Beam map sequence number
C     IN2DISK   VOL(2)    1      Beam map volumn
C     OUTNAME   NAME(1,3) 3      VC map name
C     OUTCLASS  CLASS(1,3)2      VC map class
C     OUTSEQ    SEQ(3)    1      VC map sequence number
C     OUTDISK   VOL(3)    1      VC map volumn
C     DOTV      ITV       1      1 = request TV display of VC
C     NBOXES    NBOXS     1      Number of boxes for VC
C     BOX(4,10) WINM     40      Windows for the VC boxes.
C                                maps and ask user if continue,
C                                < 0 => no display or question
C     GAIN      GAIN      1      VC loop gain
C     NITER     VCLIM     1      Maximum number of VC iterations
C     PHAT      PHAT      1      Offset to beam. Cornwell smooth
C                                stabilizer.
C     OPCODE    ICODE    12      The algorithm to be used in the
C                                reconstruction. Valid codes are
C                                'WT','ST','VC','TL' (weighted,
C                                Steer, van Cittert (GS), and TUNNL).
C                                Any of these can be prefixed by a
C                                '+' to indicate 'apply positivity'.
C                                Coresponding values are 2,4,3,1 (+/-).
C     APARM     various  10      Various iteration parameters.
C     BADDISK   IBAD     10      Bad disk list.
C-----------------------------------------------------------------------
      INTEGER   TVPASS, IDIR, IERR, IRET, ITER, I, USID, VOL(3), SEQ(3),
     *   ITV, CATBLK(256), CORN(7), JWIN(4), IER, APKEY, NEED
      LOGICAL   FINISH, OLD, EQUAL
      REAL      CATR(128), RMAX, RMIN, SMAX, SMIN
      CHARACTER SCRFIL*48, NAME(3)*12, CLASS(3)*6
      DOUBLE PRECISION APCORE(2)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APVC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DAPM.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATR(1), CATBLK(1))
      DATA CORN, JWIN /7*1, 4*0/
C-----------------------------------------------------------------------
C                                       Release AP memory
      CALL QRLSE
      NCFILE = 0
      NSCR = 0
C                                       Get input values.
      CALL GETIN (USID, NAME, VOL, CLASS, SEQ, ITV, IRET)
C                                       Check for restart of AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 990
C                                       Get map files and create
C                                       output files if required.
      CALL FILES (USID, NAME, VOL, CLASS, SEQ, OLD, IRET)
      IF (IRET.NE.0) GO TO 990
C
      ITER = 0
      IF (OLD) THEN
         VCSTR = CATBLK(KINIT)
         IF (VCSTR.GT.0) ITER = VCSTR - 1
         WRITE (MSGTXT,1000) VCSTR
         CALL MSGWRT (4)
         END IF
C                                       Write inputs to history and
C                                       log files.
      OLD = (OLD) .AND. (VCSTR.GT.0)
      CALL VCHIS (NAME, VOL, CLASS, SEQ, OLD)
C
C Save the extrema of HAT. Initialize HAT map if necessary.
C
      IF (.NOT.OLD) THEN
         HATMAX = 1.E-7
         HATMIN = 0.
         CALL FLAT (HATMAX, IRET)
         IF (IRET.NE.0) GO TO 990
      ELSE
         HATMAX = CATR(KRDMX)
         HATMIN = CATR(KRDMN)
         END IF
C
      TVPASS = 2
C                                        Make WEIGHT file.
      IDIR = 1
      NEED = 4 * NY * (NX/2 + 1)
      NEED = NEED / 1024
      CALL QINIT (APCORE, NEED, 0, APKEY)
      IF ((APKEY.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
         NEED = (NY * (NX/2 + 1)) / 2
         NEED = NEED / 1024
         NEED = MIN (16 * 1024, NEED) + 4
         CALL QINIT (APCORE, NEED, 0, APKEY)
         IF ((APKEY.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            MSGTXT = 'CANNOT GET NEEDED AP MEMORY'
            CALL MSGWRT (8)
            IRET = 8
            GO TO 990
            END IF
         END IF
      CALL APDFFT (APCORE, RMAX, RMIN, IDIR, IRET)
      CALL QRLSE
      IF (IRET.NE.0) GO TO 990
C
C
C                                       Begin VCing.
      FIRST = .TRUE.
      ITER = VCSTR
 100  CONTINUE
         ITER = ITER + 1
C
C  Create RES file. This is the current estimate(HAT)
C  convolved with the beam(WT)
C
         CALL QINIT (APCORE, NEED, 0, APKEY)
         IF ((APKEY.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            MSGTXT = 'CANNOT GET NEEDED AP MEMORY IN LOOP'
            CALL MSGWRT (8)
            IRET = 8
            GO TO 990
            END IF
         CALL CNVLVE (APCORE, SMAX, SMIN, IRET)
         CALL QRLSE
         IF (IRET.NE.0) GO TO 990
C
C  Ouptut start of iteration message.
C
         WRITE (MSGTXT,1100) ITER
         CALL MSGWRT (4)
         WRITE (MSGTXT,1300) SMAX, SMIN
         CALL MSGWRT (4)
C
C Subtract RES from DRT to obtain the RES file.
C This updates RESMIN,RESMAX,RESRMS.
C
         CALL SUBMAP ( IRET )
         IF (IRET.NE.0) GO TO 990
C
C Using the HAT,RES files calculate the new map
C and store it in the HAT file. This updates HATMIN,HATMAX.
C
         CALL VCING (IRET)
         IF (IRET.NE.0) GO TO 990
C
C Summarize end of iteration.
C
         WRITE (MSGTXT,1210) RESMAX,RESMIN
         CALL MSGWRT (4)
         WRITE (MSGTXT,1400) HATMAX,HATMIN
         CALL MSGWRT (4)
C
C Display current HAT map.
C
         IF (ITV.GT.0) THEN
            CALL QINIT (APCORE, NEED, 0, APKEY)
            IF ((APKEY.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
               MSGTXT = 'CANNOT GET NEEDED AP MEMORY FOR TV'
               CALL MSGWRT (8)
               IRET = 8
               GO TO 990
               END IF
            IF (ITV.EQ.1) CALL DISPTV (TVPASS)
            CALL QRLSE
            END IF
C
C  Make it no longer the first iteration.
C
         FIRST = .FALSE.
C
C  Check for end.
C
         FINISH = ITER.GE.VCLIM .OR. TVPASS.EQ.32700
C
C If more VCing required, then loop.
C
         IF (.NOT.FINISH) GO TO 100
C
C  Make output header.
C
      CATR(KRDMX) = HATMAX
      CATR(KRDMN) = HATMIN
      CATR(KRBMJ) = 0.0
      CATR(KRBMN) = 0.0
      CATR(KRBPA) = 0.0
      CATBLK(KITYP) = 4
      CATBLK(KINIT) = ITER
      CALL CATIO ('UPDT', VOL(3), CCNO, CATBLK, 'REST', BUFF3, IERR)
      IF ((IERR.NE.0) .AND. (IERR.LT.5)) THEN
         WRITE (MSGTXT,1200) IERR
         CALL MSGWRT (4)
         END IF
C                                       Find HAT file
      HATSCR = 0
      DO 300 I = 1,NSCR
         CALL ZPHFIL ('SC', SCRVOL(I), SCRCNO(I), 1, SCRFIL, IER)
         EQUAL = SCRFIL.EQ.HATFIL
         IF (EQUAL.AND.(SCRVOL(I).EQ.HATVOL)) HATSCR = I
         IF (HATSCR.GT.0) GO TO 310
 300     CONTINUE
C                                       Lost output file
         IRET = 8
         WRITE (MSGTXT,1301)
         CALL MSGWRT (8)
         GO TO 990
C                                       Copy to output
 310  CALL PLNPUT (VOL(3), CCNO, CORN, JWIN, HATSCR, NX, NY, BUFF1,
     *   BUFF2, BUFSZ1, BUFSZ2, LUNDRT, LUNHAT, IERR)
C                                        Finished.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('RESTARTING VCING AFTER ',I5,' ITERATIONS')
 1100 FORMAT ('ITERATION = ',I5)
 1200 FORMAT ('ERROR',I3,' UPDATING VC HEADER ')
 1210 FORMAT ('  RESIDUAL MAP  : MAX.,MIN.    = ',1PE12.4,
     *     ',',1PE12.4)
 1300 FORMAT ('  CONVOLVED MAP : MAX.,MIN.    = ',1PE12.4,',',
     *   1PE12.4)
 1301 FORMAT ('I SEEM TO HAVE LOST THE OUTPUT FILE')
 1400 FORMAT ('  MAP ESTIMATE  : MAX.,MIN.    = ',1PE12.4,
     *     ',',1PE12.4)
      END
      SUBROUTINE SUBMAP (IERR)
C-----------------------------------------------------------------------
C   SUBMAP subtracts the RES file ( = beam * map ) from the Dirty map
C   producing the residual map.
C   The WORK file is used as the output file and then
C   the physical files for the Residual and WORK files are
C   exchanged when the routine is finished.
C
C     Programmer = T. J. Cornwell May 1982
C-----------------------------------------------------------------------
      INTEGER   IERR
      INTEGER   FIND1, FIND2, FIND3, BIND1, BIND2, BIND3, WIN(4),
     *   I, J, IBOX, IO, IG, ID
      LOGICAL   MAP, EXCL, WAIT
      REAL   RNXY
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APVC.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA MAP, EXCL, WAIT /.TRUE., 2*.TRUE./
C-----------------------------------------------------------------------
C                                       Initialize extrema.
      RESMAX = -1.0E20
      RESMIN =  1.0E20
      RESRMS =  0
      RNXY   =  0
C                                       Open and INIT files.
      CALL ZOPEN (LUNDRT, FIND1, DRTVOL, DRTFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
      CALL ZOPEN (LUNRES, FIND2, RESVOL, RESFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
      CALL ZOPEN (LUNWRK, FIND3, WRKVOL, WRKFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1030) IERR
         GO TO 990
         END IF
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NX
      WIN(4) = NY
      CALL MINIT ('READ', LUNDRT, FIND1, NX, NY, WIN, BUFF1, BUFSZ1,
     *   BODRT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      CALL MINIT ('READ', LUNRES, FIND2, NX, NY, WIN, BUFF2, BUFSZ2,
     *   BORES, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
      CALL MINIT ('WRIT', LUNWRK, FIND3, NX, NY, WIN, BUFF3, BUFSZ3,
     *   BOWRK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
C                                       Loop thru map.
      DO 150 I = 1,NY
C                                       Read dirty map.
         CALL MDISK ('READ', LUNDRT, FIND1, BUFF1, BIND1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1070) IERR, I
            GO TO 990
            END IF
C                                       Write output.
         CALL MDISK ('WRIT', LUNWRK, FIND3, BUFF3, BIND3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR,I
            GO TO 990
            END IF
C                                       Read GRID map
         CALL MDISK ('READ', LUNRES, FIND2, BUFF2, BIND2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1105) IERR,I
            GO TO 990
            END IF
         CALL RFILL (NX, 0.0, BUFF3(BIND3))
         DO 140 J = 1,NX
            DO 135 IBOX = 1,NBOXS
               IF ((J.GE.WINM(1,IBOX)) .AND. (J.LE.WINM(3,IBOX)) .AND.
     *            (I.GE.WINM(2,IBOX)) .AND. (I.LE.WINM(4,IBOX))) THEN
                  IO = BIND3+J-1
                  IG = BIND2+J-1
                  ID = BIND1+J-1
                  BUFF3(IO) = BUFF1(ID) - BUFF2(IG)
                  RESMAX = MAX(BUFF3(IO), RESMAX)
                  RESMIN = MIN(BUFF3(IO), RESMIN)
                  RESRMS = RESRMS + BUFF3(IO)**2
                  RNXY = RNXY + 1
                  GO TO 140
                  END IF
 135           CONTINUE
 140        CONTINUE
 150     CONTINUE
C                                       Finish write.
      CALL MDISK ('FINI', LUNWRK, FIND3, BUFF3, BIND3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1150) IERR
         GO TO 990
         END IF
C                                       Close files.
      CALL ZCLOSE (LUNDRT, FIND1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1160) IERR
         CALL MSGWRT (8)
         END IF
      CALL ZCLOSE (LUNRES, FIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1170) IERR
         CALL MSGWRT (8)
         END IF
      CALL ZCLOSE (LUNWRK, FIND3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1180) IERR
         CALL MSGWRT (8)
         END IF
C
C                                       Return RMS value.
      RESRMS = SQRT(RESRMS/RNXY)
C                                       Switch RES and WRK files.
      CALL FSWTCH (RESFIL, WRKFIL, RESVOL, WRKVOL, CNORES, CNOWRK,
     *   BORES, BOWRK)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SUBMAP: CANNOT OPEN DIRTY FILE, ERROR ',I3)
 1020 FORMAT ('SUBMAP: CANNOT OPEN FOR READ RESIDUAL MAP, ERROR ',I3)
 1030 FORMAT ('SUBMAP: CANNOT OPEN FOR WRITE RESIDUAL MAP, ERROR ',I3)
 1040 FORMAT ('SUBMAP: CANNOT INIT DIRTY MAP, ERROR ',I3)
 1050 FORMAT ('SUBMAP: CANNOT INIT READ RESIDUAL MAP, ERROR ',I3)
 1060 FORMAT ('SUBMAP: CANNOT INIT WRITE RESIDUAL MAP, ERROR ',I3)
 1070 FORMAT ('SUBMAP: READ ERROR ',I3,' DIRTY FILE ROW ',I6)
 1105 FORMAT ('SUBMAP: READ ERROR ',I3,' RESIDUAL MAP ROW ',I6)
 1100 FORMAT ('SUBMAP: WRITE ERROR ',I3,' RESIDUAL ROW ',I6)
 1150 FORMAT ('SUBMAP: FINISH ERROR ',I3,' RESIDUAL FILE')
 1160 FORMAT ('SUBMAP: CLOSE ERROR ',I3,' DIRTY MAP ')
 1170 FORMAT ('SUBMAP: CLOSE ERROR ',I3,' READ RESIDUAL FILE')
 1180 FORMAT ('SUBMAP: CLOSE ERROR ',I3,' WRITE RESIDUAL FILE ')
      END
      SUBROUTINE APDFFT (APCORE, SMAX, SMIN, IDIR, IERR)
C-----------------------------------------------------------------------
C   APDFFT calls AP FFT routines PASS1 and PASS2.  If the transform
C   can be done all in the AP this is done; if not then a transpose
C   of the type designed by F. Schwab is done.
C   The work file is used in
C   the transpose between passes of the transform.
C   The beam in R   form is assumed in file GRD.
C   INPUT:
C     IDIR       I    Type of transform :
C                          IDIR = -1 : GRID => RES
C                          IDIR = 1  : BEAM => WT
C                          IDIR = 2  : MAP => GRID
C     BOGRD      I    Block offset of beam map.
C     GRDVOL     I    Volume for beam map.
C     GRDFIL     C    Physical name of  Beam map.
C     LUNGD1     I    LUN for Beam map.
C     BOGRD      I    Block offset of GRID file.
C     GRDVOL     I    Volume for GRID file.
C     GRDFIL     C    Physical name of GRID file.
C     LUNGD1     I    LUN for GRID file.
C     BOWT       I    Block offset of weight file.
C     WTVOL      I    Volume for weight file.
C     WTFIL      C    Physical name of weight file.
C     LUNWT      I    LUN for weight file.
C     BORES      I    Block offset for residual map.
C     RESVOL     I    Volume for residual map.
C     RESFIL     C    Physical name of residual map.
C     LUNRES     I    LUN for residual map.
C     BOHAT      I    Block offset for VC map.
C     HATVOL     I    Volume for VC map.
C     HATFIL     C    Physical name of VC map.
C     LUNHAT     I    LUN for VC map.
C     BOWRK      I    Block offset for WORK file.
C     WRKVOL     I    Volume for work file.
C     WRKFIL     C    Physical name of WORK file.
C     LUNWRK     I    LUN for WORK file.
C     BUFF1(),BUFF2()  I    Work buffers for I/O.
C     BUFSZ1,BUFSZ2    I    Size in bytes of BUFF1 and BUFF2.
C     Programmer = T. J. Cornwell May 1982
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(2)
      INTEGER   IERR
      INTEGER   IDIR, LUN(3), BO(3), VOL(3), IDIRT
      LOGICAL   F
      REAL      SMAX, SMIN
      CHARACTER FIL(3)*48
      INCLUDE 'APVC.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                       REAL TO REAL
C                                       Set file information.
C                                       1 = Beam, 2 = Work, 3 = Weight
      IF ((IDIR.GE.0) .AND. (IDIR.NE.2)) THEN
         IDIRT = IDIR
         BO(1) = BOGRD
         BO(2)= BOWRK
         BO(3) = BOWT
         VOL(1) = GRDVOL
         VOL(2) = WRKVOL
         VOL(3) = WTVOL
         LUN(1) = LUNGD1
         LUN(2) = LUNWRK
         LUN(3) = LUNWT
         FIL(1) = GRDFIL
         FIL(2) = WRKFIL
         FIL(3) = WTFIL
C                                       Do disk based FFT.
         CALL PASS1 (APCORE, IDIRT, F, LUN, VOL, FIL, BO, BUFF1,
     *      BUFSZ1, BUFF2, BUFSZ2, NX, NY, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL PASS2 (APCORE, IDIRT, F, LUN, VOL, FIL, BO, BUFF1,
     *      BUFSZ1, BUFF2, BUFSZ2, NX, NY, SMAX, SMIN, IERR)
C                                       REAL TO COMPLEX
C                                       Set file information.
C                                       1 = Map , 2 = Work, 3 = Grid
      ELSE IF (IDIR.EQ.2) THEN
         IDIRT = 3
         BO(1) = BOHAT
         BO(2) = BOWRK
         BO(3) = BOGRD
         VOL(1) = HATVOL
         VOL(2) = WRKVOL
         VOL(3) = GRDVOL
         LUN(1) = LUNHAT
         LUN(2) = LUNWRK
         LUN(3) = LUNGD1
         FIL(1) = HATFIL
         FIL(2) = WRKFIL
         FIL(3) = GRDFIL
C                                       Do disk based FFT.
         CALL PASS1 (APCORE, IDIRT, F, LUN, VOL, FIL, BO, BUFF1,
     *      BUFSZ1, BUFF2, BUFSZ2, NX, NY, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL PASS2 (APCORE, IDIRT, F, LUN, VOL, FIL, BO, BUFF1,
     *      BUFSZ1, BUFF2, BUFSZ2, NX, NY, SMAX, SMIN, IERR)
C                                       COMPLEX TO REAL
C                                       Set file information.
C                                       1 = Grid, 2 = Work, 3 = Resid.
      ELSE
         BO(1) = BOGRD
         BO(2) = BOWRK
         BO(3) = BORES
         VOL(1) = GRDVOL
         VOL(2) = WRKVOL
         VOL(3) = RESVOL
         LUN(1) = LUNGD1
         LUN(2) = LUNWRK
         LUN(3) = LUNRES
         FIL(1) = GRDFIL
         FIL(2) = WRKFIL
         FIL(3) = RESFIL
C                                       Do disk based FFT.
         CALL PASS1 (APCORE, IDIR, F, LUN, VOL, FIL, BO, BUFF1,
     *      BUFSZ1, BUFF2, BUFSZ2, NX, NY, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL PASS2 (APCORE, IDIR, F, LUN, VOL, FIL, BO, BUFF1,
     *      BUFSZ1, BUFF2, BUFSZ2, NX, NY, SMAX, SMIN, IERR)
         END IF
C
 999  RETURN
      END
      SUBROUTINE VCHIS (NAME, VOL, CLASS, SEQ, OLD)
C-----------------------------------------------------------------------
C   VCHIS copies the dirty map history if the VC map does not
C   already have a history file.  Then the inputs to VC with
C   the default values are added to the history file.
C   INPUTS:
C     NAME(6,3)   C*12 Names of maps
C                      1 = Dirty map
C                      2 = Beam map
C                      3 = VC map
C     VOL(3)      I    Vol. numbers of the maps.
C     CLASS(3)    I    Classes of the map.
C     SEQ(3)      I    Sequence numbers of the maps.
C     OLD         L    T => VC map pre-exists & restart > 0
C   From common /MAPHDR/
C     CATBLK(256) I    Catalog header block for the VC map.
C   From COMMON /VC/
C     NX          I    Number of cell in the map in RA.
C     NY          I    Number of cells in the map in dec.
C     VCLIM       I    Max number of iterations.(NITER)
C     GAIN        R    VC loop gain.
C     BUFF1()     I    Work buffer
C     BUFF2()     I    Work buffer
C     LUNCL1      I    LUN for VC history file
C     LUNDRT      I    LUN for dirty history file
C   From COMMON /CFILES/
C     FCNO(10)    I    Catalog slot numbers of catalogd maps.
C                      2 = Dirty map
C                      3 = VC map
C   OUTPUT:
C     The input parameters are written on the history file and the
C     log file.
C
C     Programmer = T. J. Cornwell May 1982
C-----------------------------------------------------------------------
      CHARACTER NAME(3)*12, CLASS(3)*6, XCLS*8, XNAM*12, OPCODS(11)*4
      INTEGER   VOL(3), SEQ(3), CATBLK(256), IERR, I, J
      LOGICAL   T, OLD
      CHARACTER HILINE*72
      INTEGER   ITEMP
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'APVC.INC'
      INCLUDE 'INCS:DFIL.INC'
      COMMON /MAPHDR/ CATBLK
      DATA T /.TRUE./
      DATA OPCODS/'PC  ','ST  ','VC  ','WT  ','TL  ','    ',
     *             '+TL ','+WT ','+VC ','+ST ','+PC '/
C-----------------------------------------------------------------------
C                                       Open old file: no copy old HI
      IF (OLD) THEN
         CALL HIOPEN (LUNCL1, VOL(3), CCNO, BUFF2, IERR)
         IF (IERR.EQ.5) GO TO 20
         IF (IERR.EQ.0) THEN
            CALL ZDATE (BUFF1(1))
            CALL ZTIME (BUFF1(4))
            CALL TIMDAT (BUFF1(4), BUFF1(1), XCLS, XNAM)
            WRITE (HILINE,1000) TSKNAM, RLSNAM, XNAM, XCLS
            CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 50
            GO TO 30
         ELSE
            WRITE (MSGTXT,1010) IERR
            CALL MSGWRT (6)
            GO TO 60
            END IF
         END IF
C                                       Copy/open history files.
 20   CALL KEYPCP (VOL(1), FCNO(2), VOL(3), CCNO, 0, ' ', IERR)
      CALL HISCOP (LUNDRT, LUNCL1, VOL(1), VOL(3), FCNO(2), CCNO,
     *   CATBLK, BUFF1, BUFF2, IERR)
C                                       Check if old file not exist
      IF (IERR.GT.2) THEN
         IF (IERR.EQ.3) GO TO 50
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (6)
         GO TO 60
         END IF
C                                       Add to history file.
C                                       Dirty map name.
 30   WRITE (MSGTXT,2000) TSKNAM, NAME(1), CLASS(2), SEQ(1), VOL(1)
      CALL MSGWRT (3)
      CALL HENCO1 (TSKNAM, NAME(1), CLASS(1), SEQ(1), VOL(1),
     *   LUNCL1, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       Dirty beam name.
      WRITE (MSGTXT,2001) TSKNAM,NAME(2),CLASS(2),SEQ(2),VOL(2)
      CALL MSGWRT (3)
      CALL HENCO2 (TSKNAM, NAME(2), CLASS(2), SEQ(2), VOL(2),
     *   LUNCL1, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       VC map name.
      WRITE (MSGTXT,2002) TSKNAM,NAME(3),CLASS(3),SEQ(3),VOL(3)
      CALL MSGWRT (3)
      CALL HENCOO (TSKNAM, NAME(3), CLASS(3), SEQ(3), VOL(3),
     *   LUNCL1, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       Maximum number of Iterations.
      WRITE (HILINE,2003) TSKNAM, VCLIM
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (2)
      IF (IERR.NE.0) GO TO 50
C                                       Loop gain.
      WRITE (HILINE,2005) TSKNAM, GAIN
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (2)
      IF (IERR.NE.0) GO TO 50
C                                       Smooth stablizer.
      WRITE (HILINE,2006) TSKNAM, PHAT
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (2)
      IF (IERR.NE.0) GO TO 50
C                                       Opcode parameter.
      ITEMP = 6 + ICODE
      WRITE (HILINE,2007) TSKNAM, OPCODS(ITEMP)
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (2)
      IF (IERR.NE.0) GO TO 50
C                                       Parameters.
      WRITE (HILINE,2008) TSKNAM, (APARM(I), I = 1,4)
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (2)
      IF (IERR.NE.0) GO TO 50
C                                       Number of boxes.
      WRITE (HILINE,2009) TSKNAM, NBOXS
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (2)
      IF (IERR.NE.0) GO TO 50
C                                       Windows.
      DO 40 I = 1,NBOXS
         WRITE (HILINE,2010) TSKNAM, I, (WINM(J,I), J = 1,4)
         CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
         MSGTXT = HILINE
         CALL MSGWRT (2)
         IF (IERR.NE.0) GO TO 50
 40      CONTINUE
      GO TO 60
C                                       Error has occured.
 50   WRITE (MSGTXT,1050) IERR
      CALL MSGWRT (6)
C                                       Close history files.
 60   CALL HICLOS (LUNCL1, T, BUFF2, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* RESTART ',
     *   A12,2X,A8)
 1010 FORMAT ('UNABLE TO OPEN OLD VC-MAP HISTORY FILE')
 1020 FORMAT ('VCHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1050 FORMAT ('VCHIS: ERROR',I3,' WRITING HISTORY FILE')
 2000 FORMAT (A6,' DIRTY MAP = ''',A12,''' . ''',A6,
     *   ''' . ',2I4)
 2001 FORMAT (A6,' BEAM  MAP = ''',A12,''' . ''',A6,
     *   ''' . ',2I4)
 2002 FORMAT (A6,' VC    MAP = ''',A12,''' . ''',A6,
     *   ''' . ',2I4)
 2003 FORMAT (A6,' NITER = ',I6,' /MAX. NO. VC ITERATIONS')
 2005 FORMAT (A6,' GAIN = ',F7.4,' /VC LOOP GAIN FACTOR')
 2006 FORMAT (A6,' PHAT = ',F7.4,' /PRUSSIAN HAT PARAM')
 2007 FORMAT (A6,' OPCODE = ',A4, '/OPCODE PARAMETER')
 2008 FORMAT (A6,' APARM  = ',4F10.3)
 2009 FORMAT (A6,' NBOXES = ',I3,' /NO. VC WINDOWS')
 2010 FORMAT (A6,' BOX(',I2,') = ',I5,', ',I5,', ',I5,', ',I5,
     *   ' /VC WINDOW')
      END
      SUBROUTINE FILES (USID, NAME, VOL, CLASS, SEQ, OLD, IERR)
C-----------------------------------------------------------------------
C   FILES reads and floats the  beam and creates the
C   VC map and components files. The R   beam is placed in the
C   GRD file and the location of the R   catalogd files are
C   left in the DRT and BEM files.
C   BEAM and Dirty maps in catalog are marked READ and VC map
C   is marked WRITE.
C   INPUT:
C     USID     I    User number.
C     NAME(3)  C    Names of maps
C                     1 = Dirty map
C                     2 = Beam map
C                     3 = VC map
C     CLASS(3) C    Classes of the maps
C     VOL(3)     I    Volumns of the maps.
C   OUTPUT:
C     ICENX    I    Offset in X of BEAM center from NX/2+1
C     ICENY    I    Offset in Y of BEAM center from NY/2+1
C     OLD      L    TRUE if old map file being replaced.
C   Commons:
C     CATBLK(256) in /MAPHDR/ a preliminary header for the VC map
C        is returned.
C
C     Programmer = T. J. Cornwell May 1982
C-----------------------------------------------------------------------
      CHARACTER  NAME(3)*12, CLASS(3)*6, STAT*4, MAPUNT*8, MTYPE*2
      INTEGER   USID, CATBLK(256), CNO,
     *   VOL(3), SEQ(3), OLDIM, OLDNAX(7), IDEPTH(5),
     *   IERR, IBOX, IER, I, IMCENX, IMCENY, NREC, LREC
      INTEGER   CORN(7), JWIN(4), NOSCR, IROUND
      LOGICAL   OLD
      DOUBLE PRECISION CATD(128), OLDCRV(7)
      REAL      CATR(128), XCEN, YCEN
      INTEGER   ISIZE
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APVC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK, CATR, CATD)
      DATA CORN, JWIN, IDEPTH /7*1, 4*0, 5*1/
      DATA MAPUNT /'JY/PIXEL'/
C-----------------------------------------------------------------------
      NCFILE = 0
C                                       Read dirty beam.
C                                       Get catalog slot for BEAM.
      CNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', VOL(2), CNO, NAME(2), CLASS(2), SEQ(2),
     *    MTYPE, USID, STAT, BUFF3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, NAME(2), CLASS(2), SEQ(2), VOL(2),
     *      USID
         GO TO 990
         END IF
C                                       Copy CATBLK and mark beam READ
      CALL CATIO ('READ', VOL(2), CNO, CATBLK, 'READ', BUFF3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         GO TO 990
         END IF
C                                       Mark file 'READ' in /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = VOL(2)
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 0
C                                       Determine NX and NY
      NX = CATBLK(KINAX)
      NY = CATBLK(KINAX+1)
C                                       Determine beam center pixel
      CALL PEAKFN (LUNBEM, VOL(2), CNO, IDEPTH, CATBLK, BUFF3,
     *   BUFSZ3, XCEN, YCEN, IERR)
      IF (IERR.NE.0) GO TO 990
      WRITE (MSGTXT,1777) XCEN,YCEN
      CALL MSGWRT (4)
      XCEN = XCEN - NX/2 - 1
      YCEN = YCEN - NY/2 - 1
      ICENX = IROUND (XCEN)
      ICENY = IROUND (YCEN)
C                                       Create scratch files.
C                                       Residual file
      RESVOL = MAX (1, VOL(2))
      NSCR = 0
      ISIZE = MAX (NX, 64) + 3
      ISIZE = (ISIZE * NY) * 4.0D0 + 2048.0D0
      ISIZE = (ISIZE - 1) / 512 + 1
      CALL SCREAT (ISIZE, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1015) IERR
         GO TO 990
         END IF
C                                       Update from COMMON /FILES/
      RESVOL = SCRVOL(NSCR)
      CNORES = SCRCNO(NSCR)
      CALL ZPHFIL ('SC', SCRVOL(NSCR), SCRCNO(NSCR), 1, RESFIL, IERR)
C                                       Grid file
      CALL SCREAT (ISIZE, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       Update from COMMON /FILES/
      GRDVOL = SCRVOL(NSCR)
      CNOGRD = SCRCNO(NSCR)
      CALL ZPHFIL ('SC', SCRVOL(NSCR), SCRCNO(NSCR), 1, GRDFIL, IERR)
      NOSCR = NSCR
C                                       Work file
      CALL SCREAT (ISIZE, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1025) IERR
         GO TO 990
         END IF
C                                       Update from COMMON /FILES/
      WRKVOL = SCRVOL(NSCR)
      CNOWRK = SCRCNO(NSCR)
      CALL ZPHFIL ('SC', SCRVOL(NSCR), SCRCNO(NSCR), 1, WRKFIL, IERR)
C                                       Weight file
      CALL SCREAT (ISIZE, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         GO TO 990
         END IF
C                                       Update from COMMON /FILES/
      WTVOL = SCRVOL(NSCR)
      CNOWT = SCRCNO(NSCR)
      CALL ZPHFIL ('SC', SCRVOL(NSCR), SCRCNO(NSCR), 1, WTFIL, IERR)
C                                       Hat file
      CALL SCREAT (ISIZE, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1037) IERR
         GO TO 990
         END IF
C                                       Update from COMMON /FILES/
      HATVOL = SCRVOL(NSCR)
      CNOHAT = SCRCNO(NSCR)
      CALL ZPHFIL ('SC', SCRVOL(NSCR), SCRCNO(NSCR), 1, HATFIL, IERR)
      HATSCR = NSCR
C
C                                       Beam map into scratch file
      CALL PLNGET (VOL(2), CNO, CORN, JWIN, ICENX, ICENY, NOSCR, NX,
     *   NY, BUFF1, BUFF2, BUFSZ1, BUFSZ2, LUNGD1, LUNDRT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1035) IERR
         GO TO 990
         END IF
C                                       Get and store info on BEAM.
C                                       Loop through the boxes.
      DO 70 IBOX = 1,NBOXS
C                                       Make sure window no larger
C                                       than map size.
         IF (WINM(3,IBOX).GT.NX) WINM(3,IBOX) = NX
         IF (WINM(4,IBOX).GT.NY) WINM(4,IBOX) = NY
C                                       If default use center 1/4 of map
         IF (WINM(1,IBOX).LE.0) WINM(1,IBOX) = NX / 4 + 1
         IF (WINM(2,IBOX).LE.0) WINM(2,IBOX) = NY / 4 + 1
         IF (WINM(3,IBOX).LE.0) WINM(3,IBOX) = 3*NX/4 - 1
         IF (WINM(4,IBOX).LE.0) WINM(4,IBOX) = 3*NY/4 - 1
 70      CONTINUE
C                                       Store information on BEAM file
C                                       Use GRD file for temp R   BEAM.
      CALL ZPHFIL ('MA', VOL(2), CNO, 1, BEMFIL, IER)
      BEMVOL = VOL(2)
      SEQ(2) = CATBLK(KIIMS)
      BOBEM = 1
C                                       Get catalog slot number for
C                                       the dirty map and CATBLK.
      CNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', VOL(1), CNO, NAME(1), CLASS(1), SEQ(1),
     *    MTYPE, USID, STAT, BUFF3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, NAME(1), CLASS(1), SEQ(1), VOL(1),
     *      USID
         GO TO 990
         END IF
C                                       Get CATBLK for dirty map.
C                                       Leave file marked READ.
      CALL CATIO ('READ', VOL(1), CNO, CATBLK, 'READ', BUFF3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1090) IERR
         GO TO 990
         END IF
C                                       Mark map READ in /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = VOL(1)
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 0
C                                       Warn if "VC"
      IF (CATBLK(KITYP).EQ.4) THEN
         WRITE (MSGTXT,1100)
         CALL MSGWRT (4)
         END IF
C                                       Get dirty scale,offset in COMMON
      CALL ZPHFIL ('MA', VOL(1), CNO, 1, DRTFIL, IER)
      DRTVOL = VOL(1)
      BODRT = 1
C                                        RA spacing.
      XSPACE = CATR(KRCIC)
C                                        Dec spacing.
      YSPACE = CATR(KRCIC+1)
C                                        Map rotation.
      MAPROT = CATR(KRCRT+1)
C                                       Make sure NX,NY same as
C                                       for the beam.
      IF ((NX.NE.CATBLK(KINAX)) .OR. (NY.NE.CATBLK(KINAX+1))) THEN
         IERR = 1
         WRITE (MSGTXT,1105)
         CALL MSGWRT (8)
         WRITE (MSGTXT,1106) NX,NY,CATBLK(KINAX),CATBLK(KINAX+1)
         GO TO 990
         END IF
C                                       Put NAME in CATBLK
      CALL CHR2H (12, NAME(3), KHIMNO, CATR(KHIMN))
      CALL CHR2H (6, CLASS(3), KHIMCO, CATR(KHIMC))
      CATBLK(KIIMS) = SEQ(3)
C                                        Put in units of map
      CALL CHR2H (8, MAPUNT, 1, CATR(KHBUN))
C                                       Create output VC map file.
      CALL MCREAT (VOL(3), CNO, BUFF1, IERR)
      OLD = .FALSE.
      IF (IERR.NE.0) THEN
         OLD = .TRUE.
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1190) IERR
            GO TO 990
C                                       Existing file: check it out
         ELSE
            OLDIM = CATBLK(KIDIM)
            DO 205 I = 1,7
               OLDNAX(I) = CATBLK(KINAX+I-1)
               OLDCRV(I) = CATD(KDCRV+I-1)
 205           CONTINUE
            CALL CATIO ('READ', VOL(3), CNO, CATBLK, 'REST', BUFF3,
     *         IERR)
            IF (OLDIM.NE.CATBLK(KIDIM)) GO TO 215
            DO 210 I = 1,OLDIM
               IF (OLDNAX(I).NE.CATBLK(KINAX+I-1)) GO TO 215
               IF (OLDCRV(I).NE.CATD(KDCRV+I-1)) GO TO 215
 210           CONTINUE
C                                       Fetch
            IMCENX = 0
            IMCENY = 0
            CALL PLNGET (VOL(3), CNO, CORN, JWIN, IMCENX, IMCENY,
     *         HATSCR, NX, NY, BUFF1, BUFF2, BUFSZ1, BUFSZ2, LUNGD1,
     *         LUNDRT, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1038) IERR
               GO TO 990
               END IF
C                                       It matches, mark WRITE
            CALL CATIO ('WRIT', VOL(3), CNO, CATBLK, 'WRIT', BUFF3,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1210) IERR
               CALL MSGWRT (8)
               END IF
            GO TO 300
            END IF
C                                       Not same file !!!
 215     IERR = 8
         WRITE (MSGTXT,1215)
         GO TO 990
         END IF
C                                       Actual seq #
 300  SEQ(3) = CATBLK(KIIMS)
C                                       Add to /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = VOL(3)
      VCVOL = VOL(3)
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 2
      IF (OLD) FRW(NCFILE) = 1
      CCNO = CNO
      NREC = VCLIM + 10
      LREC = 3
C                                      Close.
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FILES: ERR',I3,' FINDING ',A12,'.',A6,'.',I4,
     *   ' DISK',I2,' USID',I5)
 1010 FORMAT ('FILES: CANNOT COPY BEAM CATBLK, ERROR',I3)
 1015 FORMAT ('FILES: ERROR',I3,' CREATING RESIDUAL SCRATCH FILE')
 1020 FORMAT ('FILES: ERROR',I3,' CREATING GRID SCRATCH FILE')
 1025 FORMAT ('FILES: ERROR',I3,' CREATING WORK SCRATCH FILE')
 1030 FORMAT ('FILES: ERROR',I3,' CREATING WEIGHT SCRATCH FILE')
 1037 FORMAT ('FILES: ERROR',I3,' CREATING HAT SCRATCH FILE')
 1038 FORMAT ('FILES: ERROR',I3,' READING IMAGE')
 1035 FORMAT ('FILES: CANNOT COPY DIRTY BEAM, ERROR ',I3)
 1090 FORMAT ('FILES: CANNOT COPY MAP CATBLK, ERROR',I3)
 1100 FORMAT ('WARNING: MAY BE VCING A VC MAP')
 1105 FORMAT ('FILES: UNEQUAL DIMENSIONS IN DIRTY AND BEAM MAPS')
 1106 FORMAT ('       BEAM =',2I5,' DIRTY =',2I5)
 1190 FORMAT ('FILES: COULD NOT CREATE VC MAP FILE, ERROR ',I3)
 1210 FORMAT ('FILES: CANNOT UPDATE VC CATBLK, ERROR',I3)
 1215 FORMAT ('OLD VC MAP NOT COMPATIBLE WITH DIRTY MAP')
 1777 FORMAT ('    PEAK OF BEAM IS AT ',2(F6.0,1X))
      END
      SUBROUTINE GETIN (USID, NAME, VOL, CLASS, SEQ, ITV, IERR)
C-----------------------------------------------------------------------
C   GETIN gets the input parameters for the program from AIPS
C  See Prologue for APVC for more details.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6, NAME(3)*12, CLASS(3)*6,
     *   DEFCLS*6, CODES(5)*4, XOPCOD*4, MTYPE*2
      INTEGER   USID, VOL(3), SEQ(3), ITV, IERR, I4TEMP
      INTEGER   NPARMS, CATBLK(256), IND, IROUND
      INTEGER   ITEMP, NPT, CNO, I, IL, IK, J
      HOLLERITH XNAM1(3), XNAM2(3), XNAM3(3), XCLAS1(2), XCLAS2(2),
     *   XCLAS3(2), XXOPCO(1)
      REAL   DEFAUL(2,5)
      REAL   XSEQ1, XSEQ2, XSEQ3, XVOL1, XVOL2, XVOL3, XG,
     *   XNI, XDOTV, XNB, XBOX(4,10), XBAD(10), XPHAT, XPARM(10)
      LOGICAL   T, F, EQUAL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APVC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /MAPHDR/ CATBLK
      COMMON /INPARM/ XNAM1, XCLAS1, XSEQ1, XVOL1, XNAM2, XCLAS2,
     *   XSEQ2, XVOL2, XNAM3, XCLAS3, XSEQ3, XVOL3,
     *   XDOTV, XNB, XBOX, XG, XNI, XPHAT, XXOPCO, XPARM, XBAD
      DATA PRGNAM /'APVC  '/
      DATA T, F /.TRUE.,.FALSE./
      DATA CODES   /'TL',  'WT',   'VC',  'ST',   'PC'/
      DATA DEFAUL /0.,0., 0.5,0., 0.,0., 0.8,0., 0.5,4./
C-----------------------------------------------------------------------
C                                        Initialize common parameters.
C                                        global areas
      CALL ZDCHIN (T, BUFF1)
      CALL VHDRIN
      CALL HIINIT (3)
C                                        non-standard messages
C                                        VC common areas
      BOBEM = 1
      BOHAT = 1
      BORES = 1
      BOWT = 1
      BOGRD = 1
      BODRT = 1
      BOWRK = 1
      LUNBEM = 16
      LUNRES = 17
      LUNRS1 = 19
      LUNWT  = 20
      LUNGD1 = 19
      LUNGD2 = 21
      LUNDRT = 22
      LUNWRK = 23
      LUNHAT = 24
      LUNCL1 = 26
C
      NUMBIN = 1024
      I4TEMP = 2  * MABFSS
      BUFSZ1 = I4TEMP
      BUFSZ2 = I4TEMP
      BUFSZ3 = I4TEMP
      BPS = NBPS
      TVFMAX = 0.0
C                                       Get AIPS adverbs. NPARM=# reals
      NPARMS = 87
      CALL GTPARM (PRGNAM, NPARMS, RQUICK, XNAM1, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         RQUICK = .FALSE.
         GO TO 999
         END IF
C
      CALL YTVCIN
      WRITE (MSGTXT,4000)
      CALL MSGWRT (2)
C                                       Convert characters
      CALL H2CHR (12, 1, XNAM1, NAME(1))
      CALL H2CHR (6, 1, XCLAS1, CLASS(1))
      CALL H2CHR (12, 1, XNAM2, NAME(2))
      CALL H2CHR (6, 1, XCLAS2, CLASS(2))
      CALL H2CHR (12, 1, XNAM3, NAME(3))
      CALL H2CHR (6, 1, XCLAS3, CLASS(3))
      CALL H2CHR (4, 1, XXOPCO, XOPCOD)
C                                       get actual dirty map name
      VOL(1) = IROUND (XVOL1)
      SEQ(1) = IROUND (XSEQ1)
      USID = NLUSER
      MTYPE = 'MA'
      CALL MAPOPN ('READ', VOL, NAME(1), CLASS(1), SEQ, MTYPE, USID,
     *   LUNBEM, IND, CNO, CATBLK, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL MAPCLS ('READ', VOL, CNO, LUNBEM, IND, CATBLK, F, BUFF1,
     *   IERR)
C                                       Default name for Beam and VC
C                                       maps is Dirty map name.
      EQUAL = NAME(2) .EQ. '            '
      IF (EQUAL) NAME(2) = NAME(1)
C                                       Copy CLASSes or default.
      EQUAL = CLASS(2) .EQ. '      '
      IF (EQUAL) THEN
         CLASS(2) = 'IBEM  '
         IF (CLASS(1).EQ.'RMAP  ') CLASS(2) = 'RBEM  '
         IF (CLASS(1).EQ.'LMAP  ') CLASS(2) = 'LBEM  '
         END IF
      DEFCLS = 'IVC   '
      IF (CLASS(1).EQ.'RMAP  ') DEFCLS = 'RVC   '
      IF (CLASS(1).EQ.'LMAP  ') DEFCLS = 'LVC   '
      IF (CLASS(1).EQ.'QMAP  ') DEFCLS = 'QVC   '
      IF (CLASS(1).EQ.'UMAP  ') DEFCLS = 'UVC   '
      IF (CLASS(1).EQ.'VMAP  ') DEFCLS = 'VVC   '
C                                       Get volumn numbers
      VOL(2) = IROUND (XVOL2)
      VOL(3) = IROUND (XVOL3)
C                                       Get sequence numbers
      SEQ(2) = IROUND (XSEQ2)
      SEQ(3) = IROUND (XSEQ3)
      IF (SEQ(2).LE.0) SEQ(2) = SEQ(1)
      CALL MAKOUT (NAME, CLASS, SEQ, DEFCLS, NAME(3), CLASS(3),
     *   SEQ(3))
C                                       Get VCing information
      GAIN = 0.5
      VCLIM = 20
      PHAT = 0.
      IF (XG.GT.0.0)    GAIN = XG
      IF (XNI.GT.0.5)   VCLIM = IROUND (XNI)
      IF (XPHAT.GT.0.0) PHAT = XPHAT
C
C  Save parameters.
C
      DO 42 I=1,10
         APARM(I) = XPARM(I)
 42      CONTINUE
C
C                                       Determine which operation to
C                                       perform.
      ICODE = 0
      ITEMP = -1
      NPT = 1
      EQUAL = XOPCOD(1:1) .EQ. '+'
      IF (EQUAL) THEN
         NPT = 2
         ITEMP = 1
         END IF
      ICODE = ITEMP * 3
      DO 46 I=1,5
         EQUAL = CODES(I)(1:2) .EQ. XOPCOD(NPT:NPT+1)
         IF (EQUAL) THEN
            ICODE = ITEMP * I
            IF(APARM(2).LE.0) APARM(2) = DEFAUL(1,I)
            IF(APARM(3).LE.0) APARM(3) = DEFAUL(2,I)
            END IF
 46      CONTINUE
C                                       Check if TV allowed
      ITV = 0
      IF (XDOTV.GT.0.0 .AND. NTVDEV.GT.0.0) ITV = 1
C
C                                       Boxes information.
      NBOXS = IROUND (XNB)
      NBOXS = MIN (NBOXS, 10)
      NBOXS = MAX (NBOXS, 1)
      IL = 1
      DO 60 I = 1,10
         IK = 0
         DO 50 J = 1,4
            WINM(J,IL) = IROUND (XBOX(J,I))
            IF (WINM(J,IL).GT.0) IK = IK + 1
 50         CONTINUE
         IF ((I.EQ.1) .OR. (IK.GT.0)) IL = IL + 1
 60      CONTINUE
      NBOXS = MIN (IL-1, NBOXS)
C
C                                       Get bad disks.
C
      DO 70 I = 1,10
         IBAD(I) = IROUND (XBAD(I))
 70      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 4000 FORMAT ('YOU ARE USING A NON-STANDARD, EXPERIMENTAL PROGRAM')
      END
      SUBROUTINE CNVLVE (APCORE, SMAX, SMIN, IERR)
C-----------------------------------------------------------------------
C   CNVLVE Fourier convolves the current map estimate with the beam.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(2)
      INTEGER   FIND1, FIND2, FIND3, IERR, IDIR, JLIM, I, J, IO, IW, IG,
     *   WIN(4), BIND1, BIND2, BIND3
      LOGICAL   MAP, EXCL, WAIT
      REAL      WBUFF(1), GBUFF(1), OBUFF(1), SMAX,
     *   SMIN, RNXY, GAMMA, RMS, WT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APVC.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (WBUFF(1), BUFF1(1)),      (GBUFF(1), BUFF2(1))
      EQUIVALENCE (OBUFF(1), BUFF3(1))
      DATA MAP, EXCL, WAIT /.TRUE.,2*.TRUE./
C-----------------------------------------------------------------------
C                                        Do FFT to get transform of map
      IDIR = 2
      CALL APDFFT (APCORE, SMAX, SMIN, IDIR, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
C                                       Open weights file and init.
      CALL ZOPEN (LUNWT, FIND1, WTVOL, WTFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         GO TO 990
         END IF
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NY
      WIN(4) = NX / 2 + 1
      CALL MINIT ('READ', LUNWT, FIND1, WIN(3), WIN(4), WIN, WBUFF,
     *   BUFSZ1, BOWT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       Open and INIT GRID file for read
      CALL ZOPEN (LUNGD1, FIND2, GRDVOL, GRDFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         GO TO 990
         END IF
      WIN(3) = NY*2
      WIN(4) = NX / 2 + 1
      CALL MINIT ('READ', LUNGD1, FIND2, WIN(3), WIN(4), WIN, GBUFF,
     *   BUFSZ2, BOGRD, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
C                                       Open and INIT WRK file for writi
      CALL ZOPEN (LUNWRK, FIND3, WRKVOL, WRKFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         GO TO 990
         END IF
      CALL MINIT ('WRIT', LUNWRK, FIND3, WIN(3), WIN(4), WIN, OBUFF,
     *   BUFSZ3, BOWRK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
C                                       Begin loop thru map.
      JLIM = NX / 2 + 1
      RNXY = REAL(NX)*REAL(NY)
      GAMMA = 0.
      RMS   = 0.
      DO 150 I = 1,JLIM
C                                       Read weights.
         CALL MDISK ('READ', LUNWT, FIND1, WBUFF, BIND1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1080) IERR,I
            GO TO 990
            END IF
C                                       Read row from GRID file.
         CALL MDISK ('READ', LUNGD1, FIND2, GBUFF, BIND2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR,I
            GO TO 990
            END IF
C                                       Write file back to disk.
         CALL MDISK ('WRIT', LUNWRK, FIND3, OBUFF, BIND3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1090) IERR, I
            GO TO 990
            END IF
C                                        Do each row
         DO 140 J=1,NY
C                                       Multiply by weights.
            IO = BIND3+2*(J-1)
            IW = BIND1+  (J-1)
            IG = BIND2+2*(J-1)
            WT = RNXY*WBUFF(IW) + PHAT
            GAMMA = MAX(GAMMA,WT)
            RMS = RMS + WT**2
            OBUFF(IO) = WT*GBUFF(IG)
            OBUFF(IO+1) = WT*GBUFF(IG+1)
 140        CONTINUE
 150     CONTINUE
C                                       Set GAMMA.
      IF (FIRST) THEN
         RMS = SQRT( 2.*RMS/RNXY)
         WRITE (MSGTXT,1155)RMS,GAMMA
         CALL MSGWRT (8)
         GAMMA = SQRT(GAMMA*RMS)
         WRITE (MSGTXT,1158)GAMMA
         CALL MSGWRT (8)
         IF(APARM(1).LE.0)APARM(1) = GAMMA
         END IF
C                                       End of this pass, close files.
      CALL ZCLOSE (LUNWT, FIND1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1150) IERR
         CALL MSGWRT (8)
         END IF
      CALL ZCLOSE (LUNGD1, FIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1160) IERR
         CALL MSGWRT (8)
         END IF
C                                       Finish writing GRID file.
      CALL MDISK ('FINI', LUNWRK, FIND3, OBUFF, BIND3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1170) IERR
         GO TO 990
         END IF
      CALL ZCLOSE (LUNWRK, FIND3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1160) IERR
         CALL MSGWRT (8)
         END IF
C                                       Switch WRK and GRID files.
      CALL FSWTCH (GRDFIL, WRKFIL, GRDVOL, WRKVOL, CNOGRD, CNOWRK,
     *   BOGRD, BOWRK)
C                                        FFT back to map plane
      IDIR = -1
      CALL APDFFT (APCORE, SMAX, SMIN, IDIR, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1180) IERR
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CNVLVE: ERROR ',I3,' IN APDFFT MAP TO U,V')
 1010 FORMAT ('CNVLVE: ERROR ',I3,' OPENING FILE ')
 1020 FORMAT ('CNVLVE: ERROR ',I3,' INIT WEIGHT FILE')
 1030 FORMAT ('CNVLVE: ERROR ',I3,' OPENING GRID FILE ')
 1050 FORMAT ('CNVLVE: ERROR ',I3,' INIT GRID FILE')
 1090 FORMAT ('CNVLVE: WRITE ERROR ',I3,' GRID ROW ',I6)
 1080 FORMAT ('CNVLVE: ERROR ',I3,' READ WEIGHT ROW ',I6)
 1100 FORMAT ('CNVLVE: ERROR ',I3,' READ GRID ROW ',I6)
 1150 FORMAT ('CNVLVE: ERROR ',I3,' CLOSING WEIGHT FILE')
 1155 FORMAT ('GRD FILE RMS =',F9.3,'   MAX =',F9.3)
 1158 FORMAT ('DEFAULT NPPBEAM = ',F9.3)
 1160 FORMAT ('CNVLVE: ERROR ',I3,' CLOSING GRID FILE')
 1170 FORMAT ('CNVLVE: FINISH ERROR ',I3,' WRITING GRID FILE ')
 1180 FORMAT ('CNVLVE: ERROR ',I3,' IN APDFFT U,V TO MAP')
      END
      SUBROUTINE VCING (IERR)
C-----------------------------------------------------------------------
C     VCING finds the next estimate of the VC map from the current
C     estimate, stored in HAT, and the residuals of the current
C     estimate, stored in RES. The new estimate is written into the
C     HAT file.
C     Programmer : T.J. Cornwell May 1982
C-----------------------------------------------------------------------
      INTEGER   FIND1, FIND2, FIND3, IERR, I, J, IBOX, IW, IG, IO,
     *   WIN(4), BIND1, BIND2, BIND3, ITEMP
      LOGICAL   MAP, EXCL, WAIT
      REAL      HATBUF(1), RESBUF(1), OBUFF(1),
     *   GAINS, SIGMA2, HMAX, RMAX, TRIM, BETA, RNXY, ERRRMS,
     *   WEIGHT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APVC.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (RESBUF(1), BUFF1(1)),      (HATBUF(1), BUFF2(1))
      EQUIVALENCE (OBUFF(1), BUFF3(1))
      DATA MAP, EXCL, WAIT /.TRUE.,2*.TRUE./
C-----------------------------------------------------------------------
C                                          Dividingby GAMMA converts
C                                          from Jy/beam to Jy/pixel.
      GAINS = GAIN/APARM(1)
      SIGMA2 = (RESRMS/APARM(1))**2
      HMAX = MAX(ABS(HATMAX),ABS(HATMIN))
      RMAX = MAX(ABS(RESMAX),ABS(RESMIN))
      TRIM = APARM(2)*RMAX
      ALPHA = APARM(2)
      BETA = 1. - APARM(2)
C
      RNXY = 0.0
      ERRRMS = 0.0
      HATMAX = -1.E20
      HATMIN =  1.E20
C
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NX
      WIN(4) = NY
C                                       Open residuals file and init.
      CALL ZOPEN (LUNRES, FIND1, RESVOL, RESFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         GO TO 990
         END IF
      CALL MINIT ('READ', LUNRES, FIND1, NX, NY, WIN, RESBUF, BUFSZ1,
     *   BORES, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       Open and INIT HAT file for read
      CALL ZOPEN (LUNHAT, FIND2, HATVOL, HATFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         GO TO 990
         END IF
      CALL MINIT ('READ', LUNHAT, FIND2, NX, NY, WIN, HATBUF, BUFSZ2,
     *   BOHAT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
C                                       Open and INIT WRK file for writi
      CALL ZOPEN (LUNWRK, FIND3, WRKVOL, WRKFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         GO TO 990
         END IF
      CALL MINIT ('WRIT', LUNWRK, FIND3, NX, NY, WIN, OBUFF, BUFSZ3,
     *   BOWRK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
C                                        Loop thru map
      DO 285 I = 1,NY
C                                       Read Residuals
         CALL MDISK ('READ', LUNRES, FIND1, RESBUF, BIND1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1080) IERR,I
            GO TO 990
            END IF
C                                       Read row from HAT file.
         CALL MDISK ('READ', LUNHAT, FIND2, HATBUF, BIND2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR,I
            GO TO 990
            END IF
C                                       Write file back to disk.
         CALL MDISK ('WRIT', LUNWRK, FIND3, OBUFF, BIND3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1090) IERR, I
            GO TO 990
            END IF
C                                        Find new map estimate
         CALL RFILL (NX, 0.0, OBUFF(BIND3))
         DO 284 J = 1,NX
            DO 135 IBOX = 1,NBOXS
               IF ((J.GE.WINM(1,IBOX)) .AND. (J.LE.WINM(3,IBOX)) .AND.
     *            (I.GE.WINM(2,IBOX)) .AND. (I.LE.WINM(4,IBOX))) THEN
                  IW = BIND1+J-1
                  IG = BIND2+J-1
                  IO = BIND3+J-1
C
C                                        Case to correct code.
C                                        HATBUF is HAT, WBUF is RES.
                  OBUFF(IO) = HATBUF(IG)
                  ITEMP = ABS (ICODE)
C                                        TUNNEL ALGORITHM
                  IF (ITEMP.EQ.1) THEN
                     WEIGHT = APARM(2) +
     *               HATBUF(IG)**2/(HATBUF(IG)**2 + SIGMA2)
C                                        WEIGHT ALGORITHM
                  ELSE IF (ITEMP.EQ.2) THEN
                     WEIGHT = ALPHA*(RESBUF(IW)/RMAX)**2
                     WEIGHT = WEIGHT+BETA*(HATBUF(IG)/HMAX)**2
C                                        VAN CITTERT ALGORITHM
                  ELSE IF (ITEMP.EQ.3) THEN
                     WEIGHT = 1.
C                                        STEER ALGORITHM
                  ELSE IF (ITEMP.EQ.4) THEN
                     WEIGHT = 0.
                     IF (TRIM.LE.ABS(RESBUF(IG))) WEIGHT = 1.
C                                        PERCENT ALGORITHM
                  ELSE IF (ITEMP.EQ.5) THEN
                     WEIGHT = (RESBUF(IG)/RESRMS)**2
                     WEIGHT = WEIGHT/(APARM(3) + WEIGHT)
                     WEIGHT = (ALPHA+BETA*(RESBUF(IG)/RMAX)**2)*WEIGHT
                     END IF
C                                        Add the weighted residual.
C                                       Clip asnec.
                  OBUFF(IO) = OBUFF(IO) + WEIGHT*GAINS*RESBUF(IW)
                  IF ((ICODE.GT.0) .AND. (OBUFF(IO).LT.0)) OBUFF(IO)=0.
C                                        Collect statistics.
                  HATMAX = MAX (HATMAX, OBUFF(IO))
                  HATMIN = MIN (HATMIN, OBUFF(IO))
                  ERRRMS = ERRRMS + (OBUFF(IO)-HATBUF(IG))**2
                  RNXY = RNXY + 1.0
                  GO TO 284
                  END IF
 135           CONTINUE
 284        CONTINUE
 285     CONTINUE
C                                       End of this pass, close files.
      CALL ZCLOSE (LUNRES, FIND1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1150) IERR
         CALL MSGWRT (8)
         END IF
      CALL ZCLOSE (LUNHAT, FIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1160) IERR
         CALL MSGWRT (8)
         END IF
C                                       Finish writing HAT file.
      CALL MDISK ('FINI', LUNWRK, FIND3, OBUFF, BIND3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1170) IERR
         GO TO 990
         END IF
      CALL ZCLOSE (LUNWRK, FIND3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1160) IERR
         CALL MSGWRT (8)
         END IF
C                                        Output rms CHANGE
      ERRRMS = SQRT (ERRRMS/RNXY)
      WRITE (MSGTXT,1220) ERRRMS
      CALL MSGWRT (4)
C                                       Switch WRK and HAT files.
      CALL FSWTCH (HATFIL, WRKFIL, HATVOL, WRKVOL, CNOHAT, CNOWRK,
     *   BOHAT, BOWRK)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('VCING: ERROR ',I3,' OPENING FILE ')
 1020 FORMAT ('VCING: ERROR ',I3,' INIT RES FILE')
 1030 FORMAT ('VCING: ERROR ',I3,' OPENING HAT FILE ')
 1050 FORMAT ('VCING: ERROR ',I3,' INIT HAT FILE')
 1090 FORMAT ('VCING: WRITE ERROR ',I3,' HAT ROW ',I6)
 1080 FORMAT ('VCING: ERROR ',I3,' READ RES ROW ',I6)
 1100 FORMAT ('VCING: ERROR ',I3,' READ HAT ROW ',I6)
 1150 FORMAT ('VCING: ERROR ',I3,' CLOSING RES FILE')
 1160 FORMAT ('VCING: ERROR ',I3,' CLOSING HAT FILE')
 1170 FORMAT ('VCING: FINISH ERROR ',I3,' WRITING HAT FILE ')
 1220 FORMAT ('  CORRECTION    : RMS CHANGE   = ',1PE12.4)
      END
      SUBROUTINE FLAT (RMAX, IERR)
C-----------------------------------------------------------------------
C   FLAT INITIALISES the estimate of the VC map.  The new estimate is
C   written into the HAT file.
C   Programmer : T.J. Cornwell September 1982
C-----------------------------------------------------------------------
      REAL   RMAX
      INTEGER   IERR
      INTEGER   FIND3, WIN(4), BIND3, I, J, IBOX, IO
      LOGICAL   MAP, EXCL, WAIT
      REAL      WBUFF(1), GBUFF(1), OBUFF(1)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APVC.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (WBUFF(1), BUFF1(1)),      (GBUFF(1), BUFF2(1))
      EQUIVALENCE (OBUFF(1), BUFF3(1))
      DATA MAP, EXCL, WAIT /.TRUE.,2*.TRUE./
C-----------------------------------------------------------------------
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NX
      WIN(4) = NY
C                                       Open and INIT HAT file for write
      CALL ZOPEN (LUNHAT, FIND3, HATVOL, HATFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR
            GO TO 990
            END IF
      CALL MINIT ('WRIT', LUNHAT, FIND3, NX, NY, WIN, OBUFF, BUFSZ3,
     *   BOHAT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
C                                        Set to be FLAT
      DO 150 J = 1,NY
C                                       Write file back to disk.
         CALL MDISK ('WRIT', LUNHAT, FIND3, OBUFF, BIND3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1090) IERR, J
            GO TO 990
            END IF
         CALL RFILL (NX, 0.0, OBUFF(BIND3))
         DO 140 I = 1,NX
            DO 135 IBOX = 1,NBOXS
               IF ((I.GE.WINM(1,IBOX)) .AND. (I.LE.WINM(3,IBOX)) .AND.
     *            (J.GE.WINM(2,IBOX)) .AND. (J.LE.WINM(4,IBOX))) THEN
                  IO = BIND3+I-1
                  OBUFF(IO) = RMAX
                  GO TO 140
                  END IF
 135           CONTINUE
 140        CONTINUE
 150     CONTINUE
C                                       Perform enema
      CALL MDISK ('FINI', LUNHAT, FIND3, OBUFF, BIND3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1100) IERR
         GO TO 990
         END IF
C                                        Close file
      CALL ZCLOSE (LUNHAT, FIND3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1160) IERR
         CALL MSGWRT (8)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('FLAT: ERROR ',I3,' OPENING HAT FILE ')
 1050 FORMAT ('FLAT: ERROR ',I3,' INIT HAT FILE')
 1090 FORMAT ('FLAT: WRITE ERROR ',I3,' HAT ROW ',I6)
 1100 FORMAT ('FLAT: ERROR ',I3,' FLUSHING HAT FILE')
 1160 FORMAT ('FLAT: ERROR ',I3,' CLOSING HAT FILE')
      END
      SUBROUTINE DISPTV (TVPASS)
C-----------------------------------------------------------------------
C   DISPTV displays the current map on the TV, showing inner
C   portion only if that is all that will fit.
C   Inputs:  TVPASS  I     code: 0 => clear screen, else do not
C                                0,1 => do not question the user about
C                                quitting
C   Output:  TVPASS  I     code: 32700 => user wants to quit VSing
C-----------------------------------------------------------------------
      CHARACTER  PREFIX*5
      INTEGER   TVPASS, JROW(1), WIN(4), FIND, IERR, ICH, CATBLK(256),
     *   S2H(256), IQ, IB, I, INC(2), IWIN(4)
      REAL      CATR(256), TD, RPOS(2), XFMIN
      LOGICAL   MAP, EXCL, WAIT, LERR, F
      INCLUDE 'APVC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVD.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATR, CATBLK)
      EQUIVALENCE (JROW(1), BUFF2(1))
      DATA MAP, EXCL, WAIT / .TRUE., 2*.TRUE./
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      ICH = 1
      CALL TVOPEN (BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 999
         END IF
      IF (TVPASS.EQ.0) THEN
         CALL TVSET (ICH, BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            CALL MSGWRT (6)
            GO TO 998
            END IF
         END IF
C                                       Write scaling factor
      XFMIN = TVFMAX
      CALL METSCA (XFMIN, PREFIX, LERR)
      WRITE (MSGTXT,1020) XFMIN, PREFIX
      CALL MSGWRT (2)
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NX
      WIN(4) = NY
      INC(1) = NX / MAXXTV(1) + 1
      INC(2) = NY / MAXXTV(2) + 1
      INC(1) = MAX (INC(1), INC(2))
      INC(2) = MAX (INC(1), INC(2))
      DO 70 I = 1,2
         WIN(I+2) = WIN(I+2) - MOD (WIN(I+2)-WIN(I), INC(I))
         IWIN(I) = (MAXXTV(I) - (WIN(I+2)- WIN(I))/INC(I) + 1)/2
         IF (IWIN(I).LT.1) THEN
            IWIN(I) = 1
            WIN(I)  = (WIN(I+2) + WIN(I) - MAXXTV(I)*INC(I) + 1)/2
            IWIN(I+2) = MAXXTV(I)
            WIN(I+2) = WIN(I) + (IWIN(I+2) - IWIN(I)) * INC(I)
         ELSE
            IWIN(I+2) = IWIN(I) + (WIN(I+2) - WIN(I)) / INC(I)
            IF (IWIN(I+2).GT.MAXXTV(I)) THEN
               IWIN(I+2) = MAXXTV(I)
               WIN(I+2) = WIN(I) + (IWIN(I+2) - IWIN(I)) * INC(I)
               END IF
            END IF
 70      CONTINUE
      WRITE (MSGTXT,1070) 0.0, TVFMAX, INC(1)
      CALL MSGWRT (2)
      CALL COPY (256, CATBLK, S2H)
C                                       Prepare to read map.
      CALL ZOPEN (LUNHAT, FIND, HATVOL, HATFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) GO TO 998
      CALL FILL (5, 1, CATBLK(IIDEP))
      CATBLK(KINAX) = NX
      CATBLK(KINAX+1) = NY
      CATR(IRRAN) = 0
      CATR(IRRAN+1) = TVFMAX
      CALL TVLOAD (LUNHAT, FIND, ICH, INC, IWIN, WIN, BUFSZ1, BUFF1,
     *   IERR)
      CALL COPY (256, S2H, CATBLK)
      CALL ZCLOSE (LUNHAT, FIND, I)
      IERR = MAX (I, IERR)
      IF (IERR.NE.0) GO TO 998
C                                       Ask user to quit?
      IF (TVPASS.GE.2) THEN
         MSGTXT = 'Hit button D within 15 seconds to stop cleaning now'
         CALL MSGWRT (1)
         MSGTXT = 'Hit buttons A, B, or C to continue sooner'
         CALL MSGWRT (1)
         RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2.0
         RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2.0
         TD = 0.2
         CALL YCURSE ('ONNN', F, F, RPOS, IQ, IB, IERR)
         IF (IERR.NE.0) GO TO 998
         DO 130 I = 1,75
            CALL ZDELAY (TD, IERR)
            CALL YCURSE ('READ', F, F, RPOS, IQ, IB, IERR)
            IF (IERR.NE.0) GO TO 135
C                                       Wants to quit
            IF (IB.GT.7) THEN
               TVPASS = 32700
               MSGTXT = 'TV Button D hit: have done enough I guess'
               CALL MSGWRT (4)
               GO TO 150
               END IF
            IF (IB.GT.0) GO TO 135
 130        CONTINUE
 135     MSGTXT = 'Continuing'
         CALL MSGWRT (1)
C                                       Off cursor
 150     CALL YCURSE ('OFFF', F, F, RPOS, IQ, IB, IERR)
         END IF
C
 998  CALL TVCLOS (BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CANT OPEN TV IER=',I6)
 1010 FORMAT ('IMCLEAR ERROR =',I6)
 1020 FORMAT ('TVDISP: DISPLAY MAXIMUM =',F8.3,1X,A5,'JY')
 1070 FORMAT ('Loading TV from',1PE10.3,' to',1PE10.3,' every',I2,
     *   ' pixel')
      END

      SUBROUTINE WRPLAN (IPLANE, NODIM, INP, BLC, TRC, ISLUN, ISIND,
     *   IDLUN, IDIND, SCALE, XMIN, XMAX, IERR)
C-----------------------------------------------------------------------
C! copies an N dimensional plane to a N or N+1 dimensional image
C# Map-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2010, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   WRPLAN will read from an nD image file, and write to a specific
C   plane in a corresponding n+1D file.  The two files must be open
C   before this routine is called.
C   Inputs:
C      IPLANE   I   The plane to write to in the n+1D map.
C      NODIM    I   the axis number to which IPLANE applies > 1
C      INP      I(7)   the number of pixels on each axis (input)
C      BLC      R(7)   bottom left hand corner of nD map.
C                            (No defaults).
C      TRC      R(7)   top right hand corner of nD map.
C      ISLUN    I   the logical unit number of the source file.
C      ISIND    I   the FTAB pointer for the source file.
C      IDLUN    I   the logical unit number for the R
C                          destination file.
C      IDIND    I   the FTAB pointer for the destination file.
C      SCALE    R   multiple the input image by SCALE
C   In/out:
C      XMIN     R   map minimum scaled as output map
C      XMAX     R   map maximum scaled as output map
C   Outputs:
C      IERR     I   error indicator: >= 0 from IO routines
C                          < 0 => ok, but some output pixels blanked
C   Common:
C      /MAPHDR/ input    CATBLK of output map
C      /BUFRS/  output   B1(MABFSS), B2(MABFSS) scratch IO buffers
C-----------------------------------------------------------------------
      INTEGER   IPLANE, NODIM, INP(*), ISLUN, ISIND, IDLUN, IDIND, IERR
      REAL      BLC(7), TRC(7), SCALE, XMIN, XMAX
C
      INTEGER   IBLKOF, IWIN(4), DEPTH(5), JWIN(4), OBLKOF, IBKSIZ,
     *   I3, I3A, I3B, I4, I4A, I4B, I5, I5A, I5B, I6, I6A, I6B, I7,
     *   I7A, I7B, IDNX, IDNY, IDPOS, IPIX, IROW, ISPOS, CATBLK(256),
     *   JDNY
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PMAD.INC'
      REAL      BUF1(MABFSS), BUF2(MABFSS), TEMP
      COMMON /BUFRS/ BUF1, BUF2
      COMMON /MAPHDR/ CATBLK
C-----------------------------------------------------------------------
      IERR = 2
      IF ((NODIM.LT.2) .OR. (NODIM.GT.KICTPN)) GO TO 999
C                                       Set window, input file.
      IWIN(1) = BLC(1) + .01
      IWIN(2) = BLC(2) + .01
      IWIN(3) = TRC(1) + .01
      IWIN(4) = TRC(2) + .01
      IBKSIZ = 2 * MABFSS
C                                       init output
      IDNX = TRC(1) - BLC(1) + 1.01
      IDNY = TRC(2) - BLC(2) + 1.01
      JDNY = IDNY
      JWIN(1) = 1
      JWIN(2) = 1
      JWIN(3) = IDNX
      JWIN(4) = IDNY
      IF (NODIM.EQ.2) JWIN(2) = IPLANE
      IF (NODIM.EQ.2) JWIN(4) = IPLANE + IDNY - 1
      IF (NODIM.EQ.2) IDNY = CATBLK(KINAX+1)
      I3A = BLC(3) + 0.01
      I4A = BLC(4) + 0.01
      I5A = BLC(5) + 0.01
      I6A = BLC(6) + 0.01
      I7A = BLC(7) + 0.01
      I3B = TRC(3) + 0.01
      I4B = TRC(4) + 0.01
      I5B = TRC(5) + 0.01
      I6B = TRC(6) + 0.01
      I7B = TRC(7) + 0.01
      DO 70 I7 = I7A,I7B
      DO 69 I6 = I6A,I6B
      DO 68 I5 = I5A,I5B
      DO 67 I4 = I4A,I4B
      DO 66 I3 = I3A,I3B
         DEPTH(1) = I3
         DEPTH(2) = I4
         DEPTH(3) = I5
         DEPTH(4) = I6
         DEPTH(5) = I7
         CALL COMOFF (7, INP, DEPTH, IBLKOF, IERR)
         IF (IERR.NE.0) GO TO 999
         IBLKOF = IBLKOF + 1
         DEPTH(1) = I3 - I3A + 1
         DEPTH(2) = I4 - I4A + 1
         DEPTH(3) = I5 - I5A + 1
         DEPTH(4) = I6 - I6A + 1
         DEPTH(5) = I7 - I7A + 1
         IF (NODIM.GT.2) DEPTH(NODIM-2) = IPLANE
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), DEPTH, OBLKOF, IERR)
         IF (IERR.NE.0) GO TO 999
         OBLKOF = OBLKOF + 1
C                                       Initialize for double buffering
         CALL MINIT ('READ', ISLUN, ISIND, INP(1), INP(2), IWIN, BUF1,
     *      IBKSIZ, IBLKOF, IERR)
         IF (IERR.EQ.0) GO TO 10
            WRITE (MSGTXT,1000) IERR
            GO TO 995
 10      CALL MINIT ('WRIT', IDLUN, IDIND, IDNX, IDNY, JWIN, BUF2,
     *      IBKSIZ, OBLKOF, IERR)
         IF (IERR.EQ.0) GO TO 20
            WRITE (MSGTXT,1010) IERR
            GO TO 995
C                                       Read - write for all rows.
 20      DO 60 IROW = 1,JDNY
            CALL MDISK ('READ', ISLUN, ISIND, BUF1, ISPOS, IERR)
            IF (IERR.EQ.0) GO TO 30
               WRITE (MSGTXT,1020) IERR
               GO TO 995
 30         CALL MDISK ('WRIT', IDLUN, IDIND, BUF2, IDPOS, IERR)
            IF (IERR.EQ.0) GO TO 40
               WRITE (MSGTXT,1030) IERR
               GO TO 995
C                                       transfer to write buf
 40         DO 50 IPIX = 1,IDNX
               TEMP = BUF1(ISPOS+IPIX-1)
               IF (TEMP.NE.FBLANK) THEN
                  TEMP = TEMP * SCALE
                  XMIN = MIN (TEMP, XMIN)
                  XMAX = MAX (TEMP, XMAX)
                  END IF
               BUF2(IDPOS+IPIX-1) = TEMP
 50            CONTINUE
 60         CONTINUE
C                                       Write last buffer.
         CALL MDISK ('FINI', IDLUN, IDIND, BUF2, IDPOS, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1060) IERR
            GO TO 995
            END IF
 66      CONTINUE
 67      CONTINUE
 68      CONTINUE
 69      CONTINUE
 70      CONTINUE
      GO TO 999
C
 995  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('WRPLAN: DOUBLE BUFFER INIT READ ERROR. MINIT ERR=',I5)
 1010 FORMAT ('WRPLAN: DOUBLE BUFFER INIT WRITE ERROR. MINIT ERR =',I5)
 1020 FORMAT ('WRPLAN: DOUBLE BUFFERED READ ERROR. MDISK ERR =',I5)
 1030 FORMAT ('WRPLAN: DOUBLE BUFFERED WRITE ERROR. MDISK ERR =',I5)
 1060 FORMAT ('WRPLAN: ERROR WRITING LAST BUFFER. MDISK ERR =',I5)
      END

      PROGRAM ICON
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ICON converts icon file formats
C   It changes a file in 'iconedit' format to the format needed by
C   XAS for XCreateBitmapFromData.  Namely, it changes from 16-bit
C   data to 8-bit data and reverses the order of the bits in each
C   8-bit datum.
C-----------------------------------------------------------------------
      INTEGER   TTY(2), IERR, ILUN, OLUN, IFIND, OFIND, JTRIM, IL, I, JT
      CHARACTER INFIL*48, OUTFIL*48, ILINE*80, MSGBUF*80, OLINE*80
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA ILUN, OLUN /10,11/
C-----------------------------------------------------------------------
      TTY(1) = 5
      CALL AIPINI (TTY, 'ICON  ', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       infile name
      WRITE (MSGBUF, 1000) 'input'
      CALL INQSTR (TTY, MSGBUF, 48, INFIL, IERR)
      IF (IERR.NE.0) GO TO 990
      WRITE (MSGBUF, 1000) 'output'
      CALL INQSTR (TTY, MSGBUF, 48, OUTFIL, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       output file name
      CALL ZTXOPN ('READ', ILUN, IFIND, INFIL, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) 'open', 'input', IERR
         CALL MSGWRT (8)
         GO TO 980
         END IF
C                                       open files
      CALL ZTXOPN ('WRIT', OLUN, OFIND, OUTFIL, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) 'open', 'output', IERR
         CALL MSGWRT (8)
         GO TO 980
         END IF
C                                       copy beginning comment lines
      DO 10 I = 1,2
         CALL ZTXIO ('READ', ILUN, IFIND, ILINE, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) 'read', 'input', IERR
            CALL MSGWRT (8)
            GO TO 980
            END IF
         IL = JTRIM (ILINE)
         OLINE = ILINE
         CALL ZTXIO ('WRIT', OLUN, OFIND, OLINE(:IL), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) 'writ', 'output', IERR
            CALL MSGWRT (8)
            GO TO 980
            END IF
 10      CONTINUE
C                                       copy 64 lines of icon
      DO 50 I = 1,64
         CALL ZTXIO ('READ', ILUN, IFIND, ILINE, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) 'read', 'input', IERR
            CALL MSGWRT (8)
            GO TO 980
            END IF
         JT = JTRIM (ILINE)
C                                       output form
         IF (I.EQ.1) THEN
C                                       1st char = TAB
            OLINE = ILINE(:1)
            OLINE(2:3) = '0x'
            OLINE(6:8) = ',0x'
            OLINE(11:13) = ',0x'
            OLINE(16:18) = ',0x'
            OLINE(21:23) = ',0x'
            OLINE(26:28) = ',0x'
            OLINE(31:33) = ',0x'
            OLINE(36:38) = ',0x'
            OLINE(41:) = ','
            IL = 41
            END IF
C                                       reverse bits in bytes
         CALL REVCHR (ILINE(4:), OLINE(4:))
         CALL REVCHR (ILINE(6:), OLINE(9:))
         CALL REVCHR (ILINE(11:), OLINE(14:))
         CALL REVCHR (ILINE(13:), OLINE(19:))
         CALL REVCHR (ILINE(18:), OLINE(24:))
         CALL REVCHR (ILINE(20:), OLINE(29:))
         CALL REVCHR (ILINE(25:), OLINE(34:))
         CALL REVCHR (ILINE(27:), OLINE(39:))
C                                       write it out
         IF (I.EQ.64) IL = 40
         CALL ZTXIO ('WRIT', OLUN, OFIND, OLINE(:IL), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) 'writ', 'output', IERR
            CALL MSGWRT (8)
            GO TO 980
            END IF
 50      CONTINUE
C                                       close files
      CALL ZTXCLS (OLUN, OFIND, IERR)
      CALL ZTXCLS (ILUN, IFIND, IERR)
C                                       exit gracefully
 980  CALL ZCLOSE (TTY(1), TTY(2), IERR)
      CALL ACOUNT (2)
C
 990  CONTINUE
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('Enter ',A,' file name as logical:name')
 1010 FORMAT ('ERROR ON ',A,' TO ',A,' NUMBER',I6)
      END
      SUBROUTINE REVCHR (IC, OC)
C-----------------------------------------------------------------------
C   reverse bits in 2-character bytes
C   Input:
C      IC   C*(*)   Use 1st 2 chars only
C   Output:
C      OC   C*(*)   !st 2 chars changed to bit reverse of IC(1:2)
C-----------------------------------------------------------------------
      CHARACTER IC*(*), OC*(*)
C
      CHARACTER LC*1
      INTEGER   I, I1, I2
C-----------------------------------------------------------------------
      DO 10 I = 1,2
         I1 = I
         I2 = 3 - I
         LC = IC(I1:I1)
         IF (LC.EQ.'0') THEN
            OC(I2:I2) = '0'
         ELSE IF (LC.EQ.'1') THEN
            OC(I2:I2) = '8'
         ELSE IF (LC.EQ.'2') THEN
            OC(I2:I2) = '4'
         ELSE IF (LC.EQ.'3') THEN
            OC(I2:I2) = 'C'
         ELSE IF (LC.EQ.'4') THEN
            OC(I2:I2) = '2'
         ELSE IF (LC.EQ.'5') THEN
            OC(I2:I2) = 'A'
         ELSE IF (LC.EQ.'6') THEN
            OC(I2:I2) = '6'
         ELSE IF (LC.EQ.'7') THEN
            OC(I2:I2) = 'E'
         ELSE IF (LC.EQ.'8') THEN
            OC(I2:I2) = '1'
         ELSE IF (LC.EQ.'9') THEN
            OC(I2:I2) = '9'
         ELSE IF (LC.EQ.'A') THEN
            OC(I2:I2) = '5'
         ELSE IF (LC.EQ.'B') THEN
            OC(I2:I2) = 'D'
         ELSE IF (LC.EQ.'C') THEN
            OC(I2:I2) = '3'
         ELSE IF (LC.EQ.'D') THEN
            OC(I2:I2) = 'B'
         ELSE IF (LC.EQ.'E') THEN
            OC(I2:I2) = '7'
         ELSE IF (LC.EQ.'F') THEN
            OC(I2:I2) = 'F'
            END IF
 10      CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'TIORD.INC'
C                                       Local include for TIORD
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4,30), XCALC(1), XXSTOK(1)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XSUBA, XBIF, XEIF, XBCHAN, XECHAN, XDOCAL, XGUSE, XDOPOL,
     *   XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH(3), XPRT(10),
     *   BADD(10), DOALL, SCRBUF(256), BUFF2(UVBFSS), TLAST, BLAST
      INTEGER   SEQIN, DISKIN, JBUFSZ, ILOCWT, CATOLD(256), INCSI,
     *   INCFI, INCIFI, NRPRMI, OLDCNO, NERROR, NBERR, NAERR, PRTLIM(4),
     *   NFRQ
      LOGICAL   ISCOMP
      CHARACTER NAMEIN*12, CLAIN*6
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, DOALL, XSOUR, XQUAL,
     *   XCALC, XXSTOK, XTIME, XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF,
     *   XBCHAN, XECHAN, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG,
     *   XDOBND, XBPVER, XSMOTH, XPRT, BADD
      COMMON /TIORDP/ CATOLD, SEQIN, DISKIN, ILOCWT, INCSI, INCFI,
     *   INCIFI, NRPRMI, ISCOMP, OLDCNO, NERROR, TLAST, BLAST, NBERR,
     *   NAERR, PRTLIM, NFRQ
      COMMON /CHARPM/ NAMEIN, CLAIN
      COMMON /BUFRS/ SCRBUF, BUFF2, JBUFSZ
C                                       End local include for TIORD
LOCAL END
      PROGRAM TIORD
C-----------------------------------------------------------------------
C! Check time ordering
C# Utility UV UV-util VLA VLB Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2008, 2010-2011, 2013-2015, 2018-2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TIORD checks the data set for time ordering including after the
C   application of the cal adverbs.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C   full set of calibration adverbs
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      APARM(10)      APARM         User specified array.
C      BPARM(10)      BPARM         User specified array.
C      BOX(4,10)      BOX           User specified array.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'TIORD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'TIORD '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL TIORIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      IF (DOALL.GT.0.0) THEN
         CALL TIORAL (IRET)
      ELSE
         CALL TIORUV (IRET)
         END IF
      IF (IRET.NE.0) GO TO 990
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE TIORIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   TIORIN gets input parameters for TIORD.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, NFREQ, LUN, FQVER, NIF
      LOGICAL   MATCH, TABLE, FITASC, EXIST
      REAL      CATR(256), RPARM(20)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'TIORD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 178
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (4, 1, XXSTOK, STOKES)
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      PRTLIM(1) = IROUND (XPRT(1))
      PRTLIM(2) = IROUND (XPRT(2))
      PRTLIM(3) = IROUND (XPRT(3))
      IF (PRTLIM(1).LE.0) PRTLIM(1) = 100
      IF (PRTLIM(2).LE.0) PRTLIM(2) = 100
      IF (PRTLIM(3).LE.0) PRTLIM(3) = 10
      PRTLIM(4) = PRTLIM(1)
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = .TRUE.
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NFREQ = CATBLK(KINAX+JLOCF)
      BCHAN = IROUND (XBCHAN)
      ECHAN = IROUND (XECHAN)
      IF ((BCHAN.LE.0) .OR. (BCHAN.GT.NFREQ)) BCHAN = 1
      IF ((ECHAN.LE.0) .OR. (ECHAN.GT.NFREQ)) ECHAN = NFREQ
      IF (BCHAN.GT.ECHAN) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      NFRQ = 1
      LUN = 28
      IF ((FRQSEL.LE.0) .AND. (SELBAN.LE.0.0) .AND. (SELFRQ.LE.0D0))
     *   THEN
         FRQSEL = 1
C                                       Determine the number of FREQIDs.
         FQVER = 1
         CALL ISTAB ('FQ', DISKIN, OLDCNO, FQVER, LUN, FQBUFF, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) THEN
            CALL FQINI ('READ', FQBUFF, DISKIN, OLDCNO, FQVER, CATBLK,
     *         LUN, IFQRNO, FQKOLS, FQNUMV, NIF, JERR)
            IF (JERR.NE.0) GO TO 999
            NFRQ = FQBUFF(5)
            IF (NFRQ.GT.1) THEN
               WRITE (MSGTXT,1060) NFRQ
               CALL MSGWRT (3)
               END IF
            CALL TABIO ('CLOS', 0, IFQRNO, FQBUFF, FQBUFF, JERR)
            IF (JERR.NE.0) GO TO 999
            END IF
         END IF
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       now using cal system -
C                                       UVGET makes header
      IF (DOALL.LE.0.0) THEN
         CALL UVGET ('INIT', RPARM, SCRBUF, JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1035) JERR
            GO TO 990
            END IF
         CALL UVGET ('CLOS', RPARM, SCRBUF, IERR)
         END IF
C                                       Save input file info
      INCX = CATBLK(KINAX)
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       read compressed => write compr.
      IF (ISCOMP) THEN
         CATBLK(KINAX) = 1
         I = CATBLK(KIPCN)
         CALL CHR2H (8, 'WEIGHT  ', 1, CATBLK(KHPTP+2*I))
         CALL CHR2H (8, 'SCALE   ', 1, CATBLK(KHPTP+2*I+2))
         CATBLK(KIPCN) = I + 2
         ILOCWT = I
         END IF
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', SCRBUF, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      NERROR = 0
      NBERR = 0
      NAERR = 0
      TLAST = -1.E10
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TIORIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1060 FORMAT ('Processing',I4,' frequency IDs')
      END
      SUBROUTINE TIORUV (IRET)
C-----------------------------------------------------------------------
C   TIORUV sends uv data one point at a time to the time chack routine.
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   ILENBU, NIOLIM, NUMVIS, XCOUNT, CATMP(256), IA1, IA2,
     *   ISOU, IFRQ
      INCLUDE 'TIORD.INC'
      REAL      DUM, VIS(UVBFSS), RPARM(20)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
      DO 200 IFRQ = 1,NFRQ
         IF (IFRQ.GT.1) THEN
            FRQSEL = IFRQ
            NUMVIS = 0
            CALL TORDER (NUMVIS, DUM, IA1, IA2, ISOU)
            END IF
         WRITE (MSGTXT,1001) FRQSEL
         CALL MSGWRT (2)
C                                       defend cat header from UVGET
         CALL COPY (256, CATBLK, CATMP)
C                                       Open and init for read
         CALL UVGET ('INIT', RPARM, VIS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN/INIT INPUT FILE'
            GO TO 990
            END IF
         CALL COPY (256, CATMP, CATBLK)
         NIOLIM = ILENBU
         NUMVIS = 0
         XCOUNT = 0
         ISOU = -1
C                                       Loop
C                                       Read vis. record.
 100     CALL UVGET ('READ', RPARM, VIS, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ INPUT FILE'
            GO TO 990
C                                       Loop over buffer
         ELSE IF (IRET.EQ.0) THEN
            NUMVIS = NUMVIS + 1
C                                       call user routine
            IF (ILOCB.GE.0) THEN
               IA2 = RPARM(1+ILOCB) + 0.1
               IA1 = IA2 / 256
               IA2 = IA2 - 256*IA1
            ELSE
               IA1 = RPARM(1+ILOCA1) + 0.1
               IA2 = RPARM(1+ILOCA2) + 0.1
               END IF
            IF (ILOCSU.GE.0) ISOU = RPARM(1+ILOCSU) + 0.1
            CALL TORDER (NUMVIS, RPARM(1+ILOCT), IA1, IA2, ISOU)
            XCOUNT = XCOUNT + 1
            GO TO 100
            END IF
C                                       Final call to TORDER.
         NUMVIS = -1
         CALL TORDER (NUMVIS, DUM, IA1, IA2, ISOU)
C                                       Close files
         CALL UVGET ('CLOS', RPARM, VIS, IRET)
 200     CONTINUE
C                                       close NX table
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TIORUV: ERROR',I3,' ON ',A)
 1001 FORMAT ('Processing FREQID =',I4)
      END
      SUBROUTINE TIORAL (IRET)
C-----------------------------------------------------------------------
C   TIORUV sends uv data one point at a time to the time chack routine.
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'TIORD.INC'
      CHARACTER IFILE*48
      INTEGER   INIO, IPTRI, LUNI, INDI, ILENBU, IBIND, IA1, IA2, ISOU,
     *   NUMVIS, XCOUNT, VO, BO, I
      REAL      BASEN, DUM
      LOGICAL T, F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI /16/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT FILE'
         GO TO 990
         END IF
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF2, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INITING INPUT FILE'
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
      ISOU = -1
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF2, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT FILE'
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Out of data?
         IF (INIO.LE.0) GO TO 200
C                                       Loop over buffer
         DO 190 I = 1,INIO
            IF (ILOCB.GE.0) THEN
               BASEN = BUFF2(IPTRI+ILOCB)
               IA1 = BASEN / 256. + 0.1
               IA2 = BASEN - IA1*256. + 0.1
            ELSE
               IA1 = BUFF2(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF2(IPTRI+ILOCA2) + 0.1
               END IF
            IF (ILOCSU.GE.0) ISOU = BUFF2(IPTRI+ILOCSU) + 0.1
            NUMVIS = NUMVIS + 1
            CALL TORDER (NUMVIS, BUFF2(IPTRI+ILOCT), IA1, IA2, ISOU)
            XCOUNT = XCOUNT + 1
            IPTRI = IPTRI + LREC
 190        CONTINUE
         GO TO 100
C                                       Final call to TORDER.
 200  NUMVIS = -1
      CALL TORDER (NUMVIS, DUM, IA1, IA2, ISOU)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TIORAL: ERROR',I4,' ON ',A)
      END
      SUBROUTINE TORDER (NUMVIS, T, A1, A2, ISOU)
C-----------------------------------------------------------------------
C   Inputs:
C      NUMVIS  I    Visibility number: 0 -> init counters no data
C                      -1 => final call, no data passed but allows any
C                            operations to be completed.
C      T       R    Time in days since 0 IAT on the first day for
C                   which there is data, the julian day corresponding
C                   to this day can be obtained in D   form by:
C                   CALL JULDAY (CATH(KHDOB),XDAY) where XDAY will
C                   be the Julian day number.
C      A1      I    Antenna 1
C      A2      I    Antenna 1
C      ISOU    I    Source numver
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, A1, A2, ISOU
      REAL      T
C
      INTEGER   MAXBLE
      PARAMETER (MAXBLE=1000)
      INTEGER   NUMPR1, NUMB,  T1(4), T2(4), T31(3), T32(3), B1, B2, I,
     *   J, NUMPR2, LSOU, NUMPR3, TCALL
      REAL      B, TS1, TS2, TBLERR(5,MAXBLE), EPS
      INTEGER   BLERR(5,MAXBLE)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'TIORD.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (T1, T31), (T2, T32), (BLERR, TBLERR)
      SAVE NUMPR1, NUMPR2, NUMPR3, NUMB, BLERR, LSOU, TCALL
      DATA NUMPR1, NUMPR2, NUMPR3, NUMB, TCALL, LSOU /5*0, -1/
C-----------------------------------------------------------------------
      EPS = 0.01 / (3600.0 * 24.0)
C                                       call with data
      IF (NUMVIS.EQ.0) THEN
         NUMPR1 = 0
         NUMPR2 = 0
         NUMPR3 = 0
         NUMB = 0
         TCALL = 0
         LSOU = 0
      ELSE IF (NUMVIS.GT.0) THEN
         TCALL = TCALL + 1
         IF (T.GT.TLAST) BLAST = -1.E3
C                                       subarray condition
         IF ((ABS(T-TLAST).LT.EPS) .AND. (LSOU.NE.ISOU)) THEN
            IF (NUMPR3.LT.PRTLIM(4)) THEN
               CALL T2DHMS (3, T, T1, TS1)
               WRITE (MSGTXT,1020) NUMVIS, LSOU, ISOU, T31, TS1, A1, A2
               IF (MSGTXT(44:44).EQ.' ') MSGTXT(44:44) = '0'
               CALL MSGWRT (5)
               END IF
            NUMPR3 = NUMPR3 + 1
            END IF
         LSOU = ISOU
C                                       time order
         IF (T.LT.TLAST) THEN
            IF (NUMPR1.LT.PRTLIM(1)) THEN
               NUMPR1 = NUMPR1 + 1
               IF (NUMPR1.EQ.1) THEN
                  WRITE (MSGTXT,1000)
                  CALL MSGWRT (5)
                  END IF
               CALL T2DHMS (3, T, T1, TS1)
               CALL T2DHMS (3, TLAST, T2, TS2)
               WRITE (MSGTXT,1001) NUMVIS, T31, TS1, T32, TS2
               IF (MSGTXT(22:22).EQ.' ') MSGTXT(22:22) = '0'
               IF (MSGTXT(41:41).EQ.' ') MSGTXT(41:41) = '0'
               CALL MSGWRT (5)
               END IF
            NERROR = NERROR + 1
            END IF
         TLAST = T
C                                       antenna values
         IF ((A1.GT.A2) .OR. (A1.LE.0) .OR. (A2.LE.0) .OR.
     *      (A1.GT.MAXANT) .OR. (A2.GT.MAXANT)) THEN
            IF (NUMPR2.LT.PRTLIM(2)) THEN
               NUMPR2 = NUMPR2 + 1
               CALL T2DHMS (3, T, T1, TS1)
               WRITE (MSGTXT,1002) T31, TS1, A1, A2
               IF (MSGTXT(22:22).EQ.' ') MSGTXT(22:22) = '0'
               CALL MSGWRT (5)
               END IF
            NAERR = NAERR + 1
            END IF
C                                       baseline order
         B = 4096.0 * A1 + A2
         IF (B.LT.BLAST) THEN
            IF (NUMB.LT.MAXBLE) THEN
               NUMB = NUMB + 1
               B1 = BLAST / 4096.0 + 0.01
               B2 = BLAST - B1 * 4096 + 0.01
               TBLERR(1,NUMB) = T
               BLERR(2,NUMB) = A1
               BLERR(3,NUMB) = A2
               BLERR(4,NUMB) = B1
               BLERR(5,NUMB) = B2
               END IF
            NBERR = NBERR + 1
            END IF
         BLAST = B
C                                       last call - no vis
      ELSE
         NUMB = MIN (NUMB, PRTLIM(3))
         WRITE (MSGTXT,1100)
         IF (NUMB.GT.0) CALL MSGWRT (5)
         DO 100 I = 1,NUMB
            CALL T2DHMS (3, TBLERR(1,I), T1, TS1)
            WRITE (MSGTXT,1101) T31, TS1, (BLERR(J,I), J = 2,5)
            IF (MSGTXT(11:11).EQ.' ') MSGTXT(11:11) = '0'
            CALL MSGWRT (5)
 100        CONTINUE
C                                       summary
         WRITE (MSGTXT,1110) NERROR
         CALL MSGWRT (5)
         WRITE (MSGTXT,1111) NAERR
         CALL MSGWRT (5)
         WRITE (MSGTXT,1112) NBERR
         CALL MSGWRT (5)
         WRITE (MSGTXT,1113) NUMPR3
         CALL MSGWRT (5)
         WRITE (MSGTXT,1114) TCALL
         CALL MSGWRT (5)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('   VIS NUM','    TIME',6X,7X,'  T_LAST')
 1001 FORMAT (I10,I4,'/',2(I2.2,':'),F6.3,3X,I3,'/',2(I2.2,':'),F6.3)
 1002 FORMAT (10X,I4,'/',2(I2.2,':'),F6.3,3X,'ANTENNAS',2I4)
 1020 FORMAT (I10,' Source',I4,' not',I4,' at',I4,'/',2(I2.2,':'),F6.3,
     *   '   BL',I3,' -',I3)
 1100 FORMAT ('  TIME',8X,'BASELINE  <  PREVIOUS BL')
 1101 FORMAT (I3,'/',2(I2.2,':'),F6.3,3X,I2.2,' - ',I2.2,5X,I2.2,
     *   ' - ',I2.2)
 1110 FORMAT ('Total number time errors    ',I10)
 1111 FORMAT ('Total number antenna errors ',I10)
 1112 FORMAT ('Total number baseline errors',I10)
 1113 FORMAT ('Total number subarray errors',I10)
 1114 FORMAT ('Total number visrecs checked',I10)
      END
      SUBROUTINE T2DHMS (NDIG, TIMEIN, TIME, TIMS)
C-----------------------------------------------------------------------
C   Convert from Time to Days Hours Minutes Seconds format
C   Input:
C      NDIG     I       Number of digits in display, determines rounding
C                       for TIMS.
C      TIMEIN   R       Time in days
C   Output:
C      TIME     I*(4)   Output Time in Days Hours Minutes Seconds
C      TIMS     R       Output Time in Seconds
C-----------------------------------------------------------------------
      REAL     TIMEIN, TIMS
      INTEGER  NDIG, TIME(4)
C
      REAL     T
      INTEGER  MUL
C-----------------------------------------------------------------------
      MUL = 10 ** (MAX (0, NDIG))
      T = TIMEIN
      IF (TIMEIN.LT.0.0) T = -T
C
      TIME(1) = T
      T = (T - TIME(1)) * 24.0
      TIME(2) = T
      T = (T - TIME(2)) * 60.0
      TIME(3) = T
      T = (T - TIME(3)) * 60.0
      TIMS = T
      TIME(4) = T*MUL + 0.5
C                                       Now Remove 60 seconds
      IF (TIME(4).GE.60*MUL) THEN
         TIME(4) = TIME(4) - 60*MUL
         TIME(3) = TIME(3) + 1
         END IF
C                                       Now Remove 60 minutes
      IF (TIME(3).GE.60) THEN
         TIME(3) = TIME(3) - 60
         TIME(2) = TIME(2) + 1
         END IF
C                                       Now Remove 24 hours
      IF (TIME(2).GE.24) THEN
         TIME(2) = TIME(2) - 24
         TIME(1) = TIME(1) + 1
         END IF
C                                       Sign
      IF (TIMEIN.LT.0.0) TIME(1) = -TIME(1)
C                                       Seconds
      TIMS = REAL (TIME(4)) / REAL (MUL)
      TIME(4) = TIMS + 0.5
C
 999  RETURN
      END

      SUBROUTINE QCVSDI (APCORE, A, I, B, C, J, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Divide weighted complex vector by complex scalar.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version.
C   CVSDIV divides a Complex vector with weights by a complex
C   scalar.  The complex vector is expected to have data in
C   the order real, imaginary, weight.  The weight is multiplied
C   by the amplitude of the complex scalar.
C     C(mJ) = (1./(B(1)**2+B(2)**2))*(A(mI)*B(1)+A(mI+1)*B(2))
C     C(mJ+1) = (1./B(1)**2+B(2)**2))*(A(mI+1)*B(1)-A(mI)*B(2))
C     C(mJ+2) = A(mI+2) * SQRT(B(1)**2+B(2)**2)  for m = 0, N-1
C   Inputs:
C      A  I  Source vector base address.
C      I  I  Increment of A
C      B  I  Source scalar address.
C      C  I  Destination vector base address
C      J  I  Increment of C
C      N  I  Element count
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   A, I, B, C, J, N
C
      LONGINT   JA, JB, JC
      INTEGER   LOOP
      DOUBLE PRECISION WT, TEMP, E, F
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Addresses 1-rel
      JA = A + PSAPOF
      JB = B + PSAPOF
      JC = C + PSAPOF
C                                        Setup
      WT = (APCORE(JB) * APCORE(JB) + APCORE(JB+1) * APCORE(JB+1))
      WT = MAX (1.0D-15, WT)
      E = APCORE(JB) / WT
      F = APCORE(JB+1) / WT
      WT = SQRT (WT)
C                                        Loop
      INCLUDE 'INCS:ZVND.INC'
      DO 100 LOOP = 1,N
         TEMP = E * APCORE(JA) + F * APCORE(JA+1)
         APCORE(JC+1) = E * APCORE(JA+1) - F * APCORE(JA)
         APCORE(JC) = TEMP
         APCORE(JC+2) = APCORE(JA+2) * WT
         JA = JA + I
         JC = JC + J
 100     CONTINUE
C
 999  RETURN
      END

@PROCESS DIR('ibmdir:')
      subroutine s2ieee(n,src,out)                                              
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C----------------------------------------------------------------------         
C     PURPOSE:                                                                  
C        Subroutine S2IEEE converts IBM 32 bit floating point numbers           
C        into IEEE 32 bit floating point numbers.  IBM numbers with an          
C        exponent larger than can be represented by IEEE floating point         
C        are set to the maximum IEEE floating point number. Likewise,           
C        IBM numbers with an exponent too small for IEEE floating point         
C        are set to zero, with the sign retained. No errors are                 
C        reported.                                                              
C                                                                               
C                                                                               
C     ARGUMENTS:                                                                
c     n   - length of real*4 array                                              
c     src  - array of single precision IBM floating point numbers of            
c           length n                                                            
c     out - output array of single precision IEEE floating point numbers        
c           length n                                                            
C                                                                               
C                                                                               
C        This subroutine assumes all input are normalized floating              
C        point numbers.                                                         
C                                                                               
C IBM/370 Single Precision:                                                     
C        xxxx.xxxx xxxx.xxxx xxxx.xxxx xxxx.xxxx                                
C         |--exp-|-------fraction--------------|                                
C           (7)           (24)                                                  
C   value = (-1)**s * 16**(e-64) * 0.f    range = 5E-79... 7E+75                
C                                                                               
C IEEE Single Precision:                                                        
C        xxxx.xxxx xxxx.xxxx xxxx.xxxx xxxx.xxxx                                
C         |--exp------| |---fraction---------------|                            
C            (8)             (23)                                               
C   value = (-1)**s * 2**(e-127) * 1.f    range = 1E-38... 3E+38                
C                                                                               
c  src & out treated as integer for bit manipulation                            
      implicit none                                                             
      integer*4 n,src(n),out(n)                                                 
      integer*4 i,itemp                                                         
      integer*4 s,frac,expon                                                    
      integer*4 fmaxieee                                                        
      integer*4 z7fffffff                                                       
      integer*4 z80000000                                                       
      integer*4 z7f000000                                                       
      integer*4 z00ffffff                                                       
      integer*4 z00f00000                                                       
      integer*4 z007fffff                                                       
      integer*4 z00800000                                                       
      data fmaxieee /z7f7fffff/                                                 
      data z7fffffff/z7fffffff/                                                 
      data z80000000/z80000000/                                                 
      data z7f000000/z7f000000/                                                 
      data z00ffffff/z00ffffff/                                                 
      data z00f00000/z00f00000/                                                 
      data z007fffff/z007fffff/                                                 
      data z00800000/z00800000/                                                 
c                                                                               
cibmdir: ignore recrdeps                                                        
      do 100 i=1,n                                                              
c                                                                               
c       special case--if source = 0, return ieee 0                              
c                                                                               
        if (iand(src(i),z7fffffff).eq.0) then                                   
          out(i) = src(i)                                                       
c                                                                               
        else                                                                    
          s = iand(src(i),z80000000)                                            
          expon = ishft(iand(src(i),z7f000000),-24) - 64                        
          frac = iand(src(i),z00ffffff)                                         
c                                                                               
c         convert 24 bit fraction to 23 bit fraction                            
c                                                                               
          frac = ishft(frac,-1)
c                                                                               
c         convert scale factor from 16**exponent to 2**exponent by              
c         multiplying the exponent by 4                                         
c                                                                               
          if (expon.ge.0) then                                                  
            expon = ishft(expon,2)                                              
          else                                                                  
            expon = -(ishft(-expon,2))                                          
          endif                                                                 
c                                                                               
c         normalize the fraction                                                
c                                                                               
          if (frac.ne.0) then
            do while (iand(frac,z00800000).eq.0)
              frac = ishft(frac,1)
              expon = expon - 1
            end do
          endif
c                                                                               
c         drop the implied 1 preceeding the binary point                        
c                                                                               
          frac = iand(frac,z007fffff)                                           
c                                                                               
c         convert exponent to excess 127                                        
c                                                                               
          expon = expon + 127                                                   
          if (expon.ge.255) then                                                
            out(i) = ior(s,fmaxieee)                                            
          else if (expon.le.0) then                                             
            out(i) = s                                                          
          else                                                                  
            out(i) = ior(s,ior(ishft(expon,23),frac))                           
          end if                                                                
        endif                                                                   
100   continue                                                                  
      return                                                                    
      end                                                                       

      SUBROUTINE METSCL (LTYPE, X, PREFIX, PFLAG)
C-----------------------------------------------------------------------
C! scale a value to deired range and provide a metric prefix to match
C# Utility Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 2014
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Scale the real value X to a value 0.99995 - 999.95 and pick a
C   standard metric prefix to match.  If X is too large or small to
C   scale, leave it unchanged and set PFLAG to TRUE.  Note that this
C   result should be displayed with formats F6.1, F7.2, etc.  DO NOT
C   use format Fn.0 with n < 6 - an overflow could occur.
C   Inputs:
C      LTYPE   I     Plot type: j = abs(ltype)/100 -> move the
C                       scaling closer to none as
c                    j = 1 -> one step if only 1 or 2 away
c                    j = 2 -> one or two steps if only 1 or 2 away
c                    j = 3 -> one step
c                    j = 4 -> one or two steps
c                    within 2
C   In/Out:
C      X       R     input value
C   Outputs:
C      PREFIX  C*5   4 character/word (<= 5 chars total) metric prefix
C      PFLAG   L     if .FALSE. scaling worked;
C                    if .TRUE. X has been left unchanged
C-----------------------------------------------------------------------
      INTEGER   LTYPE
      CHARACTER PREFIX*5
      REAL      X
      LOGICAL   PFLAG
C                                       Declare max prefix number,blank
      INTEGER   MXPREF, NF
      PARAMETER (MXPREF=17, NF=9)
      CHARACTER PLIST(MXPREF)*5
      REAL      Y
      INTEGER   I, J, K
      DATA PLIST /'Yocto', 'Zepto', 'Atto ', 'Femto', 'Pico ', 'Nano ',
     *   'Micro', 'Milli', '     ', 'Kilo ', 'Mega ', 'Giga ', 'Tera ',
     *   'Peta ', 'Exa  ', 'Zetta', 'Yotta'/
C-----------------------------------------------------------------------
C                                       check for zero
      PFLAG = .FALSE.
      PREFIX = PLIST(NF)
      IF (X.NE.0.0) THEN
         J = ABS (LTYPE) / 100
C                                       get log10 in 3's, check rng
         Y = NF + (LOG10 (ABS (X)) / 3.0)
         PFLAG = ((Y.LT.1.0) .OR. (Y.GT.MXPREF))
C                                       do scaling, check
         IF (.NOT.PFLAG) THEN
            I = Y
            X = X * (10.0 ** (3*(NF-I)))
            IF (X.GT.999.949) THEN
               X = X / 1000.0
               I = I + 1
               END IF
            PFLAG = ((I.LT.1) .OR. (I.GT.MXPREF))
            END IF
C                                       move closer?
         IF (.NOT.PFLAG) THEN
            K = I - NF
            IF ((J.GT.0) .AND. (K.NE.0)) THEN
               IF ((ABS(K).EQ.1) .OR. ((J.EQ.1) .AND. (ABS(K).LE.2))
     *            .OR. (J.EQ.3)) THEN
                  IF (K.GT.0) THEN
                     I = I - 1
                     X = X * 1000.0
                  ELSE
                     I = I + 1
                     X = X / 1000.0
                     END IF
               ELSE IF (((ABS(K).LE.2) .AND. (J.EQ.2)) .OR. (J.EQ.4))
     *            THEN
                  IF (K.GT.0) THEN
                     I = I - 2
                     X = X * 1000000.0
                  ELSE
                     I = I + 2
                     X = X / 1000000.0
                     END IF
                  END IF
               END IF
C                                       set prefix
            PREFIX = PLIST(MAX(1,MIN(I,MXPREF)))
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZRRD2 (FCB, NBYTES, BUFF, IRET)
C-----------------------------------------------------------------------
C! read a message from a server -- generic version
C# IO-remote Z2
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C------------------------------------------------------------------------
C   Read a message from a server.
C
C   Inputs:
C      FCB      I(*)       AIPS file control block.
C
C   Input/output:
C      NBYTES   I          On input the maximum number of bytes to
C                          receive; on output the number of bytes
C                          actually read.
C
C   Outputs:
C      BUFF     I(*)       Message buffer.
C      IRET     I          Error return code:
C                             0 => message read successfully
C                             1 => message longer than NBYTES long
C                             2 => read failed
C                             3 => partner closed connection.
C
C   Generic version (stubbed)
C-----------------------------------------------------------------------
      INTEGER FCB(*), NBYTES, BUFF(*), IRET

      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IRET = 1
      WRITE (MSGTXT, 1000)
      CALL MSGWRT (6)
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZRRD2 REQUIRES LOCAL DEVELOPMENT')
      END

      PROGRAM LTESS
C-----------------------------------------------------------------------
C! Task do make linear combination mosaics
C# Map Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2002-2003, 2006-2008
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   LTESS makes a linear combination mosaic by correcting for the
C   individual primary beam patterns and optimising the signal-to-noise
C   ratio.
C   INPUTS:
C   AIPS name   Prog. name     Description
C   INNAME      NAME(1)        Input image name (name)
C   INCLASS     CLASS(1)       Input image name (class)
C   INSEQ       SEQ(1)         Input image name (sequence number)
C   INDISK      VOL(1)         Input image name (disk number)
C   OUTNAME     NAME(3)        Output image name (name)
C   OUTCLASS    CLASS(3)       Output image name (class)
C   OUTSEQ      SEQ(3)         Output image name (sequence number)
C   OUTDISK     VOL(3)         Output image name (disk number)
C   NMAPS       NFIELD         Number of maps to analyse
C   NOISE       FRES           Rms error for each image (Jy/beam)
C   BLC         BLC            Bottom left corner of LTESS image
C   TRC         TRC            Top right corner of LTESS image
C   PBSIZE      BMSIZE         FWHM of primary beam for each image
C                                 (arcsec)
C   APARM       APM            1 - cutoff for PB correction (%)
C   BADDISK     IBAD           List of disks on which not to put
C                                 scratch files
C   Programmer = R. Braun/T. Cornwell                      December 1987
C-----------------------------------------------------------------------
      CHARACTER NAME(5)*12, CLASS(5)*6
      INTEGER   IRET, LUN2, LUN1, USID, VOL(5), SEQ(5)
      LOGICAL   FINISH, OLD
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
C-----------------------------------------------------------------------
C
C                                       Initialize common constants
      T = .TRUE.
      F = .FALSE.
      MAP = .TRUE.
      EXCL = .TRUE.
      WAIT = .TRUE.
      IERR = 0
      IRET = 0
      LUN1 = 16
      LUN2 = 17
      NCFILE = 0
      FINISH = .FALSE.
      SCLF = 1.0
C                                       Get input values.
      CALL GETIN (USID, NAME, VOL, CLASS, SEQ, IRET)
C                                       Check for restart of AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFFR1, IERR)
      IF (IRET.NE.0) GO TO 990
C                                       Get map files and create
C                                       output files if required.
      CALL FILES (USID, NAME, VOL, CLASS, SEQ, OLD, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Write inputs to history and
C                                       log files.
      CALL VMHIS (NAME, VOL, CLASS, SEQ, OLD, IERR)
      IF (IERR.NE.0) GO TO 990
C
      CONTINUE
C                                       Calculate Linear Combination
      CALL LINCOM (VMOUT, IERR)
      IF (IERR.NE.0) GO TO 990
C
      CATR(KRDMX) = MAX (CATR(KRDMX), IMGMAX)
      CATR(KRDMN) = MIN (CATR(KRDMN), IMGMIN)
      CATR(KRBLK) = FBLANK
      CATBLK(KITYP) = 4
C                                       Update VTESS catalog header
      CALL CATIO ('UPDT', VOL(3), SCRCNO(SCRNM(VMOUT)), CATBLK, 'REST',
     *   BUFFR3, IERR)
      IF ((IERR.NE.0) .AND. (IERR.LT.5)) THEN
         WRITE (MSGTXT,1120) IERR
         CALL MSGWRT (4)
         IERR = 0
      END IF
C
C                                        Finished.
 990  IRET = IERR
      CALL DIE (IRET, BUFFR1)
C
 999  STOP
C-----------------------------------------------------------------------
 1120 FORMAT ('ERROR WRITING HEADER', I3)
      END
      SUBROUTINE FILES (USID, NAME, VOL, CLASS, SEQ, OLD, IERR)
C-----------------------------------------------------------------------
C   FILES reads and floats the beam and the dirty map, opens the
C   default map, creates/opens the VTESS map, and creates the scratch
C   files. The dirty map, default map, and VM map are copied into small
C   scratch files.
C   Programmer =  T.J. Cornwell      December 1987
C-----------------------------------------------------------------------
      CHARACTER NAME(5)*12, CLASS(5)*6,  STAT*4, MAPUNT*8, MTYPE*2
      INTEGER   USID, CNO, VOL(5), SEQ(5), OLDIM, OLDNAX(7), IDEPTH(5),
     *   IDEL, JDEL, I, LUN1, LUN2, FIL, CORN(7), IFIELD, JERR, ITMP,
     *   RETVOL, ISIZE, LF, MNAX(2), NOMAT
      LOGICAL   OLD
      DOUBLE PRECISION OLDCRV(7), FREQ, MCRV(2)
      REAL      XBUF1(1), MCIC(2), MCRP(2), MEPS
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (BUFFR1, XBUF1)
      DATA IDEPTH /5*1/
      DATA MAPUNT /'JY/BEAM '/
      DATA CORN /7*1/
C-----------------------------------------------------------------------
C
      IERR = 0
      NCFILE = 0
      LUN1 = 16
      LUN2 = 17
      NOMAT = 0
C                                       Read map
C                                       Get catalog slot for first map
      CNO = 1
      RETVOL = VOL(1)
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', RETVOL, CNO, NAME(1), CLASS(1), SEQ(1),
     *   MTYPE, USID, STAT, BUFFR3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, NAME(1), CLASS(1), SEQ(1), RETVOL,
     *      USID
         GO TO 990
         END IF
C                                       Copy CATBLK and mark READ
      CALL CATIO ('READ', RETVOL, CNO, CATBLK, 'REST', BUFFR1(1), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         GO TO 990
         END IF
C                                       save coordinates
      MCRV(1) = CATD(KDCRV)
      MCIC(1) = CATR(KRCIC)
      MCRP(1) = CATR(KRCRP)
      MNAX(1) = CATBLK(KINAX)
      MCRV(2) = CATD(KDCRV+1)
      MCIC(2) = CATR(KRCIC+1)
      MCRP(2) = CATR(KRCRP+1)
      MNAX(2) = CATBLK(KINAX+1)
      MEPS = 0.01 * MAX (ABS(MCIC(1)), ABS(MCIC(2)))
C                                       Determine NX and NY
      NX = CATBLK(KINAX)
      NY = CATBLK(KINAX+1)
C                                       set array name
      CALL H2CHR (8, 1, CATH(KHTEL), ANAME)
C                                       Get cell size in arcseconds
      CELLX = CATR(KRCIC)*3600.0
      CELLY = CATR(KRCIC+1)*3600.0
C                                       Set up windows
      IF ((BLC(1).LE.0) .OR. (BLC(1).GE.NX)) BLC(1) = 1
      IDEL = NX-1
      IF (TRC(1).GT.BLC(1)) IDEL = TRC(1)-BLC(1)
      TRC(1) = BLC(1) + IDEL
      IF ((BLC(2).LE.0) .OR. (BLC(2).GE.NY)) BLC(2) = 1
      JDEL = NY-1
      IF (TRC(2).GT.BLC(2)) JDEL = TRC(2) - BLC(2)
      TRC(2) = BLC(2) + JDEL
      XBEG = 1 + NX/2 - (TRC(1)-BLC(1)+1)/2
      YBEG = 1 + NY/2 - (TRC(2)-BLC(2)+1)/2
      XEND = XBEG + (TRC(1)-BLC(1))
      YEND = YBEG + (TRC(2)-BLC(2))
C
      RWNXY = REAL(TRC(1)-BLC(1)+1) * REAL(TRC(2)-BLC(2)+1)
C
      DO 10 I = 1,NUMFIL
         VMSZ(1,I) = NX
         VMSZ(2,I) = NY
 10      CONTINUE
C
      DO 20 IFIELD = 1,NFIELD
         VMSZ(1,DAT(IFIELD)) = NX
         VMSZ(2,DAT(IFIELD)) = NY
  20     CONTINUE
C
      VMSZ(1,VMOUT) = NX
      VMSZ(2,VMOUT) = NY
      HNX = NX
      HNY = NY
C                                       Create scratch files.
      NSCR = 0
      DO 30 FIL = 1,NUMSCR
         CALL MAPSIZ (2, VMSZ(1,FIL), ISIZE)
         CALL SCREAT (ISIZE, BUFFR1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR, FIL
            GO TO 990
         END IF
         SCRNM(FIL) = NSCR
         VMVOL(FIL) = SCRVOL(NSCR)
         CALL ZPHFIL ('SC', SCRVOL(NSCR), SCRCNO(NSCR), 1, VMFILE(FIL),
     *      IERR)
 30      CONTINUE
C
      SCRNM(VMOUT)  = NSCR + 1
C                                       Loop over dirty maps
C                                       Get catalog slot number for
C                                       the dirty map and it's CATBLK.
      DO 60 IFIELD = 1,NFIELD
         CNO = 1
         ITMP = SEQ(1) + IFIELD - 1
         RETVOL = VOL(1)
         MTYPE = 'MA'
         CALL CATDIR ('SRCH', RETVOL, CNO, NAME(1), CLASS(1), ITMP,
     *      MTYPE, USID, STAT, BUFFR3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, NAME(1), CLASS(1), ITMP, RETVOL,
     *         USID
            GO TO 990
            END IF
C                                       Get CATBLK for dirty map.
         CALL CATIO ('READ', RETVOL, CNO, CATBLK, 'READ', BUFFR3,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1090) IERR
            GO TO 990
            END IF
C                                       Mark map READ in /CFILES/
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = RETVOL
         FCNO(NCFILE) = CNO
         FRW(NCFILE) = 0
C                                       Find type of telescope
C                                       Single dish if BMSIZE(IFIELD) <0
         IF (BMSIZE(IFIELD).LT.0.0) THEN
            BEAMTP(IFIELD) = 0
         ELSE IF (BMSIZE(IFIELD).GT.0.0) THEN
            BEAMTP(IFIELD) = 1
         ELSE
            CALL AXEFND (4, 'FREQ', CATBLK(KIDIM), CATH(KHCTP), LF,
     *         IERR)
            IF (IERR.EQ.0) THEN
               FREQ = CATD(KDCRV+LF)
            ELSE
               FREQ = 0.0D0
               END IF
            BEAMTP(IFIELD) = 2
            IF (FREQ.NE.0.) THEN
               BMSIZE(IFIELD) = VELITE / FREQ
            ELSE
               BMSIZE(IFIELD) = 0.0
               END IF
            END IF
C                                       Find pointing center
         IDEPTH(1) = CHAN
         LOCNUM = 1
         CALL SETLOC (IDEPTH, F)
         CALL XYPIX (CATD(KDORA), CATD(KDODE), RCENX(IFIELD),
     *      RCENY(IFIELD), JERR)
         IF (JERR.NE.0) THEN
            RCENX(IFIELD) = CATR(KRCRP)
            RCENY(IFIELD) = CATR(KRCRP+1)
            END IF
C
         VMVOL(DAT(IFIELD)) = RETVOL
         SCRNM(DAT(IFIELD)) = SCRNM(VMOUT) + IFIELD
         SCRCNO(SCRNM(DAT(IFIELD))) = CNO
         CALL ZPHFIL ('MA', RETVOL, CNO, 1, VMFILE(DAT(IFIELD)), IERR)
C                                       Set up block offsets for reading
         CORN(3) = CHAN
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORN(3),
     *      VMBO(DAT(IFIELD)), IERR)
         VMBO(DAT(IFIELD)) = VMBO(DAT(IFIELD)) + 1
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1040) IERR
            GO TO 990
            END IF
C                                       test
         IF ((ABS(MCRV(1)-CATD(KDCRV)).GT.MEPS) .OR.
     *      (ABS(MCRV(2)-CATD(KDCRV+1)).GT.MEPS) .OR.
     *      (ABS(MCIC(1)-CATR(KRCIC)).GT.0.01*MEPS) .OR.
     *      (ABS(MCIC(2)-CATR(KRCIC+1)).GT.0.01*MEPS) .OR.
     *      (ABS(MCRP(1)-CATR(KRCRP)).GT.0.1) .OR.
     *      (ABS(MCRP(2)-CATR(KRCRP+1)).GT.0.1) .OR.
     *      (MNAX(1)-CATBLK(KINAX).NE.0) .OR.
     *      (MNAX(2)-CATBLK(KINAX+1).NE.0)) THEN
            WRITE (MSGTXT,1050) IFIELD
            CALL MSGWRT (7)
            NOMAT = NOMAT + 1
            END IF
 60      CONTINUE
      IF (NOMAT.GT.0) THEN
         WRITE (MSGTXT,1060) NOMAT
         IERR =  NOMAT
         GO TO 990
         END IF
C                                       End of loop over dirty maps
C                                       Create VM file if necessary
C                                       Put NAME in CATBLK
      IF (NAME(3).NE.' ') CALL CHR2H (12, NAME(3), KHIMNO, CATH(KHIMN))
C                                       Put VM class into CATBLK
      CALL CHR2H (6, CLASS(3), KHIMCO, CATH(KHIMC))
C                                        Put in units of map
      CALL CHR2H (8, MAPUNT, 1, CATH(KHBUN))
C                                       Update sequence.
      CATBLK(KIIMS) = SEQ(3)
      CATR(KRDMX) =  -1.E20
      CATR(KRDMN) =  1.E20
      CATR(KRBLK) = FBLANK
C                                       Create output LTESS map file.
      CALL MCREAT (VOL(3), CNO, BUFFR1, IERR)
      OLD = .FALSE.
      IF (IERR.NE.0) THEN
         OLD = .TRUE.
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1190) IERR
            GO TO 990
C                                       Existing file: check it out
         ELSE
            OLDIM = CATBLK(KIDIM)
            DO 70 I = 1,7
               OLDNAX(I) = CATBLK(KINAX+I-1)
               OLDCRV(I) = CATD(KDCRV+I-1)
 70           CONTINUE
            CALL CATIO ('READ', VOL(3), CNO, CATBLK, 'REST', BUFFR3,
     *         IERR)
            IF (OLDIM.NE.CATBLK(KIDIM)) GO TO 80
            IMGMAX = CATR(KRDMX)
            IMGMIN = CATR(KRDMN)
            DO 90 I = 1,2
               IF (OLDNAX(I).NE.CATBLK(KINAX+I-1)) GO TO 80
               IF (OLDCRV(I).NE.CATD(KDCRV+I-1)) GO TO 80
 90            CONTINUE
C                                       mark WRITE
            CALL CATIO ('WRIT', VOL(3), CNO, CATBLK, 'WRIT', BUFFR3,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1210) IERR
               CALL MSGWRT (8)
               END IF
            GO TO 100
C                                       not match
 80         IERR = 8
            WRITE (MSGTXT,1215)
            GO TO 990
            END IF
         END IF
C
 100  CORN(3) = CHAN
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORN(3),
     *   VMBO(VMOUT), IERR)
      VMBO(VMOUT) = VMBO(VMOUT) + 1
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1045) IERR
         GO TO 990
         END IF
C                                       Actual seq #
      SEQ(3) = CATBLK(KIIMS)
C                                        Mark for READ in /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = VOL(3)
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 1
C                                       copy keywords
      CALL KEYCOP (FVOL(1), FCNO(1), VOL(3), CNO, IERR)
C                                       Fill output file into common
      VMVOL(VMOUT) = VOL(3)
      SCRCNO(SCRNM(VMOUT)) = CNO
      CALL ZPHFIL ('MA', VOL(3), CNO, 1, VMFILE(VMOUT), IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FILES: ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,
     *   ' DISK=',I3,' USID=',I4)
 1010 FORMAT ('FILES: CANNOT COPY BEAM CATBLK, ERROR',I3)
 1020 FORMAT ('FILES: ERROR',I3,' CREATING SCRATCH FILE ',I2)
 1040 FORMAT ('FILES: CANNOT COPY DIRTY MAP, ERROR ',I3)
 1045 FORMAT ('FILES: CANNOT COPY LTESS MAP, ERROR ',I3)
 1050 FORMAT ('FILES: FIELD',I5,' DOES NOT MATCH GEOMETRY OF FIELD 1')
 1060 FORMAT ('FILES:',I5,' FIELDS DO NOT MATCH: USE HGEOM')
 1090 FORMAT ('FILES: CANNOT COPY MAP CATBLK, ERROR',I3)
 1190 FORMAT ('FILES: COULD NOT CREATE LTESS MAP FILE, ERROR ',I3)
 1210 FORMAT ('FILES: CANNOT UPDATE LTESS CATBLK, ERROR',I3)
 1215 FORMAT ('OLD LTESS MAP NOT COMPATIBLE WITH DIRTY MAP')
      END
      SUBROUTINE GETIN (USID, NAME, VOL, CLASS, SEQ, IERR)
C-----------------------------------------------------------------------
C   GETIN gets the input parameters for the program from AIPS
C   initializes the parameters, and sets up the file system.
C   Programmer =  T.J. Cornwell      December 1987
C-----------------------------------------------------------------------
      INCLUDE 'INCS:DTESS.INC'
C
      CHARACTER PRGNAM*6, NAME(5)*12, CLASS(5)*6, MTYPE*2
      HOLLERITH XNAM1(3), XNAM3(3), XCLAS1(2), XCLAS3(2)
      INTEGER   USID, SEQ(5), VOL(5), I, LUN1, RETVOL
      INTEGER   NPARMS, IND, CNO, IROUND
      REAL      XSEQ1, XSEQ3, XVOL1, XVOL3, XERROR(64), XGAIN, XNPPB,
     *   XNFIEL, XBLC(7), XTRC(7), XBMSIZ(64), XAPM(7), XBAD(10)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /INPARM/ XNAM1, XCLAS1, XSEQ1, XVOL1, XNAM3, XCLAS3, XSEQ3,
     *   XVOL3, XNFIEL, XERROR, XBLC, XTRC, XBMSIZ, XAPM, XBAD
      DATA PRGNAM /'LTESS '/
C-----------------------------------------------------------------------
C
      IERR = 0
      LUN1 = 16
C                                        Initialize common parameters.
C                                        global areas
      CALL ZDCHIN (.TRUE., BUFFR1)
      CALL VHDRIN
      CALL HIINIT (5)
      BLC(1) = 0
      BLC(2) = 0
      TRC(1) = 0
      TRC(2) = 0
      BUFSZ(1) = XBUFSZ * 2
      BUFSZ(2) = XBUFSZ * 2
      BUFSZ(3) = XBUFSZ * 2
      BUFSZ(4) = XBUFSZ * 2
      BUFSZ(5) = XBUFSZ * 2
      BUFSZ(6) = XBUFSZ * 2
      BPS = NBPS
C                                       Get AIPS adverbs.
      NPARMS = 7 + 7 + 1 + 64 + 7 + 7 + 64 + 7 + 10
      CALL GTPARM (PRGNAM, NPARMS, RQUICK, XNAM1, BUFFR1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         RQUICK = .FALSE.
         GO TO 999
         END IF
C                                       get actual dirty map name
 10   VOL(1) = IROUND(XVOL1)
      SEQ(1) = IROUND(XSEQ1)
      USID = NLUSER
      RETVOL = VOL(1)
      CALL H2CHR (12, 1, XNAM1, NAME(1))
      CALL H2CHR (6, 1, XCLAS1, CLASS(1))
      CALL H2CHR (12, 1, XNAM3, NAME(3))
      CALL H2CHR (6, 1, XCLAS3, CLASS(3))
      MTYPE = 'MA'
      CALL MAPOPN ('READ', RETVOL, NAME(1), CLASS(1), SEQ, MTYPE, USID,
     *   LUN1, IND, CNO, CATBLK, BUFFR1, IERR)
      DRTCNO = CNO
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR,'READ'
         CALL MSGWRT (8)
         GO TO 999
         END IF
 20   CALL MAPCLS ('READ', RETVOL, CNO, LUN1, IND, CATBLK, F, BUFFR1,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR, 'READ'
         CALL MSGWRT (6)
         END IF
 25   IERR = 0
C                                       Default name for Beam and LTESS
C                                       maps is Dirty map name.
      IF (NAME(3).EQ.' ') NAME(3) = NAME(1)
C                                       Copy CLASSes or default.
      IF (CLASS(3).EQ.' ') THEN
         IF (INDEX(CLASS(1), 'MAP') .EQ. 2) THEN
            CLASS(3)(1:1) = CLASS(1)(1:1)
            CLASS(3)(2:)  = 'LTESS'
         ELSE
            CLASS(3) = 'LTESS '
            END IF
         END IF
C                                       Get volume numbers
      VOL(3) = IROUND (XVOL3)
C                                       Get sequence numbers
      SEQ(3) = IROUND (XSEQ3)
C
      DO 70 I = 1,10
         IBAD(I) = IROUND (XBAD(I))
 70      CONTINUE
C                                       Get LTESS information
      BLC(1) = IROUND (MIN (XBLC(1), XTRC(1)))
      BLC(2) = IROUND (MIN (XBLC(2), XTRC(2)))
      TRC(1) = IROUND (MAX (XBLC(1), XTRC(1)))
      TRC(2) = IROUND (MAX (XBLC(2), XTRC(2)))
      CHAN = IROUND (MAX (1.0, XBLC(3)))
      NFIELD = MIN (NINT(XNFIEL), MATFLD)
      IF (NFIELD.LT.1) NFIELD = 1
C
      XNPPB = (XBAD(9) - IBAD(9)) * 1000
      RNPPB = MAX (XNPPB, 0.0)
      IF (XNPPB.EQ.0.0) RNPPB = 1.0
      XGAIN = XBAD(10) - IBAD(10)
      IF (XGAIN.NE.0.0) GAIN = XGAIN
      BLANKD = F
      DO 666 I = 1,NFIELD
         IF (I.LE.64) THEN
            FRES(I) = XERROR(I)
            BMSIZE(I) = XBMSIZ(I)
         ELSE
            FRES(I) = XERROR(64)
            BMSIZE(I) = XBMSIZ(64)
            END IF
         IF (BMSIZE(I).GE.0.0) BLANKD = T
 666     CONTINUE
C                                       cutoff for primary beam
      IF (XAPM(1).LE.0.0) XAPM(1) = 0.07
      CALL RCOPY (7, XAPM, PBPARM)
C                                       Get bad disks.
      IMG = 1
      RES = 2
      SCR = 3
      WK1 = 4
      WK2 = 5
      PRS = 6
      NUMSCR = PRS
C
      DO 779 I = 1,NFIELD
         DAT(I) = NUMSCR + I
 779     CONTINUE
      VMOUT = DAT(NFIELD) + 1
      NUMFIL = VMOUT
C                                       Output files go in common.
      WRITE (MSGTXT,1200) NUMSCR
      CALL MSGWRT (4)
      DO 125 I = 1,NUMFIL
         VMBO(I) = 1
 125     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('GETIN: ERROR',I3,' OPENING DIRTY MAP FILE FOR ',A4)
 1020 FORMAT ('GETIN: ERROR',I3,' CLOSING DIRTY MAP FILE FOR ',A4)
 1200 FORMAT ('Creating ',I3,' scratch files')
      END
      SUBROUTINE LINCOM (OUT, IERR)
C-----------------------------------------------------------------------
C Make linear combination image
C
C   Programmer =  R. Braun      November 1987
C-----------------------------------------------------------------------
      INTEGER    OUT, IFIELD
      REAL       VAL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IERR = 0
C
      DO 100 IFIELD=1,NFIELD
C
         IF (FRES(IFIELD).GT.0.0) THEN
            VAL = 1/FRES(IFIELD)**2
         ELSE
            VAL = 1.0
            END IF
         IF (IFIELD.EQ.1) THEN
            CALL APLPBI(IFIELD, DAT(IFIELD), VAL, PRS, RES, IERR)
            IF (IERR.NE.0) GO TO 990
         ELSE
            CALL APLPBI(IFIELD, DAT(IFIELD), VAL, WK1, WK2, IERR)
            IF (IERR.NE.0) GO TO 990
            CALL ADDMAP(WK1, PRS, PRS, FBLANK, RESMAX, RESMIN, IERR)
            IF (IERR.NE.0) GO TO 990
            CALL ADDMAP(WK2, RES, RES, FBLANK, RESMAX, RESMIN, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
 100     CONTINUE
C
C Now divide by (primary beam)**2
C
      CALL DIVMAP (PRS, RES, PRS, FBLANK, IMGMAX, IMGMIN, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL SMTOBG (PRS, FBLANK, OUT, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C
 990  WRITE (MSGTXT,1000)
      CALL MSGWRT (8)
      IERR = 1
C
 999  CONTINUE
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('LINCOM')
      END
      SUBROUTINE VMHIS (NAME, VOL, CLASS, SEQ, OLD, IERR)
C-----------------------------------------------------------------------
C   VMHIS copies the dirty map history if the VM map does not
C   already have a history file.  Then the inputs to VM with
C   the default values are added to the history file.
C   Programmer =  T.J. Cornwell      December 1987
C-----------------------------------------------------------------------
      CHARACTER NAME(5)*12, CLASS(5)*6, HILINE*72, BEAMNM(2)*8, ATIME*8,
     *   ADATE*12
      INTEGER   VOL(5), SEQ(5), LUN1, LUN2, ITMDAT(6), IFIELD
      LOGICAL   OLD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA BEAMNM /'Gaussian','VLA     '/
C-----------------------------------------------------------------------
      IERR = 0
      LUN1 = 16
      LUN2 = 17
C                                       Open old file: no copy old HI
      IF (.NOT.OLD) GO TO 20
         CALL HIOPEN (LUN1, VMVOL(VMOUT), SCRCNO(SCRNM(VMOUT)),
     *    BUFFR2, IERR)
         IF (IERR.EQ.5) GO TO 20
         IF (IERR.NE.0) GO TO 10
            CALL ZDATE (ITMDAT(1))
            CALL ZTIME (ITMDAT(4))
            CALL TIMDAT (ITMDAT(4), ITMDAT(1), ATIME, ADATE)
            WRITE (HILINE,1000) TSKNAM, RLSNAM, ADATE, ATIME
            CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
            IF (IERR.NE.0) GO TO 50
            GO TO 30
 10      CONTINUE
            WRITE (MSGTXT,1010) IERR
            CALL MSGWRT (6)
            GO TO 60
C                                       Copy/open history files.
 20   CONTINUE
         CALL HISCOP (LUN2, LUN1, VMVOL(DAT(1)), VOL(3),
     *       SCRCNO(SCRNM(DAT(1))),
     *       SCRCNO(SCRNM(VMOUT)), CATBLK, BUFFR1, BUFFR2, IERR)
         IF (IERR.EQ.0) GO TO 30
C                                       Check if old file doesn't exist
         IF (IERR.EQ.2) GO TO 30
            WRITE (MSGTXT,1020) IERR
            CALL MSGWRT (6)
            GO TO 60
C                                       Add to history file.
C                                       Dirty map name.
 30   WRITE (MSGTXT,2000) TSKNAM, NAME(1),CLASS(1), SEQ(1), VOL(1)
      CALL MSGWRT (3)
      CALL HENCO1 (TSKNAM, NAME(1), CLASS(1), SEQ(1), VOL(1),
     *   LUN1, BUFFR2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       LTESS map name.
      WRITE (MSGTXT,2002) TSKNAM, NAME(3), CLASS(3), SEQ(3), VOL(3)
      CALL MSGWRT (3)
      CALL HENCOO (TSKNAM, NAME(3), CLASS(3), SEQ(3), VOL(3),
     *   LUN1, BUFFR2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       Boxes
      WRITE (HILINE,2009) TSKNAM, BLC(1), BLC(2)
      CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
      MSGTXT = HILINE(7:)
      CALL MSGWRT (2)
      IF (IERR.NE.0) GO TO 50
C                                       Boxes
      WRITE (HILINE,2010) TSKNAM, TRC(1),TRC(2)
      CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
      MSGTXT = HILINE(7:)
      CALL MSGWRT (2)
      IF (IERR.NE.0) GO TO 50
C                                       Pointing centers
      DO 777 IFIELD=1,NFIELD
         WRITE (HILINE,2023) TSKNAM, IFIELD, IFIELD,
     *      RCENX(IFIELD), RCENY(IFIELD)
         CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
         MSGTXT = HILINE(7:)
         CALL MSGWRT (2)
         IF (IERR.NE.0) GO TO 50
 777     CONTINUE
C                                       Noise level
      DO 779 IFIELD=1,NFIELD
         WRITE (HILINE,2006) TSKNAM, IFIELD, FRES(IFIELD)
         CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
         MSGTXT = HILINE(7:)
         CALL MSGWRT (2)
         IF (IERR.NE.0) GO TO 50
 779     CONTINUE
C                                       Pointing centers
      DO 780 IFIELD=1,NFIELD
      IF (BEAMTP(IFIELD).EQ.0) THEN
         WRITE (HILINE,2026) TSKNAM, IFIELD
         CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
         MSGTXT = HILINE(7:)
         CALL MSGWRT (2)
         IF (IERR.NE.0) GO TO 50
      ELSE
         WRITE (HILINE,2028) TSKNAM, IFIELD
         CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
         MSGTXT = HILINE(7:)
         CALL MSGWRT (2)
         IF (IERR.NE.0) GO TO 50
         IF (BMSIZE(IFIELD).LE.0.0) THEN
            WRITE (HILINE,2027) TSKNAM, IFIELD
            CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
            MSGTXT = HILINE(7:)
            CALL MSGWRT (2)
            IF (IERR.NE.0) GO TO 50
         ELSE
            WRITE (HILINE,2025) TSKNAM, IFIELD, BEAMNM(BEAMTP(IFIELD))
            CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
            MSGTXT = HILINE(7:)
            CALL MSGWRT (2)
            IF (IERR.NE.0) GO TO 50
            IF (BEAMTP(IFIELD).EQ.1) THEN
               WRITE (HILINE,2024) TSKNAM, IFIELD, BMSIZE(IFIELD)
            ELSE
               WRITE (HILINE,2022) TSKNAM, IFIELD, BMSIZE(IFIELD)
               END IF
            CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
            MSGTXT = HILINE(7:)
            CALL MSGWRT (2)
            IF (IERR.NE.0) GO TO 50
         END IF
      END IF
  780 CONTINUE
C                                       CHAN
      WRITE (HILINE,2177) TSKNAM, CHAN
      CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
      MSGTXT = HILINE(7:)
      CALL MSGWRT (2)
      IF (IERR.NE.0) GO TO 50
C
      GO TO 60
C                                       Error has occured.
 50   WRITE (MSGTXT,1050) IERR
      CALL MSGWRT (6)
C                                       Close history files.
 60   CALL HICLOS (LUN1, T, BUFFR2, IERR)
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /******** Restart ',
     *   A12,1X,A8)
 1010 FORMAT ('UNABLE TO OPEN OLD LTESS-MAP HISTORY FILE')
 1020 FORMAT ('VMHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1050 FORMAT ('VMHIS: ERROR',I3,' WRITING HISTORY FILE')
 2000 FORMAT (A6,'Dirty map =    ''',A12,''' . ''',A6,
     *   ''' . ',2I4)
 2002 FORMAT (A6,'Ltess map =    ''',A12,''' . ''',A6,
     *   ''' . ',2I4)
 2009 FORMAT (A6,'BLC = ',2(I5,1X),' /Bottom left corner')
 2010 FORMAT (A6,'TRC = ',2(I5,1X),' /Top   right corner')
 2177 FORMAT (A6,'BLC(3) = ',I6,' /Channel number')
 2022 FORMAT (A6,'/Field',I5,' VLA lambda=',F7.4,' m for primary beam')
 2023 FORMAT (A6,'PBCENX(',I4,'), PBCENY(',I4,') = ',F7.2,',',
     *   F7.2,' /Pixels')
 2024 FORMAT (A6,'PBSIZE(',I4,') = ',F8.1,'/ Arcseconds')
 2025 FORMAT (A6,'/Field',I5,' : Primary beam = ',A8)
 2026 FORMAT (A6,'/Field',I5,' : Single aperture data')
 2028 FORMAT (A6,'/Field',I5,' : Interferometer  data')
 2027 FORMAT (A6,'/Field',I5,' : No primary beam correction')
 2006 FORMAT (A6,'NOISE(',I4,') = ',1PE11.3,'/ Jy/beam')
      END

      SUBROUTINE IMINIT (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   ROW, IMKOLS, IMNUMV, OBSCOD, RDATE, NUMSTK, STK1, NUMIF,
     *   NUMCHN, REFFRQ, CHANBW, REFPIX, NUMPOL, NUMPLY, CORREV, IERR)
C-----------------------------------------------------------------------
C! Open interferometer model table for reading or writing
C# EXT-appl VLBI Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2000, 2006, 2009, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Open an interferometer model (IM) table for reading or writing.
C
C   If OPCODE is 'READ', VER is positive, and there is an IM table with
C   version number VER attached to the file with catalogue number CNO on
C   disk DISK that can be opened for reading then open the table for
C   reading, update BUFFER, IMKOLS, and IMNUMV, set ROW to 1, set
C   OBSCOD, RDATE, NUMSTK, STK1, NUMIF, NUMCHN, REFFRQ, CHANBW, REFPIX,
C   NUMPOL, NUMPLY, and CORREV from the table header, and set IERR to
C   zero.
C
C   If OPCODE is 'READ', VER is zero, and there is at least one IM table
C   attached to the file with catalogue number CNO on disk DISK that can
C   be opened for reading then open the highest numbered IM table for
C   reading, update BUFFER, IMKOLS, and IMNUMV, set ROW to 1, set VER to
C   the version number of the table that was opened, set OBSCOD, RDATE,
C   NUMSTK, STK1, NUMIF, NUMCHN, REFFRQ, CHANBW, REFPIX, NUMPOL, NUMPLY,
C   and CORREV from the table header, and set IERR to zero.
C
C   If OPCODE is 'WRIT', VER is positive, and there is an IM table with
C   version number VER attached to the file with catalogue number CNO on
C   disk DISK that can be opened for writing then open the table for
C   writing, update BUFFER, IMKOLS, and IMNUMV, set ROW to one more than
C   the number of rows in the table, set OBSCOD, RDATE, NUMSTK, STK1,
C   NUMIF, NUMCHN, REFFRQ, CHANBW, REFPIX, NUMPOL, NUMPLY, and CORREV
C   from the table header, and set IERR to zero.
C
C   If OPCODE is 'WRIT', VER is positive, there is no IM table with
C   version number VER attached to the file with catalogue number CNO on
C   disk DISK, and a new IM table can be attached to this file then
C   create a new IM table with version number VER and open the table for
C   writing, update BUFFER, IMKOLS, and IMNUMV, set ROW to one,
C   enter the values of OBSCOD, RDATE, NUMSTK, STK1, NUMIF, NUMCHN,
C   REFFRQ, CHANBW, REFPIX, NUMPOL, NUMPLY, and CORREV in the table
C   header, and set IERR to zero.
C
C   If OPCODE is 'WRIT', VER is zero, and a new IM table can be attached
C   to the file with catalogue number CNO on disk DISK then create a new
C   IM table and open the table for writing, update BUFFER, IMKOLS, and
C   IMNUMV, set ROW to one, set VER to the version number of the new
C   table, enter the values of OBSCOD, RDATE, NUMSTK, STK1, NUMIF,
C   NUMCHN, REFFRQ, CHANBW, REFPIX, NUMPOL, NUMPLY, and CORREV in the
C   table header, and set IERR to zero.
C
C   Otherwise issue one or more error messages and set IERR to a
C   non-zero value.
C
C   Inputs:
C      OPCODE  C*4      'READ' or 'WRIT'
C      DISK    I        disk number
C      CNO     I        catalogue number
C      LUN     I        LUN for table I/O (must be valid for table I/O)
C
C   Input/Output:
C      VER     I        requested table version number or zero on entry,
C                       actual table version number on exit
C      CATBLK  I(256)   catalogue block for file CNO on DISK
C      OBSCOD  C*8      observing code
C      RDATE   C*8      reference date (YYYYMMDD)
C      NUMSTK  I        size of STOKES axis in parent data file
C      STK1    I        reference value for STOKES axis in parent data
C                       file
C      NUMIF   I        size of IF axis in parent data file
C      NUMCHN  I        size of FREQ axis in parent data file
C      REFFRQ  I        reference frequency in Hz
C      CHANBW  I        channel spacing in Hz
C      REFPIX  I        reference pixel number for FREQ axis
C      NUMPOL  I        number of polarizations in table (1 or 2)
C      NUMPLY  I        number of polynomial terms used in table
C      CORREV  I        revision number of correlator software that
C                       generated the original table
C
C   Output:
C      BUFFER  I(512)   I/O control block and data buffer for table
C      ROW     I        first row to read or write
C      IMKOLS  I(20)    index of first data word for each logical
C                       column in a table record
C      IMNUMV  I(20)    dimension of each logical column
C      IERR    I        return status: 0 if table opened, non-zero
C                                      otherwise
C
C   Note:
C      A similar routine, IMINI, uses common blocks instead of explicit
C      arguments. You should open the table with IMINI if you wish to
C      open the table for use with GETDEL.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, OBSCOD*8, RDATE*8
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN,
     *   ROW, IMKOLS(20), IMNUMV(20), NUMSTK, STK1, NUMIF, NUMCHN,
     *   NUMPOL, NUMPLY, IERR
      DOUBLE PRECISION REFFRQ, CHANBW, REFPIX, CORREV
C
C     Local variables
C
C     TTITLE            table title
C     CTITLE            column titles
C     CUNITS            column units
C     TABREV            current table revision
C     TREVN             existing table revision number
C     NKEY              number of keyword/values in table header
C     NCOL              number of columns in table
C     NREC              number of rows to add to the table when it
C                       is extended
C     DATP              column descriptors
C     COL               number of defined columns
C     HOLTMP            Hollerith buffer
C     KEYS              keywords
C     KTYPE             keyword value types
C     KVALUE            keyword value array
C     KLOC              indices of keyword values in KVALUE
C
      CHARACTER TTITLE*56
      PARAMETER (TTITLE = 'INTERFEROMETER MODEL TABLE')
      CHARACTER CTITLE(20)*24, CUNITS(20)*8
      INTEGER   TABREV
      PARAMETER (TABREV = 2)
      INTEGER   TREVN, NKEY, NCOL, NREC, DATP(128,2), COL, NDATA, NC,
     *   ITRIM, IPOINT, I, JERR, ITEMP(6)
      HOLLERITH HOLTMP(6)
      CHARACTER KEYS(13)*8
      INTEGER   KTYPE(13), KVALUE(26), KLOC(13)
      EQUIVALENCE (HOLTMP, ITEMP)
      INCLUDE 'INCS:PTAB.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA CTITLE
     *   /'TIME                    ', 'TIME_INTERVAL           ',
     *    'SOURCE_ID               ', 'ANTENNA_NO              ',
     *    'ARRAY                   ', 'FREQID                  ',
     *    'I.FAR.ROT               ', 'FREQ.VAR                ',
     *    'PDELAY_1                ', 'GDELAY_1                ',
     *    'PRATE_1                 ', 'GRATE_1                 ',
     *    'DISP_1                  ', 'DDISP_1                 ',
     *    'PDELAY_2                ', 'GDELAY_2                ',
     *    'PRATE_2                 ', 'GRATE_2                 ',
     *    'DISP_2                  ', 'DDISP_2                 '/
      DATA CUNITS /'DAYS    ', 'DAYS    ', '        ', '        ',
     *             '        ', '        ', 'RAD/M**2', 'HZ      ',
     *             'SECONDS ', 'SECONDS ', 'HZ      ', 'SEC/SEC ',
     *             'SEC/M**2', 'S/S/M**2', 'SECONDS ', 'SECONDS ',
     *             'HZ      ', 'SEC/SEC ', 'SEC/M**2', 'S/S/M**2'/
      DATA KEYS /'RDATE   ', 'OBSCODE ', 'NO_STKD ', 'STK_1   ',
     *           'NO_BAND ', 'NO_CHAN ', 'REF_FREQ', 'CHAN_BW ',
     *           'REF_PIXL', 'NO_POL  ', 'NPOLY   ', 'REVISION',
     *           'TABREV  '/
C-----------------------------------------------------------------------
C
C     If OPCODE is 'READ' then initialize variables for a call to open
C     the table for reading and set IERR to zero. If OPCODE is 'WRIT'
C     then initialize variable for a call to open the table for writing
C     and set IERR to 0. Otherwise issue an erro message and set IERR to
C     a non-zero value.
C
      NREC = 30
      IERR =  0
      IF (OPCODE.EQ.'WRIT') THEN
         NKEY = 13
         NCOL = 8 + 6 * NUMPOL
         DATP(1,2)  = TABDBL + 10
         DATP(2,2)  = TABFLT + 10
         DATP(3,2)  = TABINT + 10
         DATP(4,2)  = TABINT + 10
         DATP(5,2)  = TABINT + 10
         DATP(6,2)  = TABINT + 10
         DATP(7,2)  = TABFLT + 10
         DATP(8,2)  = TABFLT + 10 * NUMIF
         DATP(9,2)  = TABDBL + 10 * NUMIF * NUMPLY
         DATP(10,2) = TABDBL + 10 * NUMPLY
         DATP(11,2) = TABDBL + 10 * NUMIF * NUMPLY
         DATP(12,2) = TABDBL + 10 * NUMPLY
         DATP(13,2) = TABFLT + 10
         DATP(14,2) = TABFLT + 10
         IF (NUMPOL.EQ.2) THEN
            DATP(15,2) = TABDBL + 10 * NUMIF * NUMPLY
            DATP(16,2) = TABDBL + 10 * NUMPLY
            DATP(17,2) = TABDBL + 10 * NUMIF * NUMPLY
            DATP(18,2) = TABDBL + 10 * NUMPLY
            DATP(19,2) = TABFLT + 10
            DATP(20,2) = TABFLT + 10
            END IF
      ELSE IF (OPCODE.EQ.'READ') THEN
         NKEY = 0
         NCOL = 0
      ELSE
         MSGTXT = 'IMINIT: INVALID OPCODE ''' // OPCODE // ''''
         CALL MSGWRT (7)
         IERR = 1
         GO TO 999
         END IF
C                                       open table
      CALL TABINI (OPCODE, 'IM', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'IMINIT', IERR)
         GO TO 990
         END IF
C                                       new table
      IF (IERR.LT.0) THEN
         ROW = 1
C                                       Fill in the table title:
         CALL CHR2H (56, TTITLE, 1, BUFFER(101))
C                                       column labels, units
         DO 10 COL = 1,NCOL
            CALL CHR2H (24, CTITLE(COL), 1, ITEMP)
            CALL TABIO ('WRIT', 3, COL, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'IMINIT', IERR)
               GO TO 990
               END IF
            CALL CHR2H (8, CUNITS(COL), 1, ITEMP)
            CALL TABIO ('WRIT', 4, COL, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'IMINIT', IERR)
               GO TO 990
               END IF
 10         CONTINUE
C                                       Set keyword values:
         KLOC(1) = 1
         KTYPE(1) = TABHOL
         CALL CHR2H (8, RDATE, 1, KVALUE(KLOC(1)))
         KLOC(2) = KLOC(1) + 2
         KTYPE(2) = TABHOL
         CALL CHR2H (8, OBSCOD, 1, KVALUE(KLOC(2)))
         KLOC(3) = KLOC(2) + 2
         KTYPE(3) = TABINT
         KVALUE(KLOC(3)) = NUMSTK
         KLOC(4) = KLOC(3) + 1
         KTYPE(4) = TABINT
         KVALUE(KLOC(4)) = STK1
         KLOC(5) = KLOC(4) + 1
         KTYPE(5) = TABINT
         KVALUE(KLOC(5)) = NUMIF
         KLOC(6) = KLOC(5) + 1
         KTYPE(6) = TABINT
         KVALUE(KLOC(6)) = NUMCHN
         KLOC(7) = KLOC(6) + 1
         KTYPE(7) = TABDBL
         CALL DPCOPY (1, REFFRQ, KVALUE(KLOC(7)))
         KLOC(8) = KLOC(7) + NWDPDP
         KTYPE(8) = TABDBL
         CALL DPCOPY (1, CHANBW, KVALUE(KLOC(8)))
         KLOC(9) = KLOC(8) + NWDPDP
         KTYPE(9) = TABDBL
         CALL DPCOPY (1, REFPIX, KVALUE(KLOC(9)))
         KLOC(10) = KLOC(9) + NWDPDP
         KTYPE(10) = TABINT
         KVALUE(KLOC(10)) = NUMPOL
         KLOC(11) = KLOC(10) + 1
         KTYPE(11) = TABINT
         KVALUE(KLOC(11)) = NUMPLY
         KLOC(12) = KLOC(11) + 1
         KTYPE(12) = TABDBL
         CALL DPCOPY (1, CORREV, KVALUE(KLOC(12)))
         KLOC(13) = KLOC(12) + NWDPDP
         KTYPE(13) = TABINT
         KVALUE(KLOC(13)) = TABREV
         NKEY = 13
         CALL TABKEY ('WRIT', KEYS, NKEY, BUFFER, KLOC, KVALUE, KTYPE,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'IMINIT', IERR)
            GO TO 990
            END IF
C                                       Read an existing table
      ELSE
         NKEY = 1
         CALL TABKEY ('READ', KEYS, NKEY, BUFFER, KLOC, KVALUE, KTYPE,
     *      IERR)
         IF (IERR.EQ.0) THEN
            CALL H2CHR (8, 1, KVALUE(KLOC(1)), RDATE)
         ELSE
            RDATE = ' '
            END IF
         NKEY = 12
         CALL TABKEY ('READ', KEYS(2), NKEY, BUFFER, KLOC, KVALUE,
     *      KTYPE, IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'IMINIT', IERR)
            GO TO 990
            END IF
C                                       Keyword values Unpack
         CALL H2CHR (8, 1, KVALUE(KLOC(1)), OBSCOD)
         NUMSTK = KVALUE(KLOC(2))
         STK1   = KVALUE(KLOC(3))
         NUMIF  = KVALUE(KLOC(4))
         NUMCHN = KVALUE(KLOC(5))
         CALL COPY (NWDPDP, KVALUE(KLOC(6)), REFFRQ)
         CALL COPY (NWDPDP, KVALUE(KLOC(7)), CHANBW)
         CALL COPY (NWDPDP, KVALUE(KLOC(8)), REFPIX)
         NUMPOL = KVALUE(KLOC(9))
         NUMPLY = KVALUE(KLOC(10))
         CALL COPY (NWDPDP, KVALUE(KLOC(11)), CORREV)
         TREVN  = KVALUE(KLOC(12))
         IF (TREVN.NE.TABREV) THEN
            WRITE (MSGTXT,1014) TREVN, TABREV
            CALL MSGWRT (7)
            IERR = 1
            END IF
         END IF
C                                       dimensions
      NDATA = 8 + 6 * NUMPOL
      IF (OPCODE.EQ.'READ') THEN
         ROW = 1
      ELSE
         ROW = BUFFER(5) + 1
         END IF
C                                      Get array indices
C                                      Cover your ass from FNDCOL -
C                                      close to flush the buffers and
C                                      then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KVALUE, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'IMINIT', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'IM', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'IMINIT', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (NDATA, CTITLE, 24, .TRUE., BUFFER, IMKOLS, JERR)
C                                      Get array indices and no. values
      DO 150 I = 1,NDATA
         IPOINT = IMKOLS(I)
         IF (IPOINT.GT.0) THEN
            IMKOLS(I) = DATP(IPOINT,1)
            IMNUMV(I) = DATP(IPOINT,2) / 10
            IF (IMNUMV(I).LE.0) THEN
               NC = ITRIM (CTITLE(I))
               WRITE (MSGTXT,1100) CTITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            IMKOLS(I) = -1
            IMNUMV(I) = 0
            NC = ITRIM (CTITLE(I))
            WRITE (MSGTXT,1101) CTITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      IERR = 0
      GO TO 999
C                                      Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1014 FORMAT ('IMINIT: FORMAT REVISION IS ', I2, ' EXPECTED ', I2)
 1100 FORMAT ('IMINIT: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('IMINIT: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('IMINIT: ERROR INITIALIZING INTERFEROMETER MODEL TABLE',
     *   ' FOR ',A4)
      END

      SUBROUTINE ZFREE (MSLEV, IERR)
C-----------------------------------------------------------------------
C! display available disk space
C# Z System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2003-2004, 2008-2009, 2017-2018, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Determine the number of free 256-integer blocks that are available
C   on the disks used for AIPS user data and print the information on
C   the user's terminal.
C   Inputs:
C      MSLEV   I   Message level to use (1 => to terminal only,
C                     2-5 => also to message file)
C   Common /DCHCOM/
C      NVOL    I   Number of AIPS disks
C   Output:
C     IERR     I   Error return code: 0 => no error
C                     1 => error
C   UNIX version - uses ZFRE2 to get info then string processes with
C   UNIX file names in mind.
C-----------------------------------------------------------------------
      INTEGER   MSLEV, IERR
C
      INTEGER   I, VLEN, J1, J2, IP, J, ITRIM, NC, IC, K
      LONGINT   TOTBLK(99), FRBLKS(99), MXBLK
      REAL      PCTFUL(99)
      HOLLERITH HVOLN(1200)
      CHARACTER ACCES*3, LVOL*64
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      MSLEV = MAX (1, MIN (9, MSLEV))
      IERR = 0
C                                       Get AIPS disk info
      LVOL = ' '
      CALL CHR2H (4800, LVOL, 1, HVOLN)
      VLEN = 48
      CALL ZFRE2 (NVOL, HVOLN, VLEN, TOTBLK, PCTFUL, FRBLKS)
C                                       Find maxima
      MXBLK = 0
      DO 10 I = 1,NVOL
         MXBLK = MAX (MXBLK, TOTBLK(I))
 10      CONTINUE
C                                       format
      IF (MXBLK.GE.1.0D11) THEN
         IC = 14
      ELSE IF (MXBLK.GE.1.0D10) THEN
         IC = 13
      ELSE IF (MXBLK.GE.1000000000) THEN
         IC = 12
      ELSE IF (MXBLK.GE.100000000) THEN
         IC = 11
      ELSE IF (MXBLK.GE.10000000) THEN
         IC = 10
      ELSE
         IC = 9
         END IF
      NC = 49 - 2*IC
C                                       Print header.
      MSGTXT = 'Disk Volume name'
      J = 9 + NC + IC - 9
      MSGTXT(J:) = 'Total Full'
      J = 9 + NC + IC + 5 + IC - 8
      MSGTXT(J:) = 'Free Who'
      CALL MSGWRT (MSLEV)
      MSGTXT = ' #'
      K = 9 + NC + IC - 10
      MSGTXT(K:) = 'Mbytes    %'
      K = 9 + NC + IC + 5 + IC - 10
      MSGTXT(K:) = 'Mbytes'
      CALL MSGWRT (MSLEV)
C                                       Print info
      DO 40 I = 1,NVOL
         J2 = I * VLEN
         J1 = J2 - VLEN + 1
         CALL H2CHR (VLEN, J1, HVOLN, LVOL)
         J = ITRIM (LVOL)
         IF (J.GT.NC) THEN
            J2 = J1 + J - 1
            J1 = J2 - NC + 1
            J = J2 - J1 + 1
            CALL H2CHR (J, J1, HVOLN, LVOL)
            LVOL(1:1) = '<'
            END IF
         IP = PCTFUL(I) + 0.5
         ACCES = 'All'
         IF (DASSGN(1,I).NE.0) THEN
            IF (DASSGN(1,I).LT.0) THEN
               ACCES = 'Scr'
            ELSE
               ACCES = 'No '
               DO 30 J = 1,8
                  IF (DASSGN(J,I).EQ.NLUSER) ACCES = 'You'
 30               CONTINUE
               IF (NLUSER.EQ.1) ACCES = 'You'
               END IF
            END IF
         IF (IC.EQ.9) THEN
            WRITE (MSGTXT,1030,ERR=35) I, LVOL(:NC), TOTBLK(I), IP,
     *         FRBLKS(I), ACCES
         ELSE IF (IC.EQ.10) THEN
            WRITE (MSGTXT,1031,ERR=35) I, LVOL(:NC), TOTBLK(I), IP,
     *         FRBLKS(I), ACCES
         ELSE IF (IC.EQ.11) THEN
            WRITE (MSGTXT,1032,ERR=35) I, LVOL(:NC), TOTBLK(I), IP,
     *         FRBLKS(I), ACCES
         ELSE IF (IC.EQ.12) THEN
            WRITE (MSGTXT,1033,ERR=35) I, LVOL(:NC), TOTBLK(I), IP,
     *         FRBLKS(I), ACCES
         ELSE IF (IC.EQ.13) THEN
            WRITE (MSGTXT,1034,ERR=35) I, LVOL(:NC), TOTBLK(I), IP,
     *         FRBLKS(I), ACCES
         ELSE
            WRITE (MSGTXT,1035,ERR=35) I, LVOL(:NC), TOTBLK(I), IP,
     *         FRBLKS(I), ACCES
            END IF
 35      CALL MSGWRT (MSLEV)
 40      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (I2,2X,A,I9,I5,I9,1X,A3)
 1031 FORMAT (I2,2X,A,I10,I5,I10,1X,A3)
 1032 FORMAT (I2,2X,A,I11,I5,I11,1X,A3)
 1033 FORMAT (I2,2X,A,I12,I5,I12,1X,A3)
 1034 FORMAT (I2,2X,A,I13,I5,I13,1X,A3)
 1035 FORMAT (I2,2X,A,I14,I5,I14,1X,A3)
      END

      SUBROUTINE DCODEF (IPOS, IWIDTH, IFRAC, LINE, VALUE, IERR)
C-----------------------------------------------------------------------
C! Decodes data from a character string using a format.
C# Parsing
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Decode the number.
C   Inputs:
C      IPOS    I      Starting position of number in LINE.
C      IWIDTH  I      Width of field.
C      IFRAC   I      Number of fraction positions.  Works like FORTRAN
C                     format Fw.f  where "w" is IWIDTH and "f" is IFRAC
C      LINE   C*(*)   Character string.
C   Output:
C      VALUE   D      Output value.
C      IERR    I      Error code: 0 = okay
C-----------------------------------------------------------------------
      CHARACTER LINE*(*), DIGIT*10, ONECH*1
      INTEGER   IPOS, IWIDTH, IFRAC, IERR
      DOUBLE PRECISION VALUE, SIGN
      INTEGER   IT, NFRAC, IPOWER, IESIGN, ISTART, IEND, I, ISTATE
      LOGICAL   FRCFLG, INT
      INCLUDE 'INCS:DMSG.INC'
      DATA DIGIT /'0123456789'/
C-----------------------------------------------------------------------
C                                       Set some defaults.
      VALUE = 0.0D0
      NFRAC = 0
      FRCFLG = .FALSE.
      IPOWER = 0
      SIGN = 1.0D0
      ISTATE = 1
      IESIGN = 1
      ISTART = IPOS
      IEND = ISTART + IWIDTH - 1
      INT = .FALSE.
C                                       Integer format
      IF (IFRAC.GE.0) GO TO 10
         FRCFLG = .TRUE.
         INT = .TRUE.
 10   DO 600 I = ISTART,IEND
         ONECH = LINE(I:I)
         GO TO (100, 200, 300, 400, 500, 600), ISTATE
C                                       Look for sign.
 100        IF (ONECH.EQ.' ') GO TO 600
C                                       Plus
            IF (ONECH.NE.'+') GO TO 110
               ISTATE = 2
               GO TO 600
C                                       Minus
 110        IF (ONECH.NE.'-') GO TO 200
               SIGN = -1.0D0
               ISTATE = 2
               GO TO 600
C
 200        IF (INT) GO TO 300
C                                       DOT (starts fractional part)
            IF (ONECH.NE.'.') GO TO 300
               ISTATE = 3
               FRCFLG = .TRUE.
               GO TO 600
C
 300        IT = 0
            IF (ONECH.EQ.' ') GO TO 320
               IT = INDEX (DIGIT, ONECH) - 1
 320        IF ((IT.LT.0).OR.(IT.GT.9)) GO TO 350
               VALUE = VALUE * 10 + IT
               ISTATE = MAX (ISTATE, 2)
               IF (ISTATE.EQ.3) NFRAC = NFRAC + 1
               GO TO 600
C
 350        IF (INT) GO TO 980
C                                       E (starts exponent).
            IF ((ONECH.NE.'E').AND.(ONECH.NE.'e').AND.
     *         (ONECH.NE.'D').AND.(ONECH.NE.'d')) GO TO 980
               ISTATE = 4
               GO TO 600
C                                       Look for exponent sign.
 400        IF (ONECH.EQ.' ') GO TO 600
            ISTATE = 5
            IF (ONECH.EQ.'+') GO TO 600
C                                       Minus
            IF (ONECH.NE.'-') GO TO 500
               IESIGN = -1
               GO TO 600
C                                       Look for power.
 500        IT = 0
            IF (ONECH.EQ.' ') GO TO 520
               IT = INDEX (DIGIT, ONECH) - 1
 520        CONTINUE
            IF ((IT.LT.0).OR.(IT.GT.9)) GO TO 980
            IPOWER = 10 * IPOWER + IT
 600        CONTINUE
C                                       Calculate number.
      IF (.NOT.FRCFLG) NFRAC = IFRAC
      VALUE = SIGN * VALUE * 10.0D0 ** (IESIGN * IPOWER - NFRAC)
      GO TO 999
C                                       Error In format.
 980  IERR = 1
      WRITE (MSGTXT,1980) LINE(ISTART:IEND)
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('COULD NOT DECODE ',A)
      END

      SUBROUTINE PPSEL (DISKI, CNOI, DISKO, CNOO, VER, CATIN, CATOUT,
     *   LUNI, LUNO, BIF, EIF, BCHAN, ECHAN, TB, TE, IFQID, ISUB, JSUB,
     *   BUFFER, OBUFF, IRET)
C-----------------------------------------------------------------------
C! Copies and renumbers the IFs and spectral channels in a PP table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2023-2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Copies and renumbers the IFs and channels in an PP table; can also
C   modify the FQ ID.
C   Inputs:
C      DISKI    I        Input volume number
C      CNOI     I        Input catalog number
C      DISKO    I        Output volume number
C      CNOO     I        Output catalog number
C      VER      I        Version to check/modify
C      CATIN    I(256)   Input catalog header
C      CATOUT   I(256)   Output catalog header
C      LUNI     I        LUN to use
C      LUNO     I        LUN to use
C      BIF      I        Start IF number
C      EIF      I        End IF number
C      BCHAN    I        First channel
C      ECHAN    I        Last channel
C      TB       D        Beginning time in days
C      TE       D        Ending time in days
C      IFQID    I        FQ ID to select (output FQID will be 1)
C                           if <= 0 then output FQ ID unchanged.
C      ISUB     I        Selected subarray (= 0 any)
C      JSUB     I        Output subarray number (< 0 => NO CHANGE)
C   Input/Output:
C      BUFFER   I(512)   Work buffer
C      OBUFF    I(512)   Work buffer
C   Output:
C      IRET            I       Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER   DISKI, CNOI, DISKO, CNOO, VER, CATIN(256), CATOUT(256),
     *   LUNI, LUNO, BIF, EIF, BCHAN, ECHAN, IFQID, ISUB, JSUB,
     *   BUFFER(*), OBUFF(*), IRET
      DOUBLE PRECISION TB, TE
C
      INTEGER   MAXPPC
      PARAMETER (MAXPPC = 5)
C
      INCLUDE 'INCS:PUVD.INC'
      DOUBLE PRECISION PHASES(MAXCIF), ERRORS(MAXCIF)
      REAL      TIME
      INTEGER   IPPRNO, PPKOLS(MAXPPC), PPNUMV(MAXPPC), OKOLS(MAXPPC),
     *   ONUMV(MAXPPC), NPPROW, OPPRNO, SUBA, FREQID, IFA, IFB, CHA,
     *   CHB, NEWIF, NEWFRQ, JIF, JCHAN, INX, LNX, I, J, K, FOPEN,
     *   NUMFRQ, NUMIF, OVER, PPOL
      LOGICAL   REFMT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      FOPEN = 1
C                                       Open PP file
      CALL PPINI ('READ', BUFFER, DISKI, CNOI, VER, CATIN, LUNI, IPPRNO,
     *   PPKOLS, PPNUMV, NUMIF, NUMFRQ, JIF, JCHAN, PPOL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN INPUT TABLE'
         GO TO 990
         END IF
      FOPEN = 1
C                                       freq. [IFREQA,IFREQB]
      REFMT = .FALSE.
C                                       New PP table will cover
C                                       IF range [IFA,IFB].
      IFA = MAX (BIF, 1)
      IFA = MAX (IFA, JIF)
      IFB = MIN (NUMIF+JIF-1, EIF)
      NEWIF = IFB - IFA + 1
      IF (NEWIF.LE.0) THEN
         NEWIF = NUMIF
         IFA = JIF
         IFB = IFA + NUMIF - 1
         END IF
      CHA = MAX (1, BCHAN)
      CHA = MAX (CHA, JCHAN)
      CHB = MIN (NUMFRQ+JCHAN-1, ECHAN)
      NEWFRQ = CHB - CHA + 1
C                                       # rows in old table
      NPPROW = BUFFER(5)
C                                       Open up new PP table
      OVER = VER
      CALL PPINI ('WRIT', OBUFF, DISKO, CNOO, OVER, CATOUT, LUNO,
     *   OPPRNO, OKOLS, ONUMV, NEWIF, NEWFRQ, IFA-BIF+1,
     *   CHA-BCHAN+1, PPOL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OUTPUT TABLE'
         GO TO 990
         END IF
      FOPEN = 2
C                                       Loop and copy
      DO 300 I = 1,NPPROW
         CALL TABPP ('READ', BUFFER, IPPRNO, PPKOLS, PPNUMV, TIME,
     *      SUBA, FREQID, PHASES, ERRORS, IRET)
C                                       Check return code
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ INPUT TABLE'
            GO TO 990
            END IF
C                                       Is this FQ ID selected ?
         IF ((IFQID.GT.0) .AND. (FREQID.GT.0) .AND. (IFQID.NE.FREQID))
     *      IRET = -10
         IF ((SUBA.GT.0) .AND. (ISUB.GT.0) .AND. (ISUB.NE.SUBA))
     *      IRET = -10
         IF ((I.GT.1) .AND. ((TIME.LT.TB) .OR. (TIME.GT.TE))) IRET = -10
C
         IF ((IRET.LT.-3) .OR. (NEWFRQ.LE.0)) THEN
            REFMT = .TRUE.
C                                       Copy this record
         ELSE
            DO 30 J = IFA,IFB
               INX = (J - IFA) * NEWFRQ
               LNX = (J - JIF) * NUMFRQ + (CHA - JCHAN)
               IF (INX.NE.LNX) REFMT = .TRUE.
C                                       Renumber IFs/FREQ's
               DO 20 K = 1,NEWFRQ
                  INX = INX + 1
                  LNX = LNX + 1
                  PHASES(INX) = PHASES(LNX)
                  ERRORS(INX) = ERRORS(LNX)
 20               CONTINUE
 30            CONTINUE
C                                       Set output FQ ID
            IF (IFQID.GT.0) FREQID = 1
            IF (JSUB.GE.0) SUBA = JSUB
C                                       Write output record.
            CALL TABPP ('WRIT', OBUFF, OPPRNO, OKOLS, ONUMV,
     *         TIME, SUBA, FREQID, PHASES, ERRORS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TABLE'
               GO TO 990
               END IF
            END IF
 300     CONTINUE
C                                       Close both tables
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         IF (REFMT) THEN
            WRITE (MSGTXT,1300) 'Reformatted PP', DISKI, CNOI, VER,
     *         DISKO, CNOO, OVER
         ELSE
            WRITE (MSGTXT,1300) 'Copied PP', DISKI, CNOI, VER, DISKO,
     *         CNOO, OVER
            END IF
         CALL MSGWRT (3)
         END IF
      IRET = MAX (0, IRET)
      GO TO 995
C                                       Error
 990  CALL MSGWRT (6)
C                                       close
 995  IF (FOPEN.GT.0) CALL TABIO ('CLOS', 0, IPPRNO, BUFFER, BUFFER, I)
      IF (FOPEN.EQ.2) CALL TABIO ('CLOS', 0, OPPRNO, OBUFF, OBUFF, J)
      IF (IRET.EQ.0) IRET = MAX (I, J)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PPSEL: ERROR ',I3,1X,A)
 1300 FORMAT (A,' file from vol/cno/vers',I3,I5,I4,' to',I3,I5,I4)
      END

      SUBROUTINE ZDEAX2 (FCB, IOP, OP, BUFF, NBYTE, PA, PB, WAIT, IERR)
C-----------------------------------------------------------------------
C! do actual read/write from/to DeAnza device
C# Z2 TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Queue an I/O operation to the DeAnza TV device, and wait for
C   completion if requested.
C   Inputs:
C       IOP     I       Operation code number from list
C       OP      C*4     Operation code (duplicates IOP info)
C       NBYTE   I       Number of bytes to be transferred
C       PA      I       1st extra parameter
C       PB      I       2nd extra parameter
C       WAIT    L       If .TRUE. wait for completion before return
C   In/out:
C       FCB     I(*)    File control block for IO
C       BUFF    I(*)    User i/o buffer
C   Outputs:
C       IERR    I
C   VAX version
C   Calls to ZDEAXF map one to one to calls to IP8 routines in the
C   DeAnza IP8500 level 0 software package.  I replaced them here for
C   the following reasons:
C   1)  I don't like EXTERNALs scattered all over the code, so
C     now they are all concentrated here in 1 subroutine.
C   2)  If you want to do any asynchronous calls, the event
C     flag numbers, IOSBs and other such structures are
C     now contained in the standard AIPS FTAB structure, instead
C     of being buried in IP8500 code.  Thus calls to
C     ZWAIT (TVLUN, IERR) etc. will do the right thing.  I do
C     not use this in the current implimentation.
C   This effort may have been misguided, but now its done.  If you
C   want to go back to IP8 calls, it won't be much work.
C                               W. Jaffe     Nov-1983
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   FCB(*), IOP, BUFF(*), NBYTE, PA, PB, IERR
      LOGICAL   WAIT
C
      EXTERNAL  DAT, DET, LR, RR, WI, RI, LCR, RCR, BMC, LMC, LPR, RPR,
     *   LVR, RVR, LWA, RWA, LPA, RPA, WR, BPA
      INTEGER   QUERR, SYS$QIO, SYS$QIOW, FUNC, LOCPA, LOCPB, JERR
      INTEGER*2 IOSB(4)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                               Find OPCODE
      IF (IOP.EQ.1) THEN
         FUNC = %LOC(DAT)
      ELSE IF (IOP.EQ.2) THEN
         FUNC = %LOC(DET)
      ELSE IF (IOP.EQ.3) THEN
         FUNC = %LOC(LR)
      ELSE IF (IOP.EQ.4) THEN
         FUNC = %LOC(RR)
      ELSE IF (IOP.EQ.5) THEN
         FUNC = %LOC(WI)
      ELSE IF (IOP.EQ.6) THEN
         FUNC = %LOC(RI)
      ELSE IF (IOP.EQ.7) THEN
         FUNC = %LOC(LCR)
      ELSE IF (IOP.EQ.8) THEN
         FUNC = %LOC(RCR)
      ELSE IF (IOP.EQ.9) THEN
         FUNC = %LOC(BMC)
      ELSE IF (IOP.EQ.10) THEN
         FUNC = %LOC(LMC)
      ELSE IF (IOP.EQ.11) THEN
         FUNC = %LOC(LPR)
      ELSE IF (IOP.EQ.12) THEN
         FUNC = %LOC(RPR)
      ELSE IF (IOP.EQ.13) THEN
         FUNC = %LOC(LVR)
      ELSE IF (IOP.EQ.14) THEN
         FUNC = %LOC(RVR)
      ELSE IF (IOP.EQ.15) THEN
         FUNC = %LOC(LWA)
      ELSE IF (IOP.EQ.16) THEN
         FUNC = %LOC(RWA)
      ELSE IF (IOP.EQ.17) THEN
         FUNC = %LOC(LPA)
      ELSE IF (IOP.EQ.18) THEN
         FUNC = %LOC(RPA)
      ELSE IF (IOP.EQ.19) THEN
         FUNC = %LOC(WR)
      ELSE IF (IOP.EQ.20) THEN
         FUNC = %LOC(BPA)
      ELSE
         IERR = 2
         GO TO 999
      END IF
C                                       Default parameters
      LOCPA = PA
      LOCPB = PB
C                                       Set up IO call
      FCB(1+FCBERR) = 0
      FCB(1+FCBXFR) = 0
      IF (WAIT) THEN
         QUERR = SYS$QIOW (%VAL(FCB(1+FCBSP1)), %VAL(FCB(1+FCBFD)),
     *      %VAL(FUNC), IOSB, , , BUFF, %VAL(NBYTE), %VAL(LOCPA),
     *      %VAL(LOCPB), , )
         FCB(1+FCBXFR) = IOSB(2)
         IF (QUERR.NE.1) THEN
            IERR = 3
            FCB(1+FCBERR) = QUERR
         ELSE
            JERR = IOSB(1)
            IF (JERR.NE.1) THEN
               FCB(1+FCBERR) = JERR
               IERR = 3
               END IF
            END IF
      ELSE
         QUERR = SYS$QIO (%VAL(FCB(1+FCBSP1)), %VAL(FCB(1+FCBFD)),
     *      %VAL(FUNC), FCB(1+FCBSP2), , , BUFF, %VAL(NBYTE),
     *      %VAL(LOCPA), %VAL(LOCPB), , )
         IF (QUERR.NE.1) THEN
            IERR = 3
            FCB(1+FCBERR) = QUERR
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE GTICNT (ILABEL, PIXR, NCH)
C-----------------------------------------------------------------------
C! Counts numbert of characters needed in wedge tick labels
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2002, 2014, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Counts characters for vertical step wedge labeling
C   Inputs:
C      ILABEL   I      Label type -2 -> 2 => NCH = 0
C      PIXR     R(2)   Intensity range in wedge
C   Output:
C      NCH      I      Number characters needed
C-----------------------------------------------------------------------
      INTEGER   ILABEL, NCH
      REAL      PIXR(2)
C
      INTEGER   I, IX, IXL, ITRY, ILMAX, FRMT, IFRMT, LTYPE
      DOUBLE PRECISION PMIN, PMAX, DEG, DEGC, XINTER(24), DEGU, DEGL
      LOGICAL   NONUM
      CHARACTER PREFIX*5, SPRTXT*20
      REAL      PR
      INCLUDE 'INCS:DMSG.INC'
      DATA XINTER /0.001D0,0.002D0,0.005D0,0.01D0,0.02D0,0.05D0,0.1D0,
     *   0.2D0,0.5D0,1.D0,2.D0,5.D0,10.D0,20.D0,50.D0,100.D0,200.D0,
     *   500.D0,1000.D0,2000.D0,5000.D0,10000.D0,20000.D0,50000.D0/
C-----------------------------------------------------------------------
C                                       Corners give which axis has it
      NCH = 0
      LTYPE = MOD (ABS(ILABEL), 100)
      IF (LTYPE.LE.2) GO TO 999
C                                       get intensity range
      PMAX = PIXR(2)
      PMIN = PIXR(1)
      PR = PIXR(2) - PIXR(1)
      CALL METSCL (ILABEL, PR, PREFIX, NONUM)
      IF (NONUM) GO TO 999
      PMIN = PMIN * PR / (PIXR(2) - PIXR(1))
      PMAX = PMAX * PR / (PIXR(2) - PIXR(1))
      IX = 8
      IXL = 2
 10   DO 20 ITRY = 1,24
         DEG = XINTER(ITRY)
         DEGC = INT (PMAX / DEG) * DEG
         IF (DEGC.GT.PMAX) DEGC = DEGC - DEG
         DEGL = INT (PMIN / DEG) * DEG
         IF (DEGL.LT.PMIN) DEGL = DEGL + DEG
         I = (DEGC - DEGL) / DEG + 1
         IF ((I.GT.IXL) .AND. (I.LE.IX)) GO TO 30
 20      CONTINUE
      IF (IXL.EQ.0) THEN
         GO TO 999
      ELSE
         IXL = 0
         IX = IX + 3
         GO TO 10
         END IF
C                                       plot range
 30   DEGC = INT (PMAX / DEG) * DEG
      IF (DEGC.GT.PMAX) DEGC = DEGC - DEG
      DEGU = DEGC
      DEGC = INT (PMIN / DEG) * DEG
      IF (DEGC.LT.PMIN) DEGC = DEGC + DEG
      DEGL = DEGC
      DEGC = DEGL - DEG
      IXL = (DEGU - DEGL) / DEG + 1.001
C                                       max length of label
      IF (ITRY.GT.9) THEN
         PR = DEGU
         IFRMT = FRMT (13, 3, PR, SPRTXT)
      ELSE IF (ITRY.GE.7) THEN
         WRITE (SPRTXT,1032) DEGU
      ELSE IF (ITRY.GE.4) THEN
         WRITE (SPRTXT,1031) DEGU
      ELSE
          WRITE (SPRTXT,1030) DEGU
          END IF
      CALL CHTRIM (SPRTXT, 13, SPRTXT, NCH)
      IF (ITRY.GT.9) THEN
         PR = DEGL
         IFRMT = FRMT (13, 3, PR, SPRTXT)
      ELSE IF (ITRY.GE.7) THEN
         WRITE (SPRTXT,1032) DEGL
      ELSE IF (ITRY.GE.4) THEN
         WRITE (SPRTXT,1031) DEGL
      ELSE
          WRITE (SPRTXT,1030) DEGL
          END IF
      CALL CHTRIM (SPRTXT, 13, SPRTXT, ILMAX)
      NCH = MAX (NCH, ILMAX)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (F12.3)
 1031 FORMAT (F12.2)
 1032 FORMAT (F12.1)
      END

      SUBROUTINE YCHRW (CHAN, X, Y, INTENS, STRING, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! writes characters into image and graphics planes
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1996, 2020
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   writes characters into image planes of the TV.  The format is 5 x 7
C   or a multiple thereof with one or more blanks all around.  The net
C   is set to match CSIZTV if possible.  We recommend CSIZTV = 7, 9 for
C   TVs of size around 512 square and CSIZTV = 14, 22 or so for TVs of
C   size around 1024 square.  This version will work on all TVs which
C   allow horizontal writing to the right.  It is a Y routine to allow
C   for hardware character generators on the TV.
C   Inputs:
C      CHAN    I       channel select  (1 to NGRAY + NGRAPH)
C      X       I       X position lower left corner first char.
C      Y       I       Y position lower left corner first char.
C      INTENS  I       write at this intensity
C      STRING  C*(*)   character string - length passed from Fortran
C   Output:
C      SCRTCH  I(>)    scratch buffer (dim = 14*count+8 < MAXXTV(1))
C      IERR    I       error code of Z...XF:0 - ok
C                                           2 - input error
C   XAS version - let XAS do it. must put intens into scrtch
C-----------------------------------------------------------------------
      CHARACTER STRING*(*)
      INTEGER   CHAN, X, Y, INTENS, SCRTCH(*), IERR
C
      INTEGER   COUNT, LX, LY, OPCODE, DAT(4), NWSD
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                        check input
      IERR = 2
      COUNT = LEN (STRING)
      LX = X + COUNT*CSIZTV(1) - 1
      LY = Y + CSIZTV(2) - 1
      IF ((Y.LT.1) .OR. (LY.GT.MAXXTV(2))) GO TO 990
      IF ((X.LT.1) .OR. (LX.GT.MAXXTV(1))) GO TO 990
      IF (COUNT.LE.0) GO TO 990
C                                       do it
      OPCODE = 26
      DAT(1) = X
      DAT(2) = Y
      DAT(3) = CHAN
      DAT(4) = COUNT
      SCRTCH(1) = INTENS
      CALL ZCLC8 (COUNT, STRING, 1, SCRTCH(2))
      CALL ZSSSXF (OPCODE, DAT, COUNT+4, SCRTCH, NWSD, IERR)
      GO TO 999
C
 990  WRITE (MSGTXT,1990) X, LX, Y, LY, COUNT
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('YCHRW: USING CHAR SIZE',2I3,' NOT INPUT SIZE',2I3)
 1990 FORMAT ('YCHRW: BAD X,LX, Y,LY, COUNT =',5I7)
      END

LOCAL INCLUDE 'POINT.INC'
C
C     Information about source pointings
C
C     MAXPNT   Maximum number of source pointings
C     NPOINT   Actual number of source pointings
C     STIME    Start time for each pointing (days)
C     ETIME    End time for each pointing (days)
C     RAS      Right ascensions of pointings (radians)
C     DECS     Declinations of pointings (radians)
C
      INTEGER   MAXPNT, NPOINT
      PARAMETER (MAXPNT = 1000)
C
      DOUBLE PRECISION STIME(MAXPNT), ETIME(MAXPNT), RAS(MAXPNT),
     *                 DECS(MAXPNT)
C
      COMMON /POINT/ STIME, ETIME, RAS, DECS, NPOINT
      SAVE /POINT/
C
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(14)
      LOGICAL   LDUM(14)
      REAL      RDUM(14)
      DOUBLE PRECISION DDUM(7)
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
      COMMON /OBTABG/ DDUM
LOCAL END
      PROGRAM OBTAB
C-----------------------------------------------------------------------
C! Update information for orbiting antennae.
C# Task Table
C-----------------------------------------------------------------------
C;  Copyright (C) 1998, 2009, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C
C     Local variables
C
C     INPUTS      Name of INPUTS object
C     ANTAB       Name of antenna TABLE object
C     ORBTAB      Name of orbit TABLE object
C
C     OANTS       IDs of antennae to be updated
C     OCOUNT      Number of antennae to be updated
C     SUBARR      Subarray to be updated
C
C     SEMIMA      Semimajor axis of orbit/m
C     ECCEN       Eccentricity of orbit
C     INCLIN      Inclination of orbit/degrees
C     RAANOD      Right ascension of ascending node/degrees
C     APERIG      Argument of perigee/degrees
C     MANMLY      Mean anomaly at 0.0 days/degrees
C
C     IRET        Task completion status (0 - ends successfully;
C                                         other - fails)
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER INPUTS*6, ANTAB*5, ORBTAB*5
      INTEGER   OANTS(MAXANT), OCOUNT, SUBARR
      DOUBLE PRECISION SEMIMA, ECCEN, INCLIN, RAANOD, APERIG, MANMLY
      INTEGER   IRET
      INTEGER   BUFFER(256)
C
      PARAMETER (INPUTS = 'INPUTS')
      PARAMETER (ANTAB  = 'ANTAB')
      PARAMETER (ORBTAB = 'ORBTAB')
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PEARTH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C
C     Initialize task:
C
      CALL OBTINI (INPUTS, ANTAB, ORBTAB, OANTS, OCOUNT, SUBARR, SEMIMA,
     *             ECCEN, INCLIN, RAANOD, APERIG, MANMLY, IRET)
      IF (IRET.EQ.0) THEN
C
C        The following conditions should hold:
C        INPUTS is initialized
C        SUBARR > 0
C        ANTAB is initialized
C        ANTAB.VERS = SUBARR
C        ORBTAB is initialized if SEMIMA < ERAD
C        0 < OCOUNT <= MAXANT
C        for all i, 1 <= i <= OCOUNT, OANTS(i) > 0
C
         IF (SEMIMA.LT.ERAD) THEN
C
C           Scan and update OB table:
C
            CALL UPDOTB (ORBTAB, OANTS, OCOUNT, SUBARR, IRET)
            IF (IRET.EQ.0) THEN
C
C              Extract orbital elements calculated from OB table:
C
               CALL OELEM (ORBTAB, SEMIMA, ECCEN, INCLIN, RAANOD,
     *                     APERIG, MANMLY, IRET)
               IF (IRET.NE.0) THEN
                  MSGTXT = 'COULD NOT DERIVE ORBITAL ELEMENTS'
                  CALL MSGWRT (9)
                  END IF
            ELSE
               MSGTXT = 'FAILED TO UPDATE ORBIT TABLE'
               CALL MSGWRT (9)
               END IF
            END IF
C
C        IRET = 0 implies that the orbital elements have their
C        correct values.
C
         IF (IRET.EQ.0) THEN
            CALL UPDATB (ANTAB, OANTS, OCOUNT, SEMIMA, ECCEN, INCLIN,
     *                   RAANOD, APERIG, MANMLY, IRET)
            IF (IRET.EQ.0) THEN
               CALL OBHIST (INPUTS, ANTAB, ORBTAB, IRET)
               IF (IRET.NE.0) THEN
                  MSGTXT = 'FAILED TO UPDATE HISTORY FILE'
                  CALL MSGWRT (9)
                  END IF
            ELSE
               MSGTXT = 'FAILED TO UPDATE ANTENNA TABLE'
               CALL MSGWRT (9)
               END IF
            END IF
         END IF
C
      CALL DIE (IRET, BUFFER)
      END
      SUBROUTINE OBTINI (INPUTS, ANTAB, ORBTAB, OANTS, OCOUNT, SUBARR,
     *                   SEMIMA, ECCEN, INCLIN, RAANOD, APERIG, MANMLY,
     *                   IRET)
C-----------------------------------------------------------------------
C   Read the task adverbs and detach from POPS.
C
C   Inputs:
C      INPUTS     C*(*)          Name of INPUTS object for task adverbs
C      ANTAB      C*(*)          Name of TABLE object for antenna table
C      ORBTAB      C*(*)          Name of TABLE object for orbit table
C
C   Outputs:
C      OANTS      I(*)           List of antennae to modify
C      OCOUNT     I              Number of antennae to modify
C      SUBARR     I              Subarray to modify
C      SEMIMA     D              Semimajor axis of orbit/m if specified
C                                 explicitly
C      ECCEN      D              Eccentricity of orbit if specified
C                                 explicitly
C      INCLIN     D              Inclination of orbit/degree if
C                                 specified explicitly
C      RAANOD     D              Right ascension of ascending node/deg
C                                 if specified explicitly
C      APERIG     D              Argument of perigee/degree if specified
C                                 explicitly
C      MANMLY     D              Mean anomaly at 0.00 days/degrees if
C                                 specified explicitly
C      IRET       I              Status: 0 - task initialized
C                                        1 - can not open OB table
C                                        2 - no antennae to update
C                                        3 - can not open AN table
C                                        4 - can not initialize task
C                                      999 - logic error
C
C   Postconditions:
C      IRET = 0 implies
C         (INPUTS is initialized) and (SUBARR > 0) and
C         (ANTAB is initialized) and (ANTAB.VER = SUBARR) and
C         (ANTAB is closed) and
C         (SEMIMA < ERAD implies (ORBTAB is initialized) and
C                                   (ORBTAB is closed)) and
C         (1 <= OCOUNT <= length(OANTS)) and
C         (for all i, 1 <= i <= OCOUNT, OANTS(i) > 0)
C-----------------------------------------------------------------------
      CHARACTER INPUTS*(*), ANTAB*(*), ORBTAB*(*)
      INTEGER   OANTS(*), OCOUNT, SUBARR
      DOUBLE PRECISION SEMIMA, ECCEN, INCLIN, RAANOD, APERIG, MANMLY
      INTEGER   IRET
C
C     Local variables:
C
C     TASKNM       Task name
C     NPARMS       Number of adverb parameters
C     AVNAME       Adverb names
C     AVTYPE       Adverb type codes
C     AVDIM        Adverb array dimensions
C
C     ANTENS       Value of ANTENNAS adverb array
C     APARM        Value of APARM adverb array
C
      CHARACTER TASKNM*6
      PARAMETER (TASKNM = 'OBTAB ')
      INTEGER   NPARMS
      PARAMETER (NPARMS = 8)
      CHARACTER AVNAME(NPARMS)*8
      INTEGER   AVTYPE(NPARMS), AVDIM(2, NPARMS)
C
      INTEGER   ANTENS(50)
      REAL      APARM(10)
C
      INTEGER   I, TYPE, DIM(3)
      CHARACTER CDUMMY
C
      INCLUDE 'INCS:PEARTH.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
C
      DATA AVNAME /'INNAME  ', 'INCLASS ', 'INSEQ   ', 'INDISK  ',
     *             'INVERS  ', 'SUBARRAY', 'ANTENNAS', 'APARM   '/
      DATA AVTYPE /OOACAR,     OOACAR,     OOAINT,     OOAINT,
     *             OOAINT,     OOAINT,     OOAINT,     OOARE/
      DATA AVDIM  /12, 1,      6, 1,        1, 1,       1, 1,
     *              1, 1,      1, 1,       50, 1,      10, 1/
C-----------------------------------------------------------------------
      CALL AV2INP (TASKNM, NPARMS, AVNAME, AVTYPE, AVDIM, INPUTS, IRET)
      IF (IRET.EQ.0) THEN
C
C     Initialize antenna table:
C
         CALL INIATB (ANTAB, INPUTS, IRET)
         IF (IRET.EQ.0) THEN
C
C           Read the subarray number:
C
            CALL TABGET (ANTAB, 'VER', TYPE, DIM, IDUM, CDUMMY, IRET)
            SUBARR = IDUM(1)
            CALL CHECK ('OBTINI', 1,
     *                  ((IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *                   .AND. (DIM(1).EQ.1) .AND. (DIM(2).EQ.1)
     *                   .AND. (SUBARR.GT.0)), IRET)
            IF (IRET.NE.0) GO TO 999
C
C           Read the antenna specifications:
C
            CALL INGET (INPUTS, 'ANTENNAS', TYPE, DIM, ANTENS, CDUMMY,
     *         IRET)
            CALL CHECK ('OBTINI', 2,
     *                  ((IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *                   .AND. (DIM(1).LE.50) .AND. (DIM(2).EQ.1)),
     *                  IRET)
            IF (IRET.NE.0) GO TO 999
            OCOUNT = 0
C           Inv: OCOUNT >= 0 and OANTS(1:OCOUNT) > 0
            DO 10 I = 1, 50
               IF (ANTENS(I).GT.0) THEN
                  OCOUNT = OCOUNT + 1
                  OANTS(OCOUNT) = ANTENS(I)
                  END IF
   10          CONTINUE
C
C           Look-up orbiting antennae in the AN table if the user
C           has not indicated which antennae are to be updated:
C
            IF (OCOUNT.EQ.0) THEN
               CALL ORBANS (ANTAB, OANTS, OCOUNT, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT, 9004) IRET
                  IRET = 3
                  OCOUNT = 0
                  END IF
               END IF
C
            IF (OCOUNT.GT.0) THEN
C
C              Get user-supplied orbital elements:
C
               CALL INGET (INPUTS, 'APARM', TYPE, DIM, IDUM, CDUMMY,
     *            IRET)
               CALL CHECK ('OBTINI', 3,
     *                     ((IRET.EQ.0) .AND. (TYPE.EQ.OOARE)
     *                      .AND. (DIM(1).EQ.10)
     *                      .AND. (DIM(2).EQ.1)), IRET)
               IF (IRET.NE.0) GO TO 999
               CALL RCOPY (DIM(1), RDUM,APARM)
               SEMIMA = APARM(1)
               ECCEN  = APARM(2)
               INCLIN = APARM(3)
               RAANOD = APARM(4)
               APERIG = APARM(5)
               MANMLY = APARM(6)
               IF (SEMIMA.LT.ERAD) THEN
                  CALL INIOTB (ORBTAB, INPUTS, SUBARR, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT, 9001) IRET
                     CALL MSGWRT (9)
                     IRET = 1
                     END IF
                  END IF
            ELSE
               MSGTXT = 'NO ANTENNAE TO CORRECT --- NOTHING TO DO'
               CALL MSGWRT (9)
               IRET = 2
               END IF
         ELSE
            WRITE (MSGTXT, 9002) IRET
            CALL MSGWRT (9)
            IRET = 3
            END IF
      ELSE
         WRITE (MSGTXT, 9003) IRET
         CALL MSGWRT (9)
         IRET = 4
         END IF
C
  999    CONTINUE
C-----------------------------------------------------------------------
 9001 FORMAT ('OBTINI: FAILED TO INITIALIZE OB TABLE (ERROR ', I4, ')')
 9002 FORMAT ('OBTINI: FAILED TO INITIALIZE AN TABLE (ERROR ', I4, ')')
 9003 FORMAT ('OBTINI: FAILED TO INITIALIZE TASK (ERROR ', I4, ')')
 9004 FORMAT ('OBTINI: FAILED TO READ ANTENNA TABLE (ERROR ', I4, ')')
      END
      SUBROUTINE OBHIST (INPUTS, ANTAB, ORBTAB, IRET)
C-----------------------------------------------------------------------
C   Update history file.
C
C   Inputs:
C      INPUTS      C*(*)      Name of INPUTS object holding adverbs
C      ANTAB       C*(*)      Name of TABLE object used for antenna
C                              table.  If the table has been modified
C                              then there should be an integer keyword,
C                              NUPDATED, giving the number of entries
C                              changed and an integer array keyword
C                              UPDATED, listing the station numbers of
C                              the modified antennae in its first
C                              NUPDATED elements.
C      ORBTAB      C*(*)      Name of TABLE object used for the orbit
C                              table.  If the table has been modified
C                              then there should be an integer keyword
C                              NUPDATED giving the number of records
C                              updated.
C
C   Output:
C      IRET        I          Status: 0 - history updated
C                                     1 - error writing history
C                                   999 - logic error
C-----------------------------------------------------------------------
      CHARACTER INPUTS*(*), ANTAB*(*), ORBTAB*(*)
      INTEGER   IRET
C
C     Local variables:
C
C     AUPDTD    List of updated antennae
C     NUPDAT    Number of AN or OB table records updated
C     ENTRY     History file record buffer
C
C     NPARMS    Number of adverb values to record in history
C     AVNAME    Names of adverbs to be recorded
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   AUPDTD(MAXANT), NUPDAT
      CHARACTER ENTRY*72
      INTEGER   NPARMS
      PARAMETER (NPARMS = 8)
      CHARACTER AVNAME(NPARMS)*8
C
      INTEGER   I, TYPE, DIM(3), MSGSAV
      CHARACTER CDUMMY
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
C
      DATA AVNAME /'INNAME  ', 'INCLASS ', 'INSEQ   ', 'INDISK  ',
     *             'INVERS  ', 'SUBARRAY', 'ANTENNAS', 'APARM   '/
C-----------------------------------------------------------------------
      CALL OHTIME (ANTAB, IRET)
      IF (IRET.EQ.0) THEN
C
C        Copy adverb values:
C
         CALL OHLIST (INPUTS, AVNAME, NPARMS, ANTAB, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT, 9000) IRET
            CALL MSGWRT (9)
            IRET = 1
            END IF
      ELSE
         WRITE (MSGTXT, 9000) IRET
         CALL MSGWRT (9)
         IRET = 1
         END IF
C
C     Add extra details if the information is available (suppress error
C     messages since errors are not critical here):
C
      IF (IRET.EQ.0) THEN
         MSGSAV = MSGSUP
         MSGSUP = 32000
         CALL OGET (ORBTAB, 'NUPDATED', TYPE, DIM, IDUM, CDUMMY, IRET)
         NUPDAT = IDUM(1)
         MSGSUP = MSGSAV
         IF (IRET.EQ.0) THEN
            CALL CHECK ('OBHIST', 1,
     *                  ((TYPE.EQ.OOAINT) .AND. (DIM(1).EQ.1)
     *                   .AND. (DIM(2).EQ.1)), IRET)
            IF (IRET.NE.0) GO TO 999
            WRITE (ENTRY, 1000) NUPDAT
            CALL OHWRIT (ENTRY, ORBTAB, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT, 9000) IRET
               CALL MSGWRT (9)
               IRET = 1
               END IF
         ELSE
            IRET = 0
            END IF
         END IF
      IF (IRET.EQ.0) THEN
         MSGSAV = MSGSUP
         MSGSUP = 32000
         CALL OGET (ANTAB, 'NUPDATED', TYPE, DIM, IDUM, CDUMMY, IRET)
         NUPDAT = IDUM(1)
         MSGSUP = MSGSAV
         IF (IRET.EQ.0) THEN
            CALL CHECK ('OBHIST', 2,
     *                  ((TYPE.EQ.OOAINT) .AND. (DIM(1).EQ.1)
     *                   .OR. (DIM(2).NE.1)), IRET)
            IF (IRET.NE.0) GO TO 999
            MSGSAV = MSGSUP
            MSGSUP = 32000
            CALL OGET (ANTAB, 'UPDATED', TYPE, DIM, AUPDTD, CDUMMY,
     *                  IRET)
            MSGSUP = MSGSAV
            CALL CHECK ('OBHIST', 3,
     *                  ((IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *                   .AND. (DIM(1).LE.MAXANT)
     *                   .AND. (DIM(2).EQ.1)), IRET)
            IF (IRET.NE.0) GO TO 999
            DO 10 I = 1, NUPDAT
               IF (IRET.EQ.0) THEN
                  WRITE (ENTRY, 1001) AUPDTD(I)
                  CALL OHWRIT (ENTRY, ANTAB, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT, 9000) IRET
                     CALL MSGWRT (9)
                     IRET = 1
                     END IF
                  END IF
   10          CONTINUE
         ELSE
            IRET = 0
            END IF
         END IF
C
  999    CONTINUE
C-----------------------------------------------------------------------
 1000 FORMAT ('/ Updated ', I6, ' OB table records.')
 1001 FORMAT ('/ Added orbital elements for antenna ', I3)
 9000 FORMAT ('OBHIST: ERROR ', I4, ' UPDATING HISTORY FILE')
      END
      SUBROUTINE INIATB (ANTAB, INPUTS, IRET)
C-----------------------------------------------------------------------
C   Initialize antenna table ANTAB using adverb values from INPUTS.
C   Reformat the table to hold the six orbital elements if necessary,
C   and leave the table closed.
C
C   Inputs:
C      ANTAB    C*(*)      The name of the TABLE object used to access
C                           the antenna table.
C      INPUTS   C*(*)      The name of the INPUTS object used to access
C                           the input adverbs
C
C   Output:
C      IRET     I          Status: 0 - table initialized
C                                  1 - failed to reformat table
C                                  2 - failed to open table
C                                  3 - failed to create table object
C
C   Preconditions:
C      INPUTS.INNAME is defined
C      INPUTS.INCLASS is defined
C      INPUTS.INSEQ is defined
C      INPUTS.INDISK is defined
C      INPUTS.SUBARR is defined
C
C   Postconditions:
C      IRET = 0 implies that
C         (ANTAB is initialized) and (ANTAB refers to an existing table)
C         and (ANTAB has room for orbital elements)
C         and (ANTAB is not open)
C-----------------------------------------------------------------------
      CHARACTER ANTAB*(*), INPUTS*(*)
      INTEGER   IRET
C
      INCLUDE 'INCS:PUVD.INC'
C
C     Local variables:
C
C     NKEY       Number of adverbs to copy to ANTAB
C     INKEY      Adverbs to copy to ANTAB
C     OUTKEY     ANKEY attributes to receive adverb values
C
C     COLDIM     Antenna table column dimensions
C
C     KEYWRD     Keywords to read from ANTAB
C     KEYVAL     Keyword value array
C     KEYLOC     Keyword value pointers
C     KEYTYP     Keyword value type codes
C
      INTEGER   NKEY
      PARAMETER (NKEY = 5)
      CHARACTER INKEY(NKEY)*8, OUTKEY(NKEY)*8, KEYWRD(1)*8
      INTEGER   COLDIM(MAXANC), KEYVAL(1), KEYLOC(1), KEYTYP(1)
C
      INTEGER   TYPE, DIM(3)
      CHARACTER CDUMMY
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
C
      DATA INKEY  /'INNAME  ', 'INCLASS ', 'INSEQ   ', 'INDISK  ',
     *             'SUBARRAY'/
      DATA OUTKEY /'NAME    ', 'CLASS   ', 'IMSEQ   ', 'DISK    ',
     *             'VER     '/
      DATA KEYWRD /'NUMORB  '/
C-----------------------------------------------------------------------
      CALL TABCRE (ANTAB, IRET)
      IF (IRET.EQ.0) THEN
         CALL IN2OBJ (INPUTS, NKEY, INKEY, OUTKEY, ANTAB, IRET)
         CALL CHECK ('INIATB', 1, (IRET.EQ.0), IRET)
         IF (IRET.NE.0) GO TO 999
         TYPE = OOACAR
         DIM(1) = 2
         DIM(2) = 1
         DIM(3) = 0
         CALL TABPUT (ANTAB, 'TBLTYPE ', TYPE, DIM, IDUM, 'AN', IRET)
         CALL CHECK ('INIATB', 2, (IRET.EQ.0), IRET)
         IF (IRET.NE.0) GO TO 999
         CALL TABOPN (ANTAB, 'READ', IRET)
         IF (IRET.EQ.0) THEN
C
C        Make sure that the table has the correct column dimension for
C        the ORBPRM column:
C
            CALL TABGET (ANTAB, 'COLDIM', TYPE, DIM, COLDIM, CDUMMY,
     *         IRET)
            CALL CHECK ('INIATB', 3,
     *                  ((IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *                   .AND. (DIM(1).LE.MAXANC)
     *                   .AND. (DIM(2).EQ.1)), IRET)
            IF (IRET.NE.0) GO TO 999
            CALL TABCLO (ANTAB, IRET)
            CALL CHECK ('INIATB', 4, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
            IF (COLDIM(3).NE.6) THEN
C
C              Reformat table:
C
               CALL REFATB (ANTAB, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT, 9000) IRET
                  CALL MSGWRT (9)
                  IRET = 1
                  END IF
            ELSE
C
C              Make sure number of orbital elements is correct:
C
               CALL TABOPN (ANTAB, 'WRIT', IRET)
               IF (IRET.EQ.0) THEN
                  CALL TABKGT (ANTAB, KEYWRD, 1, KEYLOC, KEYVAL, KEYTYP,
     *                         IRET)
                  CALL CHECK ('INIATB', 5, ((IRET.EQ.0)
     *                        .AND. (KEYTYP(1).EQ.OOAINT)), IRET)
                  IF (IRET.NE.0) GO TO 999
                  IF (KEYVAL(KEYLOC(1)).NE.6) THEN
                     KEYVAL(KEYLOC(1)) = 6
                     CALL TABKPT (ANTAB, KEYWRD, 1, KEYLOC, KEYVAL,
     *                  KEYTYP,IRET)
                     CALL CHECK ('INIATB', 6, (IRET.EQ.0), IRET)
                     IF (IRET.NE.0) GO TO 999
                     END IF
                  CALL TABCLO (ANTAB, IRET)
                  CALL CHECK ('INIATB', 7, (IRET.EQ.0), IRET)
                  IF (IRET.NE.0) GO TO 999
               ELSE
                  WRITE (MSGTXT, 9001) IRET
                  CALL MSGWRT (9)
                  IRET = 2
                  END IF
               END IF
         ELSE
            WRITE (MSGTXT, 9001) IRET
            CALL MSGWRT (9)
            IRET = 2
            END IF
      ELSE
         WRITE (MSGTXT, 9002) IRET
         CALL MSGWRT (9)
         IRET = 3
         END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 9000 FORMAT ('INIATB: FAILED TO REFORMAT ANTENNA TABLE (ERROR ', I3,
     *   ')')
 9001 FORMAT ('INIATB: FAILED TO OPEN ANTENNA TABLE (ERROR ', I3, ')')
 9002 FORMAT ('INIATB: FAILED TO CREATE TABLE OBJECT (ERROR ', I3, ')')
      END
      SUBROUTINE UPDATB (ANTAB, OANTS, OCOUNT, SEMIMA, ECCEN, INCLIN,
     *                   RAANOD, APERIG, MANMLY, IRET)
C-----------------------------------------------------------------------
C   Update the orbital elements for the antennae listed in the first
C   OCOUNT elements of ANTAB and ensure that their mount type is
C   "orbiting".  Insert the number of records updated as ANTAB.NUPDATED
C   (integer attribute) and the numbers of the antennae updated as
C   ANTAB.UPDATED (integer array attribute).
C
C   Inputs:
C      ANTAB     C*(*)     The name of the TABLE object used to access
C                           the antenna table
C      OANTS     I(*)      A list of antenna numbers
C      OCOUNT    I         The number of entries in OANTS
C      SEMIMA    D         Semimajor axis of orbit/m
C      ECCEN     D         Eccentricity of orbit
C      INCLIN    D         Inclination of orbit/degrees
C      RAANOD    D         Right ascension of ascending node/degrees
C      APERIG    D         Argument of perigee/degrees
C      MANMLY    D         Mean anomaly at 0.00 days/degrees
C
C   Output:
C      IRET      I         Status: 0 - table updated
C                                  1 - can not open table
C                                999 - logic error
C
C   Preconditions:
C      ANTAB is initialized
C      ANTAB refers to an existing AN table with room for 6 orbital
C        elements
C      ANTAB is closed
C
C   Postconditions:
C      IRET = 0 implies that
C         ((ANTAB has been updated) and (ANTAB is closed)
C          and (0 <= ANTAB.NUPDATED <= MAXANT)
C          and (for all i, 1 <= i <= ANTAB.NUPDATED,
C              1 <= ANTAB.UPDATED(i) <= MAXANT))
C-----------------------------------------------------------------------
      CHARACTER ANTAB*(*)
      INTEGER   OANTS(*), OCOUNT, IRET
      DOUBLE PRECISION SEMIMA, ECCEN, INCLIN, RAANOD, APERIG, MANMLY
C
      INCLUDE 'INCS:PUVD.INC'
C
C     Local variables
C
C     NUMROW       Number of rows in table
C     ANROW        Current row
C     UPDATD       List of antennae updated
C     NUPDAT       Number of antennae updated
C     MATCH        Does the current row match an antenna to be updated?
C
      INTEGER   NUMROW, ANROW, UPDATD(MAXANT), NUPDAT
      LOGICAL   MATCH
C
      INTEGER   TYPE, DIM(3), I, J, IERR
      CHARACTER CDUMMY
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL TABOPN (ANTAB, 'WRIT', IRET)
      IF (IRET.EQ.0) THEN
         CALL TABGET (ANTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IRET)
         NUMROW = IDUM(1)
         CALL CHECK ('UPDATB', 1, ((IRET.EQ.0)
     *               .AND. (TYPE.EQ.OOAINT) .AND. (DIM(1).EQ.1)
     *               .AND. (DIM(2).EQ.1)), IRET)
         IF (IRET.NE.0) GO TO 999
C
C        Close the table and reopen for reading/writing using AN table
C        specific routines (no failures are expected since the table
C        has already been opened successfully):
C
         CALL TABCLO (ANTAB, IRET)
         CALL CHECK ('UPDATB', 2, (IRET.EQ.0), IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OANINI (ANTAB, 'WRIT', ANROW, ARRAYC, GSTIA0, DEGPDY,
     *      SAFREQ, RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME,
     *      XYZHAN, TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IRET)
         CALL CHECK ('UPDATB', 3, (IRET.EQ.0), IRET)
C
C        Test every unflagged record in the antenna table against the
C        list of antennae to be modified and updated the records which
C        match, recording the updated antennae in UPDATD(1:NUPDAT):
C
         NUPDAT = 0
C
C        Invariant: records 1 to I have been updated and
C                   UPDATD(1:NUPDAT) is the set of updated antennae
C
         DO 20 I = 1, NUMROW
            ANROW = I
            CALL OTABAN (ANTAB, 'READ', ANROW, ANNAME, STAXYZ, ORBPRM,
     *         NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN, POLTYA, POLAA,
     *         POLCA, POLTYB, POLAB, POLCB, IERR)
            CALL CHECK ('UPDATB', 4,
     *                  ((IERR.EQ.0) .OR. (IERR.EQ.-1)), IRET)
            IF (IRET.NE.0) GO TO 999
            IF (IERR.EQ.0) THEN
               MATCH = .FALSE.
C
C              Invariant: MATCH = NOSTA in OANTS(1:J)
C
               DO 10 J = 1, OCOUNT
                  IF (OANTS(J).EQ.NOSTA) THEN
                     MATCH = .TRUE.
                     END IF
   10             CONTINUE
C
C              MATCH = NOSTA in OANTS(1:OCOUNT)
C
               IF (MATCH) THEN
                  ANROW = I
                  MNTSTA = 2
                  ORBPRM(1) = SEMIMA
                  ORBPRM(2) = ECCEN
                  ORBPRM(3) = INCLIN
                  ORBPRM(4) = RAANOD
                  ORBPRM(5) = APERIG
                  ORBPRM(6) = MANMLY
                  CALL OTABAN (ANTAB, 'WRIT', ANROW, ANNAME, STAXYZ,
     *               ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *               POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
                  CALL CHECK ('UPDATB', 5, (IRET.EQ.0), IRET)
                  IF (IRET.NE.0) GO TO 999
                  NUPDAT = NUPDAT + 1
                  CALL CHECK ('UPDATB', 6, (NUPDAT.LE.MAXANT), IRET)
                  IF (IRET.NE.0) GO TO 999
                  UPDATD(NUPDAT) = NOSTA
                  END IF
               END IF
   20       CONTINUE
         CALL TABCLO (ANTAB, IRET)
         CALL CHECK ('UPDATB', 7, (IRET.EQ.0), IRET)
         IF (IRET.NE.0) GO TO 999
         WRITE (MSGTXT, 1020) NUPDAT
         CALL MSGWRT (4)
         TYPE = OOAINT
         DIM(1) = 1
         DIM(2) = 1
         DIM(3) = 0
         IDUM(1) = NUPDAT
         CALL TABPUT (ANTAB, 'NUPDATED', TYPE, DIM, IDUM, CDUMMY,
     *                IRET)
         CALL CHECK ('UPDATB', 8, (IRET.EQ.0), IRET)
         IF (IRET.NE.0) GO TO 999
         DIM(1) = MAX (1, NUPDAT)
         CALL TABPUT (ANTAB, 'UPDATED', TYPE, DIM, UPDATD, CDUMMY,
     *      IRET)
         CALL CHECK ('UPDATB', 9, (IRET.EQ.0), IRET)
         IF (IRET.NE.0) GO TO 999
      ELSE
         WRITE (MSGTXT, 9000) IRET
         CALL MSGWRT (9)
         IRET = 1
         END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('Updated ', I3, ' antenna table records.')
 9000 FORMAT ('UPDATB: FAILED TO OPEN AN TABLE (ERROR ', I3, ')')
      END
      SUBROUTINE ORBANS (ANTAB, OANTS, OCOUNT, IRET)
C-----------------------------------------------------------------------
C   List the orbiting antennae found in ANTAB in the first OCOUNT
C   elements of OANTS.  Identify the orbiting antennae using their
C   mount type code.
C
C   Input:
C      ANTAB     C*(*)         The TABLE object used to access the AN
C                               table.
C
C   Outputs:
C      OANTS     I*(MAXANT)    A list of orbiting antennae
C      OCOUNT    I             The number of antennae in OANTS
C      IRET      I             Status: 0 - table searched
C                                      1 - failed to open table
C                                    999 - logic error
C
C   Preconditions:
C      ANTAB is initialized
C      ANTAB is closed
C
C   Postconditions:
C      IRET = 0 implies that
C         ((ANTAB is closed) and (0 <= OCOUNT <= MAXANT)
C         and (for all i, 1 <= i <= MAXANT, 1 <= OANTS(i) <= MAXANT))
C-----------------------------------------------------------------------
      CHARACTER ANTAB*(*)
      INTEGER   OANTS(*), OCOUNT, IRET
C
C     Local variables:
C
C     NUMROW       Number of rows in antenna table
C     ANROW        Current row in antenna table
C
      INTEGER   NUMROW, ANROW
C
      INTEGER   TYPE, DIM(3), I, IERR
      CHARACTER CDUMMY
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL TABOPN (ANTAB, 'READ', IRET)
      IF (IRET.EQ.0) THEN
         CALL TABGET (ANTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IRET)
         NUMROW = IDUM(1)
         CALL CHECK ('ORBANS', 1, ((IRET.EQ.0)
     *               .AND. (TYPE.EQ.OOAINT) .AND. (DIM(1).EQ.1)
     *               .AND. (DIM(2).EQ.1)), IRET)
         IF (IRET.NE.0) GO TO 999
C
C        Close the table and reopen for reading using AN table
C        specific routines (no failures are expected since the table
C        has already been opened successfully):
C
         CALL TABCLO (ANTAB, IRET)
         CALL CHECK ('ORBANS', 2, (IRET.EQ.0), IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OANINI (ANTAB, 'READ', ANROW, ARRAYC, GSTIA0, DEGPDY,
     *      SAFREQ, RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME,
     *      XYZHAN, TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IRET)
         CALL CHECK ('ORBANS', 3, (IRET.EQ.0), IRET)
C
         OCOUNT = 0
C
C        Invariant: OANTS(1:OCOUNT) is a list of orbiting antennae
C                   found in rows 1 to I
C
         DO 10 I = 1, NUMROW
            ANROW = I
            CALL OTABAN (ANTAB, 'READ', ANROW, ANNAME, STAXYZ, ORBPRM,
     *         NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN, POLTYA, POLAA,
     *         POLCA, POLTYB, POLAB, POLCB, IERR)
            CALL CHECK ('ORBANS', 4,
     *                  ((IERR.EQ.0) .OR. (IERR.EQ.-1)), IRET)
            IF (IRET.NE.0) GO TO 999
            IF (IERR.EQ.0) THEN
               IF (MNTSTA.EQ.2) THEN
                  OCOUNT = OCOUNT + 1
                  CALL CHECK ('ORBANS', 5, (OCOUNT.LE.MAXANT), IRET)
                  IF (IRET.NE.0) GO TO 999
                  OANTS(OCOUNT) = NOSTA
                  END IF
               END IF
   10       CONTINUE
         CALL TABCLO (ANTAB, IRET)
         CALL CHECK ('ORBANS', 6, (IRET.EQ.0), IRET)
         IF (IRET.NE.0) GO TO 999
      ELSE
         WRITE (MSGTXT, 9000) IRET
         CALL MSGWRT (9)
         IRET = 1
         END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 9000 FORMAT ('ORBANS: FAILED TO OPEN ANTENNA TABLE (ERROR ', I3, ')')
      END
      SUBROUTINE REFATB (ANTAB, IRET)
C-----------------------------------------------------------------------
C   Reformat ANTAB to hold 6 orbital parameters.
C
C   Inputs:
C      ANTAB   C*(*)     The name of the TABLE object used to access
C                         the antenna table.
C
C   Outputs:
C      IRET    I         Status: 0 - table reformatted
C                                1 - failed to delete scratch table
C                                2 - failed to restore AN table
C                                3 - failed to remove AN table
C                                4 - failed to create scratch table
C                                5 - failed to create TABLE object
C                                6 - failed to open AN table
C                              999 - logic error
C
C   Preconditions:
C      (ANTAB is defined) and (ANTAB exists)
C
C   Postconditions:
C      IRET = 0 implies that
C         (ANTAB.COLDIM(3) = 6) and (NUMORB keyword is set to 6)
C-----------------------------------------------------------------------
      CHARACTER ANTAB*(*)
      INTEGER   IRET
C
C     Local variables
C
C     ANTEMP      Temporary TABLE object
C     NUMROW      Number of rows in AN table
C     ANROW       Current row number
C     INVER       Input table version number
C     OUTVER      Output table version number
C
      CHARACTER ANTEMP*18
      PARAMETER (ANTEMP = 'temporary AN table')
      INTEGER   NUMROW, ANROW, INVER, OUTVER
C
      INTEGER   TYPE, DIM(3), I, J, IERR
      CHARACTER CDUMMY
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C
C     Create a temporary copy of ANTAB with the correct number of
C     orbital parameters, copy unflagged records to the temporary table,
C     delete the original, copy the temporary table to the original
C     table's location, and delete the temporary:
C
      CALL TABOPN (ANTAB, 'READ', IRET)
      IF (IRET.EQ.0) THEN
         CALL TABGET (ANTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IRET)
         NUMROW = IDUM(1)
         CALL CHECK ('REFATB', 1, ((IRET.EQ.0)
     *               .AND. (TYPE.EQ.OOAINT) .AND. (DIM(1).EQ.1)
     *               .AND. (DIM(2).EQ.1)), IRET)
         IF (IRET.NE.0) GO TO 999
         CALL TABGET (ANTAB, 'VER', TYPE, DIM, IDUM, CDUMMY, IRET)
         INVER = IDUM(1)
         CALL CHECK ('REFATB', 2, ((IRET.EQ.0)
     *               .AND. (TYPE.EQ.OOAINT) .AND. (DIM(1).EQ.1)
     *               .AND. (DIM(2).EQ.1)), IRET)
         IF (IRET.NE.0) GO TO 999
         CALL TABCLO (ANTAB, IRET)
         CALL CHECK ('REFATB', 3, (IRET.EQ.0), IRET)
         IF (IRET.NE.0) GO TO 999
C
         WRITE (MSGTXT, 1000) INVER
         CALL MSGWRT (5)
C
         CALL TABCRE (ANTEMP, IRET)
         IF (IRET.EQ.0) THEN
            CALL TBCOPY (ANTAB, ANTEMP, IRET)
            CALL CHECK ('REFATB', 4, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
            TYPE = OOAINT
            DIM(1) = 1
            DIM(2) = 1
            DIM(3) = 0
            IDUM(1) = 0
            CALL TABPUT (ANTEMP, 'VER', TYPE, DIM, IDUM, CDUMMY, IRET)
            CALL CHECK ('REFATB', 5, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OANINI (ANTAB, 'READ', ANROW, ARRAYC, GSTIA0, DEGPDY,
     *         SAFREQ, RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME,
     *         XYZHAN, TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IRET)
            CALL CHECK ('REFATB', 6, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OANINI (ANTEMP, 'WRIT', ANROW, ARRAYC, GSTIA0, DEGPDY,
     *         SAFREQ, RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME,
     *         XYZHAN, TFRAME, 6, NOPCAL, ANTNIF, ANFQID, IRET)
            IF (IRET.EQ.0) THEN
               CALL TABGET (ANTEMP, 'VER', TYPE, DIM, IDUM, CDUMMY,
     *            IRET)
               OUTVER = IDUM(1)
               CALL CHECK ('REFATB', 7, ((IRET.EQ.0)
     *                     .AND. (TYPE.EQ.OOAINT)
     *                     .AND. (DIM(1).EQ.1)
     *                     .AND. (DIM(2).EQ.1)), IRET)
               IF (IRET.NE.0) GO TO 999
C
               WRITE (MSGTXT, 1001) INVER, OUTVER
               CALL MSGWRT (4)
C
               J = 0
               DO 10 I = 1, NUMROW
                  ANROW = I
                  CALL OTABAN (ANTAB, 'READ', ANROW, ANNAME, STAXYZ,
     *               ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *               POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
                  CALL CHECK ('REFATB', 8, ((IERR.EQ.0) .OR.
     *                                      (IERR.EQ.-1)), IRET)
                  IF (IRET.NE.0) GO TO 999
                  IF (IERR.EQ.0) THEN
                     J = J + 1
                     ANROW = J
                     CALL DFILL (6, DBLANK, ORBPRM)
                     CALL OTABAN (ANTEMP, 'WRIT', ANROW, ANNAME, STAXYZ,
     *                  ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *                  POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB,IRET)
                     CALL CHECK ('REFATB', 9, (IRET.EQ.0), IRET)
                     IF (IRET.NE.0) GO TO 999
                     END IF
   10             CONTINUE
               CALL TABCLO (ANTAB, IRET)
               CALL CHECK ('REFATB', 10, (IRET.EQ.0), IRET)
               IF (IRET.NE.0) GO TO 999
               CALL TABCLO (ANTEMP, IRET)
               CALL CHECK ('REFATB', 11, (IRET.EQ.0), IRET)
               IF (IRET.NE.0) GO TO 999
C
               WRITE (MSGTXT, 1010) J, OUTVER
               CALL MSGWRT (4)
C
               CALL TABRMV (ANTAB, IRET)
               IF (IRET.EQ.0) THEN
C
                  WRITE (MSGTXT, 1011) INVER
                  CALL MSGWRT (4)
C
                  CALL TBLCOP (ANTEMP, ANTAB, IRET)
                  IF (IRET.EQ.0) THEN
C
                     WRITE (MSGTXT, 1012) OUTVER, INVER
                     CALL MSGWRT (4)
C
                     CALL TABZAP (ANTEMP, IRET)
                     IF (IRET.EQ.0) THEN
                        WRITE (MSGTXT, 1013) OUTVER
                        CALL MSGWRT (4)
                        WRITE (MSGTXT, 1014) INVER
                        CALL MSGWRT (5)
                     ELSE
                        WRITE (MSGTXT, 9000) IRET
                        CALL MSGWRT (9)
                        WRITE (MSGTXT, 9001) OUTVER
                        CALL MSGWRT (6)
                        IRET = 1
                        END IF
                  ELSE
                     WRITE (MSGTXT, 9002) IRET
                     CALL MSGWRT (9)
                     WRITE (MSGTXT, 9003) OUTVER, INVER
                     CALL MSGWRT (6)
                     IRET = 2
                     END IF
               ELSE
                  WRITE (MSGTXT, 9004) IRET
                  CALL MSGWRT (9)
                  WRITE (MSGTXT, 9005) OUTVER
                  CALL MSGWRT (6)
                  WRITE (MSGTXT, 9006)
                  CALL MSGWRT (6)
                  IRET = 3
                  END IF
            ELSE
               WRITE (MSGTXT, 9007) IRET
               CALL MSGWRT (9)
               IRET = 4
               END IF
         ELSE
            WRITE (MSGTXT, 9008) IRET
            CALL MSGWRT (9)
            IRET = 5
            END IF
      ELSE
         WRITE (MSGTXT, 9009) IRET
         CALL MSGWRT (9)
         IRET = 6
         END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Reformatting AN table ', I2,
     *        ' to hold orbital elements.')
 1001 FORMAT ('Copying AN table ', I2, ' to temporary version ', I2)
 1010 FORMAT ('Copied ', I5, ' records to AN table ', I2)
 1011 FORMAT ('Removed AN table ', I2)
 1012 FORMAT ('Copied temporary AN table ', I2, ' to AN table ', I2)
 1013 FORMAT ('Removed temporary AN table ', I2)
 1014 FORMAT ('Reformatted AN table ', I2)
 9000 FORMAT ('REFATB: UNABLE TO DELETE SCRATCH TABLE (ERROR ', I3,
     *        ')')
 9001 FORMAT ('YOU MUST MANUALLY DELETE AN TABLE ', I2)
 9002 FORMAT ('REFATB: UNABLE TO COPY SCRATCH TABLE (ERROR ', I3, ')')
 9003 FORMAT ('YOU MUST MANUALLY COPY AN TABLE ', I2, ' TO ', I2,
     *        ' USING TACOP')
 9004 FORMAT ('REFATB: UNABLE TO DELETE ORIGINAL TABLE (ERROR ', I3,
     *        ')')
 9005 FORMAT ('MANUALLY DELETE SCRATCH AN TABLE ', I2,
     *        ' AND CHECK FILE')
 9006 FORMAT ('STATUS')
 9007 FORMAT ('REFATB: CAN NOT CREATE SCRATCH TABLE (ERROR ', I3, ')')
 9008 FORMAT ('REFATB: CAN NOT CREATE TABLE OBJECT (ERROR ', I3, ')')
 9009 FORMAT ('REFATB: CAN NOT OPEN AN TABLE (ERROR ', I3, ')')
      END
      SUBROUTINE INIOTB (ORBTAB, INPUTS, SUBARR, IRET)
C-----------------------------------------------------------------------
C   Initialize orbit table ORBTAB using adverb values from INPUTS.
C
C   Inputs:
C      ORBTAB  C*(*)      The name of the TABLE object used to access
C                          the OB table.
C      INPUTS  C*(*)      The name of the INPUTS object used to access
C                          the input adverbs
C      SUBARR  I          Subarray number
C
C   Output:
C      IRET    I          Status: 0 - ORBTAB is initialized
C                                 1 - could not initialize source
C                                     look-up table
C                                 2 - could not open OB table
C                                 3 - could not create OB TABLE object
C                                 4 - could not create UVDATA object
C                               999 - logic error
C
C   Preconditions:
C      INPUTS.INNAME is defined
C      INPUTS.INCLASS is defined
C      INPUTS.INSEQ is defined
C      INPUTS.INDISK is defined
C      INPUTS.INVERS is defined
C      SUBARR > 0
C
C   Postconditions:
C      IRET = 0 implies that
C         ((ORBTAB is initialized)
C          and (ORBTAB refers to an existing table)
C          and (ORBTAB is closed)
C          and (OTAB.JD0 is Julian day number at midnight on reference
C               date)
C-----------------------------------------------------------------------
      CHARACTER ORBTAB*(*), INPUTS*(*)
      INTEGER SUBARR, IRET
C
C     Local variables
C
C     NKEY      Number of adverbs to copy to TABLE object
C     INKEY     Adverbs to copy to TABLE object
C     UVKEY     UVDATA keywords to receive adverb values
C     TABKEY    TABLE keywords to receive adverb values
C     REFDAT    Reference day as character string
C     JD0       Julian day number at 0h on reference day
C
      INTEGER   NKEY
      PARAMETER (NKEY = 5)
      CHARACTER INKEY(NKEY)*8, UVKEY(NKEY-1)*16, TABKEY(NKEY)*8,
     *   REFDAT*8, UVDATA*6
      PARAMETER (UVDATA = 'UVDATA')
      DOUBLE PRECISION JD0
C
      INTEGER   TYPE, DIM(3)
      CHARACTER CDUMMY
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
C
      DATA INKEY /'INNAME  ', 'INCLASS ', 'INSEQ   ', 'INDISK  ',
     *            'INVERS  '/
      DATA UVKEY /'FILE_NAME.NAME  ', 'FILE_NAME.CLASS ',
     *            'FILE_NAME.IMSEQ ', 'FILE_NAME.DISK  '/
      DATA TABKEY /'NAME    ', 'CLASS   ', 'IMSEQ   ', 'DISK    ',
     *             'VER     '/
C-----------------------------------------------------------------------
      CALL OUVCRE (UVDATA, IRET)
      IF (IRET.EQ.0) THEN
         CALL IN2OBJ (INPUTS, NKEY - 1, INKEY, UVKEY, UVDATA, IRET)
         CALL CHECK ('INIOTB', 1, (IRET.EQ.0), IRET)
         IF (IRET.NE.0) GO TO 999
         CALL TABCRE (ORBTAB, IRET)
         IF (IRET.EQ.0) THEN
            CALL IN2OBJ (INPUTS, NKEY, INKEY, TABKEY, ORBTAB, IRET)
            CALL CHECK ('INIOTB', 2, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
            TYPE = OOACAR
            DIM(1) = 2
            DIM(2) = 1
            DIM(3) = 0
            CALL TABPUT (ORBTAB, 'TBLTYPE', TYPE, DIM, IDUM, 'OB',
     *         IRET)
            CALL CHECK ('INIOTB', 3, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
C
C           Try to open the table to make sure that it exists:
C
            CALL TABOPN (ORBTAB, 'READ', IRET)
            IF (IRET.EQ.0) THEN
               CALL TABCLO (ORBTAB, IRET)
               CALL CHECK ('INIOTB', 4, (IRET.EQ.0), IRET)
               IF (IRET.NE.0) GO TO 999
C
C              Store the Julian day number of the reference date as
C              an attribute of ORBTAB (it will be required for eclipse
C              calculations):
C
               CALL OUVATT (UVDATA, .FALSE., IRET)
               CALL CHECK ('INIOTB', 5, (IRET.EQ.0), IRET)
               IF (IRET.NE.0) GO TO 999
               CALL UVDGET (UVDATA, 'DATE-OBS', TYPE, DIM, IDUM, REFDAT,
     *            IRET)
               CALL CHECK ('INIOTB', 6, ((IRET.EQ.0)
     *                     .AND. (TYPE.EQ.OOACAR)
     *                     .AND. (DIM(1).EQ.8) .AND. (DIM(2).EQ.1)),
     *                     IRET)
               IF (IRET.NE.0) GO TO 999
               CALL JULDAY (REFDAT, JD0)
               TYPE = OOADP
               DIM(1) = 1
               DIM(2) = 1
               DIM(3) = 0
               DDUM(1) = JD0
               CALL TABPUT (ORBTAB, 'JD0', TYPE, DIM, IDUM, CDUMMY,
     *            IRET)
               CALL CHECK ('INIOTB', 7, (IRET.EQ.0), IRET)
               IF (IRET.NE.0) GO TO 999
C
C              Set up a look up table of source positions as a function
C              of time:
C
               CALL SETCRD (UVDATA, SUBARR, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT, 9000) IRET
                  CALL MSGWRT (9)
                  IRET = 1
                  END IF
            ELSE
               WRITE (MSGTXT, 9001) IRET
               CALL MSGWRT (9)
               IRET = 2
               END IF
         ELSE
            WRITE (MSGTXT, 9002) IRET
            CALL MSGWRT (9)
            IRET = 3
            END IF
C
C        Finalize the UVDATA object which is no longer needed:
C
         CALL OUVDES (UVDATA, IRET)
         CALL CHECK ('INIOTB', 8, (IRET.EQ.0), IRET)
         IF (IRET.NE.0) GO TO 999
      ELSE
         WRITE (MSGTXT, 9003) IRET
         CALL MSGWRT (9)
         IRET = 4
         END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 9000 FORMAT ('INIOTB: FAILED TO INITIALIZE SOURCE TABLE (ERROR ', I3,
     *        ')')
 9001 FORMAT ('INIOTB: FAILED TO OPEN OB TABLE (ERROR ', I3, ')')
 9002 FORMAT ('INIOTB: FAILED TO CREATE OB TABLE OBJECT (ERROR ', I3,
     *        ')')
 9003 FORMAT ('INIOTB: FAILED TO CREATE UVDATA OBJECT (ERROR ', I3,
     *        ')')
      END
      SUBROUTINE UPDOTB (ORBTAB, OANTS, OCOUNT, SUBARR, IRET)
C-----------------------------------------------------------------------
C   Fill in missing quantities in ORBTAB for records with antenna numbers
C   matching the first OCOUNT entries in OANTS and with subarray numbers
C   matching subarray (interpret zero antenna numbers and zero subarray
C   numbers as matching).  Calculate the mean orbital elements from the
C   matching records and record them as attributes of ORBTAB.  Also
C   attach the total number of records altered as an attribute of ORBTAB.
C
C   If a missing antenna number is to be inserted use the first element
C   of OANTS.
C
C   Inputs:
C      ORBTAB      C*(*)       The name of the TABLE object used to
C                              access the OB table
C      OANTS      I(*)        List of antenna numbers to update
C      OCOUNT     I           Number of entries in OANTS
C      SUBARR     I           Subarray to which antennae belong
C
C   Output:
C      IRET       I           Status: 0 - table updated
C                                     1 - no OB records selected
C                                     2 - can not open OB table
C                                   999 - logic error
C
C   Preconditions:
C      ORBTAB is initialized
C      ORBTAB refers to an existing OB table
C      ORBTAB is closed
C      1 <= OCOUNT <= MAXANT
C      for all i, 1 <= i <= OCOUNT, 1 <= OANTS(i) <= MAXANT
C      SUBARR > 0
C
C   Postconditions:
C      IRET = 0 implies that
C         ((ORBTAB has been updated) and (ORBTAB is closed)
C          and (ORBTAB.NUPDATED = number of records modified)
C          and (ORBTAB.SEMIMA = semimajor axis/m)
C          and (ORBTAB.ECCEN  = eccentricity)
C          and (ORBTAB.INCLIN = inclination/deg)
C          and (ORBTAB.RAANOD = RA of ascending node/deg)
C          and (ORBTAB.APERIG = argument of perigee/deg)
C          and (ORBTAB.MANMLY = mean anomaly at 0.0 days/deg))
C-----------------------------------------------------------------------
      CHARACTER ORBTAB*(*)
      INTEGER   OANTS(*), OCOUNT, SUBARR, IRET
C
C     Local variables:
C
C     COUNT     Number of OB table entries processed
C     SUMA      Sum of semimajor axis values (m)
C     SUMECC    Sum of eccentricity values
C     SUMINC    Sum of inclinations (radians)
C     SUMRN     Sum of RA of ascending node values (radians)
C     SUMAP     Sum of arguments of perigee (radians)
C     SUMM      Sum of mean anomalies (radians)
C
C     NUMROW    Number of rows in OB table
C     OBROW     Current row in OB table
C     MATCH     Does current row match antenna selection criteria
C     NOSTA     Station number from OB table
C     OBSUB     Subarray from OB table
C     TIME      Time of OB table entry
C     POS       Position vector from OB table
C     VEL       Velocity vector from OB table
C     SUNANG    Sun angle values from OB table
C     ECLIPS    Eclipse parameters from OB table
C     ORIENT    Orientation angle from OB table
C
C     SEMIMA    Semimajor axis derived from OB table (m)
C     ECCEN     Eccentricity derived from OB table
C     INCLIN    Inclination derived from OB table (radians)
C     RAANOD    RA of ascending node derived from OB table (radians)
C     APERIG    Argument of perigee derived from OB table (radians)
C     MANMLY    Mean anomaly derived from OB table (radians)
C
C     RANODT    RA of ascending node at reference time (radians)
C     APERIT    Argument of perigee at reference time (radians)
C     MANMLT    Mean anomaly at reference time (radians)
C
C     RA        RA of current source (radians)
C     DEC       Declination of current souce (radians)
C     SOLRA     RA of sun (radians)
C     SOLDEC    Declination of sun (radians)
C     JD0       Julian day number at reference time
C
      DOUBLE PRECISION SUMA, SUMECC, SUMINC, SUMRN, SUMAP, SUMM, TIME,
     *                 POS(3), VEL(3), SEMIMA, ECCEN, INCLIN, RAANOD,
     *                 APERIG, MANMLY, RANODT, APERIT, MANMLT, RA, DEC,
     *                 SOLRA, SOLDEC, JD0
      REAL             SUNANG(3), ECLIPS(4), ORIENT
      INTEGER          COUNT, NUMROW, NOSTA, OBSUB, OBROW
      LOGICAL          MATCH
C
      INTEGER          I, J, TYPE, DIM(3)
      CHARACTER        CDUMMY
C
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:PEARTH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL OOBINI (ORBTAB, 'WRIT', OBROW, IRET)
      IF (IRET.EQ.0) THEN
C
C        Initialize sums for averaging:
C
         COUNT  = 0
         SUMA   = 0.0D0
         SUMECC = 0.0D0
         SUMINC = 0.0D0
         SUMRN  = 0.0D0
         SUMAP  = 0.0D0
         SUMM   = 0.0D0
C
         CALL TABGET (ORBTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IRET)
         NUMROW = IDUM(1)
         CALL CHECK ('UPDOTB', 1, ((IRET.EQ.0)
     *               .AND. (TYPE.EQ.OOAINT) .AND. (DIM(1).EQ.1)
     *               .AND. (DIM(2).EQ.1)), IRET)
         IF (IRET.NE.0) GO TO 999
         CALL TABGET (ORBTAB, 'JD0', TYPE, DIM, IDUM, CDUMMY, IRET)
         JD0 = DDUM(1)
         CALL CHECK ('UPDOTB', 2, ((IRET.EQ.0)
     *               .AND. (TYPE.EQ.OOADP) .AND. (DIM(1).EQ.1)
     *               .AND. (DIM(2).EQ.1)), IRET)
         IF (IRET.NE.0) GO TO 999
C
         DO 20 I = 1, NUMROW
C
            IF (MOD(I, 500).EQ.0) THEN
               WRITE (MSGTXT, 1000) I
               CALL MSGWRT (5)
               END IF
C
            OBROW = I
            CALL OTABOB (ORBTAB, 'READ', OBROW, NOSTA, OBSUB, TIME, POS,
     *                   VEL, SUNANG, ECLIPS, ORIENT, IRET)
            CALL CHECK ('UPDOTB', 3, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
C
C           Fill in default values if the antenna number or subarray
C           field is blank:
C
            IF (NOSTA.LE.0) THEN
               NOSTA = OANTS(1)
               END IF
            IF (OBSUB.LE.0) THEN
               OBSUB = SUBARR
               END IF
C
C           Check whether the current record is wanted:
C
            MATCH = .FALSE.
            DO 10 J = 1, OCOUNT
               IF (NOSTA.EQ.OANTS(J)) THEN
                  MATCH = .TRUE.
                  END IF
   10          CONTINUE
            IF (MATCH .AND. (OBSUB.EQ.SUBARR)) THEN
C
C              Fill in the sun angle parameters if the current pointing
C              can be determined:
C
               CALL SUNPOS (JD0 + TIME, SOLRA, SOLDEC)
               CALL GETCRD (TIME, RA, DEC)
               SUNANG(2) = FBLANK
               SUNANG(3) = FBLANK
               IF ((RA.NE.DBLANK) .AND. (DEC.NE.DBLANK)) THEN
                  SUNANG(1) = RAD2DG * ACOS (COS (DEC) * COS (SOLDEC)
     *                                       * COS (SOLRA - RA)
     *                                       + SIN (DEC) * SIN (SOLDEC))
                  ORIENT = RAD2DG * ATAN2 (COS (SOLDEC)
     *                                     * SIN (SOLRA - RA),
     *                                     -COS (SOLDEC) * SIN (DEC)
     *                                     * COS (SOLRA - RA)
     *                                     + COS (DEC) * SIN (SOLDEC))
               ELSE
                  SUNANG(1) = FBLANK
                  ORIENT    = FBLANK
                  END IF
C
C              Calculate orbital elements and use them to find eclipses
C              up to one orbit before this time:
C
               CALL VEC2OE (POS, VEL, SEMIMA, ECCEN, INCLIN, RAANOD,
     *                      APERIG, MANMLY, IRET)
               CALL CHECK ('UPDOTB', 4, (IRET.EQ.0), IRET)
               IF (IRET.NE.0) GO TO 999
C                                       Debugging note: SUNECL begins
C                                       by calculating the position and
C                                       velocity from the orbital
C                                       elements --- this should
C                                       reproduce the original POS and
C                                       VEL apart from rounding errors.
C                                       This can be used to check the
C                                       orbit calculations
               CALL SUNECL (JD0 + TIME, SEMIMA, ECCEN, INCLIN,
     *                      RAANOD, APERIG, MANMLY, ECLIPS, 60.0D0)
C
C              Propagate the orbital elements to the reference time
C              and remove 2 * pi ambiguities:
C
               CALL PROPOE (-DBLE(TIME), SEMIMA, ECCEN, INCLIN,
     *                      RAANOD, APERIG, MANMLY, RANODT, APERIT,
     *                      MANMLT)
               IF (COUNT.GT.0) THEN
                  IF ((RANODT - SUMRN / COUNT).GT.PI) THEN
                     RANODT = RANODT - TWOPI
                  ELSE IF ((RANODT - SUMRN / COUNT).LT.-PI) THEN
                     RANODT = RANODT + TWOPI
                     END IF
                  IF ((APERIT - SUMAP / COUNT).GT.PI) THEN
                     APERIT = APERIT - TWOPI
                  ELSE IF ((APERIT - SUMAP / COUNT).LT.-PI) THEN
                     APERIT = APERIT + TWOPI
                     END IF
                  IF ((MANMLT - SUMM / COUNT).GT.PI) THEN
                     MANMLT = MANMLT - TWOPI
                  ELSE IF ((MANMLT - SUMM / COUNT).LT.-PI) THEN
                     MANMLT = MANMLT + TWOPI
                     END IF
                  END IF
C
C              Update accumulators:
C
               SUMA   = SUMA + SEMIMA
               SUMECC = SUMECC + ECCEN
               SUMINC = SUMINC + INCLIN
               SUMRN  = SUMRN + RANODT
               SUMAP  = SUMAP + APERIT
               SUMM   = SUMM  + MANMLT
               COUNT  = COUNT + 1
C
C              Write out updated table record:
C
               OBROW = I
               CALL OTABOB (ORBTAB, 'WRIT', OBROW, NOSTA, OBSUB, TIME,
     *                      POS, VEL, SUNANG, ECLIPS, ORIENT, IRET)
               CALL CHECK ('UPDOTB', 5, (IRET.EQ.0), IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
   20       CONTINUE
C
         CALL OTABOB (ORBTAB, 'CLOS', OBROW, NOSTA, OBSUB, TIME,
     *                POS, VEL, SUNANG, ECLIPS, ORIENT, IRET)
         CALL CHECK ('UPDOTB', 6, (IRET.EQ.0), IRET)
         IF (IRET.NE.0) GO TO 999
C
         IF (COUNT.GT.0) THEN
C
C           Calculate mean orbital elements and make sure that the
C           angles lie in their conventional ranges:
C
            SEMIMA = SUMA / COUNT
            ECCEN  = SUMECC / COUNT
            INCLIN = RAD2DG * SUMINC / COUNT
            RAANOD = RAD2DG * SUMRN / COUNT
            IF (RAANOD.LT.0.0) THEN
               RAANOD = RAANOD + 360.0D0
            ELSE IF (RAANOD.GE.360.0) THEN
               RAANOD = RAANOD - 360.0D0
               END IF
            APERIG = RAD2DG * SUMAP / COUNT
            IF (APERIG.LT.0.0) THEN
               APERIG = APERIG + 360.0D0
            ELSE IF (APERIG.GE.360.0) THEN
               APERIG = APERIG - 360.0D0
               END IF
            MANMLY = RAD2DG * SUMM / COUNT
   30       IF (MANMLY.LT.0.0) THEN
               MANMLY = MANMLY + 360.0D0
               GO TO 30
            ELSE IF (MANMLY.GE.360.0) THEN
               MANMLY = MANMLY - 360.0D0
               GO TO 30
               END IF
C
C           Record the orbital elements and the number of records
C           updated:
C
            TYPE = OOAINT
            DIM(1) = 1
            DIM(2) = 1
            DIM(3) = 0
            IDUM(1) = COUNT
            CALL TABPUT (ORBTAB, 'NUPDATED', TYPE, DIM, IDUM, CDUMMY,
     *         IRET)
            CALL CHECK ('UPDOTB', 6, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
            TYPE = OOADP
            DDUM(1) = SEMIMA
            CALL TABPUT (ORBTAB, 'SEMIMA', TYPE, DIM, IDUM, CDUMMY,
     *         IRET)
            CALL CHECK ('UPDOTB', 7, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
            DDUM(1) = ECCEN
            CALL TABPUT (ORBTAB, 'ECCEN', TYPE, DIM, IDUM, CDUMMY, IRET)
            CALL CHECK ('UPDOTB', 8, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
            DDUM(1) = INCLIN
            CALL TABPUT (ORBTAB, 'INCLIN', TYPE, DIM, IDUM, CDUMMY,
     *         IRET)
            CALL CHECK ('UPDOTB', 9, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
            DDUM(1) = RAANOD
            CALL TABPUT (ORBTAB, 'RAANOD', TYPE, DIM, IDUM, CDUMMY,
     *         IRET)
            CALL CHECK ('UPDOTB', 10, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
            DDUM(1) = APERIG
            CALL TABPUT (ORBTAB, 'APERIG', TYPE, DIM, IDUM, CDUMMY,
     *         IRET)
            CALL CHECK ('UPDOTB', 11, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
            DDUM(1) = MANMLY
            CALL TABPUT (ORBTAB, 'MANMLY', TYPE, DIM, IDUM, CDUMMY,
     *                   IRET)
            CALL CHECK ('UPDOTB', 12, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
            WRITE (MSGTXT, 1030) COUNT
            CALL MSGWRT (5)
         ELSE
            MSGTXT = 'UPDOBT: NO RECORDS SELECTED FROM OB TABLE'
            CALL MSGWRT (9)
            MSGTXT = 'UPDOTB: CHECK ANTENNAS AND SUBARRAY ADVERBS'
            CALL MSGWRT (9)
            IRET = 1
            END IF
      ELSE
         WRITE (MSGTXT, 9000) IRET
         CALL MSGWRT (9)
         IRET = 2
         END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Processing orbit record number ', I6)
 1030 FORMAT ('Updated ', I6, ' orbit table records')
 9000 FORMAT ('UPDOTB: FAILED TO OPEN OB TABLE (ERROR ', I3, ')')
      END
      SUBROUTINE OELEM (ORBTAB, SEMIMA, ECCEN, INCLIN, RAANOD, APERIG,
     *                  MANMLY, IRET)
C-----------------------------------------------------------------------
C   Recover previously calculated orbital elements from ORBTAB.
C
C   Inputs:
C      ORBTAB    C*(*)      The name of the TABLE object used to access
C                            the OB table
C
C   Outputs:
C      SEMIMA    D         Semimajor axis of orbit/m
C      ECCEN     D         Eccentricity of orbit
C      INCLIN    D         Inclination of orbit/degrees
C      RAANOD    D         Right ascension of ascending node/degrees
C      APERIG    D         Argument of perigee/degrees
C      MANMLY    D         Mean anomaly at 0.00 days/degrees
C      IRET      I         Status: 0 - elements recovered
C
C   Preconditions:
C      ORBTAB.SEMIMA holds semimajor axis in metres
C      ORBTAB.ECCEN  holds eccentricity
C      ORBTAB.INCLIN holds inclination in degrees
C      ORBTAB.RAANOD holds RA of ascending node in degrees
C      ORBTAB.APERIG holds argument of perigee in degrees
C      ORBTAB.MANMLY holds mean anomaly at 0.00 days in degrees
C-----------------------------------------------------------------------
      CHARACTER ORBTAB*(*)
      DOUBLE PRECISION SEMIMA, ECCEN, INCLIN, RAANOD, APERIG, MANMLY
      INTEGER   IRET
C
      INTEGER   TYPE, DIM(3)
      CHARACTER CDUMMY
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
C-----------------------------------------------------------------------
      CALL TABGET (ORBTAB, 'SEMIMA', TYPE, DIM, IDUM, CDUMMY, IRET)
      SEMIMA = DDUM(1)
      CALL CHECK ('OELEM', 1, ((IRET.EQ.0) .AND. (TYPE.EQ.OOADP)
     *            .AND. (DIM(1).EQ.1) .AND. (DIM(2).EQ.1)
     *            .AND. (SEMIMA.GT.0.0D0)), IRET)
      IF (IRET.NE.0) GO TO 999
      CALL TABGET (ORBTAB, 'ECCEN', TYPE, DIM, IDUM, CDUMMY, IRET)
      ECCEN = DDUM(1)
      CALL CHECK ('OELEM', 2, ((IRET.EQ.0) .AND. (TYPE.EQ.OOADP)
     *            .AND. (DIM(1).EQ.1) .AND. (DIM(2).EQ.1)
     *            .AND. (ECCEN.GT.0.0D0) .AND. (ECCEN.LT.1.0D0)),
     *             IRET)
      IF (IRET.NE.0) GO TO 999
      CALL TABGET (ORBTAB, 'INCLIN', TYPE, DIM, IDUM, CDUMMY, IRET)
      INCLIN = DDUM(1)
      CALL CHECK ('OELEM', 3, ((IRET.EQ.0) .AND. (TYPE.EQ.OOADP)
     *            .AND. (DIM(1).EQ.1) .AND. (DIM(2).EQ.1)
     *            .AND. (INCLIN.GE.-90.0D0)
     *            .AND. (INCLIN.LE.+90.0D0)),
     *             IRET)
      IF (IRET.NE.0) GO TO 999
      CALL TABGET (ORBTAB, 'RAANOD', TYPE, DIM, IDUM, CDUMMY, IRET)
      RAANOD = DDUM(1)
      CALL CHECK ('OELEM', 4, ((IRET.EQ.0) .AND. (TYPE.EQ.OOADP)
     *            .AND. (DIM(1).EQ.1) .AND. (DIM(2).EQ.1)
     *            .AND. (RAANOD.GE.0.0D0)
     *            .AND. (RAANOD.LE.360.0D0)),
     *             IRET)
      IF (IRET.NE.0) GO TO 999
      CALL TABGET (ORBTAB, 'APERIG', TYPE, DIM, IDUM, CDUMMY, IRET)
      APERIG = DDUM(1)
      CALL CHECK ('OELEM', 5, ((IRET.EQ.0) .AND. (TYPE.EQ.OOADP)
     *            .AND. (DIM(1).EQ.1) .AND. (DIM(2).EQ.1)
     *            .AND. (APERIG.GE.0.0D0)
     *            .AND. (APERIG.LE.360.0D0)),
     *             IRET)
      IF (IRET.NE.0) GO TO 999
      CALL TABGET (ORBTAB, 'MANMLY', TYPE, DIM, IDUM, CDUMMY, IRET)
      MANMLY = DDUM(1)
      CALL CHECK ('OELEM', 6, ((IRET.EQ.0) .AND. (TYPE.EQ.OOADP)
     *            .AND. (DIM(1).EQ.1) .AND. (DIM(2).EQ.1)
     *            .AND. (MANMLY.GE.0.0D0)
     *            .AND. (MANMLY.LE.360.0D0)),
     *             IRET)
      IF (IRET.NE.0) GO TO 999
C
  999 RETURN
      END
      SUBROUTINE SETCRD (UVDATA, SUBARR, IRET)
C-----------------------------------------------------------------------
C   Create and initialize a look-up table of source positions.
C
C   Inputs:
C     UVDATA     C*(*)      The name of the UVDATA object
C     SUBARR     I          The desired subarray
C
C   Outputs:
C     IRET       I          Status: 0 - look-up table initialized
C                                   1 - too many pointings
C                                   2 - can not open NX table
C                                   3 - can not open SU table
C                                 999 - logic error
C-----------------------------------------------------------------------
      CHARACTER UVDATA*(*)
      INTEGER   SUBARR, IRET
C
C     Local variables:
C
C     IDXTAB        Name of TABLE object used for index table
C     SRCTAB        Name of TABLE object used for source table
C     IDXROW        Current row in index table
C     NUMROW        Number of rows in index table
C
C     TIME         Centre time of index record
C     DTIME        Duration of index record
C     IDSOUR       Source ID number
C     VSTART       Starting visibility
C     VEND         Ending visibility
C     SUB          Subarray number for index record
C     FREQID       Frequency ID for index record
C
C     CRVAL        Coordinate reference values
C
      CHARACTER IDXTAB*6, SRCTAB*6
      PARAMETER (IDXTAB = 'IDXTAB')
      PARAMETER (SRCTAB = 'SRCTAB')
      INTEGER   IDXROW, NUMROW, IDSOUR, VSTART, VEND, SUB, FREQID
      REAL      TIME, DTIME
      DOUBLE PRECISION CRVAL(16)
C
      INTEGER   ILOCU, ILOCV, ILOCW, ILOCT, ILOCB, ILOCSU, ILOCFQ,
     *   ILOCA1, ILOCA2, ILOCSA, JLOCC, JLOCS, JLOCF, JLOCR, JLOCD,
     *   JLOCIF, INCS, INCF, INCIF
C
      INTEGER   IERR, TYPE, DIM(3), I
      CHARACTER CDUMMY
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'GFORT'
      INCLUDE 'POINT.INC'
C-----------------------------------------------------------------------
      CALL OUVATT (UVDATA, .FALSE., IRET)
      CALL CHECK ('SETCRD', 1, (IRET.EQ.0), IRET)
      IF (IRET.NE.0) GO TO 999
      CALL UVDPNT (UVDATA, ILOCU, ILOCV, ILOCW, ILOCT, ILOCB, ILOCSU,
     *   ILOCFQ, ILOCA1, ILOCA2, ILOCSA, JLOCC, JLOCS, JLOCF, JLOCR,
     *   JLOCD, JLOCIF, INCS, INCF, INCIF, IRET)
      CALL CHECK ('SETCRD', 2, (IRET.EQ.0), IRET)
      IF (IRET.NE.0) GO TO 999
C
C     Look up pointings in the index table if the input file is a
C     multisource file otherwise use header coordinates:
C
      IF (ILOCSU.GT.0) THEN
         CALL UV2TAB (UVDATA, SRCTAB, 'SU', 1, IRET)
         CALL CHECK ('SETCRD', 3, (IRET.EQ.0), IRET)
         IF (IRET.NE.0) GO TO 999
         CALL TABOPN (SRCTAB, 'READ', IRET)
         IF (IRET.EQ.0) THEN
C
C           Close the table since SOUNFO will be used to access it:
C
            CALL TABCLO (SRCTAB, IRET)
            CALL CHECK ('SETCRD', 4, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
C
            CALL UV2TAB (UVDATA, IDXTAB, 'NX', 1, IRET)
            CALL CHECK ('SETCRD', 5, (IRET.EQ.0), IRET)
            IF (IRET.NE.0) GO TO 999
            CALL ONXINI (IDXTAB, 'READ', IDXROW, IRET)
            IF (IRET.EQ.0) THEN
               CALL TABGET (IDXTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY,
     *            IRET)
               NUMROW = IDUM(1)
               CALL CHECK ('SETCRD', 6, ((IRET.EQ.0)
     *                     .AND. (TYPE.EQ.OOAINT)
     *                     .AND. (DIM(1).EQ.1) .AND. (DIM(2).EQ.1)),
     *                     IRET)
               IF (IRET.NE.0) GO TO 999
C
C           Scan the table for entries relevent to the current subarray
C           and add them to the look-up table:
C                                       [Should FREQID by checked too?]
C
               NPOINT = 0
               DO 10 I = 1, NUMROW
                  IF (IRET.EQ.0) THEN
                     IDXROW = I
                     CALL OTABNX (IDXTAB, 'READ', IDXROW, TIME, DTIME,
     *                            IDSOUR, SUB, VSTART, VEND, FREQID,
     *                            IERR)
                     CALL CHECK ('SETCRD', 7,
     *                           ((IERR.EQ.0) .OR. (IERR.EQ.-1)),
     *                           IRET)
                     IF (IRET.NE.0) GO TO 999
                     IF (IERR.EQ.0) THEN
                        IF ((SUB.EQ.SUBARR)
     *                      .AND. (NPOINT.LT.MAXPNT)) THEN
                           NPOINT = NPOINT + 1
                           STIME(NPOINT) = TIME - DTIME
                           ETIME(NPOINT) = TIME + DTIME
                           CALL SOUNFO (SRCTAB, IDSOUR, 'RAEPO', TYPE,
     *                                  DIM, RAS(NPOINT), CDUMMY, IRET)
                           CALL CHECK ('SETCRD', 8, ((IRET.EQ.0)
     *                                 .AND. (TYPE.EQ.OOADP)
     *                                 .AND. (DIM(1).EQ.1)
     *                                 .AND. (DIM(2).EQ.1)), IRET)
                           IF (IRET.NE.0) GO TO 999
                           CALL SOUNFO (SRCTAB, IDSOUR, 'DECEPO', TYPE,
     *                                  DIM, DECS(NPOINT), CDUMMY, IRET)
                           CALL CHECK ('SETCRD', 9, ((IRET.EQ.0)
     *                                 .AND. (TYPE.EQ.OOADP)
     *                                 .AND. (DIM(1).EQ.1)
     *                                 .AND. (DIM(2).EQ.1)), IRET)
                           IF (IRET.NE.0) GO TO 999
                           RAS(NPOINT)  = DG2RAD * RAS(NPOINT)
                           DECS(NPOINT) = DG2RAD * DECS(NPOINT)
                        ELSE IF ((SUB.EQ.SUBARR)
     *                           .AND. (NPOINT.EQ.MAXPNT)) THEN
                           WRITE (MSGTXT, 9000) MAXPNT
                           CALL MSGWRT (9)
                           IRET = 1
                           END IF
                        END IF
                     END IF
   10             CONTINUE
               CALL OTABNX (IDXTAB, 'CLOS', IDXROW, TIME, DTIME,
     *                      IDSOUR, SUB, VSTART, VEND, FREQID, IRET)
               CALL CHECK ('SETCRD', 10, (IRET.EQ.0), IRET)
               IF (IRET.NE.0) GO TO 999
            ELSE
               WRITE (MSGTXT, 9001) IRET
               CALL MSGWRT (9)
               IRET = 2
               END IF
         ELSE
            WRITE (MSGTXT, 9002) IRET
            CALL MSGWRT (9)
            IRET = 3
            END IF
      ELSE
         CALL UVDGET (UVDATA, 'CRVAL', TYPE, DIM, IDUM, CDUMMY, IRET)
         CALL CHECK ('SETCRD', 11, ((IRET.EQ.0)
     *               .AND. (TYPE.EQ.OOADP) .AND. (DIM(1).LE.16)
     *               .AND. (DIM(2).EQ.1)), IRET)
         IF (IRET.NE.0) GO TO 999
         CALL DPCOPY (DIM(1), DDUM, CRVAL)
         NPOINT = 1
         STIME(1) = -999.0D0
         ETIME(1) = +999.0D0
         CALL CHECK ('SETCRD', 12,
     *               ((JLOCR.GE.1) .AND. (JLOCR.LE.16)), IRET)
         IF (IRET.NE.0) GO TO 999
         CALL CHECK ('SETCRD', 13,
     *               ((JLOCD.GE.1) .AND. (JLOCD.LE.16)), IRET)
         IF (IRET.NE.0) GO TO 999
         RAS(1)   = DG2RAD * CRVAL(JLOCR)
         DECS(1)  = DG2RAD * CRVAL(JLOCD)
         END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 9000 FORMAT ('SETCRD: EXCEEDED SIZE OF LOOK-UP TABLE (', I4,
     *        ' ENTRIES)')
 9001 FORMAT ('SETCRD: FAILED TO OPEN INDEX TABLE (ERROR ', I2, ')')
 9002 FORMAT ('SETCRD: FAILED TO OPEN SOURCE TABLE (ERROR ', I2, ')')
      END
      SUBROUTINE GETCRD (TIME, RA, DEC)
C-----------------------------------------------------------------------
C   Look up source coordinates at TIME.  Set the RA and declination
C   to DBLANK if the source can not be determined.
C
C   Inputs:
C      TIME     D      Time (days)
C
C   Output:
C      RA       D      Right ascension at standard equinox (radians)
C      DEC      D      Declination at standard equinox (radians)
C-----------------------------------------------------------------------
      DOUBLE PRECISION TIME, RA, DEC
C
      INTEGER   I
C
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'POINT.INC'
C-----------------------------------------------------------------------
      RA  = DBLANK
      DEC = DBLANK
      DO 10 I = 1, NPOINT
         IF ((TIME.GE.STIME(I)) .AND. (TIME.LE.ETIME(I))) THEN
            RA  = RAS(I)
            DEC = DECS(I)
            END IF
   10    CONTINUE
      END
      SUBROUTINE SUNECL (JD, SEMIMA, ECCEN, INCLIN, RAANOD, APERIG,
     *                   MANMLY, ECLIPS, RESOLN)
C-----------------------------------------------------------------------
C   Fill in the Earth eclipse parameters for Julian day number JD.  The
C   time since last entering or last leaving the Earth's shadow should
C   be set to FBLANK if no eclipse occurred on the last orbit.
C
C   Inputs:
C      JD        D      Julian day number at which eclipse times are to
C                       be calculated
C      SEMIMA    D      Semimajor axis of orbit (m)
C      ECCEN     D      Eccentricity of orbit
C      INCLIN    D      Inclination of orbit (radians)
C      RAANOD    D      RA of ascending node at JD (radians)
C      APERIG    D      Argument of perigee at JD (radians)
C      MANMLY    D      Mean anomaly at JD (radians)
C      RESOLN    D      Resolution of eclipse times (seconds)
C
C   Outputs:
C      ECLIPS    R(4)   1: time since entering Earth's shadow (days)
C                       2: time since leaving Earth's shadow (days)
C                       3: FBLANK
C                       4: FBLANK
C-----------------------------------------------------------------------
      DOUBLE PRECISION JD, SEMIMA, ECCEN, INCLIN, RAANOD, APERIG,
     *                 MANMLY, RESOLN
      REAL             ECLIPS(4)
C
C     Local variables
C
C     PERIOD      Orbital period (days)
C     RESD        Resolution (days)
C     DT          Time shift (days)
C     SOLRA       Solar RA at DT (radians)
C     SOLDEC      Solar declination at DT (radians)
C     RANODT      RA of ascending node at DT (radians)
C     APERIT      Argument of perigee at DT (radians)
C     MANMLY      Mean anomaly at DT (radians)
C     POS         Position vector at DT (m)
C     VEL         Velocity vector at DT (m s**-1)
C     R           Length of radius vector
C     ANGLE       Angle between radious vector and sun (radians)
C     EANGLE      Half angular size of the Earth at the spacecraft (rad)
C     ISECL       Is spacecraft in eclipse at DT?
C     WASECL      Was spacecraft eclipsed at previous DT?
C
      DOUBLE PRECISION PERIOD, RESD, DT, SOLRA, SOLDEC, RANODT, APERIT,
     *                 MANMLT, POS(3), VEL(3), ANGLE, EANGLE, R
      LOGICAL          ISECL, WASECL
C
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PEARTH.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      CALL RFILL (4, FBLANK, ECLIPS)
      PERIOD = (TWOPI * SQRT (SEMIMA ** 3 / EMU)) / (24.0D0 * 3600.0D0)
      RESD   = RESOLN / (24.0D0 * 3600.0)
C
C     Iterate over the previous orbit, noting when the spacecraft
C     enters and leaves shadow.  It is assumed that all coordinates are
C     referred to FK5 but the errors are probably tolerable if other
C     reference frames are used.
C
      CALL SUNPOS (JD, SOLRA, SOLDEC)
      CALL OE2VEC (SEMIMA, ECCEN, INCLIN, RAANOD, APERIG, MANMLY, POS,
     *             VEL)
      R = SQRT (POS(1) ** 2 + POS(2) ** 2 + POS(3) ** 2)
      EANGLE = ATAN (ERAD / R)
      ANGLE  = ACOS (-(POS(1) * COS (SOLDEC) * COS (SOLRA)
     *                 + POS(2) * COS (SOLDEC) * SIN (SOLRA)
     *                 + POS(3) * SIN (SOLDEC)) / R)
      WASECL = ANGLE.LE.EANGLE
      DT = RESD
   10 IF (DT.LE.PERIOD) THEN
         CALL SUNPOS (JD - DT, SOLRA, SOLDEC)
         CALL PROPOE (-DT, SEMIMA, ECCEN, INCLIN, RAANOD, APERIG,
     *                MANMLY, RANODT, APERIT, MANMLT)
         CALL OE2VEC (SEMIMA, ECCEN, INCLIN, RANODT, APERIT, MANMLT,
     *                POS, VEL)
         R = SQRT (POS(1) ** 2 + POS(2) ** 2 + POS(3) ** 2)
         EANGLE = ATAN (ERAD / R)
         ANGLE  = ACOS (-(POS(1) * COS (SOLDEC) * COS (SOLRA)
     *                    + POS(2) * COS (SOLDEC) * SIN (SOLRA)
     *                    + POS(3) * SIN (SOLDEC)) / R)
         ISECL = ANGLE.LE.EANGLE
C                                       Note that time is running
C                                       backwards in this loop
         IF (ISECL .AND. (.NOT. WASECL)) THEN
            ECLIPS(2) = DT
         ELSE IF ((.NOT. ISECL) .AND. WASECL) THEN
            ECLIPS(1) = DT
            END IF
         WASECL = ISECL
         DT = DT + RESD
         GO TO 10
         END IF
C
      END
      SUBROUTINE SUNPOS (JD, RA, DEC)
C-----------------------------------------------------------------------
C   Calculate the position of the sun on Julian day number JD in the
C   FK5 reference frame.
C
C   This is a low accuracy routine, good to about 1 minute of arc.
C
C   Inputs:
C      JD          D             Julian day number
C
C   Outputs:
C      RA          D             RA of sun (radians)
C      DEC         D             Declination of sun (radians)
C
C   References:
C      "Astronomical Algorithms", Jean Meeus, Wilmann-Bell 1991
C      (Section 24)
C-----------------------------------------------------------------------
      DOUBLE PRECISION JD, RA, DEC
C
C     Local variables:
C
C     JD0     Julian day number of epoch J2000.0
C     JCENT   Days in Julian century
C     OB2000  Obliquity of the ecliptic at J2000.0 (radians)
C     T       Time from J2000.0 (centuries)
C     L0      Geometric mean longitude (radians)
C     M       Mean anomaly (radians)
C     ECCEN   Eccentricity of the Earth's orbit
C     C       Equation of centre (radians)
C     TLONG   True longitude (radians)
C     L2000   Longitude at J2000.0 (radians)
C
      INCLUDE 'INCS:PSTD.INC'
      DOUBLE PRECISION JD0, JCENT, OB2000
      PARAMETER (JD0 = 2451545.0D0)
      PARAMETER (JCENT = 36525.0D0)
      PARAMETER (OB2000 = DG2RAD * 23.43929111)
      DOUBLE PRECISION T, L0, M, ECCEN, C, TLONG, L2000
C-----------------------------------------------------------------------
      T = (JD - JD0) / JCENT
      L0 = DG2RAD * (((0.0003032 * T) + 36000.76983) * T + 280.46645)
      M = DG2RAD * ((((-0.00000048 * T) - 0.0001559) * T
     *               + 35999.05030) * T + 357.52910)
      ECCEN = ((-0.0000001236 * T) - 0.000042037) * T + 0.016708617
      C = DG2RAD * ((((-0.000014 * T) - 0.004817) * T + 1.914600)
     *              * SIN (M)
     *              + ((-0.000101 * T) + 0.019993) * SIN (2.0D0 * M)
     *              + 0.000290 * SIN (3.0D0 * M))
      TLONG = L0 + C
      L2000 = TLONG - DG2RAD * 1.397D0 * T
      RA = ATAN2 (COS (OB2000) * SIN (L2000), COS (L2000))
      DEC = ASIN (SIN (OB2000) * SIN (L2000))
      END

      SUBROUTINE YFIND (MAXPL, TYPE, IPL, UNIQUE, CATBLK, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! determines the unique TV image of desired type, returns catalog block
C# Y0 TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YFIND determines which of the visible TV images the user wishes
C   to select.  The TV must already be open.
C   Inputs:
C      MAXPL   I        Highest plane number allowed (i.e. do graphics
C                       count?)
C      TYPE    C*2      2-char image type to restrict search
C   Output:
C      IPL     I        Plane number found
C      UNIQUE  L        T => only one image visible now
C                           (all types except zeroed ones ('ZZ'))
C      CATBLK  I(256)   Image catalog block found
C      SCRTCH  I(256)   Scratch buffer
C      IERR    I        Error code: 0 => ok
C                          1 => no image
C                          2 => IO error in image catalog
C                          3 => TV error
C                         10 => > 1 image of requested type
C   Generic Y routine: for local host-controlled TV device
C-----------------------------------------------------------------------
      CHARACTER TYPE*2
      LOGICAL   UNIQUE
      INTEGER   SCRTCH(256), MAXPL, IPL, CATBLK(256), IERR
C
      CHARACTER CTEST*2
      INTEGER   ONPL, ZOR, ILUN, IIND, IER, IC, NLAST, I, J, K, KPL, LL,
     *   ITC, IOFF, I2TMP1, ZAND, IREC, NR, NR0
      LOGICAL   ANY, EQUAL, ISZZ
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA ILUN /20/
C-----------------------------------------------------------------------
      IERR = 1
C                                       Which planes are on ?
      UNIQUE = .TRUE.
      ONPL = 0
      DO 10 I = 1,4
         ONPL = ZOR (ONPL, TVLIMG(I))
 10      CONTINUE
      IF (ONPL.EQ.0) GO TO 999
      IERR = 0
      IOFF = KHPTY
      ANY = TYPE.EQ.'  '
      ISZZ = TYPE.EQ.'ZZ'
C                                       Look in image catalog: is it
C                                       only one image visible
      CALL ICOPEN (1, ILUN, IIND, IER)
      IF (IER.EQ.0) GO TO 15
         IERR = 2
         GO TO 999
 15   IC = 0
      ITC = 0
      LL = (NIMAGE - 1) / 51
      DO 40 I = 1,MAXPL
         I2TMP1 = 2 ** (I-1)
         IF (ZAND(ONPL, I2TMP1).EQ.0) GO TO 40
C                                       Multi image plane
         IF (I.GT.NGRAY) GO TO 30
            NR = 1 + (I-1) * (1+NIMAGE+LL)
            NR0 = NR
            CALL ZFIO ('READ', ILUN, IIND, NR, SCRTCH, IER)
            IF (IER.NE.0) GO TO 960
            NLAST = SCRTCH(1)
            IF (NLAST.LE.0) GO TO 40
            DO 20 J = 1,NIMAGE
               IF ((J.EQ.1) .OR. (MOD(J,51).NE.1)) GO TO 16
                  NR = NR + 1
                  CALL ZFIO ('READ', ILUN, IIND, NR, SCRTCH, IER)
                  IF (IER.NE.0) GO TO 960
 16            K = 5 * MOD (J-1, 51) + 2
               IF ((SCRTCH(K).LE.0) .OR. (SCRTCH(K).GT.NLAST)) GO TO 20
                  ITC = ITC + 1
                  IF (ANY) GO TO 18
                     IREC = J + NR0 + LL
                     CALL ZFIO ('READ', ILUN, IIND, IREC, CATBLK, IER)
                     IF (IER.NE.0) GO TO 960
                     CALL H2CHR (2, KHPTYO, CATBLK(IOFF), CTEST)
                     EQUAL = CTEST.EQ.'ZZ'
                     IF ((EQUAL) .AND. (.NOT.ISZZ)) ITC = ITC - 1
                     IF (TYPE.NE.CTEST) GO TO 20
 18               IF (IC.GE.1) GO TO 50
                  IC = IC + 1
                  IPL = I
                  KPL = J + NR0 + LL
 20            CONTINUE
            GO TO 40
C                                       Single image planes
 30      CONTINUE
            NR = I + NGRAY * (NIMAGE + LL)
            CALL ZFIO ('READ', ILUN, IIND, NR, SCRTCH, IER)
            IF (IER.NE.0) GO TO 960
            IF ((SCRTCH(IICOR).LE.0) .OR. (SCRTCH(IICOR+1).LE.0) .OR.
     *         (SCRTCH(IICOR+2).LE.SCRTCH(IICOR))) GO TO 40
               ITC = ITC + 1
               IF (ANY) GO TO 35
                  IREC = NR
                  CALL H2CHR (2, KHPTYO, CATBLK(IOFF), CTEST)
                  IF (TYPE.NE.CTEST) GO TO 40
 35            IF (IC.GE.1) GO TO 50
               IC = IC + 1
               IPL = I
               KPL = NR
 40      CONTINUE
C                                       No image actually on
      IF (IC.GT.0) GO TO 45
         CALL ZCLOSE (ILUN, IIND, IER)
         IERR = 1
         GO TO 999
C                                       Unique: get header
 45   IREC = KPL
      CALL ZFIO ('READ', ILUN, IIND, IREC, CATBLK, IER)
      IF (IER.NE.0) GO TO 960
      CALL ZCLOSE (ILUN, IIND, IER)
      UNIQUE = ITC.EQ.1
      GO TO 999
C                                       Not unique: ask user
 50   CALL ZCLOSE (ILUN, IIND, IER)
      UNIQUE = .FALSE.
      IERR = 10
      GO TO 999
C                                       Errors
 960  CALL ZCLOSE (ILUN, IIND, IER)
      IERR = 2
C
 999  RETURN
      END

      SUBROUTINE GETNME (DEFNAM, NCLIM, OUTNAM)
C-----------------------------------------------------------------------
C! gets the next name in the input character buffer
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   GETNME parses a name from input buffer KARBUF.
C   Inputs:
C      DEFNAM   C*(*)   default name (' ' => none)
C      NCLIM    I       max no. of characters allowed.
C   Output:
C      OUTNAM   C*(*)   output name.
C-----------------------------------------------------------------------
      CHARACTER DEFNAM*(*), OUTNAM*(*)
      INTEGER   NCLIM
C
      CHARACTER PRGNAM*6, M*1
      INTEGER   POTERR, J
      LOGICAL   WASQ, WASP
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DIO.INC'
      INCLUDE 'INCS:DSMS.INC'
      DATA PRGNAM /'GETNME'/
C-----------------------------------------------------------------------
C                                       Insert default.
      OUTNAM = DEFNAM
C                                       Parse.
      WASP = .FALSE.
      WASQ = .FALSE.
      NKAR = 0
C                                       Skip leading blanks.
 10   M = KARBUF(KBPTR:KBPTR)
         IF (M.NE.' ') GO TO 15
            KBPTR = KBPTR + 1
            IF (KBPTR.LE.KARLIM) GO TO 10
            GO TO 999
 15   IF ((.NOT.WASQ) .AND. (.NOT.WASP) .AND. (M.EQ.';')) GO TO 999
      IF (M.NE.'''') GO TO 20
         KBPTR = KBPTR + 1
         IF (WASQ) GO TO 999
         WASQ = .TRUE.
         GO TO 10
 20   IF (M.NE.'(') GO TO 25
         KBPTR = KBPTR + 1
         WASP = .TRUE.
         GO TO 10
 25   IF (M.NE.')') GO TO 30
         KBPTR = KBPTR + 1
         IF (WASP) GO TO 999
         POTERR = 9
         GO TO 980
C                                       Test for alpha characters.
 30   POTERR = 9
      IF (((M.LT.'A') .OR. (M.GT.'Z')) .AND. ((M.LT.'a') .OR.
     *   (M.GT.'z'))) GO TO 980
C                                       Find trailing blank or ;
      NKAR = 0
      J = KBPTR
 35   NKAR = NKAR + 1
         J = J + 1
         POTERR = 4
         IF (J.GT.KARLIM) GO TO 980
         M = KARBUF(J:J)
         IF ((WASQ) .AND. (M.EQ.'''')) GO TO 40
         IF ((WASP) .AND. (M.EQ.')')) GO TO 40
         IF ((WASP) .OR. (WASQ)) GO TO 35
         IF ((M.NE.' ') .AND. (M.NE.';')) GO TO 35
C
 40   POTERR = 5
      IF (NKAR.GT.NCLIM) GO TO 980
      OUTNAM = KARBUF(KBPTR:KBPTR+NKAR-1)
      KBPTR = KBPTR + NKAR
      CALL CHLTOU (NKAR, OUTNAM)
      IF ((WASQ) .AND. (M.EQ.'''')) KBPTR = KBPTR + 1
      IF ((WASP) .AND. (M.EQ.')')) KBPTR = KBPTR + 1
      IF ((WASP) .AND. (WASQ) .AND. (M.EQ.'''')) KBPTR = KBPTR + 1
      GO TO 999
C                                       Errors.
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      ERRLEV = ERRLEV+1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
      END

      LOGICAL FUNCTION SLCTD (ITEM, LIST, NITEMS, INCLD)
C-----------------------------------------------------------------------
C! Determines whether an item has been selected by the user
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   User selections (eg. antennas, sources and calibration sources) are
C   usually stored as a list of integer codes and a flag which indicates
C   whether the requested items in the list are to be included in or
C   excluded from the selection. Given a list of NITEMS requested items
C   and a flag, INCLD, which is true if the requested items are included
C   in the selection and false if the requested items are excluded from
C   the selection, return true if ITEM is a selected item or false if
C   ITEM is not selected. If NITEMS <= 0 then it is assumed that all
C   items are selected.
C   If INCLD is false, the item and the list are compared in absolute
C   value.
C   Inputs:
C     ITEM     I         Item to test.
C     LIST     I(*)      List of requested items.
C     NITEMS   I         Number of items in LIST.
C     INCLD    L         .TRUE. if the requested items are included in
C                        the selected, .FALSE. if the requested items
C                        are excluded from the selection.
C
C   Return value:
C     SLCTD    L         .TRUE. if ITEM is selected, .FALSE. if ITEM is
C                        not selected.
C-----------------------------------------------------------------------
      INTEGER   ITEM, LIST(*), NITEMS
      LOGICAL   INCLD
C
      INTEGER   I
      LOGICAL   INLIST
C-----------------------------------------------------------------------
      IF (NITEMS.LE.0) THEN
         SLCTD = .TRUE.
      ELSE
         INLIST = .FALSE.
         IF (INCLD) THEN
            DO 10 I = 1,NITEMS
               IF (ITEM.EQ.LIST(I)) INLIST = .TRUE.
 10            CONTINUE
         ELSE
            DO 20 I = 1,NITEMS
               IF (ABS(ITEM).EQ.ABS(LIST(I))) INLIST = .TRUE.
 20            CONTINUE
            END IF
C                                       INLIST is true if ITEM is one
C                                       of the first NITEMS entries in
C                                       LIST and false otherwise.
         SLCTD = INLIST.EQV.INCLD
C                                       INLIST.EQV.INCLD is equivalent
C                                       to (INLIST.AND.INCLD) .OR.
C                                       (.NOT.INLIST .AND. .NOT.INCLD).
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'XSMTH.INC'
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, OPCODE*4,
     *   HISCRD(5)*64
      HOLLERITH OLDH(256), XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2),
     *   XOPCOD(1)
      REAL      XSEQIN, XDISKI, XSEQO, XDISKO, BLC(7), TRC(7), XPOINT,
     *   DPARM(10), TAB(5000), WCUTOF, SUPRAD, BUFF1(MABFSS),
     *   BUFF2(MABFSS), OLD4(256)
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO,
     *   CATOLD(256), NUMHIS, JBUFSZ, ICODE, IXDIV, SCRTCH(256),
     *   SUPRL, SUPRH
      DOUBLE PRECISION OLD8(128)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XNAMOU, XCLAOU,
     *   XSEQO, XDISKO, BLC, TRC, XPOINT, XOPCOD, DPARM
      COMMON /PARMS/ TAB, WCUTOF, SUPRAD, SEQIN, SEQOUT, DISKIN, DISKO,
     *   NEWCNO, OLDCNO, JBUFSZ, ICODE, IXDIV, NUMHIS, SUPRL, SUPRH
      COMMON /CHPARM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, OPCODE, HISCRD
      COMMON /BUFRS/ BUFF1, BUFF2, SCRTCH
      COMMON /OLDHDR/ CATOLD
      EQUIVALENCE (CATOLD, OLD4, OLDH, OLD8)
LOCAL END
      PROGRAM XSMTH
C-----------------------------------------------------------------------
C! XSMTH smooths image x-axis by convolution or resampling.
C# Map-util Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000, 2008, 2010, 2015, 2021-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   XSMTH is an AIPS task to smooth the x axis by convolution or
C   interpolation with resampling.  It began from TAFFY by W. D.
C   Cotton, March 1983.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLAOUT        Class of the output image.
C                                   Default is input class.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      NPOINTS        XPOINT        Number of x axis points out.
C      OPCODE         OPCODE        'SMOT' => convolve (default)
C                                   'INTE' => polynomial interpolate
C      DPARM(10)      DPARM         (1) type of function
C                                   (2) diameter of func in cells
C                                   (3) support of func in cells
C   Programmer Eric W. Greisen  May 1983.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'XSMTH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DEVI.INC'
      DATA PRGM /'XSMTH '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL XSMTIN (PRGM, IRET)
C                                       Call routine that sends data
C                                       to the user routine.
      IF (IRET.EQ.0) CALL XSMTMA (IRET)
      IF (IRET.EQ.0) CALL XSMTHI
C                                       Close down files, etc.
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE XSMTIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   XSMTIN gets input parameters for XSMTH and creates an output file.
C   Inputs:  PRGN    C*6       Program name
C   Output:  IRET    I         Error code: 0 => ok
C                                4 => user routine detected error.
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER  STAT*4, PRGN*6, MTYPE*2
      INTEGER  IRET, IERR, NPARM, IROUND
      INCLUDE 'XSMTH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 40
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      SEQIN = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO = IROUND (XDISKO)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, 'READ', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Copy old CATBLK to new.
      CALL COPY (256, CATOLD, CATBLK)
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT, CLAOUT,
     *    SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATOLD(KIDIM), CATOLD(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get user modification to CATBLK
      IRET = 4
      CALL XSMHED (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create output file.
      NEWCNO = 1
      IRET = 4
      CALL MCREAT (DISKO, NEWCNO, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy most keywords
      CALL KEYPCP (DISKIN, OLDCNO, DISKO, NEWCNO, 0, ' ', IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XSMTIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1060 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE XSMTMA (IRET)
C-----------------------------------------------------------------------
C   XSMTMA sends image one row at a time to one of the smoothing
C   routineS and then writes the modified data.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER IFILE*48
      INTEGER   IRET, IROUND, LUNI, LUNO, RBP, NYI, NXI, WINI(4), NXO,
     *   NYO, WINO(4), BOI, BOO, BPI, BPO, LIM2, LIM3, LIM4, LIM5,
     *   LIM6, LIM7, I1, I2, I3, I4, I5, I6, I7, IPOS(7), CORN(7),
     *   BOTEMP, KOFF, LIMO, LIMIT, IBIND, OBIND, INDI, INDO, LIM1
      REAL      OUTMAX, OUTMIN
      LOGICAL   T, F, BLNKD
      INCLUDE 'XSMTH.INC'
      REAL      XDATA(MAXIMG)
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNI, LUNO /16,17/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open some output file
      RBP = 2
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
C                                       Use actual f.p. output
      CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Setup for I/O
      NXI = CATOLD(KINAX)
      NYI = CATOLD(KINAX+1)
      NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      BPI = 2
      BPO = 2
      OUTMAX = -1.0E20
      OUTMIN = 1.0E20
      BLNKD = F
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = MAX (1, CATBLK(KINAX+1))
      LIM3 = MAX (1, CATBLK(KINAX+2))
      LIM4 = MAX (1, CATBLK(KINAX+3))
      LIM5 = MAX (1, CATBLK(KINAX+4))
      LIM6 = MAX (1, CATBLK(KINAX+5))
      LIM7 = MAX (1, CATBLK(KINAX+6))
      KOFF = 0
      CORN(7) = 1
      LIMO = CATBLK(KINAX) - 1
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         CORN(7+KOFF) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            CORN(6+KOFF) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               CORN(5+KOFF) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  CORN(4+KOFF) = I4
                  DO 300 I3 = 1,LIM3
      IPOS(3) = BLC(3) + I3 - 0.9
      CORN(3+KOFF) = I3
C                                       Init. files, first input.
      CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IPOS(3), BOTEMP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1099) IRET
         GO TO 990
         END IF
      BOI = BOTEMP + 1
      CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFF1, JBUFSZ,
     *   BOI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) 'READ', IRET
         GO TO 990
         END IF
C                                       Init output file.
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORN(3), BOTEMP, IRET)
      BOO = BOTEMP + 1
      CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO, BUFF2, JBUFSZ,
     *   BOO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) 'WRIT', IRET
         GO TO 990
         END IF
      DO 250 I2 = 1,LIM2
         IPOS(2) = BLC(2) + I2 - 0.9
         IPOS(1) = IROUND (BLC(1))
C                                       Read.
         CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1120) 'READ', IRET
            GO TO 990
            END IF
C                                       Copy/scale to buffer.
         DO 165 I1 = 1,LIM1
            XDATA(I1) = BUFF1(IBIND+I1-1)
 165        CONTINUE
C                                       Write.
         CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IRET)
         OBIND = OBIND - 1
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1120) 'WRIT', IRET
            GO TO 990
            END IF
C                                       Call function
         OBIND = OBIND + 1
         IF (ICODE.EQ.1) CALL XSMCON (IPOS, XDATA, BUFF2(OBIND), IRET)
         IF (ICODE.EQ.2) CALL XSMINT (IPOS, XDATA, BUFF2(OBIND), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1180) IRET
            GO TO 990
            END IF
C                                       Check max, min, blanking.
         LIMIT = OBIND + LIMO
         DO 200 I1 = OBIND,LIMIT
            BLNKD = BLNKD .OR. (BUFF2(I1).EQ.FBLANK)
            IF (BUFF2(I1).EQ.FBLANK) GO TO 200
               OUTMAX = MAX (OUTMAX, BUFF2(I1))
               OUTMIN = MIN (OUTMIN, BUFF2(I1))
 200           CONTINUE
 250     CONTINUE
C                                       Dump plane to output.
C                                       Flush buffer.
      CALL MDISK ('FINI', LUNO, INDO, BUFF2, OBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1120) 'FINI', IRET
         GO TO 990
         END IF
C                                       Update CATBLK.
         CATR(KRDMX) = OUTMAX
         CATR(KRDMN) = OUTMIN
         CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRTCH,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1260) IRET
            GO TO 990
            END IF
 300     CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Mark blanking in CATBLK.
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
      CATR(KRDMN) = OUTMIN
      CATR(KRDMX) = OUTMAX
C                                       Final call to functions
      IPOS(1) = -1
      IF (ICODE.EQ.1) CALL XSMCON (IPOS, XDATA, BUFF2(OBIND), IRET)
      IF (ICODE.EQ.2) CALL XSMINT (IPOS, XDATA, BUFF2(OBIND), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1180) IRET
         GO TO 990
         END IF
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XSMTMA: ERROR',I5,' OPENING INPUT FILE')
 1010 FORMAT ('XSMTMA: ERROR',I5,' OPENING OUTPUT FILE')
 1099 FORMAT ('XSMTMA: COMOF3 ERROR',I5)
 1100 FORMAT ('XSMTMA: INIT-FOR-',A4,' ERROR',I5)
 1120 FORMAT ('XSMTMA: ',A4,' ERROR',I5)
 1180 FORMAT ('XSMTMA: SMOOTHING FUNCTION ERROR',I5)
 1260 FORMAT ('XSMTMA: CATIO ERROR',I5,' UPDATING CATBLK')
      END
      SUBROUTINE XSMTHI
C-----------------------------------------------------------------------
C   XSMTHI converts output to integer, copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER LABEL*8, LINE*80, NOTTYP*2
      INTEGER   LUN1, LUN2, IERR, I
      LOGICAL   T
      INCLUDE 'XSMTH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NOTTYP /'  '/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 20
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       BLC
      WRITE (MSGTXT,2000) TSKNAM, BLC
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       TRC
      WRITE (MSGTXT,2001) TSKNAM, TRC
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       OPCODE
      WRITE (MSGTXT,2002) TSKNAM, OPCODE
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                      Add any user supplied history.
      IF (NUMHIS.GT.0) THEN
         WRITE (LABEL,1010) TSKNAM
         LINE(1:8) = LABEL(1:8)
         DO 15 I = 1,NUMHIS
            LINE(9:72) = HISCRD(I)(1:64)
            CALL HIADD (LUN2, LINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 20
 15         CONTINUE
         END IF
C                                       Close HI file
 20   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (1, NOTTYP, LUN1, LUN2, DISKIN, DISKO, OLDCNO,
     *   NEWCNO, CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XSMTHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,'  ')
 2000 FORMAT (A6,' BLC =',6(F6.0,','),F6.0)
 2001 FORMAT (A6,' TRC =',6(F6.0,','),F6.0)
 2002 FORMAT (A6,' OPCODE = ''',A4,'''')
      END
      SUBROUTINE XSMHED (IRET)
C-----------------------------------------------------------------------
C   XSMHED modifies the output header for subimaging and change of
C   x-axis scale.  It also pre-computes parameters for convolution
C   including the gridded function values and for interpoolation
C   including the output x-coordinate positions.
C   Input:
C      CATBLK(256)    I     Output catalog header, also CATR, CATD
C      CATOLD(256)    I     Input catalog header, also OLD4, OLD8
C   Output:
C      CATBLK(256)    I     Modified output catalog header.
C      IRET           I     Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER CODES(2)*4, POSTYP(10)*4, CHTM12*12
      INTEGER   IRET, I, NCODE, TABSIZ, IT, N, IROUND
      LOGICAL   EQUAL
      REAL      WIDTHS(4), SUPS(4), XMUL, FX, W, X, Y
      INCLUDE 'XSMTH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA WIDTHS /4.0, 2.0, 2.0, 3.0/
      DATA SUPS /1.0, 3.0, 1.0, 4.0/
      DATA NCODE, CODES /2, 'SMOT','INTE'/
      DATA TABSIZ /5000/
      DATA POSTYP /'RA  ','DEC ', 'RA--','DEC-', 'LL  ','MM  ',
     *   'GLON','GLAT', 'ELON','ELAT'/
C-----------------------------------------------------------------------
      IRET = 8
C                                       Set default OPCODE
      ICODE = 1
      DO 10 I = 1,NCODE
         ICODE = I
         IF (OPCODE.EQ.CODES(I)) GO TO 20
 10      CONTINUE
C                                       Default OPCODE is first.
      OPCODE = CODES(1)
      ICODE = 1
C                                       Convolution: parms & tables
 20   IF (ICODE.EQ.1) THEN
         IF (XPOINT.LE.2.0) XPOINT = TRC(1) - BLC(1) + 1.0
         IF (XPOINT.GT.MAXIMG) XPOINT = MAXIMG
         IT = IROUND(DPARM(1)) + 1
         IF ((IT.LT.1) .OR. (IT.GT.4)) IT = 1
         DPARM(1) = IT - 1
         IF ((DPARM(2).LT.0.1) .OR. (DPARM(2).GT.(TRC(1)-BLC(1)+1.)/3.))
     *      DPARM(2) = WIDTHS(IT)
         IF ((DPARM(3).LT.DPARM(2)) .OR. (DPARM(3).GT.4.*SUPS(IT)*
     *      DPARM(2))) DPARM(3) = SUPS(IT) * DPARM(2)
         SUPRAD = DPARM(3) / 2.0
         IXDIV = (TABSIZ - 1) / (SUPRAD + 0.1)
         IF (IXDIV.GT.500) IXDIV = 500
         WCUTOF = DPARM(4)
         IF (WCUTOF.LE.0.0) WCUTOF = 0.33
         IF (WCUTOF.GE.1.0) WCUTOF = 0.95
         CALL RFILL (TABSIZ, 0.0, TAB)
         N = 1 + SUPRAD*IXDIV + 0.99
         FX = 2.0 / DPARM(2)
         Y = 1.0 / IXDIV
         TAB(1) = 1.0
         SUPRL = SUPRAD
         SUPRH = SUPRAD
C                                       Compute look-up tables
C                                       Hanning
         IF (IT.EQ.1) THEN
            DO 25 I = 2,N
               X = Y * (I - 1)
               TAB(I) = MAX (0.0, 1.0-FX*X)
 25            CONTINUE
C                                       Gaussian
         ELSE IF (IT.EQ.2) THEN
            FX = -LOG(2.0) * FX * FX
            DO 35 I = 2,N
               X = Y * (I - 1)
               TAB(I) = EXP (FX * X * X)
 35            CONTINUE
C                                       Pillbox
         ELSE IF (IT.EQ.3) THEN
            CALL RFILL (N, 1.0, TAB)
            I = DPARM(2) + 0.1
            SUPRL = (I-1) / 2
            SUPRH = I / 2
C                                       sin(x) / x
         ELSE IF (IT.EQ.4) THEN
            FX = 3.14159 * FX
            DO 55 I = 2,N
               X = Y * (I - 1) * FX
               TAB(I) = SIN(X) / X
 55            CONTINUE
            END IF
C                                       Normalize integral
         W = -TAB(1)
         DO 65 I = 1,N,IXDIV
            W = W + 2. * TAB(I)
 65         CONTINUE
         DO 70 I = 1,N
            TAB(I) = TAB(I) / W
 70         CONTINUE
C                                       Interpolation: parms
      ELSE
         IT = IROUND (DPARM(1))
         IT = MIN (3, MAX (0, IT))
         DPARM(1) = IT
         IF (XPOINT.LE.2.0) XPOINT = (TRC(1) - BLC(1)) * 2. + 1.0
         IF (XPOINT.GT.MAXIMG) XPOINT = MAXIMG
         XMUL = (TRC(1) - BLC(1)) / (XPOINT - 1.0)
         N = XPOINT + 0.01
         DO 85 I = 1,N
            TAB(I) = (I-1) * XMUL + 1.0
 85         CONTINUE
C                                       Init interp coeff.
         CALL SETCOF (IT)
         END IF
C                                       Set axes in output CATBLK.
      XMUL = (TRC(1) - BLC(1)) / (XPOINT - 1.0)
      CALL SUBHDR (BLC, TRC, XMUL, 1.0)
      IRET = 0
C                                       Remove clean beam on CONV
C                                       if x is position axis
      IF (ICODE.EQ.1) THEN
         IF (IT.EQ.3) THEN
            I = DPARM(2) + 0.1
            IF (MOD(I,2).EQ.0) CATR(KRCRP) = CATR(KRCRP) - 0.5 / I
            END IF
         IF ((CATR(KRBMJ).EQ.0.0) .AND. (CATR(KRBMN).EQ.0.0)) GO TO 999
         DO 210 I = 1,10
            CALL H2CHR (4, 1, CATH(KHCTP), CHTM12)
            EQUAL = CHTM12(1:4) .EQ. POSTYP(I)
            IF (EQUAL) THEN
               CATR(KRBMJ) = 0.0
               CATR(KRBMN) = 0.0
               CATR(KRBPA) = 0.0
               WRITE (MSGTXT,1220)
               CALL MSGWRT (3)
               GO TO 999
               END IF
 210        CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1220 FORMAT ('CLEAN beam parameters reset due to x-axis convolution')
      END
      SUBROUTINE XSMINT (IPOS, XDATA, RESULT, IRET)
C-----------------------------------------------------------------------
C   XSMINT interpolates an image row  Up to 10 history entries are
C   written on the last call to the HISCRD array in common.  If IRET
C   > 0, then the output file will be destroyed.  After all data have
C   been processed a final call will be made with IPOS(1)=-1.
C   Inputs:
C      IPOS(7)   I    BLC (input image) of first value in XDATA
C      XDATA(*)   R    Input row, magic value blanked.
C   Values from commons:
C      FBLANK    R    Value of blanked pixel.
C      DPARM(10) R    Input adverb array.
C      CATBLK    I    Output catalog header (also CATR, CATD)
C      CATOLD    I    Input catalog header (also OLD4, OLD8)
C   Output:
C      RESULT(*) R    Output row.
C      IRET      I    Return code   0 => OK
C                                  >0 => error, terminate.
C   Output in COMMON:
C      NUMHIS     I    # history entries (max. 10)
C      HISCRD(NUMHIS) C*64   History records
C      CATBLK     I    Catalog header block
C-----------------------------------------------------------------------
      CHARACTER CTYPE(4)*8
      INTEGER   IPOS(7), MO, MO2, I, K, KP, IXI, N, NP, IT, IRET
      REAL      XDATA(*), RESULT(*), SVX(14), S
      INCLUDE 'XSMTH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA CTYPE /'LINEAR', 'CUBIC', 'QUINTIC', 'SEPTIC'/
C-----------------------------------------------------------------------
      IRET = 0
C                                       Check if last call
      IF (IPOS(1).LT.0) GO TO 900
C                                       Dummy version, copy to output
      N = TRC(1) - BLC(1) + 1.01
      MO = DPARM(1) + 1.01
      MO2 = 2 * MO
      NP = CATBLK(KINAX)
      DO 20 I = 1,NP
         RESULT(I) = FBLANK
         S = 0.0
         CALL IEVERT (TAB(I), IXI, SVX)
         DO 15 K = 1,MO2
            KP = K + IXI
            IF ((KP.GE.1) .AND. (KP.LE.N)) GO TO 10
               IF ((KP.LT.1-MO) .OR. (KP.GT.N+MO)) GO TO 20
                  IF (KP.LT.1) KP = 1 - KP
                  IF (KP.GT.N) KP = 2*N - KP + 1
 10         IF (XDATA(KP).EQ.FBLANK) GO TO 20
               S = S + SVX(K) * XDATA(KP)
 15         CONTINUE
         RESULT(I) = S
 20      CONTINUE
      GO TO 999
C                                       Last call - do history etc.
 900  NUMHIS = 2
      WRITE (HISCRD(1),1901) XPOINT
      IT = DPARM(1) + 1.01
      WRITE (HISCRD(2),1902) CTYPE(IT)
C
 999  RETURN
C-----------------------------------------------------------------------
 1901 FORMAT ('XPOINTS =',F7.0,10X,'/ output x dimension')
 1902 FORMAT ('ITYPE   =''',A8,'''',7X,'/ interpolation level')
      END
      SUBROUTINE XSMCON (IPOS, XDATA, RESULT, IRET)
C-----------------------------------------------------------------------
C   XSMCON convolves an input row with a convolving look up table
C   established in common.  Up to 10 history entries are written
C   on the last call to the HISCRD array in common.  If IRET > 0,
C   then the output file will be destroyed.  After all data have
C   been processed a final call will be made with IPOS(1)=-1.
C   Inputs:
C      IPOS(7)   I    BLC (input image) of first value in XDATA
C      XDATA(*)   R    Input row, magic value blanked.
C   Values from commons:
C      FBLANK    R    Value of blanked pixel.
C      DPARM(10) R    Input adverb array.
C      CATBLK    I    Output catalog header (also CATR, CATD)
C      CATOLD    I    Input catalog header (also OLD4, OLD8)
C      TAB(5000) R    Convolution look-up table
C      WCUTOF    R    Blank if sum weights < WCUTOF
C      SUPRAD    R    Conv. function support radius (old cells)
C      IXDIV     I    # divisions / old cell in look-up table
C   Output:
C      RESULT(*) R    Output row.
C      IRET      I    Return code   0 => OK
C                                  >0 => error, terminate.
C   Output in COMMON:
C      NUMHIS     I    # history entries (max. 10)
C      HISCRD(NUMHIS) C*64   History records
C      CATBLK     I    Catalog header block
C-----------------------------------------------------------------------
      CHARACTER CTYPE(4)*8
      INTEGER   IPOS(7), LROW, I, IRET, IROW, IT, J, J1, J2, L
      REAL      XDATA(*), RESULT(*), S, W, XJ, XMUL, XDIV
      INCLUDE 'XSMTH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA CTYPE /'HANNING', 'GAUSSIAN', 'PILL BOX', 'SIN(X)/X'/
C-----------------------------------------------------------------------
      IRET = 0
C                                       Check if last call
      IF (IPOS(1).LT.0) GO TO 900
         LROW = TRC(1) - BLC(1) + 1.01
         IROW = CATBLK(KINAX)
         XMUL = (LROW-1.0) / (IROW-1.0)
         XJ = 1.0 - XMUL
         XDIV = IXDIV
         DO 30 I = 1,IROW
            XJ = XJ + XMUL
            IF (SUPRL.NE.SUPRH) THEN
               J1 = XJ - SUPRL + 0.99
               J2 = XJ + SUPRH
            ELSE
               J1 = XJ - SUPRAD + 0.9999
               J2 = XJ + SUPRAD
               END IF
            J1 = MAX (1, J1)
            J2 = MIN (LROW, J2)
            S = 0.0
            W = 0.0
            IF (J1.GT.J2) GO TO 20
               DO 10 J = J1,J2
                  IF (XDATA(J).NE.FBLANK) THEN
                     L = ABS(XJ-J)*XDIV + 1.5
                     S = XDATA(J) * TAB(L) + S
                     W = TAB(L) + W
                     END IF
 10               CONTINUE
 20         RESULT(I) = FBLANK
            IF (W.GT.WCUTOF) RESULT(I) = S / W
 30         CONTINUE
         GO TO 999
C                                       Last call - do history etc.
 900  NUMHIS = 5
      WRITE (HISCRD(1),1901) XPOINT
      IT = DPARM(1) + 1.01
      WRITE (HISCRD(2),1902) CTYPE(IT)
      WRITE (HISCRD(3),1903) DPARM(2), DPARM(3)
      WRITE (HISCRD(4),1904) IXDIV
      WRITE (HISCRD(5),1905) WCUTOF
C
 999  RETURN
C-----------------------------------------------------------------------
 1901 FORMAT ('XPOINT =',F7.0,10X,'/ output x dimension')
 1902 FORMAT ('CTYPE  =''',A8,'''',7X,'/ convolving function')
 1903 FORMAT ('CWIDTH =',F7.1,' CSUPRT =',F7.1,2X,'/ width, support',
     *   ' (old cells)')
 1904 FORMAT ('IXDIV  =',I7,10X,'/ conv function eval ixdiv times',
     *   '/cell')
 1905 FORMAT ('WCUTOFF=',1PE12.4,5X,'/ min ok sum of conv function')
      END
      SUBROUTINE IEVERT (DX, IX, SVECT)
C-----------------------------------------------------------------------
C   Compute subscript offset and weights for interpolating at a
C   specified position in a vector.  Interpolation is done using a
C   group of pixels centered on the specified position. The order of
C   interpolation is specified by integer MORD in subroutine SETCOF.
C   We do linear interpolation for MORD=0, cubic for 1, and quintic
C   for 2. If MORD=1 (i.e., cubic interpolation) we will be using
C   four pixels in the interpolation.  From the Everett interpolation
C   package originally coded by Larry Goad at KPNO.
C   Inputs:  DX     R       Position in vector
C   Outputs: IX     I       Offset to start
C            SVECT  R(*)    Weights
C-----------------------------------------------------------------------
      INTEGER   IX
      REAL      SVECT(*), DX
c
      INTEGER   NR, IR0, IV0, MC, IR
      REAL      U, W, CW, CU, W2, U2
      INCLUDE 'INCS:DEVI.INC'
C-----------------------------------------------------------------------
      IX = DX
      U  = DX - IX
      IX = IX - IS0
      CALL RFILL (NVALS, 0.0, SVECT)
C                                       distance of point from cells
      W  = 1.0 - U
      CW = W
      CU = U
      W2 = W * W
      U2 = U * U
      SVECT(IS0)   = W
      SVECT(IS0+1) = U
C                                       leave if on cell or linear
      IF ((U.EQ.0) .OR. (MORD2.EQ.0)) GO TO 999
      NR  = 1
      IR0 = 0
      IV0 = IS0 - 1
      DO 20 MC = 1,MORD2
C                                       (IR0=MC*MC):
         IR0 = IR0 + NR
C                                       (NR=2*MC+1):
         NR  = NR  + 2
C                                       (IV0=IS0-MC-1):
         IV0 = IV0 - 1
         CU  = CU * (U2 - IR0) / ((IR0 + IR0 + MC) + (IR0 + IR0 + MC))
         CW  = CW * (W2 - IR0) / ((IR0 + IR0 + MC) + (IR0 + IR0 + MC))
         DO 10 IR = 1,NR
            SVECT(IV0+IR)   = SVECT(IV0+IR)   + CW * BCOEF(IR0+IR)
            SVECT(IV0+IR+1) = SVECT(IV0+IR+1) + CU * BCOEF(IR0+IR)
 10         CONTINUE
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SETCOF (IORD)
C-----------------------------------------------------------------------
C   SETCOF computes certain quantities which are needed by IEVERT
C   when it computes the actual weights for an interpolation. The
C   result produced by SETCOF is in the BCOEF array in the COMMON
C   block, and is based on binomial coefficients computed by BINOM.
C   From the Everett interpolation package originally coded by
C   Larry Goad at KPNO.
C   Input: IORD   I     Order of interp 0 = linear, 1 cubic, 2 quintic
C-----------------------------------------------------------------------
      INTEGER   IORD, IN, NT, M, N
      REAL      XT
      INCLUDE 'INCS:DEVI.INC'
C-----------------------------------------------------------------------
      MORD2 = MIN (IORD, 6)
      IN = 1
      NT = 0
      BCOEF(1) = 1.
C                                   Compute the BCOEF array:
      DO 50 M = 1,MORD2
         IN = IN + NT + 1
         NT = M + M
         XT = NT
         CALL BINOM (XT, NT, BCOEF(IN))
C
         DO 40 N = 1,NT,2
            BCOEF(IN+N) = -BCOEF(IN+N)
 40         CONTINUE
 50      CONTINUE
C                                    Set up pointer constants:
      IS0   = MORD2 + 1
      NVALS = IS0  + IS0
C
 999  RETURN
      END
      SUBROUTINE BINOM (X, M, VAL)
C-----------------------------------------------------------------------
C   BINOM generates binomial coefficients for use in the Everett
C   interpolation routines. It is called only by SETCOF.  From the
C   Everett interpolation package originally coded by Larry Goad, KPNO.
C-----------------------------------------------------------------------
      INTEGER    M
      REAL       X, VAL(*)
c
      INTEGER    I
      REAL       R, XL
C-----------------------------------------------------------------------
      VAL(1) = 1.
      R = 0.
      XL = X + 1.
C
      DO 20 I = 1,M
         XL = XL - 1.
         R = R + 1.
         VAL(I+1) = VAL(I) * XL / R
 20      CONTINUE
C
      RETURN
      END

      SUBROUTINE LMDER (FCN, M, N, X, FVEC, FJAC, LDFJAC, FTOL, XTOL,
     *   GTOL, MAXFEV, DIAG, MODE, FACTOR, NPRINT, INFO, NFEV, NJEV,
     *   IPVT, QTF, WA1, WA2, WA3, WA4)
C-----------------------------------------------------------------------
C! minimize the sum of squares of M nonlinear functions in N variables
C# modeling math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   The purpose of LMDER is to minimize the sum of the squares of M
C   nonlinear functions in N variables by a modification of the
C   Levenberg-Marquardt algorithm. The user must provide a subroutine
C   which calculates the functions and the Jacobian.
C   Subprograms called
C      User-supplied ...... FCN
C      Minpack-supplied ... DPMPAR, ENORM, LMPAR, QRFAC
C      FORTRAN-supplied ... ABS, MAX, MIN, SQRT, MOD
C   Argonne National Laboratory. Minpack project. March 1980.
C   Burton S. Garbow, Kenneth E. Hillstrom, Jorge J. More
C   Inputs:
C      FCN     EXTERNAL The name of the user-supplied subroutine
C                   which calculates the functions and the jacobian.
C                   FCN must be declared in an external statement in
C                   the user calling program, and should be written
C                   as follows:
C *********************************************************************
C         SUBROUTINE FCN (M, N, X, FVEC, FJAC, LDFJAC, IFLAG)
C                                       Variables used as adjustable
C                                       array dimension specifiers
C                                       should be declared simply as
C                                       INTEGER
C         INTEGER M,N,LDFJAC
C         INTEGER*2 IFLAG
C         REAL*8 X(N),FVEC(M),FJAC(LDFJAC,N)
C         ----------
C         If IFLAG = 1 calculate the functions at X and
C         return this vector in FVEC. Do not alter FJAC.
C         If IFLAG = 2 calculate the Jacobian at X and
C         return this matrix in FJAC. Do not alter FVEC.
C         ----------
C         RETURN
C         END
C
C         The value of IFLAG should not be changed by FCN unless
C         the user wants to terminate execution of LMDER.
C         In this case set IFLAG to a negative INTEGER*2.
C**********************************************************************
C      M       I   The number of functions (adj. array dim.).
C      N       I   The number of variables (adj. array dim.; N
C                       must not exceed M.
C      X       D(N)   contains an initial estimate of the
C                   solution vector.
C      FTOL    D   Termination occurs when both the actual and
C                   predicted relative reductions in the sum of
C                   squares are at most FTOL. Therefore, FTOL measures
C                   the relative error desired in the sum of squares.
C      XTOL    D     Termination occurs when the relative error
C                    between two consecutive iterates is at most XTOL.
C                    therefore, XTOL measures the relative error desired
C                    in the approximate solution.
C      GTOL    D     Termination occurs when the cosine of the angle
C                    between FVEC and any column of the Jacobian is at
C                    most GTOL in absolute value. Therefore, GTOL
C                    measures the orthogonality desired between the
C                    function vector and the columns of the Jacobian.
C      MAXFEV  I     Termination occurs when the number of calls to
C                    FCN with IFLAG = 1 has reached MAXFEV.
C      DIAG    D(N)  If MODE = 1 (see below), DIAG is internally
C                    set. If MODE = 2, DIAG must contain positive
C                    entries that serve as multiplicative scale factors
C                    for the variables.
C      MODE    I     If MODE = 1, the variables will be scaled
C                    internally. If MODE = 2, the scaling is specified
C                    by the input DIAG. other values of mode are
C                    equivalent to MODE = 1.
C      FACTOR  D     Used in determining the initial step bound.
C                    This bound is set to the product of FACTOR and
C                    the Euclidean norm of DIAG*X if nonzero, or else
C                    to FACTOR itself. In most cases FACTOR should lie
C                    in the interval (.1,100.0).  100.0 is a generally
C                    recommended value.
C      NPRINT  I     enables controlled printing of iterates if it
C                    is positive. In this case, FCN is called with
C                    IFLAG = 0 at the beginning of the first iteration
C                    and every NPRINT iterations thereafter and
C                    immediately prior to return, with X, FVEC, and
C                    FJAC available for printing. FVEC and FJAC should
C                    not be altered. If NPRINT is not positive, no
C                    special calls of FCN with IFLAG = 0 are made.
C      LDFJAC  I     variable not less than M which specifies the
C                    leading dimension of the array FJAC (adj. array
C                    dim.).
C   Outputs:
C      X       D(N)  contains the final estimate of the
C                    solution vector.
C      FVEC    D(M)  contains the functions evaluated at
C                    the output X.
C      FJAC    D(M,N)  The upper N by N submatrix of FJAC
C                    contains an upper triangular matrix R with
C                    diagonal elements of nonincreasing magnitude
C                    such that
C                           T     T           T
C                          P *(JAC *JAC)*P = R *R,
C                    where P is a permutation matrix and JAC is the
C                    final calculated Jacobian. Column J of P is column
C                    IPVT(J) (see below) of the identity matrix. The
C                    lower trapezoidal part of FJAC contains information
C                    generated during the computation of R.
C      INFO    I     If the user has terminated execution, INFO is
C                    set to the (negative) value of IFLAG. SEE
C                    description of FCN. otherwise, INFO is set
C                    as follows:
C                    INFO = 0  Improper input parameters.
C                    INFO = 1  Algorithm estimates that the relative
C                    error in the sum of squares is at most FTOL.
C                    INFO = 2  Algorithm estimates that the relative
C                    error between X and the solution is at most XTOL.
C                    INFO = 3  Conditions for INFO = 1 and INFO = 2
C                    both hold.
C                    INFO = 4  The cosine of the angle between FVEC
C                    and any column of the Jacobian is at most GTOL
C                    in absolute value.
C                    INFO = 5  Number of calls to FCN with IFLAG = 1 HAS
C                    reached MAXFEV.
C                    INFO = 6  FTOL is too small. No further reduction
C                    in the sum of squares is possible.
C                    INFO = 7  XTOL is too small. No further improvement
C                    in the approximate solution X is possible.
C                    INFO = 8  GTOL is too small. FVEC is orthogonal
C                    to the columns of the Jacobian to machine
C                    precision.
C      NFEV    I     Number of calls to FCN with IFLAG = 1.
C      NJEV    I     The number of calls to FCN with IFLAG = 2.
C      IPVT    I(N)  Defines a permutation matrix P such that
C                                JAC*P = Q*R,
C                    where JAC is the final calculated Jacobian, Q is
C                    orthogonal (not stored), and R is upper triangular
C                    with diagonal elements of nonincreasing magnitude.
C                    column J of P is column IPVT(J) of the identity
C                    matrix.
C      QTF     D(N)  contains the first N elements of the
C                    vector (Q transpose)*FVEC.
C      WA1     D(N)  work array.
C      WA2     D(N)  work array.
C      WA3     D(N)  work array.
C      WA4     D(M)  work array.
C-----------------------------------------------------------------------
      EXTERNAL  FCN
C     INTEGER   FCN
      INTEGER   M, N, LDFJAC, MAXFEV, MODE, NPRINT, INFO, NFEV,
     *   NJEV, IPVT(N)
      DOUBLE PRECISION FTOL, XTOL, GTOL, FACTOR, X(N), FVEC(M),
     *   FJAC(LDFJAC,N), DIAG(N), QTF(N), WA1(N), WA2(N), WA3(N),
     *   WA4(M)
C
      INTEGER   I, IFLAG, ITER, J, L
      DOUBLE PRECISION ACTRED, DELTA, DIRDER, EPSMCH, FNORM, FNORM1,
     *   GNORM, ONE, PAR, PNORM, PRERED, P1, P5, P25, P75, P0001, RATIO,
     *   SUM, TEMP, TEMP1, TEMP2, XNORM, ZERO
      DOUBLE PRECISION DPMPAR, ENORM
      LOGICAL   T
      DATA T /.TRUE./
      DATA ONE, P1, P5, P25, P75, P0001, ZERO
     *     /1.0D0, 1.0D-1, 5.0D-1, 2.5D-1, 7.5D-1, 1.0D-4, 0.0D0/
C-----------------------------------------------------------------------
C                                       EPSMCH is the machine precision
      EPSMCH = DPMPAR (1)
      INFO = 0
      IFLAG = 0
      NFEV = 0
      NJEV = 0
C                                       Check the input parameters for
C                                       errors.
      IF ((N.LE.0) .OR. (M.LT.N) .OR. (LDFJAC.LT.M) .OR.
     *    (FTOL.LT.ZERO) .OR. (XTOL.LT.ZERO) .OR. (GTOL.LT.ZERO)
     *    .OR. (MAXFEV.LE.0) .OR. (FACTOR.LE.ZERO)) GO TO 300
      IF (MODE.NE.2) GO TO 20
         DO 10 J = 1, N
            IF (DIAG(J).LE.ZERO) GO TO 300
 10         CONTINUE
 20   CONTINUE
C                                 Evaluate the function at the starting
C                                 point and calculate its norm.
      IFLAG = 1
      CALL FCN (M, N, X, FVEC, FJAC, LDFJAC, IFLAG)
      NFEV = 1
      IF (IFLAG.LT.0) GO TO 300
      FNORM = ENORM (M, FVEC)
C                                       Initialize Levenberg-Marquardt
C                                       parameter and iteration counter
      PAR = ZERO
      ITER = 1
C                                       Beginning of the outer loop.
 30   CONTINUE
C                                       Calculate the Jacobian matrix.
         IFLAG = 2
         CALL FCN (M, N, X, FVEC, FJAC, LDFJAC, IFLAG)
         NJEV = NJEV + 1
         IF (IFLAG.LT.0) GO TO 300
C                                       If requested, call FCN to
C                                       enable printing of iterates.
         IF (NPRINT.LE.0) GO TO 40
         IFLAG = 0
         IF (MOD (ITER-1, NPRINT).EQ.0)
     *      CALL FCN (M, N, X, FVEC, FJAC, LDFJAC, IFLAG)
         IF (IFLAG.LT.0) GO TO 300
 40      CONTINUE
C                                       Compute the QR factorization
C                                       of the Jacobian.
         CALL QRFAC (M, N, FJAC, LDFJAC, T, IPVT, N, WA1, WA2, WA3)
C                                       On the first iteration and if
C                                       MODE is 1, scale according
C                                       to the norms of the columns of
C                                       the initial Jacobian.
         IF (ITER.NE.1) GO TO 80
         IF (MODE.EQ.2) GO TO 60
            DO 50 J = 1,N
               DIAG(J) = WA2(J)
               IF (WA2(J).EQ.ZERO) DIAG(J) = ONE
 50            CONTINUE
 60      CONTINUE
C                                       On the first iteration,
C                                       calculate the norm of the
C                                       scaled X and initialize the
C                                       step bound DELTA.
         DO 70 J = 1,N
            WA3(J) = DIAG(J) * X(J)
 70         CONTINUE
         XNORM = ENORM (N, WA3)
         DELTA = FACTOR * XNORM
         IF (DELTA.EQ.ZERO) DELTA = FACTOR
 80      CONTINUE
C                                       Form (Q transpose)*FVEC and
C                                       store the first N components in
C                                       QTF.
         DO 90 I = 1,M
            WA4(I) = FVEC(I)
 90         CONTINUE
         DO 130 J = 1,N
            IF (FJAC(J,J).EQ.ZERO) GO TO 120
               SUM = ZERO
               DO 100 I = J,M
                  SUM = SUM + FJAC(I,J) * WA4(I)
 100              CONTINUE
               TEMP = -SUM / FJAC(J,J)
               DO 110 I = J,M
                  WA4(I) = WA4(I) + FJAC(I,J) * TEMP
 110              CONTINUE
 120        FJAC(J,J) = WA1(J)
            QTF(J) = WA4(J)
 130        CONTINUE
C                                       Compute the norm of the scaled
C                                       gradient.
         GNORM = ZERO
         IF (FNORM.EQ.ZERO) GO TO 170
         DO 160 J = 1,N
            L = IPVT(J)
            IF (WA2(L).EQ.ZERO) GO TO 150
            SUM = ZERO
            DO 140 I = 1,J
               SUM = SUM + FJAC(I,J) * (QTF(I) / FNORM)
 140           CONTINUE
            GNORM = MAX(GNORM, ABS (SUM/WA2(L)))
 150        CONTINUE
 160        CONTINUE
 170     CONTINUE
C                                       Test for convergence of the
C                                       gradient norm.
         IF (GNORM.LE.GTOL) INFO = 4
         IF (INFO.NE.0) GO TO 300
C                                       Rescale if necessary.
         IF (MODE.EQ.2) GO TO 190
            DO 180 J = 1,N
               DIAG(J) = MAX (DIAG(J), WA2(J))
 180           CONTINUE
 190     CONTINUE
C                                       Beginning of the inner loop.
 200     CONTINUE
C                                       Determine the
C                                       Levenberg-Marquardt parameter.
            CALL LMPAR (N, FJAC, LDFJAC, IPVT, DIAG, QTF, DELTA, PAR,
     *         WA1, WA2, WA3, WA4)
C                                       Store the directn P and X + P.
C                                       Calculate the norm of P.
            DO 210 J = 1,N
               WA1(J) = -WA1(J)
               WA2(J) = X(J) + WA1(J)
               WA3(J) = DIAG(J) * WA1(J)
 210           CONTINUE
            PNORM = ENORM (N, WA3)
C                                       On the first iteration, adjust
C                                       the initial step bound.
            IF (ITER.EQ.1) DELTA = MIN (DELTA, PNORM)
C                                       Evaluate the function at X + P
C                                       and calculate its norm.
            IFLAG = 1
            CALL FCN (M, N, WA2, WA4, FJAC, LDFJAC, IFLAG)
            NFEV = NFEV + 1
            IF (IFLAG.LT.0) GO TO 300
            FNORM1 = ENORM (M, WA4)
C                                       Compute the scaled actual
C                                       reduction.
            ACTRED = -ONE
            IF (P1*FNORM1.LT.FNORM) ACTRED = ONE - (FNORM1/FNORM)**2
C                                       Compute the scaled predicted
C                                       reduction and the scaled
C                                       directional derivative.
            DO 230 J = 1,N
               WA3(J) = ZERO
               L = IPVT(J)
               TEMP = WA1(L)
               DO 220 I = 1,J
                  WA3(I) = WA3(I) + FJAC(I,J) * TEMP
 220              CONTINUE
 230           CONTINUE
            TEMP1 = ENORM(N,WA3)/FNORM
            TEMP2 = (SQRT(PAR)*PNORM)/FNORM
            PRERED = TEMP1**2 + TEMP2**2/P5
            DIRDER = -(TEMP1**2 + TEMP2**2)
C                                       Compute the ratio of the
C                                       actual to the predicted
C                                       reduction.
            RATIO = ZERO
            IF (PRERED .NE. ZERO) RATIO = ACTRED/PRERED
C                                       Update the step bound.
            IF (RATIO .GT. P25) GO TO 240
               IF (ACTRED .GE. ZERO) TEMP = P5
               IF (ACTRED .LT. ZERO)
     *            TEMP = P5*DIRDER/(DIRDER + P5*ACTRED)
               IF (P1*FNORM1 .GE. FNORM .OR. TEMP .LT. P1) TEMP = P1
               DELTA = TEMP*MIN(DELTA,PNORM/P1)
               PAR = PAR/TEMP
               GO TO 260
 240        CONTINUE
               IF (PAR .NE. ZERO .AND. RATIO .LT. P75) GO TO 250
               DELTA = PNORM/P5
               PAR = P5*PAR
 250           CONTINUE
 260        CONTINUE
C                                       Test for successful iteration.
            IF (RATIO .LT. P0001) GO TO 290
C                                       Successful iteration. update
C                                       X, FVEC, and their norms.
            DO 270 J = 1, N
               X(J) = WA2(J)
               WA2(J) = DIAG(J)*X(J)
 270           CONTINUE
            DO 280 I = 1, M
               FVEC(I) = WA4(I)
 280           CONTINUE
            XNORM = ENORM(N, WA2)
            FNORM = FNORM1
            ITER = ITER + 1
 290        CONTINUE
C                                       Tests for convergence.
            IF (ABS(ACTRED) .LE. FTOL .AND. PRERED .LE. FTOL
     *         .AND. P5*RATIO .LE. ONE) INFO = 1
            IF (DELTA .LE. XTOL*XNORM) INFO = 2
            IF (ABS(ACTRED) .LE. FTOL .AND. PRERED .LE. FTOL
     *         .AND. P5*RATIO .LE. ONE .AND. INFO .EQ. 2) INFO = 3
            IF (INFO .NE. 0) GO TO 300
C                                       Tests for termination and
C                                       stringent tolerances.
            IF (NFEV .GE. MAXFEV) INFO = 5
            IF (ABS(ACTRED) .LE. EPSMCH .AND. PRERED .LE. EPSMCH
     *         .AND. P5*RATIO .LE. ONE) INFO = 6
            IF (DELTA .LE. EPSMCH*XNORM) INFO = 7
            IF (GNORM .LE. EPSMCH) INFO = 8
            IF (INFO .NE. 0) GO TO 300
C                                       End of the inner loop. Repeat
C                                       if iteration unsuccessful.
            IF (RATIO .LT. P0001) GO TO 200
C                                       End of the outer loop.
         GO TO 30
 300  CONTINUE
C                                       Termination, either normal
C                                       or user imposed.
      IF (IFLAG.LT.0) INFO = IFLAG
      IFLAG = 0
      IF (NPRINT.GT.0) CALL FCN (M, N, X, FVEC, FJAC, LDFJAC, IFLAG)
      RETURN
C
      END

      SUBROUTINE ZCLC8 (NCHAR, INBUF, NP, OUTBUF)
C-----------------------------------------------------------------------
C! convert local character string to packed ASCII buffer
C# Z Binary
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Convert local characters in a buffer to standard 8-bit ASCII
C   character form
C   Inputs:
C      NCHAR    I       Number of characters to convert
C      INBUF    C*(*)   Characters in local form
C      NP       I       Starting position in output buffer in units of
C                       8-bit characters (1-relative)
C   Output:
C      OUTBUF   R(*)    Buffer containing characters in 8-bit ASCII form
C   Generic version - assumes local characters are ASCII.
C   Requires local development if NBITWD not n*8.
C-----------------------------------------------------------------------
      INTEGER   NCHAR, NP
      CHARACTER INBUF*(*)
      REAL      OUTBUF(*)
C
      INTEGER   J, NCHPFP, J1, J2, I, I1, I2
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (NCHAR.LE.0) GO TO 999
      NCHPFP = NBITWD / 8
      J = MOD (NBITWD, 8)
      IF (J.NE.0) THEN
         WRITE (MSGTXT,9999) NBITWD
         CALL MSGWRT (9)
         STOP'ZCLC8 NEEDS LOCAL DEVELOPMENT'
      ELSE
         I1 = MAX (NP, 1) - 1
         DO 20 I = 1,NCHAR
            J = ICHAR (INBUF(I:I))
            I2 = I + I1
            J1 = (I2-1) / NCHPFP + 1
            J2 = MOD (I2-1, NCHPFP) + 1
            CALL ZPUTCH (J, OUTBUF(J1), J2)
 20         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 9999 FORMAT ('ZCLC8: REQUIRES LOCAL DEVELOPMENT FOR NBITWD=',I7)
      END

      SUBROUTINE Q1FIN (APCORE, U, ROW, MO2, LROW)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Finish gridding a row of uv data.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2006, 2008, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Vectorizing compiler version
C   Does various tasks associated with completion of gridding a row.
C   If U is within 1/2 support of 0 the symmetric row is conjugated,
C   flipped and added.  Finally rows are rotated so that zero column
C   (assumed LROW/2+1) goes to the first column.
C   If U=0 the space for the next row down is used.
C   Inputs:
C      U     I  U in cells (non-negative)
C      ROW   I  Base address of Grid row of interest
C      MO2   I  Half the number of rows kept in the AP.
C      LROW  I  Length of row (no. vis)
C   Expects necessary constants in following AP locations:
C           0 = COS(PHASE0)           to shift map center
C           1 = SIN(PHASE0)
C           4 = COS(DELPHC)           for rotating down columns
C           5 = SIN(DELPHC)
C   Old comments say the following, but they are NOT used:
C           2 = COS(DELPHR)           for rotating down rows
C           3 = SIN(DELPHR)
C           6 = 1.0
C           7 = 0.0
C   6,7 appropriated for use in QNGRD
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   U, ROW, MO2, LROW
C
      INTEGER   ROW2,  SYM, REND, LROW1, LROWT2, LOOP
      LONGINT   JA, JB, JC, TEST
      DOUBLE PRECISION TEMP, SPHS, CPHS, SDEL, CDEL, DTEST
      EQUIVALENCE (TEST, DTEST)
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      LROW1 = LROW - 1
      LROWT2 = LROW + LROW
C                                       If near origin, add symmetric
C                                       points.
      IF (U.LE.MO2) THEN
         ROW2 = ROW + 2
         SYM = ROW - (4 * LROW * U)
         DTEST = APCORE(PSAPOF+19)
         IF (SYM.GE.TEST) THEN
C                                       If U=0 move 0 row 1 slot lower
C                                       and work from there.
            IF (U.EQ.0) THEN
               SYM = ROW - LROWT2
               JA = ROW + PSAPOF - 1
               JC = SYM + PSAPOF - 1
      INCLUDE 'INCS:ZVND.INC'
               DO 20 LOOP = 1,LROWT2
                  APCORE (JC+LOOP) = APCORE (JA+LOOP)
 20               CONTINUE
               END IF
            REND = SYM + LROWT2 - 2
            JA = ROW2 + PSAPOF
            JB = REND + PSAPOF
      INCLUDE 'INCS:ZVND.INC'
            DO 30 LOOP = 1,LROW1
               APCORE(JA) = APCORE(JA) + APCORE(JB)
               APCORE(JA+1) = APCORE(JA+1) - APCORE(JB+1)
               JA = JA + 2
               JB = JB - 2
 30            CONTINUE
C                                       End cell
            APCORE(ROW+PSAPOF) = APCORE(ROW+PSAPOF) + APCORE(SYM+PSAPOF)
            APCORE(ROW+PSAPOF+1) = APCORE(ROW+PSAPOF+1) -
     *         APCORE(SYM+PSAPOF+1)
            END IF
         END IF
C                                       Rotate zero to first col.
      SYM = ROW + LROW
      JA = ROW + PSAPOF - 1
      JC = SYM + PSAPOF - 1
      INCLUDE 'INCS:ZVND.INC'
      DO 100 LOOP = 1,LROW
         TEMP = APCORE(JA+LOOP)
         APCORE(JA+LOOP) = APCORE(JC+LOOP)
         APCORE(JC+LOOP) = TEMP
 100     CONTINUE
C                                       Rotate map center.
      CALL QPHSRO (APCORE, ROW, 2, ROW, 2, 0, 2, LROW)
C                                       Update for next row
      CPHS = APCORE(PSAPOF)
      SPHS = APCORE(PSAPOF+1)
      CDEL = APCORE(PSAPOF+4)
      SDEL = APCORE(PSAPOF+5)
      APCORE(PSAPOF) = CPHS * CDEL - SPHS * SDEL
      APCORE(PSAPOF+1) = CPHS * SDEL + SPHS * CDEL
C
 999  RETURN
      END

      SUBROUTINE ZEHEX (IVAL, NC, HVAL)
C-----------------------------------------------------------------------
C! encode an integer into extended hexadecimal (base 36) characters
C# Z Service
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  Convert decimal to nc character extended hexidecimal 'string' -
C  leading blanks are made into 0's.
C  Input:
C     IVAL   I       Decimal value to convert
C     NC     I       Width of receiving field
C  Output:
C     HVAL   C*(*)   String receiving hexidecimal conversion
C  Generic version - klunky but works
C-----------------------------------------------------------------------
      INTEGER   IVAL, NC
      CHARACTER HVAL*(*)
C
      INTEGER   I, J, JVAL, LVAL, LC
      CHARACTER HEXC*36
      INCLUDE 'INCS:DDCH.INC'
      DATA HEXC /'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
C-----------------------------------------------------------------------
      HVAL = ' '
      LC = MIN (NC, LEN(HVAL))
C                                       loop through digits
      LVAL = IVAL
      DO 10 I = 1,LC
         J = LC + 1 - I
         JVAL = MOD (LVAL, 36) + 1
         HVAL(J:J) = HEXC(JVAL:JVAL)
         LVAL = LVAL / 36
 10      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ZPARAL (NPROC)
C-----------------------------------------------------------------------
C! Set and report on number of processors to use for parallel tasks
C# Z General
C-----------------------------------------------------------------------
C;  Copyright (C) 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   If NPROC is positive then set the number of threads of execution to
C   be NPROC for subsequent tasks.  Set NPROC to the actual number of
C   threads of execution regardless of its initial value.
C
C   Input/output:
C      NPROC     I       On entry: the number of threads/processors
C                                  requested
C                        On exit: the actual number of threads that
C                                 will be used
C
C   IRIX version: sets/reads the MP_SET_NUMTHREADS environment variable
C-----------------------------------------------------------------------
      INTEGER   NPROC
C
C   Local variables
C
C   LNAME       Logical name used to set parallelism (constant)
C   NUMBUF      Character buffer for translating numbers
C   TRBUF       Translation buffer for logical names
C   XLATED      Number of characters in translated names
C   START       Pointer to first non-zero digit in NUMBUF
C   IRET        Return code from ZCRLOG and ZTRLOG
C
      CHARACTER LNAME*17, NUMBUF*20, TRBUF*20
      INTEGER   XLATED, START, IRET
C                                       Note that a 20-character buffer
C                                       holds the decimal version of a
C                                       16-bit binary integer.
      PARAMETER (LNAME = 'MP_SET_NUMTHREADS')
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (NPROC .GT. 0) THEN
         WRITE (NUMBUF, 1000) NPROC
         START = 1
C
C        Simulated while loop
C        Invariant: NUMBUF(1:START - 1) is all zeros
C        Bound: LEN (NUMBUF) - START
C        Note that the last character is guaranteed not to be zero
C        by the restriction that NPROC > 0
C
   10    IF (NUMBUF(START:START) .EQ. '0') THEN
            START = START + 1
            GO TO 10
         END IF
         CALL ZCRLOG (LEN (LNAME), LNAME, LEN (NUMBUF) - START + 1,
     *      NUMBUF(START:LEN (NUMBUF)), IRET)
         IF (IRET .NE. 0) THEN
C
C           Can not update logical so issue an error message and try
C           and read back the actual value.
C
            MSGTXT = 'ZPARAL: CAN NOT SET ''' // LNAME // ''''
            CALL MSGWRT (6)
            IRET = 0
            CALL ZTRLOG (LEN (LNAME), LNAME, LEN (TRBUF), TRBUF, XLATED,
     *         IRET)
            IF (IRET .EQ. 0) THEN
C
C              Right-justify the translated value in NUMBUF:
C
               NUMBUF = ' '
               NUMBUF(20 - XLATED + 1:20) = TRBUF(1:XLATED)
               READ (NUMBUF, 1001, IOSTAT = IRET) NPROC
               IF (IRET .EQ. 0) THEN
C
C                 Filter out obviously silly values:
C
                  NPROC = MAX (NPROC, 1)
               ELSE
C
C                 The value couldn't be translated to an integer so
C                 assume that only one processor will be used:
C
                  MSGTXT = 'ZPARAL: ''' // LNAME //
     *               ''' HAS A NON-NUMERIC VALUE'
                  CALL MSGWRT (6)
                  MSGTXT = 'ZPARAL: ASSUMING ONLY ONE PROCESSOR ' //
     *               'WILL BE USED'
                  CALL MSGWRT (6)
                  NPROC = 1
               END IF
            ELSE
C
C              Can not read the logical variable. The most likely
C              reason is that it is not set so assume that only
C              one processor will be used and don't bother the
C              user:
C
               NPROC = 1
            END IF
         END IF
      ELSE
         CALL ZTRLOG (LEN (LNAME), LNAME, LEN (TRBUF), TRBUF, XLATED,
     *      IRET)
         IF (IRET .EQ. 0) THEN
C
C           Right-justify the translated value in NUMBUF:
C
            NUMBUF = ' '
            NUMBUF(20 - XLATED + 1:20) = TRBUF(1:XLATED)
            READ (NUMBUF, 1001, IOSTAT = IRET) NPROC
            IF (IRET .EQ. 0) THEN
C
C              Filter out obviously silly values:
C
               NPROC = MAX (NPROC, 1)
            ELSE
C
C              The value couldn't be translated to an integer so
C              assume that only one processor will be used:
C
               MSGTXT = 'ZPARAL: ''' // LNAME //
     *            ''' HAS A NON-NUMERIC VALUE'
               CALL MSGWRT (6)
               MSGTXT = 'ZPARAL: ASSUMING ONLY ONE PROCESSOR ' //
     *            'WILL BE USED'
               CALL MSGWRT (6)
               NPROC = 1
            END IF
         ELSE
C
C           Can not read the logical variable. The most likely
C           reason is that it is not set so assume that only
C           one processor will be used and don't bother the
C           user:
C
            NPROC = 1
         END IF
      END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I20.20)
 1001 FORMAT (I20)
      END

      SUBROUTINE HDRINF (LUN, WTYPE, SITEM, NITEM, OUTPUT, ERROR)
C-----------------------------------------------------------------------
C! returns consecutivew items of specified type from header for WaWa
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   WaWa IO system:   Return a number of items from the header block
C   of an open, catalogd file.
C   Inputs:
C      LUN       I       Logical Unit No. of file
C      WTYPE     I       Data type: 1 = I,   2 = R   3 = D   6 = C*8
C      SITEM     I       Index # of 1st item wanted, indexed in a
C                        system appropriate to WTYPE (R   for C*8)
C      NITEM     I       Number of items requested
C   Outputs:
C      OUTPUT(*) ???     Array into which items go
C      ERROR     I       Error code: 0 => ok
C                                    1 => file not open
C                                    2 => nonsense input parms
C                                   10 => catlg read error
C   Common /MAPHDR/ receives the header read from catlg file
C   Written by WaWa (4/21/81)
C-----------------------------------------------------------------------
      INTEGER   LUN, WTYPE, SITEM, NITEM, OUTPUT(*), ERROR
C
      INTEGER   NI2, SI2, NB, NONSEN
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA NONSEN /2/
C-----------------------------------------------------------------------
C                                       How many Integers to transfer
      ERROR = NONSEN
      IF ((WTYPE.LT.1) .OR. (WTYPE.GT.6)) GO TO 999
C                                       C*8 special case
      IF (WTYPE.NE.6) GO TO 20
         NB = 4
         NI2 = NITEM * NB / 2
         SI2 = SITEM
         GO TO 30
C                                       Normal data
 20   CONTINUE
         NB = 2
         IF (WTYPE.EQ.3) NB = 2 * NWDPDP
         NI2 = NITEM * NB / 2
         SI2 = 1 + NB * (SITEM - 1)/2
 30   IF ((SI2.LE.0) .OR. (SI2+NI2.GT.257)) GO TO 999
C                                       Get the header
      CALL GETHDR (LUN, CATBLK, ERROR)
      IF (ERROR.NE.0) GO TO 999
C                                       Move them doggies
      CALL COPY (NI2, CATBLK, OUTPUT)
C
 999  RETURN
      END

      SUBROUTINE GCINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IGCRNO, GCKOLS, GCNUMV, NPOLGC, NUMIF, NTABGC, IERR)
C-----------------------------------------------------------------------
C! creates and intializes a Gain Curve (GC) table
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2000, 2006-2007, 2010, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes Gain curve tables.
C   Inputs:
C      OPCODE         C*4  Operation code:
C                          'WRIT' = create/init for write or read
C                          'READ' = open for read only
C      BUFFER(512)    I    I/O buffer and related storage, also defines
C                          file if open.
C      DISK           I    Disk to use.
C      CNO            I    Catalog slot number
C      CATBLK(256)    I    Catalog header block.
C      LUN            I    Logical unit number to use
C   Input/Output:
C      VER            I    GC table version
C   Input (create) / output (pre-existing)
C      NPOLGC         I    # polzns in the table
C      NUMIF          I    The number of bands (IF's) in the data.
C      NTABGC         I    # tabulated values per row
C   Output:
C      IGCRNO         I    Next row number, start of the file if READ,
C                          the last+1 if WRITE
C      GCKOLS(MAXGCC) I    The column pointer array in order:
C                             ANTENNA NO, SUBARRAY, FREQ ID,
C                             CURVE TYPE 1, NO ENTRIES 1, X TYPE 1,
C                             Y TYPE 1, X VALUE 1, Y VALUES 1,
C                             GAIN VALUES 1, SENSITIVITY 1
C                          the following are only present if NPOLGC = 2
C                             CURVE TYPE 2, NO ENTRIES 2, X TYPE 2,
C                             Y TYPE 2, X VALUE 2, Y VALUES 2,
C                             GAIN VALUES 2, SENSITIVITY 2,
C      GCNUMV(MAXGCC) I    Element count in each column.
C      IERR           I    Return error code, 0=>OK, else TABINI or
C                          TABIO error.
C----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PGCV.INC'
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, IGCRNO,
     *   GCKOLS(MAXGCC), GCNUMV(MAXGCC), NPOLGC, NTABGC, NUMIF, IERR
C
      INCLUDE 'INCS:PTAB.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C                                       Local variables
      LOGICAL   T, DOREAD, NEWFIL
      INTEGER   NUMKEY
      PARAMETER (NUMKEY = 4)
      CHARACTER LTGC(MAXGCC)*24, LTTGC*56, LUNTGC(MAXGCC)*8,
     *   LKEYGC(NUMKEY)*8
      INTEGER  DTYP(MAXGCC), DATP(128,2), NREC, NCOL, NKEY, I, ITEMP(6),
     *   JERR, NDATA, IPOINT, NTTGC, ITRIM, NC
      INTEGER  KEYVAL(2 * NUMKEY), KLOCS(NUMKEY), KEYTYP(NUMKEY)
      HOLLERITH HOLTMP(6)
      EQUIVALENCE (HOLTMP, ITEMP)
C                                       Data statements
      DATA LTGC /'ANTENNA_NO              ',
     *   'SUBARRAY                ', 'FREQ ID                 ',
     *   'TYPE_1                  ', 'NTERM_1                 ',
     *   'X_TYP_1                 ', 'Y_TYP_1                 ',
     *   'X_VAL_1                 ', 'Y_VAL_1                 ',
     *   'GAIN_1                  ', 'SENS_1                  ',
     *   'TYPE_2                  ', 'NTERM_2                 ',
     *   'X_TYP_2                 ', 'Y_TYP_2                 ',
     *   'X_VAL_2                 ', 'Y_VAL_2                 ',
     *   'GAIN_2                  ', 'SENS_2                  '/
      DATA LTTGC
     *   /'GAIN CURVE TABLE '/
      DATA LUNTGC /7*'        ', 2*'DEGREES ', '        ',
     *   'K/JY    ', 4*'        ', 2*'DEGREES ', '        ',
     *   'K/JY    '/
      DATA LKEYGC /'NO_BAND ', 'NO_POL', 'NO_TABS', 'TABREV' /
      DATA NTTGC /56/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Set up needed variables
      NREC = 30
      NCOL = 3 + 8 * MIN (2, NPOLGC)
      IF (DOREAD) NCOL = 0
      NKEY = NUMKEY
      NDATA = MAXGCC
      CALL FILL (NDATA, 0, GCKOLS)
      CALL FILL (NDATA, 0, GCNUMV)
      IF (.NOT.DOREAD) THEN
C                                       Check no. of entries requested
         IF (NTABGC.GT.MXTBGC) THEN
            IERR = 1
            WRITE (MSGTXT,1000) NTABGC
            CALL MSGWRT (7)
            GO TO 990
            END IF
C                                       Fill in types, lengths
C                                       See Going AIPS Vol 2 p13-3.
         DTYP(GCIANT) = TABINT + 10
         DTYP(GCISUB) = TABINT + 10
         DTYP(GCIFQD) = TABINT + 10
         DTYP(GCITP1) = TABINT + 10 * NUMIF
         DTYP(GCINT1) = TABINT + 10 * NUMIF
         DTYP(GCIXT1) = TABINT + 10 * NUMIF
         DTYP(GCIYT1) = TABINT + 10 * NUMIF
         DTYP(GCRXV1) = TABFLT + 10 * NUMIF
         DTYP(GCRYV1) = TABFLT + 10 * NUMIF * NTABGC
         DTYP(GCRGA1) = TABFLT + 10 * NUMIF * NTABGC
         DTYP(GCRSE1) = TABFLT + 10 * NUMIF
         DTYP(GCITP2) = TABINT + 10 * NUMIF
         DTYP(GCINT2) = TABINT + 10 * NUMIF
         DTYP(GCIXT2) = TABINT + 10 * NUMIF
         DTYP(GCIYT2) = TABINT + 10 * NUMIF
         DTYP(GCRXV2) = TABFLT + 10 * NUMIF
         DTYP(GCRYV2) = TABFLT + 10 * NUMIF * NTABGC
         DTYP(GCRGA2) = TABFLT + 10 * NUMIF * NTABGC
         DTYP(GCRSE2) = TABFLT + 10 * NUMIF
         CALL COPY (NCOL, DTYP, DATP(1,2))
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'GC', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'GCINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
C                                       Get number of records
      IGCRNO = BUFFER(5) + 1
      IF (DOREAD) IGCRNO = 1
      NKEY = NUMKEY
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 40 I = 1,NCOL
            CALL CHR2H (24, LTGC(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'GCINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, LUNTGC(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'GCINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTTGC, LTTGC, 1, BUFFER(101))
C                                       Write keywords if table created
         KEYTYP(1) = TABINT
         KLOCS(1)  = 1
         KEYVAL(1) = NUMIF
         KEYTYP(2) = TABINT
         KLOCS(2)  = 2
         KEYVAL(2) = MIN (NPOLGC, 2)
         KEYTYP(3) = TABINT
         KLOCS(3)  = 3
         KEYVAL(3) = NTABGC
         KEYTYP(4) = TABINT
         KLOCS(4)  = 4
         KEYVAL(4) = IGCREV
         NKEY = NUMKEY
         CALL TABKEY ('WRIT', LKEYGC, NKEY, BUFFER, KLOCS, KEYVAL,
     *      KEYTYP, IERR)
         IF ((IERR.GE.1).AND.(IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'GCINI ', IERR)
            GO TO 990
            END IF
      ELSE
C                                       Read keywords
         NKEY = NUMKEY
         CALL TABKEY ('READ', LKEYGC, NKEY, BUFFER, KLOCS, KEYVAL,
     *      KEYTYP, IERR)
         IF ((IERR.GE.1).AND.(IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'GCINI ', IERR)
            GO TO 990
            END IF
         IF (KLOCS(1) .GT. 0) THEN
            NUMIF = KEYVAL(KLOCS(1))
            END IF
         IF (KLOCS(2) .GT. 0) THEN
            NPOLGC = KEYVAL(KLOCS(2))
            NPOLGC = MIN (2, NPOLGC)
            END IF
         IF (KLOCS(3) .GT. 0) THEN
            NTABGC = KEYVAL(KLOCS(3))
            END IF
         END IF
C                                       Get array indices
C                                       Prevent problems with FNDCOL -
C                                       close to flush the buffers and
C                                       then reopen.
      CALL TABIO ('CLOS', 0, 0, BUFFER, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'GCINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
C                                       Re-open
      CALL TABINI (OPCODE, 'GC', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'GCINI', IERR)
         GO TO 990
         END IF
C
      CALL FNDCOL (NDATA, LTGC, 24, T, BUFFER, GCKOLS, JERR)
C                                       Get array indices and no. values
      NCOL = 3 + 8 * MIN (2, NPOLGC)
      DO 150 I = 1,NDATA
         IPOINT = GCKOLS(I)
         IF (IPOINT.GT.0) THEN
            GCKOLS(I) = DATP(IPOINT,1)
            GCNUMV(I) = DATP(IPOINT,2) / 10
            IF (GCNUMV(I).LE.0) THEN
               NC = ITRIM (LTGC(I))
               WRITE (MSGTXT,1100) LTGC(I)(:NC)
               IF (I.LE.NCOL) CALL MSGWRT (6)
               END IF
         ELSE
            GCKOLS(I) = -1
            GCNUMV(I) = 0
            NC = ITRIM (LTGC(I))
            WRITE (MSGTXT,1101) LTGC(I)(:NC)
            IF (I.LE.NCOL) CALL MSGWRT (6)
            END IF
 150     CONTINUE
C
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GCINI: NTABGC=',I6,' EXCEEDS MAXIMUM ALLOWED')
 1100 FORMAT ('GCINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('GCINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('GCINI: ERROR INITIALIZING GAIN CURVE TABLE FOR ',A4)
      END

      SUBROUTINE PPINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IPPRNO, PPKOLS, PPNUMV, NUMIF, NUMFRQ, BIF, BCHAN, PPOL, IERR)
C-----------------------------------------------------------------------
C! Create/open/initialize R-L or X-Y phase difference (PP) table
C# EXT-util Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2019, 2021-2022, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes phase difference (PP) extension tables.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'WRIT' = create/init for write or read
C                        'READ' = open for read only
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      LUN      I        Logical unit number to use
C   Input/output
C      VER      I        PP file version
C      CATBLK   I(256)   Catalog header block.
C   Input (create) / output (pre-existing)
C      NUMIF    I        Number of IFs
C      NUMFRQ   I        Number of frequency channels
C      BIF      I        First IF
C      BCHAN    I        Start channel number
C      PPOL     I        0 unknown, 1 -> RL, 2 -> VH
C   Output:
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      IPPRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      PPKOLS   I(MAXPPC)   The column pointer array in order:
C                        SUBARRAY, FREQ. ID,
C                        Phase(NUMFRQ,NUMIF)
C      PPNUMV   I(MAXPPC)   Element count in each column.
C      IERR     I        Return error code, 0=>OK, else TABINI or TABIO
C                        error.
C-----------------------------------------------------------------------
      INTEGER   MAXPPC
      PARAMETER (MAXPPC = 5)
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER OPCODE*4
      INTEGER   BUFFER(*), DISK, CNO, VER, CATBLK(256), LUN, IPPRNO,
     *   PPKOLS(MAXPPC), PPNUMV(MAXPPC), NUMIF, NUMFRQ, BIF, BCHAN,
     *   PPOL, IERR
C
      HOLLERITH HOLTMP(6)
      CHARACTER TTITLE*56, TITLE(MAXPPC)*24, UNITS(MAXPPC)*8, KEYW(5)*8
      INTEGER   NKEY, NREC, DATP(128,2), NCOL, NTT, DTYP(MAXPPC), NDATA,
     *   KLOCS(5), KEYVAL(5), KEYTYP(5), IPOINT, MSGSAV, I, NC, JERR,
     *   ITRIM, ITEMP(6)
      REAL      KEYVAR(12)
      LOGICAL   DOREAD, NEWFIL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (KEYVAL, KEYVAR), (HOLTMP, ITEMP)
      DATA NTT /56/
      DATA TTITLE /'AIPS UV DATA FILE PHASE DIFFERENCE TABLE '/
      DATA DTYP /12, 14, 14, 2, 2/
      DATA TITLE /'TIME', 'SUBARRAY ', 'FREQ ID ', 'PHASE DIFF',
     *   'PHASE RMS'/
      DATA KEYW /'NO_IF', 'NO_CHAN', 'BIF', 'BCHAN', 'PP POL'/
      DATA UNITS /'DAYS', ' ', ' ', 2*'DEGREES'/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NREC = 1
      NKEY = 5
      NDATA = MAXPPC
      CALL FILL (NDATA, 0, PPKOLS)
      CALL FILL (NDATA, 0, PPNUMV)
C                                       Fill in types
      IF (.NOT.DOREAD) THEN
         NCOL = NDATA
         CALL COPY (NDATA, DTYP, DATP(1,2))
C                                       Chan. shift type
         DATP(4,2) = DTYP(4) + 10*NUMIF*NUMFRQ
         DATP(5,2) = DTYP(5) + 10*NUMIF*NUMFRQ
      ELSE
         NCOL = 0
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'PP', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'PPINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
      MSGSAV = MSGSUP
C                                       Get number of scans
      IPPRNO = BUFFER(5) + 1
      IF (DOREAD) IPPRNO = 1
      NKEY = 5
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 10 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'PPINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'PPINI', IERR)
               GO TO 990
               END IF
 10         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       Set keyword values
C                                       No. IFs
         KLOCS(1) = 1
         KEYTYP(1) = 4
         KEYVAL(1) = NUMIF
C                                       No. channels
         KLOCS(2) = 2
         KEYTYP(2) = 4
         KEYVAL(2) = NUMFRQ
C                                       start IF
         KLOCS(3) = 3
         KEYTYP(3) = 4
         KEYVAL(3) = BIF
C                                       Start channel
         KLOCS(4) = 4
         KEYTYP(4) = 4
         KEYVAL(4) = BCHAN
C                                       Polarization code
         KLOCS(5) = 5
         KEYTYP(5) = 4
         KEYVAL(5) = PPOL
C                                       Only write if just created.
         CALL TABKEY ('WRIT', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'PPINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         MSGSUP = 32000
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         MSGSUP = MSGSAV
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'PPINI', IERR)
            GO TO 990
            END IF
C                                       Retrieve keyword values
C                                       No. IFs
         IPOINT = KLOCS(1)
         IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       No. channels
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) NUMFRQ = KEYVAL(IPOINT)
C                                       First IF
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) BIF = KEYVAL(IPOINT)
C                                       First channel
         IPOINT = KLOCS(4)
         IF (IPOINT.GT.0) BCHAN = KEYVAL(IPOINT)
C                                       Polarization
         PPOL = 0
         IPOINT = KLOCS(5)
         IF (IPOINT.GT.0) PPOL = KEYVAL(IPOINT)
         END IF
      IERR = 0
C                                      Get array indices
C                                      Cover your ass from FNDCOL -
C                                      close to flush the buffers and
C                                      then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KEYVAL, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'PPINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'PP', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'PPINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (NDATA, TITLE, 24, .TRUE., BUFFER, PPKOLS, JERR)
C                                      Get array indices and no. values
      DO 150 I = 1,NDATA
         IPOINT = PPKOLS(I)
         IF (IPOINT.GT.0) THEN
            PPKOLS(I) = DATP(IPOINT,1)
            PPNUMV(I) = DATP(IPOINT,2) / 10
            IF (PPNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            PPKOLS(I) = -1
            PPNUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('PPINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('PPINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('PPINI: ERROR INITIALIZING PP TABLE FOR ',A)
      END

      SUBROUTINE GAUSPS (DIR, PX0, PY0, BMAJP, BMINP, BPAP, BMAJS,
     *   BMINS, BPAS, IERR)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   converts between Gaussians in pixels and Gaussians on the sky.  It
C   is assumed that the sky is approximately linear about the center
C   pixel for the position angle portion of the computation.
C   Inputs:
C      DIR     C*4   'P2S', 'S2P' direction of conversion
C      PX0     R     Center X pixel
C      PY0     R     Center Y pixel
C   In or out:
C      BMAJP   R     Major axis length pixels
C      BMINP   R     Minor axis length pixels
C      BPAP    R     Position angle of the major axis anticlockwise from
C                    the Y axis in degrees.
C      BMAJS   R     Major axis length in degrees
C      BMINS   R     Minor axis length in degrees
C      BPAS    R     Position angle of the major axis East from North
C   Output
C      IERR    I     Error code from coordinate routines
C   Common:
C      DCAT.INC      image header
C      DLOC.INC      location common with SETLOC already called
C-----------------------------------------------------------------------
      CHARACTER DIR*(*)
      REAL      PX0, PY0, BMAJS, BMINS, BPAS, BMAJP, BMINP, BPAP
      INTEGER   IERR
C
      REAL      XXT, YYT, COSC, SINC
      DOUBLE PRECISION X(3), Y(3), Z(3), XX, YY
      DOUBLE PRECISION C1, C2, DX, DY, DMIN, DMAJ, XSMALL, YSMALL
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       Pixels to sky
      IF (DIR.EQ.'P2S') THEN
         SINC = SIN (DG2RAD*BPAP)
         COSC = COS (DG2RAD*BPAP)
         CALL XYVAL (PX0, PY0, X(1), Y(1), Z(1), IERR)
         IF (IERR.NE.0) GO TO 990
         XXT = PX0 - BMAJP * SINC / 2
         YYT = PY0 + BMAJP * COSC / 2.
         CALL XYVAL (XXT, YYT, X(2), Y(2), Z(2), IERR)
         IF (IERR.NE.0) GO TO 990
         XXT = PX0 - BMINP * COSC / 2.
         YYT = PY0 - BMINP * SINC / 2.
         CALL XYVAL (XXT, YYT, X(3), Y(3), Z(3), IERR)
         IF (IERR.NE.0) GO TO 990
         IF (CORTYP(LOCNUM).EQ.1) THEN
C                                       X => RA,   Y => DECLINATION
C                                       X,Y projection of major semiaxis
C                                       in degrees
            DX = X(1)-X(2)
            DY = Y(1)-Y(2)
            DMAJ = SQRT(DX*DX + DY*DY)
            C1 = COS(DG2RAD*Y(1))
            C2 = COS(DG2RAD*Y(2))
            XSMALL = SQRT (DY*DY + DX*DX*C1*C2)
            XX = SIN(DG2RAD*Y(1)) * SIN(DG2RAD*Y(2)) +
     *         COS(DG2RAD*Y(1)) * COS(DG2RAD*Y(2)) *
     *         COS(DG2RAD*(X(1)-X(2)))
            IF (DMAJ .LT. 0.1D0/3600.D0) THEN
               BMAJS = XSMALL*2.0D0
            ELSE
               BMAJS = 2. * RAD2DG * ACOS (XX)
               END IF
C                                       X,Y projection of minor semiaxis
C                                       in degrees
            DX = X(1)-X(3)
            DY = Y(1)-Y(3)
            DMIN = SQRT(DX*DX + DY*DY)
            C1 = COS(DG2RAD*Y(1))
            C2 = COS(DG2RAD*Y(3))
            YSMALL = SQRT (DY*DY + DX*DX*C1*C2)
            YY = SIN(DG2RAD*Y(1)) * SIN(DG2RAD*Y(3)) +
     *         COS(DG2RAD*Y(1)) * COS(DG2RAD*Y(3)) *
     *         COS(DG2RAD*(X(1)-X(3)))
            IF (DMIN .LT. 0.1D0/3600.D0) THEN
               BMINS = YSMALL*2.0D0
            ELSE
               BMINS = 2. * RAD2DG * ACOS (YY)
               END IF
            BPAS = ATAN2 ((X(2)-X(1)) * COS(Y(1)*DG2RAD),
     *         Y(2) - Y(1)) / DG2RAD
         ELSE
C                                       X => DECLINATION, Y => RA
C                                       X,Y projection of major semiaxis
C                                       in degrees
            DX = X(1)-X(2)
            DY = Y(1)-Y(2)
            DMAJ = SQRT(DX*DX + DY*DY)
            C1 = COS(DG2RAD*X(1))
            C2 = COS(DG2RAD*X(2))
            XSMALL = SQRT (DX*DX + DY*DY*C1*C2)
            XX = SIN(DG2RAD*X(1)) * SIN(DG2RAD*X(2)) +
     *         COS(DG2RAD*X(1)) * COS(DG2RAD*X(2)) *
     *         COS(DG2RAD*(Y(1)-Y(2)))
            IF (DMAJ .LT. 0.1D0/3600.D0) THEN
               BMAJS = XSMALL*2.0D0
            ELSE
               BMAJS = 2. * RAD2DG * ACOS (XX)
               END IF
C                                       X,Y projection of minor semiaxis
C                                       in degrees
            DX = X(1)-X(3)
            DY = Y(1)-Y(3)
            DMIN = SQRT(DX*DX + DY*DY)
            C1 = COS(DG2RAD*X(1))
            C2 = COS(DG2RAD*X(3))
            YSMALL = SQRT (DX*DX + DY*DY*C1*C2)
            YY = SIN(DG2RAD*X(1)) * SIN(DG2RAD*X(3)) +
     *         COS(DG2RAD*X(1)) * COS(DG2RAD*X(3)) *
     *         COS(DG2RAD*(Y(1)-Y(3)))
            IF (DMIN .LT. 0.1D0/3600.D0) THEN
               BMINS = YSMALL*2.0D0
            ELSE
               BMINS = 2. * RAD2DG * ACOS (YY)
               END IF
            BPAS = ATAN2 ((Y(2)-Y(1)) * COS(X(1)*DG2RAD),
     *         X(2) - X(1)) / DG2RAD
            END IF
C                                       sky to pixel:
      ELSE
         END IF
      GO TO 999
C
 990  WRITE (MSGTXT,1990) IERR, DIR
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1990 FORMAT ('GAUSPS: ERROR',I4,' CONVERTING ',A)
      END

      SUBROUTINE TABBP (OPCODE, BUFFER, IBPRNO, BPKOLS, BPNUMV, NUMIF,
     *   NUMFRQ, NUMPOL, TIME, INTERV, SOURID, SUBA, ANT, BANDW, CHSHFT,
     *   FREQID, REFANT, WEIGHT, BNDPAS, IERR)
C-----------------------------------------------------------------------
C! Does I/O to bandpass (BP) table opened by BPINI
C# EXT-util UV Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2013, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to bandpass (BP) extention tables. Usually used after
C   setup by BPINI.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'READ' = read entry from table.
C                        'WRIT' = write entry in table.
C                        'CLOS' = close file, flush on write
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open. Should have been returned by
C                        BPINI or TABINI.
C      IBPRNO   I        Next entry number to read or write.
C      BPKOLS   I(MAXBPC) The column pointer array in order,
C                        TIME, INTERVAL, SOURID,
C                        SUBARRAY, ANTENNA,
C                        BANDW (of individual channel), CHN_SHIFT,
C                        FREQID,
C                        REFANT1, WT1, REAL1, IMAG1, for all channels
C                        Following used if 2 polarizations per IF
C                        REFANT2, WT2, REAL2, IMAG2.
C      BPNUMV   I(MAXBPC) Element count in each column.
C      NUMIF    I        Number of IF's
C      NUMFRQ   I        Number of chns
C      NUMPOL   I        Number of polarizations per IF.
C   Input/output: (written to or read from baseline file)
C      TIME    D        Center time of record (Days)
C      INTERV  R        Time interval of record (Days)
C      SOURID  I        Source ID number.
C      SUBA    I        Subarray number.
C      ANT     I        Antenna number.
C      BANDW   R        Bandwidth of an individual channel (Hz)
C      CHSHFT  D(m)     Frequency shift for each IF.
C      FREQID  I        Freq. id number
C      REFANT  I(2)     Reference Antenna; one for each poln
C      WEIGHT  R(m,P  ) Weights for complex bandpass
C                       m IFS; p polns
C      BNDPAS  C(n,m,p) Complex bandpass: m IFS; n channels; p polns
C   Output:
C      IBPRNO    I      Next solution number.
C      IERR      I      Error code, 0=>OK else TABIO error.
C                       Note: -1=> read but all polzn #1 flagged
C                             -2=> read but all polzn #2 flagged
C                             -3=> both flagged
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER OPCODE*4
      INTEGER   BUFFER(*), IBPRNO, BPKOLS(MAXBPC), BPNUMV(MAXBPC),
     *   NUMIF, NUMFRQ, NUMPOL, SOURID, SUBA,  ANT, FREQID, REFANT(2),
     *   IERR
      DOUBLE PRECISION TIME, CHSHFT(MAXIF)
      REAL      INTERV, WEIGHT(*), BNDPAS(*), BANDW
C
      INTEGER   RECI(XBPRSZ), KOLS(MAXBPC), TIMKOL, SOUKOL, SUBKOL,
     *   ANTKL, INTKOL, BWKOL, CHSKOL, FRQKOL, REF1KL, REF2KL, RE1KL,
     *   IM1KL, RE2KL, IM2KL, LOOP, IFLP, NDATA, BDCNT1, BDCNT2, INDX,
     *   NNDX, WT1KL, WT2KL
      REAL      RECORD(XBPRSZ), WT
      DOUBLE PRECISION RECD(XBPRSZ/2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (KOLS(1), TIMKOL), (KOLS(2), INTKOL),
     *   (KOLS(3), SOUKOL), (KOLS(4), SUBKOL), (KOLS(5), ANTKL),
     *   (KOLS(6), BWKOL),  (KOLS(7), CHSKOL), (KOLS(8), FRQKOL),
     *   (KOLS(9), REF1KL), (KOLS(10), WT1KL),  (KOLS(11), RE1KL),
     *   (KOLS(12), IM1KL), (KOLS(13), REF2KL), (KOLS(14), WT2KL),
     *   (KOLS(15),RE2KL), (KOLS(16),IM2KL)
      SAVE RECORD
      EQUIVALENCE (RECD, RECORD, RECI)
C-----------------------------------------------------------------------
      BDCNT1 = 0
      BDCNT2 = 0
C                                       Close
      IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, IBPRNO, RECORD, BUFFER, IERR)
         IF (IERR.GT.0) GO TO 980
         GO TO 999
         END IF
C                                       Check sizes
      NNDX = NUMPOL * NUMFRQ * NUMIF
      IF (NNDX.GT.MAXCIF) THEN
         IERR = 1
         MSGTXT = 'TABBP: RECORDS TOO BIG FOR BUFFERS'
         GO TO 985
         END IF
      IF (NNDX.LE.0) THEN
         IERR = 1
         MSGTXT = 'TABBP: ZERO SIZE DATA REQUESTED'
         GO TO 985
         END IF
      IF (NUMPOL.GT.2) THEN
         IERR = 1
         MSGTXT = 'TABBP: > 2 POLARIZATIONS IN BANDPASS TABLE!'
         GO TO 985
         END IF
C                                       Set pointers
      NDATA = MAXBPC
      CALL COPY (NDATA, BPKOLS, KOLS)
      NNDX = NUMFRQ * NUMIF
C                                       If write fill RECORD
      IF (OPCODE.NE.'READ') THEN
         RECD(TIMKOL) = TIME
         RECORD(INTKOL) = INTERV
         RECI(SOUKOL) = SOURID
         RECI(SUBKOL) = SUBA
         RECI(ANTKL) = ANT
         RECORD(BWKOL) = BANDW
         DO 10 IFLP = 1, NUMIF
            RECD(CHSKOL) = CHSHFT(IFLP)
            CHSKOL = CHSKOL + 1
            IF (WT1KL.GT.0) THEN
               RECORD(WT1KL) = WEIGHT(IFLP)
               WT1KL = WT1KL + 1
               END IF
            IF (NUMPOL.GT.1) THEN
               IF (WT2KL.GT.0) THEN
                  RECORD(WT2KL) = WEIGHT(IFLP+NUMIF)
                  WT2KL = WT2KL + 1
                  END IF
               END IF
 10         CONTINUE
         IF (FRQKOL.GT.0) RECI(FRQKOL) = FREQID
         RECI(REF1KL) = REFANT(1)
C                                       First polarization
         INDX = 0
         DO 20 LOOP = 1,NNDX
            INDX = INDX + 1
            RECORD(RE1KL) = BNDPAS(INDX)
            INDX = INDX + 1
            RECORD(IM1KL) = BNDPAS(INDX)
            RE1KL = RE1KL + 1
            IM1KL = IM1KL + 1
 20         CONTINUE
C                                       Second polarization
         IF (NUMPOL.GT.1) THEN
            RECI(REF2KL) = REFANT(2)
            DO 30 LOOP = 1,NNDX
               INDX = INDX + 1
               RECORD(RE2KL) = BNDPAS(INDX)
               INDX = INDX + 1
               RECORD(IM2KL) = BNDPAS(INDX)
               RE2KL = RE2KL + 1
               IM2KL = IM2KL + 1
 30            CONTINUE
            END IF
         END IF
C                                       Process record.
      CALL TABIO (OPCODE, 0, IBPRNO, RECORD, BUFFER, IERR)
      IBPRNO = IBPRNO + 1
      IF (IERR.GT.0) GO TO 980
C                                       If READ pick data from RECORD.
      IF (OPCODE.EQ.'READ') THEN
         TIME   = RECD(TIMKOL)
         INTERV = RECORD(INTKOL)
         SOURID = RECI(SOUKOL)
         SUBA   = RECI(SUBKOL)
         ANT    = RECI(ANTKL)
         BANDW  = RECORD(BWKOL)
         WT = INTERV * 24. * 60. * 6.
         DO 70 IFLP = 1,NUMIF
            CHSHFT(IFLP) = RECD(CHSKOL)
            CHSKOL = CHSKOL + 1
            IF (WT1KL.GT.0) THEN
               WEIGHT(IFLP) = RECORD(WT1KL)
               WT1KL = WT1KL + 1
            ELSE
               WEIGHT(IFLP) = WT
               END IF
            IF (NUMPOL.GT.1) THEN
               IF (WT2KL.GT.0) THEN
                  WEIGHT(IFLP+NUMIF) = RECORD(WT2KL)
                  WT2KL = WT2KL + 1
               ELSE
                  WEIGHT(IFLP+NUMIF) = WT
                  END IF
               END IF
 70         CONTINUE
         IF (FRQKOL.LE.0) THEN
            FREQID = 1
         ELSE
            FREQID = RECI(FRQKOL)
            END IF
         REFANT(1) = RECI(REF1KL)
C                                       First polarization
         INDX = 0
         DO 80 LOOP = 1,NNDX
            INDX = INDX + 1
            BNDPAS(INDX) = RECORD(RE1KL)
            INDX = INDX + 1
            BNDPAS(INDX) = RECORD(IM1KL)
            IF ((RECORD(RE1KL).EQ.FBLANK) .OR.
     *         (RECORD(IM1KL).EQ.FBLANK)) BDCNT1 = BDCNT1 + 1
            RE1KL = RE1KL + 1
            IM1KL = IM1KL + 1
 80         CONTINUE
C                                       Second polarization
         IF (NUMPOL.GT.1) THEN
            REFANT(2) = RECI(REF2KL)
            DO 90 LOOP = 1,NNDX
               INDX = INDX + 1
               BNDPAS(INDX) = RECORD(RE2KL)
               INDX = INDX + 1
               BNDPAS(INDX) = RECORD(IM2KL)
               IF ((RECORD(RE2KL).EQ.FBLANK) .OR.
     *             (RECORD(IM2KL).EQ.FBLANK)) BDCNT2 = BDCNT2 + 1
               RE2KL = RE2KL + 1
               IM2KL = IM2KL + 1
 90            CONTINUE
            END IF
         END IF
      IF (BDCNT1.EQ.(NUMIF*NUMFRQ)) IERR = -1
      IF (BDCNT2.EQ.(NUMIF*NUMFRQ)) IERR = -2
      IF ((BDCNT1.EQ.(NUMIF*NUMFRQ)) .AND.
     *   (BDCNT2.EQ.(NUMIF*NUMFRQ))) IERR = -3
      GO TO 999
C                                       Error
 980  WRITE (MSGTXT,1980) IERR
C
 985  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('TABBP: TABIO ERROR',I3)
      END

      SUBROUTINE GSCRED (MXSTAR, IVOL, CNO, VERS, NSTAR, GSCIDS, RADEGS,
     *   DECDGS, MAGS, IERR)
C-----------------------------------------------------------------------
C! reads a UK (guide star table) and fills arrays of coordinates
C# Table-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GSCRED reads the star positions in a UK table which is assumed to be
C   a Guide star catalog table. The UK file contains the center
C   position (RA-DEC (J2000) position error, magnitude,  and other info
C   for several million stars.
C   Inputs:
C      MXSTAR  I         Maximum number of stars to read from table
C      VERS    I         Desired UK file version number: 0 => high
C      IVOL    I         File disk number
C      CNO     I         File catalog number
C   Output:
C      NSTAR   I         Number of stars read from UK table
C      GSCIDS  R(MXSTAR) Guide Star ID number for each star
C      RADEGS  R(MXSTAR) Guide Star RA in DEG (J2000) for each star
C      DECDGS  R(MXSTAR) Guide Star DEC in DEG (J2000) for each star
C      MAGS    R(MXSTAR) Guide Star Magnitude for each star
C      IERR    I         Error code: 0 => okay
C                                -1 => there was no UK file
C                                +1 => logical error in UK file
C                                +2 => IO error in UK file
C                                +3 => IO error in plotting
C   Common:
C      /MAPHDR/ CATBLK input   Image header having the UK file
C-----------------------------------------------------------------------
      INTEGER   MXSTAR, VERS, IVOL, CNO, NSTAR, IERR
      REAL      GSCIDS(*), RADEGS(*), DECDGS(*), MAGS(*)
C                                       Max Numb Columns, Label length
      INTEGER MXUKCL
      PARAMETER (MXUKCL=20)
      CHARACTER KEYS(MXUKCL)*8
      HOLLERITH CATH(256)
      INTEGER   IOBUF(768), CATBLK(256), IV, I, NKEY, NCOL, NREC, NUK,
     *   TABLUN, KOLS(MXUKCL), IER, ITYPE, SCRTCH(50), IUK, GSCID, LRNO,
     *   ITEMP
      REAL      CATR(256), RADEG, DECDEG, POSERR, MAG, RTEMP
      LOGICAL   LORDER
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (ITEMP, RTEMP)
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK, CATH, CATR)
      DATA TABLUN /27/
      DATA LORDER /.TRUE./
C-----------------------------------------------------------------------
C                                       Is there an UK file
      IERR = -1
      CALL FNDEXT ('UK', CATBLK, I)
      IF (I.LE.0) GO TO 999
      IV = VERS
      IF ((IV.LE.0) .OR. (IV.GT.I)) IV = I
C                                       Open UK table file
      NKEY = 0
      NCOL = 0
      NREC = 0
      CALL TABINI ('READ', 'UK', IVOL, CNO, IV, CATBLK, TABLUN, NKEY,
     *   NREC, NCOL, IOBUF(513), IOBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, IV
         GO TO 990
         END IF
C                                       Read no more than fit in array
      NUK = MIN (IOBUF(5), MXSTAR)
C                                       Find needed columns
      KEYS(1) = 'GSC_ID'
      KEYS(2) = 'RA_DEG'
      KEYS(3) = 'DEC_DEG'
      KEYS(4) = 'POS_ERR'
      KEYS(5) = 'MAG'
      NCOL    = 5
      CALL FNDCOL (NCOL, KEYS, 8, LORDER, IOBUF, KOLS, IER)
      IF (IER.GT.0) THEN
         IF (IER.LE.10) GO TO 975
            IERR = 1
            MSGTXT = '!!!  CAN NOT FIND COLUMNS IN TABLE  !!!'
            CALL MSGWRT(5)
            MSGTXT = '??? Is this a Guide Star (UK) Table ???'
            GO TO 980
         END IF
C                                       I guess we can do it now
      NSTAR = 0
C                                       For all rows in the table
      LRNO = 0
      DO 100 IUK = 1,NUK
         CALL GETCOL (IUK, KOLS(1), IOBUF(513), LRNO, IOBUF, ITYPE,
     *      RTEMP, SCRTCH, IER)
         GSCID = ITEMP
         IF (IER.LT.0) GO TO 100
         IF (IER.NE.0) GO TO 975
         CALL GETCOL (IUK, KOLS(2), IOBUF(513), LRNO, IOBUF, ITYPE,
     *      RADEG, SCRTCH, IER)
         IF (IER.NE.0) GO TO 975
         CALL GETCOL (IUK, KOLS(3), IOBUF(513), LRNO, IOBUF, ITYPE,
     *      DECDEG, SCRTCH, IER)
         IF (IER.NE.0) GO TO 975
         CALL GETCOL (IUK, KOLS(4), IOBUF(513), LRNO, IOBUF, ITYPE,
     *      POSERR, SCRTCH, IER)
         IF (IER.NE.0) GO TO 975
         IF (NCOL.GT.4) THEN
            CALL GETCOL (IUK, KOLS(5), IOBUF(513), LRNO, IOBUF, ITYPE,
     *         MAG, SCRTCH, IER)
            IF (IER.NE.0) GO TO 975
            END IF
         NSTAR = NSTAR + 1
         GSCIDS(NSTAR) = GSCID
         RADEGS(NSTAR) = RADEG
         DECDGS(NSTAR) = DECDEG
         MAGS(NSTAR)   = MAG
 100     CONTINUE
      IERR = 0
      WRITE (MSGTXT,1100) NSTAR, IV
      CALL MSGWRT (2)
      GO TO 985
C                                       Error print and close
 975  WRITE (MSGTXT,1975) IER
      IERR = 2
 980  CALL MSGWRT (8)
 985  CALL TABIO ('CLOS', 0, IUK, SCRTCH, IOBUF, IER)
      GO TO 999
C                                       Error print
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I6,' OPENING UK FILE VERSION',I4)
 1100 FORMAT ('Read ',I6,' Positions from UK table version',I4)
 1975 FORMAT ('I/O ERROR',I5,' IN UK TABLE FILE')
      END

      SUBROUTINE GETSTN (IND2, STNNAM, NSTNS, JERR)
C-----------------------------------------------------------------------
C! Reads the VLB station list opened in VBLIN and VBCIT
C# UV Obselete
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   GETSTN reads the VLB station list opened in VBLIN and VBCIT
C   on the file specified by FIL2NAME.
C   J. M. Benson    March 1983
C-----------------------------------------------------------------------
      CHARACTER STNNAM(*)*8, STATN*8
      INTEGER   IND2, NSTNS, JERR, ICNT(50), NSTRT, I, NSTOP, K
      INCLUDE 'INCS:DMSG.INC'
      DATA NSTRT /-4/
C-----------------------------------------------------------------------
      JERR = 0
      NSTNS= 0
      DO 10 I = 1,50
         ICNT(I) = I
 10      CONTINUE
C                                       Read a card in the stations
C                                       list file.
 100  READ (IND2,1000,ERR=120,END=200) STATN
      IF (STATN.EQ.'        ') GO TO 100
      NSTNS = NSTNS + 1
      IF (NSTNS.LE.50) GO TO 110
         WRITE (MSGTXT,1001) NSTNS
         CALL MSGWRT (8)
         JERR = 1
         GO TO 999
 110  STNNAM(NSTNS) = STATN
      GO TO 100
C
 120  CONTINUE
      WRITE (MSGTXT,1200)
      CALL MSGWRT (8)
      JERR = 1
      GO TO 999
C
 200  CONTINUE
      WRITE (MSGTXT,2000) NSTNS
      CALL MSGWRT (8)
      IF (NSTNS.GE.0) GO TO 210
         JERR = 1
         GO TO 999
 210  NSTRT = NSTRT + 5
      NSTOP = NSTRT + 4
      WRITE (MSGTXT,2100) (ICNT(K),STNNAM(K), K=NSTRT,NSTOP)
      CALL MSGWRT (8)
      IF (NSTNS.GT.NSTOP) GO TO 210
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A8)
 1001 FORMAT (I3,' STATIONS IN IN2FILE EXCEEDS VBLIN LIMIT OF 50')
 1200 FORMAT ('GETSTN: READ ERROR IN IN2FILE')
 2000 FORMAT (I3,' VLB stations to AIPS ant extension file')
 2100 FORMAT (5(I2,':',A8))
      END

C   Table Class module
C-----------------------------------------------------------------------
C! Object Oriented AIPS Fortran "TABLE" class library
C# Ext-util Utility Object-Oriented
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999, 2011, 2015, 2019, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Most table access is through TABGET and TABPUT  but rapid access to
C   row data is possible through TABDGT and TABDPT.
C
C   Class public members:
C     NAME      C*12     Catalog file name
C     CLASS     C*6      Catalog file class
C     SEQ       I        Catalog file sequence number
C     DISK      I        Disk number
C     TBLTYPE   C*2      Table type
C     VER       I        Version number
C   The following must be set before a new table is opened and are
C   unavailable before an existing table is opened.
C   state:
C     LABEL     C*56     Table label
C     NCOL      I        Number of columns
C     COLABEL   C(*)*24  Column labels
C     COLUNIT   C(*)*8   Column units
C     COLTYPE   I(*)     Column data type: 1=double, 2=real,
C                        3=character, 4=integer, 5=logical, 7=bit
C                        arrays.
C     COLDIM    I(*)     Column dimension.
C   The following are available only when the table is open.
C     NROW      I        Number of rows
C     SORT      I(2)     Sort order
C     CURROW    I        Current row number, if negative it has not yet
C                        been read.
C     ENTRY.nn  ?(?)     table entry for column number nn
C     KEY.xxxx  ?        table keyword/value pair for keyword xxxx
C
C   Class private members:
C     TBNCOL    I(MAXIO)      Number of columns, per I/O stream.
C     TBCROW    I(MAXIO)      Current row number, per I/O stream.
C     TBTYPE    I(128,MAXIO)  Column type codes, one set per I/O stream
C     TBDIM     I(128,MAXIO)  Column element count
C     TBPTR     I(128,MAXIO)  Column pointer to first element in array
C                             of type.
C     RECORD    I(2048,MAXIO) Record buffer per I/O stream.
C                             Equivalenced to RECR, RECD, RECH and, RECL
C                             for real, double, Hollerith and logical.
C
C   Public functions:
C     TABCRE (name, iret)
C        Creates a table object.
C     TABDES (name, ierr)
C        Destroys the table object with name "name"; quasi-permanent
C        forms are unaffected.
C     TABZAP (name, ierr)
C        Destroys the table object with name "name"; quasi-permanent
C        forms are deleted.
C     TABRMV (name, ierr)
C        Removes any underlying AIPS files leaves object intact.
C     TBCOPY (namein, namout, ierr)
C        Copys one object to another.  The same quasi permanent forms
C        are used for both.
C     TBLCOP (namein, namout, ierr)
C        Copys contents of one table object to another.  (Standard AIPS
C        TABCOP)
C     TABCLN (namein, namout, ierr)
C        CLONES an object.  A new table is created.
C     TABOPN (name, status, ierr)
C        Opens a table for access.
C     TABCLO (name, ierr)
C        Closes a table for access.
C     TABCOL (name, ncol, colab, colnum, ierr)
C        Returns column numbers for a list of column labels.
C     TABGET (name, keywrd, type, dim, value, valuec, ierr)
C        Fetches table member
C     TABPUT (name, keywrd, type, dim, value, valuec, ierr)
C        Stores table member
C     TABDGT (name, row, col, type, dim, value, valuec, ierr)
C        Fetches table row data
C     TABDPT (name, row, col, type, dim, value, valuec, ierr)
C        Stores table row data
C     TABKGT (name, keys, nkeys, klocs, kvals, ktype, ierr)
C        Fetches values of specified table keywords.  If keys(1) is
C        blank then all keywords up to a maximum of nkeys is read.  On
C        return nkeys is the number read.
C     TABKPT (name, keys, nkeys, klocs, kvals, ktype, ierr)
C        Stores values of specified table keywords.
C     TBLSRT (name, key1, key2, ierr)
C        Sorts a table using a 2 key sort.
C     TBLMRG (name, mkol, toler, skol, nskol, srtkol, ierr)
C        Merge a table.
C     TABEXI (name, exists, ierr)
C        Check whether the table exists.
C
C   Private functions:
C     TBLMEM (keywrd, mem, arg, local, ierr)
C        Parses keyword into components
C     TBLKUP (name, tdisk, tcno, ttype, tver, ierr)
C        Looks up information about table object.
C     TBLHIV (name, nver, ierr)
C        Returns highest table version number.
C-----------------------------------------------------------------------
LOCAL INCLUDE 'TABLE.INC'
C                                       Table class
      INTEGER   NMEM
C                                       NMEM = .no. base classes.
      PARAMETER (NMEM = 5)
      CHARACTER LMEM(NMEM)*8, THSCLS*16
      DATA LMEM /'CURROW', 'KEY', 'ENTRY', 'NROW', 'SORT'/
      DATA THSCLS /'TABLE'/
LOCAL END
LOCAL INCLUDE 'TABGFORT'
      INTEGER   IDUM(128)
      REAL      RDUM(128)
      LOGICAL   LDUM(128)
      DOUBLE PRECISION DDUM(64)
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
      COMMON /TAFORT/ DDUM
LOCAL END
LOCAL INCLUDE 'TABLEIO.INC'
C                                       Table class I/O
C                                       Requires OBJPARM.INC,CLASSIO.INC
C                                       table control block last 512 of
C                                       each OBUFFR
      INTEGER   TBNCOL(MAXIO), TBCROW(MAXIO), TBTYPE(128,MAXIO),
     *   TBDIM(128,MAXIO), TBPRT(128,MAXIO), RECORD(BUFSIZ,MAXIO),
     *   IBUFFR(BUFSIZ,MAXIO)
C                                       Have to address double in real
C                                       array and copy.
      REAL      RECR(BUFSIZ,MAXIO), RECD(BUFSIZ,MAXIO)
      HOLLERITH RECH(BUFSIZ,MAXIO)
      LOGICAL   RECL(BUFSIZ,MAXIO)
      CHARACTER TABSTR*(MAXSIZ/2)
      COMMON /TBLIOC/ TBNCOL, TBCROW, TBTYPE, TBDIM, TBPRT
      COMMON /TBLCOC/ TABSTR
      EQUIVALENCE (OBUFFR, IBUFFR, RECORD, RECR, RECD, RECH, RECL)
LOCAL END
      SUBROUTINE TABCRE (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Creates an table object with name "name"
C   Simple return if object exists.
C   Inputs:
C      NAME  C*?   The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INTEGER   OBJNUM, MSGSAV
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Does it exist already?
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL OBNAME (NAME, OBJNUM, IERR)
      MSGSUP = MSGSAV
      IF (IERR.EQ.0) GO TO 999
C                                       Create AIPS object
      CALL OBCREA (NAME, 'TABLE', IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE TABDES (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Destroys the table object with name "name"; quasi-permanent forms
C   are unaffected.
C   Inputs:
C      NAME  C*32  The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
C-----------------------------------------------------------------------
      IERR = 0
C                                       Destroy object
      CALL OBFREE (NAME, IERR)
C
 999  RETURN
      END
      SUBROUTINE TABZAP (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Destroys the table object with name "name"; quasi-permanent forms
C   are deleted.
C   Inputs:
C      NAME  C*32  The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INTEGER   TCNO, TDISK, TVER
      CHARACTER TTYPE*2, FNAME*48, STAT*4
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Look up table
      CALL TBLKUP (NAME, TDISK, TCNO, TTYPE, TVER, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Destroy table
      CALL ZPHFIL (TTYPE, TDISK, TCNO, TVER, FNAME, IERR)
      CALL ZDESTR (TDISK, FNAME, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Remove from AIPS catalog entry
      STAT = 'WRWR'
      CALL DELEXT (TTYPE, TDISK, TCNO, STAT, SBUFF, SBUFF(257), TVER,
     *   IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.3)) GO TO 999
C                                       Destroy object
      CALL TABDES (NAME, IERR)
C
 999  RETURN
      END
      SUBROUTINE TABRMV (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Removed any underlying AIPS files but leaves the object intact.
C   If VER = 0 then the highest numbered table is deleted.
C   If VER < 0 then all versions are deleted.
C   Inputs:
C      NAME  C*32  The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INTEGER   TCNO, TDISK, TVER, NVER, IVER, LOWVER, HIVER
      LOGICAL   EXIST
      CHARACTER TTYPE*2, FNAME*48, STAT*4
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Look up table
      CALL TBLKUP (NAME, TDISK, TCNO, TTYPE, TVER, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Highest version number?
      CALL TBLHIV (NAME, NVER, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Specific table?
      IF (TVER.GT.0) THEN
C                                       Does it exist?
         CALL OBFEXS (NAME, EXIST, IERR)
         IERR = 0
         IF (.NOT.EXIST) GO TO 999
         LOWVER = TVER
         HIVER = TVER
C                                       Highest
      ELSE IF (TVER.EQ.0) THEN
         LOWVER = MAX (NVER, 1)
         HIVER = NVER
C                                       All
      ELSE
         LOWVER = 1
         HIVER = NVER
         END IF
C                                       Loop as necessary deleting tables
      DO 100 IVER = LOWVER, HIVER
C                                       Destroy table
         CALL ZPHFIL (TTYPE, TDISK, TCNO, IVER, FNAME, IERR)
         CALL ZDESTR (TDISK, FNAME, IERR)
         IF (IERR.GT.1) THEN
            IERR = 0
            GO TO 100
            END IF
         IERR = 0
C                                       Remove from AIPS catalog entry
         STAT = 'WRWR'
         CALL DELEXT (TTYPE, TDISK, TCNO, STAT, SBUFF, SBUFF(257), IVER,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE TBCOPY (NAMEIN, NAMOUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Copys one object to another.  The same quasi permanent forms are
C   used for both.  Only copies relevant naming info.
C   Inputs:
C      NAMEIN  C*?   The name of the input object.
C      NAMOUT  C*?   The name of the output object.
C   Output:
C      IERR    I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAMEIN*(*), NAMOUT*(*)
      INTEGER   IERR
C
      INTEGER   OBJIN, OBJOUT, TYPE, DIM(3)
      CHARACTER TNAME*12, TCLASS*6, TTYPE*2, CDUMMY*1
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'TABGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Create output
      CALL TABCRE (NAMOUT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Find object numbers
      CALL OBNAME (NAMEIN, OBJIN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBNAME (NAMOUT, OBJOUT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy relevant info
      CALL OBGET (OBJIN, 'NAME', TYPE, DIM, IDUM, TNAME, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBPUT (OBJOUT, 'NAME', OOACAR, DIM, IDUM, TNAME, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBGET (OBJIN, 'CLASS', TYPE, DIM, IDUM, TCLASS, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBPUT (OBJOUT, 'CLASS', OOACAR, DIM, IDUM, TCLASS, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBGET (OBJIN, 'IMSEQ', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBPUT (OBJOUT, 'IMSEQ', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBGET (OBJIN, 'DISK', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBPUT (OBJOUT, 'DISK', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBGET (OBJIN, 'TBLTYPE', TYPE, DIM, IDUM, TTYPE, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBPUT (OBJOUT, 'TBLTYPE', OOACAR, DIM, IDUM, TTYPE, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBGET (OBJIN, 'VER', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBPUT (OBJOUT, 'VER', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE TBLCOP (NAMEIN, NAMOUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Copys the contents of one table object to another.
C   Destroys any previous version of the underlying files of NAMOUT.
C   Note: no error is returned if input table does not  exist.
C   Inputs:
C      NAMEIN  C*?   The name of the input object.
C      NAMOUT  C*?   The name of the output object.
C   Output:
C      IERR    I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAMEIN*(*), NAMOUT*(*)
      INTEGER   IERR
C
      INTEGER   LUNI, LUNO, DISKI, DISKO, CNOI, CNOO, BUFIN, BUFOUT,
     *   VERI, VERO
      LOGICAL   EXIST
      CHARACTER TBTYPE*2
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Open object for buffer
      CALL OBOPEN (NAMEIN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBOPEN (NAMOUT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get buffer number
      CALL OBINFO (NAMEIN, BUFIN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBINFO (NAMOUT, BUFOUT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get other info
      CALL TBLKUP (NAMEIN, DISKI, CNOI, TBTYPE, VERI, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TBLKUP (NAMOUT, DISKO, CNOO, TBTYPE, VERO, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Make sure output does not exist
      CALL OBFEXS (NAMOUT, EXIST, IERR)
      IERR = 0
      IF (EXIST) THEN
         CALL TABRMV (NAMOUT, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Catalog header
      CALL OBHGET (NAMOUT, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Assign LUNs
      CALL OBLUN (LUNI, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBLUN (LUNO, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy table
      CALL TABCOP (TBTYPE, VERI, VERO, LUNI, LUNO, DISKI, DISKO, CNOI,
     *   CNOO, CATBLK, OBUFFR(1,BUFIN), OBUFFR(1,BUFOUT), IERR)
C                                       OK if no input files
      IF (IERR.EQ.2) IERR = 0
      IF (IERR.NE.0) GO TO 999
C                                       Save catalog header
      CALL OBHPUT (NAMOUT, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Close object
      CALL OBCLOS (NAMEIN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBCLOS (NAMOUT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Free LUN
      CALL OBLUFR (LUNI)
      IF (IERR.NE.0) GO TO 999
      CALL OBLUFR (LUNO)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE TABCLN (NAMEIN, NAMOUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Clones an table object.  The output name, class, seq, disk, ver are
C   given by the keywords OUTNAME, OUTCLASS, OUTSEQ, OUTDISK, OUTVER.
C   Inputs:
C      NAMEIN  C*?   The name of the input object.
C      NAMOUT  C*?   The name of the output object.
C   Output:
C      IERR    I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAMEIN*(*), NAMOUT*(*)
      INTEGER   IERR
C
      INTEGER   TYPE, DIM(7), OBJNUM
      CHARACTER TNAME*12, TCLASS*6, CDUMMY*1
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'TABGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Open and close input table to be
C                                       sure that all info there.
      CALL TABOPN (NAMEIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TABCLO (NAMEIN, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy Object
      CALL TBCOPY (NAMEIN, NAMOUT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Find object number
      CALL OBNAME (NAMOUT, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Update name etc.
      CALL OBGET (OBJNUM, 'OUTNAME', TYPE, DIM, IDUM, TNAME, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBPUT (OBJNUM, 'NAME', OOACAR, DIM, IDUM, TNAME, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBGET (OBJNUM, 'OUTCLASS', TYPE, DIM, IDUM, TCLASS, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBPUT (OBJNUM, 'CLASS', OOACAR, DIM, IDUM, TCLASS, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBGET (OBJNUM, 'OUTSEQ', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBPUT (OBJNUM, 'IMSEQ', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBGET (OBJNUM, 'OUTDISK', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBPUT (OBJNUM, 'DISK', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBGET (OBJNUM, 'OUTVER', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBPUT (OBJNUM, 'VER', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open and close input table to
C                                       force table creation.
      CALL TABOPN (NAMOUT, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TABCLO (NAMOUT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy table
C
 999  RETURN
      END
      SUBROUTINE TABOPN (NAME, STATUS, IERR)
C-----------------------------------------------------------------------
C   Public
C   Sets up to open a table file.  Obtains header info etc.
C   Inputs:
C      NAME   C*32  The name of the object.
C      STATUS C*4   'READ', 'WRIT' (mixed reads and writes)
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), STATUS*4
      INTEGER   IERR
C
      INTEGER   TDISK, TCNO, TVER, LUN, BUFNO, DATP(128,2), LOOP, NKEY,
     *   NCOL, NREC, OFF, POINT, TYPE, DIM(7)
      LOGICAL   TABLE, EXIST, FITASC
      HOLLERITH HTEMP(6)
      CHARACTER TTYPE*2, STAT*4, CDUMMY*1
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'TABLEIO.INC'
      INCLUDE 'TABGFORT'
C-----------------------------------------------------------------------
      IERR = 0
      OFF = BUFSIZ - 511
C                                       Look up table
      CALL TBLKUP (NAME, TDISK, TCNO, TTYPE, TVER, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Does it exist?
      CALL OBLUN (LUN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ISTAB (TTYPE, TDISK, TCNO, TVER, LUN, SBUFF, TABLE, EXIST,
     *   FITASC, IERR)
      EXIST = EXIST .AND. (IERR.EQ.0)
      IERR = 0
C                                       If TVER=0 then hope for the best
      IF (TVER.LE.0) THEN
         EXIST = STATUS.EQ.'READ'
         TABLE = .TRUE.
         END IF
C                                       Table must exist for read
      IF ((.NOT.EXIST) .AND. (STATUS.EQ.'READ')) THEN
         IERR = 2
         WRITE (MSGTXT,1000) TTYPE, TVER
         GO TO 990
         END IF
C                                       Error if it is not a table file
      IF (.NOT.TABLE) THEN
         IERR = 2
         WRITE (MSGTXT,1001) TTYPE, TVER
         GO TO 990
         END IF
C                                       Setup for TABINI call
C                                       Get CATBLK
      STAT = 'REST'
      CALL CATIO ('READ', TDISK, TCNO, CATBLK, STAT, SBUFF, IERR)
      IF ((IERR.GE.1) .AND. (IERR.LE.4)) THEN
         WRITE (MSGTXT,1002) IERR
         GO TO 990
         END IF
      IERR = 0
C                                       Open object
      CALL OBOPEN (NAME, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get buffer number
      CALL OBINFO (NAME, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Writing new table?
      IF ((.NOT.EXIST) .AND. (STATUS.EQ.'WRIT')) THEN
C                                       Default 20 keywords
         NKEY = 20
         NREC = 100
C                                       Number of columns
         CALL TABGET (NAME, 'NCOL', TYPE, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
         NCOL = IDUM(1)
C                                       Element count
         CALL TABGET (NAME, 'COLTYPE', TYPE, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL COPY (DIM(1), IDUM, TBTYPE(1,BUFNO))
C                                       Type
         CALL TABGET (NAME, 'COLDIM', TYPE, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL COPY (DIM(1), IDUM, TBDIM(1,BUFNO))
C                                       Fill DATP
         DO 100 LOOP = 1,NCOL
            DATP(LOOP,2) = TBTYPE(LOOP,BUFNO) + 10 * TBDIM(LOOP,BUFNO)
 100        CONTINUE
      ELSE
C                                       Existing table
         NKEY = 0
         NREC = 0
         NCOL = 0
         END IF
C                                       Call TABINI to create/open
      CALL TABINI (STATUS, TTYPE, TDISK, TCNO, TVER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, OBUFFR(OFF,BUFNO), IERR)
      IF (IERR.GT.0) GO TO 999
C                                       If just created fill in info.
      IF (IERR.LT.0) THEN
         IERR = 0
C                                       Table name
         CALL TABGET (NAME, 'LABEL', TYPE, DIM, IDUM, TABSTR, IERR)
         IF (IERR.NE.0) GO TO 999
         DIM(1) = 56
         CALL CHR2H (DIM, TABSTR, 1, OBUFFR(OFF+100,BUFNO))
C                                       Column labels
         CALL TABGET (NAME, 'COLABEL', TYPE, DIM, IDUM, TABSTR, IERR)
         IF (IERR.NE.0) GO TO 999
         DO 120 LOOP = 1,NCOL
            POINT = (LOOP-1) * DIM(1) + 1
            CALL CHR2H (DIM, TABSTR(POINT:POINT+DIM(1)-1), 1, HTEMP)
            CALL TABIO ('WRIT', 3, LOOP, HTEMP, IBUFFR(OFF,BUFNO), IERR)
            IF (IERR.NE.0) GO TO 990
 120        CONTINUE
C                                       Column Units
         CALL TABGET (NAME, 'COLUNIT', TYPE, DIM, IDUM, TABSTR, IERR)
         IF (IERR.NE.0) GO TO 999
         DO 140 LOOP = 1,NCOL
            POINT = (LOOP-1) *DIM(1) + 1
            CALL CHR2H (DIM, TABSTR(POINT:POINT+DIM(1)-1), 1, HTEMP)
            CALL TABIO ('WRIT', 4, LOOP, HTEMP, IBUFFR(OFF,BUFNO), IERR)
            IF (IERR.NE.0) GO TO 990
 140        CONTINUE
         END IF
C                                       Save CATBLK
      CALL OBHPUT (NAME, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Save local information.
C                                       Save disk, ver in case defaults
C                                       passed.
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      IDUM(1) = TDISK
      CALL TABPUT (NAME, 'DISK', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IDUM(1) = TVER
      CALL TABPUT (NAME, 'VER', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Interprete DATP
      DO 200 LOOP = 1,NCOL
         TBPRT(LOOP,BUFNO) = DATP(LOOP,1)
         TBDIM(LOOP,BUFNO) = DATP(LOOP,2) / 10
         TBTYPE(LOOP,BUFNO) = DATP(LOOP,2) - TBDIM(LOOP,BUFNO) * 10
 200     CONTINUE
C                                       Number of columns
      DIM(1) = 1
      DIM(2) = 1
      IDUM(1) = NCOL
      CALL TABPUT (NAME, 'NCOL', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      TBNCOL(BUFNO) = NCOL
C                                       Current row
      TBCROW(BUFNO) = -1
C                                       Element count
      DIM(1) = NCOL
      CALL COPY (NCOL, TBTYPE(1,BUFNO), IDUM)
      CALL TABPUT (NAME, 'COLTYPE', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Type
      CALL COPY (NCOL, TBDIM(1,BUFNO), IDUM)
      CALL TABPUT (NAME, 'COLDIM', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Table name
      DIM(1) = 56
      TYPE = 3
      CALL H2CHR (DIM(1), 1, OBUFFR(OFF+100,BUFNO), TABSTR)
      CALL TABPUT (NAME, 'LABEL', OOACAR, DIM, IDUM, TABSTR, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Column labels
      DIM(1) = 24
      DIM(2) = NCOL
      DIM(3) = 0
      TABSTR = '  '
      DO 220 LOOP = 1,NCOL
         POINT = (LOOP-1) * DIM(1) + 1
         CALL TABIO ('READ', 3, LOOP, HTEMP, IBUFFR(OFF,BUFNO), IERR)
         IF (IERR.NE.0) GO TO 990
         CALL H2CHR (DIM, 1, HTEMP, TABSTR(POINT:POINT+DIM(1)-1))
 220     CONTINUE
      CALL TABPUT (NAME, 'COLABEL', OOACAR, DIM, IDUM, TABSTR, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Column Units
      DIM(1) = 8
      TABSTR = '  '
      DO 240 LOOP = 1,NCOL
         POINT = (LOOP-1) * DIM(1) + 1
         CALL TABIO ('READ', 4, LOOP, HTEMP, IBUFFR(OFF,BUFNO), IERR)
         IF (IERR.NE.0) GO TO 990
         CALL H2CHR (DIM, 1, HTEMP, TABSTR(POINT:POINT+DIM(1)-1))
 240     CONTINUE
      CALL TABPUT (NAME, 'COLUNIT', OOACAR, DIM, IDUM, TABSTR, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Remove LUN from reserved list
      CALL OBLUFR (LUN)
      GO TO 999
C                                       Error
 990     CALL MSGWRT (7)
         MSGTXT = 'PROBLEM OPENING TABLE OBJECT: ' // NAME
         CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TABLE TYPE ',A,' VERSION ', I3,' DOES NOT EXIST')
 1001 FORMAT ('EXTENSION TYPE ',A,' VERSION ', I3,' IS NOT A TABLE')
 1002 FORMAT ('ERROR ',I3,' READING CATBLK')
      END
      SUBROUTINE TABCLO (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Closes table updating disk resident information.
C   Inputs:
C      NAME  C*?   The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INTEGER   BUFNO, OFF
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'TABLEIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
      OFF = BUFSIZ - 511
C                                       Get buffer number
      CALL OBINFO (NAME, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Write old record if necessary
      IF ((IBUFFR(OFF+70,BUFNO).EQ.2) .AND. (TBCROW(BUFNO).GT.0)) THEN
         CALL TABIO ('WRIT', 0, TBCROW(BUFNO), RECR(1,BUFNO),
     *      IBUFFR(OFF,BUFNO), IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
C                                       Close table
      CALL TABIO ('CLOS', 0, TBCROW(BUFNO), RECR(1,BUFNO),
     *   IBUFFR(OFF,BUFNO), IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Close object
      CALL OBCLOS (NAME, IERR)
      IF (IERR.NE.0) GO TO 900
      GO TO 999
C                                       Error
 900  MSGTXT = 'TABCLO: ERROR CLOSING ' // NAME
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE TABCOL (NAME, NCOL, COLAB, COLNUM, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Looks up column numbers.  This routine calls FNDCOL which is rather
C   dangerous,  Do not call after starting I/O to the table.
C   Inputs:
C      NAME     C*?   The name of the object.
C      NCOL     I     The number of columns
C      COLAB    C(?)*? Column labels will check the number of characters
C                      passed.
C   Outputs:
C      COLNUM   I(*)  column numbers
C      IERR     I     Error return code, 0=OK, else FNDCOL errors
C-----------------------------------------------------------------------
      INTEGER   NCOL, COLNUM(NCOL), IERR
      CHARACTER NAME*(*), COLAB(NCOL)*(*)
C
      INTEGER   NCHK, OFF, BUFNO
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'TABLEIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
      OFF = BUFSIZ - 511
C                                       Number of characters to check.
      NCHK = LEN (COLAB(1))
C                                       Get buffer number
      CALL OBINFO (NAME, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Table open?
      IF (BUFNO.LE.0) THEN
         MSGTXT = NAME // ' TABLE IS NOT OPEN'
         CALL MSGWRT (6)
         IERR = 5
         GO TO 999
         END IF
C                                       Look up numbers
      CALL FNDCOL (NCOL, COLAB, NCHK, .TRUE., IBUFFR(OFF,BUFNO), COLNUM,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE TABPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Stores a table member.
C   Inputs:
C      NAME     C*?   The name of the object.
C      KEYWRD   C*?   The name of the keyword in form 'MEM1.MEM2...'
C      TYPE     I     Data type of VALUE: 1=double, 2=real,
C                        3=character, 4=integer, 5=logical, 7=bit
C                        arrays.
C      DIM      I(*)  Dimensionality of value, an axis dimension of zero
C                     means that that dimension and higher are
C                     undefined.
C      VALUE    ?(*)  The value associated with keyword.
C      VALUEC   C*(*) Character value associated with keyword.
C   Outputs:
C      IERR     I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC(*)*(*)
      INTEGER   TYPE, DIM(*), VALUE(*), IERR
C
      INTEGER   OBJNUM, KEYVAL(2), NKEY, LOCS(1), COL, ROW, OFF, BUFNO,
     *   IDUM(2), TYPES(1)
      CHARACTER MEM*8, ARG*8
      LOGICAL LOCAL, KEYVL(2)
      HOLLERITH KEYVH(2)
      REAL      KEYVR(2)
      DOUBLE PRECISION KEYVD
      EQUIVALENCE (KEYVAL, KEYVR, KEYVH, KEYVL, KEYVD)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'TABLEIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
      OFF = BUFSIZ - 511
C                                       Look for base class.member name
C                                       in KEYWRD.
      CALL TBLMEM (KEYWRD, MEM, ARG, LOCAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Deal with keywrd here?
      IF (LOCAL) THEN
C                                       Get buffer number
         CALL OBINFO (NAME, BUFNO, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Table open?
         IF (BUFNO.LE.0) THEN
            MSGTXT = NAME // ' TABLE IS NOT OPEN'
            CALL MSGWRT (6)
            IERR = 5
            GO TO 999
            END IF
C                                       Number of columns
C                                       Current row number
         IF (MEM.EQ.'CURROW') THEN
C                                       Write old record
            CALL TABIO ('WRIT', 0, TBCROW(BUFNO), RECR(1,BUFNO),
     *         IBUFFR(OFF,BUFNO), IERR)
            IF (IERR.NE.0) GO TO 500
C                                       negate because not read yet
            TBCROW(BUFNO) = -VALUE(1)
C                                       Number of rows.
         ELSE IF (MEM.EQ.'NROW') THEN
            IBUFFR(OFF+4,BUFNO) = VALUE(1)
C                                       Sort order
         ELSE IF (MEM.EQ.'SORT') THEN
            IBUFFR(OFF+42,BUFNO) = VALUE(1)
            IBUFFR(OFF+43,BUFNO) = VALUE(2)
C                                       Table Keyword
         ELSE IF (MEM.EQ.'KEY') THEN
            NKEY = 1
            LOCS(1) = 1
            IF (TYPE.EQ.1) THEN
               CALL COPY (NWDPDP, VALUE, KEYVAL)
            ELSE IF (TYPE.EQ.2) THEN
               CALL COPY (1, VALUE, KEYVAL)
            ELSE IF (TYPE.EQ.3) THEN
               IDUM(1) = MAX (8, DIM(1))
               CALL CHR2H (IDUM, VALUEC, 1, KEYVH)
            ELSE IF (TYPE.EQ.4) THEN
               KEYVAL(1) = VALUE(1)
            ELSE IF (TYPE.EQ.5) THEN
               CALL COPY (1, VALUE, KEYVAL)
               END IF
            TYPES(1) = TYPE
            CALL TABKEY ('WRIT', ARG, NKEY, IBUFFR(OFF,BUFNO), LOCS,
     *         KEYVAL, TYPES, IERR)
C                                       Table data entry
         ELSE IF (MEM.EQ.'ENTRY') THEN
C                                       Decode column number from ARG
            READ (ARG,1000,ERR=500) COL
C                                       Return entry
            ROW = ABS (TBCROW(BUFNO))
            CALL TABDPT (NAME, ROW, COL, TYPE, DIM, VALUE, VALUEC, IERR)
            END IF
      ELSE
C                                       Find object number
         CALL OBNAME (NAME, OBJNUM, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OBPUT (OBJNUM, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
         END IF
      GO TO 999
C                                       Error decoding column number
 500  WRITE (MSGTXT,1500) KEYWRD
      CALL MSGWRT (7)
      MSGTXT = 'ERROR FOR TABLE OBJECT ' // NAME
      CALL MSGWRT (7)
      IERR = 4
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I8)
 1500 FORMAT ('ERROR PARSING COLUMN NUMBER FROM ',A)
      END
      SUBROUTINE TABGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Returns a table member.
C   Inputs:
C      NAME     C*?   The name of the object.
C      KEYWRD   C*?   The name of the keyword in form 'MEM1.MEM2...'
C      TYPE     I     Data type of VALUE: 1=double, 2=real,
C                        3=character, 4=integer, 5=logical, 7=bit
C                        arrays.
C      DIM      I(*)  Dimensionality of value, an axis dimension of zero
C                     means that that dimension and higher are
C                     undefined.
C      VALUE    ?(*)  The value associated with keyword.
C      VALUEC   C*(*) Character value associated with keyword.
C   Outputs:
C      IERR     I     Error return code, 0=OK, -1 => table row
C                     deselected.
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC(*)*(*)
      INTEGER   TYPE, DIM(*), VALUE(*), IERR
C
      INTEGER   KEYVAL(2), NKEY, LOCS(1), COL, ROW, NCOL, OFF, BUFNO,
     *   OBJNUM, TYPES(1)
      CHARACTER MEM*8, ARG*8
      LOGICAL LOCAL, KEYVL(2)
      HOLLERITH KEYVH(2)
      REAL      KEYVR(2)
      DOUBLE PRECISION KEYVD
      EQUIVALENCE (KEYVAL, KEYVR, KEYVH, KEYVL, KEYVD)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'TABLEIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
      OFF = BUFSIZ - 511
C                                       Look for base class.member name
C                                       in KEYWRD.
      CALL TBLMEM (KEYWRD, MEM, ARG, LOCAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Deal with keywrd here?
      IF (LOCAL) THEN
C                                       Get buffer number
         CALL OBINFO (NAME, BUFNO, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Table open?
         IF (BUFNO.LE.0) THEN
            MSGTXT = NAME // ' TABLE IS NOT OPEN'
            CALL MSGWRT (6)
            IERR = 5
            GO TO 999
            END IF
         NCOL = TBNCOL(BUFNO)
         TYPE = 4
         DIM(2) = 1
         DIM(3) = 0
C                                       Current row number
         IF (MEM.EQ.'CURROW') THEN
            DIM(1) = 1
            VALUE(1) = ABS (TBCROW(BUFNO))
C                                       Number of rows
         ELSE IF (MEM.EQ.'NROW') THEN
            DIM(1) = 1
            VALUE(1) = IBUFFR(OFF+4,BUFNO)
C
         ELSE IF (MEM.EQ.'SORT') THEN
            DIM(1) = 2
            VALUE(1) = IBUFFR(OFF+42,BUFNO)
            VALUE(2) = IBUFFR(OFF+43,BUFNO)
C                                       Table Keyword
         ELSE IF (MEM.EQ.'KEY') THEN
            DIM(1) = 1
            NKEY = 1
            CALL TABKEY ('READ', ARG, NKEY, IBUFFR(OFF,BUFNO), LOCS,
     *         KEYVAL, TYPES, IERR)
            TYPE = TYPES(1)
            IF (IERR.NE.0) GO TO 999
            IF (TYPE.EQ.1) THEN
               CALL COPY (NWDPDP, KEYVAL, VALUE)
            ELSE IF (TYPE.EQ.2) THEN
               CALL COPY (DIM(1), KEYVAL, VALUE)
            ELSE IF (TYPE.EQ.3) THEN
               DIM(1) = 8
               CALL H2CHR (DIM, 1, KEYVH, VALUEC)
            ELSE IF (TYPE.EQ.4) THEN
               VALUE(1) = KEYVAL(1)
            ELSE IF (TYPE.EQ.5) THEN
               CALL COPY (DIM(1), KEYVAL, VALUE)
               END IF
C                                       Table data entry
         ELSE IF (MEM.EQ.'ENTRY') THEN
C                                       Decode column number from ARG
            READ (ARG,1000,ERR=500) COL
            ROW = ABS (TBCROW(BUFNO))
            CALL TABDGT (NAME, ROW, COL, TYPE, DIM, VALUE, VALUEC, IERR)
            GO TO 999
            END IF
      ELSE
C                                       Find object number
         CALL OBNAME (NAME, OBJNUM, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OBGET (OBJNUM, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
         END IF
      GO TO 999
C                                       Error decoding column number
 500  WRITE(MSGTXT,1500) KEYWRD
      CALL MSGWRT (7)
      MSGTXT = 'ERROR FOR TABLE OBJECT ' // NAME
      CALL MSGWRT (7)
      IERR = 4
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I8)
 1500 FORMAT ('ERROR PARSING COLUMN NUMBER FROM ',A)
      END
      SUBROUTINE TABDGT (NAME, ROW, COL, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Returns table row data.
C   Inputs:
C      NAME     C*?   The name of the object.
C      ROW      I     Desired row number.
C      COL      I     Desired column number
C   Outputs:
C      TYPE     I     Data type of VALUE: 1=double, 2=real,
C                        3=character, 4=integer, 5=logical, 7=bit
C                        arrays.
C      DIM      I(*)  Dimensionality of value, an axis dimension of zero
C                     means that that dimension and higher are
C                     undefined.
C      VALUE    ?(*)  The value associated with keyword.
C      VALUEC   C*(*) Character value associated with keyword.
C      IERR     I     Error return code, 0=OK, -1 => record deselected.
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), VALUEC(*)*(*)
      INTEGER   ROW, COL, TYPE, DIM(*), VALUE(*), IERR
C
      INTEGER   BUFNO, OFF, RPNT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'TABLEIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
      OFF = BUFSIZ - 511
C                                       Get buffer number
      CALL OBINFO (NAME, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Validity checks
C                                       Table open?
      IF (BUFNO.LE.0) THEN
         MSGTXT = 'TABLE IS NOT OPEN'
         IERR = 5
         GO TO 510
         END IF
C                                       Check column number
      IF (COL.GT.TBNCOL(BUFNO)) THEN
         WRITE(MSGTXT,1000) COL, TBNCOL(BUFNO)
         IERR = 1
         GO TO 510
         END IF
C                                       Check row number
      IF (ROW.GT.IBUFFR(OFF+4,BUFNO)) THEN
         WRITE(MSGTXT,1001) ROW, IBUFFR(OFF+4,BUFNO)
         IERR = 1
         GO TO 510
         END IF
C                                       May need to change row
      IF (TBCROW(BUFNO).NE.ROW) THEN
C                                       Need to write?
         IF ((IBUFFR(OFF+70,BUFNO).EQ.2)  .AND. (TBCROW(BUFNO).GT.0))
     *      CALL TABIO ('WRIT', 0, TBCROW(BUFNO), RECR(1,BUFNO),
     *      IBUFFR(OFF,BUFNO), IERR)
         TBCROW(BUFNO) = ROW
C                                       Do not read past end of table.
         IF (ROW.LE.IBUFFR(OFF+4,BUFNO)) CALL TABIO ('READ', 0,
     *      TBCROW(BUFNO), RECR(1,BUFNO), IBUFFR(OFF,BUFNO), IERR)
C                                       IERR = -1 => deselected
         IF (IERR.GT.0) GO TO 500
         END IF
      TBCROW(BUFNO) = ROW
C                                       Return column entry
      DIM(1) = TBDIM(COL,BUFNO)
      DIM(2) = 1
      DIM(3) = 0
      TYPE  = TBTYPE(COL,BUFNO)
      RPNT = TBPRT(COL,BUFNO)
      IF (TYPE.EQ.1) THEN
         RPNT = (RPNT-1) * NWDPDP + 1
         CALL COPY (DIM(1)*NWDPDP, RECORD(RPNT,BUFNO), VALUE)
      ELSE IF (TYPE.EQ.2) THEN
         CALL COPY (DIM(1), RECORD(RPNT,BUFNO), VALUE)
      ELSE IF (TYPE.EQ.3) THEN
         CALL H2CHR (DIM, 1, RECH(RPNT,BUFNO), VALUEC)
      ELSE IF (TYPE.EQ.4) THEN
         CALL COPY (DIM(1), RECORD(RPNT,BUFNO), VALUE)
      ELSE IF (TYPE.EQ.5) THEN
         CALL COPY (DIM(1), RECORD(RPNT,BUFNO), VALUE)
      ELSE IF (TYPE.EQ.7) THEN
         CALL LG2BIT (DIM(1), VALUE, RECORD(RPNT,BUFNO), -1)
         END IF
      GO TO 999
C                                       Error in TABIO
 500  WRITE(MSGTXT,1500) IERR
      IERR = 4
C                                       Other error?
 510  CALL MSGWRT (7)
      MSGTXT = 'ERROR FOR TABLE OBJECT: ' // NAME
      CALL MSGWRT (7)
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('REQUESTED COLUMN ',I4,' EXCEEDS MAX OF ',I4)
 1001 FORMAT ('REQUESTED ROW ',I4,' EXCEEDS MAX OF ',I4)
 1500 FORMAT ('ERROR ',I3,' IN TABIO ')
      END
      SUBROUTINE TABDPT (NAME, ROW, COL, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Stores table row data.
C   Inputs:
C      NAME     C*?   The name of the object.
C      ROW      I     Desired row number.
C      COL      I     Desired column number
C      TYPE     I     Data type of VALUE: 1=double, 2=real,
C                        3=character, 4=integer, 5=logical, 7=bit
C                        arrays.
C      DIM      I(*)  Dimensionality of value, an axis dimension of zero
C                     means that that dimension and higher are
C                     undefined.
C      VALUE    ?(*)  The value associated with keyword.
C      VALUEC   C*(*) Character value associated with keyword.
C   Outputs:
C      IERR     I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), VALUEC(*)*(*)
      INTEGER   ROW, COL, TYPE, DIM(*), VALUE(*), IERR
C
      INTEGER   BUFNO, OFF, RPNT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'TABLEIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
      OFF = BUFSIZ - 511
C                                       Get buffer number
      CALL OBINFO (NAME, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Validity checks
C                                       Table open?
      IF (BUFNO.LE.0) THEN
         MSGTXT = 'TABLE IS NOT OPEN'
         IERR = 5
         GO TO 510
         END IF
C                                       Check column number
      IF (COL.GT.TBNCOL(BUFNO)) THEN
         WRITE(MSGTXT,1000) COL, TBNCOL(BUFNO)
         IERR = 1
         GO TO 510
         END IF
C                                       Check type
      IF (TYPE.NE.TBTYPE(COL,BUFNO)) THEN
         WRITE(MSGTXT,1002) COL, TYPE, TBTYPE(COL,BUFNO)
         IERR = 1
         GO TO 510
         END IF
C                                       Check dim
      IF (DIM(1).NE.TBDIM(COL,BUFNO)) THEN
         WRITE(MSGTXT,1003) COL, DIM(1), TBDIM(COL,BUFNO)
         IERR = 1
         GO TO 510
         END IF
C                                       May need to write old and
C                                       read new row
      IF (TBCROW(BUFNO).NE.ROW) THEN
         IF (TBCROW(BUFNO).GT.0) CALL TABIO ('WRIT', 0, TBCROW(BUFNO),
     *      RECR(1,BUFNO), IBUFFR(OFF,BUFNO), IERR)
         IF (IERR.NE.0) GO TO 500
         TBCROW(BUFNO) = ROW
C                                       Do not read past end of table.
         IF (ROW.LE.IBUFFR(OFF+4,BUFNO)) CALL TABIO ('READ', 0,
     *      TBCROW(BUFNO), RECR(1,BUFNO), IBUFFR(OFF,BUFNO), IERR)
         IF (IERR.NE.0) GO TO 500
         END IF
C                                       Update no. rows
      IBUFFR(OFF+4,BUFNO) = MAX (IBUFFR(OFF+4,BUFNO), ROW)
      TBCROW(BUFNO) = ROW
      RPNT = TBPRT(COL,BUFNO)
C                                       Store column entry
      IF (TYPE.EQ.1) THEN
         RPNT = (RPNT-1) * NWDPDP + 1
         CALL COPY (DIM(1)*NWDPDP, VALUE, RECORD(RPNT,BUFNO))
      ELSE IF (TYPE.EQ.2) THEN
         CALL COPY (DIM(1), VALUE, RECORD(RPNT,BUFNO))
      ELSE IF (TYPE.EQ.3) THEN
         CALL CHR2H (DIM, VALUEC, 1, RECH(RPNT,BUFNO))
      ELSE IF (TYPE.EQ.4) THEN
         CALL COPY (DIM(1), VALUE, RECORD(RPNT,BUFNO))
      ELSE IF (TYPE.EQ.5) THEN
         CALL COPY (DIM(1), VALUE, RECORD(RPNT,BUFNO))
      ELSE IF (TYPE.EQ.7) THEN
         CALL LG2BIT (DIM(1), VALUE, RECORD(RPNT,BUFNO), +1)
         END IF
         GO TO 999
C                                       Error in TABIO
 500  WRITE(MSGTXT,1500) IERR
C                                       Other error
 510  CALL MSGWRT (7)
      MSGTXT = 'ERROR FOR TABLE OBJECT: ' // NAME
      CALL MSGWRT (7)
      IERR = 4
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('REQUESTED COLUMN ',I4,' EXCEEDS MAX OF ',I4)
 1002 FORMAT ('INCOMPATIBLE DATA TYPES FOR COL ',I3,I4,'<>',I4)
 1003 FORMAT ('INCOMPATIBLE DIMENSIONALITY FOR COL ',I3,I4,'<>',I4)
 1500 FORMAT ('ERROR ',I3,' IN TABIO ')
      END
      SUBROUTINE TABKGT (NAME, KEYS, NKEYS, KLOCS, KVALS, KTYPE, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Fetches values of specified table keywords.  If keys(1) is
C     blank then all keywords up to a maximum of nkeys is read.
C   Inputs:
C      NAME     C*?        The name of the object.
C      KEYS     C(*)*8     Keywords to read; first blank => read all.
C   In/out:
C      NKEYS   I           Max. Number of keywords to read; on return
C                          the number of keywords.
C   Output:
C      KLOCS    I(NKEYS)   The word offset of first integer
C                          word of keyword value in array KVALS.
C                          This value will be -1 for keywords not found.
C     KVALS     I(2*NKEYS) The array of keyword values.  This array may
C                          contain values of type real, double, integer,
C                          logical and hollerith.  Due to word
C                          alignment problems on some machines values
C                          longer than an integer should be copied,
C                          eg. if the  5th keyword (XXX) is a double:
C                               IPOINT = KLOCS(5)
C                               CALL COPY (NWDPDP, KVALS(IPOINT), XXX)
C     KTYPE     I(NKEYS)   The type code of the keywords:
C                             1 = Double precision floating
C                             2 = Single precision floating
C                             3 = Character string (8 HOLLERITH chars)
C                             4 = integer
C                             5 = Logical
C   Outputs:
C      IERR     I     Error return code, 0=OK
C                     Note: will return 0 if some keywords not found.
C-----------------------------------------------------------------------
      INTEGER   NKEYS
      CHARACTER NAME*(*), KEYS(NKEYS)*8
      INTEGER   KLOCS(NKEYS), KVALS(*), KTYPE(NKEYS), IERR
C
      CHARACTER OPCODE*4
      INTEGER   BUFNO, OFF, MSGSAV
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'TABLEIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
      OFF = BUFSIZ - 511
C                                       Get buffer number
      CALL OBINFO (NAME, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Table open?
      IF (BUFNO.LE.0) THEN
         MSGTXT = 'TABLE IS NOT OPEN'
         IERR = 5
         GO TO 510
         END IF
C                                       Set OPCODE
      OPCODE = 'READ'
      IF (KEYS(1) .EQ. '        ') OPCODE = 'ALL '
C                                       Call TABKEY (disable error
C                                       messages)
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL TABKEY (OPCODE, KEYS, NKEYS, IBUFFR(OFF,BUFNO), KLOCS,
     *   KVALS, KTYPE, IERR)
      MSGSUP = MSGSAV
C                                       Some not found is OK.
      IF (IERR.GT.20) IERR = 0
      IF (IERR.NE.0) GO TO 500
      GO TO 999
C                                       Error in TABKEY
 500  WRITE(MSGTXT,1500) IERR
C                                       Other error
 510  CALL MSGWRT (7)
      MSGTXT = 'ERROR FOR TABLE OBJECT: ' // NAME
      CALL MSGWRT (7)
      IERR = 4
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1500 FORMAT ('ERROR ',I3,' IN TABKEY ')
      END
      SUBROUTINE TABKPT (NAME, KEYS, NKEYS, KLOCS, KVALS, KTYPE, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Stores values of specified table keywords.
C   Inputs:
C      NAME     C*?        The name of the object.
C      KEYS     C(*)*8     Keywords to store.
C      NKEYS   I           Number of keywords.
C      KLOCS    I(NKEYS)   The word offset of first integer
C                          word of keyword value in array KVALS.
C     KVALS     I(2*NKEYS) The array of keyword values.  This array may
C                          contain values of type real, double, integer,
C                          logical and hollerith.  Due to word
C                          alignment problems on some machines values
C                          longer than an integer should be copied,
C                          eg. if the  5th keyword (XXX) is a double
C                               KLOCS(5) = IPOINT
C                               CALL COPY (NWDPDP, XXX, KVALS(IPOINT))
C     KTYPE     I(NKEYS)   The type code of the keywords:
C                             1 = Double precision floating
C                             2 = Single precision floating
C                             3 = Character string (8 HOLLERITH chars)
C                             4 = integer
C                             5 = Logical
C   Outputs:
C      IERR     I     Error return code, 0=OK
C-----------------------------------------------------------------------
      INTEGER   NKEYS
      CHARACTER NAME*(*), KEYS(NKEYS)*8
      INTEGER   KLOCS(NKEYS), KVALS(*), KTYPE(NKEYS), IERR
C
      CHARACTER OPCODE*4
      INTEGER   BUFNO, OFF
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'TABLEIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
      OFF = BUFSIZ - 511
C                                       Get buffer number
      CALL OBINFO (NAME, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Table open?
      IF (BUFNO.LE.0) THEN
         MSGTXT = 'TABLE IS NOT OPEN'
         IERR = 5
         GO TO 510
         END IF
C                                       Set OPCODE
      OPCODE = 'WRIT'
C                                       Call TABKEY
      CALL TABKEY (OPCODE, KEYS, NKEYS, IBUFFR(OFF,BUFNO), KLOCS,
     *   KVALS, KTYPE, IERR)
      IF (IERR.NE.0) GO TO 500
      GO TO 999
C                                       Error in TABKEY
 500  WRITE(MSGTXT,1500) IERR
C                                       Other error
 510  CALL MSGWRT (7)
      MSGTXT = 'ERROR FOR TABLE OBJECT: ' // NAME
      CALL MSGWRT (7)
      IERR = 4
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1500 FORMAT ('ERROR ',I3,' IN TABKEY ')
      END
      SUBROUTINE TBLSRT (NAME, KEY1, KEY2, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Sorts a table into an order specified by the values contained in
C   columns specified by KEY1 and KEY2.  If KEY1=KEY2 and is a character
C   column then an up to 8 character sort is done on that column.
C   The object should not be open when the call is made.
C      The default output ordering is in ascending order of the key
C   values. Descending order or ordering by absolute value can be
C   requested by an appropriate prefix to the column labels (KEY1,
C   KEY2).  If the column label begins with a minus sign "-" then the
C   sorting will be by descending value of that column.  After the minus
C   sign, if any, "ABS:" indicates that the absolute values of numeric
C   entries in that column be used in the sorting.  For example to sort
C   column labeled 'SOMETHING_OR_OTHER' by descending absolute order
C   then the corresponding KEY? would be: '-ABS:SOMETHING_OR_OTHER'
C     Note: This routine uses fixed LUNs and may not function when any
C   objects are open. This routine may create scratch files.
C   Inputs:
C      NAME     C*?    The name of the object.
C      KEY1     C*?    Label of the column containing the slowest
C                      varying keys.  May include abs. and/or descending
C                      order prefix.
C      KEY2     C*?    Label of the column containing the fastest
C                      varying keys.  May include abs. and/or descending
C                      order prefix.
C   Outputs:
C      IERR     I      Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), KEY1*(*), KEY2*(*)
      INTEGER   IERR
C
      INTEGER   BUFNO, BUFNO2, COL1, COL2, SORT(2), TYPE, DIM(3), TDISK,
     *   TCNO, TVER, KEY(2,2), IER, BS, C1TYPE, C1DIM, KEYSUB(2,2)
      REAL      FKEY(2,2)
      LOGICAL   ISOPEN, ISOP2, ABS1, ABS2, DESC1, DESC2
      CHARACTER TTYPE*2, STAT*4, TNAM*36, KKEY1*32, KKEY2*32, TKEY*32,
     *   CDUMMY*1
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'TABLEIO.INC'
      INCLUDE 'TABGFORT'
      DATA KEYSUB /4*1/
C-----------------------------------------------------------------------
      IERR = 0
      BS = BUFSIZ
      ISOPEN = .FALSE.
      ISOP2 = .FALSE.
C                                       Check for descending order.
      DESC1 = KEY1(1:1).EQ.'-'
      IF (DESC1) THEN
         KKEY1 = KEY1(2:)
      ELSE
         KKEY1 = KEY1
         END IF
      DESC2 = KEY2(1:1).EQ.'-'
      IF (DESC2) THEN
         KKEY2 = KEY2(2:)
      ELSE
         KKEY2 = KEY2
         END IF
C                                       Check for absolute values
      ABS1 = KKEY1(1:4).EQ.'ABS:'
      IF (ABS1) THEN
         TKEY = KKEY1(5:)
         KKEY1 = TKEY
         END IF
      ABS2 = KKEY2(1:4).EQ.'ABS:'
      IF (ABS2) THEN
         TKEY = KKEY2(5:)
         KKEY2 = TKEY
         END IF
C                                       Shallow copy table to get second
C                                       buffer.
      TNAM = 'Temporary shallow copy'
      CALL TBCOPY (NAME, TNAM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Open
      CALL TABOPN (NAME, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
      ISOPEN = .TRUE.
C                                       Look up table info
      CALL TBLKUP (NAME, TDISK, TCNO, TTYPE, TVER, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Get CATBLK
      STAT = 'REST'
      CALL CATIO ('READ', TDISK, TCNO, CATBLK, STAT, SBUFF, IERR)
      IF ((IERR.GE.1) .AND. (IERR.LE.4)) THEN
         WRITE (MSGTXT,1002) IERR
         GO TO 990
         END IF
      IERR = 0
C                                       Get buffer number
      CALL OBINFO (NAME, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Check sort order
      CALL TABCOL (NAME, 1, KKEY1, IDUM, IERR)
      IF (IERR.NE.0) GO TO 990
      COL1 = IDUM(1)
      CALL TABCOL (NAME, 1, KKEY2, IDUM, IERR)
      IF (IERR.NE.0) GO TO 990
      COL2 = IDUM(1)
      CALL TABGET (NAME, 'SORT', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL COPY (DIM(1), IDUM, SORT)
C                                       Get first column info
      C1TYPE = TBTYPE(COL1,BUFNO)
      C1DIM = TBDIM(COL1,BUFNO)
C                                       Open copy for second buffer
      CALL TABOPN (TNAM, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
      ISOP2 = .TRUE.
C                                       Get second buffer number
      CALL OBINFO (TNAM, BUFNO2, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Close tables; will use buffers
C                                       allocated for the table when it
C                                       was open.
      CALL TABCLO (NAME, IERR)
      IF (IERR.NE.0) GO TO 990
      ISOPEN = .FALSE.
      CALL TABCLO (TNAM, IERR)
      IF (IERR.NE.0) GO TO 990
      ISOP2 = .FALSE.
C                                       Delete temporary object.
      CALL DESTRY (TNAM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Is a sort needed?
      IF ((COL1.EQ.SORT(1)) .AND. (COL2.EQ.SORT(2))) GO TO 999
C                                       Sort by abs?
      IF (ABS1) COL1 = -COL1
      IF (ABS2) COL2 = -COL2
C                                       Sort table
      KEY(1,1) = COL1
      KEY(2,1) = COL1
      KEY(1,2) = COL2
      KEY(2,2) = COL2
      FKEY(1,1) = 1.0
      FKEY(2,1) = 1.0E-10
      FKEY(1,2) = 1.0
      FKEY(2,2) = 1.0E-10
C                                       If the sort columns are the same
C                                       and a character string use up to
C                                       8 characters for sort.
      IF ((COL1.EQ.COL2) .AND. (C1TYPE.EQ.3)) THEN
         FKEY(1,1) = 1.0
         FKEY(2,1) = MIN (4, C1DIM)
         KEY(2,1) = COL1
         IF (C1DIM.GT.4) THEN
            FKEY(1,2) = 5.0
            FKEY(2,2) = MIN (4, C1DIM-4)
            KEY(2,2) = COL2
            END IF
         END IF
C                                       Any descending order?
      IF (DESC1) THEN
         FKEY(1,1) = - ABS (FKEY(1,1))
         FKEY(2,1) = - ABS (FKEY(2,1))
      ELSE
         FKEY(1,1) = ABS (FKEY(1,1))
         FKEY(2,1) = ABS (FKEY(2,1))
         END IF
      IF (DESC2) THEN
         FKEY(1,2) = - ABS (FKEY(1,2))
         FKEY(2,2) = - ABS (FKEY(2,2))
      ELSE
         FKEY(1,2) = ABS (FKEY(1,2))
         FKEY(2,2) = ABS (FKEY(2,2))
         END IF
C                                       Sort
      CALL TABSRT (TDISK, TCNO, TTYPE, TVER, TVER, KEY, KEYSUB, FKEY,
     *   IBUFFR(1,BUFNO2), CATBLK, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'PROBLEM SORTING TABLE OBJECT: ' // NAME
      CALL MSGWRT (7)
C                                       Make sure object is closed
      IF (ISOPEN) CALL TABCLO (NAME, IER)
      IF (ISOP2) CALL TABCLO (TNAM, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1002 FORMAT ('TBLSRT: ERROR ',I3,' READING CATBLK')
      END
      SUBROUTINE TBLMRG (NAME, MKOL, TOLER, SKOL, NSKOL, SRTKOL, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Merges a table by first sorting the table using the merge columns,
C   then merging rows with columns MKOL agreeing to within the tolerance
C   given by TOLER and then sorting by SRTKOL.
C      The default output ordering is in ascending order of the key
C   values. Descending order or ordering by absolute value can be
C   requested by an appropriate prefix to the column labels (SRTKOL)
C   If the column label begins with a minus sign "-" then the
C   sorting will be by descending value of that column.  After the minus
C   sign, if any, "ABS:" indicates that the absolute values of numeric
C   entries in that column be used in the sorting.  For example to sort
C   column labeled 'SOMETHING_OR_OTHER' by descending absolute order
C   then the corresponding SRTKOL entry would be:
C   '-ABS:SOMETHING_OR_OTHER'
C   Note: This routine uses fixed LUNs and may not function when any
C   objects are open.
C   This routine may create scratch files.
C   Inputs:
C      NAME     C*?    The name of the object.
C      MKOL     C(2)*? Columns to be compared
C      TOLER    R(2)   Tolerance for numeric values in columns MKOL
C      SKOL     C(*)*? Labels of columns to be summed
C      NSKOL    I      Number of entries in SKOL. (max 25)
C      SRTKOL   C(2)*? Labels of columns for output sort.  May include
C                      abs. and/or descending order prefix.
C                      varying keys.
C      KEY2     C*?    Label of the column containing the fastest
C                      varying keys.
C   Outputs:
C      IERR     I      Error return code, 0=OK
C-----------------------------------------------------------------------
      INTEGER   NSKOL, IERR
      CHARACTER NAME*(*), MKOL(2)*(*), SKOL(NSKOL)*(*), SRTKOL(2)*(*)
      REAL      TOLER(2)
C
      INTEGER   BUFNO, BUFNO2, TDISK, TCNO, TVER, IER, BS, ECOL(3),
     *   SCOL(25), OUTNUM, LIM
      LOGICAL   ISOPEN, ISOP2
      CHARACTER TTYPE*2, STAT*4, TNAM*36
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'TABLEIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Sort input by MKOL
      CALL TBLSRT (NAME, MKOL(1), MKOL(2), IERR)
      IF (IERR.NE.0) GO TO 990
      BS = BUFSIZ
      ISOPEN = .FALSE.
      ISOP2 = .FALSE.
C                                       Shallow copy table to get second
C                                       buffer.
      TNAM = 'TBMRG Temporary table'
      CALL TBCOPY (NAME, TNAM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Open
      CALL TABOPN (NAME, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
      ISOPEN = .TRUE.
C                                       Look up table info
      CALL TBLKUP (NAME, TDISK, TCNO, TTYPE, TVER, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Get CATBLK
      STAT = 'REST'
      CALL CATIO ('READ', TDISK, TCNO, CATBLK, STAT, SBUFF, IERR)
      IF ((IERR.GE.1) .AND. (IERR.LE.4)) THEN
         WRITE (MSGTXT,1002) IERR
         GO TO 990
         END IF
      IERR = 0
C                                       Get buffer number
      CALL OBINFO (NAME, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Get column numbers
      CALL TABCOL (NAME, 2, MKOL, ECOL, IERR)
      IF (IERR.NE.0) GO TO 990
      ECOL(3) = 0
      LIM = MIN (NSKOL, 25)
      CALL TABCOL (NAME, LIM, SKOL, SCOL, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (LIM.LT.25) SCOL(LIM+1) = 0
C                                       Open copy for second buffer
      CALL TABOPN (TNAM, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
      ISOP2 = .TRUE.
C                                       Get second buffer number
      CALL OBINFO (TNAM, BUFNO2, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Close tables; will use buffers
C                                       allocated for the table when it
C                                       was open.
      CALL TABCLO (NAME, IERR)
      IF (IERR.NE.0) GO TO 990
      ISOPEN = .FALSE.
      CALL TABCLO (TNAM, IERR)
      IF (IERR.NE.0) GO TO 990
      ISOP2 = .FALSE.
C                                       Delete temporary object.
      CALL DESTRY (TNAM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Merge
      CALL TABMRG (TDISK, TCNO, TTYPE, TVER, TVER, ECOL, SCOL, TOLER,
     *   IBUFFR(1,BUFNO), IBUFFR(1,BUFNO2), CATBLK,
     *   OUTNUM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Sort output by SRTKOL
      CALL TBLSRT (NAME, SRTKOL(1), SRTKOL(2), IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'PROBLEM MERGING TABLE OBJECT: ' // NAME
      CALL MSGWRT (7)
C                                       Make sure object is closed
      IF (ISOPEN) CALL TABCLO (NAME, IER)
      IF (ISOP2) THEN
         CALL TABCLO (TNAM, IER)
         CALL DESTRY (TNAM, IER)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1002 FORMAT ('TBLMRG: ERROR ',I3,' READING CATBLK')
      END
      SUBROUTINE TABEXI (NAME, EXISTS, IERR)
C-----------------------------------------------------------------------
C   Tests whether the table exists.
C
C   Inputs:
C      NAME    C*?    Object name
C
C   Outputs:
C      EXISTS  L      True if and only if the table exists
C      IERR    I      Return code: 0 indicates success
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      LOGICAL   EXISTS
      INTEGER   IERR
C-----------------------------------------------------------------------
      INTEGER   TDISK, TCNO, TVER, LUN
      CHARACTER TTYPE*2
      LOGICAL   TABLE, EXIST, FITASC
      INCLUDE 'INCS:CLASSIO.INC'
C-----------------------------------------------------------------------
C                                       Look up table:
      CALL TBLKUP (NAME, TDISK, TCNO, TTYPE, TVER, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Check existance:
      CALL OBLUN (LUN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ISTAB (TTYPE, TDISK, TCNO, TVER, LUN, SBUFF, TABLE, EXIST,
     *   FITASC, IERR)
      EXISTS = EXIST .AND. TABLE .AND. (IERR.EQ.0)
C                                       Free LUN
      CALL OBLUFR (LUN)
C
  999 RETURN
      END
      SUBROUTINE TBLMEM (KEYWRD, MEM, ARG, LOCAL, IERR)
C-----------------------------------------------------------------------
C   Private function
C   Parses the keyword into component parts and then checks if mem is a
C   special local value.
C   Inputs:
C      KEYWRD  C*?  Keyword in form 'base.mem.mem'
C   Outputs:
C      MEM     C*?  Table class member
C      ARG     C*?  Any argument, for MEM='ENTRY' it is a right
C                   justified string.
C      LOCAL   L    If true then MEM is recognized as a locally stored
C                   member.
C      IERR    I    Return code, 0=>OK else unknown base class.
C-----------------------------------------------------------------------
      CHARACTER KEYWRD*(*), MEM*(*), ARG*(*)
      LOGICAL   LOCAL
      INTEGER   IERR
C
      INTEGER   POINT, PNT2, LOOP, LARG, L, LEN
      INCLUDE 'TABLE.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Look for base_class.member_name
C                                       in KEYWRD.
      POINT = INDEX (KEYWRD, '.')
C                                       Base class reference
      IF (POINT.GE.1) THEN
         MEM = KEYWRD(1:POINT-1)
C                                       Special trap for ENTRY member
         IF (MEM.EQ.'ENTRY') THEN
            LARG = LEN (ARG)
            PNT2 = INDEX (KEYWRD, ' ')
            IF (PNT2.LE.0) PNT2 = LEN (KEYWRD) + 1
            L = PNT2 - POINT - 2
            ARG(LARG-L:) = KEYWRD(POINT+1:PNT2-1)
         ELSE
            ARG = KEYWRD(POINT+1:)
            END IF
      ELSE
         MEM = KEYWRD
         ARG = '  '
         END IF
C                                       Search list of local members.
         LOCAL = .FALSE.
         DO 20 LOOP = 1,NMEM
            LOCAL = LOCAL .OR. (MEM.EQ.LMEM(LOOP))
 20         CONTINUE
C
 999  RETURN
      END
      SUBROUTINE TBLKUP (NAME, TDISK, TCNO, TTYPE, TVER, IERR)
C-----------------------------------------------------------------------
C   Private
C   Looks up information on a table object. Fills in names etc. in
C   object.  Reads CATBLK.
C   Inputs:
C      NAME  C*?   The name of the object.
C   Output:
C      TDISK I     AIPS disk number
C      TCNO  I     AIPS catalog slot number
C      TTYPE C*2   Table type
C      TVER  I     Table version number
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), TTYPE*(*)
      INTEGER   TDISK, TCNO, TVER, IERR
C
      INTEGER   OBJNUM, TYPE, DIM(7), TSEQ, USID
      CHARACTER TNAME*12, TCLASS*6, PTYPE*2, STAT*4, CDUMMY*1
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'TABGFORT'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Find object number
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Look up table info
      CALL OBGET (OBJNUM, 'NAME', TYPE, DIM, IDUM, TNAME, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OBGET (OBJNUM, 'CLASS', TYPE, DIM, IDUM, TCLASS, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OBGET (OBJNUM, 'IMSEQ', TYPE, DIM, IDUM, CDUMMY, IERR)
      TSEQ = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OBGET (OBJNUM, 'DISK', TYPE, DIM, IDUM, CDUMMY, IERR)
      TDISK = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OBGET (OBJNUM, 'TBLTYPE', TYPE, DIM, IDUM, TTYPE, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OBGET (OBJNUM, 'VER', TYPE, DIM, IDUM, CDUMMY, IERR)
      TVER = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      TCNO = 1
      USID = 0
      PTYPE = '  '
      CALL CATDIR ('SRCH', TDISK, TCNO, TNAME, TCLASS, TSEQ, PTYPE,
     *   USID, STAT, SBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1000) IERR, TNAME, TCLASS, TSEQ, TDISK
         CALL MSGWRT (6)
         GO TO 990
         END IF
C                                       Get CATBLK
      STAT = 'REST'
      CALL CATIO ('READ', TDISK, TCNO, CATBLK, STAT, SBUFF, IERR)
      IF ((IERR.GE.1) .AND. (IERR.LE.4)) THEN
         WRITE (MSGTXT,1002) IERR
         CALL MSGWRT (7)
         GO TO 990
         END IF
      IERR = 0
C                                       Update any information
      CALL OBHPUT (NAME, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 990
      DIM(1) = 12
      CALL OBPUT (OBJNUM, 'NAME', OOACAR, DIM, IDUM, TNAME, IERR)
      IF (IERR.NE.0) GO TO 990
      DIM(1) = 6
      CALL OBPUT (OBJNUM, 'CLASS', OOACAR, DIM, IDUM, TCLASS, IERR)
      IF (IERR.NE.0) GO TO 990
      DIM(1) = 1
      IDUM(1) = TSEQ
      CALL OBPUT (OBJNUM, 'IMSEQ', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      IDUM(1) = TDISK
      CALL OBPUT (OBJNUM, 'DISK', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      IDUM(1) = TCNO
      CALL OBPUT (OBJNUM, 'CNO', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'TBLKUP: ERROR WITH TABLE OBJECT ' // NAME
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' FINDING ',A,'.',A,'.',I4,' DISK=', I3)
 1002 FORMAT ('ERROR ',I3,' READING CATBLK')
      END
      SUBROUTINE TBLHIV (NAME, NVER, IERR)
C-----------------------------------------------------------------------
C   Private
C   Finds highest version number of TBLTYPE table associated with
C   catalog entry. Returns 0 if there are no versions of that type.
C   Inputs:
C      NAME  C*?   The name of the object.
C   Output:
C      NVER  I     Table version number
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   NVER, IERR
C
      INTEGER   TDISK, TCNO, TVER
      CHARACTER TTYPE*2
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IERR = 0
      NVER = 0
C                                       Get table type and force read of
C                                       CATBLK.
      CALL TBLKUP (NAME, TDISK, TCNO, TTYPE, TVER, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Read CATBLK
      CALL OBHGET (NAME, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Loop thru CATBLK
      CALL FNDEXT (TTYPE, CATBLK, NVER)
      GO TO 999
C                                       Error
 990  MSGTXT = 'TBLHIV: ERROR WITH TABLE ' // NAME
      CALL MSGWRT (6)
C
 999  RETURN
      END

      SUBROUTINE CFFTB(N, C, WSAVE, WSAVEI)
C-----------------------------------------------------------------------
C! Complex-to-complex inverse FFT
C# FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Replace the first N elements of C by their unnormalized inverse FFT.
C   N must be positive and WSAVE must have at least 4*N+15 elements and
C   must have been initialized by calling CFFTI.  WSAVE may not be
C   modified between the call to CFFTI and CFFTB.
C
C   This routine should not be called directly: use QCFT1D instead.
C   QCFT1D may take advantage of FFT routines that have been
C   specifically optimized for the machine that you are working on.
C
C   Inputs:
C      N        I       Length of FFT
C      WSAVE    R(*)    Workspace
C      WSAVEI   I(*)    Workspace (can be same as WSAVE
C   Input/output
C      C      C(*)    Complex data; replaced by its transform
C
C   Adapted from the FFTPACK routine by Paul N. Schwartztrauber.
C   This file also contains subroutines CFFTB1, PASSB, PASSB2, PASSB3,
C   PASSB4, and PASSB5
C-----------------------------------------------------------------------
      INTEGER   N, WSAVEI(*)
      REAL      C(*)
      REAL      WSAVE(*)
C
      INTEGER IW1, IW2
C-----------------------------------------------------------------------
      IF (N .GT. 1) THEN
         IW1 = N + N + 1
         IW2 = IW1 + N + N
C                                       This call may generate compiler
C                                       warnings since WSAVE(IW2) is
C                                       associated with an INTEGER
C                                       array and C with a REAL array
C                                       in this call.
         CALL CFFTB1(N, C, WSAVE, WSAVE(IW1), WSAVEI(IW2))
      END IF
C
      END
      SUBROUTINE CFFTB1(N, C, CH, WA, IFAC)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      INTEGER   N, IFAC(*)
      REAL      C(*), CH(*), WA(*)
C
      INTEGER   I, IDL1, IDO, IDOT, IP, IW, IX2, IX3, IX4, K1, L1,
     *   L2, N2, NA, NAC, NF
C-----------------------------------------------------------------------
      NF = IFAC(2)
      NA = 0
      L1 = 1
      IW = 1
      DO 100 K1 = 1, NF
         IP = IFAC(K1+2)
         L2 = IP*L1
         IDO = N/L2
         IDOT = IDO + IDO
         IDL1 = IDOT*L1
         IF ( IP.EQ.4 ) THEN
            IX2 = IW + IDOT
            IX3 = IX2 + IDOT
            IF ( NA.NE.0 ) THEN
               CALL PASSB4(IDOT, L1, CH, C, WA(IW), WA(IX2), WA(IX3))
            ELSE
               CALL PASSB4(IDOT, L1, C, CH, WA(IW), WA(IX2), WA(IX3))
            END IF
            NA = 1 - NA
         ELSE IF ( IP.EQ.2 ) THEN
            IF ( NA.NE.0 ) THEN
               CALL PASSB2(IDOT, L1, CH, C, WA(IW))
            ELSE
               CALL PASSB2(IDOT, L1, C, CH, WA(IW))
            END IF
            NA = 1 - NA
         ELSE IF ( IP.EQ.3 ) THEN
            IX2 = IW + IDOT
            IF ( NA.NE.0 ) THEN
               CALL PASSB3(IDOT, L1, CH, C, WA(IW), WA(IX2))
            ELSE
               CALL PASSB3(IDOT, L1, C, CH, WA(IW), WA(IX2))
            END IF
            NA = 1 - NA
         ELSE IF ( IP.NE.5 ) THEN
            IF ( NA.NE.0 ) THEN
               CALL PASSB(NAC, IDOT, IP, L1, IDL1, CH, CH, CH, C, C,
     *                    WA(IW))
            ELSE
               CALL PASSB(NAC, IDOT, IP, L1, IDL1, C, C, C, CH, CH,
     *                    WA(IW))
            END IF
            IF ( NAC.NE.0 ) NA = 1 - NA
         ELSE
            IX2 = IW + IDOT
            IX3 = IX2 + IDOT
            IX4 = IX3 + IDOT
            IF ( NA.NE.0 ) THEN
               CALL PASSB5(IDOT, L1, CH, C, WA(IW), WA(IX2), WA(IX3),
     *                     WA(IX4))
            ELSE
               CALL PASSB5(IDOT, L1, C, CH, WA(IW), WA(IX2), WA(IX3),
     *                     WA(IX4))
            END IF
            NA = 1 - NA
         END IF
         L1 = L2
         IW = IW + (IP-1)*IDOT
 100  CONTINUE
      IF ( NA.EQ.0 ) RETURN
      N2 = N + N
      DO 200 I = 1, N2
         C(I) = CH(I)
 200  CONTINUE
      RETURN
      END
      SUBROUTINE PASSB(NAC, IDO, IP, L1, IDL1, CC, C1, C2, CH, CH2, WA)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      INTEGER   NAC, IDO, IP, L1, IDL1
      REAL      CC(IDO, IP, L1), C1(IDO, L1, IP), C2(IDL1, IP),
     *   CH(IDO, L1, IP), CH2(IDL1, IP), WA(*)
C
      REAL      WAI, WAR
      INTEGER I, IDIJ, IDJ, IDL, IDLJ, IDOT, IDP, IK, INC,
     *        IPP2, IPPH, J, JC, K, L, LC
      INTEGER NT
C-----------------------------------------------------------------------
      IDOT = IDO/2
      NT = IP*IDL1
      IPP2 = IP + 2
      IPPH = (IP+1)/2
      IDP = IP*IDO
C
      IF ( IDO.LT.L1 ) THEN
         DO 50 J = 2, IPPH
            JC = IPP2 - J
            DO 20 I = 1, IDO
               DO 10 K = 1, L1
                  CH(I, K, J) = CC(I, J, K) + CC(I, JC, K)
                  CH(I, K, JC) = CC(I, J, K) - CC(I, JC, K)
 10            CONTINUE
 20         CONTINUE
 50      CONTINUE
         DO 100 I = 1, IDO
            DO 60 K = 1, L1
               CH(I, K, 1) = CC(I, 1, K)
 60         CONTINUE
 100     CONTINUE
      ELSE
         DO 150 J = 2, IPPH
            JC = IPP2 - J
            DO 120 K = 1, L1
               DO 110 I = 1, IDO
                  CH(I, K, J) = CC(I, J, K) + CC(I, JC, K)
                  CH(I, K, JC) = CC(I, J, K) - CC(I, JC, K)
 110           CONTINUE
 120        CONTINUE
 150     CONTINUE
         DO 200 K = 1, L1
            DO 160 I = 1, IDO
               CH(I, K, 1) = CC(I, 1, K)
 160        CONTINUE
 200     CONTINUE
      END IF
      IDL = 2 - IDO
      INC = 0
      DO 400 L = 2, IPPH
         LC = IPP2 - L
         IDL = IDL + IDO
         DO 250 IK = 1, IDL1
            C2(IK, L) = CH2(IK, 1) + WA(IDL-1)*CH2(IK, 2)
            C2(IK, LC) = WA(IDL)*CH2(IK, IP)
 250     CONTINUE
         IDLJ = IDL
         INC = INC + IDO
         DO 300 J = 3, IPPH
            JC = IPP2 - J
            IDLJ = IDLJ + INC
            IF ( IDLJ.GT.IDP ) IDLJ = IDLJ - IDP
            WAR = WA(IDLJ-1)
            WAI = WA(IDLJ)
            DO 260 IK = 1, IDL1
               C2(IK, L) = C2(IK, L) + WAR*CH2(IK, J)
               C2(IK, LC) = C2(IK, LC) + WAI*CH2(IK, JC)
 260        CONTINUE
 300     CONTINUE
 400  CONTINUE
      DO 500 J = 2, IPPH
         DO 450 IK = 1, IDL1
            CH2(IK, 1) = CH2(IK, 1) + CH2(IK, J)
 450     CONTINUE
 500  CONTINUE
      DO 600 J = 2, IPPH
         JC = IPP2 - J
         DO 550 IK = 2, IDL1, 2
            CH2(IK-1, J) = C2(IK-1, J) - C2(IK, JC)
            CH2(IK-1, JC) = C2(IK-1, J) + C2(IK, JC)
            CH2(IK, J) = C2(IK, J) + C2(IK-1, JC)
            CH2(IK, JC) = C2(IK, J) - C2(IK-1, JC)
 550     CONTINUE
 600  CONTINUE
      NAC = 1
      IF ( IDO.EQ.2 ) RETURN
      NAC = 0
      DO 700 IK = 1, IDL1
         C2(IK, 1) = CH2(IK, 1)
 700  CONTINUE
      DO 800 J = 2, IP
         DO 750 K = 1, L1
            C1(1, K, J) = CH(1, K, J)
            C1(2, K, J) = CH(2, K, J)
 750     CONTINUE
 800  CONTINUE
      IF ( IDOT.LE.L1 ) THEN
         IDIJ = 0
         DO 850 J = 2, IP
            IDIJ = IDIJ + 2
            DO 820 I = 4, IDO, 2
               IDIJ = IDIJ + 2
               DO 810 K = 1, L1
                  C1(I-1, K, J) = WA(IDIJ-1)*CH(I-1, K, J) - WA(IDIJ)
     *                            *CH(I, K, J)
                  C1(I, K, J) = WA(IDIJ-1)*CH(I, K, J) + WA(IDIJ)
     *                          *CH(I-1, K, J)
 810           CONTINUE
 820        CONTINUE
 850     CONTINUE
         RETURN
      END IF
      IDJ = 2 - IDO
      DO 1000 J = 2, IP
         IDJ = IDJ + IDO
         DO 900 K = 1, L1
            IDIJ = IDJ
            DO 860 I = 4, IDO, 2
               IDIJ = IDIJ + 2
               C1(I-1, K, J) = WA(IDIJ-1)*CH(I-1, K, J) - WA(IDIJ)
     *                         *CH(I, K, J)
               C1(I, K, J) = WA(IDIJ-1)*CH(I, K, J) + WA(IDIJ)
     *                       *CH(I-1, K, J)
 860        CONTINUE
 900     CONTINUE
 1000 CONTINUE
      RETURN
C
      END
      SUBROUTINE PASSB2(IDO, L1, CC, CH, WA1)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      INTEGER   IDO, L1
      REAL      CC(IDO, 2, L1), CH(IDO, L1, 2), WA1(*)
C
      REAL      TI2, TR2
      INTEGER   I, K
C-----------------------------------------------------------------------
      IF ( IDO.LE.2 ) THEN
         DO 50 K = 1, L1
            CH(1, K, 1) = CC(1, 1, K) + CC(1, 2, K)
            CH(1, K, 2) = CC(1, 1, K) - CC(1, 2, K)
            CH(2, K, 1) = CC(2, 1, K) + CC(2, 2, K)
            CH(2, K, 2) = CC(2, 1, K) - CC(2, 2, K)
 50      CONTINUE
         RETURN
      END IF
      DO 200 K = 1, L1
         DO 100 I = 2, IDO, 2
            CH(I-1, K, 1) = CC(I-1, 1, K) + CC(I-1, 2, K)
            TR2 = CC(I-1, 1, K) - CC(I-1, 2, K)
            CH(I, K, 1) = CC(I, 1, K) + CC(I, 2, K)
            TI2 = CC(I, 1, K) - CC(I, 2, K)
            CH(I, K, 2) = WA1(I-1)*TI2 + WA1(I)*TR2
            CH(I-1, K, 2) = WA1(I-1)*TR2 - WA1(I)*TI2
 100     CONTINUE
 200  CONTINUE
      RETURN
      END
      SUBROUTINE PASSB3(IDO, L1, CC, CH, WA1, WA2)
C------------------------------------------------------------------------
C------------------------------------------------------------------------
      INTEGER   IDO, L1
      REAL      CC(IDO, 3, L1), CH(IDO, L1, 3), WA1(*), WA2(*)
C
      REAL CI2, CI3, CR2, CR3, DI2, DI3, DR2, DR3, TAUI, TAUR,
     *     TI2, TR2
      PARAMETER (TAUR = -0.5)
      PARAMETER (TAUI = 0.866025403784439)
      INTEGER I, K
C-----------------------------------------------------------------------
      IF ( IDO.EQ.2 ) THEN
         DO 50 K = 1, L1
            TR2 = CC(1, 2, K) + CC(1, 3, K)
            CR2 = CC(1, 1, K) + TAUR*TR2
            CH(1, K, 1) = CC(1, 1, K) + TR2
            TI2 = CC(2, 2, K) + CC(2, 3, K)
            CI2 = CC(2, 1, K) + TAUR*TI2
            CH(2, K, 1) = CC(2, 1, K) + TI2
            CR3 = TAUI*(CC(1, 2, K)-CC(1, 3, K))
            CI3 = TAUI*(CC(2, 2, K)-CC(2, 3, K))
            CH(1, K, 2) = CR2 - CI3
            CH(1, K, 3) = CR2 + CI3
            CH(2, K, 2) = CI2 + CR3
            CH(2, K, 3) = CI2 - CR3
 50      CONTINUE
         RETURN
      END IF
      DO 200 K = 1, L1
         DO 100 I = 2, IDO, 2
            TR2 = CC(I-1, 2, K) + CC(I-1, 3, K)
            CR2 = CC(I-1, 1, K) + TAUR*TR2
            CH(I-1, K, 1) = CC(I-1, 1, K) + TR2
            TI2 = CC(I, 2, K) + CC(I, 3, K)
            CI2 = CC(I, 1, K) + TAUR*TI2
            CH(I, K, 1) = CC(I, 1, K) + TI2
            CR3 = TAUI*(CC(I-1, 2, K)-CC(I-1, 3, K))
            CI3 = TAUI*(CC(I, 2, K)-CC(I, 3, K))
            DR2 = CR2 - CI3
            DR3 = CR2 + CI3
            DI2 = CI2 + CR3
            DI3 = CI2 - CR3
            CH(I, K, 2) = WA1(I-1)*DI2 + WA1(I)*DR2
            CH(I-1, K, 2) = WA1(I-1)*DR2 - WA1(I)*DI2
            CH(I, K, 3) = WA2(I-1)*DI3 + WA2(I)*DR3
            CH(I-1, K, 3) = WA2(I-1)*DR3 - WA2(I)*DI3
 100     CONTINUE
 200  CONTINUE
      RETURN
      END
      SUBROUTINE PASSB4(IDO, L1, CC, CH, WA1, WA2, WA3)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      INTEGER   IDO, L1
      REAL      CC(IDO, 4, L1), CH(IDO, L1, 4), WA1(*), WA2(*), WA3(*)
C
      REAL      CI2, CI3, CI4, CR2, CR3, CR4, TI1, TI2, TI3, TI4,
     *   TR1, TR2, TR3, TR4
      INTEGER   I, K
C-----------------------------------------------------------------------
      IF ( IDO.EQ.2 ) THEN
         DO 50 K = 1, L1
            TI1 = CC(2, 1, K) - CC(2, 3, K)
            TI2 = CC(2, 1, K) + CC(2, 3, K)
            TR4 = CC(2, 4, K) - CC(2, 2, K)
            TI3 = CC(2, 2, K) + CC(2, 4, K)
            TR1 = CC(1, 1, K) - CC(1, 3, K)
            TR2 = CC(1, 1, K) + CC(1, 3, K)
            TI4 = CC(1, 2, K) - CC(1, 4, K)
            TR3 = CC(1, 2, K) + CC(1, 4, K)
            CH(1, K, 1) = TR2 + TR3
            CH(1, K, 3) = TR2 - TR3
            CH(2, K, 1) = TI2 + TI3
            CH(2, K, 3) = TI2 - TI3
            CH(1, K, 2) = TR1 + TR4
            CH(1, K, 4) = TR1 - TR4
            CH(2, K, 2) = TI1 + TI4
            CH(2, K, 4) = TI1 - TI4
 50      CONTINUE
         RETURN
      END IF
      DO 200 K = 1, L1
         DO 100 I = 2, IDO, 2
            TI1 = CC(I, 1, K) - CC(I, 3, K)
            TI2 = CC(I, 1, K) + CC(I, 3, K)
            TI3 = CC(I, 2, K) + CC(I, 4, K)
            TR4 = CC(I, 4, K) - CC(I, 2, K)
            TR1 = CC(I-1, 1, K) - CC(I-1, 3, K)
            TR2 = CC(I-1, 1, K) + CC(I-1, 3, K)
            TI4 = CC(I-1, 2, K) - CC(I-1, 4, K)
            TR3 = CC(I-1, 2, K) + CC(I-1, 4, K)
            CH(I-1, K, 1) = TR2 + TR3
            CR3 = TR2 - TR3
            CH(I, K, 1) = TI2 + TI3
            CI3 = TI2 - TI3
            CR2 = TR1 + TR4
            CR4 = TR1 - TR4
            CI2 = TI1 + TI4
            CI4 = TI1 - TI4
            CH(I-1, K, 2) = WA1(I-1)*CR2 - WA1(I)*CI2
            CH(I, K, 2) = WA1(I-1)*CI2 + WA1(I)*CR2
            CH(I-1, K, 3) = WA2(I-1)*CR3 - WA2(I)*CI3
            CH(I, K, 3) = WA2(I-1)*CI3 + WA2(I)*CR3
            CH(I-1, K, 4) = WA3(I-1)*CR4 - WA3(I)*CI4
            CH(I, K, 4) = WA3(I-1)*CI4 + WA3(I)*CR4
 100     CONTINUE
 200  CONTINUE
      RETURN
      END
      SUBROUTINE PASSB5(IDO, L1, CC, CH, WA1, WA2, WA3, WA4)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      INTEGER   IDO, L1
      REAL      CC(IDO, 5, L1), CH(IDO, L1, 5), WA1(*), WA2(*), WA3(*),
     *   WA4(*)
      REAL      CI2, CI3, CI4, CI5, CR2, CR3, CR4, CR5, DI2, DI3,
     *   DI4, DI5, DR2, DR3, DR4, DR5, TI11, TI12
      REAL      TI2, TI3, TI4, TI5, TR11, TR12, TR2, TR3, TR4, TR5
      PARAMETER (TR11 =  0.309016994374947)
      PARAMETER (TI11 =  0.951056516295154)
      PARAMETER (TR12 = -0.809016994374947)
      PARAMETER (TI12 =  0.587785252292473)
      INTEGER   I, K
C-----------------------------------------------------------------------
      IF ( IDO.EQ.2 ) THEN
         DO 50 K = 1, L1
            TI5 = CC(2, 2, K) - CC(2, 5, K)
            TI2 = CC(2, 2, K) + CC(2, 5, K)
            TI4 = CC(2, 3, K) - CC(2, 4, K)
            TI3 = CC(2, 3, K) + CC(2, 4, K)
            TR5 = CC(1, 2, K) - CC(1, 5, K)
            TR2 = CC(1, 2, K) + CC(1, 5, K)
            TR4 = CC(1, 3, K) - CC(1, 4, K)
            TR3 = CC(1, 3, K) + CC(1, 4, K)
            CH(1, K, 1) = CC(1, 1, K) + TR2 + TR3
            CH(2, K, 1) = CC(2, 1, K) + TI2 + TI3
            CR2 = CC(1, 1, K) + TR11*TR2 + TR12*TR3
            CI2 = CC(2, 1, K) + TR11*TI2 + TR12*TI3
            CR3 = CC(1, 1, K) + TR12*TR2 + TR11*TR3
            CI3 = CC(2, 1, K) + TR12*TI2 + TR11*TI3
            CR5 = TI11*TR5 + TI12*TR4
            CI5 = TI11*TI5 + TI12*TI4
            CR4 = TI12*TR5 - TI11*TR4
            CI4 = TI12*TI5 - TI11*TI4
            CH(1, K, 2) = CR2 - CI5
            CH(1, K, 5) = CR2 + CI5
            CH(2, K, 2) = CI2 + CR5
            CH(2, K, 3) = CI3 + CR4
            CH(1, K, 3) = CR3 - CI4
            CH(1, K, 4) = CR3 + CI4
            CH(2, K, 4) = CI3 - CR4
            CH(2, K, 5) = CI2 - CR5
 50      CONTINUE
         RETURN
      END IF
      DO 200 K = 1, L1
         DO 100 I = 2, IDO, 2
            TI5 = CC(I, 2, K) - CC(I, 5, K)
            TI2 = CC(I, 2, K) + CC(I, 5, K)
            TI4 = CC(I, 3, K) - CC(I, 4, K)
            TI3 = CC(I, 3, K) + CC(I, 4, K)
            TR5 = CC(I-1, 2, K) - CC(I-1, 5, K)
            TR2 = CC(I-1, 2, K) + CC(I-1, 5, K)
            TR4 = CC(I-1, 3, K) - CC(I-1, 4, K)
            TR3 = CC(I-1, 3, K) + CC(I-1, 4, K)
            CH(I-1, K, 1) = CC(I-1, 1, K) + TR2 + TR3
            CH(I, K, 1) = CC(I, 1, K) + TI2 + TI3
            CR2 = CC(I-1, 1, K) + TR11*TR2 + TR12*TR3
            CI2 = CC(I, 1, K) + TR11*TI2 + TR12*TI3
            CR3 = CC(I-1, 1, K) + TR12*TR2 + TR11*TR3
            CI3 = CC(I, 1, K) + TR12*TI2 + TR11*TI3
            CR5 = TI11*TR5 + TI12*TR4
            CI5 = TI11*TI5 + TI12*TI4
            CR4 = TI12*TR5 - TI11*TR4
            CI4 = TI12*TI5 - TI11*TI4
            DR3 = CR3 - CI4
            DR4 = CR3 + CI4
            DI3 = CI3 + CR4
            DI4 = CI3 - CR4
            DR5 = CR2 + CI5
            DR2 = CR2 - CI5
            DI5 = CI2 - CR5
            DI2 = CI2 + CR5
            CH(I-1, K, 2) = WA1(I-1)*DR2 - WA1(I)*DI2
            CH(I, K, 2) = WA1(I-1)*DI2 + WA1(I)*DR2
            CH(I-1, K, 3) = WA2(I-1)*DR3 - WA2(I)*DI3
            CH(I, K, 3) = WA2(I-1)*DI3 + WA2(I)*DR3
            CH(I-1, K, 4) = WA3(I-1)*DR4 - WA3(I)*DI4
            CH(I, K, 4) = WA3(I-1)*DI4 + WA3(I)*DR4
            CH(I-1, K, 5) = WA4(I-1)*DR5 - WA4(I)*DI5
            CH(I, K, 5) = WA4(I-1)*DI5 + WA4(I)*DR5
 100     CONTINUE
 200  CONTINUE
      RETURN
      END

      SUBROUTINE ZRLR64 (NVAL, NP, INB, OUTB)
C-----------------------------------------------------------------------
C! convert buffer of local double precision values to IEEE 64-bit float.
C# Z Binary
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Converts from local double precision (or corresponding 64 bit
C   precision) to 64 bit IEEE floating format.
C
C   The IEEE format is:
C
C                1         2         3         4         5         6
C      0123456789012345678901234567890123456789012345678901234567890123
C      seeeeeeeeeeemmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
C
C   where sign = -1 ** s, exponent = eee..., mantissa = 1.mmmmm...
C
C   The value is given by:
C
C      value = sign * 2 **(exp-1023) * mantissa
C
C   Note: these values have a "hidden" bit and must always be normalized
C   The IEEE nan (not a number) values are used to indicate an invalid
C   number; a value with all bits set is recognized as a "nan".
C
C   The AIPS internal format for an invalid number is the value which
C   has the same bit pattern as 'INDE    '.
C
C   The IEEE special values (-0., +/- Infty) are not recognized.
C
C   A multiplication by a factor of 4.0 converts between VAX G and IEEE
C   64 bit formats.
C
C   Inputs:
C      NVAL   I      Number of values to convert
C      NP     I      First location in OUTB for results
C      INB    D(*)   Local format values
C   Output:
C      OUTB   D(*)   64-bit IEEE format values ('INDE    ' values are
C                    replaced with "nan")
C   Generic version  - does IEEE and VAX G formats for 32-bit machines,
C   is stubbed with STOP for all others.
C-----------------------------------------------------------------------
      INTEGER   NVAL, NP
      DOUBLE PRECISION INB(*), OUTB(*)
C
      INTEGER   LOOP, I4NAN(2), J
      DOUBLE PRECISION R8NAN
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (I4NAN, R8NAN)
C                                       Equivalence should yield
C                                       R8NAN = FFFFFFFFFFFFFFFF
      DATA I4NAN /-1, -1/
C-----------------------------------------------------------------------
      IF (NVAL.LE.0) GO TO 999
C                                       only works for 32-bit words
      IF ((NBITWD.NE.32) .OR. (NWDPDP.NE.2)) THEN
         WRITE (MSGTXT,1000) NBITWD, NWDPDP
         CALL MSGWRT (10)
         STOP 'ZRLR64 NEEDS LOCAL DEVELOPMENT'
C                                       IEEE floating-point - copy
      ELSE
         IF (DPFRMT.EQ.1) THEN
            DO 10 LOOP = 1,NVAL
               J = LOOP + NP - 1
               IF (INB(LOOP).EQ.DBLANK) THEN
                  OUTB(J) = R8NAN
               ELSE
                  OUTB(J) = INB(LOOP)
                  END IF
 10            CONTINUE
C                                       Flip bytes & words if necessary
            CALL ZBFLIP (8, NVAL, OUTB(NP), OUTB(NP))
C                                       VAX G - multiply by 4
         ELSE IF (DPFRMT.EQ.3) THEN
            DO 20 LOOP = 1,NVAL
               J = LOOP + NP - 1
               IF (INB(LOOP).EQ.DBLANK) THEN
                  OUTB(J) = R8NAN
               ELSE
                  OUTB(J) = INB(LOOP) * 0.250D0
                  END IF
 20            CONTINUE
            CALL ZBFLIP (8, NVAL, OUTB(NP), OUTB(NP))
C                                       VAX F, IBM not easy
         ELSE
            WRITE (MSGTXT,1020) DPFRMT
            CALL MSGWRT (10)
            STOP 'ZRLR64 NEEDS LOCAL DEVELOPMENT'
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZR64RL: REQUIRES LOCAL DEVELOPMENT FOR NBITWD =',I3,
     *   ' NWDPDP =',I2)
 1020 FORMAT ('ZR64RL: REQUIRES LOCAL DEVELOPMENT FOR DPFRMT =',I7)
      END

      SUBROUTINE FQMATC (DISK, CNO, CATTMP, LUN, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, IRET)
C-----------------------------------------------------------------------
C! Check if selection criteria match FQ table entries.
C# UV IO-appl Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to determine if the frequency selection adverbs match
C   entries in the FQ table.
C   Inputs:
C     DISK           I            Volume number
C     CNO            I            Catalogue. number
C     CATTMP(256)    I            catalogue header
C     LUN            I            LUN
C     SELBAN         R            Bandwidth requested
C     SELFRQ         D            Frequency requested
C   Input (via common DUVH)
C     ILOCFQ         I            FRQSEL random parm pointer
C
C   Outputs:
C     MATCH          L            True if match
C     FRQSEL         I            FQ ID number which matches
C     IRET           I            Error code, 0 => OK
C                                 > 0 => FQ table error
C-----------------------------------------------------------------------
      LOGICAL  MATCH
      INTEGER  DISK, CNO, CATTMP(256), LUN, FRQSEL, IRET
      REAL     SELBAN
      DOUBLE PRECISION SELFRQ
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER  NIF, NUMFQE, FQID, FQSID(MAXIF), I, CATEQU(256), VER,
     *   FQKOLS(MAXFQC), FQNUMV(MAXFQC), IFQRNO, FQBUFF(512)
      REAL     FQCHB(MAXIF), FQTBW(MAXIF), TOL, HZBAN, HZFREQ
      DOUBLE PRECISION FQFRQ(MAXIF), CATD(128), REFF, ACTFRQ
      LOGICAL  FRQOK, T, F, NOBAND, DOFQS, TABLE, CHEXIS, FITASC
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATEQU, CATD)
      DATA T, F /.TRUE., .FALSE./
C-----------------------------------------------------------------------
      CALL COPY (256, CATTMP, CATEQU)
      REFF = CATD(KDCRV+JLOCF)
C                                       Do we need to check
      MATCH = T
      IRET = 0
C                                       Is FRQ r.p. present
      IF (ILOCFQ.LT.0) THEN
         FRQSEL = -1
         SELBAN = 0.0
         SELFRQ = 0.D0
         GO TO 999
         END IF
C                                       Check for CH table, remote
C                                       possibility is present
      CALL ISTAB ('CH', DISK, CNO, 1, LUN, FQBUFF, TABLE, CHEXIS,
     *   FITASC, IRET)
      IF (CHEXIS) THEN
         FRQSEL = 1
         SELBAN = 0.0
         SELFRQ = 0.D0
         MATCH = T
         IRET = 0
         GO TO 999
         END IF
C                                       Are selection adverbs set?
      DOFQS = FRQSEL.GT.0
      NOBAND = (SELBAN.LE.0.0) .AND. (SELFRQ.LE.0.D0)
C
      MATCH = F
      HZBAN = SELBAN * 1.0E3
      HZFREQ = SELFRQ * 1.0E6
      FRQOK = F
C                                       Open FQ table
      VER = 1
      CALL FQINI ('READ', FQBUFF, DISK, CNO, VER, CATTMP, LUN, IFQRNO,
     *   FQKOLS, FQNUMV, NIF, IRET)
      IF (IRET.NE.0) GO TO 999
      NUMFQE = FQBUFF(5)
C
      DO 100 I = 1,NUMFQE
         IFQRNO = I
         CALL TABFQ ('READ', FQBUFF, IFQRNO, FQKOLS, FQNUMV, NIF, FQID,
     *      FQFRQ, FQCHB, FQTBW, FQSID, BNDCOD, IRET)
         IF (IRET.NE.0) GO TO 999
C
         IF ((.NOT.DOFQS) .AND. (NOBAND)) THEN
            FRQSEL = FQID
            MATCH = T
            WRITE (MSGTXT,1020) FRQSEL
            IF (NUMFQE.GT.1) CALL MSGWRT (6)
            CALL TABIO ('CLOS', 0, IFQRNO, FQBUFF, FQBUFF, IRET)
            GO TO 999
            END IF
         IF (DOFQS .AND. NOBAND) THEN
            IF (FRQSEL.EQ.FQID) THEN
               MATCH = T
               CALL TABIO ('CLOS', 0, IFQRNO, FQBUFF, FQBUFF, IRET)
               GO TO 999
               END IF
            GO TO 100
            END IF
C                                       Use SELBAN/SELFRQ
         ACTFRQ = REFF + FQFRQ(1)
         IF (SELBAN.GT.0.0) THEN
            TOL = (SELBAN/4.0) * 1.0E3
         ELSE
            TOL = FQTBW(1)/4.0
            END IF
C
         IF ((ACTFRQ .LT. (HZFREQ+TOL)) .AND.
     *       (ACTFRQ .GT. (HZFREQ-TOL))) FRQOK = T
C
         IF (MATCH .AND. FRQOK .AND. (HZBAN.EQ.FQTBW(1))) THEN
            MATCH = F
            WRITE (MSGTXT,1000)
            CALL TABIO ('CLOS', 0, IFQRNO, FQBUFF, FQBUFF, IRET)
            GO TO 990
            END IF
         IF (FRQOK .AND. (HZBAN.EQ.FQTBW(1))) THEN
            MATCH = T
            FRQSEL = FQID
            FRQOK = F
            END IF
 100     CONTINUE
C                                       No match to FRQSEL
      IF (DOFQS .AND. NOBAND) THEN
         WRITE (MSGTXT,1030) FRQSEL
         IRET = 1
         CALL TABIO ('CLOS', 0, IFQRNO, FQBUFF, FQBUFF, IRET)
         GO TO 990
         END IF
C                                       Close table
      CALL TABIO ('CLOS', 0, IFQRNO, FQBUFF, FQBUFF, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FQMATC: MULTIPLE MATCH TO SELBAN & SELFREQ, USE FREQID')
 1010 FORMAT ('FQMATC: NO FREQ. SELECTION ADVERBS SET - CHECK INPUTS')
 1020 FORMAT ('FQMATC: Setting FQ id number = ',I4)
 1030 FORMAT ('FQMATC: FREQID = ',I4,' HAS NO MATCH IN FQ TABLE')
      END

      SUBROUTINE PLDRW (XVAL, YVAL, IRET)
C-----------------------------------------------------------------------
C! draw line to new pixel position from current pixel position in buffer
C# Utility Plot
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Draw a line to the pixel posn. defined by data values (XVAL, YVAL)
C   Inputs:
C      XVAL    R     x-coordinate value
C      YVAL    R     y-coordinate value
C   Outputs:
C      IRET    I     Return code (0 => ok)
C---------------------------------------------------------------------
      REAL XVAL, YVAL
      INTEGER IRET
C
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DPLD.INC'
      DOUBLE PRECISION DXSCAL, DYSCAL
      REAL XPIX, YPIX
C---------------------------------------------------------------------
C                                       Scale X,Y values
      DXSCAL = XVAL * XPFACT
      DYSCAL = YVAL * YPFACT
C                                       Compute pixel position
      CALL XYPIX (DXSCAL, DYSCAL, XPIX, YPIX, IRET)
C                                       Check if out of range
      IF (IRET.EQ.0) THEN
         XPIX = MIN (XPIX, PLTRC(1))
         XPIX = MAX (XPIX, PLBLC(1))
         YPIX = MIN (YPIX, PLTRC(2))
         YPIX = MAX (YPIX, PLBLC(2))
C                                       Go to pixel position
         CALL GVEC (XPIX, YPIX, PLTBLK, IRET)
         END IF
C                                       Exit
 999  RETURN
      END

      SUBROUTINE QCFT3D (SIGN, LEN1, LEN2, LEN3, A, LDA1, LDA2, WSAVE)
C-----------------------------------------------------------------------
C! Pseudo AP routine: complex-to-complex 3D FFT
C# AP-FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Replace A(1:LEN1, 1:LEN2, 1:LEN3) with its two dimensional DFT
C   (see QCFT1D). Calling QCFT1D with SIGN = +1 and then with SIGN = -1
C   on the same array has the effect of multiplying each element of the
C   array by LEN1*LEN2*LEN3.
C
C   The following conditions must be true (FFTMAX is defined in
C   INCS:PFFT.INC)
C
C   0 < LEN2 <= FFTMAX
C   0 < LEN3 <= FFTMAX
C   LEN1 <= LDA1
C   LEN2 <= LDA2
C   SIGN = +1 or SIGN = -1
C   WSAVE has been initialized by calling QCFT2I
C
C   This routine may be optimized for parallel execution on machines
C   that support this.
C
C   Input:
C      SIGN       I          Direction of transform (see QCFT1D)
C      LEN1       I          Rows to be transformed
C      LEN2       I          Columns to be transformed
C      LEN3       I          Planes to be transformed
C      LDA1       I          Leading dimension of A
C      LDA2       I          Second dimension of A
C      WSAVE      R(*)       Initialized workspace (from QCFT3I)
C   Input/Output:
C      ARRAY      C(LDA1, LDA2, *)
C                            Array to be transformed: replaced by its
C                            transform
C-----------------------------------------------------------------------
      INTEGER   SIGN, LEN1, LEN2, LEN3, LDA1, LDA2
      COMPLEX   A(LDA1,LDA2,*)
      REAL      WSAVE(*)
C
      INCLUDE 'INCS:PFFT.INC'
      COMPLEX   SCRTCH(FFTMAX)
      INTEGER   IDX3
      INTEGER   I, J, K
C-----------------------------------------------------------------------
      IDX3 = FTWMUL * (LEN1 + LEN2) + 2 * FTWADD + 1
C                                       Transform planes:
      IF ((LEN1.GT.1) .OR. (LEN2.GT.1)) THEN
         DO 10 K = 1,LEN3
            CALL QCFT2D (SIGN, LEN1, LEN2, A(1, 1, K), LDA1, WSAVE(1))
 10         CONTINUE
         END IF
C                                       Transform third dimension
      IF (LEN3.GT.1) THEN
         DO 50 J = 1,LEN2
            DO 40 I = 1,LEN1
               DO 20 K = 1,LEN3
                  SCRTCH(K) = A(I,J,K)
 20               CONTINUE
               CALL QCFT1D (SIGN, LEN3, SCRTCH, WSAVE(IDX3))
               DO 30 K = 1,LEN3
                  A(I,J,K) = SCRTCH(K)
 30               CONTINUE
 40            CONTINUE
 50         CONTINUE
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'TX2IM.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQOU, DISKOU, NEWCNO, JBUFSZ, ICODE, NVAL, SCRTCH(512)
      HOLLERITH XNAMEO(3), XCLAOU(2), XINFIL(12), XAXTYP(2), XSORC(4),
     *   XDATE(2)
      CHARACTER NAMEOU*12, CLAOU*6, INFILE*48, AXTYPE*8, BUNIT*8,
     *   SRCNAM*16, OBSDAT*8
      REAL      XSEQOU, XDISKO, COORD(6), REFREQ, BUFF1(MABFSS)
      DOUBLE PRECISION XX(16384), XV(16384), FREQ0
      COMMON /INPARM/ XNAMEO, XCLAOU, XSEQOU, XDISKO, XINFIL, XAXTYP,
     *   COORD, REFREQ, XSORC, XDATE
      COMMON /CHPARM/ NAMEOU, CLAOU, INFILE, AXTYPE, BUNIT, OBSDAT,
     *   SRCNAM
      COMMON /PARMS/ SEQOU, DISKOU, NEWCNO, JBUFSZ, ICODE, NVAL
      COMMON /BUFRS/ XX, XV, FREQ0, BUFF1, SCRTCH
LOCAL END
      PROGRAM TX2IM
C-----------------------------------------------------------------------
C! Convert 1-D text file to 1-D cataloged image
C# Map-util Analysis
C-----------------------------------------------------------------------
C;  Copyright (C) 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TX2IM converts 1-D text file to 1-D image
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEOU        Name of input image.
C      INCLASS        CLAOU         Class of input image.
C      INSEQ          SEQOU         Seq. of input image.
C      INDISK         DISKOU        Disk number of input image.
C      INFILE         INFILE        Text file
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'TX2IM.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'TX2IM '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL TX2IMI (PRGM, IRET)
C                                       Call routine that sends data
C                                       to the user routine.
      IF (IRET.EQ.0) CALL TX2IMR (IRET)
C                                       History
      IF (IRET.EQ.0) CALL TX2IMH
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE TX2IMI (PRGN, IRET)
C-----------------------------------------------------------------------
C   TX2IMI gets input parameters for TX2IM and creates an output text
C   file.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      INTEGER   IERR, NPARM, IROUND
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'TX2IM.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      LOCNUM = 1
C                                       Get input parameters.
      NPARM = 34
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, ' OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMEO, NAMEOU)
      CALL H2CHR (6, 1, XCLAOU, CLAOU)
      CALL H2CHR (8, 1, XAXTYP, AXTYPE)
      CALL H2CHR (48, 1, XINFIL, INFILE)
      CALL H2CHR (16, 1, XSORC, SRCNAM)
      CALL H2CHR (16, 1, XDATE, OBSDAT)
C                                       Crunch input parameters.
      SEQOU = IROUND (XSEQOU)
      DISKOU = IROUND (XDISKO)
      IF (INFILE.EQ.' ') THEN
         MSGTXT = 'INFILE MUST BE SPECIFIED'
         GO TO 990
         END IF
C                                       Get the data
      CALL READIT (IERR)
      IF (IERR.NE.0) GO TO 999
      IF (NAMEOU.EQ.' ') NAMEOU = 'NO NAME'
      IF (CLAOU.EQ.' ') CLAOU = TSKNAM
      CALL CHR2H (12, NAMEOU, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOU, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOU
C                                       Create output file.
      NEWCNO = 1
      CALL MCREAT (DISKOU, NEWCNO, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATING OUTPUT IMAGE'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKOU
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TX2IMI: ERROR',I3,' ON ',A)
      END
      SUBROUTINE READIT (IRET)
C-----------------------------------------------------------------------
C     READIT reads the spectrum and any header data
C     Output
C     IRET  i   error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'TX2IM.INC'
      INTEGER   I, J, K, JTRIM, TLUN, TIND, LPLIM, LP, M, HM(2), JF,
     *   JR, JD, JS, ALTCOD
      CHARACTER INLINE*128, CTYPE(7)*8, CHM*1
      REAL      SEC, ALTPIX
      DOUBLE PRECISION CRVAL(2,7), X, CDELT(7), RA, DEC, RESTFR, ALTVAL,
     *   CRPIX(7)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      DO 5 I = 1,7
         CRVAL(1,I) = 0.0D0
         CRVAL(2,I) = 0.0D0
         CTYPE(I) = ' '
         CDELT(I) = 0.0D0
 5       CONTINUE
      BUNIT = ' '
      RESTFR = 0.0D0
      ALTVAL = 0.0D0
      ALTPIX = 0.0
      ALTCOD = 0
      NVAL = 0
      TLUN = 3
      CALL ZTXOPN ('READ', TLUN, TIND, INFILE, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT TEXT FILE'
         GO TO 990
         END IF
 10   CALL ZTXIO ('READ', TLUN, TIND, INLINE, IRET)
      IF (IRET.EQ.2) THEN
         CALL ZTXCLS (TLUN, TIND, IRET)
         GO TO 100
      ELSE IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING INPUT TEXT FILE'
         GO TO 990
      ELSE IF (INLINE(:1).EQ.'#') THEN
         LPLIM = JTRIM (INLINE)
         IF (INLINE(2:5).EQ.'Data') THEN
            I = INDEX (INLINE, '''')
            K = INDEX (INLINE(I+1:), '''')
            IF (K.EQ.0) THEN
               K = I + 9
            ELSE
               K = K + I
               K = MIN (K, LPLIM)
               END IF
            AXTYPE = INLINE(I+1:K-1)
         ELSE IF (INLINE(2:5).EQ.'INFO') THEN
            LP = INDEX (INLINE, 'BUNIT')
            IF (LP.GT.0) THEN
               I = INDEX (INLINE(LP:), '''')
               I = LP + I
               K = INDEX (INLINE(I:), '''')
               K = K + I - 1
               BUNIT = INLINE(I:K)
               END IF
            LP = INDEX (INLINE, 'OBSDATE')
            IF (LP.GT.0) THEN
               I = INDEX (INLINE(LP:), '''')
               I = LP + I
               K = INDEX (INLINE(I:), '''')
               K = K + I - 1
               OBSDAT = INLINE(I:K)
               END IF
            LP = INDEX (INLINE, 'SRCNAME')
            IF (LP.GT.0) THEN
               I = INDEX (INLINE(LP:), '''')
               I = LP + I
               K = INDEX (INLINE(I:), '''')
               K = K + I - 1
               SRCNAM = INLINE(I:K)
               END IF
            LP = INDEX (INLINE, 'ALTCODE')
            IF (LP.GT.0) THEN
               LP = LP + 7
               CALL GETNUM (INLINE, LPLIM, LP, X)
               IF (X.NE.DBLANK) ALTCOD = X + 0.01
               END IF
            LP = INDEX (INLINE, 'RESTFREQ')
            IF (LP.GT.0) THEN
               LP = LP + 8
               CALL GETNUM (INLINE, LPLIM, LP, X)
               IF (X.NE.DBLANK) RESTFR = X
               END IF
            LP = INDEX (INLINE, 'ALTVAL')
            IF (LP.GT.0) THEN
               LP = LP + 6
               CALL GETNUM (INLINE, LPLIM, LP, X)
               IF (X.NE.DBLANK) ALTVAL = X
               END IF
            LP = INDEX (INLINE, 'ALTPIX')
            IF (LP.GT.0) THEN
               LP = LP + 6
               CALL GETNUM (INLINE, LPLIM, LP, X)
               IF (X.NE.DBLANK) ALTPIX = X
               END IF
         ELSE IF (INLINE(2:5).EQ.'HEAD') THEN
            LP = INDEX(INLINE, ' ')
            CALL GETNUM (INLINE, LPLIM, LP, X)
            IF (X.EQ.DBLANK) GO TO 10
            M = X + 0.1
            IF ((M.LT.1) .OR. (M.GT.7)) THEN
               WRITE (MSGTXT,1010) M
               CALL MSGWRT (6)
               GO TO 10
               END IF
            I = INDEX (INLINE, '''')
            IF (I.GT.0) THEN
               K = INDEX (INLINE(I+1:), '''')
               IF (K.EQ.0) THEN
                  K = I + 9
               ELSE
                  K = K + I
                  K = MIN (K, LPLIM)
                  END IF
               CTYPE(M) = INLINE(I+1:K-1)
               END IF
            I = INDEX (INLINE, 'Refval')
            IF (I.GT.0) THEN
               LP = I + 6
               CALL GETNUM (INLINE, LPLIM, LP, X)
               IF (X.EQ.DBLANK) GO TO 10
               CRVAL(1,M) = X
               END IF
            I = INDEX (INLINE, 'Cdelt')
            IF (I.GT.0) THEN
               LP = I + 5
               CALL GETNUM (INLINE, LPLIM, LP, X)
               IF (X.EQ.DBLANK) GO TO 10
               CDELT(M) = X
               END IF
            I = INDEX (INLINE, 'Refpix')
            IF (I.GT.0) THEN
               LP = I + 6
               CALL GETNUM (INLINE, LPLIM, LP, X)
               IF (X.EQ.DBLANK) GO TO 10
               CRPIX(M) = X
               END IF
            I = INDEX (INLINE, 'AvgValue')
            IF (I.GT.0) THEN
               LP = I + 8
               CALL GETNUM (INLINE, LPLIM, LP, X)
               IF (X.EQ.DBLANK) GO TO 10
               CRVAL(2,M) = X
               END IF
            END IF
      ELSE
         LPLIM = JTRIM (INLINE)
         LP = 1
         CALL GETNUM (INLINE, LPLIM, LP, X)
         IF (X.EQ.DBLANK) GO TO 10
         XX(NVAL+1) = X
         CALL GETNUM (INLINE, LPLIM, LP, X)
         IF (X.EQ.DBLANK) GO TO 10
         XV(NVAL+1) = X
         NVAL = NVAL + 1
         END IF
      GO TO 10
C                                       build header
 100  CALL CATINI (CATBLK)
C                                       check header
      JF = 0
      JR = 0
      JD = 0
      JS = 0
      LP = 0
      IF (AXTYPE(:4).EQ.'FREQ') JF = -1
      IF (AXTYPE(:2).EQ.'RA') JR = -1
      IF (AXTYPE(:3).EQ.'DEC') JD = -1
      IF (AXTYPE(:4).EQ.'STOK') JS = -1
      DO 110 I = 1,7
         IF (CTYPE(I).NE.' ') LP = LP + 1
         IF (CTYPE(I)(:4).EQ.'FREQ') JF = I
         IF (CTYPE(I)(:2).EQ.'RA') JR = I
         IF (CTYPE(I)(:3).EQ.'DEC') JD = I
         IF (CTYPE(I)(:4).EQ.'STOK') JS = I
 110     CONTINUE
      IF ((JR.EQ.0) .AND. (LP.LE.6)) THEN
         LP = LP + 1
         CTYPE(LP) = 'RA'
         END IF
      IF ((JD.EQ.0) .AND. (LP.LE.6)) THEN
         LP = LP + 1
         CTYPE(LP) = 'DEC'
         END IF
      IF ((JF.EQ.0) .AND. (LP.LE.6)) THEN
         LP = LP + 1
         CTYPE(LP) = 'FREQ'
         END IF
      IF ((JS.EQ.0) .AND. (LP.LE.6)) THEN
         LP = LP + 1
         CTYPE(LP) = 'STOKES'
         CRVAL(1,LP) = 1.0D0
         END IF
      IF (BUNIT.EQ.' ') BUNIT = 'JY/BEAM'
      IF (SRCNAM.EQ.' ') SRCNAM = 'Source ?'
C                                       build header
      CALL CHR2H (8, BUNIT, 1, CATH(KHBUN))
      CALL CHR2H (8, SRCNAM, 1, CATH(KHOBJ))
      CALL CHR2H (8, OBSDAT, 1, CATH(KHDOB))
      CATD(KDRST) = RESTFR
      CATD(KDARV) = ALTVAL
      CATR(KRARP) = ALTPIX
      CATBLK(KIALT) = ALTCOD
      CATBLK(KIDIM) = 1
      CALL CHR2H (8, AXTYPE, 1, CATH(KHCTP))
      CATBLK(KINAX) = NVAL
      J = 0
      DO 150 I = 1,7
         IF (CTYPE(I).EQ.AXTYPE) THEN
            CATD(KDCRV) = CRVAL(1,I)
            CATR(KRCIC) = CDELT(I)
            CATR(KRCRP) = CRPIX(I)
         ELSE IF (CTYPE(I).NE.' ') THEN
            IF (CRVAL(2,I).NE.0.0D0) CRVAL(1,I) = CRVAL(2,I)
            J = J + 1
            IF (J.LE.6) THEN
               CATBLK(KIDIM) = CATBLK(KIDIM) + 1
               CALL CHR2H (8, CTYPE(I), 1, CATH(KHCTP+2*J))
               IF (CRVAL(1,I).EQ.0.0D0) THEN
                  IF (CTYPE(I).EQ.'FREQ') CRVAL(1,I) = REFREQ*1.D9
                  IF (CTYPE(I)(:2).EQ.'RA') CRVAL(1,I) = 15.0D0 *
     *               (COORD(1) + COORD(2)/60.0D0 + COORD(3)/3600.D0)
                  IF (CTYPE(I)(:3).EQ.'DEC') THEN
                     CRVAL(1,I) = ABS(COORD(4)) + ABS(COORD(2))/6.D1 +
     *                  ABS(COORD(3))/3.6D3
                     IF ((COORD(4).LT.0.) .OR. (COORD(5).LT.0.) .OR.
     *                  (COORD(6).LT.0.)) CRVAL(1,I) = -CRVAL(1,I)
                     END IF
                  END IF
               IF (CTYPE(I).EQ.'FREQ') FREQ0 = CRVAL(1,I)
               IF (CTYPE(I).EQ.'FQID') CRVAL(1,I) = 1.0D0
               IF (CTYPE(I)(:2).EQ.'RA') RA = CRVAL(1,I)
               IF (CTYPE(I)(:3).EQ.'DEC') DEC = CRVAL(1,I)
               CATD(KDCRV+J) = CRVAL(1,I)
               CATR(KRCIC+J) = CDELT(I)
               END IF
            END IF
 150     CONTINUE
      REFREQ = FREQ0 / 1.D9
      CALL COORDD (1, RA, CHM, HM, SEC)
      COORD(1) = HM(1)
      COORD(2) = HM(2)
      COORD(3) = SEC
      CALL COORDD (2, DEC, CHM, HM, SEC)
      COORD(4) = HM(1)
      COORD(5) = HM(2)
      COORD(6) = SEC
      IF (CHM.EQ.'-') THEN
         COORD(4) = -COORD(4)
         IF (COORD(4).EQ.0.) COORD(5) = -COORD(5)
         IF ((COORD(4).EQ.0.) .AND. (COORD(5).EQ.0.)) COORD(6) =
     *      -COORD(6)
         END IF
C
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('READIT ERROR',I4,' ON ',A)
 1010 FORMAT ('READIT BAD AXIS NUMBER',I5)
      END
      SUBROUTINE TX2IMR (IRET)
C-----------------------------------------------------------------------
C   TX2IMR copies data to image file, fixes header for the axis,
C   writes an FQ table if needed
C   Output
c      IRET   I   error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   I, LUNO, INDO, NX, NY, WIN(4), BOI, VER, LUN, IFQRNO,
     *   FQKOLS(MAXFQC), FQNUMV(MAXFQC), NUMIF, FQID, IFSIDE, IBIND
      REAL      OUTMAX, OUTMIN, IFCHW, IFTBW
      CHARACTER IFILE*48, BNDCOD*8, CTYPE*8
      LOGICAL   T, F
      DOUBLE PRECISION S, SS, IFFREQ

      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'TX2IM.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      CALL ZPHFIL ('MA', DISKOU, NEWCNO, 1, IFILE, IRET)
      LUNO = 18
      CALL ZOPEN (LUNO, INDO, DISKOU, IFILE, T, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OUPUT IMAGE'
         GO TO 990
      END IF
      NX = NVAL
      NY = 1
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NX
      WIN(4) = NY
      OUTMAX = -1.0E30
      OUTMIN = 1.0E30
      BOI = 1
      CALL MINIT ('WRIT', LUNO, INDO, NX, NY, WIN, BUFF1, JBUFSZ, BOI,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT I/O TO IMAGE FILE'
         GO TO 990
         END IF
      CALL MDISK ('WRIT', LUNO, INDO, BUFF1, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE TO IMAGE FILE'
         GO TO 990
         END IF
      DO 20 I = 1,NVAL
         IF (XV(I).LT.OUTMIN) OUTMIN = XV(I)
         IF (XV(I).GT.OUTMAX) OUTMAX = XV(I)
         BUFF1(IBIND+I-1) = XV(I)
 20      CONTINUE
      CALL MDISK ('FINI', LUNO, INDO, BUFF1, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINISH IMAGE FILE'
         GO TO 990
         END IF
      CATR(KRDMN) = OUTMIN
      CATR(KRDMX) = OUTMAX
C                                       study increments
      CALL H2CHR (8, 1, CATH(KHCTP), CTYPE)
      IF (CTYPE.NE.'FQID') THEN
         S = 0.0D0
         SS = 0.0D0
         DO 30 I = 2,NVAL
            S = S + XX(I) - XX(I-1)
            SS = SS + (XX(I)-XX(I-1)) ** 2
 30         CONTINUE
         S = S / (NVAL-1)
         SS = SS / (NVAL-1) - S * S
         SS = SQRT (MAX(0.0D0,SS))
         IF (ABS(SS/S).GT.0.05) THEN
            WRITE (MSGTXT,1030) S, SS
            CALL MSGWRT (5)
            END IF
         CATR(KRCIC) = S
      ELSE
         CATD(KDCRV) = 1.0D0
         VER = 1
         LUN = 20
         NUMIF = 1
         CALL FQINI ('WRIT', SCRTCH, DISKOU, NEWCNO, VER, CATBLK, LUN,
     *      IFQRNO, FQKOLS, FQNUMV, NUMIF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATE FQ TABLE'
            GO TO 990
         END IF
         IFSIDE = 1
         IFCHW = 0.0
         IFTBW = 0.0
         BNDCOD = ' '
         DO 50 I = 1,NVAL
            IFQRNO = I
            IFFREQ = XX(I) - FREQ0
            FQID = I
            CALL TABFQ ('WRIT', SCRTCH, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *         FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITING FQ TABLE'
               GO TO 990
               END IF
 50         CONTINUE
C                                       close
         CALL TABFQ ('CLOS', SCRTCH, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *      FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, VER)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TX2IMR ERROR',I4,' ON ',A)
 1030 FORMAT ('AVERAGE INCREMENT',1PE12.4,' RMS LARGE',1PE12.4)
      END
      SUBROUTINE TX2IMH
C-----------------------------------------------------------------------
C     Creates and fills history file
C-----------------------------------------------------------------------
C
      INCLUDE 'TX2IM.INC'
      INTEGER   HLUN, TLUN, TIND, IRET, HBUFF(256), J, JTRIM
      CHARACTER INLINE*128, HILINE*72
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      CALL HIINIT (1)
      HLUN = 27
      CALL HICREA (HLUN, DISKOU, NEWCNO, CATBLK, HBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATE HISTORY FILE'
         GO TO 990
      END IF
      J = JTRIM (INFILE)
      HILINE = TSKNAM // 'INFILE=''' // INFILE(:J) // ''''
      CALL HIADD (HLUN, HILINE, HBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      HILINE = TSKNAM // 'AXTYPE=''' // AXTYPE // ''''
      CALL HIADD (HLUN, HILINE, HBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      WRITE (HILINE,1010) TSKNAM, COORD
      CALL HIADD (HLUN, HILINE, HBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      WRITE (HILINE,1015) TSKNAM, REFREQ
      CALL HIADD (HLUN, HILINE, HBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      J = JTRIM (SRCNAM)
      WRITE (HILINE,1020) TSKNAM, SRCNAM(:J)
      CALL HIADD (HLUN, HILINE, HBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      WRITE (HILINE,1025) TSKNAM, OBSDAT
      CALL HIADD (HLUN, HILINE, HBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                       input file info
      HILINE = TSKNAM // '/ Comments found in INFILE'
      CALL HIADD (HLUN, HILINE, HBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      TLUN = 3
      CALL ZTXOPN ('READ', TLUN, TIND, INFILE, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT TEXT FILE'
         GO TO 990
         END IF
 10   CALL ZTXIO ('READ', TLUN, TIND, INLINE, IRET)
      IF (IRET.EQ.2) THEN
         CALL ZTXCLS (TLUN, TIND, IRET)
         GO TO 100
      ELSE IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING INPUT TEXT FILE'
         GO TO 990
      ELSE IF (INLINE(:1).EQ.'#') THEN
         J = JTRIM (INLINE)
         J = MIN (J, 64)
         HILINE = TSKNAM // '/ ' // INLINE(:J)
         CALL HIADD (HLUN, HILINE, HBUFF, IRET)
         IF (IRET.NE.0) GO TO 980
      END IF
      GO TO 10
C
 100  CALL HICLOS (HLUN, .TRUE., HBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING HISTORY FILE'
         GO TO 990
      END IF
      GO TO 999
C
 980  WRITE (MSGTXT,1000) IRET, 'WRITING HISTORY FILE'
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TX2IMH ERROR',I4,' ON ',A)
 1010 FORMAT (A,'COORDINA=',2F4.0,F6.2,2F4.0,F6.2)
 1015 FORMAT (A,'REFREQ=',F10.5,' GHz')
 1020 FORMAT (A,'SRCNAME=''',A,'''')
 1025 FORMAT (A,'REFDATE=''',A,'''')
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER NPARMS
      PARAMETER (NPARMS=11)
      INTEGER AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
      INCLUDE 'INCS:PAOOF.INC'
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'BLC', 'TRC',
     *   'PIXRANGE',
     *   'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK'/
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOAINT, OOAINT,
     *   OOARE,
     *   OOACAR, OOACAR, OOAINT, OOAINT/
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 7,1, 7,1,
     *   2,1,
     *   12,1, 6,1, 1,1, 1,1/
LOCAL END
      PROGRAM IMCLP
C-----------------------------------------------------------------------
C! Clip an image to a specified range.
C# Task IMAGE-UTIL OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2010, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, IN*32, OUT*32
      REAL      PIXRA(2)
      INTEGER   IRET, BUFF1(256)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PAOOF.INC'
      DATA PRGM /'IMCLP'/
C                                       Startup
      CALL IMCOIN (PRGM, IN, PIXRA, OUT, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Clip
      CALL IMGCLP (IN, PIXRA, OUT, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       History
      CALL IMCOHI (IN, OUT)
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE IMCOIN (PRGN, IN, PIXRA, OUT, IRET)
C-----------------------------------------------------------------------
C   IMCOIN gets input parameters for IMCLP and creates the objects.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IN      C*?  Input image object
C      PIXRA   R(2) Range of pixel values desired
C      OUT     C*?  Output image object.
C      IRET    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6, IN*(*), OUT*(*)
      REAL      PIXRA(2)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NKEY1
C                                       NKEY1=no. adverbs for IN
      PARAMETER (NKEY1=10)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INAME*12, ONAME*12,
     *   OCLASS*6, CDUM*1
      REAL      RTEMP, RDUM(2)
      INTEGER   TYPE, DIM(3)
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs for IN
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'BLC', 'TRC',
     *   'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK'/
C                                       Rename
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'BLC', 'TRC',
     *   'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Get pixel range
      CALL OGET ('Input', 'PIXRANGE', TYPE, DIM, PIXRA, CDUM, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (PIXRA(1).GT.PIXRA(2)) THEN
C                                       PIXRA=(min,max)
         RTEMP = PIXRA(1)
         PIXRA(1) = PIXRA(2)
         PIXRA(2) = RTEMP
         END IF
C                                       Default outname = INNAME
      CALL OGET ('Input', 'INNAME', TYPE, DIM, RDUM, INAME, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'OUTNAME', TYPE, DIM, RDUM, ONAME, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (ONAME.EQ.'            ') THEN
         ONAME = INAME
         CALL OPUT ('Input', 'OUTNAME', TYPE, DIM, RDUM, ONAME, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Default OUTCLASS = 'IMCLP'
      CALL OGET ('Input', 'OUTCLASS', TYPE, DIM, RDUM, OCLASS, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (OCLASS.EQ.'      ') THEN
         OCLASS = 'IMCLP'
         CALL OPUT ('Input', 'OUTCLASS', TYPE, DIM, RDUM, OCLASS,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Create IN
      IN = 'Input image object'
      CALL CREATE (IN, 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, IN, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create output object
      OUT = 'Output image'
      CALL IMGCLN (IN, OUT, IRET)
      IF (IRET.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE IMCOHI (IN, OUT)
C-----------------------------------------------------------------------
C   Routine to write history file to output.
C   Inputs:
C      IN      C*?  Input object
C      OUT     C*?  Output object
C-----------------------------------------------------------------------
      CHARACTER IN*(*), OUT*(*)
C
      INTEGER   NADV
      PARAMETER (NADV=7)
      CHARACTER LIST(NADV)*8
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
     *   'BLC', 'TRC', 'PIXRANGE'/
C-----------------------------------------------------------------------
C                                        Copy old history
      CALL OHCOPY (IN, OUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                        New additions - copy adverb
C                                        values.
      CALL OHLIST ('Input', LIST, NADV, OUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       copy tables
      CALL IMCALT (IN, OUT, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'ERROR COPYING TABLES'
         CALL MSGWRT (6)
         END IF
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // OUT
      CALL MSGWRT (6)
 999  RETURN
      END
C   Note: the following really should go into the relevant class
C   libraries.  If this is done ARRCLP can be made more efficient by
C   using ARRIO rather than ARRREAD/ARRWRI and working directly in the
C   I/O buffer.
      SUBROUTINE IMGCLP (IN, RANGE, OUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Clips the values in the input image to a specifiec range.  Values
C   out of range are replaced with the closest value in the range.
C   Inputs:
C      IN     C*?   The name of the input image object.
C      RANGE  R(2)  Range of valid values
C      OUT    C*?   The name of the output image object.
C   Output:
C      IERR   I     Error return code, 0=OK, 1=don't match
C-----------------------------------------------------------------------
      CHARACTER IN*(*), OUT*(*)
      REAL      RANGE(2)
      INTEGER   IERR
C
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Setup OUT if necessary
      CALL IMCLNX (IN, OUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Open Images
      CALL IMGOPN (OUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 990
      CALL IMGOPN (IN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Process array
      CALL ARRCLP (IN, RANGE, OUT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Close Images
      CALL IMGCLO (OUT, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL IMGCLO (IN, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'IMGCLP: INPUT ' // IN
      CALL MSGWRT (7)
      MSGTXT = 'IMGCLP: OUTPUT ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE ARRCLP (IN, RANGE, OUT, IERR)
C-----------------------------------------------------------------------
C   Public
C   Clip an array to a specified range.
C   Only handles real (including blanked) arrays.
C   Inputs:
C      IN     C*32  The name of the input array object.
C      RANGE  R(2)  Range of allowed values.
C      OUT    C*32  The name of the output array object.
C   Output:
C      IERR   I     Error return code, 0=OK, 1=don't match
C-----------------------------------------------------------------------
      CHARACTER IN*(*), OUT*(*)
      REAL      RANGE(2)
      INTEGER   IERR
C
      INTEGER   BLC(7), TRC(7), LOOP2, LOOP3, LOOP4, LOOP5, LOOP6,
     *   LOOP7, LROW, LROWC, NAXIS(7), DIM(7), TYPE
      CHARACTER DATYPE*8, TIN*32, CDUMMY*1
      REAL      BLANK, RDUM
      LOGICAL   DOCMPL, ISBLNK
      INTEGER   MAXROW
      PARAMETER (MAXROW=4096)
      REAL      ROW(MAXROW)
      LOGICAL   VALID(MAXROW)
      INCLUDE 'INCS:DMSG.INC'
C-------------------------------------------------------------------
      IERR = 0
C     May need temporary object
      IF (IN.EQ.OUT) THEN
C     Create temporary output object
         TIN = 'Temporary IMAGE for ARRCLP'
         CALL IMGCOP (IN, TIN, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         TIN = IN
      END IF
C     Open arrays
      CALL ARROPN (TIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
C     Output
      CALL ARROPN (OUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
C     Clear output window
      CALL ARRCWI (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C     Check compatibility
      CALL ARRCHK (TIN, OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C     Window
      CALL ARRWIN (TIN, BLC, TRC, NAXIS, IERR)
      IF (IERR.NE.0) GO TO 995
C     Complex?
      CALL ARDGET (TIN, 'DATATYPE', TYPE, DIM, RDUM, DATYPE, IERR)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
C     Error if Complex
      IF(DOCMPL) THEN
         IERR = 1
         MSGTXT = 'ARRCLP: CANNOT DO COMPLEX ARRAYS'
         GO TO 990
      END IF
      IERR = 0
C     Blanking?
      CALL ARDGET (TIN, 'BLANK', TYPE, DIM, RDUM, CDUMMY, IERR)
      BLANK = RDUM
      ISBLNK = (BLANK.NE.0.0) .AND. (IERR.EQ.0)
      IERR = 0
C     Loop over array
      LROW = TRC(1) - BLC(1) + 1
      LROWC = LROW
      DO 700 LOOP7 = BLC(7),TRC(7)
         DO 600 LOOP6 = BLC(6),TRC(6)
            DO 500 LOOP5 = BLC(5),TRC(5)
               DO 400 LOOP4 = BLC(4),TRC(4)
                  DO 300 LOOP3 = BLC(3),TRC(3)
                     DO 200 LOOP2 = BLC(2),TRC(2)
C                                       Fetch input row
                        CALL ARREAD (TIN, DIM, ROW, IERR)

                        IF (IERR.GT.0) GO TO 995
C                                       Blanking?
                        IF (ISBLNK) THEN
C                                       Clip row with blanking
                           CALL CHKBLK (LROW, ROW, VALID)
                           CALL RVBCLP (ROW, VALID, RANGE, ROW, VALID,
     *                        LROW)
                           CALL SETBLK (LROW, VALID, ROW)
C                                       Clip row
                        ELSE
                           CALL RVCLP (ROW, RANGE, ROW, LROW)
                           END IF
                        CALL ARRWRI (OUT, DIM, ROW, IERR)
                        IF (IERR.GT.0) GO TO 995
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close files
      CALL ARRCLO (TIN, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (OUT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Delete temporary if necessary
      IF (TIN(1:32).NE.IN(1:32)) CALL IMGDES (TIN, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 990  CALL MSGWRT (7)
 995  MSGTXT = 'ARRCLP: INPUT ' // IN
      CALL MSGWRT (7)
      MSGTXT = 'ARRCLP: OUTPUT ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE RVCLP (IN1, RANGE, OUT, N)
C-----------------------------------------------------------------------
C   Public
C   Real vector clip
C   Inputs:
C      IN1    R(*)  Input vector
C      RANGE  R(2)  Range of valid values
C      N      I     Number of elements
C   Outputs:
C      OUT    R(*)  Output vector
C-----------------------------------------------------------------------
      INTEGER   N
      REAL      IN1(N), RANGE(2), OUT(N)
C
      INTEGER   LOOP
C-----------------------------------------------------------------------
      DO 100 LOOP = 1,N
         OUT(LOOP) =  IN1(LOOP)
         IF (OUT(LOOP).LT.RANGE(1)) OUT(LOOP) = RANGE(1)
         IF (OUT(LOOP).GT.RANGE(2)) OUT(LOOP) = RANGE(2)
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE RVBCLP (IN1, VALIN1, RANGE, OUT, VALOUT, N)
C-----------------------------------------------------------------------
C   Public
C   Real vector clip with blanking
C   Inputs:
C      IN1    R(*)  Input vector
C      VALIN1 L(*)  True if corresponding element of IN1 is valid.
C      RANGE  R(2)  Range of valid values
C      N      I     Number of elements
C   Outputs:
C      OUT    R(*)  Output vector
C      VALOUT L(*)  True if corresponding element of OUT is valid.
C-----------------------------------------------------------------------
      INTEGER   N
      REAL      IN1(N), RANGE(2), OUT(N)
      LOGICAL   VALIN1(N), VALOUT(N)
C
      INTEGER   LOOP
C-----------------------------------------------------------------------
      DO 100 LOOP = 1,N
         VALOUT(LOOP) = VALIN1(LOOP)
         IF (VALOUT(LOOP)) THEN
            OUT(LOOP) =  IN1(LOOP)
            IF (OUT(LOOP).LT.RANGE(1)) OUT(LOOP) = RANGE(1)
            IF (OUT(LOOP).GT.RANGE(2)) OUT(LOOP) = RANGE(2)
            END IF
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE CCSMEM (APCORE, IFIELD, DOSUM, CHANEL, NCHAN, JBUFSZ,
     *   LOGRID, MODSTA, MODEND, BUFF1, BUFF2, BUFF3, IRET)
C-----------------------------------------------------------------------
C! Transforms CLEAN components to a grid. - remaining in AP memory
C# AP-util Map UV Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 2008, 2015, 2018-2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CCSMEM transforms CLEAN components to GRD file.
C   Input:
C      IFIELD   I      FIELD number for grid.
C      DOSUM    L      If true sum the flux in each field
C      CHANEL   I      First channel to subtract in uv data
C      NCHAN    I      Number channels to subtract
C      JBUFSZ   I      Size of the buffers in bytes. The dimension of
C                      the buffers must be at least 4096.
C      LOGRID   I      AP pointer for start of FFTed model grid
C      MODSTA   I       First model to use
C      MODEND   I       Last model to use
C      CLEAN components for field IFIELD.
C   Output:
C      BUFF1    R(*)   Work buffer
C      BUFF2    R(*)   Work buffer
C      BUFF3    R(*)   Work buffer
C      IRET     I      Error return
C   Transform of additional CLEAN components left in AP memory.
C   memory version of CCSGRD.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   IFIELD, CHANEL, NCHAN, JBUFSZ, LOGRID, MODSTA, MODEND,
     *   IRET
      REAL      BUFF1(*), BUFF2(*), BUFF3(*)
      LOGICAL   DOSUM
C
      INTEGER   FIRST, NUMBER, MAXCMP, NUMCLN, JNUM, NAPGAU, NAPEX1,
     *   NAPGRD, NAPCMP, NAPCMS, APBUF, ONENY, TWONY, WRK1, WRK2,
     *   APSIZ, NLOAD, I, JLIM, NX, NY, CURGRD, LGRD, CCVSAV, LFIELD,
     *   TOTNUM, NEED, KAP, INPSAP
      LOGICAL   DOGAUS, WESET
      REAL      GPARMS(3), DU, DV, UU
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMOD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DAPM.INC'
C-----------------------------------------------------------------------
      INPSAP = PSAPNW
C                                       has DMOD.INC been set up?
      WESET = MODMAX.LE.0
      IF (WESET) THEN
         MODMAX = 1
         MODSTA = 1
         MODEND = 1
         MODFLD(1) = IFIELD
         MODCHN(1) = CHANEL
         MODNCH(1) = NCHAN
         MODCCV(1) = ABS(CCVER(IFIELD))
         MODCCB(1) = NSUBG(IFIELD)
         END IF
C                                       loop over requested grids
      MODGRD(MODSTA) = LOGRID
      TOTNUM = 0
      DO 100 LGRD = MODSTA,MODEND
         LFIELD = MODFLD(LGRD)
         CCVSAV = CCVER(LFIELD)
         CCVER(LFIELD) = MODCCV(LGRD)
         NX = FLDSZ(1,LFIELD) * OSFX + 0.1
         NY = FLDSZ(2,LFIELD) * OSFY + 0.1
C                                       Initialize flux sums.
         IF (DOSUM) FLUXG(LFIELD) = 0.0
C                                       Determine Area assignments in AP
         ONENY = NY
         TWONY = 2 * NY
         WRK1 = ONENY + 1
         WRK2 = TWONY + 1
         NAPGRD = MODGRD(LGRD)
         NAPCMP = NAPGRD + 2*NY*(NX/2+12) + 1
         MODGRD(LGRD+1) = NAPCMP
         NAPGAU = NAPCMP + WRK2
         NAPEX1 = NAPGAU + WRK1
         NAPCMS = NAPEX1 + WRK1
         APSIZ = PSAPNW * 1024
         MAXCMP = (APSIZ - NAPCMS) / 5
         NUMCLN = NCLNG(LFIELD) - MODCCB(LGRD) + 1
         IF (MAXCMP.LE.0) THEN
            NEED = (NAPCMS + 5 * NUMCLN - 1) / 1024 + 4 + INPSAP
            CALL QINIT (APCORE, NEED, 0, KAP)
            MAXCMP = (PSAPNW*1024 - NAPCMS) / 5
            END IF
         FIRST = MODCCB(LGRD)
         APBUF = NAPCMP
C                                       clear grid area
         NLOAD = NAPCMP - NAPGRD
         CALL QVCLR (APCORE, NAPGRD, 1, NLOAD)
         CALL QWR
C                                       Determine size of AP buffer for
         NLOAD = NAPCMS - NAPCMP - 3
         JLIM = NX / 2 + 1
C                                       Begin component loop.
 10      IF (FIRST.LE.NCLNG(LFIELD)) THEN
            NUMBER = MIN (MAXCMP, NUMCLN)
C                                       Load CLEAN components this pass.
            JNUM = NUMBER
            CALL GRDCRM (APCORE, LFIELD, DOSUM, NAPCMS, APBUF, FIRST,
     *         NUMBER, NLOAD, GPARMS, JBUFSZ, BUFF1, BUFF2, BUFF3, IRET)
            IF (IRET.EQ.10) IRET = 0
            IF (IRET.NE.0) GO TO 999
            TOTNUM = TOTNUM + NUMBER
C                                       Gaussian model?
            DOGAUS = (GPARMS(1).GT.0.0) .AND. (GPARMS(2).GT.0.0)
            IF (DOGAUS) THEN
               IF ((NX*CELLSG(1).EQ.0.0) .OR. (NY*CELLSG(2).EQ.0.0))
     *            THEN
                  IRET = 8
                  MSGTXT = 'NX, NY, OR CELLSG 0!!!'
                  CALL MSGWRT (8)
                  GO TO 999
                  END IF
               DU = RAD2AS / (NX * ABS(CELLSG(1)))
               DV = RAD2AS / (NY * ABS(CELLSG(2)))
               END IF
C                                       Begin loop thru map.
            CURGRD = NAPGRD + 5 * TWONY
            DO 20 I = 1,JLIM
C                                       Gaussian taper then crunch
               IF (DOGAUS) THEN
                  UU = DU * (I-1)
                  CALL QTAPER (APCORE, GPARMS, UU, DV, ONENY, NAPGAU)
                  CALL QGRDCC (APCORE, NAPCMS, NAPGAU, NAPCMP, CURGRD,
     *               ONENY, NUMBER)
C                                       Crunch data.
               ELSE
                  CALL QGRDCC (APCORE, NAPCMS, -1, NAPCMP, CURGRD,
     *               ONENY, NUMBER)
                  END IF
               CURGRD = CURGRD + TWONY
 20            CONTINUE
            CALL QWR
            FIRST = FIRST + JNUM
            NUMCLN = NUMCLN - JNUM
            GO TO 10
            END IF
C                                       restore CCVER
         CCVER(LFIELD) = CCVSAV
 100     CONTINUE
      IF (WESET) MODMAX = 0
      IF (TOTNUM.LE.0) IRET = 10
C
 999  RETURN
      END

      SUBROUTINE QNGRD (APCORE, SDAT, UV, VIS, L, INCF, NT2, M, LROW,
     *   CNT, NFREQ)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Grid a uv data, >1 grid possible
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 2008, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Vectorizing compiler version
C   QNGRD differs from Q1GRD in that the data are preserved to allow
C   for multiple calls to QNGRD for multiple grids.
C     Grids visibility data that has been loaded into the AP previously,
C   If requested, positions are shifted and then a taper is applied to
C   the weights if requested before gridding. Multiple frequency
C   channels may be gridded together for bandwidth synthesis.
C      Two work words are assumed before the first visibility.
C   Inputs:
C      SDAT  I  base address of copy of data to be left alone
C      UV    I  base address of u,v vector
C      VIS   I  base address of visibility
C      L     I  length of visibility record
C      INCF  I  Increment between visibilities and weights,
C               stepping in frequency.
C      NT2   I  INT ( (no. cells used on a row)/2 )
C      M     I  number of rows kept in AP (MUST be odd)
C      LROW  I  length of a row (V)
C      CNT   I  number of visibility points.
C      NFREQ I  number of frequencies to grid.
C               If NFREQ is negative then tapering is requested.
C               If CNT is neg, do not shift data.
C   Expects necessary constants in following AP locations:
C         0-5 = parameters used by Q1FIN
C           6 = max X pixel allowed (NX/2 - edge)
C           7 = max Y pixel (+NY/2 reduced by edge considerations)
C           8 = Row number of lowest central row to grid
C           9 = -SIG(U)**2 (CELLS**2) for taper
C          10 = -SIG(V)**2 (CELLS**2) for taper
C          11 = U scaling to cells
C          12 = V scaling to cells
C          13 = W scaling to cells
C          14 = DXC = -2 * PI * delta RA (in 1/cells) for 1ST
C          15 = DYC = -2 * PI * delta DEC         frequency channel
C          16 = DZC = -2 * PI * delta Z
C          17 = AP address containing integer-valued address of base
C               address of row convolving fn. (Y on sky)
C          18 = AP address containing integer-valued address of base
C               address of col. convolving fn. (X on sky)
C          19 = AP address containing integer-valued address of base
C               address of grid.
C       20-28 = 3x3 matrix to rotate u,v,w
C          20...20+NFREQ-2 = differential frequency scaling table
C               for channels after the first one.
C               FREQ(n) = (1+MD(16+n-1)) * FREQ(n-1) for n>1
C   NOTE: Input addresses are 0 relative, must be converted to
C   1 relative before use.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   SDAT, UV, VIS, L, INCF, NT2, M, LROW, CNT, NFREQ
C
      INTEGER   NOTAP, NOSHF, VVIS, WWT, IFRQ, JNFREQ, JCNT, LOOP, WORK,
     *   LTOT, I, IVAL1, IVAL2, IVAL3
      LONGINT   JA, JC, IWRK, JB, LTEMP
      DOUBLE PRECISION VALUE1, VALUE2, VALUE3, TEMPR1, TEMPR2, TEMPI1,
     *   TEMPI2, TEXP, R11, R12, R13, R21, R22, R23, R31, R32, R33, U,
     *   V, W, DTEMP
      EQUIVALENCE (LTEMP, DTEMP)
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                       Save variables to be changed
      JCNT = CNT
      JNFREQ = NFREQ
      VVIS = VIS
      WWT = VIS + 2
      WORK = VIS - 2
C                                       Check if tapered
      NOTAP = JNFREQ
      IF (JNFREQ.LT.0) JNFREQ = - JNFREQ
C                                       Check shift
      NOSHF = JCNT
      IF (JCNT.EQ.0) GO TO 999
      IF (JCNT.LT.0) JCNT = -JCNT
C                                       Copy from save area
      JA = UV + PSAPOF
      JC = ABS(SDAT) + PSAPOF
      LTOT = L * JCNT
      INCLUDE 'INCS:ZVND.INC'
      DO 10 LOOP = 1,LTOT
         APCORE(JA) = APCORE(JC)
         JA = JA + 1
         JC = JC + 1
 10      CONTINUE
C                                       Scale u,v,w to cells.
      JA = UV + PSAPOF
      VALUE1 = APCORE(PSAPOF+11)
      VALUE2 = APCORE(PSAPOF+12)
      VALUE3 = APCORE(PSAPOF+13)
      R11 = APCORE(PSAPOF+20) * VALUE1
      R21 = APCORE(PSAPOF+21) * VALUE1
      R31 = APCORE(PSAPOF+22) * VALUE1
      R12 = APCORE(PSAPOF+23) * VALUE2
      R22 = APCORE(PSAPOF+24) * VALUE2
      R32 = APCORE(PSAPOF+25) * VALUE2
      R13 = APCORE(PSAPOF+26) * VALUE3
      R23 = APCORE(PSAPOF+27) * VALUE3
      R33 = APCORE(PSAPOF+28) * VALUE3
      INCLUDE 'INCS:ZVND.INC'
      DO 20 LOOP = 1,JCNT
         U = APCORE(JA)
         V = APCORE(JA+1)
         W = APCORE(JA+2)
         APCORE(JA)   = U*R11 + V*R21 + W*R31
         APCORE(JA+1) = U*R12 + V*R22 + W*R32
         APCORE(JA+2) = U*R13 + V*R23 + W*R33
         JA = JA + L
 20      CONTINUE
C                                       Check if rotated to U negative
      JA = UV + PSAPOF
      JC = VIS + PSAPOF
      DO 40 LOOP = 1,JCNT
         IF (APCORE(JA).LT.0.0) THEN
            APCORE(JA) = -APCORE(JA)
            APCORE(JA+1) = -APCORE(JA+1)
            APCORE(JA+2) = -APCORE(JA+2)
            JB = JC + 1
            DO 30 I = 1,JNFREQ
               APCORE(JB) = -APCORE(JB)
               JB = JB + INCF
 30            CONTINUE
            END IF
         JA = JA + L
         JC = JC + L
 40      CONTINUE
C                                       Check if rotated out of plane
      VALUE1 = APCORE(PSAPOF+6)
      VALUE2 = APCORE(PSAPOF+7)
      VALUE3 = -VALUE2
      JA = UV + PSAPOF
      JC = VIS + PSAPOF
      DO 60 LOOP = 1,JCNT
         IF ((APCORE(JA).GT.VALUE2) .OR. (APCORE(JA+1).GT.VALUE2) .OR.
     *      (APCORE(JA+1).LT.VALUE3)) THEN
            APCORE(JA) = 0.0
            APCORE(JA+1) = 0.0
            APCORE(JA+2) = 0.0
            JB = JC
            DO 50 I = 1,JNFREQ
               APCORE(JB) = 0.0
               APCORE(JB+1) = 0.0
               APCORE(JB+2) = 0.0
               JB = JB + INCF
 50            CONTINUE
            END IF
         JA = JA + L
         JC = JC + L
 60      CONTINUE
C                                       Frequency looping, rescale uv
      DO 300 IFRQ = 1,JNFREQ
C                                       Do not rescale on first pass.
         IF (IFRQ.NE.1) THEN
            VALUE1 = APCORE(IFRQ+PSAPOF+27)
            JA = UV + PSAPOF
      INCLUDE 'INCS:ZVND.INC'
            DO 100 LOOP = 1,JCNT
               APCORE(JA) = (VALUE1 * APCORE(JA)) + APCORE(JA)
               APCORE(JA+1) = (VALUE1 * APCORE(JA+1)) + APCORE(JA+1)
               APCORE(JA+2) = (VALUE1 * APCORE(JA+2)) + APCORE(JA+2)
               JA = JA + L
 100           CONTINUE
C                                       end if first pass
            END IF
C                                       beam: replace w 1,0
         IF (SDAT.LT.0) THEN
            JA = VVIS + PSAPOF
            DO 110 LOOP = 1,JCNT
               APCORE(JA) = 1.0
               APCORE(JA+1) = 0.0
               JA = JA + L
 110           CONTINUE
            END IF
C                                       Taper
         IF (NOTAP.LE.0) THEN
            VALUE1 = APCORE(PSAPOF+9)
            VALUE2 = APCORE(PSAPOF+10)
            IF ((VALUE1.NE.0.0) .OR. (VALUE2.NE.0.0)) THEN
               JA = UV + PSAPOF
               JC = WWT + PSAPOF
      INCLUDE 'INCS:ZVND.INC'
               DO 120 LOOP = 1,JCNT
                  TEXP = VALUE1 * APCORE(JA) * APCORE(JA) +
     *               VALUE2 * APCORE(JA+1) * APCORE(JA+1)
                  IF (TEXP.GT.-14.0) THEN
                     APCORE(JC) = APCORE(JC) * EXP (TEXP)
                  ELSE
                     APCORE(JC) = 0.0
                     END IF
                  JA = JA + L
                  JC = JC + L
 120              CONTINUE
               END IF
            END IF
C                                       Shift position.
         IF (NOSHF.GT.0) THEN
            VALUE1 = APCORE(PSAPOF+14)
            VALUE2 = APCORE(PSAPOF+15)
            VALUE3 = APCORE(PSAPOF+16)
            IF ((VALUE1.NE.0.0) .OR. (VALUE2.NE.0.0) .OR.
     *         (VALUE3.NE.0.0)) THEN
               JA = UV + PSAPOF
               IWRK = WORK + PSAPOF
      INCLUDE 'INCS:ZVND.INC'
               DO 150 LOOP = 1,JCNT
C                                       Set phase to shift
                  APCORE(IWRK+1) = APCORE(JA) * VALUE1 +
     *               APCORE(JA+1) * VALUE2 + APCORE(JA+2) * VALUE3
                  JA = JA + L
                  IWRK = IWRK + L
 150              CONTINUE
C                                       Calc Cos and Sin of Phase
               CALL QRECT1 (APCORE, WORK, L, WORK, L, JCNT)
               JC = VVIS + PSAPOF
               IWRK = WORK + PSAPOF
      INCLUDE 'INCS:ZVND.INC'
               DO 160 LOOP = 1,JCNT
C                                       Shift positions
                  TEMPR1 = APCORE(IWRK)
                  TEMPI1 = APCORE(IWRK+1)
                  TEMPR2 = APCORE(JC)
                  TEMPI2 = APCORE(JC+1)
                  APCORE(JC)   = TEMPR1 * TEMPR2 - TEMPI1 * TEMPI2
                  APCORE(JC+1) = TEMPR1 * TEMPI2 + TEMPI1 * TEMPR2
                  IWRK = IWRK + L
                  JC = JC + L
 160              CONTINUE
               END IF
            END IF
C                                       Grid, Correct row number to
C                                       lowest central row.
         DTEMP = APCORE(PSAPOF+19)
         IVAL1 = LTEMP
         DTEMP = APCORE(PSAPOF+17)
         IVAL2 = LTEMP
         DTEMP = APCORE(PSAPOF+18)
         IVAL3 = LTEMP
         CALL QGRD4 (APCORE, UV, VVIS, WWT, IVAL1, IVAL2, IVAL3, NT2, M,
     *      LROW, 8, L, JCNT)
         VVIS = VVIS + INCF
         WWT = WWT + INCF
 300     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE NXCHCK (DISK, CNO, BUFF2)
C-----------------------------------------------------------------------
C! Check that NX table matches number of vis, otherwise re-do table
C# FITS EXT-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   NXCHCK (re)writes the NX table correcting the visibility pointers
C   Input:
C      DISK   I   Disk number
C      CNO    I   Catalog number
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO
      REAL      BUFF2(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   BUFFER(512), LUN, IND, LUNTMP, INXRNO, NXKOLS(MAXNXC),
     *   NXNUMV(MAXNXC), IERR, IDSOUR, SUBARR, VS, VE, FREQID, RNXRET,
     *   VO, BO, IBIND, JBUFSZ, IPTRI, INIO, I, VER, ILENBU, MSGSAV,
     *   IDUM(2), I2DUM(2)
      REAL      TIME, DTIME
      LOGICAL   T, F
      CHARACTER PHNAME*48
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DRNX.INC'
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      CALL FNDEXT ('NX', CATBLK, VER)
      CALL UVPGET (IERR)
C                                       If NX table, check match of #s
      IF (VER.GT.0) THEN
         LUN = LUNTMP (1)
         CALL NDXINI ('READ', BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *      INXRNO, NXKOLS, NXNUMV, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPENING NX TABLE TO CHECK'
            GO TO 990
            END IF
         INXRNO = BUFFER(5)
         CALL TABNDX ('READ', BUFFER, INXRNO, NXKOLS, NXNUMV, TIME,
     *      DTIME, IDSOUR, SUBARR, IDUM, I2DUM, FREQID, IERR)
         VS = IDUM(1)
         VE = I2DUM(1)
         CALL TABNDX ('CLOS', BUFFER, INXRNO, NXKOLS, NXNUMV, TIME,
     *      DTIME, IDSOUR, SUBARR, VSTART, VEND, FREQID, I)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READING NX TABLE TO CHECK'
            GO TO 990
            END IF
         IF (VE.EQ.CATBLK(KIGCN)) THEN
            MSGTXT = 'Index table matches visibility count, assuming' //
     *         ' it is good'
            CALL MSGWRT (4)
            GO TO 999
            END IF
         END IF
C                                       have to do revised NX table
      CALL RNXGET (DISK, CNO, CATBLK)
      MSGSAV = MSGSUP
      IF (VER.GT.0) MSGSUP = 32000
      CALL RNXINI (DISK, CNO, CATBLK, RNXRET)
      MSGSUP = MSGSAV
      IF (RNXRET.GT.0) THEN
         WRITE (MSGTXT,1000) RNXRET, 'INIT INDEX TABLE (RE)WRITE'
         GO TO 990
         END IF
C                                       force file re-write
      RNXRNO = 1
      IF (VER.GT.0) THEN
         MSGTXT = 'NXCHCK: Rebuilding index table'
      ELSE
         MSGTXT = 'NXCHCK: Building new index table'
         END IF
      CALL MSGWRT (2)
      LUN = LUNTMP (0)
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISK, CNO, 1, PHNAME, IERR)
      CALL ZOPEN (LUN, IND, DISK, PHNAME, T, F, F, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN OUTPUT UV DATA SET'
         GO TO 990
         END IF
C                                       Init vis file for read.
      ILENBU = 0
      JBUFSZ = UVBFSL * 2
      CALL UVINIT ('READ', LUN, IND, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF2, BO, IBIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INIT READ FROM OUTPUT DATA SET'
         GO TO 990
         END IF
C                                       Loop
      INIO = 1
 100  IF (INIO.GT.0) THEN
C                                       Read vis. record.
         CALL UVDISK ('READ', LUN, IND, BUFF2, INIO, IBIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READ OUTPUT DATA SET'
            GO TO 990
            END IF
         IPTRI = IBIND
         DO 110 I = 1,INIO
C                                       update NX table
            CALL RNXUPD (BUFF2(IPTRI), RNXRET)
            IPTRI = IPTRI + LREC
 110        CONTINUE
C                                       Read next buffer.
         GO TO 100
         END IF
C                                       Close files
      CALL ZCLOSE (LUN, IND, IERR)
C                                       close NX table
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'NXCHCK: OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('NXCHCK: ERROR',I4,' ON ',A)
      END

LOCAL INCLUDE 'BSROT.INC'
C                                       Local include for BSROT
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      REAL      XSIN, XDISIN, XSOUT, XDISO, ROTATE, SCALE,
     *   BUFF1(UVBFSS), BUFF2(UVBFSS), THROW, DELTAZ, DELTEL
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS, JBUFSZ, ILOCWT,
     *   CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI,
     *   LRECO, NRPRMI, NRPRMO, OLDCNO, NEWCNO
      LOGICAL   ISCOMP
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, HISCRD(2)*64
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XCLAOU,
     *   XSOUT, XDISO, ROTATE, SCALE
      COMMON /BSROTC/ CATOLD, SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS,
     *   ILOCWT, INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI,
     *   LRECO, NRPRMI, NRPRMO, ISCOMP, THROW, DELTAZ, DELTEL, OLDCNO,
     *   NEWCNO
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, HISCRD
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
C                                       End local include for BSROT
LOCAL END
      PROGRAM BSROT
C-----------------------------------------------------------------------
C! Correct beam-switch continuum data for beam throw error
C# Utility UV singledish
C-----------------------------------------------------------------------
C;  Copyright (C) 1996, 2000, 2008, 2015, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BSROT corrects for rotation and scale errors in the assumed beam
C   throw.  At present the RA and Dec data are not corrected.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      ROTATE         ROTATE        Rotate the throw ccw
C      SCALE          SCALE         Scale the throw
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'BSROT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'BSROT '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL BSRTIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL BSRTUV (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL BSRHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE BSRTIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   BSRTIN gets input parameters for BSROT and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, LOCS, KEYTYP
      LOGICAL   T
      INCLUDE 'BSROT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK  /'      '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 16
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'GETTING PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
      IF (SCALE.LE.0.0) SCALE = 1.0
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING HEADER'
         GO TO 990
         END IF
      CALL CATKEY ('READ', DISKIN, OLDCNO, 'BSTHROW', 1, LOCS, THROW,
     *   KEYTYP, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'GETTING THROW'
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      NEWCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, NEWCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1000) IERR, 'CREATING OUTPUT'
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((NEWCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            MSGTXT = 'MAY OVERWRITE INPUT FILE ONLY.  QUITTING'
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, NEWCNO, CATBLK, 'WRIT', BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READING OUTPUT HEADER'
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
      CALL CATKEY ('WRIT', DISKO, NEWCNO, 'BSTHROW', 1, LOCS, THROW,
     *   KEYTYP, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'WRITING THROW'
         GO TO 990
         END IF
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BSRTIN: ERROR',I3,1X,A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
      END
      SUBROUTINE BSRTUV (IRET)
C-----------------------------------------------------------------------
C   BSRTUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48, IFILE*48
      INTEGER   INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, ILENBU,
     *   KBIND, NIOUT, NIOLIM, IBIND, I, IA1, IA2, INCX, BO, VO,
     *   NUMVIS, XCOUNT, NCORI, NCORO, NCOPY, RNXRET
      LOGICAL   T, F
      INCLUDE 'BSROT.INC'
      REAL      BASEN, CBUFF(UVBFSS), RESULT(UVBFSS)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI, LUNO /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
      IF (ISCOMP) INCX = 3
C                                       Number of visibilities in input
C                                       and output files.
      NCORI = (LRECI - NRPRMI) / CATOLD(KINAX)
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, NEWCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Out of data?
         IF (INIO.LE.0) GO TO 200
C                                       Loop over buffer
         DO 190 I = 1,INIO
            IF (ILOCB.GE.0) THEN
               BASEN = BUFF1(IPTRI+ILOCB)
               IA1 = BASEN / 256. + 0.1
               IA2 = BASEN - IA1*256. + 0.1
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               END IF
            NUMVIS = NUMVIS + 1
C                                      Call user routine.
            IF (ISCOMP) THEN
C                                       Compressed data.
               CALL ZUVXPN (NCORI, BUFF1(IPTRI+NRPRMI),
     *            BUFF1(IPTRI+ILOCWT), CBUFF)
               CALL BSRTDO (NUMVIS, CBUFF, BUFF1(IPTRI), INCX, RESULT,
     *            IRET)
            ELSE
C                                       Un compressed data
               CALL BSRTDO (NUMVIS, BUFF1(IPTRI+NRPRMI), BUFF1(IPTRI),
     *            INCX, RESULT, IRET)
               END IF
C                                       Branch on his return
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
C                                       Copy to output.
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1.0D0
               CALL RCOPY (NRPRMO, BUFF1(IPTRI), BUFF2(IPTRO))
C                                       update NX table
               CALL RNXUPD (BUFF1(IPTRI), RNXRET)
C                                       Compressed
               IF (ISCOMP) THEN
                  CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *               BUFF2(IPTRO+NRPRMO))
               ELSE
                  CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
                  END IF
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               END IF
C                                       OK, but no output please
            IPTRI = IPTRI + LRECI
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
C                                       Read next buffer.
         GO TO 100
C                                       Final call to BSRTDO.
 200     NUMVIS = -1
         CALL BSRTDO (NUMVIS, BUFF1, BUFF1, INCX, RESULT, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
            END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, NEWCNO, LUNO, CATBLK, BUFF2, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF

      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BSRTUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1010 FORMAT ('BSRTUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('BSRTUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('BSRTUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('BSRTUV: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('BSRTUV: BSRTDO ERROR',I3)
 1150 FORMAT ('BSRTUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE BSRHIS
C-----------------------------------------------------------------------
C   BSRHIS copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP*2, HILINE*72
      INTEGER   LUN1, LUN2, IERR, I, NONOT
      LOGICAL   T
      INCLUDE 'BSROT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NONOT, NOTTYP /0, '  '/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any other history.
      IF (NUMHIS.LE.0) GO TO 200
         DO 50 I = 1,NUMHIS
            HILINE = TSKNAM // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
C                                       Close HI file
 200   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO,
     *   FCNO(2), FCNO(1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1200)
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST',
     *   BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BSRHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1200 FORMAT ('BSRHIS: ERROR COPYING TABLES')
      END
      SUBROUTINE BSRTDO (NUMVIS, VIS, RPARM, INCX, RESULT, IRET)
C-----------------------------------------------------------------------
C   Appplies correction to the az and el do to a throw error - should do
C   the ra and dec but does not now.
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      RPARM   R(*) Random parameter array which includes U,V,W etc
C                   but also any other random parameters.
C      VIS     R(INCX,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                   NOTE: INCX may be any value .GE. 2
C   Inputs from COMMON:
C      RA         D       Right ascension (1950) of phase center. (deg)
C      DEC        D       Declination (1950) of phase center. (deg)
C      FREQ       D       Frequency of observation (Hz)
C      NRPARM     I       # random parameters.
C      NCOR       I       # correlators
C      CATBLK     I(256)  Catalog header record. See Going Aips for
C                         details.
C      LRECI      I    Input file record length
C      NRPRMI     I    Input number of random parameters.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
C      LRECO      I    Output file record length
C      NRPRMO     I    Output number of random parameters.
C      INCSO      I    Output Stokes' increment in vis.
C      INCFO      I    Output frequency increment in vis.
C      INCIFO     I    Output IF increment in vis.
C   Output:
C      RPARM      R    Modified random parameter array.
C      RESULT  R(INCX,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C
C   Output in COMMON:
C      NUMHIS    I         # history entries (max. 10)
C      HISCRD    C(NUMHIS) History records
C      CATBLK    I         Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, INCX, IRET
      REAL      VIS(INCX,*), RPARM(*), RESULT(INCX,*)
C
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXO, INDEXI, I
      INCLUDE 'BSROT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PSTD.INC'
      SAVE NS, NF, NIF
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.GT.0) THEN
         IF (NUMVIS.EQ.1) THEN
            DELTAZ = (SCALE * COS (ROTATE*DG2RAD) - 1.) * THROW / 3600.
            DELTEL = SCALE * SIN (ROTATE*DG2RAD) * THROW / 3600.
            NS = 1
            NIF = 1
            NF = 1
            IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
            IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
            IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
            END IF
C                                       SHIFT COORDS
         RPARM(1+ILOCU) = RPARM(1+ILOCU) + DELTAZ
         RPARM(1+ILOCV) = RPARM(1+ILOCV) + DELTEL
C                                       copy data
         DO 40 JIF = 1,NIF
            DO 30 JF = 1,NF
               DO 20 JS = 1,NS
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *               (JS-1) * INCSO + 1
                  DO 10 I = 1,INCX
                     RESULT(I,INDEXO) = VIS(I,INDEXI)
 10                  CONTINUE
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
C                                       end of example (vis)
C                                       last call - no vis
      ELSE
         WRITE (HISCRD(1),1101) SCALE
         WRITE (HISCRD(2),1102) ROTATE
         NUMHIS = 2
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1101 FORMAT ('SCALE  =',F8.4,5X,'/ scale throw by this factor')
 1102 FORMAT ('ROTATE =',F8.4,5X,'/ rotate throw ccw in degrees')
      END

      SUBROUTINE TVTPOS (DOMENU, TIMLIM, TVXY, TVBUTT, IERR)
C-----------------------------------------------------------------------
C! reads TV cursor and button with prompt and time out options
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   get tv position within a time limit.  The TV button buffer is
C   cleared on entry if TIMLIM >= 0.  The TV cursor is turned on if
C   needed, but it is not moved to do so.
C   Inputs:
C      DOMENU   I      Prompt message control:
C                        -1 => cursor position unimportant
C                         0 => picking an image pixel
C                         1 => picking a menu item
C                         2 => menu help avalable
C      TIMLIM   I      Return after TIMLIM seconds even if no button
C                         0 => infinite time limit
C                        <= -1 => no message and no wait
C   Outputs:
C      TVXY     R(2)   TV x,y pixel position: corrected for zoom, not
C                      scroll
C      TVBUTT   I      Selected button: 0 => timed out
C      IERR     I      Error code: > 10 => object not open properly
C-----------------------------------------------------------------------
      INTEGER   DOMENU, TIMLIM, TVBUTT, IERR
      REAL      TVXY(2)
C
      INTEGER   IX, IY, RBLINK, BUTTON, QUAD
      LOGICAL   ON, LINKX, LINKY, VRTRTC
      REAL      TD
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       get current cursor status
      CALL YCRCTL ('READ', ON, IX, IY, LINKX, LINKY, RBLINK, BUTTON,
     *   VRTRTC, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (.NOT.ON) THEN
         ON = .TRUE.
         CALL YCRCTL ('READ', ON, IX, IY, LINKX, LINKY, RBLINK, BUTTON,
     *      VRTRTC, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Quicky
      QUAD = -1
      IF (TIMLIM.LT.0) THEN
         CALL YCURSE ('READ', .FALSE., .TRUE., TVXY, QUAD, TVBUTT, IERR)
         TVBUTT = MAX (TVBUTT, BUTTON)
C                                       Prompted
      ELSE
         IF (TIMLIM.GT.0) THEN
            WRITE (MSGTXT,1000) TIMLIM
            CALL MSGWRT (1)
            END IF
         IF (DOMENU.LT.0) THEN
            MSGTXT = 'Press desired TV button'
         ELSE IF (DOMENU.EQ.0) THEN
            MSGTXT = 'Move cursor to desired position, press desired TV'
     *         // ' button'
         ELSE IF (DOMENU.EQ.1) THEN
            MSGTXT = 'Move cursor to desired menu item, ' //
     *         'press desired TV button'
         ELSE
            MSGTXT = 'Move cursor to desired menu item, ' //
     *         'press button A, B, or C to select'
            CALL MSGWRT (1)
            MSGTXT = 'Press button D for help'
            END IF
         CALL MSGWRT (1)
C                                       infinite
         IF (TIMLIM.EQ.0) THEN
            CALL YCURSE ('READ', .TRUE., .TRUE., TVXY, QUAD, TVBUTT,
     *         IERR)
C                                       Timed
         ELSE
            TD = 0.2
            IX = 5 * TIMLIM
            DO 20 IY = 1,IX
               CALL YCURSE ('READ', .FALSE., .TRUE., TVXY, QUAD, TVBUTT,
     *            IERR)
               IF ((IERR.NE.0) .OR. (TVBUTT.GT.0)) GO TO 999
               CALL ZDELAY (TD)
 20            CONTINUE
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('You have',I6,' seconds to:')
      END

      SUBROUTINE XCSHNQ (DATA, ISB, NIFRQ, DELI, WORK)
C-----------------------------------------------------------------------
C! Frequency shift cross power spectra
C# UV IO-appl Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  Routine to perform the frequency shift for XC data, this version
C  does not use Q routines.
C
C  Inputs:
C      DATA(2,*)     R        The cross-power spectrum to be
C                             shifted. Will also contain shifted
C                             result
C      ISB           I        Sideband
C      NIFRQ         I        No. freq. channels in spectrum
C      DELI          D        No. channels to shift by
C      WORK          R        Work array (same size as data array)
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXCH2
      PARAMETER (MAXCH2=MAXCHA*2)
      REAL    DATA(2,MAXCH2), WORK(2,1), DEL, DEL1, CD, SD, C, S,
     *   STORE
      DOUBLE PRECISION DELI
      INTEGER   ISB, NFRQ, NXCF, I, NIFRQ
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCVL.INC'
C-----------------------------------------------------------------------
      NFRQ = NIFRQ
C                                       FFT to xc-function
      NXCF = NFRQ * 2
      CALL NQTOCF (ISB, NFRQ, DATA, WORK)
C                                        Minus sign in following
C                                        equation for "del" is because
C                                        increasing channel #
C                                        corresponds to decreasing lag
C                                        values.
      DEL  = -1.0 * ISB * TWOPI * DELI / NXCF
      DEL1 = -0.5 *  NXCF  * DEL
      CD   = COS( DEL )
      SD   = SIN( DEL )
      C    = COS( DEL1 )
      S    = SIN( DEL1 )
C                                        Shift XC spectrum.
C                                        At this point the array DATA
C                                        should contain a correlation
C                                        function with the zero delay
C                                        in the NFRQ+1'th channel.
      DO 50 I = 1, NXCF
         STORE     = DATA(1,I)
         DATA(1,I) = DATA(1,I)*C - DATA(2,I)*S
         DATA(2,I) =     STORE*S + DATA(2,I)*C
         STORE = C
         C     = C*CD - S*SD
         S     = STORE*SD + S*CD
   50    CONTINUE
C                                       FFT back to spectrum
      CALL NQTOCS (ISB, NXCF, DATA, WORK)
C
      RETURN
      END

      SUBROUTINE TKCATL (OPER, IX, IY, CATBLK, IERR)
C-----------------------------------------------------------------------
C! performs operations on the Graphics image catalog
C# Catalog Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Read, write, init the Graphics image catalog.  If the TK server is
C   in use (TKTYPE > 0), the TK device must be open.
C   Inputs:
C      OPER    C*4     'INIT' - zero catalog block for current TEK #
C                      'READ' - read catalog block for current TEK #
C                      'WRIT' - write catalog block for current TEK #
C      IX      I       X pixel position (check vs CATBLK on READ)
C      IY      I       Y pixel position (check vs CATBLK on READ)
C   In/out:
C      CATBLK  I(256)  Image header converted for image catalog use
C   Output:
C      IERR    I       Error return:  0 => o.k.
C                         10 => access not allowed for this POPS #
C                         11 => IX, IY not in image
C                         > 0 => error return from ZOPEN, ZFIO
C-----------------------------------------------------------------------
      CHARACTER OPER*4
      INTEGER   IX, IY, CATBLK(256), IERR
C
      CHARACTER INAME*48
      INTEGER   LUN, IND, JERR, WORK(256), I
      LOGICAL   T, F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTKS.INC'
      DATA T, F /.TRUE., .FALSE./
      DATA LUN /20/
C-----------------------------------------------------------------------
C                                       Is access allowed?
      IERR = 10
      IF (NTKDEV.LE.0) GO TO 999
C                                       real device: disk catalog
      IF (TKTYPE.EQ.0) THEN
C                                       Open image catalog
         CALL ZPHFIL ('IC', 1, 0, 0, INAME, IERR)
         CALL ZOPEN (LUN, IND, 1, INAME, F, T, T, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       INIT, WRIT
         IF ((OPER.EQ.'INIT') .OR. (OPER.EQ.'WRIT')) THEN
            IF (OPER.EQ.'INIT') CALL FILL (256, 0, CATBLK)
            CALL ZFIO ('WRIT', LUN, IND, NTKDEV, CATBLK, IERR)
         ELSE IF (OPER.EQ.'READ') THEN
            CALL ZFIO ('READ', LUN, IND, NTKDEV, CATBLK, IERR)
            IF ((IERR.EQ.0) .AND. ((IX.LT.CATBLK(IICOR)) .OR.
     *         (IX.GT.CATBLK(IICOR+2)) .OR. (IY.LT.CATBLK(IICOR+1)) .OR.
     *         (IY.GT.CATBLK(IICOR+3)))) IERR = 11
         ELSE
            IERR = 2
            END IF
C                                       Always close image catalog
         CALL ZCLOSE (LUN, IND, JERR)
C                                       TK server holds catalog
      ELSE
         CALL TEKFLS (IERR)
C                                       INIT, WRIT catalog
         IF ((OPER.EQ.'INIT') .OR. (OPER.EQ.'WRIT')) THEN
C                                       get its attention
            I = 1
            CALL ZPUTCH (I, WORK(1), 1)
            CALL ZPUTCH (I, WORK(1), 2)
            CALL ZFIO ('WRIT', TKLUN, TKFIND, 2, WORK, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL ZFIO ('READ', TKLUN, TKFIND, 2, WORK, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       send the header
            IF (OPER.EQ.'INIT') THEN
               CALL FILL (256, 0, WORK)
            ELSE
               CALL CATN2L ('L2NI', CATBLK, WORK)
               END IF
            CALL ZFIO ('WRIT', TKLUN, TKFIND, 1024, WORK, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       make sure it got it
            CALL ZFIO ('READ', TKLUN, TKFIND, 1024, WORK, IERR)
C                                       read catalog
         ELSE IF (OPER.EQ.'READ') THEN
C                                       get its attention
            I = 2
            CALL ZPUTCH (I, WORK(1), 1)
            CALL ZPUTCH (I, WORK(1), 2)
            CALL ZFIO ('WRIT', TKLUN, TKFIND, 2, WORK, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       read the header
            CALL ZFIO ('READ', TKLUN, TKFIND, 1024, WORK, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL CATN2L ('N2LI', WORK, CATBLK)
C                                       check the coordinate
            IF ((IX.LT.CATBLK(IICOR)) .OR. (IX.GT.CATBLK(IICOR+2)) .OR.
     *         (IY.LT.CATBLK(IICOR+1)) .OR. (IY.GT.CATBLK(IICOR+3)))
     *         IERR = 11
C                                       bad opcode
         ELSE
            IERR = 2
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZDIR (TYPE, RVERSN, FILE, FULNAM, IERR)
C-----------------------------------------------------------------------
C! build a full path name to files in AIPS-standard areas (HE, RU, ...)
C# Z2 Text IO-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Given a file type (e.g., 'HE' for HELP, 'RU' for RUN, etc.), a
C   version (e.g., 'OLD:', 'NEW:', 'TST:', 'MYAREA' as a logical,
C   /aippgmr/khilldru as a literal, etc.) and a file name (e.g., UVSRT,
C   MX, etc.), build the full path name of the file (e.g.,
C   /AIPS/15JUL87/HELP/MX.HLP).
C   Inputs:
C      TYPE     C*2    File type
C      RVERSN   C*48   Version - directory path name)
C      FILE     C*(*)  File name (if a '.' is not found in the name, a
C                      default extension determined from TYPE)
C   Output:
C      FULNAM   C*(*)  Full path name of the file
C      IERR     I      Error return code: 0 => no error
C                         1 => invalid file type
C                         2 => no such logical
C                         3 => error in directory name
C   Generic version - stub
C-----------------------------------------------------------------------
      CHARACTER TYPE*2, RVERSN*48, FILE*(*), FULNAM*(*)
      INTEGER   IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 1
      MSGTXT = 'ZDIR REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (9)
C
 999  RETURN
      END

      SUBROUTINE LTSTOR
C-----------------------------------------------------------------------
C! allocate storage for literal if needed, return pointer in any case
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   LTSTOR searches the literal list.  If a matching literal is found,
C   the TAG is returned.  If not found, a new one is generated and
C   linked to the literal list.
C   Commons altered:
C      L         point to storage location
C      TAG       point to storage location as real variable
C      LOCSYM    point to storage location
C      KKT or K  area of literal storage
C   Note: uses KKT only if MODE = 0, does not check permanent area
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   IX(1), KKT(10)
      INTEGER   MK, N, NT, LLOCAT
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DSMS.INC'
      EQUIVALENCE (X(1), IX(1)),    (KKT(1), K(51))
      DATA PRGNAM /'LTSTOR'/
C-----------------------------------------------------------------------
C                                       Literal look-up & define.
      NT = LX
      N = LX + 2
C                                       Temporary Literals.
      IF (MODE.NE.0) GO TO 15
         L = KKT(4)
C                                       Leave L pointing to the entry.
         CALL HUNT (KKT, L, NT, 2, IX)
         IF (L.NE.0) GO TO 10
            L = LLOCAT (N, KKT, KKT(10))
            IF (ERRNUM.NE.0) GO TO 980
C                                       Make L refer to the K array.
 10      L = L + KT - 1
         GO TO 20
C                                       Permanent literals.
 15   CONTINUE
         L = K(4)
         CALL HUNT (K, L, NT, 2, IX)
         IF (L.NE.0) GO TO 30
            L = LLOCAT (N, K, K(10))
            IF (ERRNUM.NE.0) GO TO 980
C                                       set in type, etc. in new one
 20      CONTINUE
            MK = L + 2
            K(L+1) = 16*NT + SYTYPE
            CALL COPY (NT, IX(1), K(MK))
 30   TAG = L + 2
      LOCSYM = L
      GO TO 999
C                                       Error return.
 980  ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
      END

      SUBROUTINE YCWRIT (IPLANE, IMAWIN, CATBLK, BUFF, IERR)
C-----------------------------------------------------------------------
C! write image header to image catalog, update image catalog directory
C# Y0 TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;  Eric W. Greisen
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Write image catalog block in CATBLK into image catalog
C   Inputs:
C      IPLANE   I        image plane involved
C      IMAWIN   I(4)     Corners of image on screen
C      CATBLK   I(256)   Image catalog block
C  Outputs:
C      BUFF     I(256)   working buffer
C      IERR     I        error code: 0 => ok
C                           1 => no room in catalog
C                           2 => IO problems
C   XAS (SSS) routine: for image catalog in XAS
C-----------------------------------------------------------------------
      INTEGER   IPLANE, IMAWIN(4), CATBLK(256), BUFF(256), IERR
C
      INTEGER   ILUN, IIND, IER, NLAST, I, J, LL, NREC, NREC0, JREC,
     *   DAT(4), OPCODE, NWSD, WORK(260)
      CHARACTER CATYPE*2
      LOGICAL   OVER, DONE
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA ILUN /20/
C-----------------------------------------------------------------------
      IERR = 0
C                                       image catalog on disk
      IF (TVIMGC.LE.0) THEN
C                                       Open image catalog
         CALL ICOPEN (IPLANE, ILUN, IIND, IER)
         IF (IER.NE.0) GO TO 970
         LL = (NIMAGE - 1) / 51
C                                       multiple image planes
         IF (IPLANE.LE.NGRAY) THEN
            NREC = 1 + (IPLANE - 1) * (NIMAGE + 1 + LL)
            NREC0 = NREC
C                                       Get directory block
            CALL ZFIO ('READ', ILUN, IIND, NREC, BUFF, IER)
            IF (IER.NE.0) GO TO 970
            NLAST = BUFF(1)
            DONE = .FALSE.
C                                       Search catalog
            DO 50 I = 1,NIMAGE
               IF ((I.NE.1) .AND. (MOD(I,51).EQ.1)) THEN
                  CALL ZFIO ('WRIT', ILUN, IIND, NREC, BUFF, IER)
                  IF (IER.NE.0) GO TO 970
                  NREC = NREC + 1
                  CALL ZFIO ('READ', ILUN, IIND, NREC, BUFF, IER)
                  IF (IER.NE.0) GO TO 970
                  END IF
               J = 5 * MOD (I-1, 51) + 2
C                                       Is slot empty
               IF (BUFF(J).NE.0) THEN
C                                       Does image overlap old image
                  OVER = (IMAWIN(1).LE.BUFF(J+1)) .AND.
     *               (IMAWIN(2).LE.BUFF(J+2))
                  OVER = OVER .AND. (IMAWIN(3).GE.BUFF(J+3)) .AND.
     *               (IMAWIN(4).GE.BUFF(J+4))
C                                       Clear slot
                  IF (OVER) BUFF(J) = 0
                  END IF
C                                       on EMPTY or OVER and NOT.DONE
C                                       update directory and write new
C                                       block
               IF ((.NOT.DONE) .AND. (BUFF(J).EQ.0)) THEN
                  NLAST = NLAST + 1
                  BUFF(1) = NLAST
                  BUFF(J) = NLAST
                  CALL COPY (4, IMAWIN, BUFF(J+1))
C                                       Write requested image block
                  JREC = NREC0 + I + LL
                  CALL ZFIO ('WRIT', ILUN, IIND, JREC, CATBLK, IER)
                  IF (IER.NE.0) GO TO 970
                  DONE = .TRUE.
                  END IF
 50            CONTINUE
C                                       No room in catalog
            IF (.NOT.DONE) THEN
               WRITE (MSGTXT,1150) IPLANE
               IERR = 1
               GO TO 980
C                                       Update directory block
            ELSE
               CALL ZFIO ('WRIT', ILUN, IIND, NREC, BUFF, IER)
               IF (IER.NE.0) GO TO 970
               IF (NREC.EQ.NREC0) GO TO 990
               CALL ZFIO ('READ', ILUN, IIND, NREC0, BUFF, IER)
               IF (IER.NE.0) GO TO 970
               BUFF(1) = NLAST
               CALL ZFIO ('WRIT', ILUN, IIND, NREC0, BUFF, IER)
               IF (IER.NE.0) GO TO 970
               GO TO 990
               END IF
C                                       graphics: write block
         ELSE
            IF (IPLANE.LE.NGRAY+NGRAPH) THEN
               NREC = IPLANE + NGRAY * (NIMAGE + LL)
               CALL ZFIO ('WRIT', ILUN, IIND, NREC, CATBLK, IER)
               IF (IER.NE.0) GO TO 970
            ELSE
               IERR = 3
               END IF
            GO TO 990
            END IF
C                                       XAS has catalog
      ELSE
         CALL COPY (4, IMAWIN, DAT)
         OPCODE = 33
         CALL CATN2L ('L2NI', CATBLK, WORK)
         CALL H2CHR (2, KHPTYO, CATBLK(KHPTY), CATYPE)
         CALL ZCLC8 (2, CATYPE, 1025, WORK)
         CALL ZILI16 (1, IPLANE, 514, WORK)
         CALL ZSSSXF (OPCODE, DAT, 1028, WORK, NWSD, IER)
         IF (IER.EQ.-2) THEN
            IERR = 1
            WRITE (MSGTXT,1150) IPLANE
            CALL MSGWRT (6)
         ELSE IF (IER.NE.0) THEN
            IERR = 2
            WRITE (MSGTXT,1200) IER
            CALL MSGWRT (6)
         ELSE
            IERR = 0
            END IF
         GO TO 999
         END IF
C                                       Errors
 970  IF (IER.EQ.11) THEN
         IERR = 3
         WRITE (MSGTXT,1970)
      ELSE
         IERR = 2
         WRITE (MSGTXT,1971) IER
         END IF
 980  CALL MSGWRT (6)
C
 990  CALL ZCLOSE (ILUN, IIND, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1150 FORMAT ('YCWRIT: CATALOG FULL FOR PLANE',I6)
 1200 FORMAT ('YCWRIT: XAS IMAGE CATALOG RETURNS ERROR',I5)
 1970 FORMAT ('YCWRIT: NO LONGER HANDLES TK DEVICES')
 1971 FORMAT ('YCWRIT: NO ACCESS TO IMAGE CATALOG, ERROR =',I6)
      END

      SUBROUTINE PDSEL (DISKI, CNOI, DISKO, CNOO, VER, CATIN, CATOUT,
     *   LUNI, LUNO, BPOL, EPOL, BIF, EIF, BCHAN, ECHAN, IFQID, ISUB,
     *   JSUB, BUFFER, OBUFF, IRET)
C-----------------------------------------------------------------------
C! Copies and renumbers the IFs in a PD table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2007, 2010-2012, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Copies and renumbers the IFs and channels in an PD table; can also
C   modify the FQ ID.
C   Inputs:
C      DISKI    I        Input volume number
C      CNOI     I        Input catalog number
C      DISKO    I        Output volume number
C      CNOO     I        Output catalog number
C      VER      I        Version to check/modify
C      CATIN    I(256)   Input catalog header
C      CATOUT   I(256)   Output catalog header
C      LUNI     I        LUN to use
C      LUNO     I        LUN to use
C      BPOL     I        First polarization to copy
C      EPOL     I        Last polarization to copy
C      BIF      I        Start IF number
C      EIF      I        End IF number
C      BCHAN    I        First channel
C      ECHAN    I        Last channel
C      IFQID    I        FQ ID to select (output FQID will be 1)
C                           if <= 0 then output FQ ID unchanged.
C      ISUB     I        Selected subarray (= 0 any)
C      JSUB     I        Output subarray number (< 0 => NO CHANGE)
C   Input/Output:
C      BUFFER   I(512)   Work buffer
C      OBUFF    I(512)   Work buffer
C   Output:
C      IRET     I        Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER   DISKI, CNOI, DISKO, CNOO, VER, CATIN(256), CATOUT(256),
     *   LUNI, LUNO, BPOL, EPOL, BIF, EIF, BCHAN, ECHAN, IFQID, ISUB,
     *   JSUB, BUFFER(*), OBUFF(*), IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXPDC
      PARAMETER (MAXPDC = 9)
C
      REAL      DTERMS(2,MAXCIF), PHDIFF(MAXCIF)
      INTEGER   IPDRNO, PDKOLS(MAXPDC), PDNUMV(MAXPDC), OKOLS(MAXPDC),
     *   ONUMV(MAXPDC), NPDROW, OPDRNO, SUBA, FREQID, REFANT(2), NUMANT,
     *   NUMPOL, NUMIF, NUMFRQ, ANT, I, J, K, L, JJ, NEWIF, NEWFRQ, IFA,
     *   IFB, IFREQA, IFREQB, INX, LNX, OVER, FOPEN, LBPOL, M, NEWPOL
      LOGICAL   REFMT
      CHARACTER POLTYP*8
      SAVE DTERMS, PHDIFF
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      FOPEN = 0
C                                       Open PD file
      CALL PDINI ('READ', BUFFER, DISKI, CNOI, VER, CATIN, LUNI, IPDRNO,
     *   PDKOLS, PDNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ, POLTYP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN INPUT TABLE'
         GO TO 990
         END IF
      FOPEN = 1
      REFMT = .FALSE.
      IFREQA = MAX (BCHAN, 1)
      IFREQB = MIN (NUMFRQ, ECHAN)
      NEWFRQ = IFREQB - IFREQA + 1
C                                       New PD table will cover
C                                       IF range [IFA,IFB].
      IFA = MAX (1, BIF)
      IFB = MIN (NUMIF, EIF)
      NEWIF = IFB - IFA + 1
      IF (NEWIF.LE.0) THEN
         IFA = 1
         NEWIF = NUMIF
         END IF
      LBPOL = MAX (1, BPOL)
      NEWPOL = MIN (2, MIN (NUMPOL, EPOL)) - LBPOL + 1
      IF (NEWPOL.LE.0) THEN
         NEWPOL = NUMPOL
         LBPOL = 1
         END IF
C                                       # rows in old table
      NPDROW = BUFFER(5)
C                                       Open up new PD table
      OVER = VER
      CALL PDINI ('WRIT', OBUFF, DISKO, CNOO, OVER, CATOUT, LUNO,
     *   OPDRNO, OKOLS, ONUMV, NUMANT, NEWPOL, NEWIF, NEWFRQ, POLTYP,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN NEW TABLE'
         GO TO 990
         END IF
C                                       Loop and copy
      FOPEN = 2
      DO 300 I = 1,NPDROW
         CALL TABPD ('READ', BUFFER, IPDRNO, PDKOLS, PDNUMV, NUMIF,
     *      NUMFRQ, NUMPOL, ANT, SUBA, FREQID, REFANT, PHDIFF, DTERMS,
     *      IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ OLD TABLE'
            GO TO 990
            END IF
C                                       Is this FQ ID selected ?
         IF ((IFQID.GT.0) .AND. (FREQID.GT.0) .AND. (IFQID.NE.FREQID))
     *      IRET = -10
         IF ((SUBA.GT.0) .AND. (ISUB.GT.0) .AND. (ISUB.NE.SUBA))
     *      IRET = -10
         IF ((IRET.LT.-3) .OR. (NEWFRQ.LE.0)) THEN
            REFMT = .TRUE.
C                                       Copy this record
         ELSE
            DO 40 L = 1,NEWPOL
               M = L + LBPOL - 1
               DO 30 J = 1,NEWIF
                  JJ = IFA + J - 1
                  INX = (J - 1) * NEWFRQ + (M - 1) * NEWFRQ * NEWIF
                  LNX = (JJ - 1) * NUMFRQ + (L - 1) * NUMFRQ * NUMIF +
     *               IFREQA - 1
                  IF (INX.NE.LNX) REFMT = .TRUE.
C                                       Renumber IFs/FREQ's
                  DO 20 K = 1,NEWFRQ
                     INX = INX + 1
                     LNX = LNX + 1
                     DTERMS(1,INX) = DTERMS(1,LNX)
                     DTERMS(2,INX) = DTERMS(2,LNX)
                     IF (L.EQ.1) PHDIFF(INX) = PHDIFF(LNX)
 20                  CONTINUE
 30               CONTINUE
 40            CONTINUE
C                                       Set output FQ ID
            IF (IFQID.GT.0) FREQID = 1
            IF (JSUB.GE.0) SUBA = JSUB
C                                       Write output record.
            CALL TABPD ('WRIT', OBUFF, OPDRNO, OKOLS, ONUMV, NEWIF,
     *         NEWFRQ, NEWPOL, ANT, SUBA, FREQID, REFANT, PHDIFF,
     *         DTERMS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITE NEW TABLE'
               GO TO 990
               END IF
            END IF
 300     CONTINUE
C                                       Close both tables
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         IF (REFMT) THEN
            WRITE (MSGTXT,1300) 'Reformatted PD', DISKI, CNOI, VER,
     *         DISKO, CNOO, OVER
         ELSE
            WRITE (MSGTXT,1300) 'Copied PD', DISKI, CNOI, VER, DISKO,
     *         CNOO, OVER
            END IF
         CALL MSGWRT (3)
         END IF
      GO TO 995
C                                       Error
 990  CALL MSGWRT (6)
C                                       close
 995  IF (FOPEN.GT.0) CALL TABIO ('CLOS', 0, IPDRNO, BUFFER, BUFFER, I)
      IF (FOPEN.GT.1) CALL TABIO ('CLOS', 0, OPDRNO, OBUFF, OBUFF, J)
      IF (IRET.EQ.0) IRET = MAX (I, J)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PDSEL: ERROR ',I3,1X,A)
 1300 FORMAT (A,' file from vol/cno/vers',I3,I5,I4,' to',I3,I5,I4)
      END

      SUBROUTINE UVTBGD (IFIELD, DISKI, CNOSCI, SCROUT, CATUVR, JBUFSZ,
     *   FREQID, BUFF1, BUFF2, IRET)
C-----------------------------------------------------------------------
C! Grids uv data in arbitrary sort order to be FFTed.
C# AP-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 1999-2000, 2006-2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVTBGD convolves uv data onto a grid using AP routines.
C   The visibilities are convolved onto the grid using the convolving
C   function specified by CTYPX,CTYPY,XPARM,YPARM.  The defaults for
C   these values must be filled in by a call to GRDFLT.
C   The gridded data is phase rotated so that the map center comes out
C   at location ICNTRX,ICNTRY.  If requested, a uv taper is applied to
C   the visibility weights before gridding.  If necessary, a three
C   dimension phase reference position  shift is done in AP1GRD.
C      This routine will grid data in arbitrary sord order if there is
C   sufficient memory.  All gridding is done in a single pass and the
C   data is written to disk.
C      Zero spacing flux densities are gridded if provided.
C   Uses AIPS LUNs 18, 20, 21
C   Input uv data file in UV file CNOSCI.
C   Output grid file in image file SCROUT although SCROUT and SCRWRK may
C   be switched if bandwidth synthesis is used.
C   Inputs:
C      IFIELD      I     Field number to grid, if 0 then grid a beam.
C      DISKI       I     Input file disk number for catalogd files,
C                        .LE. 0 => /CFILES/ scratch file.
C      CNOSCI      I     Input file catalog slot number or /CFILES/
C                        scratch file number.
C      DISKO       I     Output file disk number for catalogd files,
C                        .LE. 0 => /CFILES/ scratch file.
C      SCROUT      I     /CFILES/ scratch file number of output file
C      CATUVR(256) R     UV data catalog header record.
C      JBUFSZ      I     Size in bytes of buffers. Dimension of
C                        BUFF1,2,3  must be at least 4096 words
C      FREQID      I     Freq ID number, if it exists.
C   From commons: (Includes DGDS, DMPR, DUVH, CGDS, CMPR, CUVH)
C      NVIS         I    Number of visibility records (/UVHDR/)
C      LREC         I    Number of (real) words per visibility record
C                        (/UVHDR/)
C      NCHAVG       I    Number of frequency channels to grid
C                        together.
C      FLDSZ(2,*)   I    Dimension of map in RA, Dec (cells)
C      CELLSG(2)    R    The cell spacing in X and Y in arcseconds.
C      CHUV1        I    First channel number in file to grid
C                        (1 relative)
C      FREQ         D    Reference frequency (Hz) (/UVHDR/)
C      JLOCF        I    0 relative number of the frequency axis,
C                        (/UVHDR/)
C      TFLUXG       R    The total flux density removed from the data,
C                        this will be subtracted from the zero spacing
C                        flux before gridding.
C      CTYPX,CTYPY  I    Convolving function types for RA and Dec
C      XPARM(10)    R    Convolving function parameters for RA
C                        XPARM(1) = support half width.
C      YPARM(10)    R    Convolving function parameters for Dec.
C      BLMAX        R    Maximum baseline length allowed in 1000s of
C                        wavelengths.
C      BLMIN        R    Minimum baseline length allowed in 1000s of
C                        wavelengths.
C      GUARDB       R(2) Fraction of UMAX and VMAX to blank on edge of
C                        field
C      DOZERO       L    If true then do zero spacing flux.
C      ZEROSP(5)    R    Zero spacing flux, 1=>flux density (Jy)
C                        5 => weight to use.
C                        polarization.
C      DOTAPE       L    True if taper requested.
C      TAPERU,TAPERV R   TAPER ( to 30%) in u and v (kilolamda)
C      NXBEM,NYBEM  I    The size of the BEAM in pixels.
C      FREQG(*)     D    Frequencies of the channels
C      FREQUV       D    Reference frequency for u,v, and w.
C      NGRDAT       L    If FALSE get map size, scaling etc. parms
C                        from the model map cat. header. If TRUE
C                        then the values filled in by GRDAT must
C                        already be filled into the common.
C   The following must be provided if NGRDAT is .TRUE.
C      XFLD,YFLD(*)    R    Field of view in RA and Dec (arcseconds)
C      DXCG,DYCG,DZCG  R    2*pi*(delta ra, delta dec, and delta z)
C                           to be used in AP1GRD to shift positions.
C                           (u,v and w are in cells). one per field.
C      SCLUG,SCLVG,SCLWG R   Conversion factors for u,v and w from
C                           wavelengths at the reference frequency
C                           to cells. one set per field.
C      ICNTRX,ICNTRY(*) I   The center pixel in X and Y for each
C                           field.
C   The following must be provided if NGRDAT is .FALSE.
C      CCDISK(16)  I     Disk numbers of the output images.
C      CCCNO(16)   I     Catalog slot numbers of output images.
C   Output:
C      SCROUT      I     /CFILES/ scratch file number of output file
C      BUFF1       R     Working buffer
C      BUFF2       R     Working buffer
C      IRET        I     Return error code. 0=>OK, error otherwise.
C   Output via common:
C      BEMMAX      R     Sum of weights = normalization factor
C      GUAXAU,GUAXAV R   Max U, V in data set
C      GUAXBU,GUAXBV R   Max U, V used in grid
C   Usage Notes:
C    1) The input uvdata file is, with one exception, assumed to be
C     accurately described by the contents of CATUVR and the common
C     /UVHDR/ (includes DUVH, CUVH).  The exception is that the
C     frequencies of the channels are given by the common array FREQG.
C     The u,v, and w are assumes to be given by the common variable
C     FREQUV.
C    2) the contents of common /UVHDR/ (=includes DUVH, CUVH)
C     are filled in by UVPGET from the catalog header; UVPGET should
C     be called before calling UVTBGD.
C    3) if NGRDAT is .FALSE. then the properties (e.g. shift) of the
C     desired output image are assumed to be described in the catalog
C     header of the existant file pointed to by CCDISK,CCCNO(IFIELD).
C    4) only one polarization will be processed and the input data is
C     assumed to be in the desired Stokes' type (i.e. I, Q, U, V etc.)
C     In the general case this will require reformatting the data.
C     This can be accomplished via CALCOP to do the whole file or
C     UVGET or SET1VS & GET1VS which work a record at a time.
C     Multiple channels may be gridded together a la bandwidth
C     synthesis by specifying NCHAVG > 1. One channel of several
C     channels may be gridded using CHUV1 > 1.
C    5) the random parameters in the data should include, in order,
C     u, v, w, weight (optional), time (optional) and baseline
C     (optional).  While the last are optional and not used, the last
C     words of random parameters are used as work space and, if they
C     are missing, u, v, and w may be clobbered.  The weights are
C     required but may be passed either as random parameters or as
C     part of the regular data array, CATUVR should tell which.
C    6) The necessary image normalization constant for proper
C     normalization of the FFTed image is produced only by a call
C     with IFIELD=0 to grid the sampling function.  Therefore,
C     UVTBGD must be called to grid the sampling function IRREGARDLESS
C     of whether or not a beam will be produced.
C    7) The gridding convolution function parameters must be completely
C     specified.  The defaults should be filled in by a call to
C     GRDFLT before calling UVTBGD.
C    8) Multiple IFs can be processed using the common frequency table
C     FREQG
C-----------------------------------------------------------------------
      INTEGER   IFIELD, DISKI, CNOSCI, SCROUT, JBUFSZ, FREQID, IRET
      REAL      BUFF1(*), BUFF2(*), CATUVR(256)
C
      CHARACTER NAME*48
      INTEGER   VO, BO, LLVIS, VOL, LUNUV, LUN1, JJ, IFACT, INPTR, IERR,
     *   IU, JNPTR, NIO, NPOINT, NX2, BIND2, ILENBU, ICENX, ICENY,
     *   INDS2, NX, NY, JNDX, FLIST(22), VSOFF, LVIS, WTOFF, IWOFF,
     *   NUMROW, NCHGRD, KAP, U, GRID, ROW, NUM, CY, CX, VIS,  WT,
     *   IDATA, UV, ITEMP, LLREC, NO2, M, LROW, TOLROW,  MO2, INDEX,
     *   CNT, MAXREC, APSIZE, APSMWT, I, II, INCNT,  NEEDED, LIMIT,
     *   MCHGRD, APCONI(3), LFIELD, NEED
      LOGICAL   T, F, DOSHFT, BEAM, ONEWT
      REAL      APCONS(20), TUC, TVC, XMAX, ZSCLU, ZSCLV, ZSCLW, XXFLD,
     *   YYFLD, DDXS(3), FFRAC, SUMWT, APXTMP, BLEN, BLMN2, BLMX2,
     *   UUMAX, VVMAX, DU, DV, DW, UIN, VIN, UUMAXG, VVMAXG, UMAT(3,3),
     *   PMAT(3,3)
      DOUBLE PRECISION   WX, WY, TWOPI, FREQLO, FREQHI, XRA, XDEC
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DAPM.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMPR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA VO, BO /0, 1/
      DATA LUNUV, LUN1 /18, 20/
C-----------------------------------------------------------------------
      IRET = 0
      IF ((GUARDB(1).LT.0.0) .OR. (GUARDB(1).GT.0.9)) GUARDB(1) = 0.0
      IF ((GUARDB(2).LT.0.0) .OR. (GUARDB(2).GT.0.9)) GUARDB(2) = 0.0
      GUAXAU = 0.
      GUAXAV = 0.
      GUAXBU = 0.
      GUAXBV = 0.
      GUACNT = 0
      SUMWT = 0.0
C                                       Get field info. if nec.
      IF (.NOT.NGRDAT) THEN
         CALL GRDAT (F, IFIELD, CATUVR, BUFF1, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Fill channel table.
      LFIELD = MAX (1, ABS(IFIELD))
      IF ((IFIELD.LE.0) .AND. (LFIELD.EQ.1)) THEN
         CALL FRQTAB (DISKI, CNOSCI, LUNUV, CATUVR, FREQID, BUFF1, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      IF (DO3DIM) THEN
         MSGTXT = 'WARNING: UVTBGD CALLED WITH DO3DIM TRUE'
         CALL MSGWRT (6)
         CALL XYSHFT (RA, DEC, XSHIFT(LFIELD), YSHIFT(LFIELD), MAPROT,
     *      XRA, XDEC)
         CALL PRJMAT (RA, DEC, UVROT, XRA, XDEC, MAPROT, UMAT, PMAT)
         END IF
C                                       Set parameters for beam/map.
      BEAM = IFIELD.LE.0
C                                       Map.
      IF (IFIELD.GT.0) THEN
         NX = FLDSZ(1,IFIELD)
         NY = FLDSZ(2,IFIELD)
         ICENX = ICNTRX(IFIELD)
         ICENY = ICNTRY(IFIELD)
         ZSCLU = 1.0 / (2.06264E5 / (NX * ABS (CELLSG(1))))
C                                       Flip sign on v to make maps come
C                                       out upside down.
         ZSCLV =  - 1.0 / (2.06264E5 / (NY * CELLSG(2)))
         ZSCLW = 1.0
         XXFLD = XFLD(IFIELD)
         YYFLD = YFLD(IFIELD)
         DDXS(1) = -DXCG(IFIELD)
         DDXS(2) = -DYCG(IFIELD)
         DDXS(3) = -DZCG(IFIELD)
         IF (DO3DIM) CALL PRJMUL (2, DDXS, PMAT, DDXS)
C                                       Beam
      ELSE
         NX = NXBEM(LFIELD)
         NY = NYBEM(LFIELD)
         ICENX = NX / 2
         ICENY = NY / 2 + 1
         ZSCLU = SCLUG(1) * NX / FLDSZ(1,LFIELD)
         ZSCLV = SCLVG(1) * NY / FLDSZ(2,LFIELD)
         ZSCLW = 1.0E-6
         XXFLD = ABS (CELLSG(1)) * NX
         YYFLD = ABS (CELLSG(2)) * NY
         DDXS(1) = 0.0
         DDXS(2) = 0.0
         DDXS(3) = 0.0
         END IF
      DOSHFT = (DDXS(1).NE.0.0) .OR. (DDXS(2).NE.0.0)
C                                       Set baseline limits
C                                       Determine some constants.
      DU = 2.06264E5 / (NX * ABS (CELLSG(1)))
      DV = 2.06264E5 / (NY * CELLSG(2))
      DW = 1.0
C                                       Setup I/O
      ILENBU = 0
C                                       Set up for APIO to transfer
C                                       the GRID to and from the AP.
C                                       Init FLIST
      CALL FILL (22, 0, FLIST)
      FLIST(1) = LUN1
      FLIST(2) = SCROUT
      FLIST(13) = JBUFSZ
C                                       Set grid size
      FLIST(5) = NY * 2
      FLIST(6) = NX / 2 + 1
C                                       Set window - write backwards
      FLIST(9) = 1
      FLIST(10) = FLIST(6)
      FLIST(11) = FLIST(5)
      FLIST(12) = 1
      NCHGRD = NCHAVG
      MCHGRD = NCHAVG
C-----------------------------------------------------------------------
C                                       Set various constants
C                                       Frequency scaling constants
      NX2 = NX / 2
C                                       Set miscellaneous AP values.
      NO2 = MAX (YPARM(1) , 1.0) + 0.1
      M = MAX (XPARM(1) , 1.0) + 0.1
      M = M * 2 + 1
      MO2 = M / 2
      LLREC = LREC
      LROW = NY
      TOLROW = 2 * LROW
      NUMROW = NX / 2 + 1 + M
C                                       IFACT is the number of REAL
C                                       accumulators in GRID per cell
      IFACT = 2
C                                       Is there sufficient memory?
      NEEDED = (NY * IFACT * NUMROW) + ((NO2*2+1) * 100)  + (M * 100)
     *   + NCHAVG + 100 +  (JBUFSZ/2)
      NEED = NEEDED / 1024 + 2
C                                       Grab AP
      CALL QINIT (NEED, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
         MSGTXT = 'UVTBGD CANNOT GET NEEDED MEMORY'
         IRET = 8
         GO TO 995
         END IF
      APSIZE = PSAPNW * 1024
      IF (NEEDED.GT.APSIZE) THEN
         IRET = 9
         WRITE (MSGTXT,1040) NEEDED
         GO TO 995
         END IF
C                                       Set AP pointers
      GRID = APSIZE - (NUMROW * IFACT) * NY - 1
C                                       Set size of grid to clear
      NUM = IFACT * NY * NUMROW
C                                       Set AP locations for conv. fn.
      CY = GRID - 100 * (2 * NO2 + 1) - 1
      CX = CY - 100 * M - 1
C                                       Location of sum of weights for
C                                       beam.
      APSMWT = 21 + NCHAVG
C                                       Set AP data locations
      UV = APSMWT + 1
C                                       Set AP data freq. increment.
      LVIS = INCF
      IF ((INCIF.GT.0) .AND. (INCIF.LT.INCF)) LVIS = INCIF
      LLVIS = LVIS
C                                       Find where weight is.
C                                       IWOFF + => Offset in rec.
C                                       IWOFF - => Offset in vis.
      IWOFF = 0
      CALL AXEFND (4, 'WEIG', KIPTPN, CATUVR(KHPTP), IWOFF, IERR)
C                                       If COMPLEX axis more then
C                                       2 long assume it has weight.
      ONEWT = (LVIS.LE.2)
      IF (.NOT.ONEWT) IWOFF = -2
C                                       Set constants.
C                                       To simplify the map output
C                                       routine, shift the map center
C                                       here in the gridding routine.
C                                       ICENX and ICENY define the
C                                       pixel number of the map center,
C                                       counted from the front of the
C                                       file.
      TWOPI = 8.0D0 * ATAN (1.0D0)
      WX = (-TWOPI * (ICENX-1-NX/2)) / NX
      WY = (-TWOPI * (ICENY-1-NY/2)) / NY
C                                       Convert taper widths to
C                                       convenient constants.
      TUC = 0.0
      TVC = 0.0
      IF (DOTAPE) THEN
         IF (TAPERU.GT.0.) TUC = LOG(.3) / (TAPERU * 1E3 /
     *      206265. * XXFLD) ** 2
         IF (TAPERV.GT.0.) TVC = LOG(.3) / (TAPERV * 1E3 /
     *      206265. * YYFLD) ** 2
         END IF
C                                       Set AP gridding constants.
      APCONS(1) = COS ((NX / 2) * WX)
      APCONS(2) = SIN ((NX / 2) * WX)
      APCONS(3) = COS (WY)
      APCONS(4) = SIN (WY)
      APCONS(5) = COS (-WX)
      APCONS(6) = SIN (-WX)
      APCONS(7) = 1.0
      APCONS(8) = 0.0
      APCONS(9) = 0.0
      APCONS(10) = TUC
      APCONS(11) = TVC
      APCONI(1) =  CX
      APCONI(2) =  CY
      APCONI(3) =  GRID
C                                       Determine the maximum number
C                                       of visibility points which
C                                       fit in the AP.
      MAXREC = (CX - UV) / LREC - 5
C                                       Be sure MAXREC.GT.10
      IF (MAXREC.LE.10) THEN
         XMAX = - MAXREC * LREC
         IF (MAXREC.GT.0) XMAX = (11 - MAXREC) * LREC
         WRITE (MSGTXT,1040) XMAX
         IRET = 1
         GO TO 995
         END IF
C                                       Open files. Use UVINIT and
C                                       UVDISK to read the
C                                       visibility file,
C                                       APIO to read and write the
C                                       grid file.
      VOL = DISKI
      IF (DISKI.LE.0) VOL = SCRVOL(CNOSCI)
      IF (DISKI.GT.0) CALL ZPHFIL ('UV', VOL, CNOSCI, 1, NAME, IRET)
      IF (DISKI.LE.0) CALL ZPHFIL ('SC', VOL, SCRCNO(CNOSCI), 1,
     *   NAME, IRET)
      CALL ZOPEN (LUNUV, INDS2, VOL, NAME, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1050) IRET
         GO TO 995
         END IF
C-----------------------------------------------------------------------
C                                       Grid data.
C                                       Init UV file.
      CALL UVINIT ('READ', LUNUV, INDS2, NVIS, VO, LREC, ILENBU,
     *   JBUFSZ, BUFF1, BO, BIND2, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1060) IRET
         GO TO 995
         END IF
      FLIST(13) = JBUFSZ
C                                       Clear grid.
      CALL QVCLR (GRID, 1, NUM)
C                                       Offset VIS to freq channel.
      VSOFF = NRPARM + (CHUV1-1) * LVIS
      VIS = UV + VSOFF
C                                       Set weight pointer.
      WTOFF = IWOFF
      IF (IWOFF.LE.0) WTOFF = VSOFF - IWOFF
      WT = UV + WTOFF
C                                       Convolving functions
      CALL CONVFN (CX, CTYPX, XPARM, BUFF2)
      CALL CONVFN (CY, CTYPY, YPARM, BUFF2)
C                                       Frequency scaling table
      FREQLO = FREQG(CHUV1)
      FREQHI = FREQG(CHUV1)
      LIMIT = CHUV1 + NCHAVG - 1
      DO 100 II = CHUV1,LIMIT
C                                       Use BUFF2.
         IF (II.GT.CHUV1) BUFF2(II-CHUV1) =
     *      (FREQG(II) / FREQG(II-1)) - 1.0D0
         FREQLO = MIN (FREQLO, FREQG(II))
         FREQHI = MAX (FREQHI, FREQG(II))
 100     CONTINUE
      CALL QPUT (BUFF2, 20, NCHGRD, 2)
      IF (DOTAPE) NCHGRD = -NCHGRD
C                                       Set freq. scaling factors
      FFRAC = (FREQG(CHUV1) / FREQUV) - 1.0D0
C                                       Set limits.
C                                       Stay away from edge of grid.
      UUMAX = (NX/2-0.5) * DU - MAX (3.0, XPARM(1)) * DU
      VVMAX = (NY/2-0.5) * DV - MAX (3.0, YPARM(1)) * DV
      BLMX2 = 1.0E6 * BLMAX * BLMAX
      IF (BLMAX.LE.1.0) BLMX2 = 1.0E20
      BLMN2 = 1.0E6 * BLMIN * BLMIN
C                                       Rescale baseline limits.
      BLMN2 = BLMN2 / ((1.0D0 + FFRAC) ** 2)
      BLMX2 = BLMX2 / ((1.0D0 + FFRAC) ** 2)
      UUMAX = UUMAX / (1.0D0 + FFRAC)
      VVMAX = VVMAX / (1.0D0 + FFRAC)
      UUMAXG = NX/2 * DU * (1. - GUARDB(1)) / (1.0D0 + FFRAC)
      VVMAXG = NY/2 * DV * (1. - GUARDB(2)) / (1.0D0 + FFRAC)
      UUMAXG = MIN (UUMAXG, UUMAX)
      VVMAXG = MIN (VVMAXG, VVMAX)
C                                       Put gridding constants into AP
      APCONS(12) = FFRAC*ZSCLU + ZSCLU
      APCONS(13) = FFRAC*ZSCLV + ZSCLV
      APCONS(14) = FFRAC*ZSCLW + ZSCLW
      APCONS(15) = DDXS(1) / ZSCLU
      APCONS(16) = DDXS(2) / ZSCLV
      APCONS(17) = DDXS(3) / ZSCLW
      APCONI(3) = GRID
      CALL QPUT (APCONS, 0, 17, 2)
      CALL QPUT (APCONI, 17, 3, 1)
      NPOINT = 0
      INCNT = 1
      CNT = 0
      IDATA = UV
C                                       Loop through data.
 150     CALL UVDISK ('READ', LUNUV, INDS2, BUFF1, NIO, BIND2, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 995
            END IF
         INPTR = BIND2
         IF (NIO.LE.0) GO TO 500
C                                       Munge Buffer
         DO 200 IU = 1,NIO
            JNPTR = INPTR + ILOCU
            IF (DO3DIM) CALL PRJMUL (1, BUFF1(JNPTR), UMAT,
     *         BUFF1(JNPTR))
            UIN = ABS (BUFF1(JNPTR))
            VIN = ABS (BUFF1(JNPTR+1))
C                                       Check UV location
            BLEN = UIN * UIN + VIN * VIN
            IF (BLEN.LE.BLMX2) THEN
               GUAXAU = MAX (GUAXAU, UIN)
               GUAXAV = MAX (GUAXAV, VIN)
               END IF
C                                       Dummy data, zero weight.
            IF (((BLEN.LT.BLMN2) .OR. (BLEN.GT.BLMX2)) .OR.
     *         (UIN.GE.UUMAXG) .OR. (VIN.GE.VVMAXG)) THEN
               JNDX = INPTR + VSOFF
               BUFF1(JNPTR) = 0.0
               BUFF1(JNPTR+1) = 0.0
               IF (WTOFF.GT.0) BUFF1(INPTR+WTOFF) = 0.0
               DO 160 JJ = 1,MCHGRD
                  BUFF1(JNDX) = 0.0
                  BUFF1(JNDX+1) = 0.0
                  IF (LVIS.GT.2) BUFF1(JNDX+2) = 0.0
                  JNDX = JNDX + LVIS
 160              CONTINUE
            ELSE
               GUACNT = GUACNT + 1
               GUAXBU = MAX (GUAXBU, UIN)
               GUAXBV = MAX (GUAXBV, VIN)
               END IF
C                                       BEAM replace data with (1,0)
            IF (BEAM) THEN
               JNDX = INPTR + VSOFF
               DO 170 JJ = 1,MCHGRD
                  BUFF1(JNDX) = 1.0
                  BUFF1(JNDX+1) = 0.0
                  JNDX = JNDX + LVIS
 170              CONTINUE
               END IF
C                                       Check if U neg.; if so then flip
C                                       data to other half plane.
            IF (BUFF1(JNPTR).LT.0.0) THEN
C                                       Flip U, V, W, conjugate data.
               BUFF1(JNPTR) = -BUFF1(JNPTR)
               BUFF1(JNPTR+1) = -BUFF1(JNPTR+1)
               BUFF1(JNPTR+2) = -BUFF1(JNPTR+2)
               JNDX = INPTR + VSOFF + 1
               DO 180 JJ = 1,MCHGRD
                  BUFF1(JNDX) = -BUFF1(JNDX)
                  JNDX = JNDX + LVIS
 180              CONTINUE
               END IF
            NPOINT = NPOINT + 1
            INPTR = INPTR + LREC
 200        CONTINUE
C                                       Move to  AP.
C                                       Time to grid
         IF ((CNT+NPOINT).GT.MAXREC) THEN
            ITEMP = -CNT
            IF (DOSHFT) ITEMP = -ITEMP
            CALL Q1GRD (UV ,VIS, WT, LLREC, LLVIS, NO2, M, LROW, ITEMP,
     *         NCHGRD)
            CALL QWR
            IDATA = UV
            CNT = 0
            END IF
C                                       Load into AP.
         CNT = CNT + NPOINT
         ITEMP = LREC * NPOINT
         CALL QPUT (BUFF1(BIND2), IDATA, ITEMP, 2)
         IDATA = IDATA + ITEMP
         NPOINT = 0
C                                       Read more data
         IF (NIO.GT.0) GO TO 150
C                                       Grid any remaining data
C                                       Check if AP full or row finished
 500  IF (CNT.GT.0) THEN
         ITEMP = -CNT
         IF (DOSHFT) ITEMP = -ITEMP
         CALL Q1GRD (UV ,VIS, WT, LLREC, LLVIS, NO2, M,
     *      LROW, ITEMP, NCHGRD)
         CALL QWR
         END IF
C                                       Do zero spacing flux densities
      IF (DOZERO) THEN
C                                       Fill values
         CALL RFILL (NRPARM, 0.0, BUFF1)
         IF (LVIS.LE.2) BUFF1(1+WTOFF) = ZEROSP(5)
         JNDX = NRPARM + 1
         DO 550 II = 1,NCHAVG
            BUFF1(JNDX) = ZEROSP(1) - TFLUXG
            BUFF1(JNDX+1) = 0.0
            IF (LVIS.GT.2) BUFF1(JNDX+2) = ZEROSP(5)
            JNDX = JNDX + LVIS
 550        CONTINUE
C                                       Put into AP
         ITEMP = NRPARM + LVIS * NCHAVG
         CALL QWAIT
         CALL QPUT (BUFF1, UV, ITEMP, 2)
         ITEMP = -1
         IF (DOSHFT) ITEMP = -ITEMP
         CALL QWAIT
C                                       Grid
         CALL Q1GRD (UV, VIS, WT, LLREC, LLVIS, NO2, M, LROW, ITEMP,
     *      NCHGRD)
         END IF
      LIMIT = NX / 2 + M - 1
C                                       If beam sum weights
      IF (BEAM) THEN
         DO 600 IU = MO2,LIMIT
            U = LIMIT - IU - MO2
            ROW = GRID + (U + MO2) * IFACT * NY
            CALL QWAIT
            CALL QSVE (ROW, 2, APSMWT, LROW)
C                                       Read sum of weights
            CALL QWR
            CALL QGET (APXTMP, APSMWT, 1, 2)
            CALL QWD
C                                       Double sum wt. since both
C                                       halves of plane used.
            SUMWT = SUMWT + 2 * APXTMP
 600        CONTINUE
         END IF
C                                       Finish grid and write to disk
      DO 700 IU = MO2,LIMIT
         U = LIMIT - IU - MO2
         ROW = GRID + (U + MO2) * IFACT * NY
C                                       Finish grid
         IF ((U.LE.(NX/2)) .AND. (U.GE.0)) THEN
            CALL Q1FIN (U, ROW, MO2, LROW)
C                                       Write new GRID file values.
            CALL QWAIT
            CALL APIO ('WRIT', FLIST, ROW, BUFF2, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1550) IRET, I
               GO TO 995
               END IF
            END IF
 700     CONTINUE
C                                       Give up AP
      CALL QRLSE
C                                       Close files
      CALL ZCLOSE (LUNUV, INDS2, IRET)
      CALL APIO ('CLOS', FLIST, INDEX, BUFF2, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1600) IRET
         GO TO 995
         END IF
C                                       Set sum of weights
      IF (BEAM) THEN
         BEMMAX(LFIELD) = SUMWT
         WRITE (MSGTXT,1601) LFIELD, BEMMAX(LFIELD)
         CALL MSGWRT (4)
         END IF
      GO TO 999
C                                       Error
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('UVTBGD: NEED AT LEAST ',I9,' WORDS OF AP MEMORY')
 1050 FORMAT ('UVTBGD: TROUBLE OPENING UV DATA FILE, IER=',I3)
 1060 FORMAT ('UVTBGD: ERROR',I3,' INITIALIZING FILE')
 1100 FORMAT ('UVTBGD: READ ERROR IN VISIBILITY FILE, IER=',I3)
 1550 FORMAT ('UVTBGD: ERROR',I3,' WRITING GRID ROW ',I5)
 1600 FORMAT ('UVTBGD: TROUBLE CLOSING FILE, IER=',I3)
 1601 FORMAT ('Field',I5,' Sum of gridding weights = ',1PE12.5)
      END

LOCAL INCLUDE 'IMFLT.INC'
C                                       Local include for IMFLT
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO,
     *   CATOLD(256), CATBLK(256), JBUFSZ, ICODE, SCRTCH(512)
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      REAL      XSEQIN, XDISKI, XSEQO, XDISKO, BLC(7), TRC(7), XBOXES,
     *   BOX(4,10), APARM(10), PIXR(2), BUFF1(MABFSS), BUFF2(MABFSS)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XNAMOU, XCLAOU,
     *   XSEQO, XDISKO, BLC, TRC, XBOXES, BOX, APARM, PIXR
      COMMON /PARMS/ SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO,
     *   CATOLD, JBUFSZ, ICODE
      COMMON /BUFRS/ BUFF1, BUFF2, SCRTCH
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMOUT, CLAOUT
      COMMON /MAPHDR/ CATBLK
C                                       End IMFLT
LOCAL END
      PROGRAM IMFLT
C-----------------------------------------------------------------------
C!  Fits a plane to selected portions of an images and flattens it.
C#  Map-util Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000, 2008, 2010
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   IMFLT fits a plane to the data included in the boxes defined by
C   BOX.  The image is the flattened using this plane.
C   APARM indicates how the fit plane is used.
C
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLAOUT        Class of the output image.
C                                   Default is input class.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      NBOXES         NBOXES        Number of boxes in fit.
C      BOX(4,10)      BOX           BLC and TRC for each box.
C      APARM(10)      APARM         (1) determines order of the fit.
C                                     =  0 only the mean value is used.
C                                     =  1 the fit plane is used.
C                                     = -1 then a plane whose slope
C                                          in direction APARM(2)
C                                          is removed from the data.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'IMFLT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'IMFLT '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL FLTIN (PRGM, IRET)
C                                       Call routine that flattens
C                                       the image.
      IF (IRET.EQ.0) CALL FLATEN (IRET)
C                                       History
      IF (IRET.EQ.0) CALL FLTHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE FLTIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   FLTIN gets input parameters for IMFLT and creates an output file.
C   Inputs:  PRGN    C*6       Program name
C   Output:  IRET    I         Error code: 0 => ok
C                                4 => user routine detected error.
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in IMFLT for more details.
C-----------------------------------------------------------------------
      CHARACTER  STAT*4, PRGN*6, MTYPE*2
      HOLLERITH CATH(256)
      INTEGER   IRET, IERR, NPARM, IROUND
      REAL      CATR(256)
      INCLUDE 'IMFLT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATR, CATH, CATBLK)
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 81
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.EQ.0) GO TO 10
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
C                                       Restart AIPS
 10   IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO = IROUND (XDISKO)
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C
      IF ((APARM(1).GE.0.) .OR. (APARM(2).NE.0.)) GO TO 20
          WRITE (MSGTXT,1060)
          GO TO 990
   20 CONTINUE
C                                       Create new file.
C                                       Get CATBLK from old file.
 30   OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.EQ.0) GO TO 40
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
C                                       Read CATBLK and mark 'READ'.
 40   CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, 'READ', SCRTCH, IERR)
      IF (IERR.EQ.0) GO TO 50
         WRITE (MSGTXT,1040) IERR
         GO TO 990
 50   NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Copy old CATBLK to new.
      CALL COPY (256, CATOLD, CATBLK)
      IF ((PIXR(1).GE.PIXR(2)) .OR. (PIXR(1).GE.CATR(KRDMX)) .OR.
     *   (PIXR(2).LE.CATR(KRDMN))) THEN
         PIXR(1) = CATR(KRDMN)
         PIXR(2) = CATR(KRDMX)
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATOLD(KIDIM), CATOLD(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get user modification to CATBLK
      IRET = 4
      CALL FLTHED (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create output file.
      NEWCNO = 1
      IRET = 4
      CALL MCREAT (DISKO, NEWCNO, SCRTCH, IERR)
      IF (IERR.EQ.0) GO TO 70
         WRITE (MSGTXT,1050) IERR
         GO TO 990
 70   NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy keywords partly
      CALL KEYPCP (DISKIN, OLDCNO, DISKO, NEWCNO, 0, ' ', IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FLTIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('FLTIN: ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('FLTIN: ERRIR...YOU MUST SPECIFY A SLOPE FOR A ',
     *               'CONSTRAINED FIT ')
      END
      SUBROUTINE FLATEN (IRET)
C-----------------------------------------------------------------------
C   FLATEN is called by IMFLT to read an image, and determine the best
C   fit slope (one plane at a time).  Then, it uses the values of APARM
C   to decide on the background to subtract off the image.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER IFILE*48
      INTEGER   IBOX(4,10), NBOX
      INTEGER   IRET, IROUND, LUNI, LUNO, NYI, NXI, WINI(4), WINI2(4),
     *   NXO, NYO, WINO(4), BOI, BOO, LIM2, LIM3, LIM4, LIM5, LIM6,
     *   LIM7, I1, I2, I3, I4, I5, I6, I7, IPOS(7), CORN(7), BOTEMP,
     *   KOFF, LIMO, IBIND, OBIND, INDI, INDO, LIM1, I, J
      REAL      OUTMAX, OUTMIN, CATR(256), OLDR(256), TEMP
      DOUBLE PRECISION    OLDD(128), CATD(128)
      REAL   SUMN, SUMX, SUMY, SUMZ, SUMXX, SUMYY, SUMXY, SUMXZ, SUMYZ
      LOGICAL   T, F, BLNKD
      REAL   DENOM, SLOPEX, SLOPEY, ZMEAN, YMEAN, XMEAN, SPHI, CPHI,
     *   SLOPE, ANGLE, RADDEG, XC, YC, X, Y
      INCLUDE 'IMFLT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATBLK, CATR, CATD),  (CATOLD, OLDR, OLDD)
      DATA LUNI, LUNO /16,17/
      DATA T, F /.TRUE.,.FALSE./
      DATA RADDEG /57.29577852/
C-----------------------------------------------------------------------
C                                       Open and init for read
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.LE.0) GO TO 10
         WRITE (MSGTXT,1000) IRET
         GO TO 990
 10   CONTINUE
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, T, T, IRET)
      IF (IRET.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) IRET
         GO TO 990
C                                       Setup for I/O for input map.
 30   NXI = CATOLD(KINAX)
      NYI = CATOLD(KINAX+1)
C                                      Set input window for first pass.
C                                      For the first pass, the entire
C                                      image is read.
      WINI(1) = 1
      WINI(2) = 1
      WINI(3) = NXI
      WINI(4) = NYI
C                                      Box off positions are from the
C                                      BLC OF THE INPUT WINDOW
      NBOX = INT (XBOXES)
      CALL COPY (4, WINI, IBOX)
      I3 = 0
      IF (NBOX.GT.0) THEN
         DO 35 I = 1,NBOX
            I2 = 0
            DO 32 J = 1,4
               WINI2(J) = BOX(J,I) + 0.1
               IF (WINI2(J).GT.0) I2 = I2 + 1
 32            CONTINUE
            IF (I2.EQ.4) THEN
               I3 = I3 + 1
               CALL COPY (4, WINI2, IBOX(1,I3))
               END IF
 35         CONTINUE
         END IF
      NBOX = MAX (1, I3)
C                                       Set up window for output
      NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
C                                       Set up input window
C                                       for second pass
      WINI2(1) = BLC(1)
      WINI2(2) = BLC(2)
      WINI2(3) = TRC(1)
      WINI2(4) = TRC(2)
      OUTMAX = -1.0E20
      OUTMIN = 1.0E20
      BLNKD = F
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
      KOFF = 0
      CORN(7) = 1
      LIMO = CATBLK(KINAX) - 1
      YC = LIM2 / 2.0
      XC = LIM1 / 2.0
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         CORN(7+KOFF) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            CORN(6+KOFF) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               CORN(5+KOFF) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  CORN(4+KOFF) = I4
                  DO 300 I3 = 1,LIM3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     CORN(3+KOFF) = I3
C                                    Initialize sums
      SUMN  = 0.
      SUMX  = 0.
      SUMY  = 0.
      SUMZ  = 0.
      SUMXX = 0.
      SUMYY = 0.
      SUMXY = 0.
      SUMXZ = 0.
      SUMYZ = 0.
C
C                                       Init. input file, first pass.
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1099) IRET
            GO TO 990
            END IF
 100     BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'READ', IRET
            GO TO 990
            END IF
C                                           Loop over the y axis
         DO 190 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
            Y = I2 - YC
C                                          Read one row of input file,
C                                          first pass.
            CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'READ', IRET
               GO TO 990
               END IF
C                                           Loop over the x axis
          DO 180 I1 = 1,LIM1
C                                           Is this pixel in a box ?
              DO 150 I = 1,NBOX
                  IF ((I1.GE.IBOX(1,I)).AND.(I1.LE.IBOX(3,I))
     *                                  .AND.
     *                 (I2.GE.IBOX(2,I)).AND.(I2.LE.IBOX(4,I)))
     *                                GO TO 160
  150         CONTINUE
C                                             No.
              GO TO 180
C                                             Yes.
  160         TEMP = BUFF1(IBIND+I1-1)
C                                                Include it in the sums.
              IF ((TEMP.NE.FBLANK) .AND. (TEMP.GE.PIXR(1)) .AND.
     *           (TEMP.LE.PIXR(2))) THEN
                 X = I1 - XC
                 SUMN  = SUMN  + 1.
                 SUMX  = SUMX  + X
                 SUMY  = SUMY  + Y
                 SUMZ  = SUMZ  + TEMP
                 SUMXX = SUMXX + X * X
                 SUMYY = SUMYY + Y * Y
                 SUMXY = SUMXY + X * Y
                 SUMXZ = SUMXZ + X * TEMP
                 SUMYZ = SUMYZ + Y * TEMP
                 END IF
  180        CONTINUE
  190     CONTINUE
C                                                Calculate the fit.
          IF (SUMN.EQ.0.) THEN
             WRITE (MSGTXT,1300) ' NO DATA POINTS IN BOXES '
             IRET = 2
             GO TO 990
             END IF
          WRITE (MSGTXT,1310) ' NUMBER OF FIT POINTS =', SUMN
          CALL MSGWRT (8)
          SUMXX = SUMXX - SUMX*SUMX/SUMN
          SUMYY = SUMYY - SUMY*SUMY/SUMN
          SUMXY = SUMXY - SUMX*SUMY/SUMN
          SUMXZ = SUMXZ - SUMX*SUMZ/SUMN
          SUMYZ = SUMYZ - SUMY*SUMZ/SUMN
          DENOM = SUMXY * SUMXY - SUMXX * SUMYY
          IF (DENOM.EQ.0.) THEN
             WRITE (MSGTXT,1300) ' INFINITE SLOPE ! '
             IRET = 2
             GO TO 990
             END IF
          YMEAN = SUMY / SUMN
          XMEAN = SUMX / SUMN
          ZMEAN = SUMZ / SUMN
          SLOPEX = (SUMXY*SUMYZ - SUMXZ*SUMYY) / DENOM
          SLOPEY = (SUMXY*SUMXZ - SUMYZ*SUMXX) / DENOM
C                                       Use APARM to determine the
C                                       type of fit desired.
C                                       Set coefficients appropriately
          I = INT (MIN (1., MAX(-1., APARM(1))))
          IF (I.EQ.1) THEN
             ZMEAN  = ZMEAN - SLOPEY*YMEAN - SLOPEX*XMEAN
C                                       Subtract constrained slope.
C                                       APARM(2) contains the direction
C                                       of zero slope in output image.
          ELSE IF (I.EQ.-1) THEN
             SPHI = SIN (APARM(2)/RADDEG)
             CPHI = COS (APARM(2)/RADDEG)
             ZMEAN  = ZMEAN - SLOPEX * CPHI * XMEAN
     *          - SLOPEY * SPHI * YMEAN
             SLOPEX = CPHI * SLOPEX
             SLOPEY = SPHI * SLOPEY
C                                       just the mean
          ELSE
             SLOPEX = 0.
             SLOPEY = 0.
             END IF
C                                       Output information about the fit
          SLOPE = SQRT  (SLOPEX*SLOPEX + SLOPEY*SLOPEY)
          ANGLE = 0.
          IF (ABS(SLOPEY).GT.1.E-6*ABS(SLOPEX)) ANGLE =
     *       ATAN (SLOPEX / SLOPEY) * RADDEG
          WRITE (MSGTXT,1310) ' Offset  is  ',ZMEAN
          CALL MSGWRT (4)
          IF (I.NE.0) THEN
             WRITE (MSGTXT,1310) ' X slope is  ', SLOPEX
             CALL MSGWRT (4)
             WRITE (MSGTXT,1310) ' Y slope is  ', SLOPEY
             CALL MSGWRT (4)
             WRITE (MSGTXT,1310) ' Total slope ',SLOPE
             CALL MSGWRT (4)
             WRITE (MSGTXT,1320) ' Direction   ',ANGLE, '  degrees'
             CALL MSGWRT (4)
             END IF
C                                       send to HI
          APARM(6) = ZMEAN
          APARM(7) = SLOPEX
          APARM(8) = SLOPEY
          APARM(9) = SLOPE
          APARM(10) = ANGLE
C*******************************************************************
C                                       First pass finished
C                                       Init. files for second pass.
C                                       Input file.
C
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         IF (IRET.EQ.0) GO TO 205
            WRITE (MSGTXT,1099) IRET
            GO TO 990
  205    BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI2, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.EQ.0) GO TO 210
            WRITE (MSGTXT,1100) 'READ', IRET
            GO TO 990
  210    CONTINUE
C                                        Output file.
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORN(3), BOTEMP,
     *      IRET)
         BOO = BOTEMP + 1
         CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO, BUFF2, JBUFSZ,
     *      BOO, IRET)
         IF (IRET.EQ.0) GO TO 211
             WRITE (MSGTXT,1100) 'WRIT', IRET
             GO TO 990
  211    CONTINUE
C                                                    Loop
         DO 260 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
            Y = I2 - YC
            TEMP = ZMEAN + SLOPEY * Y
C
C                                       Read input file, second pass.
            CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'READ', IRET
               GO TO 990
               END IF
C                                       It is necessary to setup
C                                       output file here.
C                                       First call initializes pointers.
            CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'WRIT', IRET
               GO TO 990
                END IF
C                                       Copy to buffer.
             DO 250 I1 = 1,LIM1
                X = I1 - XC
C                                        Blanked data?
                IF (BUFF1(IBIND+I1-1).EQ.FBLANK) THEN
                   BUFF2(OBIND+I1-1) = FBLANK
                   BLNKD = .TRUE.
C                                        subtract off fitted background
C                                        move data to output buffer.
                ELSE
                   BUFF2(OBIND+I1-1) = BUFF1(IBIND+I1-1) - TEMP
     *                - SLOPEX * X
                   OUTMAX = MAX (OUTMAX, BUFF2(OBIND+I1-1))
                   OUTMIN = MIN (OUTMIN, BUFF2(OBIND+I1-1))
                   END IF
 250            CONTINUE
 260         CONTINUE
 300     CONTINUE
C                                         Flush buffer.
                 CALL MDISK ('FINI', LUNO, INDO, BUFF2, OBIND, IRET)
                 IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1120) 'FINI', IRET
                     GO TO 990
                     END IF
C                                       Update CATBLK.
                  CATR(KRDMX) = OUTMAX
                  CATR(KRDMN) = OUTMIN
                  CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST',
     *               SCRTCH, IRET)
                  IF (IRET.EQ.0) GO TO 400
                     WRITE (MSGTXT,1260) IRET
                     GO TO 990
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Mark blanking in CATBLK.
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
C                                       Close input map.
      CALL ZCLOSE (LUNI, INDI, IRET)
 720  CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FLATEN: ERROR',I3,' OPENING INPUT FILE')
 1020 FORMAT ('FLATEN: ERROR',I5,' OPENING OUTPUT FILE')
 1099 FORMAT ('FLATEN: COMOFF ERROR',I3)
 1100 FORMAT ('FLATEN: INIT-FOR-',A4,' ERROR',I3)
 1113 FORMAT ('FLATEN: OUTCNT.LT.0! Too many output rows returned.')
 1120 FORMAT ('FLATEN: ',A4,' ERROR',I3)
 1180 FORMAT ('FLATEN: DIDDLE ERROR',I3)
 1200 FORMAT ('FLATEN: INFINITE SLOPE IN FITTING....BAD DATA ')
 1260 FORMAT ('FLATEN: CATIO ERROR',I3,' UPDATING CATBLK')
 1300 FORMAT ('FLATEN: ',A)
 1310 FORMAT ('FLATEN: ',A,1PE15.8)
 1320 FORMAT ('FLATEN: ',A,F7.1,2X,A)
      END
      SUBROUTINE FLTHIS
C-----------------------------------------------------------------------
C   FLTHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, NOTTYP*2
      INTEGER   LUN1, LUN2, IERR, I, IROUND
      LOGICAL   T
      INCLUDE 'IMFLT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NOTTYP /'  '/
C-----------------------------------------------------------------------
C
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   SCRTCH(257), SCRTCH, IERR)
      IF (IERR.LE.2) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 20
C                                       New history
 10   CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, SCRTCH,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       BLC
      WRITE (HILINE,2000) TSKNAM, BLC
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       TRC
      WRITE (HILINE,2001) TSKNAM, TRC
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       pixrange
      WRITE (HILINE,2003) TSKNAM, PIXR
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR. NE. 0) GO TO 20
C                                        APARM
      I = IROUND (APARM(1))
      I = MAX (-1, MIN (1, I))
      WRITE (HILINE,2004) TSKNAM, I
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C
      IF (I.EQ.-1) THEN
         WRITE (HILINE,2005) TSKNAM, APARM(2)
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         IF (IERR. NE. 0) GO TO 20
         END IF
C
      WRITE (HILINE,2006) TSKNAM, APARM(6)
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR. NE. 0) GO TO 20
C
      IF (I.NE.0) THEN
         WRITE (HILINE,2007) TSKNAM, APARM(7)
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         IF (IERR. NE. 0) GO TO 20
         WRITE (HILINE,2008) TSKNAM, APARM(8)
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         IF (IERR. NE. 0) GO TO 20
         WRITE (HILINE,2009) TSKNAM, APARM(9)
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         IF (IERR. NE. 0) GO TO 20
         WRITE (HILINE,2010) TSKNAM, APARM(10)
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         IF (IERR. NE. 0) GO TO 20
         END IF
C                                       Close HI file
 20   CALL HICLOS (LUN2, T, SCRTCH, IERR)
C                                        Copy tables
      CALL ALLTAB (1, NOTTYP, LUN1, LUN2, DISKIN, DISKO, OLDCNO,
     *   NEWCNO, CATBLK, SCRTCH(257), SCRTCH, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FLTHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 2000 FORMAT (A6,'BLC =',6(F6.0,','),F6.0)
 2001 FORMAT (A6,'TRC =',6(F6.0,','),F6.0)
 2003 FORMAT (A6,'PIXRANGE=',2(1PE12.4))
 2004 FORMAT (A6,'APARM(1) = ',I2)
 2005 FORMAT (A6,'APARM(2) = ',F8.3)
 2006 FORMAT (A6,'/ MEAN PIX  = ',1PE15.8)
 2007 FORMAT (A6,'/ SLOPE X   = ',1PE15.8)
 2008 FORMAT (A6,'/ SLOPE Y   = ',1PE15.8)
 2009 FORMAT (A6,'/ SLOPE TOT = ',1PE15.8)
 2010 FORMAT (A6,'/ DIRECTION = ',F10.5)
      END
      SUBROUTINE FLTHED (IRET)
C-----------------------------------------------------------------------
C   FLTHED is a routine in which sets the limits on the axes of the new
C   catalog.  It can be safely replaced by the template routine, NEWHED,
C   associated with task TAFFY.
C   See initial comments in that subroutine for more information.
C-----------------------------------------------------------------------
      CHARACTER FCHARS(3)*4, CHTMP*4
      HOLLERITH CATH(256), OLDH(256)
      INTEGER   LIMIT, I, FIRSTI, FIRSTO, IRET
      REAL      CATR(256), OLDR(256)
      DOUBLE PRECISION    CATD(128), OLDD(128)
      INTEGER   INDXI, INDEX
      INCLUDE 'IMFLT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE  (CATBLK, CATR, CATD, CATH)
      EQUIVALENCE  (CATOLD, OLDR, OLDD, OLDH)
      DATA FCHARS /'FREQ','VELO','FELO'/
C-----------------------------------------------------------------------
C                                       Set axes in output CATBLK.
      FIRSTI = -1
      FIRSTO = -1
      LIMIT = CATOLD(KIDIM)
C                                       Copy/update axis values
      DO 80 I = 1,LIMIT
         CATBLK(KINAX+FIRSTO+I) = TRC(I+FIRSTI+1) -
     *      BLC(I+FIRSTI+1) + 1.01
         CATR(KRCRP+FIRSTO+I) = OLDR(KRCRP+FIRSTI+I) - BLC(I+FIRSTI+1)
     *      + 1.0
         CATR(KRCIC+FIRSTO+I) = CATR(KRCIC+FIRSTI+I)
         CATD(KDCRV+FIRSTO+I) = OLDD(KDCRV+FIRSTI+I)
         INDXI = KHCTP + (I+FIRSTI) * 2
         INDEX = KHCTP + (I-1) * 2
         CATH(INDEX) = OLDH(INDXI)
         CATH(INDEX+1) = OLDH(INDXI+1)
         IF (CATBLK(KIALT).EQ.0) GO TO 80
            CALL H2CHR (4, 1, CATH(INDEX), CHTMP)
            IF ((CHTMP.EQ.FCHARS(1)) .OR. (CHTMP.EQ.FCHARS(2)) .OR.
     *         (CHTMP.EQ.FCHARS(3))) CATR(KRARP) = CATR(KRARP) -
     *         BLC(FIRSTI+I+1) + 1.0
 80      CONTINUE
C                                       Finished.
      IRET = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
      END

      SUBROUTINE ZTPWAR (FCB, IERR)
C-----------------------------------------------------------------------
C! wait for asynchronous IO to finish on remote tape or pseudo-tape disk
C# Z2 Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Wait until an asynchronous tape or sequential pseudo-tape disk file
C   I/O operation completes.
C   Inputs:
C      FCB    I(*)   FTAB structure for this buffer
C   Output:
C      IERR   I      Error return code: 0 => no error
C                       1 => LUN not open in FTAB
C                       3 => I/O error
C                       4 => end of file
C                       7 => wait service error
C   Generic version - picks up things left by ZTPMIR since we force
C   remote tapes to be synchronous.
C-----------------------------------------------------------------------
      INTEGER   FCB(*), IERR
C
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
C-----------------------------------------------------------------------
      IERR = FCB(1 + FCBSP4)
C
 999  RETURN
      END

LOCAL INCLUDE 'QUFIX.INC'
      INCLUDE 'INCS:PUVD.INC'
C
      CHARACTER UVNAME*12, UVCLAS*6, IMNAM2*12, IMCLA2*6, IMNAM3*12,
     *   IMCLA3*6, CALIN*48, OUTEXT*48
      HOLLERITH XNAME1(3), XCLA1(2), XNAME2(3), XCLA2(2), XNAME3(3),
     *   XCLA3(2), XCALIN(12), XOUTXT(12)
      REAL      XS1, XDIS1, XS2, XDIS2, XS3, XDIS3, PCUT, XNBOX,
     *   XBOXS(4,50)
      INTEGER   DISK1, SEQ1, CNO1, DISK2, SEQ2, CNO2, DISK3, SEQ3, CNO3,
     *   NBOX, CLBOX(4,50), CATI1(256), CATI2(256), CATI3(256),
     *   BUFFER(512)
      DOUBLE PRECISION  FOFF(MAXIF), CATD1(128), CATD2(128), CATD3(128)
      REAL      FINC(MAXIF), CATR1(256), CATR2(256), CATR3(256)
      HOLLERITH CATH1(256), CATH2(256), CATH3(256)
      EQUIVALENCE (CATI1, CATR1, CATD1, CATH1)
      EQUIVALENCE (CATI2, CATR2, CATD2, CATH2)
      EQUIVALENCE (CATI3, CATR3, CATD3, CATH3)
C
      COMMON /INPARM/ XNAME1, XCLA1, XS1, XDIS1, XNAME2, XCLA2, XS2,
     *   XDIS2, XNAME3, XCLA3, XS3, XDIS3, PCUT, XNBOX, XBOXS, XCALIN,
     *   XOUTXT
      COMMON /CQUFIX/ UVNAME, UVCLAS, IMNAM2, IMCLA2, IMNAM3, IMCLA3,
     *   CALIN, OUTEXT
      COMMON /PQUFIX/ FOFF, FINC, BUFFER, DISK1, SEQ1, CNO1, DISK2,
     *   SEQ2, CNO2, DISK3, SEQ3, CNO3, NBOX, CLBOX
      COMMON /MAPHDR/ CATD1, CATD2, CATD3
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
LOCAL END
      PROGRAM QUFIX
C-----------------------------------------------------------------------
C! QUFIX determines RL phase corrections and applies them spectrally
C# Calibration UV VLA VLB polarization
C-----------------------------------------------------------------------
C;  Copyright (C) 2011-2012, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task QUFIX prints data from uv data files in a variety of forms.
C   Inputs:
C      AIPS Adverb   Prg. Name          Description
C      INNAME         UVNAME        UV File name to be corrected
C      INCLASS        UVCLAS        File class
C      INSEQ          SEQ1          File sequence number.
C      INDISK         DISK1         Disk volumn on which file resides.
C      IN2NAME        IMNAM2        Image file name good cal
C      IN2CLASS       IMCLA2        File class to be listed.
C      IN2SEQ         SEQ           File sequence number.
C      IN2DISK        DISK          Disk volumn on which file resides.
C      IN3NAME        IMNAM3        Image File name to be corrected
C      IN3CLASS       IMCLA3        File class
C      IN3SEQ         SEQ3          File sequence number.
C      IN3DISK        DISK3         Disk volumn on which file resides.
C      PCUT           PCUT          Min sqrt(q*q+u*u) to include
C      NBOXES         NBOX          Number boxes
C      CLBOX          CLBOX         Search windows
C      CALIN          CALIN         Text file instead of images
C      OUTTEXT        OUTEXT        Text file out rather than correction
C-----------------------------------------------------------------------
      INCLUDE 'QUFIX.INC'
      CHARACTER PRGM*6
      INTEGER   IRET, NVAL, NCH, NIF
      REAL      PDCOR(MAXCIF)
      DOUBLE PRECISION PDFREQ(MAXCIF)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'QUFIX '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL QUFIXI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       get correction list
      IF (CALIN.NE.' ') THEN
         CALL QUFIXC (NVAL, PDFREQ, PDCOR, IRET)
      ELSE
         CALL QUFIXD (NVAL, PDFREQ, PDCOR, IRET)
         END IF
      IF (IRET.NE.0) GO TO 990
C                                       output as text
      IF (OUTEXT.NE.' ') THEN
         CALL QUFIXO (NVAL, PDFREQ, PDCOR, IRET)
C                                       translate and correct
      ELSE
         CALL QUFIXT (NVAL, PDFREQ, PDCOR, NCH, NIF)
         CALL QUFIXA (NCH, NIF, PDCOR, IRET)
         IF (IRET.NE.0) GO TO 990
         CALL QUFIXH
         END IF
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE QUFIXI (PRGN, IRET)
C-----------------------------------------------------------------------
C   QUFIXI gets input parameters for QUFIX
C   Inputs:
C      PRGN    C*6       Program name (2 chars/word)
C   Output:
C      IRET    I         Error code: 0 => ok
C                           5 => catalog troubles
C                           8 => can't start
C   Commons:
C      /INPARM/ all input adverbs in order given by INPUTS file
C      /MAPHDR/ output file catalog header
C   See prologue comments in QUFIX for more details.
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   IRET
C
      INCLUDE 'QUFIX.INC'
      CHARACTER STAT*4, STATUS*4, TYPE*2, BNDCOD(MAXIF)*8
      INTEGER   IROUND, NPARM, IERR, I, LUN, NIF, IIVER, J, FRQSEL,
     *   ISBAND(MAXIF)
      REAL      EPS
      LOGICAL   FAIL
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
      FAIL = .FALSE.
C                                       Get input parameters.
      NPARM = 247
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAME1, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFFER, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAME1, UVNAME)
      CALL H2CHR (6, 1, XCLA1, UVCLAS)
      CALL H2CHR (12, 1, XNAME2, IMNAM2)
      CALL H2CHR (6, 1, XCLA2, IMCLA2)
      CALL H2CHR (12, 1, XNAME3, IMNAM3)
      CALL H2CHR (6, 1, XCLA3, IMCLA3)
      CALL H2CHR (48, 1, XCALIN, CALIN)
      CALL H2CHR (48, 1, XOUTXT, OUTEXT)
C                                       Crunch input parameters.
      SEQ1 = IROUND (XS1)
      SEQ2 = IROUND (XS2)
      SEQ3 = IROUND (XS3)
      DISK1 = IROUND (XDIS1)
      DISK2 = IROUND (XDIS2)
      DISK3 = IROUND (XDIS3)
      CALL FILL (200, 0, CLBOX)
      IF (CALIN.NE.' ') THEN
         NBOX = 0
      ELSE
         NBOX = IROUND (XNBOX)
         DO 20 J = 1,NBOX
            DO 10 I = 1,4
               CLBOX(I,J) = IROUND (XBOXS(I,J))
 10            CONTINUE
 20         CONTINUE
         END IF
C                                       Get UV if correcting
      IF (OUTEXT.EQ.' ') THEN
         CNO1 = 1
         TYPE = 'UV'
         CALL CATDIR ('SRCH', DISK1, CNO1, UVNAME, UVCLAS, SEQ1, TYPE,
     *      NLUSER, STAT, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, UVNAME, UVCLAS, SEQ1, DISK1,
     *         NLUSER
            GO TO 990
            END IF
         STATUS = 'WRIT'
         CALL CATIO ('READ', DISK1, CNO1, CATI1, STATUS, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR, 'READ HEADER OF UV DATA'
            GO TO 990
            END IF
C                                       Mark in CFILES
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISK1
         FCNO(NCFILE) = CNO1
         FRW(NCFILE) = 1
C                                       Get uv header info.
         CALL UVPGET (IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Get IF freq offset.
         LUN = 28
         IIVER = 1
         FRQSEL = 1
         CALL CHNDAT ('READ', BUFFER, DISK1, CNO1, IIVER, CATI1, LUN,
     *      NIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IERR)
         IF (IERR.GT.0) GO TO 999
         END IF
C                                       Get MA if computing
      IF (CALIN.EQ.' ') THEN
         CNO2 = 1
         TYPE = 'MA'
         CALL CATDIR ('SRCH', DISK2, CNO2, IMNAM2, IMCLA2, SEQ2, TYPE,
     *      NLUSER, STAT, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, IMNAM2, IMCLA2, SEQ2, DISK2,
     *         NLUSER
            GO TO 990
            END IF
         STATUS = 'READ'
         CALL CATIO ('READ', DISK2, CNO2, CATI2, STATUS, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR, 'READ HEADER OF MA DATA 1'
            GO TO 990
            END IF
C                                       Mark in CFILES
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISK2
         FCNO(NCFILE) = CNO2
         FRW(NCFILE) = 0
C                                       uncal image
         CNO3 = 1
         TYPE = 'MA'
         CALL CATDIR ('SRCH', DISK3, CNO3, IMNAM3, IMCLA3, SEQ3, TYPE,
     *      NLUSER, STAT, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, IMNAM3, IMCLA3, SEQ3, DISK3,
     *         NLUSER
            GO TO 990
            END IF
         STATUS = 'READ'
         CALL CATIO ('READ', DISK3, CNO3, CATI3, STATUS, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR, 'READ HEADER OF MA DATA 3'
            GO TO 990
            END IF
C                                       Mark in CFILES
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISK3
         FCNO(NCFILE) = CNO3
         FRW(NCFILE) = 0
C                                       test matching
         IF (CATI2(KIDIM).NE.CATI3(KIDIM)) THEN
            MSGTXT = 'IMAGES DO NOT MATCH IN DIMENSIONS'
            GO TO 990
            END IF
         DO 40 I = 1,CATI2(KIDIM)
            J = I - 1
            IF (CATI2(KINAX+J).NE.CATI3(KINAX+J)) THEN
               WRITE (MSGTXT,1030) I, 'NUMBER PIXELS'
               CALL MSGWRT (7)
               FAIL = .TRUE.
               END IF
            EPS = 0.01 * ABS (CATR2(KRCIC+J))
            IF (ABS(CATD2(KDCRV+J)-CATD3(KDCRV+J)).GT.EPS) THEN
               WRITE (MSGTXT,1030) I, 'REF VALUE'
               CALL MSGWRT (7)
               FAIL = .TRUE.
               END IF
            IF (ABS(CATR2(KRCIC+J)-CATR3(KRCIC+J)).GT.EPS) THEN
               WRITE (MSGTXT,1030) I, 'INCREMENT'
               CALL MSGWRT (7)
               FAIL = .TRUE.
               END IF
            IF (ABS(CATR2(KRCRT+J)-CATR3(KRCRT+J)).GT.0.01) THEN
               WRITE (MSGTXT,1030) I, 'ROTATION'
               CALL MSGWRT (7)
               FAIL = .TRUE.
               END IF
            IF (ABS(CATR2(KRCRP+J)-CATR3(KRCRP+J)).GT.0.01) THEN
               WRITE (MSGTXT,1030) I, 'REF PIXEL'
               CALL MSGWRT (7)
               FAIL = .TRUE.
               END IF
 40         CONTINUE
         END IF
      IF (.NOT.FAIL) IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('QUFIXI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1020 FORMAT ('QUFIXI ERROR',I3,1X,A)
 1030 FORMAT ('IMAGE MISMATCH AXIS',I2,' IN ',A)
      END
      SUBROUTINE QUFIXC (NVAL, PDFREQ, PDCOR, IRET)
C-----------------------------------------------------------------------
C   QUFIXC reads a CALIN file
C   Outputs:
C      NVAL     I      Number values in PDFREQ and PDCOR
C      PDFREQ   D(*)   Frequencies in GHz
C      PDCOR    R(*)   Correction in degrees
C      IRET     I      Error code: > 0 => QUIT
C-----------------------------------------------------------------------
      INTEGER   NVAL, IRET
      DOUBLE PRECISION PDFREQ(*)
      REAL      PDCOR(*)
C
      INCLUDE 'QUFIX.INC'
      INTEGER   LUN, FIND, NLINES, JTRIM, JLIM, I, KBP
      CHARACTER LINE*132
      DOUBLE PRECISION X
C-----------------------------------------------------------------------
      LUN = 3
      CALL ZTXOPN ('READ', LUN, FIND, CALIN, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING CALIN TEXT FILE'
         GO TO 990
         END IF
      NVAL = 0
      NLINES = 0
C                                       read loop
 20   CALL ZTXIO ('READ', LUN, FIND, LINE, IRET)
      IF ((IRET.NE.0) .AND. (IRET.NE.2)) THEN
         WRITE (MSGTXT,1000) IRET, 'READING CALIN TEXT FILE'
         GO TO 990
C                                       got a line
      ELSE IF (IRET.EQ.0) THEN
         NLINES = NLINES + 1
         JLIM = JTRIM (LINE)
         IF (JLIM.LE.1) GO TO 20
         IF ((LINE(:1).EQ.';') .OR. (LINE(:1).EQ.'#')) GO TO 20
         KBP = 1
         CALL GETNUM (LINE, JLIM, KBP, X)
         IF (X.EQ.DBLANK) GO TO 20
         PDFREQ(NVAL+1) = X
         CALL GETNUM (LINE, JLIM, KBP, X)
         IF (X.EQ.DBLANK) GO TO 20
         PDCOR(NVAL+1) = X
         NVAL = NVAL + 1
         GO TO 20
         END IF
C                                       close
      CALL ZTXCLS (LUN, FIND, I)
      WRITE (MSGTXT,1020) NVAL, NLINES
      CALL MSGWRT (2)
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('QUFIXC ERROR',I3,' ON ',A)
 1020 FORMAT ('QUFIXC: read',I6,' values in',I6,' lines of CALIN')
      END
      SUBROUTINE QUFIXD (NVAL, PDFREQ, PDCOR, IRET)
C-----------------------------------------------------------------------
C   QUFIXD reads two image files to determine the correction
C   Outputs:
C      NVAL     I      Number values in PDFREQ and PDCOR
C      PDFREQ   D(*)   Frequencies in GHz
C      PDCOR    R(*)   Correction in degrees
C      IRET     I      Error code: > 0 => QUIT
C-----------------------------------------------------------------------
      INTEGER   NVAL, IRET
      DOUBLE PRECISION PDFREQ(*)
      REAL      PDCOR(*)
C
      INCLUDE 'QUFIX.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   I, FAX, SAX, QP, UP, IROUND, IBLC(7), ITRC(7), LUN(4),
     *   NANG, IND(4), DEPTH(5), QDEPTH(5,4), I3, I4, I5, I6, I7, NX,
     *   NY, IX, IY, ISX, ISY, J, NF, NF1, NF2, WIN(4), NBY, BLKOF,
     *   BIND(4)
      REAL      TEMP, QU(4), BUFF(MABFSS,4), A1, A2, ANGS, ANGC, ANGSS,
     *   ANGCS
      LOGICAL   ISQU
      CHARACTER PHNAME*48
      DOUBLE PRECISION FREQ, REFP, INCF, FREF
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUN /47,48,49,50/
      EQUIVALENCE (DEPTH(1), I3), (DEPTH(2), I4), (DEPTH(3), I5),
     *   (DEPTH(4), I6), (DEPTH(5), I7)
C-----------------------------------------------------------------------
C                                       find freq axis
      CALL AXEFND (4, 'FREQ', CATI2(KIDIM), CATH2(KHCTP), FAX, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'FREQUENCY AXIS NOT FOUND'
         GO TO 990
         END IF
      IF (FAX.LT.2) THEN
         MSGTXT = 'FREQUENCY AXIS IS X OR Y, MUST BE AXIS 3 OR MORE'
         IRET = 10
         GO TO 990
         END IF
C                                       stokes axis
      ISQU = .FALSE.
      CALL AXEFND (6, 'STOKES', CATI2(KIDIM), CATH2(KHCTP), SAX, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'STOKES AXIS NOT FOUND'
         IRET = 10
         GO TO 990
         END IF
      TEMP = (2.0D0 - CATD2(KDCRV+SAX)) / CATR2(KRCIC+SAX) +
     *   CATR2(KRCRP+SAX)
      QP = IROUND (TEMP)
      IF (ABS(QP-TEMP).LT.0.01) THEN
         TEMP = (3.0D0 - CATD2(KDCRV+SAX)) / CATR2(KRCIC+SAX) +
     *      CATR2(KRCRP+SAX)
         UP = IROUND (TEMP)
         IF (ABS(UP-TEMP).LT.0.01) THEN
            IF ((QP.GE.1) .AND. (QP.LE.CATI2(KINAX+SAX)) .AND.
     *         (UP.GE.1) .AND. (UP.LE.CATI2(KINAX+SAX))) ISQU=.TRUE.
            END IF
         END IF
      IF (.NOT.ISQU) THEN
         MSGTXT = 'Q AND U PLANES NOT FOUND IN IMAGES'
         IRET = 10
         GO TO 990
         END IF
C                                       open them
      CALL ZPHFIL ('MA', DISK2, CNO2, 1, PHNAME, IRET)
      CALL ZOPEN (LUN(1), IND(1), DISK2, PHNAME, .TRUE., .FALSE.,
     *   .TRUE., IRET)
      IF (IRET.NE.0) GO TO 999
      CALL ZOPEN (LUN(2), IND(2), DISK2, PHNAME, .TRUE., .FALSE.,
     *   .TRUE., IRET)
      IF (IRET.NE.0) GO TO 999
      CALL ZPHFIL ('MA', DISK3, CNO3, 1, PHNAME, IRET)
      CALL ZOPEN (LUN(3), IND(3), DISK3, PHNAME, .TRUE., .FALSE.,
     *   .TRUE., IRET)
      IF (IRET.NE.0) GO TO 999
      CALL ZOPEN (LUN(4), IND(4), DISK3, PHNAME, .TRUE., .FALSE.,
     *   .TRUE., IRET)
      IF (IRET.NE.0) GO TO 999
      NBY = 2 * MABFSS
      ISX = CATI2(KINAX)
      ISY = CATI2(KINAX+1)
      FREF = CATD2(KDCRV+FAX) / 1.D9
      REFP = CATR2(KRCRP+FAX)
      INCF = CATR2(KRCIC+FAX) / 1.D9
      NF1 = 1
      NF2 = CATI2(KINAX+FAX)
      CALL FILL (5, 1, IBLC(3))
      CALL COPY (5, CATI2(KINAX+2), ITRC(3))
      DO 10 I = 3,7
         ITRC(I) = MAX (1, ITRC(I))
 10      CONTINUE
C                                       loop over freq
      PCUT = PCUT * PCUT
      DO 190 NF = NF1,NF2
         ITRC(FAX+1) = NF
         IBLC(FAX+1) = NF
         ANGS = 0.0
         ANGC = 0.0
         ANGSS = 0.0
         ANGCS = 0.0
         NANG = 0
         IBLC(SAX+1) = QP
         ITRC(SAX+1) = QP
         DO 177 I7 = IBLC(7),ITRC(7)
            DO 176 I6 = IBLC(6),ITRC(6)
               DO 175 I5 = IBLC(5),ITRC(5)
                  DO 174 I4 = IBLC(4),ITRC(4)
                     DO 173 I3 = IBLC(3),ITRC(3)
                        CALL COPY (5, DEPTH, QDEPTH(1,1))
                        CALL COPY (5, DEPTH, QDEPTH(1,2))
                        CALL COPY (5, DEPTH, QDEPTH(1,3))
                        CALL COPY (5, DEPTH, QDEPTH(1,4))
                        QDEPTH(SAX-1,2) = UP
                        QDEPTH(SAX-1,4) = UP
                        DO 160 I = 1,NBOX
                           IF (CLBOX(1,I).LT.0) THEN
                              WIN(1) = CLBOX(3,I) - CLBOX(2,I) + 1
                              WIN(2) = CLBOX(4,I) - CLBOX(2,I) + 1
                              WIN(3) = CLBOX(3,I) + CLBOX(2,I) - 1
                              WIN(4) = CLBOX(4,I) + CLBOX(2,I) - 1
                           ELSE
                              CALL COPY (4, CLBOX(1,I), WIN)
                              END IF
C                                       init
                           DO 110 J = 1,4
                              CALL COMOFF (CATI2(KIDIM), CATI2(KINAX),
     *                           QDEPTH(1,J), BLKOF, IRET)
                              IF (IRET.NE.0) GO TO 999
                              BLKOF = BLKOF + 1
                              CALL MINIT ('READ', LUN(J), IND(J), ISX,
     *                           ISY, WIN, BUFF(1,J), NBY, BLKOF, IRET)
                              IF (IRET.NE.0) THEN
                                 WRITE (MSGTXT,1000) IRET,
     *                              'INIT READ OF IMAGE', J
                                 GO TO 990
                                 END IF
 110                          CONTINUE
C                                       read plane
                           NY = WIN(4) - WIN(2) + 1
                           NX = WIN(3) - WIN(1) + 1
                           DO 140 IY = 1,NY
                              DO 120 J = 1,4
                                 CALL MDISK ('READ', LUN(J), IND(J),
     *                              BUFF(1,J), BIND(J), IRET)
                                 IF (IRET.NE.0) THEN
                                    WRITE (MSGTXT,1000) IRET,
     *                                 'READ IMAGE ROW', J
                                    GO TO 990
                                    END IF
 120                             CONTINUE
                              DO 130 IX = 1,NX
                                 IF (CLBOX(1,I).LT.0) THEN
                                    TEMP = (IX-CLBOX(3,I))**2
                                    TEMP = (IY-CLBOX(4,I))**2 + TEMP
                                    TEMP = SQRT (TEMP)
                                    IF (TEMP.GT.CLBOX(2,I)) GO TO 130
                                    END IF
                                 DO 125 J = 1,4
                                    QU(J) = BUFF(BIND(J)+IX-1,J)
                                    IF (QU(J).EQ.FBLANK) GO TO 130
 125                                CONTINUE
                                 IF (QU(1)*QU(1)+QU(2)*QU(2).LT.PCUT)
     *                              GO TO 130
                                 IF (QU(3)*QU(3)+QU(4)*QU(4).LT.PCUT)
     *                              GO TO 130
                                 A1 = ATAN2 (QU(2), QU(1))
                                 A2 = ATAN2 (QU(4), QU(3))
                                 ANGS = ANGS + SIN (A1 - A2)
                                 ANGC = ANGC + COS (A1 - A2)
                                 ANGSS = ANGSS + (SIN (A1 - A2))**2
                                 ANGCS = ANGCS + (COS (A1 - A2))**2
                                 NANG = NANG + 1
 130                             CONTINUE
 140                          CONTINUE
 160                       CONTINUE
 173                    CONTINUE
 174                 CONTINUE
 175              CONTINUE
 176           CONTINUE
 177        CONTINUE
         FREQ = FREF + (NF - REFP) * INCF
         IF (NANG.GT.0) THEN
            ANGS = ANGS / NANG
            ANGC = ANGC / NANG
            ANGSS = MAX (0.0, ANGSS / NANG - ANGS * ANGS)
            ANGCS = MAX (0.0, ANGCS / NANG - ANGC * ANGC)
            A1 = RAD2DG * ATAN2 (ANGS, ANGC)
            A2 = RAD2DG * SQRT (ANGS*ANGS*ANGCS + ANGC*ANGC*ANGSS) /
     *         (ANGS * ANGS + ANGC * ANGC)
            WRITE (MSGTXT,1177) NF, FREQ, A1, A2
            CALL MSGWRT (3)
            NVAL = NVAL + 1
            PDFREQ(NVAL) = FREQ
            PDCOR(NVAL) = A1
         ELSE
            A1 = 0.0
            WRITE (MSGTXT,1178) NF, FREQ
            CALL MSGWRT (6)
            END IF
 190     CONTINUE
      DO 195 J = 1,4
         CALL ZCLOSE (LUN(J), IND(J), I)
 195     CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('QUFIXD ERROR',I3,' ON ',A,I2)
 1177 FORMAT ('Freq #',I5,F10.5,' GHz  corr',F8.3,' +-',F8.3,' degrees')
 1178 FORMAT ('Freq #',I5,F10.5,' GHz  NO DATA FOUND')
      END
      SUBROUTINE QUFIXO (NVAL, PDFREQ, PDCOR, IRET)
C-----------------------------------------------------------------------
C   QUFIXO writes an OUTTEXT correction file
C   Inputs:
C      NVAL     I      Number values in PDFREQ and PDCOR
C      PDFREQ   D(*)   Frequencies in GHz
C      PDCOR    R(*)   Correction in degrees
C   Outputs:
C      IRET     I      Error code: > 0 => QUIT
C-----------------------------------------------------------------------
      INTEGER   NVAL, IRET
      DOUBLE PRECISION PDFREQ(*)
      REAL      PDCOR(*)
C
      INCLUDE 'QUFIX.INC'
      INTEGER   LUN, FIND, JTRIM, L, I, TIME(3), DATE(3)
      CHARACTER LINE*132, CTIME*8, CDATE*12
C-----------------------------------------------------------------------
      LUN = 3
      CALL ZTXOPN ('WRIT', LUN, FIND, OUTEXT, .TRUE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTTEXT TEXT FILE'
         GO TO 990
         END IF
C                                       label
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME, CDATE)
      WRITE (LINE,1005) CDATE, CTIME
      L = JTRIM (LINE)
      CALL ZTXIO ('WRIT', LUN, FIND, LINE(:L), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITING OUTTEXT FILE'
         GO TO 990
         END IF

C                                       write loop
      DO 20 I = 1,NVAL
         WRITE (LINE,1010) PDFREQ(I), PDCOR(I)
         L = JTRIM (LINE)
         CALL ZTXIO ('WRITE', LUN, FIND, LINE(:L), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTTEXT FILE'
            GO TO 990
            END IF
 20      CONTINUE
C                                       close
      CALL ZTXCLS (LUN, FIND, I)
      WRITE (MSGTXT,1020) NVAL
      CALL MSGWRT (2)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('QUFIXO ERROR',I3,' ON ',A)
 1005 FORMAT ('# QUFIX run ',A,A)
 1010 FORMAT (F13.9,F12.5)
 1020 FORMAT ('QUFIXO: wrote',I6,' values to OUTTEXT')
      END
      SUBROUTINE QUFIXT (NVAL, PDFREQ, PDCOR, NCH, NIF)
C-----------------------------------------------------------------------
C   QUFIXT translates the list of corrections to match the UV data
C   Inputs:
C      NVAL     I      Number values in PDFREQ and PDCOR
C      PDFREQ   D(*)   Frequencies in GHz
C   In/Out:
C      PDCOR    R(*)   Correction in degrees: NVAL in, (Nchan,Nif) out
C   Outputs:
C      NCH      I      Number spectral channels
C      NIF      I      Number IFs
C-----------------------------------------------------------------------
      INTEGER   NVAL, NCH, NIF
      DOUBLE PRECISION PDFREQ(*)
      REAL      PDCOR(*)
C
      INCLUDE 'QUFIX.INC'
      INTEGER   I, IIF, ICH, J, K
      DOUBLE PRECISION FF, F0, RP, CI, FI
      REAL      PDTEMP(MAXCIF), TEMP
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      IF (JLOCIF.GE.0) THEN
         NIF = CATI1(KINAX+JLOCIF)
      ELSE
         NIF = 1
         END IF
      CALL RCOPY (NVAL, PDCOR, PDTEMP)
      NCH = CATI1(KINAX+JLOCF)
      F0 = CATD1(KDCRV+JLOCF) / 1.0D9
      RP = CATR1(KRCRP+JLOCF)
      I = 0
      K = 1
      DO 50 IIF = 1,NIF
         CI = FINC(IIF) / 1.0D9
         FI = F0 + FOFF(IIF) / 1.D9
         DO 40 ICH = 1,NCH
            FF = FI + (ICH-RP) * CI
            I = I + 1
            IF (FF.LE.PDFREQ(1)) THEN
               PDCOR(I) = PDTEMP(1)
            ELSE IF (FF.GE.PDFREQ(NVAL)) THEN
               PDCOR(I) = PDTEMP(NVAL)
            ELSE
 20            DO 30 J = K,NVAL
                  IF ((FF.GE.PDFREQ(J)) .AND. (FF.LE.PDFREQ(J+1))) THEN
                     K = J
                     TEMP = PDFREQ(J+1) - PDFREQ(J)
                     IF (TEMP.NE.0.0) TEMP = (FF - PDFREQ(J)) / TEMP
                     PDCOR(I) = PDTEMP(J) + TEMP *
     *                  (PDTEMP(J+1) - PDTEMP(J))
                     GO TO 40
                     END IF
 30               CONTINUE
C                                       prevent infinite loop
C                                       should not be needed
               IF (K.EQ.1) THEN
                  PDCOR(I) = PDTEMP(1)
C                                       check full list
               ELSE
                  K = 1
                  GO TO 20
                  END IF
               END IF
 40         CONTINUE
 50      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE QUFIXA (NCH, NIF, PDCOR, IRET)
C-----------------------------------------------------------------------
C   QUFIXA applies the corrections to BP, CP, PD tables
C   Inputs:
C      PDCOR    R(*)   Correction in degrees: (Nchan,Nif)
C   Outputs:
C      IRET     I      Error code: > 0 => QUIT
C-----------------------------------------------------------------------
      INTEGER   NCH, NIF, IRET
      REAL      PDCOR(NCH,NIF)
C
      INCLUDE 'QUFIX.INC'
      INTEGER   NUMTA, LUN1, LUN2, TABUF1(512), TABUF2(512), IBPRNO,
     *   BPKOLS(MAXBPC), BPNUMV(MAXBPC), NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *   LCHAN, NUMSHF, NREC, IREC, SOURID, SUBA, ANT, FREQID, LI, LC,
     *   REFANT(2), CPNUMV(6), CPKOLS(6), ICPRNO, PDKOLS(9), PDNUMV(9),
     *   IPDRNO, I, JNX, VER, PDKOLO(9), PDNUMO(9), BPVER, SUBARR,
     *   FRQSEL
      DOUBLE PRECISION TIME, CHSHFT(MAXIF)
      REAL      CF, SF, LOWSHF, DELSHF, INTERV, BANDW, WEIGHT(2*MAXIF),
     *   BNDPAS(2,MAXCIF), XT, YT, VFLUX(4,MAXCIF), PHDIFF(MAXCIF)
      CHARACTER LBPTYP*8, SOURSE*16, POLTYP*8
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (BNDPAS, VFLUX)
      DATA LUN1, LUN2 /79, 78/
C-----------------------------------------------------------------------
      CALL FNDEXT ('BP', CATI1, BPVER)
      VER = BPVER + 1
      SUBARR = -1
      FRQSEL = -1
C                                       modify existing BP table
      IF (BPVER.GT.0) THEN
         MSGTXT = 'Updating existing BP table, writing new one'
         CALL MSGWRT (5)
         CALL BPINI ('READ', TABUF2, DISK1, CNO1, BPVER, CATI1, LUN2,
     *      IBPRNO, BPKOLS, BPNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *      LCHAN, NUMSHF, LOWSHF, DELSHF, LBPTYP, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OLD BP TABLE'
            GO TO 990
            END IF
         CALL BPINI ('WRIT', TABUF1, DISK1, CNO1, VER, CATI1, LUN1,
     *      IBPRNO, BPKOLS, BPNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *      LCHAN, NUMSHF, LOWSHF, DELSHF, LBPTYP, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OLD BP TABLE'
            GO TO 990
            END IF
         NREC = TABUF2(5)
         DO 50 IREC = 1,NREC
            IBPRNO = IREC
            CALL TABBP ('READ', TABUF2, IBPRNO, BPKOLS, BPNUMV, NUMIF,
     *         NUMFRQ, NUMPOL, TIME, INTERV, SOURID, SUBA, ANT, BANDW,
     *         CHSHFT, FREQID, REFANT, WEIGHT, BNDPAS, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ OLD BP TABLE'
               GO TO 990
               END IF
            IF (((SUBA.LE.0) .OR. (SUBARR.LE.0) .OR. (SUBA.EQ.SUBARR))
     *         .AND. ((FREQID.LE.0) .OR. (FRQSEL.LE.0) .OR.
     *         (FREQID.EQ.FRQSEL)) .AND. (IRET.GT.-2)) THEN
               DO 30 LI = 1,NIF
                  JNX = (LI - 1) * NUMFRQ + 1 + NUMFRQ*NUMIF
                  DO 20 LC = 1,NCH
                     XT = BNDPAS(1,JNX)
                     YT = BNDPAS(2,JNX)
                     IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK) .AND.
     *                  (PDCOR(LC,LI).NE.FBLANK)) THEN
                        CF = COS (PDCOR(LC,LI)*DG2RAD)
                        SF = SIN (PDCOR(LC,LI)*DG2RAD)
                        BNDPAS(1,JNX) = XT*CF - YT*SF
                        BNDPAS(2,JNX) = XT*SF + YT*CF
                        END IF
                     JNX = JNX + 1
 20                  CONTINUE
 30               CONTINUE
               END IF
            IBPRNO = IREC
            CALL TABBP ('WRIT', TABUF1, IBPRNO, BPKOLS, BPNUMV, NUMIF,
     *         NUMFRQ, NUMPOL, TIME, INTERV, SOURID, SUBA, ANT, BANDW,
     *         CHSHFT, FREQID, REFANT, WEIGHT, BNDPAS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITE NEW BP TABLE'
               GO TO 990
               END IF
 50         CONTINUE
         CALL TABIO ('CLOS', 0, IBPRNO, TABUF2, TABUF2, LI)
C                                       create one from scratch
      ELSE
         MSGTXT = 'Writing new BP table from scratch'
         CALL MSGWRT (5)
         CALL GETANT (DISK1, CNO1, SUBARR, CATI1, TABUF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ AN FILE WITH GETANT'
            GO TO 990
            END IF
         NUMANT = NSTNS
         NUMPOL = 2
         NUMIF = 1
         IF (JLOCIF.GE.0) NUMIF = CATI1(KINAX+JLOCIF)
         NUMFRQ = CATI1(KINAX+JLOCF)
         LCHAN = 1
         NUMSHF = 3
         LOWSHF = 0.0
         DELSHF = 0.0
         LBPTYP = ' '
         CALL BPINI ('WRIT', TABUF1, DISK1, CNO1, VER, CATI1, LUN1,
     *      IBPRNO, BPKOLS, BPNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *      LCHAN, NUMSHF, LOWSHF, DELSHF, LBPTYP, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OLD BP TABLE'
            GO TO 990
            END IF
         TIME = 0.0D0
         INTERV = 0.0
         SOURID = 0
         SUBA = SUBARR
         FREQID = FRQSEL
         REFANT(1) = 1
         REFANT(2) = 1
         LI = NUMIF * NUMPOL * NUMFRQ
         CALL RFILL (2*MAXIF, 1.0, WEIGHT)
         DO 110 I = 1,LI
            BNDPAS(1,I) = 1.0
            BNDPAS(2,I) = 0.0
 110        CONTINUE
         DO 130 LI = 1,NIF
            JNX = (LI - 1) * NUMFRQ + 1 + NUMFRQ*NUMIF
            DO 120 LC = 1,NCH
               IF (PDCOR(LC,LI).NE.FBLANK) THEN
                  BNDPAS(1,JNX) = COS (PDCOR(LC,LI)*DG2RAD)
                  BNDPAS(2,JNX) = SIN (PDCOR(LC,LI)*DG2RAD)
               ELSE
                  BNDPAS(1,JNX) = FBLANK
                  BNDPAS(2,JNX) = FBLANK
                  END IF
               JNX = JNX + 1
 120           CONTINUE
 130        CONTINUE
         DO 150 ANT = 1,NSTNS
            IBPRNO = ANT
            CALL TABBP ('WRIT', TABUF1, IBPRNO, BPKOLS, BPNUMV, NUMIF,
     *         NUMFRQ, NUMPOL, TIME, INTERV, SOURID, SUBA, ANT, BANDW,
     *         CHSHFT, FREQID, REFANT, WEIGHT, BNDPAS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITE NEW BP TABLE'
               GO TO 990
               END IF
 150        CONTINUE
         END IF
      CALL TABIO ('CLOS', 0, IBPRNO, TABUF1, TABUF1, LI)
C                                       CP file if any
      CALL FNDEXT ('CP', CATI1, NUMTA)
      VER = NUMTA + 1
 200  VER = VER - 1
      IF (VER.GT.0) THEN
         CALL CPINI ('READ', TABUF2, DISK1, CNO1, VER, CATI1, LUN2,
     *      ICPRNO, CPKOLS, CPNUMV, NUMIF, NUMFRQ, FREQID, IRET)
         IF (((FREQID.GT.0) .AND.(FRQSEL.GT.0) .AND. (FRQSEL.NE.FREQID))
     *      .OR. (IRET.NE.0)) THEN
            CALL TABIO ('CLOS', 0, ICPRNO, TABUF2, TABUF2, LI)
            GO TO 200
            END IF
         MSGTXT = 'Updating existing CP table, writing new one'
         CALL MSGWRT (5)
         VER = NUMTA + 1
         CALL CPINI ('WRIT', TABUF1, DISK1, CNO1, VER, CATI1, LUN1,
     *      ICPRNO, CPKOLS, CPNUMV, NUMIF, NUMFRQ, FREQID, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN NEW CP TABLE'
            GO TO 990
            END IF
         NREC = TABUF2(5)
         DO 250 IREC = 1,NREC
            ICPRNO = IREC
            CALL TABCP ('READ', TABUF2, ICPRNO, CPKOLS, CPNUMV, NUMIF,
     *         NUMFRQ, SOURSE, SOURID, VFLUX, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ OLD CP TABLE'
               GO TO 990
               END IF
            DO 230 LI = 1,NIF
               JNX = (LI - 1) * NUMFRQ + 1
               DO 220 LC = 1,NCH
                  IF (PDCOR(LC,LI).NE.FBLANK) THEN
                     CF = COS (PDCOR(LC,LI)*DG2RAD)
                     SF = SIN (PDCOR(LC,LI)*DG2RAD)
                     XT = VFLUX(2,JNX)
                     YT = VFLUX(3,JNX)
                     VFLUX(2,JNX) = XT*CF - YT*SF
                     VFLUX(3,JNX) = XT*SF + YT*CF
                     END IF
                  JNX = JNX + 1
 220              CONTINUE
 230           CONTINUE
            ICPRNO = IREC
            CALL TABCP ('WRIT', TABUF1, ICPRNO, CPKOLS, CPNUMV, NUMIF,
     *         NUMFRQ, SOURSE, SOURID, VFLUX, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITE NEW CP TABLE'
               GO TO 990
               END IF
 250        CONTINUE
         CALL TABIO ('CLOS', 0, ICPRNO, TABUF2, TABUF2, LI)
         CALL TABIO ('CLOS', 0, ICPRNO, TABUF1, TABUF1, LI)
         END IF
C                                       PD update
      CALL FNDEXT ('PD', CATI1, NUMTA)
      IF (NUMTA.LE.0) THEN
         MSGTXT = 'NO PD TABLE - HOW CAN THIS BE?'
         GO TO 990
         END IF
      MSGTXT = 'Updating existing PD table, writing new one'
      CALL MSGWRT (5)
      VER = NUMTA
      CALL PDINI ('READ', TABUF2, DISK1, CNO1, VER, CATI1, LUN2,
     *   IPDRNO, PDKOLS, PDNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *   POLTYP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OLD PD TABLE FOR READ'
         GO TO 990
         END IF
      VER = NUMTA + 1
      CALL PDINI ('WRIT', TABUF1, DISK1, CNO1, VER, CATI1, LUN1,
     *   IPDRNO, PDKOLO, PDNUMO, NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *   POLTYP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'RE-OPEN OLD PD TABLE FOR WRITE'
         GO TO 990
         END IF
      NREC = TABUF2(5)
      DO 360 IREC = 1,NREC
         IPDRNO = IREC
         CALL TABPD ('READ', TABUF2, IPDRNO, PDKOLS, PDNUMV, NUMIF,
     *      NUMFRQ, NUMPOL, ANT, SUBA, FREQID, REFANT, PHDIFF, BNDPAS,
     *      IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ PD TABLE'
            GO TO 990
            END IF
         IF (((SUBA.LE.0) .OR. (SUBARR.LE.0) .OR. (SUBA.EQ.SUBARR))
     *      .AND. (IRET.GT.-3)) THEN
C                                       Just add to phase difference
            IF (POLTYP.EQ.'ORI-ELP') THEN
               DO 320 LI = 1,NIF
                  JNX = (LI - 1) * NUMFRQ + 1
                  DO 310 LC = 1,NCH
                     IF (PDCOR(LC,LI).NE.FBLANK) PHDIFF(JNX) =
     *                  PHDIFF(JNX) + PDCOR(LC,LI) * DG2RAD
                     JNX = JNX + 1
 310                 CONTINUE
 320              CONTINUE
C                                       correct D terms
            ELSE
               DO 350 LI = 1,NIF
                  JNX = (LI - 1) * NUMFRQ + 1
                  DO 330 LC = 1,NCH
                     XT = BNDPAS(1,JNX)
                     YT = BNDPAS(2,JNX)
                     IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK) .AND.
     *                  (PDCOR(LC,LI).NE.FBLANK)) THEN
                        CF = COS (PDCOR(LC,LI)*DG2RAD)
                        SF = SIN (PDCOR(LC,LI)*DG2RAD)
                        BNDPAS(1,JNX) = XT*CF - YT*SF
                        BNDPAS(2,JNX) = XT*SF + YT*CF
                        END IF
                     JNX = JNX + 1
 330                 CONTINUE
C                                       2nd polarization opposite
                  JNX = (LI - 1) * NUMFRQ + 1 +
     *               NUMFRQ * NUMIF
                  DO 340 LC = 1,NCH
                     XT = BNDPAS(1,JNX)
                     YT = BNDPAS(2,JNX)
                     IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK) .AND.
     *                  (PDCOR(LC,LI).NE.FBLANK)) THEN
                        CF = COS (PDCOR(LC,LI)*DG2RAD)
                        SF = SIN (PDCOR(LC,LI)*DG2RAD)
                        BNDPAS(1,JNX) = XT*CF + YT*SF
                        BNDPAS(2,JNX) = YT*CF - XT*SF
                        END IF
                     JNX = JNX + 1
 340                 CONTINUE
 350              CONTINUE
               END IF
            END IF
         IPDRNO = IREC
         CALL TABPD ('WRIT', TABUF1, IPDRNO, PDKOLO, PDNUMO, NUMIF,
     *      NUMFRQ, NUMPOL, ANT, SUBA, FREQID, REFANT, PHDIFF, BNDPAS,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'RE-WRITE PD TABLE'
            GO TO 990
            END IF
 360     CONTINUE
      CALL TABIO ('CLOS', 0, IPDRNO, TABUF1, TABUF1, LI)
      CALL TABIO ('CLOS', 0, IPDRNO, TABUF2, TABUF2, LI)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPAPPL: ERROR',I4,' ON ',A)
      END
      SUBROUTINE QUFIXH
C-----------------------------------------------------------------------
C   writes HI records when solution is appled to data
C-----------------------------------------------------------------------
      INCLUDE 'QUFIX.INC'
      INTEGER   LUN, LUNTMP, TIME(3), DATE(3), IERR, BUFF2(256), I, J,
     *   JTRIM
      CHARACTER CTIME(2)*12, HILINE*72
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      LUN = LUNTMP (1)
C                                       Write History.
      CALL HIINIT (3)
C                                       Open old history
      CALL HIOPEN (LUN, DISK1, CNO1, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,1000) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       read text file
      IF (CALIN.NE.' ') THEN
         J = JTRIM (CALIN)
         WRITE (HILINE,1010) TSKNAM, CALIN(:J)
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         WRITE (HILINE,1011) TSKNAM
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       found from images
      ELSE
         CALL HENCO2 (TSKNAM, IMNAM2, IMCLA2, SEQ2, DISK2, LUN, BUFF2,
     *      IERR)
         IF (IERR.NE.0) GO TO 200
         CALL HENCO3 (TSKNAM, IMNAM3, IMCLA3, SEQ3, DISK3, LUN, BUFF2,
     *      IERR)
         IF (IERR.NE.0) GO TO 200
         PCUT = SQRT (PCUT)
         WRITE (HILINE,1020) TSKNAM, PCUT
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         DO 20 J = 1,NBOX
            WRITE (HILINE,1025) TSKNAM, J, (CLBOX(I,J), I = 1,4)
            CALL HIADD (LUN, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
 20         CONTINUE
         END IF
C                                       Close HI file
 200  CALL HICLOS (LUN, .TRUE., BUFF2, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 1010 FORMAT (A6,'CALIN =''',A,'''')
 1011 FORMAT (A6,25X,'/ Text file with corrections')
 1020 FORMAT (A6,'PCUT ',F8.4,'   / only SQRT(q*q+u*u) > PCUT used')
 1025 FORMAT (A6,'CLBOX(*,',I2.2,') =',3(I6,','),I6,'   / window(s)')
      END

      SUBROUTINE ALSINI (ALIST, SIZE, NDIM, NAME, IERR)
C-----------------------------------------------------------------------
C! Initialize Associative list (ALIST)
C# Utility 
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Public function
C   Initialize ALIST.
C   An associative list (ALIST) lis a list of labeled values.  The
C   values may be of double precision, real, cahracter, integer or
C   logical data types.  A value can be a multi-dimensional array
C   (although for characters the first dimension is the length of the
C   string).  There is a minimum dimensionality of 1 and a maximum of
C   100. 
C      Arbitrary entries can be saved or stored subject to the
C   limitation of the size of the ALIST. All ALISTs are independent and
C   several may be used at the same time.  Numerous checks are made for
C   internal consistency. 
C      Direct references to the contents of an active ALIST are not
C   needed and SHOULD NOT BE MADE.  The public interface should be
C   used for all access.
C      Note the AIPS datatypes are defined as parameters in the INCLUDE
C   'INCS:PAOOF.INC': OOADP = double precision, OOARE = real, 
C   OOACAR = character, OOAINT = integer, and OOALOG = logical.
C
C   An ALIST has the following structure:
C   ALIST(ALSIZE) = number of words
C   ALIST(ALSNAM) = Hollerith name (32 char)
C   ALIST(ALSBEG) = First word of linked list.
C   ALIST(ALSEND) = Next free word in ALIST.
C   ALIST(ALSCHK) = Validity check word
C   ALIST(ALSNDM) = number of dimensions
C   ALIST(ALSHED) = number of words of list header
C   ALIST(ALSDIM) = offset of start of data.      
C   ALIST(ALIST(ALSBEG)-end) = Linked list with entries in the following
C      form: 
C          Word  Type        Contents
C        ------  ----  --------------------------------------------
C        ALSNXT    I    Address of next cell, .LE. 0 => last entry.
C        ALSKWD    H*16 Keyword as HOLLERITH
C        ALSTYP    I    Type: 1=D, 2=R, 3=C, 4=I, 5=L
C        ALSDIM    I    First dimension (length of string for char),
C                       higher dimensions follow
C        ALSDAT    ?    Data, characters as Hollerith
C           ...         As many words as necessary for the data.
C
C   Module parameters:
C     ALSIZE   PI      ALIST index of size
C     ALSNAM   PI      ALIST index of name
C     ALSBEG   PI      ALIST index of first
C     ALSEND   PI      ALIST index of next free word
C     ALSCHK   PI      ALIST index of validity check
C     ALSCVL   PI      ALIST validity check value
C     ALSNDM   PI      ALIST index of dimensionality  
C     ALSHED   PI      ALIST index of length of header
C     ALSDAT   PI      ALIST index of offset to start of data.
C     ALSNXT   PI      ALIST offset for next cell pointer.
C     ALSKWD   PI      ALIST offset for keyword
C     ALSTYP   PI      ALIST offset for data type
C     ALSDIM   PI      ALIST offset for 1st dimension
C
C   Public functions:
C      ALSINI (alist, size, ndim, name, ierr)
C         Initialize an alist
C      ALSGET (alist, keywrd, type, dim, value, valuec, ierr)
C         Fetch the value (array) for a specified keyword.
C         Recognizes special keyword 'LISTNAME' as the name of the ALIST
C         Recognizes special keyword 'GET SIZE' as the size of the ALIST
C      ALSPUT (alist, keywrd, type, dim, value, valuec, ierr)
C         Store the value (array) for a specified keyword.
C         Recognizes special keyword 'LISTNAME' as the name of the ALIST
C      ALSASK (alist, keywrd, type, dim, ierr)
C         Inquire about an entry.
C      ALSADD (alist, keywrd, type, dim, ierr)
C         Add an entry but store no data.
C      ALSDEL (alist, keywrd, ierr)
C         Remove a keyword entry from an ALIST and compress ALIST.
C      ALSDMP (alist)
C         Dump the contents of an ALIST to MSGWRT; intended for
C         debugging purposes.
C
C   Private functions:
C      ALSKEY (alist, keywrd, keypnt, ierr)
C         Lookup keyword in ALIST called by OBGET and OBPUT.
C      ALSC2H (string, ndim, dim, holl)
C         Convert a string (possibly an array) to hollerith
C      ALSH2C (holl, ndim, dim, string)
C         Convert a hollerith (possibly an array) to a string.
C
C   Inputs:
C      ALIST  I(*)  ALIST array
C      SIZE   I     Number of words in ALIST
C      NDIM   I     Max. dimensionality of any entry (min 1., max 100)
C      NAME   C*32  Name of ALIST
C   Outputs:
C      IERR   I  Return error code 0=>OK else failed
C-----------------------------------------------------------------------
      INTEGER   ALIST(*), SIZE, NDIM, IERR
      CHARACTER NAME*32
C
      INCLUDE 'INCS:PALIST.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Save size
      ALIST(ALSIZE) = SIZE
      ALIST(ALSNDM) = MAX (1, MIN (100,NDIM))
C                                       Save name
      CALL CHR2H (32, NAME, 1, ALIST(ALSNAM))
C                                       Initialize pointers
      ALIST(ALSBEG) = ALSDAT + 10
      ALIST(ALSEND) = ALIST(ALSBEG)
C                                       Length of header
      ALIST(ALSHED) = ALSDIM + ALIST(ALSNDM)
C                                       Offset to beginning of data
      ALIST(ALSDAT) = ALIST(ALSHED)
C                                       Initialize empty list
      ALIST(ALIST(ALSEND)) = -1
C                                       Save validity check
      ALIST(ALSCHK) = ALSCVL
C
 999  RETURN
      END

      SUBROUTINE INTERP (X, XVAL, YVAL, N, VALUE)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   One-dimensional linear interpolation routine
C   Inputs:
C      X       R    Abscissa value
C      N       I    Dimension of XVAL and YVAL
C   In/Out:
C      XVAL    R(*) Tabulated X values - sorted on output
C      YVAL    R(*) Tabulated Y values
C   Outputs:
C      VALUE   R    Interpolated value
C----------------------------------------------------------------------
      INTEGER   N
      REAL      X, XVAL(N), YVAL(N), VALUE
C
      REAL      RTEMP, SLOPE
      INTEGER   I, J
C----------------------------------------------------------------------
C                                       Sort array
      DO 100 I = 1,N-1
         DO 50 J = I+1,N
            IF (XVAL(J).LT.XVAL(I)) THEN
               RTEMP = XVAL(J)
               XVAL(J) = XVAL(I)
               XVAL(I) = RTEMP
               RTEMP = YVAL(J)
               YVAL(J) = YVAL(I)
               YVAL(I) = RTEMP
               END IF
50          CONTINUE
100      CONTINUE
C                                       Special cases
      IF (X.LE.XVAL(1)) THEN
         VALUE = YVAL(1)
      ELSE IF (X.GE.XVAL(N)) THEN
         VALUE = YVAL(N)
C                                       Find values on either side of
C                                       the desired x-ordinate and
C                                       interpolate.
      ELSE
         VALUE = 0.0
         DO 200 I = 1, N-1
            IF ((XVAL(I).LE.X) .AND. (XVAL(I+1).GE.X)) THEN
               IF (XVAL(I).EQ.XVAL(I+1)) THEN
                  VALUE = (YVAL(I+1) + YVAL(I)) / 2.0
               ELSE
                  SLOPE = (YVAL(I+1) - YVAL(I)) / (XVAL(I+1) - XVAL(I))
                  VALUE = (X - XVAL(I)) * SLOPE + YVAL(I)
                  END IF
               END IF
200         CONTINUE
         END IF
C                                       Exit
999   RETURN
      END

      SUBROUTINE ZTACTQ (NAME, PID, ACTIVE, IERR)
C-----------------------------------------------------------------------
C! inquires if a task is currently active on the local computer
C# Z System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZTACTQ determines if a specified task is active.
C   Inputs:
C      NAME     C*6    Actual task name.
C   In/out:
C      PID      I(4)   Process "ID" code
C                      In:  PID(1) user number  0 => any
C                           PID(2-4) process #  0 => unknown
C                      Out: PID(1) not changed
C                           PID(2-4) the ID determined here from NAME
C   Output:
C      ACTIVE   L      Task active indicator (T => active)
C      IERR     I      Error return code: 0 => ok.
C                         2 => invalid task name.
C                         3 => other
C   Generic version - calls ZTACT2 w CHARACTER for VMS, HOLLERITH other
C      VMS COMMENTED OUT
C-----------------------------------------------------------------------
      CHARACTER NAME*6
      INTEGER   PID(4), IERR
      LOGICAL   ACTIVE
C
      INTEGER   JERR, IL, ITRIM
      HOLLERITH HNAME(2)
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IL = ITRIM (NAME)
C     IF (SYSTYP.EQ.'VMS') THEN
C        CALL ZTACT2 (IL, NAME, PID(2), JERR)
C     ELSE
         CALL CHR2H (IL, NAME, 1, HNAME)
         CALL ZTACT2 (IL, HNAME, PID(2), JERR)
C        END IF
      ACTIVE = JERR.EQ.0
      IERR = 0
      IF (JERR.GT.1) IERR = JERR
C
 999  RETURN
      END

      SUBROUTINE MFINI (LUN, VOL, CNO, DEPTH, PLANE, VER, CATBLK,
     *   BUFFER, IERR)
C-----------------------------------------------------------------------
C! Creates/opens Model Fit table files for SAD and others
C# Map Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2006, 2010, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MFINI creates and/or opens for writing (and reading) a specified
C   MF or Model-fit file.
C   FORMAT REVISION 4
C   Inputs:
C      LUN     I        Logical unit number to use
C      VOL     I        Disk number
C      CNO     I        Catalog number
C      DEPTH   I(5)     Depth into cube
C      PLANE   I        Which plane is this?
C   In/out:
C      VER     I        Input: desired version number 0 -> new
C                       Output: that used
C      CATBLK  I(256)   Image header
C   Output:
C      BUFFER     I(512)   Required for later calls to TABIO
C      IERR    I        Error codes from TABINI or TABIO
C   Common: DLOC.INC must be initialized
C-----------------------------------------------------------------------
      INTEGER   LUN, VOL, CNO, DEPTH(5), PLANE, VER, CATBLK(256),
     *   BUFFER(512), IERR
C
      INCLUDE 'INCS:PMFC.INC'
      INTEGER   IRNO, NKEY, NREC, ITITLE(8), NCOL, I, LDEPTH(5), LPLANE,
     *   DATP(128,2), ITRIM, NC, MFKOLS(NUMCOL), REVISN
      HOLLERITH HTITLE(8)
      REAL      RTITLE(8)
      CHARACTER TTITLE*32, CTITLE(NUMCOL)*8, UNITS(NUMCOL)*8, TITLE*24,
     *   TUNIT*8, TTYPE*8, NUMCH*8
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (ITITLE, HTITLE, RTITLE)
      DATA TTITLE /'AIPS MODEL FIT COMPONENTS TABLE'/
      DATA CTITLE /  'PLANE',    'PEAK INT', 'I FLUX  ', 'DELTAX  ',
     *   'DELTAY  ', 'MAJOR AX', 'MINOR AX', 'POSANGLE', 'Q FLUX  ',
     *   'U FLUX  ', 'V FLUX  ', 'ERR PEAK', 'ERR FLUX', 'ERR DLTX',
     *   'ERR DLTY', 'ERR MAJA', 'ERR MINA', 'ERR PA  ', 'ERR QFLX',
     *   'ERR UFLX', 'ERR VFLX', 'TYPE MOD', 'D0 MAJOR', 'D0 MINOR',
     *   'D0 POSAN', 'D- MAJOR', 'D- MINOR', 'D- POSAN', 'D+ MAJOR',
     *   'D+ MINOR', 'D+ POSAN', 'RES RMS ', 'RES PEAK', 'RES FLUX',
     *   'CENTER X', 'CENTER Y', 'MAJ AXIS', 'MIN AXIS', 'PIXEL PA',
     *   'PB FACT ', 'DLY FACT'/
      DATA NUMCH /'12345678'/
      DATA REVISN /4/
C-----------------------------------------------------------------------
C                                       Init parameters
      NCOL = NUMCOL
      NKEY = 7
      NREC = 500
C                                       Data = 7 R's   x 1
      CALL FILL (256, 0, DATP)
      CALL FILL (NCOL, 12, DATP(1,2))
C                                       create/open
      CALL TABINI ('WRIT', 'MF', VOL, CNO, VER, CATBLK, LUN, NKEY, NREC,
     *   NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('WRIT', 'TABINI', 'MFINI', IERR)
         GO TO 990
         END IF
C                                       New file created
      IF (IERR.LT.0) THEN
C                                       write column titles
         DO 20 IRNO = 1,NCOL
            TITLE = CTITLE(IRNO)
            CALL CHR2H (24, TITLE, 1, HTITLE)
            CALL TABIO ('WRIT', 3, IRNO, HTITLE, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'MFINI', IERR)
               GO TO 990
               END IF
 20         CONTINUE
C                                       figure out the units
         DO 25 I = 1,NUMCOL
            UNITS(I) = 'DEGREES'
 25         CONTINUE
         UNITS(COLPLN) = ' '
         UNITS(COPCEX) = 'PIXELS'
         UNITS(COPCEY) = 'PIXELS'
         UNITS(COPMAJ) = 'PIXELS'
         UNITS(COPMIN) = 'PIXELS'
         CALL H2CHR (8, 1, CATBLK(KHBUN), TUNIT)
         UNITS(COLPEK) = TUNIT
         UNITS(COLFLX) = TUNIT
         CALL CHLTOU (8, TUNIT)
         IF (TUNIT(:3).EQ.'JY/') UNITS(COLFLX) = 'JY'
         IF (TUNIT(:4).EQ.'MAG/') UNITS(COLFLX) = 'MAG'
         UNITS(COEPEK) = UNITS(COLPEK)
         UNITS(COEFLX) = UNITS(COLFLX)
         UNITS(COLQFL) = UNITS(COLFLX)
         UNITS(COLUFL) = UNITS(COLFLX)
         UNITS(COLVFL) = UNITS(COLFLX)
         UNITS(COEQFL) = UNITS(COLFLX)
         UNITS(COEUFL) = UNITS(COLFLX)
         UNITS(COEVFL) = UNITS(COLFLX)
         UNITS(COLTYP) = ' '
         UNITS(CORRMS) = UNITS(COLPEK)
         UNITS(CORPEK) = UNITS(COLPEK)
         UNITS(CORFLX) = UNITS(COLFLX)
         UNITS(COBMFA) = ' '
         UNITS(CODLFA) = ' '
C                                       X axis
         DO 30 I = 1,2
            IF ((AXTYP(LOCNUM).NE.1) .AND. (AXTYP(LOCNUM).NE.1+I)) THEN
               CALL H2CHR (8, 1, CATBLK(KHCTP+2*(I-1)), TTYPE)
               IF ((TTYPE(:4).EQ.'VELO') .OR. (TTYPE(:4).EQ.'FELO'))
     *            THEN
                  TUNIT = 'M/SEC'
               ELSE IF (TTYPE(:4).EQ.'TIME') THEN
                  TUNIT = 'SECONDS'
               ELSE IF (TTYPE(:4).EQ.'FREQ') THEN
                  TUNIT = 'HERTZ'
               ELSE IF ((TTYPE(:6).EQ.'LAMBDA') .OR.
     *            (TTYPE.EQ.'DISTANCE')) THEN
                  TUNIT = 'METERS'
               ELSE IF ((TTYPE.EQ.'PIXEL') .OR. (TTYPE.EQ.' ')) THEN
                  TUNIT = 'UNITLESS'
               ELSE
                  TUNIT = '????????'
                  END IF
               UNITS(COLDLX+I-1) = TUNIT
               UNITS(COLMJX+I-1) = TUNIT
               UNITS(COEDLX+I-1) = TUNIT
               UNITS(COEMJX+I-1) = TUNIT
               UNITS(COLD0J+I-1) = TUNIT
               UNITS(COLDMJ+I-1) = TUNIT
               UNITS(COLDPJ+I-1) = TUNIT
               END IF
 30         CONTINUE
C                                       write units
         DO 35 IRNO = 1,NCOL
            TITLE = UNITS(IRNO)
            CALL CHR2H (24, TITLE, 1, HTITLE)
            CALL TABIO ('WRIT', 4, IRNO, HTITLE, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'MFINI', IERR)
               GO TO 990
               END IF
 35         CONTINUE
C                                       write keywords
C                                       loop 100 must match
         TUNIT = 'REVISION'
         CALL CHR2H (8, TUNIT, 1, HTITLE)
         ITITLE(3) = REVISN
         ITITLE(4) = 0
         ITITLE(5) = 4
         CALL TABIO ('WRIT', 5, 1, HTITLE, BUFFER, IERR)
         IF (IERR.GT.0) THEN
            CALL TABERR ('WRIT', 'TABIO', 'MFINI', IERR)
            GO TO 990
            END IF
         DO 40 I = 1,5
            TUNIT = 'DEPTH' // NUMCH(I:I)
            CALL CHR2H (8, TUNIT, 1, HTITLE)
            ITITLE(3) = DEPTH(I)
            CALL TABIO ('WRIT', 5, I+1, HTITLE, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'MFINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
         TUNIT = 'REALRMS'
         CALL CHR2H (8, TUNIT, 1, HTITLE)
         RTITLE(3) = 0.0
         ITITLE(4) = 0
         ITITLE(5) = 2
         CALL TABIO ('WRIT', 5, 7, HTITLE, BUFFER, IERR)
         IF (IERR.GT.0) THEN
            CALL TABERR ('WRIT', 'TABIO', 'MFINI', IERR)
            GO TO 990
            END IF
C                                       table title
         CALL CHR2H (32, TTITLE, 1, HTITLE)
         CALL COPY (8, ITITLE, BUFFER(101))
C                                       check depth!
      ELSE
         DO 100 I = 2,6
            CALL TABIO ('READ', 5, I, HTITLE, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('READ', 'TABIO', 'MFINI', IERR)
               GO TO 990
               END IF
            LDEPTH(I-1) = ITITLE(3)
 100        CONTINUE
C                                       get plane number
         LPLANE = 1
         IF (CATBLK(KIDIM).GE.7) LPLANE = MAX (LDEPTH(5), 1)
         IF (CATBLK(KIDIM).GE.6) LPLANE = MAX (LDEPTH(4), 1) +
     *      (LPLANE-1) * MAX (CATBLK(KINAX+5), 1)
         IF (CATBLK(KIDIM).GE.5) LPLANE = MAX (LDEPTH(3), 1) +
     *      (LPLANE-1) * MAX (CATBLK(KINAX+4), 1)
         IF (CATBLK(KIDIM).GE.4) LPLANE = MAX (LDEPTH(2), 1) +
     *      (LPLANE-1) * MAX (CATBLK(KINAX+3), 1)
         IF (CATBLK(KIDIM).GE.3) LPLANE = MAX (LDEPTH(1), 1) +
     *      (LPLANE-1) * MAX (CATBLK(KINAX+2), 1)
         IF (PLANE.NE.LPLANE) THEN
            WRITE (MSGTXT,1100) PLANE, LPLANE
            CALL MSGWRT (6)
            END IF
C                                       check that columns are there
         CALL FNDCOL (NUMCOL, CTITLE, 8, .TRUE., BUFFER, MFKOLS, I)
         DO 110 I = 1,NUMCOL
            NC = ITRIM (CTITLE(I))
            IF (MFKOLS(I).LE.0) THEN
               WRITE (MSGTXT,1110) CTITLE(I)(:NC)
               CALL MSGWRT (6)
               IERR = 11
            ELSE IF (MFKOLS(I).NE.I) THEN
               WRITE (MSGTXT,1111) CTITLE(I)(:NC)
               CALL MSGWRT (6)
               IERR = 12
            ELSE IF (DATP(I,2).NE.12) THEN
               WRITE (MSGTXT,1112) CTITLE(I)(:NC)
               CALL MSGWRT (6)
               IERR = 12
               END IF
 110        CONTINUE
         IF (IERR.NE.0) GO TO 990
         END IF
      GO TO 999
C
 990  WRITE (MSGTXT,1990)
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('Warning: current plane =',I4,' not = initial plane',I4)
 1110 FORMAT ('MFINI: ''',A,''' COLUMN NOT FOUND')
 1111 FORMAT ('MFINI: ''',A,''' COLUMN OUT OF ORDER')
 1112 FORMAT ('MFINI: ''',A,''' COLUMN NOT CORRECT TYPE OR NUMBER')
 1990 FORMAT ('MFINI: ERROR INITIALIZING MODEL FIT TABLE FOR WRIT')
      END

      SUBROUTINE ZV20OP (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C! open Comtal Vision 1/20 TV device
C# Z IO-TV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Open an Comtal Vision 1/20 TV device for non-map (single buffered)
C   I/O.
C   Inputs:
C      LUN    I    Logical unit number
C   Output:
C      FIND   I    Index in FTAB to file control block for LUN
C      IERR   I    Error return code: 0 => no error
C                     1 => LUN already in use
C                     2 => no such logical device
C                     3 => device not found
C                     5 => no room for LUN in FTAB
C                     6 => other open errors
C   Generic version.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
C
      CHARACTER PNAME*48
      INTEGER   JERR, FCBOFF, TVLUN, TVDEVN, I, J
      LOGICAL   F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA F /.FALSE./
      DATA TVLUN, TVDEVN /9, 4/
C-----------------------------------------------------------------------
C                                       Check inputs.
      IERR = 6
C                                       Valid LUN?
      IF (LUN.EQ.TVLUN) GO TO 10
         WRITE (MSGTXT,1000) LUN
         GO TO 995
C                                       Valid device type?
 10   IF (DEVTAB(LUN).EQ.TVDEVN) GO TO 20
         WRITE (MSGTXT,1010) LUN, DEVTAB(LUN)
         GO TO 995
C                                       Allocate area in FTAB for LUN.
 20   CALL LSERCH ('OPEN', LUN, FIND, F, JERR)
      IF (JERR.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) JERR, 'OPEN', LUN
C                                       LUN already in use.
         IF (JERR.EQ.2) THEN
            CALL MSGWRT (6)
            IERR = 1
            WRITE (MSGTXT,1021) LUN
C                                       No room in FTAB for LUN.
         ELSE IF (JERR.EQ.3) THEN
            CALL MSGWRT (6)
            IERR = 5
            WRITE (MSGTXT,1022) LUN
            END IF
         GO TO 995
C                                       Build physical file name for
C                                       TV device.
 30   CALL ZPHFIL ('TV', 1, 1, 1, PNAME, IERR)
C                                       Error?
      IF (IERR.EQ.0) GO TO 40
         IERR = 6
         WRITE (MSGTXT,1030)
         GO TO 900
C                                       Open TV device.
 40   FCBOFF = FIND + NMOFF
      CALL ZV20O2 (FTAB(FCBOFF), PNAME, IERR)
      IF (IERR.NE.0) THEN
C                                       No such logical device.
         IF (IERR.EQ.2) THEN
            WRITE (MSGTXT,1040) PNAME(1:24)
            CALL MSGWRT (6)
C                                       No such device.
         ELSE IF (IERR.EQ.3) THEN
            WRITE (MSGTXT,1050) PNAME(1:24)
            CALL MSGWRT (6)
C                                       Other open error.
         ELSE
            CALL ZERROR ('ZV20O2', FTAB(FCBOFF+FCBERR), PNAME,
     *         FTAB(FCBOFF), F)
            END IF
C                                       store file name
      ELSE
         CALL FSERCH (FIND, I, J, JERR)
         IF (JERR.EQ.0) THEN
            IF (I.EQ.1) DEVNAM(J) = PNAME
            IF (I.EQ.2) NONNAM(J) = PNAME
            IF (I.EQ.3) MAPNAM(J) = PNAME
            END IF
         GO TO 999
         END IF
C                                       Remove FTAB entry for LUN.
 900  CALL LSERCH ('CLOS', LUN, FIND, F, JERR)
      IF (JERR.EQ.0) GO TO 999
           IERR = IERR + 2
           WRITE (MSGTXT,1020) JERR, 'CLOS', LUN
C
 995  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZV20OP: LUN = ',I2,' INVALID FOR TV DEVICE')
 1010 FORMAT ('ZV20OP: DEVTAB(',I2,') = ',I1,' INVALID FOR TV DEVICE')
 1020 FORMAT ('ZV20OP: LSERCH ERROR ',I2,' ON ',A4,' LUN = ',I2)
 1021 FORMAT ('ZV20OP: LUN = ',I2,' ALREADY OPENED IN FTAB')
 1022 FORMAT ('ZV20OP: NO ROOM IN FTAB FOR LUN = ',I2)
 1030 FORMAT ('ZV20OP: ZPHFIL ERROR FOR TYPE =''TV'' VOL = 1',
     *   ' SEQ = 1 VER = 1')
 1040 FORMAT ('ZV20OP: NO SUCH LOGICAL DEVICE = ',A24)
 1050 FORMAT ('ZV20OP: TV DEVICE ',A24,' NOT FOUND')
      END

      SUBROUTINE GDVEC (X, Y, BUFF, IERR)
C-----------------------------------------------------------------------
C! writes a write DARK vector command in a plot file
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2002, 2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GVEC will write a 'write vector' command record to a graph file or
C   the TV (in immediate TV mode).
C   The output record description is:
C            I     opcode, 10 in this program.
C            I     scaled X position.
C            I     scaled Y position.
C   Inputs:
C      X      R       x position
C      Y      R       y position.
C      BUFF   I(256)  buffer to use for I/O.
C   Output:
C      IERR   I       error code. 0 = ok.
C                        1 = disk problems.
C                        2 = TV problems
C   Common:
C      GPHPOS  incremented by 3.
C      GPHRRN  incremented by 1 if a write to disk is needed.
C-----------------------------------------------------------------------
      REAL      X, Y
      INTEGER   BUFF(256), IERR
C
      REAL      RX, RY, RLIM, ALPHA, BETA
      INTEGER   NEED, OPCODE, IER, IROUND, IXN, IYN, X1, X2, Y1, Y2, DGR
      LOGICAL   ISERR
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA NEED, OPCODE, DGR /254, 10, 8/
C-----------------------------------------------------------------------
      IERR = 0
C                                       Scale X and Y.
      IF (GPHIX2.EQ.GPHIX1) THEN
         RX = 0.0
      ELSE
         RX = (X - GPHX1) / (GPHX2 - GPHX1)
         END IF
      IF (GPHIY2.EQ.GPHIY1) THEN
         RY = 0.0
      ELSE
         RY = (Y - GPHY1) / (GPHY2 - GPHY1)
         END IF
      RLIM = 4.0
      RX = MAX (-RLIM, MIN (RLIM, RX))
      RY = MAX (-RLIM, MIN (RLIM, RY))
C                                       Plot files
      IF (.NOT.GPHDOT) THEN
C                                       See if enough room in buffer.
         IF (GPHPOS.GE.NEED) THEN
            CALL GPHWRT (BUFF, IER)
            IF (IER.NE.0) THEN
               IERR = 1
               GO TO 999
               END IF
            END IF
C                                       Put data in buffer.
         RX = RX * SCALEF
         RY = RY * SCALEF
         BUFF(GPHPOS+1) = OPCODE
         BUFF(GPHPOS+2) = IROUND (RX)
         BUFF(GPHPOS+3) = IROUND (RY)
         GPHPOS = GPHPOS + 3
C                                       TV instead
      ELSE
         ISERR = .FALSE.
         IXN = RX * GPHSCX  +  GPHIX0 + 0.5
         IYN = RY * GPHSCY  +  GPHIY0 + 0.5
         X1 = MAX (1, MIN (MAXXTV(1), GPHIXL))
         Y1 = MAX (1, MIN (MAXXTV(2), GPHIYL))
         X2 = MAX (1, MIN (MAXXTV(1), IXN))
         Y2 = MAX (1, MIN (MAXXTV(2), IYN))
         IF ((X1.NE.GPHIXL) .OR. (Y1.NE.GPHIYL)) THEN
            ALPHA = 1.0
            IF (IXN.NE.GPHIXL) ALPHA = REAL(X1-IXN)/REAL(GPHIXL-IXN)
            BETA = 1.0
            IF (IYN.NE.GPHIYL) BETA = REAL(Y1-IYN)/REAL(GPHIYL-IYN)
            ALPHA = MIN (ALPHA, BETA)
            X1 = IXN + ALPHA * (GPHIXL-IXN) + 0.5
            Y1 = IYN + ALPHA * (GPHIYL-IYN) + 0.5
            ISERR = .TRUE.
            END IF
         IF ((X2.NE.IXN) .OR. (Y2.NE.IYN)) THEN
            ALPHA = 1.0
            IF (IXN.NE.GPHIXL) ALPHA = REAL(X2-GPHIXL)/REAL(IXN-GPHIXL)
            BETA = 1.0
            IF (IYN.NE.GPHIYL) BETA = REAL(Y2-GPHIYL)/REAL(IYN-GPHIYL)
            ALPHA = MIN (ALPHA, BETA)
            X2 = GPHIXL + ALPHA * (IXN-GPHIXL) + 0.5
            Y2 = GPHIYL + ALPHA * (IYN-GPHIYL) + 0.5
            ISERR = .TRUE.
            END IF
C                                        write DARK vectors
         IF (GPHDOD) THEN
            DGR = 8 + NGRAY
         ELSE
            GPHLTY = MAX (1, GPHLTY)
            DGR = GPHTVG(GPHLTY)
            END IF
         CALL GCINIT (DGR, 0, IERR)
         IF (IERR.NE.0) GO TO 999
         BUFF(1) = MAX (1, MIN (MAXXTV(1), X1))
         BUFF(3) = MAX (1, MIN (MAXXTV(2), Y1))
         BUFF(2) = MAX (1, MIN (MAXXTV(1), X2))
         BUFF(4) = MAX (1, MIN (MAXXTV(2), Y2))
         CALL IMVECT ('ONNN', DGR, 2, BUFF, BUFF(3), GPHSCR, IERR)
C                                        set last position
         GPHIXL = IXN
         GPHIYL = IYN
         IF (ISERR) GPHERV = GPHERV + 1
         GPHCNT = GPHCNT + 1
         IF (GPHCNT.GT.5000) THEN
            CALL YHOLD ('OFFF', IER)
            CALL YHOLD ('ONNN', IER)
            GPHCNT = 0
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE TIMDAT (ITIME, IDATE, ATIME, ADATE)
C-----------------------------------------------------------------------
C! convert integer time and date to character form for display
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Convert integer array form of time and date to expanded alpha
C   form for printing.
C   Inputs:
C      ITIME  I(3)   hours, minutes, seconds.
C      IDATE  I(3)   year, month, date.  If IDATE(1) < 0, then a short
C                    (9 char) output is created using ABS(IDATE(1))
C   Outputs:
C      ATIME  C*8    Time in form  'hh:mm:ss'
C      ADATE  C*12   Date in form  'dd-MMM-yyyy' or 'dd-MMM-yy'
C-----------------------------------------------------------------------
      INTEGER   ITIME(3), IDATE(3)
      CHARACTER ATIME*(*), ADATE*(*)
C
      CHARACTER MONTH(12)*3, BADTIM*8, BADAT1*12, BADAT2*12
      INTEGER   IYEAR
      DATA MONTH /'JAN','FEB','MAR','APR','MAY','JUN','JUL',
     *   'AUG','SEP','OCT','NOV','DEC'/
      DATA BADTIM /'BAD TIME'/
      DATA BADAT1 /'FUNNY DATE  '/
      DATA BADAT2 /'BAD DATE    '/
C-----------------------------------------------------------------------
C                                       time
      IF ((ITIME(1).LT.0) .OR. (ITIME(1).GT.24) .OR. (ITIME(2).LT.0)
     *   .OR. (ITIME(2).GT.60) .OR. (ITIME(3).LT.0) .OR.
     *   (ITIME(3).GT.60)) THEN
         ATIME = BADTIM
      ELSE
         WRITE (ATIME,1000) ITIME
         END IF
C                                       Do date - 11 char
 20   IYEAR = IDATE(1)
      IF (IYEAR.GE.0) THEN
         IF (IYEAR.LT.40) IYEAR = IYEAR + 2000
         IF (IYEAR.LT.200) IYEAR = IYEAR + 1900
         IF ((IYEAR.LE.1900) .OR. (IYEAR.GE.2100) .OR. (IDATE(3).LE.0)
     *      .OR. (IDATE(3).GT.31) .OR. (IDATE(2).LE.0) .OR.
     *      (IDATE(2).GT.12)) THEN
            ADATE = BADAT1
         ELSE
            WRITE (ADATE,1020) IDATE(3), MONTH(IDATE(2)), IYEAR
            END IF
C                                       Do date - 9 char
      ELSE
         IYEAR = -IYEAR
         IYEAR = MOD (IYEAR, 100)
         IF ((IDATE(3).LE.0) .OR. (IDATE(3).GT.31) .OR. (IDATE(2).LE.0)
     *      .OR. (IDATE(2).GT.12)) THEN
            ADATE = BADAT2
         ELSE
            WRITE (ADATE,1021) IDATE(3), MONTH(IDATE(2)), IYEAR
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I2.2,':',I2.2,':',I2.2)
 1020 FORMAT (I2.2,'-',A3,'-',I4)
 1021 FORMAT (I2.2,'-',A3,'-',I2.2)
      END

      SUBROUTINE FLGINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IFGRNO, FGKOLS, FGNUMV, IERR)
C-----------------------------------------------------------------------
C! Create/Open/Init Flag (FG) table.
C# EXT-util Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000, 2006, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes FLAG extension tables.
C    Inputs:
C     OPCODE       C*4 Operation code:
C                      'WRIT' = create/init for write or read
C                      'READ' = open for read only
C     BUFFER(512)  I   I/O buffer and related storage, also defines file
C                      if open.
C     DISK         I   Disk to use.
C     CNO          I   Catalog slot number
C     VER          I   FG file version
C     CATBLK(256)  I   Catalog header block.
C     LUN          I   Logical unit number to use
C    Output:
C     IFGRNO       I   Next scan number, start of the file if 'READ',
C                      the last+1 if WRITE
C     FGKOLS(MAXFGC)   I   The column pointer array in order, SOURCE,
C                      SUBARRAY, FREQID, ANTS, TIMERANG, IFS, CHANS,
C                      PFLAGS, REASON
C     FGNUMV(MAXFGC)    I   Element count in each column.
C     IERR         I   Return error code, 0=>OK, else TABINI or TABIO
C                      error.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, IFGRNO,
     *   FGKOLS(*), FGNUMV(*), IERR
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER TITLE(MAXFGC)*24, UNITS(MAXFGC)*8, TTITLE*56
      HOLLERITH HOLTMP(6)
      INTEGER   NTT, NKEY, NREC, DATP(128,2), NCOL, DTYP(MAXFGC), NDATA,
     *   I, JERR, NC, ITRIM, IPOINT, ITEMP(6)
      LOGICAL   DOREAD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (ITEMP, HOLTMP)
      DATA NTT /56/
      DATA TTITLE /'AIPS UV DATA FILE FLAG TABLE '/
      DATA DTYP /14,14,14,24,22,24,24,47,243/
      DATA TITLE /'SOURCE                  ',
     *   'SUBARRAY                ', 'FREQ ID                 ',
     *   'ANTS                    ',
     *   'TIME RANGE              ', 'IFS                     ',
     *   'CHANS                   ',
     *   'PFLAGS                  ', 'REASON                  '/
      DATA UNITS /4*'        ', 'DAYS    ', 4*'        '/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NDATA = MAXFGC
      NREC = 500
      NCOL = NDATA
      NKEY = 0
C                                       Fill in types
      IF (.NOT.DOREAD) CALL COPY (NDATA, DTYP, DATP(1,2))
C                                       Create/open file
      CALL TABINI (OPCODE, 'FG', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'FLGINI', IERR)
         GO TO 990
         END IF
C                                       See if file exists.
      IF (IERR.LT.0) THEN
C                                       File created, initialize
         DO 40 I = 1,NDATA
C                                       Col. labels.
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'FLGINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'FLGINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
         END IF
C                                       Get number of scans
      IFGRNO = BUFFER(5)
      IFGRNO = IFGRNO + 1
      IF (DOREAD) IFGRNO = 1
C                                      Get array indices
C                                      Cover your ass from FNDCOL -
C                                      close to flush the buffers and
C                                      then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, ITEMP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'FLGINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'FG', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'FLGINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (MAXFGC, TITLE, 24, .TRUE., BUFFER, FGKOLS, JERR)
C                                      Get array indices and no. values
      DO 150 I = 1,MAXFGC
         IPOINT = FGKOLS(I)
         IF (IPOINT.GT.0) THEN
            FGKOLS(I) = DATP(IPOINT,1)
            FGNUMV(I) = DATP(IPOINT,2) / 10
            IF (FGNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            FGKOLS(I) = -1
            FGNUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('FLGINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('FLGINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('FLGINI: ERROR INITIALIZING FLAG TABLE FOR ',A4)
      END

      SUBROUTINE ZLPCLS (LUN, IERR)
C-----------------------------------------------------------------------
C! close an open printer device
C# Z Printer
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2002, 2004, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Close a line printer file, spool it to a printer and delete it.
C   Inputs:
C      LUN      I   Logical unit number
C   Output:
C      IERR     I   Error return code: 0 => no error
C                      1 => close error
C   Generic version - closes file, calls ZLPCL2  VMS COMMENTED OUT
C-----------------------------------------------------------------------
      INTEGER   LUN, IERR
C
      INTEGER   LLEN, DELFIL, SYSERR, IOSVAL, ITRIM
      LOGICAL   F
      CHARACTER LPRFIL*256
      HOLLERITH HPRFIL(64)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      IERR = 1
C                                       Get the name of the line printer
C                                       file as opened on LUN.
      INQUIRE (UNIT=LUN, NAME=LPRFIL, IOSTAT=IOSVAL)
      IF (IOSVAL.NE.0) THEN
         WRITE (MSGTXT,1000) IOSVAL, LUN
         GO TO 995
         END IF
C                                       Perform the Fortran CLOSE.
      CLOSE (UNIT=LUN, IOSTAT=IOSVAL)
      IF (IOSVAL.NE.0) THEN
         WRITE (MSGTXT,1010) IOSVAL, LUN
         GO TO 995
         END IF
C                                       Print and delete the file.
      LLEN = ITRIM (LPRFIL)
      DELFIL = INDEX (LPRFIL, 'ZLPOPN')
      DELFIL = MIN (DELFIL, 1)
C
      IF (DELFIL.EQ.0) THEN
         IERR = 0
C                                       print and  delete
      ELSE
         DELFIL = PRDELE
C        IF (SYSTYP.EQ.'VMS') THEN
C           CALL ZLPCL2 (LLEN, LPRFIL, DELFIL, PRTMAX, SYSERR, IERR)
C        ELSE
            CALL CHR2H (256, ' ', 1, HPRFIL)
            CALL CHR2H (LLEN, LPRFIL, 1, HPRFIL)
            CALL ZLPCL2 (LLEN, HPRFIL, DELFIL, PRTMAX, SYSERR, IERR)
C           END IF
         IF (IERR.NE.0) CALL ZERROR ('ZLPCL2', SYSERR, ' ', -999, F)
         END IF
      GO TO 999
C
 995  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZLPCLS: FORTRAN ERROR ',I6,' ON INQUIRE FOR LUN = ',I6)
 1010 FORMAT ('ZLPCLS: FORTRAN ERROR ',I6,' ON CLOSE FOR LUN = ',I6)
      END

      SUBROUTINE CUBHLX (START, ROTS, HUE, GAMMA, NLEVS, RED, GRN, BLU,
     *   NLO, nHI)
C-----------------------------------------------------------------------
C! OFM helix in color intensity space called by TVHELX
C# POPS=appl TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2010
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does a helix in OFM colors, which is monotonically increasing in
C   perceived intensity (since R, G, B are appropriately weighted).
C   Calculates a "helix" colour table. The colours run along the
C   diagonal of the [R,G,B] colour cube, from black [0,0,0] to white
C   [1,1,1].  Deviations away from the diagonal vary quadratically,
C   increasing from zero at black, to a maximum, then decreasing to
C   zero at white, all the time rotating in colour (i.e. a tapered
C   helix along the [R,G,B] diagonal).
C
C   The parameters controlling the colour helix are:
C
C      START    colour (1=red, 2=green, 3=red; e.g. 0.5=purple);
C      ROTS     rotations in colour (typically -1.5 to 1.5, e.g. -1.0
C               is one blue->green->red cycle);
C      HUE      for hue intensity scaling (in the range 0.0 (B+W) to
C               1.0 to be strictly correct, larger values may be OK
C               with particular start/end colours);
C      GAMMA    set the gamma correction for intensity.
C
C   The routine returns a colour table NLEVS elements long in RED,
C   GRN and BLU (each element in the range 0.0 to 1.0), and also
C   returns the number of values, NLO and NHI, that were clipped to
C   0.0 or 1.0 respectively.
C   Dave Green --- MRAO --- 2010 September 20th
C-----------------------------------------------------------------------
      REAL      START, ROTS, HUE, GAMMA, RED(*), GRN(*), BLU(*)
      INTEGER   NLEVS, NLO, NHI
C
      REAL      PI, FRACT, ANGLE, AMP
      INTEGER   I
C-----------------------------------------------------------------------
      PI = 4.0 * ATAN (1.0)
      NLO = 0
      NHI = 0
C
      DO 20 I = 1,NLEVS
         FRACT = FLOAT (I-1) / FLOAT (NLEVS-1)
         ANGLE = 2 * PI * (START/3.0 + 1.0 + ROTS * FRACT)
         FRACT = FRACT ** GAMMA
         AMP = HUE * FRACT * (1-FRACT)/2.0
         RED(I) = FRACT + AMP * (-0.14861 * COS(ANGLE) +
     *      1.78277 * SIN(ANGLE))
         GRN(I) = FRACT + AMP * (-0.29227 * COS(ANGLE) -
     *      0.90649 * SIN(ANGLE))
         BLU(I) = FRACT + AMP * (+1.97294 * COS(ANGLE))
         IF (RED(I).LT.0.0) THEN
            RED(I) = 0.0
            NLO = NLO + 1
            END IF
         IF (GRN(I).LT.0.0) THEN
            GRN(I) = 0.0
            NLO = NLO + 1
            END IF
         IF (BLU(I).LT.0.0) THEN
            BLU(I) = 0.0
            NLO = NLO + 1
            END IF
         IF (RED(I).GT.1.0) THEN
            RED(I) = 1.0
            NHI = NHI + 1
            END IF
         IF (GRN(I).GT.1.0) THEN
            GRN(I) = 1.0
            NHI = NHI + 1
            END IF
         IF (BLU(I).GT.1.0) THEN
            BLU(I) = 1.0
            NHI = NHI + 1
            END IF
 20      CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'QUACK.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XXSTOK(1),
     *   XOPCOD(1), XREAS(6)
      REAL      XSIN, XDISIN, XSUBAR, xbif, xeif, XBAND, XFREQ, XFQID,
     *   TIMER(8), XANTS(50), XBASE(50), XFGVER, APARM(10), BADD(10),
     *   BUFF1(4096), BUFF2(4096), TBEG, TEND
      INTEGER   SEQIN, DISKIN, SUBAR, FGVER, NANT, ANTS(50), BIF, EIF,
     *   NID, ID(300), NUMHIS, JBUFSZ, FRQSEL, NUMAN(513)
      INTEGER MAXBAS
      PARAMETER (MAXBAS = 500)
      INTEGER XA1(MAXBAS), XA2(MAXBAS), NBASE
C
      CHARACTER NAMEIN*12, CLAIN*6, XSOUR(30)*16, OPCODE*4, REASON*24,
     *   HISCRD(10)*64, STOKES*4
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XXSTOK, XBIF, XEIF,
     *   XXSOUR, XSUBAR, XBAND, XFREQ, XFQID,TIMER, XANTS, XBASE,
     *   XFGVER, XOPCOD, XREAS, APARM, BADD,
     *   TBEG, TEND, SEQIN, DISKIN, SUBAR, FGVER, NANT, ANTS, NID, ID,
     *   NUMHIS, FRQSEL, NUMAN, XA1, XA2, NBASE, BIF, EIF
      COMMON /CHARPM/ NAMEIN, CLAIN, XSOUR, OPCODE, REASON, HISCRD,
     *   STOKES
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
LOCAL END
      PROGRAM QUACK
C-----------------------------------------------------------------------
C! Flags a selected portion of each specified scan in a uv data set
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998-1999, 2002, 2006-2007, 2011-2012, 2016,
C;  Copyright (C) 2018, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   QUACK flags a selected portion of scans in uv data.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      SOURCES        XSOUR         Sources selected/deselected
C      SUBARRAY       SUBAR         Subarray number 0=>all.
C      SELBAND      SELBAN      Bandwidth in FQ table
C      SELFREQ      SELFRQ      Freq in FQ table
C      FREQID       FFQID      Freq ID to flag
C      TIMERANG       TIMER         timerange to consider
C      ANTENNAS       ANTS          Antennas to flag
C      FLAGVER        FGVER         Flag table version number
C      OPCODE         OPCODE        Opcode
C      REASON         REASON        Reason for flagging
C      APARM(10)      APARM         Control values
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER IRET
      INCLUDE 'QUACK.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'QUACK '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL QUAKIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Flag data
      CALL QUAKUV (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL QUAKHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE QUAKIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   QUAKIN gets input parameters for QUACK.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                6 => invalid inputs
C                                7 = No data selected.
C                                8 => can't start
C   Output in common:
C      NID     I      Number of values in ID
C      ID      I(300) Source IDs selected
C      NANT    I      Number of values in ANTS
C      ANTS    I(50)  Number of antennas selected.
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER  STAT*4, PTYPE*2, CTIME*8, CDATE*12
      INTEGER   OLDCNO, IROUND, NPARM, I, IERR, QUAL(30), NSOUR,
     *   LUNFQ, LUNAN, IERANT, IFGVER, DATE(3), TIME(3)
      LOGICAL   T, NOSOUR, MATCH
      REAL      SELBAN
      DOUBLE PRECISION SELFRQ
      INCLUDE 'QUACK.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA QUAL /30*-1/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T, BUFF1)
      CALL VHDRIN
      JBUFSZ = 4096 * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 270
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      CALL H2CHR (4, 1, XXSTOK, STOKES)
      CALL H2CHR (24, 1, XREAS, REASON)
      IF (REASON.EQ.' ') THEN
         CALL ZDATE (DATE)
         CALL ZTIME (TIME)
         DATE(1) = -DATE(1)
         CALL TIMDAT (TIME, DATE, CTIME, CDATE)
         WRITE (REASON,1001) TSKNAM, CDATE(:9), CTIME
         END IF
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      NOSOUR = .TRUE.
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
         NOSOUR = NOSOUR .AND. (XSOUR(I).EQ.' ')
 20      CONTINUE
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      SUBAR = IROUND (XSUBAR)
      FGVER = IROUND (XFGVER)
      BIF = XBIF + 0.1
      EIF = XEIF + 0.1
C                                       Defaults

      IF (OPCODE.EQ.' ') OPCODE = 'BEG '
      IF (APARM(1).LE.0.000001) APARM(1) = 2.0
      IF (APARM(2).LE.0.000001) APARM(2) = 0.1
C                                       Validity check.
      IF (((OPCODE.NE.'END ') .AND. (OPCODE.NE.'BEG ')) .AND.
     *   (OPCODE.NE.'ENDB') .AND. (OPCODE.NE.'TAIL')) THEN
         MSGTXT = 'UNKNOWN OPCODE = ' // OPCODE
         JERR = 6
         GO TO 990
         END IF
C                                       Get CATBLK from file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'WRIT', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = MAX (1, BIF)
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
C                                       Determine FG max
      CALL FNDEXT ('FG', CATBLK, IFGVER)
      IF (FGVER.LE.0) FGVER = MAX (1, IFGVER)
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.LT.0) FRQSEL = -1
      IF (FRQSEL.GE.0) THEN
         LUNFQ = 40
         CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUNFQ, SELBAN, SELFRQ,
     *      MATCH, FRQSEL, JERR)
         IF (.NOT.MATCH) THEN
            WRITE (MSGTXT,1070)
            JERR = 1
            GO TO 990
            END IF
         IF (JERR.GT.0) GO TO 999
         END IF
C                                       Look up sources selected.
      IF (NOSOUR) THEN
         NID = 0
         ID(1) = 0
      ELSE
         NSOUR = 30
         NID = 300
         CALL SOURNU (XSOUR, QUAL, NSOUR, DISKIN, OLDCNO, NID,
     *      BUFF1, ID, JERR)
         IF (JERR.GT.0) GO TO 999
C                                       Check that sources found.
         IF (JERR.LT.0) THEN
            JERR = 7
            MSGTXT = 'NONE OF THE SPECIFIED SOURCES WERE FOUND'
            GO TO 990
            END IF
         END IF
C                                       Get number(s) of antennas.
C                                       Since GETNAN will return
C                                       a reasonable default -
C                                       ignore error code.
      LUNAN = 30
      CALL GETNAN (DISKIN, OLDCNO, CATBLK, LUNAN, BUFF1, NUMAN, IERANT)
C                                       Convert to baseline antennas.
      NBASE = MAXBAS
      CALL AN10RS (NUMAN, SUBAR, XANTS, XBASE, NBASE, XA1, XA2)
C
      JERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('QUAKIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1001 FORMAT (A6,A9,1X,A8)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
      END
      SUBROUTINE QUAKUV (IRET)
C-----------------------------------------------------------------------
C   QUAKUV writes entries in the specified FG table.
C   routine and then writes the modified data if requested.
C   Input in common:
C      FGVER   I      FG version number
C      NID     I      Number of values in ID
C      ID      I(300) Source IDs selected
C      NANT    I      Number of values in ANTS
C      ANTS    I(50)  Number of antennas selected.
C   Output:
C      IRET   I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   LUNNX, LUNFG, BUFFNX(4096), BUFFFG(4096), INXRNO,
     *   IFGRNO, NUMNX, NXVER, ISCAN, IDSOUR, SUBA, VSTART, VEND, FQID,
     *   IBASL, ANT(2), IFS(2), CHANS(2), LOOP, NUMFLG, FGSOUR
      LOGICAL   PFLAGS(4)
      REAL      TIME, DTIME, TMR(2), TIMOFF, TIMBEG, TIMEND, SUMFLG,
     *   BACKS
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NXKOLS(MAXNXC), NXNUMV(MAXNXC), FGKOLS(MAXFGC),
     *   FGNUMV(MAXFGC)
      CHARACTER LSTOK*4
      INCLUDE 'QUACK.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (BUFFNX, BUFF1), (BUFFFG, BUFF2)
      DATA LUNNX, LUNFG /25, 26/
C-----------------------------------------------------------------------
C                                       Explicit initialisation.
      ANT(1) = 0
      ANT(2) = 0
      IFS(1) = BIF
      IFS(2) = EIF
      CHANS(1) = 1
      CHANS(2) = 0
C                                       stokes
      LSTOK = STOKES
      IF ((STOKES.EQ.' ') .OR. (STOKES.EQ.'FULL')) THEN
         LSTOK = '1111'
      ELSE IF ((INDEX(STOKES,'0').EQ.0) .AND. (INDEX(STOKES,'1').EQ.0))
     *   THEN
         LSTOK = '0000'
         IF (ICOR0.LT.-4) THEN
            IF (STOKES.EQ.'HALF') THEN
               LSTOK = '1100'
            ELSE
               IF (MOD(INDEX(STOKES,'VV'),2).GT.0) LSTOK(1:1) = '1'
               IF (MOD(INDEX(STOKES,'HH'),2).GT.0) LSTOK(2:2) = '1'
               IF (MOD(INDEX(STOKES,'VH'),2).GT.0) LSTOK(3:3) = '1'
               IF (MOD(INDEX(STOKES,'HV'),2).GT.0) LSTOK(4:4) = '1'
               END IF
         ELSE IF (ICOR0.LT.0) THEN
            IF (STOKES.EQ.'HALF') THEN
               LSTOK = '1100'
            ELSE
               IF (MOD(INDEX(STOKES,'RR'),2).GT.0) LSTOK(1:1) = '1'
               IF (MOD(INDEX(STOKES,'LL'),2).GT.0) LSTOK(2:2) = '1'
               IF (MOD(INDEX(STOKES,'RL'),2).GT.0) LSTOK(3:3) = '1'
               IF (MOD(INDEX(STOKES,'LR'),2).GT.0) LSTOK(4:4) = '1'
               END IF
         ELSE
            IF (INDEX(STOKES,'I').GT.0) LSTOK(1:1) = '1'
            IF (INDEX(STOKES,'Q').GT.0) LSTOK(2:2) = '1'
            IF (INDEX(STOKES,'U').GT.0) LSTOK(3:3) = '1'
            IF (INDEX(STOKES,'V').GT.0) LSTOK(4:4) = '1'
            END IF
         END IF
      DO 20 LOOP = 1, 4
        PFLAGS(LOOP) = LSTOK(LOOP:LOOP).EQ.'1'
  20    CONTINUE
C                                       Timerange
      TBEG = TIMER(1) + (TIMER(2) / 24.0) + (TIMER(3) / (24.0 * 60.0)) +
     *   (TIMER(4) / (24.0 * 3600.0))
      TEND = TIMER(5) + (TIMER(6) / 24.0) + (TIMER(7) / (24.0 * 60.0)) +
     *   (TIMER(8) / (24.0 * 3600.0))
C                                       All times
      IF (TBEG.LE.0.0000001) TBEG = -1.E5
      IF ((TEND.LE.0.0000001) .OR. (TBEG.GT.TEND)) TEND = 1.0E5
      TIMOFF = APARM(1) / (24.0 * 60.0)
      TIMBEG = APARM(2) / (24.0 * 60.0)
      TIMEND = TIMBEG
C                                       Back start .5 sec or nothing
      BACKS = 5.78704E-6
      IF (APARM(3).LT.-0.0001) THEN
         BACKS = 0.
      ELSE IF (APARM(3) .GT. 0.0001) THEN
         BACKS = APARM(3) / 24. / 60. / 60.
         END IF
      SUMFLG = 0.0
      NUMFLG = 0
C                                       Open NX table
      NXVER = 1
      CALL NDXINI ('READ', BUFFNX, FVOL(NCFILE), FCNO(NCFILE), NXVER,
     *   CATBLK, LUNNX, INXRNO, NXKOLS, NXNUMV, IRET)
C                                       Table present?
      IF (IRET.EQ.2) THEN
         MSGTXT = 'USE TASK INDXR TO CREATE AN INDEX (NX) TABLE'
         GO TO 990
         END IF
      IF (IRET.NE.0) GO TO 999
      NUMNX = BUFFNX(5)
C                                       Open FG table
      CALL FGREFM (FVOL(NCFILE), FCNO(NCFILE), FGVER, CATBLK, LUNFG,
     *   IRET)
      CALL FLGINI ('WRIT', BUFFFG, FVOL(NCFILE), FCNO(NCFILE), FGVER,
     *   CATBLK, LUNFG, IFGRNO, FGKOLS, FGNUMV, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Loop over scans
      DO 500 ISCAN = 1,NUMNX
         INXRNO = ISCAN
         CALL TABNDX ('READ', BUFFNX, INXRNO, NXKOLS, NXNUMV, TIME,
     *      DTIME, IDSOUR, SUBA, VSTART, VEND, FQID, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Want this one?
         IF (((TIME-0.5*DTIME).LT.TBEG) .OR.
     *      ((TIME+0.5*DTIME).GT.TEND) .OR. ((SUBA.NE.SUBAR) .AND.
     *      (SUBAR.GT.0) .AND. (SUBA.GT.0))) GO TO 500
         IF ((FRQSEL.GT.0) .AND. (FQID.GT.0) .AND. (FQID.NE.FRQSEL))
     *      GO TO 500
         IF (NID.GT.0) THEN
            DO 50 LOOP = 1,NID
               IF (IDSOUR.EQ.ID(LOOP)) GO TO 60
 50            CONTINUE
            GO TO 500
            END IF
C                                       Set flag time range
 60      FGSOUR = IDSOUR
C                                       End good.
         IF (OPCODE.EQ.'END ') THEN
            TMR(1) = TIME - 0.5 * DTIME
C                                       Back start time off by BACKS sec.
            TMR(1) = TMR(1) - BACKS
            TMR(2) = TIME + 0.5 * DTIME - TIMOFF
C                                       Beginning bad.
         ELSE IF (OPCODE.EQ.'BEG ') THEN
            TMR(1) = TIME - 0.5 * DTIME
            TMR(2) = TMR(1) + TIMBEG
C                                       Back start time off by BACKS sec.
            TMR(1) = TMR(1) - BACKS
C                                       end bad.
         ELSE IF (OPCODE.EQ.'ENDB') THEN
            TMR(2) = TIME + 0.5 * DTIME
            TMR(1) = TMR(2) - TIMEND
C                                       Stop time later by BACKS sec.
            TMR(2) = TMR(2) + BACKS
C                                       Time past end bad
         ELSE IF (OPCODE.EQ.'TAIL') THEN
            FGSOUR = 0
            TMR(1) = TIME + 0.5 * DTIME
            TMR(2) = TMR(1) + TIMEND
            TMR(1) = TMR(1) + BACKS
            END IF
         IF (TMR(2).LE.TMR(1)) GO TO 500
C                                       Record time flagged
         SUMFLG = SUMFLG + (TMR(2) - TMR(1)) * 1440.0
         NUMFLG = NUMFLG + 1
C                                       Deal with antennas-baselines
C                                       selected
C                                       ANTENNAS=BASELINE=0
         IF (NBASE.EQ.1 .AND. (XA1(1).EQ.0 .AND. XA2(1).EQ.0)) THEN
            ANT(1) = 0
            ANT(2) = 0
C                                       Write table
            CALL TABFLG ('WRIT', BUFFFG, IFGRNO, FGKOLS, FGNUMV, FGSOUR,
     *         SUBA, FRQSEL, ANT, TMR, IFS, CHANS, PFLAGS, REASON, IRET)
            IF (IRET.NE.0) GO TO 999
         ELSE
            DO 100 IBASL = 1, NBASE
               ANT(1) = XA1(IBASL)
               ANT(2) = XA2(IBASL)
C                                       Write table
               CALL TABFLG ('WRIT', BUFFFG, IFGRNO, FGKOLS, FGNUMV,
     *            FGSOUR, SUBA, FRQSEL, ANT, TMR, IFS, CHANS, PFLAGS,
     *            REASON, IRET)
               IF (IRET.NE.0) GO TO 999
 100           CONTINUE
            END IF
 500     CONTINUE
C                                       Tell how much flagged
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),1500) SUMFLG, NUMFLG
      MSGTXT = HISCRD(NUMHIS)
      CALL MSGWRT (4)
C                                       Mark FG table as unsorted
      BUFFFG(43) = 0
      BUFFFG(44) = 0
C                                       Close tables.
      CALL TABIO ('CLOS', 0, INXRNO, BUFFNX, BUFFNX, IRET)
      CALL TABIO ('CLOS', 0, IFGRNO, BUFFFG, BUFFFG, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1500 FORMAT ('Flagged ',F8.2,' min. of data in ',I5,' scans')
      END
      SUBROUTINE QUAKHI
C-----------------------------------------------------------------------
C   QUAKHI updates history file.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, LABEL*8, CTIME*8, CDATE*12
      INTEGER   LUN, IERR, I, DATE(3), TIME(3), IC1, IC2
      LOGICAL   T
      INCLUDE 'QUACK.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN, FVOL(NCFILE), FCNO(NCFILE), BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME, CDATE)
      WRITE (HILINE,1010) TSKNAM, RLSNAM, CDATE, CTIME
      CALL HIADD (LUN, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       OPCODE
      WRITE (HILINE,2000) TSKNAM, OPCODE
      CALL HIADD (LUN, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Sources
      IF (NID.LE.0) THEN
         WRITE (HILINE,3000) TSKNAM
         CALL HIADD (LUN, HILINE, BUFF1, IERR)
      ELSE
C                                       1st 2 and label.
         WRITE (HILINE,3003) TSKNAM, XSOUR(1), XSOUR(2)
         CALL HIADD (LUN, HILINE, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       Rest of sources
         IF (NID.GT.2) THEN
            DO 20 I = 3,NID,2
               WRITE (HILINE,3004) TSKNAM, XSOUR(I), XSOUR(I+1)
               CALL HIADD (LUN, HILINE, BUFF1, IERR)
               IF (IERR.NE.0) GO TO 200
 20            CONTINUE
            END IF
         END IF
C                                       TIMERANG
      CALL HITIME (TBEG, TEND, LUN, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       ANTENNAS
      IC1 = MIN (15, NANT)
      IC1 = MAX (1, IC1)
      IF (NANT.GE.0) THEN
         WRITE (HILINE,3005) TSKNAM, (ANTS(IC2), IC2=1,IC1)
         CALL HIADD (LUN, HILINE, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
      IF (NANT.GT.15) THEN
         IC1 = MIN (30, NANT)
         WRITE (HILINE,3006) TSKNAM, (ANTS(IC2), IC2=16,IC1)
         CALL HIADD (LUN, HILINE, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
      IF (NANT.GT.30) THEN
         IC1 = MIN (45, NANT)
         WRITE (HILINE,3006) TSKNAM, (ANTS(IC2), IC2=31,IC1)
         CALL HIADD (LUN, HILINE, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
      IF (NANT.GT.45) THEN
         IC1 = MIN (50, NANT)
         WRITE (HILINE,3006) TSKNAM, (ANTS(IC2), IC2=46,IC1)
         CALL HIADD (LUN, HILINE, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       Subarray
         WRITE (HILINE,2003) TSKNAM, SUBAR
         CALL HIADD (LUN, HILINE, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       FQ ID
         WRITE (HILINE,2008) TSKNAM, FRQSEL
         CALL HIADD (LUN, HILINE, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       FG version
         WRITE (HILINE,2004) TSKNAM, FGVER
         CALL HIADD (LUN, HILINE, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       REASON
         WRITE (HILINE,2005) TSKNAM, REASON
         CALL HIADD (LUN, HILINE, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       APARM
         IF (OPCODE.EQ.'END ') THEN
            WRITE (HILINE,2006) TSKNAM, APARM(1)
         ELSE IF (OPCODE.EQ.'BEG ') THEN
            WRITE (HILINE,2007) TSKNAM, APARM(2)
         ELSE IF (OPCODE.EQ.'ENDB') THEN
            WRITE (HILINE,2010) TSKNAM, APARM(2)
            END IF
         CALL HIADD (LUN, HILINE, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 200
C                                      Add any other history.
      IF (NUMHIS.LE.0) GO TO 200
         LABEL = TSKNAM // '  '
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN, HILINE, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
C                                       Close HI file
 200  CALL HICLOS (LUN, T, BUFF1, IERR)
C                                        Update CATBLK.
      CALL CATIO ('UPDT', FVOL(NCFILE), FCNO(NCFILE), CATBLK, 'REST',
     *   BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('QUAKHI: ERROR',I3,' OPENING HISTORY FILE')
 1010 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 2000 FORMAT (A6,' OPCODE =''',A4,'''')
 2003 FORMAT (A6,' SUBARRAY =',I4)
 2004 FORMAT (A6,' FGVER =',I4,' / FG table')
 2005 FORMAT (A6,' REASON = ''',A,''' / Reason for flagging')
 2006 FORMAT (A6,' APARM(1) =',F10.5,' / Good data at end of scan')
 2007 FORMAT (A6,' APARM(2) =',F10.5,' / Bad data at start of scan')
 2008 FORMAT (A6,' Freq. ID = ',I4)
 2010 FORMAT (A6,' APARM(2) =',F10.5,' / Bad data at end of scan')
 3000 FORMAT (A6,' SOURCES = '' '' / All sources')
 3003 FORMAT (A6,' SOURCES = ''',A16,''',''',A16,'''')
 3004 FORMAT (A6,'          ,''',A16,''',''',A16,'''')
 3005 FORMAT (A6, ' ANTENNAS = ',15(I2,','))
 3006 FORMAT (A6, '            ',15(I2,','))
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NPARMS
      PARAMETER (NPARMS=31)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'SOURCES',
     *   'QUAL', 'CALCODE', 'TIMERANG', 'SELBAND', 'SELFREQ', 'FREQID',
     *   'BIF', 'EIF', 'BCHAN', 'ECHAN', 'SUBARRAY', 'DOCALIB',
     *   'GAINUSE', 'DOPOL', 'PDVER', 'BLVER', 'FLAGVER', 'DOBAND',
     *   'BPVER', 'SMOOTH', 'UVRANGE', 'SOLINT', 'BPARM', 'DOCRT',
     *   'OUTPRINT', 'BADDISK'/
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOACAR,
     *   OOAINT, OOACAR, OOARE, OOARE, OOARE, OOAINT,
     *   OOAINT, OOAINT, OOAINT, OOAINT, OOAINT, OOARE,
     *   OOAINT, OOAINT, OOAINT, OOAINT, OOAINT, OOAINT,
     *   OOAINT, OOARE, OOARE, OOARE, OOARE, OOAINT,
     *   OOACAR, OOAINT/
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 16,30,
     *   1,1, 4,1, 8,1, 1,1, 1,1, 1,1,
     *   1,1, 1,1, 1,1, 1,1, 1,1, 1,1,
     *   1,1, 1,1, 1,1, 1,1, 1,1, 1,1,
     *   1,1, 3,1, 2,1, 1,1, 10,1, 1,1,
     *   48,1, 10,1/
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(10)
      LOGICAL   LDUM(10)
      REAL      RDUM(10)
      DOUBLE PRECISION DDUM(5)
      EQUIVALENCE (DDUM, RDUM, IDUM, LDUM)
      COMMON /RFIGFO/ DDUM
LOCAL END
      PROGRAM RFI
C-----------------------------------------------------------------------
C! Interference detector
C# Task OOP calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000, 2003-2004, 2006-2007, 2010, 2015,
C;  Copyright (C) 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Interference detector
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, UVMULT*32, PRINT*32, INPUT*32
      INTEGER  IRET, BUFF1(256)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'RFI '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL RFIIN (PRGM, INPUT, UVMULT, PRINT, IRET)
      IF (IRET.GT.0) GO TO 990
C                                       Check interference
      CALL RFIO (UVMULT, PRINT, IRET)
      IF (IRET.GT.0) GO TO 990
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE RFIIN (PRGN, INPUT, UVMULT, PRINT, IERR)
C-----------------------------------------------------------------------
C   RFIIN gets input parameters for RFI and creates the input uvdata
C   object.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      INPUT   C*?  Task inputs object
C      UVMULT  C*?  Input multisource uv data object.
C      PRINT   C*?  Print object
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER PRGN*6, INPUT*32, UVMULT*32, PRINT*32
      INTEGER   IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INTEGER   NKEY, NKEY2
C                                       NKEY=no. adverbs to copy to
C                                       UVMULT
      PARAMETER (NKEY=25)
C                                       NKEY2=no. adverbs for PRINT
      PARAMETER (NKEY2=2)
      INTEGER   DIM(7), TYPE, FGVER
      REAL      BPARM(10), SOLINT, XDOCAL
      CHARACTER INK(NKEY)*8, OUTK(NKEY)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32, FGTAB*32, STOKES*4, CDUMMY*1
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs for UVMULT
      DATA INK /'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
     *   'GAINUSE', 'DOPOL', 'BLVER', 'DOBAND', 'BPVER',
     *   'FLAGVER',  'TIMERANG', 'UVRANGE', 'SOURCES', 'QUAL',
     *   'SELBAND', 'SELFREQ', 'FREQID', 'CALCODE', 'SUBARRAY',
     *   'BIF', 'EIF', 'BCHAN', 'ECHAN', 'SMOOTH', 'PDVER'/
      DATA OUTK /'NAME', 'CLASS', 'IMSEQ', 'DISK',
     *   'CALEDIT.CLUSE', 'CALEDIT.DOPOL', 'CALEDIT.BLVER',
     *   'CALEDIT.FGVER', 'CALEDIT.DOBAND', 'CALEDIT.BPVER',
     *   'CALEDIT.TIMRNG', 'CALEDIT.UVRNG', 'CALEDIT.SOURCS',
     *   'CALEDIT.SELQUA', 'CALEDIT.SELBAN', 'CALEDIT.SELFRQ',
     *   'CALEDIT.FRQSEL', 'CALEDIT.SELCOD', 'CALEDIT.SUBARR',
     *   'CALEDIT.BIF', 'CALEDIT.EIF', 'CALEDIT.BCHAN', 'CALEDIT.ECHAN',
     *   'CALEDIT.SMOOTH', 'CALEDIT.PDVER'/
C                                       Adverbs for PRINT
      DATA INK2  /'DOCRT', 'OUTPRINT'/
      DATA OUTK2 /'DOCRT', 'LPFILE'/
C-----------------------------------------------------------------------
C                                       Startup
      INPUT = 'Input'
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, INPUT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       BADDISK
      CALL OGET (INPUT, 'BADDISK', TYPE, DIM, IBAD, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Create UVMULT
      UVMULT = 'Input UVdata'
      CALL CREATE (UVMULT, 'UVDATA', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ (INPUT, NKEY, INK, OUTK, UVMULT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       DOCALIB
      CALL OGET ('Input', 'DOCALIB', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      XDOCAL = RDUM(1)
      DIM(1) = 1
      DIM(2) = 1
      LDUM(1) = XDOCAL.GT.0.0
      CALL OPUT (UVMULT, 'CALEDIT.DOCAL', OOALOG, DIM, IDUM, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
      LDUM(1) = (XDOCAL.GT.0.0) .AND. (XDOCAL.LE.99.0)
      CALL OPUT (UVMULT, 'CALEDIT.DOWTCL', OOALOG, DIM, IDUM, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Select all Stokes'
      STOKES = '    '
      DIM(1) = LEN (STOKES)
      DIM(2) = 1
      CALL OPUT (UVMULT, 'CALEDIT.STOKES', OOACAR, DIM, IDUM, STOKES,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open UVMULT to be sure it's OK.
      CALL OOPEN (UVMULT, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OCLOSE (UVMULT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Check defaults
C                                       Digest BPARM
      CALL OGET (INPUT, 'BPARM', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, BPARM)
C                                       MAXBAD (0.25)
      IF (ABS (BPARM(1)).LE.1.0E-20) BPARM(1) = 0.25
C                                       Save defaults in BPARM
      CALL RCOPY (10, BPARM, RDUM)
      CALL OPUT (INPUT, 'BPARM', OOARE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Save on UVMULT
      DIM(1) = 1
      DIM(2) = 1
      RDUM(1) = BPARM(1)
      CALL OPUT (UVMULT, 'MAXBAD', OOARE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      DIM(1) = 2
      RDUM(1) = BPARM(2)
      RDUM(2) = BPARM(3)
      CALL OPUT (UVMULT, 'MAXRMS', OOARE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Default FLAGVER
      CALL OGET (INPUT, 'FLAGVER', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      FGVER = IDUM(1)
C                                       Find highest FG table.
      IF (FGVER.LE.0.0) THEN
         FGTAB = 'Temporary FG table for RFIIN'
         FGVER = 1
         CALL UV2TAB (UVMULT, FGTAB, 'FG', FGVER, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL TBLHIV (FGTAB, FGVER, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL TABDES (FGTAB, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
      IDUM(1) = FGVER
      CALL OPUT (INPUT, 'FLAGVER', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OPUT (UVMULT, 'CALEDIT.FGVER', OOAINT, DIM, IDUM, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Default SOLINT (60 sec)
      CALL OGET (INPUT, 'SOLINT', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      SOLINT = RDUM(1)
      IF (SOLINT.LE.0.0) SOLINT = 60.0
      RDUM(1) = SOLINT
      CALL OPUT (INPUT, 'SOLINT', OOARE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OPUT (UVMULT, 'TIMEAVG', OOARE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Printer object
      PRINT = 'Printer object'
      CALL PRTCRE (PRINT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ (INPUT, NKEY2, INK2, OUTK2, PRINT, IERR)
      IF (IERR.NE.0) GO TO 999
      DIM(1) = LEN (UVMULT)
      DIM(2) = 1
      CALL PRTPUT (PRINT, 'PRINTOBJ', OOACAR, DIM, IDUM, UVMULT, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE RFIO (UVMULT, PRINT, IERR)
C-----------------------------------------------------------------------
C   Process data.
C   Inputs:
C      UVMULT  C*?  Input multisource uv object
C      PRINT   C*?  Print object
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER UVMULT*(*), PRINT*(*)
      INTEGER   IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Interference detection.
      CALL RFIRMS (UVMULT, PRINT, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR FINDING RFI IN ' //UVMULT
      CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE RFIRMS (UVIN, PRINT, IERR)
C-----------------------------------------------------------------------
C   Look for interference based on a high real or imaginary rms in time
C   interval TIMEAVG.
C      Currently this routine is configured to do up to 28 antennas and
C   8 correlations, i.e. standard VLA continuum data.
C   Inputs:
C      UVIN    C*?  Name of input uvdata object.
C      PRINT   C*?  Print object
C   Inputs attached to UVIN:
C      MAXRMS  R(2) Maximum RMS allowed, constant plus amplitude
C                   coefficient.
C      MAXBAD  R    Maximum allowed fraction of bad baselines.
C      TIMEAVG R    Time in seconds for clipping interval
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER UVIN*(*), PRINT*(*)
      INTEGER   IERR
C
      REAL      MAXRMS(2), MAXBAD, TCLIP
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXXA, MAXXBL, MAXXCR
C                                       Number (max) of Antennas.
      PARAMETER (MAXXA = MAXANT)
      PARAMETER (MAXXBL = MXBASE)
      PARAMETER (MAXXCR = 8)
      INTEGER   COUNT, TYPE, DIM(7), I, J, NCORR, INDXT, INDXB, INDXSU,
     *   ANT1, ANT2, BLINDX, BLOFF(MAXXA), CNTBAS, NWORD, OKCNT, DUMMY,
     *   ENDVIS, VISNO, BCORNO, CURSOU, THISOU, TBVER, DOCRT, NACROS,
     *   QUAL, BEGT(4), ENDT(4), MSGSAV, INDXA1, INDXA2
      LOGICAL   BADCOR(MAXXCR),  DONE, DOSOU, QUIT, DOCAL
      CHARACTER SUTAB*32, SUNAME*16, LINE*132, CDUMMY*1, UVTYPE*2
      REAL      ACC(6,MAXXCR,MAXXBL), AMP2, RMS1, RMS2, RP(50),
     *   VS(3,MAXXCR), MXRMS2, MXAMP2, CORCNT(MAXXCR), CORBAD(MAXXCR),
     *   CURTIM, LSTIME, WORST, CORSUM(MAXXCR), ENDTIM, BEGTIM
      LOGICAL   FLGBAS, ISBAD, BADRFI
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Open printer
      CALL OOPEN (PRINT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OGET (PRINT, 'DOCRT', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      DOCRT = IDUM(1)
      CALL OGET (PRINT, 'NACROS', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      NACROS = IDUM(1)
C                                       Open input.
      CALL OUVOPN (UVIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Get parameters
      CALL OUVGET (UVIN, 'MAXBAD', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      MAXBAD = RDUM(1)
      CALL OUVGET (UVIN, 'MAXRMS', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL RCOPY (2, RDUM, MAXRMS)
      MXRMS2 = MAXRMS(1) * MAXRMS(1)
      MXAMP2 = MAXRMS(2) * MAXRMS(2)
      CALL OUVGET (UVIN, 'TIMEAVG', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      TCLIP = RDUM(1)
      TCLIP = TCLIP / 86400.0
C                                       Processing info
      CALL OUVGET (UVIN, 'CALEDIT.DOCAL', TYPE, DIM, IDUM, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 990
      DOCAL = LDUM(1)
      IF (DOCAL) THEN
         LINE = 'Calibration applied'
      ELSE
         LINE = 'NO Calibration applied'
         END IF
      CALL PRTWRI (PRINT, LINE, QUIT, IERR)
      IF (IERR.NE.0) GO TO 990
      WRITE (LINE,1001) MAXBAD, MAXRMS
      CALL PRTWRI (PRINT, LINE, QUIT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Page labels
      LINE = 'Data affected by interference'
      DIM(1) = LEN (LINE)
      DIM(2) = 1
      CALL OPUT (PRINT, 'TITLE1', OOACAR, DIM, IDUM, LINE, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL PRTWRI (PRINT, LINE, QUIT, IERR)
      IF (QUIT) GO TO 700
      IF (IERR.NE.0) GO TO 990
      LINE = 'Source           Qual         Time range        ' //
     *   ' Corr flags   Maxrms(c)'
      CALL OPUT (PRINT, 'TITLE2', OOACAR, DIM, IDUM, LINE, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL PRTWRI (PRINT, LINE, QUIT, IERR)
      IF (QUIT) GO TO 700
      IF (IERR.NE.0) GO TO 990
C                                       Need baseline RP
      CALL UVDGET (UVIN, 'TYPEUVD', TYPE, DIM, IDUM, UVTYPE, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (UVTYPE(:1).EQ.'S') THEN
         CALL UVDFND (UVIN, 1, 'BEAM', INDXB, IERR)
      ELSE
         CALL UVDFND (UVIN, 1, 'BASELINE', INDXB, IERR)
         IF (IERR.NE.0) THEN
            INDXB = -1
            CALL UVDFND (UVIN, 1, 'ANTENNA1', INDXA1, IERR)
            IF (IERR.EQ.0) CALL UVDFND (UVIN, 1, 'ANTENNA2', INDXA2,
     *         IERR)
            END IF
         END IF
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE FINDING RANDOM PARAMETER BEAM/BASELINE'
         GO TO 990
         END IF
C                                       Need TIME RP
      CALL UVDFND (UVIN, 1, 'TIME1', INDXT, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE FINDING RANDOM PARAMETER TIME'
         GO TO 990
         END IF
C                                       Need SOURCE RP
C                                       May not be there
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL UVDFND (UVIN, 1, 'SOURCE', INDXSU, IERR)
      MSGSUP = MSGSAV
      DOSOU = (IERR.EQ.0) .AND. (INDXSU.GT.0)
      IERR = 0
C                                       Source table/name
      IF (DOSOU) THEN
         SUTAB = 'SoUrce table for RFIRMS'
         TBVER = 1
         CALL UV2TAB (UVIN, SUTAB, 'SU', TBVER, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       For single source use 'OBJECT'
      ELSE
         SUNAME = ' '
         CALL UVDGET (UVIN, 'OBJECT', TYPE, DIM, IDUM, SUNAME, IERR)
         IF (IERR.NE.0) GO TO 990
         QUAL = 0
         END IF
C                                       Number of correlators
      CALL UVDGET (UVIN, 'NCORR', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 985
      NCORR = IDUM(1)
C                                       Make sure it fits
      IF (NCORR.GT.MAXXCR) THEN
         WRITE (MSGTXT,1000) NCORR, MAXXCR
         IERR = 2
         GO TO 985
         END IF
C                                       Clear accumulators:
C                                       (1,*) =  count
C                                       (2,*) =  sum r then max rms**2
C                                       (3,*) =  sum**2 r then rms**2
C                                       (4,*) =  sum imaginary
C                                       (5,*) =  sum**2 imaginary
C                                       (6,*) =  sum amplitude
      NWORD = 6 * MAXXCR * MAXXBL
      CALL RFILL (NWORD, 0.0, ACC)
      CALL RFILL (NCORR, 0.0, CORCNT)
      CALL RFILL (NCORR, 0.0, CORBAD)
      CALL RFILL (NCORR, 0.0, CORSUM)
      DO 10 I = 1,NCORR
         BADCOR(I) = .FALSE.
 10      CONTINUE
C                                       Fill baseline index array
      COUNT = 1
      DO 50 I = 1,MAXXA
         BLOFF(I) = COUNT
         COUNT = COUNT + MAXXA - I + 1
 50      CONTINUE
C                                       Initialize visibility count
      COUNT = 0
      OKCNT = 0
      CNTBAS = 0
      DONE = .FALSE.
      VISNO = 0
      WORST = 0.0
C                                       Swallow input collecting
C                                       statistics.
C                                       Loop thru data
 100     CALL UVREAD (UVIN, RP, VS, IERR)
         IF (IERR.LT.0) THEN
            DONE = .TRUE.
            IERR = 0
            END IF
         IF (IERR.GT.0) GO TO 990
         VISNO = VISNO + 1
 110     CURTIM = RP(INDXT)
         IF (DOSOU) THEN
            CURSOU = RP(INDXSU) + 0.5
         ELSE
            CURSOU = 0
            END IF
C                                       Initial selection.
         IF (VISNO.EQ.1) THEN
            THISOU = CURSOU
            BEGTIM = CURTIM
            ENDTIM = CURTIM + TCLIP
            END IF
C                                       Finished with data or interval?
         IF (DONE .OR. (CURTIM.GT.ENDTIM) .OR. (CURSOU.NE.THISOU))
     *      GO TO 150
C                                       Set last vis of interval
         ENDVIS = VISNO
C                                       Set last time
         LSTIME = CURTIM
C                                       Get antenna numbers
         IF (INDXB.GT.0) THEN
            ANT1 = (RP(INDXB) / 256.0) + 0.001
            ANT2 = (RP(INDXB) - ANT1 * 256) + 0.001
         ELSE
            ANT1 = RP(INDXA1) + 0.1
            ANT2 = RP(INDXA2) + 0.1
            END IF
C                                       Baseline index
         BLINDX = BLOFF(ANT1) + ANT2 - ANT1
         DO 120 I = 1,NCORR
            IF (VS(3,I).GT.0) THEN
               ACC(1,I,BLINDX) = ACC(1,I,BLINDX) + 1.0
               ACC(2,I,BLINDX) = ACC(2,I,BLINDX) + ABS (VS(1,I))
               ACC(3,I,BLINDX) = ACC(3,I,BLINDX) + VS(1,I) * VS(1,I)
               IF (ANT1.NE.ANT2) THEN
                  ACC(4,I,BLINDX) = ACC(4,I,BLINDX) + ABS (VS(2,I))
                  ACC(5,I,BLINDX) = ACC(5,I,BLINDX) + VS(2,I) * VS(2,I)
                  ACC(6,I,BLINDX) = ACC(6,I,BLINDX) + SQRT
     *               (VS(1,I)*VS(1,I) + VS(2,I) * VS(2,I))
               ELSE
                  ACC(6,I,BLINDX) = ACC(6,I,BLINDX) + ABS (VS(1,I))
                  END IF
               END IF
 120        CONTINUE
C                                       Next vis until done
         IF (.NOT.DONE) GO TO 100
 150     IERR = 0
C                                       Get statistics
      DO 200 I = 1,MAXXBL
         FLGBAS = .FALSE.
         DO 190 J = 1,NCORR
            IF (ACC(1,J,I).GT.1.1) THEN
C                                       Real part
               RMS1 = (ACC(3,J,I) - ((ACC(2,J,I)**2) / ACC(1,J,I))) /
     *            (ACC(1,J,I) - 1.0)
               ACC(3,J,I) = RMS1
C                                       Convert sum to maximum rms**2
               AMP2 = (ACC(6,J,I) / ACC(1,J,I)) ** 2
               ACC(2,J,I) = MXRMS2 + (MXAMP2*AMP2)
C                                       Is this one bad?
               ISBAD = RMS1.GT.ACC(2,J,I)
C                                       Imaginary part
               RMS2 = (ACC(5,J,I) - ((ACC(4,J,I)**2) / ACC(1,J,I))) /
     *            (ACC(1,J,I) - 1.0)
C                                       Is this one bad?
               ISBAD = ISBAD .OR. (RMS2.GT.ACC(2,J,I))
               FLGBAS = FLGBAS .OR. ISBAD
C                                       Correlator info
               CORCNT(J) = CORCNT(J) + 1.0
               IF (ISBAD) THEN
                  CORBAD(J)= CORBAD(J) + 1.0
                  CORSUM(J)= CORSUM(J) + RMS2 + RMS1
                  END IF
               END IF
 190        CONTINUE
         IF (FLGBAS) CNTBAS = CNTBAS + 1
 200     CONTINUE
C                                       Check for bad correlators
      BADRFI = .FALSE.
      DO 210 I = 1,NCORR
         IF (CORCNT(I).GT.1.1) THEN
C                                       Kill correlator
            IF ((CORBAD(I)/CORCNT(I)).GT.MAXBAD) THEN
               BADCOR(I) = .TRUE.
               BADRFI = .TRUE.
               END IF
            IF (BADCOR(I)) THEN
               RMS2 = CORSUM(I) / CORBAD(I)
               IF (WORST.LT.RMS2) THEN
                  WORST = RMS2
                  BCORNO = I
                  END IF
               END IF
            END IF
 210     CONTINUE
C                                       If bad tell about it
      IF (BADRFI) THEN
C                                       Get source name, qualifier
         IF (DOSOU) THEN
            CALL SOUNFO (SUTAB, THISOU, 'SOURCE', TYPE, DIM, DUMMY,
     *         SUNAME, IERR)
            IF (IERR.NE.0) GO TO 990
            CALL SOUNFO (SUTAB, THISOU, 'QUAL', TYPE, DIM, QUAL,
     *         CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
         CALL TODHMS (BEGTIM, BEGT)
         CALL TODHMS (LSTIME, ENDT)
         IF (WORST.GT.1.0E-10) WORST = SQRT (WORST)
         WRITE (LINE,1210) SUNAME, QUAL, BEGT, ENDT,
     *      (BADCOR(I), I = 1,8), WORST, BCORNO
         IF (NCORR.LT.8) LINE(51+NCORR:58) = ' '
         CALL PRTWRI (PRINT, LINE, QUIT, IERR)
         IF (QUIT) GO TO 700
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       Clear accumulators:
      NWORD = 6 * MAXXCR * MAXXBL
      CALL RFILL (NWORD, 0.0, ACC)
      CALL RFILL (NCORR, 0.0, CORCNT)
      CALL RFILL (NCORR, 0.0, CORBAD)
      CALL RFILL (NCORR, 0.0, CORSUM)
      DO 220 I = 1,NCORR
         BADCOR(I) = .FALSE.
 220     CONTINUE
C                                       Another clipping interval?
      IF (.NOT.DONE) THEN
         THISOU = CURSOU
         BEGTIM = CURTIM
         ENDTIM = CURTIM + TCLIP
         WORST = 0.0
         GO TO 110
         END IF
C                                       Close file
 700  CALL OUVCLO (UVIN, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Close printer
      CALL OCLOSE (PRINT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Delete temporary table
      CALL DESTRY (SUTAB, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 985  CALL MSGWRT (7)
 990  MSGTXT = 'RFIRMS: ERROR IN RFI DETECTION FOR ' // UVIN
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RFIRMS: ERROR, NO. CORRELATORS = ',I4, ' > ', I4)
 1001 FORMAT ('Max. fract. bad baselines= ',F5.3,', Clipping coef.=',
     *   2F8.5)
 1210 FORMAT (A,':',I5.5,I3,'/',2(I2.2,':'),I2.2,' -',I3,'/',
     *   2(I2.2,':'),I2.2,2X,8L1,F10.5,'(',I1,')')
      END

LOCAL INCLUDE 'BLCAL.INC'
C                                                         Include BLCAL
C                                       Local include for BLCAL
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   CATIN(256), SEQIN, SEQ2, DISKIN, DISK2, CNOIN, CNOIN2,
     *   CCTVER, VISDSK, VISCNO, BLVERO, KOLSBL(MAXBLC), NUMVBL(MAXBLC),
     *   LUNBL, JBUFSZ, NCOMP(MAXFLD), IRNOBL, CHNSEL(3,20,MAXIF)
      LOGICAL   SINGLE, DOMODL, BLOPEN
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAME2(3), XCLAS2(2),
     *   XXSOUR(4,30), XMETH(1), XCMOD(1)
      CHARACTER NAMEIN*12, CLAIN*6, NAME2*12, CLAS2*6, XSOUR(30)*16,
     *   CMETH*4, CMOD*4
      REAL   XSI, XDI, XBLV, XTIME(8), XBAND, XFREQ, XFQID, XANTS(50),
     *   XSUBA, XFLAG, XDOCAL, XGUSE, XDOPOL, XPDVER, XDOBND, XBPVER,
     *   XSMOTH(3), XS2, XD2, XVER, XNCOMP(MAXAFL), XFLUX, XNMAP,
     *   XSMOD(7), XSOLIN, XCHNS(4,20), BPARM(10), XBADD(10),
     *   BUFF1(UVBFSS), BUFF2(UVBFSS)
      COMMON /CINFO/ NCOMP, IRNOBL, SINGLE, DOMODL, BLOPEN, CATIN,
     *   CNOIN, CNOIN2, CCTVER, VISDSK, VISCNO, BLVERO, KOLSBL, NUMVBL,
     *   LUNBL, DISKIN, DISK2, SEQIN, SEQ2, CHNSEL
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
      COMMON /XINPUT/ XNAMEI, XCLAIN, XSI, XDI, XBLV, XXSOUR, XTIME,
     *   XBAND, XFREQ, XFQID, XANTS, XSUBA, XFLAG, XDOCAL, XGUSE,
     *   XDOPOL, XPDVER, XDOBND, XBPVER, XSMOTH, XNAME2, XCLAS2, XS2,
     *   XD2, XVER, XNCOMP, XFLUX, XNMAP, XMETH, XCMOD, XSMOD, XSOLIN,
     *   XCHNS, BPARM, XBADD
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAME2, CLAS2, XSOUR, CMETH, CMOD
C                                                          End BLCAL
LOCAL END
      PROGRAM BLCAL
C-----------------------------------------------------------------------
C! Determines correlator based offsets given a model of the source.
C# UV Calibration AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2000, 2003-2004, 2006-2010, 2012, 2015-2016,
C;  Copyright (C) 2019, 2021-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BLCAL computes baseline dependent correction and writes them into
C   an BL table.  BLCAL divides the specified data by a given model
C   and averages the data for a specified time to determine the
C   corrections.  At present only multiplicative errors are corrected.
C     The object is to read a file containing
C   data from a strong point source (or data divided by model) and
C   averaged over time (eg one visrec from each baseline).  That
C   data will be written in BL table file.
C   Adapted from FUDGE.  Nov. 28 1983  R.C.Walker
C   Averages and statistics added.  18 Apr. 1985   RCW
C   Converted to BLCAL Jan. 1987, W. D. Cotton.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, MAXANS, MAXIFS, NEED, TNEED, IWORK(2)
      LONGINT   BPT, DBPT
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'BLCAL.INC'
      REAL      WORK(2)
      DOUBLE PRECISION DWORK(2)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DGDS.INC'
      EQUIVALENCE (WORK, DWORK)
      DATA PRGM /'BLCAL '/
C-----------------------------------------------------------------------
C                                       Release AP memory
      CALL QRLSE
C                                       Get input parameters and
C                                       create output file if nec.
      CALL BLCIN (PRGM, MAXANS, MAXIFS, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       get dynamic memory
      NEED = MAXIFS * MAXANS * MAXANS
      TNEED = (10 * NEED - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', TSKNAM, TNEED, WORK, BPT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'FAILED TO ALLOCATED NEEDED MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       Select data.
      CALL BLCSEL (IRET)
      IF (IRET.NE.0) GO TO 980
C                                       Divide data by model if nec.
      IF (DOMODL) THEN
         CALL BLCMOD (IRET)
         IF (IRET.NE.0) GO TO 980
         END IF
C                                       Average data and write BL table
      DBPT = BPT / 2
      CALL BLCUV (MAXANS, MAXIFS, DWORK(DBPT+1), DWORK(DBPT+1+NEED),
     *   DWORK(DBPT+1+2*NEED), DWORK(DBPT+1+3*NEED), WORK(BPT+1+8*NEED),
     *   IWORK(BPT+1+9*NEED), IRET)
      IF (IRET.NE.0) GO TO 980
C                                       History
      CALL BLCHIS
C                                       free memory
 980  CALL ZMEMRY ('FREE', TSKNAM, TNEED, WORK, BPT, IRET)
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE BLCIN (PRGN, MAXANS, MAXIFS, IRET)
C-----------------------------------------------------------------------
C   BLCIN gets input parameters for BLCAL and creates an output file
C   if necessary.
C   Inputs:  PRGN    H(2)      Program name (4 chars/word)
C   Output:  MAXANS  I         Maximum antenna number in data.
C            MAXIFS  I         Maximum number of IFs.
C            IRET    I         Error code: 0 => ok
C                                1 => too few frequency channels.
C                                5 => catalog troubles
C                                7 => Too many ant. for ls.
C                                8 => cannot start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in BLCAL for more details.
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   MAXANS, MAXIFS, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IERR, NPARM, I, MXFLD, NUMSUB, IROUND, LUN1, NUMAN(513),
     *   LUN, NW(MAXIF), J, K, K1, K2
      LOGICAL   T, TABLE, EXIST, FITASC, MATCH
      REAL      CATR(128), CATINR(128)
      CHARACTER STAT*4, UTYPE*2
      HOLLERITH CATH(256)
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'BLCAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (NUMAN, BUFF2)
      EQUIVALENCE (CATBLK, CATR, CATH)
      EQUIVALENCE (CATIN, CATINR)
      DATA LUN1/28/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS  * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
      NSOUWD = 1
C                                       Get input parameters.
      MXFLD = MAXAFL
      NPARM = 240 + MXFLD + 80
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSI)
      SEQ2 = IROUND (XS2)
      DISKIN = IROUND (XDI)
      DISK2 = IROUND (XD2)
      CCTVER = IROUND (XVER)
      CCTVER = MAX (0, CCTVER)
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAME2, NAME2)
      CALL H2CHR (6, 1, XCLAS2, CLAS2)
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
 10      CONTINUE
C                                       Get CATBLK from old file.
      CNOIN = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'REST', BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1050) IRET
         GO TO 990
         END IF
C                                       Save Input file info
      VISDSK = DISKIN
      VISCNO = CNOIN
C                                       Get uv header info.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       BADDISK
      DO 15 I = 1,10
         IBAD(I) = IROUND (XBADD(I))
 15      CONTINUE
C                                       Check sort order, must be T*
      IF (ISORT(1:1).NE.'T') THEN
         IRET = 4
         WRITE (MSGTXT,1070) ISORT, 'T*'
         GO TO 990
         END IF
C                                       Save input header.
      CALL COPY (256, CATBLK, CATIN)
C                                       See if a multiple source file
      LUNS(1) = 29
      CALL ISTAB ('SU', DISKIN, CNOIN, 1, LUNS, BUFF1, TABLE, EXIST,
     *   FITASC, IERR)
      SINGLE = (.NOT.EXIST) .OR. (IERR.NE.0) .OR. (ILOCSU.LT.0)
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DO 20 I = 1,30
         SOURCS(I) = XSOUR(I)
 20      CONTINUE
      CALL RCOPY (8, XTIME, TIMRNG)
      DXTIME = 0.0
      BCHAN = 1
      ECHAN = CATBLK(KINAX+JLOCF)
      BIF = 1
      EIF = 1
      IF ((JLOCIF.GE.0)) EIF = CATBLK(KINAX+JLOCIF)
C                                       Channel selection
      I = 60 * MAXIF
      CALL FILL (I, 0, CHNSEL)
      CALL FILL (MAXIF, 0, NW)
      DO 40 J = 1,20
         K = IROUND (XCHNS(2,J))
         IF (K.GT.0) THEN
            K = IROUND (XCHNS(4,J))
            IF ((K.LE.0) .OR. (K.GT.MAXIF)) THEN
               K1 = 1
               K2 = MAXIF
            ELSE
               K1 = K
               K2 = K
               END IF
            DO 35 K = K1,K2
               NW(K) = NW(K) + 1
               DO 30 I = 1,3
                  CHNSEL(I,NW(K),K) = IROUND (XCHNS(I,J))
                  IF (CHNSEL(I,NW(K),K).LT.0) CHNSEL(I,NW(K),K) = 0
 30               CONTINUE
               IF (CHNSEL(3,NW(K),K).EQ.0) CHNSEL(3,NW(K),K) = 1
 35            CONTINUE
            END IF
 40      CONTINUE
C                                       If no channel selection
C                                       use VLA definition of
C                                       channel 0
      DO 50 K = 1,MAXIF
         IF (NW(K).LE.0) THEN
            NW(K) = 1
            CHNSEL(1,1,K) = (ECHAN+1)/8 + 1
            CHNSEL(2,1,K) = ECHAN - ((ECHAN+1)/8)
            CHNSEL(3,1,K) = 1
            END IF
         DO 45 I = 1,NW(K)
            CHNSEL(1,I,K) = MAX (1, MIN (CHNSEL(1,I,K), ECHAN))
            IF (CHNSEL(2,I,K).LT.CHNSEL(1,I,K))
     *         CHNSEL(2,I,K) = ECHAN
            CHNSEL(2,I,K) = MAX (1, MIN (CHNSEL(2,I,K), ECHAN))
 45         CONTINUE
 50      CONTINUE
C                                       Antennas
      DO 85 I = 1,50
         ANTENS(I) = IROUND (XANTS(I))
 85      CONTINUE
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOPOL = IROUND (XDOPOL)
      IF ((DOPOL.EQ.0) .AND. (XDOPOL.GT.0.0)) DOPOL = 1
      PDVER = IROUND (XPDVER)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
C                                       Smoothing type
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LE.0) SUBARR = 1
      FGVER = IROUND (XFLAG)
      CLVER = 0
      CLUSE = IROUND (XGUSE)
      BLVERO = IROUND (XBLV)
      BLVER = -1
C                                       See if do divide by model
      DOMODL = BPARM(1) .LE. 0.5
C                                       Default averaging time
      XSOLIN = XSOLIN / (24.0 * 60.0)
      IF (XSOLIN.LE.1.0E-20) XSOLIN = 1.0E10
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, IRET)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         IRET = 1
         GO TO 990
         END IF
      IF (IRET.GT.0) GO TO 999
C                                       Find number of subarrays
      CALL FNDEXT ('AN', CATBLK, NUMSUB)
      NUMSUB = MAX (1, NUMSUB)
      IF (NUMSUB.LT.SUBARR) THEN
         WRITE (MSGTXT,1160) SUBARR, NUMSUB
         GO TO 990
         END IF
C                                       Find number of antennas.
      CALL GETNAN (DISKIN, CNOIN, CATBLK, LUN1, BUFF1, NUMAN, IRET)
      IF (IRET.NE.0) GO TO 999
      NUMANT = NUMAN(2)
      IF (SUBARR.LE.NUMAN(1)) NUMANT = NUMAN(1+SUBARR)
      MAXANS = NUMANT
C                                       Number of IFs
      NUMIF = 1
      IF (JLOCIF.GE.0) NUMIF = CATBLK(KINAX+JLOCIF)
      MAXIFS = NUMIF
C                                       Number of polarizations
      NUMPOL = 1
      IF (CATBLK(KINAX+JLOCS).GT.1) NUMPOL = 2
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BLCIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,' . ',A6,' . ',
     *   I3,' DISK=',I3,' USID=',I4)
 1050 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1070 FORMAT ('SORT ORDER IS ',A2,' NOT ',A2,' AS REQUIRED')
 1160 FORMAT ('SPECIFIED SUBARRAY ',I4,' > MAX. OF ',I4)
      END
      SUBROUTINE BLCUV (MAXANS, MAXIFS, SUMP1, SUMP2, SUM2P1, SUM2P2,
     *   SWT, COUNT, IRET)
C-----------------------------------------------------------------------
C   BLCUV averages data and writes the BL table.
C   Input:
C      MAXANS   I      Number of antennas (array dimension)
C      MAXIFS   I      Number of IFs (array dimension)
C   Output:
C      SUMP1    D(*)   Work array. Sums for polarization 1
C                      (IF,ant1,ant2) two halves for real and imag.
C      SUMP2    D(*)   Work array. Sums for polarization 2
C      SUM2P1   D(*)   Work array. Sums**2 for polarization 1
C      SUM2P1   D(*)   Work array. Sums**2 for polarization 2
C      COUNT    I(*)   Work array. counts
C      IRET     I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   MAXANS, MAXIFS, IRET
      DOUBLE PRECISION SUMP1(MAXIFS,MAXANS,MAXANS),
     *   SUMP2(MAXIFS,MAXANS,MAXANS),
     *   SUM2P1(MAXIFS,MAXANS,MAXANS), SUM2P2(MAXIFS,MAXANS,MAXANS)
      REAL      SWT(MAXIFS,MAXANS,MAXANS)
      INTEGER   COUNT(MAXIFS,MAXANS,MAXANS)
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER TYPE*2, IFILE*48
      INTEGER   INIO, IPTRI, LUNI, NFREQ, INDEX, IOFF, INDI, IDSOU,
     *   ILENBU, IBIND, I, IA1, IA2, LPIF, LPFRQ, VDSK, VCNO, BO, VO,
     *   NUMVIS, XCOUNT, NUGOOD, II
      REAL      TMSRT, TIMEND, VISRE, VISIM, WT, CHFLGS(MAXCIF)
      LOGICAL   T, F
      INCLUDE 'BLCAL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNI /16/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      BLOPEN = F
      CALL CHWANT (ECHAN, MAXIFS, CHNSEL, CHFLGS)
C                                       Initialize arrays.
      NUGOOD = 0
      DO 30 IA2 = 1,MAXANS
         DO 20 IA1 = 1,MAXANS
            DO 10 I = 1,MAXIFS
               SUMP1(I,IA1,IA2) = 0.0D0
               SUMP2(I,IA1,IA2) = 0.0D0
               SUM2P1(I,IA1,IA2) = 0.0D0
               SUM2P2(I,IA1,IA2) = 0.0D0
               SWT(I,IA1,IA2) = 0.0
               COUNT(I,IA1,IA2) = 0
 10            CONTINUE
 20         CONTINUE
 30      CONTINUE
      NFREQ = CATBLK(KINAX+JLOCF)
C                                       Init. Source ID number
      IDSOU = 0
      IF (.NOT.SINGLE) IDSOU = SOUWAN(1)
C                                       Open and init for read
C                                       visibility file
      TYPE = 'UV'
      VDSK = VISDSK
      VCNO = VISCNO
      IF (VISDSK.LE.0) THEN
         VDSK = SCRVOL(VISCNO)
         VCNO = SCRCNO(VISCNO)
         TYPE = 'SC'
         END IF
      CALL ZPHFIL (TYPE, VDSK, VCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, VDSK, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 999
         END IF
C                                       Init vis file for write
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       Loop
C                                       Read vis. record.
 100     CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
         IF (INIO.LE.0) GO TO 200
C                                       Set initial time range.
         IF (NUMVIS.EQ.0) TMSRT = BUFF1(IPTRI+ILOCT)
         IF (NUMVIS.EQ.0) TIMEND = BUFF1(IPTRI+ILOCT) + XSOLIN
         DO 190 I = 1,INIO
            IF (ILOCB.GE.0) THEN
               IA1 = BUFF1(IPTRI+ILOCB) / 256. + 0.1
               IA2 = BUFF1(IPTRI+ILOCB) - IA1*256. + 0.1
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               END IF
            IF ((.NOT.SINGLE) .AND. (NSOUWD.GT.1)) IDSOU =
     *         BUFF1(IPTRI+ILOCSU) + 0.1
            NUMVIS = NUMVIS + 1
C                                       Check if through with average.
            IF ((BUFF1(IPTRI+ILOCT) .GT. TIMEND) .AND. (NUGOOD.GT.0))
     *         THEN
               CALL BLCOUT (IDSOU, TMSRT, TIMEND, MAXANS, MAXIFS,
     *            SUMP1, SUMP2, SUM2P1, SUM2P2, SWT, COUNT, IRET)
               IF (IRET.NE.0) GO TO 999
               NUGOOD = 0
C                                       Reset times if necessary
               IF (BUFF1(IPTRI+ILOCT) .GT. TIMEND) THEN
                  TMSRT = BUFF1(IPTRI+ILOCT)
                  TIMEND = TMSRT + XSOLIN
                  END IF
               END IF
C                                       Sum data
            NUGOOD = NUGOOD + 1
C                                       Loop over IF
            II = 0
            DO 140 LPIF = 1,NUMIF
               IOFF = IPTRI + NRPARM + (LPIF-1) * INCIF
C                                       Sum frequencies
               DO 130 LPFRQ = 1,NFREQ
                  II = II + 1
C                                       Get data pointer 1st poln.
                  INDEX = IOFF + (LPFRQ-1) * INCF
                  VISRE = BUFF1(INDEX)
                  VISIM = BUFF1(INDEX+1)
C                                       Sum first polarization.
                  WT = BUFF1(INDEX+2) * CHFLGS(II)
                  IF (WT.GT.1.0E-20) THEN
                     SUMP1(LPIF,IA1,IA2) = SUMP1(LPIF,IA1,IA2) +
     *                  VISRE * WT
                     SUMP1(LPIF,IA2,IA1) = SUMP1(LPIF,IA2,IA1) +
     *                  VISIM * WT
                     SUM2P1(LPIF,IA1,IA2) = SUM2P1(LPIF,IA1,IA2) +
     *                  VISRE * VISRE * WT
                     SUM2P1(LPIF,IA2,IA1) = SUM2P1(LPIF,IA2,IA1) +
     *                  VISIM * VISIM * WT
                     SWT(LPIF,IA1,IA2) = SWT(LPIF,IA1,IA2) + WT
                     COUNT(LPIF,IA1,IA2) = COUNT(LPIF,IA1,IA2) + 1
                     END IF
C                                       Get data pointer 2nd poln.
                  INDEX = INDEX + INCS
                  VISRE = BUFF1(INDEX)
                  VISIM = BUFF1(INDEX+1)
                  WT = BUFF1(INDEX+2) * CHFLGS(II)
C                                       Sum second polarization.
                  IF ((WT.GT.1.0E-20) .AND. (NUMPOL.GT.1)) THEN
                     SUMP2(LPIF,IA1,IA2) = SUMP2(LPIF,IA1,IA2) +
     *                  VISRE * WT
                     SUMP2(LPIF,IA2,IA1) = SUMP2(LPIF,IA2,IA1) +
     *                  VISIM * WT
                     SUM2P2(LPIF,IA1,IA2) = SUM2P2(LPIF,IA1,IA2) +
     *                  VISRE * VISRE * WT
                     SUM2P2(LPIF,IA2,IA1) = SUM2P2(LPIF,IA2,IA1) +
     *                  VISIM * VISIM * WT
                     SWT(LPIF,IA2,IA1) = SWT(LPIF,IA2,IA1) + WT
                     COUNT(LPIF,IA2,IA1) = COUNT(LPIF,IA2,IA1) + 1
                     END IF
 130              CONTINUE
 140           CONTINUE
C                                       Increment buffer pointer
            IPTRI = IPTRI + LREC
 190     CONTINUE
      GO TO 100
C                                       Final call to BLCOUT
 200  IF (NUGOOD.GT.0) CALL BLCOUT (IDSOU, TMSRT, TIMEND, MAXANS,
     *   MAXIFS, SUMP1, SUMP2, SUM2P1, SUM2P2, SWT, COUNT, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL TABIO ('CLOS', 1, IRNOBL, BUFF1, BLBUFF, IRET)
      IF (IRET.LE.0) GO TO 999
         WRITE (MSGTXT,1200) IRET
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BLCUV: ERROR',I3,' OPEN VIS FILE')
 1030 FORMAT ('BLCUV: ERROR',I3,' INIT VIS FILE')
 1100 FORMAT ('BLCUV: ERROR',I3,' READING VIS FILE')
 1200 FORMAT ('BLCUV: ERROR',I3,' CLOSING BL TABLE')
      END
      SUBROUTINE BLCOUT (IDSOU, TMSRT, TIMEND, MAXANS, MAXIFS, SUMP1,
     *   SUMP2, SUM2P1, SUM2P2, SWT, COUNT, IRET)
C-----------------------------------------------------------------------
C   BLCOUT computes averages, writes BL table and gives RMSs for the
C   baselines in the message file.
C   Inputs:
C      IDSOU    I      Source ID number
C      MAXANS   I      Number of antennas (array dimension)
C      MAXIFS   I      Number of IFs (array dimension)
C   Input/Output:
C      TMSRT    R      Start time in days, reset to TIMEND on return
C      TIMEND   R      End time in days, reset on return
C      SUMP1    D()    Sum of visibilities 1st poln., (IF, ant1, ant2),
C                      Real part in ant1<ant2 and Imag part in
C                      ant2<ant1.   Zeroed on return.
C      SUMP2    D()    Sum of visibilities 2nd poln., zeroed on return.
C      SUM2P1   D()    Sum of sq. of vis. 1st poln., zeroed on return.
C      SUM2P2   D()    Sum of sq. of vis. 2nd poln., zeroed on return.
C      SWT      R()    Sum WT, (IF, Ant1, Ant2) Poln 1 in Ant1<Ant2
C      COUNT    I()    Counts, (IF, Ant1, Ant2) Poln 1 in Ant1<Ant2
C                      Poln. 2 in Ant2<Ant1. zeroed on return.
C   Inputs from COMMON:
C      BLVERO   I      BL table version number
C      DISKIN   I      Input file disk number
C      CNOIN    I      Input file catalog slot number
C      CATIN    I()    Input file catalog header
C      LUNBL    I      LUN for BL table
C      NUMANT   I      Number of antennas
C      NUMPOL   I      Number of polarizations
C      NUMIF    I      Number of IFs
C      XSOLIN   R      Solution time in days.
C      SUBARR   I      Subarray number
C   Input/Output in common:
C      BLOPEN   L      True if BL table open.
C      IRNOBL   I      BL table number of next entry.
C     NUMVBL(MAXBLC) I    Column numbers for TABBL
C     KOLSBL(MAXBLC) I    Column pointers for TABBL
C     BLBUFF(*)  I    Buffer used for I/O the BL table.
C   Output:
C      IRET       I    Return code   0 => OK
C                                   >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   MAXANS, MAXIFS, IDSOU, IRET
      REAL      SWT(MAXIFS,MAXANS,MAXANS)
      INTEGER   COUNT(MAXIFS,MAXANS,MAXANS)
      REAL      TMSRT, TIMEND, TIME
      DOUBLE PRECISION SUMP1(MAXIFS,MAXANS,MAXANS),
     *   SUMP2(MAXIFS,MAXANS,MAXANS),
     *   SUM2P1(MAXIFS,MAXANS,MAXANS), SUM2P2(MAXIFS,MAXANS,MAXANS)
      INTEGER   IANT1, IANT2, LOOPIF, LIMIT1, LIMIT2, ITR(6)
      REAL      AMP1, AMP2, PHP1, PHP2, RMSAP1, RMSAP2, RMSPP1, RMSPP2,
     *   RP1, RP2, IP1, IP2
      DOUBLE PRECISION XDIV
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NZERO
      PARAMETER (NZERO=4*MAXIF)
      REAL      FACMUL(2,2,MAXIF), FACADD(2,2,MAXIF), TEMP
      INCLUDE 'BLCAL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA FACADD /NZERO*0.0/
C-----------------------------------------------------------------------
      CALL RFILL (NZERO, FBLANK, FACMUL)
C                                       Initialize BL Table
      IF (.NOT.BLOPEN) THEN
         LUNBL = 29
         CALL BLINI ('WRIT', BLBUFF, DISKIN, CNOIN, BLVERO, CATIN,
     *      LUNBL, IRNOBL, KOLSBL, NUMVBL, NUMANT, NUMPOL, NUMIF, IRET)
         IF (IRET.GT.0) GO TO 999
         BLOPEN = .TRUE.
C                                       Mark in time order iff it is
C                                       now empty
         BLBUFF(43) = 0
         IF (IRNOBL.LE.1) BLBUFF(43) = KOLSBL(1)
C                                       Warn user if solutions will
C                                       be appended to an existing
C                                       BL table.
         IF (IRNOBL.GT.1) THEN
            MSGTXT = 'WARNING - Solutions appended to an existing' //
     *         ' BL table'
            CALL MSGWRT (6)
            END IF
         END IF
C                                       Average data and write BL Table
      TIME = (TMSRT + TIMEND) * 0.5
      IF (TIME.GT.1.0E3) TIME = TMSRT
      LIMIT1 = NUMANT - 1
      DO 200 IANT1 = 1,LIMIT1
         LIMIT2 = IANT1 + 1
         DO 190 IANT2 = LIMIT2,NUMANT
C                                       Loop over IF
            DO 120 LOOPIF = 1,NUMIF
C                                       Blank if bad
               FACMUL(1,1,LOOPIF) = FBLANK
               FACMUL(2,1,LOOPIF) = FBLANK
               FACMUL(1,2,LOOPIF) = FBLANK
               FACMUL(2,2,LOOPIF) = FBLANK
C                                       Average 1st poln
               IF (SWT(LOOPIF,IANT1,IANT2).GT.0.0) THEN
                  XDIV = 1.0D0 / SWT(LOOPIF,IANT1,IANT2)
                  SUMP1(LOOPIF,IANT1,IANT2) = SUMP1(LOOPIF,IANT1,IANT2)
     *               * XDIV
                  SUMP1(LOOPIF,IANT2,IANT1) = SUMP1(LOOPIF,IANT2,IANT1)
     *               * XDIV
                  SUM2P1(LOOPIF,IANT1,IANT2) =
     *               SUM2P1(LOOPIF,IANT1,IANT2) * XDIV
                  SUM2P1(LOOPIF,IANT2,IANT1) =
     *               SUM2P1(LOOPIF,IANT2,IANT1) * XDIV
C                                       Convert to corrections
                  RP1 = SUMP1(LOOPIF,IANT1,IANT2)
                  IP1 = SUMP1(LOOPIF,IANT2,IANT1)
                  AMP1 = RP1 * RP1 + IP1* IP1
                  IF (AMP1.LE.1.0E-15) AMP1 = 1.0E-15
                  FACMUL(1,1,LOOPIF) = RP1 / AMP1
                  FACMUL(2,1,LOOPIF) = -IP1 / AMP1
                  END IF
C                                       Compute RMS
               IF (COUNT(LOOPIF,IANT1,IANT2).GT.2) THEN
                  XDIV = 1.0D0 / (COUNT(LOOPIF,IANT1,IANT2) - 1)
                  SUM2P1(LOOPIF,IANT1,IANT2) =
     *               (SUM2P1(LOOPIF,IANT1,IANT2) -
     *               SUMP1(LOOPIF,IANT1,IANT2) *
     *               SUMP1(LOOPIF,IANT1,IANT2)) * XDIV
                  SUM2P1(LOOPIF,IANT2,IANT1) =
     *               (SUM2P1(LOOPIF,IANT2,IANT1) -
     *               SUMP1(LOOPIF,IANT2,IANT1) *
     *               SUMP1(LOOPIF,IANT2,IANT1)) * XDIV
                  END IF
C                                       Average 2nd poln
               IF (SWT(LOOPIF,IANT2,IANT1).GT.0) THEN
                  XDIV = 1.0D0 / SWT(LOOPIF,IANT2,IANT1)
                  SUMP2(LOOPIF,IANT1,IANT2) = SUMP2(LOOPIF,IANT1,IANT2)
     *               * XDIV
                  SUMP2(LOOPIF,IANT2,IANT1) = SUMP2(LOOPIF,IANT2,IANT1)
     *               * XDIV
                  SUM2P2(LOOPIF,IANT1,IANT2) =
     *               SUM2P2(LOOPIF,IANT1,IANT2) * XDIV
                  SUM2P2(LOOPIF,IANT2,IANT1) =
     *               SUM2P2(LOOPIF,IANT2,IANT1) * XDIV
C                                       Convert to corrections
                  RP2 = SUMP2(LOOPIF,IANT1,IANT2)
                  IP2 = SUMP2(LOOPIF,IANT2,IANT1)
                  AMP2 = RP2 * RP2 + IP2* IP2
                  IF (AMP2.LE.1.0E-15) AMP2 = 1.0E-15
                  FACMUL(1,2,LOOPIF) = RP2 / AMP2
                  FACMUL(2,2,LOOPIF) = -IP2 / AMP2
                  END IF
C                                       Compute RMS
               IF (COUNT(LOOPIF,IANT2,IANT1).GT.2) THEN
                  XDIV = 1.0D0 / (COUNT(LOOPIF,IANT2,IANT1)-1)
                  SUM2P2(LOOPIF,IANT1,IANT2) =
     *               (SUM2P2(LOOPIF,IANT1,IANT2) -
     *               SUMP2(LOOPIF,IANT1,IANT2) *
     *               SUMP2(LOOPIF,IANT1,IANT2)) * XDIV
                  SUM2P2(LOOPIF,IANT2,IANT1) =
     *               (SUM2P2(LOOPIF,IANT2,IANT1) -
     *               SUMP2(LOOPIF,IANT2,IANT1) *
     *               SUMP2(LOOPIF,IANT2,IANT1)) * XDIV
                  END IF
 120           CONTINUE
C                                       Write BL table entry
            CALL TABBL ('WRIT', BLBUFF, IRNOBL, KOLSBL, NUMVBL,
     *         NUMPOL, TIME, IDSOU, SUBARR, IANT1, IANT2, FRQSEL,
     *         FACMUL, FACADD, IRET)
            IF (IRET.NE.0) GO TO 999
 190        CONTINUE
 200     CONTINUE
C                                       Print statistics
      IF (BPARM(2).GT.0.0) THEN
C                                       Timerange
         TEMP = TMSRT
         ITR(1) = TEMP
         TEMP = (TEMP - ITR(1)) * 24.0
         ITR(2) = TEMP
         TEMP = (TEMP - ITR(2)) * 60.0
         ITR(3) = TEMP + 0.5
         TEMP = 0.0
         IF (TIMEND.LT.1.0E3) TEMP = TIMEND
         ITR(4) = TEMP
         TEMP = (TEMP - ITR(4)) * 24.0
         ITR(5) = TEMP
         TEMP = (TEMP - ITR(5)) * 60.0
         ITR(6) = TEMP + 0.5
C                                       Label and timerange
         IF (TIMEND.LT.1.0E3) THEN
            WRITE (MSGTXT,1200) ITR
         ELSE
            MSGTXT = 'Correlator statistics - all data averaged'
            END IF
         CALL MSGWRT (6)
C                                       Key
         MSGTXT = 'Values given are in the order:'
         CALL MSGWRT (5)
         MSGTXT = 'Amp pol1(RMS), Phase(RMS) Amp pol2(RMS) Phase(RMS)'
         CALL MSGWRT (5)
C                                       Do 1 IF per pass
         DO 500 LOOPIF = 1,NUMIF
            LIMIT1 = NUMANT - 1
            DO 490 IANT1 = 1,LIMIT1
               LIMIT2 = IANT1 + 1
               DO 480 IANT2 = LIMIT2,NUMANT
                  IF ((COUNT(LOOPIF,IANT1,IANT2).GT.0) .OR.
     *               (COUNT(LOOPIF,IANT2,IANT1).GT.0)) THEN
C                                       Convert to amp, phase
                     RP1 = SUMP1(LOOPIF,IANT1,IANT2)
                     RP2 = SUMP2(LOOPIF,IANT1,IANT2)
                     IP1 = SUMP1(LOOPIF,IANT2,IANT1)
                     IP2 = SUMP2(LOOPIF,IANT2,IANT1)
                     AMP1 = SQRT (RP1*RP1 + IP1*IP1)
                     IF (AMP1.LT.1.0E-15) AMP1 = 1.0E-15
                     AMP2 = SQRT (RP2*RP2 + IP2*IP2)
                     IF (AMP2.LT.1.0E-15) AMP2 = 1.0E-15
                     PHP1 = ATAN2 (IP1, RP1+1.0E-20)
                     PHP2 = ATAN2 (IP2, RP2+1.0E-20)
C                                       Convert RMS to amp, phase
                     RMSAP1 = SQRT ((SUM2P1(LOOPIF,IANT1,IANT2)*RP1*RP1)
     *                 + (SUM2P1(LOOPIF,IANT2,IANT1)*IP1*IP1)) * 2.0
     *                 / AMP1
                     RMSAP2 = SQRT ((SUM2P2(LOOPIF,IANT1,IANT2)*RP2*RP2)
     *                 + (SUM2P2(LOOPIF,IANT2,IANT1)*IP2*IP2)) * 2.0
     *                 / AMP2
                     RMSPP1 = SQRT ((SUM2P1(LOOPIF,IANT1,IANT2) *
     *                  ((-IP1 / (AMP1*AMP1))**2)) +
     *                  (SUM2P1(LOOPIF,IANT2,IANT1) *
     *                  ((RP1 / (AMP1*AMP1))**2)))
                     RMSPP2 = SQRT ((SUM2P2(LOOPIF,IANT1,IANT2) *
     *                  ((-IP2 / (AMP2*AMP2))**2)) +
     *                  (SUM2P2(LOOPIF,IANT2,IANT1) *
     *                  ((RP2 / (AMP2*AMP2))**2)))
C                                       Phases to degrees
                     PHP1 = PHP1 * 57.296
                     PHP2 = PHP2 * 57.296
                     RMSPP1 = RMSPP1 * 57.296
                     RMSPP2 = RMSPP2 * 57.296
                     IF (RMSPP1.GT.99.9) RMSPP1 = 99.9
                     IF (RMSPP2.GT.99.9) RMSPP2 = 99.9
                     IF (RMSAP1.GT.9.999) RMSAP1 = 9.99
                     IF (RMSAP2.GT.9.999) RMSAP2 = 9.99
                     WRITE (MSGTXT,1210) IANT1, IANT2, LOOPIF, AMP1,
     *                  RMSAP1, PHP1, RMSPP1, AMP2, RMSAP2, PHP2, RMSPP2
                     CALL MSGWRT (5)
                     END IF
 480              CONTINUE
 490           CONTINUE
 500        CONTINUE
         END IF
C                                       Zero arrays
      DO 730 IANT2 = 1,NUMANT
         DO 720 IANT1 = 1,NUMANT
            DO 710 LOOPIF = 1,NUMIF
               SUMP1(LOOPIF,IANT1,IANT2) = 0.0D0
               SUMP2(LOOPIF,IANT1,IANT2) = 0.0D0
               SUM2P1(LOOPIF,IANT1,IANT2) = 0.0D0
               SUM2P2(LOOPIF,IANT1,IANT2) = 0.0D0
               SWT(LOOPIF,IANT1,IANT2) = 0.0
               COUNT(LOOPIF,IANT1,IANT2) = 0
 710           CONTINUE
 720        CONTINUE
 730     CONTINUE
C                                       Reset times
      TMSRT = TIMEND
      TIMEND = TMSRT + XSOLIN
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1200 FORMAT ('Correlator statistics timerange ',I3,'/',2I3,':',I3,'/',
     *   2I3)
 1210 FORMAT (I2,'-',I2,' IF=',I2,2(F7.4,'(',F6.4,')',F8.2,'(',F5.2,
     *   ')'))
      END
      SUBROUTINE BLCSEL (IRET)
C-----------------------------------------------------------------------
C   BLCSEL will read a multi source data set into a temporary scratch
C   file.  Editing and calibration may be applied.
C   Inputs via common /SELCAL/  (Include DSEL.INC)
C      UNAME(3)     R    AIPS name of input file.
C      UCLAS(2)     R    AIPS class of input file.
C      UDISK        R    AIPS disk of input file.
C      USEQ         R    AIPS sequence of input file.
C      SOURCS(4,30) R    Names (16 char) of up to 30 sources, *=>all
C                        First character of name '-' => all except those
C                        specified.
C      TIMRNG(8)    R    Start day, hour, min, sec, end day, hour,
C                        min,sec. 0 => all
C      UVRNG(2)     R    Minimum and maximum baseline lengths in
C                        1000's wavelengths. 0's => all
C      ANTENS(50)   I    List of antennas selected, 0=>all,
C                        any negative => all except those specified
C      FGVER        I    FLAG file version number, if .le. 0 then
C                        NO flagging is applied.
C      CLUSE        I    Cal file version number to apply.
C   Output:
C      IRET         I    Error code: 0 => OK,
C                        -1 => end of data
C                        >0 => failed, abort process.
C-----------------------------------------------------------------------
      INTEGER   IRET, LUN1, LUN2, IIVER, OOVER
      REAL     DUM
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'BLCAL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      REAL WORKR(MAXIF)
      DATA LUN1, LUN2 /28, 29/
C-----------------------------------------------------------------------
C                                       Setup
      CALL UVGET ('INIT', DUM, DUM, IRET)
      IF (IRET.GT.0) GO TO 999
C                                       No data
      IF ((NVIS.LE.0) .OR. (IRET.LT.0)) THEN
         CALL UVGET ('CLOS', DUM, DUM, IRET)
         IRET = -1
C                                       Message
      ELSE
         IF (DOFLAG) THEN
            MSGTXT = 'Selecting, editing and calibrating the data'
         ELSE
            MSGTXT = 'Selecting and calibrating the data'
            END IF
         CALL MSGWRT (4)
C                                       Copy
         VISDSK = 0
         VISCNO = 0
         CALL CALCOP (VISDSK, VISCNO, BUFF1, JBUFSZ, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Copy relevant portion of IF
C                                       table.
         IIVER = 1
         OOVER = 1
         CALL CHNCOP (IIVER,OOVER, LUN1, LUN2, DISKIN, SCRVOL(VISCNO),
     *      CNOIN, SCRCNO(VISCNO), CATUV, CATBLK, BIF, EIF, FRQSEL,
     *      SFREQS, BUFF1, BUFF2, UBUFF, WORKR, IRET)
            GO TO 999
         END IF
C
 999  RETURN
      END
      SUBROUTINE BLCMOD (IRET)
C-----------------------------------------------------------------------
C   BLCMOD divides the CLEAN model visibilities into the data.
C   If no model is found or a point model is specified then the data
C   is divided by the flux density found in the Source (SU) table.
C   Inputs: from commons
C     XNIT      R    Number of components to be divided.
C     DISKIN    R    Input file disk number.
C     CNOIN     I    Input file catalog number.
C     DISK2     R    CLEAN file disk number.
C     XNMAP     R    Number of model files.
C     CCTVER    I    CC table version number.
C     BPARM(1)  R    If .lt. 0 use no model, if .gt. 0 use model
C     FRQSEL    I    FQ ID number
C   Output:
C     CNOIN2    I    CLEAN file catalog number.
C     IRET      I    Return code, 0 => ok, otherwise not.
C-----------------------------------------------------------------------
      INTEGER   IRET
      INTEGER   MODEL, METHOD, ISTOKE, DISKO, ISCR, CHAN, NCHAN, I, IIF,
     *   IROUND
      LOGICAL   DOMSG, F, NONAM, NOCLAS, WASOME
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGDS.INC'
      INTEGER   BITER(MAXFLD)
      DOUBLE PRECISION APCORE(2)
      INCLUDE 'BLCAL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSCD.INC'
C
      REAL RBUF(MAXIF)
C
      DATA DOMSG, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IRET = 0
C                                       Check if multiple sources
      IF (SINGLE) NSOUWD = 1
      IF (NSOUWD.NE.1) GO TO 300
C                                       If neither a point (XSMOD) nor
C                                       clean model use source table.
      NONAM = NAME2 .EQ. '            '
      NOCLAS = CLAS2 .EQ. '      '
      IF (NONAM .AND. NOCLAS .AND. (XSMOD(1).LE.1.0E-20)) GO TO 300
C                                       Set model and method
      CALL H2CHR (4, 1, XMETH, CMOD)
      MODEL = 0
      IF (CMOD.EQ.'COMP') MODEL = 1
      IF (CMOD.EQ.'IMAG') MODEL = 2
      IF (CMOD.EQ.'SUBI') MODEL = 3
      CALL H2CHR (4, 1, XMETH, CMETH)
      METHOD = 0
      IF (CMETH.EQ.'DFT') METHOD = -1
      IF (CMETH.EQ.'GRID') METHOD = 1
C                                       Point source parameters
      DOPTMD = ABS (XSMOD(1)) .GT. 1.0E-20
      PTFLX = XSMOD(1)
      PTRAOF = XSMOD(2)
      PTDCOF = XSMOD(3)
C                                       Point model only
      PARMOD(1) = 0.0
C                                       Get info on model file(s)
      LIMFLX = XFLUX
      MFIELD = IROUND (XNMAP)
      IF (MFIELD.LE.0) MFIELD = 1
      NONEG = F
      WASOME = F
      DO 10 I = 1,MFIELD
         BITER(I) = 1
         IF (I.LE.MAXAFL) THEN
            NCOMP(I) = ABS (XNCOMP(I)) + 0.1
            IF (XNCOMP(I).LE.-0.5) NONEG = .TRUE.
            IF (NCOMP(I).GT.0) WASOME = .TRUE.
         ELSE
            NCOMP(I) = 0
            IF (WASOME) NCOMP(I) = 1000000000
            END IF
 10      CONTINUE
C                                       Set factor to multiply
      FACGRD(1) = 1.0
      FACGRD(2) = 1.0
      IF (DOPTMD) THEN
         DO3DIM = .FALSE.
      ELSE
         CALL SETGDS (DISKIN, CNOIN, NAME2, CLAS2, SEQ2, DISK2, MFIELD,
     *      CCTVER, NCOMP, BITER, MODEL, METHOD, BUFF1, BUFF2, ISTOKE,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         IF (MODEL.GT.0) THEN
            IF (MODEL.EQ.3) THEN
               MSGTXT = 'Using sub-images for the source model'
            ELSE IF (MODEL.EQ.2) THEN
               MSGTXT = 'Using images for the source model'
            ELSE
               MSGTXT = 'Using Clean Component source model'
               END IF
            CALL MSGWRT (3)
            CALL FACSET (DISKIN, CNOIN, 1, SOUWAN(1), MODEL, 1.0, IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
         END IF
      CNOIN2 = CCCNO(1)
C                                       Divide data by model
      DISKO = VISDSK
      ISCR = VISCNO
      CHAN = 1
      NUMIF = 1
      IF (JLOCIF.GT.0) NUMIF = CATBLK(KINAX+JLOCIF)
      COMPDT = .FALSE.
      DATDIV = .TRUE.
C                                       Consider whether to process
C                                       1 IF at a time
      IF ((NUMIF.GT.1) .AND. (MODEL.GT.0) .AND. (FACFLX.GT.0.0)) THEN
C                                       number of channels
         NCHAN = CATBLK(KINAX+JLOCF)
C                                       For each IF
         DO 15 IIF = 1,NUMIF
C                                       Already know IF 1 scale
            IF (IIF.GT.1) THEN
C                                       Reset Components for div
               IF (MFIELD.GT.0) THEN
                  DO 12 I = 1,MFIELD
                     BITER(I) = 1
                     IF (I.LE.MAXAFL) THEN
                        NCOMP(I) = ABS (XNCOMP(I)) + 0.1
                     ELSE
                        NCOMP(I) = 0
                        IF (WASOME) NCOMP(I) = 1000000000
                        END IF
 12                  CONTINUE
                  CALL SETGDS (DISKIN, CNOIN, NAME2, CLAS2, SEQ2, DISK2,
     *               MFIELD, CCTVER, NCOMP, BITER, MODEL, METHOD, BUFF1,
     *               BUFF2, ISTOKE, IRET)
                  IF (IRET.NE.0) GO TO 999
                  XVER = CCTVER
                  CNOIN2 = CCCNO(1)
                  END IF
C                                       Divide data by model
               DISKO = VISDSK
               ISCR = VISCNO
C                                       Set division parameters
               COMPDT = .FALSE.
               DATDIV = .TRUE.
               FACGRD(1) = 1.0
               IF (MODEL.GT.0) THEN
                  CALL FACSET (DISKIN, CNOIN, IIF, SOUWAN(1), MODEL,
     *               1.0, IRET)
                  IF (IRET.NE.0) GO TO 999
                  END IF
               END IF
C                                       start channel
            CHAN = 1 + (NCHAN * (IIF-1))
C                                       Divide 1 IF by model
            CALL UVMDIV (APCORE, VISDSK, VISCNO, DISKO, ISCR, MODEL,
     *         METHOD, DOMSG, CHAN, NCHAN, CATBLK, JBUFSZ, FRQSEL,
     *         BUFF1, BUFF2, UBUFF, RBUF, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL UNSETG (BUFF2)
            DOMSG  = .FALSE.
 15         CONTINUE
      ELSE
         CHAN = 1
         NCHAN = CATBLK(KINAX+JLOCF) * NUMIF
C                                       CC components to unity
         CALL UVMDIV (APCORE, VISDSK, VISCNO, DISKO, ISCR, MODEL,
     *      METHOD, DOMSG, CHAN, NCHAN, CATBLK, JBUFSZ, FRQSEL, BUFF1,
     *      BUFF2, UBUFF, RBUF, IRET)
         IF (IRET.NE.0) GO TO 999
         IF (.NOT.DOPTMD) CALL UNSETG (BUFF2)
         END IF
C                                       Get true values of NCOMP
      DO 20 I = 1,MFIELD
         NCOMP(I) = NSUBG(I) - 1
 20      CONTINUE
C                                       Model divided by data now
C                                       in scratch file.
      VISDSK = 0
      VISCNO = ISCR
      GO TO 999
C                                       Multiple sources, use point
C                                       source at phase center only.
 300  CALL BLCDIV (IRET)
C
 999  RETURN
      END
      SUBROUTINE BLCDIV (IRET)
C-----------------------------------------------------------------------
C   BLCDIV divides multisource data in a scratch file  by the
C   calibrator flux densities given in the source table; if 0, 1.0 is
C   used.  If all calibrator flux densities are 1.0 then no operation
C   is performed.
C   Input from common:
C    NSOUWD        I    Number of sources included or excluded; if
C                       0 all sources are included.
C    DOSWNT        L    If .TRUE. then sources in SOUWAN are included
C                       If .FALSE. then excluded.
C    SOUWAN(30)    I    The source numbers of sources included or
C                       excluded.
C    DISKIN        I    Disk number of the input multisource data file
C                       whose SU table is to be used.
C    CNOIN         I    Catalog slot number for SU file.
C    VISCNO        I    /CFILES/ number of the scratch file
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C   Note: also uses buffers, BUFF1, BUFF2, UBUFF, NXBUFF
C   Note: assumes that IF  is the most slowly variable axis.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4, IFILE*48
      INTEGER   INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, LENVIS,
     *   ILENBU, KBIND, IBIND, I, J, IVIS, IOFF, NOVIS,
     *   SUKOLS(MAXSUC), SUNUMV(MAXSUC), IDSOU, QUAL, SULUN, IFNO, INDX,
     *   NVPIF,BO, VO, ISURNO, NUMSOU, LOOP, SUFQID
      LOGICAL   T, F
      DOUBLE PRECISION BANDW, RAEPO, DECEPO, EPOCH, RAAPP, DECAPP,
     *   PMRA, PMDEC, RAOBS, DECOBS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'BLCAL.INC'
      INCLUDE 'INCS:DSEL.INC'
      REAL      SFLUX(UVBFSL/2), XSFLUX
      DOUBLE PRECISION LSRVEL(MAXIF), FREQO(MAXIF), RESTFQ(MAXIF)
      REAL     FLUX(4,MAXIF)
      DATA SULUN, LUNI, LUNO /27, 16,17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IF (SOUWAN(1).LE.0) SOUWAN(1) = 1
C                                       Message
      WRITE (MSGTXT,2000)
      CALL MSGWRT (6)
      LENVIS = CATBLK(KINAX)
C                                       Open source (SU) table
      CALL SOUINI ('READ', NXBUFF, DISKIN, CNOIN, 1, CATUV, SULUN,
     *   NUMIF, VELTYP, VELDEF, SUFQID, ISURNO, SUKOLS, SUNUMV, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Get number of sources
      NUMSOU = NXBUFF(5)
C                                       Read flux array
      DO 30 LOOP = 1,NUMSOU
         ISURNO = LOOP
         CALL TABSOU ('READ', NXBUFF, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA,
     *      PMDEC, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET
            GO TO 990
            END IF
C                                       Get flux densities
         INDX = (IDSOU-1) * NUMIF
         DO 25 I = 1,NUMIF
            SFLUX(INDX+I) = FLUX(1,I)
C                                       All sources selected must have
C                                       flux densities - test that only
C                                       when data are read
            IF (SFLUX(INDX+I).GT.1.0E-10) SFLUX(INDX+I) = 1.0 /
     *         SFLUX(INDX+I)
 25         CONTINUE
 30      CONTINUE
C                                       Close table
      CALL TABIO ('CLOS', 0, ISURNO, BUFF1, NXBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
C                                       Do divisions
      NOVIS = (LREC - NRPARM) / LENVIS
      NVPIF = NOVIS / NUMIF
      IF (NVPIF.LT.1) NVPIF = 1
C                                       Open and init for write
C                                       visibility file
      CALL ZPHFIL ('SC', SCRVOL(VISCNO), SCRCNO(VISCNO), 1, IFILE,
     *   IRET)
      CALL ZOPEN (LUNO, INDO, SCRVOL(VISCNO), IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1040) IRET, 'WRIT'
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IPTRO = KBIND
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1050) IRET, 'WRIT'
         GO TO 990
         END IF
C                                       Open and init for read
C                                       visibility file
      CALL ZOPEN (LUNI, INDI, SCRVOL(VISCNO), IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1040) IRET, 'READ'
         GO TO 990
         END IF
C                                       Init vis file for read
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1050) IRET, 'READ'
         GO TO 990
         END IF
C                                       Loop
C                                       Read vis. record.
 100     CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET, 'READ'
            GO TO 990
            END IF
         IPTRI = IBIND
         IF (INIO.LE.0) GO TO 200
         IDSOU = SOUWAN(1)
C                                       loop thru buffer full
         DO 180 I = 1,INIO
            DO 120 J = 1,LREC
               BUFF2(IPTRO+J-1) = BUFF1(IPTRI+J-1)
 120           CONTINUE
            IF (ILOCSU.GE.0) IDSOU = BUFF2(IPTRO+ILOCSU) + 0.5
            IOFF = NRPARM
C                                       This assumes that IF is the
C                                       most slowly varying axis.
            DO 140 IVIS = 1,NOVIS
               IFNO = ((IVIS-1) / NVPIF) + 1
               INDX = (IDSOU-1) * NUMIF + IFNO
               XSFLUX = SFLUX(INDX)
               IF (XSFLUX.LE.1.E-10) THEN
                  WRITE (MSGTXT,1120) IDSOU
                  MSGTXT = 'FLUX NOT DEFINED FOR SOURCE'
                  IRET = 99
                  GO TO 990
                  END IF
               BUFF2(IPTRO+IOFF) = BUFF2(IPTRO+IOFF) * XSFLUX
               BUFF2(IPTRO+IOFF+1) = BUFF2(IPTRO+IOFF+1) * XSFLUX
               IOFF = IOFF + LENVIS
 140           CONTINUE
            IPTRI = IPTRI + LREC
            IPTRO = IPTRO + LREC
 180        CONTINUE
C                                       Write vis. record.
         CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, INIO, KBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET, 'WRIT'
            GO TO 990
            END IF
         IPTRO = KBIND
         GO TO 100
C                                       Done
C                                       Flush buffer
 200  INIO = 0
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, INIO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) IRET, 'FLSH'
         GO TO 990
         END IF
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1210) IRET, 'READ'
         GO TO 990
         END IF
      CALL ZCLOSE (LUNO, INDO, IRET)
      IF (IRET.EQ.0) GO TO 999
         WRITE (MSGTXT,1210) IRET, 'WRIT'
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BLCDIV: ERROR',I3,' OPENING SOURCE TABLE')
 1010 FORMAT ('BLCDIV: ERROR',I3,' READING SOURCE TABLE')
 1030 FORMAT ('BLCDIV: ERROR',I3,' CLOSING SOURCE TABLE')
 1040 FORMAT ('BLCDIV: ERROR',I3,' OPEN-FOR-',A4,' VIS FILE')
 1050 FORMAT ('BLCDIV: ERROR',I3,' INIT-FOR-',A4,' VIS FILE')
 1100 FORMAT ('BLCDIV: ERROR',I3,1X,A4,'ING VIS FILE')
 1120 FORMAT ('BLCDIV: FLUX NOT DEFINED FOR SOURCE',I4)
 1210 FORMAT ('BLCDIV: ERROR',I3,'CLOSING ',A4,' VIS FILE')
 2000 FORMAT ('Dividing data by source flux densities')
      END
      SUBROUTINE BLCHIS
C-----------------------------------------------------------------------
C   BLCHIS updates history file.
C-----------------------------------------------------------------------
      CHARACTER CTIME(2)*12, HILINE*72
      INTEGER   LUN2, IERR, I, TIME(3), DATE(3)
      LOGICAL   T
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'BLCAL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN2 /28/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Open old history
      CALL HIOPEN (LUN2, DISKIN, CNOIN, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,1000) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Add selection/calibration
      CALL CALHIS (LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Bl table version written.
      WRITE (HILINE,3020) TSKNAM, BLVERO
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Write control info.
C                                       CC tables
      IF (DOMODL .AND. (XSMOD(1).LE.0.0)) THEN
C                                       CC File Name etc.
         CALL HENCO2 (TSKNAM, NAME2, CLAS2, SEQ2, DISK2, LUN2, BUFF2,
     *      IERR)
         IF (IERR.NE.0) GO TO 190
C                                        CCfile version no.
         WRITE (HILINE,2001) TSKNAM, CCTVER
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                        Number of images
         WRITE (HILINE,2002) TSKNAM, MFIELD
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       Number of CLEAN components.
         DO 140 I = 1,MFIELD
            WRITE (HILINE,2003) TSKNAM, I, NCOMP(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
 140        CONTINUE
         END IF
C                                       Point source model
      IF (XSMOD(1).GT.0.0) THEN
         WRITE (HILINE,2020) TSKNAM, XSMOD(1), XSMOD(2), XSMOD(3)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         END IF
C                                       Solution time
      XSOLIN = XSOLIN * (24.0 * 60.0)
      IF (XSOLIN.LT.1.0E3) THEN
         WRITE (HILINE,2025) TSKNAM, XSOLIN
      ELSE
         WRITE (HILINE,2026) TSKNAM
         END IF
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                        Already divided by model
      IF (BPARM(1).GT.0.0) THEN
         WRITE (HILINE,2021) TSKNAM
      ELSE
         WRITE (HILINE,2022) TSKNAM
         END IF
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Close HI file
 190  CALL HICLOS (LUN2, T, BUFF2, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 2001 FORMAT (A6,'INVER = ',I5,' /CC file version no.')
 2002 FORMAT (A6,'NMAPS =',I4,' /Number of CLEAN images used')
 2003 FORMAT (A6,'NCOMP(',I3,') = ',I8,' /Number of CLEAN comps.')
 2020 FORMAT (A6,'SMODEL = ',2(F10.5,','),F10.5,
     *   ' /Pt. model parameters')
 2021 FORMAT (A6,'BPARM(1) = 1 /Data already divided by model')
 2022 FORMAT (A6,'BPARM(1) = 0 /Divide data by model')
 2025 FORMAT (A6,'SOLINT=',F7.2,' /Soln. inter. (min)')
 2026 FORMAT (A6,'SOLINT = 0 / Average over all time')
 3020 FORMAT (A6,'BASEVER = ',I3,' /BL table written')
      END
      SUBROUTINE CHWANT (NCH, NIF, CHNSEL, CHFLGS)
C-----------------------------------------------------------------------
C   Makes a mask of the desired channels
C   Inputs:
C      NCH      I            Number spectral chans
C      NIF      I            Number IFs
C      CHNSEL   I(3,20,*)    Start, stop, incr 20 sets per IF
C   Outputs
C      CHFLGS   R(*,*)       1.0 => use, 0.0 => do not use
C-----------------------------------------------------------------------
      INTEGER   NCH, NIF, CHNSEL(3,20,*)
      REAL      CHFLGS(NCH,NIF)
C
      INTEGER   I, J, K
C-----------------------------------------------------------------------
      J = NCH * NIF
      CALL RFILL (J, 0.0, CHFLGS)
      DO 30 K = 1,NIF
         DO 20 J = 1,20
            IF ((CHNSEL(1,J,K).GT.0) .AND. (CHNSEL(3,J,K).GT.0) .AND.
     *         (CHNSEL(2,J,K).GE.CHNSEL(1,J,K))) THEN
               DO 10 I = CHNSEL(1,J,K),CHNSEL(2,J,K),CHNSEL(3,J,K)
                  CHFLGS(I,K) = 1.0
 10               CONTINUE
               END IF
 20         CONTINUE
 30      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE TVBLNK (ENTRY, ICS, BUFFER, IERR)
C-----------------------------------------------------------------------
C! blinks two TV channels, cursor controls rate; also enhancements
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998-1999
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TVBLNK alternates 2 channels at a rate set by the cursor position.
C   It returns whenever a button is pushed in autoblink (ENTRY=1)
C   mode.  In manual control mode (ENTRY=2), button A selects
C   alternate planes, button B selects autoblink (temporarily) and
C   the other buttons cause a return.
C   Inputs:
C      ENTRY   I        Type of blinking (1 -> auto, 2 -> man)
C      ICS     I(2)     Channel numbers: 1 - NGRAY
C   Output:
C      IBUT    I        Button(s) pushed: (1 - 15)
C      BUFFER  I(256)   Work buffer
C      IERR    I        Error code of ZM70XF: 0 => ok,  2 => input error
C-----------------------------------------------------------------------
      INTEGER   ENTRY, ICS(2), BUFFER(*), IERR
C
      INTEGER   IQ, IER, I, ION, ICBS(4,2), ICOLOR, ISM, ITM, IXS, IYS,
     *   J, ITYPE, ICHA(4), IBUT
      REAL      RPOS(2), S, X, D1, D2, PPOS(2,3), RSZX, RSZY
      LOGICAL   F, T
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA T, F /.TRUE., .FALSE./
C-----------------------------------------------------------------------
C                                       check inputs
      IERR = 2
      IF ((ICS(1).LT.1) .OR. (ICS(1).GT.NGRAY)) GO TO 999
      IF ((ICS(2).LT.1) .OR. (ICS(2).GT.NGRAY)) GO TO 999
C                                       set parameters
      ICOLOR = 7
      ISM = 2
      IF (TYPSPL.EQ.2) ISM = 1
      IF ((TYPSPL.LE.0) .OR. (TVIMPC.LE.0)) ISM = 3
      ITM = 2
      ICBS(1,1) = 2 ** (ICS(1)-1)
      ICBS(1,2) = 2 ** (ICS(2)-1)
      CALL FILL (3, ICBS(1,1), ICBS(2,1))
      CALL FILL (3, ICBS(1,2), ICBS(2,2))
      ION = 2
      RSZX = WINDTV(3) - WINDTV(1) + 1
      RSZY = WINDTV(4) - WINDTV(2) + 1
      CALL RFILL (6, 0.0, PPOS)
      CALL YHOLD ('ONNN', IERR)
C                                       All channels off
      DO 10 I = 1,NGRAY
         CALL YSLECT ('OFFF', I, 0, BUFFER, IERR)
 10      CONTINUE
C                                       General instructions
 20   IF (ENTRY.EQ.1) THEN
         WRITE (MSGTXT,1020) ICS(1)
         CALL MSGWRT (1)
         WRITE (MSGTXT,1021) ICS(2)
      ELSE
         MSGTXT = 'Hit button A to switch manually between images'
         CALL MSGWRT (1)
         MSGTXT = 'Hit button B to do automatic blink'
         END IF
      CALL MSGWRT (1)
      IF (ISM.GE.3) THEN
         MSGTXT = 'Hit button C to set next transfer function'
      ELSE
         MSGTXT = 'Hit button C to set both transfer functions together'
         END IF
      CALL MSGWRT (1)
C                                       Cursor on
      RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
      RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2
      PPOS(1,1) = RPOS(1)
      PPOS(2,1) = RPOS(2)
      CALL YCURSE ('ONNN', F, F, RPOS, IQ, IBUT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Blinking
 100  MSGTXT = 'Hit button D to exit'
         CALL MSGWRT (1)
C                                       Instructions
         MSGTXT = 'Cursor X position controls blink rate'
         CALL MSGWRT (1)
         MSGTXT = 'Cursor Y position controls proportion of time on'
     *      // ' each plane'
         CALL MSGWRT (1)
C                                       Blink loop: plane on, delay,
C                                       read cursor, plane off
 120     DO 130 I = 1,2
            CALL YSPLIT ('WRIT', TVSPLT(1), TVSPLT(2), ICBS(1,I),
     *         ICBS(1,I), ICBS(1,I), T, IERR)
            IF (IERR.NE.0) GO TO 900
            CALL YHOLD ('OFFF', IERR)
            X = (RPOS(1) - WINDTV(1) + 1.) / RSZX
            S = 5.8 * X * X  -  0.72 * X  -  0.08
            X = 0.5 * (RPOS(2) - WINDTV(2) + 1.) / RSZY  + 0.25
            IF (I.EQ.2) X = 1.0 - X
            S = S * X
            IF (S.GT.0.0) THEN
               CALL ZDELAY (S, IERR)
               IF (IERR.NE.0) GO TO 900
               END IF
            CALL YCURSE ('READ', F, F, RPOS, IQ, IBUT, IERR)
            IF (IERR.NE.0) GO TO 900
            IF (IBUT.NE.0) THEN
               CALL YHOLD ('ONNN', IERR)
               CALL YSLECT ('OFFF', ICS(I), 0, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 900
               GO TO 150
               END IF
            D1 = ABS (RPOS(1)-PPOS(1,1)) / (0.75*MAXXTV(1))
            D2 = ABS (RPOS(2)-PPOS(2,1)) / (0.75*MAXXTV(2))
            IF ((D1.GE.1.0) .OR. (D2.GE.1.0)) THEN
               IF (D1.GE.1.0) RPOS(1) = PPOS(1,1)
               IF (D2.GE.1.0) RPOS(2) = PPOS(2,1)
               CALL YCURSE ('ONNN', F, F, RPOS, IQ, IBUT, IERR)
               IF (IERR.NE.0) GO TO 999
               END IF
            PPOS(1,1) = RPOS(1)
            PPOS(2,1) = RPOS(2)
 130        CONTINUE
         GO TO 120
C                                       Manual mode?
 150  IF ((ENTRY.EQ.2) .AND. (IBUT.LT.4)) THEN
         CALL YWINDO ('READ', WINDTV, IERR)
         IF (IERR.NE.0) GO TO 900
         RSZX = WINDTV(3) - WINDTV(1) + 1
         RSZY = WINDTV(4) - WINDTV(2) + 1
C                                       Switch planes
         IF (IBUT.GE.2) THEN
            RPOS(1) = PPOS(1,1)
            RPOS(2) = PPOS(2,1)
            GO TO 120
         ELSE
            ION = 3 - ION
            CALL YSLECT ('ONNN', ICS(ION), 0, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 900
            CALL YHOLD ('OFFF', IERR)
            CALL YCURSE ('READ', T, F, RPOS, IQ, IBUT, IERR)
            IF (IERR.NE.0) GO TO 900
            CALL YHOLD ('ONNN', IERR)
            CALL YSLECT ('OFFF', ICS(ION), 0, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 900
            GO TO 150
            END IF
         END IF
C                                       Done blink
      IF ((ENTRY.EQ.2) .AND. (IBUT.LT.8)) IBUT = 4
C                                       Image enhancement
 200  IF (IBUT.LT.8) THEN
         IF (IBUT.EQ.1) THEN
            ITM = 1
         ELSE IF (IBUT.EQ.2) THEN
            ITM = 2
         ELSE IF (IBUT.GT.2) THEN
            IF (ISM.GE.3) THEN
               ITM = 3 - ITM
            ELSE
               ITM = 3
               END IF
            END IF
C                                       Turn on plane(s): single
         IF (ISM.GE.3) THEN
            CALL YHOLD ('ONNN', IERR)
            CALL YSLECT ('OFFF', ICS(3-ITM), 0, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 900
            CALL YSLECT ('ONNN', ICS(ITM), 0, BUFFER, IERR)
C                                       Vertical split
         ELSE IF (TYPSPL.NE.2) THEN
            IXS = MAXXTV(1)/2
            IYS = 1
            ICHA(1) = 2 ** (ICS(ISM)-1)
            ICHA(2) = 2 ** (ICS(3-ISM)-1)
            ICHA(3) = ICHA(2)
            ICHA(4) = ICHA(1)
            CALL YSPLIT ('WRIT', IXS, IYS, ICHA, ICHA, ICHA, T, IERR)
C                                       Horizontal split
         ELSE
            IYS = MAXXTV(2)/2
            IXS = 1
            ICHA(1) = 2 ** (ICS(ISM)-1)
            ICHA(3) = 2 ** (ICS(3-ISM)-1)
            ICHA(2) = ICHA(1)
            ICHA(4) = ICHA(3)
            CALL YSPLIT ('WRIT', IXS, IYS, ICHA, ICHA, ICHA, T, IERR)
            END IF
         IF (IERR.NE.0) GO TO 900
         CALL YHOLD ('OFFF', IERR)
C                                       Instructions: enhance channel
         IF (ITM.LE.2) THEN
            WRITE (MSGTXT,1200) ICS(ITM)
         ELSE
            WRITE (MSGTXT,1201) ICS(1), ICS(2)
            END IF
         CALL MSGWRT (1)
         IF (ITM.GE.2) WRITE (MSGTXT,1020) ICS(1)
         IF (ITM.GT.2) CALL MSGWRT (1)
         IF (ITM.NE.2) WRITE (MSGTXT,1021) ICS(2)
         CALL MSGWRT (1)
         MSGTXT = 'Hit button C to reverse sign of slope'
         CALL MSGWRT (1)
         MSGTXT = 'Hit button D to resume blinking'
         CALL MSGWRT (1)
         IF (ITM.LE.2) THEN
            I = 2 ** (ICS(ITM) - 1)
            J = ITM + 1
         ELSE
            I = 2 ** (ICS(1) - 1) + 2 ** (ICS(2) - 1)
            J = 2
            END IF
         ITYPE = 2
         CALL IENHNS (I, ICOLOR, ITYPE, PPOS(1,J), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 900
         IBUT = ITYPE
         IF (IBUT.LE.2) GO TO 200
         GO TO 20
         END IF
C                                       Final state: ch ICS(1) on
 900  CALL YHOLD ('ONNN', IER)
      CALL YSLECT ('OFFF', ICS(2), 0, BUFFER, IER)
      CALL YSLECT ('ONNN', ICS(1), 0, BUFFER, IER)
      CALL YHOLD ('OFFF', IER)
C                                       Off cursor
      CALL YCURSE ('OFFF', F, F, RPOS, IQ, I, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('Hit button A to set transfer function of channel',I2)
 1021 FORMAT ('Hit button B to set transfer function of channel',I2)
 1200 FORMAT ('Setting transfer function for channel',I2)
 1201 FORMAT ('Setting transfer functions for channels',I2,' and',I2)
      END

      SUBROUTINE APPEEK(BUFFER)
C-----------------------------------------------------------------------
C! Routine to examine the memory of the AP.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C----------------------------------------------------------------------
C
C     APPEEK ALLOWS THE DEBUG EXAMINATION OF AP VARAIBLES.
C     VARIABLES ARE SET BY THE DEBUGGER.
C
C      LOOP = LOOP COUNTER
C      NLOOP = MAXIMUM NUMBER OF LOOPS
C      XAPLOC = R*8 START ADDRESS, CONVERTED TO P I*4 APLOC
C      NUM = I*2 UNSIGNED NUMBER OF LOCATIONS TO READ
C     ITYP = 1 FOR I*2 VALUES, 2 FOR R*4 VALUES, 3 TO DUMP SPAD
C            SPAD DUMP WILL BE TO SPDUMP.
C
C     THE RESULTS ARE RETURNED IN BUFFER
C
C      PROGRAMMER = W. D. COTTON, AUGUST 1980.
C----------------------------------------------------------------------
      INTEGER*2 LOOP,NLOOP,APLOC(2),NUB,ITYP,SPDUMP(16)
      REAL*4 BUFFER(1),OP8TO4
      REAL*8 XAPLOC
      DATA OP8TO4 /'8TO4'/
C----------------------------------------------------------------------
      CALL APWR
      NLOOP = 50
      XAPLOC = 0.0
      NUM = 0
      ITYP = 2
      DO 100 LOOP = 1 , NLOOP
C                                     CHANGE VALUES HERE
   50    CONTINUE
         IF ( NUM .LE. 0 ) GO TO 100
            CALL ZR8P4 (OP8TO4, APLOC, XAPLOC)
            IF(ITYP.LE.2) CALL APGET(BUFFER,APLOC,NUM,ITYP)
            CALL APWD
C                                       READ SPADS IF REQUESTED
      IF (ITYP .NE. 3) GO TO 60
      DO 65 I = 1 , 16
         CALL APGSP(II,I-1)
         CALL APWD
         SPDUMP(I) = II
   65    CONTINUE
C                                      EXAMINE RESULTS HERE
   60       CONTINUE
  100       CONTINUE
  999 RETURN
      END

      SUBROUTINE UVMDIV (APCORE, DISKI, CNOSCI, DISKO, CNOSCO, MODEL,
     *   METHOD, DOMSG, CHANEL, NCHAN, CATBLK, JBUFSZ, FREQID, BUFF1,
     *   BUFF2, BUFF3, BUFF4, IRET)
C-----------------------------------------------------------------------
C! Divides a uv data set by the Fourier transform of a model.
C# AP-util UV Map Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 1999-2000, 2006, 2008, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVMDIV divides model visibilities derived from CLEAN components
C   or images into a uv data set.  The weights of the data returned
C   will be the input values multiplied by the model amplitude.
C      A variety of model computation methods are available; if a single
C   pass thru VISDFT, the DFT routine, is not sufficient then the data
C   is copied to a scratch file which has space for a second copy of the
C   data, the model values are computed and summed in these locations
C   and finally the model is divided into the data and written to the
C   output file.
C      Extensive use is made of commons to communicate with UVMDIV, in
C   particular /MAPDES/ (include DGDS.INC) contains most
C   of the critical information about the CLEAN components files or
C   images to be used.  Common /UVHDR/ (filled in by UVPGET) is
C   presumed to describe the uv data files.
C      Also fills in frequency table (NCHANG, FREQG) in include
C   DGDS.INC
C   Inputs:
C      DISKI    I        Input disk number. if <= 0 then input is a
C                        scratch file.
C      CNOSCI   I        Input file catalog slot number or /CFILES/
C                        scratch file number.
C      DISKO    I        Output disk number. if <= 0 then output is a
C                        scratch file.
C      CNOSCO   I        Output file catalog slot number or /CFILES/
C                        scratch file number.  If <= 0 then one of the
C                        internal scratch files will be used.
C      MODEL    I        1=> clean components, 2=>image.
C      METHOD   I        1=>gridded, -1=>DFT, 0=>chose.
C      DOMSG    L        If true give percent done messages for DFT.
C      CHANEL   I        First uv data channel to subtract.
C      NCHAN    I        Number of frequency channels to subtract.
C      CATBLK   I(256)   UV data catalog header record.
C      JBUFSZ   I        Size of BUFF1,2,3 in bytes, must be at least
C                        4096 words.
C      FREQID   I        Freq ID number, if it exists.
C   Inputs from COMMON /MAPDES/:
C      MFIELD   I        Number of fields
C      NSUBG    I(*)     Number of components already sub.
C      NCLNG    I(*)     Number of components per field.
C      CCDISK   I(*)     Disk numbers for CC files
C      CCCNO    I(*)     Catalog slot numbers for CC files.
C      CCVER    I(*)     CC file version number for each field.
C      FACGRD   R(2)     Value to multiply clean component fluxes by
C                        before subtraction (negative for sum).
C                        FACGRD(2) is for data and 0 or 1 only values
C                        used.  Model added not subtracted when data are
C                        ignored.
C      SCTYPE   C*2      Scratch file type to create. (eg. 'SC')
C      NONEG    L        Stop reading comps. from a file past the first
C                        negative component.
C      LIMFLX   R        Stop when flux < LIMFLX.
C      DOPTMD   L        Use the point model specified by PTFLX, PTRAOF,
C                        PTDCOF (DFT modeling ONLY)
C      PTFLX    R        Point model flux density (Jy) (I pol. only)
C      PTRAOF   R        Point model RA offset from uv phase center
C                        (asec)
C      PTDCOF   R        Point model Dec. offset from uv phase center
C   Input from COMMON /UVHDR/:
C      LREC     I        Length of visibility record.
C      NVIS     I        Number of visibility records.
C      NRPARM   I        "Random" parameters before data, can be used
C                        to skip observed values when computing model.
C   Output:
C      CNOSCO   I        Output file catalog slot number or /CFILES/
C                        scratch file number.  Value returned if not
C                        specified in call.
C      BUFF1    R(*)     Work buffers.
C      BUFF2    R(*)     Work buffers.
C      BUFF3    R(*)     Work buffers.
C      BUFF4    R(*)     Work buffers.
C      IRET     I        Return error code. 0=>OK, otherwise failed.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   DISKI, CNOSCI, DISKO, CNOSCO, MODEL, METHOD, CHANEL,
     *   NCHAN, CATBLK(256), JBUFSZ, FREQID, IRET
      LOGICAL   DOMSG
      REAL      BUFF1(*), BUFF2(*), BUFF3(*), BUFF4(*)
C
      INTEGER   I, LENMOD, ISCR2, DISKX, SAVNRP, SAVLRC, DISK, CNO, LUN,
     *   LUN2, INMETH, OUMETH, CNOX, BIF, EIF, CATSCR(256), TEMP(256),
     *   LENBU, MXCMP, XNCC, APSIZ, SCFRW, IV, OV, NEED, MSGSAV, KAP,
     *   LCHANL, LCHAN
      LOGICAL   DOSUM, DODFT, F, LTEMP
      REAL      BUFSZ, TIMDFT, TIMFFT
      INCLUDE 'INCS:PUVD.INC'
      DOUBLE PRECISION SFOFF(MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSCD.INC'
      INCLUDE 'INCS:DMOD.INC'
      SAVE LUN, LUN2
      DATA LENMOD /7/, LUN/27/, LUN2/28/
      DATA F /.FALSE./
      DATA SFOFF /MAXIF*0.0D0/
C-----------------------------------------------------------------------
      IRET = 0
      NGRDAT = F
C                                       Store CATBLK for later use
      CALL COPY (256, CATBLK, SCRCAT)
      SCLREC = LREC
      SCRPRM = NRPARM
      COMPDT = CATBLK(KINAX).EQ.1
      IF (COMPDT) THEN
         CALL AXEFND (8, 'WEIGHT  ', SCRCAT(KIPCN), SCRHOL(KHPTP),
     *      WTLOC, IRET)
         IF ((IRET.NE.0) .OR. (WTLOC.LT.0)) THEN
            IRET = 5
            MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
            CALL MSGWRT (8)
            GO TO 999
            END IF
         IRET = 0
         END IF
C                                       Decide model computation method.
      INMETH = METHOD
      DODFT = (METHOD.LT.0) .AND. (MODEL.EQ.1)
C                                       DFT only for pt. model
      CALL UVMTYP (0, METHOD, NCHAN, LTEMP, TIMDFT, TIMFFT)
      IF (MODEL.EQ.1) DODFT = LTEMP
      DODFT = DODFT .OR. DOPTMD
      OUMETH = 1
      IF (DODFT) OUMETH = -1
C                                       If doing Direct Fourier Trans.
      IF (DODFT) THEN
C                                       Check point model
         IF (DOPTMD) THEN
            XNCC = 1
         ELSE
            XNCC = 0
            DO 20 I = 1,MFIELD
               XNCC = XNCC + NCLNG(I) - NSUBG(I)
 20            CONTINUE
            END IF
C                                       Make AP memory for this
         BUFSZ = JBUFSZ
         LENBU = ((BUFSZ-2*NBPS) / 2) / (LREC*2)
         NEED = 12 + (LENBU*LREC) + CATBLK(KINAX+JLOCF) + XNCC*LENMOD
     *      + 2*LENMOD
         NEED = NEED / 1024
         MSGSAV = MSGSUP
         MSGSUP = 32000
         CALL QINIT (APCORE, NEED, 0, KAP)
         MSGSUP = MSGSAV
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            NEED = 12 + (LENBU*LREC) + CATBLK(KINAX+JLOCF) +
     *         XNCC*LENMOD/10 + 2*LENMOD
            NEED = NEED / 1024
            NEED = MIN (32+1024, NEED) + 2
            CALL QINIT (APCORE, NEED, 0, KAP)
            IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
               IRET = 8
               MSGTXT = 'UVMDIV CANNOT GET NEEDED MEMORY'
               CALL MSGWRT (8)
               END IF
            END IF
         APSIZ = PSAPNW * 1024
         CALL QRLSE
C                                       Decide if will fit.in AP
         MXCMP = (APSIZ-10.-(LENBU*LREC)-2.-CATBLK(KINAX+JLOCF))
     *    / LENMOD
         MXCMP = MXCMP - 2
C                                       If room for all components
         IF (XNCC.LE.MXCMP) THEN
C                                       IF using a scratch file
            IF (DISKI.LE.0) THEN
               DISK = SCRVOL(CNOSCI)
               CNO = SCRCNO(CNOSCI)
            ELSE
               DISK = DISKI
               CNO = CNOSCI
               END IF
C                                       Fill Frequency table.
            CALL FRQTAB (DISK, CNO, LUN, CATBLK, FREQID, BUFF1, IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Divide model.
            CALL VISDFT (APCORE, 'DIV ', CHANEL, NCHAN, DISKI, CNOSCI,
     *         DISKO, CNOSCO, 0, DOSUM, DOMSG, CATBLK, JBUFSZ, BUFF1,
     *         BUFF2, BUFF3, IRET)
C                                       Check for too many comps.
            IF (IRET.EQ.10) GO TO 100
            GO TO 999
            END IF
         END IF
C                                       Use UVMSUB for model.
C                                       Copy to padded scratch file.

 100  ISCR2 = 0
C                                       Message to about division
      MSGTXT = 'Divide data by model - first compute model by summing'
      IF (MSGSUP.NE.32000) CALL MSGWRT (3)
      CALL UVDPAD (DISKI, CNOSCI, ISCR2, JBUFSZ, BUFF1, BUFF2, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Get scratch file header
      IF (DISKI.LE.0) THEN
         DISKX = SCRVOL(CNOSCI)
         CNOX = SCRCNO(CNOSCI)
      ELSE
         DISKX = DISKI
         CNOX = CNOSCI
         END IF
      CALL CATIO ('READ', DISKX, CNOX, CATSCR, 'REST', BUFF1, IRET)
      IF ((IRET.GE.1) .AND. (IRET.LE.4)) GO TO 999
      IRET = 0
C                                       Determine BIF, EIF
      BIF = 1
      EIF = 1
C                                       If more than 1 IF
      IF (JLOCIF.GT.0) THEN
         EIF = CATBLK(KINAX+JLOCIF)
C                                       Copy part portion of IF table
         IV = 1
         OV = 1
         CALL CHNCOP (IV, OV, LUN, LUN2, DISKX, SCRVOL(ISCR2), CNOX,
     *      SCRCNO(ISCR2), CATBLK, CATSCR, BIF, EIF, FREQID, SFOFF,
     *      BUFF1, BUFF2, BUFF3, BUFF4, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       End if more than 1 IF
         END IF
C                                       Compute model.
C                                       Set factor for subtraction.
      FACGRD(1) = - FACGRD(1)
C                                       Redefine record size in
C                                       /UVHDR/.
      DISKX = 0
      SAVNRP = NRPARM
      SAVLRC = LREC
      NRPARM = LREC
      LREC = 2 * SAVLRC - SAVNRP
      CALL UVMSUB (APCORE, DISKX, ISCR2, DISKX, ISCR2, 0, MODEL, METHOD,
     *   CHANEL, NCHAN, F, DOMSG, CATBLK, JBUFSZ, FREQID, BUFF1, BUFF2,
     *   BUFF3, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Restore /UVHDR/
      NRPARM = SAVNRP
      LREC = SAVLRC
C                                       Reset factor for subtraction.
      FACGRD(1) = - FACGRD(1)
C                                       If no output file specified
C                                       use ISCR2
      IF ((DISKO.LE.0) .AND. (CNOSCO.LE.0)) CNOSCO = ISCR2
C                                       Divide/compress record to output
      LCHANL = CHANEL
      LCHAN = NCHAN
      IF (MODMAX.GT.0) THEN
         LCHAN = 0
         LCHANL = 1000000
         DO 110 I = 1,MODMAX
            IV = MODCHN(I) + MODNCH(I) - 1
            LCHAN = MAX (LCHAN, IV)
            LCHANL = MIN (LCHANL, MODCHN(I))
 110        CONTINUE
         LCHAN = LCHAN - LCHANL + 1
         END IF
      CALL UVDOUT (ISCR2, DISKO, CNOSCO, LCHANL, LCHAN, JBUFSZ,
     *   BUFF1, BUFF2, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Delete scratch file
      IF (ISCR2.GT.0) THEN
         CALL COPY (256, CATBLK, TEMP)
         SCFRW = 2
         IV = 1
         CALL MAPCLR (IV, SCRVOL(ISCR2), SCRCNO(ISCR2), SCFRW, BUFF1)
         IF (ISCR2.EQ.NSCR) NSCR = NSCR - 1
         CALL COPY (256, TEMP, CATBLK)
         END IF
C
 999  RETURN
      END

      SUBROUTINE MOVIST (OP, ICHAN, NFR, NFRPCH, MAG, IERR)
C-----------------------------------------------------------------------
C! sets/resets the movie status parameters in the TV common
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   MOVIST sets and resets the movie status parameters in the TV common.
C   Inputs:
C      OP      C*4   'ONNN' when turning on a movie
C                    'OFFF' when clearing channel(s)
C      ICHAN   I     Bit pattern of channels involved (OFFF)
C                    Actual first channel number (1-NGRAY, ONNN)
C      NFR     I     Number of frames in movie total (ONNN)
C      NFRPCH  I     Number of frames per TV channel (ONNN)
C                    < 0 => in display rather than movie order
C      MAG     I     Magnification number (0 - 3, ONNN)
C   Output:
C      IERR    I     Error = 2 => bad input, else ok
C   The code: bit 1 (lsb) 1 (on) = display order, 0 => movie order
C                 2       1 => frame starts movie
C                 3-6     magnification step
C                 7-15    # frames
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   ICHAN, NFR, NFRPCH, MAG, IERR
C
      INTEGER   ICH, IC, ICS, ICN, IL, ILS, ILM, ILN, I, ILT
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
C                                       check inputs
      IERR = 2
      IF (('ONNN'.NE.OP) .AND. ('OFFF'.NE.OP)) GO TO 999
      ICH = ICHAN
C                                       Turn OFFF channel(s)
      IF (OP.EQ.'ONNN') GO TO 50
         IF (ICHAN.LE.0) ICH = 2 ** NGRAY - 1
         IERR = 0
         DO 40 I = 1,NGRAY
            IC = MOD (ICH, 2)
            IF (IC.EQ.0) GO TO 30
            IC = I
            IF (TYPMOV(IC).EQ.0) GO TO 30
C                                       channel is part of a movie
            IL = IC
            ICS = MOD (TYPMOV(IC)/2, 2)
            ICN = TYPMOV(IC) / 64
            TYPMOV(IC) = 0
C                                       next higher starts sub-movie
            ILT = MOD(TYPMOV(IC+1), 2)
            IF ((IC.LT.NGRAY) .AND. (TYPMOV(IC+1).NE.0))
     *         TYPMOV(IC+1) = 4 * (TYPMOV(IC+1) / 4)  +  2 + ILT
C                                       lower smaller movies now
            IF (ICS.EQ.1) GO TO 30
 20            IL = IL - 1
               IF (IL.LE.0) GO TO 30
                  ILT = MOD(TYPMOV(IL), 2)
                  ILS = MOD (TYPMOV(IL)/2, 2)
                  ILM = MOD (TYPMOV(IL)/4, 16)
                  ILN = TYPMOV(IL) / 64 - ICN
                  IF (ILN.LE.0) TYPMOV(IL) = 0
                  IF (ILN.GT.0) TYPMOV(IL) = ILT + 2*ILS + 4*ILM +
     *               64*ILN
                  IF ((ILN.GT.0) .AND. (ILS.EQ.0)) GO TO 20
 30         ICH = ICH / 2
            IF (ICH.EQ.0) GO TO 999
 40         CONTINUE
         GO TO 999
C                                       Turn on a channel: check
 50   CONTINUE
         IF ((NFR.LE.0) .OR. (NFRPCH.EQ.0)) GO TO 999
         IF ((MAG.LT.0) .OR. (MAG.GT.15) .OR.
     *      (MAG.GT.IABS(MXZOOM))) GO TO 999
         IF ((ICHAN.LT.1) .OR. (ICHAN.GT.NGRAY)) GO TO 999
         IERR = 0
C                                       channel is part of a movie
         IF (TYPMOV(ICHAN).EQ.0) GO TO 60
            IL = ICHAN
            ILT = MOD (TYPMOV(ICHAN+1), 2)
            ICS = MOD (TYPMOV(ICHAN)/2, 2)
            ICN = TYPMOV(ICHAN) / 64
C                                       next higher starts sub-movie
            IF ((ICHAN.LT.NGRAY) .AND. (TYPMOV(ICHAN+1).NE.0))
     *         TYPMOV(ICHAN+1) = 4 * (TYPMOV(ICHAN+1) / 4) + 2 + ILT
C                                       lower smaller movies now
            IF (ICS.EQ.1) GO TO 60
 55            IL = IL - 1
               IF (IL.LE.0) GO TO 60
                  ILT = MOD (TYPMOV(IL), 2)
                  ILS = MOD (TYPMOV(IL)/2, 2)
                  ILM = MOD (TYPMOV(IL)/4, 16)
                  ILN = TYPMOV(IL) / 64 - ICN
                  IF (ILN.LE.0) TYPMOV(IL) = 0
                  IF (ILN.GT.0) TYPMOV(IL) = ILT + 2*ILS + 4*ILM +
     *               64*ILN
                  IF ((ILN.GT.0) .AND. (ILS.EQ.0)) GO TO 55
C                                       Insert new movie
 60      IL = ICHAN
         IC = NFR
         DO 70 I = IL,NGRAY
            TYPMOV(I) = 4 * MAG + 64 * IC
            IF (I.EQ.IL) TYPMOV(I) = TYPMOV(I) + 2
            IF (NFRPCH.LT.0) TYPMOV(I) = TYPMOV(I) + 1
            IC = IC - ABS(NFRPCH)
            IF (IC.LE.0) GO TO 999
 70         CONTINUE
C
 999  RETURN
      END

      SUBROUTINE TABMRG (DISK, CNO, TYPE, INVER, OUTVER, EKOL, SKOL,
     *   TKOL, ITABL, OTABL, CATBLK, OUTNUM, IERR)
C-----------------------------------------------------------------------
C! merges rows of an an input table file
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TABMRG merges an AIPS general table-format file.  It does not sort
C   the file - so sorts must be done first if merging is to make any
C   sense.  TABMRG compares row N with row N+1 and merges the two,
C   summing columns SKOL and using row N for the others, if each of
C   columns EKOL are within TKOL of each other.
C   Inputs:
C      DISK    I         Disk number to use
C      CNO     I         Primary file catalog number
C      TYPE    C*2       Extension file type (e.g. CC)
C      INVER   I         Input extension file number (0 -> high)
C      EKOL    I(*)      Columns which must be "equal" by logical
C                        column number.  A zero MUST terminate the
C                        list unless it is 25 long.  Must have >0.
C      SKOL    I(*)      Columns which will be summed on a merge by
C                        column number.  A zero MUST terminate the
C                        list unless it is 25 long.  May be 0.
C      TKOL    R(*)      Tolerance for equality by logical column
C                        number (parallel to EKOL list)
C   In/out:
C      OUTVER  I         Output extension file number (0 -> high+1)
C      CATBLK  I(256)    Primary file header
C   Output:
C      ITABL   I(512)    Scratch for input table IO
C      OTABL   I(512)    Scratch for output table IO
C      OUTNUM  I         Number rows in output file.
C      IERR    I         Error code: 0 -> ok
C                           1 -> input file open error
C                           2 -> input parameter error
C                           3 -> output file create/open error
C                           4 -> ZFIO IO error
C                           5 -> TABIO IO error
C-----------------------------------------------------------------------
      CHARACTER TYPE*2
      INTEGER   DISK, CNO, INVER, OUTVER, EKOL(*), SKOL(*), ITABL(*),
     *   OTABL(*), CATBLK(256), OUTNUM, IERR
      REAL      TKOL(*)
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER PHNAME*48, CHTEST*2
      INTEGER   NREC, NCOL, NKEY, ILUN, OLUN, IFIND, OFIND, NE, NS, I,
     *   IDATP(128,2), ODATP(128,2), J, EPCOL(25), ESLEN(25), ETYPE(25),
     *   SPCOL(25), STYPE(25), IP, JP, LIM, NFIRST, NWORD, KKEY, ICOL,
     *   IREC(XBPRSZ), OREC(XBPRSZ), NCH, IER, SPLEN(25), NCOPY, ICOUNT,
     *   IRNO, OCOUNT, CHKTYP(128), CHKCOL(128), CHKLEN(128), JJP
      REAL      IREC4(XBPRSZ), OREC4(XBPRSZ)
      LOGICAL   SAME, FIRST, IRECL(XBPRSZ), ORECL(XBPRSZ), CHKIT(128)
      DOUBLE PRECISION    IREC8(XBPRSZ/2), OREC8(XBPRSZ/2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (IREC, IRECL, IREC4, IREC8)
      EQUIVALENCE (OREC, ORECL, OREC4, OREC8)
C-----------------------------------------------------------------------
C                                       Open input file
      NREC = 20
      NCOL = 0
      NKEY = 0
      ILUN = 29
      IFIND = 0
      OFIND = 0
      CALL TABINI ('READ', TYPE, DISK, CNO, INVER, CATBLK, ILUN, NKEY,
     *   NREC, NCOL, IDATP, ITABL, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1000) IER
         IERR = 1
         GO TO 990
         END IF
C                                       Init. columns to check for
C                                       blanking
      DO 10 ICOL = 1,NCOL
         CHKCOL(ICOL) = IDATP(ICOL,1)
         CHKLEN(ICOL) = IDATP(ICOL,2) / 10
         CHKTYP(ICOL) = MOD (IDATP(ICOL,2), 10)
C                                       Only check double and real
         CHKIT(ICOL) = (CHKTYP(ICOL).EQ.1) .OR. (CHKTYP(ICOL).EQ.2)
 10      CONTINUE
C                                       Check inputs
      NE = 0
      IFIND = ITABL(82)
      DO 20 I = 1,25
         IF ((EKOL(I).LE.0) .OR. (EKOL(I).GT.NCOL)) GO TO 25
            NE = I
            IP = EKOL(I)
            EPCOL(I) = IDATP(IP,1)
            ESLEN(I) = IDATP(IP,2) / 10
            ETYPE(I) = IDATP(IP,2) - 10 * ESLEN(I)
            IF (TKOL(I).LT.0.0) TKOL(I) = 0.0
            CHKIT(IP) = .FALSE.
 20      CONTINUE
 25   NS = 0
      IERR = 2
      DO 30 I = 1,25
         IP = SKOL(I)
         IF ((IP.LE.0) .OR. (IP.GT.NCOL)) GO TO 35
            NS = I
            SPCOL(I) = IDATP(IP,1)
            SPLEN(I) = IDATP(IP,2) / 10
            STYPE(I) = IDATP(IP,2) - 10 * SPLEN(I)
            CHKIT(IP) = .FALSE.
            IP = STYPE(I)
            IF ((IP.EQ.1) .OR. (IP.EQ.2) .OR. (IP.EQ.4)) GO TO 30
               WRITE (MSGTXT,1025)
               GO TO 990
 30      CONTINUE
 35   IF (NE.GT.0) GO TO 40
         WRITE (MSGTXT,1035)
         GO TO 990
C                                       Find in catalog header
C                                       TABINI called FXHDEX for us
 40   DO 45 I = 1,KIEXTN
         CALL H2CHR (2, 1, CATBLK(KHEXT+I-1), CHTEST)
         IF (TYPE.EQ.CHTEST) GO TO 50
 45      CONTINUE
      GO TO 999
C                                       check OUTVER
 50   JP = KIVER + I - 1
      LIM = CATBLK(JP)
      I = LIM + 1
      IF ((OUTVER.LE.0) .OR. (OUTVER.GT.I)) OUTVER = I
      SAME = OUTVER.EQ.INVER
C                                       Number input rows
      ICOUNT = ITABL(5)
C                                       Set up for create
      CALL COPY (256, ITABL, OTABL)
      CALL COPY (256, IDATP, ODATP)
      OLUN = ILUN + 1
      IF (.NOT.SAME) GO TO 55
         OLUN = ILUN
         CALL ZCLOSE (ILUN, IFIND, IER)
         IFIND = 0
C                                       Create
 55   CALL TABINI ('WRIT', TYPE, DISK, CNO, OUTVER, CATBLK, OLUN, NKEY,
     *   NREC, NCOL, ODATP, OTABL, IER)
      IF (IER.LE.0) GO TO 60
         WRITE (MSGTXT,1055) IER
         IERR = 3
         GO TO 990
C                                       Save info from input header
C                                       Creation date, time
 60   NCOPY = 6
      CALL COPY (NCOPY, ITABL(11), OTABL(11))
C                                       Creation task
      NCOPY = 3
      CALL COPY (NCOPY, ITABL(29), OTABL(29))
C                                       Sort info
      OTABL(43) = ITABL(43)
      OTABL(44) = ITABL(44)
C                                       Number of keywords
      OTABL(53) = ITABL(53)
C                                       Selection strings
      NCOPY = 10
      CALL COPY (NCOPY, ITABL(61), OTABL(61))
C                                       Title
      NCOPY = 28
      CALL COPY (NCOPY, ITABL(101), OTABL(101))
C                                       Copy Keywords et al.
      OFIND = OTABL(82)
      IF (SAME) IFIND = OFIND
      NFIRST = OTABL(50)
      IERR = 4
      IF (SAME) GO TO 75
         DO 70 I = 2,NFIRST
            IRNO = I
            CALL ZFIO ('READ', ILUN, IFIND, IRNO, ITABL(257), IER)
            IF (IER.EQ.0) GO TO 65
               WRITE (MSGTXT,1060) IER, 'READ', IRNO
               GO TO 900
 65         CALL ZFIO ('WRIT', OLUN, OFIND, IRNO, ITABL(257), IER)
            IF (IER.EQ.0) GO TO 70
               WRITE (MSGTXT,1060) IER, 'WRIT', IRNO
               GO TO 900
 70         CONTINUE
         ITABL(77) = 5
         ITABL(78) = NFIRST
C                                       more set ups
 75   NWORD = ITABL(72)
      FIRST = .TRUE.
      OCOUNT = 0
      IERR = 5
C                                      copy rows:
 100  DO 200 IRNO = 1,ICOUNT
         CALL TABIO ('READ', 0, IRNO, IREC, ITABL, IER)
         IF (IER.LT.0) GO TO 200
         IF (IER.EQ.0) GO TO 110
            WRITE (MSGTXT,1100) IER, 'READ', IRNO
            GO TO 900
 110     IF (FIRST) GO TO 195
C                                       is everything equal
         DO 150 ICOL = 1,NE
            IP = EPCOL(ICOL)
            KKEY = ETYPE(ICOL)
            NCH = ESLEN(ICOL)
            GO TO (115, 120, 125, 130, 135, 140, 145), KKEY
C                                       D
 115        CONTINUE
               DO 116 I = 1,NCH
                  IF (ABS(IREC8(IP+I-1)-OREC8(IP+I-1)).GT.TKOL(ICOL))
     *               GO TO 190
 116              CONTINUE
               GO TO 150
C                                       R
 120        CONTINUE
               DO 121 I = 1,NCH
                  IF (ABS(IREC4(IP+I-1)-OREC4(IP+I-1)).GT.TKOL(ICOL))
     *               GO TO 190
 121              CONTINUE
               GO TO 150
C                                       Hollerith: exact match
 125        CONTINUE
               DO 126 I = 1,NCH,4
                  J = (I-1) / 4 + IP
                  IF (IREC4(J).NE.OREC4(J)) GO TO 190
 126              CONTINUE
               GO TO 150
C                                       I
 130        CONTINUE
               DO 131 I = 1,NCH
                  IF (ABS(IREC(IP+I-1)-OREC(IP+I-1)).GT.TKOL(ICOL))
     *               GO TO 190
 131              CONTINUE
               GO TO 150
C                                       Logical
 135        CONTINUE
               DO 136 I = 1,NCH
                  IF ((IRECL(IP+I-1)) .AND. (ORECL(IP+I-1))) GO TO 190
                  IF ((.NOT.IRECL(IP+I-1)) .AND. (.NOT.ORECL(IP+I-1)))
     *               GO TO 190
 136              CONTINUE
               GO TO 150
C                                       I
 140        CONTINUE
               WRITE (MSGTXT,1140) ICOL
               IERR = 2
               GO TO 900
C                                       BIT: exact match
 145        CONTINUE
               NCH = (ESLEN(ICOL) - 1) / NBITWD + 1
               DO 146 I = 1,NCH
                  J = IP + I - 1
                  IF (IREC(J).NE.OREC(J)) GO TO 190
 146              CONTINUE
 150         CONTINUE
C                                       All equal: do summing taking
C                                       care of blanked values
         IF (NS.GT.0) THEN
            DO 160 ICOL = 1,NS
               IP = SPCOL(ICOL)
               KKEY = STYPE(ICOL)
               NCH = SPLEN(ICOL)
 155           IF (NCH.LE.0) GO TO 160
               IF (KKEY.EQ.1) THEN
                  IF (OREC8(IP).EQ.DBLANK) THEN
                     OREC8(IP) = IREC8(IP)
                  ELSE IF (IREC8(IP).NE.DBLANK) THEN
                     OREC8(IP) = OREC8(IP) + IREC8(IP)
                     END IF
               ELSE IF (KKEY.EQ.2) THEN
                  IF (OREC4(IP).EQ.FBLANK) THEN
                     OREC4(IP) = IREC4(IP)
                  ELSE IF (IREC4(IP).NE.FBLANK) THEN
                     OREC4(IP) = OREC4(IP) + IREC4(IP)
                     END IF
               ELSE IF (KKEY.EQ.4) THEN
                  OREC(IP) = OREC(IP) + IREC(IP)
                  END IF
               IP = IP + 1
               NCH = NCH - 1
               GO TO 155
 160           CONTINUE
            END IF
C                                       Take unblanked values
         DO 180 ICOL = 1,NCOL
            IP = CHKCOL(ICOL)
            KKEY = CHKTYP(ICOL)
            NCH = CHKLEN(ICOL)
            IF (.NOT.CHKIT(ICOL)) GO TO 180
C                                       Loop over elements
 175           IF (NCH.LE.0) GO TO 180
               IF (KKEY.EQ.1) THEN
                  IF (OREC8(IP).EQ.DBLANK) OREC8(IP) = IREC8(IP)
               ELSE IF (KKEY.EQ.2) THEN
                  IF (OREC4(IP).EQ.FBLANK) OREC4(IP) = IREC4(IP)
                  END IF
               IP = IP + 1
               NCH = NCH - 1
               GO TO 175
 180        CONTINUE
         GO TO 200
C                                       Not equal: write old
 190     OCOUNT = OCOUNT + 1
         CALL TABIO ('WRIT', 0, OCOUNT, OREC, OTABL, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1100) IER, 'WRIT', OCOUNT
            GO TO 900
            END IF
C                                       move new row to out buffer
 195     CALL COPY (NWORD, IREC, OREC)
         FIRST = .FALSE.
 200     CONTINUE
C                                       write last record
      IF (.NOT.FIRST) THEN
         OCOUNT = OCOUNT + 1
         CALL TABIO ('WRIT', 0, OCOUNT, OREC, OTABL, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1100) IER, 'WRIT', OCOUNT
            GO TO 900
            END IF
         END IF
C                                       close output
      OTABL(5) = OCOUNT
C                                       transfer sort order ?
      IF (.NOT.SAME) THEN
         IP = ABS (ITABL(43))
         IF (IP.GT.256) IP = IP - 256
         JJP = ABS (ITABL(44))
         IF (JJP.GT.256) JJP = JJP - 256
         DO 210 I = 1,NS
            IF ((SKOL(I).EQ.IP) .OR. (SKOL(I).EQ.JJP)) GO TO 220
 210        CONTINUE
         OTABL(43) = ITABL(43)
         OTABL(44) = ITABL(44)
         END IF
 220  CALL TABIO ('CLOS', 0, OCOUNT, OREC, OTABL, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1100) IER, 'CLOS', OCOUNT
         GO TO 900
         END IF
C                                       close input
      IF (.NOT.SAME) CALL TABIO ('CLOS', 0, IRNO, IREC, ITABL, IER)
      OUTNUM = OCOUNT
      IERR = 0
      GO TO 999
C                                       Error close down
 900  CALL MSGWRT (8)
      CALL ZCLOSE (OLUN, OFIND, IER)
      IF (.NOT.SAME) CALL ZCLOSE (ILUN, IFIND, IER)
C                                       destroy new files only
      IF (OUTVER.LE.LIM) GO TO 999
         CALL ZPHFIL (TYPE, DISK, CNO, OUTVER, PHNAME, IER)
         CALL ZDESTR (DISK, PHNAME, IER)
         IF (IER.NE.0) GO TO 999
            CATBLK(JP) = LIM
            CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'REST', ITABL, IER)
            GO TO 999
C
 990  CALL MSGWRT (8)
      IF (OFIND.GT.0) CALL ZCLOSE (OLUN, OFIND, IER)
      IF ((IFIND.GT.0) .AND. (IFIND.NE.OFIND)) CALL ZCLOSE (ILUN,
     *   IFIND, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TABMRG: ERROR',I7,' OPENING INPUT TABLE')
 1025 FORMAT ('TABMRG: CANNOT SUM LOGICALS, CHARACTERS, OR BITS')
 1035 FORMAT ('TABMRG: NO VALID TEST COLUMNS SPECIFIED')
 1055 FORMAT ('TABMRG: ERROR',I7,' OPENING OUTPUT TABLE')
 1060 FORMAT ('TABMRG: ZFIO ERROR',I7,1X,A4,'ING RECORD',I10)
 1100 FORMAT ('TABMRG: TABIO ERROR',I7,1X,A4,'ING ROW',I10)
 1140 FORMAT ('TABMRG: COLUMN TYPE 6 IN COLUMN',I4,' NO LONGER LEGAL')
      END

LOCAL INCLUDE 'AFARS.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   HSIZE, FSIZE, HSIZER, FSIZER
      REAL      CELL
      INTEGER   CATI1(256), CATI2(256), CATB(256,2), CATIO(256,3)
      REAL      CATR1(256), CATR2(256)
      HOLLERITH CATH1(256), CATH2(256)
      DOUBLE PRECISION CATD1(128), CATD2(128)
      REAL      IROW(MABFSS,2), ACUT, ABL(2), XN(3), XX(3)
      CHARACTER NAMIN(2)*12, CLSIN(2)*6, NAMOUT(3)*12, CLSOUT(3)*6,
     *   OPCOD*4
      LOGICAL   BFLAG(3), AMPHAS
      INTEGER   IBLC(7,2), ITRC(7,2), NPI(7,2), NPO(7), FBL(2), ILUN(2),
     *   IIND(2), OLUN(3), OIND(3), ISSEQ(2), IDSEQ(3), NAX, NRDIM(2),
     *   CTYPE, IUSER, IPOINT, FCVOL(5), FCCNO(5), HISTDO, USEOLD
      COMMON /FARSCM/ CATB, CATIO, IROW, ACUT, ABL, HSIZE, FSIZE,
     *   HSIZER, FSIZER, CELL, XN, XX, BFLAG, AMPHAS, FBL, IBLC, ITRC,
     *   NPI, NPO, ILUN, IIND, OLUN, OIND, ISSEQ, IDSEQ, NAX, NRDIM,
     *   CTYPE, IUSER, IPOINT, FCVOL, FCCNO, HISTDO, USEOLD
      COMMON /FARSCH/ NAMIN, CLSIN, NAMOUT, CLSOUT, OPCOD
      EQUIVALENCE (CATI1, CATR1, CATD1, CATH1, CATB(1,1))
      EQUIVALENCE (CATI2, CATR2, CATD2, CATH2, CATB(1,2))
      INCLUDE 'INCS:DCAT.INC'
LOCAL END
      PROGRAM AFARS
C-----------------------------------------------------------------------
C! use outputs of FARS to find maximum position and its Amp & Phase.
C# Map-util SPECTRAL POLARIZATION ANALYSIS
C-----------------------------------------------------------------------
C;  Copyright (C) 2011-2013, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AFARS can be ran after FARS to carry out additional data reduction.
C   Inputs: (from AIPS)
C   INNAME......First image name.     Standard defaults.
C   INCLASS.....First image class.    Standard defaults.
C   INSEQ.......First image seq. #.   0 => highest.
C   INDISK......Disk drive # for the first image.  0 => any.
C   IN2NAME.....Second image name.    Standard defaults.
C   IN2CLASS....Second image class.   Standard defaults.
C   IN2SEQ......Second image seq. #.  0 => highest.
C   IN2DISK.....Disk drive # for the second image.  0 => any.
C   OUT2NAME....Second output image name.     Standard defaults.
C   OUT2CLAS....Second output image class.    Standard defaults.
C   OUT2SEQ.....Second output image seq. #.   0 => highest.
C   OUT2DISK....Second output disk. 0 => highest with space.
C   DOALIGN.....Controls how the four images are to be aligned (see HELP
C               DOALIGN).  True (>.1) means that the images must agree
C               in their coordinates, though not necessarily in the
C               reference pixel position.  Alignment is by coordinate
C               values (if DOALIGN > -0.1) or by offsets from the
C               reference pixel positions (if DOALIGN <= -0.1).  NOTE:
C               all real axes (>1 point) are aligned.  If DOALIGN = -2,
C               the headers are ignored and the images are aligned at
C               pixel (1,1,...).
C   OUTNAME.....Output image name.    Standard defaults.
C   OUTCLASS....Output image class.   Standard behavior with default.
C               The noise image has the 6th character of class set to N.
C   OUTSEQ......Output image seq. #.  0 => highest unique.
C   OUTDISK.....Output disk number. 0 => highest with space.
C   BLC.........Bottom left corner of the 1st input image. The other
C               images are aligned by coordinates (see DOALIGN) on all
C               axes having > 1 point.  The other images may have fewer
C               real axes than the 1st.  The 4 windows must have the
C               same dimension on the first 2 axes, but the task will
C               select a smaller window than was specified if needed to
C               overlap the 4 images.
C   TRC.........Top right corner of input images. (See BLC.)
C   OPCODE......Amplmax or phase to send to the second cube
C   DOHIST.....-2 => copy 1st HI only
C              -3 => no copy of HI
C- uses the FARS.FOR as initial codes !---------------------------------
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   IRET, IERR, IWIN(4), ISWIN(4), NBY, NXI, NYI, IDEPTH(5),
     *   IBLKOF, NBYBUF, ISPOS(2), IDPOS(3), I3, I4, I5, I6, I7, I, IY,
     *   NF, INY
      INCLUDE 'AFARS.INC'
      REAL      XBUFF(MABFSS,3)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGNAM /'AFARS '/
      DATA ISWIN /0,0,0,0/
C-----------------------------------------------------------------------
C                                        Initialize input maps
      IRET = 16
      CALL FARSIN (PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Do-loop limits: window
      NBY = 2
      NBYBUF = MABFSS * NBY
C                                       make a correct value
C                                       corresponded to the actual
C                                       first axis pixels
      NF = NPO(1)
      NXI = CATBLK(KINAX)
      NYI = CATBLK(KINAX+1)
      CALL COPY (7, CATBLK(KINAX), NPO)
      DO 80 I7 = 1,NPO(7)
      DO 79 I6 = 1,NPO(6)
      DO 78 I5 = 1,NPO(5)
      DO 77 I4 = 1,NPO(4)
      DO 76 I3 = 1,NPO(3)
C                                        Initialize output file
         IDEPTH(1) = I3
         IDEPTH(2) = I4
         IDEPTH(3) = I5
         IDEPTH(4) = I6
         IDEPTH(5) = I7
         CALL COMOFF (NAX, NPO, IDEPTH, IBLKOF, IERR)
         IF (IERR.NE.0) GO TO 995
         IBLKOF = IBLKOF + 1
         ISWIN(1) = 1
         ISWIN(2) = 1
         ISWIN(3) = NXI
         ISWIN(4) = NYI
         DO 10 I = 1,3
            CALL MINIT ('WRIT', OLUN(I), OIND(I), NXI, NYI, ISWIN,
     *         XBUFF(1,I), NBYBUF, IBLKOF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1020) I, IERR
               GO TO 980
               END IF
 10         CONTINUE
         DO 60 INY = 1,NYI
            DO 15 I = 1,3
               CALL MDISK ('WRIT', OLUN(I), OIND(I), XBUFF(1,I),
     *            IDPOS(I), IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1040) INY, I, IERR
                  GO TO 980
                  END IF
 15            CONTINUE
C                                        Initialize input maps
            DO 20 I = 1,2
               CALL FILL (5, 1, IDEPTH(1))
               IF (NRDIM(I).GE.3) IDEPTH(1) = INY - 1 + IBLC(3,I)
               IF (NRDIM(I).GE.4) IDEPTH(2) = I3 - 1 + IBLC(4,I)
               IF (NRDIM(I).GE.5) IDEPTH(3) = I4 - 1 + IBLC(5,I)
               IF (NRDIM(I).GE.6) IDEPTH(4) = I5 - 1 + IBLC(6,I)
               IF (NRDIM(I).GE.7) IDEPTH(5) = I6 - 1 + IBLC(7,I)
               CALL COMOFF (NAX, NPI(1,I), IDEPTH, IBLKOF, IERR)
               IF (IERR.NE.0) GO TO 995
               IBLKOF = IBLKOF + 1
               IWIN(1) = IBLC(1,I)
               IWIN(2) = IBLC(2,I)
               IWIN(3) = ITRC(1,I)
               IWIN(4) = ITRC(2,I)
               CALL MINIT ('READ', ILUN(I), IIND(I), NPI(1,I), NPI(2,I),
     *            IWIN, IROW(1,I), NBYBUF, IBLKOF, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1010) I, IERR
                  GO TO 980
                  END IF
 20            CONTINUE
C                                        Loop over rows
            DO 50 IY = 1,NXI
               DO 30 I = 1,2
                  CALL MDISK ('READ', ILUN(I), IIND(I), IROW(1,I),
     *               ISPOS(I), IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1030) IY, I, IERR
                     GO TO 980
                     END IF
 30               CONTINUE
C                                       do real work
               CALL XFARSN (IROW(ISPOS(1),1), IROW(ISPOS(2),2),
     *            XBUFF(IDPOS(1),1), XBUFF(IDPOS(2),2),
     *            XBUFF(IDPOS(3),3))
               IDPOS(1) = IDPOS(1) + 1
               IDPOS(2) = IDPOS(2) + 1
               IDPOS(3) = IDPOS(3) + 1
 50            CONTINUE
 60         CONTINUE
C                                        Write the last buffer
         DO 70 I = 1,3
            CALL MDISK ('FINI', OLUN(I), OIND(I), XBUFF(1,I),
     *         IDPOS(I), IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1060) I, IERR
               GO TO 980
               END IF
 70         CONTINUE
 76      CONTINUE
 77      CONTINUE
 78      CONTINUE
 79      CONTINUE
 80      CONTINUE
C                                        Create and write HI file
      CALL FARSHI (IRET)
      GO TO 995
C                                        Error return
 980  CALL MSGWRT (7)
C
 995  CALL DIE (IRET, IROW)
C
 999  STOP
C-----------------------------------------------------------------------
 1010 FORMAT ('COULD NOT INITIALIZE INPUT FILE #',I2,'  IER=',I7)
 1020 FORMAT ('COULD NOT INITIALIZE OUTPUT FILE #',I2,'  IER=',I7)
 1030 FORMAT ('COULD NOT READ LINE',I4,'  MAP #',I2,'  IER=',I7)
 1040 FORMAT ('COULD NOT WRITE LINE',I4,'  MAP #',I2,'  IER=',I7)
 1060 FORMAT ('COULD NOT WRITE LAST LINE, MAP #',I2,'.  IER=',I7)
      END
      SUBROUTINE FARSIN (PRGNAM, IER)
C-----------------------------------------------------------------------
C   FARSIN gets the inputs for AFARS, opens and checks the input images,
C   creates the output image(s), and prepares parameters in common for
C   the later stages of AFARS.
C   Inputs:
C      PRGNAM   C*6   Program name
C   Outputs:
C      IER      I     Error return: 0-->  Okay
C                        3-->  Cannot create and open output file
C                        2-->  Cannot open either input map
C                        1-->  Error in getting input parameters
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   IER
C
      CHARACTER IDCDEF*6, PHNAME*48, MTYPE*2, STOKES*8, CHTMP*8,
     *   CHTMP1*8, UNITS(2)*8
      INTEGER   I, IERR, IRETCD, INPRMS, NB, INC, J, I1, IROUND, K
      LOGICAL   REDUCE, T
      REAL      STOKI(2), STOKO, EPS, X, AXV
      REAL      XSEQ1, XDSK1, XSEQ2, XDSK2, SEQOUT, DISOUT, BPARM(10),
     *   BLC(7), TRC(7), GRIDCR, DOHIST
      HOLLERITH XNAM1(3), XCLS1(2), XNAM2(3), XCLS2(2), XNAMOU(3),
     *   XOPCOD(1)
      DOUBLE PRECISION    DAXV
C
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'AFARS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      COMMON /INPARM/ XNAM1, XCLS1, XSEQ1, XDSK1, XNAM2, XCLS2, XSEQ2,
     *   XDSK2, XNAMOU, SEQOUT, DISOUT, GRIDCR, BLC, TRC, XOPCOD, BPARM,
     *   DOHIST
      DATA EPS /0.2/
      DATA T /.TRUE./
      DATA STOKES /'STOKES  '/
C-----------------------------------------------------------------------
C                                        Initialize file and header I/O
      ILUN(1) = 17
      ILUN(2) = 18
      OLUN(1) = 21
      OLUN(2) = 22
      OLUN(3) = 23
C
      CALL ZDCHIN (T)
      CALL VHDRIN
      NSCR = 0
      NCFILE = 0
      IER = 0
C                                        Get inputs from AIPS
      INPRMS = 46
      CALL GTPARM (PRGNAM, INPRMS, RQUICK, XNAM1, IROW, IERR)
      IRETCD = IERR
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (7)
         END IF
      IF (RQUICK) CALL RELPOP (IRETCD, IROW, IERR)
      IF (IRETCD.NE.0) GO TO 980
C                                       Change input OPCODE - char
      HISTDO = IROUND (DOHIST)
      CALL H2CHR (4, 1, XOPCOD, OPCOD)
      CTYPE = 1
      ACUT = BPARM(1)
      ACUT = MAX (0.0, ACUT)
      IF (ABS(BPARM(2)+1111.0).LT.0.5) BPARM(2) = FBLANK
      IF (ABS(BPARM(3)+1111.0).LT.0.5) BPARM(3) = FBLANK
      ABL(1) = BPARM(2)
      ABL(2) = BPARM(3)
C                                        Transfer inputs into integer
C                                        variables
      FCVOL(1) = IROUND (XDSK1)
      FCVOL(2) = IROUND (XDSK2)
      FCVOL(3) = IROUND (DISOUT)
      FCVOL(4) = IROUND (DISOUT)
      FCVOL(5) = IROUND (DISOUT)
      ISSEQ(1) = IROUND (XSEQ1)
      ISSEQ(2) = IROUND (XSEQ2)
      IDSEQ(1) = IROUND (SEQOUT)
      IDSEQ(2) = IROUND (SEQOUT)
      IDSEQ(3) = IROUND (SEQOUT)
      IUSER = NLUSER
      USEOLD = IROUND (BPARM(5))
C                                       Hollerith -> Char.
      CALL H2CHR (12, 1, XNAM1, NAMIN(1))
      CALL H2CHR (6, 1, XCLS1, CLSIN(1))
      CALL H2CHR (12, 1, XNAM2, NAMIN(2))
      CALL H2CHR (6, 1, XCLS2, CLSIN(2))
C
      CALL H2CHR (12, 1, XNAMOU, NAMOUT(1))
      NAMOUT(2) = NAMOUT(1)
      NAMOUT(3) = NAMOUT(1)
      CLSOUT(1) = ' '
      CLSOUT(2) = ' '
      CLSOUT(3) = ' '
C                                        Open both input maps
      MTYPE = 'MA'
C
      DO 35 I = 1,2
         CALL MAPOPN ('READ', FCVOL(I), NAMIN(I), CLSIN(I), ISSEQ(I),
     *      MTYPE, IUSER, ILUN(I), IIND(I), FCCNO(I), CATBLK,
     *      IROW(1,I), IERR)
         CALL COPY (256, CATBLK, CATB(1,I))
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1025) I,IERR
            CALL MSGWRT (7)
            GO TO 960
            END IF
         NCFILE = NCFILE + 1
         FRW(NCFILE) = 0
         FVOL(NCFILE) = FCVOL(I)
         FCNO(NCFILE) = FCCNO(I)
         CALL H2CHR (8, 1, CATH(KHBUN), UNITS(I))
         NB = CATBLK(KIDIM)
         CALL FILL (KICTPN, 1, NPI(1,I))
         CALL COPY (NB, CATBLK(KINAX), NPI(1,I))
         NRDIM(I) = NB
         DO 30 J = 1,NB
            NPI(J,I) = MAX (1, NPI(J,I))
            IF (NPI(J,I).LE.1) NRDIM(I) = NRDIM(I) - 1
 30         CONTINUE
 35      CONTINUE
      AMPHAS = UNITS(1).NE.UNITS(2)
C                                        Set up some needed header vals
      REDUCE = .FALSE.
      NAX = CATI1(KIDIM)
      CALL WINDOW (NAX, NPI(1,1), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 960
      DO 40 I = 1,7
         IBLC(I,1) = BLC(I) + EPS
         ITRC(I,1) = TRC(I) + EPS
         NPO(I) = ITRC(I,1) - IBLC(I,1) + 1
 40      CONTINUE
C                                       Are input maps coincident?
C                                       Set 2nd map corners
      INC = 2
      K = 2
      CALL COPY (256, CATB(1,K), CATBLK)
      DO 45 I = 1,7
         J = I - 1
C                                       null axis
         IBLC(I,K) = 1
         ITRC(I,K) = 1
         IF (NPI(I,K).GT.1) THEN
            AXV = CATR(KRCRP+J) - CATR1(KRCRP+J) + IBLC(I,1)
            IF (GRIDCR.LT.-1.5) AXV = IBLC(I,1)
            IF (GRIDCR.GT.-0.1) THEN
               DAXV = CATD1(KDCRV+J) + (IBLC(I,1) -
     *            CATR1(KRCRP+J)) * CATR1(KRCIC+J)
               IF (CATR(KRCIC+J).EQ.0.0) GO TO 55
               AXV = (DAXV - CATD(KDCRV+J)) / CATR(KRCIC+J) +
     *            CATR(KRCRP+J)
               END IF
            IBLC(I,K) = IROUND (AXV)
            IF ((GRIDCR.GE.0.1) .AND. (ABS(AXV-IBLC(I,K)).GT.EPS))
     *         GO TO 55
            ITRC(I,K) = IBLC(I,K) + ITRC(I,1) - IBLC(I,1)
C                                       smaller subimage required?
            IF (IBLC(I,K).LT.1) THEN
               IBLC(I,1) = IBLC(I,1) + 1 - IBLC(I,K)
               BLC(I) = IBLC(I,1)
               REDUCE = .TRUE.
               IBLC(I,K) = 1
               END IF
            IF (ITRC(I,K).GT.NPI(I,K)) THEN
               ITRC(I,1) = ITRC(I,1) + NPI(I,K) - ITRC(I,K)
               TRC(I) = ITRC(I,1)
               REDUCE = .TRUE.
               ITRC(I,K) = NPI(I,K)
               END IF
            IF (IBLC(I,1).GT.ITRC(I,1)) GO TO 55
            NPO(I) = ITRC(I,1) - IBLC(I,1) + 1
C                                        Check coincidence
            IF (GRIDCR.GE.0.1) THEN
               IPOINT = KHCTP+J*INC
               CALL H2CHR (8, 1, CATH(IPOINT), CHTMP)
               CALL H2CHR (8, 1, CATH1(IPOINT), CHTMP1)
               IF (CHTMP.NE.CHTMP1) GO TO 55
               X = EPS * EPS * ABS(CATR1(KRCIC+J))
               IF (ABS(CATR(KRCIC+J)-CATR1(KRCIC+J)).GT.X)
     *            GO TO 55
               IF (ABS(CATR(KRCRT+J)-CATR1(KRCRT+J)).GT.1.)
     *            GO TO 55
               END IF
            END IF
 45      CONTINUE
      GO TO 60
C                                        Maps not coincident
 55   WRITE (MSGTXT,1075) I
      CALL MSGWRT (7)
      GO TO 960
C                                       Create output map
 60   MSGTXT = 'FARSIN: input maps coincident on reduced subimage only'
      IF (REDUCE) CALL MSGWRT (6)
      XX(1) = -1.0E30
      XX(2) = -1.0E30
      XX(3) = -1.0E30
      XN(1) = 1.0E30
      XN(2) = 1.0E30
      XN(3) = 1.0E30
      BFLAG(1) = .FALSE.
      BFLAG(2) = .FALSE.
      BFLAG(3) = .FALSE.
      CALL COPY (256, CATI1, CATBLK)
      INC = 2
      STOKO = -1
      DO 85 I = 1,NAX
         IPOINT = KHCTP+(I-1)*INC
         CALL H2CHR (8, 1, CATH(IPOINT), CHTMP)
         IF (CHTMP.EQ.STOKES) GO TO 95
 85      CONTINUE
C                                        No Stokes axis
      STOKI(1) = -10
      GO TO 110
 95   I1 = KDCRV + I - 1
      STOKI(1) = CATD(I1) + CATR(KRCIC+I-1) * (IBLC(I,1) -
     *   CATR(KRCRP+I-1))
      STOKI(2) = CATD2(I1) + CATR2(KRCIC+I-1) * (IBLC(I,2) -
     *   CATR2(KRCRP+I-1))
C                                        Various cases
      IF (STOKI(1).EQ.STOKI(2)) STOKO = STOKI(1)
C
      IF (NPO(I).LE.1) THEN
         CATD(I1) = STOKO
         CATR(KRCRP+I-1) = 1.0
         END IF
C                                        Default out class
 110  IDCDEF = 'AFARrm'
C                                        Set header values for output
C                                        map
      CALL MAKOUT (NAMIN(1), CLSIN(1), ISSEQ(1), IDCDEF, NAMOUT(1),
     *   CLSOUT(1), IDSEQ(1))
      CALL CHR2H (12, NAMOUT(1), KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLSOUT(1), KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = IDSEQ(1)
      CATBLK(KIIMU) = NLUSER
C                                       set all axis for the output file
      CALL SUBHDR (BLC, TRC, 1.0, 1.0)
C                                       CELL and FSIZE from the header
      CELL = CATR(KRCIC)
      FSIZE = CATBLK(KINAX)
C                                       FSIZE is an odd number
      HSIZE = FSIZE/2
C                                        move axes 2-7 to 1-6
      J = 0
      K = CATBLK(KIDIM) - 1
      DO 115 I = 1,K
         CATBLK(KINAX+J) = MAX (1, CATBLK(KINAX+I))
         CATD(KDCRV+J) = CATD(KDCRV+I)
         CATR(KRCRP+J) = CATR(KRCRP+I)
         CATR(KRCIC+J) = CATR(KRCIC+I)
         CATR(KRCRT+J) = CATR(KRCRT+I)
         CATH(KHCTP+2*J) = CATH(KHCTP+2*I)
         CATH(KHCTP+2*J+1) = CATH(KHCTP+2*I+1)
         CALL H2CHR (8, 1, CATH(KHCTP+2*J), CHTMP)
         IF (CHTMP.NE.STOKES) J = J + 1
 115     CONTINUE
      CATBLK(KIDIM) = J
      DO 116 K = 0,6
         IF (K.LT.J) THEN
            CATBLK(KINAX+K) = MAX (1, CATBLK(KINAX+K))
         ELSE
            CATBLK(KINAX+K) = 1
            END IF
 116     CONTINUE
C                                        Put in map units
      CALL MCREAT (FCVOL(3), FCCNO(3), IROW, IERR)
      IDSEQ(1) = CATI1(KIIMS)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) IERR
         CALL MSGWRT (8)
         GO TO 950
         END IF
      NCFILE = NCFILE + 1
      FRW(NCFILE) = 2
      FVOL(NCFILE) = FCVOL(3)
      FCNO(NCFILE) = FCCNO(3)
C                                       Copy header keywords from first
C                                       input.
      CALL KEYPCP (FCVOL(1), FCCNO(1), FCVOL(3), FCCNO(3), 0, ' ', IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1135) IERR
         CALL MSGWRT (7)
         END IF
C                                        Open the output file
      CALL ZPHFIL ('MA', FCVOL(3), FCCNO(3), 1, PHNAME, IERR)
      CALL ZOPEN (OLUN(1), OIND(1), FCVOL(3), PHNAME, T, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1136) IERR
         CALL MSGWRT (7)
         GO TO 950
         END IF
      CALL COPY (256, CATBLK, CATIO(1,1))
C                                       output map 2
      IDCDEF = 'AFARam'
      IF (OPCOD.EQ.'CMPL') IDCDEF = 'AFARre'
      CALL MAKOUT (NAMIN(1), CLSIN(1), ISSEQ(1), IDCDEF, NAMOUT(2),
     *   CLSOUT(2), IDSEQ(2))
      CALL CHR2H (12, NAMOUT(2), KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLSOUT(2), KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = IDSEQ(2)
      CATBLK(KIIMU) = NLUSER
      CALL CHR2H (8, 'JY/BEAM ', 1, CATH(KHBUN))
      CALL MCREAT (FCVOL(4), FCCNO(4), IROW, IERR)
      IDSEQ(2) = CATI1(KIIMS)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) IERR
         CALL MSGWRT (8)
         GO TO 950
         END IF
      NCFILE = NCFILE + 1
      FRW(NCFILE) = 2
      FVOL(NCFILE) = FCVOL(4)
      FCNO(NCFILE) = FCCNO(4)
C                                       Copy header keywords from first
C                                       input.
      CALL KEYPCP (FCVOL(1), FCCNO(1), FCVOL(4), FCCNO(4), 0, ' ',
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1135) IERR
         CALL MSGWRT (7)
         END IF
C                                        Open the output file
      CALL ZPHFIL ('MA', FCVOL(4), FCCNO(4), 1, PHNAME, IERR)
      CALL ZOPEN (OLUN(2), OIND(2), FCVOL(4), PHNAME, T, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1136) IERR
         CALL MSGWRT (7)
         GO TO 950
         END IF
      CALL COPY (256, CATBLK, CATIO(1,2))
C                                       output map 3
      IDCDEF = 'AFARph'
      IF (OPCOD.EQ.'CMPL') IDCDEF = 'AFARim'
      CALL MAKOUT (NAMIN(1), CLSIN(1), ISSEQ(1), IDCDEF, NAMOUT(3),
     *   CLSOUT(3), IDSEQ(3))
      CALL CHR2H (12, NAMOUT(3), KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLSOUT(3), KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = IDSEQ(3)
      CATBLK(KIIMU) = NLUSER
C
      IF (OPCOD.NE.'CMPL') THEN
         CALL CHR2H (8, 'DEGREES ', 1, CATH(KHBUN))
      ELSE
         CALL CHR2H (8, 'JY/BEAM ', 1, CATH(KHBUN))
         END IF
      CALL MCREAT (FCVOL(5), FCCNO(5), IROW, IERR)
      IDSEQ(3) = CATI1(KIIMS)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) IERR
         CALL MSGWRT (8)
         GO TO 950
         END IF
      NCFILE = NCFILE + 1
      FRW(NCFILE) = 2
      FVOL(NCFILE) = FCVOL(5)
      FCNO(NCFILE) = FCCNO(5)
C                                       Copy header keywords from first
C                                       input.
      CALL KEYPCP (FCVOL(1), FCCNO(1), FCVOL(5), FCCNO(5), 0, ' ',
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1135) IERR
         CALL MSGWRT (7)
         IERR = 0
         END IF
C                                        Open the output file
      CALL ZPHFIL ('MA', FCVOL(5), FCCNO(5), 1, PHNAME, IERR)
      CALL ZOPEN (OLUN(3), OIND(3), FCVOL(5), PHNAME, T, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1136) IERR
         CALL MSGWRT (7)
         GO TO 950
         END IF
      CALL COPY (256, CATBLK, CATIO(1,3))
C
      GO TO 999
C-----------------------------------------------------------------------
C                                        Error returns
C                                        Failed to create output file
 950  IER = IER + 1
C                                        Error in MAPOPN
 960  IER = IER + 1
C                                        Error in getting parameters
 980  IER = IER + 1
C
      WRITE (MSGTXT,1900) IERR
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('FARSIN: COULD NOT GET PARMS.  IER=',I7)
 1025 FORMAT ('FARSIN: COULD NOT OPEN MAP # ',I1,'  IER=',I7)
 1075 FORMAT ('FARSIN: INPUT MAPS ARE NOT COINCIDENT ON AXIS',I2)
 1110 FORMAT ('FARSIN: COULD NOT CREATE OUTPUT MAP.  IER=',I7)
 1135 FORMAT ('FARSIN: ERROR ', I3,' COPYING KEYWORDS - CONTINUING')
 1136 FORMAT ('FARSIN: COULD NOT OPEN OUTPUT MAP.  IER=',I7)
 1900 FORMAT ('TABIO: ERROR = ', I3)
      END
      SUBROUTINE XFARSN (V1, V2, R1, R2, R3)
C-----------------------------------------------------------------------
C   XFARSN combines two pixel rows V1 and V2 with noise rows S1 and S2
C   to form result row R1 and noise row R2.  The algorithm is specified
C   by FARS and any parameters are stored in the array C.
C   Inputs:
C      V1     R(*)   The pixel values of the input map 1 * = FSIZE
C      V2     R(*)   The pixel values of the input map 2
C   Outputs:
C      R1     R      The position of the maximum
C      R2     R      The amplitude or real at that point
C      R3     R      The phase or imaginary at that point
C-----------------------------------------------------------------------
      REAL      V1(*), V2(*), R1, R2, R3
C
      INTEGER   K, KMAXAM, NEQUAT, NFIT, IPOIN, IRET, IP1, IP2
      REAL      PHASE, AMP, RMAXAM, POSMAX, FUNC(25), ARGUM(25),
     *   FITPAR(3), VARRES, AMPMAX, TREAL, TIMAG
C
      INCLUDE 'AFARS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      IF (USEOLD.LE.0) THEN
         IP1 = 2
         IP2 = 4
      ELSE
         IP1 = 1
         IP2 = 5
         END IF
C                                       read the input files of
C                                       amplitue and phase
      AMPMAX = 1.0E-20
      KMAXAM = -1
      IRET = 0
      DO 10 K = 1,FSIZE
         IF (V1(K).NE.FBLANK) THEN
            IF (AMPHAS) THEN
               AMP = V1(K)
            ELSE
               AMP = SQRT (V1(K)*V1(K) + V2(K)*V2(K))
               END IF
C                                       Find position of maximum of
C                                       amplitude
            IF (AMP.GT.AMPMAX) THEN
               AMPMAX = AMP
               KMAXAM = K
               END IF
            END IF
 10      CONTINUE
      IF (KMAXAM.LE.0) THEN
         POSMAX = ABL(1)
         PHASE = ABL(2)
         TREAL = 0.0
         TIMAG = 0.0
      ELSE
         IF (AMPHAS) THEN
            PHASE = V2(KMAXAM)
            TREAL = AMPMAX * COS (DG2RAD * PHASE)
            TIMAG = AMPMAX * SIN (DG2RAD * PHASE)
         ELSE
            PHASE = RAD2DG * ATAN2 (V2(KMAXAM), V1(KMAXAM))
            TREAL = V1(KMAXAM)
            TIMAG = V2(KMAXAM)
            END IF
C
C                                       make more precise position of
C                                       the maximum at amplitude, only
C
C                                       take 5 (+-2) points near maximum
         NEQUAT = 5
         NFIT = 3
         DO 20 IPOIN = IP1,IP2
            K = KMAXAM + IPOIN - 3
C                                       K is outside of range
            IF ((K.LT.1) .OR. (K.GT.FSIZE)) IRET = 1
C
            ARGUM(IPOIN) = IPOIN - 3
            IF (V1(K).EQ.FBLANK) THEN
               NFIT = 0
            ELSE
               IF (AMPHAS) THEN
                  FUNC(IPOIN) = V1(K)
               ELSE
                  FUNC(IPOIN) = SQRT (V1(K)*V1(K) + V2(K)*V2(K))
                  END IF
               END IF
 20         CONTINUE
C                                       find the three coefficients of
C                                       parabolla by least square
C                                       Y = A*X*X + B*X +C
C                                       C= FITPAR(1), B=FITPAR(2)
C                                       A = FITPAR(3)
         RMAXAM = 0.0
         IF ((NFIT.EQ.3) .AND. (IRET.EQ.0) .AND. (USEOLD.LE.1)) THEN
            IF (USEOLD.LE.0) THEN
               CALL QCUBE (FUNC(2), RMAXAM, AMPMAX)
               TREAL = AMPMAX * COS (DG2RAD * PHASE)
               TIMAG = AMPMAX * SIN (DG2RAD * PHASE)
            ELSE
               CALL SOLIN (ARGUM, FUNC, NFIT, NEQUAT, FITPAR, VARRES,
     *            IRET)
C                                       the more precise max position
               IF (IRET.EQ.0) THEN
                  RMAXAM = -FITPAR(2) / (2*FITPAR(3))
                  IF (ABS(RMAXAM).GT.1.0) THEN
                     RMAXAM = 0.0
                  ELSE
                     AMPMAX = FITPAR(1) - FITPAR(2)*FITPAR(2)/4.0
     *                  /FITPAR(3)
                     TREAL = AMPMAX * COS (DG2RAD * PHASE)
                     TIMAG = AMPMAX * SIN (DG2RAD * PHASE)
                     END IF
                  END IF
               END IF
            END IF
         RMAXAM = RMAXAM + KMAXAM + IBLC(1,1) - 1
C                                       max position in FARADROT (1/l^2)
C                                       Dec 30: Position of maximum at
C                                       cells relatively the center of
C                                       the input data  NPI(1,1)/2 + 1
C      POSMAX = (RMAXAM - NPI(1,1)/2 - 1) * CELL
C                                       correct coordinate computation
C                                       drop assumptions.
         POSMAX = (RMAXAM - CATR1(KRCRP)) * CELL + CATD1(KDCRV)
C                                       change the value of POSMAX
C                                       if AMPL is considered small
         IF (AMPMAX.LE.ACUT) THEN
            POSMAX = ABL(1)
            PHASE = ABL(2)
            END IF
         END IF
C                                       position (RM) of maximum
      R1 = POSMAX
      IF (OPCOD.EQ.'CMPL') THEN
         R2 = TREAL
         R3 = TIMAG
      ELSE
         R2 = AMPMAX
         R3 = PHASE
         END IF
C                                       Get max/min
      IF (R1.NE.FBLANK) THEN
         XX(1) = MAX (XX(1), R1)
         XN(1) = MIN (XN(1), R1)
      ELSE
         BFLAG(1) = .TRUE.
         END IF
      IF (R2.NE.FBLANK) THEN
         XX(2) = MAX (XX(2), R2)
         XN(2) = MIN (XN(2), R2)
      ELSE
         BFLAG(2) = .TRUE.
         END IF
      IF (R3.NE.FBLANK) THEN
         XX(3) = MAX (XX(3), R3)
         XN(3) = MIN (XN(3), R3)
      ELSE
         BFLAG(3) = .TRUE.
         END IF
C
 999  RETURN
      END
      SUBROUTINE FARSHI (IRET)
C-----------------------------------------------------------------------
C   FARSHI creates and writes the HI file associated with task AFARS.
C   Outputs:
C      IRET   I      > 0 => output all blanks
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER HILINE*72, FTYPE(5)*10, NOTTYP*2, CTIME*8, CDATE*12
      INTEGER   NHISTF, IHDLUN, IHSLUN, I, IER, IERR, IBUFF1(256), J,
     *    IBUFF2(256), IPTR, ITEMP, FU, TIME(3), DATE(3)
      INCLUDE 'AFARS.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (IBUFF1(1),IROW(1,1)),  (IBUFF2(1),IROW(257,1))
      DATA NHISTF, IHDLUN, IHSLUN /2,27,28/
      DATA FTYPE /'RotMeasure','Amplitude', 'Phase','Real','Imaginary'/
      DATA NOTTYP /'CC'/
C-----------------------------------------------------------------------
C                                       Initialize HITAB
      CALL HIINIT (NHISTF)
      IRET = 0
      DO 200 J = 3,1,-1
         FU = J
         IF ((OPCOD.EQ.'CMPL') .AND. (J.GT.1)) FU = FU + 2
C                                       Test validity of result
         IF (XX(J).LT.XN(J)) THEN
            WRITE (MSGTXT,1000) FTYPE(FU)
            CALL MSGWRT (6)
            BFLAG(J) = .TRUE.
         ELSE IF (XX(J).EQ.XN(J)) THEN
            WRITE (MSGTXT,1001) FTYPE(FU), XX(J)
            CALL MSGWRT (6)
            END IF
C                                       Insert header parameters
         CALL COPY (256, CATIO(1,J), CATBLK)
         CATR(KRDMN) = XN(J)
         CATR(KRDMX) = XX(J)
C                                        Put in inhibited pixel value
         CATR(KRBLK) = 0.0
         IF (BFLAG(J)) CATR(KRBLK) = FBLANK
         IF (J.EQ.1) CALL CHR2H (8, 'RAD/M/M ', 1, CATH(KHBUN))
C                                       Create and open new HI file
         CALL HICREA (IHDLUN, FCVOL(2+J), FCCNO(2+J), CATBLK, IBUFF2,
     *      IERR)
         IPTR = IBUFF2(3)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) FTYPE(J), IERR
            CALL MSGWRT (7)
            GO TO 200
            END IF
C                                       Copy both input HI files
         IF (HISTDO.GE.-2) THEN
            I = 1
            WRITE (HILINE,1020) I
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            ITEMP = HITAB(IPTR+2)
            CALL HIOPEN (IHSLUN, FCVOL(I), FCCNO(I), IBUFF1, IERR)
            IF (IERR.NE.0) GO TO 30
            CALL HICOPY (IHSLUN, IBUFF1, IHDLUN, IBUFF2, IERR)
            CALL HICLOS (IHSLUN, .FALSE., IBUFF1, IER)
            IF (IERR.EQ.0) GO TO 50
            IF (IERR.GE.100) HITAB(IPTR+2) = ITEMP
 30            WRITE (MSGTXT,1030) I, IERR
               CALL MSGWRT (6)
               WRITE (HILINE,1031)
               CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
 50         I = 2
            WRITE (HILINE,1032) TSKNAM, I
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            END IF
         WRITE (HILINE,1050)
         CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         CALL ZDATE (DATE)
         CALL ZTIME (TIME)
         CALL TIMDAT (TIME, DATE, CTIME, CDATE)
         WRITE (HILINE,1055) TSKNAM, RLSNAM, CDATE, CTIME
         CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       Add input parameters
         CALL HENCO1 (TSKNAM, NAMIN(1), CLSIN(1), ISSEQ(1), FCVOL(1),
     *      IHDLUN, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         CALL HENCO2 (TSKNAM, NAMIN(2), CLSIN(2), ISSEQ(2), FCVOL(2),
     *      IHDLUN, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         CALL HENCOO (TSKNAM, NAMOUT(J), CLSOUT(J), IDSEQ(J),
     *      FCVOL(2+J), IHDLUN, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         WRITE (HILINE,1094) TSKNAM, (IBLC(I,1), I = 1,7)
         CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         WRITE (HILINE,1096) TSKNAM, (ITRC(I,1), I = 1,7)
         CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         WRITE (HILINE,1097) TSKNAM, ACUT
         CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         IF (J.EQ.1) THEN
            WRITE (HILINE,1098) TSKNAM, ABL(1)
            IF (ABL(1).EQ.FBLANK) WRITE (HILINE,1100) TSKNAM
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
         ELSE IF (FU.EQ.3) THEN
            WRITE (HILINE,1099) TSKNAM, ABL(2)
            IF (ABL(1).EQ.FBLANK) WRITE (HILINE,1100) TSKNAM
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            END IF
C                                       Close HI file
 190     CALL HICLOS (IHDLUN, .TRUE., IBUFF2, IER)
         WRITE (MSGTXT,1900) FTYPE(FU)
         IF ((IER.NE.0) .OR. (IERR.NE.0)) WRITE (MSGTXT,1901)
     *      FTYPE(J), IERR, IER
         CALL MSGWRT (2)
C                                        Copy tables
         CALL ALLTAB (1, NOTTYP, IHSLUN, IHDLUN, FCVOL, FCVOL(J+2),
     *      FCCNO, FCCNO(J+2), CATBLK, IBUFF1, IBUFF2, IERR)
         IF (IERR.GT.2) THEN
            MSGTXT = 'ERROR COPYING TABLE FILES'
            CALL MSGWRT (6)
            END IF
C                                       Close map file
         CALL MAPCLS ('INIT', FCVOL(2+J), FCCNO(2+J), OLUN(J),
     *      OIND(J), CATBLK, .TRUE., IBUFF2, IERR)
         NCFILE = NCFILE - 1
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1910) FTYPE(J), IERR
            CALL MSGWRT (6)
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OUTPUT ',A,' FILE COMPLETELY BLANKED',
     *   ' -- saving it anyway')
 1001 FORMAT ('Output ',A,' FILE constant at',1PE13.5,
     *   ' -- saving it anyway')
 1010 FORMAT ('FARSHI: could not create HISTORY FOR ',A,' FILE.  IER=',
     *   I5)
 1020 FORMAT (31X,'/ History of input map', I2)
 1030 FORMAT ('WARNING COULD NOT OPEN/COPY INPUT HI FILE=',I2,
     *   '.  IER=',I7)
 1031 FORMAT (31X,'/ NO HISTORY TO BE FOUND')
 1032 FORMAT (A6,'/ No history copied from file',I2)
 1050 FORMAT (31X,'/ End of old histories')
 1055 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',A12,2X,A8)
 1094 FORMAT (A6,'BLC=',7I5,' / Bottom left corner')
 1096 FORMAT (A6,'TRC=',7I5,' / Top right corner')
 1097 FORMAT (A6,'BPARM(1)=',1PE13.5,' / clip level')
 1098 FORMAT (A6,'BPARM(2)=',F12.5,' / RM value when clipped')
 1099 FORMAT (A6,'BPARM(3)=',F12.5,' / phase value when clipped')
 1100 FORMAT (A6,'  / Magic value blanks used when image clipped')
 1900 FORMAT ('History file created and written for ',A,' file')
 1901 FORMAT ('HISTORY FILE FOR ',A,' INCOMPLETE.  IERRS =',2I7)
 1910 FORMAT ('WARNING FARSHI COULD NOT CLOSE OUTPUT ',A,
     *   ' FILE.  IER=',I7)
      END
      SUBROUTINE QCUBE (D, X, DM)
C-----------------------------------------------------------------------
C   Does an exact cubic fit to 3 values from consecutive pixels
C   Inputs
C      D        R(3)   values to fit (at x = -1,0,1)
C   Outputs
C      X    R   X position of maximum
C      DM   R   Maximum D
C-----------------------------------------------------------------------
      REAL      D(3), X, DM
C
      REAL      FITPAR(3), P
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      X = 0.0
      DM = D(2)
      IF ((D(1).NE.FBLANK) .AND. (D(2).NE.FBLANK) .AND.
     *   (D(3).NE.FBLANK)) THEN
         FITPAR(1) = D(2)
         FITPAR(2) = (D(3) - D(1)) / 2.0
         FITPAR(3) = (D(3) + D(1)) / 2.0 - D(2)
         IF (FITPAR(3).NE.0.0) THEN
            P = -FITPAR(2) / (2.0 * FITPAR(3))
            IF (ABS(P).LT.1.0) THEN
               X = P
               DM = FITPAR(1) + FITPAR(2) * X + FITPAR(3) * X * X
               END IF
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE SOLIN (ARG, FUNC, NFIT, NEQUAT, FITPAR, VARRES, IRET)
C-----------------------------------------------------------------------
C   Routine to fit a polynom to the data by Least Square method
C   Input:
C      ARG     R(*)  Array of data arguments
C      FUNC    R(*)  Array of data function
C      NFIT    I     Number of parameters to fit
C      NEQUAT  I     Total number of points at arrays ARG and FUNC
C   Output:
C      FITPAR  R(*)  Array of found parameters of fitting function
C      VARRES  R     SQRT of residuals
C      IRET    I     Error; 0 => OK
C-----------------------------------------------------------------------
      INTEGER  NFIT, NEQUAT, I, IFIT, KFIT, IKFIT, IRET
      REAL     ARG(*), FUNC(*), R(20), MATR(400), NOBS, SUM,
     *   SSQ, VX(20), SSQRES, VARRES, VARY, FIT, FITPAR(*)
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Force result vector R(NFIT),
C                                       matrix M(NFIT*NFIT) to zero
      DO 20 IFIT = 1, NFIT
         R(IFIT) = 0.0
         DO 10 KFIT = 1, NFIT
            IKFIT = IFIT + (KFIT - 1)*NFIT
            MATR (IKFIT) = 0.0
 10         CONTINUE
 20      CONTINUE
      SUM = 0.0
      SSQ = 0.0
      NOBS = 0.0
C                                       Prepare result vector R(NFIT)
C                                       and matrix MATR(NFIT*NFIT)
C                                       for routine LEASQR

      DO 80 I = 1, NEQUAT
         NOBS = NOBS + 1
         SUM = SUM + FUNC(I)
         SSQ = SSQ + FUNC(I)*FUNC(I)
C
         DO 60 IFIT = 1, NFIT
            R(IFIT) = R(IFIT) + FUNC(I) * (ARG(I) ** (IFIT - 1))
C                                       calculate upper/right
C                                       triangle of MATR
            DO 40 KFIT = IFIT, NFIT
               IKFIT = IFIT + (KFIT-1)*NFIT
               MATR(IKFIT) = MATR(IKFIT) +
     *            (ARG(I) ** (IFIT - 1)) * (ARG(I) ** (KFIT - 1))
   40          CONTINUE
   60       CONTINUE
 80      CONTINUE
C
      CALL LEASQR (NFIT, NOBS, SUM, SSQ, R, MATR, FITPAR, VX, SSQRES,
     *   VARRES, VARY, FIT, IRET)
      VARRES = SQRT(VARRES)
C
  999 RETURN
      END
      SUBROUTINE LEASQR (NP, N, SUM, SSQ, R, M, X, VX, SSQRES,
     *   VARRES, VARY, FIT, IERR)
C-----------------------------------------------------------------------
C   The private version excludes the print out when there is a problem
C   LEASQR does the matrix inversion and other necessary tasks
C   involved in a least squares analysis.
C   Given:
C          NP        I     Number of parameters.
C          N         R     The number of observations.
C          SUM       R     Error sum.
C          SSQ       R     Square error sum.
C          R(NP)     R     Results vector.
C
C   Given and returned:
C          M(NP,NP)  R     On input, the upper triangular part contains
C                          the design matrix.  This is not changed.
C                          On output, the lower triangular part contains
C                          the covariance matrix.  Diagonal elements of
C                          the covariance matrix are stored in VX.
C
C   Returned:
C          X(NP)     R     Vector holding the least squares solution.
C          VX(NP)    R     Variance of the best fit parameters.
C          SSQRES    R     Sum of squares of the residuals.
C          VARRES    R     Variance of the residuals.
C          VARY      R     Variance of the error values.
C          FIT       R     Goodness of fit parameter, lies between 0
C                          and 1.
C          IERR      I     Error status, 0 means successful.
C                             1 - nonspecific error return,
C                             2 - insufficient degrees of freedom.
C
C     Called:
C          none
C
C     Algorithm:
C          LU-triangular factorization with scaled partial pivoting.
C          The sub-diagonal triangular matrix contains the scaling
C          factors used at each step in the Gaussian elimination.  Row
C          interchanges are recorded in vectors MXS and SXM.
C             During forward substitution, the pivoting and Gaussian
C          elimination operations performed on matrix M are applied to
C          vector R.  Vector X holds the intermediate result.
C             On backward substitution, successive elements of the
C          solution vector, X, are calculated by substitution of the
C          preceding elements into the equations of the upper triangular
C          factorization of the design matrix.
C
C     Notes:
C       1) Strictly speaking, the design matrix will usually contain
C          rows of zeroes and therefore be singular.  This arises if no
C          observations sensitive to a particular parameter have been
C          done.
C             In practice, any such singularities are ignored and the
C          associated parameters remain undetermined.
C
C       2) The covariance matrix is the inverse of M(i,j) multiplied by
C          the variance of the residuals.  It is obtained by forward and
C          backward substitution on the columns of the unit matrix.
C
C       3) Two statement functions, C, and SC have been employed to
C          partially alleviate the problems posed by passing arrays in
C          FORTRAN.  The design/covariance matrix m(i,j) is copied into
C          the working vector s(i).  This is addressed by using C, and
C          SC in an attempt to make it look like the matrix that it
C          actually represents.
C
C       4) The maximum size problem that LEASQR can handle is set by
C          parameter MX.
C
C     Author:
C          Mark Calabretta, Australia Telescope.
C          Origin; 1988/Sep/29. Code last modified; 1989/Nov/22.
C-----------------------------------------------------------------------
C     Parameter which determines the maximum size problem.
      INTEGER   MX
      PARAMETER (MX = 50)

      INTEGER   C, I, IERR, ITEMP, J, K, MXS(MX), NF, NP, PIVOT,
     *          SXM(MX)
      REAL      COLMAX, DTEMP, FIT, M(NP,NP), N, R(NP), RESIDU, RLEN,
     *          ROWMAX(MX), S(MX*MX), SC, RTEMP, SSQ, SSQRES, SUM,
     *          VARRES, VARY, VX(NP), W(MX), X(NP)

      INCLUDE 'INCS:DMSG.INC'

C     Statement functions for array manipulation, see note 3 above.
      C(I,J)  = NP*(I-1) + J
      SC(I,J) = S(C(I,J))
C-----------------------------------------------------------------------
C  Initialize.
C     Anticipate and return immediately on error.
      IERR = 1

C     Initialize arrays.
      DO 40 I = 1, NP
C        Vector which records row interchanges.
         MXS(I) = I

C        The solution and variance vectors.
         X(I)  = 0.0
         VX(I) = 0.0

C        Copy the design matrix and zero the covariance matrix.
         DO 10 J = 1, I-1
            M(I,J) = 0.0
            S(C(I,J)) = M(J,I)
 10      CONTINUE
         DO 20 J = I, NP
            S(C(I,J)) = M(I,J)
 20      CONTINUE

C        Find the maximum absolute element in each row.
         ROWMAX(I) = 0.0
         DO 30 J = 1, NP
            ROWMAX(I) = MAX(ROWMAX(I), ABS(SC(I,J)))
 30      CONTINUE
 40   CONTINUE

      VARY   = 0.0
      SSQRES = 0.0
      VARRES = 0.0
      FIT    = 0.0


C     Find the number of degrees of freedom.
      NF = N
      DO 60 I = 1, NP
         IF (ROWMAX(I).NE.0.0) THEN
            NF = NF - 1
         ELSE IF (R(I).NE.0.0) THEN
C           Any row of zeroes must extend to the results vector.
C            WRITE (MSGTXT,50) I
C 50         FORMAT ('LEASQR: Design matrix inconsistency in row',I4)
C            CALL MSGWRT (6)
         END IF
 60   CONTINUE

      IF (NF.LE.1) THEN
C         WRITE (MSGTXT,70)
C 70      FORMAT ('LEASQR: Insufficient degrees of freedom.')
C         CALL MSGWRT (6)
         IERR = 2
         RETURN
      END IF


C  Factorize the matrix.
      DO 120 K = 1, NP
C        Check for a row of zeroes.
         IF (ROWMAX(K).EQ.0.0) GO TO 120

C        A non-zero row maximum implies non-zero diagonal element.
         IF (SC(K,K).EQ.0.0) THEN
C            WRITE (MSGTXT,50) MXS(K)
C            CALL MSGWRT (6)
            GO TO 120
         END IF

C        Decide whether to pivot.
         COLMAX = ABS(SC(K,K))/ROWMAX(K)
         PIVOT = K
         DO 80 I = K+1, NP
            IF (ROWMAX(I).NE.0.0) THEN
               IF (ABS(SC(I,K))/ROWMAX(I).GT.COLMAX) THEN
                  COLMAX = ABS(SC(I,K))/ROWMAX(I)
                  PIVOT = I
               END IF
            END IF
 80      CONTINUE

         IF (PIVOT.GT.K) THEN
C           We must pivot, interchange the rows of the design matrix.
            DO 90 J = 1, NP
               DTEMP = SC(PIVOT,J)
               S(C(PIVOT,J)) = SC(K,J)
               S(C(K,J)) = DTEMP
 90         CONTINUE

C           Don't forget the vector of row maxima.
            DTEMP = ROWMAX(PIVOT)
            ROWMAX(PIVOT) = ROWMAX(K)
            ROWMAX(K) = DTEMP

C           Record the interchange for later use.
            ITEMP = MXS(PIVOT)
            MXS(PIVOT) = MXS(K)
            MXS(K) = ITEMP
         END IF

C        Gaussian elimination.
         DO 110 I = K+1, NP
C           Nothing to do if SC(i,k) is zero.
            IF (SC(I,K).NE.0.0) THEN
C              Save the scaling factor.
               S(C(I,K)) = SC(I,K)/SC(K,K)

C              Subtract rows.
               DO 100 J = K+1, NP
                  S(C(I,J)) = SC(I,J) - SC(I,K)*SC(K,J)
 100           CONTINUE
            END IF
 110     CONTINUE
 120  CONTINUE

C     MXS(i) records which row of M corresponds to row i of SC.
C     SXM(i) records which row of S corresponds to row i of M.
      DO 130 I = 1, NP
         SXM(MXS(I)) = I
 130  CONTINUE


C  Solve the normal equations.
      DO 150 I = 1, NP
C        Forward substitution.
         W(I) = R(MXS(I))
         DO 140 J = 1, I-1
            W(I) = W(I) - SC(I,J)*W(J)
 140     CONTINUE
 150  CONTINUE

      DO 170 I = NP, 1, -1
C        Backward substitution.
         IF (SC(I,I).NE.0.0) THEN
            DO 160 J = I+1, NP
               W(I) = W(I) - SC(I,J)*W(J)
 160        CONTINUE
            W(I) = W(I)/SC(I,I)
         END IF
         X(I) = W(I)
 170  CONTINUE

C     Check that the solution is acceptable.
      RLEN = 0.0
      RESIDU = 0.0
      DO 200 I = 1, NP
         RTEMP = 0.0
         DO 180 J = 1, I-1
            RTEMP = RTEMP + M(J,I)*X(J)
 180     CONTINUE
         DO 190 J = I, NP
            RTEMP = RTEMP + M(I,J)*X(J)
 190     CONTINUE

         RLEN = RLEN + R(I)**2
         RESIDU = RESIDU + (RTEMP - R(I))**2
 200  CONTINUE

      IF (RESIDU.GT.0.001*RLEN) THEN
C         WRITE (MSGTXT,210) RESIDU/RLEN
C 210     FORMAT ('LEASQR: The solution is discrepant at',E8.1)
C         CALL MSGWRT (6)
         RETURN
      END IF


C  Determine goodness-of-fit estimates, and statistical errors.
      SSQRES = SSQ
      DO 220 I = 1, NP
         SSQRES = SSQRES - X(I)*R(I)
 220  CONTINUE
      IF (SSQRES.LT.0.0) SSQRES = 0.0

      VARRES = SSQRES/NF
      VARY = (SSQ - SUM*SUM/N)/(N - 1.0)
      FIT = 1.0
      IF (VARY.NE.0.0) FIT = 1.0 - SSQRES/(SSQ - SUM*SUM/N)

C     Determine the covariance matrix.
      DO 280 K = 1, NP
C        Forward substitution affects only that part of W() below the
C        first non-zero entry.
         DO 230 I = 1, SXM(K)-1
            W(I) = 0.0
 230     CONTINUE
         W(SXM(K)) = 1.0

         DO 250 I = SXM(K)+1, NP
C           Forward substitution.
            W(I) = 0.0
            DO 240 J = SXM(K), I-1
               W(I) = W(I) - SC(I,J)*W(J)
 240        CONTINUE
 250     CONTINUE

         DO 270 I = NP, K, -1
            IF (SC(I,I).NE.0.0) THEN
C              Backward substitution.
               DO 260 J = I+1, NP
                  W(I) = W(I) - SC(I,J)*W(J)
 260           CONTINUE
               W(I) = W(I)/SC(I,I)
            END IF

            IF (I.NE.K) THEN
C              Off diagonal elements of the covariance matrix.
               M(I,K) = VARRES*W(I)
            ELSE IF (I.EQ.K) THEN
C              Diagonal elements of the covariance matrix.
               VX(K)  = VARRES*W(I)
            END IF
 270     CONTINUE
 280  CONTINUE
C                                       Successful completion.
      IERR = 0
      RETURN
      END

      SUBROUTINE BCINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IERR)
C-----------------------------------------------------------------------
C! creates and intializes a temporary baseline corrections table
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2000, 2006, 2008, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes baseline corrections tables.
C   Inputs:
C      OPCODE         C*4  Operation code:
C                          'WRIT' = create/init for write or read
C                          'READ' = open for read only
C      BUFFER(512)    I    I/O buffer and related storage, also defines
C                          file if open.
C      DISK           I    Disk to use.
C      CNO            I    Catalog slot number
C      CATBLK(256)    I    Catalog header block.
C      LUN            I    Logical unit number to use
C   In/Out:
C      VER            I    BC file version
C   Input/output via common (file keywords):
C      NOANT          I    Number of antennas
C      NOPOLZ         I    Number of polarizations in the table
C      OBSCOD         C*8  Observing code
C      NOSTKD         I    No polzns in the data
C      STK1           I    First Stokes parameter in the data
C      NOBAND         I    The number of bands (IF's) in the data.
C      NOCHAN         I    The number of spectral channels in the data.
C      REFFRQ         D    Freq. at reference pixel (Hz)
C      CHNBW          R    Bandwidth of single spectral channel (Hz)
C      REFPIX         R    Reference pixel
C      TABREV         I    Table revision number.
C                          Revision 1 - table invented, PJD, Feb 1, 1991
C      BCNUMV(MAXBCC) I    Element count in each column. On input only
C                          used if the file is created.
C   Output:
C      IBCRNO         I    Next row number, start of the file if READ,
C                          the last+1 if WRITE
C      BCKOLS(MAXBCC) I    The column pointer array in order:
C                          TIME, SOURCE ID, ARRAY, ANTENNA NOS.,
C                          FREQID, REAL_M, IMAG_M, REAL_A, IMAG_A
C      IERR           I    Return error code, 0=>OK, else TABINI or
C                          TABIO error.
C----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DGLB.INC'
C                                       Input variables
      CHARACTER OPCODE*4
      INTEGER   BUFFER(*), DISK, CNO, VER, CATBLK(256), LUN, IERR
C                                       Local variables
      INTEGER   I, ITEMP(6), JERR, NTT, ITRIM, NC
      LOGICAL   T, DOREAD, NEWFIL
      HOLLERITH HOLTMP(6)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (HOLTMP, ITEMP)
      INCLUDE 'INCS:DBCV.INC'
      CHARACTER  KEYW(NKEYBC)*8, TITLE(MAXBCC)*24, UNITS(MAXBCC)*8,
     *   TTITLE*56
C
      DATA NTT /56/
      DATA TTITLE /'BASELINE CORRECTIONS TABLE'/
C                                       Table column titles
      DATA TITLE /'TIME', 'SOURCE_ID  ', 'ARRAY', 'ANTENNA_NOS.',
     *   'FREQID', 'REAL_M', 'IMAG_M', 'REAL_A', 'IMAG_A' /
C                                       Units of table columns
      DATA UNITS /'DAYS', 8*' ' /
C                                       Header keywords
      DATA KEYW /'NO_ANT', 'OBSCODE', 'NO_STKD', 'STK_1', 'NO_BAND',
     *   'NO_CHAN', 'REF_FREQ', 'CHAN_BW', 'REF_PIXL', 'TABREV' /
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Set up needed variables
      NREC = 30
      NCOL = MAXBCC
      NKEY = NKEYBC
C                                       Fill in types, lengths
C                                       See Going AIPS Vol 2 p13-3.
      IF (.NOT.DOREAD) THEN
         DTYP(KTIM) = TABFLT  + 10
         DTYP(KSOU) = TABINT + 10
         DTYP(KARR) = TABINT + 10
         DTYP(KANO) = TABINT + 10 * 2
         DTYP(KFQI) = TABINT + 10
         DTYP(KRM)  = TABFLT  + 10 * NOBAND * NOSTKD
         DTYP(KIM)  = TABFLT  + 10 * NOBAND * NOSTKD
         DTYP(KRA)  = TABFLT  + 10 * NOBAND * NOSTKD
         DTYP(KIA)  = TABFLT  + 10 * NOBAND * NOSTKD
         CALL COPY (NCOL, DTYP, DATP(1,2))
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'BC', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'BCINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
C                                       Get number of records
      IBCRNO = BUFFER(5) + 1
      IF (DOREAD) IBCRNO = 1
      NKEY = NKEYBC
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 40 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'BCINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'BCINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       Set keyword values
         CALL BCIO ('WRIT', KEYVAL, IERR)
         IF (IERR.GT.0) THEN
            CALL TABERR ('WRIT', 'BCIO', 'BCINI', IERR)
            GO TO 990
            END IF
C                                       Write if just created
         CALL TABKEY (OPCODE, KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR (OPCODE, 'TABKEY', 'BCINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'BCINI', IERR)
            GO TO 990
            END IF
C                                       Retrieve keyword values
         CALL BCIO ('READ', KEYVAL, IERR)
         IF (IERR.GT.0) THEN
            CALL TABERR ('READ', 'BCIO', 'BCINI', IERR)
            GO TO 990
            END IF
         END IF
      IERR = 0
C                                       Get array indices
C                                       Cover your ass from FNDCOL -
C                                       close to flush the buffers and
C                                       then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KEYVAL, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'BCINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'BC', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'BCINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (MAXBCC, TITLE, 24, T, BUFFER, BCKOLS, JERR)
C                                       Get array indices and no. values
      DO 150 I = 1,MAXBCC
         IPOINT = BCKOLS(I)
         IF (IPOINT.GT.0) THEN
            BCKOLS(I) = DATP(IPOINT,1)
            BCNUMV(I) = DATP(IPOINT,2) / 10
            IF (BCNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            BCKOLS(I) = -1
            NC = ITRIM (TITLE(I))
            BCNUMV(I) = 0
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('BCINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('BCINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('BCINI: ERROR INITIALIZING BASELINE CORR. TABLE FOR ',A4)
      END

      SUBROUTINE ALGSUB (IFIELD, SCRGRD, SCRWRK, DISKI, CNOSCI, DISKO,
     *   CNOSCO, CHANEL, NCHAN, CATR, JBUFSZ, BUFF1, BUFF2, BUFF3,
     *   IRET)
C-----------------------------------------------------------------------
C! Interpolates model visibility from a grid and subtracts from uv data.
C# UV Modeling AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 1999-2000, 2003, 2006, 2008
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ALGSUB interpolates model visibility data from a grid and subtracts
C   it from the observed visibilities.  Data must be in 'XY' sort order
C   (not checked).
C   Inputs:
C      IFIELD   I       Field number.
C      SCRGRD   I       /CFILES/ file number for grid file.
C      SCRWRK   I       /CFILES/ file number for work file
C      DISKI    I       Input file disk number for catalogd files,
C                       .LE. 0 => /CFILES/ scratch file.
C      CNOSCI   I       Input file catalog slot number or /CFILES/
C                       scratch file number.
C      DISKO    I       Output file disk number for catalogd files,
C                       .LE. 0 => /CFILES/ scratch file.
C      CNOSCO   I       Output file catalog slot number or /CFILES/
C                       scratch file number.
C      CHANEL   I       First channel number.
C      NCHAN    I       Number of channels to process.
C      CATR     R(256)  UV data catalog header record.
C      JBUFSZ   I       Size in bytes of buffers. Dimension of
C                       BUFF1,2,3  must be at least 4096 words.
C   Inputs: from commons
C      LREC     I       length in words of vis record.
C      NVIS     I       number of vis records
C      FREQG    D(*)    Frequencies of IF and channels in same order
C                       as occurs in the data.
C   Output:
C      BUFF1    R(*)    Working buffer
C      BUFF2    R(*)    Working buffer
C      BUFF3    R(*)    Working buffer
C      IRET     I       Return code, 0 => ok, otherwise not.
C-----------------------------------------------------------------------
      INTEGER   IFIELD, SCRGRD, SCRWRK, DISKI, CNOSCI, DISKO, CNOSCO,
     *   CHANEL, NCHAN, JBUFSZ, IRET
      REAL       BUFF1(*), BUFF2(*), BUFF3(*)
C
C                                       CJTBSZ = conj. table size
      INTEGER   CJTBSZ
      PARAMETER (CJTBSZ=5000)
      INTEGER   VO, BO, VISOUT, VISRED, NIOUT, KLIM, IDISK, ICNOSC, IM,
     *   BIND2, BIND3, INDS2, INDS3, NX, NX2, NY, ILENBU, IFACT, IU, JU,
     *   I, NIO, FLIST(22), VOL, MINT, HICHAN, LIMISJ, NWRITE, IU1, IU2,
     *   CNJPTR(CJTBSZ), KINT, LIMIT, LOCHAN, NCHGRD, NROGRD, MXROGD,
     *   KAP, GRID, CX, VIS, END1, END2, NMOV, UV, LLREC, LROW, MM,
     *   WORK, INDEX, ONENY, FLAG, VISOFF, LVIS, NS, APMAXW, MAXREC,
     *   CNT, INDCNJ, INPTR, II, NPOINT, INCNT, LIM, JNPTR, NCONJ,
     *   MAXCNJ, IINCS, FCONJ, EXCESS, LOGRID, NF, IINCF, I4T1, I4T2,
     *   I4T3, I4SIZ, TOLROW, ITEMP, IDATA, IXTEMP(3), MSGSAV
      LOGICAL   T, F, ENDROW, CHKROL, DOROT
      REAL      XTEMP(7), UMIN, FACT2(2), XMAX, CATR(256), ZSCLV,
     *   ZSCLW, ZSCLU, SCALU, SCALV, FFRAC, FRSTU, UUMAX, VVMAX, DDX,
     *   DDY, UTEMP, GFAC2, UUU
      DOUBLE PRECISION GFACT, FREQLO, FREQHI
      CHARACTER NAME*48, CSTOK*1
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C                                       MAXCNJ = size of conjugate array
      DATA MAXCNJ /CJTBSZ/
C                                       MINT = Interpolation support
C                                       size.
      DATA MINT /11/
C-----------------------------------------------------------------------
      IRET = 0
C                                       Check rotation, this routine
C                                       can't do it.
      DOROT = (ABS (SSROT).GT.1.0E-6) .OR. (ABS (CCROT-1.0).GT.1.0E-4)
      IF ((DOROT) .OR. (DO3DIM)) THEN
         IRET=5
         MSGTXT = 'ALGSUB: CANNOT HANDLE ROTATED OR 3D IMAGE'
         GO TO 995
         END IF
      NCONJ = 0
      CHKROL = F
      FFRAC = 0.0
      NX = FLDSZ(1,IFIELD) * OSFX + 0.1
      NY = FLDSZ(2,IFIELD) * OSFY + 0.1
      ZSCLU = SCLUG(IFIELD) * OSFX
      ZSCLV = SCLVG(IFIELD) * OSFY
      ZSCLW = SCLWG(IFIELD)
      NX2 = NX / 2 + 1
C                                       Set up for APIO
      CALL FILL (22, 0, FLIST)
      FLIST(1) = LUNS(4)
      FLIST(2) = SCRGRD
      FLIST(5) = NY * 2
      FLIST(6) = NX2
      FLIST(9) = 1
      FLIST(11) = FLIST(5)
      FLIST(12) = 1
      FLIST(13) = JBUFSZ
C                                       Set other values
      ONENY = NY
      LLREC = LREC
      IINCS = INCS
      IINCF = INCF
      IF ((INCIF.GT.0) .AND. (INCIF.LT.INCF)) IINCF = INCIF
      GFACT = 1.0D0 / ((1.0D0 + FFRAC) * ZSCLU)
      SCALU = FFRAC * ZSCLU + ZSCLU
      SCALV = FFRAC * ZSCLV + ZSCLV
C                                       Set I/O length.
      ILENBU = ((JBUFSZ - 2 * NBPS) / 2) / LREC - 2
      ILENBU = MAX (ILENBU, 1)
      IDISK = DISKI
      ICNOSC = CNOSCI
C                                       Loop, making sure problem will
C                                       fit.
      KINT = MINT
      I4T1 = KINT * 2 * NY
      I4T2 = 2 * (KINT + 1) * 100
      I4T3 = (LREC + 4) * ILENBU
C                                       Compute size needed.
      I4SIZ = 100 + I4T1 + I4T2 + I4T3
      APMAXW = I4SIZ / 1024 + 2
C                                       Grab AP
      CALL QINIT (APMAXW, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.LT.APMAXW)) THEN
         IRET = 8
         MSGTXT = 'ALGSUB CANNOT GET DESIRED MEMORY'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Check if fits.
      APMAXW = PSAPNW * 1024
C                                       Correlator scaling table.
 20   MSGSAV = MSGSUP
      MSGSUP = 31900
      CALL GETCTL (CATR, FACT2, IRET)
      MSGSUP = MSGSAV
      IF (IRET.NE.0) GO TO 999
      CSTOK = MSGTXT(1:1)
      NS = NSTOK
      LIMISJ = NS
C                                       Set AP pointers
      LROW = NY
      TOLROW = 2 * LROW
C                                       Determine no. rows in AP -
C                                       any excess over allowing 1/4
C                                       of the AP for data buffer
C                                       goes to extra rows.
      MAXREC = MIN (2048, (APMAXW/30)/(LLREC+4)) + 5
      MAXREC = MAX (15, MAXREC)
      EXCESS = APMAXW - MAXREC * (LLREC+4) - NCHAN - 222 - 200*KINT -
     *   KINT * TOLROW
      MXROGD = KINT
      IF (EXCESS.GT.0) MXROGD = MXROGD + EXCESS / TOLROW
      IFACT = 2
      LOGRID = APMAXW - (MXROGD * IFACT) * NY - 1
      CX = LOGRID - 200 * (KINT+1) - 1
      MM = KINT
      FLAG = 1
      IF ((KSTOK.EQ.3) .AND. (ICOR0.LE.0)) FLAG = -1
C                                       Set other AP values.
      LROW = NY
C                                       model only
      IF (FACGRD(2).EQ.0.0) THEN
         UUU = 0.0
         FACT2(1) = FACT2(1) * FACGRD(1)
         FACT2(2) = FACT2(2) * FACGRD(1)
C                                       Scale FACT2 by -FACGRD
C                                       data - model
      ELSE
         UUU = 1.0
         FACT2(1) = -FACT2(1) * FACGRD(1)
         FACT2(2) = -FACT2(2) * FACGRD(1)
         END IF
C                                       If FFT scale by 0.5
      IF (DOFFT) THEN
         FACT2(1) = FACT2(1) * 0.5
         FACT2(2) = FACT2(2) * 0.5
         END IF
C                                       Prepare for BS loop
      LOCHAN = 1
      NCHGRD = 1
C                                       Loop over frequency channel
C                                       for bandwidth synthesis.
 30      CONTINUE
C                                       Open files. Use UVINIT and
C                                       UVDISK to read and write the
C                                       visibility file,
C                                       APIO to read the grid file.
C                                       Set input file name.
         IF (IDISK.LE.0) THEN
            VOL = SCRVOL(ICNOSC)
            CALL ZPHFIL ('SC', VOL, SCRCNO(ICNOSC), 1, NAME, IRET)
         ELSE
            VOL = IDISK
            CALL ZPHFIL ('UV', VOL, ICNOSC, 1, NAME, IRET)
            END IF
         CALL ZOPEN (LUNS(2), INDS2, VOL, NAME, T, F, T, IRET)
         IF (IRET.LE.0) GO TO 40
            WRITE (MSGTXT,1030) IRET
            GO TO 995
C                                       Reset input file to output file.
 40      IDISK = DISKO
         ICNOSC = CNOSCO
C                                       Init UV file read.
         CALL UVINIT ('READ', LUNS(2), INDS2, NVIS, VO, LREC, ILENBU,
     *      JBUFSZ, BUFF1, BO, BIND2, IRET)
         IF (IRET.EQ.0) GO TO 50
            WRITE (MSGTXT,1040) IRET
            GO TO 995
C                                       UV file for write
C                                       Set output file name.
 50      IF (DISKO.GT.0) THEN
            VOL = DISKO
            CALL ZPHFIL ('UV', VOL, CNOSCO, 1, NAME, IRET)
         ELSE
            VOL = SCRVOL(CNOSCO)
            CALL ZPHFIL ('SC', VOL, SCRCNO(CNOSCO), 1, NAME, IRET)
            END IF
         CALL ZOPEN (LUNS(3), INDS3, VOL, NAME, T, F, T, IRET)
         IF (IRET.LE.0) GO TO 60
            WRITE (MSGTXT,1030) IRET
            GO TO 995
C                                       Init UV file write.
 60      CALL UVINIT ('WRIT', LUNS(3), INDS3, NVIS, VO, LREC, ILENBU,
     *      JBUFSZ, BUFF3, BO, BIND3, IRET)
         NIOUT = ILENBU
         IF (IRET.EQ.0) GO TO 70
            WRITE (MSGTXT,1040) IRET
            GO TO 995
C                                       Read first visibility record
 70      CALL UVDISK ('READ', LUNS(2), INDS2, BUFF1, NIO, BIND2, IRET)
         IF (IRET.EQ.0) GO TO 80
            WRITE (MSGTXT,1100) IRET
            GO TO 995
 80      INPTR = BIND2
         INCNT = 1
         VISOUT = 0
         VISRED = 0
C                                       Determine first U (in cells)
         FRSTU = ABS (BUFF1(BIND2)) * ZSCLU
         FREQHI = MAX( FREQG(CHANEL+NCHAN-1), FREQG(CHANEL))
C                                       Set NCHGRD (no. ch to grid)
         NCHGRD = 1
C                                       Reset for bandwidth synthesis
         FREQLO = FREQG(CHANEL+LOCHAN-1)
         FREQHI = FREQLO
         DO 90 II = LOCHAN,NCHAN
            IF (FREQG(CHANEL+LOCHAN-1).LT.FREQG(CHANEL+II-1)) THEN
               IU1 = FRSTU * FREQG(CHANEL+LOCHAN-1) / FREQ
               IU2 = FRSTU * FREQG(CHANEL+II-1) / FREQ + 1.0
            ELSE
               IU2 = FRSTU * FREQG(CHANEL+LOCHAN-1) / FREQ + 1.0
               IU1 = FRSTU * FREQG(CHANEL+II-1) / FREQ
               END IF
            IF (IU2-IU1+KINT+1.GT.MXROGD) GO TO 100
               NCHGRD = (II - LOCHAN) + 1
               INDEX = CHANEL + II - 1
               FREQLO = MIN (FREQLO, FREQG(INDEX))
               FREQHI = MAX (FREQHI, FREQG(INDEX))
 90         CONTINUE
 100     LIMIT = LOCHAN + 1
         DO 110 II = LIMIT,NCHAN
C                                       Frequency scaling table.
C                                       Use BUFF3.
            INDEX = CHANEL + II - 1
            BUFF3(II-LOCHAN) = (FREQG(INDEX) / FREQG(INDEX-1)) - 1.0D0
 110        CONTINUE
C                                       Determine no. rows needed.
         IU1 = FREQLO * FRSTU / FREQ
         IU2 = FREQHI * FRSTU / FREQ + 1.0
         NROGRD = KINT + IU2 - IU1 + 1
         HICHAN = LOCHAN + NCHGRD - 1
         INDEX = CHANEL + LOCHAN - 1
         NF = CHANEL + HICHAN - 1
         IF (MFIELD.LE.1) THEN
            WRITE (MSGTXT,1110) CSTOK, INDEX, NF
         ELSE
            WRITE (MSGTXT,1111) IFIELD, CSTOK, INDEX, NF
            END IF
         CALL MSGWRT (2)
         NF = NCHGRD
C                                       Reset GRID to top of AP
         GRID = APMAXW - (NROGRD * IFACT) * NY - 1
C                                       Set values for shifting GRID
C                                       at end of each row.
         END1 = LOGRID + (NROGRD-1) * NY * IFACT - 1
         END2 = APMAXW - 2
         NMOV = (IFACT * NY) * (NROGRD-1)
C                                       Determine where data starts.
         FLIST(10) = ((FRSTU*FREQHI/FREQ + 0.5) - (KINT/2)) + NROGRD
         FLIST(10) = MIN (FLIST(10), NX2)
C                                       Get frequency scaling factors.
         FFRAC = (FREQLO / FREQ) - 1.0D0
         GFACT = 1.0D0 / ((1.0D0 + FFRAC) * ZSCLU)
         GFAC2 = (1.0D0 + FFRAC) * ZSCLU
         FFRAC = (FREQHI / FREQ) - 1.0D0
         SCALU = FFRAC * ZSCLU + ZSCLU
         SCALV = FFRAC * ZSCLV + ZSCLV
C                                       Set limits on u,v - don't get
C                                       within MINT/2+1 of edge.
         UUMAX = ABS (((NX/2) - (MINT/2+1)) / SCALU)
         VVMAX = ABS (((NY/2) - (MINT/2+1)) / SCALV)
C                                       Setup for AP griding
C                                       Set constants in AP.
         FFRAC = (FREQG(LOCHAN+CHANEL-1) / FREQ) - 1.0D0
         XTEMP(1) = (ZSCLU + FFRAC * ZSCLU)
         XTEMP(2) = (ZSCLV + FFRAC * ZSCLV)
         DDX = DXCG(IFIELD)
         DDY = DYCG(IFIELD)
         XTEMP(3) = DDX / ZSCLU
         XTEMP(4) = DDY / ZSCLV
         XTEMP(5) = DZCG(IFIELD) * FFRAC + DZCG(IFIELD)
         XTEMP(6) = 0.0
         XTEMP(7) = 0.0
         IXTEMP(1) = IU
         IXTEMP(2) = GRID
         IXTEMP(3) = CX
         CALL QPUT (XTEMP, 0, 7, 2)
         CALL QPUT (IXTEMP, 7, 3, 1)
C                                       Correlator scaling table.
         ITEMP = 16
         CALL QPUT (FACT2, ITEMP, NS, 2)
         CALL QPUT (UUU, 15, 1, 2)
C                                       Frequency scaling table.
         ITEMP = 20
         CALL QPUT (BUFF3, ITEMP, NF, 2)
C                                       Set interpolation tables
         CALL INTPFN (CX, KINT, BUFF3, JBUFSZ, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Determine the maximum number
C                                       of visibility points which
C                                       fit in the AP.
C                                       Save space for four word work
C                                       array.
         MAXREC = (CX - 20 + NS + NF) / (LREC+4) - 5
         IF (MAXREC.GT.MAXCNJ) MAXREC = MAXCNJ
C                                       Be sure MAXREC.GT.10
         IF (MAXREC.GT.10) GO TO 130
            XMAX = - MAXREC * REAL (LREC)
            WRITE (MSGTXT,1090) XMAX
            IRET = 1
            GO TO 995
C                                       More AP pointers.
 130     WORK = 20 + NF
         UV = WORK + 4 + (MAXREC * 4)
C                                       Compute offset from beginning of
C                                       record to first correlator.
C                                       Offset = NRPARM + LVIS * CHANEL
C                                       LVIS = no. words per correlator
         LVIS = MIN (INCS, INCF)
         IF ((INCIF.GT.0) .AND. (INCIF.LT.LVIS)) LVIS = INCIF
C                                       Correction for stokes.
         VISOFF = NRPARM + ((CHANEL-1) + (LOCHAN-1))*INCF + VOFF
         VIS = UV + VISOFF
C                                       Put first NROGRD rows in AP.
         DO 150 IM = 1,NROGRD
            INDEX = NROGRD - IM
            INDEX = GRID + INDEX * TOLROW
            CALL APIO ('READ', FLIST, INDEX, BUFF2, IRET)
            IF (IRET.EQ.0) GO TO 150
               WRITE (MSGTXT,1230) IRET, IM
               GO TO 995
 150        CONTINUE
C
C                                       Loop through grid
         KLIM = FLIST(10) - NROGRD + KINT/2 + 1
         DO 400 I = 1,KLIM
            IU = KLIM - I
            UMIN = (IU - 0.5) * GFACT
            UMIN = (IU - 0.4975)
            IDATA = UV
            CNT = 0
            INDCNJ = 0
C                                       Return to here if more than one
C                                       record is loaded at a time.
  160       ENDROW = T
            NPOINT = 0
C                                       Check if all data read.
            IF (NIO.LE.0) GO TO 220
C                                       See if need a new input buffer
            IF (INCNT.GT.NIO) GO TO 200
C                                       Make sure there is some data on
C                                       this row.
            UTEMP = ABS (BUFF1(INPTR)) * GFAC2
            IF (UTEMP.LE.UMIN) GO TO 220
C                                       Check if end of row occures in
C                                       this record.
            LIM = INCNT + MAXREC - CNT - 1
            IF (LIM.GT.NIO) LIM = NIO
            JNPTR = INPTR
C                                       Check for end of row and look
C                                       for data on wrong plane half.
            DO 180 II = INCNT,LIM
C                                       Check that data inside grid.
               IF ((ABS (BUFF1(JNPTR))  .GT.UUMAX) .OR.
     *             (ABS (BUFF1(JNPTR+1)).GT.VVMAX)) GO TO 980
               INDCNJ = INDCNJ + 1
C                                       Check if datum in current row.
               UTEMP = ABS (BUFF1(JNPTR)) * GFAC2
               IF (UTEMP.LE.UMIN) GO TO 190
C                                       Check if U neg.; if so then flip
C                                       data to other half plane.
               IF (BUFF1(JNPTR).LT.0.0) THEN
C                                       Check max. no. in table.
                  IF (NCONJ.GE.MAXCNJ) GO TO 185
C                                       Enter in CNJPTR table.
                  NCONJ = NCONJ + 1
                  CNJPTR(NCONJ) = INDCNJ
C                                       Flip U, V, W, conjugate data.
                  CALL UVCONJ( VISOFF, INCF, NCHGRD, LIMISJ, INCS,
     *               BUFF1(JNPTR))
C                                       end if U < 0, conjugate
                  END IF
               NPOINT = NPOINT + 1
               VISRED = VISRED + 1
               JNPTR = JNPTR + LREC
C                                       end for all vis recs read
 180           CONTINUE
C                                       Rest of record is on same row.
 185        ENDROW = F
 190        CONTINUE
            CNT = CNT + NPOINT
C                                       Load into AP.
            CALL QWR
            ITEMP = NPOINT * LLREC
            CALL QPUT (BUFF1(INPTR), IDATA, ITEMP, 2)
C                                       Low row to AP
            IXTEMP(1) = IU
            IXTEMP(2) = GRID
            CALL QPUT (IXTEMP, 7, 3, 1)
            IDATA = IDATA + ITEMP
            INCNT = INCNT + NPOINT
            INPTR = INPTR + NPOINT * LREC
C                                       Check if AP full or row finished
            IF ((ENDROW) .OR. (CNT.GE.MAXREC) .OR. (NCONJ.GE.MAXCNJ))
     *         GO TO 220
C                                       Read next record.
  200       INCNT = 1
C                                       Check if all records read.
            ENDROW = NIO.EQ.0
            IF (NIO.GT.0) THEN
               CALL UVDISK ('READ', LUNS(2), INDS2, BUFF1, NIO, BIND2,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1100) IRET
                  GO TO 995
                  END IF
               INPTR = BIND2
C                                       Loop back
               GO TO 160
               END IF
C                                       exit loop if no more data
 220        CONTINUE
            INDCNJ = 0
C                                       Interpolate data
            IF (CNT.LE.0) GO TO 250
            CALL QWAIT
            CALL QUVIN (UV, VIS, WORK, LLREC, MM, LROW, NS, IINCS,
     *         NF, IINCF, CNT, FLAG)
            CALL QWR
C                                       Read out data.
            IDATA = UV
C                                       Setup for flipping half plane
            FCONJ = 1
            INDCNJ = 0
C                                       Loop, transfering to disk
 230           NWRITE = NIOUT
               IF (NWRITE.GT.CNT) NWRITE = CNT
               ITEMP = NWRITE * LLREC
               CALL QGET (BUFF3(BIND3), IDATA, ITEMP, 2)
               IDATA = IDATA + ITEMP
               NIOUT = NWRITE
               CALL QWD
C                                       Check if any data in buffer
C                                       needs to be reflipped to
C                                       other half plane.
 234           IF ((FCONJ.LE.NCONJ) .AND.
     *             ((INDCNJ+NWRITE) .GE. CNJPTR(FCONJ))) THEN
C                                       Loop flipping as necessary.
                  JNPTR = BIND3 + (CNJPTR(FCONJ)-INDCNJ-1) * LREC
C                                       Flip U, V, W, conjugate data.
                  CALL UVCONJ( VISOFF, INCF, NCHGRD, LIMISJ, LVIS,
     *               BUFF3(JNPTR))
                  FCONJ = FCONJ + 1
C                                       Loop back until all cojugated
                  GO TO 234
C                                       end if data to conjigate back
                  END IF
               INDCNJ = INDCNJ + NWRITE
               VISOUT = VISOUT + NIOUT
C                                       Write data to disk
               CALL UVDISK ('WRIT', LUNS(3), INDS3, BUFF3, NIOUT,
     *            BIND3, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1100) IRET
                  GO TO 995
                  END IF
               CNT = CNT - NWRITE
               IF (CNT.GT.0) GO TO 230
C                                       Reset counters pointers.
            CNT = 0
            FCONJ = 1
            NCONJ = 0
            INDCNJ = 0
C                                       See if done.
            IF (NIOUT.LE.0) GO TO 530
            IDATA = UV
C                                       Check if row finished.
            IF (.NOT.ENDROW) THEN
               IF (INCNT.LE.NIO) GO TO 160
               GO TO 200
               END IF
C                                       Prepare AP for next row.
 250        IF ((GRID.EQ.LOGRID) .AND. (IU.NE.0)) THEN
               CALL QVMOV (END1, -1, END2, -1, NMOV)
               GRID = END2 - NMOV + 1
               END IF
C                                       Reset GRID
            GRID = GRID - NY * IFACT
            GRID = MAX (GRID, LOGRID)
C                                       when AP Finishes do I/O
            CALL QWAIT
C                                       prepare for next row
            JU = IU - 1
C                                       when not near end of rows
            IF (IU.GT.KINT/2) THEN
C                                       Put next row into AP.
               CALL APIO ('READ', FLIST, GRID, BUFF2, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1230) IRET, I
                  GO TO 995
                  END IF
            ELSE
C                                       else near end of rows, create
C                                       U<0 rows from conj U>0 row
C                                       calc distance between rows
               INDEX = ((2*(KINT/2)) - (2*JU) + 1) * IFACT * NY - IFACT
C                                       GRID -> start JU-KINT/2 row
               INDEX = GRID + INDEX
C                                       INDEX -> start JU+KINT/2 ROW
               CALL QCVCON (INDEX, -IFACT, GRID+IFACT, IFACT, ONENY-1)
C                                       INDEX -> end JU+KINT/2 Row
               INDEX = INDEX - (IFACT*NY) + IFACT
C                                       conjugate a single pixel
               CALL QCVCON (INDEX, IFACT, GRID, IFACT, 1)
               END IF
C                                       end for all rows loop
 400        CONTINUE
C                                       Finish write.
 530     NIOUT = 0
         CALL UVDISK ('FLSH', LUNS(3), INDS3, BUFF3, NIOUT, BIND3, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1230) IRET, I
            GO TO 995
            END IF
C                                       Give up AP.
         CALL QRLSE
C                                       Close files
         CALL ZCLOSE (LUNS(2), INDS2, IRET)
         CALL ZCLOSE (LUNS(3), INDS3, IRET)
C                                       Check that written all data read
         IF (VISOUT.NE.VISRED) THEN
            WRITE (MSGTXT,1541) NVIS, VISOUT
            CALL MSGWRT (8)
            END IF
C                                       INIT grid file.
         CALL APIO ('INIT', FLIST, GRID, BUFF2, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1540) IRET
            GO TO 995
            END IF
C                                       End frequency (BS) loop.
         LOCHAN = LOCHAN + NCHGRD
         IF (LOCHAN.LE.NCHAN) GO TO 30
C                                       Close grid file.
      CALL APIO ('CLOS', FLIST, GRID, BUFF2, IRET)
      GO TO 999
C                                       Data outside of grid
 980  WRITE (MSGTXT,1980)
      CALL MSGWRT (8)
      WRITE (MSGTXT,1981) UUMAX, VVMAX
      IRET = 5
C                                       Error
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('ALGSUB: TROUBLE OPENING UV DATA FILE, IER=',I5)
 1040 FORMAT ('ALGSUB: ERROR',I5,' INITIALIZING FILE')
 1090 FORMAT ('ALGSUB: ',F8.0,' TOO FEW AP WORDS AVAILABLE')
 1100 FORMAT ('ALGSUB: READ ERROR IN VISIBILITY FILE, IER=',I5)
 1110 FORMAT ('ALGSUB: ',A1,'pol gridded model subtraction, chans',I5,
     *   ' through',I5)
 1111 FORMAT ('ALGSUB field',I5,1X,A1,'pol gridded model subtraction',
     *   ' chns',I5,'-',I5)
 1230 FORMAT ('ALGSUB: ERROR',I5,' READING GRID ROW ',I5)
 1540 FORMAT ('ALGSUB: TROUBLE INIT GRID FILE, IER=',I5)
 1541 FORMAT ('ALGSUB: WARNING: MISPLACED DATA, NVIS = ',I8,
     *   ' WRITTEN =',I8)
 1980 FORMAT ('ALGSUB: ERROR: DATA OUTSIDE OF UV GRID USED:')
 1981 FORMAT ('        UMAX = ',1PE12.5,' VMAX = ',1PE12.5,
     *   ' WAVELENGTH')
      END

      PROGRAM IMFLM
C-----------------------------------------------------------------------
C! For queueing disk images to Dicomed
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C                ---------------------------------
C                !                               !
C                !           I M F L M           !
C                !                               !
C                ! Version 1.0 - 20 February 1990!
C                !                               !
C                !          Arnold Rots          !
C                !                               !
C                ---------------------------------
C
C
C     IMFLM generates an image from a disk file with the TV transfer function
C     in a Dicomed Image File and queues it.  For cubes it will make a multi-
C     panel composite.
C
C     Version 1.0: New task  -  900220 ahr
C
C     INPUT ADVERBS :
C   USERID     -32000.0      32000.0    User ID.  0 => current user,
C                                         32000 => any user.
C   INNAME                              Image name(name).
C   INCLASS                             Image name(class).
C   INSEQ           0.0       9999.0    Image name(seq. #). 0=>high
C   INDISK          0.0          9.0    Disk drive #. 0=>any
C   TBLC            0.0       4096.0    Bottom Left Corner of image
C                                         0=>entire image
C   TTRC            0.0       4096.0    Top Right Corner of image
C                                         0=>entire image
C   TXINC        -100.0        256.0    Load every TXINC'th column
C   TYINC        -100.0        256.0    Load every TYINC'th row
C   TZINC        -100.0        256.0    Load every TZINC'th plane
C   PIXRANGE                            Min,Max  of image intensity
C                                         0=>entire range
C   FUNCTYPE                            Image intensity transfer func
C                                         'LN' Linear.  unknown=>'LN'
C                                         'LG' Logarithmic
C                                         'NE' Negative linear
C                                         'NG' Negative logarithmic
C   COPIES          0.0        200.0    Number of copies requested
C   STRA1                               Specifies film size and type
C   OUTPRINT                            User comment
C
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6, PS*40
      REAL      CHAN(14), COPIES, STRA1, OUTPRT(12), PARM(42)
      INTEGER   NSUB, NPARM, NRET, ERROR, POTERR
      INTEGER   BUFF(256)
      LOGICAL   QUICK
      EQUIVALENCE (CHAN(1), COPIES), (CHAN(2), STRA1),
     *            (CHAN(3),OUTPRT(1)), (CHAN(1), PARM(29))
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA NPARM /42/, PRGNAM /'IMFLM '/
C-----------------------------------------------------------------------
C                                       I/O handling
      TSKNAM = PRGNAM
      CALL ZDCHIN (.TRUE., BUFF)
      CALL VHDRIN
C                                       get inputs
      CALL GTPARM (PRGNAM, NPARM, QUICK, PARM, BUFF, ERROR)
      IF (ERROR .NE. 0) GO TO 900
      CALL YTVCIN
C                                       open TV
      CALL IMDICO (POTERR, COPIES, STRA1, OUTPRT, PARM, QUICK)
      IF (POTERR .NE. 0) GOTO 900
C                                       done
      NRET = 0
      GO TO 990
C                                       error exit
 900  CONTINUE
C     WRITE (MSGTXT,9000) SUBNOM(NSUB), ERROR
C     CALL MSGWRT (8)
      NRET = 16
C                                       exit
 990  CALL DIETSK (NRET, QUICK, BUFF)
C
      STOP
C-----------------------------------------------------------------------
C9000 FORMAT (A6,'  ERROR NO',I6)
      END
      SUBROUTINE IMDICO (POTERR, COPIES, STRA1, OUTPRT, PARM, QUICK)
C
C           +-----------------------------------+
C           |                                   |
C           |            i m d i c o            |
C           |                                   |
C           |  Version 1.0  -  20 February 1990 |
C           |                                   |
C           |            Arnold Rots            |
C           |                                   |
C           +-----------------------------------+
C
C     IMDICO is the routine that queues the disk image to the film writer.
C
C     Version 1.0: New program  -  900220 ahr
C
C     Input params:
C       copies   I   Number of copies to be made
C       stra1   C*4  String containing film type and size code
C       outprt  C*48 User comment string
C       parm    R*28 Image info
C       quick    L   Whether or not to release AIPS
C     Output params:
C       poterr   I   Exit error code
C
C-----------------------------------------------------------------------
C
      REAL COPIES, STRA1, OUTPRT(12), PARM(28), EPS, BLC(7), TRC(7), SCL
      INTEGER N1, BUFFER(4096), LUNOUT, IVOL, USID, SEQNO, INC(3), MAGIC
      INTEGER NX, NY, IERROR, I, J, K, NPLNON, NPON(12), FLMSIZ, FLMTYP
      INTEGER NCOPY, NSCRPL, NSPLBT, N16, BITS(16), DLUN, DIND, CNO,
     *        STATUS, IZP, ZINC, NNX, NNY, NNZ, LX, LY, MX, MY, ITVC(4)
      INTEGER N, BITPIX, LUTPPB, BPLUT, OFMLEN, LUTPTR, OFMPTR, DATPTR
      INTEGER USERNO, IC, MONOFF(12), SYSTEM, POTERR, INTSCA, TYPE
      INTEGER IWIN(4)
      INTEGER*2 I2, BUFFR2(256)
      BYTE I1, A1(2), BUFFR1(4096)
      BYTE FRBUFF(16777216)
      CHARACTER*4 REED, RITE, FILNAM*18, FILM1, FILM2*6, DATEX*9
      CHARACTER*8 TIMEX, STRING*50, TSTR*2, NAME*12, CLASS*6, PTYPE*2
      LOGICAL QUICK, F, T, MAOPEN, FILOPN, TVOPN, SUCCES, BW, CUBE
      LOGICAL RELEAS
C
C     INCLUDE 'INCS:DAPL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C
      INTEGER BUFPTR
      BYTE OUTBUF(8192), LINBUF(4096)
      COMMON /DICCOM/ BUFPTR, OUTBUF
      EQUIVALENCE (OUTBUF(1), LINBUF(1))
C
      EQUIVALENCE (I2,A1(1)), (I1, A1(2))
      EQUIVALENCE (BUFFER(1), BUFFR2(1))
C
      DATA N1, N16, F, T, REED, RITE, EPS, DLUN, MAGIC
     *     /1, 16, .FALSE., .TRUE., 'READ', 'WRIT', 0.1, 16, 32000/
      DATA MONOFF
     *     /0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334/
C
C-----------------------------------------------------------------------
C                                       Initialize
      BUFPTR = 0
      IERROR = 0
      MAOPEN = F
      FILOPN = F
      TVOPN = F
      SUCCES = F
      RELEAS = F
      LUNOUT = 101
      NCOPY = COPIES
      STRING = ' '
      CALL H2CHR (48, 1, OUTPRT, STRING)
      CALL H2CHR (2, 1, STRA1, TSTR)
      IF (TSTR .EQ. '35') THEN
            FILM1 = '35mm'
         ELSE IF (TSTR .EQ. '  ') THEN
            FILM1 = '35mm'
         ELSE IF (TSTR .EQ. '2"') THEN
            FILM1 = '2x2'
         ELSE IF (TSTR .EQ. '4"') THEN
            FILM1 = '4x5'
         ELSE
            FILM1 = ' '
      END IF
      CALL H2CHR (2, 3, STRA1, TSTR)
      IF (TSTR .EQ. 'CP') THEN
            FILM2 = 'ColPos'
         ELSE IF (TSTR .EQ. '  ') THEN
            FILM2 = 'ColPos'
         ELSE IF (TSTR .EQ. 'CN') THEN
            FILM2 = 'ColNeg'
         ELSE IF (TSTR .EQ. 'BW') THEN
            FILM2 = 'B/W'
         ELSE
            FILM2 = ' '
      END IF
      USERNO = NLUSER
C
C                                       Construct file name
C
      CALL TIME (TIMEX)
      CALL DATE (DATEX)
      CALL IDATE (I, J, K)
      WRITE (FILNAM,1000) USERNO
 1000 FORMAT (I4)
      FILNAM(5:5) = '_'
      J = J + MONOFF(I)
      IF (((K/4)*4 .EQ. K) .AND. (I .GT. 2)) J = J + 1
      WRITE (FILNAM(6:8),1010) J
 1010 FORMAT (I3)
      FILNAM(9:9) = '_'
      FILNAM(10:11) = TIMEX(1:2)
      FILNAM(12:13) = TIMEX(4:5)
      FILNAM(14:15) = TIMEX(7:8)
      FILNAM(16:18) = '_V1'
      DO 7 I=1,18
         IF (FILNAM(I:I) .EQ. ' ') FILNAM(I:I) = '0'
 7    CONTINUE
C
C                                       Open TV
C
      CALL TVOPEN (BUFFER, IERROR)
      IF (IERROR .NE. 0) GOTO 910
      TVOPN = T
      INTSCA = MAX0(1, (MAXINT+2)/256)
C
C                                       Open output image file
C
      OPEN (UNIT=LUNOUT, FILE=FILNAM, STATUS='NEW', FORM='UNFORMATTED',
     *      RECL=4096, RECORDTYPE='FIXED', ERR=961)
      FILOPN = T
C
C                                       What's on?
C
      CALL YSPLIT (REED, I, J, NPON(1), NPON(5), NPON(9), F, IERROR)
      IF (IERROR .NE. 0) GOTO 950
      NPLNON = 0
      DO 10 I=1,12
         NPLNON = NPLNON .OR. NPON(I)
 10   CONTINUE
C
C                                       Set film options
C
      IF ((FILM1 .EQ. '35mm') .OR. (FILM1 .EQ. '35MM')) THEN
            FLMSIZ = 1
            NX = 1536
            NY = 1024
         ELSE IF ((FILM1 .EQ. '2x2') .OR. (FILM1 .EQ. '2X2')) THEN
            FLMSIZ = 2
            NX = 2048
            NY = 2048
         ELSE IF ((FILM1 .EQ. '4x5') .OR. (FILM1 .EQ. '4X5')) THEN
            FLMSIZ = 3
            NX = 4096
            NY = 4096
         ELSE
            GOTO 920
      END IF
      IF ((FILM2 .EQ. 'ColPos') .OR. (FILM2 .EQ. 'COLPOS')) THEN
            FLMTYP = 1
            BW = F
         ELSE IF ((FILM2 .EQ. 'ColNeg') .OR. (FILM2 .EQ. 'COLNEG')) THEN
            FLMTYP = 2
            BW = F
         ELSE IF ((FILM2 .EQ. 'b/w') .OR. (FILM2 .EQ. 'B/W')) THEN
            FLMTYP = 3
            BW = T
         ELSE
            GOTO 930
      END IF
      NCOPY = MAX0 (1, NCOPY)
C
C                                       Open map and determine size
C
      MAXXTV(1) = NX
      MAXXTV(2) = NY
      I = 1
      IVOL = PARM(8) + EPS
      USID = ABS(PARM(1)) + EPS
      SEQNO = PARM(7) + EPS
      IF (USID.EQ.0) USID = NLUSER
      IF (USID.EQ.MAGIC) USID = 0
      CALL H2CHR (12, 1, PARM(2), NAME)
      CALL H2CHR (6, 1, PARM(5), CLASS)
      INC(1) = NINT(PARM(23))
      INC(2) = NINT(PARM(24))
      INC(3) = NINT(PARM(25))
      PTYPE = 'MA'
      CALL MAPOPN (REED, IVOL, NAME, CLASS, SEQNO, PTYPE, USID,
     *             DLUN, DIND, CNO, CATBLK, BUFFER, IERROR)
      POTERR = 33
      IF (IERROR.GT.1) GO TO 975
      MAOPEN = T
      CALL RCOPY (7, PARM(9), BLC)
      CALL RCOPY (7, PARM(16), TRC)
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IERROR)
      IF (IERROR .NE. 0) GOTO 980
      IWIN(1) = BLC(1)
      IWIN(2) = BLC(2)
      IWIN(3) = TRC(1)
      IWIN(4) = TRC(2)
C                                       Image cat fill in some
      CALL RNGSET (PARM(26), CATR(KRDMX), CATR(KRDMN), CATR(IRRAN))
      CATBLK(IIVOL) = IVOL
      CATBLK(IICNO) = CNO
      CATH(IITRA) = PARM(28)
C                                       Decide 3-D vs 2-D
      ZINC = MAX0 (1, INC(3))
      CUBE = F
      IF (CATBLK(KIDIM) .GE. 3) THEN
         DO 15 I=3,CATBLK(KIDIM)
            IF ((((TRC(I)-BLC(I))/ZINC) .GT. 1.0) .AND. (.NOT. CUBE))
     *          THEN
               CUBE = T
               IZP = I
            END IF
            CATBLK(IIDEP+I-3) = NINT(BLC(I))
 15      CONTINUE
      END IF
C                                       Cube
      IF (CUBE) THEN
            DO 20 I=1,3
               INC(I) = MAX0(1,INC(I))
 20         CONTINUE
            NNX = (TRC(1) - BLC(1)) / INC(1) + 1.01
            NNY = (TRC(2) - BLC(2)) / INC(2) + 1.01
            NNZ = (TRC(IZP) - BLC(IZP)) / INC(3) + 1.01
            LX = (NX - 1) / (NNX + 1)
            LY = (NY - 1) / (NNY + 1)
            IF ((LX * LY) .LT. NNZ) GOTO 985
            MX = NINT(SQRT(NNZ*(FLOAT(NX*(NNY+1))/FLOAT(NY*(NNX+1)))))
            MX = MIN0(MX, LX)
            MY = (NNZ-1) / MX + 1
            MY = MIN0(MY, LY)
            MX = (NNZ-1) / MY + 1
            NX = (NNX + 1) * MX + 1
            NY = (NNY + 1) * MY + 1
C                                       2-D image
         ELSE
            ITVC(1) = 1
            ITVC(2) = 1
            POTERR = 49
            TYPE = -1
            I = 1
            CALL TVWIND (TYPE, INC, BLC, TRC, I, ITVC, IWIN, IERROR)
            IF (IERROR .NE. 0) GOTO 980
            NX = ITVC(3) - ITVC(1) + 1
            NY = ITVC(4) - ITVC(2) + 1
      END IF
C
C                                       Get TV items
C
C                                       Only if one plane on
      NSCRPL = 0
      J = 1
      DO 110 I=1,NGRAY
         IF (NPLNON .EQ. J) NSCRPL = I
         J = J * 2
 110  CONTINUE
      IF (NSCRPL .LE. 0) GOTO 970
C                                       Header items
      BITPIX = 8
      BPLUT = 16
      LUTPTR = 512
C                                       B/W
      IF (BW) THEN
            LUTPPB = 1
            OFMLEN = 0
            OFMPTR = 0
            DATPTR = LUTPTR+LUTPPB*BPLUT/8*BITPIX/8*256+OFMLEN*3
            CALL MAKHED (LUNOUT, FILNAM, DATEX, TIMEX, USERNO,
     *                   FLMSIZ, FLMTYP, NCOPY, BITPIX, NX, NY,
     *                   LUTPPB, BPLUT, OFMLEN, LUTPTR, OFMPTR,
     *                   DATPTR, STRING)
C                                       Get LUT
            CALL YLUT (REED, NPLNON, N1, F, BUFFER, IERROR)
            IF (IERROR .NE. 0) GOTO 950
            SCL = 255.0 / LUTOUT
            BUFFR2(1) = NINT(BUFFER(1) * SCL)
            DO 120 I=2,255
               BUFFR2(I) = NINT(BUFFER(INTSCA*I) * SCL)
 120        CONTINUE
            BUFFR2(256) = NINT(BUFFER(MAXINT+1) * SCL)
            CALL DICOUT (LUNOUT, BUFFR2, 512, IERROR)
            IF (IERROR .NE. 0) GOTO 960
C                                       Color
         ELSE
            LUTPPB = 3
            OFMLEN = OFMINP + 1
            OFMPTR = LUTPTR + 256 * LUTPPB * BPLUT/8 * BITPIX/8
            DATPTR = LUTPTR+256*LUTPPB*BPLUT/8*BITPIX/8+OFMLEN*3
            CALL MAKHED (LUNOUT, FILNAM, DATEX, TIMEX, USERNO,
     *                   FLMSIZ, FLMTYP, NCOPY, BITPIX, NX, NY,
     *                   LUTPPB, BPLUT, OFMLEN, LUTPTR, OFMPTR,
     *                   DATPTR, STRING)
C                                       Get LUTs
            DO 125 IC=3,1,-1
               J = 2**(IC-1)
               CALL YLUT (REED, NPLNON, J, F, BUFFER, IERROR)
               IF (IERROR .NE. 0) GOTO 950
               BUFFR2(1) = BUFFER(1)
               DO 122 I=2,255
                  BUFFR2(I) = BUFFER(INTSCA*I)
 122           CONTINUE
               BUFFR2(256) = BUFFER(MAXINT+1)
               CALL DICOUT (LUNOUT, BUFFR2, 512, IERROR)
               IF (IERROR .NE. 0) GOTO 960
 125        CONTINUE
C                                       OFMs
            SCL = 255.0 / OFMOUT
            DO 150 IC=3,1,-1
               J = 2**(IC-1)
               CALL YOFM (REED, J, F, BUFFER, IERROR)
               IF (IERROR .NE. 0) GOTO 950
               DO 130 I=1,OFMLEN
                  I2 = NINT(BUFFER(I) * SCL)
                  BUFFR1(I) = I1
 130           CONTINUE
               CALL DICOUT (LUNOUT, BUFFR1, OFMLEN, IERROR)
               IF (IERROR .NE. 0) GOTO 960
 150        CONTINUE
      END IF
C                                       Image
C                                       Release TV & AIPS
      CALL TVCLOS (BUFFER, IERROR)
      TVOPN = F
      IF (QUICK) THEN
         I = 0
         CALL RELPOP (I, BUFFER, IERROR)
         IF (IERROR .EQ. 0) RELEAS = T
      END IF
C                                       Fake the TV common for TVLOD
      MAXINT = 255
C                                       Now really get the image
      IF (CUBE) THEN
            CALL IM3LOD (DLUN, DIND, NX, NY, INC, IWIN, 4096, BUFFER,
     *                   FRBUFF, NNX, NNY, NNZ, MX, MY, IZP, IERROR)
            IF (IERROR .NE. 0) GOTO 940
         ELSE
            NNX = NX
            NNY = NY
            CALL IM2LOD (DLUN, DIND, NX, NY, INC, IWIN, 4096, BUFFER,
     *                   FRBUFF, NNX, NNY, 1, 1, IERROR)
            IF (IERROR .NE. 0) GOTO 940
      END IF
      CALL WRTPLN (LUNOUT, FRBUFF, NX, NY, IERROR)
      IF (IERROR .NE. 0) GOTO 949
C                                       End of it all
      SUCCES = T
      GOTO 990
C                                       Error messages
 910  CONTINUE
      WRITE (MSGTXT,9100)
      CALL MSGWRT (8)
      GOTO 990
C
 920  CONTINUE
      WRITE (MSGTXT,9200) FILM1
      CALL MSGWRT (8)
      GOTO 990
C
 930  CONTINUE
      WRITE (MSGTXT,9300) FILM2
      CALL MSGWRT (8)
      GOTO 990
C
 940  CONTINUE
      WRITE (MSGTXT,9400)
      CALL MSGWRT (8)
      GOTO 990
C
 949  CONTINUE
      IF (IERROR .LT. 0) THEN
            GOTO 960
         ELSE
            GOTO 950
      END IF
C
 950  CONTINUE
      WRITE (MSGTXT,9500)
      CALL MSGWRT (8)
      GOTO 990
C
 960  CONTINUE
      WRITE (MSGTXT,9600)
      CALL MSGWRT (8)
      GOTO 990
C
 961  CONTINUE
      WRITE (MSGTXT,9610)
      CALL MSGWRT (8)
      GOTO 990
C
 970  CONTINUE
      WRITE (MSGTXT,9700)
      CALL MSGWRT (8)
      GOTO 990
C
 975  CONTINUE
      WRITE (MSGTXT,9750)
      CALL MSGWRT (8)
      GOTO 990
C
 980  CONTINUE
      WRITE (MSGTXT,9800)
      CALL MSGWRT (8)
      GOTO 990
C
 985  CONTINUE
      WRITE (MSGTXT,9850)
      CALL MSGWRT (8)
      GOTO 990
C                                       Close and exit
 990  CONTINUE
      IF (SUCCES) THEN
            POTERR = 0
            CALL DICFLS (LUNOUT)
            CLOSE (UNIT=LUNOUT)
            I = SYSTEM('lpr -r -Pfw '//FILNAM)
         ELSE
            POTERR = 1
            IF (FILOPN) CLOSE (UNIT=LUNOUT, DISPOSE='DELETE')
      END IF
      QUICK = RELEAS
      IF (MAOPEN) CALL MAPCLS (REED, IVOL, CNO, DLUN, DIND, CATBLK,
     *                          F, BUFFER, IERROR)
      IF (TVOPN) CALL TVCLOS (BUFFER, IERROR)
      COPIES = 1
      RETURN
C
C-----------------------------------------------------------------------
 9100 FORMAT ('IMDICO: Can''t open the TV')
 9200 FORMAT ('IMDICO: Illegal film size: ',A)
 9300 FORMAT ('IMDICO: Illegal film type: ',A)
 9400 FORMAT ('IMDICO: I have trouble composing your frame')
 9500 FORMAT ('IMDICO: I have trouble communicating with the TV')
 9600 FORMAT ('IMDICO: I have trouble writing the image to disk')
 9610 FORMAT ('IMDICO: I can''t open the output image file')
 9700 FORMAT ('IMDICO: You have more than one TV channel on')
 9750 FORMAT ('IMDICO: I can''t open your map file')
 9800 FORMAT ('IMDICO: There is something wrong with the BLC/TRC')
 9850 FORMAT ('IMDICO: There are not enough film pixels for all this')
      END
      SUBROUTINE MAKHED (LUNOUT, FILNAM, DATEX, TIMEX, USERNO, FLMSIZ,
     *                   FLMTYP, NCOPY, BITPIX, NX, NY,
     *                   LUTPPB, BPLUT, OFMLEN, LUTPTR, OFMPTR, DATPTR,
     *                   STRING)
C-----------------------------------------------------------------------
C
C     This subroutine makes the Dicomed Image File header and writes
C     it out.
C
C-----------------------------------------------------------------------
C
      INTEGER LUNOUT, USERNO, FLMSIZ, FLMTYP, NCOPY, BITPIX, NX, NY
      INTEGER LUTPPB, BPLUT, OFMLEN, LUTPTR, OFMPTR, DATPTR, IERROR
      INTEGER HOSTNM, I, J, K, I4
      BYTE A1(4), I1, BUFFER(512)
      CHARACTER*(*) FILNAM, DATEX, TIMEX, STRING
      CHARACTER*64 HEADER(8), SIZE(3)*4, TYPE(3)*6, HOST*8
C
      EQUIVALENCE (I4,A1(1)), (A1(4),I1)
C
      DATA SIZE, TYPE /'35mm','2x2 ','4x5', 'ColPos','ColNeg','B/W   '/
C
C-----------------------------------------------------------------------
C
      HEADER(1) = 'Filename:                               '//
     *            'Origin:                 '
      HEADER(2) = 'Date:               Time:               '//
     *            'Userno:                 '
      HEADER(3) = 'Filmsize:           Filmtype:           '//
     *            'Copies:                 '
      HEADER(4) = 'Bits/pixel:         Columns:            '//
     *            'Rows:                   '
      HEADER(5) = 'LUTs/pixelbyte:     Bits/LUTelement:    '//
     *            'OFMelements:            '
      HEADER(6) = 'LUTpointer:         OFMpointer:         '//
     *            'Datapointer:            '
      HEADER(7) = 'Usercomments:                           '//
     *            '                        '
      HEADER(8) = 'Recorded:                               '//
     *            '                        '
C
      I = HOSTNM (HOST)
      DO 10 I=1,8
         IF (ICHAR(HOST(I:I)) .EQ. 0) HOST(I:I) = ' '
 10   CONTINUE
      HEADER(1)(11:28) = FILNAM
      HEADER(1)(49:56) = HOST
      HEADER(2)(7:15) = DATEX
      HEADER(2)(27:34) = TIMEX
      WRITE (HEADER(2)(49:52), 1004) USERNO
      HEADER(3)(11:14) = SIZE(FLMSIZ)
      HEADER(3)(31:36) = TYPE(FLMTYP)
      WRITE (HEADER(3)(49:51), 1003) NCOPY
      WRITE (HEADER(4)(13:14), 1002) BITPIX
      WRITE (HEADER(4)(30:33), 1004) NX
      WRITE (HEADER(4)(47:50), 1004) NY
      WRITE (HEADER(5)(17:17), 1001) LUTPPB
      WRITE (HEADER(5)(38:39), 1002) BPLUT
      WRITE (HEADER(5)(54:58), 1004) OFMLEN
      WRITE (HEADER(6)(13:17), 1005) LUTPTR
      WRITE (HEADER(6)(33:37), 1005) OFMPTR
      WRITE (HEADER(6)(54:58), 1005) DATPTR
      HEADER(7)(15:64) = STRING
C
      K = 1
      DO 30 J=1,8
         DO 20 I=1,63
            I4 = ICHAR(HEADER(J)(I:I))
            BUFFER(K) = I1
            K = K + 1
 20      CONTINUE
         BUFFER(K) = 10
         K = K + 1
 30   CONTINUE
C
      CALL DICOUT (LUNOUT, BUFFER, 512, IERROR)
C
      RETURN
C-----------------------------------------------------------------------
 1001 FORMAT (I1)
 1002 FORMAT (I2)
 1003 FORMAT (I3)
 1004 FORMAT (I4)
 1005 FORMAT (I5)
      END
      SUBROUTINE WRTPLN (LUN, FRBUFF, NX, NY, IERROR)
C-----------------------------------------------------------------------
C
C     wrtpln writes the frame buffer frbuff (size <nx> by <ny>)
C     to file <lun>.
C
C-----------------------------------------------------------------------
C
      INTEGER LUN, NX, NY, IERROR
      INTEGER J
      BYTE FRBUFF(NX,NY)
C
C-----------------------------------------------------------------------
C
      DO 50 J=NY,1,-1
         CALL DICOUT (LUN, FRBUFF(1,J), NX, IERROR)
         IF (IERROR .NE. 0) GOTO 990
 50   CONTINUE
C
 990  CONTINUE
      RETURN
      END
      SUBROUTINE DICOUT (LUN, BUF, NX, IERROR)
C-----------------------------------------------------------------------
C
C     Adds a single line (length <nx>) to the output buffer and writes
C     a record to <lun> whenever appropriate (i.e., there are at least
C     4096 bytes waiting).  For lun<0 it is just a direct write to <-lun>.
C
C-----------------------------------------------------------------------
C
      INTEGER LUN, NX, IERROR, I
      BYTE BUF(NX)
C
      INTEGER BUFPTR
      BYTE OUTBUF(8192), LINBUF(4096)
      COMMON /DICCOM/ BUFPTR, OUTBUF
      EQUIVALENCE (OUTBUF(1), LINBUF(1))
C
C-----------------------------------------------------------------------
C                                       Regular write
      IF (LUN .LT. 0) THEN
            WRITE (-LUN,ERR=900) BUF
         ELSE
C                                       Add to buffer
            DO 10 I=1,NX
               OUTBUF(BUFPTR+I) = BUF(I)
 10         CONTINUE
            BUFPTR = BUFPTR + NX
C                                       Flush one 4096-byte record
C                                       if there is enough
            IF (BUFPTR .GE. 4096) THEN
               WRITE (LUN,ERR=900) LINBUF
C                                       Shift the rest back, if any
               BUFPTR = BUFPTR - 4096
               IF (BUFPTR .GT. 0) THEN
                  DO 20 I=1,BUFPTR
                     OUTBUF(I) = OUTBUF(I+4096)
 20               CONTINUE
               END IF
            END IF
      END IF
      GOTO 990
C
 900  CONTINUE
      IERROR = -1
C
 990  CONTINUE
      RETURN
      END
      SUBROUTINE DICFLS (LUN)
C-----------------------------------------------------------------------
C
C     Flushes the output buffer to <lun>.
C
C-----------------------------------------------------------------------
C
      INTEGER LUN, I
C
      INTEGER BUFPTR
      BYTE OUTBUF(8192), LINBUF(4096)
      COMMON /DICCOM/ BUFPTR, OUTBUF
      EQUIVALENCE (OUTBUF(1), LINBUF(1))
C
C-----------------------------------------------------------------------
C
      DO 10 I=BUFPTR+1,4096
         LINBUF(I) = 0
 10   CONTINUE
      WRITE (LUN) LINBUF
      RETURN
      END
      SUBROUTINE IM2LOD (LUN, IND, NX, NY, PXINC, WIN, BUFSZ, BUFF,
     *   FRBUFF, NNX, NNY, I0, J0, IERR)
C-----------------------------------------------------------------------
C! load image to a TV memory from open MA file
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Subroutine to load a map from an already opened map file to an in-
C   memory frame buffer. It assumes that the windows are all computed.
C   One can think of the frame buffer as a TV device.
C   Inputs:
C      LUN      I      Logical unit # of map file
C      IND      I      FTAB pointer for map file
C      NX       I      Size of FRBUFF in X
C      NY       I      Size of FRBUFF in Y
C      PXINC    I(2)   Increment in x,y between included pixels
C                      Negative values indicate interpolation
C      WIN      I(4)   Map window: BLC x,y TRC x,y
C      BUFSZ    I      Buffer size in bytes
C      BUFF     R(*)   Read buffer
C      NNX      I      Number of pixels to fill in X
C      NNY      I      Number of pixels to fill in Y
C      I0       I      Lower LH corner of inage in FRBUFF
C      J0       I          "          "
C   Outputs
C      FRBUFF   B(NX,NY) Frame buffer
C      IERR     I      Error code: 0 => ok
C                                  1 => input errors
C                                  2 => MINIT errors
C                                  3 => MDISK errors
C   Commons: /MAPHDR/ CATBLK  image header
C-----------------------------------------------------------------------
      INTEGER   LUN, IND, PXINC(2), IMAWIN(4), WIN(4), BUFSZ, IERR
      INTEGER   NNX, NNY, I0, J0, II0, NX, NY
      REAL      BUFF(*)
      BYTE      FRBUFF(NX, NY)
C
      CHARACTER TRANFN*2
      INTEGER   JERR, ININD, DELBLK, I, IYTV, MPIX, NPIX, IM1, IM2,
     *   HORIZ, IX, PLINC(2), NXINT, NYINT, LPIX, IBUFF(4096),
     *   JBUFF(4096), IY, TBUFF(4096), II
      INTEGER*2 I2
      BYTE AI(2), I1
      EQUIVALENCE (AI(1), I2), (AI(2), I1)
      REAL      EPS, X, Y
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA EPS, HORIZ /0.01, 0/
C-----------------------------------------------------------------------
      IERR = 1
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CATBLK(IIDEP), DELBLK,
     *   JERR)
      IF (JERR.NE.0) GO TO 999
      DELBLK = DELBLK + 1
      IMAWIN(1) = I0
      IMAWIN(2) = J0
      IMAWIN(3) = I0 + NNX - 1
      IMAWIN(4) = J0 + NNY - 1
      II0 = I0 -1
C                                       fix up img cat block
      CALL COPY (4, WIN, CATBLK(IIWIN))
      CALL COPY (4, IMAWIN, CATBLK(IICOR))
      CALL H2CHR (2, 1, CATH(IITRA), TRANFN)
C                                       start map read
      PLINC(1) = MAX (1, PXINC(1))
      PLINC(2) = MAX (1, PXINC(2))
      NXINT = MAX (1, -PXINC(1))
      NYINT = MAX (1, -PXINC(2))
      NPIX = 1 + WIN(3) - WIN(1)
      MPIX = 1 + (IMAWIN(3) - IMAWIN(1)) / NXINT
      LPIX = 1 + IMAWIN(3) - IMAWIN(1)
      CALL MINIT ('READ', LUN, IND, CATBLK(KINAX), CATBLK(KINAX+1), WIN,
     *   BUFF, BUFSZ, DELBLK, JERR)
      IF (JERR.EQ.0) GO TO 20
         WRITE (MSGTXT,1010) JERR
         GO TO 980
C                                       set up TV writing
 20   IM1 = WIN(2)
      IM2 = WIN(4)
      IERR = 3
      IYTV = IMAWIN(2)-1
C                                       read 1st row
      CALL MDISK ('READ', LUN, IND, BUFF, ININD, JERR)
      IF (JERR.EQ.0) GO TO 25
         WRITE (MSGTXT,1020) JERR
         GO TO 980
 25   CALL ISCALE (TRANFN, MAXINT, CATR(IRRAN), NPIX, PLINC,
     *   BUFF(ININD), TBUFF)
      CALL LINTER (MPIX, NXINT, TBUFF, IBUFF)
      DO 70 IY = IM1,IM2
C                                       End: write row only
         IF (IY.LT.IM2) GO TO 30
            IYTV = IYTV + 1
            DO 27 II=1,NNX
               I2 = IBUFF(II)
               FRBUFF(II+II0,IYTV) = I1
 27         CONTINUE
            GO TO 70
 30      CALL MDISK ('READ', LUN, IND, BUFF, ININD, JERR)
         IF (JERR.EQ.0) GO TO 40
            WRITE (MSGTXT,1020) JERR
            GO TO 980
 40      IF (MOD(IY-IM1,PLINC(2)).NE.0) GO TO 70
            CALL ISCALE (TRANFN, MAXINT, CATR(IRRAN), NPIX, PLINC,
     *         BUFF(ININD), TBUFF)
            CALL LINTER (MPIX, NXINT, TBUFF, JBUFF)
            IYTV = IYTV + 1
            DO 47 II=1,NNX
               I2 = IBUFF(II)
               FRBUFF(II+II0,IYTV) = I1
 47         CONTINUE
C                                       interpolate rows
            IF (NYINT.LE.1) GO TO 65
               X = 1.0 / NYINT
               DO 60 I = 2,NYINT
                  Y = (I-1) * X
                  DO 55 IX = 1,LPIX
                     TBUFF(IX) = IBUFF(IX) + Y * (JBUFF(IX) - IBUFF(IX))
     *                  + 0.4999
 55                  CONTINUE
                  IYTV = IYTV + 1
                  DO 57 II=1,NNX
                     I2 = TBUFF(II)
                     FRBUFF(II+II0,IYTV) = I1
 57               CONTINUE
 60            CONTINUE
 65         CALL COPY (LPIX, JBUFF, IBUFF)
 70      CONTINUE
      IERR = 0
      GO TO 999
C                                       write error message
 980  CALL MSGWRT (7)
C
 999   RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('IM2LOD: MINIT DISK I/O ERROR =',I6)
 1020 FORMAT ('IM2LOD: MDISK DISK I/O ERROR =',I6)
      END
      SUBROUTINE IM3LOD (LUN, IND, NX, NY, INC, IWIN, BUFSIZ, BUFFER,
     *                   FRBUFF, NNX, NNY, NNZ, MX, MY, IZP, IERROR)
C-----------------------------------------------------------------------
C
C     IM3LOD writes cube panels, using IM2LOD.  It puts the individual
C     planes in a mosaic with borders and uses IM2LOD to paint each pane.
C     The call parameters are pretty much the same as IM2LOD's:
C   Inputs:
C      LUN      I      Logical unit # of map file
C      IND      I      FTAB pointer for map file
C      NX       I      Size of FRBUFF in X
C      NY       I      Size of FRBUFF in Y
C      INC      I(3)   Increment in x,y,z between included pixels
C                      Negative values indicate interpolation
C      IWIN     I(4)   Map window: BLC x,y TRC x,y
C      BUFSIZ   I      Buffer size in bytes
C      BUFFER   R(*)   Buffer
C      NNX      I      Number of pixels to fill in X
C      NNY      I      Number of pixels to fill in Y
C      NNZ      I      Number of panes
C      MX       I      Number of panes in X
C      MY       I      Number of panes in Y
C      IZP      I      Dimension number of third axis
C   Outputs
C      FRBUFF   B(NX,NY) Frame buffer
C      IERROR   I      Error code: 0 => ok
C                                  1 => input errors
C                                  2 => MINIT errors
C                                  3 => MDISK errors
C
C-----------------------------------------------------------------------
C
      INTEGER LUN, IND, NX, NY, INC(3), IWIN(4), BUFSIZ, BUFFER(BUFSIZ)
      INTEGER NNX, NNY, NNZ, MX, MY, IZP, IERROR
      INTEGER I, J, K, L, M, I0, J0
      BYTE FRBUFF(NX,NY)
C
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C
C-----------------------------------------------------------------------
C
C                                       Prepare the frame
      DO 20 J=1,NY-1
         FRBUFF(1,J) = -1
         DO 10 I=2,NX
            FRBUFF(I,J) = 0
 10      CONTINUE
 20   CONTINUE
      DO 30 I=1,NX
         FRBUFF(I,NY) = -1
 30   CONTINUE
C                                       Loop over planes
      CATBLK(IIDEP+IZP-3) = CATBLK(IIDEP+IZP-3) - INC(3)
      K = 0
      DO 110 M=1,MY
         J0 = NY - M * (NNY+1) + 1
         DO 100 L=1,MX
            K = K + 1
            I0 = 2 + (L - 1) * (NNX+1)
            IF (K .LE. NNZ) THEN
               CATBLK(IIDEP+IZP-3) = CATBLK(IIDEP+IZP-3) + INC(3)
               CALL IM2LOD (LUN, IND, NX, NY, INC, IWIN, BUFSIZ, BUFFER,
     *                      FRBUFF, NNX, NNY, I0, J0, IERROR)
               IF (IERROR .NE. 0) GOTO 900
               J = J0 - 1
               DO 80 I=I0,I0+NNX
                  FRBUFF(I,J) = -1
 80            CONTINUE
               I = I0 + NNX
               DO 90 J=J0,J0+NNY
                  FRBUFF(I,J) = -1
 90            CONTINUE
            END IF
 100     CONTINUE
 110  CONTINUE
C
 900  CONTINUE
      RETURN
      END

      SUBROUTINE FINDVO (MXNUM, DISK, CNO, CATBLK, ISUB, IFQ, NSOUWD,
     *   SOUWAN, BTIME, ETIME, NVORNG, VORNG)
C-----------------------------------------------------------------------
C! finds selected ranges of visibility record numbers
C# UV
C-----------------------------------------------------------------------
C;  Copyright (C) 2011
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Checks the NX table to match up the start position in the UV data
C   with the file offset
C   Inputs:
C      MXNUM    I        Maximum number intervals allowed
C      DISK     I        Disk file number
C      CNO      I        Catalog number
C      CATBLK   I(*)     Data set header
C      ISUB     I        Subarray
C      IFQ      I        FreqID
C      NSOUWD   I        Number sources in list
C      SOUWAN   I(*)     Source numbers wanted
C      BTIME    R        Start time
C      ETIME    R        Start time
C   In/Out in common
C      NVORNG   I        Number VO range's
C      VORNG    I(2,*)   Range of vis number (VO really vis#-1)
C-----------------------------------------------------------------------
      INTEGER   MXNUM, disk, cno, catblk(256), ISUB, IFQ, NSOUWD,
     *   SOUWAN(*), NVORNG, VORNG(2,*)
      REAL      BTIME, ETIME
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NXBUFF(512), VER, IERR, NXKOLS(MAXNXC), NXNUMV(MAXNXC),
     *   INXRNO, IDSOUR, SUBARR, FREQID, VSTART, VEND, I, IROW, NROW,
     *   LUNNX, VOIN(2), LUNTMP
      REAL      TIME, DTIME, EPS
      LOGICAL   INONE
      INCLUDE 'INCS:DMSG.INC'
      DATA EPS /1.157E-6/
C-----------------------------------------------------------------------
      VOIN(1) = VORNG(1,1)
      VOIN(2) = VORNG(2,1)
C                                       open index table
      VER = 0
      LUNNX = LUNTMP (1)
      CALL NDXINI ('READ', NXBUFF, DISK, CNO, VER, CATBLK, LUNNX,
     *   INXRNO, NXKOLS, NXNUMV, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN NX TABLE'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       read
      NROW = NXBUFF(5)
      NVORNG = 0
      INONE = .FALSE.
      DO 20 IROW = 1,NROW
         INXRNO = IROW
         CALL TABNDX ('READ', NXBUFF, INXRNO, NXKOLS, NXNUMV, TIME,
     *      DTIME, IDSOUR, SUBARR, VSTART, VEND, FREQID, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READ NX TABLE'
            CALL MSGWRT (8)
            GO TO 30
         ELSE IF (IERR.EQ.0) THEN
            IF (((ISUB.LE.0) .OR. (SUBARR.LE.0) .OR. (ISUB.EQ.SUBARR))
     *         .AND. ((IFQ.LE.0) .OR. (FREQID.LE.0) .OR.
     *         (IFQ.EQ.FREQID))) THEN
               IF ((BTIME.LE.TIME+DTIME/2.0-EPS) .AND.
     *            (ETIME.GE.TIME-DTIME/2.0) .AND. (VEND.GE.VOIN(1)))
     *            THEN
                  IF (NSOUWD.GT.0) THEN
                     DO 10 I = 1,NSOUWD
                        IF (IDSOUR.EQ.SOUWAN(I)) GO TO 15
 10                     CONTINUE
                     INONE = .FALSE.
                     GO TO 20
                     END IF
 15               IF (.NOT.INONE) THEN
                     INONE = .TRUE.
                     NVORNG = NVORNG + 1
                     IF (NVORNG.GT.MXNUM) THEN
                        MSGTXT = 'FINDVO: TOO MANY SCANS INCLUDED'
                        CALL MSGWRT (7)
                        NVORNG = 1
                        VORNG(1,1) = VOIN(1)
                        VORNG(2,1) = VOIN(2)
                        GO TO 30
                        END IF
                     VORNG(1,NVORNG) = MAX (VSTART, VOIN(1))
                     VORNG(2,NVORNG) = VEND
                  ELSE
                     VORNG(2,NVORNG) = VEND
                     END IF
                  END IF
               END IF
            END IF
 20      CONTINUE
C                                       close and exit
 30   CALL TABNDX ('CLOS', NXBUFF, INXRNO, NXKOLS, NXNUMV, TIME, DTIME,
     *   IDSOUR, SUBARR, VSTART, VEND, FREQID, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FNDVO: ERROR',I4,' ON ',A)
      END

      SUBROUTINE DA13 (DATJUL, A1, A2, A3)
C-----------------------------------------------------------------------
C! Computes arguments A1, A2 and A3 of the mean motion of the sun.
C# Math Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Calculation of the basic arguments A1, A2, A3 of the mean motion of
C   the Sun.  A1 is the mean longitude of the Sun at DATJUL, referred to
C   the mean equinox of DATJUL.  A2 is the mean longitude of the sun's
C   perigee at DATJUL, referred to the mean equinox of DATJUL.  A3 is
C   the mean anomaly of the Sun at DATJUL.
C-----------------------------------------------------------------------
      DOUBLE PRECISION DATJUL, A1, A2, A3
      DOUBLE PRECISION TWOPI, CC, T
C-----------------------------------------------------------------------
      TWOPI = 8.D0 * ATAN (1.D0)
      CC = TWOPI / 1296000.D0
      T = (DATJUL - 2415020.D0) / 36525.D0
      A1 = ((1.089D0 * T + 129602768.13D0) * T + 1006908.04D0) * CC
      A2 = (((.012D0 * T + 1.63D0) * T + 6189.03D0) * T
     *   + 1012395D0) * CC
      A3 = (((-.012D0 * T - .54D0) * T + 129596579.1D0) * T
     *   + 1290513.04D0) * CC
      A1 = MOD (A1, TWOPI)
      A2 = MOD (A2, TWOPI)
      A3 = MOD (A3, TWOPI)
C
 999  RETURN
      END

      SUBROUTINE PHINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   PHROW, PHCOLS, PHNUMV, NUMPOL, NUMIF, NUMTON, TABREV, IRET)
C-----------------------------------------------------------------------
C! Intialize a FITS interchange phase-cal table for reading
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1998, 2006, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Verify that a temporary phase-cal (PH) table is a valid FITS
C   interferometry data interchange table and, if so, open it for
C   reading.
C   Inputs:
C      OPCODE      C*4        Operation code:
C                               'READ' - open for read only
C      DISK        I          Disk to use.
C      CNO         I          Catalog slot number
C      CATBLK      I(256)     Catalog header block
C      LUN         I          Logical unit number to use
C   Input/output:
C      BUFFER      I(512)     Table I/O control block and buffer
C      VER         I          PH file version (if VER = 0 when PHINI
C                               is called the the PH table with the
C                               highest version number will be
C                               initialized provided that one exists and
C                               VER will be set to its version number)
C   Output:
C      PHROW       I          Next PH table row to read (1)
C      PHCOLS      I(MAXPHC)  Column pointers in the order
C                                1  TIME
C                                2  TIME_INTERVAL
C                                3  SOURCE_ID
C                                4  ANTENNA_NO
C                                5  ARRAY
C                                6  FREQID
C                                7  CABLE_CAL
C                                8  STATE_1
C                                9  PC_FREQ_1
C                               10  PC_REAL_1
C                               11  PC_IMAG_1
C                               12  PC_RATE_1
C                               13  STATE_2
C                               14  PC_FREQ_2
C                               15  PC_REAL_2
C                               16  PC_IMAG_2
C                               17  PC_RATE_2
C      PHNUMV      I(MAXPHC)  Column dimensions in the same order as
C                               PHCOLS
C      NUMPOL      I          Number of polarizations in table
C      NUMIF       I          Number of IFs covered by the table
C      NUMTON      I          Number of phase-cal tones in table
C      TABREV      I          Table revision number
C      IRET        I          Return code:
C                               0 -> table open
C                               1 -> table format is not valid
C                               2 -> table format is valid but exceeds
C                                    an AIPS limit
C                               3 -> an I/O error was detected
C                             999 -> subroutine call was invalid
C   Notes:
C      PH tables should be converted to AIPS PC tables when read from
C      FITS interferometry data interchange files.
C
C      NUMIF is set to the value of the NO_BAND keyword and need not
C      correspond to the number of IFs in the root data file (its value
C      may be greater than or equal to this quantity).
C
C      The table will be left open if IRET = 1 or 2 on exit but will
C      not be safe for reading using TABPH.  The state of the table
C      will be indeterminate if IRET = 3.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PTAB.INC'
      INCLUDE 'INCS:PPHV.INC'
C
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, PHROW,
     *   PHCOLS(MAXPHC), PHNUMV(MAXPHC), NUMPOL, NUMIF, NUMTON,
     *   TABREV, IRET
C
C     Local variables:
C
C     NKEY     Number of keywords to read from table
C     NCOL     Number of columns in table
C     NREC     Number of records by which to extend table (unused)
C     DATP     Table pointers and type codes
C     NPHKEY   Number of keywords to read from table (parameter)
C     PHKEYW   Keywords to be read
C     KEYLOC   Keyword pointers
C     KEYTYP   Keyword type codes
C     KEYVAL   Keyword value buffer
C     CURREV   Current PH revision number (parameter)
C     CTITLE   Column titles (indexed by column and table revision)
C     CTYPE    Column types(indexed by column and table revision)
C     CDIM     Column dimensions (indexed by column and table revision)
C     XTYPE    Expected column type codes for current table (indexed
C                by column)
C     XDIM     Expected column dimensions for current table (indexed by
C                column)
C     COLS     Column pointers
C     COL      Column number
C     KEYW     Keyword number
C     TYPE     Type of current column
C     MSGSAV   Saved message suppression level
C
      INTEGER   NKEY, NCOL, NREC, DATP(128,2), JERR, NC, IPOINT
C
      INTEGER   NPHKEY
      PARAMETER (NPHKEY = 4)
      CHARACTER PHKEYW(NPHKEY)*8
      INTEGER   KEYLOC(NPHKEY), KEYTYP(NPHKEY), KEYVAL(2 * NPHKEY)
C
      INTEGER   CURREV
      PARAMETER (CURREV = 2)
      CHARACTER CTITLE(MAXPHC, CURREV)*24
      INTEGER   CTYPE(MAXPHC, CURREV), CDIM(MAXPHC, CURREV)
      INTEGER   XTYPE(MAXPHC), XDIM(MAXPHC), COLS(MAXPHC)
C
      INTEGER   COL, KEYW, TYPE
      INTEGER   MSGSAV
C
      INTEGER   ITRIM
      EXTERNAL  ITRIM
C
      INCLUDE 'INCS:DMSG.INC'
C                                       Keywords
      DATA PHKEYW /'TABREV', 'NO_POL', 'NO_BAND', 'NO_TONES'/
C                                       Columns for TABREV 1
      DATA (CTITLE(COL, 1), COL = 1, MAXPHC)
     *   /'TIME                    ', 'TIME_INTERVAL           ',
     *    'SOURCE_ID               ', 'ANTENNA_NO              ',
     *    'ARRAY                   ', 'FREQID                  ',
     *    'CABLE_CAL               ', 'STATE_1                 ',
     *    'PC_FREQ 1               ', 'PC_REAL 1               ',
     *    'PC_IMAG 1               ', 'PC_RATE 1               ',
     *    'STATE_2                 ', 'PC_FREQ 2               ',
     *    'PC_REAL 2               ', 'PC_IMAG 2               ',
     *    'PC_RATE 2               ' /
      DATA (CTYPE(COL, 1), COL = 1, MAXPHC)
     *   / TABDBL, TABFLT, TABINT, TABINT, TABINT,
     *     TABINT, TABDBL, TABFLT, TABDBL, TABFLT,
     *     TABFLT, TABFLT, TABFLT, TABDBL, TABFLT,
     *     TABFLT, TABFLT /
      DATA (CDIM(COL, 1), COL = 1, MAXPHC)
     *   / 1, 1, 1, 1, 1, 1, 1, 0, 0, 0,
     *     0, 0, 0, 0, 0, 0, 0 /
C                                       Columns for TABREV 2
      DATA (CTITLE(COL, 2), COL = 1, MAXPHC)
     *   /'TIME                    ', 'TIME_INTERVAL           ',
     *    'SOURCE_ID               ', 'ANTENNA_NO              ',
     *    'ARRAY                   ', 'FREQID                  ',
     *    'CABLE_CAL               ', 'STATE_1                 ',
     *    'PC_FREQ_1               ', 'PC_REAL_1               ',
     *    'PC_IMAG_1               ', 'PC_RATE_1               ',
     *    'STATE_2                 ', 'PC_FREQ_2               ',
     *    'PC_REAL_2               ', 'PC_IMAG_2               ',
     *    'PC_RATE_2               ' /
      DATA (CTYPE(COL, 2), COL = 1, MAXPHC)
     *   / TABDBL, TABFLT, TABINT, TABINT, TABINT,
     *     TABINT, TABDBL, TABFLT, TABDBL, TABFLT,
     *     TABFLT, TABFLT, TABFLT, TABDBL, TABFLT,
     *     TABFLT, TABFLT /
      DATA (CDIM(COL, 2), COL = 1, MAXPHC)
     *   / 1, 1, 1, 1, 1, 1, 1, 0, 0, 0,
     *     0, 0, 0, 0, 0, 0, 0 /
C-----------------------------------------------------------------------
C                                       open table only read allowed
      IF (OPCODE .EQ. 'READ') THEN
         NKEY = NPHKEY
         NCOL = MAXPHC
         NREC = 0
         CALL TABINI (OPCODE, 'PH', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *      NREC, NCOL, DATP, BUFFER, IRET)
         IF (IRET.EQ.0) THEN
            PHROW = 1
C           Read the mandatory keywords while supressing messages
C           from TABKEY:
            MSGSAV = MSGSUP
            MSGSUP = 32000
            NKEY = NPHKEY
            CALL TABKEY ('READ', PHKEYW, NKEY, BUFFER, KEYLOC, KEYVAL,
     *         KEYTYP, IRET)
            MSGSUP = MSGSAV
C                                       Check the revision number:
            IF (IRET.EQ.0) THEN
               IF (KEYTYP(1).EQ.TABINT) THEN
                  TABREV = KEYVAL(KEYLOC(1))
                  IF ((TABREV.LT.1) .OR. (TABREV.GT.CURREV)) THEN
                     WRITE (MSGTXT,9000) VER
                     CALL MSGWRT (6)
                     WRITE (MSGTXT,9001) TABREV
                     CALL MSGWRT (6)
                     IRET = 1
                     END IF
               ELSE
                  WRITE (MSGTXT,9000) VER
                  CALL MSGWRT (6)
                  WRITE (MSGTXT,9002) PHKEYW(1), 'INTEGER'
                  CALL MSGWRT (6)
                  IRET = 1
                  END IF
C                                       Check the NO_POL keyword
               IF (KEYTYP(2).EQ.TABINT) THEN
                  NUMPOL = KEYVAL(KEYLOC(2))
                  IF ((NUMPOL.LT.1) .OR. (NUMPOL.GT.2)) THEN
                     WRITE (MSGTXT,9000) VER
                     CALL MSGWRT (6)
                     WRITE (MSGTXT,9002) PHKEYW(2), 'VALID'
                     CALL MSGWRT (6)
                     IRET = 1
                     END IF
               ELSE
                  WRITE (MSGTXT,9000) VER
                  CALL MSGWRT (6)
                  WRITE (MSGTXT,9002) PHKEYW(2), 'INTEGER'
                  CALL MSGWRT (6)
                  IRET = 1
                  END IF
C                                       Check the NO_BAND keyword
               IF (KEYTYP(3).EQ.TABINT) THEN
                  NUMIF = KEYVAL(KEYLOC(3))
                  IF (NUMIF.LT.0) THEN
                     WRITE (MSGTXT,9000) VER
                     CALL MSGWRT (6)
                     WRITE (MSGTXT,9002) PHKEYW(3), 'POSITIVE'
                     CALL MSGWRT (6)
                     IRET = 1
                  ELSE IF (NUMIF.GT.MAXIF) THEN
                     WRITE (MSGTXT,9003) VER
                     CALL MSGWRT (6)
                     WRITE (MSGTXT,9004) PHKEYW(3), NUMIF, MAXIF
                     CALL MSGWRT (6)
                     IRET = 2
                     END IF
               ELSE
                  WRITE (MSGTXT,9000) VER
                  CALL MSGWRT (6)
                  WRITE (MSGTXT,9002) PHKEYW(3), 'INTEGER'
                  CALL MSGWRT (6)
                  IRET = 1
                  END IF
C                                       Check the NO_TONES keyword
               IF (KEYTYP(4).EQ.TABINT) THEN
                  NUMTON = KEYVAL(KEYLOC(4))
                  IF (NUMTON.LT.0) THEN
                     WRITE (MSGTXT,9000) VER
                     CALL MSGWRT (6)
                     WRITE (MSGTXT,9002) PHKEYW(4), 'POSITIVE'
                     CALL MSGWRT (6)
                     IRET = 1
                  ELSE IF (NUMTON.GT.MAXTON) THEN
                     WRITE (MSGTXT,9003) VER
                     CALL MSGWRT (6)
                     WRITE (MSGTXT,9004) PHKEYW(4), NUMTON, MAXTON
                     CALL MSGWRT (6)
                     IRET = 2
                     END IF
               ELSE
                  WRITE (MSGTXT,9000) VER
                  CALL MSGWRT (6)
                  WRITE (MSGTXT,9002) PHKEYW(4), 'INTEGER'
                  CALL MSGWRT (6)
                  IRET = 1
                  END IF
C                                       List missing keywords:
            ELSE IF (IRET.GT.20) THEN
               WRITE (MSGTXT,9000) VER
               CALL MSGWRT (6)
               DO 10 KEYW = 1,NPHKEY
                  IF (KEYLOC(KEYW).LE.0) THEN
                     WRITE (MSGTXT,9005) PHKEYW(KEYW)
                     CALL MSGWRT (6)
                     END IF
 10               CONTINUE
               IRET = 1
            ELSE
               CALL TABERR ('READ', 'TABKEY', 'PHINI ', IRET)
               IRET = 3
               END IF
C                                       Decode and verify the column
C                                       structure of the table
            IF (IRET.EQ.0) THEN
C                                       1 <= TABREV <= CURREV
C                                       0 <= NUMIF <= MAXIF
C                                       1 <= NUMPOL <= 2
C                                       0 <= NUMTON <= MAXTON
               CALL COPY (MAXPHC, CTYPE(1, TABREV), XTYPE)
               CALL COPY (MAXPHC, CDIM(1, TABREV), XDIM)
               NCOL = 7 + 5 * NUMPOL
               DO 20 COL = 8,NCOL
                  IF ((COL.EQ.8) .OR. (COL.EQ.13)) THEN
                     XDIM(COL) = 4 * NUMIF
                  ELSE
                     XDIM(COL) = NUMTON * NUMIF
                     END IF
   20             CONTINUE
               CALL FNDCOL (NCOL, CTITLE(1, TABREV), 24, .TRUE., BUFFER,
     *            COLS, JERR)
               IF ((JERR.EQ.0) .OR. (JERR.GT.10)) THEN
                  DO 40 COL = 1,NCOL
                     IPOINT = COLS(COL)
                     NC = ITRIM (CTITLE(COL,TABREV))
                     IF (IPOINT.GT.0) THEN
                        PHCOLS(COL) = DATP(IPOINT,1)
                        PHNUMV(COL) = DATP(IPOINT,2) / 10
                        IF (PHNUMV(COL).LE.0) THEN
                           WRITE (MSGTXT,1100) CTITLE(COL,TABREV)(:NC)
                           CALL MSGWRT (6)
                           END IF
C                                       Check type:
                        TYPE = MOD (DATP(IPOINT,2), 10)
                        IF (TYPE.NE.XTYPE(COL)) THEN
                           WRITE (MSGTXT,9000) VER
                           CALL MSGWRT (6)
                           WRITE (MSGTXT,9030) CTITLE(COL,TABREV)(:NC)
                           CALL MSGWRT (6)
                           PHCOLS(COL) = -1
                           PHNUMV(COL) = 0
                           END IF
C                                       Check dimensions:
                        IF (PHNUMV(COL).NE.XDIM(COL)) THEN
                           WRITE (MSGTXT,9000) VER
                           CALL MSGWRT (6)
                           WRITE (MSGTXT,9031) CTITLE(COL,TABREV)(:NC),
     *                        PHNUMV(COL), XDIM(COL)
                           CALL MSGWRT (6)
                           PHCOLS(COL) = -1
                           PHNUMV(COL) = 0
                           END IF
                     ELSE
                        WRITE (MSGTXT,1101) CTITLE(COL,TABREV)(:NC)
                        CALL MSGWRT (6)
                        PHCOLS(COL) = -1
                        PHNUMV(COL) = 0
                        END IF
   40                CONTINUE
               ELSE
                  CALL TABERR ('FIND', 'FNDCOL', 'PHINI ', IRET)
                  IRET = 3
                  END IF
               END IF
         ELSE
            CALL TABERR (OPCODE, 'TABINI', 'PHINI ', IRET)
            IRET = 3
            END IF
      ELSE
         WRITE (MSGTXT,9040) OPCODE
         IRET = 999
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('PHINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('PHINI: ''',A,''' COLUMN NOT FOUND')
 9000 FORMAT ('PHINI: PHASE-CAL (PH) TABLE ', I3, ' IS NOT VALID')
 9001 FORMAT ('PHINI: UNRECOGNIZED REVISION NUMBER ', I3)
 9002 FORMAT ('PHINI: ', A, ' KEYWORD DOES NOT HAVE ', A, ' VALUE')
 9003 FORMAT ('PHINI: PHASE-CAL (PH) TABLE ', I3,
     *        'CAN NOT BE USED BY AIPS')
 9004 FORMAT ('PHINI: ', A, ' VALUE ', I4, ' EXCEEDS LIMIT OF ', I4)
 9005 FORMAT ('PHINI: KEYWORD ', A, ' IS MISSING')
 9030 FORMAT ('PHINI: COLUMN ''', A, ''' HAS WRONG TYPE')
 9031 FORMAT ('PHINI: COLUMN ''', A, ''' HAS DIMENSION ', I4, ' NOT ',
     *        I4)
 9040 FORMAT ('PHINI: UNRECOGNIZED OPCODE ''', A, '''')
      END

      SUBROUTINE CHCOMP (NCHAR, KP1, STR1, KP2, STR2, EQUAL)
C-----------------------------------------------------------------------
C! compares two HOLLERITH strings
C# Character
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   CHCOMP compares two character strings
C   Inputs: NCHAR  I       # characters to compare
C           KP1    I       starting character in string 1
C           STR1   H(*)    string 1
C           KP2    I       starting character in string 2
C           STR2   H(*)    string 2
C   Output: EQUAL  L       T => strings are same
C-----------------------------------------------------------------------
      HOLLERITH STR1(*), STR2(*)
      INTEGER   NCHAR, KP1, KP2
      LOGICAL   EQUAL
C
      INTEGER   KA1, KA2, I1, I2, J1, J2, C1, C2, I
C-----------------------------------------------------------------------
      EQUAL = NCHAR.LE.0
      IF (EQUAL) GO TO 999
         KA1 = MAX (1, KP1) - 1
         KA2 = MAX (1, KP2) - 1
         DO 10 I = 1,NCHAR
            I1 = KA1 / 4 + 1
            I2 = KA2 / 4 + 1
            J1 = MOD (KA1, 4) + 1
            J2 = MOD (KA2, 4) + 1
            CALL ZGETCH (C1, STR1(I1), J1)
            CALL ZGETCH (C2, STR2(I2), J2)
            IF (C1.NE.C2) GO TO 999
            KA1 = KA1 + 1
            KA2 = KA2 + 1
 10         CONTINUE
         EQUAL = .TRUE.
C
 999  RETURN
      END

LOCAL INCLUDE 'NANS.INC'
C                                       Local include for NANS
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2)
      REAL      XSIN, XDISIN, XBCNT, XNCNT, BLC(7), TRC(7),
     *   BUFF1(UVBFSS)
      INTEGER   SEQIN, DISKIN, CNOIN, BCOUNT, NCOUNT, JBUFSZ, ILOCWT,
     *   CATOLD(256), INCSI, INCFI, INCIFI, LRECI, NRPRMI,
     *   IBUFF1(UVBFSS)
      LOGICAL   ISCOMP
      CHARACTER NAMEIN*12, CLAIN*6, DATYPE*2
      EQUIVALENCE (IBUFF1, BUFF1)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XBCNT, XNCNT, BLC,
     *   TRC
      COMMON /OTPARM/ CATOLD, SEQIN, DISKIN, ILOCWT, INCSI, INCFI,
     *   INCIFI, LRECI, NRPRMI, ISCOMP, NCOUNT, BCOUNT, CNOIN
      COMMON /CHARPM/ NAMEIN, CLAIN, DATYPE
      COMMON /BUFRS/ BUFF1, JBUFSZ
C                                       End local include for NANS
LOCAL END
      PROGRAM NANS
C-----------------------------------------------------------------------
C! Looks for NaNs in a data set
C# Utility UV UV-util VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 2011, 2015, 2017, 2020
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   NANS finds NaNs in a UV data set
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      BCOUNT         BCOUNT        Start vis in UV data set
C      NCOUNT         NCOUNT        Max number lines printed
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'NANS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'NANS '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL NANSIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       UV data
      IF (DATYPE.EQ.'UV') THEN
         CALL NANSUV (IRET)
      ELSE
         CALL NANSIM (IRET)
         END IF
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE NANSIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   NANSIN gets input parameters for NANS
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in NANS for more details.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, PTYPE*2
      INTEGER   OLDCNO, IROUND, NPARM, IERR, INCX
      LOGICAL   T
      INCLUDE 'NANS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 23
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      BCOUNT = IROUND (XBCNT)
      NCOUNT = IROUND (XNCNT)
      IF (BCOUNT.LT.1) BCOUNT = 1
      IF (NCOUNT.LT.1) NCOUNT = 1000
C                                       Get CATBLK from old file.
      OLDCNO = 1
      DATYPE = '  '
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   DATYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      CNOIN = OLDCNO
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       UV
      IF (DATYPE.EQ.'UV') THEN
C                                       Compressed data?
         ISCOMP = CATBLK(KINAX).EQ.1
C                                       Find weight and scale.
         IF (ISCOMP) THEN
            CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP),
     *         ILOCWT, JERR)
            IF (JERR.NE.0) THEN
               MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
               JERR = 9
               GO TO 990
               END IF
            END IF
C                                       Get uv header info.
         CALL UVPGET (JERR)
         IF (JERR.NE.0) GO TO 999
C                                       Save input file info
         INCX = CATBLK(KINAX)
         LRECI = LREC
         NRPRMI = NRPARM
         INCSI = INCS / INCX
         INCFI = INCF / INCX
         INCIFI = INCIF / INCX
C                                       Image
      ELSE IF (DATYPE.EQ.'MA') THEN
         CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, JERR)
         IF (JERR.NE.0) GO TO 999
      ELSE
         MSGTXT = 'UNRECOGNIZED FILE TYPE = ''' // DATYPE // ''''
         JERR = 10
         GO TO 990
         END IF
C                                        Put input file in READ
      PTYPE = DATYPE
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('NANSIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE NANSUV (IRET)
C-----------------------------------------------------------------------
C   NANSUV sends uv data one point at a time to the checking routine
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER IFILE*48
      INTEGER   INIO, IPTRI, LUNI, INDI, ILENBU, IBIND, I, IA1, IA2,
     *   BO, VO, NUMVIS, XCOUNT, NCOPY, JTT(3), JRET, YCOUNT
      LOGICAL   T, F
      INCLUDE 'NANS.INC'
      REAL      BASEN, RTT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI /16/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Number of visibilities in input
C                                       and output files.
      NCOPY = LRECI
      IF (ISCOMP) THEN
         NCOPY = NRPRMI
         MSGTXT = 'CHECKS RANDOM PARAMETERS ONLY FOR COMPRESSED DATA'
         CALL MSGWRT (7)
         END IF
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Init vis file for read.
      ILENBU = 0
      VO = BCOUNT - 1
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = BCOUNT - 1
      XCOUNT = 0
      YCOUNT = 0
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Loop over buffer
         DO 190 I = 1,INIO
            NUMVIS = NUMVIS + 1
            IF (MOD(NUMVIS,100000).EQ.0) THEN
               WRITE (MSGTXT,1105) NUMVIS
               CALL MSGWRT (2)
               END IF
C                                       Call user routine.
            CALL CNTNAN (NCOPY, IBUFF1(IPTRI), IRET)
            CALL CNTIND (NCOPY, BUFF1(IPTRI), JRET)
C                                       tell of NaN(s)
            IF ((IRET.GT.0) .OR. (JRET.GT.0)) THEN
               IF (ILOCB.GE.0) THEN
                  BASEN = BUFF1(IPTRI+ILOCB)
                  IA1 = BASEN / 256. + 0.1
                  IA2 = BASEN - IA1*256. + 0.1
               ELSE
                  IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
                  IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
                  END IF
               CALL T2DHMS (BUFF1(IPTRI+ILOCT), 3, JTT, RTT)
               IF (IRET.GT.0) THEN
                  WRITE (MSGTXT,1110) IRET, NUMVIS, IA1, IA2, JTT, RTT
                  IF (MSGTXT(56:56).EQ.' ') MSGTXT(56:56) = '0'
                  IF (XCOUNT.LT.NCOUNT) CALL MSGWRT (5)
                  XCOUNT = XCOUNT + 1
                  END IF
               IF (JRET.GT.0) THEN
                  WRITE (MSGTXT,1111) JRET, NUMVIS, IA1, IA2, JTT, RTT
                  IF (MSGTXT(56:56).EQ.' ') MSGTXT(56:56) = '0'
                  IF (YCOUNT.LT.NCOUNT) CALL MSGWRT (5)
                  YCOUNT = YCOUNT + 1
                  END IF
               END IF
            IPTRI = IPTRI + LRECI
 190        CONTINUE
         IF (INIO.GT.0) GO TO 100
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      IRET = 0
      WRITE (MSGTXT,1200) XCOUNT
      CALL MSGWRT (5)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('NANSUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1030 FORMAT ('NANSUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('NANSUV: ERROR',I3,' READING VIS FILE')
 1110 FORMAT (I7,' NaNs at vis',I10,' ants, T',I3.2,' -',I2.2,I4,'/',
     *   2(I2.2,':'),F6.3)
 1111 FORMAT (I7,' INDEs at vis',I10,' ants, T',I3.2,' -',I2.2,I4,'/',
     *   2(I2.2,':'),F6.3)
 1105 FORMAT ('At vis number',I12)
 1200 FORMAT (I10,' vis records had NaNs')
      END
      SUBROUTINE T2DHMS (TIMEIN, NDIG, TIME, RTIME)
C-----------------------------------------------------------------------
C   Convert from Time to Days Hours Minutes Seconds format
C   Input:
C      TIMEIN   R       Input:  Time
C      NDIG     I       Number digits in seconds display
C   Output:
C      TIME     I*(3)   Output Time in Days Hours Minutes
C      RTIME    R       SECONDS
C-----------------------------------------------------------------------
      REAL     TIMEIN, RTIME
      INTEGER  NDIG, TIME(3)
C
      REAL     T
      INTEGER  I, J
C-----------------------------------------------------------------------
      T = TIMEIN
      IF (TIMEIN.LT.0.0) T = -T
C
      TIME(1) = T
      T = (T - TIME(1)) * 24.0
      TIME(2) = T
      T = (T - TIME(2)) * 60.0
      TIME(3) = T
      T = (T - TIME(3)) * 60.0
      RTIME   = T
      J = 10 ** NDIG
      J = MAX (1, J)
      I = J*T + 0.5
C                                       Now Remove 60 seconds
      IF (I.GE.J*60) THEN
         RTIME = RTIME - 60.0
         TIME(3) = TIME(3) + 1
         END IF
C                                       Now Remove 60 minutes
      IF (TIME(3).GE.60) THEN
         TIME(3) = TIME(3) - 60
         TIME(2) = TIME(2) + 1
         END IF
C                                       Now Remove 24 hours
      IF (TIME(2).GE.24) THEN
         TIME(2) = TIME(2) - 24
         TIME(1) = TIME(1) + 1
         END IF
C                                       Sign
      IF (TIMEIN.LT.0.0) TIME(1) = -TIME(1)
C
 999  RETURN
      END
      SUBROUTINE CNTNAN (N, IARR, CNT)
C-----------------------------------------------------------------------
C   count NaNs
C   Inputs:
C      N      I      Number values to check
C      IARR   I(*)   Values to check
C   Outputs:
C      CNT    I      Number of NaNs
C-----------------------------------------------------------------------
      INTEGER   N, IARR(*), CNT
C
      INTEGER   I, I4NAN, J, ZAND
C                                       = 7F800000 mask for exponent
      DATA I4NAN /2139095040/
C-----------------------------------------------------------------------
      CNT = 0
      DO 10 I = 1,N
         J = ZAND (IARR(I), I4NAN)
         IF (J.EQ.I4NAN) CNT = CNT + 1
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE CNTIND (N, IARR, CNT)
C-----------------------------------------------------------------------
C   count INDEs
C   Inputs:
C      N      I      Number values to check
C      IARR   I(*)   Values to check
C   Outputs:
C      CNT    I      Number of NaNs
C-----------------------------------------------------------------------
      INTEGER   N, CNT
      REAL      IARR(*)
C
      INTEGER   I
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      CNT = 0
      DO 10 I = 1,N
         IF (IARR(I).EQ.FBLANK) CNT = CNT + 1
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE NANSIM (IRET)
C-----------------------------------------------------------------------
C   NANSIM reads an image and reports on the NaNs present (magic blanks
C   are expected and are not reported).
C   Outputs:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'NANS.INC'
      INTEGER   IX, IY, I3, I4, I5, I6, I7, I1L, I2L, I3L, I4L, I5L,
     *   I6L, I7L, I1U, I2U, I3U, I4U, I5U, I6U, I7U, LUN, IND, BIND,
     *   WIN(4), NXI, NYI, DEPTH(5), BO, ICOUNT, NNAN, NX, NP, I, IP1,
     *   IP2, LIST(700), TCOUNT, XCOUNT, JCOUNT, YCOUNT
      CHARACTER PHNAME*48
      LOGICAL   T, F, FIRST, DOBLK, WASBLK
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (DEPTH(1), I3)
      EQUIVALENCE (DEPTH(2), I4)
      EQUIVALENCE (DEPTH(3), I5)
      EQUIVALENCE (DEPTH(4), I6)
      EQUIVALENCE (DEPTH(5), I7)
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      DOBLK = CATR(KRBLK).NE.FBLANK
C                                       set limits
      I1L = BLC(1) + 0.1
      I2L = BLC(2) + 0.1
      I3L = BLC(3) + 0.1
      I4L = BLC(5) + 0.1
      I5L = BLC(5) + 0.1
      I6L = BLC(6) + 0.1
      I7L = BLC(7) + 0.1
      I1U = TRC(1) + 0.1
      I2U = TRC(2) + 0.1
      I3U = TRC(3) + 0.1
      I4U = TRC(5) + 0.1
      I5U = TRC(5) + 0.1
      I6U = TRC(6) + 0.1
      I7U = TRC(7) + 0.1
      FIRST = .TRUE.
C                                       open image
      CALL ZPHFIL ('MA', DISKIN, CNOIN, 1, PHNAME, IRET)
      LUN = 16
      CALL ZOPEN (LUN, IND, DISKIN, PHNAME, T, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING IMAGE FILE'
         GO TO 990
         END IF
C                                       init IO
      WIN(1) = I1L
      WIN(2) = I2L
      WIN(3) = I1U
      WIN(4) = I2U
      NXI = CATBLK(KINAX)
      NYI = CATBLK(KINAX+1)
      NX = I1U - I1L + 1
      ICOUNT = 0
      JCOUNT = 0
      YCOUNT = 0
      XCOUNT = 0
      MSGTXT = ' Row Plane         Information'
      DO 70 I7 = I7L,I7U
         DO 60 I6 = I6L,I6U
            DO 50 I5 = I5L,I5U
               DO 40 I4 = I4L,I4U
                  DO 30 I3 = I3L,I3U
                     CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), DEPTH,
     *                  BO, IRET)
                     BO = BO + 1
                     CALL MINIT ('READ', LUN, IND, NXI, NYI, WIN, BUFF1,
     *                  JBUFSZ, BO, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'INIT IMAGE I/O'
                        GO TO 990
                        END IF
                     TCOUNT = 0
                     DO 20 IY = I2L,I2U
                        CALL MDISK ('READ', LUN, IND, BUFF1, BIND, IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET, 'READ IMAGE ROW'
                           GO TO 990
                           END IF
                        CALL CNTNAN (NX, IBUFF1(BIND), NNAN)
                        XCOUNT = XCOUNT + NNAN
C                                       summarize plane
                        TCOUNT = TCOUNT + NNAN
                        IF (ICOUNT.LT.2*NCOUNT) THEN
C                                       full row?
                           IF (NNAN.GE.NX) THEN
                              IF (FIRST) CALL MSGWRT (5)
                              FIRST = .FALSE.
                              WRITE (MSGTXT,1100) IY, DEPTH
                              CALL MSGWRT (5)
                              ICOUNT = ICOUNT + 1
C                                       summarize row
                           ELSE IF ((NNAN.GT.0) .AND.
     *                        (ICOUNT.GE.NCOUNT)) THEN
                              IF (FIRST) CALL MSGWRT (5)
                              FIRST = .FALSE.
                              WRITE (MSGTXT,1101) IY, DEPTH, NNAN
                              CALL MSGWRT (5)
                              ICOUNT = ICOUNT + 1
C                                       report details
                           ELSE IF (NNAN.GT.0) THEN
                              NP = 0
                              DO 10 IX = 1,NX
                                 CALL CNTNAN (1, IBUFF1(BIND+IX-1), I)
                                 IF ((I.GT.0) .AND. (NP.LT.700)) THEN
                                    NP = NP + 1
                                    LIST(NP) = I1L + IX - 1
                                    END IF
 10                              CONTINUE
                              IP1 = 1
                              IF (FIRST) CALL MSGWRT (5)
                              FIRST = .FALSE.
 11                           IF (IP1.LE.NP) THEN
                                 IP2 = MIN (IP1+6, NP)
                                 WRITE (MSGTXT,1102) IY, DEPTH,
     *                              (LIST(I), I = IP1,IP2)
                                 IF (IP1.NE.1) MSGTXT(1:17) = ' '
                                 CALL MSGWRT (5)
                                 ICOUNT = ICOUNT + 1
                                 IP1 = IP2 + 1
                                 GO TO 11
                                 END IF
                              END IF
                           END IF
                        IF (DOBLK) THEN
                           WASBLK = .FALSE.
                           DO 15 IX = 1,NX
                              IF (BUFF1(BIND+IX-1).EQ.FBLANK) THEN
                                 YCOUNT = YCOUNT + 1
                                 IF (JCOUNT.LT.NCOUNT) THEN
                                    WRITE (MSGTXT,1015) IX+I1L-1, IY,
     *                                 DEPTH
                                    CALL MSGWRT (5)
                                    JCOUNT = JCOUNT + 1
                                 ELSE
                                    WASBLK = .TRUE.
                                    END IF
                                 END IF
 15                           CONTINUE
                           IF (WASBLK) THEN
                              WRITE (MSGTXT,1016) IY, DEPTH
                              CALL MSGWRT (5)
                              END IF
                           END IF
 20                     CONTINUE
C                                       plane summary if needed
                     IF (TCOUNT.GT.0) THEN
                        IF (FIRST) CALL MSGWRT (5)
                        FIRST = .FALSE.
                        WRITE (MSGTXT,1120) DEPTH, TCOUNT
                        CALL MSGWRT (5)
                        ICOUNT = ICOUNT + 1
                        END IF
 30                  CONTINUE
 40               CONTINUE
 50            CONTINUE
 60         CONTINUE
 70      CONTINUE
      CALL ZCLOSE (LUN, IND, I)
      WRITE (MSGTXT,1170) XCOUNT, ICOUNT
      CALL MSGWRT (5)
      WRITE (MSGTXT,1171) YCOUNT, JCOUNT
      IF (DOBLK) CALL MSGWRT (5)
      GO TO 999
C
 990  CALL MSGWRT (8)
c
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('NANSIM: ERROR',I4,' ON ',A)
 1100 FORMAT (I5,I4,4I2,'  Full row')
 1101 FORMAT (I5,I4,4I2,'  Number NaNs=',I5)
 1102 FORMAT (I5,I4,4I2,'  IX=',7I6)
 1015 FORMAT ('Magic blank at',2I6,4I2)
 1016 FORMAT ('Magic blank(s) in row',I6,4I2)
 1120 FORMAT (5X,I4,4I2,'  Number NaNs in plane=',I8)
 1170 FORMAT ('Found',I9,' NaNs reported in',I4,' message lines')
 1171 FORMAT ('Found',I9,' unexpected blanks reported in',I4,' lines')
      END

      SUBROUTINE YGRAPH (OP, CHAN, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! turns TV graphics planes on and off
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YGRAPH is used to turn graphics overlay planes on & off by
C   altering the graphics color look up table.  The color pattern is:
C      CHAN = 1    insert   yellow            drawing plots
C             2    insert   green+.05 red     axis labels
C             3    insert   blue + 0.6 green  blotch
C                           + red
C             4    insert   black             label backgrounds
C             5-7  add      nothing           null channels
C             8    insert   purple            cursor
C   by default.  It may be altered by YGRAFX.
C   Inputs:
C      OP      C*4       'ONNN' or 'OFFF'
C                        'INIT' sets default colors in common
C      CHAN    I         channel number (1 - 8)
C   Output:
C      SCRTCH  I(256)    scratch buffer
C      IERR    I         error code of Z...XF: 0 => ok
C                                              2 => input error
C   IVAS version: uses and sets YBUFF(13-16).  Colors in YBUFF(18-22).
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   CHAN, SCRTCH(256), IERR
C
      LOGICAL   VRTRTC
      INTEGER   I, LCOLOR, II, DCOLOR(5), J, IC, ZAND, ZEOR, JJ, IV,
     *   MODE, MASK, JERR
      INTEGER   FIVASGMDEFGRAPHIC, FIVASGMFREEZE, FIVASCSCOLOR
      INCLUDE 'INCS:DTVC.INC'
      DATA VRTRTC /.FALSE./
C     DATA DCOLOR /Z00FF, Z00F1, Z0FAF, Z0000, Z0F0F/
      DATA DCOLOR /  255,   241,  4015,     0,  3855/
C-----------------------------------------------------------------------
C                                       Initialization only
      IF (OP.EQ.'INIT') THEN
         IERR = 0
         CALL COPY (5, DCOLOR, YBUFF(18))
         GO TO 999
         END IF
C                                        check input
      IERR = 2
      IF ((CHAN.LT.1) .OR. (CHAN.GT.8)) GO TO 999
      IF ((CHAN.GE.5) .AND. (CHAN.LE.7)) GO TO 999
      IF ((OP.NE.'ONNN') .AND. (OP.NE.'OFFF')) GO TO 999
      IF (YBUFF(22).EQ.0) CALL COPY (5, DCOLOR, YBUFF(18))
C                                       restrict off
 20   CALL YVRTR (VRTRTC, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (CHAN.EQ.8) GO TO 50
C                                       leave display fixed
      MASK = 1
      JERR = FIVASGMFREEZE (MASK)
      IF (JERR.NE.0) GO TO 900
      IF (OP.EQ.'ONNN') THEN
         YBUFF(12+CHAN) = 1
      ELSE
         YBUFF(12+CHAN) = 0
         END IF
C                                       do selections
      MASK = 0
      DO 30 I = 1,16
         LCOLOR = 0
         II = I - 1
         IC = 0
         DO 25 J = 1,4
            JJ = 2 ** (J-1)
            IF ((YBUFF(12+J).LE.0) .OR. (ZAND(II,JJ).EQ.0)) GO TO 25
               IC = IC + 1
               LCOLOR = ZEOR (LCOLOR, YBUFF(17+J))
 25         CONTINUE
         IV = II
         MODE = 1
         IF (IC.LE.0) MODE = -1
         JERR = FIVASGMDEFGRAPHIC (IV, MODE, LCOLOR, MASK)
         IF (JERR.NE.0) GO TO 800
 30      CONTINUE
C                                       Unfreeze display
      MASK = 0
      JERR = FIVASGMFREEZE (MASK)
      IF (JERR.NE.0) GO TO 900
      GO TO 999
C                                       Cursor color
 50   IF (OP.EQ.'ONNN') THEN
         LCOLOR = YBUFF(22)
      ELSE
         LCOLOR = 0
         END IF
      JERR = FIVASCSCOLOR (LCOLOR)
      IF (JERR.EQ.0) GO TO 999
C                                       Errors
 800  CALL YDOERR ('YGRAPH', JERR, IERR)
      MASK = 0
      JERR = FIVASGMFREEZE (MASK)
      IF (JERR.EQ.0) GO TO 999
C
 900  CALL YDOERR ('YGRAPH', JERR, IERR)
C
 999  RETURN
      END

      SUBROUTINE YGRAFX (OP, GRFX, RED, GREEN, BLUE, IERR)
C-----------------------------------------------------------------------
C! read/write TV graphics colors
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   YGRAFX modifies the colour of the graphics or cursor.
C   Inputs:
C      OP       C*4   READ or WRITE graphics colour assignment.
C      GRFX     I     Cursor (0), or graphics plane number.
C   In/Out:
C      RED      R     Red,   0.0 - 1.0
C      GREEN    R     Green, 0.0 - 1.0
C      BLUE     R     Blue,  0.0 - 1.0
C   Output:
C      IERR     I     Error status, 0 means success.
C   Version for Screen Servers.
C   Author: Mark Calabretta, Australia Telescope.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   GRFX, IERR
      REAL      BLUE, GREEN, RED
C
      INTEGER   DAT(4), NWSD, NWVD, OPCODE, BUFFER(3)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
C                                       Check inputs.
      IF ((GRFX.LT.0) .OR. (GRFX.GT.NGRAPH)) THEN
         WRITE (MSGTXT,1000) GRFX
         IERR = 2
C                                       Send instructions to the SS
      ELSE IF (OP.EQ.'WRIT') THEN
         OPCODE = 51
         DAT(1) = GRFX
         DAT(2) = RED * 255.0 + 0.5
         DAT(3) = GREEN * 255.0 + 0.5
         DAT(4) = BLUE * 255.0 + 0.5
         NWVD = 0
         CALL ZSSSXF (OPCODE, DAT, NWVD, BUFFER, NWSD, IERR)
         IF (IERR.NE.0) WRITE (MSGTXT,1020) IERR
C                                       RGRFX opcode.
      ELSE IF (OP.EQ.'READ') THEN
         OPCODE = 52
         DAT(1) = GRFX
         NWVD = 0
         CALL ZSSSXF (OPCODE, DAT, NWVD, BUFFER, NWSD, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR
         ELSE IF (NWSD.NE.3) THEN
            WRITE (MSGTXT,1031) NWSD
            IERR = 1
         ELSE
            CALL ZI8IL (3, 1, BUFFER, BUFFER)
            RED   = BUFFER(1) / 255.0
            GREEN = BUFFER(2) / 255.0
            BLUE  = BUFFER(3) / 255.0
            END IF
C                                       Unrecognized OP.
      ELSE
         MSGTXT = 'YGRAFX: Unrecognized OP code - ' // OP
         IERR = 2
         END IF
C
 990  IF (IERR.NE.0) CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('YGRAFX: INVALID GRAPHICS PLANE NUMBER',I4)
 1020 FORMAT ('YGRAFX: UNSUCCESSFUL WRITE TO SSS, ERROR',I3,'.')
 1030 FORMAT ('YGRAFX: ERROR',I4,' RETURNED ON READ WITH ZSSSXF')
 1031 FORMAT ('YGRAFX: UNSUCCESSFUL READ,',I4,' WORDS RECEIVED.')
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER   NPARMS
      PARAMETER (NPARMS=25)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'VNPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                                       Uses PAOOF.INC
      DATA AVNAME /'INNAME  ', 'INCLASS ', 'INSEQ   ', 'INDISK  ',
C                                       2
     *             'OUTNAME ', 'OUTCLASS', 'OUTSEQ  ', 'OUTDISK ',
C                                       6
     *             'SOURCES ', 'QUAL    ', 'CALCODE ', 'TIMERANG',
C                                       10
     *             'UVRANGE ', 'STOKES  ', 'BCHAN   ', 'ECHAN   ',
C                                       14
     *             'BIF     ', 'EIF     ',
C                                       18
     *                         'FREQID  ', 'SELBAND ', 'SELFREQ ',
C                                       19
     *             'ANTENNAS', 'SUBARRAY', 'FLAGVER ', 'UVCOPPRM'/
C                                       23
      DATA AVTYPE / OOACAR   ,  OOACAR   ,  OOAINT   ,  OOAINT   ,
C                                       2
     *              OOACAR   ,  OOACAR   ,  OOAINT   ,  OOAINT   ,
C                                       6
     *              OOACAR   ,  OOAINT   ,  OOACAR   ,  OOARE    ,
C                                       10
     *              OOARE    ,  OOACAR   ,  OOAINT   ,  OOAINT   ,
C                                       12
     *              OOAINT   ,  OOAINT   ,
C                                       16
     *                          OOAINT   ,  OOARE    ,  OOARE    ,
C                                       17
     *              OOAINT   ,  OOAINT   ,  OOAINT   ,  OOARE    /
C                                       21
      DATA AVDIM  / 12,1     ,  6,1      ,  1,1      ,  1,1      ,
C                                       2
     *              12,1     ,  6,1      ,  1,1      ,  1,1      ,
C                                       6
     *              16,30    ,  1,1      ,  4,1      ,  8,1      ,
C                                       10
     *              2,1      ,  4,1      ,  1,1      ,  1,1      ,
C                                       12
     *              1,1      ,  1,1      ,
C                                       16
     *                          1,1      ,  1,1      ,  1,1      ,
C                                       17
     *              50,1     ,  1,1      ,  1,1      ,  10,1     /
C                                       21
LOCAL END
      PROGRAM VCOPY
C-----------------------------------------------------------------------
C! Copy visibilities from one data set to another
C# UV-UTIL SPECTRAL CALIBRATION OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1997-1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   All available selection criteria are available to select data from
C   one data set to copy over to another data set.  This task is meant
C   to be more fully featured than UVCOP, but otherwise identical in
C   function.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, POPS*36, UVIN*36, UVOUT*36
      INTEGER  IRET
C
      PARAMETER (PRGM = 'VCOPY ')
      PARAMETER (POPS = 'Input ADVob')
      PARAMETER (UVIN = 'Input UVob')
      PARAMETER (UVOUT = 'Output UVob')
C
      INTEGER BUFF(256)
C                                       Are these includes NECESSARY?
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Get AIPS Adverb values
      CALL GETADV (PRGM, POPS, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Copy UVIN to UVOUT
C                                         under POPS control
      CALL GUVIN (POPS, UVIN, UVOUT, IRET)
      IF (IRET.NE.0) GO TO 990
      GO TO 999
C                                       Error handling stuff
 990  WRITE (MSGTXT,1990) IRET
      CALL MSGWRT(6)
C
 999  CALL DIE (IRET, BUFF)
      STOP
C-----------------------------------------------------------------------
 1990 FORMAT ('VCOPY: error ',I5)
      END
      SUBROUTINE GETADV (PRGM, POPS, IRET)
C-----------------------------------------------------------------------
C   GETADV gets adverb values from AIPS and fills them into POPSob
C   Inputs:
C      PRGM    C*?  program name
C   Output:
C      POPS    C*?  memory object describing AIPS adverb values
C      IRET    I    error code: 0 => ok
C-----------------------------------------------------------------------
C                                       I/O parameters
      INTEGER   IRET
      CHARACTER PRGM*(*), POPS*(*)
C                                       Std. OOP declarations
      INTEGER   DIM(7), TYPE, IDUM
      CHARACTER CDUM*1
      REAL      RDUM, UPARM(10)
      LOGICAL   LDUM, DOACOR, DOXCOR
C                                       Enumerate number of adverbs
      INCLUDE 'INPUT.INC'
C                                       Enumerate available data types
      INCLUDE 'INCS:PAOOF.INC'
C                                       AIPS errorlog facilities
      INCLUDE 'INCS:DMSG.INC'
C                                       AIPS baddisk mechanism
      INCLUDE 'INCS:DFIL.INC'
C                                       List adverb names
      INCLUDE 'VNPUTDATA.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Create/Fill adverbs into POPSob
      CALL AV2INP (PRGM, NPARMS, AVNAME, AVTYPE, AVDIM, POPS, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Save Integer keyword type
      TYPE = OOAINT
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (POPS, 'INTEGER', TYPE, DIM, IDUM, CDUM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Save Logical keyword type
      TYPE = OOALOG
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (POPS, 'LOGICAL', TYPE, DIM, LDUM, CDUM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Save Real keyword type
      TYPE = OOARE
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (POPS, 'REAL', TYPE, DIM, RDUM, CDUM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       get XCOR and ACOR from UVCOPPRM
      CALL OGET (POPS, 'UVCOPPRM', TYPE, DIM, UPARM, CDUM, IRET)
      DOACOR = (UPARM(3).EQ.0) .OR. (UPARM(3).EQ.1)
      DOXCOR = (UPARM(3).EQ.0) .OR. (UPARM(3).EQ.2)
      CALL OGET (POPS, 'LOGICAL', TYPE, DIM, LDUM, CDUM, IRET)
      CALL OPUT (POPS, 'KEEPACOR', TYPE, DIM, DOACOR, CDUM, IRET)
      CALL OPUT (POPS, 'KEEPXCOR', TYPE, DIM, DOXCOR, CDUM, IRET)
C                                       Done
      GO TO 999
C                                       Error handling stuff
 990  CONTINUE
      WRITE (MSGTXT,1990) IRET
      CALL MSGWRT(6)
 999  RETURN
 1990 FORMAT ('GETADV: error ',I5)
      END
      SUBROUTINE GUVIN (POPS, UVIN, UVOUT, IRET)
C-----------------------------------------------------------------------
C   Create UVINob and fill using POPSob, check underlying data-set
C   properties
C   Inputs:
C      POPS    C*?  memory object describing AIPS adverbs
C   Output:
C      UVIN    C*?  memory object describing input UV data set
C      IRET    I    Error code: 0 => ok
C-----------------------------------------------------------------------
C                                       I/O parameters
      INTEGER   IRET
      CHARACTER POPS*(*), UVIN*(*), UVOUT*(*)
C                                       OOP keyword transfer variables
      INTEGER   NKEY0
      PARAMETER (NKEY0=3)
      CHARACTER IKEY0(NKEY0)*8, OKEY0(NKEY0)*16
C
      INTEGER   NKEY1
      PARAMETER (NKEY1=4)
      CHARACTER IKEY1(NKEY1)*8, OKEY1(NKEY1)*16
C
      INTEGER   NKEY2
      PARAMETER (NKEY2=18)
      CHARACTER IKEY2(NKEY2)*8, OKEY2(NKEY2)*16
C
      INTEGER   NKEY3
      PARAMETER (NKEY3=4)
      CHARACTER IKEY3(NKEY3)*8, OKEY3(NKEY3)*16
C                                       OOP declarations
      INTEGER   NADV
      PARAMETER (NADV=4)
      CHARACTER LIST(NADV)*8
C
C                                       Std OOP declarations
      INTEGER   TYPE, DIM(7), IDUM
      CHARACTER CDUM*1
C                                       Internal variables
      LOGICAL T, F, ISCOMP
      INTEGER ABSEL, BSELET(50), ASELET(50), GCOUNT, SUBA, NSUB
      CHARACTER DRPTBS(20)*2
      CHARACTER ANTAB*36
C                                       For I/O to user
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
C                                       for table transfer
      DATA DRPTBS /'AN', 'NX', 'FQ', 'HI', 'SU', 15*'  '/
C                                       Xfer keyword types
      DATA IKEY0 /'INTEGER ', 'LOGICAL ', 'REAL'/
      DATA OKEY0 /'INTEGER ', 'LOGICAL ', 'REAL'/
C                                       File specification info
      DATA IKEY1 /'INNAME  ', 'INCLASS ', 'INSEQ   ', 'INDISK  '/
      DATA OKEY1 /'FILE_NAME.NAME  ', 'FILE_NAME.CLASS ',
     *            'FILE_NAME.IMSEQ ', 'FILE_NAME.DISK  '/
C                                       Cal/Selection info
      DATA IKEY2 /'SOURCES ', 'QUAL    ', 'CALCODE ', 'TIMERANG',
     *            'UVRANGE ', 'STOKES  ', 'BCHAN   ', 'ECHAN   ',
     *            'BIF     ', 'EIF     ', 'KEEPACOR', 'KEEPXCOR',
     *                        'FREQID  ', 'SELBAND ', 'SELFREQ ',
     *            'ANTENNAS', 'SUBARRAY', 'FLAGVER '/
      DATA OKEY2 /'CALEDIT.SOURCS  ', 'CALEDIT.SELQUA  ',
     *            'CALEDIT.SELCOD  ', 'CALEDIT.TIMRNG  ',
     *            'CALEDIT.UVRNG   ', 'CALEDIT.STOKES  ',
     *            'CALEDIT.BCHAN   ', 'CALEDIT.ECHAN   ',
     *            'CALEDIT.BIF     ', 'CALEDIT.EIF     ',
     *            'CALEDIT.DOACOR  ', 'CALEDIT.DOXCOR  ',
     *                                'CALEDIT.FRQSEL  ',
     *            'CALEDIT.SELBAN  ', 'CALEDIT.SELFRQ  ',
     *            'CALEDIT.ANTENNS ', 'CALEDIT.SUBARR  ',
     *            'CALEDIT.FGVER   '/
C                                       Output file specification info
      DATA IKEY3 /'OUTNAME ', 'OUTCLASS', 'OUTSEQ  ', 'OUTDISK '/
      DATA OKEY3 /'OUTNAME ', 'OUTCLASS', 'OUTSEQ  ', 'OUTDISK '/
      DATA T, F /.TRUE.,.FALSE./
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'INDISK'/
      DATA ANTAB /'temp AN table'/
C-----------------------------------------------------------------------
      IRET = 0
C                                       Create UVINob
      CALL CREATE (UVIN, 'UVDATA', IRET)
      IF (IRET.NE.0) GO TO 990
C                                       copy over fundamental data types
      CALL IN2OBJ (POPS, NKEY0, IKEY0, OKEY0, UVIN, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Specify UVINob
      CALL IN2OBJ (POPS, NKEY1, IKEY1, OKEY1, UVIN, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Select/Calibrate UVINob
      CALL IN2OBJ (POPS, NKEY2, IKEY2, OKEY2, UVIN, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Prep for UVOUTob
      CALL IN2OBJ (POPS, NKEY3, IKEY3, OKEY3, UVIN, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       get UVINob info
      CALL OUVATT (UVIN, F, IRET)
C                                       specifically, get compression stae
      CALL OGET (UVIN, 'UV_DESC.ISCOMP', TYPE, DIM, ISCOMP, CDUM, IRET)
C                                       set state request for UVOUTob
      CALL OPUT (UVIN, 'DOUVCOMP', TYPE, DIM, ISCOMP, CDUM, IRET)
C                                       get subarray number
      CALL OGET (UVIN, 'CALEDIT.SUBARR  ',TYPE, DIM, SUBA, CDUM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       copy all subarrays
      IF (SUBA.EQ.0) THEN
C                                       get max subarray number
         CALL UV2TAB (UVIN, ANTAB, 'AN', 1, IRET)
         IF (IRET.NE.0) GO TO 990
         CALL TBLHIV (ANTAB, NSUB, IRET)
         IF (IRET.NE.0) GO TO 990
         DO 100 SUBA = 1, NSUB
C                                       select subarray
            CALL OPUT (UVIN, 'CALEDIT.SUBARR  ',TYPE, DIM, SUBA,
     *         CDUM,IRET)
            IF (IRET.NE.0) GO TO 990
C                                       copy this subarray
            CALL UVCOPY (UVIN, UVOUT, IRET)
            IF (IRET.NE.0) GO TO 990
C                                       synchronize the file sizes
            CALL OOPEN (UVOUT, 'READ', IRET)
            IF (IRET.NE.0) GO TO 990
            CALL OCLOSE (UVOUT, IRET)
            IF (IRET.NE.0) GO TO 990
C                                       get current output data set size
            CALL OGET (UVOUT, 'UV_DESC.GCOUNT',TYPE, DIM, GCOUNT,
     *         CDUM,IRET)
            IF (IRET.NE.0) GO TO 990
C                                       put back in as offset size
            CALL OPUT (UVOUT, 'UV_DESC.VISOFF',TYPE, DIM, GCOUNT,
     *         CDUM,IRET)
            IF (IRET.NE.0) GO TO 990
 100        CONTINUE
      ELSE
C                                       copy over the requested subarray
         CALL UVCOPY (UVIN, UVOUT, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
C                                       Open UVOUTob
      CALL OOPEN (UVOUT, 'READ', IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Close UVOUTob
      CALL OCLOSE (UVOUT, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       get current output data set size
      CALL OGET (UVOUT, 'UV_DESC.GCOUNT',TYPE, DIM, GCOUNT, CDUM, IRET)
      IF (IRET.NE.0) GO TO 990
      IF (GCOUNT.EQ.0) THEN
         IRET = 1
         GO TO 990
         END IF
C                                       Copy FQ tables with selection
      CALL UVFCOP (UVIN, UVOUT, IRET)
      IF (IRET.NE.0) GO TO 990
C                                        Copy old history
      CALL OHCOPY (UVIN, UVOUT, IRET)
      IF (IRET.NE.0) GO TO 990
C                                        New additions - copy adverb
C                                        values.
      CALL OHLIST (POPS, LIST, NADV, UVOUT, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       prepare to copy tables
      TYPE = OOACAR
      DIM(1) = 2
      DIM(2) = 20
      CALL OPUT (UVIN, 'DROPTABS', TYPE, DIM, IDUM, DRPTBS, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Copy all tables except those
C                                       listed in DROPTABS
      CALL UVCALT (UVIN, UVOUT, IRET)
      IF (IRET.NE.0) GO TO 990
C
C                                       Done
      GO TO 999
C                                       Error handling stuff
 990  CONTINUE
      WRITE (MSGTXT,1990) IRET
      CALL MSGWRT(6)
 999  RETURN
 1990 FORMAT ('GUVOUT: error ',I5)
      END

LOCAL INCLUDE 'WTMOD.INC'
C                                       Local include for WTMOD
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER  SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS, JBUFSZ, ILOCWT
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, HISCRD(10)*64
      REAL      XSIN, XDISIN, XSOUT, XDISO, XSUBA, APARM(10), ANTWT(30),
     *   ANTSCL(64), XCENT, ANTSSS(MAXANT), ANTWTS(MAXANT),
     *   BUFF1(UVBFSS), BUFF2(UVBFSS), DIFPIX
      DOUBLE PRECISION UVSCAL
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XCLAOU,
     *   XSOUT, XDISO, XSUBA, APARM, ANTWT, ANTSCL, XCENT
      COMMON /WTMODP/ UVSCAL, SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS,
     *   ILOCWT, ANTWTS, ANTSSS, DIFPIX
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, HISCRD
      INCLUDE 'INCS:DCAT.INC'
LOCAL END
      PROGRAM WTMOD
C-----------------------------------------------------------------------
C! Modify weights of a uv data file
C# UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000-2001, 2004, 2006, 2008, 2014-2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This task will modify the weights of uv data as specified by the
C   user.  The purpose is to adjust the weights so that data from very
C   sensitive baselines will not swamp the less sensitive baselines.
C   The maximum and minimum positive weights found will be told.  The
C   output file may be the input file.
C  Adverbs:
C   INNAME.....Input UV file name (name).      Standard defaults.
C   INCLASS....Input UV file name (class).     Standard defaults.
C   INSEQ......Input UV file name (seq. #).    0 => highest.
C   INDISK.....Disk drive # of input UV file.  0 => any.
C   OUTNAME....Output UV file name (name).     Standard defaults.
C   OUTCLASS...Output UV file name (class).    Standard defaults.
C   OUTSEQ.....Output UV file name (seq. #).   0 => highest unique
C   OUTDISK....Disk drive # of output UV file. 0 => highest with
C              space for the file.
C   APARM......Weight modification control information:
C              1 = A multiplier for the weights. 0 => 1.0
C              2 = A power to which to raise the weights;
C                  0.25 - 0.5 is a useful range for VLBI.
C                  0 = > 1.0
C              3 = The maximum acceptable value of the weight.
C                  Values higher that APARM(3) will be set to
C                  APARM(3).  0 => infinity.
C   ANTWT......Constant antenna weights that replace existing weights.
C   NOISE......Antenna weight scaling
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'WTMOD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'WTMOD '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL WTMDIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL WTMDUV (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL WTMDHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE WTMDIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   WTMDIN gets input parameters for WTMOD and creates an output file
C   if necessary.
C   Inputs:
C      PRGN   C*6   Program name
C   Output:
C      JERR   I     Error code: 0 => ok
C                      5 => catalog troubles
C                      8 => can't start
C   Commons:
C      /INPARM/ all input adverbs in order given by INPUTS file
C      /MAPHDR/ output file catalog header
C   See prologue comments in WTMOD for more details.
C-----------------------------------------------------------------------
      CHARACTER  STAT*4, PRGN*6, BLANK*6, UTYPE*2
      INTEGER   JERR, OLDCNO, IROUND, NPARM, IERR, INCX
      LOGICAL   T
      INCLUDE 'WTMOD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK /'      '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 120
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Find weight and scale.
      IF (CATBLK(KINAX).EQ.1) THEN
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
      ELSE
         ILOCWT = -1
         END IF
C                                       center frequencies
      IF (JLOCF.LT.0) XCENT = -1.
      IF (XCENT.GT.0.0) THEN
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = (INCX-CATR(KRCRP+JLOCF))
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
         UVSCAL = CATD(KDCRV+JLOCF) / FREQ
      ELSE
         DIFPIX = 0.0
         UVSCAL = 1.0D0
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT(1:12), KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT(1:6), KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((CCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                        Put input file in READ
      UTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
      CALL UVPGET (IERR)
C                                       copy header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('WTMDIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('WTMDIN: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE WTMDUV (IRET)
C-----------------------------------------------------------------------
C   WTMDUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER OFILE*48, IFILE*48
      INTEGER   IRET, INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, INCX,
     *   BO, VO, NUMVIS, XCOUNT, LRECO, ILENBU, KBIND, NIOUT, NIOLIM,
     *   IBIND, I, IA1, IA2, LSUBA, ISUBA
      LOGICAL   T, F
      INCLUDE 'WTMOD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNI, LUNO /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      ISUBA = XSUBA + 0.5
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.LE.0) GO TO 10
         WRITE (MSGTXT,1000) IRET
         GO TO 990
C                                       Open vis file for write
 10   CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.LE.0) GO TO 20
         WRITE (MSGTXT,1010) IRET
         GO TO 990
C                                       Init vis file for write
C                                       LRECO = length of output rec.
 20   LRECO = LREC
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) IRET
         GO TO 990
 30   IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
      LSUBA = 0
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
         IF (INIO.LE.0) GO TO 200
         DO 190 I = 1,INIO
            NUMVIS = NUMVIS + 1
            BUFF1(IPTRI+ILOCU) = BUFF1(IPTRI+ILOCU) * UVSCAL
            BUFF1(IPTRI+ILOCV) = BUFF1(IPTRI+ILOCV) * UVSCAL
            BUFF1(IPTRI+ILOCW) = BUFF1(IPTRI+ILOCW) * UVSCAL
            IF (ILOCB.GE.0) THEN
               IA1 = BUFF1(IPTRI+ILOCB) / 256. + 0.1
               IA2 = BUFF1(IPTRI+ILOCB) - IA1*256. + 0.1
               IF (ISUBA.GT.0) LSUBA = 1.5 + 100.0 * (BUFF1(IPTRI+ILOCB)
     *            - IA1*256 - IA2)
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               IF (ISUBA.GT.0) ISUBA = BUFF1(IPTRI+ILOCSA) + 0.1
               END IF
C                                      Call user routine.
            IF (LSUBA.EQ.ISUBA) CALL WTMDFN (NUMVIS, IA1, IA2,
     *         BUFF1(IPTRI+NRPARM), BUFF1(IPTRI), INCX, IRET)
C                                       Error (fatal)
            IF (IRET .GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
C                                       Copy to output.
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1.0D0
               CALL RCOPY (LREC, BUFF1(IPTRI), BUFF2(IPTRO))
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               END IF
C                                       advance input pointer
            IPTRI = IPTRI + LREC
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
         GO TO 100
C                                       Final call to WTMDFN.
 200  NUMVIS = -1
      CALL WTMDFN (NUMVIS, IA1, IA2, BUFF1, BUFF1, INCX, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('WTMDUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1010 FORMAT ('WTMDUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('WTMDUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('WTMDUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('WTMDUV: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('WTMDUV: WTMDFN ERROR',I3)
 1150 FORMAT ('WTMDUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE WTMDHI
C-----------------------------------------------------------------------
C   WTMDHI copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP(1)*2, HILINE*72, LABEL*8
      INTEGER   LUN1, LUN2, IERR, I, J, NONOT, JJ
      LOGICAL   T, F, ANTWRT
      INCLUDE 'WTMOD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T, F /.TRUE.,.FALSE./
      DATA NONOT, NOTTYP /0,'  '/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.LE.2) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
C                                       New history
 10   CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       APARM  inputs
      WRITE (HILINE,2000) TSKNAM, APARM(1)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,2001) TSKNAM, APARM(2)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,2002) TSKNAM, APARM(3)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Write ANTWT values into history.
      DO 100 I = 1,26,5
         ANTWRT = F
         JJ = I + 4
         DO 105 J = I,JJ
            IF (ANTWT(J).NE.0.0) ANTWRT = T
 105        CONTINUE
         IF (ANTWRT) THEN
            WRITE (HILINE,2010) TSKNAM,I,(ANTWT(J),J=I,I+4)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
            END IF
 100     CONTINUE
C                                      Add any user supplied history.
      IF (NUMHIS.LE.0) GO TO 200
         WRITE (LABEL,1010) TSKNAM
         DO 15 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
 15         CONTINUE
C                                       Close HI file
 200   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO,
     *   FCNO(2), FCNO(1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1200)
         CALL MSGWRT (6)
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (DISKO, FCNO(1), DIFPIX, BUFF1, BUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'WTMDHI: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST', BUFF1,
     *   IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('WTMDHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,' /')
 1200 FORMAT ('WTMDHI: ERROR COPYING TABLES')
 2000 FORMAT (A6,' APARM(1) = ',1PE12.5,' / Multiplier ')
 2001 FORMAT (A6,' APARM(2) = ',F10.5,' / Power ')
 2002 FORMAT (A6,' APARM(3) = ',1PE12.5,' / Max. weight')
 2010 FORMAT (A6,' ANTWT(',I2,') = ',5F10.2)
      END
      SUBROUTINE WTMDFN (NUMVIS, IA1, IA2, VIS, RPARM, INCX, IRET)
C-----------------------------------------------------------------------
C   This routine modifies the weights.
C   Inputs:
C      NUMVIS     I    Visibility number, -1 => final call, no data
C                      passed but allows any operations to be completed.
C      IA1        I    First antenna number
C      IA2        I    Second antenna number
C      RPARM(*)   I    Random parameter array which includes U,V,W etc
C                      but also any other random parameters.
C      VIS(INCX,*) R    Visibilities in order real, imaginary, weight
C                      (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                      NOTE: INCX may be any value .GE. 2
C   Inputs from COMMON
C      APARM(10)  R    User array.
C      RA         D    Right ascension (1950) of phase center. (deg)
C      DEC        D    Declination (1950) of phase center. (deg)
C      FREQ       D    Frequency of observation (Hz)
C      NRPARM     I    # random parameters.
C      NCOR       I    # correlators
C      CATBLK(256)I    Catalog header record. See Going Aips for
C                      details.
C
C   Output:
C      RPARM      R    Modified random parameter array.  N.B.  U,V,W,
C                      time, baseline should not be modified in RPARM
C      VIS        R    Visibilities
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C
C   Output in COMMON
C      NUMHIS            I    # history entries (max. 10)
C      HISCRD(NUMHIS)    C*64 History records
C      CATBLK            I    Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IRET, IA1, IA2, INCX
      REAL      VIS(INCX,*), RPARM(*)
      INTEGER   LOOP, NUMCOR, I
      LOGICAL   DOPWR, REWT, FIRST
      REAL      WTMAX, WTMIN, TEMP, WT1, WT2, XSIGN, AVWT
      INCLUDE 'WTMOD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      SAVE REWT, NUMCOR, DOPWR, FIRST, WTMAX, WTMIN
      DATA FIRST /.TRUE./
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.LT.0) GO TO 800
      IF (FIRST) THEN
         FIRST = .FALSE.
C                                       Setup
C                                       Defaults:
         IF (ABS(APARM(1)).LT.1.0E-10) APARM(1) = 1.0
         DOPWR = ABS (APARM(2)).GT.1.0E-10
         IF (.NOT.DOPWR) APARM(2) = 1.0
         IF (APARM(3).LE.1.0E-10) APARM(3) = 1.0E25
C                                       No. correlator values
         NUMCOR = (LREC - NRPARM) / INCX
         IF (NUMCOR.LE.0) NUMCOR = 1
C                                       Init, max., min
         WTMAX = 1.0E-20
         WTMIN = 1.0E20
C
         REWT = .FALSE.
         AVWT = 0.0
         DO 50 I = 1,30
            IF (ANTWT(I).NE.0.0) REWT = .TRUE.
            AVWT = AVWT + ABS (ANTWT(I))
 50         CONTINUE
         AVWT = AVWT / 30
         I = MAXANT - 30
         CALL RCOPY (30, ANTWT, ANTWTS)
         CALL RFILL (I, AVWT, ANTWTS(31))
         CALL RFILL (MAXANT, 1.0, ANTSSS)
         DO 55 I = 1,64
            IF (ANTSCL(I).GT.0.0) ANTSSS(I) = ANTSCL(I)
 55         CONTINUE
         END IF
C
      IF (REWT) THEN
         IF (ANTWTS(IA1).EQ.0.0) THEN
            WRITE (MSGTXT,1100) IA1
            IRET = 1
            GO TO 999
            END IF
         IF (ANTWTS(IA2).EQ.0.0) THEN
            WRITE (MSGTXT,1100) IA2
            IRET = 1
            GO TO 999
            END IF
         WT1 = ANTWTS(IA1)
         WT2 = ANTWTS(IA2)
         XSIGN = 1.0
         IF ((WT1.LT.0.0) .OR. (WT2.LT.0.0)) THEN
            XSIGN = -1.0
            WT1 = ABS(WT1)
            WT2 = ABS(WT2)
            END IF
         IF (ILOCWT.GE.0) THEN
            TEMP = SQRT (WT1*WT2)
            WTMAX = MAX (TEMP, WTMAX)
            WTMIN = MIN (TEMP, WTMIN)
            IF (RPARM(1+ILOCWT).LE.0.0) THEN
               RPARM(1+ILOCWT) = -TEMP
            ELSE
               RPARM(1+ILOCWT) = XSIGN * TEMP
               END IF
         ELSE
            DO 120 LOOP = 1,NUMCOR
               TEMP = SQRT (WT1*WT2)
               WTMAX = MAX (TEMP, WTMAX)
               WTMIN = MIN (TEMP, WTMIN)
               IF (VIS(3,LOOP).LE.0.0) THEN
                  VIS(3,LOOP) = -TEMP
               ELSE
                  VIS(3,LOOP) = XSIGN * TEMP
                  END IF
 120           CONTINUE
            END IF
C                                       Process record
      ELSE
         IF (ILOCWT.GE.0) THEN
            TEMP = ABS (RPARM(1+ILOCWT)) * APARM(1)
            IF (DOPWR) TEMP = TEMP ** APARM(2)
            TEMP = MIN (TEMP, APARM(3))
            TEMP = TEMP * ANTSSS(IA1) * ANTSSS(IA2)
            WTMAX = MAX (TEMP, WTMAX)
            WTMIN = MIN (TEMP, WTMIN)
            IF (RPARM(1+ILOCWT).LE.0.0) THEN
               RPARM(1+ILOCWT) = -TEMP
            ELSE
               RPARM(1+ILOCWT) = TEMP
               END IF
         ELSE
            DO 150 LOOP = 1,NUMCOR
               TEMP = ABS (VIS(3,LOOP)) * APARM(1)
               IF (DOPWR) TEMP = TEMP ** APARM(2)
               TEMP = MIN (TEMP, APARM(3))
               TEMP = TEMP * ANTSSS(IA1) * ANTSSS(IA2)
               WTMAX = MAX (TEMP, WTMAX)
               WTMIN = MIN (TEMP, WTMIN)
               IF (VIS(3,LOOP).LE.0.0) THEN
                  VIS(3,LOOP) = -TEMP
               ELSE
                  VIS(3,LOOP) = TEMP
                  END IF
 150           CONTINUE
            END IF
         END IF
      GO TO 999
C                                       Tell max, min wt.
 800  WRITE (MSGTXT,1800) WTMIN, WTMAX
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ERROR: ANTWT(',I2,') = 0.0')
 1800 FORMAT ('Min. Abs(wt) =',1PE12.5,' Max. wt. =',E12.5)
      END

      SUBROUTINE JPRECS (JD, EQUIN, DELDAT, DIR, GR, OBSPOS, POLAR,
     *   RAMEAN, DECMEA, RAAPP, DECAPP)
C-----------------------------------------------------------------------
C! Precess between apparent and J2000 epoch positions.
C# Math Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2001, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to precess positions using the Julian IAU 1984 conventions,
C   (i.e. J2000 positions).  Optional corrections can be made for
C   relativistic bending of the light by the sun, diurnal aberration and
C   polar motion.  Proper motion and parallax are assumed negligible.
C   Several bugs which prevented exact returning back to the mean
C   coordinates (DIR=1 => DIR=-1) are fixed by L. Kogan August 8, 2001
C   Starting Dec 2004 the routine can work for both J2000 and B1950.
C   If input mean coordinates (DIR=1) are B1950 (EQUIN=1950D0) they are
C   converted to J2000 at the beginning by inserted routine B2J.
C   If EQUIN=1950.D0 and DIR=-1, the apparent coordinates are converted
C   to the J2000 mean coordinates and then converted to B1950 by
C   inserted routine J2B.
C   Inputs:
C     JD       D  Julian date of observation (e.g. 2446754.123445).
C     EQUIN    D  Epoch of mean equinox (e.g. 2000.0)
C     DELDAT   D  Interpolation interval; compute precession etc.
C                 parameters at this interval and do a linear
C                 interpolation (days).
C     DIR      I  1 => convert from mean to apparent;
C                -1 => convert from apparent to mean.
C     GR       L  If true correct apparent position for the general
C                 relativistic bending of light by the sun.
C     OBSPOS(3)D  Earth centered location of the observations.
C                 If non zero then diurnal aberation corrections are
C                 made for this location.
C                 1 = Latitude (radians)
C                 2 = East longitude
C                 3 = radius from earth center (meter).
C     POLAR(2) R  X and Y position of the pole (arcsec.)
C                 If non zero then the apparent position is corrected
C                 for the position of the pole.
C                 Note: this correction is not desirable if the antenna
C                 positions are corrected for polar motion.
C    Input/Output:
C     RAMEAN   D  Right ascension at the mean epoch (radians).
C     DECMEA   D  Declination at mean epoch.
C     RAAPP    D  Apparent Right ascension at JD and OBSPOS.
C     DECAPP   D  Apparent declination.
C-----------------------------------------------------------------------
      DOUBLE PRECISION JD, EQUIN, DELDAT, OBSPOS(3), RAMEAN, DECMEA,
     *   RAAPP, DECAPP
      INCLUDE 'INCS:DMSG.INC'
      DOUBLE PRECISION DR1950, DD1950, BEPOCH, EQUINN
      REAL      POLAR(2)
      INTEGER   DIR
      LOGICAL   GR
      INTEGER   ITEMP, I, J, DIROLD
      LOGICAL   DIURN
      DOUBLE PRECISION JDINT(2), PRNMAT(3,3,2), POSO(3,2), VELO(3,2),
     *   RLST, POS(3), WT1, WT2, TU, GMST, TIME, ROTI(3,3), POSOI(3),
     *   VELOI(3), CONST, V(3), BETA, PDOTV, CONST2, OUT(3), RHOGEO,
     *   GMST0, OBSOLD(3)
C
      DOUBLE PRECISION LENGTH, POSSQR, OUTSQR, VSQR, SD, CD, DRA,
     *   DDEC, AYX, AZX, BYX, BZX
      INCLUDE 'INCS:PSTD.INC'
      SAVE JDINT, PRNMAT, POSO, VELO, OBSOLD, DIROLD
      DATA JDINT, OBSOLD /5*0.0D0/
      DATA DIROLD /100/
C-----------------------------------------------------------------------
C                                       Stmt. fn. to compute GMST at
C                                       IAT=0 in radians.
      GMST0 (TU) = MOD (((((((-6.2D-6 * TU) + 0.093104D0) *
     *   TU) + 8640184.812866D0) * TU + 24110.54841D0) * TWOPI /
     *   86400.0D0), TWOPI)
C-----------------------------------------------------------------------
C                                       save input EQUIN
      EQUINN = EQUIN
      EQUIN = 2000.0D0
C                                       Convert to rectangular
C                                       coordinates.
      IF (DIR.GT.0) THEN
C                                       convert B1950 to J2000
         IF (EQUINN .EQ. 1950.0D0) THEN
            BEPOCH = 1979.3D0
            CALL B2J (RAMEAN, DECMEA, BEPOCH, RAMEAN, DECMEA)
            END IF
         POS(1) = COS (RAMEAN) * COS (DECMEA)
         POS(2) = SIN (RAMEAN) * COS (DECMEA)
         POS(3) = SIN (DECMEA)
      ELSE
         POS(1) = COS (RAAPP) * COS (DECAPP)
         POS(2) = SIN (RAAPP) * COS (DECAPP)
         POS(3) = SIN (DECAPP)
         END IF
C                                       New set of interpolation values?
      IF (((JD.LT.JDINT(1)) .OR. (JD.GT.JDINT(2))) .OR.
     *      (DIR.NE.DIROLD) .OR.
     *      ((ABS (OBSPOS(1)-OBSOLD(1)) + ABS (OBSPOS(2)-OBSOLD(2)) +
     *      ABS (OBSPOS(3)-OBSOLD(3))).GT.1.0D-5)) THEN
         JDINT(1) = JD
         JDINT(2) = JD + DELDAT
         OBSOLD(1) = OBSPOS(1)
         OBSOLD(2) = OBSPOS(2)
         OBSOLD(3) = OBSPOS(3)
         DIROLD = DIR
C                                       Beginning of interpolation
C                                       Precession and nutation
         CALL JPRENU (DIR, JDINT(1), EQUIN, .TRUE., PRNMAT(1,1,1))
C                                       Aberation and light bending
         DIURN = (ABS (OBSPOS(3)) .GT. 1.0D-5)
         RHOGEO = 0.0
         RLST = 0.0
C                                       Following for diurnal aberation.
         IF (DIURN) THEN
            RHOGEO = OBSPOS(3) / 6378140.0D0
            ITEMP = JDINT(1)
            TIME = (JDINT(1) - ITEMP - 0.5D0) * TWOPI * 1.002737778D0
            TU = (JDINT(1) - 2451545.0D0) / 36525.0D0
            GMST = GMST0 (TU) + TIME
            RLST = OBSPOS(2) + GMST
            END IF
         CALL JABER (JDINT(1), EQUIN, DIURN, RHOGEO, OBSPOS(1), RLST,
     *      POSO(1,1), VELO(1,1))
C                                       End on interpolation,
C                                       don't interpolate less than 1
C                                       sec.
         IF (DELDAT.GT.1.15741D-5) THEN
C                                       Precession and nutation
            CALL JPRENU (DIR, JDINT(2), EQUIN, .TRUE., PRNMAT(1,1,2))
C                                       Following for diurnal aberation.
            IF (DIURN) THEN
               ITEMP = JDINT(2)
               TIME = (JDINT(2) - ITEMP - 0.5D0) * TWOPI * 1.002737778D0
               TU = (JDINT(2) - 2451545.0D0) / 36525.0D0
               GMST = GMST0 (TU) + TIME
               RLST = OBSPOS(2) + GMST
               END IF
            CALL JABER (JDINT(2), EQUIN, DIURN, RHOGEO, OBSPOS(1), RLST,
     *         POSO(1,2), VELO(1,2))
            END IF
         END IF
C                                       Interpolate vectors and matrix.
      WT1 = 1.0D0
      IF (DELDAT.GT.1.15741D-5)
     *   WT1 = (JDINT(2) - JD) / (JDINT(2) - JDINT(1))
      WT2 = 1.0D0 - WT1
      DO 60 I = 1,3
         POSOI(I) = WT1 * POSO(I,1) + WT2 * POSO(I,2)
         VELOI(I) = WT1 * VELO(I,1) + WT2 * VELO(I,2)
         DO 50 J = 1,3
            ROTI(J,I) = WT1 * PRNMAT(J,I,1) + WT2 * PRNMAT(J,I,2)
 50         CONTINUE
 60      CONTINUE
C                                       Reduce position.
      IF (DIR.GT.0) THEN
C                                       Mean to apparent.
C                                       Light deflection
C                                       using the routine GRD
         IF (GR) THEN
            SD = SIN(DECMEA)
            CD = COS(DECMEA)
            CALL GRD (JD, RAMEAN, DECMEA, SD, CD, DRA, DDEC)
            RAAPP = RAMEAN + DRA
            DECAPP= DECMEA + DDEC
            POS(1) = COS (RAAPP) * COS (DECAPP)
            POS(2) = SIN (RAAPP) * COS (DECAPP)
            POS(3) = SIN (DECAPP)
            END IF
C                                       Aberation
         V(1) = VELOI(1) * 0.0057755D0
         V(2) = VELOI(2) * 0.0057755D0
         V(3) = VELOI(3) * 0.0057755D0
         BETA = SQRT (1.0D0 - (V(1)*V(1) + V(2)*V(2) + V(3)*V(3)))
         PDOTV = POS(1)* V(1) + POS(2)*V(2) + POS(3)*V(3)
C
         CONST = (1.0D0 + (PDOTV / (1.0D0 + BETA))) / (1.0D0 + PDOTV)
         CONST2 = BETA / (1.0D0 + PDOTV)
         POS(1) = POS(1)*CONST2 + CONST*V(1)
         POS(2) = POS(2)*CONST2 + CONST*V(2)
         POS(3) = POS(3)*CONST2 + CONST*V(3)
C                                       Precession and nutation
         OUT(1) = POS(1)*ROTI(1,1) + POS(2)*ROTI(2,1) + POS(3)*ROTI(3,1)
         OUT(2) = POS(1)*ROTI(1,2) + POS(2)*ROTI(2,2) + POS(3)*ROTI(3,2)
         OUT(3) = POS(1)*ROTI(1,3) + POS(2)*ROTI(2,3) + POS(3)*ROTI(3,3)
C
         LENGTH = SQRT(OUT(1)*OUT(1) + OUT(2)*OUT(2) + OUT(3)*OUT(3))
         OUT(1) = OUT(1)/LENGTH
         OUT(2) = OUT(2)/LENGTH
         OUT(3) = OUT(3)/LENGTH
      ELSE
C                                       Apparent to mean
C                                       Precession and nutation
         OUT(1) = POS(1)*ROTI(1,1) + POS(2)*ROTI(2,1) + POS(3)*ROTI(3,1)
         OUT(2) = POS(1)*ROTI(1,2) + POS(2)*ROTI(2,2) + POS(3)*ROTI(3,2)
         OUT(3) = POS(1)*ROTI(1,3) + POS(2)*ROTI(2,3) + POS(3)*ROTI(3,3)
C                                       Aberation
         V(1) = VELOI(1) * 0.0057755D0
         V(2) = VELOI(2) * 0.0057755D0
         V(3) = VELOI(3) * 0.0057755D0
C                                       let's calculate LENGTH.
C                                       The vector out*length is equal
C                                       to vector at DIR=1 before
C                                       precession+nutation
         BETA = SQRT (1.0D0 - (V(1)*V(1) + V(2)*V(2) + V(3)*V(3)))
         PDOTV = POS(1)* V(1) + POS(2)*V(2) + POS(3)*V(3)
C
         CONST = (1.0D0 + (PDOTV / (1.0D0 + BETA))) / (1.0D0 + PDOTV)
         CONST2 = BETA / (1.0D0 + PDOTV)
         POSSQR = POS(1)*POS(1) + POS(2)*POS(2) + POS(3)*POS(3)
         OUTSQR = OUT(1)*OUT(1) + OUT(2)*OUT(2) + OUT(3)*OUT(3)
         VSQR = V(1)*V(1) + V(2)*V(2) +V(3)*V(3)
C
         LENGTH = SQRT((POSSQR*CONST2*CONST2 + VSQR*CONST*CONST
     *      + 2*PDOTV*CONST2*CONST) / OUTSQR)
C
         OUT(1) = OUT(1)*LENGTH
         OUT(2) = OUT(2)*LENGTH
         OUT(3) = OUT(3)*LENGTH
C                                       Solve the system of equations
C                                       to find nonaberrated coordinates
C                                       from aberrated ones
         AYX = (OUT(2) - V(2)/(1+BETA)) / (OUT(1) - V(1)/(1+BETA))
         AZX = (OUT(3) - V(3)/(1+BETA)) / (OUT(1) - V(1)/(1+BETA))
         BYX = (AYX*V(1) - V(2)) / (1+BETA)
         BZX = (AZX*V(1) - V(3)) / (1+BETA)
C                                       Solution of the equation
C                                       for OUT(1)
         OUT(1) = ((1 + BYX*V(2) + BZX*V(3))*(OUT(1) - V(1)/(1+BETA))
     *      - (BETA/(1+BETA))*V(1)) / (BETA - (OUT(1) - V(1)/(1+BETA))
     *      * (V(1) + AYX*V(2) + AZX*V(3)))
C                                       find OUT(2) and OUT(3)
C                                       knowing OUT(1)
         OUT(2) = BYX + AYX*OUT(1)
         OUT(3) = BZX + AZX*OUT(1)
C                                       Light deflection?
C                                       using the routine GRD
         IF (GR) THEN
            RAAPP = ATAN2 (OUT(2), OUT(1))
            IF (RAAPP.LT.0.0D0) RAAPP = RAAPP + TWOPI
            DECAPP = ASIN (OUT(3))
            SD = SIN(DECAPP)
            CD = COS(DECAPP)
            CALL GRD (JD, RAAPP, DECAPP, SD, CD, DRA, DDEC)
            RAMEAN = RAAPP - DRA
            DECMEA = DECAPP -  DDEC
            OUT(1) = COS (RAMEAN) * COS (DECMEA)
            OUT(2) = SIN (RAMEAN) * COS (DECMEA)
            OUT(3) = SIN (DECMEA)
            END IF
         END IF
C                                       Polar motion
      IF ((ABS (POLAR(1)) + ABS (POLAR(2))).GT.1.0E-20)
     *   CALL JPOLAR (DIR, POLAR(1), POLAR(2), OUT)
C                                       Convert to spherical coord.
C                                       Mean to apparent
      IF (DIR.GT.0) THEN
         RAAPP = ATAN2 (OUT(2), OUT(1))
         IF (RAAPP.LT.0.0D0) RAAPP = RAAPP + TWOPI
         DECAPP = ASIN (OUT(3))
C                                       Apparent to mean
      ELSE
         RAMEAN = ATAN2 (OUT(2), OUT(1))
         IF (RAMEAN.LT.0.0D0) RAMEAN = RAMEAN + TWOPI
         DECMEA = ASIN (OUT(3))
C                                       convert calculated J2000
C                                       coordinates back to B1950
         IF (EQUINN .EQ. 1950.D0) THEN
            BEPOCH = 1979.3D0
            CALL J2B (RAMEAN, DECMEA, BEPOCH, RAMEAN,
     *            DECMEA, DR1950, DD1950)
            END IF
         END IF
C                                       restore input EQUIN
      EQUIN = EQUINN

C
 999  RETURN
      END

C   selection/calibration/editing class: name = 'CALEDIT'
C-----------------------------------------------------------------------
C! Object Oriented AIPS Fortran "selection/calibration/editing" class
C# Map-util Utility Object-Oriented
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2004, 2010, 2012, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   The parameters controling data selection, calibration and editing
C   are stored here.
C
C   Class public members.
C      SOURCS   C(30)*16  Names of up to 30 sources, *=>all
C                         First character of name '-' => all except
C                         those specified.
C      SELQUA   I         Qualifier wanted (-1 => all)
C      SELCOD   C*4       Cal code ('    ')
C      TIMRNG   R(8)      Start day, hour, min, sec, end day, hour,
C                         min, sec. 0 => all
C      UVRNG    R(2)      Minimum and maximum baseline lengths in
C                         1000s wavelengths. 0 => all
C      STOKES   C*4       Stokes types wanted.
C                         'I','Q','U','V','R','L','IQU','IQUV'
C                         '    '=> Leave data in same form as in input.
C      BCHAN    I         First channel number selected, 1 rel. to first
C                         channel in data base. 0 => all
C      ECHAN    I         Last channel selected. 0=>all
C      BIF      I         First IF number selected, 1 rel. to first
C                         IF in data base. 0 => all
C      EIF      I         Last IF selected. 0=>all
C      DOCAL    L         If true apply calibration, else not.
C      DOPOL    I         If >0 then correct for feed polarization
C                         based on antenna file info.
C      PDVER    I         PD table version for DOPOL>0
C      DOACOR   L         True if autocorrelations wanted (false)
C      DOXCOR   L         True if cross-correlations wanted (true)
C      DOWTCL   L         True if weight calibration wanted.
C      DOFQSL   L         True if FREQSEL random parm present (false)
C      FRQSEL   I         Default FQ table entry to select (-1)
C      SELBAN   R         Bandwidth (Hz) to select (-1.0)
C      SELFRQ   R         Frequency (Hz) to select (-1.0)
C      DOBAND   I         >0 if bandpass calibration. (-1)
C      DOSMTH   I         if smoothing requested, 1 before 2 after BP
C      SMOOTH   R(3)      Smoothing parameters (0.0s)
C      DXTIME   R         Integration time (days). Used when applying
C                         delay corrections to correct for delay error.
C      ANTENS   I(50)     List of antennas selected, 0=>all,
C                         any negative => all except those specified
C      SUBARR   I         Subarray desired, 0=>all
C      FGVER    I         FLAG file version number, if < 0 then
C                         NO flagging is applied. 0 => use highest
C                         numbered table.
C      CLUSE    I         Cal (CL or SN) file version number to apply.
C      BLVER    I         BL Table to apply .le. 0 => none
C      BPVER    I         BP table to apply .le. 0 => none
C
C   Public functions:
C      SECGET (name, keywrd, type, dim, value, valuec, ierr)
C         Return member.
C      SECPUT (name, keywrd, type, dim, value, valuec, ierr)
C         Store  member.
C      SECINI (name, ierr)
C         Initializes default values (mostly no sel. edit, cal.)
C      SECSLT (name, bif, eif, bchan, echan, stokes, ierr)
C         Returns IF, channel and Stokes selection.
C      SECSAV (name, bif, eif, bchan, echan, stokes, ierr)
C         Resets IF, channel and Stokes selection.
C   Private to UV data class:
C      SECSET (name, ierr)
C         Copy current sel/edt/cal criteria to common
C
LOCAL INCLUDE 'CALEDIT.INC'
C                                       CALEDIT class include
      INTEGER   NMEML
      PARAMETER (NMEML = 30)
      CHARACTER MEMS(NMEML)*8, THSCLS*16
C                                       Gfortran 11
      INTEGER   IVAL(50)
      REAL      RVAL(50)
      LOGICAL   LVAL(50)
      EQUIVALENCE (IVAL, RVAL, LVAL)
C                   1          2         3         4         5
      DATA MEMS /'SOURCS', 'SELQUA', 'SELCOD', 'TIMRNG', 'UVRNG',
C           6         7        8      9     10       11      12
     *   'STOKES', 'BCHAN', 'ECHAN', 'BIF', 'EIF', 'DOCAL', 'DOPOL',
C           13       14        15         16        17       18
     *   'DOACOR', 'DOXCOR', 'DOWTCL', 'DOFQSL', 'FRQSEL', 'SELBAN',
C           19        20        21        22         23        24
     *   'SELFRQ', 'DOBAND', 'DOSMTH' ,'SMOOTH', 'DXTIME', 'ANTENNS',
C           25      26        27       28       29       30
     *   'SUBARR', 'CLUSE', 'BLVER', 'BPVER', 'FGVER', 'PDVER'/
      DATA THSCLS /'CALEDIT'/
LOCAL END
      SUBROUTINE SECGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public
C   Return selection/calibration/editing member.
C   Inputs:
C      NAME    C*?    Object name
C      KEYWRD  C*(*)  Keyword in form 'mem1.mem2...'
C   Outputs:
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of the array.
C      VALUE   ?     associated value (non character)
C      VALUEC  C*?   associated value (character)
C      IERR    I     Error code, 0=OK.  1=> did not find.,
C                    2= Input error.
C-----------------------------------------------------------------------
      INTEGER   TYPE, DIM(*), VALUE(*), IERR
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC*(*)
C
      INTEGER   IMEM, LOOP, OBJNUM, POINT
      CHARACTER MEMBER*16
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'CALEDIT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Lookup NAME
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Look for base class.member name
C                                       in KEYWRD.
      POINT = INDEX (KEYWRD, '.')
C                                       No base classes exist for this
C                                       class.
      IF (POINT.GE.1) THEN
         IERR = 2
         MSGTXT = 'NO BASE CLASSES FOR CLASS ' // THSCLS
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Save member name
      IF (POINT.LE.0) THEN
         MEMBER = KEYWRD
      ELSE
         MEMBER = KEYWRD(1:POINT-1)
         END IF
C                                       Search list of recognized
C                                       members.
      IMEM = -1
      DO 10 LOOP = 1,NMEML
         IF (MEMBER.EQ.MEMS(LOOP)) IMEM = LOOP
 10      CONTINUE
C                                       Find it?
      IF (IMEM.LE.0) THEN
         IERR = 2
         MSGTXT = 'UNRECOGNIZED ' // THSCLS // ' MEMBER ' // MEMBER
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Fetch value:
      CALL OBGET (OBJNUM, KEYWRD(POINT+1:), TYPE, DIM, VALUE, VALUEC,
     *   IERR)
C                                       Message if not found
      IF (IERR.EQ.1) THEN
         MSGTXT = 'MEMBER ' // MEMBER // ' NOT FOUND'
         CALL MSGWRT (6)
         MSGTXT = 'OBJECT =' // NAME
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
      END
      SUBROUTINE SECPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public
C   Store selection/calibration/editing member.
C   Inputs:
C      NAME    C*?    Object name
C      KEYWRD  C*(*)  Keyword in form 'mem1.mem2...'
C   Outputs:
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of the array.
C      VALUE   ?     associated value (non character)
C      VALUEC  C*?   associated value (character)
C      IERR    I     Error code, 0=OK.  1=> did not find.,
C                    2= Input error.
C-----------------------------------------------------------------------
      INTEGER   TYPE, DIM(*), VALUE(*), IERR
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC*(*)
C
      INTEGER   IMEM, LOOP, OBJNUM, POINT
      CHARACTER MEMBER*16
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'CALEDIT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Lookup NAME
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Look for base class.member name
C                                       in KEYWRD.
      POINT = INDEX (KEYWRD, '.')
C                                       No base classes exist for this
C                                       class.
      IF (POINT.GE.1) THEN
         IERR = 2
         MSGTXT = 'NO BASE CLASSES FOR CLASS ' // THSCLS
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Save member name
      IF (POINT.LE.0) THEN
         MEMBER = KEYWRD
      ELSE
         MEMBER = KEYWRD(1:POINT-1)
         END IF
C                                       Search list of recognized
C                                       members.
      IMEM = -1
      DO 10 LOOP = 1,NMEML
         IF (MEMBER.EQ.MEMS(LOOP)) IMEM = LOOP
 10      CONTINUE
C                                       Find it?
      IF (IMEM.LE.0) THEN
         IERR = 2
         MSGTXT = 'UNRECOGNIZED ' // THSCLS // ' MEMBER ' // MEMBER
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Fetch value:
      CALL OBPUT (OBJNUM, KEYWRD(POINT+1:), TYPE, DIM, VALUE, VALUEC,
     *   IERR)
C                                       Message if not stored
      IF (IERR.NE.0) THEN
         MSGTXT = 'MEMBER ' // MEMBER // ' COULD NOT BE STORED'
         CALL MSGWRT (6)
         MSGTXT = 'OBJECT =' // NAME
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
      END
      SUBROUTINE SECINI (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Initialize selection/calibration/editing object.
C   Inputs:
C      NAME    C*?    Object name
C   Outputs:
C      IERR    I     Error code, 0=OK.
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER NAME*(*)
C
      INTEGER   DIM(3), OBJNUM
      CHARACTER CVAL*480
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'CALEDIT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Lookup NAME
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
      DIM(3) = 0
C                                       Source list
      CVAL = '   '
      DIM(1) = 16
      DIM(2) = 30
      CALL OBPUT (OBJNUM, MEMS(1), OOACAR, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       SELQUA
      IVAL(1) = -1
      DIM(1) = 1
      DIM(2) = 1
      CALL OBPUT (OBJNUM, MEMS(2), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       SELCOD
      CVAL(1:4) = '    '
      DIM(1) = 4
      DIM(2) = 1
      CALL OBPUT (OBJNUM, MEMS(3), OOACAR, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Timerange
      CALL RFILL (8, 0.0, RVAL)
      DIM(1) = 8
      DIM(2) = 1
      CALL OBPUT (OBJNUM, MEMS(4), OOARE, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       UV range
      CALL RFILL (2, 0.0, RVAL)
      DIM(1) = 2
      DIM(2) = 1
      CALL OBPUT (OBJNUM, MEMS(5), OOARE, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       STOKES
      CVAL(1:4) = '    '
      DIM(1) = 4
      DIM(2) = 1
      CALL OBPUT (OBJNUM, MEMS(6), OOACAR, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       BCHAN
      IVAL(1) = 1
      DIM(1) = 1
      DIM(2) = 1
      CALL OBPUT (OBJNUM, MEMS(7), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       ECHAN
      IVAL(1) = 0
      CALL OBPUT (OBJNUM, MEMS(8), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       BIF
      IVAL(1) = 1
      CALL OBPUT (OBJNUM, MEMS(9), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       EIF
      IVAL(1) = 0
      CALL OBPUT (OBJNUM, MEMS(10), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       DOCAL
      LVAL(1) = .FALSE.
      CALL OBPUT (OBJNUM, MEMS(11), OOALOG, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       DOPOL
      IVAL(1) = -1
      CALL OBPUT (OBJNUM, MEMS(12), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       DOACOR
      LVAL(1) = .FALSE.
      CALL OBPUT (OBJNUM, MEMS(13), OOALOG, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       DOXCOR (true)
      LVAL(1) = .TRUE.
      CALL OBPUT (OBJNUM, MEMS(14), OOALOG, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       DOWTCL
      LVAL(1) = .FALSE.
      CALL OBPUT (OBJNUM, MEMS(15), OOALOG, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       DOFQSL
      LVAL(1) = .FALSE.
      CALL OBPUT (OBJNUM, MEMS(16), OOALOG, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       FRQSEL
      IVAL(1) = -1
      CALL OBPUT (OBJNUM, MEMS(17), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       SELBAN
      RVAL(1) = -1.0
      CALL OBPUT (OBJNUM, MEMS(18), OOARE, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       SELFRQ (can only be passed as
C                                       real)
      RVAL(1) = -1.0
      CALL OBPUT (OBJNUM, MEMS(19), OOARE, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       DOBAND
      IVAL(1) = -1
      CALL OBPUT (OBJNUM, MEMS(20), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       DOSMTH
      IVAL(1) = 0
      CALL OBPUT (OBJNUM, MEMS(21), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       SMOOTH
      CALL RFILL (3, 0.0, RVAL)
      DIM(1) = 3
      CALL OBPUT (OBJNUM, MEMS(22), OOARE, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       DXTIME
      RVAL(1) = 0.0
      DIM(1) = 1
      CALL OBPUT (OBJNUM, MEMS(23), OOARE, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       ANTENNAS
      CALL FILL (50, 0, IVAL)
      DIM(1) = 50
      CALL OBPUT (OBJNUM, MEMS(24), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       SUBARR
      IVAL(1) = 0
      DIM(1) = 1
      CALL OBPUT (OBJNUM, MEMS(25), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       CLUSE
      IVAL(1) = 0
      DIM(1) = 1
      CALL OBPUT (OBJNUM, MEMS(26), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       BLVER
      IVAL(1) = -1
      DIM(1) = 1
      CALL OBPUT (OBJNUM, MEMS(27), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       BPVER
      IVAL(1) = -1
      DIM(1) = 1
      CALL OBPUT (OBJNUM, MEMS(28), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       FGVER (no flagging)
      IVAL(1) = -100
      DIM(1) = 1
      CALL OBPUT (OBJNUM, MEMS(29), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       PDVER
      IVAL(1) = -1
      CALL OBPUT (OBJNUM, MEMS(30), OOAINT, DIM, IVAL, CVAL, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE SECSET (NAME, IERR)
C-----------------------------------------------------------------------
C   Shared with UV data class
C   Does a variety of startup operations for establishing
C   selection/calibration and editing.  First SELINI is called to
C   initialize DSEL.INC.  Then the sel/cal/edit criteria are copied from
C   the object to DSEL.INC.  Finally, FQMATC is called to set selection
C   by FQ id.
C   Note: as POPS adverbs cannot be passed as double precision they are
C   stored as real.  It is intended that most of these values be filled
C   in by copying the adverb values from the Input object to the uv data
C   object.
C   Inputs:
C      NAME    C*?    Object name
C   Outputs:
C      IERR    I     Error code, 0=OK.
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER NAME*(*)
C
      INTEGER   TYPE, DIM(3), OBJNUM, LUN, DISK, CNO
      CHARACTER CDUMMY*1
      LOGICAL   MATCH
      REAL      RTEMP
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'CALEDIT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Initialize DSEL.INC
      CALL SELINI
C                                       Lookup NAME
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Source list
      CALL OBGET (OBJNUM, MEMS(1), TYPE, DIM, IVAL, SOURCS, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       SELQUA
      CALL OBGET (OBJNUM, MEMS(2), TYPE, DIM, IVAL, CDUMMY, IERR)
      SELQUA = IVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       SELCOD
      CALL OBGET (OBJNUM, MEMS(3), TYPE, DIM, IVAL, SELCOD, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Timerange
      CALL OBGET (OBJNUM, MEMS(4), TYPE, DIM, IVAL, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RVAL, TIMRNG)
C                                       UV range
      CALL OBGET (OBJNUM, MEMS(5), TYPE, DIM, IVAL, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RVAL, UVRNG)
C                                       STOKES
      CALL OBGET (OBJNUM, MEMS(6), TYPE, DIM, IVAL, STOKES, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       BCHAN
      CALL OBGET (OBJNUM, MEMS(7), TYPE, DIM, IVAL, CDUMMY, IERR)
      BCHAN = IVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       ECHAN
      CALL OBGET (OBJNUM, MEMS(8), TYPE, DIM, IVAL, CDUMMY, IERR)
      ECHAN = IVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       BIF
      CALL OBGET (OBJNUM, MEMS(9), TYPE, DIM, IVAL, CDUMMY, IERR)
      BIF = IVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       EIF
      CALL OBGET (OBJNUM, MEMS(10), TYPE, DIM, IVAL, CDUMMY, IERR)
      EIF = IVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       DOCAL
      CALL OBGET (OBJNUM, MEMS(11), TYPE, DIM, IVAL, CDUMMY, IERR)
      DOCAL = LVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       DOPOL
      CALL OBGET (OBJNUM, MEMS(12), TYPE, DIM, IVAL, CDUMMY, IERR)
      DOPOL = IVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       DOACOR
      CALL OBGET (OBJNUM, MEMS(13), TYPE, DIM, IVAL, CDUMMY, IERR)
      DOACOR = LVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       DOXCOR
      CALL OBGET (OBJNUM, MEMS(14), TYPE, DIM, IVAL, CDUMMY, IERR)
      DOXCOR = LVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       DOWTCL
      CALL OBGET (OBJNUM, MEMS(15), TYPE, DIM, IVAL, CDUMMY, IERR)
      DOWTCL = LVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       DOFQSL
      CALL OBGET (OBJNUM, MEMS(16), TYPE, DIM, IVAL, CDUMMY, IERR)
      DOFQSL = LVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       FRQSEL
      CALL OBGET (OBJNUM, MEMS(17), TYPE, DIM, IVAL, CDUMMY, IERR)
      FRQSEL = IVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       SELBAN
      CALL OBGET (OBJNUM, MEMS(18), TYPE, DIM, IVAL, CDUMMY, IERR)
      SELBAN = RVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       SELFRQ (can only be passed as
C                                       real)
      CALL OBGET (OBJNUM, MEMS(19), TYPE, DIM, IVAL, CDUMMY, IERR)
      RTEMP = RVAL(1)
      IF (IERR.NE.0) GO TO 999
      SELFRQ = RTEMP
C                                       DOBAND
      CALL OBGET (OBJNUM, MEMS(20), TYPE, DIM, IVAL, CDUMMY, IERR)
      DOBAND = IVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       DOSMTH
      CALL OBGET (OBJNUM, MEMS(21), TYPE, DIM, IVAL, CDUMMY, IERR)
      DOSMTH = IVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       SMOOTH
      CALL OBGET (OBJNUM, MEMS(22), TYPE, DIM, IVAL, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RVAL, SMOOTH)
C                                       DXTIME
      CALL OBGET (OBJNUM, MEMS(23), TYPE, DIM, IVAL, CDUMMY, IERR)
      DXTIME = RVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       ANTENNAS
      CALL OBGET (OBJNUM, MEMS(24), TYPE, DIM, ANTENS, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       SUBARR
      CALL OBGET (OBJNUM, MEMS(25), TYPE, DIM, IVAL, CDUMMY, IERR)
      SUBARR = IVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       CLUSE
      CALL OBGET (OBJNUM, MEMS(26), TYPE, DIM, IVAL, CDUMMY, IERR)
      CLUSE = IVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       BLVER
      CALL OBGET (OBJNUM, MEMS(27), TYPE, DIM, IVAL, CDUMMY, IERR)
      BLVER = IVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       BPVER
      CALL OBGET (OBJNUM, MEMS(28), TYPE, DIM, IVAL, CDUMMY, IERR)
      BPVER = IVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       FGVER
      CALL OBGET (OBJNUM, MEMS(29), TYPE, DIM, IVAL, CDUMMY, IERR)
      FGVER = IVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       PDVER
      CALL OBGET (OBJNUM, MEMS(30), TYPE, DIM, IVAL, CDUMMY, IERR)
      PDVER = IVAL(1)
      IF (IERR.NE.0) GO TO 999
C                                       Process FQ selection criteria.
      CALL OBLUN (LUN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBDSKC (NAME, DISK, CNO, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBHGET (NAME, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Need to update DUVH.INC
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 999
      CALL FQMATC (DISK, CNO, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, IERR)
C                                       Free LUN
      CALL OBLUFR (LUN)
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1070)
         CALL MSGWRT (8)
         IERR = 1
      ELSE
         IERR = 0
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
      END
      SUBROUTINE SECSLT (NAME, BIF, EIF, BCHAN, ECHAN, STOKES, IERR)
C-----------------------------------------------------------------------
C   Public
C   Return current IF, channel and Stokes selection criteria.
C   Inputs:
C      NAME    C*?    Object name
C   Outputs:
C      BIF     I     First IF selected
C      EIF     I     Highest IF selected
C      BCHAN   I     First channel selected
C      ECHAN   I     Highest channel selected
C      STOKES  C*4   Stokes selection string
C      IERR    I     Error code, 0=OK.
C-----------------------------------------------------------------------
      INTEGER   BIF, EIF, BCHAN, ECHAN, IERR
      CHARACTER NAME*(*), STOKES*4
C
      INTEGER   TYPE, DIM(3), OBJNUM
      CHARACTER CDUMMY*1
      INCLUDE 'CALEDIT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Lookup NAME
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Look up values
      CALL OBGET (OBJNUM, 'BIF', TYPE, DIM, IVAL, CDUMMY, IERR)
      BIF = IVAL(1)
      IF (IERR.NE.0) GO TO 999
      CALL OBGET (OBJNUM, 'EIF', TYPE, DIM, IVAL, CDUMMY, IERR)
      EIF = IVAL(1)
      IF (IERR.NE.0) GO TO 999
      CALL OBGET (OBJNUM, 'BCHAN', TYPE, DIM, IVAL, CDUMMY, IERR)
      BCHAN = IVAL(1)
      IF (IERR.NE.0) GO TO 999
      CALL OBGET (OBJNUM, 'ECHAN', TYPE, DIM, IVAL, CDUMMY, IERR)
      ECHAN = IVAL(1)
      IF (IERR.NE.0) GO TO 999
      CALL OBGET (OBJNUM, 'STOKES', TYPE, DIM, IVAL, STOKES, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE SECSAV (NAME, BIF, EIF, BCHAN, ECHAN, STOKES, IERR)
C-----------------------------------------------------------------------
C   Public
C   Reset IF, channel and Stokes selection criteria to specified
C   values.
C   Inputs:
C      BIF     I     First IF selected
C      EIF     I     Highest IF selected
C      BCHAN   I     First channel selected
C      ECHAN   I     Highest channel selected
C      STOKES  C*4   Stokes selection string
C      NAME    C*?    Object name
C   Outputs:
C      IERR    I     Error code, 0=OK.
C-----------------------------------------------------------------------
      INTEGER   BIF, EIF, BCHAN, ECHAN, IERR
      CHARACTER NAME*(*), STOKES*4
C
      INTEGER   DIM(3), OBJNUM
      CHARACTER CDUMMY*1
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'CALEDIT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Lookup NAME
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Save values
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      IVAL(1) = BIF
      CALL OBPUT (OBJNUM, 'BIF', OOAINT, DIM, IVAL, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IVAL(1) = EIF
      CALL OBPUT (OBJNUM, 'EIF', OOAINT, DIM, IVAL, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IVAL(1) = BCHAN
      CALL OBPUT (OBJNUM, 'BCHAN', OOAINT, DIM, IVAL, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IVAL(1) = ECHAN
      CALL OBPUT (OBJNUM, 'ECHAN', OOAINT, DIM, IVAL, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      DIM(1) = LEN (STOKES)
      CALL OBPUT (OBJNUM, 'STOKES', OOACAR, DIM, IVAL, STOKES, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END

      SUBROUTINE Q1GRD (UV, VIS, WT, L, INCF, NT2, M,
     *   LROW, CNT, NFREQ)
C-----------------------------------------------------------------------
C! FPS AP version: Grids row of UV data
C# AP-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FPS AP 120B version
C   Grids visibility data that has been loaded into the AP
C   previously,  If requested, positions are shifted and then
C   a taper is applied to the weights if requested before gridding.
C   multiple frequency channels may be gridded together for
C   bandwidth synthesis.  Two work words are assumed before the
C   first visibility.
C     Inputs:
C       I   UV = base address of u,v vector
C       I   VIS = base address of visibility
C       I   WT = base address of weights
C       I   L  = length of visibility record
C       I   INCF = Increment between visibility, stepping in
C                    frequency.
C       I   NT2 = INT ( (no. cells used on a row)/2 )
C       I   M = number of rows kept in AP (MUST be odd)
C       I   LROW = length of a row (V)
C       I   CNT =  number of visibility points.
C       I   NFREQ  =  number of frequencies to grid.
C              If NFREQ is negative then tapering is requested.
C              If CNT is neg, do not shift data.
C     Expects necessary constants in following AP locations:
C           8 = Row number of lowest central row to grid
C           9 = -SIG(U)**2 (CELLS**2) for taper
C          10 = -SIG(V)**2 (CELLS**2) for taper
C          11 = U scaling to cells
C          12 = V scaling to cells
C          13 = W scaling to cells
C          14 = DXC = -2 * PI * delta RA (in 1/cells) for 1ST
C          15 = DYC = -2 * PI * delta DEC         frequency channel
C          16 = DZC = -2 * PI * delta Z
C          17 = AP address containing address of base address of row
C               convolving fn. (Y on sky)
C          18 = AP address containing address of base address of col.
C               convolving fn. (X on sky)
C          19 = AP address containing address of base address of grid.
C          20...20+NFREQ-2 = differential frequency scaling table
C               for channels after the first one.
C               FREQ(n) = (1+MD(16+n-1)) * FREQ(n-1) for n>1
C-----------------------------------------------------------------------
      INTEGER UV, VIS, WT, L, INCF, NT2, M, LROW, CNT, NFREQ
      INTEGER*2 IUV, IVIS, IWT, IL, IINCF, INT2, IM, ILROW,
     *   ICNT, INFREQ
C-----------------------------------------------------------------------
C                                       Convert to 2-comp. unsigned I*2
      IF (UV.LT.32768) IUV = UV
      IF (UV.GE.32768) IUV = UV - 65536
      IF (VIS.LT.32768) IVIS = VIS
      IF (VIS.GE.32768) IVIS = VIS - 65536
      IF (WT.LT.32768) IWT = WT
      IF (WT.GE.32768) IWT = WT - 65536
      IF (L.LT.32768) IL = L
      IF (L.GE.32768) IL = L - 65536
      IF (INCF.LT.32768) IINCF = INCF
      IF (INCF.GE.32768) IINCF = INCF - 65536
      IF (NT2.LT.32768) INT2 = NT2
      IF (NT2.GE.32768) INT2 = NT2 - 65536
      IF (M.LT.32768) IM = M
      IF (M.GE.32768) IM = M - 65536
      IF (LROW.LT.32768) ILROW = LROW
      IF (LROW.GE.32768) ILROW = LROW - 65536
      IF (CNT.LT.32768) ICNT = CNT
      IF (CNT.GE.32768) ICNT = CNT - 65536
      IF (NFREQ.LT.32768) INFREQ = NFREQ
      IF (NFREQ.GE.32768) INFREQ = NFREQ - 65536
C                                       Call FPS routine
      CALL AP1GRD (IUV, IVIS, IWT, IL, IINCF, INT2, IM, ILROW,
     *   ICNT, INFREQ)
C
 999  RETURN
      END

      SUBROUTINE TVWHER (QUAD, RPOS, IBUT, IERR)
C-----------------------------------------------------------------------
C! turns on cursor, waits for button, returns quadrant, position, button
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   TVWHER is the routine to use if you want the user to point at
C   something on the TV screen.  It turns on the cursor, waits for a
C   button push, determines which quadrant the event occurred in, and
C   returns the quadrant number and the TV coordinates of the event
C   corrected for the scroll of the lowest numbered plane which is
C   "on" in that quadrant  and for zoom.
C   Outputs:
C      QUAD  I       Quadrant number
C      RPOS  R(2)    TV position corrected for scroll (& zoom)
C      IBUT  I       Value of button(s) pushed
C      IERR  I       Error code of ZM70XF
C-----------------------------------------------------------------------
      REAL      RPOS(2)
      INTEGER   QUAD, IBUT, IERR
C
      LOGICAL   T
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Read cursor, wait for button
      QUAD = 0
      CALL YCURSE ('READ', T, T, RPOS, QUAD, IBUT, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END

      SUBROUTINE ICBPLT (IBUFF, CBCORN, IGR, DOZERO, IERR)
C-----------------------------------------------------------------------
C! draws Clean beam on TV
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ICBPLT draws the half power beam on a TV graphics plane
C   Inputs:
C      IBUFF    I(*)   The output buffer used in writing to the TV:
C                      size >= max x dimension
C      CBCORN   I      Corner of image: 1 lower left, 2 lower right,
C                      3 upper right, 4 upper left
C      IGR      I      Use graphics plane IGR
C      DOZERO   I      1 => zero full graphics plane (UNIQUE true)
C                      -1 => zero only needed piece of graphics plane
C                      0 => do NOT zero the graphics plane
C   Output:
C      IBUFF    I(*)   the updated TV output buffer.
C      IERR     I      error indicator: 0 no error; 10 = Image too small
C   Common:
C      /MAPHDR/ CATBLK   I(256)   the image catalog header.
C      Also assumes that LABINI has been called (e.g. by IAXIS1)
C-----------------------------------------------------------------------
      INTEGER   IBUFF(*), CBCORN, IGR, DOZERO, IERR
C
      INTEGER   I, IG1, IXCORN, IYCORN, IXTCRN, IYTCRN, IXBLC, IYBLC, J,
     *   IXTRC, IYTRC, BBLC(2), BTRC(2), IX(361), IY(361), ITG1, JERR
      REAL      BLC(2), TRC(2), BMAJ, BMIN, BEAMPA, XC, YC, XBC, YBC,
     *   CP, SP, CPA, SPA, PHI, X, Y, XINC, YINC
      DOUBLE PRECISION RAC, DECC, RA, DEC, DRA
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      CALL CHECKL ('ICBPLT')
      IF ((CORTYP(LOCNUM).LT.1) .OR. (CORTYP(LOCNUM).GT.2)) THEN
         IERR = -1
         MSGTXT = 'IMAGE NOT 2 CELESTIAL COORDINATES'
         GO TO 990
         END IF
      BMAJ = ABS (CATR(KRBMJ)) / 2.0
      BMIN = ABS (CATR(KRBMN)) / 2.0
      BEAMPA = CATR(KRBPA) * DG2RAD
C                                       Check that the beam is defined
      IF ((BMAJ.LT.1.E-9) .OR. (BMIN.LT.1.E-9)) THEN
         MSGTXT = 'NO CLEAN BEAM IN HEADER'
         IERR = -1
         GO TO 990
         END IF
C                                       Initial values.
      IG1 = IGR
      IF ((IG1.LE.0) .OR. (IG1.GT.NGRAPH-1)) IG1 = MIN (2, NGRAPH-1)
      ITG1 = IG1 + NGRAY
      IXCORN = CATBLK(IICOR)
      IYCORN = CATBLK(IICOR+1)
      IXTCRN = CATBLK(IICOR+2)
      IYTCRN = CATBLK(IICOR+3)
      IXBLC = CATBLK(IIWIN)
      IYBLC = CATBLK(IIWIN+1)
      IXTRC = CATBLK(IIWIN+2)
      IYTRC = CATBLK(IIWIN+3)
      IF ((IXTCRN-IXCORN.LE.2) .OR. (IYTCRN-IYCORN.LE.2) .OR.
     *   (IYTRC-IYBLC.LE.2) .OR. (IXTRC-IXBLC.LE.2)) THEN
         IERR = 10
         MSGTXT = 'IMAGE TOO SMALL TO PLOT BEAM'
         GO TO 990
         END IF
      XINC = REAL(IXTRC-IXBLC) / REAL(IXTCRN-IXCORN)
      YINC = REAL(IYTRC-IYBLC) / REAL(IYTCRN-IYCORN)
      ITG1 = NGRAY + IG1
      CALL YSLECT ('ONNN', ITG1, 0, IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       determine area of beam
      BLC(1) = IXBLC
      BLC(2) = IYBLC
      TRC(1) = IXTRC
      TRC(2) = IYTRC
      CALL PLTBSZ (CBCORN, BLC, TRC, CATR, BBLC, BTRC)
      J = MOD (CBCORN, 5)
      I = (BTRC(1) - BBLC(1) + 1) / 2
      IF ((J.EQ.2) .OR. (J.EQ.3)) I = -I
      BBLC(1) = BBLC(1) + I
      BTRC(1) = BTRC(1) + I
      I = (BTRC(2) - BBLC(2) + 1) / 2
      IF ((J.EQ.3) .OR. (J.EQ.4)) I = -I
      BBLC(2) = BBLC(2) + I
      BTRC(2) = BTRC(2) + I
      IX(1) = (BBLC(1) - IXBLC) / XINC + IXCORN + 0.5
      IX(2) = (BTRC(1) - IXBLC) / XINC + IXCORN + 0.5
      IX(3) = IX(2)
      IX(4) = IX(1)
      IX(5) = IX(1)
      IY(1) = (BBLC(2) - IYBLC) / YINC + IYCORN + 0.5
      IY(2) = IY(1)
      IY(3) = (BTRC(2) - IYBLC) / YINC + IYCORN + 0.5
      IY(4) = IY(3)
      IY(5) = IY(1)
C                                       zeroing
      IF (DOZERO.GT.0) THEN
         CALL YZERO (ITG1, IERR)
C                                       Clear part of sceen.
      ELSE IF (DOZERO.LT.0) THEN
         CALL YFILL (ITG1, IX(1), IY(1), IX(3), IY(3), 0, IBUFF,
     *      IERR)
         END IF
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'ZEROING GRAPHICS PLANE'
         GO TO 990
         END IF
C                                       draw boundary
      CALL IMVECT ('ONNN', ITG1, 5, IX, IY, IBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'IMVECT THE BOUNDARY'
         GO TO 990
         END IF
C                                       find coordinate info
      XC = (BLC(1) + TRC(1)) / 2.0
      YC = (BLC(2) + TRC(2)) / 2.0
      IF (CORTYP(LOCNUM).EQ.1) THEN
         CALL XYVAL (XC, YC, RAC, DECC, DRA, JERR)
      ELSE
         CALL XYVAL (XC, YC, DECC, RAC, DRA, JERR)
         END IF
      IF (JERR.NE.0) GO TO 980
      XBC = (BBLC(1) + BTRC(1)) / 2.0
      YBC = (BBLC(2) + BTRC(2)) / 2.0
C                                       Compute the extrema of X and Y
      CPA = COS (BEAMPA)
      SPA = SIN (BEAMPA)
      DRA = COS (DECC * DG2RAD)
      IF (DRA.EQ.0.0) DRA = 1.0
      DO 10 I = 0,360
         PHI = I * DG2RAD
         CP = BMIN * COS(PHI)
         SP = BMAJ * SIN(PHI)
         X  = CP*CPA - SP*SPA
         Y  = CP*SPA + SP*CPA
         RA = RAC - X / DRA
         DEC = DECC + Y
         IF (CORTYP(LOCNUM).EQ.1) THEN
            CALL XYPIX (RA, DEC, X, Y, JERR)
         ELSE
            CALL XYPIX (DEC, RA, X, Y, JERR)
            END IF
         IF (JERR.NE.0) GO TO 980
         X = X - XC + XBC
         Y = Y - YC + YBC
         IX(I+1) = (X - IXBLC) / XINC + IXCORN + 0.5
         IY(I+1) = (Y - IYBLC) / YINC + IYCORN + 0.5
 10      CONTINUE
C                                       draw boundary
      CALL IMVECT ('ONNN', ITG1, 361, IX, IY, IBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'IMVECT THE BEAM'
         GO TO 990
         END IF
      GO TO 999
C                                       coordinate issue
 980  MSGTXT = 'ERROR DURING COORDINATE COMPUTATION'
      IERR = 1
C
 990  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ICBPLT: ERROR',I4,' ON ',A)
      END

      SUBROUTINE PUTCRD (CARD, VOL, CNO, IERR)
C-----------------------------------------------------------------------
C! parses header keyword from FITS card and adds to catalog header
C# FITS Parsing Header
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PUTCRD takes a FITS history card of the form
C        HISTORY AIPS HEADERi  keyword = value / comment
C   parses the type code (i), the keyword, and the value and then
C   adds them to the catalog header file with CATKEY.
C   Inputs:
C      CARD   C*80   Card image
C      VOL    I      Disk volume
C      CNO    I      Catalog slot number
C   Output:
C      IERR   I      Error code: 0 okay, 1 => input error, > 1 => bad
C                       error
C-----------------------------------------------------------------------
      INTEGER   VOL, CNO, IERR
      CHARACTER CARD*80
C
      CHARACTER KEYWRD*8, KEYVAL*8
      INTEGER   ITYPE, NP, IT, IROUND, NUMKEY, LOCS, SCRTCH(256), I
      LOGICAL   LVALUE
      REAL      VALUES(2)
      DOUBLE PRECISION X
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 1
      IF (CARD(:19).NE.'HISTORY AIPS HEADER') THEN
         MSGTXT = 'PUTCRD CALLED WITH WRONG SORT OF FITS HEADER CARD:'
         CALL MSGWRT (6)
         GO TO 990
         END IF
C                                       type of data
      ITYPE = 0
      IF (CARD(20:20).EQ.'1') ITYPE = 1
      IF (CARD(20:20).EQ.'2') ITYPE = 2
      IF (CARD(20:20).EQ.'3') ITYPE = 3
      IF (CARD(20:20).EQ.'4') ITYPE = 4
      IF (CARD(20:20).EQ.'5') ITYPE = 5
      IF (ITYPE.LE.0) THEN
         MSGTXT = 'ILLEGAL HEADER KEYWORD TYPE ''' // CARD(20:20) //
     *      ''' IN CARD'
         CALL MSGWRT (6)
         GO TO 990
         END IF
C                                       get keyword
C                                       allowing imbedded blanks
      NP = 20
 10   NP = NP + 1
         IF (NP.GE.80) GO TO 980
         IF (CARD(NP:NP).EQ.' ') GO TO 10
      IT = NP
 20   NP = NP + 1
         IF (NP.GE.80) GO TO 980
         IF (CARD(NP:NP).NE.'=') GO TO 20
      I = MIN (IT+7, NP-1)
      KEYWRD = CARD(IT:I)
      NP = NP + 1
C                                       get keyword value
      VALUES(2) = 0
      IF (ITYPE.EQ.1) THEN
         CALL GETNUM (CARD, 80, NP, X)
         IF (X.EQ.DBLANK) GO TO 985
         CALL RCOPY (NWDPDP, X, VALUES)
      ELSE IF (ITYPE.EQ.2) THEN
         CALL GETNUM (CARD, 80, NP, X)
         IF (X.EQ.DBLANK) GO TO 985
         VALUES(1) = X
      ELSE IF (ITYPE.EQ.3) THEN
         CALL GETSTR (CARD, 80, 8, NP, KEYVAL, IT)
         CALL CHR2H (8, KEYVAL, 1, VALUES)
      ELSE IF (ITYPE.EQ.4) THEN
         CALL GETNUM (CARD, 80, NP, X)
         IF (X.EQ.DBLANK) GO TO 985
         VALUES(1) = X
         IT = IROUND (VALUES(1))
         CALL COPY (1, IT, VALUES)
      ELSE
         CALL GETLG (CARD, 80, NP, IT)
         LVALUE = IT.GT.0
         CALL LCOPY (1, LVALUE, VALUES)
         END IF
      NUMKEY = 1
      LOCS = 1
      CALL CATKEY ('WRIT', VOL, CNO, KEYWRD, NUMKEY, LOCS, VALUES,
     *   ITYPE, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         IERR = 2
         END IF
      GO TO 990
C
 980  MSGTXT = 'KEYWORD = VALUE PAIR NOT FOUND IN CARD'
      CALL MSGWRT (6)
      GO TO 990
 985  MSGTXT = 'PUTCRD: BAD VALUE ON CARD'
      CALL MSGWRT (6)
      IERR = 1
C
 990  IF (IERR.NE.0) THEN
         MSGTXT = CARD
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CATKEY RETURNS ERROR',I4,' ON CARD')
      END

      SUBROUTINE DGGET (VISIN, IND, TRANSL, MVIS, JADR, SELFAC, ALLWT,
     *   VISOUT, DROP)
C-----------------------------------------------------------------------
C! Selects uv data and changes Stokes' type.
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2003, 2017
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Gets requested data from visibility record, reformatting if needed.
C   REQUIRES setup by DGINIT to set values of MVIS, JADR, SELFAC and
C   ALLWT.
C   Inputs:
C      VISIN    R(IND,*)   Input visibility array
C      IND      I          First dimension of VISIN (CATBLK(KINAX))
C      TRANSL   L          f => Do simple copy, not combining pols
C      MVIS     I(8)       Number of visibilities in requested output
C                          format., # pol, BIF, EIF, BCH, ECH, JNCIF,
C                          JNCF
C      JADR     I(2,4)     Pointers to the first and second visibility
C                          input records to be used in the output
C                          record. If JADR(1,n) is negative use IABS
C                          (JADR(1,n)) and multiply the visibility by i
C                          (=SQRT(-1)).  If JADR(2,n) < 0, use IABS and
C                          construct (1) + i*(2)
C      SELFAC   R(2,4)     Factors to be multiplied by the first and
C                          second input vis's to make the output vis.
C      ALLWT    L          Flag, = .TRUE. if all visibilities must have
C                          positive weight.
C   Output:
C      VISOUT   R(3,*)     Output visibility record
C      DROP     L          .TRUE. if all data in record flaged.
C-----------------------------------------------------------------------
      INTEGER   MVIS(8), JADR(2,4), IND
      LOGICAL   TRANSL, ALLWT, DROP
      REAL      VISIN(IND,*), SELFAC(2,4), VISOUT(3,*)
C
      INTEGER   I, IP1, IP2, LF, LC, LP, LFOFF, IOFF
      LOGICAL   GOOD, HASWT
      REAL      WT1, WT2, TEMP, XFACT1, XFACT2
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      GOOD = .FALSE.
C                                       See if weight in data
      HASWT = IND.GE.3
C                                       Check input.
      IF (MVIS(1).LE.0) GO TO 999
C                                       Loop checking
C                                       and summing weights
C                                       and getting visibilities.
      I = 0
      LFOFF = (MVIS(3) - 2) * MVIS(7) + (MVIS(5) - 2) * MVIS(8)
      DO 70 LF = MVIS(3),MVIS(4)
         LFOFF = LFOFF + MVIS(7)
         IOFF = LFOFF
         DO 60 LC = MVIS(5),MVIS(6)
            IOFF = IOFF + MVIS(8)
            IF (TRANSL) THEN
               DO 40 LP = 1,MVIS(2)
                  I = I + 1
C                                       Initialize output
                  VISOUT(1,I) = 0.0
                  VISOUT(2,I) = 0.0
                  VISOUT(3,I) = 0.0
C                                       Set pointers.
                  IP1 = ABS (JADR(1,LP)) + IOFF
                  IP2 = ABS (JADR(2,LP)) + IOFF
C                                       Get weights.
                  IF (HASWT) THEN
                     WT1 = MAX (0.0, VISIN(3,IP1))
                     WT2 = MAX (0.0, VISIN(3,IP2))
                  ELSE
                     WT1 = 1.0
                     WT2 = 1.0
                     IF (VISIN(1,IP1).EQ.FBLANK) WT1 = 0.0
                     IF (VISIN(1,IP2).EQ.FBLANK) WT2 = 0.0
                     END IF
C                                       Check weights.
                  IF ((ALLWT) .AND. ((WT1.LE.0.0) .OR. (WT2.LE.0.0)))
     *                  GO TO 40
C                                       Set visibility.
                  VISOUT(3,I) = WT1 + WT2
                  IF (VISOUT(3,I).GT.0.0) THEN
                     XFACT1 = 0.0
                     XFACT2 = 0.0
                     IF (WT1.GT.0.0) XFACT1 = SELFAC(1,LP)
                     IF (WT2.GT.0.0) XFACT2 = SELFAC(2,LP)
                     GOOD = .TRUE.
C                                       RL, LR from Q, U
                     IF (JADR(2,LP).LT.0) THEN
                        VISOUT(1,I) = XFACT1 * VISIN(1,IP1) - XFACT2
     *                     * VISIN(2,IP2)
                        VISOUT(2,I) = XFACT1 * VISIN(2,IP1) + XFACT2 *
     *                     VISIN(1,IP2)
                     ELSE
                        VISOUT(1,I) = XFACT1 * VISIN(1,IP1) + XFACT2
     *                     * VISIN(1,IP2)
                        VISOUT(2,I) = XFACT1 * VISIN(2,IP1) + XFACT2 *
     *                     VISIN(2,IP2)
C                                       Upol, mult. by i
                        IF (JADR(1,LP).LT.0) THEN
                           TEMP = VISOUT(1,I)
                           VISOUT(1,I) = - VISOUT(2,I)
                           VISOUT(2,I) = TEMP
                           END IF
                        END IF
C                                       If one wt .le. 0  double VIS.
                     IF ((WT1.LE.0.0) .OR. (WT2.LE.0.0)) THEN
                        VISOUT(1,I) = 2.0 * VISOUT(1,I)
                        VISOUT(2,I) = 2.0 * VISOUT(2,I)
C                                       correct weight combination
                     ELSE IF (IP1.NE.IP2) THEN
                        VISOUT(3,I) = 4.0 * WT1 * WT2 / (WT1 + WT2)
                     ELSE
                        VISOUT(3,I) = (WT1 + WT2) / 2.0
                        END IF
                     END IF
 40               CONTINUE
C                                       No translation
            ELSE
               DO 50 LP = 1,MVIS(2)
                  I = I + 1
                  IP1 = ABS (JADR(1,LP)) + IOFF
C                                       Get weights.
                  IF (HASWT) THEN
                     WT1 = MAX (0.0, VISIN(3,IP1))
                  ELSE
                     WT1 = 1.0
                     IF (VISIN(1,IP1).EQ.FBLANK) WT1 = 0.0
                     END IF
C                                       Set visibility.
                  VISOUT(3,I) = WT1
                  IF (WT1.GT.0.0) GOOD = .TRUE.
                  VISOUT(1,I) = VISIN(1,IP1)
                  VISOUT(2,I) = VISIN(2,IP1)
 50               CONTINUE
               END IF
 60         CONTINUE
 70      CONTINUE
C                                       See if any good data.
      DROP = .NOT. GOOD
C
 999  RETURN
      END

      SUBROUTINE UNSCR
C-----------------------------------------------------------------------
C! delete all scratch files belonging to this tasl
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   WaWa IO system:  Delete all scratch files belonging to this task
C   and POPS number.
C   Written by WaWa (4/21/81)
C-----------------------------------------------------------------------
C
      CHARACTER DNAM*36, STAT*4, NAME*12, CLASS*6, PTYPE*2, OPER*4
      INTEGER   DVOL, SEQ, USID, NSUB, NOFIND, IERR, QUSID, CNO
      LOGICAL   LCH, F
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA F /.FALSE./
      DATA NOFIND /5/
C-----------------------------------------------------------------------
C                                       Get basic namestring
      DVOL = 0
      SEQ = 0
      USID = 0
      PTYPE = 'SC'
      NAME = ' '
      CLASS = ' '
      CALL A2WAWA (NAME, CLASS, SEQ, PTYPE, DVOL, USID, DNAM)
      CALL SCRNAM (DNAM, DNAM)
      CALL WAWA2A (DNAM, NAME, CLASS, SEQ, PTYPE, DVOL, USID)
      QUSID = USID
C                                       Loop for all seq numbers
 10   CONTINUE
         DVOL = 0
         SEQ = 0
         USID = QUSID
         NSUB = 1
         CNO = 1
         OPER = 'SRCH'
         CALL CATDIR ('SRCN', DVOL, CNO, NAME, CLASS, SEQ, PTYPE,
     *      USID, STAT, WBUFF, IERR)
         IF (IERR.EQ.NOFIND) GO TO 999
            IF (IERR.NE.0) GO TO 980
C                                       Clear ALL status flags!
 20         CONTINUE
               OPER = 'INFO'
               CALL CATDIR ('INFO', DVOL, CNO, NAME, CLASS, SEQ,
     *            PTYPE, USID, STAT, WBUFF, IERR)
               OPER = 'CSTA'
               LCH = STAT.EQ.'REST'
               IF (LCH) GO TO 50
                  LCH = STAT.EQ.'READ'
                  IF (.NOT.LCH) GO TO 30
                     OPER = 'CSTA'
                     CALL CATDIR ('CSTA', DVOL, CNO, NAME, CLASS, SEQ,
     *                   PTYPE, USID, 'CLRD', WBUFF, IERR)
                     IF (IERR.NE.0) GO TO 980
                     GO TO 20
 30               CONTINUE
                     CALL CATDIR ('CSTA', DVOL, CNO, NAME, CLASS, SEQ,
     *                   PTYPE, USID, 'CLWR', WBUFF, IERR)
                     IF (IERR.NE.0) GO TO 980
                     GO TO 20
C                                       Actual file destroy
 50         CALL A2WAWA (NAME, CLASS, SEQ, PTYPE, DVOL, USID, DNAM)
            CALL FILDES (DNAM, F, CNO, STAT, IERR)
            GO TO 10
C                                       Error return
 980  WRITE (MSGTXT,1980) SUBNAM(NSUB), OPER, IERR
      CALL MSGWRT (8)
      CALL PRTNAM (DNAM, 8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('UNSCR: ',A6,2X,A4,' ERROR',I7)
      END

      SUBROUTINE MINIT (OP, LUN, IND, LX, LY, WIN, BUFF, BFSZ, BLKOF,
     *   IERR)
C-----------------------------------------------------------------------
C! intializes IO and pointers for quick-return image IO via MDISK
C# IO-basic Map-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MINIT sets up a special section of FTAB for quick-return, double
C   buffered I/O.  N.B. This routine is designed to read/write images
C   one plane at a time.  One can run the planes together iff the rows
C   are not blocked: i.e. iff NBPS / (LX * 2) < 2.
C   Inputs:
C      OP    C*4   Operation code character string: 'READ','WRIT','UPDT'
C      LUN   I     logical unit number
C      IND   I     pointer to FTAB, returned by ZOPEN
C      LX    I     Number of pixels per line in X-direction for whole
C                  map
C      LY    I     Number of lines in whole plane
C      WIN   I(4)  Xmin,Ymin,Xmax,Ymax defining desired subrectangle in
C                  the current plane
C      BFSZ  I     Size of total available buffer in AIPS bytes
C      BLKOF I     block number, 1 relative, of first map pixel in this
C                  plane of the image
C   Outputs:
C      IERR  I     Error return: 0 => ok
C                             1 -> file not open
C                             2 => input error
C                             7 => Buffer too small
C                             3 => i/o error on initialize
C                             4 => end of file
C                             5 => beginning of medium
C                             6 => end of medium
C   Usage notes: For map i/o the first 16 words in each FTAB entry
C   contain a user table to handle double buffer i/o,  the rest
C   contain system-dependent IO tables.  A "major line" is 1 row or
C   1 sector if more than 1 line fits in a sector.  FTAB user table
C   entries, with offsets from the FIND pointer are:
C      FTAB + 0 =>  LUN using this entry
C             1 =>  No. of major lines transfered per i/o op
C             2 =>  No. of major times a buffer has been acessed
C             3 =>  No. of major lines remaining on disk
C             4 =>  Output index for first pixel in window
C             5 =>  No. pixels to increment for next major line
C             6 =>  Which buffer to use for i/o; -1 => single buffer
C             7 =>  Block offset in file for next operation
C             8 =>
C             9 =>  Block increment in file for each operation
C            10 =>  No. of bytes transferred
C            11 =>  I/O op code
C            12 =>  sum of any buffer numbers needing to be waited upon
C            13 =>  # rows / major line (>= 1)
C            14 =>  # times this major line has been accessed
C            15 =>  # pixels to increment for next row (= LX)
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   LUN, IND, LX, LY, WIN(4), BFSZ, BLKOF, IERR
      REAL      BUFF(*)
C
      LOGICAL   BACK, TAPE
      INTEGER   IOP, NBYTE, JBUF, BLKLX, BLKW1, BLKW3, FBBLK, FIBLK,
     *   DBUF, BYT0, NBLK0, NEX, IBUF, FNX, FYC, IWRITE, IREAD, BFSZ2,
     *   W(4), FUNF, I, ILX, IS2, IS4, MBYTE
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA IWRITE, IREAD /1,2/
C-----------------------------------------------------------------------
C                                       Test OPcode
      IERR = 2
      IF (MOD(DEVTAB(LUN),2).EQ.1) GO TO 999
      IOP = 0
      IF (OP.EQ.'WRIT') IOP = IWRITE
      IF (OP.EQ.'READ') IOP = IREAD
      IF (IOP.NE.0) GO TO 10
         WRITE (MSGTXT,1000) OP
         GO TO 980
C                                       Check for Default WINDOW
 10   IF (WIN(1).LE.0) THEN
         W(1) = 1
         W(2) = 1
         W(3) = LX
         W(4) = LY
         BACK = .FALSE.
      ELSE
         DO 20 I = 1,4
            W(I) = WIN(I)
 20         CONTINUE
C                                       Check for backward read
         BACK = W(2).GT.W(4)
         IF (BACK) THEN
            I = W(4)
            W(4) = W(2)
            W(2) = I
            END IF
C                                       No X-WINDOW allowed on WRITE
         IF ((IOP.EQ.IWRITE) .AND. ((W(1).NE.1) .OR. (W(3).NE.LX)))
     *      GO TO 970
C                                       Check if WINDOW is in bounds
         IF ((W(1).LE.0) .OR. (W(3).GT.LX)) GO TO 970
         IF ((W(2).LE.0) .OR. (W(4).GT.LY)) GO TO 970
         END IF
C                                       Check if file in FTAB
 30   IERR = 1
      IF (LUN.EQ.FTAB(IND)) GO TO 35
          WRITE (MSGTXT,1030) LUN
          GO TO 980
C                                       Is this a tape unit?
C                                       or other non-disk unit
 35   TAPE = (DEVTAB(LUN).NE.0)
      ILX = NBPS / (2 * LX)
      ILX = MAX (ILX, 1)
      IF (TAPE) ILX = 1
      IF ((IOP.EQ.IWRITE) .AND. (MOD(W(2)-1,ILX).NE.0)) GO TO 970
      IF ((IOP.EQ.IWRITE) .AND. (MOD(W(4),ILX).NE.0) .AND.
     *   (W(4).NE.LY)) GO TO 970
C                                       Set up table
      BLKLX = 1 + (2*LX - 1) / NBPS
      BLKW3 = (2*W(3) - 1) / NBPS
      BLKW1 = (2*W(1) - 1) / NBPS
C                                       No. of blocks and bytes to read
      NBLK0 = 1 + BLKW3 - BLKW1
      BYT0  = NBLK0 * NBPS
C                                       No blocking for tapes
      IF (TAPE) BYT0 = LX * 2
C                                       Is buffer large enough
      IERR = 7
      IF (BYT0.LE.BFSZ) GO TO 40
         WRITE (MSGTXT,1035) LX, BFSZ
         GO TO 980
C                                       Can we double buffer
 40   IERR = 0
      IBUF = -1
      NEX = 0
      IS4 = (W(4)-1) / ILX + 1
      IS2 = (W(2)-1) / ILX + 1
      BFSZ2 = BFSZ / 2
C                                      Double buffer
      IF (BYT0.LE.BFSZ2) THEN
         IBUF = 1
C                                       more than 1 line in buffer?
         NEX = (BFSZ2 - BYT0) / (BLKLX * NBPS)
         NEX = MIN (NEX, IS4-IS2)
         END IF
C                                       Fill in table
      FNX   = IND + 1
      FYC   = IND + 3
      FBBLK = IND + 7
      FIBLK = IND + 9
      FTAB(FNX)      = 1 + NEX
      FTAB(IND + 2)  = 1
      FTAB(FYC)      = 1 + IS4 - IS2
      FTAB(IND + 4)  = W(1) - ((BLKW1*NBPS)/2)
      FTAB(IND + 5)  = (BLKLX*NBPS)/2
      FTAB(IND + 6)  = IBUF
      FTAB(IND +12)  = 0
      FTAB(IND +13)  = ILX
      FTAB(IND +14)  = MOD (W(2)-1, ILX) + 1
      FTAB(IND +15)  = LX
C                                        Do some math to calcul
      FTAB(FBBLK) = BLKLX * (IS2 - 1) + BLKW1 + BLKOF
      FTAB(FIBLK) =  BLKLX
      NBYTE = BYT0 + NEX * NBPS * BLKLX
      IF (TAPE) NBYTE = BYT0
      FTAB(IND + 10)  = NBYTE
      FTAB(IND + 11) = IOP
C                                        Modify for backward reading
      IF (BACK) THEN
         FTAB(IND + 4) = FTAB(IND + 4) + NEX * FTAB(IND + 5) +
     *      (ILX - 1) * LX
         FTAB(IND +15) = -LX
         FTAB(IND +14) = ILX - MOD (W(4)-1, ILX)
         FTAB(IND + 5) = - FTAB(IND + 5)
         FTAB(FIBLK) =   - BLKLX
         FTAB(FBBLK) = BLKLX * (IS4 - 1 - NEX) + BLKW1 + BLKOF
         END IF
C                                       Modify for tapes-unblocked
      IF (TAPE) THEN
         FTAB(FNX) = 1
         FTAB(IND + 4) = W(1)
         END IF
C                                       If WRITE issue a dummy write to
C                                       buffer 2
      IF (IOP.EQ.IWRITE) THEN
         JBUF = 2
         MBYTE = 0
         IF (IBUF.EQ.-1) GO TO 999
         CALL ZMIO ('WRIT', LUN, IND, FTAB(FBBLK), MBYTE, BUFF, JBUF,
     *      IERR)
         FTAB(IND+12)  = FTAB(IND+12) + JBUF
C                                       Start first read
      ELSE
         JBUF = 1
         CALL ZMIO ('READ', LUN, IND, FTAB(FBBLK), NBYTE, BUFF, JBUF,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         FTAB(IND+12)  = FTAB(IND+12) + JBUF
C                                       Update block counter
         FTAB(FBBLK) = FTAB(FBBLK) + FTAB(FIBLK) * (1 + NEX)
         FTAB(FYC) = FTAB(FYC) - FTAB(FNX)
C                                       Start 2nd read
         IF ((IBUF.GE.0) .AND. (FTAB(FYC).GT.0)) THEN
            DBUF = 2 + (NBYTE - 1) / 2
            JBUF = 2
C                                       Is this the last read
            FUNF = FTAB(FNX) - FTAB(FYC)
            IF (FUNF.GT.0) THEN
C                                       Yes: forward
               IF (FTAB(FIBLK).GE.0) THEN
                  NBYTE = NBYTE - FUNF*FTAB(FIBLK)*NBPS
C                                       Yes: backward
               ELSE
                  NBYTE = NBYTE + FUNF * FTAB(FIBLK) * NBPS
                  DBUF = DBUF - (FUNF * NBPS * FTAB(FIBLK)) / 2
                  FTAB(FBBLK) = FTAB(FBBLK) - FTAB(FIBLK) * FUNF
                  END IF
               END IF
            CALL ZMIO ('READ', LUN, IND, FTAB(FBBLK), NBYTE, BUFF(DBUF),
     *         JBUF, IERR)
            IF (IERR.NE.0) GO TO 999
            FTAB(IND+12)  = FTAB(IND+12) + JBUF
            FTAB(FBBLK) = FTAB(FBBLK) + FTAB(FIBLK) * (1 + NEX)
            FTAB(FYC) = FTAB(FYC) - FTAB(FNX)
            END IF
C                                       Wait for 1st buffer
         JBUF = 1
         CALL ZWAIT (LUN, IND, JBUF, IERR)
         FTAB(IND+12)  = FTAB(IND+12) - JBUF
         END IF
      GO TO 999
C                                       error messages
 970  WRITE (MSGTXT,1970) OP, WIN, LX, LY
 980  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MINIT: OPCODE ',A4,' INVALID')
 1030 FORMAT ('MINIT: FILE FOR LUN',I4,' NOT OPEN')
 1035 FORMAT ('MINIT: BUFFER TOO SMALL LX =',I5,' BY/PX=2   BUFSZ=',I6)
 1970 FORMAT ('MINIT: OP ',A4,' ERROR IN WIN,LX,LY=',6I6)
      END

      SUBROUTINE ZOPEN (LUN, FIND, IVOL, PNAME, MAP, EXCL, WAIT, IERR)
C-----------------------------------------------------------------------
C! open binary disk files and  TTY devices
C# Z IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2004, 2014, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Open a binary disk file or tty.  Message files, line printers, text
C   files, tape devices, Tektronix devices and TV devices are NOT opened
C   using this routine (see ZMSGOP for message files, ZTOPEN for text
C   files, ZTPOPN for tape devices, ZTKOPN for Tektronix devices and the
C   device specific routine for TV devices, e.g., ZM70OP).  See LPOPEN
C   for a standard way to open line printers.
C   Inputs:
C      LUN     I      Logical unit number
C      IVOL    I      Disk volume containing file, 1,2,3,...
C      PNAME   C*48   Physical file name (from ZPHFIL)
C      MAP     L      Is this a "map" file?
C      EXCL    L      Exclusive use requested?
C      WAIT    L      Wait for exclusive use?
C   Output:
C      FIND    I      Index in FTAB to file control block for LUN
C      IERR    I      Error return code: 0 => no error
C                        1 => LUN already in use
C                        2 => file not found
C                        3 => volume/logical not found
C                        4 => exclusive use denied
C                        5 => no room for LUN in FTAB
C                        6 => other open errors
C   Generic version - uses ZDAOPN, ZLPOPN, ZTTOPN
C   No longer opens TV devices as of the 15MAR84 release.
C   No longer opens tape devices as of the 15APR87 release.
C   No longer opens Tektronix devices as of the 15OCT87 release.
C   No longer opens text files as of the 15OCT87 release.
C   No longer opens line printers as of the 15JAN91 release.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IVOL, IERR
      CHARACTER PNAME*(*)
      LOGICAL   MAP, EXCL, WAIT
C
      INTEGER   JERR, ERRLUN, ERRTER, FCBOFF, IMAP, IEXCL, DELMAX,
     *   DELCNT, DLMAX2, DLCNT2, I, J
      REAL      TDELAY
      HOLLERITH ANAME(12)
      LOGICAL   IAMOK
      CHARACTER CTEMP*2
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE 'INCS:DDRC.INC'
      DATA ERRLUN, ERRTER, TDELAY, DELMAX, DLMAX2 /12, 6, 1.0, 30, 60/
C-----------------------------------------------------------------------
C                                       Check inputs.
      IERR = 6
C                                       Valid LUN?
      IF ((LUN.NE.ERRLUN) .AND. (LUN.NE.ERRTER) .AND. (LUN.GT.0) .AND.
     *   (LUN.LE.120)) GO TO 10
         WRITE (MSGTXT,1000) LUN
         GO TO 995
C                                       Does not handle TVs
 10   IF (DEVTAB(LUN).NE.4) GO TO 20
         WRITE (MSGTXT,1010)
         GO TO 995
C                                       Does not handle text files
 20   IF (DEVTAB(LUN).NE.3) GO TO 30
         WRITE (MSGTXT,1020)
         GO TO 995
C                                       Does not handle Tektronix I/O
 30   IF (LUN.NE.7) GO TO 40
         WRITE (MSGTXT,1030)
         GO TO 995
C                                       Does not handle tapes
 40   IF ((DEVTAB(LUN).NE.2) .AND. (PNAME(1:2).NE.'MT')) GO TO 50
         IF (LUN.EQ.1) GO TO 50
         WRITE (MSGTXT,1040) LUN
         IF (PNAME(1:2).EQ.'MT') WRITE (MSGTXT,1041)
         GO TO 995
C                                       Allocate area in FTAB for LUN.
 50   IF ((LUN.EQ.5) .AND. (DEVTAB(5).EQ.1)) GO TO 80
      CALL LSERCH ('OPEN', LUN, FIND, MAP, JERR)
      IF (JERR.EQ.0) GO TO 60
C                                       LUN already in use.
         IF (JERR.EQ.2) THEN
            IERR = 1
            WRITE (MSGTXT,1051) LUN
C                                       No room in FTAB for LUN.
         ELSE IF (JERR.EQ.3) THEN
            IERR = 5
            WRITE (MSGTXT,1052) LUN
         ELSE
            WRITE (MSGTXT,1050) JERR, 'OPEN', LUN, MAP
            END IF
         GO TO 995
C                                       Ok, so far.
 60   IERR = 0
      DELCNT = 0
      DLCNT2 = 0
C                                       Set integer map, exclusive use
      IMAP = 0
      IF (MAP) IMAP = 1
      IEXCL = 0
      IF (EXCL) IEXCL = 1
C                                       Disk file requiring map or non-
C                                       map file control block in FTAB?
      IF (DEVTAB(LUN).NE.0) GO TO 80
C                                       Determine offset in FTAB for the
C                                       file control block.
         IF (MAP) THEN
            FCBOFF = FIND + MOFF
         ELSE
            FCBOFF = FIND + NMOFF
            END IF
C                                       Volume (disk) number in range?
         IF ((IVOL.GT.0) .AND. (IVOL.LE.NVOL)) GO TO 65
            IERR = 3
            WRITE (MSGTXT,1060) IVOL
            GO TO 900
C                                       Check privilege
 65      I = INDEX (PNAME, ':')
         IF (I.GT.0) THEN
            CTEMP = PNAME(I+1:)
            IF (.NOT.IAMOK(IVOL,CTEMP)) THEN
               WRITE (MSGTXT,1065) CTEMP, IVOL, NLUSER
               IERR = 2
               GO TO 900
               END IF
            END IF
C                                       Open disk file.
 70      CALL CHR2H (48, PNAME, 1, ANAME)
C                                       no exclusive if read only
         IF (DSKLOK(IVOL).EQ.1) IEXCL = -1
         CALL ZDAOPN (FTAB(FCBOFF), ANAME, IMAP, IEXCL, IERR)
         IF (IERR.EQ.0) GO TO 100
C                                       File not found?
            IF (IERR.EQ.2) THEN
               WRITE (MSGTXT,1070) PNAME(1:24)
C                                       Volume not found?
            ELSE IF (IERR.EQ.3) THEN
               WRITE (MSGTXT,1071) PNAME(1:28)
C                                       File busy?
            ELSE IF (IERR.EQ.4) THEN
C                                       Wait and try again every TDELAY
C                                       seconds up to DELMAX*DLMAX2
C                                       times.  Issue a message every
C                                       DLMAX2 wait.
               IF (.NOT.WAIT) GO TO 73
                  DELCNT = DELCNT + 1
                  IF (DELCNT.LE.DELMAX) THEN
                     CALL ZDELAY (TDELAY, IERR)
                  ELSE
                     DLCNT2 = DLCNT2 + 1
                     IF (DLCNT2.GT.DLMAX2) GO TO 73
                        DELCNT = 0
                        WRITE (MSGTXT,1072) PNAME(1:24)
                        CALL MSGWRT (2)
                     END IF
                  GO TO 70
 73            WRITE (MSGTXT,1073) PNAME(1:24)
C                                       Other open error.
            ELSE
               CALL ZERROR ('ZDAOPN', FTAB(FCBOFF+FCBERR), PNAME,
     *            FTAB(FCBOFF), MAP)
               GO TO 910
               END IF
            GO TO 900
C                                       Open a Fortran device here.
 80   IF (DEVTAB(LUN).NE.1) GO TO 999
C                                       Printer?
         IF (LUN.EQ.1) THEN
            MSGTXT = 'ZOPEN: DOES NOT OPEN THE LINE PRINTER AS OF ' //
     *         '15JAN91'
            IERR = 6
            GO TO 900
C                                       Terminal?
         ELSE IF (LUN.EQ.5) THEN
            CALL ZTTOPN (LUN, FIND, IERR)
            IF (IERR.EQ.0) GO TO 100
               IF (FTAB(FIND+1+NFCBER).GT.0) CALL ZERROR ('ZTTOPN',
     *            FTAB(FIND+1+NFCBER), ' ', -999, .FALSE.)
               WRITE (MSGTXT,1080) IERR
               IERR = 6
               GO TO 900
C                                       Invalid DEVTAB(LUN).
         ELSE
            WRITE (MSGTXT,1090) LUN, DEVTAB(LUN)
            IERR = 6
            END IF
         GO TO 900
C                                       store file name
 100  CALL FSERCH (FIND, I, J, JERR)
      IF (JERR.EQ.0) THEN
         IF (I.EQ.1) DEVNAM(J) = PNAME
         IF (I.EQ.2) NONNAM(J) = PNAME
         IF (I.EQ.3) MAPNAM(J) = PNAME
      ELSE
         WRITE (MSGTXT,1100) FIND, JERR
         CALL MSGWRT (6)
         END IF
      GO TO 999
C                                       Error
 900  CALL MSGWRT (6)
C                                       Remove FTAB entry for LUN.
 910  IF (FIND.LE.0) GO TO 999
      CALL LSERCH ('CLOS', LUN, FIND, MAP, JERR)
      IF (JERR.EQ.0) GO TO 999
         IERR = IERR + 2
         WRITE (MSGTXT,1050) JERR, 'CLOS', LUN, MAP
C
 995  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZOPEN: INVALID LUN =',I5)
 1010 FORMAT ('ZOPEN: DOES NOT PERFORM TV OPENS AS OF 15MAR84')
 1020 FORMAT ('ZOPEN: DOES NOT PERFORM TEXT FILE OPENS AS OF 15OCT87')
 1030 FORMAT ('ZOPEN: DOES NOT PERFORM TEKTRONIX OPENS AS OF 15OCT87')
 1040 FORMAT ('ZOPEN: DOES NOT PERFORM DEVICE OPENS; LUN =',I5)
 1041 FORMAT ('ZOPEN: DOES NOT PERFORM TAPE OPENS AS OF 15APR87')
 1050 FORMAT ('ZOPEN: LSERCH ERROR ',I2,' ON ',A4,' LUN =',I3,
     *   ' MAP = ',L1)
 1051 FORMAT ('ZOPEN: LUN =',I4,' ALREADY OPENED IN FTAB')
 1052 FORMAT ('ZOPEN: NO ROOM IN FTAB FOR LUN =',I4)
 1060 FORMAT ('ZOPEN: VOLUME NUMBER = ',I6,' OUT OF RANGE')
 1065 FORMAT ('ZOPEN: ',A2,' FILES ON DISK',I3,' NOT ALLOWED FOR USER',
     *   I5)
 1070 FORMAT ('ZOPEN: FILE ',A24,' NOT FOUND')
 1071 FORMAT ('ZOPEN: TROUBLE FINDING PATH TO FILE ',A)
 1072 FORMAT ('ZOPEN: STILL WAITING FOR LOCKED FILE ',A24)
 1073 FORMAT ('ZOPEN: FILE ',A24,' NOT AVAILABLE: LOCKED')
 1080 FORMAT ('ZOPEN: ZTTOPN RETURNS ERROR',I5)
 1090 FORMAT ('ZOPEN: INVALID DEVTAB(',I2,') = ',I1)
 1100 FORMAT ('ZOPEN WARNING: FIND =',I5,' FSERCH ERR=',I5)
      END

      SUBROUTINE FRQUPD (DISKIN, CNOIN, GUSE, IANT, TIME, CVLSOU, ISUB,
     *   IFQ, CATIN, CLSORT, FRQOFF, IRET)
C-----------------------------------------------------------------------
C! Examines CL table or FO table for frequency offsets.
C# Table IO-appl Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2009, 2011-2013, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to obtain the freq. offset (if any) stored in the CL table.
C   Uses call to TABIO directly rather than TABCAL for efficiency.
C   Will use an FO table if present in preference to the CL table.
C   Inputs:
C      DISKIN   I        Volume number
C      CNOIN    I        File catalogue number
C      GUSE     I        Version number of CL table to use
C      IANT     I        Antenna number - must be > 0
C      TIME     R        Time of visibility record (days)
C      CVLSOU   I        Source number (from common /CVELCM/)
C      ISUB     I        Subarray desired: <= 0 -> all
C      IFQ      I        Frequency ID desired: <= 0 -> all
C      CATIN    I(256)   Catalogue header
C   Input from common /CURCL/
C      CURXLT   D(*)     Time of current CL entry for each antenna
C      CURXLI   R(*)     Interval of current CL entry
C      CURLOO   R(*)     Current lo-offset for each antenna
C      CURRNO   I(*)     Current CL record number for each antenna
C   Input/output:
C      CLSORT   L        True if CL table already sorted and opened
C                        if false, sorted no matter what the header
C                        says about the sort order
C   Outputs:
C      FRQOFF   D(*)     Freq. offset (Hz) - for each if
C      IRET     I        Error flag: = 0 => OK, -1 not found
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   DISKIN, CNOIN, GUSE, IANT, CVLSOU, ISUB, IFQ,
     *   CATIN(256), IRET
      REAL      TIME
      DOUBLE PRECISION FRQOFF(MAXIF)
      LOGICAL   CLSORT
C
      INTEGER   IFNO, TIMKOL, SOUKOL, ANTKOL, DOPKOL, INTKOL, SUBKOL,
     *   FQKOL, NKEY, NREC, REC2(XCLRSZ), IFOFF, I, J, IPOINT, LIMIT,
     *   NCOL, MLOCIF, DATP(128,2), NUMIF, KOLS(7), KEY(2,2), NUMCLT,
     *   CATBLK(256), KEYSUB(2,2), JANT, LSTSOU, LUSE
      REAL      TIMLOW, TIMHI, REC4(XCLRSZ), FKEY(2,2), TINTER
      DOUBLE PRECISION REC8(XCLRSZ/2), TLAST
      HOLLERITH CATH(256)
      LOGICAL   T, F, NOCL
      CHARACTER COLHED(7)*24, CHIF*8, INEXT*2
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCVL.INC'
      EQUIVALENCE (REC2, REC4, REC8)
      EQUIVALENCE (TIMKOL,XLKOLS(1)),  (INTKOL,XLKOLS(2)),
     *   (SOUKOL,XLKOLS(3)), (ANTKOL,XLKOLS(4)), (SUBKOL,XLKOLS(5)),
     *   (FQKOL,XLKOLS(6)), (DOPKOL,XLKOLS(7))
      EQUIVALENCE (CATBLK, CATH)
      SAVE NOCL, TINTER
      DATA T, F /.TRUE., .FALSE./
      DATA COLHED /'TIME', 'TIME INTERVAL', 'SOURCE ID', 'ANTENNA NO.',
     *   'SUBARRAY', 'FREQ ID', 'DOPPOFF'/
      DATA FKEY /1.0,0.0,1.0,0.0/
      DATA KEYSUB /4*1/
      DATA CHIF /'IF'/
      DATA TINTER /-1.0/
C-----------------------------------------------------------------------
      CALL COPY (256, CATIN, CATBLK)
      CALL AXEFND (8, CHIF, CATBLK(KIDIM), CATH(KHCTP), MLOCIF, IRET)
      NUMIF = 1
      IF ((MLOCIF.GT.0) .AND. (IRET.EQ.0)) NUMIF = CATBLK(KINAX+MLOCIF)
C                                       Open CL?
      IF (.NOT.CLSORT) THEN
         NOCL = F
         INEXT = 'FO'
         CALL FNDEXT (INEXT, CATBLK, NUMCLT)
         IF (NUMCLT.LE.0) THEN
            INEXT = 'CL'
            CALL FNDEXT (INEXT, CATBLK, NUMCLT)
            END IF
         IF (NUMCLT.EQ.0) NOCL = T
         IF (NOCL) GO TO 999
C                                       Initialize
         CALL FILL (MAXANT, 0, CURRNO)
C                                       Sort CL table if needed
         ICXLUN = 49
         NKEY = 0
         NREC = 0
         NCOL = 0
         IXLRNO = 1
         LUSE = MIN (GUSE, NUMCLT)
         CALL TABINI ('READ', INEXT, DISKIN, CNOIN, LUSE, CATBLK,
     *      ICXLUN, NKEY, NREC, NCOL, DATP, XLBUFF, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1005) IRET, 'CL', LUSE
            GO TO 990
            END IF
C                                       Get number of scans
         NXLINR = XLBUFF(5)
C                                       Check if empty
         IF (NXLINR.LE.0) THEN
            WRITE (MSGTXT,1010) INEXT
            IRET = 1
            GO TO 990
            END IF
C                                       Get column pointers
         NKEY = 7
         CALL FNDCOL (NKEY, COLHED, 24, .TRUE., XLBUFF, KOLS, IRET)
         IF ((IRET.GE.1) .AND. (IRET.LE.10)) GO TO 999
         IRET = 0
         CALL FILL (NKEY, 0, XLKOLS)
         CALL FILL (NKEY, 0, XLNUMV)
         DO 20 J = 1,NKEY
            IPOINT = KOLS(J)
            IF (IPOINT.NE.0) THEN
               XLKOLS(J) = DATP(IPOINT,1)
               XLNUMV(J) = DATP(IPOINT,2) / 10
               END IF
 20         CONTINUE
C                                       check for non-zero DOPOFF
         DO 40 I = 1,NXLINR
            IXLRNO = I
            CALL TABIO ('READ', 0, IXLRNO, REC2, XLBUFF, IRET)
            IF (IRET.LT.0) THEN
               IRET = 0
            ELSE IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, INEXT
               GO TO 990
            ELSE
               DO 30 IFNO = 1,NUMIF
                  IF (REC4(DOPKOL+IFNO-1).NE.0.0) GO TO 50
 30               CONTINUE
               END IF
 40         CONTINUE
         CALL TABIO ('CLOS', 0, IXLRNO, XLBUFF, XLBUFF, IRET)
         MSGTXT = 'All Doppler offsets are zero'
         CALL MSGWRT (2)
         CLSORT = .TRUE.
         NOCL = .TRUE.
         IRET = 0
         GO TO 999
C                                       SORT: ignore claimed order
 50      KEY(1,1) = KOLS(1)
         KEY(2,1) = 0
         KEY(1,2) = KOLS(4)
         KEY(2,2) = 0
C                                       Close table
         CALL TABIO ('CLOS', 0, IXLRNO, XLBUFF, XLBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Sort
         CALL TABSRT (DISKIN, CNOIN, INEXT, GUSE, GUSE, KEY, KEYSUB,
     *      FKEY, XLBUFF, CATBLK, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1030) IRET, INEXT
            GO TO 990
            END IF
         CLSORT = .TRUE.
C                                       Open calibration table
C                                       for use in FRQUPD
         NKEY = 0
         NREC = 0
         NCOL = 0
         IXLRNO = 1
         NOCL = F
         CALL TABINI ('READ', INEXT, DISKIN, CNOIN, GUSE, CATBLK,
     *      ICXLUN, NKEY, NREC, NCOL, DATP, XLBUFF, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1005) IRET, INEXT, GUSE
            NOCL = T
            GO TO 999
            END IF
         WRITE (MSGTXT,1130) INEXT, GUSE
         CALL MSGWRT (4)
C                                       Get number of scans
         NXLINR = XLBUFF(5)
C                                       Check if empty
         IF (NXLINR.LE.0) THEN
            WRITE (MSGTXT,1010) INEXT
            CALL MSGWRT (8)
            NOCL = T
            END IF
         END IF
C                                       Set frqoff to a default
      DO 80 IFNO = 1,NUMIF
         FRQOFF(IFNO) = 0.D0
 80      CONTINUE
C
      IF (NOCL) GO TO 999
C                                       do we know the interval?
      IF (TINTER.LE.0.0) THEN
         JANT = IANT
 90      TLAST = -1.0D0
         LSTSOU = -1
         DO 100 I = 1,NXLINR
            IXLRNO = I
            CALL TABIO ('READ', 0, IXLRNO, REC2, XLBUFF, IRET)
            IF (IRET.LT.0) THEN
               IRET = 0
            ELSE IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, INEXT
               GO TO 990
            ELSE IF (REC4(INTKOL).GT.0.0) THEN
               TINTER = REC4(INTKOL)
               GO TO 170
            ELSE
               IF (JANT.LE.0) JANT = REC2(ANTKOL)
               IF (JANT.EQ.REC2(ANTKOL)) THEN
                  IF (LSTSOU.NE.REC2(SOUKOL)) THEN
                     TLAST = REC8(TIMKOL)
                     LSTSOU = REC2(SOUKOL)
                  ELSE
                     IF (REC8(TIMKOL)-TLAST.GT.TINTER) TINTER =
     *                  REC8(TIMKOL) - TLAST
                     TLAST = REC8(TIMKOL)
                     END IF
                  END IF
               END IF
 100        CONTINUE
         IF (TINTER.LE.0.0) THEN
            IF (IANT.EQ.JANT) THEN
               JANT = 0
               GO TO 90
            ELSE
               TINTER = 1.0 / (60.0 * 24.0)
               END IF
            END IF
         END IF
C                                       Do we need to look through table
 170  IF (CURRNO(IANT).GT.0) THEN
         IF (TIME.LE.(CURXLT(IANT) + 0.5*CURXLI(IANT))) THEN
            DO 175 IFNO = 1, NUMIF
               FRQOFF(IFNO) = CURLOO(IANT,IFNO)
 175           CONTINUE
            GO TO 999
            END IF
         END IF
C                                       Read until selected time.
      IF (CURRNO(IANT).LE.0) THEN
         LIMIT = 1
      ELSE
         LIMIT = CURRNO(IANT)
         END IF
      DO 200 I = LIMIT,NXLINR
         IXLRNO = I
         CALL TABIO ('READ', 0, IXLRNO, REC2, XLBUFF, IRET)
         IF (IRET.LT.0) THEN
            IRET = 0
            GO TO 200
         ELSE IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, INEXT
            GO TO 990
            END IF
C                                       make sure interval reasonable
         REC4(INTKOL) = MAX (TINTER, REC4(INTKOL))
C                                       leave if this is not good
C                                       independent of antenna,source
         IF (REC8(TIMKOL)-REC4(INTKOL)/2.GT.TIME) GO TO 220
C                                       See if correct source
         IF (REC2(SOUKOL).NE.CVLSOU) GO TO 200
C                                       See if correct antenna
         JANT = REC2(ANTKOL)
         IF (JANT.NE.IANT) GO TO 200
C                                       check subarray
         IF ((REC2(SUBKOL).GT.0) .AND. (ISUB.GT.0) .AND.
     *      (REC2(SUBKOL).NE.ISUB)) GO TO 200
C                                       check freqid
         IF ((REC2(FQKOL).GT.0) .AND. (IFQ.GT.0) .AND.
     *      (REC2(FQKOL).NE.IFQ)) GO TO 200
C                                       Check time
         TIMLOW = REC8(TIMKOL) - (REC4(INTKOL)/2.0)
         TIMHI  = REC8(TIMKOL) + (REC4(INTKOL)/2.0)
         IF ((TIME.LE.TIMHI) .AND. (TIME.GE.TIMLOW)) THEN
            CURXLT(JANT) = REC8(TIMKOL)
            CURXLI(JANT) = REC4(INTKOL)
            CURRNO(JANT) = IXLRNO
C                                       Loop over IF
            DO 180 IFNO = 1,NUMIF
               IFOFF = IFNO - 1
               FRQOFF(IFNO) = REC4(DOPKOL+IFOFF)
               CURLOO(JANT,IFNO) = REC4(DOPKOL+IFOFF)
 180           CONTINUE
            GO TO 999
            END IF
 200     CONTINUE
C                                       did we find it
 220  IRET = -1
      IF (CURRNO(IANT).GT.0) THEN
         IF (TIME.LE.(CURXLT(IANT) + 0.5*CURXLI(IANT))) THEN
            DO 230 IFNO = 1, NUMIF
               FRQOFF(IFNO) = CURLOO(IANT,IFNO)
 230           CONTINUE
            IRET = 0
            END IF
         END IF
      GO TO 999
C                                       Error?
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1005 FORMAT ('FRQUPD: ERROR',I3,' OPENING ',A2,' TABLE, VERSION',I5)
 1010 FORMAT ('FRQUPD: EMPTY ',A,' TABLE')
 1030 FORMAT ('FRQUPD: ERROR',I3,' SORTING ',A,' TABLE')
 1000 FORMAT ('FRQUPD: ERROR',I3,' READING ',A,' TABLE')
 1130 FORMAT ('Using ',A,' table ',I3,' to obtain time dependent freq',
     *   ' offsets')
      END

      SUBROUTINE QCLNSU (COMP, LMAP, L1MAP, L2MAP, IBX, IBY, JNDEX,
     *   INDEX)
C-----------------------------------------------------------------------
C! Alliant Pseudo AP routine:  Low level Clark CLEAN routine
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   QCLNSU does a CLEAN on a list of residuals using a given beam
C   patch
C   Inputs:
C      COMP     R(4)  Component vector:
C                     0 => intensity
C                     1 => x in cells
C                     2 => Y in cells
C                     3 => CLEAN loop gain (fractional)
C      LMAP     I    number of residuals
C      L1MAP    I    First residual in Y window
C      L2MAP    I    Last residual in Y window
C      IBX,IBY  I    Beam patch half width in X and Y
C                    Residuals with delta X or Y from the component
C                    position in COMP .GE. IBX,IBY are to be ignored.
C      JNDEX    I    0 - rel Index in FLUX, IX, IY of next residual
C                    to sub.
C   Input From Vector Work common:
C      IWVEC3   I    = IX, X pixel location of residuals
C      IWVEC4   I    = IY, Y pixel location of residuals
C      WKVEC5   R    = FLUX, Residual flux density
C      WKVEC6,7 R    = BEAM, BEAM patch.
C   Output:
C      INDEX    I    Index in FLUX of next residual.
C   Useage notes:
C     The following common work vectors are used:
C      IWVEC8   = IDXRAY  => array of x pixel offsets
C      IWVEC9   = IB      => indirect address array
C
C   Alliant version (same as Convex version).
C-----------------------------------------------------------------------
      INTEGER  	ISAMAX, KMAX, INCX, IDXRAY(1), IB(1), IX(1), IY(1)
      INTEGER  	L21MAP, NIB, JNDEX
      INTEGER   LMAP, IBX, IBY, L1MAP, L2MAP, INDEX, BOFF, BEMADR,
     *   LROW, ADDR, LOOP, XCOMP, YCOMP
      REAL      SUBT, COMP(4), BEAM(1), FLUX(1)
      INCLUDE 'INCS:DAPC.INC'
      EQUIVALENCE (IX, IWVEC3), (IY, IWVEC4), (FLUX, WKVEC5),
     *   (BEAM, WKVEC6)
      EQUIVALENCE (IDXRAY, IWVEC8), (IB, IWVEC9)
C-----------------------------------------------------------------------
      LROW = 2 * IBY - 1
      BOFF = (IBX-1) * LROW + IBY
      IF (LMAP.LE.0) GO TO 999
C                                        Get component to be CLEANed
      XCOMP = COMP(2) + 0.5
      YCOMP = COMP(3) + 0.5
      SUBT = COMP(1) * COMP(4)
C					Get residual offsets
      INCLUDE 'INCS:ZVND.INC'
      DO 100 LOOP = L1MAP,L2MAP
         IDXRAY(LOOP) = IX(LOOP+JNDEX) - XCOMP
 100     CONTINUE
C                                        Compress x window
      L21MAP = L2MAP - L1MAP + 1
      CALL WHNALT (L21MAP, IDXRAY(L1MAP), 1, IBX, IB, NIB)
C                                        Subtraction loop
      INCLUDE 'INCS:ZVND.INC'
      DO 200 LOOP = 1,NIB
         ADDR = IB(LOOP) + L1MAP - 1
C                                        Get beam address
         BEMADR = BOFF + (IDXRAY(ADDR) * LROW)
     *      + (IY(ADDR+JNDEX) - YCOMP)
         FLUX(ADDR+JNDEX) = FLUX(ADDR+JNDEX) - SUBT * BEAM(BEMADR)
 200     CONTINUE
C                                        Find largest mag. residual
      INCX = 1
C                                       Call Alliant provided Linpack
C                                       routine = ISAMAX.
      KMAX = ISAMAX (LMAP, FLUX(1+JNDEX), INCX)
      COMP(1) = FLUX (KMAX+JNDEX)
      COMP(2) = IX(KMAX+JNDEX)
      COMP(3) = IY(KMAX+JNDEX)
C                                        Save index of next max.
      INDEX = KMAX
C
 999  RETURN
      END

LOCAL INCLUDE 'FGSPW.INC'
C                                       Local include for FGSPW
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4,30), XCALC(1)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XSUBA, XBIF, XEIF, XBCHAN, XECHAN, XDOCAL, XGUSE, XDOPOL,
     *   XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH(3), XOUTFG,
     *   SOLINT, APARM(10), BADD(10),    BUFF1(UVBFSS), BUFF2(UVBFSS)
      INTEGER   SEQIN, DISKIN, NUMHIS, JBUFSZ, ILOCWT, CATOLD(256),
     *   INCSI, INCFI, INCIFI, NRPRMI, OLDCNO, FGVERO, NANT, NIF, NPOL,
     *   NCHAN, IDSOUR, NFLAGS, MFLAGS(4,MAXIF), INSOU,
     *   SCRBUF(256), IBUFF1(UVBFSS), IBUFF2(UVBFSS)
      CHARACTER NAMEIN*12, CLAIN*6, TTIME(2)*12
      EQUIVALENCE (IBUFF1, BUFF1), (IBUFF2, BUFF2)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XTIME, XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF, XBCHAN, XECHAN,
     *   XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER,
     *   XSMOTH, XOUTFG, SOLINT, APARM, BADD
      COMMON /FGSPWP/ CATOLD, SEQIN, DISKIN, NUMHIS, ILOCWT, INCSI,
     *   INCFI, INCIFI, NRPRMI, OLDCNO, FGVERO, NANT, NIF, NPOL, NCHAN,
     *   IDSOUR, NFLAGS, MFLAGS, INSOU
      COMMON /CHARPM/ NAMEIN, CLAIN, TTIME
      COMMON /BUFRS/ SCRBUF, BUFF1, BUFF2, JBUFSZ
C                                       End local include for FGSPW
LOCAL END
      PROGRAM FGSPW
C-----------------------------------------------------------------------
C! Flags bad spectral windows
C# Utility UV UV-util VLA VLB Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2017-2018, 2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FGSPW flags bad spectral wondows ("IFs")
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C   full set of calibration adverbs
C      OUTFGVER
C      APARM(10)      APARM         User specified array.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      DOUBLE PRECISION CATD(128)
      INCLUDE 'FGSPW.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATD)
      DATA PRGM /'FGSPW '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL FGSPIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL FGSPUV (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL FGSPHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE FGSPIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   FGSPIN gets input parameters for FGSPW
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in FGSPW for more details.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, NFREQ, LUN, TIME(3),
     *   DATE(3)
      LOGICAL   MATCH
      REAL      CATR(256), RPARM(20), VIS(20)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'FGSPW.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      DATA BLANK  /' '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 178
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      STOKES = 'FULL'
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      FGVERO = XOUTFG + 0.1
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      DATE(1) = -DATE(1)
      CALL TIMDAT (TIME, DATE, TTIME(2), TTIME)
      SOLINT = SOLINT / 60.0 / 24.0
      IF (SOLINT.LE.0.0) SOLINT = 10.
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       flag versions
      CALL FNDEXT ('FG', CATBLK, I)
      IF ((FGVER.EQ.0) .OR. (FGVER.GT.I)) FGVER = I
      IF ((FGVERO.LE.0) .OR. (FGVERO.GT.I)) FGVERO = I + 1
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NFREQ = CATBLK(KINAX+JLOCF)
      BCHAN = IROUND (XBCHAN)
      ECHAN = IROUND (XECHAN)
      IF ((BCHAN.LE.0) .OR. (BCHAN.GT.NFREQ)) BCHAN = 1
      IF ((ECHAN.LE.0) .OR. (ECHAN.GT.NFREQ)) ECHAN = NFREQ
      IF (BCHAN.GT.ECHAN) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, VIS, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, VIS, IERR)
      INSOU = 0
      IF ((DOSWNT) .AND. (NSOUWD.EQ.1)) INSOU = SOUWAN(1)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
c      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
c     *   PTYPE, NLUSER, 'WRIT', SCRBUF, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FGSPIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE FGSPUV (IRET)
C-----------------------------------------------------------------------
C   FGSPUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'FGSPW.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      INTEGER   IA1, IA2, IIF, IP, LUN, LFGRNO, LIF, LRET, LSOU
      LOGICAL   T, F
      REAL      VIS(UVBFSS), RPARM(20), SCANV(MAXANT,MAXANT,MAXIF,4),
     *   TIME(2), FLUX(MAXIF)
      LOGICAL   PFLAGS(4), ISFLAG
      CHARACTER REASON*24
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN /48/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT IO TO INPUT UV DATA SET'
         GO TO 990
         END IF
      NPOL = CATBLK(KINAX+JLOCS)
      NIF = CATBLK(KINAX+JLOCIF)
      NCHAN = CATBLK(KINAX+JLOCF)
      NANT = 0
      NFLAGS = 0
      CALL FILL (4*MAXIF, 0, MFLAGS)
      WRITE (REASON,1010) TSKNAM, TTIME
      RPARM(1) = FBLANK
      CALL RFILL (MAXIF, 1.0, FLUX)
C                                       Loop
C                                       Read vis. record.
 100  CALL SCANAV (RPARM, VIS, TIME, SCANV, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'AVERAGING SCAN DATA'
         GO TO 990
C                                       check values
      ELSE
C                                       scaling
         IF ((IDSOUR.NE.LSOU) .AND. (APARM(4).GT.0.0))
     *      CALL GTFLUX (IDSOUR, DISKIN, OLDCNO, CATOLD, FLUX)
         LSOU = IDSOUR
         LRET = IRET
         DO 150 IA1 = 1,NANT-1
            DO 140 IA2 = IA1+1,NANT
               DO 130 IIF = 1,NIF
                  LIF = IIF + BIF - 1
                  ISFLAG = .FALSE.
                  DO 120 IP = 1,NPOL
                     PFLAGS(IP) = SCANV(IA1,IA2,IIF,IP).GT.
     *                  APARM((IP+1)/2) * FLUX(LIF)
                     ISFLAG = ISFLAG .OR. PFLAGS(IP)
 120                 CONTINUE
                  IF (ISFLAG) THEN
                     IF (APARM(3).GT.0) CALL LFILL (4, .TRUE., PFLAGS)
                     CALL FLAGIT ('FLAG', LUN, DISKIN, OLDCNO, FGVER,
     *                  FGVERO, LFGRNO, FGKOLS, FGNUMV, IDSOUR, SUBARR,
     *                  FRQSEL, IA1, IA2, TIME(1), TIME(2), LIF, LIF,
     *                  1, 0, PFLAGS, REASON, CATOLD, IBUFF1, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'WRITE FG TABLE'
                        GO TO 990
                        END IF
                     NFLAGS = NFLAGS + 1
                     DO 125 IP = 1,NPOL
                        IF (PFLAGS(IP)) MFLAGS(IP,IIF) = MFLAGS(IP,IIF)
     *                     + 1
 125                    CONTINUE
                     END IF
 130              CONTINUE
 140           CONTINUE
 150        CONTINUE
         IF (LRET.EQ.0) THEN
            GO TO 100
         ELSE
            WRITE (MSGTXT,1100) NFLAGS
            CALL MSGWRT (5)
            DO 170 IIF = 1,NIF
               DO 165 IP = 1,NPOL
                  IF (MFLAGS(IP,IIF).GT.0) THEN
                     LIF = IIF + BIF - 1
                     WRITE (MSGTXT,1150) MFLAGS(IP,IIF), IP, LIF
                     CALL MSGWRT (4)
                     END IF
 165              CONTINUE
 170           CONTINUE
            CALL FLAGIT ('CLOS', LUN, DISKIN, OLDCNO, FGVER, FGVERO,
     *         LFGRNO, FGKOLS, FGNUMV, IDSOUR, SUBARR, FRQSEL, IA1, IA2,
     *         TIME(1), TIME(2), IIF, IIF, 1, 0, PFLAGS, REASON, CATOLD,
     *         IBUFF1, IRET)
            END IF
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FGSPUV: ERROR',I3,' ON ',A)
 1010 FORMAT (A6,A9,1X,A8)
 1100 FORMAT ('Wrote',I10,' flag commands')
 1150 FORMAT ('Wrote',I6,' for pol',I2,' IF',I3)
      END
      SUBROUTINE SCANAV (RPARM, VIS, TIME, SCANV, IRET)
C-----------------------------------------------------------------------
C   Computes scan average scalar amplitude averaging over time and
C   spectral channel within each IF
C   Input
C      SOLINT   R        Max integration time (days)
C   Input/output:
C      RPARM    R(*)     Random parameters
C      VIS      R(3,*)   Visibility data
C      ISOU     I        source number: -1 => ignore source
C   Outputs:
C      TIME     R(2)     Start and stop times of data
C      SCANV    R(*)     Average data
C      IRET     I        Error code: -1 => end of data
C-----------------------------------------------------------------------
      INCLUDE 'FGSPW.INC'
      INTEGER   IRET
      REAL      RPARM(*), VIS(3,*), TIME(2),
     *   SCANV(MAXANT,MAXANT,MAXIF,*)
C
      INTEGER   IA1, IA2, I, COUNT(MAXANT,MAXANT,MAXIF,4), SCANUM,
     *   INDEXI, JF, JIF, JS
      LOGICAL   DONE1, GOTDAT
      REAL      BASEN, TT, AMP, WT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      DONE1 = RPARM(1).NE.FBLANK
      GOTDAT = .FALSE.
C                                       clear arrays
 10   I = MAXANT * MAXANT * MAXIF * 4
      CALL RFILL (I, 0.0, SCANV)
      CALL FILL (I, 0, COUNT)
      TIME(1) = 1.E10
      TIME(2) = -1.E10
C                                       Save scan number (0= no index)
      SCANUM = INXRNO
C                                       Loop reading data
 100  IF (.NOT.DONE1) THEN
         CALL UVGET ('READ', RPARM, VIS, IRET)
         IF (IRET.GT.0) GO TO 999
         END IF
      DONE1 = .FALSE.
C                                       Check if scan done
      TT = RPARM(ILOCT+1)
      IF ((INXRNO.GT.SCANUM) .OR. (IRET.LT.0) .OR.
     *   (TT.GT.TIME(1)+SOLINT)) GO TO 200
C                                       antenna numbers
      IF (ILOCB.GE.0) THEN
         BASEN = RPARM(1+ILOCB)
         IA1 = BASEN / 256. + 0.1
         IA2 = BASEN - IA1*256. + 0.1
      ELSE
         IA1 = RPARM(1+ILOCA1) + 0.1
         IA2 = RPARM(1+ILOCA2) + 0.1
         END IF
C                                       parameters needed later
      NANT = MAX (NANT, IA1)
      NANT = MAX (NANT, IA2)
      IDSOUR = INSOU
      IF (ILOCSU.GE.0) IDSOUR = RPARM(1+ILOCSU) + 0.1
      TIME(1) = MIN (TIME(1), TT)
      TIME(2) = MAX (TIME(2), TT)
      GOTDAT = .TRUE.
      DO 140 JIF = 1,NIF
         DO 130 JF = 1,NCHAN
            DO 120 JS = 1,NPOL
               INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *            (JS-1) * INCSI + 1
               IF (VIS(3,INDEXI).GT.0.0) THEN
                  WT = VIS(3,INDEXI)
                  COUNT(IA1,IA2,JIF,JS) = COUNT(IA1,IA2,JIF,JS) + WT
                  AMP = SQRT (VIS(1,INDEXI)**2 + VIS(2,INDEXI)**2)
                  SCANV(IA1,IA2,JIF,JS) = SCANV(IA1,IA2,JIF,JS) + WT*AMP
                  END IF
 120           CONTINUE
 130        CONTINUE
 140     CONTINUE
      GO TO 100
C                                       scan done
 200  IF ((.NOT.GOTDAT) .AND. (IRET.EQ.0)) GO TO 10
      IF (GOTDAT) THEN
         DO 260 IA1 = 1,NANT-1
            DO 250 IA2 = IA1+1,NANT
               DO 240 JIF = 1,NIF
                  DO 230 JS = 1,NPOL
                     IF (COUNT(IA1,IA2,JIF,JS).GT.0.0) THEN
                        WT = COUNT(IA1,IA2,JIF,JS)
                        SCANV(IA1,IA2,JIF,JS) = SCANV(IA1,IA2,JIF,JS) /
     *                     WT
                        END IF
 230                CONTINUE
 240              CONTINUE
 250           CONTINUE
 260        CONTINUE
         END IF
      IF (IRET.LT.0) CALL UVGET ('CLOS', RPARM, VIS, I)
      IF ((IRET.LT.0) .AND. (.NOT.GOTDAT)) THEN
         IRET = 1
         MSGTXT = 'NO DATA FOUND'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE FGSPHI
C-----------------------------------------------------------------------
C   FGSPHI copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72
      INTEGER   LUN1, IERR
      INCLUDE 'FGSPW.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1 /27/
C-----------------------------------------------------------------------
      IF (NFLAGS.LE.0) GO TO 999
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HIOPEN (LUN1, DISKIN, OLDCNO, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (HILINE,1000) TSKNAM, RLSNAM, TTIME
      CALL HIADD (LUN1, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       calibration history
      CALL CALHIS (LUN1, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       parameters
      WRITE (HILINE,1010) TSKNAM, APARM(1)
      CALL HIADD (LUN1, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1011) TSKNAM, APARM(2)
      CALL HIADD (LUN1, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      IF (APARM(3).GT.0.0) THEN
         WRITE (HILINE,1012) TSKNAM
         CALL HIADD (LUN1, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
         END IF
      WRITE (HILINE,1015) TSKNAM, NFLAGS
      CALL HIADD (LUN1, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1016) TSKNAM, FGVERO
      CALL HIADD (LUN1, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Close HI file
 100  CALL HICLOS (LUN1, .TRUE., BUFF2, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A9,2X,A8)
 1010 FORMAT (A6,'APARM(1) =',F9.2,'   / clip level parallel hands')
 1011 FORMAT (A6,'APARM(2) =',F9.2,'   / clip level cross hands')
 1012 FORMAT (A6,'/ All polarizations flagged when one is bad')
 1015 FORMAT (A6,'/ Wrote',I10,' flag commands to')
 1016 FORMAT (A6,'OUTFGVER =',I4,'   / flag table version')
      END
      SUBROUTINE FLAGIT (OPCODE, LUN, DISK, CNO, VERI, VER, LFGRNO,
     *   FGKOLS, FGNUMV, ID, SUBA, FQID, ANT1, ANT2, BTIME, ETIME, BIF,
     *   EIF, BCHAN, ECHAN, PFLAGS, REASON, CATUV, BUFF, IRET)
C-----------------------------------------------------------------------
C   Updates the Flag (FG) table. Adapted from FLAGUP
C   One entry is made indicating a visibility to be rejected.
C   The FLAG table will be opened on the first call but a final call
C   with OPCODE='CLOS' is required to close the file.
C   Inputs:
C      OPCODE   C*4      Operation desired, 'CLOS'=>close file
C                        Anything else = 'FLAG'
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      VERI     I        Input version number
C      VER      I        FG file version
C      LUN      I        Logical unit number to use
C      ID       I(NID)   List of source ID as defined in SOURCE table
C      NID      I        Number of elements in ID
C      SUBA     I        Subarray number.
C      FQID     I        Freqid number
C      ANT1     I        First antenna number in baseline
C      ANT2     I        Second antenna number in baseline
C      BTIME    R        Start time of data to be flagged (Days)
C      ETIME    R        End time of data to be flagged (Days)
C      BIF      I        First IF number to flag. 0=>all
C      EIF      I        Last IF number to flag. 0=>all higher than IFS(1)
C      BCHAN    I        First channel number to flag. 0=>all
C      ECHAN    I        Last channel number to flag. 0=>all higher.
C      PFLAGS   L(4)     Correlator flags
C      REASON   C*24     Reason for flagging blank => ignore for unflag.
C   Input/Output:
C      CATUV    I(256)   Header for disk file to get FG table
C      BUFF     I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      LFGRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      FGKOLS   I(*)     The column pointer array in order, SOURCE,
C                        SUBARRAY, ANTS, TIMERANG, IFS, CHANS, PFLAGS,
C                        REASON
C      FGNUMV   I(*)     Element count in each column.
C   Output:
C      IRET     I        Error code, 0=>OK else TABIO error.
C                        Note: -1 => read, but record deselected.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, REASON*24
      INTEGER   LUN, DISK, CNO, VERI, VER, LFGRNO, FGKOLS(*), FGNUMV(*),
     *   ID, SUBA, FQID, ANT1, ANT2, BIF, EIF, BCHAN, ECHAN, CATUV(256),
     *   BUFF(*), IRET
      REAL      BTIME, ETIME
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER TREAS*24, CTEMP*12
      INTEGER   IDT, SUBT, ANTS(2), IFS(2), CHANS(2), IDUM, FIND, I,
     *   BUFF2(512), LUN2, IFGKOL(MAXFGC), IFGNUM(MAXFGC), NROW, IFQ,
     *   IFGRNO
      LOGICAL   PFLAGS(4), TFLAGS(4), FIRST
      REAL      TIMER(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      SAVE FIRST
      DATA FIRST /.TRUE./
C-----------------------------------------------------------------------
C                                       See if table open - check FTAB
      IF (OPCODE.NE.'CLOS') THEN
         FIND = BUFF(82)
C                                       Open file
         IF ((FIND.LT.0) .OR. (FIND.GT.10000) .OR. (LUN.NE.FTAB(FIND)))
     *      THEN
            CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV',
     *         IDUM, 'CLRD', BUFF, IRET)
            CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV',
     *         IDUM, 'WRIT', BUFF, IRET)
C
            CALL FLGINI ('WRIT', BUFF, DISK, CNO, VER, CATUV, LUN,
     *         LFGRNO, FGKOLS, FGNUMV, IRET)
C                                       Report on the need for flagging
            WRITE (MSGTXT,1000) VER
            IF (.NOT.FIRST) WRITE (MSGTXT,1001) VER
            CALL MSGWRT (2)
            IF (IRET.NE.0) GO TO 999
C                                       Copy the old file
            IF ((FIRST) .AND. (VERI.GT.0)) THEN
               LUN2 = LUN + 1
               CALL FLGINI ('READ', BUFF2, DISK, CNO, VERI, CATUV, LUN2,
     *            IFGRNO, IFGKOL, IFGNUM, IRET)
               IF (IRET.NE.0) GO TO 999
               NROW = BUFF2(5)
               WRITE (MSGTXT,1002) NROW, VERI, VER
               CALL MSGWRT (2)
               DO 20 I = 1,NROW
                  CALL TABFLG ('READ', BUFF2, IFGRNO, IFGKOL, IFGNUM,
     *               IDT, SUBT, IFQ, ANTS, TIMER, IFS, CHANS, TFLAGS,
     *               TREAS, IRET)
                  IF (IRET.GT.0) GO TO 999
                  IF (IRET.EQ.0) THEN
                     CALL TABFLG ('WRIT', BUFF, LFGRNO, FGKOLS, FGNUMV,
     *                  IDT, SUBT, IFQ, ANTS, TIMER, IFS, CHANS, TFLAGS,
     *                  TREAS, IRET)
                     IF (IRET.NE.0) GO TO 999
                     END IF
 20               CONTINUE
               CALL TABIO ('CLOS', 0, IFGRNO, BUFF2, BUFF2, I)
               END IF
            FIRST = .FALSE.
C                                       Mark as unsorted
            BUFF(43) = 0
            BUFF(44) = 0
            END IF
C                                       Set up for flagging
         ANTS(1) = ANT1
         ANTS(2) = ANT2
         TIMER(1) = BTIME
         TIMER(2) = ETIME
         IFS(1) = BIF
         IFS(2) = EIF
         CHANS(1) = BCHAN
         CHANS(2) = ECHAN
C                                       Flag table entry.
         CALL TABFLG ('WRIT', BUFF, LFGRNO, FGKOLS, FGNUMV, ID, SUBA,
     *      FQID, ANTS, TIMER, IFS, CHANS, PFLAGS, REASON, IRET)
C                                       Close
      ELSE
         CALL TABFLG ('CLOS', BUFF, LFGRNO, FGKOLS, FGNUMV, IDT, SUBT,
     *      FQID, ANTS, TIMER, IFS, CHANS, TFLAGS, TREAS, IRET)
C                                       Clear write status
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV', IDUM,
     *      'CLWR', BUFF, IRET)
C                                       Reset status to read
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV', IDUM,
     *      'READ', BUFF, IRET)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Found some bad data, will write flags to table FG', I4)
 1001 FORMAT ('Found some bad data, will add   flags to table FG', I4)
 1002 FORMAT ('Copy',I8,' rows from FG vers',I3,' to',I3)
      END
      SUBROUTINE GTFLUX (SUID, DISK, CNO, CATBLK, FLUXES)
C-----------------------------------------------------------------------
C   fill in FLUX array for current source
C   Input:
C      SUID     I       source number
C      DISK     I       disk number
C      CNO      I       catalog number
C      CATBLK   I(*)    header
C   Output:
C      FLUXES   R(*)    flux in Jy from SU or 1.0
C-----------------------------------------------------------------------
      INTEGER   SUID, DISK, CNO, CATBLK(256)
      REAL      FLUXES(*)
C
      INTEGER   IERR, I, LUN, LUNTMP
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSOU.INC'
C-----------------------------------------------------------------------
      LUN = LUNTMP (1)
      CALL GETSOU (SUID, DISK, CNO, CATBLK, LUN, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FINDING SOURCE FLUX'
         CALL MSGWRT (8)
         CALL RFILL (MAXIF, 1.0, FLUXES)
      ELSE
         DO 20 I = 1,MAXIF
            FLUXES(I) = FLUX(1,I)
            IF (FLUXES(I).LE.0.0) FLUXES(I) = 1.0
 20         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GTFLUX: ERROR',I4,' ON ',A)
      END

      SUBROUTINE ZLASCL (FILNAM, LUN, DELFIL, SYSERR, IERR)
C-----------------------------------------------------------------------
C! close and spool a laser printer print/plot file
C# Z2 Printer Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   close and spool a file for printing a plot on a laser printer
C   Inputs:
C      FILNAM   C*48   print/plot file name
C      LUN      I      LUN under which file is open
C      DELFIL   I      1 => delete the file after print, 0 => keep it
C                      -1 => close print file only
C   Output
C      SYSERR   I      system error code (on IERR 2)
C      IERR     I      error code: 0 => okay, 1 => error in queue,
C                         2 => Fortran close error
C   Generic version - calls ZLASC2 for any special stuff after a Fortran
C   close.    VMS COMMENTED OUT
C-----------------------------------------------------------------------
      CHARACTER FILNAM*(*)
      INTEGER   LUN, DELFIL,SYSERR,  IERR
C
      INTEGER   ITRIM, FLEN, ID
      HOLLERITH HNAM(32)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Fortran close
      CLOSE (UNIT=LUN, IOSTAT=SYSERR)
      IF (SYSERR.NE.0) THEN
         WRITE (MSGTXT,1000) SYSERR
         CALL MSGWRT (6)
         IERR = 2
         GO TO 999
         ENDIF

      IF (DELFIL.GE.0) THEN
         IF (DELFIL.GT.0) THEN
            ID = PRDELE
         ELSE
            ID = 0
            END IF
         FLEN = ITRIM (FILNAM)
C        IF (SYSTYP.EQ.'VMS') THEN
C           CALL ZLASC2 (FLEN, FILNAM, ID, IERR)
C        ELSE
            CALL CHR2H (128, ' ', 1, HNAM)
            CALL CHR2H (FLEN, FILNAM, 1, HNAM)
            CALL ZLASC2 (FLEN, HNAM, ID, IERR)
            END IF
C         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZLASCL: FORTRAN CLOSE ERROR =',I7)
      END

      SUBROUTINE WANTCH (CHNS, ICHN, WT)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to decide if a channel is wanted, based on the CHNSEL adverb
C   Inputs:
C      CHNS(3,20)   I    Channel selector, start, stop and increment
C                        channel numbers
C      ICHN         I    The current channel number
C   Input/output
C      WT           R    The data weight, will be set to zero
C                        if channel is deselected.
C-----------------------------------------------------------------------
      INTEGER CHNS(3,20), ICHN
      REAL    WT
C
      INTEGER I, J, NINCR, NJUMP, K
      REAL    SAVWT
C-----------------------------------------------------------------------
      SAVWT = WT
      WT = 0.0
      DO 20 I = 1,20
         IF ((CHNS(2,I).GT.0) .AND. (ICHN.GE.CHNS(1,I)) .AND.
     *      (ICHN.LE.CHNS(2,I))) THEN
            K = MAX (1, CHNS(3,I))
            IF ((ICHN.EQ.CHNS(1,I)) .OR. (K.EQ.1)) THEN
               WT = SAVWT
               GO TO 999
               END IF
            NINCR = CHNS(2,I) - CHNS(1,I) + 1
            NJUMP = (NINCR / K) + 1
            DO 10 J = 1,NJUMP
               IF (ICHN.EQ.CHNS(1,I)+J*K) THEN
                  WT = SAVWT
                  GO TO 999
                  END IF
 10            CONTINUE
            END IF
 20      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE GETVIS (MODE, MVIS, JADR, SFACT, ALLWT, DATA, WT,
     *   VIS, IERR)
C-----------------------------------------------------------------------
C! uses setup from SETVIS to get and reformat a visibility sample
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GETVIS gets and reformats uv data. Requires setup by SETVIS.
C   Inputs:
C      MODE          I    Operation number (see SETVIS).
C                         When MODE = 2 or 3 and RL and LR are given
C                         the U visibility is multiplied by i.
C      MVIS          I    Number of visibilities wanted.
C      JADR(2,MVIS)  I    Pointers set by SETVIS.
C      SFACT(2,MVIS) R    Factors set by SETVIS.
C      ALLWT         L    Flag set by SETVIS, if .TRUE. all relevant
C                         weights must be positive.
C      DATA(3,*)     R    Visibility portion of input data.
C   Outputs:
C      WT            R    Average weight.
C      VIS(MVIS)     CMPX Visibilities.
C      IERR          I    Error code, 0=>OK,
C                                  1 => bad weights.(data flagged).
C                                  2 = bad input.
C-----------------------------------------------------------------------
      INTEGER   MODE, MVIS, JADR(2,*), IERR
      LOGICAL   ALLWT
      REAL      SFACT(2,*), DATA(3,*), WT
      COMPLEX   VIS(*)
C
      INTEGER   I, IP1, IP2
      REAL      SUM, AWT, WT1, WT2, TMPRI(2), XFACT1, XFACT2
      COMPLEX   CMPLX, TMP
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (TMP, TMPRI)
C-----------------------------------------------------------------------
      WT = 0.0
      VIS(1) = CMPLX (0.0, 0.0)
C                                       Check input.
      IERR = 2
      IF (MVIS.LE.0) GO TO 999
      IERR = 1
      SUM = 0.0
C                                       Loop checking
C                                       and summing weights
C                                       and getting visibilities.
      DO 50 I = 1,MVIS
C                                       Set pointers.
         IP1 = JADR(1,I)
         IP2 = JADR(2,I)
C                                       Get weights.
         WT1 = MAX (0.0, DATA(3,IP1))
         WT2 = MAX (0.0, DATA(3,IP2))
         AWT = WT1 + WT2
C                                       Check weights.
         IF ((ALLWT) .AND. ((WT1.LE.0.0) .OR. (WT2.LE.0.0)))
     *      GO TO 999
C                                       Set visibility.
         XFACT1 = 0.0
         XFACT2 = 0.0
         IF (WT1.GT.0.0) XFACT1 = SFACT(1,I)
         IF (WT2.GT.0.0) XFACT2 = SFACT(2,I)
         VIS(I) = XFACT1 * CMPLX (DATA(1,IP1), DATA(2,IP1)) +
     *      XFACT2 * CMPLX (DATA(1,IP2), DATA(2,IP2))
C                                       If one wt .le.0 (should
C                                       be one vis only) double VIS.
         IF ((WT1.LE.0.0) .OR. (WT2.LE.0.0)) THEN
            VIS(I) = 2.0 * VIS(I)
         ELSE IF (IP1.NE.IP2) THEN
            AWT = 4.0 * WT1 * WT2 / (WT1 + WT2)
         ELSE
            AWT = AWT / 2.0
            END IF
         SUM = SUM + AWT
 50      CONTINUE
C                                       Check summed weight.
      IF (SUM.LE.0.0) GO TO 999
      WT = SUM / MVIS
      IERR = 0
C                                       If using Upol multiply by i
      IF ((ICOR0.GT.0) .OR. ((MODE.NE.2).AND.(MODE.NE.3))) GO TO 999
         TMP = VIS(3)
         VIS(3) = CMPLX (-TMPRI(2), TMPRI(1))
C
 999  RETURN
      END

LOCAL INCLUDE 'PRTIM.INC'
C                                       Local include for PRTIM
      HOLLERITH XNAMIN(3), XCLSIN(2), XLPNAM(12)
      CHARACTER NAMEIN*12, CLASIN*6, LPNAME*48, TITL1*132,
     *   TITL2*132, ALINE*132, SCRTCH*132
      REAL      RSEQIN, DISKIN, BLC(7), TRC(7), RNDIG, MULT, RXINC,
     *   RYINC, XDOCRT, DOCRT
      LOGICAL   SHORT
      INTEGER   LINMAX, LUNPRT, INDPRT, LINPRT, IPAGE
      COMMON /CHRTIM/ ALINE, TITL1, TITL2, SCRTCH, NAMEIN, CLASIN,
     *   LPNAME
      COMMON /CPRTIM/ DOCRT, SHORT, LINMAX, LUNPRT, INDPRT, LINPRT,
     *   IPAGE
      COMMON /INPARM/ XNAMIN, XCLSIN, RSEQIN, DISKIN, BLC, TRC, RNDIG,
     *   MULT, RXINC, RYINC, XDOCRT, XLPNAM
LOCAL END
      PROGRAM PRTIM
C-----------------------------------------------------------------------
C! Task displays a map on line-printer or terminal
C# Map-util Plot-util Printer
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998-1999, 2004, 2007, 2009, 2014-2016,
C;  Copyright (C) 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PRTIM displays a map on a line-printer or terminal device.
C   Inputs:
C      USERID     R     Print user number
C      INNAME(3)  H     Image name (name)
C      INCLASS(2) H     Image name (class)
C      INSEQ      R     Image name (seq. #)
C      INDISK     R     Input disk unit
C      BLC(7)     R     Bottom left corner
C      TRC(7)     R     Top right corner
C      NDIG       R     Number of digits in display
C      FACTOR     R     Multiplication factor
C      XINC       R     Increment columns
C      YINC       R     Increment rows
C      DOCRT      R     >0 -> use CRT, else line printer
C      OUTPRINT   H     File name to keep printer output
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER MTYPE*2, PRGNAM*6, STR*4
      INTEGER   CNO, DLUN, MIND, IRET, NPARM, IERR, NDIG, ISCR(256),
     *   WIND(4), NGET, USER, IVOL, KVOL, DEPTH(7), IBLKOF, SEQIN, NX,
     *   NY, NLINES, NBKOF, ININD, ILO, I, J, LINE, JBUFSZ, NCOL, NPL,
     *   JJ, XINC, YINC, L3, L3L, L3U, L4, L4L, L4U, L5, L5L, L5U, L6,
     *   L6L, L6U, L7, L7L, L7U, IPRN(140), BLANK3, IROUND, NCOUNT,
     *   TTY(2)
      LOGICAL   F, RQUICK, DONE, FIRST
      REAL      MSCAL, DMAX,  DMIN, SCALE, VMAX, RBUFF(MABFSS), CON1,
     *   TEMP, RMAX, RMIN
      INCLUDE 'PRTIM.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (ISCR(1), RBUFF(1))
      DATA DLUN, NBKOF /16, 1/
      DATA F /.FALSE./
      DATA PRGNAM /'PRTIM '/
C-----------------------------------------------------------------------
C                                       Initialize for 1 map and
C                                       three non-map files
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Initialize from AIPS
      NPARM = 38
      CALL GTPARM (PRGNAM, NPARM, RQUICK, XNAMIN, ISCR, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (8)
         END IF
      DOCRT = XDOCRT
      IF ((IRET.NE.0) .OR. (NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   DOCRT = MIN (-1.0, DOCRT)
      CALL H2CHR (48, 1, XLPNAM, LPNAME)
      IF (DOCRT.GT.0.0) RQUICK = .FALSE.
      IF (RQUICK) RQUICK = LPNAME.NE.' '
      IF (RQUICK) CALL RELPOP (IRET, ISCR, IERR)
      IF (IRET.NE.0) GO TO 995
      IRET = 4

C                                       Assign parameters
      SEQIN = RSEQIN + 0.01
      IVOL = DISKIN + 0.01
      NDIG = RNDIG + 0.01
      XINC = RXINC + 0.01
      YINC = RYINC + 0.01
      IF (NDIG.LE.0) NDIG = 1
      IF (NDIG.GT.7) NDIG = 7
      IF (MULT.LE.0.) MULT = 1.0
      IF (XINC.LE.0) XINC = 1
      IF (YINC.LE.0) YINC = 1
      USER = NLUSER
      CALL H2CHR (12, 1, XNAMIN, NAMEIN)
      CALL H2CHR (6, 1, XCLSIN, CLASIN)
C                                       open map: get cat header
      KVOL = IVOL
      MTYPE = 'MA'
      CALL MAPOPN ('READ', KVOL, NAMEIN, CLASIN, SEQIN, MTYPE, USER,
     *    DLUN, MIND, CNO, CATBLK, ISCR, IERR)
      IF (IERR.GT.1) GO TO 995
      NX = CATBLK(KINAX)
      NY = CATBLK(KINAX+1)
C                                       Determine scale factor
      DMAX = CATR(KRDMX)
      DMIN = CATR(KRDMN)
      VMAX = MAX (ABS(DMAX), ABS(DMIN))
      IF ((DMIN.LT.0.0) .AND. (NDIG.GT.1)) VMAX = MAX (VMAX,
     *   10.0 * ABS(DMIN))
      IF (VMAX.LE.0.0) THEN
         WRITE (MSGTXT,1015)
         CALL MSGWRT (8)
         GO TO 960
         END IF
      I = LOG10 (VMAX) + 25.0
      I = I - 24
      VMAX = 10.0**I
      MSCAL = VMAX / MULT
      SCALE = (10.0**NDIG) / MSCAL
      JBUFSZ = MABFSS * 2
C                                       Set up window in y
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 960
      WIND(2) = TRC(2) + 0.01
      WIND(4) = BLC(2) + 0.01
C                                       NLINES  total number of lines
      NLINES = WIND(2) - WIND(4) + 1
C                                       open printer excl
      IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
      CALL LPOPEN (LPNAME, DOCRT, LUNPRT, INDPRT, LINMAX, ISCR, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) LUNPRT, IERR
         CALL MSGWRT (8)
         GO TO 960
         END IF
      SHORT = LINMAX.LT.110
C                                       Get various measures per line
C                                       NPL = # of col/line
C                                       NCOL = range of col num/line
      NPL = (LINMAX - 6) / NDIG
      NCOL = NPL * XINC
C                                       Set up some counter
      IPAGE = 0
      CON1 = SCALE
      RMAX = 10.**NDIG + 1.5
      RMIN = 10.**MAX(NDIG-1, 1) + 1.5
      RMIN = -RMIN
      BLANK3 = RMIN - 2
      DEPTH(1) = (TRC(1) + BLC(1)) / 2.0 + 0.5
      DEPTH(2) = (TRC(2) + BLC(2)) / 2.0 + 0.5
      L3L = BLC(3) + 0.01
      L4L = BLC(4) + 0.01
      L5L = BLC(5) + 0.01
      L6L = BLC(6) + 0.01
      L7L = BLC(7) + 0.01
      L3U = TRC(3) + 0.01
      L4U = TRC(4) + 0.01
      L5U = TRC(5) + 0.01
      L6U = TRC(6) + 0.01
      L7U = TRC(7) + 0.01
C                                       count lines
      IF ((DOCRT.LE.0.0) .AND. (LPNAME.EQ. ' ')) THEN
         NCOUNT = 0
         MSGTXT = 'Checking count of lines for direct output to printer'
         CALL MSGWRT (2)
C                                       loop over planes
         DO 100 L7 = L7L,L7U
         DO 99 L6 = L6L,L6U
         DO 98 L5 = L5L,L5U
         DO 97 L4 = L4L,L4U
         DO 96 L3 = L3L,L3U
            WIND(1) = BLC(1) + 0.01
            WIND(1) = WIND(1) - NCOL
            WIND(3) = WIND(1) + NCOL - 1
            DEPTH(3) = L3
            DEPTH(4) = L4
            DEPTH(5) = L5
            DEPTH(6) = L6
            DEPTH(7) = L7
            CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), DEPTH(3), IBLKOF,
     *         IERR)
            IF (IERR.NE.0) GO TO 950
            IBLKOF = IBLKOF + NBKOF
            DONE = .FALSE.
            FIRST = .TRUE.
C                                       Begin paging loop
 50         WIND(1) = WIND(1) + NCOL
               WIND(3) = WIND(3) + NCOL
               LINE = WIND(2) + 1
C                                       Is this the last page?
               IF (WIND(3).GE.TRC(1)) THEN
                  DONE = .TRUE.
                  WIND(3) = TRC(1) + 0.01
                  END IF
               NGET = WIND(3) - WIND(1) + 1
C                                       Write the page headers
               IF (FIRST) THEN
                  NCOUNT = NCOUNT + 9 + CATBLK(KIDIM)
               ELSE
                  NCOUNT = 2 + NCOUNT
                  END IF
               FIRST = .FALSE.
C                                       Read a line from the map
               DO 90 I = 1,NLINES
C                                       Do we want this line?
                  IF (MOD(I-1,YINC).EQ.0) NCOUNT = NCOUNT + 1
 90               CONTINUE
C                                       Was this the last line?
               IF (.NOT.DONE) GO TO 50
 96            CONTINUE
 97         CONTINUE
 98         CONTINUE
 99         CONTINUE
 100        CONTINUE
         IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) THEN
            IF (NCOUNT.GT.1000) THEN
               IRET = -1
               LINE = -1
               CALL LPCLOS (LUNPRT, INDPRT, LINE, IERR)
               END IF
         ELSE IF (NCOUNT.GT.500) THEN
            TTY(1) = 5
            CALL ZOPEN (TTY(1), TTY(2), 1, SCRTCH, .FALSE., .FALSE.,
     *         .TRUE., IRET)
            MSGTXT = 'PROBLEM OPENING TERMINAL'
            IF (IRET.GT.0) GO TO 940
            WRITE (SCRTCH,1100) NCOUNT
            CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, IRET)
            MSGTXT = 'PROBLEM DOING IO TO TERMINAL'
            IF (IRET.GT.0) GO TO 940
            SCRTCH = 'Do you really want to print this much??' //
     *         ' Enter Y or y if so'
            CALL INQSTR (TTY, SCRTCH, 1, STR, IRET)
            IF (IRET.GT.0) GO TO 940
            IF ((STR(:1).NE.'y') .AND. (STR(:1).NE.'Y')) THEN
               LINE = -1
               CALL LPCLOS (LUNPRT, INDPRT, LINE, IERR)
               IRET = -1
               SCRTCH = 'Good choice - save trees'
            ELSE
               SCRTCH = 'OKAY, printing anyway'
               END IF
            CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, I)
            CALL ZCLOSE (TTY(1), TTY(2), I)
            IF (IRET.NE.0) GO TO 960
            END IF
         END IF
C                                       loop over planes
      DO 200 L7 = L7L,L7U
      DO 199 L6 = L6L,L6U
      DO 198 L5 = L5L,L5U
      DO 197 L4 = L4L,L4U
      DO 196 L3 = L3L,L3U
         WIND(1) = BLC(1) + 0.01
         WIND(1) = WIND(1) - NCOL
         WIND(3) = WIND(1) + NCOL - 1
         DEPTH(3) = L3
         DEPTH(4) = L4
         DEPTH(5) = L5
         DEPTH(6) = L6
         DEPTH(7) = L7
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), DEPTH(3), IBLKOF,
     *      IERR)
         IF (IERR.NE.0) GO TO 950
         IBLKOF = IBLKOF + NBKOF
         DONE = .FALSE.
         FIRST = .TRUE.
C                                       Begin paging loop
 150     WIND(1) = WIND(1) + NCOL
            WIND(3) = WIND(3) + NCOL
            LINE = WIND(2) + 1
C                                       Is this the last page?
            IF (WIND(3).GE.TRC(1)) THEN
               DONE = .TRUE.
               WIND(3) = TRC(1) + 0.01
               END IF
            NGET = WIND(3) - WIND(1) + 1
C                                       Write the page headers
            CALL PHEAD (WIND, DEPTH, XINC, NDIG, MSCAL, FIRST, IERR)
            IF (IERR.NE.0) GO TO 950
            FIRST = .FALSE.
C                                       Initialize the mapfile
            CALL MINIT ('READ', DLUN, MIND, NX, NY, WIND, RBUFF, JBUFSZ,
     *         IBLKOF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1055) IERR
               CALL MSGWRT (8)
               GO TO 950
               END IF
C                                       Read a line from the map
            DO 190 I = 1,NLINES
               CALL MDISK ('READ', DLUN, MIND, RBUFF, ININD, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1060) IERR, I
                  CALL MSGWRT (8)
                  GO TO 950
                  END IF
               LINE = LINE - 1
C                                       Do we want this line?
               IF (MOD(I-1,YINC).EQ.0) THEN
                  ILO = ININD - 1
                  JJ = 0
C                                       Scale line and store:
                  DO 170 J = 1,NGET,XINC
                     JJ = JJ + 1
                     TEMP = RBUFF(ILO+J)
                     IF (TEMP.EQ.FBLANK) THEN
                        IPRN(JJ) = BLANK3
                     ELSE
                        TEMP = TEMP * CON1
                        TEMP = MAX (RMIN, MIN (RMAX, TEMP))
                        IPRN(JJ) = IROUND (TEMP)
                        END IF
 170                 CONTINUE
C                                          Write out this line
                  CALL PLINE (LINE, IPRN, JJ, NDIG, BLANK3, IERR)
                  IF (IERR.NE.0) GO TO 950
                  END IF
 190           CONTINUE
C                                       Was this the last line?
            IF (.NOT.DONE) GO TO 150
 196        CONTINUE
 197     CONTINUE
 198     CONTINUE
 199     CONTINUE
 200     CONTINUE
      GO TO 950
C                                       Close mapfile and directory
 940  CALL MSGWRT (8)
C
 950  IF (IERR.LE.0) IRET = 0
      CALL LPCLOS (LUNPRT, INDPRT, LINPRT, IERR)
 960  CALL MAPCLS ('READ', KVOL, CNO, DLUN, MIND, CATBLK, F, ISCR, IERR)
C
 995  IRET = MAX (0, IRET)
      CALL DIETSK (IRET, RQUICK, ISCR)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR IN GTPARM=',I4)
 1015 FORMAT ('MAP IS ALL ZERO')
 1040 FORMAT ('PRINTER LUN',I3,' OPEN ERR =',I6)
 1055 FORMAT ('CAN''T INITIALIZE MAP.  IER=',I6)
 1060 FORMAT ('ERROR IN READING MAP.  IER=',I6,'  LINE=',I4)
 1100 FORMAT ('Requested print job is',I10,' lines long!')
      END
      SUBROUTINE PHEAD (WIND, DEPTH, XINC, NDIG, DSEC, FIRST, IERR)
C-----------------------------------------------------------------------
C   PHEAD prints page headers for PRTIM
C   Inputs:
C      WIND    I(4)   x-y window of the moment
C      DEPTH   I(7)   depth on axes 1 - 7
C      XINC    I      increment on first axis
C      NDIG    I      # digits in print out
C      DSEC    R      Data max at 10 ** NDIG
C      FIRST   L      T => full header
C   Output:
C      IERR    I      0 -> OK, -1 user asks quit, > 0 error.
C   Uses the catalog header block in common /MAPHDR/
C-----------------------------------------------------------------------
      INTEGER   WIND(4), DEPTH(7), XINC, NDIG, IERR
      REAL      DSEC
      LOGICAL   FIRST
C
      CHARACTER BLANK*8, WPROC(5)*8, CHSTOK(20)*4, FORM1*20, NNTEMP*18,
     *   AXIS(2)*1, CHSGN1*1, CHSGN2*1, CHSGN4*1, NTEMP*12, CTEMP*6,
     *   BTEMP*8, STOKEV*4, STRING*50, XTEMP*8
      INTEGER   I, J, NAX, INC, HM(2), XST, IST, I1, I2, I3, J1, J2,
     *   IPIX(50), IROUND, IN, IDM(2), IRM(2), JERR(7), J4, ITMP, NC
      REAL      TEMP, DEC, SEC, AREA, RTEMP, SECD, SECR, RDX, RDY
      DOUBLE PRECISION DX, DY, X(7), DT, COSR, SINR, FREQV, XT
      LOGICAL   FLUXFL, DONEIT, NOSWAP, LONG
      INCLUDE 'PRTIM.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA BLANK, NOSWAP /'    ', .FALSE./
      DATA WPROC /'Dirty   ','Compnts ','Residual','Points  ',
     *   'Clean   '/
      DATA CHSTOK /'Beam','Ipol','Qpol','Upol','Vpol','Ppol','Fpol',
     *   'Pang','Spix','Optd','Rotm','????','RR','LL','RL','LR',
     *   'VV','HH','VH','HV'/
      DATA AXIS /'X','Y'/
C-----------------------------------------------------------------------
      LONG = .NOT.SHORT
C                                       force page: do we continue?
      IERR = 0
      LINPRT = 998
      TITL1 = ' '
      TITL2 = ' '
C                                       source, img name, page
      CALL H2CHR (18, KHIMNO, CATH(KHIMN), NNTEMP)
      IF ((DOCRT.GT.-2.5) .AND. (FIRST)) THEN
         CALL H2CHR (8, 1, CATH(KHOBJ), BTEMP)
         CALL H2CHR (12, KHIMNO, CATH(KHIMN), NTEMP)
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), CTEMP)
         IF (LONG) THEN
            WRITE (ALINE,1000) BTEMP, NTEMP, CTEMP, CATBLK(KIIMS)
         ELSE
            WRITE (ALINE,1001) BTEMP, NTEMP, CTEMP, CATBLK(KIIMS)
            END IF
         CALL PRTLIN (LUNPRT, INDPRT, DOCRT, LINMAX, TITL1, TITL2,
     *      ALINE, LINPRT, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       set up axes loop
      NAX = CATBLK(KIDIM)
      INC = 2
      I1 = 0
      I2 = 0
      I3 = 0
      STOKEV = BLANK
      FREQV = 0.D0
      SECR = 0.0
      SECD = 0.0
      CHSGN2 = ' '
      CALL FILL (2, 0, IRM)
      CHSGN4 = ' '
      CALL FILL (2, 0, IDM)
      LOCNUM = 1
      CALL SETLOC (DEPTH(3), NOSWAP)
      RDX = DEPTH(1)
      RDY = DEPTH(2)
      CALL FILL (7, 0, JERR)
      CALL XYVAL (RDX, RDY, X(1), X(2), XT, JERR(1))
      JERR(2) = JERR(1)
      IF (KLOCA(LOCNUM).GE.0) THEN
         X(KLOCA(LOCNUM)+1) = XT
         JERR(KLOCA(LOCNUM)+1) = JERR(1)
         END IF
      IF (NAX.GE.3) THEN
         DONEIT = AXTYP(LOCNUM).NE.4
         DO 10 I = 3,NAX
            J = I - 1
            IF (((AXTYP(LOCNUM).EQ.2) .OR. (AXTYP(LOCNUM).EQ.3)) .AND.
     *         (KLOCA(LOCNUM).EQ.J)) GO TO 10
            IF (AXFUNC(I,LOCNUM).LE.0) THEN
               X(I) = CATD(KDCRV+J) + (DEPTH(I) - CATR(KRCRP+J)) *
     *            CATR(KRCIC+J)
            ELSE IF (AXFUNC(I,LOCNUM).EQ.1) THEN
               X(I) = DEPTH(I) - CATR(KRCRP+J)
               X(I) = CATD(KDCRV+J) + X(I) * CATR(KRCIC+J) /
     *            (1.D0 + AXDENU(LOCNUM)*X(I))
            ELSE IF (AXTYP(LOCNUM).NE.4) THEN
               X(I) = CATD(KDCRV+J) + (DEPTH(I) - CATR(KRCRP+J)) *
     *            CATR(KRCIC+J)
            ELSE IF (.NOT.DONEIT) THEN
               DONEIT = .TRUE.
               DX = (ZDEPTH(KLOCL(LOCNUM)-1,LOCNUM) - RPLOC(3,LOCNUM)) *
     *            AXINC(3,LOCNUM)
               DY = (ZDEPTH(KLOCM(LOCNUM)-1,LOCNUM) - RPLOC(4,LOCNUM)) *
     *            AXINC(4,LOCNUM)
               COSR = COS (ROT(LOCNUM) * COND2R)
               SINR = SGNROT(LOCNUM) * SIN (ROT(LOCNUM) * COND2R)
               DT = (DX * COSR - DY * SINR) * COND2R
               DY = (DY * COSR + DX * SINR) * COND2R
               DX = DT
               COSR = RPVAL(3,LOCNUM) * COND2R
               SINR = RPVAL(4,LOCNUM) * COND2R
               CALL NEWPOS (AXFUNC(KLOCL(LOCNUM)+1,LOCNUM), COSR, SINR,
     *            DX, DY, X(KLOCL(LOCNUM)+1), X(KLOCM(LOCNUM)+1), IN,
     *            JERR(KLOCL(LOCNUM)+1))
               JERR(KLOCM(LOCNUM)+1) = JERR(KLOCL(LOCNUM)+1)
               X(KLOCL(LOCNUM)+1) = X(KLOCL(LOCNUM)+1) / COND2R
               X(KLOCM(LOCNUM)+1) = X(KLOCM(LOCNUM)+1) / COND2R
               END IF
 10         CONTINUE
         END IF
C                                       Loop to display axes
      DO 50 I = 1,NAX
         J = I - 1
         ITMP = KHCTP+J*INC
         CALL H2CHR (8, 1, CATH(ITMP), BTEMP)
         CTEMP = BTEMP
         CALL CHLTOU (8, XTEMP)
         IF (XTEMP(1:4).EQ.'FREQ') I3 = I
C                                       Check axis type
         IF ((JERR(I).EQ.0) .AND. ((XTEMP(:2).EQ.'LL') .OR.
     *      (XTEMP(:2).EQ.'RA') .OR. (XTEMP(:2).EQ.'MM') .OR.
     *      (XTEMP(:3).EQ.'DEC'))) THEN
C                                       RA axis
            IF ((XTEMP(:2).EQ.'LL') .OR. (XTEMP(:2).EQ.'RA')) THEN
               CALL COORDD (1, X(I), CHSGN1, HM, SEC)
               CALL COORDD (1, X(I), CHSGN2, IRM, SECR)
               I1 = I
C                                       DEC axis
            ELSE
               CALL COORDD (2, X(I), CHSGN1, HM, SEC)
               CALL COORDD (2, X(I), CHSGN4, IDM, SECD)
               I2 = I
               END IF
            DEC = CATR(KRCIC+J) * 3600.
            IF ((DOCRT.GT.-2.5) .AND. (FIRST)) THEN
               IF (LONG) THEN
                  IF (I.LE.2) THEN
                     WRITE (ALINE,1010) AXIS(I), BTEMP, CHSGN1, HM, SEC,
     *                  DEPTH(I), DEC, CATR(KRCRT+J)
                  ELSE
                     WRITE (ALINE,1011) I, BTEMP, CHSGN1, HM, SEC,
     *                  DEPTH(I), CATR(KRCRT+J)
                     END IF
               ELSE
                  IF (I.LE.2) THEN
                     WRITE (ALINE,1015) AXIS(I), BTEMP, CHSGN1, HM, SEC,
     *                  DEPTH(I), DEC, CATR(KRCRT+J)
                  ELSE
                     WRITE (ALINE,1016) I, BTEMP, CHSGN1, HM, SEC,
     *                  DEPTH(I), CATR(KRCRT+J)
                     END IF
                  END IF
               END IF
C                                       Stokes axis
         ELSE IF (J.EQ.KLOCS(LOCNUM)) THEN
            RTEMP = X(I)
            J1 = IROUND (RTEMP) + 1
            J2 = J1
            IF ((J1.LE.0) .OR. (J1.GT.11)) J2 = 12
            IF ((J1.LT.0) .AND. (J1.GE.-7)) J2 = 13 - J1
            STOKEV = CHSTOK(J2)
            IF ((DOCRT.GT.-2.5) .AND. (FIRST)) THEN
               IF (LONG) THEN
                  IF (I.LE.2) THEN
                     WRITE (ALINE,1020) AXIS(I), BTEMP, STOKEV,
     *                  DEPTH(I), CATR(KRCIC+J), CATR(KRCRT+J)
                  ELSE
                     WRITE (ALINE,1021) I, BTEMP, STOKEV, DEPTH(I),
     *                  CATR(KRCRT+J)
                     END IF
               ELSE
                  IF (I.LE.2) THEN
                     WRITE (ALINE,1025) AXIS(I), BTEMP, STOKEV,
     *                  DEPTH(I), CATR(KRCIC+J), CATR(KRCRT+J)
                  ELSE
                     WRITE (ALINE,1026) I, BTEMP, STOKEV, DEPTH(I),
     *                  CATR(KRCRT+J)
                     END IF
                  END IF
               END IF
C                                       No RA or DEC axis
         ELSE
            IF (J.EQ.KLOCF(LOCNUM)) FREQV = X(I)
            IF ((DOCRT.GT.-2.5) .AND. (FIRST)) THEN
               IF (LONG) THEN
                  IF (I.LE.2) THEN
                     WRITE (ALINE,1030) AXIS(I), BTEMP, X(I), DEPTH(I),
     *                  CATR(KRCIC+J), CATR(KRCRT+J)
                  ELSE
                     WRITE (ALINE,1031) I, BTEMP, X(I), DEPTH(I),
     *                  CATR(KRCRT+J)
                     END IF
               ELSE
                  IF (I.LE.2) THEN
                     WRITE (ALINE,1035) AXIS(I), BTEMP, X(I), DEPTH(I),
     *                  CATR(KRCIC+J), CATR(KRCRT+J)
                  ELSE
                     WRITE (ALINE,1036) I, BTEMP, X(I), DEPTH(I),
     *                  CATR(KRCRT+J)
                     END IF
                  END IF
               END IF
            END IF
         IF ((DOCRT.GT.-2.5) .AND. (FIRST)) THEN
            CALL PRTLIN (LUNPRT, INDPRT, DOCRT, LINMAX, TITL1, TITL2,
     *         ALINE, LINPRT, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 50      CONTINUE
      FLUXFL = (I1.GT.0) .AND. (I2.GT.0)
C                                       clean parameters
      IF ((CATBLK(KINIT).GT.0) .AND. (DOCRT.GT.-2.5) .AND. (FIRST)) THEN
         TEMP = CATR(KRBMJ) * 3600.0
         SEC = CATR(KRBMN) * 3600.0
         DEC = CATR(KRBPA)
         J = CATBLK(KITYP)
         IF ((J.LT.1) .OR. (J.GT.4)) J = 1
         IF ((J.EQ.1) .AND. (CATBLK(KINIT).GT.0)) J = 5
         IF (LONG) THEN
            IF ((TEMP.GT.0.5) .OR. (SEC.GT.0.5)) THEN
               WRITE (ALINE,1050) CATBLK(KINIT), TEMP, SEC, DEC,
     *            WPROC(J)
            ELSE
               WRITE (ALINE,1051) CATBLK(KINIT), TEMP, SEC, DEC,
     *           WPROC(J)
               END IF
         ELSE
            IF ((TEMP.GT.0.5) .OR. (SEC.GT.0.5)) THEN
               WRITE (ALINE,1055) CATBLK(KINIT), TEMP, SEC, DEC,
     *            WPROC(J)
            ELSE
               WRITE (ALINE,1056) CATBLK(KINIT), TEMP, SEC, DEC,
     *            WPROC(J)
               END IF
            END IF
         CALL PRTLIN (LUNPRT, INDPRT, DOCRT, LINMAX, TITL1, TITL2,
     *      ALINE, LINPRT, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       print scaling info
      CALL H2CHR (8, 1, CATH(KHBUN), BTEMP)
      XTEMP = BTEMP
      CALL CHLTOU (8, XTEMP)
      J4 = 10.0**NDIG + 0.1
      FLUXFL = (FLUXFL) .AND. (XTEMP(1:8).EQ.'JY/BEAM ')
      IF (LONG) THEN
         WRITE (ALINE,1060) J4, DSEC, BTEMP
      ELSE
         WRITE (ALINE,1065) J4, DSEC, BTEMP
         END IF
      IF ((DOCRT.GT.-2.5) .OR. (FIRST)) THEN
         CALL PRTLIN (LUNPRT, INDPRT, DOCRT, LINMAX, TITL1, TITL2,
     *      ALINE, LINPRT, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Clean beam area
      AREA = 1.1331 * CATR(KRBMJ) * CATR(KRBMN) * 3600.0 * 3600.0
      IF ((FLUXFL) .AND. (AREA.GT.0.0) .AND. (DOCRT.GT.-2.5) .AND.
     *   (FIRST)) THEN
         SEC = DSEC / AREA
         IF (LONG) THEN
            WRITE (ALINE,1070) J4, SEC
         ELSE
            WRITE (ALINE,1075) J4, SEC
            END IF
         CALL PRTLIN (LUNPRT, INDPRT, DOCRT, LINMAX, TITL1, TITL2,
     *      ALINE, LINPRT, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 999
         IF ((I3.GT.0) .AND. (X(I3).GT.1.E3)) THEN
            X(I3) = X(I3) / 1.D9
            SEC = 1.3849E6 * SEC / (X(I3) * X(I3))
            IF (LONG) THEN
               WRITE (ALINE,1080) J4, SEC
            ELSE
               WRITE (ALINE,1085) J4, SEC
               END IF
            CALL PRTLIN (LUNPRT, INDPRT, DOCRT, LINMAX, TITL1, TITL2,
     *         ALINE, LINPRT, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         END IF
C                                       Second title line:
C                                       Print x pixel positions: every
C                                       fifth one divisible by 5 if ?
      XST = WIND(1) - XINC
      DO 110 I = 1,5
         XST = XST + XINC
         IF (MOD(XST,5).EQ.0) GO TO 115
 110     CONTINUE
      XST = WIND(1)
      I = 1
C                                       XST: first pix value
C                                       IST: first pixel loc
 115  IST = I
      I2 = 5 * XINC
      I1 = XST - I2
      DO 120 I = 1,50
         IPIX(I) = I1 + I2*I
         IF (IPIX(I).GT.WIND(3)) GO TO 125
 120     CONTINUE
      I = 51
 125  I1 = I - 1
C                                       Format (J1X, 255(I4,J2X))
      J1 = 2 + IST*NDIG
      J2 = 5*NDIG - 4
      I = I1 - 1
      WRITE (FORM1,1125) J1, I, J2
      IF (I.LE.0) WRITE (FORM1,1126) J1
      WRITE (TITL2,FORM1) (IPIX(I), I = 1,I1)
C                                       First title line
      CALL NAMEST (NNTEMP, CATBLK(KIIMS), STRING, NC)
      I = 1
      LONG = (LINMAX - NC - 6).GE.70
      IF (LONG) THEN
         J1 = (LINMAX - NC - 68) / 4
         TITL1 = 'Image=' // STRING(:NC)
         I = NC + 7
      ELSE
         J1 = (LINMAX - NC - 43) / 4
         TITL1 = STRING(:NC)
         I = NC + 1
         END IF
      J1 = MIN (5, J1)
      I = I + J1
      WRITE (STRING,1130) CHSGN2, IRM, SECR, CHSGN4, IDM, SECD, FREQV,
     *   STOKEV
      IF (STRING(8:8).EQ.' ') STRING(8:8) = '0'
      IF (STRING(22:22).EQ.' ') STRING(22:22) = '0'
      IF (LONG) THEN
         TITL1(I:) = 'RA=' // STRING(1:13) // BLANK(:J1) // 'DEC=' //
     *      STRING(15:26) // BLANK(:J1) // 'Freq=' // STRING(28:41) //
     *      BLANK(:J1) // 'Stokes=' // STRING(43:46)
      ELSE
         TITL1(I:) = STRING(1:13) // BLANK(:J1) // STRING(15:26) //
     *      BLANK(:J1) // STRING(28:41) // BLANK(:J1) // STRING(43:46)
         END IF
      IF ((DOCRT.GT.-2.5) .OR. (FIRST)) THEN
         CALL PRTLIN (LUNPRT, INDPRT, DOCRT, LINMAX, TITL1, TITL2,
     *      TITL1, LINPRT, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
      CALL PRTLIN (LUNPRT, INDPRT, DOCRT, LINMAX, TITL1, TITL2,
     *   TITL2, LINPRT, IPAGE, SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (16X,'Object=',A8,8X,'Imagename=',A,'.',A,'.',I4)
 1001 FORMAT ('Object=',A8,6X,'Imagename=',A,'.',A,'.',I4)
 1010 FORMAT (9X,A1,' Axis',4X,'Type=',A8,5X,'Ref Value=',A1,I2,I3,
     *   F6.2,3X,'at pixel',I5,5X,'Inc=',F9.3,5X,'rot=',F6.1)
 1011 FORMAT (9X,'  Axis',I2,2X,'Type=',A8,5X,'Ref Value=',A1,I2,I3,
     *   F6.2,3X,'at pixel',I5,5X,'rot=',F6.1)
 1015 FORMAT (A1,' Axis',3X,A8,2X,'Val=',A1,I2,I3,F6.2,' at',I5,2X,
     *   'Inc=',F9.3,3X,'rot=',0PF6.1)
 1016 FORMAT ('  Axis',I2,1X,A8,2X,'Val=',A1,I2,I3,F6.2,' at',I5,2X,
     *   'rot=',0PF6.1)
 1020 FORMAT (9X,A1,' Axis',4X,'Type=',A8,9X,'Value= ',A4,10X,
     *   'at pixel',I5,5X,'Inc=',1PE11.4,3X,'rot=',0PF6.1)
 1021 FORMAT (9X,'  Axis',I2,2X,'Type=',A8,9X,'Value= ',A4,10X,
     *   'at pixel',I5,5X,'rot=',0PF6.1)
 1025 FORMAT (A1,' Axis',3X,A8,2X,'Val=',A4,8X,' at',I5,2X,
     *   'Inc=',1PE10.3,2X,'rot=',0PF6.1)
 1026 FORMAT ('  Axis',I2,1X,A8,2X,'Val=',A4,8X,' at',I5,2X,
     *   'rot=',0PF6.1)
 1030 FORMAT (9X,A1,' Axis',4X,'Type=',A8,5X,'Ref value=',1PE13.5,
     *   2X,'at pixel',I5,5X,'inc=',1PE11.4,3X,'rot=',0PF6.1)
 1031 FORMAT (9X,'  Axis',I2,2X,'Type=',A8,9X,'Value=',1PE13.5,2X,
     *   'at pixel',I5,5X,'rot=',0PF6.1)
 1035 FORMAT (A1,' Axis',3X,A8,2X,'Val=',1PE12.5,' at',I5,2X,
     *   'INC=',1PE10.3,2X,'rot=',0PF6.1)
 1036 FORMAT ('  Axis',I2,1X,A8,2X,'Val=',1PE12.5,' at',I5,2X,
     *   'rot=',0PF6.1)
 1050 FORMAT (19X,'CLEAN nit=',I8,6X,'BMAJ=',F5.2,6X,'BMIN=',F5.2,
     *   6X,'BPA=',F6.1,10X,'Type=',A8)
 1051 FORMAT (19X,'CLEAN nit=',I8,6X,'BMAJ=',F6.4,5X,'BMIN=',F6.4,
     *   5X,'BPA=',F6.1,10X,'Type=',A8)
 1055 FORMAT ('CLEAN nit=',I8,3X,'BMAJ=',F5.2,2X,'BMIN=',F5.2,
     *   2X,'BPA=',F6.1,3X,'Type=',A8)
 1056 FORMAT ('CLEAN nit=',I8,3X,'BMAJ=',F6.4,1X,'BMIN=',F6.4,
     *   1X,'BPA=',F6.1,3X,'Type=',A8)
 1060 FORMAT (37X,'Map scale:',I10,'=',1PE12.4,1X,A8)
 1065 FORMAT ('   Map scale:',I10,'=',1PE12.4,1X,A8)
 1070 FORMAT (34X,'Approx scale:',I10,'=',1PE12.4,' Jy / (arcsec)**2')
 1075 FORMAT ('Approx scale:',I10,'=',1PE12.4,' Jy / (arcsec)**2')
 1080 FORMAT (34X,'Approx scale:',I10,'=',1PE12.4,' Kelvins')
 1085 FORMAT ('Approx scale:',I10,'=',1PE12.4,' Kelvins')
 1125 FORMAT ('(',I2,'X,I4,',I2,'(',I2,'X,I4))')
 1126 FORMAT ('(',I2,'X,I4)')
 1130 FORMAT (A1,I2.2,':',I2.2,':',F6.3,1X,A1,I2.2,':',I2.2,':',F5.2,
     *   1X,1PE14.6,1X,A4)
      END
      SUBROUTINE PLINE (LINE, IPRN, NPL, NDIG, PBLANK, IERR)
C-----------------------------------------------------------------------
C   PLINE writes a map line, suitably scaled, on the line printer or
C   CRT for PRTIM.
C   Inputs:
C      LINE     I      Pixel value of the line
C      NPL      I      Number of pixel per written line
C      NDIG     I      Number of digits in the display
C      PBLANK   I      Value of blanked pixel
C   In/out:
C      IPRN     I(*)   Array of scaled map values (used for scrtch)
C   Output:
C      IERR     I      Error code: 0 -> ok,
C                         -1 -> user wants to quit,
C                         else error
C-----------------------------------------------------------------------
      INTEGER   LINE, IPRN(140), NPL, NDIG, PBLANK, IERR
C
      CHARACTER SYM(23)*1, IDIS*1, BDIS(3)*8, LPRN*140, FORM3*8,
     *   PRTMP*12
      INTEGER   IMAX, IMIN, ITEMP, J, I, IX
      INCLUDE 'PRTIM.INC'
      DATA SYM /'-','J','I','H','G','F','E','D','C','B','A',
     *   '.','1','2','3','4','5','6','7','8','9','T','+'/
      DATA IDIS, BDIS /':', '::::::::','++++++++','--------'/
C-----------------------------------------------------------------------
C                                       Special print out for 1 digit
      IF (NDIG.EQ.1) THEN
         DO 30 I = 1,NPL
            ITEMP = IPRN(I)
C                                       Is this a blank pixel
            IF (ITEMP.EQ.PBLANK) THEN
               LPRN(I:I) = IDIS
            ELSE
               ITEMP = MAX (-11, MIN (11,  ITEMP))
               LPRN(I:I) = SYM(ITEMP+12)
               END IF
 30         CONTINUE
         WRITE (ALINE,1030) LINE, LPRN(:NPL)
C                                       multi-digit displays
      ELSE
         IMAX = 10.0**NDIG - 0.5
         IMIN = -IMAX / 10
         WRITE (FORM3,1050) NDIG
         WRITE (ALINE,1051) LINE
         J = 7 - NDIG
         DO 70 I = 1,NPL
            J = J + NDIG
            ITEMP = IPRN(I)
            IX = 0
            IF (ITEMP.GT.IMAX) IX = 2
            IF (ITEMP.LT.IMIN) IX = 3
            IF (ITEMP.EQ.PBLANK) IX = 1
C                                       good pixel
            IF (IX.EQ.0) THEN
               WRITE (PRTMP,FORM3) ITEMP
               ALINE(J:J+NDIG-1) = PRTMP(:NDIG)
C                                       Blanked or overflow pixel
            ELSE
               ALINE(J:J+NDIG-1) = BDIS(IX)(:NDIG)
               END IF
 70         CONTINUE
         END IF
C                                       Write it
      CALL PRTLIN (LUNPRT, INDPRT, DOCRT, LINMAX, TITL1, TITL2,
     *   ALINE, LINPRT, IPAGE, SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (I4,2X,A)
 1050 FORMAT ('(I',I1,')')
 1051 FORMAT (I4)
      END

      SUBROUTINE GETFQ (IDFREQ, DISK, CNO, CATFQ, LUN, FREQFQ, TBWFQ,
     *   CHBWFQ, SIDFQ, BNDCOD, IERR)
C-----------------------------------------------------------------------
C! Find info on a given frequency id.
C# EXT-appl UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to look up frequency info for a given freq. id.
C   If can't find FQ/CH table the info will be obtained from
C   the common maintained by UVPGET; UVPGET should be called before
C   calling GETFQ
C   Inputs:
C      IDFREQ   I       Freq. id
C      DISK     I       Disk number
C      CNO      I       Catalog slot number
C      CATFQ   I(256)  Catalog header
C      LUN      I       LUN to use. (e.g. 25)
C   Output:
C      FREQFQ   D(*)    Frequency for each IF (Hz)
C      TBWFQ    R(*)    Bandwidth for each IF (Hz)
C      CHBWFQ   R(*)    Ch. sep for each IF (Hz)
C      SIDFQ    I(*)    Sideband for each IF
C      BNDCOD   C*8(*)  band code for each IF
C   Output:
C      IERR     I       Return code. 0=OK, else failed.
C                          11 => Couldn't find IDFREQ in FQ table.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IDFREQ, DISK, CNO, CATFQ(256), LUN, SIDFQ(MAXIF),
     *   IERR
      DOUBLE PRECISION FREQFQ(MAXIF)
      REAL      TBWFQ(MAXIF), CHBWFQ(MAXIF)
      CHARACTER BNDCOD(*)*(*)
C
      INTEGER   BUFFER(512), NUMIFQ, JERR, RNOFQ, KOLSFQ(MAXFQC),
     *   NUMVFQ(MAXFQC), FQNUMB, IFQN, I, FQID, IIF, CATEQU(256),
     *   MLOCF
      LOGICAL   TABLE, FQEXIS, FITASC, CHEXIS
      REAL      CATRFQ(256)
      DOUBLE PRECISION CATDFQ(128)
      HOLLERITH CATHFQ(256)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATDFQ, CATRFQ, CATEQU, CATHFQ)
C-----------------------------------------------------------------------
      IERR = 0
      CALL COPY (256, CATFQ, CATEQU)
      CALL AXEFND (8, 'FREQ    ', CATEQU(KIDIM), CATHFQ(KHCTP), MLOCF,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1020) IERR
         GO TO 990
         END IF
C                                       Does table exist
      CHEXIS = .FALSE.
      CALL ISTAB ('FQ', DISK, CNO, 1, LUN, BUFFER, TABLE, FQEXIS,
     *   FITASC, IERR)
      IF (.NOT. FQEXIS) THEN
         CALL ISTAB ('CH', DISK, CNO, 1, LUN, BUFFER, TABLE, CHEXIS,
     *      FITASC, IERR)
         END IF
      IF ((.NOT.FQEXIS) .AND. (.NOT.CHEXIS)) GO TO 500
      IF (CHEXIS) GO TO 400
C                                       Open table and fill arrays
      CALL FQINI ('READ', BUFFER, DISK, CNO, 1, CATFQ, LUN, RNOFQ,
     *   KOLSFQ, NUMVFQ, NUMIFQ, IERR)
      IF (IERR.NE.0) GO TO 999
      FQNUMB = BUFFER(5)
      IF ((IDFREQ.EQ.-1) .AND. (FQNUMB.GT.1)) THEN
         IERR = 1
         WRITE (MSGTXT,1000) IDFREQ, FQNUMB
         CALL MSGWRT (8)
         WRITE (MSGTXT,1010)
         GO TO 980
         END IF
C                                       Find match to IDFREQ
      DO 100 I = 1,FQNUMB
         IFQN = I
         CALL TABFQ ('READ', BUFFER, IFQN, KOLSFQ, NUMVFQ, NUMIFQ, FQID,
     *      FREQFQ, CHBWFQ, TBWFQ, SIDFQ, BNDCOD, IERR)
         IF (IERR.NE.0) GO TO 980
         IF ((FQID.EQ.IDFREQ) .OR. (FQNUMB.EQ.1)) THEN
            DO 50 IIF = 1, NUMIFQ
               FREQFQ(IIF) = CATDFQ(KDCRV+MLOCF) + FREQFQ(IIF)
 50            CONTINUE
            GO TO 200
            END IF
 100     CONTINUE
C                                       No match
      IERR = 11
 200  CALL TABIO ('CLOS', 0, RNOFQ, BUFFER, BUFFER, JERR)
      GO TO 999
C                                       Use CH table
 400  CALL CHNDAT ('READ', BUFFER, DISK, CNO, 1, CATFQ, LUN, NUMIFQ,
     *   FREQFQ, SIDFQ, CHBWFQ, BNDCOD, IDFREQ, IERR)
      IF (IERR.NE.0) GO TO 999
      DO 450 IIF = 1, NUMIFQ
         FREQFQ(IIF) = CATDFQ(KDCRV+MLOCF) + FREQFQ(IIF)
         TBWFQ(IIF) = ABS(CHBWFQ(IIF) * CATFQ(KINAX+MLOCF))
 450     CONTINUE
      GO TO 999
C                                       Get info from header.
 500  IERR = 0
      FREQFQ(1) = CATDFQ(KDCRV+MLOCF)
      CHBWFQ(1) = CATRFQ(KRCIC+MLOCF)
      TBWFQ(1) = ABS(CHBWFQ(1) * CATFQ(KINAX+MLOCF))
      SIDFQ(1) = 1
      GO TO 999
C
 980  CALL MSGWRT (8)
      CALL TABIO ('CLOS', 0, RNOFQ, BUFFER, BUFFER, JERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETFQ: FREQSEL = ',I3,'; # ROWS IN FQ TABLE = ',I4)
 1010 FORMAT ('GETFQ: RERUN TASK SELECTING FREQSEL EXPLICITLY')
 1020 FORMAT ('GETFQ: ERROR ',I3,' DETERMINING FREQ. AXIS')
      END

LOCAL INCLUDE 'PCDATA.INC'
      INCLUDE 'INCS:PPCV.INC'
      DOUBLE PRECISION TIME, CABCAL, PCFREQ(2,MAXTON,MAXIF)
      INTEGER   PCNPOL, PCNIF, NUMTON, PCBUFF(512), PCNUMV(MAXPCC),
     *   PCKOLS(MAXPCC), PCRNO, SOUNUM, ANTNUM, ISUB, IDFREQ, NPCINR
      REAL TIMINT, STATE(2,4,MAXIF), PCREAL(2,MAXTON,MAXIF),
     *   PCIMAG(2,MAXTON,MAXIF), PCRATE(2,MAXTON,MAXIF)
      COMMON /PCDATA/ PCFREQ, TIME, CABCAL, STATE, PCREAL, PCIMAG,
     *   PCRATE, PCBUFF, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON, PCRNO,
     *   TIMINT, SOUNUM, ANTNUM, ISUB, IDFREQ, NPCINR
LOCAL END
LOCAL INCLUDE 'PCSCAN.INC'
      INTEGER   SSCAN(3,1000), NOSCAN
      REAL      TSCAN(2,1000)
      COMMON /PCSCAN/ TSCAN, SSCAN, NOSCAN
LOCAL END
LOCAL INCLUDE 'PCBPASS.INC'
      INCLUDE 'INCS:DCHND.INC'
      INTEGER   BPBUFF(512), IBPRNO, BPKOLS(MAXBPC), BPNUMV(MAXBPC),
     *   BPNIF, BPNCHN, BPNPOL, BPFQID, BPREFA, BPNUMA, BPSUBA
      REAL      BANDW, WEIGHT(2*MAXIF)
      DOUBLE PRECISION CHSHFT(MAXIF)
      COMMON /PCBPAS/ CHSHFT, BPBUFF, WEIGHT, BANDW, IBPRNO, BPKOLS,
     *   BPNUMV, BPNIF, BPNCHN, BPNPOL, BPFQID, BPREFA, BPNUMA, BPSUBA
LOCAL END
LOCAL INCLUDE 'PCASS.INC'
      INCLUDE 'INCS:PUVD.INC'
      REAL      XSEQ, XDISK, XVER, XFQ, XSUB, BPARM(10), BADD(10)
      HOLLERITH XINNAM(3), XINCLS(2), CALSOR(4,30)
      CHARACTER INNAM*12, INCLS*6
      COMMON /INPARM/ XINNAM, XINCLS, XSEQ, XDISK, XVER, XFQ, XSUB,
     *   CALSOR, BPARM, BADD
      COMMON /CHPARM/ INNAM, INCLS
C
      INTEGER   INSEQ, INDISK, INVERS, CNO, OUVER, SCRTCH(512)
      COMMON /PCASSC/ SCRTCH, INSEQ, INDISK, INVERS, CNO, OUVER
LOCAL END
      PROGRAM PCASS
C-----------------------------------------------------------------------
C! Finds bandpass table spectra from PC table spectra
C# EXT-appl Calibration Table
C-----------------------------------------------------------------------
C;  Copyright (C) 2016-2018, 2022, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Smooths/interpolates bandpass table to regular intervals
C   Inputs from user
C      INNAME.....Input UV file name (name).      Standard defaults.
C      INCLASS....Input UV file name (class).     Standard defaults.
C      INSEQ......Input UV file name (seq. #).    0 => highest.
C      INDISK.....Disk drive # of input UV file.  0 => any.
C      INVERS.....Specifies the version of the PC table to be read as
C                 input.   0 -> highest.
C                 The output version is always highest + 1.
C      FREQID.....Frequency ID - 0 all
C      SUBARRAY...Subarray number - 0 all
C      CALSOUR....Calibration sources - all ' ' -> all
C      SOLINT.....Integration time in minutes (<= 0 -> scan)
C-----------------------------------------------------------------------
      INTEGER   IRET
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'PCASS.INC'
C-----------------------------------------------------------------------
C                                       Get parms, open things
      CALL PCASSI (IRET)
C                                       do bandpass
      IF (IRET.EQ.0) CALL PCASST (IRET)
C                                       close down
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE PCASSI (IERR)
C-----------------------------------------------------------------------
C   PCASSI performs initialization for AIPS task PCASS.  It gets the
C   adverbs, opens the catalog file for 'WRIT' (eventually), sorts and
C   opens the PC input file, and determines the scan structure applying
C   to the calibration sources
C   Output:
C      IERR    I      Error code: 0 => keep going, else quit.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'PCASS.INC'
      INCLUDE 'PCDATA.INC'
      INCLUDE 'PCSCAN.INC'
      INCLUDE 'PCBPASS.INC'
      INCLUDE 'INCS:DSEL.INC'
      CHARACTER INTYP*2, STAT*4, PRGN*6, KEYSPC(2)*24
      INTEGER   IROUND, PCLUN, JERR, KEY(2,2), NKEY, KOLS(2), J1, J2,
     *   I, KEYSUB(2,2), IROW, BUFFER(612), VER, LUN, IDSOUR, JSUB,
     *   IFQID, VSTART, VEND, NROW, NPARMS, BPLUN
      REAL      FKEY(2,2), TEPS, DTIME, RTIME
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PCLUN, BPLUN, LUN, INTYP /87, 88, 43, 'UV'/
      DATA PRGN /'PCASS '/
      DATA NKEY /2/
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
      DATA KEYSPC /'ANTENNA_NO', 'TIME '/
C                                       8 milliseconds
      DATA TEPS /9.E-8/
C-----------------------------------------------------------------------
C                                       AIPS init
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      NCFILE = 0
      NSCR = 0
C                                       get adverbs
      NPARMS = 150
      IERR = 0
      CALL GTPARM (PRGN, NPARMS, RQUICK, XINNAM, PCBUFF, JERR)
      IF (JERR.NE.0) THEN
         RQUICK = .TRUE.
         IERR = 8
         IF (JERR.EQ.1) THEN
            GO TO 999
         ELSE
            WRITE (MSGTXT,1000) JERR, 'GET INPUT ADVERBS'
            CALL MSGWRT (8)
            END IF
         END IF
C                                       restart AIPS
      IF (RQUICK) CALL RELPOP (IERR, PCBUFF, JERR)
      IF (IERR.NE.0) GO TO 999
C                                       Hollerith -> Char
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      CALL H2CHR (12, 1, XINNAM, INNAM)
      CALL H2CHR (6, 1, XINCLS, INCLS)
      INSEQ = IROUND (XSEQ)
      INDISK = IROUND (XDISK)
      INVERS = IROUND (XVER)
      CNO = 1
      CALL CATDIR ('SRCH', INDISK, CNO, INNAM, INCLS, INSEQ, INTYP,
     *   NLUSER, STAT, PCBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, INNAM, INCLS, INSEQ, INTYP,
     *      INDISK
         GO TO 990
         END IF
C                                       Get catblk, mark file write
      CALL CATIO ('READ', INDISK, CNO, CATBLK, 'WRIT', PCBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READ CATALOG HEADER'
         GO TO 990
         END IF
      NCFILE = 1
      FVOL(1) = INDISK
      FCNO(1) = CNO
      FRW(1) = 1
      CALL UVPGET (IERR)
C                                       DSEL parms
      IUDISK = INDISK
      IUCNO = CNO
      CALL COPY (256, CATBLK, CATUV)
C                                       Open PC file
      CALL PCINI ('READ', PCBUFF, INDISK, CNO, INVERS, CATBLK, PCLUN,
     *   PCRNO, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN INPUT PC TABLE'
         GO TO 990
         END IF
C                                       Set column pointers for sort
      CALL FNDCOL (NKEY, KEYSPC, 24, .TRUE., PCBUFF, KOLS, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FIND PC COLUMNS'
         GO TO 990
         END IF
C                                       Sort to ant-time order
      J1 = 1
      J2 = 2
      IF ((PCBUFF(43).NE.KOLS(J1)) .OR. (PCBUFF(44).NE.KOLS(J2))) THEN
C                                       Close
         CALL TABIO ('CLOS', 0, PCRNO, PCBUFF, PCBUFF, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'CLOSE PC TABLE'
            GO TO 990
            END IF
         MSGTXT = 'Sorting input PC table'
         CALL MSGWRT (2)
C                                       sort
         KEY(1,1) = KOLS(J1)
         KEY(2,1) = KOLS(J1)
         KEY(1,2) = KOLS(J2)
         KEY(2,2) = KOLS(J2)
         CALL TABSRT (INDISK, CNO, 'PC', INVERS, INVERS, KEY, KEYSUB,
     *      FKEY, PCBUFF, CATBLK, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'SORT PC TABLE'
            GO TO 990
            END IF
C                                       Re-open PC table for read
         CALL PCINI ('READ', PCBUFF, INDISK, CNO, INVERS, CATBLK, PCLUN,
     *      PCRNO, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPEN SORTED PC TABLE'
            GO TO 990
            END IF
         END IF
C                                       number of records
      NPCINR = PCBUFF(5)
      FRQSEL = IROUND (XFQ)
      IF (FRQSEL.LE.0) FRQSEL = 0
      SUBARR = IROUND (XSUB)
      IF (SUBARR.LE.0) SUBARR = 0
      XSUB = SUBARR
C                                       find cal sources
      DO 20 I= 1,30
         CALL H2CHR (16, 1, CALSOR(1,I), SOURCS(I))
         CALSOU(I) = SOURCS(I)
 20      CONTINUE
      IXLUN = 28
      CALL SOUFIL (IERR)
C                                       find scan structure
      VER = 1
      CALL NDXINI ('READ', BUFFER, INDISK, CNO, VER, CATBLK, LUN,
     *   INXRNO, NXKOLS, NXNUMV, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING INDEX TABLE'
         GO TO 990
         END IF
      NROW = BUFFER(5)
      NOSCAN = 0
      DO 100 IROW = 1,NROW
         CALL TABNDX ('READ', BUFFER, INXRNO, NXKOLS, NXNUMV, RTIME,
     *      DTIME, IDSOUR, JSUB, VSTART, VEND, IFQID, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READING INDEX TABLE'
            GO TO 990
            END IF
C                                       subarray, fqid match
         IF ((SUBARR.GT.0) .AND. (JSUB.GT.0) .AND. (JSUB.NE.SUBARR))
     *      GO TO 100
         IF ((FRQSEL.GT.0) .AND. (IFQID.GT.0) .AND. (IFQID.NE.FRQSEL))
     *      GO TO 100
C                                       desired source
         IF (NCALWD.GT.0) THEN
            DO 30 I = 1,NCALWD
               IF (IDSOUR.EQ.CALWAN(I)) THEN
                  IF (.NOT.DOCWNT) GO TO 100
                  GO TO 40
                  END IF
 30            CONTINUE
            IF (DOCWNT) GO TO 100
            END IF
 40      NOSCAN = NOSCAN + 1
         TSCAN(1,NOSCAN) = RTIME - 0.5 * DTIME - TEPS
         TSCAN(2,NOSCAN) = RTIME + 0.5 * DTIME + TEPS
         SSCAN(1,NOSCAN) = IDSOUR
         SSCAN(2,NOSCAN) = JSUB
         SSCAN(3,NOSCAN) = IFQID
 100     CONTINUE
      CALL TABNDX ('CLOS', BUFFER, INXRNO, NXKOLS, NXNUMV, RTIME, DTIME,
     *   IDSOUR, JSUB, VSTART, VEND, IFQID, IERR)
C                                       set up BP parameters
      IF (JLOCIF.GE.0) THEN
         BPNIF = CATBLK(KINAX+JLOCIF)
      ELSE
         BPNIF = 1
         END IF
      BPNCHN = CATBLK(KINAX+JLOCF)
      BPNPOL = MIN (2, CATBLK(KINAX+JLOCS))
      BPREFA = 0
C                                       get FQ settings first
      VER = 1
      CALL CHNDAT ('READ', BPBUFF, INDISK, CNO, VER, CATBLK, BPLUN,
     *   NUMIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING FQ TABLE FOR FREQUENCIES'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PCASSI: ERROR',I5,' ON ',A)
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,1X,A2,
     *   'DISK=',I2)
      END
      SUBROUTINE PCASST (IERR)
C-----------------------------------------------------------------------
C   PCASST uses the open PC table to generate a bandpass table
C   Output:
C      IERR   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'PCASS.INC'
      INCLUDE 'PCDATA.INC'
      INCLUDE 'PCBPASS.INC'
      INCLUDE 'PCSCAN.INC'
      INTEGER   IANT, ISCAN, JREC, I, K, LIF, LTONE, LPOL, J, IFSTEP,
     *   PCOUNT(2,MAXTON,MAXIF), BPLUN, NUMSHF, BCHAN
      LONGINT   BPPTR
      LOGICAL   FIRST
      REAL      BNDPAS(2), PCSUM(3,2,MAXTON,MAXIF), PCDELY(2,MAXIF),
     *   PCPHAS(2,MAXIF), ERDELY(2,MAXIF), ERPHAS(2,MAXIF), PRTLEV,
     *   LOWSHF, DELSHF
      DOUBLE PRECISION PCFRQS(2,MAXTON,MAXIF)
      CHARACTER LBPTYP*8
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA BPLUN /88/
C-----------------------------------------------------------------------
      IFSTEP = 1
      PRTLEV = 0.0

C                                       memory for BNDPAS
      J = (2 * BPNCHN * BPNIF * BPNPOL - 1) / 1024 + 4
      CALL ZMEMRY ('GET ', 'PCASST', J, BNDPAS, BPPTR, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'GETTING DYNAMIC MEMORY'
         GO TO 990
         END IF
C                                       get max ant number
      PCRNO = NPCINR
      CALL TABPC ('READ', PCBUFF, PCRNO, PCKOLS, PCNUMV, PCNPOL,
     *   TIME, TIMINT, SOUNUM, ANTNUM, ISUB, IDFREQ, CABCAL,
     *   STATE, PCFREQ, PCREAL, PCIMAG, PCRATE, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READ PC TABLE MAX REC'
         GO TO 990
         END IF
      BPNUMA = ANTNUM
C                                       create new BP table
      OUVER = 0
      BCHAN = 1
      NUMSHF = 2
      LOWSHF = 0.0
      DELSHF = 0.0
      LBPTYP = ' '
      CALL BPINI ('WRIT', BPBUFF, INDISK, CNO, OUVER, CATBLK, BPLUN,
     *   IBPRNO, BPKOLS, BPNUMV, BPNUMA, BPNPOL, BPNIF, BPNCHN, BCHAN,
     *   NUMSHF, LOWSHF, DELSHF, LBPTYP, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CREATING NEW BP TABLE'
         GO TO 990
         END IF
C                                       loop through PC table
      JREC = 0
      K = 2 * MAXTON * MAXIF
      DO 200 IANT = 1,BPNUMA
         CALL FILL (K, 0, PCOUNT)
         CALL RFILL (3*K, 0.0, PCSUM)
         ISCAN = 0
         FIRST = .TRUE.
         WRITE (MSGTXT,1010) IANT
         CALL MSGWRT (2)
 10      PCRNO = JREC + 1
         IF (PCRNO.GT.NPCINR) GO TO 100
         CALL TABPC ('READ', PCBUFF, PCRNO, PCKOLS, PCNUMV, PCNPOL,
     *      TIME, TIMINT, SOUNUM, ANTNUM, ISUB, IDFREQ, CABCAL,
     *      STATE, PCFREQ, PCREAL, PCIMAG, PCRATE, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READ PC TABLE'
            GO TO 990
            END IF
         IF (IERR.LT.0) THEN
            JREC = JREC + 1
            GO TO 10
            END IF
         IF (ANTNUM.NE.IANT) GO TO 100
C                                       find which scan
 15      IF (BPARM(4).GT.0.0) ISCAN = 0
         IF (ISCAN.EQ.0) THEN
            DO 20 I = 1,NOSCAN
               IF ((TIME.GE.TSCAN(1,I)) .AND. (TIME.LE.TSCAN(2,I)))
     *            ISCAN = I
 20            CONTINUE
            IF (ISCAN.EQ.0) THEN
               JREC = JREC + 1
               GO TO 10
               END IF
            IF (BPARM(4).LE.0.0) FIRST = .TRUE.
            END IF
C                                       add in
         IF (TIME.LE.TSCAN(2,ISCAN)) THEN
            CALL PCFITR (ANTNUM, PCNPOL, PCNIF, IFSTEP, NUMTON, PCFREQ,
     *         PCREAL, PCIMAG, PRTLEV, PCDELY, PCPHAS, ERDELY, ERPHAS,
     *         WEIGHT, IERR)
            DO 40 LIF = 1,PCNIF
               DO 35 LTONE = 1,NUMTON
                  DO 30 LPOL = 1,PCNPOL
                     IF (FIRST) PCFRQS(LPOL,LTONE,LIF) =
     *                  PCFREQ(LPOL,LTONE,LIF)
                     IF ((PCREAL(LPOL,LTONE,LIF).NE.FBLANK) .AND.
     *                  (PCIMAG(LPOL,LTONE,LIF).NE.FBLANK)) THEN
                        PCOUNT(LPOL,LTONE,LIF) = 1 +
     *                     PCOUNT(LPOL,LTONE,LIF)
                        PCSUM(1,LPOL,LTONE,LIF) =
     *                     PCSUM(1,LPOL,LTONE,LIF) +
     *                     SQRT (PCREAL(LPOL,LTONE,LIF)**2 +
     *                     PCIMAG(LPOL,LTONE,LIF)**2)
                        PCSUM(2,LPOL,LTONE,LIF) = PCREAL(LPOL,LTONE,LIF)
     *                     + PCSUM(2,LPOL,LTONE,LIF)
                        PCSUM(3,LPOL,LTONE,LIF) = PCIMAG(LPOL,LTONE,LIF)
     *                     + PCSUM(3,LPOL,LTONE,LIF)
                        END IF
 30                  CONTINUE
 35               CONTINUE
 40            CONTINUE
            JREC = JREC + 1
            FIRST = .FALSE.
            GO TO 10
C                                       scan done - average
        ELSE
            J = 0
            DO 60 LIF = 1,PCNIF
               DO 55 LTONE = 1,NUMTON
                  DO 50 LPOL = 1,PCNPOL
                     IF (PCOUNT(LPOL,LTONE,LIF).GT.0) THEN
                        PCSUM(1,LPOL,LTONE,LIF) =
     *                     PCSUM(1,LPOL,LTONE,LIF) /
     *                     PCOUNT(LPOL,LTONE,LIF)
                        PCSUM(2,LPOL,LTONE,LIF) =
     *                     PCSUM(2,LPOL,LTONE,LIF) /
     *                     PCOUNT(LPOL,LTONE,LIF)
                        PCSUM(3,LPOL,LTONE,LIF) =
     *                     PCSUM(3,LPOL,LTONE,LIF) /
     *                     PCOUNT(LPOL,LTONE,LIF)
                        J = J + 1
                     ELSE
                        PCSUM(1,LPOL,LTONE,LIF) = FBLANK
                        PCSUM(2,LPOL,LTONE,LIF) = FBLANK
                        PCSUM(3,LPOL,LTONE,LIF) = FBLANK
                        END IF
 50                  CONTINUE
 55               CONTINUE
 60            CONTINUE
            IF (J.GT.0) THEN
               CALL BPWRIT (IANT, TSCAN(1,ISCAN), SSCAN(1,ISCAN), PCSUM,
     *            PCFRQS, BPNCHN, BPNIF, BPNPOL, BNDPAS(1+BPPTR),
     *            IERR)
               IF (IERR.NE.0) GO TO 999
               END IF
            ISCAN = 0
            CALL FILL (K, 0, PCOUNT)
            CALL RFILL (3*K, 0.0, PCSUM)
            GO TO 15
            END IF
C                                       antenna or whole file done
 100     J = 0
         DO 120 LIF = 1,PCNIF
            DO 115 LTONE = 1,NUMTON
               DO 110 LPOL = 1,PCNPOL
                  IF (PCOUNT(LPOL,LTONE,LIF).GT.0) THEN
                     PCSUM(1,LPOL,LTONE,LIF) = PCSUM(1,LPOL,LTONE,LIF) /
     *                  PCOUNT(LPOL,LTONE,LIF)
                     PCSUM(2,LPOL,LTONE,LIF) = PCSUM(2,LPOL,LTONE,LIF) /
     *                  PCOUNT(LPOL,LTONE,LIF)
                     PCSUM(3,LPOL,LTONE,LIF) = PCSUM(3,LPOL,LTONE,LIF) /
     *                  PCOUNT(LPOL,LTONE,LIF)
                     J = J + 1
                  ELSE
                     PCSUM(1,LPOL,LTONE,LIF) = FBLANK
                     PCSUM(2,LPOL,LTONE,LIF) = FBLANK
                     PCSUM(3,LPOL,LTONE,LIF) = FBLANK
                     END IF
 110              CONTINUE
 115           CONTINUE
 120        CONTINUE
         IF (J.GT.0) THEN
            CALL BPWRIT (IANT, TSCAN(1,ISCAN), SSCAN(1,ISCAN), PCSUM,
     *         PCFRQS, BPNCHN, BPNIF, BPNPOL, BNDPAS(1+BPPTR), IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         IF (PCRNO.GT.NPCINR) GO TO 900
 200     CONTINUE
C                                       close tables
 900  CALL TABIO ('CLOS', 0, IBPRNO, BPBUFF, BPBUFF, IERR)
      CALL TABIO ('CLOS', 0, PCRNO, PCBUFF, PCBUFF, IERR)
      IERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PCASST: ERROR',I4,' ON ',A)
 1010 FORMAT ('Starting on antenna',I3)
      END
      SUBROUTINE BPWRIT (IANT, TSCAN, SSCAN, PCSUM, PCFRQS, NC, NI, NP,
     *   BNDPAS, IERR)
C-----------------------------------------------------------------------
C   BPWRIT fills in a BP table record interpolating from PC freqs
C   Inputs:
C      IANT     I      Antenna number
C      TSCAN    R(2)   Time range
C      SSCAN    I(3)   source number, subarray, fqid
C      PCSUM    R(*)   Average PC amplitude (3,2,MAXTON,MAXIF)
C      PCFRQS   D(*)   Frequencies of PC data (2,MAXTON,MAXIF)
C      NC       I      Number channel in BNDPAS
C      NI       I      Number IFs in BNDPAS
C      NP       I      Number polarizations in BNDPAS
C   Outputs:
C      BNDPAS   R(*)   bandpass function (2,NC,NI,NP)
C      IERR     I      error code from TABBP
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PPCV.INC'
      INTEGER   IANT, SSCAN(3), NC, NI, NP, IERR
      REAL      TSCAN(2), PCSUM(3,2,MAXTON,*), BNDPAS(2,NC,NI,NP)
      DOUBLE PRECISION PCFRQS(2,MAXTON,*)
C
      INCLUDE 'PCASS.INC'
      INCLUDE 'PCBPASS.INC'
      INCLUDE 'PCDATA.INC'
      INTEGER   LCHAN, LIF, LP, SOURID, REFANT, NS(2)
      REAL      BPAMP(3,2), INTERV, BPS(2), FACT, AMP, PHAS
      DOUBLE PRECISION CFREQ, BPTIME
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      SOURID = SSCAN(1)
      BPSUBA = SSCAN(2)
      BPFQID = SSCAN(3)
      BPTIME = (TSCAN(1) + TSCAN(2)) / 2.0
      INTERV = TSCAN(2) - TSCAN(1)
      REFANT = 0
      DO 50 LIF = 1,NI
         WEIGHT(LIF) = 1.0
         IF (NP.EQ.2) WEIGHT(LIF+NI) = 1.0
         NS(1) = 0
         NS(2) = 0
         BPS(1) = 0.0
         BPS(2) = 0.0
         DO 30 LCHAN = 1,NC
            CFREQ = CATD(KDCRV+JLOCF) + (LCHAN - CATR(KRCRP+JLOCF)) *
     *         FINC(LIF) + FOFF(LIF)
            CALL GETVAL (BPARM(3), CFREQ, NUMTON, PCFRQS(1,1,LIF),
     *         PCSUM(1,1,1,LIF), NP, BPAMP)
            DO 20 LP = 1,NP
               IF (BPAMP(1,LP).EQ.FBLANK) THEN
                  BNDPAS(1,LCHAN,LIF,LP) = FBLANK
                  BNDPAS(2,LCHAN,LIF,LP) = FBLANK
               ELSE
                  IF (BPARM(1).GT.0.0) THEN
                     AMP = SQRT (BPAMP(2,LP)**2 + BPAMP(3,LP)**2)
                  ELSE
                     AMP = BPAMP(1,LP)
                     END IF
                  IF (BPARM(2).GT.0.0) THEN
                     PHAS = ATAN2 (BPAMP(3,LP), BPAMP(2,LP))
                  ELSE
                     PHAS = 0
                     END IF
                  BNDPAS(1,LCHAN,LIF,LP) = AMP * COS (PHAS)
                  BNDPAS(2,LCHAN,LIF,LP) = AMP * SIN (PHAS)
                  IF ((LCHAN.GT.1) .AND.(LCHAN.LT.NC)) THEN
                     NS(LP) = NS(LP) + 1
                     BPS(LP) = BPS(LP) + AMP
                     END IF
                  END IF
 20            CONTINUE
 30         CONTINUE
C                                       normalize
         DO 45 LP = 1,NP
            IF (NS(LP).GT.0) THEN
               FACT = BPS(LP) / NS(LP)
               IF (FACT.LE.0.0) FACT = 1.0
               DO 40 LCHAN = 1,NC
                  IF (BNDPAS(1,LCHAN,LIF,LP).NE.FBLANK) THEN
                     BNDPAS(1,LCHAN,LIF,LP) = BNDPAS(1,LCHAN,LIF,LP) /
     *                  FACT
                     BNDPAS(2,LCHAN,LIF,LP) = BNDPAS(2,LCHAN,LIF,LP) /
     *                  FACT
                     END IF
 40               CONTINUE
               END IF
 45         CONTINUE
 50      CONTINUE
      CALL TABBP ('WRIT', BPBUFF, IBPRNO, BPKOLS, BPNUMV, BPNIF, BPNCHN,
     *   BPNPOL, BPTIME, INTERV, SOURID, BPSUBA, IANT, BANDW, CHSHFT,
     *   BPFQID, REFANT, WEIGHT, BNDPAS, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'WRITING BP TABLE'
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPWRIT: ERROR',I4,' ON ',A)
      END
      SUBROUTINE GETVAL (DOSQRT, CFREQ, NUMTON, PCFRQS, PCSUM, NP,
     *   BPAMP)
C-----------------------------------------------------------------------
C   GETVAL finds the frequencies closest to the channel frequency in
C   the PC table and then interpolates to find the bandpass value
C   Inputs
C      DOSQRT   R          > 0 -> take SQRT of amp
C      CFREQ    D          channel frequency
C      NUMTON   I          Number of tones
C      PCFRQS   D(2,*)     PC table frequencies
C      PCSUM    R(3,2,*)   PC table amplitudes, real, imag
C      NP       I          Number polarizatiosn
C   Outputs
C      BPAMP    R(3,2)     BP correction value (sqrt (interp PCSUM))
C-----------------------------------------------------------------------
      DOUBLE PRECISION CFREQ, PCFRQS(2,*)
      INTEGER   NUMTON, NP
      REAL      DOSQRT, PCSUM(3,2,*), BPAMP(3,*)
C
      INCLUDE 'INCS:PPCV.INC'
      INTEGER   LP, J1, J2, J3, I
      DOUBLE PRECISION DIFFS(MAXTON), DMIN, ARG(3), FUNC(3), FITPAR,
     *   DMAX
      REAL      AMP, PHAS, RAMP, IAMP
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      DO 50 LP = 1,NP
         BPAMP(1,LP) = FBLANK
         BPAMP(2,LP) = FBLANK
         BPAMP(3,LP) = FBLANK
         DO 10 I = 1,NUMTON
            IF (PCSUM(1,LP,I).NE.FBLANK) THEN
               DIFFS(I) = ABS (CFREQ - PCFRQS(LP,I))
            ELSE
               DIFFS(I) = 1.0D30
               END IF
 10         CONTINUE
C                                       find min
         J1 = 0
         J2 = 0
         J3 = 0
         DMIN = 1.0D20
         DO 15 I = 1,NUMTON
            IF (DIFFS(I).LT.DMIN) THEN
               J1 = I
               DMIN = DIFFS(I)
               END IF
 15         CONTINUE
         DMIN = 1.0D20
         DO 20 I = 1,NUMTON
            IF ((DIFFS(I).LT.DMIN) .AND. (I.NE.J1)) THEN
               J2 = I
               DMIN = DIFFS(I)
               END IF
 20         CONTINUE
         DMIN = 1.0D20
         DO 25 I = 1,NUMTON
            IF ((DIFFS(I).LT.DMIN) .AND. (I.NE.J1) .AND. (I.NE.J2)) THEN
               J3 = I
               DMIN = DIFFS(I)
               END IF
 25         CONTINUE
C                                       do we have all 3?
         IF (J3.LE.0) THEN
            IF (J2.LE.0) THEN
               IF (J1.NE.0) THEN
                  BPAMP(1,LP) = PCSUM(1,LP,J1)
                  AMP = SQRT (PCSUM(2,LP,J1)**2 + PCSUM(3,LP,J1)**2)
                  IF (DOSQRT.GT.0.0) THEN
                     BPAMP(1,LP) = SQRT (BPAMP(1,LP))
                     AMP = SQRT (AMP)
                     END IF
                  PHAS = ATAN2 (PCSUM(3,LP,J1), PCSUM(2,LP,J1))
                  BPAMP(2,LP) = AMP * COS (PHAS)
                  BPAMP(3,LP) = AMP * SIN (PHAS)
                  END IF
            ELSE
               BPAMP(1,LP) = PCSUM(1,LP,J1) + (CFREQ - PCFRQS(LP,J1)) *
     *            (PCSUM(1,LP,J2) - PCSUM(1,LP,J1)) /
     *            (PCFRQS(LP,J2) - PCFRQS(LP,J1))
               IF (DOSQRT.GT.0.0) BPAMP(1,LP) = SQRT (BPAMP(1,LP))
               RAMP = PCSUM(2,LP,J1) + (CFREQ - PCFRQS(LP,J1)) *
     *            (PCSUM(2,LP,J2) - PCSUM(2,LP,J1)) /
     *            (PCFRQS(LP,J2) - PCFRQS(LP,J1))
               IAMP = PCSUM(3,LP,J1) + (CFREQ - PCFRQS(LP,J1)) *
     *            (PCSUM(3,LP,J2) - PCSUM(3,LP,J1)) /
     *            (PCFRQS(LP,J2) - PCFRQS(LP,J1))
               AMP = SQRT (RAMP*RAMP + IAMP*IAMP)
               IF (DOSQRT.GT.0.0) AMP = SQRT (AMP)
               PHAS = ATAN2 (IAMP, RAMP)
               BPAMP(2,LP) = AMP * COS (PHAS)
               BPAMP(3,LP) = AMP * SIN (PHAS)
               END IF
C                                       yes
         ELSE
            ARG(1) = CFREQ - PCFRQS(LP,J1)
            ARG(2) = CFREQ - PCFRQS(LP,J2)
            ARG(3) = CFREQ - PCFRQS(LP,J3)
            DMIN = ARG(1) * ARG(3) * (ARG(3)-ARG(1))
            DMAX = ARG(1) * ARG(2) * (ARG(2)-ARG(1))
            FUNC(1) = PCSUM(1,LP,J1)
            FUNC(2) = PCSUM(1,LP,J2)
            FUNC(3) = PCSUM(1,LP,J3)
            FITPAR =
     *         ((FUNC(1)*ARG(2)*ARG(2) - FUNC(2)*ARG(1)*ARG(1)) * DMIN -
     *         (FUNC(1)*ARG(3)*ARG(3) - FUNC(3)*ARG(1)*ARG(1)) * DMAX) /
     *         ((ARG(2)**2-ARG(1)**2)*DMIN - (ARG(3)**2-ARG(1)**2)*DMAX)
            IF (FITPAR.GT.0.0D0) THEN
               BPAMP(1,LP) = FITPAR
               IF (DOSQRT.GT.0.0) BPAMP(1,LP) = SQRT (BPAMP(1,LP))
               END IF
            FUNC(1) = PCSUM(2,LP,J1)
            FUNC(2) = PCSUM(2,LP,J2)
            FUNC(3) = PCSUM(2,LP,J3)
            RAMP =
     *         ((FUNC(1)*ARG(2)*ARG(2) - FUNC(2)*ARG(1)*ARG(1)) * DMIN -
     *         (FUNC(1)*ARG(3)*ARG(3) - FUNC(3)*ARG(1)*ARG(1)) * DMAX) /
     *         ((ARG(2)**2-ARG(1)**2)*DMIN - (ARG(3)**2-ARG(1)**2)*DMAX)
            FUNC(1) = PCSUM(3,LP,J1)
            FUNC(2) = PCSUM(3,LP,J2)
            FUNC(3) = PCSUM(3,LP,J3)
            IAMP =
     *         ((FUNC(1)*ARG(2)*ARG(2) - FUNC(2)*ARG(1)*ARG(1)) * DMIN -
     *         (FUNC(1)*ARG(3)*ARG(3) - FUNC(3)*ARG(1)*ARG(1)) * DMAX) /
     *         ((ARG(2)**2-ARG(1)**2)*DMIN - (ARG(3)**2-ARG(1)**2)*DMAX)
            AMP = SQRT (RAMP*RAMP + IAMP*IAMP)
            IF (DOSQRT.GT.0.0) AMP = SQRT (AMP)
            PHAS = ATAN2 (IAMP, RAMP)
            BPAMP(2,LP) = AMP * COS (PHAS)
            BPAMP(3,LP) = AMP * SIN (PHAS)
            END IF
 50      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ZVTVX3 (FCB, BUFSW, BUFFER, IERR)
C-----------------------------------------------------------------------
C! reads/writes from/to client (virtual TV) for the server (real TV)
C# TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZVTVX3 reads into TVMON (on the computer with the real TV) from the
C   computer running AIPS VTV code and returns answers and error codes.
C   Inputs:
C      FCB      I      File descriptor
C      BUFSW    I      Number words to send (incl header); if = 0,
C                      implies this is a read instead.
C   In/out:
C      BUFFER   I(*)   8-word header plus data buffer: in FITS-standard
C                      16-bit integer form!!!!!
C   Output:
C      IERR     I      Error: 0 => okay
C                         3 => IO error
C                         4 => End of File
C   Generic version - stub.
C-----------------------------------------------------------------------
      INTEGER   FCB(*), BUFSW, BUFFER(*), IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 8
      WRITE (MSGTXT,1000)
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZVTVX3: REQUIRES DEVELOPMENT; GENERIC IS A STUB')
      END

LOCAL INCLUDE 'QUXTR.INC'
C                                       Local include for QUXTR
      INCLUDE 'INCS:PMAD.INC'
C
      HOLLERITH XNAMEQ(3), XCLASQ(2), XNAMEU(3), XCLASU(2), XOUFIL(12)
      REAL      XSEQQ, XDISKQ, XSEQU, XDISKU, VPARM(2,15)
      REAL      BUFF(MABFSL), QUVALS(2,MAXIMG)
      DOUBLE PRECISION FREQS(MAXIMG)
      INTEGER   SEQI(2), DISKI(2), OLDCNO(2), JBUFSZ, CATOLD(256,2),
     *   SCRTCH(256), XPIX(15), YPIX(15), NPIX, NFREQS, EASY
      CHARACTER NAMEI(2)*12, CLASI(2)*6, OUTFIL*48
      COMMON /INPARM/ XNAMEQ, XCLASQ, XSEQQ, XDISKQ, XNAMEU, XCLASU,
     *   XSEQU, XDISKU, XOUFIL, VPARM
      COMMON /CHRCOM/ NAMEI, CLASI, OUTFIL
      COMMON /PARMS/ CATOLD, SEQI, DISKI, OLDCNO, JBUFSZ, XPIX, YPIX,
     *   EASY, NPIX, NFREQS
      COMMON /BUFRS/ FREQS, QUVALS, BUFF, SCRTCH
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C                                       End QUXTR
LOCAL END
      PROGRAM QUXTR
C-----------------------------------------------------------------------
C! extracts Q,U spectra to text file for input to TARS
C# Map Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   QUXTR is an AIPS task to modify an image by a model
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEI         Name of Q input image.
C      INCLASS        CLASI         Class of Q input image.
C      INSEQ          SEQI          Seq. of Q input image.
C      INDISK         DISKI         Disk number of Q input image.
C      IN2NAME        NAMEI         Name of U input image.
C      IN2CLASS       CLASI         Class of U input image.
C      IN2SEQ         SEQI          Seq. of U input image.
C      IN2DISK        DISKI         Disk number of U input image.
C      OUTFILE        OUTFIL        Base name of output file(s)
C      VPARM          VPARM(2,15)   List of x,y pixels to send out
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'QUXTR.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA PRGM /'QUXTR '/
C-----------------------------------------------------------------------
C                                       Get inputs
      CALL QUXTRI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       do it the easy way
      IF (EASY.LE.1) THEN
         CALL QUXTRE (IRET)
C                                       else poor transposition
      ELSE IF (EASY.EQ.2) THEN
         CALL QUXTR2 (IRET)
C                                       else poor transposition
      ELSE IF (EASY.EQ.3) THEN
         CALL QUXTR3 (IRET)
         END IF
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE QUXTRI (PRGN, IRET)
C-----------------------------------------------------------------------
C   QUXTRI gets input parameters for QUXTR and creates an output file.
C   Inputs:
C      PRGN    C*6       Program name
C   Output:
C      IRET    I         Error code: 0 => ok
C                           4 => user routine detected error.
C                           5 => catalog troubles
C                           8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER STAT*4, MTYPE*2, BNDCOD*8
      INTEGER   IERR, NPARM, IROUND, I, IRA, IDEC, IFREQ, NRA, NDEC,
     *   IFQ, FQBUFF(512), FQKOLS(MAXFQC), FQNUMV(MAXFQC), JRA, JDEC,
     *   IFQRNO, JFQ, NUMREC, NUMIF, IFSIDE, FQID, ILUN, FQVER
      DOUBLE PRECISION IFFREQ, IQFREQ
      REAL      IFCHW, IFTBW
      LOGICAL   ISFQ
      INCLUDE 'QUXTR.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSL
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 56
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEQ, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQI(1) = IROUND (XSEQQ)
      SEQI(2) = IROUND (XSEQU)
      DISKI(1) = IROUND (XDISKQ)
      DISKI(2) = IROUND (XDISKU)
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEQ, NAMEI(1))
      CALL H2CHR (6, 1, XCLASQ, CLASI(1))
      CALL H2CHR (12, 1, XNAMEU, NAMEI(2))
      CALL H2CHR (6, 1, XCLASU, CLASI(2))
      CALL H2CHR (48, 1, XOUFIL, OUTFIL)
C                                       Get CATBLK from old file.
      MTYPE = 'MA'
      DO 20 I = 1,2
         OLDCNO(I) = 1
         CALL CATDIR ('SRCH', DISKI(I), OLDCNO(I), NAMEI(I),
     *      CLASI(I), SEQI(I), MTYPE, NLUSER, STAT, SCRTCH, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, NAMEI(I), CLASI(I), SEQI(I),
     *         DISKI(I), NLUSER
            GO TO 990
            END IF
C                                       Read CATBLK and mark 'READ'.
         CALL CATIO ('READ', DISKI(I), OLDCNO(I), CATOLD(1,I),
     *      'READ', SCRTCH, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR, I
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKI(I)
         FCNO(NCFILE) = OLDCNO(I)
         FRW(NCFILE) = 0
 20      CONTINUE
      CALL COPY (256, CATOLD, CATBLK)
C                                       find which axis is which
      CALL AXEFND (4, 'RA--', CATBLK(KIDIM), CATH(KHCTP), IRA, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'RA-- AXIS NOT FOUND'
         GO TO 990
         END IF
      CALL AXEFND (4, 'DEC-', CATBLK(KIDIM), CATH(KHCTP), IDEC, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'DEC- AXIS NOT FOUND'
         GO TO 990
         END IF
      CALL AXEFND (4, 'FQID', CATBLK(KIDIM), CATH(KHCTP), IFQ, IRET)
      IF (IRET.EQ.0) THEN
         ISFQ = .TRUE.
         CALL AXEFND (4, 'FREQ', CATBLK(KIDIM), CATH(KHCTP), IFREQ,
     *      IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'FREQ AXIS NOT FOUND ALTHOUGH FQID ONE FOUND'
            GO TO 990
            END IF
         EASY = IFQ + 1
      ELSE
         ISFQ = .FALSE.
         CALL AXEFND (4, 'FREQ', CATBLK(KIDIM), CATH(KHCTP), IFREQ,
     *      IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'FREQ/FQID AXIS NOT FOUND'
            GO TO 990
            END IF
         EASY = IFREQ + 1
         END IF
      NRA = CATBLK(KINAX+IRA)
      NDEC = CATBLK(KINAX+IDEC)
      NPIX = 0
      DO 30 I = 1,15
         JRA = IROUND (VPARM(1,I))
         JDEC = IROUND (VPARM(2,I))
         IF ((JRA.LT.1) .OR. (JRA.GT.NRA) .OR. (JDEC.LT.1) .OR.
     *      (JDEC.GT.NDEC)) GO TO 40
         NPIX = NPIX + 1
         IF (IRA.LT.IDEC) THEN
            XPIX(NPIX) = JRA
            YPIX(NPIX) = JDEC
         ELSE
            XPIX(NPIX) = JDEC
            YPIX(NPIX) = JRA
            END IF
 30      CONTINUE
 40   IF (NPIX.LT.1) THEN
         MSGTXT = 'NO PIXEL POSITIONS SPECIFIED'
         IRET = 10
         GO TO 990
         END IF
C                                       get frequencies
      NFREQS = CATBLK(KINAX+IFREQ)
C                                       from header
      IF (.NOT.ISFQ) THEN
         DO 50 I = 1,NFREQS
            FREQS(I) = CATD(KDCRV+IFREQ) + (I - CATR(KRCRP+IFREQ)) *
     *         CATR(KRCIC+IFREQ)
 50         CONTINUE
C                                       from FQ table
      ELSE
         FQVER = 1
         ILUN = 53
         CALL FQINI ('READ', FQBUFF, DISKI(1), OLDCNO(1), FQVER, CATBLK,
     *      ILUN, IFQRNO, FQKOLS, FQNUMV, NUMIF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1050) IRET, 'OPENING FQ TABLE'
            GO TO 990
            END IF
C                                       Get number of records
         NUMREC = FQBUFF(5)
         IF (NUMREC.LT.NFREQS) THEN
            WRITE (MSGTXT,1055) NUMREC, NFREQS
            IRET = 10
            GO TO 990
            END IF
C                                       read FQ table
         CALL DFILL (NFREQS, 0.0D0, FREQS)
         DO 60 IFQRNO = 1,NUMREC
            JFQ = IFQRNO
            CALL TABFQ ('READ', FQBUFF, JFQ, FQKOLS, FQNUMV, NUMIF,
     *         FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1050) IRET, 'READING FQ TABLE'
               GO TO 990
               END IF
            IQFREQ = (FQID - CATD(KDCRV+IFQ)) / CATR(KRCIC+IFQ) +
     *         CATR(KRCRP+IFQ)
            I = IQFREQ + 0.01
            FREQS(I) = IFFREQ + CATD(KDCRV+IFREQ)
 60         CONTINUE
C                                      Close table.
         CALL TABIO ('CLOS', 0, IFQRNO, FQBUFF, FQBUFF, IRET)
         END IF
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('QUXTRI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1020 FORMAT ('QUXTRI: ERROR',I3,' COPYING CATBLK IMAGE',I2)
 1050 FORMAT ('QUXTRI: ERROR',I4,' ON ',A)
 1055 FORMAT ('QUXTRI: FQ TABLE # ROWS',I5,' LESS THAN EXPECTED',I5)
      END
      SUBROUTINE QUXTRE (IRET)
C-----------------------------------------------------------------------
C   QUXTRE finds and writes up to 15 text files with Q/U values taken
C   from the first axis of the images.
C   Output:
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER IFILE*48, CHARS*16, OUTLIN*80
      INTEGER   LUNI, NYI, NXI, WINI(4), BOI, IDEPTH(5), BOTEMP, IBIND,
     *   INDI, I, J, K, NLIN, JTRIM, TLUN, TIND
      LOGICAL   T, F
      INCLUDE 'QUXTR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUNI /16/
      DATA T, F /.TRUE.,.FALSE./
      DATA CHARS /'123456789ABCDEF'/
C-----------------------------------------------------------------------
C                                       loop over selected pixels
      DO 100 K = 1,NPIX
         WRITE (MSGTXT,1005) XPIX(K), YPIX(K), K
         CALL MSGWRT (2)
         DO 30 J = 1,2
            CALL COPY (256, CATOLD(1,J), CATBLK)
C                                       Open and init for read
            CALL ZPHFIL ('MA', DISKI(J), OLDCNO(J), 1, IFILE, IRET)
            CALL ZOPEN (LUNI, INDI, DISKI(J), IFILE, T, F, T, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'OPEN INPUT', J
               GO TO 990
               END IF
C                                       Setup for I/O
            NXI = CATBLK(KINAX)
            NYI = CATBLK(KINAX+1)
            WINI(1) = 1
            WINI(2) = XPIX(K)
            WINI(3) = NXI
            WINI(4) = XPIX(K)
C                                       Loop
            CALL FILL (5, 1, IDEPTH)
            IDEPTH(1) = YPIX(K)
            CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH, BOTEMP,
     *         IRET)
            BOI = BOTEMP + 1
            CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFF,
     *         JBUFSZ, BOI, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'INIT INPUT', J
               GO TO 990
               END IF
C                                       Read.
            CALL MDISK ('READ', LUNI, INDI, BUFF, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ INPUT', J
               GO TO 990
               END IF
            DO 20 I = 1,NXI
               QUVALS(J,I) = BUFF(IBIND+I-1)
 20            CONTINUE
            CALL ZCLOSE (LUNI, INDI, IRET)
 30         CONTINUE
C                                       write text file
         I = JTRIM (OUTFIL)
         IFILE = OUTFIL(:I) // CHARS(K:K)
         TLUN = 11
         CALL ZTXOPN ('WRIT', TLUN, TIND, IFILE, .FALSE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OUTPUT TEXT', K
            GO TO 990
            END IF
         WRITE (OUTLIN,1030) K, XPIX(K), YPIX(K)
         I = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:I), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT', K
            GO TO 990
            END IF
         WRITE (OUTLIN,1031)
         I = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:I), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT', K
            GO TO 990
            END IF
         NLIN = 0
         I = 47
         DO 50 J = 1,NFREQS
            IF ((FREQS(J).GT.0.0D0) .AND. (QUVALS(1,J).NE.FBLANK) .AND.
     *         (QUVALS(2,J).NE.FBLANK)) THEN
               NLIN = NLIN + 1
               WRITE (OUTLIN,1035) FREQS(J), QUVALS(1,J), QUVALS(2,J)
               CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:I), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT', K
                  GO TO 990
                  END IF
               END IF
 50         CONTINUE
         CALL ZTXCLS (TLUN, TIND, IRET)
         IRET = 0
         WRITE (MSGTXT,1050) NLIN, K
         CALL MSGWRT (3)
 100     CONTINUE
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('QUXTRE: ERROR',I3,' ON ',A,' FILE',I3)
 1005 FORMAT ('Beginning X,Y pixel',2I6,' output file',I3)
 1030 FORMAT ('; QUXTR pixel',I3,' xpix',I6,' ypix',I6)
 1031 FORMAT (';  Frequency',8X,'Q',12X,'U',7X,'weight')
 1035 FORMAT (F13.0,2F13.5,'    1.00')
 1050 FORMAT ('Wrote',I6,' lines in file',I3)
      END
      SUBROUTINE QUXTR2 (IRET)
C-----------------------------------------------------------------------
C   QUXTR2 reads the X-freq-Y cube to extract spectra
C   Output:
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   iRET
C
      CHARACTER IFILE*48, OUTLIN*80, CHARS*16
      INTEGER   LUNI, NYI, NXI, WINI(4), BOI, BOTEMP, IBIND, INDI,
     *   J, K, IDEPTH(5), I, JTRIM, TLUN, TIND, NLIN
      LOGICAL   T, F
      INCLUDE 'QUXTR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUNI /16/
      DATA T, F /.TRUE.,.FALSE./
      DATA CHARS /'123456789ABCDEF'/
C-----------------------------------------------------------------------
      DO 100 K = 1,NPIX
         WRITE (MSGTXT,1005) XPIX(K), YPIX(K), K
         CALL MSGWRT (2)
         DO 30 J = 1,2
            CALL COPY (256, CATOLD(1,J), CATBLK)
C                                       Open and init for read
            CALL ZPHFIL ('MA', DISKI(J), OLDCNO(J), 1, IFILE, IRET)
            CALL ZOPEN (LUNI, INDI, DISKI(J), IFILE, T, F, T, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'OPEN INPUT', J
               GO TO 990
               END IF
C                                       Setup for I/O
            NXI = CATBLK(KINAX)
            NYI = CATBLK(KINAX+1)
            WINI(1) = XPIX(K)
            WINI(2) = 1
            WINI(3) = XPIX(K)
            WINI(4) = NYI
            CALL FILL (5, 1, IDEPTH)
            IDEPTH(1) = YPIX(K)
            CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH, BOTEMP,
     *         IRET)
            BOI = BOTEMP + 1
            CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFF,
     *         JBUFSZ, BOI, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'INIT INPUT', J
               GO TO 990
               END IF
C                                       Read.
            DO 20 I = 1,NYI
               CALL MDISK ('READ', LUNI, INDI, BUFF, IBIND, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'READ INPUT', J
                  GO TO 990
                  END IF
               QUVALS(J,I) = BUFF(IBIND)
 20            CONTINUE
            CALL ZCLOSE (LUNI, INDI, IRET)
 30         CONTINUE
C                                       write text file
         I = JTRIM (OUTFIL)
         IFILE = OUTFIL(:I) // CHARS(K:K)
         TLUN = 11
         CALL ZTXOPN ('WRIT', TLUN, TIND, IFILE, .FALSE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OUTPUT TEXT', K
            GO TO 990
            END IF
         WRITE (OUTLIN,1030) K, XPIX(K), YPIX(K)
         I = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:I), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT', K
            GO TO 990
            END IF
         WRITE (OUTLIN,1031)
         I = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:I), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT', K
            GO TO 990
            END IF
         NLIN = 0
         I = 47
         DO 50 J = 1,NFREQS
            IF ((FREQS(J).GT.0.0D0) .AND. (QUVALS(1,J).NE.FBLANK) .AND.
     *         (QUVALS(2,J).NE.FBLANK)) THEN
               NLIN = NLIN + 1
               WRITE (OUTLIN,1035) FREQS(J), QUVALS(1,J), QUVALS(2,J)
               CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:I), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT', K
                  GO TO 990
                  END IF
               END IF
 50         CONTINUE
         CALL ZTXCLS (TLUN, TIND, IRET)
         IRET = 0
         WRITE (MSGTXT,1050) NLIN, K
         CALL MSGWRT (3)
 100     CONTINUE
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('QUXTR2: ERROR',I3,' ON ',A,' FILE',I3)
 1005 FORMAT ('Beginning X,Y pixel',2I6,' output file',I3)
 1030 FORMAT ('; QUXTR pixel',I3,' xpix',I6,' ypix',I6)
 1031 FORMAT (';  Frequency',8X,'Q',12X,'U',7X,'weight')
 1035 FORMAT (F13.0,2F13.5,'    1.00')
 1050 FORMAT ('Wrote',I6,' lines in file',I3)
      END
      SUBROUTINE QUXTR3 (IRET)
C-----------------------------------------------------------------------
C   QUXTRH reads the X-Y-FREQ cube to extract spectra
C   Output:
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER IFILE*48, OUTLIN*80, CHARS*16
      INTEGER   LUNI, NYI, NXI, WINI(4), BOI, IDEPTH(5), BOTEMP, IBIND,
     *   INDI, I, J, K, NLIN, TLUN, TIND, JTRIM, NZI
      LOGICAL   T, F
      INCLUDE 'QUXTR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUNI /16/
      DATA T, F /.TRUE.,.FALSE./
      DATA CHARS /'123456789ABCDEF'/
C-----------------------------------------------------------------------
C                                       loop over selected pixels
      DO 100 K = 1,NPIX
         WRITE (MSGTXT,1005) XPIX(K), YPIX(K), K
         CALL MSGWRT (2)
         DO 30 J = 1,2
            CALL COPY (256, CATOLD(1,J), CATBLK)
C                                       Open and init for read
            CALL ZPHFIL ('MA', DISKI(J), OLDCNO(J), 1, IFILE, IRET)
            CALL ZOPEN (LUNI, INDI, DISKI(J), IFILE, T, F, T, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'OPEN INPUT', J
               GO TO 990
               END IF
C                                       Setup for I/O
            NXI = CATBLK(KINAX)
            NYI = CATBLK(KINAX+1)
            NZI = CATBLK(KINAX+2)
            WINI(1) = XPIX(K)
            WINI(2) = YPIX(K)
            WINI(3) = XPIX(K)
            WINI(4) = YPIX(K)
            CALL FILL (5, 1, IDEPTH)
            DO 20 I = 1,NZI
               IDEPTH(1) = I
               CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH,
     *            BOTEMP, IRET)
               BOI = BOTEMP + 1
               CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFF,
     *            JBUFSZ, BOI, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'INIT INPUT', J
                  GO TO 990
                  END IF
C                                       Read.
               CALL MDISK ('READ', LUNI, INDI, BUFF, IBIND, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'READ INPUT', J
                  GO TO 990
                  END IF
               QUVALS(J,I) = BUFF(IBIND)
 20            CONTINUE
            CALL ZCLOSE (LUNI, INDI, IRET)
 30         CONTINUE
C                                       write text file
         I = JTRIM (OUTFIL)
         IFILE = OUTFIL(:I) // CHARS(K:K)
         TLUN = 11
         CALL ZTXOPN ('WRIT', TLUN, TIND, IFILE, .FALSE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OUTPUT TEXT', K
            GO TO 990
            END IF
         WRITE (OUTLIN,1030) K, XPIX(K), YPIX(K)
         I = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:I), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT', K
            GO TO 990
            END IF
         WRITE (OUTLIN,1031)
         I = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:I), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT', K
            GO TO 990
            END IF
         NLIN = 0
         I = 47
         DO 50 J = 1,NFREQS
            IF ((FREQS(J).GT.0.0D0) .AND. (QUVALS(1,J).NE.FBLANK) .AND.
     *         (QUVALS(2,J).NE.FBLANK)) THEN
               NLIN = NLIN + 1
               WRITE (OUTLIN,1035) FREQS(J), QUVALS(1,J), QUVALS(2,J)
               CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:I), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT TEXT', K
                  GO TO 990
                  END IF
               END IF
 50         CONTINUE
         CALL ZTXCLS (TLUN, TIND, IRET)
         IRET = 0
         WRITE (MSGTXT,1050) NLIN, K
         CALL MSGWRT (3)
 100     CONTINUE
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('QUXTRD: ERROR',I3,' ON ',A,' FILE',I2)
 1005 FORMAT ('Beginning X,Y pixel',2I6,' output file',I3)
 1030 FORMAT ('; QUXTR pixel',I3,' xpix',I6,' ypix',I6)
 1031 FORMAT (';  Frequency',8X,'Q',12X,'U',7X,'weight')
 1035 FORMAT (F13.0,2F13.5,'    1.00')
 1050 FORMAT ('Wrote',I6,' lines in file',I3)
      END

      SUBROUTINE XTRFIT (NPAR, NSTDS, XY, AD, NAMES, DOPRT, REFPIX,
     *   REFVAL, REFINC, ANGLE, A, B, RES, IERR)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999-2000, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Finds the xy to RA,Dec transformation using a user supplied list
C   of standard star positions.  The function that is fit is a linear
C   function (NPAR=3) or a linear plus quadratic (NPAR=6) in the tangent
C   plane.  Axis increments, rotation angle, and axis offets are found.
C   If the user requests the transformation to be applied, these values
C   are put in the image header.
C   Input:
C      NPAR     I             Number of paramters to fit (if not 6 then
C                             3)
C      NSTDS    I             Number of stars
C      XY       R(2,NSTDS)    Pixel containing the centroid of the star
C      AD       R(2,NSTDS)    Angle containing the centroid of the star
C                             (degrees)
C      NAMES    C(20,NSTDS)   Names of stars
C      DOPRT    L             If true print fit and residuals
C      REFPIX   D(2)          Referenc Pixel Location
C   Input/Output:
C      REFVAL   D(2)          Angle of center of image (degrees)
C   Output:
C      REFINC   D(2)          Pixel Increment of image (degrees)
C      ANGLE    D             Orientation angle of image (degrees)
C      A        D(6)          Model parameters for RA
C      B        D(6)          Model parameters for Declination
C      RES      R(2,NSTDS)    Residuals from fit (degrees)
C      IERR     I             Error return code
C-----------------------------------------------------------------------
      INTEGER   NPAR, NSTDS, IERR
      CHARACTER NAMES(*)*20
      LOGICAL   DOPRT
      REAL      XY(2,*), AD(2,*), RES(2,*)
      DOUBLE PRECISION REFVAL(2), REFINC(2), REFPIX(2), ANGLE
C
      INTEGER   MXSTFT
      PARAMETER (MXSTFT=1000)
      DOUBLE PRECISION RADIAN, PI, DEGRES
      PARAMETER (RADIAN=5.729577951D1, PI=3.1415926536,
     *   DEGRES=0.017453292519943295769)
C
      INTEGER   NP, LDFJAC, LWA, NST, INF, IPVT(6), I, K, NTOT, ILSQ,
     *   NLSQ, NPRT
      REAL   R1, R2, R3, RTEMP1, RTEMP2, ANGL1, ANGL2, X00(1000,6)
      DOUBLE PRECISION TOL, FVEC(MXSTFT), FJAC(6,6),
     *   ACEN, DCEN, AX, AY, DIFF(MXSTFT), SDCEN, CDCEN,
     *   DENOM(MXSTFT), DIRCOS(3,3), A(6), B(6), WA(2, MXSTFT)
      LOGICAL   WT
      EXTERNAL XTRFCN
      COMMON /XYAD/ X00
      SAVE     NPRT
      INCLUDE 'INCS:DMSG.INC'
      DATA     NPRT/0/
C-----------------------------------------------------------------------
      IERR = 0
C                                       Do not weight stars in fit
      WT = .FALSE.
C                                       Then do a 3 parameter fit
      IF (NPAR.NE.6.) THEN
         NP = 3
         NLSQ = 1
C                                       6 parameter fit
      ELSE
         NP = 6
         NLSQ = 2
         END IF
      TOL = 1.D-10
C                                       Set Weight array size
      LWA = 2 * MXSTFT
      LDFJAC = NP
C                                       Can only fit MXSTFT stars
      NST = MIN (MXSTFT, NSTDS)
C                                       If enought stars
      IF (NP.GT.NST) THEN
         MSGTXT = 'XTRFIT: TOO FEW STARS FOR FIT'
         IERR = 3
         GO TO 960
         END IF
C                                       User input field center (degrees)
      ACEN = REFVAL(1) * DEGRES
C                                       Convert Center angle to radians
      DCEN = REFVAL(2) * DEGRES
C                                       Set up initialize guesses
      DO 210 I = 1,NST
         DO 209 K = 1,6
            X00(I,K) = 0.
 209        CONTINUE
 210     CONTINUE
      DO 215 I = 1,6
         A(I) = 0.
         B(I) = 0.
 215     CONTINUE
      A(3) = 1.
      B(2) = 1.
C                              Find the transformation constants:
C                                ILSQ=1: First pass through LSQ; uses
C                                estimated values from ACEN and DCEN.
C                                ILSQ=2: Second pass through LSQ;uses
C                                ACEN=A(1) and DCEN=B(1)
      ILSQ = 1
 220  CONTINUE
C                                      Set a couple constants
      SDCEN = SIN(DCEN)
      CDCEN = COS(DCEN)
C                                      For all stars
      DO 250 I = 1,NST
C                                      Work with differences from center
         DIFF(I)  = (AD(1,I)*DEGRES) - ACEN
         DENOM(I) = (SIN(AD(2,I)*DEGRES)*SDCEN) +
     *              (COS(AD(2,I)*DEGRES)*CDCEN)*COS(DIFF(I))
C                                      skip star with ra of  de a row, exit
         IF (DENOM(I).EQ.0.) THEN
            WRITE (MSGTXT,9900) I
            IERR = 5
            GO TO 960
            END IF
         X00(I,1) = (COS(AD(2,I)*DEGRES)*SIN(DIFF(I)))/DENOM(I)
         X00(I,2) = XY(1,I) - REFPIX(1)
         X00(I,3) = XY(2,I) - REFPIX(2)
C                              NLSQ selects linear or quad. solution
         IF (NLSQ.EQ.2) THEN
            X00(I,4) = X00(I,2)**2
            X00(I,5) = X00(I,3)**2
            X00(I,6) = X00(I,2)*X00(I,3)
            END IF
 250     CONTINUE
C                                       Call function to calc fit in ra
      CALL LMSTR1 (XTRFCN, NST, NP, A, FVEC, FJAC, LDFJAC, TOL, INF,
     *   IPVT, WA, LWA)
      IF ((INF.EQ.0).OR.(INF.EQ.4)) THEN
         MSGTXT = 'XTRFIT: RA FIT FAILED (ARE STARS ALIGNED?)'
         IERR = 4
         GO TO 960
         END IF
C                                      For Dec
      DO 320 I=1,NST
         X00(I,1) = ((SIN(AD(2,I)*DEGRES)*CDCEN) -
     *               (COS(AD(2,I)*DEGRES)*SDCEN*COS(DIFF(I))))/DENOM(I)
 320     CONTINUE
C                                       Call function to calc fit in ra
      CALL LMSTR1 (XTRFCN, NST, NP, B, FVEC, FJAC, LDFJAC, TOL, INF,
     *   IPVT, WA, LWA)
      IF ((INF.EQ.0).OR.(INF.EQ.4)) THEN
         MSGTXT = 'XTRFIT: DEC FIT FAILED (ARE STARS ALIGNED?)'
         IERR = 4
         GO TO 960
         END IF
C                                 Compute coord. increments, rot. angle
      ANGL1 = ATAN(B(3)/A(3))
      ANGL2 = ATAN(-A(2)/B(2))
      REFINC(1) = .5*(A(3)/COS(ANGL1) + B(3)/SIN(ANGL1))*RADIAN
      REFINC(2) = .5*(B(2)/COS(ANGL2) - A(2)/SIN(ANGL2))*RADIAN
      ANGLE = 0.5*(ANGL1 + ANGL2)
      IF ((ILSQ.EQ.2) .AND. (ABS((ANGL1-ANGL2)*RADIAN).GT.0.05)) THEN
         WRITE (MSGTXT,1330) ANGL1*RADIAN, ANGL2*RADIAN
         CALL MSGWRT (6)
         END IF
C                              If only first least squares trial
      IF ((ILSQ.EQ.2) .AND. (DOPRT)) THEN
         MSGTXT = 'Actual fit parameter values:'
         CALL MSGWRT (2)
         MSGTXT = 'Number     X_fit         Y_fit'
         CALL MSGWRT (2)
         DO 340 I = 1,6
            WRITE (MSGTXT,1335) I, A(I), B(I)
            CALL MSGWRT (4)
 340        CONTINUE
         MSGTXT = 'Fit and residuals from the calibration:'
         CALL MSGWRT (2)
         WRITE (MSGTXT,3810)
         CALL MSGWRT (2)
         WRITE (MSGTXT,3820)
         CALL MSGWRT (2)
         END IF
C                              Direction cosines for inverse transform
      DIRCOS(1,1) = -SIN(ACEN)
      DIRCOS(1,2) = -(COS(ACEN))*(SIN(DCEN))
      DIRCOS(1,3) = (COS(ACEN))*(COS(DCEN))
      DIRCOS(2,1) = COS(ACEN)
      DIRCOS(2,2) = -(SIN(ACEN))*(SIN(DCEN))
      DIRCOS(2,3) = (SIN(ACEN))*(COS(DCEN))
      DIRCOS(3,2) = COS(DCEN)
      DIRCOS(3,3) = SIN(DCEN)
C                              Compute residuals and RA and DEC
      NTOT = NST + 1
C                              for all standards, calc residuals
      DO 500 I=1,NTOT
C                              If on last star
         IF (I.GE.NTOT) THEN
C                              Coordinate of image center
            AX = A(1)
            AY = B(1)
         ELSE
C                              Jump out if first fit
            IF (ILSQ.EQ.1) GO TO 500
            AX = A(1) + A(2)*X00(I,3) + A(3)*X00(I,2)
            AY = B(1) + B(2)*X00(I,3) + B(3)*X00(I,2)
C                              If a second order fit
            IF (NLSQ.EQ.2) THEN
               AX = AX + A(4)*X00(I,4) + A(5)*X00(I,5) + A(6)*X00(I,6)
               AY = AY + B(4)*X00(I,4) + B(5)*X00(I,5) + B(6)*X00(I,6)
               END IF
            END IF
C                              Calc orientation
         R1 = AX*DIRCOS(1,1) + AY*DIRCOS(1,2) + DIRCOS(1,3)
         R2 = AX*DIRCOS(2,1) + AY*DIRCOS(2,2) + DIRCOS(2,3)
         R3 = AY*DIRCOS(3,2) + DIRCOS(3,3)
         AX = ATAN(ABS(R2/R1))
C                              Handle +/- 180 cases
         IF (R2.LE.0.) THEN
            IF (R1.LT.0.) THEN
               AX = AX + PI
            ELSE
               AX = 2.*PI - AX
               END IF
         ELSE
            IF (R1.LT.0.) THEN
               AX = PI - AX
               END IF
C                              Else R1, R2 positve, AX unchanged
C                              End if quadrant problem
            END IF
         AY = ATAN(R3*COS(AX)/R1)
C                              If really a star
         IF (I.LT.NTOT) THEN
C                              calc residuals in degrees
            RES(1,I) = AX*RADIAN - AD(1,I)
            RES(2,I) = AY*RADIAN - AD(2,I)
C                              residuals in arc seconds
            RTEMP1   = RES(1,I) * 3600. * COS (AD(2,I)*DEGRES)
            RTEMP2   = RES(2,I) * 3600.
C                              Tell Residuals
            WRITE (MSGTXT,4800) NAMES(I), AX*RADIAN, RTEMP1,
     *         AY*RADIAN, RTEMP2
            IF (DOPRT) CALL MSGWRT (2)
         ELSE
            A(1) = AX
            B(1) = AY
            END IF
C                                End of all star residuals loop
 500     CONTINUE
C                                If finished first fit
      IF (ILSQ.LE.1) THEN
C                                prepare to do second fit
         ILSQ = 2
         ACEN = A(1)
         DCEN = B(1)
         GO TO 220
         END IF
C                                Write coeff.
      IF (A(1).GT. 2.*PI) A(1) = A(1) - (2.*PI)
      WRITE (MSGTXT,5200)
      ANGLE = ANGLE * RADIAN
      IF (DOPRT) CALL MSGWRT (2)
C                                Put ref. params in output values
      REFVAL(1) = A(1)*RADIAN
      REFVAL(2) = B(1)*RADIAN
C                                       Print Inc in arc sec/pixel
      RTEMP1    = REFINC(1) * 3600.
      WRITE (MSGTXT,5210) 'X', REFVAL(1), REFPIX(1), RTEMP1, ANGLE
      IF (DOPRT) CALL MSGWRT (2)
      RTEMP1 = REFINC(2) * 3600.
      WRITE (MSGTXT,5210) 'Y', REFVAL(2), REFPIX(2), RTEMP1, ANGLE
      IF (DOPRT) CALL MSGWRT (2)
C                                Error handling
 960  IF (IERR.NE.0) THEN
C                                Only repeat messages 5 times
         IF (NPRT.LT.5) THEN
            CALL MSGWRT (5)
            NPRT = NPRT + 1
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1330 FORMAT ('WARNING: X_FIT ANGLE',F9.3,' Y_FIT ANGLE',F9.3,' DIFFER')
 1335 FORMAT (I4,2X,2(1PE14.5))
 3810 FORMAT ('  Name',7X,'X        X Resid',8X,'Y        Y Resid')
 3820 FORMAT (11X,'(deg)       (secs)',6X,'(deg)       (secs)')
 4800 FORMAT (2X, A4, 2X, F10.4, F10.2, 4X, F10.4, F10.2)
 5200 FORMAT (' Axis   Coord value    at pixel   Coord incr      Rotat')
 5210 FORMAT (3X,A1,1X,1PD16.9,0PF10.3,F13.5,F11.4)
 9900 FORMAT ('XTRFIT: ON STAR',I4,' TRIED TO DIVIDE BY ZERO')
      END
      SUBROUTINE XTRFCN (NPNTS, NPAR, A, FVEC, FJROW, IFLAG)
C-----------------------------------------------------------------------
C   Computes the values and Jacobian of the model.
C   Inputs:
C      NPNTS   I         No. of data points
C      NPAR    I         No. of parameters in fit
C      A       D(NPAR)   Fit coefficients
C      IFLAG   I         Type of operation: 1=value,
C                           N=Jacobian of row N-1
C   Outputs:
C      FVEC    D(NPNTS)   Model-Data for each point
C      FJROW   D(NPAR)    The function partials
C-----------------------------------------------------------------------
      INTEGER   NPNTS, NPAR, IFLAG, I, K
      REAL      X00(1000,6)
      DOUBLE PRECISION  A(*), FVEC(*), FJROW(*)
      COMMON /XYAD/ X00
C-----------------------------------------------------------------------
C                                        Find (Model - Data) values
      IF (IFLAG.LE.1) THEN
         DO 100 I = 1,NPNTS
            FVEC(I) = A(1) + A(2)*X00(I,3) + A(3)*X00(I,2) - X00(I,1)
            IF (NPAR.GT.3) THEN
               DO 50 K = 4,NPAR
                  FVEC(I) = FVEC(I) + A(K)*X00(I,K)
 50               CONTINUE
               END IF
 100        CONTINUE
C                                        Find IFLAG-1 row of Jacobian
      ELSE
         I = IFLAG - 1
         FJROW(1) = 1.
         FJROW(2) = X00(I,3)
         FJROW(3) = X00(I,2)
         IF (NPAR.GT.3) THEN
            DO 250 K = 4,NPAR
               FJROW(K) = X00(I,K)
 250           CONTINUE
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE REMKEY (IVOL, CNO, KEYWRD, NUMKEY, BUFFER, IERR)
C-----------------------------------------------------------------------
C! Removes keywords from the keyword section of an AIPS header file
C# Header Catalog
C-----------------------------------------------------------------------
C;  Copyright (C) 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;  Eric W. Greisen
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Deletes KEYWORDs from an AIPS image (or uv) header.  The order of
C   the keywords is arbitrary.  Uses LUN 15, so any CA or CB files must
C   be closed before calling this routine.
C   Inputs:
C      IVOL     I          File disk number
C      CNO      I          File catalog block number
C      KEYWRD   C(*)*8     Keywords to read/write: output on ALL
C      NUMKEY   I          Number of keywords to read/write.
C                             Input on OPCODE='ALL' = max to read.
C                             Output on OPCODE='ALL' = # read.
C   Output:
C      BUFFER   I(512)     Scratch buffer - note size
C      IERR     I          Return code, 0=>OK,
C                             1-10 => ZFIO error
C                             19   => unrecognized data type.
C                             20   => bad OPCODE
C                             -n   => n keywords not found.
C-----------------------------------------------------------------------
      CHARACTER KEYWRD(*)*(*)
      INTEGER   IVOL, CNO, NUMKEY, BUFFER(512), IERR
C
      INTEGER   J, JP, CLUN, CIND, MAXREC, HEDKEY, RECNO, GOTIT(100),
     *   II, IO, IREC, OREC
      CHARACTER CTEST*8, PHNAME*48
      LOGICAL   T, F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA CLUN /15/
C-----------------------------------------------------------------------
      IERR = 0
      IF (NUMKEY.LE.0) GO TO 999
C                                       Open CB file
      CALL ZPHFIL ('CB', IVOL, CNO, 1, PHNAME, IERR)
      CALL ZOPEN (CLUN, CIND, IVOL, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 995
         END IF
      IREC = 2
      CALL ZFIO ('READ', CLUN, CIND, IREC, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1005) IERR, 'READ', IREC
         GO TO 980
         END IF
      MAXREC = BUFFER(1)
      HEDKEY = BUFFER(2)
C                                       quit now if empty
      IF (HEDKEY.LE.0) THEN
         CALL ZCLOSE (CLUN, CIND, IERR)
         IERR = -NUMKEY
         GO TO 999
         END IF
      II = MIN (100, NUMKEY)
      CALL FILL (II, 0, GOTIT)
      OREC = 2
      IO = 0
      CALL FILL (256, 0, BUFFER(257))
      BUFFER(257) = MAXREC
      DO 50 II = 1,HEDKEY
         RECNO = II/51 + 2
         IF (RECNO.GT.IREC) THEN
            IREC = RECNO
            CALL ZFIO ('READ', CLUN, CIND, IREC, BUFFER, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1005) IERR, 'READ', IREC
               GO TO 980
               END IF
            END IF
         JP = 5 * MOD (II,51) + 2
         CALL H2CHR (8, 1, BUFFER(JP), CTEST)
C                                       Search input list
         DO 20 J = 1,NUMKEY
            IF (CTEST.EQ.KEYWRD(J)) THEN
               IF (J.LE.100) GOTIT(J) = GOTIT(J) + 1
               GO TO 50
               END IF
 20         CONTINUE
C                                       Save this word
         IO = IO + 1
         RECNO = IO/51 + 2
         IF (RECNO.NE.OREC) THEN
            CALL ZFIO ('WRIT', CLUN, CIND, OREC, BUFFER(257), IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1005) IERR, 'WRIT', OREC
               GO TO 980
               END IF
            CALL FILL (256, 0, BUFFER(257))
            OREC = RECNO
            END IF
         J = 5 * MOD (IO,51) + 2 + 256
         CALL COPY (5, BUFFER(JP), BUFFER(J))
 50      CONTINUE
C                                       Write last rec if needed
      IF (OREC.NE.2) THEN
         CALL ZFIO ('WRIT', CLUN, CIND, OREC, BUFFER(257), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1005) IERR, 'WRIT', OREC
            GO TO 980
            END IF
         OREC = 2
         CALL ZFIO ('READ', CLUN, CIND, OREC, BUFFER(257), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1005) IERR, 'READ', OREC
            GO TO 980
            END IF
         END IF
      BUFFER(258) = IO
      CALL ZFIO ('WRIT', CLUN, CIND, OREC, BUFFER(257), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1005) IERR, 'WRIT', OREC
         GO TO 980
         END IF
C                                       set error return
      II = MIN (100, NUMKEY)
      DO 60 J = 1,II
         IF (GOTIT(J).NE.1) IERR = IERR - 1
 60      CONTINUE
 100  CALL ZCLOSE (CLUN, CIND, II)
      IF (IERR.EQ.0) IERR = II
      IF (IERR.GT.0) GO TO 995
      GO TO 999
C                                       Error
 980  CALL MSGWRT (8)
      CALL ZCLOSE (CLUN, CIND, II)
C
 995  WRITE (MSGTXT,1995) IVOL, CNO
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('REMKEY: ERROR',I5,' OPENING THE HEADER FILE')
 1005 FORMAT ('REMKEY: ERROR',I5,1X,A4,'ING THE HEADER FILE RECORD',I5)
 1995 FORMAT ('REMKEY: ERROR ON VOL,CNO',I3,I6)
      END

      SUBROUTINE ZTXOPN (OPCODE, LUN, FIND, OUTFIL, APPEND, IERR)
C-----------------------------------------------------------------------
C! open a text file for read or write
C# Z Text
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2018, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Open a text file.
C   Inputs:
C      OPCODE   C*4    Open for 'READ' 'QRED' read existing
C                         'WRIT' or 'QWRT' write new
C                         'REWR', 'QREW' write existing (or not)
C      LUN      I      Logical unit number
C      OUTFIL   C*(*)  Physical file name: with logical:name
C                      - if no colon - full name from ZFULLN assumed
C      APPEND   L      If true append new text to end of old file.
C                         (OPCODE='WRIT' or 'QWRT' only).
C   Outputs:
C      FIND     I      Index in FTAB for LUN
C      IERR     I      Error return code: 0 => no error
C                         1 => error in inputs
C                         2 => LUN already in use
C                         3 => no room for LUN in FTAB
C                         4 => trouble translating logical
C                         5 => file already exists
C                         6 => open error
C   Generic version --- uses ZTXOP2 for actual open.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, OUTFIL*(*)
      INTEGER   LUN, FIND, IERR
      LOGICAL   APPEND
C
      INTEGER   I, JERR, J
      LOGICAL   MAP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA MAP /.FALSE./
C-----------------------------------------------------------------------
C                                       Check inputs.
      IERR = 1
C                                       Valid OPCODE?
      IF ((OPCODE.NE.'READ') .AND. (OPCODE.NE.'QRED') .AND.
     *   (OPCODE.NE.'REWR') .AND. (OPCODE.NE.'QREW') .AND.
     *   (OPCODE.NE.'WRIT') .AND. (OPCODE.NE.'QWRT')) THEN
         WRITE (MSGTXT,1000) OPCODE
         GO TO 995
         END IF
C                                       Valid LUN?
      IF ((LUN.LE.0) .OR. (LUN.GT.128)) THEN
         WRITE (MSGTXT,1001) LUN
         GO TO 995
         END IF
C                                       Valid device type?
      IF (DEVTAB(LUN).NE.3) THEN
         WRITE (MSGTXT,1010) LUN, DEVTAB(LUN)
         GO TO 995
         END IF
C                                       Allocate area in FTAB for LUN.
      CALL LSERCH ('OPEN', LUN, FIND, MAP, JERR)
      IF (JERR.NE.0) THEN
         IERR = 3
C                                       LUN already in use.
         IF (JERR.EQ.2) THEN
            IERR = 2
            WRITE (MSGTXT,1022) LUN
C                                       No room in FTAB for LUN.
         ELSE IF (JERR.EQ.3) THEN
            WRITE (MSGTXT,1023) LUN
         ELSE
            WRITE (MSGTXT,1020) JERR, 'OPEN', LUN
            END IF
         GO TO 995
         END IF
      IERR = 0
C                                       Call 2nd level Z routine for
C                                       name translation and actual open
      CALL ZTXOP2 (OPCODE, LUN, FIND, OUTFIL, APPEND, IERR)
C                                       store file name
      IF (IERR.EQ.0) THEN
         CALL FSERCH (FIND, I, J, JERR)
         IF (JERR.EQ.0) THEN
            IF (I.EQ.1) DEVNAM(J) = OUTFIL
            IF (I.EQ.2) NONNAM(J) = OUTFIL
            IF (I.EQ.3) MAPNAM(J) = OUTFIL
            END IF
         GO TO 999
         END IF
C                                       Error.  Remove FTAB entry.
 990  CALL LSERCH ('CLOS', LUN, FIND, MAP, JERR)
      IF (JERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1990) JERR, 'CLOS', LUN
C
 995  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZTXOPN: UNKNOWN OPCODE = ',A4)
 1001 FORMAT ('ZTXOPN: INVALID LUN = ',I3)
 1010 FORMAT ('ZTXOPN: INVALID DEVTAB(',I2,') = ',I1)
 1020 FORMAT ('ZTXOPN: LSERCH ERROR ',I2,' ON ',A4,' LUN = ',I3)
 1022 FORMAT ('ZTXOPN: LUN = ',I3,' ALREADY OPENED IN FTAB')
 1023 FORMAT ('ZTXOPN: NO ROOM IN FTAB FOR LUN = ',I3)
 1990 FORMAT ('ZTXOPN: LSERCH ERROR ',I2,' ON ',A4,' LUN = ',I3)
      END

      SUBROUTINE PTPARM (NPARMS, RPARM, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! starts tasks, getting parameters and task ID number, does accounting
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PTPARM uses the activator task number to return parameters to AIPS
C   adverbs.  Call it before DIETSK and never if RQUICK was true.
C   Inputs:
C      NPARMS  I          Number of real variables wanted
C      RPARM   R(NPARMS)  Parameters received
C   Output:
C      SCRTCH  I(256)     Scratch buffer
C      IERR    I          Error code: 0 -> ok
C                                     2 -> disk troubles
C-----------------------------------------------------------------------
      INTEGER   NPARMS, SCRTCH(256), IERR
      REAL      RPARM(*)
C
      INTEGER   FINDTD, ISCR, I, IER, J, LUNTD, NBL, JBL
      REAL      RSCR
      LOGICAL   T, F
      CHARACTER PHNAME*48, PTYPE*2
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (RSCR, ISCR)
      DATA LUNTD, PTYPE /13, 'TD'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      NBL = 4
C                                       set initial values
      IERR = 0
C                                       open task data file
      CALL ZPHFIL (PTYPE, 1, 0, 4, PHNAME, IER)
      CALL ZOPEN (LUNTD, FINDTD, 1, PHNAME, F, T, T, IER)
      IF (IER.NE.0) THEN
         IERR = 2
         GO TO 999
         END IF
C                                       read directory record
      CALL ZFIO ('READ', LUNTD, FINDTD, 1, SCRTCH, IER)
      IF (IER.NE.0) GO TO 980
      NBL = MAX (4, SCRTCH(256))
C                                       set values, read pars
      JBL = NBL*(NPOPS-1) + 2
      CALL ZFIO ('READ', LUNTD, FINDTD, JBL, SCRTCH, IER)
      IF (IER.NE.0) GO TO 980
C                                       Get task parms
      IF (NPARMS.GT.0) THEN
         J = 10
         CALL FILL (246, 0, SCRTCH(11))
         DO 50 I = 1,NPARMS
            J = J + 1
            IF (J.GT.256) THEN
               CALL ZFIO ('WRIT', LUNTD, FINDTD, JBL, SCRTCH, IER)
               IF (IER.NE.0) GO TO 980
               J = 1
               JBL = JBL + 1
               CALL FILL (256, 0, SCRTCH)
               END IF
            RSCR = RPARM(I)
            SCRTCH(J) = ISCR
 50         CONTINUE
         CALL ZFIO ('WRIT', LUNTD, FINDTD, JBL, SCRTCH, IER)
         IF (IER.NE.0) GO TO 980
         END IF
C                                       close file
 60   CALL ZCLOSE (LUNTD, FINDTD, IER)
C                                       message: start
      MSGTXT = 'returns adverbs to AIPS'
      CALL MSGWRT (2)
      GO TO 999
C                                       Errors
 980  IERR = 2
 990  CALL ZCLOSE (LUNTD, FINDTD, IER)
C
 999  RETURN
      END

      PROGRAM MF2ST
C-----------------------------------------------------------------------
C! Task converts MF file of components to a stars file for plotting
C# EXT-util Map-util Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2006, 2009, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MF2ST will convert a MF (Model fit) extension file (usually produced
C   by SAD) to a ST file containing the positions and widths attached to
C   an AIPS image.  The ST file will be in standard tables format.
C   Inputs:   (from AIPS)
C      USERID    R      user number, 0 means use logon user
C                       number, 32000 means any user can be accessed.
C      INNAME    R(3)   name of primary file.
C      INCLASS   R(2)   class of primary file.
C      INSEQ     R      sequence number of primary file.
C      INDISK    R      disk volume number. 0 means try all.
C      INVERS    R      MF file version number
C      OUTVERS   R      ST file version number
C      FLUX      R      Min flux to include
C      CTYPE     R(4)   (1) Star type
C                       (2) Max # MF to include
C                       (3,4) If (4) > (3), use ST types 0 to (1) scaled
C                           overs fluxes (3) to (4)
C-----------------------------------------------------------------------
C                                       Max Number Columns, Label Length
      INTEGER MXSTCL, MXSTLB
      PARAMETER (MXSTCL=7, MXSTLB=24)
C
      CHARACTER PRGNAM*6, HILINE*72, NAMIN*12, CLSIN*6, TYPIN*2,
     *   ATIME*8, ADATE*12, STFILE*48, SBUF*80, TTITLE*28, ATYPE(18)*4,
     *   NTYPE(7)*8, CHTM12*12, TITLE*48, UNITS(MXSTCL)*8
      HOLLERITH HOLTMP(6), XNAMIN(3), XCLSIN(2), STLABL(6)
      DOUBLE PRECISION XPOS, YPOS, ZPOS
      REAL      DSKIN, SEQIN, XINVER, XOUVER, FLUX, XCTYPE(4), DXPOS,
     *   DYPOS, POSANG, STTYPE, RECORD(50), ICTYPE
      INTEGER  I, IWBUFF(256), IMFIND, IMLUN, IERR, IRETCD, ISEQ, FCOL,
     *   INPRMS, ISLOT, IUSER, IVOL, IROUND, MFLUN, SLUN, HLUN, IT(3),
     *   ID(3), J, K, BUF(512), XBUF(256), NKEY, NREC, NCOL, OUVER,
     *   ICOL, IER, IRNO, INVER, NMF, NST, IOBUF(768), PCOL, WCOL,
     *   DEPTH(5)
      LOGICAL   T, F, SAVE, QUICK, DOPIXR
      HOLLERITH HBUF(512), PBUF(14)
      EQUIVALENCE (BUF, HBUF), (XPOS, PBUF)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:PSTD.INC'
      COMMON /INPARM/ XNAMIN, XCLSIN, SEQIN, DSKIN, XINVER, XOUVER,
     *   FLUX, XCTYPE
      COMMON /MF2STD/ XPOS, YPOS, DXPOS, DYPOS, POSANG, STTYPE, STLABL
      DATA IMLUN, MFLUN, SLUN, HLUN /16, 27, 28, 29/
      DATA PRGNAM /'MF2ST '/
      DATA TYPIN /'MA'/
      DATA T, F /.TRUE.,.FALSE./
      DATA TTITLE /'AIPS ST star positions table'/
      DATA ATYPE /'TIME','FREQ','LAMB','VELO','FELO','    ','DIST',
     *   'ANGL','ELON','ELAT', 'GLON','GLAT','RA  ','RA--','LL  ',
     *   'DEC ','DEC-','MM  '/
      DATA NTYPE /'SECONDS ', 'HERTZ   ', 'METERS  ',
     *   'METR/SEC', 'METR/SEC', 'PIXELS  ', 'DEGREES '/
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      SAVE = F
      CALL FILL (5, 1, DEPTH)
C                                       Get input values from AIPS.
      INPRMS = 14
      IRETCD = 0
      CALL GTPARM (PRGNAM, INPRMS, QUICK, XNAMIN, IWBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRETCD = 8
         END IF
      IF (QUICK) CALL RELPOP (IRETCD, IWBUFF, IERR)
      IF (IRETCD.NE.0) GO TO 990
      IRETCD = 8
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
C
      ISEQ = IROUND (SEQIN)
      IVOL = IROUND (DSKIN)
      IUSER = NLUSER
      OUVER = IROUND (XOUVER)
      INVER = IROUND (XINVER)
      NMF = IROUND (XCTYPE(2))
      ICTYPE = IROUND (XCTYPE(1))
      ICTYPE = MAX (1.0, MIN (24.0, ICTYPE))
C                                       Open map file & get header.
      CALL MAPOPN ('HDWR', IVOL, NAMIN, CLSIN, ISEQ, TYPIN, IUSER,
     *   IMLUN, IMFIND, ISLOT, CATBLK, IWBUFF, IERR)
      IF (IERR.NE.0) GO TO 990
      LOCNUM = 1
      CALL SETLOC (DEPTH, .FALSE.)
C                                       get MF file open
      CALL FNDEXT ('MF', CATBLK, I)
      IF (I.LE.0) THEN
         MSGTXT = 'THERE APPEARS TO BE NO MF FILE - SORRY'
         CALL MSGWRT (7)
         GO TO 980
         END IF
      IF ((INVER.LE.0) .OR. (INVER.GT.I)) INVER = I
C                                       Open CC or MF table file
      NKEY = 0
      NCOL = 0
      NREC = 0
      CALL TABINI ('READ', 'MF', IVOL, ISLOT, INVER, CATBLK, MFLUN,
     *   NKEY, NREC, NCOL, IOBUF(513), IOBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, INVER
         CALL MSGWRT (7)
         GO TO 980
         END IF
      NST = IOBUF(5)
      IF (NMF.GT.0) NST = MIN (NST, NMF)
      CALL FNDCOL (1, 'I FLUX', 6, .FALSE., IOBUF, FCOL, IERR)
      CALL FNDCOL (1, 'DELTAX', 6, .FALSE., IOBUF, PCOL, IERR)
      CALL FNDCOL (1, 'MAJOR AX', 8, .FALSE., IOBUF, WCOL, IERR)
C                                       Fill in defaults in PARMS
      DSKIN = IVOL
      XINVER = INVER
C                                       Create/open ST file
      NCOL = MXSTCL
      NKEY = 1
      NREC = 50
C                                       data types: 2 D, 4 R, Chars
      CALL FILL (256, 0, XBUF)
C                                       First two entries are Ra+Dec
      XBUF(129) = 11
      XBUF(130) = 11
C                                       Second two are Star size
      XBUF(131) = 12
      XBUF(132) = 12
C                                       Fifth is orientation
      XBUF(133) = 12
C                                       Sixth is type (cross, ellipse)
      XBUF(134) = 12
C                                       Seventh is Character Star label
      XBUF(135) = (MXSTLB*10) + 3
C                                       create/open
      CALL TABINI ('WRIT', 'ST', IVOL, ISLOT, OUVER, CATBLK, SLUN, NKEY,
     *    NREC, NCOL, XBUF, BUF, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1030) IERR, OUVER
         CALL MSGWRT (8)
         GO TO 970
         END IF
C                                       table title
      CALL CHR2H (28, TTITLE, 1, HBUF(101))
C                                       write column titles
      TITLE = ' '
      DO 45 ICOL = 1,NCOL
         IRNO = ICOL
         J = MOD (ICOL-1, 2) * 2
C                                       Star coordinates
         IF ((ICOL.EQ.1) .OR. (ICOL.EQ.2)) THEN
            CALL H2CHR (8, 1, CATH(KHCTP+J), TITLE)
            END IF
C                                       Star Position Angle
         IF (ICOL.EQ.3) TITLE = 'MAJOR AX'
         IF (ICOL.EQ.4) TITLE = 'MINOR AX'
         IF (ICOL.EQ.5) TITLE = 'POSANG'
         IF (ICOL.EQ.6) TITLE = 'STARTYPE'
         IF (ICOL.EQ.7) TITLE = 'LABEL'
         CALL CHR2H (MXSTLB, TITLE, 1, HOLTMP)
         CALL TABIO ('WRIT', 3, IRNO, HOLTMP, BUF, IERR)
         IF (IERR.NE.0) GO TO 960
 45      CONTINUE
C                                       Figure out units
      DO 55 I = 1,2
         J = (I-1) * 2 + KHCTP
         UNITS(I) = ' '
         DO 50 K = 1,18
            CALL H2CHR (4, 1, CATH(J), CHTM12)
            IF (CHTM12(1:4).EQ.ATYPE(K)(1:4)) THEN
               IF (K.LT.7) UNITS(I) = NTYPE(K)
               IF (K.GE.7) UNITS(I) = NTYPE(7)
               J = I + 2
               UNITS(J) = UNITS(I)
               GO TO 55
               END IF
 50         CONTINUE
 55      CONTINUE
C                                       Position angle is degrees
      UNITS(5) = NTYPE(7)
C                                       Star type is an index
C                                       0=cross, 1=elipse, 2=none
      UNITS(6) = 'INDEX   '
C                                       Lable  is an arbitary string
      UNITS(7) = 'STRING  '
C                                       write units
      DO 60 ICOL = 1,NCOL
         IRNO = ICOL
         CALL CHR2H (8, UNITS(ICOL), 1, HOLTMP)
         CALL TABIO ('WRIT', 4, IRNO, HOLTMP, BUF, IERR)
         IF (IERR.NE.0) GO TO 960
 60      CONTINUE
      IRNO = 0
C                                       Read record loop
      STTYPE = ICTYPE
      DOPIXR = XCTYPE(4).GT.XCTYPE(3)
      DO 100 I = 1,NST
         CALL TABIO ('READ', 0, I, RECORD, IOBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR
            CALL MSGWRT (8)
            GO TO 960
            END IF
         IF (RECORD(FCOL).GE.FLUX) THEN
            DXPOS = RPLOC(1,LOCNUM) + RECORD(PCOL)/AXINC(1,LOCNUM)
            DYPOS = RPLOC(2,LOCNUM) + RECORD(PCOL+1)/AXINC(2,LOCNUM)
            CALL XYVAL (DXPOS, DYPOS, XPOS, YPOS, ZPOS, IERR)
            IF (IERR.NE.0) GO TO 100
            DXPOS = RECORD(WCOL)
            DYPOS = RECORD(WCOL+1)
            POSANG = RECORD(WCOL+2)
            IF (DOPIXR) THEN
               STTYPE = (ICTYPE-1.0) * (RECORD(FCOL)-XCTYPE(3)) /
     *            (XCTYPE(4)-XCTYPE(3)) + 1.0
               STTYPE = IROUND (STTYPE)
               STTYPE = MAX (1.0, MIN (STTYPE, ICTYPE))
               END IF
            IF (RECORD(FCOL).GT.90.) THEN
               WRITE (SBUF,1101) RECORD(FCOL)
            ELSE IF (RECORD(FCOL).GT.9.) THEN
               WRITE (SBUF,1102) RECORD(FCOL)
            ELSE
               WRITE (SBUF,1103) RECORD(FCOL)
               END IF
            CALL CHR2H (24, SBUF, 1, STLABL)
            IRNO = IRNO + 1
            CALL TABIO ('WRIT', 0, IRNO, PBUF, BUF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1150) IERR
               CALL MSGWRT (8)
               GO TO 960
               END IF
            END IF
 100     CONTINUE
C                                       Normal EOF
      CALL TABIO ('CLOS', 0, IRNO, PBUF, BUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1150) IERR
         CALL MSGWRT (8)
         GO TO 960
         END IF
      WRITE (MSGTXT,1210) IRNO, OUVER
      CALL MSGWRT (4)
      IRETCD = 0
C                                       Add to history file
      CALL HIINIT (3)
      CALL HIOPEN (HLUN, IVOL, ISLOT, IWBUFF, IER)
      IF (IER.NE.0) GO TO 970
C                                       Prepare text and add to file
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, ATIME, ADATE)
      WRITE (SBUF,1211,ERR=215) TSKNAM, OUVER, IRNO, ADATE, ATIME
 215  HILINE = SBUF
      CALL HIADD (HLUN, HILINE, IWBUFF, IER)
      CALL HICLOS (HLUN, T, IWBUFF, IER)
      GO TO 970
C                                       ERRORS:
C                                       Kill the ST file
 960  CALL ZCLOSE (SLUN, BUF(82), IERR)
      CALL H2CHR (24, 1, HBUF(17), STFILE)
      CALL ZDESTR (IVOL, STFILE, IERR)
C                                       FXHDEX already called > once
      DO 965 I = 1,KIEXTN
         J = I - 1
         CALL H2CHR (2, 1, CATH(KHEXT+J), CHTM12)
         IF (CHTM12(1:2).EQ.'ST') THEN
            IF (OUVER.EQ.CATBLK(KIVER+J)) CATBLK(KIVER+J) =
     *         CATBLK(KIVER+J) - 1
            SAVE = T
            GO TO 970
            END IF
 965     CONTINUE
C                                       Close the text file
 970  CALL TABIO ('CLOS', 0, I, RECORD, IOBUF, IERR)
C                                       Close map file.
 980  CALL MAPCLS ('WRIT', IVOL, ISLOT, IMLUN, IMFIND, CATBLK, SAVE,
     *   IWBUFF, IERR)
C
 990  CALL DIETSK (IRETCD, QUICK, IWBUFF)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR GETTING PARAMETERS FROM AIPS. GTPARM ERR =',I5)
 1010 FORMAT ('ERROR',I5,' OPENING MF FILE VERSION',I4)
 1030 FORMAT ('ERROR',I4,' CREATING/OPENING ST FILE VERSION',I4)
 1100 FORMAT ('ERROR',I4,' READING MF FILE')
 1101 FORMAT (F6.2)
 1102 FORMAT (F6.3)
 1103 FORMAT (F6.4)
 1150 FORMAT ('ERROR',I4,' WRITING ST FILE')
 1210 FORMAT ('Wrote',I6,' lines in ST file version',I4)
 1211 FORMAT (A6,' Version=',I3,' Lines=',I5,
     *   '  / Star file created ',A,A)
      END

      PROGRAM QMNGR
C-----------------------------------------------------------------------
C! manages the AIPS batch queues, starting AIPSBs to run the jobs
C# Batch
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1996, 2018, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   QMNGR is the AIPS batch queue manager.  It's started by one of the
C   AIPSC (Checker) and runs as NPOPS = NINTRN+2.
C   Inputs: POPS number of routine which started it.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   IBUF(512), IERR
      LOGICAL   RQUICK
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA PRGNAM /'QMNGR '/
C-----------------------------------------------------------------------
C                                       init the queues and job
      CALL QMNGIN (PRGNAM, IBUF, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Do it until all empty
      CALL QMNGDO (IBUF, IERR)
C
 990  RQUICK = .TRUE.
      CALL DIETSK (IERR, RQUICK, IBUF)
C
 999  STOP
      END
      SUBROUTINE QMNGIN (PRGM, IBUF, IRET)
C-----------------------------------------------------------------------
C   QMNGIN starts up the Q manager program, resumes the initiator,
C   and switches to user number 1.
C   Inputs:
C      PRGM    C*6)      Program name
C   Output:
C      IBUF    I(512)    Scratch
C      IRET    I         0 => keep going, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IBUF(512), IRET
C
      INTEGER   IERR, INPOPS
      LOGICAL   RQUICK
      REAL      STARTR
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                        FIRST time: talk to initiator
C                                        initialize
      IRET = 1
      STARTR = 0.0
      TSKNAM = PRGM
      CALL ZDCHIN (.TRUE.)
      INPOPS = 1
      CALL GTPARM (PRGM, 1, RQUICK, STARTR, IBUF, IERR)
      IF ((IERR.GT.1) .AND. (IERR.NE.3)) THEN
         NPOPS = INPOPS
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (10)
         GO TO 999
         END IF
C                                        Force no TV, TK
      NTVDEV = 0
      NTKDEV = 0
C                                        set NPOPS of starter
      INPOPS = ABS(STARTR) + 0.1
C                                        restart initiator
      IF (IERR.EQ.0) THEN
         CALL RELPOP (0, IBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) INPOPS, IERR
            CALL MSGWRT (6)
            END IF
         END IF
C                                       go to user 1
      CALL ACOUNT (2)
      NLUSER = 1
      CALL ACOUNT (1)
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BATCH Q MANAGER CAN''T START',I7)
 1010 FORMAT ('RESUME INITIATOR',I4,' ERROR',I7)
      END
      SUBROUTINE QMNGDO (IBUF, IRET)
C-----------------------------------------------------------------------
C   QMNGDO begins by clearing any supposedly running jobs in any Q for
C   which there is not a current AIPSB.  Then it goes into a loop with
C   a delay looking for jobs which need to be run.  If there are none
C   it will exit.  If there is one that is ready, it will start the
C   appropriate AIPSBn.
C   Output:
C      IBUF   I(512)     scratch
C      IRET   I          0 => no errors, 1 => error occurred
C-----------------------------------------------------------------------
      INTEGER   IBUF(512), IRET
C
      CHARACTER AIPSB*6, ANAME*6, AIPVER*48, PHNAME*48
      INTEGER   NQ, OUPOPS, IERR, PID(4), ILUSER, INHUSE(3,12), JOBNO,
     *   TDLUN, TDIND, ISCRTC(256), ITEMP, IRETCD, IT, IREC
      LOGICAL   T, F, ACTIVE, ISJOB
      REAL      TDELAY, RSCRTC(256), TDL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (ISCRTC, RSCRTC)
      DATA T, F /.TRUE.,.FALSE./
      DATA AIPSB /'AIPSB '/
      DATA TDLUN /13/
C-----------------------------------------------------------------------
      IRET = 1
      CALL FILL (36, 0, INHUSE)
      IT = 0
C                                       MAIN LOOP
 100  ISJOB = .FALSE.
         TDELAY = 10.0
         IF (AIPSMK.GT.1.0) TDELAY = TDELAY / AIPSMK
         CALL ZDELAY (TDELAY, IERR)
         DO 120 NQ = 1,NBATQS
            OUPOPS = NINTRN + 1 + NQ
            CALL BLDTNM (AIPSB, OUPOPS, ANAME, IERR)
            CALL FILL (4, 0, PID)
            CALL ZTACTQ (ANAME, PID, ACTIVE, IERR)
            IF ((IERR.EQ.0) .AND. (ACTIVE)) THEN
               ISJOB = .TRUE.
            ELSE IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1100) NQ, IERR
               GO TO 990
C                                       Clear any failed batch jobs
            ELSE
               CALL BATQ ('FAIL', TDELAY, ' ', NQ, INHUSE, ILUSER,
     *            JOBNO, IBUF, IERR)
               IF ((IERR.NE.0) .AND. (IERR.NE.3)) THEN
                  WRITE (MSGTXT,1110) 'FAIL', NQ, IERR
                  GO TO 990
                  END IF
C                                       A job ready to run?
               CALL BATQ ('FIND', TDELAY, ' ', NQ, INHUSE(1,NQ), ILUSER,
     *            JOBNO, IBUF, IERR)
               IF ((IERR.GT.0) .AND. (IERR.NE.3)) THEN
                  WRITE (MSGTXT,1110) 'FIND', NQ, IERR
                  GO TO 990
                  END IF
               IF (IERR.EQ.0) GO TO 200
               IF (IERR.EQ.-1) ISJOB = .TRUE.
               END IF
 120        CONTINUE
         IF (.NOT.ISJOB) GO TO 900
            IF (IT.LT.10) IT = IT + 1
            IF (IT.LT.10) GO TO 100
               TDELAY = 140.0
               IF (AIPSMK.GT.1.0) TDELAY = TDELAY / SQRT (AIPSMK)
               CALL ZDELAY (TDELAY, IERR)
               GO TO 100
C                                       There is a job to run
 200  CONTINUE
         IT = 0
C                                       open task data file: use
C                                       the batch guy's NPOPS area
         ITEMP = JOBNO + 100 * NQ
         WRITE (MSGTXT,1200) ITEMP, ILUSER, OUPOPS
         CALL MSGWRT (4)
         CALL ZPHFIL ('TD', 1, 0, 4, PHNAME, IERR)
         CALL ZOPEN (TDLUN, TDIND, 1, PHNAME, F, T, T, IERR)
         IF (IERR.EQ.0) GO TO 210
            WRITE (MSGTXT,1201) IERR
            GO TO 990
C                                        Parms data
 210     CALL FILL (256, 0, ISCRTC)
         ISCRTC(1) = ILUSER
         ISCRTC(2) = 0
         ISCRTC(3) = 0
         ISCRTC(4) = 0
         ISCRTC(5) = 32000
         ISCRTC(6) = 0
         ISCRTC(7) = 0
         ISCRTC(8) = 0
         RSCRTC(9) = 1.
         CALL CHR2H (4, VERNAM, 1, RSCRTC(10))
         RSCRTC(11) = JOBNO
         IREC = (OUPOPS-1) * 4 + 2
         CALL ZFIO ('WRIT', TDLUN, TDIND, IREC, ISCRTC, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1215) IERR
            GO TO 990
            END IF
         CALL ZFIO ('READ', TDLUN, TDIND, 1, ISCRTC, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1215) IERR
            GO TO 990
            END IF
         ITEMP = (OUPOPS-1) * 5 + 1
         CALL CHR2H (8, AIPSB, 1, RSCRTC(ITEMP))
         IRETCD = -999
         ISCRTC(ITEMP+2) = IRETCD
         ISCRTC(ITEMP+3) = 0
         ISCRTC(ITEMP+4) = 0
         CALL ZFIO ('WRIT', TDLUN, TDIND, 1, ISCRTC, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1215) IERR
            GO TO 990
            END IF
         CALL ZCLOSE (TDLUN, TDIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1225) IERR
            GO TO 990
            END IF
C                                        activate it finally
         CALL FILL (4, 0, PID)
         AIPVER = VERNAM
         CALL ZACTV8 (AIPSB, OUPOPS, AIPVER, PID, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1230) NQ, IERR
            GO TO 990
            END IF
C                                        suspend until AIPSB ok
C                                        read return code
         TDL = 3.0
         IF (AIPSMK.GT.0.0) TDL = 3.0 / MAX (0.5, AIPSMK)
         CALL TASKWT (ANAME, OUPOPS, PID, F, TDL, ISCRTC, IRETCD, IERR)
C                                       ABORT not resume via TD
         IF ((IRETCD.EQ.-999) .OR. (IERR.NE.0)) THEN
            WRITE (MSGTXT,1250) NQ, IERR
            CALL MSGWRT (8)
C                                       Okay.
         ELSE
            WRITE (MSGTXT,1255) NQ, IRETCD
            CALL MSGWRT (2)
            END IF
         GO TO 100
C                                        end BATCH: normal
 900  WRITE (MSGTXT,1900)
      CALL MSGWRT (2)
      IRET = 0
      GO TO 999
C                                       error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ZTACTQ ON AIPSB QUEUE',I5,' ERROR',I7)
 1110 FORMAT (A4,' QUEUE',I5,' ERROR',I7)
 1200 FORMAT ('Start job',I5,' for user',I6,' as POPS',I4)
 1201 FORMAT ('OPEN TASK DATA FILE ERROR',I7)
 1215 FORMAT ('READ/WRITE TASK DATA FILE ERROR',I7)
 1225 FORMAT ('CLOSE TASK DATA FILE ERROR',I7)
 1230 FORMAT ('ACTVIVATE QUEUE',I3,' AIPSB ZACTV8 ERROR',I7)
 1250 FORMAT ('AIPSB QUEUE',I4,' TASKWT ERROR CODE',I4)
 1255 FORMAT ('AIPSB queue',I4,' resumes me normally.  Code=',I7)
 1900 FORMAT ('All batch jobs have concluded')
      END

      SUBROUTINE QGRD8 (APCORE, UV, VIS, WT, GRID, CONX, CONY, CONI,
     *   NO2, M, LROW)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Convolve data onto a grid: sigma**2 estimate
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Convolves pseudo-visibility (real only) data onto a grid.
C   Works for total intensity mapping, accumulating weighted
C   gridded visibility values and the sum of the weights
C   accumulated into a cell.
C   Inputs:
C      UV    I  Location of (u,v) values in cells, uniform weight FACTOR
C      VIS   I  Location of (complex) visibilities.
C      WT    I  Weight for data. Assumes any tapering
C               has already been done.
C      GRID  I  base address of gridded data.
C               Order assumed to be the following
C               for each of the M rows:
C                1) 2 * LROW visibilities (sum gridded vis, sum weights)
C      CONX  I  base address of X convolving fn.
C      CONY  I  base address of Y convolving fn.
C      CONI  I  increment in convolving func = 1/CONI cells
C      NO2   I  INT( (# cells used on a row) / 2 )
C      M     I  number of rows kept in the AP.
C      LROW  I  length of a row ( max. X).
C   In the above, X refers to rows and y to columns in the gridded data,
C   NOT on the sky.  The total numbers of rows and cells used on a row
C   should be odd.  All AP memory I/O values are assumed floating.
C   It is assumed that all values of v correspond to row M/2.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   UV, VIS, WT, GRID, CONX, CONY, CONI, NO2, M, LROW
C
      LONGINT   JUV, JVIS, JWT, JGRID, JCONX, JCONY, JCX, JCY, JG, JJCX
      INTEGER   N, INCR, IADD, IX, IY, IRND, LINC
      DOUBLE PRECISION ARE, AIM, X, XX, XWT, Y, UWT, XCONI
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IRND(XX) = INT (XX + SIGN (0.5D0, XX))
C-----------------------------------------------------------------------
C                                        Convert addresses to 1 rel.
      JUV = UV + PSAPOF
      JVIS = VIS + PSAPOF
      JWT = WT + PSAPOF
      JGRID = GRID + PSAPOF
      JCONX = CONX + PSAPOF
      JCONY = CONY + PSAPOF
      N = NO2 * 2 + 1
      XCONI = CONI
C                                        Check weight.
      XWT = APCORE(JWT)
      IF (XWT.LE.0.0D0) GO TO 999
      UWT = APCORE(JUV+2)
      IF (UWT.LE.0.0D0) GO TO 999
C                                        Determine location.
      X = APCORE(JUV+1)
      Y = APCORE(JUV)
C                                        Separable conv functions
      IF (JCONY.NE.JCONX) THEN
C                                        Deter. conv. fn loc.
         JCX = IRND (XCONI * (IRND (X)-X-0.5D0))
         JCY = IRND (XCONI * (IRND (Y)-Y-0.5D0))
         JCX = JCX + JCONX + CONI
         JCY = JCY + JCONY + CONI
C                                        Determine grid loc.
         JG = JGRID
C                                        Check end of row.
         IX = IRND (X) + LROW / 2 + 1
         IADD = LROW - NO2 - IX
C                                        Will hit end of row.
         IF (IADD.LT.0) THEN
            N = N + IADD
            IF (N.LE.0) GO TO 999
            END IF
C                                        Check front of row.
         IX = IX - NO2 - 1
C                                        Will hit front of row
         IF (IX.LT.0) THEN
            N = N + IX
            IF (N.LE.0) GO TO 999
            JCX = JCX - IX * CONI
C                                        Finish grid address.
         ELSE
            JG = JG + 2 * IX
            END IF
C                                        Save JCX
         JJCX = JCX
C                                        Get visibility
         INCR = 2 * LROW - 2 * N
C                                        Gridding loop
      INCLUDE 'INCS:ZVND.INC'
         DO 30 IY = 1,M
            JCX = JJCX
            AIM = APCORE(JCY) * XWT * UWT
            ARE = APCORE(JCY) * AIM * UWT
      INCLUDE 'INCS:ZVND.INC'
            DO 20 IX = 1,N
C                                        Sum to grid.
               APCORE(JG) = APCORE(JG) + APCORE(JCX) * APCORE(JCX) * ARE
               APCORE(JG+1) = APCORE(JG+1) + APCORE(JCX) * AIM
C                                        Update pointers.
               JCX = JCX + CONI
               JG = JG + 2
 20            CONTINUE
C                                        Update pointers.
            JCY = JCY + CONI
            JG = JG + INCR
 30         CONTINUE
C                                       circular function
      ELSE
C                                        Deter. conv. fn loc.
         JCX = IRND (XCONI * (IRND (X)-X-0.5D0))
         JCY = IRND (XCONI * (IRND (Y)-Y-0.5D0))
         JCX = JCX + JCONX + CONI
         JCY = JCY + CONI
C                                        Determine grid loc.
         JG = JGRID + 2 * (IRND (X) + LROW / 2 - NO2)
C                                        Save JCX
         JJCX = JCX
C                                        Get visibility
         INCR = 2 * LROW - 2 * N
         LINC = CONI * M + 1
C                                        Gridding loop
         AIM = XWT * UWT
         ARE = AIM * UWT
      INCLUDE 'INCS:ZVND.INC'
         DO 130 IY = 1,M
            JCX = JJCX + JCY
      INCLUDE 'INCS:ZVND.INC'
            DO 120 IX = 1,N
C                                        Sum to grid.
               APCORE(JG) = APCORE(JG) + APCORE(JCX) * APCORE(JCX) * ARE
               APCORE(JG+1) = APCORE(JG+1) + APCORE(JCX) * AIM
C                                        Update pointers.
               JCX = JCX + CONI
               JG = JG + 2
 120           CONTINUE
C                                        Update pointers.
            JCY = JCY + CONI * LINC
            JG = JG + INCR
 130        CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE SNREFM (DISK, CNO, VER, CATBLK, LUN, IRET)
C-----------------------------------------------------------------------
C! Checks existence of SN table, changes format if necessary
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2012, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to change the format of the SN table prior to SNREV from
C   PSNTAB.INC
C   NOTE: routine uses LUNs 45 & 46 as a temporary logical unit number.
C      For versions prior to revision 10 the reference frequency for IF
C   phases is changed to the ref. channel in the IF rather than the
C   reference frequency for the array.
C
C   Inputs:
C      DISK            I       Volume number
C      CNO             I       Catalogue number
C      VER             I       Version to check/modify
C      CATBLK(256)     I       Catalogue header
C      LUN             I       LUN to use
C   Output:
C      IRET            I       Error, 0 => OK
C
C   Note, routine will leave no trace of its operation, i.e. SN table
C   will be closed on output and will have same number as one specified.
C   Difference will be only that the table will be in the new format.
C-----------------------------------------------------------------------
      INTEGER DISK, CNO, VER, CATBLK(256), LUN, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER CTEMP*12, UTYPE*2, STAT*4, KEYW*8, BNDCOD(MAXIF)*8
      INTEGER BUFFER(1024), ISNRNO, SNKOLS(MAXSNC), SNNUMV(MAXSNC),
     *   NUMANT, NUMPOL, NUMIF, NUMNOD, OVER, OLUN, REVNO,
     *   OBUFF(1024), OKOLS(MAXSNC), ONUMV(MAXSNC), NSNROW, I, IIF,
     *   SOURID, ANTNO, SUBA, FREQID, NODENO, REFA(2,MAXIF),
     *   OSNRNO, MSGSAV, IDUM, KLOCS(1), KEYVAL(1), KEYTYP, JERR
      LOGICAL ISAPPL, CHSTAT, TABLE, EXIST, FITASC
      REAL    GMMOD, RANOD(25), DECNOD(25), TIMEI, IFR, MBDELY(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF),
     *   RATE(2,MAXIF), WEIGHT(2,MAXIF), DISP(2), DDISP(2), TWOPI
      DOUBLE PRECISION TIME
C                                       CHNDAT arguments
      INTEGER   FQLUN, FQNIF, FQBUFF(512), FQFQID, FQVER, FQSBND(MAXIF)
      REAL      FQFINC(MAXIF), FQPHS, FQRE, FQIM, FQTRE, FQTIM
      DOUBLE PRECISION FQFOFF(MAXIF)
      INCLUDE 'INCS:PSNTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA OLUN /45/
      DATA TWOPI /6.283185308/
C-----------------------------------------------------------------------
C                                       Check existance
      CALL ISTAB ('SN', DISK, CNO, VER, LUN, BUFFER, TABLE, EXIST,
     *   FITASC, IRET)
      IRET = 0
      IF (.NOT.EXIST) GO TO 999
C                                       Open SN file
      CALL SNINI ('READ', BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   ISNRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD,
     *   GMMOD, RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.EQ.2) THEN
         IRET = 0
         GO TO 999
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Is it new format?
C                                       Read REVISION keyword
      KEYW = 'REVISION'
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL TABKEY ('READ', KEYW, 1, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *   JERR)
      MSGSUP = MSGSAV
      REVNO = -1
      IF ((JERR.EQ.0) .AND. (KLOCS(1).GT.0)) REVNO = KEYVAL(KLOCS(1))
C                                       Current revision (from PSNTAB)?
      IF (REVNO.GE.SNREV) THEN
         CALL TABIO ('CLOS', 0, ISNRNO, BUFFER, BUFFER, IRET)
         GO TO 999
         END IF
C                                       Reformat table; should be able
C                                       to read old tables with TABSN.
      WRITE (MSGTXT,1070) VER
      CALL MSGWRT (6)
C                                       Determine status of file
      UTYPE = 'UV'
      CHSTAT = .FALSE.
      CALL CATDIR ('INFO', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE, IDUM,
     *   STAT, OBUFF, IRET)
      IF (STAT.EQ.'READ') THEN
C                                       Change status
         STAT = 'CLRD'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'CLRD'
            GO TO 990
            END IF
         STAT = 'WRIT'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'WRIT'
            GO TO 990
            END IF
         CHSTAT = .TRUE.
         END IF
C                                       # rows in old table
      NSNROW = BUFFER(5)
C                                       Setup
      FQFQID = -999
      FQLUN = 46
      FQVER = 1
C                                       Open up new SN table
      OVER = 0
      CALL SNINI ('WRIT', OBUFF, DISK, CNO, OVER, CATBLK, OLUN,
     *   OSNRNO, OKOLS, ONUMV, NUMANT, NUMPOL, NUMIF, NUMNOD,
     *   GMMOD, RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Loop and copy
      DO 800 I = 1, NSNROW
         CALL TABSN ('READ', BUFFER, ISNRNO, SNKOLS, SNNUMV, NUMPOL,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
C                                       Deselected record.
         IF (IRET.LT.0) GO TO 800
         IF (IRET.NE.0) GO TO 999
C                                       Modifications
         IF (REVNO.LT.10) THEN
C                                       New frequency table
            IF ((FREQID.GT.0) .AND. (FREQID.NE.FQFQID)) THEN
               FQFQID = FREQID
               CALL CHNDAT ('READ', FQBUFF, DISK, CNO, FQVER, CATBLK,
     *            FQLUN, FQNIF, FQFOFF, FQSBND, FQFINC, BNDCOD, FQFQID,
     *            IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
C                                       Change ref. frequency for IF
C                                       phase.
            DO 50 IIF = 1,FQNIF
               IF ((CREAL(1,IIF).NE.FBLANK) .AND.
     *            (DELAY(1,IIF).NE.FBLANK)) THEN
                  FQPHS = TWOPI * FQFOFF(IIF) * DELAY(1,IIF)
                  FQRE = COS (FQPHS)
                  FQIM = SIN (FQPHS)
                  FQTRE = CREAL(1,IIF)
                  FQTIM = CIMAG(1,IIF)
                  CREAL(1,IIF) = FQRE * FQTRE - FQIM * FQTIM
                  CIMAG(1,IIF) = FQRE * FQTIM + FQIM * FQTRE
                  END IF
 50            CONTINUE
            IF (NUMPOL.GT.1) THEN
               DO 60 IIF = 1,FQNIF
                  IF ((CREAL(2,IIF).NE.FBLANK) .AND.
     *               (DELAY(2,IIF).NE.FBLANK)) THEN
                     FQPHS = TWOPI * FQFOFF(IIF) * DELAY(2,IIF)
                     FQRE = COS (FQPHS)
                     FQIM = SIN (FQPHS)
                     FQTRE = CREAL(2,IIF)
                     FQTIM = CIMAG(2,IIF)
                     CREAL(2,IIF) = FQRE * FQTRE - FQIM * FQTIM
                     CIMAG(2,IIF) = FQRE * FQTIM + FQIM * FQTRE
                     END IF
 60               CONTINUE
               END IF
            END IF
C                                       Write new table.
         CALL TABSN ('WRIT', OBUFF, OSNRNO, OKOLS, ONUMV, NUMPOL,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
         IF (IRET.NE.0) GO TO 999
 800     CONTINUE
      IRET = 0
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ISNRNO, BUFFER, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OSNRNO, OBUFF, OBUFF, IRET)
C                                       Delete the original file
      CALL RMEXT (DISK, CNO, 'SN', VER, CATBLK, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy new file to place
C                                       occupied by old one
      MSGSAV = MSGSUP
      MSGSUP = 31999
      CALL TABCOP ('SN', OVER, VER, OLUN, LUN, DISK, DISK, CNO, CNO,
     *   CATBLK, OBUFF, BUFFER, IRET)
      MSGSUP = MSGSAV
      IF (IRET.NE.0) GO TO 999
C                                       Delete the now defunct
C                                       original output file
      CALL RMEXT (DISK, CNO, 'SN', OVER, CATBLK, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Check if changed status
      IF (CHSTAT) THEN
         STAT = 'CLWR'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'CLWR'
            GO TO 990
            END IF
         STAT = 'READ'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'READ'
            GO TO 990
            END IF
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SNREFM: ERROR ',I3,' RETURNED FROM SNINI')
 1070 FORMAT ('SNREFM: Reformatting SN table ',I3)
 1080 FORMAT ('SNREFM: ERROR ',I3,' CHANGING ',A4,' STATUS')
      END

      SUBROUTINE ZDOPR4 (IVOL, IBMLUN, NCOPY, FILNAM, ISIZE, INBLK,
     *   IERR)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZDOPRT will read a bit map such as produced by PRTDRW and convert
C   it into a FORTRAN file that can be spooled to the PRINTRONIX
C   printer-plotter as a plot.  The number of pixels per line for the
C   PRINTRONIX is set to 768 (128*6, 96*8, or 48 I).    This version
C   spools the plot to the device queue with the logical name PLOTTER.
C     INPUTS:
C        IVOL      I   volume no. of bit map disk (1 rel)
C        IBMLUN    I   bit map logical unit number.
C        NCOPY     I   Number of copies of the plot to make.
C        FILNAM    I(12)   physical file name of bit map.
C        ISIZE     I   size of INBLK in words
C      IN/Out:
C        INBLK     I(*)    scratch buffer
C     OUTPUTS:
C        IERR      I   error return code.
C                    0 - good.
C                   >0 - an error occurred.
C   VAX VERSION: works under VMS for PRINTRONIX as a regular printer
C       831107   JHS
C-----------------------------------------------------------------------
      IMPLICIT   NONE
      DOUBLE PRECISION
     *       RBYTES
      REAL       READ, DELAY1, DELAY3
      INTEGER    FORERR, RMSERR, QPRINT, IER
      INTEGER    I4ERR, SYS$CRELOG
      INTEGER    MSGLEN
      INTEGER    INBLK(1), IOBLK(66), ISIZE, FILNAM(12)
      INTEGER    IHURT(12)
      INTEGER    ILPLUN, ISIZE2, NCOPY, IERR
      INTEGER    ILEN, INPOS, IOPOS, IBMLUN, IBMIND, IVOL, INIBLK
      INTEGER    IRRN(2), FF, IMLINE, ILINE, NBYTES
      INTEGER    I, II
      INTEGER    N1, N6, N7, N48
      LOGICAL    EXCL, NOMAP, WAIT, MAP
      BYTE       PLOTBYT(24), LPBLK(128), SUFFIX(3)
      CHARACTER*64 MESSAGE
      CHARACTER*9 PRINTQ
      CHARACTER*7 PLOTER, DEVICQ
      CHARACTER  PLTFIL*13, PLOTDSN*24
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (EXCL, WAIT, MAP)
C  Note that character variable PLOTDSN is set through its equvalence
C  with IHURT which is set to FILNAM
      EQUIVALENCE (IHURT(1),PLOTBYT(1)),(PLOTBYT(1),PLOTDSN)
      DATA READ /'READ'/
      DATA FF/'000C'X/
      DATA ILPLUN/1/,       N1, N6, N7, N48 /1, 6, 7, 48/
      DATA SUFFIX / '05'X, '0D'X, '0A'X /
      DATA EXCL /.TRUE./,         NOMAP /.FALSE./
      DATA PLOTER /'PLOTTER'/,    PRINTQ /'SYS$PRINT'/
      DATA DELAY1, DELAY3 /1.0, 3.0/
C-----------------------------------------------------------------------
C                                       Open the bit map file.
      CALL ZOPEN (IBMLUN, IBMIND, IVOL, FILNAM, MAP, EXCL, WAIT, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (N7)
         GO TO 999
C                                       Find out Queue name for plotter.
 10   CONTINUE
      CALL ZTRLOG (PLOTER, DEVICQ, ILEN, IERR)
      IF (IERR.EQ.0) GO TO 12
         WRITE (MSGTXT,1010)
         CALL MSGWRT (N6)
         GO TO 995
 12   CONTINUE
C                                       Get the Bit file name into
C                                       characters for others to use
      DO I=1,12
          IHURT(I) = FILNAM(I)          !Note the equivalence to PLOTDSN
      ENDDO
C                                       Assign SYS$PRINT to plotter
C                                       device queue.
      I4ERR = SYS$CRELOG (%VAL(2), PRINTQ, DEVICQ(:ILEN),)
      IF (I4ERR.EQ.1) GO TO 15
         WRITE (MSGTXT,1012) I4ERR
         CALL MSGWRT (N6)
         GO TO 995
 15   CONTINUE
C                                       Initial buffer counters.
      INPOS = 257
      IOPOS = 1
      IRRN(1) = 1
      IRRN(2) = 0
      NBYTES = 2 * ISIZE                !Number of bytes in input buffer
      ILINE = 0
      ISIZE2 = ISIZE                    !Size of input buffer (words)
C     IBMLUN - Logical unit number for read
C     IBMIND - Pointer to FTAB returned by ZOPEN (always even number)
C     IRRN(1)- Block number 'One relative beginning block number.'
C     NBYTES - Number of bytes to transfer
C     INBLK  - The i/o buffer
C     N1     - One signifies use one buffer i/o
C     IERR   - Error return code (0-> success)
      CALL ZMI3 (READ, IBMLUN, IBMIND, IRRN, NBYTES, INBLK, N1, IERR)
      IF (IERR.EQ.0) CALL ZWAIT (IBMLUN, IBMIND, N1, IERR)
      IF (IERR.NE.0) GO TO 920
      IRRN(1) = IRRN(1) + NBYTES/NBPS   !Number of records read in
      IMLINE = INBLK(1)                 !Number of lines in picture
C
C   It appears that RBYTES is the number of bytes in the picture
C   remaining to be processed.  I am going to change the coefficient on
C   IMLINE from 264 (2112/8) to reflect the PRINTRONIX
C                                My guess is 768/8 = 96      JHS 831018
      RBYTES = 512.0D0 + 96.0D0 * IMLINE - NBYTES
C                                Open the PRINTRONIX (spool file)
C                                Estimate an initial size for PLOT.DAT
      INIBLK = .58 * IMLINE
C                                       Try for each available disk.
      DO 50 I = 1,NVOL
         WRITE (PLTFIL, '(''DA0'',I1,'':PLOT.DAT'')' ) I - 1
         OPEN (UNIT=ILPLUN, FILE=PLTFIL, STATUS='NEW',
     *      ACCESS='SEQUENTIAL', FORM='FORMATTED',
     *      CARRIAGECONTROL='NONE', DISP='PRINT',
     *      RECORDTYPE='VARIABLE', INITIALSIZE=INIBLK, IOSTAT=IERR)
         IF (IERR.EQ.0) GO TO 100
            WRITE (MSGTXT,1015) IERR, I
            CALL MSGWRT (N7)
 50      CONTINUE
      GO TO 990
C
C-----------------------------------------------------------------------
C
C                                       Begin master loop.
 100  CONTINUE
C                                       See if we need to read new buff
         IF (INPOS.LE.ISIZE2) GO TO 110
            IF (RBYTES.LT.0.01) GO TO 800
            IF (RBYTES.GE.NBYTES) GO TO 105
C                                       Last input buffer.
               NBYTES = RBYTES + 0.1
               ISIZE2 = NBYTES / 2
 105        CONTINUE
            CALL ZMI3 (READ, IBMLUN, IBMIND, IRRN, NBYTES, INBLK, N1,
     *         IERR)
            IF (IERR.EQ.0) CALL ZWAIT (IBMLUN, IBMIND, N1, IERR)
            IF (IERR.NE.0) GO TO 920
            RBYTES = RBYTES - NBYTES
C       NBPS is appearantly Number of Bytes Per Something (buffer?)
C           When I ran DEBUG NBPS was 512 (probably set from common)
            IRRN(1) = IRRN(1) + NBYTES/NBPS
            INPOS = 1
C                                       Determine length to copy.
 110     ILEN = MIN (ISIZE2+1-INPOS, 49-IOPOS)
C                                       Try it without a swap
        DO I=0, ILEN - 1
           IOBLK(IOPOS+I) = INBLK(INPOS+I)
        ENDDO
C                                       Update position counters (words)
        IOPOS = IOPOS + ILEN
        INPOS = INPOS + ILEN
C
C                                       Write to PRINTRONIX spool file.
        IF (IOPOS.LE.48) GO TO 100
C                                       Convert to PRINTRONIX char
         CALL GETCH (N48, IOBLK, IOPOS, LPBLK, IERR)
C
         IF (IOPOS.GT.128) THEN
            IOPOS = 128
         ENDIF
         WRITE (ILPLUN,1110,ERR=940) (LPBLK(I), I=1,IOPOS) , SUFFIX
         ILINE = ILINE + 1
         IOPOS = 1
        GO TO 100
C                                       Flush last buffer.
 800  CONTINUE
      IOPOS = IOPOS - 1
      IF (IOPOS.LE.0) GO TO 990
C
         CALL GETCH(IOPOS,IOBLK,IOPOS,LPBLK,IERR)
C
         WRITE (ILPLUN,1110,ERR=940)    (LPBLK(I), I=1,IOPOS) , SUFFIX
         GO TO 990
C                                       Error handling.
 920  WRITE (MSGTXT,1920) IERR
      CALL MSGWRT (N7)
      GO TO 990
 940  CONTINUE
      CALL ERRSNS (FORERR, RMSERR)
      CALL SYS$GETMSG (%VAL(RMSERR), MSGLEN, MESSAGE, %VAL(1), )
      WRITE (6, '(1X,A64)' ) MESSAGE
      WRITE (MSGTXT,1940)
      CALL MSGWRT (N7)
C                                       Issue final form feed and
C                                       close files.
 990  WRITE (ILPLUN,1020,ERR=995) FF
      NCOPY = NCOPY - 1
      IF (NCOPY.LE.0) GO TO 995
         DO 993 I = 1, NCOPY
            CLOSE (UNIT=ILPLUN)
C  Note that character variable PLOTDSN is set through its equvalence
C  with FILNAM
C            IER = QPRINT(PLOTDSN)
C            IF (IER .NE. 0) THEN
C                ENCODE (80, 1995, MSGTXT) IER
C                CALL MSGWRT (N6)
C            ENDIF
C                                       Give spooler chance to get file.
            CALL ZDELAY (DELAY3, IERR)
C                                       Try a few times to open file.
            DO 992 II = 1,10
               CALL ZDELAY (DELAY1, IERR)
               OPEN (UNIT=ILPLUN, FILE=PLTFIL, STATUS='OLD',
     *            ACCESS='SEQUENTIAL', FORM='FORMATTED',
     *            CARRIAGECONTROL='NONE', DISP='PRINT',
     *            RECORDTYPE='VARIABLE', IOSTAT=IERR)
               IF (IERR.EQ.0) GO TO 993
 992           CONTINUE
            WRITE (MSGTXT,1992)
            CALL MSGWRT (N6)
 993        CONTINUE
 995  CLOSE (UNIT=ILPLUN, DISP='PRINT/DELETE')
C  Note that character variable PLOTDSN is set through its equvalence
C  with FILNAM
C      IER = QPRINT(PLOTDSN)
C      IF (IER .NE. 0) THEN
C         ENCODE (80, 1995, MSGTXT) IER
C         CALL MSGWRT (N6)
C      ENDIF
      CALL ZCLOSE (IBMLUN,IBMIND,IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZDOPRT: UNABLE TO OPEN BIT MAP FILE. IERR=',I4)
 1010 FORMAT ('ZDOPRT: NO LOGICAL NAME "PLOTTER".')
 1012 FORMAT ('ZDOPRT: COULD NOT ASSIGN LOGICAL NAME, IERR=',Z8)
 1015 FORMAT ('ZDOPRT: ERR ',I4,' OPENING SPOOL FILE ON DISK',I3,
     *  '. TRYING NEXT DISK')
 1020 FORMAT (A2)
 1110 FORMAT (128A1,3A1)
 1920 FORMAT ('ZDOPRT: ZFI3 READ ERROR. IERR=',I4)
 1940 FORMAT ('ZDOPRT: FORTRAN WRITE ERROR TO PLOTTER')
 1992 FORMAT ('ZDOPRT: COULD NOT REOPEN FILE FOR NEXT COPY')
 1995 FORMAT ('ZDOPRT: ERROR SENDING FILE TO PRTSYMB1. IERR=',I4)
      END
        SUBROUTINE GETCH(NIN,IN,NOUT,OUT,IERR)
C-----------------------------------------------------------------------
C       This routine takes the packed input byte stream and turns it
C       into a six character stream suitable for the PRINTRONIX P600.
C     INPUTS:
C        NIN       I    number of input words
C        IN(*)     I    packed bit stream
C     OUTPUTS:
C        NOUT      I    number of output characters (should be 8/3 NIN)
C        OUT(*)    BYTE characters suitable for the P600
C        IERR      I   error return code.
C                    0 - good.
C                   >0 - an error occurred.
C   VAX VERSION: works under VMS for PRINTRONIX as a regular printer
C       831103   JHS
C-----------------------------------------------------------------------
        IMPLICIT NONE
        INTEGER   IN(*), NIN, NOUT, IERR, IOUT, II, IO, IT, J, JJ, K
        BYTE OUT(*), NULL
        DATA NULL / 'C0'X /
C
        IOUT = 0                !Clear temp for output
        K = 0                   !Bit counter for out temp
        IO = 0          !Index into OUT
C
        DO II = 1, NIN
           IT = IN(II)
           DO JJ = 1, 16
              IT = ISHFTC(IT,1,16)      !Get MSB into LSB to use
              J = IT .AND. 1            !Reduce to 1 bit of interest
              IOUT = IOUT .OR. J        !Put this bit into output
              IOUT = ISHFTC(IOUT,-1,6)
              K = K + 1                 !Done 6 bits yet?
              IF (K .GE. 6) THEN        !Then store it.
                 IO = IO + 1            !Get the next byte index
                 OUT(IO) = IOUT + NULL  !Strobe in the graphics flag bit
                 IOUT = 0               !Reset for next character
                 K = 0
              ENDIF
           ENDDO
        ENDDO
        NOUT = IO
        IERR = 0
        RETURN
        END

      SUBROUTINE FILIO (OP, LUN, REC, DATA, ERROR)
C-----------------------------------------------------------------------
C! reads/writes 256-integer record to non-map file opened by FILOPN
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   WaWa IO system:  Read or Write a single record from/to a non-map
C   file which has been opened with FILOPN (256 integers).  Adds a
C   'READ' status to catlg on first call.
C   Inputs:
C      OP          C*4      READ or WRIT
C      LUN         I        File Logical Unit Number
C      REC         I        Which record out of file (1-relative)
C   In/Out:
C      DATA(256)   I        Data record to input or output
C   Output:
C      ERROR       I        Error return from ZFI3
C                           0 => o.k.
C                           1 => file not open
C                           2 => input error e.g. file not opened for
C                                desired operation
C                           3 => i/o error
C                           4 => end of file
C                           5 => beginning of medium
C                           6 => end of medium (from IO system)
C                          10 => catalog error
C   Written by WaWa (4/21/81)
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   LUN, REC, DATA(256), ERROR
C
      CHARACTER CHTM12*12, CHTM6*6, DUM2*2
      INTEGER   IFIL, NOTOPN, BADOP, CATER, WARN, IOP, IERR, IDUM
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA NOTOPN, BADOP, CATER, WARN /1,2,10,9/
C-----------------------------------------------------------------------
C                                       Is file open?
      ERROR = NOTOPN
      DO 10 IFIL = 1,5
         IF (FILTAB(POLUN,IFIL).EQ.LUN) GO TO 20
 10      CONTINUE
      GO TO 999
C                                       Good OPCODE?
 20   ERROR = BADOP
      IOP = 0
      IF (OP.EQ.'WRIT') IOP = 1
      IF (OP.EQ.'READ') IOP = 2
      IF (IOP.LE.0) GO TO 999
C                                       Need to set status, IOP?
 40   IF ((FILTAB(POIOP,IFIL).EQ.1) .OR. (FILTAB(POIOP,IFIL).EQ.2))
     *   GO TO 50
         FILTAB(POIOP,IFIL) = IOP
         CALL CATDIR ('CSTA', FILTAB(POVOL,IFIL), FILTAB(POCAT,IFIL),
     *      CHTM12, CHTM6, IDUM, DUM2, IDUM, REED, WBUFF, IERR)
         IF ((IERR.EQ.0) .OR. (IERR.EQ.WARN)) GO TO 50
            WRITE (MSGTXT,1040) FILTAB(POVOL,IFIL),
     *         FILTAB(POCAT,IFIL), IERR
            CALL MSGWRT (8)
            ERROR = CATER
            GO TO 999
C                                       Do it!
 50   CALL ZFIO (OP, LUN, FILTAB(POFIN,IFIL), REC, DATA, ERROR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('FILIO: CAN''T SET INITIAL STATUS ON VOL',I2, ' CAT',I4,
     *   ' ERROR',I6)
      END

      SUBROUTINE DEAVRT (IOP, RV, IEEE)
C-----------------------------------------------------------------------
C! converts between local REAL and local INT binary forms for transport
C# FITS TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   converts between real numbers and a local integer form suitable for
C   ZILI16 and transport using an intermediate IEEE representation
C   Inputs:
C      IOP    I       1 => R4 -> IEEE4,    2 => R8 -> IEEE8
C                     3 => IEEE4 -> R4,    4 => IEEE8 -> R8
C   In/out:
C      RV     "R"     Local value
C      IEEE   I(4)    IEEE value in integer buffer (3-4 for R8 only)
C   This version for doubles.  IOP 2 and 4 only
C-----------------------------------------------------------------------
      INTEGER   IOP, IEEE(4)
      REAL      RV
C
      DOUBLE PRECISION DX
C-----------------------------------------------------------------------
      IF (IOP.EQ.2) THEN
         CALL ZRLR64 (1, 1, RV, DX)
         CALL ZI16IL (4, 1, DX, IEEE)
      ELSE IF (IOP.EQ.4) THEN
         CALL ZILI16 (4, IEEE, 1, DX)
         CALL ZR64RL (1, 1, DX, RV)
         END IF
C
 999  RETURN
      END

      PROGRAM HLPB
C-----------------------------------------------------------------------
C! Modifies APROPOS list, replacing references to a help file
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2006, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Program to change the APROPOS list information from a help file.
C   Reads the command line argument <name>, then replaces all references
C   to <name> in $UPDATE/LSAPROPO.HLP with the current information.  If
C   $HLPFIL/<name..HLP does not exist, then it only removes the old
C   info.  The output will be written to $UPDATE/LSAPROPO.NEW.
C-----------------------------------------------------------------------
      INTEGER   NOWRDS
      PARAMETER (NOWRDS = 46)
      CHARACTER INLINE*100, OUTLIN*26, INFIL*48, OUTFIL*48, ARGV*12,
     *   LFIL*48, CATS(50)*15, WORDS(50)*15, NOWRD(NOWRDS)*15,
     *   TSTWRD*15, TSTLIN*26
      INTEGER   LOOP, IOERR, NUMWRD, LEN, LCATS, I, J, JTRIM, JT, DONE,
     *   BUFFER(512), LUNI, LUNO, FINDI, FINDO, LUNL, FINDL, IRET
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LUNI, LUNO, LUNL /16, 17, 18/
      DATA NOWRD /'ABOUT', 'AFTER', 'ALL', 'ALONG', 'ALSO', 'AN', 'AND',
     *   'ANOTHER', 'ANY', 'ARE', 'AS', 'AT', 'BASED', 'BE', 'BEFORE',
     *   'BETWEEN', 'BY', 'CAN', 'DOES', 'DURING', 'FOR', 'FROM',
     *   'GIVES', 'HAS', 'IN', 'INTO', 'IS', 'NOT', 'OF', 'ON', 'OR',
     *   'OTHER', 'SET', 'SETS', 'THE', 'TO', 'WHICH', 'WITH', 'VERB',
     *   'TASK', 'ADVERB', 'PSEUDOVERB', 'VERBS', 'TASKS', 'ADVERBS',
     *   'PSEUDOVERBS'/
C-----------------------------------------------------------------------
C                                       AIPS system start up stuff
      TSKNAM ='HLPB'
      NPOPS = 1
      IRET = 8
      MSGKIL = 32000
      MSGSUP = 32000
      CALL ZDCHIN (.FALSE., BUFFER)
      MSGKIL = 32000
      DEVTAB(LUNI) = 3
      DEVTAB(LUNO) = 3
      DEVTAB(LUNL) = 3
      CALL GETARG (1, ARGV)
      I = JTRIM (ARGV)
      IF (I.LE.0) THEN
         MSGTXT = 'ARGUMENT MUST BE GIVEN'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      IF (ARGV(:2).EQ.'ZZ') THEN
         MSGTXT = 'ZZ LIST FILES IGNORED'
         CALL MSGWRT (8)
         NUMWRD = 0
         GO TO 101
         END IF
C                                       read the help file
      INFIL = 'HLPFIL:' // ARGV(:I) // '.HLP'
      CALL ZTXOPN ('READ', LUNI, FINDI, INFIL, .FALSE., IOERR)
      NUMWRD = 0
      IF (IOERR.NE.0) GO TO 100
      NUMWRD = 1
      CATS(1) = ARGV(:I)
      DONE = 0
C                                       Read line loop
 10   CALL ZTXIO ('READ', LUNI, FINDI, INLINE, IOERR)
C                                       End of file?
         IF (IOERR.GT.0) GO TO 100
C                                       get words
         JT = JTRIM (INLINE)
         IF ((INLINE(:2).EQ.';!') .OR. (INLINE(:2).EQ.';#')) THEN
            LEN = JT - 2
            LCATS = 15
            CALL RWORDS (INLINE(3:), LEN, NUMWRD, LCATS, CATS)
            DONE = DONE + 1
            IF (DONE.EQ.2) GO TO 100
            END IF
C                                       Next line
         GO TO 10
C                                       Got words - sort them
 100  CALL ZTXCLS (LUNI, FINDI, IOERR)
 101  WORDS(1) = ' '
      IF (NUMWRD.GT.0) THEN
         DO 120 LOOP = 1,NUMWRD
            TSTWRD = 'ZZZZZZZZZZZZZZZ'
            DO 110 I = 1,NUMWRD
               IF (CATS(I).NE.' ') THEN
                  IF (CATS(I).LT.TSTWRD) THEN
                     J = I
                     TSTWRD = CATS(I)
                     END IF
                  END IF
 110           CONTINUE
            WORDS(LOOP) = TSTWRD
            CATS(J) = ' '
 120        CONTINUE
C                                       drop duplicates
         LEN = NUMWRD - 1
         DO 140 LOOP = 1,LEN
            J = LOOP + 1
            DO 130 I = J,NUMWRD
               IF (WORDS(LOOP).EQ.WORDS(I)) WORDS(I) = NOWRD(1)
 130           CONTINUE
 140        CONTINUE
C                                       drop prohibited words
         J = 0
         DO 160 LOOP = 1,NUMWRD
            DO 150 I = 1,NOWRDS
               IF (WORDS(LOOP).EQ.NOWRD(I)) GO TO 160
 150           CONTINUE
            J = J + 1
            CATS(J) = WORDS(LOOP)
 160        CONTINUE
         NUMWRD = J
         END IF
C                                       Open input list
      LFIL = 'UPDATE:LSAPROPO.HLP'
      CALL ZTXOPN ('READ', LUNL, FINDL, LFIL, .FALSE., IOERR)
      IF (IOERR.NE.0) GO TO 999
C                                       Open output file
      OUTFIL = 'UPDATE:LSAPROPO.OUT'
      CALL ZTXOPN ('WRIT', LUNO, FINDO, OUTFIL, .TRUE., IOERR)
      IF (IOERR.NE.0) GO TO 900
      J = 1
      TSTLIN = CATS(J) // ' ' // ARGV(:10)
C                                       look for start of data
 190  CALL ZTXIO ('READ', LUNL, FINDL, INLINE, IOERR)
         IF (IOERR.NE.0) GO TO 900
         I = JTRIM (INLINE)
         CALL ZTXIO ('WRIT', LUNO, FINDO, INLINE(:I), IOERR)
         IF (IOERR.NE.0) GO TO 900
         IF (INLINE(:8).NE.'--------') GO TO 190
C                                       looping over words in file
 200  CALL ZTXIO ('READ', LUNL, FINDL, INLINE, IOERR)
         IF (IOERR.NE.0) THEN
            IF (IOERR.EQ.2) IOERR = 0
            GO TO 900
            END IF
C                                       skip old ones
         IF (INLINE(17:26).EQ.ARGV(:10)) GO TO 200
C                                       Do we insert here?
 210     IF ((J.LE.NUMWRD) .AND. (TSTLIN.LT.INLINE)) THEN
            I = JTRIM (TSTLIN)
            CALL ZTXIO ('WRIT', LUNO, FINDO, TSTLIN(:I), IOERR)
            IF (IOERR.NE.0) GO TO 900
            J = J + 1
            TSTLIN = CATS(J) // ' ' // ARGV(:10)
            GO TO 210
            END IF
         OUTLIN = INLINE
         I = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', LUNO, FINDO, OUTLIN(:I), IOERR)
         IF (IOERR.NE.0) GO TO 900
         GO TO 200
C                                       Done - close files
 900  IF (IOERR.EQ.0) IRET = 0
      CALL ZTXCLS (LUNO, FINDO, IOERR)
      CALL ZTXCLS (LUNL, FINDL, IOERR)
C
 999  IF (IRET.GT.0) CALL ZEXIT (IRET)
      STOP
C-----------------------------------------------------------------------
 1000 FORMAT (A20)
 1100 FORMAT (' FILE TYPE HLP MUST BE SPECIFIED FOR ',A)
 1590 FORMAT (' ERROR READING FILE ',A)
      END
      SUBROUTINE RWORDS (LINE, LEN, NWORD, LWORDS, WORDS)
C-----------------------------------------------------------------------
C   Routine to get a list of words from a string:
C   Inputs:
C      LINE   C*(*)      Line to be scanned
C      LEN    I          Length of LINE to be searched.
C   Inputs/outputs:
C      NWORD  I          Number of values in WORDS
C      LWORD  I          Max number of characters in WORDS
C      WORDS  C(*)*LWORD Array or words
C-----------------------------------------------------------------------
      INTEGER   LEN, NWORD, LWORDS
      CHARACTER LINE*(*), WORDS(*)*(*)
C
      INTEGER   NIGNOR
      PARAMETER (NIGNOR = 22)
      INTEGER   POINT, WEND, I
      CHARACTER TCHAR, IGNORE(NIGNOR)*1
      DATA IGNORE /'.', ',', '''', '"', '?', '(', ')', '[', ']', '{',
     *   '}', '!', '&', '/', '|', '\\', ':', '-', '>', '<', '=', ';'/
C-----------------------------------------------------------------------
C                                       go to upper case
      CALL CHLTOU (LEN, LINE)
C                                       remove punctuation
      DO 20 POINT = 1,LEN
         TCHAR = LINE(POINT:POINT)
         DO 10 I = 1,NIGNOR
            IF (TCHAR.EQ.IGNORE(I)) THEN
               LINE(POINT:POINT) = ' '
               GO TO 20
               END IF
 10         CONTINUE
 20      CONTINUE
C                                       Loop finding words
      POINT = 1
C                                       Find next nonblank or end
 100  IF (POINT.LT.LEN) THEN
         IF (LINE(POINT:POINT).NE.' ') THEN
C                                       Found start of word
            WEND = POINT + INDEX (LINE(POINT:LEN), ' ') - 1
C                                       Last on line?
            IF (WEND.LE.POINT) WEND = LEN + 1
C                                       Snatch words > 1 char
            IF (WEND-1.GT.POINT) THEN
               NWORD = NWORD + 1
               WORDS(NWORD)(1:LWORDS) = LINE(POINT:WEND-1)
               END IF
            POINT = WEND
C                                       Blank
         ELSE
            POINT = POINT + 1
            END IF
         GO TO 100
         END IF
C
 999  RETURN
      END

      SUBROUTINE TSKBEG (PRGNAM, NPARM, RPARM, ERROR)
C-----------------------------------------------------------------------
C! task start up operations (common inits, GTPARM, RELPOP) for WaWa
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   WaWa IO package: Do most of the operations necessary to begin a
C   task:  Calls IOSET, calls GTPARM to get parameters, and, if
C   appropriate, calls RELPOP.  For <= 5 simultaneously open map files.
C   You should end with TSKEND..
C   Inputs:
C      PRGNAM   C*6    Task name
C      NPARM    I      No. of real parameters passed by AIPS
C   OUTPUTS:
C      RPARM    R(*)   Array to receive passed parameters
C      ERROR    I      Error return: 0 => Okay
C                         0 < ERROR <10  => Error return from GTPARM
C   Written by WaWa (last rev 4/21/81)
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*(*)
      INTEGER   NPARM, ERROR
      REAL      RPARM(*)
C
      INTEGER   IRET, IERR
      LOGICAL   RQUICK
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DITB.INC'
C-----------------------------------------------------------------------
C                                       Set WaWa IO tables
      TSKNAM = PRGNAM
      CALL IOSET
C                                       Get task parms from AIPS
      CALL GTPARM (PRGNAM, NPARM, RQUICK, RPARM, WBUFF, ERROR)
      IRET = 0
      IF (ERROR.EQ.0) GO TO 10
         RQUICK = .TRUE.
         IRET = 16
C                                       Resume AIPS if requested
 10   IF ((RQUICK) .AND. (ERROR.NE.1)) CALL RELPOP (IRET, WBUFF, IERR)
C                                       Pass RQUICK via integer
      QUACK = 0
      IF (RQUICK) QUACK = 1
C
 999  RETURN
      END

      SUBROUTINE TABNDX (OPCODE, BUFFER, INXRNO, NXKOLS, NXNUMV,
     *   TIME, DTIME, IDSOUR, SUBARR, VSTART, VEND, FREQID, IERR)
C-----------------------------------------------------------------------
C! Does I/O to Index (NX) table opened by NDXINI
C# EXT-util UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2013, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to INDEX extension tables. Usually used after setup by
C   NDXINI.
C    Inputs:
C     OPCODE       C*4 Operation code:
C                      'READ' = read entry from table.
C                      'WRIT' = write entry in table.
C                      'CLOS' = close file, flush on write
C     BUFFER(512)  I   I/O buffer and related storage, also defines file
C                      if open. Should have been returned by NDXINI or
C                      TABINI.
C     INXRNO       I   Next scan number to read or write.
C     NXKOLS(MAXNXC)  I   The column pointer array in order, TIME,
C                         TIME INTERVAL, SOURCE ID, SUBARRAY, START VIS,
C                         END VIS, FREQID.
C     NXNUMV(MAXNXC)  I   Element count in each column, set by NDXINI.
C    Input/output: (written to or read from INDEX file)
C     TIME         R   Center time of the scan (Days)
C     DTIME        R   Duration of scan (Days)
C     IDSOUR       I   Source ID as defined in then SOURCE table.
C     SUBARR       I   Subarray number.
C     VSTART       I   First visibility number in file.
C     VEND         I   Last visibility number in file.
C     FREQID       I   Freqid of scan
C    Output:
C     INXRNO       I   Next scan number.
C     IERR         I   Error code, 0=>OK else TABIO error.
C                      Note: -1=> read but record deselected.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), NXKOLS(MAXNXC), NXNUMV(MAXNXC), IDSOUR,
     *   SUBARR, FREQID, IERR, TIMKOL, INTKOL, SOUKOL, SUBKOL, FRSKOL,
     *   LSTKOL, FRQKOL, RECI(12)
      LOGICAL   DOREAD, DOCLOS
      INTEGER   INXRNO, VSTART, VEND
      REAL      TIME, DTIME, RECORD(12)
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (RECORD, RECI)
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
      DOCLOS = OPCODE.EQ.'CLOS'
C                                       Branch for CLOS
      IF (DOCLOS) GO TO 800
C                                       Set pointers
      TIMKOL = NXKOLS(1)
      INTKOL = NXKOLS(2)
      SOUKOL = NXKOLS(3)
      SUBKOL = NXKOLS(4)
      FRSKOL = NXKOLS(5)
      LSTKOL = NXKOLS(6)
      FRQKOL = NXKOLS(7)
C                                       If write fill RECORD
      IF (DOREAD) GO TO 50
         RECORD(TIMKOL) = TIME
         RECORD(INTKOL) = DTIME
         RECI(SOUKOL) = IDSOUR
         RECI(SUBKOL) = SUBARR
         RECI(FRSKOL) = VSTART
         RECI(LSTKOL) = VEND
         RECI(FRQKOL) = FREQID
C                                       Process record.
 50   CALL TABIO (OPCODE, 0, INXRNO, RECORD, BUFFER, IERR)
      INXRNO = INXRNO + 1
      IF (IERR.GT.0) GO TO 990
C                                       If READ pick data from RECORD.
      IF (DOREAD) THEN
         TIME = RECORD(TIMKOL)
         DTIME = RECORD(INTKOL)
         IDSOUR = RECI(SOUKOL)
         SUBARR = RECI(SUBKOL)
         VSTART = RECI(FRSKOL)
         VEND = RECI(LSTKOL)
         IF (BUFFER(10).EQ.7) THEN
            FREQID = RECI(FRQKOL)
         ELSE
            FREQID = 1
            END IF
         END IF
      GO TO 999
C                                       Close
 800  CALL TABIO ('CLOS', 0, INXRNO, RECORD, BUFFER, IERR)
      IF (IERR.GT.0) GO TO 990
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1800) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1800 FORMAT ('TABNDX: TABIO ERROR',I3)
      END

      SUBROUTINE ZTKBUF (IN, IT, IERR)
C-----------------------------------------------------------------------
C! flush TK buffer if needed, then store 8-bit byte in buffer
C# Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZTKBUF will flush the Tektronix output buffer TKBUFF, if necessary,
C   then store the low order 8-bit byte of IN into the proper 8-bit byte
C   of TKBUFF.  This is a Z-routine to allow for any required local
C   conversions.
C   Inputs:
C      IN       I   Word from which to extract the low order byte and
C                   store in TKBUF
C      IT       I   Data type indicator: 1 => control
C                      2 => position,  3 => char
C   Output:
C      IERR     I   Error return code: 0 => no error
C                      > 1 => write error (from TEKFLS)
C   Common: (DTKS.INC)
C      TKSIZE   I      Size of TKBUFF in floating point words
C      TKBUFF   R(*)   Tektronix output buffer
C      TKPOS    I      Current byte position in TKBUFF
C   Generic version.
C-----------------------------------------------------------------------
      INTEGER   IN, IT, IERR
C
      INTEGER   IBYTE, IWORD
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTKS.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       TKBUFF full?
      IF (TKPOS.GE.TKSIZE*4) CALL TEKFLS (IERR)
      IF (IERR.NE.0) IERR = 1
C                                       Increment position in TKBUFF.
      TKPOS = TKPOS + 1
      IWORD = (TKPOS - 1) / 4 + 1
      IBYTE = MOD (TKPOS-1, 4) + 1
C                                       Store low order byte of IN
C                                       in IBYTE of TKBUFF(IWORD).
      CALL ZPUTCH (IN, TKBUFF(IWORD), IBYTE)
C
 999  RETURN
      END

      SUBROUTINE CONV3 (APCORE, LUN, VOL, FIL, BO, XBUFF1, BUFSZ1,
     *   XBUFF2, BUFSZ2, NX, NY, IERR)
C-----------------------------------------------------------------------
C! Third of four routines to convolve two real images.
C# AP-FFT Math Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2006, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CONV3 = third of four routines to convolve two real images.
C   This routine reads the convolving image file and the transformed
C   image from CONV2, multiplies them and does the first pass at
C   transforming back.  Intermediate results are expected and left in
C   the AP if space permits.
C   Input:
C     LUN(5)      I    LUNs for files
C     VOL(5)      I    Volume numbers for the files.
C     FIL(5)      C*48 Physical names for the files.
C     BO(5)       I    Block offsets for the files.
C     XBUFF1(),XBUFF2()  R    Work buffers for I/O
C     BUFSZ1,BUFSZ2  I    Size in bytes for XBUFF1 and XBUFF2
C     NX,NY          I    Number of grid cells in X and Y of maps.
C   Output:
C     IERR          I    Return error code, 0=>OK, otherwise failed.
C                        3=>image too small to FFT
C     Partially transformed and transposed file left in the AP or
C     on the WORK file if necessary.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      CHARACTER FIL(5)*48, BADOP*4
      INTEGER   LUN(5), VOL(5), BO(5), BUFSZ1, BUFSZ2,
     *   NX, NY, IERR, IWIN(4), NX2, NY2
      REAL      XBUFF1(*), XBUFF2(*)
      INTEGER   FIND1, FIND2, BIND1, BIND2, BADFIL, WIN(4), IER,
     *   J, MPASS, NCOL, JAPWRD, I, IT, HALFNX, INDEX, ONENX, TWONY,
     *   JNDEX, APSIZ, ONENY, NWORD, JDIR, KNDEX, LNDEX
      DOUBLE PRECISION   XNDEX
      LOGICAL   MAP, WAIT, EXCL, ISNOT1
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DAPM.INC'
      DATA MAP, WAIT, EXCL /2*.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IERR = 0
C                                       Get power of 2 size of AP.
      JAPWRD = PSAPNW
      CALL AP2SIZ (JAPWRD, APSIZ)
C                                       Make sure min. dim .ge. 4
      IF ((NX.LT.4) .OR. (NY.LT.4)) THEN
           WRITE (MSGTXT,1000) NX,NY
           CALL MSGWRT (8)
           IERR = 3
           GO TO 999
           END IF
C                                       Determine number of AP loads
C                                       required
      NX2 = NX * 2
      NY2 = NY * 2
      XNDEX = NX2 / (1.0 * APSIZ)
      MPASS = NY2 * XNDEX + 0.0001
      MPASS = MAX (MPASS, 1)
      HALFNX = NX
      ONENX = NX2
      ONENY = NY2
      NWORD = 0
C                                       Open input and work file.
C                                       I/O only on multiple AP loads
      IF (MPASS.GT.1) THEN
         BADFIL = 1
         BADOP = 'OPEN'
         CALL ZOPEN (LUN(1), FIND1, VOL(3), FIL(3), MAP, EXCL, WAIT,
     *      IERR)
         IF (IERR.GT.0) GO TO 900
         BADFIL = 2
         CALL ZOPEN (LUN(2), FIND2, VOL(2), FIL(2), MAP, EXCL, WAIT,
     *      IERR)
         IF (IERR.GT.0) GO TO 900
         END IF
      BADOP = 'INIT'
C                                       COMPLEX to REAL transform
C                                       INIT read and write files.
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NY2 * 2
      WIN(4) = NX
      BADFIL = 1
      NCOL = APSIZ / (NY2 * 2)
      NCOL = MIN (NCOL, NX)
      TWONY = 2 * NY2
      JDIR = -1
C                                       Since Complex=>real do last
C                                       row (NX/2+1) to pack with first.
C                                       For MPASS=1 this was done in
C                                       CONV2.
      INDEX = ONENY * 2
      JNDEX = INDEX
      IF (MPASS.GT.1) THEN
         BADOP = 'INIT'
         IWIN(1) = 1
         IWIN(3) = NY2 * 2
         IWIN(2) = (NX2 / 2) + 1
         IWIN(4) = (NX2 / 2) + 1
         CALL MINIT ('READ', LUN(1), FIND1, IWIN(3), IWIN(4), IWIN,
     *      XBUFF1, BUFSZ1, BO(1), IERR)
         IF (IERR.NE.0) GO TO 900
         BADOP = 'READ'
         CALL MDISK ('READ', LUN(1), FIND1, XBUFF1, BIND1, IERR)
         IF (IERR.NE.0) THEN
            IT = NCOL
            GO TO 900
            END IF
         CALL QWR
         CALL QPUT (APCORE, XBUFF1(BIND1), JNDEX, TWONY, 2)
         CALL QWD
C                                       FFT row
         CALL QCFFT (APCORE, INDEX, ONENY, JDIR)
         BADOP = 'INIT'
         CALL MINIT ('READ', LUN(1), FIND1, WIN(3), WIN(4), WIN,
     *      XBUFF1, BUFSZ1, BO(1), IERR)
         IF (IERR.NE.0) GO TO 900
         BADFIL = 2
         CALL MINIT ('WRIT', LUN(2), FIND2, WIN(3), WIN(4), WIN,
     *      XBUFF2, BUFSZ2, BO(2), IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
         DO 600 I = 1,MPASS
            DO 560 J = 1,NCOL
               INDEX = (J - 1) * 2
               INDEX = INDEX * ONENY
               JNDEX = INDEX
               IF (MPASS.GT.1) THEN
                  CALL MDISK ('READ', LUN(1), FIND1, XBUFF1, BIND1,
     *               IERR)
                  IF (IERR.NE.0) THEN
                     IT = I + J - 1
                     BADFIL = 1
                     BADOP = 'READ'
                     GO TO 900
                     END IF
                  CALL QWR
                  CALL QPUT (APCORE, XBUFF1(BIND1), JNDEX, TWONY, 2)
                  CALL QWD
C                                       Row loaded, do FFT.
                  CALL QWR
                  END IF
C                                       Do not do FFT if it was done
C                                       in CONV2.
               ISNOT1 = (I*J) .NE.  1
               IF (ISNOT1 .OR. (MPASS.GT.1))
     *            CALL QCFFT (APCORE, INDEX, ONENY, JDIR)
               IF (.NOT.ISNOT1 .AND. (MPASS.NE.1)) THEN
C                                       Pack first (real) and
C                                       last (imag.)
                  LNDEX = 1
                  KNDEX = TWONY
                  CALL QVMOV (APCORE, KNDEX, 2, LNDEX, 2, ONENY)
                  END IF
 560           CONTINUE
C                                       Transpose.
            CALL APXPOS (APCORE, NCOL, NY2, 0, IERR)
            IF (IERR.NE.0) GO TO 990
C                                       Write only on multiple AP loads
            IF (MPASS.GT.1) THEN
C                                       Write out AP to work file.
               DO 590 J = 1,NCOL
                  INDEX = (J - 1) * ONENY * 2
                  JNDEX = INDEX
                  CALL MDISK ('WRIT', LUN(2), FIND2, XBUFF2, BIND2,
     *               IERR)
                  IF (IERR.NE.0) THEN
                     IT = I + J - 1
                     BADOP = 'WRIT'
                     BADFIL = 2
                     GO TO 900
                     END IF
                  CALL QGET (APCORE, XBUFF2(BIND2), JNDEX, TWONY, 2)
                  CALL QWD
 590              CONTINUE
               END IF
C                                       Roll AP if necessary.
C                                       Roll whole AP memory if
C                                       MPASS=1 otherwise none.
            NWORD = 0
            IF (MPASS.EQ.1) NWORD = APSIZ
            CALL QROLL (APCORE, NWORD, XBUFF1, BUFSZ1, IERR)
            IF (IERR.NE.0) GO TO 999
 600        CONTINUE
C                                       Finish write.
C                                       Write only on multiple AP loads
         IF (MPASS.GT.1) THEN
            CALL MDISK ('FINI', LUN(2), FIND2, XBUFF2, BIND2, IERR)
            IF (IERR.NE.0) THEN
               BADFIL = 2
               BADOP = 'FINI'
               GO TO 900
               END IF
            END IF
         GO TO 990
C                                       Errors
 900  WRITE (MSGTXT,1900) BADOP, IERR, FIL(BADFIL)
      IF ((BADOP.EQ.'READ') .OR. (BADOP.EQ.'WRIT')) WRITE (MSGTXT,1901)
     *   BADOP, IERR, IT, FIL(BADFIL)
      CALL MSGWRT (8)
C                                       Close files.
 990  IF ((MPASS.GT.1) .AND. (BADOP.NE.'OPEN')) CALL ZCLOSE (LUN(2),
     *   FIND2, IER)
      IF ((MPASS.GT.1) .AND. (BADOP.NE.'OPEN') .OR. (BADFIL.EQ.2))
     *   CALL ZCLOSE (LUN(1), FIND1, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CONV3: NX OR NY (',I5,',',I5,') LESS THAN 4')
 1900 FORMAT ('CONV3: ',A4,' ERROR',I7,' FILE ',A)
 1901 FORMAT ('CONV3: ',A4,' ERROR',I7,' ROW',I5,' FILE ',A)
      END

      SUBROUTINE ECALC (INIT, VOBS, IS, JS, WT, NUMBL, REFANT, MODE,
     *   MINNO, G, NREF, PRTLV, IERR)
C-----------------------------------------------------------------------
C! Gain Soln: exact solutions for 1 or 2 baselines only
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2004, 2014
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ECALC computes antenna gains given visibilities divided by the
C   model values for 1 or 2 baselines only
C   Inputs:
C      INIT     L        T -> start with (1,0) compute NREF if needed
C                        F -> start with GLAST, keep NREF as is
C      VOBS     R(2,*)   Averaged visibility (real, imaginary)
C      IS       I(*)     Array of first antenna numbers.
C      JS       I(*)     Array of second antenna numbers.
C      NUMBL    I        Number of observations.
C      REFANT   I        Desired reference antenna.
C      MODE     I        Solution mode: 0 = full gain soln.
C                           1 = phase only keep ampl. info.
C                           2 = phase only discard ampl. info.
C                           4-6 => 0-2 with robustness
C                        + 10 * weight func (1 sqrt, 2 4th root, 3 -> 1
C      MINNO    I        Min. number of antennas acceptable.
C      PRTLV    I        Print level,   0 = none
C                           1 = print (MSGWRT) soln.
C                           2 = print RMS at each iteration
C                           3 = print data plus soln.
C      FFLAST   R        Mark bad those data with closure error >
C                        FFLAST * rms closure error on last iteration
C   In/out:
C      WT       R(*)     Array of visibility weights - adjusted for
C                        amplitude normalizations and weight function
C   Outputs:
C      G        R(2,*)   Antenna gains to be applied (real, imaginary)
C      WORK     R(*)     Work array the size of VOBS
C      NREF     I        Reference antenna used.
C      IERR     I        Return error code 0 = OK
C                           1 = no valid data
C                           2 = didn't converge
C                           3 = too few antennas
C-----------------------------------------------------------------------
      LOGICAL   INIT
      INTEGER   IS(*), JS(*), NUMBL, REFANT, MODE, MINNO, NREF, PRTLV,
     *   IERR
      REAL      VOBS(2,*), WT(*), G(2,*)
C
      REAL      AMP, PH, XX1, XX2
      INTEGER   I, J, K, I1, I2, J1, J2, LMODE
      INCLUDE 'INCS:PUVD.INC'
      REAL      GLAST(2,MAXANT), SWT(MAXANT)
      INCLUDE 'INCS:DMSG.INC'
      COMMON /GLASTS/ GLAST
C-----------------------------------------------------------------------
      LMODE = MOD (MODE, 10)
      IF (LMODE.GT.4) LMODE = LMODE - 4
      IF (LMODE.EQ.2) LMODE = 1
      IERR = 0
C                                       find antenna list
      DO 10 I = 1,MAXANT
         SWT(I) = 0.0
 10      CONTINUE
      DO 20 K = 1,NUMBL
         I = IS(K)
         J = JS(K)
         SWT(I) = SWT(I) + WT(K)
         SWT(J) = SWT(J) + WT(K)
 20      CONTINUE
C                                       Initialize solutions
      DO 30 I = 1,MAXANT
         IF (INIT) THEN
            G(1,I) = 1.0
            G(2,I) = 0.0
            GLAST(1,I) = G(1,I)
            GLAST(2,I) = G(2,I)
         ELSE
            G(1,I) = GLAST(1,I)
            G(2,I) = GLAST(2,I)
            END IF
 30      CONTINUE
C                                       one single baseline
      IF (NUMBL.EQ.1) THEN
         IF (MINNO.GT.2) IERR = 3
         I1 = IS(1)
         J1 = JS(1)
         IF (NREF.EQ.0) NREF = REFANT
         IF ((NREF.NE.I1) .AND. (NREF.NE.J1)) NREF = I1
         XX1 = 1.0
         IF (LMODE.EQ.1) XX1 = SQRT (VOBS(1,1)*VOBS(1,1) +
     *      VOBS(2,1)*VOBS(2,1))
         IF (I1.EQ.NREF) THEN
            G(1,I1) = 1.0
            G(2,I1) = 0.0
            G(1,J1) = VOBS(1,1) / XX1
            G(2,J1) = -VOBS(2,1) / XX1
         ELSE
            G(1,J1) = 1.0
            G(2,J1) = 0.0
            G(1,I1) = VOBS(1,1) / XX1
            G(2,I1) = VOBS(2,1) / XX1
            END IF
C                                       exact solutions: 2 BASELINE
      ELSE IF (NUMBL.EQ.2) THEN
         IF (MINNO.GT.3) IERR = 3
         I1 = IS(1)
         J1 = JS(1)
         I2 = IS(2)
         J2 = JS(2)
         IF (NREF.EQ.0) NREF = REFANT
         IF ((NREF.NE.I1) .AND. (NREF.NE.I2) .AND. (NREF.NE.J1)
     *      .AND. (NREF.NE.J2)) NREF = I1
         XX1 = 1.0
         XX2 = 1.0
         IF (LMODE.EQ.1) XX1 = SQRT (VOBS(1,1)*VOBS(1,1) +
     *      VOBS(2,1)*VOBS(2,1))
         IF (LMODE.EQ.2) XX2 = SQRT (VOBS(1,2)*VOBS(1,2) +
     *      VOBS(2,2)*VOBS(2,2))
         IF (I1.EQ.NREF) THEN
            G(1,I1) = 1.0
            G(2,I1) = 0.0
            G(1,J1) = VOBS(1,1) / XX1
            G(2,J1) = -VOBS(2,1) / XX1
            IF (I2.EQ.NREF) THEN
               G(1,J2) = VOBS(1,2) / XX2
               G(2,J2) = -VOBS(2,2) / XX2
            ELSE IF (J2.EQ.NREF) THEN
               G(1,I2) = VOBS(1,2) / XX2
               G(2,I2) = VOBS(2,2) / XX2
            ELSE IF (I2.EQ.J1) THEN
               G(1,J2) = (VOBS(1,2)/XX2 * G(1,I2) +
     *            VOBS(2,2)/XX2 * G(2,I2)) /
     *            (G(1,I2)*G(1,I2) + G(2,I2)*G(2,I2))
               G(2,J2) = (VOBS(1,2)/XX2 * G(2,I2) -
     *            VOBS(2,2)/XX2 * G(1,I2)) /
     *            (G(1,I2)*G(1,I2) + G(2,I2)*G(2,I2))
            ELSE IF (J2.EQ.J1) THEN
               G(1,I2) = (VOBS(1,2)/XX2 * G(1,J2) -
     *            VOBS(2,2)/XX2 * G(2,J2)) /
     *            (G(1,J2)*G(1,J2) + G(2,J2)*G(2,J2))
               G(2,I2) = (VOBS(2,2)/XX2 * G(1,J2) +
     *            VOBS(1,2)/XX2 * G(2,J2)) /
     *            (G(1,J2)*G(1,J2) + G(2,J2)*G(2,J2))
            ELSE
               IERR = 2
               END IF
         ELSE IF (J1.EQ.NREF) THEN
            G(1,J1) = 1.0
            G(2,J1) = 0.0
            G(1,I1) = VOBS(1,1) / XX1
            G(2,I1) = VOBS(2,1) / XX1
            IF (I2.EQ.NREF) THEN
               G(1,J2) = VOBS(1,2) / XX2
               G(2,J2) = -VOBS(2,2) / XX2
            ELSE IF (J2.EQ.NREF) THEN
               G(1,I2) = VOBS(1,2) / XX2
               G(2,I2) = VOBS(2,2) / XX2
            ELSE IF (I2.EQ.I1) THEN
               G(1,J2) = (VOBS(1,2)/XX2 * G(1,I2) +
     *            VOBS(2,2)/XX2 * G(2,I2)) /
     *            (G(1,I2)*G(1,I2) + G(2,I2)*G(2,I2))
               G(2,J2) = (VOBS(1,2)/XX2 * G(2,I2) -
     *            VOBS(2,2)/XX2 * G(1,I2)) /
     *            (G(1,I2)*G(1,I2) + G(2,I2)*G(2,I2))
            ELSE IF (J2.EQ.I1) THEN
               G(1,I2) = (VOBS(1,2)/XX2 * G(1,J2) -
     *            VOBS(2,2)/XX2 * G(2,J2)) /
     *            (G(1,J2)*G(1,J2) + G(2,J2)*G(2,J2))
               G(2,I2) = (VOBS(2,2)/XX2 * G(1,J2) +
     *            VOBS(1,2)/XX2 * G(2,J2)) /
     *            (G(1,J2)*G(1,J2) + G(2,J2)*G(2,J2))
            ELSE
               IERR = 2
               END IF
         ELSE IF (I2.EQ.NREF) THEN
            G(1,I2) = 1.0
            G(2,I2) = 0.0
            G(1,J2) = VOBS(1,2) / XX2
            G(2,J2) = -VOBS(2,2) / XX2
            IF (I1.EQ.J2) THEN
               G(1,J1) = (VOBS(1,1)/XX1 * G(1,I1) +
     *            VOBS(2,1)/XX1 * G(2,I1)) /
     *            (G(1,I2)*G(1,I2) + G(2,I2)*G(2,I2))
               G(2,J1) = (VOBS(1,2)/XX2 * G(2,I1) -
     *            VOBS(2,1)/XX1 * G(1,I1)) /
     *            (G(1,I2)*G(1,I2) + G(2,I2)*G(2,I2))
            ELSE IF (J1.EQ.J2) THEN
               G(1,I1) = (VOBS(1,1)/XX1 * G(1,J1) -
     *            VOBS(2,1)/XX1 * G(2,J1)) /
     *            (G(1,J2)*G(1,J2) + G(2,J2)*G(2,J2))
               G(2,I1) = (VOBS(2,1)/XX1 * G(1,J1) +
     *            VOBS(1,1)/XX1 * G(2,J1)) /
     *            (G(1,J2)*G(1,J2) + G(2,J2)*G(2,J2))
            ELSE
               IERR = 2
               END IF
         ELSE IF (J2.EQ.NREF) THEN
            G(1,J2) = 1.0
            G(2,J2) = 0.0
            G(1,I2) = VOBS(1,2) / XX2
            G(2,I2) = VOBS(2,2) / XX2
            IF (I1.EQ.I2) THEN
               G(1,J1) = (VOBS(1,1)/XX1 * G(1,I1) +
     *            VOBS(2,1)/XX1 * G(2,I1)) /
     *            (G(1,I2)*G(1,I2) + G(2,I2)*G(2,I2))
               G(2,J1) = (VOBS(1,2)/XX2 * G(2,I1) -
     *            VOBS(2,1)/XX1 * G(1,I1)) /
     *            (G(1,I2)*G(1,I2) + G(2,I2)*G(2,I2))
            ELSE IF (J1.EQ.I2) THEN
               G(1,I1) = (VOBS(1,1)/XX1 * G(1,J1) -
     *            VOBS(2,1)/XX1 * G(2,J1)) /
     *            (G(1,J2)*G(1,J2) + G(2,J2)*G(2,J2))
               G(2,I1) = (VOBS(2,1)/XX1 * G(1,J1) +
     *            VOBS(1,1)/XX1 * G(2,J1)) /
     *            (G(1,J2)*G(1,J2) + G(2,J2)*G(2,J2))
            ELSE
               IERR = 2
               END IF
            END IF
         END IF
C                                       squirrel and print away
      IF (IERR.EQ.0) THEN
C                                       Print data if nec.
         IF (PRTLV.GE.3) THEN
            DO 100 K = 1,NUMBL
               AMP = SQRT (VOBS(1,K)*VOBS(1,K) + VOBS(2,K)*VOBS(2,K))
               PH = 57.296 * ATAN2 (VOBS(2,K), VOBS(1,K)+1.0E-20)
               WRITE (MSGTXT,1000) K, AMP, PH, IS(K), JS(K), WT(K)
               CALL MSGWRT (3)
 100           CONTINUE
            END IF
C                                       Print results.
         IF (PRTLV.GE.1) THEN
            DO 110 I = 1,MAXANT
               IF (SWT(I).GT.1.0E-20) THEN
                  AMP = SQRT (G(1,I)*G(1,I) + G(2,I)*G(2,I))
                  PH = 57.2958 * ATAN2 (G(2,I), G(1,I))
                  WRITE (MSGTXT,1420) I, AMP, PH
                  CALL MSGWRT (3)
                  END IF
 110           CONTINUE
            END IF
C                                       insure phase only
         IF (LMODE.EQ.1) THEN
            DO 120 I = 1,MAXANT
               IF (SWT(I).GT.1.0E-20) THEN
                  AMP = SQRT (G(1,I)*G(1,I) + G(2,I)*G(2,I))
                  IF (AMP.LE.0.0) AMP = 1.0
                  G(1,I) = G(1,I) / AMP
                  G(2,I) = G(2,I) / AMP
                  END IF
 120           CONTINUE
            END IF
C                                       save answers
         GLAST(1,I1) = G(1,I1)
         GLAST(2,I1) = G(2,I1)
         GLAST(1,J1) = G(1,J1)
         GLAST(2,J1) = G(2,J1)
         IF (NUMBL.EQ.2) THEN
            GLAST(1,I2) = G(1,I2)
            GLAST(2,I2) = G(2,I2)
            GLAST(1,J2) = G(1,J2)
            GLAST(2,J2) = G(2,J2)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I4,' Amp =',1PE12.3,' Phase =',0PF7.1,2I3,1PE12.3)
 1420 FORMAT ('Ant=',I5,' Amp=',F12.5,' Phase=',F12.2)
      END

      SUBROUTINE BOXBSM (WIDTH, X, Y, S, BLANK, N, YS)
C-----------------------------------------------------------------------
C! smoothing by boxcar of irregularly spaced array with blanking
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does a box-car smoothing of irregularly spaced points, replacing
C   blanked and good values with the smoothed values.  Only returns
C   blanked values if no valid data found within +-WIDTH/2.  Does not
C   smooth different source numbers together.  Therefore, make S(*)
C   constant if you wish to smooth all samples.
C   Inputs:
C      WIDTH    R      Full width of window in same units as X
C      X        R(N)   Absissae of points to be smoothed - monotonically
C                      increasing
C      Y        R(N)   Values to be smoothed.
C      S        I(N)   Source numbers - do not smooth across numbers
C                      If S(1) < 0, then S(I) is not otherwise examined
C      BLANK    R      Value used for blanking.
C      N        I      Number of points to smooth.
C    Output:
C      YS       R(N)   Smoothed values.
C-----------------------------------------------------------------------
      INTEGER   N, S(N)
      REAL      WIDTH, X(N), Y(N), YS(N), BLANK
C
      INTEGER   I, J, J1, J2
      REAL      HWIDTH, WTS, V
      LOGICAL   NOSORC
C-----------------------------------------------------------------------
C                                       copy if width <= 0
      IF (WIDTH.LE.0.0) THEN
         CALL RCOPY (N, Y, YS)
      ELSE
         NOSORC = S(1).LT.0
         HWIDTH = WIDTH / 2.0
         J2 = 1
         DO 100 I = 1,N
            J1 = J2
            J2 = N + 1
            WTS = 0.0
            V   = 0.0
C                                       source not examined
            IF (NOSORC) THEN
               DO 10 J = J1,N
                  IF (X(J)-X(I).GT.HWIDTH) GO TO 90
                  IF (ABS(X(I)-X(J)).LE.HWIDTH) THEN
                     J2 = MIN (J2, J)
                     IF (Y(J).NE.BLANK) THEN
                        WTS = WTS + 1.0
                        V = V + Y(J)
                        END IF
                     END IF
 10               CONTINUE
C                                       source examined
            ELSE
               DO 20 J = J1,N
                  IF (X(J)-X(I).GT.HWIDTH) GO TO 90
                  IF (ABS(X(I)-X(J)).LE.HWIDTH) THEN
                     J2 = MIN (J2, J)
                     IF ((Y(J).NE.BLANK) .AND. (S(I).EQ.S(J))) THEN
                        WTS = WTS + 1.0
                        V = V + Y(J)
                        END IF
                     END IF
 20               CONTINUE
               END IF
 90         IF (WTS.GT.0.0) THEN
               YS(I) = V / WTS
            ELSE
               YS(I) = BLANK
               END IF
 100        CONTINUE
         END IF
C
 999  RETURN
      END

      INTEGER FUNCTION ICAMAX (N, CX, INCX)
C-----------------------------------------------------------------------
C! Linpack routine: Index of complex element with max. abs. value
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Find index of complex element having Max. absolute value.
C     Inputs:
C      N     I  Element count
C      CX(*) C  Array
C      INCX  I  Increment of CX
C     Jack Dongarra, LINPACK, 3/11/78.
C-----------------------------------------------------------------------
      COMPLEX CX(*)
      REAL    SMAX
      INTEGER I, INCX, IX, N
      COMPLEX ZDUM
      REAL CABS1
C-----------------------------------------------------------------------
      CABS1(ZDUM) = ABS (REAL (ZDUM)) + ABS (AIMAG (ZDUM))
C
      ICAMAX = 0
      IF (N.LT.1) GO TO 999
      ICAMAX = 1
      IF (N.EQ.1) GO TO 999
      IF (INCX.EQ.1) GO TO 20
C                                       Code for increment not = 1
      IX = 1
      SMAX = CABS1 (CX(1))
      IX = IX + INCX
      DO 10 I = 2,N
         IF (CABS1 (CX(IX)).GT.SMAX) THEN
            ICAMAX = I
            SMAX = CABS1 (CX(IX))
            END IF
         IX = IX + INCX
   10    CONTINUE
      GO TO 999
C                                       Code for increment equal to 1
   20 SMAX = CABS1 (CX(1))
      DO 30 I = 2,N
         IF (CABS1 (CX(I)).GT.SMAX) THEN
            ICAMAX = I
            SMAX = CABS1 (CX(I))
            END IF
   30    CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ZTPOPN (LUN, FIND, IVOL, PNAME, OPER, IERR)
C-----------------------------------------------------------------------
C! open tape or pseudo-tape device
C# Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Open a tape drive (as well as its corresponding disk control file)
C   for sequential, "map" (double buffered, asynchronous) I/O or open
C   a pseudo-tape sequential disk file.  Exclusive use and wait to open
C   are assumed.  Uses a 'TP' disk "lock" file for real tapes.
C   Inputs:
C      LUN     I       Logical unit number (30 < LUN <= 30 + NTAPED
C                         => tape, else disk)
C      IVOL    I       Tape drive or disk volume containing file
C      PNAME   C*48    tape disk physical file name
C      OPER    C*4     'READ' => read only or 'WRIT' => read/write
C   Output:
C      FIND    I       Index in FTAB to file control block for LUN
C      IERR    I       Error return code: 0 => no error
C                         1 => LUN already in use
C                         2 => file not found
C                         3 => volume not found
C                         4 => exclusive use denied
C                         5 => no room for LUN in FTAB
C                         6 => other open errors
C   UNICOS version.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IVOL, IERR
      CHARACTER PNAME*48, OPER*4
C
      INTEGER   JERR, DELMAX, DELCNT, DLMAX2, DLCNT2, MODE, MTLUN, I, J,
     *   MTIND, IMAP, IEXCL, FCBOFF
      REAL      TDELAY
      HOLLERITH ANAME(12)
      LOGICAL   T, F, TAPE
      CHARACTER MTNAM*48
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA T, F /.TRUE., .FALSE./
      DATA TDELAY, DELMAX, DLMAX2 /1.0, 30, 60/
      DATA IMAP /0/
C-----------------------------------------------------------------------
C                                       Check inputs.
      IERR = 6
C                                       Valid LUN?
      TAPE = (LUN.GT.30) .AND. (LUN.LE.30+NTAPED)
C                                       Proper device type?
      IF ((TAPE) .AND. (DEVTAB(LUN).EQ.2)) GO TO 20
      IF ((.NOT.TAPE) .AND. (DEVTAB(LUN).EQ.0)) GO TO 20
         WRITE (MSGTXT,1010) LUN, DEVTAB(LUN)
         GO TO 995
C                                       Valid opcode?
 20   IF ((OPER.EQ.'READ') .OR. (OPER.EQ.'WRIT')) GO TO 25
         WRITE (MSGTXT,1020) OPER
         GO TO 995
C                                       match tape LUN and IVOL
 25   IF ((.NOT.TAPE) .OR. (LUN.EQ.30+IVOL)) GO TO 30
         WRITE (MSGTXT,1025) IVOL, LUN
         GO TO 995
C                                       Real tapes:
C                                       Open tape control disk file.
 30   IF (.NOT.TAPE) GO TO 70
         CALL ZPHFIL ('TP', 1, 1, IVOL, MTNAM, IERR)
         MTLUN = LUN + 20
C                                       Allocate area in FTAB for MTLUN.
         CALL LSERCH ('OPEN', MTLUN, MTIND, F, JERR)
         IF (JERR.EQ.0) GO TO 40
C                                       MTLUN already in use.
            IF (JERR.EQ.2) THEN
               IERR = 1
               WRITE (MSGTXT,1031) MTLUN
C                                       No room in FTAB for MTLUN.
            ELSE IF (JERR.EQ.3) THEN
               IERR = 5
               WRITE (MSGTXT,1032) MTLUN
C                                       Other error
            ELSE
               WRITE (MSGTXT,1030) JERR, 'OPEN', MTLUN
               END IF
            GO TO 995
C                                       Okay, so far.
 40      IERR = 0
         DELCNT = 0
         DLCNT2 = 0
         FCBOFF = MTIND + NMOFF
         IEXCL = 1
C 50      CALL CHR2H (48, MTNAM, 1, ANAME)
 50      CALL ZDAOPN (FTAB(FCBOFF), MTNAM, IMAP, IEXCL, IERR)
         IF (IERR.EQ.0) GO TO 70
C                                       File not found
            IF (IERR.EQ.2) THEN
               WRITE (MSGTXT,1050) MTNAM(1:24)
               CALL MSGWRT (6)
C                                       Volume not found?
            ELSE IF (IERR.EQ.3) THEN
               WRITE (MSGTXT,1051) IVOL, MTNAM(1:24)
               CALL MSGWRT (6)
C                                       File busy?
            ELSE IF (IERR.EQ.4) THEN
C                                       Wait and try again every TDELAY
C                                       seconds up to DELMAX*DLMAX2
C                                       times.  Issue a message every
C                                       DLMAX2 wait.
               DELCNT = DELCNT + 1
               IF (DELCNT.LE.DELMAX) THEN
                  CALL ZDELAY (TDELAY, IERR)
               ELSE
                  DLCNT2 = DLCNT2 + 1
                  IF (DLCNT2.GT.DLMAX2) GO TO 53
                     DELCNT = 0
                     WRITE (MSGTXT,1052) MTNAM(1:24)
                     CALL MSGWRT (2)
                  END IF
               GO TO 50
C                                       No more patience
 53            WRITE (MSGTXT,1053) MTNAM(1:24)
               CALL MSGWRT (6)
C                                       Other open error.
 54         ELSE
               CALL ZERROR ('ZDAOPN', FTAB(FCBOFF+FCBERR), MTNAM,
     *            FTAB(FCBOFF), F)
               END IF
            GO TO 915
C                                       Allocate area in FTAB for LUN.
 70   CALL LSERCH ('OPEN', LUN, FIND, T, JERR)
      IF (JERR.EQ.0) GO TO 80
C                                       LUN already in use.
         IF (JERR.EQ.2) THEN
            IERR = 1
            WRITE (MSGTXT,1071) LUN
C                                       No room in FTAB for LUN.
         ELSE IF (JERR.EQ.3) THEN
            IERR = 5
            WRITE (MSGTXT,1072) MTLUN
         ELSE
            WRITE (MSGTXT,1070) JERR, 'OPEN', LUN
            END IF
         CALL MSGWRT (6)
         GO TO 910
C                                       Finally, open the tape drive.
 80   IERR = 0
      FCBOFF = FIND + MOFF
      MODE = 0
      IF (OPER.EQ.'WRIT') MODE = 2
C                                       Open real tape.
      IF (TAPE) THEN
         CALL ZTPOP2 (FTAB(FCBOFF), PNAME, MODE, IERR)
         IF (IERR.NE.0) THEN
C                                       Device not found?
            IF (IERR.EQ.2) THEN
               WRITE (MSGTXT,1080) PNAME(1:24)
               CALL MSGWRT (6)
C                                       No such logical?
            ELSE IF (IERR.EQ.3) THEN
               WRITE (MSGTXT,1081) PNAME(1:24)
               CALL MSGWRT (6)
C                                       Other open error.
            ELSE
               CALL ZERROR ('ZTPOP2', FTAB(FCBOFF+FCBERR), PNAME,
     *            FTAB(FCBOFF), T)
               END IF
            GO TO 905
            END IF
C                                       Pseudo-tape disk files.
      ELSE
         CALL ZTPOPD (LUN, FTAB(FCBOFF), PNAME, MODE, IERR)
         IF (IERR.NE.0) THEN
C                                       Device not found?
            IF (IERR.EQ.2) THEN
               WRITE (MSGTXT,1280) PNAME(1:24)
               CALL MSGWRT (6)
C                                       No such logical?
            ELSE IF (IERR.EQ.3) THEN
               WRITE (MSGTXT,1281) PNAME(1:24)
               CALL MSGWRT (6)
C                                       Other open error.
            ELSE
               CALL ZERROR ('ZTPOPD', FTAB(FCBOFF+FCBERR), PNAME,
     *            FTAB(FCBOFF), T)
               END IF
            GO TO 925
            END IF
         END IF
C                                       store file name
      CALL FSERCH (FIND, I, J, JERR)
      IF (JERR.EQ.0) THEN
         IF (I.EQ.1) DEVNAM(J) = PNAME
         IF (I.EQ.2) NONNAM(J) = PNAME
         IF (I.EQ.3) MAPNAM(J) = PNAME
         END IF
      GO TO 999
C                                       Error.  Close files ignoring
C                                       error returns and clear FTAB
C                                       entries for MTLUN and LUN.
 905  CALL LSERCH ('CLOS', LUN, FIND, T, JERR)
 910  CALL ZDACLS (FTAB(MTIND+NMOFF), IMAP, JERR)
 915  CALL LSERCH ('CLOS', MTLUN, MTIND, F, JERR)
      GO TO 999
 925  CALL LSERCH ('CLOS', LUN, FIND, T, JERR)
      GO TO 999
C
 995  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ZTPOPN: IMPROPER DEVICE TYPE DEVTAB(',I2,') = ',I1,
     *   'FOR TAPE I/O')
 1020 FORMAT ('ZTPOPN: INVALID OPERATION CODE = ',A4)
 1025 FORMAT ('ZTPOPN: TAPE NUMBER',I5,' DOESN''T MATCH LUN',I5)
 1030 FORMAT ('ZTPOPN: LSERCH ERROR ',I1,' FOR ',A4,' ON MTLUN = ',I2)
 1031 FORMAT ('ZTPOPN: MTLUN = ',I2,' ALREADY OPEN IN FTAB')
 1032 FORMAT ('ZTPOPN: NO ROOM IN FTAB FOR MTLUN = ',I2)
 1050 FORMAT ('ZTPOPN: TAPE CONTROL FILE = ',A24,' NOT FOUND')
 1051 FORMAT ('ZTPOPN: VOLUME = ',I2,' FOR FILE = ',A24,' NOT FOUND')
 1052 FORMAT ('ZTPOPN: STILL WAITING FOR FILE = ',A24)
 1053 FORMAT ('ZTPOPN: FILE = ',A24,' NOT AVAILABLE')
 1070 FORMAT ('ZTPOPN: LSERCH ERROR ',I1,' FOR ',A4,' ON LUN = ',I2)
 1071 FORMAT ('ZTPOPN: LUN = ',I2,' ALREADY OPEN IN FTAB')
 1072 FORMAT ('ZTPOPN: NO ROOM IN FTAB FOR LUN = ',I2)
 1080 FORMAT ('ZTPOPN: TAPE DEVICE = ',A24,' NOT FOUND')
 1081 FORMAT ('ZTPOPN: NO SUCH LOGICAL DEVICE = ',A24)
 1280 FORMAT ('ZTPOPN: DISK DEVICE = ',12A4,' NOT FOUND')
 1281 FORMAT ('ZTPOPN: NO SUCH LOGICAL DEVICE = ',A24)
      END

      SUBROUTINE BLGET (TIME, IERR)
C-----------------------------------------------------------------------
C! Sets up for interpolation in baseline (BL) table
C# Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2007, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C    Sets up for interpolation in baseline (BL) table, reads values
C    from BL table.
C    Inputs:
C       TIME     R        Current data time.
C    Inputs from common /SELCAL/:
C       BLBUFF   I(*)     BL table I/O TABIO buffer
C       IBLRNO   I        Current BL record number
C       NBLINR   I        Number of BL records in file.
C       NUMANT   I        Number of antennas
C       NUMPOL   I        Number of polarizations
C       NUMIF    I        Number of IFs.
C    Output:
C       IERR     I       Return error code 0=>OK, else failed.
C    Output to common /SELCAL/:
C       BLTAB    R(*,2)  Baseline table from BL table file.
C                        The second dimension corresponds to the time
C                        before and after the current data time.
C                        Indexing scheme: an entry defined by ant1<ant2
C                        starts in element:
C          lentry * (((ant1-1)*numant-((ant1+1)*ant1)/2 + ant2) - 1) + 1
C                        where lentry = 2 * NUMPOL * (EIF-BIF+1)
C                        An entry contains the values in order:
C                        By IF (NUMIF)
C                           By Polarization (NUMPOL)
C                               Real part, imaginary part.
C       BLTIM    R(3)     Time of two BL entries; third value is
C                         time of current values.
C       IBLP1    I       Pointer in BLTAB, BLTIM to previous time.
C       IBLP2    I       Pointer in BLTAB, BLTIM to next time.
C   Useage note:  The BL table is open/initialized in GAININ and
C   closed in UVGET.
C-----------------------------------------------------------------------
      REAL      TIME
      INTEGER   IERR
C
      INTEGER   IFNO, LENTRY, ANT1, ANT2, BLNDX, IFOFF,
     *   TIMKOL, SOUKOL, SUBKOL, ANT1KL, ANT2KL, REM1KL, IMM1KL,
     *   REA1KL, IMA1KL, REM2KL, IMM2KL, REA2KL, IMA2KL, FRQKOL
      INTEGER   I, INDEX, LIMIT, NBLANK, NUMBL
      LOGICAL   T, F, GOT1
      DOUBLE PRECISION CURTIM
      INCLUDE 'INCS:PUVD.INC'
      INTEGER  RECI(6+8*MAXIF)
      REAL     RECR(6+8*MAXIF)
      DOUBLE PRECISION RECD(6+8*MAXIF)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (RECI, RECR, RECD)
      EQUIVALENCE (BLKOLS(1), TIMKOL), (BLKOLS(2), SOUKOL),
     *   (BLKOLS(3), SUBKOL), (BLKOLS(4),ANT1KL), (BLKOLS(5), ANT2KL),
     *   (BLKOLS(6), FRQKOL), (BLKOLS(7), REM1KL), (BLKOLS(8),IMM1KL),
     *   (BLKOLS(9), REA1KL), (BLKOLS(10), IMA1KL),
     *   (BLKOLS(11), REM2KL), (BLKOLS(12), IMM2KL),
     *   (BLKOLS(13), REA2KL), (BLKOLS(14),IMA2KL)
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Check if want to keep contents
C                                       of BLTAB
      IF (IBLRNO.GE.NBLINR) GO TO 999
C                                       Check if first call
      IF (IBLP2.GT.0) GO TO 300
C                                       Blank fill BLTAB
      NUMBL = (NUMANT * (NUMANT+1)) / 2
      NBLANK = NUMBL * (EIF-BIF+1) * NUMPOL * 2
      DO 40 I = 1,NBLANK
         BLTAB(I,1) = FBLANK
         BLTAB(I,2) = FBLANK
 40      CONTINUE
C                                       Read until selected time.
      LENTRY = 2 * NUMPOL * (EIF - BIF + 1)
      IBLP1 = 2
      IBLP2 = 1
      GOT1 = F
      LIMIT = IBLRNO
      DO 80 I = LIMIT,NBLINR
         IBLRNO = I
         CALL TABIO ('READ', 0, IBLRNO, RECR, BLBUFF, IERR)
         IF (IERR.LT.0) GO TO 80
         IF (IERR.NE.0) GO TO 990
C                                       Check SUBARRAY
         IF ((RECI(SUBKOL).NE.SUBARR) .AND. (RECI(SUBKOL).GT.0) .AND.
     *      (SUBARR.GT.0)) GO TO 100
C                                       Check FRQSEL
         IF ((RECI(FRQKOL).NE.FRQSEL) .AND. (RECI(FRQKOL).GT.0) .AND.
     *      (FRQSEL.GE.0)) GO TO 100
C                                       See if time past data time.
         IF (RECR(TIMKOL).GT.TIME) GO TO 100
C                                       Fill in values
         GOT1 = T
         BLTIM(1) = RECR(TIMKOL)
C                                       Loop over IF
         ANT1 = RECI(ANT1KL)
         ANT2 = RECI(ANT2KL)
         BLNDX = ((ANT1-1)*NUMANT) - ((ANT1-1)*ANT1)/2 + ANT2
         INDEX = LENTRY * (BLNDX - 1) + 1
         DO 70 IFNO = BIF,EIF
            IFOFF = IFNO - 1
            BLTAB(INDEX,1) = RECR(REM1KL+IFOFF)
            BLTAB(INDEX+1,1) = RECR(IMM1KL+IFOFF)
            INDEX = INDEX + 2
            IF (NUMPOL.GT.1) THEN
C                                       Second polarization
               BLTAB(INDEX,1) = RECR(REM2KL+IFOFF)
               BLTAB(INDEX+1,1) = RECR(IMM2KL+IFOFF)
               INDEX = INDEX + 2
               END IF
 70         CONTINUE
 80      CONTINUE
C                                       After time, see if have before
 100  IF (GOT1) GO TO 300
C                                       Only have bl after data time.
      IBLP1 = -1
      IBLP2 = 1
      GO TO 310
C                                       Next record
C                                       Initialize BLTAB
 300  IBLP1 = IBLP2
      IBLP2 = 3 - IBLP2
C                                       Check if BL table exhausted,
C                                       If so just mark tables,
      IF (IBLRNO.GE.NBLINR) IBLP2 = -1
      IF (IBLRNO.GE.NBLINR) GO TO 999
C                                       Blank fill table
 310  NBLANK = NUMANT * (EIF-BIF+1) * NUMPOL * 2
      DO 340 I = 1,NBLANK
         BLTAB(I,IBLP2) = FBLANK
 340     CONTINUE
      LIMIT = IBLRNO
      DO 380 I = LIMIT,NBLINR
         IBLRNO = I
         CALL TABIO ('READ', 0, IBLRNO, RECR, BLBUFF, IERR)
         IF (IERR.LT.0) GO TO 380
         IF (IERR.NE.0) GO TO 990
C                                       Check SUBARRAY
         IF ((RECI(SUBKOL).NE.SUBARR) .AND. (RECI(SUBKOL).GT.0) .AND.
     *      (SUBARR.GT.0)) GO TO 380
C                                       Check FRQSEL
         IF ((RECI(FRQKOL).NE.FRQSEL) .AND. (RECI(FRQKOL).GT.0) .AND.
     *      (FRQSEL.GT.0)) GO TO 380
         IF (I.EQ.LIMIT) CURTIM = RECR(TIMKOL)
C                                       See if time past data time.
         IF (RECR(TIMKOL).GT.CURTIM) GO TO 400
         BLTIM(IBLP2) = CURTIM
C                                       Fill in values
         GOT1 = T
C                                       Loop over IF
         ANT1 = RECI(ANT1KL)
         ANT2 = RECI(ANT2KL)
         BLNDX = ((ANT1-1)*NUMANT) - ((ANT1+1)*ANT1)/2 + ANT2
         INDEX = LENTRY * (BLNDX - 1) + 1
         DO 370 IFNO = BIF,EIF
            IFOFF = IFNO - 1
            BLTAB(INDEX,IBLP2) = RECR(REM1KL+IFOFF)
            BLTAB(INDEX+1,IBLP2) = RECR(IMM1KL+IFOFF)
            INDEX = INDEX + 2
            IF (NUMPOL.GT.1) THEN
C                                       Second polarization
               BLTAB(INDEX,IBLP2) = RECR(REM2KL+IFOFF)
               BLTAB(INDEX+1,IBLP2) = RECR(IMM2KL+IFOFF)
               INDEX = INDEX + 2
               END IF
 370        CONTINUE
 380     CONTINUE
C                                       Finished file
      IBLRNO = NBLINR
      GO TO 999
C                                       Check if correct time
 400  IF (CURTIM.LT.TIME) GO TO 300
      GO TO 999
C                                       TABIO error
 990  WRITE (MSGTXT,1400) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1400 FORMAT ('BLGET: ERROR ',I3,' READING BASELINE TABLE')
      END

      SUBROUTINE ZV20MC (FTAB)
C-----------------------------------------------------------------------
C! issue a master clear to the TV - for Comtal this is a No-Op
C# Z TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   issues a "master clear" to the TV.  This resets the TV IO system (if
C   necessary) to expect a command record next.
C   Generic version for Comtal - apparently this operation doesn't exist
C
C   Inputs:
C      FTAB     I(*)        FTAB entry for TV i/o channel
C-----------------------------------------------------------------------
      INTEGER   FTAB(*)
C-----------------------------------------------------------------------
C                                       NO-OP for Comtal
C
 999  RETURN
      END

      SUBROUTINE SYMBOL (NTYPE)
C-----------------------------------------------------------------------
C! obtains symbol identification from symbol table; creates new symbols
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   SYMBOL obtains a symbol from the symbol list.  If not found and
C   MODE = 69 stores new symbol in linked list.  as coded, this routine
C   IS CASE SENSITIVE.  If the search is to be for only upper case,
C   the symbol must be converted (CHLTOU) prior to calling SYMBOL.
C   Inputs:
C      NTYPE   I     type to be assigned to new symbol
C   Commons in:
C      /SMSTUF/ KPAK  NKAR Hollerith characters to be found
C   Commons out:
C      /SMSTUF/ sets SYTYPE, LOCSYM, TAG
C      /POPS/ sets L to point at symbol area
C      /CORE/ sets new symbol into K as needed
C-----------------------------------------------------------------------
      INTEGER  NTYPE
C
      CHARACTER PRGNAM*6
      INTEGER   KXLINK, LENGTH, MK, N, NT, LLOCAT, RLOCAT, POTERR
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DSMS.INC'
      DATA PRGNAM /'SYMBOL'/
C-----------------------------------------------------------------------
C                                       Search symbol table.
      L = K(1)
      NT = NKAR
      CALL CHUNT (K, L, NT, 4, KPAK)
      IF (IDEBUG.LE.0) GO TO 10
         WRITE (MSGTXT,1000) MODE, L, NT, NTYPE
         CALL MSGWRT (4)
C                                       Old symbol found.
 10   IF (L.GT.0) THEN
         LENGTH = K(L+1) / 16
         SYTYPE = K(L+1) - 16*LENGTH
         IF ((SYTYPE.NE.4) .AND. (SYTYPE.NE.5)) LOCSYM = L
         TAG = K(L+2)
C                                       New symbol - create new entry.
      ELSE
         POTERR = 2
         IF ((MODE.NE.69) .OR. (NTYPE.EQ.0)) GO TO 980
         SYTYPE = NTYPE
         N = (NT+3) / 4 + 4
         L = LLOCAT(N, K, K(9))
         IF (ERRNUM.NE.0) GO TO 980
         K(L+1) = 16*NT + SYTYPE
         LOCSYM = L
         MK = L + 4
         NT = (NT+3) / 4
         CALL RCOPY (NT, KPAK, CH(MK))
C                                       Point at verb, pseudoverb
         IF ((SYTYPE.EQ.4) .OR. (SYTYPE.EQ.5)) THEN
            TAG = NEWCOD
C                                       Allocate variable storage.
         ELSE
            KXLINK = 1
            TAG = RLOCAT (1, K(KXORG), C, KXLINK)
            IF (ERRNUM.NE.0) GO TO 980
            END IF
         K(L+2) = TAG
         END IF
      GO TO 999
C                                       Error
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SYMBOL: MODE,L,NT,NTYPE ',4I6)
      END

      SUBROUTINE ZI32IL (NVAL, NP, INB, OUTB)
C-----------------------------------------------------------------------
C! convert FITS-standard 32-bit integers from buffer into local integers
C# Binary
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Extract 32-bit, 2's complement integers from an input buffer and put
C   them into an output buffer in local large integer form.  This must
C   work even when the address of the input and output buffers is the
C   same.  The IBM order applies to the input (i.e., the most
C   significant part of the 32-bit integer is in the lower index of the
C   input buffer and the least significant part is in the higher index.
C   Inputs:
C      NVAL   I      # values to extract
C      NP     I      Starting position in the input buffer (1-relative)
C                    in units of 32-bit integers
C      INB    I(*)   Input buffer
C   Output:
C      OUTB   I(*)   Output buffer
C   Generic version  - does byte order flip in 16-bit words and a flip
C   of the order of the words.  This assumes local 32-bit integers.
C-----------------------------------------------------------------------
      INTEGER   NVAL, NP, INB(*), OUTB(*)
C
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (NVAL.LE.0) GO TO 999
      IF (NBITWD.NE.32) THEN
         WRITE (MSGTXT,1000) NBITWD
         CALL MSGWRT (9)
         STOP 'ZI32IL NEEDS LOCAL DEVELOPMENT'
C                                       Flip bytes in each word or copy.
      ELSE
         CALL ZBFLIP (4, NVAL, INB(NP), OUTB(1))
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZI32IL: REQUIRES LOCAL DEVELOPMENT FOR NBITWD =',I7)
      END

      SUBROUTINE QCGAUS (APCORE, APBASE, NX, NY, BMAJ, BMIN, BPA)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Create a complex Gaussian centered at NX/2,NY/2+1
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Create a complex Gaussian centered at NX/2,NY/2+1
C   Inputs:
C      APBASE  I  Base address of complex Gaussian image.
C      NX      I  X dimension of image
C      NY      I  Y dimension of image
C      BMAJ    R  Gaussian major axis in cells
C      BMIN    R  Gaussian minor axis in cells
C      BPA     R  Gaussian position angle in degrees
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   APBASE, NX, NY
      REAL      BMAJ, BMIN, BPA
C
      INCLUDE 'INCS:DAPC.INC'
      INCLUDE 'INCS:PSTD.INC'
      LONGINT   JB
      INTEGER   LOOPX, LOOPY
      DOUBLE PRECISION X, Y, XC, YC, XX, YY, CPHI, SPHI, YSSPHI, YSCPHI
C-----------------------------------------------------------------------
C                                       Addresses 1-rel
      JB = APBASE + PSAPOF
C                                       Set image center
      XC = NX / 2
      YC = NY / 2 + 1
C                                       Trig. combinations of model p.a.
      SPHI = SIN (BPA * DG2RAD)
      CPHI = COS (BPA * DG2RAD)
C                                       Loop
      INCLUDE 'INCS:ZVND.INC'
      DO 200 LOOPY = 1,NY
         Y = LOOPY - YC
         YSCPHI = Y * CPHI
         YSSPHI = Y * SPHI
      INCLUDE 'INCS:ZVND.INC'
         DO 100 LOOPX = 1,NX
            X = LOOPX - XC
            XX = (YSCPHI - X*SPHI) / BMAJ
            YY = (X*CPHI + YSSPHI) / BMIN
C                                       Gaussian; 2.772588722 = 4ln(2)
            APCORE(JB) = EXP (-2.772588722D0 * (XX*XX + YY*YY))
            APCORE(JB+1) = 0.0
            JB = JB + 2
 100        CONTINUE
 200     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE QXFOUR (JC, N, ISIGN)
C-----------------------------------------------------------------------
C! Pseudo AP routine: FFT routine.
C# AP-FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Cooley-Tukey Fast Fourier Transform in USASI basic FORTRAN.
C   one-dimensional transform of complex data, arbitrary number of
C   points.  N points can be transformed in time proportional to
C   N*Log(N) (for N non-prime), whereas other methods take N**2 time.
C   furthermore, because fewer arithmetic operations are performed,
C   less error is built up.  The transform done is--
C     TRANSFORM(K) = SUM(DATA(J)*EXP(ISIGN*2*PI*I*(J-1)*(K-1)/N)),
C        summed from J = 1 to N for all K from 1 to N.
C     Inputs:
C       JC     I    Base address in /APCORE/ of vector to FFT (0-rel)
C       N      I    Length of complex vector to FFT in complex elements
C       ISIGN  I    +1 or -1 for reverse or forward transform.
C
C   Usage notes:
C   The transform is in-place, with output replacing the input.
C   N may be any positive number, but it should be non-prime for speed.
C   A ISIGN=-1 transform followed by a +1 one (or vice versa)
C   returns N times the original data.
C   Running time is proportional to N * (sum of the prime factors of
C   N).  For example, N = 1960, time is to * 1960 * (2+2+2+5+7+7).
C   naive methods directly implementing the summation run in time
C   proportional to N**2.  An upper bound for the RMS relative error
C   is 3 * 2**(-B) * sum(F**1.5), where B is the number of bits in
C   the floating point fraction and the sum is over the prime
C   factors of N.
C   Written by Norman Brenner, MIT, August 1968.  See--
C   IEEE Audio and Electroacoustics Transactions, June 1967 and
C   June 1969, special issues on the FFT.
C   CRI version.
C-----------------------------------------------------------------------
      INTEGER   IFACT(32)
      INTEGER   JC, N, ISIGN, I1, I2, I3, I2MAX, I3REV, ID, IDIV, IF,
     *   IFCUR,IP0, IP1, IP2, IP3, IQUOT, IWMAX, J0, J1, JWORK,
     *   NFACT, NPART
      REAL      FLOAT, ROOTI, ROOTR, SINTH, SUMI, SUMR, TEMPI, TEMPR,
     *   THETA, TWOPI, WI, WMINI, WMINR, WR, WSTPI, WSTPR, TEMP
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      TWOPI = 6.2831853072 * ISIGN
C                                       Factor N into its prime factors
C                                       NFACT in number.  For example,
C                                       for N = 1960, NFACT = 6 and
C                                       IFACT(IF) = 2, 2, 2, 5, 7 and 7.
      IF = 0
      NPART = N
      INCLUDE 'INCS:ZVND.INC'
      DO 50 ID = 1,N,2
         IDIV = ID
         IF (ID-1) 10,10,20
 10      IDIV = 2
 20      IQUOT = NPART / IDIV
         IF (NPART-IDIV*IQUOT) 40,30,40
 30      IF = IF + 1
         IFACT(IF) = IDIV
         NPART = IQUOT
         GO TO 20
 40      IF (IQUOT-IDIV) 60,60,50
 50      CONTINUE
 60   IF (NPART-1) 80,80,70
 70   IF = IF + 1
      IFACT(IF) = NPART
 80   NFACT = IF
C                                       Shuffle the data array by
C                                       reversing the digits of the
C                                       index. Replace DATA(I) by
C                                       DATA(IREV) for all I from 1
C                                       to N.  IREV-1 is the integer
C                                       whose digit representation in
C                                       the multi-radix notation of
C                                       factors IFACT(IF) is the
C                                       reverse of the representation
C                                       of I-1.  For example, if all
C                                       IFACT(IF)=2, then for
C                                       I-1 = 11001, IREV-1 =  10011.
C                                       A work array of length N is
C                                       needed.
      IP0 = 2
      IP3 = IP0 * N
      JWORK = 1
      I3REV = 1
      INCLUDE 'INCS:ZVND.INC'
      DO 110 I3 = 1,IP3,IP0
         WRKFFT(JWORK) = APCORE(JC+I3REV)
         WRKFFT(JWORK+1) = APCORE(JC+I3REV+1)
         IP2 = IP3
      INCLUDE 'INCS:ZVND.INC'
         DO 100 IF = 1,NFACT
            IP1 = IP2 / IFACT(IF)
            I3REV = I3REV + IP1
            IF (I3REV-IP2) 105,105,90
 90         I3REV = I3REV - IP2
            IP2 = IP1
 100        CONTINUE
 105     JWORK = JWORK + IP0
 110     CONTINUE
      JWORK = 1
      INCLUDE 'INCS:ZVND.INC'
      DO 120 I3 = 1,IP3,IP0
         APCORE(JC+I3) = WRKFFT(JWORK)
         APCORE(JC+I3+1) = WRKFFT(JWORK+1)
         JWORK = JWORK + IP0
 120     CONTINUE
C                                       Phase-shifted Fourier transform
C                                       of length IFACT(IF).
C                                       IPROD = IP1 / IP0
C                                       IREM = N / (IFACT(IF) * IPROD)
C                                       DATA(I1,J2,I3) = SUM (DATA(I1,
C                                       I2,I3) * W**(I2-1)), summed
C                                       over I2 = 1 to IFACT(IF) for
C                                       all I1 from 1 to IPROD, J2 from
C                                       1 to IFACT(IF) and I3 from 1
C                                       to IREM.
C                                       W = EXP(ISIGN*2*PI*I*(I1-1+
C                                           IPROD*(J2-1)) /
C                                           (IPROD*IFACT(IF))).
      IF = 0
      IP1 = IP0
 130  IF (IP1-IP3) 140,240,240
 140  IF = IF + 1
      IFCUR = IFACT(IF)
      IP2 = IP1 * IFCUR
      THETA = TWOPI / REAL (IFCUR)
      SINTH = SIN (THETA / 2.)
      ROOTR = -2. * SINTH * SINTH
      ROOTI = SIN (THETA)
      THETA = TWOPI / REAL (IP2 / IP0)
      SINTH = SIN (THETA / 2.)
      WSTPR = -2. * SINTH * SINTH
      WSTPI = SIN (THETA)
      WMINR = 1.
      WMINI = 0.
      INCLUDE 'INCS:ZVND.INC'
      DO 230 I1 = 1,IP1,IP0
         IF (IFCUR-2) 150,150,170
      INCLUDE 'INCS:ZVND.INC'
 150     DO 160 I3 = I1,IP3,IP2
            J0 = I3
            J1 = I3 + IP1
            TEMPR = WMINR * APCORE(JC+J1) - WMINI * APCORE(JC+J1+1)
            TEMPI = WMINR * APCORE(JC+J1+1) + WMINI * APCORE(JC+J1)
            APCORE(JC+J1) = APCORE(JC+J0) - TEMPR
            APCORE(JC+J1+1) = APCORE(JC+J0+1) - TEMPI
            APCORE(JC+J0) = APCORE(JC+J0) + TEMPR
            APCORE(JC+J0+1) = APCORE(JC+J0+1) + TEMPI
 160        CONTINUE
         GO TO 220
 170     IWMAX = IP0 * IFCUR
      INCLUDE 'INCS:ZVND.INC'
         DO 210 I3 = I1,IP3,IP2
            I2MAX = I3 + IP2 - IP1
            WR = WMINR
            WI = WMINI
      INCLUDE 'INCS:ZVND.INC'
            DO 200 JWORK = 1,IWMAX,IP0
               I2 = I2MAX
               SUMR = APCORE(JC+I2)
               SUMI = APCORE(JC+I2+1)
 180           I2 = I2 - IP1
               TEMPR = SUMR
               SUMR = WR * SUMR - WI * SUMI + APCORE(JC+I2)
               SUMI = WR * SUMI + WI * TEMPR + APCORE(JC+I2+1)
               IF (I2-I3) 190,190,180
 190           WRKFFT(JWORK) = SUMR
               WRKFFT(JWORK+1) = SUMI
               TEMP = WR
               WR = WR * ROOTR - WI * ROOTI + WR
               WI = TEMP * ROOTI + WI * ROOTR + WI
 200           CONTINUE
            JWORK = 1
      INCLUDE 'INCS:ZVND.INC'
            DO 210 I2 = I3,I2MAX,IP1
               APCORE(JC+I2) = WRKFFT(JWORK)
               APCORE(JC+I2+1) = WRKFFT(JWORK+1)
               JWORK = JWORK + IP0
 210           CONTINUE
 220     TEMPR = WMINR
         WMINR = WMINR * WSTPR - WMINI * WSTPI + WMINR
         WMINI = TEMPR * WSTPI + WMINI * WSTPR + WMINI
 230     CONTINUE
      IP1 = IP2
      GO TO 130
 240  CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'UVHGM.INC'
      REAL      XUSER, XSEQ, XDISK, XQUAL, XBAND, XFREQ, XFQID,
     *   XTIME(8), XANT(50), XBASE(50), XUVRA(2), XSUBA, XBCHAN, XECHAN,
     *   XNCHAV, XCHINC, XBIF, XEIF, XDOCAL, XGUSE, XDOPOL, XPDVER,
     *   XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH(3), XDOALL, XBOXS,
     *   XRANGE(2), XLABEL, XDOTV, XGRCHN, XYRAT, XPARMS(50), BADD(10)
      HOLLERITH XNAME(3), XCLASS(2), XSOUR(4), XCALC(1), XSTOK(1),
     *   XAXTYP(2), XOPCOD(1)
      LOGICAL   DOLOG, DOWGT, DOTV
      INTEGER   NBINS, INDISK, CNO, UVLUN, UVIND, IVER, GRCHN, LABEL,
     *   NSUBA, NFRQ, NPARMS, CHINC, NCHAV
      COMMON /INPARM/ XUSER, XNAME, XCLASS, XSEQ, XDISK, XSOUR, XQUAL,
     *   XCALC, XSTOK, XBAND, XFREQ, XFQID, XTIME, XANT, XBASE, XUVRA,
     *   XSUBA, XBCHAN, XECHAN, XNCHAV, XCHINC, XBIF, XEIF, XDOCAL,
     *   XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG,XDOBND, XBPVER, XSMOTH,
     *   XDOALL, XBOXS, XRANGE, XAXTYP, XOPCOD, XLABEL, XDOTV, XGRCHN,
     *   XYRAT, BADD, XPARMS
      COMMON /UVHGMP/ DOLOG, DOWGT, NBINS, INDISK, CNO, UVLUN, UVIND,
     *   IVER, DOTV, GRCHN, LABEL, NSUBA, NFRQ, NPARMS, CHINC, NCHAV
LOCAL END
LOCAL INCLUDE 'GDATA.INC'
      DOUBLE PRECISION DATA(32768)
      INTEGER   NITTER, ITTER
      COMMON /GDATA/ DATA, NITTER, ITTER
LOCAL END
LOCAL INCLUDE 'ANTDATA.INC'
      INTEGER   NUMAN(513), BLOFF(513)
      COMMON /ANDATA/ NUMAN, BLOFF
LOCAL END
      PROGRAM UVHGM
C-----------------------------------------------------------------------
C! Makes histograms summarizing the statistics of a UV data set.
C# Util UV Plot
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1999, 2002-2003, 2006, 2009-2010, 2012,
C;  Copyright (C) 2014-2016, 2018, 2020, 2022-2023, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVHGM is an AIPS task which produces histograms summarizing the
C   contents of a uv data set.  The histograms are saved as PL type
C   extension files associated with the uv data.
C   Adverbs:
C      USERID       AIPS user number.
C      INNAME(3)    uv name  (12 chars).
C      INCLASS(2)   uv class ( 6 chars).
C      INSEQ        uv sequence number.
C      INDISK       uv disk.
C      STOKES       Stokes parameter (I, Q, U, V, RR, LL, RL, LR).
C      BCHAN        1st Spectral channel number.
C      ECHAN        last Spectral channel
C      BIF          1st IF band to use
C      EIF          last Spectral channel
C      DOALL        > 0 => do Gaussian fit and plot, =2 hist outline
C      NBOXES       Number of histogram bins.
C      AXTYPE(2)    Operation code in the form  'A', 'UVWR', etc.
C                   Up to 8 histograms can be produced in one go.
C                      U = u,  V = v,  W = w
C                      R = SQRT(u*u + v*v)
C                      D = SQRT(u*u + v*v + w*w)
C                      O = baseline position angle
C                      T = time
C                      B = baseline antenna pair
C                      S = source identification number
C                      F = frequency identification number
C                      H = real part of the visibility
C                      I = imaginary part
C                      A = amplitude,  P = phase, C = weight
C                      X = amplitude weighted: A/sqrt(WT)
C      OPCODE       CLIN: linear by count
C                   CLOG: log10  by count
C                   WLIN: linear by weight
C                   WLOG: log10  by weight
C-----------------------------------------------------------------------
      CHARACTER UTITLE*80, LTITLE*80, TYPE(16)*12, UNITS(16)*12,
     *   XLAB*40, YLAB*40, CHTMP8*8, NS*18
      INTEGER   HDX(16), I, IERR, IOBLK(256), K, NERR, NPLTS, NOUT(2,16)
      LOGICAL   LAST
      REAL      DOMAIN(2,16), HGMS(32768), MHZ, CATR(256)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128), PARMS(3), FVEC(32768)
      INCLUDE 'UVHGM.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATD, CATR, CATH, CATBLK)
      DATA TYPE /
     *   'U           ', 'V           ', 'W           ',
     *   'R           ', 'Baselength  ', 'Baseangle   ',
     *   'Time        ', 'Baselines   ', 'Source Id   ',
     *   'Frequency Id', 'Real        ', 'Imaginary   ',
     *   'Amplitude   ', 'Phase       ', 'Weight      ',
     *   'Amp*sqrt(wt)'/
      DATA UNITS /
     *   'Wavelengths ', 'Wavelengths ', 'Wavelengths ',
     *   'Wavelengths ', 'Wavelengths ', 'Degrees     ',
     *   'Days        ', 'Number      ', 'Number      ',
     *   'Number      ', 'Jy          ', 'Jy          ',
     *   'Jy          ', 'Degrees     ', '1/(Jy**2)   ',
     *   'Jy * (1/Jy) '/
C-----------------------------------------------------------------------
C                                       Initialize and open file.
      CALL UVHGIN (HDX, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'INITIALIZATION PROBLEM.'
         GO TO 990
         END IF
C                                       Accumulate statistics from the
C                                       uv data.
      CALL BLDHGM (HDX, DOMAIN, NOUT, HGMS, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'PROBLEM PROCESSING THE UV DATA.'
         GO TO 990
         END IF
C                                       Source name and frequency.
      CALL H2CHR (8, 1, CATH(KHOBJ), CHTMP8)
      MHZ = (CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF)
     *   * (1.0 - CATR(KRCRP+JLOCF))) / 1.0E6
      WRITE (UTITLE,1010) CHTMP8, MHZ, STOKES
C                                       Image name.
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), NS)
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), NS(13:18))
      CALL NAMEST (NS, CATBLK(KIIMS), UTITLE(31:), I)
      CALL REFRMT (UTITLE, '_', I)
C                                       Lower title
      LTITLE = ' '
      IF ((JLOCIF.GE.0) .AND. (CATBLK(KINAX+JLOCIF).GT.1)) THEN
         IF (CATBLK(KINAX+JLOCF).GT.1) THEN
            WRITE (LTITLE,1020) BIF, EIF, BCHAN, ECHAN
         ELSE
            WRITE (LTITLE,1021) BIF, EIF
            END IF
      ELSE
         IF (CATBLK(KINAX+JLOCF).GT.1) WRITE (LTITLE,1022) BCHAN, ECHAN
         END IF
      CALL REFRMT (LTITLE, '_', I)
      MSGTXT = 'Begin plotting of histograms'
      CALL MSGWRT (1)
C                                       Now produce the PLot files.
      NPLTS = 0
      DO 110 K = 1,16
         IF (HDX(K).GT.0) NPLTS = NPLTS + 1
 110     CONTINUE
      DO 120 K = 1,16
         IF (HDX(K).GT.0) THEN
            NPLTS = NPLTS - 1
            LAST = NPLTS.LE.0
            XLAB = TYPE(K)
C                                       Y-axis label.
            YLAB = 'LOG '
            I = 1
            IF (DOLOG) I = 5
            IF (DOWGT) THEN
               YLAB(I:) = 'Sum weight'
            ELSE
               YLAB(I:) = 'Count'
               END IF
C                                       Gaussian fitting
            IERR = -1
            IF (XDOALL.GT.0.0) CALL FITHGM (HGMS(HDX(K)), DOMAIN(1,K),
     *         PARMS, FVEC, IERR)
            IF (IERR.NE.0) PARMS(1) = 0.0D0
C                                       Do the histogram.
            CALL PLHGM (HGMS(HDX(K)), NOUT(1,K), XLAB, YLAB, UTITLE,
     *         LTITLE, UNITS(K), DOMAIN(1,K), LAST, PARMS, FVEC, IERR)
            IF (IERR.NE.0) GO TO 995
            END IF
 120     CONTINUE
      GO TO 995
C                                       Close down files etc.
 990  CALL MSGWRT (8)
 995  CALL MAPCLS ('WRIT', INDISK, CNO, UVLUN, UVIND, CATBLK, .FALSE.,
     *   IOBLK, NERR)
      IERR = MAX (0, IERR)
      CALL DIE (IERR, IOBLK)
C
 999  STOP
C-----------------------------------------------------------------------
 1010 FORMAT (A8,1X,F10.3,' MHz__',A4)
 1020 FORMAT ('IF number',2I3,'__Spectral channel',2I5)
 1021 FORMAT ('IF number',2I3)
 1022 FORMAT ('Spectral channel',2I5)
      END
      SUBROUTINE UVHGIN (HDX, IERR)
C-----------------------------------------------------------------------
C    UVHGIN gets adverbs for UVHGM, opens the uv file, and determines
C    what is to be done.
C    Inputs:
C       HDX          I(16)   pointers into HGMS,
C       IERR         I       Error code, 0 means success.
C   Output in Common:
C       .....        R(*)    AIPS adverbs values.
C       NBINS        I       Number of histogram bins.
C       INDISK       I       uv input disk number.
C       CNO          I       uv catalog slot number.
C       UVLUN        I       uv logical unit number.
C       UVIND        I       uv buffer pointer returned by MAPOPN.
C       BCHAN        I       Frequency channel.
C       DOLOG        L       If true, use log10 bins.
C       DOWGT        L       If true, use visibility weights.
C-----------------------------------------------------------------------
      INTEGER   HDX(16), IERR
C
      CHARACTER PRGM*6, INNAME*12, INCLAS*6, OPCODE(4)*4, AXTYPE*18,
     *   TEXT*8, CHTMP4*4, PTYPE*2
      LOGICAL   NODATA, TABLE, EXIST, FITASC, MATCH
      INTEGER   I, INSEQ, IOBLK(256), IRET, IROUND, IUSER, J, K, LUN,
     *   FQVER, NIF, JERR, NHDX, LTYPE, MANT, SCRBUF(512)
      HOLLERITH CATH(256)
      REAL      CATR(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'UVHGM.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'ANTDATA.INC'
      EQUIVALENCE (CATBLK, CATH, CATR, CATD)
      DATA PRGM /'UVHGM '/
      DATA AXTYPE /' UVWRDOTBSFHIAPCX '/
      DATA OPCODE /'CLIN', 'CLOG', 'WLIN', 'WLOG'/
C-----------------------------------------------------------------------
C                                       Initialize parameters.
      CALL ZDCHIN (.TRUE., IOBLK)
      CALL VHDRIN
      CALL SELINI
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARMS = 167
      CALL GTPARM (PRGM, NPARMS, RQUICK, XUSER, IOBLK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010)
         CALL MSGWRT (8)
         RQUICK = .TRUE.
         CALL RELPOP (IERR, IOBLK, IRET)
         GO TO 999
         END IF
C                                       Restart AIPS.
      IF (RQUICK) CALL RELPOP (IERR, IOBLK, IRET)
C                                       Decode adverb values.
C                                       AIPS user number.
      XUSER = NLUSER
      IUSER = NLUSER
C                                       Input uv name etc.
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      CALL H2CHR (12, 1, XNAME, INNAME)
      CALL H2CHR (6, 1, XCLASS, INCLAS)
      INSEQ  = IROUND (XSEQ)
      INDISK = IROUND (XDISK)
      CALL H2CHR (4, 1, XSTOK, STOKES)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (16, 1, XSOUR, SOURCS(1))
      SELQUA = IROUND (XQUAL)
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
C                                       Number of histogram bins.
      NBINS = IROUND (XBOXS)
      IF (NBINS.LT.2)    NBINS = 128
      IF (NBINS.GT.32768) NBINS = 32768
      XBOXS = REAL(NBINS)
C                                       Histograms required.
      CALL H2CHR (8, 1, XAXTYP, TEXT)
C                                       Bin opcode.
      DOLOG = .FALSE.
      DOWGT = .FALSE.
      CALL H2CHR (4, 1, XOPCOD, CHTMP4)
      IF (CHTMP4.EQ.OPCODE(2)) THEN
         DOLOG = .TRUE.
      ELSE IF (CHTMP4.EQ.OPCODE(3)) THEN
         DOWGT = .TRUE.
      ELSE IF (CHTMP4.EQ.OPCODE(4)) THEN
         DOLOG = .TRUE.
         DOWGT = .TRUE.
      ELSE
         CALL CHR2H (4, OPCODE(1), 1, XOPCOD)
         END IF
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCHN + 0.1
      LABEL = IROUND (XLABEL)
      LTYPE = MOD (ABS(LABEL), 100)
      IF ((LTYPE.EQ.0) .OR. (LTYPE.GT.10)) LTYPE = 3
      IF (LTYPE.GT.7) LTYPE = 7
      IF ((LTYPE.GE.4) .AND. (LTYPE.LE.6)) LTYPE = 3
      IF (LABEL.LT.0) THEN
         LABEL = (LABEL/100)*100 - LTYPE
      ELSE
         LABEL = (LABEL/100)*100 + LTYPE
         END IF
C                                       Open the uv file and get its
C                                       catalog header.
      UVLUN = 56
      PTYPE = 'UV'
      CALL MAPOPN ('READ', INDISK, INNAME, INCLAS, INSEQ, PTYPE, IUSER,
     *   UVLUN, UVIND, CNO, CATBLK, IOBLK, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'UVHGIN: ERROR OPENING UV FILE.'
         IERR = 1
         GO TO 990
         END IF
      CALL CHR2H (12, INNAME, 1, XNAME)
      CALL CHR2H (6, INCLAS, 1, XCLASS)
      XDISK = INDISK
      XSEQ = INSEQ
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = INDISK
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 0
      CALL COPY (256, CATBLK, CATUV)
C                                       Get uv pointer information from
C                                       the catalog header.
      CALL UVPGET (IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'UVHGIN: ERROR GETTING OFFSETS FROM UV FILE HEADER.'
         IERR = 1
         GO TO 990
         END IF
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = INNAME
      UCLAS = INCLAS
      UDISK = INDISK
      USEQ = INSEQ
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      UVRNG(1) = XUVRA(1)
      UVRNG(2) = XUVRA(2)
      IF (TYPUVD.GT.0) CALL RFILL (2, 0.0, UVRNG)
      IF (UVRNG(2).LE.0.0) UVRNG(2) = 1.0E10
C                                       Check spectral channel.
      BCHAN = 1
      ECHAN = 1
      IF (JLOCF.GE.0) THEN
         I = CATBLK(KINAX+JLOCF)
         IF (I.GT.1) THEN
            BCHAN = IROUND (XBCHAN)
            ECHAN = IROUND (XECHAN)
            IF (BCHAN.LE.0) BCHAN = 1
            IF ((ECHAN.LT.BCHAN) .OR. (ECHAN.GT.I)) ECHAN = I
            IF (BCHAN.GT.I) THEN
               WRITE (MSGTXT,1020) BCHAN, I
               IERR = 1
               GO TO 990
               END IF
            END IF
         END IF
      NCHAV = XNCHAV + 0.01
      IF (NCHAV.LE.0) NCHAV = 1
      IF (NCHAV.GT.ECHAN-BCHAN+1) NCHAV = ECHAN-BCHAN+1
      CHINC = XCHINC + 0.01
      IF (CHINC.LE.0) CHINC = NCHAV
      IF (CHINC.GT.ECHAN-BCHAN+1) CHINC = NCHAV
C                                       Check IF band
      BIF = 1
      EIF = 1
      IF (JLOCIF.GT.1) THEN
         I = CATBLK(KINAX+JLOCIF)
         IF (I.GT.1) THEN
            BIF = IROUND (XBIF)
            EIF = IROUND (XEIF)
            IF (BIF.LE.0) BIF = 1
            IF ((EIF.LT.BIF) .OR. (EIF.GT.I)) EIF = I
            IF (BIF.GT.I) THEN
               WRITE (MSGTXT,1025) BIF, I
               IERR = 1
               GO TO 990
               END IF
            END IF
         END IF
      XBCHAN = BCHAN
      XECHAN = ECHAN
      XCHINC = CHINC
      XNCHAV = NCHAV
      XBIF = BIF
      XEIF = EIF
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
C                                       Allow multiple subarrays
      CALL FNDEXT ('AN', CATBLK, NSUBA)
      NSUBA = MAX (1, NSUBA)
      IF (NSUBA.EQ.1) SUBARR = 1
      IF ((SUBARR.GT.0) .AND. (SUBARR.LE.NSUBA)) NSUBA = 1
      XSUBA = SUBARR
      IF (NSUBA.GT.1) XSUBA = -NSUBA
      CALL GETNAN (INDISK, CNO, CATBLK, LUN, SCRBUF, NUMAN, IERR)
      IF (IERR.EQ.0) THEN
         IF (SUBARR.GT.0) THEN
            NUMAN(2) = NUMAN(1+SUBARR)
            NUMAN(1) = 1
            BLOFF(1) = 0
            BLOFF(2) = (NUMAN(1+SUBARR) * (NUMAN(1+SUBARR) + 1)) / 2
         ELSE
            MANT = 0
            DO 52 I = 1,NUMAN(1)
               J = NUMAN(1+I)
               J = (J * (J+1)) / 2
               BLOFF(I) = MANT
               MANT = MANT + J
 52            CONTINUE
            BLOFF(1+NUMAN(1)) = MANT
            END IF
         END IF

C                                       Allow multiple FQ ids
      NFRQ = 1
      IF ((FRQSEL.LE.0) .AND. (SELBAN.LE.0.0) .AND. (SELFRQ.LE.0D0))
     *   THEN
         FRQSEL = 1
C                                       Determine the number of FREQIDs.
         FQVER = 1
         CALL ISTAB ('FQ', INDISK, CNO, FQVER, LUN, FQBUFF, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) THEN
            CALL FQINI ('READ', FQBUFF, INDISK, CNO, FQVER, CATBLK,
     *         LUN, IFQRNO, FQKOLS, FQNUMV, NIF, JERR)
            IF (JERR.NE.0) GO TO 999
            NFRQ = FQBUFF(5)
            IF (NFRQ.GT.1) THEN
               WRITE (MSGTXT,1030) NFRQ
               CALL MSGWRT (3)
               XFQID = -NFRQ
               END IF
            CALL TABIO ('CLOS', 0, IFQRNO, FQBUFF, FQBUFF, JERR)
            IF (JERR.NE.0) GO TO 999
            END IF
         END IF
C                                       Find specified FQ id
      CALL FQMATC (INDISK, CNO, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
      IF (NFRQ.LE.1) XFQID = MAX (1, FRQSEL)
      DOACOR = .FALSE.
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Clear the array of pointers.
      DO 100 I = 1,16
         HDX(I) = 0
 100     CONTINUE
      NHDX = 0
C                                       Construct pointers into the
C                                       histogram array.
      J = 1
      DO 140 I = 1,8
         K = INDEX (AXTYPE, TEXT(I:I)) - 1
         IF (K.GT.0) THEN
C                                       Check that the desired random
C                                       parameters are present.
            NODATA = .FALSE.
C                                       Axtype U.
            IF (K.EQ.1) THEN
               IF (ILOCU.EQ.-1) NODATA = .TRUE.
C                                       Axtype V.
            ELSE IF (K.EQ.2) THEN
               IF (ILOCV.EQ.-1) NODATA = .TRUE.
C                                       Axtype W.
            ELSE IF (K.EQ.3) THEN
               IF (ILOCW.EQ.-1) NODATA = .TRUE.
C                                       Axtype R.
            ELSE IF (K.EQ.4) THEN
               IF (ILOCU.EQ.-1) NODATA = .TRUE.
               IF (ILOCV.EQ.-1) NODATA = .TRUE.
C                                       Axtype D.
            ELSE IF (K.EQ.5) THEN
               IF (ILOCU.EQ.-1) NODATA = .TRUE.
               IF (ILOCV.EQ.-1) NODATA = .TRUE.
               IF (ILOCW.EQ.-1) NODATA = .TRUE.
C                                       Axtype P.
            ELSE IF (K.EQ.6) THEN
               IF (ILOCU.EQ.-1) NODATA = .TRUE.
               IF (ILOCV.EQ.-1) NODATA = .TRUE.
C                                       Axtype T.
            ELSE IF (K.EQ.7) THEN
               IF (ILOCT.EQ.-1) NODATA = .TRUE.
C                                       Axtype B.
            ELSE IF (K.EQ.8) THEN
               IF (ILOCB.EQ.-1) THEN
                  IF ((ILOCA1.EQ.-1) .OR. (ILOCA2.EQ.-1) .OR.
     *               (ILOCSA.EQ.-1)) NODATA = .TRUE.
                  END IF
C                                       Axtype S.
            ELSE IF (K.EQ.9) THEN
               IF (ILOCSU.EQ.-1) NODATA = .TRUE.
C                                       Axtype S.
            ELSE IF (K.EQ.10) THEN
               IF (ILOCFQ.EQ.-1) NODATA = .TRUE.
               END IF
C                                       No data for this histogram.
            IF (NODATA) THEN
               WRITE (MSGTXT,1110) TEXT(I:I)
               CALL MSGWRT (6)
C                                       No room left in HGMS.
            ELSE IF (J+NBINS.GT.32768) THEN
               WRITE (MSGTXT,1120) TEXT(I:I)
               CALL MSGWRT (6)
            ELSE
               HDX(K)  = J
               J = J + NBINS
               NHDX = NHDX + 1
               END IF
         ELSE IF (K.EQ.-1) THEN
            WRITE (MSGTXT,1130) TEXT(I:I)
            CALL MSGWRT (6)
            END IF
 140     CONTINUE
C                                       No servicable request.
      IF (NHDX.EQ.0) THEN
         WRITE (MSGTXT,1150)
         IERR = 1
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('UVHGIN: ERROR GETTING ADVERB VALUES.')
 1020 FORMAT ('UVHGIN: FREQUENCY CHANNEL',I4,' EXCEEDS LIMIT',I4)
 1025 FORMAT ('UVHGIN: IF BAND',I4,' EXCEEDS LIMIT',I4)
 1030 FORMAT ('Plotting',I4,' frequency IDs.')
 1110 FORMAT ('AXTYPE ',A1,' SKIPPED - NO DATA.')
 1120 FORMAT ('AXTYPE ',A1,' SKIPPED - INSUFFICIENT STORAGE.')
 1130 FORMAT ('UNRECOGNIZED AXTYPE ',A1,' IGNORED.')
 1150 FORMAT ('UVHGIN: NO SERVICABLE REQUEST.')
      END
      SUBROUTINE GETBL (RPARM, ISUB, BL)
C-----------------------------------------------------------------------
C   computes B (baseline) value
C   Inputs:
C      RPARM   R(*)   Random parameter set
C      ISUB    I      Current subarray
C   Output:
C      BL      R      Baseline number
C-----------------------------------------------------------------------
      INTEGER   ISUB
      REAL      RPARM(*), BL
C
      INTEGER   A1, A2, N
      INCLUDE 'ANTDATA.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       antenna numbers
      IF (ILOCB.GE.0) THEN
         A2 = RPARM(1+ILOCB) + 0.1
         A1 = A2 / 256
         A2 = A2 - A1 * 256
      ELSE
         A1 = RPARM(1+ILOCA1) + 0.1
         A2 = RPARM(1+ILOCA2) + 0.1
         END IF
C                                       number antennas this subarray
      N = NUMAN(ISUB+1)
      BL = N * (A1-1) - ((A1-2) * (A1-1)) / 2 + A2 + BLOFF(ISUB)
C
 999  RETURN
      END
      SUBROUTINE BLDHGM (HDX, DOMAIN, NOUT, HGMS, IERR)
C-----------------------------------------------------------------------
C   BLDHGM does two passes through the uv data file.  Firstly to get
C   the maxima and minima of the various parameters, and second to
C   construct the histograms.
C   Inputs:
C      HDX      I(16)     pointers into HGMS,
C                         number of histograms to do,
C   Inputs from common:
C      INDISK   I         uv input disk number.
C      UVLUN    I         uv logical unit number.
C      UVIND    I         uv buffer pointer returned by MAPOPN.
C   Outputs:
C      NOUT     I(2,16)   Number samples low/high of each histogram
C      DOMAIN   R(2,16)   Range of values on the horizontal axis
C                         of each histogram.
C      HGMS     R(*)      Array containing the histograms.
C      IERR     I         Error code, 0 means success.
C-----------------------------------------------------------------------
      INTEGER   HDX(16), NOUT(2,16), IERR
      REAL      DOMAIN(2,16), HGMS(*)
C
      INCLUDE 'INCS:ZPBUFSZ.INC'
      LOGICAL   DOTHIS, REQBAS, DESEL
      INTEGER   ADDRES, IBIN, IROUND, K, L, IIF, ICHAN, ISTK1, ISTK2,
     *   ISTK, JSUB, IFRQ, ISUB, NIF, NXVER, NXLUN, NANT, IANT(50),
     *   NBAS, IBAS(50), I, J, LCHAN, LC2
      REAL      AMPSQ, ASQMAX, BMAX, BMIN, CNTRIB, DSQ, DSQMAX, FQMAX,
     *   FQMIN, IM, R2D, RE, RSQ, SUMAX, SUMIN, TMAX, TMIN, U, UVWMAX,
     *   V, VAR, W, WGT, WGTMAX, UVMAX, RSQMAX, WAMPMX, WAMPSQ, WASQMX,
     *   VIS(UVBFSS), RPARM(20), CATUVR(256), RBIN, REMAX, REMIN, IMMAX,
     *   IMMIN, ASQMIN, SRE, SIM, SWT
      LONGINT   NSAMP
      DOUBLE PRECISION FI, FZ, FRQMUL
      INCLUDE 'UVHGM.INC'
      INCLUDE 'INCS:DSEL.INC'
      DOUBLE PRECISION FOFF(MAXIF)
      REAL      FINC(MAXIF)
      INTEGER   ISBAND(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'ANTDATA.INC'
      EQUIVALENCE (CATUV, CATUVR)
      PARAMETER (R2D = 180.0/3.14159265358)
C-----------------------------------------------------------------------
      JSUB = SUBARR
      NXVER = 1
      NXLUN = 90
      NSAMP = 0
C                                       Initialize baseline selection.
      CALL SETANT (50, XANT, XBASE, NANT, NBAS, IANT, IBAS, DESEL)
C                                       init maxima
      DSQMAX =  0.0
      RSQMAX =  0.0
      TMIN   =  1E30
      TMAX   = -1E30
      ASQMAX =  -1.E10
      ASQMIN = 1.E10
      WASQMX =  0.0
      WGTMAX =  0.0
      REMIN = 1.E10
      REMAX = -REMIN
      IMMIN = 1.E10
      IMMAX = -REMIN
      FQMIN = 0.0
      FQMAX = 0.1
      SUMIN = 0.0
      SUMAX = 0.1
      BMIN = 0
      BMAX = BLOFF(NSUBA+1)
      ISTK1 = 1
      ISTK2 = 0
      MSGTXT = 'Begin determination of scaling'
      IF (XRANGE(2).LE.XRANGE(1)) CALL MSGWRT (1)
C                                       range set by user
      IF (XRANGE(2).GT.XRANGE(1)) THEN
         DO 5 L = 1,16
            DOMAIN(1,L) = XRANGE(1)
            DOMAIN(2,L) = XRANGE(2)
 5          CONTINUE
C                                       range set by data
      ELSE
         DO 90 IFRQ = 1,NFRQ
            IF (NFRQ.GT.1) FRQSEL = IFRQ
            CALL CHNDAT ('READ', NXBUFF, INDISK, CNO, NXVER, CATUV,
     *         NXLUN, NIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IERR)
            IF (IERR.NE.0) THEN
               MSGTXT = 'PROBLEM FINDING FREQUENCIES'
               CALL MSGWRT (6)
               GO TO 90
               END IF
            DO 80 ISUB = 1,NSUBA
               IF (JSUB.EQ.0) SUBARR = ISUB
C                                       Init vis file for read.
               CALL UVGET ('INIT', RPARM, VIS, IERR)
C
               IF (IERR.EQ.-1) GO TO 70
               IF (IERR.EQ.5) GO TO 70
               IF (IERR.GT.0) GO TO 999
               IF (ISTK2.LE.0) ISTK2 = CATBLK(KINAX+JLOCS)

C                                       Loop Read vis. record.
 10            CALL UVGET ('READ', RPARM, VIS, IERR)
               IF (IERR.GT.0) THEN
                  WRITE (MSGTXT,1010) IERR
                  GO TO 990
C                                       a data record
               ELSE IF (IERR.EQ.0) THEN
C                                       Do we need this baseline?
                  IF (ILOCB.GE.0) THEN
                     I = INT (RPARM(ILOCB+1)) / 256
                     J = MOD (INT (RPARM(ILOCB+1)), 256)
                  ELSE
                     I = RPARM(ILOCA1+1) + 0.1
                     J = RPARM(ILOCA2+1) + 0.1
                     END IF
                  IF (.NOT.REQBAS (I, J, DESEL, IANT, NANT, IBAS, NBAS))
     *               GO TO 10
                  DOTHIS = .FALSE.
                  DO 60 ICHAN = BCHAN,ECHAN,CHINC
                     DO 50 IIF = BIF,EIF
                        FZ = FOFF(IIF) / UVFREQ + 1.0D0
                        FI = FINC(IIF) / UVFREQ
                        FRQMUL = 1.0D0
                        IF (TYPUVD.LE.0) FRQMUL = FZ + FI *
     *                    (ICHAN - 1 + BCHAN - CATUVR(KRCRP+KLOCFY))
                        FRQMUL = FRQMUL ** 2
                        DO 40 ISTK = ISTK1,ISTK2
                           LC2 = MIN (ECHAN, ICHAN+NCHAV-1)
                           SRE = 0.0
                           SIM = 0.0
                           SWT = 0.0
                           DO 20 LCHAN = ICHAN,LC2
                              ADDRES = 1 + (LCHAN-BCHAN) * INCF +
     *                           (IIF-BIF) * INCIF + (ISTK-ISTK1) * INCS
                              WGT    = VIS(ADDRES+2)
                              IF (WGT.GT.0.0) THEN
                                 SRE = SRE + WGT * VIS(ADDRES)
                                 SIM = SIM + WGT * VIS(ADDRES+1)
                                 SWT = SWT + WGT
                                 END IF
 20                           CONTINUE
C                                       Get maxima and minima.
                           IF (SWT.GT.0.0) THEN
                              DOTHIS = .TRUE.
                              RE = SRE / SWT
                              IM = SIM / SWT
                              AMPSQ  = RE**2 + IM**2
                              WAMPSQ  = AMPSQ * SWT
                              ASQMAX = MAX (ASQMAX, AMPSQ)
                              ASQMIN = MIN (ASQMIN, AMPSQ)
                              WASQMX = MAX (WASQMX, WAMPSQ)
                              WGTMAX = MAX (WGTMAX, SWT)
                              REMAX = MAX (REMAX, RE)
                              REMIN = MIN (REMIN, RE)
                              IMMAX = MAX (IMMAX, IM)
                              IMMIN = MIN (IMMIN, IM)
                              END IF
 40                        CONTINUE
 50                     CONTINUE
 60                  CONTINUE
C                                       Get maxima and minima.
                  IF (DOTHIS) THEN
                     RSQ    = (RPARM(1+ILOCU)**2 + RPARM(1+ILOCV)**2)
     *                  * FRQMUL
                     RSQMAX = MAX (RSQ, RSQMAX)
                     DSQ    = RSQ + (RPARM(1+ILOCW)**2) * FRQMUL
                     DSQMAX = MAX (DSQMAX, DSQ)
                     TMIN   = MIN (TMIN, RPARM(1+ILOCT))
                     TMAX   = MAX (TMAX, RPARM(1+ILOCT))
                     IF (ILOCSU.GE.0) THEN
                        SUMIN  = MIN (SUMIN, RPARM(1+ILOCSU))
                        SUMAX  = MAX (SUMAX, RPARM(1+ILOCSU))
                        END IF
                     IF (ILOCFQ.GE.0) THEN
                        FQMIN = MIN (FQMIN, RPARM(1+ILOCFQ))
                        FQMAX = MAX (FQMAX, RPARM(1+ILOCFQ))
                        END IF
                     END IF
                  GO TO 10
                  END IF
 70            CALL UVGET ('CLOS', RPARM, VIS, IERR)
 80            CONTINUE
 90         CONTINUE
C
         UVWMAX = SQRT (DSQMAX)
         WAMPMX = SQRT (WASQMX)
         UVMAX = SQRT (RSQMAX)
         DOMAIN(1,1)  = -UVMAX
         DOMAIN(2,1)  =  UVMAX
         DOMAIN(1,2)  = -UVMAX
         DOMAIN(2,2)  =  UVMAX
         DOMAIN(1,3)  = -UVWMAX
         DOMAIN(2,3)  =  UVWMAX
         DOMAIN(1,4)  =  0.0
         DOMAIN(2,4)  =  UVMAX
         DOMAIN(1,5)  =  0.0
         DOMAIN(2,5)  =  UVWMAX
         DOMAIN(1,6)  = -180.0
         DOMAIN(2,6)  = +180.0
         DOMAIN(1,7)  =  TMIN
         DOMAIN(2,7)  =  TMAX
         DOMAIN(1,8)  =  BMIN
         DOMAIN(2,8)  =  BMAX
         DOMAIN(1,9)  =  SUMIN
         DOMAIN(2,9)  =  SUMAX
         DOMAIN(1,10) =  FQMIN
         DOMAIN(2,10) =  FQMAX
         DOMAIN(1,11) =  REMIN
         DOMAIN(2,11) =  REMAX
         DOMAIN(1,12) =  IMMIN
         DOMAIN(2,12) =  IMMAX
         DOMAIN(1,13) =  SQRT (ASQMIN)
         DOMAIN(2,13) =  SQRT (ASQMAX)
         DOMAIN(1,14) = -180.0
         DOMAIN(2,14) = +180.0
         DOMAIN(1,15) =  0.0
         DOMAIN(2,15) =  WGTMAX
         DOMAIN(1,16) =  0.0
         DOMAIN(2,16) =  WAMPMX
         END IF
C                                       Second pass:  Accumulate data
C                                       for the histograms.
C                                       Clear the histogram storage
C                                       array.
      CALL FILL (32, 0, NOUT)
      MSGTXT = 'Begin binning of the data'
      CALL MSGWRT (1)
      CALL RFILL (32768, 0.0, HGMS)
C                                       over FQID
      DO 190 IFRQ = 1,NFRQ
         IF (NFRQ.GT.1) FRQSEL = IFRQ
         CALL CHNDAT ('READ', NXBUFF, INDISK, CNO, NXVER, CATUV,
     *      NXLUN, NIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IERR)
         IF (IERR.NE.0) GO TO 190
         DO 180 ISUB = 1,NSUBA
            IF (JSUB.EQ.0) SUBARR = ISUB
C                                       Init vis file for read.
            CALL UVGET ('INIT', RPARM, VIS, IERR)
C
            IF (IERR.EQ.-1) GO TO 175
            IF (IERR.EQ.5) GO TO 175
            IF (IERR.GT.0) GO TO 999
            IF (ISTK2.LE.0) ISTK2 = CATBLK(KINAX+JLOCS)
C                                       Loop Read vis. record.
 110        CALL UVGET ('READ', RPARM, VIS, IERR)
            IF (IERR.GT.0) THEN
               WRITE (MSGTXT,1010) IERR, IFRQ, ISUB
               GO TO 990
C                                       a data record
            ELSE IF (IERR.EQ.0) THEN
C                                       Do we need this baseline?
               IF (ILOCB.GE.0) THEN
                  I = INT (RPARM(ILOCB+1)) / 256
                  J = MOD (INT (RPARM(ILOCB+1)), 256)
               ELSE
                  I = RPARM(ILOCA1+1) + 0.1
                  J = RPARM(ILOCA2+1) + 0.1
                  END IF
               IF (.NOT.REQBAS (I, J, DESEL, IANT, NANT, IBAS, NBAS))
     *            GO TO 110
C                                       Get visibilities out of uvbuff.
               DO 170 ICHAN = BCHAN,ECHAN,CHINC
                  DO 150 IIF = BIF,EIF
                     FZ = FOFF(IIF) / UVFREQ + 1.0D0
                     FI = FINC(IIF) / UVFREQ
                     FRQMUL = 1.0D0
                     IF (TYPUVD.LE.0) FRQMUL = FZ + FI *
     *                  (ICHAN - 1 + BCHAN - CATUVR(KRCRP+KLOCFY))
C                                       Get (u,v,w) out of uvbuff.
                     U = RPARM(1+ILOCU) * FRQMUL
                     V = RPARM(1+ILOCV) * FRQMUL
                     W = RPARM(1+ILOCW) * FRQMUL
                     DO 140 ISTK = ISTK1,ISTK2
                        LC2 = MIN (ECHAN, ICHAN+NCHAV-1)
                        SRE = 0.0
                        SIM = 0.0
                        SWT = 0.0
                        DO 120 LCHAN = ICHAN,LC2
                           ADDRES = 1 + (LCHAN-BCHAN) * INCF +
     *                        (IIF-BIF) * INCIF + (ISTK-ISTK1) * INCS
                           WGT    = VIS(ADDRES+2)
                           IF (WGT.GT.0.0) THEN
                              SRE = SRE + WGT * VIS(ADDRES)
                              SIM = SIM + WGT * VIS(ADDRES+1)
                              SWT = SWT + WGT
                              END IF
 120                       CONTINUE
                        WGT = SWT
                        IF (WGT.GT.0.0) THEN
                           NSAMP = NSAMP + 1
                           RE  = SRE / WGT
                           IM  = SIM / WGT
                           DO 130 K = 1,16
                              IF (HDX(K).GT.0) THEN
                                 VAR = 0.0
C                                       Identify the variable.
                                 IF (K.EQ.1) THEN
                                    VAR = U
                                 ELSE IF (K.EQ.2) THEN
                                    VAR = V
                                 ELSE IF (K.EQ.3) THEN
                                    VAR = W
                                 ELSE IF (K.EQ.4) THEN
                                    VAR = SQRT (U*U + V*V)
                                 ELSE IF (K.EQ.5) THEN
                                    VAR = SQRT (U*U + V*V + W*W)
                                 ELSE IF (K.EQ.6) THEN
                                    IF ((U.NE.0.0) .OR. (V.NE.0.0))
     *                                 VAR = ATAN2 (V, U) * R2D
                                 ELSE IF (K.EQ.7) THEN
                                    VAR = RPARM(1+ILOCT)
                                 ELSE IF (K.EQ.8) THEN
                                    CALL GETBL (RPARM, ISUB, VAR)
                                 ELSE IF (K.EQ.9) THEN
                                    IF (ILOCSU.GE.0) VAR =
     *                                 RPARM(1+ILOCSU)
                                 ELSE IF (K.EQ.10) THEN
                                    IF (ILOCFQ.GE.0) VAR =
     *                                 RPARM(1+ILOCFQ)
                                 ELSE IF (K.EQ.11) THEN
                                    VAR = RE
                                 ELSE IF (K.EQ.12) THEN
                                    VAR = IM
                                 ELSE IF (K.EQ.13) THEN
                                    VAR = SQRT (RE*RE + IM*IM)
                                 ELSE IF (K.EQ.14) THEN
                                    IF ((RE.NE.0.0) .OR. (IM.NE.0.0))
     *                                 VAR = ATAN2 (IM, RE) * R2D
                                 ELSE IF (K.EQ.15) THEN
                                    VAR = WGT
                                 ELSE IF (K.EQ.16) THEN
                                    VAR = SQRT (RE*RE + IM*IM) *
     *                                 SQRT (WGT)
                                    END IF
C                                       Calculate the bin.
                                 RBIN = NBINS * (VAR-DOMAIN(1,K))
     *                              / (DOMAIN(2,K)-DOMAIN(1,K)) + 1.0
                                 RBIN = MAX (0.0, MIN (RBIN, NBINS+1.0))
                                 IF (ABS(1.0-RBIN).LT.0.01) THEN
                                    IBIN = 1
                                 ELSE IF (ABS(RBIN-NBINS-1).LT.0.01)
     *                              THEN
                                    IBIN = NBINS
                                 ELSE
                                    IBIN = RBIN
                                    END IF
                                 IBIN = IROUND (RBIN)
C                                       Check for under- or overflow.
                                 IF (IBIN.LT.1) THEN
                                    NOUT(1,K) = NOUT(1,K) + 1
                                 ELSE IF (IBIN.GT.NBINS) THEN
                                    NOUT(2,K) = NOUT(2,K) + 1
                                 ELSE
C                                       Count or weight?
                                    CNTRIB = 1.0
                                    IF (DOWGT) CNTRIB = WGT
C                                       Add this contribution.
                                    IBIN = HDX(K) + IBIN - 1
                                    HGMS(IBIN) = HGMS(IBIN) + CNTRIB
                                    END IF
                                END IF
 130                         CONTINUE
                           END IF
 140                    CONTINUE
 150                 CONTINUE
 170              CONTINUE
               GO TO 110
               END IF
 175        CALL UVGET ('CLOS', RPARM, VIS, IERR)
 180        CONTINUE
 190     CONTINUE
      WRITE (MSGTXT,1190) NSAMP
      CALL MSGWRT (5)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ERROR INITING FQ',I3,' SUBARRAY',I3)
 1190 FORMAT ('Found',I12,' samples for each plot')
      END
      SUBROUTINE PLHGM (HGM1, NOUT, XLAB, YLAB, UTITLE, LTITLE, UNITS,
     *   DOMAIN, LAST, PARMS, FVEC, IERR)
C-----------------------------------------------------------------------
C   PLHGM produces a histogram as an AIPS plot file.
C   Inputs:
C      HGM1     R(*)   Histogram constructed using only good data, i.e.
C                      having non-negative weight.
C      NOUT     I(2)   Number samples low/high of plot
C      XLAB     C*40   X-axis type
C      YLAB     C*40   Y-axis label
C      UTITLE   C*80   Top title for histogram
C      LTITLE   C*80   Lower title for histogram - plot if not ' '
C      UNITS    C*12   Units on the x-axis
C      DOMAIN   R(2)   The domain of values over which the histograms
C                      are defined.
C      LAST     L      T => there are no more plots
C      PARMS    D(3)   Gaussian fit parameters
C      FVEC     D(*)   Gaussian values
C   Inputs from common:
C      INDISK   I      Input disk number.
C      CNO      I      Catalog slot number.
C      .....    R(80)  AIPS adverbs values.
C   Output to common:
C      IVER     I      The PLot file version number containing histogram
C   Outputs:
C      IERR     I      Error code, 0 means success.
C-----------------------------------------------------------------------
      INTEGER   NOUT(2), IERR
      CHARACTER XLAB*40, YLAB*40, UTITLE*80, LTITLE*80, UNITS*12
      REAL      HGM1(*), DOMAIN(2)
      LOGICAL   LAST
      DOUBLE PRECISION PARMS(3), FVEC(*)
C
      CHARACTER PFILE*48, CHT12*12, CHT6*6, CHTY*2
      LOGICAL   YES
      INTEGER   IBIN, IOBLK(256), IRET, PIND, PLUN, TVCHN, TVCORN(4)
      REAL      BMAX
      INCLUDE 'UVHGM.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGPH.INC'
      DATA YES /.TRUE./
      DATA PLUN /26/
C-----------------------------------------------------------------------
C                                       Add plot file to the image
C                                       catalog header.
      IF (.NOT.DOTV) THEN
         CHT12 = ' '
         CHT6 = ' '
         CHTY = ' '
         CALL CATDIR ('CSTA', INDISK, CNO, CHT12, CHT6, 0, CHTY, 0,
     *      'CLRD', IOBLK, IERR)
         IF (IERR.EQ.0) CALL CATDIR ('CSTA', INDISK, CNO, CHT12, CHT6,
     *      0, CHTY, 0, 'WRIT', IOBLK, IERR)
         CALL MADDEX ('PL', INDISK, CNO, CATUV, IOBLK, YES, 'WRIT',
     *      IVER, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'PLHGM: ERROR UPDATING CATALOGUE HEADER.'
            CALL MSGWRT (8)
            GO TO 999
            END IF
         END IF
C                                       Create and initialize the plot.
C                                       Compute the maximum bin count.
      BMAX = 0
      DO 20 IBIN = 1,NBINS
         BMAX = MAX (BMAX, HGM1(IBIN))
 20      CONTINUE
C                                       Add extra info for EXTLIST.
      CALL CHR2H (40, XLAB, 1, XPARMS(1))
      CALL CHR2H (40, YLAB, 1, XPARMS(11))
      CALL CHR2H (80, UTITLE, 1, XPARMS(21))
      CALL CHR2H (12, UNITS, 1, XPARMS(41))
      XPARMS(44) = DOMAIN(1)
      XPARMS(45) = DOMAIN(2)
      XPARMS(46) = BMAX
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
C                                       Open the PLot file.
      CALL ZPHFIL ('PL', INDISK, CNO, IVER, PFILE, IERR)
      IBIN = NPARMS + 46
      CALL GINIT (INDISK, CNO, PFILE, 0, 19, IBIN, XUSER, DOTV, TVCHN,
     *   GRCHN, TVCORN, CATUV, IOBLK, PLUN, PIND, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'PLHGM: ERROR OPENING PLOT FILE FOR THE HISTOGRAM.'
         CALL MSGWRT (8)
         IF (.NOT.DOTV) CALL DELEXT ('PL', INDISK, CNO, 'WRIT', CATUV,
     *      IOBLK, IVER, IRET)
         GO TO 999
         END IF
C                                       Draw the histogram.
      CALL DRWHGM (HGM1, NOUT, XLAB, YLAB, UTITLE, LTITLE, UNITS,
     *   DOMAIN, BMAX, PARMS, FVEC, IOBLK, IERR)
C                                       Error?  Try to use it.
      IF (IERR.NE.0) THEN
         MSGTXT = 'PLHGM: ATTEMPTING TO FINISH HISTOGRAM AFTER ERROR.'
         CALL MSGWRT (8)
         END IF
      GPHPAG = .NOT.LAST
      CALL GFINIS (IOBLK, IERR)
C                                       Fatal error doing histogram.
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1070) XLAB(:10), IVER
         CALL MSGWRT (8)
C                                       Destroy the PLot file on error.
         IF (.NOT.DOTV) THEN
            CALL ZCLOSE (PLUN, PIND, IRET)
            CALL ZDESTR (INDISK, PFILE, IRET)
            CALL DELEXT ('PL', INDISK, CNO, 'WRIT', CATUV, IOBLK,
     *         IVER, IRET)
            END IF
      ELSE
         IF (.NOT.DOTV) THEN
            WRITE (MSGTXT,1075) XLAB(:10), IVER
            CALL MSGWRT (3)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1070 FORMAT ('DESTROY ',A,' PLOT VERSION',I4,' DUE TO ERRORS')
 1075 FORMAT ('Successful ',A,' plot version',I4,' created')
      END
      SUBROUTINE DRWHGM (HGM1, NOUT, XLAB, YLAB, UTITLE, LTITLE, UNITS,
     *   DOMAIN, BMAX, PARMS, FVEC, IOBLK, IERR)
C-----------------------------------------------------------------------
C   DRWHGM writes commands to an open plot file to draw a histogram.
C   Inputs:
C      HGM1     R(*)     Histogram constructed using only good data,
C                        i.e. having non-negative weight.
C      NOUT     I(2)     Number samples low/high of plot
C      XLAB     C*40     X-axis type
C      YLAB     C*40     Y-axis label
C      UTITLE   C*80     Top title for histogram
C      LTITLE   C*80     Lower title for histogram - plot if not ' '
C      UNITS    C*12     Units on the x-axis
C      DOMAIN   R(2)     The domain of values over which the histograms
C                        are defined.
C      BMAX     R        Maximum bin count.
C      PARMS    D(3)     Gaussian parameter fit if > 0
C      FVEC     D(*)     Gaussian values
C   In/out:
C      IOBLK    I(256)   I/O buffer for open, initialized PL type
C                        extension file.
C   Outputs:
C      IERR     I        Error code, 0 means success.
C-----------------------------------------------------------------------
      INTEGER   NOUT(2), IOBLK(256), IERR
      REAL      HGM1(*), DOMAIN(2), BMAX
      DOUBLE PRECISION PARMS(3), FVEC(*)
      CHARACTER XLAB*40, YLAB*40, UTITLE*80, LTITLE*80, UNITS*12
C
      INTEGER   IBIN, IDEPTH(5), J, I, NCHAR, IT(3), ID(3), ITRIM, NC1,
     *   NC2, LTYPE
      REAL      BLC(2), CH(4), RANGE(2), TRC(2), X, XSCALE, XYRATO, Y1,
     *   Y2, YSCALE, X2, DX, DY, SF(2)
      LOGICAL   FLAG
      CHARACTER STRING*80, ADATE*12, ATIME*8, STRNG1*16, STRNG2*16
      INCLUDE 'UVHGM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DGPH.INC'
C-----------------------------------------------------------------------
      IERR = 1
      IF (BMAX.LE.0.0) THEN
         WRITE (MSGTXT,1000) BMAX
         GO TO 995
         END IF
      RANGE(1) = 0.0
      RANGE(2) = BMAX
      IF (DOLOG) THEN
         RANGE(1) = LOG10(0.5)
         RANGE(2) = LOG10(RANGE(2))
         END IF
C                                       Set BLC, TRC, XYRATO.
      CALL FILL (5, 1, IDEPTH)
      BLC(1) = -1.0
      BLC(2) = -1.0
      TRC(1) = 102.0
      TRC(2) = 102.0
      XYRATO = XYRAT
C                                       Set coordinate common
      LOCNUM = 1
      RPVAL(1,LOCNUM) = DOMAIN(1)
      RPVAL(2,LOCNUM) = RANGE(1)
      RPLOC(1,LOCNUM) = 1.0
      RPLOC(2,LOCNUM) = 1.0
      AXINC(1,LOCNUM) = (DOMAIN(2) - DOMAIN(1)) / 99.0
      AXINC(2,LOCNUM) = (RANGE(2) - RANGE(1)) / 99.0
      ROT(LOCNUM) = 0.0
      NCHLAB(1,LOCNUM) = 0
      NCHLAB(2,LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      CORTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 4
      AXFUNC(1,LOCNUM) = 0
      AXFUNC(2,LOCNUM) = 0
      NCHLAB(1,LOCNUM) = 0
      NCHLAB(2,LOCNUM) = 0
      CTYP(1,LOCNUM) = UNITS
      CTYP(2,LOCNUM) = YLAB
C                                       metric scaling
      DO 10 I = 1,2
         SF(I) = 1.0
         IF (CTYP(I,LOCNUM).NE.'Days') THEN
            Y1 = ABS (AXINC(I,LOCNUM) * (TRC(I) - BLC(I)))
            Y2 = Y1
            CALL METSCL (LABEL, Y2, CPREF(I,LOCNUM), FLAG)
            IF ((.NOT.FLAG) .AND. (Y1.NE.0.0)) THEN
               SF(I) = Y2 / Y1
               RPVAL(I,LOCNUM) = RPVAL(I,LOCNUM) * Y2 / Y1
               AXINC(I,LOCNUM) = AXINC(I,LOCNUM) * Y2 / Y1
               END IF
         ELSE
            CPREF(I,LOCNUM) = ' '
            END IF
 10      CONTINUE
C                                       Set character offsets.
      LTYPE = MOD (ABS (LABEL), 100)
      CALL RFILL (4, 0.5, CH)
      CALL CHNTIC (BLC, TRC, J)
      IF (LTYPE.EQ.2) CH(1) = 2.5
      IF (LTYPE.GT.2) CH(1) = J + 4.0
      IF (LTYPE.GT.1) CH(2) = 2.0
      IF (LTYPE.GT.2) CH(2) = CH(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         CH(2) = CH(2) + 1.333
         IF (LTITLE.NE.' ') CH(2) = CH(2) + 1.333
         IF ((NOUT(1).GT.0) .OR. (NOUT(2).GT.0)) CH(2) = CH(2) + 1.333
         CH(4) = 2.0
         IF (LABEL.GT.0) CH(4) = CH(4) + 1.333
         END IF
C                                       default XYRATIO
      IF (XYRATO.LT.0.01) THEN
         IF (DOTV) THEN
            DX = WINDTV(3) - WINDTV(1) + 1 - CSIZTV(1) * (CH(1) + CH(3))
            DY = WINDTV(4) - WINDTV(2) + 1 - CSIZTV(2) * (CH(2) + CH(4))
            XYRATO = 1.0
            IF (DY.GT.0.0) XYRATO = DX / DY
         ELSE
            XYRATO = 1.4
            END IF
         END IF
C                                       Initialize for line drawing
      CALL GINITL (BLC, TRC, XYRATO, CH, IDEPTH, IOBLK, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'DRWHGM: ERROR INITIALIZING FOR LINE DRAWING.'
         GO TO 995
         END IF
      CALL GLTYPE (4, IOBLK, IERR)
      IF (IERR.NE.0) GO TO 920
      CALL GLTYPE (1, IOBLK, IERR)
      IF (IERR.NE.0) GO TO 920
C                                       Draw borders.
      CALL GPOS (BLC(1), BLC(2), IOBLK, IERR)
      IF (IERR.NE.0) GO TO 910
      CALL GVEC (TRC(1), BLC(2), IOBLK, IERR)
      IF (IERR.NE.0) GO TO 920
      CALL GVEC (TRC(1), TRC(2), IOBLK, IERR)
      IF (IERR.NE.0) GO TO 920
      CALL GVEC (BLC(1), TRC(2), IOBLK, IERR)
      IF (IERR.NE.0) GO TO 920
      CALL GVEC (BLC(1), BLC(2), IOBLK, IERR)
      IF (IERR.NE.0) GO TO 920
C                                       Calculate range and scales.
      XSCALE = 99.0 / NBINS
      YSCALE = 99.0 / (RANGE(2) - RANGE(1))
C                                       Labeling: source, freq, etc
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DX = 0.0
         DY = 0.5
         NCHAR = ITRIM (UTITLE)
         CALL GPOS (BLC(1), TRC(2), IOBLK, IERR)
         IF (IERR.NE.0) GO TO 910
         CALL GCHAR (NCHAR, 0, DX, DY, UTITLE, IOBLK, IERR)
         IF (IERR.NE.0) GO TO 930
         END IF
C                                       Labeling: date
      IF ((LABEL.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, ATIME, ADATE)
         WRITE (STRING,1010) IVER, ADATE, ATIME
         DY = DY + 1.333
         CALL REFRMT (STRING, '_', NCHAR)
         CALL GPOS (BLC(1), TRC(2), IOBLK, IERR)
         IF (IERR.NE.0) GO TO 910
         CALL GCHAR (NCHAR, 0, DX, DY, STRING, IOBLK, IERR)
         IF (IERR.NE.0) GO TO 930
         END IF
C                                       Labeling: bin stuff
      WRITE (STRING,1011) NBINS
      CALL CHTRIM (STRING, 10, STRING, NCHAR)
      NCHAR = NCHAR + 2
      STRING(NCHAR-1:) = ' '
      I = ITRIM (XLAB)
      STRING(NCHAR:) = XLAB(:I) // ' bins of width '
      NCHAR = NCHAR + I + 15
      X = (DOMAIN(2) - DOMAIN(1)) / (NBINS - 1)
      WRITE (ADATE,1012) X
      STRING(NCHAR:) = ADATE(2:10) // ' ' // UNITS
      NCHAR = ITRIM (STRING)
      MSGTXT = 'Plot ' // STRING
      CALL MSGWRT (4)
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DY = -1.5 - 1.333
         IF (LTYPE.GT.2) DY = DY - 1.333
         CALL GPOS (BLC(1), BLC(2), IOBLK, IERR)
         IF (IERR.NE.0) GO TO 910
         CALL GCHAR (NCHAR, 0, DX, DY, STRING, IOBLK, IERR)
         IF (IERR.NE.0) GO TO 930
C                                       samples outside
         IF ((NOUT(1).GT.0) .OR. (NOUT(2).GT.0)) THEN
            WRITE (STRING,1013) NOUT
            CALL REFRMT (STRING, '_', NCHAR)
            DY = DY - 1.333
            CALL GPOS (BLC(1), BLC(2), IOBLK, IERR)
            IF (IERR.NE.0) GO TO 910
            CALL GCHAR (NCHAR, 0, DX, DY, STRING, IOBLK, IERR)
            IF (IERR.NE.0) GO TO 930
            END IF
C                                       lower title: chan, IF
         IF (LTITLE.NE.' ') THEN
            NCHAR = ITRIM (LTITLE)
            DY = DY - 1.333
            CALL GPOS (BLC(1), BLC(2), IOBLK, IERR)
            IF (IERR.NE.0) GO TO 910
            CALL GCHAR (NCHAR, 0, DX, DY, LTITLE, IOBLK, IERR)
            IF (IERR.NE.0) GO TO 930
            END IF
         END IF
C                                       tick marks, labels, ...
      CALL CLAB1 (BLC, TRC, CH, LABEL, XYRATO, .FALSE., IOBLK, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'DRWHGM: PLOT ERROR OCCURRED WHILE DRAWING TICKS.'
         GO TO 995
         END IF
C                                       Draw the histogram
      CALL GLTYPE (2, IOBLK, IERR)
      IF (IERR.NE.0) GO TO 920
      X = 1.0
      CALL GPOS (X, 1.0, IOBLK, IERR)
      IF (IERR.NE.0) GO TO 910
      DO 30 IBIN = 1,NBINS
         Y1 = HGM1(IBIN)
         IF (DOLOG) Y1 = LOG10 (MAX (Y1, 0.5))
         Y1 = (Y1 - RANGE(1)) * YSCALE + 1.0
         CALL GVEC (X, Y1, IOBLK, IERR)
         IF (IERR.NE.0) GO TO 920
         X2 = X + XSCALE
         CALL GVEC (X2, Y1, IOBLK, IERR)
         IF (IERR.NE.0) GO TO 920
         X = X2
         IF ((XDOALL.LE.1.0) .OR. (IBIN.EQ.NBINS)) THEN
            CALL GVEC (X, 1.0, IOBLK, IERR)
            IF (IERR.NE.0) GO TO 920
            END IF
 30      CONTINUE
C                                       Get rid of last Gaussian
      CALL GLTYPE (4, IOBLK, IERR)
      IF (IERR.NE.0) GO TO 920
      IBIN = 4 + NGRAY
      GPHCON(IBIN) = 0
      CALL GPOS (X2, Y1, IOBLK, IERR)
      CALL GUNVEC (X2, Y1, IOBLK, IERR)
      IERR = 0
C                                       Draw the Gaussian
      IF (PARMS(1).GT.0.0) THEN
         X = 1.0
         DO 40 IBIN = 1,NBINS
            Y1 = -FVEC(IBIN)
            IF (DOLOG) Y1 = LOG10 (MAX (Y1, 0.5))
            Y1 = (Y1 - RANGE(1)) * YSCALE + 1.0
            IF (IBIN.EQ.1) THEN
               CALL GPOS (X, Y1, IOBLK, IERR)
            ELSE
               CALL GVEC (X, Y1, IOBLK, IERR)
               END IF
            IF (IERR.NE.0) GO TO 910
            X = X + XSCALE
 40         CONTINUE
         CALL GLTYPE (1, IOBLK, IERR)
         IF (IERR.NE.0) GO TO 920
         Y1 = SF(1) * PARMS(2)
         Y2 = ABS (Y1)
         IF (Y2.GT.1000.) THEN
            WRITE (STRNG1,1040) 'C =', Y1
         ELSE IF (Y2.GT.1.0) THEN
            WRITE (STRNG1,1041) 'C =', Y1
         ELSE IF (Y2.GT.0.01) THEN
            WRITE (STRNG1,1042) 'C =', Y1
         ELSE
            WRITE (STRNG1,1043) 'C =', Y1
            END IF
         CALL REFRMT (STRNG1, '_', NC1)
         Y1 = SF(1) * PARMS(3)
         Y2 = ABS (Y1)
         IF (Y2.GT.1000.) THEN
            WRITE (STRNG2,1040) 'RMS=', Y1
         ELSE IF (Y2.GT.1.0) THEN
            WRITE (STRNG2,1041) 'RMS=', Y1
         ELSE IF (Y2.GT.0.01) THEN
            WRITE (STRNG2,1042) 'RMS=', Y1
         ELSE
            WRITE (STRNG2,1043) 'RMS=', Y1
            END IF
         CALL REFRMT (STRNG2, '_', NC2)
         NCHAR = MAX (NC1, NC2)
         DX = -NCHAR - 5
         DY = -5.0
         CALL GPOS (TRC(1), TRC(2), IOBLK, IERR)
         IF (IERR.NE.0) GO TO 910
         CALL GCHAR (NC1, 0, DX, DY, STRNG1, IOBLK, IERR)
         IF (IERR.NE.0) GO TO 930
         DX = -NCHAR - 5
         DY = -7.0
         CALL GPOS (TRC(1), TRC(2), IOBLK, IERR)
         IF (IERR.NE.0) GO TO 910
         CALL GCHAR (NC2, 0, DX, DY, STRNG2, IOBLK, IERR)
         IF (IERR.NE.0) GO TO 930
         WRITE (MSGTXT,1050) PARMS(2), UNITS
         CALL MSGWRT (4)
         WRITE (MSGTXT,1051) PARMS(3), UNITS
         CALL MSGWRT (4)
         END IF
      GO TO 999
C                                       Error return from GPOS.
 910  MSGTXT = 'DRWHGM: PLOT ERROR OCCURRED WHILE MOVING TO A POINT.'
      GO TO 995
C                                       Error return from GVEC.
 920  MSGTXT = 'DRWHGM: PLOT ERROR OCCURRED WHILE DRAWING A LINE.'
      GO TO 995
C                                       error return from GCHAR
 930  MSGTXT = 'DRWHGM: PLOT ERROR OCCURRED WHILE DRAWING CHARACTERS.'
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DRWHGM: MAXIMUM BIN CONTAINED ONLY',F10.4,' COUNTS.')
 1010 FORMAT ('PLot file version',I4,'__created ',A12,A8)
 1011 FORMAT (I8)
 1012 FORMAT (1PE10.3)
 1013 FORMAT ('Samples outside plot:',I8,' below,_',I8,' above')
 1040 FORMAT (A,F7.0)
 1041 FORMAT (A,F8.3)
 1042 FORMAT (A,F8.4)
 1043 FORMAT (A,F9.6)
 1050 FORMAT ('Gaussian fit center',1PE11.4,2X,A)
 1051 FORMAT ('Gaussian fit RMS   ',1PE11.4,2X,A)
      END
      SUBROUTINE FITHGM (RHIS, DOMAIN, PARMS, FVEC, IERR)
C-----------------------------------------------------------------------
C   FITHGM fits a Gaussian to the histogram in HGM
C   Inputs
C      RHIS     R(*)   Histogram with NBINS samples
C      DOMAIN   R(2)   Range of values
C   Outputs:
c      PARMS    D(3)   Fit parameters
C      FVEC     D(*)   Gaussian values
C      IERR     I      > 0 => fit fails
C-----------------------------------------------------------------------
      REAL      RHIS(*), DOMAIN(2)
      DOUBLE PRECISION PARMS(3), FVEC(*)
      INTEGER   IERR
C
      EXTERNAL  XGFUNC
      INTEGER   I, RIMAX, RILOW, RIHIGH, IPVT(3), INFO, JNPTS, I3, I4
      REAL      RMAX, RHS, RS, RINT, RAVG, RRMS
      DOUBLE PRECISION FJAC(14,3), TOL
      INCLUDE 'UVHGM.INC'
      INCLUDE 'GDATA.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      ITTER = 0
      NITTER = 100
      RIMAX = -1
      RMAX = -1
      RHS = 0.0
      DO 10 I = 1,NBINS
         RHS = RHS + RHIS(I)
         IF (RHIS(I).GT.RMAX) THEN
            RIMAX = I
            RMAX = RHIS(I)
            END IF
 10      CONTINUE
      IF ((RIMAX.LE.2) .OR. (RIMAX.GE.NBINS-1)) THEN
         MSGTXT = 'GAUSSIAN FITS FAILS: MAX AT EDGE'
         IERR = 1
         GO TO 990
         END IF
      JNPTS = 0
      RILOW = 0
      RIHIGH = RIMAX + 1
      RS = 0.0
      RAVG = 0.0
      RRMS = 0.0
      DO 15 I = 1,NBINS
         IF (RHIS(I).GT.0.04*RMAX) THEN
            RS = RS + RHIS(I)
            RAVG = RAVG + I * RHIS(I)
            RRMS = RRMS + I * I * RHIS(I)
            END IF
 15      CONTINUE
      RAVG = RAVG / RS
      RRMS = RRMS / RS - RAVG * RAVG
      RRMS = SQRT (MAX (0.0, RRMS))
      RINT = (DOMAIN(2) - DOMAIN(1)) / (NBINS-1.0)
      RAVG = (RAVG - 1.0) * RINT + DOMAIN(1)
      RRMS = RRMS * RINT
      WRITE (MSGTXT,1015) RAVG, RRMS
C     CALL MSGWRT (4)
      RMAX = 0.3 * RMAX
      DO 20 I = 1,NBINS
         I3 = MIN (RIMAX + I, NBINS)
         I4 = MAX (RIMAX - I, 2)
         IF ((RHIS(I3).LT.RMAX) .AND. (RHIS(I4).LT.RMAX)) GO TO 30
         IF (RHIS(I4).GE.RMAX) RILOW = I4
         IF (RHIS(I3).GE.RMAX) RIHIGH = I3
 20      CONTINUE
      IF (RIHIGH-RILOW.GT.700) THEN
         MSGTXT = 'HISTOGRAM TOO WIDE FOR GAUSSIAN FITTER'
         IERR = 2
         GO TO 990
         END IF
 30   RS = 0.0
      DO 40 I = RILOW,RIHIGH
         JNPTS = JNPTS + 1
         DATA(JNPTS) = RHIS(I)
         RS = RS + RHIS(I)
 40      CONTINUE
      IF (JNPTS.LT.4) THEN
         MSGTXT = 'HISTOGRAM TOO NARROW TO GAUSSIAN FIT'
         IERR = 3
         GO TO 990
         END IF
      IF (RS.LT.0.1*RHS) THEN
         MSGTXT = 'HISTOGRAM CONTAINS TOO SMALL A FRACTION OF THE DATA'
         IERR = 4
         GO TO 990
         END IF
C                                       restore max and other initial
      PARMS(1) = RMAX / 0.3
      PARMS(2) = RIMAX - RILOW + 1
      PARMS(3) = 1.3 * (RIHIGH - RILOW + 1.0) / 2.0
C                                       call fitting routine
      I = 1
      CALL XGFUNC (JNPTS, 3, PARMS, FVEC, FJAC, I)
      TOL = 1.D-5
      I = 3
      CALL XGALMS (XGFUNC, JNPTS, I, PARMS, FVEC, FJAC, 14, TOL,
     *   INFO, IPVT)
      IF ((INFO.LE.0) .OR. (INFO.GT.3)) THEN
         WRITE (MSGTXT,1040) INFO
         IF (INFO.EQ.4) MSGTXT = 'GAUSSIAN FITTING ROUTINES' //
     *      ' THINK THE HISTOGRAM IS ORTHOGONAL'
         CALL MSGWRT (6)
         PARMS(2) = 1.0 + (RAVG - DOMAIN(1)) / RINT
         PARMS(3) = RRMS * SQRT (8.0 * LOG (2.0)) / RINT
      ELSE
         PARMS(2) = PARMS(2) - 1.0 + RILOW
         END IF
      IERR = 0
C                                       get Gaussian
      DO 45 I = 1,NBINS
         DATA(I) = 0.0D0
 45      CONTINUE
      I = 1
      CALL XGFUNC (NBINS, 3, PARMS, FVEC, FJAC, I)
      RINT = (DOMAIN(2) - DOMAIN(1)) / (NBINS-1.0)
      PARMS(2) = (PARMS(2) - 1.0) * RINT + DOMAIN(1)
      PARMS(3) = PARMS(3) * RINT / SQRT (8.0 * LOG (2.0))
      GO TO 999
C
 990  CALL MSGWRT (8)
c
 999  RETURN
C-----------------------------------------------------------------------
 1015 FORMAT ('Simple average, rms',2(1PE12.4))
 1040 FORMAT ('GAUSSIAN FITTING RETURNS INFO CODE',I3,
     *   ' using ordinary mean/rms')
      END
      SUBROUTINE XGALMS (FCN, M, N, X, FVEC, FJAC, LDFJAC, TOL, INFO,
     *   IPVT)
C-----------------------------------------------------------------------
C   XGALMS provides an extra interface to the math routine LMSTR1
C   and holds the WORK array (for overlay purposes)
C   Inputs:
c      FCN      EXT      Function to evaluate the model
C      M        I        Number data points (adj. array dim.)
C      LDFJAC   I        Number points on first axis of FJAC (adj.
C                        array dim.)
C      TOL      D        Tolerance desired
C   In/out:
c      X        D(N)     Initial guess/ answer
C      FVEC     D(M)     Function (Data - model) evaluation
C      FJAC     D(N,N)
C      INFO     I        Error code: 1 - 3 good, 0 bad input,
C                           4 orthogonal, 5 - 7 poor fit
C      IPVT     D(N)
C   See precursor remarks to LMSTR1 or LMSTR for details.
C   This version hard codes N = 3 parameters.
C-----------------------------------------------------------------------
      EXTERNAL  FCN
      INTEGER   M, N, LDFJAC, LWA
      INTEGER   INFO, IPVT(N)
      DOUBLE PRECISION    TOL, X(N), FVEC(N), FJAC(LDFJAC,N), WA(920)
      DATA LWA /920/
C-----------------------------------------------------------------------
C                                       It's just a dummy routine
      N = 3
      CALL LMSTR1 (FCN, M, N, X, FVEC, FJAC, LDFJAC, TOL, INFO, IPVT,
     *   WA, LWA)
C
 999  RETURN
      END
      SUBROUTINE XGFUNC (M, N, PARMS, FVEC, FJROW, IFLAG)
C-----------------------------------------------------------------------
C   This routine is called by the Argonne package to calculate the
C   difference between the current fit and the actual data OR the
C   Jacobian for this difference.
C   Inputs:
C      M       I      Number of data points in slice
C      N       I      No. of parameters (assumed 3 here)
C      PARMS   D(N)   parameters of gaussian components,
C                     GMAX, GPOS, GWIDTH
C      IFLAG   I      1 = calculate difference for current guess.
C                     > 1  IFLAG-1 is the position in the array to
C                          evaluate the Jacobian
C   COMMON /GDATA/:
C      DATA    R(*)   Original slice data points.
C      ITTER   I      Number of calls to evaluate FVEC.
C   Outputs:
C      FVEC    D(M)   Slice data points minus data points evaluated for
C                     current guess.
C      FJROW   D(N)   Row (IFLAG - 1) of Jacobian.
C-----------------------------------------------------------------------
      INTEGER   N, M, IFLAG
      DOUBLE PRECISION PARMS(N), FVEC(M), FJROW(N)
C
      DOUBLE PRECISION AMP, POS, SIG, EFACT, RES2, TSIG2, X, HALFAC
      INTEGER   IDATA
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'GDATA.INC'
      DATA HALFAC /2.77258872D0/
C-----------------------------------------------------------------------
C                                       Determine difference between
C                                       data and current fit.
      IF (IFLAG.LE.1) THEN
         ITTER = ITTER + 1
         IF (ITTER.GT.NITTER) THEN
            IFLAG = -1
            GO TO 999
            END IF
         DO 20 IDATA = 1,M
            FVEC(IDATA) = DATA(IDATA)
            IF (FVEC(IDATA).EQ.FBLANK) THEN
               FVEC(IDATA) = 0.0D0
            ELSE
               X = IDATA
               AMP = PARMS(1)
               IF (AMP.GT.0.0D0) THEN
                  POS = PARMS(2)
                  SIG = PARMS(3)
                  RES2 = (X - POS) / SIG
                  RES2 = HALFAC * RES2 * RES2
                  IF (RES2.LE.69.0D0) FVEC(IDATA) = FVEC(IDATA) -
     *               AMP * EXP (-RES2)
                  END IF
               END IF
 20         CONTINUE
C                                       Calculate Jacobian.
      ELSE
         IDATA = IFLAG - 1
         X = IDATA
         FJROW(1) = 0.0D0
         FJROW(2) = 0.0D0
         FJROW(3) = 0.0D0
         AMP = PARMS(1)
         POS = PARMS(2)
         SIG = PARMS(3)
         RES2 = HALFAC * (X - POS) * (X - POS)
         TSIG2 = RES2 / (SIG * SIG)
         IF (TSIG2.LE.69.0D0) THEN
            EFACT = -EXP (-TSIG2)
            FJROW(1) = EFACT
            EFACT = 2.0D0 * EFACT * AMP / (SIG * SIG)
            FJROW(2) = HALFAC * EFACT * (X-POS)
            FJROW(3) = EFACT * RES2 / SIG
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE HDRWIN (BLC, TRC, HDR, ERROR)
C-----------------------------------------------------------------------
C! sets image corners via WINDOW, revises header to that of output
C# IO-WaWa Map-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   HDRWIN normalizes input window parameters and converts the window
C   portion of the input header to that of the desired output map.
C   In/out:
C      BLC   R(7)      Bottom left corner
C      TRC   R(7)      Top right corner
C      HDR   I(256)    Header: may be /MAPHDR/ CATBLK
C   Output:
C      ERROR I         Error code: 0 => ok
C                                 16 => incorrect window
C   Common: /MAPHDR/ CATBLK  used as scratch
C-----------------------------------------------------------------------
      REAL      BLC(7), TRC(7)
      INTEGER   HDR(256), ERROR
C
      INTEGER   WINER, IERR
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA WINER /16/
C-----------------------------------------------------------------------
C                                       Normalize window
      CALL COPY (256, HDR, CATBLK)
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IERR)
      ERROR = WINER
      IF (IERR.NE.0) GO TO 999
      ERROR = 0
C                                       Fix header
      CALL SUBHDR (BLC, TRC, 1.0, 1.0)
C                                       Copy back to input header.
      CALL COPY (256, CATBLK, HDR)
C
 999  RETURN
      END

      SUBROUTINE TKCHAR (INCHAR, IANGL, DCX, DCY, TEXT, IERR)
C-----------------------------------------------------------------------
C! writes characters to a TK graphics device
C# Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TKCHAR will write characters to a TEKTRONIX 4012.
C   Inputs:
C      INCHAR  I       number of characters.
C      IANGL   I       0=horizontal, other = vertical.
C      DCX     R       X distance in characters from current position.
C      DCY     R       Y distance in characters from current position.
C      TEXT    C*(*)   packed characters.
C  Outputs:
C      IERR    I       error indicator. 0 = ok.
C-----------------------------------------------------------------------
      REAL      DCX, DCY
      INTEGER   INCHAR, IANGL, IERR
      CHARACTER TEXT*(*)
C
      REAL      X, Y
      INTEGER   IERRC, IERRL, LT, I, IT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTKS.INC'
      DATA IERRL /50/
C-----------------------------------------------------------------------
      IERR = 0
      IF (INCHAR.LE.0) GO TO 999
      IERRC = 0
      X = RXL + DCX * CSIZTK(1)
      Y = RYL + DCY * CSIZTK(2)
      CALL TEKVEC (X, Y, 3, IERR)
      IERRC = IERRC + IERR
      IF (IERRC.GT.IERRL) GO TO 980
C                                       Alpha mode.
      IT = 31
      CALL ZTKBUF (IT, 1, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Loop for each character.
      DO 10 I = 1,INCHAR
         LT = ICHAR (TEXT(I:I))
         CALL ZTKBUF (LT, 3, IERR)
         IERRC = IERRC + IERR
         IF (IERRC.GT.IERRL) GO TO 980
C                                       Vertical, reposition.
         IF (IANGL.EQ.0) GO TO 10
            X = RXL
            Y = RYL - CSIZTK(2)
            CALL TEKVEC (X, Y, 3, IERR)
            IERRC = IERRC + IERR
            IF (IERRC.GT.IERRL) GO TO 980
            CALL ZTKBUF (IT, 1, IERR)
            IERRC = IERRC + IERR
            IF (IERRC.GT.IERRL) GO TO 980
 10      CONTINUE
      IERR = 0
      GO TO 999
C                                       Error limit exceeded.
 980  WRITE (MSGTXT,1980)
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('ERROR LIMIT EXCEEDED.')
      END

      SUBROUTINE ZDAOPN (FCB, PNAME, MAP, EXCL, IERR)
C-----------------------------------------------------------------------
C! open the specified disk file
C# Z2 IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Opens a disk file for map (double buffered) or non-map (single
C   buffered) I/O and shared or exclusive use.
C   Inputs:
C      pname   H*48   Physical file name (H for Macro, C, ...')
C      map     I      I/O type: 0 => non-map (single buffered)
C                               1 => map (double buffered)
C      excl    I      Usage mode indicator: 0 => shared
C                                           1 => exclusive
C   Output:
C      fcb     I(*)   File control block for disk file involved
C      ierr    I      Error return code: 0 => no error
C                        2 => file not found
C                        3 => volume/logical not found
C                        4 => exclusive use requested but not ok
C                        6 => other open error
C   Generic version - stub
C-----------------------------------------------------------------------
      INTEGER   FCB(*), MAP, EXCL, IERR
      HOLLERITH PNAME(12)
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'ZDAOPN: REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (9)
C
 999  RETURN
      END

      SUBROUTINE ADVRBS (ANAME, ATYPE, ALENG, CLENG, IVALU, RVALU,
     *   CVALU)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   finds an adverb in the POPS linked list of adverbs and sets its
C   value.
C   Inputs:
C      ANAME   C*(*)     Adverb name - left justified
C      ATYPE   C*1       'C' => convert hollerith to C in CVALU
C                        'I' -> convert reals to integer in IVALU
C                        'R' => copy real values to RVALU
C      ALENG   I         number of values
C      CLENG   I         string length in chars
C      IVALU   I(*)      Integer values 'I' only
C      RVALU   I(*)      Real values 'R' only
C      CVALU   C(*)*(*)  Character values 'C' only
C   Output in common:
C      ERRNUM =  2       not an adverb
C               72       type wrong
C               73       length wrong
C-----------------------------------------------------------------------
      CHARACTER ANAME*(*), ATYPE*1, CVALU(*)*(*)
      INTEGER   ALENG, CLENG, IVALU(*)
      REAL      RVALU(*)
C
      INTEGER   POTERR, ITAG, ILOC, ITYPE, ISIZE, I, IL, NUMC, NUMW
      CHARACTER PRGNAM*6
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DSMS.INC'
      INCLUDE 'INCS:DIO.INC'
      INCLUDE 'INCS:DERR.INC'
      DATA PRGNAM /'ADVERB'/
C-----------------------------------------------------------------------
      POTERR = 0
C                                       get the adverb in the table
      KARBUF = ANAME
      KBPTR = 1
      CALL GETFLD
      IF (ERRNUM.NE.0) GO TO 980
      ITAG = TAG
      ILOC = LOCSYM
      ITYPE = SYTYPE
C                                       real values
      IF (((ITYPE.EQ.1) .OR. (ITYPE.EQ.2)) .AND. ((ATYPE.EQ.'I') .OR.
     *   (ATYPE.EQ.'R'))) THEN
         ISIZE = 1
         IF (ITYPE.NE.1) ISIZE = K(K(ILOC+3))
         IF (ISIZE.NE.ALENG) THEN
            POTERR = 72
         ELSE IF (ATYPE.EQ.'R') THEN
            CALL RCOPY (ISIZE, RVALU, C(ITAG))
         ELSE
            DO 10 I = 1,ISIZE
               C(ITAG+I-1) = IVALU(I)
 10            CONTINUE
         END IF
C                                       character values
      ELSE IF ((ITYPE.EQ.7) .AND. (ATYPE.EQ.'C')) THEN
         IL = K(ILOC+3)
         ISIZE = K(IL)
         NUMC  = K(IL+3)
         NUMW  = (NUMC + 3) / 4
         NUMW = MAX (1, NUMW)
         ISIZE = ISIZE / NUMW
         IF ((ISIZE.NE.ALENG) .OR. (NUMC.NE.CLENG)) THEN
            POTERR = 72
         ELSE
            DO 20 I = 1,ISIZE
               CALL CHR2H (NUMC, CVALU(I),  1, C(ITAG))
               ITAG = ITAG + NUMW
 20            CONTINUE
            END IF
C                                       type mismatch
      ELSE
         POTERR = 73
         END IF         

C                                       POPS error management
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
      END

      SUBROUTINE TEINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   ITERNO, TEKOLS, TENUMV, RDATE, TECTYP, IERR)
C-----------------------------------------------------------------------
C! Create/open/initialize TECOR details table
C# EXT-util Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2023-2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes TECOR details table
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'WRIT' = create/init for write or read
C                        'READ' = open for read only
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      LUN      I        Logical unit number to use
C   Input/output
C      VER      I        TE file version
C      CATBLK   I(256)   Catalog header block.
C      RDATE    C*8      Observation date
C      TECTYP   C*8      TEC data file name
C   Output:
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      ITERNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      TEKOLS   I(MAXTEC)   The column pointer array in order:
C                        Time, source, antenna, ...
C      TENUMV   I(MAXTEC)   Element count in each column.
C      IERR     I        Return error code, 0=>OK, else TABINI or TABIO
C                        error.
C-----------------------------------------------------------------------
      INTEGER   MAXTEC
      PARAMETER (MAXTEC = 16)
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER OPCODE*4, RDATE*8, TECTYP*8
      INTEGER   BUFFER(*), DISK, CNO, VER, CATBLK(256), LUN, ITERNO,
     *   TEKOLS(MAXTEC), TENUMV(MAXTEC), IERR
C
      HOLLERITH HOLTMP(6)
      CHARACTER TTITLE*56, TITLE(MAXTEC)*24, UNITS(MAXTEC)*8, KEYW(2)*8
      INTEGER   NKEY, NREC, DATP(128,2), NCOL, NTT, DTYP(MAXTEC), NDATA,
     *   KLOCS(2), KEYVAL(4), KEYTYP(2), IPOINT, MSGSAV, I, NC, JERR,
     *   ITRIM, ITEMP(6)
      REAL      KEYVAR(12)
      LOGICAL   DOREAD, NEWFIL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (KEYVAL, KEYVAR), (HOLTMP, ITEMP)
      DATA NTT /56/
      DATA TTITLE /'AIPS TECOR INTERNAL DETAILS TABLE '/
      DATA DTYP /11, 14, 14, 7*12, 32, 4*12, 22/
      DATA TITLE /'TIME', 'SOURCE', 'ANTENNA', 'HOUR ANGLE', 'AZIMUTH',
     *   'ZENITH ANGLE', 'AZION', 'ZAION', 'DLON', 'DLAT', 'BFIELD',
     *   'TEPATH', 'PROJECTED B', 'TOTAL TEC', 'IFR', 'DISP DELAY'/
      DATA KEYW /'RDATE', 'TECRTYPE'/
      DATA UNITS /'DAYS', ' ', ' ', 7*'DEGREES', 'GAUSS', '^16 /M^2',
     *   'GAUSS', '^16 /M^2', 'RAD/M^2', 'SEC/M^2'/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NREC = 1
      NKEY = 2
      NDATA = MAXTEC
      CALL FILL (NDATA, 0, TEKOLS)
      CALL FILL (NDATA, 0, TENUMV)
C                                       Fill in types
      IF (.NOT.DOREAD) THEN
         NCOL = NDATA
         CALL COPY (NDATA, DTYP, DATP(1,2))
      ELSE
         NCOL = 0
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'TE', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'TEINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
      MSGSAV = MSGSUP
C                                       Get number of scans
      ITERNO = BUFFER(5) + 1
      IF (DOREAD) ITERNO = 1
      NKEY = 2
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 10 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'TEINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'TEINI', IERR)
               GO TO 990
               END IF
 10         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       Set keyword values
C                                       obs date
         KLOCS(1) = 1
         KEYTYP(1) = 3
         CALL CHR2H (8, RDATE, 1, KEYVAL(1))
         KLOCS(2) = 3
         KEYTYP(2) = 3
         CALL CHR2H (8, TECTYP, 1, KEYVAL(3))
C                                       Only write if just created.
         CALL TABKEY ('WRIT', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'TEINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         MSGSUP = 32000
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         MSGSUP = MSGSAV
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'TEINI', IERR)
            GO TO 990
            END IF
C                                       Retrieve keyword values
C                                       RDATE
         IPOINT = KLOCS(1)
         IF (IPOINT.GT.0) CALL H2CHR (8, 1, KEYVAR(1), RDATE)
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) CALL H2CHR (8, 1, KEYVAR(3), TECTYP)
         END IF
      IERR = 0
C                                      Get array indices
C                                      Cover your ass from FNDCOL -
C                                      close to flush the buffers and
C                                      then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KEYVAL, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'TEINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'TE', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'TEINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (NDATA, TITLE, 24, .TRUE., BUFFER, TEKOLS, JERR)
C                                      Get array indices and no. values
      DO 150 I = 1,NDATA
         IPOINT = TEKOLS(I)
         IF (IPOINT.GT.0) THEN
            TEKOLS(I) = DATP(IPOINT,1)
            TENUMV(I) = DATP(IPOINT,2) / 10
            IF (TENUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            TEKOLS(I) = -1
            TENUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('TEINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('TEINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('TEINI: ERROR INITIALIZING TE TABLE FOR ',A)
      END

      SUBROUTINE CRDTRN (AZ1, POL1, CRDPRM, AZ2, POL2, ROTN)
C-----------------------------------------------------------------------
C! Apply Euler angle based coordinate transformation.
C# Math Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   CRDTRN applies the Euler angle based coordinate transformation.
C   Inputs:
C      AZ1      D       Azimuthal angle in the old system (degrees)
C      POL1     D       Polar angle in old system (degrees)
C      CRDPRM   D(11)   Parameters for the coordinate transformation.
C                       Euler angles for the transformation.
C                       1) (PHI0) Longitude of the ascending node in the
C                       old system, in degrees.  The ascending node is
C                       the point of intersection of the equators of the
C                       two systems such that the equator of the new
C                       system crosses from south to north as viewed in
C                       the old system.
C                       2) (THETA) The angle between the poles of the
C                       two systems.  THETA is positive for a positive
C                       rotation about the ascending node.
C                       3) (PHI) Longitude of the ascending node in the
C                       new system, in degrees.
C                       4) (CTHETA) = cos(THETA).
C                       5) (STHETA) = sin(THETA).
C                       The elliptic terms of aberration which were
C                       applied to pre-IAU1976 catalogue positions.
C                       6) C term
C                       7) D term
C                       8) C*TAN(eccentricity)
C                       9-11) similarly for the output system
C   Outputs:
C      AZ2      D       Azimuthal angle in the new system (degrees)
C      POL2     D       Polar angle in new system (degrees)
C      ROTN     D       The position angle of the old pole at the
C                       specified point, in degrees.
C   Called: EULROT
C   Algorithm:
C      A coordinate rotation specified by the three Euler angles.
C      The elliptic terms of aberration are applied as necessary,
C      Refer to the precursor comments to CRDSET.
C   Notes:
C   1) Longitude at the poles in the new system is consistent with that
C   specified in the old system.  This may be important when dealing
C   with map projections in which the poles are represented by finite
C   line segments.  Such is the case for cylindrical projections for
C   example.
C   2) Subroutine CRDSET may be called to set the transformation
C   parameters for any of a variety of transformations.
C   Author: Mark Calabretta, Australia Telescope.
C      Origin; 1988/Oct/05. Code last modified; 1990/Aug/15
C-----------------------------------------------------------------------
      DOUBLE PRECISION   AZ1, AZ2, POL1, POL2, CRDPRM(11), ROTN
C
      DOUBLE PRECISION   CAZ1, CAZ2, CPOL1, CPOL2, D2R, EAZ1, EAZ2,
     *   EPOL1, EPOL2, PI, SAZ1, SAZ2, SPOL1, SPOL2
C
      PARAMETER (PI = 3.141592653589793238462643D0)
      PARAMETER (D2R = PI/180D0)
C-----------------------------------------------------------------------
C                                       Remove the E-terms (non-zero
C                                       only for FK4)
      CAZ1  = COS (AZ1*D2R)
      SAZ1  = SIN (AZ1*D2R)
      CPOL1 = COS (POL1*D2R)
      SPOL1 = SIN (POL1*D2R)
      IF (CPOL1.NE.0D0) THEN
         EAZ1 = (CRDPRM(6) * CAZ1 + CRDPRM(7) * SAZ1) / CPOL1
      ELSE
         EAZ1 = 0D0
         END IF
      EPOL1 = (CRDPRM(7) * CAZ1 - CRDPRM(6) * SAZ1) * SPOL1 +
     *   CRDPRM(8) * CPOL1
C                                       Spherical coordinate rotation
      CALL EULROT (AZ1-EAZ1, POL1-EPOL1, CRDPRM, AZ2, POL2, ROTN)
C                                       Apply the E-terms (non-zero only
C                                       for FK4)
      CAZ2  = COS (AZ2*D2R)
      SAZ2  = SIN (AZ2*D2R)
      CPOL2 = COS (POL2*D2R)
      SPOL2 = SIN (POL2*D2R)
      IF (CPOL2.NE.0D0) THEN
         EAZ2 = (CRDPRM(9) * CAZ2 + CRDPRM(10) * SAZ2) / CPOL2
      ELSE
         EAZ2 = 0D0
         END IF
      EPOL2 = (CRDPRM(10) * CAZ2 - CRDPRM(9) * SAZ2) * SPOL2 +
     *   CRDPRM(11) * CPOL2
C
      AZ2  = AZ2  + EAZ2
      POL2 = POL2 + EPOL2
C                                       Normalize
      AZ2 = MOD (AZ2, 360D0)
      IF (AZ2.LT.0D0) AZ2 = AZ2 + 360D0
C
 999  RETURN
      END

      SUBROUTINE SCREAT (SIZE, WBUFF, IERR)
C-----------------------------------------------------------------------
C! create an AIPS-standard scratch file w common DFIL.INC, ...
C# IO-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2004, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SCREAT is intended to replace all previous scratch file creation
C   routines in AIPS (beginning on February 11, 1985).  It uses the
C   Common included via the new DFIL.INC, CFIL.INC pair and returns
C   the scratch file disk and catalog number in variables SCRVOL(NSCR)
C   and SCRCNO(NSCR), where NSCR is updated on successful creation.
C   It attempts to avoid the disk used for the previously created
C   scratch file.  All files have physical name SCvccc01 where v is the
C   disk number and ccc is the catalog slot number.  Their logical
C   names are determined from the routine BLDSNM.
C
C   SCREAT was modified to insert the system name in the catalog
C   header so that the destroy routines will not destroy some other
C   machines scratch files.
C
C   Input:
C      SIZE    I          Desired size in AIPS blocks (256-integer
C                         blocks)
C   Output:
C      WBUFF   I(512)     Scratch buffer    (NOTE 512 integers)
C      IERR    I          error: 0 => ok
C                            1 => catalog error in setting name
C                            2 => catalog error on open
C                            3 => CATIO error writing header to catlg
C                            4 => No allowed disk with room
C   Commons:
C      /MAPHDR/   in      scratch file image header - contents mostly
C                         ignored
C      /CFILES/   in/out  file info
C   Note: this common uses IBAD to specify BADDISKs which are avoided.
C-----------------------------------------------------------------------
      INTEGER   SIZE, WBUFF(512), IERR
C
      CHARACTER NAME*12, CLASS*6, STAT*4, PHNAME*48, TYPTMP*2
      CHARACTER SYSKYS(2)*8
      HOLLERITH NAMESY(4)
      INTEGER   NLOCS(2), NKEYTP(2), ASIZE, SNO, IVOL, CNO, I, IV,
     *   NTRY, ITRY(15)
      LOGICAL   MAP, IAMOK
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DDRC.INC'
      DATA MAP /.TRUE./
      DATA NLOCS /1, 3/, NKEYTP /3, 3/
      DATA SYSKYS /'SYSNAME1', 'SYSNAME2'/
C-----------------------------------------------------------------------
      IF (NSCR.GE.SCRLST) THEN
         MSGTXT = 'SCREAT: SCRATCH FILE LIST OVERFLOWS'
         CALL MSGWRT (8)
         IERR = 8
         GO TO 999
         END IF
C                                       Build logical name
      CALL BLDSNM (TSKNAM, NPOPS, NAME, CLASS, IERR)
C                                       protect current mapheader
      CALL COPY (256, CATBLK, WBUFF(257))
C                                       scratch header
      CATBLK(KIDIM) = 0
      CATBLK(KIPCN) = 0
      CATBLK(KIIMS) = 0
      CALL CATCLR (CATBLK)
      CALL CHR2H (12, NAME, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLASS, KHIMCO, CATH(KHIMC))
      CALL CHR2H (2, 'SC', KHPTYO, CATH(KHPTY))
      CALL ZDATE (WBUFF)
      WRITE (MSGTXT,1000) WBUFF(1), WBUFF(2), WBUFF(3)
      CALL CHR2H (8, MSGTXT, 1, CATH(KHDMP))
C                                       prepare the system name
C                                       20 characters go into
C                                       3 8 char keywords.
      CALL CHR2H (8, HSTNAM(1:8), 1, NAMESY(1))
      CALL CHR2H (8, HSTNAM(9:), 1, NAMESY(3))
C                                       find highest seq number + 1
      SNO = 0
      CNO = 1
      IVOL = 0
      TYPTMP = ' '
      CALL CATDIR ('SRCH', IVOL, CNO, NAME, CLASS, SNO, TYPTMP, NLUSER,
     *   STAT, WBUFF, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.5)) THEN
         WRITE (MSGTXT,1010) IERR, 'SEARCHING CATALOG TO MAKE SCRATCH'
         IERR = 1
         GO TO 980
         END IF
      IF (IERR.EQ.5) SNO = 0
      SNO = SNO + 1
      CATBLK(KIIMS) = SNO
C                                       set pointers to try
      IV = 1
      IF (NSCR.GE.1) IV = SCRVOL(NSCR)
      IF ((NSCR.LE.0) .AND. (NCFILE.GE.1)) IV = FVOL(NCFILE)
C                                       loop over disks
      NTRY = 0
      DO 50 IVOL = 1,NVOL
C                                       select next volume
         IV = MOD (IV, NVOL) + 1
         DO 15 I = 1,10
            IF (IV.EQ.IBAD(I)) GO TO 50
 15         CONTINUE
         IF (.NOT.IAMOK(IV,'SC')) GO TO 50
         IF (DSKLOK(IVOL).EQ.1) GO TO 50
         IF (NTRY.LT.15) THEN
            NTRY = NTRY + 1
            ITRY(NTRY) = IV
            END IF
C                                       create a catalog slot
         CNO = 1
         TYPTMP = 'SC'
         CALL CATDIR ('OPEN', IV, CNO, NAME, CLASS, SNO, TYPTMP, NLUSER,
     *       STAT, WBUFF, IERR)
         IF (IERR.NE.0) THEN
            IF ((IERR.EQ.1) .OR. (IERR.EQ.5)) THEN
               WRITE (MSGTXT,1015) IV
               MSGTXT(25:) = 'could not open catalog file'
               IF (IERR.EQ.5) MSGTXT(25:) =
     *            'no room in the catalog file'
               CALL MSGWRT (6)
               GO TO 50
            ELSE
               WRITE (MSGTXT,1010) IERR, 'OPENING CATALOG SCRATCH SLOT'
               IERR = 2
               GO TO 980
               END IF
            END IF
C                                       header to disk
         CALL CATIO ('UPDT', IV, CNO, CATBLK, 'REST', WBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR,
     *         'WRITING SCRATCH HEADER TO CATALOG'
            IERR = 3
            GO TO 970
            END IF
C                                       system name keywords to disk
         CALL CATKEY ('WRIT', IV, CNO, SYSKYS, 2, NLOCS, NAMESY, NKEYTP,
     *      WBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, 'WRITING SYSNAME CATALOG HEADER'
            IERR = 4
            GO TO 970
            END IF
C                                       create
         CALL ZPHFIL ('SC', IV, CNO, 1, PHNAME, IERR)
         CALL ZCREAT (IV, PHNAME, SIZE, MAP, ASIZE, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1040) IV, IERR
            IF (IERR.EQ.3) WRITE (MSGTXT,1041) IV, SIZE
            IF (IERR.EQ.5) WRITE (MSGTXT,1042) IV
            CALL MSGWRT (8)
C                                       clean up cat - status, slot
            TYPTMP = 'SC'
            CALL CATDIR ('CSTA', IV, CNO, NAME, CLASS, SNO, TYPTMP,
     *         NLUSER, 'CLWR', WBUFF, IERR)
            TYPTMP = 'SC'
            CALL CATDIR ('CLOS', IV, CNO, NAME, CLASS, SNO, TYPTMP,
     *         NLUSER, STAT, WBUFF, IERR)
         ELSE
            GO TO 60
            END IF
 50      CONTINUE
C                                       cannot do it
      MSGTXT = 'SCREAT: FAILED TO CREATE REQUESTED SCRATCH FILE'
      CALL MSGWRT (8)
      MSGTXT = 'SCREAT: PERHAPS BADDISK IS TOO EXTENSIVE'
      CALL MSGWRT (8)
      WRITE (MSGTXT,1050) (ITRY(I), I = 1,NTRY)
      IERR = 5
      GO TO 980
C                                       Did it
 60   NSCR = NSCR + 1
      SCRVOL(NSCR) = IV
      SCRCNO(NSCR) = CNO
      GO TO 990
C                                       Error returns
C                                       clean up cat - status, slot
 970  CALL MSGWRT (8)
      TYPTMP = 'SC'
      CALL CATDIR ('CSTA', IV, CNO, NAME, CLASS, SNO, TYPTMP, NLUSER,
     *   'CLWR', WBUFF, IERR)
      TYPTMP = 'SC'
      CALL CATDIR ('CLOS', IV, CNO, NAME, CLASS, SNO, TYPTMP, NLUSER,
     *   STAT, WBUFF, IERR)
      GO TO 990
C                                       No clean up
 980  CALL MSGWRT (8)
C                                       restore header
 990  CALL COPY (256, WBUFF(257), CATBLK)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I4.4,I2.2,I2.2)
 1010 FORMAT ('SCREAT: ERROR',I5,' ON ',A)
 1015 FORMAT ('SCREAT: DISK',I3,' WARNING')
 1040 FORMAT ('SCREAT: DISK',I3,' ERROR',I5,' ON SCRATCH CREATE')
 1041 FORMAT ('SCREAT: NO ROOM ON',I3,' FOR SCRATCH SIZE',I10,
     *   ' KILOBYTES')
 1042 FORMAT ('SCREAT: PROHIBITED FROM USING DISK ',I3)
 1050 FORMAT ('SCREAT: TRIED DISKS',15I3)
      END

LOCAL INCLUDE 'XMBUFRS'
      INCLUDE 'INCS:PMAD.INC'
      REAL      BUFF1(MABFSS), BUFF2(MABFSS)
      INTEGER   IBUFF1(MABFSS), IBUFF2(MABFSS), SCRTCH(512)
      EQUIVALENCE (IBUFF1, BUFF1), (IBUFF2, BUFF2)
      COMMON /BUFRS/ BUFF1, BUFF2, SCRTCH
LOCAL END
LOCAL INCLUDE 'TVSPX.INC'
      INTEGER   MAXLIS, MAXFQ
      PARAMETER (MAXLIS=1000)
      PARAMETER (MAXFQ=16384)
C
      INCLUDE 'XMBUFRS'
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, OPTYPE*4, FUNCTY(7)*2,
     *   CUNITS(7)*8
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XOPTYP, CATOH(256)
      REAL      XSEQIN, XDISKI, XSEQO, XDISKO, BLC(7), TRC(7),
     *   FCUT, REFREQ, PBPARM(7), DPARM(10), CPARM(10), BADD(10)
      DOUBLE PRECISION CATOD(128), FV, RV, DV, RA0, DE0, XFREQ(MAXFQ),
     *   DEFREQ
      REAL      CATOR(256), PMIN(7), PMAX(7), FI, RI, DI, FR, RR, DR,
     *   MROT, ROBUST(4,7)
      INTEGER   CATOLD(256), SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO,
     *   OLDCNO, JBUFSZ, FAX, RAX, DAX, NGOOD, PIXLIS(2,MAXLIS), NLIST,
     *   SUBWIN(4), SVZOOM(3)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XNAMOU, XSEQO,
     *   XDISKO, BLC, TRC, FCUT, REFREQ, XOPTYP, PBPARM, DPARM, CPARM,
     *   BADD
      COMMON /CHPARM/ NAMEIN, CLAIN, NAMOUT, OPTYPE, FUNCTY, CUNITS
      COMMON /PARMS/ CATOLD, FV, RV, DV, RA0, DE0, XFREQ, DEFREQ, PMAX,
     *   PMIN, SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO, JBUFSZ, FI,
     *   RI, DI, FR, RR, DR, FAX, RAX, DAX, MROT, NGOOD, PIXLIS, NLIST,
     *   SUBWIN, ROBUST, SVZOOM
      EQUIVALENCE (CATOLD, CATOR, CATOH, CATOD)
LOCAL END
LOCAL INCLUDE 'TVSPX.TV'
      INTEGER   IGR1, IGR2, IGR3, IGR4, IGR5, IGR7, TTYLUN, TTYIND,
     *   IPL(2)
      LOGICAL   LABWED
      REAL      PLTMIN, PLTMAX
      INCLUDE 'INCS:DTVC.INC'
      COMMON /TVSPIX/ IGR1, IGR2, IGR3, IGR4, IGR5, IGR7, TTYLUN,
     *   TTYIND, LABWED, PLTMIN, PLTMAX, IPL
LOCAL END
      PROGRAM TVSPX
C-----------------------------------------------------------------------
C! TVSPX fits 1-D spectral indexes
C# Map-util Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 2024-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TVSPX fits 1-dimensional spectral inices to rows of an image.  It
C   fits and then allows TV interaction to blank bad values
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      FLUX           FCUT          Flux cutoff: use only data >
C                                   FLUX.
C      OPTYPE         XOPTYP        '': Blank illegal velocities;
C      BADD(10)       IBAD          Disk numbers to avoid.
C   Programmer Eric W. Greisen  2005
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, NX, NY, NZ, ITYP
      LOGICAL   ABLANK
      REAL      IMAGE(2), ANSW(2)
      LONGINT   PIMAGE, PANSW
      INCLUDE 'TVSPX.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'TVSPX'/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL SPIXIN (PRGM, NX, NY, NZ, ITYP, IMAGE, PIMAGE, ANSW, PANSW,
     *   IRET)
C                                       Call routine that sends data
C                                       to the user routine.
      IF (IRET.EQ.0) CALL SPIXDO (ABLANK, NX, NY, NZ, ITYP,
     *   IMAGE(1+PIMAGE), ANSW(1+PANSW), IRET)
      IF (IRET.EQ.0) CALL SPIXTV (ABLANK, NX, NY, NZ, ITYP,
     *   IMAGE(1+PIMAGE), ANSW(1+PANSW), IRET)
      IF (IRET.EQ.0) CALL SPIXOU (ABLANK, NX, NY, ITYP, ANSW(1+PANSW),
     *   IRET)
C                                       Close down files, etc.
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE SPIXIN (PRGN, NX, NY, NZ, ITYP, IMAGE, PIMAGE, ANSW,
     *   PANSW, IRET)
C-----------------------------------------------------------------------
C   SPIXIN gets input parameters for TVSPX.
C   Inputs:
C      PRGN     C*6    Program name (2 chars/word)
C      IMAGE    R(*)   buffer for image
C      ANSW     R(*)   buffer for answers
C   Output:
C      NX       I      # X pixels
C      NY       I      # Y pixels
C      NZ       I      # spectral pixels
C      ITYP     I      # output parameters
C      PIMAGE   L      pointer for image
C      PANSW    L      pointer for answ
C      IRET     I      Error code: 0 => ok
C                                4 => user routine detected error.
C                                5 => catalog troubles
C                                8 => can't start
C                               <0 => failed to get all frequencies
C      /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN(6)
      REAL      IMAGE(*), ANSW(*)
      LONGINT   PIMAGE, PANSW
      INTEGER   NX, NY, NZ, ITYP, IRET
C
      CHARACTER STAT*4, OTYPE*8, CLAOUT*6, SEQTYP(7)*8, CTEMP*8,
     *   MTYPE*2, C1TYP*8
      INTEGER   IPT, I, IERR, NPARM, IROUND, IG, INC, NAX, J, need
      DOUBLE PRECISION C1CRV
      REAL      CONST, C1CRP, C1CIC, C1CRT
      INCLUDE 'TVSPX.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA SEQTYP /'SP CNT', 'B TEMP', 'D BT', 'SPIX','D SPIX',
     *   'SPCU', 'D SPCU'/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
C                                       Fixed PPM 1996.09.30: was 38
      NPARM = 66
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      RQUICK = .FALSE.
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (12, 1, XOPTYP, OPTYPE)
      SEQIN = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO = IROUND (XDISKO)
      DO 20 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 20      CONTINUE
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, 'READ', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'COPYING CATBLK'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Copy old CATBLK to new.
      CALL COPY (256, CATOLD, CATBLK)
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CATBLK(KIIMS) = SEQOUT
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATOLD(KIDIM), CATOLD(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
      NZ = TRC(1) - BLC(1) + 1.01
      NX = TRC(2) - BLC(2) + 1.01
      NY = TRC(3) - BLC(3) + 1.01
C                                       allocate memory
      NEED = (NX * NY * NZ - 1) / 1024 + 5
      CALL ZMEMRY ('GET ', TSKNAM, NEED, IMAGE, PIMAGE, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'GETTING MEMORY FOR IMAGE'
         GO TO 990
         END IF
      ITYP = 5
      IF (OPTYPE.EQ.'CURV') ITYP = 7
      NEED = (ITYP * NX * NY - 1) / 1024 + 5
      CALL ZMEMRY ('GET ', TSKNAM, NEED, ANSW, PANSW, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'GETTING MEMORY FOR ANSWERS'
         GO TO 990
         END IF
      NEED = NEED * 1024
      CALL RFILL (NEED, 0.0, ANSW(1+PANSW))
C                                       Get user modification to CATBLK
      IRET = 4
      CALL SPIHED (IRET)
      IF (IRET.NE.0) GO TO 999
      NEWCNO = 0
C                                       Make names, classes, disks OK.
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), NAMOUT)
      CONST = -1.E15
      CALL RFILL (7, CONST, PMAX)
      CONST = -CONST
      CALL RFILL (7, CONST, PMIN)
C                                       PBCORR parameters
      FAX = 0
      RAX = 0
      DAX = 0
      NAX = CATOLD(KIDIM)
      DO 100 I = 1,NAX
         CALL H2CHR (8, 1, CATOH(KHCTP+2*(I-1)), OTYPE)
         IF (OTYPE(:4).EQ.'FREQ') THEN
            FAX = I
            J = I
            FV = CATOD(KDCRV+I-1)
            FI = CATOR(KRCIC+I-1)
            FR = CATOR(KRCRP+I-1)
         ELSE IF (OTYPE(:8).EQ.'SEQ.NUM.') THEN
            FAX = I
         ELSE IF (OTYPE(:8).EQ.'FQID') THEN
            FAX = I
         ELSE IF ((OTYPE(:2).EQ.'RA') .OR. (OTYPE(2:4).EQ.'LON')) THEN
            RAX = I
            RV = CATOD(KDCRV+I-1) * DG2RAD
            RI = CATOR(KRCIC+I-1) * DG2RAD
            RR = CATOR(KRCRP+I-1)
         ELSE IF ((OTYPE(:3).EQ.'DEC') .OR. (OTYPE(2:4).EQ.'LAT')) THEN
            DAX = I
            DV = CATOD(KDCRV+I-1) * DG2RAD
            DI = CATOR(KRCIC+I-1) * DG2RAD
            DR = CATOR(KRCRP+I-1)
            MROT = CATOR(KRCRT+I-1) * DG2RAD
            END IF
 100     CONTINUE
      IF ((PBPARM(1).GT.0.0) .AND. (DAX*RAX*FAX.LE.0)) THEN
         MSGTXT = 'FREQ/RA/DEC AXIS NOT FOUND: PBPARM TURNED OFF'
         CALL MSGWRT (7)
         PBPARM(1) = 0.0
         END IF
      RA0 = CATOD(KDORA) * DG2RAD
      DE0 = CATOD(KDODE) * DG2RAD
      IF ((RA0.EQ.0.0D0) .AND. (DE0.EQ.0.0D0)) THEN
         RA0 = RV
         DE0 = DV
         END IF
C                                       reference freq
      IF (FAX.LE.0) THEN
         IF (REFREQ.LE.0.0) REFREQ = 1.0
      ELSE IF (REFREQ.LT.0.0) THEN
         REFREQ = FV / 1.D9
      ELSE IF (REFREQ.EQ.0.0) THEN
         REFREQ = 1.0
         END IF
      DEFREQ = REFREQ * 1.D9
C                                       create output files in advance
C                                       Basic output header
      NAX = CATBLK(KIDIM) - 1
      J = J - 1
      INC = 2
C                                       save averaged axis for what??
      C1CRP = (CATR(KRCRP) - 1.5) / CATBLK(KINAX) + 0.5
      C1CIC = CATR(KRCIC) * CATBLK(KINAX)
      C1CRT = CATR(KRCRT)
      C1CRV = CATD(KDCRV)
      CALL H2CHR (8, 1, CATH(KHCTP), C1TYP)
      IF (C1TYP.EQ.'FREQ') J = NAX + 1
C                                       move other axes down
      DO 60 I = 1,NAX
         CATBLK(KINAX+I-1) = CATBLK(KINAX+I)
         CATR(KRCRP+I-1) = CATR(KRCRP+I)
         CATR(KRCRT+I-1) = CATR(KRCRT+I)
         CATR(KRCIC+I-1) = CATR(KRCIC+I)
         CATD(KDCRV+I-1) = CATD(KDCRV+I)
         IPT = KHCTP+I*INC
         CALL H2CHR (8, 1, CATH(IPT), CTEMP)
         IPT = KHCTP+(I-1)*INC
         CALL CHR2H (8, CTEMP, 1, CATH(IPT))
 60      CONTINUE
      CATR(KRCRP+NAX) = 1.0
      CATR(KRCRT+NAX) = 0.0
      CATR(KRCIC+NAX) = 1.0
      CATD(KDCRV+NAX) = C1CRV
      IPT = KHCTP + NAX*INC
      CALL CHR2H (8, C1TYP, 1, CATH(IPT))
      DO 65 I = NAX,6
         CATBLK(KINAX+I) = 1
 65      CONTINUE
      CATD(KDCRV+J-1) = DEFREQ
C                                       creates
      CALL H2CHR (8, 1, CATOH(KHBUN), CTEMP)
      CUNITS(2) = CTEMP
      CUNITS(3) = CTEMP
      CUNITS(1) = 'SP COUNT'
      CUNITS(4) = 'SP INDEX'
      CUNITS(6) = 'CSPINDEX'
      CUNITS(5) = 'SP INDEX'
      CUNITS(7) = 'CSPINDEX'
      DO 90 IG = 1,ITYP
         CALL CHR2H (6, SEQTYP(IG), KHIMCO, CATH(KHIMC))
         CALL CHR2H (8, CUNITS(IG), 1, CATH(KHBUN))
C                                       Create
         DISKO = XDISKO + 0.01
         NEWCNO = 1
         CALL MCREAT (DISKO, NEWCNO, SCRTCH, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1075) IERR, SEQTYP(IG)
            GO TO 990
            END IF
C                                       Record the creation
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKO
         FCNO(NCFILE) = NEWCNO
         FRW(NCFILE) = 2
         SEQOUT = CATBLK(KIIMS)
C                                       copy most keywords
         CALL KEYPCP (DISKIN, OLDCNO, DISKO, NEWCNO, 0, ' ', IERR)
 90      CONTINUE
      IRET = 0
C                                       get frequencies
      NAX = CATOLD(KINAX)
      IF (NAX.GT.MAXFQ) THEN
         MSGTXT = 'I CAN ONLY HANDLE 16384 FREQUENCIES'
         IERR = 10
         GO TO 990
         END IF
      CALL H2CHR (8, 1, CATOH(KHCTP), OTYPE)
      IF (OTYPE(:4).EQ.'FREQ') THEN
         DO 110 I = 1,MIN(NAX,MAXFQ)
            XFREQ(I) = FV + FI * (I - FR)
            XFREQ(I) = LOG10 (XFREQ(I)/DEFREQ)
 110        CONTINUE
      ELSE IF (OTYPE.EQ.'SEQ.NUM.') THEN
         CALL HIGET (DISKIN, OLDCNO, NAX, DEFREQ, XFREQ, IRET)
      ELSE
         C1CRV = CATOD(KDCRV)
         C1CRP = CATOR(KRCRP)
         C1CIC = CATOR(KRCIC)
         CALL FQGET (DISKIN, OLDCNO, NAX, FV, C1CRV, C1CRP, C1CIC,
     *      CATOLD, DEFREQ, XFREQ, IRET)
         END IF
C                                       correct XFREQ for BLC(1)
      IPT = BLC(1) + 0.1
      IF (IPT.GT.1) THEN
         IPT = IPT - 1
         IG = TRC(1) - BLC(1) + 1.01
         DO 120 I = 1,IG
            XFREQ(I) = XFREQ(I+IPT)
 120        CONTINUE
         END IF
C                                       set DPARM defaults
      IF (DPARM(1).LT.0.0) DPARM(1) = 0
      IF (DPARM(2).EQ.0.0) DPARM(2) = -1.E8
      IF (DPARM(3).EQ.0.0) DPARM(3) = 1.E8
      IF (DPARM(4).LT.0.0) DPARM(4) = 0
      IF (DPARM(5).EQ.0.0) DPARM(5) = 1.E8
      IF (DPARM(6).LT.0.0) DPARM(6) = 0
      IF (DPARM(7).EQ.0.0) DPARM(7) = 1.E8
      IF (DPARM(8).EQ.0.0) DPARM(8) = -1.E8
      IF (DPARM(9).EQ.0.0) DPARM(9) = 1.E8
      DPARM(10) = 0.0
      IF (CPARM(1).LE.0.0) CPARM(1) = 1.E8
      IF (CPARM(2).LE.0.0) CPARM(2) = 1.E8
      IF (CPARM(3).LE.0.0) CPARM(3) = 1.E8
      NGOOD = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPIXIN: ERROR',I3,' ON ',A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I2,' USID=',I5)
 1075 FORMAT ('ERROR',I5,' CREATING FILE TYPE ',A6)
      END
      SUBROUTINE FQGET (DISK, CNO, NF, FV, CV, CP, CI, CATBLK, DEFREQ,
     *   XFREQ, IRET)
C-----------------------------------------------------------------------
C   Gets the frequencies from the FQ table
C   Inputs:
C      DISK     I        disk
C      CNO      I        calatog number
C      NF       I        Number of frequencies
C      FV       D        Header ref frequency
C      CV       D        FQID axis ref value
C      CP       D        FQID axis ref pixel
C      CI       D        FQID axis increment
C      CATBLK   I(256)   old image header
C      DEFREQ   D        ref freq
C   Outputs:
C      XFREQ    D(*)     LOG10(freq/FV)
C      IERR     I        Error code
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, NF, CATBLK(*), IRET
      DOUBLE PRECISION FV, CV, DEFREQ, XFREQ(*)
      REAL      CP, CI
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   BUFFER(512), VER, LUN, IFQRNO, FQKOLS(MAXFQC),
     *   FQNUMV(MAXFQC), NUMIF, FQID, IFSIDE, IREC, NREC, I, MF
      DOUBLE PRECISION IFFREQ
      REAL      IFCHW, IFTBW
      CHARACTER BNDCOD*8
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       open
      VER = 1
      LUN = 20
      NUMIF = 1
      CALL FQINI ('READ', BUFFER, DISK, CNO, VER, CATBLK, LUN, IFQRNO,
     *   FQKOLS, FQNUMV, NUMIF, IRET)
      IF (IRET.NE.0) GO TO 999
      NREC = BUFFER(5)
C                                       read
      DO 10 IREC = 1,NREC
         CALL TABFQ ('READ', BUFFER, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *      FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IRET)
         IF (IRET.NE.0) GO TO 20
         I = (FQID - CV) / CI + CP + 0.5
         IF ((I.GE.1) .AND. (I.LE.NF)) XFREQ(I) = IFFREQ + FV
 10      CONTINUE
 20   CALL TABFQ ('CLOS', BUFFER, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *   FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IREC)
C                                       test
      MF = NF
      DO 30 I = 1,NF
         IF (XFREQ(I).GT.0.0D0) THEN
            MF = MF - 1
            XFREQ(I) = LOG10 (XFREQ(I)/DEFREQ)
            END IF
 30      CONTINUE
      IF (IRET.LE.0) IRET = -MF
      IF (MF.GT.0) THEN
         WRITE (MSGTXT,1030) MF
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('WARNING:',I3,' FREQUENCY PLANES NOT FOUND IN FQ FILE')
      END
      SUBROUTINE HIGET (DISK, CNO, NF, DEFREQ, XFREQ, IRET)
C-----------------------------------------------------------------------
C   HIGET tries to get the frequencies from the history file
C   Inputs:
C      DISK    I      Disk number
C      CNO     I      Catalog number
C      NF      I      Number of frequencies
C   Output
C      XFREQ   D(*)   Frequencies
C      IRET    I      Error code
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, NF, IRET
      DOUBLE PRECISION DEFREQ, XFREQ(*)
C
      INTEGER   IHLUN, NREC, IHPTR, HIBUFF(256), IBLK, ICARD, IP, MF,
     *   ICUR, IHIND, II
      CHARACTER LINE*72, CTYP*8
      DOUBLE PRECISION X
      REAL      HRBUFF(256)
      EQUIVALENCE (HIBUFF, HRBUFF)
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      MF = 0
      CALL DFILL (NF, 0.0D0, XFREQ)
C                                       open history file
      IHLUN = 27
C                                       Open history file.
      CALL HIINIT (3)
      CALL HIOPEN (IHLUN, DISK, CNO, HIBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL HILOCT ('SRCH', IHLUN, IHPTR, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       Determine no. of hist. recs.
      NREC = HITAB(IHPTR+2)
      IHIND = HITAB(IHPTR+1)
      IBLK = 0
      ICARD = NHILPR
      DO 20 ICUR = 1,NREC
C                                       Read next buffer.
         ICARD = ICARD + 1
         IF (ICARD.GT.NHILPR) THEN
            IBLK = IBLK + 1
            ICARD = 1
            CALL ZFIO ('READ', IHLUN, IHIND, IBLK, HIBUFF, IRET)
            IF (IRET.NE.0) GO TO 100
            END IF
C                                       desired task?
         II = (ICARD-1) * NHIWPL + 5
         CALL H2CHR (72, 1, HRBUFF(II), LINE)
         IF (LINE(:12).EQ.'MCUBE COORD=') THEN
            READ (LINE,1000) X, CTYP, IP
C                                       test
            IF ((CTYP(:4).EQ.'FREQ') .AND. (IP.GT.0) .AND. (IP.LE.NF))
     *         THEN
               XFREQ(IP) = X
               MF = MF + 1
               WRITE (MSGTXT,1001) CTYP, X, IP
               CALL MSGWRT (3)
            ELSE
               WRITE (MSGTXT,1010) X, CTYP, IP
               CALL MSGWRT (7)
               END IF
            END IF
 20      CONTINUE
C                                       Close history file.
 100  CALL HICLOS (IHLUN, .FALSE., HIBUFF, II)
C                                       fill it all in??
      MF = NF
      DO 110 II = 1,NF
         IF (XFREQ(II).GT.0.0D0) THEN
            MF = MF - 1
            XFREQ(II) = LOG10 (XFREQ(II)/DEFREQ)
            END IF
 110     CONTINUE
      IF (IRET.LE.0) IRET = -MF
      IF (MF.GT.0) THEN
         WRITE (MSGTXT,1110) MF
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (12X,E13.5,5X,13X,A8,11X,I5)
 1001 FORMAT ('Found in MCUBE history ',A8,' F=',1PE13.5,' plane',I5)
 1010 FORMAT ('Coordinate mismatch',1PE13.5,' ''',A8,''' plane',I5)
 1110 FORMAT ('WARNING:',I3,
     *   ' FREQUENCY PLANES NOT FOUND IN HISTORY FILE')
      END
      SUBROUTINE SPIXDO (TBLNKD, NX, NY, NZ, ITYP, IMAGE, ANSW, IRET)
C-----------------------------------------------------------------------
C   SPIXDO sends image one row at a time to the moment fitting
C   routine and then saves the answers
C   Inputs
C      NX       I      # X pixels
C      NY       I      # Y pixels
C      NZ       I      # spectral channels
C      ITYP     I      # answers (5 or 7)
C   Output:
C      IMAGE    R(*)   Input data image
C      ANSW     R(*)   Answer images
C      TBLNKD   L      Answers contain blanked pixels?
C      IRET     I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      LOGICAL   TBLNKD
      INTEGER   NX, NY, NZ, ITYP, IRET
      REAL      IMAGE(NZ,NX,NY), ANSW(NX,NY,ITYP)
C
      CHARACTER IFILE*48
      INTEGER   IROUND, LUNI, NYI, NXI, WINI(4), BOI, LIM2, LIM3, LIM4,
     *   LIM5, LIM6, LIM7, I1, I2, I3, I4, I5, I6, I7, IPOS(7), CORN(7),
     *   BOTEMP, IBIND, INDI, LIM1, JBUFS3
      LOGICAL   T, F
      INCLUDE 'TVSPX.INC'
      REAL      ANSWER(7)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI /16/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      JBUFS3 = 2 * MABFSS
C                                       Open and init for read
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT IMAGE'
         GO TO 990
         END IF
C                                       Setup for I/O
C                                       remember names switched
      NXI = CATOLD(KINAX)
      NYI = CATOLD(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
      CORN(7) = 1
      TBLNKD = .FALSE.
      IF (LIM4+LIM5+LIM6+LIM7.GT.4) THEN
         MSGTXT = 'IMAGE HAS TOO MANY REAL AXES'
         IRET = 10
         GO TO 990
         END IF
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         CORN(7) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            CORN(6) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               CORN(5) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  CORN(4) = I4
                  DO 300 I3 = 1,LIM3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     CORN(3) = I3
C                                       Init. files, first input.
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SET I/O OFFSET'
            GO TO 990
            END IF
         BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT READ OF IMAGE'
            GO TO 990
            END IF
         DO 250 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
C                                       Read.
            CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING INPUT IMAGE'
               GO TO 990
               END IF
C                                       Copy to memory
            CALL RCOPY (LIM1, BUFF1(IBIND), IMAGE(1,I2,I3))
C                                       Call DO1SPX
            IF (OPTYPE.NE.'CURV') THEN
               CALL DO1SPX (IPOS, BUFF1(IBIND), ANSWER)
            ELSE
               CALL DO2SPX (IPOS, BUFF1(IBIND), ANSWER)
               END IF
C                                       Check blanking, save answer
            DO 215 I1 = 1,ITYP
               ANSW(I2,I3,I1) = ANSWER(I1)
               IF (ANSW(I2,I3,I1).EQ.FBLANK) TBLNKD = .TRUE.
 215           CONTINUE
 250        CONTINUE
C                                       Flush buffers.
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPIXDO: ERROR',I3,' ON ',a)
      END
      SUBROUTINE SPIHED (IRET)
C-----------------------------------------------------------------------
C   SPIHED modifies the new image header for the subimaging and for
C   replacing the first axis with Gaussian components.
C   Input:
C      CATBLK(256)    I     Output catalog header, also CATR, CATD,
C                           CATH
C      CATOLD(256)    I     Input catalog header, also CATOR, CATOD,
C                           CATOH
C   Output:
C      CATBLK(256)    I     Modified output catalog header.
C      IRET           I     Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER CHTM12*12
      INCLUDE 'TVSPX.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Set axes in output CATBLK.
      CALL SUBHDR (BLC, TRC, 1.0, 1.0)
C                                       Check input axes
      CALL H2CHR (8, 1, CATH(KHCTP), CHTM12)
      IF ((CHTM12(:4).NE.'FREQ') .AND. (CHTM12(:8).NE.'SEQ.NUM.') .AND.
     *   (CHTM12(:8).NE.'FQID')) THEN
         MSGTXT = 'FIRST AXIS NOT FREQUENCY, FQID, OR SEQ.NUM.'
         CALL MSGWRT (8)
         IRET = 8
         END IF
C
 999  RETURN
      END
      SUBROUTINE DO1SPX (IPOS, IDATA, RESULT)
C-----------------------------------------------------------------------
C   DO1SPX fits spectral index to a row of an image and returns the
C   answers in RESULT.
C   Inputs:
C      IPOS(7)   I      BLC (input image) of first value in DATA
C      IDATA     R(*)   Input data (floated and scaled)
C   Values from commons:
C      FCUT      R      Flux cutoff
C      FBLANK    R      Value of blanked pixel.
C      CATOLD    I      Input catalog header (also CATOR, CATOD)
C   Output:
C     RESULT(*) R      Output row (count, br, br err, spix sp err,...)
C      IRET      I      Return code   0 => OK
C                               >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   IPOS(7)
      REAL      IDATA(*), RESULT(*)
C
      INTEGER   INPTS, I, IRET
      REAL      LFCUT, V , TMIN, TMAX
      DOUBLE PRECISION X, Y, SXX, SX, SY, SXY, SN, DET, VM, VB, SDD
      LOGICAL   FAIL
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'TVSPX.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Not last call
      IF (IPOS(1).GE.0) THEN
         LFCUT = FCUT
         LFCUT = MAX (1.E-10, LFCUT)
         INPTS = TRC(1) - BLC(1) + 1.01
         SXX = 0.0
         SX  = 0.0
         SXY = 0.0
         SY  = 0.0
         SN  = 0.0
         TMIN = 1.E8
         TMAX = -TMIN
         DO 20 I = 1,INPTS
            V = IDATA(I)
            IF ((V.GT.0.0) .AND. (V.NE.FBLANK)) THEN
               IF (PBPARM(1).GT.0.0) THEN
                  CALL SPIXPB (I, IPOS, LFCUT, IRET)
                  IF (IRET.NE.0) GO TO 20
                  END IF
               IF (V.GE.LFCUT) THEN
                  TMIN = MIN (TMIN, V)
                  TMAX = MAX (TMAX, V)
                  Y = LOG10 (V)
                  X = XFREQ(I)
                  SX = SX + X
                  SY = SY + Y
                  SXX = SXX + X * X
                  SXY = SXY + X * Y
                  SN = SN + 1.0
                  END IF
               END IF
 20         CONTINUE
         IRET = 0
         DET = SN * SXX - SX * SX
         FAIL = (DET.LE.0.0) .OR. (SN.LE.1.5)
         IF (.NOT.FAIL) THEN
            VB = (SXX * SY - SX * SXY) / DET
            VM = (SN * SXY - SX * SY) / DET
C                                       find overall sigma**2
            SDD = 0.0
            DO 30 I = 1,INPTS
               Y = IDATA(I)
               IF ((Y.GT.0.0) .AND. (Y.NE.FBLANK)) THEN
                  IF (PBPARM(1).GT.0.0) THEN
                     CALL SPIXPB (I, IPOS, LFCUT, IRET)
                     IF (IRET.NE.0) GO TO 30
                     END IF
                  IF (Y.GE.LFCUT) THEN
                     Y = LOG10 (Y)
                     X = XFREQ(I)
                     SDD = SDD + (VM * X + VB - Y)**2
                     END IF
                  END IF
 30            CONTINUE
            IRET = 0
            SDD = SDD / SN
            RESULT(2) = VB
            RESULT(4) = VM
            RESULT(1) = SN
            RESULT(3) = SQRT (SDD * SXX / DET)
            RESULT(5) = SQRT (SN * SDD / DET)
            RESULT(6) = 0.0
            RESULT(7) = 0.0
C                                       but want T not log T
            RESULT(2) = 10.0 ** (RESULT(2))
            RESULT(3) = RESULT(2) * RESULT(3)
C                                       test results
            IF (RESULT(1).LT.DPARM(1)) FAIL = .TRUE.
            IF (RESULT(4).LT.DPARM(2)) FAIL = .TRUE.
            IF (RESULT(4).GT.DPARM(3)) FAIL = .TRUE.
            IF (TMIN.GT.0.0) THEN
               IF (RESULT(2)/TMIN.LT.DPARM(4)) FAIL = .TRUE.
               END IF
            IF (RESULT(2)/TMAX.GT.DPARM(5)) FAIL = .TRUE.
            IF (RESULT(2).LT.DPARM(6)) FAIL = .TRUE.
            IF (RESULT(2).GT.DPARM(7)) FAIL = .TRUE.
            IF (RESULT(3).GT.CPARM(1)) FAIL = .TRUE.
            IF (RESULT(5).GT.CPARM(2)) FAIL = .TRUE.
            IF (FAIL) DPARM(10) = DPARM(10) + 1.0
            END IF
C                                       Max / Min
         IF (.NOT.FAIL) THEN
            NGOOD = NGOOD + 1
            DO 40 I = 1,7
               PMAX(I) = MAX (PMAX(I), RESULT(I))
               PMIN(I) = MIN (PMIN(I), RESULT(I))
 40            CONTINUE
         ELSE
            CALL RFILL (5, FBLANK, RESULT)
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE DO2SPX (IPOS, IDATA, RESULT)
C-----------------------------------------------------------------------
C   DO2SPX fits spectral index plus curvature to a row of an image and
C   returns the answers in RESULT.
C   Inputs:
C      IPOS(7)   I      BLC (input image) of first value in DATA
C      IDATA     R(*)   Input data (floated and scaled)
C   Values from commons:
C      FCUT      R      Flux cutoff
C      FBLANK    R      Value of blanked pixel.
C      CATOLD    I      Input catalog header (also CATOR, CATOD)
C   Output:
C      RESULT(*) R      Output row (count, 4 moments)
C      IRET      I      Return code   0 => OK
C                               >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   IPOS(7)
      REAL      IDATA(*), RESULT(*)
C
      INTEGER   INPTS, I, IRET
      REAL      LFCUT, V, TMAX, TMIN
      DOUBLE PRECISION X, Y, SXXXX, SXXX, SXX, SX, SY, SXY, SXXY, SN,
     *   DET, VM, VB, VC, SDD, AB, AC, AM, BB, BC, BM, CB, CC, CM
      LOGICAL   FAIL
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'TVSPX.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Not last call
      IF (IPOS(1).GE.0) THEN
         LFCUT = FCUT
         LFCUT = MAX (1.E-10, LFCUT)
         INPTS = TRC(1) - BLC(1) + 1.01
         SXXXX = 0.0
         SXXX = 0.0
         SXX = 0.0
         SX = 0.0
         SXXY = 0.0
         SXY = 0.0
         SY = 0.0
         SN = 0.0
         TMIN = 1.E8
         TMAX = -TMIN
         DO 20 I = 1,INPTS
            V = IDATA(I)
            IF ((V.GT.0.0) .AND. (V.NE.FBLANK)) THEN
               IF (PBPARM(1).GT.0.0) THEN
                  CALL SPIXPB (I, IPOS, LFCUT, IRET)
                  IF (IRET.NE.0) GO TO 20
                  END IF
               IF (V.GE.LFCUT) THEN
                  TMIN = MIN (TMIN, V)
                  TMAX = MAX (TMAX, V)
                  Y = LOG10 (V)
                  X = XFREQ(I)
                  SX = SX + X
                  SY = SY + Y
                  SXX   = SXX + X * X
                  SXXXX = SXXXX + X * X * X * X
                  SXXX  = SXXX + X * X * X
                  SXXY = SXXY + X * X * Y
                  SXY = SXY + X * Y
                  SN = SN + 1.0
                  END IF
               END IF
 20         CONTINUE
         IRET = 0
         DET = SN*SXXXX*SXX - SXXXX*SX*SX - SN*SXXX*SXXX +
     *      2.0*SXXX*SXX*SX  - SXX*SXX*SXX
         FAIL = (DET.LE.0.0) .OR. (SN.LE.2.5)
         IF (.NOT.FAIL) THEN
C                                       const (log brightness)
            AB = (SXXX*SX - SXX*SXX) / DET
            BB = (SXXX*SXX - SXXXX*SX) / DET
            CB = (SXXXX*SXX - SXXX*SXXX) / DET
            VB = (SXXY * AB + SXY * BB + SY * CB)
C                                       slope (spectral index)
            AM = (SXX*SX - SN*SXXX) / DET
            BM = (SN*SXXXX - SXX*SXX) / DET
            CM = (SXXX*SXX - SXXXX*SX) / DET
            VM = (SXXY * AM + SXY * BM + SY * CM)
C                                       curvature
            AC = (SN*SXX - SX*SX) / DET
            BC = (SXX*SX - SN*SXXX) / DET
            CC = (SXXX*SX - SXX*SXX) / DET
            VC = (SXXY * AC + SXY * BC + SY * CC)
C                                       find overall sigma**2
            SDD = 0.0
            DO 30 I = 1,INPTS
               Y = IDATA(I)
               IF ((Y.GT.0.0) .AND. (Y.NE.FBLANK)) THEN
                  IF (PBPARM(1).GT.0.0) THEN
                     CALL SPIXPB (I, IPOS, LFCUT, IRET)
                     IF (IRET.NE.0) GO TO 30
                     END IF
                  IF (Y.GE.LFCUT) THEN
                     Y = LOG10 (Y)
                     X = XFREQ(I)
                     SDD = SDD + (VC * X * X + VM * X + VB - Y)**2
                     END IF
                  END IF
 30            CONTINUE
            IRET = 0
            SDD = SDD / SN
            RESULT(2) = VB
            RESULT(4) = VM
            RESULT(1) = SN
            RESULT(6) = VC
C                                       error bars
            X = AB * AB * SXXXX + BB * BB * SXX + CB * CB +
     *         2. * (AB*BB*SXXX + AB*CB*SXX + BB*CB*SX)
            X = ABS (X)
            RESULT(3) = SQRT (SDD * X)
            X = AM * AM * SXXXX + BM * BM * SXX + CM * CM +
     *         2. * (AM*BM*SXXX + AM*CM*SXX + BM*CM*SX)
            X = ABS (X)
            RESULT(5) = SQRT (SDD * X)
            X = AC * AC * SXXXX + BC * BC * SXX + CC * CC +
     *         2. * (AC*BC*SXXX + AC*CC*SXX + BC*CC*SX)
            X = ABS (X)
            RESULT(7) = SQRT (SDD * X)
C                                       but want T not log T
            RESULT(2) = 10.0 ** (RESULT(2))
            RESULT(3) = RESULT(2) * RESULT(3)
C                                       test results
            IF (RESULT(1).LT.DPARM(1)) FAIL = .TRUE.
            IF (RESULT(4).LT.DPARM(2)) FAIL = .TRUE.
            IF (RESULT(4).GT.DPARM(3)) FAIL = .TRUE.
            IF (TMIN.GT.0.0) THEN
               IF (RESULT(2)/TMIN.LT.DPARM(4)) FAIL = .TRUE.
               END IF
            IF (RESULT(2)/TMAX.GT.DPARM(5)) FAIL = .TRUE.
            IF (RESULT(2).LT.DPARM(6)) FAIL = .TRUE.
            IF (RESULT(2).GT.DPARM(7)) FAIL = .TRUE.
            IF (RESULT(6).LT.DPARM(8)) FAIL = .TRUE.
            IF (RESULT(6).GT.DPARM(9)) FAIL = .TRUE.
            IF (RESULT(3).GT.CPARM(1)) FAIL = .TRUE.
            IF (RESULT(5).GT.CPARM(2)) FAIL = .TRUE.
            IF (RESULT(7).GT.CPARM(3)) FAIL = .TRUE.
            IF (FAIL) DPARM(10) = DPARM(10) + 1.0
            END IF
C                                       Max / Min
         IF (.NOT.FAIL) THEN
            NGOOD = NGOOD + 1
            DO 40 I = 1,7
               PMAX(I) = MAX (PMAX(I), RESULT(I))
               PMIN(I) = MIN (PMIN(I), RESULT(I))
 40            CONTINUE
         ELSE
            CALL RFILL (7, FBLANK, RESULT)
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE SPIXPB (IX, IPOS, FCC, IRET)
C-----------------------------------------------------------------------
C   SPIXPB computes the primary beam correction at the current pixel and
C   adjusts FCUT and ICUT for it.
C   Inputs:
C      IX     I      X pixel position
C      IPOS   I(7)   ?,Y,Z,... pixels
C   Output:
C      FCC    R      FCUT adjusted
C      IRET   I      0 - okay, 1 outside the usable beam
C-----------------------------------------------------------------------
      INTEGER   IX, IPOS(*), IRET
      REAL      FCC
C
      INTEGER   LPOS(7), LF, LR, LD, CATSAV(256), LY
      DOUBLE PRECISION DX, DY, DT, X, Y, LAMBDA, ANGLE
      REAL      PBCORF
      CHARACTER ARRAY*8
      LOGICAL   OUTSID
      INCLUDE 'TVSPX.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:PSTD.INC'
      SAVE LF, LR, LD, LY, LAMBDA, ANGLE
      DATA LF, LR, LD, LY /3*0,300000/
C-----------------------------------------------------------------------
      CALL COPY (6, IPOS(2), LPOS(2))
      LPOS(1) = IX
      IRET = 0
      CALL H2CHR (8, 1, CATH(KHTEL), ARRAY)
C                                       init common each plane
      IF (LPOS(2).LT.LY) THEN
        CALL COPY (256, CATBLK, CATSAV)
        LOCNUM = 1
        CALL COPY (256, CATOLD, CATBLK)
        CALL SETLOC (LPOS(3), .FALSE.)
        END IF
      LY = LPOS(2)
C                                       new frequency
      IF (LF.NE.LPOS(1)) THEN
         LF = LPOS(1)
         LAMBDA = XFREQ(LF) + 9.0D0
         LAMBDA = 10.0D0**(LAMBDA)
         LAMBDA = VELITE / LAMBDA
         END IF
C                                       new coordinate
      IF ((LD.NE.LPOS(DAX)) .OR. (LR.NE.LPOS(RAX))) THEN
         DX = (LPOS(RAX) - RR) * RI
         DY = (LPOS(DAX) - DR) * DI
         DT = DX * COS (MROT) - DY * SIN (MROT)
         DY = DY * COS (MROT) + DX * SIN (MROT)
         DX = DT
         CALL NEWPOS (AXFUNC(KLOCL(LOCNUM)+1,LOCNUM), RA0, DE0, DX, DY,
     *      X, Y, IRET)
         IF (IRET.NE.0) THEN
            LD = -10
            GO TO 999
            END IF
         DT = SIN (DE0) * SIN (Y) + COS (DE0) * COS (Y) * COS (RA0-X)
         DT = MIN (1.0D0, DT)
         DT = MAX (-1.0D0, DT)
         ANGLE = RAD2DG * ACOS (DT)
         LD = LPOS(DAX)
         LR = LPOS(RAX)
         END IF
C                                       primary beam
      CALL PBCALC (ANGLE, LAMBDA, ARRAY, PBPARM(2), PBCORF, OUTSID)
      IF ((OUTSID) .OR. (PBCORF.LE.0.0) .OR. (PBCORF.LT.PBPARM(1))) THEN
         IRET = 1
      ELSE
         FCC = FCUT / PBCORF
         END IF
C
 999  RETURN
      END
      SUBROUTINE SPIXTV (TBLNKD, NX, NY, NZ, ITYP, IMAGE, ANSW, IRET)
C-----------------------------------------------------------------------
C   SPIXTV interacts with user and answer images
C   Inputs
C      NX       I      # X pixels
C      NY       I      # Y pixels
C      NZ       I      # spectral channels
C      ITYP     I      # answers (5 or 7)
C      IMAGE    R(*)   Input data image
C      TBLNKD   L      Answers contain blanked pixels?
C   In/output:
C      ANSW     R(*)   Answer images
C   Output:
C      IRET     I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      LOGICAL   TBLNKD
      INTEGER   NX, NY, NZ, ITYP, IRET
      REAL      IMAGE(NZ,NX,NY), ANSW(NX,NY,ITYP)
C
      INTEGER   I, J, I1, I2, MTYPE, MCOL, MROWS(2), GRCHS(2), TIMLIM,
     *   CHS, TVBUT, TOPSEP, SIDSEP, NTITL, IPOS(2), CATEMP(256), IC,
     *   ICOLOR, IG, II, IP, JJ, LSTIMG, NLEVS, JTRIM, DOCHAR
      CHARACTER CHOIC1(9)*16, CHOICD(14)*16, CHOICS(40)*16, ROUTIN*6,
     *   IMGTYP(7)*3, ISHELP*6, TITLE(3)*128, MSGBUF*72
      REAL      RANGE(2,3), ERROR(3), SLOPE
      LOGICAL   LEAVE(30), DOIT, IMGOK
      DOUBLE PRECISION XX(2)
      INCLUDE 'TVSPX.INC'
      INCLUDE 'TVSPX.TV'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA CHOIC1 /'EXIT', 'ABORT', ' ', 'SET BRIGHT RANGE',
     *   'SET SPIX RANGE', 'SET CURV RANGE', 'SET MAX ERR BR',
     *   'SET MAX ERR SPIX', 'SET MAX ERR CURV'/
      DATA CHOICD /' ', 'REDO ALL', 'FLAG ALL', ' ', 'ADD TO LIST',
     *   'CLEAR LIST', 'SHOW LIST', 'REDO LIST', 'FLAG LIST', ' ',
     *   'OFF ZOOM', 'OFF TRANSFER', 'RESET WINDOW', 'LABEL WEDGE?'/
      DATA IMGTYP /'NP', 'BR', 'EBR', 'SP', 'ESP', 'CU', 'ECU'/
      DATA LEAVE /.FALSE., 29*.TRUE./
C-----------------------------------------------------------------------
      CALL FILL (3, 0, SVZOOM)
      CALL TVOPEN (SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING TV DISPLAY'
         GO TO 990
         END IF
      CALL YINIT (BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT THE TV DISPLAY'
         GO TO 990
         END IF
      LABWED = .FALSE.
      IMGOK = .FALSE.
      SUBWIN(1) = 1
      SUBWIN(2) = 1
      SUBWIN(3) = NX
      SUBWIN(4) = NY
      DOCHAR = SQRT ((MAXXTV(1)/1024.0)*(MAXXTV(2)/1024.0)) + 0.5
      IF (DOCHAR.LE.1) DOCHAR = CSIZTV(1) / 7
      IF (DOCHAR.EQ.1) DOCHAR = 0
C                                       prepare menu
      J = 9
      DO 10 I = 1,9
         CHOICS(I) = CHOIC1(I)
 10      CONTINUE
      IF (ITYP.LT.7) THEN
         CHOICS(6) = CHOIC1(7)
         CHOICS(7) = CHOIC1(8)
         J = 7
         END IF
      DO 15 I = 1,14
         J = J + 1
         CHOICS(J) = CHOICD(I)
 15      CONTINUE
      IF (DOCHAR.GT.0) THEN
         J = J + 1
         CHOICS(J) = 'CHAR MULT'
         END IF
      MROWS(1) = J
      MROWS(2) = ITYP
      DO 20 I = 1,ITYP
         FUNCTY(I) = ' '
         J = J + 1
         CHOICS(J) = 'SHOW IMAGE ' // IMGTYP(I)
 20   CONTINUE
      MTYPE = -1
      MCOL = 2
C                                       turn on graphics
      IGR1 = 1 + NGRAY
      IGR2 = 2 + NGRAY
      IGR3 = 3 + NGRAY
      IGR4 = 4 + NGRAY
      IGR5 = 5 + NGRAY
      IGR7 = 7 + NGRAY
      ROUTIN = 'YSLECT'
      CALL YSLECT ('ONNN', IGR1, 0, IBUFF1, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL YSLECT ('ONNN', IGR2, 0, IBUFF1, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL YSLECT ('ONNN', IGR3, 0, IBUFF1, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL YSLECT ('ONNN', IGR4, 0, IBUFF1, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL RFILL (6, 0.0, RANGE)
      CALL RFILL (3, 0.0, ERROR)
      IF (TTYIND.LE.0) THEN
         TTYLUN = 5
         CALL ZOPEN (TTYLUN, TTYIND, 1, MSGBUF, .FALSE., .TRUE., .TRUE.,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN TTY FOR INPUTS'
            TTYIND = 0
            GO TO 990
            END IF
         END IF
      GRCHS(1) = 2
      GRCHS(2) = 1
      TOPSEP = 3
      SIDSEP = 10
      ISHELP = TSKNAM
      TIMLIM = 0
      NTITL = 3
      IF (ITYP.LT.7) NTITL = 2
C                                       (re)set robust
 30   CONTINUE
      DO 40 I = 1,ITYP
         CALL TVSTAT (' ', NX, NY, ANSW(1,1,I), SUBWIN, ROBUST(1,I))
 40      CONTINUE
C                                       title lines
 50   WRITE (TITLE(1),1050) RANGE(1,1), RANGE(2,1), ERROR(1)
      WRITE (TITLE(2),1051) RANGE(1,2), RANGE(2,2), ERROR(2)
      WRITE (TITLE(3),1052) RANGE(1,3), RANGE(2,3), ERROR(3)
      CALL TVMENU (MTYPE, MCOL, MROWS, GRCHS, TOPSEP, SIDSEP, ISHELP,
     *   CHOICS, TIMLIM, LEAVE, NTITL, TITLE, CHS, TVBUT, IBUFF2, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'RETURNED FROM TVMENU'
         GO TO 990
         END IF
C                                       case statement
C                                       exit
      IF (CHOICS(CHS).EQ.'EXIT') THEN
         MSGTXT = 'Bye-bye'
         CALL MSGWRT (2)
         GO TO 990
      ELSE IF (CHOICS(CHS).EQ.'ABORT') THEN
         MSGTXT = 'Bye-bye and delete output files'
         CALL MSGWRT (2)
         IRET = 10
         GO TO 990
C                                       blank
      ELSE IF (CHOICS(CHS).EQ.' ') THEN
C                                       brightness range
      ELSE IF (CHOICS(CHS).EQ.'SET BRIGHT RANGE') THEN
         MSGBUF = 'Enter brightness range, 0 0 for self-scale'
         CALL INQFLN (TTYLUN, MSGBUF, 2, XX, JJ, IRET)
         IF (IRET.EQ.0) THEN
            RANGE(1,1) = XX(1)
            RANGE(2,1) = XX(2)
            END IF
C                                       spectral index range
      ELSE IF (CHOICS(CHS).EQ.'SET SPIX RANGE') THEN
         MSGBUF = 'Enter spectral index range, 0 0 for self-scale'
         CALL INQFLN (TTYLUN, MSGBUF, 2, XX, JJ, IRET)
         IF (IRET.EQ.0) THEN
            RANGE(1,2) = XX(1)
            RANGE(2,2) = XX(2)
            END IF
C                                       curvature range
      ELSE IF (CHOICS(CHS).EQ.'SET CURV RANGE') THEN
         MSGBUF = 'Enter spectral curvature range, 0 0 for self-scale'
         CALL INQFLN (TTYLUN, MSGBUF, 2, XX, JJ, IRET)
         IF (IRET.EQ.0) THEN
            RANGE(1,3) = XX(1)
            RANGE(2,3) = XX(2)
            END IF
C                                       max brightness rms
      ELSE IF (CHOICS(CHS).EQ.'SET MAX ERR BR') THEN
         MSGBUF = 'Enter maximum error in brightness'
         CALL INQFLT (TTYLUN, MSGBUF, 1, XX, IRET)
         IF (IRET.EQ.0) ERROR(1) = XX(1)
C                                       max spectral index rms
      ELSE IF (CHOICS(CHS).EQ.'SET MAX ERR SPIX') THEN
         MSGBUF = 'Enter maximum error in spectral index'
         CALL INQFLT (TTYLUN, MSGBUF, 1, XX, IRET)
         IF (IRET.EQ.0) ERROR(2) = XX(1)
C                                       max curvature rms
      ELSE IF (CHOICS(CHS).EQ.'SET MAX ERR CURV') THEN
         MSGBUF = 'Enter maximum error in spectral curvature'
         CALL INQFLT (TTYLUN, MSGBUF, 1, XX, IRET)
         IF (IRET.EQ.0) ERROR(3) = XX(1)
C                                       redo all
      ELSE IF (CHOICS(CHS).EQ.'REDO ALL') THEN
         DOIT = .FALSE.
         DO 58 IG = 1,3
            IF (ERROR(IG).GT.0.0) DOIT = .TRUE.
            IF (RANGE(1,IG).NE.RANGE(2,IG)) DOIT = .TRUE.
 58         CONTINUE
         IF (.NOT.DOIT) THEN
            MSGTXT = 'Allowed range and/or max error must be set'
            CALL MSGWRT (6)
         ELSE
            CALL YZERO (IGR5, IRET)
            CALL YZERO (1, IRET)
            CALL COPY (256, CATBLK, CATEMP)
            CALL COPY (256, CATOLD, CATBLK)
            CALL UPDALL ('REDO', RANGE, ERROR, NX, NY, NZ, ITYP, IMAGE,
     *         ANSW, IRET)
            CALL COPY (256, CATEMP, CATBLK)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'RE-DOING ALL'
               GO TO 990
               END IF
            GO TO 30
            END IF

C                                       flag all
      ELSE IF (CHOICS(CHS).EQ.'FLAG ALL') THEN
         DOIT = .FALSE.
         DO 59 IG = 1,3
            IF (ERROR(IG).GT.0.0) DOIT = .TRUE.
            IF (RANGE(1,IG).NE.RANGE(2,IG)) DOIT = .TRUE.
 59         CONTINUE
        IF (.NOT.DOIT) THEN
            MSGTXT = 'Allowed range and/or max error must be set'
            CALL MSGWRT (6)
         ELSE
            CALL YZERO (IGR5, IRET)
            CALL YZERO (1, IRET)
            CALL UPDALL ('FLAG', RANGE, ERROR,  NX, NY, NZ, ITYP, IMAGE,
     *         ANSW, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'FLAGGING ALL'
               GO TO 990
               END IF
            GO TO 30
            END IF
C                                       offzoom
      ELSE IF (CHOICS(CHS).EQ.'OFF ZOOM') THEN
         CALL FILL (3, 0, SVZOOM)
         TVZOOM(1) = 0
         TVZOOM(2) = MAXXTV(1) / 2
         TVZOOM(3) = MAXXTV(2) / 2
         CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), .TRUE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'TURNING OFF ZOOM'
            GO TO 990
            END IF
C                                       offtr
      ELSE IF (CHOICS(CHS).EQ.'OFF TRANSFER') THEN
         IC = 2 ** NGRAY - 1
         ICOLOR = 7
         NLEVS = MAXINT + 1
         SLOPE = REAL (LUTOUT) / REAL(MAXINT)
         DO 67 I = 1,NLEVS
            IBUFF1(I) = (I-1) * SLOPE + 0.5
 67         CONTINUE
         CALL YLUT ('WRIT', IC, ICOLOR, .FALSE., IBUFF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'TUNING OFF BLACK&WHITE TRANSFER'
            GO TO 990
            END IF
         I = OFMINP + 1
         ICOLOR = 7
         CALL RFILL (I, 0.0, BUFF1)
         NLEVS = LUTOUT + 1
         IF (NLEVS.GT.OFMINP) NLEVS = OFMINP + 1
         SLOPE = 1.0 / (NLEVS-1.0)
         DO 167 I = 1,NLEVS
            BUFF1(I) = (I-1) * SLOPE
 167        CONTINUE
         I = OFMINP + 1
         JJ = NLEVS
         I = I / NLEVS
         DO 267 II = 2,I
            CALL RCOPY (NLEVS, BUFF1, BUFF1(JJ+1))
            JJ = JJ + NLEVS
 267        CONTINUE
         CALL YOFM ('WRIT', ICOLOR, .FALSE., BUFF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'TUNING OFF PSEUDO-COLOR'
            GO TO 990
            END IF
C                                       reset window
      ELSE IF (CHOICS(CHS).EQ.'RESET WINDOW') THEN
         SUBWIN(1) = 1
         SUBWIN(2) = 1
         SUBWIN(3) = NX
         SUBWIN(4) = NY
         IP = LSTIMG
         IF (IP.GT.0) CALL SHOIMG (.TRUE., IP, NX, NY, ITYP, IGR5,
     *      ANSW, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SHOWING AN IMAGE'
            GO TO 990
         ELSE IF (IRET.LT.0) THEN
            IMGOK = .FALSE.
            IRET = 0
            END IF
C                                       label wedge
      ELSE IF (CHOICS(CHS).EQ.'LABEL WEDGE?') THEN
         LABWED = .NOT.LABWED
         IP = LSTIMG
         IF (IP.GT.0) CALL SHOIMG (.TRUE., IP, NX, NY, ITYP, IGR5,
     *      ANSW, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SHOWING AN IMAGE'
            GO TO 990
         ELSE IF (IRET.LT.0) THEN
            IMGOK = .FALSE.
            IRET = 0
            END IF
C                                       add to list
      ELSE IF (CHOICS(CHS).EQ.'ADD TO LIST') THEN
         IF (NLIST.GE.MAXLIS) THEN
            MSGTXT = 'LIST IS FULL'
            CALL MSGWRT (6)
         ELSE
            MSGBUF = 'Enter X and Y pixels to add to list: 2 integers'
            CALL INQINT (TTYLUN, MSGBUF, 2, IPOS, IRET)
            IF (IRET.NE.0) GO TO 50
            IF ((IPOS(1).LE.-1) .AND. (IPOS(1).GE.-NX) .AND.
     *         (IPOS(2).LE.-1) .AND. (IPOS(2).GE.-NY)) THEN
               IPOS(1) = -IPOS(1)
               IPOS(2) = -IPOS(2)
               DO 65 I = 1,NLIST
                  IF ((IPOS(1).EQ.PIXLIS(1,I)) .AND.
     *               (IPOS(2).EQ.PIXLIS(2,I))) GO TO 165
 65               CONTINUE
 165           IF (I.GT.NLIST) THEN
                  WRITE (MSGTXT,1165) IPOS, NX, NY
                  CALL MSGWRT (6)
               ELSE
                  DO 265 I1 = I+1,NLIST
                     PIXLIS(1,I) = PIXLIS(1,I1)
                     PIXLIS(2,I) = PIXLIS(2,I1)
                     I = I + 1
 265                 CONTINUE
                  NLIST = NLIST - 1
                  END IF
            ELSE IF ((IPOS(1).LT.1) .OR. (IPOS(1).GT.NX) .OR.
     *         (IPOS(2).LT.1) .OR. (IPOS(2).GT.NY)) THEN
               WRITE (MSGTXT,1265) IPOS, NX, NY
               CALL MSGWRT (6)
            ELSE
               NLIST = NLIST + 1
               PIXLIS(1,NLIST) = IPOS(1)
               PIXLIS(2,NLIST) = IPOS(2)
               END IF
            END IF
C                                       empty the list
      ELSE IF (CHOICS(CHS).EQ.'CLEAR LIST') THEN
         NLIST = 0
C                                       list list
      ELSE IF (CHOICS(CHS).EQ.'SHOW LIST') THEN
         IF (NLIST.LE.0) THEN
            MSGTXT = 'List is empty'
            CALL MSGWRT (6)
         ELSE
            I1 = 1
 66         I2 = MIN (NLIST, I1+3)
            IF (I2.GE.I1) THEN
               WRITE (MSGTXT,1066) (PIXLIS(1,I), PIXLIS(2,I), I = I1,I2)
               IF (I2-I1.LT.3) THEN
                  J = JTRIM (MSGTXT)
                  IF (MSGTXT(J:J).EQ.'(') MSGTXT(J:) = ' '
                  END IF
               CALL MSGWRT (2)
               I1 = I2 + 1
               GO TO 66
               END IF
            END IF
C                                       redo list
      ELSE IF (CHOICS(CHS).EQ.'REDO LIST') THEN
         IF (NLIST.LE.0) THEN
            MSGTXT = 'List is empty'
            CALL MSGWRT (6)
         ELSE
            CALL YZERO (IGR5, IRET)
            CALL YZERO (1, IRET)
            CALL COPY (256, CATBLK, CATEMP)
            CALL COPY (256, CATOLD, CATBLK)
            CALL UPDLIS ('REDO', NX, NY, NZ, ITYP, IMAGE, ANSW, IRET)
            CALL COPY (256, CATEMP, CATBLK)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'UPDATING FIT OF PIXEL LIST'
               GO TO 990
               END IF
            GO TO 30
            END IF
C                                       flag list
      ELSE IF (CHOICS(CHS).EQ.'FLAG LIST') THEN
         IF (NLIST.LE.0) THEN
            MSGTXT = 'List is empty'
            CALL MSGWRT (6)
         ELSE
            CALL YZERO (IGR5, IRET)
            CALL YZERO (1, IRET)
            CALL UPDLIS ('FLAG', NX, NY, NZ, ITYP, IMAGE, ANSW, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'UPDATING FIT OF PIXEL LIST'
               GO TO 990
               END IF
            GO TO 30
            END IF
C                                       flag list
      ELSE IF (CHOICS(CHS).EQ.'CHAR MULT') THEN
         I = CSIZTV(1) / 7
         WRITE (MSGBUF,1100) I
         CALL INQINT (TTYLUN, MSGBUF, 1, IPOS, IRET)
         IF (IRET.NE.0) GO TO 50
         IF ((IPOS(1).GE.1) .AND. (IPOS(1).LE.5)) THEN
            CALL YCMULT (IPOS(1), IRET)
            CSIZTV(1) = 7 * IPOS(1)
            CSIZTV(2) = 9 * IPOS(1)
            END IF
C                                       display image
      ELSE
         IP = CHS - MROWS(1)
         IF (MCOL.GT.2) IP = IP - MROWS(2)
         CALL SHOIMG (.FALSE., IP, NX, NY, ITYP, IGR5, ANSW, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SHOWING AN IMAGE'
            GO TO 990
         ELSE IF (IRET.LT.0) THEN
            IMGOK = .FALSE.
            IRET = 0
         ELSE
            LSTIMG = IP
            END IF
         END IF
      GO TO 50
C                                       TV function failure
 980  WRITE (MSGTXT,1000) IRET, 'TV INIT FUNCTIONS'
C
 990  IF ((IRET.GT.0) .AND. (IRET.NE.99)) CALL MSGWRT (8)
      IF (TTYIND.GT.0) THEN
         CALL ZCLOSE (TTYLUN, TTYIND, J)
         TTYIND = 0
         END IF
      CALL TVCLOS (SCRTCH, J)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPIXTV ERROR',I4,' ON A',A)
 1050 FORMAT (F9.4,' < BRIGHT <',F10.4,'  ERROR <',F8.4)
 1051 FORMAT (F9.4,' < SPIX   <',F10.4,'  ERROR <',F8.4)
 1052 FORMAT (F9.4,' < CURV   <',F10.4,'  ERROR <',F8.4)
 1165 FORMAT ('POSITION',2I6,' NOT FOUND IN THE PIXEL LIST')
 1265 FORMAT ('POSITION',2I6,' OUTSIDE 1-',I5,' 1-',I5)
 1066 FORMAT (4('(',I5,',',I5,')',3X))
 1100 FORMAT ('Enter character multiplier 1 - 5, current value',I2)
      END
      SUBROUTINE SHOIMG (QUICK, IP, NX, NY, NP, LGR, ANSW, IRET)
C-----------------------------------------------------------------------
C   SHOIMG displays an image plane on the TV screen and allows an
C   interactive transfer function, coloring, CURVALUE, and EXIT.
C   Inputs:
C      QUICK   L      T -> load image and return
C      IP      I      Desired plane
C      NX      I      Number X pixels in image
C      NY      I      Number Y pixels in image
C      NP      I      Number Z pixels in image
C      LGR     I      Graphics plane for labeling
C      ANSW    R(*)   Images of NP parameters
C   Output:
C      IRET    I      Error code
C-----------------------------------------------------------------------
      LOGICAL   QUICK
      INTEGER   IP, NX, NY, NP, LGR, IRET
      REAL      ANSW(NX,NY,*)
C
      INCLUDE 'TVSPX.INC'
      INCLUDE 'TVSPX.TV'
      INTEGER   NOPTS
      PARAMETER (NOPTS=14)
      INCLUDE 'INCS:PMAD.INC'
      INCLUDE 'INCS:PTVC.INC'
C
      INTEGER   IX, IY, TVWIN(4), IWIN(4), NPIX, PLINC, IYTV, HORIZ,
     *   IBUFF(MABFSS), NLEVS, MCOL, NROWS, MTYPE, TIMLIM, TOPSEP, I,
     *   GRCHS(2), TVBUT, CHS, ITR, LUTBUF(TVMLUT), JJ, II, LTY, NW,
     *   EX(5), EY(5), NXFRAM, NYFRAM, CFRAME, TFRAME, PINC, LNX, LNY,
     *   IC(2), NPIXW, WXPOS, JTRIM, JT, MMCOL, POFF, NEDGE, SIDSEP,
     *   MINC, MPIX, JBUFF(MABFSS), JNX, JNY, NBO, MBOX, IGR,
     *   CATSAV(256), ILAB, MROWS(1)
      CHARACTER TRANFN*2, CHOICS(NOPTS+1)*12, ISHELP*8, TITLE*132,
     *   TVALS(7)*16, CHTEMP*8, FUNCS(4)*2, BUNITS*8, BTEMP*8,
     *   TUNITS(7)*8, STRING*128
      REAL      PMN, PMX, RPOS(4), SLOPE, TEMP, BLCO(7), TRCO(7),
     *   OFM(TVMOFM,3), IOFM(TVMOFM,3)
      LOGICAL   LEAVE(NOPTS+1), DOWEDG, DOEDGE
      EQUIVALENCE (NROWS, MROWS)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (IBUFF, BUFF2, LUTBUF), (JBUFF, BUFF1)
      DATA MCOL, MTYPE, TIMLIM, TOPSEP, SIDSEP /1, -1, 0, 3, 10/
      DATA CHOICS /'RETURN', ' ','LOAD AS','SET WINDOW','RESET WINDOW',
     *   'OFF TRANSF', 'OFF COLOR', 'TVTRANSF', 'TVPSEUDO', 'TVPHLAME',
     *   'OFMCOLOR', 'TVZOOM', 'IMSTAT', 'CURVALUE', ' '/
      DATA LEAVE /13*.TRUE., .FALSE.,.TRUE./
      DATA TVALS /'CHANNELS', 'BRIGHTNESS', 'ERR BRIGHT', 'SPEC INDEX',
     *   'ERR SPIX', 'CURVATURE', 'ERR CURV'/
      DATA TUNITS /'PIXELS', 2*'JY/BEAM', 2*'SPECINDX',2*'SPECCURV'/
      DATA FUNCS /'LN', 'SQ', 'LG', 'L2'/
C-----------------------------------------------------------------------
      MMCOL = 1
      LTY = IP
      CALL YWINDO ('READ', WINDTV, IRET)
      NROWS = NOPTS
      IF (SVZOOM(1).NE.0) CALL COPY (3, SVZOOM, TVZOOM)
C                                       find max/min
 10   JNX = SUBWIN(3) - SUBWIN(1)
      JNY = SUBWIN(4) - SUBWIN(2)
      PMN = 1.E15
      PMX = -PMN
      DO 20 IY = SUBWIN(2),SUBWIN(4)
         DO 15 IX = SUBWIN(1),SUBWIN(3)
            IF (ANSW(IX,IY,IP).NE.FBLANK) THEN
               PMN = MIN (PMN, ANSW(IX,IY,IP))
               PMX = MAX (PMX, ANSW(IX,IY,IP))
               END IF
 15         CONTINUE
 20      CONTINUE
      IF (PMX.GE.PMN) THEN
         PLTMIN = PMN
         PLTMAX = PMX
         END IF
C                                       too big for TV?
      NXFRAM = (JNX - 1) / (MAXXTV(1)-33) + 1
      NYFRAM = (JNY - 1) / (MAXXTV(2)-33) + 1
      TFRAME = NXFRAM * NYFRAM
      CFRAME = 0
      PINC = MAX (NXFRAM, NYFRAM)
      LNX = JNX / PINC
      LNY = JNY / PINC
      MINC = 1
      IF (PINC.EQ.1) THEN
         JJ = 256
         IF ((MAXXTV(1).GT.650) .AND. (MAXXTV(2).GT.650)) JJ = 512
         IF ((2*JNX.LE.JJ) .AND. (2*JNY.LE.JJ)) THEN
            MINC = JJ / JNX
            IF (JJ/JNY.LT.MINC) MINC = JJ / JNY
            MINC = MIN (20, MINC)
            LNX = MINC * JNX
            LNY = MINC * JNY
            END IF
         END IF
      IC(1) = SUBWIN(1)
      IC(2) = SUBWIN(2)
C                                       menu list
      IF ((TFRAME.GT.1) .AND. (CHOICS(NROWS).NE.'NEXT WINDOW')) THEN
         NROWS = NROWS + 1
         CHOICS(NROWS) = 'NEXT WINDOW'
         POFF = 0
C                                       menu is on right and left sides
      ELSE IF (MMCOL.LE.2) THEN
         POFF = 0
C                                       offset image from menus
C                                       menu all on left
      ELSE
         NEDGE = (CSIZTV(1) + 1) / 2
         POFF = 2 * (2 + NEDGE + (MMCOL-1)*(1+NEDGE)) + 56 * CSIZTV(1)
         POFF = POFF + 7 + NEDGE
         IF (POFF+LNX.GT.WINDTV(3)-WINDTV(1)) POFF = 0
         END IF
C                                       width of wedge
      NW = MIN (JNY, 16)
C                                       no real image
      IF (PMX.LT.PMN) THEN
         MSGTXT = 'NO VALID PIXELS FOUND'
         IF ((SUBWIN(1).GT.1) .OR. (SUBWIN(2).GT.1) .OR.
     *      (SUBWIN(3).LT.NX) .OR. (SUBWIN(4).LT.NY)) THEN
            MSGTXT = 'NO VALID PIXELS FOUND: TRY DOING A RESET WINDOW'
            END IF
         CALL MSGWRT (7)
         IRET = -1
C                                       okay do it
      ELSE
         TRANFN = FUNCTY(IP)
         ITR = 1
         DO 30 I = 2,4
            IF (TRANFN.EQ.FUNCS(I)) ITR = I
 30         CONTINUE
         ITR = MOD (ITR, 4) + 1
C                                       header adjust
         CALL H2CHR (8, 1, CATOH(KHBUN), BUNITS)
         BTEMP = BUNITS(:4) // '*PIX'
         IF (MOD(IP-1,4).EQ.0) THEN
            CALL CHR2H (8, BUNITS, 1, CATH(KHBUN))
         ELSE IF (MOD(IP-1,4).EQ.3) THEN
            CALL CHR2H (8, BTEMP, 1, CATH(KHBUN))
         ELSE
            CALL CHR2H (8, 'PIXELS  ', 1, CATH(KHBUN))
            END IF
         CATR(KRDMX) = PMX
         CATR(KRDMN) = PMN
         TEMP = 0.005 * (PMX-PMN)
         CATR(IRRAN+1) = PMX + TEMP
         CATR(IRRAN) = PMN - TEMP
         WRITE (MSGTXT,1020) PMN, PMX, TVALS(LTY)
         CALL REFRMT (MSGTXT, '_', I)
         CALL MSGWRT (2)
C                                       window
 50      DOWEDG = .FALSE.
         DOEDGE = (LNX.LT.MAXXTV(1)-2) .AND.
     *      (LNY.LT.MAXXTV(2)-2*CSIZTV(2))
         IF (LNX.LE.MAXXTV(1)) THEN
            IWIN(1) = IC(1)
            IWIN(3) = IC(1) - 1 + (LNX/MINC) * PINC
            TVWIN(1) = (MAXXTV(1) - POFF - LNX) / 2 + POFF
            TVWIN(3) = TVWIN(1) + LNX - 1
            END IF
         IF (LNY.LE.MAXXTV(2)) THEN
            IF (LNY.LE.MAXXTV(2)-24) THEN
               IY = (NW * 2) / 3
               TVWIN(2) = (MAXXTV(2)-IY - LNY) / 2 + 16
               TVWIN(4) = TVWIN(2) + LNY - 1
               DOWEDG = .TRUE.
            ELSE
               TVWIN(2) = (MAXXTV(2) - LNY) / 2
               TVWIN(4) = TVWIN(2) + LNY - 1
               END IF
            IWIN(2) = IC(2)
            IWIN(4) = IC(2) - 1 + (LNY/MINC) * PINC
            END IF
         CALL COPY (4, IWIN, CATBLK(IIWIN))
         CALL COPY (4, TVWIN, CATBLK(IICOR))
C                                       not from disk
         CATBLK(IIVOL) = 0
         CATBLK(IICNO) = 0
         IPL(1) = 1
         IPL(2) = 1
         CALL YHOLD ('ONNN', IRET)
         CALL YZERO (LGR, IRET)
         CALL YZERO (IPL(1), IRET)
         IF (TFRAME.GT.1) THEN
            IF (PINC.EQ.1) THEN
               WRITE (MSGTXT,1050) CFRAME
            ELSE
               WRITE (MSGTXT,1051) PINC
               END IF
            CALL MSGWRT (2)
         ELSE IF (MINC.GT.1) THEN
            WRITE (MSGTXT,1052) MINC
            CALL MSGWRT (2)
            END IF
C                                       return here to reload
 60      CALL CHR2H (2, TRANFN, 1, CATH(IITRA))
         CHOICS(3)(9:10) = FUNCS(ITR)
         FUNCTY(IP) = TRANFN
         CALL YHOLD ('ONNN', IRET)
         CALL YCINIT (IPL(1), SCRTCH)
         CALL YCWRIT (IPL(1), TVWIN, CATBLK, SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE IMAGE CATALOG'
            GO TO 990
            END IF
         CALL YSLECT ('ONNN', IPL(1), 0, SCRTCH, IRET)
         CALL COPY (256, CATBLK, CATSAV)
C                                       write TV image
         IYTV = TVWIN(2) - 1
         NPIX = (IWIN(3) - IWIN(1)) / PINC + 1
         MPIX = NPIX * MINC
         IF (MPIX.GT.17) THEN
            NPIXW = MPIX
            WXPOS = TVWIN(1)
         ELSE
            NPIXW = 17
            WXPOS = TVWIN(1) - (18-NPIX)/2
            WXPOS = MAX (1, WXPOS)
            END IF
         PLINC = 1
         HORIZ = 0
         DO 70 IY = IWIN(2),IWIN(4),PINC
            IYTV = IYTV + 1
            CALL ISCALE (TRANFN, MAXINT, CATR(IRRAN), NPIX*PINC, PINC,
     *         ANSW(IWIN(1),IY,IP), IBUFF)
            IF (MINC.EQ.1) THEN
               CALL YIMGIO ('WRIT', IPL(1), TVWIN(1), IYTV, HORIZ, NPIX,
     *            IBUFF, IRET)
            ELSE
               DO 64 I = 1,NPIX
                  CALL FILL (MINC, IBUFF(I), JBUFF(MINC*(I-1)+1))
 64               CONTINUE
               IYTV = IYTV - 1
               DO 65 I = 1,MINC
                  IYTV = IYTV + 1
                  IF (IRET.EQ.0) CALL YIMGIO ('WRIT', IPL(1), TVWIN(1),
     *               IYTV, HORIZ, MPIX, JBUFF, IRET)
 65               CONTINUE
               END IF
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITING IMAGE TO TV'
               GO TO 990
               END IF
 70         CONTINUE
         IF (DOWEDG) THEN
            IYTV = TVWIN(2) - (NW+1)/2
            SLOPE = (PMX - PMN) / (NPIXW - 1)
            DO 80 IY = 1,NPIXW
               BUFF1(IY) = (IY - 1.0) * SLOPE + PMN
 80            CONTINUE
            CALL ISCALE (TRANFN, MAXINT, CATR(IRRAN), NPIXW, 1, BUFF1,
     *         IBUFF)
            DO 90 IY = 1,NW
               IYTV = IYTV - 1
               CALL YIMGIO ('WRIT', IPL(1), WXPOS, IYTV, HORIZ, NPIXW,
     *            IBUFF, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITING WEDGE TO TV'
                  GO TO 990
                  END IF
 90            CONTINUE
            IF (NGRAPH.GE.4) THEN
               I = NGRAY + NGRAPH
               CALL YZERO (I, IRET)
               IRET = 0
               END IF
            IF ((IYTV.GT.2*CSIZTV(2)) .AND. (LABWED)) THEN
               CATBLK(IICOR) = WXPOS
               CATBLK(IICOR+2) = WXPOS + NPIXW -1
               CATBLK(IICOR+1) = IYTV
               CATBLK(IICOR+3) = IYTV + NW - 1
               CALL COPY (4, CATBLK(IICOR), CATBLK(IIWIN))
               CATR(KRCRP) = (CATBLK(IICOR) + CATBLK(IICOR+2)) / 2.0
               CATD(KDCRV) = (CATR(KRDMX) + CATR(KRDMN)) / 2.0
               CATR(KRCIC) = (CATR(KRDMX) - CATR(KRDMN)) /
     *            (CATBLK(IICOR+2) - CATBLK(IICOR))
               I = 2 * (KICTPN-1)
               CALL RFILL (I, HBLANK, CATH(KHCTP+2))
               CALL CHR2H (8, TUNITS(LTY), 1, CATH(KHCTP))
               CALL CHR2H (4, 'WEBB', 1, CATH(KHCTP+I))
               CATR(KRCIC+1) = 0.0
               CATR(KRCRP+1) = CATBLK(IICOR+1) - 1
               CATD(KDCRV+1) = 0.0
               CALL CHR2H (2, 'WE', KHPTYO, CATH(KHPTY))
               ILAB = 7
               LOCNUM = MAX (1, LOCNUM)
               LABTYP(LOCNUM) = 0
               LGR = 5
               CALL IAXIS1 (SCRTCH, ILAB, LGR, 1, .TRUE., IRET)
               IF (IRET.NE.0) THEN
                  MSGTXT = 'WEDGE LABEL ERROR'
                  CALL MSGWRT (6)
                  IRET = 0
                  END IF
               CALL COPY (256, CATSAV, CATBLK)
               END IF
            END IF
C                                       line around
         IF (DOEDGE) THEN
            EX(1) = TVWIN(1) - 1
            EY(1) = TVWIN(2) - 1
            EX(3) = TVWIN(3) + 1
            EY(3) = TVWIN(4) + 1
            EX(2) = EX(3)
            EY(2) = EY(1)
            EX(4) = EX(1)
            EY(4) = EY(3)
            EX(5) = EX(1)
            EY(5) = EY(1)
            LGR = NGRAY + 5
            CALL YSLECT ('ONNN', LGR, 0, IBUFF, IRET)
            IF (IRET.EQ.0) CALL IMVECT ('ONNN', LGR, 5, EX, EY, IBUFF,
     *         IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'DRAWING EDGE LINE AROUND' //
     *            ' THE IMAGE'
               GO TO 990
               END IF
            WRITE (STRING,1095) (ROBUST(I,IP), I = 1,4)
            CALL REFRMT (STRING, '_', I)
            EY(1) = EY(3) + (CSIZTV(2)+1)/2
            IF (EY(1)+1.5*CSIZTV(2).LT.MAXXTV(2)) THEN
               CALL IMCHAR (LGR, EX(1), EY(1), 0, 0, STRING(:I), IBUFF,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'SHOWING STATISTICS'
                  GO TO 990
                  END IF
               END IF
            END IF
         IF (QUICK) THEN
            CALL YHOLD ('OFFF', IRET)
            GO TO 999
            END IF
         NLEVS = LUTOUT + 1
         ISHELP = TSKNAM
C                                       simple menu
C                                       menu selection
         IY = IP
         CALL H2CHR (8, 1, CATOH(KHBUN), CHTEMP)
         JT = JTRIM (TVALS(IP))
         TEMP = MAX (ABS(PMN), ABS(PMX))
         IF (TFRAME.GT.1) THEN
            IF ((TEMP.LT.10000.) .AND. (TEMP.GT.0.001)) THEN
               WRITE (TITLE,1090) CFRAME, TVALS(IP)(:JT), PMN, PMX
            ELSE
               WRITE (TITLE,1091) CFRAME, TVALS(IP)(:JT), PMN, PMX
            END IF
         ELSE
            IF ((TEMP.LT.10000.) .AND. (TEMP.GT.0.001)) THEN
               WRITE (TITLE,1092) TVALS(IP)(:JT), PMN, PMX
            ELSE
               WRITE (TITLE,1093) TVALS(IP)(:JT), PMN, PMX
               END IF
            END IF
         CALL REFRMT (TITLE, '_', I)
         GRCHS(1) = 2
         GRCHS(2) = 1
         RPOS(1) = MAXXTV(1) / 2
         RPOS(2) = MAXXTV(2) / 2
 100     CALL TVMENU (MTYPE, MCOL, MROWS, GRCHS, TOPSEP, SIDSEP, ISHELP,
     *      CHOICS, TIMLIM, LEAVE, 1, TITLE, CHS, TVBUT, IBUFF2, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'RETURNED FROM TVMENU'
            GO TO 990
            END IF
C                                       return to main menu
         IF (CHOICS(CHS).EQ.'RETURN') THEN
            MSGTXT = 'Returning to main menu'
            CALL MSGWRT (2)
            CALL COPY (3, TVZOOM, SVZOOM)
            TVZOOM(1) = 0
            TVZOOM(2) = MAXXTV(1) / 2
            TVZOOM(3) = MAXXTV(2) / 2
            CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), .TRUE., IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'TURNING OFF ZOOM'
               GO TO 990
               END IF
            GO TO 999
C                                       blank
         ELSE IF (CHOICS(CHS).EQ.' ') THEN
C                                       set window
         ELSE IF (CHOICS(CHS).EQ.'SET WINDOW') THEN
            CALL YCINIT (LGR, IBUFF2)
            NBO = 0
            MBOX = 1
            CALL RCOPY (7, BLC, BLCO)
            CALL RCOPY (7, TRC, TRCO)
            IGR = LGR - NGRAY
            CALL GRBOXS (IGR, MBOX, NBO, BLCO, TRCO, BUFF2, IRET)
            IF (IRET.EQ.0) THEN
               SUBWIN(1) = BLCO(1) + 0.1
               SUBWIN(2) = BLCO(2) + 0.1
               SUBWIN(3) = TRCO(1) + 0.1
               SUBWIN(4) = TRCO(2) + 0.1
               WRITE (MSGTXT,1110) SUBWIN
               CALL MSGWRT (2)
               END IF
            GO TO 10
C                                       reset window
         ELSE IF (CHOICS(CHS).EQ.'RESET WINDOW') THEN
            SUBWIN(1) = 1
            SUBWIN(2) = 1
            SUBWIN(3) = NX
            SUBWIN(4) = NY
            GO TO 10
C                                       change transfer function
         ELSE IF (CHOICS(CHS)(:8).EQ.'LOAD AS ') THEN
            TRANFN = FUNCS(ITR)
            ITR = MOD (ITR, 4) + 1
            GO TO 60
C                                       TV transfer func OFF
         ELSE IF (CHOICS(CHS).EQ.'OFF TRANSF') THEN
            IYTV = MAXINT + 1
            SLOPE = REAL(LUTOUT) / REAL(MAXINT)
            DO 110 I = 1,IYTV
               LUTBUF(I) = (I-1) * SLOPE + 0.5
 110           CONTINUE
            I = 2 ** (IPL(1)-1)
            CALL YLUT ('WRIT', I, 7, .FALSE., LUTBUF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'RETURNED BY OFF TRANSF'
               GO TO 990
               END IF
C                                       TV color func OFF
         ELSE IF (CHOICS(CHS).EQ.'OFF COLOR') THEN
            I = OFMINP + 1
            CALL RFILL (I, 0.0, BUFf1)
            NLEVS = LUTOUT + 1
            IF (I.LT.NLEVS) NLEVS = I
            SLOPE = 1.0 / (NLEVS-1.0)
            DO 120 I = 1,NLEVS
               BUFF1(I) = (I-1) * SLOPE
 120           CONTINUE
            I = (OFMINP + 1) / NLEVS
            JJ = NLEVS
            DO 130 II = 2,I
               CALL RCOPY (NLEVS, BUFF1, BUFF1(JJ+1))
               JJ = JJ + NLEVS
 130           CONTINUE
            CALL YOFM ('WRIT', 7, .FALSE., BUFF1, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'RETURNED BY OFF COLOR'
               GO TO 990
               END IF
C                                       TV transfer func
         ELSE IF (CHOICS(CHS).EQ.'TVTRANSF') THEN
            I = 2 ** (IPL(1)-1)
            IYTV = 1
            CALL IENHNS (I, 7, IYTV, RPOS, BUFF1, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'RETURNED BY TVTRANSF'
               GO TO 990
               END IF
C                                       TV pseudo colors
         ELSE IF (CHOICS(CHS).EQ.'TVPSEUDO') THEN
            CALL TVPSUD (NLEVS, BUFF1, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'RETURNED BY TVPSEUDO'
               GO TO 990
               END IF
C                                       TV flame colors
         ELSE IF (CHOICS(CHS).EQ.'TVPHLAME') THEN
            CALL TVFLAM (NLEVS, BUFF1, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'RETURNED BY TVPHLAME'
               GO TO 990
               END IF
C                                       TV OFM table colors
         ELSE IF (CHOICS(CHS).EQ.'OFMCOLOR') THEN
            CALL OFMCOL (NLEVS, OFM, IOFM, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'RETURNED BY OFMCOLOR'
               GO TO 990
               END IF
C                                       TV zoom
         ELSE IF (CHOICS(CHS).EQ.'TVZOOM') THEN
            CALL TVZOME (IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'RETURNED BY TVZOOM'
               GO TO 990
               END IF
C                                       Cursor value: local version
         ELSE IF (CHOICS(CHS).EQ.'CURVALUE') THEN
            CALL YSLECT ('OFFF', GRCHS(2)+NGRAY, 0, IBUFF1, IRET)
            CALL TVALUE (GRCHS(1), NX, NY, ANSW(1,1,IP), CUNITS(IP),
     *         NLIST, PIXLIS, IBUFF1, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'RETURNED BY TVALUE'
               GO TO 990
               END IF
C                                       Imstat
         ELSE IF (CHOICS(CHS).EQ.'IMSTAT') THEN
            CALL TVSTAT (TVALS(IP), NX, NY, ANSW(1,1,IP), SUBWIN,
     *         RPOS)
            IF ((SUBWIN(1).EQ.1) .AND. (SUBWIN(2).EQ.1) .AND.
     *         (SUBWIN(3).EQ.NX) .AND. (SUBWIN(4).EQ.NY)) THEN
               CALL RCOPY (4, RPOS, ROBUST(1,IP))
               IF (DOEDGE) THEN
                  WRITE (STRING,1095) (ROBUST(I,IP), I = 1,4)
                  I = JTRIM (STRING)
                  CALL REFRMT (STRING, '_', II)
                  EY(1) = EY(3) + (CSIZTV(2)+1)/2
                  CALL IMCHAR (LGR, EX(1), EY(1), 0, 0, STRING(:I),
     *               IBUFF, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'SHOWING STATISTICS'
                     GO TO 990
                     END IF
                  END IF
               END IF
C                                       load next portion
         ELSE IF (CHOICS(CHS).EQ.'NEXT WINDOW') THEN
            CFRAME = CFRAME + 1
            IF (CFRAME.GT.TFRAME) THEN
               CFRAME = 0
               PINC = MAX (NXFRAM, NYFRAM)
               IC(1) = SUBWIN(1)
               IC(2) = SUBWIN(2)
               LNX = JNX / PINC
               LNY = JNY / PINC
            ELSE
               PINC = 1
               IF (NXFRAM.EQ.1) THEN
                  IC(1) = SUBWIN(1)
                  LNX = JNX
               ELSE
                  II = MOD (CFRAME-1, NXFRAM) + 1
                  IC(1) = (II - 1) * (MAXXTV(1) - 3) + SUBWIN(1)
                  IF (IC(1)+MAXXTV(1)-33.GT.NX) IC(1) = JNX - MAXXTV(1)
     *               + 33
                  LNX = MAXXTV(1) - 33
                  END IF
               IF (NYFRAM.EQ.1) THEN
                  IC(2) = SUBWIN(2)
                  LNY = JNY
               ELSE
                  II = (CFRAME-1) / NXFRAM + 1
                  IC(2) = (II - 1) * (MAXXTV(2) - 3) + SUBWIN(2)
                  IF (IC(2)+MAXXTV(2)-33.GT.NY) IC(2) = JNY - MAXXTV(2)
     *               + 33
                  LNY = MAXXTV(2) - 33
                  END IF
               END IF
            GO TO 50
            END IF
         GO TO 100
         END IF
C
 990  IF (IRET.GT.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SHOIMG: ERROR:',I4,' ON ',A)
 1020 FORMAT ('Loading image',F12.5,' to',F12.5,' of ',A)
 1050 FORMAT ('Loading every pixel in subimage',I3)
 1051 FORMAT ('Loading full image with only every',I3,
     *   ' pixels in X and Y')
 1052 FORMAT ('Loading every pixel replicated by',I3)
 1090 FORMAT ('Subim',I3,2X,A,'_',F11.5,' TO',F11.5)
 1091 FORMAT ('Subim',I3,2X,A,'_',1PE11.3,' TO',1PE11.3)
 1092 FORMAT (A,'_',F11.5,' TO',F11.5)
 1093 FORMAT (A,'_',1PE11.3,' TO',1PE11.3)
 1095 FORMAT ('Robust mean, rms',2F10.3,'____Full mean, rms',2F10.3)
 1110 FORMAT ('BLC/TRC=',4I7)
      END
      SUBROUTINE TVALUE (GR, NX, NY, IMAGE, CUNITS, NLIST, PIXLIS,
     *   BUFFER, IRET)
C-----------------------------------------------------------------------
C   TVALUE performs interactive displays of map image values:
C   Special version for XGAUS - allows picking pixels for list
C   Inputs:
C      GR        I        Graphics plane for lettering
C      NX        I        Number X pixels in image
C      NY        I        Number Y pixels in image
C      IMAGE     R(*)     Image values
C   In/out:
C      NLIST     I        Number entries in PIXLIS
C      PIXLIST   I(2,*)   List of pixels
C   Output:
C      BUFFER    I(*)     Scratch buffer
C      IRET      I        Basic TV error code
C-----------------------------------------------------------------------
      INTEGER   GR, NX, NY, NLIST, PIXLIS(2,*), BUFFER(*), IRET
      REAL      IMAGE(NX,NY)
      CHARACTER CUNITS*(*)
C
      CHARACTER STRING*16, PREFIX*5, ITRTYP(8)*2, LMTYPS(2)*2, LMTYPE*2
      INTEGER   MIND, IG, IG1, IG2, ITW(3), NPIX, NROW, MAG, IX0, IY0,
     *   IX, IY, IP, ECOUNT, QUAD, IBUT, ITR, ICMASK, ZAND, ISCX,
     *   ISCY, I, INCNO, INVOL, LDEP(5), ITG1, ITG2, ITEMP, IX1, IY1,
     *   MSGSAV, LBUT
      REAL      PPOS(2), RPOS(2), PIXVAL, CORN(7)
      LOGICAL   T, F, EQUAL, DOIT, FROMTV, BLNKD, NOQUAD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA ITRTYP /'LN','LG','L2','SQ','NE','NG','N2','NQ'/
      DATA LMTYPS /'WE','ZZ'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      MIND = 0
      QUAD = 0
      FROMTV = .TRUE.
      CALL ZTIME (ITW)
      MSGSAV = MSGSUP
      NOQUAD = .TRUE.
C                                       Turn on graphics
      CALL YHOLD ('ONNN', IRET)
      IG1 = MIN (GR, NGRAPH)
      IF (IG1.LE.0) IG1 = MIN (2, NGRAPH)
      IG2 = 0
      IF (NGRAPH.GE.4) IG2 = NGRAPH
      ITG1 = NGRAY + IG1
      ITG2 = NGRAY + IG2
      CALL YSLECT ('ONNN', ITG1, 0, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL YZERO (ITG1, IRET)
      IF (IRET.NE.0) GO TO 970
      IF (IG2.NE.0) THEN
         CALL YSLECT ('ONNN', ITG2, 0, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YZERO (ITG2, IRET)
         IF (IRET.NE.0) GO TO 970
         END IF
C                                       Display area: location, size
C                                       Approx corr for zoom
      NPIX = 13 * CSIZTV(1)
      NROW = 4 * CSIZTV(2)
      ISCX = 0
      ISCY = 0
      MAG = 1 + TVZOOM(1)
      IF (MXZOOM.GT.0) MAG = 2 ** TVZOOM(1)
      IX0 = WINDTV(1) - (MAG-1)/2
      IY0 = WINDTV(4) - MAG*NROW + 1 - (MAG-1)/2
      IF (MAG.GT.1) IY0 = IY0 + MAG
      IX0 = (IX0 - TVZOOM(2)) / MAG + TVZOOM(2) - TVSCGX
      IY0 = (IY0 - TVZOOM(3)) / MAG + TVZOOM(3) - TVSCGY
      IF (IX0+NPIX-1.GT.MAXXTV(1)) IX0 = 1
      IF (IY0+NROW-1.GT.MAXXTV(2)) IY0 = MAXXTV(2) - NROW + 1
      IX1 = IX0 + NPIX - 1
      IY1 = IY0 + NROW - 1
      CALL YFILL (ITG1, IX0, IY0, IX1, IY1, 0, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      IF (IG2.GT.0) THEN
         CALL YFILL (ITG2, IX0, IY0, IX1, IY1, 1, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         END IF
      CALL YHOLD ('OFFF', IRET)
C                                       CURVALUE (from disk file)
C                                       no image yet
      RPOS(1) = (CATBLK(IICOR) + CATBLK(IICOR+2)) / 2
      RPOS(2) = (CATBLK(IICOR+1) + CATBLK(IICOR+3)) / 2
      CALL FILL (4, 0, CATBLK(IICOR))
      CATBLK(IICNO) = 0
      LDEP(1) = -10000
      WRITE (MSGTXT,1100)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1101)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1102)
      CALL MSGWRT (1)
C                                       turn on cursor
      IP = 0
      ECOUNT = 0
      IG = IG1 + NGRAY
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Cursor read loop point
 110  CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IRET)
      IF ((IBUT.GE.4) .OR. (IRET.NE.0)) GO TO 970
      LBUT = IBUT
      CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
      IF (.NOT.DOIT) GO TO 110
C                                       Find new image catalog block
         QUAD = 0
         CALL YCURSE ('FXIT', F, T, RPOS, QUAD, IBUT, IRET)
         IX = RPOS(1) + 0.51
         IY = RPOS(2) + 0.51
         INCNO = CATBLK(IICNO)
         INVOL = CATBLK(IIVOL)
         IF ((IX.LT.CATBLK(IICOR)) .OR. (IX.GT.CATBLK(IICOR+2)) .OR.
     *      (IY.LT.CATBLK(IICOR+1)) .OR. (IY.GT.CATBLK(IICOR+3))) THEN
            DO 115 IP = 1,NGRAY
               ITEMP = 2 ** (IP - 1)
               IF (ZAND(TVLIMG(QUAD),ITEMP).NE.0) THEN
                  CALL YCREAD (IP, IX, IY, CATBLK, IRET)
                  IF (IRET.EQ.0) GO TO 120
                  IF (IRET.NE.1) GO TO 960
                  END IF
 115           CONTINUE
C                                       No or invalid image here
 116        ECOUNT = ECOUNT + 1
            CALL FILL (4, 0, CATBLK(IICOR))
            CATBLK(IICNO) = 0
            IF (ECOUNT.LT.1) THEN
               WRITE (MSGTXT,1116) IX, IY
               CALL MSGWRT (1)
               END IF
            GO TO 110
C                                       Set up image reads
 120        CALL H2CHR (2, KHPTYO, CATH(KHPTY), LMTYPE)
            IF (LMTYPE.EQ.LMTYPS(2)) GO TO 116
            BLNKD = .FALSE.
C                                       Scaling parms for TV pixvals
            CALL COPY (5, CATBLK(IIDEP), LDEP)
            ICMASK = 2 ** (IP-1)
            ITR = 1
            CALL H2CHR (2, 1, CATH(IITRA), LMTYPE)
            DO 135 I = 1,8
               IF (LMTYPE.EQ.ITRTYP(I)) ITR = I
 135           CONTINUE
            ECOUNT = 0
            END IF
C                                       From TV for wedges
         CALL IMA2MP (RPOS, CORN)
         IX = CORN(1) + 0.51
         IY = CORN(2) + 0.51
         PIXVAL = IMAGE(IX,IY)
         BLNKD = IMAGE(IX,IY).EQ.FBLANK
C                                       Button A or B => add to lists
         IF (LBUT.GT.0) THEN
            NLIST = NLIST + 1
            PIXLIS(1,NLIST) = IX
            PIXLIS(2,NLIST) = IY
            WRITE (MSGTXT,1135) IX, IY
            CALL MSGWRT (2)
            END IF
C                                       Write text to TV
         IF ((IX.LE.9999) .AND. (IY.LE.9999)) THEN
            WRITE (STRING,1170) IX, IY
         ELSE
            WRITE (STRING,1171) IX, IY
            END IF
         IY = IY0 + 3*CSIZTV(2)
         CALL YHOLD ('ONNN', IRET)
         CALL YSLECT ('OFFF', ITG1, 0, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL IMCHAR (IG, IX0, IY, 0, 0, STRING(:13), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         IF (.NOT.BLNKD) THEN
            CALL METSCA (PIXVAL, PREFIX, EQUAL)
            WRITE (STRING,1172) PIXVAL
            IY = IY - 1.5*CSIZTV(2)
            CALL IMCHAR (IG, IX0, IY, 0, 0, STRING(:10), BUFFER, IRET)
            IF (IRET.NE.0) GO TO 970
            STRING = PREFIX
            STRING(6:) = CUNITS
            CALL IMCHAR (IG, IX0, IY0, 0, 0, STRING(:13), BUFFER, IRET)
            IF (IRET.NE.0) GO TO 970
         ELSE
            STRING = 'B  BLANKED'
            IY = IY - 1.5*CSIZTV(2)
            CALL IMCHAR (IG, IX0, IY, 0, 0, STRING(:10), BUFFER, IRET)
            IF (IRET.NE.0) GO TO 970
            STRING = ' '
            CALL IMCHAR (IG, IX0, IY0, 0, 0, STRING(:13), BUFFER, IRET)
            IF (IRET.NE.0) GO TO 970
            END IF
         IF (IG2.GT.0) CALL YFILL (ITG2, IX0, IY0, IX1, IY1, 1,
     *      BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YSLECT ('ONNN', ITG1, 0, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YHOLD ('OFFF', IRET)
C                                       Button A or B => add to lists
         IF (IBUT.GT.0) THEN
            NLIST = NLIST + 1
            PIXLIS(1,NLIST) = IX
            PIXLIS(2,NLIST) = IY
            END IF
         GO TO 110
C-----------------------------------------------------------------------
C                                       Close downs
C                                       Img Catlg error
 960  WRITE (MSGTXT,1960) IRET
      CALL MSGWRT (6)
      GO TO 975
C                                       TV error possibly
 970  IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1970) IRET
         CALL MSGWRT (6)
         END IF
C                                       Close things
 975  CALL YHOLD ('ONNN', I)
      CALL YCURSE ('OFFF', F, F, RPOS, QUAD, IBUT, I)
      ITEMP = 2 ** NGRAY
      IF ((ISCX.NE.0) .OR. (ISCY.NE.0)) CALL YSCROL (ITEMP, ISCX,
     *   ISCY, F, I)
      CALL YZERO (ITG1, I)
      IF (IG2.NE.0) CALL YZERO (ITG2, I)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('Cursor selects which pixel is displayed')
 1101 FORMAT ('Hit button A or B to add the current pixel to list')
 1102 FORMAT ('Hit button C or D to exit')
 1116 FORMAT ('TVALUE: ',2I7,' NOT IN VALID IMAGE')
 1135 FORMAT ('Pixel',I5,',',I5,' added to list')
 1170 FORMAT ('X=',I4,' Y=',I4)
 1171 FORMAT (I6,I7)
 1172 FORMAT ('B=',F8.3)
 1960 FORMAT ('TVALUE: IMAGE CAT FILE IO ERROR',I7)
 1970 FORMAT ('TVALUE: TV ACTION IO ERROR',I7)
      END
      SUBROUTINE TVSTAT (CTYPE, NX, NY, IMAGE, WIN, ROBUST)
C-----------------------------------------------------------------------
C   TVSTAT computes the statistics of an image
C   reports the results
C   Inputs:
C      CTYPE    C*(*)    Image type
C      NX       I        Number X pixels
C      NY       I        Number Y pixels (rows)
C      IMAGE    R(*,*)   Image values
C      WIN      I(4)     window for stat
C   Output
C      ROBUST   R(4)     Robust mean, rms; Full mean, rms
C-----------------------------------------------------------------------
      CHARACTER CTYPE*(*)
      INTEGER   NX, NY, WIN(4)
      REAL      IMAGE(NX,NY), ROBUST(4)
C
      INTEGER   IX, IY, NPASS, SN,
     *   TN, J, JTRIM
      REAL      T, RX, A
      DOUBLE PRECISION RSP, RSM, TT, SS, SQ, RM, RS, TS, TQ
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       we need to find it
      RSP = 1.D10
      RSM = -1.D10
      RX = 0.0
      DO 60 NPASS = 1,7
         SS = 0.0D0
         SQ = 0.0D0
         SN = 0
         TS = 0.0D0
         TQ = 0.0D0
         TN = 0
         DO 50 IY = WIN(2),WIN(4)
            DO 40 IX = WIN(1),WIN(3)
               T = IMAGE(IX,IY)
               IF (T.NE.FBLANK) THEN
                  RX = MAX (RX, ABS(T))
                  TT = T
                  IF ((TT.LT.RSP) .AND. (TT.GT.RSM)) THEN
                     SS = SS + TT
                     SQ = SQ + TT * TT
                     SN = SN + 1
                     END IF
                  TS = TS + TT
                  TQ = TQ + TT * TT
                  TN = TN + 1
                  END IF
 40            CONTINUE
 50         CONTINUE
         IF (SN.LE.0.0D0) THEN
            RSP = RSP + 3.0D0 * RS
            RSM = RSP - 3.0D0 * RS
         ELSE
            RM = SS / SN
            SQ = SQ / SN
            RS = SQ - RM * RM
            RS = SQRT (MAX (0.0D0, RS))
            RS = MAX (RS, 0.01D0*RM)
            RSP = RM + 3.0D0 * RS
            RSM = RM - 4.0D0 * RS
            END IF
         IF (TN.GT.0) THEN
            TS = TS / TN
            TQ = TQ / TN - TS * TS
            TQ = SQRT (MAX (0.0D0, TQ))
            END IF
 60      CONTINUE
      J = JTRIM (CTYPE)
      IF (J.GT.0) THEN
         WRITE (MSGTXT,1060) CTYPE(:J), RM, RS
         CALL MSGWRT (3)
         WRITE (MSGTXT,1061) CTYPE(:J), TS, TQ
         CALL MSGWRT (3)
         END IF
      ROBUST(1) = RM
      ROBUST(2) = RS
      ROBUST(3) = TS
      ROBUST(4) = TQ
C
 999  RETURN
C-----------------------------------------------------------------------
 1060 FORMAT ('Image ',A,'  robust mean',1PE12.4,'  rms',1PE12.4)
 1061 FORMAT ('Image ',A,'  full   mean',1PE12.4,'  rms',1PE12.4)
      END
      SUBROUTINE UPDALL (OPER, RANGE, ERROR, NX, NY, NZ, ITYP, IMAGE,
     *   ANSW, IRET)
C-----------------------------------------------------------------------
C   UPDALL flags or re-does fitting on all pixels matching test
C   conditions
C   Inputs:
C      OPER     C*4    'REDO', 'FLAG'
C      RANGE    R(2,3)   Min/Max range
C      ERROR    R(3)     Max allowed rms
C      NX       I        # X pixels
C      NY       I        # Y pixels
C      NZ       I        # freq pixels
C      ITYP     I        # parameters (5, 7)
C   In/out:
C      IMAGE    R(*)   Images of data (NX,NY,NZ)
C      ANSW     R(*)     Answers (NX,NY,ITYP)
C   Output:
C      IRET     I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER OPER*4
      INTEGER   NX, NY, NZ, ITYP, IRET
      REAL      RANGE(2,3), ERROR(3), IMAGE(NZ,NX,NY), ANSW(NX,NY,ITYP)
C
      INCLUDE 'TVSPX.INC'
      INTEGER   IX, IY, I, J, N
      LOGICAL   DOIT(7), CH, REV(7)
      REAL      RESULT(7)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA REV /7*.FALSE./
C-----------------------------------------------------------------------
      DOIT(2) = RANGE(2,1).GT.RANGE(1,1)
      DOIT(4) = RANGE(2,2).GT.RANGE(1,2)
      DOIT(6) = RANGE(2,3).GT.RANGE(1,3)
      DOIT(3) = ERROR(1).GT.0.0
      DOIT(5) = ERROR(2).GT.0.0
      DOIT(7) = ERROR(3).GT.0.0
      REV(2) = RANGE(2,1).LT.RANGE(1,1)
      REV(4) = RANGE(2,2).LT.RANGE(1,2)
      REV(6) = RANGE(2,3).LT.RANGE(1,3)
      IF (OPER.EQ.'FLAG') THEN
         N = 0
         DO 40 IY = SUBWIN(2),SUBWIN(4)
            DO 30 IX = SUBWIN(1),SUBWIN(3)
               CH = .FALSE.
               DO 10 I = 2,ITYP,2
                  J = I/2
                  IF (ANSW(IX,IY,I).NE.FBLANK) THEN
                     IF ((I.EQ.4) .AND. (ABS(ANSW(IX,IY,I)).LT.0.1))
     *                  THEN
                        MSGTXT = 'WE ARE HERE'
                        END IF
                     IF ((DOIT(I)) .AND. ((ANSW(IX,IY,I).LT.RANGE(1,J))
     *                  .OR. (ANSW(IX,IY,I).GT.RANGE(2,J)))) CH = .TRUE.
                     IF ((DOIT(I+1)).AND.(ANSW(IX,IY,I+1).GT.ERROR(J)))
     *                  CH = .TRUE.
                     IF ((REV(I)) .AND. (ANSW(IX,IY,I).LT.RANGE(1,J))
     *                  .AND. (ANSW(IX,IY,I).GT.RANGE(2,J))) CH = .TRUE.
                     END IF
 10               CONTINUE
               IF (CH) THEN
                  N = N + 1
                  DO 20 I = 1,ITYP
                     ANSW(IX,IY,I) = FBLANK
 20                  CONTINUE
                  END IF
 30            CONTINUE
 40         CONTINUE
      ELSE
         N = 0
         DO 80 IY = SUBWIN(2),SUBWIN(4)
            DO 70 IX = SUBWIN(1),SUBWIN(3)
               CH = .FALSE.
               DO 50 I = 2,ITYP,2
                  J = I/2
                  IF (ANSW(IX,IY,I).NE.FBLANK) THEN
                     IF ((DOIT(I)) .AND. ((ANSW(IX,IY,I).LT.RANGE(1,J))
     *                  .OR. (ANSW(IX,IY,I).GT.RANGE(2,J)))) CH = .TRUE.
                     IF ((DOIT(I+1)).AND.(ANSW(IX,IY,I+1).GT.ERROR(J)))
     *                  CH = .TRUE.
                     IF ((REV(I)) .AND. (ANSW(IX,IY,I).LT.RANGE(1,J))
     *                  .AND. (ANSW(IX,IY,I).GT.RANGE(2,J))) CH = .TRUE.
                     END IF
 50               CONTINUE
               IF (CH) THEN
                  DO 55 J = 1,ITYP
                     RESULT(J) = ANSW(IX,IY,J)
 55                  CONTINUE
                  CALL SPREDO (NZ, ITYP, IX, IY, IMAGE(1,IX,IY), RESULT,
     *                  IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1080) OPER, N, 'But skipped some'
                     CALL MSGWRT (4)
                     IRET = 0
                     GO TO 999
                     END IF
                  N = N + 1
                  DO 60 J = 1,ITYP
                     ANSW(IX,IY,J) = RESULT(J)
 60                  CONTINUE
                  END IF
 70            CONTINUE
 80         CONTINUE
         END IF
      WRITE (MSGTXT,1080) OPER, N, ' '
      CALL MSGWRT (4)
      CALL RFILL (6, 0.0, RANGE)
      CALL RFILL (3, 0.0, ERROR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1080 FORMAT ('UPDALL did ',A,' on',I8,' pixels ',A)
      END
      SUBROUTINE UPDLIS (OPER, NX, NY, NZ, ITYP, IMAGE, ANSW, IRET)
C-----------------------------------------------------------------------
C   UPDLIS flags or re-does fitting on a list of pixels
C   Inputs:
C      OPER     C*4    'REDO', 'FLAG'
C      NX       I      # X pixels
C      NY       I      # Y pixels
C      NZ       I      # freq pixels
C      ITYP     I      # parameters (5, 7)
C   In/out:
C      IMAGE    R(*)   Images of data (NX,NY,NZ)
C      ANSW     R(*)   Answers (NX,NY,ITYP)
C   Output:
C      IRET     I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER OPER*4
      INTEGER   NX, NY, NZ, ITYP, IRET
      REAL      IMAGE(NZ,NX,NY), ANSW(NX,NY,ITYP)
C
      INCLUDE 'TVSPX.INC'
      INTEGER   I, IX, IY, J, N
      REAL      RESULT(7)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (OPER.EQ.'FLAG') THEN
         DO 20 I = 1,NLIST
            IX = PIXLIS(1,I)
            IY = PIXLIS(2,I)
            DO 10 J = 1,ITYP
               ANSW(IX,IY,J) = FBLANK
 10            CONTINUE
 20         CONTINUE
         N = NLIST
C                                       redo
      ELSE
         N = 0
         DO 50 I = 1,NLIST
            IX = PIXLIS(1,I)
            IY = PIXLIS(2,I)
            DO 35 J = 1,ITYP
               RESULT(J) = ANSW(IX,IY,J)
 35            CONTINUE
            CALL SPREDO (NZ, ITYP, IX, IY, IMAGE(1,IX,IY), RESULT, IRET)
            IF (IRET.NE.0) GO TO 60
            N = N + 1
            DO 40 J = 1,ITYP
               ANSW(IX,IY,J) = RESULT(J)
 40            CONTINUE
 50         CONTINUE
         END IF
 60   WRITE (MSGTXT,1080) OPER, N
      CALL MSGWRT (4)
      IF (N.LT.NLIST) THEN
         IX = 2 * (NLIST - N)
         CALL COPY (IX, PIXLIS(1,N+1), PIXLIS(1,1))
         END IF
      NLIST = NLIST - N
      WRITE (MSGTXT,1081) NLIST
      IF (NLIST.GT.0) CALL MSGWRT (4)
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1080 FORMAT ('UPDLIS did ',A,' on',I5,' pixels')
 1081 FORMAT ('There are',I5,' pixels left in the list')
      END
      SUBROUTINE SPREDO (NZ, ITYP, IX, IY, IMAGE, RESULT, IRET)
C-----------------------------------------------------------------------
C   SPREDO displays a spectrum, allows interaction to fit, flag data
C   returns new values to the answer
C   Inputs
C      NZ      I      # spectral points
C      ITYP    I      # answers (5 or 7)
C      IX      I      X pixel
C      IY      I      Y pixel
C      IMAGE   R(*)   spectrum
C   In/Output:
C      RESULT  R(*)   Initial/New fit parms (or blanked)
C      IRET    I      > 0 => quit was selected
C-----------------------------------------------------------------------
      INTEGER   NZ, ITYP, IX, IY, IRET
      REAL      IMAGE(*), RESULT(*)
C
      INCLUDE 'TVSPX.INC'
      INCLUDE 'TVSPX.TV'
      INTEGER   I, J, MCOL, MROWS(1), TVWIND(4), IDROP(2), LABEL,
     *   IDEPTH(5), TVSIZE(2), IX1, IY1, IX2, IY2, ICHL, ICHB, ICHR,
     *   ICHT, NYA, NXA, IDX, IDY, I4XTRA, NTEXT, MTYPE, TIMLIM, TOPSEP,
     *   SIDSEP, GRCHS(2), CHS, TVBUT, IPOS(7), IROUND, NPIX, NROW, IM,
     *   LXPT(MAXFQ), LYPT(MAXFQ), IR, IP, IBUT, ITW(3), QUAD, LBUT
      CHARACTER CHOICS(10)*12, TEXT(2)*80, MSGBUF*80, ISHELP*8, TITLE*80
      REAL      D, LDATA(16384), LRES(7), LMOD(MAXFQ), VMIN, VMAX, YGAP,
     *   RANGE(2), PBLC(2), PTRC(2), XBLC(7), XTRC(7), FQFINC, CH(4),
     *   XYRATO, X, XX, Y, DY, DX, XFAC, XOFF, RPOS(2), PPOS(2), VX, VY,
     *   XM(2)
      LOGICAL   LEAVE(10), DOIT, T, F
      DOUBLE PRECISION FF, FMIN, FMAX, FFMN, FFMX

      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVS.INC'
      DATA CHOICS /'CHAN RANGE', 'RESET CHANS', 'FLAG POINTS',
     *   'UNDO FLAGS', 'NEW FIT', ' ', 'GOOD', 'BAD', ' ', 'QUIT'/
      DATA MCOL, MTYPE, TIMLIM, TOPSEP, SIDSEP /1, -1, 0, 1, 10/
      DATA MROWS /10/
      DATA LRES, IPOS /7*0.0, 7*1/
      DATA IDROP, IDEPTH, LABEL /0,0, 5*1, 3/
      DATA LEAVE /10*.TRUE./
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IRET = 0
C                                       make local copies
      IF (NZ.GT.16384) THEN
         MSGTXT = 'SPECTRUM TOO LARGE FOR ME'
         GO TO 980
         END IF
      IRET = 0
      CALL RCOPY (NZ, IMAGE, LDATA)
      CALL RCOPY (ITYP, RESULT, LRES)
      DO 5 I = 1,ITYP
         IF (LRES(I).EQ.FBLANK) THEN
            CALL RCOPY (ITYP, FBLANK, RESULT)
            WRITE (MSGTXT,1010) IX, IY
            CALL MSGWRT (6)
            GO TO 999
            END IF
 5       CONTINUE
C                                       X axis range
      FMIN = 1.D15
      FMAX = -FMIN
      DO 10 I = 1,NZ
         FF = 10.0D0**XFREQ(I)
         FMIN = MIN (FF, FMIN)
         FMAX = MAX (FF, FMAX)
 10      CONTINUE
      DX = 0.05 * (FMAX - FMIN)
      FMIN = (FMIN - DX) * DEFREQ
      FMAX = (FMAX + DX) * DEFREQ
      FFMN = FMIN
      FFMX = FMAX
      CALL RCOPY (7, BLC, XBLC)
      XBLC(2) = XBLC(2) + IX - 1.0
      XBLC(3) = XBLC(3) + IY - 1.0
      CALL RCOPY (7, XBLC, XTRC)
      XTRC(1) = XBLC(1) + NZ - 1
C                                       Compute model, max/min
 20   D = LOG10 (LRES(2))
      VMIN = 1.E15
      VMAX = -VMIN
      DO 30 I = 1,NZ
         LMOD(I) = D + LRES(4)*XFREQ(I) + LRES(6)*(XFREQ(I)**2)
         LMOD(I) = 10.0**LMOD(I)
         VMIN = MIN (VMIN, LMOD(I))
         VMAX = MAX (VMAX, LMOD(I))
         IF (LDATA(I).NE.FBLANK) THEN
            VMIN = MIN (VMIN, LDATA(I))
            VMAX = MAX (VMAX, LDATA(I))
            END IF
 30      CONTINUE
      DY = 0.05 * (VMAX - VMIN)
      VMIN = VMIN - DY
      VMAX = VMAX + DY
      RANGE(1) = VMIN
      RANGE(2) = VMAX
      CALL YWINDO ('READ', TVWIND, IRET)
      IF (IRET.NE.0) THEN
         TVWIND(1) = 1
         TVWIND(2) = 1
         TVWIND(3) = MAXXTV(1)
         TVWIND(4) = MAXXTV(2)
         END IF
      IF (IRET.NE.0) GO TO 970
      CALL YHOLD ('ONNN', IRET)
      CALL YSLECT ('OFFF', 1, 0, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 970
      DO 35 I = 1,5
         J = I + NGRAY
         CALL YZERO (J, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YSLECT ('ONNN', J, 0, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YCINIT (J, SCRTCH)
 35      CONTINUE
      CATR(IRRAN) = RANGE(1)
      CATR(IRRAN+1) = RANGE(2)
      XFAC = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      XOFF = 40000.0 - XFAC * CATR(IRRAN+1)
      PBLC(2) = RANGE(1) * XFAC + XOFF
      PTRC(2) = RANGE(2) * XFAC + XOFF
C                                       Label inits
      LOCNUM = 1
      I = NZ * 110
      FQFINC = (FFMX - FFMN) / (I-1)
      CALL SLBINI (IDROP, I, RANGE, PBLC, PTRC, XBLC, XTRC, FFMN,
     *   FQFINC, IDEPTH, LABEL, YGAP, CH, TEXT, NTEXT)
      IF (ITYP.LT.7) THEN
         WRITE (TEXT(2),1035) (LRES(I), I=2,5)
      ELSE
         WRITE (TEXT(2),1036) (LRES(I), I=2,7)
         END IF
      NTEXT = 2
      CH(2) = CH(2) + 1.333
      RANGE(1) = XFAC*RANGE(1) + XOFF
      RANGE(2) = XFAC*RANGE(2) + XOFF
      TVSIZE(1) = TVWIND(3) - TVWIND(1) + 1
      TVSIZE(2) = 0.75 * (TVWIND(4) - TVWIND(2) + 1)
      XYRATO = (PTRC(2) - PBLC(2)) / (PTRC(1) - PBLC(1))
      IX1 = PBLC(1) + .5
      IY1 = PBLC(2) + .5
      IX2 = PTRC(1) + .5
      IY2 = PTRC(2) + .5
      ICHL = CH(1) * CSIZTV(1) + .5
      ICHB = CH(2) * CSIZTV(2) + .5
      ICHR = CH(3) * CSIZTV(1) + .5
      ICHT = CH(4) * CSIZTV(2) + .5
      NYA = TVSIZE(2) - ICHT -ICHB -1
      NXA = TVSIZE(1) - ICHL - ICHR - 1
C                                       compute scaling
      X = IX2
      X = ABS (X - IX1)
      XX = X * XYRATO
      Y = IY2
      Y = ABS (Y - IY1)
      IF ((XX.LE.0.0) .OR. (Y.LE.0.0)) THEN
         MSGTXT = 'SCALING ERROR'
         CALL MSGWRT (8)
         IRET = 1
         GO TO 999
         END IF
      IF ((XX/Y).LE.FLOAT(NXA)/FLOAT(NYA)) THEN
         SCALEY = NYA / Y
         SCALEX = SCALEY * Y / X * FLOAT(TVSIZE(1)) / FLOAT(TVSIZE(2))
      ELSE
         SCALEX = NXA / X
         SCALEY = SCALEX * X / Y
         END IF
C
      NXA = SCALEX * X + ICHL + ICHR
      IF (NXA.GE.TVSIZE(1)) THEN
         SCALEX = SCALEX * (FLOAT(TVSIZE(1)) / (NXA + 5.0))
         SCALEY = SCALEY * (FLOAT(TVSIZE(1)) / (NXA + 5.0))
         NXA = SCALEX * X + ICHL + ICHR
         END IF
      NYA = SCALEY * Y + ICHB + ICHT
      IF (NXA.GE.TVSIZE(1)) THEN
         SCALEX = SCALEX * (FLOAT(TVSIZE(2)) / (NYA + 5.0))
         SCALEY = SCALEY * (FLOAT(TVSIZE(2)) / (NYA + 5.0))
         NXA = SCALEX * X + ICHL + ICHR
         NYA = SCALEY * Y + ICHB + ICHT
         END IF
      RX0 = ICHL + MAX (0, TVSIZE(1)-NXA) / 2 + TVWIND(1)
      RY0 = ICHB + MAX (0, TVSIZE(2)-NYA) / 2 + TVWIND(2)
C                                       Put stuff in image catalog.
      CATBLK(IIWIN  ) = IX1
      CATBLK(IIWIN+1) = IY1
      CATBLK(IIWIN+2) = IX2
      CATBLK(IIWIN+3) = IY2
      CATBLK(IICOR  ) = RX0 + 0.5
      CATBLK(IICOR+1) = RY0 + 0.5
      CATBLK(IICOR+2) = RX0 + X * SCALEX + 0.5
      CATBLK(IICOR+3) = RY0 + Y * SCALEY + 0.5
      CATBLK(IIPLT) = 5
      CATBLK(IIOTH) = LABEL
      CATBLK(IIOTH+1) = IDROP(1)
      CATBLK(IIOTH+2) = IDROP(2)
      I4XTRA = IIOTH + 3
      CATR(I4XTRA  ) = XBLC(1)
      CATR(I4XTRA+1) = XBLC(2)
      CATR(I4XTRA+2) = XTRC(1)
      CATR(I4XTRA+3) = XTRC(2)
C                                       Update image catalog
      CALL YCWRIT (IGR5, CATBLK(IICOR), CATBLK, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'TV IMAGE CATALOG ERROR'
         CALL MSGWRT (6)
         END IF
C                                       set scale for plot routines
      RX0 = RX0 - PBLC(1) * SCALEX + 0.5
      RY0 = RY0 - PBLC(2) * SCALEY + 0.5
C                                       label the plot
      IGR = IGR5
      CALL TVLAB (PBLC, PTRC, LABEL, YGAP, TEXT, NTEXT, CH, .FALSE.,
     *   IRET)
      IF (IRET.NE.0) GO TO 970
C                                       add pixel coordinates
      DX = PTRC(1)*SCALEX + RX0 - 8.5 * CSIZTV(1)
      DY = PTRC(2)*SCALEY + RY0 - 2.0 * CSIZTV(2)
      IDX = DX + 0.5
      IDY = DY + 0.5
      WRITE (MSGBUF,1060) IX
      CALL IMCHAR (IGR, IDX, IDY, 0, 0, MSGBUF(:7), SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 970
      DY = DY - 1.5 * CSIZTV(2)
      IDY = DY + 0.5
      WRITE (MSGBUF,1061) IY
      CALL IMCHAR (IGR, IDX, IDY, 0, 0, MSGBUF(:7), SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       add pixel coordinates
      DX = 0.02* (PTRC(1) - PBLC(1))
      DY = 0.02* (PTRC(2) - PBLC(2))
      IGR = IGR4
      CALL FILL (NZ, -10000, LXPT)
      CALL FILL (NZ, -10000, LYPT)
      DO 50 I = 1,NZ
         FF = (10.0D0**XFREQ(I)) * DEFREQ
         IF ((LDATA(I).NE.FBLANK) .AND. (FF.GE.FFMN) .AND. (FF.LT.FFMX))
     *      THEN
            X = (FF - FFMN) / (FFMX - FFMN)
            LXPT(I) = X * (CATBLK(IICOR+2) - CATBLK(IICOR)) +
     *         CATBLK(IICOR)
            X = X * (PTRC(1) - PBLC(1)) + PBLC(1)
            Y = (LDATA(I) - VMIN) / (VMAX - VMIN)
            LYPT(I) = Y * (CATBLK(IICOR+3) - CATBLK(IICOR+1)) +
     *         CATBLK(IICOR+1)
            Y = Y * (PTRC(2) - PBLC(2)) + PBLC(2)
            CALL TVVEC (X+DX, Y, 1, IRET)
            IF (IRET.EQ.0) CALL TVVEC (X-DX, Y, 2, IRET)
            IF (IRET.EQ.0) CALL TVVEC (X, Y+DY, 1, IRET)
            IF (IRET.EQ.0) CALL TVVEC (X, Y-DY, 2, IRET)
            IF (IRET.NE.0) GO TO 970
            END IF
 50      CONTINUE
      J = 1
      DO 60 I = 1,NZ
         FF = (10.0D0**XFREQ(I)) * DEFREQ
         IF ((FF.GE.FFMN) .AND. (FF.LE.FFMX)) THEN
            X = (FF - FFMN) / (FFMX - FFMN)
            X = X * (PTRC(1) - PBLC(1)) + PBLC(1)
            Y = (LMOD(I) - VMIN) / (VMAX - VMIN)
            Y = Y * (PTRC(2) - PBLC(2)) + PBLC(2)
            CALL TVVEC (X, Y, J, IRET)
            IF (IRET.NE.0) GO TO 970
            J = 2
            END IF
 60      CONTINUE
      CALL YHOLD ('FFFF', IRET)
      GRCHS(1) = 2
      GRCHS(2) = 1
      RPOS(1) = MAXXTV(1) / 2
      RPOS(2) = MAXXTV(2) / 2
      ISHELP = TSKNAM
      TITLE = ' '
 100  CALL TVMENU (MTYPE, MCOL, MROWS, GRCHS, TOPSEP, SIDSEP, ISHELP,
     *   CHOICS, TIMLIM, LEAVE, 1, TITLE, CHS, TVBUT, IBUFF2, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'RETURNED FROM TVMENU'
         GO TO 980
         END IF
C                                       case statement
C                                       exit
      IF (CHOICS(CHS).EQ.'GOOD') THEN
         CALL RCOPY (ITYP, LRES, RESULT)
         GO TO 990
      ELSE IF (CHOICS(CHS).EQ.'BAD') THEN
         CALL RFILL (ITYP, FBLANK, RESULT)
         GO TO 990
      ELSE IF (CHOICS(CHS).EQ.'QUIT') THEN
         IRET = 1
         GO TO 990
      ELSE IF (CHOICS(CHS).EQ.'RESET CHANS') THEN
         FFMN = FMIN
         FFMX = FMAX
         GO TO 20
      ELSE IF (CHOICS(CHS).EQ.'CHAN RANGE') THEN
         CALL YZERO (IGR1, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YZERO (IGR2, IRET)
         IF (IRET.NE.0) GO TO 970
         NPIX = 16 * CSIZTV(1)
         NROW = 3 * CSIZTV(2)
         IX1 = WINDTV(1)
         IY1 = WINDTV(4) - NROW + 1
         IF (IX1+NPIX-1.GT.MAXXTV(1)) IX1 = 1
         IF (IY1+NROW-1.GT.MAXXTV(2)) IY1 = MAXXTV(2) - NROW + 1
         IX2 = IX1 + NPIX - 1
         IY2 = IY1 + NROW - 1
         CALL YFILL (IGR2, IX1, IY1, IX2, IY2, 0, IBUFF2, IRET)
         IF (IRET.NE.0) GO TO 970
         WRITE (MSGTXT,1090)
         CALL MSGWRT (1)
         WRITE (MSGTXT,1092)
         CALL MSGWRT (1)
         WRITE (MSGTXT,1093)
         CALL MSGWRT (1)
         CALL ZTIME (ITW)
         RPOS(1) = (CATBLK(IICOR) + CATBLK(IICOR+2)) / 2
         RPOS(2) = (CATBLK(IICOR+1) + CATBLK(IICOR+3)) / 2
         CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IRET)
         IF (IRET.NE.0) GO TO 970
         XM(1) = FFMN
         XM(2) = FFMX
         IM = 1
 110     IGR = IGR3
         X = (XM(1) - FFMN) / (FFMX - FFMN)
         X = X * (PTRC(1) - PBLC(1)) + PBLC(1)
         CALL TVVEC (X, PBLC(2), 1, IRET)
         IF (IRET.EQ.0) CALL TVVEC (X, PTRC(2), 2, IRET)
         X = (XM(2) - FFMN) / (FFMX - FFMN)
         X = X * (PTRC(1) - PBLC(1)) + PBLC(1)
         CALL TVVEC (X, PBLC(2), 1, IRET)
         IF (IRET.EQ.0) CALL TVVEC (X, PTRC(2), 2, IRET)
C                                       Cursor read loop point
         CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF (DOIT) THEN
            LBUT = IBUT
C                                       Display coordinate
            QUAD = 0
            CALL YCURSE ('FXIT', F, T, RPOS, QUAD, IBUT, IRET)
            IF (RPOS(1).LT.CATBLK(IICOR)) RPOS(1) = CATBLK(IICOR)
            IF (RPOS(1).GT.CATBLK(IICOR+2)) RPOS(1) = CATBLK(IICOR+2)
            IF (RPOS(2).LT.CATBLK(IICOR+1)) RPOS(2) = CATBLK(IICOR+1)
            IF (RPOS(2).GT.CATBLK(IICOR+3)) RPOS(2) = CATBLK(IICOR+3)
            VX = (RPOS(1) - CATBLK(IICOR)) * (FFMX - FFMN) /
     *         (CATBLK(IICOR+2)-CATBLK(IICOR)) + FFMN
            VY = (RPOS(2) - CATBLK(IICOR+1)) * (VMAX - VMIN) /
     *         (CATBLK(IICOR+3)-CATBLK(IICOR+1)) + VMIN
            IF (IM.EQ.2) THEN
               VX = MAX (VX, XM(1))
            ELSE
               VX = MIN (VX, XM(2))
               END IF
            RPOS(1) = (VX - FFMN) * (CATBLK(IICOR+2)-CATBLK(IICOR)) /
     *         (FFMX - FFMN) + CATBLK(IICOR)
            WRITE (MSGBUF,1115) VY
            I = IY1 + 1.5*CSIZTV(2)
            CALL IMCHAR (IGR2, IX1, I, 0, 0, MSGBUF(:18), IBUFF2, IRET)
            IF (IRET.NE.0) GO TO 970
            WRITE (MSGBUF,1116) VX
            CALL IMCHAR (IGR2, IX1, IY1, 0, 0, MSGBUF(:14), IBUFF2,
     *         IRET)
            IF (IRET.NE.0) GO TO 970
            X = (XM(1) - FFMN) / (FFMX - FFMN)
            X = X * (PTRC(1) - PBLC(1)) + PBLC(1)
            CALL TVVEC (X, PBLC(2), 1, IRET)
            IF (IRET.EQ.0) CALL TVVEC (X, PTRC(2), 3, IRET)
            X = (XM(2) - FFMN) / (FFMX - FFMN)
            X = X * (PTRC(1) - PBLC(1)) + PBLC(1)
            CALL TVVEC (X, PBLC(2), 1, IRET)
            IF (IRET.EQ.0) CALL TVVEC (X, PTRC(2), 3, IRET)
            XM(IM) = VX
            IF ((LBUT.GT.0) .AND. (LBUT.LE.3)) THEN
               IM = 3 - IM
               IF (IM.EQ.1) THEN
                  WRITE (MSGTXT,1090)
               ELSE
                  WRITE (MSGTXT,1091)
                  END IF
               CALL MSGWRT (1)
               END IF
            END IF
         IF (LBUT.LE.3) GO TO 110
         FFMN = XM(1)
         FFMX = XM(2)
         CALL YZERO (IGR3, IRET)
         IF (IRET.NE.0) GO TO 970
         GO TO 20
C                                       blank
      ELSE IF (CHOICS(CHS).EQ.' ') THEN
C                                       undo flags
      ELSE IF (CHOICS(CHS).EQ.'UNDO FLAGS') THEN
         CALL RCOPY (NZ, IMAGE, LDATA)
         CALL RCOPY (ITYP, RESULT, LRES)
         GO TO 20
      ELSE IF (CHOICS(CHS).EQ.'NEW FIT') THEN
         IPOS(1) = IROUND (BLC(1))
         IPOS(2) = IX
         IPOS(3) = IY
         IF (ITYP.LT.7) THEN
            CALL DO1SPX (IPOS, LDATA, LRES)
         ELSE
            CALL DO2SPX (IPOS, LDATA, LRES)
            END IF
         IF (LRES(2).EQ.FBLANK) THEN
            MSGTXT = '****** FIT FAILED, UNDOING FLAGS ******'
            CALL MSGWRT (6)
            MSGTXT = '*** YOU SHOULD PROBABLY MARK IT BAD ***'
            CALL MSGWRT (6)
            CALL RCOPY (NZ, IMAGE, LDATA)
            CALL RCOPY (ITYP, RESULT, LRES)
            END IF
         GO TO 20
      ELSE IF (CHOICS(CHS).EQ.'FLAG POINTS') THEN
         CALL YZERO (IGR1, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YZERO (IGR2, IRET)
         IF (IRET.NE.0) GO TO 970
         NPIX = 16 * CSIZTV(1)
         NROW = 3 * CSIZTV(2)
         IX1 = WINDTV(1)
         IY1 = WINDTV(4) - NROW + 1
         IF (IX1+NPIX-1.GT.MAXXTV(1)) IX1 = 1
         IF (IY1+NROW-1.GT.MAXXTV(2)) IY1 = MAXXTV(2) - NROW + 1
         IX2 = IX1 + NPIX - 1
         IY2 = IY1 + NROW - 1
         CALL YFILL (IGR2, IX1, IY1, IX2, IY2, 0, IBUFF2, IRET)
         IF (IRET.NE.0) GO TO 970
         WRITE (MSGTXT,1100)
         CALL MSGWRT (1)
         WRITE (MSGTXT,1101)
         CALL MSGWRT (1)
         WRITE (MSGTXT,1102)
         CALL MSGWRT (1)
         CALL ZTIME (ITW)
         RPOS(1) = (CATBLK(IICOR) + CATBLK(IICOR+2)) / 2
         RPOS(2) = (CATBLK(IICOR+1) + CATBLK(IICOR+3)) / 2
         CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IRET)
         IF (IRET.NE.0) GO TO 970
C                                       Cursor read loop point
 115     CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IRET)
         IF (IRET.NE.0) GO TO 970
         IF (IBUT.GE.4) GO TO 100
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF (DOIT) THEN
            LBUT = IBUT
C                                       Find new image catalog block
            QUAD = 0
            CALL YCURSE ('FXIT', F, T, RPOS, QUAD, IBUT, IRET)
            VX = (RPOS(1) - CATBLK(IICOR)) * (FFMX - FFMN) /
     *         (CATBLK(IICOR+2)-CATBLK(IICOR)) + FFMN
            VY = (RPOS(2) - CATBLK(IICOR+1)) * (VMAX - VMIN) /
     *         (CATBLK(IICOR+3)-CATBLK(IICOR+1)) + VMIN
            WRITE (MSGBUF,1115) VY
            I = IY1 + 1.5*CSIZTV(2)
            CALL IMCHAR (IGR2, IX1, I, 0, 0, MSGBUF(:18), IBUFF2, IRET)
            IF (IRET.NE.0) GO TO 970
            WRITE (MSGBUF,1116) VX/1.E9
            CALL IMCHAR (IGR2, IX1, IY1, 0, 0, MSGBUF(:14), IBUFF2,
     *         IRET)
            IF (IRET.NE.0) GO TO 970
            IF (LBUT.GT.0) THEN
               IP = 0
               IR = 100000
               DO 120 I = 1,NZ
                  XX = (RPOS(1)-LXPT(I))**2 + (RPOS(2)-LYPT(I))**2
                  IF (XX.LT.IR) THEN
                     IR = XX + 0.5
                     IP = I
                     END IF
 120              CONTINUE
               IF (IR.LT.100) THEN
                  DX = 0.02* (PTRC(1) - PBLC(1))
                  DY = 0.02* (PTRC(2) - PBLC(2))
                  IGR = IGR3
                  FF = (10.0D0**XFREQ(IP)) * DEFREQ
                  X = (FF - FFMN) / (FFMX - FFMN)
                  X = X * (PTRC(1) - PBLC(1)) + PBLC(1)
                  Y = (LDATA(IP) - VMIN) / (VMAX - VMIN)
                  Y = Y * (PTRC(2) - PBLC(2)) + PBLC(2)
                  CALL TVVEC (X+DX, Y, 1, IRET)
                  IF (IRET.EQ.0) CALL TVVEC (X-DX, Y, 2, IRET)
                  IF (IRET.EQ.0) CALL TVVEC (X, Y+DY, 1, IRET)
                  IF (IRET.EQ.0) CALL TVVEC (X, Y-DY, 2, IRET)
                  IF (IRET.NE.0) GO TO 970
                  LDATA(IP) = FBLANK
                  END IF
               END IF
            END IF
         GO TO 115
         END IF
      GO TO 100
C
 970  WRITE (MSGTXT,1000) IRET, 'TV FUNCTION'
C
 980  CALL MSGWRT (8)
C
 990  CALL YINIT (BUFF1, I)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPREDO ERROR',I4,' ON ',A)
 1010 FORMAT ('SPREDO: PIXEL IX, IY=',2I6,' ALREADY FAILED')
 1035 FORMAT ('T0=',F8.5,' (',F7.5,') SP=',F7.3,' (',F6.3,')')
 1036 FORMAT ('T0=',F8.5,' (',F7.5,') SP=',F7.3,' (',F6.3,') CU=',F7.3,
     *   ' (',F6.3,')')
 1060 FORMAT ('X=',I5)
 1061 FORMAT ('Y=',I5)
 1090 FORMAT ('Setting lower limit')
 1091 FORMAT ('Setting lower limit')
 1092 FORMAT ('Hit button A or B to switch to other limit')
 1093 FORMAT ('Hit button C or D to exit')
 1100 FORMAT ('Cursor selects which pixel is displayed')
 1101 FORMAT ('Hit button A or B to flag a point')
 1102 FORMAT ('Hit button C or D to exit flagging')
 1115 FORMAT (F10.5,' Jy/beam')
 1116 FORMAT (F10.5,' GHz')
      END
      SUBROUTINE SPIXOU (BLNKD, NX, NY, ITYP, ANSW, IRET)
C-----------------------------------------------------------------------
C   SPIXOU creates and fills (via PSCALE) the individual spix maps.
C   It calls SPIXHI for history info for all images.
C   Inputs
C      BLNKD    L      there are blank pixels
C      NX       I      # X pixels
C      NY       I      # Y pixels
C      ITYP     I      # answers (5 or 7)
C      ANSW     R(*)   Answer images
C   Output:
c      IRET    I      0 => ok,  4 => real trouble.
C------------------------------------------------------------------------
      LOGICAL   BLNKD
      INTEGER   NX, NY, ITYP, IRET
      REAL      ANSW(NX,NY,*)
C
      CHARACTER CLAOUT*6, SEQTYP*6
      INTEGER   NXO, NYO, WINI(4), WINO(4), IERR, IG, IP, NP, IY, IX
      REAL      PMX, PMN
      INCLUDE 'TVSPX.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       loop limits etc.
      WINO(1) = 1
      WINO(2) = 1
      NP = 5
      IF (OPTYPE.EQ.'CURV') NP = 7
C                                       Output spectral index parms
      DO 40 IG = 1,NP
         IP = NCFILE - NP + IG
         NEWCNO = FCNO(IP)
         DISKO = FVOL(IP)
         CALL CATIO ('READ', DISKO, NEWCNO, CATBLK, 'REST', SCRTCH,
     *        IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.6)) THEN
            WRITE (MSGTXT,1010) IERR, IP
            GO TO 990
            END IF
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), SEQTYP)
         WRITE (MSGTXT,1020) SEQTYP
         CALL MSGWRT (1)
         SEQOUT = CATBLK(KIIMS)
         CALL H2CHR (12, KHIMNO, CATH(KHIMNO), NAMOUT)
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), CLAOUT)
         NXO = CATBLK(KINAX)
         NYO = CATBLK(KINAX+1)
         WINI(4) = NXO
         WINO(3) = NXO
         WINO(4) = NYO
         PMX = -1.E15
         PMN = -PMX
         DO 20 IY = 1,NY
            DO 15 IX = 1,IX
               IF (ANSW(IX,IY,IG).NE.FBLANK) THEN
                  PMX = MAX (PMX, ANSW(IX,IY,IG))
                  PMN = MIN (PMN, ANSW(IX,IY,IG))
               ELSE
                  BLNKD = .TRUE.
                  END IF
 15            CONTINUE
 20         CONTINUE
C                                       Fill image
         CALL PSCALE (NEWCNO, DISKO, WINO, JBUFSZ, NX, ANSW(1,1,IG),
     *        PMX, PMN, BLNKD, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1021) IERR, SEQTYP
            GO TO 990
            END IF
C                                       History, close
         CALL SPIXHI (IP, CLAOUT)
 40      CONTINUE
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
      IRET = 4
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SPIXOU ERROR',I5,' RECOVERING HEADER NUMBER',I5)
 1020 FORMAT ('Begin writing file of type ',A6)
 1021 FORMAT ('ERROR',I5,' MOVING DATA TO FILE TYPE ',A6)
      END
      SUBROUTINE PSCALE (NEWCNO, DISKO, WINO, JBUFSZ, NX, ANSW, PMAX,
     *   PMIN, BLNKD, IERR)
C-----------------------------------------------------------------------
C   PSCALE copies an in memory image to output file
C   Inputs:
C      NEWCNO   I      Output catalog number
C      DISKO    I      Output disk number
C      WINO     I(4)   Output Window
C      JBUFSZ   I      Buffer size in bytes
C      NX       I      # points on 1st axis
C      ANSW     R(*)   image
C      PMAX     R(*)   Max values by columns
C      PMIN     R(*)   Min values by columns
C      BLNKD    L      Image is blanked
C   Output:
C      IERR     I      0 -> ok, else IO error
C      CATBLK in common: change max/min and scaling and blanking
C      Buffers in common
C-----------------------------------------------------------------------
      INTEGER   NEWCNO, DISKO, WINO(4), JBUFSZ, NX, IERR
      REAL      ANSW(NX,*), PMAX, PMIN
      LOGICAL   BLNKD
C
      CHARACTER PHNAME*48
      INTEGER   NXO, L3, L4, L5, L6, L7, I3, I4, I5, I6, I7, LUNO, INDO,
     *   IPOS(8), BOTEMP, OBIND, JERR
      LOGICAL   T
      INCLUDE 'XMBUFRS'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNO /17/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Set maxima, clear blanking
      CATR(KRDMX) = PMAX
      CATR(KRDMN) = PMIN
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
C                                       loop limits
      L3 = CATBLK(KINAX+1)
      L4 = CATBLK(KINAX+2)
      L5 = CATBLK(KINAX+3)
      L6 = CATBLK(KINAX+4)
      L7 = CATBLK(KINAX+5)
      NXO = WINO(3)
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, PHNAME, IERR)
      CALL ZOPEN (LUNO, INDO, DISKO, PHNAME, T, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN OUTPUT FILE'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       loop
      DO 700 I7 = 1,L7
         IPOS(7) = I7
         DO 600 I6 = 1,L6
            IPOS(6) = I6
            DO 500 I5 = 1,L5
               IPOS(5) = I5
               DO 400 I4 = 1,L4
                  IPOS(4) = I4
C                                       Init output
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IPOS(4), BOTEMP, IERR)
      BOTEMP = BOTEMP + 1
      CALL MINIT ('WRIT', LUNO, INDO, WINO(3), WINO(4), WINO, BUFF2,
     *   JBUFSZ, BOTEMP, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INIT OUTPUT I/O'
         GO TO 970
         END IF
      DO 300 I3 = 1,L3
C                                       Init a write
         CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'WRITING OUTPUT FILE'
            GO TO 970
            END IF
         CALL RCOPY (NXO, ANSW(1,I3), BUFF2(OBIND))
 300     CONTINUE
C                                       Flush output plane
      CALL MDISK ('FINI', LUNO, INDO, BUFF2, OBIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FINISHING OUTPUT I/O'
         GO TO 970
         END IF
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
      GO TO 980
C                                       Close down (error)
 970  CALL MSGWRT (8)
C                                       Close files
 980  CALL ZCLOSE (LUNO, INDO, JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PSCALE: ERROR',I5,' ON ',A)
      END
      SUBROUTINE SPIXHI (NCN, CLAOUT)
C-----------------------------------------------------------------------
C   SPIXHI copies and updates history file.
C   Inputs:
C      NCN      I     Index in catlgd files common
C      CLAOUT   C*6   Output map CLASS
C-----------------------------------------------------------------------
      CHARACTER CLAOUT*6
      INTEGER   NCN
C
      CHARACTER LABEL*8, DCOM(9)*14, HILINE*72, CCOM(3)*14
      INTEGER   LUN1, LUN2, IERR, I
      REAL      DMIN(9)
      LOGICAL   T
      INCLUDE 'TVSPX.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA DMIN / 0.0, -1.E7, -1.E7, 0.0, 0.0, 0.0, 0.0, -1.E7, -1.E7/
      DATA DCOM /'Num pix < D(1)', 'Spix < D(2)', 'Spix > D(3)',
     *   'T/Tmin < D(4)', 'T/Tmax < D(5)', 'T < D(6)',
     *   'T > D(7)', 'Curv < D(8)', 'Curv > D(9)'/
      DATA CCOM /'Error T > C(1)', 'Error Sp> C(2)', 'Error C > C(3)'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   SCRTCH(257), SCRTCH, IERR)
      IF (IERR.LE.2) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 50
C                                       New history
 10   CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, SCRTCH,
     *   IERR)
      IF (IERR.NE.0) GO TO 50
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       BLC
      WRITE (HILINE,2000) TSKNAM, BLC
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       TRC
      WRITE (HILINE,2001) TSKNAM, TRC
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       other Parms
      CALL H2CHR (8, 1, CATOH(KHBUN), LABEL)
      WRITE (HILINE,2002) TSKNAM, FCUT, LABEL
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       Old axis 1
      CALL H2CHR (8, 1, CATOH(KHCTP), LABEL)
      WRITE (HILINE,2020) TSKNAM, LABEL
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 50
      WRITE (HILINE,2021) TSKNAM, CATOLD(KINAX)
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 50
      WRITE (HILINE,2022) TSKNAM, CATOR(KRCRP)
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 50
      WRITE (HILINE,2023) TSKNAM, CATOR(KRCIC)
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 50
      WRITE (HILINE,2024) TSKNAM, CATOD(KDCRV)
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       ref freq
      WRITE (HILINE,2025) TSKNAM, REFREQ
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       Cutoffs
      DO 30 I = 1,9
         IF ((DPARM(I).GT.DMIN(I)) .AND. (DPARM(I).LT.1.E7)) THEN
            WRITE (HILINE,2030) TSKNAM, I, DPARM(I), DCOM(I)
            CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 50
            END IF
 30      CONTINUE
      DO 35 I = 1,3
         IF (CPARM(I).LE.1.E7) THEN
            WRITE (HILINE,2031) TSKNAM, I, CPARM(I), CCOM(I)
            CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 50
            END IF
 35      CONTINUE
C                                       blanked
      IF (DPARM(10).GT.0.0) THEN
         I = DPARM(10)
         WRITE (HILINE,2032) TSKNAM, I
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 50
         MSGTXT = HILINE(9:)
         IF (NCN.EQ.NCFILE) CALL MSGWRT (4)
         END IF
C                                       good
      WRITE (HILINE,2033) TSKNAM, NGOOD
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 50
      MSGTXT = HILINE(9:)
      IF (NCN.EQ.NCFILE) CALL MSGWRT (4)
C                                       Close HI file
 50   CALL HICLOS (LUN2, T, SCRTCH, IERR)
C                                        Update CATBLK and close
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'CLWR', SCRTCH, IERR)
      FRW(NCN) = -1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPIXHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 2000 FORMAT (A6,'BLC =',6(F6.0,','),F6.0)
 2001 FORMAT (A6,'TRC =',6(F6.0,','),F6.0)
 2002 FORMAT (A6,'FLUX =',1PE12.4,14X,'/ Use only t > flux ',A8)
 2020 FORMAT (A6,'CTYPE1  = ''',A8,'''',12X,'/ Old axis 1')
 2021 FORMAT (A6,'NAXIS1  = ',I6,16X,'/ Old axis 1')
 2022 FORMAT (A6,'CRPIX1  = ',F9.3,13X,'/ Old axis 1')
 2023 FORMAT (A6,'CDELT1  = ',1PE13.5,9X,'/ Old axis 1')
 2024 FORMAT (A6,'CRVAL1  = ',1PE18.10,4X,'/ Old axis 1')
 2025 FORMAT (A6,'REFREQ = ',F9.4,4X,'/ reference frequency GHz')
 2030 FORMAT (A6,'DPARM(',I1,')= ',F12.3,4X,
     *   '/ Flag solution if ',A)
 2031 FORMAT (A6,'CPARM(',I1,')= ',F12.3,4X,
     *   '/ Flag solution if ',A)
 2032 FORMAT (A6,'/ Number possible solutions flagged=',I10)
 2033 FORMAT (A6,'/ Number good solutions=',I10)
      END

LOCAL INCLUDE 'BPEPL.INC'
      INCLUDE 'INCS:PUVD.INC'
      REAL      XSEQ, XDISK, XVER, XFQ, XSUB, XTIME(8), XBCHAN, XECHAN,
     *   XBIF, XEIF, XANT(50), XDO3C, APARM(10), XLTYPE, XDOTV, XCHAN,
     *   XYRATO, XIMSIZ(2), XBADD(10)
      HOLLERITH XINNAM(3), XINCLS(2)
      CHARACTER INNAM*12, INCLS*6, TTYPE*2, IPOLC(2)*1
      COMMON /INPARM/ XINNAM, XINCLS, XSEQ, XDISK, XVER, XFQ, XSUB,
     *   XTIME, XBCHAN, XECHAN, XBIF, XEIF, XANT, XDO3C, APARM,
     *   XLTYPE, XDOTV, XCHAN, XYRATO, XIMSIZ, XBADD
      COMMON /CHPARM/ INNAM, INCLS, TTYPE, IPOLC
      INTEGER   INSEQ, INDISK, INVERS, CNO, IUSER, BIF, EIF, BPOL, EPOL,
     *   BCHAN, ECHAN, PBUFF(256), FQID, SUBARR, NPARMS, PLUN, PFIND,
     *   LABEL, IANTS(MAXANT), DO3COL, NIANTS, LTYPE, DOPLAN
      LOGICAL   DOTV
      DOUBLE PRECISION TIME, TIMBEG, TIMEND, TPLBEG, TPLEND
      REAL      ARANGE(2), PRANGE(2), SAPARM(10), COLV, DCOLV, AMAX,
     *   AMIN, PMAX, PMIN, BLC(7), TRC(7)
      COMMON /BPEPLC/ TIME, TIMBEG, TIMEND, TPLBEG, TPLEND, PBUFF,
     *   INSEQ, INDISK, INVERS, CNO, IUSER, BIF, EIF, BPOL, EPOL, BCHAN,
     *   ECHAN, FQID, SUBARR, NPARMS, PLUN, PFIND, LABEL, IANTS, ARANGE,
     *   DO3COL, NIANTS, LTYPE, PRANGE, SAPARM, DOPLAN, AMIN, AMAX,
     *   PMIN, PMAX, DOTV, COLV, DCOLV, BLC, TRC
      INCLUDE 'INCS:DBPC.INC'
LOCAL END
      PROGRAM BPEPL
C-----------------------------------------------------------------------
C! Plots bandpass table profiles with times overlapped
C# EXT-appl Calibration Plot
C-----------------------------------------------------------------------
C;  Copyright (C) 2020-2021, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Plots bandpass table with times overlapping
C   Inputs from user
C      USERID.....Input file user number.  ignored
C                 32000 => any user.
C      INNAME.....Input UV file name (name).      Standard defaults.
C      INCLASS....Input UV file name (class).     Standard defaults.
C      INSEQ......Input UV file name (seq. #).    0 => highest.
C      INDISK.....Disk drive # of input UV file.  0 => any.
C      INVERS.....Specifies the version of the BP table to be read as
C                 input.   0 -> highest.
C                 The output version is always highest + 1.
C      FREQID.....Frequency ID, 0 -> 1
C      SUBARRAY...Limit to subarray #.
C      TIMERANG...Time range
C      BCHAN......Lowest channel of a range of channels to be plotted.
C                 0 => 1.
C      ECHAN......Highest channel number to be plotted.  0 => highest.
C      BIF........Lowest IF to be plotted.  0 => 1
C      EIF........Highest IF to be plotted.  0 => highest.
C      ANTENNAS...List of antennas to do
C      CROWDED....> 0 overplot all times
C      DO3COLOR...> 0 use color to separate times
C      APARM......(1,2) amplitude range; (3,4) phase range
C      LTYPE......Labelling type: 1 = border, 2 = no ticks, 3 or 7 =
C                 standard, 4 or 8 = relative to ref. pixel, 5 or 9 =
C                 relative to subimage (BLC, TRC) center, 6 or 10 =
C                 pixels. 7-10 all labels other than tick numbers and
C                 axis type are omitted.  Less than 0 is the same except
C                 that the plot file version number and create time are
C                 omitted.
C      DOTV.......> 0 => plot directly on the TV device, otherwise make
C                 plot files for later display on one or more devices
C                 (including the TV if desired).
C      GRCHAN.....Graphics channel (1 - 7) to use for line drawing.
C                 0 => 1.
C      BADDISK....Disks to avoid
C-----------------------------------------------------------------------
      INTEGER   IRET
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'BPEPL.INC'
C-----------------------------------------------------------------------
C                                       Get parms, open things
      CALL BPEPLI (IRET)
C                                       do plotting
      IF (IRET.EQ.0) CALL BPEPLT (IRET)
C                                       close down
      CALL DIE (IRET, PBUFF)
C
 999  STOP
      END
      SUBROUTINE BPEPLI (IERR)
C-----------------------------------------------------------------------
C   BPEPLI performs initialization for AIPS task BPEPL.  It gets the
C   adverbs, opens the catalog file for 'READ' (eventually), sorts and
C   opens the BP input file, and determines which FQs, times, and
C   antenna counts apply to the table.
C   Output:
C      IERR    I      Error code: 0 => keep going, else quit.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'BPEPL.INC'
      CHARACTER INTYP*2, STAT*4, PRGN*6, KEYSBP(2)*24, LTYPBP*8
      INTEGER   IROUND, BPLUN, JERR, J, KEY(2,2), NKEY, KOLS(2), J1, J2,
     *   KEYSUB(2,2), I, IST, DROUND
      REAL      FKEY(2,2), TEMP
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA BPLUN, INTYP /27, 'UV'/
      DATA PRGN /'BPEPL '/
      DATA NKEY /2/
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
      DATA KEYSBP /'ANTENNA ', 'TIME '/
C-----------------------------------------------------------------------
C                                       AIPS init
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NCFILE = 0
      NSCR = 0
C                                       get adverbs
      NPARMS = 99
      IERR = 0
      CALL GTPARM (PRGN, NPARMS, RQUICK, XINNAM, BPBUFF, JERR)
      IF (JERR.NE.0) THEN
         RQUICK = .TRUE.
         IERR = 8
         IF (JERR.EQ.1) THEN
            GO TO 999
         ELSE
            WRITE (MSGTXT,1000) JERR, 'GET INPUT ADVERBS'
            CALL MSGWRT (8)
            END IF
         END IF
C                                       restart AIPS
      IF (RQUICK) CALL RELPOP (IERR, BPBUFF, JERR)
      IF (IERR.NE.0) GO TO 999
C                                       Hollerith -> Char
      CALL H2CHR (12, 1, XINNAM, INNAM)
      CALL H2CHR (6, 1, XINCLS, INCLS)
      INSEQ = IROUND (XSEQ)
      INDISK = IROUND (XDISK)
      INVERS = IROUND (XVER)
      IUSER = NLUSER
      CNO = 1
      CALL CATDIR ('SRCH', INDISK, CNO, INNAM, INCLS, INSEQ, INTYP,
     *   IUSER, STAT, BPBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, INNAM, INCLS, INSEQ, INTYP,
     *      INDISK, IUSER
         GO TO 990
         END IF
C                                       Get catblk, mark file write
      CALL CATIO ('READ', INDISK, CNO, CATBLK, 'WRIT', BPBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READ CATALOG HEADER'
         GO TO 990
         END IF
      NCFILE = 1
      FVOL(1) = INDISK
      FCNO(1) = CNO
      FRW(1) = 1
      DO3COL = IROUND (XDO3C)
      IF (XDO3C.GT.0.0) DO3COL = MAX (1, DO3COL)
      DO 5 I = 1,10
         IBAD(I) = XBADD(I) + 0.5
 5       CONTINUE
      CALL UVPGET (IERR)
      IST = DROUND (CATD(KDCRV+JLOCS))
      IPOLC(1) = '?'
      IPOLC(2) = '?'
      IF (IST.GT.0) THEN
         IPOLC(1) = 'I'
      ELSE IF (IST.EQ.-1) THEN
         IPOLC(1) = 'R'
         IPOLC(2) = 'L'
      ELSE IF (IST.EQ.-2) THEN
         IPOLC(1) = 'L'
      ELSE IF (IST.EQ.-5) THEN
         IPOLC(1) = 'X'
         IPOLC(2) = 'Y'
      ELSE IF (IST.EQ.-6) THEN
         IPOLC(1) = 'Y'
         END IF
C                                       Open BP file
      TTYPE = 'BP'
      CALL BPREFM (INDISK, CNO, INVERS, CATBLK, BPLUN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL BPINI ('READ', BPBUFF, INDISK, CNO, INVERS, CATBLK, BPLUN,
     *   IBPRNO, BPKOLS, BPNUMV, NANTBP, NPOLBP, NIFBP, NCHNBP,
     *   BCHNBP, NUMSHF, LOWSHF, DELSHF, LTYPBP, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN INPUT BP TABLE'
         GO TO 990
         END IF
      WPOLY = LTYPBP.NE.' '
      XVER = INVERS
C                                       Set column pointers for sort
      CALL FNDCOL (NKEY, KEYSBP, 24, .TRUE., BPBUFF, KOLS, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FIND BP COLUMNS'
         GO TO 990
         END IF
C                                       Sort to ant-time order
      J1 = 1
      J2 = 2
      IF ((BPBUFF(43).NE.KOLS(J1)) .OR. (BPBUFF(44).NE.KOLS(J2)))
     *   THEN
C                                       Close
         CALL TABIO ('CLOS', 0, IBPRNO, BPBUFF, BPBUFF, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'CLOSE BP TABLE'
            GO TO 990
            END IF
C                                       sort
         KEY(1,1) = KOLS(J1)
         KEY(2,1) = KOLS(J1)
         KEY(1,2) = KOLS(J2)
         KEY(2,2) = KOLS(J2)
         CALL TABSRT (INDISK, CNO, 'BP', INVERS, INVERS, KEY, KEYSUB,
     *      FKEY, BPBUFF, CATBLK, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'SORT BP TABLE'
            GO TO 990
            END IF
C                                       Re-open BP table for read
         CALL BPINI ('READ', BPBUFF, INDISK, CNO, INVERS, CATBLK,
     *      BPLUN, IBPRNO, BPKOLS, BPNUMV, NANTBP, NPOLBP, NIFBP,
     *      NCHNBP, BCHNBP, NUMSHF, LOWSHF, DELSHF, LTYPBP, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPEN SORTED BP TABLE'
            GO TO 990
            END IF
         END IF
C                                      number of records
      NBPINR = BPBUFF(5)
      BPOL = 1
      EPOL = NPOLBP
      CALL RCOPY (10, APARM, SAPARM)
      BCHAN = IROUND (XBCHAN)
      BCHAN = MAX (1, MIN (BCHAN, NCHNBP))
      ECHAN = IROUND (XECHAN)
      IF ((ECHAN.LE.BCHAN) .OR. (ECHAN.GT.NCHNBP)) ECHAN = NCHNBP
      XBCHAN = BCHAN
      XECHAN = ECHAN
      BIF = IROUND (XBIF)
      BIF = MAX (1, MIN (BIF, NIFBP))
      EIF = IROUND (XEIF)
      IF ((EIF.LT.BIF) .OR. (EIF.GT.NIFBP)) EIF = NIFBP
      XBIF = BIF
      XEIF = EIF
      ARANGE(1) = APARM(1)
      ARANGE(2) = APARM(2)
      PRANGE(1) = APARM(3)
      PRANGE(2) = APARM(4)
      TIMBEG = ((XTIME(4)/60.0 + XTIME(3)) / 60.0 + XTIME(2)) / 24.0 +
     *   XTIME(1)
      TIMEND = ((XTIME(8)/60.0 + XTIME(7)) / 60.0 + XTIME(6)) / 24.0 +
     *   XTIME(5)
      TPLBEG = TIMBEG
      TPLEND = TIMEND
      IF ((TIMEND.LE.TIMBEG) .OR. (TIMEND.LE.0.0)) THEN
         TIMEND = 9999.
         TIMBEG = -100.
         END IF
      IF (TPLEND.EQ.TPLBEG) THEN
         TPLEND = 9999.
         TPLBEG = -100.0
      ELSE IF (TPLEND.LT.TPLBEG) THEN
         TEMP = TPLEND
         TPLEND = TPLBEG
         TPLBEG = TEMP
         END IF
      FQID = IROUND (XFQ)
      IF (FQID.LE.0) FQID = 1
      SUBARR = IROUND (XSUB)
      IF (SUBARR.LE.0) SUBARR = 1
      LABEL = IROUND (XLTYPE)
      CALL FILL (MAXANT, 0, IANTS)
      CALL FILL (NANTBP, 1, IANTS)
      J1 = 0
      DO 10 J = 1,50
         J2 = IROUND (XANT(J))
         IF (J2.LT.0) THEN
            J1 = J2
         ELSE IF (J1.GE.0) THEN
            J1 = MAX (J1, J2)
            END IF
 10      CONTINUE
C                                       none negative, some > 0
      NIANTS = NANTBP
      IF (J1.GT.0) THEN
         NIANTS = 0
         CALL FILL (NANTBP, 0, IANTS)
         DO 20 J = 1,50
            J2 = IROUND (XANT(J))
            IF ((J2.GT.0) .AND. (J2.LE.NANTBP)) THEN
               IF (IANTS(J2).LE.0) NIANTS = NIANTS + 1
               IANTS(J2) = 1
               END IF
 20         CONTINUE
C                                       some negative
      ELSE IF (J1.LT.0) THEN
         DO 30 J = 1,50
            J2 = IROUND (ABS (XANT(J)))
            IF ((J2.GT.0) .AND. (J2.LE.NANTBP)) THEN
               IF (IANTS(J2).GT.0) NIANTS = NIANTS - 1
               IANTS(J2) = 0
               END IF
 30         CONTINUE
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPEPLI: ERROR',I5,' ON ',A)
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,1X,A2,
     *   'DISK=',I2,' USER=',I5)
      END
      SUBROUTINE BPEPLT (IERR)
C-----------------------------------------------------------------------
C   BPEPLT uses the open BP table to generate the plots.
C   Output:
C      IERR   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'BPEPL.INC'
      CHARACTER PFILE*48, FUNC*12
      INTEGER   I, J, J1, J2, NREC, SOURID, SUBA, ANTNO, FREQID, IP, IA,
     *   BPREF(2), JERR, ANTS(MAXANT), THEANT, IIF, IIC, IIP, MREC,
     *   LINE, TVCHN, GRCHN, TVCORN(2), IVER, IROUND, NP, NX, NY, NZ,
     *   ITYPE, NPLOT, NRECI, NRECC, KREC, INIANT, K, TVPLAN(2)
      REAL      TIMES(20000), INTERV, WT, LMAX, BNDPAS(2,MAXCIF), XT,
     *   WEIGHT(2*MAXIF), DX, X0, Y0, SCALE, X, Y, PLPTS(2,MAXCIF+100),
     *   COL(3), PPMAX, PPMIN, A, P, LMIN
      LOGICAL   LBLANK, SPHASE
      LONGINT   PTVPLN
      DOUBLE PRECISION TTIME, DTIME
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      DTIME = 5. / 60.0 / 24.0
      IIP = BPOL - 1
      INIANT = NIANTS
 5    IIP = IIP + 1
      IF (IIP.GT.EPOL) GO TO 350
      J2 = 0
      NPLOT = 0
      NIANTS = INIANT
      LTYPE = MOD (ABS(LABEL), 100)
C                                       loop for next plot
 10   J1 = J2 + 1
C                                       find range of desired data
         NREC = 0
         KREC = 0
         MREC = 0
         DO 90 J = J1,NBPINR
            IBPRNO = J
            CALL TABBP ('READ', BPBUFF, IBPRNO, BPKOLS, BPNUMV, NIFBP,
     *         NCHNBP, NPOLBP, TIME, INTERV, SOURID, SUBA, ANTNO,
     *         CHNBND, BPFREQ, FREQID, BPREF, WEIGHT, BNDPAS, IERR)
            IF (IERR.GT.0) THEN
               WRITE (MSGTXT,1000) IERR, 'READ BP TABLE'
               GO TO 990
               END IF
            IF (((FREQID.EQ.FQID) .OR. (FREQID.LE.0)) .AND.
     *         ((SUBA.EQ.SUBARR) .OR. (SUBA.LE.0)) .AND.
     *         (TIME.GE.TIMBEG) .AND. (TIME.LE.TIMEND) .AND.
     *         (IANTS(ANTNO).GT.0)) THEN
               IF (NREC.EQ.0) THEN
                  J1 = J
                  KREC = 0
                  THEANT = ANTNO
                  CALL FILL (MAXANT, 0, ANTS)
                  TTIME = TIME
                  AMAX = -1.E10
                  AMIN = -AMAX
                  PPMAX = AMAX
                  PPMIN = AMIN
                  PMAX = AMAX
                  PMIN = AMIN
                  END IF
               IF (ANTNO.NE.THEANT) GO TO 100
C                                       check for valid data
               DO 14 IIF = BIF,EIF
                  I = IIF + (IIP - 1) * NIFBP
                  WT = WEIGHT(I)
                  IF (WT.LE.0) GO TO 14
                  I = (IIP - 1) * NCHNBP * NIFBP + (IIF - 1) *
     *               NCHNBP + BCHAN - 1
                  DO 13 IIC = BCHAN,ECHAN
                     I = I + 1
                     IF (BNDPAS(1,I).NE.FBLANK) GO TO 18
 13                  CONTINUE
 14               CONTINUE
               J2 = J
               ANTS(ANTNO) = J
               IF ((TIME.GE.TPLBEG) .AND. (TIME.LE.TPLEND)) THEN
                  KREC = KREC + 1
                  TIMES(KREC) = TIME
                  END IF
               GO TO 90
 18            MREC = MREC + 1
               ANTS(ANTNO) = J
               J2 = J
               IF ((TIME.GE.TPLBEG) .AND. (TIME.LE.TPLEND)) THEN
                  NREC = NREC + 1
                  KREC = KREC + 1
                  TIMES(KREC) = TIME
                  END IF
C                                       or find max/min
               IF ((ARANGE(2).LE.ARANGE(1)) .OR.
     *            (PRANGE(2).LE.PRANGE(1))) THEN
                  DO 45 IIF = BIF,EIF
                     I = IIF + (IIP - 1) * NIFBP
                     WT = WEIGHT(I)
                     IF (WT.LE.0) GO TO 45
                     I = (IIP - 1) * NCHNBP * NIFBP + (IIF - 1) *
     *                  NCHNBP + BCHAN - 1
                     DO 40 IIC = BCHAN,ECHAN
                        I = I + 1
                        IF (BNDPAS(1,I).NE.FBLANK) THEN
                           A = SQRT (BNDPAS(1,I)**2 + BNDPAS(2,I)**2)
                           P = 0.0
                           IF ((BNDPAS(1,I).NE.0.0) .OR.
     *                        (BNDPAS(2,I).NE.0.0)) P = RAD2DG *
     *                        ATAN2 (BNDPAS(2,I), BNDPAS(1,I))
                           AMAX = MAX (A, AMAX)
                           AMIN = MIN (A, AMIN)
                           PMAX = MAX (P, PMAX)
                           PMIN = MIN (P, PMIN)
                           IF (P.LT.0.0) P = P + 360.0
                           PPMAX = MAX (P, PPMAX)
                           PPMIN = MIN (P, PPMIN)
                           END IF
 40                     CONTINUE
 45                  CONTINUE
                  END IF
               END IF
 90         CONTINUE
C                                       Found no more data
 100     IF (MREC.LE.0) THEN
            MSGTXT = 'Done with all selected data this polarization'
            CALL MSGWRT (2)
            IF (NPLOT.GT.0) THEN
               IERR = 0
            ELSE
               IERR = 1
               MSGTXT = 'But no plots were done'
               CALL MSGWRT (7)
               END IF
            GO TO 5
            END IF
C                                       found data but no plot
         IF (NREC.EQ.0) THEN
            IF (J2.LT.NBPINR) GO TO 10
            GO TO 350
            END IF
         NREC = KREC
C                                       set scale, blank array
         I = MAXCIF + 100
         IF (PRANGE(2).GT.PRANGE(1)) THEN
            PMIN = PRANGE(1)
            PMAX = PRANGE(2)
            SPHASE = PMIN.GE.0.0
         ELSE
            IF (PMAX-PMIN.LE.PPMAX-PPMIN) THEN
               SPHASE = .FALSE.
            ELSE
               PMIN = PPMIN
               PMAX = PPMAX
               SPHASE = .TRUE.
               END IF
            END IF
         IF (PMIN.EQ.PMAX) THEN
            IF (PMIN.EQ.0.0) THEN
               PMAX = 1.
               PMIN = -1.
            ELSE
               PMAX = 1.03 * PMIN
               PMIN = 0.97 * PMIN
               END IF
            END IF
         IF (ARANGE(2).GT.ARANGE(1)) THEN
            AMIN = ARANGE(1)
            AMAX = ARANGE(2)
            END IF
C                                       now init the plot
         APARM(1) = AMIN
         APARM(2) = AMAX
         APARM(3) = PMIN
         APARM(4) = PMAX
         IF ((APARM(5).LT.0.1) .OR. (APARM(5).GT.0.9)) APARM(5) = 0.3
         DOTV = XDOTV.GT.0.0
         IF (DOTV) THEN
            DOPLAN = 1
            IF (DO3COL.GT.0) DOPLAN = 2
         ELSE
            DOPLAN = 3
            IF (DO3COL.GE.0) DOPLAN = 4
            END IF
         IF (APARM(6).LE.0.0) DOPLAN = 0
         TVCHN = 0
         TVCORN(1) = 0
         TVCORN(2) = 0
         GRCHN = IROUND (XCHAN)
         PLUN = 26
         IVER = 0
         IF (.NOT.DOTV) THEN
            CALL MADDEX ('PL', INDISK, CNO, CATBLK, PBUFF, .TRUE.,
     *         'WRIT', IVER, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CREATE PLOT FILE'
               CALL MSGWRT (7)
               GO TO 999
               END IF
            END IF
C                                       gridded image
         DCOLV = 0.97 / MAX (1, NREC-1)
         COLV = 0.0
         IF (APARM(6).LE.0.0) THEN
            NX = 0
            NY = 0
            NZ = 0
         ELSE
            CALL PLPLAN (NX, NY, NZ, TVPLAN, PTVPLN, THEANT, IIP, IVER,
     *         J1, J2, SPHASE, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         XIMSIZ(1) = NX
         XIMSIZ(2) = NY
C                                       time/antenna adverbs to match
C                                       one time
         CALL RFILL (8, 0.0, XTIME)
C                                       one antenna
         XTIME(1) = TPLBEG
         XTIME(5) = TPLEND
         APARM(9) = THEANT
         APARM(10) = IIP
         CALL ZPHFIL ('PL', INDISK, CNO, IVER, PFILE, IERR)
         ITYPE = 71
         CALL GINIT (INDISK, CNO, PFILE, 0, ITYPE, NPARMS, XINNAM, DOTV,
     *      TVCHN, GRCHN, TVCORN, CATBLK, PBUFF, PLUN, PFIND, IERR)
         FUNC = 'GINIT'
         IF (IERR.NE.0) GO TO 900
         CALL BPLABL (IVER, THEANT, IIP, NX, NY, NZ, TVPLAN(1+PTVPLN),
     *      IERR)
         FUNC = 'BPLABL'
         IF (IERR.NE.0) GO TO 900
         IF (NX.GT.0) THEN
            CALL ZMEMRY ('FRAL', 'PLPLAN', J, TVPLAN, PTVPLN, IERR)
            GO TO 300
            END IF
         NP = (EIF-BIF+1)
         DX = NP*(ECHAN-BCHAN+4)
         DX = 1000.0 / DX
         X0 = DX / 2.0
         Y0 = 0.0
         XT = MAX (X0, 17.5)
         COLV = 0.0
C                                       get the data part
         MREC = J2 - J1 + 1
         IA = 0
         LINE = 0
         NRECC = 0
         NRECI = MAX (1, NREC / 20)
         DO 290 J = 1,MREC
            IBPRNO = J + J1 - 1
            CALL TABBP ('READ', BPBUFF, IBPRNO, BPKOLS, BPNUMV, NIFBP,
     *         NCHNBP, NPOLBP, TIME, INTERV, SOURID, SUBA, ANTNO,
     *         CHNBND, BPFREQ, FREQID, BPREF, WEIGHT, BNDPAS, IERR)
            IF (IERR.GT.0) THEN
               WRITE (MSGTXT,1000) IERR, 'READ BP TABLE'
               GO TO 990
               END IF
            IF (((FREQID.EQ.FQID) .OR. (FREQID.LE.0)) .AND.
     *         ((SUBA.EQ.SUBARR) .OR. (SUBA.LE.0)) .AND.
     *         (TIME.GE.TPLBEG) .AND. (TIME.LE.TPLEND) .AND.
     *         (IANTS(ANTNO).GT.0)) THEN
               NRECC = NRECC + 1
               IF (DO3COL.GT.0) THEN
                  CALL COLOR3 (COLV, .FALSE., COL)
                  COLV = COLV + DCOLV
                  CALL G3VCOL (COL(1), COL(2), COL(3), PBUFF, IERR)
                  FUNC = 'G3VCOL'
                  IF (IERR.NE.0) GO TO 900
                  END IF
               IP = 0
               LINE = LINE + 1
               DO 235 IIF = BIF,EIF
                  I = IIF + (IIP - 1) * NIFBP
                  WT = WEIGHT(I)
                  I = (IIP - 1) * NCHNBP * NIFBP + (IIF - 1) *
     *               NCHNBP + BCHAN - 1
                  IP = IP + 1
                  PLPTS(1,IP) = FBLANK
                  PLPTS(2,IP) = FBLANK
                  DO 230 IIC = BCHAN,ECHAN
                     I = I + 1
                     IP = IP + 1
                     A = FBLANK
                     P = FBLANK
                     IF ((WT.GT.0.0) .AND. (BNDPAS(1,I).NE.FBLANK)) THEN
                        P = 0.0
                        A =  SQRT (BNDPAS(1,I)**2 + BNDPAS(2,I)**2)
                        IF ((BNDPAS(1,I).NE.0.0) .OR.
     *                     (BNDPAS(2,I).NE.0.0)) THEN
                           P = ATAN2 (BNDPAS(2,I), BNDPAS(1,I)) * RAD2DG
                           IF ((SPHASE) .AND. (P.LT.0.0))
     *                         P = P + 360.0
                           END IF
                        IF ((A.NE.FBLANK) .AND. ((A.LT.AMIN) .OR.
     *                     (A.GT.AMAX))) A = FBLANK
                        IF ((P.NE.FBLANK) .AND. ((P.LT.PMIN) .OR.
     *                     (P.GT.PMAX))) P = FBLANK
                        END IF
                     PLPTS(1,IP) = A
                     PLPTS(2,IP) = P
 230                 CONTINUE
                  IP = IP + 1
                  PLPTS(1,IP) = FBLANK
                  PLPTS(2,IP) = FBLANK
                  IP = IP + 1
                  PLPTS(1,IP) = FBLANK
                  PLPTS(2,IP) = FBLANK
 235              CONTINUE
C                                       Do the plot now
               SCALE = 1000.0 * (1.0 - APARM(5)) / (AMAX - AMIN)
               CALL GLTYPE (2, PBUFF, IERR)
               FUNC = 'GLTYPE'
               IF (IERR.NE.0) GO TO 900
               Y0 = 0.0
               LMAX = AMAX
               LMIN = AMIN
               DO 260 K = 1,2
                  LBLANK = .TRUE.
                  X = X0
                  DO 250 I = 1,IP
                     IF (PLPTS(K,I).EQ.FBLANK) THEN
                        LBLANK = .TRUE.
                        X = X + DX
                     ELSE
                        Y = Y0 + (PLPTS(K,I)-LMIN) * SCALE
                        IF (LBLANK) THEN
                           CALL GPOS (X, Y, PBUFF, IERR)
                        ELSE IF (DO3COL.GT.0) THEN
                           CALL G3VEC (X, Y, PBUFF, IERR)
                        ELSE
                           CALL GVEC (X, Y, PBUFF, IERR)
                           END IF
                        FUNC = 'GVEC'
                        IF (IERR.NE.0) GO TO 900
                        LBLANK = .FALSE.
                        X = X + DX
                        END IF
                     IF (IERR.NE.0) GO TO 900
 250                 CONTINUE
                  LMAX = PMAX
                  LMIN = PMIN
                  SCALE = 1000.0 * APARM(5) / (PMAX - PMIN)
                  Y0 = 1000.0 * (1.0 - APARM(5))
 260              CONTINUE
               END IF
 290        CONTINUE
C                                       finish plot and continue?
 300     NIANTS = NIANTS - 1
         GPHPAG = (DOTV) .AND. (((J2.LT.NBPINR) .AND. (NIANTS.GT.0))
     *      .OR. (IIP.LT.EPOL))
         CALL GFINIS (PBUFF, IERR)
C                                       Successful plot file finished.
         IF (IERR.EQ.0) THEN
            NPLOT = NPLOT + 1
            IF (.NOT.DOTV) THEN
               CALL HIPLOT (INDISK, CNO, IVER, PBUFF, IERR)
               WRITE (MSGTXT,1290) IVER
               CALL MSGWRT (5)
               IERR = 0
               END IF
            END IF
C                                       loop
         IF (IERR.EQ.0) THEN
            IF (J2.LT.NBPINR) GO TO 10
            IF (IIP.LT.EPOL) GO TO 5
            END IF
 350  IERR = MAX (0, IERR)
C                                       close
      CALL TABBP ('CLOS', BPBUFF, IBPRNO, BPKOLS, BPNUMV, NIFBP, NCHNBP,
     *   NPOLBP, TIME, INTERV, SOURID, SUBA, ANTNO, CHNBND, BPFREQ,
     *   FREQID, BPREF, WEIGHT, BNDPAS, JERR)
      GO TO 999
C                                       plotter error
 900  WRITE (MSGTXT,1900) IERR, FUNC
      CALL MSGWRT (8)
      MSGTXT = 'WILL TRY TO SAVE PARTIAL GRAPH'
      CALL MSGWRT (8)
      GPHPAG = .FALSE.
      CALL GFINIS (PBUFF, I)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPEPLT: ERROR',I5,' ON ',A)
 1290 FORMAT ('Successful plot file version',I5,' written')
 1900 FORMAT ('PLOTTING ERROR',I5,' AT ',A)
      END
      SUBROUTINE PLPLAN (NX, NY, NZ, TVPLAN, PTVPLN, THEANT, IIP, IVER,
     *   J1, J2, SPHASE, IERR)
C-----------------------------------------------------------------------
C   PLPLAN creates a plot grid containing an image of the plot
C   Inputs:
C      THEANT   I      The current antenna number
C      IIP      I      The current polarization
C      IVER     I      the current plot file version
C      J1       I      start BP rec number
C      J2       I      end BP rec number
C      SPHASE   L      T => all P positive
C   Outputs:
C      NX       I      X dimension
C      NY       I      Y dimension
C      NZ       I      1 - B/W, 3 color
C      PTVPLN   LI     Pointer to dynamic memory
C      TVPLAN   I(*)   Memory
C      IERR     I      > 0 quit
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, TVPLAN(*), THEANT, IIP, IVER, J1, J2, IERR
      LONGINT   PTVPLN
      LOGICAL   SPHASE
C
      INCLUDE 'BPEPL.INC'
      INTEGER   ITYPE, NWORDS, NP, ICOL(3), MREC, IA, LINE, NRECC, K,
     *   I, J, SOURID, SUBA, ANTNO, FREQID, IP, IIF, IIC, BPREF(2),
     *   SCRTCH(256), GRCHN, IDEPTH(5), TVCHN, TVCORN(2), GRCOLS(3,8)
      CHARACTER PFILE*48, FUNC*8
      REAL      CH(4), XMIN, YMIN, DX, X0, Y0, WT, A, P, SCALE, X, Y,
     *   BNDPAS(2,MAXCIF), WEIGHT(2*MAXIF), PLPTS(2,MAXCIF+100), INTERV,
     *   LMAX, LMIN
      LOGICAL   LBLANK
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA TVCHN, IDEPTH, TVCORN /1, 5*1, 2*0/
      DATA GRCOLS /255,255,0, 16,255,0, 255,171,255, 0,255,255,
     *   255,45,45, 153,153,255, 255,204,102, 0,0,0/
C-----------------------------------------------------------------------
      GRCHN = XCHAN + 0.1
C                                       create plot file
      CALL ZPHFIL ('PL', INDISK, CNO, IVER, PFILE, IERR)
      ITYPE = 71
      CALL GINIT (INDISK, CNO, PFILE, 0, ITYPE, NPARMS, XINNAM, DOTV,
     *   TVCHN, GRCHN, TVCORN, CATBLK, PBUFF, PLUN, PFIND, IERR)
      FUNC = 'GINIT'
      IF (IERR.NE.0) GO TO 900
C                                       number characters around
      LTYPE = MOD (ABS(LABEL), 100)
      IF (LTYPE.EQ.0) LTYPE = 3
      IF (LABEL.GE.0) THEN
         LABEL = (LABEL/100)*100 + LTYPE
      ELSE
         LABEL = (LABEL/100)*100 - LTYPE
         END IF
      CALL RFILL (4, 0.5, CH)
      IF (LTYPE.EQ.2) CH(1) = 2.5
      IF (LTYPE.GT.2) CH(1) = 6.5
      IF (LTYPE.GT.1) CH(2) = 2.0
      IF (LTYPE.GT.2) CH(2) = CH(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         CH(2) = CH(2) + 2 * 1.333
         END IF
      IF (LTYPE.EQ.2) CH(3) = 2.5
      IF (LTYPE.GT.1) CH(4) = CH(4) + 1.5
      IF ((LABEL.GT.1) .AND. (LTYPE.LT.7)) CH(4) = CH(4) + 1.333
C                                       Set BLC, TRC, XYRATO.
      BLC(2) = 0.0
      BLC(1) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      IF ((XIMSIZ(1).GT.100.) .AND. (XIMSIZ(2).GT.100.) .AND.
     *   (.NOT.DOTV)) CALL RCOPY (2, XIMSIZ, TRC)
C                                       default XYRATIO
      IF (XYRATO.LT.0.01) THEN
         IF (XDOTV.GT.0.0) THEN
            XMIN = WINDTV(3) - WINDTV(1) + 1 - CSIZTV(1) * (CH(1)+CH(3))
            YMIN = WINDTV(4) - WINDTV(2) + 1 - CSIZTV(2) * (CH(2)+CH(4))
            XYRATO = 1.0
            IF (YMIN.GT.0.0) XYRATO = XMIN / YMIN
         ELSE
            XYRATO = 1.0
            END IF
         END IF
C                                       Initialize plot file line drw.
      CALL GINITL (BLC, TRC, XYRATO, CH, IDEPTH, PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       get memory
      IF (DOTV) THEN
         NX = GPHSCX + 1.01
         NY = GPHSCY + 1.01
      ELSE
         NX = TRC(1) - BLC(1) + 1.01
         NY = TRC(2) - BLC(2) + 1.01
         END IF
      NZ = 1
      IF (MOD(DOPLAN,2).EQ.0) NZ = 3
      NWORDS = (NX * NY * NZ - 1) / 1024 + 4
      CALL ZMEMRY ('GET ', 'PLPLAN', NWORDS, TVPLAN, PTVPLN, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         PTVPLN = 0
         NX = 0
         NY = 0
         NZ = 0
         IERR = 0
         GO TO 999
         END IF
      NWORDS = NX * NY * NZ
      CALL FILL (NWORDS, 0, TVPLAN(1+PTVPLN))
C                                       start plot
      NP = (EIF-BIF+1)
      DX = NP*(ECHAN-BCHAN+4)
      DX = (TRC(1)-BLC(1)) / DX
      X0 = DX / 2.0
      Y0 = 0.0
      I = MOD (GRCHN, 10)
      IF (I.LE.0) I = 4
      IF (NZ.EQ.3) THEN
         IF (MAXINT.LE.0) MAXINT = 8191
         ICOL(1) = GRCOLS(1,I) / 256.0 * MAXINT
         ICOL(2) = GRCOLS(2,I) / 256.0 * MAXINT
         ICOL(3) = GRCOLS(3,I) / 256.0 * MAXINT
      ELSE
         ICOL(1) = 32767
         ICOL(2) = 0
         ICOL(3) = 0
         END IF
C                                       get the data part
      MREC = J2 - J1 + 1
      IA = 0
      LINE = 0
      NRECC = 0
      DO 290 J = 1,MREC
         IBPRNO = J + J1 - 1
         CALL TABBP ('READ', BPBUFF, IBPRNO, BPKOLS, BPNUMV, NIFBP,
     *      NCHNBP, NPOLBP, TIME, INTERV, SOURID, SUBA, ANTNO,
     *      CHNBND, BPFREQ, FREQID, BPREF, WEIGHT, BNDPAS, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READ BP TABLE'
            GO TO 990
            END IF
         IF (((FREQID.EQ.FQID) .OR. (FREQID.LE.0)) .AND.
     *      ((SUBA.EQ.SUBARR) .OR. (SUBA.LE.0)) .AND.
     *      (TIME.GE.TPLBEG) .AND. (TIME.LE.TPLEND) .AND.
     *      (IANTS(ANTNO).GT.0)) THEN
            NRECC = NRECC + 1
            IF (DO3COL.GT.0) THEN
               CALL PLCOL3 (COLV, ICOL)
               COLV = COLV + DCOLV
               END IF
            IP = 0
            LINE = LINE + 1
            DO 235 IIF = BIF,EIF
               I = IIF + (IIP - 1) * NIFBP
               WT = WEIGHT(I)
               I = (IIP - 1) * NCHNBP * NIFBP + (IIF - 1) *
     *            NCHNBP + BCHAN - 1
               IP = IP + 1
               PLPTS(1,IP) = FBLANK
               PLPTS(2,IP) = FBLANK
               DO 230 IIC = BCHAN,ECHAN
                  I = I + 1
                  IP = IP + 1
                  A = FBLANK
                  P = FBLANK
                  IF ((WT.GT.0.0) .AND. (BNDPAS(1,I).NE.FBLANK)) THEN
                     P = 0.0
                     A =  SQRT (BNDPAS(1,I)**2 + BNDPAS(2,I)**2)
                     IF ((BNDPAS(1,I).NE.0.0) .OR.
     *                  (BNDPAS(2,I).NE.0.0)) THEN
                        P = ATAN2 (BNDPAS(2,I), BNDPAS(1,I)) * RAD2DG
                        IF ((SPHASE) .AND. (P.LT.0.0))
     *                      P = P + 360.0
                        END IF
                     IF ((A.NE.FBLANK) .AND. ((A.LT.AMIN) .OR.
     *                  (A.GT.AMAX))) A = FBLANK
                     IF ((P.NE.FBLANK) .AND. ((P.LT.PMIN) .OR.
     *                  (P.GT.PMAX))) P = FBLANK
                     END IF
                  PLPTS(1,IP) = A
                  PLPTS(2,IP) = P
 230              CONTINUE
               IP = IP + 1
               PLPTS(1,IP) = FBLANK
               PLPTS(2,IP) = FBLANK
               IP = IP + 1
               PLPTS(1,IP) = FBLANK
               PLPTS(2,IP) = FBLANK
 235           CONTINUE
C                                       Do the plot now
            SCALE = (TRC(2)-BLC(2)) * (1.0 - APARM(5)) / (AMAX - AMIN)
            CALL GLTYPE (2, PBUFF, IERR)
            FUNC = 'GLTYPE'
            IF (IERR.NE.0) GO TO 900
            Y0 = 0.0
            LMAX = AMAX
            LMIN = AMIN
            DO 260 K = 1,2
               LBLANK = .TRUE.
               X = X0
               DO 250 I = 1,IP
                  IF (PLPTS(K,I).EQ.FBLANK) THEN
                     LBLANK = .TRUE.
                     X = X + DX
                  ELSE
                     Y = Y0 + (PLPTS(K,I)-LMIN) * SCALE
                     IF (LBLANK) THEN
                        CALL GPLPOS (X, Y, DOPLAN, TVPLAN(1+PTVPLN),
     *                     IERR)
                     ELSE
                        CALL GPLVEC (X, Y, ICOL, NX, NY, NZ, DOPLAN,
     *                     TVPLAN(1+PTVPLN), IERR)
                        IF (IERR.EQ.0) CALL GPLPOS (X, Y, DOPLAN,
     *                     TVPLAN(1+PTVPLN), IERR)
                        END IF
                     FUNC = 'GVEC'
                     IF (IERR.NE.0) GO TO 900
                     LBLANK = .FALSE.
                     X = X + DX
                     END IF
                  IF (IERR.NE.0) GO TO 900
 250              CONTINUE
               LMAX = PMAX
               LMIN = PMIN
               SCALE = (TRC(2)-BLC(2)) * APARM(5) / (PMAX - PMIN)
               Y0 = (TRC(2)-BLC(2)) * (1.0 - APARM(5))
 260           CONTINUE
            END IF
 290     CONTINUE
      IF (DOTV) THEN
         CALL TVCLOS (SCRTCH, IERR)
      ELSE
         CALL ZCLOSE (PLUN, PFIND, IERR)
         CALL ZDESTR (INDISK, PFILE, IERR)
         END IF
      IERR = 0
      GO TO 999
C
 900  WRITE (MSGTXT,1900) IERR, FUNC
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('LPLAN ERROR',I4,' ON ',A)
 1900 FORMAT ('PLPLAN: ERROR PLOTTING',I4)
      END
      SUBROUTINE BPLABL (IVER, THEANT, IPOL, NX, NY, NZ, TVPLAN, IERR)
C-----------------------------------------------------------------------
C   Do the init for line drawing, ...
C   Inputs:
C      IVER    I      File version number
C      THEANT  I      antenna number
C      IPOL    I      polarization
C   Output:
C      IERR   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IVER, THEANT, IPOL, NX, NY, NZ, TVPLAN(NX,NY,*), IERR
C
      REAL      CH(4), X, DX, DY, DCX, DCY, XMIN, YMIN, Y
      INTEGER   IDEPTH(5), I, JP, IIF, XINTER(10), NP, XINT, XLO, XHI,
     *   TIME1(4), TIME2(4), INCHAR, DEG, DU, DL
      CHARACTER STRING*80, NAMSTR*20, CTIME*8, CDATE*12
      INCLUDE 'BPEPL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA XINTER /2,5,10,20,50,100,200,500,1000,2000/
C-----------------------------------------------------------------------
C                                       number characters around
      LTYPE = MOD (ABS(LABEL), 100)
      IF (LTYPE.EQ.0) LTYPE = 3
      IF (LABEL.GE.0) THEN
         LABEL = (LABEL/100)*100 + LTYPE
      ELSE
         LABEL = (LABEL/100)*100 - LTYPE
         END IF
      CALL RFILL (4, 0.5, CH)
      IF (LTYPE.EQ.2) CH(1) = 2.5
      IF (LTYPE.GT.2) CH(1) = 6.5
      IF (LTYPE.GT.1) CH(2) = 2.0
      IF (LTYPE.GT.2) CH(2) = CH(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         CH(2) = CH(2) + 2 * 1.333
         END IF
      IF (LTYPE.EQ.2) CH(3) = 2.5
      IF (LTYPE.GT.1) CH(4) = CH(4) + 1.5
      IF ((LABEL.GT.1) .AND. (LTYPE.LT.7)) CH(4) = CH(4) + 1.333
C                                       Set BLC, TRC, XYRATO.
      CALL RFILL (5, 1.0, BLC(3))
      CALL RFILL (5, 1.0, TRC(3))
      CALL FILL (5, 1, IDEPTH)
      IF (NX.EQ.0) THEN
         BLC(1) = 0.0
         BLC(2) = 0.0
         TRC(1) = 1000.0
         TRC(2) = 1000.0
         END IF
C                                       default XYRATIO
      IF (XYRATO.LT.0.01) THEN
         IF (XDOTV.GT.0.0) THEN
            XMIN = WINDTV(3) - WINDTV(1) + 1 - CSIZTV(1) * (CH(1)+CH(3))
            YMIN = WINDTV(4) - WINDTV(2) + 1 - CSIZTV(2) * (CH(2)+CH(4))
            XYRATO = 1.0
            IF (YMIN.GT.0.0) XYRATO = XMIN / YMIN
         ELSE
            XYRATO = 1.0
            END IF
         END IF
C                                       Initialize plot file line drw.
      CALL GINITL (BLC, TRC, XYRATO, CH, IDEPTH, PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       If a graphics plane already
      IF (NX.GT.0) THEN
         IF ((DOPLAN.EQ.1) .OR. (DOPLAN.EQ.2)) CALL DRPLAN (NX, NY, NZ,
     *      TVPLAN, PBUFF, IERR)
         IF ((DOPLAN.EQ.3) .OR. (DOPLAN.EQ.4)) CALL GRPLAN (NX, NY, NZ,
     *      TVPLAN, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Draw borders.
      CALL GLTYPE (1, PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GPOS (BLC(1), BLC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (TRC(1), BLC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (TRC(1), TRC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (BLC(1), TRC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (BLC(1), BLC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      Y = (TRC(2) - BLC(2)) * (1.0 - APARM(5))
      CALL GPOS (BLC(1), Y, PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (TRC(1), Y, PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       separate polarizations/IFs
      NP = (EIF-BIF+1)
      I = NP * (ECHAN-BCHAN+4)
      DX = (TRC(1)-BLC(1)+1.0) / I
      IF (NP.GT.1) THEN
         X = 0.0
         DO 20 JP = 2,NP
            X = X + (ECHAN-BCHAN+4) * DX
            CALL GPOS (X, BLC(2), PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GVEC (X, TRC(2), PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
 20         CONTINUE
         END IF
      IF (LTYPE.LE.1) GO TO 999
C                                       Horizontal ticks
      DCY = -0.17
      IF (LTYPE.EQ.2) GO TO 100
      JP = 12
      IF (NP.GT.1) JP = 11 - NP
      JP = MAX (3, JP)
      DO 30 I = 1,10
         DEG = XINTER(I)
         DU = (ECHAN/DEG) * DEG
         IF (DU.GT.ECHAN) DU = DU - DEG
         DL = (BCHAN/DEG) * DEG
         IF (DL.LT.BCHAN) DL = DL + DEG
         IIF = (DU-DL) / DEG + 1
         IF (IIF.LE.JP) GO TO 35
 30      CONTINUE
      GO TO 100
C                                       tick drawing
 35   XINT = DEG
      XLO = (BCHAN / XINT) * XINT
      IF (XLO.LT.BCHAN) XLO = XLO + XINT
      XHI = (ECHAN / XINT) * XINT
      DY = 25. * (TRC(2)-BLC(2)+1.) / 1000.0
      DCY = -1.5
      DO 60 JP = 1,NP
         DO 50 I = XLO,XHI,XINT
            X = DX * (2.0 + I - BCHAN) + (JP-1) * (ECHAN-BCHAN+4) * DX
            WRITE (STRING,1035) I
            CALL CHTRIM (STRING, 4, STRING, IIF)
            DCX = -IIF + 0.5
            CALL GPOS (X, TRC(2), PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GVEC (X, TRC(2)-DY, PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GPOS (X, BLC(2)+DY, PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GVEC (X, BLC(2), PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GCHAR (IIF, 0, DCX, DCY, STRING(:IIF), PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
 50         CONTINUE
 60      CONTINUE
C                                       IF, POL labels
      X = DX
      DCY = 1.5
      DO 65 IIF = BIF,EIF
         CALL GPOS (X, BLC(2)+DY, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         WRITE (STRING,1060) IIF
         DCX = 1.5
         CALL GICHAR (1, 4, 0, DCX, DCY, STRING(:4), PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         X = X + (ECHAN-BCHAN+4) * DX
 65      CONTINUE
C                                       horizontal axis label
      DCY = -2.833
      CALL GPOS (TRC(1)/2.0, 0., PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      DCX = -8.5
      CALL GCHAR (17, 0, DCX, DCY, 'SPECTRAL CHANNELS', PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       vertical axis
      CALL YLABEL (IERR)
      IF (IERR.NE.0) GO TO 999
C                                       more labels
 100  IF (LTYPE.GE.7) GO TO 999
C                                       image name etc
      CALL GPOS (BLC(1), TRC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      DCY = 0.5
      DCX = 0.0
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), NAMSTR(1:12))
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), NAMSTR(13:18))
      CALL NAMEST (NAMSTR, CATBLK(KIIMS), STRING, IIF)
      STRING(IIF+1:) = ' '
      IIF = IIF + 4
      WRITE (STRING(IIF:),1121) INVERS, THEANT, IPOLC(IPOL)
      CALL REFRMT (STRING, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DCX, DCY, STRING(:INCHAR), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       time/date, version
      IF (LABEL.GT.0) THEN
         CALL GPOS (BLC(1), TRC(2), PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL ZDATE (TIME1)
         CALL ZTIME (TIME2)
         CALL TIMDAT (TIME2, TIME1, CTIME, CDATE)
         WRITE (STRING,1130) IVER, CDATE, CTIME
         CALL REFRMT (STRING, '_', INCHAR)
         IIF = 51
         DCY = DCY + 1.333
         CALL GCHAR (INCHAR, 0, DCX, DCY, STRING(:INCHAR), PBUFF, IERR)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1035 FORMAT (I4)
 1060 FORMAT ('IF',I2.2)
 1121 FORMAT ('___bpver',I4,' _antenna',I3,' _pol ''',A1,'''')
 1130 FORMAT ('Plot file version',I4,'__created ',A,A)
      END
      SUBROUTINE YLABEL (IERR)
C-----------------------------------------------------------------------
C   Does tick labels and tics
C   Inputs:
C      BLC    R(*)    Botton left corner
C      TRC    R(*)    Top right corner
C   Outputs
C      IERR   I       Error code
C   Plus lots in COMMON
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'BPEPL.INC'
      INTEGER   IT, INOINT, IXO, INCHAR, I
      REAL      XINTER(19), DCX, DCY, DIST, YMIN, YMAX, YBLC, YTRC,
     *   XINT, XVAL, DCXM, TICLEN, YTICEL, YTICER, YPOS, TICSCL, DEG,
     *   DU, DL
      CHARACTER MSGBUF*20
      INCLUDE 'INCS:DMSG.INC'
      DATA XINTER /.001, .002, .005, .01, .02, .05,.1, .2, .5, 1., 2.,
     *   5., 10., 20., 50., 100., 200., 500., 1000./
      DATA TICSCL /70.0/
C-----------------------------------------------------------------------
C                                       loop amp, phase
      DO 100 IT = 1,2
         YMIN = APARM(2*IT-1)
         YMAX = APARM(2*IT)
         DIST = YMAX - YMIN
         IF (IT.EQ.1) THEN
            YBLC = BLC(2)
            YTRC = YBLC + (1.0-APARM(5)) * (TRC(2) - BLC(2))
            XINT = (1.0 - APARM(5)) * 14.0
         ELSE
            YBLC = YTRC
            YTRC = TRC(2)
            XINT = APARM(5) * 14.0
            END IF
         DO 10 I = 1,19
            DEG = XINTER(I)
            DU = AINT (YMAX/DEG) * DEG
            IF (DU.GT.YMAX) DU = DU + DEG
            DL = AINT (YMIN/DEG) * DEG
            IF (DL.LT.YMIN) DL = DL + DEG
            INOINT = AINT ((DU-DL)/DEG) + 1
            IF (INOINT.LE.XINT) GO TO 20
 10         CONTINUE
         MSGTXT = 'Y AXIS LAELING PROBLEM'
         CALL MSGWRT (6)
         GO TO 100
C                                       Interval and no of inter found.
 20      XINT = DEG
         INOINT = INOINT + 2
         XVAL = AINT (YMIN/XINT) * XINT
         IF (XVAL.GE.YMIN) XVAL = XVAL - XINT
         IXO = I
         DCXM = -0.5
         TICLEN = (TRC(1) - BLC(1)) / TICSCL
         YTICEL = BLC(1) + TICLEN
         YTICER = TRC(1) - TICLEN
C                                       Loop for all tics.
         DO 30 I = 1,INOINT
            XVAL = XVAL + XINT
            YPOS = YBLC + (XVAL - YMIN) / DIST * (YTRC - YBLC)
            IF (YPOS.GT.YTRC) GO TO 40
C                                       TOP tic.
            CALL GPOS (TRC(1), YPOS, PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GVEC (YTICER, YPOS, PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       Left hand tic.
            CALL GPOS (YTICEL, YPOS, PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GVEC (BLC(1), YPOS, PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       Write value.
            IF (LTYPE.GT.2) THEN
               WRITE (MSGBUF,1030) XVAL
               CALL CHTRIM (MSGBUF, 14, MSGBUF, INCHAR)
               IF (IXO.GT.3) INCHAR = INCHAR - 1
               IF (IXO.GT.6) INCHAR = INCHAR - 1
               IF (IXO.GT.9) INCHAR = INCHAR - 2
               DCX = - INCHAR - 1.0
               DCY = -0.5
               DCXM = MIN (DCXM, DCX)
               CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, PBUFF, IERR)
               IF (IERR.NE.0) GO TO 999
               END IF
 30         CONTINUE
 40      IF (IT.EQ.1) THEN
            MSGBUF = 'Amplitude'
            INCHAR = 9
         ELSE
            MSGBUF = 'Phase'
            INCHAR = 5
            END IF
         YPOS = (YTRC + YBLC) / 2.0
         CALL GPOS (BLC(1), YPOS, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         DCX = DCXM - 2.
         DCY = INCHAR / 2.0 - 1.0
         CALL GCHAR (INCHAR, 1, DCX, DCY, MSGBUF, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
 100     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (F14.3)
      END
      SUBROUTINE GPLPOS (X, Y, DOPLAN, BUFF, IERR)
C-----------------------------------------------------------------------
C   Inputs:
C      X        R      X position
C      Y        R      Y position
C      DOPLAN   I      > 2 -> plot file
C   Outputs
C      BUFF     I(*)   unused
C      IERR     I      error code
C-----------------------------------------------------------------------
      INTEGER   DOPLAN, BUFF(*), IERR
      REAL      X, Y
C
      REAL      RX, RY, RLIM
      INCLUDE 'INCS:DGPH.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Scale X and Y.
      RLIM = 4.0
      IF (GPHIX2.EQ.GPHIX1) THEN
         RX = 0.0
      ELSE
         RX = (X - GPHX1) / (GPHX2 - GPHX1)
         END IF
      IF (GPHIY2.EQ.GPHIY1) THEN
         RY = 0.0
      ELSE
         RY = (Y - GPHY1) / (GPHY2 - GPHY1)
         END IF
      RX = MAX (-RLIM, MIN (RLIM, RX))
      RY = MAX (-RLIM, MIN (RLIM, RY))
C                                       tv
      IF (DOPLAN.LE.2) THEN
         GPHIXL = RX * GPHSCX + 1.5
         GPHIYL = RY * GPHSCY + 1.5
      ELSE
         GPHIXL = RX * (GPHIX2 - GPHIX1) + GPHIX1 + 1.5
         GPHIYL = RY * (GPHIY2 - GPHIY1) + GPHIY1 + 1.5
         END IF
C
 999  RETURN
      END
      SUBROUTINE GPLVEC (X, Y, ICOL, NX, NY, NZ, DOPLAN, TVPLAN, IERR)
C-----------------------------------------------------------------------
C   Inputs:
C      X        R      X position
C      Y        R      Y position
C      ICOL     I(3)   RGB color to use
C      NX       I      X dimension of BUFF
C      NY       I      Y dimension of BUFF
C      NZ       I      Z dimension of BUFF
C      DOPLAN   I      > 2 -> plot file
C   Outputs
C      TVPLAN   I(*)   unused
C      IERR     i      error code
C-----------------------------------------------------------------------
      INTEGER   ICOL(3), NX, NY, NZ, DOPLAN, TVPLAN(NX,NY,*), IERR
      REAL      X, Y
C
      REAL      RX, RY, RLIM, ALPHA, BETA
      INTEGER   IXN, IYN, X1, X2, Y1, Y2, XLIM, YLIM, ZLIM
      INCLUDE 'INCS:DGPH.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Scale X and Y.
      RLIM = 4.0
      IF (GPHIX2.EQ.GPHIX1) THEN
         RX = 0.0
      ELSE
         RX = (X - GPHX1) / (GPHX2 - GPHX1)
         END IF
      IF (GPHIY2.EQ.GPHIY1) THEN
         RY = 0.0
      ELSE
         RY = (Y - GPHY1) / (GPHY2 - GPHY1)
         END IF
      RX = MAX (-RLIM, MIN (RLIM, RX))
      RY = MAX (-RLIM, MIN (RLIM, RY))
      XLIM = NX
      YLIM = NY
      ZLIM = NZ
C                                       scale
      IF (DOPLAN.LE.2) THEN
         IXN = RX * GPHSCX + 1.5
         IYN = RY * GPHSCY + 1.5
      ELSE
         IXN = RX * (GPHIX2 - GPHIX1) + GPHIX1 + 1.5
         IYN = RY * (GPHIY2 - GPHIY1) + GPHIY1 + 1.5
         END IF
      X1 = MAX (1, MIN (XLIM, GPHIXL))
      Y1 = MAX (1, MIN (YLIM, GPHIYL))
      X2 = MAX (1, MIN (XLIM, IXN))
      Y2 = MAX (1, MIN (YLIM, IYN))
      IF ((X1.NE.GPHIXL) .OR. (Y1.NE.GPHIYL)) THEN
         ALPHA = 1.0
         IF (IXN.NE.GPHIXL) ALPHA = REAL(X1-IXN)/REAL(GPHIXL-IXN)
         BETA = 1.0
         IF (IYN.NE.GPHIYL) BETA = REAL(Y1-IYN)/REAL(GPHIYL-IYN)
         ALPHA = MIN (ALPHA, BETA)
         X1 = IXN + ALPHA * (GPHIXL-IXN) + 0.5
         Y1 = IYN + ALPHA * (GPHIYL-IYN) + 0.5
         END IF
      IF ((X2.NE.IXN) .OR. (Y2.NE.IYN)) THEN
         ALPHA = 1.0
         IF (IXN.NE.GPHIXL) ALPHA = REAL(X2-GPHIXL)/REAL(IXN-GPHIXL)
         BETA = 1.0
         IF (IYN.NE.GPHIYL) BETA = REAL(Y2-GPHIYL)/REAL(IYN-GPHIYL)
         ALPHA = MIN (ALPHA, BETA)
         X2 = GPHIXL + ALPHA * (IXN-GPHIXL) + 0.5
         Y2 = GPHIYL + ALPHA * (IYN-GPHIYL) + 0.5
         END IF
      CALL PLVECT (XLIM, YLIM, ZLIM, ICOL, X1, Y1, X2, Y2, TVPLAN)
C
 999  RETURN
      END
      SUBROUTINE PLVECT (NX, NY, NZ, ICOL, X1, Y1, X2, Y2, TVPLAN)
C-----------------------------------------------------------------------
C   Fills a line in an array
C   Inputs:
C      NX       I      X dimension of plane
C      NY       I      Y dimension of plane
C      NZ       I      Z dimension of plane
C      ICOL     I(3)   rgb colors to use
C      X1       I      X of first point
C      Y1       i      Y of first point
C      X2       I      X of 2nd point
C      Y2       I      Y of 2nd point
C   Output:
C      TVPLAN   I(*)   plane
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, ICOL(3), X1, X2, Y1, Y2, TVPLAN(NX,NY,*)
C
      REAL      X, Y, SLOPE
      INTEGER   IX, IY, IZ, IROUND
C-----------------------------------------------------------------------
      IX = ABS (X2-X1)
      IY = ABS (Y2-Y1)
C                                       loop over X
      IF (IX.GE.IY) THEN
         SLOPE = FLOAT (Y2 - Y1) / FLOAT (X2 - X1)
         IF (X1.LT.X2) THEN
            DO 10 IX = X1,X2
               Y = Y1 + SLOPE * (IX - X1)
               IY = IROUND (Y)
               IF ((IX.GE.1) .AND. (IX.LE.NX) .AND. (IY.GE.1) .AND.
     *            (IY.LE.NY)) THEN
                  DO 5 IZ = 1,NZ
                     TVPLAN(IX,IY,IZ) = ICOL(IZ)
 5                   CONTINUE
                  END IF
 10            CONTINUE
         ELSE IF (X2.LT.X1) THEN
            DO 20 IX = X2,X1
               Y = Y1 + SLOPE * (IX - X1)
               IY = IROUND (Y)
               IF ((IX.GE.1) .AND. (IX.LE.NX) .AND. (IY.GE.1) .AND.
     *            (IY.LE.NY)) THEN
                  DO 15 IZ = 1,NZ
                     TVPLAN(IX,IY,IZ) = ICOL(IZ)
 15                  CONTINUE
                  END IF
 20            CONTINUE
C                                       single pixel
         ELSE
            IX = X1
            IY = Y1
            IF ((IX.GE.1) .AND. (IX.LE.NX) .AND. (IY.GE.1) .AND.
     *         (IY.LE.NY)) THEN
               DO 22 IZ = 1,NZ
                  TVPLAN(IX,IY,IZ) = ICOL(IZ)
 22               CONTINUE
               END IF
            END IF
C                                       loop over Y
      ELSE
         SLOPE = FLOAT (X2 - X1) / FLOAT (Y2 - Y1)
         IF (Y1.LT.Y2) THEN
            DO 30 IY = Y1,Y2
               X = X1 + SLOPE * (IY - Y1)
               IX = IROUND (X)
               IF ((IX.GE.1) .AND. (IX.LE.NX) .AND. (IY.GE.1) .AND.
     *            (IY.LE.NY)) THEN
                  DO 25 IZ = 1,NZ
                     TVPLAN(IX,IY,IZ) = ICOL(IZ)
 25                  CONTINUE
                  END IF
 30            CONTINUE
         ELSE
            DO 40 IY = Y2,Y1
               X = X1 + SLOPE * (IY - Y1)
               IX = IROUND (X)
               IF ((IX.GE.1) .AND. (IX.LE.NX) .AND. (IY.GE.1) .AND.
     *            (IY.LE.NY)) THEN
                  DO 35 IZ = 1,NZ
                     TVPLAN(IX,IY,IZ) = ICOL(IZ)
 35                  CONTINUE
                  END IF
 40            CONTINUE
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE PLCOL3 (COLV, ICOL)
C-----------------------------------------------------------------------
C   Color integers returned
C   Input:
C      COLV   R      Color level 0 - 1
C   Output
C      ICOL   I(3)   R, G, B colors (0 to 1) * 32767
C-----------------------------------------------------------------------
      REAL      COLV
      INTEGER   ICOL(3)
C
      INTEGER   I
      REAL      COL(3)
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
      IF (MAXINT.LE.0) MAXINT = 8191
      CALL COLOR3 (COLV, .FALSE., COL)
      DO 10 I = 1,3
         ICOL(I) = COL(I) * MAXINT + 0.5
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE DRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IERR)
C-----------------------------------------------------------------------
C   Draw TVPLAN into a graphics plane or memory planes of TV only
C   Inputs:
C      NX       I      X dimension
C      NY       I      Y dimension
C      TVPLAN   I(*)   plane to draw
C   Outputs:
C      BUFFER   I(*)   plot buffer
C      IERR     I      error code
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, TVPLAN(NX,NY,*), BUFFER(*), IERR
C
      INTEGER   LX, IY, LY, CHAN, LC
      INCLUDE 'INCS:DGPH.INC'
C-----------------------------------------------------------------------
C                                       graphics
      IF (NZ.LE.1) THEN
         CALL GLTYPE (4, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Channel okay?
         GPHLTY = MAX (1, GPHLTY)
         CHAN = GPHTVG(GPHLTY)
         CALL GCINIT (CHAN, 0, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       load image
         LX = GPHIX0
         LY = GPHIY0 - 1
         DO 10 IY = 1,NY
            LY = LY + 1
            CALL YIMGIO ('WRIT', CHAN, LX, LY, 0, NX, TVPLAN(1,IY,1),
     *         IERR)
            IF (IERR.NE.0) GO TO 999
 10         CONTINUE
C                                       3 color grey scale
      ELSE
         DO 50 LC = 1,NZ
            CHAN = GPHTVC(LC)
            CALL GCINIT (CHAN, LC, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       load image
            LX = GPHIX0
            LY = GPHIY0 - 1
            DO 30 IY = 1,NY
               LY = LY + 1
               CALL YIMGIO ('WRIT', CHAN, LX, LY, 0, NX,
     *            TVPLAN(1,IY,LC), IERR)
               IF (IERR.NE.0) GO TO 999
 30            CONTINUE
 50         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE GRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IERR)
C-----------------------------------------------------------------------
C   Draw TVPLAN into a plot file
C   Inputs:
C      NX       I      X dimension
C      NY       I      Y dimension
C      NZ       I      Z dimension (1 B&W, 3 color)
C      TVPLAN   I(*)   plane to draw
C   Outputs:
C      BUFFER   I(*)   plot buffer
C      IERR     I      error code
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, TVPLAN(NX,NY,*), BUFFER(*), IERR
C
      INTEGER   LX, IY, LY, IGLO, IGHI
      REAL      RANGE(2), RANGES(2,3), X, Y
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
      IF (MAXINT.LE.0) MAXINT = 8191
C                                       Black & white
      IF (NZ.LE.1) THEN
         IGLO = 0
         IGHI = MAXINT
         RANGE(1) = 0.0
         RANGE(2) = MAXINT
         CALL GINITG (IGLO, IGHI, RANGE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       load image
         LX = GPHIX1
         X = LX
         LY = GPHIY1 - 1
         DO 10 IY = 1,NY
            LY = LY + 1
            Y = LY
            CALL GPOS (X, Y, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GRAYPX (NX, 0, TVPLAN(1,IY,1), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 999
 10         CONTINUE
C                                       3 color grey scale
      ELSE
         IGLO = 0
         IGHI = MAXINT
         RANGES(1,1) = 0.0
         RANGES(2,1) = MAXINT
         RANGES(1,2) = 0.0
         RANGES(2,2) = MAXINT
         RANGES(1,3) = 0.0
         RANGES(2,3) = MAXINT
         CALL GINITC (IGLO, IGHI, RANGES, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       load image
         LX = GPHIX1
         X = LX
         LY = GPHIY1 - 1
         DO 20 IY = 1,NY
            LY = LY + 1
            Y = LY
            CALL GPOS (X, Y, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL G3COLR (NX, 0, TVPLAN(1,IY,1), TVPLAN(1,IY,2),
     *         TVPLAN(1,IY,3), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 999
 20         CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE ISCALE (TYP, OMAX, RANGE, NPIX, NINC, RBUF, OUTBUF)
C-----------------------------------------------------------------------
C! scale a buffer by various functions to an integer buffer (ie for TV)
C# TV-util Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998-1999, 2002, 2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Rescale a line of map data in preparation for output device
C   Inputs:
C      TYP      C*2    Type of scaling function '  ' = linear
C                      'SQ' square root,      'NQ' negative sqrt
C                      'LG' log               'NG' negtive log
C                      'LN' linear (default)  'NL' negative linear
C      OMAX     I      Maximum value accepted by output device
C      RANGE    R(2)   Map range to transfer; RANGE(1) and (2)
C                      should be transfered to output 0 and OMAX
C                      RANGE(1) < RANGE(2) forced inside routine.
C      NPIX     I      Pixels/line
C      NINC     I      Increment between included pixels
C      RBUF     R(*)   Input buffer
C   Outputs:
C      OUTBUF   I(*)   output buffer with scaled data
C-----------------------------------------------------------------------
      CHARACTER TYP*2
      INTEGER   OMAX, NPIX, NINC, OUTBUF(*)
      REAL      RANGE(2), RBUF(*)
C
      INTEGER   I, NC, LINC
      LOGICAL   NEGATV
      REAL      SCL, RMIN, RMAX, RZERO, X, Y, XRANGE(2), RLOFF,
     *   XMAX, XMIN, RSCALE(2)
      INCLUDE 'INCS:DDCH.INC'
      SAVE RSCALE
      DATA RSCALE /9.0, 99.0/
C-----------------------------------------------------------------------
      NC = 0
      LINC = MAX (1, NINC)
      XRANGE(1) = RANGE(1)
      XRANGE(2) = RANGE(2)
      IF (XRANGE(2).EQ.XRANGE(1)) THEN
         XRANGE(1) = XRANGE(1) - 0.5
         XRANGE(2) = XRANGE(2) + 0.5
         END IF
C                                       Choose transfer type
      XMAX = MAX (XRANGE(1), XRANGE(2))
      XMIN = MIN (XRANGE(1), XRANGE(2))
      NEGATV = TYP(1:1).EQ.'N'
      RMAX = OMAX + 0.99
      RMIN = 1.01
C                                       Square root
      IF ((TYP.EQ.'SQ') .OR. (TYP.EQ.'NQ')) THEN
         SCL = (OMAX-0.02) / SQRT (ABS(XRANGE(2) -XRANGE(1)))
         DO 110 I = 1,NPIX,LINC
            Y = 0.0
            X = RBUF(I)
            IF (X.NE.FBLANK) THEN
               X = MIN (XMAX, MAX (XMIN, X))
               IF (NEGATV) THEN
                  Y = SCL * SQRT (ABS(X-XRANGE(2))) + RMIN
               ELSE
                  Y = SCL * SQRT (ABS(X-XRANGE(1))) + RMIN
                  END IF
               Y = MAX (RMIN, MIN (RMAX, Y))
               END IF
            NC = NC + 1
            OUTBUF(NC) = Y
 110        CONTINUE
C                                       logarithmic transfer function
      ELSE IF ((TYP.EQ.'LG') .OR. (TYP.EQ.'NG') .OR. (TYP.EQ.'L2') .OR.
     *   (TYP.EQ.'N2')) THEN
         RLOFF = RSCALE(1) / (XRANGE(2) - XRANGE(1))
         IF (TYP(2:2).EQ.'2') RLOFF = RSCALE(2) / (XRANGE(2)-XRANGE(1))
         RZERO = RLOFF * XRANGE(1) - 1.0
         IF (NEGATV) RZERO = RLOFF * XRANGE(2) + 1.0
         SCL = (OMAX-0.02) / LOG (1.0 + RLOFF * (XRANGE(2) -XRANGE(1)))
         RMAX = OMAX + 0.99
         RMIN = 1.01
         DO 210 I = 1,NPIX,LINC
            Y = 0.0
            X = RBUF(I)
            IF (X.NE.FBLANK) THEN
               X = RLOFF * MIN (XMAX, MAX (XMIN, X))
               IF (NEGATV) THEN
                  Y = SCL * LOG (RZERO - X) + RMIN
               ELSE
                  Y = SCL * LOG (X - RZERO) + RMIN
                  END IF
               Y = MAX (RMIN, MIN (RMAX, Y))
               END IF
            NC = NC + 1
            OUTBUF(NC) = Y
 210        CONTINUE
C                                       linear transfers
      ELSE
         SCL = (OMAX - 0.02) / (XRANGE(2) - XRANGE(1))
         RZERO = XRANGE(1) * SCL - 1.01
         RMAX = OMAX + 0.99
         RMIN = 1.01
         DO 310 I = 1,NPIX,LINC
            Y = 0.0
            IF (RBUF(I).NE.FBLANK) THEN
               Y = SCL * RBUF(I) - RZERO
               Y = MAX (RMIN, MIN (RMAX, Y))
               IF (NEGATV) Y = RMAX + RMIN - Y
               END IF
            NC = NC + 1
            OUTBUF(NC) = Y
 310        CONTINUE
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'ACCOR.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2)
      REAL      XSIN, XDISIN, XFLAG, TIME(8), SOLINT, BADD(10),
     *   BUFF1(256), SOLIN, TIME1, TIME2, GNMOD, STARTD, STOPD,
     *   TACCUM(MAXANT)
      INTEGER SNKOLS(MAXSNC), SNNUMV(MAXSNC), ISNRNO, NUMNOD,
     *   SNLUN, SNBUFF(1024), NPOLZN, NUMBIF, NUMTEL, SNV
      INTEGER   SEQIN, DISKIN, NUMHIS, ILOCWT, CATOLD(256),
     *   INCSI, INCFI, INCIFI, LRECI, NRPRMI, NANT, ANTNO(MAXANT),
     *   NNIF, NNF, NCORI, OLDCNO
      LOGICAL   ISCOMP, ISAPPL, DOSCAN
      CHARACTER NAMEIN*12, CLAIN*6, HISCRD(10)*64
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XFLAG, TIME, SOLINT,
     *   BADD
      COMMON /MYPARM/ CATOLD, BUFF1, SEQIN, DISKIN, NUMHIS, ILOCWT,
     *   INCSI, SOLIN, INCFI, INCIFI, LRECI, NRPRMI, ISCOMP, NNIF, NNF,
     *   NCORI, TIME1, TIME2, NANT, NUMTEL, NPOLZN, NUMBIF, STARTD,
     *   STOPD, OLDCNO, SNV
      COMMON /CHARPM/ NAMEIN, CLAIN, HISCRD
      COMMON /CANIN/ ANTNO, TACCUM
      COMMON /SNPARM/ SNBUFF, SNKOLS, SNNUMV, ISNRNO, NUMNOD,
     *   SNLUN, GNMOD, ISAPPL, DOSCAN
LOCAL END
      PROGRAM ACCOR
C-----------------------------------------------------------------------
C! Correct amplitudes using auto correlation measurements
C# Utility UV UV-util VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998-2001, 2003, 2008-2010, 2012,
C;  Copyright (C) 2014-2016, 2018, 2022, 2024-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ACCOR correct amplitudes' errors causing due to sampler errors
C   using auto correlation measurements. The correction is recorded
C   in SN table.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      TIMERANG(8)    TIME          Timerange to be copied
C                                   1-4 = start Day, Hour, Min, Sec.
C                                   5-8 =  end  Day, Hour, Min, Sec.
C      SOLINT         SOLINT        Solution interval in minutes
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'ACCOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
C
      DATA PRGM /'ACCOR '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL ACCIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Calculate corrections and
C                                       record them into SN table
      CALL ACRCOR (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL ACCHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE ACCIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   ACCIN gets input parameters for ACCOR and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, UTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, VER, KEYLOC, KEYTYP,
     *   ORIGIN, NUMKEY
      REAL      DECNOD(25), RANOD(25), TTIME, CATR(256)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      LOGICAL   T, F, CHSTAT, MULTI
      INCLUDE 'ACCOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATH, CATR, CATD)
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL SELINI
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 27
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       SOLINT
      IF (SOLINT.EQ.0.0) SOLINT = -2
C                                       to pay attention on scan
C                                       if SOLINT is negative
      DOSCAN = .FALSE.
      IF (SOLINT.LT.-0.1) THEN
         SOLINT = ABS(SOLINT)
         DOSCAN = .TRUE.
         END IF
C                                       SOLIN is in minutes
      SOLIN = SOLINT
C                                       SOLINT is in days
      SOLINT = SOLINT / (24.0*60.0)
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   UTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOXCOR = .FALSE.
      DOACOR = .TRUE.
      FGVER = IROUND (XFLAG)
C                                       Determine stop time of data
      CALL UVTIME (DISKIN, OLDCNO, CATBLK, STARTD, STOPD, JERR)
      IF (JERR.NE.0) THEN
         JERR = 1
         WRITE (MSGTXT,1020)
         GO TO 990
         END IF
      TIME1 = TIME(1)+TIME(2)/24.+TIME(3)/(24.*60.)+TIME(4)/(24.*3600.)
      TIME2 = TIME(5)+TIME(6)/24.+TIME(7)/(24.*60.)+TIME(8)/(24.*3600.)
      IF (TIME1.EQ.0.0) TIME1 = -1.0E6
      IF ((TIME1.GE.TIME2) .OR. (TIME2.EQ.0.0)) TIME2  = 1.0E6
      IF (TIME1.LT.STARTD) TIME1 = STARTD
      IF (TIME2.GT.STOPD) TIME2 = STOPD
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
      NNIF = 1
      NNF = 1
C      IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
      IF (JLOCIF.GE.0) NNIF = CATBLK(KINAX+JLOCIF)
      IF (JLOCF.GE.0) NNF = CATBLK(KINAX+JLOCF)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                        Put input file in READ
      UTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   UTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Prepare antennas data
      VER = 1
      CALL ANTDAT (VER, DISKIN, OLDCNO, IERR)
      IF (IERR .NE. 0) THEN
         JERR = 1
         WRITE (MSGTXT, 1120)
         GO TO 990
         END IF
C                                       Open SN table
C                                       Change status to 'writ'
C                                       Determine status of file
      UTYPE = 'UV'
      CHSTAT = .FALSE.
      CALL CATDIR ('INFO', DISKIN, OLDCNO, NAMEIN, CLAIN,
     *   SEQIN, UTYPE, NLUSER, STAT, BUFF1, IERR)
C                                       Change status
      IF (STAT.EQ.'READ') THEN
         STAT = 'CLRD'
         CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN,
     *      SEQIN, UTYPE, NLUSER, STAT, BUFF1 , IERR)
         IF (IERR .NE. 0) THEN
            JERR = 1
            WRITE (MSGTXT,1140) IERR, STAT
            GO TO 990
            END IF
         STAT = 'WRIT'
         CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN,
     *      SEQIN, UTYPE, NLUSER, STAT, BUFF1, IERR)
         IF (IERR .NE. 0) THEN
            JERR = 1
            WRITE (MSGTXT,1140) IERR, STAT
            GO TO 990
            END IF
         CHSTAT = .TRUE.
         END IF
C
      ISAPPL = F
      GNMOD = 1.0
      DO 60 I = 1, 25
         RANOD(I) = 0.0
         DECNOD(I) = 0.0
 60      CONTINUE
      SNLUN = 48
      NUMBIF = NNIF
      NUMTEL = NANT
      NPOLZN = 2
      IF (NCOR.EQ.1) NPOLZN = 1
      NUMNOD = 0
      SNV = 0
      CALL SNINI ('WRIT', SNBUFF, DISKIN, OLDCNO, SNV, CATOLD, SNLUN,
     *   ISNRNO, SNKOLS, SNNUMV, NUMTEL, NPOLZN, NUMBIF, NUMNOD,
     *   GNMOD, RANOD, DECNOD, ISAPPL, IERR)
      IF (IERR .NE. 0) THEN
         JERR = 1
         WRITE (MSGTXT,1010) SNV
         GO TO 990
         END IF
C                                       history file
      NUMHIS = NUMHIS + 1
      TTIME = 0
      DO 80 I = 1, 8
         TTIME = TTIME + TIME(I)
 80      CONTINUE
      IF (TTIME.EQ.0.0) THEN
         WRITE (HISCRD(NUMHIS),2100)
      ELSE
         WRITE (HISCRD(NUMHIS),2200) (TIME(I), I =1,8)
         END IF
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2300) SNV
      NUMHIS = NUMHIS + 1
C                                       averaged by scans or by the
C                                       given SOLINT?
      WRITE (HISCRD(NUMHIS),2500) SOLIN
C
      ISNRNO = 1
      WRITE (MSGTXT,1060) SNV
      CALL MSGWRT (3)
C                                       Add the ORIGIN keyword
      CALL MULSDB (CATOLD, MULTI)
      KEYLOC = 1
      KEYTYP = 4
      ORIGIN = 0
      NUMKEY = 1
      IF (.NOT.MULTI) ORIGIN = 1
      CALL TABKEY ('WRIT', 'SNORIGIN', NUMKEY, SNBUFF, KEYLOC,
     *   ORIGIN, KEYTYP, IERR)
      IF (IERR.NE.0) THEN
         JERR = 1
         WRITE (MSGTXT,1015) IERR
         GO TO 990
         END IF
C                                       Check if changed status
      IF (CHSTAT) THEN
         STAT = 'CLWR'
         CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN,
     *      SEQIN, UTYPE, NLUSER, STAT, BUFF1, IERR)
         IF (IERR .NE. 0) THEN
            JERR = 1
            WRITE (MSGTXT,1140) IERR, STAT
            GO TO 990
            END IF
         STAT = 'READ'
         CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN,
     *      SEQIN, UTYPE, NLUSER, STAT, BUFF1, IERR)
         IF (IERR .NE. 0) THEN
            WRITE (MSGTXT,1140) IERR, STAT
            GO TO 990
            END IF
         END IF
      JERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ACCIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('ACCIN: ERROR in initialization of SN table ',I3)
 1015 FORMAT ('ACCIN: ERROR',I3,' READING KEYWORDS FROM SN TABLE')
 1020 FORMAT ('ACCIN: UNABLE TO DETERMINE DATA STOP TIME')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1060 FORMAT ('Writing to SN table ',I3)
 1120 FORMAT ('ACCIN: PROBREM OF READING DATA FROM ANTENNA TABLE')
 1140 FORMAT ('ACCIN: ERROR ',I3,' CHANGING ',A4,' STATUS')
 2100 FORMAT ('TIMERANG = beginning to end')
 2200 FORMAT (F3.0,1X,F3.0,F3.0,F4.1,' - ',F3.0,1X,F3.0,F3.0,F4.1,
     *   '/ Time range')
 2300 FORMAT ('SN table =',I3)
 2500 FORMAT ('SOLINT = ', F5.1, ' minutes')
      END
      SUBROUTINE ACRCOR (IRET)
C-----------------------------------------------------------------------
C   ACRCOR calculates deviation of auto correlation from unit and record
C   it into SN table.
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
c
      INTEGER   I, L, IA1, IA2, INCX, JIF, JF, JS, IND, IANT, INDEXI,
     *   SUBA, SOUN, FREQN, MODENO, NUMVIS, VISINC, VISMSG
      DOUBLE PRECISION CTIM
      INCLUDE 'ACCOR.INC'
      INTEGER   MAXM
      PARAMETER (MAXM = 2 * MAXANT * MAXIF)
      REAL      BASEN, DMEAN, MEAN(MAXM), TMAX, TMIN, REAL(2,MAXIF),
     *   IMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF), WEIGHT(2,MAXIF),
     *   MBDELY(2), TIMINT, EPS, SWT(MAXM), WT, WTT, IFRM, RPARM(20),
     *   VIS(3,UVBFSS/3), DISP(2), DDISP(2)
      INTEGER   SCNSUB, SCNSOU, IDUM1, IDUM2, FREQID, IERR
      REAL      SCNTIM, SCNDT, SCNEND, CURTIM, SCNDTM
      LOGICAL   DONDX, GOTDAT, ISEOF
      INTEGER   REFA(2,MAXIF), LNXBUF(512), LNXKOL(MAXNXC),
     *   LNXNUM(MAXNXC), LNXRNO
      CHARACTER SNNAME*48
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------

C                                       Dimension of complex axis
      INCX = CATOLD(KINAX)
      IF (ISCOMP) INCX = 3
C                                       Number of visibilities in input
      NCORI = (LRECI - NRPRMI) / CATOLD(KINAX)
      GOTDAT = .FALSE.
C                                       Open and init for read
C                                       visibility file
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      VISINC = CATBLK(KIGCN) / 25
      VISMSG = CATBLK(KIGCN) / 10
      VISINC = MAX (40000, MIN (200000,VISINC))
      VISMSG = (VISMSG / VISINC) * VISINC
      IF (VISMSG.LT.VISINC) VISMSG = 100 * VISINC
C                                       Initials for a new SN table
      DO 20 L = 1, 2
         MBDELY(L) = 0.0
         DISP(L) = 0.0
         DDISP(L) = 0.0
         DO 10 I = 1, NNIF
            IMAG(L, I) = 0.0
            REAL(L,I) = 1.0
            DELAY(L, I) = 0.0
            RATE(L, I) = 0.0
            WEIGHT(L, I) = 1.0
            REFA(L, I) = ANTNO(1)
 10         CONTINUE
 20      CONTINUE
C                                       Force the auto correlation
C                                       mean to zero
      DO 50 IANT = 1, NANT
         TACCUM(IANT) = 0
         DO 40 JIF = 1,NNIF
            DO 30 JS = 1,NPOLZN
               IND= JS + (JIF-1)*NPOLZN + (IANT-1)*NPOLZN*NNIF
               MEAN(IND) = 0.0
               SWT(IND) = 0.0
  30           CONTINUE
  40        CONTINUE
  50     CONTINUE
C                                       begin of buisness1 with NX table
C                                       Initialize I/O to INDEX file
      MSGSUP = 32000
      IXLUN = 98
      CALL NDXINI ('READ', LNXBUF, DISKIN, OLDCNO, 1, CATOLD, IXLUN,
     *   LNXRNO, LNXKOL, LNXNUM, IERR)
      MSGSUP = 0
      DONDX = IERR.EQ.0
C
      LNXRNO = 1
C                                       Dummy if no scans
      SCNTIM = -1.0E10
      SCNEND =  1.0E10
      EPS = 1.0/(60.0*60.0*24.0)
C                                   Read first scan info
      IF (DONDX) THEN
         CALL TABNDX ('READ', LNXBUF, LNXRNO, LNXKOL, LNXNUM, SCNTIM,
     *      SCNDT, SCNSOU, SCNSUB, IDUM1, IDUM2, FREQID, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Add 0.5 sec to each end
         SCNDT = SCNDT + EPS
         SCNTIM = SCNTIM - 0.5 * SCNDT
         SCNEND = SCNTIM + SCNDT
         END IF
C
      TMIN = TIME1
      TMAX = TMIN + SOLINT
      IF (TMAX.GT.TIME2) TMAX = TIME2
C
C   *******        This is where the routine loops back to after
C   *******        finishing a solution interval
C
C                                       end of buisness1 with NX table
      NUMVIS = 0
C                                       READ loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over buffer
      ELSE
C                                       Out of data?
         ISEOF = IRET.LT.0
         IF (IRET.EQ.0) THEN
            NUMVIS = NUMVIS + 1
            IF (MOD(NUMVIS-1,VISMSG).EQ.0) THEN
               WRITE (MSGTXT,1105) NUMVIS
               CALL MSGWRT (2)
            ELSE IF (MOD(NUMVIS-1,VISINC).EQ.0) THEN
               WRITE (MSGTXT,1105) NUMVIS
               CALL MSGWRT (1)
               END IF
            END IF
C                                       Begin Loop in time.
         IF (ISEOF) THEN
            CURTIM = 10000.
         ELSE
            CURTIM = RPARM(1+ILOCT)
            END IF
         IF (CURTIM.LT.TIME1) GO TO 100
C                                       Determine subarray, source,
C                                       FREQID of the previous scan
         SUBA = SCNSUB
C                                       If averaging through costant
C                                       time (not scan) record the same
C                                       SOUN = 0 and FREQN = 0
         IF (DOSCAN) THEN
            SOUN = SCNSOU
            FREQN = FREQID
         ELSE
            SOUN = 0
            FREQN = 0
            END IF
C                                       next scan?
C                                       pay attention on scans only if
C                                       SOLINT=-1
         IF (CURTIM.GT.SCNEND .AND. DOSCAN) THEN
            TMAX = SCNEND
C
            IF (DONDX) THEN
C                                       Find next index record
 105           IF (LNXRNO.LE.LNXBUF(5)) THEN
                  CALL TABNDX ('READ', LNXBUF, LNXRNO, LNXKOL, LNXNUM,
     *               SCNTIM, SCNDT, SCNSOU, SCNSUB, IDUM1, IDUM2,
     *               FREQID, IERR)
                  IF (IERR.NE.0) GO TO 999
C                                       Add 0.5 sec to each end
                  SCNDT = SCNDT + EPS
                  SCNTIM = SCNTIM - 0.5 * SCNDT
                  SCNEND = SCNTIM + SCNDT
                  IF (CURTIM.GT.SCNEND) GO TO 105
               ELSE
                  SCNEND = CURTIM + EPS
                  END IF
               END IF
         ELSE
            IF (TMAX.EQ.STOPD) THEN
               IF (CURTIM.LE.(TMAX-EPS)) GO TO 200
            ELSE
               IF (CURTIM.LE.TMAX) GO TO 200
               END IF
            END IF
C                                       Do a record into SN table
C
C                                       Length and central of time
C                                       interval for SN table
         CTIM = 0.5D0 * (TMIN + TMAX)
         TIMINT = TMAX - TMIN
C
         IFRM = 0.0
         MODENO = 0
         DO 130 IANT = 1, NANT
            DO 120 JIF = 1,NNIF
               DO 110 JS = 1,NPOLZN
                  IND = JS + (JIF-1)*NPOLZN + (IANT-1)*NPOLZN*NNIF
                  IF (SWT(IND).GT.0.0) THEN
                     MEAN(IND) = MEAN(IND) / SWT(IND)
                  ELSE
                     MEAN(IND) = 0.0
                     END IF
                  IF (MEAN(IND).GT.0.0) THEN
                     REAL(JS,JIF) = 1.0 / SQRT(MEAN(IND))
                     IMAG(JS,JIF) = 0.0
                     GOTDAT = .TRUE.
                  ELSE
                     REAL(JS,JIF) = FBLANK
                     IMAG(JS,JIF) = FBLANK
                     END IF
C                 WRITE (MSGTXT,1900) IANT, JIF, MEAN(IND), SWT(IND)
C                 CALL MSGWRT (2)
 110              CONTINUE
 120           CONTINUE
C                                       record only if the accumulated
C                                       time for the given antenna is
C                                       big enough
C
C                                       SCNDTM scan length in minutes
            SCNDTM = 1000
            IF (DOSCAN) SCNDTM = SCNDT*24*60
            IF ((TACCUM(IANT).GT.0.1*MIN(SOLIN,SCNDTM))
     *         .OR. (SOLIN.GT.60)) THEN
C                                       write SN table
               CALL TABSN ('WRIT', SNBUFF, ISNRNO, SNKOLS, SNNUMV,
     *            NPOLZN, CTIM, TIMINT, SOUN, ANTNO(IANT), SUBA,
     *            FREQN, IFRM, MODENO, MBDELY, DISP, DDISP, REAL, IMAG,
     *            DELAY, RATE, WEIGHT, REFA, IRET)
               END IF
 130        CONTINUE
C                                       quit if done with data
         IF (ISEOF) GO TO 500
C                                       Force the auto mean to
C                                       zero for next SN record
         DO 180 IANT = 1, NANT
            TACCUM(IANT) = 0
            DO 160 JIF = 1,NNIF
               DO 140 JS = 1,NPOLZN
                  IND = JS + (JIF-1)*NPOLZN + (IANT-1)*NPOLZN*NNIF
                  MEAN(IND) = 0.0
                  SWT(IND) = 0.0
 140              CONTINUE
 160           CONTINUE
 180        CONTINUE
C                                       TMIN, TMAX for next SN row
 190     TMIN = CURTIM
         TMAX = TMIN + SOLINT
         IF (TMAX.GT.TIME2) TMAX = TIME2
         IF (TMAX.EQ.STOPD) THEN
            IF (RPARM(1+ILOCT).GT.(TIME2-EPS) ) GO TO 500
         ELSE
            IF (RPARM(1+ILOCT).GT.TIME2 ) GO TO 500
            END IF
C
         IF (RPARM(1+ILOCT).GT.TMAX ) GO TO 190
C                                       accumulate auto correlation
C                                       data
 200     IF (ILOCB.GE.0) THEN
            BASEN = RPARM(1+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
            END IF
C                                       take only auto correlation
         IF (IA1.NE.IA2) GO TO 100
         DO 220 IANT = 1, NANT
            IF (IA1.EQ.ANTNO(IANT)) GO TO 230
 220        CONTINUE
         GO TO 100
C                                       accumulated time for the given
C                                       antenna, in minutes
 230     IF (ILOCIT.GE.0) THEN
            TACCUM(IANT) = TACCUM(IANT) + RPARM(1+ILOCIT)/60
         ELSE
            TACCUM(IANT) = TACCUM(IANT) + 0.166
            END IF
         DO 260 JIF = 1,NNIF
            DO 250 JS = 1,NPOLZN
               IND = JS + (JIF-1)*NPOLZN + (IANT-1)*NPOLZN*NNIF
               DMEAN = 0.0
               WT = 0.0
               DO 240 JF = 1,NNF
                  INDEXI = (JIF-1) * INCIFI + (JF-1) *
     *               INCFI + (JS-1) * INCSI + 1
                  WTT = VIS(3,INDEXI)
                  IF (WTT.GT.0.0) THEN
                     DMEAN = DMEAN + VIS(1,INDEXI)
                     WT = WT + WTT
                     END IF
 240              CONTINUE
               DMEAN = DMEAN / NNF
               WT = WT / NNF
C                                       accumulate MEAN with weights
               SWT(IND) = SWT(IND) + WT
               MEAN(IND) = MEAN(IND) + DMEAN *WT
 250           CONTINUE
 260        CONTINUE
C                                       Read next buffer.
         GO TO 100
         END IF
C                                       Close files
 500  CALL UVGET ('CLOS', RPARM, VIS, IRET)
C                                       Close SN table
      CALL TABIO ('CLOS', 0, ISNRNO, SNBUFF, SNBUFF, IRET)
C                                       Close index file
      IF (DONDX) CALL TABIO ('CLOS', 0, LNXRNO, LNXBUF, LNXBUF, IRET)
      IF (GOTDAT) THEN
         IRET = 0
         GO TO 999
      ELSE
         MSGTXT = 'ACRCOR: NO VALID AC DATA FOUND'
         IRET = 10
         END IF
C                                       Error
 990  CALL MSGWRT (8)
C                                       delete SN table on error
      IF (IRET.GT.0) THEN
         CALL ZPHFIL ('SN', DISKIN, OLDCNO, SNV, SNNAME, I)
         CALL ZDESTR (DISKIN, SNNAME, I)
         CALL DELEXT ('SN', DISKIN, OLDCNO, 'READ', CATOLD, SNBUFF, SNV,
     *      I)
         WRITE (MSGTXT,1990) SNV
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ACRCOR: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1105 FORMAT ('At autocorrelation visibility record',I10)
 1100 FORMAT ('ACRCOR: ERROR',I3,' READING VIS FILE')
C 1900 FORMAT ('ANT=', I3, '  IF=', I3, ' MEAN =',F7.4, ' WEIGHT',F7.4)
 1990 FORMAT ('ACRCOR: DELETED SN VERSION',I5,' DUE TO ERROR')
      END
      SUBROUTINE ANTDAT (VER, DISKI, CNOIN, IERR)
C-----------------------------------------------------------------------
C   Selects station information
C   Inputs:
C      VER           I    Antenna array number (AN file ver.)
C      DISKI         I    Vol number
C      CNOIN         I    CNO
C   Outputs in common:
C      NANT          I    Number of antennas
C      ANTNO(*)      I    Array of antennas' numbers
C-----------------------------------------------------------------------
      INTEGER   IERR, IA, LUNA, CNOIN, IABUF(512), VER,  DISKI
      REAL      UT1XXX, IATUTC
      CHARACTER STNAME*8
      INCLUDE 'ACCOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                     open antenna file
      LUNA = 28
      CALL ANTINI ('READ', IABUF, DISKI, CNOIN, VER, CATBLK, LUNA,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1XXX, IATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IERR)
      IF (IERR .NE. 0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                     Get antenna info.
      NANT = 0
      DO 30 IA = 1,IABUF(5)
         IANRNO = IA
         CALL TABAN ('READ', IABUF, IANRNO, ANKOLS, ANNUMV, STNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IA, IERR
            CALL MSGWRT (8)
            END IF
         ANTNO(IA) = NOSTA
         NANT = MAX (NANT, NOSTA)
 30      CONTINUE
C                                     close antenna file
      CALL TABIO ('CLOS', 1, IANRNO, IABUF, IABUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ANTDAT: ERROR IN OPEN AN-FILE IERR = ',I6)
 1010 FORMAT ('ANTDAT: ERROR IN FINDING STATION',I3,' IERR=',I3)
 1030 FORMAT ('ANTDAT: ERROR IN CLOSING AN-FILE IERR = ',I6)
      END
      SUBROUTINE ACCHIS
C-----------------------------------------------------------------------
C   ACCHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER CTIME(2)*12,  HILINE*72, LABEL*8
      INTEGER   LUN, IERR, TIM(3), DATE(3), I
      LOGICAL   T
      INCLUDE 'ACCOR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN, DISKIN, FCNO(NCFILE), BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIM)
      CALL TIMDAT (TIM, DATE, CTIME(2)(1:8), CTIME)
      WRITE (HILINE,1010) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any other history.
      IF (NUMHIS.LE.0) GO TO 200
         WRITE (LABEL,1020) TSKNAM
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN, HILINE, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
C                                       Close HI file
 200   CALL HICLOS (LUN, T, BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ACCHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6, 'RELEASE =''',A7,' ''  /********* Start ',
     *   A12, 2X, A8)
 1020 FORMAT (A6)
      END

LOCAL INCLUDE 'SETJY.INC'
C                                       Local include for SETJY
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXSOU
C                                       Maximum number of sources
      PARAMETER (MAXSOU = 5000)
      INTEGER   SEQIN, DISKIN, OLDCNO, IVER, EIF, BIF, NSOUWD, FREQID,
     *   SQUAL, NSOURC, ICOEFF, JCOEFF(MAXSOU), LCOEFF(MAXSOU), RIF
      LOGICAL   DOSWNT, DOFQSL, IS1934
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XALIAS(4,30),
     *   XCALCO, XVELTY(2), XVELDE(2), XOPTY, XCODTY
      CHARACTER NAMEIN*12, CLAIN*6, XSOUR(30)*16, CLCODE*4, VELTP*8,
     *   VELDF*8, OPTYPE*4, SOUNAM(MAXSOU)*16, NEWCOD*4, SALIAS(30)*16
      REAL      XSEQIN, XDISKI, XQUAL, XBIF, XEIF, ZEROSP(5), SPECI(4),
     *   XNIF, SYSV, RESTF(2), XFQID, APARM(10),
     *   PRIMFL(MAXIF,MAXSOU), PRIMFE(MAXIF,MAXSOU), PRIMSP(5,MAXSOU),
     *   PRIMFO(MAXIF,MAXSOU), PRIMEO(MAXIF,MAXSOU), VELS(MAXIF,MAXSOU)
      DOUBLE PRECISION FRCALC(MAXIF)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XXSOUR, XALIAS,
     *   XQUAL, XCALCO, XBIF, XEIF, ZEROSP, SPECI, XOPTY, XCODTY, XNIF,
     *   SYSV, RESTF, XVELTY, XVELDE, XFQID, APARM
      COMMON /CHRCOM/ NAMEIN, CLAIN, XSOUR, CLCODE, VELTP, VELDF,
     *   OPTYPE, SOUNAM, NEWCOD, SALIAS
      COMMON /EDTINF/ FRCALC, PRIMFL, PRIMFO, DOSWNT, DOFQSL, NSOUWD,
     *   SEQIN, DISKIN, OLDCNO, IVER, EIF, BIF, FREQID, SQUAL, NSOURC,
     *   PRIMFE, PRIMEO, ICOEFF, PRIMSP, IS1934, VELS, JCOEFF, LCOEFF,
     *   RIF
LOCAL END
      PROGRAM SETJY
C-----------------------------------------------------------------------
C! Enters source flux densities in a SU (source) table.
C# UV Calibration EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1999-2000, 2004-2007, 2009-2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  SETJY enters flux densities in an SU table.
C   ADVERBS:
C    INNAME      Input image name (name)
C    INCLASS     Input image name (class)
C    INSEQ       Input image name (seq. #)
C    INDISK      Input image disk unit #
C    SOURCES     The list of sources
C    BIF         Low IF # for flux density.
C    EIF         High IF # for flux density.
C    ZEROSP      I,Q,U,V flux density
C    CLCODE      Calibrator code
C    SYSVEL      Velocity of source (m/s) at pixel defined
C                by APARM(1)
C    RESTFREQ    Line rest frequency (Hz)
C    VELTP       Velocity type 'LSR,'HELIO'
C    VELDF       Velocity defination 'RADIO' or 'OPTICAL'
C    APARM       1: pixel to which SYSVEL refers (0 => 1)
C    APARM       2: epoch of flux scale (LEQ 0 => 1999.2, 1 => Baars,
C                  2 => 1995.2, GEQ 3 => 1990)
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET, BUFFER(256)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'SETJY.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'SETJY '/
C-----------------------------------------------------------------------
C                                       Initialize
      CALL SETJIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Edit tables
      CALL SETJ (IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Add history to output
      CALL STJHIS
C                                       Close down files, etc
 995  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE SETJIN (PRGM, IRET)
C-----------------------------------------------------------------------
C   Initialization subroutine for SETJY
C   Inputs:
C      PRGN   C*6   Program name
C   Output:
C      IRET   I     Error code: 0 => ok
C                      4 => user routine detected error.
C                      5 => catalog troubles
C                      8 => can't start
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
C
      CHARACTER TYPE*2, STAT*4
      INTEGER   BUFF1(256), NPARM, IROUND, IERR, I, LUN
      LOGICAL   MATCH
      REAL      SELBAN
      DOUBLE PRECISION SELFRQ
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'SETJY.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE., BUFF1)
      CALL VHDRIN
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 277
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      DISKIN = IROUND (XDISKI)
      BIF = IROUND (XBIF)
      EIF = IROUND (XEIF)
      FREQID = IROUND (XFQID)
      SQUAL = IROUND (XQUAL)
      IS1934 = .FALSE.
      RIF = IROUND (XNIF)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (8, 1, XVELTY, VELTP)
      CALL H2CHR (8, 1, XVELDE, VELDF)
      CALL H2CHR (4, 1, XOPTY, OPTYPE)
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
         CALL H2CHR (16, 1, XALIAS(1,I), SALIAS(I))
 20      CONTINUE
C                                       cal code
      CALL H2CHR (4, 1, XCALCO, CLCODE)
      CALL H2CHR (4, 1, XCODTY, NEWCOD)
      IF (NEWCOD(1:1).EQ.'*') THEN
         MSGTXT = 'CODETYPE = ''' // CLCODE // ' ILLEGAL'
         IRET = 1
         GO TO 990
         END IF
C                                       Coefficient set to
C                                       use for flux density
C                                       calculation
      ICOEFF = IROUND (APARM(2))
      ICOEFF = MAX (-1, MIN (6, ICOEFF))
C                                       Find input
      OLDCNO = 1
      TYPE = '  '
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, TYPE,
     *   NLUSER, STAT, BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read old CATBLK and mark 'READ'
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'WRIT', BUFF1, IRET)
      IF ((IRET.GT.0) .AND. (IRET.LT.5)) THEN
         WRITE (MSGTXT,1040) IRET
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 1
C                                       Fill UVH.INC
      CALL UVPGET (IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1050) IRET
         GO TO 990
         END IF
C                                       APARM(4) default
      IF (APARM(4).EQ.0.0) APARM(4) = (1 + CATBLK(KINAX+JLOCF)) / 2.0
      CALL DFILL (MAXIF, 0.0D0, FRCALC)
C                                       Check to see if fq entries
      DOFQSL = ILOCFQ.GT.0
      IF (DOFQSL) THEN
         IF (FREQID.EQ.0) FREQID = -1
         SELBAN = 0.0
         SELFRQ = 0.D0
         LUN = 28
C                                       Give warning message if FREQID
C                                       -1 since should specify FREQID
C                                       for mode CALC, else frequency
C                                       may be wrong if
C                                       desired frequency not ref. freq
         IF (FREQID.LE.0 .AND. OPTYPE.EQ.'CALC') THEN
            WRITE (MSGTXT,1055) FREQID
            CALL MSGWRT (6)
            MSGTXT = '     FREQID WILL BE RESET TO 1, CHECK YOUR' //
     *         ' RESULTS CAREFULLY'
            CALL MSGWRT (6)
            END IF
C
         CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ,
     *      MATCH, FREQID, IRET)
         IF (.NOT.MATCH) THEN
            MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS' //
     *         ' - CHECK INPUTS'
            IRET = 1
            GO TO 990
            END IF
         IF (IRET.GT.0) GO TO 999
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' GETING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',I3,
     *   ' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' FILLING UVH.INC')
 1055 FORMAT ('**WARNING: OPCODE=CALC AND FREQID = ',I4)
      END
      SUBROUTINE SETJ (IRET)
C-----------------------------------------------------------------------
C   Subroutine to add flux densities and calcode to source table.
C   Output:
C      IRET   I  Return code, 0=OK, else failed.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER KEYWRD(2)*8, COMPAR(2)*4
      INTEGER   BUFFER(768), SUKOLS(MAXSUC), SUNUMV(MAXSUC), NUMIF, J,
     *   LUN1, LUN2, LUN3, IIF, JERR, SOUWAN(30), LSIGN, CVER, LOOP,
     *   BUFF2(768), KEYLOC(2), KEYVAL(8), KEYTYP(2), NFRQ, ISURNO,
     *   NDONE, BUFFX(1024), ISBAND(MAXIF), REFANT
      LOGICAL   NOFLUX, HELO
      REAL      ALTRFP(MAXIF), REFPIX, FINC(MAXIF)
      DOUBLE PRECISION NUX(MAXIF), FOFF(MAXIF), TFREQ, SPX, SPX1,
     *   REFFRQ, DREST
C                                       DSOU.INC vars no in common
      INTEGER   IDSOUR, QUAL, SUFQID, ID(3), IDNUM
      REAL      FLUX(4,MAXIF), DD
      DOUBLE PRECISION FREQO(MAXIF), BANDW, RAEPO, DECEPO, EPOCH, RAAPP,
     *   DECAPP, RAOBS, DECOBS, LSRVEL(MAXIF), RESTFQ(MAXIF), PMRA,
     *   PMDEC, FRQREF, FRQDIF
      CHARACTER CALCOD*4, VELTYP*8, VELDEF*8, BNDCOD(MAXIF)*8, DATE*8,
     *   SNAME*16
C
      INCLUDE 'SETJY.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA KEYWRD /'VELDEF  ', 'VELTYP  '/
      DATA LUN1, LUN2, LUN3 /77,78,79/
      DATA COMPAR /'RADI','OPTI'/
C-----------------------------------------------------------------------
C                                       If invalid OPTYPE, exit
      IF((OPTYPE.NE.'RESE') .AND. (OPTYPE.NE.'REJY') .AND.
     *   (OPTYPE.NE.'CALC') .AND. (OPTYPE.NE.'REVL') .AND.
     *   (OPTYPE.NE.' ') .AND. (OPTYPE.NE.'SPEC') .AND.
     *   (OPTYPE.NE.'VCAL') .AND. (OPTYPE.NE.'VANT')) THEN
         IRET = 1
         MSGTXT = 'INVALID OPTYPE = ''' // OPTYPE // ''' - TRY AGAIN'
         GO TO 990
         END IF
C                                       See if fluxes to be changed
      IF ((OPTYPE.EQ.'RESE') .OR. (OPTYPE.EQ.'REJY') .OR.
     *   (OPTYPE.EQ.'REVL') .OR. (OPTYPE.EQ.'CALC') .OR.
     *   (OPTYPE.EQ.'VCAL') .OR. (OPTYPE.EQ.'VANT'))
     *   CALL RFILL (4, 0.0, ZEROSP)
      NOFLUX = (ABS (ZEROSP(1)).LE.1.0E-20) .AND.
     *   (ABS (ZEROSP(2)).LE.1.0E-20) .AND. (ABS (ZEROSP(3)).LE.1.0E-20)
     *   .AND. (ABS (ZEROSP(4)).LE.1.0E-20)
      IF (NOFLUX) CALL RFILL (4, 0.0, SPECI)
C                                       Reformat table if necessary
      CALL FMTSOU (DISKIN, OLDCNO, CATBLK, LUN1, LUN2, BUFFER, BUFF2,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Crunch source list
      CALL FNDSOU (DISKIN, OLDCNO, XSOUR, BUFFER, NSOUWD, DOSWNT,
     *   SOUWAN, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Fill frequency table
      CVER = 1
      IF ((DOFQSL) .AND. (FREQID.LT.0)) THEN
         WRITE (MSGTXT,2000) FREQID
         IRET = 1
         GO TO 990
         END IF
      CALL CHNDAT ('READ', BUFFER, DISKIN, OLDCNO, CVER, CATBLK,
     *   LUN3, NUMIF, FOFF, ISBAND, FINC, BNDCOD, FREQID, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
      REFFRQ = CATD(KDCRV+JLOCF)
      IF ((ICOEFF.GT.0) .AND. (REFFRQ.LE.5.0D8)) ICOEFF = -1
      CALL FILL (MAXSOU, ICOEFF+1, JCOEFF)
      CALL FILL (MAXSOU, ICOEFF, LCOEFF)
      IF ((ICOEFF.EQ.0) .AND. (REFFRQ.LE.5.0D8))
     *   CALL FILL (MAXSOU, -1, JCOEFF)
C                                       Open SU table
C                                       First read it to get current
C                                       values
      CALL SOUINI ('READ', BUFFER, DISKIN, OLDCNO, 1, CATBLK, LUN1,
     *   NUMIF, VELTYP, VELDEF, SUFQID, ISURNO, SUKOLS, SUNUMV, IRET)
      CALL TABIO ('CLOS', 0, ISURNO, BUFFER, BUFFER, IRET)
C                                       Then write to insert new
C                                       values.
      CALL SOUINI ('WRIT', BUFFER, DISKIN, OLDCNO, 1, CATBLK, LUN1,
     *   NUMIF, VELTYP, VELDEF, FREQID, ISURNO, SUKOLS, SUNUMV, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPNING SOURCE TABLE'
         GO TO 990
         END IF
C                                       Set EIF, BIF defaults
      BIF = MAX (1, MIN (BIF, NUMIF))
      IF (BIF.GT.EIF) EIF = NUMIF
      EIF = MAX (1, MIN (EIF, NUMIF))
      IF ((RIF.LT.BIF) .OR. (RIF.GT.EIF)) RIF = BIF
C                                       Update KEYWORDS if necessary
C                                       Velocity definition
      LSIGN = 1
      IF (VELDF.EQ.' ') VELDF = VELDEF
      IF (VELDF(1:4).EQ.COMPAR(1)) LSIGN = -1
      IF (VELDF(1:4).EQ.COMPAR(2)) LSIGN = 1
      IF ((OPTYPE.EQ.' ') .OR. (OPTYPE.EQ.'SPEC') .OR.
     *   (OPTYPE.EQ.'VCAL') .OR. (OPTYPE.EQ.'VANT')) THEN
         IF (VELDF.EQ.' ') VELDF = VELDEF
         VELDEF = VELDF
         KEYLOC(1) = 1
         KEYTYP(1) = 3
         IF (VELDEF.EQ.' ') VELDEF = 'OPTICAL'
         CALL CHR2H (8, VELDEF, 1, KEYVAL(KEYLOC(1)))
C                                       Velocity type
         IF (VELTP.EQ.' ') VELTP = VELTYP
         VELTYP = VELTP
         KEYLOC(2) = KEYLOC(1) + 2
         KEYTYP(2) = 3
         IF (VELTYP.EQ.' ') VELTYP = 'LSR'
         HELO = (VELTYP(1:5).EQ.'HELIO') .OR. (VELTYP(1:5).EQ.'BARYC')
         CALL CHR2H (8, VELTYP, 1, KEYVAL(KEYLOC(2)))
C                                       Write keywords
         CALL TABKEY ('WRIT', KEYWRD, 2, BUFFER, KEYLOC, KEYVAL, KEYTYP,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
      ELSE
         VELDF = ' '
         VELTP = ' '
         END IF
C                                       Get number of channels
      NFRQ = CATBLK(KINAX+JLOCF)
C                                       Get number of sources.
      NSOURC = BUFFER(5)
C                                       Check if empty
      IF (NSOURC.LE.0) GO TO 800
C                                       Check if too many
      IF (NSOURC.GT.MAXSOU) THEN
         WRITE (MSGTXT,1005) NSOURC, MAXSOU
         CALL MSGWRT (6)
         NSOURC = MAXSOU
         END IF
C                                       Loop through records
      NDONE = 0
      REFPIX = CATR(KRCRP+JLOCF)
      IIF = MAXIF * NSOURC
      CALL RFILL (IIF, 0.0, PRIMFL)
      CALL RFILL (IIF, -9129.1, VELS)
      DO 500 LOOP = 1,NSOURC
C                                       Read record
         ISURNO = LOOP
         CALL TABSOU ('READ', BUFFER, ISURNO, SUKOLS, SUNUMV, IDSOUR,
     *      SOUNAM(LOOP), QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO,
     *      DECEPO, EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL,
     *      RESTFQ, PMRA, PMDEC, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1020) IRET, 'READ'
            GO TO 990
            END IF
C                                       Check qualifier
         IF ((QUAL.NE.SQUAL) .AND. (SQUAL.NE.-1)) GO TO 500
C                                       check CALCODE
         IF (CLCODE.NE.' ') THEN
            IF (CLCODE.EQ.'*') THEN
               IF (CALCOD.EQ.' ') GO TO 500
            ELSE IF (CLCODE.EQ.'-CAL') THEN
               IF (CALCOD.NE.' ') GO TO 500
            ELSE
               IF (CALCOD.NE.CLCODE) GO TO 500
               END IF
            END IF
C                                       Search lists
         J = -1
         IF (NSOUWD.GT.0) THEN
            DO 80 J = 1,NSOUWD
               IF ((IDSOUR.EQ.SOUWAN(J)) .AND. DOSWNT) GO TO 200
               IF ((IDSOUR.EQ.SOUWAN(J)) .AND. (.NOT.DOSWNT)) GO TO 500
 80            CONTINUE
C                                       Not in list - see if OK
            IF (DOSWNT) GO TO 500
            J = -1
            END IF
C                                       Process source.
C                                       Check if fluxes wanted
 200     IF (APARM(1).EQ.0) APARM(1) = 1
         NDONE = NDONE + 1
         IF ((APARM(3).GT.0.0) .AND. (APARM(3).LE.2.0) .AND.
     *      (APARM(3).NE.1.0)) THEN
            WRITE (MSGTXT,1200) APARM(3)
            CALL MSGWRT (5)
         ELSE
            APARM(3) = 1.0
            END IF
         IF (SOUNAM(LOOP)(:7).EQ.'1934-638') IS1934 = .TRUE.
         IF (OPTYPE.EQ.'CALC') THEN
            SNAME = SOUNAM(LOOP)
            IF (J.GT.0) THEN
               DO 205 J = 1,NSOUWD
                  IF (XSOUR(J).EQ.SOUNAM(LOOP)) THEN
                     IF (SALIAS(J).NE.' ') SNAME = SALIAS(J)
                     END IF
 205              CONTINUE
               END IF
            CALL H2CHR (8, 1, CATH(KHDOB), DATE)
            CALL DATEST (DATE, ID)
            CALL DAYNUM (ID(1), ID(3), ID(2), IDNUM)
            DD = ID(1) + IDNUM/365.25
            END IF
         DO 250 IIF = BIF,EIF
C                                       Calculate flux densities for
C                                       known calibrators.
            IF (OPTYPE.EQ.'CALC') THEN
               TFREQ = REFFRQ + FOFF(IIF) + FREQO(IIF) +
     *            FINC(IIF) * (APARM(4) - REFPIX)
               FRCALC(IIF) = TFREQ
               CALL GETFLX (1, TFREQ, DD, SNAME, JCOEFF(LOOP),
     *            PRIMSP(1,LOOP), PRIMFO(IIF,LOOP), PRIMEO(IIF,LOOP),
     *            JERR)
               CALL GETFLX (0, TFREQ, DD, SNAME, LCOEFF(LOOP),
     *            PRIMSP(1,LOOP), PRIMFL(IIF,LOOP), PRIMFE(IIF,LOOP),
     *            JERR)
               PRIMFO(IIF,LOOP) = PRIMFO(IIF,LOOP) * APARM(3)
               PRIMEO(IIF,LOOP) = PRIMEO(IIF,LOOP) * APARM(3)
               PRIMFL(IIF,LOOP) = PRIMFL(IIF,LOOP) * APARM(3)
               PRIMFE(IIF,LOOP) = PRIMFE(IIF,LOOP) * APARM(3)
               FLUX(1,IIF) = PRIMFL(IIF,LOOP)
               IF (JERR.NE.0) GO TO 250
               END IF
C                                       Use user supplied values
            IF (.NOT.NOFLUX) THEN
               SPX = 1.0D0
               IF (SPECI(1).NE.0.0) THEN
                  TFREQ = LOG10 ((REFFRQ + FOFF(IIF) + FREQO(IIF))/1.D9)
                  SPX = TFREQ * (SPECI(1) + TFREQ * (SPECI(2) + TFREQ *
     *               (SPECI(3) + TFREQ * SPECI(4))))
                  SPX = 10.0D0 ** SPX
                  IF (OPTYPE.NE.'SPEC') THEN
                     TFREQ = LOG10 ((REFFRQ + FOFF(BIF) + FREQO(BIF))
     *                  /1.D9)
                     SPX1 = TFREQ * (SPECI(1) + TFREQ * (SPECI(2) +
     *                  TFREQ *  (SPECI(3) + TFREQ * SPECI(4))))
                     SPX1 = 10.0D0 ** SPX1
                     SPX = SPX / SPX1
                     END IF
                  END IF
               IF (ZEROSP(1).GE.0.0) FLUX(1,IIF) = ZEROSP(1) * SPX
               FLUX(2,IIF) = ZEROSP(2) * SPX
               FLUX(3,IIF) = ZEROSP(3) * SPX
               FLUX(4,IIF) = ZEROSP(4) * SPX
               END IF
C                                       Reset to zero
            IF ((OPTYPE.EQ.'RESE') .OR. (OPTYPE.EQ.'REJY')) THEN
               FLUX(1,IIF) = 0.0
               FLUX(2,IIF) = 0.0
               FLUX(3,IIF) = 0.0
               FLUX(4,IIF) = 0.0
               END IF
C                                       Velocity info.
            IF ((OPTYPE.EQ.'RESE') .OR. (OPTYPE.EQ.'REVL')) THEN
               LSRVEL(IIF) = 0.D0
               RESTFQ(IIF) = 0.D0
C                                       calculate it
            ELSE IF ((OPTYPE.EQ.'VCAL') .OR. (OPTYPE.EQ.'VANT')) THEN
               SYSV = 0.0
               CATR(KRARP) = REFPIX
               NUX(IIF) = REFFRQ + FOFF(IIF) + FREQO(IIF)
               CALL POPSRD ('R2D', RESTF, DREST)
               IF (DREST.GT.1.0E-10) RESTFQ(IIF) = DREST
               IF (OPTYPE.EQ.'VANT') THEN
                  REFANT = APARM(5) + 0.1
                  REFANT = MAX (1, REFANT)
               ELSE
                  REFANT = 0
                  END IF
               CALL GETV (DISKIN, OLDCNO, IDSOUR, IIF, LSIGN, HELO,
     *            REFANT, NUX(IIF), RESTFQ(IIF), LSRVEL(IIF), IRET)
               IF (IRET.GT.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'GETTING VELOCITY'
                  GO TO 990
                  END IF
               VELS(IIF,LOOP) = LSRVEL(IIF)
C
            ELSE IF ((OPTYPE.EQ.' ') .OR. (OPTYPE.EQ.'SPEC')) THEN
               CATR(KRARP) = REFPIX
               LSRVEL(IIF) = SYSV * 1.0D3
               CALL POPSRD ('R2D', RESTF, DREST)
               IF (DREST.GT.1.0E-10) RESTFQ(IIF) = DREST
C
               ALTRFP(IIF) = APARM(1)
C                                       Calculate signed freq. inc
               IF (ISBAND(IIF).EQ.0) ISBAND(IIF) = 1
C
               FRQREF = (APARM(1)-REFPIX) * FINC(RIF) +
     *            REFFRQ + FOFF(RIF) + FREQO(RIF)
               NUX(IIF) = REFFRQ + FOFF(IIF) + FREQO(IIF)
C                                       optical - non linear
               IF (LSIGN.GT.0) THEN
C                 LSRVEL(IIF) = LSRVEL(IIF) + VELITE * RESTFQ(IIF) *
C    *               (1.0D0/FRQREF - 1.0D0/NUX(IIF))
                  FRQDIF = RESTFQ(IIF) * (1.0D0/NUX(IIF) - 1.0D0/FRQREF)
                  LSRVEL(IIF) = LSRVEL(IIF) + VELITE * FRQDIF
C                                       radio is linear
               ELSE
C                 LSRVEL(IIF) = VELITE / RESTFQ(IIF) * (NUX(IIF)-FRQREF)
C    *               + LSRVEL(IIF)
                  FRQDIF = NUX(IIF) - FRQREF
                  LSRVEL(IIF) = - FRQDIF / RESTFQ(IIF) * VELITE +
     *               LSRVEL(IIF)
                  END IF
               END IF
 250        CONTINUE
C                                       Calcode
         IF ((OPTYPE.EQ.' ') .OR. (OPTYPE.EQ.'SPEC')) THEN
            IF (NEWCOD.NE.' ') CALCOD = NEWCOD
            IF (NEWCOD.EQ.'----') CALCOD = ' '
            END IF
C                                       rewrite record
         ISURNO = LOOP
         CALL TABSOU ('WRIT', BUFFER, ISURNO, SUKOLS, SUNUMV, IDSOUR,
     *      SOUNAM(LOOP), QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO,
     *      DECEPO, EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL,
     *      RESTFQ, PMRA, PMDEC, IRET)
C                                       Check error
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1020) IRET, 'WRIT'
            GO TO 990
            END IF
 500     CONTINUE
C                                       Done
      IF (NDONE.EQ.0) THEN
         IRET = 1
         MSGTXT = 'NO SOURCES MET SELECTION CRITERA - CHECK INPUTS'
         GO TO 990
         END IF
      CALL CATIO ('UPDT', DISKIN, OLDCNO, CATBLK, 'REST', BUFFX, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1040) IRET
         GO TO 990
         END IF
      GO TO 900
C                                       No SOURCE records
 800  IRET = 10
      MSGTXT = 'ERROR: SOURCE (SU) TABLE IS EMPTY'
      CALL MSGWRT (8)
C                                       Close file
 900  CALL TABIO ('CLOS', 0, ISURNO, BUFFER, BUFFER, JERR)
      IF (JERR.EQ.0) GO TO 999
      IRET = JERR
      WRITE (MSGTXT,1900) IRET
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR ',I3,' ON ',A)
 1005 FORMAT ('NUMBER SOURCES',I5,' EXCEEDS MAX',I5,
     *   ' DOING FIRST ONES ONLY')
 1010 FORMAT ('ERROR ',I3,' FILLING FREQ TABLE.')
 1020 FORMAT ('TABSOU ERROR ',I3,1X,A4,'ING SOURCE (SU) TABLE')
 1040 FORMAT ('SETJ: ERROR ',I3,' UPDATING CATALOGUE HEADER')
 1200 FORMAT ('All fluxes are scaled by a factor of',F7.4)
 1900 FORMAT ('TABIO ERROR',I3,' CLOSING SU TABLE - NOT UPDATED?')
 2000 FORMAT ('FREQID ',I3,' FORBIDDEN, USE A USEFUL VALUE - SEE HELP')
      END
      SUBROUTINE FMTSOU (DISK, CNO, CATBLK, LUN1, LUN2, BUFF1, BUFF2,
     *   IRET)
C-----------------------------------------------------------------------
C   Reformats SU table if necessary to include Line rest frequency
C   and other made March 1987. Works by copying to version 2 and then
C   back to version 1.
C   Input:
C      DISK        I    Disk number
C      CNO         I    Catalog number
C      CATBLK(256) I    Catalog header
C      LUN1,2      I    LUNs to use
C   Output:
C      BUFF1,BUFF2 I    I/O buffers
C      IRET        I    Return code, 0=OK, else failed.
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, CATBLK(256), LUN1, LUN2, BUFF1(768),
     *   BUFF2(768), IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER VT*8, VD*8, SOUNAM*16, CALCO*4
      INTEGER   SUKOLS(MAXSUC,2), SUNUMV(MAXSUC,2), NUMIF, IVER, OVER,
     *   IQUAL, IDSOUR, JERR, ISURNO, LOOP, NSOURC, SUFQID
      DOUBLE PRECISION   BANDW, RAEPO, DECEPO, EPOCH, RAAPP, DECAPP,
     *   PMRA, PMDEC, RAOBS, DECOBS
      REAL     FLUX(4,MAXIF)
      DOUBLE PRECISION   SYSVEL(MAXIF), FREQO(MAXIF), LRESTF(MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IVER = 1
      OVER = 2
C                                       Open SU table
      CALL SOUINI ('READ', BUFF1, DISK, CNO, IVER, CATBLK, LUN1,
     *   NUMIF, VT, VD, SUFQID, ISURNO, SUKOLS(1,1), SUNUMV(1,1), IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ'
         GO TO 990
         END IF
C                                       See if table to be reformatted
C                                       IF SUNUMV(17) .ne. NUMIF, or
C                                       SUFQID = -999.
      IF (SUFQID.EQ.-999) GO TO 10
      IF (SUNUMV(17,1).EQ.NUMIF) THEN
C                                       Close up and return.
         CALL TABIO ('CLOS', 0, ISURNO, BUFF1, BUFF1, JERR)
         IF (JERR.EQ.0) GO TO 999
         IRET = JERR
         WRITE (MSGTXT,1900) IRET
         GO TO 990
         END IF
C                                       Get number of sources.
 10   NSOURC = BUFF1(5)
C                                       Check if empty
      IF (NSOURC.LE.0) GO TO 600
C                                       Open output table.
      SUFQID = -1
      CALL SOUINI ('WRIT', BUFF2, DISK, CNO, OVER, CATBLK, LUN2,
     *   NUMIF, VT, VD, SUFQID, ISURNO, SUKOLS(1,2), SUNUMV(1,2), IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRIT'
         GO TO 990
         END IF
C                                       Copy file
      DO 500 LOOP = 1,NSOURC
C                                       Read record
         ISURNO = LOOP
         CALL TABSOU ('READ', BUFF1, ISURNO, SUKOLS(1,1), SUNUMV(1,1),
     *      IDSOUR, SOUNAM, IQUAL, CALCO, FLUX, FREQO, BANDW, RAEPO,
     *      DECEPO, EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, SYSVEL, LRESTF,
     *      PMRA, PMDEC, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1020) IRET, 'READ'
            GO TO 990
            END IF
C                                       rewrite record
         ISURNO = LOOP
         CALL TABSOU ('WRIT', BUFF2, ISURNO, SUKOLS(1,2), SUNUMV(1,2),
     *      IDSOUR, SOUNAM, IQUAL, CALCO, FLUX, FREQO, BANDW, RAEPO,
     *      DECEPO, EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, SYSVEL, LRESTF,
     *      PMRA, PMDEC, IRET)
C                                       Check error
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1020) IRET, 'WRIT'
            GO TO 990
            END IF
 500     CONTINUE
C                                       Finished copy - close
 600  CALL TABIO ('CLOS', 0, ISURNO, BUFF1, BUFF1, JERR)
      IF (JERR.NE.0) THEN
         IRET = JERR
         WRITE (MSGTXT,1900) IRET
         GO TO 990
         END IF
      CALL TABIO ('CLOS', 0, ISURNO, BUFF2, BUFF2, JERR)
      IF (JERR.NE.0) THEN
         IRET = JERR
         WRITE (MSGTXT,1900) IRET
         GO TO 990
         END IF
C                                       delete version 1
      CALL RMEXT (DISK, CNO, 'SU', IVER, CATBLK, BUFF1, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy 2 back to 1
      CALL TABCOP ('SU', OVER, IVER, LUN1, LUN2, DISK, DISK, CNO, CNO,
     *   CATBLK, BUFF1, BUFF2, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       delete version 2
      CALL RMEXT (DISK, CNO, 'SU', OVER, CATBLK, BUFF1, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR ',I3,' OPENING SU TABLE FOR ',A4)
 1020 FORMAT ('TABSOU ERROR ',I3,1X,A4,'ING SOURCE (SU) TABLE')
 1900 FORMAT ('TABIO ERROR',I3,' CLOSING SU TABLE - NOT UPDATED?')
      END
      SUBROUTINE STJHIS
C-----------------------------------------------------------------------
C   Add reference in output history
C   Input from common:
C      DISKIN     I    Disk number
C      OLDCNO     I    Catalog slot number
C      BIF        I    Low IF number
C      EIF        I    High IF number
C      ZEROSP(5)  R    Flux density array.
C      NEWCOD     C*4  Calcode
C      SYSV       R    Velocity
C      APARM(1)   R    Pixel to which SYSV refers
C      NSOUWD     I    Number of  sources specified
C      DOSWNT     L    If true listed sources wanted
C      XSOUR(*)   C*16 Source list
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, CTIME(2)*12, HISTR(12)*32
      INTEGER   BUFFER(1024), LUN1, IRET, TIME(3), DATE(3), I, IS, IIF,
     *   JTRIM, J
      REAL      TEMP, DMAX
      LOGICAL   NOFLUX, T, WASOLD
      DOUBLE PRECISION DT
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'SETJY.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DHIS.INC'
      DATA LUN1 /27/
      DATA T /.TRUE./
      DATA HISTR /'Scaife-Heald low freq',
     *   'Perley-butler wide-band (2017)',
     *   'Perley-Butler time dependent',
     *   'Perley-Butler (2013)',
     *   'Perley-Butler (2010)',
     *   'Taylor-Perley (1999.2)',
     *   'Perley (1995.2)',
     *   'Perley (1990)',
     *   'Baars',
     *   ' ', ' ',
     *   'Perley-Butler time independent'/
C-----------------------------------------------------------------------
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN1, DISKIN, OLDCNO, BUFFER, IRET)
      IF (IRET.GT.2) THEN
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,1010) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN1, HILINE, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 250
C                                       OPTYPE
      IF (OPTYPE.NE.' ') THEN
         IF (OPTYPE.EQ.'CALC') THEN
            MSGTXT = '/ Flux calculated using known spectrum'
         ELSE IF (OPTYPE.EQ.'VCAL') THEN
            MSGTXT = '/ Calculating velocity of reference pixel'
         ELSE IF (OPTYPE.EQ.'VANT') THEN
            MSGTXT = '/ Calculating velocity of reference pixel'
         ELSE IF (OPTYPE.EQ.'RESE') THEN
            MSGTXT = '/ Resetting flux and source information to zero'
         ELSE IF (OPTYPE.EQ.'REJY') THEN
            MSGTXT = '/ Resetting flux information to zero'
         ELSE IF (OPTYPE.EQ.'REVL') THEN
            MSGTXT = '/ Resetting velocity information to zero'
         ELSE IF (OPTYPE.EQ.'SPEC') THEN
            MSGTXT = '/ Flux calculated with 1 GHz as reference'
            END IF
         HILINE = TSKNAM // MSGTXT
         CALL MSGWRT (2)
         CALL HIADD (LUN1, HILINE, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 250
         END IF
C                                       BIF, EIF
      WRITE (HILINE,1020) TSKNAM, BIF, EIF
      MSGTXT = HILINE(7:)
      CALL MSGWRT (2)
      CALL HIADD (LUN1, HILINE, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 250
C                                       CALCODE
      IF (CLCODE.NE.' ') THEN
         WRITE (HILINE,1023) TSKNAM, CLCODE
         MSGTXT = HILINE(7:)
         CALL MSGWRT (2)
         CALL HIADD (LUN1, HILINE, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 250
         END IF
C                                       QUAL
      IF (SQUAL.GE.0) THEN
         WRITE (HILINE,1022) TSKNAM, SQUAL
         MSGTXT = HILINE(7:)
         CALL MSGWRT (2)
         CALL HIADD (LUN1, HILINE, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 250
         END IF
C                                       ZEROSP
C                                       See if fluxes to be changed
      NOFLUX = (ABS(ZEROSP(1)).LE.1.0E-20) .AND.
     *   (ABS(ZEROSP(2)).LE.1.0E-20) .AND. (ABS(ZEROSP(3)).LE.1.0E-20)
     *   .AND. (ABS(ZEROSP(4)).LE.1.0E-20)
C                                       CALC fluxes
      IF (OPTYPE.EQ.'CALC') THEN
         IF (APARM(3).NE.1.0) THEN
            WRITE (MSGTXT,1035) APARM(3)
            HILINE = TSKNAM // MSGTXT
            CALL HIADD (LUN1, HILINE, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 250
            END IF
         WRITE (MSGTXT,1036) APARM(4)
         HILINE = TSKNAM // MSGTXT
         CALL HIADD (LUN1, HILINE, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 250
         IF (IS1934) THEN
            MSGTXT = 'Also using Reynolds (1994) for 1934-638'
            CALL MSGWRT (2)
            HILINE = TSKNAM // '/ ' // MSGTXT
            CALL HIADD (LUN1, HILINE, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 250
            END IF
         DO 15 IIF = BIF,EIF
            IF (FRCALC(IIF).GT.0.0D0) THEN
               WRITE (MSGTXT,1031) IIF, FRCALC(IIF)/1.0D9
               HILINE = TSKNAM // MSGTXT
               CALL MSGWRT (2)
               CALL HIADD (LUN1, HILINE, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 250
               END IF
 15         CONTINUE
         DO 30 IS = 1,NSOURC
            IF ((PRIMFL(BIF,IS).GT.0.) .OR. (PRIMSP(1,IS).NE.0.0)) THEN
               J = JTRIM (HISTR(LCOEFF(IS)+2))
               MSGTXT = 'Using ' // HISTR(LCOEFF(IS)+2)(:J) //
     *            ' coefficients'
               CALL MSGWRT (2)
               HILINE = TSKNAM // '/ ' // MSGTXT
               CALL HIADD (LUN1, HILINE, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 250
               END IF
            DMAX = 0.0
            WASOLD = .FALSE.
            DO 20 IIF = BIF,EIF
C                                       If flux was calculated
               IF (PRIMFL(IIF,IS).GT.0) THEN
                  TEMP = (PRIMFL(IIF,IS) - PRIMFO(IIF,IS)) /
     *               PRIMFL(IIF,IS)
                  IF (PRIMFO(IIF,IS).GT.0.0) WASOLD = .TRUE.
                  DMAX = MAX (DMAX, ABS(TEMP))
C                                       If error was known
                  IF (PRIMFE(IIF,IS).GT.0) THEN
                     WRITE (MSGTXT,1030) SOUNAM(IS), IIF,
     *                  PRIMFL(IIF,IS), PRIMFE(IIF,IS)
C                                       Else no error estimate
                  ELSE
                     WRITE (MSGTXT,1025) SOUNAM(IS), IIF,
     *                  PRIMFL(IIF,IS)
                     END IF
                  HILINE = TSKNAM // MSGTXT
                  CALL MSGWRT (2)
                  CALL HIADD (LUN1, HILINE, BUFFER, IRET)
                  IF (IRET.NE.0) GO TO 250
                  END IF
 20            CONTINUE
            IF (PRIMSP(1,IS).NE.0.0) THEN
               WRITE (HILINE,1055) TSKNAM, PRIMSP(1,IS)
               MSGTXT = HILINE(7:)
               CALL MSGWRT (2)
               CALL HIADD (LUN1, HILINE, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 250
               WRITE (HILINE,1056) TSKNAM, PRIMSP(2,IS),
     *            PRIMSP(3,IS), PRIMSP(4,IS), PRIMSP(5,IS)
               MSGTXT = HILINE(7:)
               CALL MSGWRT (2)
               CALL HIADD (LUN1, HILINE, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 250
               END IF
            DMAX = DMAX * 100.0
            IF ((DMAX.GT.0.1) .AND. (WASOLD)) THEN
               MSGTXT = 'Previous coefficients ' //
     *            HISTR(JCOEFF(IS)+2)
               CALL MSGWRT (2)
               HILINE = TSKNAM // '/ ' // MSGTXT
               CALL HIADD (LUN1, HILINE, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 250
               WRITE (HILINE,1057) TSKNAM, DMAX
               MSGTXT = HILINE(9:)
               CALL MSGWRT (2)
               CALL HIADD (LUN1, HILINE, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 250
               IF (DMAX.GT.3.0) THEN
                  DO 25 IIF = BIF,EIF
C                                       If flux was calculated
                     IF (PRIMFL(IIF,IS).GT.0.0) THEN
C                                       If error was known
                        IF (PRIMEO(IIF,IS).GT.0) THEN
                           WRITE (MSGTXT,1030) SOUNAM(IS), IIF,
     *                        PRIMFO(IIF,IS), PRIMEO(IIF,IS)
C                                       Else no error estimate
                        ELSE
                           WRITE (MSGTXT,1025) SOUNAM(IS), IIF,
     *                        PRIMFO(IIF,IS)
                           END IF
                        HILINE = TSKNAM // MSGTXT
                        CALL MSGWRT (2)
                        CALL HIADD (LUN1, HILINE, BUFFER, IRET)
                        IF (IRET.NE.0) GO TO 250
                        END IF
 25                  CONTINUE
                  END IF
               END IF
 30         CONTINUE
         IF (APARM(3).NE.1.0) THEN
            WRITE (MSGTXT,1035) APARM(3)
            CALL MSGWRT (2)
            HILINE = TSKNAM // MSGTXT
            CALL HIADD (LUN1, HILINE, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 250
            END IF
C                                       VCAL
      ELSE IF ((OPTYPE.EQ.'VCAL') .OR. (OPTYPE.EQ.'VANT')) THEN
         DO 40 IS = 1,NSOURC
            DO 35 IIF = BIF,EIF
C                                       If flux was calculated
               IF (ABS(VELS(IIF,IS)+9129.1).GT.0.1) THEN
                  WRITE (MSGTXT,1040) SOUNAM(IS), IIF,
     *               VELS(IIF,IS)/1000.0
                  HILINE = TSKNAM // MSGTXT
                  CALL MSGWRT (2)
                  CALL HIADD (LUN1, HILINE, BUFFER, IRET)
                  IF (IRET.NE.0) GO TO 250
                  END IF
 35            CONTINUE
 40         CONTINUE
         IF (OPTYPE.EQ.'VANT') THEN
            I = APARM(5) + 0.1
            I = MAX (I, 1)
            WRITE (MSGTXT,1041) I
         ELSE
            MSGTXT = '/ Velocities refer to the center of the Earth'
            END IF
         HILINE = TSKNAM // MSGTXT
         CALL MSGWRT (2)
         CALL HIADD (LUN1, HILINE, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 250
C                                       Other modes sources/fluxes
      ELSE
C                                       All selected
         IF (NSOUWD.LE.0) THEN
            MSGTXT = 'SOURCES = ''''     /All sources selected'
            HILINE = TSKNAM // MSGTXT
            CALL MSGWRT (2)
            CALL HIADD (LUN1, HILINE, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 250
C                                       list them
         ELSE
            DO 50 I = 1,NSOUWD,2
               IF (I.EQ.1) THEN
                  MSGTXT = 'SOURCES = ''' // XSOUR(I) // ''''
               ELSE
                  MSGTXT = ' '
                  MSGTXT(11:) = '''' // XSOUR(I) // ''''
                  END IF
               IF (NSOUWD.GT.I) THEN
                  MSGTXT(30:) = ', ''' // XSOUR(I+1) // ''''
                  IF (NSOUWD.GT.I+1) MSGTXT(51:) = ','
                  END IF
               IS = JTRIM (MSGTXT) + 3
               IF (DOSWNT) THEN
                  MSGTXT (IS:) = '/ Included'
               ELSE
                  MSGTXT (IS:) = '/ Excluded'
                  END IF
               HILINE = TSKNAM // MSGTXT
               CALL MSGWRT (2)
               CALL HIADD (LUN1, HILINE, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 250
 50            CONTINUE
            END IF
         IF (.NOT.NOFLUX) THEN
            WRITE (HILINE,1050) TSKNAM, ZEROSP(1), ZEROSP(2), ZEROSP(3),
     *         ZEROSP(4)
            MSGTXT = HILINE(7:)
            CALL MSGWRT (2)
            CALL HIADD (LUN1, HILINE, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 250
            END IF
         END IF
C                                       spectral index parameters
      IF (SPECI(1).NE.0.0) THEN
         WRITE (HILINE,1055) TSKNAM, SPECI(1)
         MSGTXT = HILINE(7:)
         CALL MSGWRT (2)
         CALL HIADD (LUN1, HILINE, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 250
         WRITE (HILINE,1056) TSKNAM, SPECI(2), SPECI(3), SPECI(4)
         MSGTXT = HILINE(7:)
         CALL MSGWRT (2)
         CALL HIADD (LUN1, HILINE, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 250
         END IF
C                                       new calcode
      IF ((OPTYPE.EQ.' ') .OR. (OPTYPE.EQ.'SPEC')) THEN
         IF (NEWCOD.NE.' ') THEN
            IF (NEWCOD.EQ.'----') THEN
               WRITE (HILINE,1021) TSKNAM, '    '
            ELSE
               WRITE (HILINE,1021) TSKNAM, NEWCOD
               END IF
            MSGTXT = HILINE(7:)
            CALL MSGWRT (2)
            CALL HIADD (LUN1, HILINE, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 250
            END IF
         END IF
C                                       SYSVEL & Ref. pixel
      IF ((OPTYPE.EQ.' ') .OR. (OPTYPE.EQ.'SPEC') .OR.
     *   (OPTYPE.EQ.'VCAL') .OR. (OPTYPE.EQ.'VANT')) THEN
         IF ((OPTYPE.EQ.' ') .OR. (OPTYPE.EQ.'SPEC')) THEN
            WRITE (HILINE,1060) TSKNAM, SYSV
            MSGTXT = HILINE(7:)
            CALL MSGWRT (2)
            CALL HIADD (LUN1, HILINE, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 250
            WRITE (HILINE,1061) TSKNAM, APARM(1)
            MSGTXT = HILINE(7:)
            CALL MSGWRT (2)
            CALL HIADD (LUN1, HILINE, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 250
            WRITE (HILINE,1062) TSKNAM, RIF
            MSGTXT = HILINE(7:)
            CALL MSGWRT (2)
            CALL HIADD (LUN1, HILINE, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 250
            END IF
C                                       Rest frequency
         CALL POPSRD ('R2D', RESTF, DT)
         IF (ABS(DT).GT.1.0E-20) THEN
            WRITE (HILINE,1065) TSKNAM, DT
            MSGTXT = HILINE(7:)
            CALL MSGWRT (2)
            CALL HIADD (LUN1, HILINE, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 250
            END IF
C                                       Velocity type
         IF (VELTP.NE.' ') THEN
            WRITE (HILINE,1070) TSKNAM, VELTP
            MSGTXT = HILINE(7:)
            CALL MSGWRT (2)
            CALL HIADD (LUN1, HILINE, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 250
            END IF
C                                       Velocity definition
         IF (VELDF.NE.' ') THEN
            WRITE (HILINE,1071) TSKNAM, VELDF
            MSGTXT = HILINE(7:)
            CALL MSGWRT (2)
            CALL HIADD (LUN1, HILINE, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 250
            END IF
         END IF
C                                       Close HI file
 250  CALL HICLOS (LUN1, T, BUFFER, IRET)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' OPENING HISTORY FILE')
 1010 FORMAT (A6,'release =''',A7,' ''  /********* Start ',A12,2X,A8)
 1020 FORMAT (A6,'BIF =',I3,' EIF =',I3,' / Range of IFs')
 1021 FORMAT (A6,'CODETYPE = ''',A4,'''   / NEW Calibrator code')
 1022 FORMAT (A6,'QUAL = ',I4,'   / Qualifier code in')
 1023 FORMAT (A6,'CALCODE = ''',A4,'''   / Calibrator code in')
 1025 FORMAT ('''',A,''' IF=',I3,' flux=',F10.4,' (Jy calcd)')
 1030 FORMAT ('''',A,''' IF=',I3,' flux=',F10.4,' +/- ',F7.4,
     *   ' (Jy calcd)')
 1031 FORMAT ('FREQ(',I2,') =',F11.6,' GHz')
 1035 FORMAT ('APARM(3)=',F7.4,' /Factor that scales all fluxes')
 1036 FORMAT ('APARM(4)=',F9.2,' / channel for frequencies')
 1040 FORMAT ('''',A,''' IF =',I3,' velocity =',F11.2,
     *   ' (km/sec calcd)')
 1041 FORMAT ('APARM(5) =',I3,5X,'/ Velocity reference antenna')
 1050 FORMAT (A6,'ZEROSP =',4F10.3,' /I,Q,U,V fluxes')
 1055 FORMAT (A6,'SPECINDX=',F8.4,5X,' / spectral index')
 1056 FORMAT (A6,'SPECURVE=',4F8.4,' /spectral curvature')
 1057 FORMAT (A6,'/ FLUXES HAVE CHANGED since last version by <=',F6.1,
     *   ' percent')
 1060 FORMAT (A6,'SYSVEL =',F10.3,' / Velocity (km/s)')
 1061 FORMAT (A6,'APARM(1) =',F7.1,' / Sysvel ref pixel')
 1062 FORMAT (A6,'NIF =',I5,' / Sysvel ref IF')
 1065 FORMAT (A6,'RESTFREQ =',1PD15.8,'   /Rest frequency (Hz)')
 1070 FORMAT (A6,'VELTYP = ''',A8,''' /velocity type')
 1071 FORMAT (A6,'VELDEF = ''',A8,''' /velocity definition')
      END
      SUBROUTINE GETFLX (IT, TFREQ, DD, SOURCE, ICTYPE, SPECI, FLUX,
     *   FERR, IERR)
C-----------------------------------------------------------------------
C   Routine that uses the Baars et al formulae to calculate the
C   fluxes for 3C295, 3C286, 3C48 and 3C147.    1934-638 from R Duncan
C   Inputs:
C      IT       I     Is this current (0) or previous (1)
C      TFREQ    D     Frequency (Hz)
C      DD       R     Year (incl fraction)
C      SOURCE   C*8   Source for which to calculate flux
C      ICTYPE   I     = -1  Use Scaife and Heald low freq coeff
C                        0  Use Perley 2017 wideband
C                        1: Use Perley 2013 coeff.
C                        2: Use Perley 2013/2010 coeff.
C                        3  Use Perley 2010 coeff
C                        4: Use Taylor 1999.2 coeff.
C                        5: Use Perley 1995.2 coeff.
C                        6: Use Perley 1990 coeff.
C                     >= 7: Use Baars coeff.
C                     1 becomes 2 on IT=1 for some sources
C                     >= 0 -> 10 for time independent sources
C   Outputs:
C      SPECI    R(4)  spectral index parameters
C      FLUX     R     Calculated fluxes.
C      FERR     R     Flux error, 0=> Not known
C      IERR     I     Error code, 0=OK, 1=>unknown source.
C
C Flux density, S, at frequency, nu, is calculated assuming
C
C   Log  (S) = F  and Log  (nu) = x, and
C      10                10
C
C   F  = [ a + b * x + c * x**2 + d * x**3]
C
C where  a, b, c and d are observed parameters.
C The error in F as a function of errors in a,b,c and d are
C
C    2      dF 2  2     dF 2  2     dF 2  2     dF 2  2
C   E   =  (--)  E   + (--)  E  +  (--)  E  +  (--)  E
C    F      da    a     db    b     dc    c     dd    d
C
C where the dF/da are partial derivatives.  So
C
C    2       2     2  2     4  2     6  2
C   E   =   E   + x  E  +  x  E  +  x  E
C    F       a        b        c        d
C
C The error in S is
C                                    F
C           dS             dS      10                F dF
C   E   =  (--)  E   and  (--) = d --  =  Log (10) 10  -- = S Log (10)
C    S      dF    F        dF      dF        e         dF        e
C so,
C   E   = S Log (10) * E
C    S         e        F
C-----------------------------------------------------------------------
      DOUBLE PRECISION TFREQ
      CHARACTER SOURCE*16
      REAL      DD, SPECI(5), FLUX, FERR
      INTEGER   IT, ICTYPE, IERR
C                                       XNSOU = number of recognized
C                                       source names. XSOUR actual numb.
C                                       of sources
      INTEGER   XNSOU, XSOUR, NDATES, XSOU17
      PARAMETER (XNSOU = 24, XSOUR=6, NDATES=17, XSOU17=11)
      INTEGER   SNSOU, SSOUR
      PARAMETER (SNSOU=8, SSOUR = 2)
C
      INTEGER   ISRC, KSOUNO(XNSOU), LENCHK(XNSOU), LOOP, IBAND, LCTYPE,
     *   I, LSRC, SENCHK(SNSOU), J, K, JTRIM
      REAL      COEFF(4,XSOUR), NCOEFF(4,XSOUR), PCOEFF(4,XSOUR),
     *   RCOEFF(4,XSOUR), COERR(4,XSOUR), FBAND(7), TCOEFF(4,XSOUR),
     *   TCOEF3(4,XSOUR), W1, W2, DATES(NDATES), DCOEFF(4,NDATES,3),
     *   LCOEFF(5,XSOUR), LCOERR(5,XSOUR), SCOEF3(4,SSOUR),
     *   FRMIN(XSOU17), FRMAX(XSOU17), TCOEF7(6,XSOUR+SSOUR+XSOU17)
      CHARACTER KNOSOU(XNSOU)*16, LNOSOU(XNSOU)*16, SNOSOU(SNSOU)*16,
     *   KNOS17(4,XSOU17)*16
      DOUBLE PRECISION FREQ, TEMP1, TEMP2, DT, FERROR
      LOGICAL   DONMSG(20)
      INCLUDE 'INCS:DMSG.INC'
      SAVE DONMSG
C                                       Source lists, Baars et al.
C                                       3C286
      DATA COEFF /1.480, 0.292, -0.124, 0.000,
C                                       3C48
     *            2.345, 0.071, -0.138, 0.000,
C                                       3C147
     *            1.766, 0.447, -0.184, 0.000,
C                                       3C138
     *            2.009, -0.07176, -0.0862, 0.000,
C                                       1934-638
     *            -23.839, 19.569, -4.8168, 0.35836,
C                                       3C295
     *            1.485, 0.759, -0.255, 0.000/
C
C                                       3C286, Baars et al errors
      DATA COERR /0.018, 0.006, 0.001, 0.000,
C                                       3C48
     *            0.030, 0.001, 0.001, 0.000,
C                                       3C147
     *            0.017, 0.006, 0.001, 0.000,
C                                       3C138
     *            0.000, 0.000, 0.000, 0.000,
C                                       1934-638
     *            0.000, 0.000, 0.000, 0.000,
C                                       3C295
     *            0.013, 0.009, 0.001, 0.000/
C
C                                       Source lists, Taylor 1999.2
C                                       Note that the VLA coefficients
C                                       are for freq. in GHz, not MHz,
C                                       not true of 1934-638.  This
C                                       requires some modifications in
C                                       the calculation loop for RCOEFF.
C                                       3C286
      DATA RCOEFF /1.23734, -0.43276, -0.14223,  0.00345,
C                                       3C48
     *             1.31752, -0.74090, -0.16708,  0.01525,
C                                       3C147
     *             1.44856, -0.67252, -0.21124,  0.04077,
C                                       3C138
     *             1.00761, -0.55629, -0.11134, -0.01460,
C                                       1934-638 (Reynolds, 02/Jul/94)
     *            -30.7667,  26.4908,  -7.0977, 0.605334,
C                                       3C295
     *             1.46744, -0.77350, -0.25912,  0.00752/
C
C                                       Perley 2010 coefficients
C                                       same units as RCOEFF
C                                       3C286
      DATA TCOEFF /1.2361,  -0.4127,  -0.1864,   0.0294,
C                                       3C48
     *             1.3197,  -0.7253,  -0.2023,   0.0540,
C                                       3C147
     *             1.4428,  -0.6300,  -0.3142,   0.1032,
C                                       3C138
     *             1.0053,  -0.4384,  -0.1855,   0.0511,
C                                       1934-638 (Reynolds, 02/Jul/94)
     *           -30.7667,  26.4908,  -7.0977,   0.605334,
C                                       3C295
     *             1.4605,  -0.7043,  -0.3951,   0.0815 /
C                                       3C196
C    *             1.2753,  -0.7971,  -0.2255,   0.0380/
C
C                                       Perley 2017 coefficients
C                                       3C286
      DATA TCOEF7 /1.2481, -0.4507, -0.1798, 0.0357, 0.0, 0.0,
C                                       3C48
     *             1.3253, -0.7553, -0.1914, 0.0498, 0.0, 0.0,
C                                       3C147
     *             1.4516, -0.6961, -0.2007, 0.0640, -0.0464, 0.0289,
C                                       3C138
     *             1.0088, -0.4981, -0.1552, -0.0102, 0.0223, 0.0,
C                                       1934-638 (Reynolds, 02/Jul/94)
     *           -30.7667, 26.4908, -7.0977,  0.605334, 0.0, 0.0,
C                                       3C295
     *             1.4701, -0.7658, -0.2780, -0.0347, 0.0399, 0.0,
C                                       3C123
     *             1.8017, -0.7884, -0.1035, -0.0248, 0.0090, 0.0,
C                                       3C196
     *             1.2872, -0.8530, -0.1534, -0.0200, 0.0201, 0.0,
C                                       J044-2809
     *             0.9710, -0.8938, -0.1176,  0.0,    0.0,    0.0,
C                                       PictorA
     *             1.9380, -0.7470, -0.0739,  0.0,    0.0,    0.0,
C                                       3C144
     *             2.9516, -0.2173, -0.0473, -0.0674, 0.0,    0.0,
C                                       3C218
     *             1.7795, -0.9176, -0.0843, -0.0139, 0.0295, 0.0,
C                                       3C274
     *             2.4466, -0.8116, -0.0483,  0.0,    0.0,    0.0,
C                                       3C348
     *             1.8298, -1.0247, -0.0951,  0.0,    0.0,    0.0,
C                                       3C353
     *             1.8627, -0.6938, -0.0998, -0.0732, 0.0,    0.0,
C                                       3C380
     *             1.2320, -0.7909,  0.0947,  0.0976,-0.1794, -0.1566,
C                                       3C405
     *             3.3498, -1.0022, -0.2246,  0.0227, 0.0425, 0.0,
C                                       3C444
     *             1.1064, -1.0052, -0.0750, -0.0767, 0.0,    0.0,
C                                       3C461
     *             3.3584, -0.7518, -0.0347, -0.0705, 0.0,    0.0/
C
C                                       Perley 2013 coefficients
C                                       same units as RCOEFF
C                                       3C286
      DATA TCOEF3 /1.2515,  -0.4605,  -0.1715,   0.0336,
C                                       3C48 (2010)
     *             1.3197,  -0.7253,  -0.2023,   0.0540,
C                                       3C147 (2010)
     *             1.4428,  -0.6300,  -0.3142,   0.1032,
C                                       3C138 (2010)
     *             1.0053,  -0.4384,  -0.1855,   0.0511,
C                                       1934-638 (Reynolds, 02/Jul/94)
     *           -30.7667,  26.4908,  -7.0977,   0.605334,
C                                       3C295
     *             1.4866,  -0.7871,  -0.3440,   0.0749 /
C                                       3C196
C    *             1.2969,  -0.8690,  -0.1788,   0.0305/
C
C                                       steady sources Perley 2013
C                                       3C123
      DATA SCOEF3 / 1.8077, -0.8018, -0.1157, 0.0,
C                                       3C196
     *              1.2969, -0.8690, -0.1788, 0.0305/
C                                       3C295
C    *              1.4866, -0.7871, -0.3440, 0.0749/
C                                       Source lists, Perley 1990
C                                       3C286, Perley 1990
      DATA NCOEFF /1.35899, 0.35990, -0.13338, 0.000,
C                                       3C48
     *            2.0868, 0.20889, -0.15498, 0.000,
C                                       3C147
     *            1.92641, 0.36072, -0.17389, 0.000,
C                                       3C138      (Baars again)
     *            2.009, -0.07176, -0.0862, 0.000,
C                                       1934-638 (Reynolds, 02/Jul/94)
     *            -30.7667, 26.4908, -7.0977, 0.605334,
C                                       3C295      (Baars again)
     *            1.485, 0.759, -0.255, 0.000/
C
C                                       Source lists, Perley 1995.2
C                                       3C286
      DATA PCOEFF /0.50344,  1.05026, -0.31666,  0.01602,
C                                       3C48
     *             1.16801,  1.07526, -0.42254,  0.02699,
C                                       3C147
     *             0.05702,  2.09340, -0.70760,  0.05477,
C                                       3C138
     *             1.97498, -0.23918,  0.01333, -0.01389,
C                                       1934-638 (Reynolds, 02/Jul/94)
     *            -30.7667,  26.4908,  -7.0977, 0.605334,
C                                       3C295
     *             1.28872,  0.94172, -0.31113,  0.00569/
C                                       Source lists: low freq
C                                       3C286
      DATA LCOEFF /27.477, -0.158,  0.032, -0.180,  0.000,
C                                       3C48
     *             64.768, -0.387, -0.420,  0.181,  0.000,
C                                       3C147
     *             66.738, -0.022, -1.012,  0.549,  0.000,
C                                       3C196
     *             83.084, -0.699,  0.110,  0.000,  0.000,
C                                       3c380
     *             77.352, -0.767,  0.000,  0.000,  0.000,
C                                       3C295
     *             97.763, -0.582, -0.298,  0.583, -0.363/
C                                       Error bars: low freq
C                                       3C286
      DATA LCOERR /0.746, 0.033, 0.043, 0.052, 0.000,
C                                       3C48
     *             1.761, 0.039, 0.031, 0.060, 0.000,
C                                       3C147
     *             2.490, 0.030, 0.167, 0.170, 0.000,
C                                       3C196
     *             1.862, 0.014, 0.024, 0.000, 0.000,
C                                       3C380
     *             1.164, 0.013, 0.000, 0.000, 0.000,
C                                       3C295
     *             2.787, 0.045, 0.085, 0.116, 0.137/
C                                       Source lists
      DATA KNOSOU /'3C286','1328+307','1331+305', 'J1331+3030',
     *   '3C48',    '0134+329', '0137+331', 'J0137+3309',
     *   '3C147',   '0538+498', '0542+498', 'J0542+4951',
     *   '3C138',   '0518+165', '0521+166', 'J0521+1638',
     *   '1934-638','1934-638', '1939-634', 'J1939-6342',
     *   '3C295',   '1409+524', '1411+522', 'J1411+5212'/
      DATA SNOSOU /'3C123', '0433+295', '0437+296', 'J0437+2940',
     *   '3C196', '0809+483', '0813+482', 'J0813+4813'/
      DATA KNOS17 /'J0444-2809','J0444-2809','J0444-2809','0444-281',
     *   'PictorA', 'Pictor A', 'J0519-4546', '0519-457',
     *   '3C144',   'Taurus A', 'J0543+2200', '0543_220',
     *   '3C218',   'Hydra A',  'J0918-1205', '0918-120',
     *   '3C274',   'Virgo A',  'J1230+1223', '1230+123',
     *   '3C348', 'Hercules A', 'J1651+0459', '1651+049',
     *   '3C353',   '3C353',    'J1720-0058', '1720-OO9',
     *   '3C380',   '1828+487', 'J1829+4844', '1829+487',
     *   '3C405',   'Cygnus A', 'J1959+4044', '1959+407',
     *   '3C444',   '3C444',    'J2214-1701', '2214-170',
     *   '3C461',   'Cass A',   'J2323+5848', '2323+588'/
      DATA LNOSOU /'3C286','1328+307','1331+305', 'J1331+3030',
     *   '3C48',    '0134+329', '0137+331', 'J0137+3309',
     *   '3C147',   '0538+498', '0542+498', 'J0542+4951',
     *   '3C196',   '0809+483', '0813+482', 'J0813+4813',
     *   '3C380',   '1828+487', '1829+487', 'J1829+4844',
     *   '3C295',   '1409+524', '1411+522', 'J1411+5212'/
      DATA FRMIN /0.2, 0.2, 0.05, 0.05, 0.05, 0.2, 0.2, 0.05, 0.05, 0.2,
     *   0.2/
      DATA FRMAX /2.0, 4.0, 4.0,  12.0, 3.0,  12., 50., 4.0, 12.0, 12.,
     *   4.0/
C                                       date list
      DATA DATES /1983.4, 1985.9, 1987.3, 1989.9, 1995.2, 1998.1,
     *   1999.3, 2000.8, 2001.9, 2003.1, 2004.7, 2006.0, 2007.4, 2008.7,
     *   2010.0, 2010.9, 2012.0/
C                                       3C48
      DATA DCOEFF /
     *   1.3339,-.7643,-.1946,.055,   1.3350,-.7598,-.1869,.057,
     *   1.3361,-.7577,-.1905,.048,   1.3363,-.7605,-.1965,.057,
     *   1.3359,-.7673,-.2041,.059,   1.3342,-.7732,-.2078,.065,
     *   1.3342,-.7682,-.2097,.056,   1.3323,-.7654,-.2091,.060,
     *   1.3342,-.7708,-.2014,.059,   1.3341,-.7691,-.2006,.057,
     *   1.3341,-.7641,-.2102,.059,   1.3335,-.7705,-.2008,.058,
     *   1.3335,-.7660,-.1982,.051,   1.3361,-.7700,-.2119,.076,
     *   1.3334,-.7662,-.1988,.062,   1.3332,-.7665,-.1980,.064,
     *   1.3324,-.7690,-.1950,.059,
C                                       3C147
     *   1.4620,-.7085,-.2347,.051,   1.4648,-.7177,-.2501,.089,
     *   1.4624,-.7115,-.2336,.071,   1.4646,-.7194,-.2532,.092,
     *   1.4632,-.7121,-.2346,.086,   1.4641,-.7090,-.2313,.088,
     *   1.4642,-.7132,-.2424,.082,   1.4585,-.7086,-.2296,.068,
     *   1.4636,-.7124,-.2426,.084,   1.4639,-.7144,-.2453,.082,
     *   1.4635,-.7112,-.2453,.091,   1.4631,-.7136,-.2338,.094,
     *   1.4645,-.7115,-.2378,.084,   1.4625,-.7112,-.2396,.081,
     *   1.4623,-.7139,-.2405,.081,   1.4607,-.7150,-.2372,.077,
     *   1.4616,-.7187,-.2424,.079,
C                                       3C138
     *   1.0328,-.5523,-.1161,.008,   1.0337,-.5591,-.1605,.032,
     *   1.0354,-.5914,-.1032,-.005,  1.0292,-.5636,-.1857,.052,
     *   1.0145,-.5466,-.1758,.038,   1.0259,-.5679,-.1735,.039,
     *   1.0204,-.5702,-.1636,.030,   1.0081,-.5077,-.2492,.064,
     *   1.0196,-.5627,-.1823,.039,   1.0177,-.5686,-.1591,.029,
     *   1.0094,-.5003,-.2642,.085,   1.0181,-.5543,-.1486,.038,
     *   1.0149,-.5408,-.1174,.012,   1.0132,-.4941,-.1556,.045,
     *   1.0230,-.4983,-.1529,.048,   1.0207,-.5140,-.1626,.058,
     *   1.0332,-.5608,-.1197,.041/
C                                       Number of characters to check
      DATA LENCHK /5,8,8,10,  4,8,8,10, 5,8,8,10,
     *   5,8,8,10, 8,8,8,10, 5,8,8,10/
      DATA SENCHK /5,8,8,10, 5,8,8,10/
C                                       Source number in coef table
      DATA KSOUNO /1,1,1,1, 2,2,2,2, 3,3,3,3,
     *   4,4,4,4, 5,5,5,5, 6,6,6,6/
C                                       Frequency break points for bands
      DATA FBAND /0.15E3, 0.7E3, 2.0E3, 6.0E3, 11.5E3, 18.E3, 28.E3/
      DATA DONMSG /20*.FALSE./
C-----------------------------------------------------------------------
      IERR = 0
      CALL RFILL (5, 0.0, SPECI)
C                                       Frequency In MHz
      FREQ = TFREQ * 1.0D-6
      IBAND = 8
      DO 10 LOOP = 1,7
         IF (FREQ.LT.FBAND(8-LOOP)) IBAND = 8-LOOP
 10      CONTINUE
C                                       Find source
      ISRC = -1
      IF (ICTYPE.LT.0) THEN
         DO 20 LOOP = 1,XNSOU
            IF (SOURCE(1:LENCHK(LOOP)).EQ.LNOSOU(LOOP)(1:LENCHK(LOOP)))
     *         ISRC = KSOUNO(LOOP)
 20       CONTINUE
      ELSE
         DO 25 LOOP = 1,SNSOU
            IF (SOURCE(1:SENCHK(LOOP)).EQ.SNOSOU(LOOP)(1:SENCHK(LOOP)))
     *         ISRC = (LOOP - 1) / 4 + XSOUR + 1
 25         CONTINUE
         DO 30 LOOP = 1,XNSOU
            IF (SOURCE(1:LENCHK(LOOP)).EQ.KNOSOU(LOOP)(1:LENCHK(LOOP)))
     *         ISRC = KSOUNO(LOOP)
 30         CONTINUE
C                                       extra 2017 sources
         IF ((ICTYPE.EQ.0) .AND. (ISRC.LE.0)) THEN
            FREQ = FREQ * 1.D-3
            DO 35 LOOP = 1,XSOU17
               DO 34 J = 1,4
                  K = JTRIM (KNOS17(J,LOOP))
                  IF (SOURCE(:K).EQ.KNOS17(J,LOOP)(:K)) THEN
                     IF ((FREQ.GE.FRMIN(LOOP)) .AND.
     *                  (FREQ.LE.FRMAX(LOOP))) THEN
                        ISRC = LOOP + XSOUR + SSOUR
                     ELSE
                        WRITE (MSGTXT,1030) FREQ, FRMIN(LOOP),
     *                     FRMAX(LOOP)
                        CALL MSGWRT (6)
                        END IF
                     GO TO 36
                     END IF
 34               CONTINUE
 35            CONTINUE
 36         FREQ = FREQ * 1.D3
            END IF
         END IF
C                                       Complain if unknown
      IF (ISRC.LT.0) THEN
         MSGTXT = 'UNKNOWN FLUX CALIBRATOR: ' // SOURCE
         IF (IT.EQ.0) CALL MSGWRT (6)
         FLUX = 0.0
         IERR = 1
         GO TO 999
         END IF
C                                       message about model
      IF ((ISRC.LE.4) .AND. (.NOT.DONMSG(ISRC))) THEN
         MSGTXT = 'A source model for this calibrator is available'
         CALL MSGWRT (5)
         MSGTXT = 'Consult the help file for CALRD for assistance'
         CALL MSGWRT (5)
         DONMSG(ISRC) = .TRUE.
         END IF
C                                       Assume no error
      FERROR = 0.0
C                                       Perley-Butler 2017
      IF (ICTYPE.EQ.0) THEN
         DT = LOG10 (FREQ)
         IF (ISRC.NE.5) THEN
            DT = DT - 3.0D0
            CALL RCOPY (5, TCOEF7(2,ISRC), SPECI)
            END IF
         TEMP2 = TCOEF7(1,ISRC) + DT * (TCOEF7(2,ISRC) + DT *
     *      (TCOEF7(3,ISRC) + DT * (TCOEF7(4,ISRC) + DT *
     *      (TCOEF7(5,ISRC) + DT * TCOEF7(6,ISRC)))))
         GO TO 190
         END IF
C                                       steady sources
C                                       Perley 2013
      IF (ISRC.GT.XSOUR) THEN
         ICTYPE = 10
         ISRC = ISRC - XSOUR
         DT = LOG10 (FREQ)
         DT = DT - 3.0D0
         CALL RCOPY (3, SCOEF3(2,ISRC), SPECI)
         TEMP2 = SCOEF3(1,ISRC) + DT * (SCOEF3(2,ISRC) + DT *
     *      (SCOEF3(3,ISRC) + DT * SCOEF3(4,ISRC)))
         GO TO 190
         END IF
C                                       fix ref for some sources
C                                       HI writing depends on this
      IF ((IT.EQ.1) .AND. (ICTYPE.EQ.2) .AND. (ISRC.GE.2) .AND.
     *   (ISRC.LE.4)) ICTYPE = 3
      LCTYPE = ICTYPE
      IF ((ICTYPE.EQ.1) .AND. ((ISRC.LT.2) .OR. (ISRC.GT.4))) LCTYPE = 2
C                                       Compute flux
      DT = LOG10 (FREQ)
C                                       Low frequency
      IF (LCTYPE.LT.0) THEN
C                                       return wrt 1 GHz, not 150 MHz
         DT = LOG10 (1.0D3 / 150.0D0)
         SPECI(1) = LCOEFF(2,ISRC) + 2.D0*DT*LCOEFF(3,ISRC) +
     *      3.D0*DT*DT*LCOEFF(4,ISRC) + 4.D0*DT*DT*DT*LCOEFF(5,ISRC)
         SPECI(2) = LCOEFF(3,ISRC) + 3.D0*DT*LCOEFF(4,ISRC) +
     *      6.D0*DT*DT*LCOEFF(5,ISRC)
         SPECI(3) = LCOEFF(4,ISRC) + 4.D0*DT*LCOEFF(5,ISRC)
         SPECI(4) = LCOEFF(5,ISRC)
C                                       compute flux, error
         DT = LOG10 (FREQ/150.0D0)
         TEMP2 = DT * (LCOEFF(2,ISRC) + DT * (LCOEFF(3,ISRC) + DT *
     *      (LCOEFF(4,ISRC) + DT * LCOEFF(5,ISRC))))
         FLUX = LCOEFF(1,ISRC) * (10.D0 ** TEMP2)
         DT = DT * DT
         FERROR = LCOERR(1,ISRC)**2 + (LOG(10.0D0)**2) * DT *
     *      (LCOERR(2,ISRC)**2 + DT * (LCOERR(3,ISRC) + DT *
     *      (LCOERR(4,ISRC) + DT * LCOERR(5,ISRC))))
         FERROR = SQRT (FERROR) * (10.0D0 ** TEMP2)
         GO TO 210
C                                       Perley-Butler 2013 time
      ELSE IF (LCTYPE.EQ.1) THEN
         DT = DT - 3.0D0
         LSRC = ISRC - 1
         IF ((DD.LE.DATES(1)) .OR. (DD.GE.DATES(NDATES))) THEN
            I = NDATES
            IF (DD.LE.DATES(1)) I = 1
            CALL RCOPY (3, DCOEFF(2,I,LSRC), SPECI)
            TEMP2 = DCOEFF(1,I,LSRC) + DT * (DCOEFF(2,I,LSRC) + DT *
     *         (DCOEFF(3,I,LSRC) + DT * DCOEFF(4,I,LSRC)))
C                                       interpolate
         ELSE
            DO 110 I = 2,NDATES
               IF (DD.LT.DATES(I)) THEN
                  W1 = (DATES(I) - DD) / (DATES(I) - DATES(I-1))
                  W2 = 1.0 - W1
                  TEMP2 = DCOEFF(1,I,LSRC) + DT * (DCOEFF(2,I,LSRC) +
     *                DT * (DCOEFF(3,I,LSRC) + DT * DCOEFF(4,I,LSRC)))
                  TEMP1 = DCOEFF(1,I-1,LSRC) + DT * (DCOEFF(2,I-1,LSRC)
     *               + DT * (DCOEFF(3,I-1,LSRC) + DT *
     *               DCOEFF(4,I-1,LSRC)))
                  FLUX = W2 * (10.D0**TEMP2) + W1 * (10.D0**TEMP1)
                  SPECI(1) = W2*DCOEFF(2,I,LSRC) + W1*DCOEFF(2,I-1,LSRC)
                  SPECI(2) = W2*DCOEFF(3,I,LSRC) + W1*DCOEFF(3,I-1,LSRC)
                  SPECI(3) = W2*DCOEFF(4,I,LSRC) + W1*DCOEFF(4,I-1,LSRC)
                  GO TO 200
                  END IF
 110           CONTINUE
            END IF
C                                       Perley 2013
      ELSE IF (LCTYPE.EQ.2) THEN
         IF (ISRC.NE.5) THEN
            DT = DT - 3.0D0
            CALL RCOPY (3, TCOEF3(2,ISRC), SPECI)
            END IF
         TEMP2 = TCOEF3(1,ISRC) + DT * (TCOEF3(2,ISRC) + DT *
     *      (TCOEF3(3,ISRC) + DT * TCOEF3(4,ISRC)))
C                                       Perley 2010
      ELSE IF (LCTYPE.EQ.3) THEN
         IF (ISRC.NE.5) THEN
            DT = DT - 3.0D0
            CALL RCOPY (3, TCOEFF(2,ISRC), SPECI)
            END IF
         TEMP2 = TCOEFF(1,ISRC) + DT * (TCOEFF(2,ISRC) + DT *
     *      (TCOEFF(3,ISRC) + DT * TCOEFF(4,ISRC)))
C                                       Taylor 1999.2 &
C                                       Reynolds (1934-638)
      ELSE IF (LCTYPE.EQ.4) THEN
         IF (ISRC.NE.5) THEN
            DT = DT - 3.0D0
            CALL RCOPY (3, RCOEFF(2,ISRC), SPECI)
            END IF
         TEMP2 = RCOEFF(1,ISRC) + DT * (RCOEFF(2,ISRC) + DT *
     *      (RCOEFF(3,ISRC) + DT * RCOEFF(4,ISRC)))
C                                       Baars scale
      ELSE IF (LCTYPE.GE.7) THEN
         TEMP2 = COEFF(1,ISRC) + DT * (COEFF(2,ISRC) + DT *
     *      (COEFF(3,ISRC) + DT * COEFF(4,ISRC)))
C                                       Baars error, sum of squares
         FERROR =  (COERR(1,ISRC)**2) +
     *            ((COERR(2,ISRC)*DT)**2) +
     *            ((COERR(3,ISRC)*DT*DT)**2) +
     *            ((COERR(4,ISRC)*DT*DT*DT)**2)
C                                       Perley 1995.2 &
C                                       Reynolds (1934-638)
      ELSE IF (LCTYPE.EQ.5) THEN
         TEMP2 = PCOEFF(1,ISRC) + DT * (PCOEFF(2,ISRC) + DT *
     *      (PCOEFF(3,ISRC) + DT * PCOEFF(4,ISRC)))
C                                       Perley 1990 &
C                                       Reynolds (1934-638)
      ELSE IF (LCTYPE.EQ.6) THEN
         TEMP2 = NCOEFF(1,ISRC) + DT * (NCOEFF(2,ISRC) + DT *
     *      (NCOEFF(3,ISRC) + DT * NCOEFF(4,ISRC)))
         END IF
C
 190  FLUX = 10.0D0 ** TEMP2
C                                       If non-zero error exponent
 200  IF (FERROR.GT.0) THEN
C                                       sqrt sum of squares * factor
         FERROR = LOG(10.) * FLUX * SQRT(FERROR)
         END IF
C                                       Convert back to real
 210  FERR = FERROR
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('F=',F6.2,' OUTSIDE ALLOWED RANGE',2F6.2,' GHz')
      END
      SUBROUTINE GETV (DISK, CNO, SID, IIF, LSIGN, HELO, REFANT, NUX,
     *   LRESTF, SYSVEL, IRET)
C-----------------------------------------------------------------------
C   Returns the source velocity at the first observation time in the
C   data set.
C   Inputs:
C      IIF      I   IF of this velocity, rest freq, etc
C      LSIGN    I   Velocity type sign for computation
C      NUX      D   Frequency of reference pixel this IF not counting
C                   any in the CL/FO table
C      LRESTF   D   Rest frequency
C      REFANT   I   Velcities are wrt this antenna: 0 -> Earth center
C   Output:
C      SYSVEL   D   Velocity
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, SID, IIF, LSIGN, REFANT, IRET
      LOGICAL   HELO
      DOUBLE PRECISION NUX, LRESTF, SYSVEL
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   LUN, LUNTMP, IVER, TABUFF(512), INXRNO, NXKOLS(MAXNXC),
     *   NXNUMV(MAXNXC), IREC, NREC, ID, SUBA, VSTART, VEND, FQID,
     *   LSTSOU, GUSE, CLSUB, CLFQ, IANT, OLDSOU, I, NANT, IA1, IA2
      REAL      UT, TIME, DTIME
      LOGICAL   FIRST, SORT
      DOUBLE PRECISION CLFOFF(MAXIF), OBS, DOPVEL, ARRLON
      INCLUDE 'INCS:DCVL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PSTD.INC'
      SAVE FIRST, SORT, LSTSOU, CLFOFF, GUSE, IANT, DOPVEL, TIME, UT
      DATA FIRST, SORT, LSTSOU, GUSE, IANT /.TRUE., .FALSE., 0, 0, 0/
C-----------------------------------------------------------------------
C                                       first time: get ant, NX, ...
      IF (FIRST) THEN
         FIRST = .FALSE.
         LUN = LUNTMP (1)
C                                       time system, array center
         IVER = 1
         CALL ANTINI ('READ', TABUFF, DISK, CNO, IVER, CATBLK, LUN,
     *      IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *      RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *      TFRAME, NUMORB, NOPCAL, ANFQID, ANTNIF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING THE ANTENNA TABLE'
            GO TO 990
            END IF
         NANT = TABUFF(5)
         CALL TABIO ('CLOS', 1, IANRNO, TABUFF, TABUFF, IRET)
C                                       get antenna info (a la CVEL)
         IF (REFANT.GT.0) THEN
C                                       Fill AN information
C                                       into common in D/CANS.INC
            CALL GETANT (DISK, CNO, IVER, CATBLK, TABUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'GETTING ANTENNA INFO'
               GO TO 990
               END IF
C                                       Correct station positions for
C                                       centre array offset if non-zero
C                                       go to left-hand system
            ARRLON = 0.0D0
            IF ((ABS(CNTRX).GT.1.D2) .AND. (ABS(CNTRY).GT.1.D2) .AND.
     *         (ABS(CNTRZ).GT.1.D2)) ARRLON = ATAN2 (CNTRY, CNTRX)
            DO 10 I = 1, MAXANT
               ANTX(I) = CNTRX + STNX(I)*COS(ARRLON) -
     *            STNY(I)*SIN(ARRLON)
               ANTY(I) = CNTRY + STNY(I)*COS(ARRLON) +
     *            STNX(I)*SIN(ARRLON)
               ANTY(I) = -ANTY(I)
               ANTZ(I) = CNTRZ + STNZ(I)
 10            CONTINUE
            END IF
         END IF
C                                       find time first record
      IF (SID.NE.LSTSOU) THEN
         UT = 0.0
         TIME = 0.0
         CALL FNDEXT ('NX', CATBLK, IVER)
         IF (IVER.GT.0) THEN
            LUN = LUNTMP (1)
            IVER = 1
            CALL NDXINI ('READ', TABUFF, DISK, CNO, IVER, CATBLK, LUN,
     *         INXRNO, NXKOLS, NXNUMV, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'OPENING THE INDEX TABLE'
               GO TO 990
               END IF
            NREC = TABUFF(5)
            DO 20 IREC = 1,NREC
               INXRNO = IREC
               CALL TABNDX ('READ', TABUFF, INXRNO, NXKOLS, NXNUMV,
     *            TIME, DTIME, ID, SUBA, VSTART, VEND, FQID, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'READING THE INDEX TABLE'
                  GO TO 990
                  END IF
               IF (ID.EQ.SID) THEN
                  TIME = TIME - DTIME/2.0
                  UT = TIME - (DATUTC/86400.0D0)
                  GO TO 25
                  END IF
 20            CONTINUE
 25         CALL TABIO ('CLOS', 1, IANRNO, TABUFF, TABUFF, IRET)
            END IF
C                                       CL/FO addition all IFs
         HELIO = HELO
         CALL DFILL (MAXIF, 0.0D0, CLFOFF)
         LSTSOU = SID
         CLFQ = 0
         CLSUB = 0
         IF (REFANT.GT.0) THEN
            IA1 = REFANT
            IA2 = REFANT
         ELSE
            IA1 = 1
            IA2 = NANT
            END IF
         DO 30 IANT = IA1,IA2
            CALL FRQUPD (DISK, CNO, GUSE, IANT, TIME, LSTSOU, CLSUB,
     *         CLFQ, CATBLK, SORT, CLFOFF, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING CL/FO TABLE OFFSETS'
               GO TO 990
            ELSE IF (IRET.EQ.0) THEN
               GO TO 40
               END IF
 30         CONTINUE
         IANT = MAX (1, REFANT)
 40      OLDSOU = -1
         CALL CVLDOP (DISK, CNO, UT, REFANT, LSTSOU, OLDSOU, LSTSOU,
     *      DOPVEL, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'GETTING DOPPLER VELOCITY'
            GO TO 990
            END IF
         END IF
C                                       velocity
      OBS = NUX + CLFOFF(IIF)
      IF (LSIGN.GT.0) THEN
         SYSVEL = VELITE * (LRESTF/OBS - 1.0D0) - DOPVEL
      ELSE
         SYSVEL = VELITE * (1.0D0 - OBS/LRESTF) - DOPVEL
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETV ERROR',I4,' ON ',A)
      END

      PROGRAM FILAIP
C-----------------------------------------------------------------------
C! stand-alone program to create/initialize all basic AIPS files
C# Service
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2002-2003, 2005, 2007-2008, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FILAIP is a service program designed to create and initialize the
C   files needed to run AIPS.  It may be used to alter the AIPS
C   configuration already in use as well.  In either case, it
C   initializes all basic AIPS files.
C-----------------------------------------------------------------------
      CHARACTER MPASS*12, PHNAME*48, FTYP(13)*2, MSGBUF*80, PRGNAM*6
      INTEGER   I, J, CMAX, IC, NREC, ZBUF(256), IT, IERR, IAERR, IVOL,
     *   BUFFER(256), LUN, FIND, NL, IN, IQ, TTYLUN, TTYIND,
     *   SCRTCH(256), ISIZE, LSIZE, IRNO, TTY(2), IARR(5)
      REAL      ROBUFF(256), RBUFFR(256)
      HOLLERITH HPASS(3), HBUFFR(256)
      LOGICAL   T, F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PKSZ.INC'
      EQUIVALENCE (BUFFER, RBUFFR, HBUFFR),    (BUFFER, ROBUFF)
      EQUIVALENCE (TTY(1), TTYLUN),  (TTY(2), TTYIND)
      DATA MPASS /'AMANAGER '/
      DATA T, F /.TRUE.,.FALSE./
      DATA PRGNAM /'FILAIP'/
      DATA FTYP /'BQ','BA','CA','TD','IC','MS','ME','SP','AC','TP',
     *   'GR','PW','TC'/
      DATA LUN, TTYLUN  /15, 5/
C-----------------------------------------------------------------------
C                                       basic init
      CALL AIPINI (TTY, PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL ZPHFIL ('AC', 1, 0, 0, PHNAME, IERR)
      CALL ZEXIST (1, PHNAME, ISIZE, IAERR)
      CALL YTVCIN
C                                       Is this job ok?
C                                       Does password file exist
      CALL ZPHFIL ('PW', 1, 0, 0, PHNAME, IERR)
      CALL ZEXIST (1, PHNAME, ISIZE, IERR)
C                                       Error
      IF (IERR.GT.1) THEN
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (8)
C                                       Ask for password
      ELSE IF (IERR.EQ.0) THEN
         CALL PASWRD (SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 995
         END IF
C                                       Ask for basic data
C                                       # disks, cat size
      CMAX = 400
      NVOL = 35
      UCTSIZ = 100
C                                       # interactive, batch AIPS
 30   WRITE (MSGBUF,1030)
      CALL INQINT (TTY, MSGBUF, 2, IARR, IERR)
      IF (IERR.GT.0) GO TO 990
      IF (IERR.LT.0) GO TO 30
      I = IARR(1)
      J = IARR(2)
      IF (I.LE.0) I = NINTRN
      IF (J.LT.0) J = NBATQS
      IC = I
      IF (J.GT.0) IC = I + 1 + J
      IF ((I.LE.0) .OR. (IC.GT.35)) GO TO 30
      NINTRN = I
      NBATQS = J
C                                       # interactive devices:
C                                       obsolete
      CALL FILL (256, 0, ZBUF)
C                                       # of tape drives
      NTAPED = 10
C-----------------------------------------------------------------------
C                                       Batch queuing
      IF (NBATQS.GT.0) THEN
         IT = 1
         ISIZE = NBATQS
         CALL ZPHFIL (FTYP(IT), 1, 0, 0, PHNAME, IERR)
         CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
         IF (IERR.LE.1) GO TO 110
            WRITE (MSGTXT,1100) FTYP(IT), IERR
            CALL MSGWRT (8)
            GO TO 150
 110     CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1110) FTYP(IT), IERR
            CALL MSGWRT (8)
            GO TO 150
            END IF
         DO 125 I = 1,NBATQS
            IRNO = I
            CALL ZFIO ('WRIT', LUN, FIND, IRNO, ZBUF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1120) FTYP(IT), IERR, I
               CALL MSGWRT (8)
               GO TO 130
               END IF
 125        CONTINUE
 130     CALL ZCLOSE (LUN, FIND, IERR)
         END IF
C-----------------------------------------------------------------------
C                                       Batch work files
 150  IF (NBATQS.GT.0) THEN
         IT = 2
         NL = 252 / 22
         ISIZE = 100/NL + 1
         CALL FILL (256, 0, BUFFER)
         BUFFER(2) = 2
         BUFFER(3) = 1
         NL = NINTRN + 1
         DO 180 IN = 1,NL
            DO 170 IQ = 1,NBATQS
               CALL ZPHFIL (FTYP(IT), 1, IQ, IN, PHNAME, IERR)
               CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
               IF (IERR.GT.1) THEN
                  WRITE (MSGTXT,1100) FTYP(IT), IERR, IN, IQ
                  CALL MSGWRT (8)
                  GO TO 170
                  END IF
               IF (IERR.EQ.1) BUFFER(4) = ISIZE
               IF (IERR.EQ.0) BUFFER(4) = LSIZE
               CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1110) FTYP(IT), IERR, IN, IQ
                  CALL MSGWRT (8)
                  GO TO 170
                  END IF
               CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
               WRITE (MSGTXT,1120) FTYP(IT), IERR, IN, IQ
               IF (IERR.NE.0) CALL MSGWRT (8)
               CALL ZCLOSE (LUN, FIND, IERR)
 170           CONTINUE
 180        CONTINUE
         END IF
C-----------------------------------------------------------------------
C                                       File catalog
C                                       This code never executed now
C                                       was used in the old days
      IF (UCTSIZ.LE.0) THEN
         IT = 3
         NL = 10
         ISIZE = 2 + (CMAX-1) / (256/NL)
         DO 240 IVOL = 1,NVOL
            CALL ZPHFIL (FTYP(IT), IVOL, 0, 0, PHNAME, IERR)
            CALL ZCREAT (IVOL, PHNAME, ISIZE, F, LSIZE, IERR)
            IF (IERR.NE.0) THEN
C                                       Creation error other than
C                                       the file already exists.
               IF (IERR.NE.1) THEN
                  WRITE (MSGTXT,1100) FTYP(IT), IERR, IVOL
                  CALL MSGWRT (8)
C                                       CA file exist. Do not init.
               ELSE
                  WRITE (MSGTXT,1205) FTYP(IT)
                  CALL MSGWRT (2)
                  END IF
               GO TO 240
               END IF
C
            CALL ZOPEN (LUN, FIND, IVOL, PHNAME, F, T, T, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1110) FTYP(IT), IERR, IVOL
               CALL MSGWRT (8)
               GO TO 240
               END IF
C
            CALL FILL (256, 0, BUFFER)
            BUFFER(1) = IVOL
            BUFFER(3) = CMAX
            CALL ZDATE (BUFFER(4))
            CALL ZTIME (BUFFER(7))
            CALL ZDATE (BUFFER(10))
            CALL ZTIME (BUFFER(13))
            CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1120) FTYP(IT), IERR, IVOL, 1
               CALL MSGWRT (8)
               GO TO 235
               END IF
            CALL FILL (16, 0, BUFFER)
            DO 225 I = 1,256,NL
               BUFFER(I) = -1
 225           CONTINUE
            NREC = LSIZE
            DO 230 IRNO = 2,NREC
               CALL ZFIO ('WRIT', LUN, FIND, IRNO, BUFFER, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1120) FTYP(IT), IERR, IVOL, IRNO
                  CALL MSGWRT (8)
                  GO TO 235
                  END IF
 230           CONTINUE
 235        CALL ZCLOSE (LUN, FIND, IERR)
 240        CONTINUE
         END IF
C-----------------------------------------------------------------------
C                                       Task data communications
      IT = 4
      ISIZE = 4 * 35 + 1
      CALL ZPHFIL (FTYP(IT), 1, 0, 4, PHNAME, IERR)
      CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
      IF (IERR.GT.1) THEN
         WRITE (MSGTXT,1100) FTYP(IT), IERR
         CALL MSGWRT (8)
         GO TO 300
         END IF
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL MSGWRT (8)
         GO TO 300
         END IF
      ZBUF(256) = 4
      CALL ZFIO ('WRIT', LUN, FIND, 1, ZBUF, IERR)
      ZBUF(256) = 0
      WRITE (MSGTXT,1120) FTYP(IT), IERR
      IF (IERR.NE.0) CALL MSGWRT (8)
      CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Image catalogs
C                                       Television devices
C                                       obsolete - no files needed
 300  IT = 5
C                                       Graphics devices
      NREC = 1295
      ISIZE = NREC
      CALL ZPHFIL (FTYP(IT), 1, 0, 0, PHNAME, IERR)
      CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
C                                       leave pre-existing alone
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1100) FTYP(IT), IERR
         IF (IERR.GT.1) CALL MSGWRT (8)
         GO TO 350
         END IF
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL MSGWRT (8)
         GO TO 350
         END IF
      DO 340 I = 1,1295
         CALL ZFIO ('WRIT', LUN, FIND, I, ZBUF, IERR)
         IF (IERR.NE.0)  THEN
            WRITE (MSGTXT,1120) FTYP(IT), IERR, I
            CALL MSGWRT (8)
            GO TO 345
            END IF
 340     CONTINUE
 345  CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Message files: user #1
 350  IT = 6
      ISIZE = 4
      CALL FILL (256, 0, BUFFER)
      CALL ZPHFIL (FTYP(IT), 1, NLUSER, 0, PHNAME, IERR)
      CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
C                                       Creation error
      IF (IERR.NE.0) THEN
         IF (IERR.NE.1) THEN
            WRITE (MSGTXT,1100) FTYP(IT), IERR
            CALL MSGWRT (8)
C                                       MS file exists. Do not init.
         ELSE
            WRITE (MSGTXT,1205) FTYP(IT)
            CALL MSGWRT (2)
            END IF
         GO TO 400
         END IF
C
      BUFFER(2) = LSIZE
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL MSGWRT (8)
         GO TO 400
         END IF
      CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1120) FTYP(IT), IERR
         CALL MSGWRT (8)
         END IF
      CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Memory files: create only
 400  NREC = KBLOCK + LBLOCK
      IC = NINTRN + 1
      IF (NBATQS.GT.0) IC = NINTRN + 1 + NBATQS + 1
      ISIZE = NREC
      IT = 7
      DO 410 I = 1,IC
         J = I - 1
         CALL ZPHFIL (FTYP(IT), 1, 0, J, PHNAME, IERR)
         CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
         IF (IERR.GT.1) THEN
            WRITE (MSGTXT,1100) FTYP(IT), IERR, J
            CALL MSGWRT (8)
            END IF
 410     CONTINUE
      WRITE (MSGTXT,1410) IC
      CALL MSGWRT (2)
C-----------------------------------------------------------------------
C                                       System parameters file
      IT = 8
      NREC = 1
      ISIZE = NREC
      CALL ZPHFIL (FTYP(IT), 1, 0, 0, PHNAME, IERR)
      CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
C                                       leave pre-existing alone
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1100) FTYP(IT), IERR
         IF (IERR.NE.1) CALL MSGWRT (8)
         GO TO 500
         END IF
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL MSGWRT (8)
         GO TO 500
         END IF
      CALL FILL (256, 0, BUFFER)
      BUFFER(1) = NVOL
      BUFFER(2) = NTAPED
      BUFFER(3) = CRTMAX
      BUFFER(4) = PRTMAX
      BUFFER(5) = NBATQS
      BUFFER(6) = MAXXPR(1)
      BUFFER(7) = MAXXPR(2)
      BUFFER(8) = CSIZPR(1)
      BUFFER(9) = CSIZPR(2)
      BUFFER(10) = NINTRN
      BUFFER(11) = KAPWRD
      BUFFER(12) = NTVDEV
      BUFFER(13) = NTKDEV
      BUFFER(64) = NTVACC
      BUFFER(65) = NTKACC
      BUFFER(66) = UCTSIZ
      BUFFER(67) = USELIM
      BUFFER(68) = NCHPRT
      BUFFER(69) = 0
C                                       Floating pt values.
      ROBUFF(71) = XPRDMM
      ROBUFF(72) = XTKDMM
      CALL CHR2H (20, SYSNAM, 1, ROBUFF(73))
      CALL RCOPY (15, TIMEDA, ROBUFF(78))
      ROBUFF(93) = TIMESG
      ROBUFF(94) = TIMEMS
      ROBUFF(95) = TIMESC
      ROBUFF(96) = TIMECA
      CALL RCOPY (4, TIMEBA, ROBUFF(97))
      CALL RCOPY (3, TIMEAP, ROBUFF(101))
      CALL COPY (120, DASSGN, BUFFER(104))
      BUFFER(224) = MAXXTK(1)
      BUFFER(225) = MAXXTK(2)
      BUFFER(226) = CSIZTK(1)
      BUFFER(227) = CSIZTK(2)
      BUFFER(228) = PRDELE
      ROBUFF(238) = AIPSMK
      IF (ROBUFF(238).LE.0.0) ROBUFF(238) = 500.0
C                                       Set device table.
      CALL COPY (50, DEVTAB, BUFFER(14))
      CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
      IF (IERR.NE.0)  THEN
         WRITE (MSGTXT,1120) FTYP(IT), IERR
         CALL MSGWRT (8)
         END IF
      CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Accounting
 500  IT = 9
      NREC = 100
      ISIZE = NREC
      CALL ZPHFIL (FTYP(IT), 1, 0, 0, PHNAME, IERR)
      CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
C                                       Creation error
      IF (IERR.NE.0) THEN
         IF (IERR.NE.1) THEN
            WRITE (MSGTXT,1100) FTYP(IT), IERR
            CALL MSGWRT (8)
C                                       AC file exists. Do not init.
         ELSE
            WRITE (MSGTXT,1205) FTYP(IT)
            CALL MSGWRT (2)
            END IF
         GO TO 550
         END IF
C
      NREC = LSIZE
      CALL FILL (256, 0, BUFFER)
      BUFFER(3) = 9
      BUFFER(4) = 256 / BUFFER(3)
      BUFFER(2) = NREC * BUFFER(4) - 1
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL MSGWRT (8)
         GO TO 550
         END IF
      CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1120) FTYP(IT), IERR
         CALL MSGWRT (8)
         END IF
      CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Tape drive dummy files
 550  IF (NTAPED.LE.0) GO TO 600
         NREC = 0
         ISIZE = 1
         IT = 10
         DO 560 I = 1,NTAPED
            CALL ZPHFIL (FTYP(IT), 1, 1, I, PHNAME, IERR)
            CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
            IF (IERR.GT.1) THEN
               WRITE (MSGTXT,1100) FTYP(IT), IERR
               CALL MSGWRT (8)
               END IF
 560        CONTINUE
C-----------------------------------------------------------------------
C                                       Gripes
 600  IT = 11
      NREC = 50
      ISIZE = NREC
      CALL FILL (256, 0, BUFFER)
      BUFFER(3) = 2
      BUFFER(4) = 1
      CALL ZPHFIL (FTYP(IT), 1, 0, 0, PHNAME, IERR)
      CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
C                                       Creation error
      IF (IERR.NE.0) THEN
         IF (IERR.NE.1) THEN
            WRITE (MSGTXT,1100) FTYP(IT), IERR
            CALL MSGWRT (8)
C                                       GR file exists. Do not init.
         ELSE
            WRITE (MSGTXT,1205) FTYP(IT)
            CALL MSGWRT (2)
            END IF
         GO TO 650
         END IF
C
      BUFFER(1) = LSIZE
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL MSGWRT (8)
      ELSE
         CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1120) FTYP(IT), IERR
            CALL MSGWRT (8)
            END IF
         CALL ZCLOSE (LUN, FIND, IERR)
         END IF
C-----------------------------------------------------------------------
C                                       Password file
 650  IT = 12
      I = 3
      J = 256 / I
      NREC = (USELIM-1) / J + 1
      ISIZE = NREC
      CALL ZPHFIL (FTYP(IT), 1, 0, 0, PHNAME, IERR)
      CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
C                                       Creation error
      IF (IERR.NE.0) THEN
         IF (IERR.NE.1) THEN
            WRITE (MSGTXT,1100) FTYP(IT), IERR
            CALL MSGWRT (8)
C                                       PW file exists. Do not init.
         ELSE
            WRITE (MSGTXT,1205) FTYP(IT)
            CALL MSGWRT (2)
            END IF
         GO TO 700
         END IF
C                                       Encode the blank password
      MSGBUF = ' '
      CALL PASENC (MSGBUF, HPASS)
      J = 3 * J
      DO 665 I = 1,J,3
         CALL RCOPY (3, HPASS, RBUFFR(I))
 665     CONTINUE
C                                       and the default AIPS Manager
      CALL PASENC (MPASS, HBUFFR)
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL MSGWRT (8)
         GO TO 700
         END IF
      DO 680 I = 1,NREC
         CALL ZFIO ('WRIT', LUN, FIND, I, BUFFER, IERR)
         IF (I.EQ.1) CALL RCOPY (3, HPASS, RBUFFR(1))
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1120) FTYP(IT), IERR
            CALL MSGWRT (8)
            GO TO 690
            END IF
 680     CONTINUE
 690  CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Task communications (SHOW, TELL)
 700  IT = 13
      IC = NINTRN + 1
      IF (NBATQS.GT.0) IC = IC + NBATQS + 1
      ISIZE = 18 + 16 * IC
      CALL ZPHFIL (FTYP(IT), 1, 0, 1, PHNAME, IERR)
      CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
      IF (IERR.GT.1) THEN
         WRITE (MSGTXT,1100) FTYP(IT), IERR
         CALL MSGWRT (8)
         GO TO 750
         END IF
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL MSGWRT (8)
         GO TO 750
         END IF
      DO 715 IRNO = 1,18
         CALL ZFIO ('WRIT', LUN, FIND, IRNO, ZBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1120) FTYP(IT), IERR
            CALL MSGWRT (8)
            GO TO 720
            END IF
 715     CONTINUE
 720  CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Enough for now!!
 750  GO TO 900
C
 900  WRITE (MSGTXT,1900)
      CALL MSGWRT (2)
      GO TO 995
 990  WRITE (MSGTXT,1990) IERR
      CALL MSGWRT (8)
C
 995  CALL ZCLOSE (TTYLUN, TTYIND, IERR)
      IF (IAERR.EQ.0) CALL ACOUNT (2)
C
 999  STOP
C-----------------------------------------------------------------------
 1010 FORMAT ('** ERROR',I7,' FROM ZEXIST ON PASSWORD FILE ***')
 1030 FORMAT ('# interactive AIPS, # batch queues (2 I)')
 1100 FORMAT ('FILE TYPE ',A2,' CREATE ERROR',4I7)
 1110 FORMAT ('FILE TYPE ',A2,' OPEN ERROR',4I7)
 1120 FORMAT ('FILE TYPE ',A2,' WRITE ERROR',4I7)
 1205 FORMAT (A2,' FILE NOT INITIALIZED.',
     *   ' USE FILINI IF YOU REALLY MEAN IT')
 1410 FORMAT ('Init POPS memory files 1 through ',I2,
     *   ' with program POPSGN')
 1900 FORMAT ('Done!')
 1990 FORMAT ('ERROR',I7,' IN TERMINAL IO')
      END

      SUBROUTINE CCINI (LUN, NCOL, VOL, CNO, VER, CATBLK, BUF, IERR)
C-----------------------------------------------------------------------
C! creates and/or opens a CC (components) extension table
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CCINI creates and/or opens for writing (and reading) a specified
C   CC (components table) file.
C   Inputs:
C      LUN     I         Logical unit number to use
C      VOL     I         Disk number
C      CNO     I         Catalog number
C   In/out:
C      NCOL    I         Number of columns: 3 or 7 are allowed.
C      VER     I         Input: desired version number 0 -> new
C                        Output: that used
C      CATBLK  I(256)    File catalog header block
C   Output:
C      BUF     I(768)    First 512 words required for later calls to
C                        TABIO
C      IERR    I         Error codes from TABINI or TABIO
C-----------------------------------------------------------------------
      INTEGER   LUN, NCOL, VOL, CNO, VER, CATBLK(256), BUF(768), IERR
C
      INTEGER   IRNO, NKEY, NREC, ITITLE(8)
      HOLLERITH HTITLE(8)
      CHARACTER WRITE*4, CC*2, TTITLE*32, CTITLE(7)*8, UNITS(7)*8,
     *   TITLE*24
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (ITITLE, HTITLE)
      DATA CC, WRITE /'CC','WRIT'/
      DATA TTITLE /'AIPS CC CLEAN COMPONENTS TABLE  '/
      DATA CTITLE /'FLUX    ', 'DELTAX  ', 'DELTAY  ', 'MAJOR AX',
     *   'MINOR AX', 'POSANGLE', 'TYPE OBJ'/
      DATA UNITS /'JY      ', 5*'DEGREES ', 'CODE    '/
C-----------------------------------------------------------------------
C                                       Init parameters
      IF (NCOL.LE.3) NCOL = 3
      IF (NCOL.GT.3) NCOL = 7
      NKEY = 1
      NREC = 500
C                                       Data = 7 R's   x 1
      CALL FILL (256, 0, BUF(513))
      CALL FILL (7, 12, BUF(641))
C                                       create/open
      CALL TABINI (WRITE, CC, VOL, CNO, VER, CATBLK, LUN, NKEY, NREC,
     *   NCOL, BUF(513), BUF(1), IERR)
C                                       New file created
      IF (IERR.GE.0) GO TO 999
C                                       write column titles
         DO 20 IRNO = 1,NCOL
            TITLE = CTITLE(IRNO)
            CALL CHR2H (24, TITLE, 1, HTITLE)
            CALL TABIO (WRITE, 3, IRNO, ITITLE, BUF, IERR)
            IF (IERR.NE.0) GO TO 999
 20         CONTINUE
C                                       write units
         DO 30 IRNO = 1,NCOL
            TITLE = UNITS(IRNO)
            CALL CHR2H (24, TITLE, 1, HTITLE)
            CALL TABIO (WRITE, 4, IRNO, ITITLE, BUF, IERR)
            IF (IERR.NE.0) GO TO 999
 30         CONTINUE
C                                       sort order
         BUF(43) = -257
C                                       table title
         CALL CHR2H (32, TTITLE, 1, HTITLE)
         CALL COPY (8, ITITLE, BUF(101))
C
 999  RETURN
      END

      SUBROUTINE BASLST (NUMAN, ISUB, ANTENN, BASELN, NBASE, ANT1, ANT2)
C-----------------------------------------------------------------------
C! Build a list of antenna pairs from adverbs ANTENNA, BASELINE
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Determine a list of selected antenna pairs from the standard
C   ANTENNA and BASELINE adverbs.  BASLST differs from AN10RS in that
C   BASLST will always produce a full list of antenna pairs while
C   AN10RS will produce an abbreviated list if there are no entries in
C   ANTENNAS or BASELINE.
C   Inputs:
C      NUMAN    I(51)   NUMAN(1) is the number of subarrays present.
C                       NUMAN(i) is the maximum antenna number for
C                       subarray i-1, for i > 1.
C      ISUB     I       The subarray number for which a list of
C                       baselines is required: must be greater than
C                       zero (and is not checked!).
C      ANTENN   R(50)   The values of the ANTENNAS adverb.
C      BASELN   R(50)   The values of the BASELINE adverb.
C
C   Input/output:
C      NBASE    I       The maximum number of baselines to list on
C                       input.  Either the number of baselines found
C                       or zero or zero on output.  A value of zero
C                       indicates that more than the maximum number of
C                       baselines met the selection criteria.
C   Outputs:
C      ANT1     I(*)    List of first elements of antenna pairs.
C      ANT2     I(*)    List of second elements of antenna pairs.
C                       For all i, 1 <= i <= NBASE, ANT2(i) > ANT1(i).
C-----------------------------------------------------------------------
      INTEGER   NUMAN(51), ISUB
      REAL      ANTENN(50), BASELN(50)
      INTEGER   NBASE, ANT1(*), ANT2(*)
C                                        DOSEL is true if baselines
C                                        listed in the adverbs are
C                                        to be deselected rather
C                                        selected.
      LOGICAL   DESEL
C                                        ANT lists the absolute values
C                                        of entries in the ANTENNAS
C                                        adverb, NANT is the number
C                                        of non-zero entries.
      INTEGER   ANT(50), NANT
C                                        BAS lists the absolute values
C                                        of entries in the BASELINE
C                                        adverb, NBAS is the number
C                                        of non-zero entries.
      INTEGER   BAS(50), NBAS
C                                        NREQ is the number of
C                                        baselines that match the
C                                        request criteria that have
C                                        been found so far.
      INTEGER   NREQ
C
      INTEGER   I, J, K, IROUND
      LOGICAL   REQBAS
      EXTERNAL  REQBAS, IROUND
C-----------------------------------------------------------------------
      IF ((ISUB.GT.0) .AND. (ISUB.LE.NUMAN(1))) THEN
         CALL SETANT (50, ANTENN, BASELN, NANT, NBAS, ANT, BAS, DESEL)
C                                       make full list w REQBAS
         K = NUMAN(ISUB+1)
         NREQ = 0
         DO 50 I = 1,K-1
            DO 40 J = I+1,K
               IF (REQBAS (I, J, DESEL, ANT, NANT, BAS, NBAS)) THEN
C                                        Too many baselines.
                  IF (NREQ.EQ.NBASE) THEN
                     NBASE = 0
                     GO TO 999
                  ELSE
                     NREQ = NREQ + 1
                     ANT1(NREQ) = I
                     ANT2(NREQ) = J
                     END IF
                  END IF
 40            CONTINUE
 50         CONTINUE
         NBASE = NREQ
      ELSE
C                                        Non-existent subarray.
         NBASE = 0
         END IF
C
  999 RETURN
      END

      SUBROUTINE IMVECT (OP, CHAN, COUNT, XDATA, YDATA, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! draws connected line segments on TV
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   IMVECT writes a connected sequence of line segments on a TV channel
C   calling YCNECT
C   Inputs:
C      OP      C*4     'ONNN' line of ones (max intensity)
C                      'OFFF' line of zeros (min intensity)
C      CHAN    I       channel number (1 to NGRAY+NGRAPH)
C      COUNT   I       number of X,Y pairs ( > 1)
C      XDATA   I(COUNT)      X coordinates X1,X2,...
C      YDATA   I(COUNT)      Y coordinates Y1,Y2,...
C   Output:
C      SCRTCH  I(*)    scratch buffer (size MAXXTV)
C      IERR    I       error code of ZM70XF - 0 => ok;  2 => input error
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   CHAN, COUNT, XDATA(*), YDATA(*), SCRTCH(*), IERR
C
      INTEGER   INT
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
C                                       check inputs
      IERR = 2
      INT = -99
      IF ((OP.EQ.'ONNN') .AND. (CHAN.LE.NGRAY)) INT = MAXINT
      IF ((OP.EQ.'ONNN') .AND. (CHAN.GT.NGRAY)) INT = 2**NGRAPH - 1
      IF (OP.EQ.'OFFF') INT = 0
      IF (INT.NE.-99) CALL TVVECT (INT, CHAN, COUNT, XDATA, YDATA,
     *   SCRTCH, IERR)
C
 999  RETURN
      END

LOCAL INCLUDE 'UVSRT.INC'
      INTEGER   BUFSIZ
      PARAMETER (BUFSIZ = 1024 * 4096 * 5)
C
      INTEGER   CATBLK(256), SEQIN, SEQOUT, DISKIN, DISOUT, SORT1,
     *   SORT2, LENBU, NSORT, IN, OUT, KEY1, KEY2, NBUFF, BUFSZ,
     *   CATSAV(256)
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2), XSORT(1)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, SORT*4
      REAL   XSIN, XSOUT, XDISIN, XDISO, BADD(10), ROTATE, DEFER,
     *   BUFFER(BUFSIZ)
      COMMON /BUFRS/ BUFSZ, IN, OUT, BUFFER
      COMMON /UVINF/ CATSAV, NBUFF, SEQIN, SEQOUT, DISKIN, DISOUT,
     *   SORT1, SORT2, LENBU, NSORT, KEY1, KEY2
      COMMON /MAPHDR/ CATBLK
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XCLAOU,
     *   XSOUT, XDISO, BADD, XSORT, ROTATE, DEFER
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, SORT
LOCAL END
      PROGRAM UVSRT
C-----------------------------------------------------------------------
C! Sorts uv data into a specified order.
C# UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2001, 2005, 2008, 2011, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVSRT sorts a uv data base into a specified order
C   Inputs:
C   AIPS adverb  Prg. name.          Description.
C   INNAME         NAMEIN        Name of the file to be sorted
C   INCLASS        CLASIN        Class of the file to be sorted.
C   INSEQ          SEQIN         Seq. number of file to be sorted.
C   INDISK         DISKIN        Disk number of file to be sorted.
C   OUTNAME        NAMOUT        Name of the output sorted file.
C   OUTCLASS       CLAOUT        Class of the output sorted file.
C   OUTSEQ         SEQOUT        Seq. number of output sorted file.
C   OUTDISK        DISKO         Disk number of the output file.
C   BADDISK        IBAD          Disk numbers of disks not to be used.
C   SORT           SORT          Two char. sort order, eg. 'XY'
C                                Second key varies faster
C   ROTATE         ROTATE        Angle by which data is to be rotated.
C   DEFER          DEFER         Defer output file creation
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   LUNM(10),IRET, IERR, LRECM
      INCLUDE 'UVSRT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA PRGM /'UVSRT '/
      DATA LUNM /16,17,18,19,20,21,22,23,24,25/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      IRET = 18
      CALL UVSRIN (PRGM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Read and partially sort data
C                                       to scratch file.
      IRET = 17
      CALL INSORT (IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Merge data.
      IF (NVIS.GE.NSORT) THEN
         LRECM = LREC + 2
         IRET = 16
         CALL AMERGE (KEY1, KEY2, NVIS, LRECM, NSORT, NBUFF, LUNM,
     *      SCRVOL, SCRCNO, LENBU, BUFFER(IN), BUFFER(OUT), IERR)
         IF (IERR.NE.0) GO TO 990
         IRET = 15
         END IF
C                                       Write data back to catalogd
C                                       file
      CALL UVOUT (IRET)
C                                       Close down files
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE UVSRIN (PRGM, JERR)
C-----------------------------------------------------------------------
C   UVSRIN gets input parameters for UVSRT and creates an output file
C   if necessary.
C   Inputs: PRGM   C*6       Task name
C   Output: JERR   I         Error code: 0 => ok, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, XSORTC(11)*1, TYPES(6)*4, STAT*4, XSORT1*1,
     *   XSORT2*1, UTYPE*2
      HOLLERITH CATH(256)
      INTEGER  JERR, NOPT, OLDCNO, IROUND, NPARM, IERR, I, NTRY, IOFF,
     *   JOFF
      LOGICAL   T
      REAL      CATR(256)
      INCLUDE 'UVSRT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATR, CATH, CATBLK)
      DATA NTRY /6/
      DATA TYPES /'DEC ','DEC-','MM  ','GLON','ELON','Y   '/
      DATA XSORTC /'B','T','U','V','W','R','P','X','Y','Z','M'/
      DATA NOPT /11/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init IO characteristics
      CALL ZDCHIN (T)
      CALL VHDRIN
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
      BUFSZ = BUFSIZ * 2
C                                       Get input parameters.
      NPARM = 27
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMEI, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         JERR = 8
         RQUICK = .FALSE.
         GO TO 999
         END IF
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISOUT = IROUND (XDISO)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (4, 1, XSORT, SORT)
      DO 15 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 15      CONTINUE
C                                        Default sort order is 'XY'
      IF (SORT.EQ.' ') SORT = 'XY  '
C                                       Decode sort order.
      XSORT1 = SORT(1:1)
      XSORT2 = SORT(2:2)
      SORT1 = 8
      SORT2 = 9
      DO 20 I = 1,NOPT
         IF (XSORT1.EQ.XSORTC(I)) SORT1 = I
         IF (XSORT2.EQ.XSORTC(I)) SORT2 = I
 20      CONTINUE
C                                       Restart AIPS.
      IF (RQUICK) CALL RELPOP (JERR, BUFFER, IERR)
C                                       Get CATBLK from old file.
      OLDCNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN, NLUSER
         CALL MSGWRT (8)
         JERR = 5
         GO TO 999
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         CALL MSGWRT (8)
         JERR = 5
         GO TO 999
         END IF
      NCFILE = 1
      FVOL(1) = DISKIN
      FCNO(1) = OLDCNO
      FRW(1) = 0
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CALL CHR2H (2, SORT, 1, CATH(KITYP))
      CATBLK(KIIMS) = SEQOUT
      IOFF = 3
      DO 55 I = 1,NTRY
         CALL AXEFND (4, TYPES(I), KICTPN, CATH(KHCTP), JOFF, IERR)
         IF (IERR.EQ.0) IOFF = JOFF
         IERR = 0
 55      CONTINUE
      CATR(KRCRT+IOFF) = CATR(KRCRT+IOFF) + ROTATE
C                                       create output
      CALL COPY (256, CATBLK, CATSAV)
      IF (DEFER.LE.0) CALL CREOUT (JERR)
C                                       Put input file in READ
      UTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, FCNO(1), NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, 'READ', BUFFER, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVSRIN: ERROR',I7,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I7,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I7,' COPYING CATBLK ')
      END
      SUBROUTINE CREOUT (IERR)
C-----------------------------------------------------------------------
C   CREOUT creates the output file and copies tables and HI info
C   Output:
C      IRET     I   Error return
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   LUN1, LUN2, NONOT
      CHARACTER UTYPE*2, NOTAB*2, HILINE*72
      HOLLERITH CATH(256)
      REAL      CATR(256)
      INCLUDE 'UVSRT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (CATR, CATH, CATBLK)
      DATA LUN1, LUN2 /27,28/
      DATA NONOT, NOTAB /1, 'NX'/
C-----------------------------------------------------------------------
C                                       Create output file.
      CCNO = 1
      FRW(2) = 3
      CALL UVCREA (DISOUT, CCNO, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            CALL MSGWRT (8)
            IERR = 8
            GO TO 999
C                                       Only overwrite input file
         ELSE IF ((CCNO.NE.FCNO(1)) .OR. (DISOUT.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            CALL MSGWRT (8)
            IERR = 8
            GO TO 999
C                                        Update existing CATBLK
         ELSE
            FRW(2) = 2
            CALL CATIO ('READ', DISOUT, CCNO, CATBLK, 'REST', BUFFER,
     *         IERR)
            IF (IERR.EQ.0) THEN
C                                       Put input file in READ
               UTYPE = 'UV'
               CALL CATDIR ('CSTA', DISKIN, FCNO(1), NAMEIN, CLAIN,
     *            SEQIN, UTYPE, NLUSER, 'CLRD', BUFFER, IERR)
               CALL CHR2H (2, SORT(1:2), 1, CATH(KITYP))
               CATR(KRCRT+4) = CATR(KRCRT+4) + ROTATE
               CALL CATIO ('WRIT', DISOUT, CCNO, CATBLK, 'WRIT', BUFFER,
     *            IERR)
               END IF
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1066) IERR
               CALL MSGWRT (5)
               END IF
            END IF
         END IF
      NCFILE = 2
      FVOL(2) = DISOUT
      FCNO(2) = CCNO
      FRW(2) = FRW(2) - 1
C                                       copy header keywords
      CALL KEYCOP (DISKIN, FCNO(1), DISOUT, CCNO, IERR)
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISOUT, FCNO(1), CCNO,
     *   CATBLK, BUFFER, BUFFER(257), IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1070) IERR
         CALL MSGWRT (5)
         GO TO 100
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2,
     *   BUFFER(257), IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, CATBLK(KIIMS), DISOUT, LUN2,
     *   BUFFER(257), IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Add new sort order.
      WRITE (HILINE,1080) TSKNAM, SORT
      CALL HIADD (LUN2, HILINE, BUFFER(257), IERR)
C                                       Add rotation.
      IF (ROTATE.NE.0.0) THEN
         WRITE (HILINE,1081) TSKNAM, ROTATE
         CALL HIADD (LUN2, HILINE, BUFFER(257), IERR)
         END IF
C                                       Close history file.
 100  CALL HICLOS (LUN2, .TRUE., BUFFER(257), IERR)
      IERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       Copy tables
      CALL ALLTAB (NONOT, NOTAB, LUN1, LUN2, DISKIN, DISOUT, FCNO(1),
     *   CCNO, CATBLK, BUFFER, BUFFER(4097), IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('ERROR',I7,' CREATING OUTPUT FILE')
 1060 FORMAT ('OUTPUT FILE ALREADY EXISTS, BUT IS NOT INPUT FILE')
 1066 FORMAT ('UVSRIN: ERROR',I7,' UPDATING NEW CATBLK')
 1070 FORMAT ('UVSRIN: ERROR',I7,' COPY/OPEN HISTORY FILE')
 1080 FORMAT (A6,' SORT = ','''',A2,''' / New sort order')
 1081 FORMAT (A6,' ROTATE = ',F10.2,' / Rotn. added')
      END
      SUBROUTINE INSORT (JERR)
C-----------------------------------------------------------------------
C   INSORT reads an input file, creates scratch files, and presorts
C   blocks of data onto a scratch file.
C   Output:
C      NBUFF    I    Number of AMERGE streams. in common
C      LENBU    I    No. vis records per read. in common
C      JERR     I    Return error code.: 0 = OK
C                      1 = buffers too small
C                      2 = can't make scratch files.
C                      3 = can't open input file.
C                      4 = sort failure.
C                      8 = I/O error
C-----------------------------------------------------------------------
      INTEGER   JERR
C
      INTEGER   ILRECO, INVSUM, MAXBUF, ILIM, BIND1, BIND2, IBSTRT,
     *   LRECO, IERR, LUN1, IND1, LUN2, IND2, INIO, IBUFSZ, NIOUT,
     *   NVSUM, IPTR2, I, IPTR1, J, IKEY, KKEY, KEY, KOUT, LENIO, BO,
     *   VO, ISIZE
      LOGICAL   T, F, EOI, NOROT
      REAL      TEMPU, TEMPV, CROT, SROT, XX, YY
      CHARACTER PHNAME*48
      INCLUDE 'UVSRT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA BO, VO, MAXBUF /1, 0, 4/
C-----------------------------------------------------------------------
C                                       Check if rotate wanted.
      NOROT = ROTATE.EQ.0.0
      CROT = COS (-ROTATE/57.29578)
      SROT = SIN (-ROTATE/57.29578)
C                                       Set keys.
      KEY1 = 1
      KEY2 = 2
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      LRECO = LREC + 2
C                                       Set length of buffers.
      NBUFF = MAXBUF
      LENBU = (BUFSZ - (4 * NBPS * (NBUFF+1))) /
     *   ((NBUFF+1) * LRECO * 2)
      ILIM = 204800 / NBUFF
      LENBU = MIN (ILIM, LENBU)
C                                       Set number pre sorted.
      NSORT = NBUFF * LENBU
      IN = 1
      OUT = IN + LRECO * LENBU + NBPS
C                                       Make sure scratch files are
C                                       two buffers larger than nec.
      CALL UVSIZE (LRECO, NVIS, ISIZE)
      CALL SCREAT (ISIZE, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (8)
         JERR = 2
         GO TO 999
         END IF
      CALL SCREAT (ISIZE, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         JERR = 2
         GO TO 999
         END IF
C                                       Open input file.
      LUN1 = 16
      CALL ZPHFIL ('UV', DISKIN, FCNO(1), 1, PHNAME, IERR)
      CALL ZOPEN (LUN1, IND1, DISKIN, PHNAME, T, F, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         CALL MSGWRT (8)
         JERR = 3
         GO TO 999
         END IF
C                                       Open output file.
      LUN2 = 17
      CALL ZPHFIL ('SC', SCRVOL(1), SCRCNO(1), 1, PHNAME, IERR)
      CALL ZOPEN (LUN2, IND2, SCRVOL(1), PHNAME, T, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1070) IERR
         CALL MSGWRT (8)
         JERR = 3
         GO TO 995
         END IF
C                                       Initialize files, single buffer.
      INIO = LENBU
      IBUFSZ = LREC * 2 * LENBU + 2 * NBPS
      CALL UVINIT ('READ', LUN1, IND1, NVIS, VO, LREC, INIO, IBUFSZ,
     *   BUFFER(IN), BO, BIND1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1080) IERR, 'READ'
         CALL MSGWRT (8)
         JERR = 8
         GO TO 990
         END IF
      IBUFSZ = LRECO * LENBU * 2  +  2 * NBPS
      NIOUT = LENBU
      CALL UVINIT ('WRIT', LUN2, IND2, NVIS, VO, LRECO, NIOUT, IBUFSZ,
     *   BUFFER(OUT), BO, BIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1080) IERR, 'WRIT'
         CALL MSGWRT (8)
         JERR = 8
         GO TO 990
         END IF
C                                       Prepare pointers and counters.
      EOI = F
C                                       Begin loop.
 200  CONTINUE
C                                       Read NBUFF buffers, add keys and
C                                       place in output buffer area.
C                                       Fill output buffer with
C                                       NBUFF input buffers.
         NVSUM = 0
         IPTR2 = OUT + BIND2 - 1
         DO 400 I = 1,NBUFF
            IF (EOI) GO TO 400
            CALL UVDISK ('READ', LUN1, IND1, BUFFER(IN), INIO, BIND1,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1200) 'READ',IERR
               CALL MSGWRT (8)
               JERR = 8
               GO TO 990
               END IF
C                                       Sum no. vis. records
            NVSUM = NVSUM + INIO
            IPTR1 = IN + BIND1 - 1
C                                       Check if all data read.
            IF (INIO.LE.0) EOI = T
            IF (EOI) GO TO 400
C                                       Loop thru input buffer adding
C                                       keys and writing to output
C                                       buffer.  Since AMERGE orders
C                                       by descending values of the keys
C                                       negate keys.
            DO 370 J = 1,INIO
               IKEY = 0
               KKEY = SORT1
C                                        Rotate data if necessary.
               IF (.NOT.NOROT) THEN
                  TEMPU = CROT * BUFFER(IPTR1+ILOCU) -
     *               SROT * BUFFER(IPTR1+ILOCV)
                  TEMPV = SROT * BUFFER(IPTR1+ILOCU) +
     *               CROT * BUFFER(IPTR1+ILOCV)
                  BUFFER(IPTR1+ILOCU) = TEMPU
                  BUFFER(IPTR1+ILOCV) = TEMPV
                  END IF
C                                       Loop thru keys.
               DO 350 KEY = 1,2
C                                       Select key.
                  GO TO (220, 230, 240, 250, 260, 270, 280, 290, 300,
     *               310, 320, 330), KKEY
C                                       Baseline number.
 220                 IF (ILOCB.GE.0) THEN
                        BUFFER(IPTR2+IKEY) = -BUFFER(IPTR1+ILOCB)
                     ELSE
                        BUFFER(IPTR2+IKEY) = -BUFFER(IPTR1+ILOCA2) -
     *                     4096.0 * BUFFER(IPTR1+ILOCA1)
                        END IF
                     GO TO 340
C                                       Time.
 230                 BUFFER(IPTR2+IKEY) = -BUFFER(IPTR1+ILOCT)
                     GO TO 340
C                                       U
 240                 BUFFER(IPTR2+IKEY) = -BUFFER(IPTR1+ILOCU)
                     GO TO 340
C                                       V
 250                 BUFFER(IPTR2+IKEY) = -BUFFER(IPTR1+ILOCV)
                     GO TO 340
C                                       W
 260                 BUFFER(IPTR2+IKEY) = -BUFFER(IPTR1+ILOCW)
                     GO TO 340
C                                       Baseline length.
 270                 XX = BUFFER(IPTR1+ILOCU)
                     YY = BUFFER(IPTR1+ILOCV)
                     BUFFER(IPTR2+IKEY) = -SQRT (XX*XX + YY*YY)
                     GO TO 340
C                                       Baseline PA
 280                 XX = BUFFER(IPTR1+ILOCU)
                     YY = BUFFER(IPTR1+ILOCV)
                     BUFFER(IPTR2+IKEY) = -ATAN2 (YY, XX+1.0E-20)
                     GO TO 340
C                                       Descending ABS(u)
 290                 BUFFER(IPTR2+IKEY) = ABS (BUFFER(IPTR1+ILOCU))
                     GO TO 340
C                                       Descending ABS(v)
 300                 BUFFER(IPTR2+IKEY) = ABS (BUFFER(IPTR1+ILOCV))
                     GO TO 340
C                                       Ascending ABS(u)
 310                 BUFFER(IPTR2+IKEY) = -ABS (BUFFER(IPTR1+ILOCU))
                     GO TO 340
C                                       Ascending ABS(v)
 320                 BUFFER(IPTR2+IKEY) = -ABS (BUFFER(IPTR1+ILOCV))
                     GO TO 340
C                                       Spare
 330                 GO TO 340
C                                       Get set for second key.
 340              IKEY = 1
                  KKEY = SORT2
 350              CONTINUE
C                                       Load rest of record into output
C                                       buffer.
               CALL RCOPY (LREC, BUFFER(IPTR1), BUFFER(IPTR2+2))
C                                       Update pointers.
               IPTR1 = IPTR1 + LREC
               IPTR2 = IPTR2 + LRECO
 370           CONTINUE
 400        CONTINUE
         IF (NVSUM.LE.0) GO TO 520
C                                       Output buffer now loaded ready
C                                       to sort.
         KOUT = OUT + BIND2 - 1
         ILRECO = LRECO
         INVSUM = NVSUM
         CALL ICSORT (BUFFER(KOUT), ILRECO, INVSUM, KEY1, KEY2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1400) IERR
            CALL MSGWRT (8)
            JERR = 4
            GO TO 990
            END IF
C                                       Dump output buffer to disk
C                                       Trick UVDISK by moving buffer
C                                       pointer adjusted to take care
C                                       of unwritten data.
         IBSTRT = BIND2 - 1
         DO 500 I = 1,NBUFF
            IF (NVSUM.LE.0) GO TO 510
            NIOUT = MIN (LENBU, NVSUM)
            NVSUM = NVSUM - NIOUT
            LENIO = (I-1) * LENBU * LRECO  +  IBSTRT
            KOUT = OUT + LENIO - MOD (LENIO, NBPS/2)
            CALL UVDISK ('FLSH', LUN2, IND2, BUFFER(KOUT), NIOUT, BIND2,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1200) 'FLSH', IERR
               CALL MSGWRT (8)
               JERR = 8
               GO TO 990
               END IF
            IF (NIOUT.LE.0) GO TO 510
 500        CONTINUE
C                                        Copy any unwritten data
C                                        to start of buffer.
 510     IF (BIND2.GT.1) CALL RCOPY (BIND2, BUFFER(KOUT), BUFFER(OUT))
C                                       If not finished loop back
         IF (.NOT.EOI) GO TO 200
C                                       Empty buffer.
 520  NIOUT = 0
      IF (BIND2.GT.1) THEN
         CALL UVDISK ('FLSH', LUN2, IND2, BUFFER(KOUT), NIOUT, BIND2,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1200) 'FLSH', IERR
            CALL MSGWRT (8)
            JERR = 8
            END IF
         END IF
C                                       Switch IN and OUT.
      I = IN
      IN = OUT
      OUT = I
C                                       Close files.
 990  CALL ZCLOSE (LUN2, IND2, IERR)
 995  CALL ZCLOSE (LUN1, IND1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('ERROR',I3,' CREATING SCRATCH FILE')
 1060 FORMAT ('INSORT: OPEN ERROR',I3,' ON INPUT FILE')
 1070 FORMAT ('INSORT: OPEN ERROR',I3,' ON SCRATCH FILE')
 1080 FORMAT ('INSORT: INIT ERROR',I3,' ON ',A4)
 1200 FORMAT ('INSORT:',A4,' ERROR',I3)
 1400 FORMAT ('INSORT: ERROR',I3,' DURING INCORE SORT')
      END
      SUBROUTINE UVOUT (JERR)
C-----------------------------------------------------------------------
C   UVOUT copies the data on a scratch file to a catalogd file,
C   removing the keys.
C   Inputs (from common):
C      NAMOUT             C*12 Output file name.
C      CLAOUT             C*6  Output file class.
C      DISOUT             I    Output file disk number.
C      SEQOUT             I    Output file sequence number.
C      SCRVOL(1)          I  Scratch file disk number.
C      SCRCNO(1)          I    Scratch file catalog number
C      LENBU              I    Buffer length in records.
C      LREC               I    Output record length in I   words.
C   Output:
C      JERR               I    Return error code: 0 = OK
C                              8 = I/O error.
C-----------------------------------------------------------------------
      INTEGER   LUN1, LUN2, IND1, IND2, BIND1, BIND2, JERR, IERR,
     *   IBUFSZ, LRECIN, NIOUT, IPTR2, INIO, IPTR1, I, BO, VO, NF, RW
      LOGICAL   T
      CHARACTER PHNAME*48
      INCLUDE 'UVSRT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T /.TRUE./
      DATA LUN1, LUN2 /16, 17/
      DATA BO, VO /1, 0/
C-----------------------------------------------------------------------
C                                       Kill second SC file
      RW = 2
      NF = 1
      CALL MAPCLR (NF, SCRVOL(2), SCRCNO(2), RW, BUFFER)
C                                       Deferred creation
      IF (DEFER.GT.0.0) THEN
         CALL COPY (256, CATSAV, CATBLK)
         CALL CREOUT (JERR)
         IF (JERR.NE.0) GO TO 999
         END IF
      JERR = 8
C                                       Open files
      CALL ZPHFIL ('UV', DISOUT, FCNO(2), 1, PHNAME, IERR)
      CALL ZOPEN (LUN2, IND2, DISOUT, PHNAME, T, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'WRIT'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL ZPHFIL ('SC', SCRVOL(1), SCRCNO(1), 1, PHNAME, IERR)
      CALL ZOPEN (LUN1, IND1, SCRVOL(1), PHNAME, T, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR,' READ'
         CALL MSGWRT (8)
         GO TO 995
         END IF
C                                       Init files, output first.
      IBUFSZ = BUFSZ / 2
      IN = 1
      OUT = IBUFSZ / 2 + 1
      LRECIN = LREC + 2
      NIOUT = LENBU
      CALL UVINIT ('WRIT', LUN2, IND2, NVIS, VO, LREC, NIOUT, IBUFSZ,
     *   BUFFER(OUT), BO, BIND2, IERR)
      IPTR2 = BIND2 + (OUT-1)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR, 'WRIT'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       Init input file.
      INIO = LENBU
      CALL UVINIT ('READ', LUN1, IND1, NVIS, VO, LRECIN, INIO, IBUFSZ,
     *   BUFFER(IN), BO, BIND1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR, 'READ'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       Begin loop
 100  CONTINUE
         CALL UVDISK ('READ', LUN1, IND1, BUFFER(IN), INIO, BIND1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) 'READ',IERR
            CALL MSGWRT (8)
            GO TO 990
            END IF
         IPTR1 = BIND1 + 1 + IN
C                                       Copy to output.
         IF (INIO.GT.0) THEN
            DO 150 I = 1,INIO
               CALL RCOPY (LREC, BUFFER(IPTR1), BUFFER(IPTR2))
C                                       Update pointers
               IPTR1 = IPTR1 + LRECIN
               IPTR2 = IPTR2 + LREC
 150           CONTINUE
            NIOUT = INIO
            CALL UVDISK ('WRIT', LUN2, IND2, BUFFER(OUT), NIOUT, BIND2,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1100) 'WRIT', IERR
               CALL MSGWRT (8)
               GO TO 990
               END IF
            IPTR2 = BIND2 + (OUT-1)
C                                       Loop back for next buffer.
            GO TO 100
            END IF
C                                       Finish write.
      NIOUT = 0
      CALL UVDISK ('FLSH', LUN2, IND2, BUFFER(OUT), NIOUT, BIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1100) 'FLSH', IERR
         CALL MSGWRT (8)
         END IF
C                                       Close files.
 990  IF (IERR.EQ.0) JERR = 0
      CALL ZCLOSE (LUN1, IND1, IERR)
 995  CALL ZCLOSE (LUN2, IND2, IERR)
C                                       Kill first SC file
      RW = 2
      NF = 1
      CALL MAPCLR (NF, SCRVOL(1), SCRCNO(1), RW, BUFFER)
      NSCR = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVOUT: ERROR',I3,' OPEN FOR ',A4)
 1020 FORMAT ('UVOUT: ERROR',I3,' INIT FOR ',A4)
 1100 FORMAT ('UVOUT:',A4,' ERROR ',I3)
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QGASUB (MODL, U, VS, INCVS, INCF, INCS, NCOMP, NVIS,
     *   NF, NS, FLAG)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Subtract Gaus. model vis. from uv data.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Vector compiler version
C   Subtracts the model visibility derived from Gaussian components from
C   visibility records.  Arbitrary numbers of frequencies and
C   polarizations can be processed.
C   Inputs:
C      MODL   I  Base address of Gaussian components, increment=12
C                0 = used (model amplitude)
C                1 = used (PHASE)
C                2 = used (REAL)
C                3 = used (IMAG)
C                4 = -2 * PI * X (radians)
C                5 = -2 * PI * Y
C                6 = -2 * PI * Z
C                7 = A = -0.5*((COS(PA)*SIG(MAJ))**2 +
C                        (SIN(PA)*SIG(MIN))**2)
C                8 = B = -0.5*((SIN(PA)*SIG(MAJ))**2 +
C                        (COS(PA)*SIG(MIN))**2)
C                9 = C = -(SIN(PA)*COS(PA)*
C                         (SIG(MAJ)**2 - SIG(MIN)**2)
C               10 = Amplitude
C               11 = used (MAMP)
C      U     I  Base address of U's, assumed followed by V, W
C      VS    I  Base address of vis rec. (real, imag, wt)
C      INCVS I  Increment of VS for next visibility
C      INCF  I  Increment of VS for next frequency
C      INCS  I  Increment of VS for next Stokes (RR or LL)
C      NCOMP I  Number of Gaussian components.
C      NVIS  I  Number of visibilities.
C      NF    I  Number of frequencies.
C      NS    I  Number of Stokes (usually 1 or 2)
C      FLAG  I  If FLAG < 0 multiply model vis by i (SQRT(-1))
C   Also uses AP locations 0 and 1 and expects an array of length NS
C   beginning in location 2+NF composed of the correlator factors.
C   Beginning in location 2 should be an array of length NF :
C              Freq(0) / Freq(ref) - 1.0
C              Freq(1) / Freq(0)   - 1.0
C                      .
C                      .
C                      .
C              Freq(NF-1) / Freq(NF-2) - 1.0
C   Note: all addresses are 0 relative and needed to be incremented by
C   1 to work in Fortran.
C   Note: the important loops to vectorize are 50,90,100,125 and 130.
C   Calls QRECT.
C-----------------------------------------------------------------------
      INTEGER   MODL, U, VS, INCVS, INCS, INCF, NCOMP, NVIS, NF, NS,
     *   PHASE, REAL, IMAG, X, JVS, F, IU, IVS, IF,
     *   IV, FLAG, S, IS, JX, JPHAS, JAMP, ICOMP, LOOP, KAMP,
     *   KREAL, A, JA, AMP, MAMP, JMAMP
      REAL   FREQF, SUMRE, SUMIM, REMOD, IMMOD, WT, TEMP
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                        Make sure that there is data.
      IF ((NCOMP.LE.0) .OR. (NVIS.LE.0) .OR. (NF.LE.0) .OR.
     *   (NS.LE.0))  GO TO 999
C                                       Setup array addresses
      PHASE = MODL + 1
      REAL = PHASE + 1
      IMAG = REAL + 1
      X = IMAG + 1
      A = MODL + 7
      AMP = MODL + 10
      MAMP = MODL + 11
      IU = U
      IVS = VS
C                                       Begin visibility loop
      DO 300 IV = 1,NVIS
C                                       Compute phase and amp factor
C                                       at ref. freq.
         JX = X + 1
         JA = A + 1
         JPHAS = PHASE + 1
         JMAMP = MAMP + 1
C@DIR IGNORE RECRDEPS(APCORE)
         DO 50 LOOP = 1,NCOMP
C                                       Phase
            APCORE(JPHAS) = APCORE(JX) * APCORE(IU+1)
     *                    + APCORE(JX+1) * APCORE(IU+2)
     *                    + APCORE(JX+2) * APCORE(IU+3)
C                                       Amplitude
            APCORE(JMAMP) = APCORE(JA) * APCORE(IU+2) * APCORE(IU+2)
     *                    + APCORE(JA+1) * APCORE(IU+1) * APCORE(IU+1)
     *                    + APCORE(JA+2) * APCORE(IU+2) * APCORE(IU+1)
C                                       Update pointers.
            JPHAS = JPHAS + 12
            JX = JX + 12
            JMAMP = JMAMP + 12
            JA = JA + 12
 50         CONTINUE
C                                        Get ready for freq. loop.
         JVS = IVS
         F = 2
         S = NF + 2
         FREQF = 1.0
C                                        Begin frequency loop.
         DO 200 IF = 1,NF
C                                       Loop over component
            KREAL = MODL + 2
C                                       Check scaling
            IF (ABS (APCORE(F+1)).GT.1.0E-20) GO TO 110
C                                       Finish amplitudes
               JMAMP = MAMP + 1
               JAMP = MODL + 1
               KAMP = AMP + 1
C@DIR IGNORE RECRDEPS(APCORE)
               DO 90 ICOMP = 1,NCOMP
                  APCORE(JAMP) = APCORE(KAMP) * EXP (APCORE(JMAMP))
                  JMAMP = JMAMP + 12
                  JAMP = JAMP + 12
                  KAMP = KAMP + 12
 90               CONTINUE
C                                       Convert to polar
               JAMP = MODL
               CALL QRECT (JAMP, 12, KREAL, 12, NCOMP)
               GO TO 130
C                                       Subsequent frequency
 110           FREQF = 1.0 + APCORE(F+1)
C                                       Scale frequency
               JMAMP = MAMP + 1
               JPHAS = PHASE + 1
C@DIR IGNORE RECRDEPS(APCORE)
               DO 120 ICOMP = 1,NCOMP
                  APCORE(JPHAS) = FREQF * APCORE(JPHAS)
                  APCORE(JMAMP) = FREQF * FREQF * APCORE(JMAMP)
                  JPHAS = JPHAS + 12
                  JMAMP = JMAMP + 12
 120              CONTINUE
C                                       Finish amplitudes
               JMAMP = MAMP + 1
               JAMP = MODL + 1
               KAMP = AMP + 1
C@DIR IGNORE RECRDEPS(APCORE)
               DO 125 ICOMP = 1,NCOMP
                  APCORE(JAMP) = APCORE(KAMP) * EXP (APCORE(JMAMP))
                  JMAMP = JMAMP + 12
                  JAMP = JAMP + 12
                  KAMP = KAMP + 12
 125              CONTINUE
C                                       Convert to polar
               JAMP = MODL
               CALL QRECT (JAMP, 12, KREAL, 12, NCOMP)
C                                       Do sum
 130           SUMRE = 0.0
               SUMIM = 0.0
               REAL = MODL + 3
               IMAG = MODL + 4
C@DIR IGNORE RECRDEPS(APCORE)
               DO 140 ICOMP = 1,NCOMP
                  SUMRE = SUMRE + APCORE(REAL)
                  SUMIM = SUMIM + APCORE(IMAG)
                  REAL = REAL + 12
                  IMAG = IMAG + 12
 140              CONTINUE
C                                       Correct visibility
            JA = JVS + 1
C                                        Setup
            REMOD = SUMRE
            IMMOD = SUMIM
            IF (FLAG.LT.0) REMOD = -SUMIM
            IF (FLAG.LT.0) IMMOD = SUMRE
C                                       Loop over Stokes' (1 or 2,
C                                       no point in vectorizing)
            DO 150 IS = 1,NS
C                                       Subtract model
               APCORE(JA) = APCORE(JA) - REMOD * APCORE(S+IS)
               APCORE(JA+1) = APCORE(JA+1) - IMMOD * APCORE(S+IS)
               JA = JA + INCS
 150           CONTINUE
C                                        Update vis pointer.
            JVS = JVS + INCF
            F = F + 1
 200        CONTINUE
C                                        Update pointers.
         IVS = IVS + INCVS
         IU = IU + INCVS
 300     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ALIASA (AARRAY)
C-----------------------------------------------------------------------
C! implements antenna aliasing array
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This routine processes a list of specified antennas.  The first
C   antenna specified is to be treated as the alias antenna.  All
C   other antennas on the list are treated as being identical to the
C   first one.  e.g. if AARRAY comes in with 2 3 6 7 0, antennas
C   3,6,7 are treated as if they were actually antenna 2.
C   In/out:
C      AARRAY   I(31)   in: list of antennas to be aliased, 1st <= 0
C                           ends list (no more than 30 > 0)
C                       out: (1) length of alias list incl counter
C                            (2) antenna to which others are aliased
C                            (3:AARRAY(1)) list of antennas aliased to
C                                AARRAY(2)
C-----------------------------------------------------------------------
      INTEGER   AARRAY(31)
C
      INTEGER   I, J
C-----------------------------------------------------------------------
C                                       first element MUST be positive
      IF (AARRAY(1).LE.0) GO TO 999
C                                       find first nonpositive entry
      DO 10 I = 1,30
         IF (AARRAY(I).LE.0) GO TO 15
 10      CONTINUE
      I = 31
C                                       shift up entries one notch
 15   DO 20 J = I,2,-1
         AARRAY(J) = AARRAY(J-1)
 20      CONTINUE
C                                       count positive entries
      AARRAY(1) = 0
      DO 30 I = 2,31
         IF (AARRAY(I).GT.0) AARRAY(1) = AARRAY(1) + 1
 30      CONTINUE
C                                       include counter itself
      AARRAY(1) = AARRAY(1) + 1
C
 999  RETURN
      END

      SUBROUTINE REFSET (IS, JS, LCHAN, NUMBL, MAXTEL, MAXPOL, MAXIFS,
     *   SPCWT, REFANT)
C-----------------------------------------------------------------------
C! Finds a reference antenna from all channels, IFs, antennas
C# UV UV-util Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Look over all channels to find antenna with max weight
C   Inputs:
C      IS       I(*)   First ant. of baseline numbers
C      JS       I(*)   2nd ant. of baseline numbers
C      LCHAN    I      Maximum number of frequency channels.
C      NUMBL    I      Maximum number of baselines
C      MAXTEL   I      Maximum number of antennas
C      MAXPOL   I      Maximum number polarizations
C      MAXIFS   I      Maximum number polarizations
C      SPCWT    R(*)   Weights (LCHAN,NUMBL,MAXPOL,*),
C   Output
C      REFANT   I      reference antenna suggestion
C-----------------------------------------------------------------------
      INTEGER   IS(*), JS(*), LCHAN, NUMBL, MAXTEL, MAXPOL, MAXIFS,
     *   REFANT
      REAL      SPCWT(LCHAN,NUMBL,MAXPOL,*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   I, J, K, IC, IP, IIF
      DOUBLE PRECISION SWT(MAXANT), WT
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       sum weights
      CALL DFILL (MAXANT, 0.0D0, SWT)
      DO 100 K = 1,NUMBL
         I = IS(K)
         J = JS(K)
         DO 90 IIF = 1,MAXIFS
            DO 80 IP = 1,MAXPOL
               DO 70 IC = 1,LCHAN
                  WT = SPCWT(IC,K,IP,IIF)
                  IF (WT.GT.0.0D0) THEN
                     SWT(I) = SWT(I) + WT
                     SWT(J) = SWT(J) + WT
                     END IF
 70               CONTINUE
 80            CONTINUE
 90         CONTINUE
 100     CONTINUE
C                                       find max
      I = 1
      WT = 0
      DO 120 K = 1,MAXTEL
         IF (SWT(K).GT.WT) THEN
            WT = SWT(K)
            I = K
            END IF
 120     CONTINUE
C
      IF (WT.GT.0.0D0) THEN
         REFANT = I
         WRITE (MSGTXT,1120) REFANT
         CALL MSGWRT (2)
      ELSE
         MSGTXT = 'REFSET FOUND NO VALID DATA'
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1120 FORMAT ('REFSET set the REFANT to',I4)
      END

      SUBROUTINE QGRD7 (APCORE, UV, VIS, WT, GRID, CONX, CONY, CONI,
     *   NO2, M, LROW, INC, NVIS)
C-----------------------------------------------------------------------
C! Convolves real data to beam and sigma**2 grid
C# AP-appl SINGLEDISH
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Convolves real-only visibility data onto a grid, producing a beam in
C   the imaginary part and an estimate of sigma**2 in the real part (sum
C   C*C*W).  A single channel is gridded at a time.  It assumes that NO
C   points lie within one half the convolving function support size of
C   the outside edge.
C   Inputs:
C      UV    I  Location of (u,v) values in cells, uniform weight FACTOR
C      VIS   I  Location of (complex) visibilities.
C      WT    I  Weight for data. Assumes any tapering
C               has already been done.
C      GRID  I  base address of gridded data.
C               Order assumed to be the following
C               for each of the M rows:
C                1) 2 * LROW visibilities
C      CONX  I  base address of X convolving fn.
C      CONY  I  base address of Y convolving fn.
C               IF CONY = CONX then they both point at a circular array
C      CONI  I  # values / image cell in CONX (was assumed 100)
C      NO2   I  X support radius of convolving function
C      M     I  Y support size (2*radius + 1)
C      LROW  I  length of a (in reals) row ( max. X).
C      INC   I  increment for UV, VIS and WT
C      NVIS  I  number of visibilities to grid.
C   In the above, X refers to rows and y to columns in the gridded data,
C   NOT on the sky.  The total numbers of rows and cells used on a row
C   should be odd. All AP memory I/O values are assumed floating.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   UV, VIS, WT, GRID, CONX, CONY, CONI, NO2, M, LROW, INC,
     *   NVIS
C
      LONGINT   JUV, JVIS, JWT, JGRID, JCONX, JCONY, JCX, JCY, JG, JJCX,
     *   JJLOOP
      INTEGER   IRND,  N, INCR, HAFX, HAFY, IX, IY, OFFS, LINC
      DOUBLE PRECISION RE, RRE, AAIM, X, XX, XWT, Y, AIM, UWT, XCONI
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IRND(XX) = INT (XX + SIGN (0.5D0, XX))
C-----------------------------------------------------------------------
C                                        Convert addresses to 1 rel.
      JUV = UV + PSAPOF
      JVIS = VIS + PSAPOF
      JWT = WT + PSAPOF
      JGRID = GRID + PSAPOF
      JCONX = CONX + PSAPOF
      JCONY = CONY + PSAPOF
      N = NO2 * 2 + 1
      HAFX = LROW / 2 - NO2
      HAFY = -M/2 - 1
      OFFS = HAFX + LROW * HAFY
      INCR = 2 * LROW - 2 * N
      XCONI = CONI
C                                        Loop over visibilities.
C                                        Separable conv functions
      IF (JCONY.NE.JCONX) THEN
      INCLUDE 'INCS:ZVND.INC'
         DO 90 JJLOOP = 1,NVIS
C                                        Check weight.
            XWT = APCORE(JWT)
            UWT = APCORE(JUV+2)
            IF ((XWT.GT.0.0D0) .AND. (UWT.GT.0.0D0)) THEN
C                                        Determine location.
               X = APCORE(JUV+1)
               Y = APCORE(JUV)
C                                        Deter. conv. fn loc.
               JCX = IRND (XCONI * (IRND (X) - X - 0.5D0))
               JCY = IRND (XCONI * (IRND (Y) - Y - 0.5D0))
               JCX = JCX + JCONX + CONI
               JCY = JCY + JCONY + CONI
C                                        Determine grid loc.
               JG = 2 * (IRND (X) + OFFS + IRND (Y) * LROW)
               JG = JG + JGRID
C                                        Save JCX
               JJCX = JCX
C                                        Get visibility
               AIM = XWT * UWT
               RE =  AIM * UWT
C                                        Gridding loop
      INCLUDE 'INCS:ZVND.INC'
               DO 40 IY = 1,M
                  JCX = JJCX
                  RRE = RE * APCORE(JCY) * APCORE(JCY)
                  AAIM = AIM * APCORE(JCY)
      INCLUDE 'INCS:ZVND.INC'
                  DO 20 IX = 1,N
C                                        Sum to grid.
                     APCORE(JG) = APCORE(JG) +
     *                  APCORE(JCX) * APCORE(JCX) * RRE
                     APCORE(JG+1) = APCORE(JG+1) + APCORE(JCX) * AAIM
C                                        Update pointers.
                     JCX = JCX + CONI
                     JG = JG + 2
 20                  CONTINUE
C                                        Update pointers.
                  JCY = JCY + CONI
                  JG = JG + INCR
 40               CONTINUE
               END IF
C                                       Update for next vis.
 80         JUV = JUV + INC
            JVIS = JVIS + INC
            JWT = JWT + INC
 90         CONTINUE
C                                        Precomputed 2D function
      ELSE
         LINC = CONI * M + 1
      INCLUDE 'INCS:ZVND.INC'
         DO 190 JJLOOP = 1,NVIS
C                                        Check weight.
            XWT = APCORE(JWT)
            UWT = APCORE(JUV+2)
            IF ((XWT.GT.0.0D0) .AND. (UWT.GT.0.0D0)) THEN
C                                        Determine location.
               X = APCORE(JUV+1)
               Y = APCORE(JUV)
C                                        Deter. conv. fn loc.
               JCX = IRND (XCONI * (IRND (X) - X - 0.5D0))
               JCY = IRND (XCONI * (IRND (Y) - Y - 0.5D0))
               JCX = JCX + JCONX + CONI
               JCY = (JCY + CONI) * LINC
C                                        Determine grid loc.
               JG = 2 * (IRND (X) + OFFS + IRND (Y) * LROW)
               JG = JG + JGRID
C                                        Save JCX
               JJCX = JCX
C                                        Get visibility
               AIM = XWT * UWT
               RE =  AIM * UWT
C                                        Gridding loop
      INCLUDE 'INCS:ZVND.INC'
               DO 140 IY = 1,M
                  JCX = JJCX + JCY
      INCLUDE 'INCS:ZVND.INC'
                  DO 120 IX = 1,N
C                                        Sum to grid.
                     APCORE(JG) = APCORE(JG) +
     *                  APCORE(JCX)*APCORE(JCX)*RE
                     APCORE(JG+1) = APCORE(JG+1) + APCORE(JCX) * AIM
C                                        Update pointers.
                     JCX = JCX + CONI
                     JG = JG + 2
 120                 CONTINUE
C                                        Update pointers.
                  JCY = JCY + CONI * LINC
                  JG = JG + INCR
 140              CONTINUE
               END IF
C                                       Update for next vis.
 180        JUV = JUV + INC
            JVIS = JVIS + INC
            JWT = JWT + INC
 190        CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZEINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IZERNO, ZEKOLS, ZENUMV, IBLC, ITRC, DOGAUS, ICLIP, PDONE,
     *   REFVAL, REFPIX, REFINC, REFTYP, ABSORP, IRET)
C-----------------------------------------------------------------------
C! Fits Zeeman models to spectra: init ZE table used by ZEMAN
C# Map Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 2013-2017, 2020-2021, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes Zeeman fit (ZE) extension tables.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'WRIT' = create/init for write or read
C                        'READ' = open for read only
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      LUN      I        Logical unit number to use
C   Input/output
C      VER      I        ZE file version
C      CATBLK   I(256)   Catalog header block.
C   Input (create) / output (pre-existing)
C      IBLC     I(2)     BLC of Y,Z plane
C      ITRC     I(2)     TRC of Y,Z plane
C      DOGAUS   I        -1 2-sided derivative, 0 1-sided,
C                        > 0 number of Gaussians (<= 32)
C      ICLIP    R        fit spectra only above ICLIP in I
C      PDONE    I        number of planes with fit attempts
C      REFVAL   D        Reference value for spectral axis
C      REFPIX   R        Reference pixel for spectral axis
C      REFVAL   R        Reference increment for spectral axis
C      REFVAL   C*8      Reference type for spectral axis
C      ABSORP   I        > 0 -> absorption line model: = 1 leakage gain
C                          applies to full Ipol(chan), = 2 leakage gain
C                          applies to Ipol(chan) - continuum (i.e. Vpol
C                          cube from continuum subtracted visibilities)
C   Output:
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      IZERNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      ZEKOLS   I(MAXZEC)   The column pointer array in order:
C                        pixel(2), I peak value, V residual rms, gain,
C                        gain error, field (4), field error(4), #gauss,
C                        amp(4), center(4), width(4)
C      ZENUMV   I(MAXZEC)   Element count in each column.
C      IERR     I        Return error code, 0=>OK, else TABINI or TABIO
C                        error.
C   MAXZEC = 7 only known locally.
C-----------------------------------------------------------------------
      INTEGER   MAXZEC, MAXZEK, MAXGAU
      PARAMETER (MAXZEC = 12)
      PARAMETER (MAXZEK = 12)
      PARAMETER (MAXGAU = 32)
C
      CHARACTER OPCODE*4, REFTYP*8
      INTEGER   BUFFER(*), DISK, CNO, VER, CATBLK(256), LUN, IZERNO,
     *   ZEKOLS(MAXZEC), ZENUMV(MAXZEC), IBLC(2), ITRC(2), DOGAUS,
     *   PDONE, ABSORP, IRET
      REAL      ICLIP, REFPIX, REFINC
      DOUBLE PRECISION REFVAL
C
      HOLLERITH HOLTMP(6)
      CHARACTER TTITLE*56, TITLE(MAXZEC)*24, UNITS(MAXZEC)*8,
     *   KEYW(MAXZEK)*8
      INTEGER   NKEY, NREC, DATP(128,2), NCOL, NTT, DTYP(MAXZEC), NDATA,
     *   KLOCS(MAXZEK), KEYVAL(MAXZEK+6), KEYTYP(MAXZEK), IPOINT, NG,
     *   MSGSAV, I, NC, JERR, JTRIM, II, ITEMP(6)
      REAL      RR
      DOUBLE PRECISION KEYVAD(9), XX
      LOGICAL   DOREAD, NEWFIL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (KEYVAL, KEYVAD), (II, RR), (HOLTMP, ITEMP)
      DATA TTITLE /'AIPS ZEMAN FIT TABLE'/
      DATA DTYP /24, 12, 12, 2*12, 2*0, 14, 3*0, 22/
      DATA TITLE /'PIXEL', 'I PEAK', 'V RMS', 'GAIN', 'ERR GAIN',
     *   'B  FIELD', 'ERR BFLD', 'NGAUS', 'AMPLITUD', 'CENTER', 'WIDTH',
     *   'BASELINE'/
      DATA UNITS /'PIXELS', 2*'JY/BEAM', 2 * ' ', 2*'PIXELS', ' ',
     *   'JY/BEAM', 2*'PIXELS', 'JY/BEAM'/
      DATA KEYW /'YBLC', 'YTRC', 'ZBLC', 'ZTRC', 'DOGAUS', 'PIX_FIT',
     *   'ICLIP', 'REFVALUE', 'REFPIXEL', 'REFINCR', 'REFTYPE',
     *   'ABSORPTN'/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NREC = 500
      NKEY = MAXZEK
      NDATA = MAXZEC
      NCOL = NDATA
      CALL FILL (NDATA, 0, ZEKOLS)
      CALL FILL (NDATA, 0, ZENUMV)
C                                       Fill in types
      IF (.NOT.DOREAD) THEN
         NG = MAX (1, DOGAUS)
         CALL COPY (NDATA, DTYP, DATP(1,2))
         DATP(6,2) = 10 * NG + 2
         DATP(7,2) = 10 * NG + 2
         IF (DOGAUS.GT.0) THEN
            DATP(9,2) = 10 * NG + 2
            DATP(10,2) = 10 * NG + 2
            DATP(11,2) = 10 * NG + 2
            END IF
         END IF
      CALL FNDEXT ('ZE', CATBLK, I)
      IF ((I.GT.0) .AND. (VER.GT.0) .AND. (VER.LE.I)) THEN
         NCOL = 0
         NKEY = 0
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'ZE', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IRET)
      IF (IRET.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'ZEINI', IRET)
         IF ((.NOT.DOREAD) .AND. (IRET.EQ.1)) THEN
            MSGTXT = 'OLD ZE TABLE CANNOT BE WRITTEN, TRY XG2XG'
            CALL MSGWRT (7)
            END IF
         GO TO 990
         END IF
      NEWFIL = IRET.LT.0
      MSGSAV = MSGSUP
C                                       Get number of scans
      IZERNO = BUFFER(5) + 1
      IF (DOREAD) IZERNO = 1
      NKEY = MAXZEK
C                                       File created, initialize
      IF (NEWFIL) THEN
         CALL H2CHR (8, 1, CATBLK(KHBUN), UNITS(3))
C                                       Col. labels.
         DO 10 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IRET)
            IF (IRET.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'ZEINI', IRET)
               GO TO 990
               END IF
C                                       Units
            IF ((I.EQ.9) .AND. (ABSORP.GT.0)) THEN
               CALL CHR2H (8, 'OptDepth', 1, ITEMP)
            ELSE
               CALL CHR2H (8, UNITS(I), 1, ITEMP)
               END IF
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IRET)
            IF (IRET.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'ZEINI', IRET)
               GO TO 990
               END IF
 10         CONTINUE
C                                       Fill in Table title
         NTT = JTRIM (TTITLE)
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       Set keyword values
C                                       yblc
         KLOCS(1) = 1
         KEYTYP(1) = 4
         KEYVAL(1) = IBLC(1)
C                                       ytrc
         KLOCS(2) = 2
         KEYTYP(2) = 4
         KEYVAL(2) = ITRC(1)
C                                       zblc
         KLOCS(3) = 3
         KEYTYP(3) = 4
         KEYVAL(3) = IBLC(2)
C                                       ztrc
         KLOCS(4) = 4
         KEYTYP(4) = 4
         KEYVAL(4) = ITRC(2)
C                                       dogaus
         KLOCS(5) = 5
         KEYTYP(5) = 4
         KEYVAL(5) = DOGAUS
C                                       number done
         PDONE = 0
         KLOCS(6) = 6
         KEYTYP(6) = 4
         KEYVAL(7) = PDONE
C                                       clip value
         KLOCS(7) = 7
         KEYTYP(7) = 1
         KEYVAD(4) = ICLIP
C                                       ref value
         KLOCS(8) = 9
         KEYTYP(8) = 1
         KEYVAD(5) = REFVAL
C                                       ref pixel
         KLOCS(9) = 11
         KEYTYP(9) = 1
         KEYVAD(6) = REFPIX
C                                       ref incr
         KLOCS(10) = 13
         KEYTYP(10) = 1
         KEYVAD(7) = REFINC
C                                       ref type
         KLOCS(11) = 15
         KEYTYP(11) = 3
         CALL CHR2H (8, REFTYP, 1, KEYVAL(15))
C                                       absorption
         KLOCS(12) = 17
         KEYTYP(12) = 4
         KEYVAL(17) = ABSORP
C                                       Only write if just created.
         CALL TABKEY ('WRIT', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IRET)
         IF ((IRET.GE.1) .AND. (IRET.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'ZEINI', IRET)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         MSGSUP = 32000
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IRET)
         MSGSUP = MSGSAV
         IF ((IRET.GE.1) .AND. (IRET.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'ZEINI', IRET)
            GO TO 990
            END IF
C                                       Retrieve keyword values
C                                       yblc
         IBLC(1) = 0
         IPOINT = KLOCS(1)
         IF (IPOINT.GT.0) IBLC(1) = KEYVAL(IPOINT)
C                                       ytrc
         ITRC(1) = 0
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) ITRC(1) = KEYVAL(IPOINT)
C                                       zblc
         IBLC(2) = 0
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) IBLC(2) = KEYVAL(IPOINT)
C                                       ytrc
         ITRC(2) = 0
         IPOINT = KLOCS(4)
         IF (IPOINT.GT.0) ITRC(2) = KEYVAL(IPOINT)
C                                       DOGAUS
         DOGAUS = 1
         IPOINT = KLOCS(5)
         IF (IPOINT.GT.0) DOGAUS = KEYVAL(IPOINT)
C                                       pixels fit
         PDONE = 0
         IPOINT = KLOCS(6)
         IF (IPOINT.GT.0) PDONE = KEYVAL(IPOINT)
C                                       clip level
         ICLIP = 0.0
         IPOINT = KLOCS(7)
         IF (IPOINT.GT.0) THEN
            CALL RCOPY (NWDPDP, KEYVAL(IPOINT), XX)
            ICLIP = XX
            END IF
C                                       ref value
         CALL RCOPY (NWDPDP, CATBLK(2*KDCRV-1), XX)
         IPOINT = KLOCS(8)
         IF (IPOINT.GT.0) CALL RCOPY (NWDPDP, KEYVAL(IPOINT), XX)
         REFVAL = XX
C                                       ref pixel
         IPOINT = KLOCS(9)
         IF (IPOINT.GT.0) THEN
            CALL RCOPY (NWDPDP, KEYVAL(IPOINT), XX)
            REFPIX = XX
         ELSE
            II = CATBLK(KRCRP)
            REFPIX = RR
            END IF
C                                       ref incr
         IPOINT = KLOCS(10)
         IF (IPOINT.GT.0) THEN
            CALL RCOPY (NWDPDP, KEYVAL(IPOINT), XX)
            REFINC = XX
         ELSE
            II = CATBLK(KRCIC)
            REFINC = RR
            END IF
C                                       ref type
         IPOINT = KLOCS(11)
         IF (IPOINT.GT.0) THEN
            CALL H2CHR (8, 1, KEYVAL(IPOINT), REFTYP)
         ELSE
            CALL H2CHR (8, 1, CATBLK(KHCTP), REFTYP)
            END IF
C                                       absorption
         ABSORP = 0
         IPOINT = KLOCS(12)
         IF (IPOINT.GT.0) ABSORP = KEYVAL(IPOINT)
         END IF
      IRET = 0
C                                      Get array indices
C                                      Cover your ass from FNDCOL -
C                                      close to flush the buffers and
C                                      then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KEYVAL, BUFFER, IRET)
      IF (IRET.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'ZEINI', IRET)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'ZE', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IRET)
      IF (IRET.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'ZEINI', IRET)
         GO TO 990
         END IF
      CALL FNDCOL (NDATA, TITLE, 24, .TRUE., BUFFER, ZEKOLS, JERR)
C                                      Get array indices and no. values
      DO 150 I = 1,NDATA
         IPOINT = ZEKOLS(I)
         IF (IPOINT.GT.0) THEN
            ZEKOLS(I) = DATP(IPOINT,1)
            ZENUMV(I) = DATP(IPOINT,2) / 10
            IF (ZENUMV(I).LE.0) THEN
               NC = JTRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               IF (I.NE.3) CALL MSGWRT (6)
               END IF
         ELSE
            ZEKOLS(I) = -1
            ZENUMV(I) = 0
            NC = JTRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            IF (I.NE.3) CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ZEINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('ZEINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('ZEINI: ERROR INITIALIZING GAUSS-FIT TABLE FOR ',A)
      END

      SUBROUTINE AU6D (BRANCH)
C-----------------------------------------------------------------------
C! verbs to do image statistics in blotch regions: TVSTAT, IMSTAT
C# POPS-appl TV-appl Map-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2003, 2005, 2007-2010, 2012-2014, 2016,
C;  Copyright (C) 2018, 2021, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AU6D performs the function of obtaining the image rms and mean
C   with an option to set blotch areas on the TV first
C   BRANCH = 1 : TVSTAT   TV blotch, then get statistics
C            2 : IMSTAT   no TV function, just statistics
C   Adverbs: output (TVSTAT and IMSTAT)
C      PIXRMS   :  rms over specified area
C      PIXAVG   :  mean over specified area
C   Inputs:  (IMSTAT only - usual INNAME et al, BLC, TRC)
C      The name and corners for TVSTAT are taken from the TV
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      INTEGER   MPOLY
      PARAMETER (MPOLY=50)
C
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER STRING*20, PRGNAM*6, LLCHAR(5)*4, XXCHAR*4, BUN2*4,
     *   MMCHAR(5)*4, SNAME*12, SCLAS*6, STYPE*2, BUNITS*8, CDUM*1
      INTEGER   POTERR, IERR, NPOLY, BUF(MABFSS), USID, IVOL, SEQNO,
     *   DLUN, DIND, CNO, NX, NY, I, J, WIN(4), IOFF, IG, NVERT(MPOLY),
     *   XV(10*MPOLY), YV(10*MPOLY), MV, I1U, I2U, I3U, I4U, I5U, I6U,
     *   I7U, I1L, I2L, I3L, I4L, I5L, I6L, I7L, IX, IY, I3, I4, I5, I6,
     *   I7, JJ, DEPTH(5), BLKOF, LNX, IXL(MPOLY), IXU(MPOLY), IBP,
     *   ITEMP, MAXDEP(7), MINDEP(7), ICH, ILEN, IBUFSZ, IDUM(2),
     *   IROUND, JTRIM
      LOGICAL   T, F, DOIT, ADOIT, DOINV, CIRCLE, XDOIT, TVOPN, MAOPN
      REAL      LBLC(7), LTRC(7), RBUF(MABFSS), X, Y, AREAI, AREA,
     *   RDUM(2), XC, YC, RC, RX1, RX2, DOALL
      DOUBLE PRECISION S, S2, Z, ZMAX, SKYPOS(3), ZMIN, NZ, SW
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /AIPSCR/ RBUF
      EQUIVALENCE (BUF, RBUF)
      DATA PRGNAM /'AU6D  '/
      DATA T, F /.TRUE.,.FALSE./
      DATA DLUN /16/
      DATA LLCHAR, MMCHAR /'LL  ','RA  ','RA--','GLON','ELON',
     *   'MM  ','DEC ','DEC-','GLAT','ELAT'/
C-----------------------------------------------------------------------
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.2)) GO TO 999
      IBUFSZ = 2 * MABFSS
      CALL ADVERB ('DOINVERS', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      DOINV = RDUM(1).GT.0.0
      CALL ADVERB ('DOALL', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      DOALL = RDUM(1)
      TVOPN = F
      MAOPN = F
C
      GO TO (100, 200), BRANCH
C-----------------------------------------------------------------------
C                                       TVSTAT
C-----------------------------------------------------------------------
 100  CALL TVOPEN (BUF, IERR)
      IF (IERR.NE.0) GO TO 980
      TVOPN = T
      IG = MIN (3, NGRAPH)
C                                       check TV state
      IF ((TVLIMG(1).NE.TVLIMG(2)) .OR. (TVLIMG(1).NE.TVLIMG(3)) .OR.
     *   (TVLIMG(1).NE.TVLIMG(4))) THEN
         POTERR = 77
         GO TO 900
         END IF
C                                       do interactive polygons
      NPOLY = 0
      CALL GRPOLY (MPOLY, IG, NPOLY, NVERT, XV, YV, BUF, IERR)
      IF ((IERR.NE.0) .OR. (NPOLY.LE.0)) THEN
         POTERR = 49
         IF (IERR.EQ.0) THEN
            POTERR = 101
            MSGTXT = 'NO BLOTCH REGIONS WERE SPECIFIED'
            CALL MSGWRT (8)
            END IF
         GO TO 900
         END IF
C                                       close TV
      CALL TVCLOS (BUF, IERR)
      IF (IERR.EQ.0) TVOPN = F
      I3L = MAX (1, CATBLK(IIDEP))
      I4L = MAX (1, CATBLK(IIDEP+1))
      I5L = MAX (1, CATBLK(IIDEP+2))
      I6L = MAX (1, CATBLK(IIDEP+3))
      I7L = MAX (1, CATBLK(IIDEP+4))
      CALL COPY (4, CATBLK(IIWIN), WIN)
      USID = CATBLK(KIIMU)
      IVOL = CATBLK(IIVOL)
      SEQNO = CATBLK(KIIMS)
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), SNAME)
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), SCLAS)
      STYPE = 'MA'
      POTERR = 33
      CALL MAPOPN ('READ', IVOL, SNAME, SCLAS, SEQNO, STYPE, USID, DLUN,
     *    DIND, CNO, CATBLK, BUF, IERR)
      IF (IERR.GT.1) GO TO 900
      MAOPN = T
      IF (IERR.EQ.1) GO TO 900
C                                       number of vertices
      MV = 0
      DO 115 I = 1,NPOLY
         MV = MV + NVERT(I)
 115     CONTINUE
      I1U = 1
      I2U = 1
      I1L = 2048
      I2L = 2048
      DO 120 I = 1,MV
         I1L = MIN (I1L, XV(I))
         I1U = MAX (I1U, XV(I))
         I2L = MIN (I2L, YV(I))
         I2U = MAX (I2U, YV(I))
 120     CONTINUE
      I3U = I3L
      I4U = I4L
      I5U = I5L
      I6U = I6L
      I7U = I7L
      IF (DOINV) THEN
         I1L = WIN(1)
         I2L = WIN(2)
         I1U = WIN(3)
         I2U = WIN(4)
         END IF
      GO TO 220
C-----------------------------------------------------------------------
C                                       IMSTAT
C                                       from disk only
C-----------------------------------------------------------------------
C                                       Open the map
 200  CALL ADVERB ('INDISK', 'I', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IVOL = IDUM(1)
      CALL ADVERB ('INSEQ', 'I', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      SEQNO = IDUM(1)
      USID = NLUSER
      STYPE = 'MA'
      POTERR = 33
      CALL ADVERB ('INNAME', 'C', 1, 12, IDUM, RDUM, SNAME)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INCLASS', 'C', 1, 6, IDUM, RDUM, SCLAS)
      IF (ERRNUM.NE.0) GO TO 980
      CALL MAPOPN ('READ', IVOL, SNAME, SCLAS, SEQNO, STYPE, USID, DLUN,
     *    DIND, CNO, CATBLK, BUF, IERR)
      IF (IERR.GT.1) GO TO 980
      MAOPN = T
      IF (IERR.EQ.1) GO TO 900
C                                       Basic window
      CALL ADVERB ('BLC', 'R', 7, 0, IDUM, LBLC, CDUM)
      IF (ERRNUM.NE.0) GO TO 900
      CALL ADVERB ('TRC', 'R', 7, 0, IDUM, LTRC, CDUM)
      IF (ERRNUM.NE.0) GO TO 900
C                                       circular?
      JJ = IROUND (LBLC(1))
      CIRCLE = JJ.EQ.-1
      IF (CIRCLE) THEN
         RC = LBLC(2)
         XC = LTRC(1)
         YC = LTRC(2)
         LBLC(1) = XC - RC
         LTRC(1) = XC + RC
         LBLC(2) = YC - RC
         LTRC(2) = YC + RC
         END IF
      POTERR = 101
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), LBLC, LTRC, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       loop limits
      IF (DOINV) THEN
         I7L = 1
         I6L = 1
         I5L = 1
         I4L = 1
         I3L = 1
         I2L = 1
         I1L = 1
         I7U = MAX (1, CATBLK(KINAX+6))
         I6U = MAX (1, CATBLK(KINAX+5))
         I5U = MAX (1, CATBLK(KINAX+4))
         I4U = MAX (1, CATBLK(KINAX+3))
         I3U = MAX (1, CATBLK(KINAX+2))
         I2U = MAX (1, CATBLK(KINAX+1))
         I1U = MAX (1, CATBLK(KINAX))
      ELSE
         I7L = LBLC(7) + 0.01
         I6L = LBLC(6) + 0.01
         I5L = LBLC(5) + 0.01
         I4L = LBLC(4) + 0.01
         I3L = LBLC(3) + 0.01
         I2L = LBLC(2) + 0.01
         I1L = LBLC(1) + 0.01
         I7U = LTRC(7) + 0.01
         I6U = LTRC(6) + 0.01
         I5U = LTRC(5) + 0.01
         I4U = LTRC(4) + 0.01
         I3U = LTRC(3) + 0.01
         I2U = LTRC(2) + 0.01
         I1U = LTRC(1) + 0.01
         END IF
C                                       SO DO IT
 220  S = 0.0D0
      S2 = 0.0D0
      SW = 0.0D0
      NZ = 0.0D0
      ZMAX = -1.0D15
      ZMIN = 1.0D15
      WIN(1) = I1L
      WIN(2) = I2L
      WIN(3) = I1U
      WIN(4) = I2U
      NX = CATBLK(KINAX)
      NY = CATBLK(KINAX+1)
      POTERR = 50
      DO 295 I7 = I7L,I7U
      DO 294 I6 = I6L,I6U
      DO 293 I5 = I5L,I5U
      DO 292 I4 = I4L,I4U
      DO 291 I3 = I3L,I3U
         DOIT = ((I7.LT.LBLC(7)) .OR. (I7.GT.LTRC(7))
     *      .OR. (I6.LT.LBLC(6)) .OR. (I6.GT.LTRC(6))
     *      .OR. (I5.LT.LBLC(5)) .OR. (I5.GT.LTRC(5))
     *      .OR. (I4.LT.LBLC(4)) .OR. (I4.GT.LTRC(4))
     *      .OR. (I3.LT.LBLC(3)) .OR. (I3.GT.LTRC(3)))
     *      .AND. (BRANCH.EQ.2)
         DEPTH(1) = I3
         DEPTH(2) = I4
         DEPTH(3) = I5
         DEPTH(4) = I6
         DEPTH(5) = I7
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), DEPTH, BLKOF, IERR)
         BLKOF = BLKOF + 1
C                                       Initialize for read:
         CALL MINIT ('READ', DLUN, DIND, NX, NY, WIN, BUF, IBUFSZ,
     *      BLKOF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1220) IERR
            CALL MSGWRT (8)
            GO TO 900
            END IF
         DO 290 IY = I2L,I2U
            CALL MDISK ('READ', DLUN, DIND, BUF, IBP, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1225) IERR
               CALL MSGWRT (8)
               GO TO 900
               END IF
C                                       set interior segment list
            LNX = 1
            IXL(1) = I1L
            IXU(1) = I1U
            ADOIT = .FALSE.
            IF (BRANCH.EQ.2) THEN
               IF (DOINV) THEN
                  ADOIT = (DOIT) .OR. (IY.LT.LBLC(2)) .OR.
     *               (IY.GT.LTRC(2))
                  END IF
               IF (CIRCLE) THEN
                  RDUM(1) = RC*RC - (IY-YC)**2
                  RDUM(1) = SQRT (MAX(0.0, RDUM(1)))
                  RX1 = XC - RDUM(1)
                  RX2 = XC + RDUM(1)
               ELSE
                  RX1 = LBLC(1)
                  RX2 = LTRC(1)
                  END IF
               END IF
C                                       loop over polygons
            IF (BRANCH.NE.2) THEN
               CALL BLTLIS (1, 1, NPOLY, NVERT, XV, YV, IY, LNX, IXL,
     *            IXU)
               IF ((LNX.LE.0) .AND. (.NOT.DOINV)) GO TO 290
               END IF
C                                       loop over row
            IOFF = IBP - I1L
            DO 285 IX = I1L,I1U
               IF (RBUF(IOFF+IX).NE.FBLANK) THEN
C                                       Inside a blotch?
                  XDOIT = ADOIT
                  IF (.NOT.XDOIT) THEN
                     IF (BRANCH.EQ.2) THEN
                        IF (DOINV) THEN
                           XDOIT = (IX.LT.RX1) .OR. (IX.GT.RX2)
                        ELSE
                           XDOIT = (IX.GE.RX1) .AND. (IX.LE.RX2)
                           END IF
                     ELSE
                        DO 275 I = 1,LNX
                           IF ((IX.GE.IXL(I)). AND. (IX.LE.IXU(I)))
     *                        XDOIT = .TRUE.
 275                       CONTINUE
C                                       in blotch
                        IF (XDOIT) THEN
                           XDOIT = .NOT.DOINV
C                                       not in blotch
                        ELSE
                           XDOIT = DOINV
                           END IF
                        END IF
                     END IF
C                                       Add it in
                  IF (XDOIT) THEN
                     IF ((RBUF(IOFF+IX).NE.0.0) .OR. (DOALL.GT.0.0))
     *                  THEN
                        IF (RBUF(IOFF+IX).EQ.0.0) NZ = NZ + 1
                        Z = RBUF(IOFF+IX)
                        S = S + Z
                        S2 = S2 + Z * Z
                        SW = SW + 1.0D0
                        IF (Z.GT.ZMAX) THEN
                           ZMAX = Z
                           CALL COPY (5, DEPTH, MAXDEP(3))
                           MAXDEP(1) = IX
                           MAXDEP(2) = IY
                           END IF
                        IF (Z.LT.ZMIN) THEN
                           ZMIN = Z
                           CALL COPY (5, DEPTH, MINDEP(3))
                           MINDEP(1) = IX
                           MINDEP(2) = IY
                           END IF
                    ELSE
                       NZ = NZ + 1.0D0
                       END IF
                     END IF
                  END IF
 285           CONTINUE
 290        CONTINUE
 291     CONTINUE
 292     CONTINUE
 293     CONTINUE
 294     CONTINUE
 295     CONTINUE
C                                       no data
      POTERR = 24
      IF (SW.LE.0) THEN
         WRITE (MSGTXT,1295)
         CALL MSGWRT (8)
         GO TO 900
         END IF
C                                       Print results
      S = S / SW
      S2 = S2 / SW - S * S
      IF (S2.LT.0.0D0) S2 = 0.0D0
      S2 = SQRT (S2)
      RDUM(1) = S
      CALL ADVRBS ('PIXAVG', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 900
      RDUM(1) = S2
      CALL ADVRBS ('PIXSTD', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 900
      RDUM(1) = ZMAX
      CALL ADVRBS ('PIXVAL', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 900
      RDUM(1) = ZMIN
      CALL ADVRBS ('PIX2VAL', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 900
      CALL ADVRBS ('PIXXY', 'I', 7, 0, MAXDEP, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 900
      CALL ADVRBS ('PIX2XY', 'I', 7, 0, MINDEP, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 900
      CALL H2CHR (8, 1, CATH(KHBUN), BUNITS)
      WRITE (MSGTXT,1300) S, S2, BUNITS, SW
      CALL MSGWRT (5)
      IF (DOALL.GT.0.0) THEN
         WRITE (MSGTXT,1303) NZ
      ELSE
         WRITE (MSGTXT,1304) NZ
         END IF
      IF (NZ.GT.0) CALL MSGWRT (5)
      WRITE (MSGTXT,1301) ZMAX, MAXDEP
      CALL MSGWRT (5)
      LOCNUM = 1
      CALL SETLOC (MAXDEP(3), .FALSE.)
      X = MAXDEP(1)
      Y = MAXDEP(2)
      CALL XYVAL (X, Y, SKYPOS(1), SKYPOS(2), SKYPOS(3), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1305) IERR
         CALL MSGWRT (7)
      ELSE
         IF ((AXTYP(LOCNUM).EQ.2) .OR. (AXTYP(LOCNUM).EQ.3)) CALL AXSTRN
     *      (CTYP(3,LOCNUM), SKYPOS(3), KLOCA(LOCNUM), NCHLAB(1,LOCNUM),
     *      SAXLAB(1,LOCNUM))
         WRITE (MSGTXT,1302)
         ICH = 9
         DO 310 I = 1,2
            ITEMP = I - 1
            CALL AXSTRN (CTYP(I,LOCNUM), SKYPOS(I), ITEMP, ILEN, STRING)
            MSGTXT(ICH:) = STRING(:ILEN)
            ICH = ICH + ILEN + 2
 310        CONTINUE
         CALL MSGWRT (5)
         END IF
C                                       Secondary axes
      IF ((NCHLAB(1,LOCNUM).GT.0) .OR. (NCHLAB(2,LOCNUM).GT.0)) THEN
         WRITE (MSGTXT,1302)
         ICH = 9
         DO 315 I = 1,2
            IF (NCHLAB(I,LOCNUM).GT.0) THEN
               MSGTXT(ICH:) = SAXLAB(I,LOCNUM)(:NCHLAB(I,LOCNUM))
               ICH = ICH + NCHLAB(I,LOCNUM) + 2
               END IF
 315        CONTINUE
         CALL MSGWRT (5)
         END IF
C                                       Minimum
      WRITE (MSGTXT,1320) ZMIN, MINDEP
      CALL MSGWRT (5)
      CALL SETLOC (MINDEP(3), .FALSE.)
      X = MINDEP(1)
      Y = MINDEP(2)
      CALL XYVAL (X, Y, SKYPOS(1), SKYPOS(2), SKYPOS(3), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1305) IERR
         CALL MSGWRT (7)
      ELSE
         IF ((AXTYP(LOCNUM).EQ.2) .OR. (AXTYP(LOCNUM).EQ.3)) CALL AXSTRN
     *      (CTYP(3,LOCNUM), SKYPOS(3), KLOCA(LOCNUM), NCHLAB(1,LOCNUM),
     *      SAXLAB(1,LOCNUM))
         WRITE (MSGTXT,1302)
         ICH = 9
         DO 330 I = 1,2
            ITEMP = I - 1
            CALL AXSTRN (CTYP(I,LOCNUM), SKYPOS(I), ITEMP, ILEN, STRING)
            MSGTXT(ICH:) = STRING(:ILEN)
            ICH = ICH + ILEN + 2
 330        CONTINUE
         CALL MSGWRT (5)
         END IF
C                                       Secondary axes
      IF ((NCHLAB(1,LOCNUM).GT.0) .OR. (NCHLAB(2,LOCNUM).GT.0)) THEN
         WRITE (MSGTXT,1302)
         ICH = 9
         DO 335 I = 1,2
            IF (NCHLAB(I,LOCNUM).GT.0) THEN
               MSGTXT(ICH:) = SAXLAB(I,LOCNUM)(:NCHLAB(I,LOCNUM))
               ICH = ICH + NCHLAB(I,LOCNUM) + 2
               END IF
 335        CONTINUE
         CALL MSGWRT (5)
         END IF
C                                       total flux ?
      CALL CHLTOU (8, BUNITS)
      BUN2 = BUNITS(5:8)
      IF (BUNITS(:4).EQ.'JY/B') THEN
         IF (BUN2.EQ.'EAM') BUN2 = ' '
         AREA = 1.1331 * CATR(KRBMJ) * CATR(KRBMN)
         IF (AREA.GT.0.0) THEN
            J = CATBLK(KIDIM)
            I1U = 0
            I2U = 0
            DO 345 I = 1,J
               CALL H2CHR (4, 1, CATH(KHCTP+2*(I-1)), XXCHAR)
               DO 344 JJ = 1,5
                  IF (XXCHAR.EQ.LLCHAR(JJ)) I1U = I
                  IF (XXCHAR.EQ.MMCHAR(JJ)) I2U = I
 344              CONTINUE
 345           CONTINUE
            IF ((I1U.GT.0) .AND. (I2U.GT.0)) THEN
               AREAI = ABS (CATR(KRCIC+I1U-1) * CATR(KRCIC+I2U-1))
               IF (AREAI.GT.0.0) THEN
                  AREA = AREA / AREAI
                  S = S * SW / AREA
                  I = MAX (1, JTRIM(BUN2))
                  WRITE (MSGTXT,1345) S, BUN2(:I), AREA
                  CALL MSGWRT (5)
                  END IF
               END IF
            END IF
      ELSE IF (BUNITS(:4).EQ.'JY/P') THEN
         IF (BUN2.EQ.'IXEL') BUN2 = ' '
         I = MAX (1, JTRIM(BUN2))
         S = S * SW
         WRITE (MSGTXT,1346) S, BUN2(:I)
         CALL MSGWRT (5)
         END IF
      POTERR = 0
C-----------------------------------------------------------------------
C                                       Close down
 900  IF (TVOPN) CALL TVCLOS (BUF, IERR)
      IF (MAOPN) CALL MAPCLS ('READ', IVOL, CNO, DLUN, DIND, CATBLK, F,
     *   BUF, IERR)
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1220 FORMAT ('MAP I/O INITIALIZATION ERROR',I5)
 1225 FORMAT ('MAP READ ERROR',I5)
 1295 FORMAT ('NO VALID PIXELS FOUND')
 1300 FORMAT ('Mean=',1PE10.3,' rms=',1PE10.3,1X,A8,' over',0PF13.0,
     *   ' pixels')
 1301 FORMAT ('Maximum=',1PE11.4,' at',2I7,I6,4I5)
 1302 FORMAT ('Skypos: ')
 1303 FORMAT ('Including',F11.0,' pure zero pixels')
 1304 FORMAT ('Ignored',F13.0,' pure zero pixels')
 1305 FORMAT ('ERROR',I3,' FINDING SKY COORDINATES')
 1320 FORMAT ('Minimum=',1PE11.4,' at',2I7,I6,4I5)
 1345 FORMAT ('Flux density =',1PE12.4,' Jy',A,'  Beam area =',0PF9.2,
     *   ' pixels')
 1346 FORMAT ('Flux density =',1PE12.4,' Jy',A)
      END

      SUBROUTINE QDIRAD (APCORE, A, IA, B, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Directed vector add.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Does a complex directed add: adds a complex vector to a complex
C   vector whose addresses are given in the first vector.
C      B(A(mIA))   = B(A(mIA))  + A(mIA+1)   for m = 0,N-1
C      B(A(mIA)+1) = B(A(mIA)+1)+ A(mIA+2)
C   Inputs:
C      A  I  Source vector base address
C            0 => address (integer) to be added to
C                (address is zero relative)
C            1,2 => complex value (reals)
C      IA I  Increment for A (normally 3 * integer)
C      B  I  Destination vector base address
C      N  I  Element count
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   A, IA, B, N
C
      LONGINT   JA, JB, IADDR, TEST
      INTEGER   LOOP
      DOUBLE PRECISION DTEST
      EQUIVALENCE (TEST, DTEST)
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Addresses 1-rel
      JA = A + PSAPOF
      JB = B + PSAPOF
C                                        Do loop
      DO 100 LOOP = 1,N
         DTEST = APCORE(JA)
         IADDR = TEST + JB
         APCORE(IADDR) = APCORE(IADDR) + APCORE(JA+1)
         APCORE(IADDR+1) = APCORE(IADDR+1) + APCORE(JA+2)
         JA = JA + IA
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE FFTMC (DIR, L, M, N, VIS)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C     FFTMC does a fast Fourier transform of an input array.
C     Given:
C         DIR          I     Sign of the complex phase in the Fourier
C                            integral.
C         L,M,N        I     Dimensions of the array.
C     Given and returned:
C         VIS(L,M,N)   CX    Array containing the complex visibilities.
C                            Returned as the Fourier transform of the
C                            input array.
C     Called:
C          APLNOT: {FFTV2}
C     Algorithm:
C          Singleton's FFT.
C     Author:
C          Mark Calabretta, Australia Telescope.
C          Origin; 1987/Dec     Code last modified; 1989/Nov/01.
C-----------------------------------------------------------------------
      INTEGER    DIR, ISN, L, M, N
      REAL       VIS(2*L*M*N)
C-----------------------------------------------------------------------
C     Direction of the FFT.
      ISN = SIGN(2, DIR)

C     Transform along lines of constant V and W.
      IF (L.GT.1) CALL FFTV2 (VIS(1), VIS(2), N*M, L, 1, ISN)

C     Now along lines of constant U and W.
      IF (M.GT.1) CALL FFTV2 (VIS(1), VIS(2), N, M, L, ISN)

C     Now along lines of constant U and V.
      IF (N.GT.1) CALL FFTV2 (VIS(1), VIS(2), 1, N, M*L, ISN)

      RETURN
      END

      SUBROUTINE DNRM2 (N, DX, INCX, XDNRM2)
C-----------------------------------------------------------------------
C! Compute Euclidean norm of N-Vector
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Euclidean norm of the N-vector stored in DX() with storage
C   increment INCX .
C    Input:
C     N      I    Size of vector DX with increment INCX
C     DX(*)  D    Input vector
C     INCX   I    Increment of DX
C    Output:
C     XDNRM2 D    Euclidian norm
C  Useage notes:
C   IF    N .LE. 0 return with RESULT = 0.
C   IF N .GE. 1 then INCX must be .GE. 1
C        C. L. Lawson, 1978 JAN 08
C   Four phase method  using two built-in constants that are
C   hopefully applicable to all machines.
C       CUTLO = Maximum of  DSQRT(U/EPS)  over all known machines.
C       CUTHI = Minimum of  DSQRT(V)      over all known machines.
C   where
C       EPS = smallest no. such that EPS + 1. .GT. 1.
C       U   = smallest positive no.   (underflow limit)
C       V   = largest  no.            (overflow  limit)
C   brief outline of algorithm..
C   Phase 1    scans zero components.
C   move to phase 2 when a component is nonzero and .LE. CUTLO
C   move to phase 3 when a component is .GT. CUTLO
C   move to phase 4 when a component is .GE. CUTHI/M
C   where M = N for X() real and M = 2*N for COMPLEX.
C
C   values for CUTLO and CUTHI..
C   from the environmental parameters listed in the IMSL converter
C   document the limiting values are as follows..
C   CUTLO, S.P.   U/EPS = 2**(-102) for  Honeywell.  Close seconds are
C                 UNIVAC and DEC at 2**(-103)
C                 Thus CUTLO = 2**(-51) = 4.44089E-16
C   CUTHI, S.P.   V = 2**127 for UNIVAC, HONEYWELL, and DEC.
C                 THUS CUTHI = 2**(63.5) = 1.30438E19
C   CUTLO, D.P.   U/EPS = 2**(-67) for HONEYWELL and DEC.
C                 thus CUTLO = 2**(-33.5) = 8.23181D-11
C   CUTHI, D.P.   same AS S.P.  CUTHI = 1.30438D19
C   DATA CUTLO, CUTHI / 8.232D-11,  1.304D19 /
C   DATA CUTLO, CUTHI / 4.441E-16,  1.304E19 /
C-----------------------------------------------------------------------
      INTEGER   N, INCX, NEXT, NN, I, J
      DOUBLE PRECISION DX(*), XDNRM2, CUTLO, CUTHI, HITEST, SUM, XMAX
      DATA CUTLO, CUTHI / 8.232D-11,  1.304D19 /
C-----------------------------------------------------------------------
      IF (N.GT.0) GO TO 10
         XDNRM2 = 0.0D0
         GO TO 300
C
 10   NEXT = 1
      SUM = 0.0D0
      NN = N * INCX
C                                                 Begin main loop
      I = 1
 20   GO TO (30, 50, 70, 110), NEXT
C
 30   IF( ABS (DX(I)).GT.CUTLO) GO TO 85
      NEXT = 2
      XMAX = 0.0D0
C                                       Phase 1.  sum is zero
 50   IF (DX(I).EQ.0.0D0) GO TO 200
      IF (ABS (DX(I)).GT.CUTLO) GO TO 85
C                                       Prepare for phase 2.
      NEXT = 3
      GO TO 105
C                                       Prepare for phase 4.
 100  I = J
      NEXT = 4
      SUM = (SUM / DX(I)) / DX(I)
 105  XMAX = ABS (DX(I))
      GO TO 115
C                                       phase 2.  SUM is small.
C                                       scale to avoid destructive
C                                       underflow.
 70   IF( ABS (DX(I)).GT.CUTLO ) GO TO 75
C                                       Common code for phases 2 and 4.
C                                       In phase 4 SUM is large.
C                                       Scale to avoid overflow.
 110  IF (ABS(DX(I)).GT.XMAX) THEN
         SUM = 1.0D0 + SUM * (XMAX / DX(I))**2
         XMAX = ABS (DX(I))
         GO TO 200
         END IF
 115  SUM = SUM + (DX(I)/XMAX)**2
      GO TO 200
C                                       Prepare for phase 3.
 75   SUM = (SUM * XMAX) * XMAX
C                                       For real or D.P.
C                                       set HITEST = CUTHI/N
C                                       For complex
C                                       set HITEST = CUTHI/(2*N)
   85 HITEST = CUTHI / REAL (N)
C                                       phase 3.
C                                       Sum is mid-range.  No scaling.
      DO 95 J =I, NN,INCX
         IF (ABS (DX(J)).GE.HITEST) GO TO 100
         SUM = SUM + DX(J)**2
 95      CONTINUE
      XDNRM2 = SQRT (SUM)
      GO TO 300
 200  CONTINUE
      I = I + INCX
      IF (I.LE.NN) GO TO 20
C                                       End of main loop.
C                                       Compute square root and
C                                       adjust for scaling.
      XDNRM2 = XMAX * SQRT (SUM)
 300  CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'TLCAL.INC'
      INCLUDE 'INCS:PUVD.INC'
C
      CHARACTER NAMEIN*12, CLAIN*6, ASDMF(2)*64, SNAMES(1000)*16
      HOLLERITH XNAMEI(3), XCLAIN(2), XASDMF(16,2)
      REAL      XSIN, XDISIN, DOAPPL
      INTEGER   SEQIN, DISKIN, CNOIN, LUNF, INDF, NUMSOU, SCRTCH(512)
      REAL      SFLUXS(MAXIF,1000)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, DOAPPL, XASDMF
      COMMON /CHPARM/ SNAMES, NAMEIN, CLAIN, ASDMF
      COMMON /UVPCOM/ SCRTCH, SFLUXS, SEQIN, DISKIN, CNOIN, LUNF, INDF,
     *   NUMSOU
      INCLUDE 'INCS:DCHND.INC'
LOCAL END
      PROGRAM TLCAL
C-----------------------------------------------------------------------
C! TLCAL converts a JVLA telcal file to an SN table
C# Calibration VLA UV
C-----------------------------------------------------------------------
C;  Copyright (C) 2018
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TLCAL converts a telcal file to an SN table for JVLA
C   Inputs:
C      INNAME                             Input UV file name (name)
C      INCLASS                            Input UV file name (class)
C      INSEQ             0.0     9999.0   Input UV file name (seq. #)
C      INDISK                             Input UV file disk unit #
C      ASDMFILE                           File name in telcal area
C-----------------------------------------------------------------------
C
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'TLCAL.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'TLCAL '/
C-----------------------------------------------------------------------
C                                       Get input parameters and create
C                                       output file if nec.
      CALL TLCLIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Write flag table
      CALL TLCLDO (IRET)
C                                       Close it down
 995  IRET = MAX (0, IRET)
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE TLCLIN (PRGM, IRET)
C-----------------------------------------------------------------------
C   TLCLIN gets input parameters for TLCAL .
C   Inputs:
C      PRGM   C*6   Program name
C   Output:
C      IRET   I     Error code: 0 => ok, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
C
      CHARACTER UTYPE*2, STAT*4, OBSDAT*8, ASDMFL*128
      INTEGER   IUSER, IERR, IROUND, NPARM, J, JTRIM, IDATE(3), TLUN, I,
     *   VER, K
      INCLUDE 'TLCAL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   SUKOLS(MAXSUC), SUNUMV(MAXSUC), ISURNO, SUNIF
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Init IO et al.
      TSKNAM = PRGM
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 40
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         IRET = 8
         IF (IERR.NE.1) THEN
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
            END IF
         RQUICK = .FALSE.
         GO TO 999
         END IF
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> Char
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (64, 1, XASDMF(1,1), ASDMF(1))
      CALL H2CHR (64, 1, XASDMF(1,2), ASDMF(2))
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
C                                       Get CATBLK from file.
      IUSER = NLUSER
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   IUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      IUSER
         GO TO 990
         END IF
C                                       OK, get the header now
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'REST', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1035) IERR
         GO TO 990
         END IF
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
      XDISIN = DISKIN
      XSIN = SEQIN
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 0
C                                       duvh pointers
      CALL UVPGET (IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'SETTING UV HEADER POINTERS'
         GO TO 990
         END IF
C                                       open the gain file
      CALL H2CHR (8, 1, CATH(KHDOB), OBSDAT)
      CALL DATEST (OBSDAT, IDATE)
      WRITE (OBSDAT,1040) IDATE(1), IDATE(2)
      IF (ASDMF(2).EQ.' ') THEN
         J = JTRIM (ASDMF(1))
         ASDMFL = '/home/mchammer/evladata/telcal/' // OBSDAT //
     *      ASDMF(1)(:J) // '.GN'
      ELSE
         J = JTRIM (ASDMF(1))
         VER = JTRIM (ASDMF(2))
         ASDMFL = ASDMF(1)(:J) // ASDMF(2)(:VER) // '.GN'
         END IF
      LUNF = 3
      CALL ZTXOPN ('READ', LUNF, INDF, ASDMFL, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'COULD NOT OPEN TELCAL FILE:'
         CALL MSGWRT (8)
         J = JTRIM(ASDMFL)
         IF (J.GT.64) THEN
            MSGTXT = ASDMFL(:64)
            CALL MSGWRT (6)
            MSGTXT = ASDMFL(65:)
         ELSE
            MSGTXT = ASDMFL(:J)
            END IF
         GO TO 990
         END IF
C                                       Get frequencies
      VER = 1
      TLUN = 29
      CALL CHNDAT ('READ', SCRTCH, DISKIN, CNOIN, VER, CATBLK, TLUN,
     *   CHNIF, FOFF, ISBAND, FINC, BNDCOD, FQCHND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING FREQUENCY DATA'
         GO TO 990
         END IF
C                                       set frequencies
      DO 20 I = 1,CHNIF
         FOFF(I) = (FREQ + FOFF(I)) / 1.D6
 20      CONTINUE
C                                       Get source names
      DO 25 I = 1,1000
         SNAMES(I) = ' '
 25      CONTINUE
C                                       open table
      CALL SOUINI ('READ', SCRTCH, DISKIN, CNOIN, VER, CATBLK, TLUN,
     *   SUNIF, VELDEF, VELTYP, SUFQID, ISURNO, SUKOLS, SUNUMV, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING THE SOURCE TABLE'
         GO TO 990
         END IF
      J = SCRTCH(5)
C                                       Read record
      NUMSOU = 0
      K = MAXIF * 1000
      CALL RFILL (K, 1.0, SFLUXS)
      DO 40 I = 1,J
         CALL TABSOU ('READ', SCRTCH, ISURNO, SUKOLS, SUNUMV, IDSOUR,
     *      SNAME, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA,
     *      PMDEC, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING THE SOURCE TABLE'
            GO TO 990
            END IF
         SNAMES(IDSOUR) = SNAME
         NUMSOU = MAX (NUMSOU, IDSOUR)
         DO 30 K = 1,SUNIF
            IF (FLUX(1,K).LE.0.0) FLUX(1,K) = 1.0
            IF (FLUX(1,K).EQ.FBLANK) FLUX(1,K) = 1.0
            SFLUXS(K,IDSOUR) = SQRT (FLUX(1,K))
 30         CONTINUE
 40      CONTINUE
      CALL TABSOU ('CLOS', SCRTCH, ISURNO, SUKOLS, SUNUMV, IDSOUR,
     *   SNAME, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *   EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA,
     *   PMDEC, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TLCLIN: ERROR',I3,' ON ',A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK =',
     *   I3,' USER=',I5)
 1035 FORMAT ('ERROR',I3,' OBTAINING CATBLK ')
 1040 FORMAT (I4,'/',I2.2,'/')
      END
      SUBROUTINE TLCLDO (IRET)
C-----------------------------------------------------------------------
C   TLCLDO reads the telcal text file and writea an SN table
C   Outputs:
C      IRET     I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   CLBUFF(512), SNVER, LUNS, ISNRNO, IANT, SNKOLS(MAXSNC),
     *   SNNUMV(MAXSNC), NUMANT, NUMPOL, NUMIF, NUMNOD, SOURID, ANTNO,
     *   SUBA, FREQID, NODENO, REFA(2,MAXIF), JTRIM, I, J, MJD0, NVAL,
     *   IPOL, IIF, NTXT, NTIM, NAV(28), NREC, NMSGFR, NIFAIL, NSFAIL,
     *   NMSGSU, NFLAGD, NCHRIF, JIF
      REAL      GMMOD, TIMEI, IFR, MBDELY(2), DISP(2), DDISP(2),
     *   CREAL(2,MAXIF,28), CIMAG(2,MAXIF,28), DELAY(2,MAXIF,28),
     *   RATE(2,MAXIF), WEIGHT(2,MAXIF,28), TEPS, AMP, PHS, DLY
      LOGICAL   ISAPPL, FINISH
      DOUBLE PRECISION  RANOD, DECNOD, TIME, DTEMP, SKYFRQ, MSGFRQ(1000)
      CHARACTER TXTLIN*256, IFCHAR*1, FLAGGD*5, SRC*16, LSOUR*16,
     *   SFAIL(100)*16, IFCHRS*5, CHARIF(MAXIF)*5
      INCLUDE 'TLCAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUNS /33/
      DATA IFR, MBDELY, DISP, DDISP /7*0.0/
      DATA SUBA, FREQID /2 * 1/
C-----------------------------------------------------------------------
      TEPS = 0.1 / (24.0 * 3600.0)
      I = 2 * MAXIF
      CALL RFILL (I, 0.0, RATE)
      NTXT = 0
      NTIM = 0
      NMSGFR = 0
      NIFAIL = 0
      NMSGSU = 0
      NSFAIL = 0
      NFLAGD = 0
      NCHRIF = 0
C                                       init the SN table
      NUMNOD = 0
      NODENO = 0
      NUMPOL = 1
      GMMOD = 1.0
      IF (NCOR.GT.1) NUMPOL = 2
      NUMIF = CHNIF
      ISAPPL = .FALSE.
      RANOD = 0.0D0
      DECNOD = 0.0D0
      SNVER = 0
      CALL SNINI ('WRIT', CLBUFF, DISKIN, CNOIN, SNVER, CATBLK, LUNS,
     *   ISNRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATING NEW SN TABLE'
         GO TO 990
         END IF
C                                       skip first 3 lines
      DO 10 I = 1,3
         CALL ZTXIO ('READ', LUNF, INDF, TXTLIN, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INITIAL READING OF TEXT FILE'
            GO TO 990
            END IF
 10      CONTINUE
      NVAL = 0
      CALL FILL (28, 0, NAV)
      TIME = -10.0D0
      MJD0 = 0
C                                       read loop
 20   CALL ZTXIO ('READ', LUNF, INDF, TXTLIN, IRET)
      FINISH = IRET.EQ.2
      IF ((IRET.NE.0) .AND. (IRET.NE.2)) THEN
         WRITE (MSGTXT,1000) IRET, 'READING OF TEXT FILE'
         GO TO 990
         END IF
      IF (.NOT.FINISH) THEN
         J = JTRIM (TXTLIN)
         IF (MJD0.LE.0) READ (TXTLIN,1020) MJD0
         READ (TXTLIN,1021) DTEMP
         DTEMP = DTEMP - MJD0
         NTXT = NTXT + 1
      ELSE
         DTEMP = 1000.
         END IF
C                                       new time
      IF (ABS(DTEMP-TIME).GT.TEPS) THEN
C                                       write out current values
         IF (NVAL.GT.0) THEN
            TIMEI = DTEMP - TIME
            NTIM = NTIM + 1
            DO 30 I = 1,28
               ANTNO = I
               IF (NAV(I).GT.0) THEN
                  CALL TABSN ('WRIT', CLBUFF, ISNRNO, SNKOLS, SNNUMV,
     *               NUMPOL, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID,
     *               IFR, NODENO, MBDELY, DISP, DDISP, CREAL(1,1,I),
     *               CIMAG(1,1,I), DELAY(1,1,I), RATE, WEIGHT(1,1,I),
     *               REFA, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'WRITING SN TABLE'
                     GO TO 990
                     END IF
                  NREC = NREC + 1
                  END IF
 30            CONTINUE
            END IF
         IF (FINISH) GO TO 900
C                                       init
         NVAL = 0
         I = 2 * MAXIF * 28
         CALL RFILL (I, 0.0, WEIGHT)
         CALL RFILL (I, FBLANK, CREAL)
         CALL RFILL (I, FBLANK, CIMAG)
         CALL RFILL (I, FBLANK, DELAY)
         CALL FILL (28, 0, NAV)
         LSOUR = ' '
         END IF
C                                       parse line
      READ (TXTLIN,1030,ERR=890) IFCHRS, SKYFRQ, IANT, AMP, PHS, DLY,
     *   FLAGGD, SRC
      IFCHAR = IFCHRS(:1)
      IF (IFCHAR.EQ.'C') IFCHRS(:1) = 'A'
      IF (IFCHAR.EQ.'D') IFCHRS(:1) = 'B'
C                                       flagged
      NAV(IANT) = NAV(IANT) + 1
      IF (FLAGGD.NE.'false') THEN
         NFLAGD = NFLAGD + 1
C                                       not flagged
      ELSE
         JIF = 0
         DO 35 I = 1,NCHRIF
            IF (IFCHRS.EQ.CHARIF(I)) JIF = I
 35         CONTINUE
         IF (JIF.LE.0) THEN
            NCHRIF = NCHRIF + 1
            CHARIF(NCHRIF) = IFCHRS
            JIF = NCHRIF
            END IF
C                                       init source number
         IF (LSOUR.EQ.' ') THEN
            SOURID = 0
            DO 50 I = 1,NUMSOU
               IF (SNAMES(I).EQ.SRC) SOURID = I
 50            CONTINUE
            IF (SOURID.LE.0) THEN
               NSFAIL = NSFAIL + 1
               DO 55 I = 1,NMSGSU
                  IF (SRC.EQ.SFAIL(I)) GO TO 20
 55               CONTINUE
               WRITE (MSGTXT,1040) SRC
               CALL MSGWRT (7)
               NMSGSU = NMSGSU + 1
               SFAIL(NMSGSU) = SRC
               GO TO 20
               END IF
            LSOUR = SRC
            END IF
C                                       check source
         IF (LSOUR.NE.SRC) THEN
            WRITE (MSGTXT,1041) LSOUR, SRC
            CALL MSGWRT (7)
            END IF
C                                       polarization
         IPOL = 1
         IF ((IFCHAR.EQ.'C') .OR. (IFCHAR.EQ.'D')) IPOL = 2
         IIF = 0
         IF (ABS(FOFF(JIF)-SKYFRQ).LT.0.1) IIF = JIF
         IF (IIF.LE.0) THEN
            DO 60 I = 1,NUMIF
               IF (ABS(FOFF(I)-SKYFRQ).LT.0.1) IIF = I
 60            CONTINUE
            END IF
C                                       limit failure messages
         IF (IIF.LE.0) THEN
            NIFAIL = NIFAIL + 1
            DO 65 I = 1,NMSGFR
               IF (ABS(SKYFRQ-MSGFRQ(I)).LT.0.1) GO TO 20
 65            CONTINUE
            WRITE (MSGTXT,1050) SKYFRQ
            CALL MSGWRT (7)
            NMSGFR = NMSGFR + 1
            MSGFRQ(NMSGFR) = SKYFRQ
C                                       found the IF
         ELSE
            NVAL = NVAL + 1
            TIME = DTEMP
            IF (AMP.NE.0.0) AMP = 1.0 / AMP
            IF ((DOAPPL.GT.0.0) .AND. (SOURID.GT.0)) AMP = AMP *
     *         SFLUXS(IIF,SOURID)
            CREAL(IPOL,IIF,IANT) = AMP * COS (DG2RAD*PHS)
            CIMAG(IPOL,IIF,IANT) = AMP * SIN (DG2RAD*PHS)
            DELAY(IPOL,IIF,IANT) = DLY*1.D-9
            WEIGHT(IPOL,IIF,IANT) = 1.0
            END IF
         END IF
      GO TO 20
C                                       read error
 890  MSGTXT = 'PARSE LINE FORMAT ERROR'
      CALL MSGWRT (8)
C                                       normal finish
 900  CALL ZTXCLS (LUNF, INDF, I)
      I = 1
      CALL TABSN ('CLOS', CLBUFF, ISNRNO, SNKOLS, SNNUMV, NUMPOL, TIME,
     *   TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO, MBDELY, DISP,
     *   DDISP, CREAL(1,1,I), CIMAG(1,1,I), DELAY(1,1,I), RATE,
     *   WEIGHT(1,1,I), REFA, IANT)
      WRITE (MSGTXT,1900) NTXT
      CALL MSGWRT (3)
      WRITE (MSGTXT,1901) NTIM, NREC
      CALL MSGWRT (3)
      WRITE (MSGTXT,1902) SNVER
      CALL MSGWRT (3)
      IF (NSFAIL.GT.0) THEN
         WRITE (MSGTXT,1903) NSFAIL
         CALL MSGWRT (7)
         END IF
      IF (NIFAIL.GT.0) THEN
         WRITE (MSGTXT,1904) NIFAIL
         CALL MSGWRT (7)
         END IF
      IF (NFLAGD.GT.0) THEN
         WRITE (MSGTXT,1905) NFLAGD
         CALL MSGWRT (7)
         END IF
      GO TO 999
C                                       error finish
 990  CALL MSGWRT (8)
      GO TO 900
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TLCLDO ERROR',I4,' ON ',A)
 1020 FORMAT (I5)
 1021 FORMAT (F18.12)
 1030 FORMAT (58X,A5,1X,F9.2,4X,I2,F8.4,F8.1,10X,F11.4,5X,A5,37X,A)
 1040 FORMAT ('SOURCE NAME NOT FOUND IN SU TABLE = ''',A,'''')
 1041 FORMAT ('EXPECT SOURCE ',A,' FOUND ',A)
 1050 FORMAT ('SKYFRQ',F10.2,' NOT RECOGNIZED')
 1900 FORMAT ('Read',I8,' text records')
 1901 FORMAT ('Wrote',I7,' times and',I8,' total records')
 1902 FORMAT ('To SN table version',I4)
 1903 FORMAT (I10,' INPUT RECORDS DID NOT HAVE A MATCHING SOURCE')
 1904 FORMAT (I10,' INPUT RECORDS DID NOT HAVE A MATCHING FREQUENCY')
 1905 FORMAT (I10,' INPUT RECORDS WERE MARKED AS FLAGGED')
      END

      SUBROUTINE TXRGBL (X0, Y0, AX, AY, LEVTXT, RGBLEV, GBUFF, IERR)
C-----------------------------------------------------------------------
C! writes characters in colors to a plot string to describe RGBLEV
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2006, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TXRGBL draws the RGBLEVs string in suitable colors in a plot file
C   Inputs:
C      X0       R        initial character offset in X
C      Y0       R        initial character offset in Y
C      AX       R        X position for GPOS
C      Ay       R        Y position for GPOS
C      BLC      R(2)     BLC of full plot area
C      TRC      R(2)     TRC of full plot area
C      LEVTXT   C*(*)    Text string containing blank-separated LEVS
C      RGBLEV   R(3,*)   Colors of each LEVS
C   In/out
C      GBUFF    I(*)     Plot buffer
C   Outputs:
C      IERR     I        Error code
C-----------------------------------------------------------------------
      INTEGER   GBUFF(256), IERR
      REAL      X0, Y0, ax, ay, RGBLEV(3,*)
      CHARACTER LEVTXT*(*)
C
      INTEGER   NC, ITRIM, LP, IP, LC
      REAL      X
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       decide scale
      IERR = 0
      X = X0
      NC = ITRIM (LEVTXT)
      IF (NC.LE.1) GO TO 999
C                                       precursor section
      IP = INDEX (LEVTXT, '(')
      IF (IP.GT.0) THEN
         CALL G3VCOL (0.7, 0.7, 0.1, GBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) 'G3VCOL', IERR
            GO TO 990
            END IF
         CALL GPOS (AX, AY, GBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) 'GPOS', IERR
            GO TO 990
            END IF
         CALL G3CHAR (IP, 0, X, Y0, LEVTXT(:IP), GBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) 'G3CHAR', IERR
            GO TO 990
            END IF
         X = X + IP + 1
         END IF
      LP = IP
C                                       parse for string
      LC = 0
 15   IP = LP
 20      IP = IP + 1
         IF (IP.GT.NC) GO TO 100
         IF ((LEVTXT(IP:IP).NE.' ') .AND. (LEVTXT(IP:IP).NE.')'))
     *      GO TO 20
C                                       got one set color
            LC = LC + 1
            CALL G3VCOL (RGBLEV(1,LC), RGBLEV(2,LC), RGBLEV(3,LC),
     *         GBUFF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) 'G3VCOL', IERR
               GO TO 990
               END IF
            LP = LP + 1
            IF (LEVTXT(IP:IP+1).EQ.'  ') IP = IP + 1
            IF (LEVTXT(IP:IP).EQ.') ') IP = IP - 1
            CALL GPOS (AX, AY, GBUFF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) 'GPOS', IERR
               GO TO 990
               END IF
            CALL G3CHAR (IP-LP+1, 0, X, Y0, LEVTXT(LP:IP), GBUFF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) 'G3CHAR', IERR
               GO TO 990
               END IF
            X = X + IP-LP+1
            LP = IP
            IF (LEVTXT(IP+1:IP+1).NE.')') GO TO 15
 100     CALL G3VCOL (0.7, 0.7, 0.1, GBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) 'G3VCOL', IERR
            GO TO 990
            END IF
         CALL GPOS (AX, AY, GBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) 'GPOS', IERR
            GO TO 990
            END IF
         X = X + 1
         CALL G3CHAR (1, 0, X, Y0, ')', GBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) 'G3CHAR', IERR
            GO TO 990
            END IF
         GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TXRGBL: ',A,' RETURNS ERROR CODE',I4)
      END

      SUBROUTINE YGGRAM (OP, CURSOR, RGBBUF, IERR)
C-----------------------------------------------------------------------
C! controls the TV graphics color assignments
C# Y3 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YGGRAM reads/writes the TV graphics color assignment RAM.  The
C   data are packed in this look up table for colors as:
C         bit 15 (msb)   :   1 - graphics replace 0 - add to image
C         bits 10-14     :   red value for this graphics value
C         bits  5- 9     :   green
C         bits  0- 4     :   blue
C   Inputs:
C      OP      C*4       'READ' from DEANZA or 'WRIT' to DEANZA
C      CURSOR  L         T => set CURSOR ON colors
C                              else set CURSOR OFF colors
C   In/Out:
C      RGBBUF  I(256)    data array
C   Out:
C      IERR    I         error code of Z...XF : 0 => ok
C   DeAnza version: Nov-83  W. Jaffe
C-----------------------------------------------------------------------
      CHARACTER OP*4
      LOGICAL   CURSOR
      INTEGER   RGBBUF(256), IERR
C
      INCLUDE 'INCS:YDEA.INC'
      INTEGER   NB, CA, WG, OVRADR, CURON, CUROFF
      LOGICAL   WAIT
      DATA NB, WAIT /512, .TRUE./
C                                       Word Group 1 is VOC
C                                       Channel address 0 is 1st
C                                       Overlay LUT for VOC unit 0.
C                                       Other overlay LUTs are not used
      DATA CA, WG /0, 1/
C                                       Overlay byte addr 0 is start
C                                       of cursor on area.  Z200 and
C                                       Z400 are complicated double
C                                       cursor areas and are ignored
C                                       here.  Z600 is start of no
C                                       cursor on area.
      DATA CURON, CUROFF /0, 1536/
C-----------------------------------------------------------------------
      IF (CURSOR) THEN
         OVRADR = CURON
      ELSE
         OVRADR = CUROFF
         END IF
C                                       Set VOCLUT address
      CALL ZDEAXF ('LVR ', OVRADR, 2, 0, 3, WAIT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Read or Write WORD array
      IF (OP.EQ.'READ') THEN
         CALL ZDEAXF ('RWA ', RGBBUF, NB, CA, WG, WAIT, IERR)
      ELSE IF (OP.EQ.'WRIT') THEN
         CALL ZDEAXF ('LWA ', RGBBUF, NB, CA, WG, WAIT, IERR)
      ELSE
         IERR = 2
         END IF
C
 999  RETURN
      END

      SUBROUTINE FRQTAB (DISK, CNO, LUN, CATBLK, FREQID, BUFFER, IRET)
C-----------------------------------------------------------------------
C! Fill Frequency table in common for IFs and channels
C# Modeling Header Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2011-2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Fills in the frequency table FREQG in common /MAPDES/ (INCLUDEs
C   C/DGDS.INC) taking into account multiple IFs.  Uses values from
C   includes C/DHDR.INC and C/DUVH.INC so VHDRIN and UVPGET should have
C   been called first for the header record passed.
C   Note: uses LUN 27 if necessary to read IF table.
C   Input:
C      DISK     I        Disk number. If .le. 0 /CFILES/ scratch file
C                        number CNO will be used.
C      CNO      I        Catalog slot number
C      LUN      I        AIPS LUN to use for CHNDAT.
C      CATBLK   I(*)     Catalog header
C      FREQID   I        FREQ ID to use
C   Output:
C      BUFFER   I(512)   I/O work buffer for channel table.
C      IRET     I        Return error code, 0=>OK,
C                           5 => too many frequency channels
C                           6 => too many IFs (local dimension problem)
C                                or CHNDAT error code
C   Output in common /MAPDES/ (INCLUDEs C/DGDS.INC)
C      NCHANG   I        Number of frequency channels.
C      FREQG    D(*)     Frequency table (Hz)
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, LUN, CATBLK(256), BUFFER(512), FREQID, IRET
C
      INTEGER   NCH, NIF, ICH, IIF, VER, ITAB, FDISK, SCFCNO, IEQ
      REAL      REFPIX, REQ
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ISBAND(MAXIF)
      DOUBLE PRECISION FOFF(MAXIF), DRP, DFINC(MAXIF)
      REAL      FINC(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (IEQ, REQ)
C-----------------------------------------------------------------------
C                                       Initialize
      NIF = 1
      FOFF(1) = 0.0D0
      VER = 1
      IF (DISK.LE.0) THEN
         FDISK = SCRVOL(CNO)
         SCFCNO = SCRCNO(CNO)
      ELSE
         FDISK = DISK
         SCFCNO = CNO
         END IF
C                                       Get IF info if available,
C                                       need now because want FINC
      CALL CHNDAT ('READ', BUFFER, FDISK, SCFCNO, VER, CATBLK, LUN,
     *   NIF, FOFF, ISBAND, FINC, BNDCOD, FREQID, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Blew local declaration of
C                                       FOFF, ISBAND, & FINC
      IF (NIF.GT.MAXIF) THEN
         IRET = 6
         WRITE (MSGTXT,1020) NIF, MAXIF
         GO TO 990
         END IF
      NCH = CATBLK(KINAX+JLOCF)
      NCHANG = NIF * NCH * CATBLK(KINAX+JLOCS)
C                                       Too many channels
      IF (NCHANG.GT.MAXCIF) THEN
         WRITE (MSGTXT,1040) NCHANG, MAXCIF
         IRET = 5
         GO TO 990
         END IF
      IEQ = CATBLK(KRCRP+JLOCF)
      REFPIX = REQ
      ITAB = 1
C                                       double precision all
      DRP = REFPIX
      DO 10 IIF = 1,NIF
         DFINC(IIF) = FINC(IIF)
 10      CONTINUE
C                                       Fill table in right order
      IF ((JLOCIF.GE.0) .AND. (JLOCIF.LT.JLOCF)) THEN
         DO 105 ICH = 1,NCH
            DO 100 IIF = 1,NIF
               FREQG(ITAB) = FREQ + (ICH-DRP)*DFINC(IIF) + FOFF(IIF)
               ITAB = ITAB + 1
 100           CONTINUE
 105        CONTINUE
      ELSE
         DO 115 IIF = 1,NIF
            DO 110 ICH = 1,NCH
               FREQG(ITAB) = FREQ + (ICH-DRP)*DFINC(IIF) + FOFF(IIF)
               ITAB = ITAB + 1
 110           CONTINUE
 115        CONTINUE
         END IF

      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FRQTAB: CHNDAT ERROR ',I3)
 1020 FORMAT ('FRQTAB: TOO MANY IFS',I4,' > ',I3,' LOCALLY DEFINED')
 1040 FORMAT ('FRQTAB: TOO MANY FREQUENCY CHAN.',I4,' > ',I4)
      END

      SUBROUTINE DDOT (N, DX, INCX, DY, INCY, XDDOT)
C-----------------------------------------------------------------------
C! Linpack routine: Form dot product of two vectors (DOUBLE)
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Forms the dot product of two vectors.
C   uses unrolled loops for increments equal to one.
C   Jack Dongarra, Linpack, 3/11/78.
C     Inputs:
C      N       I    Element count
C      DX(*)   D    First vector
C      INCX    I    Increment of DX
C      DY(*)   D    Second vector
C      INCY    I    Increment of DY
C    Output:
C      XDDOT   D    Dot product of DX and DY
C-----------------------------------------------------------------------
      DOUBLE PRECISION DX(*), DY(*), XDDOT, DTEMP
      INTEGER   I, INCX, INCY, IX, IY, M, MP1, N
C-----------------------------------------------------------------------
      XDDOT = 0.0D0
      DTEMP = 0.0D0
      IF (N.LE.0) GO TO 999
      IF (INCX.EQ.1 .AND. INCY.EQ.1) GO TO 20
C                                       Code for unequal increments or
C                                       equal increments not equal to 1
C
      IX = 1
      IY = 1
      IF (INCX.LT.0) IX = (-N+1) * INCX + 1
      IF (INCY.LT.0) IY = (-N+1) * INCY + 1
      DO 10 I = 1,N
         DTEMP = DTEMP + DX(IX)*DY(IY)
         IX = IX + INCX
         IY = IY + INCY
   10    CONTINUE
      XDDOT = DTEMP
      GO TO 999
C                                       Code for both increments
C                                       equal to 1.
C                                       Clean-up loop.
   20 M = MOD (N, 5)
      IF (M.EQ.0) GO TO 40
      DO 30 I = 1,M
         DTEMP = DTEMP + DX(I)*DY(I)
   30    CONTINUE
      IF (N.LT.5) GO TO 60
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
         DTEMP = DTEMP + DX(I)*DY(I) + DX(I+1)*DY(I+1) +
     *      DX(I+2)*DY(I+2) + DX(I+3)*DY(I+3) + DX(I+4)*DY(I+4)
   50    CONTINUE
   60 XDDOT = DTEMP
C
 999  RETURN
      END

      SUBROUTINE HILOCT (OP, HLUN, HPTR, IERR)
C-----------------------------------------------------------------------
C! manipulates the history table, opening, closing, located an entry
C# History
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   HILOCT locates a history file in HITAB in /HICOM /
C   Inputs:
C      OP    C*4   'OPEN' assign vacant space
C                  'CLOS' remove from table
C                  'SRCH' find in table only
C      HLUN  I     lun of file
C   Output:
C      HPTR  I     pointer to first word of table entry
C      IERR  I     error code 0 => ok
C                             1 => LUN in use (OPEN)
C                             2 => no room (OPEN)
C                             3 => not found (CLOS< SRCH)
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   HLUN, HPTR, IERR
C
      INTEGER   NC, NP, I
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                        locate in HITAB
      NP = 1 - NHIWRD
      NC = 0
      DO 10 I = 1,NHIFIL
         NP = NP + NHIWRD
         IF (HLUN.EQ.HITAB(NP)) GO TO 20
         IF ((NC.EQ.0) .AND. (HITAB(NP).EQ.0)) NC = NP
 10      CONTINUE
C                                        OPEN
      IF (OP.NE.'OPEN') GO TO 900
         IF (NC.EQ.0) GO TO 910
            HPTR = NC
            HITAB(NC) = HLUN
            GO TO 999
C                                        found LUN in table
 20   IF (OP.EQ.'OPEN') GO TO 920
         HPTR = NP
         IF (OP.EQ.'CLOS') CALL FILL (NHIWRD, 0, HITAB(NP))
         GO TO 999
C                                        errors
C                                        LUN not found
 900  IERR = 3
      WRITE (MSGTXT,1900) HLUN
      GO TO 990
C                                        no room
 910  IERR = 2
      WRITE (MSGTXT,1910) HLUN
      GO TO 990
C                                        in use
 920  IERR = 1
      WRITE (MSGTXT,1920) HLUN
 990  CALL MSGWRT (7)
      HPTR = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('HILOCT: FILE',I6,' NOT OPEN IN HITAB')
 1910 FORMAT ('HILOCT: NO ROOM IN HITAB FOR', I6)
 1920 FORMAT ('HILOCT: FILE',I6,' ALREADY IN USE IN HITAB')
      END

LOCAL INCLUDE 'CALWR.INC'
C                                                          Include CALWR
C                                       Local include for CALWR
      HOLLERITH XOBJ(2), XBAND
      CHARACTER NAME*12, CLASS*6, TYPE*2, OUTFIL*48, LINE*2880
      REAL      BLC(7), TRC(7), RITBLK(1440)
      INTEGER   IVOL, ISEQ, ICNO, FDVEC(50), TBIND, DLUN, DIND, USER,
     *   ICARD, FITBLK(1440), TABLES, ANTFIL, IFLAG(20), IFMTYP,
     *   KLOCWT, NUMCOR, CATSAV(256), SCRTCH(256)
      LOGICAL   LSTOKE, ISCMP
      EQUIVALENCE (FITBLK, RITBLK)
      COMMON /INPARM/ XOBJ, XBAND, BLC, TRC
      COMMON /MORPRM/ CATSAV, FITBLK, LSTOKE, ISCMP, IVOL, ICNO, ISEQ,
     *   FDVEC, TBIND, DLUN, DIND, USER, ICARD,TABLES, ANTFIL, IFLAG,
     *   IFMTYP, KLOCWT, NUMCOR, SCRTCH
      COMMON /FTPCHR/ NAME, CLASS, TYPE, OUTFIL, LINE
C                                                          End CALWR.
LOCAL END
LOCAL INCLUDE 'CALWR2.INC'
C                                       Local include for buffers
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   TAPBUF(29184), IBUFSZ
      REAL      BUFF(UVBFSS), TBUFF(UVBFSS)
      COMMON /BUFRS/ TAPBUF, BUFF, TBUFF, IBUFSZ
LOCAL END
      PROGRAM CALWR
C-----------------------------------------------------------------------
C! Translate AIPS image file to a FITS-format file for calibrator set
C# Tape Map
C-----------------------------------------------------------------------
C;  Copyright (C) 2004-2005, 2007, 2013, 2015, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C     This program will write an image of a calibrator source to a FITS
C   disk file suitable for standard calibrator usage.
C   Inputs:
C     INNAME     R(3)   Name of input file.
C     INCLASS    R(2)   Class of file.
C     INSEQ      R      sequence number of file.
C     INDISK     R      disk volume no. of file.
C     BLC        R(7)   Bottom left corner
C     TRC        R(7)   Top right corner
C     OUTFILE    R(12)  Disk file name
C-----------------------------------------------------------------------
      INTEGER   IERR, IRET
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'CALWR.INC'
      INCLUDE 'CALWR2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       Set No. of files & no. of
C                                       scratch files to zero
      NCFILE = 0
      NSCR = 0
C                                       Get input parameters. Fill in
C                                       defaults.
      CALL CALWIN (RQUICK, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       write out image
      CALL CALWRI (IRET)
      CALL MAPCLS ('READ', IVOL, ICNO, DLUN, DIND, CATBLK, .FALSE.,
     *   SCRTCH, IERR)
C                                       Then close it
      CALL TAPIO ('CLOS', FDVEC, TAPBUF, TBIND, IERR)
      IF (IRET.EQ.0) IRET = IERR
C
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE CALWIN (RQUICK, IRET)
C-----------------------------------------------------------------------
C   CALWIN does the most basic inits for CALWR.  Get the parameters,
C   restart AIPS if required, fill in defaults, init the tape I/O.
C   Outputs: RQUICK  L         T -> AIPS already restarted
C            IRET    I         Return code : 0 => ok
C                                       else quit
C            COMMON /INPARM/
C            COMMON /MORPRM/
C-----------------------------------------------------------------------
      LOGICAL   RQUICK
      INTEGER   IRET
C
      CHARACTER PRGNAM*6, OBJECT*8, BAND*4
      INTEGER   NPARM, IERR, I, ITRIM
      HOLLERITH HFDVEC(50)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'CALWR.INC'
      INCLUDE 'CALWR2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (HFDVEC, FDVEC)
      DATA PRGNAM, NPARM /'CALWR ', 17/
C-----------------------------------------------------------------------
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Zero fill FDVEC
      CALL FILL (50, 0, FDVEC)
C                                       Init the FITS I/O
      TBIND = 1
C                                       Initialize for AIPS
      CALL GTPARM (PRGNAM, NPARM, RQUICK, XOBJ, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
C                                       Convert characters
      CALL H2CHR (8, 1, XOBJ, OBJECT)
      CALL H2CHR (4, 1, XBAND, BAND)
      I = ITRIM (OBJECT)
      NAME = OBJECT(:I) // '_' // BAND
      I = ITRIM (NAME)
      CLASS = 'MODEL'
      ISEQ = 1
      IVOL = 0
      OUTFIL = 'FITS:' // NAME(:I) // '.MODEL'
      USER = NLUSER
      DLUN = 16
      WRITE (MSGTXT,1010) OUTFIL
      CALL MSGWRT (4)
      CALL CHR2H (48, OUTFIL, 1, HFDVEC(7))
      FDVEC(1) = 25
C                                       open output file
      TYPE = 'MA'
      CALL MAPOPN ('READ', IVOL, NAME, CLASS, ISEQ, TYPE, USER, DLUN,
     *   DIND, ICNO, CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       Force window
      BLC(1) = MIN (BLC(1), CATBLK(KINAX)+1-TRC(1))
      BLC(2) = MIN (BLC(2), CATBLK(KINAX+1)+1-TRC(2))
      TRC(1) = MAX (TRC(1), CATBLK(KINAX)+1-BLC(1))
      TRC(2) = MAX (TRC(2), CATBLK(KINAX+1)+1-BLC(2))
C                                       Open output file
      FDVEC(5) = 1
      FDVEC(2) = 2880
      FDVEC(3) = (29184 * NBITWD) / 8
      IFMTYP = 3
      FDVEC(6) = 1
      CALL TAPIO ('OPWT', FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (8)
      ELSE
         GO TO 999
         END IF
      GO TO 999
C                                       error close downs
 960  CALL MAPCLS ('READ', IVOL, ICNO, DLUN, DIND, CATBLK, .FALSE.,
     *   SCRTCH, IERR)
C
 995  IRET = 16
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('COULD NOT GET PARMS.  IER=',I3)
 1010 FORMAT ('Writing to disk file: ',A)
 1020 FORMAT ('COULD NOT OPEN OUTPUT FILE.  IER=',I4)
      END
      SUBROUTINE CALWRI (IERR)
C-----------------------------------------------------------------------
C   CALWRI calls the specific routines for translating an AIPS MAp
C   image to FITS format.
C   COMMON /CFTP/
C      DOALL        R       < 0 (False) do first match, >= 0 (True)
C                           do every match.
C      NAME         C*12    Image designation (Name)
C      CLASS        C*6     Image designation (Class)
C      INSEQ        R       Image designation (Seq #)
C      INDISK       R       Inputs disk unit #
C      OUTTAPE      R       Output tape unit #
C   OUTPUT:
C      IERR         I       0=ok, 1=not ok.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   I, IBLC(7), ITRC(7)
      CHARACTER CHTMP*18
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'CALWR.INC'
      INCLUDE 'CALWR2.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IFMTYP = 3
      DO 10 I = 1,7
         IBLC(I) = BLC(I) + 0.01
         ITRC(I) = TRC(I) + 0.01
         IBLC(I) = MAX (1, IBLC(I))
         ITRC(I) = MAX (ITRC(I), IBLC(I))
 10      CONTINUE
      CALL COPY (256, CATBLK, CATSAV)
      CALL SUBHDR (BLC, TRC, 0.0, 0.0)
C                                       Tell user
      WRITE (MSGTXT,1000) USER, IVOL
      CALL H2CHR (18, 1, CATH(KHIMN), CHTMP)
      CALL NAMEST (CHTMP, CATBLK(KIIMS), MSGTXT(40:80), I)
      CALL MSGWRT (3)
C                                       Convert standard header to FITS
      CALL FITHCN (IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) 'BASIC FITS HEADER', IERR
         GO TO 960
         END IF
C                                       Copy header extra keywords
      CALL FITKEY (IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) 'HEADER KEYWORDS', IERR
         GO TO 960
         END IF
C                                       Copyright as history
      CALL FTMAHI (IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) 'HISTORY', IERR
         GO TO 960
         END IF
C                                       Write mapdata onto tape
      CALL FITDCN (BLC, TRC, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) 'BINARY IMAGE DATA', IERR
         GO TO 960
         END IF
C                                       Write ext files to tape
      CALL FITEXT (IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) 'EXTENSION FILES', IERR
         CALL MSGWRT (6)
         END IF
C                                       Close Tape EOF
      MSGTXT = 'Writing end-of-file marks'
      CALL MSGWRT (2)
      CALL TAPIO ('FLSH', FDVEC, TAPBUF, TBIND, IERR)
      GO TO 999
C
C                                       Error return
 960  CALL MSGWRT (8)
      I = 1
      CALL ZTPCLS (FDVEC(1), FDVEC(40), IERR)
      FDVEC(40) = 0
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Writing image: User',I5,'  Disk',I2,'  Name')
 1010 FORMAT ('ERROR WRITING ',A,':',I7)
      END
      SUBROUTINE FITHCN (IERR)
C-----------------------------------------------------------------------
C   FITHCN converts the standard map header into the FITS format and
C   writes this header on tape.
C   Outputs:
C      IERR   I   Error return: 0--> okay, else  from IO routines
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      CHARACTER CHEXTN*8, TCOM*32, CHBLOK*8, BLKCOM*32, BCOM*32
      INTEGER   I, NWORDS, LBPX
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'CALWR.INC'
      INCLUDE 'CALWR2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DKEY.INC'
      INCLUDE 'INCS:VKEY.INC'
      DATA CHEXTN /'EXTEND  '/
      DATA TCOM /'Tables following main image     '/
      DATA CHBLOK, BLKCOM /'BLOCKED ', 'Tape may be blocked      '/
C-----------------------------------------------------------------------
C                                       Initialize
      ICARD = 0
      BCOM = '          '
C                                       Required keywords
      CALL KEYWRD (RWORD(1), RTYPE(1), RPOINT(1), BCOM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       header no longer has bits/pix
      LBPX = -32
      CALL KEYWRD (RWORD(2), 10, LBPX, BCOM, IERR)
      IF (IERR.NE.0) GO TO 999
      NWORDS = 3 + CATBLK(KIDIM)
      DO 45 I = 3,NWORDS
         CALL KEYWRD (RWORD(I), RTYPE(I), RPOINT(I), BCOM, IERR)
         IF (IERR.NE.0) GO TO 999
 45      CONTINUE
C                                       New FITS extension/table file.
      CALL KEYWRD (CHEXTN, 1, 1, TCOM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       New FITS BLOCKED = T
      CALL KEYWRD (CHBLOK, 1, 1, BLKCOM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Normal keywords
      DO 50 I = 1,NNT
         CALL KEYWRD (NWORD(I), NTYPE(I), NPOINT(I), NCOM(I), IERR)
         IF (IERR.NE.0) GO TO 999
 50      CONTINUE
C                                       Axis keywords
      NWORDS = 5 * CATBLK(KIDIM)
      DO 65 I = 1,NWORDS
         CALL KEYWRD (AWORD(I), ATYPE(I), APOINT(I), BCOM, IERR)
         IF (IERR.NE.0) GO TO 999
 65      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE FITKEY (IERR)
C-----------------------------------------------------------------------
C   FITKEY writes history records into FITS headers containing all of
C   the special keywords from the catalog header.  So that readers will
C   recognize them they go out in the form:
C   HISTORY AIPS HEADERi keyword = value / comment
C   where i is the keyword type code (1-5 => double precision, single
C   precision, character*8, integer, logical).
C   Output:
C      IERR    I      Error code from IO routines.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   MXKEYS
      PARAMETER (MXKEYS=500)
      INTEGER   LOCS(MXKEYS), KEYTS(MXKEYS), ITEMP, IKEY, IC, NUMKEY, I,
     *   ITRIM
      CHARACTER KEYWOR(MXKEYS)*8, HCOM*27, CARD*80, HKEY*19, LOGKEY*1,
     *   DATEST*12
      LOGICAL   LTEMP
      REAL      VALUES(MXKEYS), RTEMP(2)
      DOUBLE PRECISION DTEMP
      INCLUDE 'CALWR.INC'
      INCLUDE 'CALWR2.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (DTEMP, RTEMP, LTEMP, ITEMP)
      DATA HCOM /'AIPS Catalog Header Keyword'/
      DATA HKEY /'HISTORY AIPS HEADER'/
C-----------------------------------------------------------------------
C                                       read all header keywords
      NUMKEY = MXKEYS
      CALL CATKEY ('ALL ', IVOL, ICNO, KEYWOR, NUMKEY, LOCS,
     *   VALUES, KEYTS, BUFF, IERR)
      IF (IERR.NE.0) NUMKEY = 0
C                                       If any keywords read
      IF (NUMKEY.GT.0) THEN
         DO 20 IKEY = 1,NUMKEY
            IF ((KEYWOR(IKEY).NE.'ACTNOISE') .AND.
     *         (KEYWOR(IKEY).NE.'CCFLUX')) GO TO 20
C                                       Double precsion keyword
            IF (KEYTS(IKEY).EQ.1) THEN
               CALL RCOPY (NWDPDP, VALUES(LOCS(IKEY)), RTEMP)
               WRITE (CARD,1010) HKEY, KEYTS(IKEY), KEYWOR(IKEY), DTEMP,
     *            HCOM
C                                       Single precsion keyword
            ELSE IF (KEYTS(IKEY).EQ.2) THEN
               WRITE (CARD,1010) HKEY, KEYTS(IKEY), KEYWOR(IKEY),
     *            VALUES(LOCS(IKEY)), HCOM
C                                       Character keyword
            ELSE IF (KEYTS(IKEY).EQ.3) THEN
               CALL H2CHR (8, 1, VALUES(LOCS(IKEY)), DATEST)
               IF (INDEX(KEYWOR(IKEY), 'DATE').GT.0)
     *            CALL DATFST ('L2F', DATEST)
               I = MAX (8, ITRIM (DATEST))
               WRITE (CARD,1030) HKEY, KEYTS(IKEY), KEYWOR(IKEY),
     *            DATEST(:I), HCOM
C                                       Integer keyword
            ELSE IF (KEYTS(IKEY).EQ.4) THEN
               CALL RCOPY (1, VALUES(LOCS(IKEY)), RTEMP)
               WRITE (CARD,1040) HKEY, KEYTS(IKEY), KEYWOR(IKEY), ITEMP,
     *            HCOM
C                                       Logical keyword
            ELSE IF (KEYTS(IKEY).EQ.5) THEN
               CALL RCOPY (1, VALUES(LOCS(IKEY)), RTEMP)
               LOGKEY = 'F'
               IF (LTEMP) LOGKEY = 'T'
               WRITE (CARD,1050) HKEY, KEYTS(IKEY), KEYWOR(IKEY),
     *            LOGKEY, HCOM
C                                       shouldn't get here
            ELSE
               WRITE (MSGTXT,1000) IKEY, KEYTS(IKEY)
               CALL MSGWRT (6)
               GO TO 20
               END IF
C                                       Put card into buffer.
            IF (ICARD.GE.36) THEN
               CALL WRCTAP (IERR)
               IF (IERR.NE.0) GO TO 999
               END IF
            ICARD = ICARD + 1
C                                       Put card in buffer.
            IC = 80 * (ICARD - 1)  +  1
            CALL FITCHM (CARD, IC, FITBLK)
 20         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FITKEY: KEYWORD',I3,' STRANGE TYPE =',I5)
 1010 FORMAT (A,I1,2X,A8,' =',1PE17.9,' /',A)
 1030 FORMAT (A,I1,2X,A8,' = ''',A,'''',6X,' /',A)
 1040 FORMAT (A,I1,2X,A8,' =',I12,5X,' /',A)
 1050 FORMAT (A,I1,2X,A8,' = ',A1,15X,' /',A)
      END
      SUBROUTINE FTMAHI (IERR)
C-----------------------------------------------------------------------
C   FTMAHI writes copyright as history records by calling FITHIS and
C   then adding special records re Clean.
C   Output:
C      IERR    I      Error code from IO routines.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      CHARACTER PRODS(5)*12
      INTEGER   I, J, IC, IL
      REAL      X, Y, Z
      INCLUDE 'CALWR.INC'
      INCLUDE 'CALWR2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA PRODS /'NORMAL      ', 'COMPONENTS  ',
     *   'RESIDUAL    ', 'POINTS      ', 'DIRTY MAP   '/
C-----------------------------------------------------------------------
C                                       Copy HI file + general AIPS
      CALL FITHIS (IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Write MAp specific 'AIPS' HI
C                                       Clean parameters
C                                       Convert parameters
      X = CATR(KRBMJ)
      Y = CATR(KRBMN)
      Z = CATR(KRBPA)
      IF ((CATBLK(KINIT).GT.0) .OR. (X.GT.0.) .OR. (Y.GT.0.) .OR.
     *   (Z.NE.0.)) THEN
C                                       Clean beam
         IF (ICARD.GE.36) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 999
         ICARD = ICARD + 1
         IC = 80 * ICARD - 79
         WRITE (MSGTXT,1020) X, Y, Z
         CALL FITCHM (MSGTXT, IC, FITBLK)
C                                       Iterations, product
         IF (ICARD.GE.36) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 999
         ICARD = ICARD + 1
         IC = 80 * ICARD - 79
         I = MAX (1, MIN (4, CATBLK(KITYP)))
         J = I
         IF (CATBLK(KINIT).LE.0) I = 5
         IF (CATBLK(KINIT).LE.0) J = 0
         WRITE (MSGTXT,1025) CATBLK(KINIT), J, PRODS(I)
         CALL FITCHM (MSGTXT, IC, FITBLK)
         END IF
C                                       imaging type, xpoff, ypoff
      I = CATBLK(KIITY)
      IF ((I.EQ.1) .OR. (I.EQ.2)) THEN
         IF (ICARD.GE.36) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 999
         ICARD = ICARD + 1
         IC = 80 * ICARD - 79
         WRITE (MSGTXT,1030) I, CATR(KRXPO), CATR(KRYPO)
         CALL FITCHM (MSGTXT, IC, FITBLK)
         END IF
C                                       END card
      IF (ICARD.GE.36) CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 999
      IC = ICARD * 80 + 1
      MSGTXT = 'END     '
      CALL FITCHM (MSGTXT, IC, FITBLK)
C                                       Fill and Write record
      IL = 2880 - IC + 1
      IF (IL.GT.0) THEN
         LINE (IC:2880) = '                  '
         CALL ZCLC8 (IL, LINE(IC:2880), IC, FITBLK)
         END IF
      IL = 2880 / (NBITWD / 8)
      CALL COPY (IL, FITBLK, TAPBUF(TBIND))
      CALL TAPIO ('WRIT', FDVEC, TAPBUF, TBIND, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('HISTORY AIPS   CLEAN BMAJ=',1PE12.4,' BMIN=',1PE12.4,
     *   ' BPA=',0PF7.2)
 1025 FORMAT ('HISTORY AIPS   CLEAN NITER=',I9,' PRODUCT=',I1,3X,
     *   '/ ',A)
 1030 FORMAT ('HISTORY AIPS   IMAGE ITYPE=',I1,' XPOFF=',1PE16.8,
     *   ' YPOFF=',1PE16.8)
      END
      SUBROUTINE FITDCN (NBLC, NTRC, IER)
C-----------------------------------------------------------------------
C   FITDCN reads the standard map image data and writes the image.
C   Inputs:
C      NBLC     R(7)    Bottom left corner
C      NTRC     R(7)    Top right corner
C   Outputs:
C      IER   I     Error return
C                     0--> okay
C                     1--> error condition
C-----------------------------------------------------------------------
      INTEGER   IER
      REAL      NBLC(7), NTRC(7)
C
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   IERR, IWIN(4), NBKOF1, IOFF, NX, NY, IDEPTH(5), NBYB, I,
     *   INX, INY, IBL, NVAL, ININD, NXX, NXY, I3, I3A, I3B, I4, I4A,
     *   I4B, I5, I5A, I5B, I6, I6A, I6B, I7, I7A, I7B
      REAL      BUFFRR(MAXIMG), FITBRR(1440)
      DOUBLE PRECISION NONZER, NZERO
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'CALWR.INC'
      INCLUDE 'CALWR2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (FITBLK(1), FITBRR(1))
C-----------------------------------------------------------------------
C                                       Initialize
      IER = 0
      NBYB = UVBFSS * 2
      NONZER = 0.0D0
      NZERO = 0.0D0
      NVAL = 720
      CALL FILL (1440, 0, FITBLK)
      MSGTXT = 'Now writing the image'
      CALL MSGWRT (3)
C                                       Set window parms
      I3A = NBLC(3) + 0.01
      I4A = NBLC(4) + 0.01
      I5A = NBLC(5) + 0.01
      I6A = NBLC(6) + 0.01
      I7A = NBLC(7) + 0.01
      I3B = NTRC(3) + 0.01
      I4B = NTRC(4) + 0.01
      I5B = NTRC(5) + 0.01
      I6B = NTRC(6) + 0.01
      I7B = NTRC(7) + 0.01
      IWIN(1) = NBLC(1) + 0.01
      IWIN(2) = NBLC(2) + 0.01
      IWIN(3) = NTRC(1) + 0.01
      IWIN(4) = NTRC(2) + 0.01
      NY = IWIN(4) - IWIN(2) + 1
      NX = IWIN(3) - IWIN(1) + 1
      INX = CATSAV(KINAX)
      INY = CATSAV(KINAX+1)
      IBL = 0
      DO 100 I7 = I7A,I7B
      DO 99 I6 = I6A,I6B
      DO 98 I5 = I5A,I5B
      DO 97 I4 = I4A,I4B
      DO 96 I3 = I3A,I3B
C                                       Initialize disk
         IDEPTH(1) = I3
         IDEPTH(2) = I4
         IDEPTH(3) = I5
         IDEPTH(4) = I6
         IDEPTH(5) = I7
         CALL COMOFF (CATSAV(KIDIM), CATSAV(KINAX), IDEPTH, NBKOF1,
     *      IERR)
         IF (IERR.NE.0) GO TO 990
         NBKOF1 = NBKOF1 + 1
         CALL MINIT ('READ', DLUN, DIND, INX, INY, IWIN, BUFF, NBYB,
     *      NBKOF1, IERR)
         IF (IERR.EQ.0) GO TO 40
            WRITE (MSGTXT,1030) IERR
            GO TO 980
C                                       Begin read/write loop
 40      DO 90 I = 1,NY
C                                       Read a map line
            CALL MDISK ('READ', DLUN, DIND, BUFF, ININD, IERR)
            IF (IERR.EQ.0) GO TO 50
               WRITE (MSGTXT,1040) IERR,I
               GO TO 980
 50         CALL RCOPY (NX, BUFF(ININD), BUFFRR)
            NXY = NX
            IOFF = 1
 55         NXX = MIN (NXY, NVAL-IBL)
C                                       Need new buffer
            IF (NXX.LE.0) THEN
               CALL WRTAPE (IBL, IERR)
               IBL = 0
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1055) IERR
                  GO TO 980
                  END IF
               GO TO 55
               END IF
C                                       Do copy
            CALL RCOPY (NXX, BUFFRR(IOFF), FITBRR(1+IBL))
            IBL = IBL + NXX
            IOFF = IOFF + NXX
            NXY = NXY - NXX
            IF (NXY.GT.0) GO TO 55
 90         CONTINUE
 96      CONTINUE
 97      CONTINUE
 98      CONTINUE
 99      CONTINUE
 100     CONTINUE
C                                       Warning:
      IF (NZERO.GT.0.5D0) THEN
         NZERO = 100.0D0 * NZERO / (NZERO + NONZER)
         WRITE (MSGTXT,1100) NZERO
         IF (NZERO.GT.0.1D0) CALL MSGWRT (6)
         END IF
C                                       Write last record on tape
      IF (IBL.LE.0) GO TO 999
         CALL WRTAPE (IBL, IERR)
         IF (IERR.EQ.0) GO TO 999
            WRITE (MSGTXT,1055) IERR
            GO TO 980
C
 980  CALL MSGWRT (8)
 990  IER = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('FITDCN: COULD NOT INITIALIZE MAP.  IER=',I4)
 1040 FORMAT ('FITDCN: COULD NOT READ MAP.  IER=',I3,' LINE=',I4)
 1055 FORMAT ('FITDCN: COULD NOT WRITE FITS RECORD.  IER=',I4)
 1100 FORMAT ('WARNING: ',F8.4,' per cent of pixels written as 0')
      END
      SUBROUTINE KEYWRD (WORD, ITYPE, POINT, COMENT, IERR)
C-----------------------------------------------------------------------
C   This routine will encode a given keyword and the corresponding
C   value in the header into the FITS card format and put that card
C   into the tape output buffer.  If that buffer is full, the output
C   buffer will be written to tape.
C   INPUTS:
C      WORD    C*8     FITS keyword (characters).
C      ITYPE   I        data type of header value.
C                           1=Logical variable
C                           2=Number
C                           3=String on real boundary
C                           4=String on integer boundary
C                           5=image scaling parms
C                           6=Rand parm scalling factors.
C                           7=Rand parm offsets.
C                           8=Rand parm names.
C                           9=blanking value.
C                          10=value = pointer.
C                          11=NUMERIC, omit if zero.
C      POINT   I        'pointer code' of the header value, i.e. 1000 *
C                       length in bytes + 100 * offset into the header +
C                       position of pointer in common HDRVAL.
C      COMENT  C*32     comment for this card.
C      COMMON /MAPHDR/
C      COMMON /HDRVAL/
C      COMMON /MORPRM/
C   IN/OUT: (In common)
C      ICARD   I         last card in the buffer FITBLK (0-36).
C      TBIND   I         Starting word of current buffer in FITBLK.
C      FITBLK  I(1440)   output work buffer.
C      TAPBUF  I(*)      TAPIO buffers
C   OUTPUT:
C      IERR    I         error code. 0=ok, 1=bad.
C-----------------------------------------------------------------------
      CHARACTER WORD*8, COMENT*32, CARD*80, STR*12
      INTEGER   ITYPE, POINT, IERR
      INTEGER   KPNTR(58), PNTR, POFF, NBYT, ISTART, IC, ITEND, ITRIM
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'CALWR.INC'
      INCLUDE 'CALWR2.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (KPNTR, KHOBJ)
C-----------------------------------------------------------------------
C                                       Decode POINT.
      IERR = 0
      IF ((ITYPE.LT.1) .OR. (ITYPE.GT.11)) GO TO 999
      PNTR = MOD (POINT, 1000)
      POFF = PNTR / 100
      PNTR = MOD (PNTR, 100)
      IF (PNTR.GT.0) PNTR = KPNTR(PNTR)
      NBYT = POINT / 1000
C                                       Go to appropiate data type.
C                                       Special cases start at label
C                                       600.
      GO TO (100, 200, 300, 400, 500, 600, 610, 620, 630, 640,
     *   200), ITYPE
C                                       Logical (always true so far)
 100     WRITE (CARD,1100) WORD, COMENT
         GO TO 800
C                                       Numeric.
C                                       Integer.
 200     IF (NBYT.NE.2) GO TO 210
            IF ((ITYPE.EQ.11) .AND. (CATBLK(PNTR+POFF).EQ.0)) GO TO 999
            WRITE (CARD,1200) WORD, CATBLK(PNTR+POFF), COMENT
            GO TO 800
C                                       Real
 210     IF (NBYT.NE.4) GO TO 220
            IF ((ITYPE.EQ.11) .AND. (CATR(PNTR+POFF).EQ.0.0)) GO TO 999
            WRITE (CARD,1210) WORD, CATR(PNTR+POFF), COMENT
            GO TO 800
C                                       Double precision
 220        IF ((ITYPE.EQ.11) .AND. (CATD(PNTR+POFF).EQ.0.0D0))
     *         GO TO 999
            WRITE (CARD,1220) WORD, CATD(PNTR+POFF), COMENT
            GO TO 800
C                                       Character on real boundary.
 300        WRITE (CARD,1300) WORD, COMENT
C                                       Dates are special
            IF (WORD(:4).EQ.'DATE') THEN
               ISTART = NBYT * POFF  +  1
               STR  = ' '
               CALL H2CHR (NBYT, ISTART, CATH(PNTR), STR)
               CALL DATFST ('L2F', STR)
               NBYT = ITRIM (STR)
               CARD(12:11+NBYT) = STR(:NBYT)
            ELSE
               ISTART = NBYT * POFF  +  1
               CALL H2CHR (NBYT, ISTART, CATH(PNTR), CARD(12:11+NBYT))
               END IF
            ITEND = NBYT + 12
            CARD(ITEND:ITEND) = ''''
            GO TO 800
C                                       Character on integer boundary.
 400        WRITE (CARD,1300) WORD, COMENT
            ITEND = NBYT + 12
            ISTART = NBYT * POFF  +  1
            CALL H2CHR (NBYT, ISTART, CATH(PNTR), CARD(12:11+NBYT))
            CARD(ITEND:) = ''''
            GO TO 800
C                                       Image scaling parameter.
 500        IF (WORD.EQ.'BSCALE') WRITE (CARD,1220) WORD, 1.0D0, COMENT
            IF (WORD.EQ.'BZERO') WRITE (CARD,1220) WORD, 0.0D0, COMENT
            GO TO 800
C                                       Get scaling factors from
C                                       common MORPRM.
 600        PNTR = MOD (POINT, 100)
            WRITE (CARD,1220) WORD, 1.0D0, COMENT
            GO TO 800
C                                       Get offsets from MORPRM.
 610        PNTR = MOD (POINT, 100)
            WRITE (CARD,1220) WORD, 0.0D0, COMENT
            GO TO 800
C                                       Get RP type from MORPRM
 620        PNTR = MOD (POINT, 100)
            WRITE (CARD,1300) WORD, COMENT
            ITEND = NBYT + 12
            CARD(12:11+NBYT) = ' '
            CARD(ITEND:) = ''' '
            GO TO 800
C                                       Blanking
 630        IF (CATR(PNTR+POFF).EQ.0) GO TO 999
            IF (IFMTYP.EQ.1) WRITE (CARD,1630) WORD
            IF (IFMTYP.EQ.2) WRITE (CARD,1631) WORD
            IF (IFMTYP.EQ.3) WRITE (CARD,1632)
            GO TO 800
C                                       Value given by POINT.
 640        WRITE (CARD,1200) WORD, POINT, COMENT
C                                       Put card into buffer.
 800  IF (ICARD.GE.36) CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 999
      ICARD = ICARD + 1
C                                       Put card in buffer.
      IC = 80 * (ICARD - 1)  +  1
      CALL FITCHM (CARD, IC, FITBLK)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT (A8,'= ',19X,'T /',A)
 1200 FORMAT (A8,'= ',I20,' /',A)
 1210 FORMAT (A8,'= ',1PE20.9,' /',A)
 1220 FORMAT (A8,'= ',1PE20.11,' /',A)
 1300 FORMAT (A8,'= ''',19X,' /',A)
 1630 FORMAT (A8,'= ',14X,'-32768 / Blanked pixel tape value')
 1631 FORMAT (A8,'= ',9X,'-2147483648 / Blanked pixel tape value')
 1632 FORMAT ('COMMENT / IEEE not-a-number used for blanked',
     *   ' f.p. pixels')
      END
      SUBROUTINE FITHIS (IERR)
C-----------------------------------------------------------------------
C   This routine will write the general history information to tape.
C   An END card is NOT written.
C   In/out:  (in common)
C      ICARD    I         The last card written in FITBLK  (1:36)
C      TBIND    I         TAPBUF(TBIND) is the start of the current I/O
C                         buffer.
C      FITBLK   I(1440)   header buffer
C      TAPBUF   I(*)      TAPIO buffers
C   Output:
C      IERR     I         error code. 0=ok, 1=bad>
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   NGNU
      PARAMETER (NGNU = 26)
      CHARACTER COFITS(2)*72, GPLTXT(2,NGNU)*35, GPLTX1(2,10)*35,
     *   GPLTX2(2,10)*35, GPLTX3(2,NGNU-20)*35, CTEMP*4
      HOLLERITH IBUFF(256)
      INTEGER   I, IC, ID(3)
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'CALWR.INC'
      INCLUDE 'CALWR2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (IBUFF, BUFF)
      EQUIVALENCE (GPLTXT(1,1), GPLTX1(1,1))
      EQUIVALENCE (GPLTXT(1,11), GPLTX2(1,1))
      EQUIVALENCE (GPLTXT(1,21), GPLTX3(1,1))
      DATA GPLTX1 /'-----------------------------------',
     *             '-----------------------------------',
     *             '  Copyright (C)                    ',
     *             '                                   ',
     *             '  Associated Universities, Inc. Was',
     *             'hington DC, USA.                   ',
     *             '                                   ',
     *             '                                   ',
     *             '  This program is free software; yo',
     *             'u can redistribute it and/or       ',
     *             '  modify it under the terms of the ',
     *             'GNU General Public License as      ',
     *             '  published by the Free Software Fo',
     *             'undation; either version 2 of      ',
     *             '  the License, or (at your option) ',
     *             'any later version.                 ',
     *             '                                   ',
     *             '                                   ',
     *             '  This program is distributed in th',
     *             'e hope that it will be useful,     '/
      DATA GPLTX2 /'  but WITHOUT ANY WARRANTY; without',
     *             ' even the implied warranty of      ',
     *             '  MERCHANTABILITY or FITNESS FOR A ',
     *             'PARTICULAR PURPOSE.  See the       ',
     *             '  GNU General Public License for mo',
     *             're details.                        ',
     *             '                                   ',
     *             '                                   ',
     *             '  You should have received a copy o',
     *             'f the GNU General Public           ',
     *             '  License along with this program; ',
     *             'if not, write to the Free          ',
     *             '  Software Foundation, Inc., 675 Ma',
     *             'ssachusetts Ave, Cambridge,        ',
     *             '  MA 02139, USA.                   ',
     *             '                                   ',
     *             '                                   ',
     *             '                                   ',
     *             '  Correspondence concerning AIPS sh',
     *             'ould be addressed as follows:      '/
      DATA GPLTX3 /'         Internet email: aipsmail@n',
     *             'rao.edu.                           ',
     *             '         Postal address: AIPS Proje',
     *             'ct Office                          ',
     *             '                         National R',
     *             'adio Astronomy Observatory         ',
     *             '                         520 Edgemo',
     *             'nt Road                            ',
     *             '                         Charlottes',
     *             'ville, VA 22903-2475 USA           ',
     *             '-----------------------------------',
     *             '-----------------------------------'/
C-----------------------------------------------------------------------
      IERR = 0
      COFITS(1) = '  FITS (Flexible Image Transport System) format is'
     *   // ' defined in ''Astronomy'
      COFITS(2) = '  and Astrophysics'', volume 376, page 359;' //
     *   ' bibcode: 2001A&A...376..359H'
C                                       ORIGIN keyword
      IF (ICARD.GE.36) CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 999
      ICARD = ICARD + 1
      IC = 80 * ICARD - 79
      WRITE (MSGTXT,1000) HSTNAM, SYSNAM, RLSNAM
      CALL FITCHM (MSGTXT, IC, FITBLK)
C                                       history: FITS ref 1 and 2
      DO 10 I = 1,2
         IF (ICARD.GE.36) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 999
         ICARD = ICARD + 1
         IC = 80 * ICARD - 79
         MSGTXT = 'COMMENT ' // COFITS(I)
         CALL FITCHM (MSGTXT, IC, FITBLK)
 10      CONTINUE
C                                       copyleft
      CALL ZDATE (ID)
      IF (ID(1).LT.200) ID(1) = ID(1) + 1900
      WRITE (CTEMP,1010) ID(1)
      GPLTXT(1,2)(17:20) = CTEMP
      DO 20 I = 1,NGNU
         IF (ICARD.GE.36) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 999
         ICARD = ICARD + 1
         IC = 80 * ICARD - 79
         MSGTXT = 'HISTORY ' // GPLTXT(1,I) // GPLTXT(2,I)
         CALL FITCHM (MSGTXT, IC, FITBLK)
 20      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ORIGIN  = ''AIPS',A12,1X,A20,1X,A7,'''',4X,'/ ')
 1010 FORMAT (I4)
      END
      SUBROUTINE WRTAPE (ITFULL, IERR)
C-----------------------------------------------------------------------
C   Writes TAPBUF to tape and resets counters.
C   INPUTS:
C      ITFULL  I        Number values filled in buffer (will zero fill)
C   Inputs via common:
C      FDVEC   I(40)    File descriptor vector for TAPIO output
C      FITBLK  I(*)     header buffer
C      TAPBUF  I(*)     TAPIO buffers
C      IFMTYP  I        Desired format in FITBLK
C   In/Out via common:
C      TBIND   I      starting index of current buffer in TAPBUF.
C   Outputs:
C      IERR    I      IO error code.
C-----------------------------------------------------------------------
      REAL      FITBR4(1440)
      INTEGER   FITBI4(1440)
      INTEGER   ITFULL, ITMAX, IERR, I, ITZ
      INCLUDE 'CALWR.INC'
      INCLUDE 'CALWR2.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (FITBLK, FITBI4, FITBR4)
C-----------------------------------------------------------------------
C                                       Write this buffer to tape.
      ITMAX = 720
      IF (IFMTYP.EQ.1) ITMAX = 1440
      ITZ = ITMAX - ITFULL
      IF (ITZ.LE.0) GO TO 100
         GO TO (10, 30, 50), IFMTYP
 10      CONTINUE
            DO 20 I = 1,ITZ
               FITBLK(I+ITFULL) = 0
 20            CONTINUE
            GO TO 100
 30      CONTINUE
            DO 40 I = 1,ITZ
               FITBI4(I+ITFULL) = 0
 40            CONTINUE
            GO TO 100
 50      CONTINUE
            DO 60 I = 1,ITZ
               FITBR4(I+ITFULL) = 0.0
 60            CONTINUE
C                                       translate
 100  IF (IFMTYP.EQ.1) CALL ZILI16 (ITMAX, FITBLK, 1, TAPBUF(TBIND))
      IF (IFMTYP.EQ.2) CALL ZILI32 (ITMAX, FITBLK, 1, TAPBUF(TBIND))
      IF (IFMTYP.EQ.3) CALL ZRLR32 (ITMAX, 1, FITBR4, TAPBUF(TBIND))
C                                       write
      CALL TAPIO ('WRIT', FDVEC, TAPBUF, TBIND, IERR)
C
 999  RETURN
      END
      SUBROUTINE FITCHM (TEXT, IC, BUFFER)
C-----------------------------------------------------------------------
C   FITCHM moves TEXT to BUFFER 80-charcter strings converting to
C   real world characters.
C   Inputs/outputs:
C      TEXT    C*80      text line:
C      IC      I          pointer to char loc for text
C      BUFFER  I(*)       buffer to hold n lines
C-----------------------------------------------------------------------
      CHARACTER TEXT*80
      INTEGER   IC, BUFFER(*)
C-----------------------------------------------------------------------
      CALL ZCLC8 (80, TEXT, IC, BUFFER)
      IC = IC + 80
C
 999  RETURN
      END
      SUBROUTINE FT2CHM (TEXT, ICARD, BUFFER)
C-----------------------------------------------------------------------
C   FT2CHM moves TEXT to BUFFER converting to real world characters.
C   Inputs/outputs:
C      TEXT     C*80   text line:
C      ICARD    I      pointer to char loc for text
C      BUFFER   I(*)   buffer to hold n lines
C-----------------------------------------------------------------------
      CHARACTER TEXT*80
      INTEGER   ICARD, BUFFER(*)
C
      INTEGER   IC
C-----------------------------------------------------------------------
      ICARD = ICARD + 1
      IC = 80 * ICARD - 79
      CALL ZCLC8 (80, TEXT, IC, BUFFER)
C
 999  RETURN
      END
      SUBROUTINE WRCTAP (IERR)
C-----------------------------------------------------------------------
C   WRCTAP writes a tape record of FITS character data.
C   The data in FITBLK must already have been converted into real world
C   characters.
C   Output:  IERR   I     Error code of IO routines.
C-----------------------------------------------------------------------
      INTEGER   IERR, IL
      INCLUDE 'CALWR.INC'
      INCLUDE 'CALWR2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Copy to buffer
      IL = 2880 / (NBITWD/8)
      CALL COPY (IL, FITBLK, TAPBUF(TBIND))
      CALL TAPIO ('WRIT', FDVEC, TAPBUF, TBIND, IERR)
      ICARD = 0
C
 999  RETURN
      END
      SUBROUTINE FITEXT (IER)
C-----------------------------------------------------------------------
C   FITEXT copies AIPS tables files to the FITS output file.  All
C   tables will be written as 3-D tables unless DOASC=.TRUE.; in this
C   case, all files which can be written as ASCII tables will be
C   written thus and others will be written as 3-D tables.
C   Output:  IER    I     Error number: 0 => none
C                           else count of errors or tape IO error #
C-----------------------------------------------------------------------
      INTEGER   IER
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER TTYPE*2
      INTEGER   NEXTF, IVER
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'CALWR.INC'
      INCLUDE 'CALWR2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       Loop for all extension files.
      CALL FXHDEX (CATBLK)
      NEXTF = KHEXT + KIEXTN - 1
      TTYPE = 'CC'
      IVER = 1
      CALL EXTWRT (TTYPE, IVER, IER)
C
 999  RETURN
      END
      SUBROUTINE EXTWRT (TTYPE, IVER, IER)
C-----------------------------------------------------------------------
C   EXTWRT copies a single, specified AIPS table file to the FITS
C   output file.  Table will be written as 3-D tables unless
C   DOASC=.TRUE.; in this case, a file which can be written as an ASCII
C   table will be  written thus else it will be written as a 3-D table.
C   Inputs:
C      TTYPE   C*2   Extension table type, 2 char.
C      IVER    I     Version number.
C   Output:
C      IER     I     Error number: 0 => none
C                       else count of errors or tape IO error #
C-----------------------------------------------------------------------
      INTEGER   IER
C
      INCLUDE 'INCS:PUVD.INC'
C                                       XBPRSZ is maximum size of an
C                                       array in a table record in real
C                                       words, worst case is bandpass
C                                       table.
      CHARACTER COLHDR(128)*24, UNITS(128)*8, KWNAME*8, TTYPE*2,
     *   FORM3D*8, FORMXX*8, FORCOD(7)*1, FORM(7)*8, TYPTAB(2)*8,
     *   FRMOUT*8, STARS*32, CHTMP*10
      HOLLERITH RECH(XBPRSZ), HVALUE(2)
      DOUBLE PRECISION RECORD(XBPRSZ/2), DVALUE, RECRD(XBPRSZ/2),
     *   DLINE(XBPRSZ/2)
      REAL      RLINE(XBPRSZ), RECRR(XBPRSZ), RVALUE
      INTEGER   NREC, RECI(XBPRSZ), IRNO, JVALUE,
     *   IPAIR, SUMBYT, MXTEST, MAXL, CH1, CHEND
      LOGICAL   EXIST, TABLE, RECL(XBPRSZ), FITASC, IS3D
      INTEGER   IVER, LUN, IFORMT(128), BUFFER(512), IC, I, II, ITRIM,
     *   IERR, IFLEN(128), ITLEN(7), ITYPE, NKEY, NCOL, DATP(128,2),
     *   ICRDL, INCRD, IL, IRCODE, IDUM,ILEN, IBCOL(128), MINLEN, IOFF,
     *   ILEN0, JJ, SRTORD, TBTYP, NUMFOR, NUMBYT(7), ILINE(XBPRSZ),
     *   NCOPY, NEXT, TCOUNT(128), TPTYPE(128), TOFF(128),
     *   ITNCOL, FLAGD, RECOUT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'CALWR.INC'
      INCLUDE 'CALWR2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (BUFF, BUFFER)
      EQUIVALENCE (DVALUE, HVALUE)
      EQUIVALENCE (DLINE, RLINE, ILINE)
      EQUIVALENCE (RECORD, RECRD, RECRR, RECI, RECL, RECH)
      DATA FORCOD /'D','E','A','J','L','I','X'/
      DATA STARS /'********************************'/
      DATA NUMBYT / 8, 4,  1,  4,  1,  2,  1/
      DATA MAXL /XBPRSZ/
      DATA LUN /28/
      DATA FORM /'D24.15  ','E15.6   ','        ',
     *   'I12     ','A1      ', 'I6      ','        '/
      DATA ITLEN /24, 15, 0, 12, 0, 6, 0/
      DATA TYPTAB /'A3DTABLE',  'BINTABLE'/
C-----------------------------------------------------------------------
      IER = 0
      ILEN0 = 160
      IS3D = .TRUE.
C                                       See if we have a table.
      CALL ISTAB (TTYPE, IVOL, ICNO, IVER, LUN, BUFFER, TABLE, EXIST,
     *   FITASC, IERR)
      IF (.NOT.EXIST) GO TO 999
      IF (.NOT.TABLE) GO TO 999
      CALL TABINI ('READ', TTYPE, IVOL, ICNO, IVER, CATBLK, LUN, NKEY,
     *   IDUM, NCOL, DATP, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 999
      NREC = BUFFER(5)
C                                       Count the unflagged records.
C                                         This will have to be revised.
      FLAGD = 0
      DO 10 IRNO = 1,NREC
         CALL TABIO ('READ', IRCODE, IRNO, RECI, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.-1)) GO TO 999
C                                       IERR=-1 is flagged row.
         IF (IERR.EQ.-1) FLAGD = FLAGD + 1
         IERR = 0
 10      CONTINUE
C                                       Let the user know.
C
      RECOUT = NREC - FLAGD
      IF (FLAGD.GT.0) THEN
         WRITE (MSGTXT,1010) RECOUT
         CALL MSGWRT (4)
         WRITE (MSGTXT,1011) NREC, TTYPE, IVER
         CALL MSGWRT (4)
         ENDIF
C                                       Everything you need to know
C                                       about the columns.
      CALL GETHUT (NCOL, DATP, BUFFER, COLHDR, UNITS,
     *   IFORMT, IFLEN, IERR)
C                                       Determine col start positions
C                                       and number of bytes for 3-D
      II = IFORMT(1)
      SUMBYT = IFLEN(1) * NUMBYT(II)
      IF (II.EQ.7) SUMBYT = 1 + (IFLEN(1)-1) / NBITWD
      IBCOL(1) = 1
      DO 40 I = 2,NCOL
         II = IFORMT(I-1)
         IBCOL(I) = IBCOL(I-1) + ITLEN(II) + IFLEN(I-1) + 1
         II = IFORMT(I)
         IF (II.NE.7) SUMBYT = SUMBYT + IFLEN(I) * NUMBYT(II)
         IF (II.EQ.7) SUMBYT = SUMBYT + 1 + (IFLEN(I)-1)/NBITWD
 40      CONTINUE
      II = IFORMT(NCOL)
      IF (II.EQ.7) MINLEN = IBCOL(NCOL) +
     *   (IFLEN(I-1) - 1) / 4 + 1
      IF (II.NE.7) MINLEN = IBCOL(NCOL) + ITLEN(II) + IFLEN(II)
C                                       Make card length a multiple of
C                                       60 to make things simple.
      ICRDL = 60 * (MINLEN / 60  +  1)
      INCRD = 2880 / ICRDL
C                                       We did not reserve enuf buffer
C                                       size in array LINE or RLINE
      MXTEST = (MAXL * 2)
      IF (SUMBYT.GT.MXTEST) THEN
         WRITE (MSGTXT,1040) ICRDL
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Table header
      ICARD = 0
C                                       Table type
      TBTYP = 2
C                                       Tell user table and type
      WRITE (MSGTXT,1015) TTYPE
      CALL MSGWRT (3)
      WRITE (MSGTXT,1050) TYPTAB(TBTYP)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1051)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1052)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1053) SUMBYT
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1054) RECOUT
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1055)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1056)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1057) NCOL
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1058) TTYPE
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1059) IVER
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      DO 80 I = 1,NCOL
         IF (I.LT.10) WRITE (MSGTXT,1060) I, IBCOL(I)
         IF (I.GE.10) WRITE (MSGTXT,1061) I, IBCOL(I)
C         IF (.NOT.IS3D) CALL FT2CHM (MSGTXT, ICARD, FITBLK)
         IF (ICARD.GT.35) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 900
         II = IFORMT(I)
         IF (II.NE.3) GO TO 70
C                                       Try to get character format
C                                       into the right form.
            WRITE (MSGTXT,1062) IFLEN(I)
            CALL CHTRIM (MSGTXT, 8, MSGTXT, ILEN)
            FORM(3) = 'A' // MSGTXT(1:ILEN)
 70      CONTINUE
C                                       Get correct format for file type
         FRMOUT = FORM(II)
C                                       3-D tables
         WRITE (FORM3D,1076) IFLEN(I), FORCOD(II)
         FORMXX = '        '
         CALL CHTRIM (FORM3D, 8, FORMXX, NUMFOR)
         FRMOUT = FORMXX
         IF (I.LT.10) WRITE (MSGTXT,1070) I, FRMOUT, I
         IF (I.GE.10) WRITE (MSGTXT,1071) I, FRMOUT, I
         CALL FT2CHM (MSGTXT, ICARD, FITBLK)
         IF (ICARD.GT.35) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 900
         IF (I.LT.10) WRITE (MSGTXT,1072) I, COLHDR(I)(1:16), I
         IF (I.GE.10) WRITE (MSGTXT,1073) I, COLHDR(I)(1:16), I
         CALL FT2CHM (MSGTXT, ICARD, FITBLK)
         IF (ICARD.GT.35) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 900
         IF (I.LT.10) WRITE (MSGTXT,1074) I, UNITS(I), I
         IF (I.GE.10) WRITE (MSGTXT,1075) I, UNITS(I), I
         CALL FT2CHM (MSGTXT, ICARD, FITBLK)
         IF (ICARD.GT.35) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 900
 80      CONTINUE
C                                       Do all KeyWord value pairs.
      NKEY = BUFFER(53)
      IF (NKEY.GE.1) THEN
         DO 240 IPAIR = 1,NKEY
            CALL GTPAIR (IPAIR, BUFFER, KWNAME, DVALUE, ITYPE)
            IF (ITYPE.EQ.0) GO TO 240
            GO TO (120, 140, 160, 180, 200), ITYPE
C                                       Double Precision.
 120           WRITE (MSGTXT,1120) KWNAME, DVALUE
               GO TO 230
C                                       Real.
 140           RVALUE = DVALUE
               WRITE (MSGTXT,1140) KWNAME, RVALUE
               GO TO 230
C                                       Character.
 160           CALL H2CHR (8, 1, HVALUE, CHTMP)
               IF (INDEX(KWNAME,'DATE').GT.0) CALL DATFST ('L2F', CHTMP)
               I = MAX (8, ITRIM (CHTMP))
               WRITE (MSGTXT,1160) KWNAME, CHTMP(:I)
               GO TO 230
C                                       Integer.
 180           IF (DVALUE.LT.0.0D0) JVALUE = DVALUE - 0.01D0
               IF (DVALUE.GE.0.0D0) JVALUE = DVALUE + 0.01D0
               WRITE (MSGTXT,1180) KWNAME, JVALUE
               GO TO 230
C                                       Logical.
 200           IF (DVALUE.GT.0.0D0) WRITE (MSGTXT,1200) KWNAME
               IF (DVALUE.LE.0.0D0) WRITE (MSGTXT,1202) KWNAME
               GO TO 230
C                                       Integer (short no longer valid)
C 220           IER = 5
C               MSGTXT = 'SHORT INTEGERS NO LONGER VALID'
C               CALL MSGWRT (8)
C               GO TO 999
C
 230        CALL FT2CHM (MSGTXT, ICARD, FITBLK)
            IF (ICARD.GT.35) CALL WRCTAP (IERR)
 240        CONTINUE
         END IF
C                                       Sort order.
      SRTORD = BUFFER(43)
      IF (SRTORD.NE.0) THEN
         WRITE (MSGTXT,1230) SRTORD
         CALL FT2CHM (MSGTXT, ICARD, FITBLK)
         IF (ICARD.GT.35) CALL WRCTAP (IERR)
         END IF
C                                       END card.
      WRITE (MSGTXT,1240)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
C                                       Blank fill rest of block.
      IC = 80 * ICARD  + 1
      IL = 2881 - IC
      IF (IL.GT.0) THEN
         LINE (IC:2880) = '                  '
         CALL ZCLC8 (IL, LINE(IC:2880), IC, FITBLK)
         END IF
      CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Decide file type
      IF (IS3D) GO TO 500
C                                       ASCII format table
C                                       Table data
      IRCODE = 0
      DO 340 IRNO = 1,NREC
         CALL TABIO ('READ', IRCODE, IRNO, RECI, BUFFER, IERR)
         IF (IERR.EQ.-1) GO TO 340
            IF (IERR.EQ.0) GO TO 270
               WRITE (MSGTXT,1245) IERR
               CALL MSGWRT (6)
               DO 260 II = 1, NCOL
                  ITYPE = IFORMT(II)
                  ILEN = ITLEN(ITYPE) + IFLEN(II)
                  LINE(IBCOL(II):IBCOL(II)+ILEN-1) = STARS(1:ILEN)
 260              CONTINUE
               GO TO 320
 270        CONTINUE
            IF (ICARD.GE.INCRD) CALL WRCTAP (IERR)
            IF (IERR.NE.0) GO TO 900
            IC = ICRDL * ICARD + 1
            ICARD = ICARD + 1
            LINE(1:ICRDL) = '     '
C                                       Put each column value in the
C                                       card line.
            DO 300 II = 1,NCOL
               ITYPE = IFORMT(II)
               ILEN = ITLEN(ITYPE) + IFLEN(II)
               IOFF = DATP(II,1)
               CH1 = IBCOL(II)
               CHEND = CH1 + ILEN - 1
               GO TO (281, 282, 283, 284, 285, 286), ITYPE
C                                       Double precision.
 281              WRITE (LINE(CH1:CHEND),1281) RECRD(IOFF)
                  GO TO 295
C                                       Real.
 282              WRITE (LINE(CH1:CHEND),1282) RECRR(IOFF)
                  GO TO 295
C                                       Character
 283              CALL H2CHR (ILEN, 1, RECH(IOFF), LINE(CH1:CHEND))
                  GO TO 295
C                                       Integer.
 284              WRITE (LINE(CH1:CHEND),1284) RECI(IOFF)
                  GO TO 295
C                                       Logical
 285              IF (RECL(IOFF)) WRITE (LINE(CH1:CHEND),1285)
                  IF (.NOT.RECL(IOFF)) WRITE (LINE(CH1:CHEND),1286)
                  GO TO 295
C                                       Integer (short no longer valid)
 286              IER = 5
                  MSGTXT = 'SHORT INTEGERS NO LONGER VALID'
                  CALL MSGWRT (8)
                  GO TO 999
C
 295           CONTINUE
 300           CONTINUE
 320         CONTINUE
            CALL ZCLC8 (ICRDL, LINE, IC, FITBLK)
 340     CONTINUE
C                                       Last record flush
      IC = ICRDL * ICARD + 1
      IL = 2881 - IC
      IF (IL.LT.2880) THEN
         IF (IL.GT.0) THEN
            LINE (IC:2880) = '                  '
            CALL ZCLC8 (IL, LINE(IC:2880), IC, FITBLK)
            END IF
         IL = 2880 / (NBITWD/8)
         CALL COPY (IL, FITBLK, TAPBUF(TBIND))
         CALL TAPIO ('WRIT', FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      CALL TABIO ('CLOS', IRCODE, IRNO, RECI, BUFFER, IERR)
      GO TO 999
C                                       3-D table
 500  IRCODE = 0
C                                       Table control info
      DO 510 II = 1,NCOL
         TPTYPE(II) = IFORMT(II)
         TCOUNT(II) = IFLEN(II)
         TOFF(II) = DATP(II,1)
 510     CONTINUE
C                                       Compress table if possible
      ITNCOL = NCOL
      NEXT = 1
      CALL RFILL (720, 0.0, TAPBUF(TBIND))
C
      DO 740 IRNO = 1,NREC
         CALL TABIO ('READ', IRCODE, IRNO, RECI, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 740
C                                       Use RLINE for scratch output
            DO 700 II = 1,ITNCOL
               ITYPE = TPTYPE(II)
               ILEN = TCOUNT(II)
               IOFF = TOFF(II)
               GO TO (560, 580, 600, 620, 640, 660, 670), ITYPE
C                                       Double precision.
 560              CALL ZRLR64 (ILEN, 1, RECRD(IOFF), DLINE)
                  GO TO 680
C                                       Real.
 580              CALL ZRLR32 (ILEN, 1, RECRR(IOFF), ILINE)
                  GO TO 680
C                                       Character
 600              CALL H2CHR (ILEN, 1, RECH(IOFF), LINE)
                  CALL ZCLC8 (ILEN, LINE, 1, ILINE)
                  GO TO 680
C                                       Integer.
 620              CALL ZILI32 (ILEN, RECI(IOFF), 1, ILINE)
                  GO TO 680
C                                       Logical
 640              DO 650 JJ = 1,ILEN
                     IF (RECL(IOFF+JJ-1)) LINE(JJ:JJ) = 'T'
                     IF (.NOT.RECL(IOFF+JJ-1)) LINE(JJ:JJ) = 'F'
 650                 CONTINUE
                  CALL ZCLC8 (ILEN, LINE, 1, ILINE)
                  GO TO 680
C                                       Integer (short no longer valid)
 660              IER = 5
                  MSGTXT = 'SHORT INTEGERS NO LONGER VALID'
                  CALL MSGWRT (8)
                  GO TO 999
C                                       Bit array
 670              CALL ZXLX8 (ILEN, RECI(IOFF), RLINE)
                  GO TO 680
C                                       Copy to output
 680           NCOPY = NUMBYT(ITYPE) * ILEN
               IF (ITYPE.EQ.7) NCOPY = 1 + (ILEN-1) / (NBITWD/2)
               CALL PTF3D (FDVEC, TBIND, NEXT, RLINE, TAPBUF, NCOPY,
     *            IERR)
               IF (IERR.NE.0) GO TO 900
 700           CONTINUE
 740     CONTINUE
C                                       Last record flush
      IF (NEXT.GT.1) THEN
         CALL TAPIO ('WRIT', FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      CALL TABIO ('CLOS', IRCODE, IRNO, RECI, BUFFER, IERR)
      GO TO 999
C                                       Error on I/O
 900  WRITE (MSGTXT,1900) IERR
      CALL MSGWRT (8)
      IER = IERR
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('EXTWRT: WRITING ',I6,' UNFLAGGED ROWS OUT OF ')
 1011 FORMAT (8X,I6,' TOTAL FOR TABLE ',A2,' VERSION ',I3)
 1015 FORMAT ('Writing binary table of type ',A2)
 1040 FORMAT ('BUFFER NOT BIG ENOUGH FOR NEEDED CARD SIZE. BYTES=',I8)
 1050 FORMAT ('XTENSION= ',1H',A8,1H',11X,'/ Extension type')
 1051 FORMAT ('BITPIX  =',20X,'8',1X,'/ Binary data')
 1052 FORMAT ('NAXIS   =',20X,'2',1X,'/ Table is a matrix')
 1053 FORMAT ('NAXIS1  =',13X,I8,1X,'/ Width of table in bytes')
 1054 FORMAT ('NAXIS2  =',13X,I8,1X,'/ Number of entries in table')
 1055 FORMAT ('PCOUNT  =',20X,'0',1X,'/ Random parameter count')
 1056 FORMAT ('GCOUNT  =',20X,'1',1X,'/ Group count')
 1057 FORMAT ('TFIELDS =',19X,I2,1X,'/ Number of fields in each row')
 1058 FORMAT ('EXTNAME = ''AIPS ',A2,1X,'''',11X,'/ AIPS table file')
 1059 FORMAT ('EXTVER  = ',15X,I5,1X,'/ Version number of table')
 1060 FORMAT ('TBCOL',I1,'  = ',15X,I5,1X,'/ Starting Char. pos. of',
     *   ' field',I3)
 1061 FORMAT ('TBCOL',I2 ,' = ',15X,I5,1X,'/ Starting char. pos. of',
     *   ' field',I3)
 1062 FORMAT (I6)
 1070 FORMAT ('TFORM',I1,'  = ''',A8,'''',11X,'/ FORTRAN format',
     *   ' of field',I3)
 1071 FORMAT ('TFORM',I2 ,' = ''',A8,'''',11X,'/ FORTRAN format',
     *   ' of field',I3)
 1072 FORMAT ('TTYPE',I1,'  = ''',A16,'''',3X,'/ Type (heading)',
     *   ' of field',I3)
 1073 FORMAT ('TTYPE',I2,' = ''',A16,'''',3X,'/ Type (heading)',
     *   ' of field',I3)
 1074 FORMAT ('TUNIT',I1,'  = ''',A8,'''',11X,'/ Physical units',
     *   ' of field',I3)
 1075 FORMAT ('TUNIT',I2 ,' = ''',A8,'''',11X,'/ physical units',
     *   ' of field',I3)
 1076 FORMAT (I7,1A1)
 1120 FORMAT (A8,'= ',D25.17)
 1140 FORMAT (A8,'= ',E15.7)
 1160 FORMAT (A8,'= ''',A,'''')
 1180 FORMAT (A8,'= ',I12)
 1200 FORMAT (A8,'=',20X,'T')
 1202 FORMAT (A8,'=',20X,'F')
 1230 FORMAT ('ISORTORD=',I20)
 1240 FORMAT ('END')
 1245 FORMAT ('TABIO RETURNS ERROR',I7,' PROCEED WITH NULL DATA')
 1281 FORMAT (D24.15)
 1282 FORMAT (E15.6)
 1284 FORMAT (I12)
 1285 FORMAT ('T')
 1286 FORMAT ('F')
 1900 FORMAT ('EXTWRT: FITS WRITE ERROR',I7)
      END

LOCAL INCLUDE 'PRBM.INC'
C                                       local include for primary beam
C                                       NSTEP number of points in the
C                                       primary beam calculation
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NSTEP
      PARAMETER (NSTEP = 1000)
      INTEGER   NMAX, BTYPE
      PARAMETER (NMAX = 5000)
      REAL   ASTEP, PRBEAM(NSTEP), POINTE(NMAX), DANTT, LAMBDA, TIMTOL,
     *   COEF, PRBMA, PRBMI, PRBP
      REAL   HPHASR, HAMPFR
      LOGICAL DOONE
      DOUBLE PRECISION DELT, RASH, DECSH, RASHS, DECSHS
      LOGICAL   DOPOIN, DOPHAS, DOPRBM, DOSHFT, FIRST
      COMMON /PRMBM/ DELT, RASH, DECSH, RASHS, DECSHS, ASTEP, PRBEAM,
     *   POINTE, DANTT, LAMBDA, TIMTOL, COEF, PRBMA, PRBMI, PRBP,
     *   HPHASR, HAMPFR,
     *   BTYPE, DOPOIN, DOPHAS, DOPRBM, DOSHFT, FIRST, DOONE
LOCAL END
C
LOCAL INCLUDE 'UVCON.INC'
C                                       Local include for UVCON
      INCLUDE 'PRBM.INC'
C      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
C                                       Max number of elevations at the
C                                       second input file
      INTEGER   NELMAX
      PARAMETER (NELMAX = 100000)
C
      INTEGER   NCOMP(MAXFLD), BCOMP(MAXFLD)
      INTEGER   CATBLK(256), UVBLK(256), SEQOUT, DISINT, NUMHIS,
     *   JBUFSZ, N, MODEL, METHOD, DISOUT, CNOINT, SEQ2, DISK2, VER,
     *   ISTOKE, NFRCHA, NFRGR, NFRTOT,  NNLEV(NMAX), NLINE2,
     *   IAN(NELMAX), SCRTCH(512)
      LOGICAL    DOUTFI, DOIN2F, ONECHA
      HOLLERITH XINFIL(12), XI2FIL(12), XOFILE(12), XNAME2(3),
     *   XCLAS2(2), XNAMOU(3), XCLAOU(2), XCMETH(1), XCMOD(1)
      CHARACTER INFILE*48, I2FILE*48, OFILE*48, NAMOUT*12, CLAOUT*6,
     *   NAME2*12, CLAS2*6, HISCRD(2*NMAX+11)*64, CMETH*4, CMOD*4,
     *   ARNAME*8
      REAL      XS2, XDISK2, XVER, XSOUT, XDISO, XNMAPS, XBCOMP(MAXAFL),
     *   XNCOMP(MAXAFL), XFLUX, FACTOR, SMODEL(7), RASHIF(MAXAFL),
     *   DECSHI(MAXAFL), APARM(10), BPARM(10), CPARM(10),
     *   CNOISE, BUFFER(UVBFSS),BUFF1(UVBFSS), BUFF2(UVBFSS),
     *   BUFF3(UVBFSS), SEFD(NMAX), BANDW, SEFDMI, EFF(NMAX),
     *   NOISTE(NMAX), TSKYZE, RANGPB, PRBMAJ, PRBMIN, PRBPA,
     *   ELEVA(NELMAX), TSYS(NELMAX), EFFEL(NELMAX)
      REAL    DOW
      DOUBLE PRECISION SITELA, SITELO, DELTA, HMIN, HMAX, ELMIN,
     *   BLKMAX, TAU, BLKREJ, FREQNM, LX(NMAX), LY(NMAX), LZ(NMAX),
     *   LXORI(NMAX), LYORI(NMAX), LZORI(NMAX),
     *   DIAM(NMAX), TAUSEC, XCENT, YCENT, ZCENT, GSTIAT
      COMMON /BUFRS/ BUFFER, BUFF1, BUFF2, BUFF3, SCRTCH, JBUFSZ
      COMMON /INPARM/ XINFIL, XI2FIL, XOFILE, XNAME2, XCLAS2, XS2,
     *   XDISK2, XVER, XNAMOU, XCLAOU, XSOUT, XDISO, XNMAPS,  XBCOMP,
     *   XNCOMP, XFLUX, XCMETH, XCMOD, FACTOR, SMODEL, RASHIF, DECSHI,
     *   APARM, BPARM, CPARM, PRBMAJ, PRBMIN, PRBPA, DOW
      COMMON /CHRCOM/ INFILE, I2FILE, NAMOUT, NAME2, CLAS2, CLAOUT,
     *   HISCRD, CMETH, CMOD, ARNAME
      COMMON /CHR2/ OFILE
      COMMON /LOG/ DOUTFI, DOIN2F, ONECHA
      COMMON /MAPHDR/ CATBLK, UVBLK
      COMMON /FRED/ XCENT, YCENT, ZCENT, SITELA, SITELO, DELTA, HMIN,
     *   HMAX, ELMIN, GSTIAT,
     *   LXORI, LYORI, LZORI,
     *   BLKMAX, TAU, LX, LY, LZ, DIAM, BLKREJ, FREQNM, N,
     *   MODEL, METHOD, DISOUT, CNOINT, NUMHIS, SEQOUT, DISINT,
     *   SEQ2, DISK2, VER, BCOMP, NCOMP, ISTOKE, SEFD, BANDW, SEFDMI,
     *   TAUSEC, CNOISE, NFRCHA, NFRGR, NFRTOT, EFF, NOISTE, NNLEV,
     *   TSKYZE, RANGPB, IAN, ELEVA, TSYS, EFFEL, NLINE2
LOCAL END
      PROGRAM UVCON
C-----------------------------------------------------------------------
C! Simulates uv coverage of an arbitrary interferometer array.
C# UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1999-2003, 2005-2010, 2012, 2014-2015, 2019-2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVCON creates an AIPS uv data base and fills with simulated data.
C   See the UVCON EXPLAIN file or Going AIPS for better descriptions
C   of the UV data file and catalog header structure and the contents
C   and structure of the antenna (AN) table.
C   There are sufficient comments in NEWHED to describe simple cases.
C   See Going AIPS for assistance in compiling and linking this task
C   onn your system.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INFILE         INFILE        Input file name. (antenna info.)
C      I2FILE         I2FILE        Second input file name.
C                                   (antenna elevation dependence.)
C      OUTFILE        OFILE         Output file name. (antenna info.)
C      IN2NAME        NAME2         Name of image.
C      IN2CLASS       CLAS2         Class of image.
C      IN2SEQ         SEQ2          Seq. of image.
C      IN2DISK        DISK2         Vol. of image.
C      INVER          VER           Version no. of CC file.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is source name
C      OUTCLASS       CLAOUT        Class of the output uv file.
C                                   Default 'UVDATA'
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISOUT         Disk number of the output file.
C      NMAPS          NMAPS         Number of input images.
C      BCOMP(64)      BCOMP         Start clean component to use
C                                   1 per field.
C      NCOMP(64)      NCOMP         Last Clean component no to use
C                                      1 per field, 0 => all
C      CMETHOD        METHOD        Modeling method:
C                                   'DFT' = FDT method
C                                   'GRID' = gridded FFT method.
C                                   '    ' = DFT.
C      CMODEL         MODEL         Model type, 'COMP'=>CC
C                                   'IMAG'=> image.
C      FACTOR         FACGRD        Multiplicative factor for MODEL
C                                      (default=1.0)
C      SMODEL         SMODEL        MODEL
C                                   1 = Flux density (Jy)
C                                   2 = RA offset (arcsec E. pos)
C                                   3 = Dec offset (arcsec N. pos)
C                                   4-7 model parameters
C      RASHIFT(64)    RASHIF        Shift of the tangent point
C                                   at RA direction
C      DECSHIFT(64)   DECSHI        Shift of the tangent point
C                                   at DEC direction
C      APARM(10)      APARM         User specified array.
C                                   1: nominal frequency, GHz
C                                   2: nominal wavelength, cm
C                                   3: Source declination, deg
C                                   4: Min hour angle, hours
C                                   5: Max hour angle, hours
C                                   6: Min antenna elevation, deg
C                                   7: Integration time, sec
C                                   8: Bandwidth, MHz
C                                   9: Number of freq. channels
C                                   10:Max blockage
C      BPARM(10)      BPARM         User specified array.
C                                   1:  Factor to the calculated
C                                       noise. 0 => 1
C                                      -1 = > 0 (no noise)
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'UVCON.INC'
C      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSCD.INC'
      DATA PRGM /'UVCON '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL UVFILN (PRGM, IRET)
C                                       exit if calculate the OUTFILE
C                                       and BPARM.EQ.0
      IF (IRET .EQ. 10) THEN
         IRET = 0
         GO TO 990
         END IF
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL GETUV (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL FILHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE UVFILN (PRGN, JERR)
C-----------------------------------------------------------------------
C   UVFILN gets input parameters for UVCON and creates an output file.
C   Inputs:  PRGN    C*6       Program name
C   Output:  JERR    I         Error code: 0 => ok
C                                4 => error creating output file.
C                                8 => cannot start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in UVCON for more details.
C
C-----------------------------------------------------------------------
      CHARACTER PRGN*6, OLDNAM*12, DEFNAM*12
      CHARACTER UNITS*8
      REAL   RAINC, DECINC, BEMJ, BEMN, B2PIX
     *   , EPS
      INTEGER  NPX, NPY
      HOLLERITH CATH(256)
      INTEGER  JERR, IERR, IROUND, NPARM, MXFLD, I
      LOGICAL   T, F, WASOME
      REAL      CATR(256)
C      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'UVCON.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (CATR, CATH, CATBLK)
      DATA DEFNAM /'UV DATA FILE'/
      DATA T, F /.TRUE.,.FALSE./
      DATA EPS /0.00001/
C-----------------------------------------------------------------------
C                                       the coefficient for calculating
C                                       the gaussian primary beam
      COEF = 4 * ALOG(2.0)
      CALL RANDIN (JERR)
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      MXFLD = MAXAFL
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
C      NPARM = 59 + 2 * MXFLD
C      NPARM = 71 + 2 * MXFLD
C      NPARM = 71 + 4 * MXFLD
C      NPARM = 74 + 4 * MXFLD
C                                       I2FILE added
C      NPARM = 86 + 4 * MXFLD
C                                       DOW added
C      NPARM = 87 + 4 * MXFLD
C                                       CPARM added
      NPARM = 97 + 4 * MXFLD
      CALL GTPARM (PRGN, NPARM, RQUICK, XINFIL, SCRTCH, IERR)
      IF (IERR.EQ.0) GO TO 10
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
C                                       Crunch input parameters.
C                                       Convert characters
 10   CALL H2CHR (48, 1, XINFIL, INFILE)
C                                       VLA or VLBA
      IF (INFILE(10:13) .EQ. 'VLA-') ARNAME = 'VLA     '
      IF (INFILE(10:13) .EQ. 'VLBA') ARNAME = 'VLBA    '

      CALL H2CHR (48, 1, XI2FIL, I2FILE)
      CALL H2CHR (48, 1, XOFILE, OFILE)
      CALL H2CHR (12, 1, XNAME2, NAME2)
      CALL H2CHR (6, 1, XCLAS2, CLAS2)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (4, 1, XCMETH, CMETH)
      CALL H2CHR (4, 1, XCMOD, CMOD)
C                                       calculate the output file?
      DOUTFI = OFILE(1:1) .NE. ' '
C                                       use the second input file?
      DOIN2F = I2FILE(1:1) .NE. ' '
C                                       Get other input

      CALL GETINP (IERR)
      IF (IERR.NE.0) JERR = IERR
C                                       exit if calculate output file
C                                       and BPARM(10).EQ.0
      IF (DOUTFI .AND. BPARM(10).EQ.0) THEN
         JERR = 10
         GO TO 999
         END IF
C                                       calculate primary beam
C                                       of the array antenna in the
C                                       normalized coordinates
C                                       U = pi * (d/lambda) *sin(theta)
C                                       Consider all antennas are
C                                       identical circular dishes
      BTYPE = BPARM(6) + 0.01
C                                       range of the primary beam
C                                       at one side
      RANGPB = BPARM(9)
C
      IF (RANGPB .LT. 0.01) RANGPB = 2.5
      CALL PRB
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRTCH, IERR)
      IF (JERR.NE.0) GO TO 999
C                                       Crunch input parameters.
      SEQOUT = IROUND (XSOUT)
      SEQ2 = IROUND (XS2)
      DISOUT = IROUND (XDISO)
      DISK2 = IROUND (XDISK2)
C                                       default is 28arcmin- the VLA
C                                       FWHM at L band (21cm)
      IF (PRBMAJ .EQ. 0) PRBMAJ = 0.4666667
      IF (PRBMIN .EQ. 0) PRBMIN = 0.4666667
C                                       convert the gausian primary
C                                       beam paramers to radians
      PRBPA = PRBPA * DG2RAD
      PRBMAJ = PRBMAJ * DG2RAD
      PRBMIN = PRBMIN * DG2RAD
      PRBP = PRBPA
      PRBMA = PRBMAJ
      PRBMI = PRBMIN
C                                       CC file version number
      VER = IROUND (XVER)
C                                       Number of fields
      MFIELD = 1
      IF (XNMAPS.GT.0.0) MFIELD = IROUND (XNMAPS)
C                                       Start component number
      LIMFLX = XFLUX
      NONEG = F
      WASOME = F
      DO 20 I = 1,MFIELD
         IF (I.LE.MAXAFL) THEN
            BCOMP(I) = XBCOMP(I) + 0.1
            BCOMP(I) = MAX (BCOMP(I), 1)
            NCOMP(I) = ABS (XNCOMP(I)) + 0.1
            IF (XNCOMP(I).LE.-0.5) NONEG = T
            IF (NCOMP(I).GT.0) WASOME = T
         ELSE
            BCOMP(I) = 1
            NCOMP(I) = 0
            IF (WASOME) NCOMP(I) = 1000000000
            END IF
   20    CONTINUE
      FACGRD(1) = -FACTOR
      IF (ABS(FACGRD(1)) .LT. 1.0E-20) FACGRD(1) = -1.0
      FACGRD(2) = 1
C                                       Check model
      DOPTMD = ABS (SMODEL(1)) .GT. 1.0E-20
      PTFLX = SMODEL(1)
      PTRAOF = SMODEL(2)
      PTDCOF = SMODEL(3)
      PARMOD(1) = SMODEL(4)
      PARMOD(2) = SMODEL(5)
      PARMOD(3) = SMODEL(6)
      PARMOD(4) = SMODEL(7)
C                                       Consider pointing error?
      DOPOIN = BPARM(3) .GT. EPS
C      DOPOIN = (BPARM(3)+BPARM(4)+BPARM(5)) .GT. EPS
C                                       Consider phase errors?
      DOPHAS = BPARM(3) .LT. 0
      IF(DOPHAS) THEN
         HPHASR = ABS(BPARM(3))
         HAMPFR = BPARM(4)
         DOONE = BPARM(5) .EQ. 0
         END IF
C                                       multiply the model by primary
C                                       beam?
      DOPRBM = BPARM(6) .GT. 0.001
C                                       Shift the UV data by
C                                       RASHIFT, DECSHIFT? or stay the
C                                       tangent point at RA=0, DEC
C                                       =APARM(3)
      DOSHFT = BPARM(8) .LT. 0.01
C                                       IF the difference  of the
C                                       current and  previos time is
C                                       less than TIMTOL, the pointing
C                                       error or the simulated phase
C                                       of the given antenna is
C                                       not changed
      TIMTOL = (BPARM(7)-0.1/60) /60.0/24.0
C                                       Let TIMTOL 0.1sec less
      IF (TIMTOL .LT. 0.01/60.0/24.0) TIMTOL = 1.0/60.0/24.0
C                                       estimate pointing errors for
C                                       the antennas.
      IF (DOPOIN) CALL POERR
C                                       If pointing error or phase
C                                       simulation then
C                                       CMETH=DFT and CMOD = COMP
      IF ((DOPOIN.OR.DOPHAS) .AND.
     *   (CMETH .EQ. 'GRID' .OR. CMOD .EQ. 'IMAG') ) THEN
         WRITE (MSGTXT,1010)
         CALL MSGWRT (8)
         WRITE (MSGTXT,1015)
         CALL MSGWRT (8)
         WRITE (MSGTXT,1020)
         CALL MSGWRT (8)
         CMETH = 'DFT '
         CMOD = 'COMP'
         END IF

C                                       If variable primary beam
C                                       is simulated then
C                                       CMETH=DFT and CMOD = COMP
      IF ((BTYPE .EQ. 5) .AND.
     *   (CMETH .EQ. 'GRID' .OR. CMOD .EQ. 'IMAG') ) THEN
         WRITE (MSGTXT,1070)
         CALL MSGWRT (8)
         WRITE (MSGTXT,1075)
         CALL MSGWRT (8)
         WRITE (MSGTXT,1080)
         CALL MSGWRT (8)
         CMETH = 'DFT '
         CMOD = 'COMP'
         END IF
C                                       Get  modeling method
      METHOD = -1
      IF (CMETH.EQ.'DFT ') METHOD = -1
      IF (CMETH.EQ.'GRID') METHOD = 1
C                                       Get  model type
      MODEL = 0
      IF (CMOD.EQ.'COMP') MODEL = 1
      IF (CMOD.EQ.'IMAG') MODEL = 2
C
C
C                                       Create new header.
      CALL NEWHED (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Get uv header info and
C                                       verify header structure.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Put new values in CATBLK.
C                                       Get naming defaults
      OLDNAM = DEFNAM
      CALL MAKOUT (OLDNAM, '      ', 0, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
C                                       Image type ='UV'
      CALL CHR2H (2, 'UV', KHPTYO, CATH(KHPTY))
      CATBLK(KIIMS) = SEQOUT
C                                       shift UVCREA here from bottom
C                                       Create output file.
      CCNO = 1
      CALL UVCREA (DISOUT, CCNO, SCRTCH, IERR)
      IF (IERR .NE. 0) THEN
         WRITE (MSGTXT,1060) IERR
         JERR = 4
         GO TO 990
         END IF
C                                       Get info on model file(s)
      ISTOKE = 1
      IF (DOPTMD) THEN
         DO3DIM = .FALSE.
      ELSE
         IF (NAME2 .EQ. ' ') THEN
            WRITE (MSGTXT,1025)
            JERR = 1
            GO TO 990
            END IF
         CALL SETGDS (DISOUT, CCNO, NAME2, CLAS2, SEQ2, DISK2, MFIELD,
C         CALL SETGDS (0, 0, NAME2, CLAS2, SEQ2, DISK2, MFIELD,
     *      VER, NCOMP, BCOMP, MODEL, METHOD, BUFF1, BUFF2, ISTOKE,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         IF (MODEL.EQ.2) THEN
            MSGTXT = 'Using images for the source model'
         ELSE
            MSGTXT = 'Using Clean Component source model'
            END IF
         CALL MSGWRT (3)
C                                       Find header parameters of the
C                                       model
         CALL FHEAD (NAME2, CLAS2, SEQ2, DISK2, UNITS, RAINC, DECINC,
     *      BEMJ, BEMN, NPX, NPY, SCRTCH, IERR)
         IF (IERR .NE. 0) THEN
            WRITE (MSGTXT,1030)
            JERR = 1
            GO TO 990
            END IF
C                                       If NPX = 2**(integer)?
         CALL TWON (NPX, IERR)
         IF (IERR .NE. 0) THEN
            WRITE (MSGTXT,1040)
            JERR = 1
            GO TO 990
            END IF

C                                       If NPY = 2**(integer)?
         CALL TWON (NPY, IERR)
         IF (IERR .NE. 0) THEN
            WRITE (MSGTXT,1050)
            JERR = 1
            GO TO 990
            END IF

C
         IF (UNITS(4:7).EQ.'BEAM' .AND. CMOD.EQ.'IMAG') THEN
            WRITE (MSGTXT,1065)
            CALL MSGWRT (8)
C                                       Number of pixels in the beam
C                                       1.1331 = twopi/(8*ln(2))
            B2PIX = ABS(1.1331*(BEMJ*BEMN) / (RAINC*DECINC))
            IF (B2PIX .EQ. 0) THEN
               B2PIX = 1
               WRITE (MSGTXT,1067)
               CALL MSGWRT (8)
               END IF
            FACGRD(1) = FACGRD(1) / B2PIX
            END IF
         END IF
C                                       UVCREA was here
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISOUT
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = 2
C                                       Get SEQ. no. used.
      SEQOUT = CATBLK(KIIMS)
      CALL COPY  (256, CATBLK, UVBLK)
C                                       Write Antenna file.
      CALL ANTFIL
      JERR = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVFILN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('CMETHOD and CMODEL are forced to DFT and COMP')
 1015 FORMAT ('because pointing error you request works only ')
 1020 FORMAT ('if CMETHOD = DFT and CMODEL = COMP.')
 1025 FORMAT ('SMODEL=0 =>the model name (IN2NAME) can not be blank')
 1030 FORMAT ('Error reading header parameters of the model')
 1040 FORMAT ('Number of pixels along the model RA should be 2**n')
 1050 FORMAT ('Number of pixels along the model DEC should be 2**n')
 1060 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1065 FORMAT ('The amplitudes are rescaled by BEAM/PIXEL')
 1067 FORMAT ('There is no data of beam. So the rescaling canceled.')
 1070 FORMAT ('CMETHOD and CMODEL are forced to DFT and COMP')
 1075 FORMAT ('because variable primary beam you request works only')
 1080 FORMAT ('if CMETHOD = DFT and CMODEL = COMP.')
      END
      SUBROUTINE GETUV (IRET)
C-----------------------------------------------------------------------
C   GETUV creates the scratch file with the visibilities corresponding
C   to the calculated noise, adds model and writes the output file
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER PHNAME*48
      DOUBLE PRECISION APCORE(2)
      INTEGER   IRET, IPTRO, LENBU, IA1, IA2, NIOUT, LRECO, KBIND, VO,
     *   BO, NUMVIS, XCOUNT, ISIZE, FRQSEL,
     *   NCHAN, CHAN, LUNINT, INDINT, IH, NUMT, IFR, IFRCHA, IFRGR
      LOGICAL   T, F, DOMSG, DOSUM, ELIOK, ELJOK, BLKIOK, BLKJOK
      LOGICAL   DOINT
      INTEGER   IERR
      INCLUDE 'UVCON.INC'
C                                       Local variables
      DOUBLE PRECISION H, ANBMAX(NMAX), AZ, EL(NMAX), PARANG, FI, FJ,
     *   UANT(NMAX), VANT(NMAX), WANT(NMAX), TIMDAY, HANT,
     *   ANTLON, ANTLAT, XANT, HGRWCH, YANT, ZANT, XYANT, FREQQ,
     *   HTANG, DETANG, HPOIN, DEPOIN, TIMST
      REAL      U, V, W, TEMP, PRODSE, NOISEC, TSKYI, TSKYJ,
     *   TINTI, EFINTI, TINTJ, EFINTJ, ELIDEG, ELJDEG
      INTEGER   I, J, INDEX
C      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSCD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANT.INC'
      DATA LUNINT /17/
      DATA VO, BO, LENBU /0, 1, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Convert GSTIA0 to rad
      GSTIAT=GSTIA0*DG2RAD
      LRECO = LREC
      CALL UVSIZE (LRECO, NVIS, ISIZE)
C                                       Create scratch file.
      CALL SCREAT (ISIZE, SCRTCH, IRET)
      IF (IRET .NE. 0) THEN
         WRITE (MSGTXT,1030) IRET
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Open scrtch file.
      CALL ZPHFIL ('SC', SCRVOL(1), SCRCNO(1), 1, PHNAME, IRET)
      CALL ZOPEN (LUNINT, INDINT, SCRVOL(1), PHNAME, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Init scrtch file for write
C                                       LRECO = length of output rec.
      LRECO = LREC
      CALL UVINIT ('WRIT', LUNINT, INDINT, NVIS, VO, LRECO, LENBU,
     *   JBUFSZ, BUFFER, BO, KBIND, IRET)
      IF (IRET .NE. 0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NUMVIS = 0
      XCOUNT = 0
C
C                                       record visibilities
      NUMT = (HMAX - HMIN) / TAU + 1.0D0
      DO 100 IH = 1, NUMT
         H = HMIN + (IH - 1) * TAU
C                                       H is hour angle at the array
C                                       center
         HGRWCH = H + SITELO
C                                       HGRWCH is hour angle at
C                                       GREENWICH
C         TIMDAY = 0.5D0 + H /TWOPI / 1.00274D0
C         TIMDAY = H / TWOPI / 1.00274D0
C         TIMDAY = DMOD(TIMDAY, 1.0D0)
C                                       Time corresponding to the hour
C                                       angle
         TIMDAY = (HGRWCH-GSTIAT) /TWOPI / 1.00274D0
         IF (IH .EQ. 1) TIMST = TIMDAY
C                                       Make times positive
         IF (TIMST .LE. 0) TIMDAY = TIMDAY + 1.D0/1.00274D0
         DO 20 I = 1, N
C                                       ANBMAX is for blockage
            ANBMAX(I) = 0.0D0
C                                       return back to the absolute
C                                       coordinate relatively the Earth
C                                       center
            XANT = XCENT + LX(I)
            YANT = YCENT + LY(I)
            ZANT = ZCENT + LZ(I)
            XYANT = SQRT(XANT*XANT + YANT*YANT)
C                                       Longitute of the antenna
C                                       Minus before YANT to get
C                                       positive to west.
C                                       All 4 coordinate systems
C                                       are converted to RH!
            ANTLON = ATAN2(-YANT, XANT)
            ANTLAT = ATAN2(ZANT, XYANT)
C                                       HH is hour angle at the given
C                                       antenna
C                                       wrong sign of west ANTLON
C                                       LK 04/26/07
C            HANT = H + ANTLON - SITELO
            HANT = H - ANTLON + SITELO
            HPOIN = HANT - RASH / COS(DELTA)
            DEPOIN = DELTA + DECSH
            CALL GETANG (HPOIN, DEPOIN, ANTLAT, AZ, EL(I), PARANG)
 20         CONTINUE
C                                       RA, DEC depend on DOSHIFT
         HTANG = HGRWCH - RA*DG2RAD
         DETANG = DEC * DG2RAD
         CALL UVANT (HTANG, DETANG, N, LX, LY, LZ, UANT, VANT, WANT)
         DO 40 I = 1,N-1
            DO 30 J = I+1,N
               CALL BLOCK (I, J, UANT, VANT, WANT, DIAM, FI, FJ)
               ANBMAX(I) = MAX (ANBMAX(I), FI)
               ANBMAX(J) = MAX (ANBMAX(J), FJ)
 30            CONTINUE
 40         CONTINUE
         DO 90 I = 1,N-1
            ELIOK = EL(I) .GE. ELMIN
            BLKIOK = ANBMAX(I) .LE. BLKREJ
C                                       TSKY of the antenna I
            IF (EL(I) .GT. 0.1) THEN
               TSKYI = TSKYZE / SIN(EL(I))
            ELSE
               TSKYI = 0
               END IF
            DO 80 J = I+1,N
               ELJOK = EL(J) .GE. ELMIN
               BLKJOK = ANBMAX(J) .LE. BLKREJ
C                                       TSKY of the antenna J
               IF (EL(J) .GT. 0.1) THEN
                  TSKYJ = TSKYZE / SIN(EL(J))
               ELSE
                  TSKYJ = 0
                  END IF
               IF ((BLKIOK .AND. BLKJOK) .AND.
     *            (ELIOK .AND. ELJOK)) THEN
                  IA1 = I
                  IA2 = J
                  IFR = 0
                  DO 60 IFR = 1, NFRTOT
                     IF (NFRGR .EQ. 0) THEN
                        IF (ONECHA) THEN
C                                       one channel UV data
C                                       for each frequency
                           FREQQ = FREQNM + (IFR - 1) * BANDW
                        ELSE
C                                       multi channel data
C                                       UV for the first frequency
                           FREQQ = FREQNM
                           END IF
                     ELSE
C
                        IFRGR = (IFR-1) / NFRCHA + 1
                        IFRCHA = IFR - (IFRGR-1)*NFRCHA
                        FREQQ = CPARM(IFRGR+1)*1.E6 +
     *                     (IFRCHA - 1) * BANDW
                        END IF
C                                       use the VLA/VLBA convention:
C                                       the bigger antenna number is
C                                       subtructed of the smaller one
                     U = (UANT(I)-UANT(J)) * FREQQ / VELITE
                     V = (VANT(I)-VANT(J)) * FREQQ / VELITE
                     W = (WANT(I)-WANT(J)) * FREQQ / VELITE
                     NUMVIS = NUMVIS+1
                     BUFFER(IPTRO+ILOCU) = U
                     BUFFER(IPTRO+ILOCV) = V
                     BUFFER(IPTRO+ILOCW) = W
                     BUFFER(IPTRO+ILOCT) = TIMDAY
C                                       baseline
                     IF (ILOCB.GE.0) THEN
                        BUFFER(IPTRO+ILOCB) = IA1 * 256 + IA2
                     ELSE
                        BUFFER(IPTRO+ILOCA1) = IA1
                        BUFFER(IPTRO+ILOCA2) = IA2
                        BUFFER(IPTRO+ILOCSA) = 1.0
                        END IF
C                                       freqid
C                     BUFFER(IPTRO+ILOCFQ) = IFR


C                                       restore the product of SEFDs
C                                       taking into account the sky
C                                       noise depending on elevation
                     PRODSE = SEFD(I)*(NOISTE(I)+TSKYI) *
     *                  SEFD(J)*(NOISTE(J)+TSKYJ)
C-----------------------------------------
C                                       Interpolate the IN2FILE data
                     DOINT = .TRUE.
                     IF (DOIN2F) THEN
                        ELIDEG = EL(I)*RAD2DG
                        ELJDEG = EL(J)*RAD2DG
                        CALL UVCINT (NLINE2, IAN, ELEVA, TSYS, EFFEL,
     *                     I, ELIDEG, TINTI, EFINTI, IERR)
                        DOINT = DOINT .AND. IERR.EQ.0
                        CALL UVCINT (NLINE2, IAN, ELEVA, TSYS, EFFEL,
     *                     J, ELJDEG, TINTJ, EFINTJ, IERR)
                        DOINT = DOINT .AND. IERR.EQ.0
C                                       remove the efficiency taken
C                                       from INFILE EFF() and substitute
C                                       it by the interpolated value
C                                       EFINT
                        IF (DOINT) PRODSE =
     *                     (SEFD(I)*EFF(I)/EFINTI*TINTI) *
     *                     (SEFD(J)*EFF(J)/EFINTJ*TINTJ)
                        END IF
C------------------------------------------
C                                       NOISEC is the RMS of the
C                                       calculated noise
                     NOISEC = SQRT (PRODSE / 2 / TAUSEC / BANDW)
C
                     IF (ONECHA) THEN
                        INDEX = IPTRO + NRPARM
                     ELSE
                        INDEX = IPTRO + NRPARM + (IFR-1)*3
                        END IF
C                                       TEMP is a random 'gaussian'
C                                       number with mean = 0 and
C                                       RMS = 1
                     CALL NOISE (TEMP)
C                                       Real part of the visibility
                     BUFFER(INDEX) = TEMP * NOISEC * CNOISE
C                                       Image part of the visibility
                     CALL NOISE (TEMP)
                     BUFFER(INDEX + 1) = TEMP * NOISEC * CNOISE
C                                       Weight of the visibility
                     BUFFER(INDEX + 2) = SEFDMI / PRODSE
C                                       Record
C                                       IM, RE, W for each frequency
                     IF (ONECHA) THEN
C
                        XCOUNT = XCOUNT + 1
                        IPTRO = IPTRO + LRECO
                        NIOUT = NIOUT + 1
                        CALL UVDISK('WRIT',LUNINT,INDINT,BUFFER,NIOUT,
     *                     KBIND, IRET)
                        IPTRO = KBIND
                        NIOUT = 0
                        END IF
 60                  CONTINUE
C                                       record all channels
                  IF (.NOT. ONECHA) THEN
                     XCOUNT = XCOUNT + 1
                     IPTRO = IPTRO + LRECO
                     NIOUT = NIOUT + 1
                     CALL UVDISK('WRIT',LUNINT,INDINT,BUFFER,NIOUT,
     *                  KBIND, IRET)
                     IPTRO = KBIND
                     NIOUT = 0
                     END IF
C
                  END IF
 80            CONTINUE
 90         CONTINUE
 100     CONTINUE
C                                       Do history file entries:
      NUMHIS=2*N+11
      WRITE (HISCRD(1),2001) N
      WRITE (HISCRD(2),2002) DELTA * RAD2DG
      WRITE (HISCRD(3),2003) HMIN/TWOPI*24.0D0, HMAX/TWOPI*24.0D0
      WRITE (HISCRD(4),2004) TAU / TWOPI * 86400.0D0
      WRITE (HISCRD(5),2005) ELMIN * RAD2DG
      WRITE (HISCRD(6),2006) BLKREJ
      WRITE (HISCRD(7),2007) SITELA * RAD2DG, SITELO * RAD2DG
      WRITE (HISCRD(8),2008) FREQNM
      WRITE (HISCRD(9),2009) VELITE / FREQNM
      WRITE (HISCRD(10),2010)
      DO  200 I = 1,N
         WRITE (HISCRD(2*I+10),2011) I, LX(I), LY(I), LZ(I), DIAM(I)
         WRITE (HISCRD(2*I+11),2012) I, EFF(I), NOISTE(I), NNLEV(I)
 200     CONTINUE
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNINT, INDINT, BUFFER, NIOUT, KBIND, IRET)
      IF (IRET .NE. 0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, SCRVOL(1), SCRCNO(1), LUNINT, CATBLK, IRET)
C                                       close the scratch file
      CALL ZCLOSE (LUNINT, INDINT, IRET)
      IRET = 0
      CHAN = 1
C      NCHAN = 1
      NCHAN = CATBLK(KINAX+2)
      DOMSG = T
      DOSUM = F
      FRQSEL = -1
C                                       fit UVMSUB inputs
      CNOINT = 1
      DISINT = 0
      CALL UVMSUB (APCORE, DISINT, CNOINT, DISOUT, CCNO, 0, MODEL,
     *   METHOD, CHAN, NCHAN, DOSUM, DOMSG, UVBLK, JBUFSZ, FRQSEL,
     *   BUFF1, BUFF2, BUFF3, IRET)
      IF (.NOT.DOPTMD) CALL UNSETG (BUFF2)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('GETUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('ERROR',I3,' CREATING SCRATCH FILE')
 1150 FORMAT ('GETUV: ERROR',I3,' WRITING VIS FILE')
 2001 FORMAT (' Number of antennas:  ',I3)
 2002 FORMAT (' Declination:  ',F10.5,' degrees')
 2003 FORMAT (' Hour-angle coverage:  ',F10.5,' to ',F10.5,' hours')
 2004 FORMAT (' Integration time:  ',F10.3,' seconds')
 2005 FORMAT (' Minimum allowed elevation angle:  ',F10.5,' degrees')
 2006 FORMAT (' Maximum allowed fractional blockage:  ',F10.5)
 2007 FORMAT (' Site latitude, longitude: ',2F8.3,' deg')
 2008 FORMAT (' Nominal frequency:  ',1PE20.12,' Hz')
 2009 FORMAT (' Nominal wavelength:  ',1PE20.12,' meters')
 2010 FORMAT (' Antenna x-y-z coordinates and diameters (all in ',
     *   'meters):')
 2011 FORMAT (I3,3G16.7, G12.5)
 2012 FORMAT (I3, ' ef=', F5.2, ' T=', F6.1, ' nlev=', I2)
      END
      SUBROUTINE FILHIS
C-----------------------------------------------------------------------
C   FILHIS creates and fills a history file.
C-----------------------------------------------------------------------
      CHARACTER   HILINE*72, ATIME*8, ADATE*12, LABEL*8, TELE*8, OBSR*8
      HOLLERITH CATH(256)
      INTEGER   LUN, I, IERR, TIME(3), DATE(3)
      REAL      CATR(256)
      DOUBLE PRECISION CATD(128)
      LOGICAL   T
      INCLUDE 'UVCON.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATBLK, CATH, CATR, CATD)
      DATA LUN /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Create/open hist. file.
      CALL HICREA (LUN, DISOUT, CCNO, CATBLK, SCRTCH, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 999
C                                       Get current date/time.
 10   CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
C                                       Write first record.
      WRITE (HILINE,1010) TSKNAM, NLUSER, ADATE, ATIME
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       New history
      WRITE (HILINE,1011) TSKNAM, INFILE
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       UV output
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISOUT, LUN,
     *   SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       MODEL
      CALL HENCO2 (TSKNAM, NAME2, CLAS2, SEQ2, DISK2, LUN,
     *   SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       SOURCE
      WRITE (HILINE,2000) TSKNAM, SOURCE
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       Number of visibilities
      WRITE (HILINE,2001) TSKNAM, CATBLK(KIGCN)
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       Telescope, observer name.
      CALL H2CHR (8, 1, CATH(KHTEL), TELE)
      CALL H2CHR (8, 1, CATH(KHOBS), OBSR)
      WRITE (HILINE,2002) TSKNAM, TELE, OBSR
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       primary beam
C
C                                       pointing error
      IF (DOPOIN) THEN
         WRITE (HILINE,2003)
         CALL HIADD (LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 20
         END IF
C                                       multiplication by the primary
C                                       beam
      IF (DOPRBM) THEN
         WRITE (HILINE,2004)
         CALL HIADD (LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 20
         END IF
C                                       AIPS release
      WRITE (HILINE,2010) TSKNAM, RLSNAM
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                      Add any other history.
      IF (NUMHIS.LE.0) GO TO 20
         WRITE (LABEL,1015) TSKNAM
         DO 15 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN, HILINE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 20
 15         CONTINUE
C                                       Close HI file
 20   CALL HICLOS (LUN, T, SCRTCH, IERR)
C                                       Update CATBLK.
      CALL CATIO ('UPDT', DISOUT, CCNO, CATBLK, 'REST', SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FILHIS: ERROR',I3,' CREATE/OPEN HISTORY FILE')
 1010 FORMAT (A6,'/ Image created by user',I5,' at ',A12,2X,A8)
 1011 FORMAT (A6,'INFILE =''',A,'''')
 1015 FORMAT (A6,' /')
 2000 FORMAT (A6,' SOURCE = ''',A8,'''')
 2001 FORMAT (A6,' / Number of visibilities copied=',I9)
 2002 FORMAT (A6,' / Telescope = ',A8,' Observer = ',A8)
 2003 FORMAT ('Pointing errors have been applied')
 2004 FORMAT ('The model nas been multiplied by the primary beam.')
 2010 FORMAT (A6,' RELEASE = ''',A7,' ''')
      END
      SUBROUTINE ANTFIL
C-----------------------------------------------------------------------
C   ANTFIL creates and fills the antenna file.
C-----------------------------------------------------------------------
      HOLLERITH CATH(256)
      INTEGER   IERR, ANVER, LUN, I
      REAL      CATR(256)
      DOUBLE PRECISION JD, GMSTM, GASTM, RATE
C      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'UVCON.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATH, CATR)
      DATA LUN /27/
C-----------------------------------------------------------------------
C                                       Make sure there is antenna info
      IF (N.LE.0) GO TO 999
C                                       Setup for AN table initization
         NUMORB = 0
         NOPCAL = 2
         ANTNIF = 1
C                                       Position of the Earth pole
         POLRXY(1) = 0.0
         POLRXY(2) = 0.0
         UT1UTC = 0.0
         DATUTC = 0.0
         TIMSYS = 'UTC'
C                                       Array name
C         ANAME = 'VLBA'
         ANAME = ARNAME
C                                       Array center (rel to center of
C                                       earth)
         IF (ANAME.EQ.'VLBA') THEN
            ARRAYC(1) = 0
            ARRAYC(2) = 0
            ARRAYC(3) = 0
         ELSE
            ARRAYC(1) = XCENT
            ARRAYC(2) = YCENT
            ARRAYC(3) = ZCENT
            END IF
C                                       Get GST0 and Earth rotation rate
         CALL H2CHR (8, 1, CATH(KHDOB), RDATE)
         CALL JULDAY (RDATE, JD)
         CALL GSTROT (JD, GMSTM, GASTM, RATE)
         GSTIA0 = GMSTM
         DEGPDY = RATE
         SAFREQ = FREQ
         ANFQID = -1
         ANVER = 1
         ANTNIF = 1
         XYZHAN = 'RIGHT'
         TFRAME = ' '
C                                       Create/init file
         CALL ANTINI ('WRIT', SCRTCH, DISOUT, CCNO, ANVER, CATBLK, LUN,
     *      IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *      RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *      TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       init basic AN record
         ANNAME = ' '
         STAXOF = 0.0
         STAXYZ(1) = 0.0D0
         STAXYZ(2) = 0.0D0
         STAXYZ(3) = 0.0D0
         ORBPRM(1) = 0.0D0
         NOSTA = 0
         MNTSTA = 0
         POLAA = 0.0
         POLAB = 0.0
         CALL RFILL (3, 0.0, POLCA)
         CALL RFILL (3, 0.0, POLCB)
         POLTYA = 'R'
         POLTYB = 'L'
         DIAMAN = 0.0
         FWHMAN(1) = 0.0
C                                       AN records
         DO 20 I = 1,N
            IF (ANAME.EQ.'VLA') THEN
               STAXYZ(1) = LXORI(I)
               STAXYZ(2) = LYORI(I)
               STAXYZ(3) = LZORI(I)
            ELSE IF (ANAME.EQ.'VLBA') THEN
               STAXYZ(1) = LXORI(I)
               STAXYZ(2) = LYORI(I)
               STAXYZ(3) = LZORI(I)
            ELSE
               STAXYZ(1) = LX(I)
               STAXYZ(2) = LY(I)
               STAXYZ(3) = LZ(I)
               END IF
            NOSTA = I
            IANRNO = I
            CALL TABAN ('WRIT', SCRTCH, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
            IF (IERR.NE.0) GO TO 990
 20         CONTINUE
C                                       Fill in header and close
         CALL TABIO ('CLOS', 1, IANRNO, ANNAME, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 990
         GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1020) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('ERROR ',I3,' OCCURED WRITING ANTENNA FILE')
      END
      SUBROUTINE NEWHED (IRET)
C-----------------------------------------------------------------------
C   NEWHED is a routine in which the catalog header is constructed.
C   Necessary values can be read in the areas markes "USER CODE
C   GOES HERE".
C
C   NOTE: the AIPS convention for the coordinate reference value
C   for the STOKES axis is that 1,2,3,4 represent I, Q, U, V
C   Stokes parameters and -1,-2,-3,-4 represent RR, LL, RL and
C   LR correlator values.  Currently set for R and L polarization
C   ie Ref. value = -1 and increment = -1.
C
C   The MINIMUM information required here is that
C   required to define the size of the output file; ie.
C      CATBLK(KIGCN)   = I   number of visibility records
C      CATBLK(KIPCN) = Number of random parameters.
C      CATBLK(KIDIM)= the number of axes,
C      CATBLK(KINAX+i) = the dimension of each axis.
C    Input:
C     CATBLK(256)    I     Output catalog header, also CATR, CATD
C                          The OUTNAME, OUTCLASS, OUTSEQ are entered
C                          elsewhere.
C    Output:
C     CATBLK(256)    I     Modified output catalog header.
C     IRET           I     Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER RTYPES(9)*8, TYPES(7)*8, UNITS*8, OBSDAT*8,
     *   TELE*8, OBSR*8, INSTR*8
      HOLLERITH CATH(256)
      INTEGER   I, NAXIS, NRAN, NCHAN, NPOLN, NDIM(7), INDEX, IRET,
     *   XCOUNT, NUMT
      REAL      CATR(256), CRPIX(7), CRINC(7), EPOCH
      DOUBLE PRECISION    CATD(128), CRVAL(7)
      INCLUDE 'UVCON.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE  (CATBLK, CATH, CATR, CATD)
C                                       User definable values
C                                       Random parameters.
C                                         No. random parameters.
      DATA NRAN /7/
C                                         Rand. parm. names.
      DATA RTYPES /'UU-L', 'VV-L', 'WW-L', 'TIME1', 'SUBARRAY',
     *   'ANTENNA1', 'ANTENNA2', 2*' '/
C                                       Uniform axes.
C                                         No. axes.
      DATA NAXIS /5/
C                                         Axes names.
      DATA TYPES /'COMPLEX ','STOKES  ','FREQ    ',
     *   'RA      ','DEC     ',2*'        '/
C                                         Axis dimensions
      DATA NDIM /3,1,1,1,1,0,0/
C                                         Reference values
      DATA CRVAL /1.0D0, -1.0D0, 5*0.0D0/
C                                         Reference pixel.
      DATA CRPIX /7*1.0/
C                                         Coordinate increment.
      DATA CRINC /1.0, -1.0, 0.0, 0.0, 0.0, 2*0.0/
C                                       Epoch of position.
      DATA EPOCH /2000.0/
C                                       Units
      DATA UNITS /'JY      '/
C                                       "Observing" date
      DATA OBSDAT /'20000101'/
C-----------------------------------------------------------------------
C                                       Zero fill CATBLK
      CALL FILL (256, 0, CATBLK)
C                                       Fill axis arrays.
C                                       Random axis names
      DO 10 I = 1,KIPTPN
         INDEX = KHPTP + (I-1) * 2
         IF (I.LE.7) THEN
            CALL CHR2H (8, RTYPES(I), 1, CATH(INDEX))
         ELSE
            CALL CHR2H (8, RTYPES(8), 1, CATH(INDEX))
            END IF
 10      CONTINUE
C                                       Uniform axes
      DO 30 I = 1,KICTPN
C                                       Init dimension
         CATBLK(KINAX+I-1) = NDIM(I)
C                                       Init. increment.
         CATR(KRCIC+I-1) = CRINC(I)
C                                       Init. rotation.
         CATR(KRCRT+I-1) = 0.0
C                                       Init. ref pixel.
         CATR(KRCRP+I-1) = CRPIX(I)
C                                       Init. ref value.
         CATD(KDCRV+I-1) = CRVAL(I)
C                                       Fill axis type from
C                                       TYPES
         INDEX = KHCTP + (I-1) * 2
         CALL CHR2H (8, TYPES(I), 1, CATH(INDEX))
 30      CONTINUE
C                                       Fill in values.
C                                       Fill other character strings.
C                                       Source name
      SOURCE = ' '
C                                       Telescope.
      TELE = ' '
C                                       Receiver
      INSTR = ' '
C                                       Observer name.
      OBSR = ' '
C                                       Set number of axes.
      CATBLK(KIDIM) = NAXIS
      CATBLK(KIPCN) = NRAN
C                                       User ID
      CATBLK(KIIMU) = NLUSER
C                                       Miscellaneous items.
C                                       Epoch.
      CATR(KREPO) = EPOCH
C                                       Convolving beam
      CATR(KRBMJ) = 0.0
      CATR(KRBMN) = 0.0
      CATR(KRBPA) = 0.0
      CATBLK(KINIT) = 0
C                                       Max. min.
      CATR(KRDMX) = 0.0
      CATR(KRDMN) = 0.0
C                                       Shift
      CATR(KRXSH) = 0.0
      CATR(KRYSH) = 0.0
C                                       "Old" (observed) position.
      CATD(KDORA) = 0.0D0
      CATD(KDODE) = 0.0D0
C                                       Rest Frequency
      CATD(KDRST) = 0.0D0
C                                       Alternate ref. value & pixel
      CATD(KDARV) = 0.0D0
      CATR(KRARP) = 0.0
      CATBLK(KIALT) = 0
C                                       Sort order ('**'=>unsorted)
      CALL CHR2H (2, 'TB', 1, CATH(KITYP))
C                                       No magic value blanking.
      CATR(KRBLK) = 0.0
C                                       Units
      CALL CHR2H (8, UNITS, 1, CATH(KHBUN))
C-----------------------------------------------------------------------
C                                       Enter values for data:
C                                       XCOUNT = number of vis. record.
C                                       RA = Right ascension (2000)
C                                          in degrees.
C                                       DEC = Declination in degrees.
C                                       FREQ = frequency of obs in Hz.
C                                       BANDW = bandwidth or channel
C                                           separation.
C                                       NCHAN = Number of freq chan.
C                                       NPOLN = number of polarization
C                                            correlators.
C                                       OBSDAT = Reference date of time
C                                          tags for data as "yyyymmdd"
C                                       SOURCE = source name (8 char)
C                                       TELE = telescope name (8 char)
C                                       INSTR = Receiver name (8 char)
C                                       OBSR = Observers name (8 char)
C
C                                       Figure out file size:
      NUMT = (HMAX - HMIN) / TAU + 1.0D0
      XCOUNT = NUMT * (N * (N-1) / 2)
      IF (ONECHA) THEN
         NCHAN = 1
         XCOUNT = XCOUNT * NFRTOT
      ELSE
         NCHAN = NFRTOT
         END IF
      NPOLN = 1
C                                       Tangent point of the UV data
      RA = 0.0D0
      DEC = DELTA / TWOPI * 360.0D0
C
      FREQ = FREQNM
C                                       Insert values in header.
C                                       Number of vis.
      CATBLK(KIGCN) = XCOUNT
C                                       Position at the reference pixel
      IF (DOSHFT) THEN
         CATD(KDCRV+3) = RA + (RASH/COS(DELTA))*RAD2DG
         CATD(KDCRV+4) = DEC + DECSH*RAD2DG
      ELSE
         CATD(KDCRV+3) = RA
         CATD(KDCRV+4) = DEC
         END IF
C                                       Position of the pointing
C                                       direcrion
      CATD(KDORA) = RA + (RASH/COS(DELTA))*RAD2DG
      CATD(KDODE) = DEC + DECSH*RAD2DG
C                                       Frequency
      CATD(KDCRV+2) = FREQ
C                                       Bandwidth.
      CATR(KRCIC+2) = BANDW
C                                       Number of frequencies.
      CATBLK(KINAX+2) = NCHAN
C                                       Number of polarizations.
      CATBLK(KINAX+1) = NPOLN
C                                       Observing date.
      CALL CHR2H (8, OBSDAT, 1, CATH(KHDOB))
C                                       Object.
      CALL CHR2H (8, SOURCE, 1, CATH(KHOBJ))
C                                       Telescope.
      CALL CHR2H (8, TELE, 1, CATH(KHTEL))
C                                       Receiver
      CALL CHR2H (8, INSTR, 1, CATH(KHINS))
C                                       Observer name.
      CALL CHR2H (8, OBSR, 1, CATH(KHOBS))
C
C                                       Finished.
      IRET = 0
C
 999  RETURN
      END
      SUBROUTINE GETINP (IERR)
C-----------------------------------------------------------------------
C   Routine to ask user for information
C   Input from common:  INFILE  C*48 File name.
C   Output: IERR                I    Return code 0=>OK
C-----------------------------------------------------------------------
      INTEGER   IERR
      INCLUDE 'UVCON.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      N = 0
C                                       Atmosphere noise at zenith
      TSKYZE = BPARM(2)
C                                       Read antenna info from file
      CALL GETANT (INFILE, I2FILE, OFILE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Use a nominal wavelength of 1mm
C                                       if both APARM(1) and APARM(2)
C                                       are less than or equal to zero.
C                                       Otherwise, if APARM(1) is
C                                       greater than zero then use a
C                                       nominal frequency of APARM(1)
C                                       Hz; otherwise, if APARM(2) is
C                                       greater than zero then use a
C                                       nominal wavelength of APARM(2)
C                                       meters:
      IF ((APARM(1).LE.0.0) .AND. (APARM(2).LE.0.0)) THEN
         FREQNM = 299.7924562D9
      ELSE
         IF (APARM(1).GT.0.) THEN
            FREQNM = APARM(1) * 1.0D9
         ELSE
            FREQNM = 2.997924562D10 / APARM(2)
            END IF
         END IF
C                                       wavelength in meters
      LAMBDA = 299.7924562D6 / FREQNM
C                                       declination of the model center
C                                       in degrees
      DELT = APARM(3)
C                                       declination of the model center
C                                       in radians
      DELTA = DELT * DG2RAD
C                                       shift of the tangent point
C                                       for the first field, in arcsec
C                                       RASH is given at the picture
      RASHS = RASHIF(1)
      DECSHS = DECSHI(1)
C                                       shift of the tangent point,
C                                       in radians
      RASH = RASHS / 3600 * DG2RAD
      DECSH = DECSHS / 3600 * DG2RAD
C
      HMIN =  APARM(4) * TWOPI / 24.0D0
      HMAX =  APARM(5) * TWOPI / 24.0D0
      ELMIN = APARM(6) * DG2RAD
C                                       default for APARM(7)=1.E6
C                                       to simulate snapshot
      IF (APARM(7) .EQ. 0) APARM(7) = 1.E6
      TAUSEC = APARM(7)
      TAU = TAUSEC * TWOPI * 1.00274D0 / 86400.0D0
      BANDW = APARM(8) * 1.E6
      IF (BANDW .LT. 0) THEN
C                                       one channel data created
         ONECHA = .TRUE.
         BANDW = -BANDW
      ELSE
C                                       multi channel data created
         ONECHA = .FALSE.
         IF (BANDW .EQ. 0) BANDW = 1.E6
         END IF
      NFRCHA = APARM(9) + 0.01
      IF (NFRCHA .LE. 0) NFRCHA = 1
C                                       Frequency groups (IFs)
      NFRGR = CPARM(1) + 0.01
      NFRTOT = NFRCHA*NFRGR
      IF (NFRGR .LE. 0) NFRTOT = NFRCHA
C                                       Fource ONECHA=.TRUE. IF
C                                       NFRGR .GT. 0
      IF (NFRGR .GT. 0) ONECHA = .TRUE.
C                                       default for APARM(10)=1
C                                       to exclude the blockage
C                                       consideration
      IF (APARM(10) .EQ. 0) APARM(10) = 1
      BLKREJ = APARM(10)
C                                       CNOISE is the factor to
C                                       multiply noise
      IF (BPARM(1) .EQ. 0) THEN
         CNOISE = 1
      ELSE
         IF (BPARM(1) .LT. 0) THEN
            CNOISE = 0
         ELSE
            CNOISE = BPARM(1)
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE GETANT (FILE, FILE2, OUFILE, IERR)
C-----------------------------------------------------------------------
C  This subroutine reads, from an input file specified by name "file",
C  the antenna information.
C  The first (ascii) data record should specify n, the number of
C  elements.
C  The second data record should specify the site latitude and
C  longitude, in degrees.
C  The third record must specify two conversion factors: first,
C  a multiplicative factor for converting antenna coordinates to meters,
C  and, second, a factor for converting antenna diameters to meters.
C  (E.g., if the station coordinates are in nanoseconds and the antenna
C  diameters are in feet, then the two factors that need to be supplied
C  are 0.2997924562 (approximately) and 0.3048 (exactly).)
C  Then, n records must follow, each with eight numbers:  The coordinate
C  system identificator; the three coordinates of the antenna location;
C  antenna diameter; efficiency of the antenna; noise temperature;
C  number of level in the digitizer.
C
C  add reading the second input file: FILE2 with four columns:
C  1. Antenna number
C  2. Elevation
C  3. TSYS
C  4. Efficiency

C   Inputs:
C    FILE     C*48  File name
C    FILE2    C*48  Second file name
C    OUFILE   C*48  output file name
C   Outputs in common:
C    N        I     Number of antennas
C    LX(*)    D     "X" coordinate of antennas (m)
C    LY(*)    D     "Y" coordinate of antennas (m)
C    LZ(*)    D     "Z" coordinate of antennas (m)
C    DIAM(*)  D     Antenna diameters (m)
C    SITELA   D     Site latidude (rad)
C    SITELO   D     Site longitude (rad)
C    ELEVA(*) R     Elevations of antennas
C    TSYS(*)  R     System temperature of antennas
C    EFFEL(*) R     Efficiency of antennas
C   Outputs:
C    IERR     I     Return code, 0=>OK
C-----------------------------------------------------------------------
      CHARACTER FILE*48, FILE2*48, OUFILE*48
      INTEGER   IERR
      INTEGER   NCH
      INTEGER   LUN, LUNPR, FIND, PFIND, NBYTES, KBP, CENTER, NL
      LOGICAL   F
C
      DOUBLE PRECISION XTEMP, YTEMP, ZTEMP, LAT, LONG, ALT
      INTEGER   I, J, COOR, MODE, JT, JTRIM
      REAL  AEFF, NLEV, ALFA, EFFIC, TEMPER, SEFDCU
      CHARACTER LINE*80
      DOUBLE PRECISION CONST1, CONST2, X, SINLA, SINLO, COSLA,
     *   COSLO
C
      INCLUDE 'UVCON.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                       open file for record the output
C                                       file at the equatorial
C                                       coordinate system
      IF (DOUTFI) THEN
         LUNPR = 3
         CALL ZTXOPN ('WRIT', LUNPR, PFIND, OUFILE, F, IERR)
         END IF
C                                       Open input text file for read
      LUN = 10
      CALL ZTXOPN ('READ', LUN, FIND, FILE, F, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1001)
         GO TO 990
         END IF



C                                       Get number of antennas
   10 CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
      IF (IERR.NE.0) GO TO 980
      JT = JTRIM (LINE)
C-----------------------------------
C                                       skip comments
      IF (LINE(1:1) .EQ. ';') THEN
         IF (DOUTFI) THEN
            NCH = JTRIM(LINE)
            CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IERR)
            END IF
         GO TO 10
         END IF
C---------------------------------
C                                       Get value
      KBP = 1
      NBYTES = 80
      CALL GETNUM (LINE, NBYTES, KBP, X)
      N = X + 0.1
C                                       record number of antennas
      IF (DOUTFI) THEN
         WRITE (LINE, 3010) N
         NCH = JTRIM(LINE)
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IERR)
         END IF
C                                       Tell user
      WRITE (MSGTXT,2000) N
      CALL MSGWRT (6)
C                                       get site latitude, longtitude
      CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
      IF (IERR.NE.0) GO TO 980
      JT = JTRIM (LINE)
C                                       Get values of LAT, LONG and ALT
C                                       of the array center
      KBP = 1
      CALL GETNUM (LINE, NBYTES, KBP, X)
      SITELA = X
      CALL GETNUM (LINE, NBYTES, KBP, X)
      SITELO = X
      CALL GETNUM (LINE, NBYTES, KBP, X)
      ALT = X
C                                       record site latitude, longtitude
      IF (DOUTFI) THEN
         WRITE (LINE, 3020) SITELA, SITELO
         NCH = JTRIM(LINE)
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IERR)
         END IF
C                                       Tell user
      WRITE (MSGTXT,2001) SITELA
      CALL MSGWRT (6)
      WRITE (MSGTXT,2100) SITELO
      CALL MSGWRT (6)
      SITELA = SITELA * DG2RAD
      SITELO = SITELO * DG2RAD
C                                       Get conversion constants
      CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
      IF (IERR.NE.0) GO TO 980
      JT = JTRIM (LINE)
C                                       Get values
      KBP = 1
      CALL GETNUM (LINE, NBYTES, KBP, X)
      CONST1 = X
      CALL GETNUM (LINE, NBYTES, KBP, X)
      CONST2 = X
C                                       record conversion constants
      IF (DOUTFI) THEN
         WRITE (LINE, 3030)
         NCH = JTRIM(LINE)
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IERR)
         END IF
C                                       Tell user
      WRITE (MSGTXT,2002) CONST1
      CALL MSGWRT (6)
      WRITE (MSGTXT,2003) CONST2
      CALL MSGWRT (6)
      SINLA = SIN(SITELA)
      SINLO = SIN(SITELO)
      COSLA = COS(SITELA)
      COSLO = COS(SITELO)
C                                       convert geodetic LAT, LONG, ALT
C                                       of the array center to geocenter
C                                       RH equatorial coordinate system
C                                       XCENT, YCENT, ZCENT
      MODE = 0
      CALL GEOXYZ (MODE, SITELO, SITELA, ALT, XCENT, YCENT, ZCENT, IERR)

C                                       Read antenna info
      DO 100 I = 1,N
 20      CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
         IF (IERR.NE.0) GO TO 980
         JT = JTRIM (LINE)
C                                       skip comments
         IF (LINE(1:1) .EQ. ';') THEN
            IF (DOUTFI) THEN
               NCH = JTRIM(LINE)
               CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IERR)
               END IF
            GO TO 20
            END IF
C                                       Get values
         KBP = 1
C                                       Coordinate system
         CALL GETNUM (LINE, NBYTES, KBP, X)
         COOR = X
C
C                                       Do not use the conversion
C                                       factor if position is given in
C                                       LAT, LONG, ALT
         IF (COOR .EQ. 2) CONST1 = 1
C
         CALL GETNUM (LINE, NBYTES, KBP, X)
         LX(I) = X * CONST1
         CALL GETNUM (LINE, NBYTES, KBP, X)
         LY(I) = X * CONST1
         CALL GETNUM (LINE, NBYTES, KBP, X)
         LZ(I) = X * CONST1
         CALL GETNUM (LINE, NBYTES, KBP, X)
         DIAM(I) = X * CONST2
C                                       efficiency of the antenna
         IF (KBP .LE. NBYTES) THEN
            CALL GETNUM (LINE, NBYTES, KBP, X)
            EFFIC = X
            IF (EFFIC .EQ. 0) EFFIC = 0.5
         ELSE
            EFFIC = 0.5
            END IF
         EFF(I) = EFFIC
C                                       Noise temperature
         IF (KBP .LE. NBYTES) THEN
            CALL GETNUM (LINE, NBYTES, KBP, X)
            TEMPER = X
            IF (TEMPER .EQ. 0) TEMPER = 50
         ELSE
            TEMPER = 50
            END IF
         NOISTE(I) = TEMPER
C                                       Levels of digitizer
         IF (KBP .LE. NBYTES) THEN
            CALL GETNUM (LINE, NBYTES, KBP, X)
            NLEV = X
            IF (NLEV .EQ. 0) NLEV = 2.0
         ELSE
            NLEV = 2.0
            END IF
         IF (NLEV .GT. 4 .OR. NLEV .LT. 2) NLEV = 4.0
         NL = NLEV + 0.1
         NNLEV(I) = NL
C                                       Coordinates are relatively the
C                                       array center or relatively the
C                                       Earth center
         IF (KBP .LE. NBYTES) THEN
            CALL GETNUM (LINE, NBYTES, KBP, X)
            CENTER = X
            IF (CENTER .NE. 0) CENTER = 1
         ELSE
            CENTER = 0
            END IF
C                                       Calculate SEFD of the antennas
            AEFF = EFFIC * PI * DIAM(I) * DIAM(I) / 4
C                                       Alfa estimates the noise
C                                       increasing because of digitizing
C                                       The following formula gives a
C                                       good approximation when the
C                                       noise is considered to be
C                                       proportional to the SEFD
C                                       product
            ALFA = 2.24 / SQRT(NLEV)
C                                       calculate SEFD/TEMPER to
C                                       multiply it later by sum of
C                                       TEMPER and atmosphere noise
C                                       depending on elevation
            SEFD(I) = ALFA * 2760 / AEFF
         IF (COOR .EQ. 2) THEN
            LAT = LX(I) * DG2RAD
            LONG = LY(I) * DG2RAD
            ALT = LZ(I)
            WRITE (MSGTXT,2200) I, LX(I), LY(I), LZ(I), DIAM(I),
     *         EFFIC, TEMPER, NL
         ELSE
            WRITE (MSGTXT,2004) I, LX(I), LY(I), LZ(I), DIAM(I),
     *         EFFIC, TEMPER, NL
            END IF
         CALL MSGWRT (6)
C                                       store the original LX, LY, LZ
         LXORI(I) = LX(I)
         LYORI(I) = LY(I)
         LZORI(I) = LZ(I)
C
         IF (COOR .EQ. 1) THEN
C                                       Recalculate antenna coordinates
C                                       from the RH coordinate system
C                                       (Z in local zenith) to the RH
C                                       equatorial coordinate system
C
            XTEMP = -LX(I) * (-SINLO) - LY(I) * SINLA * COSLO
     *         + LZ(I) * COSLA * COSLO
            YTEMP = LX(I) * COSLO - LY(I) * SINLA * (-SINLO)
     *         + LZ(I) * COSLA * (-SINLO)
            ZTEMP = LY(I) * COSLA + LZ(I) * SINLA
C
            LX(I) = XTEMP
            LY(I) = YTEMP
            LZ(I) = ZTEMP
            END IF
C
         IF (COOR .EQ. 2) THEN
C                                       convert geodetic LAT, LONG, ALT
C                                       of the antenna to geocenter
C                                       RH equatorial coordinate system
            CALL GEOXYZ (MODE, LONG, LAT, ALT, LX(I), LY(I), LZ(I),
     *         IERR)
            CENTER = 1
            END IF
         IF (COOR .EQ. 3) THEN
C                                       Recalculate antenna coordinates
C                                       from the RH equatorial
C                                       coordinate system
C                                       (X to the array center meridian)
C                                       VLA for example to the RH
C                                       equatorial coordinate system
C                                       (X to the Greenwich meridian)
            XTEMP = LX(I) * COSLO + LY(I) * SINLO
            YTEMP = -LX(I) * SINLO + LY(I) * COSLO
            ZTEMP = LZ(I)
            LX(I) = XTEMP
            LY(I) = YTEMP
            LZ(I) = ZTEMP
            END IF
C                                       recalculate coordinates to
C                                       the origin at the array center
         LX(I) = LX(I) - CENTER * XCENT
         LY(I) = LY(I) - CENTER * YCENT
         LZ(I) = LZ(I) - CENTER * ZCENT
C                                       record the antenna lines
         IF (DOUTFI) THEN
            WRITE (LINE, 3040) LX(I), LY(I), LZ(I), DIAM(I),
     *         EFFIC, TEMPER, NL
            NCH = JTRIM(LINE)
            CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IERR)
            END IF
         WRITE (MSGTXT,2004) I, LX(I), LY(I), LZ(I), DIAM(I),
     *      EFFIC, TEMPER, NL
         CALL MSGWRT (6)
 100     CONTINUE
C                                       considering all antennas
C                                       identical take the diameter of
C                                       the first antenna for
C                                       calculation of the primary beam
      DANTT = DIAM(1)
C                                       close input file
      CALL ZTXCLS (LUN, FIND, IERR)
C                                       close output file
      IF (DOUTFI)  CALL ZTXCLS (LUNPR, PFIND, IERR)
C                                       calculate minimum of product
C                                       SEFDs at zenith
      SEFDMI = 1.E10
      DO 140 I = 1,N-1
         DO 120 J = I+1,N
            SEFDCU = SEFD(I)*(NOISTE(I) + TSKYZE) *
     *         SEFD(J)*(NOISTE(J) + TSKYZE)
            SEFDMI = MIN(SEFDMI, SEFDCU)
  120       CONTINUE
  140    CONTINUE
C
C                                       Open second input text file
C                                       for read
      IF (DOIN2F) THEN
         LUN = 10
         CALL ZTXOPN ('READ', LUN, FIND, FILE2, F, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1002)
            GO TO 990
            END IF
C
         WRITE (MSGTXT,2005)
         CALL MSGWRT (6)
C                                       Read elevation info
         I = 0
  200    CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
C                                       get the file end
            IF (IERR .EQ. 2) THEN
               IERR = 0
               GO TO 970
               END IF
            IF (IERR.NE.0) GO TO 985
            JT = JTRIM (LINE)
C                                       skip comments
            IF (LINE(1:1) .EQ. ';') GO TO 200
            I = I + 1
C                                       Get values
            KBP = 1
C                                       Antenna number
            CALL GETNUM (LINE, NBYTES, KBP, X)
            IAN(I) = X
C                                       Elevation
            CALL GETNUM (LINE, NBYTES, KBP, X)
            ELEVA(I) = X
C                                       TSYS in degrees
            CALL GETNUM (LINE, NBYTES, KBP, X)
            TSYS(I) = X
C                                       Efficiency
            CALL GETNUM (LINE, NBYTES, KBP, X)
            EFFEL(I) = X
C
            WRITE (MSGTXT,2006) IAN(I), ELEVA(I), TSYS(I), EFFEL(I)
            CALL MSGWRT (6)
C
            GO TO 200

C                                       Number of lines in the
C                                       second input file
  970    NLINE2 = I
C                                       End of the second file reading
C
C                                       close input file
         CALL ZTXCLS (LUN, FIND, IERR)
         END IF
C
      GO TO 999
C                                       Infile read error
 980  WRITE (MSGTXT,1980) IERR
      GO TO 990
C                                       Second file read error
  985 WRITE (MSGTXT,1985) IERR
      GO TO 990
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1001 FORMAT ('ERROR ',I3,' OPENING ANTENNA INFO TEXT FILE')
 1002 FORMAT ('ERROR ',I3,' OPENING SECOND INPUT TEXT FILE')
 1980 FORMAT ('ERROR ',I3,' READING ANTENNA INFO TEXT FILE')
 1985 FORMAT ('ERROR ',I3,' READING SECOND INPUT TEXT FILE')
 2000 FORMAT ('Number of antennas = ',I4)
 2001 FORMAT ('Site latitude = ',F8.3,' degrees')
 2100 FORMAT ('Site longtitude = ',F8.3,' degrees')
 2002 FORMAT ('Coordinate conversion factor to meters =',1PE12.5)
 2003 FORMAT ('Diameter conversion factor to meters =',1PE12.5)
 2004 FORMAT ('A(',I4,'):',3F9.0,'; d=',F4.0,
     *   ' ef=', F5.2, ' T=', F6.1, 1X, I2)
 2005 FORMAT (1X, ' ANT ', 3X,'  EL ', 6X, '  TSYS ', 5X, ' EFF ')
 2006 FORMAT (I4, 5X, F5.2, 6X, F7.2, 5X, F5.2)
 2200 FORMAT ('A(',I4,'): ',F4.1,'deg; ',
     *   F6.1,'deg; ', F6.1,'; d=',F4.0,
     *   ' ef=', F5.2, ' T=', F6.1, 1X, I2)
 3010 FORMAT (I4)
 3020 FORMAT (2F15.6)
 3030 FORMAT ('1 1')
 3040 FORMAT ('0', 3(F14.4), F5.0, F5.2, F6.1, I2)
      END
      SUBROUTINE GETANG (H, DELTA, SLAT, AZ, EL, PARANG)
C-----------------------------------------------------------------------
C   Given the hour-angle h, the source declination delta, and the
C   geographic latitude, slat, of the site, this subroutine computes
C   the azimuth, the elevation, and the parallactic angle.
C   Inputs:
C    H        D    Hour angle (rad)
C    DELTA    D    Source declination (rad)
C    SLAT     D    Site latitude (rad)
C   Outputs:
C    AZ       D    Azimuth (rad)
C    EL       D    Elevation (rad)
C    PARANG   D    Parallactic angle (rad)
C-----------------------------------------------------------------------
      DOUBLE PRECISION H, DELTA, SLAT, AZ, EL, PARANG
      DOUBLE PRECISION Z, SINQ, COSQ, SINA, COSA
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      Z = ACOS (SIN (DELTA) * SIN (SLAT) + COS (DELTA) * COS (SLAT) *
     *   COS (H))
      EL = PI / 2.0D0 - Z
      IF (Z.EQ.0D0) THEN
         PARANG = 0.0D0
         AZ = 0.0D0
      ELSE
         SINQ = SIN (H) * COS (SLAT) / SIN (Z)
         COSQ = SIN (SLAT) / SIN (Z) / COS (DELTA) - TAN (DELTA) /
     *      TAN (Z)
         PARANG = ATAN2 (SINQ, COSQ)
         SINA = -COS (DELTA) * SIN (H) / SIN (Z)
         COSA = (SIN (DELTA) * COS (SLAT) - COS (DELTA) * COS (H) *
     *      SIN (SLAT)) / SIN (Z)
         AZ = ATAN2 (SINA, COSA)
         IF (AZ.LT.0.0D0) AZ = AZ + 2.0D0 * PI
         END IF
C
 999  RETURN
      END
      SUBROUTINE BLOCK (I, J, UANT, VANT, WANT, DIAM, FI, FJ)
C-----------------------------------------------------------------------
C  Subroutine to compute geometric shadowing.
C  Given i and j, antenna-based (u,v,w), and the antenna diameters,
C  this subroutine computes the fractional blockage fi of antenna i by
C  antenna j, and the fractional blockage fj of antenna j by antenna i.
C  Whenever blockage occurs, if w<0 then it is the case that antenna j
C  is blocked by antenna i, if w>0 then antenna i has been blocked by
C  antenna j, and if w = 0 then the antennas have run into each other.
C  So generally, on return, one - but not both - of fi and fj may be
C  nonzero.
C  The antenna profiles are assumed to be circular, and the antennas
C  are assumed to be pointed the same way (a reasonably valid
C  assumption for the case of a compact array configuration, which
C  is the only case where one generally worries about shadowing).
C   Inputs:
C    I       I    First antenna number
C    J       I    Second antenna number
C    UANT(*) D    Array of U values (m)
C    VANT(*) D    Array of V values (m)
C    WANT(*) D    Array of W values (m)
C    DIAM(*) D    Array of diameters (m)
C   Outputs:
C    FI      D    Fractional blockage of antenna I
C    FJ      D    Fractional blockage of antenna J
C-----------------------------------------------------------------------
      INTEGER   I, J
      DOUBLE PRECISION    UANT(*), VANT(*), WANT(*), DIAM(*), FI, FJ
      DOUBLE PRECISION    U, V, W, SEP, RMIN, RMAX, SINA, SINB,
     *   AREA, S, C, A, B
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      U = UANT(J)-UANT(I)
      V = VANT(J)-VANT(I)
      W = WANT(J)-WANT(I)
      SEP = SQRT (U**2 + V**2)
      RMIN = 0.5D0 * MIN (DIAM(I), DIAM(J))
      RMAX = 0.5D0 * MAX (DIAM(I), DIAM(J))
      IF (SEP.GE.RMIN+RMAX) THEN
         FI = 0.0D0
         FJ = 0.0D0
      ELSE IF (SEP+RMIN.LE.RMAX) THEN
         FI = MIN (1.0D0, (DIAM(J) / DIAM(I))**2)
         FJ = MIN (1.0D0, (DIAM(I) / DIAM(J))**2)
      ELSE
         C = SEP / (0.5D0*DIAM(I))
         S = DIAM(J) / DIAM(I)
         SINB = SQRT ((S+C+1.0D0) * (S+C-1.0D0) * (S-C+1.0D0) *
     *      (C-S+1.0D0)) / (2.0D0*C)
C  Or,
C        SINB = SQRT(2D0*((C*S)**2+C**2+S**2)-C**4-S**4-1D0)/(2D0*C)
C
         SINA = SINB / S
C                                       Due to roundoff, sina or sinb
C                                       might be ever so slightly larger
C                                       than 1. In the case of unequal
C                                       radii, with the center of one
C                                       antenna pattern inside the
C                                       other:
         SINB = MIN (1.0D0, SINB)
         SINA = MIN (1.0D0, SINA)
C
         B = ASIN (SINB)
         A = ASIN (SINA)
         AREA = (S**2*A+B) - (S**2*SINA*COS (A)+SINB*COS (B))
         FI = AREA / PI
         FJ = FI / S**2
      END IF
      IF (W.LT.0.0D0) FI = 0.0D0
      IF (W.GT.0.0D0) FJ = 0.0D0
 999  RETURN
      END
      SUBROUTINE UVANT (H, DELTA, N, LX, LY, LZ, UANT, VANT, WANT)
C-----------------------------------------------------------------------
C  Given the hour-angle h, the source declination delta, the number
C  of elements n, and the element locations (lx(i),ly(i),lz(i)),
C  i = 1,...,n, this subroutine computes the antenna-based spatial
C  frequency coordinates (uant(i),vant(i),want(i)), i = 1,...,n.
C   Inputs:
C    H        D    Hour angle (rad)
C    DELTA    D    Source declination (rad)
C    N        I    Number of antennas
C    LX(*)    D    "X" component of antenna position (m)
C    LY(*)    D    "Y" component of antenna position (m)
C    LZ(*)    D    "Z" component of antenna position (m)
C   Outputs:
C    UANT(*)  D    "U" component of project coordinate (m)
C    VANT(*)  D    "V" component of project coordinate (m)
C    WANT(*)  D    "W" component of project coordinate (m)
C-----------------------------------------------------------------------
      INTEGER   N
      DOUBLE PRECISION H, DELTA, LX(*), LY(*), LZ(*), UANT(*),
     *   VANT(*), WANT(*)
      INTEGER   I
      DOUBLE PRECISION SH, CH, SD, CD
C-----------------------------------------------------------------------
      SH = SIN (H)
      CH = COS (H)
      SD = SIN (DELTA)
      CD = COS (DELTA)
      DO 100 I = 1,N
         UANT(I) = SH * LX(I) + CH * LY(I)
         VANT(I) = -SD * (CH * LX(I) - SH * LY(I)) + CD * LZ(I)
         WANT(I) = CD * (CH * LX(I) - SH * LY(I)) + SD * LZ(I)
 100     CONTINUE
C
 999  RETURN
      END
C
      SUBROUTINE NOISE (ANOISE)
C-----------------------------------------------------------------------
C   Random noise generator
C    Output: ANOISE  R    Result
C-----------------------------------------------------------------------
      REAL      ANOISE, TEMP
      INTEGER   J
C-----------------------------------------------------------------------
      ANOISE = -6.0
      DO 10 J = 1,12
         CALL RANDUM (TEMP)
         ANOISE = ANOISE + TEMP
 10      CONTINUE
C
 999  RETURN
      END
C
      SUBROUTINE QXXPTS (APCORE, C, U, VS, INCVS, INCF, INCS, MCOMP,
     *   NVIS, NF, NS, FLAG)
C-----------------------------------------------------------------------
C   This is the private version to add pointing error simulation
C-----------------------------------------------------------------------
C   Vector compiler version
C   Subtracts the model visibility derived from CLEAN components from
C   visibility records.  Arbitrary numbers of frequencies and
C   polarizations can be processed.  The weights of the visibilities
C   are multiplied times the amplitude of the model visibility.
C   Inputs:
C      C     I  Base address of CLEAN components, increment = 4
C               0 = Amplitude
C               1 = -2 * PI * X
C               2 = -2 * PI * Y
C               3 = -2 * PI * Z
C      U     I  Base address of U, assumed followed by V, W
C      VS    I  Base address of vis rec. (real, imag, wt)
C      INCVS I  Increment of VS for next visibility
C      INCF  I  Increment of VS for next frequency
C      INCS  I  Increment of VS for next IF (RR of LL)
C      MCOMP I  Number of CLEAN components.
C      NVIS  I  Number of visibilities.
C      NF    I  Number of frequencies.
C      NS    I  Number of IF (usually 1 or 2)
C      FLAG  I  If FLAG < 0 multiply model vis by i (SQRT(-1))
C   Also uses AP locations 0 and 1 and expects an array of length NS
C   beginning in location 2+NF composed of the correlator factors.
C   Beginning in location 2 should be an array of length NF :
C              Freq(0) / Freq(ref) - 1.0
C              Freq(1) / Freq(ref) - 1.0
C                      .
C                      .
C                      .
C              Freq(NF-1) / Freq(ref) - 1.0
C   Also 1 or 2 factors to multiply model by and a factor (0 or 1) to
C   multiply the input data.  These 3 words follow the freq table
C   Note: all addresses are 0 relative and needed to be incremented by
C   1 to work in Fortran.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   C, U, VS, INCVS, INCS, INCF, MCOMP, NVIS, NF, NS, FLAG
C
      INTEGER   X, JVS, IVS, IF, IV, IS, ICOMP
      LONGINT   F, S, JX, IU, JAMP, JA
      DOUBLE PRECISION FREQF, SUMRE, SUMIM, REMOD, IMMOD, PHS
C
      DOUBLE PRECISION DTHETA, FACT, UU, PFACT1, PFACT2, ANGL, POINT1,
     *   POINT2, PHAS1, PHAS2, TIMNEW, TIMOLD, DTNOLD, AMPF1, AMPF2,
     *   AMPF12
      INTEGER   BASE, IA1, IA2, IA, ISTEP, DROUND
C
      INCLUDE 'INCS:DAPC.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'UVCON.INC'
      REAL   POIOLD(NMAX), PHAOLD(NMAX), TEMP
      REAL   AMPOLD(NMAX)
      REAL   XX, YY, XXT, YYT, SKYBEA
      DOUBLE PRECISION   HALOC, COSZA, DARG, DARG2, DAZ

      SAVE TIMOLD
C-----------------------------------------------------------------------
C                                        Make sure that there is data.
      IF ((MCOMP.LE.0) .OR. (NVIS.LE.0) .OR. (NF.LE.0) .OR.
     *   (NS.LE.0))  GO TO 999
C                                       Setup array addresses
      X = C + 1
      IU = U - 1 + PSAPOF
      IVS = VS
C                                        Begin visibility loop
C$OMP PARALLEL DO PRIVATE (IV, JVS, F, S, IF, SUMRE, SUMIM, JX, JAMP,
C$OMP+                     FREQF, ICOMP, PHS, REMOD, IMMOD, IS,
C$OMP+                     JA, IVS, IU), SHARE(APCORE)
      DO 300 IV = 1,NVIS
C                                       variable primary beam
         IF (DOPRBM .AND. BTYPE .EQ. 5) THEN
            TIMNEW = APCORE(IU + 4)
            DTNOLD = ABS (TIMOLD - TIMNEW)
C                                       Consider that PRBP, PRBMA
C                                       do not change if time differs
C                                       less than TIMTOL
            IF (DTNOLD .GT. TIMTOL) THEN
               TIMOLD = TIMNEW
C                                       calculate elevation and azimuth
C                                       of the array center
C
C                                       Hour angle at the array center
               HALOC = TIMNEW*TWOPI*1.00274D0 - SITELO + GSTIAT
C                                       Limit to between 0 and 2pi
               HALOC = DMOD (HALOC, TWOPI)
C                                       translate to between -pi and pi
               IF (HALOC.GT.PI) HALOC = HALOC - TWOPI
               IF (HALOC.LT.-PI) HALOC = HALOC + TWOPI
C                                       cos of zenith angle
               COSZA = SIN (SITELA) * SIN (DELTA) + COS
     *                  (SITELA)* COS (DELTA) * COS (HALOC)
C                                       AZ = ATAN2(SD*CL - CD*SL*CH,
C                                       CD*SH)
               DARG = SIN (DELTA) * COS (SITELA) -
     *                  COS (DELTA) * SIN (SITELA) * COS(HALOC)
               DARG2 = COS (DELTA) * SIN (HALOC)
               DAZ = ATAN2 (DARG, DARG2)
               DAZ = MOD (DAZ - PI/2.0D0, TWOPI)
               IF (DAZ.LT.0.0) DAZ = DAZ + TWOPI
C
               PRBP = DAZ
               PRBMA = PRBMI / COSZA
               END IF
            END IF
C                                       random pointing error
C                                       adding to each antenna
         IF (DOPOIN) THEN
            BASE = APCORE(IU + 5)
            IA1 = BASE / 256
            IA2 = BASE - IA1*256
            TIMNEW = APCORE(IU + 4)
C                                       pointing error random among
C                                       antennas and in time
C
C                                       TEMP is a random 'gaussian'
C                                       number with mean =0 and
C                                       RMS = 1
            DTNOLD = ABS (TIMOLD - TIMNEW)
C                                       Consider that pointing can
C                                       change if time difference is
C                                       more than given tolerance
            IF (DTNOLD .GT. TIMTOL) THEN
               TIMOLD = TIMNEW
C                                       initialize the antennas
C                                       pointing error being very big
               DO 40 IA = 1,N
                  POIOLD(IA) = 100
   40             CONTINUE
C
               CALL NOISE (TEMP)
               POINT1 = POINTE(IA1) + BPARM(5) / 3600. * TEMP * DG2RAD
               POIOLD(IA1) = POINT1
               CALL NOISE (TEMP)
               POINT2 = POINTE(IA2) + BPARM(5) / 3600. * TEMP * DG2RAD
               POIOLD(IA2) = POINT2
            ELSE
               IF (POIOLD(IA1) .LT. 50) THEN
                  POINT1 = POIOLD(IA1)
               ELSE
                  CALL NOISE (TEMP)
                  POINT1 = POINTE(IA1) + BPARM(5) / 3600. * TEMP
     *               * DG2RAD
                  POIOLD(IA1) = POINT1
                  END IF
C
               IF (POIOLD(IA2) .LT. 50) THEN
                  POINT2 = POIOLD(IA2)
               ELSE
                  CALL NOISE (TEMP)
                  POINT2 = POINTE(IA2) + BPARM(5) / 3600. * TEMP
     *               * DG2RAD
                  POIOLD(IA2) = POINT2
                  END IF
               END IF
            END IF
C---------------------------
C                                       random phase adding to the
C                                       antennas
         IF (DOPHAS) THEN
            BASE = APCORE(IU + 5)
            IA1 = BASE / 256
            IA2 = BASE - IA1*256
            TIMNEW = APCORE(IU + 4)
            DTNOLD = ABS (TIMNEW - TIMOLD)
C                                       Consider that phase can
C                                       change if time difference is
C                                       more than given tolerance
            IF (DTNOLD.GE.TIMTOL .OR. (FIRST .AND. IV.EQ.1)) THEN
               TIMOLD = TIMNEW
C                                       initialize the antennas
C                                       phase error being very big
               DO 60 IA = 1,N
                  PHAOLD(IA) = 100
                  AMPOLD(IA) = 100
   60             CONTINUE
C
C                                       TEMP is a random even disri-
C                                       buted number at the range (0,1)
C
C                                       Random phase
               CALL RANDUM (TEMP)
               PHAS1 = 2*HPHASR*TEMP - HPHASR
               PHAOLD(IA1) = PHAS1
               CALL RANDUM (TEMP)
               PHAS2 = 2*HPHASR*TEMP - HPHASR
               PHAOLD(IA2) = PHAS2
C                                       Random amplitude factor
               CALL RANDUM (TEMP)
               AMPF1 = 2*HAMPFR*TEMP - HAMPFR
               AMPOLD(IA1) = AMPF1
               CALL RANDUM (TEMP)
               AMPF2 = 2*HAMPFR*TEMP - HAMPFR
               AMPOLD(IA2) = AMPF2
            ELSE
C                                       Random phase
C
C                                       first antenna
               IF (PHAOLD(IA1) .LT. 50) THEN
                  PHAS1 = PHAOLD(IA1)
               ELSE
                  CALL RANDUM (TEMP)
                  PHAS1 = 2*HPHASR*TEMP - HPHASR
                  PHAOLD(IA1) = PHAS1
                  END IF
C                                       second antenna
               IF (PHAOLD(IA2) .LT. 50) THEN
                  PHAS2 = PHAOLD(IA2)
               ELSE
                  CALL RANDUM (TEMP)
                  PHAS2 = 2*HPHASR*TEMP - HPHASR
                  PHAOLD(IA2) = PHAS2
                  END IF
C                                       Random amplitude factor
C
C                                       first antenna
               IF (AMPOLD(IA1) .LT. 50) THEN
                  AMPF1 = AMPOLD(IA1)
               ELSE
                  CALL RANDUM (TEMP)
                  AMPF1 = 2*HAMPFR*TEMP - HAMPFR
                  AMPOLD(IA1) = AMPF1
                  END IF
C                                       second antenna
               IF (AMPOLD(IA2) .LT. 50) THEN
                  AMPF2 = AMPOLD(IA2)
               ELSE
                  CALL RANDUM (TEMP)
                  AMPF2 = 2*HAMPFR*TEMP - HAMPFR
                  AMPOLD(IA2) = AMPF2
                  END IF
               END IF
            END IF
C---------------------------
C                                        Get ready for freq. loop.
         JVS = IVS
         F = 1 + PSAPOF
         S = NF + 1 + PSAPOF
C                                        Begin frequency loop.
         DO 200 IF = 1,NF
C                                       Loop over component
            SUMRE = 0.0D0
            SUMIM = 0.0D0
            JX = X + PSAPOF
            JAMP = C + PSAPOF
            IF (ABS (APCORE(F+1)).GT.1.0D-20) THEN
               FREQF = 1.0D0 + APCORE(F+1)
            ELSE
               FREQF = 1.0D0
               END IF
            DO 100 ICOMP = 1, MCOMP
C                                       W term 0.5(l**2 + m**2)
               IF (DOW.GT.0) APCORE(JX+2) =
     *            (APCORE(JX)**2 + APCORE(JX+1)**2)/2.0D0/TWOPI
               AMPF12 = 1
               PHS = FREQF * (APCORE(JX) * APCORE(IU+1)
     *                      + APCORE(JX+1) * APCORE(IU+2)
C                                       change sign to minus to match
C                                       with UVMOD. LK March 19 2009
     *                      - APCORE(JX+2) * APCORE(IU+3))
C                                       add the random phase =
C                                       random phase of AN2
C                                       - random phase of AN1
C                                       and the random factor
C                                       as Rick requested
               IF (DOPHAS) THEN
                  IF (DOONE .AND. ICOMP.GT.1) GO TO 110
                  PHS = PHS + PHAS2 - PHAS1
                  AMPF12 = EXP(AMPF1+AMPF2)
  110             CONTINUE
                  END IF
C
               IF (DOPOIN) THEN
C                                       calculate the distance of the
C                                       component (in radians) from the
C                                       reference direction
C                                       Do it only for the first vis.
C                                       to save the time
                  IF (IV.EQ.1)
     *               DTHETA = SQRT(APCORE(JX)*APCORE(JX) +
     *                  APCORE(JX+1)*APCORE(JX+1)) / TWOPI
                  ANGL = ABS(DTHETA + POINT1)
                  UU = DANTT / LAMBDA * SIN(ANGL)
                  ISTEP = DROUND(UU /ASTEP) + 1
                  IF (ISTEP .LE. NSTEP) THEN
                     PFACT1 = PRBEAM(ISTEP)
                  ELSE
                     PFACT1 = 0
                     END IF
C                                       pointing error of ant2
                  ANGL = ABS(DTHETA + POINT2)
                  UU = DANTT / LAMBDA * SIN(ANGL)
                  ISTEP = DROUND(UU /ASTEP) + 1
                  IF (ISTEP .LE. NSTEP) THEN
                     PFACT2 = PRBEAM(ISTEP)
                  ELSE
                     PFACT2 = 0
                     END IF
                  FACT = PFACT1 * PFACT2
C                                       Do sum with the pointing error
C                                       correction
                  SUMRE = SUMRE + APCORE(JAMP) * COS(PHS) * FACT
                  SUMIM = SUMIM + APCORE(JAMP) * SIN(PHS) * FACT
               ELSE
                  IF (DOPRBM .AND. BTYPE.EQ.5) THEN

                     XX = APCORE(JX) / TWOPI
                     YY = APCORE(JX+1) / TWOPI
C
C                                       the primary beam is gaussian
C                                       rotate by BPA
                     XXT = XX*COS(PRBP) - YY*SIN(PRBP)
                     YYT = XX*SIN(PRBP) + YY*COS(PRBP)
C
                     UU = (XXT/PRBMA)**2 + (YYT/PRBMI)**2
                     ISTEP = DROUND(UU /ASTEP) + 1
C                                       SKYBEA is CC comp multiplied by
C                                       the primary beam
                     IF (ISTEP .LE. NSTEP) THEN
                        SKYBEA = PRBEAM(ISTEP)*APCORE(JAMP)
                     ELSE
                        SKYBEA = 0
                        END IF
C
                     SUMRE = SUMRE + SKYBEA * COS(PHS) * AMPF12
                     SUMIM = SUMIM + SKYBEA * SIN(PHS) * AMPF12
                  ELSE
C
                     SUMRE = SUMRE + APCORE(JAMP) * COS(PHS) * AMPF12
                     SUMIM = SUMIM + APCORE(JAMP) * SIN(PHS) * AMPF12
                     END IF
                  END IF
               JX = JX + 4
               JAMP = JAMP + 4
 100           CONTINUE
C                                       Correct visibility
            JA = JVS + PSAPOF
C                                        Setup
            IF (FLAG.LT.0) THEN
               REMOD = -SUMIM
               IMMOD = SUMRE
            ELSE
               REMOD = SUMRE
               IMMOD = SUMIM
               END IF
C                                       Loop over Stokes (1 or 2)
C                                       drop data
            IF (APCORE(S+3).EQ.0.0D0) THEN
               DO 150 IS = 1,NS
                  APCORE(JA) = REMOD * APCORE(S+IS)
                  APCORE(JA+1) = IMMOD * APCORE(S+IS)
                  JA = JA + INCS
 150              CONTINUE
C                                       Subtract model from data
            ELSE
               DO 160 IS = 1,NS
                  APCORE(JA) = APCORE(JA) - REMOD * APCORE(S+IS)
                  APCORE(JA+1) = APCORE(JA+1) - IMMOD * APCORE(S+IS)
                  JA = JA + INCS
 160              CONTINUE
               END IF
C                                        Update vis pointer.
            JVS = JVS + INCF
            F = F + 1
 200        CONTINUE
C                                        Update pointers.
         IVS = IVS + INCVS
         IU = IU + INCVS
 300     CONTINUE
C$OMP END PARALLEL DO
C
 999  RETURN
      END
C
      SUBROUTINE POERR
C-----------------------------------------------------------------------
C   POERR estimates the pointing errors of the antennas
C-----------------------------------------------------------------------
C   Inputs in common:
C       BPARM(3)   R  RMS (constant in time) of the pointing error
C                     in arcsec
C       BPARM(4)   R  global pointing error (const for all antennas
C                     and time in arcsec
C   Outputs in common:
C       POINTE(*)  R  Pointing errors of the antennas in radians
C   Output:
C       IRET       I  Error
C
      INTEGER   I
      REAL      TEMP
      INCLUDE 'UVCON.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C
      DO 100 I = 1, N
C                                       TEMP is a random 'gaussian'
C                                       number with mean =0 and
C                                       RMS = 1
         CALL NOISE (TEMP)
         POINTE(I) = (BPARM(3) * TEMP  + BPARM(4)) / 3600. * DG2RAD
  100    CONTINUE
C
      RETURN
      END
      SUBROUTINE PRB
C-----------------------------------------------------------------------
C   PRB estimates array of the primary beam values
C   Inputs in common:
C       BTYPE      I  Type of the beam
C                  1 => Circular dish with a table type of ilumination
C                       PRBEAM(U) = 2*I_1(U)/U
C                  2 => Circular dish with the ilumination of 10db
C                       down at the dish edge (ALMA)
C                       PRBEAM(U) = [1/(b+0.5)] *
C                                   [b*2*I_1(U)/U + 0.5*8 *I_2(U)/U^2]
C                       b = 0.46
C                  3 => Circular dish with the ilumination of 15db
C                       down at the dish edge (ALMA)
C                       PRBEAM(U) = [1/(b+0.5)] *
C                                   [b*2*I_1(U)/U + 0.5*8 *I_2(U)/U^2]
C                       b = 0.216
C                  >3 => Gaussian beam
C                       PRBMAJ- FWHM major axis;
C                       PRBMIN- FWHM minor axis;
C                       PRBPA - Positian angle
C       RANGPB     Range of the primary beam calculation
C   Outputs in common:
C       PRBEAM(*)  R  Array of the primary beam values
C
      INTEGER   I, MSTEP
      REAL BESSJ1, J0BES, J1BES, J2BES, LAM1, LAM2, UU, B
      DOUBLE PRECISION   BESSJ0, UUU
      INCLUDE 'UVCON.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C
C                                       calculate primary beam
C                                       of the array antenna in the
C                                       normalized coordinates
C                                       U = pi * (d/lambda) *sin(theta)
C                                       or in gaussian shape
      MSTEP = NSTEP
      ASTEP = RANGPB / MSTEP
      DO 10 I = 1, MSTEP
         IF (BTYPE .EQ. 0) THEN
C                                       primary beam is indefinetely
C                                       wide
            PRBEAM(I) = 1
         ELSE
            UU = ASTEP * (I - 1) * PI
            IF (I .EQ. 1) THEN
               PRBEAM(I) = 1
            ELSE
               IF ((BTYPE.EQ.1 .OR. BTYPE.EQ.2) .OR. BTYPE.EQ.3) THEN
                  J1BES = BESSJ1(UU)
                  LAM1 = 2 * J1BES / UU
                  END IF
               IF (BTYPE .EQ. 1) THEN
C                                       flat ilumination
                  PRBEAM(I) = LAM1 ** 2
               ELSE
                  IF (BTYPE.EQ.2 .OR. BTYPE.EQ.3) THEN
C                                       ilumination with 10db down at
C                                       the edge
                     IF (BTYPE .EQ. 2)   B = 0.46
C                                       ilumination with 15db down at
C                                       the edge
                     IF (BTYPE .EQ. 3) B = 0.216
C                                       Bessel funcion of zero
C                                       order
                     UUU = UU
                     J0BES = BESSJ0(UUU)
C                                       Bessel funcion of the second
C                                       order
                     J2BES = LAM1 - J0BES
C                                       LAMBDA funcion of the second
C                                       order
                     LAM2 = 2 * (4/(UU*UU)) * J2BES
                     PRBEAM(I) = ((B * LAM1 + 0.5 * LAM2) / (B + 0.5))
     *                  **2
                  ELSE
C                                       gaussian beam
                     UU = UU/PI
                     PRBEAM(I) = EXP(-COEF*UU)
                     END IF
                  END IF
               END IF
            END IF
   10    CONTINUE
C
      RETURN
      END
      SUBROUTINE FHEAD (MODNAM, MODCLS, MODSEQ, MODVOL, UNITS, RAINC,
     *   DECINC, BEMJ, BEMN, NPX, NPY, SCRTCH, IERR)
C-----------------------------------------------------------------------
C   FHEAD some parameters of the IMH.
C   In particular:
C      1.Units
C      2.Increament in RA--SIN
C      3.Increament in DEC--SIN
C      4.Beam major axis
C      5.Beam minor axis
C      6.Number of pixels along RA
C      7.Number of pixels along DEC
C   Inputs:
C      MODNAM   C*12      Name of model file(s).
C      MODCLS   C*6       Class of first model file.
C      MODSEQ   I         Model file(s) sequence number.
C      MODVOL   I         Model file(s) disk number
C      BUFFER   I(256)    Work buffer
C   Output:
C      UNITS    C*8       Units
C      RAINC    R         Increament in RA--SIN, arcsec
C      DECINC   R         Increament in DEC--SIN, arcsec
C      BEMJ     R         Beam major axis, arcsec
C      BEMN     R         Beam minor axis, arcsec
C      NPX      I         Number of pixels at RA direction
C      NPY      I         Number of pixels at DEC direction
C      IERR     I         Error
C-----------------------------------------------------------------------
      CHARACTER UNITS*8
      REAL      RAINC, DECINC, BEMJ, BEMN
      INTEGER   NPX, NPY
      CHARACTER MODNAM*12, MODCLS*6
      INTEGER   MODSEQ, MODVOL, NMOD, IERR, SCRTCH(*)
C
      CHARACTER ITYPE*2, STAT*4
      HOLLERITH CATCH(256)
      INTEGER   CATCLN(256), IRET
      REAL      CATCR(256)
      DOUBLE PRECISION CATCD(128)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (CATCLN, CATCR, CATCH, CATCD)
C-----------------------------------------------------------------------
C                                       Other info
      IERR = 0
      NMOD = 1
C
C                                       Set class.
      ITYPE = '  '
      CALL CATDIR ('SRCH', MODVOL, NMOD, MODNAM, MODCLS, MODSEQ,
     *   ITYPE, NLUSER, STAT, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, MODNAM, MODCLS, MODSEQ, ITYPE,
     *      MODVOL, NLUSER
         IERR = 2
         IF (IRET.EQ.5) IERR = 3
         IF (IRET.EQ.3) IERR = 4
         GO TO 990
         END IF
C                                       Read catalog block
      CALL CATIO ('READ', MODVOL, NMOD, CATCLN, 'READ', SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         IERR = 4
         IF (IRET.GT.4) IERR = 2
         WRITE (MSGTXT,1011) IRET
         GO TO 990
         END IF
C                                       Units
      CALL H2CHR (8, 1, CATCH(KHBUN), UNITS)
      RAINC = CATCR(KRCIC)
      DECINC = CATCR(KRCIC+1)
      BEMJ = CATCR(KRBMJ)
      BEMN = CATCR(KRBMN)
      NPX = CATCLN(KINAX)
      NPY = CATCLN(KINAX+1)
C
      GO TO 999
C                                       Error
 990  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,2X,A2,' DISK=',
     *   I3,' USID=',I4)
 1011 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE VISDFT (APCORE, OPCODE, CHANEL, NCHAN, DISKI, CNOSCI,
     *   DISKO, CNOSCO, IFIELD, DOSUM, DOMSG, CATR, JBUFSZ, BUFF1,
     *   BUFF2, IBUFF, IRET)
C-----------------------------------------------------------------------
C   This private version allows to multiply the model by the
C   primary beam
C-----------------------------------------------------------------------
C   VISDFT subtracts/divides CLEAN components from/into ungridded
C   visibility data by a DFT model computation.  Only model components
C   of a single type are processed.  The type is determined from the
C   first component to be processed in the first field.
C   All un subtracted data processed in one call.
C   Inputs:
C      OPCODE   C*4      Opcode 'SUB ', or 'DIV '
C      CHANEL   I        Frequency channel
C      NCHAN    I        Number of frequency channels.
C      DISKI    I        Input file disk number for cataloged files,
C                        .LE. 0 => /CFILES/ scratch file.
C      CNOSCI   I        Input file catalog slot number or /CFILES/
C                        scratch file number.
C      DISKO    I        Output file disk number for cataloged files,
C                        .LE. 0 => /CFILES/ scratch file.
C      IFIELD   I        Field to do (0 -> all)
C      DOSUM    L        If true sum the flux in each field
C      DOMSG    L        If true give percent done messages.
C      CATR     R(256)   UV data catalog header record.
C      JBUFSZ   I        Size of BUFF1,2, IBUFF in AIPS bytes, each
C                        must be at least 4096 words.
C   Inputs: from commons
C      MFIELD   I        Number of fields
C      NCLNG    I(16)    Number of components per field. -
C                        changed if flux limit hit
C      NSUBG    I(16)    The next component to subtract.
C      CCDISK   I(16)    Disk numbers of the clean images.
C      CCCNO    I(16)    Catalog slot numbers of clean images.
C      CCVER    I(*)     CC file version number for each field.
C      NGRDAT   L        If FALSE get map size, scaling etc. parms
C                        from the model map cat. header. If TRUE
C                        then the values filled in by GRDAT must
C                        already be filled into the common.
C      LREC     I        Length in words of vis record.
C      NVIS     I        Number of vis. records
C      NONEG    L        Stop reading comps. from a file past the first
C                        negative component.
C      LIMFLX   R        Stop if abs(flux) < LIMFLX
C      DOPTMD   L        Use the point model specified by PTFLX, PTRAOF,
C                        PTDCOF
C      PTFLX    R        Point model flux density (Jy) (I pol. only)
C      PTRAOF   R        Point model RA offset from uv phase center
C                        (asec)
C      PTDCOF   R        Point model Dec. offset from uv phase center
C      PARMOD   R(6)     Model parameters for non point models; used
C                        only if DOPTMOD is true.
C                        1=> model type, 0=point, 1=gaussian, 3=sphere
C                        Gaussian: (2)=major axis(asec), (3)=minor axis
C                                  (4)=PA (degrees)
C                        Sphere: (2)=radius (asec).
C      KSTOK    I        (DGDS.INC) If a point model is specified a
C                        value of 2 indicates a Q pol model, 3 U and
C                        4 V pol.AC
C   In/out:
C      CNOSCO   I        IN: output file catalog slot number or /CFILES/
C                        scratch file number. Will create a scratch file
C                        if CNOSCO and DISKO .le. 0.
C                        Out: file /CFILES/ number if created.
C   Output:
C      BUFF1    R(*)     I/O buffers.
C      BUFF2    R(*)     I/O buffers.
C      IBUFF    I(*)     I/O Buffer.
C      IRET     I        Return code, 0 => ok, otherwise not.
C                            9 => Buffers too small to load AP.
C                           10 => Too many components for division.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      CHARACTER OPCODE*4
      INTEGER   CHANEL, NCHAN, DISKI, CNOSCI, DISKO, CNOSCO, IFIELD,
     *   JBUFSZ, IBUFF(*), IRET
      LOGICAL   DOSUM, DOMSG
      REAL      BUFF1(*), BUFF2(*), CATR(256)
C
      CHARACTER NAME*48, MDTYP(4)*8, ERRTXT*40
      INTEGER   JNCOMP, CCOUNT, XNCOMP, MXCMP, CURCMP, JT,
     *   NCOMP, J, MCOMP, VO, BO, ISIZE, INIO, MMCOMP, NNCOR, IDATA, UV,
     *   LLREC, IAPBUF, IAPCC, IAPCT, LMCOMP, IAPTMP, VIS, WRK, LLNMOD,
     *   MCHAN, JNCS, JNCF, KAP, SFLAG, APSIZ, MXCC, INIO2, LUNC, VOL,
     *   INDEX, ITYPE, NIOUT, KBIND, LENBU, LENMOD, JLREC, JNREC, FINDI,
     *   FINDO, I, LUNI, LUNO, ITIME(3), IBIND, LFIELD, LMOD(4), NKEY,
     *   IPCLST, IPCDNE, NCALL, NTIMES, MODTYP, LRPARM, LF1, LF2, ISTEP,
     *   IROUND, NEED, MSGSAV, SCRTCH(256)
      REAL      XXOFF, YYOFF, ZZOFF, CONST, FACT2(4), CPA, SPA, XMAJ,
     *   XMIN, CONST2, ABFACG, XYZ(3), XP(3), UMAT(3,3), PMAT(3,3), UUU,
     *   UU, DTHETA, PFACT, XXT, YYT
      DOUBLE PRECISION XTLST, PCTOT, PCLST, XRA, XDEC
      LOGICAL   T, F, DIVIDE
      INCLUDE 'PRBM.INC'
      INCLUDE 'INCS:PSTD.INC'
C      INCLUDE 'INCS:PUVD.INC'
      LOGICAL   DONE(MAXFLD), ONZE, DO3D
      INTEGER   CCKOLS(MAXCCC),CCNUMV(MAXCCC), CCRNO, CCNCOL, CCTYPE
      REAL      XX, YY, ZZ, FLUX, PARMS(3), RDUM(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMPR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      PARAMETER (CONST = DG2RAD * TWOPI)
      SAVE ONZE
      DATA LMOD /4, 7, 7, 6/
      DATA MDTYP /'Point   ', 'Gaussian', 'Unknown ', 'Sphere  '/
      DATA VO, BO, MXCC /0, 1, 1024/
      DATA LUNI, LUNO, LUNC /22,23,29/
      DATA T, F /.TRUE.,.FALSE./, ONZE/.FALSE./
C-----------------------------------------------------------------------
C                                       CONST2 converts FWHM(deg) to
C                                       coefficients for u*u, v*v, u*v
      CONST2 = DG2RAD * (PI / 1.17741022) * SQRT (0.5)
C                                       Check if divide.
      DIVIDE = OPCODE.EQ.'DIV '
C                                       Tell kind of operation.
      IF (DIVIDE) THEN
         MSGTXT = 'VISDFT: Begin DFT component division'
      ELSE
         MSGTXT = 'VISDFT: Begin DFT component subtraction'
         END IF
      CALL MSGWRT (2)
      MCHAN = NCHAN
      NNCOR = 1
C                                       Get un-compressed UV increments
      CALL UVINCS (INCS, INCF, INCIF, NRPARM, LREC, JNCS, JNCF, LRPARM,
     *   LLREC)
      LFIELD = 0
      CCOUNT = 0
      IF (IFIELD.LE.0) THEN
         LF1 = 1
         LF2 = MFIELD
      ELSE
         LF1 = IFIELD
         LF2 = IFIELD
         END IF
C                                       Decide component type.
C                                       From model passed
      IF (DOPTMD) THEN
         MODTYP = PARMOD(1) + 0.5
C                                       From CC table, field 1
      ELSE
         LFIELD = LF1
C                                       Get field info. if nec.
         IF (.NOT.NGRDAT) THEN
            CALL GRDAT (F, LFIELD, CATR, IBUFF(2049), IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
C                                       If NGRDAT read CLEAN CATBLK.
         IF (NGRDAT) THEN
            ERRTXT = 'READING CLEAN CATBLK'
            CALL CATIO ('READ', CCDISK(LFIELD), CCCNO(LFIELD), KLNBLK,
     *         'REST', IBUFF(2049), IRET)
            IF ((IRET.GT.0) .AND. (IRET.LT.5)) GO TO 990
            END IF
         JNREC = 1
         JLREC = 0
         NKEY = 0
         ERRTXT = 'OPENING CLEAN COMPS FILE'
         CALL CCMINI ('READ', IBUFF, CCDISK(LFIELD), CCCNO(LFIELD),
     *      CCVER(LFIELD), KLNBLK, LUNC, CCRNO, CCKOLS, CCNUMV, CCNCOL,
     *      IRET)
         IF (IRET.GT.1) GO TO 990
         DO3D = (CCNCOL.EQ.4) .OR. (CCNCOL.EQ.8)
C                                       For point model
         MODTYP = 0
C                                       More complex models
C                                       Find columns (physical)
         IF (CCNCOL.GT.4) THEN
C                                       Read 1st record
            CCRNO = NSUBG(LFIELD)
            CALL TABCCM ('READ', IBUFF, CCRNO, CCKOLS, CCNUMV,
     *         CCNCOL, XX, YY, ZZ, FLUX, CCTYPE, PARMS, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1090) IRET, CCRNO
               GO TO 995
               END IF
C                                       Get model type.
            MODTYP = CCTYPE
            END IF
C                                       Close CLEAN components file.
         CALL TABCCM ('CLOS', IBUFF, CCRNO, CCKOLS, CCNUMV,
     *      CCNCOL, XX, YY, ZZ, FLUX, CCTYPE, PARMS, IRET)
         END IF
C                                       Bad model type.
      IF ((MODTYP.NE.0) .AND. (MODTYP.NE.1) .AND. (MODTYP.NE.3)) THEN
         WRITE (MSGTXT,1002) MODTYP
         GO TO 995
         END IF
C                                       Determine no. CC to sub.
      XNCOMP = 0
      DO 10 LFIELD = LF1,LF2
         DONE(LFIELD) = F
         XNCOMP = XNCOMP + NCLNG(LFIELD) - NSUBG(LFIELD) + 1
 10      CONTINUE
C                                       Check for point model.
      IF (DOPTMD) XNCOMP = 1
      LFIELD = LF1 - 1
C                                       Tell model type once
      IF (.NOT.ONZE) THEN
C                                       Tell model type
         MSGTXT = 'VISDFT: Model components of type '//MDTYP(MODTYP+1)
         CALL MSGWRT (2)
         ONZE = .NOT. ONZE
C                                       Check Buffer size
         IF ((XNCOMP.GT.10) .AND. (JBUFSZ/2.LT.4096)) THEN
            MSGTXT = 'VISDFT: SCRATCH BUFFER TOO SMALL FOR CCs!'
            CALL MSGWRT (8)
            IRET = 9
            GO TO 999
            END IF
         MSGTXT = 'VISDFT: using 3D Clean Component file'
         IF (DO3D) CALL MSGWRT (2)
         END IF
C                                       Set model length
      LENMOD = LMOD(MODTYP+1)
C                                       Determine size of uv I/O and
C                                       the number of CC that will fit.
      LENBU = ((JBUFSZ-2*NBPS) / 2) / (LLREC*2)
C                                       How much data fits in AP?
      JT = 15 + LENBU * LLREC
      IF (MXCC.GT.JT) JT = MXCC
      NEED = JT + NCHAN + (XNCOMP+2)*LENMOD
      NEED = NEED / 1024
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL QINIT (APCORE, NEED, 0, KAP)
      MSGSUP = MSGSAV
      IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
         NEED = JT + NCHAN + (XNCOMP/10+2)*LENMOD
         NEED = NEED / 1024
         NEED = MIN (32*1024, NEED) + 2
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
             IRET = 8
             MSGTXT = 'VISDFT (LOCAL VERSION) CANNOT GET NEEDED MEMORY'
             GO TO 995
             END IF
          END IF
      APSIZ = PSAPNW * 1024
      CALL QRLSE
      MXCMP = (APSIZ - JT - NCHAN)  / LENMOD
      MXCMP = MXCMP - 2
C                                       Set AP pointers.
C                                       UV=UV pointer, VIS=vis pointer
C                                       IAPCC=CLEAN components pointer.
      IDATA = 12 + NCHAN
      UV = IDATA + ILOCU
      IAPCC = 15 + LENBU * LLREC + NCHAN
      IF  (MXCC.GT.IAPCC) IAPCC = MXCC

      LLNMOD = LENMOD
C                                       Compute number of passes.
      NTIMES = (1.0 * XNCOMP) / MXCMP + 0.99999
      NTIMES = MAX (NTIMES, 1)
C                                       Only one pass allowed for
C                                       division.  No can do.
      IF (DIVIDE .AND. (NTIMES.GT.1)) THEN
         ERRTXT = 'TOO MANY COMPONENTS FOR DIVISION'
         IRET = 10
         GO TO 990
         END IF
C                                       Fix for Division scaling
      ABFACG = 1.0
      IF (DIVIDE) ABFACG = ABS(FACGRD(1))
C                                       Open uv files.
C                                       Set input file name.
      VOL = DISKI
      IF (DISKI.LE.0) VOL = SCRVOL(CNOSCI)
      IF (DISKI.GT.0) CALL ZPHFIL ('UV', VOL, CNOSCI, 1, NAME, IRET)
      IF (DISKI.LE.0) CALL ZPHFIL ('SC', VOL, SCRCNO(CNOSCI), 1, NAME,
     *   IRET)
C                                       Open input file.
      ERRTXT = 'OPEN-FOR-READ VIS FILE'
      CALL ZOPEN (LUNI, FINDI, VOL, NAME, T, F, T, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Create scratch file if necessary
      IF ((DISKO.LE.0) .AND. (CNOSCO.EQ.0)) THEN
         CALL UVSIZE (LREC, NVIS, ISIZE)
         ERRTXT = 'CREATING SCRATCH FILE'
         CALL SCREAT (ISIZE, SCRTCH, IRET)
         CNOSCO = NSCR
         IF (IRET.GT.0) THEN
            IF (IRET.EQ.1) ERRTXT = 'NO SPACE FOR SCRATCH FILE'
            GO TO 990
            END IF
C                                       End if creating scratch file
         END IF
C                                       Open vis file for write.
      IF (DISKO.LE.0) THEN
         VOL = SCRVOL(CNOSCO)
         CALL ZPHFIL ('SC', VOL, SCRCNO(CNOSCO), 1, NAME, IRET)
      ELSE
         VOL = DISKO
         CALL ZPHFIL ('UV', VOL, CNOSCO, 1, NAME, IRET)
         END IF
      ERRTXT = 'OPEN-FOR-WRITE VIS FILE'
      CALL ZOPEN (LUNO, FINDO, VOL, NAME, T, F, T, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Loop, subtracting Max Component
C                                       In AP each pass
      DO 500 NCALL = 1,NTIMES
C                                       Setup for % done messages.
         PCTOT = NVIS
         PCLST = PCTOT * (NCALL - 1)
         IPCLST = (100. / NTIMES ) * (NCALL - 1)
C                                       Set AP loc for next CC load
         IAPCT = IAPCC
C                                       Determine. no. this pass.
         MMCOMP = 0
         NCOMP = MIN( MXCMP, XNCOMP)
C                                       Grab AP.
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
             IRET = 8
             MSGTXT = 'VISDFT (LOCAL VERS2) CANNOT GET NEEDED MEMORY'
             GO TO 995
             END IF
C                                       Initialize REAL time clock for
C                                       AP roller.
         CALL ZTIME (ITIME)
         XTLST = (ITIME(1) * 60.00) + ITIME(2) + (ITIME(3) / 60.0)
C                                       If Not single component model.
         IF (.NOT.DOPTMD) THEN
C                                       Find next FIELD.
C                                       Loop back here for next field.
 70         LFIELD = LFIELD + 1
C                                       See if done.
            IF (LFIELD.GT.LF2) GO TO 150
            IF (DONE(LFIELD)) GO TO 70
C                                       See if there are CC.
            IF ((NSUBG(LFIELD).GT.NCLNG(LFIELD))) GO TO 70
C                                       Get field info. if nec.
            IF (.NOT.NGRDAT) THEN
               CALL GRDAT (F, LFIELD, CATR, IBUFF(2049), IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
C                                       If NGRDAT read CLEAN CATBLK.
            IF (NGRDAT) THEN
               ERRTXT = 'READING CLEAN CATBLK'
               CALL CATIO ('READ', CCDISK(LFIELD), CCCNO(LFIELD),
     *            KLNBLK, 'REST', IBUFF(2049), IRET)
               IF ((IRET.GT.0) .AND. (IRET.LT.5)) GO TO 990
               END IF
C                                       Set field center offsets.
            XXOFF = DXCG(LFIELD) * CCROT + DYCG(LFIELD) * SSROT
            YYOFF = DYCG(LFIELD) * CCROT - DXCG(LFIELD) * SSROT
            ZZOFF = DZCG(LFIELD)
            CALL XYSHFT (RA, DEC, XSHIFT(LFIELD), YSHIFT(LFIELD),
     *         MAPROT, XRA, XDEC)
            IF (DO3DIM) THEN
               CALL PRJMAT (RA, DEC, UVROT, XRA, XDEC, MAPROT, UMAT,
     *            PMAT)
            ELSE
               CALL P2DMAT (RA, DEC, UVROT, XRA, XDEC, MAPROT, UMAT,
     *            PMAT)
               END IF
C                                       Load CLEAN components into AP.
C                                       Open components file.
            ERRTXT = 'OPENING CLEAN COMPS FILE'
            CALL CCMINI ('READ', IBUFF, CCDISK(LFIELD), CCCNO(LFIELD),
     *         CCVER(LFIELD), KLNBLK, LUNC, CCRNO, CCKOLS, CCNUMV,
     *         CCNCOL, IRET)
            IF (IRET.GT.1) GO TO 990
            CCRNO = NSUBG(LFIELD)
            DO3D = CCNUMV(4).GT.0
C                                       Make sure that there are some
            IF (IBUFF(5).LE.0) GO TO 140
            IF (NCLNG(LFIELD).LE.0) NCLNG(LFIELD) = IBUFF(5)
C                                       Loop loading components.
            IAPBUF = 10
            CURCMP = MMCOMP + 1
C                                       Check next component
            IF (CCRNO.GT.NCLNG(LFIELD)) GO TO 140
            DO 130 J = CURCMP,NCOMP,MXCC
               JT = J - 1
               JNCOMP = 0
               MCOMP = NCOMP - J + 1
               IF (MCOMP.GT.MXCC) MCOMP = MXCC
               IF (MCOMP.GT.(NCLNG(LFIELD)-NSUBG(LFIELD)+1))
     *            MCOMP = NCLNG(LFIELD) - NSUBG(LFIELD) + 1
               DO 110 I = 1,MCOMP
C                                       Check if finished field
                  IF (CCRNO.GT.NCLNG(LFIELD)) GO TO 120
                  CALL TABCCM ('READ', IBUFF, CCRNO, CCKOLS, CCNUMV,
     *               CCNCOL, XX, YY, ZZ, FLUX, CCTYPE, PARMS, IRET)
                  IF (IRET.GT.0) THEN
                     WRITE (MSGTXT,1090) IRET, CCRNO
                     GO TO 995
                     END IF
C                                        Check that point comp.
                  JT = JT + 1
                  ITYPE = CCTYPE
                  IF ((ITYPE.EQ.MODTYP) .AND. (IRET.EQ.0)) THEN
C                                       Check negative component limit
                     DONE(LFIELD) = (NONEG.AND.(FLUX.LE.0.0))
     *                  .OR. (ABS(FLUX).LT.LIMFLX)
                     IF (DONE(LFIELD)) THEN
                        NCLNG(LFIELD) = CCRNO - 1
                        GO TO 120
                        END IF
C                                       If req. sum flux
                     IF (DOSUM) THEN
                        FLUXG(LFIELD) = FLUXG(LFIELD) + FLUX
                        TFLUXG = TFLUXG + FLUX
                        END IF
                     JNCOMP = JNCOMP + 1
                     CCOUNT = CCOUNT + 1
                     IF (.NOT.DO3D) THEN
                        XP(1) = (XX + XPOFF(LFIELD)) * CONST
                        XP(2) = (YY + YPOFF(LFIELD)) * CONST
                        XP(3) = 0.0
                        CALL PRJMUL (2, XP, UMAT, XYZ)
C                                       BUFF1 is measured in radians
C                                       *TWOPI
                        BUFF1(JNCOMP) = XYZ(1) + XXOFF
                        BUFF1(1024+JNCOMP) = XYZ(2) + YYOFF
                        BUFF1(2048+JNCOMP) = XYZ(3) + ZZOFF
                     ELSE
                        BUFF1(JNCOMP) = XX * CONST
                        BUFF1(1024+JNCOMP) = YY * CONST
                        BUFF1(2048+JNCOMP) = ZZ * CONST
                        END IF
C                                       Handle scaling for division
                     BUFF1(3072+JNCOMP) = ABFACG * FLUX
C
                     IF (DOPRBM) THEN
                        XX = BUFF1(JNCOMP) / TWOPI
                        YY = BUFF1(1024+JNCOMP) / TWOPI
                        IF (BTYPE .LE. 3) THEN
C                                       the primary beam is related with
C                                       the dish ilumination
C
C                                       the distance of the given
C                                       component from the shifted
C                                       center in radians
                           DTHETA = SQRT(XX*XX + YY*YY)
                           UU = DANTT / LAMBDA * SIN(DTHETA)
                           ISTEP = IROUND(UU /ASTEP) + 1
                           IF (ISTEP .LE. NSTEP) THEN
                              PFACT = PRBEAM(ISTEP)
                           ELSE
                              PFACT = 0
                              END IF
                           END IF
C
                        IF (BTYPE .EQ. 4) THEN
C                                       the primary beam is gaussian
C
C                                       rotate by BPA
                           XXT = XX*COS(PRBP) - YY*SIN(PRBP)
                           YYT = XX*SIN(PRBP) + YY*COS(PRBP)
                           UU = (XXT/PRBMA)**2 + (YYT/PRBMI)**2
                           ISTEP = IROUND(UU /ASTEP) + 1
                           IF (ISTEP .LE. NSTEP) THEN
                              PFACT = PRBEAM(ISTEP)
                           ELSE
                              PFACT = 0
                              END IF
                           END IF
C
                        IF (BTYPE .EQ. 5) THEN
C                                       the primary beam is variable
C                                       gaussian. No correction here.
C                                       Correct later at QXXPTS
                           PFACT = 1.0
                           END IF
C                                       muliply by beam
                        BUFF1(3072+JNCOMP) = BUFF1(3072+JNCOMP)*PFACT
                        END IF
C                                       Gaussian
                     IF (MODTYP.EQ.1) THEN
C                                       Convert to convenient
C                                       coefficients.
                         CPA = COS (DG2RAD*PARMS(3))
                         SPA = SIN (DG2RAD*PARMS(3))
                         XMAJ = PARMS(1) * CONST2
                         XMIN = PARMS(2) * CONST2
                         BUFF2(JNCOMP) = - (((CPA * XMAJ)**2) +
     *                      (SPA * XMIN)**2)
                         BUFF2(1024+JNCOMP) = - (((SPA * XMAJ)**2)
     *                      + (CPA * XMIN)**2)
                         BUFF2(2048+JNCOMP) = - 2.0 * CPA * SPA *
     *                      (XMAJ*XMAJ - XMIN*XMIN)
                        END IF
C                                       Sphere
                     IF (MODTYP.EQ.3) THEN
                        BUFF1(3072+JNCOMP) = 3.0 * BUFF1(3072+JNCOMP)
                        BUFF2(JNCOMP) = PARMS(1) * 0.109662271
                        BUFF2(1024+JNCOMP) = 0.1
                        END IF
                     END IF
 110              CONTINUE
C                                       Load components
 120           IF (JNCOMP.GT.0) THEN
                  LMCOMP = JNCOMP
                  MMCOMP = MMCOMP + LMCOMP
C                                       Load into AP
                  IAPBUF = 10
C                                       x component
                  CALL QPUT (APCORE, BUFF1, IAPBUF, LMCOMP, 2)
                  IAPTMP = IAPCT + 1
                  CALL QWD
                  CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD, LMCOMP)
                  CALL QWR
C                                       y component
                  CALL QPUT (APCORE, BUFF1(1025), IAPBUF, LMCOMP, 2)
                  IAPTMP = IAPCT + 2
                  CALL QWD
                  CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD, LMCOMP)
                  CALL QWR
C                                       z component
                  CALL QPUT (APCORE, BUFF1(2049), IAPBUF, LMCOMP, 2)
                  IAPTMP = IAPCT + 3
                  CALL QWD
                  CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD, LMCOMP)
                  CALL QWR
C                                       Flux density
                  CALL QPUT (APCORE, BUFF1(3073), IAPBUF, LMCOMP, 2)
                  CALL QWD
                  CALL QVMOV (APCORE, IAPBUF, 1, IAPCT, LLNMOD, LMCOMP)
                  CALL QWR
C                                       Gaussian
                  IF (MODTYP.EQ.1) THEN
C                                       Coef 1.
                     CALL QPUT (APCORE, BUFF2, IAPBUF, LMCOMP, 2)
                     IAPTMP = IAPCT + 4
                     CALL QWD
                     CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD,
     *                  LMCOMP)
                     CALL QWR
C                                       Coef 2.
                     CALL QPUT (APCORE, BUFF2(1025), IAPBUF, LMCOMP, 2)
                     IAPTMP = IAPCT + 5
                     CALL QWD
                     CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD,
     *                  LMCOMP)
                     CALL QWR
C                                       Coef 3.
                     CALL QPUT (APCORE, BUFF2(2049), IAPBUF, LMCOMP, 2)
                     IAPTMP = IAPCT + 6
                     CALL QWD
                     CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD,
     *                  LMCOMP)
                     CALL QWR
                     END IF
C                                       Sphere
                  IF (MODTYP.EQ.3) THEN
C                                       Radius
                     CALL QPUT (APCORE, BUFF2, IAPBUF, LMCOMP, 2)
                     IAPTMP = IAPCT + 4
                     CALL QWD
                     CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD,
     *                  LMCOMP)
                     CALL QWR
C                                       Minimum argument
                     CALL QPUT (APCORE, BUFF2(1025), IAPBUF, LMCOMP, 2)
                     IAPTMP = IAPCT + 5
                     CALL QWD
                     CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD,
     *                  LMCOMP)
                     CALL QWR
                     END IF
                  IAPCT = IAPCT + (LLNMOD * LMCOMP)
                  END IF
C                                       Check if finished field.
               IF ((CCRNO.GT.NCLNG(LFIELD)) .OR. DONE(LFIELD))
     *            GO TO 140
 130           CONTINUE
C                                       Close CLEAN components file.
 140        CALL TABCCM ('CLOS', IBUFF, CCRNO, CCKOLS, CCNUMV,
     *         CCNCOL, XX, YY, ZZ, FLUX, CCTYPE, PARMS, IRET)
C                                       Update field sub. count.
            NSUBG(LFIELD) = CCRNO
C                                       Check if need another field.
            IF (JT.LT.NCOMP) GO TO 70
C                                      Check no. comps.
 150        IF ((MMCOMP.EQ.0) .AND. (NCALL.EQ.1)) THEN
               ERRTXT = 'NO POINT COMPONENTS FOUND'
               IRET = 1
               GO TO 990
               END IF
C                                       No comps on later pass is OK
            IF (MMCOMP.LE.0) GO TO 510
C                                       Load correlator factors
            CALL GETCTL (CATR, FACT2, IRET)
            IF (IRET.NE.0) GO TO 999
         ELSE
C                                       Else, single component model.
            CALL RFILL (LENMOD, 0.0, BUFF1)
            BUFF1(2) = PTRAOF * CONST / 3600.
            BUFF1(3) = PTDCOF * CONST / 3600.
C                                       Point
            IF (MODTYP.EQ.0) BUFF1(1) = PTFLX
C                                       Gaussian
            IF (MODTYP.EQ.1) THEN
C                                       Convert to convenient
C                                       coefficients.
               CPA = COS (DG2RAD * PARMOD(4))
               SPA = SIN (DG2RAD * PARMOD(4))
               XMAJ = PARMOD(2) * CONST2 * 2.77777778E-4
               XMIN = PARMOD(3) * CONST2 * 2.77777778E-4
               BUFF1(5) = -(((CPA * XMAJ)**2) + (SPA * XMIN)**2)
               BUFF1(6) = -(((SPA * XMAJ)**2) + (CPA * XMIN)**2)
               BUFF1(7) = -2.0 *  CPA * SPA * (XMAJ*XMAJ - XMIN*XMIN)
               BUFF1(1) = PTFLX
               END IF
C                                       Uniform sphere
            IF (MODTYP.EQ.3) THEN
               BUFF1(5) = PARMOD(2) * 0.109662271 * 2.7777778E-4
               BUFF1(1) = PTFLX * 3.0
               BUFF1(6) = 0.1
               END IF
            MMCOMP = 1
            CALL QPUT (APCORE, BUFF1, IAPCC, LLNMOD, 2)
            IAPCT = IAPCC + LLNMOD
C                                       Set Stokes for point model
            FACT2(1) = 1.0
            FACT2(2) = 1.0
            IF (ICOR0.LT.0) THEN
C                                       RR,LL etc.
C                                       Q?
               IF (KSTOK.EQ.2) THEN
                  FACT2(1) = 1.0
                  FACT2(2) = 1.0
                  VOFF = (3 - ABS (ICOR0)) * INCS
               ELSE IF (KSTOK.EQ.3) THEN
                  FACT2(1) = 1.0
                  FACT2(2) = -1.0
                  VOFF = (3 - ABS (ICOR0)) * INCS
               ELSE IF (KSTOK.EQ.4) THEN
                  FACT2(1) = 1.0
                  FACT2(2) = -1.0
                  VOFF = 0
                  END IF
            ELSE
C                                       True Stokes
               IF ((KSTOK.GE.2) .AND. (KSTOK.LE.4)) THEN
                  FACT2(1) = 1.0
                  FACT2(2) = 0.0
                  VOFF = (KSTOK - ICOR0) * INCS
                  END IF
               END IF
            NSTOK = 1
            IF ((CATR(KRCIC+JLOCS).LT.0.0) .AND. (NCOR.GE.2)) NSTOK = 2
            IF ((NSTOK.EQ.2) .AND. (ABS (ICOR0).EQ.2)) NSTOK = 1
C                                       End if not single comp. model
            END IF
C                                       Correct for FACGRD
         NNCOR = NSTOK
         FACT2(1) = FACT2(1) * FACGRD(1)
         FACT2(2) = FACT2(2) * FACGRD(1)
         WRK = MCHAN + 2
         UUU = 1.0
         IF (FACGRD(2).EQ.0.0) UUU = 0.0
         RDUM(1) = UUU
         CALL QPUT (APCORE, RDUM, WRK+2, 1, 2)
         CALL QPUT (APCORE, FACT2, WRK, NNCOR, 2)
         SFLAG = 1
C                                       Set flag for UPOL and RL,LR data
         IF ((KSTOK.EQ.3) .AND. (ICOR0.LT.0)) SFLAG = -1
C                                       Set vis pointer
         VIS = IDATA + LRPARM + (CHANEL-1) * JNCF + (VOFF/INCS)*JNCS
C                                       Fill frequency table
         BUFF2(1) = (FREQG(CHANEL) / FREQ) - 1.0D0
         IF (NCHAN.GT.1) THEN
            DO 175 I = 2,NCHAN
               INDEX = CHANEL + I - 1
               BUFF2(I) = (FREQG(INDEX) / FREQ) - 1.0D0
 175           CONTINUE
            END IF
         CALL QWD
         CALL QPUT (APCORE, BUFF2, 2, MCHAN, 2)
         CALL QWAIT
C                                       Init for read & write
C                                       visibility file
C                                       Init vis file for write
         ERRTXT = 'INIT-FOR-READ VIS FILE'
         CALL UVINIT ('READ', LUNI, FINDI, NVIS, VO, LREC, LENBU,
     *      JBUFSZ, BUFF1, BO, IBIND, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Init vis file for read.
         ERRTXT = 'INIT-FOR-WRITE VIS FILE'
         CALL UVINIT ('WRIT', LUNO, FINDO, NVIS, VO, LREC, LENBU,
     *      JBUFSZ, BUFF2, BO, KBIND, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Subtract model from vis data.
C                                       Loop:  Read vis. record.
         FIRST = .TRUE.
C                                       identify the first block
 200        CONTINUE
            ERRTXT = 'READING VIS FILE'
            CALL UVDISK ('READ', LUNI, FINDI, BUFF1, INIO2, IBIND, IRET)
            INIO = INIO2
            IF (IRET.NE.0) GO TO 990
C                                       Exit if no more data
            IF (INIO.LE.0) GO TO 300
C                                       Uncompress Vis and put in AP
            CALL BUFPUT (APCORE, INIO, NRPARM, LREC, LLREC, IDATA,
     *         BUFF1(IBIND), IBUFF(1))
C                                       Do the arithmetic: divide
            IF (DIVIDE) THEN
C                                       Point
               IF (MODTYP.EQ.0) CALL QPTDIV (APCORE, IAPCC, UV, VIS,
     *            LLREC, JNCF, JNCS, MMCOMP, INIO, MCHAN, NNCOR)
C                                       Gaussian
               IF (MODTYP.EQ.1) CALL QGADIV (APCORE, IAPCC, UV, VIS,
     *            LLREC, JNCF, JNCS, MMCOMP, INIO, MCHAN, NNCOR)
C                                       Sphere
               IF (MODTYP.EQ.3) CALL QSPDIV (APCORE, IAPCC, UV, VIS,
     *            LLREC, JNCF, JNCS, MMCOMP, INIO, MCHAN, NNCOR)
C                                       Subtract
            ELSE
C                                       Point
               IF (MODTYP.EQ.0) CALL QXXPTS (APCORE, IAPCC, UV, VIS,
     *            LLREC, JNCF, JNCS, MMCOMP, INIO, MCHAN, NNCOR, SFLAG)
C                                       The next block is not first
               FIRST = .FALSE.
C                                       Gaussian
               IF (MODTYP.EQ.1) CALL QGASUB (APCORE, IAPCC, UV, VIS,
     *            LLREC, JNCF, JNCS, MMCOMP, INIO, MCHAN, NNCOR, SFLAG)
C                                       Sphere
               IF (MODTYP.EQ.3) CALL QSPSUB (APCORE, IAPCC, UV, VIS,
     *            LLREC, JNCF, JNCS, MMCOMP, INIO, MCHAN, NNCOR, SFLAG)
               END IF
            CALL QWR
C                                       Get UVs from AP (maybe pack UV)
            CALL BUFGET (APCORE, INIO, NRPARM, LREC, LLREC, IDATA,
     *         BUFF2(KBIND), IBUFF(1))
C                                       Write vis record.
            NIOUT = INIO
            ERRTXT = 'WRITING VIS FILE'
            CALL UVDISK ('WRIT', LUNO, FINDO, BUFF2, NIOUT, KBIND, IRET)
            IF (IRET.NE.0) GO TO 990
C                                       Check if time for % done
C                                       message.
            PCLST = PCLST + NIOUT
            IPCDNE = (100.0 / NTIMES) * (PCLST / PCTOT) + 0.5
            IPCDNE = IPCDNE - MOD (IPCDNE, 10)
C                                       Write % done message.
            IF ((IPCDNE.GT.IPCLST) .AND. (DOMSG)) THEN
               WRITE (MSGTXT,1240) IPCDNE
               IF (IPCDNE.LE.100) CALL MSGWRT (2)
               IPCLST = IPCDNE
               END IF
C                                       Check if time for AP roller
            CALL QROLL (APCORE, IAPCT, IBUFF, JBUFSZ, IRET)
            IF (IRET.NE.0) GO TO 999
            GO TO 200
C                                       Finish write
 300     CALL QRLSE
         NIOUT = 0
         ERRTXT = 'FLUSHING VIS FILE'
         CALL UVDISK ('FLSH', LUNO, FINDO, BUFF2, NIOUT, KBIND, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Update no. comp. left.
         XNCOMP = XNCOMP - MXCMP
C                                       Check if done.
         IF (XNCOMP.LE.0.01) GO TO 510
C                                       Input now output.
C                                       Close old input
         CALL ZCLOSE (LUNI, FINDI, IRET)
C                                       Set new input file name.
         IF (DISKO.LE.0) THEN
            VOL = SCRVOL(CNOSCO)
            CALL ZPHFIL ('SC', VOL, SCRCNO(CNOSCO), 1, NAME, IRET)
         ELSE
            VOL = DISKO
            CALL ZPHFIL ('UV', VOL, CNOSCO, 1, NAME, IRET)
            END IF
C                                       Open new input file.
         ERRTXT = 'OPEN-FOR-READ VIS FILE'
         CALL ZOPEN (LUNI, FINDI, VOL, NAME, T, F, T, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Open vis file for write.
C                                       Set output file name.
C                                       End big loop, N Comps per pass
 500     CONTINUE
C                                       Close files
 510  CALL ZCLOSE (LUNI, FINDI, IRET)
      CALL ZCLOSE (LUNO, FINDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  WRITE(MSGTXT,2000,ERR=999) IRET, ERRTXT
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1002 FORMAT ('VISDFT: ILLEGAL MODEL TYPE =',I3)
 1090 FORMAT ('VISDFT: ERROR',I5,' READING CLEAN COMPS REC',I5)
 1240 FORMAT ('Model computation is ',I5,' percent complete')
 2000 FORMAT ('VISDFT: ERROR',I5,' ',A)
      END
      SUBROUTINE PLNGET (IDISK, ICNO, CORN, JWIN, XOFF, YOFF, NOSCR,
     *   NX, NY, BUFF1, BUFF2, BUFSZ1, BUFSZ2, LUN1, LUN2, IRET)
C-----------------------------------------------------------------------
C   This private version allows to multiply the model by the
C   primary beam
C-----------------------------------------------------------------------
C   PLNGET reads a selected portion of a selected plane parallel to the
C   front and writes it into a specified scratch file.  The output file
C   will be zero padded and a shift of the center may be specified.  If
C   the input window is unspecified (0) and the output file is smaller
C   than the input file, the NX x NY region about position (MX/2+1-OFFX,
C   MY/2+1-OFFY) in the input map will be used where MX,MY is the size
C   of the input map.  NOTE: If both XOFF and/or YOFF and a window
C   (JWIN) which does not contain the whole map, XOFF and YOFF will
C   still be used to end-around rotate the region inside the window.
C   The image header is taken from the disk catalog AND explicitly will
C   not handle blanked images.   ******
C   Inputs:
C      IDISK    I      Input image disk number.
C      ICNO     I      Input image catalog slot number.
C      CORN     I(7)   BLC in input image (1 & 2 ignored)
C      JWIN     I(4)   Window in plane.
C      XOFF     I      offset in cells in first dimension of the center
C                      from MX/2+1 (MX 1st dim. of input win.)
C      YOFF     I      offset in cells in second dimension of the center
C                      from MY/2+1 (MY 2nd dim. of input win.)
C      NOSCR    I      Scratch file number in common /CFILES/ for outpu.
C      NX       I      Dimension of output file in X
C      NY       I      Dimension of output file in Y
C      BUFF1    R(*)   Work buffer
C      BUFF2    R(*)   Work buffer.
C      BUFSZ1   I      Size in AIPS bytes of BUFF1
C      BUFSZ2   I      Size in AIPS bytes of BUFF2
C      LUN1     I      Logical unit number for input file
C      LUN2     I      Logical unit number to use for output
C   Output:
C      IRET     I      Return error code, 0 => OK,
C                       1 = couldn't copy input CATBLK
C                       2 = wrong number of bits/pixel in input map.
C                       3 = input map has inhibit bits.
C                       4 = couldn't open output map file.
C                       5 = couldn't init input map.
C                       6 = couldn't init output map.
C                       7 = read error input map.
C                       8 = write error output map.
C                       9 = error computing block offset
C                       10 = output file too small.
C   Common:
C      /MAPHDR/ CATBLK  is set to the input file CATBLK.
C   Programmer: W. D. Cotton, May 1982.
C-----------------------------------------------------------------------
      INTEGER   IDISK, ICNO, CORN(7), JWIN(4), XOFF, YOFF, NOSCR, NX,
     *   NY, BUFSZ1, BUFSZ2, LUN1, LUN2, IRET
      REAL      BUFF1(*), BUFF2(*)
      REAL   XINCR, YINCR, XPIX, YPIX, DTHETA, PFACT, UU,
     *   XTETA, YTETA, XX, YY
      INTEGER   ICOLS, IROW, ISTEP, IROUND
C
      CHARACTER PHNAME*48, IFILE*48
      INTEGER   IERR, WIN(4), FIND1, FIND2, BIND1, BIND2, BO, RBO, I4,
     *   IFIRST, ILAST, IOUT, KORN(7), IADD, INDEX, LIM, IOFF, LIM1, MX,
     *   MY, JOFF1, JOFF2, LIMIT, NUM, OFFX, OFFY, IWIN(4), MMX, MMY,
     *   SCRTCH(256)
      LOGICAL   T, F
      INCLUDE 'PRBM.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
C
      INTEGER   CATBLK(256)
      REAL      CATR(256)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
C
      INCLUDE 'INCS:PSTD.INC'
      DATA RBO /1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IRET = 0
      OFFX = XOFF
      OFFY = YOFF
      FIND1 = 0
      FIND2 = 0
C                                       Read input CATBLK
      CALL CATIO ('READ', IDISK, ICNO, CATBLK, 'REST', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
C                                       increments and ref. point from
C                                       header
      XINCR = CATR(KRCIC) * DG2RAD
      YINCR = CATR(KRCIC+1) * DG2RAD
      XPIX = CATR(KRCRP)
      YPIX = CATR(KRCRP+1)
C                                       Make sure there are NO blanks
      IF (CATR(KRBLK).NE.0.0) THEN
         IRET = 3
         WRITE (MSGTXT,1020)
         GO TO 990
         END IF
C                                       Determine mapsize
      MX = CATBLK(KINAX)
      MY = CATBLK(KINAX+1)
C                                       Check defaults on IWIN
      CALL COPY (4, JWIN, IWIN)
      IF ((MX.GT.NX) .AND. ((IWIN(1).EQ.0) .OR. (IWIN(3).EQ.0))) THEN
         IWIN(1) = (MX/2+1) - (NX/2) - OFFX
         IWIN(3) = (MX/2+1) + (NX/2-1) - OFFX
         OFFX = 0
         END IF
      IF ((MY.GT.NY) .AND. ((IWIN(2).EQ.0) .OR. (IWIN(3).EQ.0))) THEN
         IWIN(2) = (MY/2+1) - (NY/2) - OFFY
         IWIN(4) = (MY/2+1) + (NY/2-1) - OFFY
         OFFY = 0
         END IF
      IF (IWIN(1).LE.0) IWIN(1) = 1
      IF (IWIN(2).LE.0) IWIN(2) = 1
      IF ((IWIN(3).LE.0) .OR. (IWIN(3).GT.MX)) IWIN(3) = MX
      IF ((IWIN(4).LE.0) .OR. (IWIN(4).GT.MY)) IWIN(4) = MY
C                                        Determine input window size.
      MMX = IWIN(3) - IWIN(1) + 1
      MMY = IWIN(4) - IWIN(2) + 1
C                                        Determine first and last
C                                        output rows for read.
      IFIRST = ((NY - MMY) / 2.0) + 1.6
      ILAST = IFIRST + (IWIN(4) - IWIN(2))
C                                        Check defaults on CORN
      IERR = 0
      DO 45 I4 = 1,KICTPN
         KORN(I4) = 1
         IF (I4.LE.CATBLK(KIDIM)) THEN
            KORN(I4) = MAX (CORN(I4), 1)
            IF (CATBLK(KINAX+I4-1).LE.1) KORN(I4) = 1
            IF (CATBLK(KINAX+I4-1).LT.KORN(I4)) IERR = 2
            END IF
 45      CONTINUE
C                                       Set input BLOCK offset.
      IF (IERR.EQ.0) THEN
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), KORN(3), BO, IERR)
         BO = BO + 1
         END IF
      IF (IERR.NE.0) THEN
         IRET = 9
         WRITE (MSGTXT,1045) IERR
         GO TO 990
         END IF
C                                       Set window for output.
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NX
      WIN(4) = NY
C                                        Make sure input window .le.
C                                        output file size.
      IF ((NX.LT.MMX) .OR. (NY.LT.MMY)) THEN
         IRET = 10
         WRITE (MSGTXT,1050) NX, NY, MMX, MMY
         GO TO 990
         END IF
      INDEX = - OFFY
      IF (INDEX.LT.0) INDEX = MMY - OFFY
      WIN(2) = INDEX + 1
C                                       If OFFX positive
      LIM = OFFX
      JOFF1 = MMX - OFFX - 1
      JOFF2 = - OFFX - 1
      IADD = (NX - MMX) / 2.0 + 0.6
C                                       If OFFX .LE. 0
      IF (OFFX.LE.0) THEN
         LIM = MMX + OFFX
         JOFF1 = - OFFX - 1
         JOFF2 = - MMX - OFFX - 1
         END IF
      JOFF1 = JOFF1 + IADD
      JOFF2 = JOFF2 + IADD
      LIMIT = MMX
      LIM = MIN (LIM, LIMIT)
      LIM1 = LIM + 1
C                                       Open output map file.
      CALL ZPHFIL ('SC', SCRVOL(NOSCR), SCRCNO(NOSCR), 1, PHNAME, IERR)
      CALL ZOPEN (LUN2, FIND2, SCRVOL(NOSCR), PHNAME, T, T, F, IERR)
      IF (IERR.NE.0) THEN
         IRET = 4
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
C                                       Open input file.
      CALL ZPHFIL ('MA', IDISK, ICNO, 1, IFILE, IERR)
      CALL ZOPEN (LUN1, FIND1, IDISK, IFILE, T, T, F, IERR)
      IF (IERR.NE.0) THEN
         IRET = 4
         WRITE (MSGTXT,1065) IERR
         CALL MSGWRT (8)
         GO TO 980
         END IF
C                                       Init files.
      CALL MINIT ('READ', LUN1, FIND1, MX, MY, IWIN, BUFF1, BUFSZ1, BO,
     *   IERR)
      IF (IERR.NE.0) THEN
         IRET = 5
         WRITE (MSGTXT,1070) IERR
         GO TO 970
         END IF
      CALL MINIT ('WRIT', LUN2, FIND2, NX, NY, WIN, BUFF2, BUFSZ2, RBO,
     *   IERR)
      IOUT = WIN(2) - 1
      IF (IERR.NE.0) THEN
         IRET = 6
         WRITE (MSGTXT,1080) IERR
         GO TO 970
         END IF
C                                       Finally do what you are here for
      DO 200 I4 = 1,NY
         IOUT = IOUT + 1
C                                       Restart at first of output file
C                                       Finish write.
         IF (IOUT.GT.NY) THEN
            CALL MDISK ('FINI', LUN2, FIND2, BUFF2, BIND2, IERR)
            IF (IERR.NE.0) THEN
               IRET = 8
               WRITE (MSGTXT,1090) IERR, NY
               GO TO 970
               END IF
            INDEX = 1
            WIN(4) = WIN(2) - 1
            WIN(2) = 1
            CALL MINIT ('WRIT', LUN2, FIND2, NX, NY, WIN, BUFF2, BUFSZ2,
     *         RBO, IERR)
            IOUT = WIN(2)
            IF (IERR.NE.0) THEN
               IRET = 6
               WRITE (MSGTXT,1080) IERR
               GO TO 970
               END IF
            END IF
C                                       Write real map.
         CALL MDISK ('WRIT', LUN2, FIND2, BUFF2, BIND2, IERR)
         IF (IERR.NE.0) THEN
            IRET = 8
            WRITE (MSGTXT,1090) IERR, I4
            GO TO 970
            END IF
C                                       Zero fill output row.
         CALL RFILL (NX, 0.0, BUFF2(BIND2))
C                                       Check if data for this row.
         IF ((IOUT.GE.IFIRST) .AND. (IOUT.LE.ILAST)) THEN
C                                       Read map row.
            CALL MDISK ('READ', LUN1, FIND1, BUFF1, BIND1, IERR)
            IF (IERR.NE.0) THEN
               IRET = 7
               WRITE (MSGTXT,1105) IERR, I4
               GO TO 970
               END IF
C                                       Move to output buffer.
            IROW = IOUT - IFIRST + 1
            IF (DOPRBM) THEN
               YTETA = (IROW - YPIX) * YINCR - DECSH
               DO 120 ICOLS = 1, MX
                  XTETA = (ICOLS - XPIX) * XINCR - RASH
                  IF (BTYPE.LE.3) THEN
C                                       the primary beam is related with
C                                       the dish ilumination

C                                       the distance of the given
C                                       component from the shifted
C                                       center in radians

                     DTHETA = SQRT(XTETA*XTETA+YTETA*YTETA)
                     UU = DANTT / LAMBDA * SIN(DTHETA)
                     ISTEP = IROUND(UU /ASTEP) + 1
                     IF (ISTEP .LE. NSTEP) THEN
                        PFACT = PRBEAM(ISTEP)
                     ELSE
                        PFACT = 0
                        END IF
                     END IF

                  IF (BTYPE .EQ. 4) THEN
C                                       the primary beam is gaussian
C
C                                       rotate by BPA
                     XX = XTETA*COS(PRBP) - YTETA*SIN(PRBP)
                     YY = XTETA*SIN(PRBP) + YTETA*COS(PRBP)
                     UU = (XX/PRBMA)**2 + (YY/PRBMI)**2
                     ISTEP = IROUND(UU /ASTEP) + 1
                     IF (ISTEP .LE. NSTEP) THEN
                        PFACT = PRBEAM(ISTEP)
                     ELSE
                        PFACT = 0
                        END IF
                     END IF
C                                       muliply by beam
                  BUFF1(BIND1+ICOLS-1) = BUFF1(BIND1+ICOLS-1)*PFACT
  120             CONTINUE
               END IF
            IOFF = BIND2 + JOFF1
            CALL RCOPY (LIM, BUFF1(BIND1), BUFF2(IOFF+1))
            IF (LIM.LT.LIMIT) THEN
               IOFF = BIND2 + JOFF2
               NUM = LIMIT - LIM1 + 1
               CALL RCOPY (NUM, BUFF1(BIND1+LIM1-1), BUFF2(IOFF+LIM1))
               END IF
            END IF
 200     CONTINUE
C                                       Finish write.
      CALL MDISK ('FINI', LUN2, FIND2, BUFF2, BIND2, IERR)
      IF (IERR.NE.0) THEN
         IRET = 8
         WRITE (MSGTXT,1090) IERR, NY
         END IF
C                                       Close real map file.
 970  IF (IRET.NE.0) CALL MSGWRT (8)
      IF (FIND1.GT.0) CALL ZCLOSE (LUN1, FIND1, IERR)
C                                       Close integer map file.
 980  IF (FIND2.GT.0) CALL ZCLOSE (LUN2, FIND2, IERR)
      GO TO 999
C                                       message only
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PLNGET: ERROR',I3,' READING INPUT CATBLK')
 1020 FORMAT ('PLNGET: MAP IS BLANKED AND I AM NOT ALLOWED TO HANDLE',
     *   ' IT')
 1045 FORMAT ('PLNGET: ERROR',I3,' COMPUTING BLOCK OFFSET')
 1050 FORMAT ('PLNGET: OUTPUT MAP TOO SMALL',2I6,' .LT. ',2I6)
 1060 FORMAT ('PLNGET: ERROR',I3,' OPENING OUTPUT FILE')
 1065 FORMAT ('PLNGET: ERROR',I3,' OPENING INPUT FILE')
 1070 FORMAT ('PLNGET: CANNOT INIT INPUT MAP, ERROR',I3)
 1080 FORMAT ('PLNGET: CANNOT INIT OUTPUT MAP, ERROR',I3)
 1090 FORMAT ('PLNGET: WRITE ERROR',I3,' ROW ',I5)
 1105 FORMAT ('PLNGET: READ ERROR',I3,' ROW ',I5)
      END
      SUBROUTINE GRDAT (DOXY, IFIELD, CATR, SCRTCH, IRET)
C-----------------------------------------------------------------------
C   GRDAT gets information about a CLEAN components file for GRDSUB.
C   Checks to see if data in XY order.
C   The system version prepares the shifts between the model center
C   and the center given at input parameters (RA=0, DEC= APARM(3)).
C   The first version of the private GRDAT excludes the shift at all.
C   The second version prepares the shift of the map with the center
C   given at input parameters (RA=0, DEC= APARM(3)). The shift is
C   given at the input parameters RASHIFT, DECSHIFT
C   Input:
C      DOXY     L        If true then check sort order ('X*')
C      IFIELD   I        Current field number.  <0 => beam -IFIELD
C      CATR     R(256)   The uv data file catalog header record.
C   Input from commons:
C      RA       D        RA of uv data. (deg.)
C      DEC      D        Declination of uv data.
C      DO3DIM   L        T => images produced by reprojecting u,v,w
C   Output:
C      BUFF1    R(256)   Working buffer.
C      IRET     I        Return error code, 0=>OK, otherwise failed.
C   Output in common /MAPDES/
C      FLDSZ    I(2,*)   Size of the CLEAN map field.
C      NXUNF    I        Dimension (cells) of the map in RA to be used
C                        to determine uniform wt. counting box if 0
C                        when called.
C      NYUNF    I        Dimensions (cells) of the map in Dec to be
C                        used to determine uniform wt. counting box if
C                        0 when called.
C      CELLSG   R(2)     Cellsize of the CLEAN maps (asec.)
C      SCLUG    R(*)     Scaling to cells in u coordinate.
C      SCLVG    R(*)     Scaling to cells in v coordinate.
C      SCLWG    R(*)     Scaling to cells in w coordinate.
C      SCLUM    R        Scaling to cells in u for NXUNF
C      SCLVM    R        Scaling to cells in v for NYUNF
C      DXCG     R(*)     Position offset parameter in x (RA) corrected
C                        to uv data set rotation
C      DYCG     R(*)     Position offset parameter in y (dec) corrected
C                        to uv data set rotation
C      DZCG     R(*)     Position offset parameter in z.
C                        DXCG, DYCG, DZCG is equal zero in the local
C                        version of the GRDAT
C      XSHIFT   R(*)     X shift arc sec
C      YSHIFT   R(*)     Y shift in arc sec
C      XPOFF    R(*)     Pixel offset in x for clean components to
C                        field phase center from tang. point. (deg.)
C      YPOFF    R(*)     Pixel offset in Y for clean components to
C                        field phase center from tang. point. (deg.)
C      XFLD     R(*)     Field of view in X (RA) in seconds.
C      YFLD     R(*)     Field of view in Y (dec) in seconds.
C      CCROT    R        Cosine of position angle difference between
C                        orientation of uv data and CLEAN image times
C                        constant for coordinate conversion.
C      SSROT    R        Sine of position angle difference between
C                        orientation of uv data and CLEAN image.
C                        CCROT = 1, SSROT = 0 in the local
C                        version of the GRDAT
C      OSFX     R        Over sampling factors in X
C      OSFY     R        Over sampling factors in Y
C      ICNTRX   I(*)     Center cell number in X
C      ICNTRY   I(*)     Center cell number in Y
C      KLNBLK   I(256)   Catalog header record of current CLEAN field.
C-----------------------------------------------------------------------
      LOGICAL   DOXY
      INTEGER   IFIELD, SCRTCH(*), IRET
      REAL      CATR(256)
C
      CHARACTER CHTEMP*8
      HOLLERITH CLNH(256)
      INTEGER   NX, NY, JFIELD, KVOL, KCNO, IRAOFF, IDECOF, IERR, NCHK,
     *   INDEX, LFIELD
      LOGICAL   DOUBX, DOUBY
      REAL      CLNR(256)
      DOUBLE PRECISION CLND(128), CLNRA, CLNDEC, RAX, DECX
      INCLUDE 'PRBM.INC'
      INCLUDE 'INCS:PSTD.INC'
C      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMPR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (KLNBLK, CLNR, CLND, CLNH)
C-----------------------------------------------------------------------
C                                       If beam do field 1
      JFIELD = IFIELD
      IF (IFIELD.LE.0) THEN
         JFIELD = 1
         LFIELD = MAX (1, -IFIELD)
         MSGTXT = 'GRDAT: beam defines image - probably should not'
         CALL MSGWRT (6)
      ELSE
         JFIELD = IFIELD
         LFIELD = 1
         END IF
C                                       Check sort order in /UVHDR/.
C                                       Wrong sort order.
      IF ((ISORT(1:1).NE.'X') .AND. (DOXY)) THEN
         IRET = 9
         WRITE (MSGTXT,1000) ISORT, 'X*'
         GO TO 990
         END IF
      IF (IFIELD.LE.0) THEN
         KVOL = BEMVOL(LFIELD)
         KCNO = CNOBEM(LFIELD)
      ELSE
         KVOL = CCDISK(JFIELD)
         KCNO = CCCNO(JFIELD)
         END IF
      CALL CATIO ('READ', KVOL, KCNO, KLNBLK, 'REST', SCRTCH, IRET)
      IF ((IRET.NE.0) .AND. (IRET.LE.4)) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Get field information
C                                       Drop hopefully obsolete fix
C     CALL FXSHFT (KLNBLK, IERR)
C                                       Field size
      FLDSZ(1,JFIELD) = KLNBLK(KINAX)
      FLDSZ(2,JFIELD) = KLNBLK(KINAX+1)
C                                       Uniform weighting size.
      IF (NXUNF.LE.0) NXUNF = KLNBLK(KINAX)
      IF (NYUNF.LE.0) NYUNF = KLNBLK(KINAX+1)
C                                       Cellsize
      CELLSG(1) = CLNR(KRCIC) * 3.6E3
      CELLSG(2) = CLNR(KRCIC+1) * 3.6E3
C                                       Over sampling factor.
      OSFX = 1.0
      OSFY = 1.0
C                                       Double if possible
      DOUBX = FLDSZ(1,JFIELD).LE.2048
      DOUBY = FLDSZ(2,JFIELD).LE.2048
      IF (DOUBX) OSFX = 2.0
      IF (DOUBY) OSFY = 2.0
      NX = FLDSZ(1,JFIELD)
      NY = FLDSZ(2,JFIELD)
C                                       Field of view
      XFLD(JFIELD) = ABS (CELLSG(1)) * NX
      YFLD(JFIELD) = ABS (CELLSG(2)) * NY
C                                       Set map center.
      ICNTRX(JFIELD) = NX / 2
      ICNTRY(JFIELD) = NY / 2 + 1
C                                       u,v,w scaling
      SCLUG(JFIELD) = NX * ABS (CELLSG(1)) * DG2RAD / 3600.0D0
      SCLVG(JFIELD) = -NY * CELLSG(2) * DG2RAD / 3600.0D0
      SCLWG(JFIELD) = 1.0
      SCLUM = NXUNF * ABS (CELLSG(1)) * DG2RAD / 3600.0D0
      SCLVM = -NYUNF * CELLSG(2) * DG2RAD / 3600.0D0
C                                       Find "CLEAN" RA and Dec axes.
      INDEX = JLOCR * 2
      CALL H2CHR (8, 1, CATR(KHCTP+INDEX), CHTEMP)
      IRAOFF = 0
      NCHK = 4
      IF (CHTEMP(1:4).EQ.'RA  ') NCHK = 2
      CALL AXEFND (NCHK, CHTEMP, KICTPN, CLNH(KHCTP), IRAOFF, IERR)
      INDEX = JLOCD * 2
      CALL H2CHR (8, 1, CATR(KHCTP+INDEX), CHTEMP)
      IDECOF = 1
      NCHK = 4
      IF (CHTEMP(1:4).EQ.'DEC ') NCHK = 3
      CALL AXEFND (NCHK, CHTEMP, KICTPN, CLNH(KHCTP), IDECOF, IERR)
C                                       Get position offsets of phase
C                                       centers.
      IF (DO3DIM) THEN
C                                       reference declination of the
C                                       model should be equal 0
         CLNRA = 0
C                                       reference declination of the
C                                       model should be equal APARM(3)
         CLNDEC = DELT
         RAX = RA
         DECX = DEC
      ELSE
C                                       reference declination of the
C                                       model should be equal 0
         CLNRA = 0 + CLNR(KRXSH)
C                                       reference declination of the
C                                       model should be equal APARM(3)
         CLNDEC = DELT + CLNR(KRYSH)
         RAX = RA + CATR(KRXSH)
         DECX = DEC + CATR(KRYSH)
         END IF
C                                       Prepare for shift and rotate
C                                       of model.
      CALL ROTFND (CLNR, MAPROT, IRET)
      CALL ROTFND (CATR, UVROT, IRET)
C                                       Field offset of the UV data
C                                       relatively desired
C                                       center of the model in arcsec
C   The following 7 cards are instead of SHFTXY.FOR
      IF (DOSHFT) THEN
         XSHIFT(JFIELD) = -RASHS
         YSHIFT(JFIELD) = -DECSHS
      ELSE
         XSHIFT(JFIELD) = 0.0
         YSHIFT(JFIELD) = 0.0
         END IF
C                                       set shift terms for field cent.
C                                       -NCP projection
      IF (TYPUVD.EQ.-1) THEN
         CALL SHINCP (RAX, DECX, MAPROT, CLNRA, CLNDEC, DXCG(JFIELD),
     *      DYCG(JFIELD), DZCG(JFIELD))
C                                       -SIN projection
      ELSE
         CALL SHISIN (RAX, DECX, MAPROT, CLNRA, CLNDEC, DXCG(JFIELD),
     *      DYCG(JFIELD), DZCG(JFIELD))
         END IF
C                                       Get reference pixel offsets from
C                                       tangent point
      XPOFF(JFIELD) = (CLNR(KRCRP+IRAOFF) - KLNBLK(KINAX+IRAOFF)/2)
     *   * CLNR(KRCIC+IRAOFF)
      YPOFF(JFIELD) = (CLNR(KRCRP+IDECOF) - KLNBLK(KINAX+IDECOF)/2 - 1)
     *   * CLNR(KRCIC+IDECOF)
C                                       No rotation in the local
C                                       version of the GRDAT
      CCROT = 1
      SSROT = 0
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UV DATA IN WRONG SORT ORDER =''',A2,''' NOT ''',A2,'''')
 1010 FORMAT ('GRDAT: ERROR',I5,' READING CATBLK ')
      END
      SUBROUTINE TWON (NPIX, IERR)
C-----------------------------------------------------------------------
C   This subroutine put IERR=0 if NPIX.EQ.2**N and
C   put IERR=1 if NPIX.NE.2**N
C
C   Inputs:
C    NPIX     I    Given integer number
C   Outputs:
C    IERR     I    Error: IF (NPIX.EQ.2**N) IERR = 0
C                         ELSE IERR = 1
C-----------------------------------------------------------------------
      INTEGER NPIX, IERR, IDIV, LDIV, IREST
C-----------------------------------------------------------------------
      IERR = 0
      LDIV = NPIX
   10 IDIV = LDIV / 2.0
      IREST = LDIV - 2 * IDIV
      IF (IREST .NE. 0) THEN
         IERR = 1
         GO TO 999
      ELSE
         LDIV = IDIV
         IF (IDIV .NE. 1) GO TO 10
         END IF
C
 999  RETURN
      END
      SUBROUTINE UVCINT (NLINE2, IAN, ELEVA, TSYS, EFFEL,
     *   IANTN, ELEVAT, TINTER, EINTER, IERR)
C-----------------------------------------------------------------------
C   Routine interpolates the given elevation of the given antenna
C   based on the givenarray of elevation, TSYS, and Efficiency
C   INPUTS
C      NLINE2    I    number of elements at the following arrays
C      IAN(*)    I    array of antenna numbers
C      ELEVA(*)  R    array of elevations, in degrees
C      TSYS(*)   R    array of system temperatures, in degrees
C      EFFEL(*)  R    array of antenna efficiencies
C      IANTN     I    Antenna number
C      ELEVAT    R    Elevation of the antenna
C   Output:
C      TINTER    R    Interpolated TSYS for the given IANTN, ELEVAT
C      EINTER    R    Interpolated Efficiensy for the given IANTN, ELEVAT
C      IERR      I    Return error code , 0=OK else failed.
C-----------------------------------------------------------------------
      INTEGER   NLINE2, IAN(*), IANTN, IERR, I
      REAL      ELEVA(*), TSYS(*), EFFEL(*), ELEVAT, TINTER, EINTER,
     *          ELEFT, ERIGHT, ELEVI, TSYSL, TSYSR, EFFR, EFFL
C-----------------------------------------------------------------------
      IERR = 10
C                                       Interpolate TSYS and Efficiency
C                                       using the data obtained from
C                                       the input arrays
      ELEFT = 0.0
      ERIGHT = 100.0
      DO 100 I = 1, NLINE2
         ELEVI = ELEVA(I)
C                                       select antenna
         IF (IANTN.EQ.IAN(I)) THEN
C                                       find the nearest (to ELEVAT)
C                                       right elevation and the relevant
C                                       TSYS and Eficiency
            IF ((ELEVI.GT.ELEVAT) .AND. (ELEVI.LT.ERIGHT)) THEN
               ERIGHT = ELEVI
               TSYSR = TSYS(I)
               EFFR = EFFEL(I)
               END IF
C                                       find the nearest (to ELEVAT)
C                                       left elevation and the relevant
C                                       TSYS and Eficiency
            IF ((ELEVI.LT.ELEVAT) .AND. (ELEVI.GT.ELEFT)) THEN
               ELEFT = ELEVI
               TSYSL = TSYS(I)
               EFFL = EFFEL(I)
               END IF
C                                       At least one line with IANTN
C                                       has been found
            IERR = 0
            END IF
 100     CONTINUE

C                                       No line with antenna IANTN
      IF (IERR .EQ. 10) GO TO 999
C
      IF (ERIGHT.EQ.100) THEN
         IF (ELEFT.EQ.0) THEN
            TINTER = 0
            EINTER = 0
         ELSE
            TINTER = TSYSL
            EINTER = EFFL
            END IF
      ELSE
         IF (ELEFT.EQ.0) THEN
            TINTER = TSYSR
            EINTER = EFFR
         ELSE
C                                       make the interpolation itself
            TINTER = TSYSL +
     *         (TSYSR-TSYSL) * (ELEVAT-ELEFT) / (ERIGHT-ELEFT)
            EINTER = EFFL +
     *         (EFFR - EFFL) * (ELEVAT-ELEFT) / (ERIGHT-ELEFT)
            END IF
         END IF
 999  RETURN
      END

      SUBROUTINE MLREOF (FDVEC, TBIND, UNKNWN, BUFFER, IERR)
C-----------------------------------------------------------------------
C! advances tape to end of file and reports records read in TAPIO system
C# Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   MLREOF advances the tape counting records until an end of file is
C   read.
C   Inputs:
C      FDVEC    I(50)  File descriptor vector.
C      TBIND    I      Buffer pointer
C   In/Out:
C      UNKNWN   I      Number of unknown records skipped
C   Output:
C      BUFFER   I(*)   I/O buffer.
C      IERR     I      0 => okay (incl. EOF), else tape trouble
C-----------------------------------------------------------------------
      INTEGER   FDVEC(50), TBIND, UNKNWN, BUFFER(*), IERR
C
      INTEGER   ERREOF, I, NC
      INCLUDE 'INCS:DMSG.INC'
      DATA ERREOF /4/
C-----------------------------------------------------------------------
      NC = 0
C                                        suppress messages
      MSGSUP = 32000
      DO 20 I = 1,2000
         NC = NC + 1
         UNKNWN = UNKNWN + 1
         CALL TAPIO ('READ', FDVEC, BUFFER, TBIND, IERR)
         IF (IERR.EQ.0) GO TO 20
            NC = NC - 1
            UNKNWN = UNKNWN - 1
            IF (IERR.NE.ERREOF) NC = -I
            GO TO 30
 20      CONTINUE
C                                        messages
 30   MSGSUP = 0
      WRITE (MSGTXT,1030) NC
      IF (NC.GE.2000) WRITE (MSGTXT,1031)
      IF (NC.EQ.0) WRITE (MSGTXT,1032)
      IF (NC.LT.0) WRITE (MSGTXT,1033) IERR
      CALL MSGWRT (5)
      IF (NC.GE.0) IERR = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (I7,' UNKNOWN RECORDS READ BEFORE EOF')
 1031 FORMAT ('END OF FILE NOT FOUND AFTER 2000 RECORDS')
 1032 FORMAT ('End of file read as expected')
 1033 FORMAT ('TAPE ERROR',I5,' WHILE SEARCHING FOR EOF')
      END

      SUBROUTINE ZVTVXF (BUFSW, BUFSR, HBUF, IERR)
C-----------------------------------------------------------------------
C! sends data from the client (virtual TV) to server (real TV)
C# TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZVTVXF performs "I/O" over some communication mechanism to a
C   cooperating program with the intention of driving a real TV device
C   controlled by the cooperating program.
C   Inputs:
C      BUFSW  I      Number 16-bit integers extra data to send
C      BUFSR  I      # 16-bit integers of extra data to receive
C   In/Out:
C      HBUF   I(*)   Buffer:  in FITS standard 16 bit
C                       (1,2) :  READ or WRIT
C                       (3,5) :  subroutine name packed ASCII
C                       (6)   :  BUFSW
C                       (7)   :  BUFSR (TV IERR returned)
C                       (8)   : error return
C                       (9..) :  extra data
C   Output:
C      IERR   I      Error code:  0 => ok.
C   Generic version - does little except call ZVTVX2
C-----------------------------------------------------------------------
      INTEGER   BUFSW, BUFSR, HBUF(*), IERR
C
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE 'INCS:DTVD.INC'
C-----------------------------------------------------------------------
      CALL ZVTVX2 (FTAB(TVIND+NMOFF), BUFSW, BUFSR, HBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (7)
      ELSE
         CALL ZI16IL (1, 8, HBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            CALL MSGWRT (7)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZVTVX2 RETURNS ERROR CODE',I7)
 1010 FORMAT ('REMOTE TV RETURNS ERROR CODE',I7)
      END

      SUBROUTINE CATIO (OP, IVOL, CNO, CATBLK, STAT, BUFF, IERR)
C-----------------------------------------------------------------------
C! reads/writes header blocks in the catalog file
C# Catalog Header
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CATIO reads or writes blocks in the map catalog header file.
C   Inputs:
C      OP       C*4      'READ' => get block into CATBLK
C                        'WRIT' => put CATBLK onto disk catalog
C                        'UPDT' => as WRIT but for use when the calling
C                                  program has previously set the
C                                  status to WRITE
C      IVOL     I        Disk volume containing catalog (1 rel)
C      CNO      I        Slot number of interest
C      CATBLK   I(256)   Array to be written on disk: WRIT, UPDT
C      STAT     C*4      Status desired for slot after operation
C                            'READ','WRIT','REST' where REST => no
C                            change of status is desired
C   Outputs:
C      CATBLK   I(256)   Array read from disk: READ
C      BUFF     I(256)   Working buffer
C      IERR     I        Error code: 0 => ok
C                           1 => cannot open catalog file
C                           2 => input parameter error
C                           3 => cannot read catalog file
C                           4 => cannot WRIT/UPDT: file is busy
C                           5 => did READ/UPDT, cannot add STAT = WRIT
C                           6 => Warning on READ, file writing
C                           7 => As 6, also added STAT=READ
C                           8 => As 6, STAT inconsistent or wrong
C                           9 => Warning: STAT inconsistent/wrong
C   The requested OP is performed unless IERR = 1 through 4.  The
C   final status requested is not set if IERR = 1 - 5, 8 - 9.  The
C   latter are probably unimportant.
C-----------------------------------------------------------------------
      CHARACTER OP*4, STAT*4
      INTEGER   IVOL, CNO, CATBLK(256), BUFF(256), IERR
C
      INTEGER   NREC, IWER(2,5), IER, CMAX, CMOD, NIND, OPSTAT, STSTAT,
     *   IOP, NOP, CIND, NSTAT, NISTAT, CLUN, INERR, OPNER, RDERR, NWPL,
     *   NLPR, NTIME, IT(6)
      LOGICAL   T, F, DOSTAT
      CHARACTER CLOP(3)*4, PHNAME*48, CB*2, OPCODE(3)*4
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDRC.INC'
      DATA NOP /3/
      DATA OPCODE /'WRIT','READ','UPDT'/
      DATA CLOP   /'CLWR','CLRD','REST'/
      DATA OPNER, INERR, RDERR /1, 2, 3/
      DATA IWER /0,6, 6,7, 9,8, 5,5, 9,8/
      DATA CLUN, CB /15,'CB'/
      DATA NSTAT, NTIME /1,2/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       check OPcode
      DO 10 IOP = 1,NOP
         IF (OPCODE(IOP).EQ.OP) GO TO 15
 10      CONTINUE
      IERR = INERR
      WRITE (MSGTXT,1010) OP
      CALL MSGWRT (6)
      GO TO 999
C                                       open catalog file
 15   CALL CATOPN (IVOL, CIND, BUFF, CMAX, IERR)
      IF (IERR.EQ.3) GO TO 980
      IF (IERR.NE.0) THEN
         IERR = OPNER
         GO TO 999
         END IF
C                                       check validity of CNO
      IF ((CNO.LE.0) .OR. (CNO.GT.CMAX)) THEN
         IERR = INERR
         WRITE (MSGTXT,1015) CNO
         GO TO 970
         END IF
C                                       get directory block
      DOSTAT = DSKLOK(IVOL).NE.1
C                                       cat block change allowed?
      IF (DOSTAT) THEN
         NWPL = 10
         NLPR = 256 / NWPL
         CMOD = (CNO - 1) / NLPR
         NREC = 2 + CMOD
         NIND = 1 + NWPL * (CNO - NLPR*CMOD - 1)
         CALL ZFIO ('READ', CLUN, CIND, NREC, BUFF, IER)
         IF (IER.NE.0) THEN
            IERR = RDERR
            GO TO 980
            END IF
         NISTAT = NIND + NSTAT
         IF (IOP.NE.3) THEN
            CALL CHSTAT (OP, BUFF(NISTAT), OPSTAT)
         ELSE
            OPSTAT = 0
            IF (BUFF(NISTAT).GT.0) OPSTAT = 3
            END IF
C                                       error: map too busy
         IF (OPSTAT.EQ.3) THEN
            IERR = 4
            WRITE (MSGTXT,1020) CNO
            CALL MSGWRT (6)
C                                       reset operation status
         ELSE
            CALL CHSTAT (CLOP(IOP), BUFF(NISTAT), IER)
C                                       set requested final status
            CALL CHSTAT (STAT, BUFF(NISTAT), STSTAT)
            IERR = IWER(OPSTAT+1, STSTAT+1)
            IF ((OPSTAT.EQ.1) .AND. (STAT.EQ.'CLWR')) IERR = 0
            IF ((STSTAT.GT.2) .AND. (IERR.NE.0)) THEN
               WRITE (MSGTXT,1030) CNO
               CALL MSGWRT (6)
C                                       return directory to disk
C                                       with latest time
            ELSE
               CALL CATIME (1, BUFF(NIND+NTIME), IT)
               CALL ZFIO ('WRIT', CLUN, CIND, NREC, BUFF, IER)
               END IF
            END IF
         END IF
      CALL ZCLOSE (CLUN, CIND, IER)
C                                       Open header file
      CALL ZPHFIL (CB, IVOL, CNO, 1, PHNAME, IER)
      CALL ZOPEN (CLUN, CIND, IVOL, PHNAME, F, T, T, IER)
      IF (IER.NE.0) THEN
         IERR = OPNER
         GO TO 999
         END IF
C                                       do operation
      NREC = 1
      IF (IOP.EQ.2) THEN
         CALL ZFIO ('READ', CLUN, CIND, NREC, CATBLK, IER)
      ELSE
         CALL ZFIO ('WRIT', CLUN, CIND, NREC, CATBLK, IER)
         END IF
      IF (IER.NE.0) IERR = RDERR
      GO TO 980
C                                       error message out
 970  CALL MSGWRT (6)
C                                       close catalog/header file
 980  CALL ZCLOSE (CLUN, CIND, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('CATIO: ILLEGAL OPCODE ',A4)
 1015 FORMAT ('CATIO: CATNO ',I6,' OUT OF RANGE')
 1020 FORMAT ('CATIO: CATBLK',I4,' IN USE, CAN''T WRITE')
 1030 FORMAT ('CATIO: CATBLK',I4,' IN USE, CAN''T CHANGE STATUS')
      END

      SUBROUTINE GTIC (ILABEL, BLC, TRC, NTRC, XTRC, PIXR, IBUFF, IERR)
C-----------------------------------------------------------------------
C! Puts tick marks on external step wedges for grey-scale plotting
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2002, 2014-2015, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   plots tick marks and labels on step wedges for GREYS
C   Inputs:
C      BLC     R(2)     Bottom left corner - image
C      TRC     R(2)     Top right corner - image
C      NTRC    R(2)     Top right corner - full field
C      XTRC    R(2)     Top right corner - ifield less wedge
C      PIXR    R(2)     Intensity range in wedge
C   In/out:
C      IBUFF   I(256)   Plot buffer
C   Output:
C      IERR    I        Error code: 2 => IO error in plotting
C-----------------------------------------------------------------------
      INTEGER   ILABEL, IBUFF(256), IERR
      REAL      BLC(2), TRC(2), NTRC(2), XTRC(2), PIXR(2)
C
      INTEGER   IAXIS, I, IX, IXL, ITRY, ILEN, ILMAX, FRMT, IFRMT,
     *   LLABEL
      DOUBLE PRECISION PMIN, PMAX, DEG, DEGC, XINTER(24), DEGU, DEGL
      LOGICAL   NONUM
      CHARACTER PREFIX*5, SPRTXT*20
      REAL      PR, DX, DY, X, Y
      INCLUDE 'INCS:DMSG.INC'
      DATA XINTER /0.001D0,0.002D0,0.005D0,0.01D0,0.02D0,0.05D0,0.1D0,
     *   0.2D0,0.5D0,1.D0,2.D0,5.D0,10.D0,20.D0,50.D0,100.D0,200.D0,
     *   500.D0,1000.D0,2000.D0,5000.D0,10000.D0,20000.D0,50000.D0/
C-----------------------------------------------------------------------
C                                       Corners give which axis has it
      IERR = 0
      LLABEL = MOD (ABS(ILABEL), 100)
      IF (LLABEL.LE.1) GO TO 999
      IAXIS = 0
      IF (XTRC(2).NE.NTRC(2)) IAXIS = 1
      IF (XTRC(1).NE.NTRC(1)) IAXIS = 2
      IF ((IAXIS.NE.1) .AND. (IAXIS.NE.2)) GO TO 999
C                                       get intensity range
      PMAX = PIXR(2)
      PMIN = PIXR(1)
      PR = PIXR(2) - PIXR(1)
      CALL METSCL (ILABEL, PR, PREFIX, NONUM)
      PR = PR / (PIXR(2) - PIXR(1))
C
      IF (.NOT.NONUM) THEN
         PMIN = PMIN * PR
         PMAX = PMAX * PR
         IX = 8
         IF (IAXIS.EQ.1) IX = 5
         IXL = 2
 10      DO 20 ITRY = 1,24
            DEG = XINTER(ITRY)
            DEGC = INT (PMAX / DEG) * DEG
            IF (DEGC.GT.PMAX) DEGC = DEGC - DEG
            DEGL = INT (PMIN / DEG) * DEG
            IF (DEGL.LT.PMIN) DEGL = DEGL + DEG
            I = (DEGC - DEGL) / DEG + 1.001
            IF ((I.GT.IXL) .AND. (I.LE.IX)) GO TO 30
 20         CONTINUE
         IF (IXL.EQ.0) THEN
            NONUM = .TRUE.
         ELSE
            IXL = 0
            IX = IX + 3
            GO TO 10
            END IF
         END IF
C                                       fails
 30   IF (NONUM) THEN
         PMIN = 0.0001D0
         PMAX = 0.9999D0
         DEG = 0.1D0
         WRITE (MSGTXT,1020)
         CALL MSGWRT (6)
         END IF
C                                       plot range
      DEGC = INT (PMAX / DEG) * DEG
      IF (DEGC.GT.PMAX) DEGC = DEGC - DEG
      DEGU = DEGC
      DEGC = INT (PMIN / DEG) * DEG
      IF (DEGC.LT.PMIN) DEGC = DEGC + DEG
      DEGL = DEGC
      IXL = (DEGU - DEGL) / DEG + 1.001
C                                       Horizontal
      DEGC = DEGL - DEG
      IF (IAXIS.EQ.1) THEN
         DO 50 I = 1,IXL
            DEGC = DEGC + DEG
            X = (DEGC - PMIN) / (PMAX - PMIN) * (TRC(1) - BLC(1)) +
     *         BLC(1)
            Y = (XTRC(2) + NTRC(2)) / 2.0
            CALL GPOS (X, Y, IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
            Y = NTRC(2)
            CALL GVEC (X, Y, IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
C                                       label
            IF ((.NOT.NONUM) .AND. (LLABEL.GE.3)) THEN
               PR = DEGC
               IF (ITRY.GT.9) IFRMT = FRMT (13, 3, PR, SPRTXT)
               IF (ITRY.LT.4) WRITE (SPRTXT,1030) DEGC
               IF ((ITRY.GE.4) .AND. (ITRY.LE.6)) WRITE (SPRTXT,1031)
     *            DEGC
               IF ((ITRY.GE.7) .AND. (ITRY.LE.9)) WRITE (SPRTXT,1032)
     *            DEGC
C                                       Trim blanks from RA/DEC
               CALL CHTRIM (SPRTXT, 13, SPRTXT, ILEN)
               DX = 0.5 - ILEN
               DY = 0.5
               CALL GCHAR (ILEN, 0, DX, DY, SPRTXT, IBUFF, IERR)
               IF (IERR.NE.0) GO TO 980
               END IF
 50         CONTINUE
C                                       Vertical
      ELSE
C                                       max length of label
         IF ((.NOT.NONUM) .AND. (LLABEL.GE.3)) THEN
            PR = DEGU
            IF (ITRY.GT.9) IFRMT = FRMT (13, 3, PR, SPRTXT)
            IF (ITRY.LT.4) WRITE (SPRTXT,1030) DEGU
            IF ((ITRY.GE.4) .AND. (ITRY.LE.6)) WRITE (SPRTXT,1031) DEGU
            IF ((ITRY.GE.7) .AND. (ITRY.LE.9)) WRITE (SPRTXT,1032) DEGU
            CALL CHTRIM (SPRTXT, 13, SPRTXT, ILEN)
            PR = DEGL
            IF (ITRY.GT.9) IFRMT = FRMT (13, 3, PR, SPRTXT)
            IF (ITRY.LT.4) WRITE (SPRTXT,1030) DEGL
            IF ((ITRY.GE.4) .AND. (ITRY.LE.6)) WRITE (SPRTXT,1031) DEGL
            IF ((ITRY.GE.7) .AND. (ITRY.LE.9)) WRITE (SPRTXT,1032) DEGL
            CALL CHTRIM (SPRTXT, 13, SPRTXT, ILMAX)
            ILMAX = MAX (ILMAX, ILEN)
            END IF
         DO 90 I = 1,IXL
            DEGC = DEGC + DEG
            Y = (DEGC - PMIN) / (PMAX - PMIN) * (TRC(2) - BLC(2)) +
     *         BLC(2)
            X = (XTRC(1) + NTRC(1)) / 2.0
            CALL GPOS (X, Y, IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
            X = NTRC(1)
            CALL GVEC (X, Y, IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
C                                       label
            IF ((.NOT.NONUM) .AND. (LLABEL.GE.3)) THEN
               PR = DEGC
               IF (ITRY.GT.9) IFRMT = FRMT (13, 3, PR, SPRTXT)
               IF (ITRY.LT.4) WRITE (SPRTXT,1030) DEGC
               IF ((ITRY.GE.4) .AND. (ITRY.LE.6)) WRITE (SPRTXT,1031)
     *            DEGC
               IF ((ITRY.GE.7) .AND. (ITRY.LE.9)) WRITE (SPRTXT,1032)
     *            DEGC
C                                       Trim blanks from RA/DEC
               CALL CHTRIM (SPRTXT, 13, SPRTXT, ILEN)
               DX = 0.5 + ILMAX - ILEN
               DY = -0.5
               CALL GCHAR (ILEN, 0, DX, DY, SPRTXT, IBUFF, IERR)
               IF (IERR.NE.0) GO TO 980
               END IF
 90         CONTINUE
         END IF
      GO TO 999
C                                       error
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (7)
      IERR = 2
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('TICK ALGORITHM FAILS ON STEP WEDGE - continuing')
 1030 FORMAT (F12.3)
 1031 FORMAT (F12.2)
 1032 FORMAT (F12.1)
 1980 FORMAT ('GTIC: STEP WEDGE LABEL/TICK WRITING ERROR =',I5)
      END

      SUBROUTINE YINIT (SCRTCH, IERR)
C-----------------------------------------------------------------------
C! initialize everything about the TV
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YINIT initializes the TV subunits: doing everything
C   Output:
C      SCRTCH  I(1024)    scratch buffer
C      IERR    I          error code of Z...XF - 0 => ok
C                                                2 => input error
C   IVAS version - with IVAS cursor shape, not our standard.
C-----------------------------------------------------------------------
      INTEGER   SCRTCH(*), IERR
C
      INTEGER   MODE, JERR, LX, LY, NX, MASK, CBUFF(2), I, J, IC,
     *   ICRED(4), LBLINK
      INTEGER   FIVASVPDEPTH, FIVASVPSETUP, FIVASCSSHAPE, FIVASFLUSH,
     *   FIVASGPHSET, FIVASGPHORIGIN, FIVASGMFREEZE, FIVASGPHWINDOW,
     *   FIVASMACURSOR
      LOGICAL   T, F, LON, LLINKX, LLINKY
      REAL      SLOPE, TDELAY, RBUF(256)
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA TDELAY /1.5/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Common assummed initialized
C                                       Hardware Master Clear assummed
C                                       Set channel depth in bits
      IF (NGRAY.GT.2) THEN
         MODE = 8
      ELSE
         MODE = 12
         END IF
      JERR = FIVASVPDEPTH (MODE)
      IF (JERR.NE.0) GO TO 900
C                                       Major init: LUTs, OFMs
C                                       channel 3
      MASK = 0
      IF (NGRAY.GT.2) THEN
         MODE = 2
         JERR = FIVASVPSETUP (MODE, MODE, MODE, MASK)
         IF (JERR.NE.0) GO TO 900
         END IF
C                                       channel 2
 10   MODE = 1
      JERR = FIVASVPSETUP (MODE, MODE, MODE, MASK)
      IF (JERR.NE.0) GO TO 900
C                                       channel 1, selected
      MODE = 0
      JERR = FIVASVPSETUP (MODE, MODE, MODE, MASK)
      IF (JERR.NE.0) GO TO 900
      JERR = FIVASFLUSH
      CALL ZDELAY (TDELAY, IERR)
C                                       Drop restrictions
      CALL FILL (8, 0, YBUFF(2))
      YBUFF(1) = 1
      CALL YVRTR (F, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Zero graphics memory
      LX = 0
      NX = 1024
      JERR = FIVASGPHSET (LX, LX, NX, NX, MASK)
      IF (JERR.NE.0) GO TO 900
C                                       Zero character memory
      LY = -1024
      JERR = FIVASGPHSET (LX, LY, NX, NX, MASK)
      IF (JERR.NE.0) GO TO 900
C                                       graphics origin
      JERR = FIVASGPHORIGIN (LX, LX)
      IF (JERR.NE.0) GO TO 900
C                                       set cursor pattern
      MASK = 0
      NX = 128
      LX = 1
      LY = 2
      JERR = FIVASCSSHAPE (1, NX, 2, 0)
      IF (JERR.NE.0) GO TO 900
      LY = 63
      LX = 15
      CBUFF(1) = 7
      CBUFF(2) = 14
      JERR = FIVASMACURSOR (CBUFF, 2, 1, LX, LY)
      IF (JERR.NE.0) GO TO 900
      LY = 64
      JERR = FIVASMACURSOR (CBUFF, 2, 1, LX, LY)
      IF (JERR.NE.0) GO TO 900
C                                       Graphics colors
      CALL FILL (4, 0, YBUFF(13))
      CALL YGRAPH ('INIT', 1, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      DO 20 I = 1,4
         CALL YGRAPH ('OFFF', I, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 999
 20      CONTINUE
      CALL YGRAPH ('ONNN', 8, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Set some common variables
      IC = -1
      CALL MOVIST ('OFFF', IC, 0, 0, 0, IERR)
      CALL FILL (16, 0, TVSCRX)
      CALL FILL (16, 0, TVSCRY)
      TVLIMG(1) = 1
      TVLIMG(2) = 1
      TVLIMG(3) = 1
      TVLIMG(4) = 1
      TVSPLM = 0
      TVSPLC = 0
      CALL FILL (4, 1, ICRED)
      TVSPLT(1) = MAXXTV(1)/2
      TVSPLT(2) = MAXXTV(2)/2
C                                       cursor off but linked
      LON = F
      LLINKX = T
      LLINKY = T
      LBLINK = 0
      CALL YCRCTL ('WRIT', LON, TVSPLT(1), TVSPLT(2), LLINKX, LLINKY,
     *   LBLINK, I, F, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        zoom/scroll to null
      CALL YZOOMC (0, TVSPLT(1), TVSPLT(2), F, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        split pts and chan 1 on
      CALL YSPLIT ('WRIT', TVSPLT(1), TVSPLT(2), ICRED, ICRED, ICRED, F,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Disable "window"
      LX = 0
      NX = 16
      MODE = 0
      JERR = FIVASGPHWINDOW (LX, LX, NX, NX, MODE)
      IF (JERR.NE.0) GO TO 900
C                                       Set LUTs for us
      J = MAXINT + 1
      SLOPE = (LUTOUT + 1.0) / (MAXINT + 1.0)
      DO 60 I = 1,J
         SCRTCH(I) = I * SLOPE - 0.5
 60      CONTINUE
      I = (2 ** NGRAY) - 1
      J = 7
      CALL YLUT ('WRIT', I, J, F, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Set OFM too to allow gamma
      DO 70 I = 1,256
         RBUF(I) = (I - 1) / 255.0
 70      CONTINUE
      CALL YOFM ('WRIT', 7, F, RBUF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Clear image catalog
      IC = NGRAY + NGRAPH
      DO 80 I = 1,IC
         CALL YCINIT (I, SCRTCH)
 80      CONTINUE
      GO TO 999
C                                       IVAS error
 800  CALL YDOERR ('YINIT', JERR, IERR)
      MASK = 0
      JERR = FIVASGMFREEZE (MASK)
      IF (JERR.EQ.0) GO TO 999
C
 900  CALL YDOERR ('YINIT', JERR, IERR)
C
 999  RETURN
      END

      SUBROUTINE ASOLVE (PRTLEV, CTYPE, BEGTIM, ENDTIM, NANT, FFLAST,
     *   SSQ, SASQ, FRACT)
C-----------------------------------------------------------------------
C! Finds antenna-based amp from baseline amp**2 data ROBUSTLY
C# Subroutine OOP calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2004-2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Converts array of baseline sigma**2 or amp**2 to antenna-based
C   sigma or amp
C   Inputs:
C      PRTLEV   I      Print answers errors
C      CTYPE    C*3    If 'rms', diagonal elements averaged
C      BEGTIM   R      Begin time
C      ENDTIM   R      End time
C      NANT     I      Number antennas
C      FFLAST   R      Mark bad those data with closure error >
C                      FFLAST * rms closure error on last iteration
C   In/Out
C      SSQ      R(*)   Sigma**2 by baseline
C   Outputs
C      SASQ     R(*)   Antenna sigma, amp
C                         FBLANK => no data, <= 0 => failed
C      FRACT    R(*)   Fraction of this antenna > 3. sigma from closure
C-----------------------------------------------------------------------
      INTEGER   PRTLEV, NANT
      CHARACTER CTYPE*(*)
      REAL      BEGTIM, ENDTIM, FFLAST, SSQ(NANT,NANT), SASQ(NANT),
     *   FRACT(NANT)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   I, J, NRMS, IT, NODATA(MAXANT), BEGT(4),  ENDT(4), ITER
      REAL      ARMS, FACT, SUM, SUMS, RMS, FF(10), LSQ(MAXANT), FB(10),
     *   RMSMIN
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA FB /15.0, 8.0, 6.0, 4.5, 3.5, 3.0, 2.8, 2.6, 2.4, 3.0/
C-----------------------------------------------------------------------
      CALL RFILL (NANT, FBLANK, SASQ)
      FACT = 1.0
      IF (CTYPE.EQ.'rms') FACT = 0.5
      CALL RCOPY (10, FB, FF)
      IF (FFLAST.GT.1.0) FF(10) = FFLAST
C                                       sum in Re and Im
C                                       or take one if other blanked
C                                       (usually scalar amp...)
      NRMS = 0
      ARMS = 0.0
      DO 20 I = 1,NANT
         NODATA(I) = 0
         DO 10 J = I+1,NANT
            IF (SSQ(I,J).NE.FBLANK) THEN
               IF (SSQ(J,I).NE.FBLANK) SSQ(I,J) = (SSQ(I,J) + SSQ(J,I))
     *            * FACT
            ELSE
               IF (SSQ(J,I).NE.FBLANK) SSQ(I,J) = SSQ(J,I)
               END IF
            IF (SSQ(I,J).LE.0.0) SSQ(I,J) = FBLANK
            IF (SSQ(I,J).NE.FBLANK) THEN
               NRMS = NRMS + 1
               ARMS = ARMS + SSQ(I,J)
               END IF
 10         CONTINUE
 20      CONTINUE
      IF (ARMS.LE.0.0) THEN
         IF (PRTLEV.GE.3) THEN
            CALL TODHMS (BEGTIM, BEGT)
            CALL TODHMS (ENDTIM, ENDT)
            WRITE (MSGTXT,1010) CTYPE, BEGT, ENDT
            CALL MSGWRT (6)
            END IF
C                                       iteration 0
      ELSE
         ARMS = ARMS / NRMS
         ARMS = SQRT (ARMS)
         RMSMIN = ARMS / 1000.0
         IF (PRTLEV.GE.4) THEN
            CALL TODHMS (BEGTIM, BEGT)
            CALL TODHMS (ENDTIM, ENDT)
            WRITE (MSGTXT,1020) CTYPE, BEGT, ENDT, ARMS
            CALL MSGWRT (2)
            END IF
         DO 40 I = 1,NANT
            ARMS = 0.0
            NRMS = 0
            DO 25 J = I+1,NANT
               IF (SSQ(I,J).NE.FBLANK) THEN
                  NRMS = NRMS + 1
                  ARMS = ARMS + SSQ(I,J)
                  END IF
 25            CONTINUE
            DO 30 J = 1,I
               IF (SSQ(J,I).NE.FBLANK) THEN
                  NRMS = NRMS + 1
                  ARMS = ARMS + SSQ(J,I)
                  END IF
 30            CONTINUE
            IF (ARMS.GT.0.0) THEN
               SASQ(I) = SQRT (ARMS / NRMS)
            ELSE
               NODATA(I) = 1000000
               END IF
            LSQ(I) = SASQ(I)
 40         CONTINUE
         RMS = 1.E14
C                                       robust iterations
         DO 90 ITER = 1,10
C                                       iterate new solution
            DO 60 IT = 1,5
               DO 55 I = 1,NANT
                  ARMS = 0.0
                  NRMS = 0
                  DO 45 J = I+1,NANT
                     IF (SSQ(I,J).NE.FBLANK) THEN
                        IF (ABS(SSQ(I,J)-SASQ(I)*SASQ(J))/RMS
     *                     .LT.FF(ITER)) THEN
                           NRMS = NRMS + 1
                           ARMS = ARMS + SSQ(I,J) / LSQ(J)
                           END IF
                        END IF
 45                  CONTINUE
                  DO 50 J = 1,I
                     IF (SSQ(J,I).NE.FBLANK) THEN
                        IF (ABS(SSQ(J,I)-SASQ(I)*SASQ(J))/RMS
     *                     .LT.FF(ITER)) THEN
                           NRMS = NRMS + 1
                           ARMS = ARMS + SSQ(J,I) / LSQ(J)
                           END IF
                        END IF
 50                  CONTINUE
                  IF (ARMS.GT.0.0) THEN
                     LSQ(I) = ARMS / NRMS
                     NODATA(I) = 0
                  ELSE
                     IF (NODATA(I).LE.0) NODATA(I) = 1
                     END IF
 55               CONTINUE
 60            CONTINUE
            DO 70 I = 1,NANT
               SASQ(I) = LSQ(I)
 70            CONTINUE
C                                       find rms of soln
            SUM = 0
            SUMS = 0
            NRMS = 0
            DO 85 I = 1,NANT
               IF (SASQ(I).NE.FBLANK) THEN
                  DO 75 J = I+1,NANT
                     IF ((SSQ(I,J).NE.FBLANK) .AND. (SASQ(J).NE.FBLANK))
     *                  THEN
                        IF (ABS(SSQ(I,J)-SASQ(I)*SASQ(J))/RMS
     *                     .LT.FF(ITER)) THEN
                           ARMS = SSQ(I,J) - SASQ(I)*SASQ(J)
                           NRMS = NRMS + 1
                           SUM = SUM + ARMS
                           SUMS = SUMS + ARMS * ARMS
                           END IF
                        END IF
 75                  CONTINUE
                  DO 80 J = 1,I
                     IF ((SSQ(J,I).NE.FBLANK) .AND. (SASQ(J).NE.FBLANK))
     *                  THEN
                        IF (ABS(SSQ(J,I)-SASQ(I)*SASQ(J))/RMS
     *                     .LT.FF(ITER)) THEN
                           ARMS = SSQ(J,I) - SASQ(I)*SASQ(J)
                           NRMS = NRMS + 1
                           SUM = SUM + ARMS
                           SUMS = SUMS + ARMS * ARMS
                           END IF
                        END IF
 80                  CONTINUE
                  END IF
 85            CONTINUE
            SUM = SUM / NRMS
            SUMS = SUMS / NRMS - SUM * SUM
            RMS = SQRT (MAX (0.0, SUMS))
            RMS = MAX (RMS, RMSMIN)
            IF (RMS.LE.0.0) RMS = 1.0
 90         CONTINUE
C                                       DONE!  Get stat re error
         DO 120 I = 1,NANT
            NRMS = 0
            SUM = 0.
            IF (SASQ(I).NE.FBLANK) THEN
               DO 105 J = I+1,NANT
                  IF ((SSQ(I,J).NE.FBLANK) .AND. (SASQ(J).NE.FBLANK))
     *               THEN
                     ARMS = ABS (SSQ(I,J) - SASQ(I)*SASQ(J))
                     IF (ARMS/RMS.GT.5.0) SUM = SUM + 1.0
                     NRMS = NRMS + 1
                     END IF
 105              CONTINUE
               DO 110 J = 1,I
                  IF ((SSQ(J,I).NE.FBLANK) .AND. (SASQ(J).NE.FBLANK))
     *               THEN
                     ARMS = ABS (SSQ(J,I) - SASQ(I)*SASQ(J))
                     IF (ARMS/RMS.GT.3.0) SUM = SUM + 1.0
                     NRMS = NRMS + 1
                     END IF
 110              CONTINUE
               END IF
            IF (NRMS.GT.0) THEN
               FRACT(I) = SUM / NRMS
            ELSE
               FRACT(I) = 1.0
               END IF
 120        CONTINUE
C                                       now flag if needed
         DO 130 I = 1,NANT
            IF (NODATA(I).GE.1000000) THEN
               SASQ(I) = FBLANK
            ELSE IF (NODATA(I).GT.0) THEN
               SASQ(I) = - ABS (SASQ(I))
               END IF
 130        CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ASOLV: FAILS ',A,' AT',I3,'/',2(I2.2,':'),I2.2,' -',
     *   I3,'/',2(I2.2,':'),I2.2)
 1020 FORMAT ('ASOLV: average ',A,' at',I3,'/',2(I2.2,':'),I2.2,' -',
     *   I3,'/',2(I2.2,':'),I2.2,' =',F9.5)
      END

      SUBROUTINE TABGC (OPCODE, BUFFER, IGCRNO, GCKOLS, GCNUMV,
     *   NPOLGC, NTABGC, IANTGC, ISUBGC, IFQDGC, ITPGC, NTGC,
     *   IXTGC, IYTGC, XVALGC, YVALGC, GAINGC, SENSGC, IERR)
C-----------------------------------------------------------------------
C! I/O to Gain curve tables (following init. by GCINI)
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2007, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to gain curve tables. Usually used after setup by
C   GCINI.
C   Inputs:
C      OPCODE   C*4        Operation code:
C                          'READ' = read entry from table.
C                          'WRIT' = write entry in table.
C                          'CLOS' = close file, flush on write
C      BUFFER   I(*)       I/O buffer and related storage, also defines
C                          file if open. Should have been returned by
C                          GCINI.
C      IGCRNO   I          Next scan number to read or write.
C      GCKOLS(MAXGCC) I    The column pointer array in order:
C                             ANTENNA NO, SUBARRAY, FREQ ID,
C                             CURVE TYPE 1, NO ENTRIES 1, X TYPE 1,
C                             Y TYPE 1, X VALUE 1, Y VALUES 1,
C                             GAIN VALUES 1, SENSITIVITY 1
C                          the following are only present if NPOLGC = 2
C                             CURVE TYPE 2, NO ENTRIES 2, X TYPE 2,
C                             Y TYPE 2, X VALUE 2, Y VALUES 2,
C                             GAIN VALUES 2, SENSITIVITY 2,
C      GCNUMV   I(MAXGCC)  Element count in each column.
C      NPOLGC   I          # polzns in table
C      NTABGC   I          # tabulated values per row
C   Input/output: (written to or read from gain curve file)
C      IANTGC   I          Antenna number
C      ISUBGC   I          Subarray number
C      IFQDGC   I          Freq. ID
C      ITPGC    I(2,*)     Gain curve type: (1 /Polzn/IF)
C                            1 => tabulated values
C                            2 => polynomial
C                            3 => spherical harmonic
C      NTGC     I(2,*)     No. of terms or entries (1 /Polzn/IF)
C      IXTGC    I(2,*)     Gain curve X-absicssa code type: (1/Polzn/IF)
C                            0 => none
C                            1 => elevation (degrees)
C                            2 => zenith angle (degrees)
C                            3 => hour angle (degrees)
C                            4 => declination (degrees)
C                            5 => 90-declination (degrees)
C      IYTGC    I(2,*)     Gain curve Y-absicssa code type: (1/Polzn/IF)
C                            1 => elevation (degrees)
C                            2 => zenith angle (degrees)
C                            3 => hour angle (degrees)
C                            4 => declination (degrees)
C                            5 => 90-declination (degrees)
C      XVALGC   R(2,*)     Value of X abscissa (1/Polzn/IF)
C      YVALGC   R(2,*,*)   Values of Y abscissa (1/Polzn/IF/sample)
C      GAINGC   R(2,*,*)   Corresponding values of relative
C                          gain (if tabulated); or coefficients
C                          of approximating function. (1/Polzn/IF/sample)
C      SENSGC   R(2,*)     Point source sensitivity (K/Jy) (1/Polzn/IF)
C   Output:
C      IGCRNO   I          Next row number.
C      IERR     I          Error code, 0=>OK else TABIO error.
C                          Note: -1=> read but record deselected.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PGCV.INC'
      CHARACTER OPCODE*4
      INTEGER NTABGC
      REAL XVALGC(2,MAXIF), YVALGC(2,MAXIF,NTABGC),
     *   GAINGC(2,MAXIF,NTABGC), SENSGC(2,MAXIF)
      INTEGER BUFFER(*), IGCRNO, GCKOLS(MAXGCC), GCNUMV(MAXGCC),
     *   NPOLGC, IANTGC, ISUBGC, IFQDGC, ITPGC(2,MAXIF),
     *   NTGC(2,MAXIF), IXTGC(2,MAXIF), IYTGC(2,MAXIF), IERR
C
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      LOGICAL   DOREAD, DOCLOS
      REAL RECORD(MXSPGC)
      INTEGER RECI(MXSPGC), I, NUMIF, JIF, K
      EQUIVALENCE (RECORD, RECI)
C-----------------------------------------------------------------------
      NUMIF = GCNUMV(GCITP1)
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
      DOCLOS = OPCODE.EQ.'CLOS'
C                                       Branch for CLOS
      IF (DOCLOS) GO TO 800
C                                       If write fill RECORD
      IF (.NOT.DOREAD) THEN
C                                       Antenna number
         RECI(GCKOLS(GCIANT)) = IANTGC
C                                       Subarray
         RECI(GCKOLS(GCISUB)) = ISUBGC
C                                       Frequency ID.
         RECI(GCKOLS(GCIFQD)) = IFQDGC
C                                       Loop over IF
         DO 100 JIF = 1, NUMIF
C                                       Gain curve type.
            RECI(GCKOLS(GCITP1)+JIF-1) = ITPGC(1,JIF)
C                                       No. of terms or entries
            RECI(GCKOLS(GCINT1)+JIF-1) = NTGC(1,JIF)
C                                       X-abscissa type
            RECI(GCKOLS(GCIXT1)+JIF-1) = IXTGC(1,JIF)
C                                       Y-abscissa type
            RECI(GCKOLS(GCIYT1)+JIF-1) = IYTGC(1,JIF)
C                                       X-abscissa value.
            RECORD(GCKOLS(GCRXV1)+JIF-1) = XVALGC(1,JIF)
            DO 80 I = 1, NTABGC
               K = (JIF - 1) * NTABGC + (I - 1)
               IF (I.LE.NTGC(1,JIF)) THEN
C                                       Y-abscissa values
                  RECORD(GCKOLS(GCRYV1)+K) = YVALGC(1,JIF,I)
C                                       Gain values or gain coefficients
                  RECORD(GCKOLS(GCRGA1)+K) = GAINGC(1,JIF,I)
               ELSE
                  RECORD(GCKOLS(GCRYV1)+K) = FBLANK
                  RECORD(GCKOLS(GCRGA1)+K) = FBLANK
                  END IF
 80            CONTINUE
C                                       Point source sensitivity
            RECORD(GCKOLS(GCRSE1)+JIF-1) = SENSGC(1,JIF)
100         CONTINUE
C
C                                       Dual polzn?
         IF (NPOLGC.EQ.2) THEN
C                                       Loop over IF
            DO 200 JIF = 1, NUMIF
C                                       Gain curve type.
               RECI(GCKOLS(GCITP2)+JIF-1) = ITPGC(2,JIF)
C                                       No. of terms or entries
               RECI(GCKOLS(GCINT2)+JIF-1) = NTGC(2,JIF)
C                                       X-abscissa type
               RECI(GCKOLS(GCIXT2)+JIF-1) = IXTGC(2,JIF)
C                                       Y-abscissa type
               RECI(GCKOLS(GCIYT2)+JIF-1) = IYTGC(2,JIF)
C                                       X-abscissa value.
               RECORD(GCKOLS(GCRXV2)+JIF-1) = XVALGC(2,JIF)
               DO 180 I = 1, NTABGC
                  K = (JIF - 1) * NTABGC + (I - 1)
                  IF (I.LE.NTGC(2,JIF)) THEN
C                                       Y-abscissa values
                     RECORD(GCKOLS(GCRYV2)+K) = YVALGC(2,JIF,I)
C                                       Gain values or gain coefficients
                     RECORD(GCKOLS(GCRGA2)+K) = GAINGC(2,JIF,I)
                  ELSE
                     RECORD(GCKOLS(GCRYV2)+K) = FBLANK
                     RECORD(GCKOLS(GCRGA2)+K) = FBLANK
                     END IF
 180              CONTINUE
C                                       Point source sensitivity
               RECORD(GCKOLS(GCRSE2)+JIF-1) = SENSGC(2,JIF)
200            CONTINUE
            END IF
C
         END IF
C                                       Process record.
220   CALL TABIO (OPCODE, 0, IGCRNO, RECORD, BUFFER, IERR)
      IGCRNO = IGCRNO + 1
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABIO', 'TABGC', IERR)
         GO TO 999
         END IF
C                                       If READ pick data from RECORD.
      IF (DOREAD) THEN
C                                       Antenna number
         IANTGC = RECI(GCKOLS(GCIANT))
C                                       Subarray
         ISUBGC = RECI(GCKOLS(GCISUB))
C                                       Freq. ID
         IFQDGC = RECI(GCKOLS(GCIFQD))
C                                       Loop over IF
         DO 300 JIF = 1, NUMIF
C                                       Gain curve type
            ITPGC(1,JIF) = RECI(GCKOLS(GCITP1)+JIF-1)
C                                       No. of terms or entries
            NTGC(1,JIF) = RECI(GCKOLS(GCINT1)+JIF-1)
C                                       X-abscissa type
            IXTGC(1,JIF) = RECI(GCKOLS(GCIXT1)+JIF-1)
C                                       Y-abscissa type
            IYTGC(1,JIF) = RECI(GCKOLS(GCIYT1)+JIF-1)
C                                       X-abscissa value
            XVALGC(1,JIF) = RECORD(GCKOLS(GCRXV1)+JIF-1)
            DO 280 I = 1, NTGC(1,JIF)
               K = (JIF - 1) * NTABGC + (I - 1)
C                                       Y-abscissa values
               YVALGC(1,JIF,I) = RECORD(GCKOLS(GCRYV1)+K)
C                                       Gain values
               GAINGC(1,JIF,I) = RECORD(GCKOLS(GCRGA1)+K)
280            CONTINUE
C                                       Point source sensitivity
            SENSGC(1,JIF) = RECORD(GCKOLS(GCRSE1)+JIF-1)
300         CONTINUE
C                                       Dual polarization ?
         IF (NPOLGC.EQ.2) THEN
C                                       Loop over IF
            DO 400 JIF = 1, NUMIF
C                                       Gain curve type
               ITPGC(2,JIF) = RECI(GCKOLS(GCITP2)+JIF-1)
C                                       No. of terms or entries
               NTGC(2,JIF) = RECI(GCKOLS(GCINT2)+JIF-1)
C                                       X-abscissa type
               IXTGC(2,JIF) = RECI(GCKOLS(GCIXT2)+JIF-1)
C                                       Y-abscissa type
               IYTGC(2,JIF) = RECI(GCKOLS(GCIYT2)+JIF-1)
C                                       X-abscissa value
               XVALGC(2,JIF) = RECORD(GCKOLS(GCRXV2)+JIF-1)
               DO 380 I = 1, NTGC(2,JIF)
                  K = (JIF - 1) * NTABGC + (I - 1)
C                                       Y-abscissa values
                  YVALGC(2,JIF,I) = RECORD(GCKOLS(GCRYV2)+K)
C                                       Gain values or coefficients.
                  GAINGC(2,JIF,I) = RECORD(GCKOLS(GCRGA2)+K)
380               CONTINUE
C                                       Point source sensititivity
               SENSGC(2,JIF) = RECORD(GCKOLS(GCRSE2)+JIF-1)
400            CONTINUE
            END IF
         END IF
      GO TO 999
C                                       Close
 800  CALL TABIO ('CLOS', 0, IGCRNO, RECORD, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'TABGC', IERR)
         GO TO 999
         END IF
      GO TO 999
C
 999  RETURN
      END

      SUBROUTINE PRECES (JD, EQUIN, DELDAT, RAMEAN, DECMEA, RAAPP,
     *   DECAPP, DIR, GR, DA, RHOGEO, PHIGEO, RLST, NR)
C-----------------------------------------------------------------------
C! Convert between mean and apparent positions (B1950 only)
C# Math Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Conversion between mean and apparent coordinates.
C    Inputs:
C      JD      Julian date corresponding to instant of observation
C              (e.g., 2443468.13472)
C      EQUIN   mean equinox (e.g., 1950.0)
C      DELDAT  interpolation interval in days.  (e.g., .1)
C      RAMEAN  mean RA in radians.
C      DECMEA  mean DEC in radians.
C      RAAPP   apparent RA in radians.
C      DECAPP  apparent DEC in radians.
C      DIR     .T. for conversion from mean to apparent
C              .F. for conversion from apparent to mean
C      GR      .T. to include (solar) general relativistic deflection
C                  in apparent position
C              .F. to not do so
C      DA      .T. to include diurnal aberration in apparent position
C              .F. to not do so
C      RHOGEO  geocentric radius to the point of observation, expressed
C              in units of Earth's equatorial radius.  This is used only
C              when diurnal aberration is applied.
C      PHIGEO  geocentric latitude of the observatory.  This is used
C              only when diurnal aberration is applied.
C      RLST    local sidereal time.  This is used only when diurnal
C              aberration is applied.
C      NR      .T. to use non-rigid Earth model in calculation of
C                 nutation
C              .F. to not do so.  i.e., to use standard rigid Earth.
C-----------------------------------------------------------------------
      LOGICAL   DIR, GR, DA, NR
      DOUBLE PRECISION JD, EQUIN, DELDAT, RAMEAN, DECMEA, RAAPP,
     *   DECAPP, RHOGEO, PHIGEO, RLST
      DOUBLE PRECISION CC, KON, HA, DRA, DDEC, RAP, DAP, SD, CD
C-----------------------------------------------------------------------
      CC = ATAN (1.D0) / 162000.D0
C                                       Conversion from mean to apparent
      IF (.NOT.DIR) GO TO 30
         CALL DMAP (JD, EQUIN, DELDAT, RAMEAN, DECMEA, RAAPP, DECAPP,
     *      NR)
         IF (.NOT.DA) GO TO 10
            KON = .3198D0 * RHOGEO * COS(PHIGEO) * CC
            HA = RLST - RAAPP
            DRA = KON * COS(HA) / COS(DECAPP)
            DDEC = KON * SIN(HA) * SIN(DECAPP)
            RAAPP = RAAPP + DRA
            DECAPP = DECAPP + DDEC
 10      IF (.NOT.GR) GO TO 20
            SD = SIN(DECAPP)
            CD = COS(DECAPP)
            CALL GRD (JD, RAAPP, DECAPP, SD, CD, DRA, DDEC)
            RAAPP = RAAPP + DRA
            DECAPP = DECAPP + DDEC
 20      GO TO 999
C                                       Conversion from apparent to mean
 30   CONTINUE
         RAP = RAAPP
         DAP = DECAPP
         IF (.NOT.DA) GO TO 40
            KON = .3198D0 * RHOGEO * COS(PHIGEO) * CC
            HA = RLST - RAP
            DRA = KON * COS(HA) / COS(DAP)
            DDEC = KON * SIN(HA) * SIN(DAP)
            RAP = RAP - DRA
            DAP = DAP - DDEC
 40      IF (.NOT.GR) GO TO 50
            SD = SIN(DAP)
            CD = COS(DAP)
            CALL GRD (JD, RAP, DAP, SD, CD, DRA, DDEC)
            RAP = RAP - DRA
            DAP = DAP - DDEC
 50      CALL DAPM (JD, EQUIN, DELDAT, RAP, DAP, RAMEAN, DECMEA, NR)
C
 999  RETURN
      END

      SUBROUTINE FXSHFT (INCATR, IERR)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This routine works for -SIN projection without 3D only.  It should
C   be obsolete and is not currently called.
C
C   FXSHFT compares the image reference pixel and the shift and rotate
C   parameters in the supplied image header.  If they disagree, FXSHFT
C   assumes that the error is due to the old error in MX and UVMAP in
C   which the rotation was used in degrees where radians was required.
C   It changes the header for this, if that assumption produces
C   agreement.  The bug was in images produced by UVMAP and MX prior to
C   19-JUL-93 in release 15JUL93 and all earlier releases.
C   In/out:
C      INCATR   R(256)   Image header
C   Output:
C      IERR     I        Condition code: 0 nothing done, all okay
C                           -1 => header fixed
C                           +1 => shift and reference pixel inconsistent
C                                 even with fix.
C-----------------------------------------------------------------------
      REAL      INCATR(256)
      INTEGER   IERR
C
      INTEGER   CATBLK(256), I, IR, ID, N, J
      REAL      CATR(256), ROT, XP, YP
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128), XSHIFT, YSHIFT, YSHRFT, XSHRFT, DEC,
     *   XS, YS, SS, RA, XDEC, XRA
      CHARACTER CHTEMP*8
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
C-----------------------------------------------------------------------
      CALL RCOPY (256, INCATR, CATR)
C                                       find RA/Dec axes
      N = CATBLK(KIDIM)
      IR = -1
      ID = -1
      DO 10 I = 1,N
         J = KHCTP + 2 * (I - 1)
         CALL H2CHR (8, 1, CATR(J), CHTEMP)
         IF ((CHTEMP(:4).EQ.'RA  ') .OR. (CHTEMP(:4).EQ.'RA--'))
     *      IR = I - 1
         IF ((CHTEMP(:4).EQ.'DEC ') .OR. (CHTEMP(:4).EQ.'DEC-'))
     *      ID = I - 1
 10      CONTINUE
      IF ((IR.LT.0) .OR. (ID.LT.0)) THEN
         IERR =  0
         MSGTXT = 'FXSHFT: COORDINATE AXIS MISSING'
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       no shift: check reference
      XP = CATBLK(KINAX+IR) / 2
      YP = CATBLK(KINAX+ID) / 2 + 1
      IF ((CATR(KRXSH).EQ.0.0) .AND. (CATR(KRYSH).EQ.0.0)) THEN
         IERR = 0
         IF ((ABS(XP-CATR(KRCRP+IR)).GT.0.03) .OR.
     *      (ABS(YP-CATR(KRCRP+ID)).GT.0.03)) THEN
            IERR =  1
            MSGTXT = 'FXSHFT: REFERENCE PIXELS OFF WITH NO SHIFTS'
            CALL MSGWRT (7)
            END IF
         GO TO 999
C                                       shift
      ELSE
C                                       do we have a problem?
C                                       find XSH, YSH from RP
         DEC = CATD(KDCRV+ID) * DG2RAD
         RA = CATD(KDCRV+IR) * DG2RAD
         ROT = CATR(KRCRT+ID) * DG2RAD
         XS = ABS (CATR(KRCIC+IR)) * (CATR(KRCRP+IR) - XP)
         YS = ABS (CATR(KRCIC+ID)) * (CATBLK(KINAX+ID) - YP + 2 -
     *      CATR(KRCRP+ID))
         XSHRFT = (XS * COS (ROT) - YS * SIN (ROT)) * DG2RAD
         YSHRFT = (XS * SIN (ROT) + YS * COS (ROT)) * DG2RAD
         XS = ATAN (XSHRFT / (YSHRFT * SIN (DEC) - COS (DEC) *
     *      SQRT (1.0D0 - XSHRFT * XSHRFT - YSHRFT * YSHRFT)))
         XRA = RA - XS
         XDEC = ASIN (YSHRFT * COS (DEC) + SIN (DEC) *
     *      SQRT (1.0D0 - XSHRFT * XSHRFT - YSHRFT * YSHRFT))
         XSHIFT = (XRA - RA) / DG2RAD
         YSHIFT = (XDEC - DEC) / DG2RAD
         XS = MAX (ABS(CATR(KRCIC+IR)), ABS(CATR(KRCIC+ID))) * 0.05
         IERR = 0
         IF ((ABS(XSHIFT-CATR(KRXSH)).GT.XS) .OR.
     *      (ABS(YSHIFT-CATR(KRYSH)).GT.XS)) THEN
C                                       find RP from XSH, YSH
C                                       transcendental problem
            SS = 1.0D0
            DO 50 I = 1,40
               YS = (SIN (DEC + CATR(KRYSH)*DG2RAD) - SIN (DEC) * SS) /
     *            COS (DEC)
               XS = TAN(DG2RAD * CATR(KRXSH)) * (COS(DEC) * SS - YS *
     *            SIN(DEC))
               SS = SQRT ( 1.0D0 - XS * XS - YS * YS)
 50            CONTINUE
            YSHRFT = (SIN (DEC + CATR(KRYSH)*DG2RAD) - SIN (DEC) * SS) /
     *         COS (DEC)
            XSHRFT = TAN(DG2RAD * CATR(KRXSH)) * (COS(DEC) * SS -
     *         YSHRFT * SIN(DEC))
            XSHIFT = XSHRFT * COS (ROT) + YSHRFT * SIN (ROT)
            YSHIFT = YSHRFT * COS (ROT) - XSHRFT * SIN (ROT)
            XSHIFT = XSHIFT * RAD2DG / ABS (CATR(KRCIC+IR))
            YSHIFT = YSHIFT * RAD2DG / ABS (CATR(KRCIC+ID))
            XP = XP + XSHIFT
            YP = YP - YSHIFT
C                                       disagree
            IF ((ABS(XP-CATR(KRCRP+IR)).GT.0.04) .OR.
     *         (ABS(YP-CATR(KRCRP+ID)).GT.0.04)) THEN
C                                       try fix
               IF (ROT.NE.0.0) THEN
                  ROT = CATR(KRCRT+ID)
                  XSHIFT = XSHRFT * COS (ROT) + YSHRFT * SIN (ROT)
                  YSHIFT = YSHRFT * COS (ROT) - XSHRFT * SIN (ROT)
                  XSHIFT = XSHIFT * RAD2DG / ABS (CATR(KRCIC+IR))
                  YSHIFT = YSHIFT * RAD2DG / ABS (CATR(KRCIC+ID))
                  XP = CATBLK(KINAX+IR) / 2 + XSHIFT
                  YP = CATBLK(KINAX+ID) / 2 + 1 - YSHIFT
C                                       fix it
                  IF ((ABS(XP-CATR(KRCRP+IR)).LE.0.003) .AND.
     *               (ABS(YP-CATR(KRCRP+ID)).LE.0.003)) THEN
                     XSHIFT = XSHIFT / RAD2DG * ABS (CATR(KRCIC+IR))
                     YSHIFT = YSHIFT / RAD2DG * ABS (CATR(KRCIC+ID))
                     ROT = CATR(KRCRT+ID) * DG2RAD
                     XSHRFT = XSHIFT * COS (ROT) - YSHIFT * SIN (ROT)
                     YSHRFT = YSHIFT * COS (ROT) + XSHIFT * SIN (ROT)
                     SS = SQRT (1.0D0 - XSHRFT * XSHRFT - YSHRFT
     *                  * YSHRFT)
                     INCATR(KRXSH) = ATAN (XSHRFT / (COS(DEC) * SS -
     *                  YSHRFT * SIN(DEC))) * RAD2DG
                     INCATR(KRYSH) = (ASIN (YSHRFT * COS(DEC) + SIN(DEC)
     *                  * SS) - DEC) * RAD2DG
                     MSGTXT = 'FXSHFT: fixed pre-19-July-1993 header' //
     *                  ' shift bug'
                     CALL MSGWRT (2)
                     IERR = -1
                     GO TO 999
                     END IF
                  END IF
               MSGTXT = 'FXSHFT: SHIFTS AND REFERENCE PIXELS DISAGREE'
               IERR = 1
               CALL MSGWRT (7)
               END IF
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE WINDF (WIN, NBOXES, NFIELD, IMSIZE, BOXFIL, IERR)
C-----------------------------------------------------------------------
C! read clean boxes from text file
C# AP Imaging
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2001, 2005, 2007-2008
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Fills the WIN array with clean box definitions taken from BOXFIL
C   Inputs:
C      BOXFIL   C*48        User provided file name containing box defs
C      NFIELD   I           Number of fields defined
C   In/Out:
C      WIN      I(4,*,*)    clean boxes - defaulted on in (4,FIELD,BOX)
C      NBOXES   I*(*)       Array containing number of boxes/field
C   Outputs:
C      IERR     I           Error return code:
C                              0 => no error
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCLN.INC'
      CHARACTER BOXFIL*48
      INTEGER   NFIELD, WIN(4,NFIELD,*), NBOXES(*)
      INTEGER   IMSIZE(2,*), IERR
C
      INTEGER   LUN, I, J, ISUBF(MXNBOX), IFIELD, FIND, IPARM(5), KBP,
     *   I1, I2, IDD, LIMIT
      CHARACTER LINE*132
      DOUBLE PRECISION X
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      LIMIT = MIN (MXNBOX, MXNBFL / MAX(1,NFIELD))
C                                        Open clean box file
      LUN = 11
      CALL ZTXOPN ('READ', LUN, FIND, BOXFIL, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN'
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                        Enter box parameters from file
      CALL FILL (MXNBOX, 0, ISUBF)
      IDD = 0
      DO 50 I = 1,100000
         CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
         IF (IERR.EQ.2) GO TO 60
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPEN'
            CALL MSGWRT (6)
            GO TO 999
            END IF
C                                       check for comments
         CALL CHTRIM (LINE, 132, LINE, J)
         IF (LINE(:1).LT.'0') GO TO 50
         IF (LINE(:1).GT.'9') GO TO 50
C                                       parse for 5 integers
C                                       field, blc, trc
         KBP = 1
         CALL FILL (5, 0, IPARM)
         DO 30 J = 1,5
            CALL GETNUM (LINE, 132, KBP, X)
            IF (X.EQ.DBLANK) THEN
               IF (J.EQ.1) GO TO 50
               WRITE (MSGTXT,1020) I, J
               CALL MSGWRT (6)
               IERR = 1
               GO TO 999
            ELSE
               IF (X.GE.0.0D0) THEN
                  IPARM(J) = X + 0.50D0
               ELSE
                  IPARM(J) = X - 0.50D0
                  END IF
               END IF
 30         CONTINUE
         IFIELD = IPARM(1)
         IF ((IFIELD.GE.1) .AND. (IFIELD.LE.NFIELD)) THEN
            IDD = IDD + 1
            ISUBF(IFIELD) = MAX (ISUBF(IFIELD),0) + 1
            IF (ISUBF(IFIELD).LE.LIMIT) THEN
               J = ISUBF(IFIELD)
C                                       circular
               IF (IPARM(2).LT.0) THEN
                  WIN(1,IFIELD,J) = -1
                  WIN(3,IFIELD,J) = MAX (1+IPARM(3), MIN (IPARM(4),
     *               IMSIZE(1,IFIELD)-IPARM(3)))
                  WIN(4,IFIELD,J) = MAX (1+IPARM(3), MIN (IPARM(5),
     *               IMSIZE(2,IFIELD)-IPARM(3)))
                  WIN(2,IFIELD,J) = IPARM(3)
C                                       rectangular
               ELSE IF (IPARM(2).GT.0) THEN
                  WIN(1,IFIELD,J) = MAX (1, MIN (IPARM(2),
     *               IMSIZE(1,IFIELD)))
                  WIN(3,IFIELD,J) = MAX (1, MIN (IPARM(4),
     *               IMSIZE(1,IFIELD)))
                  IF (WIN(3,IFIELD,J).LT.WIN(1,IFIELD,J)) THEN
                     I1 = WIN(3,IFIELD,J)
                     WIN(3,IFIELD,J) = WIN(1,IFIELD,J)
                     WIN(1,IFIELD,J) = I1
                     END IF
                  WIN(2,IFIELD,J) = MAX (1, MIN (IPARM(3),
     *               IMSIZE(2,IFIELD)))
                  WIN(4,IFIELD,J) = MAX (1, MIN (IPARM(5),
     *               IMSIZE(2,IFIELD)))
                  IF (WIN(4,IFIELD,J).LT.WIN(2,IFIELD,J)) THEN
                     I1 = WIN(4,IFIELD,J)
                     WIN(4,IFIELD,J) = WIN(2,IFIELD,J)
                     WIN(2,IFIELD,J) = I1
                     END IF
C                                       no boxes this field
               ELSE
                  IF (ISUBF(IFIELD).GT.1) THEN
                     WRITE (MSGTXT,1030) IFIELD
                     CALL MSGWRT (6)
                  ELSE
                     ISUBF(IFIELD) = -1
                     END IF
                  END IF
               END IF
            END IF
 50      CONTINUE
 60   DO 70 I = 1,NFIELD
         IF (ISUBF(I).LT.0) NBOXES(I) = 0
         IF (ISUBF(I).GT.0) NBOXES(I) = MIN (LIMIT, ISUBF(I))
         IF (ISUBF(I).GT.LIMIT) THEN
            WRITE (MSGTXT,1060) I, LIMIT, ISUBF(I)
            CALL MSGWRT (6)
            END IF
 70      CONTINUE
      CALL ZTXCLS (LUN, FIND, I)
      IERR = 0
C
      IF (IDD.GT.0) THEN
         MSGTXT = 'WINDF: Number of clean boxes/field read as follows:'
         CALL MSGWRT (3)
         DO 80 J = 1,NFIELD,4
            I1 = J
            I2 = MIN (NFIELD, I1+3)
            WRITE (MSGTXT,1070) ('Fld', I, NBOXES(I), I = I1,I2)
            CALL MSGWRT (3)
 80         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('WINDF: ERROR',I4,1X,A,'ING THE CLEAN BOXES TEXT FILE')
 1020 FORMAT ('WINDF: PARSING ERROR ON LINE',I4,' FIELD',I5)
 1030 FORMAT ('WINDF: FIELD',I5,' ZERO BOXES CODE IGNORED DUE TO',
     *   ' REAL BOXES READ')
 1060 FORMAT ('WARNING: FIELD',I5,' USED FIRST',I5,' OF',I6,
     *   ' BOXES IN FILE')
 1070 FORMAT (4(A3,I5.2,':',I5,2X))
      END

      SUBROUTINE DSISL (A, LDA, N, KPVT, B)
C-----------------------------------------------------------------------
C! Solves a DP symmetric system.
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C     DSISL SOLVES THE DOUBLE PRECISION SYMMETRIC SYSTEM
C     A * X = B
C     USING THE FACTORS COMPUTED BY DSIFA.
C
C     ON ENTRY:
C
C        A       DOUBLE PRECISION(LDA,N)
C                THE OUTPUT FROM DSIFA.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  A .
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX  A .
C
C        KPVT    INTEGER(N)
C                THE PIVOT VECTOR FROM DSIFA.
C
C        B       DOUBLE PRECISION(N)
C                THE RIGHT HAND SIDE VECTOR.
C
C     ON RETURN
C
C        B       THE SOLUTION VECTOR  X .
C
C     ERROR CONDITION
C
C        A DIVISION BY ZERO MAY OCCUR IF  DSICO  HAS SET RCOND.EQ.0.0
C        OR  DSIFA  HAS SET INFO .NE. 0  .
C
C     TO COMPUTE  INVERSE(A) * C  WHERE  C  IS A MATRIX
C     WITH  P  COLUMNS
C           CALL DSIFA(A,LDA,N,KPVT,INFO)
C           IF (INFO .NE. 0) GO TO ...
C           DO 10 J = 1, P
C              CALL DSISL(A,LDA,N,KPVT,C(1,J))
C        10 CONTINUE
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     JAMES BUNCH, UNIV. CALIF. SAN DIEGO, ARGONNE NAT. LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS DAXPY,DFDOT
C     FORTRAN IABS
C
C-----------------------------------------------------------------------
      INTEGER   LDA, N, KPVT(*)
      DOUBLE PRECISION A(LDA,*), B(*)
C
      DOUBLE PRECISION AK, AKM1, BK, BKM1, DFDOT, DENOM, TEMP
      INTEGER   K, KP
      INTEGER   IT1
C-----------------------------------------------------------------------
C
C     LOOP BACKWARD APPLYING THE TRANSFORMATIONS AND
C     D INVERSE TO B.
C
      K = N
   10 IF (K.EQ.0) GO TO 80
         IF (KPVT(K).LT.0) GO TO 40
C
C           1 X 1 PIVOT BLOCK.
C
            IF (K.EQ.1) GO TO 30
               KP = KPVT(K)
               IF (KP.EQ.K) GO TO 20
C
C                 INTERCHANGE.
C
                  TEMP = B(K)
                  B(K) = B(KP)
                  B(KP) = TEMP
   20          CONTINUE
C
C              APPLY THE TRANSFORMATION.
C
               IT1 = K-1
               CALL DAXPY (IT1, B(K), A(1,K), 1, B(1), 1)
   30       CONTINUE
C
C           APPLY D INVERSE.
C
            B(K) = B(K)/A(K,K)
            K = K - 1
         GO TO 70
   40    CONTINUE
C
C           2 X 2 PIVOT BLOCK.
C
            IF (K.EQ.2) GO TO 60
               KP = ABS(KPVT(K))
               IF (KP.EQ.K - 1) GO TO 50
C
C                 INTERCHANGE.
C
                  TEMP = B(K-1)
                  B(K-1) = B(KP)
                  B(KP) = TEMP
   50          CONTINUE
C
C              APPLY THE TRANSFORMATION.
C
               IT1 = K-2
               CALL DAXPY (IT1, B(K), A(1,K), 1, B(1), 1)
               CALL DAXPY (IT1, B(K-1), A(1,K-1), 1, B(1), 1)
   60       CONTINUE
C
C           APPLY D INVERSE.
C
            AK = A(K,K)/A(K-1,K)
            AKM1 = A(K-1,K-1)/A(K-1,K)
            BK = B(K)/A(K-1,K)
            BKM1 = B(K-1)/A(K-1,K)
            DENOM = AK*AKM1 - 1.0D0
            B(K) = (AKM1*BK - BKM1)/DENOM
            B(K-1) = (AK*BKM1 - BK)/DENOM
            K = K - 2
   70    CONTINUE
      GO TO 10
   80 CONTINUE
C
C     LOOP FORWARD APPLYING THE TRANSFORMATIONS.
C
      K = 1
   90 IF (K.GT.N) GO TO 160
         IF (KPVT(K).LT.0) GO TO 120
C
C           1 X 1 PIVOT BLOCK.
C
            IF (K.EQ.1) GO TO 110
C
C              APPLY THE TRANSFORMATION.
C
               IT1 = K-1
               B(K) = B(K) + DFDOT (IT1, A(1,K), 1, B(1), 1)
               KP = KPVT(K)
               IF (KP.EQ.K) GO TO 100
C
C                 INTERCHANGE.
C
                  TEMP = B(K)
                  B(K) = B(KP)
                  B(KP) = TEMP
  100          CONTINUE
  110       CONTINUE
            K = K + 1
         GO TO 150
  120    CONTINUE
C
C           2 X 2 PIVOT BLOCK.
C
            IF (K.EQ.1) GO TO 140
C
C              APPLY THE TRANSFORMATION.
C
               IT1 = K-1
               B(K) = B(K) + DFDOT (IT1, A(1,K), 1, B(1), 1)
               B(K+1) = B(K+1) + DFDOT (IT1, A(1,K+1), 1, B(1), 1)
               KP = ABS (KPVT(K))
               IF (KP.EQ.K) GO TO 130
C
C                 INTERCHANGE.
C
                  TEMP = B(K)
                  B(K) = B(KP)
                  B(KP) = TEMP
  130          CONTINUE
  140       CONTINUE
            K = K + 2
  150    CONTINUE
      GO TO 90
  160 CONTINUE
C
      RETURN
      END

      SUBROUTINE TABPO (OPCODE, POBUFF, IPORNO, POKOLS, PONUMV, TIME,
     *   SOUID, SOURA, SOUDEC, SOUDST, IERR)
C----------------------------------------------------------------------
C! I/O to planetary position table (following init. by POINI)
C# EXT-appl
C----------------------------------------------------------------------
C;  Copyright (C) 2001, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C----------------------------------------------------------------------
C   Does I/O to a planetary position table.  Used after setup by POINI.
C   Inputs:
C      OPCODE       C*4         Operation code:
C                               'READ' = read entry from table
C                               'WRIT' = write entry in table
C                               'CLOS' = close file, flush on write
C      POBUFF       I(*)        I/O buffer and related storage, also
C                               defines file if open. Should have
C                               been returned by POINI.
C   Input/Output:
C      IPORNO       I           Next row to read or write
C      POKOLS       I(MAXPOC)   The column pointer array in order:
C                               TIME, SOURCE, RA, DEC, DISTANCE
C      PONUMV       I(MAXPOC)   Element count in each column.
C      TIME         D           Time (days wrt reference day)
C      SOUID        I           Source ID
C      SOURA        D           Source RA (radians)
C      SOUDEC       D           Source DEC (radians)
C      SOUDST       D           Source distance (AU)
C   Output:
C      IERR         I           Return code (0=>ok; else error)
C                               Note: -1 => read by not selected
C----------------------------------------------------------------------
      INCLUDE 'INCS:DPOV.INC'
      CHARACTER OPCODE*4
      INTEGER   POBUFF(512), IPORNO, POKOLS(MAXPOC), PONUMV(MAXPOC),
     *   SOUID, IERR
      DOUBLE PRECISION TIME, SOURA, SOUDEC, SOUDST
C
      REAL      RECORD(MXSPPO)
      INTEGER   RECI(MXSPPO)
      DOUBLE PRECISION RECD(MXDPPO)
      EQUIVALENCE (RECD, RECORD, RECI)
      INCLUDE 'INCS:DMSG.INC'
C----------------------------------------------------------------------
C                                       Initialization
      IERR = 0
C                                       Close
 800  IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, IPORNO, RECORD, POBUFF, IERR)
         IF (IERR.GT.0) CALL TABERR ('CLOS', 'TABIO', 'TABPO', IERR)
C                                       Do I/O
      ELSE
C                                       If write fill RECORD
         IF (OPCODE.NE.'READ') THEN
C                                       Time
            RECD(POKOLS(PODTIM)) = TIME
C                                       Source ID
            RECI(POKOLS(POISID)) = SOUID
C                                       Source RA
            RECD(POKOLS(PODRA)) = SOURA
C                                       Source DEC
            RECD(POKOLS(PODDEC)) = SOUDEC
C                                       Source distance
            RECD(POKOLS(PODDST)) = SOUDST
            END IF
C                                       Process record
 200     CALL TABIO (OPCODE, 0, IPORNO, RECORD, POBUFF, IERR)
         IPORNO = IPORNO + 1
         IF (IERR.GT.0) THEN
            CALL TABERR (OPCODE, 'TABIO', 'TABPO', IERR)
C                                       If READ pick data from record
         ELSE IF (OPCODE.EQ.'READ') THEN
C                                       Time
            TIME = RECD(POKOLS(PODTIM))
C                                       Source ID
            SOUID = RECI(POKOLS(POISID))
C                                       Source RA
            SOURA = RECD(POKOLS(PODRA))
C                                       Source DEC
            SOUDEC = RECD(POKOLS(PODDEC))
C                                       Source distance
            SOUDST = RECD(POKOLS(PODDST))
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE MAGDIP (GLAT, GLONG, RADIUS, H)
C-----------------------------------------------------------------------
C! Calculate Earth's magnetic field components
C# Util
C-----------------------------------------------------------------------
C;  Copyright (C) 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Routine to compute the earth's magnetic field strength from an
C   offset dipole model.  Adapted from Handbook of Geophysics and Space
C   Envirnoments (circa 1965) S. L. Valley ed. Air Force Cambridge
C   Research Laboratories and Chapman and Bartels, 1940, GEOPHYSICS,
C   Oxford)
C      NOTE: The Gaussian coefficients from Chapman and Bartels give
C   a slightly better representation of the field than Valley so these
C   values are used here.
C      Values of H returned are probably good to better than 20%.
C   At the VLA the model is 6% low in total intensity and 11 deg W in
C   magnetic declination.
C    Inputs:
C     GLAT    R    Geocentric latitude (radians)
C     GLONG   R    Geocentric EAST longitude (radians)
C     RADIUS  R    Distance from the center of the earth (m)
C    Output:
C     H(3)    R    Magnetic field vector (gauss),
C                  (1) = positive away from earth center,
C                  (2) = positive east,
C                  (3) = positive north.
C-----------------------------------------------------------------------
      REAL    GLAT, GLONG, RADIUS, H(3),
     *   RE, FACT, GLATMP, GLONMP, PI,
     *   H02, L0, L1, L2, E, SQRT3,
     *   G10, G11, G20, G21, G22, H11, H21, H22, X0, Y0, Z0
      PARAMETER (PI = 3.14159265)
C                                       Geographic coordinates of
C                                       North magnetic pole.
      PARAMETER (GLATMP = 78.63 * PI / 180)
      PARAMETER (GLONMP = 289.85 * PI / 180)
C                                       Gaussian coefficients(gauss):
C                                       From Handbook of Geophysics...
C                                       Epoch 1960.
C                                       Modified??????
C      PARAMETER (G10 = -0.30509)
C      PARAMETER (G11 = -0.02181/2.0)
C      PARAMETER (G20 = -0.02196/2.0)
C      PARAMETER (G21 =  0.05145/3.0)
C      PARAMETER (G22 =  0.01448/4.0)
C      PARAMETER (H11 =  0.05841/2.0)
C      PARAMETER (H21 = -0.03443/3.0)
C      PARAMETER (H22 =  0.00172/4.0)
C                                       Chapman values Epoch 1922
      PARAMETER (G10 = -.3095)
      PARAMETER (G11 = -.0226)
      PARAMETER (G20 = -.0067)
      PARAMETER (G21 = 0.0292)
      PARAMETER (G22 = 0.0143)
      PARAMETER (H11 = 0.0592)
      PARAMETER (H21 = -.0122)
      PARAMETER (H22 = 0.0113)
C                                       SQRT3 = sqrt (3.0)
      PARAMETER (SQRT3 = 1.732050808)
C                                       Compute dipole center in units
C                                       of earth radius.
      PARAMETER (H02 = G10*G10 + G11*G11 + H11*H11)
      PARAMETER (L0  = 2.0*G10*G20 + (G11*G21 + H11*H21) * SQRT3)
      PARAMETER (L1  = -G11*G20 + (G10*G21+G11*G22+H11*H22) * SQRT3)
      PARAMETER (L2 = -H11*G20 + (G10*H21-H11*G22+G11*H22) * SQRT3)
      PARAMETER (E = (L0*G10 + L1*G11 + L2*H11) / (4.0*H02))
      PARAMETER (X0 = (L1 - G11*E) / (3.0*H02))
      PARAMETER (Y0 = (L2 - H11*E) / (3.0*H02))
      PARAMETER (Z0 = (L0 - G10*E) / (3.0*H02))
      REAL   X0M, Y0M, Z0M, HMAG, HD(3), CLA, SLA, CLO, SLO
      DOUBLE PRECISION POS0(3), POS1(3), POSTMP(3), POST2(3), RADDIP,
     *   COLAT,
     *   LONDIP, CA, SA, CB, SB
C                                       RE = Radius of earth (avg polar
C                                       and equitorial)
      DATA RE /6367650.0/
C-----------------------------------------------------------------------
C                                       Center of dipole
      X0M = X0 * RE
      Y0M = Y0 * RE
      Z0M = Z0 * RE
C                                       Convert to earth center x,y,z
C                                       Here y=> 90 e long.
      POS0(1) = RADIUS * COS (GLAT) * COS (GLONG)
      POS0(2) = RADIUS * COS (GLAT) * SIN (GLONG)
      POS0(3) = RADIUS * SIN (GLAT)
C                                       Translate
      POSTMP(1) = POS0(1) - X0M
      POSTMP(2) = POS0(2) - Y0M
      POSTMP(3) = POS0(3) - Z0M
C                                       Rotate to dipole coord.
      CA = COS (GLONMP)
      SA = SIN (GLONMP)
      CB = SIN (GLATMP)
      SB = -COS (GLATMP)
      POST2(1) = (POSTMP(1)*CA + POSTMP(2)*SA) * CB +
     *   POSTMP(3) * SB
      POST2(2) = POSTMP(2) * CA - POSTMP(1) * SA
      POST2(3) = POSTMP(3) * CB - SB * (POSTMP(1)*CA + POSTMP(2)*SA)
C                                       Polar coordinates in dipole.
      RADDIP = SQRT (POST2(1)*POST2(1) + POST2(2)*POST2(2) +
     *   POST2(3)*POST2(3))
      COLAT = ACOS (POST2(3) / RADDIP)
      LONDIP = ATAN2 (POST2(2), POST2(1))
      CLA = SIN (COLAT)
      SLA = COS (COLAT)
      CLO = COS (LONDIP)
      SLO = SIN (LONDIP)
C                                       Terms of dipole, local
      FACT = SQRT (H02) * ((RE / RADDIP) ** 3)
      H(1) = -2.0 * FACT * COS (COLAT)
      H(2) = 0.0
      H(3) = FACT * SIN (COLAT)
C                                       Rotate to dipole centered
      HD(1) = (H(1)*CLA - H(3)*SLA) * CLO - H(2) * SLO
      HD(2) = H(2) * CLO + (H(1)*CLA - H(3)*SLA) * SLO
      HD(3) = H(3) * CLA + H(1) * SLA
C                                       Modulus of HD
      HMAG = SQRT (HD(1)*HD(1) + HD(2)*HD(2) + HD(3)*HD(3))
C                                       Find position 1 km from
C                                       position in the direction of HD.
      POST2(1) = POST2(1) + 1000.0 * HD(1) / HMAG
      POST2(2) = POST2(2) + 1000.0 * HD(2) / HMAG
      POST2(3) = POST2(3) + 1000.0 * HD(3) / HMAG
C                                       Rotate new position to earth
C                                       system.
      POSTMP(1) = (POST2(1)*CB - POST2(3)*SB) * CA - POST2(2) * SA
      POSTMP(2) = POST2(2) * CA + (POST2(1)*CB - POST2(3)*SB) * SA
      POSTMP(3) = POST2(3) * CB + POST2(1) * SB
C                                       Translate to earth center
      POS1(1) = POSTMP(1) + X0M
      POS1(2) = POSTMP(2) + Y0M
      POS1(3) = POSTMP(3) + Z0M
C                                       Earth centered field
      HD(1) = (POS1(1) - POS0(1)) * 0.001 * HMAG
      HD(2) = (POS1(2) - POS0(2)) * 0.001 * HMAG
      HD(3) = (POS1(3) - POS0(3)) * 0.001 * HMAG
C                                       Earth local field
      CLA = COS (GLAT)
      SLA = SIN (GLAT)
      CLO = COS (GLONG)
      SLO = SIN (GLONG)
      H(1) = (HD(1)*CLO + HD(2)*SLO) * CLA + HD(3) * SLA
      H(2) = HD(2) * CLO - HD(1) * SLO
      H(3) = HD(3) * CLA - (HD(1)*CLO + HD(2)*SLO) * SLA
C
 999  RETURN
      END

      SUBROUTINE POINI (OPCODE, POBUFF, DISK, CNO, VER, CATBLK, LUNPO,
     *   IPORNO, POKOLS, PONUMV, OBSDAT, TABVER, IERR)
C----------------------------------------------------------------------
C! Creates and initializes a planetary position (PO) table
C# EXT-appl
C----------------------------------------------------------------------
C;  Copyright (C) 2001-2002, 2006, 2019, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C----------------------------------------------------------------------
C   Creates and initializes planetary position (PO) tables
C   Inputs:
C      OPCODE     C*4       Operation code:
C                           'WRIT' = create/init for write or read
C                           'READ' = open for read only
C      POBUFF     I(512)    I/O buffer and related storage, also
C                           defines file is open.
C      DISK       I         Disk volume
C      CNO        I         Catalog slot number
C      VER        I         PO table version
C      CATBLK     I(256)    Catalog header block
C      LUNPO      I         Logical unit number for table I/O
C   Output:
C      IPORNO     I         Next row number; start of file if READ,
C                           the last record plus one if WRIT
C      POKOLS(MAXPOC) I     The column pointer array in order:
C                           TIME, SOURCE, RA, DEC, DISTANCE
C      PONUMV(MAXPOC) I     Element count in each column. On input only
C                           used if the file is created.
C      OBSDAT     C*8       Observing date.
C      TABVER     I         Table revision number
C   Output:
C      IERR       I         Return code (0=>ok, else error)
C----------------------------------------------------------------------
      INCLUDE 'INCS:DPOV.INC'
      CHARACTER OPCODE*4, OBSDAT*8
      INTEGER   POBUFF(512), DISK, CNO, VER, CATBLK(256), LUNPO, IPORNO,
     *   POKOLS(MAXPOC), PONUMV(MAXPOC), TABVER, IERR
C
      INCLUDE 'INCS:DMSG.INC'
      LOGICAL   T, DOREAD, NEWFIL
      CHARACTER TTITLE*56, TITLE(MAXPOC)*24, UNITS(MAXPOC)*8,
     *   KEYWRD(NKEYPO)*8, OTITLE*24
      INTEGER   I, JERR, ITEMP(6), NTTPO, NKEY, NREC, NCOL, IPOINT,
     *   NC, ITRIM, NDATA, DATP(128,2), KLOCS(NKEYPO), KEYTYP(NKEYPO),
     *   KEYI(NKYWPO), DTYP(MAXPOC)
      HOLLERITH KEYH(NKYWPO), HOLTMP(6)
      EQUIVALENCE (KEYI, KEYH)
      EQUIVALENCE (HOLTMP, ITEMP)
      DATA TTITLE / 'PLANETARY POSITION TABLE' /
      DATA TITLE / 'TIME', 'SOURCE_ID', 'SOURCE RA', 'SOURCE DEC',
     *            'SOURCE DISTANCE' /
      DATA OTITLE /'SOURCE ID'/
      DATA UNITS / 'DAYS', ' ', 'DEGREES', 'DEGREES', 'AU' /
      DATA KEYWRD / 'TABREV', 'RDATE' /
      DATA NTTPO / 56 /
      DATA T / .TRUE. /
C----------------------------------------------------------------------
C                                       Initialization
      IERR = 0
C                                       Check OPCODE
      DOREAD = (OPCODE.EQ.'READ')
C                                       Set up needed variables
      NREC = 30
      NCOL = MAXPOC
      IF (DOREAD) NCOL = 0
      NKEY = NKEYPO
      NDATA = MAXPOC
      CALL FILL (NDATA, 0, POKOLS)
      CALL FILL (NDATA, 0, PONUMV)
C                                       Fill in types, lengths:
C                                       See Going AIPS, Vol 2, p13-3.
      IF (.NOT.DOREAD) THEN
         DTYP(PODTIM) = TABDBL + 10
         DTYP(POISID) = TABINT + 10
         DTYP(PODRA) = TABDBL + 10
         DTYP(PODDEC) = TABDBL + 10
         DTYP(PODDST) = TABDBL + 10
         CALL COPY (NCOL, DTYP, DATP(1,2))
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'PO', DISK, CNO, VER, CATBLK, LUNPO, NKEY,
     *   NREC, NCOL, DATP, POBUFF, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'POINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
C                                       Get number of records
      IPORNO = POBUFF(5) + 1
      IF (DOREAD) IPORNO = 1
      NKEY = NKEYPO
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Column labels
         DO 40 I = 1, NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, POBUFF, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'POINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, POBUFF, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'POINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in table title
         CALL CHR2H (NTTPO, TTITLE, 1, POBUFF(101))
C                                       Write keywords if table created
C                                       Table revision
         KLOCS(1) = 1
         KEYTYP(1) = TABINT
         KEYI(1) = IPOREV
C                                       Observing date
         KLOCS(2) = 2
         KEYTYP(2) = TABHOL
         CALL CHR2H (8, OBSDAT, 1, KEYI(KLOCS(2)))
C                                       Write to the PO table
         CALL TABKEY ('WRIT', KEYWRD, NKEYPO, POBUFF, KLOCS, KEYI,
     *      KEYTYP, IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'POINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         CALL TABKEY ('READ', KEYWRD, NKEYPO, POBUFF, KLOCS, KEYI,
     *      KEYTYP, IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'POINI', IERR)
            GO TO 990
            END IF
C                                       Table version
         TABVER = KEYI(KLOCS(1))
C                                       Observing date
         CALL H2CHR (8, 1, KEYH(KLOCS(2)), OBSDAT)
         END IF
C                                       Get array indices:
C                                       Prevent problems with FNDCOL -
C                                       close to flush the buffers
C                                       and then reopen.
      CALL TABIO ('CLOS', 0, 0, POBUFF, POBUFF, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'POINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
C                                       Re-open
      CALL TABINI (OPCODE, 'PO', DISK, CNO, VER, CATBLK, LUNPO, NKEY,
     *   NREC, NCOL, DATP, POBUFF, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'POINI', IERR)
         GO TO 990
         END IF
C
      CALL FNDCOL (NDATA, TITLE, 24, T, POBUFF, POKOLS, JERR)
      IF (POKOLS(2).LE.0) CALL FNDCOL (1, OTITLE, 24, T, POBUFF,
     *   POKOLS(2), JERR)
C                                       Get array indices and no. val.
      DO 150 I = 1,NDATA
         IPOINT = POKOLS(I)
         IF (IPOINT.GT.0) THEN
            POKOLS(I) = DATP(IPOINT,1)
            PONUMV(I) = DATP(IPOINT,2) / 10
            IF (PONUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            POKOLS(I) = -1
            PONUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C                                       Exit
 999  RETURN
C----------------------------------------------------------------------
 1100 FORMAT ('POINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('POINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('POINI: ERROR INITIALIZING PLANETARY POSITION TABLE FOR ',
     *   A4)
      END

      SUBROUTINE YGRAPH (OP, CHAN, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! turns TV graphics planes on and off
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YGRAPH is used to turn graphics overlay planes on & off by
C   altering the graphics color look up table.  The color pattern is:
C      CHAN = 1    insert   yellow            drawing plots
C             2    insert   green+.05 red     axis labels
C             3    insert   blue + 0.6 green  blotch
C                           + red
C             4    insert   black             label backgrounds
C             5-7  add      nothing           null channels
C             8    insert   purple            cursor
C   Inputs:
C      OP      C*4       'ONNN' or 'OFFF'
C                        'INIT' also allowed, though should only be
C                        secondary and hence not used in VTV
C      CHAN    I         channel number (1 - 8)
C   Output:
C      SCRTCH  I(256)    scratch buffer
C      IERR    I         error code of Z...XF: 0 => ok
C                                              2 => input error
C   Virtual TV version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   CHAN, SCRTCH(256), IERR
C
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
C                                        check input
      IERR = 2
      IF ((CHAN.LT.1) .OR. (CHAN.GT.8)) GO TO 999
      IF ((OP.NE.'ONNN') .AND. (OP.NE.'OFFF') .AND. (OP.NE.'INIT'))
     *    GO TO 999
C                                        do it
      BUFFER(1) = 0
      IF (OP.EQ.'ONNN') BUFFER(1) = 1
      IF (OP.EQ.'INIT') BUFFER(1) = 2
      BUFFER(2) = CHAN
      BUFSW = 2
      BUFSR = 0
      CALL MKYBUF ('WRIT', 'YGRAPH', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
C
 999  RETURN
      END

      SUBROUTINE R8TX (NXTLT, NTHPO, LENGT, CR0, CR1, CR2, CR3, CR4,
     *   CR5, CR6, CR7, CI0, CI1, CI2, CI3, CI4, CI5, CI6, CI7)
C-----------------------------------------------------------------------
C! VMS Pseudo AP routine: Radix 8 FFT butterfly
C# AP-FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C    Radix 8 Butterfly called by FFT842
C-----------------------------------------------------------------------
      REAL      CR0(*), CR1(*), CR2(*), CR3(*), CR4(*), CR5(*), CR6(*),
     *   CR7(*), CI0(*), CI1(*), CI2(*), CI3(*), CI4(*), CI5(*),
     *   CI6(*), CI7(*), C1, C2, C3, C4, C5, C6, C7, S1, S2, S3, S4, S5,
     *   S6, S7,
     *   AR0, AR1, AR2, AR3, AR4, AR5, AR6, AR7,
     *   AI0, AI1, AI2, AI3, AI4, AI5, AI6, AI7,
     *   BR0, BR1, BR2, BR3, BR4, BR5, BR6, BR7,
     *   BI0, BI1, BI2, BI3, BI4, BI5, BI6, BI7,
     *   TR, TI, SCALE, ARG, PI2, P7
      INTEGER   NXTLT, NTHPO, LENGT, J, K
      COMMON /CON2/ PI2, P7
C-----------------------------------------------------------------------
      SCALE = PI2 / LENGT
      DO 30 J = 1,NXTLT,2
         ARG = (J - 1.0) * SCALE
         C1 = COS (ARG)
         S1 = SIN (ARG)
         C2 = C1 * C1 - S1 * S1
         S2 = C1 * S1 * 2.0
         C3 = C1 * C2 - S1 * S2
         S3 = C2 * S1 + S2 * C1
         C4 = C2 * C2 - S2 * S2
         S4 = C2 * S2 * 2.0
         C5 = C2 * C3 - S2 * S3
         S5 = C3 * S2 + S3 * C2
         C6 = C3 * C3 - S3 * S3
         S6 = C3 * S3 * 2.0
         C7 = C3 * C4 - S3 * S4
         S7 = C4 * S3 + S4 * C3
         DO 20 K = J,NTHPO,LENGT
            AR0 = CR0(K) + CR4(K)
            AR1 = CR1(K) + CR5(K)
            AR2 = CR2(K) + CR6(K)
            AR3 = CR3(K) + CR7(K)
            AR4 = CR0(K) - CR4(K)
            AR5 = CR1(K) - CR5(K)
            AR6 = CR2(K) - CR6(K)
            AR7 = CR3(K) - CR7(K)
            AI0 = CI0(K) + CI4(K)
            AI1 = CI1(K) + CI5(K)
            AI2 = CI2(K) + CI6(K)
            AI3 = CI3(K) + CI7(K)
            AI4 = CI0(K) - CI4(K)
            AI5 = CI1(K) - CI5(K)
            AI6 = CI2(K) - CI6(K)
            AI7 = CI3(K) - CI7(K)
            BR0 = AR0 + AR2
            BR1 = AR1 + AR3
            BR2 = AR0 - AR2
            BR3 = AR1 - AR3
            BR4 = AR4 - AI6
            BR5 = AR5 - AI7
            BR6 = AR4 + AI6
            BR7 = AR5 + AI7
            BI0 = AI0 + AI2
            BI1 = AI1 + AI3
            BI2 = AI0 - AI2
            BI3 = AI1 - AI3
            BI4 = AI4 + AR6
            BI5 = AI5 + AR7
            BI6 = AI4 - AR6
            BI7 = AI5 - AR7
            CR0(K) = BR0 + BR1
            CI0(K) = BI0 + BI1
            IF (J.LE.0) GO TO 10
               CR1(K) = C4 * (BR0 - BR1) - S4 * (BI0 - BI1)
               CI1(K) = C4 * (BI0 - BI1) + S4 * (BR0 - BR1)
               CR2(K) = C2 * (BR2 - BI3) - S2 * (BI2 + BR3)
               CI2(K) = C2 * (BI2 + BR3) + S2 * (BR2 - BI3)
               CR3(K) = C6 * (BR2 + BI3) - S6 * (BI2 - BR3)
               CI3(K) = C6 * (BI2 - BR3) + S6 * (BR2 + BI3)
               TR = P7 * (BR5 - BI5)
               TI = P7 * (BR5 + BI5)
               CR4(K) = C1 * (BR4 + TR) - S1 * (BI4 + TI)
               CI4(K) = C1 * (BI4 + TI) + S1 * (BR4 + TR)
               CR5(K) = C5 * (BR4 - TR) - S5 * (BI4 - TI)
               CI5(K) = C5 * (BI4 - TI) + S5 * (BR4 - TR)
               TR = -P7 * (BR7 + BI7)
               TI = P7 * (BR7 - BI7)
               CR6(K) = C3 * (BR6 + TR) - S3 * (BI6 + TI)
               CI6(K) = C3 * (BI6 + TI) + S3 * (BR6 + TR)
               CR7(K) = C7 * (BR6 - TR) - S7 * (BI6 - TI)
               CI7(K) = C7 * (BI6 - TI) + S7 * (BR6 - TR)
               GO TO 20
 10         CR1(K) = BR0 - BR1
            CI1(K) = BI0 - BI1
            CR2(K) = BR2 - BI3
            CI2(K) = BI2 + BR3
            CR3(K) = BR2 + BI3
            CI3(K) = BI2 - BI3
            TR = P7 * (BR5 - BI5)
            TI = P7 * (BR5 + BI5)
            CR4(K) = BR4 + TR
            CI4(K) = BI4 + TI
            CR5(K) = BR4 - TR
            CI5(K) = BI4 - TI
            TR = -P7 * (BR7 + BI7)
            TI = P7 * (BR7 - BI7)
            CR6(K) = BR6 + TR
            CI6(K) = BI6 + TI
            CR7(K) = BR6 - TR
            CI7(K) = BI6 - TI
 20         CONTINUE
 30      CONTINUE
 999  RETURN
      END

LOCAL INCLUDE 'DENAN.INC'
C                                       Local include for DENAN
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      REAL      XSIN, XDISIN, XSOUT, XDISO, APARM(10),
     *   BUFF1(UVBFSS), BUFF2(UVBFSS)
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS, JBUFSZ, ILOCWT,
     *   CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI,
     *   LRECO, NRPRMI, NRPRMO, NUMNAN, NUMBIG, IBUFF1(UVBFSS), OLDCNO,
     *   NEWCNO
      DOUBLE PRECISION NANNUM
      LOGICAL   ISCOMP
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, HISCRD(10)*64
      EQUIVALENCE (IBUFF1, BUFF1)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XCLAOU,
     *   XSOUT, XDISO, APARM
      COMMON /DENANC/ CATOLD, NANNUM, SEQIN, SEQOUT, DISKIN, DISKO,
     *   ILOCWT, INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO,
     *   LRECI, LRECO, NRPRMI, NRPRMO, ISCOMP, NUMNAN, NUMHIS, NUMBIG,
     *   OLDCNO, NEWCNO
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, HISCRD
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
C                                       End local include for DENAN
LOCAL END
      PROGRAM DENAN
C-----------------------------------------------------------------------
C! Removes NaNs and excess values from UV data
C# Utility UV UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2020-2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DENAN removes NaNs and excess values from UV data
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      APARM(10)      APARM         User specified array.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'DENAN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'DENAN '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL DENANI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL DENANU (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL DENANH
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE DENANI (PRGN, JERR)
C-----------------------------------------------------------------------
C   DENANI gets input parameters for DENAN and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in DENAN for more details.
C
C   To change the adverb list sent to this task change:
C   1)  the inputs file.
C   2)  the contents of COMMON /INPARM/.  Remember all adverbs are sent
C       as R, INNAME etc. are 12 char. 3 words;
C       INCLASS etc. are 6 char., 2 words.
C       Values will be filled into COMMON /INPARM/ in the order
C       specified in the inputs file.
C   3)  If the first adverb is not INNAME (NAMEIN) then replace
C       NAMEIN in the call to GTPARM with the name of the first
C       adverb.
C   4)  Change the value of NPARM sent to GTPARM to the number of
C       R words desired.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER  STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX
      LOGICAL   T, F
      INCLUDE 'DENAN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK  /'      '/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 24
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       max allowed (Jy)
      IF (APARM(1).LE.0.0) APARM(1) = 1.E9
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         MSGTXT = 'THIS TASK DOES LITTLE FOR COMPRESSED DATA'
         CALL MSGWRT (7)
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      NEWCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, NEWCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((NEWCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, NEWCNO, CATBLK, 'WRIT', BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DENANI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('DENANI: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE DENANU (IRET)
C-----------------------------------------------------------------------
C   DENANU sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48, IFILE*48
      INTEGER   INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, ILENBU,
     *   KBIND, NIOUT, NIOLIM, IBIND, I, IA1, IA2, INCX, BO, VO,
     *   NUMVIS, XCOUNT, NCORI, NCORO, NCOPY, RNXRET
      LOGICAL   T, F
      INCLUDE 'DENAN.INC'
      REAL      BASEN, CBUFF(UVBFSS), RESULT(UVBFSS)
      INTEGER   ICBUFF(UVBFSS)
      EQUIVALENCE (ICBUFF, CBUFF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI, LUNO /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
      IF (ISCOMP) INCX = 3
C                                       Number of visibilities in input
C                                       and output files.
      NCORI = (LRECI - NRPRMI) / CATOLD(KINAX)
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, NEWCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Out of data?
         IF (INIO.LE.0) GO TO 200
C                                       Loop over buffer
         DO 190 I = 1,INIO
            BASEN = BUFF1(IPTRI+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
            NUMVIS = NUMVIS + 1
C                                      Call user routine.
            IF (ISCOMP) THEN
C                                       Compressed data.
               CALL ZUVXPN (NCORI, BUFF1(IPTRI+NRPRMI),
     *            BUFF1(IPTRI+ILOCWT), CBUFF)
               CALL DIDDLE (NUMVIS, CBUFF, ICBUFF, INCX, RESULT, IRET)
            ELSE
C                                       Un compressed data
               CALL DIDDLE (NUMVIS, BUFF1(IPTRI+NRPRMI),
     *            IBUFF1(IPTRI+NRPRMI), INCX, RESULT, IRET)
               END IF
C                                       Branch on his return
            IF (IRET.GT.0) THEN
C                                       Error (fatal)
               WRITE (MSGTXT,1120) IRET
               GO TO 990
C                                       Copy to output.
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1.0D0
               CALL RCOPY (NRPRMO, BUFF1(IPTRI), BUFF2(IPTRO))
C                                       update NX table
               CALL RNXUPD (BUFF1(IPTRI), RNXRET)
C                                       Compressed
               IF (ISCOMP) THEN
                  CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *               BUFF2(IPTRO+NRPRMO))
               ELSE
                  CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
                  END IF
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               END IF
C                                       OK, but no output please
            IPTRI = IPTRI + LRECI
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
C                                       Read next buffer.
         GO TO 100
C                                       Final call to DIDDLE.
 200     NUMVIS = -1
         CALL DIDDLE (NUMVIS, BUFF1, IBUFF1, INCX, RESULT, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
            END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, NEWCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DENANU: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1010 FORMAT ('DENANU: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('DENANU: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('DENANU: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('DENANU: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('DENANU: DIDDLE ERROR',I3)
 1150 FORMAT ('DENANU: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE DENANH
C-----------------------------------------------------------------------
C   DENANH copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP*2, HILINE*72, LABEL*8
      INTEGER   LUN1, LUN2, IERR, I, NONOT
      LOGICAL   T, F
      INCLUDE 'DENAN.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T, F /.TRUE.,.FALSE./
      DATA NONOT, NOTTYP /0, '  '/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any other history.
      IF (NUMHIS.LE.0) GO TO 200
         WRITE (LABEL,1010) TSKNAM
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
C                                       Close HI file
 200   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO,
     *   FCNO(2), FCNO(1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1200)
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST',
     *   BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DENANH: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,' /')
 1200 FORMAT ('DENANH: ERROR COPYING TABLES')
      END
      SUBROUTINE DIDDLE (NUMVIS, VIS, IVIS, INCX, RESULT, IRET)
C-----------------------------------------------------------------------
C   Does the work
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      VIS     R(INCX,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                   NOTE: INCX may be any value .GE. 2
C   Inputs from COMMON:
C      APARM(10)  R(10)   User array.
C      RA         D       Right ascension (1950) of phase center. (deg)
C      DEC        D       Declination (1950) of phase center. (deg)
C      FREQ       D       Frequency of observation (Hz)
C      NRPARM     I       # random parameters.
C      NCOR       I       # correlators
C      CATBLK     I(256)  Catalog header record. See Going Aips for
C                         details.
C      LRECI      I    Input file record length
C      NRPRMI     I    Input number of random parameters.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
C      LRECO      I    Output file record length
C      NRPRMO     I    Output number of random parameters.
C      INCSO      I    Output Stokes' increment in vis.
C      INCFO      I    Output frequency increment in vis.
C      INCIFO     I    Output IF increment in vis.
C   Output:
C      RESULT  R(INCX,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C
C   Output in COMMON:
C      NUMHIS    I         # history entries (max. 10)
C      HISCRD    C(NUMHIS) History records
C      CATBLK    I         Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IVIS(INCX,*), INCX, IRET
      REAL      VIS(INCX,*), RESULT(INCX,*)
C
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXO, INDEXI, I, J
      INCLUDE 'DENAN.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.GT.0) THEN
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
         DO 40 JIF = 1,NIF
            DO 30 JF = 1,NF
               DO 20 JS = 1,NS
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *               (JS-1) * INCSO + 1
C                                       check vis for NaNs
                  CALL CNTNAN (IVIS(1,INDEXI), J, I)
                  IF (J.GT.0) THEN
                     NANNUM = NANNUM + 1.0D0
                     IF (I.GT.0) NUMNAN = NUMNAN + 1
                  ELSE
                     CALL CHKBIG (VIS(1,INDEXI), APARM(1), J)
                     IF (J.GT.0) NUMBIG = NUMBIG + 1
                     END IF
                  DO 10 I = 1,INCX
                     IF (I.LE.2) THEN
                        RESULT(I,INDEXO) = VIS(I,INDEXI)
                     ELSE
                        RESULT(I,INDEXO) = VIS(I,INDEXI)
                        END IF
 10                  CONTINUE
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
C                                       end of example (vis)
C                                       last call - no vis
      ELSE
         NUMHIS = 2
         WRITE (HISCRD(1),1101) TSKNAM, NANNUM
         WRITE (HISCRD(2),1102) TSKNAM, NUMNAN
         WRITE (MSGTXT,1201) NANNUM
         CALL MSGWRT (4)
         WRITE (MSGTXT,1202) NUMNAN
         CALL MSGWRT (4)
         IF (APARM(1).LE.1.E8) THEN
            NUMHIS = 4
            WRITE (HISCRD(3),1103) TSKNAM, NUMBIG
            WRITE (HISCRD(4),1104) TSKNAM, APARM(1)
            WRITE (MSGTXT,1203) NUMBIG, APARM(1)
            CALL MSGWRT (4)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1101 FORMAT (A6,'/ ',F13.0,' NaNs found in data set')
 1102 FORMAT (A6,'/ ',I10,' of these were not previously flagged')
 1103 FORMAT (A6,'/ ',I10,' samples with excess amplitude')
 1104 FORMAT (A6,'APARM(1) =',F9.4,'  / peak allowed amplitude')
 1201 FORMAT (F13.0,' NaNs found in data set')
 1202 FORMAT (I10,' of these were not previously flagged')
 1203 FORMAT (I10,' samples with amplitude >',1PE10.3)
      END
      SUBROUTINE CNTNAN (IARR, CNT, WASG)
C-----------------------------------------------------------------------
C   count NaNs
C   Inputs:
C      IARR   I(3)   Values to check
C   Outputs:
C      CNT    I      Number of NaNs
C-----------------------------------------------------------------------
      INTEGER   IARR(*), CNT, WASG
C
      INTEGER   I, I4NAN, J, ZAND
      INCLUDE 'INCS:DMSG.INC'
C                                       = 7F800000 mask for exponent
      DATA I4NAN /2139095040/
C-----------------------------------------------------------------------
      CNT = 0
      WASG = 0
      DO 10 I = 1,3
         J = ZAND (IARR(I), I4NAN)
         IF (J.EQ.I4NAN) CNT = CNT + 1
 10      CONTINUE
      IF (CNT.GT.0) THEN
         IF (IARR(3).GT.0) WASG = 1
         IARR(1) = 0
         IARR(2) = 0
         IARR(3) = 0
         END IF
C
 999  RETURN
      END
      SUBROUTINE CHKBIG (VIS, LEVEL, CNT)
C-----------------------------------------------------------------------
C   count NaNs
C   Inputs:
C      IARR   I(3)   Values to check
C   Outputs:
C      CNT    I      Number of NaNs
C-----------------------------------------------------------------------
      INTEGER   CNT
      REAL      VIS(3), LEVEL
C
      REAL      FLUX
C-----------------------------------------------------------------------
      CNT = 0
      IF (VIS(3).GT.0.0) THEN
         FLUX = SQRT (VIS(1)**2 + VIS(2)**2)
         IF (FLUX.GT.LEVEL) THEN
            CNT = 1
            VIS(1) = 0.0
            VIS(2) = 0.0
            VIS(3) = 0.0
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZIVSOP (LUN, IND, IERR)
C-----------------------------------------------------------------------
C! opens IVAS TV device - using the IIS package
C# TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZIVSOP opens the IVAS TV device use the IIS software package.  It
C   does make an entry in the AIPS FTAB, but never really uses it.
C   Inputs:
C      LUN    I   FORTRAN logical file number.
C   Output:
C      IND    I   Index into FTAB for the file control block.
C      IERR   I   Error return code: 0 = no error
C                    1 = LUN already in use
C                    2 = file not found
C                    3 = volume not found
C                    4 = excl requested but not available
C                    5 = no room for lun
C                    6 = other open errors
C   Generic version - translates logical TVDEVn (n = NTVDEV), calls
C   FIVASOPEN.
C   Modified 92.03.12 to allow for double-digit TV, i.e. TVDEVnn.
C-----------------------------------------------------------------------
      INTEGER   LUN, IND, IERR
C
      INTEGER   ERRLUN, ERRTER, IER, LLEN, XLEN, XLNB, JERR, I, J
      LOGICAL   F
      CHARACTER LOGNAM*10, XLATED*256
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA F /.FALSE./
      DATA ERRLUN, ERRTER /12, 6/
C-----------------------------------------------------------------------
      IERR = 6
      IF ((LUN.EQ.ERRLUN) .OR. (LUN.EQ.ERRTER)) GO TO 980
      IF ((LUN.LE.0) .OR. (LUN.GT.50)) GO TO 980
      IF (DEVTAB(LUN).NE.4) GO TO 970
      IF ((NTVDEV.LE.0) .OR. (NTVDEV.GT.15)) GO TO 975
      IERR = 0
C                                       allocate table
      CALL LSERCH ('OPEN', LUN, IND, F, IER)
      IF (IER.EQ.0) GO TO 20
         IF (IER.NE.2) GO TO 10
            IERR = 1
            WRITE (MSGTXT,1000) LUN
            GO TO 990
 10      IF (IER.NE.3) GO TO 20
            IERR = 5
            WRITE (MSGTXT,1010) LUN
            GO TO 990
C                                       Form logical device name and
C                                       translate it.  Changed [PPM]
C                                       92.03.12, up to 255 tv's now.
 20   LOGNAM = 'TVDEV  '
      CALL ZEHEX (NTVDEV, 2, LOGNAM(6:7))
      LLEN = LEN (LOGNAM)
      XLEN = LEN (XLATED)
      CALL ZTRLOG (LLEN, LOGNAM, XLEN, XLATED, XLNB, IERR)
      IF (IERR.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) IERR
         IERR = 3
         GO TO 900
C                                       Call IVAS library open.
 30   XLATED(XLNB+1:XLNB+1) = CHAR (0)
      CALL ZIVSO2 (YBUFF(11), XLATED, JERR)
      IF (JERR.NE.0) THEN
         IERR = 6
         WRITE (MSGTXT,1030) JERR, LUN
C                                       store file name
      ELSE
         CALL FSERCH (IND, I, J, JERR)
         IF (JERR.EQ.0) THEN
            IF (I.EQ.1) DEVNAM(J) = XLATED(1:48)
            IF (I.EQ.2) NONNAM(J) = XLATED(1:48)
            IF (I.EQ.3) MAPNAM(J) = XLATED(1:48)
            END IF
         GO TO 999
         END IF
C                                       Errors
C                                       remove FTAB
 900  CALL LSERCH ('CLOS', LUN, IND, F, IER)
      IF ((IERR.EQ.3) .OR. (IERR.EQ.6)) GO TO 990
C                                       illegal device
 970  WRITE (MSGTXT,1970) LUN
      GO TO 990
C                                       illegal TV number
 975  WRITE (MSGTXT,1975) NTVDEV
      GO TO 990
C                                       illegal lun
 980  WRITE (MSGTXT,1980) LUN
C                                       print msg
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZIVSOP: LUN',I4,' ALREADY IN USE')
 1010 FORMAT ('ZIVSOP: LUN TABLE FULL, CAN''T FIT LUN',I4)
 1020 FORMAT ('ZIVSOP: TRANSLATE LOGICAL ERROR ',I4)
 1030 FORMAT ('ZIVSOP: FIVASOPEN ERROR',I12,' LUN',I3)
 1970 FORMAT ('ZIVSOP: CALLED FOR NON-TV DEVICE WITH LUN',I4)
 1975 FORMAT ('ZIVSOP: CALLED FOR ILLEGAL TV DEVICE NUMBER',I4)
 1980 FORMAT ('ZIVSOP: LUN',I6,' ILLEGAL FOR TV')
      END

      SUBROUTINE ZPHOLV (VERDAT, VERSYS, TYPE, IVOL, NSEQ, IVER, PNAM,
     *   IERR)
C-----------------------------------------------------------------------
C! construct a physical file - version for UPDAT
C# Z IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2017
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Construct a physical file name in PNAM from TYPE, IVOL, NSEQ, and
C   IVER - either for public data files or user-specific files.
C   Version of ZPHFIL for UPDAT, in which the Format version codes are
C   passed as arguments.
C   Inputs:
C      VERDAT  C*1   Data file version code letter
C      VERSYS  C*1   System file version code letter
C      TYPE    C*2   Type of file: e.g. 'MA' for map file
C      IVOL    I     Number of the disk volume to be used (1-71)
C      NSEQ    I     Sequence number (000-4095)
C      IVER    I     Version number (00-255)
C   Outputs:
C      PNAM    C*48  physical file name, left justified
C      IERR    I     Error return code: 0 = good return.   1 = error.
C
C   Example: If TYPE='MA', IVOL=7, AIPSVER=C, NSEQ=321, IVER=12799,
C            NLUSER=762 then
C               PNAME='DA06:MAD08X9VJ;'      for public data or
C               PNAME='DA06:MAD08X9VJ.0L6;'  for private data
C           use base 36 now: 321 => 08X, 12799 => 9VJ, 762 => 0L6
C           disks are base 36 but 0 relative
C
C   TYPE = 'MT' leads to special name for tapes
C   TYPE = 'TK' leads to special name for TEK4012 plotter CRT
C   TYPE = 'TV' leads to special name for TV device
C   TYPE = 'ME' leads to special logical for POPS memory files
C
C   Generic version - the ZOPEN, ZTRLOG, etc. routines interpret the
C   resulting VMS-like names.
C   If VERDAT = D or greater, use base 36 names, else use base 16.
C-----------------------------------------------------------------------
      CHARACTER VERDAT*1, VERSYS*1, TYPE*2, PNAM*48
      INTEGER   IVOL, NSEQ, IVER, IERR
C
      INTEGER   IVOL2, NUNAME, UNAME, VERLIM, VOLLIM, CATLIM
      CHARACTER CHVOL*4, CHVER*4, CHCAT*4, CHUSER*4, UNAMES(15)*2
      LOGICAL   NEW
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA NUNAME, UNAMES /15, 'AC','BA','BQ','HE','IC','ID','IN','ME',
     *   'SP','TP','TD','GR','PW','MT','TC'/
C-----------------------------------------------------------------------
      NEW = (VERDAT.NE.'A') .AND. (VERDAT.NE.'B') .AND. (VERDAT.NE.'C')
      IERR = 1
      IF (NEW) THEN
         PNAM = 'DA00:MAAFFFFFF;1 '
         VERLIM = 36 * 36 * 36 - 1
         CATLIM = VERLIM
         VOLLIM = 99
      ELSE
         PNAM = 'DA00:MAAFFFFF;1 '
         VERLIM = 16 * 16 - 1
         CATLIM = 16 * 16 * 16 - 1
         VOLLIM = 15
         END IF
      PNAM(8:8) = VERDAT
      IF (TYPE.EQ.'MT') PNAM(1:2) = 'MT'
C                                       Special code for TEK 4012
      IF (TYPE.EQ.'TK') THEN
         IF (NTKDEV.LE.0) GO TO 999
         PNAM = 'TKDEV00:'
         CALL ZEHEX (NTKDEV, 2, PNAM(6:7))
C                                       TV device
      ELSE IF (TYPE.EQ.'TV') THEN
         IF (NTVDEV.LE.0) GO TO 999
         PNAM = 'TVDEV00:'
         CALL ZEHEX (NTVDEV, 2, PNAM(6:7))
C                                       Special POPS memory files
      ELSE IF (TYPE.EQ.'ME') THEN
         IF ((IVER.LT.0) .OR. (IVER.GT.VERLIM)) GO TO 999
            IF (NEW) THEN
               PNAM = VERNAM(1:3) // 'MEM:ME1000000;1'
               CALL ZEHEX (IVER, 3, CHVER)
               PNAM(14:16) = CHVER(1:3)
            ELSE
               PNAM = VERNAM(1:3) // 'MEM:ME100000;1'
               CALL ZHEX (IVER, 2, CHVER)
               PNAM(14:15) = CHVER(1:2)
               END IF
            PNAM(10:10) = VERSYS
C                                       other devices (disk files)
      ELSE
C                                       Check input parameters.
         IF ((IVOL.LT.1) .OR. (IVOL.GT.VOLLIM)) GO TO 999
         IF ((NSEQ.LT.0) .OR. (NSEQ.GT.CATLIM)) GO TO 999
         IF ((IVER.LT.0) .OR. (IVER.GT.VERLIM)) GO TO 999
C                                       User private?
            UNAME = 0
            IF (NUNAME.LE.0) GO TO 45
               DO 40 UNAME = 1,NUNAME
                  IF (TYPE.EQ.UNAMES(UNAME)) GO TO 45
 40               CONTINUE
               UNAME = 0
C                                       Adjust for 1 relative input
 45         IVOL2 = IVOL - 1
            IF (UNAME.LE.0) IVOL2 = IVOL
            IF (NEW) THEN
               CALL ZEHEX (IVOL2, 4, CHVOL)
               CALL ZEHEX (NSEQ, 4, CHCAT)
               CALL ZEHEX (IVER, 4, CHVER)
               CALL ZEHEX (NLUSER, 4, CHUSER)
            ELSE
               CALL ZHEX (IVOL2, 4, CHVOL)
               CALL ZHEX (NSEQ, 4, CHCAT)
               CALL ZHEX (IVER, 4, CHVER)
               CALL ZHEX (NLUSER, 4, CHUSER)
               END IF
C                                       2 digit volume numbers!
            PNAM(3:4) = CHVOL(3:4)
            PNAM(6:7) = TYPE
            IF (UNAME.LE.0) THEN
               PNAM(8:8) = VERDAT
            ELSE
               PNAM(8:8) = VERSYS
               END IF
            PNAM(9:11) = CHCAT(2:4)
            IF (NEW) THEN
               PNAM(12:14) = CHVER(2:4)
            ELSE
               PNAM(12:13) = CHVER(3:4)
               END IF
C                                       User private additions
            IF ((UNAME.LE.0) .AND. (UCTSIZ.GT.0)) THEN
               IF (NEW) THEN
                  PNAM(15:) = '.' // CHUSER(2:4) // ';'
               ELSE
                  PNAM(14:) = '.' // CHUSER(2:4) // ';1'
                  END IF
               END IF
         END IF
C                                       No error
      IERR = 0
C
 999  RETURN
      END

      SUBROUTINE OFMMOD (OPER, IG, N, OFM, IOFM, IERR)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2002, 2015, 2022, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Verbs to modify existing OFMs by "TWEAKing" or "ADJUSting"
C   Input:
C      OPER     C*(*)    'TWEAK', 'ADJUS', 'STRETCH'
C      IG       I        graphics plane to use (> NGRAY)
C      N        I        Dimension of OFM
C   In/out:
C      OFM      R(N,3)   In: current OFM, Out: new OFM
C   Output:
C      IOFM     R(N,3)   Initial OFM
C      IERR     I        POPS Errror code
C   Ideas from Mark Calabretta, Australia Telescope.
C-----------------------------------------------------------------------
      CHARACTER OPER*(*)
      INTEGER   IG, N, IERR
      REAL      OFM(N,3), IOFM(N,3)
C
      REAL      FK, RPOS(2), PPOS(2), MX, MY, LX, LY, DELTAI, SLOPE,
     *   OFFSET, X
      INTEGER   I, J, QUAD, IBUT, ITW(3), NLEVS, J0, POTERR, INX(2),
     *   INY(2), OUTX(2), OUTY(4), NHIST, MODE, LG, TX(2,4), TY(4),
     *   RNGE(2,4), IX, IXP(5), IYP(5), IY, IX0, IX1, IY0, IY1, MAG,
     *   KOLOR, IYC(5), IXC(2), TTY(2), INC, RHIST(8,200), I1, I2,
     *   PRNGE(2,4), LJ0
      LOGICAL   T, F, DOIT, DOADJU
      CHARACTER STRING*8, MSGBUF*72
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DCNT.INC'
      INTEGER   BUFFER(MAXIMG)
      EQUIVALENCE (BUFFER, ILROW)
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      QUAD = -1
      RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
      RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2
      CALL ZTIME (ITW)
      NLEVS = LUTOUT + 1
      CALL RCOPY (N, OFM(1,1), IOFM(1,1))
      CALL RCOPY (N, OFM(1,2), IOFM(1,2))
      CALL RCOPY (N, OFM(1,3), IOFM(1,3))
      POTERR = 49
      LG = IG + NGRAY
      LJ0 = 0
C                                        tweak the OFMs
      IF (OPER.EQ.'TWEAK') THEN
         MX = RPOS(1)
         MY = RPOS(2)
         LX = WINDTV(3) - WINDTV(1) + 1
         LY = WINDTV(4) - WINDTV(2) + 1
C                                        instructions
         MSGTXT = 'Use the cursor to modify the OFM LUTs'
         CALL MSGWRT (1)
         MSGTXT = 'Press button A to undo changes'
         CALL MSGWRT (1)
         MSGTXT = 'Press button D to exit'
         CALL MSGWRT (1)
 20      CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       read loop
 30      CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IERR)
            IF (IERR.NE.0) GO TO 980
            CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
C                                       do something
            IF (DOIT) THEN
               IF (IBUT.GE.8) THEN
                  POTERR = 0
                  GO TO 980
C                                       Revert to the input OFM.
               ELSE IF (IBUT.EQ.1) THEN
                  CALL YWINDO ('READ', WINDTV, IERR)
                  RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
                  RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2
                  MX = RPOS(1)
                  MY = RPOS(2)
                  LX = WINDTV(3) - WINDTV(1) + 1
                  LY = WINDTV(4) - WINDTV(2) + 1
                  END IF
C                                       Find new OFM
               J0 = (1.5 * NLEVS * (MX-RPOS(1))) / LX
               FK = 2.0 ** ((RPOS(2)-MY) / (LY/4.0))
               DO 40 I = 2,NLEVS
                  J = (I + J0) * FK + 0.5
                  J = MAX (1, MIN (NLEVS, J))
                  OFM(I,3) = IOFM(J,3)
                  OFM(I,2) = IOFM(J,2)
                  OFM(I,1) = IOFM(J,1)
 40               CONTINUE
C                                       Send to TV
               CALL OFMIO ('WRIT', N, NLEVS, F, OFM, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1040) IERR
                  CALL MSGWRT (6)
                  GO TO 980
                  END IF
               IF (IBUT.EQ.1) GO TO 20
               END IF
            GO TO 30
C                                       Adjust OFMs
      ELSE IF (OPER.EQ.'ADJUS') THEN
         TTY(1) = 5
         CALL LSERCH ('SRCH', TTY(1), TTY(2), F, IERR)
         CALL IMANOT ('INIT', IG, IX, TY(3), 0, 0, 'R', BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
C                                       get visible corners
         MAG = 1 + TVZOOM(1)
         IF (MXZOOM.GT.0) MAG = 2 ** TVZOOM(1)
         IX0 = WINDTV(1) - (MAG-1)/2
         IX1 = WINDTV(3) - (MAG-1)/2
         IY0 = WINDTV(2) - (MAG-1)/2
         IY1 = WINDTV(4) - (MAG-1)/2
         IF (MAG.GT.1) IY0 = IY0 + MAG
         IF (MAG.GT.1) IY1 = IY1 + MAG
         IX0 = (IX0 - TVZOOM(2))/MAG + TVZOOM(2)
         IX1 = (IX1 - TVZOOM(2))/MAG + TVZOOM(2)
         IY0 = (IY0 - TVZOOM(3))/MAG + TVZOOM(3)
         IY1 = (IY1 - TVZOOM(3))/MAG + TVZOOM(3)
         IX0 = MAX (1, MIN (MAXXTV(1), IX0))
         IX1 = MAX (1, MIN (MAXXTV(1), IX1))
         IY0 = MAX (1, MIN (MAXXTV(1), IY0))
         IY1 = MAX (1, MIN (MAXXTV(1), IY1))
C                                       Plot locations: Input bar
         INY(2) = IY1 - 2 * CSIZTV(2) + 1
         INY(1) = INY(2) - 2 * CSIZTV(2) + 1
         TY(4) = INY(1) + (CSIZTV(2) + 1) / 2
         I = (IX1 - IX0 + 1 - CSIZTV(1)) / (LUTOUT + 1)
         IF (I.LT.1) THEN
            INX(1) = IX0 + CSIZTV(1) / 2
            INX(2) = IX1 - CSIZTV(1) / 2
         ELSE
            INX(1) = (IX1 + IX0 - I * (LUTOUT+1)) / 2
            INX(2) = INX(1) + I * (LUTOUT + 1) - 1
            END IF
         TX(1,4) = INX(1) + (CSIZTV(1) + 1) / 2
         TX(2,4) = INX(2) - (CSIZTV(1) + 1) / 2 - 4 * CSIZTV(1)
C                                       Plot locations: Output bar
         OUTY(4) = INY(1) - 3 * CSIZTV(2)
         OUTY(3) = OUTY(4) - 2 * CSIZTV(2) + 1
         OUTY(2) = OUTY(3) - 2 * CSIZTV(2) + 1
         OUTY(1) = OUTY(2) - 2 * CSIZTV(2) + 1
         TY(1) = OUTY(1) + (CSIZTV(2) + 1) / 2
         TY(2) = OUTY(2) + (CSIZTV(2) + 1) / 2
         TY(3) = OUTY(3) + (CSIZTV(2) + 1) / 2
         I = (IX1 - IX0 - 3 * CSIZTV(1)) / (OFMOUT + 1)
         IF (I.LT.1) THEN
            OUTX(1) = IX0 + CSIZTV(1) * 2
            OUTX(2) = IX1 - CSIZTV(1) * 2
         ELSE
            OUTX(1) = (IX1 + IX0 - I * (OFMOUT+1)) / 2
            OUTX(2) = OUTX(1) + I * (OFMOUT + 1) - 1
            END IF
         TX(1,1) = OUTX(1) + (CSIZTV(1) + 1) / 2
         TX(2,1) = OUTX(2) - (CSIZTV(1) + 1) / 2 - 4 * CSIZTV(1)
         TX(1,2) = TX(1,1)
         TX(2,2) = TX(2,1)
         TX(1,3) = TX(1,1)
         TX(2,3) = TX(2,1)
C                                       Draw lines and labels: IN
         IXP(1) = INX(1)
         IXP(2) = INX(2)
         IXP(3) = INX(2)
         IXP(4) = INX(1)
         IXP(5) = INX(1)
         IYP(1) = INY(1)
         IYP(2) = INY(1)
         IYP(3) = INY(2)
         IYP(4) = INY(2)
         IYP(5) = INY(1)
         CALL IMVECT ('ONNN', LG, 5, IXP, IYP, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IYP(1) = INY(1)
         IYP(2) = INY(2)
         IXP(1) = INX(1) + 0.25 * (INX(2) - INX(1)) + 0.5
         IXP(2) = IXP(1)
         CALL IMVECT ('ONNN', LG, 2, IXP, IYP, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IXP(1) = INX(1) + 0.50 * (INX(2) - INX(1)) + 0.5
         IXP(2) = IXP(1)
         CALL IMVECT ('ONNN', LG, 2, IXP, IYP, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IXP(1) = INX(1) + 0.75 * (INX(2) - INX(1)) + 0.5
         IXP(2) = IXP(1)
         CALL IMVECT ('ONNN', LG, 2, IXP, IYP, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IX = INX(1) - CSIZTV(1) / 2
         IY = INY(2) + (CSIZTV(2) + 1) / 2
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, '0', BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IX = INX(2) - 4.5 * CSIZTV(1)
         WRITE (STRING,1100) LUTOUT
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, STRING(:4), BUFFER,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IX = (INX(2) + INX(1) - CSIZTV(1)) / 2
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'IN', BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
C                                       Draw lines and labels: OUT
         IXP(1) = OUTX(1)
         IXP(2) = OUTX(2)
         IXP(3) = OUTX(2)
         IXP(4) = OUTX(1)
         IXP(5) = OUTX(1)
         IYP(1) = OUTY(1)
         IYP(2) = OUTY(1)
         IYP(3) = OUTY(4)
         IYP(4) = OUTY(4)
         IYP(5) = OUTY(1)
         CALL IMVECT ('ONNN', LG, 5, IXP, IYP, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IYP(1) = OUTY(3)
         IYP(2) = IYP(1)
         CALL IMVECT ('ONNN', LG, 2, IXP, IYP, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IYP(1) = OUTY(2)
         IYP(2) = IYP(1)
         CALL IMVECT ('ONNN', LG, 2, IXP, IYP, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IYP(1) = OUTY(1)
         IYP(2) = OUTY(4)
         IXP(1) = OUTX(1) + 0.25 * (OUTX(2) - OUTX(1)) + 0.5
         IXP(2) = IXP(1)
         CALL IMVECT ('ONNN', LG, 2, IXP, IYP, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IXP(1) = OUTX(1) + 0.50 * (OUTX(2) - OUTX(1)) + 0.5
         IXP(2) = IXP(1)
         CALL IMVECT ('ONNN', LG, 2, IXP, IYP, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IXP(1) = OUTX(1) + 0.75 * (OUTX(2) - OUTX(1)) + 0.5
         IXP(2) = IXP(1)
         CALL IMVECT ('ONNN', LG, 2, IXP, IYP, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IX = OUTX(1) - CSIZTV(1) / 2
         IY = OUTY(4) + (CSIZTV(2) + 1) / 2
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, '0', BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IX = OUTX(2) - 4.5 * CSIZTV(1)
         WRITE (STRING,1100) LUTOUT
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, STRING(:4), BUFFER,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IX = (OUTX(1) + OUTX(2) - 3 * CSIZTV(1)) / 2
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'OUT', BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IX = OUTX(1) - (3 * CSIZTV(1) + 1) / 2
         CALL IMANOT ('WRIT', IG, IX, TY(1), 0, 0, 'B', BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         CALL IMANOT ('WRIT', IG, IX, TY(2), 0, 0, 'G', BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         CALL IMANOT ('WRIT', IG, IX, TY(3), 0, 0, 'R', BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IX = OUTX(2) + (CSIZTV(1) + 1) / 2
         CALL IMANOT ('WRIT', IG, IX, TY(1), 0, 0, 'B', BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         CALL IMANOT ('WRIT', IG, IX, TY(2), 0, 0, 'G', BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         CALL IMANOT ('WRIT', IG, IX, TY(3), 0, 0, 'R', BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
C                                       Options menu
         IXC(1) = IX0 + (IX1 - IX0) / 3
         IXC(2) = IXC(1) + (IX1 - IX0) / 3
         IYC(1) = IY0 + CSIZTV(2) / 2
         IYC(2) = IYC(1) + 3 * CSIZTV(2) - 1
         IYC(3) = IYC(2) + 3 * CSIZTV(2) - 1
         IYC(4) = IYC(3) + 3 * CSIZTV(2) - 1
         IYC(5) = IYC(4) + 3 * CSIZTV(2) - 1
         IX = IX0 + CSIZTV(1) / 2
         IY = IYC(1) + CSIZTV(2)
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'SET B OUT', BUFFER,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IY = IYC(2) + CSIZTV(2)
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'SET G OUT', BUFFER,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IY = IYC(3) + CSIZTV(2)
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'SET R OUT', BUFFER,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IY = IYC(4) + CSIZTV(2)
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'SET IN RANGE', BUFFER,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IX = (IX0 + IX1) / 2  - 8 * CSIZTV(1)
         IY = IYC(1) + CSIZTV(2)
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'EXIT', BUFFER,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IY = IYC(2) + CSIZTV(2)
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'UNDO ALL CHANGES',
     *      BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IY = IYC(3) + CSIZTV(2)
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'SHOW HISTORY', BUFFER,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IY = IYC(4) + CSIZTV(2)
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'UNDO ONE CHANGE',
     *      BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IX = IX1 - 13.5 * CSIZTV(2)
         IY = IYC(1) + CSIZTV(2)
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'TYPE IN B OUT', BUFFER,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IY = IYC(2) + CSIZTV(2)
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'TYPE IN G OUT', BUFFER,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IY = IYC(3) + CSIZTV(2)
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'TYPE IN R OUT', BUFFER,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         IY = IYC(4) + CSIZTV(2)
         CALL IMANOT ('WRIT', IG, IX, IY, 0, 0, 'TYPE IN RANGE', BUFFER,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
C                                       Initial values
         CALL FILL (8, -999, RNGE)
         CALL FILL (8, -999, PRNGE)
         MODE = 0
         KOLOR = 0
         NHIST = 1
         CALL FILL (8, -999, RHIST(1,NHIST))
C                                       cursor on
         RPOS(1) = (IX0 + IXC(1)) / 2.0
         RPOS(2) = (IYC(4) + IYC(5)) / 2.0
         MSGTXT = 'Hit button D to exit at any time'
         CALL MSGWRT (1)
         MSGTXT = 'Select an option with cursor and button A, B, or C'
         CALL MSGWRT (1)
         CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       read loop
 120     CALL YCURSE ('READ', F, T, RPOS, QUAD, IBUT, IERR)
            IF (IERR.NE.0) GO TO 980
            DOADJU = F
C                                       Defeat screen wrap algo.
            IF ((RPOS(1).NE.PPOS(1)) .OR. (RPOS(2).NE.PPOS(2))) THEN
               PPOS(1) = 0.0
               PPOS(2) = 0.0
               END IF
            CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
            IF (DOIT) THEN
               IF (IBUT.GE.8) THEN
                  POTERR = 0
                  GO TO 980
                  END IF
C                                       find operation
               IF (MODE.EQ.0) THEN
                  IF (IBUT.LE.0) GO TO 120
                  IX = 2
                  IF (RPOS(1).LE.IXC(1)) IX = 1
                  IF (RPOS(1).GE.IXC(2)) IX = 3
                  IY = 1
                  DO 125 I = 2,5
                     IF (RPOS(2).GT.IYC(I)) IY = I
 125                 CONTINUE
                  IF (IY.EQ.5) GO TO 190
                  KOLOR = 0
                  IF (IX.NE.2) THEN
                     IF ((IY.LT.4) .AND. (RNGE(1,4).EQ.-999)) THEN
                        MSGTXT = 'AN INPUT RANGE MUST BE SPECIFIED'
     *                     // ' FIRST'
                        CALL MSGWRT (1)
                        GO TO 190
                        END IF
C                                       save this range
                     IF ((IY.EQ.4) .AND. (RNGE(1,4).NE.-999)) THEN
                        DO 126 KOLOR = 1,3
                           IF (RNGE(1,KOLOR).NE.-999) GO TO 127
                           IF (RNGE(1,KOLOR).NE.-999) GO TO 127
 126                       CONTINUE
                        GO TO 128
127                    IF (NHIST.EQ.200) THEN
                           MSGTXT = 'History stack is filled'
                           CALL MSGWRT (1)
                        ELSE
                           NHIST = NHIST + 1
                           END IF
 128                    CALL FILL (8, -999, RNGE)
                        CALL FILL (8, -999, PRNGE)
                        CALL FILL (8, -999, RHIST(1,NHIST))
                        STRING = ' '
                        DO 130 KOLOR = 1,4
                           DO 129 J = 1,2
                              CALL IMANOT ('WRIT', IG, TX(J,KOLOR),
     *                           TY(KOLOR), 0, 0, STRING(:4), BUFFER,
     *                           IERR)
                              IF ((IERR.NE.0) .AND. (IERR.NE.2))
     *                           GO TO 980
 129                          CONTINUE
 130                       CONTINUE
                        END IF
                     KOLOR = IY
                     END IF
C                                       Init interactive numbers
                  IF (IX.EQ.1) THEN
                     PRNGE(1,KOLOR) = RNGE(1,KOLOR)
                     PRNGE(2,KOLOR) = RNGE(2,KOLOR)
                     MODE = 1
                     IF (RNGE(1,KOLOR).EQ.-999) THEN
                        RNGE(1,KOLOR) = 0
                        IF (KOLOR.LT.4) THEN
                           I = MIN (RNGE(1,4), LUTOUT)
                           IF (I.GT.0) RNGE(1,KOLOR) = OFM(I,KOLOR) *
     *                        OFMOUT
                           END IF
                        END IF
                     IF (RNGE(2,KOLOR).EQ.-999) THEN
                        RNGE(2,KOLOR) = LUTOUT
                        IF (KOLOR.LT.4) THEN
                           RNGE(2,KOLOR) = OFM(LUTOUT+1,KOLOR) * OFMOUT
     *                        - 0.001
                           I = MAX (RNGE(2,4), 0)
                           IF (I.LT.LUTOUT) RNGE(2,KOLOR) =
     *                        OFM(I+2,KOLOR) * OFMOUT - 0.001
                           END IF
                        END IF
                     WRITE (STRING,1100) RNGE(1,KOLOR)
                     CALL IMANOT ('WRIT', IG, TX(1,KOLOR), TY(KOLOR), 0,
     *                  0, STRING(:4), BUFFER, IERR)
                     IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
                     WRITE (STRING,1100) RNGE(2,KOLOR)
                     CALL IMANOT ('WRIT', IG, TX(2,KOLOR), TY(KOLOR), 0,
     *                  0, STRING(:4), BUFFER, IERR)
                     IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
                     MSGTXT = 'Cursor X position controls starting '
     *                  // 'value'
                     CALL MSGWRT (1)
                     MSGTXT = 'Hit button A to do ending value'
                     CALL MSGWRT (1)
                     MSGTXT = 'Hit button B to revert to initial '
     *                  // 'values'
                     CALL MSGWRT (1)
                     MSGTXT = 'Hit button C to go to new color or '
     *                  // 'operation'
                     CALL MSGWRT (1)
                     IF (KOLOR.EQ.4) THEN
                        RPOS(1) = (RNGE(1,KOLOR) * (INX(2) - INX(1))) /
     *                     LUTOUT + INX(1)
                        RPOS(2) = (INY(1) + INY(2)) / 2
                     ELSE
                        RPOS(1) = (RNGE(1,KOLOR) * (OUTX(2) - OUTX(1)))
     *                     / OFMOUT + OUTX(1)
                        RPOS(2) = (OUTY(KOLOR) + OUTY(KOLOR+1)) / 2
                        END IF
                     CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IERR)
                     IF (IERR.NE.0) GO TO 980
C                                       Request typed numbers
                  ELSE IF (IX.EQ.3) THEN
                     IF (KOLOR.EQ.4) WRITE (MSGBUF,1120) LUTOUT
                     IF (KOLOR.EQ.3) WRITE (MSGBUF,1121) 'Red', OFMOUT
                     IF (KOLOR.EQ.2) WRITE (MSGBUF,1121) 'Green', OFMOUT
                     IF (KOLOR.EQ.1) WRITE (MSGBUF,1121) 'Blue', OFMOUT
                     CALL INQINT (TTY, MSGBUF, 2, RNGE(1,KOLOR), IERR)
                     IF (IERR.NE.0) THEN
                        WRITE (MSGTXT,1122) IERR
                        CALL MSGWRT (6)
                        POTERR = 101
                        GO TO 990
                        END IF
                     DOADJU = KOLOR.LE.3
                     DO 135 J = 1,2
                        WRITE (STRING,1100) RNGE(J,KOLOR)
                        CALL IMANOT ('WRIT', IG, TX(J,KOLOR), TY(KOLOR),
     *                     0, 0, STRING(:4), BUFFER, IERR)
                        IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
 135                    CONTINUE
                     CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IERR)
                     IF (IERR.NE.0) GO TO 980
                     CALL COPY (8, RNGE, RHIST(1,NHIST))
C                                       Misc. operations
                  ELSE
C                                       Quit
                     IF (IY.EQ.1) THEN
                        POTERR = 0
                        GO TO 980
C                                       Undo ALL changes
                     ELSE IF (IY.EQ.2) THEN
                        NHIST = 1
                        CALL RCOPY (N, IOFM(1,1), OFM(1,1))
                        CALL RCOPY (N, IOFM(1,2), OFM(1,2))
                        CALL RCOPY (N, IOFM(1,3), OFM(1,3))
                        CALL OFMIO ('WRIT', N, NLEVS, F, OFM, IERR)
                        IF (IERR.NE.0) GO TO 980
                        CALL FILL (8, -999, RNGE)
                        CALL FILL (8, -999, PRNGE)
                        CALL FILL (8, -999, RHIST(1,NHIST))
                        STRING = ' '
                        DO 140 KOLOR = 1,4
                           DO 139 J = 1,2
                              CALL IMANOT ('WRIT', IG, TX(J,KOLOR),
     *                           TY(KOLOR), 0, 0, STRING(:4), BUFFER,
     *                           IERR)
                              IF ((IERR.NE.0) .AND. (IERR.NE.2))
     *                           GO TO 980
 139                          CONTINUE
 140                       CONTINUE
C                                       Display history
                     ELSE IF (IY.EQ.3) THEN
                        WRITE (MSGTXT,1130)
                        CALL MSGWRT (2)
                        DO 145 I = 1,NHIST
                           IF (I.EQ.NHIST) THEN
                              MSGTXT = 'Current segment:'
                              CALL MSGWRT (2)
                              END IF
                           WRITE (MSGTXT,1140) I, RHIST(7,I),
     *                        RHIST(8,I), (RHIST(J,I), J = 1,6)
                           CALL MSGWRT (2)
 145                       CONTINUE
C                                       Undo a single change
                     ELSE IF (IY.EQ.4) THEN
                        WRITE (MSGBUF,1145) NHIST
                        CALL INQINT (TTY, MSGBUF, 1, J0, IERR)
                        IF (IERR.NE.0) THEN
                           WRITE (MSGTXT,1122) IERR
                           CALL MSGWRT (6)
                           POTERR = 101
                           GO TO 990
                           END IF
                        IF ((J0.LT.1) .OR. (J0.GT.NHIST)) THEN
                           WRITE (MSGTXT,1146) J0, NHIST
                           CALL MSGWRT (1)
                           GO TO 190
                           END IF
                        CALL RCOPY (N, IOFM(1,1), OFM(1,1))
                        CALL RCOPY (N, IOFM(1,2), OFM(1,2))
                        CALL RCOPY (N, IOFM(1,3), OFM(1,3))
                        CALL FILL (8, -999, RHIST(1,J0))
C                                       Undo current one
                        IF (J0.EQ.NHIST) THEN
                           STRING = ' '
                           DO 150 KOLOR = 1,4
                              DO 149 J = 1,2
                                 CALL IMANOT ('WRIT', IG, TX(J,KOLOR),
     *                              TY(KOLOR), 0, 0, STRING(:4), BUFFER,
     *                              IERR)
                                 IF ((IERR.NE.0) .AND. (IERR.NE.2))
     *                              GO TO 980
 149                             CONTINUE
 150                          CONTINUE
                           CALL FILL (8, -999, RNGE)
                           END IF
C                                       rebuild OFM
                        DO 165 J = 1,NHIST
                           I1 = RHIST(7,J)
                           I2 = RHIST(8,J)
                           IF ((I1.EQ.-999) .OR. (I2.EQ.-999))
     *                        GO TO 165
                           INC = 1
                           IF (I1.GT.I2) INC = -1
                           DELTAI = I2 - I1
                           IF (I2.EQ.I1) DELTAI = 1.0
                           J0 = I1
                           I1 = MAX (0, MIN (LUTOUT, I1)) + 1
                           I2 = MAX (0, MIN (LUTOUT, I2)) + 1
                           DO 160 KOLOR = 1,3
                              IX = 2 * KOLOR - 1
                              IF ((RHIST(IX,J).EQ.-999) .OR.
     *                           (RHIST(IX+1,J).EQ.-999)) GO TO 160
                              SLOPE  = (RHIST(IX+1,J)-RHIST(IX,J))
     *                           / (DELTAI * OFMOUT)
                              OFFSET = RHIST(IX,J) / REAL(OFMOUT)
     *                           - J0 * SLOPE
                              DO 155 I = I1,I2,INC
                                 OFM(I,KOLOR) = (I-1)*SLOPE + OFFSET
 155                             CONTINUE
 160                          CONTINUE
 165                       CONTINUE
                        KOLOR = 0
                        CALL OFMIO ('WRIT', N, NLEVS, F, OFM, IERR)
                        IF (IERR.NE.0) GO TO 980
                        END IF
                     END IF
C                                       interacting TV color/level
               ELSE
                  IF (IBUT.LE.0) THEN
                     J = MODE
                     IF (J.EQ.3) J = 1
                     IF (KOLOR.EQ.4) THEN
                        RNGE(J,KOLOR) = REAL ((RPOS(1) - INX(1)) *
     *                      LUTOUT) / REAL (INX(2) - INX(1)) + 0.5
                     ELSE
                        RNGE(J,KOLOR) = REAL ((RPOS(1) - OUTX(1)) *
     *                     OFMOUT) / REAL (OUTX(2) - OUTX(1)) + 0.5
                        END IF
                     WRITE (STRING,1100) RNGE(J,KOLOR)
                     CALL IMANOT ('WRIT', IG, TX(J,KOLOR), TY(KOLOR), 0,
     *                  0, STRING(:4), BUFFER, IERR)
                     IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
                     DOADJU = (KOLOR.LE.3) .AND. (MODE.NE.3)
                  ELSE IF (IBUT.EQ.1) THEN
                     MODE = 3 - MODE
                     IF (MODE.EQ.0) MODE = 2
                     MSGTXT = 'Cursor X position controls starting '
     *                  //  'value'
                     CALL MSGWRT (1)
                     IF (MODE.EQ.1) THEN
                        MSGTXT = 'Hit button A to do ending value'
                        CALL MSGWRT (1)
                     ELSE IF (MODE.EQ.2) THEN
                        MSGTXT = 'Hit button A to do starting value'
                        CALL MSGWRT (1)
                        END IF
                     MSGTXT = 'Hit button C to freeze the '
     *                  // 'present values'
                     CALL MSGWRT (1)
                     IF (KOLOR.EQ.4) THEN
                        RPOS(1) = 0.5 + REAL (RNGE(MODE,KOLOR) *
     *                     (INX(2) - INX(1))) / LUTOUT + INX(1)
                        IF (RNGE(MODE,KOLOR).EQ.-999) RPOS(1) =
     *                     INX(MODE)
                        RPOS(2) = (INY(1) + INY(2)) / 2
                     ELSE
                        RPOS(1) = 0.5 + REAL (RNGE(MODE,KOLOR) *
     *                     (OUTX(2) - OUTX(1))) / OFMOUT + OUTX(1)
                        IF (RNGE(MODE,KOLOR).EQ.-999) RPOS(1) =
     *                     OUTX(MODE)
                        RPOS(2) = (OUTY(KOLOR) + OUTY(KOLOR+1)) / 2
                        END IF
                     IF (RPOS(1).LT.WINDTV(1)) RPOS(1) = WINDTV(1)
                     IF (RPOS(1).GT.WINDTV(3)) RPOS(1) = WINDTV(3)
                     CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IERR)
                     IF (IERR.NE.0) GO TO 980
C                                       revert
                  ELSE IF (IBUT.LE.3) THEN
                     RNGE(1,KOLOR) = PRNGE(1,KOLOR)
                     RNGE(2,KOLOR) = PRNGE(2,KOLOR)
                     DO 180 J = 1,2
                        WRITE (STRING,1100) RNGE(J,KOLOR)
                        IF (RNGE(J,KOLOR).EQ.-999) STRING = ' '
                        CALL IMANOT ('WRIT', IG, TX(J,KOLOR), TY(KOLOR),
     *                     0, 0, STRING(:4), BUFFER, IERR)
                        IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
 180                    CONTINUE
                     DOADJU = KOLOR.LE.3
                     IF (KOLOR.EQ.4) THEN
                        RPOS(1) = 0.5 + REAL (RNGE(MODE,KOLOR) *
     *                     (INX(2) - INX(1))) / LUTOUT + INX(1)
                        IF (RNGE(MODE,KOLOR).EQ.-999) RPOS(1) =
     *                     INX(MODE)
                        RPOS(2) = (INY(1) + INY(2)) / 2
                     ELSE
                        RPOS(1) = 0.5 + REAL (RNGE(MODE,KOLOR) *
     *                      (OUTX(2) - OUTX(1))) / OFMOUT + OUTX(1)
                        IF (RNGE(MODE,KOLOR).EQ.-999) RPOS(1) =
     *                     OUTX(MODE)
                        RPOS(2) = (OUTY(KOLOR) + OUTY(KOLOR+1)) / 2
                        END IF
                     IF (RPOS(1).LT.WINDTV(1)) RPOS(1) = WINDTV(1)
                     IF (RPOS(1).GT.WINDTV(3)) RPOS(1) = WINDTV(3)
                     CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IERR)
                     IF (IERR.NE.0) GO TO 980
                  ELSE
                     CALL COPY (8, RNGE, RHIST(1,NHIST))
                     MODE = 0
                     RPOS(1) = (IX0 + IXC(1)) / 2.0
                     RPOS(2) = (IYC(KOLOR) + IYC(KOLOR+1)) / 2.0
                     CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IERR)
                     IF (IERR.NE.0) GO TO 980
                     END IF
                  END IF
C                                       change the OFM in fact
               IF (DOADJU) THEN
                  I1 = RNGE(1,4)
                  I2 = RNGE(2,4)
                  IF ((I1.EQ.-999) .OR. (I2.EQ.-999)) GO TO 190
                  IF ((RNGE(1,KOLOR).EQ.-999) .OR.
     *               (RNGE(2,KOLOR).EQ.-999)) GO TO 190
                  INC = 1
                  IF (I1.GT.I2) INC = -1
                  DELTAI = I2 - I1
                  IF (I2.EQ.I1) DELTAI = 1.0
                  SLOPE  = (RNGE(2,KOLOR) - RNGE(1,KOLOR)) /
     *               (DELTAI * OFMOUT)
                  OFFSET = RNGE(1,KOLOR) / REAL(OFMOUT) -
     *               I1 * SLOPE
                  I1 = MAX (0, MIN (LUTOUT, I1)) + 1
                  I2 = MAX (0, MIN (LUTOUT, I2)) + 1
                  DO 185 I = I1,I2,INC
                     OFM(I,KOLOR) = (I - 1) * SLOPE + OFFSET
 185                 CONTINUE
                  CALL OFMIO ('WRIT', N, NLEVS, F, OFM, IERR)
                  IF (IERR.NE.0) GO TO 980
                  END IF
 190           IF (MODE.EQ.0) THEN
                  MSGTXT = 'Select an option with cursor and button '
     *               // 'A, B, or C'
                  CALL MSGWRT (1)
                  END IF
               END IF
            GO TO 120
C                                        tweak the OFMs
      ELSE IF (OPER.EQ.'STRETCH') THEN
         MX = RPOS(1)
         MY = RPOS(2)
         LX = WINDTV(3) - WINDTV(1) + 1
         LY = WINDTV(4) - WINDTV(2) + 1
C                                        instructions
         MSGTXT = 'Use the cursor to modify the OFM LUTs'
         CALL MSGWRT (1)
         MSGTXT = 'Press button A to undo changes'
         CALL MSGWRT (1)
         MSGTXT = 'Press button D to exit'
         CALL MSGWRT (1)
 220     CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       read loop
 230     CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IERR)
            IF (IERR.NE.0) GO TO 980
            CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
C                                       do something
            IF (DOIT) THEN
               IF (IBUT.GE.8) THEN
                  POTERR = 0
                  GO TO 980
C                                       Revert to the input OFM.
               ELSE IF (IBUT.EQ.1) THEN
                  CALL YWINDO ('READ', WINDTV, IERR)
                  RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
                  RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2
                  MX = RPOS(1)
                  MY = RPOS(2)
                  LX = WINDTV(3) - WINDTV(1) + 1
                  LY = WINDTV(4) - WINDTV(2) + 1
                  END IF
C                                       Find new OFM
               J0 = (NLEVS * (RPOS(1)-WINDTV(1))) / LX
               FK = NLEVS / (2.0 * J0)
               DO 240 I = 2,J0
                  X = NLEVS/2 + FK * (I-J0)
                  J = X
                  OFM(I,3) = (IOFM(J+1,3)-IOFM(J,3))*(X-J) + IOFM(J,3)
                  OFM(I,2) = (IOFM(J+1,2)-IOFM(J,2))*(X-J) + IOFM(J,2)
                  OFM(I,1) = (IOFM(J+1,1)-IOFM(J,1))*(X-J) + IOFM(J,1)
 240              CONTINUE
               FK = NLEVS / (2.0 * (NLEVS-J0))
               DO 250 I = J0+1,NLEVS
                  X = NLEVS/2 + FK * (I-J0)
                  J = X
                  J = MIN (NLEVS-1, J)
                  OFM(I,3) = (IOFM(J+1,3)-IOFM(J,3))*(X-J) + IOFM(J,3)
                  OFM(I,2) = (IOFM(J+1,2)-IOFM(J,2))*(X-J) + IOFM(J,2)
                  OFM(I,1) = (IOFM(J+1,1)-IOFM(J,1))*(X-J) + IOFM(J,1)
 250              CONTINUE
C                                       Send to TV
               CALL OFMIO ('WRIT', N, NLEVS, F, OFM, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1040) IERR
                  CALL MSGWRT (6)
                  GO TO 980
                  END IF
               IF (IBUT.EQ.1) GO TO 220
               END IF
            GO TO 230
      ELSE
         IERR = 0
         POTERR = 19
         END IF
C                                       close down
C                                       messages on TV error
 980  IF (IERR.EQ.0) GO TO 990
         WRITE (MSGTXT,1980) IERR
         CALL MSGWRT (7)
C                                       error management
 990  IERR = POTERR
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('OFMMOD:: ERROR',I3,' UPDATING THE OFM LUTS')
 1100 FORMAT (I4.3)
 1120 FORMAT ('Enter lower and upper input intensity values, 0-',I4,
     *   ' (2 I)')
 1121 FORMAT ('Enter ',A,' output values at lower and upper input ',
     *   'levels, 0-',I4,' (2 I)')
 1122 FORMAT ('TERMINAL ERROR',I6)
 1130 FORMAT (8X,'Input range',4X,'Output blue',3X,'Output green',5X,
     *   'Output red')
 1140 FORMAT (I4,4(3X,I5,' :',I5))
 1145 FORMAT ('Enter segment number to be undone: 1 thru',I4)
 1146 FORMAT ('SEGMENT',I5,' OUTSIDE RANGE 1 -',I4,' NOTHING UNDONE')
 1980 FORMAT ('TV ACTION ERROR CODE',I5,' RETURNED')
      END

      SUBROUTINE ISORT (N, IA)
C-----------------------------------------------------------------------
C! sorts a list of integers into ascending order
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ISORT returns a pointer to the location in a large array at which a
C   given smaller array begins.  NOTE: do not use Hollerith.
C   Inputs:
C      N     I       number words in smaller array
C   In/Out:
C      IA    I(N)    array to sort
C-----------------------------------------------------------------------
      INTEGER   N, IA(*)
C
      INTEGER   I, J, ITEMP, II, JJ
C-----------------------------------------------------------------------
C                                       Elements to sort
      IF (N.GT.1) THEN
C                                       compare all elements in array
         II = N - 1
         DO 20 I = 1,II
C                                       with all other elements
            JJ = I + 1
            DO 10 J = JJ,N
C                                       if bigger switch
               IF (IA(I).GT.IA(J)) THEN
                  ITEMP = IA(I)
                  IA(I) = IA(J)
                  IA(J) = ITEMP
                  END IF
 10            CONTINUE
 20         CONTINUE
C                                       End if elements
         END IF
C
 999  RETURN
      END

      SUBROUTINE ATTAB (OPCODE, BUFFER, NUMBND, IERR)
C-----------------------------------------------------------------------
C! I/O to array geometry tables (following initialization by ATINI)
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2006, 2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to array geometry tables. Usually used after setup by
C   ATINI.
C   Inputs:
C      OPCODE   C*4        Operation code:
C                          'READ' = read entry from table.
C                          'WRIT' = write entry in table.
C                          'CLOS' = close file, flush on write
C      BUFFER   I(*)       I/O buffer and related storage, also defines
C                          file if open. Should have been returned by
C                          ATINI.
C      IATRNO   I          Next scan number to read or write.
C      ATKOLS   I(MAXATC)  The column pointer array in order:
C                          TIME, TIME INTERVAL, ANNAME, ANTENNA NO.,
C                          ARRAY, FREQID, NO_LEVELS, POLTYA, POLAA,
C                          POLCALA, POLTYB, POLAB, POLCALB.
C      ATNUMV   I(MAXATC)  Element count in each column.
C      NOPCAL   I          # polzn cal. constants
C      NUMBND   I          # band's (IF's) in data
C   Input/output: (written to or read from antenna file)
C      TIME     D          Time of centre of interval since 0hr on
C                          reference day (days)
C      TINT     R          Interval over which calibration constants
C                          apply (days)
C      ANNAME   C*8        Station name
C      NOSTA    I          Station number
C      IARRAY   I          Array number
C      IFQID    I          Freq ID number
C      NOLEVL   I          # levels in the digitizer at the antenna,
C                          VLBA 2 or 4, MkII/MkIII 2
C      POLTYA   C*1        Feed A polzn type ('R','L','X','Y')
C      POLAA    R(MAXIF)   Feed A posn angle (degrees)
C      POLCA    R(2*MAXIF) Feed A polzn cal parameter
C      POLTYB   C*1        Feed B polzn type ('R','L','X','Y')
C      POLAB    R(MAXIF)   Feed B posn angle (degrees)
C      POLCB    R(2*MAXIF) Feed B polzn cal parameter
C   Output:
C      IATRNO   I          Next row number.
C      IERR     I          Error code, 0=>OK else TABIO error.
C                          Note: -1=> read but record deselected.
C   Usage NOTE: use the include 'DATV.INC' for the declarations in
C   ATINI and ATTAB.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DGLB.INC'
      CHARACTER OPCODE*4
      INTEGER   BUFFER(*), IERR, NUMBND
C
      LOGICAL   DOREAD, DOCLOS
      INTEGER   NCOPY, I
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DATV.INC'
      INTEGER   RECI(MAXREC)
      HOLLERITH RECH(MAXREC)
      REAL      RECORD(MAXREC)
      DOUBLE PRECISION RECD(MAXRCD)
      EQUIVALENCE (RECD, RECORD, RECI, RECH)
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
      DOCLOS = OPCODE.EQ.'CLOS'
C                                       Branch for CLOS
      IF (DOCLOS) GO TO 800
C                                       If write fill RECORD
      IF (.NOT.DOREAD) THEN
C                                       Time
         RECD(ATKOLS(KTIM)) = TIME
C                                       Interval
         RECORD(ATKOLS(KINT)) = TINT
C                                       Antenna name
         CALL CHR2H (8, ANNAME, 1, RECH(ATKOLS(KANN)))
C                                       Antenna number
         RECI(ATKOLS(KANO)) = NOSTA
C                                       Array number
         RECI(ATKOLS(KARR)) = IARRAY
C                                       Freqid number
         RECI(ATKOLS(KFRE)) = IFQID
C                                       Number of levels
         RECI(ATKOLS(KNLV)) = NOLEVL
C                                       Feed A polzn type
         CALL CHR2H (1, POLTYA, 1, RECH(ATKOLS(KTYA)))
C                                       Feed B polzn type
         CALL CHR2H (1, POLTYB, 1, RECH(ATKOLS(KTYB)))
C                                       IF & NOPCAL dependent arrays
         NCOPY = ATNUMV(KPAA)
         CALL RCOPY (NCOPY, POLAA, RECORD(ATKOLS(KPAA)))
         NCOPY = ATNUMV(KPAB)
         CALL RCOPY (NCOPY, POLAB, RECORD(ATKOLS(KPAB)))
         DO 10 I = 1,NUMBND
            IF (NOPCAL.GE.1) THEN
               RECORD(ATKOLS(KCLA)+I-1) = POLCA(I,1)
               RECORD(ATKOLS(KCLB)+I-1) = POLCB(I,1)
               END IF
            IF (NOPCAL.GE.2) THEN
               RECORD(ATKOLS(KCLA)+I)   = POLCA(I,2)
               RECORD(ATKOLS(KCLB)+I)   = POLCB(I,2)
               END IF
 10         CONTINUE
         NCOPY = ATNUMV(KFWH)
         CALL RCOPY (NCOPY, ANTFWH, RECORD(ATKOLS(KFWH)))
         END IF
C                                       Process record.
 50   CALL TABIO (OPCODE, 0, IATRNO, RECORD, BUFFER, IERR)
      IATRNO = IATRNO + 1
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABIO', 'ATTAB', IERR)
         GO TO 990
         END IF
      IF (IERR.LT.0) GO TO 50
C                                       If READ pick data from RECORD.
      IF (DOREAD) THEN
C                                       Time
         TIME = RECD(ATKOLS(KTIM))
C                                       Interval
         TINT = RECORD(ATKOLS(KINT))
C                                       Antenna name
         CALL H2CHR (8, 1, RECH(ATKOLS(KANN)), ANNAME)
C                                       Antenna number
         NOSTA = RECI(ATKOLS(KANO))
C                                       Array number
         IARRAY = RECI(ATKOLS(KARR))
C                                       Freqid number
         IFQID = RECI(ATKOLS(KFRE))
C                                       Number of levels
         NOLEVL = RECI(ATKOLS(KNLV))
C                                       Feed A polzn type
         CALL H2CHR (1, 1, RECH(ATKOLS(KTYA)), POLTYA)
C                                       Feed B polzn type
         CALL H2CHR (1, 1, RECH(ATKOLS(KTYB)), POLTYB)
C                                       IF & NOPCAL dependent arrays
         NCOPY = ATNUMV(KPAA)
         CALL RCOPY (NCOPY, RECORD(ATKOLS(KPAA)), POLAA)
         NCOPY = ATNUMV(KPAB)
         CALL RCOPY (NCOPY, RECORD(ATKOLS(KPAB)), POLAB)
         DO 60 I = 1,NUMBND
            IF (NOPCAL.GE.1) THEN
               POLCA(I,1) = RECORD(ATKOLS(KCLA)+I-1)
               POLCB(I,1) = RECORD(ATKOLS(KCLB)+I-1)
               END IF
            IF (NOPCAL.GE.2) THEN
               POLCA(I,2) = RECORD(ATKOLS(KCLA)+I)
               POLCB(I,2) = RECORD(ATKOLS(KCLB)+I)
               END IF
 60         CONTINUE
         NCOPY = ATNUMV(KFWH)
         IF (NCOPY.GT.0) THEN
            CALL RCOPY (NCOPY, RECORD(ATKOLS(KFWH)), ANTFWH)
         ELSE
            CALL RFILL (NOBAND, 0.0, ANTFWH)
            END IF
         END IF
         GO TO 999
C                                       Close
 800  CALL TABIO ('CLOS', 0, IATRNO, RECORD, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'ATTAB', IERR)
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1800) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1800 FORMAT ('ATTAB: TABIO ERROR',I5)
      END

      SUBROUTINE DOPLR (RA, DEC, NYR, NDAY, UT, X, Y, Z,
     *     VSUN, VT)
C-----------------------------------------------------------------------
C! Doppler velocity calculations
C# Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  Routine DOPLR calculates the velocity component of the observer
C  with respect to the local standard of rest as projected onto
C  a line specified by the right ascension and declination (epoch=
C  date) for a specified time.
C  The location of the observer is specified by the geocentric
C  coordinates X, Y and Z (in metres)
C
C  This version of dop takes into account components of the observer's
C  motion due to the rotation of the earth, the revolution of the
C  earth-moon barycenter about the sun, and the motion of the earth's
C  centre about the earth-moon barycenter.  The perturbations of the
C  earth's orbit due to planets are neglected.  The absolute precision
C  of this version of dop is about 0.004 km/sec, but since the dominant
C  error term is slowly varying the relative error will be considerably
C  less for times up to a week or so.
C
C  The routine omits the planetary perturbations on the earth's orbit.
C  They amount to about 0.003 km/sec and are thought to be the largest
C  contribution to the error in the velocity.
C  Inputs:
C    RA             D           Right Ascension of date (radians)
C    DEC            D           Declination of date (radians)
C    NYR            I           Year of observation
C    NDAY           I           Day number of observation
C    UT             D           UT of datum (days)
C    X,Y,Z          D           Geocentric station coords. (metres)
C
C  Outputs:
C    VSUN           D           The component of the sun's motion
C                               with respect to the lsr as projected
C                               onto the line of sight to the source.
C                               (m/s)
C    VT             D           The total velocity component ditto
C                               (m/s)
C-----------------------------------------------------------------------
      INTEGER    NYR, NDAY, JULDA
      INCLUDE 'INCS:PSTD.INC'
      DOUBLE PRECISION   ZRO, AAA, DD, DELA, DELDD, XO, YO, ZO,
     *         RA, DEC, UT, LONG, VSUN, VT, RA1, PIE,
     *         CC, CS, S, CAT, WLONG, DU, TU, UTDA, SMD, T,
     *         START, C1, GST, XLST, RHO, VRHO, DLAT, VOBS,
     *         AM, E, AI, VS, XLAM, ALAM, AA, AN, HOP,
     *         V, OMGA, OMGAR, AMON, GAMP, PIM, EM, OLAMM,
     *         AIM, AMM, VSM, ALAMM, ANM, AAM, HOPM, VMON,
     *         BETA, DC, ALONG, ALGM, BETAM, X, Y, Z
C-----------------------------------------------------------------------
C                                      Vel of Sun wrt lsr is
C                                      20 km/s towards RA 18 hrs
C                                      Dec +30 deg
      ZRO = 0.D0
      AAA = 18.D0 * PI / 12.D0
      DD  = 30.D0 * PI / 180.D0
C                                      precesses this direction
C                                      to date
      CALL RDMOVE( 1900, NYR, 1, NDAY, AAA, DD, DELA, DELDD, DC)
      AAA = AAA + DELA
      DD = DD + DELDD
C                                      this velocity is converted
C                                      to cartesian components
      XO = 20.D0 * COS(AAA) * COS(DD)
      YO = 20.D0 * SIN(AAA) * COS(DD)
      ZO = 20.D0 * SIN(DD)
C                                      ra1 = RA in days
      RA1 = (RA * (12.D0 / PI) ) / 24.D0
C                                      CC, CS, and S are
C                                      the direction cosines
C                                      corresponding to ra and dec
      CC = COS(DEC) * COS(RA)
      CS = COS(DEC) * SIN(RA)
      S = SIN(DEC)
C                                      VSUN is the projection onto
C                                      the line of sight to the
C                                      star of the sun's motion wrt
C                                      to the lsr (km/sec)
      VSUN = -XO * CC - YO * CS - ZO * S
C
C                                      determine geodetic lat & long.
      IF ((X.EQ.0.D0) .AND. (Y.EQ.0.D0) .AND. (Z.EQ.0.D0)) THEN
         CAT = 0.D0
         LONG = 0.D0
      ELSE
         CALL GEODLL (X, Y, Z, CAT, LONG)
         END IF
      WLONG = LONG / (2.D0 * PI)
C                                      Time calculations
C                                      The epoch is 1900 jan 0.5 UT
C                                       = julian day 2415020.0
C                                      DU is the time from epoch
C                                      to jan 0.0 of the current year
C                                      (days)
      DU = (JULDA(NYR) - 2415020) - 0.5D0
C                                      TU is DU converted to julian
C                                      centuries
      TU = DU / 36525.0D0
C                                      UTDA is the gmt from
C                                      jan 0.0 to the present (days)
      UTDA = NDAY + UT
C                                      SMD is the time from the epoch
C                                      to the present (days)
      SMD = DU + UTDA
C                                      T is SMD converted to julian
C                                      centuries
      T = SMD / 36525.D0
C                                      START is the greenwich mean
C                                      sidereal time on jan 0.0 (days)
      START = (6.D0 + 38.D0 / 60.D0 + (45.836D0 + 129.1794D0 +
     *   8640184.542D0 * (TU-0.7D0) + 0.0929D0 * TU **2)
     *   / 3600.D0) / 24.D0
C                                      C1 is the conversion factor from
C                                      solar time to sidereal time
      C1 = 0.997269566414D0
C                                      GST is the greenwich mean
C                                      sidereal time (days)
      GST = START + UTDA / C1
C                                      XLST is the local mean sidereal
C                                      time (from jan 0) (days)
      XLST = GST - WLONG
      XLST = XLST - INT(XLST)
C                                      Observer's motion wrt earth's
C                                      centre
C                                      RHO is the radius vector from
C                                      the earth's center to the
C                                      observer
      RHO = SQRT (X*X + Y*Y + Z*Z)
C                                      VRHO is corresponding circular
C                                      velocity (meters/sidereal day)
      VRHO = 2.D0 * PI * RHO
C                                      converted to kilometers/sec
      VRHO = VRHO / 24.0D3 / 3600.D0 / C1
C                                      reduction of geodetic latitude
C                                      to geocentric latitude (arcsecs)
      DLAT = -(11.D0 * 60.D0 + 32.7430D0) * SIN(2.D0 * CAT)
     *   + 1.1633D0 * SIN(4.D0 * CAT) -0.0026D0 * SIN(6.D0 * CAT)
C                                      convert CAT to geocentric lat
C                                      (radians)
      CAT = CAT + DLAT * PI / 3600.D0 / 180.D0
C                                      VOBS is the projection onto the
C                                      line of sight to the star of the
C                                      velocity of the observer wrt the
C                                      earth's center (km/sec)
      VOBS = VRHO * COS(CAT) * COS(DEC) *
     *   SIN(2.D0 * PI * (XLST - RA1))
C                                      Earth's orbit about sun
C                                      AM is the mean anomaly (of the
C                                      earth's orbit) (radians)
      AM = (358.47583D0 + 0.9856002670D0 * SMD-0.000150D0 * T**2 -
     *   0.000003D0 * T**3) * PI / 180.0D0
C                                      PIE is the mean longitude of
C                                      perihelion (radians)
      PIE = (101.22083D0 + 0.0000470684D0 * SMD + 0.000453D0 * T**2 +
     *   0.000003D0 * T**3) * PI / 180.0D0
C                                      E is the eccentricity of
C                                      the orbit (dimensionless)
      E = 0.01675104D0 - 0.00004180D0 * T - 0.000000126D0 * T**2
C                                      AI is the mean obliquity
C                                      of the ecliptic (radians)
      AI = (23.452294D0 - 0.0130125D0 * T - 0.00000164D0 * T**2 +
     *   0.000000503D0 * T**3) * PI / 180.0D0
C                                      VS is the true anomaly
C                                      (approximate formula) (radians)
      VS = AM + (2.D0 * E - 0.25D0 * E**3) * SIN(AM) + 1.25D0
     *   * E**2 * SIN(2.D0 * AM) + 13.D0 / 12.D0 * E**3
     *   * SIN(3.D0 * AM)
C                                      XLAM is the true longitude
C                                      of the earth as seen from
C                                      the sun (radians)
      XLAM = PIE + VS
C                                      ALAM is the true longitude
C                                      of the sun as seen from the
C                                      earth (radians)
      ALAM = XLAM + PI
C                                      BETA is the latitude of the
C                                      star (radians). ALONG is the
C                                      longitude of the star (radians)
      CALL CDTRN (ZRO, ZRO, (-PI/2.D0), (PI/2.D0 - AI),
     *   RA, DEC, ALONG, BETA)
C                                      AA is the semi-major axis of
C                                      the earth's orbit (km)
      AA = 149598500.0D0
C                                      AN is the mean angular rate
C                                      of the earth about the sun
C                                      (radians/day)
      AN = 2.D0 * PI / 365.2564D0
C                                      HOP is h/p from smart = the
C                                      component of the earth's
C                                      velocity perpendicular to the
C                                      radius vector (km/day)
      HOP = AN * AA / SQRT(1.D0 - E**2)
C                                      converted to km/sec
      HOP = HOP / 86400.D0
C                                      V is the projection onto the
C                                      line of sight to the star of
C                                      the velocity of the earth-moon
C                                      barycenter with respect to the
C                                      sun (km/sec)
      V = -HOP * COS(BETA) * (SIN(ALAM - ALONG) - E
     *   * SIN(PIE - ALONG))
C                                      Calculate moon's orbit around
C                                      the earth-moon barycentre.
C                                      OMGA is the longitude of the
C                                      mean ascending node of the lunar
C                                      pole (degrees)
      OMGA = 259.183275D0 - 0.0529539222D0 * SMD + 0.002078D0
     *   * T**2 + 0.000002D0 * T**3
C                                      OMGAR is omga in radians
      OMGAR = OMGA * PI / 180.D0
C                                      AMON is OMGA plus the mean
C                                      lunar longitude of the moon
C                                      (degrees - should be
C                                       13.1763965268)
      AMON = 270.434164D0 + 13.176396527D0 * SMD - 0.001133D0
     *   * T**2 + 0.0000019D0 * T**3
C                                      GAMP (gamma-prime) is OMGA
C                                      plus the lunar longitude of
C                                      lunar perigee
      GAMP = 334.329556D0 + 0.1114040803D0 * SMD - 0.010325D0
     *   * T**2 - 0.000012D0 * T**3
C                                      PIM is the mean lunar longitude
C                                      of lunar perigee (in radians)
      PIM = (GAMP - OMGA) * PI / 180.D0
C                                      EM is the eccentricity of the
C                                      lunar orbit
      EM = 0.054900489D0
C                                      OLAMM is the mean lunar long.
C                                      of the moon (in radians)
      OLAMM = (AMON - OMGA) * PI / 180.D0
C                                      AIM is the inclination of the
C                                      lunar orbit to the ecliptic
C                                      (radians)
      AIM = 5.1453964D0 * PI / 180.D0
C                                      AMM is the approximate mean
C                                      anomaly (radians)
      AMM = OLAMM - PIM
C                                      VSM is the true anomaly
C                                      (approx formula) (radians)
      VSM = AMM + (2.D0 * EM - 0.25D0 * EM**3) * SIN(AMM)
     *   + 1.25D0 * EM**2 * SIN(2.D0 *AMM) + 13.D0 /
     *   12.D0 * EM**3 * SIN(3.D0 * AMM)
C                                      ALAMM is the true lunar
C                                      longitude of the moon (radians)
      ALAMM = PIM + VSM
C                                      ANM is the mean angular rate of
C                                      the lunar rotation (radians/day)
      ANM = 2.D0 * PI / 27.321661D0
C                                      AAM is the semi-major axis of
C                                      the lunar obrit (kilometers)
      AAM = 60.2665D0 * 6378.388D0
C                                      BETAM is the lunar latitude of
C                                      the star (rads). ALGM is the
C                                      lunar longitude of the star.
      CALL CDTRN (OMGAR, ZRO, (OMGAR - PI / 2.0D0),
     *   (PI / 2.0D0 - AIM), ALONG, BETA, ALGM, BETAM)
C                                      HOPM is h/p from SMART = the
C                                      component of the lunar velocity
C                                      perpendicular to the radius
C                                      vector (km/day)
      HOPM = ANM * AAM / SQRT(1.D0 - EM**2)
C                                      converted to km/sec
      HOPM = HOPM / 86400.D0
C                                      VMON is the projection onto the
C                                      line of sight to the star of the
C                                      velocity of the earth's center
C                                      with respect to the earth-moon
C                                      barycenter (km/s) (the 81.30 is
C                                      the ratio of the earth's mass to
C                                      the moon's mass)
      VMON = -HOPM / 81.30D0 * COS(BETAM) * (SIN(ALAMM - ALGM)
     *   - EM * SIN(PIM - ALGM))
C
      VT = V + VSUN + VMON + VOBS
      VT = VT * 1000.D0
      VSUN = VSUN * 1000.D0
      RETURN
      END
      SUBROUTINE CDTRN (AO, BO, AP, BP, A1, B1, A2, B2)
C-----------------------------------------------------------------------
C  Routine to convert the longitude-like (A1) and latitude-like (B1)
C  coordinates of a point on a sphere into the corresponding
C  coordinates (A2,B2) in a different coordinate system that is
C  specified by the coordinates of its origin (AO, BO) and its north
C  pole (AP, BP) in the original coordinate system.
C  The range of A2 will be from -pi to pi.
C   Inputs:
C    AO            D
C    BO            D
C    AP            D
C    BP            D
C    A1            D
C    B1            D
C   Outputs:
C    A2            D
C    B2            D
C-----------------------------------------------------------------------
      DOUBLE PRECISION AO, BO, AP, BP, A1, B1, A2, B2,
     *   SBO, CBO, SBP, CBP, SB1, CB1, SB2, CB2,
     *   SAA, CAA, SBB, CBB, SA2, CA2, TA2O2
C-----------------------------------------------------------------------
      SBO = SIN(BO)
      CBO = COS(BO)
      SBP = SIN(BP)
      CBP = COS(BP)
      SB1 = SIN(B1)
      CB1 = COS(B1)
C
      SB2 = SBP * SB1 + CBP * CB1 * COS(AP - A1)
      B2 = ASIN(SB2)
      CB2 = COS(B2)
C
      SAA = SIN(AP - A1) * CB1 / CB2
      CAA = (SB1 - SB2 * SBP) / (CB2 * CBP)
C
      CBB = SBO / CBP
      SBB = SIN(AP - AO) * CBO
C
      SA2 = SAA * CBB - CAA * SBB
      CA2 = CAA * CBB + SAA * SBB
      IF (CA2.LE.0.0) THEN
         TA2O2 = (1.0D0 - CA2) / SA2
      ELSE
         TA2O2 = SA2 / (1.0D0 + CA2)
         END IF
C
      A2 = 2.D0 * ATAN(TA2O2)
C
      RETURN
      END
      SUBROUTINE RDMOVE ( NYRI, NYRF, MO, NDA, RA, D,
     *   DELR, DELD, DC )
C-----------------------------------------------------------------------
C  Routine RDMOVE calculates the corrections in RA and Dec
C  to be added to mean coordinates for epoch NYRI.
C  If the day-number is known, use it for nda and set mo=1
C  Move also calculates the equation of the equinoxes (DC)
C  which may be added to the mean sidereal time to give the
C  apparent sidereal time.
C  DELR and DELD contain corrections for precession,
C  aberration, and some terms of nutation.
C  Inputs:
C    NYRI        I         Epoch of coords
C    NYRF        I         Year of observation
C    MO          I         Month of observation
C    NDA         I         Day of observation
C    RA          D         RA of epoch (rads)
C    D           D         Dec of epoch (rads)
C  Outputs:
C    DELR        D         RA correction (rads)
C    DELD        D         Dec correction (rads)
C    DC          D         Equation of the equinoxes (mins of time)
C-----------------------------------------------------------------------
      INTEGER   NYRI, NYRF, MO, NDA
      DOUBLE PRECISION    RA, D, DELR, DELD, DC, SND, CSD, TND,CSR, SNR,
     *          AL, TO, T, ZETAO, Z, THETA, AM, AN, ALAM, SNL,
     *          CSL, OMEGA, ARG, DLONG, DOBLQ
C-----------------------------------------------------------------------
      SND = SIN(D)
      CSD = COS(D)
      TND = SND / CSD
C
      CSR = COS(RA)
      SNR = SIN(RA)
C                                       AL is an approximate day number
C                                       (i.e. the number of days since
C                                       January of the year NYRF).
      AL = 30 * (MO - 1) + NDA
C                                       TO is the time from 1900 to
C                                       AYRI (centuries), t is the time
C                                       from AYRI to date (NYRF,MO,NDA)
C                                       (centuries) (365.2421988 is the
C                                       number of ephemeris days in a
C                                       tropical year)
      TO = (NYRI - 1900) / 100.D0
      T = ((NYRF - NYRI) + AL / 365.2421988D0) / 100.D0
C                                       ZETAO is a precessional angle
      ZETAO = (2304.250D0 + 1.396D0 * TO) * T + 0.302D0
     *   * T**2 + 0.018D0 * T**3
C                                       ditto for z
      Z = ZETAO + 0.791D0 * T**2
C                                       and theta
      THETA = (2004.682D0 - 0.853D0 * TO) * T - 0.426D0
     *   * T**2 - 0.042D0 * T**3
C                                       AM and AN are the M and N
C                                       precessional numbers
      AM = (ZETAO + Z) * 4.848136811D-6
      AN = THETA * 4.848136811D-6
C                                       ALAM is an approximate mean
C                                       longitude for sun (radians)
      ALAM = (0.985647D0 * AL + 278.5D0) * 0.0174532925D0
      SNL = SIN(ALAM)
      CSL = COS(ALAM)
C                                       DELR is the annual aberration
C                                       term in RA (radians)
      DELR = -9.92413605D-5 * (SNL * SNR + 0.91745051D0
     *   * CSL * CSR) / CSD
C                                       plus precession terms
     *   + AM + AN * SNR * TND
C                                       DELD is ditto above in dec
      DELD = -9.92413605D-5 * (SNL * CSR * SND - 0.91745051D0
     *   * CSL * SNR * SND + 0.39784993D0 * CSL * CSD) + AN * CSR
C                                       calculate the nutation (approx)
C                                       omega is the angle of the
C                                       first term of nutation
      OMEGA = 259.183275D0 - 1934.142D0 * ( TO + T )
C                                       arg is omega converted to rads
      ARG = OMEGA * 0.0174532925D0
C                                       dlong is the nutation in
C                                       longitude (delta-psi) (radians)
      DLONG = -8.3597D-5 * SIN(ARG)
C                                       doblq is the nutation in
C                                       obliquity (delta-epsilon) (rads)
      DOBLQ = 4.4678D-5 * COS(ARG)
C                                       add nutation in ra into delr
      DELR = DELR + DLONG * ( 0.91745051D0 + 0.39784993D0
     *   * SNR * TND ) - CSR * TND * DOBLQ
C                                        and dec.
      DELD = DELD + 0.39784993D0 * CSR * DLONG + SNR * DOBLQ
C                                        dc is the equation of the
C                                        equinoxes (minutes of time)
      DC = DLONG * 210.264169D0
      RETURN
      END
      INTEGER FUNCTION JULDA (NYR)
C-----------------------------------------------------------------------
C   This function computes the Julian day number at 12 hrs ut on
C   January 0 of the year NYR (Gregorian calendar). Julda is an
C   integer because of this definition.  For example,
C   JULDA = 2439856 for NYR = 1968.
C
C   Inputs:
C    NYR          I         Year
C   Outputs:
C    JULDA        I         Julian day (as above)
C-----------------------------------------------------------------------
      INTEGER    NYR, NYRM1, IC
C-----------------------------------------------------------------------
      NYRM1 = NYR-1
      IC = NYRM1/100
      JULDA = 1721425 + 365 * NYRM1 + NYRM1 / 4 - IC + IC / 4
      RETURN
      END

      SUBROUTINE MAKTAB (SRTORD, VOL, CNO, VER, CATBLK, LUN, DATP,
     *   IBLK, IERR)
C-----------------------------------------------------------------------
C! Create and initialize table from data in common /TABHDR/ (FITS)
C# EXT-util FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1999, 2016, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  This routine will create a table file and initialize the header
C  values of the table from the data in common TABHDR
C  Inputs:
C     SRTORD    I     Logical column sorted on. 0=unknown, LT 0 = desc.
C     VOL       I     Disk volume number of parent file.
C     CNO       I     Catalog number of parent file.
C     VER       I     Version number of table file. 0=use latest + 1.
C     CATBLK    I(256)   Catalog header of parent file.
C     LUN       I     Logical unit number to open table file.
C  Output:
C     DATP      I(128,2)   Data pointers used in table file control.
C     IBLK      I(512)     IO buffer for table file.
C     IERR      I          Error code.: -1 => FILE WAS CREATED
C-----------------------------------------------------------------------
      INTEGER   SRTORD, VOL, CNO, VER, CATBLK(256), LUN, DATP(128,2),
     *   IBLK(*), IERR, IRNO, TITLES, UNITS, I, NREC, TTCODE(128),
     *   ITEMP(6)
      HOLLERITH HSTRNG(6)
      EQUIVALENCE (HSTRNG, ITEMP)
      INCLUDE 'INCS:DEHD.INC'
      INCLUDE 'INCS:DTHD.INC'
      DATA TITLES, UNITS /3,4/
C-----------------------------------------------------------------------
C                                       Zero out control block.
      CALL FILL (256, 0, DATP)
C                                       Ensure small integer data
C                                       types don't get transferred
C                                       to output table type array
      CALL FILL (128, 0, TTCODE)
      DO 10 I = 1, ITNCOL
         TTCODE(I) = TFCODE(I)
         IF (MOD(TFCODE(I),10).EQ.6) THEN
            TTCODE(I) = TFCODE(I) - 2
            END IF
 10      CONTINUE
      CALL COPY (ITNCOL, TTCODE, DATP(1,2))
C                                       create/open
      NREC = MIN (NAXISI(2), 5000)
      CALL TABINI ('WRIT', ITYPE, VOL, CNO, VER, CATBLK, LUN, ITANKY,
     *   NREC, ITNCOL, DATP, IBLK, IERR)
      IF (IERR.EQ.-1) THEN
C                                       Write column values
         DO 30 I = 1,ITNCOL
            IRNO = I
C                                       Write column titles.
            CALL CHR2H (24, TTYPE(I), 1, ITEMP)
            CALL TABIO ('WRIT', TITLES, IRNO, ITEMP, IBLK, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       write units
            CALL CHR2H (8, TUNIT(I), 1, ITEMP)
            CALL TABIO ('WRIT', UNITS, IRNO, ITEMP, IBLK, IERR)
            IF (IERR.NE.0) GO TO 999
 30         CONTINUE
C                                       sort order
         IBLK(43) = SRTORD
C                                       table title
         CALL CHR2H (24, EXTNAM, 1, IBLK(101))
         IERR = -1
         END IF
C
 999  RETURN
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QMAKMS (A, I, C, B, J, N, COUNT)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Make mask depending on vector, scalar comparison.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Makes a mask from a vector depending on a comparison
C   of the vector A and scalar C.
C             B(k) = 1.0  if A(k) < C
C             B(k) = 0.0  If A(k) >= C   k = 1,N
C  Inputs:
C     A      I  Source vector base address
C     I      I  Increment of A
C     C      I  Address of scalar.
C     B      I  Destination vector base address.
C     J      I  Increment of B
C     N      I  Element count
C     COUNT  I  Address of count of number of times A(k)>=C.
C-----------------------------------------------------------------------
      INTEGER   A, I, C, B, J, N, COUNT, JA, JC, JB, JN, JCNT, LOOP
      REAL      XCNT
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Addresses to 1-rel.
      JA = A + 1
      JB = B + 1
      JC = C + 1
      JCNT = COUNT + 1
C                                        Initilize count
      XCNT = 0.0
C                                        Loop
C@DIR IGNORE RECRDEPS(APCORE)
      DO 100 LOOP = 1,N
         APCORE(JB) = 0.0
         IF (APCORE(JA).GT.APCORE(JC)) XCNT = XCNT + 1.0
C                                       Update pointers
         JA = JA + I
         JB = JB + J
 100     CONTINUE
C                                       Store count
      APCORE(JCNT) = XCNT
C
 999  RETURN
      END

LOCAL INCLUDE 'SWPAN.INC'
C                                       Local include for SWPOL
C                                       Describes the antennas to be
C                                       swapped.
C
C   INCLUD      L      See description of NANT below
C   ANTENS      I(50)  List of antennae (all entries from 1 to NANT are
C                      positive
C   NANT        I      Number of antennae in list. If NANT = 0 then all
C                      polarizations are swapped for all antennae,
C                      otherwise only antennae in the list are swapped
C                      if INCLUD is .TRUE.; if INCLUD is .FALSE. then
C                      all antennae except those in the list are swapped
C   SUBARR      I      Subarray number to process
C
      LOGICAL   INCLUD
      INTEGER   ANTENS(50), NANT, SUBARR
C
      COMMON /SWPANT/ INCLUD, ANTENS, NANT, SUBARR
C                                       End of local include SWPAN.INC
LOCAL END
LOCAL INCLUDE 'SWPFL.INC'
C                                       Local include for SWPOL
C                                       Contains the input and output
C                                       file specifications for SWPOL
C
C     INNAME      C*12      Input file name (name)
C     INCLAS      C*6       Input file name (class)
C     INSEQ       I         Input file name (sequence number)
C     INDISK      I         Input file disk number
C     INCNO       I         Input file catalogue number
C     OUTNAM      C*12      Output file name (name)
C     OUTCLS      C*6       Output file name (class)
C     OUTSEQ      I         Output file name (sequence number)
C     OUTDSK      I         Output file disk number
C     OUTCNO      I         Output file catalogue number
C
      CHARACTER INNAME*12, INCLAS*6, OUTNAM*12, OUTCLS*6, TASWAP(50)*2
      INTEGER   INSEQ, INDISK, INCNO, OUTSEQ, OUTDSK, OUTCNO, NSWAPD
C
      COMMON /SWPFCH/ INNAME, INCLAS, OUTNAM, OUTCLS, TASWAP
      COMMON /SWPFNM/ INSEQ, INDISK, INCNO, OUTSEQ, OUTDSK, OUTCNO,
     *   NSWAPD
C                                       End of local include SWPFL
LOCAL END
LOCAL INCLUDE 'SWPIO.INC'
C                                       Local include for SWPOL.
C                                       Define variables required by
C                                       SWPOL's I/O operations.
C
C   INLUN        I         Local unit number for input file (constant)
C   OUTLUN       I         Local unit number for output file (constant)
C   IFIND        I         FTAB index for input file (initialised by
C                          INITIO)
C   OFIND        I         FTAB index for output file (initialised by
C                          INITIO)
C   LBUFF        I         Length of I/O buffers in words (constant)
C   IBUFF        R(LBUFF)  Input buffer
C   OBUFF        R(LBUFF)  Output buffer
C   NIO          I         Number of visibilities in input buffer
C                          (modified by RDVIS)
C   IBIND        I         Index of start of first visibility in input
C                          buffer (may be modified by RDVIS)
C   OBIND        I         Index of start of first visibility in ouput
C                          buffer
C   VISNO        I         Number of visibility in input buffer
C                          (1 <= VISNO <= NIO) currently being processed
C                          (modified by RDVIS)
C   ILOCWT       I         Offset of WEIGHT from beginning of random
C                          parameters if data are compressed; a negative
C                          number if data are not compressed
C                          (initialised by INITIO; ILOCWT < NRPARM)
C
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   INLUN, OUTLUN, CATOLD(256)
      PARAMETER (INLUN = 16, OUTLUN = 17)
      INTEGER   IFIND, OFIND, NIO, IBIND, OBIND, VISNO, ILOCWT
      REAL      IBUFF(UVBFSS), OBUFF(UVBFSS), XCENT, DIFPIX
      DOUBLE PRECISION UVSCAL
      COMMON    /SWPIO/ CATOLD, UVSCAL, XCENT, IFIND, OFIND, IBUFF,
     *   OBUFF, NIO, IBIND, OBIND, VISNO, ILOCWT, DIFPIX
C                                       End of local include SWPIO.INC
LOCAL END
      PROGRAM SWPOL
C-----------------------------------------------------------------------
C! Swap polarizations for designated antennae
C# UV UV-Util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2000-2001, 2008, 2013-2015, 2017, 2022-2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Swaps linear or circular polarizations for a selected subset of
C   antennae. The input data must contain one of the following
C   combinations of polarizations: (RR, LL), (RR, LL, RL, LR), (XX, YY)
C   or (XX, YY, XY, YX). In the unlikely event that the data has both
C   parallel hands but only one cross hand, the data must be mangled to
C   remove the cross hand or add the other before attempting to swap
C   polarizations.
C
C   Inputs:
C     INNAME       Input file name (name)
C     INCLASS      Input file name (class)
C     INSEQ        Input file name (sequence number)
C     INDISK       Input file disk number
C     OUTNAME      Output file name (name)
C     OUTCLASS     Output file name (class)
C     OUTSEQ       Output file name (sequence number)
C     OUTDISK      Output file disk number
C     ANTENNAS     Antenna list
C     SUBARR       Subarray number
C     DOCALIB      Swap calibration info?
C-----------------------------------------------------------------------
      INTEGER   IERR, SCRTCH(256)
      CHARACTER PRGM*6
      LOGICAL   DOCAL(2)
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'SWPAN.INC'
      INCLUDE 'SWPFL.INC'
      INCLUDE 'SWPIO.INC'
C
      PARAMETER (PRGM = 'SWPOL ')
C-----------------------------------------------------------------------
C                                       Get input parameters, initialize
C                                       commons and check input file:
      CALL SWINIT (PRGM, DOCAL, IERR)
C                                       Swap polarizations:
      IF (IERR.EQ.0) CALL SWMAIN (IERR)
C                                       Flush I/O buffers
      IF (IERR.EQ.0) CALL ENDUV (DOCAL, IERR)
C                                       Copy and update history and copy
C                                       tables:
      IF (IERR.EQ.0) CALL SWPHIS (DOCAL, IERR)
C                                       Close down:
      CALL DIE (IERR, SCRTCH)
C
      STOP
      END
      SUBROUTINE SWINIT (PRGM, DOCAL, IRET)
C-----------------------------------------------------------------------
C   Initialize AIPS COMMONs and COMMON blocks in local includes; get
C   inputs; open files and check input file for suitability. The
C   polarizations should correspond to one of (RR, LL), (XX, YY)
C   (RR, LL, RL, LR) or (XX, YY, XY, YX) and the fastest varying
C   visibility axis should be the complex axis.
C
C   Input:
C     PRGM    C*6     Program name
C
C   Output:
C     DOCAL   L       .TRUE. if calibration information is to be
C                     swapped, .FALSE. otherwise
C     IRET    I       Return status: 0 -> OK
C                                    1 -> error reading inputs
C                                    2 -> error opening files
C                                    3 -> bad input file
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      LOGICAL   DOCAL(2)
      INTEGER   IRET
C
C   Local variables:
C     NSUBAR   I          Number of subarrays in this data set.
C
C   Variables in /INPARM/ provide temporary storage for POPS adverbs.
C     NPARM    I          Size of adverb list (constant)
C
      INTEGER   NSUBAR, SCRTCH(256), NPARM, I, J, IERR
      LOGICAL   FOUND
      HOLLERITH XINNAM(3), XINCLS(2), XOUTNM(3), XOUTCL(2)
      REAL      XINSEQ, XINDSK, XOUTSQ, XOUTDS, XANT(50), XSUBAR,
     *   XDOCAL, XDOTAB, DOCENT
      PARAMETER (NPARM = 68)
C
      COMMON /INPARM/ XINNAM, XINCLS, XINSEQ, XINDSK, XOUTNM, XOUTCL,
     *   XOUTSQ, XOUTDS, XANT, XSUBAR, XDOCAL, XDOTAB, DOCENT
C
      INCLUDE 'SWPAN.INC'
      INCLUDE 'SWPFL.INC'
      INCLUDE 'SWPIO.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       Initialize AIPS COMMONs:
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NSCR = 0
      NCFILE = 0
C                                       Get input adverbs:
      CALL GTPARM (PRGM, NPARM, RQUICK, XINNAM, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.1) THEN
            WRITE (MSGTXT, 1000) IERR
            CALL MSGWRT (8)
            CALL RELPOP (1, SCRTCH, IERR)
            END IF
         IRET = 1
         GO TO 999
         END IF
C                                       Restart AIPS if requested:
      IF (RQUICK)
     *      CALL RELPOP (0, SCRTCH, IERR)
C                                       Read filenames:
      CALL H2CHR (12, 1, XINNAM, INNAME)
      CALL H2CHR (6, 1, XINCLS, INCLAS)
      INSEQ = NINT (XINSEQ)
      INDISK = NINT (XINDSK)
      CALL H2CHR (12, 1, XOUTNM, OUTNAM)
      CALL H2CHR (6, 1, XOUTCL, OUTCLS)
      OUTSEQ = NINT (XOUTSQ)
      OUTDSK = NINT (XOUTDS)
      XCENT = DOCENT
C                                       Open files and initialize I/O:
      CALL INITIO (IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1001) IERR
         CALL MSGWRT (8)
         IRET = 2
         GO TO 999
         END IF
C                                       Process antennas adverb:
      NANT = 0
      INCLUD = .TRUE.
      DO 20 I = 1, 50
         IF (ABS (NINT (XANT(I))).GT.0) THEN
            IF (NINT (XANT(I)) .LT. 0)
     *         INCLUD = .FALSE.
C                                       Check whether the current
C                                       antenna is already in the list:
            FOUND = .FALSE.
            J = 0
 10         IF ((J.NE.NANT) .AND. (.NOT.FOUND)) THEN
               J = J + 1
               IF (ABS (NINT (XANT(I))).EQ.ANTENS(J))
     *            FOUND = .TRUE.
               GO TO 10
               END IF
            IF (.NOT.FOUND) THEN
               NANT = NANT + 1
               ANTENS(NANT) = ABS (NINT (XANT(I)))
               END IF
            END IF
 20      CONTINUE
C                                       Process SUBARRAY adverb:
      CALL FNDEXT ('AN', CATBLK, NSUBAR)
      SUBARR = MAX (1, MIN (NINT (XSUBAR), NSUBAR))
C                                       Process DOCAL adverb:
      DOCAL(1) = XDOCAL.GE.0.0
      DOCAL(2) = XDOTAB.GE.0.0
C                                       Check axis number of complex
C                                       axis:
      IF (JLOCC.NE.0) THEN
         WRITE (MSGTXT, 1020)
         CALL MSGWRT (8)
         IRET = 3
         GO TO 999
         END IF
C                                       Check number of polarizations:
      IF ((CATBLK(KINAX+JLOCS).NE.2) .AND.
     *   (CATBLK(KINAX+JLOCS).NE.4)) THEN
         WRITE (MSGTXT, 1021)
         CALL MSGWRT (8)
         IRET = 3
         GO TO 999
         END IF
C                                       Check first Stokes parameter
C                                       (must be RR or XX)
      IF ((NINT(CATD(KDCRV+JLOCS)).NE.-1) .AND.
     *   (NINT(CATD(KDCRV+JLOCS)).NE.-5)) THEN
         WRITE (MSGTXT, 1022)
         CALL MSGWRT (8)
         IRET = 3
         GO TO 999
         END IF
C                                       Check Stokes axis increment:
      IF (NINT(CATR(KRCIC+JLOCS)).NE.-1) THEN
         WRITE (MSGTXT, 1022)
         CALL MSGWRT (8)
         IRET = 3
         GO TO 999
         END IF
C
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SWINIT: ERROR ', I1, ' READING INPUT PARAMETERS')
 1001 FORMAT ('SWINIT: ERROR ', I1, ' INITIALIZING I/O')
 1020 FORMAT ('COMPLEX AXIS MUST BE AXIS ONE --- ABORTING')
 1021 FORMAT ('MUST BE EITHER 2 OR 4 POLARIZATIONS PRESENT --- ',
     *   'ABORTING')
 1022 FORMAT ('POLARIZATIONS INCOMPLETE OR MIXED --- ABORTING')
      END
      SUBROUTINE INITIO (IRET)
C-----------------------------------------------------------------------
C   Open input file, create output file and initialise I/O. Uses file
C   names from SWPFL.INC and sets up I/O buffers in SWPIO.INC.
C
C   Output:
C     IRET      I         Return status: 0 -> OK
C                                        1 -> error opening input file
C                                        2 -> error creating output file
C                                        3 -> error initializing input
C                                        4 -> error initializing output
C-----------------------------------------------------------------------
      INTEGER   IRET
C
C   Local variables:
C     PTYPE      C*2      Physical type of file
C     STAT       C*4      File status
C     IFILE      C*48     Input file physical name
C     OFILE      C*48     Output file physical name
C     BO         I        Block offset to begin I/O transfer from (1)
C     VO         I        Offset of first vis. rec from BO (0)
C     NPIO       I        Number of visibilities to transfer in one I/O
C                         operation (calculated by first call to UVINIT)
C
      INTEGER   BO, VO, NPIO, IERR, I, SCRTCH(256), INCX
      CHARACTER PTYPE*2, STAT*4, IFILE*48, OFILE*48, CTEMP*8
      PARAMETER (BO = 1, VO = 0)
C
      INCLUDE 'SWPFL.INC'
      INCLUDE 'SWPIO.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       Find the input file and read its
C                                       CATBLK:
      INCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', INDISK, INCNO, INNAME, INCLAS, INSEQ, PTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1000) IERR, INNAME, INCLAS, INSEQ, INDISK,
     *      NLUSER
         CALL MSGWRT (8)
         IRET = 1
         GO TO 999
         END IF
      CALL CATIO ('READ', INDISK, INCNO, CATBLK, 'REST', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1001) IERR
         CALL MSGWRT (8)
         IRET = 1
         GO TO 999
         END IF
      CALL COPY (256, CATBLK, CATOLD)
C                                       Define pointers into CATBLK:
      CALL UVPGET (IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         GO TO 999
         END IF
C                                       center frequencies
      IF (JLOCF.LT.0) XCENT = -1.
      IF (XCENT.LE.0.0) THEN
         UVSCAL = 1.0D0
         DIFPIX = 0.0
      ELSE
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
         UVSCAL = CATD(KDCRV+JLOCF) / FREQ
         END IF
C                                       Make output name and store it in
C                                       CATBLK for the output file:
      CALL MAKOUT (INNAME, INCLAS, INSEQ, ' ', OUTNAM, OUTCLS, OUTSEQ)
      CALL CHR2H (12, OUTNAM, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, OUTCLS, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = OUTSEQ
C                                       Create output file and mark it
C                                       in files common:
      OUTCNO = 1
      FRW(NCFILE) = 3
      CALL UVCREA (OUTDSK, OUTCNO, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1002) IERR
         CALL MSGWRT (8)
         IRET = 2
         GO TO 999
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = OUTDSK
      FCNO(NCFILE) = OUTCNO
      FRW(NCFILE) = 2
C                                       copy keywords
      CALL KEYCOP (INDISK, INCNO, OUTDSK, OUTCNO, IERR)
C                                       Mark input file as READ:
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', INDISK, INCNO, INNAME, INCLAS, INSEQ, PTYPE,
     *   NLUSER, 'READ', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1003) IERR
         CALL MSGWRT (8)
         IRET = 1
         GO TO 999
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = INDISK
      FCNO(NCFILE) = INCNO
      FRW(NCFILE) = 0
C                                       Open and initialize input file
C                                       for reading:
      CALL ZPHFIL ('UV', INDISK, INCNO, 1, IFILE, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1004) IERR
         CALL MSGWRT (8)
         IRET = 1
         GO TO 999
         END IF
      CALL ZOPEN (INLUN, IFIND, INDISK, IFILE, .TRUE., .FALSE., .FALSE.,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1005) IERR
         CALL MSGWRT (8)
         IRET = 1
         GO TO 999
         END IF
      NPIO = 0
      CALL UVINIT ('READ', INLUN, IFIND, NVIS, VO, LREC, NPIO,
     *   2*UVBFSS, IBUFF, BO, IBIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1006) IERR
         CALL MSGWRT (8)
         IRET = 3
         GO TO 999
         END IF
C                                       Open and initialise output file
C                                       for writing:
      CALL ZPHFIL ('UV', OUTDSK, OUTCNO, 1, OFILE, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1007) IERR
         CALL MSGWRT (8)
         IRET = 2
         GO TO 999
         END IF
      CALL ZOPEN (OUTLUN, OFIND, OUTDSK, OFILE, .TRUE., .FALSE.,
     *   .FALSE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1008) IERR
         CALL MSGWRT (8)
         IRET = 2
         GO TO 999
         END IF
      CALL UVINIT ('WRIT', OUTLUN, OFIND, NVIS, VO, LREC, NPIO,
     *   2*UVBFSS, OBUFF, BO, OBIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1009) IERR
         CALL MSGWRT (8)
         IRET = 4
         GO TO 999
         END IF
C                                       Establish the definitions of
C                                       NIO, VISNO and ILOCWT in
C                                       SWPIO.INC:
      NIO = 0
      VISNO = 0
      ILOCWT = -1
C                                       If data is compressed find the
C                                       offset of the WEIGHT parameter:
      IF (CATBLK(KINAX).EQ.1) THEN
         I = 0
 10      IF ((I.NE.KIPTPN).AND.(ILOCWT.EQ.-1)) THEN
            CALL H2CHR (8, 1, CATH(KHPTP+2*I), CTEMP)
            IF (CTEMP.EQ.'WEIGHT')
     *         ILOCWT = I
            I = I + 1
            GO TO 10
            END IF
         END IF
C                                       If data is compressed then
C                                       adjust the data increments to
C                                       correspond to the expanded data:
      IF (ILOCWT.GE.0) THEN
         INCS = 3 * INCS
         INCF = 3 * INCF
         INCIF = 3 * INCIF
         END IF
C
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR ', I2, ' FINDING ', A12, '.', A6, '.', I4,
     *   ', DISK=', I2, ', USER=', I4)
 1001 FORMAT ('INITIO: ERROR ', I1, ' READING INPUT CATBLK')
 1002 FORMAT ('INITIO: ERROR ', I1, ' CREATING OUTPUT FILE')
 1003 FORMAT ('INITIO: ERROR ', I2, ' CHANGING STATUS OF INPUT FILE')
 1004 FORMAT ('INITIO: ERROR ', I1, ' OBTAINING PHYSICAL NAME OF ',
     *   'INPUT FILE')
 1005 FORMAT ('INITIO: ERROR ', I1, ' OPENING INPUT FILE')
 1006 FORMAT ('INITIO: ERROR ', I1, ' INITIALIZING INPUT FILE')
 1007 FORMAT ('INITIO: ERROR ', I1, ' OBTAINING PHYSICAL NAME OF ',
     *   'OUTPUT FILE')
 1008 FORMAT ('INITIO: ERROR ', I1, ' OPENING OUTPUT FILE')
 1009 FORMAT ('INITIO: ERROR ', I1, ' INITIALIZING OUTPUT FILE')
      END
      SUBROUTINE SWMAIN (IRET)
C-----------------------------------------------------------------------
C   Copy all visibilities from the input to the output file, swapping
C   polarizations when necessary.  The set of polarizations must be
C   (RR, LL), (RR, LL, RL, LR), (XX, YY) or (XX, YY, XY, YX). The
C   fastest varying axis in the visibility data must be the complex
C   axis.
C
C   Output:
C     IRET      I        Return status: I/O error
C-----------------------------------------------------------------------
      INTEGER IRET
C
C   Local variables:
C     NUMCH      I         Number of channels in data
C     NUMIF      I         Number of IFs in data
C     NUMPOL     I         Number of polarizations in data
C     ANT1       I         Antenna 1 in current baseline
C     ANT2       I         Antenna 2 in current baseline
C     SUBA       I         Current subarray
C     CODE       I         Which antennas are swapped on the current
C                          baseline: 0 -> none; 1 -> ant1; 2 -> ant2;
C                          3 -> both
C     POLORG     I(4,0:3)  Maps polarization streams in output to those
C                          in input for each value of CODE.
C     BASE       I         Pointer to current IF-Channel in data
C     VIS        I         Current visibility number
C     IDATA      R(?)      Input data buffer
C     ODATA      R(?)      Output data buffer
C     RPARM      R(16)     Random parameter array
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NUMCH, NUMIF, NUMPOL, ANT1, ANT2, CODE, POLORG(4, 0:3),
     *   VIS, BASE, IERR, I, ICHAN, IIF, IPOL, SUBA, RNXRET, VISINC,
     *   VISMSG
      REAL      IDATA (3*MAXCIF), ODATA (3*MAXCIF), RPARM(16)
C
      LOGICAL   SWAPAN
      EXTERNAL  SWAPAN
C
      INCLUDE 'SWPAN.INC'
      INCLUDE 'SWPFL.INC'
      INCLUDE 'SWPIO.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
C
      DATA POLORG /1, 2, 3, 4,
     *             4, 3, 2, 1,
     *             3, 4, 1, 2,
     *             2, 1, 4, 3/
C-----------------------------------------------------------------------
      NUMIF = 1
      IF (JLOCIF.GE.0) NUMIF = CATBLK(KINAX+JLOCIF)
      NUMCH = CATBLK(KINAX+JLOCF)
      NUMPOL = CATBLK(KINAX+JLOCS)
      IF (NUMPOL*NUMCH*NUMIF.GT.MAXCIF) THEN
         WRITE (MSGTXT,1000) NUMPOL, NUMCH, NUMIF, MAXCIF
         CALL MSGWRT (8)
         IRET = 1
         GO TO 999
         END IF
C                                       make an index table
      CALL RNXGET (INDISK, INCNO, CATOLD)
      CALL RNXINI (OUTDSK, OUTCNO, CATBLK, RNXRET)
      VISINC = NVIS / 25
      VISINC = MAX (25000, MIN (250000, VISINC))
      VISMSG = 4 * VISINC
C
      DO 50 VIS = 1,NVIS
         IF (MOD(VIS-1,VISMSG).EQ.0) THEN
            WRITE (MSGTXT,1005) VIS
            CALL MSGWRT (2)
         ELSE IF (MOD(VIS-1,VISINC).EQ.0) THEN
            WRITE (MSGTXT,1005) VIS
            CALL MSGWRT (1)
            END IF
         CALL RDVIS (RPARM, IDATA, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT, 1010) VIS, NVIS
            CALL MSGWRT (8)
            IRET = 1
            GO TO 999
            END IF
         IF (ILOCB.GE.0) THEN
            ANT1 = NINT (RPARM(1+ILOCB)) / 256
            ANT2 = MOD (NINT (RPARM(1+ILOCB)), 256)
            SUBA = 1.5 + 100.0 * (RPARM(1+ILOCB) -
     *         (256 * ANT1 + ANT2))
         ELSE
            ANT1 = RPARM(1+ILOCA1) + 0.1
            ANT2 = RPARM(1+ILOCA2) + 0.1
            SUBA = RPARM(1+ILOCSA) + 0.1
            END IF
         CODE = 0
         IF (SWAPAN (ANT1))
     *      CODE = CODE + 1
         IF (SWAPAN (ANT2))
     *      CODE = CODE + 2
C                                       Don't swap if incorrect
C                                       subarray:
         IF (SUBA.NE.SUBARR)
     *      CODE = 0
C                                       Copy each IF, channel and
C                                       polarization:
         DO 40 IIF = 1,NUMIF
            DO 30 ICHAN = 1,NUMCH
               BASE = (IIF-1) * INCIF + (ICHAN-1) * INCF + 1
               DO 20 IPOL = 1, NUMPOL
C                                       Loop over complex axis:
                  DO 10 I = 0, 2
                     ODATA(BASE + (IPOL - 1) * INCS + I) =
     *                  IDATA(BASE + (POLORG(IPOL, CODE) - 1)
     *                  * INCS + I)
 10                  CONTINUE
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
C                                       update NX table
         CALL RNXUPD (RPARM, RNXRET)
         CALL WRVIS (RPARM, ODATA, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT, 1011) VIS, NVIS
            CALL MSGWRT (8)
            IRET = 1
            GO TO 999
            END IF
 50      CONTINUE
C                                       index table finish
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         CALL MSGWRT (7)
         END IF
C
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SWMAIN: NUMBER POLS, CHANS, IFS',I2,I6,I4,
     *   ' EXCEEDS BUFFER',I8)
 1005 FORMAT ('At visibility record',I10)
 1010 FORMAT ('SWMAIN: ERROR READING VISIBILITY ', I6, ' OF ', I6)
 1011 FORMAT ('SWMAIN: ERROR WRITING VISIBILITY ', I6, ' OF ', I6)
      END
      SUBROUTINE RDVIS (RPARM, DATA, IRET)
C-----------------------------------------------------------------------
C   Read one visibility from the input file and return it in
C   uncompressed form. Uses variables in COMMON storage declared in
C   SWPIO.INC and DUVH.INC which must have been initialised by INITIO
C   and UVPGET respectively. There must be at least one unread
C   visibility remaining. RPARM and DATA must be large enough to hold
C   the random parameter array and data array, respectively.
C
C   Outputs:
C     RPARM       R(*)     Random parameter array
C     DATA        R(*)     Visibility data
C     IRET        I        Return status: 0 -> OK
C                                         1 -> error on input file
C
C   Uses, and modifies, variables from SWPIO.INC
C-----------------------------------------------------------------------
      REAL      RPARM(*), DATA(*)
      INTEGER   IRET
C
C   Local variables:
C     VISPTR     I        Pointer to first element in current visibility
C
      INTEGER   IERR, VISPTR
C
      INCLUDE 'SWPIO.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       Read a new block of visibilities
C                                       if the current one is exhausted:
      IF (VISNO.EQ.NIO) THEN
         CALL UVDISK ('READ', INLUN, IFIND, IBUFF, NIO, IBIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT, 1000) IERR
            CALL MSGWRT (8)
            IRET = 1
            GO TO 999
            END IF
         VISNO = 0
         END IF
C                                       Establish the definition of
C                                       VISPTR:
      VISPTR = IBIND + VISNO * LREC
C                                       Copy random parameters to
C                                       output:
      CALL RCOPY (NRPARM, IBUFF(VISPTR), RPARM)
      RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
      RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
      RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
C                                       Copy data to output,
C                                       decompressing if necessary:
      IF (ILOCWT.GE.0) THEN
         CALL ZUVXPN (LREC-NRPARM, IBUFF(VISPTR+NRPARM),
     *      IBUFF(VISPTR+ILOCWT), DATA)
      ELSE
         CALL RCOPY (LREC-NRPARM, IBUFF(VISPTR+NRPARM), DATA)
         END IF
C                                       Re-establish the definition of
C                                       VISNO:
      VISNO = VISNO + 1
C
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RDVIS: ERROR ', I1, ' READING INPUT UV DATA')
      END
      SUBROUTINE WRVIS (RPARM, DATA, IRET)
C-----------------------------------------------------------------------
C   Write one visibility to the output file (which must have been read
C   by RDVIS), compressing the data if necessary. The data must not have
C   been modified in any way that changes the length of the random
C   parameter array or the data array. Uses variables from SWPIO.INC and
C   DUVH.INC that must have been initialised with INITIO and UVPGET,
C   respectively.
C
C   Inputs:
C     RPARM      R(*)        Random parameter array
C     DATA       R(*)        Data array
C
C   Output:
C     IRET       I           Return status: 0 -> OK
C                                           1 -> error on output file
C-----------------------------------------------------------------------
      REAL      RPARM(*), DATA(*)
      INTEGER   IRET
C
C   Local variables:
C     VISPTR     I        Pointer to first element of current visibility
C                         in I/O buffer.
C
      INTEGER   IERR, VISPTR
C
      INCLUDE 'SWPIO.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       Establish the definition of
C                                       VISPTR:
      VISPTR = OBIND + (VISNO - 1) * LREC
C                                       Copy random parameters to I/O
C                                       buffer:
      CALL RCOPY (NRPARM, RPARM, OBUFF(VISPTR))
C                                       Copy data to I/O buffer,
C                                       compressing if necessary:
      IF (ILOCWT.GE.0) THEN
         CALL ZUVPAK (LREC-NRPARM, DATA, OBUFF(VISPTR+ILOCWT),
     *      OBUFF(VISPTR+NRPARM))
      ELSE
         CALL RCOPY (LREC-NRPARM, DATA, OBUFF(VISPTR+NRPARM))
         END IF
C                                       If the current record is the
C                                       last in the buffer, flush the
C                                       contents of the buffer to disk:
      IF (VISNO.EQ.NIO) THEN
         CALL UVDISK ('WRIT', OUTLUN, OFIND, OBUFF, NIO, OBIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT, 1000) IERR
            CALL MSGWRT (8)
            IRET = 1
            GO TO 999
            END IF
         END IF
C
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('WRVIS: ERROR ', I1, ' WRITING TO OUTPUT FILE')
      END
      LOGICAL FUNCTION SWAPAN (ANT)
C-----------------------------------------------------------------------
C   Determine whether polarizations are to be swapped for antenna ANT.
C
C   Input:
C     ANT     I      Antenna number
C
C   Output:
C     SWAPAN  L      .TRUE. if ANT is to be swapped, otherwise .FALSE.
C
C   Uses variables in local include SWPAN.INC
C-----------------------------------------------------------------------
      INTEGER   ANT
C
      LOGICAL   FOUND, RESULT
      INTEGER   I
C
      INCLUDE 'SWPAN.INC'
C-----------------------------------------------------------------------
C                                       Check whether all antennae
C                                       wanted:
      IF (NANT.EQ.0) THEN
         RESULT = .TRUE.
      ELSE
C                                       Check if ANT is in antenna list:
         I = 0
         FOUND = .FALSE.
 10      IF ((I.NE.NANT) .AND. (.NOT.FOUND)) THEN
            I = I + 1
            IF (ANT.EQ.ANTENS(I))
     *         FOUND = .TRUE.
            GO TO 10
            END IF
C                                       Check whether antennas in list
C                                       are selected or deselected:
         IF (INCLUD) THEN
            RESULT = FOUND
         ELSE
            RESULT = .NOT. FOUND
            END IF
         END IF
      SWAPAN = RESULT
      RETURN
      END
      SUBROUTINE ENDUV (DOCAL, IRET)
C-----------------------------------------------------------------------
C   Flush the output buffer and close both the input and output UV
C   files, copy tables from the input file to the output file and swap
C   calibration information in all CL and SN tables if the user asked
C   for this. Uses variables from SWPIO.INC which must have been
C   initialised with INITIO and from SWPFL.INC which must have been
C   initialised with SWPIN.
C
C   NOTE: does not need to compress output file since number of
C   visibilities is not changed.
C
C   Input:
C     DOCAL      L        .TRUE. if polarization calibration information
C                         in SN and CL tables should be swapped; .FALSE.
C                         otherwise
C
C   Output:
C     IRET       I        Return status: 0 -> OK
C                                        1 -> error on output file
C                                        2 -> error closing file
C                                        3 -> error copying tables
C                                        4 -> error updating cal.
C-----------------------------------------------------------------------
      LOGICAL   DOCAL(2)
      INTEGER   IRET
C
C   Local variables:
C     TILUN       I        Input LUN for tables (constant)
C     TOLUN       I        Output LUN for tables (constant)
C     TIBUF       I(256)   Input buffer for tables I/O
C     TOBUF       I(256)   Output buffer for tables I/O
C
      INTEGER   TILUN, TOLUN
      PARAMETER (TILUN = 27, TOLUN = 28)
      INTEGER   TIBUF(512), TOBUF(512)
      INTEGER   IERR, NONOT
      CHARACTER NOTTYP(12)*2
C
      INCLUDE 'SWPFL.INC'
      INCLUDE 'SWPIO.INC'
      INCLUDE 'SWPAN.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA NOTTYP /'CD','SY','TY','AN','FG','GC','IM','MC','OF',
     *   'PP','BD','BL'/
C-----------------------------------------------------------------------
C                                       Flush output buffer:
      NIO = 0
      CALL UVDISK ('FLSH', OUTLUN, OFIND, OBUFF, NIO, OBIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1000) IERR
         CALL MSGWRT (8)
         IRET = 1
         GO TO 999
         END IF
C                                       Close files:
      CALL ZCLOSE (INLUN, IFIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1001) IERR
         CALL MSGWRT (8)
         IRET = 2
         GO TO 999
         END IF
      CALL ZCLOSE (OUTLUN, OFIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1002) IERR
         CALL MSGWRT (8)
         IRET = 2
         GO TO 999
         END IF
C                                       Copy tables:
      NONOT = 9
      IF (NANT.EQ.0) NONOT = 12
      IF (.NOT.DOCAL(2)) NONOT = 0
      CALL ALLTAB (NONOT, NOTTYP, TILUN, TOLUN, INDISK, OUTDSK, INCNO,
     *   OUTCNO, CATBLK, TIBUF, TOBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1003) IERR
         CALL MSGWRT (8)
         IRET = 3
         GO TO 999
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (OUTDSK, OUTCNO, DIFPIX, TIBUF, TOBUF, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'ENDUV: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                       Swap polarization calibration,
C                                       if requested:
      CALL SWPCAL (DOCAL(1), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1004) IERR
         CALL MSGWRT (8)
         IRET = 4
         GO TO 999
         END IF
      IF (DOCAL(2)) THEN
         CALL FIXTAB (TILUN, TOLUN, INDISK, OUTDSK, INCNO, OUTCNO,
     *      CATOLD, CATBLK, TIBUF, TOBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1210) IERR
            CALL MSGWRT (7)
            END IF
         CALL FIXFG (TILUN, TOLUN, INDISK, OUTDSK, INCNO, OUTCNO,
     *      CATOLD, CATBLK, TIBUF, TOBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1211) IERR
            CALL MSGWRT (7)
            END IF
         CALL FIXBLC (TILUN, TOLUN, INDISK, OUTDSK, INCNO, OUTCNO,
     *      CATOLD, CATBLK, TIBUF, TOBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1211) IERR
            CALL MSGWRT (7)
            END IF
         END IF
C
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ENDUV: ERROR ', I1, ' WRITING TO OUTPUT FILE')
 1001 FORMAT ('ENDUV: ERROR ', I1, ' CLOSING INPUT FILE')
 1002 FORMAT ('ENDUV: ERROR ', I1, ' CLOSING OUTPUT FILE')
 1003 FORMAT ('ENDUV: ERROR ', I1, ' COPYING TABLES')
 1004 FORMAT ('ENDUV: ERROR ', I1, ' UPDATING CALIBRATION')
 1210 FORMAT ('ENDUV: ERROR',I3,' FIXING SY, TY, CD, AN TABLES')
 1211 FORMAT ('ENDUV: ERROR',I3,' FIXING FG TABLES')
      END
      SUBROUTINE SWPHIS (DOCAL, IRET)
C-----------------------------------------------------------------------
C   Copy and update history file.
C
C   Input:
C     DOCAL   L(2)   (1) .TRUE. if calibration was swapped.
C                    (2) .TRUE. is FG and other tables swapped
C   Output:
C     IRET    I      Return status: 0 -> OK
C                                   1 -> I/O error
C-----------------------------------------------------------------------
      LOGICAL   DOCAL(2)
      INTEGER   IRET
C
C   Local variables:
C     HILUN      I      LUN for input history file
C     HOLUN      I      LUN for output history file
C     HILINE     C*72   History record buffer
C     BUFER1     I(256) Extension file I/O buffer
C     BUFER2     I(256) Extension file I/O buffer
C
      INTEGER   HILUN, HOLUN, BUFER1(256), BUFER2(256), LIMIT, LIMIT2,
     *   I, IERR, J, I2
      CHARACTER HILINE*72
C
      PARAMETER (HILUN = 27, HOLUN = 28)
C
      INCLUDE 'SWPAN.INC'
      INCLUDE 'SWPFL.INC'
      INCLUDE 'SWPIO.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL HIINIT (3)
C                                       Copy history file:
      CALL HISCOP (HILUN, HOLUN, INDISK, OUTDSK, INCNO, OUTCNO,
     *   CATBLK, BUFER1, BUFER2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       Add input file description:
      CALL HENCO1 (TSKNAM, INNAME, INCLAS, INSEQ, INDISK, HOLUN,
     *   BUFER2, IERR)
      IF (IERR.NE.0) GO TO 90
C                                       Add output file description:
      CALL HENCOO (TSKNAM, OUTNAM, OUTCLS, OUTSEQ, OUTDSK, HOLUN,
     *   BUFER2, IERR)
      IF (IERR.NE.0) GO TO 90
C                                       Add antennas adverb:
      IF (NANT.EQ.0) THEN
         WRITE (HILINE, 1002)
      ELSE IF (INCLUD) THEN
         WRITE (HILINE, 1003)
         CALL HIADD (HOLUN, HILINE, BUFER2, IERR)
         IF (IERR.NE.0) GO TO 90
      ELSE
         WRITE (HILINE, 1004)
         CALL HIADD (HOLUN, HILINE, BUFER2, IERR)
         IF (IERR.NE.0) GO TO 90
         END IF
      LIMIT2 = MIN (12, NANT)
      WRITE (HILINE, 1005) TSKNAM, (ANTENS(I), I = 1, LIMIT2)
      CALL HIADD (HOLUN, HILINE, BUFER2, IERR)
      IF (IERR.NE.0) GO TO 90
      IF (LIMIT2.LT.NANT) THEN
         DO 10 LIMIT = 13, NANT, 12
            LIMIT2 = MIN (LIMIT+11, NANT)
            WRITE (HILINE, 1006) TSKNAM, (ANTENS(I), I=LIMIT,LIMIT2)
            CALL HIADD (HOLUN, HILINE, BUFER2, IERR)
            IF (IERR.NE.0) GO TO 90
 10         CONTINUE
         END IF
C                                       Subarray:
      WRITE (HILINE, 1007) TSKNAM, SUBARR
      CALL HIADD (HOLUN, HILINE, BUFER2, IERR)
      IF (IERR.NE.0) GO TO 90
C                                       Was calibration swapped:
      IF (DOCAL(1)) THEN
         WRITE (HILINE,1008) TSKNAM
      ELSE
         WRITE (HILINE,1009) TSKNAM
         END IF
      CALL HIADD (HOLUN, HILINE, BUFER2, IERR)
      IF (IERR.NE.0) GO TO 90
      IF (DOCAL(2)) THEN
         WRITE (HILINE,1010) TSKNAM
      ELSE
         WRITE (HILINE,1011) TSKNAM
         END IF
      CALL HIADD (HOLUN, HILINE, BUFER2, IERR)
      IF (IERR.NE.0) GO TO 90
C                                       list swapped tables
      DO 50 I = 1,NSWAPD,13
         I2 = MIN (I+12, NSWAPD)
         WRITE (HILINE,1012) TSKNAM, (TASWAP(J), J = I,I2)
         CALL HIADD (HOLUN, HILINE, BUFER2, IERR)
         IF (IERR.NE.0) GO TO 90
 50      CONTINUE
      GO TO 100
C
 90   WRITE (MSGTXT, 1001) IERR
      CALL MSGWRT (6)
C                                       Close history file:
 100  CALL HICLOS (HOLUN, .TRUE., BUFER2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1100) IERR
         CALL MSGWRT (6)
         END IF
C                                       Update output file header:
      CALL CATIO ('UPDT', OUTDSK, OUTCNO, CATBLK, 'REST', BUFER1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1101) IERR
         CALL MSGWRT (8)
         IRET = 1
         GO TO 999
         END IF
C
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SWPHIS: ERROR ', I1, ' COPYING HISTORY FILE')
 1001 FORMAT ('SWPHIS: ERROR ', I1, ' WRITING TO HISTORY FILE')
 1002 FORMAT (A6,'ANTENNAS = 0 / All antennas swapped')
 1003 FORMAT (A6,' / Polarizations swapped for listed antennas')
 1004 FORMAT (A6,' / Polarizations swapped for all but listed ',
     *   'antennas')
 1005 FORMAT (A6,'ANTENNAS = ', 12(I3, ' '))
 1006 FORMAT (A6,'           ', 12(I3, ' '))
 1007 FORMAT (A6,'SUBARRAY = ', I2)
 1008 FORMAT (A6,'DOCALIB  = TRUE  / CL,SN,BP,PD,PC tables updated')
 1009 FORMAT (A6,'DOCALIB  = FALSE / CL,SN,BP,PD,PC tables left ',
     *   'unchanged')
 1010 FORMAT (A6,'DOTABLE  = TRUE  / other tables updated')
 1011 FORMAT (A6,'DOTABLE  = FALSE / other tables left unchanged')
 1012 FORMAT (A6,' / Tables swapped ',13(A2,1X))
 1100 FORMAT ('SWPHIS: ERROR ', I1, ' CLOSING HISTORY FILE')
 1101 FORMAT ('SWPHIS: ERROR ', I1, ' UPDATING CATBLK')
      END
      SUBROUTINE SWPCAL (DOCAL, IRET)
C-----------------------------------------------------------------------
C   Swap calibration antenna for each polarization for selected
C   antennae.
C   Outputs:
C      IRET   I   Return code: 0 -> OK
C                              1 -> I/O error
C                              2 -> bad table
C-----------------------------------------------------------------------
      LOGICAL   DOCAL
      INTEGER   IRET
C
C   Local variables:
C     TABLUN      I         LUN to use for tables (constant)
C     NUMCL       I         Number of CL tables present
C     NUMSN       I         Number of SN tables present
C     TABUFF      I(512)    Tables I/O buffer
C     NUMANT      I         Number of antennae in current table (unused)
C     NUMPOL      I         Number of polarizations in current table
C                           (should be 2)
C     NUMIF       I         Number of IFs in current table
C     NUMNOD      I         Number of interpolation nodes in SN table
C     RANOD       R(32)     RA offset of each node
C     DECNOD      R(32)     Declination offset of each node
C     GMMOD       R         Mean gain modulus (unused)
C     ROWNUM      I         Current row number in current table
C     LSTROW      I         Last row in current table
C     TAKOLS      I(MAXCLC) Column pointer array
C     TANUMV      I(MAXCLC) Element count for each column
C  Most others hold calibration information from CL or SN table: see
C  headers for TABCAL and TABSN for descriptions.
C
      INTEGER   TABLUN
      PARAMETER (TABLUN = 27)
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PPCV.INC'
      INTEGER   NUMCL, NUMSN, TABUFF(1024), NUMANT, NUMPOL, NUMIF,
     *   NUMNOD, ROWNUM, LSTROW, TAKOLS(MAXCLC), TANUMV(MAXCLC), I, J,
     *   IF, IERR, ITEMP, NUMBP, NUMPD, NUMSHF, K, KK, BCHAN, NUMFRQ,
     *   REFANT(2), NUMPC
      REAL      RANOD(32), DECNOD(32), GMMOD, RTEMP, LOWSHF, DELSHF,
     *   BANDW, WGT(2*MAXIF), BNDPAS(4*MAXCIF), PHDIFF(MAXCIF)
      CHARACTER LBPTYP*8, CTYP*2, POLTYP*8
C
      INTEGER   SOURID, ANTNO, SUBA, FREQID, REFA(2, MAXIF),
     *   NODENO, NTERM, NUMTON
      REAL      DOPOFF(MAXIF), ATMOS, DATMOS, MBDELY(2), CLOCK(2),
     *   DCLOCK(2), DISP(2), DDISP(2), CREAL(2,MAXIF), CIMAG(2,MAXIF),
     *   DELAY(2,MAXIF), RATE(2,MAXIF), WEIGHT(2,MAXIF)
      DOUBLE PRECISION    GEODLY(8), CHSHFT(MAXIF)
      REAL      TIMEI, IFR
      DOUBLE PRECISION TIME
      LOGICAL   ISAPPL
C
      REAL      PCREAL(2,MAXTON,MAXIF), PCIMAG(2,MAXTON,MAXIF),
     *   PCRATE(2,MAXTON,MAXIF), STATE(2,MAXTON,MAXIF)
      DOUBLE PRECISION PCFREQ(2,MAXTON,MAXIF), DTEMP, CABCAL
C
      LOGICAL   SWAPAN
      EXTERNAL  SWAPAN
C
      INCLUDE 'SWPAN.INC'
      INCLUDE 'SWPFL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       Set number of polarizations and
C                                       IFs:
      NUMPOL = 2
      NUMIF = CATBLK(KINAX+JLOCIF)
C                                       Establish the definitions of
C                                       NUMCL and NUMSN
      CALL FNDEXT ('CL', CATBLK, NUMCL)
      CALL FNDEXT ('SN', CATBLK, NUMSN)
      CALL FNDEXT ('BP', CATBLK, NUMBP)
      CALL FNDEXT ('PD', CATBLK, NUMPD)
      CALL FNDEXT ('PC', CATBLK, NUMPC)
      IRET = 0
      IF (NUMCL+NUMSN+NUMBP+NUMPD.GT.1) THEN
         IF ((DOCAL) .AND. (NANT.GT.0)) THEN
            MSGTXT = 'SWAPPING CALIBRATION OF ONLY SOME ANTENNAS NOT A'
     *         // ' GOOD IDEA!'
            CALL MSGWRT (7)
            END IF
         IF (.NOT.DOCAL) THEN
            MSGTXT = 'CALIBRATION SHOULD BE REDONE AFTER SWPOL'
            CALL MSGWRT (7)
            END IF
         END IF
      IF (.NOT.DOCAL) GO TO 999
C                                       Process all CL files:
      CTYP = 'CL'
      IF (NUMCL.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         END IF
      DO 120 I = 1, NUMCL
         CALL CLREFM (OUTDSK, OUTCNO, I, CATBLK, TABLUN, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'REFORMATING', CTYP, I
            CALL MSGWRT (7)
            GO TO 120
            END IF
         CALL CALINI ('WRIT', TABUFF, OUTDSK, OUTCNO, I, CATBLK, TABLUN,
     *      J, TAKOLS, TANUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPENING', CTYP, I
            CALL MSGWRT (7)
            GO TO 120
            END IF
C                                       Process each record:
         LSTROW = J - 1
         DO 110 J = 1, LSTROW
            ROWNUM = J
            CALL TABCAL ('READ', TABUFF, ROWNUM, TAKOLS, TANUMV, NUMPOL,
     *         NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *         GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK,
     *         DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA,
     *         IERR)
C                                       Deselected record.
            IF (IERR.LT.0) GO TO 110
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'READING', CTYP, I
               CALL MSGWRT (8)
               IRET = 1
               GO TO 999
               END IF
            IF (SWAPAN(ANTNO) .AND. (SUBA.EQ.SUBARR)) THEN
               RTEMP = MBDELY(1)
               MBDELY(1) = MBDELY(2)
               MBDELY(2) = RTEMP
               RTEMP = CLOCK(1)
               CLOCK(1) = CLOCK(2)
               CLOCK(2) = RTEMP
               RTEMP = DCLOCK(1)
               DCLOCK(1) = DCLOCK(2)
               DCLOCK(2) = RTEMP
               RTEMP = DISP(1)
               DISP(1) = DISP(2)
               DISP(2) = RTEMP
               RTEMP = DDISP(1)
               DDISP(1) = DDISP(2)
               DDISP(2) = RTEMP
               DO 100 IF = 1, NUMIF
                  RTEMP = CREAL(1, IF)
                  CREAL(1, IF) = CREAL(2, IF)
                  CREAL(2, IF) = RTEMP
                  RTEMP = CIMAG(1, IF)
                  CIMAG(1, IF) = CIMAG(2, IF)
                  CIMAG(2, IF) = RTEMP
                  RTEMP = DELAY(1, IF)
                  DELAY(1, IF) = DELAY(2, IF)
                  DELAY(2, IF) = RTEMP
                  RTEMP = RATE(1, IF)
                  RATE(1, IF) = RATE(2, IF)
                  RATE(2, IF) = RTEMP
                  RTEMP = WEIGHT(1, IF)
                  WEIGHT(1, IF) = WEIGHT(2, IF)
                  WEIGHT(2, IF) = RTEMP
                  ITEMP = REFA(1, IF)
                  REFA(1, IF) = REFA(2, IF)
                  REFA(2, IF) = ITEMP
 100              CONTINUE
               END IF
            ROWNUM = J
            CALL TABCAL ('WRIT', TABUFF, ROWNUM, TAKOLS, TANUMV, NUMPOL,
     *         NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *         GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK,
     *         DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'WRITING', CTYP, I
               CALL MSGWRT (8)
               IRET = 1
               GO TO 999
               END IF
 110        CONTINUE
         IERR = 0
         CALL TABCAL ('CLOS', TABUFF, ROWNUM, TAKOLS, TANUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK,
     *      DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'CLOSING', CTYP, I
            CALL MSGWRT (8)
            IRET = 1
            GO TO 999
            END IF
         WRITE (MSGTXT,1111) CTYP, I
         CALL MSGWRT (3)
 120     CONTINUE
C                                       Process each SN table:
      CTYP = 'SN'
      IF (NUMSN.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         END IF
      DO 220 I = 1, NUMSN
         CALL SNREFM (OUTDSK, OUTCNO, I, CATBLK, TABLUN, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'REFORMATING', CTYP, I
            CALL MSGWRT (7)
            GO TO 220
            END IF
         CALL SNINI ('WRIT', TABUFF, OUTDSK, OUTCNO, I, CATBLK, TABLUN,
     *      J, TAKOLS, TANUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, GMMOD,
     *      RANOD, DECNOD, ISAPPL, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPENING', CTYP, I
            CALL MSGWRT (7)
            GO TO 220
            END IF
C                                       Process each row
         LSTROW = J - 1
         DO 210 J = 1, LSTROW
            ROWNUM = J
            CALL TABSN ('READ', TABUFF, ROWNUM, TAKOLS, TANUMV, NUMPOL,
     *         TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *         MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *         REFA, IERR)
C                                       Deselected record.
            IF (IERR.LT.0) GO TO 210
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'READING', CTYP, I
               CALL MSGWRT (8)
               IRET = 1
               GO TO 999
               END IF
C                                       Swap info this antenna?
            IF (SWAPAN(ANTNO) .AND. (SUBA.EQ.SUBARR)) THEN
C                                       Multiband delays
               RTEMP = MBDELY(1)
               MBDELY(1) = MBDELY(2)
               MBDELY(2) = RTEMP
               RTEMP = DISP(1)
               DISP(1) = DISP(2)
               DISP(2) = RTEMP
               RTEMP = DDISP(1)
               DDISP(1) = DDISP(2)
               DDISP(2) = RTEMP
C                                       Loop over IFs:
               DO 200 IF = 1, NUMIF
                  RTEMP = CREAL(1, IF)
                  CREAL(1, IF) = CREAL(2, IF)
                  CREAL(2, IF) = RTEMP
                  RTEMP = CIMAG(1, IF)
                  CIMAG(1, IF) = CIMAG(2, IF)
                  CIMAG(2, IF) = RTEMP
                  RTEMP = DELAY(1, IF)
                  DELAY(1, IF) = DELAY(2, IF)
                  DELAY(2, IF) = RTEMP
                  RTEMP = RATE(1, IF)
                  RATE(1, IF) = RATE(2, IF)
                  RATE(2, IF) = RTEMP
                  RTEMP = WEIGHT(1, IF)
                  WEIGHT(1, IF) = WEIGHT(2, IF)
                  WEIGHT(2, IF) = RTEMP
                  ITEMP = REFA(1, IF)
                  REFA(1, IF) = REFA(2, IF)
                  REFA(2, IF) = ITEMP
 200              CONTINUE
               END IF
            ROWNUM = J
            CALL TABSN ('WRIT', TABUFF, ROWNUM, TAKOLS, TANUMV, NUMPOL,
     *         TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *         MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *         REFA, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'WRITING', CTYP, I
               CALL MSGWRT (8)
               IRET = 1
               GO TO 999
               END IF
 210        CONTINUE
         IERR = 0
         CALL TABSN ('CLOS', TABUFF, ROWNUM, TAKOLS, TANUMV, NUMPOL,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'CLOSING', CTYP, I
            CALL MSGWRT (8)
            IRET = 1
            GO TO 999
            END IF
         WRITE (MSGTXT,1111) CTYP, I
         CALL MSGWRT (3)
 220     CONTINUE
C                                       BP tables
      CTYP = 'BP'
      IF (NUMBP.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         END IF
      DO 340 I = 1,NUMBP
         CALL BPREFM (OUTDSK, OUTCNO, I, CATBLK, TABLUN, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'REFORMATING', CTYP, I
            CALL MSGWRT (7)
            GO TO 340
            END IF
         CALL BPINI ('WRIT', TABUFF, OUTDSK, OUTCNO, I, CATBLK, TABLUN,
     *      J, TAKOLS, TANUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ, BCHAN,
     *      NUMSHF, LOWSHF, DELSHF, LBPTYP, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPENING', CTYP, I
            CALL MSGWRT (7)
            GO TO 340
            END IF
C                                       Process each record:
         LSTROW = J - 1
         DO 330 J = 1,LSTROW
            ROWNUM = J
            CALL TABBP ('READ', TABUFF, ROWNUM, TAKOLS, TANUMV, NUMIF,
     *         NUMFRQ, NUMPOL, TIME, TIMEI, SOURID, SUBA, ANTNO, BANDW,
     *         CHSHFT, FREQID, REFANT, WGT, BNDPAS, IERR)
            IF (IERR.LT.0) GO TO 330
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'READING', CTYP, I
               CALL MSGWRT (8)
               IRET = 1
               GO TO 999
               END IF
            IF (SWAPAN(ANTNO) .AND. (SUBA.EQ.SUBARR)) THEN
               KK = 2 * NUMFRQ * NUMIF
               DO 310 K = 1,KK
                  RTEMP = BNDPAS(K)
                  BNDPAS(K) = BNDPAS(K+KK)
                  BNDPAS(K+KK) = RTEMP
 310              CONTINUE
               ITEMP = REFANT(2)
               REFANT(2) = REFANT(1)
               REFANT(1) = ITEMP
               DO 320 K = 1,NUMIF
                  RTEMP = WGT(K)
                  WGT(K) = WGT(K+NUMIF)
                  WGT(K+NUMIF) = RTEMP
 320              CONTINUE
               END IF
            ROWNUM = J
            CALL TABBP ('WRIT', TABUFF, ROWNUM, TAKOLS, TANUMV, NUMIF,
     *         NUMFRQ, NUMPOL, TIME, TIMEI, SOURID, SUBA, ANTNO, BANDW,
     *         CHSHFT, FREQID, REFANT, WGT, BNDPAS, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'WRITING', CTYP, I
               CALL MSGWRT (8)
               IRET = 1
               GO TO 999
               END IF
 330        CONTINUE
         CALL TABBP ('CLOS', TABUFF, ROWNUM, TAKOLS, TANUMV, NUMIF,
     *      NUMFRQ, NUMPOL, TIME, TIMEI, SOURID, SUBA, ANTNO, BANDW,
     *      CHSHFT, FREQID, REFANT, WEIGHT, BNDPAS, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'CLOSING', CTYP, I
            CALL MSGWRT (8)
            IRET = 1
            GO TO 999
            END IF
         WRITE (MSGTXT,1111) CTYP, I
         CALL MSGWRT (3)
 340     CONTINUE
C                                       PD tables
      CTYP = 'PD'
      IF (NUMPD.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         END IF
      DO 440 I = 1,NUMPD
         CALL PDINI ('WRIT', TABUFF, OUTDSK, OUTCNO, I, CATBLK, TABLUN,
     *      J, TAKOLS, TANUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ, POLTYP,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPENING', CTYP, I
            CALL MSGWRT (7)
            GO TO 440
            END IF
C                                       Process each record:
         LSTROW = J - 1
         DO 430 J = 1,LSTROW
            ROWNUM = J
            CALL TABPD ('READ', TABUFF, ROWNUM, TAKOLS, TANUMV, NUMIF,
     *         NUMFRQ, NUMPOL, ANTNO, SUBA, FREQID, REFANT, PHDIFF,
     *         BNDPAS, IERR)
            IF (IERR.LT.0) GO TO 430
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'READING', CTYP, I
               CALL MSGWRT (8)
               IRET = 1
               GO TO 999
               END IF
            IF (SWAPAN(ANTNO) .AND. (SUBA.EQ.SUBARR)) THEN
               KK = 2 * NUMFRQ * NUMIF
               DO 410 K = 1,KK
                  RTEMP = BNDPAS(K)
                  BNDPAS(K) = BNDPAS(K+KK)
                  BNDPAS(K+KK) = RTEMP
 410              CONTINUE
               ITEMP = REFANT(2)
               REFANT(2) = REFANT(1)
               REFANT(1) = ITEMP
               KK = NUMFRQ * NUMIF
               DO 420 K = 1,KK
                  PHDIFF(K) = -PHDIFF(K)
 420              CONTINUE
              END IF
            ROWNUM = J
            CALL TABPD ('WRIT', TABUFF, ROWNUM, TAKOLS, TANUMV, NUMIF,
     *         NUMFRQ, NUMPOL, ANTNO, SUBA, FREQID, REFANT, PHDIFF,
     *         BNDPAS, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'WRITING', CTYP, I
               CALL MSGWRT (8)
               IRET = 1
               GO TO 999
               END IF
 430        CONTINUE
         CALL TABPD ('CLOS', TABUFF, ROWNUM, TAKOLS, TANUMV, NUMIF,
     *      NUMFRQ, NUMPOL, ANTNO, SUBA, FREQID, REFANT, PHDIFF,
     *      BNDPAS, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'CLOSING', CTYP, I
            CALL MSGWRT (8)
            IRET = 1
            GO TO 999
            END IF
         WRITE (MSGTXT,1111) CTYP, I
         CALL MSGWRT (3)
 440     CONTINUE
C                                       PC tables
      CTYP = 'PC'
      IF (NUMPC.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         END IF
      DO 540 I = 1,NUMPC
         CALL PCINI ('WRIT', TABUFF, OUTDSK, OUTCNO, I, CATBLK, TABLUN,
     *      J, TAKOLS, TANUMV, NUMPOL, NUMIF, NUMTON, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPENING', CTYP, I
            CALL MSGWRT (7)
            GO TO 540
            END IF
C                                       Process each record:
         LSTROW = J - 1
         DO 530 J = 1,LSTROW
            ROWNUM = J
            CALL TABPC ('READ', TABUFF, ROWNUM, TAKOLS, TANUMV, NUMPOL,
     *         TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, CABCAL,
     *         STATE, PCFREQ, PCREAL, PCIMAG, PCRATE, IERR)
            IF (IERR.LT.0) GO TO 530
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'READING', CTYP, I
               CALL MSGWRT (8)
               IRET = 1
               GO TO 999
               END IF
            IF (SWAPAN(ANTNO) .AND. (SUBA.EQ.SUBARR)) THEN
               DO 520 K = 1,NUMIF
                  DO 510 KK = 1,NUMTON
                     RTEMP = PCREAL(1,K,KK)
                     PCREAL(1,K,KK) = PCREAL(2,K,KK)
                     PCREAL(2,K,KK)= RTEMP
                     RTEMP = PCIMAG(1,K,KK)
                     PCIMAG(1,K,KK) = PCIMAG(2,K,KK)
                     PCIMAG(2,K,KK)= RTEMP
                     RTEMP = PCRATE(1,K,KK)
                     PCRATE(1,K,KK) = PCRATE(2,K,KK)
                     PCRATE(2,K,KK)= RTEMP
                     RTEMP = STATE(1,K,KK)
                     STATE(1,K,KK) = STATE(2,K,KK)
                     STATE(2,K,KK)= RTEMP
                     DTEMP = PCFREQ(1,K,KK)
                     PCFREQ(1,K,KK) = PCFREQ(2,K,KK)
                     PCFREQ(2,K,KK)= DTEMP
 510                 CONTINUE
 520              CONTINUE
               END IF
            ROWNUM = J
            CALL TABPC ('WRIT', TABUFF, ROWNUM, TAKOLS, TANUMV, NUMPOL,
     *         TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, CABCAL,
     *         STATE, PCFREQ, PCREAL, PCIMAG, PCRATE, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'WRITING', CTYP, I
               CALL MSGWRT (8)
               IRET = 1
               GO TO 999
               END IF
 530        CONTINUE
         CALL TABPC ('CLOS', TABUFF, ROWNUM, TAKOLS, TANUMV, NUMPOL,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, CABCAL,
     *      STATE, PCFREQ, PCREAL, PCIMAG, PCRATE, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'CLOSING', CTYP, I
            CALL MSGWRT (8)
            IRET = 1
            GO TO 999
            END IF
         WRITE (MSGTXT,1111) CTYP, I
         CALL MSGWRT (3)
 540     CONTINUE
C
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SWPCAL: ERROR',I3,' ON ',A,1X,A2,' VERSION',I3)
 1111 FORMAT ('Corrected ',A2,' table version ', I2)
      END
      SUBROUTINE FIXTAB (LUNI, LUNO, DISKI, DISKO, CNOI, CNOO, CATOLD,
     *   CATBLK, BUFF1, BUFF2, IERR)
C-----------------------------------------------------------------------
C   swap SY, TY, CD, AN, GC, IM, MC, OF tables, copying to output
C   Inputs:
C      NUMANT   I      Number in ANTS
C      ANTS     I(*)   Antennas to swap
C      LUNI     I      Input LUN
C      LUNO     I      Output LUN
C      DISKI    I      Input disk
C      DISKO    I      Output disk
C      CNOI     I      Input catalog number
C      CNOO     I      Input catalog number
C      CATOLD   I(*)   Input header
C   In/Out
C      CATBLK   I(*)   Output header
C      BUFF1    I(*)   buffer 1
C      BUFF2    I(*)   buffer 2
C   Output:
C      IERR     I      error code
C-----------------------------------------------------------------------
      INTEGER   LUNI, LUNO, DISKI, DISKO, CNOI, CNOO, CATOLD(256),
     *   CATBLK(256), BUFF1(*), BUFF2(*), IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PGCV.INC'
      INTEGER   MAXPLY
      PARAMETER (MAXPLY=20)
C
      INTEGER   NVER, NREC, IVER, RNO, KOLS(30), NUMV(30), NUMA, I, J,
     *   NUMPOL, NUMIF, IREC, ANTNO, SUBA, FREQID, SOURID, CALTYP,
     *   ITPGC(2,MAXIF), NTGC(2,MAXIF), IXTGC(2,MAXIF), IYTGC(2,MAXIF),
     *   ITEMP, NTABGC, NUMSTK, STK1, NUMCHN, NUMPLY, FFTSIZ, OVRSMP,
     *   ZEROPD, ANFLAG, TABVER, KOLO(30), NUMO(30)
      CHARACTER CTEMP*2, OBSCOD*8, TAPER*8, OBSDAT*8, CTYP*2
      REAL      TIMEI, TCAL(4,MAXIF), PDIFF(2,MAXIF), PSUM(2,MAXIF),
     *   PGAIN(2,MAXIF), TSYS(2,MAXIF), TANT(2,MAXIF), TEMP, IFR,
     *   XVALGC(2,MAXIF), YVALGC(2,MAXIF,MXTBGC), DISP(2), DDISP(2),
     *   GAINGC(2,MAXIF,MXTBGC), SENSGC(2,MAXIF), FREQVR(MAXIF),
     *   CHNBW, RFPIX, DELTAT, LOOFF(2,MAXIF), DLOOFF(2,MAXIF), RTIME
      DOUBLE PRECISION TIME, REFFRQ, CHANBW, REFPIX, CORREV, DTEMP,
     *   PDELAY(2,MAXIF,MAXPLY), GDELAY(2,MAXPLY), RFREQ, ATMOS, DATMOS,
     *   PRATE(2,MAXIF,MAXPLY), GRATE(2,MAXPLY), CLOCK(2), DCLOCK(2)
      LOGICAL   SWAP, SWAPAN
      INCLUDE 'SWPFL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:IANT.INC'
C-----------------------------------------------------------------------
C                                       CD tables
      CTYP = 'CD'
      CALL FNDEXT (CTYP, CATOLD, NVER)
      IF (NVER.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         DO 100 IVER = 1,NVER
            CALL CDINI ('READ', BUFF1, DISKI, CNOI, IVER, CATOLD, LUNI,
     *         RNO, KOLS, NUMV, NUMA, NUMPOL, NUMIF, RDATE, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN INPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 100
               END IF
            NREC = BUFF1(5)
            CALL CDINI ('WRIT', BUFF2, DISKO, CNOO, IVER, CATBLK, LUNO,
     *         RNO, KOLO, NUMO, NUMA, NUMPOL, NUMIF, RDATE, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 90
               END IF
            DO 50 IREC = 1,NREC
               RNO = IREC
               CALL TABCD ('READ', BUFF1, RNO, KOLS, NUMV, NUMPOL,
     *            NUMIF, ANTNO, SUBA, FREQID, TCAL, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ INPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 90
                  END IF
               SWAP = SWAPAN (ANTNO)
               IF (SWAP) THEN
                  DO 30 I = 1,NUMIF
                     TEMP = TCAL(1,I)
                     TCAL(1,I) = TCAL(2,I)
                     TCAL(2,I) = TEMP
                     TEMP = TCAL(3,I)
                     TCAL(3,I) = TCAL(4,I)
                     TCAL(4,I) = TEMP
 30                  CONTINUE
                  END IF
               RNO = IREC
               CALL TABCD ('WRIT', BUFF2, RNO, KOLO, NUMO, NUMPOL,
     *            NUMIF, ANTNO, SUBA, FREQID, TCAL, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 90
                  END IF
 50            CONTINUE
            WRITE (MSGTXT,1050) 'CD', DISKI, CNOI, IVER, DISKO, CNOO,
     *         IVER
            CALL MSGWRT (3)
C                                       close
 90         RNO = NREC
            CALL TABCD ('CLOS', BUFF2, RNO, KOLO, NUMO, NUMPOL,
     *         NUMIF, ANTNO, SUBA, FREQID, TCAL, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
            RNO = NREC
            CALL TABCD ('CLOS', BUFF1, RNO, KOLS, NUMV, NUMPOL,
     *         NUMIF, ANTNO, SUBA, FREQID, TCAL, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE INPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
 100        CONTINUE
         END IF
C                                       SY tables
      CTYP = 'SY'
      CALL FNDEXT (CTYP, CATOLD, NVER)
      IF (NVER.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         DO 200 IVER = 1,NVER
            CALL SYINI ('READ', BUFF1, DISKI, CNOI, IVER, CATOLD, LUNI,
     *         RNO, KOLS, NUMV, NUMA, NUMPOL, NUMIF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN INPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 200
               END IF
            NREC = BUFF1(5)
            CALL SYINI ('WRIT', BUFF2, DISKO, CNOO, IVER, CATBLK, LUNO,
     *         RNO, KOLO, NUMO, NUMA, NUMPOL, NUMIF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 190
               END IF
            DO 150 IREC = 1,NREC
               RNO = IREC
               CALL TABSY ('READ', BUFF1, RNO, KOLS, NUMV, NUMPOL,
     *            NUMIF, TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA,
     *            FREQID, PDIFF, PSUM, PGAIN, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ INPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 190
                  END IF
               SWAP = SWAPAN (ANTNO)
               IF (SWAP) THEN
                  DO 130 I = 1,NUMIF
                     TEMP = PDIFF(1,I)
                     PDIFF(1,I) = PDIFF(2,I)
                     PDIFF(2,I) = TEMP
                     TEMP = PSUM(1,I)
                     PSUM(1,I) = PSUM(2,I)
                     PSUM(2,I) = TEMP
                     TEMP = PGAIN(1,I)
                     PGAIN(1,I) = PGAIN(2,I)
                     PGAIN(2,I) = TEMP
 130                 CONTINUE
                  END IF
               RNO = IREC
               CALL TABSY ('WRIT', BUFF2, RNO, KOLO, NUMO, NUMPOL,
     *            NUMIF, TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA,
     *            FREQID, PDIFF, PSUM, PGAIN, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 190
                  END IF
 150           CONTINUE
            WRITE (MSGTXT,1050) 'SY', DISKI, CNOI, IVER, DISKO, CNOO,
     *         IVER
            CALL MSGWRT (3)
C                                       close
 190        RNO = NREC
            CALL TABSY ('CLOS', BUFF2, RNO, KOLO, NUMO, NUMPOL,
     *         NUMIF, TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA, FREQID,
     *         PDIFF, PSUM, PGAIN, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
            RNO = NREC
            CALL TABSY ('CLOS', BUFF1, RNO, KOLS, NUMV, NUMPOL,
     *         NUMIF, TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA, FREQID,
     *         PDIFF, PSUM, PGAIN, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE INPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
 200        CONTINUE
         END IF
C                                       TY tables
      CTYP = 'TY'
      CALL FNDEXT (CTYP, CATOLD, NVER)
      IF (NVER.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         DO 300 IVER = 1,NVER
            CALL TYINI ('READ', BUFF1, DISKI, CNOI, IVER, CATOLD, LUNI,
     *         RNO, KOLS, NUMV, NUMPOL, NUMIF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN INPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 300
               END IF
            NREC = BUFF1(5)
            CALL TYINI ('WRIT', BUFF2, DISKO, CNOO, IVER, CATBLK, LUNO,
     *         RNO, KOLO, NUMO, NUMPOL, NUMIF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 290
               END IF
            DO 250 IREC = 1,NREC
               RNO = IREC
               CALL TABTY ('READ', BUFF1, RNO, KOLS, NUMV, NUMPOL,
     *            NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID,
     *            TSYS, TANT, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ INPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 290
                  END IF
               SWAP = SWAPAN (ANTNO)
               IF (SWAP) THEN
                  DO 230 I = 1,NUMIF
                     TEMP = TSYS(1,I)
                     TSYS(1,I) = TSYS(2,I)
                     TSYS(2,I) = TEMP
                     TEMP = TANT(1,I)
                     TANT(1,I) = TANT(2,I)
                     TANT(2,I) = TEMP
 230                 CONTINUE
                  END IF
               RNO = IREC
               CALL TABTY ('WRIT', BUFF2, RNO, KOLO, NUMO, NUMPOL,
     *            NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID,
     *            TSYS, TANT, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 290
                  END IF
 250           CONTINUE
            WRITE (MSGTXT,1050) 'TY', DISKI, CNOI, IVER, DISKO, CNOO,
     *         IVER
            CALL MSGWRT (3)
C                                       close
 290        RNO = NREC
            CALL TABTY ('CLOS', BUFF2, RNO, KOLO, NUMO, NUMPOL,
     *         NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID,
     *         TSYS, TANT, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
            RNO = NREC
            CALL TABTY ('CLOS', BUFF1, RNO, KOLS, NUMV, NUMPOL,
     *         NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID,
     *         TSYS, TANT, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE INPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
 300        CONTINUE
         END IF
C                                       AN tables
      CTYP = 'AN'
      CALL FNDEXT (CTYP, CATOLD, NVER)
      IF (NVER.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         DO 400 IVER = 1,NVER
C                                       allow reformat
            CALL ANTINI ('READ', BUFF1, DISKI, CNOI, IVER, CATOLD, LUNI,
     *         IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *         RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *         TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN INPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 400
               END IF
            NREC = BUFF1(5)
            CALL ANINI ('WRIT', BUFF2, DISKO, CNOO, IVER, CATBLK, LUNO,
     *         IANRNO, KOLO, NUMO, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *         RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *         TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN INPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 400
               END IF
            DO 350 IREC = 1,NREC
               IANRNO = IREC
               CALL TABAN ('READ', BUFF1, IANRNO, ANKOLS, ANNUMV,
     *            ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN,
     *            FWHMAN, POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB,
     *            IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ INPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 390
                  END IF
               SWAP = SWAPAN (NOSTA)
               IF (SWAP) THEN
                  CTEMP = POLTYA
                  POLTYA = POLTYB
                  POLTYB = CTEMP
                  TEMP = POLAA
                  POLAA = POLAB
                  POLAB = TEMP
                  DO 330 I = 1,2*NUMIF
                     TEMP = POLCA(I)
                     POLCA(I) = POLCB(I)
                     POLCB(I) = TEMP
 330                 CONTINUE
                  END IF
               IANRNO = IREC
               CALL TABAN ('WRIT', BUFF2, IANRNO, KOLO, NUMO, ANNAME,
     *            STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *            POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 390
                  END IF
 350           CONTINUE
            WRITE (MSGTXT,1050) 'AN', DISKI, CNOI, IVER, DISKO, CNOO,
     *         IVER
            CALL MSGWRT (3)
 390        IANRNO = IREC
            CALL TABAN ('CLOS', BUFF2, IANRNO, KOLO, NUMO, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
            IANRNO = IREC
            CALL TABAN ('CLOS', BUFF1, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE INPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
 400        CONTINUE
         END IF
C                                       GC tables
      CTYP = 'GC'
      CALL FNDEXT (CTYP, CATOLD, NVER)
      IF (NVER.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         DO 500 IVER = 1,NVER
            CALL GCINI ('READ', BUFF1, DISKI, CNOI, IVER, CATOLD, LUNI,
     *         RNO, KOLS, NUMV, NUMPOL, NUMIF, NTABGC, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN INPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 500
               END IF
            NREC = BUFF1(5)
            CALL GCINI ('WRIT', BUFF2, DISKO, CNOO, IVER, CATBLK, LUNO,
     *         RNO, KOLO, NUMO, NUMPOL, NUMIF, NTABGC, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 490
               END IF
            DO 450 IREC = 1,NREC
               RNO = IREC
               CALL TABGC ('READ', BUFF1, RNO, KOLS, NUMV, NUMPOL,
     *            NTABGC, ANTNO, SUBA, FREQID, ITPGC, NTGC, IXTGC,
     *            IYTGC, XVALGC, YVALGC, GAINGC, SENSGC, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ INPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 490
                  END IF
               SWAP = SWAPAN (ANTNO)
               IF (SWAP) THEN
                  DO 430 I = 1,NUMIF
                     ITEMP = ITPGC(1,I)
                     ITPGC(1,I) = ITPGC(2,I)
                     ITPGC(2,I) = ITEMP
                     ITEMP = NTGC(1,I)
                     NTGC(1,I) = NTGC(2,I)
                     NTGC(2,I) = ITEMP
                     ITEMP = IXTGC(1,I)
                     IXTGC(1,I) = IXTGC(2,I)
                     IXTGC(2,I) = ITEMP
                     ITEMP = IYTGC(1,I)
                     IYTGC(1,I) = IYTGC(2,I)
                     IYTGC(2,I) = ITEMP
                     TEMP = XVALGC(1,I)
                     XVALGC(1,I) = XVALGC(2,I)
                     XVALGC(2,I) = TEMP
                     TEMP = SENSGC(1,I)
                     SENSGC(1,I) = SENSGC(2,I)
                     SENSGC(2,I) = TEMP
                     DO 420 J = 1,NTABGC
                        TEMP = YVALGC(1,I,J)
                        YVALGC(1,I,J) = YVALGC(2,I,J)
                        YVALGC(2,I,J) = TEMP
                        TEMP = GAINGC(1,I,J)
                        GAINGC(1,I,J) = GAINGC(2,I,J)
                        GAINGC(2,I,J) = TEMP
 420                    CONTINUE
 430                 CONTINUE
                  END IF
               RNO = IREC
               CALL TABGC ('WRIT', BUFF2, RNO, KOLO, NUMO, NUMPOL,
     *            NTABGC, ANTNO, SUBA, FREQID, ITPGC, NTGC, IXTGC,
     *            IYTGC, XVALGC, YVALGC, GAINGC, SENSGC, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 490
                  END IF
 450           CONTINUE
            WRITE (MSGTXT,1050) 'GC', DISKI, CNOI, IVER, DISKO, CNOO,
     *         IVER
            CALL MSGWRT (3)
C                                       close
 490        RNO = NREC
            CALL TABGC ('CLOS', BUFF2, RNO, KOLO, NUMO, NUMPOL,
     *         NTABGC, ANTNO, SUBA, FREQID, ITPGC, NTGC, IXTGC,
     *         IYTGC, XVALGC, YVALGC, GAINGC, SENSGC, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
            RNO = NREC
            CALL TABGC ('CLOS', BUFF1, RNO, KOLS, NUMV, NUMPOL,
     *         NTABGC, ANTNO, SUBA, FREQID, ITPGC, NTGC, IXTGC,
     *         IYTGC, XVALGC, YVALGC, GAINGC, SENSGC, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE INPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
 500        CONTINUE
         END IF
C                                       IM tables
      CTYP = 'IM'
      CALL FNDEXT (CTYP, CATOLD, NVER)
      IF (NVER.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         DO 600 IVER = 1,NVER
            CALL IMINIT ('READ', BUFF1, DISKI, CNOI, IVER, CATOLD, LUNI,
     *         RNO, KOLS, NUMV, OBSCOD, RDATE, NUMSTK, STK1, NUMIF,
     *         NUMCHN, REFFRQ, CHANBW, REFPIX, NUMPOL, NUMPLY, CORREV,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN INPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 600
               END IF
            NREC = BUFF1(5)
            CALL IMINIT ('WRIT', BUFF2, DISKO, CNOO, IVER, CATBLK, LUNO,
     *         RNO, KOLO, NUMO, OBSCOD, RDATE, NUMSTK, STK1, NUMIF,
     *         NUMCHN, REFFRQ, CHANBW, REFPIX, NUMPOL, NUMPLY, CORREV,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 590
               END IF
            DO 550 IREC = 1,NREC
               RNO = IREC
               CALL TABIM ('READ', BUFF1, RNO, KOLS, NUMV, NUMPOL, TIME,
     *            TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, FREQVR,
     *            PDELAY, GDELAY, PRATE, GRATE, DISP, DDISP, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ INPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 590
                  END IF
               SWAP = SWAPAN (ANTNO)
               IF (SWAP) THEN
                  DO 530 I = 1,NUMIF
                     DTEMP = GDELAY(1,I)
                     GDELAY(1,I) = GDELAY(2,I)
                     GDELAY(2,I) = DTEMP
                     DTEMP = GRATE(1,I)
                     GRATE(1,I) = GRATE(2,I)
                     GRATE(2,I) = DTEMP
                     DO 520 J =1,NUMPLY
                        DTEMP = PDELAY(1,I,J)
                        PDELAY(1,I,J) = PDELAY(2,I,J)
                        PDELAY(2,I,J) = DTEMP
                        DTEMP = PRATE(1,I,J)
                        PRATE(1,I,J) = PRATE(2,I,J)
                        PRATE(2,I,J) = DTEMP
 520                    CONTINUE
 530                 CONTINUE
                  END IF
               RNO = IREC
               CALL TABIM ('WRIT', BUFF2, RNO, KOLO, NUMO, NUMPOL, TIME,
     *            TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, FREQVR,
     *            PDELAY, GDELAY, PRATE, GRATE, DISP, DDISP, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 590
                  END IF
 550           CONTINUE
            WRITE (MSGTXT,1050) 'IM', DISKI, CNOI, IVER, DISKO, CNOO,
     *         IVER
            CALL MSGWRT (3)
C                                       close
 590        RNO = NREC
            CALL TABIM ('CLOS', BUFF2, RNO, KOLO, NUMO, NUMPOL, TIME,
     *         TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, FREQVR,
     *         PDELAY, GDELAY, PRATE, GRATE, DISP, DDISP, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
            RNO = NREC
            CALL TABIM ('CLOS', BUFF1, RNO, KOLS, NUMV, NUMPOL, TIME,
     *         TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, FREQVR,
     *         PDELAY, GDELAY, PRATE, GRATE, DISP, DDISP, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE INPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
 600        CONTINUE
         END IF
C                                       MC tables
      CTYP = 'MC'
      CALL FNDEXT (CTYP, CATOLD, NVER)
      IF (NVER.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         DO 700 IVER = 1,NVER
            CALL MCINI ('READ', BUFF1, DISKI, CNOI, IVER, CATOLD, LUNI,
     *         RNO, KOLS, NUMV, OBSCOD, RDATE, NUMSTK, STK1, NUMIF,
     *         NUMCHN, RFREQ, CHNBW, R FPIX, NUMPOL, FFTSIZ, OVRSMP,
     *         ZEROPD, TAPER, DELTAT, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN INPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 700
               END IF
            NREC = BUFF1(5)
            CALL MCINI ('WRIT', BUFF2, DISKO, CNOO, IVER, CATBLK, LUNO,
     *         RNO, KOLO, NUMO, OBSCOD, RDATE, NUMSTK, STK1, NUMIF,
     *         NUMCHN, RFREQ, CHNBW, RFPIX, NUMPOL, FFTSIZ, OVRSMP,
     *         ZEROPD, TAPER, DELTAT, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 690
               END IF
            DO 650 IREC = 1,NREC
               RNO = IREC
               CALL MCTAB ('READ', BUFF1, RNO, KOLS, NUMV, NUMPOL,
     *            NUMIF, TIME, SOURID, ANTNO, SUBA, FREQID, ATMOS,
     *            DATMOS,GDELAY, GRATE, CLOCK, DCLOCK, LOOFF, DLOOFF,
     *            DISP, DDISP, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ INPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 690
                  END IF
               SWAP = SWAPAN (ANTNO)
               IF (SWAP) THEN
                  DTEMP = CLOCK(1)
                  CLOCK(1) = CLOCK(2)
                  CLOCK(2) = DTEMP
                  DTEMP = DCLOCK(1)
                  DCLOCK(1) = DCLOCK(2)
                  DCLOCK(2) = DTEMP
                  TEMP = DISP(1)
                  DISP(1) = DISP(2)
                  DISP(2) = TEMP
                  TEMP = DDISP(1)
                  DDISP(1) = DDISP(2)
                  DDISP(2) = TEMP
                  DO 630 I = 1,NUMIF
                     TEMP = LOOFF(1,I)
                     LOOFF(1,I) = LOOFF(2,I)
                     LOOFF(2,I) = TEMP
                     TEMP = DLOOFF(1,I)
                     DLOOFF(1,I) = DLOOFF(2,I)
                     DLOOFF(2,I) = TEMP
 630                 CONTINUE
                  END IF
               RNO = IREC
               CALL MCTAB ('WRIT', BUFF2, RNO, KOLO, NUMO, NUMPOL,
     *            NUMIF, TIME, SOURID, ANTNO, SUBA, FREQID, ATMOS,
     *            DATMOS,GDELAY, GRATE, CLOCK, DCLOCK, LOOFF, DLOOFF,
     *            DISP, DDISP, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 690
                  END IF
 650           CONTINUE
            WRITE (MSGTXT,1050) 'MC', DISKI, CNOI, IVER, DISKO, CNOO,
     *         IVER
            CALL MSGWRT (3)
C                                       close
 690        RNO = NREC
            CALL MCTAB ('CLOS', BUFF2, RNO, KOLO, NUMV, NUMPOL,
     *         NUMIF, TIME, SOURID, ANTNO, SUBA, FREQID, ATMOS,
     *         DATMOS,GDELAY, GRATE, CLOCK, DCLOCK, LOOFF, DLOOFF,
     *         DISP, DDISP, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
            RNO = NREC
            CALL MCTAB ('CLOS', BUFF1, RNO, KOLS, NUMV, NUMPOL,
     *         NUMIF, TIME, SOURID, ANTNO, SUBA, FREQID, ATMOS,
     *         DATMOS,GDELAY, GRATE, CLOCK, DCLOCK, LOOFF, DLOOFF,
     *         DISP, DDISP, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE INPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
 700        CONTINUE
         END IF
C                                       OF tables
      CTYP = 'OF'
      CALL FNDEXT (CTYP, CATOLD, NVER)
      IF (NVER.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         DO 800 IVER = 1,NVER
            CALL OFINI ('READ', BUFF1, DISKI, CNOI, IVER, CATOLD, LUNI,
     *         RNO, KOLS, NUMV, NUMIF, NUMPOL, ANNAME, OBSCOD, OBSDAT,
     *         TABVER, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN INPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 800
               END IF
            NREC = BUFF1(5)
            CALL OFINI ('WRIT', BUFF2, DISKO, CNOO, IVER, CATBLK, LUNO,
     *         RNO, KOLO, NUMO, NUMIF, NUMPOL, ANNAME, OBSCOD, OBSDAT,
     *         TABVER, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 790
               END IF
            DO 750 IREC = 1,NREC
               RNO = IREC
               CALL TABOF ('READ', BUFF1, RNO, KOLS, NUMV, RTIME,
     *            SOURID, ANTNO, SUBA, FREQID, ANFLAG, ITPGC, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ INPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 790
                  END IF
               SWAP = SWAPAN (ANTNO)
               IF (SWAP) THEN
                  DO 730 I = 1,NUMIF
                     ITEMP = ITPGC(1,I)
                     ITPGC(1,I) = ITPGC(2,I)
                     ITPGC(2,I) = ITEMP
 730                 CONTINUE
                  END IF
               RNO = IREC
               CALL TABOF ('WRIT', BUFF2, RNO, KOLO, NUMO, RTIME,
     *            SOURID, ANTNO, SUBA, FREQID, ANFLAG, ITPGC, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 790
                  END IF
 750           CONTINUE
            WRITE (MSGTXT,1050) 'OF', DISKI, CNOI, IVER, DISKO, CNOO,
     *         IVER
            CALL MSGWRT (3)
C                                       close
 790        RNO = NREC
            CALL TABOF ('CLOS', BUFF2, RNO, KOLO, NUMO, RTIME,
     *         SOURID, ANTNO, SUBA, FREQID, ANFLAG, ITPGC, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
            RNO = NREC
            CALL TABOF ('READ', BUFF1, RNO, KOLS, NUMV, RTIME,
     *         SOURID, ANTNO, SUBA, FREQID, ANFLAG, ITPGC, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE INPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
 800        CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FIXTAB ERROR:',I4,' ON ',A,1X,A,' TABLE VERSION',I4)
 1050 FORMAT ('Swapped ',A2,' file from vol/cno/vers',I3,I5,I4,' to',
     *   I3,I5,I4)
      END
      SUBROUTINE FIXFG (LUNI, LUNO, DISKI, DISKO, CNOI, CNOO, CATOLD,
     *   CATBLK, BUFF1, BUFF2, IERR)
C-----------------------------------------------------------------------
C   swap SY, TY, CD, AN tables, copying to output
C   Inputs:
C      NUMANT   I      Number in ANTS
C      ANTS     I(*)   Antennas to swap
C      LUNI     I      Input LUN
C      LUNO     I      Output LUN
C      DISKI    I      Input disk
C      DISKO    I      Output disk
C      CNOI     I      Input catalog number
C      CNOO     I      Input catalog number
C      CATOLD   I(*)   Input header
C   In/Out
C      CATBLK   I(*)   Output header
C      BUFF1    I(*)   buffer 1
C      BUFF2    I(*)   buffer 2
C   Output:
C      IERR     I      error code
C-----------------------------------------------------------------------
      INTEGER   LUNI, LUNO, DISKI, DISKO, CNOI, CNOO, CATOLD(256),
     *   CATBLK(256), BUFF1(*), BUFF2(*), IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IVER, KOLS(MAXFGC), NUMV(MAXFGC), RNO, SOURID, SUBA,
     *   FREQID, ANTS(2), IFS(2), CHANS(2), NVER, NREC, IREC,
     *   KOLO(MAXFGC), NUMO(MAXFGC)
      LOGICAL   NOGOOD, PFLAGS(4), TFLAGS(4), AFLAG, SWAP1, SWAP2
      REAL      TIMER(2)
      CHARACTER REASON*24, CTYP*2
C
      LOGICAL   SWAPAN
      EXTERNAL  SWAPAN
C
      INCLUDE 'SWPAN.INC'
      INCLUDE 'SWPFL.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       FG tables
      CTYP = 'FG'
      CALL FNDEXT (CTYP, CATOLD, NVER)
      IF (NVER.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         DO 100 IVER = 1,NVER
            CALL FGREFM (DISKI, CNOI, IVER, CATOLD, LUNI, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'REFORMAT INPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 100
               END IF
            CALL FLGINI ('READ', BUFF1, DISKI, CNOI, IVER, CATOLD, LUNI,
     *         RNO, KOLS, NUMV, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN INPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 100
               END IF
            NOGOOD = .FALSE.
            NREC = BUFF1(5)
            CALL FLGINI ('WRIT', BUFF2, DISKO, CNOO, IVER, CATBLK, LUNO,
     *         RNO, KOLO, NUMO, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 90
               END IF
            DO 50 IREC = 1,NREC
               RNO = IREC
               CALL TABFLG ('READ', BUFF1, RNO, KOLS, NUMV, SOURID,
     *            SUBA, FREQID, ANTS, TIMER, IFS, CHANS, PFLAGS, REASON,
     *            IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ INPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 90
                  END IF
               AFLAG = PFLAGS(1) .AND. PFLAGS(2) .AND. PFLAGS(3) .AND.
     *            PFLAGS(4)
               SWAP1 = SWAPAN(ANTS(1))
               SWAP2 = SWAPAN(ANTS(1))
               IF (.NOT.AFLAG) THEN
                  CALL LCOPY (4, PFLAGS, TFLAGS)
                  IF (NANT.EQ.0) THEN
                     PFLAGS(1) = TFLAGS(2)
                     PFLAGS(2) = TFLAGS(1)
                     PFLAGS(3) = TFLAGS(4)
                     PFLAGS(4) = TFLAGS(3)
                  ELSE IF (ANTS(1).EQ.0) THEN
                     NOGOOD = .TRUE.
                  ELSE IF (ANTS(2).EQ.0) THEN
                     IF (SWAP1) THEN
                        PFLAGS(1) = TFLAGS(2)
                        PFLAGS(2) = TFLAGS(1)
                        PFLAGS(3) = TFLAGS(4)
                        PFLAGS(4) = TFLAGS(3)
                        NOGOOD = .TRUE.
                        END IF
                  ELSE IF ((SWAP1) .AND. (SWAP2)) THEN
                     PFLAGS(1) = TFLAGS(2)
                     PFLAGS(2) = TFLAGS(1)
                     PFLAGS(3) = TFLAGS(4)
                     PFLAGS(4) = TFLAGS(3)
                  ELSE IF (SWAP1) THEN
                     PFLAGS(1) = TFLAGS(4)
                     PFLAGS(2) = TFLAGS(3)
                     PFLAGS(3) = TFLAGS(2)
                     PFLAGS(4) = TFLAGS(1)
                  ELSE IF (SWAP2) THEN
                     PFLAGS(1) = TFLAGS(3)
                     PFLAGS(2) = TFLAGS(4)
                     PFLAGS(3) = TFLAGS(1)
                     PFLAGS(4) = TFLAGS(2)
                     END IF
                  END IF
               RNO = IREC
               CALL TABFLG ('WRIT', BUFF2, RNO, KOLO, NUMO, SOURID,
     *            SUBA, FREQID, ANTS, TIMER, IFS, CHANS, PFLAGS, REASON,
     *            IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 90
                  END IF
 50            CONTINUE
            WRITE (MSGTXT,1050) 'FG', DISKI, CNOI, IVER, DISKO, CNOO,
     *         IVER
            CALL MSGWRT (3)
            MSGTXT = 'BUT SOME FLAGS COULD NOT BE INTERPRETED CORRECTLY'
            IF (NOGOOD) CALL MSGWRT (7)
 90         RNO = IREC
            CALL TABFLG ('CLOS', BUFF2, RNO, KOLO, NUMO, SOURID, SUBA,
     *         FREQID, ANTS, TIMER, IFS, CHANS, PFLAGS, REASON, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
            RNO = IREC
            CALL TABFLG ('CLOS', BUFF1, RNO, KOLS, NUMV, SOURID, SUBA,
     *         FREQID, ANTS, TIMER, IFS, CHANS, PFLAGS, REASON, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE INPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
 100        CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FIXFG: ERROR',I4,' ON ',A,1X,A,' TABLE VERSION',I4)
 1050 FORMAT ('Swapped ',A2,' file from vol/cno/vers',I3,I5,I4,' to',
     *   I3,I5,I4)
      END
      SUBROUTINE FIXBLC (LUNI, LUNO, DISKI, DISKO, CNOI, CNOO, CATOLD,
     *   CATBLK, BUFF1, BUFF2, IERR)
C-----------------------------------------------------------------------
C   swap SY, TY, CD, AN, GC, IM, MC, OF tables, copying to output
C   Inputs:
C      NUMANT   I      Number in ANTS
C      ANTS     I(*)   Antennas to swap
C      LUNI     I      Input LUN
C      LUNO     I      Output LUN
C      DISKI    I      Input disk
C      DISKO    I      Output disk
C      CNOI     I      Input catalog number
C      CNOO     I      Input catalog number
C      CATOLD   I(*)   Input header
C   In/Out
C      CATBLK   I(*)   Output header
C      BUFF1    I(*)   buffer 1
C      BUFF2    I(*)   buffer 2
C   Output:
C      IERR     I      error code
C-----------------------------------------------------------------------
      INTEGER   LUNI, LUNO, DISKI, DISKO, CNOI, CNOO, CATOLD(256),
     *   CATBLK(256), BUFF1(*), BUFF2(*), IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'SWPAN.INC'
      INCLUDE 'SWPFL.INC'
      INTEGER   NVER, NREC, IREC, IVER, RNO, KOLS(30), NUMV(30), I, J,
     *   BIF, BCHAN, NUMIF, NUMFRQ, SUBA, FREQID, ANT1, ANT2, IOFF,
     *   NUMANT, NUMPOL, SOURID, KOLO(30), NUMO(30), PPOL
      LOGICAL   WAS
      CHARACTER CTYP*2
      REAL      RTIME(2), FACMUL(2,2,MAXIF), FACADD(2,2,MAXIF), RTEMP
      DOUBLE PRECISION PHASES(MAXCIF), ERRORS(MAXCIF)
      COMPLEX   CTEMP, BNDPAS(4*MAXCIF)
      EQUIVALENCE (BNDPAS(1), PHASES), (BNDPAS(MAXCIF+1), ERRORS)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       antenna specific is wrong
      IF (NANT.GT.0) THEN
         WAS = .FALSE.
         CALL FNDEXT ('PP', CATOLD, NVER)
         IF (NVER.GT.0) THEN
            WRITE (MSGTXT,1010) NVER, 'PP'
            CALL MSGWRT (7)
            WAS = .TRUE.
            END IF
         CALL FNDEXT ('BL', CATOLD, NVER)
         IF (NVER.GT.0) THEN
            WRITE (MSGTXT,1010) NVER, 'BL'
            CALL MSGWRT (7)
            WAS = .TRUE.
            END IF
         CALL FNDEXT ('BD', CATOLD, NVER)
         IF (NVER.GT.0) THEN
            WRITE (MSGTXT,1010) NVER, 'BD'
            CALL MSGWRT (7)
            WAS = .TRUE.
            END IF
         MSGTXT = 'SUCH TABLES CANNOT BE SWAPPED EXCEPT FOR ALL' //
     *      ' ANTENNAS'
         IF (WAS) CALL MSGWRT (7)
         MSGTXT = 'CALIBRATIONS APPLIED BY THEM ARE NOW INCORRECT'
         IF (WAS) CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       PP tables
C                                       reverse phase
      CTYP = 'PP'
      CALL FNDEXT (CTYP, CATOLD, NVER)
      IF (NVER.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         DO 100 IVER = 1,NVER
            CALL PPINI ('READ', BUFF1, DISKI, CNOI, IVER, CATOLD, LUNI,
     *         RNO, KOLS, NUMV, NUMIF, NUMFRQ, BIF, BCHAN, PPOL, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN INPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 100
               END IF
            NREC = BUFF1(5)
            CALL PPINI ('WRIT', BUFF2, DISKO, CNOO, IVER, CATBLK, LUNO,
     *         RNO, KOLO, NUMO, NUMIF, NUMFRQ, BIF, BCHAN, PPOL, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 90
               END IF
            DO 50 IREC = 1,NREC
               RNO = IREC
               CALL TABPP ('READ', BUFF1, RNO, KOLS, NUMV, RTIME, SUBA,
     *            FREQID, PHASES, ERRORS, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ INPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 90
                  END IF
               J = NUMV(4)
               DO 30 I = 1,J
                  PHASES(I) = -PHASES(I)
 30               CONTINUE
               RNO = IREC
               CALL TABPP ('WRIT', BUFF2, RNO, KOLO, NUMO, RTIME, SUBA,
     *            FREQID, PHASES, ERRORS, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 90
                  END IF
 50            CONTINUE
            WRITE (MSGTXT,1050) 'PP', DISKI, CNOI, IVER, DISKO, CNOO,
     *         IVER
            CALL MSGWRT (3)
C                                       close
 90         RNO = NREC
            CALL TABPP ('CLOS', BUFF2, RNO, KOLO, NUMO, RTIME, SUBA,
     *         FREQID, PHASES, ERRORS, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
            RNO = NREC
            CALL TABPP ('CLOS', BUFF1, RNO, KOLS, NUMV, RTIME, SUBA,
     *         FREQID, PHASES, ERRORS, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE INPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
 100        CONTINUE
         END IF
C                                       BL tables
      CTYP = 'BL'
      CALL FNDEXT (CTYP, CATOLD, NVER)
      IF (NVER.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         DO 200 IVER = 1,NVER
            CALL BLREFM (DISKI, CNOI, IVER, CATOLD, LUNI, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'REFORMAT INPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 200
               END IF
            CALL BLINI ('READ', BUFF1, DISKI, CNOI, IVER, CATOLD, LUNI,
     *         RNO, KOLS, NUMV, NUMANT, NUMPOL, NUMIF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN INPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 200
               END IF
            NREC = BUFF1(5)
            CALL BLINI ('WRIT', BUFF2, DISKO, CNOO, IVER, CATBLK, LUNO,
     *         RNO, KOLO, NUMO, NUMANT, NUMPOL, NUMIF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 190
               END IF
            DO 150 IREC = 1,NREC
               RNO = IREC
               CALL TABBL ('READ', BUFF1, RNO, KOLS, NUMV, NUMPOL,
     *            RTIME, SOURID, SUBA, ANT1, ANT2, FREQID, FACMUL,
     *            FACADD, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ INPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 190
                  END IF
               DO 130 I = 1,NUMIF
                  RTEMP = FACMUL(1,1,I)
                  FACMUL(1,1,I) = FACMUL(1,2,I)
                  FACMUL(1,2,I) = RTEMP
                  RTEMP = FACMUL(2,1,I)
                  FACMUL(2,1,I) = FACMUL(2,2,I)
                  FACMUL(2,2,I) = RTEMP
                  RTEMP = FACADD(1,1,I)
                  FACADD(1,1,I) = FACADD(1,2,I)
                  FACADD(1,2,I) = RTEMP
                  RTEMP = FACADD(2,1,I)
                  FACADD(2,1,I) = FACADD(2,2,I)
                  FACADD(2,2,I) = RTEMP
 130              CONTINUE
               RNO = IREC
               CALL TABBL ('WRIT', BUFF2, RNO, KOLO, NUMO, NUMPOL,
     *            RTIME, SOURID, SUBA, ANT1, ANT2, FREQID, FACMUL,
     *            FACADD, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 190
                  END IF
 150           CONTINUE
            WRITE (MSGTXT,1050) 'BL', DISKI, CNOI, IVER, DISKO, CNOO,
     *         IVER
            CALL MSGWRT (3)
C                                       close
 190        RNO = NREC
            CALL TABBL ('CLOS', BUFF2, RNO, KOLO, NUMO, NUMPOL,
     *         RTIME, SOURID, SUBA, ANT1, ANT2, FREQID, FACMUL,
     *         FACADD, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
            RNO = NREC
            CALL TABBL ('CLOS', BUFF1, RNO, KOLS, NUMV, NUMPOL,
     *         RTIME, SOURID, SUBA, ANT1, ANT2, FREQID, FACMUL,
     *         FACADD, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
 200        CONTINUE
         END IF
C                                       BD tables
      CTYP = 'BD'
      CALL FNDEXT (CTYP, CATOLD, NVER)
      IF (NVER.GT.0) THEN
         NSWAPD = NSWAPD + 1
         TASWAP(NSWAPD) = CTYP
         DO 300 IVER = 1,NVER
            CALL BDINI ('READ', BUFF1, DISKI, CNOI, IVER, CATOLD, LUNI,
     *         RNO, KOLS, NUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN INPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 300
               END IF
            NREC = BUFF1(5)
            CALL BDINI ('WRIT', BUFF2, DISKO, CNOO, IVER, CATBLK, LUNO,
     *         RNO, KOLO, NUMO, NUMANT, NUMPOL, NUMIF, NUMFRQ, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPEN OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               GO TO 290
               END IF
            IOFF = NUMFRQ * NUMIF
            DO 250 IREC = 1,NREC
               RNO = IREC
               CALL TABBD ('READ', BUFF1, RNO, KOLS, NUMV, NUMIF,
     *            NUMFRQ, NUMPOL, RTIME, SOURID, SUBA, ANT1, ANT2,
     *            FREQID, BNDPAS, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ INPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 290
                  END IF
               DO 230 I = 1,IOFF
                  CTEMP = BNDPAS(I)
                  BNDPAS(I) = BNDPAS(I+IOFF)
                  BNDPAS(I+IOFF) = CTEMP
                  IF (NUMPOL.EQ.4) THEN
                     CTEMP = BNDPAS(I+2*IOFF)
                     BNDPAS(I+2*IOFF) = BNDPAS(I+3*IOFF)
                     BNDPAS(I+3*IOFF) = CTEMP
                     END IF
 230              CONTINUE
               RNO = IREC
               CALL TABBD ('WRIT', BUFF2, RNO, KOLO, NUMO, NUMIF,
     *            NUMFRQ, NUMPOL, RTIME, SOURID, SUBA, ANT1, ANT2,
     *            FREQID, BNDPAS, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT', CTYP, IVER
                  CALL MSGWRT (7)
                  GO TO 290
                  END IF
 250           CONTINUE
            WRITE (MSGTXT,1050) 'BD', DISKI, CNOI, IVER, DISKO, CNOO,
     *         IVER
            CALL MSGWRT (3)
C                                       close
 290        RNO = NREC
            CALL TABBD ('CLOS', BUFF2, RNO, KOLO, NUMO, NUMIF,
     *         NUMFRQ, NUMPOL, RTIME, SOURID, SUBA, ANT1, ANT2,
     *         FREQID, BNDPAS, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE OUTPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
            RNO = NREC
            CALL TABBD ('CLOS', BUFF1, RNO, KOLS, NUMV, NUMIF,
     *         NUMFRQ, NUMPOL, RTIME, SOURID, SUBA, ANT1, ANT2,
     *         FREQID, BNDPAS, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CLOSE INPUT', CTYP, IVER
               CALL MSGWRT (7)
               END IF
 300        CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FIXBLC ERROR:',I4,' ON ',A,1X,A,' TABLE VERSION',I4)
 1010 FORMAT ('COPIED',I3,' VERSIONS OF ',A,' BUT DID NOT CORRECT THEM')
 1050 FORMAT ('Swapped ',A2,' file from vol/cno/vers',I3,I5,I4,' to',
     *   I3,I5,I4)
      END

      SUBROUTINE QCTLUT
C-----------------------------------------------------------------------
C! Pseudo AP routine: Initialize cosine lookup table etc.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Initilizes cosine look table and other constants in common /COSLUT/
C   Table lookup scheme does a third order series expansion correction:
C     COS (tab+fract) = COS(tab)*COS(fract) - SIN(tab)*SIN(fract)
C     SIN (tab+fract) = SIN(tab)*COS(fract) + COS(tab)*SIN(fract)
C     Series expansion  for cos:
C          cos(fract) = 1 - (1/2) * fract**2 (fract is the
C                    difference from the phase of the tabulated value.)
C     Series expansion  for sin:
C                    sin(fract) = fract - (1/6) * fract**3
C   Outputs in common:
C      CLUTSC    R    Scaling factor = (LENLUT / 2*pi)
C      CLUTSI    R    1.0 / CLUTSC
C      LENLUT    I    Length of lookup table in words (must be a power
C                     of 2)
C      CTMASK    I    Mask to .AND. with to limit range (0,LENLUT-1)
C                     CTMASK = LENLUT - 1
C      CTBLBL    R    If .EQ. FBLANK then the table has been initialized
C      COSTAB    R(*) Cosine lookup table (0-2*pi)
C-----------------------------------------------------------------------
      DOUBLE PRECISION ARG, TWOPI
      INTEGER   LOOP, LENLUT, CTMASK
      REAL      CLUTSC, CLUTSI, CTBLBL, COSTAB(512)
      INCLUDE 'INCS:DDCH.INC'
      COMMON /COSLUT/ CLUTSC, CLUTSI, LENLUT, CTMASK, CTBLBL, COSTAB
C-----------------------------------------------------------------------
C                                       Set constants
      TWOPI = 8.0D0 * ATAN (1.0D0)
C                                       Mark as initialized
      CTBLBL = FBLANK
C                                       Length
      LENLUT = 512
C                                       Mask
      CTMASK = LENLUT -1
C                                       Scale
      CLUTSC = LENLUT / TWOPI
      CLUTSI = TWOPI / LENLUT
C                                       fill table
      DO 100 LOOP = 1,LENLUT
         ARG = (LOOP-1) * CLUTSI
         COSTAB(LOOP) = COS (ARG)
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE MP2IMA (MPIX, IMPIX)
C-----------------------------------------------------------------------
C! convert image pixel positions to TV pixel positions
C# Catalog TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Subroutine to convert map pixel locations to TV image pixel
C   locations using the image catalog, passed through common /MAPHDR/
C   Inputs:
C      MPIX     R(2)     x and y map pixel locations
C   Output:
C      IMPIX    R(2)     x and y TV image pixel locations
C   Common:
C      /MAPHDR/ CATBLK(256)  Image catalog block
C-----------------------------------------------------------------------
      REAL      IMPIX(2), MPIX(2)
C
      REAL      TEMP
      INTEGER   CATBLK(256), I, J
      INCLUDE 'INCS:DHDR.INC'
      COMMON /MAPHDR/ CATBLK
C-----------------------------------------------------------------------
      DO 10 I = 1,2
         TEMP = 1.0
         J = I - 1
         IF (CATBLK(IICOR+2+J).NE.CATBLK(IICOR+J)) TEMP =
     *      REAL (CATBLK(IIWIN+J+2) - CATBLK(IIWIN+J)) /
     *      REAL (CATBLK(IICOR+2+J) - CATBLK(IICOR+J))
         IMPIX(I) = CATBLK(IICOR+J) + (MPIX(I)-CATBLK(IIWIN+J)) / TEMP
 10      CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'MODVF.INC'
C                                       Local include for MODVF
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQOUT, DISKO, NEWCNO, NUMHIS, JBUFSZ, ICODE, LUNIN,
     *   FINDIN, NRING, NANNU
      CHARACTER HISCRD(10)*64, FILEIN*48, SOURCE*8, NAMOUT*12,
     *   CLAOUT*6
      HOLLERITH XFILEI(12), XSOURC(2), XNAMOU(3), XCLAOU(2)
      REAL      XMSIZ(2), CELLS(2), XSEQO, XDISKO, APARM(10),
     *          BUFFER(MABFSS), XINC
C                                       Program commons
      COMMON /INPARM/ XFILEI, XSOURC, XMSIZ, CELLS, XNAMOU, XCLAOU,
     *   XSEQO, XDISKO, APARM, XINC
      COMMON /PARMS/ SEQOUT, DISKO, NEWCNO, JBUFSZ, ICODE, LUNIN,
     *               FINDIN, NUMHIS, NRING, NANNU
      COMMON /BUFRS/ BUFFER
      COMMON /CHRCOM/ HISCRD, FILEIN, SOURCE, NAMOUT, CLAOUT
LOCAL END
LOCAL INCLUDE 'TABEL.INC'
      INTEGER   XDIM, PDIM
      PARAMETER (XDIM=1024)
      PARAMETER (PDIM=200)
      INTEGER   NVELO(XDIM,XDIM)
      REAL      VELOC(XDIM,XDIM)
      REAL      RING(PDIM), VROT(PDIM), WARP(PDIM), OMEG(PDIM),
     *   RNGM(PDIM)
      COMMON /TABEL/ RING, VROT, WARP, OMEG, RNGM
      COMMON /FIELD/ NVELO, VELOC
LOCAL END
      PROGRAM MODVF
C-----------------------------------------------------------------------
C! task to create a warped velocity field. Based on paraform task CANDY.
C# Task Imaging Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000, 2009, 2017
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INFILE         FILEIN        Input file.
C      SOURCE         SOURCE        Object name.
C      IMSIZE         XMSIZ         Image size in pixels.
C      CELLSIZE       CELLS         Pixel size in first two dim.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLAOUT        Class of the output image.
C                                   Default is input class.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      APARM(10)      APARM         User specified array.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'MODVF.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'MODVF '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file.
      CALL MODIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Populates array with velocities
      CALL MODFIL (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Writes array as AIPS image.
      CALL MODMAP (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       History
      CALL MODHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE MODIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   MODIN gets input parameters for MODVF and creates an output file.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                     4 => user routine detected error.
C                     5 => catalog troubles
C                     8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      CHARACTER BLANK*6, DEFNAM*12, OLDNAM*12
      INTEGER   IERR, NPARM, IROUND
      LOGICAL   T, F
      INCLUDE 'MODVF.INC'
      INCLUDE 'TABEL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA BLANK /'      '/
      DATA T, F /.TRUE.,.FALSE./
C
C                                       Change this default output name
      DATA DEFNAM /'MODVF MAP   '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Init CATBLK.
      CALL FILL (256, 0, CATBLK)
C                                       Get input parameters.
      NPARM = 36
      CALL GTPARM (PRGN, NPARM, RQUICK, XFILEI, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
            END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFFER, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQOUT = IROUND (XSEQO)
      DISKO = IROUND (XDISKO)
C                                       Characters
      CALL H2CHR (48, 1, XFILEI, FILEIN)
      CALL H2CHR (8, 1, XSOURC, SOURCE)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       image size, central position
      IF ((XMSIZ(1).LT.2.) .OR. (XMSIZ(1).GT.XDIM)) XMSIZ(1) = XDIM
      IF ((XMSIZ(2).LT.2.) .OR. (XMSIZ(2).GT.XDIM)) XMSIZ(2) = XDIM
      IF (APARM(1).LT.1.0) APARM(1) = 0.5 * XMSIZ(1)
      IF (APARM(2).LT.1.0) APARM(2) = 0.5 * XMSIZ(2) + 1
      IF (XINC.EQ.0.0) THEN
         MSGTXT = 'XINC *has* to be specified'
         IERR = 10
         GO TO 999
         END IF
C                                       Initialize arrays
      NPARM = XDIM * XDIM
      CALL FILL  (NPARM, 0,      NVELO)
      CALL RFILL (NPARM, FBLANK, VELOC)
C                                       Create new file.
C                                       Put values in CATBLK.
      OLDNAM = DEFNAM
      CALL MAKOUT (OLDNAM, BLANK, 0, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
      CATBLK(KIIMS) = SEQOUT
C                                       Get user modification to CATBLK
      IRET = 4
      CALL NEWHED (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create output file.
      NEWCNO = 1
      IRET = 4
      CALL MCREAT (DISKO, NEWCNO, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
C                                       Set obs. date=current date.
      CATH(KHDOB) = CATH(KHDMP)
      CATH(KHDOB+1) = CATH(KHDMP+1)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MODIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1060 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE MODMAP (IRET)
C-----------------------------------------------------------------------
C   MODMAP fills an AIPS image with data from the array VELOC
C   Output:
C      IRET   I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   LUNO, BOTEMP, NXO, NYO, WINO(4), BOO, LIM2, LIM3, LIM4,
     *   LIM5, LIM6, LIM7, IB, I1, I2, I3, I4, I5, I6, I7, IPOS(7),
     *   LIMO, LIMIT, OBIND, LUN1, LUN2, INDO, LIM1
      REAL      OUTMAX, OUTMIN
      CHARACTER IFILE*48, REST*4
      LOGICAL   T, F, BLNKD
      INCLUDE 'MODVF.INC'
      INCLUDE 'TABEL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNO, LUN1, LUN2 /16,17,18/
      DATA REST /'REST'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Create scratch file.
C                                       Open vis file for write
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Setup for I/O
      NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      OUTMAX = -1.0E20
      OUTMIN = 1.0E20
      BLNKD = F
C                                       Setup for looping
      LIM1 = MAX (1, CATBLK(KINAX))
      LIM2 = MAX (1, CATBLK(KINAX+1))
      LIM3 = MAX (1, CATBLK(KINAX+2))
      LIM4 = MAX (1, CATBLK(KINAX+3))
      LIM5 = MAX (1, CATBLK(KINAX+4))
      LIM6 = MAX (1, CATBLK(KINAX+5))
      LIM7 = MAX (1, CATBLK(KINAX+6))
      IPOS(1) = 1
      LIMO = CATBLK(KINAX) - 1
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = I4
                  DO 300 I3 = 1,LIM3
      IPOS(3) = I3
C                                       Init output file.
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IPOS(3), BOTEMP, IRET)
      BOO = BOTEMP + 1
      CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO, BUFFER, JBUFSZ,
     *   BOO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) 'WRIT', IRET
         GO TO 990
         END IF
      DO 250 I2 = 1,LIM2
         IPOS(2) = I2
C                                       Write.
         CALL MDISK ('WRIT', LUNO, INDO, BUFFER, OBIND, IRET)
         OBIND = OBIND - 1
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1120) 'WRIT', IRET
            GO TO 990
            END IF
C                                       Call MAKMAP
         OBIND = OBIND + 1
C         CALL MAKMAP (IPOS, BUFFER(OBIND), IRET)
C         IF (IRET.NE.0) THEN
C            WRITE (MSGTXT,1180) IRET
C            GO TO 990
C            END IF
C
C                                       Check max, min, blanking.
         LIMIT = OBIND + LIMO
         DO 200 IB = OBIND,LIMIT
            I1 = IB - OBIND + 1
            BUFFER(IB) = VELOC(I1,I2)
            BLNKD = BLNKD .OR. (BUFFER(IB).EQ.FBLANK)
            IF (BUFFER(IB).EQ.FBLANK) GO TO 200
               OUTMAX = MAX (OUTMAX, BUFFER(IB))
               OUTMIN = MIN (OUTMIN, BUFFER(IB))
 200           CONTINUE
 250     CONTINUE
C                                       Dump plane to output.
C                                       Flush buffer.
      CALL MDISK ('FINI', LUNO, INDO, BUFFER, OBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1120) 'FINI', IRET
         GO TO 990
         END IF
C                                       Update CATBLK.
 260  CATR(KRDMX) = OUTMAX
      CATR(KRDMN) = OUTMIN
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, REST, BUFFER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1260) IRET
         GO TO 990
         END IF
 300  CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Mark blanking in CATBLK.
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
C                                       Close files
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('MODMAP: ERROR',I3,' OPENING SCRATCH FILE')
 1100 FORMAT ('MODMAP: INIT-FOR-',A4,' ERROR',I3)
 1120 FORMAT ('MODMAP: ',A4,' ERROR',I3)
 1180 FORMAT ('MODMAP: MAKMAP ERROR',I3)
 1260 FORMAT ('MODMAP: CATIO ERROR',I3,' UPDATING CATBLK')
      END
      SUBROUTINE MODHIS
C-----------------------------------------------------------------------
C   MODHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER ATIME*8, ADATE*12, HILINE*72, LABEL*8, REST*4
      INTEGER   LUN, IERR, I, TIME(3), DATE(3)
      LOGICAL   T, F
      INCLUDE 'MODVF.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN /27/
      DATA REST /'REST'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Create/open hist. file.
      CALL HICREA (LUN, DISKO, NEWCNO, CATBLK, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Get current date/time.
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
C                                       Write first record.
      WRITE (HILINE,1010) TSKNAM, NLUSER, ADATE, ATIME
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       New history
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN,
     *   BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       SOURCE
      WRITE (HILINE,2000) TSKNAM, SOURCE
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       IMSIZE
      WRITE (HILINE,2001) TSKNAM, XMSIZ
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       CELLSIZE
      WRITE (HILINE,2002) TSKNAM, CELLS
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       AIPS release
      WRITE (HILINE,2004) TSKNAM, RLSNAM
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any user supplied history.
      IF (NUMHIS.GT.0) THEN
         WRITE (LABEL,1011) TSKNAM
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
         END IF
C                                       Close HI file
 200  CALL HICLOS (LUN, T, BUFFER, IERR)
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, REST, BUFFER,
     *   IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MODHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,'/ Image created by user',I5,' at ',A12,2X,A8)
 1011 FORMAT (A6,' /')
 2000 FORMAT (A6,' SOURCE = ''',A,'''')
 2001 FORMAT (A6,' IMSIZE = ', 2F8.0)
 2002 FORMAT (A6,' CELLSIZE = ',2F10.5)
 2004 FORMAT (A6,' RELEASE = ''',A7,' ''')
      END
      SUBROUTINE NEWHED (IRET)
C-----------------------------------------------------------------------
C   NEWHED is a routine in which the user performs several operations
C   associated with beginning the task.  For many purposes simply
C   changing some of the values in the DATA statments will be all that
C   is necessary.  The following functions are/can be preformed
C   in NEWHED:
C       1) Creating the catalog header block to represent the
C   output file.  The MINIMUM information required here is that
C   required to define the size of the output file; ie.
C      CATBLK(KIDIM)= the number of axes,
C      CATBLK(KINAX+i) = the dimension of each axis, and
C      CATBLK(KIBPX) => 2 = real*4 pixel values.
C   Other changes can be made either here or in MAKMAP; the
C   catalog block will be updated when the history file is
C   written.
C
C    Input:
C     CATBLK    I(256)  Output catalog header, also CATR, CATD
C                       The OUTNAME, OUTCLASS, OUTSEQ are entered
C                       elsewhere.
C    Output:
C     CATBLK    I(256)  Modified output catalog header.
C     IRET      I       Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER FCHARS(3)*4, BLANK*8, ATYPES(7)*8
      INTEGER   I, NAXIS, IROUND, INDEX
      INCLUDE 'MODVF.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA FCHARS /'FREQ','VELO','FELO'/
      DATA  BLANK /'        '/
C                                       User definable values
C                                       Number of axes and types.
C                                       (Set for two axes = Ra, Dec.)
      DATA NAXIS  /2/
      DATA ATYPES /'RA---SIN', 'DEC--SIN',
     *   'STOKES  ', 'FREQ    ', 3*'       '/
C-----------------------------------------------------------------------
C                                       Fill axis arrays.
      DO 30 I = 1,KICTPN
C                                       Init dimension
         CATBLK(KINAX+I-1) = 1
C                                       Init. increment.
         CATR(KRCIC+I-1) = 0.0
C                                       Init. ref pixel.
         CATR(KRCRP+I-1) = 1.0
C                                       Init. ref value.
         CATD(KDCRV+I-1) = 0.0D0
C                                       Fill axis type from
C                                       ATYPES or BLANK.
         INDEX = KHCTP + (I-1) * 2
         CALL CHR2H (8, BLANK, 1, CATH(INDEX))
         IF (I.LE.NAXIS)
     *      CALL CHR2H (8, ATYPES(I), 1, CATH(INDEX))
C                                       Blank Random axes.
         INDEX = KHPTP + (I-1) * 2
         CALL CHR2H (8, BLANK, 1, CATH(INDEX))
 30      CONTINUE
C                                       Fill in values.
      CATBLK(KINAX)   = MAX (IROUND (XMSIZ(1)), 1)
      CATBLK(KINAX+1) = MAX (IROUND (XMSIZ(2)), 1)
C                                       Assume CELLSIZE in sec.
C                                       NOTE: Ra decreases with
C                                       grid number.
      CATR(KRCIC)   = - CELLS(1) / 3600.
      CATR(KRCIC+1) =   CELLS(2) / 3600.
C                                       Fill other character strings.
C                                       Object.
      CALL CHR2H (8, SOURCE, 1, CATH(KHOBJ))
C                                       Observation date.
      CALL CHR2H (8, BLANK, 1, CATH(KHDOB))
C                                       Telescope.
      CALL CHR2H (8, BLANK, 1, CATH(KHTEL))
C                                       Receiver
      CALL CHR2H (8, BLANK, 1, CATH(KHINS))
C                                       Observer's name.
      CALL CHR2H (8, BLANK, 1, CATH(KHOBS))
C                                       Set number of axes.
      CATBLK(KIDIM) = NAXIS
      CATBLK(KIPCN) = 0
C                                       User ID
      CATBLK(KIIMU) = NLUSER
C                                       Miscellaneous items.
C                                       Epoch.
      CATR(KREPO) = 0.0
C                                       Convolving beam
      CATR(KRBMJ) = 0.0
      CATR(KRBMN) = 0.0
      CATR(KRBPA) = 0.0
C                                       Max. min.
      CATR(KRDMX) = 0.0
      CATR(KRDMN) = 0.0
C                                       Put other checks here.
C                                       Finished.
      IRET = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE MODFIL (IERR)
C-----------------------------------------------------------------------
C MODFIL reads INFILE and calls CTS.
C-----------------------------------------------------------------------
      INTEGER I, KBP, IERR, TXLUN, JTRIM, KSIZ
      REAL    RNGL
      DOUBLE PRECISION XIN
      CHARACTER LINE*132
      LOGICAL F
      INCLUDE 'MODVF.INC'
      INCLUDE 'TABEL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DERR.INC'
C
      DATA TXLUN /10/
C-----------------------------------------------------------------------
C                                       Open input file
      CALL ZTXOPN ('READ', TXLUN, FINDIN, FILEIN, F, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'Opening'
         GO TO 990
         END IF
      I    = 0
      RNGL = 0.0
 10      CALL ZTXIO ('READ', TXLUN, FINDIN, LINE, IERR)
         IF (IERR.EQ.2) GO TO 50
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'Reading'
            GO TO 990
            END IF
         KSIZ = JTRIM (LINE)
         IF ((LINE.EQ.' ') .OR. (LINE(:1).EQ.'$') .OR.
     *      (LINE(:1).EQ.'#')) GO TO 10
         I = I + 1
         IF (I.LE.PDIM) GO TO 20
            I = I - 1
            WRITE (MSGTXT,1020)
            GO TO 50
C                                   Process LINE
 20      KBP = 1
         ERRNUM = 0
         CALL GETNUM (LINE, KSIZ, KBP, XIN)
         IF (ERRNUM.NE.0) GO TO 980
         RING(I) = XIN
         RNGM(I) = (RING(I) + RNGL) / 2.0
         RNGL    = RING(I)
         IF (KBP.LE.KSIZ) THEN
            CALL GETNUM (LINE, KSIZ, KBP, XIN)
            IF (ERRNUM.NE.0) GO TO 980
            VROT(I) = XIN
         ELSE
            VROT(I) = 0.0
            END IF
         IF (KBP.LE.KSIZ) THEN
            CALL GETNUM (LINE, KSIZ, KBP, XIN)
            IF (ERRNUM.NE.0) GO TO 980
            WARP(I) = XIN
         ELSE
            WARP(I) = 0.0
            END IF
         IF (KBP.LE.KSIZ) THEN
            CALL GETNUM (LINE, KSIZ, KBP, XIN)
            IF (ERRNUM.NE.0) GO TO 980
            OMEG(I) = XIN
         ELSE
            OMEG(I) = 0.0
            END IF
         WRITE (MSGTXT,1020) I, RING(I), VROT(I), WARP(I), OMEG(I)
         CALL MSGWRT (2)
         GO TO 10

 50   CALL ZTXCLS (TXLUN, FINDIN, IERR)
      NRING      = I
      NANNU      = RING(NRING) / XINC
C                                   Now populate the velocity field
      CALL CTS
      GO TO 990
C                                    problems
 980  WRITE (MSGTXT,1980) I
      CALL MSGWRT (8)
      MSGTXT = 'LINE=''' // LINE
      CALL MSGWRT (8)
      IERR = ERRNUM
C
 990  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR ',I3,1X,A,' Text File')
 1020 FORMAT ('ERROR: list longer than 500. Using first 500')
 1980 FORMAT ('ERROR PARSING INFILE LINE',I3)
      END
      SUBROUTINE CTS
C-----------------------------------------------------------------------
C This subroutine uses the algorithm by Christodoulou, Tohline, and
C Steiman-Cameron to create a velocity field of a galaxy based on a
C tilted-ring model.
C-----------------------------------------------------------------------
C
C
C                                      Declarations
      INTEGER IX, IY
      INTEGER IANNU, ISEGM, NSEGM, IRING
      REAL    PAREF, INREF, RAANN, VCRNG, PARNG, WARNG, PASEG, DPSEG,
     *        CPARF, SPARF, CINRF, SINRF, CPARN, SPARN, CWARN, SWARN,
     *        CPASG, SPASG, TERM1, TERM2, MSEGM, RINGL, RINGU, FACTR,
     *        RRANG, VRANG, WRANG, ORANG, VOFFS, WOFFS, OOFFS, VROTL,
     *        WARPL, OMEGL
      REAL    SPCW,  CPCW,  KSI, ETA, VEL
      DOUBLE PRECISION A2R
      INCLUDE 'MODVF.INC'
      INCLUDE 'TABEL.INC'
      DATA A2R  /1.7453292519943296D-02/
C
C Two concepts are important: 1) annuli, 2) rings. Annuli are thin
C rings the thickness of which is defined by XINC. One annulus and
C one segment define a pixel in the plane of the tilted ring. This
C pixel is mapped onto the sky plane. Rings are - usually - much
C wider annuli in which the crucial variables VROT, WARP, and OMEG
C are assumed to be constant. In fact, MODVF will do a linear inter-
C polation to avoid jagged velocity contours. The current routine
C loops over annuli, and updates VROT, WARP, and OMEG whenever a new
C annulus has reached a new RING. The inner ring - which is a small
C disk - is referred to as the reference disk.
C                                      Define reference-disk variables
      PAREF = (APARM(3) + 180.0) * A2R
      INREF = APARM(4)* A2R
      CPARF = COS (PAREF)
      SPARF = SIN (PAREF)
      CINRF = COS (INREF)
      SINRF = SIN (INREF)
      MSEGM = 2.0 * 3.14159265 / XINC
C                                      # and size of inner annulus of
C                                      current ring.
      IRING = 0
      RINGL = 0.0
      RINGU = 0.0
      VROTL = VROT(1)
      WARPL = WARP(1)
      OMEGL = OMEG(1)
C                                      Initialize arrays
C                                      Begin loop over all annuli
      DO 200 IANNU = 1, NANNU
C                                      Variables for annulus: radius,
C                                      # segments, radians/segment
         RAANN = IANNU * XINC
         NSEGM = NINT (MSEGM * RAANN)
         DPSEG = 360.0 / NSEGM * A2R
C                                      Is annulus in new ring? If so,
C                                      update common variables. For last
C                                      ring, use extrapolation.
         IF (RAANN.GT.RINGU.AND.IRING.NE.NRING) THEN
            IRING = IRING + 1
            RINGL = RINGU
            RINGU = RNGM(IRING)
            RRANG = RNGM(IRING) - RINGL
            VRANG = VROT(IRING) - VROTL
            WRANG = WARP(IRING) - WARPL
            ORANG = OMEG(IRING) - OMEGL
            VOFFS = VROTL
            WOFFS = WARPL
            OOFFS = OMEGL
            VROTL = VROT(IRING)
            WARPL = WARP(IRING)
            OMEGL = OMEG(IRING)
            END IF
         FACTR = (RAANN - RINGL) / RRANG
         VCRNG = (FACTR * VRANG + VOFFS)
         WARNG = (FACTR * WRANG + WOFFS) * A2R
         PARNG = (FACTR * ORANG + OOFFS) * A2R
         CPARN = COS (PARNG)
         SPARN = SIN (PARNG)
         CWARN = COS (WARNG)
         SWARN = SIN (WARNG)
C                                      'popular' products
         SPCW  = SPARN * CWARN
         CPCW  = CPARN * CWARN
C                                      Begin loop ring segments
         DO 100 ISEGM = 1, NSEGM
C                                      Variables for this segment
            PASEG = (ISEGM - 1) * DPSEG
            CPASG = COS (PASEG)
            SPASG = SIN (PASEG)
C                                      Build up formulas
            TERM1 =  CPASG * CPARN - SPASG * SPCW
            TERM2 = (CPASG * SPARN + SPASG * CPCW) * CINRF -
     1               SPASG * SWARN * SINRF
C
            KSI = RAANN *  (CPARF * TERM1 - SPARF * TERM2) / CELLS(2)
            ETA = RAANN *  (SPARF * TERM1 + CPARF * TERM2) / CELLS(1)
            VEL = 1000.0 * (VCRNG * ((SPASG * SPARN - CPASG * CPCW)
     1            * SINRF - CPASG * SWARN * CINRF) + APARM(5))
C                                      ETA, KSI in map?
            IX =  NINT (APARM(1) - ETA)
            IY =  NINT (APARM(2) + KSI)
            IF (IX.LE.XMSIZ(1).AND.IX.GE.1.0 .AND.
     1          IY.LE.XMSIZ(2).AND.IY.GE.1.0) THEN
C                                      add value to array
               IF (NVELO(IX,IY).EQ.0) THEN
                  VELOC(IX,IY) = VEL
               ELSE
                  VELOC(IX,IY) = (VELOC(IX,IY) * NVELO(IX,IY)
     1               + VEL) / (NVELO(IX,IY) + 1)
                  END IF
               NVELO(IX,IY) = NVELO(IX,IY) + 1
               END IF
C                                      End loop ring segments
 100        CONTINUE
C                                      End loop over all rings
 200     CONTINUE
C
      RETURN
      END

      SUBROUTINE TEKFLS (IERR)
C-----------------------------------------------------------------------
C! writes any remaining buffer to the TK graphics device, zeros buffer
C# Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TEKFLS will write the output buffer TKBUFF to the TEKTRONIX 4012.
C   Output:
C      IERR     I   error flag. 0=ok,  .GT. 1=write error from ZFIO
C   All data and pointers come from DTKS.INC common.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'INCS:DTKS.INC'
C-----------------------------------------------------------------------
      IF (TKPOS.GT.0) THEN
         CALL ZFIO ('WRIT', TKLUN, TKFIND, TKPOS, TKBUFF, IERR)
      ELSE
         IERR = 0
         END IF
C                                       clear
      TKPOS = 0
      CALL RFILL (TKSIZE, 0.0, TKBUFF)
C
 999  RETURN
      END

      SUBROUTINE HICLOS (HLUN, UPDATE, BUFFER, IERR)
C-----------------------------------------------------------------------
C! closes a history file, flushing the buffer if desired
C# History
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   HICLOS closes a history file updating it if requested.
C   Inputs:
C      HLUN    I         file LUN (already open!!)
C      UPDATE  L         T => write last record & update pointers
C   In/out:
C      BUFFER  I(256)    HI work buffer
C   Output:
C      IERR    I         error code : 0 - ok
C                                     1 - LUN not open
C                                   2-6 - ZFIO errors
C-----------------------------------------------------------------------
      INTEGER   HLUN, BUFFER(256), IERR
      LOGICAL   UPDATE
C
      INTEGER   HPTR, IER, HIND, INREC, LSIZE
      CHARACTER HNAME*48
      INCLUDE 'INCS:DHIS.INC'
C-----------------------------------------------------------------------
C                                        locate in HITAB
      IERR = 1
      CALL HILOCT ('SRCH', HLUN, HPTR, IER)
      IF (IER.NE.0) GO TO 999
C                                        do update
      IERR = 0
      IF (UPDATE) THEN
         INREC = HITAB (HPTR+6)
         IF (INREC.GT.1) THEN
            CALL HIIO ('WRIT', HPTR, INREC, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 50
            END IF
         IF (INREC.NE.1) THEN
            CALL HIIO ('READ', HPTR, 1, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 50
            END IF
C                                       compression?
         IF (HITAB(HPTR+3)-HITAB(HPTR+2).GT.10*NHILPR) THEN
            LSIZE = (HITAB(HPTR+2)-1) / NHILPR + 12
            CALL ZPHFIL ('HI', HITAB(HPTR+4), HITAB(HPTR+5), 1, HNAME,
     *         IERR)
            CALL ZCMPRS (HITAB(HPTR+4), HNAME, HLUN, LSIZE, IERR)
            HITAB(HPTR+3) = LSIZE * NHILPR
            END IF
C                                       update pointers
         BUFFER(1) = HITAB (HPTR+2)
         BUFFER(2) = HITAB (HPTR+3)
         CALL HIIO ('WRIT', HPTR, 1, BUFFER, IERR)
         END IF
C                                        do close
 50   HIND = HITAB (HPTR+1)
      CALL FILL (NHIWRD, 0, HITAB(HPTR))
      CALL ZCLOSE (HLUN, HIND, IER)
C
 999  RETURN
      END

      SUBROUTINE BLSEL (DISKI, CNOI, DISKO, CNOO, VER, CATIN, CATOUT,
     *   LUNI, LUNO, BPOL, EPOL, AN, NA, ISUB, JSUB, BIF, EIF, IFQID,
     *   BUFFER, OBUFF, IRET)
C-----------------------------------------------------------------------
C! Copies a subset of IFs in a BL table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2007, 2011
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Copies a subset of IFs in a BL table, can also modify the FQ ID
C   Inputs:
C      DISKI    I        Input volume number
C      CNOI     I        Input catalog number
C      DISKO    I        Output volume number
C      CNOO     I        Output catalog number
C      VER      I        Version to check/modify
C      CATIN    I(256)   Input catalog header
C      LUNI     I        LUN to use - in
C      LUNO     I        LUN to use - out
C      BPOL     I        First polarization to copy
C      EPOL     I        Last polarization to copy
C      AN       I(*)     Array of selected antennas
C      NA       I        Number of selected antennas
C      ISUB     I        Selected subarray (= 0 any)
C      JSUB     I        Output subarray number (< 0 => NO CHANGE)
C      BIF      I        BIF used
C      EIF      I        EIF used
C   Input/Output:
C      CATOUT   I(256)   Output catalog header
C      BUFFER   I(*)     Work buffer
C      OBUFF    I(*)     Work buffer
C   Output:
C      IRET     I        Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER   DISKI, CNOI, DISKO, CNOO, VER, CATIN(256), CATOUT(256),
     *   LUNI, LUNO, AN(*), NA, BPOL, EPOL, ISUB, JSUB, BIF, EIF, IFQID,
     *   BUFFER(*), OBUFF(*), IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IBLRNO, BLKOLS(MAXBLC), BLNUMV(MAXBLC), OKOLS(MAXBLC),
     *   ONUMV(MAXBLC), NBLROW, I, OVER, ANT1, ANT2, SUBA, OBLRNO, K,
     *   NUMANT, NUMPOL, NUMIF, LNUMIF, SOURID, FREQID, J, NEWPOL, LBIF,
     *   LBPOL, L, M
      LOGICAL   REFMT, GOTIT
      REAL      TIME, FACMUL(2,2,MAXIF), FACADD(2,2,MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       Open BL file
      CALL BLINI ('READ', BUFFER, DISKI, CNOI, VER, CATIN, LUNI, IBLRNO,
     *   BLKOLS, BLNUMV, NUMANT, NUMPOL, NUMIF, IRET)
      IF (IRET.EQ.2) THEN
         IRET = 0
         GO TO 999
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       # rows in old table
      NBLROW = BUFFER(5)
C                                       Open up new BL table
      OVER = VER
      LNUMIF = EIF - BIF + 1
      LBIF = BIF
      IF (LNUMIF.LE.0) THEN
         LNUMIF = NUMIF
         LBIF = 1
         END IF
      REFMT = LNUMIF.NE.NUMIF
      LBPOL = MAX (1, BPOL)
      NEWPOL = MIN (2, MIN (NUMPOL, EPOL)) - LBPOL + 1
      IF (NEWPOL.LE.0) THEN
         LBPOL = 1
         NEWPOL = NUMPOL
         END IF
      REFMT = REFMT .OR. (NEWPOL.NE.NUMPOL)
      CALL BLINI ('WRIT', OBUFF, DISKO, CNOO, OVER, CATOUT, LUNO,
     *   OBLRNO, OKOLS, ONUMV, NUMANT, NEWPOL, LNUMIF, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 100 I = 1,NBLROW
         CALL TABBL ('READ', BUFFER, IBLRNO, BLKOLS, BLNUMV, NUMPOL,
     *      TIME, SOURID, SUBA, ANT1, ANT2, FREQID, FACMUL, FACADD,
     *      IRET)
C                                       Error reading table
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1020) IRET
            GO TO 990
C                                       check subarray, time
         ELSE IF (IRET.EQ.0) THEN
            IF ((SUBA.GT.0) .AND. (ISUB.GT.0) .AND. (JSUB.NE.SUBA))
     *         IRET = -1
            IF ((IFQID.GT.0) .AND. (FREQID.GT.0) .AND.
     *         (IFQID.NE.FREQID)) IRET = -1
C                                       antenna
            IF ((NA.GT.0) .AND. (ANT1.GT.0)) THEN
               GOTIT = .FALSE.
               DO 10 K = 1,NA
                  GOTIT = GOTIT .OR. (ANT1.EQ.AN(K))
 10               CONTINUE
               IF (.NOT.GOTIT) IRET = -1
               END IF
            IF ((NA.GT.0) .AND. (ANT2.GT.0)) THEN
               GOTIT = .FALSE.
               DO 20 K = 1,NA
                  GOTIT = GOTIT .OR. (ANT2.EQ.AN(K))
 20               CONTINUE
               IF (.NOT.GOTIT) IRET = -1
               END IF
            END IF
C                                       This record dropped
         IF (IRET.LT.0) THEN
            REFMT = .TRUE.
C                                       This record kept
         ELSE
C                                       select IFs
            DO 50 J = 1,LNUMIF
               K = J + LBIF - 1
               DO 40 L = 1,NEWPOL
                  M = L + LBPOL - 1
                  FACMUL(1,L,J) = FACMUL(1,M,K)
                  FACMUL(2,L,J) = FACMUL(2,M,K)
 40               CONTINUE
 50            CONTINUE
C                                       Write new one
            IF ((JSUB.GE.0) .AND. (SUBA.GT.0)) SUBA = JSUB
            IF (IFQID.GT.0) FREQID = 1
            CALL TABBL ('WRIT', OBUFF, OBLRNO, OKOLS, ONUMV, NEWPOL,
     *         TIME, SOURID, SUBA, ANT1, ANT2, FREQID, FACMUL, FACADD,
     *         IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1020) IRET
               GO TO 990
               END IF
            END IF
 100     CONTINUE
      IRET = 0
C                                       Close both tables
      CALL TABIO ('CLOS', 0, IBLRNO, BUFFER, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OBLRNO, OBUFF, OBUFF, IRET)
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         IF (REFMT) THEN
            WRITE (MSGTXT,1100) 'Reformatted BL', DISKI, CNOI, VER,
     *         DISKO, CNOO, OVER
         ELSE
            WRITE (MSGTXT,1100) 'Copied BL', DISKI, CNOI, VER, DISKO,
     *         CNOO, OVER
            END IF
         CALL MSGWRT (3)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('BLSEL: ERROR ',I3,' RETURNED FROM BLINI')
 1020 FORMAT ('BLSEL: ERROR ',I3,' RETURNED FROM TABBL')
 1100 FORMAT (A,' file from vol/cno/vers',I3,I5,I4,' to',I3,I5,I4)
      END

@PROCESS DIR('ibmdir:')
      subroutine s2ibm(n,src,out)                                       
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C---------------------------------------------------------------------- 
C     PURPOSE:                                                          
C        Subroutine S2IBM converts IEEE 32 bit floating point numbers   
C        into IBM 32 bit floating point numbers.  IEEE numbers with an  
C        exponent larger than can be represented by IBM floating point  
C        are set to the maximum IBM floating point number. Likewise,    
C        IEEE numbers with an exponent too small for IBM floating point 
C        are set to zero, with the sign retained. No errors are         
C        reported.                                                      
C                                                                       
C                                                                       
C     ARGUMENTS:                                                        
c     n   - length of real*4 array                                      
c     src  - array of single precision IEEE floating point numbers of    
c           length n                                                    
c     out - output array of single precision IBM floating point numbers
c           length n                                                    
C                                                                       
C        This subroutine assumes all input are normalized floating      
C        point numbers.                                                 
C                                                                       
C IBM/370 Single Precision:                                             
C        xxxx.xxxx xxxx.xxxx xxxx.xxxx xxxx.xxxx                        
C         |--exp-|-------fraction--------------|                        
C           (7)           (24)                                          
C   value = (-1)**s * 16**(e-64) * 0.f    range = 5E-79... 7E+75        
C                                                                       
C IEEE Single Precision:                                                
C        xxxx.xxxx xxxx.xxxx xxxx.xxxx xxxx.xxxx                        
C         |--exp------| |---fraction---------------|                    
C            (8)             (23)                                       
C   value = (-1)**s * 2**(e-127) * 1.f    range = 1E-38... 3E+38        
C                                                                       
C---------------------------------------------------------------------- 
C                                                                       
c  src & out treated as integer for bit manipulation                    
      implicit none                                                     
      integer*4 n,src(n),out(n)                                         
      integer*4 i,itemp                                                 
      integer*4 s,frac,expon                                            
c                                                                       
      integer*4 fmaxibm                                                 
      integer*4 z7fffffff                                               
      integer*4 z80000000                                               
      integer*4 z7f800000                                               
      integer*4 z01000000                                               
      integer*4 z0f000000                                               
      integer*4 z007fffff                                               
      integer*4 z00000003                                               
      data fmaxibm/z7fffffff/                                           
      data z7fffffff/z7fffffff/                                         
      data z80000000/z80000000/                                         
      data z7f800000/z7f800000/                                         
      data z01000000/z01000000/                                         
      data z0f000000/z0f000000/                                         
      data z007fffff/z007fffff/                                         
      data z00000003/z00000003/                                         
c                                                                       
cibmdir: ignore recrdeps                                                
      do 100 i=1,n                                                      
c                                                                       
c       special case--if source = 0, return ibm 0                       
c                                                                       
        if (iand(src(i),z7fffffff).eq.0) then                           
          out(i) = src(i)                                               
c                                                                       
        else                                                            
          s = iand(src(i),z80000000)                                    
          expon = ishft(iand(src(i),z7f800000),-23) - 127               
          frac = iand(src(i),z007fffff)                                 
c                                                                       
c         convert 23 bit fraction to 24 bit fraction                    
c                                                                       
          frac = ishft(frac,1)                                          
c                                                                       
c         restore the implied '1' which preceeded the IEEE binary point 
c                                                                       
          frac = ior(frac,z01000000)                                    
c                                                                       
c         convert scale factor from 2**exponent to 16**exponent format  
c         adjust fraction and exponent in opposite directions until     
c         exponent is a multiple of 4, then divide the exponent by 4    
c                                                                       
          if (expon.ge.0) then                                          
            itemp = iand(expon,z00000003)                               
            frac = ishft(frac,itemp)                                   
            expon = ishft(expon,-2)                                     
          else                                                          
            itemp = iand(-expon,z00000003)                              
            frac = ishft(frac,-itemp)                                    
            expon = -ishft(-expon,-2)                                   
          endif                                                         
c                                                                       
c         reduce fraction to 24 bits                                    
c                                                                       
          if (iand(frac,z0f000000).ne.0) then                           
            frac = ishft(frac,-4)                                       
            expon = expon + 1                                           
          endif                                                         
c                                                                       
c         convert exponent to excess 64                                 
c                                                                       
          expon = expon + 64                                            
          if (expon.gt.127) then                                        
            out(i) = ior(s,fmaxibm)                                     
          else if (expon.lt.0) then                                     
            out(i) = s                                                  
          else                                                          
            out(i) = ior(s,ior(ishft(expon,24),frac))                   
          end if                                                        
        endif                                                           
100   continue                                                          
      return                                                            
      end                                                               

      SUBROUTINE AU7 (BRANCH)
C-----------------------------------------------------------------------
C! verbs to print history, rescale image, alter axis descriptions
C# POPS-appl Coordinates Header History Catalog
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-2002, 2004-2007, 2009, 2012, 2015-2016,
C;  Copyright (C) 2019, 2021, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AU7 verbs:
C   1. PRTHI    prints the history file for a given catalog entry.
C   2. RENAME   renames a catalog entry.
C   3. RESCALE  changes the scale factor and offset of a catalog image
C   4. CLRSTAT  clears a write and one read for a catalog entry.
C   5. AXDEFINE add or changes an axis description
C   6. ALTDEF   add alternative axis description for velocity.
C   7. ALTSWTCH switch to velocity or back to frequency on that axis.
C   8. CELGAL   switch between Celestial and Galactic coordinates
C   9. EPOSWTCH switch between B1950 and J2000 coordinates
C    **** COWINDOW now in AU7B ******
C  10. EPOCONV  switch coordinate adverbs between B1950 and J2000
C
C   Inputs:   (though adverbs in common)
C      INNAME   H*12  input file name.  If blank the first match
C                     consistent with the other parameters is used.
C      INCLASS  H*6   input file class.  If blank the first match is
C                     used.
C      INSEQ    R     the old entry's sequence number. If zero the first
C                     match consistent with the other parameters is used
C      INDISK   R     the catalog resides on this disk.  If zero, all
C                     disk volumes are searched until a match is found.
C   (PRTHI only)
C      HISTRT   R     start record number
C      HIEND    R     end record number
C      PRTASK   H*5   only records w this at start
C      OUTPRINT H*48  File name to save printed output
C   (RENAME only)
C      OUTNAME  H*12  the new name for the catalog entry.  If blank, the
C                     old name will be used.
C      OUTCLASS H*6   the new class.  If blank the old class is used.
C      OUTSEQ   R     the new sequence number.  If zero, the old
C                     sequence number will be used.
C   (RESCALE only)
C      FACTOR   R     factor to multiply current map by
C      OFFSET   R     offset to add to current map
C   (AXDEFINE only)
C      NAXIS    R     axis number to alter (<= NDIM+1)
C      AXTYPE   H     axis type (char(8)): blank illegal
C      AXREF    R     axis reference pixel - no default
C      AXVAL    R(2)  axis value at ref pixel no default
C      RAXINC   R     axis coord incr. (0 => no change)
C   (ALTDEF only)
C      AXVAL    R(2)   velocity at (new) reference pixel.
C      RESTFR   R(2)   rest frequency.
C      AXTYPE   R(2)   'OPT' or 'RAD' plus 'HEL','LSR', or 'OBS'
C      AXREF    R      new ref. pixel for velocity
C   (ALTSWTCH, CELGAL, EPOSWTCH : no special ones)
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER  PRGNAM*6, LOCNAM*12, LOCCLS*6, LOCTYP*2, STATUS*4,
     *   VRBNAM*6, RESCA*6, RENAM*6, TITL1*132, TITL2*132, PLINE*132,
     *   SCRTCH*132, PRTNAM*48, PRTACK*8, CRRTYP*8, NEWNAM*12, NEWCLS*6,
     *   HILINE*72, DEFCLS*6, AGECOM(2)*4, VELREF(5)*3, REAXIS*6,
     *   FRAXIS(3)*4, XAXTY(4)*4, YAXTY(4)*4, CGEOM(3)*4, TMPTYP*2,
     *   CDUM*1, LAXTYP*8, TABEP1*8, TABEP2*8, TABEP3*8, CRD1*40,
     *   CRD2*40, CRD3*40, LABEP1*80, LABEP2*80, LABEP3*80, OPTYPE*4,
     *   DHC*1, RHC*1, CSAVE*1, PSTRNG*16
      DOUBLE PRECISION DVZERO, FRLINE, DELNU, REFNU, VSIGN, RAGP, DECGP,
     *   LONCP, RA, DEC, GLAT, GLON, RHO, INFACT, DOFFS, JD, JD50, JD00,
     *   XIN, XOU, YIN, YOU, CRD13(11), ROTN13, X13, Y13
      REAL      PRINTR, R1BUF(MABFSS), R2BUF(MABFSS), RDUM(2), LAXREF,
     *   LAXINC, LAXVAL(2), RESTFR(2), EPOCIN, EPOCOU, EPOCOB,
     *   XCOORD(6), DH, RH
      INTEGER   IREC, IBLK, IBUFF(256), HIBUFF(256), JTRIM, ICUR, IEND,
     *   IERR, BREC, NUMCHR, IERR2, IFIND, ILUN, IMAX, IMOD, IOFFSQ,
     *   NPI, NACROS, ISEQN, LOCSEQ, ISLOT, IUSER, IVOL, IWORD, J, PAGE,
     *   POTERR, IHLUN, IHPTR, I, ICARD, IERH, IHIND, II, ILINE, NDIM,
     *   NLPR, NREC, NWPL, IAXCOD, IXA, IYA, ITA, NGEOM, NCR, NCW, PLUN,
     *   TMPVOL, TMPSLT, EREC, JJ, IDUM, DEPTH(5), IT(6), IROUND,
     *   NCOL, RHM(2), DHM(2), IDOCC, NUMSTR, SBREC, SEREC, JBLK, INB,
     *   INE, LCUR
      LOGICAL   EQUAL, EXCL, NOMAP, NOSAVE, SAVE, WAIT, T, F, QUIT,
     *   FOPEN, POPEN, BACK, INSIDE
      HOLLERITH HBUFF(256), HHBUFF(256)
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DIO.INC'
      COMMON /AIPSCR/ R1BUF, R2BUF
      EQUIVALENCE (T, WAIT, SAVE, EXCL)
      EQUIVALENCE (F, NOMAP, NOSAVE)
      EQUIVALENCE (IBUFF, HBUFF), (HIBUFF, HHBUFF)
      DATA T, F /.TRUE.,.FALSE./
      DATA IHLUN, ILUN, IOFFSQ /27, 15, 4/
      DATA PRGNAM /'AU7   '/
      DATA RENAM, RESCA /'RENAM ', 'RESCA '/
      DATA REAXIS, AGECOM /'AXDEF ', 'OLD ','NEW '/
      DATA VELREF /'LSR','HEL','OBS','OPT','RAD'/
      DATA FRAXIS /'FREQ','FELO','VELO'/
      DATA XAXTY /'LL  ','RA  ','RA--','GLON'/
      DATA YAXTY /'MM  ','DEC ','DEC-','GLAT'/
      DATA NGEOM, CGEOM /3, '-SIN','-TAN','-ARC'/
C-----------------------------------------------------------------------
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.10)) GO TO 999
C                                       Set initial values.
      POTERR = 0
      IF (BRANCH.NE.10) THEN
         NWPL = 10
         NLPR = 256 / NWPL
         CALL ADVERB ('INDISK', 'I', 1, 0, IVOL, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('INSEQ', 'I', 1, 0, LOCSEQ, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('INNAME', 'C', 1, 12, IDUM, RDUM, LOCNAM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('INCLASS', 'C', 1, 6, IDUM, RDUM, LOCCLS)
         IF (ERRNUM.NE.0) GO TO 980
         IUSER = NLUSER
         LOCTYP = ' '
         IF (BRANCH.EQ.3) LOCTYP = 'MA'
         ISLOT = 1
         CALL CATDIR ('SRCH', IVOL, ISLOT, LOCNAM, LOCCLS, LOCSEQ,
     *      LOCTYP, IUSER, STATUS, IBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020)
            CALL MSGWRT (8)
            POTERR = 101
            GO TO 980
            END IF
         END IF
C                                       Choose function.
      VRBNAM = RESCA
      GO TO (100, 200, 300, 400, 500, 600, 700, 800, 900, 950), BRANCH
C-----------------------------------------------------------------------
C                                       PRTHI
C                                       write history file for image.
C-----------------------------------------------------------------------
 100  CALL ADVERB ('HISTART', 'I', 1, 0, BREC, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('HIEND', 'I', 1, 0, EREC, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
C                                       PRTASK changed size
      CALL ADVERB ('PRTASK', 'C', 1, 8, IDUM, RDUM, PRTACK)
      IF (ERRNUM.NE.0) THEN
         ERRNUM = 0
         CALL ADVERB ('PRTASK', 'C', 1, 5, IDUM, RDUM, PRTACK)
         IF (ERRNUM.NE.0) GO TO 980
         END IF
      CALL ADVERB ('KEYSTRNG', 'C', 1, 16, IDUM, RDUM, PSTRNG)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('DOCRT', 'R', 1, 0, IDUM, RDUM, CDUM)
      PRINTR = RDUM(1)
      IF (ERRNUM.NE.0) GO TO 980
      IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) PRINTR =
     *      MIN (-1.0, PRINTR)
      FOPEN = .FALSE.
      POPEN = .FALSE.
C                                       Open history file.
      CALL HIOPEN (IHLUN, IVOL, ISLOT, HIBUFF, IERR)
      POTERR = 34
      IF (IERR.NE.0) GO TO 980
      PAGE = 0
      CALL HILOCT ('SRCH', IHLUN, IHPTR, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Determine no. of hist. recs.
      NREC = HITAB(IHPTR+2)
      IHIND = HITAB(IHPTR+1)
C                                       loop limits
      IF (EREC.LE.0) EREC = NREC
      IF (BREC.LE.0) BREC = 1
      BACK = EREC.LT.BREC
      IF (BACK) THEN
         SEREC = EREC
         SBREC = BREC
         BREC = SEREC
         EREC = SBREC
         END IF
      IF (BREC.GT.NREC) BREC = 1
      IF (EREC.GT.NREC) EREC = NREC
C                                       Open the line printer.
      IF (PRINTR.LE.0.0) THEN
         CALL ADVERB ('OUTPRINT', 'C', 1, 48, IDUM, RDUM, PRTNAM)
         IF (ERRNUM.NE.0) GO TO 980
         IF (PRTNAM.EQ.' ') THEN
            PRINTR = -1.0
C                                       do we really mean it?
            IF ((EREC-BREC.GE.400) .AND. ((IUNIT.EQ.1) .OR.
     *         (IUNIT.EQ.4))) THEN
C                                       Loop for no. of hist. recs.
               POTERR = 50
               IBLK = (BREC-1) / NHILPR + 1
               ICARD = BREC - (IBLK-1) * NHILPR
               CALL ZFIO ('READ', IHLUN, IHIND, IBLK, HIBUFF, IERR)
               IF (IERR.NE.0) GO TO 190
               ILINE = 0
               NUMCHR = JTRIM (PRTACK)
               NUMSTR = JTRIM (PSTRNG)
               DO 110 ICUR = BREC,EREC
C                                       Read next buffer.
                  IF (ICARD.GT.NHILPR) THEN
                     IBLK = IBLK + 1
                     ICARD = 1
                     CALL ZFIO ('READ', IHLUN, IHIND, IBLK, HIBUFF,
     *                  IERR)
                     IF (IERR.NE.0) GO TO 190
                     END IF
C                                       desired task?
                  II = (ICARD-1) * NHIWPL + 5
                  CALL H2CHR (72, 1, HHBUFF(II), PLINE(ITA:))
                  EQUAL = .TRUE.
                  IF (NUMCHR.GT.0) THEN
                     CALL CHBLNK (72, 1, PLINE(ITA:), NPI)
                     NPI = NPI + ITA - 1
                     EQUAL = PRTACK(1:NUMCHR).EQ.PLINE(NPI:NPI+NUMCHR-1)
                     END IF
                  IF ((NUMSTR.GT.0) .AND. (EQUAL)) THEN
                     JJ = INDEX (PLINE, PSTRNG(:NUMSTR))
                     IF (JJ.LE.0) EQUAL = .FALSE.
                     END IF
                  IF (EQUAL) ILINE = ILINE + 1
                  ICARD = ICARD + 1
 110              CONTINUE
               IF (ILINE.GE.400) THEN
                  WRITE (MSGTXT,1100) ILINE
                  CALL MSGWRT (3)
                  CALL CONFRM (J)
                  IF (J.GT.0) GO TO 190
                  END IF
               END IF
            END IF
         CALL LPOPEN (PRTNAM, PRINTR, PLUN, IFIND, NACROS, IBUFF, IERR)
         POPEN = IERR.EQ.0
C                                       Set values for crt.
      ELSE
         PLUN = 5
         PRTNAM = 'TTY'
         CALL LSERCH ('SRCH', PLUN, IFIND, NOMAP, IERR)
         CALL ZWINC (NCOL)
         NACROS = NCOL
         END IF
      POTERR = 57
      IF (IERR.NE.0) GO TO 190
      IF (NACROS.GE.80.) THEN
         NACROS = 80
         ITA = 9
      ELSE
         NACROS = 72
         ITA = 1
         END IF
C                                       open file
      CALL CATIO ('READ', IVOL, ISLOT, CATBLK, 'READ', IBUFF, IERR)
      POTERR = 33
      IF ((IERR.NE.0) .AND. ((IERR.LT.6) .OR. (IERR.GT.9))) GO TO 190
      FOPEN = .TRUE.
C                                       Test for erroneous no. of recs.
      IF ((NREC.LE.0) .OR. (NREC.GT.10000)) THEN
         WRITE (MSGTXT,1105) LOCNAM, LOCCLS, LOCSEQ, NREC
         CALL MSGWRT (7)
         IF ((NREC.LE.0) .OR. ((PRTNAM.EQ.' ') .AND. (NREC.GT.19000)))
     *      THEN
            POTERR = 32
            IERR = 101
            GO TO 190
            END IF
         END IF
C                                       Loop for no. of hist. recs.
      ILINE = 900
      POTERR = 50
      WRITE (TITL1,1110) LOCNAM, LOCCLS, LOCSEQ, NREC
      TITL2 = ' '
      PLINE = ' '
      IBLK = (BREC-1) / NHILPR + 1
      ICARD = BREC - (IBLK-1) * NHILPR
      CALL ZFIO ('READ', IHLUN, IHIND, IBLK, HIBUFF, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       once for -3
      IF (PRINTR.LE.-2.5) THEN
         CALL PRTALN (PLUN, IFIND, PRINTR, NACROS, TITL1, TITL2,
     *      TITL1, ILINE, PAGE, SCRTCH, QUIT)
         IF ((QUIT) .OR. (ERRNUM.NE.0)) GO TO 190
         END IF
C                                       string restrictions
      NUMCHR = JTRIM (PRTACK)
      NUMSTR = JTRIM (PSTRNG)
      IF (.NOT.BACK) THEN
         DO 120 ICUR = BREC,EREC
C                                       Read next buffer.
            IF (ICARD.GT.NHILPR) THEN
               IBLK = IBLK + 1
               ICARD = 1
               CALL ZFIO ('READ', IHLUN, IHIND, IBLK, HIBUFF, IERR)
               IF (IERR.NE.0) GO TO 190
               END IF
C                                       desired task?
            II = (ICARD-1) * NHIWPL + 5
            CALL H2CHR (72, 1, HHBUFF(II), PLINE(ITA:))
            EQUAL = .TRUE.
            IF (NUMCHR.GT.0) THEN
               CALL CHBLNK (72, 1, PLINE(ITA:), NPI)
               NPI = NPI + ITA - 1
               EQUAL = PRTACK(1:NUMCHR).EQ.PLINE(NPI:NPI+NUMCHR-1)
               END IF
            IF ((NUMSTR.GT.0) .AND. (EQUAL)) THEN
               JJ = INDEX (PLINE, PSTRNG(:NUMSTR))
               IF (JJ.LE.0) EQUAL = .FALSE.
               END IF
            IF (EQUAL) THEN
               IF (ITA.GT.1) WRITE (PLINE(1:ITA-1),1115) ICUR
               JJ = JTRIM (PLINE)
               CALL PRTALN (PLUN, IFIND, PRINTR, NACROS, TITL1, TITL2,
     *            PLINE, ILINE, PAGE, SCRTCH, QUIT)
               IF ((QUIT) .OR. (ERRNUM.NE.0)) GO TO 190
               END IF
            ICARD = ICARD + 1
 120     CONTINUE
C                                       backwards, no task
      ELSE IF (NUMCHR.LE.0) THEN
         DO 125 ICUR = EREC,BREC,-1
            JBLK = (ICUR-1) / NHILPR + 1
            ICARD = ICUR - (JBLK-1) * NHILPR
C                                       Read next buffer.
            IF (JBLK.NE.IBLK) THEN
               IBLK = JBLK
               CALL ZFIO ('READ', IHLUN, IHIND, IBLK, HIBUFF, IERR)
               IF (IERR.NE.0) GO TO 190
               END IF
C                                       desired task?
            II = (ICARD-1) * NHIWPL + 5
            CALL H2CHR (72, 1, HHBUFF(II), PLINE(ITA:))
            EQUAL = .TRUE.
            IF (NUMSTR.GT.0) THEN
               JJ = INDEX (PLINE, PSTRNG(:NUMSTR))
               IF (JJ.LE.0) EQUAL = .FALSE.
               END IF
            IF (EQUAL) THEN
               IF (ITA.GT.1) WRITE (PLINE(1:ITA-1),1115) ICUR
               JJ = JTRIM (PLINE)
               CALL PRTALN (PLUN, IFIND, PRINTR, NACROS, TITL1, TITL2,
     *            PLINE, ILINE, PAGE, SCRTCH, QUIT)
               IF ((QUIT) .OR. (ERRNUM.NE.0)) GO TO 190
               END IF
            ICARD = ICARD + 1
 125     CONTINUE
C                                       backwards, task blocks
      ELSE
         INSIDE = .FALSE.
         DO 175 ICUR = EREC,BREC,-1
            JBLK = (ICUR-1) / NHILPR + 1
            ICARD = ICUR - (JBLK-1) * NHILPR
C                                       Read next buffer.
            IF (JBLK.NE.IBLK) THEN
               IBLK = JBLK
               CALL ZFIO ('READ', IHLUN, IHIND, IBLK, HIBUFF, IERR)
               IF (IERR.NE.0) GO TO 190
               END IF
C                                       desired task?
            II = (ICARD-1) * NHIWPL + 5
            CALL H2CHR (72, 1, HHBUFF(II), PLINE(ITA:))
            CALL CHBLNK (72, 1, PLINE(ITA:), NPI)
            NPI = NPI + ITA - 1
            EQUAL = PRTACK(1:NUMCHR).EQ.PLINE(NPI:NPI+NUMCHR-1)
            IF ((EQUAL) .AND. (INSIDE)) THEN
               INB = ICUR
C                                       start block
            ELSE IF (EQUAL) THEN
               INSIDE = .TRUE.
               INB = ICUR
               INE = ICUR
C                                       print block
            ELSE IF (INSIDE) THEN
               DO 130 LCUR = INB,INE
                  JBLK = (LCUR-1) / NHILPR + 1
                  ICARD = LCUR - (JBLK-1) * NHILPR
C                                       Read next buffer.
                  IF (JBLK.NE.IBLK) THEN
                     IBLK = JBLK
                     CALL ZFIO ('READ', IHLUN, IHIND, IBLK, HIBUFF,
     *                  IERR)
                     IF (IERR.NE.0) GO TO 190
                     END IF
C                                       desired task?
                  II = (ICARD-1) * NHIWPL + 5
                  CALL H2CHR (72, 1, HHBUFF(II), PLINE(ITA:))
                  EQUAL = .TRUE.
                  IF ((NUMSTR.GT.0) .AND. (EQUAL)) THEN
                     JJ = INDEX (PLINE, PSTRNG(:NUMSTR))
                     IF (JJ.LE.0) EQUAL = .FALSE.
                     END IF
                  IF (EQUAL) THEN
                     IF (ITA.GT.1) WRITE (PLINE(1:ITA-1),1115) LCUR
                     JJ = JTRIM (PLINE)
                     CALL PRTALN (PLUN, IFIND, PRINTR, NACROS, TITL1,
     *                  TITL2, PLINE, ILINE, PAGE, SCRTCH, QUIT)
                     IF ((QUIT) .OR. (ERRNUM.NE.0)) GO TO 190
                     END IF
                  ICARD = ICARD + 1
 130              CONTINUE
               INSIDE = .FALSE.
               END IF
 175        CONTINUE
         END IF
C                                       Close history file.
 190  CALL HICLOS (IHLUN, NOSAVE, HIBUFF, IERR2)
C                                       Close printer.
      IF (POPEN) CALL LPCLOS (PLUN, IFIND, ILINE, IERR2)
C                                       Clear read.
      IF (FOPEN) CALL CATDIR ('CSTA', IVOL, ISLOT, LOCNAM, LOCCLS,
     *   LOCSEQ, LOCTYP, IUSER, 'CLRD', IBUFF, IERR2)
      POTERR = 33
      IF (IERR.NE.0) GO TO 980
      GO TO 999
C-----------------------------------------------------------------------
C                                       RENAME
C                                       rename catalog entry.
C-----------------------------------------------------------------------
C                                       Initial values for RENAME.
 200  VRBNAM = RENAM
      CALL ADVERB ('OUTNAME', 'C', 1, 12, IDUM, RDUM, NEWNAM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('OUTCLASS', 'C', 1, 6, IDUM, RDUM, NEWCLS)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('OUTSEQ', 'I', 1, 0, ISEQN, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      DEFCLS = LOCCLS
      CALL MAKOUT (LOCNAM, LOCCLS, LOCSEQ, DEFCLS, NEWNAM, NEWCLS,
     *   ISEQN)
C                                       PPM 93.01.19: was IBUFF(IWORD)
C                                       but that's a relic.
      IUSER = NLUSER
C                                       Check the name.
      TMPVOL = 0
      TMPSLT = 0
      TMPTYP = '  '
C                                       Does a duplicate exist?  Don't
C                                       include type in search.
      IF (ISEQN.NE.0) THEN
         CALL CATDIR ('SRNN', TMPVOL, TMPSLT, NEWNAM, NEWCLS, ISEQN,
     *      TMPTYP, IUSER, STATUS, IBUFF, IERR)
C                                       Duplicate name found.
         IF (IERR.EQ.0) THEN
            WRITE (MSGTXT, 1210)
            CALL MSGWRT (8)
            POTERR = 101
            GO TO 980
            END IF
C                                       Find next available sequence #
      ELSE
         CALL CATDIR ('SRCH', TMPVOL, TMPSLT, NEWNAM, NEWCLS, ISEQN,
     *      TMPTYP, IUSER, STATUS, IBUFF, IERR)
         IF (IERR.EQ.0) THEN
            ISEQN = ISEQN + 1
         ELSE
            ISEQN = 1
            END IF
         END IF
C                                       Open file excl.
      CALL CATOPN (IVOL, IFIND, IBUFF, IMAX, IERR)
      POTERR = 33
      IF (IERR.NE.0) GO TO 980
C                                       Calculate catalog entry locatn.
      IMOD = (ISLOT - 1) / NLPR
      IREC = 2 + IMOD
      IWORD = 1 + NWPL * (ISLOT - NLPR*IMOD - 1)
C                                       Load proper catalog record.
      CALL ZFIO ('READ', ILUN, IFIND, IREC, IBUFF, IERR)
      POTERR = 50
      IF (IERR.NE.0) GO TO 240
      IF (IBUFF(IWORD+1).NE.0) THEN
         WRITE (MSGTXT,1200)
         CALL MSGWRT (6)
         IERR = 99
         POTERR = 33
C                                       fill values for the name
      ELSE
         CALL CHR2H (12, NEWNAM, 1, HBUFF(IWORD+5))
         CALL CHR2H (6, NEWCLS, 13, HBUFF(IWORD+5))
         IBUFF(IWORD+IOFFSQ) = ISEQN
C                                       Resave record.
         CALL ZFIO ('WRIT', ILUN, IFIND, IREC, IBUFF, IERR)
         POTERR = 50
         END IF
C                                       Close catalog file.
 240  CALL ZCLOSE (ILUN, IFIND, IERR2)
      IF ((IERR.EQ.0) .AND. (IERR2.NE.0)) POTERR = 50
      IF ((IERR.NE.0) .OR. (IERR2.NE.0)) GO TO 980
C-----------------------------------------------------------------------
C                                       RESCALE and RENAME
C                                       update the cat header
C-----------------------------------------------------------------------
C                                       Load catalog header.
 300  CALL CATIO ('READ', IVOL, ISLOT, CATBLK, 'WRIT', IBUFF, IERR)
      IERH = 0
C                                       Catalog read error.
      IF (IERR.EQ.0) GO TO 310
         WRITE (MSGTXT,1300) IERR
         IF (IERR.EQ.5) WRITE (MSGTXT,1301)
         POTERR = 33
         GO TO 970
C                                       Common history file stuff.
 310  CALL HIOPEN (IHLUN, IVOL, ISLOT, HIBUFF, IERR2)
      IF (IERR2.EQ.0) CALL HENCO1 (VRBNAM, LOCNAM, LOCCLS, LOCSEQ,
     *   IVOL, IHLUN, HIBUFF, IERR)
      IERH = IERR
C                                       Change appropriate values.
C                                       RENAME
      IF (BRANCH.EQ.2) THEN
         CALL CHR2H (12, NEWNAM, KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, NEWCLS, KHIMCO, CATH(KHIMC))
         CATBLK(KIIMS) = ISEQN
         WRITE (MSGTXT,1320) LOCNAM, LOCCLS, LOCSEQ, LOCTYP, IVOL,
     *      ISLOT
         CALL MSGWRT (2)
         WRITE (MSGTXT,1321) NEWNAM, NEWCLS, ISEQN, LOCTYP, IVOL,
     *      ISLOT
         CALL MSGWRT (2)
         IF (IERR2.EQ.0) THEN
            CALL HENCOO (RENAM, NEWNAM, NEWCLS, ISEQN, IVOL, IHLUN,
     *         HIBUFF, IERR)
            IERH = IERH + IERR
            END IF
C                                       RESCALE
      ELSE
         CALL ADVERB ('DOCC', 'I', 1, 0, IDOCC, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('OFFSET', 'R', 1, 0, IDUM, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         DOFFS = RDUM(1)
         CALL ADVERB ('FACTOR', 'R', 1, 0, IDUM, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         INFACT = RDUM(1)
         IF (INFACT.EQ.0.0) INFACT = 1.0
         JJ = MABFSS * 2
C                                       do image and SL
         IF (IDOCC.LT.2) THEN
            CALL RESCAL (INFACT, DOFFS, IVOL, ISLOT, 17, 18, R1BUF, JJ,
     *         R2BUF, JJ, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1330) IERR
               POTERR = 50
               GO TO 960
               END IF
            CALL RESCSL (IVOL, ISLOT, INFACT, DOFFS, 18, R1BUF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1331) IERR
               POTERR = 50
               GO TO 960
               END IF
            IF (IERR2.EQ.0) THEN
               WRITE (HILINE,1335) VRBNAM, INFACT, DOFFS
               CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
               IERH = IERH + IERR
               END IF
            END IF
C                                       do CCs
         IF (IDOCC.GT.0) THEN
            CALL RESCCC (IVOL, ISLOT, INFACT, 18, R1BUF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1332) IERR
               POTERR = 50
               GO TO 960
               END IF
            IF (IERR2.EQ.0) THEN
               WRITE (HILINE,1336) VRBNAM, INFACT
               CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
               IERH = IERH + IERR
               END IF
            END IF
         END IF
C                                       Close history file
 340  IF (IERR2.EQ.0) THEN
         CALL HICLOS (IHLUN, SAVE, HIBUFF, IERR)
         IERH = IERH + IERR
         END IF
C                                       Write updated catalog.
 350  CALL CATIO ('UPDT', IVOL, ISLOT, CATBLK, 'CLWR', IBUFF, IERR)
      POTERR = 0
      IF (IERH.GT.0) POTERR = 34
C                                       Catalog write error.
      IF ((IERR.EQ.0) .OR. (IERR.EQ.9)) GO TO 980
         WRITE (MSGTXT,1350) IERR
         POTERR = 33
         GO TO 970
C-----------------------------------------------------------------------
C                                       CLRSTAT
C                                       Clear catalog read or write.
C-----------------------------------------------------------------------
 400  POTERR = 33
      NCW = 0
      NCR = 0
      CALL CATDIR ('CSTA', IVOL, ISLOT, LOCNAM, LOCCLS, LOCSEQ, LOCTYP,
     *   IUSER, 'CLWR', IBUFF, IERR)
      IF (IERR.EQ.0) NCW = NCW + 1
      IF ((IERR.NE.10) .AND. (IERR.GT.0)) GO TO 980
      DO 410 I = 1,1000
         CALL CATDIR ('CSTA', IVOL, ISLOT, LOCNAM, LOCCLS, LOCSEQ,
     *       LOCTYP, IUSER, 'CLRD', IBUFF, IERR)
         IF (IERR.EQ.0) NCR = NCR + 1
         IF (IERR.GT.0) GO TO 420
 410     CONTINUE
 420  IF (IERR.EQ.10) POTERR = 0
      IF ((NCW.LE.0) .AND. (NCR.LE.0)) GO TO 980
         WRITE (MSGTXT,1420) NCW, NCR
         CALL MSGWRT (2)
         GO TO 980
C-----------------------------------------------------------------------
C                                       AXDEFINE
C                                       reset axis parms
C-----------------------------------------------------------------------
 500  CALL CATIO ('READ', IVOL, ISLOT, CATBLK, 'WRIT', IBUFF, IERR)
      IF (IERR.EQ.0) GO TO 510
         POTERR = 33
         GO TO 970
C                                       check parms
 510  NDIM = CATBLK(KIDIM)
      CALL ADVERB ('AXTYPE', 'C', 1, 8, IDUM, RDUM, LAXTYP)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('AXREF', 'R', 1, 0, IDUM, RDUM, CDUM)
      LAXREF = RDUM(1)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('AXINC', 'R', 1, 0, IDUM, RDUM, CDUM)
      LAXINC = RDUM(1)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('AXVAL', 'R', 2, 0, IDUM, LAXVAL, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('NAXIS', 'I', 1, 0, I, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IF (I.EQ.0) I = NDIM + 1
      IF ((I.GT.0) .AND. (I.LE.NDIM+1) .AND. (I.LE.7) .AND.
     *   (LAXTYP.NE.' ')) GO TO 520
C                                       allow remove last axis
         IF ((I.EQ.NDIM) .AND. (CATBLK(KINAX+I-1).EQ.1) .AND.
     *      (LAXTYP.EQ.' ')) GO TO 520
         WRITE (MSGTXT,1510)
         POTERR = 101
         GO TO 970
C                                       Old to history
 520  II = 1
      CALL HIOPEN (IHLUN, IVOL, ISLOT, HIBUFF, IERR2)
      IF (IERR2.EQ.0) THEN
         CALL HENCO1 (REAXIS, LOCNAM, LOCCLS, LOCSEQ, IVOL, IHLUN,
     *      HIBUFF, IERR)
         IERH = IERR + IERR2
         END IF
C                                       Axis parms to history
 530  IF (IERR2.NE.0) GO TO 540
         IF (I.GT.NDIM) GO TO 540
         CALL H2CHR (8, 1, CATH(KHCTP+(I-1)*2), CRRTYP)
         WRITE (HILINE,1530) I, CRRTYP, AGECOM(II)
         CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
         IERH = IERH + IERR
         IF (IERR.NE.0) GO TO 540
         WRITE (HILINE,1531) I, CATD(KDCRV+I-1), AGECOM(II)
         CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
         IERH = IERH + IERR
         IF (IERR.NE.0) GO TO 540
         WRITE (HILINE,1532) I, CATR(KRCIC+I-1), AGECOM(II)
         CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
         IERH = IERH + IERR
         IF (IERR.NE.0) GO TO 540
         WRITE (HILINE,1533) I, CATR(KRCRP+I-1), AGECOM(II)
         CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
         IERH = IERH + IERR
         IF (IERR.NE.0) GO TO 540
C                                       Update axis parms
 540  IF (II.NE.1) GO TO 340
      IF (LAXTYP.EQ.' ') GO TO 550
         CALL CHR2H (8, LAXTYP, 1, CATH(KHCTP+2*I-2))
         CATR(KRCRP+I-1) = LAXREF
         IF ((LAXINC.NE.0.0) .OR. (I.GT.NDIM)) CATR(KRCIC+I-1) = LAXINC
         CALL POPSRD ('R2D', LAXVAL, CATD(KDCRV+I-1))
         IF (I.GT.NDIM) CATBLK(KINAX+I-1) = 1
         NDIM = MAX (I, NDIM)
         CATBLK(KIDIM) = NDIM
         II = 2
         GO TO 530
C                                       Blank last null axis
 550  CONTINUE
         CATH(KHCTP+2*I-2) = HBLANK
         CATH(KHCTP+2*I-1) = HBLANK
         CATR(KRCRP+I-1) = 0.0
         CATR(KRCIC+I-1) = 0.0
         CATD(KDCRV+I-1) = 0.0D0
         NDIM = NDIM - 1
         CATBLK(KIDIM) = NDIM
         WRITE (HILINE,1550) I
         CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
         IERH = IERH + IERR
         GO TO 340
C-----------------------------------------------------------------------
C                                       ALTDEF
C                                       define alternate velocity axis
C-----------------------------------------------------------------------
C                                       Pick up parameters
 600  CALL ADVERB ('AXTYPE', 'C', 1, 8, IDUM, RDUM, LAXTYP)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('AXREF', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      LAXREF = RDUM(1)
      CALL ADVERB ('AXVAL', 'R', 2, 0, IDUM, LAXVAL, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('RESTFREQ', 'R', 2, 0, IDUM, RESTFR, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL POPSRD ('R2D', LAXVAL, DVZERO)
      CALL POPSRD ('R2D', RESTFR, FRLINE)
      IAXCOD = 1
      DO 605 J = 1,3
         I = INDEX (LAXTYP, VELREF(J))
         IF (I.GT.0) IAXCOD = J
 605     CONTINUE
      I = INDEX (LAXTYP, VELREF(5))
      IF (I.GT.0) IAXCOD = 256 + IAXCOD
C                                       Check
      IF (FRLINE.GT.1.E6) GO TO 610
         WRITE (MSGTXT,1600) FRLINE
         CALL MSGWRT (8)
         POTERR = 101
         GO TO 980
C                                       Get header
 610  CALL CATIO ('READ', IVOL, ISLOT, CATBLK, 'WRIT', IBUFF, IERR)
      IF (IERR.EQ.0) GO TO 615
         WRITE (MSGTXT,1300) IERR
         IF (IERR.EQ.5) WRITE (MSGTXT,1301)
         POTERR = 33
         GO TO 970
C                                       Find needed axis
 615  IMAX = CATBLK(KIDIM)
      DO 620 I = 1,IMAX
         IEND = KHCTP + (I-1)*2
         CALL H2CHR (8, 1, CATH(IEND), LAXTYP)
         DO 619 J = 1,3
            IF (FRAXIS(J).EQ.LAXTYP(1:4)) GO TO 625
 619        CONTINUE
 620     CONTINUE
      WRITE (MSGTXT,1615)
      POTERR = 101
      GO TO 970
C                                       Got a FREQuency axis
 625  IF (J.NE.1) GO TO 630
         CATD(KDRST) = FRLINE
         CATBLK(KIALT) = IAXCOD
         CATD(KDARV) = DVZERO
         CATR(KRARP) = LAXREF
         GO TO 640
C                                       Got a VELO or FELO axis
C                                       but can't recover frequency
 630  IF ((CATBLK(KIALT).NE.0) .AND. (CATD(KDARV).GT.1.E6) .AND.
     *   (CATD(KDRST).GT.1.E6)) GO TO 635
         WRITE (MSGTXT,1630)
         POTERR = 101
         GO TO 970
C                                       Can recover old freq info
 635  CONTINUE
         VSIGN = 1.0D0
         IF (J.EQ.3) VSIGN = -VSIGN
         DELNU = -CATR(KRCIC+I-1) * CATD(KDARV) / (VELITE +
     *      VSIGN * CATD(KDCRV+I-1))
         REFNU = CATD(KDARV) - DELNU * (CATR(KRCRP+I-1) - CATR(KRARP))
         CATD(KDRST) = FRLINE
         CATBLK(KIALT) = IAXCOD
         CATD(KDARV) = REFNU + DELNU * (LAXREF - CATR(KRARP))
         CATD(KDCRV+I-1) = DVZERO
         CATR(KRCRP+I-1) = LAXREF
         J = IAXCOD / 256 + 2
         CATR(KRCIC+I-1) = -DELNU * (VELITE + VSIGN * DVZERO) /
     *      CATD(KDARV)
         LAXTYP = FRAXIS(J)
         LAXTYP(5:5) = '-'
         J = MOD (IAXCOD, 256)
         LAXTYP(6:8) = VELREF(J)
         CALL CHR2H (8, LAXTYP, 1, CATH(IEND))
C                                       Add to history
 640  CALL HIOPEN (IHLUN, IVOL, ISLOT, HIBUFF, IERH)
      IF (IERH.NE.0) GO TO 350
      WRITE (HILINE,1640) FRLINE
      CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
      IERH = IERH + IERR
      IF (IERR.NE.0) GO TO 340
      WRITE (HILINE,1641) I, DVZERO, I, LAXREF
      CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
      IERH = IERH + IERR
      IF (IERR.NE.0) GO TO 340
      I = IAXCOD/256 + 4
      J = MOD (IAXCOD, 256)
      WRITE (HILINE,1642) VELREF(J), VELREF(I)
      CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
      IERH = IERH + IERR
      GO TO 340
C-----------------------------------------------------------------------
C                                       ALTSWTCH
C                                       switch freq/velo to alternate
C-----------------------------------------------------------------------
 700  CALL CATIO ('READ', IVOL, ISLOT, CATBLK, 'WRIT', IBUFF, IERR)
      IF (IERR.EQ.0) GO TO 710
         WRITE (MSGTXT,1300) IERR
         IF (IERR.EQ.5) WRITE (MSGTXT,1301)
         POTERR = 33
         GO TO 970
C                                       Find needed axis
 710  IMAX = CATBLK(KIDIM)
      DO 720 I = 1,IMAX
         IEND = KHCTP + (I-1)*2
         CALL H2CHR (8, 1, CATH(IEND), LAXTYP)
         DO 719 J = 1,3
            IF (FRAXIS(J).EQ.LAXTYP(1:4)) GO TO 730
 719        CONTINUE
 720     CONTINUE
      WRITE (MSGTXT,1720)
      POTERR = 101
      GO TO 970
C                                       Is it ok?
 730  IF ((CATBLK(KIALT).GT.0) .AND. (CATD(KDRST).GT.1.E6)) GO TO 740
         WRITE (MSGTXT,1730)
         POTERR = 101
         GO TO 970
C                                       Pick up values
 740  VSIGN = 1.0D0
      IF (J.EQ.3) VSIGN = -VSIGN
      IF (J.EQ.1) THEN
         DELNU = CATR(KRCIC+I-1)
         REFNU = CATD(KDCRV+I-1)
      ELSE
         DELNU = -CATR(KRCIC+I-1) * CATD(KDARV) /
     *      (VELITE + VSIGN * CATD(KDCRV+I-1) + CATR(KRCIC+I-1) *
     *      (CATR(KRCRP+I-1) - CATR(KRARP)))
         REFNU = CATD(KDARV)
         END IF
      FRLINE = CATR(KRARP)
      DVZERO = CATD(KDARV)
      CATR(KRARP) = CATR(KRCRP+I-1)
      CATR(KRCRP+I-1) = FRLINE
      IERH = 0
C                                       To velocity
       IF (J.NE.1) GO TO 750
C                                       Warning for UV data
         IF (LOCTYP.EQ.'UV') THEN
            MSGTXT = 'Some tasks (PRTUV, UVPLT) may fail on a FELO-HEL'
            CALL MSGWRT (1)
            MSGTXT = 'axis. It is recommended to ALTSWTCH back to a'
            CALL MSGWRT (1)
            MSGTXT = 'FREQUENCY axis before proceeding. Use ALTSWTCH'
            CALL MSGWRT (1)
            MSGTXT = 'on MA (map) data, NOT on UV data.'
            CALL MSGWRT (1)
            END IF
         CATD(KDARV) = REFNU
         CATD(KDCRV+I-1) = DVZERO
         J = CATBLK(KIALT)/256 + 2
         IF (J.EQ.3) VSIGN = -VSIGN
         CATR(KRCIC+I-1) = -DELNU * (VELITE + VSIGN * DVZERO) /
     *      (REFNU + DELNU * (FRLINE - CATR(KRARP)))
         LAXTYP = FRAXIS(J)
         LAXTYP(5:5) = '-'
         J = MOD (CATBLK(KIALT), 256)
         LAXTYP(6:8) = VELREF(J)
         CALL CHR2H (8, LAXTYP, 1, CATH(IEND))
         GO TO 350
C                                       To frequency
 750  CONTINUE
         CATD(KDARV) = CATD(KDCRV+I-1)
         CATD(KDCRV+I-1) = REFNU
         CATR(KRCIC+I-1) = DELNU
         LAXTYP = FRAXIS(1)
         CALL CHR2H (8, LAXTYP, 1, CATH(IEND))
         GO TO 350
C-----------------------------------------------------------------------
C                                       CELGAL
C                                       switch Celestial/Galactic coord
C-----------------------------------------------------------------------
 800  CALL CATIO ('READ', IVOL, ISLOT, CATBLK, 'WRIT', IBUFF, IERR)
      IF (IERR.EQ.0) GO TO 805
         WRITE (MSGTXT,1300) IERR
         IF (IERR.EQ.5) WRITE (MSGTXT,1301)
         POTERR = 33
         GO TO 970
C                                       Find needed axis
 805  IXA = 0
      IYA = 0
      ITA = 0
      II = CATBLK(KIDIM)
      CSAVE = '+'
      DO 820 I = 1,II
         CALL H2CHR (8, 1, CATH(KHCTP+(I-1)*2), LAXTYP)
         DO 815 J = 1,4
            IF (XAXTY(J).EQ.LAXTYP(1:4)) THEN
               IF (IXA.GT.0) GO TO 825
               IF ((ITA.GT.0) .AND. (ITA.NE.(J+2)/3)) GO TO 825
                  IXA = I
                  ITA = (J+2) / 3
                  CSAVE = LAXTYP(5:5)
            ELSE IF (YAXTY(J).EQ.LAXTYP(1:4)) THEN
               IF (IYA.GT.0) GO TO 825
               IF ((ITA.GT.0) .AND. (ITA.NE.(J+2)/3)) GO TO 825
                  IYA = I
                  ITA = (J+2) / 3
                  CSAVE = LAXTYP(5:5)
               END IF
 815        CONTINUE
 820     CONTINUE
      IF ((IXA.GT.0) .OR. (IYA.GT.0)) GO TO 830
C                                       Axes inconsistant somehow
 825  WRITE (MSGTXT,1825)
      POTERR = 101
      GO TO 970
C                                       projected or not
 830  IF ((ITA.EQ.2) .AND. (CSAVE.EQ.' ')) ITA = 3
C                                       fix up old LL, MM
      II = KHCTP + (IYA-1) * 2
      CALL H2CHR (8, 1, CATH(II), LAXTYP)
      EQUAL = LAXTYP.EQ.(YAXTY(1) // '    ')
      IF (EQUAL) CALL CHR2H (4, CGEOM(1), 5, CATH(II))
      II = KHCTP + (IXA-1) * 2
      CALL H2CHR (8, 1, CATH(II), LAXTYP)
      EQUAL = LAXTYP.EQ.(XAXTY(1) // '    ')
      IF (EQUAL) CALL CHR2H (4, CGEOM(1), 5, CATH(II))
C                                       Is it ok geometry ?
C                                       Only care if > 1 point on axis
      IF (CATH(II+1).NE.CATH(KHCTP+2*IYA-1)) GO TO 825
      IF ((CATBLK(KINAX+IYA-1).EQ.1) .AND. (CATBLK(KINAX+IXA-1).EQ.1))
     *   GO TO 840
         CALL H2CHR (8, 1, CATH(II), LAXTYP)
         DO 835 I = 1,NGEOM
            IF (LAXTYP(5:8).EQ.CGEOM(I)) GO TO 840
 835     CONTINUE
         WRITE (MSGTXT,1835)
         POTERR = 101
         GO TO 970
C                                       So do it finally
 840  IXA = IXA - 1
      IYA = IYA - 1
C                                       Get galactic coords for Epoch
      CALL GALPOL( CATR(KREPO), RAGP, DECGP, LONCP)
C                                       Convert to radians
      RAGP  = RAGP * DG2RAD
      DECGP = DECGP * DG2RAD
      LONCP = LONCP * DG2RAD
C                                       Celestial to Galactic
      IF (ITA.EQ.1) THEN
         DEC = CATD(KDCRV+IYA) * DG2RAD
         RA = CATD(KDCRV+IXA) * DG2RAD
         GLAT = ASIN (SIN(DEC)*SIN(DECGP) + COS(DEC)*COS(DECGP)*
     *      COS(RA-RAGP))
         GLON = LONCP + ATAN2 (COS(DEC)*SIN(RAGP-RA), SIN(DEC)*
     *      COS(DECGP) - COS(DEC)*SIN(DECGP)*COS(RA-RAGP))
         IF (GLON.GE.TWOPI) GLON = GLON - TWOPI
         IF (GLON.LT.0.0D0) GLON = GLON + TWOPI
C                                       Galactic to Celestial
      ELSE
         GLAT = CATD(KDCRV+IYA) * DG2RAD
         GLON = CATD(KDCRV+IXA) * DG2RAD
         DEC = ASIN (SIN(GLAT)*SIN(DECGP) + COS(GLAT)*COS(DECGP)*
     *      COS(GLON-LONCP))
         RA = RAGP + ATAN2 (COS(GLAT)*SIN(LONCP-GLON), SIN(GLAT)*
     *      COS(DECGP) - COS(GLAT)*SIN(DECGP)*COS(GLON-LONCP))
         IF (RA.GE.TWOPI) RA = RA - TWOPI
         IF (RA.LT.0.0D0) RA = RA + TWOPI
         END IF
C                                       rotation
      RHO = ATAN2 (COS(DECGP)*SIN(RA-RAGP), COS(DEC)*SIN(DECGP)
     *   - SIN(DEC)*COS(DECGP)*COS(RA-RAGP))
      IF (RHO.GT.TWOPI/2.D0) RHO = RHO - TWOPI
      IF (RHO.LT.-TWOPI/2.0D0) RHO = RHO + TWOPI
C                                       Store in header
      IERH = 0
      CALL CHR2H (4, XAXTY(5-ITA), 1, CATH(KHCTP+IXA*2))
      CALL CHR2H (4, YAXTY(5-ITA), 1, CATH(KHCTP+IYA*2))
      IF (ITA.EQ.1) THEN
         CATD(KDCRV+IXA) = GLON / DG2RAD
         CATD(KDCRV+IYA) = GLAT / DG2RAD
         CATR(KRCRT+IYA) = CATR(KRCRT+IYA) - RHO / DG2RAD
      ELSE
         CATD(KDCRV+IXA) = RA / DG2RAD
         CATD(KDCRV+IYA) = DEC / DG2RAD
         CATR(KRCRT+IYA) = CATR(KRCRT+IYA) + RHO / DG2RAD
         END IF
      GO TO 350
C-----------------------------------------------------------------------
C                                       EPOSWTCH
C                                       switch B1950 to J2000
C-----------------------------------------------------------------------
 900  CALL CATIO ('READ', IVOL, ISLOT, CATBLK, 'WRIT', IBUFF, IERR)
      IF (IERR.NE.0) THEN
         POTERR = 33
         GO TO 970
         END IF
C                                       initial epoch coordinates
      LOCNUM = 1
      DO 905 I = 1,5
         IF (I+2.LE.CATBLK(KIDIM)) THEN
            DEPTH(I) = IROUND (CATR(KRCRP+I+1))
         ELSE
            DEPTH(I) = 1
            END IF
 905     CONTINUE
      CALL SETLOC (DEPTH, F)
C                                       check type of coordinates
      IF (AXTYP(LOCNUM).LE.0) THEN
         MSGTXT = 'NO COORDINATE AXES FOR WHICH TO SWITCH EPOCH'
         POTERR = 101
         GO TO 970
         END IF
      CALL H2CHR (8, 1, CATH(KHCTP+2*KLOCL(LOCNUM)), CRRTYP)
      CALL H2CHR (8, 1, CATH(KHCTP+2*KLOCM(LOCNUM)), LAXTYP)
      IF (((CRRTYP(:4).NE.'RA  ') .AND. (CRRTYP(:4).NE.'RA--')) .OR.
     *   ((LAXTYP(:4).NE.'DEC ') .AND. (LAXTYP(:4).NE.'DEC-'))) THEN
         MSGTXT = 'CAN SWITCH EPOCH ONLY FOR EQUATORIAL COORDINATES'
         POTERR = 101
         GO TO 970
         END IF
C                                       get the 3 epochs
      EPOCIN = CATR(KREPO)
      IF (ABS(EPOCIN-2000.).LT.0.5) THEN
         EPOCOU = 1950.
      ELSE
         EPOCOU = 2000.
         END IF
      CALL H2CHR (8, 1, CATH(KHDOB), CRRTYP)
      CALL FILL (6, 0, IT)
      IT(1) = 2050
      IT(2) = 1
      IT(3) = 1
      CALL DAT2JD (IT, JD00)
      IT(1) = 1950
      CALL DAT2JD (IT, JD50)
      IT(1) = 0
      CALL JULDAY (CRRTYP, JD)
      IF ((JD.LE.JD50) .OR. (JD.GE.JD00)) THEN
         MSGTXT = 'OBSERVATION date missing/wrong - switch less'
     *      // ' accurate'
C         CALL MSGWRT (6)
         EPOCOB = 1950.
      ELSE
         EPOCOB = (JD - JD50) / (JD00 - JD50) * 100.0D0 + 1950.0D0
         END IF
C                                       init conversion routines
      CALL STEPCH (EPOCIN, I, TABEP1, CRD1, LABEP1)
      CALL STEPCH (EPOCOB, I, TABEP2, CRD2, LABEP2)
      CALL STEPCH (EPOCOU, I, TABEP3, CRD3, LABEP3)
      CALL CRDSET (CRD1, CRD3, CRD13, IERR)
C                                       reference pixel
      XIN = CATD(KDCRV+KLOCL(LOCNUM))
      YIN = CATD(KDCRV+KLOCM(LOCNUM))
      CALL CRDTRN (XIN, YIN, CRD13, X13, Y13, ROTN13)
C                                       average 2 methods
      XIN = XIN * DG2RAD
      YIN = YIN * DG2RAD
      I = 1
      IF (ABS(EPOCOU-1950.).LT.0.5) I = -1
      CALL B2JPOS (I, XIN, YIN, XOU, YOU)
      XOU = (XOU * RAD2DG + X13) / 2.0D0
      YOU = (YOU * RAD2DG + Y13) / 2.0D0
C                                       header
      CATD(KDCRV+KLOCL(LOCNUM)) = XOU
      CATD(KDCRV+KLOCM(LOCNUM)) = YOU
      CATR(KRCRT+KLOCM(LOCNUM)) = CATR(KRCRT+KLOCM(LOCNUM)) - ROTN13
      CATR(KREPO) = EPOCOU
C                                       pointing position
      XIN = CATD(KDORA)
      YIN = CATD(KDODE)
      CALL CRDTRN (XIN, YIN, CRD13, X13, Y13, ROTN13)
C                                       average 2 methods
      XIN = XIN * DG2RAD
      YIN = YIN * DG2RAD
      I = 1
      IF (ABS(EPOCOU-1950.).LT.0.5) I = -1
      CALL B2JPOS (I, XIN, YIN, XOU, YOU)
      XOU = (XOU * RAD2DG + X13) / 2.0D0
      YOU = (YOU * RAD2DG + Y13) / 2.0D0
C                                       header
      CATD(KDORA) = XOU
      CATD(KDODE) = YOU
C                                       accuracy warning
      RDUM(1) = 1.0 / 3600.0 / 10.
      IF ((ABS(CATR(KRCIC+KLOCL(LOCNUM))).LT.RDUM(1)) .OR.
     *   (ABS(CATR(KRCIC+KLOCM(LOCNUM))).LT.RDUM(1))) THEN
         MSGTXT = 'WARNING: coordinate conversion is probably not '
     *      // 'accurate enough for you'
         CALL MSGWRT (6)
         END IF
C
C                                       update header
      CALL CATIO ('UPDT', IVOL, ISLOT, CATBLK, 'CLWR', IBUFF, IERR)
      POTERR = 0
C                                       Catalog write error.
      IF ((IERR.EQ.0) .OR. (IERR.EQ.9)) GO TO 980
         WRITE (MSGTXT,1350) IERR
         POTERR = 33
         GO TO 970
C-----------------------------------------------------------------------
C                                       EPOCONV
C                                       B1950 <-> J2000
C-----------------------------------------------------------------------
C                                       Get adverbs
 950  CALL ADVERB ('COORDINA', 'R', 6, 0, IDUM, XCOORD, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('OPTYPE', 'C', 1, 4, IDUM, RDUM, OPTYPE)
      IF (ERRNUM.NE.0) GO TO 980
      XIN = (ABS (XCOORD(1)) + ABS (XCOORD(2))/60.0D0 +
     *   ABS (XCOORD(3))/3600.0D0) * 15.00D0
      IF ((XCOORD(1).LT.0.0) .OR. (XCOORD(2).LT.0.0) .OR.
     *   (XCOORD(3).LT.0.0)) XIN = -XIN
      YIN = ABS(XCOORD(4)) + ABS(XCOORD(5))/60.0D0 +
     *   ABS(XCOORD(6))/3600.0D0
      IF ((XCOORD(4).LT.0.0) .OR. (XCOORD(5).LT.0.0) .OR.
     *   (XCOORD(6).LT.0.0)) YIN = -YIN
      IF (OPTYPE.NE.'1950') THEN
         EPOCIN = 1950.
         EPOCOU = 2000.
      ELSE
         EPOCIN = 2000.
         EPOCOU = 1950.
         END IF
C                                       tell user
      CALL COORDD (1, XIN, RHC, RHM, RH)
      CALL COORDD (2, YIN, DHC, DHM, DH)
      WRITE (MSGTXT,1950) 'Input ', RHC, RHM, RH, DHC, DHM, DH, EPOCIN
      IF (MSGTXT(18:18).EQ.' ') MSGTXT(18:18) = '0'
      IF (MSGTXT(38:38).EQ.' ') MSGTXT(38:38) = '0'
      CALL MSGWRT (4)
C                                       init conversion routines
      CALL STEPCH (EPOCIN, I, TABEP1, CRD1, LABEP1)
      CALL STEPCH (EPOCOU, I, TABEP3, CRD3, LABEP3)
      CALL CRDSET (CRD1, CRD3, CRD13, IERR)
      CALL CRDTRN (XIN, YIN, CRD13, X13, Y13, ROTN13)
C                                       average 2 methods
      XIN = XIN * DG2RAD
      YIN = YIN * DG2RAD
      I = 1
      IF (ABS(EPOCOU-1950.).LT.0.5) I = -1
      CALL B2JPOS (I, XIN, YIN, XOU, YOU)
      XOU = (XOU * RAD2DG + X13) / 2.0D0
      YOU = (YOU * RAD2DG + Y13) / 2.0D0
C                                       tell user
      CALL COORDD (1, XOU, RHC, RHM, RH)
      CALL COORDD (2, YOU, DHC, DHM, DH)
      WRITE (MSGTXT,1950) 'Output', RHC, RHM, RH, DHC, DHM, DH, EPOCOU
      IF (MSGTXT(18:18).EQ.' ') MSGTXT(18:18) = '0'
      IF (MSGTXT(38:38).EQ.' ') MSGTXT(38:38) = '0'
      CALL MSGWRT (4)
C                                       save result
      XIN = ABS (XOU) / 15.0D0
      YIN = ABS (YOU)
      I = XIN
      XCOORD(1) = I
      XIN = (XIN - XCOORD(1)) * 60.0D0
      I = XIN
      XCOORD(2) = I
      XCOORD(3) = (XIN - XCOORD(2)) * 60.0D0
      IF (XOU.LT.0) THEN
         XCOORD(1) = -XCOORD(1)
         XCOORD(2) = -XCOORD(2)
         XCOORD(3) = -XCOORD(3)
         END IF
      I = YIN
      XCOORD(4) = I
      YIN = (YIN - XCOORD(4)) * 60.0D0
      I = YIN
      XCOORD(5) = I
      XCOORD(6) = (YIN - XCOORD(5)) * 60.0D0
      IF (YOU.LT.0) THEN
         XCOORD(4) = -XCOORD(4)
         XCOORD(5) = -XCOORD(5)
         XCOORD(6) = -XCOORD(6)
         END IF
      CALL ADVRBS ('COORDINA', 'R', 6, 0, IDUM, XCOORD, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      POTERR = 0
      GO TO 980
C-----------------------------------------------------------------------
C                                       Print error, clear catalog.
 960  IF (IERR2.NE.0) CALL HICLOS (IHLUN, NOSAVE, HIBUFF, IERR)
 970  CALL MSGWRT (6)
      CALL CATDIR ('CSTA', IVOL, ISLOT, LOCNAM, LOCCLS, LOCSEQ, LOCTYP,
     *   IUSER, 'CLWR', IBUFF, IERR)
C                                       AIPS error management.
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.EQ.0) GO TO 999
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('CATALOG ENTRY NOT FOUND')
 1100 FORMAT ('Printer job of',I7,' lines: do you mean it?')
 1105 FORMAT ('HIFILE FOR ',A12,'.',A6,'.',I5,' HAS',I7,
     *   ' RECORDS!!!')
 1110 FORMAT ('History file for ',A12,'.',A6,'.',I5,' with',I7,
     *   ' entries')
 1115 FORMAT (I6,2X)
 1200 FORMAT ('CANNOT RENAME A BUSY IMAGE')
 1210 FORMAT ('DUPLICATE FILE NAME FOUND')
 1300 FORMAT ('CATALOG READ ERROR',I5)
 1301 FORMAT ('MAP TOO BUSY')
 1320 FORMAT ('Rename ',A12,'.',A6,'.',I4,' (',A2,')  on disk',I2,
     *   ' cno',I5)
 1321 FORMAT ('To     ',A12,'.',A6,'.',I4,' (',A2,')  on disk',I2,
     *   ' cno',I5)
 1330 FORMAT ('RESCALE: ERROR',I6,' TRYING TO RESCALE THE VALUES')
 1331 FORMAT ('RESCALE: ERROR',I6,' TRYING TO RESCALE SLICE FILES')
 1332 FORMAT ('RESCALE: ERROR',I6,' TRYING TO RESCALE CC FILES')
 1335 FORMAT (A6,' FACTOR=',1PE16.8,'   OFFSET=',1PE16.8)
 1336 FORMAT (A6,' FACTOR=',1PE16.8,'   / Applied to CC files')
 1350 FORMAT ('CATALOG WRITE ERROR',I5)
 1420 FORMAT ('Cleared',I2,' writes and',I4,' reads')
 1510 FORMAT ('INVALID NAXIS OR BLANK AXTYPE')
 1530 FORMAT ('AXDEF CTYPE',I1,'  = ''',A8,'''',10X,'/ ',A4,
     *   'Axis type')
 1531 FORMAT ('AXDEF CRVAL',I1,'  = ',1PE16.9,4X,'/ ',A4,
     *   'Reference pixel value')
 1532 FORMAT ('AXDEF CDELT',I1,'  = ',1PE12.5,8X,'/ ',A4,
     *   'Axis increment')
 1533 FORMAT ('AXDEF CRPIX',I1,'  = ',F9.3,11X,'/ ',A4,
     *   'Reference pixel loc')
 1550 FORMAT ('AXDEF / Axis',I2,' removed')
 1600 FORMAT ('REST FREQ MUST BE IN HZ',1PE13.5,' ILLEGAL')
 1615 FORMAT ('CAN''T FIND FREQ/VELO/FELO AXIS TO WHICH TO ATTACH',
     *   ' ALTERNATE DESCRIPTION')
 1630 FORMAT ('EXISTING VELO/FELO AXIS LACKS VALID ALTERNATE FREQ',
     *   ' DESCRIPTION')
 1640 FORMAT ('ALTDEF RESTFREQ=',1PE18.10,6X,'/Rest frequency in Hz')
 1641 FORMAT ('ALTDEF CRVAL',I1,'  = ',1PE16.9,3X,'CRPIX',I1,'  = ',
     *   F8.3)
 1642 FORMAT ('ALTDEF AXREFTYPE =''',2A3,2X,'''',12X,
     *   '/Velocity ref. types')
 1720 FORMAT ('CAN''T FIND FREQ/VELO/FELO AXIS TO SWITCH WITH',
     *   ' ALTERNATE')
 1730 FORMAT ('ALTERNATE AXIS PARAMETERS ARE INVALID: USE ALTDEF')
 1825 FORMAT ('AXES INCONSISTENT: NO CONVERSION DONE')
 1835 FORMAT ('CAN SWITCH ONLY TRUE PROJECTIVE TANGENT PLANE ',
     *   'GEOMETRIES')
 1950 FORMAT (A6,' RA ',A1,2(I2.2,':'),F6.3,'   Dec ',A1,2(I2.2,':'),
     *   F5.2,'   Epoch',F6.0)
      END

      SUBROUTINE Q1FIN (U, ROW, MO2, LROW)
C-----------------------------------------------------------------------
C! FPS AP version: Finished gridding of row of UV data
C# AP-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FPS AP 120B version
C   Does various tasks associated with completion of gridding
C   row.  If U is within 1/2 support of 0 the symmetric row is
C   onjugated, flipped and added.  Finally rows are rotated so that
C   ero column (assumed LROW/2+1) goes to the first column.
C   f U=0 the space for the next row down is used.
C   Inputs:
C         I            U = U in cells (non-negative)
C         I            ROW = Base address of Grid row of interest
C         I            MO2 = Half the number of rows kept in the AP.
C         I            LROW = Length of row (no. vis)
C     Expects necessary constants in following AP locations:
C           0 = COS(PHASE0)           to shift map center
C           1 = SIN(PHASE0)
C           2 = COS(DELPHR)           for rotating down rows
C           3 = SIN(DELPHR)
C           4 = COS(DELPHC)           for rotating down columns
C           5 = SIN(DELPHC)
C           6 = 1.0
C           7 = 0.0
C-----------------------------------------------------------------------
      INTEGER U, ROW, MO2, LROW
      INTEGER*2 IU, IROW, IMO2, ILROW
C-----------------------------------------------------------------------
C                                       Convert to 2-comp. unsigned I*2
      IF (U.LT.32768) IU = U
      IF (U.GE.32768) IU = U - 65536
      IF (ROW.LT.32768) IROW = ROW
      IF (ROW.GE.32768) IROW = ROW - 65536
      IF (MO2.LT.32768) IMO2 = MO2
      IF (MO2.GE.32768) IMO2 = MO2 - 65536
      IF (LROW.LT.32768) ILROW = LROW
      IF (LROW.GE.32768) ILROW = LROW - 65536
C                                       Call FPS routine
      CALL AP1FIN (IU, IROW, IMO2, ILROW)
C
 999  RETURN
      END

LOCAL INCLUDE 'UVMTH.INC'
C                                       Local include for UVMTH
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4,30), XCALC(1), XNAME2(3),
     *   XCLAS2(2), XNAMOU(3), XCLAOU(2), XOPCOD(1)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XSUBA, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND,
     *   XBPVER, XSMOTH(3), XDOAC, XS2, XDISK2, XSOUT, XDISO, BADD(10),
     *   BUFF1(UVBFSS), BUFF2(UVBFSS), BUFF3(UVBFSS)
      INTEGER   SEQIN, SEQ2, SEQOUT, DISKIN, DISK2, DISKO, ICODE,
     *   NUMHIS, JBUFSZ, BLPNT(MAXANT,MAXANT), CNOIN, CNOIN2, CNOOUT,
     *   CATO(256), NVSA, NRPRMA, LRECA, NVISA, ILOCW2, MAXXBL, NVIS2,
     *   LREC2, NRPRM2, CATOLD(256)
      CHARACTER NAMEIN*12, CLAIN*6, NAME2*12, CLAS2*6, NAMOUT*12,
     *   CLAOUT*6, OPCODE*4, HISCRD(10)*64
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XTIME, XBAND, XFREQ, XFQID, XSUBA, XDOCAL, XGUSE, XDOPOL,
     *   XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH, XDOAC, XNAME2,
     *   XCLAS2, XS2, XDISK2, XNAMOU, XCLAOU, XSOUT, XDISO, XOPCOD, BADD
      COMMON /INTPRM/ CATO, CATOLD, SEQIN, SEQ2, SEQOUT, DISKIN, DISK2,
     *   DISKO, ICODE, NUMHIS, CNOIN, CNOIN2, CNOOUT, NVSA, NRPRMA,
     *   LRECA, NVISA, ILOCW2, MAXXBL, NVIS2, LREC2, NRPRM2
      COMMON /CHARPM/ NAMEIN, CLAIN, NAME2, CLAS2, NAMOUT, CLAOUT,
     *   OPCODE, HISCRD
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
      COMMON /AVGCOM/ BLPNT, BUFF3
LOCAL END
      PROGRAM UVMTH
C-----------------------------------------------------------------------
C! Averages one data set and applied it to another.
C# Utility UV UV-util Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1999-2000, 2005, 2007-2008, 2010-2012,
C;  Copyright (C) 2015-2016, 2018, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVMTH will time average one data file and use the average to operate
C   on another file.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input UV data.
C      IN2NAME        NAME2         Name of avg. file.
C      IN2CLASS       CLAS2         Class of avg. file.
C      IN2SEQ         SEQ2          Seq. no. of avg. file.
C      IN2DISK        DISK2         Vol. no. of avg. file.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      OPCODE         OPCODE        Operation code.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, NWORDS
      LONGINT   AVDOFF
      REAL      AVDATA(2)
      INCLUDE 'UVMTH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'UVMTH '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL UVMTIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Create averaging memory
      NWORDS = (3 * NVSA * MAXXBL - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, AVDATA, AVDOFF, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Average second input file.
      CALL UVMAVG (NVSA, AVDATA(1+AVDOFF), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Apply to first input file.
      CALL UVMTUV (NVSA, AVDATA(1+AVDOFF), IRET)
      IF (IRET.NE.0) GO TO 990
      CALL UVMHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE UVMTIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   UVMTIN gets input parameters for UVMTH and creates an output file.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in UVMTH for more details.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCFA, INCIFA, NUMAN(513), NANT, I,
     *   LUN
      REAL      RPARM(20)
      HOLLERITH CATH(256)
      LOGICAL   MATCH
      INCLUDE 'UVMTH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (CATH, CATBLK)
      DATA BLANK  /' '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 178
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      CALL H2CHR (12, 1, XNAME2, NAME2)
      CALL H2CHR (6, 1, XCLAS2, CLAS2)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      SEQ2 = IROUND (XS2)
      DISKIN = IROUND (XDISIN)
      DISK2 = IROUND (XDISK2)
      DISKO = IROUND (XDISO)
      DOACOR = XDOAC.GT.0.0
C                                       Interprete opcode default=SUB
      ICODE = 2
      IF (OPCODE.EQ.'ADD ') ICODE = 1
      IF (OPCODE.EQ.'SUB ') ICODE = 2
      IF (OPCODE.EQ.'MULT') ICODE = 3
      IF (OPCODE.EQ.'DIV ') ICODE = 4
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LE.0) SUBARR = 1
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Find first input file
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, PTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN, NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'READ', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 0
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       Get number of antennas from AN
C                                       file.
      LUN = 29
      CALL GETNAN (DISKIN, CNOIN, CATBLK, LUN, BUFF1, NUMAN, IERR)
      IF (IERR.EQ.0) THEN
         IF (SUBARR.GT.NUMAN(1)) SUBARR = 1
         NANT = NUMAN(1+SUBARR)
         END IF
C                                       If failed, assume 28.
      IF ((IERR.NE.0) .OR. (NANT.EQ.0)) THEN
         MSGTXT = 'COULD NOT GET NUMBER OF ANTENNAS FROM AN FILES ' //
     *      'ASSUME 29'
         CALL MSGWRT (6)
         NANT = 29
         END IF
      MAXXBL = NANT * (NANT+1) / 2
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, BUFF1, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, BUFF1, IERR)
C                                       Save length, etc
      NVSA = (LREC - NRPARM) / CATBLK(KINAX)
      INCFA = INCF / CATBLK(KINAX)
      INCIFA = INCIF / CATBLK(KINAX)
      NRPRMA = NRPARM
      LRECA = LREC
      NVISA = NVIS
C                                       Create new file.
C                                       Get CATBLK from old file.
      CNOIN2 = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISK2, CNOIN2, NAME2, CLAS2, SEQ2,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAME2, CLAS2, SEQ2, DISK2, NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISK2, CNOIN2, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      CALL COPY (256, CATBLK, CATOLD)
C                                       Allow packed uv data
      ILOCW2 = -1
      IF (CATBLK(KINAX).EQ.1) THEN
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCW2,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Check input file compatibility
      IF ((NVSA.NE.(LREC-NRPARM)/CATBLK(KINAX)) .OR.
     *   (INCFA.NE.INCF/CATBLK(KINAX)) .OR.
     *   (INCIFA.NE.INCIF/CATBLK(KINAX))) THEN
         JERR = 4
         MSGTXT = 'INPUT FILES ARE INCOMPATIBLE'
         GO TO 990
         END IF
      NVIS2 = NVIS
      LREC2 = LREC
      NRPRM2 = NRPARM
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAME2, CLAS2, SEQ2, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      CNOOUT = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CNOOUT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((CNOOUT.NE.CNOIN2) .OR. (DISKO.NE.DISKIN)) THEN
            MSGTXT = 'MAY OVERWRITE INPUT FILE ONLY.  QUITTING'
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, CNOOUT, CATBLK, 'WRIT', BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CNOOUT
      FRW(NCFILE) = FRW(NCFILE) - 1
      CALL COPY (256, CATBLK, CATO)
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISK2, CNOIN2, NAME2, CLAS2, SEQ2, PTYPE,
     *   NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK2
      FCNO(NCFILE) = CNOIN2
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy header keywords
      CALL KEYCOP (DISKIN, CNOIN, DISKO, CNOOUT, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVMTIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1065 FORMAT ('UVMTIN: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE UVMAVG (NC, AVDATA, IRET)
C-----------------------------------------------------------------------
C   UVMTUV averages the second input file and saves it in an array.
C   Input:
C      NC       I        Number correlators in data set
C   Input in common:
C      DISKIN   I        Volumn number of the avg. file.
C      CNOIN    I        Catalog slot number for second input
C   Output in common:
C      BLPNT    I(*,*)   Baseline numbers for first and second antennas
C   Output:
C      AVDATA   R(*)     Time averaged baseline values (*,corr,baseline)
C      IRET     I        Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NC, IRET
      REAL      AVDATA(3,NC,*)
C
      INTEGER   INDEX, I, J, IA1, IA2, NUMBAS, BLINDX, NUMVS, NCP,
     *   CATMP(256)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'UVMTH.INC'
      REAL      RPARM(20), VIS(UVBFSS)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (VIS, BUFF1)
C-----------------------------------------------------------------------
C                                       Initialize arrays
      J = 3 * NC * MAXXBL
      CALL RFILL (J, 0.0, AVDATA)
      NUMBAS = 0
      J = MAXANT * MAXANT
      CALL FILL (J, 0, BLPNT)
      NCP = 3 * NVSA
C                                       protect output image header
      CALL COPY (256, CATBLK, CATMP)
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      NUMVS = 0
C                                       Loop
C                                       Read vis. record.
 100  CONTINUE
         CALL UVGET ('READ', RPARM, VIS, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IF (IRET.EQ.0) THEN
C                                       Baseline pointers
            IF (ILOCB.GE.0) THEN
               IA1 = RPARM(1+ILOCB) / 256. + 0.1
               IA2 = RPARM(1+ILOCB) - IA1*256. + 0.1
            ELSE
               IA1 = RPARM(1+ILOCA1) + 0.1
               IA2 = RPARM(1+ILOCA2) + 0.1
               END IF
            IF (BLPNT(IA1,IA2).LE.0) THEN
               IF (NUMBAS.GE.MAXXBL) THEN
                  WRITE (MSGTXT,1101) NUMBAS
                  IRET = 5
                  GO TO 990
                  END IF
               NUMBAS = NUMBAS + 1
               BLPNT(IA1,IA2) = NUMBAS
               BLPNT(IA2,IA1) = NUMBAS
               END IF
            BLINDX = BLPNT(IA1,IA2)
            INDEX = 1
            NUMVS = NUMVS + 1
C                                       Accumulate
            DO 150 J = 1,NVSA
               IF (VIS(INDEX+2).GT.0.0) THEN
                  AVDATA(1,J,BLINDX) = AVDATA(1,J,BLINDX) +
     *               VIS(INDEX) * VIS(INDEX+2)
                  AVDATA(2,J,BLINDX) = AVDATA(2,J,BLINDX) +
     *               VIS(INDEX+1) * VIS(INDEX+2)
                  AVDATA(3,J,BLINDX) = AVDATA(3,J,BLINDX) +
     *               VIS(INDEX+2)
                  END IF
               INDEX = INDEX + 3
 150           CONTINUE
            GO TO 100
            END IF
C                                       Average
      DO 220 I = 1,NUMBAS
         DO 210 J = 1,NVSA
            IF (AVDATA(3,J,I).GT.0.0) THEN
               AVDATA(1,J,I) = AVDATA(1,J,I) / AVDATA(3,J,I)
               AVDATA(2,J,I) = AVDATA(2,J,I) / AVDATA(3,J,I)
               END IF
 210        CONTINUE
 220     CONTINUE
      CALL COPY (256, CATMP, CATBLK)
C                                       MESSAGE
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),1210) NUMVS
      WRITE (MSGTXT,1210) NUMVS
      CALL MSGWRT (4)
C                                       Close file
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      IF (IRET.LE.0) GO TO 999
         WRITE (MSGTXT,1220) IRET
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVMAVG: ERROR',I3,' OPEN VIS FILE FOR AVERAGING')
 1100 FORMAT ('UVMAVG: ERROR',I3,' READING VIS FILE FOR AVERAGING')
 1101 FORMAT ('UVMAVG: TOO MANY BASELINES >',I5)
 1210 FORMAT ('Averaged ',I8,' visibility records')
 1220 FORMAT ('UVMAVG: ERROR',I3,' CLOSING AVG. VIS FILE')
      END
      SUBROUTINE UVMTUV (NC, AVDATA, IRET)
C-----------------------------------------------------------------------
C   UVMTUV sends uv data one point at a time to the correction
C   routine and then writes the modified data if requested.
C   Input in common:
C   Input:
C      NC       I      Number of correlators
C      AVDATA   R(*)   Average of data set 2 (3,NC,baseline)
C   Output:
C      IRET     I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NC, IRET
      REAL      AVDATA(3,NC,*)
C
      CHARACTER OFILE*48, IFILE*48, OPCH(4)*12
      INTEGER   INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, ILENBU,
     *   KBIND, NIOUT, NIOLIM, IBIND, I, IA1, IA2, ISUB, BO, VO, NUMVIS,
     *   XCOUNT, LFQ, ITRIM, NCH, RNXRET
      LOGICAL   T, F
      INCLUDE 'UVMTH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNI, LUNO /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
      DATA OPCH /'sum', 'difference', 'product', 'ratio'/
C-----------------------------------------------------------------------
C                                       Get uv header info.
      CALL UVPGET (IRET)
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISK2, CNOIN2, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISK2, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CNOOUT, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS2, VO, LREC2, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS2, VO, LREC2, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
      LFQ = 1
C                                       make an index table
      CALL RNXGET (DISK2, CNOIN2, CATOLD)
      CALL RNXINI (DISKO, CNOOUT, CATBLK, RNXRET)
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Loop over buffer
         DO 190 I = 1,INIO
            IF (ILOCB.GE.0) THEN
               IA1 = BUFF1(IPTRI+ILOCB) / 256. + 0.1
               IA2 = BUFF1(IPTRI+ILOCB) - IA1*256. + 0.1
               ISUB = (BUFF1(IPTRI+ILOCB) - IA1*256 - IA2) * 100.0 + 1.1
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               ISUB = BUFF1(IPTRI+ILOCSA) + 0.1
               END IF
            IF (ILOCFQ.GE.0) LFQ = BUFF1(IPTRI+ILOCFQ) + 0.01
            IF ((ISUB.EQ.SUBARR) .AND. (LFQ.EQ.FRQSEL)) THEN
               NUMVIS = NUMVIS + 1
C                                      Call user routine.
               IF (ILOCW2.GE.0) THEN
                  CALL ZUVXPN (NVSA, BUFF1(IPTRI+NRPRM2),
     *               BUFF1(IPTRI+ILOCW2), BUFF3)
                  CALL UVMATH (IA1, IA2, NC, AVDATA, BUFF3, IRET)
                  CALL ZUVPAK (NVSA, BUFF3, BUFF1(IPTRI+ILOCW2),
     *               BUFF1(IPTRI+NRPRM2))
               ELSE
                  CALL UVMATH (IA1, IA2, NC, AVDATA,
     *               BUFF1(IPTRI+NRPRM2), IRET)
                  END IF
C                                       Error (fatal)
               IF (IRET.GT.0) THEN
                  WRITE (MSGTXT,1120) IRET
                  GO TO 990
C                                       Copy to output.
               ELSE IF (IRET.EQ.0) THEN
                  XCOUNT = XCOUNT + 1.0D0
                  CALL RCOPY (LREC2, BUFF1(IPTRI), BUFF2(IPTRO))
                  IPTRO = IPTRO + LREC2
                  NIOUT = NIOUT + 1
C                                       update NX table
                  CALL RNXUPD (BUFF1(IPTRI), RNXRET)
                  END IF
               IPTRI = IPTRI + LREC2
C                                       Write vis record.
               IF (NIOUT.GE.NIOLIM) THEN
                  CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *               IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1150) IRET
                     GO TO 990
                     END IF
                  IPTRO = KBIND
                  NIOUT = 0
                  END IF
               END IF
 190        CONTINUE
C                                       Read next buffer.
         IF (INIO.GT.0) GO TO 100
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      NCH = ITRIM (OPCH(ICODE))
      WRITE (MSGTXT,1200) NVIS, OPCH(ICODE)(:NCH)
      CALL MSGWRT (4)
      CALL UCMPRS (NVIS, DISKO, CNOOUT, LUNO, CATBLK, IRET)
C                                       close NX table
      CALL RNXCLS (RNXRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVMTUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1010 FORMAT ('UVMTUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('UVMTUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('UVMTUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('UVMTUV: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('UVMTUV: UVMATH ERROR',I3)
 1150 FORMAT ('UVMTUV: ERROR',I3,' WRITING VIS FILE')
 1200 FORMAT ('Wrote',I12,1X,A,' visibility records')
      END
      SUBROUTINE UVMHIS
C-----------------------------------------------------------------------
C   UVMHIS copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, LABEL*8, NOTTYP*2
      INTEGER   LUN1, LUN2, IERR, I, NONOT
      INCLUDE 'UVMTH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1, LUN2 /27,28/
      DATA NONOT, NOTTYP /1, 'NX'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISK2, DISKO, CNOIN2, CNOOUT, CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       New history
      HILINE = TSKNAM // '/ data set averaged over all time'
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
C                                       calibration history
      CALL CALHIS (LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       data set acted upon
      HILINE = TSKNAM // '/ data set acted upon by the averaged data'
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCO2 (TSKNAM, NAME2, CLAS2, SEQ2, DISK2, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
C                                       OPCODE
      WRITE (HILINE,2000) TSKNAM, OPCODE
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                      Add other supplied history.
      IF (NUMHIS.GT.0) THEN
         WRITE (LABEL,1010) TSKNAM
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 100
 50         CONTINUE
         END IF
C                                       Close HI file
 100  CALL HICLOS (LUN2, .TRUE., BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISK2, DISKO, CNOIN2,
     *   CNOOUT, CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'UVMHIS: ERROR COPYING TABLES'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, CNOOUT, CATBLK, 'REST', BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVMHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,'/')
 2000 FORMAT (A6,'OPCODE =''',A,''' / Operation requested')
      END
      SUBROUTINE UVMATH (IA1, IA2, NC, AVDATA, VIS, IRET)
C-----------------------------------------------------------------------
C   Modify data.
C   Inputs:
C      IA1     I    First antenna number
C      IA2     I    Second antenna number
C      VIS     R(3,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C   Inputs from COMMON:
C      BLPNT  I(*,*)    Baseline numbers for first and second antennas
C      AVDATA R(3,*,*)  Time averaged baseline values (*,corr,baseline)
C      NVSA   I         Number of correlations
C   Output:
C      VIS        R    Visibilities
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   IA1, IA2, NC, IRET
      REAL      AVDATA(3,NC,*), VIS(3,*)
C
      INTEGER   BLINDX, LOOP
      COMPLEX   C1, C2, C3
      INCLUDE 'UVMTH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Something for this baseline?
      BLINDX = BLPNT(IA1,IA2)
      IF (BLINDX.LE.0) THEN
         IRET = -1
         GO TO 999
         END IF
C                                       Branch by operation
C                                       Add
      IF (ICODE.LE.1) THEN
         DO 10 LOOP = 1,NVSA
            IF (AVDATA(3,LOOP,BLINDX).GT.0.0) THEN
               VIS(1,LOOP) = VIS(1,LOOP) + AVDATA(1,LOOP,BLINDX)
               VIS(2,LOOP) = VIS(2,LOOP) + AVDATA(2,LOOP,BLINDX)
            ELSE
               VIS(3,LOOP) = 0.0
               END IF
 10         CONTINUE
C                                       Subtract
      ELSE IF (ICODE.EQ.2) THEN
         DO 20 LOOP = 1,NVSA
            IF (AVDATA(3,LOOP,BLINDX).GT.0.0) THEN
               VIS(1,LOOP) = VIS(1,LOOP) - AVDATA(1,LOOP,BLINDX)
               VIS(2,LOOP) = VIS(2,LOOP) - AVDATA(2,LOOP,BLINDX)
            ELSE
               VIS(3,LOOP) = 0.0
               END IF
 20         CONTINUE
C                                       Multiply
      ELSE IF (ICODE.EQ.3) THEN
         DO 30 LOOP = 1,NVSA
            IF (AVDATA(3,LOOP,BLINDX).GT.0.0) THEN
               C1 = CMPLX (VIS(1,LOOP), VIS(2,LOOP))
               C2 = CMPLX (AVDATA(1,LOOP,BLINDX), AVDATA(2,LOOP,BLINDX))
               C3 = C1 * C2
               VIS(1,LOOP) = REAL (C3)
               VIS(2,LOOP) = AIMAG (C3)
            ELSE
               VIS(3,LOOP) = 0.0
               END IF
 30         CONTINUE
C                                       Divide
      ELSE
         DO 40 LOOP = 1,NVSA
            IF (AVDATA(3,LOOP,BLINDX).GT.0.0) THEN
               C1 = CMPLX (VIS(1,LOOP), VIS(2,LOOP))
               C2 = CMPLX (AVDATA(1,LOOP,BLINDX), AVDATA(2,LOOP,BLINDX))
               IF (ABS (C2).GT.1.0E-10) THEN
                  C3 = C1 / C2
               ELSE
                  C3 = CMPLX (0.0, 0.0)
                  VIS(3,LOOP) = 0.0
                  END IF
               VIS(1,LOOP) = REAL (C3)
               VIS(2,LOOP) = AIMAG (C3)
            ELSE
               VIS(3,LOOP) = 0.0
               END IF
 40         CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE TABTY (OPCODE, BUFFER, ITYRNO, TYKOLS, TYNUMV, NUMPOL,
     *   NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, TSYS, TANT,
     *   IERR)
C-----------------------------------------------------------------------
C! Does I/O to Tsys (TY) table opened by TYINI
C# EXT-util UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2013-2014
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to TSYS (TY) extention tables. Usually used after
C   setup by TYINI.
C    Inputs:
C     OPCODE       C*4 Operation code:
C                      'READ' = read entry from table.
C                      'WRIT' = write entry in table.
C                      'CLOS' = close file, flush on write
C     BUFFER(512)  I   I/O buffer and related storage, also defines file
C                      if open. Should have been returned by TABINI or
C                      TABINI.
C     ITYRNO       I   Next record number to read or write.
C     TYKOLS(*)    I   The column pointer array in order defined in
C                      PTYTAB.INC
C     TYNUMV(*)    I   Element count in each column.
C     NUMPOL       I   Number of polarizations (1 or 2)
C     NUMIF        I   Number of IFs in TY file
C    Input/output: (written to or read from Tsys file)
C     TIME         R   Time of record (Days)
C     TIMEI        R   Time interval covered by record (days)
C     SOURID       I   Source ID as defined in the SOURCE table.
C     ANTNO        I   Antenna number.
C     SUBA         I   Subarray number.
C     FREQID       I   Freqid #
C     TSYS(2,*)    R   System temperature in Kelvin (one per poln/IF)
C     TANT(2,*)    R   Antenna temperature in Kelvin (one per poln/IF)
C                         these set blank on read if value ~ 999
C    Output:
C     ITYRNO       I   Next record number.
C     IERR         I   Error code, 0=>OK else TABIO error.
C                      Note: -1=> read but record deselected.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PTYTAB.INC'
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), ITYRNO, TYKOLS(MAXTYC), TYNUMV(MAXTYC),
     *   NUMPOL, NUMIF, SOURID, ANTNO, SUBA, FREQID, IERR
      REAL      TIME, TIMEI, TSYS(2,NUMIF), TANT(2,NUMIF)
C
      INTEGER   RECSIZ
C                                       RECSIZ = size of RECI
      PARAMETER (RECSIZ = 6 + 4*MAXIF)
      INTEGER   RECI(RECSIZ), IP, IP2, I
      LOGICAL   DOREAD, DOCLOS
      REAL      RECORD(RECSIZ)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (RECORD, RECI)
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
      DOCLOS = OPCODE.EQ.'CLOS'
C                                       Branch for CLOS
      IF (DOCLOS) GO TO 800
C                                       If write fill RECORD
      IF (.NOT.DOREAD) THEN
         RECORD(TYKOLS(TYRTIM)) = TIME
         RECORD(TYKOLS(TYRTMI)) = TIMEI
         RECI(TYKOLS(TYISID)) = SOURID
         RECI(TYKOLS(TYIANT)) = ANTNO
         RECI(TYKOLS(TYISUB)) = SUBA
         RECI(TYKOLS(TYIFQI)) = FREQID
         IP = TYKOLS(TYRTS1)
         IP2 = TYKOLS(TYRTA1)
         DO 20 I = 1,NUMIF
            RECORD(IP) = TSYS(1,I)
            RECORD(IP2) = TANT(1,I)
            IP = IP + 1
            IP2 = IP2 + 1
 20         CONTINUE
C                                       Second poln?
         IF (NUMPOL.GT.1) THEN
            IP = TYKOLS(TYRTS2)
            IP2 = TYKOLS(TYRTA2)
            DO 30 I = 1,NUMIF
               RECORD(IP) = TSYS(2,I)
               RECORD(IP2) = TANT(2,I)
               IP = IP + 1
               IP2 = IP2 + 1
 30            CONTINUE
            END IF
         END IF
C                                       Process record.
 50   CALL TABIO (OPCODE, 0, ITYRNO, RECORD, BUFFER, IERR)
      ITYRNO = ITYRNO + 1
      IF (IERR.GT.0) GO TO 990
C                                       If READ pick data from RECORD.
      IF (DOREAD) THEN
         TIME = RECORD(TYKOLS(TYRTIM))
         TIMEI = RECORD(TYKOLS(TYRTMI))
         SOURID = RECI(TYKOLS(TYISID))
         ANTNO = RECI(TYKOLS(TYIANT))
         SUBA = RECI(TYKOLS(TYISUB))
         FREQID = RECI(TYKOLS(TYIFQI))
         IP = TYKOLS(TYRTS1)
         IP2 = TYKOLS(TYRTA1)
         DO 70 I = 1,NUMIF
            TSYS(1,I) = FBLANK
            TANT(1,I) = FBLANK
            IF (TYNUMV(TYRTS1).GT.0) THEN
               IF (ABS(RECORD(IP)-999.).GT.0.5) TSYS(1,I) = RECORD(IP)
               END IF
            IF (TYNUMV(TYRTA1).GT.0) THEN
               IF (ABS(RECORD(IP2)-999.).GT.0.5) TANT(1,I) = RECORD(IP2)
               END IF
            IP = IP + 1
            IP2 = IP2 + 1
 70         CONTINUE
C                                       Second poln?
         IF (NUMPOL.GT.1) THEN
            IP = TYKOLS(TYRTS2)
            IP2 = TYKOLS(TYRTA2)
            DO 80 I = 1,NUMIF
               TSYS(2,I) = FBLANK
               TANT(2,I) = FBLANK
               IF (TYNUMV(TYRTS2).GT.0) THEN
                  IF (ABS(RECORD(IP)-999.).GT.0.5)
     *               TSYS(2,I) = RECORD(IP)
                  END IF
               IF (TYNUMV(TYRTA2).GT.0) THEN
                  IF (ABS(RECORD(IP2)-999.).GT.0.5)
     *               TANT(2,I) = RECORD(IP2)
                  END IF
               IP = IP + 1
               IP2 = IP2 + 1
 80            CONTINUE
            END IF
         END IF
      GO TO 999
C                                       Close
 800  CALL TABIO ('CLOS', 0, ITYRNO, RECORD, BUFFER, IERR)
      IF (IERR.GT.0) GO TO 990
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1800) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1800 FORMAT ('TABTY: TABIO ERROR',I3)
      END

      SUBROUTINE DSKASS (IOP, RHOST, IERR)
C-----------------------------------------------------------------------
C! assign and de-assign disks for AIPS by host
C# POPS-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2010-2011, 2017, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DSKASS will add to the DAnn: assignments or remove one as needed
C   Inputs:
C      IOP     I       1 - assign, 2 de-assign
C      RHOST   C*(*)   Remote host to be added or removed
C   Output
C      IERR    I       Error code: 0 good
C-----------------------------------------------------------------------
      INTEGER   IOP, IERR
      CHARACTER RHOST*(*)
C
      INTEGER   I, I1, I2, J, JJ, JTRIM, TXLUN, TXIND, SCRBUF(256),
     *   INVOL
      CHARACTER DVAL*4, XLATED*256
      HOLLERITH HVAL(2), HNAME(48)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DDRC.INC'
      INCLUDE 'INCS:DISK.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      TXIND = 0
C                                       assign
      IF (IOP.EQ.1) THEN
         INVOL = NVOL
         CALL ZTRLOG (11, 'DADEVS_FILE', 256, XLATED, JJ, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'TRANSLATING DADEVS_FILE LOGICAL'
            GO TO 990
            END IF
         TXLUN = 11
         CALL ZTXOPN ('QRED', TXLUN, TXIND, XLATED(:JJ), .FALSE., IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPEN DADEVS FILE'
            GO TO 990
            END IF
         JJ = JTRIM (RHOST)
         I1 = 0
 110     CALL ZTXIO ('READ', TXLUN, TXIND, XLATED, IERR)
         IF (IERR.EQ.2) THEN
            CALL ZTXCLS (TXLUN, TXIND, IERR)
            TXIND = 0
         ELSE IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READING DADEVS FILE'
            GO TO 990
         ELSE IF (IERR.EQ.0) THEN
            IF (XLATED(:3).NE.'-  ') GO TO 110
            I = INDEX (XLATED(4:), RHOST(:JJ))
            IF (I.GT.0) THEN
               I = JTRIM (XLATED)
               CALL ZEHEX (NVOL+1, 4, DVAL)
               DVAL(:2) = 'DA'
               CALL CHR2H (4, DVAL, 1, HVAL)
               I2 = I - 3
               CALL CHR2H (I2, XLATED(4:I), 1, HNAME)
               CALL ZCRLOG (4, HVAL, I2, HNAME, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'CREATE LOGICAL '
     *               // DVAL
                  GO TO 990
                  END IF
               NVOL = NVOL + 1
               DSKHST(NVOL) = RHOST
               DSKNAM(NVOL) = XLATED(4:I)
               MSGSUP = 32000
               CALL CATCR (NVOL, 50, SCRBUF, IERR)
               MSGSUP = 0
               IF (IERR.NE.0) THEN
                  MSGTXT = XLATED(4:I) // ' NOT AVAILABLE'
                  CALL MSGWRT (6)
                  DSKHST(NVOL) = ' '
                  DSKNAM(NVOL) = ' '
                  NVOL = NVOL - 1
                  IERR = 0
                  END IF
               END IF
            GO TO 110
            END IF
         CALL ZDRCHK
         CALL GNETSP (INVOL+1, NVOL, DSKNAM)
C                                       de-assign
      ELSE
         I1 = 0
         DO 210 I = MINDSK+1,NVOL
            IF (RHOST.EQ.DSKHST(I)) THEN
               I1 = I1 + 1
               DSKHST(I) = ' '
               DSKNAM(I) = ' '
               END IF
 210        CONTINUE
C                                       re-assign needed
         IF (I1.GT.0) THEN
            IF (NVOL-I1.GT.MINDSK) THEN
               DO 220 I = MINDSK+1,NVOL
                  IF (DSKHST(I).EQ.' ') THEN
                     DO 215 J = I+1,NVOL
                        IF (DSKHST(J).NE.' ') THEN
                           DSKHST(I) = DSKHST(J)
                           DSKNAM(I) = DSKNAM(J)
                           TIMEDA(I) = TIMEDA(J)
                           CALL COPY (8, DASSGN(1,J), DASSGN(1,I))
                           DSKLOK(I) = DSKLOK(J)
                           DSKHST(J) = ' '
                           DSKNAM(J) = ' '
                           CALL ZEHEX (I, 4, DVAL)
                           DVAL(:2) = 'DA'
                           JJ = JTRIM (DSKNAM(I))
                           CALL CHR2H (4, DVAL, 1, HVAL)
                           CALL CHR2H (JJ, DSKNAM(I), 1, HNAME)
                           CALL ZCRLOG (4, HVAL, JJ, HNAME, IERR)
                           IF (IERR.NE.0) THEN
                              WRITE (MSGTXT,1000) IERR, 'RESET LOGICAL '
     *                           // DVAL
                              GO TO 990
                              END IF
                           GO TO 220
                           END IF
 215                    CONTINUE
                     END IF
 220              CONTINUE
               END IF
            DO 230 I = NVOL-I1+1,NVOL
               CALL ZEHEX (I, 4, DVAL)
               DVAL(:2) = 'DA'
               CALL CHR2H (4, DVAL, 1, HVAL)
               CALL CHR2H (4, DSKNAM(I), 1, HNAME)
               CALL ZCRLOG (4, HVAL, 4, HNAME, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'CLEAR LOGICAL ' // DVAL
                  CALL MSGWRT (6)
                  END IF
 230           CONTINUE
            END IF
            NVOL = NVOL - I1
         END IF
      IERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DSKASS ERROR',I3,' ON ',A)
      END

      SUBROUTINE CAXPY (N, CA, CX, INCX, CY, INCY)
C-----------------------------------------------------------------------
C! Linpack routine: Complex constant times a vector plus a vector
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Complex constant times a vector plus a vector.
C       CY(i*INCY+1) = CY(i*INCY+1) + CA * CX(i*INCX+1) for i=0 to N-1
C     Inputs:
C      N     I  Element count
C      CA    C  Constant
C      CX(*) C  Array
C      INCX  I  Increment of CX
C    Input/output:
C      CY(*) C  Array
C      INCY  I  Increment of CY
C     Jack Dongarra, LINPACK, 3/11/78.
C-----------------------------------------------------------------------
      COMPLEX   CX(*), CY(*), CA
      INTEGER   I, INCX, INCY, IX, IY, N
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
      IF (ABS (REAL (CA)) + ABS (AIMAG (CA)) .EQ. 0.0 ) GO TO 999
      IF (INCX.EQ.1.AND.INCY.EQ.1) GO TO 20
C                                       Code for unequal increments or
C                                       equal increments not equal to 1.
      IX = 1
      IY = 1
      IF (INCX.LT.0) IX = (-N+1)*INCX + 1
      IF (INCY.LT.0) IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
         CY(IY) = CY(IY) + CA*CX(IX)
         IX = IX + INCX
         IY = IY + INCY
   10    CONTINUE
      GO TO 999
C                                       Code for both increments equal
C                                       to 1.
   20 DO 30 I = 1,N
         CY(I) = CY(I) + CA*CX(I)
   30    CONTINUE
C
 999  RETURN
      END

      SUBROUTINE OFMLST (DOCRT, PRTNAM, N, OFM, IOFM)
C-----------------------------------------------------------------------
C! verbs setting, saving, and retrieving the TV OFM tables
C# POPS-appl TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998-2000, 2004, 2007, 2011
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   does OFMLIST verb to list the current OFM on the line printer
C   or the terminal.
C   Inputs:
C      PRTNAM   C*48      File name to save print
C      N        I         First dimension of OFM, IOFM
C      OFM      R(N,3)    Current OFM
C   In/Out:
C      DOCRT    R         > 0 => CRT, > 72 => CRT width, <= 0 printer
C                         reset in abs value to width used
C   Outputs:
C      IOFM     I(N,3)    Integer scaled OFM
C   Common: DERR.INC
C                         returns error codes in ERRNUM, PNAME
C-----------------------------------------------------------------------
      INTEGER   N, IOFM(N,3)
      REAL      DOCRT, OFM(N,3)
      CHARACTER PRTNAM*48
C
      INTEGER   BUFFER(256), IERR, JERR, I, J, ILINE, PAGE, ICOL, II,
     *   I2, JJ, J1, J2, INCR, IFIND, NACROS, PLUN, LS, POTERR, NCOL
      LOGICAL   F, QUIT
      CHARACTER PRGNAM*6, TITL1*132, TITL2*132, PLINE*132, SCRTCH*132
C
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA PRGNAM /'OFMLST'/
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) DOCRT = MIN (-1.0,
     *   DOCRT)
C                                       Set values for crt.
      IF (DOCRT.GT.0.0) THEN
         PLUN = 5
         CALL LSERCH ('SRCH', PLUN, IFIND, F, IERR)
         CALL ZWINC (NCOL)
         NACROS = DOCRT + 0.5
         IF ((NACROS.LE.72) .OR. (NACROS.GT.NCOL)) NACROS = NCOL
C                                       Set values for printer.
      ELSE
         IF (PRTNAM.EQ.' ') DOCRT = -1.0
         CALL LPOPEN (PRTNAM, DOCRT, PLUN, IFIND, NACROS, BUFFER, IERR)
         END IF
      POTERR = 57
      IF (IERR.NE.0) GO TO 990
      PAGE = 0
      ILINE = 900
      POTERR = 50
      TITL2 = ' '
C                                       Scale OFM values
      LS = 10
      J = OFMINP + 1
      DO 305 I = 1,J
         IOFM(I,1) = OFM(I,1) * 10000.0 + 0.5
         IOFM(I,2) = OFM(I,2) * 10000.0 + 0.5
         IOFM(I,3) = OFM(I,3) * 10000.0 + 0.5
 305     CONTINUE
C                                       Check for color OFM
      DO 310 I = 1,J
         IF (IOFM(I,1).NE.IOFM(I,2)) GO TO 330
         IF (IOFM(I,1).NE.IOFM(I,3)) GO TO 330
         IF (IOFM(I,2).NE.IOFM(I,3)) GO TO 330
 310     CONTINUE
C                                       Black and White:
      ICOL = NACROS / 12
      INCR = LS * ICOL
      TITL1 = ' '
      TITL1(25:) = 'Current OFM is Black and White'
      DO 320 I = 1,J,INCR
         IF ((I.EQ.1) .OR. (DOCRT.GT.-2.5)) THEN
            WRITE (PLINE,1310) ('  In-  Out  ', JJ = 1,ICOL)
            CALL PRTALN (PLUN, IFIND, DOCRT, NACROS, TITL1, TITL2,
     *         PLINE, ILINE, PAGE, SCRTCH, QUIT)
            IF ((QUIT) .OR. (ERRNUM.NE.0)) GO TO 390
            END IF
         I2 = MIN (I+LS-1, J)
         DO 315 II = I,I2
            J1 = II - 1
            J2 = II + INCR - 1
            J2 = MIN (J2, J) - 1
            WRITE (PLINE,1311) (JJ, IOFM(JJ+1,1), JJ = J1,J2,LS)
            CALL PRTALN (PLUN, IFIND, DOCRT, NACROS, TITL1, TITL2,
     *         PLINE, ILINE, PAGE, SCRTCH, QUIT)
            IF ((QUIT) .OR. (ERRNUM.NE.0)) GO TO 390
 315        CONTINUE
 320     CONTINUE
      GO TO 390
C                                       Color
 330  ICOL = NACROS / 24
      INCR = LS * ICOL
      TITL1 = ' '
      TITL1(25:) = 'Current OFM is in color (colour)'
      DO 340 I = 1,J,INCR
         IF ((I.EQ.1) .OR. (DOCRT.GT.-2.5)) THEN
            WRITE (PLINE,1330) ('  In- Blue:green:  red  ', JJ = 1,ICOL)
            CALL PRTALN (PLUN, IFIND, DOCRT, NACROS, TITL1, TITL2,
     *         PLINE, ILINE, PAGE, SCRTCH, QUIT)
            IF ((QUIT) .OR. (ERRNUM.NE.0)) GO TO 390
            END IF
         I2 = MIN (I+LS-1, J)
         DO 335 II = I,I2
            J1 = II - 1
            J2 = II + INCR - 1
            J2 = MIN (J2, J) - 1
            WRITE (PLINE,1331) (JJ, IOFM(JJ+1,1), IOFM(JJ+1,2),
     *         IOFM(JJ+1,3), JJ = J1,J2,LS)
            CALL PRTALN (PLUN, IFIND, DOCRT, NACROS, TITL1, TITL2,
     *         PLINE, ILINE, PAGE, SCRTCH, QUIT)
            IF ((QUIT) .OR. (ERRNUM.NE.0)) GO TO 390
 335        CONTINUE
 340     CONTINUE
C                                       Close printer.
 390  IF (DOCRT.LE.0.0) CALL LPCLOS (PLUN, IFIND, ILINE, JERR)
      POTERR = 0
C                                       POPS error management
 990  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.EQ.0) GO TO 999
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
C-----------------------------------------------------------------------
 1310 FORMAT (11A12)
 1311 FORMAT (11(I5,'-',I5.4,1X))
 1330 FORMAT (5A24)
 1331 FORMAT (5(I5,'-',I5.4,':',I5.4,':',I5.4,1X))
      END

      SUBROUTINE MCINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IMCRNO, MCKOLS, MCNUMV, OBSCOD, RDATE, NSTOKE, STOKE1, NUMIF,
     *   NCHAN, RFREQ, CHANBW, REFPIX, NUMPOL, FFTSIZ, OVRSMP, ZEROPD,
     *   TAPER, DELTAT, IERR)
C-----------------------------------------------------------------------
C! Creates/opens/initializes model components (MC) table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1997-1998, 2006, 2009, 2011, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes model components (MC) extension tables.
C   Inputs:
C     OPCODE       C*4 Operation code:
C                      'WRIT' = create/init for write or read
C                      'READ' = open for read only
C     BUFFER(512)  I   I/O buffer and related storage, also defines file
C                      if open.
C     DISK         I   Disk to use.
C     CNO          I   Catalog slot number
C     VER          I   CL file version
C     CATBLK(256)  I   Catalog header block.
C     LUN          I   Logical unit number to use
C   Input (create) / output (pre-existing):
C     OBSCOD       C*8  Observing code
C     RDATE        C*8  Reference date
C     NSTOKE       I    Number of "Stokes" channels in data
C     STOKE1       I    First "Stokes" channel number
C     NUMIF        I    Number of IFs
C     NCHAN        I    Number of channels
C     RFREQ        D    Reference frequency (Hz)
C     CHANBW       R    Channel bandwidth (Hz)
C     REFPIX       R    Reference pixel for frequency
C     NUMPOL       I    Number of polarizations in table
C     FFTSIZ       I    FFT size
C     OVRSMP       I    Oversampling factor
C     ZEROPD       I    Zero padding factor
C     TAPER        C*8  Tapering function ('HANNING' or 'UNIFORM')
C     DELTAT       R    Time interval in table (days) default 2 minutes
C     MCNUMV(21)   I    Element count in each column.
C                        before the creation of a new CL table.
C   Output:
C     IMCRNO       I   Next scan number, start of the file if 'READ',
C                       the last+1 if WRITE
C     MCKOLS(21)   I   The column pointer array in order defined by
C                        the parameters in PCLTAB.INC
C     MCNUMV(21)   I   Element count in each column.
C     IERR         I   Return error code, 0=>OK, else TABINI or TABIO
C                      error.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, OBSCOD*8, RDATE*8, TAPER*8
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, IMCRNO,
     *   MCKOLS(*), MCNUMV(*), NSTOKE, STOKE1, NUMIF, NCHAN, NUMPOL,
     *   FFTSIZ, OVRSMP, ZEROPD, IERR
      DOUBLE PRECISION RFREQ
      REAL      CHANBW, REFPIX, DELTAT
C
      INTEGER   PKEY, PCOL
      PARAMETER (PKEY=16)
      PARAMETER (PCOL=21)
C
      HOLLERITH HOLTMP(6)
      CHARACTER TTITLE*56, TITLE1(11)*24, TITLE2(10)*24, TITLE(PCOL)*24,
     *   UNITS(PCOL)*8, KEYW(PKEY)*8
      INTEGER   NKEY, NREC, DATP(128,2), NCOL, NTT, IPT, DTYP(PCOL),
     *   NDATA, KLOCS(PKEY), KEYVAL(2*PKEY), IPOINT, JERR, J, I,
     *   KEYTYP(PKEY), REVNO, MSGSAV, NC, ITRIM, ITEMP(6)
      LOGICAL   DOREAD, NEWFIL
      REAL      KEYR(27)
      DOUBLE PRECISION KEYVAD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (TITLE(1), TITLE1), (TITLE(12), TITLE2)
      EQUIVALENCE (KEYVAL, KEYR), (HOLTMP, ITEMP)
      DATA NTT /56/
      DATA TTITLE /'MODEL_COMPS '/
C                                       Values >10 are scalar
      DATA DTYP /11, 14, 14, 14, 14, 11, 11, 11, 11, 11,
     *           11, 02, 02, 12, 12, 11, 11, 02, 02, 12,
     *           12/
C                                       NOTE: Change PCLTAB.INC when
C                                       changing the table columns.
      DATA TITLE1 /'TIME                    ',
     *   'SOURCE_ID               ', 'ANTENNA_NO              ',
     *   'ARRAY                   ', 'FREQID                  ',
     *   'ATMOS                   ', 'DATMOS                  ',
     *   'GDELAY                  ', 'GRATE                   ',
     *   'CLOCK_1                 ', 'DCLOCK_1                '/
      DATA TITLE2 /
     *   'LO_OFFSET_1             ', 'DLO_OFFSET_1            ',
     *   'DISP_1                  ', 'DDISP_1                 ',
     *   'CLOCK_2                 ', 'DCLOCK_2                ',
     *   'LO_OFFSET_2             ', 'DLO_OFFSET_2            ',
     *   'DISP_2                  ', 'DDISP_2                 '/
      DATA KEYW /'OBSCODE ', 'RDATE   ', 'NO_STKD ', 'STK_1   ',
     *           'NO_BAND ', 'NO_CHAN ', 'REF_FREQ', 'CHAN_BW ',
     *           'REF_PIXL', 'NO_POL  ', 'FFT_SIZE', 'OVERSAMP',
     *           'ZERO_PAD', 'TAPER_FN', 'DELTAT', 'TABREV  '/
      DATA UNITS /'DAYS    ', '        ', '        ', '        ',
     *            '        ', 'SECONDS ', 'SEC/SEC ', 'SECONDS ',
     *            'SEC/SEC ', 'SECONDS ', 'SEC/SEC ', 'HZ      ',
     *            'HZ/SEC  ', 'SEC/M**2', 'S/S/M**2', 'SECONDS ',
     *            'SEC/SEC ', 'HZ      ', 'HZ/SEC  ', 'SEC/M**2',
     *            'S/S/M**2'/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NREC = 1000
      NCOL = 9 + NUMPOL * 6
      IF (DOREAD) NCOL = 0
      NKEY = PKEY
      NDATA = PCOL
      CALL FILL (NDATA, 0, MCKOLS)
      CALL FILL (NDATA, 0, MCNUMV)
C                                       Fill in types
      IF (.NOT.DOREAD) THEN
         CALL COPY (NDATA, DTYP, DATP(1,2))
         DO 10 J = 1,NDATA
            IF (DTYP(J).LT.10) DATP(J,2) = DTYP(J) + 10 * NUMIF
 10         CONTINUE
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'MC', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'MCINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
C                                       Get number of records
      IMCRNO = BUFFER(5) + 1
      IF (DOREAD) IMCRNO = 1
      NKEY = PKEY
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 40 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'MCINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'MCINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       Set keyword values
C                                       OBSCODE
         IPT = 1
         KLOCS(1) = IPT
         KEYTYP(1) = 3
         CALL CHR2H (8, OBSCOD, 1, KEYVAL(1))
         IPT = IPT + 2
C                                       RDATE
         KLOCS(2) = IPT
         KEYTYP(2) = 3
         CALL CHR2H (8, RDATE, 1, KEYVAL(IPT))
         IPT = IPT + 2
C                                       NO_STKD
         KLOCS(3) = IPT
         KEYTYP(3) = 4
         KEYVAL(IPT) = NSTOKE
         IPT = IPT + 1
C                                       STK_1
         KLOCS(4) = IPT
         KEYTYP(4) = 4
         KEYVAL(IPT) = STOKE1
         IPT = IPT + 1
C                                       NO_BAND
         KLOCS(5) = IPT
         KEYTYP(5) = 4
         KEYVAL(IPT) = NUMIF
         IPT = IPT + 1
C                                       NO_CHAN
         KLOCS(6) = IPT
         KEYTYP(6) = 4
         KEYVAL(IPT) = NCHAN
         IPT = IPT + 1
C                                       REF_FREQ
         KLOCS(7) = IPT
         KEYTYP(7) = 1
         CALL DPCOPY (1, RFREQ, KEYR(IPT))
         IPT = IPT + NWDPDP
C                                       CHAN_BW
         KLOCS(8) = IPT
         KEYTYP(8) = 1
         KEYVAD    = CHANBW
         CALL DPCOPY (1, KEYVAD, KEYR(IPT))
         IPT = IPT + NWDPDP
C                                       REF_PIXL
         KLOCS(9) = IPT
         KEYTYP(9) = 1
         KEYVAD    = REFPIX
         CALL DPCOPY (1, KEYVAD, KEYR(IPT))
         IPT = IPT + NWDPDP
C                                       NO_POL
         KLOCS(10) = IPT
         KEYTYP(10) = 4
         KEYVAL(IPT) = NUMPOL
         IPT = IPT + 1
C                                       FFT_SIZE
         KLOCS(11) = IPT
         KEYTYP(11) = 4
         KEYVAL(IPT) = FFTSIZ
         IPT = IPT + 1
C                                       OVERSAMP
         KLOCS(12) = IPT
         KEYTYP(12) = 4
         KEYVAL(IPT) = OVRSMP
         IPT = IPT + 1
C                                       ZERO_PAD
         KLOCS(13) = IPT
         KEYTYP(13) = 4
         KEYVAL(IPT) = ZEROPD
         IPT = IPT + 1
C                                       TAPER_FN
         KLOCS(14) = IPT
         KEYTYP(14) = 3
         CALL CHR2H (8, TAPER, 1, KEYVAL(IPT))
         IPT = IPT + 2
C                                       Time interval
         KLOCS(15) = IPT
         KEYTYP(15) = 1
         KEYVAD    = DELTAT
         IF (DELTAT.LE.0.0) KEYVAD = 2.0D0 / (24.0D0 * 60.0D0)
         CALL DPCOPY (1, KEYVAD, KEYR(IPT))
         IPT = IPT + NWDPDP
C                                       Revision number
         REVNO = 1
         KLOCS(16) = IPT
         KEYTYP(16) = 4
         KEYVAL(IPT) = REVNO
C                                       Only write if just created.
         CALL TABKEY (OPCODE, KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'MCINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         MSGSAV = MSGSUP
         MSGSUP = 32000
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         MSGSUP = MSGSAV
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'MCINI', IERR)
            GO TO 990
            END IF
C                                       Retrieve keyword values
C                                       OBSCODE
         IPOINT = KLOCS(1)
         IF (IPOINT.GT.0) CALL H2CHR (8, 1, KEYVAL(IPOINT), OBSCOD)
C                                       RDATE
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) CALL H2CHR (8, 1, KEYVAL(IPOINT), RDATE)
C                                       NO_STKD
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) NSTOKE = KEYVAL(IPOINT)
C                                       STK_1
         IPOINT = KLOCS(4)
         IF (IPOINT.GT.0) STOKE1 = KEYVAL(IPOINT)
C                                       NO_BAND
         IPOINT = KLOCS(5)
         IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       NO_CHAN
         IPOINT = KLOCS(6)
         IF (IPOINT.GT.0) NCHAN = KEYVAL(IPOINT)
C                                       REF_FREQ
         IPOINT = KLOCS(7)
         IF (IPOINT.GT.0) THEN
            IF (KEYTYP(7).EQ.1) THEN
               CALL RCOPY (NWDPDP, KEYR(IPOINT), KEYVAD)
               RFREQ = KEYVAD
            ELSE
               RFREQ = KEYR(IPOINT)
               END IF
            END IF
C                                       CHAN_BW
         IPOINT = KLOCS(8)
         IF (IPOINT.GT.0) THEN
            IF (KEYTYP(8).EQ.1) THEN
               CALL RCOPY (NWDPDP, KEYR(IPOINT), KEYVAD)
               CHANBW = KEYVAD
            ELSE
               CHANBW = KEYR(IPOINT)
               END IF
            END IF
C                                       REF_PIXL
         IPOINT = KLOCS(9)
         IF (IPOINT.GT.0) THEN
            IF (KEYTYP(9).EQ.1) THEN
               CALL RCOPY (NWDPDP, KEYR(IPOINT), KEYVAD)
               REFPIX = KEYVAD
            ELSE
               REFPIX = KEYR(IPOINT)
               END IF
            END IF
C                                       NO_POL
         IPOINT = KLOCS(10)
         IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       FFT_SIZE
         IPOINT = KLOCS(11)
         IF (IPOINT.GT.0) FFTSIZ = KEYVAL(IPOINT)
C                                       OVERSAMP
         IPOINT = KLOCS(12)
         IF (IPOINT.GT.0) OVRSMP = KEYVAL(IPOINT)
C                                       ZERO_PAD
         IPOINT = KLOCS(13)
         IF (IPOINT.GT.0) ZEROPD = KEYVAL(IPOINT)
C                                       ZERO_PAD
         IPOINT = KLOCS(14)
         IF (IPOINT.GT.0) CALL H2CHR (8, 1, KEYVAL(IPOINT), TAPER)
C                                       time interval
         IPOINT = KLOCS(15)
         IF (IPOINT.GT.0) THEN
            IF (KEYTYP(15).EQ.1) THEN
               CALL RCOPY (NWDPDP, KEYR(IPOINT), KEYVAD)
               DELTAT = KEYVAD
            ELSE
               DELTAT = KEYR(IPOINT)
               END IF
            END IF
C                                       Revision level
         IPOINT = KLOCS(16)
         REVNO = -1
         IF (IPOINT.GT.0) REVNO = KEYVAL(IPOINT)
         END IF
C                                       Get array indices
C                                       Cover your ass from FNDCOL -
C                                       close to flush the buffers and
C                                       then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KEYVAL, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'MCINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'MC', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'MCINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (NDATA, TITLE, 24, .TRUE., BUFFER, MCKOLS, JERR)
C                                       check and set
      NCOL = 9 + NUMPOL * 6
      DO 150 I = 1,NDATA
         IPOINT = MCKOLS(I)
         IF (IPOINT.GT.0) THEN
            MCKOLS(I) = DATP(IPOINT,1)
            MCNUMV(I) = DATP(IPOINT,2) / 10
            IF (MCNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               IF (I.LE.NCOL) CALL MSGWRT (6)
               END IF
         ELSE
            MCKOLS(I) = -1
            MCNUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            IF (I.LE.NCOL) CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('MCINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('MCINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('MCINI: ERROR INITIALIZING MC TABLE FOR ',A4)
      END

      SUBROUTINE  QHIST (A, I, C, N, NB, AMAX, AMIN)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Make histogram of a vector.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   QHIST computes the histogram of a vector.
C   Histogram element (NB-1)*(DATA-MIN)/(MAX-MIN) where DATA
C   is the data value is incremented.
C   Inputs:
C      A     I  Source vector base address.
C      I     I  A address increment.
C      C     I  Histogram base address
C                 Histogram must be cleared before first call.
C      N     I  Element count for A
C      NB    I  Number of bins in histogram
C      AMAX  I  Address of histogram maximum.
C      AMIN  I  Address of histogram minimum.
C-----------------------------------------------------------------------
      INTEGER   A, I, C, N, NB, AMAX, AMIN, JA, JC, JAMAX, JAMIN, INDEX,
     *   LOOP, LEND, ITEMP
      REAL      FACT, XMIN
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                       Addresses to 1-rel
      JA = A + 1
      JC = C + 1
      JAMAX = AMAX + 1
      JAMIN = AMIN + 1
C                                        Compute histogram.
      FACT = (NB-1) / (APCORE(JAMAX) - APCORE(JAMIN))
      XMIN = APCORE(JAMIN)
      LEND = JA + (N-1) * I
      DO 100 LOOP = JA,LEND,I
         INDEX = (APCORE(LOOP) - XMIN) * FACT + 0.5
         INDEX = INDEX + JC
         INDEX = MAX (JC, INDEX)
         ITEMP = JC + NB - 1
         INDEX = MIN (INDEX, ITEMP)
         APCORE(INDEX) = APCORE(INDEX) + 1.0
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE REFRAT (ISUB, REFA, ANT, NUMIF, TIMKOL, SUBKOL, ANTKOL,
     *   SOUKOL, FRQKOL, RF1KOL, RA1KOL, WT1KOL, RF2KOL, RA2KOL, WT2KOL,
     *   BUFFER, MXTIME, WRKTIM, WORK2, WORK3, IRET)
C-----------------------------------------------------------------------
C! Adjusts the reference antenna in an SN table.
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Routine to rereference rates in an open table. Rates are averaged
C   over IF and polarization.  If possible only table entries with valid
C   entries in both polarizations are used to rereference data.
C   All valid entries are included.
C      Note: this routine should be called before REFFAZ.  This routine
C   does not modify the reference antennas in the table
C   Inputs:
C      ISUB     I  Subarray number, 0=>1
C      REFA     I  Primary reference antenna
C      ANT      I  Secondary reference antenna
C      NUMIF    I  The number of IFs
C      TIMKOL   I  Time column pointer.
C      SUBKOL   I  Subarray column pointer
C      ANTKOL   I  Antenna column pointer
C      SOUKOL   I  Source ID column pointer
C      FRQKOL   I  FQ id column pointer
C      RF1KOL   I  Reference antenna 1 pointer
C      RA1KOL   I  Rate 1  column pointer
C      WT1KOL   I  Weight 1 column pointer.
C      RF2KOL   I  Reference antenna 2 pointer <1 => not present
C      RA2KOL   I  Rate 2  column pointer <1 => not present
C      WT2KOL   I  Weight 2 column pointer <1 => not present
C      MXTIME   I  Dimension of work arrays
C   Input/Output:
C      BUFFER   I(*) Table I/O buffer
C      WRKTIM   R(*) Work array
C      WORK2    R(*) Work array
C      WORK3    R(*) Work array
C   Output:
C      IRET     I  Error code, 0=OK else failed.
C-----------------------------------------------------------------------
      INTEGER   ISUB, REFA, ANT, NUMIF, TIMKOL, SUBKOL, ANTKOL, SOUKOL,
     *   FRQKOL, RF1KOL, RA1KOL, WT1KOL, RF2KOL, RA2KOL, WT2KOL,
     *   BUFFER(*), MXTIME, IRET
      REAL      WRKTIM(MXTIME), WORK2(MXTIME), WORK3(MXTIME)
C
      INTEGER    LOOPR, IRCODE, NUMTIM, IPNT1, IPNT2, REFA1, REFA2, I,
     *   NUMREC, SUB, SA
      LOGICAL   NEED2, WANT
      REAL    WT1, WT2, SUM, COUNT, RATE, RATE1, RATE2, SMOTIM
      INCLUDE 'INCS:PUVD.INC'
      DOUBLE PRECISION TIMOFF, TIME, TIME1, TIME2
      INTEGER   RECORD(1024)
      REAL      RECR(1024)
      DOUBLE PRECISION RECD(512)
      EQUIVALENCE (RECORD, RECR, RECD)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA IRCODE /0/
C-----------------------------------------------------------------------
C                                       Initially require both
C                                       polarizations if present
      NEED2 = RA2KOL.GT.0
      SUB = MAX (1, ISUB)
C                                       Loop thru table referring ANT
C                                       to REFA.
      NUMREC = BUFFER(5)
 10   NUMTIM = 0
      DO 100 LOOPR = 1,NUMREC
         CALL TABIO ('READ', IRCODE, LOOPR, RECORD, BUFFER, IRET)
         IF (IRET.LT.0) GO TO 100
         IF (IRET.NE.0) GO TO 900
         IF ((RECORD(ANTKOL).NE.ANT) .AND. (RECORD(ANTKOL).NE.REFA))
     *      GO TO 100
C                                       Right subarray?
         SA = RECORD(SUBKOL)
         IF ((SA.NE.SUB) .AND. (SA.GT.0)) GO TO 100
C                                        Find and check reference
C                                        antennas.  Must all be the
C                                        same.
         REFA1 = -1
         REFA2 = -1
C                                        Also accumulate rate.
         SUM = 0.0
         COUNT = 0.0
         DO 20 I = 1,NUMIF
            IF ((RECR(WT1KOL+I-1).GT.0.0) .AND.
     *         (RECR(RA1KOL+I-1).NE.FBLANK) .AND.
     *         (RECORD(RF1KOL+I-1).GT.0)) THEN
               IF (REFA1.LE.0) REFA1 = RECORD(RF1KOL+I-1)
               IF (REFA1.NE.RECORD(RF1KOL+I-1)) GO TO 100
               SUM = SUM + RECR(RA1KOL+I-1)
               COUNT = COUNT + 1
               END IF
            IF ((RA2KOL.GT.0) .AND. (RECR(WT2KOL+I-1).GT.0.0) .AND.
     *         (RECR(RA2KOL+I-1).NE.FBLANK) .AND.
     *         (RECORD(RF2KOL+I-1).GT.0)) THEN
               IF (REFA2.LE.0) REFA2 = RECORD(RF2KOL+I-1)
               IF (REFA2.NE.RECORD(RF2KOL+I-1)) GO TO 100
               SUM = SUM + RECR(RA2KOL+I-1)
               COUNT = COUNT + 1
               END IF
 20            CONTINUE
C                                       Desired antenna combination?
         IF (NEED2 .AND. (REFA1.GT.0) .AND. (REFA2.GT.0) .AND.
     *      (REFA1.NE.REFA2)) GO TO 100
         IF (REFA1.LT.0) REFA1 = REFA2
         IF ((REFA1.NE.ANT) .AND. (REFA1.NE.REFA))
     *      GO TO 100
         IF (RECORD(ANTKOL).EQ.REFA1) GO TO 100
         IF (NUMTIM.GE.MXTIME) GO TO 100
            RATE = 0.0
            IF (COUNT.GT.0) RATE = SUM / COUNT
            NUMTIM = NUMTIM + 1
            IF (NUMTIM.EQ.1) TIMOFF = RECD(TIMKOL)
            WRKTIM(NUMTIM) = RECD(TIMKOL) - TIMOFF
            IF (REFA1.NE.ANT) THEN
C                                       REFA is reference ant
               WORK3(NUMTIM) = RATE
            ELSE
C                                       ANT is reference ant
               WORK3(NUMTIM) = -RATE
               END IF
            IF (COUNT.EQ.0) WORK3(NUMTIM) = FBLANK
 100     CONTINUE
      IRET = 0
      IF (NEED2 .AND. (NUMTIM.LE.0)) THEN
C                                       Try again with only one poln.
         NEED2 = .FALSE.
         GO TO 10
         END IF
C                                       Find any?
      IF (NUMTIM.LE.0) GO TO 999
C                                       Smooth (2 sec to extrapolate)
      SMOTIM = 2.0 / 86400.0
      CALL BOXSMO (SMOTIM, WRKTIM, WORK3, NUMTIM, WORK2)
C                                       Set up for interpolation
      IPNT1 = 1
      IPNT2 = 2
      TIME1 = WRKTIM(1)
      TIME2 = WRKTIM(2)
      IF (NUMTIM.EQ.1) THEN
         IPNT2 = 1
         TIME2 = TIME1
         END IF
C                                       Loop thru table changing any
C                                       data with ref=ANT to ref=REFA
      DO 200 LOOPR = 1,NUMREC
         CALL TABIO ('READ', IRCODE, LOOPR, RECORD, BUFFER, IRET)
         IF (IRET.LT.0) GO TO 200
         IF (IRET.NE.0) GO TO 900
C                                       Right subarray?
         SA = RECORD(SUBKOL)
         IF ((SA.NE.SUB) .AND. (SA.GT.0)) GO TO 200
         WANT = .FALSE.
         DO 130 I = 1,NUMIF
            WANT = WANT .OR. ((RECORD(RF1KOL).EQ.ANT)
     *         .OR. ((RF2KOL.GT.0) .AND. (RECORD(RF2KOL).NE.ANT)))
 130        CONTINUE
         IF (.NOT.WANT) GO TO 200
C                                       Interpolate
         TIME = RECD(TIMKOL) - TIMOFF
 140           IF ((TIME.GE.TIME1) .AND. (TIME.LE.TIME2)) THEN
C                                       Between entries
                  IF (TIME2.NE.TIME1) THEN
                     WT1 = 1.0 - ((TIME-TIME1) / (TIME2-TIME1))
                  ELSE
                     WT1 = 1.0
                     END IF
               ELSE IF (TIME.LT.TIME1) THEN
C                                       Before first time
                  WT1 = 1.0
               ELSE IF (IPNT2.GE.NUMTIM) THEN
C                                       After last time
                  WT1 = 0.0
               ELSE
C                                       Shift in interpolation arrays
                  IPNT1 = IPNT1 + 1
                  TIME1 = WRKTIM(IPNT1)
                  IPNT2 = IPNT2 + 1
                  TIME2 = WRKTIM(IPNT2)
                  GO TO 140
                  END IF
C                                       Interpolate
                  WT2 = 1.0 - WT1
                  RATE1 = WORK2(IPNT1)
                  RATE2 = WORK2(IPNT2)
                  RATE = WT1*RATE1 + WT2*RATE2
                  DO 120 I = 1,NUMIF
                     IF ((RECR(WT1KOL+I-1).GT.0.0) .AND.
     *                  (RECR(RA1KOL+I-1).NE.FBLANK) .AND.
     *                  (RECORD(RF1KOL+I-1).EQ.ANT)) THEN
                        RECR(RA1KOL+I-1) = RECR(RA1KOL+I-1) + RATE
                        END IF
                     IF ((RA2KOL.GT.0) .AND. (RECR(WT2KOL+I-1).GT.0.0)
     *                  .AND.  (RECR(RA2KOL+I-1).NE.FBLANK) .AND.
     *                  (RECORD(RF2KOL+I-1).EQ.ANT)) THEN
                        RECR(RA2KOL+I-1) = RECR(RA2KOL+I-1) + RATE
                        END IF
 120                 CONTINUE
C                                       Rewrite record
            CALL TABIO ('WRIT', IRCODE, LOOPR, RECORD, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 900
 200     CONTINUE
      IRET = 0
      GO TO 999
C                                       TABIO error
 900  WRITE (MSGTXT,1900) IRET, ANT, REFA
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('REFRAT: TABIO ERROR',I3,' REREFERENCING ANT ',I3,' TO ',
     *   I3)
      END

       SUBROUTINE ZULIM (NFILES)
C-----------------------------------------------------------------------
C! change system limit to allow more open files
C# Z Z2 System
C-----------------------------------------------------------------------
C;  Copyright (C) 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Call the OS to allow the process to open at least NFILES files at
C   the same time.  Errors are ignored in the hope that the process will
C   not reach the limit that we were unable to change.
C   Inputs:
C      NFILES   I   Maximum number of open files this process will need
C   Stubbed version
C-----------------------------------------------------------------------
      INTEGER   NFILES
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      MSGTXT = 'ZULIM: REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (6)
C
 999  RETURN
      END

      SUBROUTINE INIT
C-----------------------------------------------------------------------
C! initializes symbol, procedure text tables, and commons for POPS
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998-1999, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   INIT initializes the K, LISTF, and commons for POPS.
C   The K array and LISTF are loaded from file ME1000nn (nn = NPOPS-1)
C   User commons are initialized by UINIT which is called by INIT.
C   LISTF is now kept in common rather than in a scratch area on disk.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6, PHNAME*48
      INTEGER   FIND, IERR, MEMLUN, POTERR, NREC, IBEG, IEND, III, I
      LOGICAL   EXCL, NOMAP, WAIT
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DSMS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DIO.INC'
      DATA NOMAP, EXCL, WAIT /2*.FALSE., .TRUE./
      DATA PRGNAM /'INIT '/
      DATA MEMLUN /14/
C-----------------------------------------------------------------------
      CALL RFILL (5, HBLANK, KPAK)
      IUNIT = 1
      IF (NPOPS.GT.NINTRN) IUNIT = 3
      IF (TSKNAM(1:5).EQ.'AIPSC') IUNIT = 3
      KARLIM = NCHLIN
C                                       COMMON variables
      SLIM = 1000
      NEXTP = 0
      LPGM = 2
      KT = 51
      LPAGE = LBLOCK
      MPAGE = KBLOCK + LPAGE
      STORE2 = 0
C                                       Error indicators
      ERRLEV = 0
      ERRNUM = 0
C
      IDEBUG = -1
      CALL FILL (SLIM, 0, STACK)
      CALL FILL (SLIM, 0, CSTACK)
      CALL FILL (5, 0, IERROR)
      DO 5 NREC = 1,5
         PNAME(NREC) = ' '
 5       CONTINUE
C                                       Open pops memory file.
      CALL ZPHFIL ('ME', 1, 0, 0, PHNAME, IERROR)
      CALL ZOPEN (MEMLUN, FIND, 1, PHNAME, NOMAP, EXCL, WAIT, IERROR)
      POTERR = 61
      IF (IERROR(1).NE.0) GO TO 980
C                                       Read basic copy of K array
      IBEG = 1
      IEND = MPAGE - LPAGE
      III = 1
      DO 10 NREC = IBEG,IEND
         CALL ZFIO ('READ', MEMLUN, FIND, NREC, K(III), IERROR(2))
         IF (IERROR(2).NE.0) GO TO 970
         III = III + 256
 10      CONTINUE
C                                       Read basic LISTF array
      NREC = IEND + 1
      III = 1
      DO 30 I = 1,LPAGE
         CALL ZFIO ('READ', MEMLUN, FIND, NREC, LISTF(III), IERROR(2))
         IF (IERROR(2).NE.0) GO TO 970
         III = III + 256
         NREC = NREC + 1
 30      CONTINUE
C                                       Close file.
      CALL ZCLOSE (MEMLUN, FIND, IERR)
      POTERR = 49
      IF (IERR.NE.0) GO TO 980
C                                       Initialize.
C                                       One
      L = K(4)
      CALL HUNT (K, L, 1, 2, 1.0)
      TAG = L + 2
      ONE = TAG
C                                       Zero
      L = K(4)
      CALL HUNT (K, L, 1, 2, 0.0)
      TAG = L + 2
      ZERO = TAG
C                                       True
      L = K(1)
      CALL CHR2H (4, 'TRUE', 1, KPAK)
      CALL CHUNT (K, L, 4, 4, KPAK)
      TAG = K(L+2)
      TRUE = TAG
C                                       False
      L = K(1)
      CALL CHR2H (5, 'FALSE', 1, KPAK)
      CALL CHUNT (K, L, 5, 4, KPAK)
      TAG = K(L+2)
      FALSE = TAG
C                                       user commons
      CALL UINIT
      MODE = 0
      IPT = '>'
      IF (ERRNUM.NE.0) GO TO 980
      GO TO 999
C                                       Error handler.
 970  CALL ZCLOSE (MEMLUN, FIND, IERR)
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
      END

      SUBROUTINE CITC2R (S, N, I, XVALUE)
C-----------------------------------------------------------------------
C! KEYIN routine: parses a floating value from a character string
C# Parsing
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   CITC2R decodes a floating point value from character string S
C   starting at location I.  On return I is updated to position after
C   value.
C   Interpretes an imbedded colon (:) as "divide what follows by 60"
C   Inputs:
C     S(N)    C    Character string with value encoded
C     N       I    Length of S
C     I       I    Pointer in S to beginning of value.
C   Outputs:
C     I       I    Pointer in S to first character after value.
C     XVALUE  D    Floating value encoded in string.
C   T.J.PEARSON  1978 MAY 11
C   MODIFIED 1979 FEB 6  VAX/VMS FORTRAN 4
C   Modified 1985 June for AIPS and renamed
C-----------------------------------------------------------------------
      CHARACTER S*(*), COLON*1, PLUS*1, MINUS*1, POINT*1, CHEXP*4
      DOUBLE PRECISION XVALUE, YVALUE, FRACTN, FACT
      INTEGER   IVALUE, SIGN, N, I, ISTART, J
      LOGICAL   ISEXP
      DATA COLON, PLUS, MINUS, POINT,  CHEXP
     *   /  ':',  '+',   '-',   '.',  'EeDd'/
C-----------------------------------------------------------------------
      XVALUE = 0.0D0
      FACT = 1.0D0
      IF (I.GT.N) GO TO 999
      SIGN = +1
      IF (S(I:I).EQ.MINUS) THEN
C                                       Negative
         I = I + 1
         SIGN = -1
         CALL CITSKP (S, N, I)
      ELSE IF (S(I:I).EQ.PLUS) THEN
C                                       Leading "+"
         I = I + 1
         CALL CITSKP (S, N, I)
         END IF
      ISTART = I
 150  CALL CITC2D (S, N, I, YVALUE)
      XVALUE = XVALUE + FACT * YVALUE * SIGN
      IF (I.GT.N) GO TO 999
      IF (S(I:I).EQ.COLON) THEN
C                                       Colon
         I = I + 1
         FACT = FACT / 60.0D0
         GO TO 150
         END IF
C                                       Look for fractional part, if any
      IF (S(I:I).EQ.POINT) THEN
         J = I + 1
         CALL CITC2D (S, N, J, YVALUE)
         FRACTN = FACT * YVALUE * SIGN
         XVALUE = XVALUE + FRACTN * 10.D0**(I-J+1)
         I = J
         IF (I.GT.N) GO TO 999
         END IF
C                                       Look for exponent, if any;
C                                       an exponent may not stand alone
      ISEXP = INDEX (CHEXP, S(I:I)) .GT. 0
      IF (ISEXP .AND. (I.NE.ISTART)) THEN
         I = I + 1
         IF (I.GT.N) GO TO 999
         SIGN = +1
         IF (S(I:I).EQ.MINUS) THEN
            I = I+1
            SIGN = -1
         ELSE IF (S(I:I).EQ.PLUS) THEN
            I = I + 1
            END IF
         CALL CITC2I (S, N, I, IVALUE)
         XVALUE = XVALUE * (10.0D0 ** (SIGN * IVALUE))
         END IF
C
 999  RETURN
      END

      SUBROUTINE TABKEY (OPCODE, KEYWRD, NUMKEY, BUFFER, LOCS, VALUES,
     *   KEYTYP, IERR)
C-----------------------------------------------------------------------
C! reads/writes the Keyword section of an AIPS table file
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998-2000, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Reads or writes KEYWORDs from or to an AIPS table file header.  The
C   order of the keywords is arbitrary. Table file must have been
C   previously opened with TABINI.
C   Inputs:
C      OPCODE   C*4        Operation desired, 'READ', 'WRIT',
C                             'ALL ' => Read all.
C      KEYWRD   C(*)*8     Keywords to read/write
C      BUFFER   I(*)       Buffer being use for table I/O >= 512 words.
C   In/out:
C      NUMKEY   I          Number of keywords to read/write.
C                             Input on OPCODE='ALL' = max. to read.
C                             Output on OPCODE='ALL' = no. read.
C      LOCS     I(NUMKEY)  The word offset of first short integer
C                          word of keyword value in array VALUES.
C                          Output on READ, input on WRIT.
C                          On READ this value will be -1 for keywords
C                          not found.
C      VALUES   I          The array of keyword values; due to word
C                          alignment problems on some machines values
C                          longer than an integer should be copied,
C                          eg. if the  5th keyword (XXX) is a D:
C                               IPOINT = LOCS(5)
C                               CALL COPY (NWDPDP, VALUES(IPOINT), XXX)
C                          Output on READ, input on WRIT
C     KEYTYP    I(NUMKEY)  The type code of the keywords:
C                             1 = Double precision floating
C                             2 = Single precision floating (deprecated)
C                             3 = Character string (8 HOLLERITH chars)
C                             4 = integer
C                             5 = Logical
C                             6 = integer
C   Output:
C      IERR     I          Return code, 0=>OK,
C                             1-10 =>TABIO error
C                             19   => unrecognized data type.
C                             20   => bad OPCODE
C                             20+n => n keywords not found on READ.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, KEYWRD(*)*8
      INTEGER   NUMKEY, BUFFER(*), LOCS(*), KEYTYP(*), IERR
      REAL      VALUES(*)
C
      INTEGER   J, NHKEY, RECORD(10), IPOINT, NWORD, JSAV, K,
     *   CHWORD(5), COUNT, MAXKEY, HEDKEY, I, RECNO, RECOFF
      CHARACTER OP*4, CTEST*8
      LOGICAL   DOREAD, REDALL, FRSTWR
      REAL      RECR(10)
      HOLLERITH RECH(10)
      DOUBLE PRECISION KEYVAD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (RECORD, RECH, RECR)
C-----------------------------------------------------------------------
      IERR = 0
      MAXKEY = NUMKEY
C                                       Initialize data type lengths
      CHWORD(1) = NWDPDP
      CHWORD(2) = 1
      CHWORD(3) = 2
      CHWORD(4) = 1
      CHWORD(5) = 1
C                                       Check OPCODE
      OP = 'WRIT'
      REDALL = OPCODE.EQ.'ALL'
      IF ((REDALL) .AND. (NUMKEY.LE.0)) IERR = 20
      IF (NUMKEY.LE.0) GO TO 999
      DOREAD = (OPCODE.EQ.'READ') .OR. (REDALL)
      IF (DOREAD) OP = 'READ'
C                                       Unknown opcode
      IF ((OPCODE.NE.'WRIT') .AND. (.NOT.DOREAD)) THEN
         IERR = 20
         WRITE (MSGTXT,1000) OPCODE
         GO TO 990
         END IF
C                                       Fill LOCS with -1 on READ
      IF (DOREAD) CALL FILL (NUMKEY, -1, LOCS)
C                                       On READ loop through header
C                                       keywords.
      NHKEY = BUFFER(53)
      HEDKEY = NHKEY
C                                       See if first write
      FRSTWR = (.NOT.DOREAD) .AND. (NHKEY.LE.0)
      JSAV = 0
C                                       Initialize output pointer.
      IPOINT = 1
C                                       On WRITe loop thru input
C                                       keywords.
      IF (.NOT.DOREAD) NHKEY = NUMKEY
      RECOFF = 0
      IF (.NOT.DOREAD) RECOFF = BUFFER(53)
      DO 200 I = 1,NHKEY
C                                       WRITing
         RECNO = I
         IF (DOREAD) GO TO 100
            J = KEYTYP(I)
            NWORD = CHWORD(J)
C                                       Unknown data type
            IF ((J.LE.0) .OR. (J.GT.5)) THEN
               WRITE (MSGTXT,1011) J
               IERR = 19
               GO TO 990
               END IF
C                                       Ok type
            IF (.NOT.FRSTWR) THEN
C                                       Search existing keywords
               IF (HEDKEY.GT.0) THEN
                  DO 50 K = 1,HEDKEY
                     RECNO = K
                     CALL TABIO ('READ', 5, RECNO, RECORD, BUFFER, IERR)
                     IF (IERR.GT.0) THEN
                        WRITE (MSGTXT,1010) IERR, 'READ'
                        GO TO 990
                        END IF
C                                       Compare
                     CALL H2CHR (8, 1, RECH, CTEST)
                     IF (CTEST.EQ.KEYWRD(I)) GO TO 70
 50                  CONTINUE
                  END IF
C                                       Add new keyword
               RECNO = RECNO + 1
               HEDKEY = RECNO
               END IF
C                                       Load RECORD
 70         IPOINT = LOCS(I)
            CALL CHR2H (8, KEYWRD(I), 1, RECH)
            RECORD(4) = 0
C                                       force R*4 to R*8
            IF (J.NE.2) THEN
               CALL COPY (NWORD, VALUES(IPOINT), RECR(3))
            ELSE
               KEYVAD = VALUES(IPOINT)
               CALL RCOPY (NWDPDP, KEYVAD, RECR(3))
               J = 1
               END IF
            RECORD(5) = J
C                                       Do table I/O
 100     CALL TABIO (OP, 5, RECNO, RECORD, BUFFER, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR, OP
            GO TO 990
            END IF
C                                       Check if read
         IF (DOREAD) THEN
C                                       Reading
            JSAV = JSAV + 1
            CALL H2CHR (8, 1, RECH, CTEST)
            IF (.NOT.REDALL) THEN
C                                       Loop through input keywords
               DO 160 J = 1,NUMKEY
                  JSAV = J
                  IF (KEYWRD(J).EQ.CTEST) GO TO 170
 160              CONTINUE
C                                       Don't want this KEYWORD
               GO TO 200
               END IF
C                                       Found match.
C                                       Find data type.
 170        J = RECORD(5)
            NWORD = CHWORD(J)
C                                       Unknown data type
            IF ((J.LE.0) .OR. (J.GT.5)) THEN
               WRITE (MSGTXT,1011) J
               IERR = 19
               GO TO 990
               END IF
C                                       Ok type, check max no. keywords
C                                       Missing keywords
            IF (JSAV.GT.MAXKEY) THEN
               WRITE (MSGTXT,1180) CTEST, MAXKEY
               CALL MSGWRT (6)
               GO TO 200
               END IF
            CALL COPY (NWORD, RECR(3), VALUES(IPOINT))
            LOCS(JSAV) = IPOINT
C                                       force double precision
            IF (J.EQ.2) THEN
               KEYVAD = VALUES(IPOINT)
               CALL RCOPY (NWDPDP, KEYVAD, VALUES(IPOINT))
               J = 1
               END IF
            KEYTYP(JSAV) = J
            IF (REDALL) KEYWRD(JSAV) = CTEST
C                                       Set pointer for next value
            IPOINT = IPOINT + CHWORD(J)
            END IF
 200     CONTINUE
      IF (REDALL) NUMKEY = NHKEY
C                                       Done if WRITing or REDALL
      IF ((.NOT.DOREAD) .OR. (REDALL)) GO TO 999
C                                       Make sure all found
      COUNT = 0
      DO 300 I = 1,NUMKEY
C                                       Not found
         IF (LOCS(I).LE.0) THEN
            COUNT = COUNT + 1
            WRITE (MSGTXT,1200) KEYWRD(I)
            CALL MSGWRT (6)
            END IF
 300     CONTINUE
      IERR = 0
      IF (COUNT.GT.0) IERR = 20 + COUNT
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
      WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TABKEY: UNKNOWN OPCODE = ',A4)
 1010 FORMAT ('TABKEY: ERROR',I4,1X,A4,'ING TABLE FILE KEYWORDS')
 1011 FORMAT ('TABKEY: UNKNOWN KEYWORD DATA TYPE, CODE = ',I3)
 1180 FORMAT ('TABKEY: KEYWORD ',A8,' IN EXCESS OF LIMIT',I4)
 1200 FORMAT ('TABKEY: TABLE KEYWORD ',A8,' NOT FOUND')
 1990 FORMAT ('TABKEY: ERROR OCCURRED DURING TABLE KEYWORD ACCESS,',
     *   ' OPCODE=',A4)
      END

LOCAL INCLUDE 'FIT2A.INC'
C                                       Local include for FIT2A
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   IBLNK
      INTEGER   CATOLD(256)
      INTEGER   CATBLK(256), FDVEC(50), TBIND, NBPIX,
     *   TAPEBP, TABLES, INBUFF(MABFSS), TAPBUF(29184)
      LOGICAL   ISBLNK, FUCKUP, STDEXT
      REAL      CATR(256)
      HOLLERITH CATH(256)
      CHARACTER HDRBUF*2880
      DOUBLE PRECISION CATD(128), POS11(2), SCALE, OFFSET, ISCALE,
     *   IZERO
      COMMON /MLTAP/ SCALE, OFFSET, ISCALE, IZERO, POS11, TAPBUF,
     *   INBUFF, IBLNK, ISBLNK, FUCKUP, STDEXT,
     *   FDVEC, TBIND, NBPIX, TAPEBP, TABLES
      COMMON /MAPHDR/ CATBLK
      COMMON /MYCAT/ CATOLD
      COMMON /CHRCOM/ HDRBUF
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
C                                                          End FIT2A
LOCAL END
C
LOCAL INCLUDE 'CONFI.INC'
C                                                          Include CONFI
C                                       Local include for CONFI
      INTEGER MXPLT
      PARAMETER (MXPLT = 400)
C                                       array size for mask
      INTEGER MXMASK
      PARAMETER (MXMASK = 2000*2000)
C                                       array size for plot
      INTEGER MXNAR
      PARAMETER (MXNAR = 1000)
      INTEGER MXARPL
      PARAMETER (MXARPL = 100*100 + 400)
      INTEGER SEQIN, DISKIN, CNOIN
      INTEGER TVCHN, PLTBLK(256), GRCHN, TVCORN(4), LUNPR, PFIND,
     *   IGLUN, IGFIND, SLOT, NARRAY, NPARM, NITER, NBAD, NUMLEV
      LOGICAL DOTV, FA, DOCONF, DOPB, DOFITS
      REAL      XSIN, XDISIN, XNCOUN, XDOTV, APARM(10), BPARM(10),
     *   CPARM(10), LATIT, LONGT, ALT, ANTDIM, ANTEF, ANTSYS,
     *   CHOUT(4), FUNCMX, FUNCMN, ARGMX, ARGMN, XYSCL(2), GAIN,
     *   XYOFF(2), GMXX, GMNX, GXYSCL(2,MXPLT), GXYOFF(2,MXPLT),
     *   XCELL(2), XPARM(10), DPARM(10), XX(MXARPL),
     *   YY(MXARPL), XBAD(MXMASK), YBAD(MXMASK), XBLCC, YBLCC,
     *   XTRCC, YTRCC, XMAX, YMAX, XMIN, YMIN
      CHARACTER INFILE*48, I2FILE*48, OFILE*48, NAMEIN*12, CLAIN*6
      HOLLERITH XNAMEI(3), XCLAIN(2), XIFILE(12), X2FILE(12),
     *   XOFILE(12)
C                                       Buffers and file info
      INTEGER   BUFFER(1024)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XIFILE, X2FILE,
     *   XCELL, XPARM, XOFILE, XNCOUN, XDOTV, APARM, BPARM,
     *   CPARM, DPARM
      COMMON /CHAR/ INFILE, I2FILE, OFILE, NAMEIN, CLAIN
      COMMON /INTREA/ SEQIN, DISKIN, CNOIN, BUFFER, NARRAY,
     *   GMXX, GMNX, GXYSCL, GXYOFF, XYSCL, XYOFF, FUNCMX, FUNCMN,
     *   ARGMX, ARGMN, NPARM, GAIN, NITER, XX, YY, NBAD, XBAD,
     *   YBAD, XBLCC, YBLCC, XTRCC, YTRCC, LATIT, LONGT, ALT,
     *   ANTDIM, ANTEF, ANTSYS, NUMLEV, XMAX, YMAX, XMIN, YMIN,
     *   DOFITS
      COMMON /PLOT/ PLTBLK, CHOUT, DOTV, TVCHN, GRCHN, TVCORN,
     *   IGLUN, IGFIND, SLOT, LUNPR, PFIND, FA, DOCONF, DOPB
LOCAL END
      PROGRAM CONFI
C-----------------------------------------------------------------------
C! Optimize array's configuration minimizing sidelobes
C# UV Calibration EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1998, 2000-2005, 2007, 2010, 2012, 2015, 2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Optimize array's configuration minimizing sidelobes.
C   Inputs:
C     INNAME.....Input UV file name (name).      Standard defaults.
C     INCLASS....Input UV file name (class).     Standard defaults.
C     INSEQ......Input UV file name (seq. #).    0 => highest.
C     INDISK.....Disk drive # of input UV file.  0 => any.
C     INFILE.....The name of a file where the initial configuration
C                is stored
C     IN2FILE....The name of a file where the restricted positions
C                are stored
C     OFILE......The name of a file where the final configuration is
C                recorded
C     NCOUNT.....Number of plots at the page.
C     DOTV.......> 0 Do plot on the TV, else make a plot file
C     APARM......Parameters
C     BPARM......More parameters
C     DPARM......More parameters
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'CONFI.INC'
      DATA PRGM /'CONFI'/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL OPTI (PRGM, IRET)
      CALL DIE (IRET, BUFFER)
      STOP
      END
      SUBROUTINE OPTI (PRGN, JERR)
C-----------------------------------------------------------------------
C   OPTI gets input parameters for CONFI.
C   Inputs:  PRGN    C*6       Program name
C   Output:  JERR    I         Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER MPOINT
      PARAMETER (MPOINT = 1000)
      INTEGER MXPOIN
      PARAMETER (MXPOIN = MPOINT*MPOINT)
      INCLUDE 'CONFI.INC'
      INTEGER IARRAY, KARRAY, NPLTOT, JERR, IERR, IROUND, IRET, JT,
     *   NLINE, ITER, NPLOTC, IPLTC, I, NCOUNT, NCOUNC, IPLOTC, NCH,
     *   JTRIM, K, IUV, NUV, NUVC, NPLOTS, KXTETA, IPLT, IPLOT, NUVTOT,
     *   NXTETA, NYTETA, NTOTX, NTOTY, IXTETA, IYTETA, IXY,
     *   MITER, KBAD,
     *   NBADMN, RADIUS, RADMAX, NINNER, NOUTER, NINTER, NTOT, NCEN,
     *   NROW, NXX, NINEST,  NX, NY, NROT, ADD1, NFIX, NXMIN, RADMIN
      REAL  REU, IMU, BEAZEN(MXPOIN), DPP, ANUMER,
     *   ELEV, EL, RDIRR(MPOINT), BEAM(MPOINT), X(MXNAR), Y(MXNAR),
     *   DX(MXNAR), DY(MXNAR), TOLER, TMAX, TMIN, TDIF, SIZEX, SIZEY,
     *   STEPAN, ANGLE, RMAX, XT, YT, RTEM, CELLX, CELLY, ARSIZE, XTEM,
     *   YTEM, XMASK(MXNAR), YMASK(MXNAR), XBEST(MXNAR), YBEST(MXNAR),
     *   XTEM1, YTEM1, XT1, YT1, DLIMIT, NEWDIS, XTETA, YTETA, ARG,
     *   SECZEN, WZENX, WZENY, DPPX, DPPY, DTETA,
     *   SCALE, MINZEN, MZENX, MZENY, XFOBAD(100), YFOBAD(100), RINNER,
     *   ROUTER, RT, SINNER, SOUTER, S1, S2, S3, RINTER, RINEST, RSUM,
     *   XSHIFT, YSHIFT, ROT, DROT, XSHFOU, YSHFOU, ROTFOU, HALFSE,
     *   SECTOR, RSHIFT, RTIN, RMIN, RMINAR, X0, DELTAX, DELTAY, XXX,
     *   YYY, BESS1, BESSJ1, ARGPB, PB, MAXVAL, DIST, ALPHA,
     *   SMINOR, SMAJOR, XELIPS, YELIPS, RELIPS, EPS
      INTEGER CONV1, CONV2, ZT, IMIN, KMIN, IND
      INTEGER INCOOR
      CHARACTER PRGN*6, LINE*80, STAT*4, UTYPE*2
      LOGICAL T, F, WREAD, BAD, TOPOGR,
     *   DONUTS, TWOCIR, TRECIR, DOSECT, OUSIDE, ELLIPS
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA EPS  /0.001/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T, BUFFER)
      CALL VHDRIN
      JERR = 0
C      NPARM = 77
C      NPARM = 91
C      NPARM = 101
      NPARM = 97
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 10
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
C                                       Restart AIPS
 10   IF (RQUICK) CALL RELPOP (JERR, BUFFER, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      DOTV = XDOTV.GT.0.0
C                                       declination in degrees
      ELEV = 90
C                                       total number of plots
      NPLTOT = BPARM(2)
      IF (NPLTOT.EQ.0) NPLTOT = 20
C                                       elevation
      EL = ELEV
      ELEV = ELEV * PI / 180.0
C                                       number of iteration
      NITER = APARM(1)
      IF (NITER.EQ.0) NITER = 1
      GRCHN = 1
C                                       number of plots at page
      NCOUNT = IROUND(XNCOUN)
      IF (NCOUNT.EQ.0) NCOUNT = 20
C                                       shift of the configuration
C                                       relatively BLC of the topography
      XSHIFT = BPARM(4)
      YSHIFT = BPARM(5)
C                                       rotation of the configuration
      ROT = BPARM(6) * DG2RAD
C                                       number of shift of configuration
C                                       in X and Y
      NX = BPARM(7)
      IF (NX.EQ.0) NX = 50
      NY = BPARM(8)
      IF (NY.EQ.0) NY = 50
C                                       step in rotation
      DROT = BPARM(10)
      IF (DROT.EQ.0.0) DROT = 5.0
C                                       number of rotation
      NROT = BPARM(9)
      IF (NROT.EQ.0) NROT = 360.0 / DROT
C                                       Parameters for the output file
C                                       in the UVCON format
      DOCONF = CPARM(1).LT.0.1
      LATIT = CPARM(2)
      LONGT = CPARM(3)
      ANTDIM = CPARM(4)
      IF (ANTDIM.LT.0.01) ANTDIM = 12
      ANTEF = CPARM(5)
      IF (ANTEF.LT.0.01) ANTEF = 0.5
      ANTSYS = CPARM(6)
      IF (ANTSYS.LT.0.01) ANTSYS = 50.0
      NUMLEV = CPARM(7) + 0.01
      IF (NUMLEV.EQ.0) NUMLEV = 2
C                                       Make the beam correction by the
C                                       primary beam?
      DOPB = CPARM(8).GT.0.5
C                                       altitude of the array center
C                                       above the geoid
      ALT = CPARM(9)
C                                       cize of cells at the topography
C                                       step in the shift
      CELLX = XCELL(1)
      IF (CELLX.LT.0.1) CELLX = 10
      CELLY = XCELL(2)
      IF (CELLY.LT.0.1) CELLY = 10
      XBLCC = XPARM(1)
      YBLCC = XPARM(2)
      XTRCC = XPARM(3)
      YTRCC = XPARM(4)
      IF (XTRCC.LT.0.1) XTRCC = 1.E8
      IF (YTRCC.LT.0.1) YTRCC = 1.E8
C                                       degree to (1/DIST) at the
C                                       dependence of the gain on the
C                                       distance
      ALPHA = XPARM(5)
      IF (ALPHA .EQ. 0) ALPHA = 1
C                                       dimension of the array in meters
      ARSIZE = APARM(7) * 1000
      IF (ARSIZE.EQ.0) ARSIZE = 1
C                                       warning about very wide field
C                                       of view
      MSGTXT = ' ----------------------------------------------'
      CALL MSGWRT (8)
      MSGTXT = '| The task uses the -SIN projection of the sky |'
      CALL MSGWRT (8)
      MSGTXT = '| So the value of one corresponds to  THETA=90 |'
      CALL MSGWRT (8)
      MSGTXT = '|   The following unequality should be valid   |'
      CALL MSGWRT (8)
      MSGTXT = '|        to exclude ABS(SIN(THETA)) > 1        |'
      CALL MSGWRT (8)
      MSGTXT = '|        APARM(4) * LAMBDA/APARM(7) <1         |'
      CALL MSGWRT (8)
      MSGTXT = '|   (LAMBDA and APARM(7) at the same units)    |'
      CALL MSGWRT (8)
      MSGTXT = ' ----------------------------------------------'
      CALL MSGWRT (8)
C


C                                       gain of the loop
      GAIN = APARM(2)
      IF (GAIN.EQ.0) GAIN = 0.001
C                                       number of fixed antennas
      NFIX = DPARM(2) + 0.1
C                                       constraint in topography
      TOPOGR = ((DPARM(3).EQ.1) .OR. (DPARM(3).EQ.4)) .OR.
     *   (DPARM(3).EQ.5)
C                                       constraint in DONUTS
      DONUTS = (DPARM(3).EQ.3) .OR. (DPARM(3).EQ.4)

C                                       constraint: inside of the
C                                       elliptic area
      ELLIPS = DPARM(3).EQ.6

C                                       constraint in two circles
      TWOCIR = (DPARM(3).EQ.2) .OR. (DPARM(3).EQ.5)
C                                       initial model three circles
      TRECIR = DPARM(1).EQ.3
C                                       If constrain are two circles
C                                       then initial configuration
C                                       should be two circles also
      IF (TWOCIR) DPARM(1) = 2
C                                       outer radius of DONUTS
      ROUTER = 0.5
C                                       inner radius of DONUTS
      RINNER = ABS(DPARM(8))
C                                       minor and major axis of the
C                                       outer ellipse
      IF (ELLIPS) THEN
         SMAJOR = 0.5
         SMINOR = DPARM(8)*SMAJOR
         END IF

C                                       shift the inner circle if
C                                       DPARM(8) is negative
      RSHIFT = 0
      IF (DPARM(8).LT.0) RSHIFT = ROUTER - RINNER
C                                       Minimum distance between
C                                       elements in meters.
      DLIMIT = DPARM(7)
C      IF (DLIMIT.EQ.0) DLIMIT = 12.5
C                                       number of additional elements
C                                       at the third cirle
      ADD1 = DPARM(10)
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (48, 1, XIFILE, INFILE)
      CALL H2CHR (48, 1, X2FILE, I2FILE)
      CALL H2CHR (48, 1, XOFILE, OFILE)
C                                       Is the I2FILE in FITS format?
      CALL FILFIT (I2FILE, DOFITS)
C                                       Find file, read CATBLK
      CNOIN = 1
      STAT = 'SRCH'
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 20
         WRITE (MSGTXT,1020) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
   20 CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'WRIT', BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 40
         WRITE (MSGTXT,1040) IERR
         GO TO 990
   40 NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       open input file if its name is
C                                       not blank
      WREAD = .FALSE.
      IF (INFILE(1:1).NE.' ') WREAD = .TRUE.
      IF (WREAD) THEN
C                                       initial configuration is in the
C                                       file
         LUNPR = 10
         FA = F
         CALL ZTXOPN ('READ', LUNPR, PFIND, INFILE, FA, IRET)
         NLINE = 1
C                                       read the file data
   50    CALL ZTXIO ('READ', LUNPR, PFIND, LINE, IRET)
         IF (IRET.EQ.2) GO TO 60
         JT = JTRIM (LINE)
         READ (LINE,1060) XT, YT
         IF (DPARM(4).EQ.0) THEN
            X(NLINE) = XT
            Y(NLINE) = YT
         ELSE
            IF (APARM(8).GT.0.001) THEN
C                                       original configuration is not
C                                       shifted
               X(NLINE) = XT / ARSIZE
               Y(NLINE) = YT / ARSIZE
            ELSE
C                                       original configuration had been
C                                       shifted
               X(NLINE) = (XT - XSHIFT) / ARSIZE
               Y(NLINE) = (YT - YSHIFT) / ARSIZE
               END IF
            END IF
C
         NLINE = NLINE + 1
         GO TO 50
   60    CONTINUE
         NARRAY = NLINE - 1
         CALL ZTXCLS (LUNPR, PFIND, IRET)
      ELSE
C                                       initial configuration is
C                                       calculated
         NARRAY = APARM(3) + 0.1
         IF (NARRAY.EQ.0) NARRAY = 64
C
         IF (TWOCIR .OR. (DPARM(1).EQ.2)) THEN
C                                       two circles.
C                                       take # elements on each of two
C                                       circle proportional to its R
            NINNER = IROUND(NARRAY * RINNER / (RINNER + ROUTER)) -
     *         ADD1
            NOUTER = NARRAY - NINNER
            SINNER = TWOPI / NINNER
            SOUTER = TWOPI / NOUTER
C
            I = 0
            IF (I2FILE(1:1).NE.' ') THEN
C                                       find positions in outer circle
C                                       with some of them fixed
               IF (DPARM(5).GT.0.1) THEN
                  JERR = 1
                  WRITE (MSGTXT, 1050)
                  CALL MSGWRT (8)
                  GO TO 999
                  END IF
               CALL OUTER (I2FILE, NOUTER, ARSIZE, DLIMIT, X, Y, I,
     *            NFIX, JERR)
               IF (JERR.LT.0) GO TO 990
            ELSE
               DO 70 IARRAY = 1, NOUTER
                  I = I + 1
                  ANGLE = SOUTER * (IARRAY - 1)
                  X(I) = ROUTER * COS(ANGLE)
                  Y(I) = ROUTER * SIN(ANGLE)
   70             CONTINUE
               END IF
C                                       inner circle
            DO 80 IARRAY = 1, NINNER
               I = I + 1
               ANGLE = SINNER * (IARRAY - 1)
C                                       shift the inner circle to the
C                                       left
               X(I) = RINNER * COS(ANGLE) - RSHIFT
               Y(I) = RINNER * SIN(ANGLE)
   80          CONTINUE
         ELSE

C                                       three circle
            IF (TRECIR) THEN
               ROUTER = 0.5
               RINTER = RINNER
               RINEST = DPARM(9)
               RSUM = ROUTER + RINTER + RINEST
C                                       take N elements on each of two
C                                       circle proportional to its R
C
               NOUTER = IROUND(NARRAY * ROUTER / RSUM) + ADD1
               NINTER = IROUND(NARRAY * RINTER / RSUM) - ADD1 - 1
               NINEST = NARRAY - NOUTER - NINTER - 1
               S1 = TWOPI / NOUTER
               S2 = TWOPI / NINTER
               S3 = TWOPI / NINEST
               I = 0
C                                       outer circle
               IF (I2FILE(1:1).NE.' ') THEN
C                                       find positions in outer circle
C                                       with some of them fixed
                  IF (DPARM(5).GT.0.1) THEN
                     JERR = 1
                     WRITE (MSGTXT, 1050)
                     CALL MSGWRT (8)
                     GO TO 999
                     END IF
                  CALL OUTER (I2FILE, NOUTER, ARSIZE, DLIMIT, X, Y, I,
     *               NFIX, JERR)
                  IF (JERR.LT.0) GO TO 990
               ELSE
                  DO 180 IARRAY = 1, NOUTER
                     I = I + 1
                     ANGLE = S1 * (IARRAY - 1)
                     X(I) = ROUTER * COS(ANGLE)
                     Y(I) = ROUTER * SIN(ANGLE)
  180                CONTINUE
                  END IF
C                                       intermediate circle
               DO 220 IARRAY = 1, NINTER
                  I = I + 1
                  ANGLE = S2 * (IARRAY - 1)
                  X(I) = RINTER * COS(ANGLE)
                  Y(I) = RINTER * SIN(ANGLE)
  220             CONTINUE
C                                       inner circle
               DO 230 IARRAY = 1, NINEST
                  I = I + 1
                  ANGLE = S3 * (IARRAY - 1) + PI/6
                  X(I) = RINEST * COS(ANGLE)
                  Y(I) = RINEST * SIN(ANGLE)
  230             CONTINUE
C                                       add the element at zero
               X(I + 1) = 0.0
               Y(I + 1) = 0.0
C                                       end three circle
            ELSE
C                                       hexagon tiling
               IF (DPARM(1).EQ.4) THEN
C                                       The number of antennas at the
C                                       array should be equal 7,19,37
C                                       61..= 3*NC^2 + 3*NC + 1
C                                       NC = 1,2,3...
                  DO 234 I = 1, 20
                     NTOT = 3*(I*I + I) + 1
                     IF (NTOT.EQ.NARRAY) THEN
                        NCEN = I
                        GO TO 235
                        END IF
  234                CONTINUE
                  JERR = 1
                  WRITE (MSGTXT, 1051) NARRAY
                  CALL MSGWRT (8)
                  WRITE (MSGTXT, 1052)
                  CALL MSGWRT (8)
                  GO TO 999
C
  235             CONTINUE
C                                       number of rows at the upper
C                                       part not counting the central
                  NROW = NCEN
                  DELTAX = 1.0 / (2.0*NCEN)
                  DELTAY = DELTAX * SQRT(3.0) / 2
                  NXX = 2*NCEN + 2
                  YYY = -DELTAY
                  X0 = -DELTAX * NCEN - DELTAX/2
                  IND = 0
                  DO 238 K = 1, NROW+1
                     NXX = NXX -1
                     X0 = X0 + DELTAX/2
                     YYY = YYY + DELTAY
                     XXX = X0 - DELTAX
                     DO 236 I = 1, NXX
                        XXX = XXX + DELTAX
                        IND = IND + 1
                        Y(IND) = XXX
                        X(IND) = YYY
                        IF (K.NE.1) THEN
                           IND = IND + 1
                           Y(IND) = XXX
                           X(IND) = -YYY
                           END IF
  236                   CONTINUE
  238                CONTINUE
C
               ELSE
C                                       one gomogenios circle
                  STEPAN = TWOPI / NARRAY
                  DO 240 IARRAY = 1, NARRAY
                     ANGLE = STEPAN * (IARRAY - 1)
                     X(IARRAY) = 0.5 * COS(ANGLE)
                     Y(IARRAY) = 0.5 * SIN(ANGLE)
  240                CONTINUE
                  END IF
               END IF
            END IF
         END IF
C                                       Start calculating the beam
      NXTETA = APARM(4)
      IF (NXTETA.EQ.0) NXTETA = 20
      NYTETA = NXTETA
C                                       NXTETA, NYTETA - number of main
C                                       beams in half field in X and Y
C                                       direction
C                                       DTETA step in the beam
      DTETA = APARM(5)
      IF (DTETA.EQ.0) DTETA = 0.2
      NXTETA = NXTETA / DTETA
      NYTETA = NYTETA / DTETA
C                                       RADMAX is square of the circle
C                                       radius fitted to the squre
C                                       Square, becase it will compare
C                                       with square
      RADMAX = MAX (NXTETA *NXTETA, NYTETA *NYTETA)
C                                       Minimum radius of the
C                                       optimization area at the sky
      NXMIN = APARM(9) / DTETA
C                                       1.2 correspond to the main lobe
C                                       edge
      IF (NXMIN .EQ. 0) NXMIN = 1.2 / DTETA
      RADMIN = NXMIN * NXMIN
C                                       Half sector of optimization
      SECTOR = ABS(APARM(10)) * DG2RAD / 2
      IF (SECTOR.LT.0.001) SECTOR = PI
C
      NTOTX = 2 * NXTETA  + 1
      NTOTY = 2 * NYTETA  + 1
      DTETA = DTETA

C                                       fit the configuration with the
C                                       topography data - mask file if
C                                       its name is not blank
      IF (DPARM(5).EQ.0) THEN
C                                       Do not provide topography fit
         XSHFOU = 0
         YSHFOU = 0
         ROTFOU = 0
      ELSE
C                                       fource NX, NY, NROT to 1
C                                       if fitting to topography is
C                                       together with optimization
         IF (DPARM(5) .EQ. 2) THEN
            NX =1
            NY = 1
            NROT = 1
            END IF
         IF (I2FILE(1:1).NE.' ') THEN
            CALL MASK (NX, NY, NROT, CELLX, CELLY, DROT,
     *         XSHIFT, YSHIFT, ROT, ARSIZE, X, Y, XMASK, YMASK ,
     *         XSHFOU, YSHFOU, ROTFOU, NBADMN, XFOBAD, YFOBAD,
     *         IRET)
            IF (IRET .NE. 0) THEN
               JERR = 1
               GO TO 999
               END IF
C                                       Go to record configuration in
C                                       meters and that is all
            IF (DPARM(5).EQ.1) GO TO 820
            END IF
         END IF
C
      ITER = 1
      MINZEN = 10.0
C                                       Cycle by iterations
  250 CONTINUE
C
      IF ((TWOCIR.OR.DONUTS.OR.ELLIPS) .OR. (I2FILE(1:1).NE.' ')
     *   .OR. (NFIX.GT.0) .OR. (NITER.EQ.1)) THEN
C      IF ((TWOCIR .OR. TRECIR) .OR. (I2FILE(1:1).NE.' ') .OR.
C     *   (NFIX.GT.0) .OR. (NITER.EQ.1)) THEN
C                                       Normalize in the topography
C                                       or not. This is the question
C      IF ((TWOCIR .OR. TRECIR) .OR. (NITER.EQ.1))  THEN
C                                       The elements are on the outer
C                                       cirlce of diameter 1. So  no
C                                       need of normalization.
         RMAX = 1
C                                       check the minimum spacing
         RMIN = 1.0E10
C                                       normalize UV coverage in all
C                                       other cases
         DO 260 I = 1, NARRAY
            DO 255 K = 1, NARRAY
               IUV = IUV + 1
               XT = X(K) - X(I)
               YT = Y(K) - Y(I)
               RTEM = (XT * XT + YT *YT)
               IF ((K.NE.I) .AND. (RTEM.LT.RMIN)) THEN
                  RMIN = RTEM
                  IMIN = I
                  KMIN = K
                  END IF
  255       CONTINUE
  260       CONTINUE
C
         RMIN = SQRT(RMIN)
         RMINAR = RMIN * ARSIZE
         IF ((DLIMIT-RMINAR).GT.EPS .AND. ARSIZE.GT.1.01) THEN
            WRITE (MSGTXT, 1055) IMIN, KMIN, RMINAR, DLIMIT
            JERR = 1
            GO TO 990
            END IF
      ELSE
         RMAX = 0
C                                       normalize UV coverage in all
C                                       other cases
         DO 280 I = 1, NARRAY
            DO 270 K = 1, NARRAY
               IUV = IUV + 1
               XT = X(K) - X(I)
               YT = Y(K) - Y(I)
               RTEM = (XT * XT + YT *YT)
               RMAX = MAX(RMAX, RTEM)
  270          CONTINUE
  280       CONTINUE
         RMAX = SQRT(RMAX)
         END IF
C                                       normalise by RMAX
      DO 320 IARRAY = 1, NARRAY
         X(IARRAY) = X(IARRAY) / RMAX
         Y(IARRAY) = Y(IARRAY) / RMAX
  320    CONTINUE
C                                       Lets calculate beam at zenith
      DO 360 IXTETA = 1, NXTETA  + 1
         XTETA = (IXTETA - NXTETA - 1) * DTETA
         DO 350 IYTETA = 1, NTOTY
            IXY = IYTETA + (IXTETA - 1) * NTOTY
            YTETA = (IYTETA - NYTETA - 1) * DTETA
            REU = 0.0
            IMU = 0.0
            DO 340 IARRAY = 1, NARRAY
               ARG = TWOPI*(X(IARRAY) * XTETA + Y(IARRAY) * YTETA)
               REU = REU + COS(ARG)
               IMU = IMU + SIN(ARG)
  340          CONTINUE
            BEAZEN(IXY) = (REU*REU + IMU*IMU) / NARRAY / NARRAY
C                                       multiply by the primary beam
C                                       take the dish of diameter 'd'
C                                       iluminated nomogeniously
            IF (DOPB) THEN
               ARGPB = PI*SQRT(XTETA*XTETA+YTETA*YTETA)*ANTDIM/ARSIZE
               IF (ARGPB.EQ.0) THEN
                  PB = 1
               ELSE
                  BESS1 = BESSJ1(ARGPB)
                  PB = (2*BESS1/ARGPB)**2
                  END IF
               BEAZEN(IXY) = BEAZEN(IXY) * PB
               END IF
  350       CONTINUE
  360    CONTINUE
      SECZEN = 0
C
C                                       find the beam maximum outside
C                                       the RADMIN.
C                                       RADMIN should exclude the main
C                                       lobe
      IF (RADMIN .LT. 0.1) THEN
         JERR = 1
         WRITE (MSGTXT,2410)
         CALL MSGWRT (8)
         WRITE (MSGTXT,2420)
         GO TO 990
         END IF
C
      DO 380 IXTETA = 1, NXTETA
         DO 370 IYTETA = 1, NTOTY
            HALFSE = ATAN(ABS(IYTETA - NYTETA - 1 + 0.001)
     *         / ABS(IXTETA - NXTETA - 1 + 0.001))
            DOSECT = HALFSE.LT.SECTOR
            RADIUS = (IXTETA - NXTETA - 1) * (IXTETA - NXTETA - 1) +
     *         (IYTETA - NYTETA - 1) * (IYTETA - NYTETA - 1)
            IXY = IYTETA + (IXTETA - 1) * NTOTY
            IF ((RADIUS.LT.RADMAX) .AND.
     *         (RADIUS.GT.RADMIN) .AND. DOSECT)  THEN
C                                       find the biggest maximum
C                                       outside RADMIN
               MAXVAL = BEAZEN(IXY)
C
               IF (MAXVAL .GT. SECZEN) THEN
                  SECZEN = MAXVAL
                  WZENX = (IXTETA - NXTETA - 1) * DTETA
                  WZENY = (IYTETA - NYTETA - 1) * DTETA
                  END IF
               END IF
  370       CONTINUE
  380     CONTINUE
C                                       Location of the worst sidelobe
C                                       for zenith is found
      WRITE (MSGTXT,2450) ITER, SECZEN, WZENX, WZENY
      CALL MSGWRT (8)
C                                       Find the gain depending on the
C                                       distance of the maximum of the
C                                       center
      IF (APARM(2) .LT. -0.00001) THEN
         DIST = SQRT (WZENX*WZENX + WZENY*WZENY)
         GAIN = ABS(APARM(2)) * ((1 / DIST) ** ALPHA)
         END IF

C                                       store the iteration with the
C                                       smallest worst sidelobe SECZEN
      IF (SECZEN.LT.MINZEN) THEN
         MINZEN = SECZEN
         MITER = ITER
         MZENX = WZENX
         MZENY = WZENY
         DO 480 IARRAY = 1, NARRAY
C                                       store the best solution
            XBEST(IARRAY) = X(IARRAY)
            YBEST(IARRAY) = Y(IARRAY)
  480       CONTINUE
         END IF
      IF (ITER.NE.1 .AND. ITER.NE.NITER) GO TO 520
      SIZEX = 1000.0
      SIZEY = 1000.0 / NCOUNT
      GMXX = -1.0E20
      GMNX = 1.0E20
      NPLOTS = MIN(NXTETA + 1, NPLTOT)
C
      DO 510 IXTETA = 1, NPLOTS
         KXTETA = NXTETA + 2 - IXTETA
         XTETA = (KXTETA - NXTETA - 1) * DTETA
C
C                                       Prepare parameters for PLTEL
         IPLT = IXTETA
         IPLOT = IPLT - 1
         IPLOT = MOD (IPLOT, NCOUNT) + 1
         IF (IPLT.EQ.NPLOTS) IPLOT = -IPLOT
C                                       find max/min of the Y
         FUNCMX = -1.0E10
         FUNCMN =  1.0E10
         ARGMX = -1.0E10
         ARGMN =  1.0E10
         DO 490 IYTETA = 1, NTOTY
            IXY = IYTETA + (KXTETA - 1) * NTOTY
            YTETA = (IYTETA - NYTETA - 1) * DTETA
            RDIRR(IYTETA) = YTETA
C                                       Take beam for zenith
C                                       to plot it
            BEAM(IYTETA) = BEAZEN(IXY)
            IF (BPARM(3).EQ.0) THEN
               FUNCMX = MAX(FUNCMX, BEAM(IYTETA))
               FUNCMN = MIN(FUNCMN, BEAM(IYTETA))
            ELSE
               FUNCMX = BPARM(3)
               FUNCMN = 0
               END IF
            ARGMX = MAX(ARGMX, YTETA)
            ARGMN = MIN(ARGMN, YTETA)
  490       CONTINUE
         TOLER = 0.01
C
C                                       TMAX, TMIN new MAX&MIN of Y
         TMAX = FUNCMX + 0.1 * (FUNCMX - FUNCMN)
         TMIN = FUNCMN - 0.1 * (FUNCMX - FUNCMN)
         IF (ABS (TMAX-TMIN).LT.TOLER) THEN
            TMAX = TMAX + TOLER
            TMIN = TMIN - TOLER
            END IF
C                                       GMXX, GMNX MAX&MIN of Y for all
C                                       plots
         GMXX = MAX (GMXX, TMAX)
         GMNX = MIN (GMNX, TMIN)
         TDIF = TMAX - TMIN
         IF (ABS (TDIF).LE.1.0E-25) TDIF = 1.0E-25
         GXYOFF(2,IPLT) = TMIN
         GXYSCL(2,IPLT) = SIZEY / TDIF
C                                       now about X-axis
         TMAX = (ARGMX + 0.1 * (ARGMX - ARGMN))
         TMIN = (ARGMN - 0.1 * (ARGMX - ARGMN))
         TDIF = TMAX - TMIN
         IF (ABS (TDIF).LE.0.01) TDIF = 0.01
         GXYOFF(1,IPLT) = TMIN
         GXYSCL(1,IPLT) = SIZEX / TDIF
C                                       plot beam
         XYSCL(1) = GXYSCL(1,IPLT)
         XYSCL(2) = GXYSCL(2,IPLT)
         XYOFF(1) = GXYOFF(1,IPLT)
         XYOFF(2) = GXYOFF(2,IPLT)
         CALL PLTEL (IPLOT, NTOTY, NTOTY, NTOTY, XTETA, NCOUNT, EL,
     *      SECZEN, WZENY, WZENX, INFILE, RDIRR, BEAM, 1, ITER, IRET)
  510    CONTINUE
  520 CONTINUE
C                                       Plot the original and final
C                                       UV coverage of the array
C                                       together with configuration
C                                       Prepare parameters for PLTEL
      IF (ITER.NE.1 .AND. ITER.NE.NITER) GO TO 600
         IF (APARM(6).NE.0) GO TO 600
         NPLOTC = 1
         NCOUNC = 1
         IPLTC = 1
         IPLOTC = IPLTC - 1
         IPLOTC = MOD (IPLOTC, NCOUNC) + 1
         IF (IPLTC.EQ.NPLOTC) IPLOTC = -IPLOTC
         SIZEX = 1000.0
         SIZEY = 1000.0 / NCOUNC
         GMXX = -1.0E20
         GMNX = 1.0E20
C                                       find max/min of the Y
         FUNCMX = -1.0E10
         FUNCMN =  1.0E10
         ARGMX = -1.0E10
         ARGMN =  1.0E10
C                                       find UV coverage
C                                       Do not store auto convolution
C                                       if NARRAY.GT.100
C
         IF (NARRAY.LE.100) THEN
            NUVC = NARRAY * NARRAY
         ELSE
            NUVC = 0
            END IF
         IUV = 0
         DO 550 I = 1, NARRAY
            XX(I + NUVC) = X(I)
            YY(I + NUVC) = Y(I)
         IF (NARRAY.GT.100) GO TO 550
            DO 540 K = 1, NARRAY
               IUV = IUV + 1
               XX(IUV) = X(K) - X(I)
               YY(IUV) = (Y(K) - Y(I)) * SIN(ELEV)
  540          CONTINUE
  550       CONTINUE
         NUV = NUVC + NARRAY
         NUVTOT = NUV
C                                       Plot the circumferences
C                                       for donuts or two circle
         IF (DONUTS .OR. TWOCIR) THEN
C
            DO 560 I = 1, 200
               ARG = TWOPI * (I - 1) / 200.0
               XX(I + NUV) = RINNER * COS(ARG) - RSHIFT
               YY(I + NUV) = RINNER * SIN(ARG)
               XX(I + NUV + 200) = ROUTER * COS(ARG)
               YY(I + NUV + 200) = ROUTER * SIN(ARG)
  560          CONTINUE
            NUVTOT = NUV + 400
            END IF
C                                       Plot the ellipse outer border
C                                       Minor ases is horisontal
         IF (ELLIPS) THEN
C
            DO 565 I = 1, 200
               ARG = TWOPI * (I - 1) / 200.0
               XX(I + NUV) = SMINOR * COS(ARG)
               YY(I + NUV) = SMAJOR * SIN(ARG)
  565       CONTINUE
            NUVTOT = NUV + 200
            END IF
C
         DO 570 I = 1, NUV
            FUNCMX = MAX(FUNCMX, YY(I))
            FUNCMN = MIN(FUNCMN, YY(I))
            ARGMX = MAX(ARGMX, XX(I))
            ARGMN = MIN(ARGMN, XX(I))
  570       CONTINUE
C                                       fix the sizes to -1, 1
         FUNCMX = 1.0
         FUNCMN = -1.0
         ARGMX = 1.0
         ARGMN = -1.0
         TOLER = 0.01
C
C                                       TMAX, TMIN new MAX&MIN of Y
         TMAX = FUNCMX + 0.1 * (FUNCMX - FUNCMN)
         TMIN = FUNCMN - 0.1 * (FUNCMX - FUNCMN)
         IF (ABS (TMAX-TMIN).LT.TOLER) THEN
            TMAX = TMAX + TOLER
            TMIN = TMIN - TOLER
            END IF
C                                       GMXX, GMNX MAX&MIN of Y for all
C                                       plots
         GMXX = MAX (GMXX, TMAX)
         GMNX = MIN (GMNX, TMIN)
         TDIF = TMAX - TMIN
         IF (ABS (TDIF).LE.1.0E-25) TDIF = 1.0E-25
         GXYOFF(2,IPLTC) = TMIN
         GXYSCL(2,IPLTC) = SIZEY / TDIF
C                                       now about X-axis
         TMAX = (ARGMX + 0.1 * (ARGMX - ARGMN))
         TMIN = (ARGMN - 0.1 * (ARGMX - ARGMN))
         TDIF = TMAX - TMIN
         IF (ABS (TDIF).LE.0.01) TDIF = 0.01
         GXYOFF(1,IPLTC) = TMIN
         GXYSCL(1,IPLTC) = SIZEX / TDIF
C                                       plot Y/ARG and model
         XYSCL(1) = GXYSCL(1,IPLTC)
         XYSCL(2) = GXYSCL(2,IPLTC)
         XYOFF(1) = GXYOFF(1,IPLTC)
         XYOFF(2) = GXYOFF(2,IPLTC)
         CALL PLTEL (IPLOTC, NUVTOT, NUVC, NUV, XTETA, NCOUNC, EL,
     *      SECZEN, WZENY, WZENX, INFILE, XX, YY, 2, ITER, IRET)
C
  600    CONTINUE

C                                       estimate optimum of the
C                                       configuration, minimizing beam
C                                       at the worst direction WZENX,
C                                       WZENY of zenith beam
      IF (ITER.EQ.NITER) GO TO 800
C                                       do not correct the last
C                                       itteration
      DO 740 IARRAY = 1, NARRAY
         ANUMER = 0
         DO 720 KARRAY = 1, NARRAY
            ANUMER = ANUMER + SIN( TWOPI * (WZENX *
     *         (X(KARRAY) - X(IARRAY))  +  WZENY *
     *         (Y(KARRAY) - Y(IARRAY)) ))
  720       CONTINUE
         DPPX = 2 * TWOPI * WZENX * ANUMER / (NARRAY * NARRAY)
         DPPY = 2 * TWOPI * WZENY * ANUMER / (NARRAY * NARRAY)
         DPP = SQRT (DPPX*DPPX + DPPY*DPPY)
C
         DX(IARRAY) = - GAIN * DPPX
         DY(IARRAY) = - GAIN * DPPY
  740    CONTINUE
C                                       apply the found corrections
      DO 780 IARRAY = 1, NARRAY
C                                       do not move the fixed elements
C                                       of the outer circle
C         IF ((TWOCIR .OR. TRECIR) .AND. (IARRAY.LE.NFIX)) THEN
C         IF ((TWOCIR .OR. TRECIR) .OR. (IARRAY.LE.NFIX)) THEN
         IF (IARRAY.LE.NFIX) THEN
            XTEM = X(IARRAY)
            YTEM = Y(IARRAY)
         ELSE
            XTEM = X(IARRAY) + DX(IARRAY)
            YTEM = Y(IARRAY) + DY(IARRAY)
            END IF
C                                       RT is the distance of the given
C                                       point to the center of the
C                                       outer circle
         RT = SQRT (XTEM * XTEM + YTEM * YTEM)
C                                       RTIN is the distance of the
C                                       given point to the center
C                                       of the inner circle (shifted)
         RTIN = SQRT ((XTEM+RSHIFT) * (XTEM+RSHIFT) + YTEM * YTEM)
C                                       Constraint of two circles
         IF (TWOCIR) THEN
            IF (ABS(RTIN - RINNER).LT.ABS(RT - ROUTER)) THEN
C                                       scale to the inner circle
               SCALE = RINNER / RT
            ELSE
C                                       scale to the outer circle
               SCALE = ROUTER / RT
               END IF
            XTEM = XTEM * SCALE
            YTEM = YTEM * SCALE
            END IF
C                                       Scale the outer circle in
C                                       the case of three circles
         IF (TRECIR .AND. (IARRAY.LE.NOUTER)) THEN
            SCALE = ROUTER / RT
            XTEM = XTEM * SCALE
            YTEM = YTEM * SCALE
            END IF
C                                       convert normalized positions
C                                       to positions in meters
         XT = XTEM * ARSIZE + XSHFOU
         YT = YTEM * ARSIZE + YSHFOU

C
         IF (TOPOGR) THEN
C                                       Is the corrected antenna
C                                       outside of the topography mask?
            OUSIDE = ((XT.GT.XMAX) .OR. (XT.LT.XMIN))
     *         .OR. ((YT.GT.YMAX) .OR. (YT.LT.YMIN))
            IF (OUSIDE) GO TO 780
C                                       check topography
            DO 760 KBAD = 1, NBAD
               BAD = (ABS (XT - XBAD(KBAD)).LE.0.55*CELLX)
     *            .AND. (ABS (YT - YBAD(KBAD)).LE.0.55*CELLY)
               IF (BAD) GO TO 780
  760          CONTINUE
            END IF
         IF (DONUTS) THEN
C                                       check donuts
            BAD = (RT.GT.ROUTER) .OR. (RT.LT.RINNER)
            IF (BAD) GO TO 780
            END IF


         IF (ELLIPS) THEN
C                                       direction to point XTEM,YTEM
            ARG = ATAN2 (YTEM, XTEM)
C                                       coordinate of the ellips' point
C                                       at the direction XTEM, YTEM
            XELIPS = SMINOR * COS(ARG)
            YELIPS = SMAJOR * SIN(ARG)
C                                       distance to the ellips' point
            RELIPS = SQRT(XELIPS*XELIPS + YELIPS*YELIPS)
            BAD = RT .GT. RELIPS
            IF (BAD) THEN
               GO TO 780
               END IF
            END IF


C                                       Check minimum distance or not?
         IF (DLIMIT.EQ.0) GO TO 770
C                                       Is the given element too close
C                                       to any other element?
         DO 765 KARRAY = 1, NARRAY
            IF (KARRAY.EQ.IARRAY) GO TO 765
            XTEM1 = X(KARRAY)
            YTEM1 = Y(KARRAY)
            XT1 = XTEM1 * ARSIZE + XSHFOU
            YT1 = YTEM1 * ARSIZE + YSHFOU
            NEWDIS = (XT1 - XT)*(XT1 - XT) + (YT1 - YT)*(YT1 - YT)
            IF ((DLIMIT*DLIMIT-NEWDIS) .GT. EPS) GO TO 780
  765    CONTINUE
C
  770    X(IARRAY) = XTEM
         Y(IARRAY) = YTEM
C
  780    CONTINUE
C
  800 CONTINUE
C                                       Lets calculate beam at zenith
C                                       at the found worth direction
C                                       after the correction
      REU = 0.0
      IMU = 0.0
      DO 810 IARRAY = 1, NARRAY
         ARG = TWOPI*(X(IARRAY) * WZENX + Y(IARRAY) * WZENY)
         REU = REU + COS(ARG)
         IMU = IMU + SIN(ARG)
  810    CONTINUE
      SECZEN = (REU*REU + IMU*IMU) / NARRAY / NARRAY
C                                       multiply by the primary beam
C                                       take the dish of diameter 'd'
C                                       iluminated nomogeniously
      IF (DOPB) THEN
         ARGPB = PI*SQRT(WZENX*WZENX+WZENY*WZENY)*ANTDIM/ARSIZE
               IF (ARGPB.EQ.0) THEN
                  PB = 1
               ELSE
                  BESS1 = BESSJ1(ARGPB)
                  PB = (2*BESS1/ARGPB)**2
                  END IF
               SECZEN = SECZEN * PB
               END IF
C
      WRITE (MSGTXT,2450) ITER, SECZEN, WZENX, WZENY
      CALL MSGWRT (8)
C
      ITER = ITER + 1
      IF (ITER.LE.NITER) GO TO 250
C
      WRITE (MSGTXT,2470) MITER, MINZEN, MZENX, MZENY
      CALL MSGWRT (8)
C                                       record found configuration to
C                                       the output file
  820 IF (OFILE(1:1).NE.' ') THEN
         LUNPR = 10
         FA = F
         CALL ZTXOPN ('WRIT', LUNPR, PFIND, OFILE, FA, IRET)
C
         IF (I2FILE(1:1).NE.' ' .AND. DPARM(5).EQ.1) THEN
C
            IF (NBADMN.EQ.0) THEN
               WRITE (LINE, 1440)
               GO TO 840
            ELSE
               WRITE (LINE, 1450) NBADMN
               END IF
            NCH = JTRIM(LINE)
            CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
            DO 830 KBAD = 1, NBADMN
               WRITE (LINE, 1500) KBAD,  XFOBAD(KBAD),
     *            YFOBAD(KBAD)
               NCH = JTRIM(LINE)
               CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
  830          CONTINUE
            END IF
C
         IF (.NOT. DOCONF) THEN
            WRITE (LINE, 1510) NARRAY
            NCH = JTRIM(LINE)
            CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
C                                       Latitude, Longtitude
            WRITE (LINE, 1515) LATIT, LONGT, ALT
            NCH = JTRIM(LINE)
            CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
C                                       Conversion factors
            CONV1 = 1
            CONV2 = 1
            WRITE (LINE, 1520) CONV1, CONV2
            NCH = JTRIM(LINE)
            CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
            END IF
C
  840    DO 860 IARRAY = 1, NARRAY
            IF (DPARM(6).NE.0) THEN
C                                       write output file data in meters
C                                       as output of fit to topography
               IF (I2FILE(1:1).NE.' ' .AND. DPARM(5).EQ.1) THEN
C                                       Take output of the topography
C                                       fit if only that fit was done
                  XT = XMASK (IARRAY)
                  YT = YMASK (IARRAY)
               ELSE
C
                  XT = XBEST(IARRAY) * ARSIZE + XSHFOU
                  YT = YBEST(IARRAY) * ARSIZE + YSHFOU
                  END IF
               WRITE (MSGTXT, 1065) XT, YT
               CALL MSGWRT (8)
               IF (DOCONF) THEN
                  WRITE (LINE, 1065) XT, YT
               ELSE
                  INCOOR = 1
                  ZT = 0
                  WRITE (LINE, 1525) INCOOR, XT, YT, ZT, ANTDIM, ANTEF,
     *               ANTSYS, NUMLEV
                  END IF
            ELSE
               WRITE (MSGTXT,2500) IARRAY, XBEST(IARRAY), YBEST(IARRAY)
               CALL MSGWRT (8)
C                                       write output file data
               WRITE (LINE, 1060) XBEST(IARRAY), YBEST(IARRAY)
               END IF
            NCH = JTRIM(LINE)
            CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
  860       CONTINUE
         CALL ZTXCLS (LUNPR, PFIND, IRET)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OPTI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1020 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('Put DPARM(5)=0 to use IN2FILE only for fixed antennas')
 1051 FORMAT ('You want the hexagonal configuration with NARRAY = ',
     *   I5)
 1052 FORMAT ('NARRAY should be equal 7,19,37..= 3*NC^2 + 3*NC + 1 ',
     *   'NC = 1,2,3...')
 1055 FORMAT ('Spacing between', I4, ' and', I4, ' ants', F10.6,
     *   '<allowed ', F10.6)
 1060 FORMAT (2F20.9)
 1065 FORMAT (2F20.4)
 1440 FORMAT ('All elements are fitted topography')
 1450 FORMAT (I3, ' elements are not fitted')
 1500 FORMAT (I6, ' XFIT= ', F7.1, ' YFIT= ', F7.1)
 1510 FORMAT (I4)
 1515 FORMAT (2F10.5, F10.1)
 1520 FORMAT (2I2)
 1525 FORMAT (I1, 2F20.4, I2, 1X,  F6.1, F5.2, F5.1, 1X, I1)
 2410 FORMAT ('You decided to find beam maximum as maximum outside ')
 2420 FORMAT ('of the circle of RADMIN. RADMIN can not be zero!!!')
 2450 FORMAT (I5, ' The worst at zenith equal ',F7.5,
     *   ' X = ', F6.2, ' Y = ', F6.2)
 2470 FORMAT (I5, ' The minimum worst equals ',F7.5,
     *   ' X = ', F6.2, ' Y = ', F6.2)
 2500 FORMAT (I3, 2F15.7)
      END

      SUBROUTINE EDGES (BEAM, NX, NY, XLEFT, XRIGHT, YLEFT, YRIGHT)
C-----------------------------------------------------------------------
C   EDGES fins the four edges of the main lobe of the beam
C   Input:
C      BEAM    R(*) The beam
C      NX      I    The half points at the X direction. The total
C                   number of the points at the X direction is 2*NX+1
C      NY      I    The half points at the Y direction. The total
C                   number of the points at the Y direction is 2*NY+1
C   Output:
C      XLEFT   I    The left point at X direction where main lobe ends
C      XRIGHT  I    The right point at X direction where main lobe ends
C      YLEFT   I    The left point at Y direction where main lobe ends
C      YRIGHT  I    The right point at Y direction where main lobe ends
C-----------------------------------------------------------------------
      REAL BEAM(*)
      INTEGER NX, NY, XLEFT, XRIGHT, YLEFT, YRIGHT, NTOTX, NTOTY,
     *   IX, IY, IXY1, IXY2
C----------------------------------------------------------------------
      NTOTX = 2 * NX  + 1
      NTOTY = 2 * NY  + 1
C                                       take the right edge at the beam
C                                       maximum, because later I
C                                       analyze only left side of the
C                                       beam using its symmetry
C
      XRIGHT = NX + 1
C                                       find left edge of the beam
C                                       at the X direction
      IX = NX + 1
  140 IXY1 = NY + 1 + (IX - 1) * NTOTY
         XLEFT = IX - 1
         IXY2 = NY + 1 + (XLEFT - 1) * NTOTY
         IF (BEAM(IXY2).GT.BEAM(IXY1)) GO TO 150
C
C                                       XLEFT the first point from
C                                       main maximum at X direction
C                                       to the left
C                                       where Beam start increasing
         IX = IX - 1
         GO TO 140
  150 CONTINUE
C                                       find right edge of the beam
C                                       at the Y direction
       IY = NY + 1
  160  IXY1 = IY + (NX + 1 - 1) * NTOTY
       YRIGHT = IY + 1
       IXY2 = YRIGHT + (NX + 1 - 1) * NTOTY
       IF (BEAM(IXY2).GT.BEAM(IXY1)) GO TO 170
C
C                                       YRIGHT the first point from
C                                       main maximum at Y direction
C                                       to the right
C                                       where Beam start increasing
       IY = IY + 1
       GO TO 160
  170 CONTINUE
C                                       find left edge of the beam
C                                       at the Y direction
       IY = NY + 1
  180  IXY1 = IY + (NX + 1 - 1) * NTOTY
       YLEFT = IY - 1
       IXY2 = YLEFT + (NX + 1 - 1) * NTOTY
       IF (BEAM(IXY2).GT.BEAM(IXY1)) GO TO 190
C
C                                       YLEFT the first point from
C                                       main maximum at Y direction
C                                       to the left
C                                       where Beam start increasing
       IY = IY - 1
       GO TO 180
 190  CONTINUE
 999  RETURN
      END
      SUBROUTINE PLTEL (IPLOT, ITIM, ITIMC, NUV, XTETA, NCOUNT, ELEV,
     *   SECM, WORSTY, WORSTX, KNFILE, X, Y, ICODE, ITER, IRET)
C-----------------------------------------------------------------------
C   PLTEL actually plots data and model.
C   Input:
C      IPLOT   I    Plot number on current page. If neg. then this is
C                   last plot.
C      ITIM    I    Total number of points at arrays X and Y
C      ITIMC   I    Number of UV points
C      NUV     I    Number of UV points plus number of antennas
C      XTETA   R    X position at the beam
C      NCOUNT  I    Number of plots at the page
C      ELEV    R    Elevation of the source in degrees
C      SECM    R    Maximum sidelobe's value
C      WORSTY  R    Y-Distance of the worst sidelobe
C      WORSTX  R    X-Distance of the worst sidelobe
C      IF (ICODE.EQ.3) THEN
C      SECM    R    XSHIFT in meters
C      WORSTY  R    YSHIFT in meters
C      WORSTX  R    Rotation in degrees
C      KNFILE  C    Infile
C      X       R(*) Array of data arguments
C      Y       R(*) Array of data function
C      ICODE   I    1 => beam partern; 2 => array configuration
C      ITER    I    Iteration number; used only for label
C   Inputs from Common:
C      GMNX    R    Max. value to plot
C      GMXX    R    Min. value to plot
C      XMX     R    Max. x value to plot
C      XMN     R    Min. x value to plot
C   Output:
C      IRET    I    Return code, 0 => OK, otherwise abort.
C                     -1 => user request termination
C                      1 => failed to add to catalog
C                      2 => failed to create
C                      3 => graph file write error
C                      4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   IPLOT, ITIM, ITIMC, NCOUNT, ICODE , ITER, IRET
      REAL   X(*), Y(*), ELEV, SECM, WORSTY, WORSTX, XTETA
      CHARACTER KNFILE*48
C
      CHARACTER TEXT*132, PFILE*48, ATIME*8, ADATE*12, AUNITS(28)*8,
     *   XUNITS(3)*20
      INTEGER   POLBUF(256), VER, IERR, ITYPE, IPSIZE, LUNPL, LTYPE,
     *   FINDPL, DEPTH(5), INCHAR, INP, IT(3), ID(3), IAXLAB, IAPLOT,
     *   I, NGOOD, NNOFIT, LABEL, ITT, EL, ALIN, SHIFTX, SHIFTY,
     *   NUV, ROTA
      REAL      BLC(2), TRC(2), XYRATO, DX, DY, TR, VALUE, TI,
     *   XY(2), XTRC(2), XBLC(2), TLC(2), PLTINC, YYOFF(2), SIZE,
     *   XMULT(2), XVARIB, YPT, DBY, DXC, DYC
      LOGICAL   T, F, GOOD, CATUP, BLPLT, WREAD
      SAVE LABEL, LTYPE, POLBUF
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'CONFI.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGPH.INC'
      DATA LUNPL /26/
      DATA DEPTH /5*1/
      DATA T, F /.TRUE.,.FALSE./
      DATA AUNITS /'Power', 'Y-unit', 'meters', 25*' '/
      DATA XUNITS / 'D/Lambda * Rteta', 'X-unit', 'meters'/
C----------------------------------------------------------------------
      EL = ELEV
      ALIN = WORSTX
      NGOOD = 0
      NNOFIT = 0
      IRET = 3
      CATUP = T
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      XYRATO = 1.0
      PLTINC = 1000. / NCOUNT
C                                       Set window for current plot.
      XBLC(1) = BLC(1)
      XBLC(2) = 1000.0 - ABS (IPLOT) * PLTINC
      XTRC(1) = TRC(1)
      XTRC(2) = XBLC(2) + PLTINC - 1.0
      TLC(1) = XBLC(1)
      TLC(2) = XTRC(2)
C                                       Offsets for current plot.
      YYOFF(1) = XBLC(1)
      YYOFF(2) = XBLC(2)
C                                       fool with location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
C                                       LABTYP(LOCNUM)=0 for xaxis
      LABTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      TR = 1.2 * (GMXX - GMNX)
      TI = TR
      CALL METSCA (TR, CPREF(2,LOCNUM), GOOD)
      XMULT(2) = TR / TI
      CPREF(1,LOCNUM) = ' '
      XMULT(1) = 1.0
      DO 5 I = 1,2
         SIZE = 1000.0
         IF (I.EQ.2) SIZE = PLTINC
         TR = SIZE / XYSCL(I)
         RPLOC(I,LOCNUM) = XBLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I) * XMULT(I)
         AXINC(I,LOCNUM) = TR * XMULT(I) / (XTRC(I) - XBLC(I))
 5      CONTINUE
      CTYP(1,LOCNUM) = XUNITS(ICODE)
      CTYP(2,LOCNUM) = AUNITS(ICODE)
C                                       Create plot file
      IF (ABS (IPLOT).EQ.1) THEN
C                                       Update catalog header.
         VER = 0
         IRET = 1
         IF (.NOT.DOTV) THEN
            CALL MADDEX ('PL', DISKIN, CNOIN, CATBLK, POLBUF, CATUP,
     *         'WRIT', VER, IERR)
            IF (IERR.NE.0) THEN
               NCFILE = NCFILE - 1
               GO TO 999
               END IF
            END IF
         CALL ZPHFIL ('PL', DISKIN, CNOIN, VER, PFILE, IERR)
         IF (IERR.NE.0) GO TO 960
         IPSIZE = 0
         ITYPE = 17
C
         CALL GINIT (DISKIN, CNOIN, PFILE, IPSIZE, ITYPE, NPARM,
     *      XNAMEI, DOTV, TVCHN, GRCHN, TVCORN, CATBLK, POLBUF, LUNPL,
     *      FINDPL, IERR)
         IRET = 2
         IF (IERR.NE.0) GO TO 960
C                                       Number of characters on each
C                                       side of the plot
         CALL RFILL (4, 0.5, CHOUT)
C                                       Not fully initialized, may make
C                                       INP too large which is okay.
         CALL CHNTIC (XBLC, XTRC, INP)
         INP = MAX (INP, 3)
C                                       standard labeling
         LABEL = 3
         LTYPE = 3
         CHOUT(1) = INP + 4
         CHOUT(2) = 3.333
         CHOUT(4) = 4.666
C                                       Init for line drawing.
         CALL GINITL (BLC, TRC, XYRATO, CHOUT, DEPTH, POLBUF, IERR)
         IRET = 3
         IF (IERR.NE.0) GO TO 970
         IF (.NOT.DOTV) THEN
            WRITE (MSGTXT,1000) VER
            CALL MSGWRT (3)
            END IF
         END IF
      IRET = 3
      CATUP = T
C                                       Draw border
      CALL GLTYPE (1, POLBUF, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GPOS (XBLC(1), XTRC(2), POLBUF, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XBLC(2), POLBUF, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XBLC(2), POLBUF, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XTRC(2), POLBUF, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XTRC(2), POLBUF, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Top labels: type & name
      IF (ABS(IPLOT).EQ.1) THEN
         DX = 0.0
         DY = 1.833
C                                       The second line of the header
         CALL GPOS (BLC(1), TRC(2), POLBUF, IERR)
         IF (IERR.NE.0) GO TO 970
         INP = 1
C                                       configuration in meters with
C                                       topography mask
         IF (ICODE.EQ.3) THEN
            SHIFTX = SECM
            SHIFTY = WORSTY
            ROTA = WORSTX
            WRITE (TEXT(INP:),1070) SHIFTX, SHIFTY, ROTA
         ELSE
            WRITE (TEXT(INP:),1040) SECM, WORSTX, WORSTY
            END IF
         CALL CHTRIM (TEXT, 80, TEXT, INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, POLBUF, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       the third line of header
         DY = 0.5
         CALL GPOS (BLC(1), TRC(2), POLBUF, IERR)
         IF (IERR.NE.0) GO TO 970
         INP = 1
         WREAD = .FALSE.
         IF (KNFILE(1:1).NE.' ') WREAD = .TRUE.
         IF (WREAD) THEN
            WRITE (TEXT(INP:),1055) KNFILE
         ELSE
            WRITE (TEXT(INP:),1056) NARRAY
            END IF
         INP = INP + 28
         IF (ICODE.EQ.3) THEN
            WRITE (TEXT(INP:),1080) I2FILE
         ELSE
            WRITE (TEXT(INP:),1045) ITER, EL
            END IF
C
         CALL CHTRIM (TEXT, 80, TEXT, INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, POLBUF, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Date/time/version
         DY = 0.5 + 2 * 1.333
C                                       the first line of the header
         CALL GPOS (BLC(1), TRC(2), POLBUF, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, ATIME, ADATE)
         WRITE (TEXT,1030) VER, ADATE, ATIME
         INCHAR = 51
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, POLBUF, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Set up location common
      CALL GPOS (XBLC(1), XTRC(2), POLBUF, IERR)
      IF (IERR.NE.0) GO TO 970
      DX =  1.5
      DY = -1.8
      INCHAR = 12
      INP = 1
C                                       label each plot
      IF (ICODE.EQ.1) THEN
         WRITE (TEXT(INP:),2040) XTETA
         INP = INP + 5
         CALL CHTRIM (TEXT, 80, TEXT, INCHAR)
         CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, POLBUF, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Blank bottom label.
      IF ((IPLOT.GE.0) .AND. (ABS (IPLOT).NE.NCOUNT)) THEN
         CPREF(1,LOCNUM) = ' '
         CTYP(1,LOCNUM) = ' '
         END IF
C                                       Only label Y axis once.
      IAXLAB = NCOUNT / 2 + 1
      IAPLOT = ABS (IPLOT)
      IF ((IAPLOT.NE.IAXLAB) .AND. ((IPLOT.GE.0) .OR.
     *   (IAPLOT.GT.IAXLAB))) CPREF(2,LOCNUM) = '-1'
C                                       Put on labels and ticks
      CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XYRATO, F, POLBUF, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       take data
C                                       Size of symbol.
      DX = 1.0
      DY = 1.0
      DBY = 0.5
      DXC = 10.0
      DYC = 10.0
C                                       Loop to plot the data
      DO 10 ITT = 1, ITIM
         XVARIB = X(ITT)
         VALUE = Y(ITT)
         BLPLT = .FALSE.
         IF (VALUE.EQ.FBLANK) THEN
            BLPLT = .TRUE.
            VALUE = 0.0
            END IF
C                                       Scale X, Y
         XY(1) = XVARIB
         XY(1) = XYSCL(1) * (XY(1) - XYOFF(1)) + YYOFF(1)
         IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1))) THEN
            NNOFIT = NNOFIT + 1
            GO TO 10
            END IF
         XY(2) = VALUE
         XY(2) = XYSCL(2) * (XY(2) - XYOFF(2)) + YYOFF(2)
         IF ((XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2))) THEN
            NNOFIT = NNOFIT + 1
            GO TO 10
            END IF
         NGOOD = NGOOD + 1
         DY = 1.0
         IF (BLPLT) DY = DBY
C                                       Draw crosses for UV points
         IF ((ITT.LE.ITIMC) .OR. (ITIMC.EQ.0)) THEN
            CALL GLTYPE (4, POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL GPOS (XY(1)+DX, XY(2), POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL GVEC (XY(1)-DX, XY(2), POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
            YPT = XY(2) + DY
            IF (YPT.GT.XTRC(2)) YPT = XTRC(2)
            CALL GPOS (XY(1), YPT, POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
            YPT = XY(2) - DY
            IF (YPT.LT.XBLC(2)) YPT = XBLC(2)
            CALL GVEC (XY(1), YPT, POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
C                                       Draw diamonds for antennas
         ELSE IF ((ITT.LE.NUV) .AND. (ITIMC.GT.0)) THEN
            CALL GLTYPE (3, POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL GPOS (XY(1)-DXC, XY(2), POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
            YPT = XY(2) + DYC
            IF (YPT.GT.XTRC(2)) YPT = XTRC(2)
            CALL GVEC (XY(1), YPT, POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL GVEC (XY(1)+DXC, XY(2), POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
            YPT = XY(2) - DYC
            IF (YPT.LT.XBLC(2)) YPT = XBLC(2)
            CALL GVEC (XY(1), YPT, POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL GVEC (XY(1)-DXC, XY(2), POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
C                                       Draw crosses for circles
         ELSE
            CALL GLTYPE (2, POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL GPOS (XY(1)+DX, XY(2), POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL GVEC (XY(1)-DX, XY(2), POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
            YPT = XY(2) + DY
            IF (YPT.GT.XTRC(2)) YPT = XTRC(2)
            CALL GPOS (XY(1), YPT, POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
            YPT = XY(2) - DY
            IF (YPT.LT.XBLC(2)) YPT = XBLC(2)
            CALL GVEC (XY(1), YPT, POLBUF, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
 10     CONTINUE
C                                       Done: finish plot
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (3)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1201) NNOFIT
         CALL MSGWRT (3)
         END IF
      IF ((IPLOT.GT.0) .AND. (ABS(IPLOT).LT.NCOUNT)) GO TO 210
         GPHPAG = IPLOT.GT.0
         CALL GFINIS (POLBUF, IERR)
         IF (IERR.GT.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, POLBUF, IERR)
            IERR = 0
            END IF
  210    IF (IERR.GT.0) GO TO 975
         IRET = MIN (IERR, 0)
         GO TO 999
C                                       ZPHFIL or GINIT failure.
  960 CONTINUE
      WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      IF (.NOT.DOTV) THEN
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, POLBUF,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
      GO TO 999
C                                       Try to finish partial graph
 970  CONTINUE
      WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1201) NNOFIT
         CALL MSGWRT (2)
         END IF
      GPHPAG = IPLOT.GT.0
      CALL GFINIS (POLBUF, IERR)
      IF (IERR.NE.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, POLBUF, IERR)
            IERR = 0
            END IF
         GO TO 999
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, POLBUF,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Plot file version',I4,'  created.')
 1030 FORMAT ('Plot file version',I4,'  created ',A, A)
 1040 FORMAT (' The worst sidelobe = ', F7.5, '; X = ', F5.1,
     *   '; Y = ',F5.1)
 1045 FORMAT (' Iteration number', I4, '. Elev =',I3,'deg')
 2040 FORMAT (F5.1)
 1055 FORMAT ('Input file:', A17)
 1056 FORMAT ('Input:', I4, ' points in circle. ' )
 1070 FORMAT ('XSHIFT =', I5, ' m;', ' YSHIFT =', I5,
     *   ' m;', ' ROT = ',I4, ' deg.')
 1080 FORMAT ('Mask file:', A17)
 1200 FORMAT ('PLTEL: ',I9,' points plotted')
 1201 FORMAT ('PLTEL: ',I9,' points did not fit')
 1960 FORMAT ('PLTEL: ERROR DURING GRAPH FILE CREATION')
 1970 FORMAT ('PLTEL: ERROR DURING GRAPHING. ',
     *   ' WILL TRY TO FINISH PARTIAL GRAPH')
      END
      SUBROUTINE MASK ( NX, NY, NROT, CELLX, CELLY, DROT,
     *   XSHIFT, YSHIFT, ROT, ARSIZE, X, Y , XMASK, YMASK, XSHFOU,
     *   YSHFOU, ROTFOU, NBADMN, XFOBAD, YFOBAD, IRET)
C-----------------------------------------------------------------------
C   MASK find the best position of the array at the given topography.
C   Input:
C      NX      I    Number of shift at X
C      NY      I    Number of shift at Y
C      NROT    I    Number of rotations
C      CELLX   R    Step of shift at X, meter
C      CELLY   R    Step of shift at Y, meter
C      DROT    R    Step of rotation, degrees
C      ARSIZE  R    Desire size of the array, meter
C      X       R(*) Normolized X positions of the array's elements
C      Y       R(*) Normolized Y positions of the array's elements
C      XSHIFT  R    Gess shift of the configuration at X, meter
C      YSHIFT  R    Gess shift of the configuration at Y, meter
C      ROT     R    Gess rotation of the configuration, radians
C   Inputs from Common:
C      I2FILE  C(*) File of topography
C      NARRAY  I    Number of elements at the array
C      GMNX    R    Max. value to plot
C      GMXX    R    Min. value to plot
C      XBLCC   R    X of bottom low corner of the mask, in meters
C      YBLCC   R    Y of bottom left corner of the mask, in meters
C      XTRCC   R    X of top right corner of the mask, in meters
C      YTRCC   R    Y of top right corner of the mask, in meters
C   Output:
C      IRET    I    Return code, 0 => OK, otherwise abort.
C      XMASK   R(*) Fitted X positions of the array's elements in meters
C      YMASK   R(*) Fitted Y positions of the array's elements in meters
C      XSHFOU  R    Found shift of the configuration at X, meter
C      YSHFOU  R    Found shift of the configuration at Y, meter
C      ROTFOU  R    Found rotation of the configuration, radians
C   Output in Common:
C      NBAD    I    Number of bad points at the topgraphy
C      XBAD    R(*) Array of X bad points at the topography
C      YBAD    R(*) Array of Y bad points at the topography
C      NBADMN  I    Number of found bad points of the array
C      XFOBAD  R(*) X of bad points
C      YFOBAD  R(*) Y of bad points
C-----------------------------------------------------------------------
      INTEGER   ISCR(256)
      INTEGER NX, NY, NROT, IRET
      REAL CELLX, CELLY, DROT, XSHIFT, YSHIFT, ROT, ARSIZE, X(*), Y(*),
     *   XMASK(*), YMASK(*), XFOBAD(*), YFOBAD(*)
      INTEGER IX, IY, KX, KY, KBAD, NBADMN, IROT, NCBAD, NUMBAD(200),
     *   NUMBA(200), I, NPLOTC, NCOUNC, IPLTC, JT, JTRIM, IPLOTC, NUV,
     *   ITER, IND
      INTEGER NBYTES, KBP
      REAL   XSH, YSH, ROTA, XSHFOU, YSHFOU,
     *   ROTFOU, ROTFDG, XT, YT, SIZEX, SIZEY, TOLER, TMAX, TMIN,
     *   TDIF, XTETA, EL, DXBT, DYBT
      CHARACTER LINE*80
      LOGICAL BAD, INSIDE
      DOUBLE PRECISION VALUE
      INCLUDE 'CONFI.INC'
C
      INCLUDE 'FIT2A.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'


      NBAD = 0
      LUNPR = 10
      FA = .FALSE.
      XMAX = -1.0E-10
      YMAX = -1.0E-10
      XMIN = 1.0E10
      YMIN = 1.0E10
      DXBT = XTRCC - XBLCC
      DYBT = YTRCC - YBLCC
C                                       FITS file
      IF (DOFITS) THEN
         CALL FITASC (ISCR, CELLX, CELLY, IRET)
         IF (IRET.NE.0) GO TO 999
      ELSE

C                                       open mask file in ASCII format
         CALL ZTXOPN ('READ', LUNPR, PFIND, I2FILE, FA, IRET)
         NBYTES = 80
C                                       read the file data
  320    CALL ZTXIO ('READ', LUNPR, PFIND, LINE, IRET)
         IF (IRET.EQ.2) GO TO 340
         JT = JTRIM (LINE)
C                                       Get values
         KBP = 1
C
         CALL GETNUM (LINE, NBYTES, KBP, VALUE)
         KX = VALUE + 0.1
         CALL GETNUM (LINE, NBYTES, KBP, VALUE)
         KY = VALUE + 0.1
         CALL GETNUM (LINE, NBYTES, KBP, VALUE)
         IND = VALUE + 0.1
C
         XT = (KX - 1) * CELLX
         YT = (KY - 1) * CELLY
C                                       take the point inside of BLC,
C                                       TRC
         IF (XT.LT.XBLCC) THEN
            GO TO 320
         ELSE
            IF (XT.LT.XTRCC) THEN
               IF (YT.LT.YBLCC .OR. YT.GT.YTRCC) GO TO 320
            ELSE
               GO TO 340
               END IF
            END IF

         XMAX = MAX(XMAX, XT)
         XMIN = MIN(XMIN, XT)
         YMAX = MAX(YMAX, YT)
         YMIN = MIN(YMIN, YT)
C                                       the bad (restricted) points
C                                       correspond to 1 (.NE. 0)
         IF (IND .NE. 0) THEN
            NBAD = NBAD + 1
            IF (NBAD .GT. MXMASK) THEN
               IRET = 5
               WRITE (MSGTXT,1040) MXMASK
               CALL MSGWRT (8)
               GO TO 999
               END IF
            XBAD(NBAD) = XT
            YBAD(NBAD) = YT
            END IF
C
         GO TO 320
  340    CONTINUE
         CALL ZTXCLS (LUNPR, PFIND, IRET)
         END IF
C
      WRITE (MSGTXT,1080)  NBAD
      CALL MSGWRT (8)
C-----shift and rotate configuration to avoid bad topography. start---
      DROT = DROT * DG2RAD
      NBADMN = 1000
      XSHFOU = XSHIFT
      YSHFOU = YSHIFT
      ROTFOU = ROT
      DO 390 IX = 1, NX
         XSH = XSHIFT + (IX - 1 - NX/2) * CELLX
         DO 380 IY = 1, NY
            YSH = YSHIFT + (IY - 1 - NY/2) *CELLY
            DO 370 IROT = 1, NROT
               ROTA = ROT + (IROT - 1 - NROT/2) * DROT
C                                       Check that all elements are
C                                       inside of the given region
               DO 345 I = 1, NARRAY
                  XT = (X(I) * COS(ROTA) + Y(I) * SIN(ROTA))
     *               * ARSIZE + XSH
                  YT = (Y(I) * COS(ROTA) - X(I) * SIN(ROTA))
     *               * ARSIZE + YSH
                  INSIDE = ((XT.LT.XMAX) .AND. (XT.GT.XMIN))
     *               .AND. ((YT.LT.YMAX) .AND. (YT.GT.YMIN))
                  IF (.NOT. INSIDE) GO TO 370
  345             CONTINUE


               NCBAD = 0
               DO 360 I = 1, NARRAY
                  XT = (X(I) * COS(ROTA) + Y(I) * SIN(ROTA))
     *               * ARSIZE + XSH
                  YT = (Y(I) * COS(ROTA) - X(I) * SIN(ROTA))
     *               * ARSIZE + YSH
C                                       Is the given element in good
C                                       location?
                  DO 350 KBAD = 1, NBAD
                     BAD = (ABS (XT - XBAD(KBAD)).LE.0.55*CELLX)
     *                  .AND. (ABS (YT - YBAD(KBAD)).LE.0.55*CELLY)
                     IF (BAD) THEN
                        NCBAD = NCBAD + 1
                        NUMBA(NCBAD) = I
                        GO TO 360
                        END IF
  350                CONTINUE
  360             CONTINUE
               IF (NCBAD.EQ.0) THEN
                  NBADMN = NCBAD
C                                       the configuration fitted the
C                                       topography has been found
                  XSHFOU = XSH
                  YSHFOU = YSH
                  ROTFOU = ROTA
                  WRITE (MSGTXT,1090)
                  CALL MSGWRT (8)
                  GO TO 400
               ELSE
C                                       find the minimum of unfitted
C                                       elements
                  IF (NCBAD.LT.NBADMN) THEN
                     NBADMN = NCBAD
                     DO 365 I = 1, NBADMN
                        NUMBAD(I) = NUMBA(I)
  365                   CONTINUE
                     XSHFOU = XSH
                     YSHFOU = YSH
                     ROTFOU = ROTA
                     END IF
                  END IF
  370          CONTINUE
  380       CONTINUE
  390    CONTINUE
C
      IF (NBADMN.EQ.1000) THEN
C                                       some antennas appeared outside
C                                       of the topography mask
         IRET = 10
         WRITE (MSGTXT,1050)
         CALL MSGWRT (8)
         GO TO 999
      ELSE
         WRITE (MSGTXT,1100) NBADMN
         CALL MSGWRT (8)
         END IF
  400 CONTINUE
      ROTFDG = ROTFOU*RAD2DG
C
      WRITE (MSGTXT,1110) XSHFOU, YSHFOU, ROTFDG
      CALL MSGWRT (8)
C                                       add the fitted configuration
      DO 410 I = 1, NARRAY
         XT = (X(I) * COS(ROTFOU) + Y(I) * SIN(ROTFOU))
     *      * ARSIZE + XSHFOU
         YT = (Y(I) * COS(ROTFOU) - X(I) * SIN(ROTFOU))
     *      * ARSIZE + YSHFOU
         XBAD(I + NBAD) = XT
         YBAD(I + NBAD) = YT
         XMASK(I) = XT
         YMASK(I) = YT
         DO 405 KBAD = 1, NBADMN
            IF (NUMBAD(KBAD).EQ.I) THEN
               XFOBAD(KBAD) = XMASK(I)
               YFOBAD(KBAD) = YMASK(I)
               GO TO 410
               END IF
  405          CONTINUE
  410    CONTINUE
      DO 415 KBAD = 1, NBADMN
         WRITE (MSGTXT,1120) KBAD, NUMBAD(KBAD), XFOBAD(KBAD),
     *      YFOBAD(KBAD)
         CALL MSGWRT (8)
  415    CONTINUE
C-----shift and rotate configuration to avoid bad topography. end-----
C                                       Plot restricted points
C                                       Prepare parameters for PLTEL
      NPLOTC = 1
      NCOUNC = 1
      IPLTC = 1
      IPLOTC = IPLTC - 1
      IPLOTC = MOD (IPLOTC, NCOUNC) + 1
      IF (IPLTC.EQ.NPLOTC) IPLOTC = -IPLOTC
C      SIZEY = 1000.0 / NCOUNC
      GMXX = -1.0E20
      GMNX = 1.0E20
C                                       find max/min of the Y
      FUNCMX = -1.0E10
      FUNCMN =  1.0E10
      ARGMX = -1.0E10
      ARGMN =  1.0E10
C
      NUV = NBAD + NARRAY
      DO 420 I = 1, NUV
         FUNCMX = MAX(FUNCMX, YBAD(I))
         FUNCMN = MIN(FUNCMN, YBAD(I))
         ARGMX = MAX(ARGMX, XBAD(I))
         ARGMN = MIN(ARGMN, XBAD(I))
  420    CONTINUE
C                                       scale the Xsize to have
C                                       identical scale at X and Y
      SIZEY = 1000.0
      SIZEX = SIZEY * (ARGMX - ARGMN) / (FUNCMX - FUNCMN)
      TOLER = 0.01
C
C                                       TMAX, TMIN new MAX&MIN of Y
      TMAX = FUNCMX + 0.1 * (FUNCMX - FUNCMN)
      TMIN = FUNCMN - 0.1 * (FUNCMX - FUNCMN)
      IF (ABS (TMAX-TMIN).LT.TOLER) THEN
         TMAX = TMAX + TOLER
         TMIN = TMIN - TOLER
         END IF
C                                       GMXX, GMNX MAX&MIN of Y for all
C                                       plots
      GMXX = MAX (GMXX, TMAX)
      GMNX = MIN (GMNX, TMIN)
      TDIF = TMAX - TMIN
      IF (ABS (TDIF).LE.1.0E-25) TDIF = 1.0E-25
      GXYOFF(2,IPLTC) = TMIN
      GXYSCL(2,IPLTC) = SIZEY / TDIF
C                                       now about X-axis
      TMAX = (ARGMX + 0.1 * (ARGMX - ARGMN))
      TMIN = (ARGMN - 0.1 * (ARGMX - ARGMN))
      TDIF = TMAX - TMIN
      IF (ABS (TDIF).LE.0.01) TDIF = 0.01
      GXYOFF(1,IPLTC) = TMIN
      GXYSCL(1,IPLTC) = SIZEX / TDIF
C                                       plot Y/ARG and model
      XYSCL(1) = GXYSCL(1,IPLTC)
      XYSCL(2) = GXYSCL(2,IPLTC)
      XYOFF(1) = GXYOFF(1,IPLTC)
      XYOFF(2) = GXYOFF(2,IPLTC)
      CALL PLTEL (IPLOTC, NUV, NBAD, NUV, XTETA, NCOUNC, EL, XSHFOU,
     *   YSHFOU, ROTFDG, INFILE, XBAD, YBAD, 3, ITER, IRET)
C
  999 RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('!Number of restricted pixels at the mask',
     *   ' exceeds limit', I8)
 1050 FORMAT ('Some antennas are outside the topography mask')
 1080 FORMAT ('NBAD = ', I8)
 1090 FORMAT ('Configuration fitted topography is found!!!')
 1100 FORMAT (I3, ' elements are not fitted')
 1110 FORMAT ('XSHFOU=', F6.0, ' m; YSHFOU=', F6.0,
     *   ' m;  ROTFOU =', F5.0, ' deg')
 1120 FORMAT (2I6, ' XFIT= ', F7.1, ' YFIT= ', F7.1)
      END
      SUBROUTINE OUTER (I2FILE, NOUTER, ARSIZE, DLIMIT, X, Y, I, NFIX,
     *   IRET)
C-----------------------------------------------------------------------
C   OUTER find element positions on the outer circle if some are fixed
C   Input:
C      I2FILE  C*48 Name of the file with fixed positions in
C                   normalized form
C      NOUTER  I    Number of elements at the outer circle
C      ARSIZE  R    Dimension of the array in meters
C      DLIMIT  R    Minimum distance between antennas, in meters
C   Output:
C      X,Y     R(*) Position of the elements
C      NFIX    I    Number of fixed elements
C      IRET    I    Return code, 0 => OK, otherwise abort.
C   In/Output:
C      I       I    The curent number of the element
C-----------------------------------------------------------------------
      INTEGER   NOUTER, NFIX, LUNPR, PFIND, NLINE, I, NADD, NIFIX,
     *   IFIX, IROUND, K, KK, KCAN(100), DROOM(100), IRET, JT, JTRIM
      REAL   ARSIZE, DLIMIT, X(*), Y(*), XT, YT, SL, ARG, DOTPRO,
     *   LENGTH, ARCINT, DLENGT, DISTM
      CHARACTER I2FILE*48, LINE*80
      LOGICAL   T, F, FA
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IRET = 0
C                                       outer circle
C                                       open in2file if its name is
C                                       not blank to read the position
C                                       and number of fixed elemets at
C                                       the outer circle
      LUNPR = 10
      FA = F
      CALL ZTXOPN ('READ', LUNPR, PFIND, I2FILE, FA, IRET)
      IF (IRET.NE.0) GO TO 999
      NLINE = 0
      I = 0
C                                       read the file data
 10   CALL ZTXIO ('READ', LUNPR, PFIND, LINE, IRET)
      IF (IRET.EQ.2) GO TO 50
      IF (IRET.GT.0) GO TO 999
      I = I + 1
      NLINE = NLINE + 1
      JT = JTRIM (LINE)
      READ (LINE,1000) XT, YT
      X(NLINE) = XT
      Y(NLINE) = YT
      GO TO 10
50    CONTINUE
      NFIX = NLINE
      CALL ZTXCLS (LUNPR, PFIND, IRET)
C                                       Now we have NFIX fixed elements
C                                       on the outer circle. Let's add
C                                       the rest NADD elements
      NADD = NOUTER - NFIX
C                                       insert number of elements
C                                       between i and i+1 fixed
C                                       elements proportionnaly to the
C                                       relevant distance between the
C                                       fixed elements
      DO 80 IFIX = 1, NFIX
         SL = ATAN2(Y(IFIX), X(IFIX))
         KK = 0
         IF (IFIX.LT.NFIX) THEN
            DOTPRO = X(IFIX) * X(IFIX+1) + Y(IFIX) * Y(IFIX+1)
         ELSE
            DOTPRO = X(1) * X(NFIX) + Y(1) * Y(NFIX)
            END IF
C                                       length of the arc in radians
C                                       between neibourgh elements on
C                                       the circle of radius 0.5
         LENGTH = ACOS(4 * DOTPRO)

C                                       How much elements can be spaced
C                                       in this arc with spacing DLIMIT
         ARCINT = 2 * ASIN(DLIMIT/ARSIZE)
C                                       ARCINT is arc of the interval
         KCAN(IFIX) = LENGTH / ARCINT - 1
C                                       The number of inserted elements
C                                       in the arc LENGTH homogeniously
         ARCINT = TWOPI / NADD
         NIFIX = IROUND(LENGTH / ARCINT)
C                                       Do the next operation only for
C                                       the smallest configuration
         IF (ARSIZE / DLIMIT.LT.10) THEN
            IF (KCAN(IFIX).GT.NIFIX) NIFIX = KCAN(IFIX)
            END IF
         IF (IFIX.EQ.NFIX) NIFIX = NOUTER - I
   55    DLENGT = LENGTH / (NIFIX + 1)
         DISTM = ARSIZE * SIN(DLENGT/2)
         IF (DISTM.LT.DLIMIT) THEN
            NIFIX = NIFIX - 1
            IF (NIFIX.LE.0) GO TO 70
            GO TO 55
            END IF
         DO 60 K = 1, NIFIX
            ARG = SL + K * DLENGT
            I = I + 1
            KK = KK + 1
            X(I) = 0.5 * COS(ARG)
            Y(I) = 0.5 * SIN(ARG)
            IF (I.EQ.NOUTER) GO TO 100
   60       CONTINUE
C                                       How much elements can be more
C                                       inserted into the given int.
  70    DROOM(IFIX) = KCAN(IFIX) - KK
  80     CONTINUE
  100 NIFIX = NOUTER - I
      IF (NIFIX.EQ.0) GO TO 999
      IF (NIFIX.GT.0) THEN
         WRITE (MSGTXT, 1100) NIFIX
         CALL MSGWRT (8)
         WRITE (MSGTXT, 1200)
         CALL MSGWRT (8)
         END IF
C
      DO 90 IFIX = 1, NFIX
         IF (DROOM(IFIX).GT.0) THEN
            WRITE (MSGTXT, 1300) DROOM(IFIX), IFIX, IFIX+1
            CALL MSGWRT (8)
            END IF
   90    CONTINUE

  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (2F20.9)
 1100 FORMAT ('There is no room for ', I2, ' elements in outer circle')
 1200 FORMAT ('Cut short number of the fixed elements')
 1300 FORMAT ('There is a room for', I2, ' elements at the interval ',
     *   I2,'-',I2)
      END
C
C----the soubroutines to read topography at FITS format-----------------
      SUBROUTINE FITASC (ISCR, CELLX, CELLY, IRET)
C-----------------------------------------------------------------------
C     FITASC reads the fits file and records it to ascii file
      INTEGER  IRET
      INTEGER  IOP, FITS, ISCR(256), IERR
      REAL CELLX, CELLY
      LOGICAL  NODATA
      INCLUDE 'FIT2A.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       store the old CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Convert to internal format.
C
      CALL MLTAPE (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       See what kind of file.
      CALL TPIOHD (FDVEC, 128, FITS, TBIND, TAPBUF, ISCR, IRET)
      IF (IRET.NE.0) GO TO 950
      IF (FITS.EQ.1) THEN
         IOP = 1
         CALL FITHDR (IOP, NODATA, IRET)
C                                       Get the data and store in file
         CALL FITDAT (CELLX, CELLY, IRET)
         IF (IRET.NE.0) GO TO 950
      ELSE
         WRITE (MSGTXT,1000)
         IF (FITS.EQ.-1) WRITE (MSGTXT,1001)
         IF ((FITS.EQ.-1) .AND. (FDVEC(42).EQ.2560))
     *      WRITE (MSGTXT,1002)
         CALL MSGWRT (8)
         IRET = 1
         GO TO 950
         END IF
C                                       Close output
 950  CALL TAPIO ('CLOS', FDVEC, TAPBUF, TBIND, IERR)
      IF (IRET.EQ.0) IRET = IERR
C                                       restore the old CATBLK
C                                       for PLTEL with dotv=-1
      CALL COPY (256, CATOLD, CATBLK)
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TAPE IS UV-EXPORT FORMAT: USE UVLOD')
 1001 FORMAT ('TAPE FILE IS NON-STANDARD FITS WHICH IS NOT SUPPORTED')
 1002 FORMAT ('TAPE IS LIKELY TO BE ''RPFITS'' FORMAT: TRY ATLOD')
      END
C
C
      SUBROUTINE MLTAPE (IERR)
C-----------------------------------------------------------------------
C   MLTAPE sets up for TAPIO and opens the input for FIT2A.
C   Outputs: IERR        I    Error return
C                             0--> okay,  1--> error
C   Uses and build special common /MLTAPE/
C-----------------------------------------------------------------------
      INTEGER  IERR
      HOLLERITH HDVEC(50)
      INCLUDE 'FIT2A.INC'
      INCLUDE 'CONFI.INC'
      EQUIVALENCE (FDVEC, HDVEC)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Buffer size.
      FDVEC(3) = (29184 * NBITWD) / 8
C                                       Logical record size (FITS)
      FDVEC(2) = 2880
C                                       Disk output.
      CALL CHR2H (48, I2FILE, 1, HDVEC(7))
      WRITE (MSGTXT,1000) I2FILE
      CALL MSGWRT (2)
      FDVEC(1) = 25
C      NTAPE = 1
      FDVEC(5) = 1
C                                       Open tape
      CALL TAPIO ('OPRD', FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1025) IERR
         GO TO 980
         END IF
C                                       Error returns
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Reading from disk file: ',A)
 1025 FORMAT ('MLTAPE: COULD NOT OPEN TAPE.  IER=',I7)
      END
      SUBROUTINE FITHDR (IOP, NODATA, IERR)
C-----------------------------------------------------------------------
C   FITHDR reads the tape which must be open and positioned at begin.
C   of file) and builds a catalog header and pointers from the
C   tape header records.  After the required fits cards are read a
C   map file with a temporary name is created and the history records
C   are recognized and written to the history file as the other header
C   cards are processed.  The file is later renamed to the correct name.
C   Inputs:
C     IOP    I     Operation code 1=> read tape, 2=>just create dummy
C                  file
C   Output:
C     NODATA L     True if tape contains no data section, else false.
C     IERR   I     =0 => ok
C                   other => quit
C-----------------------------------------------------------------------
      REAL      PIX11(2)
      INTEGER   IOP, ICARD, IE, IERR, IREC, I,
     *   IN, IS, IAX, IDEPTH(5), ICEND
      LOGICAL   END, F, T, ISHIST, NODATA
      INCLUDE 'FIT2A.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Initialize BLANK values flag
C                                       to false.
      NODATA = .FALSE.
      ISBLNK = .FALSE.
      FUCKUP = .FALSE.
      CALL CATCLR (CATBLK)
C                                       See if tape read requested
      IF (IOP.EQ.2) GO TO 15
C                                       Initialize header values.
         CALL CATINI (CATBLK)
         SCALE = 1.0D0
         OFFSET = 0.0D0
         ISCALE = 1.0D0
         IZERO = 0.0D0
C                                       Record 1 already read
         CALL ZC8CL (2880, 1, TAPBUF(TBIND), HDRBUF)
C                                       Decode required cards.
         CALL IMREQC (HDRBUF, ICEND, IERR)
         IF (IERR.NE.0) GO TO 999
         IF (CATBLK(KIDIM).NE.0) GO TO 5
C                                       No data, must have tables.
            IF (.NOT.STDEXT) GO TO 980
C                                       Make a 2x2 map.
 15   NODATA = .TRUE.
      ISBLNK = .TRUE.
      CATBLK(KIDIM) = 2
            CATBLK(KINAX) = 2
            CATBLK(KINAX+1) = 2
C                                       More defaults.
 5    DO 10 I = 1,KICTPN
         CATR(KRCRP+I-1) = CATBLK(KINAX+I-1) / 2
         CATR(KRCIC+I-1) = 1.0
 10      CONTINUE
C                                       Create map with temporary name.
C                                       Map will be renamed later.
      CALL CHR2H (12, 'FIT2A       ', KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, 'TEMP  ', KHIMCO, CATH(KHIMC))
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
      CATBLK(KIIMS) = 0
      CATBLK(KIIMU) = NLUSER
      CALL CHR2H (12, '            ', KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, '      ', KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = 0
C      ISLOT = CNO
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000)
         GO TO 990
         END IF
      NCFILE = 1
C      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 2
C      FVOL(NCFILE) = KVOL
C                                       See if need to parse rest of
C                                       header.
      IF (IOP.EQ.2) GO TO 210
C
         ICARD = ICEND + 1
C                                       Loop until END card found.
         DO 90 IREC = 1,1000000
C                                       Read next record.
            IF (ICARD.LE.36) GO TO 80
               CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
               IF (IERR.NE.0) GO TO 999
               CALL ZC8CL (2880, 1, TAPBUF(TBIND), HDRBUF)
               ICARD = 1
C                                       Parse card, put value in hdr.
 80         CALL IMPARS (ICARD, HDRBUF, ISHIST, END, IERR)
            IF (END) GO TO 100
            ICARD = ICARD + 1
 90         CONTINUE
C                                       End card found.
 100     CONTINUE
C                                       Make axis increments non zero
C                                       to help out dumb programs.
         IN = KINAX
         IS = KRCIC
         IE = IS + CATBLK(KIDIM) - 1
         DO 200 IAX = IS,IE
            IF ((CATR(IAX).EQ.0.0).AND.(CATBLK(IN).EQ.1))
     *         CATR(IAX) = 1.0
            IN = IN + 1
 200        CONTINUE
 210     CONTINUE

C                                       Correct for PDP 11 values.
C                                       set common values
      IF (FUCKUP) THEN
         DO 310 I = 3,7
            IDEPTH(I-2) = 1
            IF (I.GT.CATBLK(KIDIM)) GO TO 310
               IDEPTH(I-2) = CATR(KRCRP+I-1) + 0.5
               IDEPTH(I-2) = MAX (1, MIN (IDEPTH(I-2),
     *            CATBLK(KINAX+I-1)))
 310        CONTINUE
         LOCNUM = 1
         CALL SETLOC (IDEPTH, F)
C                                       do conversion
         IF ((ABS(POS11(1)-CATD(KDCRV+KLOCL(LOCNUM))).GE.
     *      ABS(0.01*CATR(KRCIC+KLOCL(LOCNUM)))) .OR.
     *      (ABS(POS11(2)-CATD(KDCRV+KLOCM(LOCNUM))).GE.
     *      ABS(0.01*CATR(KRCIC+KLOCM(LOCNUM))))) THEN
            CALL LMPIX (POS11(1), POS11(2), PIX11(1), PIX11(2))
            IF ((ABS(PIX11(1)-CATR(KRCRP+KLOCL(LOCNUM))).GE.
     *         CATBLK(KINAX+KLOCL(LOCNUM))/2) .OR.
     *         (ABS(PIX11(2)-CATR(KRCRP+KLOCM(LOCNUM))).GE.
     *         CATBLK(KINAX+KLOCM(LOCNUM))/2)) THEN
               WRITE (MSGTXT,1310) POS11
               CALL MSGWRT (6)
               WRITE (MSGTXT,1311) PIX11
               CALL MSGWRT (6)
            ELSE
               WRITE (MSGTXT,1320) CATR(KRCRP+KLOCL(LOCNUM)),
     *            CATR(KRCRP+KLOCM(LOCNUM)), PIX11
               CALL MSGWRT (3)
               CATR(KRCRP+KLOCL(LOCNUM)) = PIX11(1)
               CATD(KDCRV+KLOCL(LOCNUM)) = POS11(1)
               CATR(KRCRP+KLOCM(LOCNUM)) = PIX11(2)
               CATD(KDCRV+KLOCM(LOCNUM)) = POS11(2)
               END IF
            END IF
         END IF
      GO TO 999
C                                       No Data, no tables.
 980  WRITE (MSGTXT,1980)
C
 990  CALL MSGWRT (7)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MAP CREATE ERROR')
 1310 FORMAT ('PDP11/70 ERROR: PHASE REF. POS.',2E14.6)
 1311 FORMAT ('GIVES REF. PIXEL',2F9.2,' IGNORED')
 1320 FORMAT ('CORRECTING REF. PIXEL FROM',2F8.2,' TO',2F8.2)
 1980 FORMAT ('THIS FITS FILE HAS NEITHER DATA NOR TABLES')
      END
C
C
      SUBROUTINE IMREQC (FITBLK, ICARD, IERR)
C-----------------------------------------------------------------------
C   This routine will look for the required cards in a FIT header block
C   SIMPLE, BITPIX, NAXIS, NAXISn, and update a catalog header with the
C   information from these cards.
C   Inputs:
C      FITBLK  C*2880   a block of fit header data.
C   Outputs:
C      ICARD   I        The number of the last card parsed.
C      IERR    I        0=ok, 1=messed up. An error message will
C                                     be printed.
C   COMMON /MAPHDR/ Axis dimension information will be filled in.
C-----------------------------------------------------------------------
      INTEGER   ICARD, IERR
      CHARACTER FITBLK*2880
C
      CHARACTER SYMBOL*8, EXTEND*8, KL*80
      INTEGER   NPNT, ITYP, NAXIS, ITABNO, IVAL, IKEYWD, I, IAX
      LOGICAL   ISHIST, END
      DOUBLE PRECISION X
      INCLUDE 'FIT2A.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFUV.INC'
      INCLUDE 'INCS:VFUV.INC'
      DATA EXTEND /'EXTEND  '/
C-----------------------------------------------------------------------
C                                       Look for SIMPLE=T card
      I = NCT + NKT
      ICARD = 1
      IKEYWD = 1
      NPNT = 1
      CALL GETCRD (ICARD, 1, 1, CWORD(IKEYWD), FITBLK, NPNT, KL,
     *   SYMBOL, ITABNO, ISHIST, END, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GETLG (KL, 80, NPNT, ITYP)
C                                       Not .TRUE.
      IF (ITYP.NE.1) GO TO 940
C                                       Look for BITPIX.
      ICARD = ICARD + 1
      IKEYWD = IKEYWD + 1
      NPNT = 1
      CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GETCRD (ICARD, 1, 1, CWORD(IKEYWD), FITBLK, NPNT, KL,
     *   SYMBOL, ITABNO, ISHIST, END, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Check value of BITPIX
      CALL GETNUM (KL, 80, NPNT, X)
      IF (X.EQ.DBLANK) GO TO 975
      IF (X.GE.0.) IVAL = X + 0.1
      IF (X.LT.0.) IVAL = X - 0.1
      TAPEBP = IVAL
      IF ((IVAL.NE.8) .AND. (IVAL.NE.16) .AND. (IVAL.NE.32) .AND.
     *   (IVAL.NE.-32) .AND. (IVAL.NE.-64)) GO TO 950
      IF (IVAL.EQ.-64) THEN
         MSGTXT = 'WARNING: 64-bit input stored in 32 bits inside AIPS'
         CALL MSGWRT (6)
         END IF
C                                       Check NAXIS
      ICARD = ICARD + 1
      IKEYWD = IKEYWD + 1
      NPNT = 1
      CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GETCRD (ICARD, 1, 1, CWORD(IKEYWD), FITBLK, NPNT, KL,
     *   SYMBOL, ITABNO, ISHIST, END, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL GETNUM (KL, 80, NPNT, X)
      IF (X.EQ.DBLANK) GO TO 975
      NAXIS = X + .01
C
      IAX = KINAX
      CATBLK(KIDIM) = NAXIS
C                                       Check for invalid no. of axis
C                                       for our header.
      IF (NAXIS.GT.7) GO TO 960
      IF (NAXIS.LT.1) GO TO 40
C                                       Check NAXISm
         DO 30 I = 1,NAXIS
            ICARD = ICARD + 1
            IKEYWD = IKEYWD + 1
            NPNT = 1
            CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GETCRD (ICARD, 1, 1, CWORD(IKEYWD), FITBLK, NPNT,
     *         KL, SYMBOL, ITABNO, ISHIST, END, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL GETNUM (KL, 80, NPNT, X)
            IF (X.EQ.DBLANK) GO TO 975
            CATBLK(IAX) = X + .01
            IAX = IAX + 1
 30         CONTINUE
C                                       Look for EXTEND = T card.
 40   CONTINUE
      IF (CATBLK(KINAX).EQ.0) GO TO 930
      ICARD = ICARD + 1
      CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) GO TO 999
      NPNT = 1
      CALL GETCRD (ICARD, 1, 1, EXTEND, FITBLK, NPNT, KL,
     *   SYMBOL, ITABNO, ISHIST, END, ITYP)
      IF (END.OR.ISHIST.OR.(ITYP.NE.0)) GO TO 50
          CALL GETLG (KL, 80, NPNT, ITYP)
          IF (ITYP.NE.1) GO TO 50
          STDEXT = .TRUE.
          GO TO 999
 50   CONTINUE
C                                       No extensions
         ICARD = ICARD - 1
         STDEXT = .FALSE.
      GO TO 999
C                                       Probably a UV tape.
 930  WRITE (MSGTXT,1930)
      CALL MSGWRT (8)
C                                       Not SIMPLE FITS tape.
 940  WRITE (MSGTXT,1940)
      GO TO 980
C                                       Invalid bits per pixel value.
 950  WRITE (MSGTXT,1950) IVAL
      GO TO 980
C                                       Invalid number of axis.
 960  WRITE (MSGTXT,1960) NAXIS
      GO TO 980
C                                       Expected keyword not found.
 970  WRITE (MSGTXT,1970) CWORD(IKEYWD), SYMBOL
      GO TO 980
 975  MSGTXT = 'IMREQC: VALUE ERROR PARSING ' // SYMBOL
C                                       Print error message set flag.
 980  CALL MSGWRT (6)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1930 FORMAT ('THIS IS PROBABLY A UV DATA FILE THAT MUST BE READ WITH',
     *   ' UVLOD')
 1940 FORMAT ('NOT SIMPLE FITS TAPE. PROGRAM STOPPING.')
 1950 FORMAT ('INVALID BITS PER PIXEL =',I6)
 1960 FORMAT ('INVALID NUMBER OF AXIS =',I6)
 1970 FORMAT ('EXPECTED KEYWORD ',A8,'. FOUND ',A8,'.')
      END
C
      SUBROUTINE FITDAT (CELLX, CELLY, IER)
C-----------------------------------------------------------------------
C   FITDAT reads the input data file and scales the data to disk.
C   Inputs:
C      KVOL  I     desired map disk
C   Outputs:
C      IER   I     Error return:  0--> okay
C                                 1--> error condition
C-----------------------------------------------------------------------
C
      INTEGER  IX, IY, IND
      INTEGER   IER
C
      CHARACTER MNAME*48, CDECLS(5)*4, CHTM12*12
      INTEGER   BLKS, IERR, IWIN(4), NBKOF1, IOFF, NX, NY, IDEPTH(5),
     *   NBYB, I, INX, INY, IBL, ITEMP, NXY, I3, I3B, I4, I4B, I5, I5B,
     *   I6, I6B, I7, I7B, DLUN, NTAPVL, J, NDECLS, III, L0, L1,
     *   L2, NXX, OUTIND
      INCLUDE 'FIT2A.INC'
      INCLUDE 'CONFI.INC'
      REAL      BUFF(MABFSS), MMAX, MMIN, INBUFR(MABFSS), XT, YT,
     *   CELLX, CELLY
      DOUBLE PRECISION    BSC, BZE, DPBUFR(MABFSS/2), DTEMP
      LOGICAL   T, BACK, WASBLK
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (INBUFR(1), INBUFF(1), DPBUFR(1))
      DATA T /.TRUE./
      DATA NDECLS, CDECLS /5, 'DEC ', 'DEC-', 'MM  ', 'GLAT', 'ELAT'/
C-----------------------------------------------------------------------
      DLUN = 16
      MMAX = -1.E20
      MMIN =  -MMAX
      WASBLK = .FALSE.
      IF (IERR.EQ.0) GO TO 5
         WRITE (MSGTXT,1000) MNAME, IERR
         GO TO 980
C                                       Initialize
 5    IER = 0
      BSC = SCALE
      IF (BSC.EQ.0.0D0) BSC = 1.0D0
      BZE = OFFSET
      NBYB = MABFSS * 2
C                                       second axis backwards?
      BACK = .FALSE.
      IF (CATR(KRCIC+1).GE.0.0) GO TO 10
         J = KHCTP + 2
         DO 6 I = 1,NDECLS
            CALL H2CHR (4, 1, CATH(J), CHTM12)
            BACK = CHTM12(1:4) .EQ. CDECLS(I)(1:4)
            IF (BACK) GO TO 8
  6         CONTINUE
         GO TO 10
  8      CONTINUE
            CATR(KRCIC+1) = -CATR(KRCIC+1)
            CATR(KRCRP+1) = CATBLK(KINAX+1) + 1 - CATR(KRCRP+1)
C                                       Set window parms
 10   I3B = MAX (1, CATBLK(KINAX+2))
      I4B = MAX (1, CATBLK(KINAX+3))
      I5B = MAX (1, CATBLK(KINAX+4))
      I6B = MAX (1, CATBLK(KINAX+5))
      I7B = MAX (1, CATBLK(KINAX+6))
      IWIN(1) = 1
      IWIN(2) = 1
      IWIN(3) = CATBLK(KINAX)
      IWIN(4) = CATBLK(KINAX+1)
      NY = IWIN(4)
      NX = IWIN(3)
      INX = CATBLK(KINAX)
      INY = CATBLK(KINAX+1)
      IF (.NOT.BACK) GO TO 20
         IWIN(2) = NY
         IWIN(4) = 1
C                                       Initialize tape
 20   NBPIX = TAPEBP
      BLKS = (ABS(NBPIX) / 8)
      NTAPVL = 2880 / BLKS
      IOFF = NTAPVL
      BLKS = BLKS * NX * NY * I3B
      BLKS = BLKS * I4B * I5B * I6B * I7B
      BLKS = (BLKS - 1) / 2880 + 1
      BLKS = BLKS - 1
      IF (IERR.NE.0) GO TO 970
C                                       Test for Kitt Peak "error"
      IF ((IBLNK.EQ.0) .AND. (NBPIX.EQ.8)) ISBLNK = .FALSE.
      DO 200 I7 = 1,I7B
      DO 199 I6 = 1,I6B
      DO 198 I5 = 1,I5B
      DO 197 I4 = 1,I4B
      DO 196 I3 = 1,I3B
C                                       Initialize disk
         IDEPTH(1) = I3
         IDEPTH(2) = I4
         IDEPTH(3) = I5
         IDEPTH(4) = I6
         IDEPTH(5) = I7
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH, NBKOF1,
     *      IERR)
         IF (IERR.NE.0) GO TO 990
         NBKOF1 = NBKOF1 + 1
C         CALL MINIT ('WRIT', DLUN, DIND, INX, INY, IWIN, BUFF, NBYB,
C     *      NBKOF1, IERR)
         IF (IERR.EQ.0) GO TO 30
            WRITE (MSGTXT,1020) IERR
            GO TO 980
   30    CONTINUE
C
         NBAD = 0
C                                       Begin read/write loop
         DO 195 I = 1,NY
            NXY = NX
            IBL = 0
C                                       Copy and read until entire map
C                                       row filled.
 55         NXX = MIN (NXY, NTAPVL-IOFF)
C                                       Need more tape values.
               IF (NXX.GT.0) GO TO 60
                  BLKS = BLKS - 1
                  CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
                  IOFF = 0
                  IF (NBPIX.EQ.8) CALL ZI8IL (NTAPVL, 1,
     *               TAPBUF(TBIND), INBUFF)
                  IF (NBPIX.EQ.16) CALL ZI16IL (NTAPVL, 1,
     *               TAPBUF(TBIND), INBUFF)
                  IF (NBPIX.EQ.32) CALL ZI32IL (NTAPVL, 1,
     *               TAPBUF(TBIND), INBUFF)
                  IF (NBPIX.EQ.-32) CALL ZR32RL (NTAPVL, 1,
     *               TAPBUF(TBIND), INBUFF)
                  IF (NBPIX.EQ.-64) CALL ZR64RL (NTAPVL, 1,
     *               TAPBUF(TBIND), INBUFF)
                  IF (IERR.EQ.0) GO TO 55
                     GO TO 970
C                                       INT in: copy convert max/min
 60            IF ((NBPIX.EQ.8) .OR. (NBPIX.EQ.16) .OR. (NBPIX.EQ.32))
     *            THEN
                  L0 = IOFF
                  L2 = OUTIND + IBL - 1
                  IF (ISBLNK) THEN
                     DO 100 III = 1,NXX
                        L1 = L2 + III
                        ITEMP = INBUFF(L0+III)
C                                       Blank pixel found
                        IF (ITEMP.EQ.IBLNK) THEN
                           BUFF(L1) = FBLANK
                           WASBLK = .TRUE.
C                                       scale
                        ELSE
                           BUFF(L1) = BSC * ITEMP + BZE
                           MMIN = MIN (MMIN, BUFF(L1))
                           MMAX = MAX (MMAX, BUFF(L1))
                           END IF
 100                    CONTINUE
                  ELSE
                     DO 115 III = 1,NXX
                        L1 = L2 + III
                        BUFF(L1) = BSC * INBUFF(L0+III) + BZE
                        MMIN = MIN (MMIN, BUFF(L1))
                        MMAX = MAX (MMAX, BUFF(L1))
 115                    CONTINUE
                     END IF
                  GO TO 190
C                                       IEEE 64-bit in
               ELSE IF (NBPIX.EQ.-64) THEN
                  L0 = IOFF
                  L2 = OUTIND + IBL - 1
                  DO 150 III = 1,NXX
                     L1 = L2 + III
                     DTEMP = DPBUFR(L0+III)
                     IF (DTEMP.EQ.DBLANK) THEN
                        WASBLK = .TRUE.
                        BUFF(L1) = FBLANK
                     ELSE
                        BUFF(L1) = BSC * DTEMP + BZE
                        MMIN = MIN (MMIN, BUFF(L1))
                        MMAX = MAX (MMAX, BUFF(L1))
                        END IF
 150                 CONTINUE
C                                       IEEE 32-bit in
               ELSE
                  L0 = IOFF
                  L2 = OUTIND + IBL - 1
                  DO 160 III = 1,NXX
                     L1 = L2 + III
                     BUFF(L1) = INBUFR(L0+III)
                     IF (BUFF(L1).EQ.FBLANK) THEN
                        WASBLK = .TRUE.
                     ELSE
                        BUFF(L1) = BSC * BUFF(L1) + BZE
                        MMIN = MIN (MMIN, BUFF(L1))
                        MMAX = MAX (MMAX, BUFF(L1))
                        END IF
 160                 CONTINUE
                  END IF
C                                       Up the counters
 190           IBL = IBL + NXX
               IOFF = IOFF + NXX
               NXY = NXY - NXX
C                                       loop back if needed to finish
               IF (NXY.GT.0) GO TO 55
C---------------------------------------------------------
C                                       new card to read the fits file
            IY = I
            DO 170 IX = 1, NX
               XT = (IX - 1) * CELLX
               YT = (IY - 1) * CELLY
C                                       take the point inside of BLC,
C                                       TRC
               IF (XT.LT.XBLCC) THEN
                  GO TO 170
               ELSE
                  IF (XT.LT.XTRCC) THEN
                     IF (YT.LT.YBLCC .OR. YT.GT.YTRCC) GO TO 170
                  ELSE
                     GO TO 180
                     END IF
                  END IF

               XMAX = MAX(XMAX, XT)
               XMIN = MIN(XMIN, XT)
               YMAX = MAX(YMAX, YT)
               YMIN = MIN(YMIN, YT)


               IND = BUFF (IX + OUTIND - 1) + 0.01
C                                       select bad (restricted) points
C                                       corresponded to 1 (.NE. 0)
               IF (IND .NE. 0) THEN
                  NBAD = NBAD + 1
                  IF (NBAD .GT. MXMASK) THEN
                     IERR = 5
                     WRITE (MSGTXT,1040) MXMASK
                     GO TO 980
                     END IF
                  XBAD(NBAD) = XT
                  YBAD(NBAD) = YT
                  END IF
  170          CONTINUE
  180 CONTINUE
C
 195         CONTINUE
C
 196     CONTINUE
 197     CONTINUE
 198     CONTINUE
 199     CONTINUE
 200     CONTINUE
C                                       close files
      CATR(KRDMX) = MMAX
      CATR(KRDMN) = MMIN
      CATR(KRBLK) = 0.0
      IF (WASBLK) CATR(KRBLK) = FBLANK
      NCFILE = NCFILE - 1
      GO TO 999
C                                       Error
 970  WRITE (MSGTXT,1970) IERR
 980  CALL MSGWRT (8)
      IF (IERR.EQ.4) THEN
         WRITE (MSGTXT,1980)
         CALL MSGWRT(8)
         END IF
 990  IER = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FITDAT: COULD NOT OPEN MAP ',6A4,' IER=',I4)
 1020 FORMAT ('FITDAT: COULD NOT INITIALIZE DISK FILE.  IER=',I4)
 1040 FORMAT ('!Number of restricted pixels at the mask',
     *   ' exceeds limit', I8)
 1970 FORMAT ('FITDAT: COULD NOT READ INPUT.  IER=',I4)
 1980 FORMAT ('FITDAT: - MAYBE PREMATURE END OF FILE?  CHECK FILE SIZE')
      END
C
      SUBROUTINE IMPARS (ICARD, FITBLK, ISHIST, END, IERR)
C-----------------------------------------------------------------------
C   IMPARS (parse FITS card) will unpack and interpret a card image
C   from a block of FITS data and put that data into the internal AIPS
C   header.
C   Inputs:
C      ICARD   I         The card number (1-36) in block to interpret.
C      FITBLK  C*2880    A block of FITS header data.
C   Outputs:
C      ISHIST  L         True iff a history card
C      END     L         True if end card found, else false.
C      IERR    I         error code 0=ok. 1=error, -1 => special header
C   COMMON /MAPHDR/
C   COMMON /FITINF/
C-----------------------------------------------------------------------
      INTEGER   ICARD, IERR
      LOGICAL   ISHIST, END
      CHARACTER FITBLK*2880
C
      CHARACTER SYMBOL*8, STR*68, KL*80
      DOUBLE PRECISION X
      REAL      VAL
      LOGICAL   LHIST, FIRST
      INTEGER   KPNTR(65), PNTR, IPOFF, TABNO, NPNT, KT, IL, IVAL,
     *   NCHAR, NBYT, NN, NNSTR, NPNTS
      INCLUDE 'FIT2A.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIT.INC'
      EQUIVALENCE (KPNTR(1), KHOBJ)
      INCLUDE 'INCS:VFIT.INC'
C-----------------------------------------------------------------------
C                                       Find next symbol on the card
C                                       and look for it in the table.
      NPNT = 1
      NN = NKT + NCT
      NNSTR = NCT + 1
C                                       Loop for all possible values
C                                       on an AIPS HISTORY card.
      FIRST = .TRUE.
 10   CONTINUE
      CALL GETCRD (ICARD, NN, NNSTR, AWORD, FITBLK, NPNT, KL, SYMBOL,
     *    TABNO, LHIST, END, IERR)
      IF (END) GO TO 999
      IF (IERR.NE.0) GO TO 999
      IF (FIRST) ISHIST = LHIST
C      IF ((ISHIST) .AND. (XERR4.GT.1.5)) GO TO 999
      FIRST = .FALSE.
C                                       Header pointer for this
C                                       keyword, number bytes and
C                                       offset position from pointer
      PNTR = MOD (APOINT(TABNO), 1000)
      IPOFF = PNTR / 100
      PNTR = MOD (PNTR, 100)
      IF (PNTR.GT.0) PNTR = KPNTR(PNTR)
      NBYT = APOINT(TABNO) / 1000
C                                       Type value of keyword
C                                       1=LOGICAL
C                                       2=NUMBER
C                                       3=STRING
      KT = ATYPE(TABNO)
      NPNTS = NPNT
      GO TO (100, 200, 300), KT
C                                       Logical value
 100     CALL GETLG (KL, 80, NPNT, IL)
C                                       Illegal logical value.
         IF (IL.GE.0) GO TO 110
            WRITE (MSGTXT,1100) SYMBOL
            GO TO 990
C                                       Logical value special cases.
 110     CONTINUE
C                                       Handle normal logical cases.
         CATBLK(PNTR+IPOFF) = IL
         GO TO 400
C                                       Number
 200     CALL GETNUM (KL, 80, NPNT, X)
C                                       special parse for EQUINOX
         IF (X.EQ.DBLANK) THEN
            IF ((AWORD(TABNO).EQ.'EQUINOX') .OR.
     *         (AWORD(TABNO).EQ.'EPOCH')) THEN
               NPNT = NPNTS
               CALL GETSTR (KL, 80, 68, NPNT, STR, NCHAR)
               IF (INDEX(STR,'1950').GT.0) THEN
                  X = 1950.0D0
               ELSE IF (INDEX(STR,'2000').GT.0) THEN
                  X = 2000.0D0
                  END IF
               END IF
            END IF
         IF (X.EQ.DBLANK) GO TO 975
C                                       Check for number special cases.
C                                       Blank pixel value.
         IF (AWORD(TABNO).NE.'BLANK') GO TO 220
            IF (X.EQ.-2147483648.0D0) THEN
               IBLNK = -2147483647 - 1
            ELSE
               IBLNK = X
               END IF
            ISBLNK = .TRUE.
            GO TO 400
C                                       PDP 11 Stuff
 220     IF ((AWORD(TABNO).NE.'OPHRAE11') .AND.
     *      (AWORD(TABNO).NE.'OPHDCE11')) GO TO 230
            POS11(IPOFF) = X
            FUCKUP = .TRUE.
            GO TO 400
C                                       Handle normal cases. Put value
C                                       into proper header slot.
C                                       2-byte integer
 230     IF (NBYT.NE.2) GO TO 240
            IVAL = X + SIGN (0.5D0, X)
            IF (PNTR.GT.0) THEN
               CATBLK(PNTR+IPOFF) = IVAL
            ELSE
               IF (AWORD(TABNO).EQ.'BITPIX') TAPEBP = IVAL
               IF (AWORD(TABNO).EQ.'TABLES') TABLES = IVAL
               END IF
            GO TO 400
C                                       4-byte real
 240     IF (NBYT.NE.4) GO TO 250
            IF ((AWORD(TABNO) .EQ. 'HISTORY') .AND. (X .GT. 1.0E30))
     *         X = 1.0E30
            VAL = X
            IF (PNTR.GT.0) CATR(PNTR+IPOFF) = VAL
            GO TO 400
C                                       8-byte real
 250     IF (NBYT.NE.8) GO TO 400
            IF (PNTR.GT.0) THEN
               CATD(PNTR+IPOFF) = X
            ELSE
               IF (AWORD(TABNO).EQ.'BSCALE') SCALE = X
               IF (AWORD(TABNO).EQ.'ISCALE') ISCALE = X
               IF (AWORD(TABNO).EQ.'BZERO') OFFSET = X
               IF (AWORD(TABNO).EQ.'IZERO') IZERO = X
               END IF
            GO TO 400
C                                       String
 300     CALL GETSTR (KL, 80, 68, NPNT, STR, NCHAR)
C                                       Dates are special
         IF (AWORD(TABNO)(:4).EQ.'DATE') THEN
            CALL DATFST ('F2L', STR)
            NCHAR = 8
            END IF
         NCHAR = MIN (NBYT, NCHAR)
C                                       Start string on integer boundary
C                                       IMCLASS
         IF (AWORD(TABNO).NE.'IMCLASS') GO TO 320
            IPOFF = NBYT * IPOFF + 1
            CALL CHFILL (NBYT, HBLANK, IPOFF, CATH(PNTR))
            CALL CHR2H (NCHAR, STR, IPOFF, CATH(PNTR))
            GO TO 400
C                                       Start string on real boundary.
 320     IPOFF = (NBYT / 4) * IPOFF
            CALL CHFILL (NBYT, HBLANK, 1, CATH(PNTR+IPOFF))
            CALL CHR2H (NCHAR, STR, 1, CATH(PNTR+IPOFF))
C
C                                       If this is a history card, look
C                                       for more values.
 400     IF (ISHIST) GO TO 10
         GO TO 999
C
 975  MSGTXT = 'IMPARS: NUMBER VALUE ERROR ON ' // SYMBOL
C                                       Error message
 990  CALL MSGWRT (7)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT (2A4,'LOGICAL VARIABLE HAS ILLEGAL VALUE')
      END
C
      SUBROUTINE FILFIT (I2FILE, DOFITS)
C-----------------------------------------------------------------------
C   FILFIT reads the input name I2FILE, and determines if the sequence of
C                                       the characters 'FITS' appears in
C                                       the name.
C
C   Inputs:  I2FILE      C*48 input name
C
C   Outputs: DOFITS      L  'FITS' appears in I2FILE => DOFITS= .TRUE.
C                           ELSE DOFITS = .FALSE.
C-----------------------------------------------------------------------
      CHARACTER   I2FILE*48
      LOGICAL     DOFITS
      INTEGER     I
C-----------------------------------------------------------------------
      DOFITS = .FALSE.
      I = 1
    5 CONTINUE
      IF (I2FILE(I:I+3).EQ.'FITS') THEN
         DOFITS = .TRUE.
         GO TO 999
      ELSE
         I = I + 1
         IF (I .LE. 45) GO TO 5
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
      END

      SUBROUTINE YALUCT (OP, ARMODE, BFUNC, NFUNC, CONSTS, OUTSEL,
     *   EXTOFM, ESHIFT, SHIFT, CARYIN, CARRY, EQUAL, IERR)
C-----------------------------------------------------------------------
C! drives the TV arithmetic logic unit - not to be used much
C# Y2 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YALUCT reads / writes the TV arithmetic logic unit control
C   registers.  The actual feedback-ALU computation is performed only
C   upon a call to YFDBCK.
C   Inputs:
C      OP      C*4     'READ' from TV or 'WRIT' to TV
C   In/Out:
C      ARMODE  L       T => arithmetic mode F => logic mode
C      BFUNC   I       function number (1-16) in blotch
C      NFUNC   I       function number (1-16) outside blotch
C      CONSTS  I(8)    constant array (may select as ALU output)
C      OUTSEL  I(8)    lookup table selects output based on carry
C                      (lsb), equal, ROI (msb) input. values -
C                      0 - 7 : constants 1 - 8
C                      8     : accumulator channel pair
C                      9     : selected OFM
C                      10    : ALU
C                      11    : external
C      EXTOFM  L       T => extend sign of OFM on input to ALU
C      ESHIFT  L       T => extend sign of ALU output if SHIFT
C      SHIFT   L       T => right shift ALU output
C      CARYIN  L       T => add one to arithmetic results
C   Output:
C      CARRY   L       T => carry condition occurred in frame
C      EQUAL   L       T => equal condition occurred in frame
C      IERR    I       error code of Z...XF : 0 - ok
C                                             2 - input error
C   NO TV ALU VERSION - this is a IIS M70 function level 2
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   BFUNC, NFUNC, CONSTS(8), OUTSEL(8), IERR
      LOGICAL   ARMODE, EXTOFM, ESHIFT, SHIFT, CARYIN, CARRY, EQUAL
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'THERE IS NO TV ALU CONFIGURED'
      CALL MSGWRT (8)
C
 999  RETURN
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER   NPARMS
C                                       NPARMS=no. adverbs passed.
      PARAMETER (NPARMS=14)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                                       NOTE: Uses values in PAOOF.INC
C                                       Adverb names
C                     1         2          3        4         5
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INVERS',
C           6          7      8      9           10          11
     *   'OUTVERS', 'BIF', 'EIF', 'TIMERANG', 'SUBARRAY', 'FREQID',
C           12        13       14
     *   'OPTYPE', 'PRTLEV', 'APARM'/
C                                       Adverb data types (PAOOF.INC)
C                    1       2       3       4       5
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOAINT,
C          6       7       8       9      10      11
     *   OOAINT, OOAINT, OOAINT, OOARE, OOAINT, OOAINT,
c          12      13      14
     *   OOACAR, OOAINT, OOARE/
C                                       Adverb dimensions (as 2D)
C                   1    2    3    4    5
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 1,1,
C         6    7    8    9    10   11
     *   1,1, 1,1, 1,1, 8,1, 1,1, 1,1,
C         12    13    14
     *   4,1,  1,1, 10,1 /
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(14)
      LOGICAL   LDUM(14)
      REAL      RDUM(14)
      DOUBLE PRECISION DDUM(7)
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
      COMMON /MBDLYG/ DDUM
LOCAL END
      PROGRAM MBDLY
C-----------------------------------------------------------------------
C! Fits multiband delays from IF phases, updates SN table
C# Calibration VLBI OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2004-2006, 2009, 2012, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Fits multiband delays from IF phases, updates SN table
C      April 2002: Does not change SN table phases.
C      June 2003:  Does not blank out 'bad' data (APARM(7) > 0);
C                  Puts bad quality code into Node Number column
C                     of SN table.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, INTAB*36, OUTTAB*36
      INTEGER   IRET, BUFF1(256)
      DATA PRGM /'MBDLY '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL MBDIN (PRGM, INTAB, OUTTAB, IRET)
C                                       Process table
      IF (IRET.EQ.0) CALL MBDELY (INTAB, OUTTAB, IRET)
C                                       History
      IF (IRET.EQ.0) CALL MBDHI (OUTTAB)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE MBDIN (PRGN, INTAB, OUTTAB, IRET)
C-----------------------------------------------------------------------
C   MBDIN gets input parameters for MBDLY and creates the input and
C   output objects
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6, INTAB*36, OUTTAB*36
C
      INTEGER   NKEY1, NKEY2
C                                       NKEY1=no. adverbs to copy to
C                                       INTAB
      PARAMETER (NKEY1=13)
C                                       NKEY2=no. adverbs to copy to
C                                       OUTTAB
      PARAMETER (NKEY2=5)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32
      INTEGER   DIM(3)
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to INTAB
C                   1         2          3        4         5
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INVERS',
C           6      7      8           9           10        11
     *   'BIF', 'EIF', 'TIMERANG', 'SUBARRAY', 'FREQID', 'PRTLEV',
C           12       13
     *   'APARM', 'OPTYPE'/
C                                       May rename adverbs to INTAB
C                    1       2        3        4       5
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'VER',
C           6      7      8        9           10        11
     *   'BIF', 'EIF', 'TIMER', 'SUBARRAY', 'FREQID', 'PRTLEV',
C           12       13
     *   'APARM', 'OPTYPE'/
C                                       Adverbs to copy to OUTTAB
C                   1         2          3        4         5
      DATA INK2 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'OUTVERS'/
C                                       May rename adverbs to OUTTAB
C                    1       2        3        4       5
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'VER'/
C-----------------------------------------------------------------------
C                                       Startup,  returns "Input" object
C                                       containing POPS adverbs
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create input object
      INTAB = 'Input table'
      CALL CREATE (INTAB, 'TABLE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, INTAB, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Table type
      DIM(1) = 2
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (INTAB, 'TBLTYPE', OOACAR, DIM, IDUM, 'SN', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create Output Object
      OUTTAB = 'Output table'
      CALL CREATE (OUTTAB, 'TABLE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, OUTTAB, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Table type
      CALL OPUT (OUTTAB, 'TBLTYPE', OOACAR, DIM, IDUM, 'SN', IRET)
      IF (IRET.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE MBDHI (OUTTAB)
C-----------------------------------------------------------------------
C   Routine to write history file to output table object.  This assumes
C   that a previous history exists and merely adds the information from
C   the current task.
C   Inputs:
C      OUTTAB  C*?  Output table object
C-----------------------------------------------------------------------
      CHARACTER OUTTAB*(*)
C
      INTEGER   NADV
      PARAMETER (NADV=6)
      CHARACTER LIST(NADV)*8
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'INVERS', 'OUTVERS',
     *   'APARM'/
C-----------------------------------------------------------------------
C                                       Add task label to history
      CALL OHTIME (OUTTAB, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy adverb values.
      CALL OHLIST ('Input', LIST, NADV, OUTTAB, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // OUTTAB
      CALL MSGWRT (4)
 999  RETURN
      END
      SUBROUTINE MBDELY (INTAB, OUTTAB, IERR)
C-----------------------------------------------------------------------
C   Fit multiband delays, average rates and write corrected SN table.
C   Inputs:
C      INTAB   C*   Name of input table object.
C      OUTTAB  C*   Name of output table object.
C   Inputs from INTAB:
C      APARM   R(10) Editing control paramaters
C                     (1) = min SNR
C                     (2) = max rate rms (sigma)
C                     (3) = max phase rms (sigma)
C                     (4) = min. no. IFs.
C                     (5) = set scan average phase = 0?
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*), OUTTAB*(*)
      INTEGER   IERR
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER ANAME(MAXANT)*8, CDUMMY*1, OPTYPE*4
      INTEGER   IROW, OROW, NUMANT, NUMPOL, NUMIF, NUMNOD, I, SOURID,
     *   ANTNO, SUBA, FREQID, NODENO, REFA(2,MAXIF), ISBAND(MAXIF),
     *   TYPE, DIM(3), NROW, PRTLEV, MINIF, FLGMIF, FLGSNR, FLGRAS,
     *   FLGPHS, IP, IF, NTOTAL, NALL, BAD(2), FQID, ISUBA, BADIF(2),
     *   BADSNR(2), BADFAZ(2), BADRAT(2), PASBAD, MSGSAV, J
      LOGICAL   ISAPPL, SSF
      REAL      GMMOD, RANOD(25), DECNOD(25), TIMEI, IFR, MBDEL(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF),
     *   WEIGHT(2,MAXIF), FINC(MAXIF), MINSNR, MAXRAS, MAXPHS, AVGPHS,
     *   DISP(2), DDISP(2), DISPRM(3)
      DOUBLE PRECISION TIME, FRQTAB(MAXIF), FRQTAZ(MAXIF), LAM, X,
     *   SUMX, SUMXX, SUML, SUMLX, TIMD, REFREQ, REFREZ, FACTM(MAXIF),
     *   FACTP(MAXIF)
      DOUBLE PRECISION TSTART, TSTOP
      INTEGER  NSOUR
      CHARACTER*8 SNAME(400), BNDCOD(MAXIF)
      CHARACTER*12  FNAME
      INTEGER   BIF, EIF, NCHAN
      REAL      MAXMBD, REFP
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       Open input table
      CALL OSNINI (INTAB, 'READ', IROW, NUMANT, NUMPOL, NUMIF, NUMNOD,
     *   GMMOD, RANOD, DECNOD, ISAPPL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open output table
      CALL OSNINI (OUTTAB, 'WRIT', OROW, NUMANT, NUMPOL, NUMIF, NUMNOD,
     *   GMMOD, RANOD, DECNOD, ISAPPL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get editing control parameters
      CALL GETEDT (INTAB, MINSNR, MAXRAS, MAXPHS, MAXMBD, AVGPHS, MINIF,
     *   PASBAD, DISPRM, TSTART, TSTOP, IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (MSGTXT,1021) MINSNR
      CALL MSGWRT (4)
      WRITE (MSGTXT,1022) MAXRAS, MAXPHS
      CALL MSGWRT (4)
      WRITE (MSGTXT,1023) MAXMBD
      CALL MSGWRT (4)
C                                       get operation type
      CALL OGET (INTAB, 'OPTYPE', TYPE, DIM, IDUM, OPTYPE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get print level
      CALL OGET (INTAB, 'PRTLEV', TYPE, DIM, IDUM, CDUMMY, IERR)
      PRTLEV = IDUM(1)
      IF (IERR.NE.0) GO TO 999
C                                       Get number of entries
      CALL OGET (INTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IERR)
      NROW = IDUM(1)
      IF (IERR.NE.0) GO TO 999
C                                       Get subarray number
      CALL OGET (INTAB, 'SUBARRAY', TYPE, DIM, IDUM, CDUMMY, IERR)
      ISUBA = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      IF (ISUBA.LT.0) ISUBA = 0
C                                       Get freqid number
      CALL OGET (INTAB, 'FREQID', TYPE, DIM, IDUM, CDUMMY, IERR)
      FQID = IDUM(1)

      IF (IERR.NE.0) GO TO 999
      IF (FQID.LT.0) FQID = 0
C                                       Get frequency info
      CALL OCHNDA (INTAB, 'READ', NUMIF, FRQTAZ, ISBAND, FINC, BNDCOD,
     *   FQID, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get antenna info (esp. ref.
C                                       freq.)
      CALL ANTIFO (INTAB, ISUBA, ANAME, REFREZ, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Do NOT depend on antenna table
      CALL OBHGET (INTAB, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL UVPGET (IERR)
      REFREZ = FREQ
      REFP = CATR(KRCRP+JLOCF)
      NCHAN = CATBLK(KINAX+JLOCF)
C                                       Get source names
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL SUINFO (INTAB, ISUBA, NSOUR, SNAME, SSF, IERR)
      MSGSUP = MSGSAV
      IF (IERR.NE.0) GO TO 999
C                                       For SSF, get file name
      IF (SSF) THEN
         CALL OGET (INTAB, 'NAME', TYPE, DIM, IDUM, FNAME, IERR)
         IF (IERR.NE.0) GO TO 999
         SNAME(1) = FNAME(1:8)
         END IF
C                                       Get IF's to use in fit
      CALL OGET (INTAB, 'BIF', TYPE, DIM, IDUM, CDUMMY, IERR)
      BIF = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'EIF', TYPE, DIM, IDUM, CDUMMY, IERR)
      EIF = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      IF (BIF.LE.0) BIF = 1
      IF (EIF.LE.0) EIF = NUMIF
      I = EIF - BIF + 1
      IF ((MINIF.EQ.0) .OR. (MINIF.GT.I)) MINIF = I
      WRITE (MSGTXT,1030) BIF, EIF, MINIF
      CALL MSGWRT (4)
C                                       Determine Frequencies used
      REFREQ = REFREZ + FRQTAZ(BIF)
      WRITE (MSGTXT,1033) REFREQ / 1.0D6, FQID, ISUBA
      CALL MSGWRT (4)
      DO 50 I = BIF,EIF
         FRQTAB(I) = FRQTAZ(I) - FRQTAZ(BIF)
         WRITE (MSGTXT,1034) I, FRQTAB(I)/1.D6
         CALL MSGWRT (4)
         SUMX = 0.0D0
         SUMXX = 0.0D0
         SUML = 0.0D0
         SUMLX = 0.0D0
         DO 40 J = 1,NCHAN
            X = (J-REFP)*FINC(I)
            LAM = VELITE / (REFREQ + FRQTAB(I) + X)
            SUMX = SUMX + X
            SUMXX = SUMXX + X * X
            SUML = SUML + LAM
            SUMLX = SUMLX + LAM * X
 40         CONTINUE
         X = NCHAN * SUMXX - SUMX * SUMX
         FACTM(I) = VELITE * (NCHAN * SUMLX - SUMX * SUML) / X
         FACTP(I) = (SUMXX * SUML - SUMX * SUMLX) / X
 50      CONTINUE
C                                       Keep track of flagging
      FLGMIF = 0
      FLGSNR = 0
      FLGRAS = 0
      FLGPHS = 0
      NTOTAL = 0
      NALL   = 0
C                                       Process table
      DO 100 I = 1,NROW
         IROW = I
C                                       Read
         CALL OTABSN (INTAB, 'READ', IROW, NUMPOL, TIME, TIMEI, SOURID,
     *      ANTNO, SUBA, FREQID, IFR, NODENO, MBDEL, DISP, DDISP, CREAL,
     *      CIMAG, DELAY, RATE, WEIGHT, REFA, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.NE.0) GO TO 999
C                                       Check time range
         IF (TIME.LT.TSTART) GO TO 100
         IF (TIME.GT.TSTOP) GO TO 900
         TIMD = TIME * 360.0D0
C                                       Check subarray
         IF ((SUBA.NE.ISUBA) .AND. (SUBA.NE.0).AND.
     *        (ISUBA.NE.0)) GO TO 100
C                                       Check FQID
         IF ((FREQID.NE.FQID) .AND. (FREQID.NE.0).AND.
     *       (FQID.NE.0)) GO TO 100
C                                       Average Rates and filter
         CALL AVRATE (NUMIF, MINIF, BIF, EIF, MINSNR, MAXRAS, ANTNO,
     *      REFA, NUMPOL, TIMEI, REFREQ, RATE, WEIGHT, BAD, BADIF,
     *      BADSNR, BADRAT, FLGMIF, FLGSNR, FLGRAS)
C                                       fit delay for dispersion
         IF (OPTYPE.EQ.'DISP') THEN
            CALL DELAMB (NUMIF, SSF, NUMPOL, FACTM, FACTP, CREAL, CIMAG,
     *         DELAY, WEIGHT, REFA, MBDEL, DISP, TIMD, ANTNO, RATE,
     *         DISPRM, NTOTAL, NALL, SOURID, SNAME)
C                                       Fit MB delays
         ELSE
            CALL GETMB (NUMIF, SSF, MAXPHS, MAXMBD, AVGPHS, NUMPOL,
     *         FRQTAB, CREAL, CIMAG, DELAY, WEIGHT, REFA, PRTLEV, MBDEL,
     *         BAD, BADFAZ, FLGPHS, TIMD, ANTNO, RATE, NTOTAL, NALL,
     *         SOURID, SNAME)
            END IF
C                                       Pass bad: Assign quality code + 10
         IF (PASBAD.GE.1) THEN
            IF (BADSNR(1).GE.1) NODENO = 17
            IF (BADRAT(1).GE.1) NODENO = 16
            IF (BADFAZ(1).GE.1) NODENO = 15
            IF (BADIF(1) .GE.1) NODENO = 10
C                                       If BAD flag MB delays
         ELSE
            IF (BAD(1).GT.0) MBDEL(1) = FBLANK
            IF (BAD(2).GT.0) MBDEL(2) = FBLANK
            IF (BAD(1).GT.0) DISP(1) = FBLANK
            IF (BAD(2).GT.0) DISP(2) = FBLANK
            IF (BAD(1).GT.0) DDISP(1) = FBLANK
            IF (BAD(2).GT.0) DDISP(2) = FBLANK
            DO 90 IP = 1,NUMPOL
               IF (MBDEL(IP).EQ.FBLANK) THEN
                  DO 80 IF = 1, NUMIF
                     CREAL(IP,IF) = FBLANK
                     CIMAG(IP,IF) = FBLANK
 80                  CONTINUE
                  END IF
 90            CONTINUE
            END IF
C                                       Write
         CALL OTABSN (OUTTAB, 'WRIT', OROW, NUMPOL, TIME, TIMEI, SOURID,
     *      ANTNO, SUBA, FREQID, IFR, NODENO, MBDEL, DISP, DDISP, CREAL,
     *      CIMAG, DELAY, RATE, WEIGHT, REFA, IERR)
         IF (IERR.NE.0) GO TO 999
 100     CONTINUE
C                                       Close tables
 900  CALL OCLOSE (INTAB, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OCLOSE (OUTTAB, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Processed fits
      WRITE (MSGTXT,1098) NALL
      CALL MSGWRT (4)
      WRITE (MSGTXT,1099) NTOTAL
      CALL MSGWRT (4)
C                                       Flagging summary
C                                       Min IF.
      IF (FLGMIF.GT.0) THEN
         WRITE (MSGTXT,1100) FLGMIF, MINIF
         CALL MSGWRT (4)
         END IF
C                                       Min. SNR
      IF (FLGSNR.GT.0) THEN
         WRITE (MSGTXT,1101) FLGSNR, MINSNR
         CALL MSGWRT (4)
         END IF
C                                       Max. rate scatter
      IF (FLGRAS.GT.0) THEN
         WRITE (MSGTXT,1102) FLGRAS, MAXRAS
         CALL MSGWRT (4)
         END IF
C                                       Max. phase scatter
      IF (FLGPHS.GT.0) THEN
         WRITE (MSGTXT,1103) FLGPHS, MAXPHS
         CALL MSGWRT (4)
         END IF
C                                       Phase centering
      IF (AVGPHS.EQ.0.0) THEN
         WRITE (MSGTXT,1104)
         CALL MSGWRT (4)
      ELSE
         WRITE (MSGTXT,1105)
         CALL MSGWRT (4)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1021 FORMAT ('SNRmin=', F7.1)
 1022 FORMAT ('Rate rms (deg) =',F6.1,'  MBD rms (deg) =', F6.1)
 1023 FORMAT ('MBD search range (nsec) = +/-', F7.1)
 1030 FORMAT ('Using IFs ', I2, ' to ', I2,'  Min IF allowed ', I2)
 1033 FORMAT (' Reference Frequency (MHz) ', F14.6,I6,I6)
 1034 FORMAT ('IF ', I3, '    Offset frequency ', F14.6)
 1098 FORMAT ('Total number of possible fits   = ', I5)
 1099 FORMAT ('Total number of acceptible fits = ', I5)
 1100 FORMAT ('Flagged ',I5,' soln. due <',I3,' IFs')
 1101 FORMAT ('Flagged ',I5,' soln. due to SNR <=',F12.2)
 1102 FORMAT ('Flagged ',I5,' soln. due to phase scatter from rate  >',
     *   F7.1,' deg')
 1103 FORMAT ('Flagged ',I5,' soln. due to phase scatter of MBD >',
     *   F7.1,' deg')
 1104 FORMAT ('Phase offset NOT removed from each scan')
 1105 FORMAT ('Phase offset removed from each scan')
      END
      SUBROUTINE GETEDT (INTAB, MINSNR, MAXRAS, MAXPHS, MAXMBD, AVGPHS,
     *   MINIF, PASBAD, DISPRM, TSTART, TSTOP, IERR)
C-----------------------------------------------------------------------
C   Gets editing control parameters, sets defaults and updates the
C   values in the input object.
C   Inputs:
C      INTAB   C*   Name of input table object.
C   Inputs from INTAB:
C      APARM   R(10) Editing control paramaters
C                     0 --> Do not test, except for IF's
C                     (1) = min SNR, default = 0
C                     (2) = max rate rms (sigma), default = 1.0E20
C                     (3) = max phase rms (sigma), default = 1.0E20
C                     (4) = min. no. IFs., default = all
C                     (5) = MBD search range. 0 = ambiguity
C                     (6) = residual phase flag
C   Output:
C      MINSNR  R    Min SNR
C      MAXRAS  R    Max rate rms (sigma)
C      MAXPHS  R    Max phase rms (sigma)
C      MAXMBD  R    MBD search range (nsec)
C      AVGPHS  R    0.0 = Keep phase offset
C      MINIF   I    Min. no. IFs.
C      PASBAD  I    Pass "bad" data if >= 1
C      TSTART  D    Start time in days
C      TSTOP   D    Stop time in days
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*)
      DOUBLE PRECISION   TSTART, TSTOP
      REAL      MINSNR, MAXRAS, MAXPHS, MAXMBD, AVGPHS, DISPRM(3)
      INTEGER   MINIF, PASBAD, IERR
C
      INTEGER   TYPE, DIM(3)
      REAL      APARM(10), TIMER(8)
      CHARACTER CDUMMY*1
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Get APARM array
      CALL OGET (INTAB, 'APARM', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, APARM)
C                                       Set defaults: min SNR
      IF (APARM(1).LE.1.0E-10) APARM(1) = 5.0
C                                       Max rate rms
      IF (APARM(2).LE.1.0E-10) APARM(2) = 50.0
C                                       Max phase rms
      IF (APARM(3).LE.1.0E-10) APARM(3) = 20.0
C                                       MBD Search Range
C                                       Pass bad data?
      PASBAD = APARM(7) + 0.001
      IF (APARM(7).GT.0.0) PASBAD = MAX (1, PASBAD)
C                                       Save for history
      CALL RCOPY (DIM(1), APARM, RDUM)
      CALL OPUT ('Input', 'APARM', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Set output values
      MINSNR = APARM(1)
      MAXRAS = APARM(2)
      MAXPHS = APARM(3)
      MINIF = APARM(4) + 0.5
      MAXMBD = APARM(5)
      IF (MAXMBD.LT.0.0) THEN
         MAXMBD = 1.0E-20
         MINSNR = 0.001
         MAXRAS = 1000.0
         MAXPHS = 1000.0
         END IF
      AVGPHS = APARM(6)
      DISPRM(1) = APARM(8)
      DISPRM(2) = APARM(9)
      DISPRM(3) = APARM(10)
C                                       Get TIMER array
      CALL OGET (INTAB, 'TIMER', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, TIMER)
      TSTART = TIMER(1) + TIMER(2) / 24.0D0 + TIMER(3) / 1440.0D0 +
     *         TIMER(4) / 86400.0D0
      TSTOP  = TIMER(5) + TIMER(6) / 24.0D0 + TIMER(7) / 1440.0D0 +
     *         TIMER(8) / 86400.0D0
      WRITE (MSGTXT, 1020) INT(TIMER(1)), INT(TIMER(2)), INT(TIMER(3)),
     *                     INT(TIMER(4)), INT(TIMER(5)), INT(TIMER(6)),
     *                     INT(TIMER(7)), INT(TIMER(8))
      CALL MSGWRT (4)
      IF (TSTART .EQ. 0.0D0) TSTART=-100.0D0
      IF (TSTOP  .EQ. 0.0D0) TSTOP = 1000.0D0
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('Time range: ',I2,'/',3I3.2,' to ',I2,'/',3I3.2)
      END
      SUBROUTINE AVRATE (NIF, MINIF, BIF, EIF, MINSNR, MAXRAS, ANTNO,
     *   REFA, NPOLN, TIMEI, FREQ, RATE, WEIGHT, BAD, BADIF, BADSNR,
     *   BADRAT, FLGMIF, FLGSNR, FLGRAS)
C-----------------------------------------------------------------------
C   Averages valid rates and applies a number of editing criteria.
C   Inputs:
C      NIF     I    Number of IFs.
C      MINIF   I    Min. no. IFs.
C      BIF     I    First IF to use in fit.
C      EIF     I    Last IF to use in fit.
C      MINSNR  R    Min SNR
C      MAXRAS  R    Max rate rms (sigma)
C      NPOLN   I    Number of polarizations (1 or 2)
C      ANTNO   I    Antenna number, (min SNR not applied to ref.
C                   antenna).
C      REFA    I(2,*) Reference antenna
C      TIMEI   R      Time interval of record (days)
C      FREQ    D      Reference frequency (Hz)
C      WEIGHT  R(2,*) SNR of each IF by poln. Used for validity.
C   Input/Output:
C      RATE    R(2,*) Fringe rates (s/s)
C      BAD     I(2) If data, 1 per poln.
C      FLGMIF  I    Count of records flagged for too few IFs
C      FLGSNR  I    Count of records flagged for too low SNR
C      FLGRAS  I    Count of records flagged for excessive rate scatter.
C-----------------------------------------------------------------------
      INTEGER   NIF, MINIF, ANTNO, REFA(2,*), NPOLN, FLGMIF, FLGSNR,
     *   FLGRAS, BIF, EIF, BAD(2), BADIF(2), BADSNR(2), BADRAT(2)
      REAL      MINSNR, MAXRAS, TIMEI, RATE(2,*), WEIGHT(2,*)
      DOUBLE PRECISION FREQ
C
      INCLUDE 'INCS:DDCH.INC'
      INTEGER   IIF, COUNT, IPOL, CNTSNR, IREF, GETREF, MIF(2)
      REAL      SUM, SUM2, SUMSNR, SNRSUM, SIGRA, ERRRA
C-----------------------------------------------------------------------
C                                       Average
      SUM = 0.0
      SNRSUM = 0.0
      SUM2 = 0.0
      COUNT = 0
      MIF(1) = 0
      MIF(2) = 0
      BAD(1) = 0
      BAD(2) = 0
      BADIF(1) = 0
      BADIF(2) = 0
      BADSNR(1) = 0
      BADSNR(2) = 0
      BADRAT(1) = 0
      BADRAT(2) = 0
C                                       Loop over polarization
      DO 150 IPOL = 1,NPOLN
         CNTSNR = 0
         SUMSNR = 0.0
         DO 100 IIF = 1,NIF
C                                       Only use BIF to EIF
            IF (IIF .LT. BIF .OR. IIF. GT. EIF)
     *         WEIGHT(IPOL,IIF) = 0.0

            IF ((WEIGHT(IPOL,IIF).GT.0.0001) .AND.
     *         (RATE(IPOL,IIF).NE.FBLANK)) THEN
               MIF(IPOL) = MIF(IPOL) + 1
               COUNT = COUNT + 1
               CNTSNR = CNTSNR + 1
               SUM = SUM + RATE(IPOL,IIF)
               SUM2 = SUM2 + RATE(IPOL,IIF)**2
               SUMSNR = SUMSNR + (WEIGHT(IPOL,IIF))**2
               SNRSUM = SNRSUM + (WEIGHT(IPOL,IIF))**2
               END IF
 100        CONTINUE
         SUMSNR = SQRT(SUMSNR)
C                                       IF editing:
C                                       Must have enough IFs present
         IF (MIF(IPOL).LT.MINIF) THEN
            BAD(IPOL) = BAD(IPOL) + 1
            BADIF(IPOL) = 1
            FLGMIF = FLGMIF + 1
            END IF
C                                       IF dependent SNR test, only if
C                                       not refant.
         IREF = GETREF (NIF, IPOL, REFA, RATE, WEIGHT)
         IF (ANTNO.NE.IREF) THEN
            IF (CNTSNR.GT.1) THEN
               IF (SUMSNR .LT. MINSNR) THEN
                  BAD(IPOL) = BAD(IPOL) + 2
                  BADSNR(IPOL) = 1
                  FLGSNR = FLGSNR + 1
                  END IF
            ELSE
               BAD(IPOL) = BAD(IPOL) + 2
               FLGSNR = FLGSNR + 1
               END IF
            END IF
 150     CONTINUE
C                                       Use both IFs (if present to look
C                                       for bad rates)
      IF (COUNT.GT.1) THEN
         SIGRA = SQRT ((SUM2 - (SUM*SUM / COUNT)) / (COUNT-1))
C                                       Phase scatter from rate scat.
         ERRRA = SIGRA * TIMEI * 86400.0 * FREQ * 57.25
         IF (ERRRA .GT. MAXRAS) THEN
            BAD(1) = BAD(1) + 4
            BAD(2) = BAD(2) + 4
            BADRAT(1) = 1
            BADRAT(2) = 1
            FLGRAS = FLGRAS + NPOLN
            END IF
         END IF
C                                       Average rate
      IF (COUNT.GT.0) SUM = SUM / COUNT
C                                       Correct
      DO 250 IPOL = 1,NPOLN
         DO 200 IIF = 1,NIF
            IF ((WEIGHT(IPOL,IIF).GT.0.0001) .AND.
     *         (RATE(IPOL,IIF).NE.FBLANK)) RATE(IPOL,IIF) = SUM
 200        CONTINUE
 250     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE DELAMB (NIF, SSF, NPOLN, FACTM, FACTP, CREAL, CIMAG,
     *   DELAY, WEIGHT, REFA, MBDLY, DISP, TIMD, ANTNO, RATE, DISPRM,
     *   NTOTAL, NALL, SOURID, SNAME)
C-----------------------------------------------------------------------
C   Determine multiband delays from IF phases and single band delays.
C   Also corrects phases.
C   Inputs:
C      NIF      I        Number of IFs
C      SSF      L        Single source file
C      NPOLN    I        Number of polarizations (1 or 2)
C      WEIGHT   R(2,*)   SNR of each IF by poln. (1/var. of phase in
C                        rad.)
C      REFA     I(2,*)   Ref ant. of each IF by poln.
C      TIMD     D        Time of data
C      ANTNO    I        Antenna Number
C      RATE     R(2,*)   Rate solutions
C      DISPRM   R(2)     (1) > 0 -> zero phase, delay, rate
C                        (2) <= 0 -> correct phase, delay for dispersion
C                        (3) > 0 -> average 2 polarizations dispersion
C      SOURID   I        Source Number
C      SNAME    C(*)8    Source list
C   Input/Output:
C      CREAL    R(2,*)   Real part of phase of both polarizations
C      CIMAG    R(2,*)   Imaginary part of phase of  both polarizations
C      DELAY    R(2,*)   Single band delay of both polarizations
C   Outputs:
C      MBDLY    R(2)     Multi band delay of both polarizations.
C      DISP     R(2)     Dispersion
C      NTOTAL   I        Total number of good fits
C      NALL     I        Total number of possible fits
C-----------------------------------------------------------------------
      INTEGER   NIF, NPOLN, REFA(2,*), ANTNO, NTOTAL, NALL, SOURID
      LOGICAL   SSF
      REAL      CREAL(2,*), CIMAG(2,*), DELAY(2,*), WEIGHT(2,*),
     *   MBDLY(2), DISP(2), RATE(2,*), DISPRM(3)
      DOUBLE PRECISION TIMD, FACTM(*), FACTP(*)
      CHARACTER SNAME(*)*8
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DOUBLE PRECISION TIMPR
      CHARACTER CHM*1
      LOGICAL   PTITLE
      INTEGER   LOOP, ISUM, IPOL, IREF, GETREF, HM(2), ISNR(2)
      REAL      WT(MAXIF), DAVG(2), MBDLE(2), A, P, SNR, SUMSNR, SEC,
     *   FRATE, DISPE(2), DELY(MAXIF)
      INCLUDE 'INCS:PSTD.INC'
      SAVE TIMPR, PTITLE
      DATA  TIMPR / 0.0D0 /
      DATA  PTITLE /.FALSE./
C-----------------------------------------------------------------------
C                                       Print header
      IF (TIMPR.NE.TIMD) THEN
         TIMPR = TIMD
         PTITLE = .TRUE.
         END IF
C                                       Loop over polarization
      DO 40 IPOL = 1,NPOLN
         NALL = NALL + 1
C                                       This one any good?
         MBDLY(IPOL) = FBLANK
         DISP(IPOL) = FBLANK
C                                       Most common REFANT.
         IREF = GETREF (NIF, IPOL, REFA, CREAL, WEIGHT)
C                                       Must be ref. antenna, valid data
         IF (IREF.LE.0) GO TO 40
         DAVG(IPOL) = 0.0
         SUMSNR = 0.0
         ISUM = 0
C                                       Form part of first line
         CALL COORDD (1, TIMD, CHM, HM, SEC)
         FRATE = RATE(IPOL, 1) * 1.0E12
C                                       Convert to ampl. phase.; average
C                                       SNR.
         DO 30 LOOP = 1,NIF
            IF ((CREAL(IPOL,LOOP).NE.FBLANK) .AND.
     *         (CIMAG(IPOL,LOOP).NE.FBLANK) .AND.
     *         (DELAY(IPOL,LOOP).NE.FBLANK) .AND.
     *         (WEIGHT(IPOL,LOOP).GT.0.0) .AND.
     *         (REFA(IPOL,LOOP) .EQ. IREF))  THEN
               WT(LOOP) = WEIGHT(IPOL,LOOP)
               ISUM = ISUM + 1
C                                       Get average SB delay
               DELY(LOOP) = DELAY(IPOL,LOOP)
               DAVG(IPOL) = DAVG(IPOL) + DELAY(IPOL,LOOP)
C                                       Sum SNR
               SUMSNR = SUMSNR + WT(LOOP)
            ELSE
               DELY(LOOP) = 0.0
               WT(LOOP) = 0.0
               END IF
 30         CONTINUE
C                                       Less than 2 IF's?
         IF (ISUM.LE.1) GO TO 40
C                                       Poln. SNR average
         SNR = SQRT (SUMSNR)
         SNR = MAX (0.01, SNR)
         ISNR(IPOL) = SNR + 0.5
C                                       Determine MB delay, disp
         DAVG(IPOL) = DAVG(IPOL) / ISUM
         CALL DELFIT (NIF, DELY, WT, FACTM, MBDLY(IPOL), MBDLE(IPOL),
     *      DISP(IPOL), DISPE(IPOL))
         NTOTAL = NTOTAL + 1
 40      CONTINUE
C                                       Correct phases
      IF ((DISPRM(3).GT.0.0) .AND. (NPOLN.EQ.2)) THEN
         IF ((DISP(1).NE.FBLANK) .AND. (DISP(2).NE.FBLANK)) THEN
            DISP(1) = (DISP(1) + DISP(2)) / 2.0
            DISP(2) = DISP(1)
            END IF
         END IF
      DO 60 IPOL = 1,NPOLN
         IF (DISP(IPOL).NE.FBLANK) THEN
            DISP(IPOL) = -DISP(IPOL)
C                                       Don't write reference ant
            IF (ANTNO.NE.REFA(1,1)) THEN
C                                       Write Heading
               IF (PTITLE) THEN
                  WRITE (MSGTXT,1002)
                  CALL MSGWRT (4)
                  IF (SSF) THEN
                     WRITE (MSGTXT, 1013) SNAME(1), CHM, HM, SEC,
     *                  REFA(1,1)
                     CALL MSGWRT (4)
                  ELSE
                     WRITE (MSGTXT, 1014) SNAME(SOURID), CHM, HM, SEC,
     *                  REFA(1,1)
                     CALL MSGWRT (4)
                     END IF
                  WRITE (MSGTXT,1004)
                  CALL MSGWRT (4)
                  WRITE (MSGTXT,1006)
                  CALL MSGWRT (4)
                  PTITLE = .FALSE.
                  END IF
C                                       Write solution
               WRITE (MSGTXT,1025) ANTNO, FRATE, DAVG(IPOL)*1.0E9,
     *            MBDLY(IPOL)*1.E9, MBDLE(IPOL)*1.E9, DISP(IPOL)*1.E9,
     *            DISPE(IPOL)*1.E9, ISNR(IPOL)
               CALL MSGWRT (4)
               END IF
            DO 50 LOOP = 1,NIF
               IF ((CREAL(IPOL,LOOP).NE.FBLANK) .AND.
     *            (CIMAG(IPOL,LOOP).NE.FBLANK)) THEN
C                                       null them
                  IF (DISPRM(1).GT.0.0) THEN
                     CREAL(IPOL,LOOP) = 1.0
                     CIMAG(IPOL,LOOP) = 0.0
                     DELAY(IPOL,LOOP) = 0.0
C                                       correct them
                  ELSE IF (DISPRM(2).LE.0.0) THEN
                     DELAY(IPOL,LOOP) = DELAY(IPOL,LOOP) -
     *                  FACTM(LOOP) * DISP(IPOL)
                     A = SQRT (CREAL(IPOL,LOOP)**2 +
     *                  CIMAG(IPOL,LOOP)**2)
                     P = ATAN2 (CIMAG(IPOL,LOOP), CREAL(IPOL,LOOP))
                     P = P - TWOPI * VELITE * FACTP(LOOP) * DISP(IPOL)
                     CREAL(IPOL,LOOP) = A * COS (P)
                     CIMAG(IPOL,LOOP) = A * SIN (P)
C                                       don't modify phases from FRING
C                                       they are needed in CL2HF
C                 ELSE
C                    CREAL(IPOL,LOOP) = COS (PHASE(LOOP))
C                    CIMAG(IPOL,LOOP) = SIN (PHASE(LOOP))
                     END IF
                  END IF
 50            CONTINUE
            END IF
 60      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1002 FORMAT (20(' - '))
 1004 FORMAT ('Ant   Rate    <SBD>      MBD            DISP         ',
     *   'SNR')
 1006 FORMAT ('      ps/s      ns        ns          ns/m/m')
 1013 FORMAT ('File=',A8, 2X,'Time=',A1, 2I3, F6.2,'   Ref Ant= ',I2)
 1014 FORMAT ('Source=',A8, 2X,'Time=',A1, 2I3, F6.2,'   Ref Ant= ',I2)
 1025 FORMAT (I3,F7.2,F8.2,F10.4,'(',F6.4,')',F8.3,'(',F5.3,')',I5)
      END
      SUBROUTINE DELFIT (NUMIF, DELY, PHASWT, FACTM, MB, MBE, DISP,
     *   DISPE)
C-----------------------------------------------------------------------
C   Fit Single-band delays (i) to MBdelay + FACTM(i) * Dispersion
C   Inputs:
C      NUMIF     I      Number of IF.
C      DELY      R(*)   delay for IF (s).
C      PHASWT    R(*)   Weight for IF. (non positive means bad)
C      FACTM     D(*)   LSQ factor dispersion addition to delay
C   Output:
C      MB      R    Multi band delay (seconds)
C      MBE     R    Multi band delay error (seconds)
C      DISP    R    Dispersion (seconds/m/m)
C      DISPE   R    Dispersion error (seconds/m/m)
C-----------------------------------------------------------------------
      INTEGER   NUMIF
      REAL      DELY(NUMIF), PHASWT(NUMIF), MB, MBE, DISP, DISPE
      DOUBLE PRECISION FACTM(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   LOOP, COUNT
      DOUBLE PRECISION SUMX, SUMY, SUMXX, SUMXY, DIV, DTEMP1, DTEMP2,
     *   LL(MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       Find first good IF
      MB = FBLANK
      DISP = FBLANK
C                                       Init sums
      COUNT = 0
      SUMX  = 0.0
      SUMXX = 0.0
      SUMY  = 0.0
      SUMXY = 0.0
C                                       Least squares slope
      DO 130 LOOP = 1,NUMIF
         IF (PHASWT(LOOP).GT.0.0) THEN
            COUNT = COUNT + 1
            LL(LOOP) = FACTM(LOOP)
            SUMX  = SUMX + LL(LOOP)
            SUMXX = SUMXX + LL(LOOP) * LL(LOOP)
            SUMY  = SUMY + DELY(LOOP)
            SUMXY = SUMXY + DELY(LOOP) * LL(LOOP)
            END IF
 130     CONTINUE
C                                       Slope
      IF (COUNT.LE.0) GO TO 999
      DIV = COUNT * SUMXX - SUMX * SUMX
      IF (DIV.EQ.0.0) GO TO 999
      MB = (SUMY * SUMXX - SUMX * SUMXY) / DIV
      DISP = (SUMY * SUMX - COUNT * SUMXY) / DIV
C                                       MB uncertainty done right
      MBE = 0.0
      DISPE = 0.0
      DTEMP2 = 0.0D0
      DO 140 LOOP = 1,NUMIF
         IF (PHASWT(LOOP).GT.0.0) THEN
            DTEMP1 = (SUMXX - SUMX * LL(LOOP)) / DIV
            MBE = MBE + DTEMP1*DTEMP1
            DTEMP1 = (SUMX - COUNT * LL(LOOP)) / DIV
            DISPE = DISPE + DTEMP1*DTEMP1
            DTEMP2 = DTEMP2 + (DELY(LOOP)- MB + DISP*LL(LOOP)) ** 2
            END IF
 140     CONTINUE
      DTEMP2 = SQRT (DTEMP2/COUNT)
      MBE = SQRT (MBE) * DTEMP2
      DISPE = SQRT (DISPE) * DTEMP2
C
 999  RETURN
      END
      SUBROUTINE GETMB (NIF, SSF, MAXPHS, MAXMBD, AVGPHS, NPOLN, FRQTAB,
     *   CREAL, CIMAG, DELAY, WEIGHT, REFA, PRTLEV, MBDLY, BAD, BADFAZ,
     *   FLGPHS, TIMD, ANTNO, RATE, NTOTAL, NALL, SOURID, SNAME)
C-----------------------------------------------------------------------
C   Determine multiband delays from IF phases and single band delays.
C   Also corrects phases.
C   Inputs:
C      NIF    I      Number of IFs
C      SSF    L      Single source file
C      MAXPHS R      Maximum postfit phase RMS in units of the phase
C                    uncertainty.
C      MAXMBD R      Search range of MBD
C      AVGPHS R      Scan phase centering?
C      NPOLN  I      Number of polarizations (1 or 2)
C      FRQTAB D(*)   Frequency offset for each IF from reference freq.
C      DELAY  R(2,*) Single band delay of both polarizations
C      WEIGHT R(2,*) SNR of each IF by poln. (1/var. of phase in rad.)
C      REFA   I(2,*) Ref ant. of each IF by poln.
C      PRTLEV I      Print level, 1=MB result, 2=also phase residuals
C      TIMD   D      Time of data
C      ANTNO  I      Antenna Number
C      RATE   R(2,*) Rate solutions
C      SOURID I      Source Number
C      SNAME  C(*)8  Source list
C   Input/Output:
C      CREAL  R(2,*) Real part of phase of both polarizations
C      CIMAG  R(2,*) Imaginary part of phase of  both polarizations
C      BAD    I      Bad parameter  0 okay.
C      FLGPHS I      Count of records flagged for excessive post fit
C                    phase scatter.
C   Outputs:
C      MBDLY  R(2)   Multi band delay of both polarizations.
C      NTOTAL I      Total number of good fits
C      NALL   I      Total number of possible fits
C-----------------------------------------------------------------------
      INTEGER   NIF, NPOLN, REFA(2,*), PRTLEV, BAD(2), BADFAZ(2),
     *   FLGPHS, ANTNO, NTOTAL, NALL, SOURID
      LOGICAL   SSF
      REAL      MAXPHS, MAXMBD, AVGPHS, CREAL(2,*), CIMAG(2,*),
     *   DELAY(2,*), WEIGHT(2,*), MBDLY(2), RATE(2,*)
      DOUBLE PRECISION FRQTAB(*), TIMD
      CHARACTER SNAME(*)*8
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INTEGER   ISNR, HM(2), II, LOOP, ISUM, IPOL, IREF, GETREF
      REAL      SEC, FRATE, DTEMP, RPHASE(MAXIF), AMP(MAXIF),
     *   PHASE(MAXIF), WT(MAXIF), DAVG, MBDLE(2),DLAMB(2), AVGFAZ(2),
     *   SNR, SUMSNR, RMSFAZ
      DOUBLE PRECISION TIMPR
      CHARACTER  CHM*1, MSGPHS(8)*4
      LOGICAL   PTITLE
      INCLUDE 'INCS:PSTD.INC'
      SAVE TIMPR, PTITLE
      DATA  TIMPR / 0.0D0 /
      DATA  PTITLE /.FALSE./
C-----------------------------------------------------------------------
       BADFAZ(1) = 0
       BADFAZ(2) = 0
C                                       Print header
      IF (TIMPR.NE.TIMD) THEN
         TIMPR = TIMD
         PTITLE = .TRUE.
         END IF
C                                       Loop over polarization
      DO 200 IPOL = 1,NPOLN
         NALL = NALL + 1
C                                       This one any good?
         MBDLY(IPOL) = FBLANK
C                                       Most common REFANT.
         IREF = GETREF (NIF, IPOL, REFA, CREAL, WEIGHT)
C                                       Must be ref. antenna, valid data
         IF (IREF.LE.0) GO TO 200
         DAVG = 0.0
         SUMSNR = 0.0
         ISUM = 0
C                                       Form part of first line
         CALL COORDD (1, TIMD, CHM, HM, SEC)
         FRATE = RATE(IPOL, 1) * 1.0E12
C                                       Convert to ampl. phase.; average
C                                       SNR.
         DO 30 LOOP = 1,NIF
            IF ((CREAL(IPOL,LOOP).NE.FBLANK) .AND.
     *         (CIMAG(IPOL,LOOP).NE.FBLANK) .AND.
     *         (DELAY(IPOL,LOOP).NE.FBLANK) .AND.
     *         (WEIGHT(IPOL,LOOP).GT.0.0) .AND.
     *         (REFA(IPOL,LOOP) .EQ. IREF))  THEN
               AMP(LOOP) = SQRT (CREAL(IPOL,LOOP)*CREAL(IPOL,LOOP) +
     *            CIMAG(IPOL,LOOP)*CIMAG(IPOL,LOOP))
               PHASE(LOOP) = ATAN2 (CIMAG(IPOL,LOOP),
     *            CREAL(IPOL,LOOP)+1.0E-20)
               WT(LOOP) = WEIGHT(IPOL,LOOP)
               ISUM = ISUM + 1
C                                       Get average SB delay
               DAVG = DAVG + DELAY(IPOL,LOOP)
C                                       Sum SNR
               SUMSNR = SUMSNR + WT(LOOP)**2
            ELSE
               AMP(LOOP) = 0.0
               PHASE(LOOP) = 0.0
               WT(LOOP) = 0.0
               END IF
 30         CONTINUE
C                                       Less than 2 IF's?
         IF (ISUM .LE. 1) GO TO 200
C                                       Poln. SNR average
         SNR = SQRT(SUMSNR)
         SNR = MAX (0.01, SNR)
         ISNR = SNR + 0.5
C                                       Determine MB delay
C                                       phases
         DAVG = DAVG / ISUM
         CALL MBFIT (NIF, MAXMBD, PHASE, WT, FRQTAB, DAVG, PRTLEV,
     *      MBDLY(IPOL), MBDLE(IPOL), DLAMB(IPOL), AVGFAZ(IPOL), RMSFAZ,
     *      RPHASE)
C                                       Excessive MBD phase scatter
         IF (RMSFAZ*RAD2DG .GT. MAXPHS) THEN
            BAD(IPOL) = 8 + BAD(IPOL)
            BADFAZ(IPOL) = 1
            FLGPHS = FLGPHS + 1
            END IF
C                                       Failed?
         IF (BAD(IPOL) .GT. 0) GO TO 49
         NTOTAL = NTOTAL + 1
C                                       Don't write reference ant
         IF (ANTNO .EQ. REFA(1,1)) GO TO 49
C                                       Write Heading
         IF (PTITLE) THEN
            WRITE (MSGTXT,1002)
            CALL MSGWRT (4)
            IF (SSF) THEN
               WRITE (MSGTXT, 1013) SNAME(1), CHM, HM, SEC,
     *            REFA(1,1)
               CALL MSGWRT (4)
            ELSE
               WRITE (MSGTXT, 1014) SNAME(SOURID), CHM, HM, SEC,
     *            REFA(1,1)
               CALL MSGWRT (4)
               END IF
            WRITE (MSGTXT, 1004)
            CALL MSGWRT (4)
            WRITE (MSGTXT,1006)
            CALL MSGWRT (4)
            PTITLE = .FALSE.
            END IF
C                                       Write solution
         IF (MAXMBD .NE. 0.0) THEN
            DTEMP = MAXMBD
         ELSE
            DTEMP = DLAMB(IPOL)*1.0E9
            END IF
         WRITE (MSGTXT, 1025) ANTNO, FRATE,
     *      DAVG*1.0E9,AVGFAZ(IPOL)*RAD2DG,
     *      RMSFAZ*RAD2DG, DTEMP, MBDLY(IPOL)*1.0E9,
     *      MBDLE(IPOL)*1.0E9, ISNR
         CALL MSGWRT (4)
         IF (PRTLEV.GE.2) THEN
            DO 47 II = 1,NIF
               WRITE (MSGPHS(II), 1026) NINT(RPHASE(II))
 47            CONTINUE
            MSGTXT = '                    Res: '//
     *         MSGPHS(1)//MSGPHS(2)//MSGPHS(3)//MSGPHS(4)//
     *         MSGPHS(5)//MSGPHS(6)//MSGPHS(7)//MSGPHS(8)
               CALL MSGWRT (4)
            DO 48 II = 1,NIF
               MSGPHS(II) = ' '
 48            CONTINUE
            END IF
 49      CONTINUE
C                                       Correct phases
         DO 50 LOOP = 1,NIF
            IF (AVGPHS.GT.0.0) THEN
               PHASE(LOOP) = -AVGFAZ(IPOL) + MBDLY(IPOL) *
     *            FRQTAB(LOOP) * TWOPI
            ELSE
               PHASE(LOOP) = MBDLY(IPOL) * FRQTAB(LOOP) * TWOPI
               END IF
C                                       don't modify phases from FRING
C                                       they are needed in CL2HF
C           IF ((CREAL(IPOL,LOOP).NE.FBLANK) .AND.
C    *         (CIMAG(IPOL,LOOP).NE.FBLANK)) THEN
C              CREAL(IPOL,LOOP) = COS (PHASE(LOOP))
C              CIMAG(IPOL,LOOP) = SIN (PHASE(LOOP))
C              END IF
 50         CONTINUE
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1002 FORMAT (20(' - '))
 1004 FORMAT (' Ant  Rate   SBD     Phase   ',
     *   'Range        MBD    SNR')
 1006 FORMAT ('      ps/s   ns   zero  rms  ','  ns          ns')
 1013 FORMAT ('File=',A8, 2X,'Time=',A1, 2I3, F6.2,'   Ref Ant= ',I2)
 1014 FORMAT ('Source=',A8, 2X,'Time=',A1, 2I3, F6.2,'   Ref Ant= ',I2)
 1025 FORMAT (I3,F7.2,F6.1, F6.1, F5.1, F7.1, F8.3,'(', F5.3,')',I3)
 1026 FORMAT (I4)
      END
      SUBROUTINE MBFIT (NUMIF, MAXMBD, PHASE, PHASWT, FREQ, SB, PRTLEV,
     *   MB, MBE, DAMB, AVGFAZ, RMSFAZ, RPHASE)
C-----------------------------------------------------------------------
C   Fit phase slope (like multiband delay) to a set of phases.  This
C   routine is not particularly smart about resolving ambiguities.
C   Multiband results are constrained to be within 1/2 the ambiguity
C   spacing of 0.
C   Inputs:
C      NUMIF   I    Number of IF.
C      MAXMBD  R    Search range for MBD
C      PHASWT  R(*) Weight for IF. (non positive means bad)
C      FREQ    D(*) Frequencies (Hz) of IFs.
C      SB      R    The average SBDelay to center the MB
C      PRTLEV  I    Print level, 1=MB result, 2=also phase residuals
C      PHASE   R(*) Phase for IF (rad).
C   Output:
C      MB      R    Multi band delay (seconds)
C      MBE     R    Multi band delay error (seconds)
C      DAMB    R    Multi band delay ambiguity (seconds)
C      AVGFAZ  R    Average phase at ref. freq. (rad)
C      RMSFAZ  R    RMS phase residual. (rad)
C      RPHASE  R    Residial phase (deg) for each IF
C-----------------------------------------------------------------------
      INTEGER   NUMIF, PRTLEV
      REAL      PHASE(NUMIF), PHASWT(NUMIF), MB, SB, MBE, DAMB, AVGFAZ,
     *   RMSFAZ, RPHASE(NUMIF), MAXMBD
      DOUBLE PRECISION FREQ(NUMIF)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER LOOP, COUNT, GOOD1, LOOP1, FLAG(MAXIF),
     *   NSTEP, IMAX, ISUM, ILAST
      DOUBLE PRECISION P(MAXIF), SUMX, SUMY, SUMXX, SUMXY, DIV, FMIN,
     *   FMAX, DSTEP, DMAX, DVAL, DSUM, PREF, FREF, PTMP, DTEMP1,
     *   DTEMP2, DTEMP3, DLYMAX, GFREQ(MAXIF), DAMBA, XFREQ(MAXIF)
      DOUBLE PRECISION  IFINC
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       Find first good IF
      MB = FBLANK
      DAMB = FBLANK
      AVGFAZ = FBLANK
      GOOD1 = 0
C                                       Set IF flags
      DO 50 LOOP = 1,NUMIF
         GFREQ(LOOP) = FREQ(LOOP)
         FLAG(LOOP) = 0
         IF (PHASWT(LOOP).GT.0.0) THEN
            GOOD1 = GOOD1 + 1
            XFREQ(GOOD1) = GFREQ(LOOP)
            FLAG(LOOP) = 1
            END IF
 50      CONTINUE
C                                       Must have at least 2 IFs.
      IF (GOOD1.LE.1) GO TO 999
C                                       Find maximum freq. diff
      FMAX = 0.0D0
      DO 70 LOOP = 1, GOOD1
         DO 60 LOOP1 = LOOP, GOOD1
            FMAX = DMAX1(FMAX, DABS(XFREQ(LOOP)-XFREQ(LOOP1)))
 60         CONTINUE
 70      CONTINUE
C                                       Find minimum delay interval
      FMIN = IFINC (XFREQ, GOOD1)
C                                       Set up step for guess
      FMIN = MAX (FMIN, 1.0D-20)
      FMAX = MAX (FMAX, 1.0D-20)
      IF (MAXMBD .EQ. 0.0) THEN
         DAMB = 1.0 / FMIN
        ELSE
         DAMB = 2.0 * MAXMBD * 1.0E-9
         END IF
      DSTEP = 1.0 / FMAX / 36.0
      NSTEP = DAMB / DSTEP
      IF (NSTEP.GT.5000) THEN
         NSTEP = 5000
         DSTEP = DAMB / NSTEP
         END IF
      IF (NSTEP.LT.10) THEN
         NSTEP = 10
         DSTEP = DAMB / NSTEP
         END IF
C                                       Begin loop to get max coher
      DMAX = 0.0
      IMAX = 0
      DVAL = (-DAMB / 2.0) * TWOPI
      DO 100 LOOP = 1, NSTEP
         DVAL = DVAL + DSTEP * TWOPI
         DSUM = 0.0
         ISUM = 0
         DO 90 LOOP1 = 1,NUMIF
            IF (FLAG(LOOP1).GT.0) THEN
               ISUM = ISUM + 1
C                                       Reference Frequency
               IF (ISUM.EQ.1) THEN
                  DSUM = 1.0
                  PREF = PHASE(LOOP1)
                  FREF = GFREQ(LOOP1)
               ELSE
                  DSUM = DSUM + COS (PHASE(LOOP1) - PREF
     *               - DVAL * (GFREQ(LOOP1) - FREF)
     *               - TWOPI * SB * (GFREQ(LOOP1) - FREF))
                  END IF
               END IF
 90         CONTINUE
         IF (DSUM .GT. DMAX) THEN
            DMAX = DSUM
            IMAX = LOOP
            DLYMAX = DVAL
            END IF
 100     CONTINUE
C                                       Best guess from above
      DMAX = DMAX / ISUM * 100.0
      DVAL = DLYMAX / TWOPI
      ILAST = -1
      DO 200 LOOP = 1,NUMIF
         IF (PHASWT(LOOP).GT.0.0) THEN
C                                       Remove slope estimate
C                                       and leave remainder
            P(LOOP) = PHASE(LOOP) - (DVAL+SB) * (GFREQ(LOOP)-FREF)*TWOPI
            P(LOOP) = MOD (P(LOOP), TWOPI)
            IF (P(LOOP) .LT. -PI) P(LOOP) = P(LOOP) + TWOPI
            IF (P(LOOP) .GT.  PI) P(LOOP) = P(LOOP) - TWOPI
C                                       Add or subtract 2 pi to avoid
C                                       wrap problem.
            IF (ILAST.GT.0) THEN
               IF ((P(LOOP)-P(ILAST)).GT. 3.1) P(LOOP) = P(LOOP) - TWOPI
               IF ((P(LOOP)-P(ILAST)).LT.-3.1) P(LOOP) = P(LOOP) + TWOPI
               END IF
            ILAST = LOOP
            END IF
 200     CONTINUE
C                                       Init sums
      COUNT = 0
      SUMX  = 0.0
      SUMXX = 0.0
      SUMY  = 0.0
      SUMXY = 0.0
C                                       Least squares slope
      DO 300 LOOP = 1,NUMIF
         IF (PHASWT(LOOP).GT.0.0) THEN
            COUNT = COUNT + 1
            SUMX  = SUMX + FREQ(LOOP)
            SUMXX = SUMXX + FREQ(LOOP) * FREQ(LOOP)
            SUMY  = SUMY + P(LOOP)
            SUMXY = SUMXY + FREQ(LOOP) * P(LOOP)
            END IF
 300     CONTINUE
C                                       Slope
      MB = 0.0
      IF (COUNT.LE.0) GO TO 999
      DIV = SUMXX - (SUMX * SUMX / COUNT)
      IF (DIV.EQ.0.0) GO TO 999
      MB = (SUMXY - (SUMX * SUMY / COUNT)) / DIV
C                                       MB uncertainty done right
      MBE = 0.0
      DO 310 LOOP = 1,NUMIF
         IF (PHASWT(LOOP).GT.0.0) THEN
            DTEMP1 = (SUMX - COUNT*FREQ(LOOP)) / DIV
            MBE = MBE + DTEMP1*DTEMP1
            END IF
 310     CONTINUE
      MBE = SQRT (MBE)
C                                       Add in initial guess
      IF (MAXMBD .EQ. 1.0E-20) THEN
         MB = 0.0
         DVAL = 0.0
         END IF
      MB = MB + DVAL * TWOPI
C                                       Must be in first ambiguity
      DAMBA = DAMB * TWOPI
      IF (MB .GE. (0.5D0*DAMBA)) MB = MB - DAMBA
      IF (MB .LE. (-0.5D0*DAMBA)) MB = MB + DAMBA
C                                       Correct PHASE array
C                                       and get average
      DTEMP1 = 0.0
      ISUM = 0
      DO 400 LOOP = 1,NUMIF
         IF (PHASWT(LOOP).LE.0.0) GO TO 400
         PTMP = PHASE(LOOP) - (MB+TWOPI*SB) * (FREQ(LOOP)-FREF)
         ISUM = ISUM + 1
         PTMP = MOD (PTMP, TWOPI)
         IF (PTMP .GT. PI) PTMP = PTMP - TWOPI
         IF (PTMP .LT. -PI) PTMP = PTMP + TWOPI
         IF (ISUM .EQ. 1) THEN
            DTEMP2 = PTMP
         ELSE
            IF (PTMP-DTEMP2.GT.PI) PTMP = PTMP - TWOPI
            IF (PTMP-DTEMP2.LT.-PI) PTMP = PTMP + TWOPI
            END IF
         DTEMP1 = DTEMP1 + PTMP
         P(LOOP) =  PTMP
 400     CONTINUE
      ISUM = MAX (ISUM, 1)
      PTMP = DTEMP1/ISUM
C                                       MB delay to seconds
      MB = MB / TWOPI + SB
C                                       Get rms
      DTEMP1 = 0.0
      ISUM = 0
      DO 410 LOOP = 1,NUMIF
         IF (PHASWT(LOOP).LE.0.0) GO TO 410
         ISUM = ISUM + 1
         DTEMP1 = DTEMP1 + (P(LOOP)-PTMP)**2
         DTEMP2 = PTMP - P(LOOP)
C                                       Average phase
         IF (ISUM .EQ. 1) DTEMP3 = -DTEMP2 - PHASE(LOOP)
         IF (PRTLEV.GE.2) RPHASE(LOOP) = DTEMP2 * RAD2DG
 410     CONTINUE
      ISUM = MAX (1, ISUM)
      DTEMP1 = SQRT (DTEMP1/ISUM)
C                                       delay error
      MBE = MBE * DTEMP1 / TWOPI
C                                       RMS phase resid
      RMSFAZ = DTEMP1
      DTEMP1 = DTEMP1 * RAD2DG
      PTMP = MOD (DTEMP3, TWOPI)
      IF (PTMP .GT. PI) PTMP = PTMP - TWOPI
      IF (PTMP .LT. -PI) PTMP = PTMP + TWOPI
      AVGFAZ = PTMP
C
 999  RETURN
      END
      DOUBLE PRECISION FUNCTION IFINC (IFFREQ, NIF)
C-----------------------------------------------------------------------
C   The grid spacing for IF frequencies.
C
C   Inputs:
C      IFFREQ   D(*)     IF reference frequencies
C      NIF      I        Number of IFs
C-----------------------------------------------------------------------
      DOUBLE PRECISION IFFREQ(*)
      INTEGER   NIF
C
C   TOL      D        Tolerance used in testing for termination (Hz)
C
      DOUBLE PRECISION TOL
      PARAMETER (TOL = 10.0)
      INTEGER   IMAX, I
      INCLUDE 'INCS:PUVD.INC'
      DOUBLE PRECISION D(MAXIF), DIFF, MAX, MIN
C
      INTEGER   IDAMAX
      DOUBLE PRECISION DMIN
C-----------------------------------------------------------------------
C                                       Compute the frequency
C                                       differences and use a
C                                       generalized form of Euclid's
C                                       algorithm for finding their
C                                       gcd.
      DO 10 I = 1, NIF - 1
         D(I) = DABS(IFFREQ(I+1) - IFFREQ(I))
   10    CONTINUE
C
   20 CONTINUE
C                                        Find maximum and minimum
C                                        differences
         IMAX = IDAMAX (D, NIF - 1)
         MAX = D(IMAX)
         MIN = DMIN (D, NIF - 1)
C                                        Find range of differences:
         DIFF = MAX - MIN
C                                        Test for termination:
         IF (DIFF.LE.TOL) GO TO 40
C                                        Reduce maximum by minimum
         D(IMAX) = DIFF
         GO TO 20
   40 CONTINUE
C                                        The GCD is what we want:
      IFINC = D(1)
      END
      INTEGER FUNCTION IDAMAX (S, N)
C-----------------------------------------------------------------------
C The index of the first minimum in a single-precision vector
C S of length N.  Compatible with the BLAS1 routine.
C
C Inputs:
C    S     D(*)       The vector
C    N     I          The length of the vector
C-----------------------------------------------------------------------
      DOUBLE PRECISION S(*)
      INTEGER   N
C
      INTEGER   I
      DOUBLE PRECISION MAX
C-----------------------------------------------------------------------
      IDAMAX = 1
      MAX = S(1)
      DO 10 I = 2, N
         IF (S(I).GT.MAX) THEN
            MAX = S(I)
            IDAMAX = I
            END IF
   10    CONTINUE
C
      END
      DOUBLE PRECISION FUNCTION DMIN (D, N)
C-----------------------------------------------------------------------
C Return the minimum value in a double precision vector of length N
C
C Inputs:
C    D       D(*)       The vector
C    N       I          The number of elements in the vector
C-----------------------------------------------------------------------
      DOUBLE PRECISION D(*)
      INTEGER   N
C
      INTEGER   I
C-----------------------------------------------------------------------
      DMIN = D(1)
      DO 10 I = 2, N
         IF (D(I).LT.DMIN) DMIN = D(I)
   10    CONTINUE
      END
      INTEGER FUNCTION GETREF (NIF, IPOL, REFA, CREAL, WEIGHT)
C-----------------------------------------------------------------------
C   Function to find the most common reference antenna.
C   Inputs:
C      NIF    I      Number of IFs.
C      IPOL   I      Polarization number (1 or 2)
C      REFA   I(2,*) Reference antenna numbers (1 per poln, IF)
C      CREAL  r(2,*) Real part of complex gain, used to check for
C                    blanking (1 per poln, IF)
C      WEIGHT R(2,*) Weight to check for blanking (1 per poln, IF)
C   Output:
C      GETREF I      Most common valid reference antenna.
C-----------------------------------------------------------------------
      INTEGER   NIF, IPOL, REFA(2,*)
      REAL      CREAL(2,*), WEIGHT(2,*)
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INTEGER  ANTCNT(MAXANT), LOOP, IREF, MCNT
C-----------------------------------------------------------------------
C                                       Find most common reference
C                                       antenna.
      CALL FILL (MAXANT, 0, ANTCNT)
      DO 10 LOOP = 1,NIF
         IREF = REFA(IPOL,LOOP)
         IF ((CREAL(IPOL,LOOP).NE.FBLANK) .AND.
     *      (WEIGHT(IPOL,LOOP).GT.0.0).AND. (IREF.GT.0) .AND.
     *      (IREF.LE.MAXANT)) ANTCNT(IREF) = ANTCNT(IREF) + 1
 10      CONTINUE
      IREF = 0
      MCNT = 0
C                                       Which one used most
      DO 20 LOOP = 1,MAXANT
         IF (ANTCNT(LOOP) .GT. MCNT) THEN
            MCNT = ANTCNT(LOOP)
            IREF = LOOP
            END IF
 20      CONTINUE
      GETREF = IREF
C
 999  RETURN
      END
      SUBROUTINE ANTIFO (INTAB, SUBARR, ANAME, REFREQ, IERR)
C-----------------------------------------------------------------------
C   Returns the names of the antennas in a given subarray with
C   associated table INTAB.
C   Inputs:
C      INTAB   C*?  Input table object (assumed to have associated AN
C                   and SU tables)
C      SUBARR  I    Subarray number 0=> 1
C   Output:
C      ANAME   C(*)*8 Antenna names
C      REFREQ  D    Reference frequency (Hz)
C      IERR    I    Return code, O=OK, else failed.
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*), ANAME(*)*8
      DOUBLE PRECISION REFREQ
      INTEGER SUBARR, IERR
C
      CHARACTER ANTAB*36, COLLAB(2)*24, CDUMMY*1
      INTEGER   NROW, ANTNO, I, COLS(2), TYPE, DIM(3)
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
      DATA COLLAB /'NOSTA', 'ANNAME'/
C-----------------------------------------------------------------------
      IERR = 0
C                                        Make AN table object
      ANTAB = 'AN table'
      CALL OCOPY (INTAB, ANTAB, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Table type
      DIM(1) = 2
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (ANTAB, 'TBLTYPE', OOACAR, DIM, IDUM, 'AN', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Version
      DIM(1) = 1
      IDUM(1) = SUBARR
      CALL OPUT (ANTAB, 'VER', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open AN table
      CALL OOPEN (ANTAB, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get reference frequency
      CALL OGET (ANTAB, 'KEY.FREQ', TYPE, DIM, IDUM, CDUMMY, IERR)
      REFREQ = DDUM(1)
      IF (IERR.NE.0) GO TO 999
C                                        Find column numbers
      CALL TABCOL (ANTAB, 2, COLLAB, COLS, IERR)
      IF ((IERR.GE.1) .AND. (IERR.LE.10)) GO TO 999
C                                        Make sure all columns found
      DO 10 I = 1,2
         IF (COLS(I).LE.0) THEN
            MSGTXT = 'SN TABLE MISSING COLUMN ' // COLLAB(I)
            CALL MSGWRT (9)
            IERR = 7
            END IF
 10      CONTINUE
      IF (IERR.NE.0) GO TO 999
C                                       Get number of entries
      CALL OGET (ANTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IERR)
      NROW = IDUM(1)
      IF (IERR.NE.0) GO TO 999
C                                       Loop over table
      DO 100 I = 1,NROW
C                                       Read data for this row
         CALL TABDGT (ANTAB, I, COLS(1), TYPE, DIM, IDUM, CDUMMY, IERR)
         ANTNO = IDUM(1)
         IF (IERR.NE.0) GO TO 999
         ANAME(ANTNO) = ' '
         CALL TABDGT (ANTAB, I, COLS(2), TYPE, DIM, IDUM, ANAME(ANTNO),
     *      IERR)
         IF (IERR.NE.0) GO TO 999
 100     CONTINUE
C                                       Close AN table
      CALL OCLOSE (ANTAB, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Delete AN object
      CALL DESTRY (ANTAB, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE SUINFO (INTAB, SUBARR, NSOUR, SNAME, SSF, IERR)
C-----------------------------------------------------------------------
C   Returns the names of the sources in a given subarray with
C   associated table INTAB.
C   Inputs:
C      INTAB   C*?  Input table object (assumed to have associated AN
C                   and SU tables)
C      SUBARR  I    Subarray number 0=> 1
C   Output:
C      NSOUR   I    The number of sources
C      SNAME   C(*)*8 Source names
C      SSF     L    Single source file?
C      IERR    I    Return code, O=OK, else failed.
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*), SNAME(*)*8
      INTEGER SUBARR, IERR, NSOUR, SNO
C
      CHARACTER SUTAB*36, CDUMMY*1
      INTEGER   NROW, TYPE, DIM(3), I
      LOGICAL   SSF
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:PAOOF.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                        Make SU table object
      SUTAB = 'SU table'
      CALL OCOPY (INTAB, SUTAB, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Table type
      SSF = .FALSE.
      DIM(1) = 2
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (SUTAB, 'TBLTYPE', OOACAR, DIM, IDUM, 'SU', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Version
      DIM(1) = 1
      IDUM(1) = SUBARR
      CALL OPUT (SUTAB, 'VER', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open AN table
      CALL OOPEN (SUTAB, 'READ', IERR)
      IF (IERR.NE.0) THEN
C                                       Single source file
         SSF = .TRUE.
         NSOUR = 1
         SNAME(1) = '        '
         IERR = 0
         WRITE (MSGTXT,1000)
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Get number of entries
      CALL OGET (SUTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IERR)
      NROW = IDUM(1)
      IF (IERR.NE.0) GO TO 999
C                                       Loop over table
      DO 100 I = 1,NROW
C                                       Read data for this row
         CALL TABDGT (SUTAB, I, 1, TYPE, DIM, IDUM, CDUMMY, IERR)
         SNO = IDUM(1)
         IF (IERR.NE.0) GO TO 999
         NSOUR = MAX (NSOUR, SNO)
         SNAME(SNO) = ' '
         CALL TABDGT (SUTAB, I, 2, TYPE, DIM, IDUM, SNAME(SNO),
     *      IERR)
         IF (IERR.NE.0) GO TO 999
 100     CONTINUE
C                                       Close SU table
         CALL OCLOSE (SUTAB, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Delete SU object
         CALL DESTRY (SUTAB, IERR)
         IF (IERR.NE.0) GO TO 999
C
 999  RETURN
C---------------------------------------------------------------
 1000 FORMAT ('ASSUMING SINGLE SOURCE FILE')
      END

      SUBROUTINE ZTTOPN (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C! open a terminal device
C# Z2 Terminal
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2002, 2004, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Open a terminal - does not use MSGWRT because it is called by
C   ZMSGOP.  The FTAB open is done here (not to be done in ZOPEN).
C   Inputs:
C      LUN    I   Logical unit number (must be 5 or 6)
C   Output:
C      FIND   I   Position in FTAB
C      IERR   I   Error return code: 0 => no error
C                    1 => Fortran open error
C                    2 => input error
C   Generic UNIX version - assume unit will be used for terminal I/O.
C   If a message terminal is specified via the environment variable
C   TASKTT<npops>, or TTDEV and the latter not set to "TTDEV00", ZTTOP2
C   is called.  This will either redirect the stdout and stderr streams
C   to a physical terminal, or will open a socket (Berkeley but
C   supported on most systems) to the message window via service
C   "msgserv".  Any error with msgserver code causes TTDEV to be reset
C   to TTDEV00.  Note that the ZTTOP2 code for TASKTT<npops> has not
C   been implemented in the generic case.
C
C   This version remembers if the logical/environment variable
C   translation has already been done and skips unnecessary translation.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
C
      INTEGER   XLEN, XLNB, JERR, I
      LOGICAL   SALONE
      CHARACTER DEVTTY*16, TASKTT*8, XLATED*256, XLATD2*256
      HOLLERITH HLATED(64)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
C                                       Keep this around
      SAVE XLATED, XLATD2
      INCLUDE 'INCS:VSAT.INC'
      DATA XLATD2, XLATED  /2 * ' '/
C-----------------------------------------------------------------------
C                                       Check inputs.
      FIND = 0
      IF ((LUN.NE.5) .AND. (LUN.NE.6)) THEN
         IERR = 2
         GO TO 999
         END IF
C                                       If the LUN is not marked as open
C                                       in the file table then open it,
C                                       otherwise do nothing:
      CALL LSERCH ('SRCH', LUN, FIND, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         IERR = 0
C                                       Open in FTAB
         CALL LSERCH ('OPEN', LUN, FIND, .FALSE., JERR)
         IF (JERR.NE.0) FIND = 0
C                                       If LUN designates standard
C                                       output then, if the current
C                                       program is not in the list of
C                                       stand-alone AIPS tasks look for
C                                       a translation of TASKTTn where n
C                                       is the current POPS number:
         IF (LUN.EQ.6) THEN
            SALONE = .FALSE.
            DO 15 I = 1,NSANAM
               IF (TSKNAM.EQ.SATASK(I)) SALONE = .TRUE.
 15            CONTINUE
            IF (.NOT.SALONE) THEN
C                                       Check COMMON variable in case
C                                       the translation is already done.
               IF (MSGRMB.EQ.1) THEN
C                                       We already did the translation
C                                       so skip straight to ZTTOP2
                  CALL CHR2H (256, XLATD2, 1, HLATED)
                  CALL ZTTOP2 (FTAB(FIND), HLATED, JERR)
                  IF (JERR.EQ.6) THEN
                     IERR = 0
                     XLATD2 = ' '
                     MSGRMB = 0
                  ELSE IF (JERR.EQ.3) THEN
                     WRITE (*, 1002) JERR, DEVTTY
                     IERR = 1
                     XLATD2 = ' '
                     MSGRMB = 0
                     GO TO 999
                  ELSE IF (JERR.NE.0) THEN
                     WRITE (*, 1000) JERR, DEVTTY
                     IERR = 1
                     XLATD2 = ' '
                     MSGRMB = 0
                     GO TO 999
                     END IF
               ELSE
C                                       Coming in cold so check for a
C                                       physical message terminal
C                                       definition in TASKTTn.
                  TASKTT = 'TASKTT'
                  CALL ZEHEX (NPOPS, 1, TASKTT(7:7))
                  XLEN = LEN (XLATED)
                  CALL ZTRLOG (7, TASKTT, XLEN, XLATED, XLNB, JERR)
C                                       If TASKTTn is defined then more
C                                       action is needed that can't be
C                                       done here.  On a real message
C                                       terminal, a freopen of stdout
C                                       and stderr will be done.
                  IF (JERR.EQ.0) THEN
                     DEVTTY = XLATED(1:XLNB)
                     CALL CHR2H (256, DEVTTY, 1, HLATED)
                     CALL ZTTOP2 (FTAB(FIND), HLATED, JERR)
                     IF (JERR.NE.0) THEN
                        WRITE (*, 1000) JERR, DEVTTY
                        IERR = 1
                        GO TO 999
                        END IF
                  ELSE
C                                       TASKTTn not defined, but check
C                                       for TTDEV and TTDEVnn for the
C                                       Message Server X11/socket stuff
                     TASKTT = 'TTDEV'
                     XLEN = LEN (XLATED)
                     CALL ZTRLOG (5, TASKTT, XLEN, XLATED, XLNB, JERR)
                     IF (JERR.NE.0) THEN
C                                       For compatibility, silently
C                                       ignore case where not defined.
                        IERR = 0
                     ELSE
C                                       That should be TTDEVxx, so pass
C                                       it directly to ZTTOP2 unless it
C                                       is TTDEV00.
                        DEVTTY = XLATED(1:XLNB)
                        IF (DEVTTY .NE. 'TTDEV00') THEN
                           CALL CHR2H (256, DEVTTY, 1, HLATED)
                           CALL ZTTOP2 (FTAB(FIND), HLATED, JERR)
C                                       If there were problems, revert
C                                       to normal output silently.
                           IF (JERR.EQ.6) THEN
C                                       Problems with socket or connect.
C                                       Most likely the message window
C                                       died so just go back to normal
C                                       mode without a fuss.
                              IERR = 0
                              XLATD2 = ' '
                              MSGRMB = 0
C                                       get{host/serv}byname failed
                           ELSE IF (JERR.EQ.3) THEN
                              WRITE (*, 1002) JERR, DEVTTY
                              XLATD2 = ' '
                              MSGRMB = 0
                              IERR = 1
                              GO TO 999
                           ELSE IF (JERR.NE.0) THEN
                              WRITE (*, 1000) JERR, DEVTTY
                              XLATD2 = ' '
                              MSGRMB = 0
                              IERR = 1
                              GO TO 999
C                                       Remember for next time.
                           ELSE
                              XLATD2 = DEVTTY
                              MSGRMB = 1
C                                       end check on ZTTOP2 status
                              END IF
C                                       end check on not TTDEV00
                           END IF
C                                       end check on TTDEV xlation stat
                        END IF
C                                       end check on TASKTT xlation stat
                     END IF
C                                       end check on XLATD2 not blank
                  END IF
C                                       end check on standalone
               END IF
C                                       end check on LUN = 6
            END IF
C                                       end check on LSERCH status
         END IF
C                                       Success. Clear error status of
C                                       LUN in file table:
      FTAB(FIND+NFCBER) = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR ', I2, ' ASSIGNING OUTPUT TO ', A)
 1002 FORMAT ('ERROR ', I2, ' ON UNIT ', A, ', GETTING HOST/SERVICE BY',
     *   ' NAME')
      END

      SUBROUTINE FGSEL (DISKI, CNOI, DISKO, CNOO, VER, CATIN, CATOUT,
     *   LUNI, LUNO, BIF, EIF, BCHAN, ECHAN, TB, TE, IFQID, ISUB, JSUB,
     *   BUFFER, OBUFF, IRET)
C-----------------------------------------------------------------------
C! Copies and renumbers the IFs in an FG table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-2000, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Copies and renumbers the IFs in an FG table, can also modify the
C   FQ ID.
C   Inputs:
C      DISKI           I       Input volume number
C      CNOI            I       Input catalog number
C      DISKO           I       Output volume number
C      CNOO            I       Output catalog number
C      VER             I       Version to check/modify
C      CATIN(256)      I       Input catalog header
C      CATOUT(256)     I       Output catalog header
C      LUNI            I       LUN to use
C      LUNO            I       LUN to use
C      BIF             I       Start IF number
C      EIF             I       End IF number
C      BCHAN           I       First channel
C      ECHAN           I       Last channel
C      TB       D        Beginning time in days
C      TE       D        Ending time in days
C      IFQID           I       FQ ID to select (set to 1 on output)
C                              if <= 0 then output value unchanged.
C      ISUB     I        Selected subarray (= 0 any)
C      JSUB     I        Output subarray number (< 0 => NO CHANGE)
C   Input/Output:
C      BUFFER          I(*)    Work buffer
C      OBUFF           I(*)    Work buffer
C   Output:
C      IRET            I       Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER DISKI, CNOI, DISKO, CNOO, VER, CATIN(256), CATOUT(256),
     *   LUNI, LUNO, BIF, EIF, BCHAN, ECHAN, IFQID, ISUB, JSUB,
     *   BUFFER(*), OBUFF(*), IRET
      DOUBLE PRECISION TB, TE
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER REASON*24
      INTEGER   OVER, IFGRNO, FGKOLS(MAXFGC), FGNUMV(MAXFGC),
     *   OKOLS(MAXFGC), ONUMV(MAXFGC), NFGROW, I, OFGRNO,
     *   SOURID, SUBA, FREQID, ANTS(2), IFS(2), CHANS(2)
      LOGICAL PFLAGS(4), DROP, REFMT
      REAL    TIMER(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       Open FG file
      CALL FLGINI ('READ', BUFFER, DISKI, CNOI, VER, CATIN, LUNI,
     *  IFGRNO, FGKOLS, FGNUMV, IRET)
      IF (IRET.EQ.2) THEN
         IRET = 0
         GO TO 999
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       # rows in old table
      NFGROW = BUFFER(5)
      REFMT = JSUB.GE.0
C                                       Open up new FG table
      OVER = VER
      CALL FLGINI ('WRIT', OBUFF, DISKO, CNOO, OVER, CATOUT, LUNO,
     *  OFGRNO, OKOLS, ONUMV, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 100 I = 1, NFGROW
         CALL TABFLG ('READ', BUFFER, IFGRNO, FGKOLS, FGNUMV,
     *      SOURID, SUBA, FREQID, ANTS, TIMER, IFS, CHANS, PFLAGS,
     *      REASON, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1020) IRET
            GO TO 990
            END IF
         DROP = IRET.LT.0
C                                       Is this FQ ID selected ?
         DROP = DROP .OR. ((IFQID.GT.0) .AND. (IFQID.NE.FREQID) .AND.
     *      (FREQID.GT.0))
C                                       Is this FQ ID selected ?
         DROP = DROP .OR. ((ISUB.GT.0) .AND. (ISUB.NE.SUBA) .AND.
     *      (SUBA.GT.0))
C                                       timerange
         DROP = DROP .OR. (TB.GT.TIMER(2)) .OR. (TE.LT.TIMER(1))
C                                       Renumber IFs
         IF ((BIF.GT.0) .AND. (EIF.GT.0)) THEN
            IF (IFS(1).GT.0) THEN
               IF (IFS(1).GT.EIF) THEN
                  DROP = .TRUE.
               ELSE IF (BIF.GT.1) THEN
                  REFMT = .TRUE.
                  IFS(1) = MAX (1, IFS(1)-BIF+1)
                  END IF
               END IF
            IF (IFS(2).GT.0) THEN
               IF (BIF.GT.1) THEN
                  REFMT = .TRUE.
                  IFS(2) = IFS(2) - BIF + 1
                  DROP = DROP .OR. (IFS(2).LE.0)
                  END IF
               IF (IFS(2).GT.EIF-BIF+1) THEN
                  REFMT = .TRUE.
                  IFS(2) = EIF - BIF + 1
                  END IF
               END IF
            END IF
C                                       Renumber channels
         IF ((BCHAN.GT.0) .AND. (ECHAN.GT.0)) THEN
            IF (CHANS(1).GT.0) THEN
               IF (CHANS(1).GT.ECHAN) THEN
                  DROP = .TRUE.
               ELSE IF (BCHAN.GT.1) THEN
                  REFMT = .TRUE.
                  CHANS(1) = MAX (1, CHANS(1)-BCHAN+1)
                  END IF
               END IF
            IF (CHANS(2).GT.0) THEN
               IF (BCHAN.GT.1) THEN
                  REFMT = .TRUE.
                  CHANS(2) = CHANS(2) - BCHAN + 1
                  DROP = DROP .OR. (CHANS(2).LE.0)
                  END IF
               IF (CHANS(2).GT.ECHAN-BCHAN+1) THEN
                  REFMT = .TRUE.
                  CHANS(2) = ECHAN - BCHAN + 1
                  END IF
               END IF
            END IF
C                                       May ignore some records
         IF (DROP) THEN
            REFMT = .TRUE.
C                                       Write new one
         ELSE
            IF (IFQID.GT.0) FREQID = 1
            IF (JSUB.GE.0) SUBA = JSUB
            CALL TABFLG ('WRIT', OBUFF, OFGRNO, OKOLS, ONUMV,
     *         SOURID, SUBA, FREQID, ANTS, TIMER, IFS, CHANS, PFLAGS,
     *         REASON, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1020) IRET
               GO TO 990
               END IF
            END IF
 100     CONTINUE
C                                       Close both tables
      CALL TABIO ('CLOS', 0, IFGRNO, BUFFER, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OFGRNO, OBUFF, OBUFF, IRET)
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         IF (REFMT) THEN
            WRITE (MSGTXT,1100) 'Reformatted FG', DISKI, CNOI, VER,
     *         DISKO, CNOO, OVER
         ELSE
            WRITE (MSGTXT,1100) 'Copied FG', DISKI, CNOI, VER, DISKO,
     *         CNOO, OVER
            END IF
         CALL MSGWRT (3)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('FGSEL: ERROR ',I3,' RETURNED FROM FLGINI')
 1020 FORMAT ('FGSEL: ERROR ',I3,' RETURNED FROM TABFLG')
 1100 FORMAT (A,' file from vol/cno/vers',I3,I5,I4,' to',I3,I5,I4)
      END

      SUBROUTINE UVPDIV (APCORE, DISKI, CNOSCI, DISKO, CNOSCO, MODEL,
     *   METHOD, DOMSG, CHANEL, NCHAN, CATBLK, JBUFSZ, FREQID,  NPFLD,
     *   PCCDSK, PCCNO, PCVER, NPCC, PFLUX, BUFF1, BUFF2, BUFF3, BUFF4,
     *   IRET)
C-----------------------------------------------------------------------
C! Divides a uv data set by the Fourier transform of a polarized model.
C# AP-util UV Map Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 1999-2000, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVPDIV divides model visibilities derived from a polarized set of
C   CLEAN components or images into the RL and LR correlations of a  uv
C   data set.  The weights of the data returned  will be the input
C   values multiplied by the model amplitude.
C      A variety of model computation methods are available; if a single
C   pass thru VISDFT, the DFT routine, is not sufficient then the data
C   is copied to a scratch file which has space for a second copy of the
C   data, the model values are computed and summed in these locations
C   and finally the model is divided into the data and written to the
C   output file.
C      Extensive use is made of commons to communicate with UVPDIV, in
C   particular /MAPDES/ (include DGDS.INC) contains most
C   of the critical information about the CLEAN components files or
C   images to be used.  Common /UVHDR/ (filled in by UVPGET) is
C   presumed to describe the uv data files.
C      Also fills in frequency table (NCHANG, FREQG) in include
C   DGDS.INC
C   Inputs:
C      DISKI      I   Input disk number. if .LE. 0 then input is a
C                     scratch file.
C      CNOSCI     I   Input file catalog slot number or /CFILES/
C                     scratch file number.
C      DISKO      I   Output disk number. if .LE. 0 then output is a
C                     scratch file.
C      CNOSCO     I   Output file catalog slot number or /CFILES/
C                     scratch file number.  If .LE. 0 then one of the
C                     internal scratch files will be used.
C      MODEL      I   1=> clean components, 2=>image.
C      METHOD     I   1=>gridded, -1=>DFT, 0=>chose.
C      DOMSG      L    If true give percent done messages for DFT.
C      CHANEL     I   First uv data channel to subtract.
C      NCHAN      I   Number of frequency channels to subtract.
C      CATBLK(256)I   Uv data catalog header record.
C      JBUFSZ     I   Size of BUFF1,2,3 in bytes, must be at least
C                     4096 words.
C      FREQID     I   Freq ID number, if it exists.
C      NPFLD      I   Number of fields in polarized model
C      PCCDSK     I(2,*) Disk numbers for Q and U models for each field
C      PCCNO      I(2,*) Catalog slot numbers for Q, U models.
C      PCVER      I(2,*) CC version numbers for for Q, U models.
C      NPCC       I(2,*) Number of CC components for for Q, U models.
C      PFLUX      R(4)   I, Q, U, V point model flux densities.
C      BUFF1,2,3,4  R   Work buffers.
C   Inputs from COMMON /MAPDES/:(DGDS.INC)
C      FACGRD      R     Value to multiply clean component fluxes
C                        by before subtraction (negative for sum).
C      SCTYPE      C*2   Scratch file type to create. (eg. 'SC')
C      NONEG       L    Stop reading comps. from a file past the first
C                       negative component. (DFT modeling ONLY)
C      LIMFLX      R    Stop at CC component < LIMFLX.
C      DOPTMD      L    Use the point model specified by PFLX, PTRAOF,
C                       PTDCOF (DFT modeling ONLY)
C      PTFLX       R    Point model flux density (Jy) (I pol. only)
C      PTRAOF      R    Point model RA offset from uv phase center
C                       (asec)
C      PTDCOF      R    Point model Dec. offset from uv phase center
C   Input from COMMON /UVHDR/:
C      LREC        I     Length of visibility record.
C      NVIS        I     Number of visibility records.
C      NRPARM      I     "Random" parameters before data, can be used
C                        to skip observed values when computing model.
C   Outputs to COMMON /MAPDES/: (DGDS.INC)
C      MFIELD      I     Number of fields
C      NSUBG(*)    I     Number of components already sub.
C      NCLNG(*)    I     Number of components per field.
C      CCDISK(*)   I     Disk numbers for CC files
C      CCCNO(*)    I     Catalog slot numbers for CC files.
C      CCVER(*)    I     CC file version number for each field.
C   Output:
C      CNOSCO     I   Output file catalog slot number or /CFILES/
C                     scratch file number.  Value returned if not
C                     specified in call.
C      IRET       I   Return error code. 0=>OK, otherwise failed.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   DISKI, CHANEL, CNOSCI, DISKO, CNOSCO, MODEL, METHOD,
     *   NCHAN, CATBLK(256), JBUFSZ, NPFLD, PCCDSK(2,NPFLD),
     *   PCCNO(2,NPFLD), PCVER(2,NPFLD), NPCC(2,NPFLD), IRET
      LOGICAL   DOMSG
      REAL      PFLUX(4), BUFF1(*), BUFF2(*), BUFF3(*), BUFF4(*)
C
      INTEGER   IP, ISCR2, DISKX, SAVNRP, SAVLRC, LUN, LUN2, CNOX, BIF,
     *   EIF, CATSCR(256), FREQID, TEMP(256), SCFRW, IV, OV, IERR
      LOGICAL   F
      INCLUDE 'INCS:PUVD.INC'
      DOUBLE PRECISION SFOFF(MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSCD.INC'
      SAVE LUN, LUN2
      DATA LUN/27/, LUN2/28/
      DATA F /.FALSE./
      DATA SFOFF /MAXIF*0.0D0/
C-----------------------------------------------------------------------
      IRET = 0
      NGRDAT = F
      SAVLRC = LREC
      SAVNRP = NRPARM
C                                       Store CATBLK for later use
      CALL COPY (256, CATBLK, SCRCAT)
      SCLREC = LREC
      SCRPRM = NRPARM
      COMPDT = CATBLK(KINAX).EQ.1
      IF (COMPDT) THEN
         CALL AXEFND (8, 'WEIGHT  ', SCRCAT(KIPCN), SCRHOL(KHPTP),
     *      WTLOC, IRET)
         IF ((IRET.NE.0) .OR. (WTLOC.LT.0)) THEN
            IRET = 5
            MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
            CALL MSGWRT (8)
            GO TO 999
            END IF
         IRET = 0
         END IF
C                                       Use UVMSUB for model.
C                                       Copy to padded scratch file.
 100  ISCR2 = 0
C                                       Message to about division
      MSGTXT = 'Divide data by model - first compute model by summing'
      CALL MSGWRT (3)
      CALL UVDPAD (DISKI, CNOSCI, ISCR2, JBUFSZ, BUFF1, BUFF2, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Get scratch file header
      IF (DISKI.LE.0) THEN
         DISKX = SCRVOL(CNOSCI)
         CNOX = SCRCNO(CNOSCI)
      ELSE
         DISKX = DISKI
         CNOX = CNOSCI
         END IF
      CALL CATIO ('READ', DISKX, CNOX, CATSCR, 'REST', BUFF1, IRET)
      IF ((IRET.GE.1) .AND. (IRET.LE.4)) GO TO 999
      IRET = 0
      CALL COPY (256, CATSCR, CATBLK)
      CALL UVPGET (IERR)
C                                       Determine BIF, EIF
      BIF = 1
      EIF = 1
C                                       If more than 1 IF
      IF (JLOCIF.GT.0) THEN
         EIF = CATBLK(KINAX+JLOCIF)
C                                       Copy part portion of IF table
         IV = 1
         OV = 1
         CALL CHNCOP (IV, OV, LUN, LUN2, DISKX, SCRVOL(ISCR2), CNOX,
     *      SCRCNO(ISCR2), CATBLK, CATSCR, BIF, EIF, FREQID, SFOFF,
     *      BUFF1, BUFF2, BUFF3, BUFF4, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Compute model.
C                                       Set factor for subtraction.
      FACGRD(1) = - FACGRD(1)
C                                       Redefine record size in DUVH.INC
C                                       Input compressed
      IF (COMPDT) THEN
         NRPARM = SAVNRP + (SAVLRC - SAVNRP) * 3 - 2
         LREC = NRPARM + (SAVLRC - SAVNRP) * 3
C                                       Input NOT compresed
      ELSE
         NRPARM = SAVNRP + (SAVLRC - SAVNRP)
         LREC = NRPARM + (SAVLRC - SAVNRP)
         END IF
      DISKX = 0
C                                       Q model
      PARMOD(1) = 0.0
      KSTOK = 2
      MFIELD = NPFLD
      PTFLX = PFLUX(2)
      DO 110 IP = 1,NPFLD
         NSUBG(IP) = 1
         NCLNG(IP) = NPCC(1,IP)
         CCDISK(IP) = PCCDSK(1,IP)
         CCCNO(IP) = PCCNO(1,IP)
         CCVER(IP) = PCVER(1,IP)
 110     CONTINUE
      CALL UVMSUB (APCORE, DISKX, ISCR2, DISKX, ISCR2, 0, MODEL,
     *   METHOD, CHANEL, NCHAN, F, DOMSG, CATSCR, JBUFSZ, FREQID,
     *   BUFF1, BUFF2, BUFF3,IRET)
      IF (IRET.NE.0) GO TO 999
C                                       U model
      MFIELD = NPFLD
      KSTOK = 3
      PTFLX = PFLUX(3)
      DO 120 IP = 1,NPFLD
         NSUBG(IP) = 1
         NCLNG(IP) = NPCC(2,IP)
         CCDISK(IP) = PCCDSK(2,IP)
         CCCNO(IP) = PCCNO(2,IP)
         CCVER(IP) = PCVER(2,IP)
 120     CONTINUE
      CALL UVMSUB (APCORE, DISKX, ISCR2, DISKX, ISCR2, 0, MODEL, METHOD,
     *   CHANEL, NCHAN, F, DOMSG, CATSCR, JBUFSZ, FREQID, BUFF1, BUFF2,
     *   BUFF3, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Restore DUVH.INC
      IF (COMPDT) THEN
         NRPARM = SAVNRP - 2
         LREC = NRPARM + (SAVLRC-SAVNRP) * 3
C                                       Fool UVDOUT
         SCRPRM = -LREC
         SCLREC = 0
      ELSE
         NRPARM = SAVNRP
         LREC = SAVLRC
         END IF
C                                       Output not compressed.
      COMPDT = .FALSE.
C                                       Reset factor for subtraction.
      FACGRD(1) = - FACGRD(1)
C                                       If no output file specified
C                                       use ISCR2
      IF ((DISKO.LE.0) .AND. (CNOSCO.LE.0)) CNOSCO = ISCR2
C                                       Divide/compress record to output
      CALL UVDOUT (ISCR2, DISKO, CNOSCO, CHANEL, NCHAN, JBUFSZ,
     *   BUFF1, BUFF2, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Delete scratch file
      IF (ISCR2.GT.0) THEN
C                                       Save CATBLK in case it's in
C                                       common
         CALL COPY (256, CATBLK, TEMP)
         SCFRW = 2
         IV = 1
         CALL MAPCLR (IV, SCRVOL(ISCR2), SCRCNO(ISCR2), SCFRW, BUFF1)
         IF (ISCR2.EQ.NSCR) NSCR = NSCR - 1
         CALL COPY (256, TEMP, CATBLK)
         END IF
C
 999  RETURN
      END

      SUBROUTINE GENKEY (CATBLK)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  Routine to generate a set of 'standard' keywords from the catalogue
C  header.
C    Inputs:
C      CATBLK        I(256)        Catalogue header
C    Outputs in common /GLOB/:
C      OBSCOD        C*8           Observing code
C      NOSTKD        I             # stokes in data
C      STK1          I             Value of 1st Stokes
C      NOBAND        I             # of band's (IF's)
C      NOCHAN        I             # spectral channels
C      REFFRQ        D             Reference freq. (Hz)
C      CHNBW         R             Bandwidth of freq. channel (Hz)
C      REFPIX        R             Reference pixel
C-----------------------------------------------------------------------
      INTEGER   CATBLK(256)
      INCLUDE 'INCS:DGLB.INC'
C
      INTEGER   CATTMP(256)
      HOLLERITH CATH(256)
      REAL      CATR(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATTMP, CATR, CATH, CATD)
C-----------------------------------------------------------------------
      CALL COPY (256, CATBLK, CATTMP)
C                                       Sensible defaults
      OBSCOD = ' '
      NOSTKD = 1
      STK1 = -1
      NOBAND = 1
      NOCHAN = 1
      REFFRQ = 0.D0
      CHNBW = 0.0
      REFPIX = 1.0
C                                       Look in header
      CALL H2CHR (8, 1, CATH(KHOBS), OBSCOD)
      NOSTKD = NCOR
      STK1 = ICOR0
      IF (JLOCIF.GT.0) NOBAND = CATBLK(KINAX+JLOCIF)
      IF (JLOCF.GT.0) THEN
         NOCHAN = CATBLK(KINAX+JLOCF)
         REFFRQ = CATD(KDCRV+JLOCF)
         CHNBW  = CATR(KRCIC+JLOCF)
         REFPIX = CATR(KRCRP+JLOCF)
         END IF
         
C
      RETURN
      END

      SUBROUTINE TVOPEN (BUF, IERR)
C-----------------------------------------------------------------------
C! sets LUNs, calls YTVOPN to open the TV device, does error messages
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2011
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Open the TV, passing pointers through common /TVDEV/.  Almost all
C   except error checking done by YTVOPN these days.
C   Outputs:
C      BUF   I(256)     Scratch buffer
C      IERR  I          Error return from YTVOPN
C                       = 10 TV unavailable to this version
C-----------------------------------------------------------------------
      INTEGER   BUF(256), IERR
C
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IERR = 10
      TVIND2 = 0
      TVLUN = 9
      TVLUN2 = 8
C                                       Do open
      IF (NTVDEV.GT.0) THEN
         TVBROK = MAX (0, TVBROK)
         CALL YTVOPN (BUF, IERR)
         IF (IERR.EQ.0) THEN
            GO TO 999
         ELSE
            IF (TVBROK.EQ.0) TVBROK = -1
            WRITE (MSGTXT,1030) IERR
            END IF
C                                       TV unavailable messages
      ELSE IF (NPOPS.LE.NINTRN) THEN
         MSGTXT = 'YOU HAVE NOT BEEN ASSIGNED A TV DEVICE'
      ELSE
         MSGTXT = 'TVS ARE NOT AVAILABLE TO BATCH AIPS'
         END IF
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('TV OPEN ERROR',I7)
      END

LOCAL INCLUDE 'PHUINT.INC'
      INTEGER   NOPT, MAXCHR
      PARAMETER (NOPT = 7)
      PARAMETER (MAXCHR = 19)
LOCAL END
LOCAL INCLUDE 'HUINT.INC'
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER NAMIN*12, CLSIN*6, NAMIN2*12, CLSIN2*6, NAMOUT*12,
     *   CLSOUT*6, NAMOU2*12, CLSOU2*6
      HOLLERITH XNAMIN(3), XCLSIN(2), XNAMI2(3), XCLSI2(2), XNAMO(3),
     *   XCLSO(2), XNAMO2(3), XCLSO2(2)
      REAL      SEQIN, DSKIN, SEQIN2, DSKIN2, DOOUT, XOUTS, XOUTD,
     *   XOUTS2, XOUTD2, XSIZE(2), BLC(7), TRC(7), XXINC, XYINC, DOGRID,
     *   XTVCH, DOWDGE, DOCIRC, RANGE(2), DPARM(10)
      INTEGER   CATBLK(256), CATBL2(256), CATBL4(256), CATBL5(256)
      REAL      CATR(256), CATR2(256), CATR4(256), CATR5(256)
      DOUBLE PRECISION CATD(128), CATD2(128), CATD4(128), CATD5(128)
      HOLLERITH CATH(256), CATH2(256), CATH4(256), CATH5(256)
      LOGICAL   DO3CHN, FIRST, T, F, DOGRC, DOOPT
      REAL      PRANGE(2,2), ABLC(7,2), ATRC(7,2), SVGAMA, OBLC(7,2),
     *   OTRC(7,2), BUFF1(MABFSS), BUFF2(MABFSS), BUFF3(MABFSS),
     *   CURPOS(2,2)
      INTEGER   LUN1, LUN2, IND1, IND2, VOL1, VOL2, SLOT1, SLOT2, SEQ1,
     *   SEQ2, IUSER, ICHAN, HCHAN, JBUFSZ, VOLO, SLOTO, SEQO, IXWDGE,
     *   IYWDGE, NX, NY, INX, IDX, INY, IDY,NLI, NLH, NLS, XINC, YINC,
     *   LWINTV(4), IDWIN(4), GRX0,GRY0, GRMENU, DOLOGI, DOLOGH, SEQO2,
     *   VOLO2, FLIP(2), IBUFF1(MABFSS)
      COMMON /MAPHDR/ CATBLK, CATBL2, CATBL4, CATBL5
      COMMON /INPARM/ XNAMIN, XCLSIN, SEQIN, DSKIN, XNAMI2, XCLSI2,
     *   SEQIN2, DSKIN2, DOOUT, XNAMO, XCLSO, XOUTS, XOUTD, XNAMO2,
     *   XCLSO2, XOUTS2, XOUTD2, XSIZE, BLC, TRC, XXINC, XYINC, DOGRID,
     *   XTVCH, DOWDGE, DOCIRC, RANGE, DPARM
      COMMON /CHARPM/ NAMIN, CLSIN, NAMIN2, CLSIN2, NAMOUT, CLSOUT,
     *   NAMOU2, CLSOU2
      COMMON /BUFFRS/ BUFF1, BUFF2, BUFF3
      COMMON /HUINTP/ PRANGE, ABLC, ATRC, OBLC, OTRC, SVGAMA, DO3CHN,
     *   T, F, FIRST, DOLOGI, DOGRC, DOOPT, LUN1, LUN2, IND1, IND2,
     *   VOL1, VOL2, SLOT1, SLOT2, SEQ1, SEQ2, IUSER, JBUFSZ, VOLO,
     *   SLOTO, SEQO, IXWDGE, IYWDGE, NX, NY, INX, IDX, INY, IDY, NLI,
     *   NLH, NLS, XINC, YINC, LWINTV, IDWIN, GRX0, GRY0, GRMENU, SEQO2,
     *   VOLO2, DOLOGH, ICHAN, HCHAN, CURPOS, FLIP
      EQUIVALENCE (IBUFF1, BUFF1)
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      EQUIVALENCE (CATBL2, CATR2, CATH2, CATD2)
      EQUIVALENCE (CATBL4, CATR4, CATH4, CATD4)
      EQUIVALENCE (CATBL5, CATR5, CATH5, CATD5)
C                                       OFM, LUTs, etc
      INCLUDE 'INCS:PTVC.INC'
      INTEGER   WBUF(TVMLUT), LGLUT(TVMLUT), RED(TVMLUT), GREEN(TVMLUT),
     *   BLUE(TVMLUT), WLUT(TVMLUT)
      REAL      ALGOFM(TVMOFM), RWBUF(TVMLUT), RLGLUT(TVMLUT),
     *   RRED(TVMLUT), RGREEN(TVMLUT), RBLUE(TVMLUT), RWLUT(TVMLUT)
      COMMON /TVLUTS/ ALGOFM, RWBUF, RLGLUT, RRED, RGREEN, RBLUE, RWLUT,
     *   WBUF, LGLUT, RED, GREEN, BLUE, WLUT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DHDR.INC'
LOCAL END
      PROGRAM HUINT
C-----------------------------------------------------------------------
C! makes a TV image from images of hue and intensity
C# TV Map-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2014-2015, 2021-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   HUINT will display an image on the TV based on two input images, one
C   of hue and one of intensity.
C   INPUTS:   (from AIPS)
C      USERID   R      user number, 0 means use logon user number,
C                      32000 means any user can be accessed.
C      INNAME   R(3)   name of intensity image.
C      INCLASS  R(2)   class of intensity image.
C      INSEQ    R      sequence number of intensity image.
C      INDISK   R      disk volume number. 0 means try all.
C      IN2NAME  R(3)   name of hue image.
C      IN2CLASS R(2)   class of hue image.
C      IN2SEQ   R      sequence number of hue image.
C      IN2DISK  R      disk volume number. 0 means try all.
C      DOOUTPUT R      > 0 write output AIPS file w RGB axis
C      OUTNAME  H(3)   Output file name
C      OUTCLASS H(2)   Output file class
C      OUTSEQ   R      Output sequence number
C      OUTDISK  R      Output disk number
C      BLC      R(7)   the coordinate in the input file to become the
C                      left hand coordinate (1,1) of the displayed and
C                      output image.
C      TRC      R(7)   the coordinate in the input file to become the
C                      top right hand corner of the display/output
C      XINC     R      X pixel increment between input and display.
C                      Ignored when doing output.
C      YINC     R      Y pixel increment between input and display.
C                      Ignored when doing output.
C      DOALIGN  R      >= 0 => hue image must align w intensity
C      TVCHAN   R      Desired TV channel
C      DOWEDGE  R      0 < DOWEDGE <= 1 -> grey wedge along top
C                      1.5 < DOWEDGE -> grey wedge along right edge
C                      2.5 < DOWEDGE both wedges
C      DOCIRCLE R      > 0 Plot coord grid rather than just ticks
C      PIXRANGE R(2)   the maximum and minimum values allowed for the
C                      map.  All other values will be clipped.  If
C                      IRANGE(1) .GE. IRANGE(2) then the map max and
C                      min will be used.
C      DPARM    R(10)  (1,2) pixrange of 2nd image
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   INPRMS, SCRTCH(MAXIMG), IRET, JERR
      CHARACTER PRGNAM*6
C
      INCLUDE 'HUINT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVD.INC'
C-----------------------------------------------------------------------
      INPRMS = 63
      PRGNAM = 'HUINT'
      CALL HUININ (PRGNAM, INPRMS, SCRTCH, IRET)
      IF (IRET.EQ.0) CALL HUEINT (SCRTCH, IRET)
C                                       close TV
      IF ((TVIND.GT.0) .AND. (TVIND2.GT.0)) THEN
         TVGAMA = SVGAMA
         CALL TVCLOS (SCRTCH, JERR)
         END IF
C                                       write output file
      IF ((IRET.EQ.0) .AND. (DOOUT.GT.0.0)) CALL HUINOU (SCRTCH, IRET)
C                                       close files
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE HUININ (PRGNAM, INPRMS, SCRTCH, IRET)
C-----------------------------------------------------------------------
C   Routine to get parameters for HUINT
C   Inputs:
C      PRGNAM   C*6      Program name
C      INPRMS   I        Number of data parameters from AIPS
C   Outputs:
C       SCRTCH  I(256)   Scratch buffer
C       IRET    I        Return code 0=> OK, else just go to DIE
C   Task parameters are returned in common /INPARM/
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   INPRMS, SCRTCH(*), IRET
C
      INCLUDE 'PHUINT.INC'
C
      INTEGER   IERR, IPOINT, IROUND, I, INC, J, II, IX, IY, LWIN(4),
     *   MAGF, TVCODE, MX, MY, IM, MXI, IX0, IY0, TYPE
      LOGICAL   REDUCE
      CHARACTER MTYPE*2, CHTMP*8, CHTMP1*8, SUBR*6
      DOUBLE PRECISION   DX
      REAL      X, A, TRC2, TRC3, OFFS, SLOPE
      INCLUDE 'HUINT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
      NSCR = 0
      NCFILE = 0
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      IRET = 0
      JBUFSZ = 2 * MABFSS
      T = .TRUE.
      F = .FALSE.
      FIRST = T
C                                       Get input values from AIPS.
      CALL GTPARM (PRGNAM, INPRMS, RQUICK, XNAMIN, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = T
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
      ELSE
         RQUICK = F
      END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       AIPS Holleriths ->
C                                       characters
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
      CALL H2CHR (12, 1, XNAMI2, NAMIN2)
      CALL H2CHR (6, 1, XCLSI2, CLSIN2)
      CALL H2CHR (12, 1, XNAMO, NAMOUT)
      CALL H2CHR (6, 1, XCLSO, CLSOUT)
      CALL H2CHR (12, 1, XNAMO2, NAMOU2)
      CALL H2CHR (6, 1, XCLSO2, CLSOU2)
C
      LUN1 = 16
      LUN2 = 17
      SEQ1 = IROUND (SEQIN)
      SEQ2 = IROUND (SEQIN2)
      VOL1 = IROUND (DSKIN)
      VOL2 = IROUND (DSKIN2)
      IUSER = NLUSER
      ICHAN = IROUND (XTVCH)
C                                       Open intensity map file
      MTYPE = 'MA'
      SUBR = 'MAPOPN'
      CALL MAPOPN ('READ', VOL1, NAMIN, CLSIN, SEQ1, MTYPE, IUSER,
     *   LUN1, IND1, SLOT1, CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 990
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = VOL1
      FCNO(NCFILE) = SLOT1
      FRW(NCFILE) = 0
C                                       Check windows
      TRC2 = TRC(3)
      TRC3 = TRC(4)
      CALL RCOPY (5, BLC(3), TRC(3))
      SUBR = 'WINDOW'
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL RFILL (7, 0.0, OBLC)
      CALL RFILL (7, 0.0, OTRC)
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), OBLC, OTRC, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       save corners
      CALL RCOPY (5, BLC(3), TRC(3))
      CALL RCOPY (7, BLC, ABLC(1,1))
      CALL RCOPY (7, TRC, ATRC(1,1))
      CALL RCOPY (7, BLC, ABLC(1,2))
      CALL RCOPY (7, TRC, ATRC(1,2))
      ABLC(3,2) = TRC2
      ATRC(3,2) = TRC2
      CALL RCOPY (5, OBLC(3,1), OTRC(3,1))
      CALL RCOPY (7, OBLC, OBLC(1,2))
      CALL RCOPY (7, OTRC, OTRC(1,2))
      OBLC(3,2) = TRC2
      OTRC(3,2) = TRC2
C                                       Open HUE file
      REDUCE = F
      MTYPE = 'MA'
      CALL MAPOPN ('READ', VOL2, NAMIN2, CLSIN2, SEQ2, MTYPE, IUSER,
     *   LUN2, IND2, SLOT2, CATBL2, SCRTCH, IERR)
      IF (IERR.GE.2) THEN
         SUBR = 'MAPOPN'
         GO TO 990
      END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = VOL2
      FCNO(NCFILE) = SLOT2
      FRW(NCFILE) = 0
      SEQIN2 = SEQ2
      DSKIN2 = VOL2
C                                       Saturation image
C                                       Image 2 plane selection
      DO 20 I = 3,7
         J = KINAX + I - 1
         IM = 2
         IF ((CATBL2(J).LE.1) .OR. (CATBL2(KIDIM).LT.I)) THEN
            ABLC(I,2) = 1
            OBLC(I,2) = 1
         ELSE
            ABLC(I,2) = MAX (1.0, ABLC(I,2))
            IF (ABLC(I,2)-0.01.GT.CATBL2(J)) GO TO 995
            OBLC(I,2) = MAX (1.0, OBLC(I,2))
         END IF
         ATRC(I,2) = ABLC(I,2)
         OTRC(I,2) = OBLC(I,2)
 20      CONTINUE
C                                       Set Map 2 corners
      DO 30 I = 1,2
         J = KRCRP + I - 1
         IF (DOGRID.LT.-1.5) THEN
            ABLC(I,2) = ABLC(I,1)
            ATRC(I,2) = ATRC(I,1)
            OBLC(I,2) = OBLC(I,1)
            OTRC(I,2) = OTRC(I,1)
         ELSE
            ABLC(I,2) = CATR2(J) - CATR(J) + ABLC(I,1)
            ATRC(I,2) = CATR2(J) - CATR(J) + ATRC(I,1)
            OBLC(I,2) = CATR2(J) - CATR(J) + OBLC(I,1)
            OTRC(I,2) = CATR2(J) - CATR(J) + OTRC(I,1)
            END IF
         J = I - 1
         IF (DOGRID.GT.-0.1) THEN
            IF (CATR(KRCIC+J).EQ.0.0) GO TO 45
            IM = 2
            IF (CATR2(KRCIC+J).EQ.0.0) GO TO 995
            DX = CATD(KDCRV+J) + (ABLC(I,1) - CATR(KRCRP+J)) *
     *         CATR(KRCIC+J)
            X = (DX - CATD2(KDCRV+J)) / CATR2(KRCIC+J) +
     *         CATR2(KRCRP+J)
            ABLC(I,2) = IROUND (X)
            IF ((DOGRID.GE.0.1) .AND. (ABS(X-ABLC(I,2)).GT.0.2))
     *         GO TO 995
            ATRC(I,2) = ABLC(I,2) + ATRC(I,1) - ABLC(I,1)
            DX = CATD(KDCRV+J) + (OBLC(I,1) - CATR(KRCRP+J)) *
     *         CATR(KRCIC+J)
            X = (DX - CATD2(KDCRV+J)) / CATR2(KRCIC+J) +
     *         CATR2(KRCRP+J)
            OBLC(I,2) = IROUND (X)
            IF ((DOGRID.GE.0.1) .AND. (ABS(X-OBLC(I,2)).GT.0.2))
     *         GO TO 995
            OTRC(I,2) = OBLC(I,2) + OTRC(I,1) - OBLC(I,1)
            END IF
C                                       smaller subimage needed?
         IF (ABLC(I,2).LT.1.0) THEN
            ABLC(I,1) = ABLC(I,1) + 1.0 - ABLC(I,2)
            ABLC(I,2) = 1.0
            REDUCE = T
            END IF
         IF (ATRC(I,2).GT.CATBL2(KINAX+J)) THEN
            ATRC(I,1) = ATRC(I,1) + CATBL2(KINAX+J) - ATRC(I,2)
            ATRC(I,2) = CATBL2(KINAX+J)
            REDUCE = T
            END IF
         IF (ABLC(I,1).GE.ATRC(I,1)) GO TO 995
         IF (ABLC(I,2).GE.ATRC(I,2)) GO TO 995
         IF (OBLC(I,2).LT.1.0) THEN
            OBLC(I,1) = OBLC(I,1) + 1.0 - OBLC(I,2)
            OBLC(I,2) = 1.0
            REDUCE = T
            END IF
         IF (OTRC(I,2).GT.CATBL2(KINAX+J)) THEN
            OTRC(I,1) = OTRC(I,1) + CATBL2(KINAX+J) - OTRC(I,2)
            OTRC(I,2) = CATBL2(KINAX+J)
            REDUCE = T
            END IF
         IF (OBLC(I,1).GE.OTRC(I,1)) GO TO 995
         IF (OBLC(I,2).GE.OTRC(I,2)) GO TO 995
 30      CONTINUE
C                                       Check true coincidence
      IF (DOGRID.GE.0.1) THEN
         INC = 2
         DO 40 I = 1,2
            J = I - 1
            X = 0.2 * 0.2 * ABS (CATR(KRCIC+J))
            IPOINT = KHCTP+J*INC
            IM = 2
            CALL H2CHR (8, 1, CATH(IPOINT), CHTMP)
            CALL H2CHR (8, 1, CATH2(IPOINT), CHTMP1)
            IF (CHTMP.NE.CHTMP1) GO TO 995
            IF (ABS(CATR(KRCIC+J)-CATR2(KRCIC+J)).GT.X) GO TO 995
            IF (ABS(CATR(KRCRT+J)-CATR2(KRCRT+J)).GT.1.) GO TO 995
 40         CONTINUE
         END IF
C                                       Corners reduced a little
 45   IF (REDUCE) THEN
         MSGTXT = 'Input images coincident on reduced subimage only'
         CALL MSGWRT (4)
         END IF
C                                       pix ranges
      CALL RNGSET (RANGE, CATR(KRDMX), CATR(KRDMN), PRANGE(1,1))
      CALL RNGSET (DPARM, CATR2(KRDMX), CATR2(KRDMN), PRANGE(1,2))
C                                       open the TV
      IRET = 8
      SUBR = 'TVOPEN'
      CALL TVOPEN (SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       init TV
      DO3CHN = (TVIMPC.GT.0) .AND. (NGRAY.GE.2) .AND.
     *   (OFMINP+1.GE.2*(LUTOUT+1))
      IF (.NOT.DO3CHN) THEN
         MSGTXT = 'I DO NOT WORK ON NON-TRUECOLOR TVS'
         CALL MSGWRT (7)
         GO TO 999
         END IF
      IF ((ICHAN.LT.1) .OR. (ICHAN.GT.NGRAY)) ICHAN = 1
      IF (ICHAN+1.GT.NGRAY) ICHAN = NGRAY - 1
      HCHAN = ICHAN + 1
      CALL COPY (4, WINDTV, LWINTV)
      SVGAMA = TVGAMA
      CALL YHOLD ('ONNN', IERR)
      SUBR = 'YCINIT'
      CALL YCINIT (ICHAN, SCRTCH)
      IF (IERR.NE.0) GO TO 990
      CALL YCINIT (HCHAN, SCRTCH)
      IF (IERR.NE.0) GO TO 990
      SUBR = 'YSLECT'
      II = NGRAY + NGRAPH
      DO 50 I = 1,II
         CALL YSLECT ('OFFF', I, 0, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 990
 50      CONTINUE
      CALL YSLECT ('ONNN', ICHAN, 0, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL YSLECT ('ONNN', HCHAN, 0, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 990
      SUBR = 'YZERO'
      CALL YZERO (ICHAN, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL YZERO (HCHAN, IERR)
      IF (IERR.NE.0) GO TO 990
      TVCODE = 2 ** (ICHAN - 1) + 2 ** (HCHAN - 1)
      CALL YSCROL (TVCODE, 0, 0, T, IERR)
      SUBR = 'YSCROL'
      IF (IERR.NE.0) GO TO 990
C                                       anti-log OFM
      II = OFMINP + 1
      CALL RFILL (II, 0.0, ALGOFM)
      A = LOG10 (REAL(LUTOUT)) / LUTOUT
      SLOPE = 1.0 / (REAL(LUTOUT) ** 2)
      II = 2 * LUTOUT + 1
      DO 60 I = 1,II
         ALGOFM(I) = SLOPE * (10.0 ** (A * (I-1)))
60       CONTINUE
      SUBR = 'YOFM'
      TVGAMA = 1.0
      CALL YOFM ('WRIT', 7, T, ALGOFM, IERR)
      TVGAMA = SVGAMA
      IF (IERR.NE.0) GO TO 990
C                                       calculate log look up table
      A = LUTOUT / LOG10 (REAL(MAXINT))
      MXI = MAXINT + 1
      DO 65 I = 1,MAXINT
         RLGLUT(I+1) =  A * LOG10 (REAL(I))
         LGLUT(I+1) = RLGLUT(I+1) +  0.5
65       CONTINUE
      LGLUT(1) = 0
      RLGLUT(1) = 0.0
C                                       color filters
C                                       Red table: spectrum
      IF (DOCIRC.LE.0.0) THEN
         IX0 = 0.26 * MAXINT
         IX = 0.41 * MAXINT
         CALL STRLIN (0, 0, IX0, 0, RRED)
         CALL STRLIN (IX0, 0, IX, MAXINT, RRED)
         CALL STRLIN (IX, MAXINT, MAXINT, MAXINT, RRED)
C                                       Green table
         IY0 = 0.267 * MAXINT
         IX0 = 0.353 * MAXINT
         IX = 0.479 * MAXINT
         CALL STRLIN (0, IY0, IX0, MAXINT, RGREEN)
         CALL STRLIN (IX0, MAXINT, IX, MAXINT, RGREEN)
         IX0 = 0.981 * MAXINT
         CALL STRLIN (IX, MAXINT, IX0, 0, RGREEN)
         CALL STRLIN (IX0, 0, MAXINT, 0, RGREEN)
C                                       blue table
         IX0 = 0.063 * MAXINT
         IX = 0.334 * MAXINT
         CALL STRLIN (0, MAXINT, IX0, MAXINT, RBLUE)
         CALL STRLIN (IX0, MAXINT, IX, 0, RBLUE)
         CALL STRLIN (IX, 0, MAXINT, 0, RBLUE)
C                                       Circular: red table
      ELSE
         IX0 = 0.24 * MAXINT
         IX = 0.36 * MAXINT
         CALL STRLIN (0, 0, IX0, 0, RRED)
         CALL STRLIN (IX0, 0, IX, MAXINT, RRED)
         IX0 = 0.77 * MAXINT
         CALL STRLIN (IX, MAXINT, IX0, MAXINT, RRED)
         IY0 = 0.25 * MAXINT
         CALL STRLIN (IX0, MAXINT, MAXINT, IY0, RRED)
C                                       Green table
         IX0 = 0.16 * MAXINT
         IX = 0.37 * MAXINT
         CALL STRLIN (0, IY0, IX0, MAXINT, RGREEN)
         CALL STRLIN (IX0, MAXINT, IX, MAXINT, RGREEN)
         IX0 = 0.66 * MAXINT
         CALL STRLIN (IX, MAXINT, IX0, 0, RGREEN)
         CALL STRLIN (IX0, 0, MAXINT, 0, RGREEN)
C                                       Blue table
         IX0 = 0.13 * MAXINT
         IX = 0.286 * MAXINT
         CALL STRLIN (0, MAXINT, IX0, MAXINT, RBLUE)
         CALL STRLIN (IX0, MAXINT, IX, 0, RBLUE)
         IX0 = 0.57 * MAXINT
         CALL STRLIN (IX, 0, IX0, 0, RBLUE)
         IX = 0.8 * MAXINT
         CALL STRLIN (IX0, 0, IX, MAXINT, RBLUE)
         CALL STRLIN (IX, MAXINT, MAXINT, MAXINT, RBLUE)
         END IF
      RRED(1) = 0.0
      RGREEN(1) = 0.0
      RBLUE(1) = 0.0
C                                       Take log via lookup
      A = LUTOUT / LOG10 (REAL(MAXINT))
      DO 70 I = 2,MXI
         RED(I) = RRED(I) + 0.5
         GREEN(I) = RGREEN(I) + 0.5
         BLUE(I) = RBLUE(I) + 0.5
         RED(I) = LGLUT (RED(I) + 1)
         GREEN(I) = LGLUT (GREEN(I) + 1)
         BLUE(I) = LGLUT (BLUE(I) + 1)
 70      CONTINUE
      RED(1) = 0
      GREEN(1) = 0
      BLUE(1) = 0
C                                       init the LUTs
      CURPOS(1,1) = (WINDTV(3) + WINDTV(1) + 1) / 2
      CURPOS(2,1) = WINDTV(2) + (WINDTV(4) - WINDTV(2) + 1) / 3
      CURPOS(1,2) = CURPOS(1,1)
      CURPOS(2,2) = CURPOS(2,1)
      FLIP(1) = 1
      FLIP(2) = 1
      SUBR = 'HILUT'
      CALL HILUT (.FALSE., CURPOS(1,1), FLIP(1), IERR)
      IF (IERR.NE.0) GO TO 990
      CALL HILUT (.TRUE., CURPOS(1,2), FLIP(2), IERR)
      IF (IERR.NE.0) GO TO 990
C                                       step wedge size
      IXWDGE = 0
      IYWDGE = 0
      XINC = MAX (1, IROUND (XXINC))
      YINC = MAX (1, IROUND (XYINC))
      IF (NLH.LE.0) NLH = 1
      IF (((DOWDGE.GT.0.0) .AND. (DOWDGE.LE.1.5)) .OR. (DOWDGE.GT.2.5))
     *   THEN
         IYWDGE = MAX (1.0, (ATRC(2,1)-ABLC(2,1))/(8.*YINC)) + 0.5
         IYWDGE = (1 + (IYWDGE - 1) / NLH) * NLH
         END IF
      IF (DOWDGE.GT.1.5) THEN
         IXWDGE = MAX (1.0, (ATRC(1,1)-ABLC(1,1))/(8.*XINC)) + 0.5
         IXWDGE = (1 + (IXWDGE - 1) / NLH) * NLH
         END IF
C                                       check window further
      NX = (ATRC(1,1) - ABLC(1,1)) / XINC + 1.01 + IXWDGE
      IF ((NX.GT.1.5*MAXXTV(1)) .AND. (XXINC.LT.0.5)) THEN
         XINC = IROUND (REAL (NX) / REAL (MAXXTV(1)))
         IF (IXWDGE.GT.0) IXWDGE = (1 + (IXWDGE - 1) / (XINC * NLH))
     *      * NLH
         NX = (ATRC(1,1) - ABLC(1,1)) / XINC + 1.01 + IXWDGE
         END IF
      IF (NX.GT.MAXXTV(1)) THEN
         ABLC(1,1) = ABLC(1,1) + XINC * (NX - MAXXTV(1)) / 2.0 + 0.5
         ABLC(1,2) = ABLC(1,2) + XINC * (NX - MAXXTV(1)) / 2.0 + 0.5
         ATRC(1,1) = ABLC(1,1) + XINC * (MAXXTV(1) - 1 - IXWDGE)
         ATRC(1,2) = ABLC(1,2) + XINC * (MAXXTV(1) - 1 - IXWDGE)
         NX = (ATRC(1,1) - ABLC(1,1)) / XINC + 1.01 + IXWDGE
         END IF
      NY = (ATRC(2,1) - ABLC(2,1)) / YINC + 1.01 + IYWDGE
      IF ((NY.GT.1.5*MAXXTV(2)) .AND. (XYINC.LT.0.5)) THEN
         YINC = IROUND (REAL (NY) / REAL (MAXXTV(2)))
         IF (IYWDGE.GT.0) IYWDGE = (1 + (IYWDGE - 1) / (YINC * NLH))
     *      * NLH
         NY = (ATRC(2,1) - ABLC(2,1)) / YINC + 1.01 + IYWDGE
         END IF
      IF (NY.GT.MAXXTV(2)) THEN
         ABLC(2,1) = ABLC(2,1) + YINC * (NY - MAXXTV(2)) / 2.0 + 0.5
         ABLC(2,2) = ABLC(2,2) + YINC * (NY - MAXXTV(2)) / 2.0 + 0.5
         ATRC(2,1) = ABLC(2,1) + YINC * (MAXXTV(2) - 1 - IYWDGE)
         ATRC(2,2) = ABLC(2,2) + YINC * (MAXXTV(2) - 1 - IYWDGE)
         NY = (ATRC(2,1) - ABLC(2,1)) / YINC + 1.01 + IYWDGE
         END IF
      IDWIN(1) = 1
      IDWIN(2) = 1
      IDWIN(3) = NX
      IDWIN(4) = NY
      INX = NX
      INY = NY
      IDX = 1
      IDY = 1
C                                       fix up image catalog somehow
      CALL COPY (256, CATBLK, CATBL4)
      CATBLK(IIVOL) = VOL1
      CATBLK(IICNO) = SLOT1
      CATBL2(IIVOL) = VOL2
      CATBL2(IICNO) = SLOT2
      CATR(IRRAN) = PRANGE(1,1)
      CATR(IRRAN+1) = PRANGE(2,1)
      CATR2(IRRAN) = PRANGE(1,2)
      CATR2(IRRAN+1) = PRANGE(2,2)
      CALL CHR2H (2, 'HI', 1, CATH(IITRA))
      CALL CHR2H (2, 'HI', 1, CATH2(IITRA))
      DO 140 I = 1,2
         CATBLK(IIWIN+I-1) = IROUND (ABLC(I,1))
         CATBL2(IIWIN+I-1) = IROUND (ABLC(I,2))
         CATBLK(IIWIN+I+1) = IROUND (ATRC(I,1))
         CATBL2(IIWIN+I+1) = IROUND (ATRC(I,2))
 140     CONTINUE
      DO 145 I = 3,7
         CATBLK(IIDEP+I-3) = IROUND (ABLC(I,1))
         CATBL2(IIDEP+I-3) = IROUND (ABLC(I,2))
 145     CONTINUE
C                                       location on TV
      CALL COPY (4, WINDTV, LWIN)
C                                       check zoom
      MX = CSIZTV(1) * (1 + MAXCHR)
      MY = CSIZTV(2) * 2 * (1 + NOPT)
      MX = MAX (MX, NX)
      MY = MAX (MY, NY)
 150  MAGF = TVZOOM(1) + 1
      IF (MXZOOM.GT.0) MAGF = 2 ** TVZOOM(1)
      IF (MAGF.GT.1) THEN
         IF ((MAGF*MX.GE.MAXXTV(1)) .OR. (MAGF*MY.GE.MAXXTV(2))) THEN
            TVZOOM(1) = TVZOOM(1) - 1
            TVZOOM(2) = MAXXTV(1) / 2
            TVZOOM(3) = MAXXTV(2) / 2
            CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), T, IERR)
            SUBR = 'YZOOMC'
            IF (IERR.NE.0) GO TO 990
            GO TO 150
            END IF
         END IF
C                                       adjust pixels for zoom
      IF (MAGF.GT.1) THEN
         X = MAGF
         II = (TVZOOM(2) - 1.0) * (X - 1.0) / X + 1.0
         IX = WINDTV(1) - (MAGF - 1) / 2
         LWIN(1) = (IX - 1) / X + II + 0.99
         IX = WINDTV(3) - (MAGF - 1) / 2
         LWIN(3) = (IX - 1) / X + II + 0.01
         II = (MAXXTV(2) - TVZOOM(3)) * (X - 1.0) / X
         OFFS = MAXXTV(2) - II - MAXXTV(2) / X + 1.0
         IY = WINDTV(2) - (MAGF - 1) / 2
         LWIN(2) = (IY - 1.0) / X + OFFS + 0.99
         IY = WINDTV(4) - (MAGF - 1) / 2
         LWIN(4) = (IY - 1.0) / X + OFFS + 0.01
         END IF
      IX = LWIN(1) + 10
      IF (IX+INX-1.GT.LWIN(3)) IX = IX - (IX + INX - 1 - LWIN(3)) / 2
      IF (IX+INX-1.GT.MAXXTV(1)) IX = MAXXTV(1) - INX + 1
      IY = LWIN(2) + 10
      IF (IY+INY-1.GT.LWIN(4)) IY = IY - (IY + INY - 1 - LWIN(4)) / 2
      IF (IY+INY-1.GT.MAXXTV(2)) IY = MAXXTV(2) - INY + 1
      CATBL2(IICOR) = IX
      CATBL2(IICOR+1) = IY
      CATBL2(IICOR+2) = IX + INX - 1 - IXWDGE / IDX
      CATBL2(IICOR+3) = IY + INY - 1 - IYWDGE / IDY
      IX = (LWIN(1) + LWIN(3) - NX) / 2
      IX = MAX (1, IX)
      IF (IX+NX-1.GT.MAXXTV(1)) IX = MAXXTV(1) - NX + 1
      IY = (LWIN(2) + LWIN(4) - NY) / 2
      IY = MAX (1, IY)
      IF (IY+NY-1.GT.MAXXTV(2)) IY = MAXXTV(2) - NY + 1
      CATBLK(IICOR) = IX
      CATBLK(IICOR+1) = IY
      CATBLK(IICOR+2) = IX + NX - 1 - IXWDGE
      CATBLK(IICOR+3) = IY + NY - 1 - IYWDGE
      SUBR = 'YCWRIT'
      CALL YCWRIT (ICHAN, CATBLK(IICOR), CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL YCWRIT (HCHAN, CATBLK(IICOR), CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       load initial images
      DOLOGI = 0
      DOLOGH = 0
      TYPE = 0
      CALL HUINLD (TYPE, SCRTCH, IERR)
      SUBR = 'HUINLD'
      IF (IERR.NE.0) GO TO 990
C                                       create output image
      IF (DOOUT.GT.0.0) THEN
C                                       header into common, fix subimage
         CALL COPY (256, CATBLK, IBUFF1)
         CALL COPY (256, CATBL4, CATBLK)
         CALL SUBHDR (OBLC(1,1), OTRC(1,1), 1.0, 1.0)
C                                       Insert RGB axis
         DO 160 I = 1,4
            J = 7 - I
            CATBLK(KINAX+J) = CATBLK(KINAX+J-1)
            CATD(KDCRV+J) = CATD(KDCRV+J-1)
            CATR(KRCIC+J) = CATR(KRCIC+J-1)
            CATR(KRCRP+J) = CATR(KRCRP+J-1)
            CATR(KRCRT+J) = CATR(KRCRT+J-1)
            CATH(KHCTP+2*J+1) = CATH(KHCTP+2*J-1)
            CATH(KHCTP+2*J) = CATH(KHCTP+2*J-2)
 160        CONTINUE
         CATBLK(KINAX+2) = 3
         CATD(KDCRV+2) = 1.0D0
         CATR(KRCIC+2) = 1.0
         CATR(KRCRP+2) = 1.0
         CATR(KRCRT+2) = 0.0
         CALL CHR2H (8, 'RGB', 1, CATH(KHCTP+4))
         CATBLK(KIDIM) = MIN (7, CATBLK(KIDIM)+1)
C                                       Build new file cat name.
         SEQO = IROUND (XOUTS)
         VOLO = IROUND (XOUTD)
         CALL MAKOUT (NAMIN, CLSIN, SEQ1, ' ', NAMOUT, CLSOUT, SEQO)
         CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, CLSOUT, KHIMCO, CATH(KHIMC))
         CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
         CATBLK(KIIMS) = SEQO
C                                       Create new cataloged file.
         CALL MCREAT (VOLO, SLOTO, SCRTCH, IERR)
         SUBR = 'MCREAT'
         IF (IERR.NE.0) GO TO 990
         SEQO = CATBLK(KIIMS)
         NCFILE = NCFILE + 1
         FCNO(NCFILE) = SLOTO
         FVOL(NCFILE) = VOLO
         FRW(NCFILE) = 2
         CALL COPY (256, CATBLK, CATBL4)
         SEQO2 = IROUND (XOUTS2)
         VOLO2 = IROUND (XOUTD2)
         CALL COPY (256, IBUFF1, CATBLK)
         END IF
      IRET = 0
C
 990  IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1990) IERR, SUBR
         CALL MSGWRT (8)
         END IF
      GO TO 999
C                                       Maps not coincident
 995  MSGTXT = 'INPUT IMAGES ARE NOT COINCIDENT.'
      CALL MSGWRT (7)
      WRITE (MSGTXT,1995) IM, I
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('HUININ: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1990 FORMAT ('HUININ: ERROR',I5,' RETURNED FROM ROUTINE ',A)
 1995 FORMAT ('ERROR APPEARS TO BE ON IMAGE',I2,' AXIS',I2)
      END
      SUBROUTINE STRLIN (X1, Y1, X2, Y2, BUF)
C-----------------------------------------------------------------------
C   STRLIN interpolates a straight line from (X1,Y1) to (X2,Y2) into
C   BUF(X1+1) to BUF(X2+1).
C   Inputs:
C      X1    I          First X point (0-rel, i.e. >= 0)
C      Y1    I          First Y point
C      X2    I          Second X point (0-rel, >= X1)
C      Y2    I          Second Y point
C   Output:
C      BUF   R(>X2+1)   Output line in BUF(X1+1) to BUF(X2+1)
C-----------------------------------------------------------------------
      INTEGER   X1, Y1, X2, Y2
      REAL      BUF(*)
C
      INTEGER   NSTEPS, I
      REAL      INC
C-----------------------------------------------------------------------
C                                       Illegal direction
      IF (X2.GE.X1) THEN
C                                       First point
         BUF(X1+1) = Y1
         NSTEPS = X2 - X1
C                                       Interpolate
         IF (NSTEPS.GT.0) THEN
            INC = REAL(Y2-Y1) / REAL(NSTEPS)
            DO 10 I = 1,NSTEPS
               BUF(X1+I+1) = Y1 + I * INC
 10            CONTINUE
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE HILUT (HCHANG, RPOS, IFLIP, IERR)
C-----------------------------------------------------------------------
C   HILUT calculates new look up tables for hue/intensity display and
C   send them to the TV.
C   Inputs:
C      HCHANG  L       .TRUE. if hue LUTs are to be changed
C      RPOS    R(2)    Cursor position which determines the enhancement
C                      transformation
C      IFLIP   I       +1 or -1 for sign of transfer func. slope
C   Output:
C      IERR    I       Returns YLUT error code
C   Common: /AIPSCR/
C     Outputs:
C        BUFFER  I(TVMLUT)   Scratch buffer - returns the transfer
C                               function.
C        LUT     I(TVMLUT)   Scratch buffer
C   Inputs:
C      LOGLUT   I(TVMLUT)   Log look up table
C      RED      I(TVMLUT)   Look up table for red color gun func
C      GREEN    I(TVMLUT)   Look up table for green color gun func
C      BLUE     I(TVMLUT)   Look up table for blue color gun func
C-----------------------------------------------------------------------
      INTEGER   IFLIP, IERR
      LOGICAL   HCHANG
      REAL      RPOS(2)
C
      INCLUDE 'HUINT.INC'
      INTEGER   I, J, IROUND
      REAL      X, SLOPE, OFFSET, RVAL
      LOGICAL   WASYNC
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
      X = ((RPOS(1) - WINDTV(1) + 1)/ (WINDTV(3) - WINDTV(1) + 1) - 0.5)
     *   * 2.0 * MAXINT
      SLOPE = (WINDTV(4)-WINDTV(2)) / (3. * MAX (1., RPOS(2)-WINDTV(2)))
     *   * IFLIP
      OFFSET = (1.0-X) * SLOPE + MAXINT * (1-IFLIP) / 2
      J = MAXINT + 1
      X = MAXINT
      DO 10 I = 1,J
         RVAL = (I-1)*SLOPE + OFFSET + 0.5
         RWBUF(I) = MAX (1.0, MIN (X, RVAL))
         WBUF(I) = IROUND (RWBUF(I))
 10      CONTINUE
      RWBUF(1) = 0.0
      WBUF(1) = 0
      WASYNC = ISYNCH.EQ.0
      IF (WASYNC) CALL YHOLD ('ONNN', I)
C                                       Change the intensity mapping
      IF (.NOT.HCHANG) THEN
         DO 20 I = 1,J
            WLUT(I) = LGLUT(WBUF(I)+1)
 20         CONTINUE
         CALL YLUT ('WRIT', ICHAN, 7, T, WLUT, IERR)
         GO TO 990
C                                       Change the hue mapping
C                                       Red
      ELSE
         DO 60 I = 1,J
            WLUT(I) = RED(WBUF(I)+1)
 60         CONTINUE
         CALL YLUT ('WRIT', HCHAN, 4, T, WLUT, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Green
         DO 70 I = 1,J
            WLUT(I) = GREEN(WBUF(I)+1)
 70         CONTINUE
         CALL YLUT ('WRIT', HCHAN, 2, T, WLUT, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Blue
         DO 80 I = 1,J
            WLUT(I) = BLUE(WBUF(I)+1)
 80         CONTINUE
         CALL YLUT ('WRIT', HCHAN, 1, T, WLUT, IERR)
         END IF
C
 990  IF (WASYNC) CALL YHOLD ('OFFF', I)
C
 999  RETURN
      END
      SUBROUTINE HUINLD (TYPE, SCRTCH, IRET)
C-----------------------------------------------------------------------
C   HUINLD loads one or both images to the TV
C   Inputs:
C      TYPE     I          Type 1 intensity, 2 hue, else both
C      LX       I          x dimension of in-core arrays
C      LY       I          y dimension of in-core arrays
C   Outputs:
C      SCRTCH   I(1536)   TV scratch array
C      IRET     I         Return code for DIE
C-----------------------------------------------------------------------
      INTEGER   TYPE, SCRTCH(*), IRET
C
      INTEGER   I, J, IBLK, HBLK, IERR, JJ, JX, JY, BIND1, BIND2, SY,
     *   SX, IX, IY, II, LL
      REAL      X, DI(4096), DH(4096)
      CHARACTER SUBR*6
      INCLUDE 'HUINT.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
      CALL YHOLD ('ONNN', IERR)
C                                       init image windows
      JX = CATBLK(IIWIN+2) - CATBLK(IIWIN+0) + 1
      JY = CATBLK(IIWIN+3) - CATBLK(IIWIN+1) + 1
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CATBLK(IIDEP), IBLK,
     *   IERR)
      CALL COMOFF (CATBL2(KIDIM), CATBL2(KINAX), CATBL2(IIDEP), HBLK,
     *   IERR)
      IBLK = IBLK + 1
      HBLK = HBLK + 1
      IX = CATBLK(IICOR)
      IY = CATBLK(IICOR+1)
      SX = 0
      SY = 0
C                                       init the reads
      SUBR = 'MINIT'
      IF (TYPE.NE.2) THEN
         CALL MINIT ('READ', LUN1, IND1, CATBLK(KINAX), CATBLK(KINAX+1),
     *      CATBLK(IIWIN), BUFF1, JBUFSZ, IBLK, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
      IF (TYPE.NE.1) THEN
         CALL MINIT ('READ', LUN2, IND2, CATBL2(KINAX), CATBL2(KINAX+1),
     *      CATBL2(IIWIN), BUFF2, JBUFSZ, HBLK, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
      SY = 0
      DO 80 J = 1,JY
C                                       read data rows
         SUBR = 'MDISK'
         IF (TYPE.NE.2) THEN
            CALL MDISK ('READ', LUN1, IND1, BUFF1, BIND1, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
         IF (TYPE.NE.1) THEN
            CALL MDISK ('READ', LUN2, IND2, BUFF2, BIND2, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
C                                       every YINC'th row
         IF (MOD(J-1,YINC).EQ.0) THEN
C                                       scale data rows
            II = 0
            DO 65 I = 1,JX,XINC
               II = II + 1
               IF (TYPE.NE.2) THEN
                  X = BUFF1(BIND1+I-1)
                  IF (X.EQ.FBLANK) THEN
                     DI(II) = FBLANK
                  ELSE
                     X = (X - PRANGE(1,1)) / (PRANGE(2,1) - PRANGE(1,1))
                     DI(II) = MAX (0.0, MIN (1.0, X))
                     END IF
                  END IF
               IF (TYPE.NE.1) THEN
                  X = BUFF2(BIND2+I-1)
                  IF (X.EQ.FBLANK) THEN
                     DH(II) = FBLANK
                  ELSE
                     X = (X - PRANGE(1,2)) / (PRANGE(2,2) - PRANGE(1,2))
                     DH(II) = MAX (0.0, MIN (1.0, X))
                     END IF
                  END IF
 65            CONTINUE
C                                       add step wedge to right
            JJ = (J - 1) / YINC + 1
            IF (IXWDGE.GT.1) THEN
               X = REAL (JJ - 1) / REAL ((JY - 1) / YINC)
               CALL RFILL (IXWDGE, X, DI(II+1))
               DO 70 I = 1,IXWDGE
                  II = II + 1
                  DH(II) = (I - 1.0) / (IXWDGE - 1.0)
 70               CONTINUE
               END IF
            SUBR = 'YIMGIO'
            CALL HILOAD (TYPE, NX, IX, IY, DI, DH, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 990
            IY = IY + 1
            END IF
 80      CONTINUE
C                                       top step wedge
      IF (IYWDGE.GT.1) THEN
         II = NX
         X = 1.0 / REAL (II - 1)
         DO 85 I = 1,NX
            LL = MOD (I - 1, II)
            DI(I) = LL* X
 85         CONTINUE
         DO 95 J = 1,IYWDGE
            X = (J - 1.0) / (IYWDGE - 1.0)
            CALL RFILL (NX, X, DH)
            JJ = JJ + 1
            SUBR = 'YIMGIO'
            CALL HILOAD (TYPE, NX, IX, IY, DI, DH, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 990
            IY = IY + 1
 95         CONTINUE
         END IF
c      CALL YHOLD ('OFFF', IERR)
C                                        error message
 990  IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1990) IERR, SUBR
         CALL MSGWRT (7)
         IRET = 1
         IF (SUBR(1:1).EQ.'Y') IRET = 2
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1990 FORMAT ('HUINLD: ERROR',I5,' GENERATED BY ROUTINE ',A)
      END
      SUBROUTINE HILOAD (TYPE, NP, IX, IY, DI, DH, SCRTCH, IERR)
C-----------------------------------------------------------------------
C   HILOAD does the scaling, clipping of an INT/HUE pair for a row,
C   converts to RGB, scales and loads the row to 3 channels on the TV
C   Inputs:
C      TYPE     I       1 load ICHAN, 2 load HCHAN, else both
C      NP       I       Number of points in the row
C      IX       I       X position on the TV
C      IY       I       Y position on the TV
C   In/out:
C      FIRST    L       First call (inits things)
C      DI(*)    R(NP)   Intensity row
C      DH(*)    R(NP)   Hue row
C      DS(*)    R(NP)   Saturation row
C   Output:
C      IERR     I       Return code from YIMGIO
C-----------------------------------------------------------------------
      INTEGER   TYPE, NP, IX, IY, SCRTCH(*), IERR
      REAL      DI(NP), DH(NP)
C
      INTEGER   I
      REAL      S, XI(4096), XH(4096)
      INCLUDE 'HUINT.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       scale
      DO 10 I = 1,NP
         IF (TYPE.NE.2) THEN
            XI(I) = DI(I)
            IF (XI(I).NE.FBLANK) THEN
               XI(I) = MAX (0.0, MIN (1.0, XI(I)))
               IF (DOLOGI.EQ.1) THEN
                  XI(I) = LOG10 (9.0 * XI(I) + 1.0)
               ELSE IF (DOLOGI.EQ.2) THEN
                  XI(I) = 0.5 * LOG10 (99.0 * XI(I) + 1.0)
               ELSE IF (DOLOGI.EQ.3) THEN
                  XI(I) = SQRT (XI(I))
                  END IF
               XI(I) = MAX (0.0, MIN (1.0, XI(I)))
               END IF
            END IF
         IF (TYPE.NE.1) THEN
            XH(I) = DH(I)
            IF (XH(I).NE.FBLANK) THEN
               IF (DOLOGH.EQ.1) THEN
                  XH(I) = LOG10 (9.0 * XH(I) + 1.0)
               ELSE IF (DOLOGH.EQ.2) THEN
                  XH(I) = 0.5 * LOG10 (99.0 * XH(I) + 1.0)
               ELSE IF (DOLOGH.EQ.3) THEN
                  XH(I) = SQRT (XH(I))
                  END IF
               XH(I) = MAX (0.0, MIN (1.0, XH(I)))
               END IF
            END IF
 10      CONTINUE
C                                       scale to TV
      S = MAXINT - 1
      IF (TYPE.NE.2) THEN
         DO 30 I = 1,NP
            IF (DI(I).EQ.FBLANK) THEN
               SCRTCH(I) = 0
            ELSE
               SCRTCH(I) = XI(I) * S + 1.5
               END IF
 30         CONTINUE
         I = ICHAN
         CALL YIMGIO ('WRIT', I, IX, IY, 0, NP, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
      IF (TYPE.NE.1) THEN
         DO 40 I = 1,NP
            IF (DH(I).EQ.FBLANK) THEN
               SCRTCH(I) = 0
            ELSE
               SCRTCH(I) = XH(I) * S + 1.5
               END IF
 40         CONTINUE
         I = HCHAN
         CALL YIMGIO ('WRIT', I, IX, IY, 0, NP, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C
 999  RETURN
      END
      SUBROUTINE HUEINT (SCRTCH, IRET)
C-----------------------------------------------------------------------
C   HUEINT implements the interactive selection and execution of the
C   various display and interaction options of HUINT.
C   Inputs:
C   Outputs:
C      IRET     I         error return
C-----------------------------------------------------------------------
      INTEGER   SCRTCH(*), IRET
C
      INCLUDE 'PHUINT.INC'
C
      INTEGER   NOPTS, MAGF, LWIN(4), I, II, JJ, IX, IY, TYPE, IERR,
     *   IBUT, GRCS(2), CHS, NTITLE, TOPSEP, SIDSEP, TIMLIM
      LOGICAL   MENUOK, WINDOK, DOIT, LEAVE(NOPT), LEAVES(NOPT)
      REAL      X, OFFS
      CHARACTER OPTION(NOPT)*20, SUBR*6, ONLOG(4)*20, ISHELP*8,
     *   CHOICS(NOPT)*20, TITLE*8, HULOG(4)*20
      INCLUDE 'HUINT.INC'
      DATA OPTION /'ENHANCE INTENSITY', 'ENHANCE HUE',
     *   'USE LOG(INTENSITY)', 'USE LOG(HUE)', ' ', 'EXIT', 'ABORT'/
      DATA ONLOG /'USE LOG(INTENSITY)','USE ELOG(INTENSITY)',
     *   'USE SQRT(INTENSITY)', 'USE LIN(INTENSITY)'/
      DATA HULOG /'USE LOG(HUE)','USE ELOG(HUE)',
     *   'USE SQRT(HUE)', 'USE LIN(HUE)'/
      DATA LEAVE /5*.TRUE., 2*.FALSE./
C-----------------------------------------------------------------------
C                                        Initialize
      WINDOK = F
      MENUOK = F
      GRMENU = 1 + NGRAY
      NOPTS = 0
      DO 10 I = 1,NOPT
         NOPTS = NOPTS + 1
         CHOICS(NOPTS) = OPTION(I)
         LEAVES(NOPTS) = LEAVE(I)
 10      CONTINUE
C                                       all loads done
C                                       Menu interaction loop point
C                                       check window
 100  CALL YWINDO ('READ', WINDTV, IERR)
      SUBR = 'YWINDO'
      IF (IERR.NE.0) GO TO 990
      IF (WINDTV(1).NE.LWINTV(1)) MENUOK = F
      IF (WINDTV(2).NE.LWINTV(2)) MENUOK = F
      IF (WINDTV(3).NE.LWINTV(3)) MENUOK = F
      IF (WINDTV(4).NE.LWINTV(4)) MENUOK = F
      CALL COPY (4, WINDTV, LWINTV(1))
C                                       location on TV
      IF (.NOT.MENUOK) THEN
         CALL COPY (4, WINDTV, LWIN)
         MAGF = TVZOOM(1) + 1
         IF (MXZOOM.GT.0) MAGF = 2 ** TVZOOM(1)
C                                       adjust pixels for zoom
         IF (MAGF.GT.1) THEN
            X = MAGF
            II = (TVZOOM(2) - 1.0) * (X - 1.0) / X + 1.0
            IX = WINDTV(1) - (MAGF - 1) / 2
            LWIN(1) = (IX - 1) / X + II + 0.99
            IX = WINDTV(3) - (MAGF - 1) / 2
            LWIN(3) = (IX - 1) / X + II + 0.01
            II = (MAXXTV(2) - TVZOOM(3)) * (X - 1.0) / X
            OFFS = MAXXTV(2) - II - MAXXTV(2) / X + 1.0
            IY = WINDTV(2) - (MAGF - 1) / 2
            LWIN(2) = (IY - 1.0) / X + OFFS + 0.99
            IY = WINDTV(4) - (MAGF - 1) / 2
            LWIN(4) = (IY - 1.0) / X + OFFS + 0.01
            END IF
         IX = LWIN(1) + CSIZTV(1)
         IY = LWIN(4) - CSIZTV(2) * 2
         GRX0 = IX
         GRY0 = IY
         END IF
C                                       turn on menu
      GRCS(1) = GRMENU - NGRAY
      IF (MENUOK) GRCS(1) = -GRCS(1)
      GRCS(2) = MIN (NGRAPH, 4)
      ISHELP = TSKNAM
      TOPSEP = 3 * CSIZTV(2) + 1
      TITLE = ' '
      NTITLE = 0
      TIMLIM = 0
      SIDSEP = 5
      CALL TVMENU (0, 1, NOPTS, GRCS, TOPSEP, SIDSEP, ISHELP, CHOICS,
     *   TIMLIM, LEAVES, NTITLE, TITLE, CHS, IBUT, SCRTCH, IERR)
      SUBR = 'TVMENU'
      IF (IERR.NE.0) GO TO 990
      MENUOK = T
C                                       Enhance subimage
      IF (CHOICS(CHS)(:8).EQ.'ENHANCE ') THEN
         JJ = 0
         IF (CHOICS(CHS).EQ.'ENHANCE INTENSITY') JJ = 1
         IF (CHOICS(CHS).EQ.'ENHANCE HUE') JJ = 2
         IF (JJ.GT.0) THEN
            CALL HUINSI (JJ, FLIP(JJ), CURPOS(1,JJ), IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
C                                       abort
      ELSE IF (CHOICS(CHS).EQ.'ABORT') THEN
         IRET = 2
C                                       null
      ELSE IF (CHOICS(CHS).EQ.' ') THEN
C                                       Reload possible
      ELSE
C                                       Change log/linear choice
         IF ((CHOICS(CHS).EQ.ONLOG(1)) .OR. (CHOICS(CHS).EQ.ONLOG(2))
     *      .OR. (CHOICS(CHS).EQ.ONLOG(3)).OR.
     *      (CHOICS(CHS).EQ.ONLOG(4))) THEN
            DOIT = T
            DOLOGI = MOD (DOLOGI+1,4)
            CHOICS(CHS) = ONLOG(DOLOGI+1)
            MENUOK = F
            TYPE = 1
         ELSE IF ((CHOICS(CHS).EQ.HULOG(1)) .OR.
     *      (CHOICS(CHS).EQ.HULOG(2)) .OR. (CHOICS(CHS).EQ.HULOG(3)).OR.
     *      (CHOICS(CHS).EQ.HULOG(4))) THEN
            DOIT = T
            DOLOGH = MOD (DOLOGH+1,4)
            CHOICS(CHS) = HULOG(DOLOGH+1)
            MENUOK = F
            TYPE = 2
            END IF
C                                       do load function
         IF (DOIT) THEN
C                                       simple load
            CALL HUINLD (TYPE, SCRTCH, IERR)
            SUBR = 'HUINLD'
            IF (IERR.NE.0) GO TO 990
            END IF
         END IF
      IF ((CHOICS(CHS).NE.'EXIT') .AND. (CHOICS(CHS).NE.'ABORT'))
     *   GO TO 100
      IERR = 0
      CALL YHOLD ('OFFF', I)
C
 990  IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1990) IERR, SUBR
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1990 FORMAT ('HUEINT: ERROR',I5,' RETURNED BY ROUTINE ',A)
      END
      SUBROUTINE HUINSI (LJ, IFLIP, PPOS, IRET)
C-----------------------------------------------------------------------
C   HUIN1S implements single-TV channel enhancement of one of the HSI
C   components or 3-channel.
C   Inputs:
C      LJ       I          Component number (I, H = 1,2)
C   In/out:
C      FLIP     I          Sign of slope of enhancement
C      PPOS     R(2)       Cursor position last used
C   Outputs:
C      IRET     I          Return code for DIE
C-----------------------------------------------------------------------
      INTEGER   LJ, IFLIP, IRET
      REAL      PPOS(2)
C
      INTEGER   IERR, IBUT, QUAD, ITW(3)
      LOGICAL   DOIT, HCHANG
      REAL      RPOS(2), F0, POS0(2)
      CHARACTER SUBR*6
      INCLUDE 'HUINT.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
      HCHANG = LJ.EQ.2
C                                       init TV cursor
      CALL ZTIME (ITW)
      F0 = (WINDTV(4) - WINDTV(2)) / 3.0
      POS0(1) = (WINDTV(1) + WINDTV(3)) / 2.0
      POS0(2) = WINDTV(2) + F0
      IF ((PPOS(1).LT.WINDTV(1)) .OR. (PPOS(1).GT.WINDTV(3)) .OR.
     *   (PPOS(2).LT.WINDTV(2)) .OR. (PPOS(2).GT.WINDTV(4))) THEN
         RPOS(1) = POS0(1)
         RPOS(2) = POS0(2)
      ELSE
         RPOS(1) = PPOS(1)
         RPOS(2) = PPOS(2)
         END IF
C                                       turn on cursor
      QUAD = -1
      CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IERR)
      SUBR = 'YCURSE'
      IF (IERR.NE.0) GO TO 990
C                                       instructions
      MSGTXT = 'Hit button A to reverse slope of enhancement'
      CALL MSGWRT (1)
      MSGTXT = 'Hit button B to reset the enhancement to 1,0'
      CALL MSGWRT (1)
      MSGTXT = 'Hit button C or D to return to the menu'
      CALL MSGWRT (1)
      MSGTXT = 'Cursor X controls offset and Y slope of enhancement'
      CALL MSGWRT (1)
      IF (LJ.EQ.1) THEN
         MSGTXT = 'Enhancing the intensity image'
      ELSE IF (LJ.EQ.2) THEN
         MSGTXT = 'Enhancing the hue image'
         END IF
      CALL MSGWRT (1)
C                                       read loop
 50   CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IERR)
      SUBR = 'YCURSE'
      IF (IERR.NE.0) GO TO 990
      CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
      IF ((DOIT) .AND. (IBUT.LT.8)) THEN
         IF (IBUT.EQ.1) IFLIP = -IFLIP
         IF ((IBUT.EQ.2) .OR. (IBUT.EQ.3)) THEN
            RPOS(1) = POS0(1)
            RPOS(2) = POS0(2)
            IFLIP = 1
            CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IERR)
            SUBR = 'YCURSE'
            IF (IERR.NE.0) GO TO 990
            END IF
C                                       change LUTs
         CALL HILUT (HCHANG, RPOS, IFLIP, IERR)
         SUBR = 'HILUT'
         IF (IERR.NE.0) GO TO 990
         END IF
      IF (IBUT.LT.4) GO TO 50
C                                       error message
 990  IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1990) IERR, SUBR
         CALL MSGWRT (7)
         IRET = 1
         IF (SUBR(1:1).EQ.'Y') IRET = 2
         END IF
C                                       off cursor
      CALL YCURSE ('OFFF', F, F, RPOS, QUAD, IBUT, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1990 FORMAT ('HUINSI: ERROR',I5,' GENERATED BY ROUTINE ',A)
      END
      SUBROUTINE HUINOU (SCRTCH, IRET)
C-----------------------------------------------------------------------
C   HUINOU writes out the image with an RGB axis developed and filled
C   using the hue scaling prevously established.
C   Outputs:
C      SCRTCH   I(*)   Scratch buffer
C      IRET     I      Return code
C-----------------------------------------------------------------------
      INTEGER   SCRTCH(*), IRET
C
      INTEGER   I, LUNO1, LUNO2, LUNO3, INDO1, INDO2, INDO3, IWIN(4),
     *   IDEP(5), IBLI, IBLH, IBL1, IBL2, IBL3, IBINDI, IBINDH, IBIND1,
     *   IBIND2, IBIND3, IX, IY, IERR, IROUND, IDO, J, ICNT
      CHARACTER SUBR*6, PHNAME*48, LINE*72, FUNCTY(4)*2
      LOGICAL   ISBLNK
      INCLUDE 'HUINT.INC'
      REAL      BUFFI(MABFSS), BUFFH(MABFSS), SLH, OFH, RMX, RMN, SLI,
     *   OFI, X, DI, DH, XI, XH, S, A, XR, XG, XB
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA FUNCTY /'LI','LG','L2','SQ'/
C-----------------------------------------------------------------------
      IRET = 0
      FIRST = T
      ISBLNK = F
      RMX = -1.0E20
      RMN = -RMX
      ICNT = ICNT + 1
C                                       transfer functions
      X = ((CURPOS(1,1)-WINDTV(1)+1) / (WINDTV(3)-WINDTV(1)+1.) - 0.5)
     *   * 2.0
      SLI = (WINDTV(4)-WINDTV(2)) / (3.*MAX(1.,CURPOS(2,1)-WINDTV(2)))
     *   * FLIP(1)
      OFI = (1.0/MAXINT - X) * SLI + (1-FLIP(1)) / 2
      X = ((CURPOS(1,2)-WINDTV(1)+1) / (WINDTV(3)-WINDTV(1)+1.) - 0.5)
     *   * 2.0
      SLH = (WINDTV(4)-WINDTV(2)) / (3.*MAX(1.,CURPOS(2,2)-WINDTV(2)))
     *   * FLIP(2)
      OFH = (1.0/MAXINT - X) * SLH + (1-FLIP(2)) / 2
C                                       re-arrange headers
      CALL COPY (256, CATBLK, SCRTCH)
      CALL COPY (256, CATBL4, CATBLK)
      CALL COPY (256, SCRTCH, CATBL4)
C                                       Output windows
      CATBL4(IIWIN) = IROUND (OBLC(1,1))
      CATBL2(IIWIN) = IROUND (OBLC(1,2))
      CATBL4(IIWIN+1) = IROUND (OBLC(2,1))
      CATBL2(IIWIN+1) = IROUND (OBLC(2,2))
      CATBL4(IIWIN+2) = IROUND (OTRC(1,1))
      CATBL2(IIWIN+2) = IROUND (OTRC(1,2))
      CATBL4(IIWIN+3) = IROUND (OTRC(2,1))
      CATBL2(IIWIN+3) = IROUND (OTRC(2,2))
C                                       Copy any header keywords
C                                       Allow failure
      CALL KEYCOP (VOL1, SLOT1, VOLO, SLOTO, IERR)
C                                       Open new file.
      LUNO1 = LUN2 + 1
      LUNO2 = LUNO1 + 1
      LUNO3 = LUNO2 + 1
      CALL ZPHFIL ('MA', VOLO, SLOTO, 1, PHNAME, IERR)
      SUBR = 'ZOPEN'
      CALL ZOPEN (LUNO1, INDO1, VOLO, PHNAME, T, F, T, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL ZOPEN (LUNO2, INDO2, VOLO, PHNAME, T, F, T, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL ZOPEN (LUNO3, INDO3, VOLO, PHNAME, T, F, T, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Window for destination file.
      IWIN(1) = 1
      IWIN(2) = 1
      IWIN(3) = CATBLK(KINAX)
      IWIN(4) = CATBLK(KINAX+1)
      CALL FILL (5, 1, IDEP)
      CALL COMOFF (CATBL4(KIDIM), CATBL4(KINAX), CATBL4(IIDEP), IBLI,
     *   IERR)
      IBLI = IBLI + 1
      CALL COMOFF (CATBL2(KIDIM), CATBL2(KINAX), CATBL2(IIDEP), IBLH,
     *   IERR)
      IBLH = IBLH + 1
      IDEP(1) = 1
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEP, IBL1, IERR)
      IDEP(1) = 2
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEP, IBL2, IERR)
      IDEP(1) = 3
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEP, IBL3, IERR)
      IBL1 = IBL1 + 1
      IBL2 = IBL2 + 1
      IBL3 = IBL3 + 1
C                                       Read/write time
      NX = CATBLK(KINAX)
      NY = CATBLK(KINAX+1)
C                                       init the IOs
      SUBR = 'MINIT'
      CALL MINIT ('READ', LUN1, IND1, CATBL4(KINAX), CATBL4(KINAX+1),
     *   CATBL4(IIWIN), BUFFI, JBUFSZ, IBLI, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL MINIT ('READ', LUN2, IND2, CATBL2(KINAX),
     *   CATBL2(KINAX+1), CATBL2(IIWIN), BUFFH, JBUFSZ, IBLH, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL MINIT ('WRIT', LUNO1, INDO1, CATBLK(KINAX), CATBLK(KINAX+1),
     *   IWIN, BUFF1, JBUFSZ, IBL1, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL MINIT ('WRIT', LUNO2, INDO2, CATBLK(KINAX), CATBLK(KINAX+1),
     *   IWIN, BUFF2, JBUFSZ, IBL2, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL MINIT ('WRIT', LUNO3, INDO3, CATBLK(KINAX), CATBLK(KINAX+1),
     *   IWIN, BUFF3, JBUFSZ, IBL3, IERR)
      IF (IERR.NE.0) GO TO 990
      A = LOG10 (REAL(LUTOUT)) / REAL (LUTOUT)
      S = 1.0 / (REAL(LUTOUT) ** 2)
      SUBR = 'MDISK'
      DO 50 IY = 1,NY
C                                       do reads, point for writes
         CALL MDISK ('READ', LUN1, IND1, BUFFI, IBINDI, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL MDISK ('READ', LUN2, IND2, BUFFH, IBINDH, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL MDISK ('WRIT', LUNO1, INDO1, BUFF1, IBIND1, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL MDISK ('WRIT', LUNO2, INDO2, BUFF2, IBIND2, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL MDISK ('WRIT', LUNO3, INDO3, BUFF3, IBIND3, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       compute image row
         DO 30 IX = 1,NX
            I = IX - 1
C                                       blanked
            IF ((BUFFH(IBINDH+I).EQ.FBLANK) .OR.
     *         (BUFFI(IBINDI+I).EQ.FBLANK)) THEN
               BUFF1(IBIND1+I) = FBLANK
               BUFF2(IBIND2+I) = FBLANK
               BUFF3(IBIND3+I) = FBLANK
               ISBLNK = T
               ICNT = ICNT + 1
C                                       good
            ELSE
C                                       scale I
               DI = (BUFFI(IBINDI+I) - PRANGE(1,1)) /
     *            (PRANGE(2,1) - PRANGE(1,1))
               DI = MAX (0.0, MIN (1.0, DI))
               IF (DOLOGI.EQ.1) THEN
                  DI = LOG10 (9.0 * DI + 1.0)
               ELSE IF (DOLOGI.EQ.2) THEN
                  DI = 0.5 * LOG10 (99.0 * DI + 1.0)
               ELSE IF (DOLOGI.EQ.3) THEN
                  DI = SQRT (DI)
                  END IF
               DI = SLI * DI + OFI
               DI = MAX (0.0, MIN (1.0, DI))
               XI = (MAXINT - 1.0) * DI + 1.0
C                                       scale hue
               DH = (BUFFH(IBINDH+I) - PRANGE(1,2)) /
     *            (PRANGE(2,2) - PRANGE(1,2))
               DH = MAX (0.0, MIN (1.0, DH))
               IF (DOLOGH.EQ.1) THEN
                  DH = LOG10 (9.0 * DH + 1.0)
               ELSE IF (DOLOGH.EQ.2) THEN
                  DH = 0.5 * LOG10 (99.0 * DH + 1.0)
               ELSE IF (DOLOGH.EQ.3) THEN
                  DH = SQRT (DH)
                  END IF
               DH = SLH * DH + OFH
               DH = MAX (0.0, MIN (1.0, DH))
               XH = (MAXINT - 1.0) * DH + 1.0
C                                       log lookups
               IF (XI.GT.0.0) THEN
                  XI = LOG10 (XI) / A
               ELSE
                  XI = 0.0
                  END IF
               J = XH + 1.0
               XR = RRED(J) + (XH+1.0-J) * (RRED(J+1) - RRED(J))
               XG = RGREEN(J) + (XH+1.0-J) * (RGREEN(J+1) - RGREEN(J))
               XB = RBLUE(J) + (XH+1.0-J) * (RBLUE(J+1) - RBLUE(J))
               IF (XR.GT.0.0) THEN
                  XR = LOG10 (XR) / A
               ELSE
                  XR = 0.0
                  END IF
               IF (XG.GT.0.0) THEN
                  XG = LOG10 (XG) / A
               ELSE
                  XG = 0.0
                  END IF
               IF (XB.GT.0.0) THEN
                  XB = LOG10 (XB) / A
               ELSE
                  XB = 0.0
                  END IF
               BUFF1(IBIND1+I) = S * (10.0 ** (A * (XR+XI)))
               BUFF2(IBIND2+I) = S * (10.0 ** (A * (XG+XI)))
               BUFF3(IBIND3+I) = S * (10.0 ** (A * (XB+XI)))
               RMN = MIN (RMN, BUFF1(IBIND1+I))
               RMX = MAX (RMX, BUFF1(IBIND1+I))
               RMN = MIN (RMN, BUFF2(IBIND2+I))
               RMX = MAX (RMX, BUFF2(IBIND2+I))
               RMN = MIN (RMN, BUFF3(IBIND3+I))
               RMX = MAX (RMX, BUFF3(IBIND3+I))
               END IF
 30         CONTINUE
 50      CONTINUE
C                                       finish the writes
      CALL MDISK ('FINI', LUNO1, INDO1, BUFF1, IBIND1, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL MDISK ('FINI', LUNO2, INDO2, BUFF2, IBIND2, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL MDISK ('FINI', LUNO3, INDO3, BUFF3, IBIND3, IERR)
      IF (IERR.NE.0) GO TO 990
      FRW(NCFILE) = 1
C                                       close the files
      CALL ZCLOSE (LUNO1, INDO1, IERR)
      CALL ZCLOSE (LUNO2, INDO2, IERR)
      CALL ZCLOSE (LUNO3, INDO3, IERR)
      CALL ZCLOSE (LUN1, IND1, IERR)
      CALL ZCLOSE (LUN2, IND2, IERR)
C                                       update the header
      IF (RMX.LE.RMN) THEN
         MSGTXT = 'NO VALID PIXELS FOUND: QUITTING'
         CALL MSGWRT (8)
         IRET = 1
         GO TO 999
         END IF
      CATR(KRDMN) = RMN
      CATR(KRDMX) = RMX
      CATR(KRBLK) = 0.0
      IF (ISBLNK) CATR(KRBLK) = FBLANK
C                                       HI file
      CALL HIINIT (2)
      CALL HISCOP (LUNO3, LUNO2, VOL1, VOLO, SLOT1, SLOTO, CATBLK,
     *   BUFF1, SCRTCH, IERR)
      IF (IERR.GT.3) GO TO 100
C                                       HUINT history: files
      CALL HENCO1 (TSKNAM, NAMIN, CLSIN, SEQ1, VOL1, LUNO2, SCRTCH,
     *   IERR)
      IF (IERR.NE.0) GO TO 90
      CALL HENCO2 (TSKNAM, NAMIN2, CLSIN2, SEQ2, VOL2, LUNO2, SCRTCH,
     *   IERR)
      IF (IERR.NE.0) GO TO 90
C                                       HUINT history: corners
      CALL COPY (4, CATBL4(IIWIN), IWIN)
      CALL COPY (5, CATBL4(IIDEP), IDEP)
      WRITE (LINE,1050) TSKNAM, 'BLC', IWIN(1), IWIN(2), IDEP,
     *   'Intensity'
      CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 90
      WRITE (LINE,1050) TSKNAM, 'TRC', IWIN(3), IWIN(4), IDEP,
     *   'Intensity'
      CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 90
      CALL COPY (4, CATBL2(IIWIN), IWIN)
      CALL COPY (5, CATBL2(IIDEP), IDEP)
      WRITE (LINE,1050) TSKNAM, 'BLC', IWIN(1), IWIN(2), IDEP, 'Hue'
      CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 90
      WRITE (LINE,1050) TSKNAM, 'TRC', IWIN(3), IWIN(4), IDEP, 'Hue'
      CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 90
C                                       HUINT history: scaling
      WRITE (LINE,1060) TSKNAM, PRANGE(1,1), PRANGE(2,1), 'Intensity'
      CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 90
      WRITE (LINE,1061) TSKNAM, FUNCTY(DOLOGI+1), 'Intensity'
      CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 90
      WRITE (LINE,1060) TSKNAM, PRANGE(1,2), PRANGE(2,2), 'Hue'
      CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 90
      WRITE (LINE,1061) TSKNAM, FUNCTY(DOLOGH+1), 'Hue'
      CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 90
C                                       close HI
 90   IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1090) IERR
         CALL MSGWRT (6)
         END IF
      CALL HICLOS (LUNO2, T, SCRTCH, IERR)
C                                       Successful finish: image
 100  CALL CATIO ('UPDT', VOLO, SLOTO, CATBLK, 'REST', SCRTCH, IERR)
      FRW(NCFILE) = 1
C                                       write a wedge
      IDO = IROUND (DOOUT)
      IF (IDO.GE.2) THEN
         FIRST = .TRUE.
C                                       first 2 axes
         IF (XSIZE(1).LT.25.) THEN
            XSIZE(1) = CATBLK(KINAX)
            IF (MAXXTV(1).LT.XSIZE(1)) XSIZE(1) = MAXXTV(1)
            END IF
         IF (XSIZE(2).LT.20.) XSIZE(2) = MAX (XSIZE(1), 100.0) * 0.2
         CATBLK(KINAX) = XSIZE(1) + 0.1
         CATBLK(KINAX+1) = XSIZE(2) + 0.1
C                                       intensity axis
         J = 0
         IF (IDO.GE.3) J = 1
         CATD(KDCRV+J) = PRANGE(1,1)
         CATR(KRCRP+J) = 1.0
         CATR(KRCIC+J) = (PRANGE(2,1) - PRANGE(1,1)) /
     *      (CATBLK(KINAX+J) - 1.0)
         CATR(KRCRT+J) = 0.0
         CATH(KHCTP+2*J) = CATH4(KHBUN)
         CALL CHR2H (4, ' INT', 1, CATH(KHCTP+2*J+1))
C                                       hue axis
         J = 1
         IF (IDO.GE.3) J = 0
         CATD(KDCRV+J) = PRANGE(1,2)
         CATR(KRCRP+J) = 1.0
         CATR(KRCIC+J) = (PRANGE(2,2) - PRANGE(1,2)) /
     *      (CATBLK(KINAX+J) - 1.0)
         CATR(KRCRT+J) = 0.0
         CATH(KHCTP+2*J) = CATH2(KHBUN)
         CALL CHR2H (4, ' HUE', 1, CATH(KHCTP+2*J+1))
         CALL FILL (4, 1, CATBLK(KINAX+3))
C                                       create
         CALL MAKOUT (NAMIN, CLSIN, SEQ1, 'TVHWED', NAMOU2, CLSOU2,
     *      SEQO2)
         CALL CHR2H (12, NAMOU2, KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, CLSOU2, KHIMCO, CATH(KHIMC))
         CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
         CATBLK(KIIMS) = SEQO2
C                                       Create new cataloged file.
         CALL MCREAT (VOLO2, SLOTO, SCRTCH, IERR)
         SUBR = 'MCREAT'
         IF (IERR.NE.0) GO TO 990
         SEQO2 = CATBLK(KIIMS)
         NCFILE = NCFILE + 1
         FCNO(NCFILE) = SLOTO
         FVOL(NCFILE) = VOLO2
         FRW(NCFILE) = 2
C                                       Open new file.
         LUNO1 = LUN2 + 1
         LUNO2 = LUNO1 + 1
         LUNO3 = LUNO2 + 1
         CALL ZPHFIL ('MA', VOLO2, SLOTO, 1, PHNAME, IERR)
         SUBR = 'ZOPEN'
         CALL ZOPEN (LUNO1, INDO1, VOLO2, PHNAME, T, F, T, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL ZOPEN (LUNO2, INDO2, VOLO2, PHNAME, T, F, T, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL ZOPEN (LUNO3, INDO3, VOLO2, PHNAME, T, F, T, IERR)
         IF (IERR.NE.0) GO TO 990
         IWIN(1) = 1
         IWIN(2) = 1
         IWIN(3) = CATBLK(KINAX)
         IWIN(4) = CATBLK(KINAX+1)
         CALL FILL (5, 1, IDEP)
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEP, IBL1, IERR)
         IDEP(1) = 2
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEP, IBL2, IERR)
         IDEP(1) = 3
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEP, IBL3, IERR)
         IBL1 = IBL1 + 1
         IBL2 = IBL2 + 1
         IBL3 = IBL3 + 1
C                                       Read/write time
         NX = CATBLK(KINAX)
         NY = CATBLK(KINAX+1)
         ISBLNK = F
         RMX = -1.0E20
         RMN = -RMX
C                                       init the IOs
         SUBR = 'MINIT'
         CALL MINIT ('WRIT', LUNO1, INDO1, CATBLK(KINAX),
     *      CATBLK(KINAX+1), IWIN, BUFF1, JBUFSZ, IBL1, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL MINIT ('WRIT', LUNO2, INDO2, CATBLK(KINAX),
     *      CATBLK(KINAX+1), IWIN, BUFF2, JBUFSZ, IBL2, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL MINIT ('WRIT', LUNO3, INDO3, CATBLK(KINAX),
     *      CATBLK(KINAX+1), IWIN, BUFF3, JBUFSZ, IBL3, IERR)
         IF (IERR.NE.0) GO TO 990
         SUBR = 'MDISK'
         DO 150 IY = 1,NY
C                                       point for writes
            CALL MDISK ('WRIT', LUNO1, INDO1, BUFF1, IBIND1, IERR)
            IF (IERR.NE.0) GO TO 990
            CALL MDISK ('WRIT', LUNO2, INDO2, BUFF2, IBIND2, IERR)
            IF (IERR.NE.0) GO TO 990
            CALL MDISK ('WRIT', LUNO3, INDO3, BUFF3, IBIND3, IERR)
            IF (IERR.NE.0) GO TO 990
C                                       set row for I/H
            IF (IDO.LT.3) THEN
C                                       scale hue
               DH = (IY - 1.0) / (CATBLK(KINAX+1) - 1.0)
               DH = MAX (0.0, MIN (1.0, DH))
               IF (DOLOGH.EQ.1) THEN
                  DH = LOG10 (9.0 * DH + 1.0)
               ELSE IF (DOLOGH.EQ.2) THEN
                  DH = 0.5 * LOG10 (99.0 * DH + 1.0)
               ELSE IF (DOLOGH.EQ.3) THEN
                  DH = SQRT (DH)
                  END IF
               DH = SLH * DH + OFH
               DH = MAX (0.0, MIN (1.0, DH))
               XH = (MAXINT - 1.0) * DH + 1.0
               J = XH + 1.0
               XR = RRED(J) + (XH+1.0-J) * (RRED(J+1) - RRED(J))
               XG = RGREEN(J) + (XH+1.0-J) * (RGREEN(J+1) - RGREEN(J))
               XB = RBLUE(J) + (XH+1.0-J) * (RBLUE(J+1) - RBLUE(J))
               IF (XR.GT.0.0) THEN
                  XR = LOG10 (XR) / A
               ELSE
                  XR = 0.0
                  END IF
               IF (XG.GT.0.0) THEN
                  XG = LOG10 (XG) / A
               ELSE
                  XG = 0.0
                  END IF
               IF (XB.GT.0.0) THEN
                  XB = LOG10 (XB) / A
               ELSE
                  XB = 0.0
                  END IF
               DO 110 IX = 1,NX
C                                       scale I
                  DI = (IX - 1.0) / (CATBLK(KINAX) - 1.0)
                  DI = MAX (0.0, MIN (1.0, DI))
                  IF (DOLOGI.EQ.1) THEN
                     DI = LOG10 (9.0 * DI + 1.0)
                  ELSE IF (DOLOGI.EQ.2) THEN
                     DI = 0.5 * LOG10 (99.0 * DI + 1.0)
                  ELSE IF (DOLOGI.EQ.3) THEN
                     DI = SQRT (DI)
                     END IF
                  DI = SLI * DI + OFI
                  DI = MAX (0.0, MIN (1.0, DI))
                  XI = (MAXINT - 1.0) * DI + 1.0
C                                       log lookups
                  IF (XI.GT.0.0) THEN
                     XI = LOG10 (XI) / A
                  ELSE
                     XI = 0.0
                     END IF
                  I = IX - 1
                  BUFF1(IBIND1+I) = S * (10.0 ** (A * (XR+XI)))
                  BUFF2(IBIND2+I) = S * (10.0 ** (A * (XG+XI)))
                  BUFF3(IBIND3+I) = S * (10.0 ** (A * (XB+XI)))
 110              CONTINUE
C                                       set row for H/I
            ELSE
C                                       scale I
               DI = (IY - 1.0) / (CATBLK(KINAX+1) - 1.0)
               DI = MAX (0.0, MIN (1.0, DI))
               IF (DOLOGI.EQ.1) THEN
                  DI = LOG10 (9.0 * DI + 1.0)
               ELSE IF (DOLOGI.EQ.2) THEN
                  DI = 0.5 * LOG10 (99.0 * DI + 1.0)
               ELSE IF (DOLOGI.EQ.3) THEN
                  DI = SQRT (DI)
                  END IF
               DI = SLI * DI + OFI
               DI = MAX (0.0, MIN (1.0, DI))
               XI = (MAXINT - 1.0) * DI + 1.0
C                                       log lookups
               IF (XI.GT.0.0) THEN
                  XI = LOG10 (XI) / A
               ELSE
                  XI = 0.0
                  END IF
C                                       hue
               DO 120 IX = 1,NX
                  DH = (IX - 1.0) / (CATBLK(KINAX) - 1.0)
                  DH = MAX (0.0, MIN (1.0, DH))
                  IF (DOLOGH.EQ.1) THEN
                     DH = LOG10 (9.0 * DH + 1.0)
                  ELSE IF (DOLOGH.EQ.2) THEN
                     DH = 0.5 * LOG10 (99.0 * DH + 1.0)
                  ELSE IF (DOLOGH.EQ.3) THEN
                     DH = SQRT (DH)
                     END IF
                  DH = SLH * DH + OFH
                  DH = MAX (0.0, MIN (1.0, DH))
                  XH = (MAXINT - 1.0) * DH + 1.0
                  J = XH + 1.0
                  XR = RRED(J) + (XH+1.0-J) * (RRED(J+1) - RRED(J))
                  XG = RGREEN(J) + (XH+1.0-J) * (RGREEN(J+1)-RGREEN(J))
                  XB = RBLUE(J) + (XH+1.0-J) * (RBLUE(J+1) - RBLUE(J))
                  IF (XR.GT.0.0) THEN
                     XR = LOG10 (XR) / A
                  ELSE
                     XR = 0.0
                     END IF
                  IF (XG.GT.0.0) THEN
                     XG = LOG10 (XG) / A
                  ELSE
                     XG = 0.0
                     END IF
                  IF (XB.GT.0.0) THEN
                     XB = LOG10 (XB) / A
                  ELSE
                     XB = 0.0
                     END IF
                  I = IX - 1
                  BUFF1(IBIND1+I) = S * (10.0 ** (A * (XR+XI)))
                  BUFF2(IBIND2+I) = S * (10.0 ** (A * (XG+XI)))
                  BUFF3(IBIND3+I) = S * (10.0 ** (A * (XB+XI)))
 120              CONTINUE
               END IF
C                                       get scale
            DO 130 IX = 1,NX
               I = IX - 1
               IF ((BUFF1(IBIND1+I).EQ.FBLANK) .OR.
     *            (BUFF2(IBIND2+I).EQ.FBLANK) .OR.
     *            (BUFF3(IBIND3+I).EQ.FBLANK)) THEN
                  MSGTXT = 'WE ARE HERE!'
                  ISBLNK = .TRUE.
               ELSE
                  RMN = MIN (RMN, BUFF1(IBIND1+I))
                  RMX = MAX (RMX, BUFF1(IBIND1+I))
                  RMN = MIN (RMN, BUFF2(IBIND2+I))
                  RMX = MAX (RMX, BUFF2(IBIND2+I))
                  RMN = MIN (RMN, BUFF3(IBIND3+I))
                  RMX = MAX (RMX, BUFF3(IBIND3+I))
                  END IF
 130           CONTINUE
 150        CONTINUE
C                                       finish the writes
         CALL MDISK ('FINI', LUNO1, INDO1, BUFF1, IBIND1, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL MDISK ('FINI', LUNO2, INDO2, BUFF2, IBIND2, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL MDISK ('FINI', LUNO3, INDO3, BUFF3, IBIND3, IERR)
         IF (IERR.NE.0) GO TO 990
         FRW(NCFILE) = 1
C                                       close the files
         CALL ZCLOSE (LUNO1, INDO1, IERR)
         CALL ZCLOSE (LUNO2, INDO2, IERR)
         CALL ZCLOSE (LUNO3, INDO3, IERR)
C                                       history
C                                       update the header
         IF (RMX.LE.RMN) THEN
            MSGTXT = 'NO VALID PIXELS IN WEDGE FOUND: QUITTING'
            CALL MSGWRT (8)
            IRET = 1
            GO TO 999
            END IF
         CATR(KRDMN) = RMN
         CATR(KRDMX) = RMX
         CATR(KRBLK) = 0.0
         IF (ISBLNK) CATR(KRBLK) = FBLANK
C                                       HI file
         CALL HIINIT (2)
         CALL HISCOP (LUNO3, LUNO2, VOL1, VOLO2, SLOT1, SLOTO, CATBLK,
     *      BUFF1, SCRTCH, IERR)
         IF (IERR.GT.3) GO TO 200
C                                       HUINT history: files
         CALL HENCO1 (TSKNAM, NAMIN, CLSIN, SEQ1, VOL1, LUNO2, SCRTCH,
     *      IERR)
         IF (IERR.NE.0) GO TO 190
         CALL HENCO2 (TSKNAM, NAMIN2, CLSIN2, SEQ2, VOL2, LUNO2, SCRTCH,
     *   IERR)
         IF (IERR.NE.0) GO TO 190
C                                       HUINT history: corners
         CALL COPY (4, CATBL4(IIWIN), IWIN)
         CALL COPY (5, CATBL4(IIDEP), IDEP)
         WRITE (LINE,1050) TSKNAM, 'BLC', IWIN(1), IWIN(2), IDEP,
     *      'Intensity'
         CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 190
         WRITE (LINE,1050) TSKNAM, 'TRC', IWIN(3), IWIN(4), IDEP,
     *      'Intensity'
         CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 190
         CALL COPY (4, CATBL2(IIWIN), IWIN)
         CALL COPY (5, CATBL2(IIDEP), IDEP)
         WRITE (LINE,1050) TSKNAM, 'BLC', IWIN(1), IWIN(2), IDEP, 'Hue'
         CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 190
         WRITE (LINE,1050) TSKNAM, 'TRC', IWIN(3), IWIN(4), IDEP, 'Hue'
         CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       HUINT history: scaling
         WRITE (LINE,1060) TSKNAM, PRANGE(1,1), PRANGE(2,1), 'Intensity'
         CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 90
         WRITE (LINE,1061) TSKNAM, FUNCTY(DOLOGI+1), 'Intensity'
         CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 90
         WRITE (LINE,1060) TSKNAM, PRANGE(1,2), PRANGE(2,2), 'Hue'
         CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 90
         WRITE (LINE,1061) TSKNAM, FUNCTY(DOLOGH+1), 'Hue'
         CALL HIADD (LUNO2, LINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 90
C                                       close HI
 190     IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1090) IERR
            CALL MSGWRT (6)
            END IF
         CALL HICLOS (LUNO2, T, SCRTCH, IERR)
C                                       Successful finish: image
 200     CALL CATIO ('UPDT', VOLO2, SLOTO, CATBLK, 'REST', SCRTCH, IERR)
         END IF
      GO TO 999
C
 990  IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1990) IERR, SUBR
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT (A6,A,' = ',2(I5,','),4(I3,','),I3,5X,'/ For ',A,' image')
 1060 FORMAT (A6,'PIXRANGE = ',1PE12.4,',',1PE12.4,3X,'/ For ',A,
     *   ' image')
 1061 FORMAT (A6,'FUNCTYPE = ''',A2,'''  /  For ',A)
 1090 FORMAT ('HUINOU WARNING: ERROR',I5,' FROM HISTORY ROUTINES')
 1990 FORMAT ('HUINOU: ERROR',I5,' RETURNED BY ',A)
      END

LOCAL INCLUDE 'WETHR.INC'
C                                       Local include for WETHR
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXPTS, NOPTS
      PARAMETER (MAXPTS = 100000)
      PARAMETER (NOPTS = 16)
C                                       Input parameters
      REAL      XSIN, XDISIN, XNVER, XTIME(8), XANT(50), XSUBA, PIXR(2),
     *   XNCOU, XXINC, XSMOTH(3), DWT, APARM(10), XFGVER, XFGOUT,
     *   BPARM(10), DETIME, FACTOR, XLABEL, XDOTV, XGRCH, BADD(10)
      HOLLERITH XNAMEI(3), XCLAIN(2), XOPTY(1)
      CHARACTER NAMEIN*12, CLAIN*6, OPTYPE*4
C                                       Program info
C
      REAL      TSTART, TSTOP, XYSCL(2), XYOFF(2), YYMX(NOPTS),
     *   YYMN(NOPTS), XMX, XMN, XSTART, XSTOP, CHOUT(4),
     *   XXMIN(MAXANT+1), XXMAX(MAXANT+1), YYMIN(NOPTS,MAXANT+1),
     *   YYMAX(NOPTS, MAXANT+1), UBUFF(16384), XPTS(MAXPTS),
     *   YPTS(NOPTS,MAXPTS)
      INTEGER   SEQIN, DISKIN, CNOIN, IVER, ANTS(50), NCOUNT, ICODE,
     *   NPARMS, NANTSL, NPLOTS, XINC, GRCHN, TVCHN, TVCORN(4), ITPLOT,
     *   ITVER, LABEL, MUMANT, NUMPTS(MAXANT+1), NUMTOT, UBUFSZ, NPR,
     *   PRLIST(10), ISMOTH, ISUBA
      LOGICAL   DOAWNT, DOTV, DOLINE
C                                       WX info
      INCLUDE 'INCS:DWXV.INC'
      INTEGER   WXBUFF(512), WXKOLS(MAXWXC), WXNUMV(MAXWXC), IWXRNO,
     *   TABVER, NWXINR, WXRECI(MXSPWX)
      REAL      WXRECR(MXSPWX)
      DOUBLE PRECISION WXRECD(MXSPWX/2)
      CHARACTER OBSCOD*8, OBSDAT*8
      EQUIVALENCE (WXRECR, WXRECI, WXRECD)
C                                       Constants
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNVER, XTIME, XANT,
     *   XSUBA, PIXR, XNCOU, XXINC, XSMOTH, XOPTY, DWT, APARM, XFGVER,
     *   XFGOUT, BPARM, DETIME, FACTOR, XLABEL, XDOTV, XGRCH,
     *   SEQIN, DISKIN, CNOIN, IVER, ANTS, NCOUNT, ICODE, NPARMS, GRCHN,
     *   TVCHN, TVCORN, ITPLOT, ITVER, DOTV, LABEL, CHOUT, BADD
      COMMON /VGNCOM/ UBUFF, XPTS, YPTS, TSTART, TSTOP, XYSCL, XYOFF,
     *   XMX, XMN, XSTART, XSTOP, NANTSL, NPLOTS, DOAWNT, XINC, MUMANT,
     *   NUMPTS, XXMIN, XXMAX, YYMIN, YYMAX, YYMX, YYMN , NUMTOT,
     *   UBUFSZ, NPR, PRLIST, ISMOTH, ISUBA, DOLINE
      COMMON /VGNCHR/ NAMEIN, CLAIN, OPTYPE, OBSCOD, OBSDAT
      COMMON /WCDATA/ WXBUFF, WXRECR, WXKOLS, WXNUMV, IWXRNO,TABVER,
     *   NWXINR
C                                                          End WETHR
LOCAL END
      PROGRAM WETHR
C-----------------------------------------------------------------------
C! Plots data from a WX
C# UV Plot EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2002-2004, 2007-2008, 2010-2012, 2014-2018, 2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   WETHR plots WX extension files. A 'PL' extension file is made
C   which can be displayed in the usual ways .
C   Inputs:
C      INNAME.....UV file name (name).       Standard defaults.
C      INCLASS....UV file name (class).      Standard defaults.
C      INSEQ......UV file name (seq. #).     0 => highest.
C      INDISK.....Disk unit #.               0 => any.
C      INVERS.....Version number of table to plot, 0=>highest no.
C      TIMERANG...Time range of the data to be plotted. In order:
C                 Start day, hour, min. sec,
C                 end day, hour, min. sec. Days relative to ref.
C                 date.
C      ANTENNAS...A list of the antennas to be plotted. All 0 => all.
C                 If any number is negative then all antennas listed
C                 are NOT to be plotted and all others are.
C      PIXRANGE...Limit the plot to values between PIXR(1) and
C                 PIXR(2).  The plots will not exceed the min/max in
C                 the actual gains.  Basically, if PIXR(1) < PIXR(2),
C                 all plots will be on the same scale and be limited
C                 to max (datamin, PIXR(1)) through min (datamax,
C                 PIXR(2)).  If PIXR(1) >= PIXR(2), each plot will be
C                 self-scaled individually.
C      NCOUNT.....Number of antennas to plot per page (try 5).
C      OPTYPE.....Data to be plotted:'TEMP', 'PRES', 'DEWP', 'WVEL',
C                 'WDIR', 'H2OC', 'ELEC', 'RHUM', 'AHUM'
C      XTYPE......Variable data to be plotted against,
C                 1 = IAT time; 2 = elevation; 3 = HA, 4 = LST
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   IRET
      INCLUDE 'WETHR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGN /'WETHR '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      UBUFSZ = 16384 * 2
      CALL WETIN (PRGN, IRET)
C                                       Fetch data, determine scaling
      IF (IRET.EQ.0) CALL WETMAX (IRET)
C                                       Smooth and re-scale data
      IF ((IRET.EQ.0) .AND. (ISMOTH.GT.0)) CALL WETSMO (IRET)
C                                       Do plots
      IF (IRET.EQ.0) THEN
         IF (OPTYPE.EQ.'FLAG') THEN
            CALL WETFLG (IRET)
         ELSE
            CALL WETLOT (IRET)
            END IF
         END IF
      IRET = MAX (0, IRET)
C                                       Close down
      CALL DIE (IRET, WXBUFF)
C
 999  STOP
      END
      SUBROUTINE WETIN (PRGN, IERR)
C-----------------------------------------------------------------------
C   Gets the inputs parameters for WETHR.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IERR    I    Error code: 0 => ok
C      ICODE   I    1='TEMP', 2='PRES', 3='DEWP', 4='WVEL', 5='WDIR',
C                   6='WGUS', 7='PREC', 8='H2OC', 9='IONC',
c                   10='RHUM', 11='CH2O', 12='KZOP', 13='QZOP',
C                   14='WCOS', 15='WSIN', 16='DDEP'
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'WETHR.INC'
C
      CHARACTER STAT*4, PRGN*6, CODE(NOPTS)*4, TYPTMP*2
      INTEGER   IRET, BUFF(256), I, J, K, JERR, BUFFER(512), IROUND,
     *   LTYPE
      LOGICAL   T, F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA CODE /'TEMP', 'PRES', 'DEWP', 'WVEL', 'WDIR', 'WGUS', 'PREC',
     *   'H2OC', 'IONC', 'RHUM', 'CH2O', 'KZOP', 'QZOP', 'WCOS', 'WSIN',
     *   'DDEP'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      NPARMS = 113
C                                        Get input parameters.
      CALL SETUP (PRGN, NPARMS, XNAMEI, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRET = 8
         RQUICK = .FALSE.
         GO TO 990
         END IF
C                                       Decode inputs.
C                                       characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XOPTY, OPTYPE)
      CALL FILL (MAXANT+1, 0, NUMPTS)
      NUMTOT = 0
C                                       Integers
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      IVER = IROUND (XNVER)
      NCOUNT = IROUND (XNCOU)
      IF (NCOUNT.LE.0) NCOUNT = 5
      XNCOU = NCOUNT
      XINC = IROUND (XXINC)
      IF (XINC.LE.0) XINC = 1
      XXINC = XINC
      ISUBA = IROUND (XSUBA)
      DOLINE = FACTOR.LT.0.0
      FACTOR = ABS (FACTOR)
      IF ((.NOT.DOLINE) .AND. (FACTOR.LT.0.1)) FACTOR = 1.0
      IF (FACTOR.GT.10.0) FACTOR = 1.0
      IF ((DWT.LE.0.0) .OR. (DWT.GT.1.0)) DWT = 0.5
C                                       plot types
      IF ((OPTYPE.EQ.'MULT') .OR. (OPTYPE.EQ.'FLAG')) THEN
         NPR = 11
         DO 25 I = 1,10
            PRLIST(I) = IROUND (APARM(I))
            IF (PRLIST(I).LE.0) NPR = MIN (NPR, I)
 25         CONTINUE
         NPR = NPR - 1
         IF (NPR.LT.1) THEN
            NPR = 1
            PRLIST(1) = 1
            APARM(1) = 1
            END IF
      ELSE
         NPR = 1
         ICODE = 1
         DO 30 I = 1,NOPTS
            IF (OPTYPE.EQ.CODE(I)) ICODE = I
 30         CONTINUE
         CALL CHR2H (4, CODE(ICODE), 1, XOPTY)
         PRLIST(1) = ICODE
         END IF
C                                       Time range
      TSTART = XTIME(1) + (XTIME(2) / 24.0) + (XTIME(3) / (24.0*60.0)) +
     *   (XTIME(4) / (24.0*3600.0))
      TSTOP = XTIME(5) + (XTIME(6) / 24.0) + (XTIME(7) / (24.0*60.0)) +
     *   (XTIME(8) / (24.0*3600.0))
      IF (TSTART.GE.TSTOP) THEN
         TSTART = 0.0
         TSTOP = 999.0
         END IF
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
      LABEL = IROUND (XLABEL)
      LTYPE = MOD (ABS(LABEL), 100)
      IF ((LTYPE.EQ.0) .OR. (LTYPE.GT.10)) LTYPE = 3
      IF (LTYPE.GT.7) LTYPE = 7
      IF ((LTYPE.GE.4) .AND. (LTYPE.LE.6)) LTYPE = 3
      IF (LABEL.LT.0) THEN
         LABEL = (LABEL/100)*100 - LTYPE
      ELSE
         LABEL = (LABEL/100)*100 + LTYPE
         END IF
      XLABEL = LABEL
C                                       smoothing
      ISMOTH = IROUND (XSMOTH(1))
      IF (XSMOTH(2).LE.0.0) ISMOTH = 0
      IF (ISMOTH.GT.4) ISMOTH = ISMOTH - 4
      IF ((ISMOTH.LE.0) .OR. (ISMOTH.GT.4)) ISMOTH = 0
      IF ((ISMOTH.GT.0) .AND. (XSMOTH(3).LT.XSMOTH(2))) THEN
         XSMOTH(3) = XSMOTH(2)
         IF (ISMOTH.EQ.2) XSMOTH(3) = XSMOTH(2) * 3.0
         IF (ISMOTH.EQ.4) XSMOTH(3) = XSMOTH(2) * 4.0
         END IF
C                                       Find input catalog
      CNOIN = 1
      TYPTMP = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, TYPTMP,
     *   NLUSER, STAT, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      'UV', NLUSER
         GO TO 990
         END IF
C                                       Save name class etc.
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
      XDISIN = DISKIN
      XSIN = SEQIN
C                                       Read catalog header
      STAT = 'WRIT'
      IF ((DOTV) .AND. (OPTYPE.NE.'FLAG')) STAT = 'READ'
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, STAT, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FCNO(NCFILE) = CNOIN
      FVOL(NCFILE) = DISKIN
      FRW(NCFILE) = 1
      IF (DOTV) FRW(NCFILE) = 0
      XDISIN = DISKIN
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 990
      SEQIN = CATBLK(KIIMS)
      XSIN = SEQIN
C                                       Check antennas desired.
      NANTSL = 0
      DOAWNT = T
      DO 70 J = 1,50
         ANTS(J) = IROUND (XANT(J))
         IF (ANTS(J).LT.0) DOAWNT = F
C                                       Make positive
         ANTS(J) = ABS (ANTS(J))
         IF (NANTSL.LT.1) GO TO 60
            DO 50 K = 1,NANTSL
               IF (ANTS(J).EQ.ANTS(K)) ANTS(J) = 0
 50            CONTINUE
C                                       Check for multiple entries
 60      IF (ABS (ANTS(J)).GE.1) NANTSL = J
 70      CONTINUE
C                                       Make sure not too many
      IF (NANTSL.GT.MAXANT) NANTSL = MAXANT
C                                       Get antenna names
      CALL GETANT (DISKIN, CNOIN, 1, CATBLK, BUFFER, JERR)
      MUMANT = NSTNS + 1
      IF (MUMANT.LE.1) THEN
         MUMANT = MAXANT
         TIMLAB = 'IAT'
         END IF
C                                       Open table to check
      CALL WETOPN (IERR)
      IF (IERR.NE.0) GO TO 999
      XNVER = IVER
      I = MUMANT
      IF ((TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         CALL RFILL (I, TSTART, XXMIN)
         CALL RFILL (I, TSTOP, XXMAX)
      ELSE
         CALL RFILL (I, 1.E5, XXMIN)
         CALL RFILL (I, -1.E5, XXMAX)
         END IF
      I = MUMANT * NOPTS
      CALL RFILL (I, 1.E8, YYMIN)
      CALL RFILL (I, -1.E8, YYMAX)
      CALL RFILL (NOPTS, -1.E8, YYMX)
      CALL RFILL (NOPTS, 1.E8, YYMN)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR;',I7,'GETTING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',I3,
     *   ' TYPE=',A2,' USER=',I4)
 1040 FORMAT ('ERROR',I3,' COPYING CATALOG HEADER')
      END
      SUBROUTINE WETOPN (IERR)
C-----------------------------------------------------------------------
C   Routine to open WX table and get necessary information
C   Input from Common:
C      DISKIN   I     Disk number
C      CNOIN    I     Catalog slot number
C      CATBLK   I(*)  Catalog header
C   Output:
C      IERR     I     Error code, 0=OK else failed.
C   Output in common:
C      ICLRNO       I    Current cal record number
C      NCLINR       I    Number of gain records in file.
C      NUMANT       I    Number of antennas
C      ITVER        I    Version number opened.
C      KOLS         I(*) Column pointers
C      KOLTYP       I(*) Column data types
C      KOLDIM       I(*) Column dimension
C-----------------------------------------------------------------------
      INTEGER   IERR
      INCLUDE 'WETHR.INC'
C
      INTEGER   NKEY, NREC, NCOL, WXLUN, KOLS(2), KEY(2,2), JERR,
     *   KEYSUB(2,2)
      REAL      FKEY(2,2)
      CHARACTER TYPE*2, KEYS(2)*8
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA TYPE /'WX'/
      DATA KEYS /'TIME','ANTENNA'/
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
C-----------------------------------------------------------------------
C                                       Open table
      WXLUN = 28
      NKEY = 0
      NREC = 0
      NCOL = 0
      IWXRNO = 1
      CALL WXINI ('READ', WXBUFF, DISKIN, CNOIN, IVER, CATBLK, WXLUN,
     *   IWXRNO, WXKOLS, WXNUMV, OBSCOD, OBSDAT, TABVER, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1100) IERR, TYPE, IVER
         GO TO 980
         END IF
      ITVER = IVER
C                                       Get number of scans
      NWXINR = WXBUFF(5)
C                                       Check if empty
      IF (NWXINR.LE.0) THEN
         IERR = 6
         MSGTXT = 'ERROR: SELECTED TABLE IS EMPTY'
         GO TO 980
         END IF
C                                       Check sort order
      CALL FNDCOL (2, KEYS, 7, .TRUE., WXBUFF, KOLS, JERR)
      IF ((JERR.EQ.0) .AND. ((WXBUFF(43).NE.KOLS(2)) .OR.
     *   (WXBUFF(44).NE.KOLS(1)))) THEN
C                                       Close table
         CALL TABIO ('CLOS', 0, IWXRNO, FKEY, WXBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         KEY(1,1) = KOLS(2)
         KEY(2,1) = 0
         KEY(1,2) = KOLS(1)
         KEY(2,2) = 0
C                                       Sort
         CALL TABSRT (DISKIN, CNOIN, TYPE, IVER, IVER, KEY, KEYSUB,
     *      FKEY, WXBUFF, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Reopen table
         IWXRNO = 1
         CALL WXINI ('READ', WXBUFF, DISKIN, CNOIN, IVER, CATBLK, WXLUN,
     *      IWXRNO, WXKOLS, WXNUMV, OBSCOD, OBSDAT, TABVER, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1100) IERR, TYPE, IVER
            GO TO 980
            END IF
         END IF
      GO TO 999
C                                       Error
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ERROR ',I3,' OPENING ',A,' TABLE NO. ',I3)
      END
      SUBROUTINE WETMAX (IERR)
C-----------------------------------------------------------------------
C   WETMAX reads the WX table to find the max and min values.
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C      XPTS     R(*)   X values to be plotted
C      YPTS     R(*)   Y values to be plotted
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      LOGICAL   NODATA, TOMANY, OKAY, DOUBLE
      INTEGER   I, NP, IANT, IPR, JSUB
      REAL      TB, TE, TMAX, TMIN, GTIME
      INCLUDE 'WETHR.INC'
      REAL      VALUE(NOPTS)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      DOUBLE = WXKOLS(2)-WXKOLS(1).EQ.2
      NODATA = .TRUE.
      TOMANY = .FALSE.
      IF ((TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TB = TSTART
         TE = TSTOP
      ELSE
         TB = 1.0E5
         TE = -1.0E5
         END IF
      XMX = TE
      XMN = TB
C                                       Loop thru data
      NP = 1
      JSUB = 0
      DO 100 IWXRNO = 1,NWXINR,XINC
         CALL TABIO ('READ', 0, IWXRNO, WXRECR, WXBUFF, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
C                                       Record within specified
C                                       time range ?
         IF (DOUBLE) THEN
            GTIME = WXRECD(WXKOLS(WXDTIM))
         ELSE
            GTIME = WXRECR(WXKOLS(WXDTIM))
            END IF
         IF ((GTIME.LT.TSTART) .OR. (GTIME.GT.TSTOP)) GO TO 100
C                                       subarray
         IF (WXKOLS(WXSUBA).GT.0) THEN
            JSUB = WXRECI(WXKOLS(WXSUBA))
            IF ((ISUBA.NE.JSUB) .AND. (ISUBA.NE.0) .AND. (JSUB.NE.0))
     *         GO TO 100
            END IF
C                                       Antenna?
         IANT = WXRECI(WXKOLS(WXIANT))
         IF ((IANT.GT.0) .AND. (NANTSL.GT.0)) THEN
            DO 50 I = 1,NANTSL
               IF ((IANT.EQ.ANTS(I)).AND.DOAWNT) GO TO 60
               IF ((IANT.EQ.ANTS(I)).AND.(.NOT.DOAWNT)) GO TO 100
 50            CONTINUE
            IF (DOAWNT) GO TO 100
            END IF
C                                      Get start, stop times
 60      TB = MIN (TB, GTIME)
         TE = MAX (TE, GTIME)
         IANT = MAX (1, IANT+1)
C                                       Get value
         CALL WETDAT (VALUE, OKAY)
C                                       Max. - Min
         IF (OKAY) THEN
            NODATA = .FALSE.
C                                       Put in array
            IF (NUMTOT.GE.MAXPTS) THEN
               TOMANY = .TRUE.
            ELSE
               NUMTOT = NUMTOT + 1
               NUMPTS(IANT) = NUMPTS(IANT) + 1
               XPTS(NUMTOT) = GTIME
               CALL RCOPY (NPR, VALUE, YPTS(1,NUMTOT))
               XMX = MAX (XMX, GTIME)
               XMN = MIN (XMN, GTIME)
               XXMAX(IANT) = MAX (XXMAX(IANT), GTIME)
               XXMIN(IANT) = MIN (XXMIN(IANT), GTIME)
C                                       If not a summary plot
               DO 70 IPR = 1,NPR
                  IF (VALUE(IPR).NE.FBLANK) THEN
                     YYMIN(IPR,IANT) = MIN (VALUE(IPR), YYMIN(IPR,IANT))
                     YYMAX(IPR,IANT) = MAX (VALUE(IPR), YYMAX(IPR,IANT))
                     YYMX(IPR) = MAX (YYMX(IPR), VALUE(IPR))
                     YYMN(IPR) = MIN (YYMN(IPR), VALUE(IPR))
                     END IF
 70               CONTINUE
               END IF
            END IF
 100     CONTINUE
      CALL TABIO ('CLOS', 0, IWXRNO, WXRECR, WXBUFF, IERR)
C                                       reset max min on fixed scale
      IF ((PIXR(1).LT.PIXR(2)) .AND. (NPR.EQ.1)) THEN
         YYMX(1) = PIXR(2)
         YYMN(1) = PIXR(1)
         DO 120 IANT = 1,MUMANT
            IF (YYMAX(1,IANT).GE.YYMIN(1,IANT)) THEN
               YYMAX(1,IANT) = PIXR(2)
               YYMIN(1,IANT) = PIXR(1)
               END IF
 120        CONTINUE
         END IF
C                                       Set actual X range
      XSTART = TB
      XSTOP = TE
C                                       Check for no data
      IF (NODATA) THEN
         IERR = 6
         MSGTXT = 'NO DATA SELECTED'
         GO TO 990
         END IF
C                                       check and set scaling
      IF ((TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TMAX = (XSTOP + 0.03 * (XSTOP - XSTART)) * 360.0
         TMIN = (XSTART- 0.03 * (XSTOP - XSTART)) * 360.0
      ELSE
         TMAX = (XSTOP + 0.1 * (XSTOP - XSTART)) * 360.0
         TMIN = (XSTART- 0.1 * (XSTOP - XSTART)) * 360.0
         END IF
C                                       If start time is stop time,
      IF (ABS (TMAX-TMIN) .LT. 0.01) THEN
         TMIN = MAX( TMIN-0.005, 0.0)
         TMAX = TMIN + 0.01
         END IF
      XYOFF(1) = TMIN
      XYSCL(1) = 1000.0 / (TMAX - TMIN)
C                                       Send back time range
      TSTART = TB
      TSTOP = TE
      XTIME(1) = TSTART
      XTIME(2) = 0.0
      XTIME(3) = 0.0
      XTIME(4) = 0.0
      XTIME(5) = TSTOP
      XTIME(6) = 0.0
      XTIME(7) = 0.0
      XTIME(8) = 0.0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('WETMAX: ERROR =',I3,' FROM TABIO')
      END
      SUBROUTINE WETSMO (IRET)
C-----------------------------------------------------------------------
C   Smooths the data in time and recomputes the max/min
C   In/Out in common:
C      YYMIN    R(*,*)   Min of Y value by type and antenna
C      YYMAX    R(*,*)   Max of Y value by type and antenna
C      YYMN     R(*)     Min of Y value by type only
C      YYMX     R(*)     Max of Y value by type only
C      YPTS     R(*,*)   Y data by type antenna
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'WETHR.INC'
C
      INTEGER   IANT, ITYP, IP, MP
C-----------------------------------------------------------------------
      IRET = 0
      CALL RFILL (NOPTS, -1.E8, YYMX)
      CALL RFILL (NOPTS, 1.E8, YYMN)
C                                       loop over data parts
      MP = 0
      DO 100 IANT = 1,MUMANT
         IP = MP + 1
         MP = IP + NUMPTS(IANT) - 1
         IF (MP.GE.IP) THEN
            DO 95 ITYP = 1,NPR
               IF (YYMAX(ITYP,IANT).GT.YYMIN(ITYP,IANT)) CALL SMOWX
     *            (ITYP, IP, MP, IANT)
 95            CONTINUE
            END IF
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SMOWX (ITYP, IP, MP, IANT)
C-----------------------------------------------------------------------
C   Smooths a portion of data
C   Inputs:
C      ITYP   I   Type of data - seq #
C      IP     I   Start array index
C      MP     I   End array index
C      IANT   I   Antenna number
C-----------------------------------------------------------------------
      INTEGER   ITYP, IP, MP, IANT
C
      INCLUDE 'WETHR.INC'
C
      INTEGER   I, J
      REAL      X, V, W, WT, GF, XRAD, XW, A, TT(MAXPTS), SC, SS
      LOGICAL   DOVECT
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      YYMAX(ITYP,IANT) = -1.E8
      YYMIN(ITYP,IANT) = 1.E8
      XRAD = XSMOTH(3) / 2 / (60.0 * 24.0)
      XW = XSMOTH(2) / 2 / (60.0 * 24.0)
      IF (ISMOTH.EQ.2) GF = -LOG(2.0) / (XW**2)
      IF (ISMOTH.EQ.4) GF =  PI / XW
      DOVECT = PRLIST(ITYP).EQ.5
C                                       Outer loop of points
      DO 100 I = IP,MP
         V = 0.0
         W = 0.0
         SC = 0.0
         SS = 0.0
         DO 90 J = IP,MP
            X = ABS (XPTS(I) - XPTS(J))
            IF ((X.LT.XRAD) .AND. (YPTS(ITYP,I).NE.FBLANK)) THEN
C                                       Hanning
               IF (ISMOTH.EQ.1) THEN
                  WT = 1.0  - X/XW
                  WT = MAX (0.0, WT)
C                                       Gaussian
               ELSE IF (ISMOTH.EQ.2) THEN
                  WT = EXP (GF * X * X)
C                                       boxcar
               ELSE IF (ISMOTH.EQ.3) THEN
                  WT = 1.0
C                                       sinc function
               ELSE IF (ISMOTH.EQ.4) THEN
                  A = X * GF
                  IF (A.EQ.0.0) THEN
                     WT = 1.0
                  ELSE
                     WT = SIN (A) / A
                     END IF
                  END IF
               W = W + WT
               IF (DOVECT) THEN
                  SC = SC + WT * COS (DG2RAD * YPTS(ITYP,J))
                  SS = SS + WT * SIN (DG2RAD * YPTS(ITYP,J))
               ELSE
                  V = V + YPTS(ITYP,J) * WT
                  END IF
               END IF
 90         CONTINUE
         IF (W.GT.0.0) THEN
            IF (DOVECT) THEN
               IF ((SC.EQ.0.0) .AND. (SS.EQ.0.0)) THEN
                  TT(I) = FBLANK
               ELSE
                  TT(I) = RAD2DG * ATAN2 (SS, SC)
                  IF (TT(I).LT.0.0) TT(I) = TT(I) + 360.0
                  END IF
            ELSE
               TT(I) = V / W
               END IF
         ELSE
            TT(I) = FBLANK
            END IF
 100     CONTINUE
C                                       move back and max/min
      DO 120 I = IP,MP
         YPTS(ITYP,I) = TT(I)
         IF (TT(I).NE.FBLANK) THEN
            YYMIN(ITYP,IANT) = MIN (TT(I), YYMIN(ITYP,IANT))
            YYMAX(ITYP,IANT) = MAX (TT(I), YYMAX(ITYP,IANT))
            YYMX(ITYP) = MAX (YYMX(ITYP), TT(I))
            YYMN(ITYP) = MIN (YYMN(ITYP), TT(I))
            END IF
 120     CONTINUE
C                                       reset max min on fixed scale
      IF ((PIXR(1).LT.PIXR(2)) .AND. (NPR.EQ.1)) THEN
         YYMX(1) = PIXR(2)
         YYMN(1) = PIXR(1)
         IF (YYMAX(1,IANT).GE.YYMIN(1,IANT)) THEN
            YYMAX(1,IANT) = PIXR(2)
            YYMIN(1,IANT) = PIXR(1)
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE GETSCL (LANT, LPLT, DOIT)
C-----------------------------------------------------------------------
C   GETSCL converts a number of max/min's to a scale
C   Inputs:
C      LANT    I   Antenna number
C      LPLT    I   Plot number
C   Output:
C      DOIT    L      There were valid values
C   Output in common
C      XYSCL   R(2)   Scaling - only 2nd one changed
C      XYOFF   R(2)   Offset  - only second one changed
C-----------------------------------------------------------------------
      INTEGER   LANT, LPLT
      LOGICAL   DOIT
C
      INCLUDE 'WETHR.INC'
      REAL      YMX, YMN, TMAX, TMIN, TDIF, TOLER(NOPTS), SIZEY
C                                       Minimum value range for each
C                                       ICODE
C                  T    P  Dewp  Vel  Dir  Gus  Pre  H2O  Elec  Hum
      DATA TOLER /0.1, 0.1, 0.1,  1.,  1.,  1., 0.1, 0.1,  1.0,  1.,
C        CH2O,   opac    opac Wcos Wsin dDEP
     *    0.1, 0.0001, 0.0001, 1.0, 1.0, 0.1/
C-----------------------------------------------------------------------
      DOIT = .FALSE.
      YMX = -1.E8
      YMN = -YMX
      IF (YYMAX(LPLT,LANT).GT.YYMIN(LPLT,LANT)) THEN
         DOIT = .TRUE.
         YMX = MAX (YMX, YYMAX(LPLT,LANT))
         YMN = MIN (YMN, YYMIN(LPLT,LANT))
         END IF
      SIZEY = 1000.0 / NCOUNT
      TMAX = YMX + 0.1 * (YMX - YMN)
      TMIN = YMN - 0.1 * (YMX - YMN)
      IF (ABS (TMAX-TMIN) .LT. TOLER(ICODE)) THEN
         TMAX = TMAX + TOLER(ICODE)
         TMIN = TMIN - TOLER(ICODE)
         END IF
      TDIF = TMAX - TMIN
      IF (ABS (TDIF).LE.1.0E-25) TDIF = 1.0E-25
      XYOFF(2) = TMIN
      XYSCL(2) = 1000.0 / TDIF / NCOUNT
C
 999  RETURN
      END
      SUBROUTINE WETDAT (VALUE, OKAY)
C-----------------------------------------------------------------------
C   Routine to get the specified value from a WX entry
C   Input from common:
C      WXREC    R(*)  Table record
C   Also uses pointers etc. set in WETOPN
C   Output:
C      VALUE    R(*)   Table value, magic value blanked (amp on ICODE 6)
C      OKAY     L      Some values are good
C-----------------------------------------------------------------------
      REAL     VALUE(10)
      LOGICAL  OKAY
C
      INTEGER  IPR, MJD
      REAL     PT, PD, PP, T, P, DUMMY
      DOUBLE PRECISION TIME, JD
      CHARACTER DATOBS*8
      INCLUDE 'WETHR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      CALL H2CHR (8, 1, CATH(KHDOB), DATOBS)
      CALL JULDAY (DATOBS, JD)
      MJD = (JD - 2400000.5D0) + 0.00001D0
C                                       In case the data is bad
      OKAY = .FALSE.
      DO 100 IPR = 1,NPR
         VALUE(IPR) = FBLANK
         ICODE = PRLIST(IPR)
C                                       Select data type
C                                       Temperature
         IF (ICODE.EQ.1) THEN
            VALUE(IPR) = WXRECR(WXKOLS(WXRTMP))
C                                       Pressure
         ELSE IF (ICODE.EQ.2) THEN
            VALUE(IPR) = WXRECR(WXKOLS(WXRPRS))
C                                       Dew point
         ELSE IF (ICODE.EQ.3) THEN
            VALUE(IPR) = WXRECR(WXKOLS(WXRDWP))
C                                       Wind velocity
         ELSE IF (ICODE.EQ.4) THEN
            VALUE(IPR) = WXRECR(WXKOLS(WXRVEL))
C                                       Wind direction
         ELSE IF (ICODE.EQ.5) THEN
            VALUE(IPR) = WXRECR(WXKOLS(WXRDIR))
C                                       Wind gust
         ELSE IF (ICODE.EQ.6) THEN
            VALUE(IPR) = WXRECR(WXKOLS(WXRGUS))
C                                       Precipitation
         ELSE IF (ICODE.EQ.7) THEN
            VALUE(IPR) = WXRECR(WXKOLS(WXRPRE))
C                                       H2O content
         ELSE IF (ICODE.EQ.8) THEN
            VALUE(IPR) = WXRECR(WXKOLS(WXRH2O))
C                                       Ion column
         ELSE IF (ICODE.EQ.9) THEN
            VALUE(IPR) = WXRECR(WXKOLS(WXRION))
C                                       Relative humidity
         ELSE IF (ICODE.EQ.10) THEN
            P = WXRECR(WXKOLS(WXRPRS))
            T = WXRECR(WXKOLS(WXRTMP))
            IF ((P.NE.FBLANK) .AND. (T.NE.FBLANK)) THEN
               CALL SATPRS (T, P, PT)
               T = WXRECR(WXKOLS(WXRDWP))
               IF (T.NE.FBLANK) THEN
                  CALL SATPRS (T, P, PD)
                  VALUE(IPR) = 100.0 * PD / PT
                  END IF
               END IF
C                                       Use opacity routine
         ELSE IF ((ICODE.GE.11) .AND. (ICODE.LE.13)) THEN
            PD = WXRECR(WXKOLS(WXRDWP))
            PT = WXRECR(WXKOLS(WXRTMP))
            PP = WXRECR(WXKOLS(WXRPRS))
            IF (WXNUMV(WXDTIM).GT.0) THEN
               TIME = WXRECD(WXKOLS(WXDTIM))
            ELSE
               TIME = WXRECR(WXKOLS(WXDTIM))
               END IF
            IF ((PT.NE.FBLANK) .AND. (PD.NE.FBLANK) .AND.
     *         (PP.NE.FBLANK)) THEN
C                                       Computed H2O
               IF (ICODE.EQ.11) CALL OPACTY (10, PT, PD, PP, DWT, MJD,
     *            TIME, VALUE(IPR), DUMMY)
C                                       K band zenith opacity
               IF (ICODE.EQ.12) CALL OPACTY (8, PT, PD, PP, DWT, MJD,
     *            TIME, DUMMY, VALUE(IPR))
C                                       Q band zenith opacity
               IF (ICODE.EQ.13) CALL OPACTY (10, PT, PD, PP, DWT, MJD,
     *            TIME, DUMMY, VALUE(IPR))
               END IF
C                                       Wind velocity from North
         ELSE IF (ICODE.EQ.14) THEN
            PT = WXRECR(WXKOLS(WXRVEL))
            PD = WXRECR(WXKOLS(WXRDIR))
            IF ((PT.NE.FBLANK) .AND. (PD.NE.FBLANK)) VALUE(IPR) = PT *
     *         COS (DG2RAD * PD)
C                                       Wind velocity from North
         ELSE IF (ICODE.EQ.15) THEN
            PT = WXRECR(WXKOLS(WXRVEL))
            PD = WXRECR(WXKOLS(WXRDIR))
            IF ((PT.NE.FBLANK) .AND. (PD.NE.FBLANK)) VALUE(IPR) = PT *
     *         SIN (DG2RAD * PD)
C                                       Dew point depression
         ELSE IF (ICODE.EQ.16) THEN
            PT = WXRECR(WXKOLS(WXRTMP))
            PD = WXRECR(WXKOLS(WXRDWP))
            IF ((PT.NE.FBLANK) .AND. (PD.NE.FBLANK)) VALUE(IPR) =
     *         PT - PD
            END IF
         IF (VALUE(IPR).NE.FBLANK) OKAY = .TRUE.
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE WETLOT (IRET)
C-----------------------------------------------------------------------
C   WETLOT plots the data thru calls to PLTSN.
C   Input in common:
C      XPTS     R(*)   Data x values
C      YPTS     R(*)   Data y values
C   Output:
C      IRET     I      Return code, 0=OK else failed
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   IPLOT, JPLT, IANT, IPLT, NPLT, IP, NP
      LOGICAL   DOIT
      INCLUDE 'WETHR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IPLOT = 0
C                                       count the plots
      NPLOTS = 0
      DO 35 IANT = 1,MUMANT
         DO 30 IPLT = 1,NPR
            ICODE = PRLIST(IPLT)
            CALL GETSCL (IANT, IPLT, DOIT)
            IF (DOIT) NPLOTS = NPLOTS + 1
 30         CONTINUE
 35      CONTINUE
      IF (NPLOTS.LE.0) GO TO 999
C                                       Now plot
      NPLT = 0
      IP = 1
      NCOUNT = MIN (NCOUNT, NPLOTS)
      DO 100 IANT = 1,MUMANT
         NP = NUMPTS(IANT)
         DO 90 IPLT = 1,NPR
            ICODE = PRLIST(IPLT)
            CALL GETSCL (IANT, IPLT, DOIT)
            IF (DOIT) THEN
               NPLT = NPLT + 1
               JPLT = NPLT
               IPLOT = MOD (NPLT-1, NCOUNT) + 1
               IF (NPLT.EQ.NPLOTS) IPLOT = -IPLOT
               CALL PLTWX (IPLOT, IANT, IPLT, IP, NP, IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
 90         CONTINUE
         IP = IP + NP
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE PLTWX (IPLOT, ANTNO, IPLT, IP, NP, IRET)
C-----------------------------------------------------------------------
C   PLTWX actually plots data.
C   Input:
C      IPLOT    I      Plot number on current page. If neg. then this is
C                      last plot.
C      ANTNO    I      Antenna number
C      IPLT     I      Plot type sequence number
C      IP       I      Start subscript
C      NP       I      Number of points
C   Output:
C      IRET     I      Return code, 0 => OK, otherwise abort.
C                       -1 => user request termination
C                        1 => failed to add to catalog
C                        2 => failed to create
C                        3 => graph file write error
C                        4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   IPLOT, ANTNO, IPLT, IP, NP, IRET
C
      INCLUDE 'WETHR.INC'
C
      CHARACTER TEXT*132, PFILE*48, ATIME*8, ADATE*12, AUNITS(NOPTS)*20,
     *   CHTYPE(NOPTS)*20, CHTMP*18, XUNITS(5)*20
      INTEGER   BUFFER(256), VER, IERR, ITYPE, IPSIZE, LUNPL, LTYPE,
     *   FINDPL, DEPTH(5), INCHAR, INP, IT(3), ID(3), IAXLAB, IAPLOT,
     *   I, NGOOD, NNOFIT, JCODE, NN, NNM
      REAL      BLC(2), TRC(2), XYRATO, DX, DY, TR, VALUE, XY(2),
     *   XTRC(2), XBLC(2), TLC(2), PLTINC, YYOFF(2), SIZE, YPT, DBY,
     *   YPT2
      LOGICAL   T, F, GOOD, CATUP, INSIDE, BLNKD
      SAVE LTYPE, BUFFER, XYRATO
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGPH.INC'
      DATA LUNPL /26/
      DATA DEPTH /5*1/
      DATA T, F /.TRUE.,.FALSE./
      DATA AUNITS /'Centigrade', 'Millibar', 'Centigrade',
     *   'meters/second','Degrees', 'meters/second', 'cm', 2*'/m/m',
     *   'Per cent', 'mm H2O', 2*'Opacity',
     *   2*'meters/second','Centigrade'/
      DATA CHTYPE /'Temperature', 'Pressure', 'Dew point',
     *   'Wind velocity', 'Wind direction', 'Wind gusts',
     *   'Precipitation', 'H2O content', 'Electron content',
     *   'Relative humidity', 'Computed H2O', 'K-band opacity',
     *   'Q-band opacity', 'North wind', 'East wind',
     *   'Dew point depression'/
      DATA XUNITS /'IAT (hours)', 'Elevation (degrees)',
     *   'Hour Angle (hours)', 'LST (hours)', 'Parallactic angle' /
C-----------------------------------------------------------------------
C                                       Time system from AN table
      XUNITS(1)(1:3) = TIMLAB(1:3)
      INSIDE = (NPR.GT.1) .AND. (NCOUNT.GT.1)
      NGOOD = 0
      NNOFIT = 0
      IRET = 3
      CATUP = T
C
      JCODE = ICODE
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      PLTINC = 1000. / NCOUNT
C                                       Set window for current plot.
      XBLC(1) = BLC(1)
      XBLC(2) = 1000.0 - ABS (IPLOT) * PLTINC
      XTRC(1) = TRC(1)
      XTRC(2) = XBLC(2) + PLTINC - 1.0
      TLC(1) = XBLC(1)
      TLC(2) = XTRC(2)
C                                       Offsets for current plot.
      YYOFF(1) = XBLC(1)
      YYOFF(2) = XBLC(2)
C                                       fool with location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 7
      AXTYP(LOCNUM) = 0
      CALL METSCL (LABEL, TR, CPREF(2,LOCNUM), GOOD)
      CPREF(1,LOCNUM) = ' '
      CPREF(2,LOCNUM) = ' '
      DO 50 I = 1,2
         SIZE = 1000.0
         IF (I.EQ.2) SIZE = PLTINC
         TR = SIZE / XYSCL(I)
         RPLOC(I,LOCNUM) = XBLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I)
         AXINC(I,LOCNUM) = TR / (XTRC(I) - XBLC(I))
 50      CONTINUE
      CTYP(1,LOCNUM) = XUNITS(1)
      CTYP(2,LOCNUM) = AUNITS(JCODE)
C                                       Create plot file
      IF (ABS (IPLOT).EQ.1) THEN
C                                       Update catalog header.
         VER = 0
         IRET = 1
         IF (.NOT.DOTV) THEN
            CALL MADDEX ('PL', DISKIN, CNOIN, CATBLK, BUFFER, CATUP,
     *         'WRIT', VER, IERR)
            IF (IERR.NE.0) THEN
               NCFILE = NCFILE - 1
               GO TO 999
               END IF
            END IF
         CALL ZPHFIL ('PL', DISKIN, CNOIN, VER, PFILE, IERR)
         IF (IERR.NE.0) GO TO 960
         IPSIZE = 0
         ITYPE = 46
         CALL GINIT (DISKIN, CNOIN, PFILE, IPSIZE, ITYPE, NPARMS,
     *      XNAMEI, DOTV, TVCHN, GRCHN, TVCORN, CATBLK, BUFFER, LUNPL,
     *      FINDPL, IERR)
         IRET = 2
         IF (IERR.NE.0) GO TO 960
C                                       Number of characters on each
C                                       side of the plot
         CALL RFILL (4, 0.5, CHOUT)
C                                       Not fully initialized, may make
C                                       INP too large which is okay.
         CALL CHNTIC (XBLC, XTRC, INP)
         INP = MAX (INP, 5)
         LTYPE = MOD (ABS (LABEL), 100)
         IF (LTYPE.EQ.2) CHOUT(1) = 2.5
         IF (LTYPE.GT.2) CHOUT(1) = INP + 4
         IF (LTYPE.GT.1) CHOUT(2) = 2.0
         IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
         IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = 2.333
         IF ((LABEL.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7))
     *      CHOUT(4) = CHOUT(4) + 1.333
C                                       Init for line drawing.
         IF (DOTV) THEN
            XYRATO = WINDTV(4) - WINDTV(2) + 1
            XYRATO = (WINDTV(3) - WINDTV(1) + 1) / XYRATO
         ELSE
            XYRATO = 1.0
            END IF
         CALL GINITL (BLC, TRC, XYRATO, CHOUT, DEPTH, BUFFER, IERR)
         IRET = 3
         IF (IERR.NE.0) GO TO 970
         IF (.NOT.DOTV) THEN
            WRITE (MSGTXT,1000) VER
            CALL MSGWRT (2)
            END IF
         END IF
      IRET = 3
      CATUP = T
C                                       Draw border
      CALL GLTYPE (1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Top labels: type & name
      IF ((ABS(IPLOT).EQ.1) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DX = 0.0
         DY = 0.50
C                                       The second line of the header
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         INCHAR = 16
         INP = 1
         IF (INSIDE) THEN
            TEXT = 'Multiple'
         ELSE
            TEXT = CHTYPE(JCODE)
            END IF
         CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
         INP = INP + 1
         TEXT(INP:INP+16) = ' vs '// TIMLAB(1:3) // ' time for '
         INP = INP + 17
C                                       File name
         CALL H2CHR (18, KHIMNO, CATH(KHIMN), CHTMP)
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), CHTMP(13:18))
         CALL NAMEST (CHTMP, CATBLK(KIIMS), TEXT(INP:), INCHAR)
         CALL REFRMT (TEXT, ' ', INCHAR)
         WRITE (TEXT(INCHAR+1:),1010) 'WX', IVER
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Date/time/version
         IF ((LABEL.GT.0) .AND. (LTYPE.GT.1)) THEN
            DY = 0.5 + 1.333
C                                       the first line of the header
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (TEXT,1030) VER, ADATE, ATIME
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
         END IF
C                                       station ID
      CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      DX =  1.5
      DY = -1.8
      IF (ANTNO.EQ.1) THEN
         TEXT = 'All antennas'
      ELSE
         WRITE (TEXT,1040) ANTNO-1
         INP = 4
         TEXT(INP+1:) = STNNAM(ANTNO-1)
         END IF
      CALL CHTRIM (TEXT, 132, TEXT, INCHAR)
      IF (INSIDE) TEXT(INCHAR+2:) = CHTYPE(JCODE)
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Set up location common
C                                       Blank bottom label.
      IF ((IPLOT.GE.0) .AND. (ABS (IPLOT).NE.NCOUNT)) THEN
         CPREF(1,LOCNUM) = ' '
         CTYP(1,LOCNUM) = ' '
         END IF
C                                       Only label Y axis once.
      IAXLAB = NCOUNT / 2 + 1
      IAPLOT = ABS (IPLOT)
      IF ((.NOT.INSIDE) .AND. (IAPLOT.NE.IAXLAB) .AND. ((IPLOT.GE.0)
     *   .OR. (IAPLOT.GT.IAXLAB))) CPREF(2,LOCNUM) = '-1'
C                                       Put on labels and ticks
      CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XYRATO, F, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Size of symbol.
      DBY = 0.5 * FACTOR
C                                       Loop
      NNM = IP + NP - 1
      DY = 5.0 * FACTOR * XYRATO
      DX = 5.0 * FACTOR
      CALL GLTYPE (4, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      DO 100 NN = IP,NNM
C                                       Scale X
         XY(1) = XPTS(NN) * 360.0
         XY(1) = XYSCL(1) * (XY(1) - XYOFF(1)) + YYOFF(1)
         IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1))) THEN
            NNOFIT = NNOFIT + 1
            GO TO 100
            END IF
C                                       loop for points
         VALUE = YPTS(IPLT,NN)
         IF (VALUE.NE.FBLANK) THEN
            XY(2) = VALUE
            XY(2) = XYSCL(2) * (XY(2) - XYOFF(2)) + YYOFF(2)
            IF ((XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2))) THEN
               NNOFIT = NNOFIT + 1
            ELSE
               NGOOD = NGOOD + 1
C                                       Mark point
               YPT = MIN (XY(2) + DY, XTRC(2))
               YPT2 = MAX (XY(2) - DY, XBLC(2))
               CALL GPOS (XY(1)+DX, XY(2), BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               CALL GVEC (XY(1)-DX, XY(2), BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               CALL GPOS (XY(1), YPT, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               CALL GVEC (XY(1), YPT2, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               END IF
            END IF
 100     CONTINUE
      IF (DOLINE) THEN
         CALL GLTYPE (2, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         BLNKD = .TRUE.
         DO 200 NN = IP,NNM
C                                       Scale X
            XY(1) = XPTS(NN) * 360.0
            XY(1) = XYSCL(1) * (XY(1) - XYOFF(1)) + YYOFF(1)
            IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1))) THEN
               BLNKD = .TRUE.
               GO TO 200
               END IF
C                                       loop for points
            VALUE = YPTS(IPLT,NN)
            IF (VALUE.EQ.FBLANK) THEN
               BLNKD = .TRUE.
            ELSE
               XY(2) = VALUE
               XY(2) = XYSCL(2) * (XY(2) - XYOFF(2)) + YYOFF(2)
               IF ((XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2))) THEN
                  BLNKD = .TRUE.
C                                       Mark point
               ELSE IF (BLNKD) THEN
                  CALL GPOS (XY(1), XY(2), BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  BLNKD = .FALSE.
               ELSE
                  CALL GVEC (XY(1), XY(2), BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  END IF
               END IF
 200        CONTINUE
         END IF
C                                       Done: finish plot
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      IF ((IPLOT.GT.0) .AND. (ABS(IPLOT).LT.NCOUNT)) GO TO 210
         GPHPAG = IPLOT.GT.0
         CALL GFINIS (BUFFER, IERR)
         IF (IERR.GT.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
            IERR = 0
            END IF
 210  IF (IERR.GT.0) GO TO 975
         IRET = MIN (IERR, 0)
         GO TO 999
C                                       ZPHFIL or GINIT failure.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      IF (.NOT.DOTV) THEN
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
      GO TO 999
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      GPHPAG = IPLOT.GT.0
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.NE.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
            IERR = 0
            END IF
         GO TO 999
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Plot file version',I4,'  created.')
 1010 FORMAT ('__(',A2,I4,')')
 1030 FORMAT ('Plot file version',I4,'__created ',A, A)
 1040 FORMAT (I3)
 1200 FORMAT ('PLTWX:',I9,' points plotted')
 1202 FORMAT ('PLTWX:',I9,' points did not fit')
 1960 FORMAT ('PLTWX: ERROR DURING GRAPH FILE CREATION')
 1970 FORMAT ('PLTWX: ERROR DURING GRAPHING. WILL TRY TO FINISH ',
     *   'PARTIAL GRAPH')
      END
      SUBROUTINE WETFLG (IRET)
C-----------------------------------------------------------------------
C   WETFLG copies the FG table to a new one and appends any flags due to
C   weather conditions.
C   Output:
C      IRET   I   > 0 something bad
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'WETHR.INC'
C
      INTEGER   INVER, OVER, I, IROUND, ILUN, OLUN, IANT, IPLT, ITRIM,
     *   NF, IP, NP, MP, J, IDUM
      REAL      VALUE
      LOGICAL   DOIT
      CHARACTER CHTYPE(NOPTS)*16, CTEMP*12
      INCLUDE 'INCS:PUVD.INC'
C                                       FG table parameters
      INTEGER   FLANT(2), IFS(2), CHANS(2), IFGRNO, FGKOLS(MAXFGC),
     *   FGNUMV(MAXFGC), SOURID, SUBA, FREQID
      LOGICAL   PFLAGS(4)
      REAL      TIMER(2)
      CHARACTER  REASON*24
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA ILUN, OLUN /28, 29/
      DATA PFLAGS /4*.TRUE./
      DATA CHTYPE /'Temperature', 'Pressure', 'Dew point',
     *   'Wind velocity', 'Wind direction', 'Wind gusts',
     *   'Precipitation', 'H2O content', 'Electron content',
     *   'Rel humidity', 'Computed H2O', 'K-band opacity',
     *   'Q-band opacity', 'North wind', 'East wind',
     *   'DewPt depression'/
C-----------------------------------------------------------------------
      IF (DETIME.LE.0.0) THEN
         DETIME = (XPTS(2) - XPTS(1)) / 2.0
      ELSE
         DETIME = DETIME / (60.0 * 24.0)
         END IF
      CALL FNDEXT ('FG', CATBLK, I)
      INVER = IROUND (XFGVER)
      IF ((INVER.EQ.0) .OR. (INVER.GT.I)) INVER = I
      OVER = IROUND (XFGOUT)
      IF ((OVER.LE.0) .OR. (OVER.GT.I)) OVER = I + 1
      IF (OVER.LE.I) INVER = -ABS(INVER)
C                                       copy old file
      IF (INVER.GT.0) THEN
         WRITE (MSGTXT,1000) INVER, OVER
         CALL MSGWRT (3)
         CALL TABCOP ('FG', INVER, OVER, ILUN, OLUN, DISKIN, DISKIN,
     *      CNOIN, CNOIN, CATBLK, UBUFF, WXBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) 'COPY', IRET
            GO TO 990
            END IF
         END IF
C                                       init FG parms
      SUBA = ISUBA
      FREQID = 0
      SOURID = 0
      CHANS(1) = 0
      CHANS(2) = 0
      IFS(1) = 0
      IFS(2) = 0
      FLANT(2) = 0
      CALL FLGINI ('WRIT', WXBUFF, DISKIN, CNOIN, OVER, CATBLK, OLUN,
     *   IFGRNO, FGKOLS, FGNUMV, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) 'OPEN', IRET
         GO TO 990
         END IF
C                                       Loop over parameter types
      DO 100 IPLT = 1,NPR
         ICODE = PRLIST(IPLT)
         I = ITRIM (CHTYPE(ICODE))
         I = MIN (I, 12)
         WRITE (REASON,1020) CHTYPE(ICODE)(:I), BPARM(IPLT)
         NF = 0
         MP = 0
         DO 90 IANT = 1,MUMANT
            NP = MP + 1
            MP = MP + NUMPTS(IANT)
            CALL GETSCL (IANT, IPLT, DOIT)
            IF (DOIT) THEN
               FLANT(1) = IANT - 1
C                                       find first bad point
 20            DO 30 IP = NP,MP
                  VALUE = YPTS(IPLT,IP)
                  IF (VALUE.NE.FBLANK) THEN
                     IF (ICODE.LT.14) THEN
                        IF (VALUE.GT.BPARM(IPLT)) GO TO 40
                     ELSE
                        IF (ABS(VALUE).GT.BPARM(IPLT)) GO TO 40
                        END IF
                     END IF
 30               CONTINUE
               GO TO 90
C                                       find end bad point
 40            DO 50 J = IP+1,MP
                  VALUE = YPTS(IPLT,J)
                  IF (VALUE.NE.FBLANK) THEN
                     IF (ICODE.LT.14) THEN
                        IF (VALUE.LE.BPARM(IPLT)) GO TO 60
                     ELSE
                        IF (ABS(VALUE).GT.BPARM(IPLT)) GO TO 60
                        END IF
                     END IF
 50               CONTINUE
               J = MP+1
C                                       Got a range
 60            J = J - 1
               TIMER(1) = XPTS(IP) - DETIME
               TIMER(2) = XPTS(J) + DETIME
               NP = J + 1
               NF = NF + 1
C                                       flag command
               CALL TABFLG ('WRIT', WXBUFF, IFGRNO, FGKOLS, FGNUMV,
     *            SOURID, SUBA, FREQID, FLANT, TIMER, IFS, CHANS,
     *            PFLAGS, REASON, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1010) 'WRITE', IRET
                  GO TO 990
                  END IF
C                                       loop for more
               GO TO 20
               END IF
 90         CONTINUE
         WRITE (MSGTXT,1090) NF, REASON
         CALL MSGWRT (4)
 100     CONTINUE
C                                       close file
      CALL TABFLG ('CLOS', WXBUFF, IFGRNO, FGKOLS, FGNUMV, SOURID, SUBA,
     *   FREQID, FLANT, TIMER, IFS, CHANS, PFLAGS, REASON, IRET)
C                                       Clear write status
      CALL CATDIR ('CSTA', DISKIN, CNOIN, CTEMP, CTEMP, IDUM, 'UV',
     *   IDUM, 'CLWR', WXBUFF, IRET)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Copying FG version',I3,' to',I3)
 1010 FORMAT ('WETFLG: ERROR ON ',A,' =',I5)
 1020 FORMAT (A,' >',1PE10.3)
 1090 FORMAT ('Wrote',I4,' flag commands for ',A)
      END

      SUBROUTINE QSEARC (APCORE, NF, NT, MF, MT, ND, NR, APIAD, APINTR,
     *   APFIN)
C-----------------------------------------------------------------------
C! Pseudo AP routine: VLBI fringe search with FFT.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2006, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   QSEARC is a routine to do a gridded fringe search by means of
C   padded FFTs.  The number (size) of the FFTs is NF (MT) +
C   NR (MF).
C   Inputs:
C      NF       I  No. frequency channels.
C      NT       I  No. time points.
C      MF       I  No. points for freq. FFT.
C      MT       I  No. points for time FFT.
C      ND       I  No. delay channels to search.
C      NR       I  No. rate channels to search.
C      APIAD    I   Base address input data: 2 * NT * NF words used
C      APINTR   I   Base address work area: 2 * NF * NR used
C      APFIN    I   Base address work areas: 2 * NR * ND + max(MT,MF)
C   Output: (in AP memory)
C      0 => 1 dim. array index for peak.
C      1 => peak amplitude
C      2 => peak phase.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   NF, NT, MF, MT, ND, NR, APIAD, APINTR, APFIN
C
      INTEGER   INTER, FINAL, FFT, LOC1, MF2, MT2, COUNT, NN, DDATA,
     *   NR2, ND2, NT2, LOOP, PEAK, FFT2, ITEMP
      LONGINT   LTEMP
      DOUBLE PRECISION DTEMP
      EQUIVALENCE (DTEMP, LTEMP)
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                        Set pointers.
      MF2 = MF * 2
      MT2 = MT * 2
      NT2 = NT * 2
      NR2 = NR * 2
      ND2 = ND * 2
      DDATA = APIAD
      INTER = APINTR
      FINAL = APFIN
      FFT = FINAL + (NR * ND2)
      FFT2 = FFT + MT2 - NR + 1
      NN = NR * ND
      COUNT = NF
      LOC1 = INTER
C                                        Do first XFORM,
C                                        First rotate phase.
      DO 100 LOOP = 1,COUNT
         CALL QVCLR (APCORE, FFT, 1, MT2)
         CALL QVMOV (APCORE, DDATA, 1, FFT, 1, NT2)
C                                        Do time FFT.
         CALL QCFFT (APCORE, FFT, MT, -1)
C                                         Save first half
         ITEMP = NR / 2 + 1
         CALL QCVMOV (APCORE, FFT, 2, LOC1, 2, ITEMP)
C                                         Save second half
         LOC1 = LOC1 + ITEMP * 2
         ITEMP = NR / 2
         IF (ITEMP.GT.0) CALL QCVMOV (APCORE, FFT2, 2, LOC1, 2, ITEMP)
C                                        Update data pointer.
         DDATA = DDATA + NT2
C                                        Update result pointer.
         LOC1 = LOC1 + ITEMP * 2
 100     CONTINUE
C                                         Second transform loop.
      COUNT = NR
      LOC1 = FINAL
      FFT2 = FFT + MF2 - ND + 1
      DO 200 LOOP = 1,COUNT
         CALL QVCLR (APCORE, FFT, 1, MF2)
C                                         Move to FFT work space.
         CALL QCVMOV (APCORE, INTER, NR2, FFT, 2, NF)
C                                         Freq. FFT.
         CALL QCFFT (APCORE, FFT, MF, -1)
C                                         Save first half
         ITEMP = ND / 2 + 1
         CALL QCVMOV (APCORE, FFT, 2, LOC1, 2, ITEMP)
C                                         Save second half
         LOC1 = LOC1 + ITEMP * 2
         ITEMP = ND / 2
         IF (ITEMP.GT.0) CALL QCVMOV (APCORE, FFT2, 2, LOC1, 2, ITEMP)
C                                         Update output pointer.
         LOC1 = LOC1 + ITEMP * 2
C                                         Update input pointer.
         INTER = INTER + 2
 200     CONTINUE
C                                         Find max amp.
      CALL QCVMMA (APCORE, FINAL, 2, 0, NN)
      PEAK = SPAD(15)
C                                         Save index in AP LOC 0 I
      LTEMP = SPAD(15)
      APCORE(PSAPOF) = DTEMP
C                                         Polar conversion.
      PEAK = (PEAK * 2) - 2
      LOC1 = FINAL + PEAK
      CALL QPOLAR (APCORE, LOC1, 2, 1, 2, 1)
C
 999  RETURN
      END

LOCAL INCLUDE 'FGTAB.INC'
C                                       Local include for FGTAB
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
C                                       Input parameters
      HOLLERITH XNAMEI(3), XCLAIN(2), XOUTFI(12), XOPCOD(1)
      REAL      XSIN, XDISIN, XNVER, BUFF1(UVBFSS)
      INTEGER   SEQIN, DISKIN, CNOIN, IVER
      CHARACTER NAMEIN*12, CLAIN*6, OUTFIL*48, OPCODE*4
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNVER, XOUTFI,
     *   XOPCOD
      COMMON /VGNCOM/ BUFF1, SEQIN, DISKIN, CNOIN, IVER
      COMMON /VGNCHR/ NAMEIN, CLAIN, OUTFIL, OPCODE
C                                                          End FGTAB
LOCAL END
      PROGRAM FGTAB
C-----------------------------------------------------------------------
C! Prints freq range data from an FG table
C# UV Plot EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2016, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FGTAB prints FG extension file with freq range
C   Inputs:
C      INNAME.....UV file name (name).       Standard defaults.
C      INCLASS....UV file name (class).      Standard defaults.
C      INSEQ......UV file name (seq. #).     0 => highest.
C      INDISK.....Disk unit #.               0 => any.
C      INVERS.....Version number of table to plot, 0=>1.
C      DOCRT......> 0 on CRT
C      OUTPRINT...text file
C-----------------------------------------------------------------------
C
      CHARACTER PRGN*6
      INTEGER   IRET
      INCLUDE 'FGTAB.INC'
      DATA PRGN /'FGTAB '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL FGPIN (PRGN, IRET)
C                                       Close down
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE FGPIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   Gets the inputs parameters for FGTAB and prepare data for plot
C   reading FG table
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'FGTAB.INC'
C
      INTEGER   BUFF(256), I, BUFFER(512), IROUND, LUNI, VER, IFGRNO,
     *   FGKOLS(MAXFGC), FGNUMV(MAXFGC), NFGROW, SOURID, SUBA, FREQID,
     *   ANTFG(2), IFS(2), CHANS(2), LUNP, FINDP, NPARMS, NI, NUMIF,
     *   ANX, ANN
      REAL      TIMER(2)
      CHARACTER STAT*4, PRGN*6, TYPTMP*2, REASON*24
      LOGICAL   F, PFLAGS(4)
      DOUBLE PRECISION F1, F2, FX, FN
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DCHND.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      NPARMS = 21
C                                        Get input parameters.
      CALL SETUP (PRGN, NPARMS, XNAMEI, BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'GETTING INPUT PARAMETERS'
         IRET = 8
         RQUICK = F
         GO TO 990
         END IF
C                                       Decode inputs.
C                                       characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (48, 1, XOUTFI, OUTFIL)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
C                                       Integers
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      IVER = IROUND (XNVER)

      CNOIN = 1
      TYPTMP = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, TYPTMP,
     *   NLUSER, STAT, BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      'UV', NLUSER
         GO TO 990
         END IF
C                                       Save name class etc.
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
      XDISIN = DISKIN
      XSIN = SEQIN
C                                       Read catalog header
      STAT = 'READ'
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, STAT, BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING UV DATA HEADER'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FCNO(NCFILE) = CNOIN
      FVOL(NCFILE) = DISKIN
      FRW(NCFILE) = 0
      XDISIN = DISKIN
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 990
      SEQIN = CATBLK(KIIMS)
      XSIN = SEQIN
C                                       get FQ settings first
      VER = 1
      LUNI = 27
      CALL CHNDAT ('READ', BUFFER, DISKIN, CNOIN, VER, CATBLK, LUNI,
     *   NUMIF, FOFF, ISBAND, FINC, BNDCOD, FREQID, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING FQ TABLE FOR FREQUENCIES'
         GO TO 990
         END IF
C                                       read FG table first time to
C                                       store number of records for
C                                       each ant, BL, all flags
C                                       Open FG file
      LUNI = 27
      CALL FLGINI ('READ', BUFFER, DISKIN, CNOIN, IVER, CATBLK, LUNI,
     *  IFGRNO, FGKOLS, FGNUMV, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING FLAG TABLE'
         GO TO 990
         END IF
C                                       # rows in the table
      NFGROW = BUFFER(5)
C                                       Open output device
      LUNP = 3
      IF (OUTFIL.EQ.' ') OUTFIL = 'HOME:FGTAB.output'
      CALL ZTXOPN ('WRIT', LUNP, FINDP, OUTFIL, .TRUE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT FILE'
         GO TO 990
         END IF
C                                       Loop and copy
      DO 50 I = 1,NFGROW
         CALL TABFLG ('READ', BUFFER, IFGRNO, FGKOLS, FGNUMV, SOURID,
     *      SUBA, FREQID, ANTFG, TIMER, IFS, CHANS, PFLAGS, REASON,
     *      IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING FLAG TABLE'
            GO TO 990
         ELSE IF (IRET.EQ.0) THEN
            IF (SOURID.GT.0) GO TO 50
            IF (SUBA.GT.0) GO TO 50
            IF (FREQID.GT.0) GO TO 50
            IF (TIMER(1).GT.0.0) GO TO 50
            IF (TIMER(2).LT.100.) GO TO 50
            ANX = MAX (ANTFG(1), ANTFG(2))
            ANN = MIN (ANTFG(1), ANTFG(2))
            IF (ANN.GT.0) GO TO 50
            IF ((OPCODE.NE.'ANTE') .AND. (ANX.GT.0)) GO TO 50
C                                       write freq range(s)
            CHANS(1) = MAX (1, CHANS(1))
            IF ((CHANS(2).LT.CHANS(1)) .OR.
     *         (CHANS(2).GT.CATBLK(KINAX+JLOCF)))
     *         CHANS(2) = CATBLK(KINAX+JLOCF)
            IFS(1) = MAX (1, IFS(1))
            IF (JLOCIF.LT.0) THEN
               IFS(2) = 1
            ELSE IF ((IFS(2).LT.IFS(1)) .OR.
     *         (IFS(2).GT.CATBLK(KINAX+JLOCIF))) THEN
               IFS(2) = CATBLK(KINAX+JLOCIF)
               END IF
            DO 40 NI = IFS(1),IFS(2)
               F1 = CATD(KDCRV+JLOCF) + FOFF(NI) + (CHANS(1) -
     *            CATR(KRCRP+JLOCF)) * FINC(NI)
               F2 = CATD(KDCRV+JLOCF) + FOFF(NI) + (CHANS(2) -
     *            CATR(KRCRP+JLOCF)) * FINC(NI)
               F1 = F1 / 1.D6
               F2 = F2 / 1.D6
               FN = MIN (F1, F2)
               FX = MAX (F1, F2)
               IF (ANX.LE.0) THEN
                  WRITE (MSGTXT,1050) FN, FX
               ELSE
                  WRITE (MSGTXT,1051) FN, FX, ANX
                  END IF
               CALL MSGWRT (4)
               CALL ZTXIO ('WRIT', LUNP, FINDP, MSGTXT, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITING TEXT FILE'
                  GO TO 990
                  END IF
 40            CONTINUE
            END IF
 50      CONTINUE
      CALL ZTXCLS (LUNP, FINDP, IRET)
C                                       Close the table
      CALL TABIO ('CLOS', 0, IFGRNO, BUFFER, BUFFER, IRET)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FGPIN ERROR:',I7,1X,A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',I3,
     *   ' TYPE=',A2,' USER=',I4)
 1050 FORMAT  (' BFREQ =',F14.6,'  EFREQ=',F14.6,' /')
 1051 FORMAT  (' BFREQ =',F14.6,'  EFREQ=',F14.6,'  ANTENNAS =',I4,' /')
      END

      SUBROUTINE SETTYP (KARRAY, LPTR, IVALUE)
C-----------------------------------------------------------------------
C! replaces the symbol type code in the data description structure
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   SETTYP sets the type code for either a symbol or literal as defined
C   by the location LPTR, and the new type code IVALUE.
C   Inputs:
C      LPTR    I           location + 1 in KARRAY to set new type
C      IVALUE  I           new type
C   In/Outputs:
C      KARRAY  I(>LPTR-1)  POPS array
C-----------------------------------------------------------------------
      INTEGER   KARRAY(*), LPTR, IVALUE
C-----------------------------------------------------------------------
      KARRAY(LPTR-1) = (KARRAY(LPTR-1)/16)*16 + IVALUE
C
 999  RETURN
      END

      SUBROUTINE UVZRSP (WTOFF, VSOFF, LVIS, FLUX, WEIGHT, NCHGRD, BUFF)
C-----------------------------------------------------------------------
C! Puts zero spacing flux and weight into a UV Buffer.
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   UV ZeRo SPace: Puts Zero spacing flux and weight into a UV Buffer.
C   Band width synthesis is handled by this routine
C   Inputs:
C      WTOFF    I      Offset to Weight of UV point
C      VSOFF    I      Offset to UV Visibility record
C      LVIS     I      Length of Visibility record
C      FLUX     R      Zero Spacing Flux
C      WEIGHT   R      Weight of Zero Spacing Flux
C      NCHGRD   I      Number of channels to Grid
C   Output:
C      BUFF     R(*)   Visibility record
C-----------------------------------------------------------------------
      INTEGER   WTOFF, VSOFF, LVIS, NCHGRD
      REAL      FLUX, WEIGHT, BUFF(*)
C-----------------------------------------------------------------------
      INTEGER JJ, JNDX
C-----------------------------------------------------------------------
      JNDX = 1
C                                       Init UV values to zero
      CALL RFILL (VSOFF, 0.0, BUFF)
C                                       If one weight per vis
      IF (LVIS.LE.2) BUFF(JNDX+WTOFF) = WEIGHT
C                                       index to start of first vis rec
C                                       for first channel to average
      JNDX = JNDX + VSOFF
C                                       for all channels to average
      DO 10 JJ = 1,NCHGRD
         BUFF(JNDX) = FLUX
         BUFF(JNDX+1) = 0.0
         IF (LVIS.GT.2) BUFF(JNDX+2) = WEIGHT
         JNDX = JNDX + LVIS
 10      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE CATINI (HEADER)
C-----------------------------------------------------------------------
C! initializes a catalog header block
C# Catalog
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2017
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Initializes an image header (or uv) with 0's blanks, 1's etc
C   Assumes that integer 0's are also real and double 0's
C   Output:
C      HEADER   I(256)   Filled header
C-----------------------------------------------------------------------
      INTEGER   HEADER(256)
C
      INTEGER   I, J, CATBLK(256)
      HOLLERITH CATH(256)
      REAL      CATR(256)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATBLK, CATR, CATH)
C-----------------------------------------------------------------------
C                                       start with 0's
      CALL FILL (256, 0, CATBLK)
C                                       characters
      CALL RFILL (2, HBLANK, CATH(KHOBJ))
      CALL RFILL (2, HBLANK, CATH(KHTEL))
      CALL RFILL (2, HBLANK, CATH(KHINS))
      CALL RFILL (2, HBLANK, CATH(KHOBS))
      CALL RFILL (2, HBLANK, CATH(KHDOB))
      CALL RFILL (2, HBLANK, CATH(KHDMP))
      CALL RFILL (2, HBLANK, CATH(KHBUN))
C                                       random parameters
      J = KHPTP
      DO 10 I = 1,KIPTPN
         CALL RFILL (2, HBLANK, CATH(J))
         J = J + 2
 10      CONTINUE
C                                       axis parameters
      DO 20 I = 1,KICTPN
         J = I - 1
         CALL RFILL (2, HBLANK, CATH(KHCTP+2*J))
         CATR(KRCIC+J) = 1.0
         CATR(KRCRP+J) = 1.0
         CATBLK(KINAX+J) = 1
 20      CONTINUE
C                                       epoch, name
      CATR(KREPO) = 2000.0
      CALL RFILL (5, HBLANK, CATH(KHIMN))
      CATBLK(KIIMU) = NLUSER
      CATR(KRWTN) = 1.0
C                                       extensions
      CALL CATCLR (CATBLK)
C                                       return it
      CALL COPY (256, CATBLK, HEADER)
C
 999  RETURN
      END

      SUBROUTINE ZLPCL2 (LLEN, LPRFIL, DELFIL, PRTMAX, SYSERR, IERR)
C-----------------------------------------------------------------------
C! queue a file to the line printer and delete
C# Z2 Printer
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Queue a line printer file to a printer, then delete it
C   Inputs:
C      LLEN     I       Length of "lprfil" in characters
C      LPRFIL   H*(*)   Name of the line printer file to queue
C      DELFIL   I       Disposition indicator code:
C                          0 => keep after printing
C                         >0 => delete after printing and delay of
C                               DELFIL (seconds)
C      PRTMAX   I       Length of a line printer page
C   Output:
C      SYSERR   I       System error code
C      IERR     I       Error return code: 0 => no error
C                          1 => error
C   Generic version  - stub
C-----------------------------------------------------------------------
      INTEGER   LLEN, DELFIL, PRTMAX, SYSERR, IERR
      HOLLERITH LPRFIL(*)
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      MSGTXT = 'ZLPCL2: REQUIRES LOCAL DEVELOPMENT'
      IERR = 2
      CALL MSGWRT (9)
C
 999  RETURN
      END

      SUBROUTINE YTVCIN
C-----------------------------------------------------------------------
C! initialize TV characteristics common (not needed much - see TVOPEN)
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YTVCIN initializes the common which describes the characteristics
C   of the interactive display devices and the common which has the
C   current status parameters of the TV.
C   NOTE: These are default values only.  They are reset to the
C   current true values by a call to TVOPEN.
C   NOTE: YTVCIN resets the common values of TVZOOM and TVscroll, but
C   does not call the TV routines to force these to be true.  A
C   separate call to YINIT is required.
C   IVAS version: order of double statements set for "11" bit mode
C-----------------------------------------------------------------------
      INTEGER   NDUMS
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      DATA NDUMS /8/
C-----------------------------------------------------------------------
C                                       # gray image planes -
C                                       this selects 8 vs 12 bit
      NGRAY = 3
      NGRAY = 2
C                                       # graphics overlay planes
      NGRAPH = 4
C                                       # images / gray plane max
      NIMAGE = 256
C                                       screen X, Y dimensions
      MAXXTV(1) = 1024
      MAXXTV(2) = 1024
C                                       12-bit done as 11-bit to allow
C                                       2 LUTs; block last 1 to avoid
C                                       bug in graphics
      IF (NGRAY.EQ.2) THEN
         MAXINT = 2046
C                                       max gray intensity (8-bit)
      ELSE
         MAXINT = 255
         END IF
C                                       Max intensity out of LUT
      LUTOUT = 255
C                                       Max intensity into OFM
      OFMINP = 255
C                                       Max intensity out of OFM
      OFMOUT = 255
C                                       min scroll increment
      SCXINC = 1
      SCYINC = 1
C                                       max zoom (power of 2)
C                                       <0 => linear steps to 1-MXZOOM
      MXZOOM = -15
C                                       character size (XY) of TV
      CSIZTV(1) = 12
      CSIZTV(2) = 22
C                                       Type of TV split screen
C                                       0 none, 1 vert only, 2 hor
C                                       only, 3 either, 4 both
      TYPSPL = 2
C                                       Number of TV ALU units
      TVALUS = 0
C                                       Mode of loading TV: x,y
C                                          0 -> not allowed
C                                          1 -> ok in AIPS order
C                                          2 -> in reverse order ok
      TVXMOD = 1
      TVYMOD = 0
C                                       Number Image Storage Units
      ISUNUM = 0
C                                       gamma correction factor
      TVGAMA = 2.0
C                                       Number channels / color
      IF (NGRAY.EQ.2) THEN
         TVIMPC = 0
      ELSE
         TVIMPC = 1
         END IF
C                                       Scratch piece of Common
      CALL FILL (NDUMS, 0, TVDUMS)
C                                       YBUFF special area
      CALL FILL (160, 0, YBUFF)
C                                       (1) <= 0=>no transfer restrict
C                                       (2) blink rate code
C                                       (3) <= 0 => cursor off
C                                       (4) Red quad 1 bit select mask
C                                       (5) Red quad 2 bit select mask
C                                       (6) Gre quad 1 bit select mask
C                                       (7) Gre quad 2 bit select mask
C                                       (8) Blu quad 1 bit select mask
C                                       (9) Blu quad 2 bit select mask
C                                       (10) Y split point
C                                       (11-12) IVASCHAN number open
C                                       (13-16) >0 => gph chan on
      CALL FILL (16, 0, YBUFF)
C                                       (17) > 0 -> debug
      YBUFF(17) = 0
C-----------------------------------------------------------------------
C                                       TV lun, FTAB pos, map, buf#
      TVLUN = 9
      TVIND = 0
      TVLUN2 = 8
      TVIND2 = 0
      TVMAP = .FALSE.
      TVBFNO = 1
C                                       TV zoom
      TVZOOM(1) = 0
      TVZOOM(2) = MAXXTV(1) / 2
      TVZOOM(3) = MAXXTV(2) / 2
C                                       TV scrolls
      CALL FILL (16, 0, TVSCRX)
      CALL FILL (16, 0, TVSCRY)
C                                       TV last referenced image
      CALL FILL (4, 0, TVLIMG)
C                                       TV split point
      TVSPLT(1) = 1
      TVSPLT(2) = 1
C                                       Split mode: none to start
      TVSPLM = 0
      TVSPLC = 0
C                                       TV movie status
      CALL FILL (16, 0, TYPMOV)
C                                       window
      WINDTV(1) = 1
      WINDTV(2) = 1
      WINDTV(3) = MAXXTV(1)
      WINDTV(4) = MAXXTV(2)
C                                       spare control space
      CALL FILL (4, 0, TVDUM2)
C
 999  RETURN
      END

      SUBROUTINE GPHWRT (BUFF, IERR)
C-----------------------------------------------------------------------
C! write plot buffer to file, prepares buffer for more commands
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   GPHWRT writes current buffer on graphics file, updates record
C   count, and rezeros the buffer and position pointer
C   In/out:
C      BUFF   I(256)   full graphics buffer in, cleared buffer out
C   Outputs:
C      IERR   I        error code: 0 => ok
C                              other => disk error
C-----------------------------------------------------------------------
      INTEGER   BUFF(256), IERR
C
      INTEGER   NREC
      INCLUDE 'INCS:DGPH.INC'
C-----------------------------------------------------------------------
      GPHRRN = GPHRRN + 1
      IF (GPHRRN.LE.GPHSIZ) GO TO 10
         NREC = 21
         CALL ZEXPND (GPHLUN, GPHVOL, GPHNAM, NREC, IERR)
         GPHSIZ = GPHSIZ + NREC
         IF (IERR.NE.0) GO TO 999
 10   CALL ZFIO ('WRIT', GPHLUN, GPHIND, GPHRRN, BUFF, IERR)
      GPHPOS = 0
      CALL FILL (256, 0, BUFF)
C
 999  RETURN
      END

      SUBROUTINE ZTKILL (NAME, PID, IERR)
C-----------------------------------------------------------------------
C! deletes (or kills) the specified process
C# Z System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZTKILL will delete/kill the process specified by NAME.
C   Inputs:
C      NAME   C*6    actual task name
C      PID    I(4)   Process "ID" code:
C                       PID(1) user number  0 => any user
C                       PID(2-4) process #  0 => unknown
C   Output:
C      IERR   I      Error number: 0 => ok.
C                       1 => error.
C   VAX Version: PID(2) now used if not 0
C-----------------------------------------------------------------------
      CHARACTER NAME*6
      INTEGER   PID(4), IERR
C
      INTEGER   JERR, SYS$FORCEX, IL, ITRIM
      CHARACTER DNAME*6
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
      IL = ITRIM (NAME)
C                                       Force exit of subprocess.
      IF (PID(2).GT.0) THEN
         JERR = SYS$FORCEX (PID(2), DNAME(1:IL), )
      ELSE
         JERR = SYS$FORCEX ( , DNAME(1:IL), )
         END IF
C                                       Print system error msg.
      IF (JERR.NE.1) THEN
         CALL ZERROR ('ZTKILL', JERR, ' ', -999, .FALSE.)
         IERR = 1
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZTTYIO (OPER, LUN, FIND, NCHARS, BUFF, IERR)
C-----------------------------------------------------------------------
C! read/write buffer to terminal
C# Terminal
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Perform I/O to a terminal.  Used by MSGWRT so cannot use MSGWRT.
C   Inputs:
C      OPER     C*4   Operation code 'READ' or 'WRIT'
C      LUN      I     Logical unit number
C      FIND     I     Index in FTAB to file control block for LUN
C      NCHARS   I     # characters to transfer (<= 132)
C   In/out:
C      BUFF     C*(*) I/O buffer containing characters (1-256)
C   Output:
C      IERR     I     Error return code: 0 => no error
C                        1 => file not open
C                        2 => input error
C                        3 => I/O error
C                        4 => end of file
C   Generic version: formatted IO does carriage control on output based
C   on parameter TTYCAR.
C-----------------------------------------------------------------------
      CHARACTER OPER*4, BUFF*(*)
      INTEGER   LUN, FIND, NCHARS, IERR
C
      INTEGER   IOSVAL
      LOGICAL   OPND
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Check inputs.
      IERR = 0
C                                       Valid LUN?
      IF ((LUN.EQ.5) .OR. (LUN.EQ.6)) GO TO 10
         IERR = 2
         WRITE (6,*) 'ZTTYIO: INVALID LUN = ',LUN
         GO TO 999
C                                       LUN open in FTAB?
 10   IF (FTAB(FIND).EQ.LUN) GO TO 20
         IERR = 1
         WRITE (6,*) 'ZTTYIO: LUN = ',LUN,' NOT OPEN IN FTAB'
         GO TO 999
C                                       LUN open?
 20   INQUIRE (UNIT=LUN, OPENED=OPND)
      IF (OPND) GO TO 30
         IERR = 1
         WRITE (6,*) 'ZTTYIO: LUN = ',LUN,' NOT OPEN'
         GO TO 999
C                                       Valid NCHARS?
 30   IF ((NCHARS.GT.0) .AND. (NCHARS.LE.MIN(256,LEN(BUFF)))) GO TO 40
         IERR = 2
         WRITE (6,*) 'ZTTYIO: INVALID NCHARS = ',NCHARS
         GO TO 999
C                                       Do read
 40   IF (OPER.EQ.'READ') THEN
         READ (5,1000,IOSTAT=IOSVAL) BUFF(1:NCHARS)
C                                       End of file (no message).
         IF (IOSVAL.LT.0) THEN
            IERR = 4
C                                       I/O error.
         ELSE IF (IOSVAL.NE.0) THEN
            IERR = 3
            WRITE (6,*) 'ZTTYIO: FORTRAN READ ERROR = ',IOSVAL,
     *         ' ON LUN = ',LUN
            CALL ZMSGER ('ZTTYIO', IOSVAL, ' ', -999, .FALSE.)
            END IF
C                                       Write to terminal.
      ELSE IF (OPER.EQ.'WRIT') THEN
         IF (TTYCAR.GT.0) THEN
            WRITE (6,1010,IOSTAT=IOSVAL) BUFF(1:NCHARS)
         ELSE
            WRITE (6,1000,IOSTAT=IOSVAL) BUFF(1:NCHARS)
            END IF
         IF (IOSVAL.NE.0) THEN
            IERR = 3
            WRITE (6,*) 'ZTTYIO: FORTRAN WRITE ERROR = ',IOSVAL,
     *         ' ON LUN = ',LUN
            CALL ZMSGER ('ZTTYIO', IOSVAL, ' ', -999, .FALSE.)
            END IF
C                                       Invalid operation.
      ELSE
         IERR = 2
         WRITE (6,*) 'ZTTYIO: INVALID OPERATION'
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A)
 1010 FORMAT (' ',A)
      END

LOCAL INCLUDE 'TYCOP.INC'
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMIN(3), XCLAIN(2), XEXTYP(1), XOPTYP(1)
      REAL      XSEQIN, XDISKI, XIVER, APARM(10), BPARM(10), XANT(50)
      INTEGER   SEQIN, DISKIN, CNO, BUFF1(512), BUFF2(512), IVER, OVER,
     *   NA, NB, IA(10), IB(10), CDIVER, CDOVER, LUN1, LUN2, IP1, IP2
      LOGICAL   SWAP, DOANT(MAXANT)
      CHARACTER  NAMEIN*12, CLAIN*6, EXTYPE*2, OPTYPE*4
      COMMON /INPARM/ XNAMIN, XCLAIN, XSEQIN, XDISKI, XEXTYP, XIVER,
     *   APARM, BPARM, XOPTYP, XANT
      COMMON /TYCOPI/ BUFF1, BUFF2, SEQIN, DISKIN, CNO, IVER, OVER,
     *   CDIVER, CDOVER, LUN1, LUN2, NA, NB, IA, IB, IP1, IP2, SWAP,
     *   DOANT
      COMMON /TYCOPC/ NAMEIN, CLAIN, EXTYPE, OPTYPE
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
LOCAL END
      PROGRAM TYCOP
C-----------------------------------------------------------------------
C! Task to copy calibration in SY/CD tables between IFs
C# EXT-util Utility Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2011, 2013, 2015, 2017, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TYCOP copies AIPS SY and CD extension files, averaging some IFs and
C   replacing other IFs with the average.  Also TY tables.
C   ADVERBS:
C      INNAME      Input image name (name)
C      INCLASS     Input image name (class)
C      INSEQ       Input image name (seq. #)
C      INDISK      Input image disk unit #
C      INVERS      Input table file version no.
C      APARM       IFs to average
C      BPARM       IFs to replace
C-----------------------------------------------------------------------
      INTEGER   IRET
      INCLUDE 'TYCOP.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       init
      CALL TYCOIN (IRET)
C                                       DO
      IF (IRET.EQ.0) THEN
         IF (EXTYPE.EQ.'SY') THEN
            CALL TYCOSY (IRET)
         ELSE
            CALL TYCOTY (IRET)
            END IF
C                                       History
         IF (IRET.EQ.0) CALL TYCOHI
         END IF
C
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE TYCOIN (IRET)
C-----------------------------------------------------------------------
C   TYCOIN does start up operations for TYCOP
C   Output:
C      IRET   I   > 0 => quit
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER PRGM*6, FTYPE*2, STAT*4
      INTEGER   IERR, I, IROUND, NPARM, J, NUMIF
      LOGICAL   WASNEG
      INCLUDE 'TYCOP.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'TYCOP '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 80
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMIN, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'GETTING INPUT PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMIN, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (2, 1, XEXTYP, EXTYPE)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      IF (OPTYPE.EQ.'R') THEN
         IP1 = 1
         IP2 = 1
         SWAP = .FALSE.
      ELSE IF (OPTYPE.EQ.'L') THEN
         IP1 = 2
         IP2 = 2
         SWAP = .FALSE.
      ELSE IF (OPTYPE.EQ.'R2L') THEN
         IP1 = 1
         IP2 = 1
         SWAP = .TRUE.
      ELSE IF (OPTYPE.EQ.'L2R') THEN
         IP1 = 2
         IP2 = 2
         SWAP = .TRUE.
      ELSE IF (OPTYPE.EQ.'AR2L') THEN
         IP1 = 1
         IP2 = 1
         SWAP = .TRUE.
      ELSE IF (OPTYPE.EQ.'AL2R') THEN
         IP1 = 2
         IP2 = 2
         SWAP = .TRUE.
      ELSE
         IP1 = 1
         IP2 = 2
         SWAP = .FALSE.
         OPTYPE = ' '
         END IF
C                                       Crunch input parameters.
      SEQIN  = IROUND (XSEQIN)
      DISKIN = IROUND (XDISKI)
      IVER   = IROUND (XIVER)
      CNO = 0
      WASNEG = .FALSE.
      CALL LFILL (MAXANT, .FALSE., DOANT)
      DO 20 I = 1,50
         J = IROUND (XANT(I))
         IF ((J.GT.0) .AND. (J.LE.MAXANT)) THEN
            DOANT(J) = .TRUE.
            CNO = CNO + 1
         ELSE IF ((J.LT.0) .AND. (J.GE.-MAXANT)) THEN
            DOANT(-J) = .TRUE.
            CNO = CNO + 1
            WASNEG = .TRUE.
         ELSE
            GO TO 25
            END IF
 20      CONTINUE
 25   IF (CNO.EQ.0) CALL LFILL (MAXANT, .TRUE., DOANT)
      IF (WASNEG) THEN
         DO 30 I = 1,MAXANT
            DOANT(I) = .NOT.DOANT(I)
 30         CONTINUE
         END IF
C                                       Find input
      CNO = 1
      FTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNO, NAMEIN, CLAIN, SEQIN, FTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read old CATBLK and mark 'WRIT'
      CALL CATIO ('READ', DISKIN, CNO, CATBLK, 'WRIT', BUFF1, IERR)
      IF ((IERR.GT.0) .AND. (IERR.LT.5)) THEN
         WRITE (MSGTXT,1000) IERR, 'READING FILE HEADER'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 1
C                                       get number IFs
      CALL UVPGET (IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'HEADER PARSING FAILS'
         GO TO 990
         END IF
      NUMIF = CATBLK(KINAX+JLOCIF)
      IF (OPTYPE(:1).EQ.'A') THEN
         NA = 0
         NB = 0
C                                       replace all
      ELSE IF (BPARM(1).LE.0.0) THEN
         NB = -1
         NA = 10
         DO 10 I = 1,10
            IA(I) = IROUND (APARM(I))
            IF ((IA(I).LE.0) .OR. (IA(I).GT.NUMIF)) NA = MIN (NA, I-1)
 10         CONTINUE
         IF (NA.LE.0) THEN
            MSGTXT = 'YOU MUST SPECIFY IFS IN APARM'
            IRET = 10
            GO TO 990
            END IF
      ELSE
         NA = 10
         NB = 10
         DO 15 I = 1,10
            IA(I) = IROUND (APARM(I))
            IB(I) = IROUND (BPARM(I))
            IF ((IA(I).LE.0) .OR. (IA(I).GT.NUMIF)) NA = MIN (NA, I-1)
            IF ((IB(I).LE.0) .OR. (IB(I).GT.NUMIF)) NB = MIN (NB, I-1)
 15         CONTINUE
         IF ((NA.LE.0) .OR. (NB.LE.0)) THEN
            MSGTXT = 'YOU MUST SPECIFY IFS IN APARM AND BPARM'
            IRET = 10
            GO TO 990
            END IF
         END IF
C                                       Check number of tables
      CALL FNDEXT ('SY', CATBLK, I)
      CALL FNDEXT ('TY', CATBLK, J)
      IF ((EXTYPE.NE.'SY') .AND. (EXTYPE.NE.'TY')) THEN
         IF ((I.LE.0) .AND. (J.GT.0)) THEN
            EXTYPE = 'TY'
         ELSE IF ((I.GT.0) .AND. (J.LE.0)) THEN
            EXTYPE = 'SY'
         ELSE
            MSGTXT = 'UNABLE TO DETERMINE INEXT'
            GO TO 990
            END IF
         END IF
      IF (EXTYPE.EQ.'TY') I = J
      IF (I.LE.0) THEN
         MSGTXT = 'DATA SET HAS NO ' // EXTYPE // ' TABLES'
         GO TO 990
         END IF
      IF ((IVER.LE.0) .OR. (IVER.GT.I)) IVER = I
      OVER = I + 1
      CALL FNDEXT ('CD', CATBLK, CDIVER)
      CDOVER = CDIVER + 1
C
      LUN1 = 27
      LUN2 = 28
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TYCOIN: ERROR',I3,1X,A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
      END
      SUBROUTINE TYCOHI
C-----------------------------------------------------------------------
C   TYCOHI ipdates the HI files for this operation
C-----------------------------------------------------------------------
C
      INTEGER   IRET, TIME(3), DATE(3), I, LA(50), IROUND, JA, IP, L
      LOGICAL   OMIT
      CHARACTER ATIME*8, ADATE*12, HILINE*72
      INCLUDE 'TYCOP.INC'
C-----------------------------------------------------------------------
C                                       Add history to output
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN1, DISKIN, CNO, BUFF1, IRET)
      IF (IRET.GT.2) THEN
         MSGTXT = 'COULD NOT OPEN HI FILE TO ADD UPDATES'
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
      WRITE (HILINE,1000) TSKNAM, RLSNAM, ADATE, ATIME
      CALL HIADD (LUN1, HILINE, BUFF1, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       Input file
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN1, BUFF1,
     *   IRET)
      IF (IRET.NE.0) GO TO 100
C                                       Type and version
      WRITE (HILINE,1010) TSKNAM, EXTYPE, IVER, OVER
      CALL HIADD (LUN1, HILINE, BUFF1, IRET)
      IF (IRET.NE.0) GO TO 100
      WRITE (MSGTXT,1011) EXTYPE, IVER, OVER
      CALL MSGWRT (4)
      IF (EXTYPE.EQ.'SY') THEN
         WRITE (HILINE,1010) TSKNAM, 'CD', CDIVER, CDOVER
         CALL HIADD (LUN1, HILINE, BUFF1, IRET)
         IF (IRET.NE.0) GO TO 100
         WRITE (MSGTXT,1011) 'CD', CDIVER, CDOVER
         CALL MSGWRT (4)
         END IF
C                                       IFs
      IF (OPTYPE(:1).NE.'A') THEN
         WRITE (HILINE,1020) TSKNAM, IA
         CALL HIADD (LUN1, HILINE, BUFF1, IRET)
         IF (IRET.NE.0) GO TO 100
         WRITE (MSGTXT,1021) (IA(I), I = 1,NA)
         CALL MSGWRT (4)
         IF (NB.GT.0) THEN
            WRITE (HILINE,1030) TSKNAM, IB
            WRITE (MSGTXT,1031) (IB(I), I = 1,NB)
         ELSE
            HILINE = TSKNAM // '/ Replaced ALL IFs'
            MSGTXT = 'Replaced ALL IFs'
            END IF
         CALL MSGWRT (4)
         CALL HIADD (LUN1, HILINE, BUFF1, IRET)
         IF (IRET.NE.0) GO TO 100
         END IF
C                                       OPTYPE
      WRITE (HILINE,1040) TSKNAM, OPTYPE
      CALL HIADD (LUN1, HILINE, BUFF1, IRET)
      IF (IRET.NE.0) GO TO 100
      WRITE (MSGTXT,1041) OPTYPE
      CALL MSGWRT (4)
C                                       antennas
      JA = 0
      OMIT = .FALSE.
      DO 50 I = 1,50
         L = IROUND (XANT(I))
         IF (L.LT.0) THEN
            OMIT = .TRUE.
            L = -L
         ELSE IF (L.EQ.0) THEN
            GO TO 55
            END IF
         DO 45 IP = 1,JA
            IF (L.EQ.LA(IP)) GO TO 50
 45         CONTINUE
         JA = JA + 1
         LA(JA) = L
 50      CONTINUE
 55   IF (JA.LE.0) THEN
         WRITE (HILINE,1050) TSKNAM
         CALL HIADD (LUN1, HILINE, BUFF1, IRET)
         IF (IRET.NE.0) GO TO 100
         WRITE (MSGTXT,1051)
         CALL MSGWRT (4)
      ELSE
         HILINE = TSKNAM // 'ANTENNAS ='
         IF (OMIT) THEN
            HILINE(63:) = '/ omitted'
            MSGTXT = 'Omitted antennas'
         ELSE
            HILINE(63:) = '/ included'
            MSGTXT = 'Included antennas'
            END IF
         IP = 17
         I = 1
 60      IF (I.LE.JA) THEN
            WRITE (HILINE(IP:IP+2),1060) LA(I)
            WRITE (MSGTXT(IP+1:IP+3),1060) LA(I)
            IP = IP + 3
            IF (I.LT.JA) THEN
               HILINE(IP:IP) = ','
               IP = IP + 1
               END IF
            IF ((IP.GE.58) .OR. (I.EQ.JA)) THEN
               CALL HIADD (LUN1, HILINE, BUFF1, IRET)
               IF (IRET.NE.0) GO TO 100
               CALL MSGWRT (4)
               HILINE(:62) = TSKNAM
               MSGTXT(18:) = ' '
               IP = 17
               END IF
            I = I + 1
            GO TO 60
            END IF
         END IF
C                                       Close HI file
 100  CALL HICLOS (LUN1, .TRUE., BUFF1, IRET)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'Release =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 1010 FORMAT (A6,'TABLE=''',A2,''' INVERS=',I5,' OUTVERS=', I5)
 1011 FORMAT ('Copied ',A2,' table version',I5,' to version',I5)
 1020 FORMAT (A6,'APARM=',9(I2,','),I2,'  / IFs averaged')
 1021 FORMAT ('Averaged IFs',10I5)
 1030 FORMAT (A6,'BPARM=',9(I2,','),I2,'  / IFs replaced')
 1031 FORMAT ('Replaced IFs',10I5)
 1040 FORMAT (A6,'OPTYPE=''',A4,'''  / polarizations used')
 1041 FORMAT ('Under OPTYPE = ''',A,'''')
 1050 FORMAT (A6,'ANTENNAS = 0',5X,'/ all antennas included')
 1051 FORMAT ('For all antennas')
 1060 FORMAT (I3)
      END
      SUBROUTINE TYCOSY (IRET)
C-----------------------------------------------------------------------
C   Routine to average SY and CD values over some IFs and place in
C   other IFs
C   Output:
C      IRET     I       Return error code  0 => ok
C                          else quit
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER RDATE*8
      INTEGER   IRNO, KOLS(MAXSYC), NUMV(MAXSYC), NUMANT, NUMPOL, NUMIF,
     *   SOURID, ANTNO, SUBA, FREQID, IROW, NROW, ND, NS, NG, II, IP, I,
     *   MD, CALTYP
      REAL      TIMEI, PDIFF(2,MAXIF), PSUM(2,MAXIF), PGAIN(2,MAXIF),
     *   SD, SS, SG, TCAL(4,MAXIF), SOLD
      DOUBLE PRECISION TIME
      INCLUDE 'TYCOP.INC'
C-----------------------------------------------------------------------
C                                       SY table
      CALL SYINI ('READ', BUFF1, DISKIN, CNO, IVER, CATBLK, LUN1, IRNO,
     *   KOLS, NUMV, NUMANT, NUMPOL, NUMIF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT SY TABLE'
         GO TO 990
         END IF
      IF (NUMPOL.EQ.1) THEN
         IF ((OPTYPE.NE.'R') .AND. (OPTYPE.NE.' ')) THEN
            MSGTXT = '1 POLARIZATION ONLY - OPTYPE=''' // OPTYPE //
     *         ' ILLEGAL'
            IRET = 10
            GO TO 990
            END IF
         IP2 = 1
         END IF
      CALL SYINI ('WRIT', BUFF2, DISKIN, CNO, OVER, CATBLK, LUN2, IRNO,
     *   KOLS, NUMV, NUMANT, NUMPOL, NUMIF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT SY TABLE'
         GO TO 990
         END IF
      NROW = BUFF1(5)
      DO 50 IROW = 1,NROW
         IRNO = IROW
         CALL TABSY ('READ', BUFF1, IRNO, KOLS, NUMV, NUMPOL, NUMIF,
     *      TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA, FREQID, PDIFF,
     *      PSUM, PGAIN, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT SY TABLE'
            GO TO 990
            END IF
         IF (DOANT(ANTNO)) THEN
            IF (OPTYPE(:1).NE.'A') THEN
               DO 30 IP = IP1,IP2
                  ND = 0
                  NS = 0
                  NG = 0
                  SD = 0.0
                  SS = 0.0
                  SG = 0.0
                  DO 10 I = 1,NA
                     II = IA(I)
                     IF ((PDIFF(IP,II).NE.FBLANK) .AND.
     *                  (PDIFF(IP,II).GT.0.0))THEN
                        ND = ND + 1
                        SD = SD + PDIFF(IP,II)
                        END IF
                     IF ((PSUM(IP,II).NE.FBLANK) .AND.
     *                  (PSUM(IP,II).GT.0.0)) THEN
                        NS = NS + 1
                        SS = SS + PSUM(IP,II)
                        END IF
                     IF ((PGAIN(IP,II).NE.FBLANK) .AND.
     *                  (PGAIN(IP,II).GT.0.0)) THEN
                        NG = NG + 1
                        SG = SG + PGAIN(IP,II)
                        END IF
 10                  CONTINUE
                  IF (ND.GT.0) THEN
                     SD = SD / ND
                  ELSE
                     SD = FBLANK
                     END IF
                  IF (NS.GT.0) THEN
                     SS = SS / NS
                  ELSE
                     SS = FBLANK
                     END IF
                  IF (NG.GT.0) THEN
                     SG = SG / NG
                  ELSE
                     SG = FBLANK
                     END IF
                  IF (NB.LT.0) THEN
                     DO 15 I = 1,NUMIF
                        II = I
                        IF (SWAP) THEN
                           PDIFF(3-IP,II) = SD
                           PSUM(3-IP,II) = SS
                           PGAIN(3-IP,II) = SG
                        ELSE
                           PDIFF(IP,II) = SD
                           PSUM(IP,II) = SS
                           PGAIN(IP,II) = SG
                           END IF
 15                     CONTINUE
                  ELSE
                     DO 20 I = 1,NB
                        II = IB(I)
                        IF (SWAP) THEN
                           PDIFF(3-IP,II) = SD
                           PSUM(3-IP,II) = SS
                           PGAIN(3-IP,II) = SG
                        ELSE
                           PDIFF(IP,II) = SD
                           PSUM(IP,II) = SS
                           PGAIN(IP,II) = SG
                           END IF
 20                     CONTINUE
                     END IF
 30               CONTINUE
C                                       all IFs transfer
            ELSE
               DO 40 IP = IP1,IP2
                  DO 35 II = 1,NUMIF
                     PDIFF(3-IP,II) = PDIFF(IP,II)
                     PSUM(3-IP,II) =  PSUM(IP,II)
                     PGAIN(3-IP,II) = PGAIN(IP,II)
 35                  CONTINUE
 40               CONTINUE
               END IF
            END IF
         IRNO = IROW
         CALL TABSY ('WRIT', BUFF2, IRNO, KOLS, NUMV, NUMPOL, NUMIF,
     *      TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA, FREQID, PDIFF,
     *      PSUM, PGAIN, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT SY TABLE'
            GO TO 990
            END IF
 50      CONTINUE
      CALL TABSY ('CLOS', BUFF2, IRNO, KOLS, NUMV, NUMPOL, NUMIF, TIME,
     *   TIMEI, CALTYP, SOURID, ANTNO, SUBA, FREQID, PDIFF, PSUM, PGAIN,
     *   IRET)
      CALL TABSY ('CLOS', BUFF1, IRNO, KOLS, NUMV, NUMPOL, NUMIF, TIME,
     *   TIMEI, CALTYP, SOURID, ANTNO, SUBA, FREQID, PDIFF, PSUM, PGAIN,
     *   IRET)
C                                       CD tables
      CALL CDINI ('READ', BUFF1, DISKIN, CNO, CDIVER, CATBLK, LUN1,
     *   IRNO, KOLS, NUMV, NUMANT, NUMPOL, NUMIF, RDATE, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT CD TABLE'
         GO TO 990
         END IF
      CALL CDINI ('WRIT', BUFF2, DISKIN, CNO, CDOVER, CATBLK, LUN2,
     *   IRNO, KOLS, NUMV, NUMANT, NUMPOL, NUMIF, RDATE, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT CD TABLE'
         GO TO 990
         END IF
      NROW = BUFF1(5)
      DO 100 IROW = 1,NROW
         IRNO = IROW
         CALL TABCD ('READ', BUFF1, IRNO, KOLS, NUMV, NUMPOL, NUMIF,
     *      ANTNO, SUBA, FREQID, TCAL, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT CD TABLE'
            GO TO 990
            END IF
         IF (DOANT(ANTNO)) THEN
            IF (OPTYPE(:1).NE.'A') THEN
               DO 80 IP = IP1,IP2
                  ND = 0
                  SD = 0.0
                  MD = 0
                  SOLD = 0.0
                  DO 60 I = 1,NA
                     II = IA(I)
                     IF ((TCAL(IP,II).NE.FBLANK) .AND.
     *                  (TCAL(IP,II).GT.0.0)) THEN
                        ND = ND + 1
                        SD = SD + TCAL(IP,II)
                        END IF
                     IF ((TCAL(IP+2,II).NE.FBLANK) .AND.
     *                  (TCAL(IP+2,II).GT.0.0)) THEN
                        MD = MD + 1
                        SOLD = SOLD + TCAL(IP+2,II)
                        END IF
 60                  CONTINUE
                  IF (ND.GT.0) THEN
                     SD = SD / ND
                  ELSE
                     SD = FBLANK
                     END IF
                  IF (MD.GT.0) THEN
                     SOLD = SOLD / MD
                  ELSE
                     SOLD = FBLANK
                     END IF
                  DO 70 I = 1,NB
                     II = IB(I)
                     IF (SWAP) THEN
                        TCAL(3-IP,II) = SD
                        TCAL(3-IP+2,II) = SOLD
                     ELSE
                        TCAL(IP,II) = SD
                        TCAL(IP+2,II) = SOLD
                        END IF
 70                  CONTINUE
 80               CONTINUE
C                                       all IFs move
            ELSE
               DO 90 IP = IP1,IP2
                  DO 85 II = 1,NUMIF
                     TCAL(3-IP,II) = TCAL(IP,II)
                     TCAL(3-IP+2,II) = TCAL(IP+2,II)
 85                  CONTINUE
 90               CONTINUE
               END IF
            END IF
         IRNO = IROW
         CALL TABCD ('WRIT', BUFF2, IRNO, KOLS, NUMV, NUMPOL, NUMIF,
     *      ANTNO, SUBA, FREQID, TCAL, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT CD TABLE'
            GO TO 990
            END IF
 100     CONTINUE
      CALL TABCD ('CLOS', BUFF2, IRNO, KOLS, NUMV, NUMPOL, NUMIF, ANTNO,
     *   SUBA, FREQID, TCAL, IRET)
      CALL TABCD ('CLOS', BUFF1, IRNO, KOLS, NUMV, NUMPOL, NUMIF, ANTNO,
     *   SUBA, FREQID, TCAL, IRET)
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TYCOSY: ERROR',I4,1X,A)
      END
      SUBROUTINE TYCOTY (IRET)
C-----------------------------------------------------------------------
C   Routine to average TY values over some IFs and place in other IFs
C   Output:
C      IRET     I       Return error code  0 => ok
C                          else quit
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IRNO, KOLS(MAXTYC), NUMV(MAXTYC), NUMPOL, NUMIF, SOURID,
     *   ANTNO, SUBA, FREQID, IROW, NROW, ND, NS, II, IP, I
      REAL      TIME, TIMEI, TSYS(2,MAXIF), TANT(2,MAXIF), SD, SS
      INCLUDE 'TYCOP.INC'
C-----------------------------------------------------------------------
C                                       TY table
      CALL TYINI ('READ', BUFF1, DISKIN, CNO, IVER, CATBLK, LUN1, IRNO,
     *   KOLS, NUMV, NUMPOL, NUMIF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT TY TABLE'
         GO TO 990
         END IF
      IF (NUMPOL.EQ.1) THEN
         IF ((OPTYPE.NE.'R') .AND. (OPTYPE.NE.' ')) THEN
            MSGTXT = '1 POLARIZATION ONLY - OPTYPE=''' // OPTYPE //
     *         ' ILLEGAL'
            IRET = 10
            GO TO 990
            END IF
         IP2 = 1
         END IF
      CALL TYINI ('WRIT', BUFF2, DISKIN, CNO, OVER, CATBLK, LUN2, IRNO,
     *   KOLS, NUMV, NUMPOL, NUMIF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT TY TABLE'
         GO TO 990
         END IF
      NROW = BUFF1(5)
      DO 50 IROW = 1,NROW
         IRNO = IROW
         CALL TABTY ('READ', BUFF1, IRNO, KOLS, NUMV, NUMPOL, NUMIF,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, TSYS, TANT, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT TY TABLE'
            GO TO 990
            END IF
         IF (DOANT(ANTNO)) THEN
            IF (OPTYPE(:1).NE.'A') THEN
               DO 30 IP = IP1,IP2
                  ND = 0
                  NS = 0
                  SD = 0.0
                  SS = 0.0
                  DO 10 I = 1,NA
                     II = IA(I)
                     IF ((TSYS(IP,II).NE.FBLANK) .AND.
     *                  (TSYS(IP,II).GT.0.0))THEN
                        ND = ND + 1
                        SD = SD + TSYS(IP,II)
                        END IF
                     IF ((TANT(IP,II).NE.FBLANK) .AND.
     *                  (TANT(IP,II).GT.0.0)) THEN
                        NS = NS + 1
                        SS = SS + TANT(IP,II)
                        END IF
 10                  CONTINUE
                  IF (ND.GT.0) THEN
                     SD = SD / ND
                  ELSE
                     SD = FBLANK
                     END IF
                  IF (NS.GT.0) THEN
                     SS = SS / NS
                  ELSE
                     SS = FBLANK
                     END IF
                  DO 20 I = 1,NB
                     II = IB(I)
                     IF (SWAP) THEN
                        TSYS(3-IP,II) = SD
                        TANT(3-IP,II) = SS
                     ELSE
                        TSYS(IP,II) = SD
                        TANT(IP,II) = SS
                        END IF
 20                  CONTINUE
 30               CONTINUE
C                                       all IFs transfer
            ELSE
               DO 40 IP = IP1,IP2
                  DO 35 II = 1,NUMIF
                     TSYS(3-IP,II) = TSYS(IP,II)
                     TANT(3-IP,II) =  TANT(IP,II)
 35                  CONTINUE
 40               CONTINUE
               END IF
            END IF
         IRNO = IROW
         CALL TABTY ('WRIT', BUFF2, IRNO, KOLS, NUMV, NUMPOL, NUMIF,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, TSYS, TANT, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT TY TABLE'
            GO TO 990
            END IF
 50      CONTINUE
      CALL TABTY ('CLOS', BUFF2, IRNO, KOLS, NUMV, NUMPOL, NUMIF, TIME,
     *   TIMEI, SOURID, ANTNO, SUBA, FREQID, TSYS, TANT, IRET)
      CALL TABTY ('CLOS', BUFF1, IRNO, KOLS, NUMV, NUMPOL, NUMIF, TIME,
     *   TIMEI, SOURID, ANTNO, SUBA, FREQID, TSYS, TANT, IRET)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TYCOTY: ERROR',I4,1X,A)
      END

      SUBROUTINE QGRDCC (APCORE, CMS, CMG, CMP, GRD, NY, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Grid and FT Clean components.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999, 2006, 2008m 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version.
C   GRDCC is a utility routine for GRDCRM to do gridded Clean component
C   modeling.  GRDCC does a direct Fourier transform on components in
C   vector CMS to vector CMP, FFTs in Y, then swaps zero to the center.
C   It then tapers as needed and finally adds to the previous GRID
C   value.  Output is in vector CMP.  Finally GRDCC prepares CMS and the
C   phase ramp values for the next call.
C   Inputs:
C      CMS   I   Base address of component vector, increment=5:
C                  0 = Y (cells, integer)
C                  1 = Flux * cos(ux)
C                  2 = Flux * sin(ux)
C                  3 = cos(x)
C                  4 = sin(x)
C      CMG   I   Base address of Gaussian taper function (if >= 0)
C      CMP   I   Base address of complex work row. (increment = 2)
C      GRD   I   Base address of input/output row. (increment=2)
C      NY    I   Length of row (number of complex values)
C      N     I   Number of components in vector CMS
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   CMS, CMG, CMP, GRD, NY, N
C
      INTEGER   NY2, CMS1, CMS3, CMPH, CMP1
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Setup pointers etc.
      NY2 = NY * 2
      CMS1 = CMS + 1
      CMS3 = CMS + 3
      CMPH = CMP + NY
      CMP1 = CMP + 1
C                                       Clear CMP (output vector)
      CALL QVCLR (APCORE, CMP, 1, NY2)
C                                       DFT in X
      CALL QDIRAD (APCORE, CMS, 5, CMP, N)
C                                       FFT in Y
      CALL QCFFT (APCORE, CMP, NY, 1)
C                                       Swap zero to center.
      CALL QVSWAP (APCORE, CMP, 1, CMPH, 1, NY)
C                                       Taper
      IF (CMG.GE.0) THEN
         CALL QVMUL (APCORE, CMG, 1, CMP, 2, CMP, 2, NY)
         CALL QVMUL (APCORE, CMG, 1, CMP1, 2, CMP1, 2, NY)
         END IF
C                                       Add previous grid.
      CALL QVADD (APCORE, CMP, 1, GRD, 1, GRD, 1, NY2)
C                                       Rotate DFT for next call
      CALL QCVMUL (APCORE, CMS1, 5, CMS3, 5, CMS1, 5, N, 1)
C
 999  RETURN
      END

      SUBROUTINE YALUCT (OP, ARMODE, BFUNC, NFUNC, CONSTS, OUTSEL,
     *   EXTOFM, ESHIFT, SHIFT, CARYIN, CARRY, EQUAL, IERR)
C-----------------------------------------------------------------------
C! drives the TV arithmetic logic unit - not to be used much
C# Y2 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YALUCT reads / writes the TV arithmetic logic unit control
C   registers.  The actual feedback-ALU computation is performed only
C   upon a call to YFDBCK.
C   Inputs:
C      OP      C*4     'READ' from TV or 'WRIT' to TV
C   In/Out:
C      ARMODE  L       T => arithmetic mode F => logic mode
C      BFUNC   I       function number (1-16) in blotch
C      NFUNC   I       function number (1-16) outside blotch
C      CONSTS  I(8)    constant array (may select as ALU output)
C                      --- dimension 16 on Model 75
C      OUTSEL  I(8)    lookup table selects output based on carry
C                      (lsb), equal, ROI (msb) input.
C                      --- dimension 16 on Model 75, M75 values
C                      0     : consts 1 - 16 (addressed by x-reg)
C                      8     : accumulator channel pair
C                      9     : ALU-B
C                      10    : ALU-A
C                      11    : external
C                      M70 values
C                      0 - 7 : constants 1 - 8
C                      8     : accumulator channel pair
C                      9     : selected OFM
C                      10    : ALU
C                      11    : external
C      EXTOFM  L       T => extend sign of OFM on input to ALU
C      ESHIFT  L       T => extend sign of ALU output if SHIFT
C      SHIFT   L       T => right shift ALU output
C      CARYIN  L       T => add one to arithmetic results
C   Output:
C      CARRY   L       T => carry condition occurred in frame
C      EQUAL   L       T => equal condition occurred in frame
C      IERR    I       error code of Z...XF : 0 - ok
C                                             2 - input error
C           CONSTS  I(16)   constant array (may select as ALU output)
C           OUTSEL  I(16)   lookup table selects output based on carry
C                           (lsb), equal, ROI (msb) input. values -
C   IIS model 75 version
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   BFUNC, NFUNC, CONSTS(16), OUTSEL(16), IERR
      LOGICAL   ARMODE, EXTOFM, ESHIFT, SHIFT, CARYIN, CARRY, EQUAL
C
      INTEGER   HEADER(8), BUFFER(32), BUFSZ1, BUFSZ2, UNIT, BITS(16),
     *   NB, I, NOT
      LOGICAL   COMND1, COMND2, VRTRTC
      INCLUDE 'INCS:DTVC.INC'
      DATA UNIT, COMND1, COMND2, BUFSZ1, BUFSZ2 /11,.TRUE.,.FALSE.,
     *   1,32/
      DATA VRTRTC /.FALSE./
C-----------------------------------------------------------------------
C                                       Bad op if no ALU units
      IERR = 2
      IF (TVALUS.LE.0) GO TO 999
C                                       Control register first
C                                       write: check errors
      IF (OP.EQ.'WRIT') THEN
         IF ((BFUNC.LT.1) .OR. (BFUNC.GT.16)) GO TO 999
         IF ((NFUNC.LT.1) .OR. (NFUNC.GT.16)) GO TO 999
         DO 10 I = 1,16
            IF ((OUTSEL(I).LT.0) .OR. (OUTSEL(I).GT.11)) GO TO 999
 10         CONTINUE
C                                       Build word
         I = NFUNC - 1
         CALL ZGTBIT (4, I, BITS(1))
         I = BFUNC - 1
         CALL ZGTBIT (4, I, BITS(5))
         BITS(11) = 1
         BITS(15) = 0
         BITS(16) = 0
         IF (.NOT.ARMODE) BITS( 9) = 1
         IF (CARYIN) BITS(10) = 1
         IF (EXTOFM) BITS(12) = 1
         IF (SHIFT ) BITS(13) = 1
         IF ((ESHIFT) .AND. (SHIFT)) BITS(14) = 1
         CALL ZPTBIT (16, BUFFER, BITS)
         END IF
C                                        Header & IO
      CALL YMKHDR (OP, UNIT, COMND1, BUFSZ1, 0, 0, 0, 0, VRTRTC, HEADER)
      NB = BUFSZ1 * 2
      CALL ZM70XF (OP, NB, HEADER, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        READ: return control parms
      IF (OP.NE.'WRIT') THEN
         CALL ZGTBIT (16, BUFFER(1), BITS)
         CALL ZPTBIT (4, NFUNC, BITS(1))
         CALL ZPTBIT (4, BFUNC, BITS(5))
         NFUNC = NFUNC + 1
         BFUNC = BFUNC + 1
         ARMODE = BITS(9).NE.1
         CARYIN = BITS(10).EQ.1
         EXTOFM = BITS(12).EQ.1
         SHIFT  = BITS(13).EQ.1
         ESHIFT = BITS(14).EQ.1
         CARRY  = BITS(15).EQ.1
         EQUAL  = BITS(16).EQ.1
C                                       Data registers
C                                       YALUCR converts to needed
C                                       1's complement & back
      ELSE
         DO 20 I = 1,16
            BUFFER(I+16) = CONSTS(I)
            BUFFER(I   ) = OUTSEL(I)
 20         CONTINUE
         END IF
C                                       Header & IO
      CALL YMKHDR (OP, UNIT, COMND2, BUFSZ2, 0, 0, 0, 0, VRTRTC,
     *   HEADER)
      NB = 2 * BUFSZ2
      CALL ZM70XF (OP, NB, HEADER, BUFFER, IERR)
C                                       Return registers
      IF ((IERR.EQ.0) .AND. (OP.NE.'WRIT')) THEN
         DO 30 I = 1,16
            OUTSEL(I) = BUFFER(I)
            CONSTS(I) = BUFFER(I+16)
 30         CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE LMSTR (FCN, M, N, X, FVEC, FJAC, LDFJAC, FTOL, XTOL,
     *   GTOL, MAXFEV, DIAG, MODE, FACTOR, NPRINT, INFO, NFEV, NJEV,
     *   IPVT, QTF, WA1, WA2, WA3, WA4)
C-----------------------------------------------------------------------
C! minimize sum of squares of M nonlinear functions in N variables
C# Math Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   The purpose of LMSTR is to minimize the sum of the squares of M
C   nonlinear functions in N variables by a modification of the
C   Levenberg-Marquardt algorithm which uses minimum storage.  The user
C   must provide a subroutine which calculates the functions and the
C   rows of the Jacobian.  Subprograms called
C       User-supplied ...... FCN
C       Minpack-supplied ... DPMPAR, ENORM, LMPAR, QRFAC
C       FORTRAN-supplied ... ABS, MAX, MIN, SQRT, MOD
C   Argonne National Laboratory. Minpack project. March 1980.
C   Burton S. Garbow, Kenneth E. Hillstrom, Jorge J. More
C   Inputs:
C      FCN     EXTERNAL The name of the user-supplied subroutine
C                    which calculates the functions and the rows of
C                    the Jacobian.  FCN must be declared in an external
C                    statement in the user calling program, and should
C                    be written as follows:
C *********************************************************************
C         SUBROUTINE FCN (M, N, X, FVEC, FJROW, IFLAG)
C         INTEGER   M, N, IFLAG
C         DOUBLE PRECISION X(N), FVEC(M), FJROW(N)
C            If IFLAG = 1 calculate the functions at X and
C               return this vector if FVEC.
C            If IFLAG <> 1 calculate the (IFLAG - 1)st row of the
C               Jacobian at X and return this vector in FJROW.
C         RETURN
C         END
C            The value of IFLAG should not be changed by FCN unless
C            the user wants to terminate execution of LMSTR.
C            In this case set IFLAG to a negative INTEGER*2.
C**********************************************************************
C      M       I     The number of functions (adj. array dim.).
C      N       I     The number of variables. N must not exceed M
C                    (adj. array dim.).
C      X       D(N)  contains an initial estimate of solution vector
C      FTOL    D     Termination occurs when both the actual and
C                    predicted relative reductions in the sum of
C                    squares are at most FTOL. Therefore, FTOL measures
C                    the relative error desired in the sum of squares.
C      XTOL    D     Termination occurs when the relative error
C                    between two consecutive iterates is at most XTOL.
C                    therefore, XTOL measures the relative error desired
C                    in the approximate solution.
C      GTOL    D     Termination occurs when the cosine of the angle
C                    between FVEC and any column of the Jacobian is at
C                    most GTOL in absolute value. Therefore, GTOL
C                    measures the orthogonality desired between the
C                    function vector and the columns of the Jacobian.
C      MAXFEV  I     Termination occurs when the number of calls to
C                    FCN with IFLAG = 1 has reached MAXFEV.
C      DIAG    D(N)  If MODE = 1 (see below), DIAG is internally
C                    set. If MODE = 2, DIAG must contain positive
C                    entries that serve as multiplicative scale factors
C                    for the variables.
C      MODE    I     If MODE = 1, the variables will be scaled
C                    internally. If MODE = 2, the scaling is specified
C                    by the input DIAG. other values of mode are
C                    equivalent to MODE = 1.
C      FACTOR  D     Used in determining the initial step bound.
C                    This bound is set to the product of FACTOR and
C                    the Euclidean norm of DIAG*X if nonzero, or else
C                    to FACTOR itself. In most cases FACTOR should lie
C                    in the interval (.1,100.0).  100.0 is a generally
C                    recommended value.
C      NPRINT  I     enables controlled printing of iterates if it
C                    is positive. In this case, FCN is called with
C                    IFLAG = 0 at the beginning of the first iteration
C                    and every NPRINT iterations thereafter and
C                    immediately prior to return, with X, FVEC, and
C                    FJAC available for printing. FVEC and FJAC should
C                    not be altered. If NPRINT is not positive, no
C                    special calls of FCN with IFLAG = 0 are made.
C      LDFJAC  I     variable not less than N which specifies the
C                    leading dimension of the array FJAC (adj. array
C                    dim.)
C   Outputs:
C      X       D(N)  contains the final estimate of solution vector
C      FVEC    D(M)  contains the functions evaluated at the output X
C      FJAC    D(N,N)   contains an upper triangular matrix R with
C                    diagonal elements of nonincreasing magnitude
C                    such that
C                             T     T           T
C                            P *(JAC *JAC)*P = R *R,
C                    where P is a permutation matrix and JAC is the
C                    final calculated Jacobian. Column J of P is column
C                    IPVT(J) (see below) of the identity matrix. The
C                    lower trapezoidal part of FJAC contains information
C                    generated during the computation of R.
C      INFO    I     If the user has terminated execution, INFO is
C                    set to the (negative) value of IFLAG. See
C                    description of FCN. otherwise, INFO is set
C                    as follows:
C                    INFO = 0  Improper input parameters.
C                    INFO = 1  Algorithm estimates that the relative
C                       error in the sum of squares is at most FTOL.
C                    INFO = 2  Algorithm estimates that the relative
C                       error between X and the solution is at most XTOL
C                    INFO = 3  Conditions for INFO = 1 and INFO = 2
C                       both hold.
C                    INFO = 4  The cosine of the angle between FVEC
C                       and any column of the Jacobian is at most GTOL
C                       in absolute value.
C                    INFO = 5  Number of calls to FCN with IFLAG = 1 has
C                       reached MAXFEV.
C                    INFO = 6  FTOL is too small. No further reduction
C                       in the sum of squares is possible.
C                    INFO = 7  XTOL is too small. No further improvement
C                       in the approximate solution X is possible.
C                    INFO = 8  GTOL is too small. FVEC is orthogonal
C                       to the columns of the Jacobian to machine
C                       precision.
C      NFEV    I     Number of calls to FCN with IFLAG = 1.
C      NJEV    I     The number of calls to FCN with IFLAG = 2.
C      IPVT    I(N)  Defines a permutation matrix P such that
C                            JAC*P = Q*R,
C                    where JAC is the final calculated Jacobian, Q is
C                    orthogonal (not stored), and R is upper triangular
C                    with diagonal elements of nonincreasing magnitude.
C                    column J of P is column IPVT(J) of the identity
C                    matrix.
C      QTF     D(N)  contains the first N elements of the
C                    vector (Q transpose)*FVEC.
C      WA1     D(N)  work array.
C      WA2     D(N)  work array.
C      WA3     D(N)  work array.
C      WA4     D(M)  work array.
C-----------------------------------------------------------------------
C                                       This because SUNs are so STUPID
C     INTEGER   FCN
      EXTERNAL  FCN
      INTEGER   M, N, LDFJAC, MAXFEV, MODE, NPRINT, INFO, NFEV, NJEV,
     *   IPVT(N)
      DOUBLE PRECISION FTOL, XTOL, GTOL, FACTOR, X(N), FVEC(M),
     *   FJAC(LDFJAC,N), DIAG(N), QTF(N), WA1(N), WA2(N), WA3(N), WA4(M)
C
      INTEGER   I, IFLAG, ITER, J, L, IJ
      LOGICAL   SING, T
      DOUBLE PRECISION ACTRED, DELTA, DIRDER, EPSMCH, FNORM, FNORM1,
     *   GNORM, ONE, PAR, PNORM, PRERED, P1, P5, P25, P75, P0001, RATIO,
     *   SUM, TEMP, TEMP1, TEMP2, XNORM, ZERO, DPMPAR, ENORM
      DATA T /.TRUE./
      DATA ONE, P1, P5, P25, P75, P0001, ZERO
     *   /1.0D0,1.0D-1,5.0D-1,2.5D-1,7.5D-1,1.0D-4,0.0D0/
C-----------------------------------------------------------------------
C                                       EPSMCH is the machine precision
      EPSMCH = DPMPAR (1)
C
      INFO = 0
      IFLAG = 0
      NFEV = 0
      NJEV = 0
C                                       Check the input parameters for
C                                       errors.
      IF ((N.LE.0) .OR. (M.LT.N) .OR. (LDFJAC.LT.N)
     *   .OR. (FTOL.LT.ZERO) .OR. (XTOL.LT.ZERO) .OR. (GTOL.LT.ZERO)
     *   .OR. (MAXFEV.LE.0) .OR. (FACTOR.LE.ZERO)) GO TO 980
      IF (MODE.EQ.2) THEN
         DO 10 J = 1,N
            IF (DIAG(J).LE.ZERO) GO TO 980
 10         CONTINUE
         END IF
C                                       Evaluate the function at the
C                                       starting point and calculate
C                                       its norm.
      IFLAG = 1
      CALL FCN (M, N, X, FVEC, WA3, IFLAG)
      NFEV = 1
      IF (IFLAG.LT.0) GO TO 980
      FNORM = ENORM (M, FVEC)
C                                       Initialize Levenberg-Marquardt
C                                       parameter and iteration counter
      PAR = ZERO
      ITER = 1
C                                       Beginning of the outer loop.
 30   CONTINUE
C                                       If requested, call FCN to
C                                       enable printing of iterates.
         IF (NPRINT.GT.0) THEN
            IFLAG = 0
            IF (MOD(ITER-1,NPRINT).EQ.0) CALL FCN (M, N, X, FVEC,
     *         WA3, IFLAG)
            IF (IFLAG.LT.0) GO TO 980
            END IF
C                                       Compute the QR factorization
C                                       of the Jacobian matrix
C                                       calculated one row at a time,
C                                       while simultaneously
C                                       forming (Q transpose)*FVEC
C                                       and storing the first
C                                       N components in QTF.
         DO 60 J = 1,N
            QTF(J) = ZERO
            DO 50 I = 1,N
               FJAC(I,J) = ZERO
 50            CONTINUE
 60         CONTINUE
         IFLAG = 2
         DO 70 I = 1,M
            CALL FCN (M, N, X, FVEC, WA3, IFLAG)
            IF (IFLAG.LT.0) GO TO 980
            TEMP = FVEC(I)
            CALL RWUPDT (N, FJAC, LDFJAC, WA3, QTF, TEMP, WA1, WA2)
            IFLAG = IFLAG + 1
 70         CONTINUE
         NJEV = NJEV + 1
C                                       If the Jacobian is rank
C                                       deficient, call QRFAC to
C                                       reorder its columns and update
C                                       the components of QTF.
         SING = .FALSE.
         DO 80 J = 1,N
            IF (FJAC(J,J).EQ.ZERO) SING = .TRUE.
            IPVT(J) = J
            IJ = J
            WA2(J) = ENORM (IJ, FJAC(1,J))
 80         CONTINUE
         IF (SING) THEN
            CALL QRFAC (N, N, FJAC, LDFJAC, T, IPVT, N, WA1, WA2, WA3)
            DO 120 J = 1,N
               IF (FJAC(J,J).NE.ZERO) THEN
                  SUM = ZERO
                  DO 90 I = J,N
                     SUM = SUM + FJAC(I,J) * QTF(I)
 90                  CONTINUE
                  TEMP = -SUM / FJAC(J,J)
                  DO 100 I = J,N
                     QTF(I) = QTF(I) + FJAC(I,J) * TEMP
 100                 CONTINUE
                  END IF
               FJAC(J,J) = WA1(J)
 120           CONTINUE
            END IF
C                                       On the first iteration and if
C                                       mode is 1, scale according
C                                       to the norms of the columns
C                                       of the initial Jacobian.
C
         IF (ITER.EQ.1) THEN
            IF (MODE.NE.2) THEN
               DO 140 J = 1,N
                  DIAG(J) = WA2(J)
                  IF (WA2(J).EQ.ZERO) DIAG(J) = ONE
 140              CONTINUE
               END IF
C                                       On the first iteration,
C                                       calculate the norm of the scaled
C                                       X and initialize the step bound
C                                       DELTA.
            DO 160 J = 1,N
               WA3(J) = DIAG(J) * X(J)
 160           CONTINUE
            XNORM = ENORM (N, WA3)
            DELTA = FACTOR * XNORM
            IF (DELTA.EQ.ZERO) DELTA = FACTOR
            END IF
C                                       Compute the norm of the scaled
C                                       gradient.
         GNORM = ZERO
         IF (FNORM.NE.ZERO) THEN
            DO 200 J = 1,N
               L = IPVT(J)
               IF (WA2(L).EQ.ZERO) GO TO 200
                  SUM = ZERO
                  DO 180 I = 1,J
                     SUM = SUM + FJAC(I,J) * (QTF(I)/FNORM)
 180                 CONTINUE
                  GNORM = MAX (GNORM, ABS (SUM/WA2(L)))
 200           CONTINUE
            END IF
C                                       Test for convergence of the
C                                       gradient norm.
         IF (GNORM.LE.GTOL) INFO = 4
         IF (INFO.NE.0) GO TO 980
C                                       Rescale if necessary.
         IF (MODE.NE.2) THEN
            DO 220 J = 1,N
               DIAG(J) = MAX (DIAG(J), WA2(J))
 220           CONTINUE
            END IF
C                                       Beginning of the inner loop.
 240     CONTINUE
C                                       Determine the Levenberg-
C                                       Marquardt parameter.
            CALL LMPAR (N, FJAC, LDFJAC, IPVT, DIAG, QTF, DELTA, PAR,
     *         WA1, WA2, WA3, WA4)
C                                       Store the direction P and
C                                       X + P. Calculate the norm of P.
            DO 250 J = 1,N
               WA1(J) = -WA1(J)
               WA2(J) = X(J) + WA1(J)
               WA3(J) = DIAG(J)*WA1(J)
 250           CONTINUE
            PNORM = ENORM(N,WA3)
C                                       On the first iteration, adjust
C                                       the initial step bound.
            IF (ITER.EQ.1) DELTA = MIN (DELTA, PNORM)
C                                       Evaluate the function at X + P
C                                       and calculate its norm.
            IFLAG = 1
            CALL FCN (M, N, WA2, WA4, WA3, IFLAG)
            NFEV = NFEV + 1
            IF (IFLAG.LT.0) GO TO 980
            FNORM1 = ENORM (M, WA4)
C                                       Compute the scaled actual
C                                       reduction.
            ACTRED = -ONE
            IF (P1*FNORM1.LT.FNORM) ACTRED = ONE - (FNORM1/FNORM)**2
C                                       Compute the scaled predicted
C                                       reduction and the scaled
C                                       directional derivative.
            DO 270 J = 1,N
               WA3(J) = ZERO
               L = IPVT(J)
               TEMP = WA1(L)
               DO 260 I = 1,J
                  WA3(I) = WA3(I) + FJAC(I,J) * TEMP
 260              CONTINUE
 270           CONTINUE
            TEMP1 = ENORM (N, WA3) / FNORM
            TEMP2 = (SQRT(PAR) * PNORM) / FNORM
            PRERED = TEMP1**2 + TEMP2**2 / P5
            DIRDER = -(TEMP1**2 + TEMP2**2)
C                                       Compute the ratio of the actual
C                                       to the predicted reduction.
            RATIO = ZERO
            IF (PRERED.NE.ZERO) RATIO = ACTRED / PRERED
C                                       Update the step bound.
            IF (RATIO.LE.P25) THEN
               IF (ACTRED.GE.ZERO) TEMP = P5
               IF (ACTRED.LT.ZERO)
     *            TEMP = P5 * DIRDER / (DIRDER + P5*ACTRED)
               IF ((P1*FNORM1.GE.FNORM) .OR. (TEMP.LT.P1)) TEMP = P1
               DELTA = TEMP * MIN (DELTA, PNORM/P1)
               PAR = PAR / TEMP
            ELSE
               IF ((PAR.EQ.ZERO) .OR. (RATIO.GE.P75)) THEN
                  DELTA = PNORM / P5
                  PAR = P5 * PAR
                  END IF
               END IF
C                                       Test for successful iteration.
            IF (RATIO.GE.P0001) THEN
C                                       Successful iteration. update X,
C                                       FVEC, and their norms.
               DO 310 J = 1,N
                  X(J) = WA2(J)
                  WA2(J) = DIAG(J) * X(J)
 310              CONTINUE
               DO 320 I = 1,M
                  FVEC(I) = WA4(I)
 320              CONTINUE
               XNORM = ENORM (N, WA2)
               FNORM = FNORM1
               ITER = ITER + 1
               END IF
C                                       Tests for convergence.
            IF ((ABS(ACTRED).LE.FTOL) .AND. (PRERED.LE.FTOL) .AND.
     *         (P5*RATIO.LE.ONE)) INFO = 1
            IF (DELTA.LE.XTOL*XNORM) INFO = 2
            IF ((ABS(ACTRED).LE.FTOL) .AND. (PRERED.LE.FTOL) .AND.
     *         (P5*RATIO.LE.ONE) .AND. (INFO.EQ.2)) INFO = 3
            IF (INFO.NE.0) GO TO 980
C                                       Tests for termination and
C                                       stringent tolerances.
            IF (NFEV.GE.MAXFEV) INFO = 5
            IF ((ABS(ACTRED).LE.EPSMCH) .AND. (PRERED.LE.EPSMCH)
     *         .AND. (P5*RATIO.LE.ONE)) INFO = 6
            IF (DELTA.LE.EPSMCH*XNORM) INFO = 7
            IF (GNORM.LE.EPSMCH) INFO = 8
            IF (INFO.NE.0) GO TO 980
C                                       End of the inner loop.  Repeat
C                                       if iteration unsuccessful.
            IF (RATIO.LT.P0001) GO TO 240
C                                       End of the outer loop.
         GO TO 30
C                                       Termination, either normal or
C                                       user imposed.
 980  IF (IFLAG.LT.0) INFO = IFLAG
      IFLAG = 0
      IF (NPRINT.GT.0) CALL FCN (M, N, X, FVEC, WA3, IFLAG)
C
 999  RETURN
      END

      SUBROUTINE YCOVER (OVER, BUF, IERR)
C-----------------------------------------------------------------------
C! checks for overlapped images on the TV by quadrant
C# Y0 TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;  Eric W. Greisen
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   YCOVER checks to see if there are partially replaced images in any
C   of the TV planes currently visible by quadrant
C   Outputs:
C      OVER   L(4)     T => there are in quadr. I
C      BUF    I(512)   scratch
C      IERR   I        Error code: 0 => ok, other catlg IO error
C   XAS (SSS) Y routine: for image catalog in XAS or disk
C-----------------------------------------------------------------------
      LOGICAL   OVER(4)
      INTEGER   BUF(512), IERR
C
      LOGICAL   L1, L2, L3, L4
      INTEGER   ILUN, IIND, IP, IQ, II, JJ, I, J, LL, I2TMP1, QBLC(4,2),
     *   QTRC(4,2), NR, NR0, ZAND, DAT(4), OPCODE, NWSD
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA ILUN /20/
C-----------------------------------------------------------------------
C                                       on disk
      IF (TVIMGC.LE.0) THEN
         CALL ICOPEN (1, ILUN, IIND, IERR)
         IF (IERR.NE.0) GO TO 999
         LL = (NIMAGE - 1) / 51
         QBLC(1,1) = TVSPLT(1)
         QTRC(1,1) = MAXXTV(1)
         QBLC(1,2) = TVSPLT(2)
         QTRC(1,2) = MAXXTV(2)
         QBLC(2,1) = 1
         QTRC(2,1) = TVSPLT(1)
         QBLC(2,2) = TVSPLT(2)
         QTRC(2,2) = MAXXTV(2)
         QBLC(3,1) = 1
         QTRC(3,1) = TVSPLT(1)
         QBLC(3,2) = 1
         QTRC(3,2) = TVSPLT(2)
         QBLC(4,1) = TVSPLT(1)
         QTRC(4,1) = MAXXTV(1)
         QBLC(4,2) = 1
         QTRC(4,2) = TVSPLT(2)
C                                       Loop over quadrants
         DO 50 IQ = 1,4
            OVER(IQ) = .FALSE.
C                                       Loop over visible planes
 10         DO 40 IP = 1,NGRAY
               I2TMP1 = 2 ** (IP-1)
               IF (ZAND (TVLIMG(IQ), I2TMP1).EQ.0) GO TO 40
               NR0 = 1 + (IP-1) * (1 + NIMAGE + LL)
C                                       Loop over occupied slots
               DO 30 I = 1,NIMAGE
                  IF (MOD(I,51).EQ.1) THEN
                     NR = NR0 + (I-1)/51
                     CALL ZFIO ('READ', ILUN, IIND, NR, BUF(1), IERR)
                     IF (IERR.NE.0) GO TO 900
                     END IF
                  II = 5 * MOD (I-1, 51) + 2
                  IF (BUF(II).LE.0) GO TO 30
                  IF (QBLC(IQ,1).GT.BUF(II+3)) GO TO 30
                  IF (QBLC(IQ,2).GT.BUF(II+4)) GO TO 30
                  IF (QTRC(IQ,1).LT.BUF(II+1)) GO TO 30
                  IF (QTRC(IQ,2).LT.BUF(II+2)) GO TO 30
C                                       Loop over more recent ones
                  DO 25 J = 1,NIMAGE
                     IF (MOD(J,51).EQ.1) THEN
                        NR = NR0 + (J-1)/51
                        CALL ZFIO ('READ', ILUN, IIND, NR, BUF(257),
     *                     IERR)
                        IF (IERR.NE.0) GO TO 900
                        END IF
                     JJ = 5 * MOD (J-1, 51) + 258
                     IF (BUF(JJ).LE.BUF(II)) GO TO 25
                     IF (QBLC(IQ,1).GT.BUF(JJ+3)) GO TO 25
                     IF (QBLC(IQ,2).GT.BUF(JJ+4)) GO TO 25
                     IF (QTRC(IQ,1).LT.BUF(JJ+1)) GO TO 25
                     IF (QTRC(IQ,2).LT.BUF(JJ+2)) GO TO 25
                        L1 = (BUF(JJ+1).GE.BUF(II+1)) .AND.
     *                     (BUF(JJ+1).LE.BUF(II+3))
                        L2 = (BUF(JJ+3).GE.BUF(II+1)) .AND.
     *                     (BUF(JJ+3).LE.BUF(II+3))
                        L3 = (BUF(JJ+2).GE.BUF(II+2)) .AND.
     *                     (BUF(JJ+2).LE.BUF(II+4))
                        L4 = (BUF(JJ+4).GE.BUF(II+2)) .AND.
     *                     (BUF(JJ+4).LE.BUF(II+4))
                        OVER(IQ) = (L1 .AND. L3) .OR. (L2 .AND. L4)
     *                     .OR. (L1 .AND. L4) .OR. (L2 .AND. L3)
                        IF (OVER(IQ)) GO TO 50
 25                  CONTINUE
 30               CONTINUE
 40            CONTINUE
 50         CONTINUE
         GO TO 900
C                                       in XAS
      ELSE
         CALL FILL (4, 0, DAT)
         OPCODE = 34
         CALL ZSSSXF (OPCODE, DAT, 0, BUF, NWSD, IERR)
         IF (IERR.EQ.0) THEN
            CALL ZI8IL (4, 1, BUF, BUF)
            DO 60 IQ = 1,4
               OVER(IQ) = BUF(IQ).GT.0
 60            CONTINUE
         ELSE
            IERR = 2
            WRITE (MSGTXT,1200) IERR
            CALL MSGWRT (6)
            END IF
         GO TO 999
         END IF
C                                       Close cat
 900  CALL ZCLOSE (ILUN, IIND, IQ)
C
 999  RETURN
C-----------------------------------------------------------------------
 1200 FORMAT ('YCOVER: XAS IMAGE CATALOG RETURNS ERROR',I5)
      END

      PROGRAM SETTVP
C-----------------------------------------------------------------------
C! stand-alone program to initialize the TV display parameter file
C# Service
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SETTVP conducts a dialogue with the user to initialize and alter
C   The AIPS Television display parameter disk files
C-----------------------------------------------------------------------
      CHARACTER PHNAME*48, MSGBUF*80, PRGNAM*6
      INTEGER   TTYLUN, TTYIND, JOPT, IOPT, IOBLK(256), LTVDEV, I, IERR,
     *   LUN, IND, SCRTCH(256), PASPER, PASCHG, ADDR, GOADDR, NWORDS,
     *   IREC, IDUM(10), TVPRM(29)
      LOGICAL   T, F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      EQUIVALENCE (TVPRM(1), NGRAY)
      COMMON /TTYCOM/ TTYLUN, TTYIND
      DATA PRGNAM /'SETTVP'/
      DATA LUN /8/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       AIPS initialization
      TTYLUN = 5
      CALL AIPINI (TTYLUN, PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 980
      PASPER = 0
      LTVDEV = NTVDEV
C                                       Read TV #, option number
 50   PASCHG = 0
      WRITE (MSGBUF,1050)
      CALL INQINT (TTYLUN, MSGBUF, 2, IOBLK, IERR)
      IF (IERR.LT.0) GO TO 50
      IF (IERR.GT.0) GO TO 980
      IOPT = IOBLK(1)
      I = IOBLK(2)
      IF ((I.GT.0) .AND. (I.LE.LTVDEV)) NTVDEV = I
      IF (IOPT.EQ.5) GO TO 995
      IF ((IOPT.GE.1) .OR. (IOPT.LE.4)) GO TO 100
C                                       Error from somewhere
 60      WRITE (MSGTXT,1060)
         CALL MSGWRT (7)
         GO TO 50
C                                       Read TV disk current parms
 100  CALL ZPHFIL ('ID', 1, 0, NTVDEV, PHNAME, IERR)
      CALL ZOPEN (LUN, IND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) GO TO 60
      CALL ZFIO ('READ', LUN, IND, 1, IOBLK, IERR)
      IF (IERR.EQ.0) GO TO 110
         CALL ZCLOSE (LUN, IND, IERR)
         GO TO 60
C                                       Initialize from YTVCIN
 110  IF (IOPT.GT.1) THEN
         CALL COPY (29, IOBLK, TVPRM)
      ELSE
         CALL YTVCIN
         CALL COPY (29, TVPRM, IOBLK)
         PASCHG = 1
         END IF
C                                       ISU
      IF (IOPT.NE.4) GO TO 150
         IF (ISUNUM.GT.0) GO TO 125
            WRITE (MSGTXT,1120)
            CALL MSGWRT (7)
            GO TO 180
C                                       Require password
 125     IF (PASPER.GT.0) GO TO 130
            CALL PASWRD (SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 995
            PASPER = 1
 130     WRITE (MSGBUF,1130)
         CALL INQINT (TTYLUN, MSGBUF, 3, IOBLK, IERR)
         IF (IERR.LT.0) GO TO 130
         IF (IERR.GT.0) GO TO 980
         ADDR = IOBLK(1)
         NWORDS = IOBLK(2)
         GOADDR = IOBLK(3)
         CALL FILL (256, 0, SCRTCH)
         SCRTCH(1) = ADDR
         SCRTCH(2) = NWORDS
         SCRTCH(3) = GOADDR
         IREC = 2
         CALL ZFIO ('WRIT', LUN, IND, IREC, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 180
         TVLUN2 = LUN
         TVIND2 = IND
         CALL ZCLOSE (LUN, IND, IERR)
         CALL TVOPEN (SCRTCH, IERR)
         CALL YISLOD ('READ', SCRTCH, IERR)
         CALL TVCLOS (SCRTCH, IERR)
         GO TO 50
C                                       Change values: list first
 150  CONTINUE
         CALL KUESTV (IOPT, 0, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Enter option
 155     WRITE (MSGBUF,1155)
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         JOPT = IDUM(1)
         IF (IERR.LT.0) GO TO 155
         IF (IERR.GT.0) GO TO 980
         IF (JOPT.LT.0) GO TO 160
            CALL KUESTV (IOPT, JOPT, IERR)
            IF (IERR.NE.0) GO TO 980
            IF (JOPT.GT.0) THEN
               PASCHG = 1
               CALL COPY (29, TVPRM, IOBLK)
               END IF
            GO TO 155
C                                       Write file and close
 160  IF (PASCHG.LE.0) GO TO 180
C                                       Require password
         IF (PASPER.GT.0) GO TO 170
            CALL PASWRD (SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 995
            PASPER = 1
C                                       do write
 170     CALL ZFIO ('WRIT', LUN, IND, 1, IOBLK, IERR)
 180  CALL ZCLOSE (LUN, IND, IERR)
      GO TO 50
C                                       Terminal IO error
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (8)
C                                       Close accounting
 995  CALL ACOUNT (2)
C
 999  STOP
C-----------------------------------------------------------------------
 1050 FORMAT ('Enter 1=Init, 2/3=Change parms, 4=ISU, 5=quit and the',
     *   ' TV # (2I2)')
 1060 FORMAT ('SOME ERROR: TRY AGAIN')
 1120 FORMAT ('THERE ARE NO ISU UNITS ON THIS TV')
 1130 FORMAT ('Enter: start ADDR, NWORDS, GOADDR (3I6)')
 1155 FORMAT ('Enter number to change, 0=print, -1=return (I2)')
 1980 FORMAT ('ERROR',I7,' IN TERMINAL IO')
      END
      SUBROUTINE KUESTV (IOPT, JOPT, IERR)
C-----------------------------------------------------------------------
C   KUESTV displays the TV parameters and reads a specified value
C   Inputs:
C      IOPT   I   2 do principal, 3 do all
C      JOPT   I   Which option, 0 => print all, read none
C   Output:
C      IERR   I   Error code from terminal IO
C   Common in/out:
C      /TVCHAR/ TV parms (29 words available)
C-----------------------------------------------------------------------
      INTEGER   IOPT, JOPT, IERR
C
      CHARACTER MSGBUF*80
      INTEGER   TTYLUN, TTYIND, K, KK(2), IDUM(2)
      DOUBLE PRECISION DTEMP
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      COMMON /TTYCOM/ TTYLUN, TTYIND
C-----------------------------------------------------------------------
 10   IERR = 0
C                                       Branch to requested function
      IF (JOPT.EQ.0) GO TO 100
      IF (JOPT.LT.0) GO TO 90
      IF ((IOPT.NE.3) .AND. (JOPT.GT.13)) GO TO 90
      IF ((IOPT.EQ.3) .AND. (JOPT.GT.17)) GO TO 90
      GO TO (100, 110, 120, 130, 140, 150, 160, 170, 180, 190, 200,
     *   210, 220, 230, 240, 250, 260), JOPT
C                                       Error
 90   CONTINUE
         WRITE (MSGTXT,1090)
         CALL MSGWRT (6)
         GO TO 999
C                                       # gray planes
 100  WRITE (MSGBUF,1100) NGRAY
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (K.LE.0) GO TO 10
            NGRAY = K
            END IF
         GO TO 999
         END IF
C                                       # graphics overlay planes
 110  WRITE (MSGBUF,1110) NGRAPH
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (K.LE.0) GO TO 10
            NGRAPH = K
            END IF
         GO TO 999
         END IF
C                                       # images / plane
 120  WRITE (MSGBUF,1120) NIMAGE
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (K.LE.0) GO TO 10
            NIMAGE = K
            END IF
         GO TO 999
         END IF
C                                       Pixel size of TV, x,y
 130  WRITE (MSGBUF,1130) MAXXTV
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 2, KK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (KK(1).LE.0) GO TO 10
            IF (KK(2).LE.0) GO TO 10
            MAXXTV(1) = KK(1)
            MAXXTV(2) = KK(2)
            END IF
         GO TO 999
         END IF
C                                       Max TV intensity
 140  WRITE (MSGBUF,1140) MAXINT
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (K.LE.0) GO TO 10
            MAXINT = K
            END IF
         GO TO 999
         END IF
C                                       LUT output intensity
 150  WRITE (MSGBUF,1150) LUTOUT
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (K.LE.0) GO TO 10
            LUTOUT = K
            END IF
         GO TO 999
         END IF
C                                       OFM intensities
 160  WRITE (MSGBUF,1160) OFMINP, OFMOUT
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 2, KK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (KK(1).LE.0) GO TO 10
            IF (KK(2).LE.0) GO TO 10
            OFMINP = KK(1)
            OFMOUT = KK(2)
            END IF
         GO TO 999
         END IF
C                                       Scroll increments
 170  WRITE (MSGBUF,1170) SCXINC, SCYINC
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 2, KK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (KK(1).LE.0) GO TO 10
            IF (KK(2).LE.0) GO TO 10
            SCXINC = KK(1)
            SCYINC = KK(2)
            END IF
         GO TO 999
         END IF
C                                       Max zoom: power of 2, linear
 180  WRITE (MSGBUF,1180) MXZOOM
      CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (MSGBUF,1181)
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            MXZOOM = K
            END IF
         GO TO 999
         END IF
C                                       Type of splitting
 190  WRITE (MSGBUF,1190) TYPSPL
      CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (MSGBUF,1191)
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (K.LT.0) GO TO 10
            TYPSPL = K
            END IF
         GO TO 999
         END IF
C                                       TV character size: x,y
 200  WRITE (MSGBUF,1200) CSIZTV
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 2, KK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (KK(1).LE.0) GO TO 10
            IF (KK(2).LE.0) GO TO 10
            CSIZTV(1) = KK(1)
            CSIZTV(2) = KK(2)
            END IF
         GO TO 999
         END IF
C                                       TV x image write mode
C                                       0 no, 1 to right, 2 to left
 210  WRITE (MSGBUF,1210) TVXMOD
      CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (MSGBUF,1211)
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (K.LT.0) GO TO 10
            TVXMOD = K
            END IF
         GO TO 999
         END IF
C                                       TV y image write mode
C                                       0 no, 1 up, 2 down
 220  WRITE (MSGBUF,1220) TVYMOD
      CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (MSGBUF,1221)
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (K.LT.0) GO TO 10
            TVYMOD = K
            END IF
         GO TO 999
         END IF
C                                       More detailed ones
 230  IF (IOPT.NE.3) GO TO 999
C                                       Number of ALU subunits
      WRITE (MSGBUF,1230) TVALUS
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (K.LT.0) GO TO 10
            TVALUS = K
            END IF
         GO TO 999
         END IF
C                                       Number ISU units
 240  WRITE (MSGBUF,1240) ISUNUM
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (K.LT.0) GO TO 10
            ISUNUM = K
            END IF
         GO TO 999
         END IF
C                                       Gamma correction
 250  WRITE (MSGBUF,1250) TVGAMA
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQFLT (TTYLUN, MSGBUF, 1, DTEMP, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (DTEMP.LE.0.001) GO TO 10
            TVGAMA = DTEMP
            END IF
         GO TO 999
         END IF
C                                       Number channels / color
 260  WRITE (MSGBUF,1260) TVIMPC
      CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (MSGBUF,1261)
      IF (JOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.0) .OR. (K.GT.16)) GO TO 10
            TVIMPC = K
            END IF
         GO TO 999
         END IF
C                                       Maybe more later
 270  CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1090 FORMAT ('INVALID OPTION NUMBER')
 1100 FORMAT ('1  No. of gray-scale planes         (I)',I6)
 1110 FORMAT ('2  No. of graphics overlay planes   (I)',I6)
 1120 FORMAT ('3  No. of images / gray-plane       (I)',I6)
 1130 FORMAT ('4  X,Y size of TV planes (pixels) (2 I)',2I6)
 1140 FORMAT ('5  Maximum gray-scale intensity     (I)',I6)
 1150 FORMAT ('6  Peak intensity out of LUT        (I)',I6)
 1160 FORMAT ('7  Peak intensities in/out of OFM (2 I)',2I6)
 1170 FORMAT ('8  X,Y min. scroll increments     (2 I)',2I6)
 1180 FORMAT ('9  Maximum zoom: (>0) power of 2    (I)',I6)
 1181 FORMAT ('      (< 0) Max factor = 1 - MAXINT')
 1190 FORMAT ('10 Type of split-screen allowed     (I)',I6)
 1191 FORMAT ('      1=Vert, 2=Hori, 3=Either, 4=Both')
 1200 FORMAT ('11 # X,Y pixels in TV characters  (2 I)',2I6)
 1210 FORMAT ('12 X-axis image write mode(s)       (I)',I6)
 1211 FORMAT ('      0 - None, 1 -> Right, 2 -> Left')
 1220 FORMAT ('13 Y-axis image write mode(s)       (I)',I6)
 1221 FORMAT ('      0 - None, 1 -> Up, 2 -> Down')
 1230 FORMAT ('14 Number of ALU units in TV        (I)',I6)
 1240 FORMAT ('15 Number of image storage units    (I)',I6)
 1250 FORMAT ('16 Gamma correction for OFM         (R)',F8.3)
 1260 FORMAT ('17 No. simultaneous channels/color  (I)',I6)
 1261 FORMAT ('      0 -> one channel for all colors  ')
      END

LOCAL INCLUDE 'PRTAN.INC'
      HOLLERITH XNAME(3), XCLASS(2), XLPNAM(12), XFUNC(1)
      REAL      XSEQ, XDISK, XVER, XNIT, DOCRT, DOBTW, DOPLOT, XDOTV,
     *   XGRCH, XSYM, FACTOR, PIXR(2), XYRATO
      COMMON /INPARM/ XNAME, XCLASS, XSEQ, XDISK, XVER, XNIT, DOCRT,
     *   XLPNAM, DOBTW, DOPLOT, XFUNC, XDOTV, XGRCH, XSYM, FACTOR,
     *   PIXR, XYRATO
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   SEQ, DISK, VER, CNO, NPARM
      CHARACTER NAME*12, CLASS*6, FUNTYP*2
      COMMON /PRTANC/ NAME, CLASS, FUNTYP
      COMMON /PRTANI/ SEQ, DISK, VER, CNO, NPARM
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
LOCAL END
LOCAL INCLUDE 'PRTAND.INC'
      DOUBLE PRECISION ANTX(MAXANT), ANTY(MAXANT), ANTZ(MAXANT), DX, DY,
     *   XS, YS, ZS, ARRLON, SINA, COSA, ANTREL(3,MAXANT), DT, DR
      COMMON /PRTAND/ ANTX, ANTY, ANTZ, DX, DY, XS, YS, ZS, ARRLON,
     *   SINA, COSA, ANTREL, DT, DR
LOCAL END
      PROGRAM PRTAN
C-----------------------------------------------------------------------
C! Prints contents of ANtenna file
C# Calibration Utility VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 1999, 2001, 2004-2010, 2012, 2019-2020,
C;  Copyright (C) 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PRTAN prints the contents of an antenna 'AN' file on the line
C   printer.
C   Inputs:
C      AIPS ADVERB    PRGM NAME            Description.
C      USERID           ID          User id number for desired file.
C      INNAME           NAME        Name of desired uv data file.
C      INCLASS          CLASS       Class of desired uv data file.
C      INSEQ            SEQ         Seq. no. of desired file.
C      INDISK           DISK        Disk number of desired file.
C      INVER            VER         Version number of ext. file
C                                   0 => most recent
C      NCOUNT           NITER       Number of records to print, 0=>all.
C      DOCRT            DOCRT       > 0 => use CRT terminal, else print
C      OUTPRINT         LPNAME      File to save printer output in
C-----------------------------------------------------------------------
      INCLUDE 'PRTAN.INC'
      INCLUDE 'PRTAND.INC'
      INCLUDE 'INCS:DANT.INC'
      CHARACTER PRGM*6, TITL1*132, TITL2*132, UTYPE*2, LINE*132,
     *   SCRTCH*132, ATIME*8, ADATE*12, MOUNT(9)*4, SPTYPE*8,
     *   LPNAME*48, TYPOLA*2, TYPOLB*2, ANAMES(MAXANT)*8, STAT*4
      INTEGER   LUN, FIND, LUNA, IERR, DATE(3), IT(3), LUNP, FINDP, I,
     *   NITER, LINES, IRET, MANT, ID, NREC, LREC, IPAGE, IANT,
     *   NACROS, ILINE, LLINE, NANT, J, LOCS, KEYTYP, NUMIF, IPNT,
     *   IROUND, I4TEMP, BUFFER(256), J1, J2, VALUES(2), TYPMNT, NUMVLA,
     *   IABUF(512), IPDREF, BUFF2(1256), LUN2, JTRIM, NANTS
      LOGICAL   RQUICK, T, F, LTYPE(9), ISAPPR, ISORI, ISXY, ALLSAM
      REAL      AMP1, AMP2, PH1, PH2, TYPAXO, TYPLAA, TYPLAB, PP1, PP2,
     *   PP3, PP4, PD(100), PDD, ANDIAM, ANFWHM(MAXIF)
      HOLLERITH HVALUS(2)
      EQUIVALENCE (VALUES, HVALUS)
      INCLUDE 'INCS:PSTD.INC'
      DATA PRGM /'PRTAN '/
      DATA LUN, LUNA, LUN2 /16,31,30/
      DATA T, F /.TRUE.,.FALSE./
      DATA MOUNT /'ALAZ', 'EQUA','ORBI','EW--','NS-R','NS-L','BW-R',
     *  'BW-L','    '/
C-----------------------------------------------------------------------
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      DO 10 I = 1,MAXANT
         ANAMES(I) = ' '
         ANTX(I) = 0.0D0
         ANTY(I) = 0.0D0
         ANTZ(I) = 0.0D0
         ANTREL(1,I) = 0.0D0
         ANTREL(2,I) = 0.0D0
         ANTREL(3,I) = 0.0D0
 10      CONTINUE
C                                        Get parms.
      NPARM = 32
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAME, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         IRET = 8
         RQUICK = F
         GO TO 990
         END IF
      IRET = 0
      IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) DOCRT = MIN (-1.0,
     *   DOCRT)
      IF (DOCRT.GT.0.0) RQUICK = F
C                                        Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFFER, IERR)
      IRET = 8
C                                        Crunch parameters.
      ISAPPR = F
      ISORI = F
      ISXY = F
      ID = NLUSER
      SEQ = IROUND (XSEQ)
      DISK = IROUND (XDISK)
      VER = IROUND (XVER)
      NITER = IROUND (XNIT)
      CALL H2CHR (48, 1, XLPNAM, LPNAME)
C                                        Open/find uv data file.
      CALL H2CHR (12, 1, XNAME, NAME)
      CALL H2CHR (6, 1, XCLASS, CLASS)
      CALL H2CHR (2, 1, XFUNC, FUNTYP)
      IF (FUNTYP.NE.'LG') FUNTYP = 'LI'
      CALL CHR2H (2, FUNTYP, 1, XFUNC)
      UTYPE = 'UV'
      STAT = 'READ'
      IF ((DOPLOT.GT.0.0) .AND. (XDOTV.LE.0.0)) STAT = 'WRIT'
      CALL MAPOPN (STAT, DISK, NAME, CLASS, SEQ, UTYPE, ID, LUN,
     *   FIND, CNO, CATBLK, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, NAME, CLASS, SEQ, 'UV', DISK, ID
         CALL MSGWRT (8)
         GO TO 990
         END IF
      NREC = 1
      LREC = 1
C                                        Init AN file.
      CALL ANTINI ('READ', IABUF, DISK, CNO, VER, CATBLK, LUNA, IANRNO,
     *   ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE, POLRXY,
     *   UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB, NOPCAL,
     *   ANTNIF, ANFQID, IERR)
      IF (IERR.NE.0) GO TO 980
C      IF ((ABS(ARRAYC(1)).GT.1.D0) .OR. (ABS(ARRAYC(2)).GT.1.D0) .OR.
C     *   (ABS(ARRAYC(3)).GT.1.D0)) DOBTW = -1.0
C                                       Find polarization solution type
      MSGSUP = 32000
      CALL TABKEY ('READ', 'POLTYPE ', 1, IABUF, LOCS, VALUES, KEYTYP,
     *   IERR)
      MSGSUP = 0
      SPTYPE = ' '
      IF ((IERR.EQ.0) .AND. (KEYTYP.EQ.3)) CALL H2CHR (8, 1, HVALUS,
     *   SPTYPE)
      ISAPPR = (SPTYPE.EQ.'APPROX') .OR. (SPTYPE.EQ.'VLBI')
      ISORI = SPTYPE.EQ.'ORI-ELP '
      ISXY = SPTYPE.EQ.'X-Y LIN '
      NUMIF = ANTNIF
C                                        Open line printer.
      IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
      CALL LPOPEN (LPNAME, DOCRT, LUNP, FINDP, NACROS, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL ZTIME (IT)
C                                        Prepare titles
      IPAGE = 0
      LINES = 900
      WRITE (TITL1,1020) NAME, CLASS, SEQ, VER, DISK, ID
      CALL DATEST (RDATE, DATE)
      CALL TIMDAT (IT, DATE, ATIME, ADATE)
      SAFREQ = SAFREQ * 1.0D-6
      WRITE (TITL2,1022) ANAME, SAFREQ, ADATE
C                                       Begin header info
      IF (DOCRT.LE.-2.5) THEN
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, TITL1,
     *      LINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
      ELSE
         LINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      LINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1030)
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      LINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1031) ARRAYC
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      LINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1032) POLRXY
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      LINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1033) DEGPDY
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      LINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1034) GSTIA0
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      LINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1035) UT1UTC, TIMSYS, DATUTC
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      LINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         LINE = 'XYZHAND = ''' // XYZHAN // '''    TFRAME = ''' //
     *      TFRAME // ''''
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      LINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       Polarization solution type.
         IF ((ISAPPR) .OR. (ISXY)) THEN
            WRITE (LINE,1036)
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         LINES, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         IF (ISORI) THEN
C                                       Print R-L phase offsets
            CALL PDRGET (DISK, CNO, VER, LUN2, CATBLK, NUMIF, IPDREF,
     *         PD, BUFF2, IERR)
            IF (IERR.EQ.0) THEN
               WRITE (LINE,2036) IPDREF
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            LINE, LINES, IPAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 900
               DO 35 I =1,NUMIF
                  PDD = PD(I) * 57.29577951
                  WRITE (LINE,1037) I, PDD
                  CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *               LINE, LINES, IPAGE, SCRTCH, IERR)
                  IF (IERR.NE.0) GO TO 900
 35               CONTINUE
               END IF
            END IF
         IF (ANFQID.EQ.-1) THEN
            WRITE (LINE,1038)
         ELSE IF (ANFQID.GT.0) THEN
            WRITE (LINE,1039) ANFQID
            END IF
         IF (ANFQID.GE.-1) THEN
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         LINES, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         END IF
C                                       What to display
      I4TEMP = IABUF(5)
      NANT = I4TEMP
      IF (NITER.GT.0) NANT = MIN (NANT, NITER)
      IF (NANT.LE.0) GO TO 900
      MANT = 0
C                                       do not display blank MOUNT type
      LTYPE(1) = F
      LTYPE(2) = F
      LTYPE(3) = F
      LTYPE(4) = F
      LTYPE(5) = F
      LTYPE(6) = F
      LTYPE(7) = F
      LTYPE(8) = F
      LTYPE(9) = F
      TYPMNT = -1000
      ALLSAM = .TRUE.
      NANTS = 0
      XS = 0.0D0
      YS = 0.0D0
      ZS = 0.0D0
C                                       read thru all data before print
      DO 40 IANT = 1,NANT
         IANRNO = IANT
         CALL TABAN ('READ', IABUF, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.GT.0) GO TO 960
         IF (IERR.EQ.0) THEN
            MANT = MAX (MANT, NOSTA)
            IF (MOUNT(MNTSTA+1).NE.' ') LTYPE(1) = T
            IF (STAXOF.NE.0.0) LTYPE(1) = T
            IF ((POLAA.NE.0.0) .OR. (POLAB.NE.0.0)) LTYPE(4) = T
            IF ((POLCA(1).NE.0.0) .OR. (POLCB(1).NE.0.0)) LTYPE(5) = T
            IF ((POLCA(2).NE.0.0) .OR. (POLCB(2).NE.0.0)) LTYPE(5) = T
            IF ((POLCA(3).NE.0.0) .OR. (POLCB(3).NE.0.0)) LTYPE(5) = T
C                                       Keep track of MOUNT and Pol
C                                       On first pass record values
            IF (TYPMNT.LT.-1) THEN
               TYPMNT = MNTSTA
               TYPAXO = STAXOF
               TYPOLA = POLTYA
               TYPOLB = POLTYB
               TYPLAA = POLAA
               TYPLAB = POLAB
               ANDIAM = DIAMAN
               CALL RCOPY (ANTNIF, FWHMAN, ANFWHM)
C                                       else check if value is different
            ELSE
               IF ((TYPMNT.NE.MNTSTA) .OR. (TYPAXO.NE.STAXOF) .OR.
     *            (TYPOLA.NE.POLTYA) .OR. (TYPOLB.NE.POLTYB) .OR.
     *            (TYPLAA.NE.POLAA)  .OR. (TYPLAB.NE.POLAB) .OR.
     *            (ANDIAM.NE.DIAMAN)) ALLSAM = .FALSE.
               IF (ANDIAM.NE.0.0) LTYPE(6) = T
               IF (DIAMAN.NE.0.0) LTYPE(6) = T
               DO 37 J = 1,ANTNIF
                  IF (ANFWHM(J).NE.FWHMAN(J)) ALLSAM = .FALSE.
                  IF (ANFWHM(J).NE.0.0) LTYPE(7) = T
                  IF (FWHMAN(J).NE.0.0) LTYPE(7) = T
 37            CONTINUE
               END IF
C                                       Store antenna names
            IF (NOSTA.LE.MAXANT) THEN
               ANAMES(NOSTA)(1:8) = ANNAME(1:8)
C                                       casa naming convention
               IF ((ANAME.EQ.'EVLA') .AND. (ANNAME(4:).EQ.' ') .AND.
     *            ((ANNAME(:1).EQ.'E') .OR. (ANNAME(:1).EQ.'W') .OR.
     *            (ANNAME(:1).EQ.'N')))
     *            ANAMES(NOSTA) = 'EVLA:' // ANNAME(1:3)
C                                       old VLA convention
               IF ((ANNAME(1:3).EQ.'VLA') .OR. (ANNAME(1:4).EQ.'EVLA'))
     *            THEN
                  IF ((ANNAME(1:5).EQ.'VLA: ') .OR.
     *               (ANNAME(1:5).EQ.'VLA:_') .OR.
     *               (ANNAME(1:5).EQ.'EVLA:')) THEN
                     IF (ANNAME(8:8).EQ.' ')
     *                  ANAMES(NOSTA)(7:8) = '0' // ANNAME(7:7)
                  ELSE IF ((ANNAME(1:4).EQ.'VLA:') .OR.
     *               (ANNAME(1:4).EQ.'EVLA')) THEN
                     IF (ANNAME(7:8).EQ.' ')
     *                  ANAMES(NOSTA)(6:8) = '0' // ANNAME(6:6)
                     END IF
                  END IF
               ANTX(NOSTA) = STAXYZ(1)
               ANTY(NOSTA) = STAXYZ(2)
               ANTZ(NOSTA) = STAXYZ(3)
               J = INDEX (ANAMES(NOSTA), 'OUT')
               IF ((J.EQ.0) .AND. ((STAXYZ(1).NE.0.0D0) .OR.
     *            (STAXYZ(2).NE.0.0D0))) THEN
                  XS = XS + STAXYZ(1)
                  YS = YS + STAXYZ(2)
                  ZS = ZS + STAXYZ(3)
                  NANTS = NANTS + 1
                  END IF
               END IF
            END IF
C                                       For all antennas loop
 40      CONTINUE
      ILINE = 3
C                                       if values all the same, list once
      IF ((ALLSAM) .AND. (DOCRT.GT.-2.5)) THEN
         WRITE (LINE,1041) MOUNT(MNTSTA+1), STAXOF
C                                       if mount value not blank
         IF (LTYPE(1)) CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *      TITL2, LINE, LINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1042) POLTYA, POLTYB
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      LINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1043) POLAA, POLAB
         IF (LTYPE(4)) CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *      TITL2, LINE, LINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1045) ANDIAM
         IF (LTYPE(6)) CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *      TITL2, LINE, LINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         IF (LTYPE(7)) THEN
            J1 = 1
 41         J2 = MIN (ANTNIF, J1+5)
            WRITE (LINE,1046) (ANFWHM(J), J = J1,J2)
            IF (J2.EQ.ANTNIF) THEN
               J = JTRIM (LINE)
               LINE(J+2:) = 'degrees'
               END IF
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         LINES, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            J1 = J2 + 1
            IF (J1.LE.ANTNIF) GO TO 41
            END IF
C                                       value not all same
C                                       count lines per antenna
      ELSE IF (.NOT.ALLSAM) THEN
         IF (LTYPE(1)) ILINE = ILINE + 1
         IF (LTYPE(4)) ILINE = ILINE + 1
         IF (LTYPE(5)) ILINE = ILINE + 4
         IF (LTYPE(6)) ILINE = ILINE + 1
         IF (LTYPE(7)) ILINE = ILINE + (ANTNIF-1) / 6 + 1
         END IF
C                                        Loop thru file.
      DO 200 IANT = 1,NANT
         IANRNO = IANT
         CALL TABAN ('READ', IABUF, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.GT.0) GO TO 960
         IF (IERR.LT.0) GO TO 200
C                                       Add space if not all same
         IF (((.NOT.ALLSAM) .OR. (IANT.EQ.1)) .AND. (DOCRT.GT.-2.5))
     *      THEN
C                                       Page if not hold next
            LLINE = LINES + ILINE + 1
            LINES = LINES + ILINE
            LINE = ' '
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *         TITL2, LINE, LINES, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            IF (LINES.EQ.LLINE) LINES = LINES - ILINE
            END IF
C                                       Write contents of record
         IF (NOSTA.LE.MAXANT) ANNAME = ANAMES(NOSTA)
         WRITE (LINE,1040) NOSTA, ANNAME, STAXYZ
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      LINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       IF mount, axis pol values
C                                       different
         IF (.NOT.ALLSAM) THEN
            WRITE (LINE,1041) MOUNT(MNTSTA+1), STAXOF
C                                       if mount value not blank
            IF (LTYPE(1))
     *         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *         TITL2, LINE, LINES, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            WRITE (LINE,1042) POLTYA, POLTYB
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *         TITL2, LINE, LINES, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            WRITE (LINE,1043) POLAA, POLAB
            IF (LTYPE(4))
     *         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *         TITL2, LINE, LINES, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            WRITE (LINE,1045) DIAMAN
            IF (LTYPE(6)) CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS,
     *         TITL1, TITL2, LINE, LINES, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            IF (LTYPE(7)) THEN
               J1 = 1
 46            J2 = MIN (ANTNIF, J1+5)
               WRITE (LINE,1046) (FWHMAN(J), J = J1,J2)
               IF (J2.EQ.ANTNIF) THEN
                  J = JTRIM (LINE)
                  LINE(J+2:) = 'degrees'
                  END IF
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            LINE, LINES, IPAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 900
               J1 = J2 + 1
               IF (J1.LE.ANTNIF) GO TO 46
               END IF
            END IF
C                                       Polarization feed parameters
         IPNT = 1
         IF (LTYPE(5)) THEN
            IF (ISAPPR.OR.ISXY) THEN
C                                       Linear approximation
               DO 50 I = 1,NUMIF
                  AMP1 = SQRT ((POLCA(IPNT)**2) + (POLCA(IPNT+1)**2))
                  PH1 = ATAN2 (POLCA(IPNT+1), POLCA(IPNT)+1.0E-20) *
     *               57.296
                  AMP2 = SQRT ((POLCB(IPNT)**2) + (POLCB(IPNT+1)**2))
                  PH2 = ATAN2 (POLCB(IPNT+1), POLCB(IPNT)+1.0E-20) *
     *               57.296
                  WRITE (LINE,1048) I, AMP1, PH1, AMP2, PH2
                  IPNT = IPNT + 2
                  CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS,
     *               TITL1, TITL2, LINE, LINES, IPAGE, SCRTCH, IERR)
                  IF (IERR.NE.0) GO TO 900
 50               CONTINUE
               END IF
            IF (ISORI) THEN
C                                       Orientation-ellipticity
               DO 60 I = 1,NUMIF
                  PP1 = 57.296 * POLCA(IPNT)
                  PP2 = 57.296 * POLCA(IPNT+1)
                  PP3 = 57.296 * POLCB(IPNT)
                  PP4 = 57.296 * POLCB(IPNT+1)
                  WRITE (LINE,1049) I, PP1, PP2, PP3, PP4
                  IPNT = IPNT + 2
                  CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS,
     *               TITL1, TITL2, LINE, LINES, IPAGE, SCRTCH, IERR)
                  IF (IERR.NE.0) GO TO 900
 60               CONTINUE
               END IF
            END IF
 200     CONTINUE
C                                       display relative positions?
      IF ((DOBTW.GT.0.0) .OR. (DOPLOT.GT.0.0)) THEN
C                                       from FILLM for EVLA
         IF (ANAME.EQ.'EVLA') THEN
            XS = -1601185.365D0
            YS = -5041977.547D0
            ZS =  3554875.87D0
C                                       surface centric
         ELSE IF ((ARRAYC(1).NE.0.0D0) .AND. (ARRAYC(2).NE.0.0D0)) THEN
            CALL ROTVLA (ANAMES, ARRAYC)
         ELSE IF (NANTS.GT.0) THEN
            XS = XS / NANTS
            YS = YS / NANTS
            ZS = ZS / NANTS
            END IF
         ARRAYC(1) = ARRAYC(1) + XS
         ARRAYC(2) = ARRAYC(2) + YS
         ARRAYC(3) = ARRAYC(3) + ZS
         ARRLON = ATAN2 (ARRAYC(2), ARRAYC(1)) + PI/2.0D0
         COSA = COS (ARRLON)
         SINA = SIN (ARRLON)
         IF (DOBTW.GT.0.0) THEN
            LINE = ' '
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         LINES, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         LINES, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            LINE(10:) = 'Relative antenna positions wrt to new center:'
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         LINES, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            WRITE (LINE,1031) ARRAYC
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         LINES, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            LINE = ' '
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         LINES, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         DO 220 NOSTA = 1,MAXANT
            IF ((ABS(ANTX(NOSTA)).GT.1.D0) .OR.
     *         (ABS(ANTY(NOSTA)).GT.1.D0) .OR.
     *         (ABS(ANTZ(NOSTA)).NE.0.0D0)) THEN
               DR = SQRT (ANTX(NOSTA)**2 + ANTY(NOSTA)**2 +
     *            ANTZ(NOSTA)**2)
               DT = ASIN (ANTZ(NOSTA)/DR)
               DT = COS (DT)
               DX = ANTX(NOSTA) - XS
               DY = ANTY(NOSTA) - YS
               STAXYZ(1) = DX * COSA + DY * SINA
               STAXYZ(2) = DY * COSA - DX * SINA
               STAXYZ(3) = ANTZ(NOSTA) - ZS
               ANTREL(1,NOSTA) = STAXYZ(1)
               ANTREL(2,NOSTA) = STAXYZ(2)
               ANTREL(3,NOSTA) = STAXYZ(3)
               IF (DOBTW.GT.0.0) THEN
                  WRITE (LINE,1040) NOSTA, ANAMES(NOSTA), STAXYZ
                  CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *               LINE, LINES, IPAGE, SCRTCH, IERR)
                  IF (IERR.NE.0) GO TO 900
                  END IF
               END IF
 220        CONTINUE
         END IF
C                                       count number of VLA antennas
      NUMVLA = 0
C                                       count vla antennas
      DO 300 IANT = 1,MANT
         IF ((ANAMES(IANT)(1:3).EQ.'VLA') .OR.
     *      (ANAMES(IANT)(1:4).EQ.'EVLA')) NUMVLA = NUMVLA + 1
 300     CONTINUE
C                                       if a few vla antennas
C                                       print vla antenna locations
      IF (NUMVLA.GT.2) THEN
         IANT = MIN (MAXANT, MANT)
         CALL PRTVLA (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, LINES, IPAGE, SCRTCH, IANT, ANAMES, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
C                                       Make a plot
      IF (DOPLOT.GT.0.0) THEN
         CALL PLTANT (ANAMES, ARRAYC, IERR)
         END IF
C                                        Close up.
 900  IF (IERR.LE.0) THEN
         IRET = 0
      ELSE
         WRITE (MSGTXT,1900) IERR
         CALL MSGWRT (8)
         END IF
C
 960  CALL LPCLOS (LUNP, FINDP, LINES, IERR)
 970  CALL TABAN ('CLOS', IABUF, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *   STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN, POLTYA,
     *   POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
 980  CALL MAPCLS (STAT, DISK, CNO, LUN, FIND, CATBLK, F, BUFFER, IERR)
C
 990  CALL DIETSK (IRET, RQUICK, BUFFER)
C
 999  STOP
C-----------------------------------------------------------------------
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,1X,A2,
     *   ' DISK=',I3,' USER=',I5)
 1020 FORMAT ('File=',A12,'.',A6,'.',I4,5X,'An.ver=',I4,5X,'Vol=',I2,
     *   5X,'User=',I5)
 1022 FORMAT ('Array= ',A8,5X,'Freq=',F13.6,' MHz',5X,'Ref.date= ',
     *   A12)
 1030 FORMAT ('Array reference position in meters (Earth centered)')
 1031 FORMAT ('Array BX=',F16.5,4X,'BY=',F16.5,4X,'BZ=',F16.5)
 1032 FORMAT ('Polar X =',F10.5,' Polar Y =',
     *   F10.5,' arcsec')
 1033 FORMAT ('Earth rotation rate =',F16.10,' degrees / IAT day')
 1034 FORMAT ('GST at UT=0 =',F16.10,' degrees')
 1035 FORMAT ('UT1-UTC=',F15.7,3X,'Data time(',A,')-UTC=',F15.7,
     *  ' seconds')
 1036 FORMAT ('Polarization solutions are linear approximations')
 2036 FORMAT ('Polarization solutions are ellipticity-orientation, ',
     *   'ref. ant=', I3)
 1037 FORMAT ('Right-Left phase difference of IF ',I3, ' is ', F10.3,
     *   ' degrees')
 1038 FORMAT ('Solutions not yet determined for a particular FREQID')
 1039 FORMAT ('Solutions determined for FREQID ',I5)
 1040 FORMAT ('Ant',I4,' = ',A8,' BX=',F14.4,' BY=',F14.4,' BZ=',
     *   F14.4)
 1041 FORMAT ('Mount=',A4,'  Axis offset=',F8.4,' meters    IFA',
     *   15X,'IFB')
 1042 FORMAT ('Feed polarization type =',4X,2(16X,A2))
 1043 FORMAT ('Feed position angle (deg) = ',11X,F7.2,15X,F7.2)
 1045 FORMAT ('Antenna diameter       =  ',F6.1,' meters')
 1046 FORMAT ('SD beam at lambda 1m   = ',6F7.3)
 1048 FORMAT ('Lin. approx. IF(',I3,') as amp, phase = ',
     *   F7.4,',',F7.1,3X,F7.4,',',F7.1)
 1049 FORMAT ('Ellip., orient. (deg) IF(',I3,') = ',
     *   5X,F7.2,',',F7.2,3X,F7.2,',',F7.2)
 1900 FORMAT ('PRINTER ERROR',I7)
      END
      SUBROUTINE PRTVLA (OUTLUN, OUTIND, DOCRT, NC, T1, T2, LINE, NLINE,
     *   IPAGE, SCRTCH, NANT, ANAMES, IERR)
C-----------------------------------------------------------------------
C   PRTVLA prints the location of the antennas in the VLA
C   Inputs:
C      OUTLUN  I       LUN for print device (open)
C      OUTIND  I       FTAB pointer for print device
C      DOCRT   R       > 0. => use CRT, else line printer
C      NC      I       Number characters in line
C      T1      C*132   Page title line 1
C      T2      C*132   Page title line 2
C      LINE    C*132   Text line
C      NLINE   I       Number lines so far on page
C                         > 1000 => just ask about continuing
C                         = 999 => just start new page
C      IPAGE   I       Current page number
C                         = 0 => just start new page
C      SCRTCH  C*(*)   Scratch core > 132
C      NANT    I       Number of antennas in antenna name array
C      ANAMES  C*8(*)  Array of antenna names
C   Output:
C      IERR    I       Error code: 0 => OK, -1 user asks to quit
C-----------------------------------------------------------------------
      INTEGER   OUTLUN, OUTIND, NC, NLINE, IPAGE, NANT, IERR
      REAL      DOCRT
      CHARACTER SCRTCH*(*), T1*(*), T2*(*), LINE*(*), ANAMES(*)*8
C
      INTEGER   MAXPDN
      PARAMETER (MAXPDN=24)
      INTEGER   I, ARMN(50), ARME(50), ARMW(50), N, IPAD, I1, I2, I3,
     *   NEVLA
      CHARACTER PADNAM(MAXPDN)*2, ENAM*9, WNAM*9, BLANKS*25, ERMN(50)*1,
     *   ERME(50)*1, ERMW(50)*1
      LOGICAL   AFOUND(100)
      DATA PADNAM /'01','02','03','04','05','06',
     *             '07','08','09','10','12','14',
     *             '16','18','20','24','28',
     *             '32','36','40','48','56','64','72'/
      DATA ARMN, ARME, ARMW /50*0,50*0,50*0/
      DATA BLANKS /' '/
C-----------------------------------------------------------------------
C                                       for all antennas
      NEVLA = 0
      DO 200 I = 1,NANT
C                                       assume antenna is not found
         AFOUND(I) = .FALSE.
         IF ((ANAMES(I)(:3).EQ.'VLA') .OR. (ANAMES(I)(:4).EQ.'EVLA'))
     *      THEN
C                                       new form
            IF ((ANAMES(I)(:5).EQ.'VLA: ') .OR.
     *         (ANAMES(I)(:5).EQ.'VLA:_') .OR.
     *         (ANAMES(I)(:5).EQ.'EVLA:')) THEN
               I1 = 6
               I2 = 7
               I3 = 8
            ELSE
               I1 = 5
               I2 = 6
               I3 = 7
               END IF
C                                       match name and pad number
            DO 100 IPAD = 1, MAXPDN
C                                       match number
               IF (ANAMES(I)(I2:I3).EQ.PADNAM(IPAD)) THEN
C                                       match name to arm location
                  IF ((ANAMES(I)(I1:I1).EQ.'N') .OR.
     *               (ANAMES(I)(I1:I1).EQ.'n')) THEN
                     ARMN(IPAD) = I
                     AFOUND(I) = .TRUE.
                     IF (ANAMES(I)(:4).EQ.'EVLA') THEN
                        ERMN(IPAD) = '*'
                        NEVLA = NEVLA + 1
                     ELSE
                        ERMN(IPAD) = ' '
                        END IF
                     END IF
                  IF ((ANAMES(I)(I1:I1).EQ.'E') .OR.
     *               (ANAMES(I)(I1:I1).EQ.'e')) THEN
                     ARME(IPAD) = I
                     AFOUND(I) = .TRUE.
                     IF (ANAMES(I)(:4).EQ.'EVLA') THEN
                        ERME(IPAD) = '*'
                        NEVLA = NEVLA + 1
                     ELSE
                        ERME(IPAD) = ' '
                        END IF
                     END IF
                  IF ((ANAMES(I)(I1:I1).EQ.'W') .OR.
     *               (ANAMES(I)(I1:I1).EQ.'w')) THEN
                     ARMW(IPAD) = I
                     AFOUND(I) = .TRUE.
                     IF (ANAMES(I)(:4).EQ.'EVLA') THEN
                        ERMW(IPAD) = '*'
                        NEVLA = NEVLA + 1
                     ELSE
                        ERMW(IPAD) = ' '
                        END IF
                     END IF
                  END IF
 100           CONTINUE
            END IF
 200     CONTINUE
C                                       New Page, Label output
      NLINE = 950
C                                       add three lines of label
      DO 250 I = 1,3
C                                       add a blank line
         LINE =  ' '
C                                       add a label
         IF (I.EQ.2)
     *      LINE = '                      Location of VLA antennas '
C                                       print line
         IF ((I.EQ.2) .OR. (DOCRT.GT.-2.5)) THEN
            CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NC, T1, T2,
     *         LINE, NLINE, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 250     CONTINUE
C                                       for all north antenna locations
      DO 300 IPAD = MAXPDN+1,1,-1
C                                       if location contains an antenna
C                                       then print antenna location
         IF ((ARMN(IPAD).NE.0) .OR. (ARME(IPAD).NE.0) .OR.
     *      (ARMW(IPAD).NE.0)) THEN
            IF (ARMN(IPAD).NE.0) THEN
               WRITE (LINE,1000,ERR=900) 'N' // PADNAM(IPAD),
     *            ARMN(IPAD), ERMN(IPAD)
            ELSE
               WRITE (LINE,1001)
               END IF
            CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NC, T1, T2, LINE, NLINE,
     *         IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 300     CONTINUE
C
      N = 1
C                                       for all east and west locations
      DO 400 IPAD = 1,25
C                                       if location contains an antenna
         IF ((ARME(IPAD).NE.0) .OR. (ARMW(IPAD).NE.0) .OR.
     *      (ARMN(IPAD).NE.0)) THEN
C                                       if east contains a value
            IF (ARME(IPAD).NE.0) THEN
               WRITE (ENAM,1010,ERR=900) 'E', PADNAM(IPAD), ARME(IPAD),
     *            ERME(IPAD)
            ELSE
               ENAM = '    (  )  '
               END IF
C                                       if west contains a value
            IF (ARMW(IPAD).NE.0) THEN
               WRITE (WNAM,1011,ERR=900) ERMW(IPAD), ARMW(IPAD), 'W',
     *            PADNAM(IPAD)
            ELSE
               WNAM = ' (  )    '
               END IF
C                                       then print antenna location
            WRITE (LINE,1100,ERR=900) BLANKS(1:26-N), WNAM, BLANKS(1:N),
     *         BLANKS(1:N), ENAM
            CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NC, T1, T2,
     *         LINE, NLINE, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       add two blanks per antenna
            N = MIN (N+2, 25)
C                                       end if arm has a value
            END IF
 400     CONTINUE
C                                       list out or non-vla antennas
      DO 500 I = 1,NANT
C                                       if antenna not found, out or
C                                       non-vla
         IF (.NOT.AFOUND(I)) THEN
            WRITE (LINE,1110,ERR=900) ANAMES(I), I
            CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NC, T1, T2,
     *         LINE, NLINE, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 500     CONTINUE
C                                       were EVLA
      IF (NEVLA.GT.0) THEN
         LINE = '* => EVLA ANTENNA'
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NC, T1, T2, LINE, NLINE,
     *      IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       all is ok
      GO TO 999
C                                       Write to printer error
 900  CONTINUE
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (' ',30X,A3,' (',I2,')',A1)
 1001 FORMAT (35X,'(',2X,')')
 1010 FORMAT (A1,A2,' (',I2,')',A1)
 1011 FORMAT (A1,'(',I2,') ',A1,A2)
 1100 FORMAT (' ',A,A9,A,A,A9)
 1110 FORMAT (' ',25X,A,' (',I2,') ')
      END
      SUBROUTINE PLTANT (ANAMES, ARRAYC, IERR)
C-----------------------------------------------------------------------
C   makes a plot file of the antenna locations
C   Inputs:
C      ANTREL   D(3,*)   Antenna locations
C   Outputs
C      IERR     I        error code
C-----------------------------------------------------------------------
      CHARACTER ANAMES(*)*(*)
C      DOUBLE PRECISION ANTREL(3,*)
      DOUBLE PRECISION ARRAYC(3)
      INTEGER   IERR
C
      INCLUDE 'PRTAN.INC'
      INCLUDE 'PRTAND.INC'
      REAL      XMIN, XMAX, YMIN, YMAX, TEMP, R, BLC(2), TRC(2), XY(2),
     *   XYSCL(2), XYOFF(2), CHOUT(4), TR, TI, DXX, DYY, AX(5), AY(5),
     *   X(MAXANT), Y(MAXANT)
      DOUBLE PRECISION RR, SIND
      INTEGER   I, NVAL, PBUFF(256), PVER, PLUN, PIND, TVCHN, GRCHN,
     *   TVCORN(2), IAPARM(5), INP, IPSIZE, ITYPE, IT(3), ID(3), JTRIM,
     *   LABEL, ISYM, INCHAR, J, SCRTCH(256), NFAIL, NPLOT, NOUT, IROUND
      LOGICAL   DOTV, DOGRID, GOOD
      CHARACTER PFILE*48, TEXT*80, TIME*8, DATE*12, CTEMP*20
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DLOC.INC'
      DATA PLUN /27/
      DATA TVCORN, IAPARM /2*0, 5*1/
C-----------------------------------------------------------------------
C                                       scale if needed
      NFAIL = 0
      NOUT = 0
      NPLOT = 0
      NVAL = 0
      XMIN = 1.E10
      XMAX = -1.E10
      YMIN = 1.E10
      YMAX = -1.E10
      RR = SQRT (ARRAYC(1)**2 + ARRAYC(2)**2 + ARRAYC(3)**2)
      IF (RR.LE.0.0) THEN
         SIND = 1.0
      ELSE
         SIND = ARRAYC(3) / RR
         END IF
C                                       include Z in Y
      DO 10 I = 1,MAXANT
         X(I) = ANTREL(1,I)
C         Y(I) = SQRT (ANTREL(2,I)**2 + ANTREL(3,I)**2)
C         IF ((ANTREL(2,I).LT.0.0D0) .OR. (ANTREL(3,I).LT.0.0D0)) Y(I) =
C     *      -Y(I)
C         IF (RR.LE.0.0) THEN
C            X(I) = 0.0
C            Y(I) = 0.0
C         ELSE
C            SIND = ANTZ(I) / RR
            X(I) = ANTREL(1,I)
            Y(I) = ANTREL(2,I) / SIND
C            END IF
 10      CONTINUE
      IF (FUNTYP.EQ.'LG') THEN
         DO 20 I = 1,MAXANT
            R = SQRT (X(I)**2 + Y(I)**2)
            IF (R.GT.0.0) THEN
               TEMP = LOG10 (R)
               X(I) = TEMP * X(I) / R
               Y(I) = TEMP * Y(I) / R
               END IF
 20         CONTINUE
         END IF
C                                       extrema
      DO 30 I = 1,MAXANT
         J = INDEX (ANAMES(I), 'OUT')
         IF (J.NE.0) THEN
            X(I) = 0.0D0
            Y(I) = 0.0D0
            ANTREL(3,I) = 0.0D0
            END IF
         R = SQRT (X(I)**2 + Y(I)**2)
         IF (R.GT.0.0) THEN
            NVAL = I
            XMIN = MIN (XMIN, X(I))
            YMIN = MIN (YMIN, Y(I))
            XMAX = MAX (XMAX, X(I))
            YMAX = MAX (YMAX, Y(I))
            END IF
 30      CONTINUE
      IF (NVAL.LE.0) THEN
         MSGTXT = 'NO ANTENNA LOCATIONS FOUND: QUITTING PLOT'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      IF (DOPLOT.EQ.2.0) THEN
         XMAX = MAX (XMAX, YMAX)
         XMIN = MIN (XMIN, YMIN)
         YMAX = XMAX
         YMIN = XMIN
         END IF
      IF (PIXR(2).GT.PIXR(1)) THEN
         XMAX = PIXR(2)
         YMAX = PIXR(2)
         XMIN = PIXR(1)
         YMIN = PIXR(1)
         END IF
      XVER = VER
      PIXR(2) = MAX (XMAX, YMAX)
      PIXR(1) = MIN (XMIN, YMIN)
C                                       init plot
      DOTV = XDOTV.GT.0.0
      PVER = 0
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', DISK, CNO, CATBLK, PBUFF, .TRUE., 'WRIT',
     *      PVER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'ADDING PLOT FILE TO HEADER'
            GO TO 980
            END IF
         END IF
      CALL ZPHFIL ('PL', DISK, CNO, PVER, PFILE, IERR)
      TVCHN = 1
      GRCHN = XGRCH + 0.1
      IPSIZE = 0
      ITYPE = 61
      CALL GINIT (DISK, CNO, PFILE, IPSIZE, ITYPE, NPARM, XNAME, DOTV,
     *   TVCHN, GRCHN, TVCORN, CATBLK, PBUFF, PLUN, PIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CREATING PLOT FILE'
         GO TO 950
         END IF
C                                       Graph drawing parameters.
      R = 0.05 * (XMAX - XMIN)
      XMAX = XMAX + R
      XMIN = XMIN - R
      XYOFF(1) = XMIN
      XYSCL(1) = 1000.0 / (XMAX - XMIN)
      R = 0.05 * (YMAX - YMIN)
      YMAX = YMAX + R
      YMIN = YMIN - R
      XYOFF(2) = YMIN
      XYSCL(2) = 1000.0 / (YMAX - YMIN)
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      IF ((.NOT.DOTV) .AND. (XYRATO.NE.0.0) .AND. (XYRATO.NE.1.0)) THEN
         IF (XYRATO.GT.1.0) THEN
            I = 1000.0 * XYRATO + 0.5
            TRC(1) = I
            XYSCL(1) = XYSCL(1) * TRC(1) / 1000.0
         ELSE
            I = 1000.0 / XYRATO + 0.5
            TRC(2) = I
            XYSCL(2) = XYSCL(2) * TRC(2) / 1000.0
            END IF
         END IF
C                                       Set up location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      DO 40 I = 1,2
         TR = 1000.0 / XYSCL(I)
         TI = TR
         RPLOC(I,LOCNUM) = BLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I)
         AXINC(I,LOCNUM) = TR / (TRC(I) - BLC(I))
         CALL METSCL (LABEL, TR, CPREF(I,LOCNUM), GOOD)
         RPVAL(I,LOCNUM) = RPVAL(I,LOCNUM) * TR / TI
         AXINC(I,LOCNUM) = AXINC(I,LOCNUM) * TR / TI
 40      CONTINUE
      IF (FUNTYP.EQ.'LG') THEN
         CTYP(1,LOCNUM) = 'LOG10(X)'
         CTYP(2,LOCNUM) = 'LOG10(Y)'
      ELSE
         CTYP(1,LOCNUM) = 'X meters'
         CTYP(2,LOCNUM) = 'Y meters'
         END IF
C                                       character surrounding
      CALL RFILL (4, 0.5, CHOUT)
      CALL CHNTIC (BLC, TRC, INP)
      CHOUT(1) = INP + 4
      CHOUT(2) = 3.333
      CHOUT(4) = 3.333
C                                       default XYRATIO
      IF (XYRATO.LT.0.01) THEN
         IF (DOTV) THEN
            DXX = WINDTV(3) - WINDTV(1) + 1 - CSIZTV(1) * (CHOUT(1)
     *         + CHOUT(3))
            DYY = WINDTV(4) - WINDTV(2) + 1 - CSIZTV(2) * (CHOUT(2)
     *         + CHOUT(4))
            XYRATO = 1.0
            IF (DYY.GT.0.0) XYRATO = DXX / DYY
         ELSE
            XYRATO = 1.0
            END IF
         END IF
C                                       Init for line drawing.
      CALL GINITL (BLC, TRC, XYRATO, CHOUT, IAPARM, PBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INIT PLOT FOR LINE DRAWING'
         GO TO 950
         END IF
C                                       Draw border
      CALL GLTYPE (1, PBUFF, IERR)
      IF (IERR.NE.0) GO TO 940
      CALL GPOS (BLC(1), TRC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 940
      CALL GVEC (BLC(1), BLC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 940
      CALL GVEC (TRC(1), BLC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 940
      CALL GVEC (TRC(1), TRC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 940
      CALL GVEC (BLC(1), TRC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 940
C                                       top labels
      DXX = 0.0
      DYY = CHOUT(4) - 1.5
      CALL GPOS (BLC(1), TRC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 940
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, TIME, DATE)
      WRITE (TEXT,1040) PVER, DATE, TIME
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DXX, DYY, TEXT, PBUFF, IERR)
      IF (IERR.NE.0) GO TO 940
      DYY = DYY - 1.333
      IF (FUNTYP.EQ.'LG') THEN
         TEXT = 'Log of antenna relative positions for'
      ELSE
         TEXT = 'Antenna relative positions for'
         END IF
      INP = JTRIM (TEXT) + 2
      CTEMP = NAME // CLASS
      CALL NAMEST (CTEMP, SEQ, TEXT(INP:), INCHAR)
      INP = INP - 1 + INCHAR + 2
      WRITE (TEXT(INP:),1041) VER
      CALL GPOS (BLC(1), TRC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 940
      INCHAR = 80
      CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
      CALL GCHAR (INP, 0, DXX, DYY, TEXT, PBUFF, IERR)
      IF (IERR.NE.0) GO TO 940
C                                       Put on labels and ticks
      DOGRID = .FALSE.
      LABEL = 3
      CALL CLAB1 (BLC, TRC, CHOUT, LABEL, XYRATO, DOGRID, PBUFF, IERR)
      IF (IERR.NE.0) GO TO 940
C                                       plot the data
      ISYM = IROUND (XSYM)
      ISYM = ABS (ISYM)
      IF ((ISYM.LE.0) .OR. (ISYM.GT.24)) ISYM = 0
      IF (FACTOR.LT.0.05) FACTOR = 1.0
      CALL GLTYPE (2, PBUFF, IERR)
      IF (IERR.NE.0) GO TO 940
      DO 100 I = 1,NVAL
         J = INDEX (ANAMES(I), 'OUT')
         R = SQRT (X(I)**2 + Y(I)**2)
         IF (J.GT.0) THEN
            NOUT = NOUT + 1
         ELSE IF ((R.LE.0.0) .OR. (X(I).LT.XMIN) .OR. (X(I).GT.XMAX)
     *      .OR. (Y(I).LT.YMIN) .OR. (Y(I).GT.YMAX)) THEN
            NFAIL = NFAIL + 1
         ELSE
            NPLOT = NPLOT + 1
            XY(1) = XYSCL(1) * (X(I) - XYOFF(1))
            XY(2) = XYSCL(2) * (Y(I) - XYOFF(2))
C                                       Mark point
            IF (ISYM.GT.0) THEN
               CALL GLTYPE (4, PBUFF, IERR)
               IF (IERR.NE.0) GO TO 940
               DYY = 5.0 * FACTOR
               DX X= 5.0 * FACTOR
               IF (XYRATO.GT.1.0) THEN
                  DYY = DYY * XYRATO
               ELSE
                  DXX = DXX / XYRATO
               END IF
               AX(1) = XY(1)
               AY(1) = XY(2)
               AX(2) = AX(1)
               AX(3) = AX(1)
               AX(4) = AX(1) - DXX
               AX(5) = AX(1) + DXX
               AY(2) = AY(1) + DYY
               AY(3) = AY(1) - DYY
               AY(4) = AY(1)
               AY(5) = AY(1)
               CALL PNTPLT (ISYM, AX, AY, BLC, TRC, .FALSE., .FALSE.,
     *            PBUFF, IERR)
               IF (IERR.NE.0) GO TO 940
               END IF
            CALL GPOS (XY(1), XY(2), PBUFF, IERR)
            IF (IERR.NE.0) GO TO 940
            DYY = -0.5
            WRITE (TEXT,1050) I
            CALL CHTRIM (TEXT, 80, TEXT, INP)
            DXX = -INP / 2.0
            IF (XSYM.GT.-0.49) THEN
               IF (ISYM.GT.0) THEN
                  CALL GLTYPE (2, PBUFF, IERR)
                  IF (IERR.NE.0) GO TO 940
                  END IF
               CALL GICHAR (1, INP, 0, DXX, DYY, TEXT, PBUFF, IERR)
               IF (IERR.NE.0) GO TO 940
               END IF
            END IF
 100     CONTINUE
C                                       close up plot: normal end
      GPHPAG = .FALSE.
      CALL GFINIS (PBUFF, IERR)
      IF (IERR.NE.0) GO TO 940
      IF (.NOT.DOTV) THEN
         CALL HIPLOT (DISK, CNO, PVER, SCRTCH, IERR)
         WRITE (MSGTXT,1100) PVER
         CALL MSGWRT (2)
         IERR = 0
         END IF
      WRITE (MSGTXT,1105) NPLOT
      CALL MSGWRT (2)
      WRITE (MSGTXT,1106) NFAIL
      IF (NFAIL.GT.0) CALL MSGWRT (2)
      WRITE (MSGTXT,1107) NOUT
      IF (NOUT.GT.0) CALL MSGWRT (2)
      GO TO 999
C                                       something, try to finish
 940  WRITE (MSGTXT,1000) IERR, 'PLOTTING SOMETHING'
      CALL MSGWRT (8)
      MSGTXT = 'WILL TRY TO SAVE PARTIAL PLOT'
      CALL MSGWRT (8)
      CALL GFINIS (PBUFF, IERR)
      IF (IERR.NE.0) GO TO 950
      IF (.NOT.DOTV) THEN
         CALL HIPLOT (DISK, CNO, PVER, SCRTCH, IERR)
         WRITE (MSGTXT,1100) PVER
         CALL MSGWRT (2)
         IERR = 0
         END IF
      WRITE (MSGTXT,1105) NPLOT
      CALL MSGWRT (2)
      WRITE (MSGTXT,1106) NFAIL
      IF (NFAIL.GT.0) CALL MSGWRT (2)
      WRITE (MSGTXT,1107) NOUT
      IF (NOUT.GT.0) CALL MSGWRT (2)
      GO TO 999
C                                       Destroy the plot file
 950  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (PLUN, PIND, I)
         CALL ZDESTR (DISK, PFILE, I)
         CALL DELEXT ('PL', DISK, CNO, 'WRIT', SCRTCH, SCRTCH,
     *      PVER, I)
         END IF
      GO TO 999
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PLTANT ERROR',I4,' ON ',A)
 1040 FORMAT ('Plot file version',I4,' _created ',A12,A8)
 1041 FORMAT ('Subarray',I2)
 1050 FORMAT (I5)
 1100 FORMAT ('PLTANT: plot file version',I5,' created.')
 1105 FORMAT ('PLTANT: ',I4,' antennas plotted')
 1106 FORMAT ('PLTANT: ',I4,' antennas did not fit on plot')
 1107 FORMAT ('PLTANT: ',I4,' antennas labeled as OUT')
      END
      SUBROUTINE ROTVLA (ANAMES, ARRAYC)
C-----------------------------------------------------------------------
C   ROTVLA changes coords to earth-centric assuming that the site
C   centric coordinates are correct
C   Inputs:
C      ARRAYC   D(3)   Array center
C-----------------------------------------------------------------------
      DOUBLE PRECISION ARRAYC(3)
      CHARACTER ANAMES(*)*8
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PRTAND.INC'
      INTEGER   IANT, N, J
C-----------------------------------------------------------------------
      ARRLON = ATAN2 (ARRAYC(2), ARRAYC(1))
      SINA = SIN (ARRLON)
      COSA = COS (ARRLON)
      XS = 0.0D0
      YS = 0.0D0
      ZS = 0.0D0
      N = 0
      DO 100 IANT = 1,MAXANT
         J = INDEX (ANAMES(IANT), 'OUT')
         IF ((J.EQ.0) .AND. ((ANTX(IANT).NE.0.0D0) .OR.
     *      (ANTY(IANT).NE.0.0D0))) THEN
            DX = ANTX(IANT)*COSA - ANTY(IANT)*SINA
            DY = ANTY(IANT)*COSA + ANTX(IANT)*SINA
            ANTX(IANT) = ARRAYC(1) + DX
            ANTY(IANT) = ARRAYC(2) + DY
            ANTZ(IANT) = ARRAYC(3) + ANTZ(IANT)
            XS = XS + ANTX(IANT)
            YS = YS + ANTY(IANT)
            ZS = ZS + ANTZ(IANT)
            N = N + 1
         ELSE
            ANTX(IANT) = 0.0D0
            ANTY(IANT) = 0.0D0
            ANTZ(IANT) = 0.0D0
            END IF
 100     CONTINUE
      IF (N.GT.1) THEN
         XS = XS / N
         YS = YS / N
         ZS = ZS / N
         END IF
      ARRAYC(1) = 0.0D0
      ARRAYC(2) = 0.0D0
      ARRAYC(3) = 0.0D0
C
 999  RETURN
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QSEARC (NF, NT, MF, MT, ND, NR, DATA)
C-----------------------------------------------------------------------
C! Pseudo AP routine: VLBI fringe search with FFT.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   QSEARC is a routine to do a gridded fringe search by means of
C   padded FFTs.  The number (size) of the FFTs is NF (MT) +
C   NR (MF).
C   Inputs:
C      NF    I  No. frequency channels.
C      NT    I  No. time points.
C      MF    I  No. points for freq. FFT.
C      MT    I  No. points for time FFT.
C      ND    I  No. delay channels to search.
C      NR    I  No. rate channels to search.
C      DATA  I  Base address of data array (NT,NF)
C    Output: (in AP memory)
C      0 => 1 dim. array index for peak.
C      1 => peak amplitude
C      2 => peak phase.
C-----------------------------------------------------------------------
      INTEGER   NF, NT, MF, MT, ND, NR, DATA, INTER, FINAL, FFT, LOC1,
     *   MF2, MT2, COUNT, NN, DDATA, NR2, ND2, NT2, LOOP, PEAK, FFT2,
     *   ITEMP
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                        Set pointers.
      DDATA = DATA
      MF2 = MF * 2
      MT2 = MT * 2
      NT2 = NT * 2
      NR2 = NR * 2
      ND2 = ND * 2
      INTER = DDATA + (NF * NT2)
      FINAL = INTER + (NF * NR2)
      FFT = FINAL + (NR * ND2)
      FFT2 = FFT + MT2 - NR + 1
      NN = NR * ND
      COUNT = NF
      LOC1 = INTER
C                                        Do first XFORM,
C                                        First rotate phase.
      DO 100 LOOP = 1,COUNT
         CALL QVCLR (FFT, 1, MT2)
         CALL QVMOV (DDATA, 1, FFT, 1, NT2)
C                                        Do time FFT.
         CALL QCFFT (FFT, MT, -1)
C                                         Save first half
         ITEMP = NR / 2 + 1
         CALL QCVMOV (FFT, 2, LOC1, 2, ITEMP)
C                                         Save second half
         LOC1 = LOC1 + ITEMP * 2
         ITEMP = NR / 2
         IF (ITEMP.GT.0) CALL QCVMOV (FFT2, 2, LOC1, 2, ITEMP)
C                                        Update data pointer.
         DDATA = DDATA + NT2
C                                        Update result pointer.
         LOC1 = LOC1 + ITEMP * 2
 100     CONTINUE
C                                         Second transform loop.
      COUNT = NR
      LOC1 = FINAL
      FFT2 = FFT + MF2 - ND + 1
      DO 200 LOOP = 1,COUNT
         CALL QVCLR (FFT, 1, MF2)
C                                         Move to FFT work space.
         CALL QCVMOV (INTER, NR2, FFT, 2, NF)
C                                         Freq. FFT.
         CALL QCFFT (FFT, MF, -1)
C                                         Save first half
         ITEMP = ND / 2 + 1
         CALL QCVMOV (FFT, 2, LOC1, 2, ITEMP)
C                                         Save second half
         LOC1 = LOC1 + ITEMP * 2
         ITEMP = ND / 2
         IF (ITEMP.GT.0) CALL QCVMOV (FFT2, 2, LOC1, 2, ITEMP)
C                                         Update output pointer.
         LOC1 = LOC1 + ITEMP * 2
C                                         Update input pointer.
         INTER = INTER + 2
 200     CONTINUE
C                                         Find max amp.
      CALL QCVMMA (FINAL, 2, 0, NN)
      PEAK = SPAD(15)
C                                         Save index in AP LOC 0 I
      APCORI(1) = SPAD(15)
C                                         Polar conversion.
      PEAK = (PEAK * 2) - 2
      LOC1 = FINAL + PEAK
      CALL QPOLAR (LOC1, 2, 1, 2, 1)
C
 999  RETURN
      END

      SUBROUTINE PLVEC (X, Y, IERR)
C-----------------------------------------------------------------------
C! puts a 'draw vector' command in a plot file: Gary plot package
C# plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   This routine will put a 'draw vector' command in a plot file.
C   Vectors that are too big are interpolated.
C   Inputs:
C      X       R    X value.
C      Y       R    Y value.
C   Common:
C      /PLTCOM/
C   Output:
C      IERR    I    Error code.  0 means OK.
C-----------------------------------------------------------------------
      REAL      X, Y
      INTEGER   IERR
C
      REAL      XX, YY, XT(2), YT(2)
      INTEGER   NO
      INCLUDE 'INCS:DPLT.INC'
C-----------------------------------------------------------------------
      XX = XSCAL * X + XOFF
      YY = YSCAL * Y + YOFF
C                                       Test edge intersections
      CALL INTEDG (PBLC, PTRC, XX, YY, XLAST, YLAST, NO, XT, YT)
C                                       Vector all in plot
      IF (NO.GE.0) GO TO 10
         CALL GVEC (XX, YY, PLTBLK, IERR)
         GO TO 100
C                                       Both points off plot
 10   IF (NO.EQ.1) GO TO 20
         IOFFPL = IOFFPL + 1
         IF (NO.EQ.0) GO TO 100
            CALL GPOS (XT(1), YT(1), PLTBLK, IERR)
            IF (IERR.EQ.0) CALL GVEC (XT(2), YT(2), PLTBLK, IERR)
            GO TO 100
C                                       This point off plot
 20   IF ((XX.GE.PBLC(1)) .AND. (XX.LE.PTRC(1)) .AND. (YY.GE.PBLC(2))
     *   .AND. (YY.LE.PTRC(2))) GO TO 30
         IOFFPL = IOFFPL + 1
         CALL GVEC (XT(1), YT(1), PLTBLK, IERR)
         GO TO 100
C                                       Last point off plot
 30   CONTINUE
         CALL GPOS (XT(1), YT(1), PLTBLK, IERR)
         IF (IERR.EQ.0) CALL GVEC (XX, YY, PLTBLK, IERR)
C                                       Save last desired position
 100  XLAST = XX
      YLAST = YY
C
 999  RETURN
      END

      SUBROUTINE AU5D (BRANCH)
C-----------------------------------------------------------------------
C! verbs to load and run TV movie sequences
C# POPS-appl TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998-1999, 2003, 2008-2010, 2014-2015, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AU5D performs movie functions with the TV
C   BRANCH = 1 : TVMOVIE  load images and run movie
C            2 : REMOVIE  resume running previously loaded movie
C            3 : TVCUBE   load images in order suited to display of the
C                         whole set, run movie anyway
C   Algorithm originally developed by Arnold Rots, installed and
C   modified by Eric W. Greisen.
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER SNAME*12, SCLAS*6, STYPE*2, AXCHAR(13)*4, PRGNAM*6,
     *   LCHAR*1, CTEST*4, FORM2*16, STRING*12, CDUM*2
      INTEGER   POTERR, IERR, ICHAN, BUF(MABFSS), USID, IVOL, SEQNO,
     *   DLUN, DIND, LFMT, ICP, CNO, INC(3), NX, NY, NZ, I, J, IZP,
     *   LMAG, MAG, MP, MX, MY, JMAG, IX0, IY0, JJ, IWIN(4), ITVC(4),
     *   MMX, MMY, ITEMP, NP, IXP(5), IYP(5), IOFF(2), LABTYP, HNC,
     *   IBLC(2), ITRC(2), IBUFSZ, JX, JY, JR, LOFF(2), LWIN(4), SCROLX,
     *   SCROLY, SMAG, IDUM, IBUT, QUAD, LTYPE, LZP, NZ1, KBLC(7),
     *   KTRC(7), KINC(7), K3, K4, K5, K6, K7, KN(7)
      LOGICAL   T, F, EQUAL, ISFELO, TIMEIT
      REAL      EPS, LBLC(7), LTRC(7), X0, DX, RVA, RBUF(MABFSS),
     *   RDUM(2), FACT, DOALL
      DOUBLE PRECISION X, VV, VA, VB, ZREFP, ZZINC, VELITE, AXDENU
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /AIPSCR/ RBUF
      EQUIVALENCE (BUF, RBUF)
      DATA PRGNAM /'AU5D '/
      DATA T, F /.TRUE.,.FALSE./
      DATA EPS /0.01/
      DATA DLUN /16/
      DATA VELITE /2.997924562D8/
      DATA AXCHAR /'FELO','FREQ','VELO','LL  ','MM  ','RA  ','DEC ',
     *   'RA--','DEC-','GLON','GLAT','ELON','ELAT'/
C-----------------------------------------------------------------------
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.3)) GO TO 999
      IBUFSZ = 2 * MABFSS
      CALL ADVERB ('TVCHAN', 'I', 1, 0, ICHAN, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      POTERR = 101
      CALL TVOPEN (BUF, IERR)
      IF (IERR.NE.0) GO TO 980
      IF ((ICHAN.LT.1) .OR. (ICHAN.GT.NGRAY)) ICHAN = 1
      TIMEIT = IDEBUG.GT.0
      GO TO (100, 200, 100), BRANCH
C-----------------------------------------------------------------------
C                                       TVMOVIE
C-----------------------------------------------------------------------
C                                       Open the map
 100  CALL ADVERB ('INDISK', 'I', 1, 0, IVOL, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      CALL ADVERB ('INSEQ', 'I', 1, 0, SEQNO, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      USID = NLUSER
      CALL ADVERB ('INNAME', 'C', 1, 12, IDUM, RDUM, SNAME)
      IF (ERRNUM.NE.0) GO TO 975
      CALL ADVERB ('INCLASS', 'C', 1, 6, IDUM, RDUM, SCLAS)
      IF (ERRNUM.NE.0) GO TO 975
      STYPE = 'MA'
      POTERR = 33
      CALL MAPOPN ('READ', IVOL, SNAME, SCLAS, SEQNO, STYPE, USID, DLUN,
     *    DIND, CNO, CATBLK, BUF, IERR)
      IF (IERR.GT.1) GO TO 975
C                                       Basic window
      CALL ADVERB ('TBLC', 'R', 7, 0, IDUM, LBLC, CDUM)
      IF (ERRNUM.NE.0) GO TO 970
      CALL ADVERB ('TTRC', 'R', 7, 0, IDUM, LTRC, CDUM)
      IF (ERRNUM.NE.0) GO TO 970
      POTERR = 101
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), LBLC, LTRC, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL ADVERB ('TXINC', 'I', 1, 0, INC(1), RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      CALL ADVERB ('TYINC', 'I', 1, 0, INC(2), RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      CALL ADVERB ('TZINC', 'I', 1, 0, INC(3), RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      CALL ADVERB ('DOALL', 'R', 1, 0, IDUM, RDUM, CDUM)
      DOALL = RDUM(1)
      IF (ERRNUM.NE.0) GO TO 975
      INC(1) = MAX (1, INC(1))
      INC(2) = MAX (1, INC(2))
      INC(3) = MAX (1, INC(3))
      NX = (LTRC(1) - LBLC(1)) / INC(1) + 1.01
      NY = (LTRC(2) - LBLC(2)) / INC(2) + 1.01
      J = CATBLK(KIDIM)
      NZ = 1
      IZP = J
      JJ = INC(3)
      DO 105 I = 3,J
         IDUM = (LTRC(I) - LBLC(I)) / JJ + 1.01
         IF (IDUM.GT.1) THEN
            IZP = MIN (IZP, I)
            LZP = I
            IF (NZ.EQ.0) NZ1 = IDUM
            NZ = NZ * IDUM
            JJ = 1
            IF (DOALL.LE.0.0) GO TO 115
            END IF
 105     CONTINUE
      IF (NZ.LE.1) THEN
         MSGTXT = 'MOVIE ONLY WORKS WITH TRUE 3-DIMENSIONAL SUBIMAGES'
         CALL MSGWRT (7)
         GO TO 970
         END IF
C                                       Decide zoom scale, pix size
 115  J = ABS(MXZOOM) + 1
      JJ = 1 - MXZOOM
      IF (MXZOOM.GT.0) JJ = 2 ** MXZOOM
      LMAG = 0
      DO 120 I = 1,J
         JMAG = I - 1
         MAG = JMAG + 1
         IF (MXZOOM.GT.0) MAG = 2 ** JMAG
         MP = (NGRAY - ICHAN + 1) * MAG * MAG
         MMX = MAXXTV(1) - 2
         MMY = MAXXTV(2) - 2
         IF (MAG.NE.1) THEN
            MMX = MAXXTV(1) / (MAG * (MAG-1))
            MMX = MMX * (MAG-1)
            IF (MAG*MMX.GE.MAXXTV(1)) THEN
               MMX = (MAXXTV(1)-JJ) / (MAG * (MAG-1))
               MMX = MMX * (MAG-1)
               END IF
            MMY = MAXXTV(2) / (MAG * (MAG-1))
            MMY = MMY * (MAG-1)
            IF (MAG*MMY.GE.MAXXTV(2)) THEN
               MMY = (MAXXTV(2)-JJ) / (MAG * (MAG-1))
               MMY = MMY * (MAG-1)
               END IF
            END IF
C                                       all dimensions fit?
         IF (NZ.LE.MP) THEN
            IF (LMAG.EQ.0) LMAG = MAG
            MX = MMX * 0.58
            MY = MMY * 0.58
            IF ((NX.GE.MX) .OR. (NY.GE.MY)) GO TO 125
            END IF
 120     CONTINUE
C                                       Restrict number of planes
      IF (LMAG.LE.0) THEN
         LZP = IZP
         I = LBLC(IZP) + (LTRC(IZP) - LBLC(IZP) + 1 - MP*INC(3)) / 2
         LBLC(IZP) = I
         LTRC(IZP) = LBLC(IZP) + MP * INC(3)
         NZ = MP
         END IF
C                                       Check planes too
 125  DO 130 I = 1,2
         MX = (2-I) * MMX + (I-1) * MMY - 2
         MY = MX
         J = (MX-1) * INC(I)
         ITRC(I) = LTRC(I) + EPS
         IBLC(I) = LBLC(I) + EPS
         IF (ITRC(I)-IBLC(I).GT.J) THEN
            IBLC(I) = IBLC(I) + (ITRC(I) - IBLC(I) + 1 - J)/2
            ITRC(I) = IBLC(I) + J
            END IF
         IOFF(I) = (MY - 1 - (ITRC(I) - IBLC(I))/INC(I)) / 2.0
 130     CONTINUE
      KN(1) = 1
      KN(2) = 1
      DO 135 I = 3,7
         KINC(I) = 1
         KN(I) = KN(I-1) * MAX (1, CATBLK(KINAX+I-1))
         KBLC(I) = LBLC(I) + EPS
         IF ((I.LT.IZP) .OR. (I.GT.LZP)) THEN
            KTRC(I) = KBLC(I)
         ELSE IF (I.EQ.IZP) THEN
            KINC(I) = INC(3)
            J = (LTRC(I) - LBLC(I)+EPS) / INC(3)
            KTRC(I) = KBLC(I) + J * INC(3)
         ELSE
            KTRC(I) = LTRC(I) + EPS
            END IF
 135     CONTINUE
C                                       Zero planes to be used
      MP = MAG * MAG
      J = (NZ - 1) / MP + ICHAN
      CALL YHOLD ('ONNN', IERR)
      DO 140 I = ICHAN,J
         CALL YZERO (I, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL YCINIT (I, BUF)
         JJ = 2 ** (I-1)
         SCROLX = 0
         SCROLY = 0
         CALL YSCROL (JJ, SCROLX, SCROLY, F, IERR)
         IF (IERR.NE.0) GO TO 970
 140     CONTINUE
C                                       enter codes in common
      NY = MP
      IF (BRANCH.EQ.3) NY = -MP
      CALL MOVIST ('ONNN', ICHAN, NZ, NY, JMAG, IERR)
C                                       set range and other parms
      CALL ADVERB ('PIXRANGE', 'R', 2, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 970
      CALL RNGSET (RDUM, CATR(KRDMX), CATR(KRDMN), CATR(IRRAN))
      CATBLK(IIVOL) = IVOL
      CATBLK(IICNO) = CNO
      CALL ADVERB ('FUNCTYPE', 'C', 1, 2, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 970
      CALL CHR2H (2, CDUM, 1, CATH(IITRA))
      POTERR = 49
      IWIN(1) = IBLC(1)
      IWIN(2) = IBLC(2)
      IWIN(3) = ITRC(1)
      IWIN(4) = ITRC(2)
      IWIN(3) = IWIN(3) - MOD (IWIN(3)-IWIN(1), INC(1))
      IWIN(4) = IWIN(4) - MOD (IWIN(4)-IWIN(2), INC(2))
      CALL COPY (4, IWIN, LWIN)
      LOFF(1) = IOFF(1)
      LOFF(2) = IOFF(2)
C                                       Label fit wo overlap?
      NP = 7 - MAG + MAG/4 + MAG/8
      IF (NP.LT.2) NP = 2
      J = (ITRC(2)-IBLC(2))/INC(2) + 1
      IF (4*IOFF(2).GE.NP+CSIZTV(2)) THEN
         J = MMY - 2 - J
         MX = NP
         MY = CSIZTV(2)
         IF (J.LT.NP+CSIZTV(2)) MX = 0
         IF (J.LT.CSIZTV(2)) MY = J
         IF (J.GT.MX+CSIZTV(2)) J = MX + CSIZTV(2)
         IOFF(2) = IOFF(2) - (MY-MX)/2
         IF (IOFF(2).LT.0) IOFF(2) = 0
         LOFF(2) = IOFF(2) - MX
         LWIN(4) = LWIN(4) + J*INC(2)
         END IF
      DO 145 I = 1,5
         CATBLK(IIDEP+I-1) = LBLC(I+2) + EPS
 145     CONTINUE
      CATBLK(IIDEP+IZP-3) = CATBLK(IIDEP+IZP-3) - INC(3)
C                                       Off zoom
      TVZOOM(1) = 0
      TVZOOM(2) = MAXXTV(1) / 2
      TVZOOM(3) = MAXXTV(2) / 2
      CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), T, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Off graphics & gray
      NY = NGRAY + NGRAPH
      DO 150 I = 1,NY
         CALL YSLECT ('OFFF', I, 0, BUF, IERR)
         IF (IERR.NE.0) GO TO 970
 150     CONTINUE
C                                       Load planes finally
      NY = ICHAN
      JR = 0
      IF (MOD(ICHAN,2).EQ.0) JR = MAG
      CALL YSLECT ('ONNN', NY, 0, BUF, IERR)
      CALL YHOLD ('OFFF', IERR)
      MSGTXT = 'Hit button D to terminate load prematurely'
      CALL MSGWRT (1)
      RDUM(1) = MAXXTV(1) / 2
      RDUM(2) = MAXXTV(2) / 2
      CALL YCURSE ('ONNN', F, F, RDUM, QUAD, IBUT, IERR)
      I = 0
C     DO 160 I = 1,NZ
      DO 160 K7 = KBLC(7),KTRC(7),KINC(7)
         CATBLK(IIDEP+4) = K7
      DO 159 K6 = KBLC(6),KTRC(6),KINC(6)
         CATBLK(IIDEP+3) = K6
      DO 158 K5 = KBLC(5),KTRC(5),KINC(5)
         CATBLK(IIDEP+2) = K5
      DO 157 K4 = KBLC(4),KTRC(4),KINC(4)
         CATBLK(IIDEP+1) = K4
      DO 156 K3 = KBLC(3),KTRC(3),KINC(3)
         CALL YHOLD ('ONNN', IERR)
         CATBLK(IIDEP) = K3
         I = I + 1
         NX = (I-1) / MP + ICHAN
         JX = MOD (I-1, MAG) + 1
         JY = (I-1)/MAG + 1 - ((I-1)/MP)*MAG
         IF (BRANCH.NE.3) THEN
            IF (JX.EQ.1) JR = JR + 1
            IF (MOD(JR,2).EQ.0) JX = MAG + 1 - JX
            JY = JR - ((JR-1)/MAG)*MAG
            IF (MOD(NX,2).EQ.0) JY = MAG + 1 - JY
            END IF
C                                       switch planes: select, set LUT
         IF (NX.NE.NY) THEN
            CALL YSLECT ('OFFF', NY, 0, BUF, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL YSLECT ('ONNN', NX, 0, BUF, IERR)
            IF (IERR.NE.0) GO TO 970
            DO 155 MX = 1,3
               MY = 2 ** (MX-1)
               ITEMP = 2 ** (NY - 1)
               CALL YLUT ('READ', ITEMP, MY, F, BUF, IERR)
               IF (IERR.NE.0) GO TO 970
               ITEMP = 2 ** (NX - 1)
               CALL YLUT ('WRIT', ITEMP, MY, F, BUF, IERR)
               IF (IERR.NE.0) GO TO 970
 155        CONTINUE
            NY = NX
            END IF
         ITVC(1) = IOFF(1) + 3 + MMX * (JX-1)
         ITVC(2) = IOFF(2) + MAXXTV(2) + 1 - MMY * JY
         ITVC(3) = ITVC(1) + (IWIN(3) - IWIN(1)) / INC(1)
         ITVC(4) = ITVC(2) + (IWIN(4) - IWIN(2)) / INC(2)
         CALL TVLOAD (DLUN, DIND, NX, INC, ITVC, IWIN, IBUFSZ, RBUF,
     *      IERR)
         IF (IERR.NE.0) GO TO 970
         CALL YHOLD ('OFFF', IERR)
         CALL YCURSE ('READ', F, F, RDUM, QUAD, IBUT, IERR)
         IF (IERR.NE.0) GO TO 970
         IF (IBUT.GE.8) THEN
            MSGTXT = 'Button D hit - quitting movie now'
            CALL MSGWRT (1)
            POTERR = 0
            GO TO 970
            END IF
 156     CONTINUE
 157     CONTINUE
 158     CONTINUE
 159     CONTINUE
 160     CONTINUE
C                                       Close map & 'MAP' type TV
      CALL MAPCLS ('READ', IVOL, CNO, DLUN, DIND, CATBLK, F, BUF, IERR)
C                                       Annotation section
C                                       Init labels
      CALL YHOLD ('ONNN', IERR)
      CALL ADVERB ('LTYPE', 'I', 1, 0, LTYPE, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      LABTYP = MOD (ABS (LTYPE), 100)
      IF (LABTYP.GT.6) LABTYP = LABTYP - 4
      IF (LABTYP.EQ.0) LABTYP = 3
      IF (LABTYP.LT.3) LABTYP = 1
      IF (LZP.GT.IZP) LABTYP = 2
      IF (LABTYP.GE.3) THEN
         HNC = (IZP - 1) * 2 + KHCTP
         CALL H2CHR (4, 1, CATH(HNC), CTEST)
         LCHAR = CTEST(1:1)
         X = 1.0D0
         VA = KBLC(IZP)
         VB = KTRC(IZP)
         ISFELO = CTEST.EQ.AXCHAR(1)
         IF (ISFELO) LCHAR = AXCHAR(3)(1:1)
         ZZINC = CATR(KRCIC+IZP-1)
         ZREFP = CATR(KRCRP+IZP-1)
         IF (ZZINC.EQ.0.0) LABTYP = 6
         IF (LABTYP.NE.6) THEN
            ICP = 3
            IF (ABS((VB-VA)*ZZINC).LT.2.0) ICP = 13
            DO 162 I = 1,ICP
               EQUAL = CTEST.EQ.AXCHAR(I)
               IF ((EQUAL) .AND. (I.GT.3)) X = 3600.D0
               IF ((EQUAL) .AND. (I.LE.3)) X = 0.001D0
 162           CONTINUE
C                                       Non-linear velocity
            ISFELO = (ISFELO) .AND. (CATD(KDRST).GT.0.0) .AND.
     *         (CATD(KDARV).GT.0.0)
            IF (ISFELO) THEN
               AXDENU = -ZZINC / (VELITE + CATD(KDCRV+IZP-1))
               IF (LABTYP.EQ.5) LABTYP = 4
               VA = X * ZZINC * (VA-ZREFP) / (1.D0 + AXDENU*(VA-ZREFP))
               VB = X * ZZINC * (VB-ZREFP) / (1.D0 + AXDENU*(VB-ZREFP))
               IF (LABTYP.EQ.3) THEN
                  VA = VA + X * CATD(KDCRV+IZP-1)
                  VB = VB + X * CATD(KDCRV+IZP-1)
                  END IF
            ELSE
               IF (LABTYP.EQ.5) ZREFP = (LBLC(IZP) + LTRC(IZP)) / 2.0
               VA = (VA - ZREFP) * ZZINC * X
               IF (LABTYP.EQ.3) VA = VA + CATD(KDCRV+IZP-1) * X
               VB = (VB - ZREFP) * ZZINC * X
               IF (LABTYP.EQ.3) VB = VB + CATD(KDCRV+IZP-1) * X
               END IF
            END IF
C                                       Test range
         VV = MAX (ABS(VA), ABS(VB))
         IF ((LABTYP.EQ.3) .AND. (ABS(VA-VB).LE.0.02*VV)) THEN
            LABTYP = 4
            VA = VA - X * CATD(KDCRV+IZP-1)
            VB = VB - X * CATD(KDCRV+IZP-1)
            VV = MAX (ABS(VA), ABS(VB))
            END IF
         LFMT = 5
         IF ((VA.LT.0.) .OR. (VB.LT.0.)) LFMT = 6
         I = 0
         VV = MAX (VV, ABS(VA-VB))
         RVA = VV
         IF ((VV.GT.9999.) .OR. (VV.LT.1.0)) CALL METSCA (RVA,
     *      SCLAS, EQUAL)
         IF (VV.NE.0.0) X = X * RVA / VV
         IF (RVA.LT.999.) LFMT = LFMT - 1
         IF ((RVA.LT.99.9) .AND. (LABTYP.LT.6)) I = 1
         IF ((RVA.LT.9.99) .AND. (LABTYP.LT.6)) I = 2
         IF ((RVA.LT.99.9) .AND. (LABTYP.EQ.6)) LFMT = LFMT - 1
         IF ((RVA.LT.9.99) .AND. (LABTYP.EQ.6)) LFMT = LFMT - 1
         WRITE (FORM2,1160) LFMT, I
         IF (I.EQ.0) LFMT = LFMT - 1
         LFMT = LFMT + 2
      ELSE IF (LABTYP.EQ.2) THEN
         VV = KN(7)
         I = LOG10 (VV) + 1.00001
         LFMT = I
         WRITE (FORM2,1161) I, I
         END IF
C                                       Init pointers
      NX = ITVC(3) - ITVC(1) + 1 - 2*NP
      X0 = NP + 1
      DX = REAL (NX) / REAL (NZ)
C                                       Off channel NY
      CALL YSLECT ('OFFF', NY, 0, BUF, IERR)
      IF (IERR.NE.0) GO TO 975
      NY = 0
      JR = 0
      IF (MOD(ICHAN,2).EQ.0) JR = MAG
      I = 0
      DO 190 K7 = KBLC(7),KTRC(7),KINC(7)
         CATBLK(IIDEP+4) = K7
      DO 189 K6 = KBLC(6),KTRC(6),KINC(6)
         CATBLK(IIDEP+3) = K6
      DO 188 K5 = KBLC(5),KTRC(5),KINC(5)
         CATBLK(IIDEP+2) = K5
      DO 187 K4 = KBLC(4),KTRC(4),KINC(4)
         CATBLK(IIDEP+1) = K4
      DO 186 K3 = KBLC(3),KTRC(3),KINC(3)
         CATBLK(IIDEP) = K3
         I = I + 1
         NX = (I-1) / MP + ICHAN
         JX = MOD (I-1, MAG) + 1
         JY = (I-1)/MAG + 1 - ((I-1)/MP)*MAG
         IF (BRANCH.NE.3) THEN
            IF (JX.EQ.1) JR = JR + 1
            IF (MOD(JR,2).EQ.0) JX = MAG + 1 - JX
            JY = JR - ((JR-1)/MAG)*MAG
            IF (MOD(NX,2).EQ.0) JY = MAG + 1 - JY
            END IF
C                                       switch planes
         IF (NX.NE.NY) THEN
            IF (NY.GT.0) CALL YSLECT ('OFFF', NY, 0, BUF, IERR)
            IF (IERR.NE.0) GO TO 975
            CALL YSLECT ('ONNN', NX, 0, BUF, IERR)
            IF (IERR.NE.0) GO TO 975
            NY = NX
            END IF
C                                       write border
         IX0 = LOFF(1) + 3 + MMX * (JX-1)
         IY0 = LOFF(2) + MAXXTV(2) + 1 - MMY * JY
         IXP(1) = IX0 - 1
         IXP(2) = IX0 + (LWIN(3)-LWIN(1))/INC(1) + 1
         IXP(3) = IXP(2)
         IXP(4) = IXP(1)
         IXP(5) = IXP(1)
         IYP(1) = IY0 - 1
         IYP(2) = IYP(1)
         IYP(3) = IY0 + (LWIN(4)-LWIN(2))/INC(2) + 1
         IYP(4) = IYP(3)
         IYP(5) = IYP(1)
         CALL IMVECT ('ONNN', NX, 5, IXP, IYP, BUF, IERR)
         IF (IERR.NE.0) GO TO 975
         IXP(1) = MAX (1, IXP(1)-1)
         IXP(2) = MIN (MAXXTV(1), IXP(2)+1)
         IXP(3) = IXP(2)
         IXP(4) = IXP(1)
         IXP(5) = IXP(1)
         IYP(1) = MAX (1, IYP(1)-1)
         IYP(2) = IYP(1)
         IYP(3) = MIN (MAXXTV(2), IYP(3)+1)
         IYP(4) = IYP(3)
         IYP(5) = IYP(1)
         CALL IMVECT ('ONNN', NX, 5, IXP, IYP, BUF, IERR)
         IF (IERR.NE.0) GO TO 975
C                                       Label
         IF (LABTYP.GE.3) THEN
            VV = CATBLK(IIDEP+IZP-3)
            IF (LABTYP.LE.5) THEN
               IF (ISFELO) THEN
                  VV = X * ZZINC * (VV-ZREFP) /
     *               (1.0D0 + AXDENU*(VV-ZREFP))
               ELSE
                  VV = (VV - ZREFP) * ZZINC * X
                  END IF
               END IF
            IF (LABTYP.EQ.3) VV = VV + CATD(KDCRV+IZP-1) * X
            WRITE (STRING,FORM2) LCHAR, VV
            IYP(1) = IY0 + (LWIN(4)-LWIN(2))/INC(2) + 1 - CSIZTV(2)
            CALL IMCHAR (NY, IX0, IYP, 0, 0, STRING(1:LFMT), BUF, IERR)
            IF (IERR.NE.0) GO TO 975
         ELSE IF (LABTYP.EQ.2) THEN
            JJ = K3 + (K4-1)*KN(3) + (K5-1)*KN(4) + (K6-1)*KN(5) +
     *         (K7-1)*KN(6)
            WRITE (STRING,FORM2) JJ
            IYP(1) = IY0 + (LWIN(4)-LWIN(2))/INC(2) + 1 - CSIZTV(2)
            CALL IMCHAR (NY, IX0, IYP, 0, 0, STRING(1:LFMT), BUF, IERR)
            IF (IERR.NE.0) GO TO 975
            END IF
C                                       Pointer
         CALL ADVERB ('DOPOS', 'R', 8, 0, IDUM, RBUF, CDUM)
         IF (ERRNUM.NE.0) GO TO 975
         IF (RBUF(1).GT.0.0) THEN
            IXP(1) = IX0 + X0 + (I-1)*DX + 1.5
            IYP(1) = IY0 - 1
            DO 185 JJ = 1,NP
               IXP(1) = IXP(1) - 1
               IYP(1) = IYP(1) + 1
               IYP(2) = IYP(1)
               IXP(2) = IXP(1) + 2 * (JJ-1)
               CALL IMVECT ('ONNN', NX, 2, IXP, IYP, BUF, IERR)
               IF (IERR.NE.0) GO TO 975
 185           CONTINUE
            END IF
         CALL YCURSE ('READ', F, F, RDUM, QUAD, IBUT, IERR)
         IF (IERR.NE.0) GO TO 975
         IF (IBUT.GE.8) THEN
            MSGTXT = 'Button D hit - quitting movie now'
            CALL MSGWRT (1)
            POTERR = 0
            GO TO 975
            END IF
 186     CONTINUE
 187     CONTINUE
 188     CONTINUE
 189     CONTINUE
 190     CONTINUE
      IX0 = 1
      IY0 = NZ
      JX = 0
      IF (BRANCH.EQ.3) JX = 1
      CALL YHOLD ('OFFF', IERR)
      GO TO 230
C-----------------------------------------------------------------------
C                                       REMOVIE
C                                       rerun previously loaded movie
C-----------------------------------------------------------------------
C                                       Get old movie parms
 200  NZ = TYPMOV(ICHAN) / 64
      JMAG = TYPMOV(ICHAN) / 4 - 16 * NZ
      JX = MOD(TYPMOV(ICHAN), 2)
      IF (NZ.LE.0) THEN
         WRITE (MSGTXT,1200) ICHAN
         CALL MSGWRT (7)
         GO TO 975
         END IF
C                                       Get frame range desired
      CALL ADVERB ('BCHAN', 'I', 1, 0, IX0, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IF (IX0.LE.0) IX0 = 1
      CALL ADVERB ('ECHAN', 'I', 1, 0, IY0, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IF ((IY0.LE.0) .OR. (IY0.GT.NZ)) IY0 = NZ
      IF (IX0.GE.IY0) THEN
         IX0 = 1
         IY0 = NZ
         END IF
C                                       Turn everything off
      JJ = NGRAY + NGRAPH
      CALL YHOLD ('ONNN', IERR)
      DO 215 I = 1,JJ
         CALL YSLECT ('OFFF', I, 0, BUF, IERR)
         IF (IERR.NE.0) GO TO 975
 215     CONTINUE
C                                       Shift LUTs
      MAG = JMAG + 1
      IF (MXZOOM.GT.0) MAG = 2 ** JMAG
      MAG = MAG * MAG
      NX = (IX0-1) / MAG + ICHAN
      NY = (IY0-1) / MAG + ICHAN
      IF (NX.LT.NY) THEN
         JJ = NX + 1
         DO 225 J = 1,3
            MY = 2 ** (J-1)
            ITEMP = 2 ** (NX - 1)
            CALL YLUT ('READ', ITEMP, MY, F, BUF, IERR)
            IF (IERR.NE.0) GO TO 975
            DO 220 I = JJ,NY
               ITEMP = 2 ** (I-1)
               CALL YLUT ('WRIT', ITEMP, MY, F, BUF, IERR)
               IF (IERR.NE.0) GO TO 975
 220           CONTINUE
 225        CONTINUE
         END IF
C                                       Run the movie
 230  CALL ADVERB ('DOCIRCLE', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      EQUAL = RDUM(1).LE.0.0
      CALL ADVERB ('FACTOR', 'R', 1, 0, IDUM, RDUM, CDUM)
      FACT = RDUM(1)
      IF (ERRNUM.NE.0) GO TO 975
      CALL ADVERB ('DOCENTER', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IF ((RDUM(1).GT.0.0) .AND. (FACT.GT.0.9)) THEN
         IF (MXZOOM.LT.0) THEN
            SMAG = FACT - 0.9
         ELSE
            SMAG = -1
            I = FACT + 0.1
 231        SMAG = SMAG + 1
               I = I / 2
               IF (I.GT.0) GO TO 231
            END IF
      ELSE
         SMAG = JMAG
         END IF
      CALL YHOLD ('OFFF', IERR)
      CALL TVMOVI (ICHAN, JX, JMAG, SMAG, IX0, IY0, EQUAL, TIMEIT, BUF,
     *   IERR)
      POTERR = 49
      IF (IERR.EQ.0) POTERR = 0
      GO TO 975
C-----------------------------------------------------------------------
C                                       Close down
 970  CALL MAPCLS ('READ', IVOL, CNO, DLUN, DIND, CATBLK, F, BUF, IERR)
 975  CALL TVCLOS (BUF, IERR)
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.GT.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1160 FORMAT ('(A1,''='',F',I1,'.',I1,')')
 1161 FORMAT ('(I',I1,'.',I1,')')
 1200 FORMAT ('CHANNEL',I3,' DOES NOT CONTAIN A PRELOADED MOVIE',
     *   ' SEQUENCE')
      END

LOCAL INCLUDE 'IMRMS.INC'
      REAL      XSEQ, XDISK, PIXR(2), XLAB, XDOTV, XGRCH
      HOLLERITH XNAME(3), XCLASS(2), XINFIL(12)
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER INFIL*48, NAME*12, CLASS*6, STAT*4, TYPE*2, TEXT(2)*80,
     *   TITLE*80
      INTEGER   SEQ, DISK, CNO, NPARMS, IGR, MCR, NTEXT, LABEL
      REAL      RMS(MAXCHA), CHOUT(4), YGAP
      COMMON /INPARM/ XNAME, XCLASS, XSEQ, XDISK, XINFIL, PIXR, XLAB,
     *   XDOTV, XGRCH
      COMMON /BPCH/ INFIL, NAME, CLASS, STAT, TYPE, TEXT, TITLE
      COMMON /BPPARM/ RMS,SEQ, DISK, CNO, NPARMS, IGR, MCR, NTEXT,
     *   YGAP, CHOUT, LABEL
LOCAL END
      PROGRAM IMRMS
C-----------------------------------------------------------------------
C! Extracts excess closure errors from BPASS output
C# Utility task
C-----------------------------------------------------------------------
C;  Copyright (C) 1997-1998, 2002, 2012, 2014
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C
      INCLUDE 'IMRMS.INC'
      CHARACTER INLINE*136, PRGNAM*6
      INTEGER   IOERR, I, LUNL, FINDL, IERR, IROUND, JJ, SCRTCH(256),
     *   JT, JTRIM
      LOGICAL  RQUICK
      REAL     X
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNL /18/
      DATA PRGNAM /'IMRMS'/
C-----------------------------------------------------------------------
C                                       AIPS system start up stuff
      CALL ZDCHIN (.TRUE.)
      DEVTAB(LUNL) = 3
      CALL VHDRIN
      NPARMS = 24
      CALL GTPARM (PRGNAM, NPARMS, RQUICK, XNAME, SCRTCH, IERR)
      IF (RQUICK) CALL RELPOP (0, SCRTCH, IERR)
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XNAME, NAME)
      CALL H2CHR (6, 1, XCLASS, CLASS)
      CALL H2CHR (48, 1, XINFIL, INFIL)
      SEQ = XSEQ + 0.1
      DISK = XDISK + 0.1
      IGR = XGRCH + 0.1
      IF (IGR.LE.0) IGR  = 1
      IOERR = 0
      LABEL = IROUND (XLAB)
C                                       Find plot file to attach
      IF (XDOTV.NE.0.0) THEN
         CNO = 1
         TYPE = '  '
         CALL CATDIR ('SRCH', DISK, CNO, NAME, CLASS, SEQ, TYPE, NLUSER,
     *      STAT, SCRTCH, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, NAME, CLASS, SEQ, DISK, NLUSER
            CALL MSGWRT (8)
            GO TO 990
            END IF
C                                       Save name class etc.
         CALL CHR2H (12, NAME, 1, XNAME)
         CALL CHR2H (6, CLASS, 1, XCLASS)
         XDISK = DISK
         XSEQ = SEQ
C                                       Read catalog header
         STAT = 'WRIT'
         IF (XDOTV.GT.0.0) STAT = 'READ'
         CALL CATIO ('READ', DISK, CNO, CATBLK, STAT, SCRTCH, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1001) IERR
            CALL MSGWRT (8)
            GO TO 990
            END IF
         END IF
C                                       Get list of routines
      CALL ZTXOPN ('READ', LUNL, FINDL, INFIL, .FALSE., IOERR)
      IF (IOERR.NE.0) GO TO 990
C                                       Read for start job
 100  CALL ZTXIO ('READ', LUNL, FINDL, INLINE, IOERR)
      IF (IOERR.NE.0) GO TO 900
         JT = JTRIM (INLINE)
         IF (INLINE(39:48).NE.'IMEAN ') GO TO 100
         IF (INLINE(49:60).NE.'Task IMEAN  ') GO TO 100
C                                       new job
         CALL RFILL (4096, 0.0, RMS)
         MCR = 0
         JJ = 0
C                                       Read for stats
 110     CALL ZTXIO ('READ', LUNL, FINDL, INLINE, IOERR)
         IF (IOERR.NE.0) GO TO 200
            JT = JTRIM (INLINE)
            IF (INLINE(39:48).NE.'IMEAN ') GO TO 110
            IF (INLINE(49:).NE.
     *         'Mean and rms found by fitting peak in histogram:')
     *         GO TO 110
C                                       read next line
 115        CALL ZTXIO ('READ', LUNL, FINDL, INLINE, IOERR)
            IF (IOERR.NE.0) GO TO 200
            JT = JTRIM (INLINE)
            IF (INLINE(39:48).NE.'IMEAN ') GO TO 115
C                                       rms
            READ (INLINE(70:80),1115) X
C                                       read for channel
 120        CALL ZTXIO ('READ', LUNL, FINDL, INLINE, IOERR)
            IF (IOERR.NE.0) GO TO 200
            JT = JTRIM (INLINE)
            IF (INLINE(39:48).NE.'IMEAN ') GO TO 120
            IF (INLINE(49:55).NE.'Minimum') GO TO 120
            READ (INLINE(81:85),1120) JJ
            IF ((JJ.GE.1) .AND. (JJ.LE.4096)) THEN
               RMS(JJ) = X
               MCR = MAX (MCR, JJ)
               END IF
            GO TO 110
C                                       Done with this task's output
C                                       Average IFs etc
 200     IERR = 0
         IF (MCR.GT.0) THEN
            IF (XDOTV.NE.0.0) CALL RPLOTR (IERR)
            IF ((IOERR.EQ.0) .AND. (IERR.EQ.0)) GO TO 100
            END IF
C
 900  IF (XDOTV.LT.0.0) CALL CATDIR ('CSTA', DISK, CNO, NAME, CLASS,
     *   SEQ, TYPE, NLUSER, 'CLWR', SCRTCH, I)
      IF (XDOTV.GT.0.0) CALL CATDIR ('CSTA', DISK, CNO, NAME, CLASS,
     *   SEQ, TYPE, NLUSER, 'CLRD', SCRTCH, I)
C
 980  IF (IOERR.EQ.2) IOERR = 0
      CALL ZTXCLS (LUNL, FINDL, I)
C
 990  IF (IOERR.EQ.0) IOERR = IERR
      IOERR = MAX (0, IOERR)
      CALL DIETSK (IOERR, RQUICK, SCRTCH)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',I3,
     *   ' TYPE= '' '' USER=',I4)
 1001 FORMAT ('ERROR',I3,' COPYING CATALOG HEADER')
 1115 FORMAT (F11.3)
 1120 FORMAT (I5)
      END
      SUBROUTINE RPLOTR (IERR)
C-----------------------------------------------------------------------
C   RPLOTR plots the current data array
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'IMRMS.INC'
      REAL      X, Y, XMAX, YRNG(2), XRANGE, YRANGE, XR, YR, BLC(2),
     *   TRC(2), DCX, DCY, ID(3), IT(3), IANGLE
      INTEGER   I, LCR, DEPTH(5), LLABEL, INCHAR, IGLUN, IGFIND
      LOGICAL   PFLG
      CHARACTER ANAME*18, ADATE*12, ATIME*8, WRKTXT*80, PHNAME*48
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DPLT.INC'
      INCLUDE 'INCS:DGPH.INC'
      DATA DEPTH /5*1/
C-----------------------------------------------------------------------
      DOTV = XDOTV.GT.0.0
C                                       Find maximum value.
      XMAX = 0.0
      DO 10 LCR = 1,MCR
         XMAX = MAX (XMAX, RMS(LCR))
 10      CONTINUE
      IF (PIXR(2).LE.PIXR(1)) THEN
         YRNG(2) = XMAX
         YRNG(1) = 0.0
      ELSE
         YRNG(1) = PIXR(1)
         YRNG(2) = PIXR(2)
         END IF
      XMAX = 0.05 * (YRNG(2) - YRNG(1))
      YRNG(2) = YRNG(2) + XMAX
      YRNG(1) = YRNG(1) - XMAX
C                                       Create the plot file
C                                       Add plot file to header
      IVER = 0
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', DISK, CNO, CATBLK, IOBLK, .TRUE., 'WRIT',
     *      IVER, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Make physical filename
      CALL ZPHFIL ('PL', DISK, CNO, IVER, PHNAME, IERR)
C                                       Open plot file
      TVCHN = 0
      GRCHN = IGR
      TVCORN(1) = 0
      TVCORN(2) = 0
      CALL GINIT (DISK, CNO, PHNAME, 0, 1, NPARMS, XNAME,
     *   DOTV, TVCHN, GRCHN, TVCORN, CATBLK, PLTBLK, IGLUN, IGFIND,
     *   IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Set corner values. Constant 1.1
C                                       chosen for esthetics.
      BLC(1) = 0.0
      TRC(1) = MCR + 1.0
      BLC(2) = YRNG(1)
      TRC(2) = YRNG(2)
      NTEXT = 0
C                                       Draw a square plot.
      XY = (TRC(2) - BLC(2)) / (TRC(1) - BLC(1))
C                                       Set up commons for plotting.
      LOCNUM = 1
      CALL SETLOC (DEPTH, .FALSE.)
      AXFUNC(1,LOCNUM) = 0
      AXFUNC(2,LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 0
C                                        proper scaling labels
      XRANGE = TRC(1) - BLC(1)
      YRANGE = TRC(2) - BLC(2)
      XR = XRANGE
      CALL METSCL (LABEL, XR, CPREF(1,LOCNUM), PFLG)
      YR = YRANGE
      CALL METSCL (LABEL, YR, CPREF(2,LOCNUM), PFLG)
C                                        proceed filling /LOCATI/
      CALL RCOPY (2, BLC, PBLC)
      CALL RCOPY (2, TRC, PTRC)
C                                       See if we need to rescale to
C                                       prevent integer overflow in
C                                       plot routines (plot file values
C                                       are integers).
C                                       Rescale X values
      XSCAL = 1.0
      XOFF = 0.0
      IF ((XRANGE.GE.16000.0) .OR. (XRANGE.LE.10.0)) THEN
         XSCAL = 16000.0 / XRANGE
         XOFF = - BLC(1) * XSCAL
         PTRC(1) = 16000.0
         PBLC(1) = 0.0
         END IF
C                                       Rescale Y values
      YSCAL = 1.0
      YOFF = 0.0
      IF ((YRANGE.GT.16000.0) .OR. (YRANGE.LE.10.0)) THEN
         YSCAL = 16000.0 / YRANGE
         YOFF = - BLC(2) * YSCAL
         PTRC(2) = 16000.0
         PBLC(2) = 0.0
         END IF
      XY = XY * (YSCAL / XSCAL)
      RPLOC(1,LOCNUM) = PBLC(1)
      RPLOC(2,LOCNUM) = PBLC(2)
      RPVAL(1,LOCNUM) = BLC(1) * XR / XRANGE
      RPVAL(2,LOCNUM) = BLC(2) * YR / YRANGE
      AXINC(1,LOCNUM) = XR / XRANGE / XSCAL
      AXINC(2,LOCNUM) = YR / YRANGE / YSCAL
      CTYP(1,LOCNUM) = 'Channels'
      CTYP(2,LOCNUM) = 'Jy/beam'
C                                       Left border in characters
      LLABEL = MOD (ABS (LABEL), 100)
      CHOUT(1) = 0.5
      IF (LLABEL.EQ.2) CHOUT(1) = 3.0
      IF (LLABEL.GT.2) THEN
         CHOUT(1) = 2.5
         CALL CHNTIC (PBLC, PTRC, I)
         IF (I.GT.0) CHOUT(1) = 4.0 + I
         END IF
C                                       Bottom border in characters
      CHOUT(2) = 0.5
      IF (LLABEL.GT.1) CHOUT(2) = CHOUT(2) + 1.5
      IF (LLABEL.GT.2) CHOUT(2) = CHOUT(2) + 1.333
      YGAP = CHOUT(2) - 0.5 + 1.333
      IF ((LLABEL.GT.1) .AND. (LLABEL.LT.7)) CHOUT(2) =
     *    CHOUT(2) + NTEXT * 1.333
C                                       Right border in characters
      CHOUT(3) = 0.5
C                                       Top border in characters
      CHOUT(4) = 0.5
      IF ((LLABEL.GT.1) .AND. (LLABEL.LT.7)) CHOUT(4) = CHOUT(4) + 1.5
      IF ((LABEL.GT.1) .AND. (LLABEL.LT.7)) CHOUT(4) =
     *   CHOUT(4) + 1.333
C                                       Write intialization records
C                                       into plot file.
C                                       initialize line drawing
      CALL GINITL (PBLC, PTRC, XY, CHOUT, DEPTH, PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL GLTYPE (1, PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Do axis labeling.
      CALL CLAB1 (PBLC, PTRC, CHOUT, LABEL, XY, .FALSE., PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 900
C                                        draw rectangle
      CALL GPOS (PBLC(1), PBLC(2), PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL GVEC (PTRC(1), PBLC(2), PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL GVEC (PTRC(1), PTRC(2), PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL GVEC (PBLC(1), PTRC(2), PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL GVEC (PBLC(1), PBLC(2), PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       title line.
      IF ((LLABEL.GT.1) .AND. (LLABEL.LT.7)) THEN
C                                       Standard title
         CALL H2CHR (8, 1, CATH(KHOBJ), TITLE)
         INCHAR = 12
         IF (TITLE.EQ.' ') INCHAR = 1
         IF (NCHLAB(1,LOCNUM).GT.0) THEN
            IF (INCHAR.GT.1) TITLE(INCHAR-1:INCHAR-1) = '_'
            TITLE(INCHAR:) = SAXLAB(1,LOCNUM)(1:NCHLAB(1,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(1,LOCNUM)
            END IF
         IF (NCHLAB(2,LOCNUM).GT.0) THEN
            IF (INCHAR.GT.1) TITLE(INCHAR-1:INCHAR-1) = '_'
            TITLE(INCHAR:) = SAXLAB(2,LOCNUM)(1:NCHLAB(2,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(2,LOCNUM)
            END IF
         IF (INCHAR.GT.1) TITLE(INCHAR-1:INCHAR-1) = '_'
         CALL H2CHR (18, 1, CATH(KHIMN), ANAME)
         CALL NAMEST (ANAME, CATBLK(KIIMS), TITLE(INCHAR:), I)
         CALL REFRMT (TITLE, '_', INCHAR)
         CALL GPOS (PBLC(1), PTRC(2), PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 900
         DCX = 0.0
         DCY = .5
         IANGLE = 0
         CALL CHTRIM (TITLE, 80, TITLE, INCHAR)
         CALL GCHAR (INCHAR, IANGLE, DCX, DCY, TITLE, PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
C                                       Date/time version
      IF ((LABEL.GT.1) .AND. (LLABEL.LT.7)) THEN
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, ATIME, ADATE)
         WRITE (WRKTXT,1020) IVER, ADATE, ATIME
         CALL REFRMT (WRKTXT, '_', INCHAR)
         DCY = DCY + 1.333
         CALL GPOS (PBLC(1), PTRC(2), PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL GCHAR (INCHAR, IANGLE, DCX, DCY, WRKTXT, PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
C                                       Text at bottom.
      IF ((NTEXT.GT.0) .AND. (LLABEL.GT.1) .AND.
     *   (LLABEL.LT.7)) THEN
         DCX = 0.0
         IANGLE = 0
         DO 30 I = 1,NTEXT
            WRKTXT = TEXT(I)
            CALL CHTRIM (WRKTXT, 80, WRKTXT, INCHAR)
            DCY = -YGAP
            YGAP = YGAP + 1.333
            CALL GPOS (PBLC(1), PBLC(2), PLTBLK, IERR)
            CALL GCHAR (INCHAR, IANGLE, DCX, DCY, WRKTXT, PLTBLK, IERR)
            IF (IERR.NE.0) GO TO 900
 30         CONTINUE
         END IF
C                                       ** Plot specific statements.
C                                       Draw data
      CALL GLTYPE (2, PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 900
      X = 1.0
      Y = RMS(1)
      CALL PLPOS (X, Y, IERR)
      IF (IERR.NE.0) GO TO 900
      DO 45 LCR = 2,MCR
         X = LCR
         Y = RMS(LCR)
         CALL PLVEC (X, Y, IERR)
         IF (IERR.NE.0) GO TO 900
 45      CONTINUE
C                                       Close plot file
      GPHPAG = DOTV
      CALL GFINIS (PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       OK finish - do HI file
      IF (.NOT.DOTV) THEN
         CALL HIPLOT (DISK, CNO, IVER, PLTBLK, IERR)
         WRITE (MSGTXT,1050) IVER
         CALL MSGWRT (2)
         END IF
      IERR = 0
      GO TO 999
C                                       not sucessful. Destroy.
 900  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (GPHLUN, GPHIND, IERR)
         CALL ZDESTR (GPHVOL, GPHNAM, IERR)
         CALL DELEXT ('PL', DISK, CNO, 'WRIT', CATBLK, IOBLK, IVER,
     *      IERR)
         IERR = 8
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('Plot file version',I4,'__created ',A,A)
 1050 FORMAT ('Plot file version',I4,' created')
      END

LOCAL INCLUDE 'PCFIT.INC'
      REAL      XSEQ, XDISK, XVER, XFQ, XSUB, XTIME(8), XSOLIN, XPIECE,
     *   CUTOFF, PRTLEV, BADD(10)
      HOLLERITH XINNAM(3), XINCLS(2), XOPTYP(1)
      CHARACTER INNAM*12, INCLS*6, OPTYPE*4
      COMMON /INPARM/ XINNAM, XINCLS, XSEQ, XDISK, XVER, XFQ, XSUB,
     *   XTIME, XSOLIN, XPIECE, XOPTYP, CUTOFF, PRTLEV, BADD
      COMMON /CHPARM/ INNAM, INCLS, OPTYPE
      INTEGER   INSEQ, INDISK, INVERS, CNO, FQID, SUBARR, IFSTEP,
     *   SCRTCH(256), OUVERS
      DOUBLE PRECISION TIMBEG, TIMEND
      LOGICAL   DOCUT
      COMMON /PCFITC/ TIMBEG, TIMEND, INSEQ, INDISK, INVERS, CNO, FQID,
     *   SUBARR, IFSTEP, OUVERS, DOCUT, SCRTCH
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCHND.INC'
LOCAL END
LOCAL INCLUDE 'PCDATA.INC'
      INCLUDE 'INCS:PPCV.INC'
      DOUBLE PRECISION TIME, CABCAL, PCFREQ(2,MAXTON,MAXIF)
      INTEGER   PCNPOL, PCNIF, NUMTON, PCBUFF(512), PCNUMV(MAXPCC),
     *   PCKOLS(MAXPCC), PCRNO, SOUNUM, ANTNUM, ISUB, IDFREQ, NPCINR,
     *   PCBUFO(512)
      REAL TIMINT, STATE(2,4,MAXIF), PCREAL(2,MAXTON,MAXIF),
     *   PCIMAG(2,MAXTON,MAXIF), PCRATE(2,MAXTON,MAXIF)
      COMMON /PCDATA/ PCFREQ, TIME, CABCAL, STATE, PCREAL, PCIMAG,
     *   PCRATE, PCBUFF, PCBUFO, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON,
     *   PCRNO, TIMINT, SOUNUM, ANTNUM, ISUB, IDFREQ, NPCINR
LOCAL END
LOCAL INCLUDE 'PCFITD.INC'
      INCLUDE 'INCS:PPCV.INC'
      INTEGER   SPMAX
      PARAMETER (SPMAX = MAXTON*MAXIF)
C
      INTEGER   ITTER, NITTER
      DOUBLE PRECISION QDATA(SPMAX), UDATA(SPMAX), DELTAF(SPMAX)
      COMMON /PCFITD/ DELTAF, QDATA, UDATA, ITTER, NITTER
LOCAL END
LOCAL INCLUDE 'PCFITSN.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   GOTANT(2,MAXANT,MAXIF), REFANT(2,MAXIF)
      REAL      CREAL(2,MAXIF), CIMAG(2,MAXIF), CDELAY(2,MAXIF),
     *   CRATE(2,MAXIF), WEIGHT(2,MAXIF), DPHASE(2,MAXANT,MAXIF),
     *   DDELAY(2,MAXANT,MAXIF)
      COMMON /PCFITX/ DPHASE, DDELAY, GOTANT
LOCAL END
      PROGRAM PCFIT
C-----------------------------------------------------------------------
C! Fits pulse-cal table data for delays and phases
C# EXT-appl Calibration Plot
C-----------------------------------------------------------------------
C;  Copyright (C) 2016-2018, 2022, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Fits pulse-cal tables for delays and phases
C   Inputs from user
C      INNAME.....Input UV file name (name).      Standard defaults.
C      INCLASS....Input UV file name (class).     Standard defaults.
C      INSEQ......Input UV file name (seq. #).    0 => highest.
C      INDISK.....Disk drive # of input UV file.  0 => any.
C      INVERS.....Specifies the version of the CP table to be read as
C                 input.   0 -> highest.
C                 The output version is always highest + 1.
C-----------------------------------------------------------------------
      INTEGER   IRET
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'PCFIT.INC'
      INCLUDE 'PCDATA.INC'
      INCLUDE 'PCFITD.INC'
C-----------------------------------------------------------------------
C                                       Get parms, open things
      CALL PCFITI (IRET)
C                                       do plotting
      IF (IRET.EQ.0) THEN
         IF (XSOLIN.EQ.0.0) THEN
            CALL PCFITS (IRET)
         ELSE
            CALL PCAVGS (IRET)
            END IF
         END IF
C                                       close down
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE PCFITI (IRET)
C-----------------------------------------------------------------------
C   PCPLTI performs initialization for AIPS task PCFIT.  It gets the
C   adverbs, opens the catalog file for 'READ' (eventually), sorts and
C   opens the PC input file
C   Output:
C      IRET    I      Error code: 0 => keep going, else quit.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'PCFIT.INC'
      INCLUDE 'PCDATA.INC'
      CHARACTER INTYP*2, STAT*4, PRGN*6, KEYSPC(2)*24
      INTEGER   IROUND, PCLUN, JERR, KEY(2,2), NKEY, KOLS(2), J1, J2, I,
     *   KEYSUB(2,2), NPARMS, IUSER
      REAL      FKEY(2,2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PCLUN, INTYP /27, 'UV'/
      DATA PRGN /'PCFIT '/
      DATA NKEY /2/
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
      DATA KEYSPC /'ANTENNA_NO', 'TIME '/
C-----------------------------------------------------------------------
C                                       AIPS init
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NCFILE = 0
      NSCR = 0
C                                       get adverbs
      NPARMS = 33
      IRET = 0
      CALL GTPARM (PRGN, NPARMS, RQUICK, XINNAM, SCRTCH, JERR)
      IF (JERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (JERR.EQ.1) THEN
            GO TO 999
         ELSE
            WRITE (MSGTXT,1000) JERR, 'GET INPUT ADVERBS'
            CALL MSGWRT (8)
            END IF
         END IF
C                                       restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, JERR)
      IF (IRET.NE.0) GO TO 999
C                                       Hollerith -> Char
      CALL H2CHR (12, 1, XINNAM, INNAM)
      CALL H2CHR (6, 1, XINCLS, INCLS)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      IF (CUTOFF.EQ.0.0) CUTOFF = 100.0
      DOCUT = (OPTYPE.NE.'TOTA') .AND. (CUTOFF.GT.0.0)
      CUTOFF = CUTOFF / 1.0E9
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      INSEQ = IROUND (XSEQ)
      INDISK = IROUND (XDISK)
      INVERS = IROUND (XVER)
      IUSER = NLUSER
      CNO = 1
      CALL CATDIR ('SRCH', INDISK, CNO, INNAM, INCLS, INSEQ, INTYP,
     *   IUSER, STAT, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, INNAM, INCLS, INSEQ, INTYP,
     *      INDISK, IUSER
         GO TO 990
         END IF
C                                       Get catblk, mark file write
      CALL CATIO ('READ', INDISK, CNO, CATBLK, 'WRIT', SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ CATALOG HEADER'
         GO TO 990
         END IF
      NCFILE = 1
      FVOL(1) = INDISK
      FCNO(1) = CNO
      FRW(1) = 1
C                                       Open PC file
      CALL PCINI ('READ', PCBUFF, INDISK, CNO, INVERS, CATBLK, PCLUN,
     *   PCRNO, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN INPUT PC TABLE'
         GO TO 990
         END IF
C                                       Set column pointers for sort
      CALL FNDCOL (NKEY, KEYSPC, 24, .TRUE., PCBUFF, KOLS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FIND PC COLUMNS'
         GO TO 990
         END IF
C                                       Sort to ant-time order
      IF (XSOLIN.EQ.0.0) THEN
         J1 = 2
         J2 = 1
      ELSE
         J1 = 1
         J2 = 2
         END IF
      IF ((PCBUFF(43).NE.KOLS(J1)) .OR. (PCBUFF(44).NE.KOLS(J2))) THEN
C                                       Close
         CALL TABIO ('CLOS', 0, PCRNO, PCBUFF, PCBUFF, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSE PC TABLE'
            GO TO 990
            END IF
C                                       sort
         MSGTXT = 'Sorting the input table'
         CALL MSGWRT (2)
         KEY(1,1) = KOLS(J1)
         KEY(2,1) = KOLS(J1)
         KEY(1,2) = KOLS(J2)
         KEY(2,2) = KOLS(J2)
         CALL TABSRT (INDISK, CNO, 'PC', INVERS, INVERS, KEY, KEYSUB,
     *      FKEY, PCBUFF, CATBLK, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SORT PC TABLE'
            GO TO 990
            END IF
C                                       Re-open PC table for read
         CALL PCINI ('READ', PCBUFF, INDISK, CNO, INVERS, CATBLK, PCLUN,
     *      PCRNO, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN SORTED PC TABLE'
            GO TO 990
            END IF
         END IF
      TIMBEG = ((XTIME(4)/60.0 + XTIME(3)) / 60.0 + XTIME(2)) / 24.0 +
     *   XTIME(1)
      TIMEND = ((XTIME(8)/60.0 + XTIME(7)) / 60.0 + XTIME(6)) / 24.0 +
     *   XTIME(5)
      IF (TIMEND.LE.TIMBEG) TIMEND = 1000.
      FQID = IROUND (XFQ)
      IF (FQID.LE.0) FQID = 1
      SUBARR = IROUND (XSUB)
      IF (SUBARR.LE.0) SUBARR = 1
      I = XPIECE + 0.01
      IF ((I.LE.0) .OR. (I.GT.PCNIF)) I = PCNIF
      IFSTEP = PCNIF / I
C                                       Open PC file
      OUVERS = 0
      CALL PCINI ('WRIT', PCBUFO, INDISK, CNO, OUVERS, CATBLK, PCLUN+1,
     *   PCRNO, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OUTPUT PC TABLE'
         GO TO 990
         END IF
      PCBUFO(43) = PCBUFF(43)
      PCBUFO(44) = PCBUFF(44)
      WRITE (MSGTXT,1020) OUVERS
      CALL MSGWRT (3)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PCPLTI: ERROR',I5,' ON ',A)
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,1X,A2,
     *   'DISK=',I2,' USER=',I5)
 1020 FORMAT ('Writing output residual PC table version',I5)
      END
      SUBROUTINE PCFITS (IRET)
C-----------------------------------------------------------------------
C   Does the fitting on open PC table
C   Outputs:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      EXTERNAL PCFUNC
      INTEGER   MAXPRM
      PARAMETER (MAXPRM = 2)
C
      INCLUDE 'PCFIT.INC'
      INCLUDE 'PCDATA.INC'
      INCLUDE 'PCFITD.INC'
      INCLUDE 'PCFITSN.INC'
C
      INTEGER   IROW, IPOL, ITC, IIF, I, SNVER, SNBUFF(512), ISNRNO,
     *   SNKOLS(MAXSNC), SNNUMV(MAXSNC), SNNUMA, SNNPOL, SNNIF, NUMNOD,
     *   SNLUN, ITT(4)
      DOUBLE PRECISION TOL
      REAL      GMMOD, RANOD, DECNOD, IFR, MBDELY(2), DISP(2), DDISP(2),
     *   XDAY, PCDELY(2,MAXIF), PCPHAS(2,MAXIF), ERDELY(2,MAXIF),
     *   ERPHAS(2,MAXIF)
      LOGICAL   ISAPPL
      CHARACTER KEYWRD*8
      INCLUDE 'INCS:PSTD.INC'
      DATA SNLUN /23/
      DATA IFR, MBDELY, DISP, DDISP /7*0.0/
C-----------------------------------------------------------------------
C                                       init for SN table
      I = 2 * PCNIF
      CALL RFILL (I, 0.0, CRATE)
      CALL FILL (I, 0, REFANT)
      CALL FILL (2*MAXANT*MAXIF, 0, GOTANT)
      SNVER = 0
      SNNUMA = 0
      SNNPOL = PCNPOL
      SNNIF = PCNIF
      NUMNOD = 0
      GMMOD = 1.0
      RANOD = 0.0
      DECNOD = 0.0
      ISAPPL = .FALSE.
      CALL SNINI ('WRIT', SNBUFF, INDISK, CNO, SNVER, CATBLK, SNLUN,
     *   ISNRNO, SNKOLS, SNNUMV, SNNUMA, SNNPOL, SNNIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATING NEW SN TABLE'
         GO TO 990
         END IF
      WRITE (MSGTXT,1001) SNVER
      CALL MSGWRT (3)
C                                       read through PC table
      NITTER = 100
      NPCINR = PCBUFF(5)
      ITC  = (NUMTON  + 1) / 2
      DO 100 IROW = 1,NPCINR
         PCRNO = IROW
         CALL TABPC ('READ', PCBUFF, PCRNO, PCKOLS, PCNUMV, PCNPOL,
     *      TIME, TIMINT, SOUNUM, ANTNUM, ISUB, IDFREQ, CABCAL,
     *      STATE, PCFREQ, PCREAL, PCIMAG, PCRATE, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING PC TABLE'
            GO TO 990
            END IF
         IF (IRET.LT.0) GO TO 100
         SNNUMA = MAX (SNNUMA, ANTNUM)
         WRITE (MSGTXT,1010) IROW, ANTNUM
         IF (PRTLEV.GT.0.0) CALL MSGWRT (2)
         IF (CABCAL.EQ.DBLANK) CABCAL = 0.0D0
         IF (CABCAL.EQ.FBLANK) CABCAL = 0.0D0
         CABCAL = CABCAL * 1.0D-9
C                                       get solution and residual
         CALL PCFITR (ANTNUM, PCNPOL, PCNIF, IFSTEP, NUMTON, PCFREQ,
     *      PCREAL, PCIMAG, PRTLEV, PCDELY, PCPHAS, ERDELY, ERPHAS,
     *      WEIGHT, IRET)
         IRET = 0
         DO 90 IPOL = 1,PCNPOL
            DO 80 IIF = 1,PCNIF
               IF (WEIGHT(IPOL,IIF).GT.0.0) THEN
                  IF (GOTANT(IPOL,ANTNUM,IIF).LE.0) THEN
                     DPHASE(IPOL,ANTNUM,IIF) = PCPHAS(IPOL,IIF)
                     DDELAY(IPOL,ANTNUM,IIF) = PCDELY(IPOL,IIF) -
     *                  CABCAL
                     GOTANT(IPOL,ANTNUM,IIF) = 1
                     END IF
                  TOL = PCPHAS(IPOL,IIF) - DPHASE(IPOL,ANTNUM,IIF)
C                                       reverse sign
                  CREAL(IPOL,IIF) = COS (TOL)
                  CIMAG(IPOL,IIF) = -SIN (TOL)
                  IF (OPTYPE.EQ.'TOTA') THEN
                     CDELAY(IPOL,IIF) = -PCDELY(IPOL,IIF)
                  ELSE
                     CDELAY(IPOL,IIF) = -(PCDELY(IPOL,IIF) -
     *                  DDELAY(IPOL,ANTNUM,IIF))
                     IF (DOCUT) THEN
                        IF (ABS(CDELAY(IPOL,IIF)).GT.CUTOFF) THEN
                           WRITE (MSGTXT,1080) IPOL, ANTNUM, IIF
                           CALL MSGWRT (7)
                           XDAY = TIME
                           CALL TODHMS (XDAY, ITT)
                           WRITE (MSGTXT,1081)
     *                        DDELAY(IPOL,ANTNUM,IIF)*1.E9,
     *                        PCDELY(IPOL,IIF)*1.E9, ITT
                           CALL MSGWRT (7)
                           DPHASE(IPOL,ANTNUM,IIF) = PCPHAS(IPOL,IIF)
                           DDELAY(IPOL,ANTNUM,IIF) = PCDELY(IPOL,IIF) -
     *                        CABCAL
                           CDELAY(IPOL,IIF) = -(PCDELY(IPOL,IIF) -
     *                        DDELAY(IPOL,ANTNUM,IIF))
                           CREAL(IPOL,IIF) = 1.0
                           CIMAG(IPOL,IIF) = 0.0
                           END IF
                        END IF
                     END IF
               ELSE
                  CREAL(IPOL,IIF) = FBLANK
                  CIMAG(IPOL,IIF) = FBLANK
                  CDELAY(IPOL,IIF) = FBLANK
                  END IF
 80            CONTINUE
 90         CONTINUE
C                                       write SN table record
         CALL TABSN ('WRIT', SNBUFF, ISNRNO, SNKOLS, SNNUMV, SNNPOL,
     *      TIME, TIMINT, SOUNUM, ANTNUM, ISUB, IDFREQ, IFR, NUMNOD,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, CDELAY, CRATE, WEIGHT,
     *      REFANT, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING SN TABLE RECORD'
            GO TO 990
            END IF
         PCRNO = IROW
         CALL TABPC ('WRIT', PCBUFO, PCRNO, PCKOLS, PCNUMV, PCNPOL,
     *      TIME, TIMINT, SOUNUM, ANTNUM, ISUB, IDFREQ, CABCAL,
     *      STATE, PCFREQ, PCREAL, PCIMAG, PCRATE, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT PC TABLE'
            GO TO 990
            END IF
 100     CONTINUE
C                                       fix SN table number antennas
      KEYWRD = 'NO_ANT'
      CALL TABKEY ('WRIT', KEYWRD, 1, SNBUFF, 1, SNNUMA, 4, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'UPDATING SN TABLE KEYWORD'
         CALL MSGWRT (7)
         IRET = 0
         END IF
C                                       close tables
      CALL TABIO ('CLOS', 0, PCRNO, PCBUFF, PCBUFF, I)
      CALL TABIO ('CLOS', 0, PCRNO, PCBUFO, PCBUFO, I)
      CALL TABIO ('CLOS', 0, ISNRNO, SNBUFF, SNBUFF, I)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' ON ',A)
 1001 FORMAT ('Writing SN table version',I5)
 1010 FORMAT ('------------- Fitting row',I5,' antenna',I4,
     *   ' -------------')
 1080 FORMAT ('Polarization',I2,' antenna',I4,' IF',I3,
     *   ' zero pt delay changed')
 1081 FORMAT (5X,'from',F9.2,' to',F9.2,' at',I3,'/',2(I2.2,':'),I2.2)
      END
      SUBROUTINE PCAVGS (IRET)
C-----------------------------------------------------------------------
C   Does the fitting on open PC table with time averaging
C   Outputs:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      EXTERNAL PCFUNC
      INTEGER   MAXPRM
      PARAMETER (MAXPRM = 2)
C
      INCLUDE 'PCFIT.INC'
      INCLUDE 'PCDATA.INC'
      INCLUDE 'PCFITD.INC'
      INCLUDE 'PCFITSN.INC'
C
      INTEGER   IROW, IPOL, ITC, IIF, I, SNVER, SNBUFF(512), ISNRNO,
     *   SNKOLS(MAXSNC), SNNUMV(MAXSNC), SNNUMA, SNNPOL, SNNIF, NUMNOD,
     *   SNLUN, IR1, IR2, NOSCAN, ACOUNT(2,MAXTON,MAXIF), LSOU, ICH,
     *   NTIME, LANT, ITT(4)
      DOUBLE PRECISION TOL, TSTART, TSTOP, AVFREQ(2,MAXTON,MAXIF), TSUM,
     *   REFREQ, TT
      REAL      GMMOD, RANOD, DECNOD, IFR, MBDELY(2), DISP(2), DDISP(2),
     *   PCDELY(2,MAXIF), PCPHAS(2,MAXIF), ERDELY(2,MAXIF), XDAY,
     *   ERPHAS(2,MAXIF), TSCAN(1000), AVREAL(2,MAXTON,MAXIF),
     *   AVIMAG(2,MAXTON,MAXIF), AMP, PHLAST, PHSUM
      LOGICAL   ISAPPL, DOSCAN
      CHARACTER KEYWRD*8
      INCLUDE 'INCS:PSTD.INC'
      DATA SNLUN /23/
      DATA IFR, MBDELY, DISP, DDISP /7*0.0/
C-----------------------------------------------------------------------
C                                       Index table
      CALL GETNX (SNLUN, INDISK, CNO, CATBLK, ISUB, SNBUFF, NOSCAN,
     *   TSCAN)
      DOSCAN = (NOSCAN.GT.0) .AND. (XSOLIN.LT.0.0)
      XSOLIN = XSOLIN / (24.0 * 60.0)
C                                       init for SN table
      I = 2 * PCNIF
      CALL RFILL (I, 0.0, CRATE)
      CALL FILL (I, 0, REFANT)
      CALL FILL (2*MAXANT*MAXIF, 0, GOTANT)
      SNVER = 0
      SNNUMA = 0
      SNNPOL = PCNPOL
      SNNIF = PCNIF
      NUMNOD = 0
      GMMOD = 1.0
      RANOD = 0.0
      DECNOD = 0.0
      ISAPPL = .FALSE.
      CALL SNINI ('WRIT', SNBUFF, INDISK, CNO, SNVER, CATBLK, SNLUN,
     *   ISNRNO, SNKOLS, SNNUMV, SNNUMA, SNNPOL, SNNIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATING NEW SN TABLE'
         GO TO 990
         END IF
      WRITE (MSGTXT,1001) SNVER
      CALL MSGWRT (3)
C                                       read through PC table
      NPCINR = PCBUFF(5)
      NITTER = 100
      ITC  = (NUMTON  + 1) / 2
      LANT = 0
      LSOU = 0
      IR1 = 0
      IR2 = 0
      DO 500 IROW = 1,NPCINR+1
 10      PCRNO = IROW
         IF (PCRNO.LE.NPCINR) THEN
            CALL TABPC ('READ', PCBUFF, PCRNO, PCKOLS, PCNUMV, PCNPOL,
     *         TIME, TIMINT, SOUNUM, ANTNUM, ISUB, IDFREQ, CABCAL,
     *         STATE, PCFREQ, PCREAL, PCIMAG, PCRATE, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING PC TABLE'
               GO TO 990
               END IF
            IF (IRET.LT.0) GO TO 500
            SNNUMA = MAX (SNNUMA, ANTNUM)
            IF (CABCAL.EQ.DBLANK) CABCAL = 0.0D0
            IF (CABCAL.EQ.FBLANK) CABCAL = 0.0D0
            CABCAL = CABCAL * 1.0D-9
            END IF
C                                       time to average and fit??
         IF ((IR1.GT.0) .AND. ((ANTNUM.NE.LANT) .OR. (TIME.GT.TSTOP)
     *      .OR. (LSOU.NE.SOUNUM) .OR. (IROW.GT.NPCINR) .OR.
     *      (PCFREQ(1,1,1).NE.AVFREQ(1,1,1)))) THEN
            WRITE (MSGTXT,1010) IR1, IR2, LANT
            IF (PRTLEV.GT.0.0) CALL MSGWRT (2)
C                                       average
            DO 120 IIF = 1,PCNIF
               DO 110 ICH = 1,NUMTON
                  DO 100 IPOL = 1,PCNPOL
                     IF (ACOUNT(IPOL,ICH,IIF).GT.0) THEN
                        AVREAL(IPOL,ICH,IIF) = AVREAL(IPOL,ICH,IIF) /
     *                     ACOUNT(IPOL,ICH,IIF)
                        AVIMAG(IPOL,ICH,IIF) = AVIMAG(IPOL,ICH,IIF) /
     *                     ACOUNT(IPOL,ICH,IIF)
                     ELSE
                        AVREAL(IPOL,ICH,IIF) = FBLANK
                        AVIMAG(IPOL,ICH,IIF) = FBLANK
                        END IF
 100                 CONTINUE
 110              CONTINUE
 120           CONTINUE
            IF (NTIME.GT.0) TSUM = TSUM / NTIME
C                                       get solution and residual
            CALL PCFITR (LANT, PCNPOL, PCNIF, IFSTEP, NUMTON, AVFREQ,
     *         AVREAL, AVIMAG, PRTLEV, PCDELY, PCPHAS, ERDELY, ERPHAS,
     *         WEIGHT, IRET)
            IRET = 0
C                                       write SN record
            DO 150 IPOL = 1,PCNPOL
               DO 140 IIF = 1,PCNIF
                  IF (WEIGHT(IPOL,IIF).GT.0.0) THEN
                     IF (GOTANT(IPOL,LANT,IIF).LE.0) THEN
                        DPHASE(IPOL,LANT,IIF) = PCPHAS(IPOL,IIF)
                        DDELAY(IPOL,LANT,IIF) = PCDELY(IPOL,IIF) -
     *                     CABCAL
                        GOTANT(IPOL,LANT,IIF) = 1
                        END IF
                     TOL = PCPHAS(IPOL,IIF) - DPHASE(IPOL,LANT,IIF)
                     CREAL(IPOL,IIF) = COS (TOL)
                     CIMAG(IPOL,IIF) = SIN (TOL)
                     IF (OPTYPE.EQ.'TOTA') THEN
                        CDELAY(IPOL,IIF) = PCDELY(IPOL,IIF)
                     ELSE
                        CDELAY(IPOL,IIF) = (PCDELY(IPOL,IIF) -
     *                     DDELAY(IPOL,LANT,IIF))
                        IF (DOCUT) THEN
                           IF (ABS(CDELAY(IPOL,IIF)).GT.CUTOFF) THEN
                              WRITE (MSGTXT,1080) IPOL, ANTNUM, IIF
                              CALL MSGWRT (7)
                              XDAY = TIME
                              CALL TODHMS (XDAY, ITT)
                              WRITE (MSGTXT,1081)
     *                           DDELAY(IPOL,ANTNUM,IIF)*1.E9,
     *                           PCDELY(IPOL,IIF)*1.E9, ITT
                              CALL MSGWRT (7)
                              DPHASE(IPOL,ANTNUM,IIF) = PCPHAS(IPOL,IIF)
                              DDELAY(IPOL,ANTNUM,IIF) = PCDELY(IPOL,IIF)
     *                           - CABCAL
                              CDELAY(IPOL,IIF) = (PCDELY(IPOL,IIF) -
     *                           DDELAY(IPOL,ANTNUM,IIF))
                              CREAL(IPOL,IIF) = 1.0
                              CIMAG(IPOL,IIF) = 0.0
                              END IF
                           END IF
                        END IF
                  ELSE
                     CREAL(IPOL,IIF) = FBLANK
                     CIMAG(IPOL,IIF) = FBLANK
                     CDELAY(IPOL,IIF) = FBLANK
                     END IF
 140              CONTINUE
 150           CONTINUE
C                                       write SN table record
            TIME = TSUM
            CALL TABSN ('WRIT', SNBUFF, ISNRNO, SNKOLS, SNNUMV, SNNPOL,
     *         TIME, TIMINT, LSOU, LANT, ISUB, IDFREQ, IFR, NUMNOD,
     *         MBDELY, DISP, DDISP, CREAL, CIMAG, CDELAY, CRATE, WEIGHT,
     *         REFANT, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITING SN TABLE RECORD'
               GO TO 990
               END IF
C                                       correct the records
            DO 250 I = IR1,IR2
               PCRNO = I
               CALL TABPC ('READ', PCBUFF, PCRNO, PCKOLS, PCNUMV,
     *            PCNPOL, TIME, TIMINT, SOUNUM, ANTNUM, ISUB, IDFREQ,
     *            CABCAL, STATE, PCFREQ, PCREAL, PCIMAG, PCRATE, IRET)
               IF (IRET.GT.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'RE-READING PC TABLE'
                  GO TO 990
                  END IF
               IF (IRET.EQ.0) THEN
                  DO 220 IIF = 1,PCNIF
                     DO 210 ICH = 1,NUMTON
                       DO 200 IPOL = 1,PCNPOL
                          REFREQ = AVFREQ(IPOL,ITC,IIF)
                          IF ((PCDELY(IPOL,IIF).NE.FBLANK) .AND.
     *                       (PCREAL(IPOL,ICH,IIF).NE.FBLANK) .AND.
     *                       (PCIMAG(IPOL,ICH,IIF).NE.FBLANK)) THEN
                              AMP = SQRT (PCREAL(IPOL,ICH,IIF)**2 +
     *                           PCIMAG(IPOL,ICH,IIF)**2)
                              PHLAST = ATAN2 (PCIMAG(IPOL,ICH,IIF),
     *                           PCREAL(IPOL,ICH,IIF))
                              PHSUM = PCPHAS(IPOL,IIF) + TWOPI *
     *                           PCDELY(IPOL,IIF) *
     *                           (PCFREQ(IPOL,ICH,IIF) - REFREQ)
                              PCREAL(IPOL,ICH,IIF) = AMP *
     *                           COS(PHLAST-PHSUM)
                              PCIMAG(IPOL,ICH,IIF) = AMP *
     *                           SIN(PHLAST-PHSUM)
                           ELSE
                              PCREAL(IPOL,ICH,IIF) = FBLANK
                              PCIMAG(IPOL,ICH,IIF) = FBLANK
                              END IF
 200                       CONTINUE
 210                    CONTINUE
 220                 CONTINUE
                  PCRNO = I
                  CALL TABPC ('WRIT', PCBUFO, PCRNO, PCKOLS, PCNUMV,
     *               PCNPOL,TIME, TIMINT, SOUNUM, ANTNUM, ISUB, IDFREQ,
     *               CABCAL,STATE, PCFREQ, PCREAL, PCIMAG, PCRATE, IRET)
                  IF (IRET.GT.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT PC TABLE'
                     GO TO 990
                     END IF
                  END IF
 250           CONTINUE
            IR1 = 0
            LANT = 0
            LSOU = 0
            IF (IROW.LE.NPCINR) GO TO 10
C                                       add in to sums
         ELSE IF (IR1.GT.0) THEN
            IR2 = IROW
            DO 320 IIF = 1,PCNIF
               DO 310 ICH = 1,NUMTON
                  DO 300 IPOL = 1,PCNPOL
                     IF ((PCREAL(IPOL,ICH,IIF).NE.FBLANK) .AND.
     *                  (PCIMAG(IPOL,ICH,IIF).NE.FBLANK)) THEN
                        ACOUNT(IPOL,ICH,IIF) = ACOUNT(IPOL,ICH,IIF) + 1
                        AVREAL(IPOL,ICH,IIF) = AVREAL(IPOL,ICH,IIF) +
     *                     PCREAL(IPOL,ICH,IIF)
                        AVIMAG(IPOL,ICH,IIF) = AVIMAG(IPOL,ICH,IIF) +
     *                     PCIMAG(IPOL,ICH,IIF)
                        END IF
 300                 CONTINUE
 310              CONTINUE
 320           CONTINUE
            TSUM = TSUM + TIME
            NTIME = NTIME + 1
C                                       start new sum
         ELSE
            IR1 = IROW
            IR2 = IROW
            DO 420 IIF = 1,PCNIF
               DO 410 ICH = 1,NUMTON
                  DO 400 IPOL = 1,PCNPOL
                     IF ((PCREAL(IPOL,ICH,IIF).NE.FBLANK) .AND.
     *                  (PCIMAG(IPOL,ICH,IIF).NE.FBLANK)) THEN
                        ACOUNT(IPOL,ICH,IIF) = 1
                        AVREAL(IPOL,ICH,IIF) = PCREAL(IPOL,ICH,IIF)
                        AVIMAG(IPOL,ICH,IIF) = PCIMAG(IPOL,ICH,IIF)
                     ELSE
                        ACOUNT(IPOL,ICH,IIF) = 0
                        AVREAL(IPOL,ICH,IIF) = 0.0
                        AVIMAG(IPOL,ICH,IIF) = 0.0
                        END IF
                     AVFREQ(IPOL,ICH,IIF) = PCFREQ(IPOL,ICH,IIF)
 400                 CONTINUE
 410              CONTINUE
 420           CONTINUE
            LANT = ANTNUM
            LSOU = SOUNUM
C                                       which scan
            NTIME = 1
            TSUM = TIME
            TSTART = TIME
            IF (.NOT.DOSCAN) TSTOP = TSTART + XSOLIN
            IF (NOSCAN.LE.0) THEN
               IF (DOSCAN) TSTOP = 10000.
            ELSE IF (TIME.LT.TSCAN(1)) THEN
               IF (DOSCAN) TSTOP = TSCAN(1) - 0.1/(24.*3600.)
            ELSE IF (TIME.GT.TSCAN(NOSCAN)) THEN
               IF (DOSCAN) TSTOP = 10000.
            ELSE
               DO 430 I = 1,NOSCAN-1
                  IF ((TIME.GE.TSCAN(I)) .AND. (TIME.LE.TSCAN(I+1)))
     *               THEN
                     IF (DOSCAN) THEN
                        TSTOP = TSCAN(I+1) - 0.1 / (24.*3600.)
                        IF (I.EQ.NOSCAN-1) TSTOP = TSCAN(I+1)
                     ELSE
                        TT = TSCAN(I+1)-0.1/(24.*3600.)
                        TSTOP = MIN (TSTOP, TT)
                        END IF
                     END IF
 430             CONTINUE
               END IF
            END IF
 500     CONTINUE
C                                       fix SN table number antennas
      KEYWRD = 'NO_ANT'
      CALL TABKEY ('WRIT', KEYWRD, 1, SNBUFF, 1, SNNUMA, 4, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'UPDATING SN TABLE KEYWORD'
         CALL MSGWRT (7)
         IRET = 0
         END IF
C                                       close tables
      CALL TABIO ('CLOS', 0, PCRNO, PCBUFF, PCBUFF, I)
      CALL TABIO ('CLOS', 0, PCRNO, PCBUFO, PCBUFO, I)
      CALL TABIO ('CLOS', 0, ISNRNO, SNBUFF, SNBUFF, I)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' ON ',A)
 1001 FORMAT ('Writing SN table version',I5)
 1010 FORMAT ('------------- Fitting rows',I5,' -',I5,' antenna',I4,
     *   ' -------------')
 1080 FORMAT ('Polarization',I2,' antenna',I4,' IF',I3,
     *   ' zero pt delay changed')
 1081 FORMAT (5X,'from',F9.2,' to',F9.2,' at',I3,'/',2(I2.2,':'),I2.2)
      END

      SUBROUTINE CHCOPY (NCHAR, NP1, STR1, NP2, STR2)
C-----------------------------------------------------------------------
C! moves characters from one HELLERITH string to another
C# Character
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   CHCOPY  moves characters from one HOLLERITH string to another
C   Inputs: NCHAR   I       Number of characters to move
C           NP1     I       Start char position in input string
C           STR1    H(*)    Input string
C           NP2     I       Start char position in output string
C   Output: STR2    H(*)    Output string
C-----------------------------------------------------------------------
      HOLLERITH STR1(*), STR2(*)
      INTEGER   NCHAR, NP1, NP2
C
      INTEGER   J1, J2, I1, I2, I, J, NA1, NA2
C-----------------------------------------------------------------------
      IF (NCHAR.LE.0) GO TO 999
         NA1 = MAX (NP1, 1)
         NA2 = MAX (NP2, 1)
C                                       slow copy
         IF ((MOD(NCHAR,4).EQ.0) .AND. (MOD(NA1-1,4).EQ.0)
     *      .AND. (MOD(NA2-1,4).EQ.0)) GO TO 20
            DO 10 I = 1,NCHAR
               I1 = (NA1-1) / 4 + 1
               I2 = (NA2-1) / 4 + 1
               J1 = MOD (NA1-1, 4) + 1
               J2 = MOD (NA2-1, 4) + 1
               CALL ZGETCH (J, STR1(I1), J1)
               CALL ZPUTCH (J, STR2(I2), J2)
               NA1 = NA1 + 1
               NA2 = NA2 + 1
 10            CONTINUE
            GO TO 999
C                                       Fast copy
 20      CONTINUE
            J1 = NCHAR / 4
            I1 = (NA1-1) / 4
            I2 = (NA2-1) / 4
            DO 30 I = 1,J1
               STR2(I2+I) = STR1(I1+I)
 30            CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ZBKTP1 (ZLUN, ZBKNAM, BAKTXT, NTAPE, ZMT0N, LZMT0N,
     *   IERR)
C-----------------------------------------------------------------------
C! initialize BACKUP to tape operation for BAKTP
C# Z Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Initialize the host environment in preparation for ZBKTP2.  If
C   OP = 'INIT', initializes the tape too.
C   (used only by task BAKTP)
C   Inputs:
C      NTAPE    I       Tape drive number
C      BAKTXT   C*(*)   lowest file name for file listing (not used
C                       here, only in VMS now)
C   Outputs:
C      ZLUN     I       LUN to use
C      ZBKNAM   C*(*)   Command file name
C      ZMT0N    C*(*)   Tape name (translation of MT0n) n=NTAPE-1
C      LZMT0N   I       Actual length used in ZMT0N
C      IERR     I       Error code: 0 => okay
C   (Unix version)
C-----------------------------------------------------------------------
      INTEGER   ZLUN, NTAPE, LZMT0N, IERR
      CHARACTER ZBKNAM*(*), BAKTXT*(*), ZMT0N*(*)
C
      INTEGER   JERR, NP, ITEMP, XLEN, CLEN, ITRIM, II
      CHARACTER COMMND*40, GMT0N*10, CUSER*3, CTEMP*1
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DBTP.INC'
C-----------------------------------------------------------------------
C                                       ZLUN is host-dependent:
      ZLUN = 79
C                                       translate logical MT0n:
      ITEMP = NTAPE
      CALL ZEHEX (ITEMP, 1, CTEMP)
      GMT0N = 'AMT0' // CTEMP
      XLEN = LEN (ZMT0N)
      CALL ZTRLOG (5, GMT0N, XLEN, ZMT0N, LZMT0N, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1000) GMT0N, JERR
         IERR = 2
         GO TO 990
         END IF
C                                       create private command file:
      CALL ZEHEX (NPOPS, 1, CTEMP)
      CALL ZEHEX (USER, 3, CUSER)
      ZBKNAM = '/tmp/BAKTP' // CTEMP // '.' // CUSER
      IERR = 0
      OPEN (ZLUN, FILE=ZBKNAM, STATUS='UNKNOWN', ERR=900)
C                                       dummy contents initially:
      REWIND ZLUN
      WRITE (ZLUN,1001,ERR=910) 'set -x'
      CLOSE (ZLUN)
C                                       make file executable:
      COMMND = 'chmod +x ' // ZBKNAM
      CLEN = ITRIM (COMMND)
      CALL ZSHCMD (CLEN, COMMND, 8, 'TASK_OUT', IERR)
C                                       Tape initialize:
C                                       to end-of-information for BACK:
      II = 1
      IF (OP.NE.'INIT') THEN
         CALL ZTAPE ('AEOI', TLUN, TIND, II, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1005) IERR
            GO TO 990
            END IF
         NP = ABS (II) - 1
         IF (II.GT.0) WRITE (MSGTXT,1010) NP
         IF (II.LT.0) WRITE (MSGTXT,1011) NP
         IF (II.NE.0) CALL MSGWRT (3)
C                                       to BOT for INIT:
      ELSE
         CALL ZTAPE ('REWI', TLUN, TIND, II, IERR)
         CALL ZTAPE ('WEOF', TLUN, TIND, II, IERR)
         CALL ZTAPE ('REWI', TLUN, TIND, II, IERR)
         MSGTXT = 'Tape initialized for Unix-tar BAKTP use.'
         END IF
      CALL MSGWRT (4)
C                                       Must close tape under Unix.
C                                       Perhaps this means we are
C                                       undefended against simultaneous
C                                       access while BAKTP is running?
      CALL ZTPCLS (TLUN, TIND, IERR)
      TIND = 0
      GO TO 999
C                                       can't create, fatal error:
 900  MSGTXT = 'ZBKTP1: CAN''T OPEN ' // ZBKNAM
      IERR = 1
      GO TO 990
C                                       can't write, fatal error:
 910  MSGTXT = 'ZBKTP1: CAN''T WRITE ' // ZBKNAM
      IERR = 1
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZBKTP1: CANNOT TRANSLATE ''',A,''' IERR',I5)
 1001 FORMAT (A)
 1005 FORMAT ('ERROR WHILE TRYING TO SKIP TO EOI',I6)
 1010 FORMAT ('Advanced to end-of-information after file',I5)
 1011 FORMAT ('Advanced to end-of-information after skipping',I5,'
     *   files')
      END

      SUBROUTINE YCRCTL (OP, ON, X, Y, LINKX, LINKY, RBLINK, BUTTON,
     *   VRTRTC, IERR)
C-----------------------------------------------------------------------
C! controls the TV cursor visibility, position; reads trackball buttons
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YCRCTL reads/writes the cursor/trackball control register of TV
C   Inputs:
C      OP      C*4   'READ' from TV or 'WRIT' to TV
C      VRTRTC  L     T => do on vertical retrace only
C   In/out:
C      ON      L     T => cursor visible, F => off
C      X       I     X position cursor center (1-512, 1 => LHS)
C      Y       I     Y position cursor center (1-512, 1 => bot)
C      LINKX   L     T => trackball moves cursor in X
C      LINKY   L     T => trackball moves cursor in Y
C      RBLINK  I     rate of cursor blink: 0-3 no-fast blink
C   Output:
C      BUTTON  I     button value (0 - 15)
C      IERR    I     error code of Z...XF : 0 => ok
C                                           2 => input error
C   Virtual TV (by communication) version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   X, Y, RBLINK, BUTTON, IERR
      LOGICAL   ON, LINKX, LINKY, VRTRTC
C
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      BUFFER(1) = 0
      IF (VRTRTC) BUFFER(1) = 1
      IF (OP.EQ.'WRIT') THEN
         BUFFER(2) = 0
         IF (ON) BUFFER(2) = 1
         BUFFER(3) = X
         BUFFER(4) = Y
         BUFFER(5) = 0
         IF (LINKX) BUFFER(5) = 1
         BUFFER(6) = 0
         IF (LINKY) BUFFER(6) = 1
         BUFFER(7) = RBLINK
         BUFFER(8) = BUTTON
         BUFSW = 8
         BUFSR = 0
      ELSE
         BUFSW = 1
         BUFSR = 8
         END IF
      CALL MKYBUF (OP, 'YCRCTL', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
C                                        return answers
      IF ((IERR.EQ.0) .AND. (OP.NE.'WRIT')) THEN
         CALL UNYBUF (BUFSR, BUFFER, HEADER)
         ON = BUFFER(2).EQ.1
         X = BUFFER(3)
         Y = BUFFER(4)
         LINKX = BUFFER(5).EQ.1
         LINKY = BUFFER(6).EQ.1
         RBLINK = BUFFER(7)
         BUTTON = BUFFER(8)
         END IF
C
 999  RETURN
      END

      SUBROUTINE MAPXY (LUN, WIN, ERROR)
C-----------------------------------------------------------------------
C! sets WaWa windows for a window in the top plane of an image
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   WaWa IO system: Set windows so that MAPIO returns a subrectangle
C   of the top plane of a map
C   Inputs:
C      LUN    I      Logical Unit No. of an open map
C      WIN    R(4)   Corners of rectangle.  If WIN(1)=0.0, whole top
C                    plane is taken.
C   Output:
C      ERROR  I      As returned by MAPWIN
C   Written by WaWa (4/21/81)
C-----------------------------------------------------------------------
      INTEGER   LUN, ERROR
      REAL      WIN(4)
C
      INTEGER   I
      REAL      BLC(7), TRC(7)
C-----------------------------------------------------------------------
C                                       Set BLC, TRC default
      DO 10 I = 1,7
         BLC(I) = 1.0
         TRC(I) = 1.0
 10      CONTINUE
      TRC(1) = 24000.
      TRC(2) = 24000.
C                                       Set subrectangle top plane
      IF (WIN(1).LE.0.5) GO TO 20
         BLC(1) = WIN(1)
         BLC(2) = WIN(2)
         TRC(1) = WIN(3)
         TRC(2) = WIN(4)
C                                       Set IO parms,...
 20   CALL MAPWIN (LUN, BLC, TRC, ERROR)
C
 999  RETURN
      END

      SUBROUTINE YINIT (SCRTCH, IERR)
C-----------------------------------------------------------------------
C! initialize everything about the TV
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YINIT initializes the TV subunits: doing everything
C   Output:
C      SCRTCH  I(1024)    scratch buffer
C      IERR    I          error code of Z...XF - 0 => ok
C                                                2 => input error
C   IIS Model 70 version.
C-----------------------------------------------------------------------
      INTEGER   SCRTCH(*), IERR
C
      LOGICAL   T, F, LDUMMY, TON, TLINKX, TLINKY
      INTEGER   I, J, IC, IB, ICRED(4), ITEMP, TBLINK, TX, TY
      REAL      RBUF(1024), TEMP
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Common assummed initialized
C                                       Hardware Master Clear assummed
C                                       ISU program load
      IF (ISUNUM.GT.0) THEN
         CALL YISLOD ('WRIT', SCRTCH, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 999
         END IF
C                                        ALU to feed OFM output
      ITEMP = MAXINT + 1
      CALL FILL (ITEMP, 0, SCRTCH)
      CALL FILL (8, 9, SCRTCH)
      IF (TVALUS.GT.0) THEN
         CALL YALUCT ('WRIT', F, 11, 11, SCRTCH(9), SCRTCH(1), F, F,
     *      F, F, LDUMMY, LDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                        zero additive constants
      CALL YCONST ('WRIT', 0, 0, 0, F, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        cursor off but linked
      TBLINK = 0
      TX = 256
      TY = 256
      TON = F
      TLINKX = T
      TLINKY = T
      CALL YCRCTL ('WRIT', TON, TX, TY, TLINKX, TLINKY, TBLINK,
     *   I, F, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        clear graphic LUT, set cursor
C                                        color
      CALL FILL (256, 0, SCRTCH)
      CALL YGGRAM ('WRIT', F, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL YGRAPH ('INIT', 8, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL YGRAPH ('ONNN', 8, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL YGRAFE ('WRIT', 3, 1, F, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        IFM: divide by 4
      DO 30 I = 1,1024
         SCRTCH(I) = (I-1)/4
 30      CONTINUE
      DO 35 I = 1,8
         J = 1024 * (I-1) + 1
         CALL YIFM ('WRIT', J, 1024, F, F, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 999
 35      CONTINUE
C                                        OFM : multiply by 4
      TEMP = 4.0 / 1023.0
      DO 40 I = 1,256
         RBUF(I) = (I-1) * TEMP
 40      CONTINUE
      CALL RCOPY (256, RBUF(1), RBUF(257))
      CALL RCOPY (512, RBUF(1), RBUF(513))
      CALL YOFM ('WRIT', 7, F, RBUF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        zoom to null
      CALL YZOOMC (0, 256, 256, F, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        shifts to zero
      CALL YSHIFT ('WRIT', 0, 0, 0, F, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        build plus sign cursor
      CALL FILL (64, 0, SCRTCH)
      SCRTCH(33) = -1
      DO 45 I = 1,64
         CALL YSTCUR ('WRIT', 1, I, 64, F, F, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 999
 45      CONTINUE
      CALL FILL (64, -1, SCRTCH)
      SCRTCH(33) = 0
      CALL YSTCUR ('WRIT', 1, 32, 64, F, F, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        channel level
 100  IC = -1
      IB = -1
C                                        CHAN: luts and scroll
      DO 110 I = 1,256
         SCRTCH(I) = I - 1
 110     CONTINUE
      CALL YLUT ('WRIT', IC, 7, F, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL YSCROL (IC, 0, 0, F, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        ZERO memory
 150  CALL MOVIST ('OFFF', IC, 0, 0, 0, IERR)
      CALL YFDBCK (1, IC, IB, 0, F, F, T, F, F, IERR)
C                                        split pts and chan 1 on
      CALL FILL (4, 1, ICRED)
      TVSPLT(1) = MAXXTV(1) / 2
      TVSPLT(2) = MAXXTV(2) / 2
      CALL YSPLIT ('WRIT', TVSPLT(1), TVSPLT(2), ICRED, ICRED, ICRED, F,
     *   IERR)
      CALL FILL (4, 1, TVLIMG)
      TVSPLM = 0
      TVSPLC = 0
C                                       Clear image catalog
      IB = NGRAY + NGRAPH
      DO 160 IC = 1,IB
         CALL YCINIT (IC, SCRTCH)
 160     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE RELPOP (RETCOD, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! places a return code in the task data file, thereby resuming AIPS
C# System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   RELPOP places the specified return code in the appropriate location
C   of the first record of the Task Data file.  This will allow the
C   calling program (AIPS, AIPSC, AIPSB, BATER) to resume normal
C   operations.
C   Inputs:
C      RETCOD  I       return code number
C   Outputs:
C      SCRTCH  I(256)  scratch buffer
C      IERR    I       error number: 0 -> ok
C                                  1,2 -> task not resumed
C                                    3 -> NPOPS out of range
C                                    4 -> parameter not passed
C-----------------------------------------------------------------------
      INTEGER   RETCOD, IERR, SCRTCH(256)
C
      CHARACTER PHNAME*48
      INTEGER   NAX, IE, IER, IFIND, LUNTD
      LOGICAL   T, F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA LUNTD /13/
C-----------------------------------------------------------------------
      NAX = NINTRN
      IF (NBATQS.GT.0) NAX = NINTRN + 1 + NBATQS
      IERR = 3
      IF ((NPOPS.LT.1) .OR. (NPOPS.GT.NAX)) GO TO 900
C                                       write retcode on disk
      CALL ZPHFIL ('TD', 1, 0, 4, PHNAME, IER)
      IERR = 1
      CALL ZOPEN (LUNTD, IFIND, 1, PHNAME, F, T, T, IER)
      IF (IER.NE.0) GO TO 20
         IERR = 2
         CALL ZFIO ('READ', LUNTD, IFIND, 1, SCRTCH, IER)
         IF (IER.NE.0) GO TO 10
            SCRTCH(5*NPOPS-2) = RETCOD
            IF (RETCOD.LT.-100) SCRTCH(5*NPOPS-2) = -100
            CALL ZFIO ('WRIT', LUNTD, IFIND, 1, SCRTCH, IER)
 10      CALL ZCLOSE (LUNTD, IFIND, IE)
         IF (IER.EQ.0) IERR = 0
         IF (IER.EQ.0) GO TO 999
C                                       Error in pass back
 20   WRITE (MSGTXT,1020) NPOPS, IER
      CALL MSGWRT (8)
      IERR = 1
      GO TO 999
C                                       Errors: no resume
 900  WRITE (MSGTXT,1900) NPOPS
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('FAILS TO SEND RETURN CODE TO POPS',I3,' IO ERROR',I5)
 1900 FORMAT ('NPOPS',I3,': OUT OF RANGE')
      END

      SUBROUTINE QPTDIV (C, U, VS, INCVS, INCF, INCS, NCOMP, NVIS,
     *   NF, NS)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Divide point model visibility into uv data.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Divides the model visibility derived from CLEAN components into
C   visibility records.  Arbitrary numbers of frequencies and
C   polarizations can be processed.  The weights of the visibilities
C   are multiplied times  the amplitude of the model visibility.
C     Inputs:
C       C     I    Base address of CLEAN components, increment=7
C                  0 = Amplitude
C                  1 = used (PHASE)
C                  2 = used (REAL)
C                  3 = used (IMAG)
C                  4 = -2 * PI * X
C                  5 = -2 * PI * Y
C                  6 = -2 * PI * Z
C       U     I    Base address of U's, assumed followed by V, W
C       VS    I    Base address of vis rec. (real, imag, wt)
C       INCVS I    Increment of VS for next visibility
C       INCF  I    Increment of VS for next frequency
C       INCS  I    Increment of VS for next IF (RR of LL)
C       NCOMP I    Number of CLEAN components.
C       NVIS  I    Number of visibilities.
C       NF    I    Number of frequencies.
C       NS    I    Number of IF (usually 1 or 2)
C       FLAG  I    If FLAG < 0 multiply model vis by i (SQRT(-1))
C     Also uses AP locations 0 and 1 and expects an array
C     beginning in location 2 should be an array of length NF :
C              Freq(0) / Freq(ref) - 1.0
C              Freq(1) / Freq(0)   - 1.0
C                      .
C                      .
C                      .
C              Freq(NF-1) / Freq(NF-2) - 1.0
C   Note: all addresses are 0 relative and needed to be incremented by
C   1 to work in Fortran.
C   Note: the important loops to vectorize are 50, 100, and 130.
C   CRI version.
C-----------------------------------------------------------------------
      INTEGER   C, U, VS, INCVS, INCS, INCF, NCOMP, NVIS, NF, NS,
     *   PHASE, REAL, IMAG, X, JVS, F, IU, IVS, IF, JREAL, JIMAG,
     *   IV, IS, JA, JX, JPHAS, JAMP, ICOMP, LOOP, N7
      REAL   FREQF, SUMRE, SUMIM, REMOD, IMMOD, RMIN, WT, TEMP, SSUM
      INCLUDE 'INCS:DAPC.INC'
      DATA RMIN /1.0E-15/,  N7 /7/
C-----------------------------------------------------------------------
C                                        Make sure that there is data.
      IF ((NCOMP.LE.0) .OR. (NVIS.LE.0) .OR. (NF.LE.0) .OR.
     *   (NS.LE.0))  GO TO 999
C                                       Setup array addresses
      PHASE = C + 1
      REAL = PHASE + 1
      IMAG = REAL + 1
      X = IMAG + 1
      IU = U
      IVS = VS
C                                        Begin visibility loop
      DO 300 IV = 1,NVIS
C                                        Compute phase at ref. freq.
         JX = X + 1
         JPHAS = PHASE + 1
      INCLUDE 'INCS:ZVND.INC'
         DO 50 LOOP = 1,NCOMP
            APCORE(JPHAS) = APCORE(JX) * APCORE(IU+1)
     *                    + APCORE(JX+1) * APCORE(IU+2)
     *                    + APCORE(JX+2) * APCORE(IU+3)
C                                       Update pointers.
            JPHAS = JPHAS + 7
            JX = JX + 7
 50         CONTINUE
C                                        Get ready for freq. loop.
         JVS = IVS
         F = 2
         FREQF = 1.0
C                                        Begin frequency loop.
      INCLUDE 'INCS:ZVND.INC'
         DO 200 IF = 1,NF
C                                       Loop over component
            SUMRE = 0.0
            SUMIM = 0.0
            JPHAS = PHASE + 1
            JAMP = C + 1
            JREAL = REAL + 1
            JIMAG = IMAG + 1
C                                       Do first pass differently
            IF (IF.GT.1) GO TO 120
      INCLUDE 'INCS:ZVND.INC'
               DO 100 ICOMP = 1,NCOMP
C                                       Do DFT
                  APCORE(JREAL) = COS (APCORE(JPHAS)) * APCORE(JAMP)
                  APCORE(JIMAG) = SIN (APCORE(JPHAS)) * APCORE(JAMP)
                  JPHAS = JPHAS + 7
                  JAMP = JAMP + 7
                  JREAL = JREAL + 7
                  JIMAG = JIMAG + 7
 100              CONTINUE
               GO TO 140
C                                       Subsequent frequency
 120           FREQF = FREQF * (1.0 + APCORE(F+1))
      INCLUDE 'INCS:ZVND.INC'
               DO 130 ICOMP = 1,NCOMP
C                                       Do DFT
                  APCORE(JREAL) = COS (FREQF*APCORE(JPHAS)) *
     *               APCORE(JAMP)
                  APCORE(JIMAG) = SIN (FREQF*APCORE(JPHAS)) *
     *            APCORE(JAMP)
                  JPHAS = JPHAS + 7
                  JAMP = JAMP + 7
                  JREAL = JREAL + 7
                  JIMAG = JIMAG + 7
 130              CONTINUE
C                                       Correct visibility
 140        JA = JVS + 1
C                                       Sum real and imaginary
      SUMRE = SSUM (NCOMP, APCORE(REAL+1), N7)
      SUMIM = SSUM (NCOMP, APCORE(IMAG+1), N7)
C                                        Setup
      WT = (SUMRE * SUMRE + SUMIM * SUMIM)
      WT = MAX (RMIN, WT)
      REMOD = SUMRE / WT
      IMMOD = SUMIM / WT
      WT = SQRT (WT)
C                                       Loop over Stokes' (1 or 2,
C                                       no point in vectorizing)
            DO 150 IS = 1,NS
C                                       Divide model
               TEMP = REMOD * APCORE(JA) + IMMOD * APCORE(JA+1)
               APCORE(JA+1) = REMOD * APCORE(JA+1) - IMMOD * APCORE(JA)
               APCORE(JA) = TEMP
C                                       Modify weight
               APCORE(JA+2) = APCORE(JA+2) * WT
               JA = JA + INCS
 150           CONTINUE
C                                        Update vis pointer.
            JVS = JVS + INCF
            F = F + 1
 200        CONTINUE
C                                        Update pointers.
         IVS = IVS + INCVS
         IU = IU + INCVS
 300     CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'ISPEC.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQIN, DISKIN, CNOIN, NUMHIS, JBUFSZ, LUNI, INDI,
     *   WIN(4), PVER, GLUN, GFIND, PLBUFF(256), ZINC, LTYPE, NZI,
     *   NPARM, GRCHN, TVCHN, TVCORN(4), LUNP, FINDP, BUFFER(256),
     *   IPCNT, PAGE, NACROS, NGOOD, DOLOG, DOXLOG, LABEL, NBOXES,
     *   GR2CHN
      LOGICAL   DOTV, FLUXFL, INVERT, ISFQID
      HOLLERITH XNAMEI(3), XCLAIN(2), XLPNAM(12), XOPTYP
      CHARACTER NAMEIN*12, CLAIN*6, HISCRD(10)*64, LPNAME*48, TITL1*132,
     *   TITL2*132, LINE*132, SCRTCH*132, OPTYPE*4, OPCODE*4
      REAL      USERID, XSEQIN, XDISKI, BLC(7), TRC(7), XNBOXS,
     *   BOX(4,50), DOINV, PIXR(2), XZINC, XSMOTH(3), XLTYPE, DOCENT,
     *   XDOTV, XGRCH, DOSLIC, XYRATO, FACTOR, XSUM, BUFF1(MABFSS),
     *   RANGE(2), DBUFF(MAXIMG), DOCRT, CBAREA, DSUM, FSUM
      DOUBLE PRECISION FRQS(MAXIMG)
      COMMON /INPARM/ USERID, XNAMEI, XCLAIN, XSEQIN, XDISKI, BLC, TRC,
     *   XNBOXS, BOX, DOINV, XOPTYP, PIXR, XZINC, XSMOTH, XLTYPE,
     *   DOCENT, XDOTV, XGRCH, DOCRT, XLPNAM, DOSLIC, XYRATO, FACTOR
      COMMON /CHPARM/ NAMEIN, CLAIN, OPTYPE, OPCODE, HISCRD, LPNAME,
     *   TITL1, TITL2, LINE, SCRTCH
      COMMON /PARMS/ FRQS, RANGE, SEQIN, DISKIN, CNOIN, LUNI, INDI,
     *   ZINC, LTYPE, JBUFSZ, NUMHIS, WIN, PVER, GLUN, GFIND, NZI,
     *   NPARM, GRCHN, TVCHN, TVCORN, DOTV, LUNP, FINDP, IPCNT, PAGE,
     *   NACROS, CBAREA, FLUXFL, INVERT, FSUM, DSUM, XSUM, NGOOD, DOLOG,
     *   DOXLOG, ISFQID, LABEL, NBOXES, GR2CHN
      COMMON /BUFRS/ PLBUFF, BUFF1, DBUFF, BUFFER
LOCAL END
      PROGRAM ISPEC
C-----------------------------------------------------------------------
C! Task to plot the spectrum of a specified ra/dec region of an image
C# Map-util Utility Spectral Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2002, 2004, 2007-2012, 2014-2016, 2018,
C;  Copyright (C) 2020-2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ISPEC allows a user to specify a region or pixel and then will
C   generate the spectrum of that region.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      PIXRANGE       PIXR          Range of intensities to plot
C      ZINC           ZINC          Increment on freq axis
C      LTYPE          LTYPE         Type of labelling
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, IERR
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'ISPEC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      DATA PRGM /'ISPEC '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL ISPCIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Obtain spectrum
      CALL GETSPC (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       write as slice
      IF (DOSLIC.GT.0.0) THEN
         CALL SLISPC (IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
C                                       Plot it
      CALL PLTSCH (IRET)
      CALL PLTSPC (IRET)
C                                       Close printer
      IF (DOCRT.NE.0.0) THEN
         CALL LPCLOS (LUNP, FINDP, IPCNT, IERR)
         IF (IRET.EQ.0) IRET = IERR
         END IF
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE ISPCIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   ISPCIN gets input parameters for ISPEC, creates 'PL' file and
C   sets up scaling etc.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                      4 => user routine detected error.
C                      5 => catalog troubles
C                      8 => can't start
C   Commons:
C      /INPARM/ all input adverbs in order given by INPUTS file
C      /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, MTYPE*2, UNITS*8, CTEMP*8
      INTEGER   IROUND, IUSER, DEPTH(5), NFQ, ORDER, I, J
      REAL      TEMP
      DOUBLE PRECISION DTEMP
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'ISPEC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      DATA DEPTH /5*1/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      TSKNAM = PRGN
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 251
      CALL GTPARM (PRGN, NPARM, RQUICK, USERID, BUFF1, IRET)
      CALL H2CHR (48, 1, XLPNAM, LPNAME)
      IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) THEN
         IF (DOCRT.NE.0.0) DOCRT = MIN (-1.0, DOCRT)
         END IF
      IF (DOCRT.GT.0.0) RQUICK = .FALSE.
      IF ((DOCRT.NE.0.0) .AND. (RQUICK)) RQUICK = LPNAME.NE.' '
      IF (IRET.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IRET.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IRET
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IUSER)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      DOXLOG = 0
      IF (OPTYPE.EQ.'FLUX') THEN
         OPCODE = 'FLUX'
         DOLOG = 0
      ELSE IF (OPTYPE.EQ.'LGFL') THEN
         OPCODE = 'FLUX'
         DOLOG = 1
      ELSE IF (OPTYPE.EQ.'LNFL') THEN
         OPCODE = 'FLUX'
         DOLOG = 2
      ELSE IF (OPTYPE.EQ.'ADER') THEN
         OPCODE = 'ADER'
         DOLOG = 0
      ELSE IF (OPTYPE.EQ.'FDER') THEN
         OPCODE = 'FDER'
         DOLOG = 0
      ELSE IF (OPTYPE.EQ.'LGAV') THEN
         OPCODE = 'AVER'
         DOLOG = 1
      ELSE IF (OPTYPE.EQ.'LNAV') THEN
         OPCODE = 'AVER'
         DOLOG = 2
      ELSE IF (OPTYPE.EQ.'XLGF') THEN
         DOXLOG = 1
         DOLOG = 1
         OPCODE = 'FLUX'
      ELSE IF (OPTYPE.EQ.'XLGA') THEN
         DOXLOG = 1
         DOLOG = 1
         OPCODE = 'AVER'
      ELSE
         OPCODE = 'AVER'
         DOLOG = 0
         OPTYPE = 'AVER'
         END IF
      CALL CHR2H (4, OPTYPE, 1, XOPTYP)
      IF (XYRATO.LE.0.0) XYRATO = 1.3
      IF (FACTOR.EQ.0) FACTOR = 1.0
      IF (OPCODE(2:4).NE.'DER') FACTOR = 1.0
C                                       Crunch input parameters.
      USERID = NLUSER
      IUSER = NLUSER
      SEQIN = IROUND (XSEQIN)
      DISKIN = IROUND (XDISKI)
      INVERT = XZINC.LT.0.0
      ZINC = IROUND (XZINC)
      ZINC = ABS (ZINC)
      IF (ZINC.LE.0) ZINC = 1
      XZINC = ZINC
      IF (INVERT) XZINC = -XZINC
      LTYPE = IROUND (XLTYPE)
      I = MOD (ABS(LTYPE), 100)
      IF ((I.LE.0) .OR. (I.GT.10)) THEN
         IF (LTYPE.GE.0) THEN
            LTYPE = (LTYPE/100) * 100 + 3
         ELSE
            LTYPE = (LTYPE/100) * 100 - 3
            END IF
         END IF
      XLTYPE = LTYPE
      LABEL = MOD (ABS(LTYPE), 100)
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      GR2CHN = GRCHN / 10
      GRCHN = MOD (GRCHN, 10)
      IF (GR2CHN.EQ.0) GR2CHN = MAX (1, GRCHN)
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
C                                       Open map file and get
C                                       CATBLK
      LUNI = 16
      MTYPE = 'MA'
      STAT = 'HDWR'
      IF ((DOTV) .AND. (DOSLIC.LE.0.0)) STAT = 'READ'
      CALL MAPOPN (STAT, DISKIN, NAMEIN, CLAIN, SEQIN, MTYPE, IUSER,
     *   LUNI, INDI, CNOIN, CATBLK, BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      NCFILE = 1
      FVOL(1) = DISKIN
      FCNO(1) = CNOIN
      FRW(1) = 1
      IF (STAT.EQ.'READ') FRW(1) = 0
C                                       Check number of planes
      IF (BLC(3).EQ.TRC(3)) THEN
         TRC(3) = 0
         BLC(3) = 0
         END IF
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IRET)
C                                       BOXes ?
      NBOXES = XNBOXS + 0.1
C                                       make 1
      IF (NBOXES.LE.0) THEN
         XNBOXS = 1.0
         NBOXES = 1
         BOX(1,1) = BLC(1)
         BOX(2,1) = BLC(2)
         BOX(3,1) = TRC(1)
         BOX(4,1) = TRC(2)
C                                       find range
      ELSE
         BLC(2) = CATBLK(KINAX+1)
         TRC(2) = 1.0
         DO 20 I = 1,NBOXES
C                                       circular
            IF (BOX(1,I).LT.0.0) THEN
               TRC(2) = MAX (TRC(2), BOX(4,I)+BOX(2,I))
               BLC(2) = MIN (BLC(2), BOX(4,I)-BOX(2,I))
            ELSE
               TRC(2) = MAX (TRC(2), BOX(4,I))
               BLC(2) = MIN (BLC(2), BOX(2,I))
               END IF
 20         CONTINUE
         END IF
      BLC(1) = 1.0
      TRC(1) = CATBLK(KINAX)
      BLC(2) = 1.0
      TRC(2) = CATBLK(KINAX+1)
C                                       check coordinates
      LOCNUM = 1
      CALL SETLOC (DEPTH, .TRUE.)
      CALL H2CHR (8, 1, CATH(KHBUN), UNITS)
      CALL CHLTOU (8, UNITS)
      TEMP = CATR(KRCIC) * CATR(KRCIC+1)
      CBAREA = 1.1331 * CATR(KRBMJ) * CATR(KRBMN)
      FLUXFL = (AXTYP(LOCNUM).EQ.1) .AND. (UNITS.EQ.'JY/BEAM') .AND.
     *   (TEMP.NE.0.0) .AND. (CBAREA.GT.0.0)
      IF (FLUXFL) THEN
         CBAREA = CBAREA / ABS (TEMP)
      ELSE
         CBAREA = 1.0
         END IF
C                                       Set the I/O windows used by
C                                       MINIT/MDISK
      IF (IRET.EQ.0) THEN
         WIN(1) = IROUND(BLC(1))
         WIN(2) = IROUND(BLC(2))
         WIN(3) = IROUND(TRC(1))
         WIN(4) = IROUND(TRC(2))
         END IF
C                                       Open printer
      IF (DOCRT.NE.0.0) THEN
         PAGE  = 0
         IPCNT = 980
         TITL1 = ' '
         TITL2 = ' '
         LINE  = ' '
         IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
         CALL LPOPEN (LPNAME, DOCRT, LUNP, FINDP, NACROS, BUFFER, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET
            IRET = 1
            GO TO 990
            END IF
         END IF
C                                       FQID axis?
      CALL H2CHR (8, 1, CATH(KHCTP+4), CTEMP)
      ISFQID = (CTEMP.EQ.'FQID') .OR. (DOXLOG.GT.0)
      IF (ISFQID) THEN
         CALL FRQGET (DISKIN, CNOIN, NFQ, ORDER, FRQS, IRET)
         IF ((IRET.NE.0) .OR. (ABS(ORDER).NE.1)) THEN
            MSGTXT = 'FQID AXIS NOT CHANGED TO FREQUENCIES'
            CALL MSGWRT (7)
            ISFQID = .FALSE.
         ELSE
            NZI = TRC(3) - BLC(3) + 1.1
            J = BLC(3) - 0.5
            DO 50 I = 1,NZI
               IF (DOXLOG.EQ.1) THEN
                  FRQS(I) = LOG10 (FRQS(I+J))
               ELSE
                  FRQS(I) = FRQS(I+J)
                  END IF
 50            CONTINUE
            IF (INVERT) THEN
               DO 60 I = 1,NZI/2
                  DTEMP = FRQS(I)
                  FRQS(I) = FRQS(NZI+1-I)
                  FRQS(NZI+1-I) = DTEMP
 60               CONTINUE
               END IF
            END IF
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ISPCIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1080 FORMAT ('ISPEC: ERROR ',I3,' OPENING OUTPUT ''PRINT'' DEVICE')
      END
      SUBROUTINE GETSPC (IRET)
C-----------------------------------------------------------------------
C   GETSPC fills up the plotting buffer with the spectrum to be plotted
C   this is then passed to the plotting routine via common.
C   Output:
C      IRET   I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER  NYI, NXI, NCOL, BOI, LIMO, LIM2, I1, I2, I3, IY, IB,
     *   IPOS(7), BOTEMP, IBIND
      REAL     R
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'ISPEC.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Setup for I/O
      NXI = CATBLK(KINAX)
      NYI = CATBLK(KINAX+1)
      NZI = TRC(3) - BLC(3) + 1.01
      CALL RFILL (NZI, 0.0, DBUFF)
      DSUM = 0.0
      FSUM = 0.0
      XSUM = 0.0
C                                       Setup for looping
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIMO = CATBLK(KINAX) - 1
      RANGE(1) = 1.0E20
      RANGE(2) = -1.0E20
C                                       Loop
      IPOS(7) = BLC(7) + 0.01
      IPOS(6) = BLC(6) + 0.01
      IPOS(5) = BLC(5) + 0.01
      IPOS(4) = BLC(4) + 0.01
      DO 300 I3 = 1,NZI
         IF (INVERT) THEN
            IPOS(3) = BLC(3) + NZI - I3 + 0.1
         ELSE
            IPOS(3) = BLC(3) + I3 - 0.9
            END IF
C                                       Init. files, first input.
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET
            GO TO 990
            END IF
         BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WIN, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'READ', IRET
            GO TO 990
            END IF
C                                       Sum pixels
         NGOOD = 0
         NCOL = TRC(1) - BLC(1) + 1
         DO 200 I2 = 1,LIM2
            IY = WIN(2) + I2 - 1
C                                       Read.
            CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'READ', IRET
               GO TO 990
               END IF
            DO 100 I1 = 1,NCOL
               DO 20 IB = 1,NBOXES
                  IF (BOX(1,IB).GT.0.0) THEN
                     IF ((I1.GE.BOX(1,IB)) .AND. (I1.LE.BOX(3,IB)) .AND.
     *                  (IY.GE.BOX(2,IB)) .AND. (I2.LE.BOX(4,IB))) THEN
                        IF (DOINV.GT.0.0) GO TO 100
                        GO TO 40
                        END IF
                  ELSE
                     R = SQRT ((I1-BOX(3,IB))**2 + (IY-BOX(4,IB))**2)
                     IF (R.LE.BOX(2,IB)) THEN
                        IF (DOINV.GT.0) GO TO 100
                        GO TO 40
                        END IF
                     END IF
 20               CONTINUE
               IF (DOINV.LE.0.0) GO TO 100
C                                       inside box
 40            IF (BUFF1(IBIND+I1-1).NE.FBLANK) THEN
                  DBUFF(I3) = DBUFF(I3) + BUFF1(IBIND+I1-1)
                  NGOOD = NGOOD + 1
                  END IF
 100           CONTINUE
 200        CONTINUE
C                                       check for blanked pixels
         IF (NGOOD.LE.0) THEN
            DBUFF(I3) = FBLANK
         ELSE
            FSUM = FSUM + DBUFF(I3) / CBAREA
            XSUM = XSUM + 1.0
            IF ((OPCODE.EQ.'FLUX') .OR. (OPCODE.EQ.'FDER')) THEN
               DBUFF(I3) = DBUFF(I3) / CBAREA
            ELSE
               DBUFF(I3) = DBUFF(I3) / NGOOD
               END IF
            DSUM = DSUM + DBUFF(I3)
            END IF
 300     CONTINUE
C                                       Close input map.
      CALL ZCLOSE (LUNI, INDI, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETSPC: COMOFF ERROR',I3)
 1100 FORMAT ('GETSPC: INIT-FOR-',A4,' ERROR',I3)
 1120 FORMAT ('GETSPC: ',A,' ERROR',I3)
      END
      SUBROUTINE PLTSCH (IRET)
C-----------------------------------------------------------------------
C   counts lines of print
C   Output:
C      IRET   I   Error code: 0 => okay - can change DOCRT to 0
C-----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'ISPEC.INC'
      CHARACTER CTEMP*20
      REAL      X
      INTEGER   I, NCOUNT, TTY(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF ((DOCRT.GE.0.0) .OR. (LPNAME.NE.' ')) GO TO 999
      MSGTXT = 'Checking count of lines for direct output to printer'
      CALL MSGWRT (2)
      NCOUNT = 0
C                                       Header line for printer
      IF (DOCRT.LE.-2.5) NCOUNT = NCOUNT + 2
C
      DO 30 I = 1,NZI,ZINC
C                                       For printer: fill LINE
         NCOUNT = NCOUNT + 1
 30      CONTINUE
C
      NCOUNT = NCOUNT + 3
C                                       ask if needed
      X = DOCRT
      DOCRT = 0.0
      IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) THEN
         IF (NCOUNT.GT.1000) THEN
            X = 0.0
            IPCNT = -1
            CALL LPCLOS (LUNP, FINDP, IPCNT, I)
            END IF
      ELSE IF (NCOUNT.GT.500) THEN
         TTY(1) = 5
         CALL ZOPEN (TTY(1), TTY(2), 1, SCRTCH, .FALSE., .FALSE.,
     *      .TRUE., IRET)
         MSGTXT = 'PROBLEM OPENING TERMINAL'
         IF (IRET.GT.0) GO TO 990
         WRITE (SCRTCH,1030) NCOUNT
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, IRET)
         MSGTXT = 'PROBLEM DOING IO TO TERMINAL'
         IF (IRET.GT.0) GO TO 990
         SCRTCH = 'Do you really want to print this much??' //
     *      ' Enter Y or y if so'
         CALL INQSTR (TTY, SCRTCH, 1, CTEMP, IRET)
         IF (IRET.GT.0) GO TO 990
         IF ((CTEMP(:1).NE.'y') .AND. (CTEMP(:1).NE.'Y')) THEN
            X = 0.0
            IPCNT = -1
            CALL LPCLOS (LUNP, FINDP, IPCNT, I)
            SCRTCH = 'Good choice - save trees'
         ELSE
            SCRTCH = 'OKAY, printing anyway'
            END IF
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, I)
         CALL ZCLOSE (TTY(1), TTY(2), I)
         END IF
      DOCRT = X
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('Requested print job is',I10,' lines long!')
      END
      SUBROUTINE PLTSPC (IRET)
C-----------------------------------------------------------------------
C   Routine which plots the contents of the DBUFF array, performs all
C   the labelling and closes down the PL file.
C   It will also write these data to the terminal, or the line printer,
C   or to an output file depending on the value of DOCRT. (GvM, 12/92).
C   Output:
C      IRET   I   Error code: 0 => okay
C-----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'ISPEC.INC'
      CHARACTER TEXT(3)*128, CTEMP*20, PLNAME*48, ATIME*8, ADATE*12,
     *   UNIT*8, SPRTXT*80
      REAL      CHOUT(4), PBLC(2), PTRC(2), XYRATI, SCALY, X, Y, OFY,
     *   DX, DY, XBLC(7), XTRC(7), RTEMP(2), YGAP, RANGE2(2), XSEP,
     *   SBUFF(MAXIMG), SMTAB(256), FQIDUM
      INTEGER   DEPTH(5), I, INCHAR, IPTYPE, ID(3), IT(3), NTEXT, J,
     *   ITEMP(2), IDROP(2), NCHAR, IROUND, IERR, ZPIX, IP, JTRIM
      HOLLERITH HTEMP(4)
      DOUBLE PRECISION DTEMP, INCR, RPIX, ZVAL, RVAL, DVAL, FQDUM
      LOGICAL   F, T, PENUP, PRINT, DOSMTH
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA T, F /.TRUE., .FALSE./
C-----------------------------------------------------------------------
      PRINT = DOCRT.NE.0.0
      FQIDUM = 0.0
      FQDUM = 0.0D0
C                                       Set up freq smoothing
      CALL SETSM (NZI, 256, XSMOTH, DOSMTH, SMTAB)
      CALL RCOPY (NZI, DBUFF, SBUFF)
      IF (DOSMTH) CALL SMOSP (NZI, XSMOTH, SMTAB, DBUFF, SBUFF)
      CALL SPADJ (NZI, DOLOG, FACTOR, OPCODE, SBUFF, RANGE)
C                                       Add plot file to CATBLK
      PVER = 0
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', DISKIN, CNOIN, CATBLK, BUFF1, T, 'READ',
     *      PVER, IRET)
         IF (IRET.EQ.0) THEN
            WRITE (MSGTXT,1000) PVER
            CALL MSGWRT (6)
            FRW(1) = 0
         ELSE
            WRITE (MSGTXT,1001) IRET
            GO TO 990
            END IF
         END IF
C                                       Generate the plot file name
      CALL ZPHFIL ('PL', DISKIN, CNOIN, PVER, PLNAME, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1005) IRET
         GO TO 990
         END IF
C                                       Open the plot file
      IF (PIXR(1).GE.PIXR(2)) THEN
         PIXR(1) = RANGE(1) - 0.02 * (RANGE(2) - RANGE(1))
         PIXR(2) = RANGE(2) + 0.02 * (RANGE(2) - RANGE(1))
         END IF
C                                       start on labeling as a slice
      XBLC(1) = BLC(3)
      XBLC(2) = BLC(4)
      XBLC(3) = (BLC(1) + TRC(1)) / 2.0
      XBLC(4) = (BLC(2) + TRC(2)) / 2.0
      XBLC(5) = BLC(5)
      XBLC(6) = BLC(6)
      XBLC(7) = BLC(7)
      CALL RCOPY (6, XBLC(2), XTRC(2))
      XTRC(1) = TRC(3)
      IDROP(1) = 0
      IDROP(2) = 0
C                                       swap axes 1,2 with 3,4
      CALL COPY (2, CATBLK(KINAX), ITEMP)
      CALL COPY (2, CATBLK(KINAX+2), CATBLK(KINAX))
      CALL COPY (2, ITEMP, CATBLK(KINAX+2))
      CALL RCOPY (4, CATH(KHCTP), HTEMP)
      CALL RCOPY (4, CATH(KHCTP+4), CATH(KHCTP))
      CALL RCOPY (4, HTEMP, CATH(KHCTP+4))
      CALL H2CHR (8, 1, CATH(KHBUN), UNIT)
      IF ((FLUXFL) .AND. (OPCODE.EQ.'FLUX')) UNIT = ' JY'
      IF ((FLUXFL) .AND. (OPCODE.EQ.'FDER')) UNIT = ' JY/ch'
      IF ((FLUXFL) .AND. (OPCODE.EQ.'ADER')) UNIT = 'JY/bm/ch'
      IF ((.NOT.FLUXFL) .AND. (OPCODE.EQ.'ADER')) UNIT(6:8) = '/ch'
      IF (DOLOG.EQ.1) THEN
         UNIT = ' LOG' // UNIT(:4)
      ELSE IF (DOLOG.EQ.2) THEN
         UNIT = ' LN ' // UNIT(:4)
         END IF
      CALL CHR2H (8, UNIT, 1, CATH(KHBUN))
      DTEMP = CATD(KDCRV)
      CATD(KDCRV) = CATD(KDCRV+2)
      CATD(KDCRV+2) = DTEMP
      DTEMP = CATD(KDCRV+1)
      CATD(KDCRV+1) = CATD(KDCRV+3)
      CATD(KDCRV+3) = DTEMP
      CALL RCOPY (2, CATR(KRCIC), RTEMP)
      CALL RCOPY (2, CATR(KRCIC+2), CATR(KRCIC))
      CALL RCOPY (2, RTEMP, CATR(KRCIC+2))
      CALL RCOPY (2, CATR(KRCRP), RTEMP)
      CALL RCOPY (2, CATR(KRCRP+2), CATR(KRCRP))
      CALL RCOPY (2, RTEMP, CATR(KRCRP+2))
      CALL RCOPY (2, CATR(KRCRT), RTEMP)
      CALL RCOPY (2, CATR(KRCRT+2), CATR(KRCRT))
      CALL RCOPY (2, RTEMP, CATR(KRCRT+2))
C                                       boxcar smooth issue
      IF (XSMOTH(1).EQ.3.0) THEN
         J = XSMOTH(2) + 0.1
         IF (MOD(J,2).EQ.0) CATR(KRCRP) = CATR(KRCRP) - 0.5 / J
         END IF
      IF (INVERT) THEN
         CATR(KRCIC) = -CATR(KRCIC)
         CATR(KRCRP) = TRC(3) + BLC(3) - CATR(KRCRP)
         END IF
      IF ((ISFQID) .AND. (LABEL.EQ.3)) THEN
         CATD(KDCRV) = FRQS(1)
         CATR(KRCRP) = BLC(3)
         CATR(KRCIC) = (FRQS(NZI)-FRQS(1)) / (NZI - 1)
         CALL CHR2H (8, 'FREQ    ', 1, CATH(KHCTP))
         IF (DOXLOG.GT.0) CALL CHR2H (8, 'LOG FREQ', 1, CATH(KHCTP))
         END IF
      RVAL  = CATD(KDCRV)
      RPIX  = CATR(KRCRP)
      INCR  = CATR(KRCIC)
C                                       init SL plot
      CATR(IRRAN) = PIXR(1)
      CATR(IRRAN+1) = PIXR(2)
      SCALY = 39999.0 / (PIXR(2) - PIXR(1))
      OFY = 40000.0 - SCALY * PIXR(2)
      RANGE2(1) = SCALY * PIXR(1) + OFY
      RANGE2(2) = SCALY * PIXR(2) + OFY
      PBLC(2) = RANGE2(1)
      PTRC(2) = RANGE2(2)
      LOCNUM = 1
      CALL RFILL (4, 0.0, CHOUT)
      YGAP = 0.0
      CALL SLBINI (IDROP, NZI, PIXR, PBLC, PTRC, XBLC, XTRC, FQDUM,
     *   FQIDUM, DEPTH, LTYPE, YGAP, CHOUT, TEXT, NTEXT)
      PBLC(1) = PBLC(1) * 10 - 5
      PTRC(1) = PTRC(1) * 10 + 5
      RPLOC(1,LOCNUM) = RPLOC(1,LOCNUM) * 10.0
      AXINC(1,LOCNUM) = AXINC(1,LOCNUM) / 10.0
C                                       display window
      CHOUT(2) = CHOUT(2) - NTEXT * 1.333
      NTEXT = 1
      IF (LABEL.GT.3) NTEXT = 2
      IF ((DOSMTH) .OR. (FACTOR.NE.1.0)) NTEXT = NTEXT + 1
      IF (LABEL.GT.6) NTEXT = 0
      CHOUT(2) = CHOUT(2) + NTEXT * 1.333
      IDROP(1) = IROUND (BOX(1,1))
      IDROP(2) = IROUND (BOX(3,1))
      ITEMP(1) = IROUND (BOX(2,1))
      ITEMP(2) = IROUND (BOX(4,1))
      IF (NTEXT.GT.0) THEN
         IP = 1
         IF (DOLOG.EQ.1) THEN
            CTEMP = 'LOG'
            IP = 5
         ELSE IF (DOLOG.EQ.2) THEN
            CTEMP = 'LN'
            IP = 4
            END IF
         IF (OPCODE.EQ.'FLUX') THEN
            CTEMP(IP:) = 'Sum'
         ELSE IF (OPCODE.EQ.'FDER') THEN
            CTEMP(IP:) = 'Diff(sum)'
         ELSE IF (OPCODE.EQ.'ADER') THEN
            CTEMP(IP:) = 'Diff(avg)'
         ELSE
            CTEMP(IP:) = 'Average'
            END IF
         IP = JTRIM (CTEMP)
         IF (DOINV.LE.0.0) THEN
            CTEMP(IP+2:) = 'over'
         ELSE
            CTEMP(IP+2:) = 'outside'
            END IF
         IP = JTRIM (CTEMP)
         J = NTEXT
         IF ((DOSMTH) .OR. (FACTOR.NE.1.0)) J = J - 1
         IF (IDROP(1).GT.0) THEN
            WRITE (TEXT(J),1008) CTEMP(:IP), IDROP, ITEMP
         ELSE
            WRITE (TEXT(J),1012) CTEMP(:IP), IDROP(2), ITEMP(2),
     *         ITEMP(1)
            END IF
         IF (NBOXES.GT.1) THEN
            IP = JTRIM (TEXT(J)) + 1
            IF (NBOXES.GT.2) THEN
               WRITE (TEXT(J)(IP:),1013) NBOXES-1
            ELSE
               IDROP(1) = IROUND (BOX(1,2))
               IDROP(2) = IROUND (BOX(3,2))
               ITEMP(1) = IROUND (BOX(2,2))
               ITEMP(2) = IROUND (BOX(4,2))
               IF (IDROP(1).GT.0) THEN
                  WRITE (TEXT(J)(IP:),2008) IDROP, ITEMP
               ELSE
                  WRITE (TEXT(J)(IP:),2012) IDROP(2), ITEMP(2), ITEMP(1)
                  END IF
               END IF
            END IF
         CALL REFRMT (TEXT(J), '__', IP)
         IF ((DOSMTH) .OR. (FACTOR.NE.1.0)) THEN
            IF ((DOSMTH) .AND. (FACTOR.NE.1.0)) THEN
               WRITE (TEXT(NTEXT),1010) XSMOTH, FACTOR
            ELSE IF (DOSMTH) THEN
               WRITE (TEXT(NTEXT),1009) XSMOTH
            ELSE
               WRITE (TEXT(NTEXT),1011) FACTOR
               END IF
            END IF
         END IF
C                                       init plot file
      IPTYPE = 20
      CALL GINIT (DISKIN, CNOIN, PLNAME, 0, IPTYPE, NPARM, USERID,
     *   DOTV, TVCHN, GRCHN, TVCORN, CATBLK, PLBUFF, GLUN, GFIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1014) IRET
         GO TO 990
         END IF
      IF (GR2CHN.GT.0) GPHTVG(1) = GR2CHN + NGRAY
C                                       init line drawing
      XYRATI = (PTRC(2) - PBLC(2)) / (PTRC(1) - PBLC(1)) * XYRATO
      CALL GINITL (PBLC, PTRC, XYRATI, CHOUT, DEPTH, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GLTYPE (1, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                        Draw the box
      CALL GPOS (PBLC(1), PBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (PTRC(1), PBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (PTRC(1), PTRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (PBLC(1), PTRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (PBLC(1), PBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                       More labeling: x,y coords
      IF ((LABEL.GT.1) .AND. (LABEL.LT.7)) THEN
         CALL GPOS (PBLC(1), PTRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 980
         DX = 0.0
         DY = 0.5
         CALL H2CHR (8, 1, CATH(KHOBJ), SPRTXT)
         INCHAR = 12
         IF (SPRTXT.EQ.' ') INCHAR = 1
         IF (NCHLAB(1,LOCNUM).GT.0) THEN
            IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
            SPRTXT(INCHAR:) = SAXLAB(1,LOCNUM)(:NCHLAB(1,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(1,LOCNUM)
            END IF
         IF (NCHLAB(2,LOCNUM).GT.0) THEN
            IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
            SPRTXT(INCHAR:) = SAXLAB(2,LOCNUM)(:NCHLAB(2,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(2,LOCNUM)
            END IF
C                                       image name
         IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
         CALL H2CHR (18, 1, CATH(KHIMN), CTEMP)
         CALL NAMEST (CTEMP, CATBLK(KIIMS), SPRTXT(INCHAR:), NCHAR)
         CALL REFRMT (SPRTXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, SPRTXT, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 980
         TITL1 = SPRTXT
C                                       Date/time, version number
         IF (LTYPE.GT.1) THEN
            CALL GPOS (PBLC(1), PTRC(2), PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 980
            DY = DY + 1.333
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (SPRTXT,1015) PVER, ADATE, ATIME
            CALL REFRMT (SPRTXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, SPRTXT, PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 980
            END IF
C                                       Text at bottom
         IF (NTEXT.GT.0) THEN
            DX = 0.
            DY = -YGAP
            DO 20 I = 1,NTEXT
               CALL GPOS (PBLC(1), PBLC(2), PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 980
               CALL CHTRIM (TEXT(I), 80, TEXT(I), INCHAR)
               CALL GCHAR (INCHAR, 0, DX, DY, TEXT(I), PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 980
               DY = DY - 1.333
 20            CONTINUE
            END IF
         END IF
C                                       Axis labels and ticks
      CALL CLAB1 (PBLC, PTRC, CHOUT, LTYPE, XYRATI, F, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                       Header line for printer
      IF (PRINT) THEN
         LINE(1:)   = 'pixel'
         LINE(10:)  = 'coord.value '
         IP = 28
         IF (DOLOG.EQ.1) THEN
            LINE(IP:) = 'LOG'
            IP = 32
         ELSE IF (DOLOG.EQ.2) THEN
            LINE(IP:) = 'LN'
            IP = 31
            END IF
         IF (OPCODE.EQ.'FLUX') THEN
            LINE(IP:) = 'sum over area'
         ELSE IF (OPCODE.EQ.'FDER') THEN
            LINE(IP:) = 'diff(sum over area)'
         ELSE IF (OPCODE.EQ.'ADER') THEN
            LINE(IP:) = 'diff(avg over area)'
         ELSE
            LINE(IP:) = 'avg over area'
            END IF
         IF (DOSMTH) LINE(45:) = '  freq smoothed'
         TITL2 = LINE
         IF (DOCRT.LE.-2.5) THEN
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         TITL1, IPCNT, PAGE, SCRTCH, IRET)
            PRINT = IRET.EQ.0
            IF (PRINT) THEN
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            TITL2, IPCNT, PAGE, SCRTCH, IRET)
               PRINT = IRET.EQ.0
               END IF
            END IF
         END IF
C                                       Plot intensities
      CALL GLTYPE (2, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      PENUP = .TRUE.
      XSEP = 0.0
      IF (DOCENT.GT.0.0) XSEP = ZINC / 2.0
      DO 30 I = 1,NZI,ZINC
         IF (SBUFF(I).EQ.FBLANK) THEN
            PENUP = .TRUE.
            CTEMP = '   undefined   '
         ELSE
            Y = MAX (PIXR(1), MIN (PIXR(2), SBUFF(I))) * SCALY + OFY
            X = MAX (PBLC(1), (I-XSEP)*10)
            IF (ISFQID) THEN
               DVAL = (FRQS(I) - RVAL) / INCR + 1.0D0
               X = (DVAL - XSEP) * 10.0
               X = MAX (PBLC(1), X)
               END IF
            IF (PENUP) THEN
               CALL GPOS (X, Y, PLBUFF, IRET)
               PENUP = .FALSE.
            ELSE
               CALL GVEC (X, Y, PLBUFF, IRET)
               END IF
            IF (IRET.NE.0) GO TO 980
            IF (DOCENT.GT.0.0) THEN
               X = MIN (PTRC(1), (I+XSEP)*10)
               IF (ISFQID) THEN
                  IF (I+ZINC.LE.NZI) THEN
                     DTEMP = (FRQS(I+ZINC)-RVAL) / INCR + 1.0D0
                     XSEP = (DTEMP - DVAL) / 2.0D0
                     END IF
                  X = (DVAL + XSEP) * 10.0
                  X = MIN (PTRC(1), X)
                  END IF
               CALL GVEC (X, Y, PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 980
               END IF
            END IF
C                                       For printer: fill LINE
         IF (PRINT) THEN
            ZPIX = NINT (BLC(3) + I - 1)
            ZVAL = (ZPIX - RPIX) * INCR + RVAL
            IF (ISFQID) ZVAL = FRQS(I)
            IF (INVERT) ZPIX = NINT (TRC(3) - I + 1)
            WRITE (LINE,1020) ZPIX, ZVAL, DBUFF(I), SBUFF(I)
            IF (DBUFF(I).EQ.FBLANK) LINE(26:40) = '  undefined  '
            IF (SBUFF(I).EQ.FBLANK) LINE(43:57) = '  undefined  '
            IF (.NOT.DOSMTH) LINE(43:) = ' '
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         LINE, IPCNT, PAGE, SCRTCH, IRET)
            PRINT = IRET.EQ.0
            END IF
 30      CONTINUE
      IF (PRINT) THEN
         WRITE (LINE,1030) DSUM
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, IPCNT, PAGE, SCRTCH, IRET)
         IF (OPCODE.NE.'FLUX') THEN
            WRITE (LINE,1031) FSUM
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         LINE, IPCNT, PAGE, SCRTCH, IRET)
            END IF
         WRITE (LINE,1032) XSUM
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, IPCNT, PAGE, SCRTCH, IRET)
      ELSE
         WRITE (MSGTXT,1030) DSUM
         CALL MSGWRT (5)
         WRITE (MSGTXT,1031) FSUM
         IF (OPCODE.NE.'FLUX') CALL MSGWRT (5)
         WRITE (MSGTXT,1032) XSUM
         CALL MSGWRT (5)
         END IF
C                                       Finish up
      CALL GFINIS (PLBUFF, IRET)
      IF (.NOT.DOTV) CALL HIPLOT (DISKIN, CNOIN, PVER, BUFF1, IERR)
      GO TO 999
C                                       Plot error - try partial
 980  WRITE (MSGTXT,1980) IRET
      CALL MSGWRT (7)
      CALL GFINIS (PLBUFF, IERR)
      IF (IERR.EQ.0) THEN
         IRET = 0
      ELSE
         IF (.NOT.DOTV) THEN
            CALL ZCLOSE (GLUN, GFIND, IERR)
            CALL ZDESTR (DISKIN, PLNAME, IERR)
            END IF
         END IF
      IF ((IRET.NE.0) .AND. (.NOT.DOTV)) CALL DELEXT ('PL', DISKIN,
     *   CNOIN, 'READ', CATBLK, PLBUFF, PVER, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Created plot file version ', I4)
 1001 FORMAT ('PLTSPC: MADDEX ERROR ',I3)
 1005 FORMAT ('PLTSPC: ZPHFIL ERROR ',I3)
 1008 FORMAT (A,' area in X:',2I5,'   in Y:',2I5)
 1009 FORMAT ('Freq smoothing parms:',F3.0,F5.2,F5.1)
 1010 FORMAT ('Freq smoothing parms:',F3.0,F5.2,F5.1,'  Scale factor',
     *   F9.4)
 1011 FORMAT ('Scale factor',F9.4)
 1012 FORMAT (A,' area centered at',2I5,' radius',I3)
 1013 FORMAT ('__plus',I3,' more boxes')
 2008 FORMAT ('__plus area in X:',2I5,'   in Y:',2I5)
 2012 FORMAT ('__plus area centered at',2I5,' radius',I3)
 1014 FORMAT ('PLTSPC: GINIT ERROR ',I3)
 1015 FORMAT ('Plot file version',I4,'__created ',A12,A8)
 1020 FORMAT (I5,2X,1PE16.8,2(2X,1PE15.7))
 1030 FORMAT ('Sum of plotted points',1PE15.7)
 1031 FORMAT ('Sum of FLUX          ',1PE15.7)
 1032 FORMAT ('Number non-blank pts ',F7.0)
 1980 FORMAT ('ERROR ',I5,' PLOTTING - TRY TO FINISH PARTIAL GRAPH')
      END
      SUBROUTINE SETSM (NCH, MAXSMO, SMOOTH, DOSMTH, SMTAB)
C-----------------------------------------------------------------------
C   SETSM determines the type of spectral smoothing to be applied and
C   sets up the look up table to do it. The actual smoothing is done in
C   routine SMOSP
C   Inputs:
C      NCH      I      Number samples on axis being smoothed
C      MAXSMO   I      Dimension of SMTAB
C      SMOOTH   R(3)   Array containing smoothing parms
C                         SMOOTH(1) = type of function
C                               (2) = width of function in channels
C                               (3) = support of function in channels
C                         Type of function supported are:
C                            0 => no smoothing
C                            1 => hanning
C                            2 => gaussian
C                            3 => boxcar
C                            4 => sin(x)/x
C   Output:
C      DOSMTH   L      T => do smoothing
C-----------------------------------------------------------------------
      INTEGER   NCH, MAXSMO
      REAL      SMOOTH(3), SMTAB(*)
      LOGICAL   DOSMTH
C
      INTEGER   I, N, LSPECT, IROUND, IT, SUPRAD
      REAL      FX, X, W, WIDTHS(4), SUPS(4)
      DATA WIDTHS /4.0, 2.0, 2.0, 3.0/
      DATA SUPS /1.0, 3.0, 1.0, 4.0/
C-----------------------------------------------------------------------
      DOSMTH = .FALSE.
      IT = IROUND (SMOOTH(1))
      IF (IT.LE.0) GO TO 999
      DOSMTH = .TRUE.
C                                       Convolution: parms & tables
      IT = MOD (IT-1, 4) + 1
      SMOOTH(1) = IT
      LSPECT = MAX (12, NCH)
      IF ((SMOOTH(2).LT.0.5) .OR. (SMOOTH(2).GT.LSPECT/3.))
     *   SMOOTH(2) = WIDTHS(IT)
      IF ((SMOOTH(3).GT.4.*SUPS(IT)*SMOOTH(2)) .OR.
     *   (SMOOTH(3).LT.SMOOTH(2)))SMOOTH(3) = SUPS(IT) * SMOOTH(2)
      SUPRAD = SMOOTH(3) / 2.0 + 0.1
      IF (SUPRAD+1.GT.MAXSMO) THEN
         SUPRAD = MAXSMO - 1
         SMOOTH(2) = (2. * SUPRAD) / SUPS(IT)
         END IF
      SMOOTH(3) = 2.0 * SUPRAD + 1.0
      CALL RFILL (MAXSMO, 0.0, SMTAB)
      N = 1 + SUPRAD
      FX = 2.0 / SMOOTH(2)
      SMTAB(1) = 1.0
C                                       Compute look-up tables
      W = SMTAB(1)
C                                       Hanning smooth
      IF (IT.EQ.1) THEN
         DO 20 I = 2,N
            X = I - 1.0
            SMTAB(I) = MAX (0.0, 1.0-FX*X)
            W = W + 2 * SMTAB(I)
 20         CONTINUE
C                                       Gaussian smooth
      ELSE IF (IT.EQ.2) THEN
         FX = -LOG(2.0) * FX * FX
         DO 30 I = 2,N
            X = I - 1.0
            SMTAB(I) = EXP (FX * X * X)
            W = W + 2 * SMTAB(I)
 30         CONTINUE
C                                       Boxcar smooth
      ELSE IF (IT.EQ.3) THEN
         CALL RFILL (N, 1.0, SMTAB)
         W = N
C                                      Sinc smooth
      ELSE IF (IT.EQ.4) THEN
         FX = 3.14159 * FX
         DO 50 I = 2,N
            X = (I - 1.0) * FX
            SMTAB(I) = SIN(X) / X
            W = W + 2 * SMTAB(I)
 50         CONTINUE
         END IF
C                                       Normalize integral
      IF (W.LE.0.0) W = 1.0
      DO 70 I = 1,N
         SMTAB(I) = SMTAB(I) / W
 70      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SMOSP (NCH, SMOOTH, SMTAB, SPCI, SPCO)
C-----------------------------------------------------------------------
C   SMOSP convolves an input spectrum with a convolving look up table
C   established in common.
C   Values from commons:
C      SMTAB    R(MAXSMO)   Convolution look-up table
C      SMOOTH   R(3)        (3) = 2*support-radius + 1
C      BCHANS   I           Start channel for smoothing
C      ECHANS   I           Stop channel for smoothing
C      SPCI     R(*)        Spectrum
C   Output:
C      RANGE    R(2)        new intensity range
C      SPCO     R(*)        Spectrum smoothed
C-----------------------------------------------------------------------
      REAL      SMOOTH(3), SMTAB(*), SPCI(*), SPCO(*)
      INTEGER   NCH
C
      INTEGER   J, J1, J2, L, IFRQ, SUPRL, SUPRH
      REAL      S, W
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      SUPRL = (SMOOTH(3) - 0.9) / 2.0
      SUPRH = (SMOOTH(3) - 0.9) / 2.0
      IF (SMOOTH(1).EQ.3.) THEN
         J = SMOOTH(2) + 0.1
         SUPRL = (J - 1) / 2
         SUPRH = J - 1 - SUPRL
         END IF
C                                       Convolve the data
      DO 30 IFRQ = 1,NCH
         J1 = MAX (IFRQ - SUPRL, 1)
         J2 = MIN (IFRQ + SUPRH, NCH)
         S = 0.0
         W = 0.0
         DO 20 J = J1,J2
            IF (SPCI(J).NE.FBLANK) THEN
               L = ABS(IFRQ-J) + 1
               S = SPCI(J) * SMTAB(L) + S
               W = SMTAB(L) + W
               END IF
 20         CONTINUE
         IF (W.GT.0.0) THEN
            SPCO(IFRQ) = S / W
         ELSE
            SPCO(IFRQ) = FBLANK
            END IF
 30      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SPADJ (NCH, DOLOG, FACTOR, OPCODE, SPCI, RANGE)
C-----------------------------------------------------------------------
C   SPADJ adjusts spectrum to make LOG, LN, or xDER functions
C   Inputs:
C      NCH     I      Number channels
C      DOLOG   I      0 no log, 1 log10, 2 natural log
C      OPCODE  C*4    'FDER', 'ADER' do derivative
C   In/out:
C      SPCI    R(*)   spectrum
C   Output
C      RANGE   R(2)   spectrum data range
C-----------------------------------------------------------------------
      INTEGER   NCH, DOLOG
      CHARACTER OPCODE*4
      REAL      FACTOR, SPCI(*), RANGE(2)
C
      INTEGER   I
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      RANGE(1) = 1.E20
      RANGE(2) = -1.E20
C                                       derivative
      IF (OPCODE(2:4).EQ.'DER') THEN
         IF (FACTOR.EQ.0.0) FACTOR = 1.0
         DO 20 I = 1,NCH-1
            IF ((SPCI(I).EQ.FBLANK) .OR. (SPCI(I+1).EQ.FBLANK)) THEN
               SPCI(I) = FBLANK
            ELSE
               SPCI(I) = FACTOR * (SPCI(I+1) - SPCI(I))
               RANGE(1) = MIN (SPCI(I), RANGE(1))
               RANGE(2) = MAX (SPCI(I), RANGE(2))
               END IF
 20         CONTINUE
         SPCI(NCH) = FBLANK
C                                       non-derivative
      ELSE
         DO 30 I = 1,NCH
            IF (SPCI(I).NE.FBLANK) THEN
               IF (DOLOG.EQ.1) THEN
                  IF (SPCI(I).LE.0.0) THEN
                     SPCI(I) = FBLANK
                  ELSE
                     SPCI(I) = LOG10 (SPCI(I))
                     END IF
               ELSE IF (DOLOG.EQ.2) THEN
                  IF (SPCI(I).LE.0.0) THEN
                     SPCI(I) = FBLANK
                  ELSE
                     SPCI(I) = LOG (SPCI(I))
                     END IF
                  END IF
               END IF
            IF (SPCI(I).NE.FBLANK) THEN
               RANGE(1) = MIN (SPCI(I), RANGE(1))
               RANGE(2) = MAX (SPCI(I), RANGE(2))
               END IF
 30         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE SLISPC (IRET)
C-----------------------------------------------------------------------
C   SLISPC writes the fit spectrum as a SL file
C   Output:
C      IRET   I   > 0 => serious error
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'ISPEC.INC'
      CHARACTER SFILE*48
      INTEGER   ISLDAT(512), IVER, NREC, SLUN, SIND, LREC, IPT, IERR,
     *   LNZI, NG(MAXIMG), NB(MAXIMG), IN, OUT
      REAL      RSLDAT(512), RMIN, RMAX, FQFINC, RTEMP(23)
      DOUBLE PRECISION DSLDAT(256), FR, FW, F
      REAL      LBUFF(MAXIMG), SB(MAXIMG), WT(MAXIMG), W
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (USERID, RTEMP)
      EQUIVALENCE (ISLDAT, RSLDAT, DSLDAT)
      DATA SLUN /45/
C-----------------------------------------------------------------------
      CALL FNDEXT ('SL', CATBLK, IVER)
      IVER = IVER + 1
      CALL FILL (256, 0, ISLDAT)
      LREC = 256
      LNZI = NZI
      IF (ISFQID) LNZI = 4 * NZI - 3
      NREC = (LNZI - 1) / 256 + 2
C                                       create
      CALL EXTINI ('WRIT', 'SL', DISKIN, CNOIN, IVER, CATBLK, SLUN,
     *   SIND, LREC, NREC, ISLDAT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATE', IVER
         GO TO 995
         END IF
C                                       update record 1
      CALL ZFIO ('READ', SLUN, SIND, 1, ISLDAT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ 1', IVER
         GO TO 990
         END IF
      ISLDAT(57) = LNZI
      ISLDAT(58) = 0
      ISLDAT(59) = ISLDAT(1) + 1
      CALL ZFIO ('WRIT', SLUN, SIND, 1, ISLDAT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE 1', IVER
         GO TO 990
         END IF
C                                       inputs/parms in 2nd record
      CALL FILL (256, 0, ISLDAT)
      CALL CHR2H (6, TSKNAM, 1, RSLDAT(1))
      CALL ZDATE (ISLDAT(4))
      CALL ZTIME (ISLDAT(7))
      ISLDAT(10) = 23
      IF (INVERT) THEN
         RMIN = BLC(3)
         RMAX = TRC(3)
         BLC(3) = RMAX
         TRC(3) = RMIN
         END IF
      CALL RCOPY (23, RTEMP, RSLDAT(11))
      IF (INVERT) THEN
         BLC(3) = RMIN
         TRC(3) = RMAX
         END IF
C                                       RSLDAT = XOPTYP
      DO 10 IPT = 1,LNZI
         LBUFF(IPT) = DBUFF(IPT)
         IF (LBUFF(IPT).NE.FBLANK) THEN
            IF (DOLOG.EQ.1) THEN
               LBUFF(IPT) = 10.0 ** LBUFF(IPT)
            ELSE IF (DOLOG.EQ.2) THEN
               LBUFF(IPT) = EXP (LBUFF(IPT))
               END IF
            END IF
 10      CONTINUE
C                                       FQID?
      IF (ISFQID) THEN
         DSLDAT(19) = FRQS(1)
         FQFINC = (FRQS(NZI) - FRQS(1)) / (LNZI - 1)
         RSLDAT(36) = FQFINC
         END IF
C                                       FQID interpolate
      IF (ISFQID) THEN
         CALL RFILL (LNZI, 0.0, SB)
         CALL RFILL (LNZI, 0.0, WT)
         CALL FILL (LNZI, 0, NG)
         CALL FILL (LNZI, 0, NB)
         FW = 2.5D0 * FQFINC
C                                       convolve
         DO 30 IN = 1,NZI
            FR = FRQS(IN)
            F = FRQS(1) - FQFINC
            DO 20 OUT = 1,LNZI
               F = F + FQFINC
               W = ((FR - F) / FW) ** 2
               IF (W.LT.10.D0) THEN
                  IF (LBUFF(IN).NE.FBLANK) THEN
                     W = EXP(-W)
                     WT(OUT) = WT(OUT) + W
                     SB(OUT) = SB(OUT) + W * LBUFF(IN)
                     NG(OUT) = NG(OUT) + 1
                  ELSE
                     NB(OUT) = NB(OUT) + 2
                     END IF
                  END IF
 20            CONTINUE
 30         CONTINUE
C                                       average
         DO 40 OUT = 1,LNZI
            IF ((WT(OUT).GT.0.0) .AND. (NB(OUT).LT.NG(OUT))) THEN
               LBUFF(OUT) = SB(OUT) / WT(OUT)
            ELSE
               LBUFF(OUT) = FBLANK
               END IF
 40         CONTINUE
         END IF
C                                       RSLDAT = XOPTYP
C                                       min/max
      RMIN = 1.E12
      RMAX = -RMIN
      DO 50 IPT = 1,LNZI
         IF (LBUFF(IPT).NE.FBLANK) THEN
            RMAX = MAX (RMAX, LBUFF(IPT))
            RMIN = MIN (RMIN, LBUFF(IPT))
            END IF
 50      CONTINUE
      RSLDAT(34) = RMIN
      RSLDAT(35) = RMAX
C                                       finally write 2nd record
      CALL ZFIO ('WRIT', SLUN, SIND, 2, ISLDAT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE 2', IVER
         GO TO 990
         END IF
C                                       write the data
      NREC = 2
      IPT = 1
 100  LREC = LNZI + 1 - IPT
      IF (LREC.GT.0) THEN
         LREC = MIN (LREC, 256)
         CALL RCOPY (LREC, LBUFF(IPT), RSLDAT)
         NREC = NREC + 1
         CALL ZFIO ('WRIT', SLUN, SIND, NREC, ISLDAT, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE DATA', IVER
            GO TO 990
            END IF
         IPT = IPT + LREC
         IF (IPT.LE.LNZI) GO TO 100
         END IF
C                                       close
      CALL ZCLOSE (SLUN, SIND, IRET)
C                                       Slice file created message.
      WRITE (MSGTXT,1020) IVER
      CALL MSGWRT (3)
      GO TO 999
C                                       destroy SL file
 990  CALL MSGWRT (8)
      CALL ZCLOSE (SLUN, SIND, IERR)
      CALL ZPHFIL ('SL', DISKIN, CNOIN, IVER, SFILE, IERR)
      CALL ZDESTR (DISKIN, SFILE, IERR)
      CALL DELEXT ('SL', DISKIN, CNOIN, 'WRIT', CATBLK, ISLDAT, IVER,
     *   IERR)
      GO TO 999
C
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' ON ',A,' SL VERS',I5)
 1020 FORMAT ('SLice file version ',I5,' created.')
      END

LOCAL INCLUDE 'BSMOD.INC'
C                                       Local include for BSMOD
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMOU(3), XCLAOU(2), XOPTYP(1), XDATE(2), XOBJ(2)
      REAL      XSOUT, XDISO, XGAUSS, GMAX(4), GPOS(2,4), GWID(3,4),
     *   CPARM(10), APARM(10), FLUX, BPARM(10), BUFF1(UVBFSS),
     *   BUFF2(UVBFSS), DFJ(4,2), DFN(4,2), DMAX(4,2), DDX(4,2),
     *   DDC(4,2), DDY(4,2), THROW, PCATR(256)
      INTEGER   SEQO1, DISKO, JBUFSZ, INCSO, INCFO, INCIFO, LRECO,
     *   NRPRMO, NGAUSS, PCAT(256), MCAT(256)
      LOGICAL   ISCOMP, ISFREQ, FIXRA, FIXDEC
      CHARACTER NAMOUT*12, CLAOUT*6, OPTYPE*4, REFDAT*8, OBJECT*8
      DOUBLE PRECISION PCATD(128)
      EQUIVALENCE (PCAT, PCATR, PCATD)
      COMMON /INPARM/ XNAMOU, XCLAOU, XSOUT, XDISO, XOPTYP, XGAUSS,
     *   GMAX, GPOS, GWID, CPARM, APARM, FLUX, BPARM, XDATE, XOBJ
      COMMON /SDMODC/ PCAT, MCAT, SEQO1, DISKO, INCSO, INCFO, INCIFO,
     *   LRECO, NRPRMO, ISCOMP, NGAUSS, DFJ, DFN, DMAX, DDX, DDC, DDY,
     *   ISFREQ, THROW, FIXRA, FIXDEC
      COMMON /CHARPM/ NAMOUT, CLAOUT, OPTYPE, REFDAT, OBJECT
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
C                                       End local include for BSMOD
LOCAL END
      PROGRAM BSMOD
C-----------------------------------------------------------------------
C! Models beam-switched continuum data
C# Modeling singledish
C-----------------------------------------------------------------------
C;  Copyright (C) 1999-2000, 2009, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BSMOD adds a model to single-dish uv data or replaces the data with
C   the model plus noise.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQO1         Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      NGAUSS         XGAUSS        Number gaussian components
C      GMAX           GMAX          Peak value
C      GPOS           GPOS          Ra, dec offsets
C      GWIDTH         GWIDTH        major, minor, pa
C      FLUX           FLUX          < 0 -> add model in to data
C                                   >= 0 replace data with model +
C                                   noise w rms = FLUX
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'BSMOD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA PRGM /'BSMOD '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL SDMOIN (PRGM, IRET)
C                                       Call routine that alters data
      IF (IRET.EQ.0) CALL SDMOUV (IRET)
C                                       history
      IF (IRET.EQ.0) CALL SDMOHI
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE SDMOIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   SDMOIN gets input parameters for BSMOD and creates output UV files
C   Inputs:
C      PRGN    C*6     Program name
C   Output:
C      IRET    I       Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      CHARACTER BLANK*12, CTYPE(5)*8, RTYPE(6)*8, CTEMP*8
      INTEGER   I, J, IROUND, NPARM, IERR, INCX, LOCS, KEYTYP
      REAL      OBST(4)
      LOGICAL   T
      INCLUDE 'BSMOD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA BLANK  /' '/
      DATA T /.TRUE./
      DATA RTYPE /'AZ---REL', 'EL---REL', 'TIME1', 'BEAM', 'SCAN',
     *   'SAMPLE'/
      DATA CTYPE /'COMPLEX', 'STOKES', 'FREQ', 'RA', 'DEC'/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
C                                       Get input parameters.
      NPARM = 68
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMOU, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      CALL H2CHR (8, 1, XDATE, REFDAT)
      CALL H2CHR (8, 1, XOBJ, OBJECT)
      IF (NAMOUT.EQ.' ') NAMOUT = OBJECT
      IF (REFDAT.EQ.' ') REFDAT = '20000101'
      SEQO1 = IROUND (XSOUT)
      DISKO = IROUND (XDISO)
      NGAUSS = XGAUSS + 0.5
      IF (NGAUSS.LT.1) THEN
         MSGTXT = 'MODEL REQUIRED'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      IF (BPARM(1).LE.0.0) THEN
         MSGTXT = 'BPARM(1)=THROW REQUIRED'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      IF (ABS(BPARM(2)).LE.0.1) BPARM(2) = 1
      IF (BPARM(5).LE.0.1) BPARM(5) = 1
      IF (BPARM(6).LE.0.1) BPARM(6) = 1
C                                       Create new file from scratch
      CALL CATINI (CATBLK)
      CATBLK(KIPCN) = 6
      DO 10 I = 1,6
         J = KHPTP + (I-1) * 2
         CALL CHR2H (8, RTYPE(I), 1, CATH(J))
 10      CONTINUE
      CATBLK(KIDIM) = 5
      DO 20 I = 1,5
         J = KHCTP + (I-1) * 2
         CALL CHR2H (8, CTYPE(I), 1, CATH(J))
 20      CONTINUE
      CATBLK(KINAX) = 3
      CATBLK(KINAX+2) = 3
      CATD(KDCRV) = 1.0D0
      CATD(KDCRV+1) = 1.0D0
C                                       Miscellaneous items.
C                                       Sort order ('**'=>unsorted)
      CALL CHR2H (2, '  ', 1, CATH(KITYP))
C                                       Units
      CTEMP = 'K'
      CALL CHR2H (8, CTEMP, 1, CATH(KHBUN))
      CTEMP = REFDAT
      CALL CHR2H (8, CTEMP, 1, CATH(KHDOB))
      IF (CPARM(6).LT.1.0) CPARM(6) = 12.0
      WRITE (CTEMP,1020) CPARM(6)
      CALL CHR2H (8, CTEMP, 1, CATH(KHTEL))
      CALL CHR2H (8, OBJECT, 1, CATH(KHOBJ))
      CATR(KREPO) = 2000.0
C                                       Put new values in CATBLK.
      CLAOUT(6:6) = '+'
      CALL MAKOUT (BLANK, BLANK, 0, BLANK, NAMOUT, CLAOUT, SEQO1)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQO1
      CATR(KRBMJ) = APARM(7) / 3600.0
      CATR(KRBMN) = APARM(7) / 3600.0
      CATD(KDCRV+2) = RAD2DG * VELITE * 1.2 / CPARM(6) / CATR(KRBMJ)
      CATD(KDCRV+3) = CPARM(4)
      CATD(KDCRV+3) = CPARM(5)
      CATD(KDORA) = CPARM(4)
      CATD(KDODE) = CPARM(5)
      IF (CPARM(1).LE.0.0) CPARM(1) = 0.25
      IF (CPARM(2).LE.0.0) CPARM(2) = 60.0
      CPARM(3) = CPARM(3) * 15.0
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      IRET = 4
      CATBLK(KIGCN) = APARM(1) * APARM(4) + 0.1
      CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CREATING OUTPUT FILE'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
      CALL RCOPY (4, CPARM(6), OBST)
      CALL OTFANT (CCNO, DISKO, OBST)
C                                       Get throw
      THROW = BPARM(1) + APARM(2) / 4.0
      KEYTYP = 2
      LOCS = 1
      CALL CATKEY ('WRIT', DISKO, CCNO, 'BSTHROW', 1, LOCS, THROW,
     *   KEYTYP, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'WRITING THROW'
         GO TO 990
         END IF
C                                       Save output file info
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
      SEQO1 = CATBLK(KIIMS)
      CALL COPY (256, CATBLK, PCAT)
C                                       Put new values in CATBLK.
      CLAOUT(6:6) = '-'
      CALL MAKOUT (BLANK, BLANK, 0, BLANK, NAMOUT, CLAOUT, SEQO1)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQO1
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      IRET = 4
      CATBLK(KIGCN) = APARM(1) * APARM(4) + 0.1
      CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CREATING OUTPUT FILE'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
      CALL OTFANT (CCNO, DISKO, CPARM(6))
      CALL COPY (256, CATBLK, MCAT)
C                                       Get throw
      THROW = -BPARM(1) - APARM(2) / 4.0
      CALL CATKEY ('WRIT', DISKO, CCNO, 'BSTHROW', 1, LOCS, THROW,
     *   KEYTYP, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'WRITING THROW'
         GO TO 990
         END IF
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SDMOIN: ERROR',I3,1X,A)
 1020 FORMAT ('BS',F5.1,'M')
      END
      SUBROUTINE SDMOUV (IRET)
C-----------------------------------------------------------------------
C   SDMOUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input in common:
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE1*48, OFILE2*48, CHSCAN*8, CHSAMP*8
      INTEGER   IPTRO, LUNM, LUNP, INDM, INDP, ILENBU, MBIND, NIOUT,
     *   NIOLIM, PBIND, BO, VO, NUMVIS, XCOUNT, NCORO, NCOPY, IU, IERR,
     *   IV, NU, NV, ILOCSC, ILOCSM
      LOGICAL   T, F
      INCLUDE 'BSMOD.INC'
      REAL      DUM, RESULT(4), U, V, TIME, DAY
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNM, LUNP /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
      DATA CHSCAN, CHSAMP /'SCAN','SAMP'/
C-----------------------------------------------------------------------
C                                       SCAN pointer
      CALL AXEFND (4, CHSCAN, CATBLK(KIPCN), CATH(KHPTP), ILOCSC, IERR)
      IF (IERR.NE.0) ILOCSC = -1
C                                       SAMPLE pointer
      CALL AXEFND (4, CHSAMP, CATBLK(KIPCN), CATH(KHPTP), ILOCSM, IERR)
      IF (IERR.NE.0) ILOCSM = -1
      IERR = 0
C                                       Number of visibilities in input
C                                       and output files.
      NCORO = (LRECO - NRPRMO) / PCAT(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', FVOL(NCFILE), FCNO(NCFILE), 1, OFILE2, IRET)
      CALL ZOPEN (LUNM, INDM, FVOL(NCFILE), OFILE2, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', FVOL(NCFILE-1), FCNO(NCFILE-1), 1, OFILE1,
     *   IRET)
      CALL ZOPEN (LUNP, INDP, FVOL(NCFILE-1), OFILE1, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNP, INDP, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, MBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = PBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNM, INDM, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF1, BO, MBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
      NV = APARM(4) + 0.1
      NU = APARM(1) + 0.1
      DAY = 24.0 * 3600.0
      TIME = -CPARM(2) / DAY
C                                       Loop
      IPTRO = 1
      DO 100 IV = 1,NV
         TIME = TIME + CPARM(2)/DAY
         DO 90 IU = 1,NU
            U = (IU - NU/2 - 1) * APARM(2) / 3600.
            V = (IV - NV/2 - 1) * APARM(5) / 3600.
            CALL RFILL (LRECO, 0.0, BUFF1(IPTRO))
            IF (ILOCSC.GE.0) BUFF1(IPTRO+ILOCSC) = IV
            IF (ILOCSM.GE.0) BUFF1(IPTRO+ILOCSM) = IU
            BUFF1(IPTRO+ILOCT) = TIME
            TIME = TIME + CPARM(1)/DAY
            NUMVIS = NUMVIS + 1
            CALL BSMOMO (NUMVIS, U, V, TIME, RESULT, IRET)
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
C                                       Copy to output.
            ELSE IF (IRET.EQ.0) THEN
               BUFF1(IPTRO+ILOCT) = TIME
               IF (ILOCB.GE.0) THEN
                  BUFF1(IPTRO+ILOCB) = 257.0
               ELSE
                  BUFF1(IPTRO+ILOCA1) = 1.0
                  BUFF1(IPTRO+ILOCA2) = 1.0
                  END IF
               BUFF1(IPTRO+ILOCU) = U
               BUFF1(IPTRO+ILOCV) = V
               XCOUNT = XCOUNT + 1.0D0
               CALL RCOPY (NRPRMO, BUFF1(IPTRO), BUFF2(IPTRO))
               BUFF1(IPTRO+NRPRMO) = RESULT(1)
               BUFF2(IPTRO+NRPRMO) = RESULT(2)
               BUFF1(IPTRO+NRPRMO+2) = 1.0
               BUFF2(IPTRO+NRPRMO+2) = 1.0
               BUFF1(IPTRO+NRPRMO+3) = RESULT(3)
               BUFF2(IPTRO+NRPRMO+3) = RESULT(3)
               BUFF1(IPTRO+NRPRMO+5) = 1.0
               BUFF2(IPTRO+NRPRMO+5) = 1.0
               BUFF1(IPTRO+NRPRMO+6) = RESULT(4)
               BUFF2(IPTRO+NRPRMO+6) = RESULT(4)
               BUFF1(IPTRO+NRPRMO+8) = 1.0
               BUFF2(IPTRO+NRPRMO+8) = 1.0
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               END IF
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNP, INDP, BUFF2, NIOLIM, PBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET
                  GO TO 990
                  END IF
               CALL UVDISK ('WRIT', LUNM, INDM, BUFF1, NIOLIM, MBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET
                  GO TO 990
                  END IF
               IPTRO = MBIND
               NIOUT = 0
               END IF
 90         CONTINUE
 100     CONTINUE
C                                       Final call to BSMOMO.
      NUMVIS = -1
      CALL BSMOMO (NUMVIS, DUM, DUM, DUM, RESULT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
         END IF
C                                       Finish write
      IPTRO = NIOUT
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNP, INDP, BUFF2, NIOUT, PBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
      NIOUT = - IPTRO
      CALL UVDISK ('FLSH', LUNM, INDM, BUFF1, NIOUT, MBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Close files
      CALL ZCLOSE (LUNM, INDM, IRET)
      CALL ZCLOSE (LUNP, INDP, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SDMOUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1010 FORMAT ('SDMOUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('SDMOUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('SDMOUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1120 FORMAT ('SDMOUV: BSMOMO ERROR',I3)
 1150 FORMAT ('SDMOUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE SDMOHI
C-----------------------------------------------------------------------
C   SDMOHI copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72
      INTEGER   LUN1, LUN2, IERR, I
      REAL      XJ, XN
      LOGICAL   T
      INCLUDE 'BSMOD.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HICREA (LUN1, FVOL(NCFILE-1), FCNO(NCFILE-1), PCAT, BUFF1,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
      CALL HICREA (LUN2, FVOL(NCFILE), FCNO(NCFILE), MCAT, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQO1, FVOL(NCFILE), LUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQO1, FVOL(NCFILE-1), LUN1,
     *   BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1012) TSKNAM, FLUX
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       components
      IF (NGAUSS.GT.0) THEN
         WRITE (HILINE,1014) TSKNAM, NGAUSS
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         CALL HIADD (LUN1, HILINE, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 200
         HILINE = TSKNAM // '/ Pre-convolution Gaussian parameters:'
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         DO 20 I = 1,NGAUSS
            WRITE (HILINE,1015) TSKNAM, I, GMAX(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
            CALL HIADD (LUN1, HILINE, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 200
            WRITE (HILINE,1016) TSKNAM, I, GPOS(1,I), GPOS(2,I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
            CALL HIADD (LUN1, HILINE, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 200
            WRITE (HILINE,1017) TSKNAM, I, GWID(1,I), GWID(2,I),
     *         GWID(3,I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
            CALL HIADD (LUN1, HILINE, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 200
            IF (ISFREQ) THEN
               IF (APARM(2*I).LE.0.0) THEN
                  HILINE = TSKNAM // '/ independent of channel'
               ELSE
                  WRITE (HILINE,1018) TSKNAM, I, APARM(2*I-1),
     *               APARM(2*I)
                  END IF
               CALL HIADD (LUN2, HILINE, BUFF2, IERR)
               IF (IERR.NE.0) GO TO 200
               CALL HIADD (LUN1, HILINE, BUFF1, IERR)
               IF (IERR.NE.0) GO TO 200
               END IF
 20         CONTINUE
         IF (PCATR(KRBMJ).GT.0.0) THEN
            IF ((BPARM(5).EQ.1.0) .AND. (BPARM(6).EQ.1.0)) THEN
               HILINE = TSKNAM // '/ Convolved Gaussian actually added:'
            ELSE
               HILINE = TSKNAM //
     *            '/ Convolved Gaussian added plus beam:'
               END IF
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
            CALL HIADD (LUN1, HILINE, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 200
            DO 30 I = 1,NGAUSS
               WRITE (HILINE,1015) TSKNAM, I, DMAX(I,1)
               CALL HIADD (LUN2, HILINE, BUFF2, IERR)
               IF (IERR.NE.0) GO TO 200
               CALL HIADD (LUN1, HILINE, BUFF1, IERR)
               IF (IERR.NE.0) GO TO 200
               WRITE (HILINE,1016) TSKNAM, I, GPOS(1,I), GPOS(2,I)
               CALL HIADD (LUN2, HILINE, BUFF2, IERR)
               IF (IERR.NE.0) GO TO 200
               CALL HIADD (LUN1, HILINE, BUFF1, IERR)
               IF (IERR.NE.0) GO TO 200
               IF ((DFJ(I,1).GT.0.0) .AND. (DFN(I,1).GT.0.0)) THEN
                  XJ = SQRT (4.*LOG(2.) / DFJ(I,1))
                  XN = SQRT (4.*LOG(2.) / DFN(I,1))
                  WRITE (HILINE,1017) TSKNAM, I, XJ, XN, GWID(3,I)
                  CALL HIADD (LUN2, HILINE, BUFF2, IERR)
                  IF (IERR.NE.0) GO TO 200
                  CALL HIADD (LUN1, HILINE, BUFF1, IERR)
                  IF (IERR.NE.0) GO TO 200
                  END IF
 30            CONTINUE
            IF ((BPARM(5).NE.1.0) .OR. (BPARM(6).NE.1.0)) THEN
               HILINE = TSKNAM //
     *           '/ Convolved Gaussian added minus beam:'
               CALL HIADD (LUN2, HILINE, BUFF2, IERR)
               IF (IERR.NE.0) GO TO 200
               CALL HIADD (LUN1, HILINE, BUFF1, IERR)
               IF (IERR.NE.0) GO TO 200
               DO 35 I = 1,NGAUSS
                  WRITE (HILINE,1015) TSKNAM, I, DMAX(I,2)
                  CALL HIADD (LUN2, HILINE, BUFF2, IERR)
                  IF (IERR.NE.0) GO TO 200
                  CALL HIADD (LUN1, HILINE, BUFF1, IERR)
                  IF (IERR.NE.0) GO TO 200
                  WRITE (HILINE,1016) TSKNAM, I, GPOS(1,I), GPOS(2,I)
                  CALL HIADD (LUN2, HILINE, BUFF2, IERR)
                  IF (IERR.NE.0) GO TO 200
                  CALL HIADD (LUN1, HILINE, BUFF1, IERR)
                  IF (IERR.NE.0) GO TO 200
                  IF ((DFJ(I,2).GT.0.0) .AND. (DFN(I,2).GT.0.0)) THEN
                     XJ = SQRT (4.*LOG(2.) / DFJ(I,2))
                     XN = SQRT (4.*LOG(2.) / DFN(I,2))
                     WRITE (HILINE,1017) TSKNAM, I, XJ, XN, GWID(3,I)
                     CALL HIADD (LUN2, HILINE, BUFF2, IERR)
                     IF (IERR.NE.0) GO TO 200
                     CALL HIADD (LUN1, HILINE, BUFF1, IERR)
                     IF (IERR.NE.0) GO TO 200
                     END IF
 35               CONTINUE
               END IF
            END IF
         END IF
C                                       Continuum
      WRITE (HILINE,1030) TSKNAM, BPARM(1)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1031) TSKNAM, BPARM(2)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1032) TSKNAM, BPARM(3)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1033) TSKNAM, APARM(3)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1034) TSKNAM, APARM(6)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1035) TSKNAM, BPARM(5)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1036) TSKNAM, BPARM(6)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
      IF (BPARM(4).GT.0.0) THEN
         HILINE = TSKNAM // '/ coordinate corrected before modeling'
      ELSE
         HILINE = TSKNAM // '/ coordinate corrected after modeling'
         END IF
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Observatory
      WRITE (HILINE,1040) TSKNAM, CPARM(6)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1041) TSKNAM, CPARM(7)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1042) TSKNAM, CPARM(8)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1043) TSKNAM, CPARM(9)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, BUFF2, IERR)
      CALL HICLOS (LUN1, T, BUFF1, IERR)
C                                        Update CATBLK.
      CALL CATIO ('UPDT', FVOL(NCFILE-1), FCNO(NCFILE-1), PCAT, 'REST',
     *   BUFF1, IERR)
      CALL CATIO ('UPDT', FVOL(NCFILE), FCNO(NCFILE), MCAT, 'REST',
     *   BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SDMOHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1012 FORMAT (A6,'NOISE=',F8.3,5X,'/ Noise added, data discarded')
 1014 FORMAT (A6,'NGAUSS=',I2,10X,'/ Gaussians used')
 1015 FORMAT (A6,'GMAX(',I1,')=',1PE13.5,10X,'/ Peak brightness')
 1016 FORMAT (A6,'GPOS(',I1,')=',F8.1,',',F8.1,6X,
     *   '/ X,Y center in arc seconds')
 1017 FORMAT (A6,'GWID(',I1,')=',F6.1,',',F6.1,',',F6.1,3X,
     *   '/ major,minor arc sec, PA deg')
 1018 FORMAT (A6,'GCHN(',I1,')=',F6.1,',',F5.1,11X,
     *   '/ center,fwhm spectral channels')
 1030 FORMAT (A6,'THROW =',F8.4,5X,'/ formal throw length')
 1031 FORMAT (A6,'SCALE =',F8.4,5X,'/ change throw length')
 1032 FORMAT (A6,'ROTATE=',F8.4,5X,'/ rotate throw ccw (degrees)')
 1033 FORMAT (A6,'XNOISE=',F8.4,5X,'/ noise in az coord')
 1034 FORMAT (A6,'YNOISE=',F8.4,5X,'/ noise in el coord')
 1035 FORMAT (A6,'GRATIO=',F8.4,5X,'/ ratio +/- beam gain')
 1036 FORMAT (A6,'WRATIO=',F8.4,5X,'/ ratio +/- beam width')
 1040 FORMAT (A6,'DIAMETER=',F6.2,5X,'/ telescope diameter (m)')
 1041 FORMAT (A6,'OBS-LONG=',F10.5,1X,'/ observatory long (deg)')
 1042 FORMAT (A6,'OBS-LAT=',F10.5,2X,'/ observatory lat (deg)')
 1043 FORMAT (A6,'OBS-RAD=',F10.1,2X,'/ observatory-Earth center (m)')
      END
      SUBROUTINE BSMOMO (NUMVIS, U, V, T, RESULT, IRET)
C-----------------------------------------------------------------------
C   Computes the plus and minus throw model
C   Inputs:
C      NUMVIS   I      Visibility number, -1 => final call, no data
C                      passed but allows any operations to be completed
C   Inputs from COMMON:
C      RA       D      Right ascension (1950) of phase center. (deg)
C      DEC      D      Declination (1950) of phase center. (deg)
C   In/Output:
C      U        R      Azimuth in degrees
C      V        R      Elevation in degrees
C      T        R      Time in days
C   Output:
C      RESULT   R(2)   Output visibilities selected in frequency.
C      IRET     I      Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IRET
      REAL      U, V, T, RESULT(4)
C
      INTEGER   I, J, SBUFF(512)
      REAL      X, Y, XJ, XN, Z, RU, RV, ZPOS(2,4), CP, SP, X1, X2
      DOUBLE PRECISION PRA, PDEC, MRA, MDEC, ANTLST, HRANG, PANGL,
     *   SINLAT, COSLAT
      INCLUDE 'BSMOD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DFIL.INC'
      SAVE PRA, PDEC, MRA, MDEC
C-----------------------------------------------------------------------
      IRET = 0
C                                       Init information about
C                                       Gaussians:
      IF (NUMVIS.EQ.1) THEN
         CALL RANDIN (I)
         X1 = PCATR(KRBMJ) * 3600 * SQRT (BPARM(6))
         X2 = PCATR(KRBMJ) * 3600 / SQRT (BPARM(6))
         PRA = -THROW * COS (DG2RAD * BPARM(3)) * BPARM(2) / 3600.
         PDEC= -THROW * SIN (DG2RAD * BPARM(3)) * BPARM(2) / 3600.
         MRA =  THROW * COS (DG2RAD * BPARM(3)) * BPARM(2) / 3600.
         MDEC=  THROW * SIN (DG2RAD * BPARM(3)) * BPARM(2) / 3600.
C                                       Precompute gaussians
         IF (NGAUSS.GT.0) THEN
            DO 10 I = 1,NGAUSS
               IF ((X.LE.0.0) .AND. ((GWID(1,I).LE.0.0) .OR.
     *            (GWID(2,I).LE.0.0))) THEN
                  WRITE (MSGTXT,1000) I
                  CALL MSGWRT (8)
                  IRET = 8
                  GO TO 999
                  END IF
               DFJ(I,1) = 4. * LOG(2.0) / (X1*X1 + GWID(1,I)*GWID(1,I))
               DFN(I,1) = 4. * LOG(2.0) / (X1*X1 + GWID(2,I)*GWID(2,I))
               DFJ(I,2) = 4. * LOG(2.0) / (X2*X2 + GWID(1,I)*GWID(1,I))
               DFN(I,2) = 4. * LOG(2.0) / (X2*X2 + GWID(2,I)*GWID(2,I))
               DMAX(I,1) = GMAX(I) * SQRT (BPARM(5))
               DMAX(I,2) = GMAX(I) / SQRT (BPARM(5))
               IF ((X1.GT.0.0) .AND. (GWID(1,I).GT.0.0) .AND.
     *            (GWID(2,I).GT.0.0)) DMAX(I,1) = DMAX(I,1) * GWID(1,I)
     *            * GWID(2,I) / SQRT ((X1*X1 + GWID(1,I)**2) * (X1*X1 +
     *            GWID(2,I)**2))
               IF ((X2.GT.0.0) .AND. (GWID(1,I).GT.0.0) .AND.
     *            (GWID(2,I).GT.0.0)) DMAX(I,2) = DMAX(I,2) * GWID(1,I)
     *            * GWID(2,I) / SQRT ((X2*X2 + GWID(1,I)**2) * (X2*X2 +
     *            GWID(2,I)**2))
               DDY(I,1) = PDEC + GPOS(2,I)/3600.
               DDC(I,1) = COS (DG2RAD * DDY(I,1))
               DDX(I,1) = PRA * DDC(I,1) + GPOS(1,I) / 3600
               DDY(I,2) = MDEC + GPOS(2,I)/3600.
               DDC(I,2) = COS (DG2RAD * DDY(I,2))
               DDX(I,2) = MRA * DDC(I,2) + GPOS(1,I) / 3600
 10            CONTINUE
            ISFREQ = .FALSE.
            END IF
C                                       Set up antennas etc
         RA = PCATD(KDORA) * DG2RAD
         DEC = PCATD(KDODE) * DG2RAD
         CALL GETANT (FVOL(NCFILE-1), FCNO(NCFILE-1), 1, PCAT, SBUFF,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         T = (CPARM(3) * DG2RAD + RA - GSTIAT - STNLON(1)) / ROTIAT
         END IF
C                                       Current record
      IF (NUMVIS.GT.0) THEN
C                                       Antenna LST
         ANTLST = GSTIAT + STNLON(1) + T * ROTIAT
         SINLAT = SIN (STNLAT(1))
         COSLAT = COS (STNLAT(1))
C                                       Hour angle
         HRANG = ANTLST - RA
C                                       Limit to between 0 and 2pi
         HRANG = MOD (HRANG, TWOPI)
C                                       translate to between -pi and pi
         IF (HRANG.GT.PI) HRANG = HRANG - TWOPI
         IF (HRANG.LT.-PI) HRANG = HRANG + TWOPI
C                                       get coordinates
         RU = U
         RV = V
         IF (APARM(3).GT.0.0) THEN
            CALL NOISE (X)
            RU = RU + APARM(3) * X / 3600.0
            END IF
         IF (APARM(6).GT.0.0) THEN
            CALL NOISE (X)
            RV = RV + APARM(6) * X / 3600.0
            END IF
         IF (BPARM(4).GT.0.0) THEN
            U = RU
            V = RV
            END IF
C                                       Parallactic angle
         PANGL = ATAN2 (COSLAT * SIN(HRANG),
     *      (SINLAT * COS(DEC) - COSLAT * SIN(DEC) * COS(HRANG)))
         CP = COS (PANGL)
         SP = SIN (PANGL)
         RESULT(3) = U * CP - V * SP
         RESULT(4) = U * SP + V * CP
C                                       find flux
         DO 120 J = 1,2
            RESULT(J) = 0.
            DO 110 I = 1,NGAUSS
               ZPOS(1,I) = GPOS(1,I) * CP + GPOS(2,I) * SP
               ZPOS(2,I) = -GPOS(1,I) * SP + GPOS(2,I) * CP
               DDY(I,1) = PDEC + ZPOS(2,I)/3600.
               DDC(I,1) = COS (DG2RAD * DDY(I,1))
               DDX(I,1) = PRA * DDC(I,1) + ZPOS(1,I) / 3600
               DDY(I,2) = MDEC + ZPOS(2,I)/3600.
               DDC(I,2) = COS (DG2RAD * DDY(I,2))
               DDX(I,2) = MRA * DDC(I,2) + ZPOS(1,I) / 3600
               X = RU * DDC(I,J) - DDX(I,J)
               Y = RV - DDY(I,J)
               Z = DG2RAD*GWID(3,I)
               XJ = (X * SIN (Z) + Y * COS (Z)) * 3600.
               XN = (Y * SIN (Z) - X * COS (Z)) * 3600.
               Z = DFJ(I,J) * XJ * XJ + DFN(I,J) * XN * XN
               IF (Z.LT.10.) RESULT(J) = RESULT(J) + DMAX(I,J) * EXP(-Z)
 110           CONTINUE
 120        CONTINUE
        IF (FLUX.GT.0) THEN
           CALL NOISE (X)
           RESULT(1) = RESULT(1) + FLUX * X
           CALL NOISE (X)
           RESULT(2) = RESULT(2) + FLUX * X
           END IF
C                                       last call - history
      ELSE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('COMPONENT',I2,' MUST HAVE WIDTH OR HEADER BEAM WIDTH')
      END
      SUBROUTINE NOISE (ANOISE)
C-----------------------------------------------------------------------
C   Random noise generator
C    Output: ANOISE  R    Result
C-----------------------------------------------------------------------
      REAL      ANOISE, TEMP
      INTEGER   J
C-----------------------------------------------------------------------
      ANOISE = -6.0
      DO 10 J = 1,12
         CALL RANDUM (TEMP)
         ANOISE = ANOISE + TEMP
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE OTFANT (CCNO, DISKO, UCOR)
C-----------------------------------------------------------------------
C   Make an antenna file for the output data file.
C   Inputs:
C      CCNO    I   Output catalog number
C      DISKO   I      Output disk number
C      UCOR    R(3)   Diameter (m), Longitude, latitude, radius
C-----------------------------------------------------------------------
      INTEGER   CCNO, DISKO
      REAL      UCOR(4)
C
      INTEGER   LUNA,  IABUF(512), FINDA, I, JERR, ANVER, MAXA, J
      DOUBLE PRECISION JDA, GASTM
      LOGICAL   TABLE, EXIST, FITASC
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNA /30/
C-----------------------------------------------------------------------
C                                       Is there one already
      ANVER = 1
      CALL ISTAB ('AN', DISKO, CCNO, ANVER, LUNA, IABUF, TABLE, EXIST,
     *   FITASC, JERR)
C                                       Setup for AN table initization
      NUMORB = 0
      NOPCAL = 2
C                                       Position of the earth's pole
      POLRXY(1) = 0.0
      POLRXY(2) = 0.0
      UT1UTC = 0.0
      DATUTC = 0.0
      TIMSYS = 'IAT'
C                                       Array name
      CALL H2CHR (8, 1, CATH(KHTEL), ANAME)
      J = UCOR(1) + 0.5
C                                       Array center (rel to center of
C                                       earth): shift from VLBA KP one
      IF ((UCOR(4).LE.1.E6) .OR. ((UCOR(2).EQ.0.) .AND.
     *   (UCOR(3).EQ.0.))) THEN
         ARRAYC(1) = -1995945.D0
         ARRAYC(2) = -5037360.D0
         ARRAYC(3) =  3357261.D0
         UCOR(4) = 6374166.13
         UCOR(3) = 31.7826
         UCOR(2) = -111.61487
      ELSE
         ARRAYC(1) = COS (UCOR(3)*DG2RAD) * COS (UCOR(2)*DG2RAD) *
     *      UCOR(4)
         ARRAYC(2) = COS (UCOR(3)*DG2RAD) * SIN (UCOR(2)*DG2RAD) *
     *      UCOR(4)
         ARRAYC(3) = SIN (UCOR(3)*DG2RAD) * UCOR(4)
         END IF
C                                       Get GST0 and Earth rotation rate
      CALL H2CHR (8, 1, CATH(KHDOB), RDATE)
      CALL JULDAY (RDATE, JDA)
      CALL GSTROT (JDA, GSTIA0, GASTM, DEGPDY)
      SAFREQ = CATD(KDCRV+2)
C                                       Create/init file
      NUMORB = 0
      NOPCAL = 2
      ANTNIF = 1
      ANFQID = -1
      CALL ANTINI ('WRIT', IABUF, DISKO, CCNO, ANVER, CATBLK, LUNA,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *   RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME,
     *   NUMORB, NOPCAL, ANTNIF, ANFQID, JERR)
      IF (JERR.NE.0) GO TO 990
      MAXA = IANRNO - 1
      MAXA = MAX (MAXA, 1)
C                                       init basic AN record
      STAXOF = 0.0
      STAXYZ(1) = 0.0D0
      STAXYZ(2) = 0.0D0
      STAXYZ(3) = 0.0D0
      ORBPRM(1) = 0.0D0
      NOSTA = 0
      MNTSTA = 0
      POLAA = 0.0
      POLAB = 0.0
      CALL RFILL (3, 0.0, POLCA)
      CALL RFILL (3, 0.0, POLCB)
      POLTYA = 'R'
      POLTYB = 'L'
      DO 10 I = 1,MAXA
         NOSTA = I
         WRITE (ANNAME,1000) J, I
         IANRNO = I
         CALL TABAN ('WRIT', IABUF, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA,POLTYB, POLAB, POLCB, JERR)
         IF (JERR.NE.0) GO TO 990
 10      CONTINUE
C                                       Close/update AN file.
      CALL TABIO ('CLOS', 1, IANRNO, IABUF, IABUF, JERR)
      GO TO 999
C                                       Error
 990  CALL ZCLOSE (LUNA, FINDA, JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I2,'M IF',I2.2)
      END

      SUBROUTINE ILNCLR (COLOR, NPOINT, NEND, SLOPE, OFFSET, GAMMA,
     *   BUFFER, IERR)
C-----------------------------------------------------------------------
C! computes and loads a piecewise linear OFM to the TV
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2008
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ILNCLR computes a piecewise linear OFM and writes it to the TV.
C   If NEND(NPOINT) is <= OFMINP/2 or /3 or /4, the table is repeated
C   an approprite number of times.
C   Inputs:
C      COLOR   I            color bit mask: RGB = 421
C      NPOINT  I            # of segments
C      NEND    I            end points of segments
C      SLOPE   R(NPOINT)    slopes of segments
C      OFFSET  R(NPOINT)    offsets of segments
C      GAMMA   R            power applied to colors (1 /gamma)
C   Output:
C      BUFFER  R(TVMOFM)    scratch buffer
C      IERR    I            error code of ZM70XF : 0 - ok
C   Form is C = (i-1)*SLOPE + OFFSET with 0 <= C <= 1.0.
C   Used to be called YLNCLR.
C-----------------------------------------------------------------------
      INTEGER   COLOR, NPOINT, NEND(*), IERR
      REAL      SLOPE(*), OFFSET(*), GAMMA, BUFFER(*)
C
      INTEGER   I1, I2, K, I, II, JJ, KK
      REAL      S, OF, C
      LOGICAL   VRTRTC
      INCLUDE 'INCS:DTVC.INC'
      DATA VRTRTC /.TRUE./
C-----------------------------------------------------------------------
      K = OFMINP + 1
      CALL RFILL (K, 0.0, BUFFER)
      I2 = 0
C                                        loop over segments
      DO 20 K = 1,NPOINT
         I1 = I2 + 1
         I2 = NEND(K)
         S = SLOPE(K)
         OF = OFFSET(K)
         I1 = MAX (1, I1)
         IF ((I2.GE.I1) .AND. ((S.NE.0.0) .OR. (OF.NE.0.0))) THEN
            IF (ABS(GAMMA-1.0).GT.0.02) THEN
               DO 10 I = I1,I2
                  C = (I-1)*S + OF
                  IF (C.GE.1.0) THEN
                     BUFFER(I) = 1.0
                  ELSE IF (C.GT.0.0) THEN
                     BUFFER(I) = C ** GAMMA
                     END IF
 10               CONTINUE
            ELSE
               DO 15 I = I1,I2
                  C = (I-1)*S + OF
                  IF (C.GE.0.0) BUFFER(I) = MIN (1.0, C)
 15               CONTINUE
               END IF
            END IF
 20      CONTINUE
C                                        expand to fill
      BUFFER(1) = 0.
      K = NEND(NPOINT)
      JJ = K
      KK = (OFMINP+1) / K
      DO 21 II = 2,KK
         CALL RCOPY (K, BUFFER, BUFFER(JJ+1))
         JJ = JJ + K
 21      CONTINUE
C
      CALL YOFM ('WRIT', COLOR, VRTRTC, BUFFER, IERR)
C
 999  RETURN
      END

      SUBROUTINE QRFT (UDATA, UFT, UPH0, NFT, NDATA)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Does real, inverse FT with arbitrary spacing.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   QRFT computes a real, inverse fourier transform from arbitarily
C   spaced data.
C   Inputs:
C      UDATA  I    AP base address of input data.
C      UFT    I    AP base address of output F. T.
C      UPH0   I    AP base address of phase information for F. T.
C                   0=COS((TWOPI/(NG*NFT))*(1-ICENT)(1-BIAS))
C                   1=SIN((TWOPI/(NG*NFT))*(1-ICENT)(1-BIAS))
C                   2=COS((TWOPI/(NG*NFT))*(1-ICENT))
C                   3=SIN((TWOPI/(NG*NFT))*(1-ICENT))
C                   4=COS((TWOPI/(NG*NFT))*(1-BIAS))
C                   5=SIN((TWOPI/(NG*NFT))*(1-BIAS))
C                   6=COS((TWOPI/(NG*NFT)))
C                   7=SIN((TWOPI/(NG*NFT)))
C                   ICENT = center pixel of grid
C                   BIAS = center of data array (1 rel)
C                   NG = No. tabulated points per cell.
C      NFT    I    Number of FT points
C      NDATA  I    Number of data points.
C   Fourier transform is calculated by repeatedly applying a phase ramp
C   to the complex input vector and summing the result.
C   Usage note:  This routine uses work vector WKVECA
C   CRI version.
C-----------------------------------------------------------------------
      INTEGER   UDATA, UFT, UPH0, FT, NFT, NDATA, DPH, DPH0, DDPH, M2,
     *   I, JFT, LOOP, JA, JC
      REAL     TEMP, TEMPR, TEMPI, SSUM, PHASE, DPHASE, TWOPI
      INCLUDE 'INCS:DAPC.INC'
      DATA  M2 /2/
      DATA TWOPI /6.283185308/
C-----------------------------------------------------------------------
C                                       Set up addresses.
      FT = UFT
C                                       Check for data.
      IF (NDATA.LE.0) GO TO 999
C                                       Set pointers.
      DPH = UPH0 + 2
      DPH0 = DPH + 2
      DDPH = DPH0 + 2
C                                       Setup row
      CALL QPHSRO (UDATA, M2, UDATA, M2, UPH0, DPH, NDATA)
C                                       Get phase and delta phase.
      PHASE = ATAN2 (APCORE(DPH0+2), APCORE(DPH0+1)+1.0E-30)
      DPHASE = ATAN2 (APCORE(DDPH+2), APCORE(DDPH+1)+1.0E-30)
C                                       Make phase ramp
      JA = 1
      DO 20 LOOP = 1,NDATA
         TEMP = MOD ((PHASE + (LOOP-1) * DPHASE), TWOPI)
         WKVECA(JA+1) = SIN (TEMP)
         WKVECA(JA) = COS (TEMP)
         JA = JA + 2
 20      CONTINUE
C                                       Do Fourier transform.
C                                       Loop
      JFT = FT + 1
      DO 100 I = 1,NFT
C                                       Sum
         APCORE(JFT) = SSUM (NDATA, APCORE(UDATA+1), M2)
C                                       Rotate for next sum.
         JA = UDATA + 1
         JC = 1
C                                        (complex) multiply
      INCLUDE 'INCS:ZVND.INC'
         DO 50 LOOP = 1,NDATA
            TEMPR = APCORE(JA)*WKVECA(JC) - APCORE(JA+1)*WKVECA(JC+1)
            TEMPI = APCORE(JA)*WKVECA(JC+1) + APCORE(JA+1)*WKVECA(JC)
            APCORE(JA) = TEMPR
            APCORE(JA+1) = TEMPI
C                                        Update indices.
            JA = JA + 2
            JC = JC + 2
 50         CONTINUE
C                                       Update pointer
         JFT = JFT + 1
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE CGEFA (A, LDA, N, IPVT, INFO)
C-----------------------------------------------------------------------
C! Linpack routine: Factors complex matrix by Gaussian Elimination
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   CGEFA factors a complex matrix by gaussian elimination.
C   CGEFA is usually called by CGECO, but it can be called directly with
C   a saving in time if  RCOND  is not needed.
C       (Time for CGECO) = (1 + 9/N)*(time for CGEFA) .
C   Inputs:
C      A     C(LDA,N)  Matrix to be factored
C      LDA   I         The leading dimension OF the array  A .
C      N     I         The order of matrix A.
C   Outputs:
C      A     C(LDA,N)  An upper triangular matrix and the multipliers
C                      which were used to obtain it.  The factorization
C                      can be written  A = L*U  where L is a product of
C                      permutation and unit lower triangular matrices
C                      and  U  is upper triangular.
C      IPVT  I         An integer vector of pivot indices.
C      INFO  I         = 0  normal value.
C                      = K  if  U(K,K) .EQ. 0.0 .  this is not an error
C                      condition for this subroutine, but it does
C                      indicate that CGESL or CGEDI will divide by zero
C                      if called.  use  RCOND  in CGECO for a reliable
C                      indication of singularity.
C   LINPACK. This version dated 08/14/78.
C   Cleve Moler, University of New Mexico, Argonne National Lab.
C   Subroutines and Functions:
C      Blas     CAXPY, CSCAL, ICAMAX
C      Fortran  ABS, AIMAG, REAL
C-----------------------------------------------------------------------
      INTEGER    LDA, N, IPVT(*), INFO
      COMPLEX    A(LDA,*)
C
      COMPLEX   T, ZDUM
      INTEGER   J, K, KP1, L, NM1, ICAMAX
      REAL      CABS1
C-----------------------------------------------------------------------
C                                       internal function
      CABS1 (ZDUM) = ABS (REAL (ZDUM)) + ABS (AIMAG (ZDUM))
C-----------------------------------------------------------------------
C                                       Gaussian elimination with
C                                       partial Pivoting
      INFO = 0
      NM1 = N - 1
      IF (NM1.LT.1) GO TO 70
      DO 60 K = 1,NM1
         KP1 = K + 1
C                                       Find L = pivot index
         L = ICAMAX (N-K+1, A(K,K), 1) + K - 1
         IPVT(K) = L
C                                       Zero pivot implies this column
C                                       already triangularized.
         IF (CABS1(A(L,K)).EQ.0.0E0) GO TO 40
C                                       Interchange if necessary
C
            IF (L.EQ.K) GO TO 10
               T = A(L,K)
               A(L,K) = A(K,K)
               A(K,K) = T
   10       CONTINUE
C                                       Compute multipliers
            T = -(1.0E0,0.0E0) / A(K,K)
            CALL CSCAL (N-K, T, A(K+1,K), 1)
C                                       Row elimination with column
C                                       indexing.
            DO 30 J = KP1,N
               T = A(L,J)
               IF (L.EQ.K) GO TO 20
                  A(L,J) = A(K,J)
                  A(K,J) = T
   20             CONTINUE
               CALL CAXPY (N-K, T, A(K+1,K), 1, A(K+1,J), 1)
   30       CONTINUE
         GO TO 50
   40    CONTINUE
            INFO = K
   50    CONTINUE
   60 CONTINUE
   70 CONTINUE
      IPVT(N) = N
      IF (CABS1 (A(N,N)) .EQ. 0.0E0) INFO = N
C
 999  RETURN
      END

      SUBROUTINE ZWHOMI (IERR)
C-----------------------------------------------------------------------
C! determines AIPSxn task name; sets NPOPS, assigns TV and TK devices
C# Z System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZWHOMI determines the actual task name under which the present
C   version of AIPS is running.  It uses this information to set the
C   value of NPOPS in the common /MSGCOM/.  It then assigns the TV and
C   TK devices setting NTVDEV and NTKDEV in common /DCHCOM/.
C   Output:
C      IERR   I   Error return code: 0 => no error
C                    1 => process name is not AIPSx
C                    2 => illegal POPS number
C                    3 => other error
C   Generic version - uses ZGNAME, ZTRLOG
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   ITV, ITK, XLEN, XLNB, ITL, JTRIM, J1, J2, J, INTVD
      LOGICAL   REMOTE
      CHARACTER NAME*6, XLATED*24, XSPARE*24
      HOLLERITH HLATED(6), HSPARE(6)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Get name of this process.
      CALL ZGNAME (NAME, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000)
         IERR = 3
         GO TO 995
         END IF
C                                       Trim trailing null, check length
      ITL = JTRIM (NAME)
      IF (ITL.LE.0) THEN
         WRITE (MSGTXT,1001)
         IERR = 1
         GO TO 995
         END IF
C                                       Are we at least AIPS?
      IF ((NAME(:4).NE.'AIPS') .AND. (NAME(:4).NE.'DAIP')) THEN
         WRITE (MSGTXT,1010) NAME
         IERR = 1
         GO TO 995
         END IF
C                                       Get POPS number from process
C                                       name.
      CALL ZHEX10 (NAME(5:5), NPOPS, IERR)
      IF ((NPOPS.LT.1) .OR. (NPOPS.GT.35) .OR. (IERR.NE.0)) THEN
         WRITE (MSGTXT,1020) NAME, NAME(5:5)
         IERR = 2
         GO TO 995
         END IF
C                                       Get TV and TK device
C                                       assignments.
      ITK = NTKDEV + 1
      XLEN = LEN (XLATED)
      CALL ZTRLOG (7, 'AIPSTVS', XLEN, XLATED, XLNB, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) 'AIPSTVS'
         IERR = 3
         GO TO 995
         END IF
      CALL TXTLEN (XLATED(:XLNB), J1, J2)
      ITV = 0
      DO 40 J = J1,J2
         ITV = 10 * ITV + ICHAR (XLATED(J:J)) - ICHAR ('0')
 40      CONTINUE
      ITV = MAX (0, ITV)
C                                       TV device: translate logical
      XLEN = LEN (XLATED)
      CALL ZTRLOG (5, 'TVDEV', XLEN, XLATED, XLNB, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) 'TVDEV'
         IERR = 3
         GO TO 995
         END IF
C                                       Get TV device number.
      IF ((XLATED(1:5).NE.'TVDEV') .OR. (XLNB.LT.6)) THEN
         MSGTXT = 'ZWHOMI: INVALID TV DEVICE = ' // XLATED(1:XLNB)
         CALL MSGWRT (8)
         NTVDEV = 0
      ELSE
         CALL ZHEX10 (XLATED(6:XLNB), NTVDEV, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1035) XLATED(1:XLNB), XLATED(6:XLNB)
            CALL MSGWRT (8)
            NTVDEV = 0
            END IF
         END IF
C                                       Reset for POPS numbers
C                                       not allowed TV access.
      IF (NPOPS.GT.NTVACC) NTVDEV = 0
C                                       Guest accounts
      IF (NTVDEV.GT.ITV) THEN
         MSGTXT = 'You are not on a local TV device, welcome stranger'
         CALL MSGWRT (1)
         END IF
C                                       Tell user about TV assigment.
      WRITE (MSGTXT,1070) NTVDEV
      IF (NTVDEV.LE.0) WRITE (MSGTXT,1071)
      CALL MSGWRT (1)
C                                       Graphics device:
      NTKDEV = 1
      XLEN = LEN (XLATED)
      CALL ZTRLOG (5, 'TKDEV', XLEN, XLATED, XLNB, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) 'TKDEV'
         IERR = 3
         GO TO 995
         END IF
C                                       Get graphics device number.
      REMOTE = .FALSE.
C                                       Remote "tek" device, use extra
C                                       tek device slots beyond last
C                                       real TV device.
      IF (XLATED(1:XLNB).EQ.'REMOTE') THEN
         REMOTE = .TRUE.
         NTKDEV = ITV + NPOPS + 36
C                                       Reset TKDEV to TKDEVxx where xx
C                                       is the ehex TV number.
         XLATED = 'TKDEV'
         XSPARE = XLATED
         CALL ZEHEX (NTKDEV, 2, XLATED(6:7))
         CALL CHR2H (24, XSPARE, 1, HSPARE)
         CALL CHR2H (24, XLATED, 1, HLATED)
         CALL ZCRLOG (5, HSPARE, 7, HLATED, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'ZWHOMI: CANNOT REDEFINE TKDEV TO '//XLATED(1:7)
            CALL MSGWRT(8)
            NTKDEV = 0
            END IF
C                                       local or pseudo local
      ELSE IF (ITK.GT.1) THEN
         IF ((XLATED(1:5).NE.'TKDEV') .OR. (XLNB.LT.6)) THEN
            MSGTXT = 'ZWHOMI: INVALID TK DEVICE = ' // XLATED(1:XLNB)
            CALL MSGWRT (8)
            NTKDEV = 0
         ELSE
            CALL ZHEX10 (XLATED(6:XLNB), NTKDEV, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1090) XLATED(1:XLNB), XLATED(6:XLNB)
               CALL MSGWRT (8)
               NTKDEV = 0
               END IF
            END IF
C                                       reassign for guests
         IF ((NTKDEV.EQ.INTVD) .AND. (INTVD.LT.NTVDEV)) THEN
            XSPARE = XLATED
            XLEN = LEN (XLATED)
            J2 = XLNB
            CALL ZTRLOG (J2, XSPARE, XLEN, XLATED, XLNB, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1030) XSPARE
               CALL MSGWRT (6)
            ELSE
               CALL ZEHEX (NTVDEV, 2, XSPARE(6:7))
               CALL CHR2H (24, XSPARE, 1, HSPARE)
               CALL CHR2H (24, XLATED, 1, HLATED)
               CALL ZCRLOG (7, HSPARE, XLNB, HLATED, IERR)
               IF (IERR.NE.0) THEN
                  MSGTXT = 'ZWHOMI: CANNOT DEFINE ' // XSPARE
                  CALL MSGWRT (6)
                  END IF
               END IF
            NTKDEV = NTVDEV
            IF (IERR.NE.0) NTKDEV = 0
            END IF
         END IF
C
      IF ((NPOPS.GT.NTKACC) .AND. (.NOT.REMOTE)) NTKDEV = 0
C                                       Tell user about graphics
C                                       device assigment.
      WRITE (MSGTXT,1100) NTKDEV
      IF (NTKDEV.LE.0) WRITE (MSGTXT,1101)
      IF (REMOTE) WRITE (MSGTXT,1102) NTKDEV
      CALL MSGWRT (1)
      GO TO 999
C
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZWHOMI: Trouble getting process name')
 1001 FORMAT ('ZWHOMI: ZGNAME returns an EMPTY string for process name')
 1010 FORMAT ('ZWHOMI: Process name = ',A,' unrecognized')
 1020 FORMAT ('ZWHOMI: Process is ',A,' but POPS number = ',A,
     *   ' is INVALID')
 1030 FORMAT ('ZWHOMI: Cannot translate logical = ',A)
 1035 FORMAT ('ZWHOMI: TV device ',A,
     *   ' has INVALID device number = ',A)
 1070 FORMAT ('You are assigned TV device/server',I4)
 1071 FORMAT ('You are NOT assigned a TV device or server')
 1090 FORMAT ('ZWHOMI: Graphics device ',A,
     *   ' has INVALID device number = ',A)
 1100 FORMAT ('You are assigned graphics device/server',I4)
 1101 FORMAT ('You are NOT assigned a graphics device or server')
 1102 FORMAT ('Your terminal (tek-compatible) will be graphics device',
     *   I4)
      END

LOCAL INCLUDE 'HOLGRP'
      INTEGER   MX, MXFAC, NLG, MXEQ
C                                       Maximum map size
      PARAMETER (MX = 512)
      PARAMETER (MXFAC = 2)
C                                       Beam double grid
      PARAMETER (NLG = MXFAC*MX)
      PARAMETER (MXEQ = MX/MXFAC)
LOCAL END
LOCAL INCLUDE 'HOLGRMX'
      INCLUDE 'HOLGRP'
C                                       Try to save core
      REAL      WAMP(NLG,NLG), WPHA(NLG,NLG)
      COMPLEX   VCPLX(NLG,NLG)
      INTEGER   PATCH(MX,MX)
      REAL      AAMP(MX,MX), APHA(MX,MX), PAMP(MX,MX), VAMP(MX,MX),
     *          VDEV(MX,MX), VPHA(MX,MX), WGT(MX,MX), PPHA(MX,MX),
     *          UNIF(MX,MX), PHAMOD(MX,MX)
      COMPLEX   ACPLX(MX,MX), SCPLX(MX,MX)
      COMMON /BUFRS/ WAMP, WPHA, VCPLX
C                                       Depends on the factor 2 above
C                                       VAMP/VPHA must NOT equiv VCPLX
      EQUIVALENCE (PATCH, PHAMOD(1,1))
      EQUIVALENCE (VAMP,  WAMP(1,1))
      EQUIVALENCE (VPHA,  WAMP(1,1+MXEQ))
      EQUIVALENCE (PAMP,  WAMP(1,1+2*MXEQ))
      EQUIVALENCE (PPHA,  WAMP(1,1+3*MXEQ))
      EQUIVALENCE (VDEV,  WPHA(1,1))
      EQUIVALENCE (WGT,   WPHA(1,1+1*MXEQ))
      EQUIVALENCE (UNIF,  WPHA(1,1+2*MXEQ))
      EQUIVALENCE (ACPLX, VCPLX(1,1))
      EQUIVALENCE (SCPLX, VCPLX(1,1+MXEQ))
C                                       wastes a little space
C                                       AAMP/APHA must equiv VCPLX
      EQUIVALENCE (AAMP,  VCPLX(1,1+2*MXEQ))
      EQUIVALENCE (APHA,  VCPLX(1,1+3*MXEQ))
LOCAL END
LOCAL INCLUDE 'HOLGR'
C                                       Local include for HOLGR.
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'HOLGRMX'
      LOGICAL    DODFT, DOXY, LINEAR, OPT(10), NOXYZ, NOZERO, UNIWT,
     *           X0Y0Z0
      INTEGER    LUNVIS, NPIX, INDVIS, ZIPA, ZIPV
      HOLLERITH  XINFIL(12), XOUTNA(3), XOPTYP(1)
      REAL       XOUTDI, TAPER(2), XMAG, FREQ, EL0, DIAM, SUBDIA, FOCUS,
     *           X0, Y0, Z0, XANT, XSTOK, MAPSZ, XNPIX, LMMIN, LMMAX,
     *           AMPSCL, XFT, XYMIN, XYMAX, XCNTRL, XLINEA, LPRM(5),
     *           MPRM(5), XOPT(10), XOFFS(4), DISCR, DUMMY(3)
      COMPLEX    XTALK
      REAL       LAMBDA, PHSGN
      CHARACTER  INFILE*48, OUTNAM*36, OPTYPE*4
      COMMON /INPARM/ XINFIL, XOUTNA, XOUTDI, TAPER, XOPTYP, XMAG, FREQ,
     *   EL0, DIAM, SUBDIA, FOCUS, X0, Y0, Z0, XANT, XSTOK, MAPSZ,
     *   XNPIX, LMMIN, LMMAX, AMPSCL, XFT, XYMIN, XYMAX, XCNTRL, XLINEA,
     *   LPRM, MPRM, XOPT, XTALK, XOFFS, DISCR, DUMMY
      COMMON /INTLOG/ NPIX, PHSGN, DODFT, ZIPA, X0Y0Z0, ZIPV, DOXY,
     *   LINEAR, OPT, LAMBDA, LUNVIS, NOXYZ, NOZERO, UNIWT, INDVIS
      COMMON /INCHAR/ INFILE, OUTNAM, OPTYPE
LOCAL END
      PROGRAM HOLGR
C-----------------------------------------------------------------------
C! Read and process holography visibility data
C# UV ANALYSIS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2007, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Driver task for the holography package under AIPS.
C   Adverbs:
C      INFILE(12)  Input visibility file name.
C      OUTNAME(3)  Output image name.
C      OUTDISK     Output disk number.
C      LMTAPER     Taper to apply in gridding.
C      OPTYPE      The feed model (prime focus or subreflector).
C      FACTOR      The magnification (for subreflector model).
C      APARM(10)   Operating parameters.
C                      1: Observing frequency (GHz).
C                      2: Satellite elevation, degrees.
C                      3: Antenna diameter, in metres.
C                      4: Subreflector diameter, in metres.
C                      5: Focal length, in metres.
C                      6: Default offset of the antenna vertex in x
C                         from the intersection of the azimuth and
C                         elevation axes, in metres.  See BPARM(9).
C                      7: As for 6 in the y direction.
C                      8: As for 6 in the z direction.
C                      9: 10000*refant+100*scanant+IF#
C                     10: Stokes (1-4; RR,LL,RL,LR)
C  mjk (4/feb/93) : aparm(9 & 10) are used in generating the input
C  and output filenames if triggered by INFILE = 'AREA:'.
C      BPARM(10)   Data reduction parameters.
C                      1: Required map size, in metres.
C                      2: Number of pixels on a side of the output
C                         map (power of 2, maximum 512).
C                    3,4: Range of |l| and |m| to include.  Negative
C                         values denote a range of SQRT(l*l + m*m).
C                      5: Amplitude scaling factor (0 -> 1).
C                      6: Fourier transform control.  If negative,
C                         the phase read from the data file is
C                         negated.  If the absolute value is 2, a
C                         direct (slow) Fourier transform will be
C                         done, otherwise, an FFT.
C                    7,8: Range of |l| and |m| used in correcting
C                         for pointing, focus, and feed offset.
C                         Negative values denote a range of
C                         SQRT(l*l + m*m).  See also BPARM(9).
C                      9: Decimal encoded control parameters
C                            1: inhibit phase unwrapping of the
C                               A_PHA map,
C                           10: inhibit determination of a phase
C                               ramp in the (l,m) data and use
C                               APARM(6,7,8) instead.
C                          100: inhibit phase unwrapping of the
C                               V_PHA map,
C                         1000: inhibit correction for pointing,
C                               focus, and feed offset;
C                         2000: inhibit focus and feed offset only.
C                         4000: inhibit the phase offset term.
C                          In general, you want to leave = 0.
C                     10: +1 for logarithmic amplitudes,
C                         -1 for linear amplitudes
C      CPARM(10)   Parameters for the regridding operation.
C                      1: Type of interpolation to apply in l,
C                          1: Pillbox,
C                          2: Exponential,
C                          3: Sinc,
C                          4: Sinc*Exponential,
C                          5: Spheroidal (default).
C   >>>>                   NEGATIVE means natural weighting
C                      2: Support size in l.
C                    3-5: Parameters defining the interpolation
C                         function in l.
C                   6-10: Corresponding parameters for m.
C      DPARM(10)   Output option flags.  The particular map will be
C                  stored if the associated DPARM is non-zero.  If
C                  all of the DPARM are zero, DPARM(4,5) are assumed
C                  to be set.
C                    1,2: Regridded amplitude and phase of the
C                         observed antenna beam pattern.
C                      3: Weights used in the regridding procedure.
C                    4,5: Derived amplitude and phase of the voltage
C                         distribution across the antenna aperture.
C                    6,7: Amplitude and phase of the point-spread
C                         function.  This indicates the blurring in
C                         the derived voltage distribution.
C                      8: Focus model corrections, in degrees.
C                      9: Map of the surface deviations of the
C                         antenna.
C                     10: The interpolated antenna power pattern.
C                         Oversampling is supported.  See HELP
C      XPARM(10)   Additional data reduction parameters.
C                    1,2: Cross-talk correction, amp & phase.
C                    3-6: Offset beam correction, azimuth and elevation
C                         offsets (deg), amplitude factor and phase
C                         offset (deg).
C   Notes:
C      1) The coordinate systems used here are as follows:
C
C         Antenna aperture coordinates are described by a right-handed
C         system, (x,y,z), centred on the point of intersection of the
C         azimuth and elevation axes.  The xy-plane is parallel to the
C         aperture plane; the x-axis is parallel to the elevation axis
C         and increases to the right as the dish is seen from above.
C         The y-axis increases towards the top of the dish; the z-axis
C         points skyward more-or-less along the optical axis.
C
C         (l,m,n) are the direction cosines which correspond to the
C         (x,y,z) coordinates.  Note that the (l,m) plane is projected
C         onto the sky with the l-axis in the direction of decreasing
C         azimuth and the n-axis towards increasing elevation.  It is
C         therefore left-handed as seen from the earth.
C
C      2) Prefix usage for the arrays:
C         A  denotes the antenna pattern, measured or interpolated.
C         S  denotes the sampling function in (l,m) space.
C         V  denotes the derived voltage distribution across the
C            antenna aperture.
C         P  denotes the point-spread function of the derived voltage
C            distribution.
C
C         A,V and S,P are Fourier transform pairs.
C
C   Authors: Mike Kesteven & Mark Calabretta, Australia Telescope.
C      Origin; 1987/11     Code last modified; 1996/08/20
C-----------------------------------------------------------------------
      INTEGER   IERR, KMAX, MVIS, NH, NVIS, ILG, IT, MXINC, MFAC, ID(3),
     *          WSTAT(6), XVIS
      REAL      AZPEAK, CELLLM, CELLXY, DFX, DFY, DFZ, DL, DM, DP0, DPX,
     *   DPY, DX0, DY0, DZ0, ELPEAK, F1, FAZ, FEL, FL, FM, FX, FY, FZ,
     *   L1, LKRNL(0:700), LPEAK, MGAIN(5), MKRNL(0:700), MPEAK, P0,
     *   PAMPMX, PAZ, PEL, PINC, PL, PM, PX, PY, RMAX, RMIN, RMS, RMS0,
     *   TGAIN(5), VAMPMX
      CHARACTER DATOBS*8, DATMAP*8, HISTRY(50)*72, INSTRM*8, OBJECT*8,
     *   OBSERV*8, TELESC*8, CHUV(2)*8, CHXY(2)*8, CHAZEL(2)*8,
     *   CHUNIT(5)*8
      INCLUDE 'HOLGR'
      REAL      XFTK(0:MX), YFTK(0:MX)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      DATA DATOBS, INSTRM, OBJECT, TELESC, OBSERV /5*' '/
      DATA CHXY, CHUV, CHAZEL /'X','Y','U','V','Az','El'/
      DATA CHUNIT /'VOLTS','DEGREES','METERS','DB',' '/
C-----------------------------------------------------------------------
C                                       Initialization.
      LUNVIS = 3
      CALL HOLINI (IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 990
         END IF
      CALL ZDATE (ID)
      WRITE (DATMAP,1001) ID
C                                       Cell sizes in (x,y) and (l,m).
      CELLXY = MAPSZ / NPIX
      CELLLM = LAMBDA / MAPSZ
C                                       Radii in pixel units.
      RMIN = (SUBDIA/2.0) / CELLXY
      RMAX = (DIAM/2.0) / CELLXY
C                                       Interpolate the visibilities
C                                       onto a regular grid.
      DL = 0.01
      DM = 0.01
      CALL KERNEL (LPRM, DL, LKRNL)
      CALL KERNEL (MPRM, DM, MKRNL)
      CALL GRID (NPIX, EL0, CELLLM, LKRNL, LPRM(2), DL, MKRNL, MPRM(2),
     *   DM, TAPER, XTALK, XOFFS, NVIS, MVIS, XVIS, AAMP, APHA, ACPLX,
     *   SCPLX, WGT, LPEAK, MPEAK, UNIWT, UNIF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       History text.
      WRITE (HISTRY(1),1020) TSKNAM, INFILE
      WRITE (HISTRY(2),1030) TSKNAM, FREQ, LAMBDA
      WRITE (HISTRY(3),1040) TSKNAM, EL0
      WRITE (HISTRY(4),1050) TSKNAM, DIAM
      WRITE (HISTRY(5),1060) TSKNAM, SUBDIA
      WRITE (HISTRY(6),1070) TSKNAM, FOCUS
      WRITE (HISTRY(7),1080) TSKNAM, MVIS, NVIS
      NH = 7
      IF (XOFFS(3).NE.0.0) THEN
         WRITE (HISTRY(8), 1081) TSKNAM, XVIS
         WRITE (HISTRY(9), 1082) TSKNAM, XOFFS(1), XOFFS(2)
         WRITE (HISTRY(10),1083) TSKNAM, XOFFS(3), XOFFS(4)*RAD2DG
         NH = 10
         END IF
C                                       Convert peak position to arcmin.
      AZPEAK = -ASIN (LPEAK/ COS(EL0*DG2RAD)) * RAD2DG * 60.0
      WRITE (MSGTXT,1085) AZPEAK
      CALL MSGWRT (3)
      NH = NH + 1
      HISTRY(NH) = TSKNAM // MSGTXT
      ELPEAK = ASIN (MPEAK) * RAD2DG * 60.0
      WRITE (MSGTXT,1086) ELPEAK
      CALL MSGWRT (3)
      NH = NH + 1
      HISTRY(NH) = TSKNAM // MSGTXT
C                                       Unwrap antenna pattern phase?
      IF (ZIPA.GT.0) THEN
         CALL ZIPAN (ZIPA, NPIX, RMAX, RMIN, WGT, AAMP, APHA, PATCH,
     *      WSTAT)
         WRITE (MSGTXT,1090) WSTAT(1)
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
C
         WRITE (MSGTXT,1094) WSTAT(2)
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
C
         WRITE (MSGTXT,1096) WSTAT(3)
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
C
         IF (ZIPA.GT.1) THEN
            WRITE (MSGTXT,1098) WSTAT(4)
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
C
            WRITE (MSGTXT,1094) WSTAT(5)
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
C
            WRITE (MSGTXT,1100) WSTAT(6)
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
            END IF
         END IF
C                                       Correct the visibilities for the
C                                       antenna offset.
      IF (X0Y0Z0) THEN
         CALL XYZOFS (LAMBDA, CELLLM, NPIX, WGT, APHA, ACPLX, X0, Y0,
     *      Z0, DX0, DY0, DZ0, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1110)
            CALL MSGWRT (6)
            END IF
         END IF
      IF (X0Y0Z0) THEN
         WRITE (MSGTXT,1120) X0, DX0
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
         WRITE (MSGTXT,1130) Y0, DY0
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
         WRITE (MSGTXT,1140) Z0, DZ0
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
      ELSE
         WRITE (MSGTXT,1150) X0
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
         WRITE (MSGTXT,1160) Y0
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
         WRITE (MSGTXT,1170) Z0
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
         END IF
      NH = NH + 1
      WRITE (HISTRY(NH),1180) TSKNAM, MAPSZ, NPIX
      NH = NH + 1
      WRITE (HISTRY(NH),1190) TSKNAM, LMMIN, LMMAX
      NH = NH + 1
      WRITE (HISTRY(NH),1200) TSKNAM, AMPSCL
      IF (DODFT) THEN
         IF (PHSGN.LT.0) WRITE (HISTRY(NH),1210) TSKNAM
         IF (PHSGN.GT.0) WRITE (HISTRY(NH),1220) TSKNAM
      ELSE
         IF (PHSGN.LT.0) WRITE (HISTRY(NH),1230) TSKNAM
         IF (PHSGN.GT.0) WRITE (HISTRY(NH),1240) TSKNAM
         END IF
      NH = NH + 1
      WRITE (HISTRY(NH),1250) TSKNAM, XYMIN, XYMAX
      NH = NH + 1
      WRITE (HISTRY(NH),1260) TSKNAM, LPRM
      NH = NH + 1
      WRITE (HISTRY(NH),1270) TSKNAM, MPRM
      NH = NH + 1
      WRITE (HISTRY(NH),1280) TSKNAM, OPT
C                                       Save the regridded maps if
C                                       required.  Store the amplitude
C                                       part of the antenna pattern.
      IF (OPT(1)) THEN
         OUTNAM(13:18) = 'A_AMP'
         CALL HOLOUT (OUTNAM, OBJECT, TELESC, INSTRM, OBSERV, DATOBS,
     *      DATMAP, FREQ, CHUNIT(1), CHUV(1), NPIX, -CELLLM, CHUV(2),
     *      NPIX, CELLLM, AAMP, HISTRY, NH, MVIS, IERR)
         END IF
C                                       Store phase part of ant pattern
      IF (OPT(2)) THEN
         OUTNAM(13:18) = 'A_PHA'
         CALL HOLOUT (OUTNAM, OBJECT, TELESC, INSTRM, OBSERV, DATOBS,
     *      DATMAP, FREQ, CHUNIT(2), CHUV(1), NPIX, -CELLLM, CHUV(2),
     *      NPIX, CELLLM, APHA, HISTRY, NH, MVIS, IERR)
         END IF
C                                       Store the weighting function
      IF (OPT(3)) THEN
         OUTNAM(13:18) = 'WGT'
         CALL HOLOUT (OUTNAM, OBJECT, TELESC, INSTRM, OBSERV, DATOBS,
     *      DATMAP, FREQ, CHUNIT(5), CHUV(1), NPIX, -CELLLM, CHUV(2),
     *      NPIX, CELLLM, WGT, HISTRY, NH, MVIS, IERR)
         END IF
C                                       Compute the aperture voltage
C                                       distribution and point-spread
C                                       function.
      IF (OPT(4) .OR. OPT(5) .OR. OPT(6) .OR. OPT(7) .OR. OPT(8). OR.
     *   OPT(9) .OR. OPT(10)) THEN
C                                       Direct Fourier Transform.
         IF (DODFT) THEN
            CALL DFT (LAMBDA, NPIX, CELLXY, CELLXY, XTALK, VAMP, VPHA,
     *         PAMP, PPHA, VAMPMX, IERR)
C                                       Compute the gridding correction
         ELSE
            KMAX = NINT(LPRM(2)/DL)
            CALL FTKRNL (LKRNL, DL, KMAX, NPIX, XFTK)
            KMAX = NINT(MPRM(2)/DM)
            CALL FTKRNL (MKRNL, DM, KMAX, NPIX, YFTK)
C                                       Fast Fourier Transform.
            IF (OPT(4) .OR. OPT(5) .OR. OPT(8) .OR. OPT(9) .OR.
     *         OPT(10)) THEN
               CALL HOLFFT (-1, NPIX, ACPLX, VAMP, VPHA)
               CALL GRIDCR (XFTK, YFTK, NPIX, VAMP, VAMPMX)
               END IF
            IF (OPT(6) .OR. OPT(7)) THEN
               CALL HOLFFT (-1, NPIX, SCPLX, PAMP, PPHA)
               CALL GRIDCR (XFTK, YFTK, NPIX, PAMP, PAMPMX)
               END IF
            END IF
C                                       Report resulting amplitude.
         WRITE (MSGTXT,1290) VAMPMX
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
C                                       Blank shadowed and empty areas
         CALL BLANK (RMAX, RMIN, NPIX, VPHA)
C                                       Unwrap the phase map.
         IF (ZIPV.GT.0) THEN
            CALL UNWRAP (ZIPV, NPIX, RMAX, RMIN, VAMP, DISCR, VPHA,
     *         PATCH, WSTAT, IERR)
            IF (IERR.NE.0) THEN
               MSGTXT = 'Error unwrapping the V_PHA phase map.'
               CALL MSGWRT (6)
               END IF
C
            WRITE (MSGTXT,1300) WSTAT(1)
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
C
            WRITE (MSGTXT,1304) WSTAT(2)
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
C
            WRITE (MSGTXT,1306) WSTAT(3)
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
C
            IF (ZIPV.GT.1) THEN
               WRITE (MSGTXT,1308) WSTAT(4)
               CALL MSGWRT (3)
               NH = NH + 1
               HISTRY(NH) = TSKNAM // MSGTXT
C
               WRITE (MSGTXT,1304) WSTAT(5)
               CALL MSGWRT (3)
               NH = NH + 1
               HISTRY(NH) = TSKNAM // MSGTXT
C
               WRITE (MSGTXT,1310) WSTAT(6)
               CALL MSGWRT (3)
               NH = NH + 1
               HISTRY(NH) = TSKNAM // MSGTXT
               END IF
            END IF
C                                       Correct phase for pointing,
C                                       focus, and feed offset.
         IF (DOXY) THEN
            CALL FLATPH (OPTYPE, XMAG, NPIX, LAMBDA, FOCUS, XYMIN,
     *         XYMAX, CELLXY, VAMP, VPHA, P0, PX, PY, FX, FY, FZ,
     *         DP0, DPX, DPY, DFX, DFY, DFZ, RMS0, RMS, IERR, NOXYZ,
     *         NOZERO, PHAMOD)
            IF (OPTYPE.EQ.'PFOC') THEN
               MSGTXT = 'Prime focus phase model'
            ELSE
               WRITE (MSGTXT,1330) XMAG
               END IF
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
C                                       Convert offsets to
C                                       direction cosines.
            PL = -(LAMBDA*PX/360.0)/CELLXY
            PM = -(LAMBDA*PY/360.0)/CELLXY
            FL = -(0.001*FX/FOCUS)*0.85
            FM = -(0.001*FY/FOCUS)*0.85
C                                       Convert to (Az,El) offsets
C                                       in arcmin.
            PAZ = -ASIN (PL / COS(EL0*DG2RAD)) * RAD2DG * 60.0
            PEL =  ASIN (PM) * RAD2DG * 60.0
            FAZ = -ASIN (FL / COS(EL0*DG2RAD)) * RAD2DG * 60.0
            FEL =  ASIN (FM) * RAD2DG * 60.0
C
            CALL BLANK (RMAX, RMIN, NPIX, PHAMOD)
            WRITE (MSGTXT,1340) P0, DP0
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
            WRITE (MSGTXT,1350) PX, DPX
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
            WRITE (MSGTXT,1360) PY, DPY
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
            WRITE (MSGTXT,1370) FX, DFX
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
            WRITE (MSGTXT,1380) FY, DFY
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
            WRITE (MSGTXT,1390) FZ, DFZ
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
            MSGTXT = 'Equivalent pointing offsets:'
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
            WRITE (MSGTXT,1400) PAZ
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
            WRITE (MSGTXT,1410) PEL
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
            WRITE (MSGTXT,1420) FAZ
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
            WRITE (MSGTXT,1430) FEL
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
            WRITE (MSGTXT,1440) PAZ+FAZ
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
            WRITE (MSGTXT,1450) PEL+FEL
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
            WRITE (MSGTXT,1460) RMS0
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
            WRITE (MSGTXT,1470) RMS
            CALL MSGWRT (3)
            NH = NH + 1
            HISTRY(NH) = TSKNAM // MSGTXT
         ELSE
            NH = NH + 1
            HISTRY(NH) = TSKNAM // 'Phase correction suppressed.'
            END IF
C                                       Compute surface deviation map.
         CALL SURDEV (CELLXY, LAMBDA, FOCUS, NPIX, VPHA, VDEV)
C                                       Compute beam gain at obs freq
         F1 = 1.0
         CALL ANGAIN (NPIX, MAPSZ, RMAX, RMIN, LAMBDA, VAMP, VPHA, F1,
     *      MGAIN(1), TGAIN(1))
         WRITE (MSGTXT,1480) MGAIN(1)
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
         WRITE (MSGTXT,1490) TGAIN(1)
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
C                               Compute the zero-rms gain
         F1 = 0.0
         CALL ANGAIN (NPIX, MAPSZ, RMAX, RMIN, LAMBDA, VAMP, VPHA, F1,
     *      MGAIN(1), TGAIN(1))
         WRITE (MSGTXT,1500) MGAIN(1)
         CALL MSGWRT (3)
C                                       K band estimate
         L1 = 0.0133
         F1 = LAMBDA/L1
         CALL ANGAIN (NPIX, MAPSZ, RMAX, RMIN, L1, VAMP, VPHA, F1,
     *      MGAIN(2), TGAIN(2))
         WRITE (MSGTXT,1510) MGAIN(2)
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
         WRITE (MSGTXT,1520) TGAIN(2)
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
         CALL ANGAIN (NPIX, MAPSZ, RMAX, RMIN, L1, VAMP, PHAMOD, F1,
     *      MGAIN(2), TGAIN(2))
         WRITE (MSGTXT,1530) MGAIN(2)
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
C                                       Q band estimate
         L1 = 0.007
         F1 = LAMBDA/L1
         CALL ANGAIN (NPIX, MAPSZ, RMAX, RMIN, L1, VAMP, VPHA, F1,
     *    MGAIN(3), TGAIN(3))
         WRITE (MSGTXT,1540) MGAIN(3)
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
         WRITE (MSGTXT,1550) TGAIN(3)
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
C                               Compute Gain loss due to feed offset
         CALL ANGAIN (NPIX, MAPSZ, RMAX, RMIN, L1, VAMP, PHAMOD, F1,
     *    MGAIN(3), TGAIN(3))
         WRITE (MSGTXT,1560) MGAIN(3)
         CALL MSGWRT (3)
         NH = NH + 1
         HISTRY(NH) = TSKNAM // MSGTXT
C                                       Store amplitude part of voltage
C                                       distribution
         IF (OPT(4)) THEN
            OUTNAM(13:18) = 'V_AMP'
            CALL HOLOUT (OUTNAM, OBJECT, TELESC, INSTRM, OBSERV, DATOBS,
     *         DATMAP, FREQ, CHUNIT(1), CHXY(1), NPIX, CELLXY, CHXY(2),
     *         NPIX, CELLXY, VAMP, HISTRY, NH, MVIS, IERR)
            END IF
C                                       Store phase part of voltage
C                                       distribution
         IF (OPT(5)) THEN
            OUTNAM(13:18) = 'V_PHA'
            CALL HOLOUT (OUTNAM, OBJECT, TELESC, INSTRM, OBSERV, DATOBS,
     *         DATMAP, FREQ, CHUNIT(2), CHXY(1), NPIX, CELLXY, CHXY(2),
     *         NPIX, CELLXY, VPHA, HISTRY, NH, MVIS, IERR)
            END IF
C                                       Store amplitude part of point
C                                       spread function
         IF (OPT(6)) THEN
            OUTNAM(13:18) = 'P_AMP'
            CALL HOLOUT (OUTNAM, OBJECT, TELESC, INSTRM, OBSERV, DATOBS,
     *         DATMAP, FREQ, CHUNIT(1), CHXY(1), NPIX, CELLXY, CHXY(2),
     *         NPIX, CELLXY, PAMP, HISTRY, NH, MVIS, IERR)
            END IF
C                                       Store phase part of point spread
C                                       function
         IF (OPT(7)) THEN
            OUTNAM(13:18) = 'P_PHA'
            CALL HOLOUT (OUTNAM, OBJECT, TELESC, INSTRM, OBSERV, DATOBS,
     *         DATMAP, FREQ, CHUNIT(2), CHXY(1), NPIX, CELLXY, CHXY(2),
     *         NPIX, CELLXY, PPHA, HISTRY, NH, MVIS, IERR)
            END IF
C                                       Store the model corrections
         IF (OPT(8)) THEN
            OUTNAM(13:18) = 'MODEL'
            CALL HOLOUT (OUTNAM, OBJECT, TELESC, INSTRM, OBSERV, DATOBS,
     *         DATMAP, FREQ, CHUNIT(2), CHXY(1), NPIX, CELLXY, CHXY(2),
     *         NPIX, CELLXY, PHAMOD, HISTRY, NH, MVIS, IERR)
            END IF
C                                       Store the surface deviation map
         IF (OPT(9)) THEN
            OUTNAM(13:18) = 'V_DEV'
            CALL HOLOUT (OUTNAM, OBJECT, TELESC, INSTRM, OBSERV, DATOBS,
     *         DATMAP, FREQ, CHUNIT(3), CHXY(1), NPIX, CELLXY, CHXY(2),
     *         NPIX, CELLXY, VDEV, HISTRY, NH, MVIS, IERR)
            END IF
         END IF
C                                       Compute the power pattern
      IF (OPT(10)) THEN
         MFAC = XOPT(10) + 0.75
         MFAC = MAX (MFAC, MXFAC)
         IT = (MXFAC*MX)/NPIX
         IF (MFAC.GT.IT) THEN
            MXINC = 2
            MFAC = IT
         ELSE
            MXINC = 1
            END IF
         ILG = MFAC*NPIX
         CALL BEAM (NPIX, ILG, MXINC, VAMP, VPHA, AAMP, APHA, VCPLX,
     *      WAMP, WPHA)
C                                       Store the power pattern.
         OUTNAM(13:18) = 'A_PWR'
         PINC = (RAD2DG*CELLLM*NPIX)/(MXINC*ILG)
         CALL HOLOUT (OUTNAM, OBJECT, TELESC, INSTRM, OBSERV, DATOBS,
     *      DATMAP, FREQ, CHUNIT(4), CHAZEL(1), NPIX, -PINC, CHAZEL(2),
     *      NPIX, PINC, AAMP, HISTRY, NH, MVIS, IERR)
         END IF
C                                       Compute the visibility coordinat
C                                       Clean up.
 990  CALL TSKEND (IERR)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' INITIATING HOLGR.')
 1001 FORMAT (I4.4,I2.2,I2.2)
 1010 FORMAT ('ERROR',I4,' READING/GRIDING THE VISIBILITIES.')
 1020 FORMAT (A,' Visibility file: ',A)
 1030 FORMAT (A,'    Observing frequency:',F9.4,' GHz, wavelength:',
     *   F10.6,' m')
 1040 FORMAT (A,'    Satellite elevation:',F8.3,' deg')
 1050 FORMAT (A,'       Antenna diameter:',F8.3,' m')
 1060 FORMAT (A,'  Subreflector diameter:',F8.3,' m')
 1070 FORMAT (A,'           Focal length:',F8.3,' m')
 1080 FORMAT (A,'      Visibilities used:',I7,' of',I7)
 1081 FORMAT (A,'        Offset beam vis:',I7)
 1082 FORMAT (A,'    Offset beam (Az,El):',2F8.3)
 1083 FORMAT (A,'  Offset beam amp/phase:',2F8.3)
 1085 FORMAT ('    Source offset in Az:',F10.2,' arcmin')
 1086 FORMAT ('    Source offset in El:',F10.2,' arcmin')
 1090 FORMAT (' Initial A_PHA wrapping:',I6)
 1094 FORMAT ('      Number of patches:',I6)
 1096 FORMAT ('         A_PHA wrapping:',I6)
 1098 FORMAT ('     Number of closures:',I6)
 1100 FORMAT ('   Final A_PHA wrapping:',I6)
 1110 FORMAT ('Error correcting for the antenna offset, continuing.')
 1120 FORMAT ('    Antenna offset in x:',F8.3,F7.3,' m')
 1130 FORMAT ('    Antenna offset in y:',F8.3,F7.3,' m')
 1140 FORMAT ('    Antenna offset in z:',F8.3,F7.3,' m')
 1150 FORMAT ('    Antenna offset in x:',F8.3,' m (as specified)')
 1160 FORMAT ('    Antenna offset in y:',F8.3,' m (as specified)')
 1170 FORMAT ('    Antenna offset in z:',F8.3,' m (as specified)')
 1180 FORMAT (A,'               Map size:',F8.3,' m,',I5,' pixels')
 1190 FORMAT (A,'            (l,m) range:',2F10.5)
 1200 FORMAT (A,'    Amplitude scaled by:',F8.3)
 1210 FORMAT (A,'      Fourier transform: DFT with phase negation')
 1220 FORMAT (A,'      Fourier transform: DFT without phase negation')
 1230 FORMAT (A,'      Fourier transform: FFT with phase negation')
 1240 FORMAT (A,'      Fourier transform: FFT without phase negation')
 1250 FORMAT (A,'            (x,y) range:',2F10.5,' m')
 1260 FORMAT (A,'Interpolation type in l: ',5F7.3)
 1270 FORMAT (A,'Interpolation type in m: ',5F7.3)
 1280 FORMAT (A,'    Output option flags: ',10L1)
 1290 FORMAT ('         Amplitude peak:',1P,E12.3)
 1300 FORMAT (' Initial V_PHA wrapping:',I6)
 1304 FORMAT ('      Number of patches:',I6)
 1306 FORMAT ('         V_PHA wrapping:',I6)
 1308 FORMAT ('     Number of closures:',I6)
 1310 FORMAT ('   Final V_PHA wrapping:',I6)
 1330 FORMAT ('Subreflector phase model with factor:',F6.2)
 1340 FORMAT ('           Phase offset:',F10.2,F9.2,' deg')
 1350 FORMAT ('    Phase gradient in x:',F10.2,F9.2,' deg/cell')
 1360 FORMAT ('    Phase gradient in y:',F10.2,F9.2,' deg/cell')
 1370 FORMAT (' Feed is offset in x by:',F10.2,F9.2,' mm')
 1380 FORMAT (' Feed is offset in y by:',F10.2,F9.2,' mm')
 1390 FORMAT (' Feed is offset in z by:',F10.2,F9.2,' mm')
 1400 FORMAT ('   Dish component in Az:',F10.2,' arcmin')
 1410 FORMAT ('   Dish component in El:',F10.2,' arcmin')
 1420 FORMAT ('   Feed component in Az:',F10.2,' arcmin')
 1430 FORMAT ('   Feed component in El:',F10.2,' arcmin')
 1440 FORMAT ('    Source offset in Az:',F10.2,' arcmin')
 1450 FORMAT ('    Source offset in El:',F10.2,' arcmin')
 1460 FORMAT (' Pre-fit weighted rms half-path error:',F8.3,' mm')
 1470 FORMAT ('Post-fit weighted rms half-path error:',F8.3,' mm')
 1480 FORMAT ('      Measured gain with observed illumination:',
     *  F7.2,' dB')
 1490 FORMAT ('    Theoretical gain with uniform illumination:',
     *  F7.2,' dB')
 1500 FORMAT ('                    Gain with no panel errors :',
     *  F7.2,' dB')
 1510 FORMAT ('22.5 GHz estimated gain (observed illumination) :',
     *  F7.2,' dB')
 1520 FORMAT ('22.5 GHz theoretical gain (uniform illumination):',
     *  F7.2,' dB')
 1530 FORMAT ('22.5 GHz estimated gain with only feed offset   :',
     *  F7.2,' dB')
 1540 FORMAT ('Q-band estimated gain (observed illumination) :',
     *  F7.2,' dB')
 1550 FORMAT ('Q-band theoretical gain (uniform illumination):',
     *  F7.2,' dB')
 1560 FORMAT ('Q-band estimated gain with only feed offset   :',
     *  F7.2,' dB')
      END
      SUBROUTINE HOLINI (IERR)
C-----------------------------------------------------------------------
C   HOLINI reads adverbs for HOLGR.
C   Returned:
C      IERR     I      Error status, 0 means success.
C   Returned in commons INPARM, INTLOG, INCHAR:
C      INFILE   C*48   Input visibility file name.
C      OUTNAM   C*36   WAWA image namestring.
C      FREQ     R      Observing frequency, in GHz.
C      LAMBDA   R      Observing wavelength, in metres.
C      EL0      R      Satellite elevation, in degrees.
C      DIAM     R      Antenna diameter, in metres.
C      SUBDIA   R      Subreflector diameter, in metres.
C      FOCUS    R      Focal length, in metres.
C      X0       R      Offset of the antenna vertex in (x,y,z)
C      Y0              from the intersection of the azimuth and
C      Z0              elevation axes, in metres.
C      MAPSZ    R      Size of the map, in metres.
C      NPIX     I      Number of pixels on a side of the map.
C      LMMIN    R      Range of |l| and |m| to include.  Negative
C      LMMAX           values denote a range of SQRT(l*l + m*m).
C      AMPSCL   R      Amplitude scaling factor.
C      PHSGN    R      Factor by which to multiply the measured phase.
C      DODFT    L      If true do a DFT, else an FFT.
C      XYMIN    R      Range of |x| and |y| used in correcting for
C      XYMAX    R      pointing, focus, and feed offset. Negative
C                      values denote a range of SQRT(x*x + y*y).
C      ZIPA     I      Antenna pattern map (A_PHA) unwrapping control
C                      flag
C                         0: No unwrapping.
C                         1: Unwrap closed discontinuities (PHAZIP).
C                         2: Perform closure operation (PHCLOS).
C      X0Y0Z0   L      If true, determine a phase ramp in the (l,m) data
C                      and correct for it.  Otherwise use (x0,y0,z0).
C      ZIPV     I      Antenna aperture plane (V_PHA) unwrapping control
C                      flag
C                         0: No unwrapping.
C                         1: Unwrap closed discontinuities (PHAZIP).
C                         2: Perform closure operation (PHCLOS).
C      DOXY     L      If true, correct the V_PHA map for pointing,
C                      focus, and feed offset.
C      LINEAR   L      If true, the input amplitudes are linear, else
C                      logarithmic
C      LPRM     R(5)   Interpolation parameters in l.
C      MPRM     R(5)   Interpolation parameters in m.
C      UNIWT    L      Uniform weighting flag
C      OPT      L(10)  Output option flags.
C      XTALK    CX     Cross-talk correction.
C      XOFFS    R(4)   Offset beam correction, azimuth and elevation
C                      offsets (deg), amplitude factor and phase
C                      offset (radian).
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      LOGICAL   ANY
      INTEGER   CONTRL, I, IA, IB, IIF, IROUND, IS, J, JTRIM, LN, OUTDI
      REAL      AMP, PHA
      CHARACTER CHOUTN*12, PRGNAM*6, STOK(4)*2
      INCLUDE 'HOLGR'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PUVD.INC'
      DATA PRGNAM /'HOLGR '/
      DATA STOK /'RR', 'LL', 'RL', 'LR'/
C-----------------------------------------------------------------------
C                                       Get the adverbs and restart AIPS
      CALL TSKBEG (PRGNAM, 70, XINFIL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING ADVERB VALUES'
         GO TO 995
         END IF
C                                       Decode the input file name.
      CALL H2CHR (48, 1, XINFIL, INFILE)
C                                       Construct default file name
      IA = XANT + 0.1
      IB = IA/10000
      IIF = MOD (IA, 100)
      IA = IA/100
      IA = MOD (IA, 100)
      IA = MAX (1, MIN (IA, MAXANT))
      IB = MAX (0, MIN (IB, MAXANT))
      IIF = MAX (0, MIN (IIF, MAXIF))
      IS = XSTOK + 0.1
      IS = MAX (1, MIN (IS, 4))
      IF (INFILE.EQ.'ANT' .OR. INFILE.EQ.' ') INFILE = 'FITS:'
      LN = JTRIM (INFILE)
      IF (INFILE(LN:LN).EQ.':') THEN
         WRITE (INFILE,1010) IA, IB, STOK(IS), IIF
         END IF
C                                       get frequency from INFILE
      CALL FRQGET (INFILE, LUNVIS, FREQ, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, ' FINDING FREQUENCY IN INFILE'
         GO TO 995
         END IF
C                                       Output file name (the class will
C                                       be filled in by HOLGR).
      CALL H2CHR (12, 1, XOUTNA, CHOUTN)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      IF (OPTYPE.NE.'SUBR') OPTYPE = 'PFOC'
C                                       also fix the output filename
      IF (CHOUTN.EQ.' ') CHOUTN = 'HOLO'
      LN = JTRIM (CHOUTN)
      IF (LN.LE.5) WRITE (CHOUTN(6:),1011) IA, IB, STOK(IS)
      OUTDI = IROUND (XOUTDI)
      CALL A2WAWA (CHOUTN, ' ', 0, 'MA', OUTDI, NLUSER, OUTNAM)
C                                       Observing parameters.
C                                       Observing frequency (GHz), and
C                                       wavelength (m).
      IF (FREQ.LE.0.0) THEN
         MSGTXT = 'HOLINI: The observing frequency MUST be specified.'
         GO TO 990
         END IF
      LAMBDA = VELITE/(FREQ*1.0E9)
C                                       Antenna diameter, in metres,
      IF (DIAM.LE.0.0) THEN
         MSGTXT = 'HOLINI: The antenna diameter MUST be specified.'
         GO TO 990
         END IF
C                                       Subreflector diameter, in metres
      IF (SUBDIA.LE.0.0) THEN
         MSGTXT = 'HOLINI: The subreflector diameter MUST be specified.'
         GO TO 990
         END IF
C                                       Focal length, in metres
      IF (FOCUS.LE.0.0) THEN
         MSGTXT = 'HOLINI: The focal length MUST be specified.'
         GO TO 990
         END IF
C                                       Compute the visibility coordinat
C                                       Data reduction parameters.
C                                       Actual map size, in metres.
      IF (MAPSZ.LE.0.0) THEN
         MSGTXT = 'HOLINI: The map size MUST be specified.'
         GO TO 990
         END IF
C                                       Compute the visibility coordinat
C                                       Output must be power of 2
      NPIX = IROUND (XNPIX)
      IF (NPIX.EQ.0) NPIX = MX
      LN = NPIX
      IF (NPIX.GT.MX) NPIX = MX
      IF (NPIX.LT.32) NPIX = 32
      I = 16
 10   I = I*2
      IF (I.GE.MX) GO TO 15
         IF (NPIX.GT.I .AND. NPIX.LT.I*2) NPIX = I*2
         GO TO 10
 15   IF (NPIX.NE.LN) THEN
         WRITE (MSGTXT,1015) LN, NPIX
         CALL MSGWRT (4)
         END IF
C                                       Amplitude scaling factor.
      IF (AMPSCL.EQ.0.0) AMPSCL = 1.0
C                                       Fourier transform control.
      CONTRL = IROUND (XFT)
      IF (CONTRL.EQ.0) CONTRL = 1
C                                       Phase negation.
      PHSGN = SIGN(1, CONTRL)
C                                       DFT or FFT?
      DODFT = ABS(CONTRL).EQ.2
C                                       Decode control parameters.
      CONTRL = IROUND (XCNTRL)
      NOZERO = .FALSE.
      NOXYZ  = .FALSE.
      DOXY   = .TRUE.
      ZIPV   = 2
      X0Y0Z0 = .TRUE.
      ZIPA   = 2
      IF (CONTRL.GE.4000) THEN
         NOZERO = .TRUE.
         CONTRL = MOD(CONTRL,4000)
         END IF
      IF (CONTRL.GE.2000) THEN
         NOXYZ = .TRUE.
         CONTRL = MOD(CONTRL,2000)
         END IF
      IF (CONTRL.GE.1000) THEN
         DOXY = .FALSE.
         CONTRL = MOD(CONTRL,1000)
         END IF
      IF (CONTRL.GE.200) THEN
         ZIPV = 0
         CONTRL = MOD(CONTRL,200)
         END IF
      IF (CONTRL.GE.100) THEN
         ZIPV = 1
         CONTRL = MOD(CONTRL,100)
         END IF
      IF (CONTRL.GE.10) THEN
         X0Y0Z0 = .FALSE.
         CONTRL = MOD(CONTRL,10)
         END IF
      IF (CONTRL.GE.2) THEN
         ZIPA = 0
         CONTRL = MOD(CONTRL,2)
         END IF
      IF (CONTRL.GE.1) THEN
         ZIPA = 1
         END IF
C                                       Input amp's linear OR log
      LINEAR = XLINEA.LT.0.0
      IF (X0Y0Z0) THEN
         X0 = 0.0
         Y0 = 0.0
         Z0 = 0.0
         END IF
C                                       Uniform weighting?
      IF (LPRM(1).LT.-0.01 .OR. MPRM(1).LT.-0.01) THEN
         UNIWT = .FALSE.
         LPRM(1) = ABS(LPRM(1))
         MPRM(1) = ABS(MPRM(1))
      ELSE
         UNIWT = .TRUE.
         END IF
C                                       Output option flags.
      ANY = .FALSE.
      DO 90 J = 1,10
         OPT(J) = XOPT(J).GT.0.0
         IF (OPT(J)) ANY = .TRUE.
 90      CONTINUE
      IF (.NOT.ANY) THEN
         OPT(4) = .TRUE.
         OPT(5) = .TRUE.
         END IF
C                                       Cross-talk correction.
      AMP = REAL(XTALK)
      PHA = AIMAG(XTALK)*DG2RAD
      XTALK = AMP*CMPLX(COS(PHA), SIN(PHA))
C                                       Offset beam correction.
      XOFFS(4) = XOFFS(4)*DG2RAD
      GO TO 999
C                                       Error.
 990  IERR = 1
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('HOLINI: ERROR',I3,' ON ',A)
 1010 FORMAT ('FITS:HOLO',I2.2,'-',I2.2,A2,I2.2)
 1011 FORMAT (I2.2,'-',I2.2,A2)
 1015 FORMAT ('HOLINI: Grid extent changed from',I5,' to',I5)
      END
      SUBROUTINE FRQGET (INFILE, LUN, FREQ, IERR)
C-----------------------------------------------------------------------
C   FRQGET reads INFILE for the frequency
C   Inputs:
C      INFILE   C*(*)   Text file name
C      LUN      I       LUN to use
C   Outputs:
C      FREQ     R       Frequency in GHz (changed if found)
C      IERR     I       0 -> ok and found, -1 => ok not found
C                       else error
C-----------------------------------------------------------------------
      CHARACTER INFILE*(*)
      INTEGER   LUN, IERR
      REAL      FREQ
C
      INTEGER   IND, J
      CHARACTER STR*132
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL ZTXOPN ('READ', LUN, IND, INFILE, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, ' OPEN INFILE'
         GO TO 990
         END IF
 20   CALL ZTXIO ('READ', LUN, IND, STR, IERR)
      IF (IERR.EQ.2) THEN
         GO TO 100
      ELSE IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READ INFILE'
         GO TO 990
      ELSE IF (STR(:1).EQ.'#') THEN
         J = INDEX (STR, 'Freq =')
         IF (J.GT.0) THEN
            J = J + 6
            READ (STR(J:),1020) FREQ
            GO TO 110
            END IF
         END IF
      GO TO 20
C                                       end of file
 100  IERR = -1
 110  CALL ZTXCLS (LUN, IND, J)
      GO TO 999
C
 990  CALL MSGWRT (8)
      IF (IND.GT.0) CALL ZTXCLS (LUN, IND, J)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FRQGET ERROR',I4,' ON ',A)
 1020 FORMAT (F13.9)
      END
      SUBROUTINE KERNEL (PRM, DL, KRNL)
C-----------------------------------------------------------------------
C   KERNEL constructs the kernel used for interpolation.
C
C   Given and returned:
C      PRM      R(5)   Parameters defining the interpolation function
C                        1: Type of interpolation function,
C                           1: Pillbox,
C                           2: Exponential,
C                           3: Sinc,
C                           4: Sinc*Exponential,
C                           5: Spheroidal (default).
C                        2: Support size in l.
C                      3-5: Parameters defining the function.
C                      On return PRM contains the actual parameters.
C      DL       R      Separation between the elements of KRNL in units
C                      of the cell spacing.
C
C   Returned:
C      KRNL     R(*)   Array containing one half of the interpolation
C                      function.
C
C   Author: Mark Calabretta, Australia Telescope.
C   Origin; 1988/Jan/21. Code last modified; 1989/Nov/01.
C-----------------------------------------------------------------------
      REAL      PRM(5), DL, KRNL(0:*)
C
      INTEGER   IALPHA, IERR, IFLAG, INTYP, ISUPP, J, JMAX
      REAL      ETA, L, PSI
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       Type of interpolation to apply.
       INTYP = NINT(PRM(1))
       IF (INTYP.LT.1 .OR. INTYP.GT.5) THEN
          PRM(1) = 5.0
          INTYP = 5
          END IF
C                                       Set default parameters.
C                                       Pillbox.
       IF (INTYP.EQ.1) THEN
          IF (PRM(2).LE.0.0) PRM(2) = 0.5
C                                       Exponential.
       ELSE IF (INTYP.EQ.2) THEN
          IF (PRM(2).LE.0.0) PRM(2) = 3.0
          IF (PRM(3).LE.0.0) PRM(3) = 1.0
          IF (PRM(4).LE.0.0) PRM(4) = 2.0
C                                       Sinc.
      ELSE IF (INTYP.EQ.3) THEN
         IF (PRM(2).LE.0.0) PRM(2) = 3.0
         IF (PRM(3).LE.0.0) PRM(3) = 1.14
C                                       Sinc*Exponential.
      ELSE IF (INTYP.EQ.4) THEN
         IF (PRM(2).LE.0.0) PRM(2) = 3.0
         IF (PRM(3).LE.0.0) PRM(3) = 1.55
         IF (PRM(4).LE.0.0) PRM(4) = 2.52
         IF (PRM(5).LE.0.0) PRM(5) = 2.0
C                                       Spheroidal.
      ELSE IF (INTYP.EQ.5) THEN
         IF (PRM(2).LE.0.0) PRM(2) = 3.0
         IF (PRM(3).LE.0.0) PRM(3) = 1.0
C                                       Check legality
         ISUPP  = NINT(2.0*PRM(2))
         IF (ISUPP.LT.4) ISUPP = 4
         IF (ISUPP.GT.8) ISUPP = 8
         PRM(2) = ISUPP/2.0
         IALPHA = NINT(2.0*PRM(3) + 1.0)
         IF (IALPHA.LT.1) IALPHA = 1
         IF (IALPHA.GT.5) IALPHA = 5
         PRM(3) = (IALPHA-1)/2.0
         IFLAG  = 0
         END IF
C                                       Radius of support.
      JMAX = NINT(PRM(2)/DL)
      IF (JMAX.GT.700) JMAX = 700
      PRM(2) = JMAX*DL
C                                       Pillbox.
      IF (INTYP.EQ.1) THEN
         DO 10 J = 0, JMAX
            L = J*DL
            KRNL(J) = 1.0
            IF (J.EQ.JMAX) KRNL(J) = 0.5
 10         CONTINUE
C                                       Exponential.
      ELSE IF (INTYP.EQ.2) THEN
         DO 20 J = 0, JMAX
            L = J*DL
            KRNL(J) = EXP(-((L/PRM(3))**PRM(4)))
 20         CONTINUE
C                                       Sinc.
      ELSE IF (INTYP.EQ.3) THEN
         KRNL(0) = 1.0
         DO 30 J = 1, JMAX
            L = J*DL
            KRNL(J) = SIN(PI*L/PRM(3))/(PI*L/PRM(3))
 30         CONTINUE
C                                       Sinc*Exponential.
      ELSE IF (INTYP.EQ.4) THEN
         KRNL(0) = 1.0
         DO 40 J = 1, JMAX
            L = J*DL
            KRNL(J) = SIN(PI*L/PRM(3))/(PI*L/PRM(3))*
     *         EXP(-((L/PRM(4))**PRM(5)))
 40         CONTINUE
C                                       Compute the visibility coordinat
C                                       Spheroidal.
      ELSE IF (INTYP.EQ.5) THEN
         DO 50 J = 0, JMAX
            L = J*DL
            ETA = REAL(J)/REAL(JMAX)
            CALL SPHFN (IALPHA, ISUPP, IFLAG, ETA, PSI, IERR)
            KRNL(J) = PSI
 50         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE GRID (NPIX, EL0, CELLLM, LKRNL, SL, DL, MKRNL, SM, DM,
     *   TAPER, XTALK, XOFFS, NVIS, MVIS, XVIS, AAMP, APHA, ACPLX,
     *   SCPLX, WGT, LPEAK, MPEAK, UNIWT, UNIF, IERR)
C-----------------------------------------------------------------------
C   GRID grids the visibility data for the holography routines.
C
C   Given:
C      NPIX     I        Number of pixels on a side of the map.
C      EL0      R        Satellite elevation, in degrees.
C      CELLLM   R        Cell spacing in the (l,m) plane.
C      LKRNL    R(*)     Array containing one half of the
C                        interpolation function in l.
C      SL       R        Support radius for LKRNL, in cell units.
C      DL       R        Separation between the elements of LKRNL in
C                        units of the cell spacing.
C      MKRNL    R(*)     Array containing one half of the
C                        interpolation function in m.
C      SM       R        Support radius for MKRNL, in cell units.
C      DM       R        Separation between the elements of MKRNL in
C                        units of the cell spacing.
C      TAPER    R(2)     Taper type and width to 0.5, in cells.
C      XTALK    CX       Cross-talk correction.
C      XOFFS    R(4)     Azimuth and elevation offset (deg), amplitude
C                        factor and phase correction (radian) for offset
C                        beam correction.
C
C   Returned:
C      NVIS     I        Number of visibilities read.
C      MVIS     I        Number of visibilities used.
C      XVIS     I        Number of offset visibilities subtracted.
C      AAMP     R(NPIX,NPIX)
C                        The amplitude and phase of the antenna pattern,
C                        in a form suitable for output.
C      APHA     R(NPIX,NPIX)
C                        The amplitude and phase of the antenna pattern,
C                        in a form suitable for output.
C      ACPLX    CX(NPIX,NPIX)
C                        Regridded antenna pattern.
C      SCPLX    CX(NPIX,NPIX)
C                        Regridded sampling function.
C      WGT      R(NPIX,NPIX)
C                        Weight function from the interpolation.
C      LPEAK    R        Beam peak position.
C      MPEAK    R
C      UNIF     R(NPIX,NPIX)
C                        Uniform weighting summing area
C      IERR     I        Error status, 0 means success.
C
C   Called: {HGETVS}
C
C   Algorithm:
C      Convolution with a kernel of limited support size.
C
C   Author: Mark Calabretta, Australia Telescope.
C   Origin; 1987/11      Code last modified; 1996/07/17
C-----------------------------------------------------------------------
      LOGICAL   UNIWT
      INTEGER   IERR, MVIS, NPIX, NVIS, XVIS
      REAL      AAMP(NPIX,NPIX), APHA(NPIX,NPIX), CELLLM, DL, DM, EL0,
     *          SL, SM, TAPER(2), LKRNL(0:*), UNIF(NPIX,NPIX), LPEAK,
     *          MKRNL(0:*), MPEAK, WGT(NPIX,NPIX), XOFFS(4)
      COMPLEX   ACPLX(NPIX,NPIX), SCPLX(NPIX,NPIX), XTALK
C
      LOGICAL   DOOFFS, FRESH
      INTEGER   IL, IL1, IL2, ILMAX, IM, IMMAX, IM1, IM2, IOFFL, IOFFM,
     *          IROUND, ML, MM, NHALF, NMISS, TAPTYP
      REAL      AMP, AMPMAX, AZOFF, COSAZO, COSEL, COSEL0, CS, EL,
     *          ELOFF, FACT, L, M, N, OFFL, OFFM, PHA, SHFTL, SHFTM,
     *          SINAZO, SINEL, SINEL0, SN, T1, T2, TAPARM, WT
      COMPLEX   VIS
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       Initialization.
      DOOFFS = XOFFS(3).NE.0.0
C                                       Zero the output arrays.
      DO 20 IM = 1, NPIX
         DO 10 IL = 1, NPIX
            ACPLX(IL,IM) = (0.0, 0.0)
            SCPLX(IL,IM) = (0.0, 0.0)
            UNIF(IL,IM) = 0.0
            WGT(IL,IM)  = 0.0
 10         CONTINUE
 20      CONTINUE
C                                       Taper type
      TAPTYP = IROUND (TAPER(1))
      IF (TAPTYP.LE.0 .OR. TAPTYP.GT.3) TAPTYP = 0
      IF (TAPER(2).LE.3.) TAPER(2) =  NPIX/3.0
      IF (TAPTYP.EQ.1) THEN
         TAPARM = -ALOG(2.0)/(CELLLM*TAPER(2))**2
      ELSE IF (TAPTYP.EQ.2) THEN
         TAPARM = -ALOG(2.0)/(CELLLM*TAPER(2))
      ELSE IF (TAPTYP.EQ.3) THEN
         TAPARM = 0.5/(CELLLM*TAPER(2))
         END IF
C                                       Uniform weighting
      IF (UNIWT) THEN
C                                       loop through all visibilities
         NVIS = 0
         MVIS = 0
         NMISS = 0
 30      CALL HGETVS (NVIS, AZOFF, ELOFF, L, M, N, AMP, PHA, IERR)
         IF (IERR.EQ.0) THEN
            IL = NINT(L/CELLLM) + 1
            IF (IL.LT.1) IL = IL + NPIX
            IM = NINT(M/CELLLM) + 1
            IF (IM.LT.1) IM = IM + NPIX
            IF (IL.LT.1 .OR. IL.GT.NPIX .OR.
     *          IM.LT.1 .OR. IM.GT.NPIX) THEN
               NMISS = NMISS + 1
            ELSE
               UNIF(IL,IM) = UNIF(IL,IM) + 1.0
               MVIS = MVIS + 1
               END IF
            GO TO 30
            END IF
         IF (NMISS.GT.0) THEN
            WRITE (MSGTXT,1030) NMISS
            CALL MSGWRT (6)
            END IF
         IF (MVIS.LE.0) THEN
            MSGTXT = 'NO VALID DATA FOUND: CHECK INPUTS'
            CALL MSGWRT (8)
            IERR = 8
            GO TO 999
            END IF
         END IF
      NHALF = NPIX/2
C                                       Interpolate the visibilities
C                                       onto the (l,m) plane.
C                                       Loop through the data file.
      NVIS = 0
      MVIS = 0
      XVIS = 0
      NMISS = 0
 40   CALL HGETVS (NVIS, AZOFF, ELOFF, L, M, N, AMP, PHA, IERR)
         IF (IERR.NE.0) GO TO 70
         FRESH = .TRUE.
C                                       Get grid coordinates.
 45      IL = NINT(L/CELLLM) + 1
         IF (IL.LT.1) IL = IL + NPIX
         IM = NINT(M/CELLLM) + 1
         IF (IM.LT.1) IM = IM + NPIX
         IF (IL.LT.1 .OR. IL.GT.NPIX .OR. IM.LT.1 .OR. IM.GT.NPIX) THEN
            IF (FRESH) NMISS = NMISS + 1
            GO TO 40
            END IF
C                                       Uniform weighting?
         IF (UNIWT) THEN
            IF (UNIF(IL,IM).LE.0.0) GO TO 40
            FACT = 1.0/UNIF(IL,IM)
         ELSE
            FACT = 1.0
            END IF
C                                       taper
         IF (TAPTYP.EQ.1) THEN
            FACT = FACT*EXP(TAPARM*(L*L + M*M))
         ELSE IF (TAPTYP.EQ.2) THEN
            FACT = FACT*EXP(TAPARM*SQRT(L*L + M*M))
         ELSE IF (TAPTYP.EQ.3) THEN
            FACT = FACT*(1.0 - TAPARM*SQRT(L*L + M*M))
            END IF
         FACT = MAX(0.0, FACT)
C                                       Range of pixels within the
C                                       support size.  Ensure that IL1
C                                       and IM1 are rounded up, with IL2
C                                       and IM2 rounded down.
         IL1 = INT(L/CELLLM - SL - 9999.0) + 9999
         IL2 = INT(L/CELLLM + SL + 9999.0) - 9999
         IM1 = INT(M/CELLLM - SM - 9999.0) + 9999
         IM2 = INT(M/CELLLM + SM + 9999.0) - 9999
         IF (IL1.LT.-NHALF) IL1 = -NHALF
         IF (IL1.GE.NHALF)  GO TO 40
         IF (IL2.LT.-NHALF) GO TO 40
         IF (IL2.GE.NHALF)  IL2 = NHALF - 1
         IF (IM1.LT.-NHALF) IM1 = -NHALF
         IF (IM1.GE.NHALF)  GO TO 40
         IF (IM2.LT.-NHALF) GO TO 40
         IF (IM2.GE.NHALF)  IM2 = NHALF - 1
C                                       Count this visibility.
         IF (FRESH) THEN
            MVIS = MVIS + 1
         ELSE
            XVIS = XVIS + 1
            END IF
C                                       Compute the complex visibility.
         CS  = AMP*COS(PHA)
         SN  = AMP*SIN(PHA)
         VIS = CMPLX(CS, SN)
C                                       Add visibility into the grid.
         DO 60 IM = IM1, IM2
            MM = IM + 1
            IF (MM.LT.1) MM = MM + NPIX
            OFFM  = IM - M/CELLLM
            IOFFM = ABS(NINT(OFFM/DM))
            DO 50 IL = IL1, IL2
               ML = IL + 1
               IF (ML.LT.1) ML = ML + NPIX
               OFFL  = IL - L/CELLLM
               IOFFL = ABS(NINT(OFFL/DL))
               WT = LKRNL(IOFFL)*MKRNL(IOFFM)*FACT
               ACPLX(ML,MM) = ACPLX(ML,MM) + VIS*WT
               SCPLX(ML,MM) = SCPLX(ML,MM) + (1.0,0.0)*WT
               WGT(ML,MM)   =   WGT(ML,MM) + WT
 50            CONTINUE
 60         CONTINUE
C                                       Offset beam subtraction.
         IF (DOOFFS .AND. FRESH) THEN
            AZOFF = AZOFF + XOFFS(1)
            ELOFF = ELOFF + XOFFS(2)
C
            EL = EL0 + ELOFF
            COSEL0 = COS(EL0*DG2RAD)
            SINEL0 = SIN(EL0*DG2RAD)
            COSAZO = COS(AZOFF*DG2RAD)
            SINAZO = SIN(AZOFF*DG2RAD)
            COSEL  = COS(EL*DG2RAD)
            SINEL  = SIN(EL*DG2RAD)
C
            L =  SINAZO*COSEL0
            M = -COSAZO*COSEL0*SINEL + SINEL0*COSEL
            N =  COSAZO*COSEL0*COSEL + SINEL0*SINEL
C
            AMP = -AMP * XOFFS(3)
            PHA =  PHA + XOFFS(4)
            FRESH = .FALSE.
            GO TO 45
            END IF
      GO TO 40
C                                       done
 70   IF (NMISS.GT.0 .AND. .NOT.UNIWT) THEN
         WRITE (MSGTXT,1030) NMISS
         CALL MSGWRT (6)
         END IF
      IF (MVIS.LE.0) THEN
         MSGTXT = 'NO VALID DATA FOUND: CHECK INPUTS'
         CALL MSGWRT (8)
         IERR = 8
         GO TO 999
         END IF
C
      WRITE (MSGTXT,1070) MVIS, NVIS
      CALL MSGWRT (3)
      IF (DOOFFS) THEN
         WRITE (MSGTXT,1080) XVIS
         CALL MSGWRT (3)
         END IF
C
      IF (IERR.EQ.-1) IERR = 0
      IF (IERR.NE.0) THEN
         MSGTXT = 'GRID: ERROR READING THE VISIBILITY FILE'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Apply cross-talk correction.
      IF (XTALK.NE.(0.0,0.0)) THEN
         DO 90 IM = 1, NPIX
            DO 80 IL = 1, NPIX
               ACPLX(IL,IM) = ACPLX(IL,IM) - XTALK
 80            CONTINUE
 90         CONTINUE
         END IF
C                                       Compute the amplitude and phase,
C                                       and reorganize them and the
C                                       weight for output.
      AMPMAX = 0.0
      MM = NPIX/2
      DO 110 IM = 1, NPIX/2
         MM = MM + 1
         ML = NPIX/2
         DO 100 IL = NPIX, 1, -1
            ML = ML + 1
            IF (ML.GT.NPIX) ML = ML - NPIX
C
            T1 = REAL(ACPLX(ML,MM))
            T2 = AIMAG(ACPLX(ML,MM))
            AAMP(IL,IM) = SQRT(T1*T1 + T2*T2)
            IF (AAMP(IL,IM).GT.AMPMAX) THEN
               ILMAX = IL
               IMMAX = IM
               AMPMAX = AAMP(IL,IM)
               END IF
            IF (T1.EQ.0.0 .AND. T2.EQ.0.0) THEN
               APHA(IL,IM) = 0.0
            ELSE
               APHA(IL,IM) = ATAN2(T2, T1)*RAD2DG
               END IF
C
            T1 = REAL(ACPLX(IL,IM))
            T2 = AIMAG(ACPLX(IL,IM))
            AAMP(ML,MM) = SQRT(T1*T1 + T2*T2)
            IF (AAMP(ML,MM).GT.AMPMAX) THEN
               ILMAX = ML
               IMMAX = MM
               AMPMAX = AAMP(ML,MM)
               END IF
            IF (T1.EQ.0.0 .AND. T2.EQ.0.0) THEN
               APHA(ML,MM) = 0.0
            ELSE
               APHA(ML,MM) = ATAN2(T2, T1)*RAD2DG
               END IF
C
            WT = WGT(IL,IM)
            WGT(IL,IM) = WGT(ML,MM)
            WGT(ML,MM) = WT
 100        CONTINUE
 110     CONTINUE
C
      SHFTM = 1.0
      DO 130 IM = 1, NPIX
         SHFTL = SHFTM
         DO 120 IL = 1, NPIX
            ACPLX(IL,IM) = SHFTL*ACPLX(IL,IM)
            SCPLX(IL,IM) = SHFTL*SCPLX(IL,IM)
            SHFTL = -SHFTL
 120        CONTINUE
         SHFTM = -SHFTM
 130     CONTINUE
C                                       Find peak position.
      LPEAK = (AAMP(ILMAX-1,IMMAX) - AAMP(ILMAX+1,IMMAX))/
     *        2.0*(AAMP(ILMAX+1,IMMAX) - 2.0*AAMP(ILMAX,IMMAX) +
     *        AAMP(ILMAX-1,IMMAX))
      MPEAK = (AAMP(ILMAX,IMMAX-1) - AAMP(ILMAX,IMMAX+1))/
     *        2.0*(AAMP(ILMAX,IMMAX+1) - 2.0*AAMP(ILMAX,IMMAX) +
     *        AAMP(ILMAX,IMMAX-1))
      LPEAK = -(ILMAX+LPEAK - NHALF)*CELLLM
      MPEAK =  (IMMAX+MPEAK - NHALF - 1)*CELLLM
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('GRID:',I7,' SAMPLES WERE OUTSIDE THE GRID AREA')
 1070 FORMAT ('Gridded',I7,' visibilities of',I7,' read.')
 1080 FORMAT ('Gridded',I7,' offset visibilities.')
      END
      SUBROUTINE ZIPAN (ZIPA, NPIX, RMAX, RMIN, WGT, AAMP, APHA, PATCH,
     *   WSTAT)
C-----------------------------------------------------------------------
C   ZIPAN unwraps the antenna pattern phase map.
C
C   Given:
C      ZIPA     I        Antenna pattern map (A_PHA) unwrapping control
C                        flag
C                           0: No unwrapping.
C                           1: Unwrap closed discontinuities (PHAZIP).
C                           2: Perform closure operation (PHCLOS).
C      NPIX     I        Number of pixels on a side of the map.
C      RMAX     R        The antenna radius, in cell units.
C      RMIN     R        Sub-reflector radius, in cell units.
C      WGT      R(NPIX,NPIX)
C                        Weight function from the interpolation.
C      AAMP     R(NPIX,NPIX)
C                        The amplitude of the antenna pattern.
C
C   Given and returned:
C      APHA     R(NPIX,NPIX)
C                        The antenna pattern phase.
C      PATCH    I(NPIX,NPIX)
C                        Scratch array.
C
C   Returned:
C      WSTAT    I(6)     Unwrapping statistics:
C                           1) Initial phase unwrapping index.
C                           2) Number of patches unwrapped before
C                              contour closing.
C                           3) Intermediate phase unwrapping index.
C                           4) Number of contour closures.
C                           5) Number of patches unwrapped after contour
C                              closing.
C                           6) Final phase unwrapping index.
C
C   Author: Mark Calabretta, Australia Telescope.
C   Origin; 1996/07/18  Code last modified; 1996/08/20
C-----------------------------------------------------------------------
      INTEGER   NPIX, PATCH(NPIX,NPIX), WSTAT(6), ZIPA
      REAL      AAMP(NPIX,NPIX), APHA(NPIX,NPIX), RMAX, RMIN,
     *          WGT(NPIX,NPIX)
C
      INTEGER   IERR, IL, IM
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Set zero weight pixels to blank
      DO 20 IM = 1, NPIX
         DO 10 IL = 1, NPIX
            IF (WGT(IL,IM).EQ.0.0) APHA(IL,IM) = FBLANK
 10         CONTINUE
 20      CONTINUE
C                                       Do phase unwrapping.
      CALL UNWRAP (ZIPA, NPIX, RMAX, RMIN, AAMP, 0.0, APHA, PATCH,
     *   WSTAT, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'ZIPAN: Error unwrapping the A_PHA phase map.'
         CALL MSGWRT (6)
         END IF
C                                       Set blanked pixels to zero.
      DO 40 IM = 1, NPIX
         DO 30 IL = 1, NPIX
            IF (WGT(IL,IM).EQ.0.0) APHA(IL,IM) = 0.0
 30         CONTINUE
 40      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE XYZOFS (LAMBDA, CELLLM, NPIX, WGT, APHA, ACPLX, X0, Y0,
     *   Z0, DX0, DY0, DZ0, IERR)
C-----------------------------------------------------------------------
C   XYZOFS determines the offset of the antenna vertex in (x,y,z) from
C   the intersection of the azimuth and elevation axes and corrects the
C   antenna pattern phase for it.
C
C   Given:
C      LAMBDA   R        Observing wavelength, in metres.
C      CELLLM   R        Cell spacing in the (l,m) plane.
C      NPIX     I        Number of pixels on a side of the map.
C      WGT      R(NPIX,NPIX)
C                        Weight function from the interpolation.
C
C   Given and returned:
C      APHA     R(NPIX,NPIX)
C                        Phase of the antenna pattern.  Corrected for
C                        the phase ramp on return.
C      ACPLX    CX(NPIX,NPIX)
C                        Complex antenna pattern.  Corrected for the
C                        phase ramp on return.
C
C   Returned:
C      X0       R        Offset of the antenna vertex in (x,y,z) from
C                        the intersection of the azimuth and elevation
C                        axes, in metres.
C      Y0       R        y component of above
C      Z0       R        z component of above
C      DX0      R        Standard error in X0
C      DY0      R        Standard error in Y0
C      DZ0      R        Standard error in Z0
C      IERR     I        Error status, 0 means success,
C
C   Algorithm:
C      The effect on the antenna pattern phase is of the form phase
C      offset = l*x0 + m*y0 + n*z0.  Since n is close to unity, this
C      corresponds to the addition of a ramp in the phase map.
C
C   Notes:
C      1) XYZOFS assumes that the phase map has already been unwrapped.
C
C   Author: Mark Calabretta, Australia Telescope.
C   Origin; 1988/Nov/07. Code last modified; 1989/Nov/01.
C-----------------------------------------------------------------------
      INTEGER   NPIX, IERR
      REAL      LAMBDA, CELLLM, WGT(NPIX,NPIX), APHA(NPIX,NPIX), X0, Y0,
     *          Z0, DX0, DY0, DZ0
      COMPLEX   ACPLX(NPIX,NPIX)
C
      INTEGER   IL, IM, JL, JM, ML, MM, NPRM
      REAL      FIT, D(3,3), NS, PHA, R(3), SSQ, SSQRES, SUM, L, M, N,
     *          VARRES, VARY, VX(3), X(3)
      COMPLEX   CPHA
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       Determine (x0,y0,z0).
C                                       Initialize.
      ML = NPIX/2
      MM = NPIX/2 + 1
      NS     = 0.0
      SUM    = 0.0
      SSQ    = 0.0
      R(1)   = 0.0
      R(2)   = 0.0
      R(3)   = 0.0
      D(1,1) = 0.0
      D(1,2) = 0.0
      D(1,3) = 0.0
      D(2,2) = 0.0
      D(2,3) = 0.0
      D(3,3) = 0.0
C                                       Loop through the antenna pattern
C                                       phase map.
      DO 20 IM = 1, NPIX
         DO 10 IL = 1, NPIX
C                                       Check validity.
            IF (WGT(IL,IM).GT.0.0) THEN
C                                       Compute coordinates.
               L = -(IL-ML)*CELLLM
               M =  (IM-MM)*CELLLM
               N = SQRT(1.0 - L*L - M*M)
               PHA = APHA(IL,IM)
C                                       Accumulate statistics.
               NS     = NS   + 1.0
               SUM    = SUM  + PHA
               SSQ    = SSQ  + PHA*PHA
               R(1)   = R(1) + PHA*L
               R(2)   = R(2) + PHA*M
               R(3)   = R(3) + PHA*N
               D(1,1) = D(1,1) + L*L
               D(1,2) = D(1,2) + L*M
               D(1,3) = D(1,3) + L*N
               D(2,2) = D(2,2) + M*M
               D(2,3) = D(2,3) + M*N
               D(3,3) = D(3,3) + N*N
               END IF
 10         CONTINUE
 20      CONTINUE
C                                       Compute the least squares
C                                       solution for (x0,y0,z0)
      NPRM = 3
      CALL LEASQR (NPRM, NS, SUM, SSQ, R, D, X, VX, SSQRES, VARRES,
     *   VARY, FIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (6)
         GO TO 999
         END IF
      X0  = X(1)
      Y0  = X(2)
      Z0  = X(3)
C                                       Apply the correction.
      DO 50 IM = 1, NPIX
         JM = IM + MM - 1
         IF (JM.GT.NPIX) JM = JM - NPIX
         DO 40 IL = 1, NPIX
            IF (WGT(IL,IM).NE.0.0) THEN
C                                       Compute visibility coordinates
               L = -(IL-ML)*CELLLM
               M =  (IM-MM)*CELLLM
               N = SQRT(1.0 - L*L - M*M)
C                                       Fix the antenna pattern phase
               PHA = -(L*X0 + M*Y0 + N*Z0)
               APHA(IL,IM) = APHA(IL,IM) + PHA
C                                       Fix the complex antenna pattern
               JL = IL + ML - 1
               IF (JL.GT.NPIX) JL = JL - NPIX
               PHA  = PHA*DG2RAD
               CPHA = CMPLX(COS(PHA), SIN(PHA))
               ACPLX(JL,JM) = CPHA*ACPLX(JL,JM)
               END IF
 40         CONTINUE
 50      CONTINUE
C                                       Rescale to metres.
      X0  = X(1)*LAMBDA/360.0
      Y0  = X(2)*LAMBDA/360.0
      Z0  = X(3)*LAMBDA/360.0
      DX0 = SQRT(VX(1))*LAMBDA/360.0
      DY0 = SQRT(VX(2))*LAMBDA/360.0
      DZ0 = SQRT(VX(3))*LAMBDA/360.0
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('XYZOFS: Error',I4,' solving the normal equations.')
      END
      SUBROUTINE HGETVS (NVIS, AZOFF, ELOFF, L, M, N, AMP, PHA, IERR)
C-----------------------------------------------------------------------
C   HGETVS reads the next visibility.
C
C   Given (via common INPARM, INTLOG, INCHAR):
C      INFILE      C*48  Input visibility file name.
C      LUNVIS      I     Logical unit number to use for the input
C                        visibility file.
C      LAMBDA      R     Observing wavelength, in metres.
C      EL0         R     Satellite elevation, in degrees.
C      LMMIN       R     Range of |l| and |m| to include.  Negative
C      LMMAX       R     values denote a range of SQRT(l*l + m*m).
C      LINEAR      L     If true, the input amplitudes are linear,
C                        else logarithmic.
C      AMPSCL      R     Amplitude scaling factor.
C      PHSGN       R     Factor by which to multiply the measured
C                        phase.
C      X0,Y0,Z0    R     Offset of the antenna vertex in (x,y,z)
C                        from the intersection of the azimuth and
C                        elevation axes, in metres.
C
C   Given and returned:
C      NVIS        I     Progressive number of visibilities read.
C                        If given as zero, the file will be opened.
C
C   Returned:
C      AZOFF       R     Azimuth offset, deg.
C      ELOFF       R     Elevation offset, deg.
C      L,M,N       R     The (l,m,n) coordinates of the visibility.
C      AMP         R     Visibility amplitude, volts.
C      PHA         R     Visibility phase, radians.
C      IERR        I     Error status, 0: success,
C                           -1: end of file.
C
C   Notes:
C      1) The azimuth and elevation offsets in the data file refer to
C         the position of the telescope beam on the sky.
C
C         A POSITIVE azimuth offset samples a point in the antenna
C         pattern at a NEGATIVE azimuth offset and this corresponds
C         to a POSITIVE value of l (see note in HOLGR prologue).
C
C         Conversely, a POSITIVE elevation offset samples the antenna
C         pattern at a NEGATIVE elevation offset which corresponds to
C         a NEGATIVE value of m.
C
C-----------------------------------------------------------------------
      INTEGER   NVIS, IERR
      REAL      L, M, N, AMP, PHA
C
      INTEGER   JTRIM, KBP, KBLIM
      REAL      AZOFF, COSAZO, COSEL, COSEL0, EL, ELOFF, RLM, SINAZO,
     *          SINEL, SINEL0
      DOUBLE PRECISION DBLX
      CHARACTER STR*80
      INCLUDE 'HOLGR'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Open the holography data file
      IF (NVIS.EQ.0) THEN
         CALL ZTXOPN ('QRED', LUNVIS, INDVIS, INFILE, .FALSE., IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Loop until get valid visibility
 40   CALL ZTXIO ('READ', LUNVIS, INDVIS, STR, IERR)
         IF (IERR.EQ.2) GO TO 70
         IF (IERR.NE.0) GO TO 50
         IF (STR(:1).EQ.'!') GO TO 40
         IF (STR(:1).EQ.'#') GO TO 40
C                                       Parse the sample data: az, el,
C                                       amp, phase
         KBP = 1
         KBLIM = JTRIM (STR)
         CALL GETNUM (STR, KBLIM, KBP, DBLX)
         IF (DBLX.EQ.DBLANK) GO TO 50
         AZOFF = DBLX
         CALL GETNUM (STR, KBLIM, KBP, DBLX)
         IF (DBLX.EQ.DBLANK) GO TO 50
         ELOFF = DBLX
         CALL GETNUM (STR, KBLIM, KBP, DBLX)
         IF (DBLX.EQ.DBLANK) GO TO 50
         AMP = DBLX
         CALL GETNUM (STR, KBLIM, KBP, DBLX)
         IF (DBLX.EQ.DBLANK) GO TO 50
         PHA = DBLX
         NVIS = NVIS + 1
C                                       Compute visibility coordinates
         IF (EL0.GT.0) THEN
C                                       relative -> absolute elevation
            EL = EL0 + ELOFF
            COSEL0 = COS(EL0*DG2RAD)
            SINEL0 = SIN(EL0*DG2RAD)
            COSAZO = COS(AZOFF*DG2RAD)
            SINAZO = SIN(AZOFF*DG2RAD)
            COSEL  = COS(EL*DG2RAD)
            SINEL  = SIN(EL*DG2RAD)
C
            L =  SINAZO*COSEL0
            M = -COSAZO*COSEL0*SINEL + SINEL0*COSEL
            N =  COSAZO*COSEL0*COSEL + SINEL0*SINEL
C                                       Input is L, M already
         ELSE
            L = AZOFF
            M = ELOFF
            N = 0.0
            END IF
         RLM = SQRT(L*L + M*M)
C                                       Data point included?
         IF (LMMIN.GT.0.0) THEN
            IF (ABS(L).LT.LMMIN) GO TO 40
            IF (ABS(M).LT.LMMIN) GO TO 40
         ELSE IF (LMMIN.LT.0.0) THEN
            IF (L*L+M*M.LT.LMMIN*LMMIN) GO TO 40
            END IF
         IF (LMMAX.GT.0.0) THEN
            IF (ABS(L).GT.LMMAX) GO TO 40
            IF (ABS(M).GT.LMMAX) GO TO 40
         ELSE IF (LMMAX.LT.0.0) THEN
            IF (L*L+M*M.GT.LMMAX*LMMAX) GO TO 40
            END IF
C                                       Amplitude scaled to volts
      IF (LINEAR) THEN
         AMP = AMPSCL*AMP
C                                       Amplitude from power dB to volts
      ELSE
         AMP = 10.0**(AMP/20.0)
         END IF
      PHA = PHSGN*PHA - 360.0*(L*X0 + M*Y0 + N*Z0)/LAMBDA
      PHA = PHA*DG2RAD
      GO TO 999
C                                       Error Exit
 50   IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1050) NVIS
         CALL MSGWRT (8)
      ELSE IF (DBLX.EQ.DBLANK) THEN
         WRITE (MSGTXT,1055) NVIS
         CALL MSGWRT (8)
         IERR = 10
         END IF
      GO TO 999
C                                       End of file
 70   CALL ZTXCLS (LUNVIS, INDVIS, IERR)
      IERR = -1
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('HGETVS: ERROR READING VISIBILITY FILE AT VIS',I8)
 1055 FORMAT ('ERROR PARSING DATA CARD AT VIS',I8)
      END
      SUBROUTINE DFT (LAMBDA, NPIX, DX, DY, XTALK, V1, V2, P1, P2, VMAX,
     *   IERR)
C-----------------------------------------------------------------------
C   DFT does a direct Fourier transform of the holography visibility
C   data, producing amplitude and phase maps of the resolution function
C   as well as the aperture voltage distribution.
C
C   Given:
C      LAMBDA   R        Observing wavelength, in metres.
C      NPIX     I        Number of pixels on a side of the map.
C      DX       R        Map cell spacing in X and Y, in metres.
C      DY       R        Map cell spacing in X and Y, in metres.
C      XTALK    CX       Cross-talk correction.
C
C   Returned:
C      V1       R(NPIX,NPIX)
C                        Amplitude of the aperture voltage distribution,
C                        reorganized for output.
C      V2       R(NPIX,NPIX)
C                        Phase of the aperture voltage distribution,
C                        reorganized for output.
C      P1       R(NPIX,NPIX)
C                        Amplitude of the point spread function,
C                        reorganized for output.
C      P2       R(NPIX,NPIX)
C                        Phase of the point spread function, reorganized
C                        for output.
C      IERR     I        Error status, 0 means success.
C
C   Algorithm:
C      Direct Fourier transform of the visibility data.
C
C   Author: Mark Calabretta, Australia Telescope.
C   Origin; 1987/Nov.    Code last modified; 1989/Nov/01.
C-----------------------------------------------------------------------
      INTEGER   NPIX, IERR
      REAL      DX, DY, LAMBDA, VMAX, P1(NPIX,NPIX), P2(NPIX,NPIX),
     *          V1(NPIX,NPIX), V2(NPIX,NPIX)
      COMPLEX   XTALK
C
      INCLUDE 'HOLGRP'
      INTEGER   IX, IY, NX, NY, NVIS
      REAL      AMP, AZOFF, ELOFF, L, M, N, PHA, T1, T2
      DOUBLE PRECISION ML, MM, RHO, RHO0, PHI, CL, CM, DV1(MX,MX),
     *   DV2(MX,MX), DP1(MX,MX), DP2(MX,MX), DAMP, DPHA, DL, DM,
     *   DXRE, DXIM
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                        Zero the output arrays.
      DO 20 IY = 1, NPIX
         DO 10 IX = 1, NPIX
            DV1(IX,IY) = 0.0D0
            DV2(IX,IY) = 0.0D0
            DP1(IX,IY) = 0.0D0
            DP2(IX,IY) = 0.0D0
 10         CONTINUE
 20      CONTINUE
C                                       Coordinates of the map centre.
      NX = NPIX/2 + 1
      NY = NPIX/2 + 1
      ML = -DX * TWOPI / LAMBDA
      MM = -DY * TWOPI / LAMBDA
      DXRE = REAL (XTALK)
      DXIM = AIMAG (XTALK)
C                                       Loop thru visibility data file
      NVIS = 0
 30   CALL HGETVS (NVIS, AZOFF, ELOFF, L, M, N, AMP, PHA, IERR)
      IF (IERR.EQ.0) THEN
         DL = L
         DM = M
         DAMP = AMP
         DPHA = PHA
C                                       Radians per cell spacing in L
C                                       and M. (Negative for a minus-i
C                                       transform.)
         CL = DL * ML
         CM = DM * MM
C                                       Phase term for (IX,IY) = (0,0).
         RHO0 = - (CL * NX + CM * NY)
C                                       Loop over the map points.
         DO 50 IY = 1,NPIX
            RHO = RHO0 + CM*IY
            DO 40 IX = 1,NPIX
C                                       Point-spread function.
               RHO = RHO + CL
               DP1(IX,IY) = DP1(IX,IY) + COS(RHO)
               DP2(IX,IY) = DP2(IX,IY) + SIN(RHO)
C                                       Antenna pattern.
               PHI = DPHA + RHO
               DV1(IX,IY) = DV1(IX,IY) + DAMP*COS(PHI) - DXRE
               DV2(IX,IY) = DV2(IX,IY) + DAMP*SIN(PHI) - DXIM
 40            CONTINUE
 50         CONTINUE
         IF (MOD(NVIS,50).EQ.0) THEN
            WRITE (MSGTXT,1050) NVIS
            CALL MSGWRT (2)
            END IF
         GO TO 30
         END IF
C                                       done
      WRITE (MSGTXT,1050) NVIS
      CALL MSGWRT (2)
      IF (IERR.EQ.-1) IERR = 0
      IF (IERR.NE.0) THEN
         MSGTXT = 'DFT: Error reading the visibility file; continuing.'
         CALL MSGWRT (6)
         END IF
C                                        Convert the real and imaginary
C                                        parts to amplitude and phase
      VMAX = 0.0
      DO 110 IY = 1,NPIX
         DO 100 IX = 1, NPIX
C                                        Antenna pattern.
            T1 = DV1(IX,IY)
            T2 = DV2(IX,IY)
            V1(IX,IY) = SQRT (T1*T1 + T2*T2)
            IF ((T1.EQ.0.0) .AND. (T2.EQ.0.0)) THEN
               V2(IX,IY) = 0.0
            ELSE
               VMAX = MAX (VMAX, V1(IX,IY))
               V2(IX,IY) = ATAN2 (T2, T1) * RAD2DG
               END IF
C                                        Point-spread function.
            T1 = DP1(IX,IY)
            T2 = DP2(IX,IY)
            P1(IX,IY) = SQRT (T1*T1 + T2*T2)
            IF ((T1.EQ.0.0) .AND. (T2.EQ.0.0)) THEN
               P2(IX,IY) = 0.0
            ELSE
               P2(IX,IY) = ATAN2(T2, T1)*RAD2DG
               END IF
 100        CONTINUE
 110     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('DFT: Processed',I6,' visibilities.')
      END
      SUBROUTINE HOLFFT (DIR, NPIX, VIS, AMP, PHA)
C-----------------------------------------------------------------------
C   HOLFFT does a fast Fourier transform of the visibility data for
C   HOLGR.
C
C   Given:
C      DIR      I        Sign of the complex phase in Fourier integral
C      NPIX     I        Dimensions of the square array.
C
C   Given and returned:
C      VIS      CX(NPIX,NPIX)
C                        Array containing the complex visibilities.
C                        Returned as the transpose of the Fourier
C                        transform of the input array.
C      AMP      R(NPIX,NPIX)
C      PHA      R(NPIX,NPIX)
C                        Arrays containing the amplitude and phase parts
C                        of the Fourier transform of the input array.
C
C   Called: APLNOT: {FFTMC}
C
C   Algorithm:
C      Does the FFT on the input complex array then converts it to
C      amplitude and phase.
C
C   Author: Mark Calabretta, Australia Telescope.
C   Origin; 1987/Dec.    Code last modified; 1989/Nov/02.
C-----------------------------------------------------------------------
      INTEGER    DIR, NPIX
      COMPLEX    VIS(NPIX,NPIX)
      REAL       AMP(NPIX,NPIX), PHA(NPIX,NPIX)
C
      INTEGER    IL, IM
      REAL       CS, SN
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       Do the FFT.
      CALL FFTMC (DIR, NPIX, NPIX, 1, VIS)
C                                       Extract the amplitude and phase.
      DO 20 IM = 1,NPIX
         DO 10 IL = 1,NPIX
            CS =  REAL (VIS(IL,IM))
            SN = AIMAG (VIS(IL,IM))
            AMP(IL,IM) = SQRT (CS*CS + SN*SN)
            IF ((SN.EQ.0.0) .AND. (CS.EQ.0.0)) THEN
               PHA(IL,IM) = 0.0
            ELSE
               PHA(IL,IM) = ATAN2 (SN, CS) * RAD2DG
               END IF
 10         CONTINUE
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE FTKRNL (KRNL, DL, KMAX, NPIX, FTK)
C-----------------------------------------------------------------------
C   FTKRNL computes the Fourier transform of the convolution function
C   used for interpolating data onto the map grid.  This may then be
C   used to apply the gridding correction in the map plane.
C
C   Given:
C      KRNL   R(*)   Array containing one half of the interpolation
C                    function.
C      DL     R      Separation between the elements of KRNL in units of
C                    the cell spacing.
C      KMAX   I      Location of the last non-zero element of KRNL.
C      NPIX   I      Number of pixels on a side of the output map.
C
C   Returned:
C      FTK    R(*)   Fourier transform of KRNL evaluated at the map grid
C                    points.
C
C   Algorithm: Does an exact calculation as described by
C      Greisen, E.W., 1979. VLA Scientific Memorandum No. 131.
C
C   Author: Mark Calabretta, Australia Telescope.
C      Origin; 1988/Jan/22. Code last modified; 1989/Nov/01.
C-----------------------------------------------------------------------
      INTEGER   KMAX, NPIX
      REAL      DL, FTK(0:*), KRNL(0:*)
C
      INTEGER   IX, IL
      REAL      X, T
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       Loop over the map pixels.
      DO 20 IX = 0,NPIX/2
         X = REAL(IX)/REAL(NPIX)
         T = 2.0*PI*DL*X
C                                       Do the cosine transform.
         FTK(IX) = KRNL(0)
         DO 10 IL = 1,KMAX
            FTK(IX) = FTK(IX) + 2.0*KRNL(IL)*COS(IL*T)
 10         CONTINUE
C                                       Correct for the table lookup.
         IF (IX.NE.0) FTK(IX) = FTK(IX) * SIN (PI*DL*X) / (PI*DL*X)
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE GRIDCR (XFTK, YFTK, NPIX, AMP, AMPMAX)
C-----------------------------------------------------------------------
C   GRIDCR applies the gridding correction to the amplitude map and
C   normalizes it to have a peak value of 1.0 volt.
C
C   Given:
C      XFTK     R(*)     The gridding correction in the X direction.
C      YFTK     R(*)     The gridding correction in the Y direction.
C      NPIX     I        Number of pixels on a side of the map.
C
C   Given and returned:
C      AMP      R(NPIX,NPIX)
C                        The amplitude map.
C      AMPMAX   R        The normalisation constant
C
C   Author: Mark Calabretta, Australia Telescope.
C   Origin; 1988/Jan/22. Code last modified; 1989/Nov/01.
C-----------------------------------------------------------------------
      INTEGER   NPIX
      REAL      AMP(NPIX,NPIX), AMPMAX, XFTK(0:*), YFTK(0:*)
C
      INTEGER   IX, IY, JX, JY, NHALF
C-----------------------------------------------------------------------
C                                       Initialize.
      NHALF = NPIX/2 + 1
      AMPMAX = -1.0
C                                       Apply the correction.
      DO 20 IY = 1, NPIX
         JY = ABS(IY-NHALF)
C
         DO 10 IX = 1,NPIX
            JX = ABS(IX-NHALF)
            AMP(IX,IY) = AMP(IX,IY)/(XFTK(JX)*YFTK(JY))
            AMPMAX = MAX(AMP(IX,IY), AMPMAX)
 10         CONTINUE
 20      CONTINUE
C                                       Normalize.
      DO 40 IY = 1,NPIX
         DO 30 IX = 1,NPIX
            AMP(IX,IY) = AMP(IX,IY)/AMPMAX
 30         CONTINUE
 40      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE BLANK (RMAX, RMIN, NPIX, MAP)
C-----------------------------------------------------------------------
C   BLANK blanks a map beyond the antenna diameter and beneath the
C   subreflector.
C
C   Given:
C      RMAX     R        The antenna radius, in cell units.
C      RMIN     R        Sub-reflector radius, in cell units.
C      NPIX     I        Number of pixels on a side of the map.
C
C   Given and returned:
C      MAP      R(*,*)   The map to be blanked.
C
C   Author: Mark Calabretta, Australia Telescope.
C   Origin; 1988/04/11  Code last modified; 1996/08/20
C-----------------------------------------------------------------------
      INTEGER   NPIX
      REAL      RMAX, RMIN, MAP(NPIX,NPIX)
C
      INTEGER   IX, IX0, IY, IY0
      REAL      R
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Apply pixel blanking.
      IX0  = NPIX/2 + 1
      IY0  = NPIX/2 + 1
      DO 20 IY = 1,NPIX
         DO 10 IX = 1,NPIX
            R = SQRT(REAL((IX-IX0)**2 + (IY-IY0)**2))
            IF (R.GT.RMAX .OR. R.LT.RMIN) MAP(IX,IY) = FBLANK
 10         CONTINUE
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE UNWRAP (ZIP, NPIX, RMAX, RMIN, AMP, DISCR, PHA, PATCH,
     *   WSTAT, IERR)
C-----------------------------------------------------------------------
C   UNWRAP is a driver for the phase unwrapping routines.
C-----------------------------------------------------------------------
C
C   Given:
C      ZIP      I        Unwrapping control flag
C                           1: Unwrap closed discontinuities (PHAZIP).
C                           2: Perform closure operation (PHCLOS).
C      NPIX     I        Number of pixels on a side of the map.
C      RMAX     R        The antenna radius, in cell units.
C      RMIN     R        Sub-reflector radius, in cell units.
C      AMP      R(NPIX,NPIX)
C                        Amplitude part of the phase map to be
C                        rectified.
C      DISCR    R        Amplitude threshhold; pixels with amplitude
C                        below below this level will be blanked.
C
C   Given and returned:
C      PHA      R(NPIX,NPIX)
C                        The phase map to be rectified.
C      PATCH    I(NPIX,NPIX)
C                        Scratch array.
C
C   Returned:
C      WSTAT    I(6)     Unwrapping statistics:
C                           1) Initial phase unwrapping index.
C                           2) Number of patches unwrapped before
C                              contour closing.
C                           3) Intermediate phase unwrapping index.
C                           4) Number of contour closures.
C                           5) Number of patches unwrapped after contour
C                              closing.
C                           6) Final phase unwrapping index.
C      IERR     I        Error status, 0 means success,
C
C
C   Author: Mark Calabretta, Australia Telescope.
C   Origin; 1996/07/19  Code last modified; 1996/07/30
C-----------------------------------------------------------------------
      INTEGER   IERR, NPIX, PATCH(NPIX,NPIX), WSTAT(6), ZIP, TMP
      REAL      AMP(NPIX,NPIX), DISCR, PHA(NPIX,NPIX), RMAX, RMIN
C-----------------------------------------------------------------------
C                                       Initial phase wrapping index.
      CALL PHAWRP (NPIX, PHA, WSTAT(1))
C                                       Do initial unwrapping.
      IF (ZIP.GT.0) THEN
         CALL PHAZIP (NPIX, AMP, DISCR, PHA, PATCH, WSTAT(2), IERR)
C                                       Intermediate wrapping index.
         CALL PHAWRP (NPIX, PHA, WSTAT(3))
         END IF
C
      IF (ZIP.GT.1) THEN
C                                       Do contour closing.
         CALL PHCLOS (NPIX, RMAX, RMIN, PHA, PATCH, WSTAT(4), IERR)
C                                       Do final unwrapping.
         CALL PHAZIP (NPIX, AMP, DISCR, PHA, PATCH, WSTAT(5), IERR)
C                                       Do contour closing.
         CALL PHCLOS (NPIX, RMAX, RMIN, PHA, PATCH, WSTAT(4), IERR)
C                                       Do final unwrapping.
         CALL PHAZIP (NPIX, AMP, DISCR, PHA, PATCH, TMP, IERR)
         WSTAT(5) = WSTAT(5) + TMP
C                                       Final phase wrapping index.
         CALL PHAWRP (NPIX, PHA, WSTAT(6))
         END IF
C
 999  RETURN
      END
      SUBROUTINE PHAWRP (NPIX, PHA, WNDX)
C-----------------------------------------------------------------------
C   PHAWRP calculates the wrapping index of a phase map.
C
C   Given:
C      NPIX   I        Number of pixels on a side of the map.
C      PHA    R(NPIX,NPIX)
C                      The phase map.
C
C   Returned:
C      WNDX   I        The phase wrapping index.
C
C   Algorithm:
C      Simple count of the number of discontinuities between
C      neighbouring rows and columns.
C
C   Author: Mark Calabretta, Australia Telescope.
C   Origin; 1988/04/11  Code last modified; 1996/07/08
C-----------------------------------------------------------------------
      INTEGER   NPIX, WNDX
      REAL      PHA(NPIX,NPIX)
C
      INTEGER   IX, IY
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Scan through the map.
      WNDX = 0
      DO 20 IY = 1, NPIX
         DO 10 IX = 1, NPIX
            IF (PHA(IX,IY).EQ.FBLANK) GO TO 10
C                                       Look left.
            IF (IX.GT.1) THEN
               IF (PHA(IX-1,IY).EQ.FBLANK) GO TO 10
               IF (ABS(PHA(IX,IY)-PHA(IX-1,IY)).GT.180.0)
     *            WNDX = WNDX + 1
               END IF
C                                       Look below.
            IF (IY.GT.1) THEN
               IF (PHA(IX,IY-1).EQ.FBLANK) GO TO 10
               IF (ABS(PHA(IX,IY)-PHA(IX,IY-1)).GT.180.0)
     *            WNDX = WNDX + 1
               END IF
 10         CONTINUE
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE PHAZIP (NPIX, AMP, DISCR, PHA, PATCH, NPAT, IERR)
C-----------------------------------------------------------------------
C   PHAZIP unwraps a phase map.
C
C   Given:
C      NPIX     I        Number of pixels on a side of the map.
C      AMP      R(NPIX,NPIX)
C                        Amplitude part of the phase map to be
C                        rectified.
C      DISCR    R        Amplitude threshhold; pixels with amplitude
C                        below below this level will be blanked.
C
C   Given and returned:
C      PHA      R(NPIX,NPIX)
C                        The phase map to be rectified.
C      PATCH    I(NPIX,NPIX)
C                        Scratch array.
C      NPAT     I        Number of patches found.
C
C   Retured:
C      IERR     I        Error status, 0 means success,
C
C   Called: {}
C
C   Algorithm:
C      An equivalence operator is defined such that two pixels are
C      equivalent iff there is a path between them which does not cross
C      a discontinuity.  The path is restricted to horizontal and
C      vertical steps between neighbouring pixels.  A discontinuity is
C      defined as a phase step of greater than 180 degrees.
C
C      This equivalence operator partitions the phase map into a number
C      of equivalence classes referred to as "patches".  Adjacent
C      patches can be made equal to each other via the addition or
C      subtraction of an integral multiple of 360 degrees.
C
C      This algorithm is reliable.  However, it does not resolve open-
C      ended discontinuities.  It may or may not succeed in resolving
C      disguised open-ended discontinuities such as the following
C      (involving a pair of cloaked singletons, c.f. PHCLOS) where
C      only one of the two patches may be resolved:
C
C               +-------+-------+-------+-------+
C               |       |       |       |       |
C               |   0   |   0   |   0   |   0   |
C               |       |       |       |       |
C               +-------+=======*=======+-------+
C               |       %       %       %       |
C               |   0   %  200  % -200  %   0   |
C               |       %       %       %       |
C               +-------+=======*=======+-------+
C               |       |       |       |       |
C               |   0   |   0   |   0   |   0   |
C               |       |       |       |       |
C               +-------+-------+-------+-------+
C
C   Author: Mark Calabretta, Australia Telescope.
C   Origin; 1988/04/05  Code last modified; 1996/07/19
C-----------------------------------------------------------------------
      INTEGER   IERR, NPIX, PATCH(NPIX,NPIX)
      REAL      AMP(NPIX,NPIX), DISCR, PHA(NPIX,NPIX)
C
C     Maximum number of patches.
      INTEGER   MAXPAT
      PARAMETER (MAXPAT = 1000)
C
      INTEGER   IBLNK, IPAT, ITER, IX, IXMAX(MAXPAT), IXMIN(MAXPAT),
     :          IY, IYMAX(MAXPAT), IYMIN(MAXPAT), JPAT, MPAT, NPAT
      REAL      STEP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Initialize equivalence map.
      IBLNK = 0
      DO 20 IY = 1, NPIX
         DO 10 IX = 1, NPIX
            IF (PHA(IX,IY).EQ.FBLANK) THEN
               PATCH(IX,IY) = -1
               IBLNK = IBLNK + 1
            ELSE IF (AMP(IX,IY).LE.DISCR) THEN
               PATCH(IX,IY) = -1
               IBLNK = IBLNK + 1
            ELSE
               PATCH(IX,IY) = 0
               END IF
 10         CONTINUE
 20      CONTINUE
C                                       Find all patches.
      IPAT = 0
      DO 250 NPAT = 1, MAXPAT
C        Find the first pixel in this patch.
         DO 40 IY = 1, NPIX
            DO 30 IX = 1, NPIX
               IF (PATCH(IX,IY).EQ.0) THEN
                  PATCH(IX,IY) = NPAT
                  IXMIN(NPAT) = IX
                  IXMAX(NPAT) = IX
                  IYMIN(NPAT) = IY
                  IYMAX(NPAT) = IY
                  IPAT = IPAT + 1
                  GO TO 60
                  END IF
 30            CONTINUE
 40         CONTINUE
C
         WRITE (MSGTXT, 50) NPAT
 50      FORMAT ('PHAZIP: Couldn''t find first pixel in patch',I6,'.')
         CALL MSGWRT (6)
         IERR = 1
         GO TO 999
C                                       Find pixels in the same patch.
 60      DO 230 ITER = 1, 10
            JPAT = 0
C                                       Scan left-to-right from bottom
C                                       to top.
            DO 90 IY = IYMIN(NPAT), NPIX
               DO 70 IX = IXMIN(NPAT), NPIX
                  IF (PATCH(IX,IY).EQ.0) THEN
                     IF (IX.GT.1) THEN
C                                       Look left.
                        IF (ABS(PHA(IX,IY)-PHA(IX-1,IY)).LT.180.0) THEN
                           IF (PATCH(IX-1,IY).EQ.NPAT) THEN
                              PATCH(IX,IY) = NPAT
                              IXMAX(NPAT) = MAX(IX,IXMAX(NPAT))
                              IYMAX(NPAT) = MAX(IY,IYMAX(NPAT))
                              JPAT = JPAT + 1
                              GO TO 70
                              END IF
                           END IF
                        END IF
C
                     IF (IX.GT.IXMAX(NPAT)) GO TO 80
C
                     IF (IY.GT.1) THEN
C                                       Look below.
                        IF (ABS(PHA(IX,IY)-PHA(IX,IY-1)).LT.180.0) THEN
                           IF (PATCH(IX,IY-1).EQ.NPAT) THEN
                              PATCH(IX,IY) = NPAT
                              IXMAX(NPAT) = MAX(IX,IXMAX(NPAT))
                              IYMAX(NPAT) = MAX(IY,IYMAX(NPAT))
                              JPAT = JPAT + 1
                              END IF
                           END IF
                        END IF
                     END IF
 70               CONTINUE
 80            IF (IY.GT.IYMAX(NPAT)) GO TO 100
 90            CONTINUE
C                                       Scan bottom-to-top from right
C                                       to left.
 100        DO 130 IX = IXMAX(NPAT), 1, -1
               DO 110 IY = IYMIN(NPAT), NPIX
                  IF (PATCH(IX,IY).EQ.0) THEN
                     IF (IY.GT.1) THEN
C                                       Look below.
                        IF (ABS(PHA(IX,IY)-PHA(IX,IY-1)).LT.180.0) THEN
                           IF (PATCH(IX,IY-1).EQ.NPAT) THEN
                              PATCH(IX,IY) = NPAT
                              IXMIN(NPAT) = MIN(IX,IXMIN(NPAT))
                              IYMAX(NPAT) = MAX(IY,IYMAX(NPAT))
                              JPAT = JPAT + 1
                              GO TO 110
                              END IF
                           END IF
                        END IF
C
                     IF (IY.GT.IYMAX(NPAT)) GO TO 120
C
                     IF (IX.LT.NPIX) THEN
C                                       Look right.
                        IF (ABS(PHA(IX,IY)-PHA(IX+1,IY)).LT.180.0) THEN
                           IF (PATCH(IX+1,IY).EQ.NPAT) THEN
                              PATCH(IX,IY) = NPAT
                              IXMIN(NPAT) = MIN(IX,IXMIN(NPAT))
                              IYMAX(NPAT) = MAX(IY,IYMAX(NPAT))
                              JPAT = JPAT + 1
                              END IF
                           END IF
                        END IF
                     END IF
 110              CONTINUE
 120           IF (IX.LT.IXMIN(NPAT)) GO TO 140
 130           CONTINUE
C                                       Scan right-to-left from top to
C                                       bottom.
 140        DO 170 IY = IYMAX(NPAT), 1, -1
               DO 150 IX = IXMAX(NPAT), 1, -1
                  IF (PATCH(IX,IY).EQ.0) THEN
                     IF (IX.LT.NPIX) THEN
C                                       Look right.
                        IF (ABS(PHA(IX,IY)-PHA(IX+1,IY)).LT.180.0) THEN
                           IF (PATCH(IX+1,IY).EQ.NPAT) THEN
                              PATCH(IX,IY) = NPAT
                              IXMIN(NPAT) = MIN(IX,IXMIN(NPAT))
                              IYMIN(NPAT) = MIN(IY,IYMIN(NPAT))
                              JPAT = JPAT + 1
                              GO TO 150
                              END IF
                           END IF
                        END IF
C
                     IF (IX.LT.IXMIN(NPAT)) GO TO 160
C
                     IF (IY.LT.NPIX) THEN
C                                       Look above.
                        IF (ABS(PHA(IX,IY)-PHA(IX,IY+1)).LT.180.0) THEN
                           IF (PATCH(IX,IY+1).EQ.NPAT) THEN
                              PATCH(IX,IY) = NPAT
                              IXMIN(NPAT) = MIN(IX,IXMIN(NPAT))
                              IYMIN(NPAT) = MIN(IY,IYMIN(NPAT))
                              JPAT = JPAT + 1
                              END IF
                           END IF
                        END IF
                     END IF
 150              CONTINUE
 160           IF (IY.LT.IYMIN(NPAT)) GO TO 180
 170           CONTINUE
C                                       Scan top-to-bottom from left to
C                                       right.
 180        DO 210 IX = IXMIN(NPAT), NPIX
               DO 190 IY = IYMAX(NPAT), 1, -1
                  IF (PATCH(IX,IY).EQ.0) THEN
                     IF (IY.LT.NPIX) THEN
C                                       Look above.
                        IF (ABS(PHA(IX,IY)-PHA(IX,IY+1)).LT.180.0) THEN
                           IF (PATCH(IX,IY+1).EQ.NPAT) THEN
                              PATCH(IX,IY) = NPAT
                              IXMAX(NPAT) = MAX(IX,IXMAX(NPAT))
                              IYMIN(NPAT) = MIN(IY,IYMIN(NPAT))
                              JPAT = JPAT + 1
                              GO TO 190
                              END IF
                           END IF
                        END IF
C
                     IF (IY.LT.IYMIN(NPAT)) GO TO 200
C
                     IF (IX.GT.1) THEN
C                                       Look left.
                        IF (ABS(PHA(IX,IY)-PHA(IX-1,IY)).LT.180.0) THEN
                           IF (PATCH(IX-1,IY).EQ.NPAT) THEN
                              PATCH(IX,IY) = NPAT
                              IXMAX(NPAT) = MAX(IX,IXMAX(NPAT))
                              IYMIN(NPAT) = MIN(IY,IYMIN(NPAT))
                              JPAT = JPAT + 1
                              END IF
                           END IF
                        END IF
                     END IF
 190              CONTINUE
 200           IF (IX.GT.IXMAX(NPAT)) GO TO 220
 210           CONTINUE
C                                       Did we get anything?
 220        IPAT = IPAT + JPAT
            IF (IBLNK+IPAT.EQ.NPIX*NPIX) GO TO 300
            IF (JPAT.EQ.0) GO TO 250
 230        CONTINUE
C                                       Dropping out of the loop
C                                       indicates an error.
         WRITE (MSGTXT, 240) NPAT
 240     FORMAT ('PHAZIP: Too many iterations for patch',I6,'.')
         CALL MSGWRT (6)
         IERR = 1
         GO TO 999
 250     CONTINUE
C
      MSGTXT = 'PHAZIP: Too many patches.'
      CALL MSGWRT (6)
C                                       Unwrap the patches.
 300  DO 400 MPAT = 2, NPAT
         DO 320 IY = IYMIN(MPAT), IYMAX(MPAT)
            DO 310 IX = IXMIN(MPAT), IXMAX(MPAT)
               IF (PATCH(IX,IY).EQ.MPAT) THEN
C                                       Find a neighbour from a lower
C                                       patch.
                  IF (IX.GT.1) THEN
                     IF (PATCH(IX-1,IY).GT.0) THEN
                        IF (PATCH(IX-1,IY).LT.MPAT) THEN
                           STEP = PHA(IX,IY) - PHA(IX-1,IY)
                           GO TO 340
                           END IF
                        END IF
                     END IF
                  IF (IY.GT.1) THEN
                     IF (PATCH(IX,IY-1).GT.0) THEN
                        IF (PATCH(IX,IY-1).LT.MPAT) THEN
                           STEP = PHA(IX,IY) - PHA(IX,IY-1)
                           GO TO 340
                           END IF
                        END IF
                     END IF
                  IF (IX.LT.NPIX) THEN
                     IF (PATCH(IX+1,IY).GT.0) THEN
                        IF (PATCH(IX+1,IY).LT.MPAT) THEN
                           STEP = PHA(IX,IY) - PHA(IX+1,IY)
                           GO TO 340
                           END IF
                        END IF
                     END IF
                  IF (IY.LT.NPIX) THEN
                     IF (PATCH(IX,IY+1).GT.0) THEN
                        IF (PATCH(IX,IY+1).LT.MPAT) THEN
                           STEP = PHA(IX,IY) - PHA(IX,IY+1)
                           GO TO 340
                           END IF
                        END IF
                     END IF
                  END IF
 310           CONTINUE
 320        CONTINUE
C                                       Dropping out of the loop
C                                       indicates an error.
         WRITE (MSGTXT, 330) MPAT
 330     FORMAT ('PHAZIP: Couldn''t unwrap patch',I6,'.')
         CALL MSGWRT (6)
         GO TO 400
C                                       What's the step?
 340     STEP = 360.0*INT((STEP + SIGN(180.0,STEP))/360.0)
C                                       Adjust all pixels in this patch.
         DO 360 IY = IYMIN(MPAT), IYMAX(MPAT)
            DO 350 IX = IXMIN(MPAT), IXMAX(MPAT)
               IF (PATCH(IX,IY).EQ.MPAT) THEN
                  PHA(IX,IY) = PHA(IX,IY) - STEP
                  END IF
 350           CONTINUE
 360        CONTINUE
 400     CONTINUE
C
      IERR = 0
 999  RETURN
      END
      SUBROUTINE PHCLOS (NPIX, RMAX, RMIN, PHA, PATCH, NCLOS, IERR)
C-----------------------------------------------------------------------
C   PHCLOS searches for singleton pairs and tries to re-pair them so as
C   to minimize the total distance between them.
C
C   Given:
C      NPIX     I        Number of pixels on a side of the map.
C      RMAX     R        The antenna radius, in cell units.
C      RMIN     R        Sub-reflector radius, in cell units.
C
C   Given and returned:
C      PHA      R(NPIX,NPIX)
C                        The phase map to be rectified.
C      PATCH    I(NPIX,NPIX)
C                        Scratch array.
C
C   Retured:
C      NCLOS    I        Number of closures.
C      IERR     I        Error status, 0 means success.
C
C   Algorithm:
C      The sides of a pixel and their ends are coded as follows:
C
C                                  + 8 -
C                                +-------+
C                              - |       | +
C                              1 |       | 4
C                              + |       | -
C                                +-------+
C                                  - 2 +
C
C      For example, SIDE = -8 indicates the right end of the top side.
C
C      A "singleton" is the point of termination of a discontinuity,
C      for example as marked by the asterisk in the following diagrams:
C
C
C               +-------+-------+         +-------+-------+
C               |       |       |         |       |       |
C               |  150  |  225  |         |   75  |   0   |
C               |       |       | +       |       |       | -
C               +-------*-----------      +-------*-----------
C               |       |       | -       |       |       | +
C               |   75  |   0   |         |  150  |  225  |
C               |       |       |         |       |       |
C               +-------+-------+         +-------+-------+
C                positive parity           negative parity
C
C                             Naked singleton
C
C      Singletons have the following properties:
C         1) Location, always with half-integral x-, and y-coordinates.
C         2) Positive or negative parity.
C         3) Direction.
C
C      Neither the location nor the parity can be changed by addition or
C      subtraction of 360 degrees to any of the neighbouring pixels.
C
C      Pairs of singletons connected by a discontinuity have opposite
C      parity.
C
C      The parity and direction of a naked singleton is coded as
C      follows:
C
C                      +2                        -2
C                       |                         |
C                     + | -                     - | +
C                       |                         |
C                 -     |     +             +     |     -
C            +3 --------*-------- +1   -3 --------*-------- -1
C                 +     |     -             -     |     +
C                       |                         |
C                     - | +                     + | -
C                       |                         |
C                      +4                        -4
C
C      In the above diagrams the singleton is denoted by an asterisk
C      and the +/- pairs denote the phase step.
C
C      A naked singleton can be transformed into a "cloaked singleton"
C      and visa versa:
C
C               +-------+-------+         +-------+-------+
C               |       |       |         |       |       |
C               |  150  |  225  |         |  150  |  225  |
C             - |       |       | +     + |       |       | +
C            -----------*-----------   -----------*-----------
C             + |       |       | -     - |       |       | -
C               |  435  |   0   |         | -285  |   0   |
C               |       |       |         |       |       |
C               +-------|-------+         +-------|-------+
C                     + | -                     - | +
C                       |                         |
C
C                            Cloaked singleton
C
C      PHCLOS assumes that the map has no cloaked singletons and tries
C      not to create any.
C
C      A pseudo-singleton is formed where one or both of the adjacent
C      pixels is blank:
C
C               +-------+-------+         +-------+-------+
C               |       |       |         |       |       |
C               | blank |  225  |         |   75  |   0   |
C               |       |       | +       |       |       | -
C               +-------*-----------      +-------*-----------
C               |       |       | -       |       |       | +
C               | blank |   0   |         | blank |  225  |
C               |       |       |         |       |       |
C               +-------+-------+         +-------+-------+
C
C                             Pseudo-singleton
C
C      Pseudo-singletons can be moved along the perimeter of the blank
C      patch they are associated with and can be created or destroyed
C      in pairs.
C
C      A "doubleton" is like a singleton but with a double step:
C
C               +-------+-------+         +-------+-------+
C               |       |       |         |       |       |
C               |  300  |  450  |         |  150  |   0   |
C               |       |       | ++      |       |       | --
C               +-------*-----------      +-------*-----------
C               |       |       | --      |       |       | ++
C               |  150  |   0   |         |  300  |  450  |
C               |       |       |         |       |       |
C               +-------+-------+         +-------+-------+
C                positive parity           negative parity
C
C                             Naked doubleton
C
C      We assume that the data contains no doubletons.  Tripletons
C      cannot occur.
C
C   Author: Mark Calabretta, Australia Telescope National Facility.
C   Origin; 1996/07/19  Code last modified; 1996/08/20
C-----------------------------------------------------------------------
      INTEGER   IERR, NCLOS, NPIX, PATCH(NPIX,NPIX)
      REAL      PHA(NPIX,NPIX), RMAX, RMIN
C
      INTEGER   MAXEND
      PARAMETER (MAXEND = 2048)
C
      INTEGER   EDGE, I, IBLNK, IEND, ITER, IX, IY, J, JEND, JPAT, JX,
     *          JY, KX, KY, MEND, NEND, NPAT, PARY(-8:8), RANK(MAXEND),
     *          SIDE, XOFF(-8:8), YOFF(-8:8)
      REAL      D, DMIN, DX, DY, ENDS(10,MAXEND), LEN, LEN1, LEN2, R1,
     *          R2, S, TEMP, X0, X1, X2, Y0, Y1, Y2
C
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C
      DATA XOFF /+1, 0,0,0, +1, 0, -1, -1, 0, -1, +1, 0, +1, 0,0,0, -1/
      DATA YOFF /+1, 0,0,0, -1, 0, -1, +1, 0, -1, -1, 0, +1, 0,0,0, +1/
      DATA PARY /-3, 0,0,0, -2, 0, -1, -4, 0, +2, +3, 0, +4, 0,0,0, +1/
C-----------------------------------------------------------------------
C                                       Initialize.
      IBLNK = 0
      DO 20 IY = 1, NPIX
         DO 10 IX = 1, NPIX
            IF (PHA(IX,IY).EQ.FBLANK) THEN
               PATCH(IX,IY) = 1
               IBLNK = IBLNK + 1
            ELSE
               PATCH(IX,IY) = 0
               END IF
 10         CONTINUE
 20      CONTINUE
C                                       Categorize blank patches.
      NPAT = 0
 30   IF (IBLNK.GT.0) THEN
C                                       Find the first pixel in this
C                                       blank patch.
         NPAT = NPAT - 1
         DO 50 IY = 1, NPIX
            DO 40 IX = 1, NPIX
               IF (PATCH(IX,IY).EQ.1) THEN
                  PATCH(IX,IY) = NPAT
                  IBLNK = IBLNK - 1
                  GO TO 70
                  END IF
 40            CONTINUE
 50         CONTINUE
C
         WRITE (MSGTXT, 60) NPAT
 60      FORMAT ('PHCLOS: Couldn''t find first pixel in patch',I6,'.')
         CALL MSGWRT (6)
         IERR = 1
         GO TO 999
C                                       Find all pixels in this blank
C                                       patch.
 70      DO 160 ITER = 1, 10
            JPAT = 0
C                                       Scan left-to-right from bottom
C                                       to top.
            DO 90 IY = 1, NPIX
               DO 80 IX = 1, NPIX
                  IF (PATCH(IX,IY).EQ.1) THEN
                     IF (IX.GT.1) THEN
C                                       Look left.
                        IF (PATCH(IX-1,IY).EQ.NPAT) THEN
                           PATCH(IX,IY) = NPAT
                           JPAT = JPAT + 1
                           GO TO 80
                           END IF
                        END IF
C
                     IF (IY.GT.1) THEN
C                                       Look below.
                        IF (PATCH(IX,IY-1).EQ.NPAT) THEN
                           PATCH(IX,IY) = NPAT
                           JPAT = JPAT + 1
                           END IF
                        END IF
                     END IF
 80               CONTINUE
 90            CONTINUE
C                                       Scan bottom-to-top from right
C                                       to left.
            DO 110 IX = NPIX, 1, -1
               DO 100 IY = 1, NPIX
                  IF (PATCH(IX,IY).EQ.1) THEN
                     IF (IY.GT.1) THEN
C                                       Look below.
                        IF (PATCH(IX,IY-1).EQ.NPAT) THEN
                           PATCH(IX,IY) = NPAT
                           JPAT = JPAT + 1
                           GO TO 100
                           END IF
                        END IF
C
                     IF (IX.LT.NPIX) THEN
C                                       Look right.
                        IF (PATCH(IX+1,IY).EQ.NPAT) THEN
                           PATCH(IX,IY) = NPAT
                           JPAT = JPAT + 1
                           END IF
                        END IF
                     END IF
 100              CONTINUE
 110           CONTINUE
C                                       Scan right-to-left from top to
C                                       bottom.
            DO 130 IY = NPIX, 1, -1
               DO 120 IX = NPIX, 1, -1
                  IF (PATCH(IX,IY).EQ.1) THEN
                     IF (IX.LT.NPIX) THEN
C                                       Look right.
                        IF (PATCH(IX+1,IY).EQ.NPAT) THEN
                           PATCH(IX,IY) = NPAT
                           JPAT = JPAT + 1
                           GO TO 120
                           END IF
                        END IF
C
                     IF (IY.LT.NPIX) THEN
C                                       Look above.
                        IF (PATCH(IX,IY+1).EQ.NPAT) THEN
                           PATCH(IX,IY) = NPAT
                           JPAT = JPAT + 1
                           END IF
                        END IF
                     END IF
 120              CONTINUE
 130           CONTINUE
C                                       Scan top-to-bottom from left to
C                                       right.
            DO 150 IX = 1, NPIX
               DO 140 IY = NPIX, 1, -1
                  IF (PATCH(IX,IY).EQ.1) THEN
                     IF (IY.LT.NPIX) THEN
C                                       Look above.
                        IF (PATCH(IX,IY+1).EQ.NPAT) THEN
                           PATCH(IX,IY) = NPAT
                           JPAT = JPAT + 1
                           GO TO 140
                           END IF
                        END IF
C
                     IF (IX.GT.1) THEN
C                                       Look left.
                        IF (PATCH(IX-1,IY).EQ.NPAT) THEN
                           PATCH(IX,IY) = NPAT
                           JPAT = JPAT + 1
                           END IF
                        END IF
                     END IF
 140              CONTINUE
 150           CONTINUE
C                                       Did we get anything?
            IF (JPAT.EQ.0) GO TO 30
            IBLNK = IBLNK - JPAT
            IF (IBLNK.EQ.0) GO TO 200
 160        CONTINUE
C                                       Dropping out of the loop
C                                       indicates an error.
         WRITE (MSGTXT, 170) NPAT
 170     FORMAT ('PHCLOS: Too many iterations for patch',I6,'.')
         CALL MSGWRT (6)
         IERR = 1
         GO TO 999
         END IF
C                                       Mark all pixels which have a
C                                       discontinuity.
 200  DO 220 IY = 1, NPIX
         DO 210 IX = 1, NPIX
            IF (PATCH(IX,IY).LT.0) GO TO 210
C                                       Look to the left.
            IF (IX.GT.1) THEN
               IF (PATCH(IX-1,IY).GE.0) THEN
                  IF (PHA(IX-1,IY)-PHA(IX,IY).GT.180.0) THEN
                     PATCH(IX,IY) = PATCH(IX,IY) + 1
                     END IF
                  END IF
               END IF
C                                       Look below.
            IF (IY.GT.1) THEN
               IF (PATCH(IX,IY-1).GE.0) THEN
                  IF (PHA(IX,IY-1)-PHA(IX,IY).GT.180.0) THEN
                     PATCH(IX,IY) = PATCH(IX,IY) + 2
                     END IF
                  END IF
               END IF
C                                       Look to the right.
            IF (IX.LT.NPIX) THEN
               IF (PATCH(IX+1,IY).GE.0) THEN
                  IF (PHA(IX+1,IY)-PHA(IX,IY).GT.180.0) THEN
                     PATCH(IX,IY) = PATCH(IX,IY) + 4
                     END IF
                  END IF
               END IF
C                                       Look above.
            IF (IY.LT.NPIX) THEN
               IF (PATCH(IX,IY+1).GE.0) THEN
                  IF (PHA(IX,IY+1)-PHA(IX,IY).GT.180.0) THEN
                     PATCH(IX,IY) = PATCH(IX,IY) + 8
                     END IF
                  END IF
               END IF
 210        CONTINUE
 220     CONTINUE
C                                       Find the end points for all
C                                       open-ended discontinuities.
      NEND = 0
      DO 300 IY = 1, NPIX
         DO 290 IX = 1, NPIX
            IF (PATCH(IX,IY).LE.0) GO TO 290
C                                       Do we have an end point?
            EDGE = 0
            DO 280 ITER = 1, 2
               IF (MOD(PATCH(IX,IY),2).EQ.1) THEN
C                                       Discontinuity on the left
C                                       (so IX > 1).
                  IF (MOD(PATCH(IX,IY)/8,2).NE.1) THEN
C                                       End point above?
                     SIDE = -1
                     IF (IY.EQ.NPIX) THEN
                        EDGE = 1
                        GO TO 230
                        END IF
                     IF (MOD(PATCH(IX,IY+1),2).NE.1) THEN
                        IF (MOD(PATCH(IX-1,IY+1)/2,2).NE.1) THEN
                           IF (PATCH(IX,IY+1).LT.0) THEN
                              EDGE = PATCH(IX,IY+1)
                           ELSE IF (PATCH(IX-1,IY+1).LT.0) THEN
                              EDGE = PATCH(IX-1,IY+1)
                              END IF
                           GO TO 230
                           END IF
                        END IF
                  ELSE IF (MOD(PATCH(IX,IY)/2,2).NE.1) THEN
C                                       End point below?
                     SIDE = 1
                     IF (IY.EQ.1) THEN
                        EDGE = 1
                        GO TO 230
                        END IF
                     IF (MOD(PATCH(IX,IY-1),2).NE.1) THEN
                        IF (MOD(PATCH(IX-1,IY-1)/8,2).NE.1) THEN
                           IF (PATCH(IX,IY-1).LT.0) THEN
                              EDGE = PATCH(IX,IY-1)
                           ELSE IF (PATCH(IX-1,IY-1).LT.0) THEN
                              EDGE = PATCH(IX-1,IY-1)
                              END IF
                           GO TO 230
                           END IF
                        END IF
                     END IF
                  END IF
C
               IF (MOD(PATCH(IX,IY)/2,2).EQ.1) THEN
C                                       Discontinuity below (so IY > 1).
                  IF (MOD(PATCH(IX,IY),2).NE.1) THEN
C                                       End point to the left?
                     SIDE = -2
                     IF (IX.EQ.1) THEN
                        EDGE = 1
                        GO TO 230
                        END IF
                     IF (MOD(PATCH(IX-1,IY)/2,2).NE.1) THEN
                        IF (MOD(PATCH(IX-1,IY-1)/4,2).NE.1) THEN
                           IF (PATCH(IX-1,IY).LT.0) THEN
                              EDGE = PATCH(IX-1,IY)
                           ELSE IF (PATCH(IX-1,IY-1).LT.0) THEN
                              EDGE = PATCH(IX-1,IY-1)
                              END IF
                           GO TO 230
                           END IF
                        END IF
                  ELSE IF (MOD(PATCH(IX,IY)/4,2).NE.1) THEN
C                                       End point to the right?
                     SIDE = 2
                     IF (IX.EQ.NPIX) THEN
                        EDGE = 1
                        GO TO 230
                        END IF
                     IF (MOD(PATCH(IX+1,IY)/2,2).NE.1) THEN
                        IF (MOD(PATCH(IX+1,IY-1),2).NE.1) THEN
                           IF (PATCH(IX+1,IY).LT.0) THEN
                              EDGE = PATCH(IX+1,IY)
                           ELSE IF (PATCH(IX+1,IY-1).LT.0) THEN
                              EDGE = PATCH(IX+1,IY-1)
                              END IF
                           GO TO 230
                           END IF
                        END IF
                     END IF
                  END IF
C
               IF (MOD(PATCH(IX,IY)/4,2).EQ.1) THEN
C                                       Discontinuity on the right
C                                       (so IX < NPIX).
                  IF (MOD(PATCH(IX,IY)/2,2).NE.1) THEN
C                                       End point below?
                     SIDE = -4
                     IF (IY.EQ.1) THEN
                        EDGE = 1
                        GO TO 230
                        END IF
                     IF (MOD(PATCH(IX,IY-1)/4,2).NE.1) THEN
                        IF (MOD(PATCH(IX+1,IY-1)/8,2).NE.1) THEN
                           IF (PATCH(IX,IY-1).LT.0) THEN
                              EDGE = PATCH(IX,IY-1)
                           ELSE IF (PATCH(IX+1,IY-1).LT.0) THEN
                              EDGE = PATCH(IX+1,IY-1)
                              END IF
                           GO TO 230
                           END IF
                        END IF
                  ELSE IF (MOD(PATCH(IX,IY)/8,2).NE.1) THEN
C                                       End point above?
                     SIDE = 4
                     IF (IY.EQ.NPIX) THEN
                        EDGE = 1
                        GO TO 230
                        END IF
                     IF (MOD(PATCH(IX,IY+1)/4,2).NE.1) THEN
                        IF (MOD(PATCH(IX+1,IY+1)/2,2).NE.1) THEN
                           IF (PATCH(IX,IY+1).LT.0) THEN
                              EDGE = PATCH(IX,IY+1)
                           ELSE IF (PATCH(IX+1,IY+1).LT.0) THEN
                              EDGE = PATCH(IX+1,IY+1)
                              END IF
                           GO TO 230
                           END IF
                        END IF
                     END IF
                  END IF
C
               IF (MOD(PATCH(IX,IY)/8,2).EQ.1) THEN
C                                       Discontinuity above
C                                       (so IY < NPIX).
                  IF (MOD(PATCH(IX,IY)/4,2).NE.1) THEN
C                                       End point to the right?
                     SIDE = -8
                     IF (IX.EQ.NPIX) THEN
                        EDGE = 1
                        GO TO 230
                        END IF
                     IF (MOD(PATCH(IX+1,IY)/8,2).NE.1) THEN
                        IF (MOD(PATCH(IX+1,IY+1),2).NE.1) THEN
                           IF (PATCH(IX+1,IY).LT.0) THEN
                              EDGE = PATCH(IX+1,IY)
                           ELSE IF (PATCH(IX+1,IY+1).LT.0) THEN
                              EDGE = PATCH(IX+1,IY+1)
                              END IF
                           GO TO 230
                           END IF
                        END IF
                  ELSE IF (MOD(PATCH(IX,IY),2).NE.1) THEN
C                                       End point to the left?
                     SIDE = 8
                     IF (IX.EQ.1) THEN
                        EDGE = 1
                        GO TO 230
                        END IF
                     IF (MOD(PATCH(IX-1,IY)/8,2).NE.1) THEN
                        IF (MOD(PATCH(IX-1,IY+1)/4,2).NE.1) THEN
                           IF (PATCH(IX-1,IY).LT.0) THEN
                              EDGE = PATCH(IX-1,IY)
                           ELSE IF (PATCH(IX-1,IY+1).LT.0) THEN
                              EDGE = PATCH(IX-1,IY+1)
                              END IF
                           GO TO 230
                           END IF
                        END IF
                     END IF
                  END IF
C                                       Not an end point.
               GO TO 290
C                                       Found an end point.
 230           NEND = NEND + 1
               IF (NEND.GT.MAXEND) THEN
                  WRITE (MSGTXT, 240)
 240              FORMAT ('PHCLOS: Too many end points.')
                  CALL MSGWRT (6)
                  IERR = 1
                  GO TO 999
                  END IF
C                                       Record the positive parity end
C                                       as the first of the pair.
               IF (PARY(SIDE).GT.0) THEN
                  ENDS(1,NEND) = IX + XOFF(SIDE)*0.5
                  ENDS(2,NEND) = IY + YOFF(SIDE)*0.5
                  ENDS(3,NEND) = PARY(SIDE)
                  ENDS(4,NEND) = EDGE
               ELSE
                  ENDS(5,NEND) = IX + XOFF(SIDE)*0.5
                  ENDS(6,NEND) = IY + YOFF(SIDE)*0.5
                  ENDS(7,NEND) = PARY(SIDE)
                  ENDS(8,NEND) = EDGE
                  END IF
C                                       Trace the discontinuity to the
C                                       other end.
               PATCH(IX,IY) = PATCH(IX,IY) - ABS(SIDE)
C
               SIDE = -SIDE
               EDGE = 0
               JX = IX
               JY = IY
               DO 260 J = 1, 10000
                  IF (ABS(SIDE).EQ.1) THEN
C                                       Discontinuity on the left
C                                       (so JX > 1).
                     IF (SIDE.LT.0) THEN
C                                       Look above.
                        IF (JY.EQ.NPIX) THEN
                           EDGE = 1
                           GO TO 270
                           END IF
                        IF (MOD(PATCH(JX-1,JY+1)/2,2).EQ.1) THEN
                           JX = JX - 1
                           JY = JY + 1
                           SIDE = -2
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX,JY+1),2).EQ.1) THEN
                           JY = JY + 1
                           SIDE = -1
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX,JY)/8,2).EQ.1) THEN
                           SIDE = -8
                           GO TO 250
                           END IF
C
                        IF (PATCH(JX,JY+1).LT.0) THEN
                           EDGE = PATCH(JX,JY+1)
                        ELSE IF (PATCH(JX-1,JY+1).LT.0) THEN
                           EDGE = PATCH(JX-1,JY+1)
                           END IF
                     ELSE
C                                       Look below.
                        IF (JY.EQ.1) THEN
                           EDGE = 1
                           GO TO 270
                           END IF
                        IF (MOD(PATCH(JX-1,JY-1)/8,2).EQ.1) THEN
                           JX = JX - 1
                           JY = JY - 1
                           SIDE = 8
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX,JY-1),2).EQ.1) THEN
                           JY = JY - 1
                           SIDE = 1
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX,JY)/2,2).EQ.1) THEN
                           SIDE = 2
                           GO TO 250
                           END IF
C
                        IF (PATCH(JX,JY-1).LT.0) THEN
                           EDGE = PATCH(JX,JY-1)
                        ELSE IF (PATCH(JX-1,JY-1).LT.0) THEN
                           EDGE = PATCH(JX-1,JY-1)
                           END IF
                        END IF
                  ELSE IF (ABS(SIDE).EQ.2) THEN
C                                       Discontinuity below (so JY > 1).
                     IF (SIDE.LT.0) THEN
C                                       Look left.
                        IF (JX.EQ.1) THEN
                           EDGE = 1
                           GO TO 270
                           END IF
                        IF (MOD(PATCH(JX-1,JY-1)/4,2).EQ.1) THEN
                           JX = JX - 1
                           JY = JY - 1
                           SIDE = -4
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX-1,JY)/2,2).EQ.1) THEN
                           JX = JX - 1
                           SIDE = -2
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX,JY),2).EQ.1) THEN
                           SIDE = -1
                           GO TO 250
                           END IF
C
                        IF (PATCH(JX-1,JY).LT.0) THEN
                           EDGE = PATCH(JX-1,JY)
                        ELSE IF (PATCH(JX-1,JY-1).LT.0) THEN
                           EDGE = PATCH(JX-1,JY-1)
                           END IF
                     ELSE
C                                       Look right.
                        IF (JX.EQ.NPIX) THEN
                           EDGE = 1
                           GO TO 270
                           END IF
                        IF (MOD(PATCH(JX+1,JY-1),2).EQ.1) THEN
                           JX = JX + 1
                           JY = JY - 1
                           SIDE = 1
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX+1,JY)/2,2).EQ.1) THEN
                           JX = JX + 1
                           SIDE = 2
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX,JY)/4,2).EQ.1) THEN
                           SIDE = 4
                           GO TO 250
                           END IF
C
                        IF (PATCH(JX+1,JY).LT.0) THEN
                           EDGE = PATCH(JX+1,JY)
                        ELSE IF (PATCH(JX+1,JY-1).LT.0) THEN
                           EDGE = PATCH(JX+1,JY-1)
                           END IF
                        END IF
                  ELSE IF (ABS(SIDE).EQ.4) THEN
C                                       Discontinuity on the right
C                                       (so JX < NPIX).
                     IF (SIDE.LT.0) THEN
C                                       Look below.
                        IF (JY.EQ.1) THEN
                           EDGE = 1
                           GO TO 270
                           END IF
                        IF (MOD(PATCH(JX+1,JY-1)/8,2).EQ.1) THEN
                           JX = JX + 1
                           JY = JY - 1
                           SIDE = -8
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX,JY-1)/4,2).EQ.1) THEN
                           JY = JY - 1
                           SIDE = -4
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX,JY)/2,2).EQ.1) THEN
                           SIDE = -2
                           GO TO 250
                           END IF
C
                        IF (PATCH(JX,JY-1).LT.0) THEN
                           EDGE = PATCH(JX,JY-1)
                        ELSE IF (PATCH(JX+1,JY-1).LT.0) THEN
                           EDGE = PATCH(JX+1,JY-1)
                           END IF
                     ELSE
C                                       Look above.
                        IF (JY.EQ.NPIX) THEN
                           EDGE = 1
                           GO TO 270
                           END IF
                        IF (MOD(PATCH(JX+1,JY+1)/2,2).EQ.1) THEN
                           JX = JX + 1
                           JY = JY + 1
                           SIDE = 2
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX,JY+1)/4,2).EQ.1) THEN
                           JY = JY + 1
                           SIDE = 4
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX,JY)/8,2).EQ.1) THEN
                           SIDE = 8
                           GO TO 250
                           END IF
C
                        IF (PATCH(JX,JY+1).LT.0) THEN
                           EDGE = PATCH(JX,JY+1)
                        ELSE IF (PATCH(JX+1,JY+1).LT.0) THEN
                           EDGE = PATCH(JX+1,JY+1)
                           END IF
                        END IF
                  ELSE IF (ABS(SIDE).EQ.8) THEN
C                                       Discontinuity above
C                                       (so JY < NPIX).
                     IF (SIDE.LT.0) THEN
C                                       Look right.
                        IF (JX.EQ.NPIX) THEN
                           EDGE = 1
                           GO TO 270
                           END IF
                        IF (MOD(PATCH(JX+1,JY+1),2).EQ.1) THEN
                           JX = JX + 1
                           JY = JY + 1
                           SIDE = -1
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX+1,JY)/8,2).EQ.1) THEN
                           JX = JX + 1
                           SIDE = -8
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX,JY)/4,2).EQ.1) THEN
                           SIDE = -4
                           GO TO 250
                           END IF
C
                        IF (PATCH(JX+1,JY).LT.0) THEN
                           EDGE = PATCH(JX+1,JY)
                        ELSE IF (PATCH(JX+1,JY+1).LT.0) THEN
                           EDGE = PATCH(JX+1,JY+1)
                           END IF
                     ELSE
C                                       Look left.
                        IF (JX.EQ.1) THEN
                           EDGE = 1
                           GO TO 270
                           END IF
                        IF (MOD(PATCH(JX-1,JY+1)/4,2).EQ.1) THEN
                           JX = JX - 1
                           JY = JY + 1
                           SIDE = 4
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX-1,JY)/8,2).EQ.1) THEN
                           JX = JX - 1
                           SIDE = 8
                           GO TO 250
                           END IF
                        IF (MOD(PATCH(JX,JY),2).EQ.1) THEN
                           SIDE = 1
                           GO TO 250
                           END IF
C
                        IF (PATCH(JX-1,JY).LT.0) THEN
                           EDGE = PATCH(JX-1,JY)
                        ELSE IF (PATCH(JX-1,JY+1).LT.0) THEN
                           EDGE = PATCH(JX-1,JY+1)
                           END IF
                        END IF
                     END IF
C                                       Reached the other end.
                  GO TO 270
C                                       Got the next segment.
 250              PATCH(JX,JY) = PATCH(JX,JY) - ABS(SIDE)
 260              CONTINUE
C                                       Record the other end point.
 270           IF (PARY(SIDE).GT.0) THEN
                  ENDS(1,NEND) = JX + XOFF(SIDE)*0.5
                  ENDS(2,NEND) = JY + YOFF(SIDE)*0.5
                  ENDS(3,NEND) = PARY(SIDE)
                  ENDS(4,NEND) = EDGE
               ELSE
                  ENDS(5,NEND) = JX + XOFF(SIDE)*0.5
                  ENDS(6,NEND) = JY + YOFF(SIDE)*0.5
                  ENDS(7,NEND) = PARY(SIDE)
                  ENDS(8,NEND) = EDGE
                  END IF
               DX = ENDS(5,NEND) - ENDS(1,NEND)
               DY = ENDS(6,NEND) - ENDS(2,NEND)
               ENDS(9,NEND)  = ABS(DX) + ABS(DY)
               ENDS(10,NEND) = SQRT(DX*DX + DY*DY)
C
 280           CONTINUE
 290        CONTINUE
 300     CONTINUE
C                                       Try to rematch pairs to reduce
C                                       the total distance between them.
 340  LEN = 99999.0
      DO 360 IEND = 1, NEND
         LEN1 = 0.0
         DO 350 JEND = 1, NEND
            LEN2 = ENDS(10,JEND)
            IF (LEN2.GT.LEN1 .AND. LEN2.LE.LEN) THEN
               IF (LEN2.EQ.LEN .AND. JEND.LE.RANK(IEND-1)) GO TO 350
               RANK(IEND) = JEND
               LEN1 = LEN2
               END IF
 350        CONTINUE
         LEN = LEN1
 360     CONTINUE
C
      DO 380 I = 1, NEND-1
         IEND = RANK(I)
         DO 370 J = I+1, NEND
            JEND = RANK(J)
C
            LEN = ENDS(10,IEND) + ENDS(10,JEND)
            IF (ENDS(8,JEND).LT.0 .AND.
     *          ENDS(8,JEND).EQ.ENDS(4,IEND)) THEN
               LEN1 = 0.0
            ELSE
               DX = ENDS(5,JEND) - ENDS(1,IEND)
               DY = ENDS(6,JEND) - ENDS(2,IEND)
               LEN1 = SQRT(DX*DX + DY*DY)
               END IF
            IF (LEN1.GE.LEN) GO TO 370
C
            IF (ENDS(8,IEND).LT.0 .AND.
     *          ENDS(8,IEND).EQ.ENDS(4,JEND)) THEN
               LEN2 = 0.0
            ELSE
               DX = ENDS(5,IEND) - ENDS(1,JEND)
               DY = ENDS(6,IEND) - ENDS(2,JEND)
               LEN2 = SQRT(DX*DX + DY*DY)
               END IF
C
            IF (LEN1+LEN2.LT.LEN) THEN
C                                       Swap the end-points.
               TEMP = ENDS(5,IEND)
               ENDS(5,IEND) = ENDS(5,JEND)
               ENDS(5,JEND) = TEMP
               TEMP = ENDS(6,IEND)
               ENDS(6,IEND) = ENDS(6,JEND)
               ENDS(6,JEND) = TEMP
               TEMP = ENDS(7,IEND)
               ENDS(7,IEND) = ENDS(7,JEND)
               ENDS(7,JEND) = TEMP
               TEMP = ENDS(8,IEND)
               ENDS(8,IEND) = ENDS(8,JEND)
               ENDS(8,JEND) = TEMP
               ENDS(9,IEND) = ABS(ENDS(5,IEND)-ENDS(1,IEND)) +
     *                        ABS(ENDS(6,IEND)-ENDS(2,IEND))
               ENDS(9,JEND) = ABS(ENDS(5,JEND)-ENDS(1,JEND)) +
     *                        ABS(ENDS(6,JEND)-ENDS(2,JEND))
               ENDS(10,IEND) = LEN1
               ENDS(10,JEND) = LEN2
C
               GO TO 340
               END IF
 370        CONTINUE
 380     CONTINUE
C                                       Minimize the distance between
C                                       singletons connected to a blank.
      DO 430 IEND = 1, NEND
C        Is one end or the other blank?
         IF (ENDS(4,IEND).LT.0.0 .OR. ENDS(8,IEND).LT.0.0) THEN
            IF (ENDS(4,IEND).LT.0.0) THEN
               IF (ENDS(8,IEND).LT.0.0) GO TO 430
C                                       The pseudo-singleton is at the
C                                       positive parity end.
               X0 = ENDS(5,IEND)
               Y0 = ENDS(6,IEND)
               X1 = ENDS(1,IEND)
               Y1 = ENDS(2,IEND)
               EDGE = NINT(ENDS(4,IEND))
            ELSE
C                                       The pseudo-singleton is at the
C                                       negative parity end.
               X0 = ENDS(1,IEND)
               Y0 = ENDS(2,IEND)
               X1 = ENDS(5,IEND)
               Y1 = ENDS(6,IEND)
               EDGE = NINT(ENDS(8,IEND))
               END IF
C                                       Define a region to search for
C                                       closer blanks.
            JX = NINT(X0 - ENDS(10,IEND) - 0.5)
            JY = NINT(Y0 - ENDS(10,IEND) - 0.5)
            KX = NINT(X0 + ENDS(10,IEND) + 0.5)
            KY = NINT(Y0 + ENDS(10,IEND) + 0.5)
            IF (JX.LT.1) JX = 1
            IF (JY.LT.1) JY = 1
            IF (KX.GT.NPIX) KX = NPIX
            IF (KY.GT.NPIX) KY = NPIX
C                                       Search for the closest blank
C                                       pixel from the same patch.
            X2 = X1
            Y2 = Y1
            DMIN = ENDS(10,IEND)
            DO 420 IX = JX, KX
               DO 410 IY = JY, KY
                  IF (PATCH(IX,IY).EQ.EDGE) THEN
                     DX = IX - X0
                     DY = IY - Y0
                     D = SQRT(DX*DX + DY*DY)
                     IF (D.LT.DMIN) THEN
C                                       Found one.
                        IF (X2.LT.X0) THEN
                           X2 = IX + 0.5
                        ELSE
                           X2 = IX - 0.5
                           END IF
                        IF (Y2.LT.Y0) THEN
                           Y2 = IY + 0.5
                        ELSE
                           Y2 = IY - 0.5
                           END IF
                        DMIN = D
                        END IF
                     END IF
 410              CONTINUE
 420           CONTINUE
C
            IF (X2.EQ.X1 .AND. Y2.EQ.Y1) GO TO 430
C                                       Relocate the pseudo-singleton.
            S = (X1-X0)*(Y2-Y0) - (X2-X0)*(Y1-Y0)
            IF (NINT(ENDS(4,IEND)).EQ.EDGE) THEN
C                                       Positive parity.
               ENDS(1,IEND) = X2
               ENDS(2,IEND) = Y2
               IF (S.LT.0.0) THEN
                  ENDS(3,IEND) = 5
               ELSE
                  ENDS(3,IEND) = 6
                  END IF
            ELSE
C                                       Negative parity.
               ENDS(5,IEND) = X2
               ENDS(6,IEND) = Y2
               IF (S.GT.0.0) THEN
                  ENDS(7,IEND) = -5
               ELSE
                  ENDS(7,IEND) = -6
                  END IF
               END IF
C
            DX = X2 - X0
            DY = Y2 - Y0
            ENDS(9,IEND)  = NINT(ABS(DX) + ABS(DY))
            ENDS(10,IEND) = SQRT(DX*DX + DY*DY)
            END IF
 430     CONTINUE
C                                       Try rerouting each end of a
C                                       discontinuity to an edge.
      MEND = NEND
      DO 530 IEND = 1, NEND
C                                       Check that both ends are non-
C                                       blank.
         IF (ENDS(4,IEND).LT.0.0 .OR. ENDS(8,IEND).LT.0.0) GO TO 530
C
         X0 = NPIX/2 + 1
         Y0 = NPIX/2 + 1
         X1 = ENDS(1,IEND) - X0
         Y1 = ENDS(2,IEND) - Y0
         R1 = SQRT(X1*X1 + Y1*Y1)
         X2 = ENDS(5,IEND) - X0
         Y2 = ENDS(6,IEND) - Y0
         R2 = SQRT(X2*X2 + Y2*Y2)
C
         IF ((RMAX-R2)+(RMAX-R1).LT.ENDS(10,IEND)) THEN
            X1 = AINT(X1*RMAX/R1 + X0)
            Y1 = AINT(Y1*RMAX/R1 + Y0)
            X2 = AINT(X2*RMAX/R2 + X0)
            Y2 = AINT(Y2*RMAX/R2 + Y0)
            TEMP = -1.0
         ELSE IF ((R2-RMIN)+(R1-RMIN).LT.ENDS(10,IEND)) THEN
            X1 = AINT(X1*RMIN/R1 + X0)
            Y1 = AINT(Y1*RMIN/R1 + Y0)
            X2 = AINT(X2*RMIN/R2 + X0)
            Y2 = AINT(Y2*RMIN/R2 + Y0)
            TEMP = -2.0
         ELSE
C                                       No win.
            GO TO 530
            END IF
C
         X1 = X1 + SIGN(0.5,X1)
         Y1 = Y1 + SIGN(0.5,Y1)
         X2 = X2 + SIGN(0.5,X2)
         Y2 = Y2 + SIGN(0.5,Y2)
C
         MEND = MEND + 1
         S = (ENDS(1,IEND)-ENDS(5,IEND))*(Y2-ENDS(6,IEND)) -
     *       (X2-ENDS(5,IEND))*(ENDS(2,IEND)-ENDS(6,IEND))
         ENDS(1,MEND) = X2
         ENDS(2,MEND) = Y2
         IF (S.LT.0.0) THEN
            ENDS(3,MEND) = 5
         ELSE
            ENDS(3,MEND) = 6
            END IF
         ENDS(4,MEND) = TEMP
         ENDS(5,MEND) = ENDS(5,IEND)
         ENDS(6,MEND) = ENDS(6,IEND)
         ENDS(7,MEND) = ENDS(7,IEND)
         ENDS(8,MEND) = ENDS(8,IEND)
         DX = ENDS(5,MEND) - ENDS(1,MEND)
         DY = ENDS(6,MEND) - ENDS(2,MEND)
         ENDS(9,MEND)  = NINT(ABS(DX) + ABS(DY))
         ENDS(10,MEND) = SQRT(DX*DX + DY*DY)
C
         S = (ENDS(5,IEND)-ENDS(1,IEND))*(Y1-ENDS(2,IEND)) -
     *       (X1-ENDS(1,IEND))*(ENDS(6,IEND)-ENDS(2,IEND))
         ENDS(5,IEND) = X1
         ENDS(6,IEND) = Y1
         IF (S.GT.0.0) THEN
            ENDS(7,IEND) = -5
         ELSE
            ENDS(7,IEND) = -6
            END IF
         ENDS(8,IEND) = TEMP
         DX = ENDS(5,IEND) - ENDS(1,IEND)
         DY = ENDS(6,IEND) - ENDS(2,IEND)
         ENDS(9,IEND)  = NINT(ABS(DX) + ABS(DY))
         ENDS(10,IEND) = SQRT(DX*DX + DY*DY)
 530     CONTINUE
      NEND = MEND
C                                       Close open-ended
C                                       discontinuities.
      NCLOS = 0
      DO 600 IEND = 1, NEND
C                                       Uncomment for debugging info.
C        WRITE (MSGTXT, 610)
C    *      ENDS(1,IEND), ENDS(2,IEND),
C    *      NINT(ENDS(3,IEND)), NINT(ENDS(4,IEND)),
C    *      ENDS(5,IEND), ENDS(6,IEND),
C    *      NINT(ENDS(7,IEND)), NINT(ENDS(8,IEND)),
C    *      NINT(ENDS(9,IEND)), ENDS(10,IEND)
C610     FORMAT (2F7.1,2I4,2X,2F7.1,2I4,2X,I5,F7.1)
C        CALL MSGWRT (3)
C
C                                       Let the perimeter of the blank
C                                       patch do the work.
         IF (ENDS(4,IEND).LT.0.0 .AND. ENDS(8,IEND).LT.0.0) THEN
            IF (ENDS(4,IEND).EQ.ENDS(8,IEND)) GO TO 600
            END IF
C                                       Build a wall across it.
         CALL DAMNIT (NPIX, PHA, ENDS(1,IEND))
         NCLOS = NCLOS + 1
 600     CONTINUE
C
      IERR = 0
 999  RETURN
      END
      SUBROUTINE DAMNIT (NPIX, PHA, ENDS)
C-----------------------------------------------------------------------
C   DAMNIT connects pairs of naked singletons by the shortest path
C   without converting them to cloaked singletons.
C
C   Given:
C      NPIX     I        Number of pixels on a side of the map.
C
C   Given and returned:
C      PHA      R(NPIX,NPIX)
C                        The phase map to be rectified.
C      ENDS     R(10)    Information about the singleton pairs:
C                           1) X-coordinate of the positive parity end.
C                           2) Y-coordinate of the positive parity end.
C                           3) Parity (positive) and direction code.
C                           4) Blank patch number for pseudo-singletons.
C                           5) X-coordinate of the negative parity end.
C                           6) Y-coordinate of the negative parity end.
C                           7) Parity (negative) and direction code.
C                           8) Blank patch number for pseudo-singletons.
C                           9) L1 distance between ends.
C                          10) L2 distance between ends.
C
C   Author: Mark Calabretta, Australia Telescope National Facility.
C   Origin; 1996/08/06  Code last modified; 1996/08/14
C-----------------------------------------------------------------------
      INTEGER   NPIX
      REAL      ENDS(10), PHA(NPIX,NPIX)
C
      INTEGER   DIR, IX, IY, J, JQ, JX, JY, K, LX, LY, MODE
      REAL      DX, DY, P0, P1, P2, P3, P4, X, Y
C
      INCLUDE 'INCS:DDCH.INC'
C
C     Statement functions to make life easier.
      REAL      CYCLE, MATCH
      CYCLE(P1,P2) = NINT((P1-P2)/360.0)*360.0
      MATCH(P1,P2) = P1 - CYCLE(P1,P2)
C-----------------------------------------------------------------------
      LX = NINT(ENDS(5) - ENDS(1))
      LY = NINT(ENDS(6) - ENDS(2))
      IF (LX.GT.0 .AND. ABS(LY).LE.LX) THEN
         DIR = 1
      ELSE IF (LY.GT.0 .AND. ABS(LX).LE.LY) THEN
         DIR = 2
      ELSE IF (LX.LT.0 .AND. ABS(LY).LT.ABS(LX)) THEN
         DIR = 3
      ELSE IF (LY.LT.0 .AND. ABS(LX).LE.ABS(LY)) THEN
         DIR = 4
         END IF
C
      JQ = NINT(ENDS(3))
      CALL FIXEND (NPIX,  LX,  LY, ENDS(1), ENDS(2), JQ, PHA, JX, JY)
      ENDS(3) = JQ
C
      K = MAX(ABS(LX), ABS(LY))
      IF (K.GT.0) THEN
         DX = REAL(LX)/K
         DY = REAL(LY)/K
C
         DO 20 J = 1, K-1
            X = ENDS(1) + (J + 0.4999)*DX
            Y = ENDS(2) + (J + 0.4999)*DY
C
            IF (DIR.EQ.1) THEN
               IX = NINT(X)
               IY = NINT(Y - 0.5)
               IF (IY.EQ.JY) THEN
                  MODE = 0
                  P0 = PHA(JX,JY)
                  P1 = PHA(JX+1,JY)
                  P2 = PHA(JX+1,JY+1)
                  P3 = PHA(JX,JY+1)
               ELSE IF (IY.GT.JY) THEN
                  MODE = 1
                  P0 = PHA(JX,JY)
                  P1 = PHA(JX+1,JY)
                  P2 = PHA(JX+1,JY+1)
                  P3 = PHA(JX+1,JY+2)
                  P4 = PHA(JX,JY+2)
               ELSE
                  MODE = -1
                  P0 = PHA(JX,JY+1)
                  P1 = PHA(JX+1,JY+1)
                  P2 = PHA(JX+1,JY)
                  P3 = PHA(JX+1,JY-1)
                  P4 = PHA(JX,JY-1)
                  END IF
            ELSE IF (DIR.EQ.2) THEN
               IX = NINT(X + 0.5)
               IY = NINT(Y)
               IF (IX.EQ.JX) THEN
                  MODE = 0
                  P0 = PHA(JX,JY)
                  P1 = PHA(JX,JY+1)
                  P2 = PHA(JX-1,JY+1)
                  P3 = PHA(JX-1,JY)
               ELSE IF (IX.LT.JX) THEN
                  MODE = 1
                  P0 = PHA(JX,JY)
                  P1 = PHA(JX,JY+1)
                  P2 = PHA(JX-1,JY+1)
                  P3 = PHA(JX-2,JY+1)
                  P4 = PHA(JX-2,JY)
               ELSE
                  MODE = -1
                  P0 = PHA(JX-1,JY)
                  P1 = PHA(JX-1,JY+1)
                  P2 = PHA(JX,JY+1)
                  P3 = PHA(JX+1,JY+1)
                  P4 = PHA(JX+1,JY)
                  END IF
            ELSE IF (DIR.EQ.3) THEN
               IX = NINT(X)
               IY = NINT(Y + 0.5)
               IF (IY.EQ.JY) THEN
                  MODE = 0
                  P0 = PHA(JX,JY)
                  P1 = PHA(JX-1,JY)
                  P2 = PHA(JX-1,JY-1)
                  P3 = PHA(JX,JY-1)
               ELSE IF (IY.LT.JY) THEN
                  MODE = 1
                  P0 = PHA(JX,JY)
                  P1 = PHA(JX-1,JY)
                  P2 = PHA(JX-1,JY-1)
                  P3 = PHA(JX-1,JY-2)
                  P4 = PHA(JX,JY-2)
               ELSE
                  MODE = -1
                  P0 = PHA(JX,JY-1)
                  P1 = PHA(JX-1,JY-1)
                  P2 = PHA(JX-1,JY)
                  P3 = PHA(JX-1,JY+1)
                  P4 = PHA(JX,JY+1)
                  END IF
            ELSE IF (DIR.EQ.4) THEN
               IX = NINT(X - 0.5)
               IY = NINT(Y)
               IF (IX.EQ.JX) THEN
                  MODE = 0
                  P0 = PHA(JX,JY)
                  P1 = PHA(JX,JY-1)
                  P2 = PHA(JX+1,JY-1)
                  P3 = PHA(JX+1,JY)
               ELSE IF (IX.GT.JX) THEN
                  MODE = 1
                  P0 = PHA(JX,JY)
                  P1 = PHA(JX,JY-1)
                  P2 = PHA(JX+1,JY-1)
                  P3 = PHA(JX+2,JY-1)
                  P4 = PHA(JX+2,JY)
               ELSE
                  MODE = -1
                  P0 = PHA(JX+1,JY)
                  P1 = PHA(JX+1,JY-1)
                  P2 = PHA(JX,JY-1)
                  P3 = PHA(JX-1,JY-1)
                  P4 = PHA(JX-1,JY)
                  END IF
               END IF
C
            IF (MODE.EQ.0) THEN
               IF (P1.NE.FBLANK .AND. P0.NE.FBLANK) P1 = MATCH(P1,P0)
               IF (P2.NE.FBLANK .AND. P3.NE.FBLANK) P2 = MATCH(P2,P3)
            ELSE IF (MODE.EQ.1) THEN
               IF (P1.NE.FBLANK .AND. P0.NE.FBLANK) P1 = MATCH(P1,P0)
               IF (P2.NE.FBLANK) THEN
                  IF (P1.NE.FBLANK) P2 = MATCH(P2,P1)
                  IF (P3.NE.FBLANK) THEN
                     P3 = MATCH(P3,P2) + 360.0
                     IF (P4.NE.FBLANK) P4 = MATCH(P4,P3)
                     END IF
                  END IF
            ELSE
               IF (P1.NE.FBLANK .AND. P0.NE.FBLANK) P1 = MATCH(P1,P0)
               IF (P2.NE.FBLANK) THEN
                  IF (P1.NE.FBLANK) P2 = MATCH(P2,P1)
                  IF (P3.NE.FBLANK) THEN
                     P3 = MATCH(P3,P2) - 360.0
                     IF (P4.NE.FBLANK) P4 = MATCH(P4,P3)
                     END IF
                  END IF
               END IF
C
            IF (DIR.EQ.1) THEN
               IF (IY.EQ.JY) THEN
                  PHA(JX,JY) = P0
                  PHA(JX+1,JY) = P1
                  PHA(JX+1,JY+1) = P2
                  PHA(JX,JY+1) = P3
               ELSE IF (IY.GT.JY) THEN
                  PHA(JX,JY) = P0
                  PHA(JX+1,JY) = P1
                  PHA(JX+1,JY+1) = P2
                  PHA(JX+1,JY+2) = P3
                  PHA(JX,JY+2) = P4
               ELSE
                  PHA(JX,JY+1) = P0
                  PHA(JX+1,JY+1) = P1
                  PHA(JX+1,JY) = P2
                  PHA(JX+1,JY-1) = P3
                  PHA(JX,JY-1) = P4
                  END IF
            ELSE IF (DIR.EQ.2) THEN
               IF (IX.EQ.JX) THEN
                  PHA(JX,JY) = P0
                  PHA(JX,JY+1) = P1
                  PHA(JX-1,JY+1) = P2
                  PHA(JX-1,JY) = P3
               ELSE IF (IX.LT.JX) THEN
                  PHA(JX,JY) = P0
                  PHA(JX,JY+1) = P1
                  PHA(JX-1,JY+1) = P2
                  PHA(JX-2,JY+1) = P3
                  PHA(JX-2,JY) = P4
               ELSE
                  PHA(JX-1,JY) = P0
                  PHA(JX-1,JY+1) = P1
                  PHA(JX,JY+1) = P2
                  PHA(JX+1,JY+1) = P3
                  PHA(JX+1,JY) = P4
                  END IF
            ELSE IF (DIR.EQ.3) THEN
               IF (IY.EQ.JY) THEN
                  PHA(JX,JY) = P0
                  PHA(JX-1,JY) = P1
                  PHA(JX-1,JY-1) = P2
                  PHA(JX,JY-1) = P3
               ELSE IF (IY.LT.JY) THEN
                  PHA(JX,JY) = P0
                  PHA(JX-1,JY) = P1
                  PHA(JX-1,JY-1) = P2
                  PHA(JX-1,JY-2) = P3
                  PHA(JX,JY-2) = P4
               ELSE
                  PHA(JX,JY-1) = P0
                  PHA(JX-1,JY-1) = P1
                  PHA(JX-1,JY) = P2
                  PHA(JX-1,JY+1) = P3
                  PHA(JX,JY+1) = P4
                  END IF
            ELSE IF (DIR.EQ.4) THEN
               IF (IX.EQ.JX) THEN
                  PHA(JX,JY) = P0
                  PHA(JX,JY-1) = P1
                  PHA(JX+1,JY-1) = P2
                  PHA(JX+1,JY) = P3
               ELSE IF (IX.GT.JX) THEN
                  PHA(JX,JY) = P0
                  PHA(JX,JY-1) = P1
                  PHA(JX+1,JY-1) = P2
                  PHA(JX+2,JY-1) = P3
                  PHA(JX+2,JY) = P4
               ELSE
                  PHA(JX+1,JY) = P0
                  PHA(JX+1,JY-1) = P1
                  PHA(JX,JY-1) = P2
                  PHA(JX-1,JY-1) = P3
                  PHA(JX-1,JY) = P4
                  END IF
               END IF
C
            JX = IX
            JY = IY
 20         CONTINUE
         END IF
C
      JQ = NINT(ENDS(7))
      CALL FIXEND (NPIX, -LX, -LY, ENDS(5), ENDS(6), JQ, PHA, JX, JY)
      ENDS(7) = JQ
C
 999  RETURN
      END
      SUBROUTINE FIXEND (NPIX, LX, LY, X0, Y0, PARITY, PHA, IX, IY)
C-----------------------------------------------------------------------
C   FIXEND reorients a singleton towards the specified direction.  A
C   cloaked singleton may be given but a naked singleton will be
C   returned.
C
C   Given:
C      NPIX     I        Number of pixels on a side of the map.
C      LX,LY    I        Direction components in x and y.
C      X0,Y0    R        Coordinates of the singleton.
C      PARITY   I        The parity of the singleton; only the sign is
C                        used.
C
C   Given and returned:
C      PHA      R(NPIX,NPIX)
C                        The phase map to be rectified.
C      IX,IY    I        Coordinates of the pixel on the downward side
C                        of the phase step.
C
C
C   Algorithm:
C      The pixels to be fixed are copied out of the phase map and
C      labelled so that the singleton, marked with an asterisk in the
C      following diagram, is desired to travel to the right:
C
C                       +-------+-------+-------+
C                       |       |       |       |
C                       |   P2  |   P1  |   R1  |
C                       |       |       |       |
C                       +-------*-------+-------+
C                       |       |       |       |
C                       |   P3  |   P4  |   R4  |
C                       |       |       |       |
C                       +-------+-------+-------+
C
C                            Pixel numbering
C
C      P1, P2, P3, and P4 may be modified but R1 and R4 are used only
C      for reference.  The principle difficulty is in determining the
C      reference level for P1 and P4.  P2 and P3 are adjusted to make
C      the singleton naked.
C
C      Once P1, P2, P3, and P4 have been adjusted they are copied back
C      to the phase map.
C
C   Notes:
C      1)
C
C   Author: Mark Calabretta, Australia Telescope.
C   Origin; 1996/08/06  Code last modified; 1996/08/27
C-----------------------------------------------------------------------
      INTEGER   IX, IY, LX, LY, NPIX, PARITY
      REAL      PHA(NPIX,NPIX), X0, Y0
C
      REAL      C1, C4, P1, P2, P3, P4, R1, R4
      INTEGER   JX, JY, LXY
C
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C
C     Statement functions to make life easier.
      REAL      CYCLE, MATCH
      CYCLE(P1,P2) = NINT((P1-P2)/360.0)*360.0
      MATCH(P1,P2) = P1 - CYCLE(P1,P2)
C-----------------------------------------------------------------------
      IF (PARITY.EQ.0) RETURN
C
      P1 = FBLANK
      P2 = FBLANK
      P3 = FBLANK
      P4 = FBLANK
      R1 = FBLANK
      R4 = FBLANK
C                                       Rotate so that the
C                                       discontinuity travels towards
C                                       the right.
      IF (LX.GT.0 .AND. ABS(LY).LE.LX) THEN
C                                       N.B. includes (LX,LY) = (+n,+n)
C                                       and (+n,-n).
         JX = NINT(X0 + 0.5)
         JY = NINT(Y0 + 0.5)
         P1 = PHA(JX,JY)
         IF (JY.GT.1) P4 = PHA(JX,JY-1)
         IF (JX.GT.1) THEN
            P2 = PHA(JX-1,JY)
            IF (JY.GT.1) P3 = PHA(JX-1,JY-1)
            END IF
         IF (JX.LT.NPIX) THEN
            R1 = PHA(JX+1,JY)
            IF (JY.GT.1) R4 = PHA(JX+1,JY-1)
            END IF
         LXY = LY/LX
      ELSE IF (LY.GT.0 .AND. ABS(LX).LE.LY) THEN
C                                       N.B. includes (LX,LY) = (-n,+n)
C                                       but not (+n,+n).
         JX = NINT(X0 - 0.5)
         JY = NINT(Y0 + 0.5)
         P1 = PHA(JX,JY)
         IF (JX.LT.NPIX) P4 = PHA(JX+1,JY)
         IF (JY.GT.1) THEN
            P2 = PHA(JX,JY-1)
            IF (JX.LT.NPIX) P3 = PHA(JX+1,JY-1)
            END IF
         IF (JY.LT.NPIX) THEN
            R1 = PHA(JX,JY+1)
            IF (JX.LT.NPIX) R4 = PHA(JX+1,JY+1)
            END IF
         LXY = -LX/LY
      ELSE IF (LX.LT.0 .AND. ABS(LY).LT.ABS(LX)) THEN
C                                       N.B. excludes (LX,LY) = (-n,+n)
C                                       and (-n,-n).
         JX = NINT(X0 - 0.5)
         JY = NINT(Y0 - 0.5)
         P1 = PHA(JX,JY)
         IF (JY.LT.NPIX) P4 = PHA(JX,JY+1)
         IF (JX.LT.NPIX) THEN
            P2 = PHA(JX+1,JY)
            IF (JY.LT.NPIX) P3 = PHA(JX+1,JY+1)
            END IF
         IF (JX.GT.1) THEN
            R1 = PHA(JX-1,JY)
            IF (JY.LT.NPIX) R4 = PHA(JX-1,JY+1)
            END IF
         LXY = LY/LX
      ELSE IF (LY.LT.0 .AND. ABS(LX).LE.ABS(LY)) THEN
C                                       N.B. includes (LX,LY) = (-n,-n)
C                                       but not (+n,-n).
         JX = NINT(X0 + 0.5)
         JY = NINT(Y0 - 0.5)
         P1 = PHA(JX,JY)
         IF (JX.GT.1) P4 = PHA(JX-1,JY)
         IF (JY.LT.NPIX) THEN
            P2 = PHA(JX,JY+1)
            IF (JX.GT.1) P3 = PHA(JX-1,JY+1)
            END IF
         IF (JY.GT.1) THEN
            R1 = PHA(JX,JY-1)
            IF (JX.GT.1) R4 = PHA(JX-1,JY-1)
            END IF
         LXY = -LX/LY
         END IF
C                                       Point the singleton towards the
C                                       desired direction.
      IF (P1.NE.FBLANK .AND. P4.NE.FBLANK) THEN
C                                       The usual case, should we adjust
C                                       P1 or P4?
         IF (PARITY.GT.0) THEN
            IF (PARITY.LE.4) THEN
               IF (LXY.EQ.1) THEN
                  P1 = MATCH(P1,P4) + 360.0
               ELSE
                  P4 = MATCH(P4,P1) - 360.0
                  END IF
            ELSE IF (PARITY.EQ.5) THEN
               P4 = MATCH(P4,P1) - 360.0
            ELSE IF (PARITY.EQ.6) THEN
               P1 = MATCH(P1,P4) + 360.0
               END IF
         ELSE
            IF (PARITY.GE.-4) THEN
               IF (LXY.EQ.1) THEN
                  P4 = MATCH(P4,P1) + 360.0
               ELSE
                  P1 = MATCH(P1,P4) - 360.0
                  END IF
            ELSE IF (PARITY.EQ.-5) THEN
               P1 = MATCH(P1,P4) - 360.0
            ELSE IF (PARITY.EQ.-6) THEN
               P4 = MATCH(P4,P1) + 360.0
               END IF
            END IF
C                                       Uncloak any cloaked singleton
C                                       created on the right.
         IF (R1.NE.FBLANK .AND. R4.NE.FBLANK) THEN
C                                       The usual case, R1 and R4 non-
C                                       blank.
            C1 = CYCLE(P1,R1)
            C4 = CYCLE(P4,R4)
            IF (C1.GT.0.0 .AND. C4.GT.0.0) THEN
               P1 = P1 - MIN(C1,C4)
               P4 = P4 - MIN(C1,C4)
            ELSE IF (C1.LT.0.0 .AND. C4.LT.0.0) THEN
               P1 = P1 + MAX(C1,C4)
               P4 = P4 + MAX(C1,C4)
               END IF
         ELSE IF (R1.EQ.FBLANK .AND. R4.EQ.FBLANK) THEN
C                                       Reconciliation unnecessary.
         ELSE IF (R1.EQ.FBLANK) THEN
            C4 = CYCLE(P4,R4)
            IF (LXY.EQ.-1) C4 = C4 - 360.0
            P1 = P1 - C4
            P4 = P4 - C4
         ELSE IF (R4.EQ.FBLANK) THEN
            C1 = CYCLE(P1,R1)
            IF (LXY.EQ.1) C1 = C1 - 360.0
            P1 = P1 - C1
            P4 = P4 - C1
            END IF
      ELSE IF (P1.EQ.FBLANK .AND. P4.EQ.FBLANK) THEN
C                                       Not much we can do here.
      ELSE IF (P1.EQ.FBLANK) THEN
         IF (P3.NE.FBLANK) THEN
            P4 = MATCH(P4,P3)
         ELSE IF (R4.NE.FBLANK) THEN
            P4 = MATCH(P4,R4)
            IF (LXY.EQ.-1) P4 = P4 - 360.0
            END IF
      ELSE IF (P4.EQ.FBLANK) THEN
         IF (P2.NE.FBLANK) THEN
            P1 = MATCH(P1,P2)
         ELSE IF (R1.NE.FBLANK) THEN
            P1 = MATCH(P1,R1)
            IF (LXY.EQ.1) P1 = P1 - 360.0
            END IF
         END IF
C                                       Uncloak any cloaked singleton
C                                       created by the above.
      IF (P1.NE.FBLANK .AND. P2.NE.FBLANK) P2 = MATCH(P2,P1)
      IF (P3.NE.FBLANK .AND. P4.NE.FBLANK) P3 = MATCH(P3,P4)
      IF (P2.NE.FBLANK .AND. P3.NE.FBLANK) THEN
         IF (P1.EQ.FBLANK) THEN
            P2 = MATCH(P2,P3)
         ELSE IF (P4.EQ.FBLANK) THEN
            P3 = MATCH(P3,P2)
         ELSE
            IF (CYCLE(P2,P3).NE.0.0) THEN
               WRITE (MSGTXT, 10) X0, Y0
 10            FORMAT ('FIXEND: Assertion failed',2F7.1)
               CALL MSGWRT (3)
               END IF
            END IF
         END IF
C                                       De-rotate the map.
      IF (LX.GT.0 .AND. ABS(LY).LE.LX) THEN
         PHA(JX,JY) = P1
         IF (JY.GT.1) PHA(JX,JY-1) = P4
         IF (JX.GT.1) THEN
            PHA(JX-1,JY) = P2
            IF (JY.GT.1) PHA(JX-1,JY-1) = P3
            END IF
         IF (PARITY.LT.0) THEN
            IX = NINT(X0 + 0.5)
            IY = NINT(Y0 + 0.5)
            PARITY = -1
         ELSE
            IX = NINT(X0 + 0.5)
            IY = NINT(Y0 - 0.5)
            PARITY = +1
            END IF
      ELSE IF (LY.GT.0 .AND. ABS(LX).LE.LY) THEN
         PHA(JX,JY) = P1
         IF (JX.LT.NPIX) PHA(JX+1,JY) = P4
         IF (JY.GT.1) THEN
            PHA(JX,JY-1) = P2
            IF (JX.LT.NPIX) PHA(JX+1,JY-1) = P3
            END IF
         IF (PARITY.LT.0) THEN
            IX = NINT(X0 - 0.5)
            IY = NINT(Y0 + 0.5)
            PARITY = -2
         ELSE
            IX = NINT(X0 + 0.5)
            IY = NINT(Y0 + 0.5)
            PARITY = +2
            END IF
      ELSE IF (LX.LT.0 .AND. ABS(LY).LT.ABS(LX)) THEN
         PHA(JX,JY) = P1
         IF (JY.LT.NPIX) PHA(JX,JY+1) = P4
         IF (JX.LT.NPIX) THEN
            PHA(JX+1,JY) = P2
            IF (JY.LT.NPIX) PHA(JX+1,JY+1) = P3
            END IF
         IF (PARITY.LT.0) THEN
            IX = NINT(X0 - 0.5)
            IY = NINT(Y0 - 0.5)
            PARITY = -3
         ELSE
            IX = NINT(X0 - 0.5)
            IY = NINT(Y0 + 0.5)
            PARITY = +3
            END IF
      ELSE IF (LY.LT.0 .AND. ABS(LX).LE.ABS(LY)) THEN
         PHA(JX,JY) = P1
         IF (JX.GT.1) PHA(JX-1,JY) = P4
         IF (JY.LT.NPIX) THEN
            PHA(JX,JY+1) = P2
            IF (JX.GT.1) PHA(JX-1,JY+1) = P3
            END IF
         IF (PARITY.LT.0) THEN
            IX = NINT(X0 + 0.5)
            IY = NINT(Y0 - 0.5)
            PARITY = -4
         ELSE
            IX = NINT(X0 - 0.5)
            IY = NINT(Y0 - 0.5)
            PARITY = +4
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE FLATPH (TYPE, XMAG, NPIX, LAMBDA, FOCUS, XYMIN, XYMAX,
     *   CELLXY, VAMP, VPHA, P0, PX, PY, FX, FY, FZ, DP0, DPX, DPY, DFX,
     *   DFY, DFZ, RMS0, RMS, IERR, NOXYZ, NOZERO, PHAMOD)
C-----------------------------------------------------------------------
C   FLATPH corrects the phase of the aperture voltage for pointing,
C   focus, and feed offset errors using least squares.
C
C   Given:
C      TYPE     C*4      Focus type
C                           PFOC: prime focus
C                           SUBR: subreflector
C      XMAG     R        Magnification factor for Cassegrain feeds.
C      NPIX     I        Number of pixels on a side of the map.
C      LAMBDA   R        Observing wavelength, in metres.
C      FOCUS    R        Nominal focal length, in metres.
C      XYMIN    R        Range of |x| and |y| used in correcting for
C      XYMAX    R        pointing, focus, and feed offset. Negative
C                        values denote a range of SQRT(x*x + y*y).
C      CELLXY   R        Map cell spacing, in metres.
C      VAMP     R(NPIX,NPIX)
C                        Aperture voltage amplitude map.
C      VPHA     R(NPIX,NPIX)
C                        Aperture voltage phase map.
C      NOXYZ    L        Inhibit focus and feed offset
C
C   Returned:
C      P0       R        Constant offset removed, degrees.
C      PX       R        Least squares estimates of the phase ramp
C      PY       R        in the X and Y directions, in degrees/cell
C      FX       R        The feed offset, derived focal position is at
C      FY       R        (-FX,-FY,FOCUS-FZ), millimetres.
C      FZ       R
C      DP0      R        Standard error in P0.
C      DPX      R        Standard error in PX.
C      DPY      R        Standard error in PY.
C      DFX      R        Standard error in FX.
C      DFY      R        Standard error in FY.
C      DFZ      R        Standard error in FZ.
C      RMS      R        Weighted Half-path rms error, in millimetres.
C      RMS0     R        Pre-fit weighted half-path error, mm.
C      IERR     I        Error status, 0 means success.
C
C   Algorithm:
C      Weighted least squares fit to the formulation given by the
C      unpublished work by John Ruze, "Small Displacements in Parabolic
C      Reflectors", 1969, MIT.
C
C   Notes:
C      1)  Focus and feed offset inhibited if NOXYZ = .true.
C      2)  Phase offset term inhibited if NOZERO = .true.
C
C   Author: Mark Calabretta, Australia Telescope.
C   Origin; 1987/11     Code last modified; 1996/07/08
C-----------------------------------------------------------------------
      LOGICAL   NOXYZ, NOZERO
      INTEGER   NPIX, IERR
      REAL      LAMBDA, FOCUS, XYMIN, XYMAX, CELLXY, VAMP(NPIX,NPIX),
     *          VPHA(NPIX,NPIX), P0, PX, PY, FX, FY, FZ, DP0, DPX, DPY,
     *          DFX, DFY, DFZ, RMS0, RMS, PHAMOD(NPIX,NPIX), XMAG
      CHARACTER TYPE*4
C
      INTEGER   NP
      PARAMETER (NP=6)
      INTEGER   I, IDR2, IDX, IDY, IX, IX0, IR2MAX, IR2MIN, IXYMAX,
     *          IXYMIN, IY, IY0, J
      REAL      CORR, D(NP,NP), FIT, FP, MEAN, NS, PH, Q, QP, R(NP), R4,
     *          RP, RR, S, SP, SSQ, SSQRES, SUM, VARRES, VARY, VX(NP),
     *          WT, X(NP), XF, XP, YF, YP, ZF
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IF (TYPE.EQ.'SUBR') THEN
         IF (XMAG.LE.0.0) XMAG = 10.0
         END IF
C                                       Initialize.
      IXYMIN = ABS(XYMIN/CELLXY)
      IXYMAX = ABS(XYMAX/CELLXY)
      IR2MIN = (XYMIN*XYMIN)/(CELLXY*CELLXY)
      IR2MAX = (XYMAX*XYMAX)/(CELLXY*CELLXY)
C                                       Focal length in cellular units.
      FP = FOCUS/CELLXY
C                                       Half-path wavelength scaling
      R4 = LAMBDA/720.0
      NS  = 0.0
      SUM = 0.0
      SSQ = 0.0
      DO 30 I = 1,NP
         R(I) = 0.0
         DO 20 J = 1,NP
            D(I,J) = 0.0
 20         CONTINUE
 30      CONTINUE
      RR = NPIX/2.0 + 1.0
C                                       Compute pre-fit rms error
      CALL SRFRMS (NPIX, XYMIN, XYMAX, IXYMIN, IXYMAX, IR2MIN, IR2MAX,
     *   VAMP, VPHA, R4, MEAN, RMS0)
C                                       Loop through the map.
      IX0 = NPIX/2 + 1
      IY0 = NPIX/2 + 1
      DO 50 IY = 1, NPIX
         IDY = ABS (IY - IY0)
C                                       Check absolute limits.
         IF (XYMIN.GT.0.0 .AND. IDY.LT.IXYMIN) GO TO 50
         IF (XYMAX.GT.0.0 .AND. IDY.GT.IXYMAX) GO TO 50
C                                       Is this row of pixels outside
C                                       the outer ring?
         IF (XYMAX.LT.0.0 .AND. IDY*IDY.GT.IR2MAX) GO TO 50
         DO 40 IX = 1,NPIX
C                                       Ignore blanked pixels.
            IF (VPHA(IX,IY).EQ.FBLANK) GO TO 40
C                                       Check for inclusion.
            IDX  = ABS(IX-IX0)
            IDR2 = IDX*IDX + IDY*IDY
C                                       Inner limits.
            IF (XYMIN.GT.0.0) THEN
               IF (IDX.LT.IXYMIN) GO TO 40
            ELSE IF (XYMIN.LT.0.0) THEN
               IF (IDR2.LT.IR2MIN) GO TO 40
               END IF
C                                       Outer limits.
            IF (XYMAX.GT.0.0) THEN
               IF (IDX.GT.IXYMAX) GO TO 40
            ELSE IF (XYMAX.LT.0.0) THEN
               IF (IDR2.GT.IR2MAX) GO TO 40
               END IF
C                                       Evaluate variables (in cellular
C                                       units).
            PH = VPHA(IX,IY)
            WT = VAMP(IX,IY)
            XP = IX - IX0
            YP = IY - IY0
            RP = SQRT(XP*XP + YP*YP)
            Q = RP/(2.0*FP)
            S = 1.0/(1.0 + Q*Q)
            IF (TYPE.EQ.'PFOC') THEN
               XF = 2.0*(XP/RP)*Q*S
               YF = 2.0*(YP/RP)*Q*S
               ZF = -(1.0 - Q*Q)*S
            ELSE
               QP = Q/XMAG
               SP = 1.0/(1.0 + QP*QP)
               XF = 2.0*(XP/RP)*(Q*S - QP*SP)
               YF = 2.0*(YP/RP)*(Q*S - QP*QP)
               ZF = -(1.0 - Q*Q)*S - (1.0 - QP*QP)*SP
               END IF
C                                       Accumulate statistics.
            NS     = NS  + WT
            SUM    = SUM + PH*WT
            SSQ    = SSQ + PH*PH*WT
            R(1)   = R(1) + PH*WT
            R(2)   = R(2) + PH*XP*WT
            R(3)   = R(3) + PH*YP*WT
            R(4)   = R(4) + PH*XF*WT
            R(5)   = R(5) + PH*YF*WT
            R(6)   = R(6) + PH*ZF*WT
            D(1,1) = D(1,1) + WT
            D(1,2) = D(1,2) + XP*WT
            D(1,3) = D(1,3) + YP*WT
            D(1,4) = D(1,4) + XF*WT
            D(1,5) = D(1,5) + YF*WT
            D(1,6) = D(1,6) + ZF*WT
            D(2,2) = D(2,2) + XP*XP*WT
            D(2,3) = D(2,3) + XP*YP*WT
            D(2,4) = D(2,4) + XP*XF*WT
            D(2,5) = D(2,5) + XP*YF*WT
            D(2,6) = D(2,6) + XP*ZF*WT
            D(3,3) = D(3,3) + YP*YP*WT
            D(3,4) = D(3,4) + YP*XF*WT
            D(3,5) = D(3,5) + YP*YF*WT
            D(3,6) = D(3,6) + YP*ZF*WT
            D(4,4) = D(4,4) + XF*XF*WT
            D(4,5) = D(4,5) + XF*YF*WT
            D(4,6) = D(4,6) + XF*ZF*WT
            D(5,5) = D(5,5) + YF*YF*WT
            D(5,6) = D(5,6) + YF*ZF*WT
            D(6,6) = D(6,6) + ZF*ZF*WT
 40         CONTINUE
 50      CONTINUE
C                                       Disable the focus and feed
C                                       offset if requested
      IF (NOXYZ) THEN
        DO 70 I = 4, 6
           R(I) = 0.0
           DO 60 J = 1,NP
              D(J,I) = 0.0
              D(I,J) = 0.0
 60           CONTINUE
 70         CONTINUE
         END IF
C                                       Disable the zero offset term,
C                                       if requested
      IF (NOZERO) THEN
         R(1) = 0.0
         DO 80 J = 1,NP
            D(1,J) = 0.0
            D(J,1) = 0.0
 80         CONTINUE
         END IF
C                                       Compute least squares solution.
      CALL LEASQR (NP, NS, SUM, SSQ, R, D, X, VX, SSQRES, VARRES, VARY,
     *   FIT, IERR)
C                                       Pick up answers
      P0 = X(1)
      PX = X(2)
      PY = X(3)
      FX = X(4)
      FY = X(5)
      FZ = X(6)
      DP0 = SQRT(VX(1))
      DPX = SQRT(VX(2))
      DPY = SQRT(VX(3))
      DFX = SQRT(VX(4))
      DFY = SQRT(VX(5))
      DFZ = SQRT(VX(6))
C                                       Apply the correction.
      DO 100 IY = 1,NPIX
         DO 90 IX = 1,NPIX
            IF (VPHA(IX,IY).NE.FBLANK) THEN
               XP = IX - IX0
               YP = IY - IY0
               RP = SQRT(XP*XP + YP*YP)
               Q = RP/(2.0*FP)
               S = 1.0/(1.0 + Q*Q)
               IF (TYPE.EQ.'PFOC') THEN
                  XF = 2.0*(XP/RP)*Q*S
                  YF = 2.0*(YP/RP)*Q*S
                  ZF = -(1.0 - Q*Q)*S
               ELSE
                  QP = Q/XMAG
                  SP = 1.0/(1.0 + QP*QP)
                  XF = 2.0*(XP/RP)*(Q*S - QP*SP)
                  YF = 2.0*(YP/RP)*(Q*S - QP*SP)
                  ZF = -(1.0 - Q*Q)*S - (1.0 - QP*QP)*SP
                  END IF
               CORR = P0 + PX*XP + PY*YP + FX*XF + FY*YF + FZ*ZF
               VPHA(IX,IY) = VPHA(IX,IY) - CORR
               PHAMOD(IX,IY) = CORR
               END IF
 90         CONTINUE
 100     CONTINUE
C                                       Rescale feed offsets to mm.
      FX  = 1000.0*LAMBDA*FX/360.0
      FY  = 1000.0*LAMBDA*FY/360.0
      FZ  = 1000.0*LAMBDA*FZ/360.0
      DFX = 1000.0*LAMBDA*DFX/360.0
      DFY = 1000.0*LAMBDA*DFY/360.0
      DFZ = 1000.0*LAMBDA*DFZ/360.0
C                                       Compute the weighted half-path
C                                       error (as RMS)
      CALL SRFRMS (NPIX, XYMIN, XYMAX, IXYMIN, IXYMAX, IR2MIN, IR2MAX,
     *   VAMP, VPHA, R4, MEAN, RMS)
C
 999  RETURN
      END
      SUBROUTINE SRFRMS (NPIX, XYMIN, XYMAX, IXYMIN, IXYMAX, IR2MIN,
     *  IR2MAX, VAMP, VPHA, R4, MEAN, RMS)
C-----------------------------------------------------------------------
      INTEGER   IDR2, IDX, IDY, IR2MAX, IR2MIN, IX, IX0, IXYMAX, IXYMIN,
     *          IY, IY0, NPIX
      REAL      MEAN, R4, RMS, VAMP(NPIX,NPIX), VPHA(NPIX,NPIX), WT,
     *          XYMAX, XYMIN
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Compute the weighted half-path
C                                       error (as RMS)
C                                       Loop through the map.
      MEAN = 0.0
      RMS = 0.0
      WT  = 0.0
      IX0 = NPIX/2 + 1
      IY0 = NPIX/2 + 1
      DO 140 IY = 1,NPIX
         IDY = ABS(IY-IY0)
C                                       Check absolute limits.
         IF (XYMIN.GT.0.0 .AND. IDY.LT.IXYMIN) GO TO 140
         IF (XYMAX.GT.0.0 .AND. IDY.GT.IXYMAX) GO TO 140
C                                       Is this row of pixels outside
C                                       the outer ring?
         IF (XYMAX.LT.0.0 .AND. IDY*IDY.GT.IR2MAX) GO TO 140
         DO 130 IX = 1,NPIX
            IF (VPHA(IX,IY).EQ.FBLANK) GO TO 130
C                                       Check for inclusion.
            IDX  = ABS(IX-IX0)
            IDR2 = IDX*IDX + IDY*IDY
C                                       Inner limits.
            IF (XYMIN.GT.0.0) THEN
               IF (IDX.LT.IXYMIN) GO TO 130
            ELSE IF (XYMIN.LT.0.0) THEN
               IF (IDR2.LT.IR2MIN) GO TO 130
               END IF
C                                       Outer limits.
            IF (XYMAX.GT.0.0) THEN
               IF (IDX.GT.IXYMAX) GO TO 130
            ELSE IF (XYMAX.LT.0.0) THEN
               IF (IDR2.GT.IR2MAX) GO TO 130
               END IF
            MEAN = MEAN + VAMP(IX,IY)*VPHA(IX,IY)*R4
            RMS = RMS + VAMP(IX,IY)*((VPHA(IX,IY)*R4)**2)
            WT  = WT  + VAMP(IX,IY)
 130        CONTINUE
 140     CONTINUE
C
      IF (WT.GT.0) THEN
         MEAN = MEAN/WT
         RMS = RMS/WT - MEAN*MEAN
         IF (RMS.GT.0) RMS = SQRT(RMS)
C                                               Convert to mm.
         MEAN = 1000.0*MEAN
         RMS  = 1000.0*RMS
      ELSE
         RMS = -99.0
         END IF
C
      RETURN
      END
      SUBROUTINE SURDEV (CELLXY, LAMBDA, FOCUS, NPIX, VPHA, DEV)
C-----------------------------------------------------------------------
C   SURDEV computes the surface deviation map from the phase of the
C   aperture voltage distribution function.
C
C   Given:
C      CELLXY   R        Map cell spacing, in metres.
C      LAMBDA   R        Observing wavelength, in metres.
C      FOCUS    R        Focal length, in metres.
C      NPIX     I        Number of pixels on a side of the map.
C      VPHA     R(NPIX,NPIX)
C                        Aperture voltage phase map.
C
C   Returned:
C      DEV      R(NPIX,NPIX)
C                        Surface deviation map.
C
C   Algorithm:
C      The pathlength seen by an incoming signal is phase shifted on
C      both incidence and reflection from the antenna surface. Moreover,
C      away from the collimation axis of the antenna, the path deviates
C      from the normal to the antenna surface, this being the direction
C      in which the displacement is required.
C
C   Author: Mark Calabretta, Australia Telescope.
C   Origin; 1987/Apr/11  Code last modified; 1992/Nov/18
C-----------------------------------------------------------------------
      INTEGER   NPIX
      REAL      CELLXY, LAMBDA, FOCUS, VPHA(NPIX,NPIX), DEV(NPIX,NPIX)
C
      INTEGER   IX, IX0, IY, IY0
      REAL      A, B, C, R
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Initialization.
      IX0 = NPIX/2 + 1
      IY0 = NPIX/2 + 1
      A = FOCUS/CELLXY
      B = (LAMBDA/360.0)/(4.0*A)
      C = 4.0*A*A
C                                       Loop over the map.
      DO 20 IY = 1,NPIX
         DO 10 IX = 1,NPIX
            IF (VPHA(IX,IY).NE.FBLANK) THEN
               R = SQRT(REAL((IX-IX0)**2 + (IY-IY0)**2))
               DEV(IX,IY) = B*VPHA(IX,IY)*SQRT(R*R + C)
            ELSE
               DEV(IX,IY) = FBLANK
               END IF
 10         CONTINUE
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE HOLOUT (OUTNAM, OBJECT, TELESC, INSTRM, OBSERV, DATOBS,
     *   DATMAP, FREQ, UNITS, AXIS1, NX1, PINC1, AXIS2, NX2, PINC2,
     *   RDAT, HISTRY, NHIST, MVIS, IERR)
C-----------------------------------------------------------------------
C   HOLOUT saves the maps as AIPS image files with history as well.
C
C   Given:
C      OUTNAM   C*36      WAWA image namestring.
C      OBJECT   C*8       Object name.
C      TELESC   C*8       Telescope name.
C      INSTRM   C*8       Instrument name (receiver, correlator).
C      OBSERV   C*8       Observers.
C      DATOBS   C*8       Observation date.
C      DATMAP   C*8       Map date.
C      UNITS    C*8       Map units.
C      AXIS1    C*8       Title for axis 1.
C      NX1      I         Number of pixels on axis 1.
C      PINC1    R         Pixel increment on axis 1.
C      AXIS2    C*8       Title for axis 2.
C      NX2      I         Number of pixels on axis 2.
C      PINC2    R         Pixel increment on axis 2.
C      RDAT     R(NX1,NX2)
C                         Array containing the image.
C      HISTRY   C*72(*)   Internal file containing history text.
C      NHIST    I         Number of records in HISTRY.
C
C      MVIS     I         Number of vis used
C   Returned:
C      IERR     I         Error status, 0 means success.
C
C   Author: Mark Calabretta, Australia Telescope.
C   Origin; 1987/Nov.    Code last modified; 1992/Mar/12
C-----------------------------------------------------------------------
      CHARACTER OUTNAM*36, OBJECT*8, TELESC*8, INSTRM*8, OBSERV*8,
     *   DATOBS*8, DATMAP*8, UNITS*8, AXIS1*8, AXIS2*8, HISTRY(*)*(*)
      INTEGER   NX1, NX2, NHIST, MVIS, IERR
      REAL      FREQ, PINC1, PINC2, RDAT(NX1,NX2)
C
      INTEGER   BUFF(256), CNO, HILUN, I1, I2, IRET, ISEQ, IUSER, IVOL,
     *   NH, NHISTF, OLUN, NUMKEY, LOCS, KEYTYP, BUFF2(256)
      REAL      VMAX, VMIN
      CHARACTER CLASS*6, NAME*12, PTYPE*2, KEYWRD*8
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA OLUN, HILUN, NHISTF /18, 27, 1/
C-----------------------------------------------------------------------
C                                       Fill in the catalog header
      CALL CHR2H (8, OBJECT, 1, CATH(KHOBJ))
      CALL CHR2H (8, TELESC, 1, CATH(KHTEL))
      CALL CHR2H (8, INSTRM, 1, CATH(KHINS))
      CALL CHR2H (8, OBSERV, 1, CATH(KHOBS))
      CALL CHR2H (8, DATOBS, 1, CATH(KHDOB))
      CALL CHR2H (8, DATMAP, 1, CATH(KHDMP))
      CALL CHR2H (8, UNITS,  1, CATH(KHBUN))
      CATR(KREPO) = 0.0
      CATR(KRBLK) = FBLANK
      CATBLK(KIPCN) = 0
      CATBLK(KIDIM) = 3
      CATR(KRXSH) = 0.0
      CATR(KRYSH) = 0.0
C                                       First axis parameters.
      CALL CHR2H (8, AXIS1, 1, CATH(KHCTP))
      CATD(KDCRV) = 0.0D0
      CATR(KRCIC) = PINC1
      IF (PINC1.GE.0.0) THEN
         CATR(KRCRP) = NX1/2 + 1
      ELSE
         CATR(KRCRP) = NX1/2
         END IF
      CATBLK(KINAX) = NX1
C                                       Second axis parameters.
      CALL CHR2H (8, AXIS2, 1, CATH(KHCTP+2))
      CATD(KDCRV+1) = 0D0
      CATR(KRCIC+1) = PINC2
      CATR(KRCRP+1) = NX2/2 + 1
      CATBLK(KINAX+1) = NX2
C                                       Third axis parameters.
      CALL CHR2H (8, 'FREQ    ', 1, CATH(KHCTP+4))
      CATD(KDCRV+2) = FREQ * 1.D9
      CATR(KRCIC+2) = 0.0
      CATR(KRCRP+2) = 1.0
      CATBLK(KINAX+2) = 1
C                                       Create and open the map file.
      CALL MAPCR (OUTNAM, OUTNAM, CATBLK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CREATING MAP FILE'
         GO TO 990
         END IF
C                                       Compute the visibility coordinat
C                                       Open the map file.
      CALL OPENCF (OLUN, OUTNAM, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING MAP FILE'
         GO TO 990
         END IF
C                                       Extract the data from the array
C                                       and write the AIPS map.
      VMIN = +1.0E38
      VMAX = -1.0E38
      DO 50 I2 = 1, NX2
C                                       Find the maximum and minimum.
         DO 30 I1 = 1, NX1
            IF (RDAT(I1,I2).NE.FBLANK) THEN
               IF (RDAT(I1,I2).LT.VMIN) VMIN = RDAT(I1,I2)
               IF (RDAT(I1,I2).GT.VMAX) VMAX = RDAT(I1,I2)
               END IF
 30         CONTINUE
C                                       Write it to the AIPS file.
         CALL MAPIO ('WRIT', OLUN, RDAT(1,I2), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1040) IERR, I2
            GO TO 990
            END IF
 50      CONTINUE
C                                       Update the map header.
      CATR(KRDMX) = VMAX
      CATR(KRDMN) = VMIN
      CALL SAVHDR (OLUN, CATBLK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'UPDATING THE CATALOG HEADER'
         GO TO 990
         END IF
C                                       Close the output file.
      CALL FILCLS (OLUN)
C                                       Write the history file.
      CNO = FILTAB(POCAT, 6)
      CALL HIINIT (NHISTF)
      CALL WAWA2A (OUTNAM, NAME, CLASS, ISEQ, PTYPE, IVOL, IUSER)
C                                       Add output name.
      CALL HICREA (HILUN, IVOL, CNO, CATBLK, BUFF, IERR)
      CALL HENCOO (TSKNAM, NAME, CLASS, ISEQ, IVOL, HILUN, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'ADDING IMAGE NAME TO HISTORY'
         GO TO 990
         END IF
C                                       Add history text.
      DO 100 NH = 1, NHIST
         CALL HIADD (HILUN, HISTRY(NH), BUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'WRITING TO HISTORY FILE'
            GO TO 990
            END IF
 100     CONTINUE
C                                       add keyword for PANEL
      IF (MVIS.GT.0) THEN
         KEYWRD = 'VisUsed'
         NUMKEY = 1
         LOCS = 1
         KEYTYP = 4
         CALL CATKEY ('WRIT', IVOL, CNO, KEYWRD, NUMKEY, LOCS, MVIS,
     *      KEYTYP, BUFF2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'WRITING VisUsed KEYWORD'
            CALL MSGWRT (7)
            END IF
         END IF
C                                       Normal end.
      IRET = 0
      GO TO 995
C                                       Error exit
 990  IRET = 1
      CALL MSGWRT (8)
      CALL FILCLS (OLUN)
C
 995  CALL HICLOS (HILUN, .TRUE., BUFF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('HOLOUT: ERROR',I3,' ON ', A)
 1040 FORMAT ('HOLOUT: ERROR',I3,' WRITING LINE NUMBER',I6)
      END
      SUBROUTINE BEAM (NPIX, NLG, CMPRS, VAMP, VPHA, AAMP, APHA, VCPLX,
     *   WAMP, WPHA)
C-----------------------------------------------------------------------
C   BEAM evaluates the antenna power pattern.
C
C   Given:
C      NPIX    I        Number of pixels on a side of the map.
C      NLG     I        Number of pixels on a side of the beam fields
C      CMPRS   I        Select every CMPRS cells from VAMP,VPHA
C      VAMP    R(NPIX,NPIX)
C                       The amplitude of the voltage distribution across
C                       the antenna aperture.
C      VPHA    R(NPIX,NPIX)
C                       The phase of the voltage distribution across
C                       the antenna aperture.
C
C   Returned:
C      AAMP    R(NPIX,NPIX)
C                       The amplitude of the antenna pattern.
C      APHA    R(NPIX,NPIX)
C                       The phase of the antenna pattern.
C      VCPLX   C(NLG,NLG)
C                       Complex array for beam computation
C      WAMP    R(NLG,NLG)
C                       Real array for beam amplitude
C      WPHA    R(NLG,NLG)
C                       Real array for beam phase
C
C   Called:
C      {HOLFFT}
C
C   Algorithm:
C      Interpolation is done by compressing the voltage distribution map
C      and imbedding it in a larger array.  This is effectively a
C      multiplication by a pillbox function, and corresponds to a
C      convolution by a sinc function in the Fourier transform domain.
C
C   Author: Mike Kesteven, Australia Telescope.
C   Origin; 1987/12      Code last modified; 1996/07/09
C-----------------------------------------------------------------------
      INTEGER   NPIX, NLG, CMPRS
      REAL      VAMP(NPIX,NPIX), VPHA(NPIX,NPIX), AAMP(NPIX,NPIX),
     *          APHA(NPIX,NPIX), WAMP(NLG,NLG), WPHA(NLG,NLG)
      COMPLEX   VCPLX(NLG,NLG)
C
      INTEGER   IX, IY, JX, JY, K
      REAL      CS, SHFTX, SHFTY, SN
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       Initialize.
      DO 20 JY = 1, NLG
         DO 10 JX = 1, NLG
            VCPLX(JX,JY) = (0.0,0.0)
 10         CONTINUE
 20      CONTINUE
C                                       Compress and imbed the NPIXxNPIX
C                                       map in a NLGxNLG array.
      K = NLG - NPIX/(2*CMPRS)
      JY = K
      DO 40 IY = 1, NPIX, CMPRS
         JY = JY + 1
         IF (JY.GT.NLG) JY = JY - NLG
         JX = K
         DO 30 IX = 1, NPIX, CMPRS
            JX = JX + 1
            IF (JX.GT.NLG) JX = JX - NLG
            IF (VPHA(IX,IY).NE.FBLANK) THEN
               CS = VAMP(IX,IY)*COS(VPHA(IX,IY)*DG2RAD)
               SN = VAMP(IX,IY)*SIN(VPHA(IX,IY)*DG2RAD)
               VCPLX(JX,JY) = CMPLX(CS,SN)
               END IF
 30         CONTINUE
 40      CONTINUE
C                                       Apply a phase gradient to centre
C                                       the beam.
      SHFTY = 1.0
      DO 60 JY = 1, NLG
         SHFTX = SHFTY
         DO 50 JX = 1, NLG
            VCPLX(JX,JY) = SHFTX*VCPLX(JX,JY)
            SHFTX = -SHFTX
 50         CONTINUE
         SHFTY = -SHFTY
 60      CONTINUE
C                                       Transform.
      CALL HOLFFT (1, NLG, VCPLX, WAMP, WPHA)
C                                       Extract the beam, convert to dB
      K = (NLG - NPIX)/2
      DO 80 IY = 1, NPIX
         JY = K + IY
         DO 70 IX = NPIX, 1, -1
            JX = K + IX
            AAMP(IX,IY) = WAMP(JX,JY)
            APHA(IX,IY) = WPHA(JX,JY)
            IF (AAMP(IX,IY).LE.0.0) THEN
               AAMP(IX,IY) = FBLANK
            ELSE
               AAMP(IX,IY) = 20.0*LOG10(AAMP(IX,IY))
               END IF
 70         CONTINUE
 80      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE ANGAIN (NPIX, MAPSZ, RMAX, RMIN, LAMBDA, VAMP, VPHA,
     *   F1, MGAIN, TGAIN)
C-----------------------------------------------------------------------
C   ANGAIN computes the gain of an antenna given the aperture voltage
C   distribution.
C
C   Given:
C      NPIX     I        Number of pixels on a side of the map.
C      MAPSZ    R      Size of the map, in metres.
C      RMAX     R        The antenna radius, in cell units.
C      RMIN     R        Sub-reflector radius, in cell units.
C      LAMBDA   R        Wavelength of the observation, in metres.
C      VAMP     R(NPIX,NPIX)
C                        Amplitude of the voltage distribution across
C                        the antenna aperture.
C      VPHA     R(NPIX,NPIX)
C                        Phase of the voltage distribution across the
C                        antenna aperture.
C      F1       R        Scaling factor used to extrapolate in freq
C
C   Returned:
C      MGAIN    R        Measured gain, in dB.
C      TGAIN    R        Theoretical gain, in dB.
C
C   Author: Mike Kesteven, Australia Telescope.
C   Origin; 1987/11/11  Code last modified; 1996/08/20
C-----------------------------------------------------------------------
      INTEGER   NPIX
      REAL      F1, LAMBDA, MAPSZ, MGAIN, RMAX, RMIN, TGAIN,
     *          VAMP(NPIX,NPIX), VPHA(NPIX,NPIX)
C
      INTEGER   IX, IX0, IY, IY0, R
      REAL      AMAX, CELLSZ, CS1, CS2, FACT, SN1, SN2
      COMPLEX   INT1, INT2, INT3, INT4, TMP1, TMP2
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       Initialize
      CELLSZ = MAPSZ/NPIX
      IX0 = NPIX/2 + 1
      IY0 = NPIX/2 + 1
      INT1 = (0.0, 0.0)
      INT2 = (0.0, 0.0)
      INT3 = (0.0, 0.0)
      INT4 = (0.0, 0.0)
C                                       Integrate.
      DO 20 IY = 1, NPIX
         DO 10 IX = 1, NPIX
            R = SQRT(REAL((IX-IX0)**2) + REAL((IY-IY0)**2))
            IF (R.LE.RMAX .AND. R.GE.RMIN) THEN
               CS1 = VAMP(IX,IY)*COS(F1*VPHA(IX,IY)*DG2RAD)
               SN1 = VAMP(IX,IY)*SIN(F1*VPHA(IX,IY)*DG2RAD)
               CS2 = 1.0
               SN2 = 0.0
               TMP1 = CMPLX(CS1, SN1)
               TMP2 = CMPLX(CS2, SN2)
               INT1 = INT1 + TMP1
               INT2 = INT2 + TMP1*CONJG(TMP1)
               INT3 = INT3 + TMP2
               INT4 = INT4 + TMP2*CONJG(TMP2)
               END IF
 10         CONTINUE
 20      CONTINUE
C                                       Normalize.
      FACT  = CELLSZ/LAMBDA
      AMAX  = INT1*CONJG(INT1)/INT2
      AMAX  = AMAX*FACT*FACT
      MGAIN = AMAX*4.0*PI
      MGAIN = 10.0*LOG10(MGAIN)
      AMAX  = INT3*CONJG(INT3)/INT4
      AMAX  = AMAX*FACT*FACT
      TGAIN = AMAX*4.0*PI
      TGAIN = 10.0*LOG10(TGAIN)
C
 999  RETURN
      END

      SUBROUTINE ZSETUP
C-----------------------------------------------------------------------
C! performs system-level operations after VERNAM, TSKNAM, NPOPS known
C# System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZSETUP performs any needed system level operations which can be
C   performed only after VERNAM, TSKNAM, and NPOPS have been determined.
C
C   Generic version  - only lowers priority of batch jobs from that of
C   interactive.  If batch are started at the interactive priority,
C   then they can usually go back to interactive whne needed such as
C   while they possess a valuable device (e.g., a real AP).
C-----------------------------------------------------------------------
      INTEGER   IER
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Batch job - Lower priority for
C                                       everything except AIPSB, QMNGR
      IF ((NPOPS.GT.NINTRN+1) .OR. (ISBTCH.EQ.32000)) THEN
         IF ((TSKNAM.NE.'AIPSB') .AND. (TSKNAM.NE.'QMNGR'))
     *      CALL ZPRIO ('DOWN', IER)
         END IF
C
 999  RETURN
      END

      SUBROUTINE MSGWRT (MSGLEV)
C-----------------------------------------------------------------------
C! writes messages to log file and/or terminal - a fundamental routine!
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MSGWRT writes messages to log file and, if NPOPS = 1 and MSGLEV > 0,
C   to terminal.
C   Inputs:
C      MSGLEV   > 1   message importance (use 2 - 10)
C               = 1   message to terminal only
C               = 0   message to file only
C               < 0   force file closing
C   Common: alters MSGCNT in /MSGCOM/
C-----------------------------------------------------------------------
      INTEGER   MSGLEV
C
      CHARACTER PHNAME*48, MSGTET*80, ACTION(5)*4
      INTEGER   MINLEV, MAGIC, J1, KERR, NWPL, NLPR, NPKLIP, MSGTER,
     *   MSGFIL, SCRTCH(256), FINDF, FINDP, IER, IERR, JTRIM, IMSGPR,
     *   IPOS, IPRNT, IREC, J, JERR, K, MSGMAX, MSGINC, ITIME(6),
     *   MSGLEN, ITRIM
      LOGICAL   F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA F /.FALSE./
      DATA MSGTER, MSGFIL /6, 12/
      DATA ACTION /'OPEN','WRIT','CLOS','PRNT','XPND'/
      DATA MAGIC /32000/
      DATA MSGINC /210/
C-----------------------------------------------------------------------
C                                       optional suppression: level 6,7
      IF ((MSGSUP.EQ.MAGIC) .AND. ((MSGLEV.EQ.6) .OR.
     *   (MSGLEV.EQ.7))) GO TO 999
C                                       kill all lower messages option
      IF ((MSGKIL.EQ.MAGIC) .AND. (NPOPS.LE.NINTRN) .AND.
     *   (MSGLEV.EQ.0) .AND. (ISBTCH.NE.32000)) GO TO 999
      IF ((MSGLEV.GT.1) .AND. (MSGLEV.LE.MSGKIL-MAGIC+1)) GO TO 999
      FINDF = 0
C                                       clear nulls
      MINLEV = MSGLEV
C                                       Suppress informative messages?
      IF (MSGSUP.EQ.32005) THEN
         IF (MSGLEV.EQ.1) GO TO 999
         IF (MSGLEV.GT.1 .AND. MSGLEV.LE.5) MINLEV = 0
         IF (MSGKIL.EQ.MAGIC .AND. NPOPS.LE.NINTRN .AND.
     :    ISBTCH.NE.32000 .AND. MINLEV.EQ.0) GO TO 999
         END IF
      IF ((MSGKIL.EQ.MAGIC) .AND. (NPOPS.LE.NINTRN) .AND.
     *   (ISBTCH.NE.32000)) MINLEV = MIN (MINLEV, 1)
      KERR = 0
      IF (MINLEV.LT.0) GO TO 10
         NPKLIP = NINTRN
         IF (NBATQS.GT.0) NPKLIP = NINTRN + 1
         IF ((NPOPS.GT.NPKLIP) .AND. (MINLEV.EQ.1)) MINLEV = 2
         IF ((ISBTCH.EQ.32000) .AND. (MINLEV.EQ.1)) MINLEV = 2
         IMSGPR = JTRIM (MSGTXT)
         IMSGPR = MAX (1, IMSGPR)
C                                       check if file open
 10   IF (MINLEV.EQ.1) GO TO 20
      CALL LSERCH ('SRCH', MSGFIL, FINDF, F, IERR)
      IF (IERR.EQ.1) MSGCNT = -1
      IF ((IERR.EQ.0) .AND. (MSGCNT.LT.0)) CALL ZMSGCL (MSGFIL,
     *   FINDF, IERR)
C                                       Open file.
      NWPL = 25
      NLPR = 255 / NWPL
      IF ((MINLEV.LT.0) .OR. (MINLEV.EQ.1) .OR. (MSGCNT.GE.0))
     *   GO TO 20
         CALL ZPHFIL ('MS', 1, NLUSER, 0, PHNAME, IERR)
         JERR = 1
         CALL ZMSGOP (MSGFIL, FINDF, 1, PHNAME, IERR)
         IF (IERR.NE.0) FINDF = 0
         IF (IERR.NE.0) GO TO 90
C                                       read message count
         CALL ZMSGDK ('READ', MSGFIL, FINDF, 1, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 90
         MSGCNT = SCRTCH(1)
         MSGREC = SCRTCH(2)
         IF (MSGCNT.LT.0) MSGCNT = 0
         MSGMAX = NLPR * MSGREC
         IF (MSGCNT.GT.MSGMAX) THEN
            WRITE (MSGTER,1010) MSGCNT, MSGREC
            MSGCNT = MSGMAX
            END IF
C                                       Message to file
 20   IF ((MINLEV.LT.0) .OR. (MINLEV.EQ.1)) GO TO 30
         JERR = 2
         MSGCNT = MSGCNT + 1
         IREC = (MSGCNT-1) / NLPR + 1
         IPOS = MOD (MSGCNT-1, NLPR) * NWPL + 2
         MSGMAX = NLPR * MSGREC
         IF ((NPOPS.LE.NINTRN) .AND. (ISBTCH.NE.32000)) MSGMAX = 5000
C                                       expand file
         IF (IREC.LE.MSGREC) GO TO 22
            J = 100 / NLPR
            K = MSGSUP
            MSGSUP = 32000
            CALL ZPHFIL ('MS', 1, NLUSER, 0, PHNAME, IERR)
            CALL ZMSGXP (MSGFIL, 1, PHNAME, J, IERR)
            JERR = 5
            MSGSUP = K
            IF (IERR.NE.0) GO TO 90
            MSGREC = MSGREC + J
            IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) MSGMAX =
     *         MSGMAX + J*NLPR
C                                       get message record
 22      CALL ZMSGDK ('READ', MSGFIL, FINDF, IREC, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 90
C                                       Message format: 102 bytes
C                                       LEV, YY, MM, DD, HH, MM,
C                                       SS, POPS#, NAME(3),
C                                       MSG(40)
         SCRTCH(IPOS+1) = MIN (MINLEV, 15) + 16 * NPOPS
         CALL CATIME (1, SCRTCH(IPOS+2), ITIME)
         CALL CHR2H (6, TSKNAM, 1, SCRTCH(IPOS+4))
         CALL CHR2H (80, MSGTXT, 1, SCRTCH(IPOS+6))
C                                       back to disk
         CALL ZMSGDK ('WRIT', MSGFIL, FINDF, IREC, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 90
 25      IF (MSGCNT.LT.MSGMAX) GO TO 30
            IF (MOD(MSGCNT,MSGINC).NE.0) GO TO 30
            IF (NLUSER.EQ.1) GO TO 30
            CALL ZMSGOP (MSGTER, FINDP, 0, PHNAME, IER)
            IF ((IER.NE.0) .AND. (IER.NE.1)) GO TO 30
               WRITE (MSGTET,1025) NLUSER
               CALL ZTTYIO ('WRIT', MSGTER, FINDP, 72, MSGTET, IERR)
               CALL ZMSGCL (MSGTER, FINDP, IER)
C                                       Close file
 30   IF ((MSGCNT.LT.0) .OR. (MINLEV.EQ.1)) GO TO 40
 35      JERR = 3
         CALL ZMSGDK ('READ', MSGFIL, FINDF, 1, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 90
         MSGMAX = NLPR * MSGREC
         IF (MSGCNT.GT.MSGMAX) THEN
            WRITE (MSGTER,1035) MSGCNT, MSGREC
            MSGCNT = MSGMAX
            END IF
         SCRTCH(1) = MSGCNT
         SCRTCH(2) = MSGREC
         CALL ZMSGDK ('WRIT', MSGFIL, FINDF, 1, SCRTCH, IERR)
         MSGCNT = -1
         CALL ZMSGCL (MSGFIL, FINDF, IERR)
         FINDF = 0
         IF (IERR.NE.0) GO TO 90
         IF (KERR.NE.0) GO TO 999
C                                       Msg to terminal
 40   IF ((NPOPS.GT.NPKLIP) .OR. (MINLEV.LE.0)) GO TO 999
         JERR = 4
         CALL ZMSGOP (MSGTER, FINDP, 0, PHNAME, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.1)) GO TO 999
 42         IPRNT = MIN (64, IMSGPR)
            MSGTET = TSKNAM(1:6) // ': ' //  MSGTXT(1:IPRNT)
            CALL ZEHEX (NPOPS, 1, MSGTET(6:6))
C                                       Skip trailing blanks
            MSGLEN = ITRIM( MSGTET)
            CALL ZTTYIO ('WRIT', MSGTER, FINDP, MSGLEN, MSGTET, IERR)
            IF (IPRNT.GE.IMSGPR) GO TO 45
               J1 = IMSGPR - IPRNT
               IPRNT = IPRNT + 1
               MSGTET = ' '
               MSGTET(9:8+J1) = MSGTXT(IPRNT:IPRNT+J1-1)
C                                       Skip trailing blanks
               MSGLEN = ITRIM( MSGTET)
               CALL ZTTYIO ('WRIT', MSGTER, FINDP, MSGLEN, MSGTET, IERR)
 45         CALL ZMSGCL (MSGTER, FINDP, IERR)
            GO TO 999
C                                       Error
 90   IF (KERR.NE.0) GO TO 999
         KERR = 1
         CALL ZMSGOP (MSGTER, FINDP, 0, PHNAME, IER)
         IF ((IER.NE.0) .AND. (IER.NE.1)) GO TO 95
            WRITE (MSGTET,1090) IERR, ACTION(JERR)
            CALL ZTTYIO ('WRIT', MSGTER, FINDP, 72, MSGTET, IERR)
            IF (FINDF.GT.0) CALL ZMSGCL (MSGFIL, FINDF, IERR)
            GO TO 42
C                                       close disk
 95   CALL LSERCH ('SRCH', MSGFIL, FINDF, F, IERR)
      IF ((IERR.EQ.0) .AND. (JERR.EQ.2)) GO TO 35
      IF (IERR.EQ.0) CALL ZMSGCL (MSGFIL, FINDF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (' MSGCOUNT IN FILE EXCEEDS MSG REC',I16,I8)
 1025 FORMAT ('LOGFILE FOR USER ',I4,' GETTING LARGE: USE PRTMSG',
     *   ' AND CLRMSG NOW!')
 1035 FORMAT (' MSGCOUNT TO FILE EXCEEDS MSG REC',I16,I8)
 1090 FORMAT ('MSGWRT ERROR',I7,' AT ',A4)
      END

      PROGRAM AIPLAS
C-----------------------------------------------------------------------
C! AIPLAS reads AIPS manual from tape and prints on laser printer.
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C
C   PROBABLY DOES NOT WORK AT THE MOMENT - INCOMPLETE USE OF ZLASIO
C
C   AIPLAS reads and prints the AIPS manual from a tape written by
C   PRNTMN.  Line printer is logical unit 1, talks to unit 5.
C   This version is designed for the Laser printer in a small font
C   with two columns.
C   AIPMAN needs routines from the AIPS [APL] library.
C-----------------------------------------------------------------------
      CHARACTER MSGBUF*80, PHNAME*48, PRGNAM*6, PGBUF(2,65)*80,
     *   BUFF(100,2)*80, TCNOW*6, TRNOW*8, ICBEG*14, ICEND*14,
     *   TC(500)*6, TR(1000)*8
      INTEGER   NTAPE, IBUFF, NLINES, NTC, NTR, IPAGE, TTYLUN,
     *   TTYIND, I, J, I1, I2, IT, IP1, ILINES, TCP(500), TRP(1000),
     *   MAXTC, MAXTR, TLUN, TIND, NBYTES, LPLUN, LPIND,
     *   FLAG, IERR, PGCOL, TTY(2)
      LOGICAL   FIRST, T, F, WASEOF, EQUAL, LEOF, LOPAGE, LRPAGE,
     *   EQUAL1, LASER, DOIT, DOHELP, ICEDO
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMMON /MANCOM/ DOIT, DOHELP, TLUN, TIND, NBYTES, LPLUN, LPIND,
     *   PGCOL
      COMMON /MANCHR/ TCNOW, TRNOW, PGBUF
      EQUIVALENCE (TTY(1), TTYLUN),   (TTY(2), TTYIND)
      DATA T, F /.TRUE.,.FALSE./
      DATA MAXTC, MAXTR /500,1000/
      DATA TTYLUN /5/
      DATA PRGNAM /'AIPLAS'/
C-----------------------------------------------------------------------
C                                       Initialize
      CALL AIPINI (TTY, PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       shorten page a bit !!!
      PRTMAX = PRTMAX - 3
      NLINES = 0
      TCNOW = ' '
      TRNOW = ' '
      I1 = 1
      I2 = 2
      IPAGE = 0
      WASEOF = F
      NTC = 0
      NTR = 0
      FLAG = 2
      FIRST = T
      LASER = T
C                                        Ask which tape drive?
 10   WRITE (MSGBUF,1000)
      CALL INQINT (TTY, MSGBUF, 1, NTAPE, IERR)
      IF (IERR.LT.0) GO TO 10
      IF (IERR.GT.0) GO TO 970
      NTAPE = MAX (1, NTAPE)
C                                        Is there a start point?
      WRITE (MSGBUF,1010)
      CALL INQSTR (TTY, MSGBUF, 14, ICBEG, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL CHLTOU (14, ICBEG)
      DOIT = ICBEG.EQ.' '
C                                        Is there an end point?
      WRITE (MSGBUF,1020)
      CALL INQSTR (TTY, MSGBUF, 14, ICEND, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL CHLTOU (14, ICEND)
      ICEDO = ICEND.NE.' '
C                                        Read first buffer.
      CALL GETREC (FIRST, NTAPE, BUFF(1,I1), IERR)
      IF (IERR.NE.0) GO TO 980
C                                        Label first page.
      CALL PAGER (FLAG, NLINES, IPAGE)
C                                        Begin main loop.
 100  CONTINUE
C                                        Read next buffer.
         CALL GETREC (FIRST, NTAPE, BUFF(1,I2), IERR)
         WASEOF = IERR.EQ.4
         IF ((IERR.NE.0) .AND. (IERR.NE.4)) GO TO 550
C                                        Loop thru first buffer.
         DO 300 I = 1,100
C                                        Check for special records.
            LOPAGE = BUFF(I,I1)(1:2) .EQ. '@@'
            LRPAGE = (LOPAGE) .AND. (BUFF(I,I1)(3:4).EQ.'@@')
            LEOF   = BUFF(I,I1)(1:2) .EQ. '$$'
C                                        Check for end of file
            IF (LEOF) GO TO 500
C                                        If normal line print.
            IF (LOPAGE) GO TO 120
               PGBUF(PGCOL,NLINES) = BUFF(I,I1)
C                                        Check for new page.
               NLINES = NLINES + 1
               IF (NLINES.GT.PRTMAX) CALL PAGER (FLAG, NLINES, IPAGE)
               GO TO 300
C                                        New section.
 120        TCNOW = BUFF(I,I1)(5:10)
            TRNOW = BUFF(I,I1)(11:16)
C                                       Do we start printing now?
            IF (DOIT) GO TO 121
               EQUAL = TCNOW .EQ. ICBEG(1:6)
               EQUAL1 = TRNOW .EQ. ICBEG(7:14)
               DOIT = EQUAL .AND. EQUAL1
               GO TO 125
C                                       or end?
 121        IF (.NOT.ICEDO) GO TO 125
               EQUAL = TCNOW .EQ. ICEND(1:6)
               EQUAL1 = TRNOW .EQ. ICEND (7:14)
               IF ((EQUAL) .AND. (EQUAL1)) GO TO 500
C                                        Check for required page.
 125        IF ((.NOT.LRPAGE) .AND. (NLINES.LE.PRTMAX)) GO TO 130
               CALL PAGER (FLAG, NLINES, IPAGE)
               GO TO 200
C                                        Check if next section will fit
C                                        on current page.
 130        CONTINUE
               IF (NLINES.LE.4) GO TO 200
               IF (NLINES+6.GT.PRTMAX) GO TO 180
                  ILINES = 6
                  IP1 = I + 1
                  IF (IP1.GT.100) GO TO 145
                     DO 140 J = IP1,100
                        LOPAGE = BUFF(J,I1)(1:2) .EQ. '@@'
                        LEOF   = BUFF(J,I1)(1:2) .EQ. '$$'
                        IF ((LOPAGE) .OR. (LEOF)) GO TO 160
                           ILINES = ILINES + 1
 140                    CONTINUE
C                                        Loop thru second buffer.
 145           IF (WASEOF) GO TO 160
                  DO 150 J = 1,100
                     LOPAGE = BUFF(J,I2)(1:2) .EQ. '@@'
                     LEOF   = BUFF(J,I2)(1:2) .EQ. '$$'
                     IF ((LOPAGE) .OR. (LEOF)) GO TO 160
                        ILINES = ILINES + 1
 150                 CONTINUE
C                                        Next section will fit.
 160           IF (NLINES+ILINES.GT.2*PRTMAX) GO TO 180
               IF ((NLINES+ILINES.GT.PRTMAX) .AND. (PGCOL.EQ.2))
     *            GO TO 180
                  NLINES = NLINES + 6
                  GO TO 200
C                                        New page.
 180           CONTINUE
                  CALL PAGER (FLAG, NLINES, IPAGE)
C                                        Chapter index entry.
 200        EQUAL = TCNOW .EQ. TC(NTC)
            EQUAL1 = TCNOW .EQ. ' '
            IF ((EQUAL1) .OR. ((NTC.NE.0) .AND. (EQUAL))) GO TO 210
            IF (NTC.GE.MAXTC) GO TO 210
               NTC = NTC + 1
               TC(NTC) = TCNOW
               TCP(NTC) = IPAGE
               WRITE (MSGTXT,1200) TCNOW, IPAGE
               CALL MSGWRT (2)
               EQUAL1 = TC(NTC)(1:4) .EQ. '1C04'
               EQUAL = TC(NTC-1)(1:4) .EQ. 'IC04'
C                                       Force to odd page at start helps
               IF ((EQUAL) .OR. (.NOT.EQUAL1)) GO TO 205
                  IF (IPAGE.LE.0) GO TO 205
                  IF (((IPAGE/2)*2.NE.IPAGE) .AND. (NLINES.LE.4))
     *               GO TO 205
                  NLINES = MAX (5, NLINES)
                  DOHELP = EQUAL1
                  CALL PAGER (FLAG, NLINES, IPAGE)
                  IF (((IPAGE/2)*2.NE.IPAGE) .AND. (NLINES.LE.4))
     *               GO TO 205
                  NLINES = MAX (5, NLINES)
                  CALL PAGER (FLAG, NLINES, IPAGE)
 205           DOHELP = EQUAL1
C                                        Section index entry.
 210        EQUAL = TRNOW .EQ. TR(NTR)
            EQUAL1 = TRNOW .EQ. ' '
            IF ((EQUAL1) .OR. ((NTR.NE.0).AND.(EQUAL))) GO TO 300
            IF (NTR.GE.MAXTR) GO TO 300
               NTR = NTR + 1
               TR(NTR) = TRNOW
               TRP(NTR) = IPAGE
               WRITE (MSGTXT,1210) TRNOW, IPAGE
               CALL MSGWRT (1)
 300        CONTINUE
C                                        Move BUFF2 to BUFF1
         IF (WASEOF) GO TO 500
            IT = I1
            I1 = I2
            I2 = IT
            GO TO 100
C                                        Finished - do index.
C                                        Chapter index.
 500  TCNOW = 'INDEX '
      TRNOW = ' '
      CALL PAGER (FLAG, NLINES, IPAGE)
      IF (NTC.LT.1) GO TO 525
         DO 520 I = 1,NTC
            IF (MOD (I,5).NE.0) GO TO 510
               NLINES = NLINES + 1
               IF (NLINES.GT.PRTMAX) CALL PAGER (FLAG, NLINES, IPAGE)
 510        WRITE (MSGBUF,1510) TC(I), TCP(I)
            PGBUF(PGCOL,NLINES)(1:) = MSGBUF(1:)
            NLINES = NLINES + 1
            IF (NLINES.GT.PRTMAX) CALL PAGER (FLAG, NLINES, IPAGE)
 520        CONTINUE
C                                         Section index.
 525  IF (NTR.LE.0) GO TO 550
         IF ((NTC.GT.0) .AND. (NLINES.NE.4)) NLINES = NLINES + 4
         IF (NLINES.GT.PRTMAX) CALL PAGER (FLAG, NLINES, IPAGE)
         DO 540 I = 1,NTR
            IF (MOD(I,5).NE.0) GO TO 530
               NLINES = NLINES + 1
               IF (NLINES.GT.PRTMAX) CALL PAGER (FLAG, NLINES, IPAGE)
 530        WRITE (MSGBUF,1530) TR, TRP(I)
            PGBUF(PGCOL,NLINES)(1:) = MSGBUF(1:)
            NLINES = NLINES + 1
            IF (NLINES.GT.PRTMAX) CALL PAGER (FLAG, NLINES, IPAGE)
 540        CONTINUE
C                                        Finished - close printer.
 550  FLAG = -1
      IF (LASER) FLAG = -2
      CALL PAGER (FLAG, NLINES, IPAGE)
      GO TO 980
C                                       Error: TTY
 970  WRITE (MSGTXT,1970) IERR
      CALL MSGWRT (7)
C                                       Close TTY
 980  CALL ZCLOSE (TTYLUN, TTYIND, IERR)
C
 990  CALL ACOUNT (2)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('Enter tape drive number (I)')
 1010 FORMAT ('Start chapter, member names (A6,A8)')
 1020 FORMAT ('End chapter, member names (A6,A8)')
 1200 FORMAT ('At chapter ',A6,'  Page',I5)
 1210 FORMAT ('At section ',A8,'  Page',I5)
 1510 FORMAT (25X,A6,4X,I5)
 1530 FORMAT (25X,A8,4X,I5)
 1970 FORMAT ('TTY I/O ERROR = ',I6)
      END
      SUBROUTINE PAGER (FLAG, NLINES, IPAGE)
C-----------------------------------------------------------------------
C   PAGER  opens and closes the line printer and prints page headers.
C   Inputs:
C      FLAG    I    If 2 open laser file, then write laser commands
C                   and page header.
C                   If 1 open file then write page header.
C                   If 0 write page header.
C                   If -1 close line printer.
C      IPAGE    I   Page number.
C   In/Output:
C      NLINES   I   Line count initialized to 3
C      IPAGE    I   Page count incremented.
C-----------------------------------------------------------------------
      CHARACTER LPNAME*48,  OUTFIL*48, XC*80,
     *   CTYP(4)*2, PGBUF(2,65)*80, TCNOW*6, TRNOW*8
      INTEGER   FLAG, NLINES, IPAGE, TIND, TLUN, NBYTES,
     *   LPLUN, LPIND, IERR, I, IT, J, PGCOL, ISIZE
      LOGICAL   T, F, DOIT, DOHELP
      INCLUDE 'INCS:DDCH.INC'
      COMMON /MANCOM/ DOIT, DOHELP, TLUN, TIND, NBYTES, LPLUN, LPIND,
     *   PGCOL
      COMMON /MANCHR/ TCNOW, TRNOW, PGBUF
      DATA T, F /.TRUE.,.FALSE./
      DATA CTYP /'1C','2C','3C','4C'/
      DATA OUTFIL /' '/
C-----------------------------------------------------------------------
      ISIZE = 40 * 2 * 65
C                                        Check FLAG
      IF (FLAG) 300, 200, 100
C                                        Open
 100  LPLUN = 1
C                                       non-QMS
      IF (FLAG.EQ.2) GO TO 120
         CALL ZPHFIL ('LP', 1, 1, 1, LPNAME, IERR)
         CALL ZOPEN (LPLUN, LPIND, 1, LPNAME, F, T, T, IERR)
         GO TO 150
C                                       QMS
 120  CONTINUE
         LPIND = 0
         CALL ZLASIO ('POPN', LPLUN, OUTFIL, 1, LPNAME, IERR)
         IF (IERR.NE.0) GO TO 999
         WRITE (LPLUN, 1120)
         WRITE (LPLUN, 1121)
 150  IF (IERR.NE.0) GO TO 999
      FLAG = 0
      NLINES = 0
      IPAGE = 0
      GO TO 250
C                                       Page header.
 200  IF ((NLINES.EQ.4) .OR. ((IPAGE/2)*2.NE.IPAGE) .OR. (.NOT.DOIT))
     *   GO TO 250
C                                       Write it out
 210  CONTINUE
         IT = MOD (IPAGE-1, 4)
         IF ((IT.LT.2) .AND. (.NOT.DOHELP)) WRITE (LPLUN,1210)
     *      PGBUF(1,1), PGBUF(2,1)
         IF ((IT.LT.2) .AND. (DOHELP)) WRITE (LPLUN,1211)
     *      PGBUF(1,1), PGBUF(2,1)
         IF ((IT.GE.2) .AND. (.NOT.DOHELP)) WRITE (LPLUN,1212)
     *      PGBUF(1,1), PGBUF(2,1)
         IF ((IT.GE.2) .AND. (DOHELP)) WRITE (LPLUN,1213)
     *      PGBUF(1,1), PGBUF(2,1)
         DO 220 J = 2,PRTMAX
            IF (.NOT.DOHELP) WRITE (LPLUN,1214) PGBUF(1,J), PGBUF(2,J)
            IF (DOHELP) WRITE (LPLUN,1215) PGBUF(1,J), PGBUF(2,J)
 220        CONTINUE
         IF (FLAG.LT.0) GO TO 310
C                                       advance page
 250  IF ((IPAGE/2)*2.EQ.IPAGE) PGBUF(1,1) = ' '
      IF (NLINES.NE.4) IPAGE = IPAGE + 1
      NLINES = 4
      PGCOL = MOD (IPAGE-1, 2) + 1
      IF (IPAGE.EQ.1) GO TO 999
      DO 260 I = 1,4
         IF (CTYP(I).EQ.TCNOW(1:2)) GO TO 270
 260     CONTINUE
      IF (DOHELP) THEN
         WRITE (XC,1261) TCNOW, TRNOW, IPAGE
      ELSE
         WRITE (XC,1260) TCNOW, TRNOW, IPAGE
         END IF
      GO TO 280
 270  IF (DOHELP) THEN
         WRITE (XC,1271) TCNOW(1:1), TCNOW(2:3), TCNOW(4:5), TRNOW,
     *      IPAGE
      ELSE
         WRITE (XC,1270) TCNOW(1:1), TCNOW(2:3), TCNOW(4:5), TRNOW,
     *      IPAGE
         END IF
 280  PGBUF(PGCOL,1) = XC
      GO TO 999
C                                       Do last print ?
 300  IF ((IPAGE.GT.0) .AND. (DOIT) .AND. (NLINES.GT.4) .OR.
     *   (PGCOL.GT.1)) GO TO 210
C                                       Close printer.
 310  IF (FLAG.EQ.-2) GO TO 320
         CALL ZCLOSE (LPLUN, LPIND, IERR)
         GO TO 999
 320  CONTINUE
         WRITE (LPLUN,1320)
         WRITE (LPLUN,1321)
         CALL ZLASIO ('CLOS', LPLUN, OUTFIL, 1, LPNAME, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1120 FORMAT (' ^PY^-')
 1121 FORMAT (' ^IOL^IL0810^IS010^IC1400^IJ00560^IT00350^N``PN`-')
 1210 FORMAT ('1'///1X,A72,6X,A72)
 1211 FORMAT ('1'///7X,A64,10X,A64)
 1212 FORMAT ('1',A72,6X,A72)
 1213 FORMAT ('1',6X,A64,10X,A64)
 1214 FORMAT (1X,A72,6X,A72)
 1215 FORMAT (7X,A64,10X,A64)
 1260 FORMAT (A6,22X,A8,22X,'PAGE',I5)
 1261 FORMAT (A6,19X,A8,19X,'PAGE',I5)
 1270 FORMAT ('Volume ',A1,' Chapter ',A2,' ',A2,15X,A8,15X,
     *   'Page',I5)
 1271 FORMAT ('Volume ',A1,' Chapter ',A2,' ',A2,12X,A8,12X,
     *   'Page',I5)
 1320 FORMAT (' `PY`-')
 1321 FORMAT (' `N^^IOP^IL0600^IS404^IC1000^IJ00450^IT00700^PN^-')
      END
      SUBROUTINE GETREC (FIRST, NTAPE, REC, IERR)
C-----------------------------------------------------------------------
C   GETREC reads the tape and returns 8000 byte records.  Will also
C   open and close tape file if necessary.
C   Inputs:
C      FIRST     L         If true then open tape.
C      NTAPE     I         Tape drive number.
C   Output:
C      REC       C*8000    Data record from tape.
C      IERR      I         Error code, 0=>OK, 4=>EOF, otherwise error.
C-----------------------------------------------------------------------
      CHARACTER  REC*8000, TNAME*48
      INTEGER   NTAPE, IERR, TLUN, TIND, NBYTES, JERR, LPLUN, LPIND,
     *   PGCOL
      LOGICAL   T, F, FIRST, DOIT, DOHELP
      REAL      LREC(2000)
      COMMON /MANCOM/ DOIT, DOHELP, TLUN, TIND, NBYTES, LPLUN, LPIND,
     *   PGCOL
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                        Initialize
      NBYTES = 8000
      TLUN = 31
C                                        Check if need to open tape.
C                                        Open tape.
      IF (.NOT.FIRST) GO TO 100
         CALL ZPHFIL ('MT', NTAPE, 1, 1, TNAME, JERR)
         CALL ZOPEN (TLUN, TIND, NTAPE, TNAME, F, T, T, IERR)
         FIRST = F
         IF (IERR.NE.0) GO TO 999
C                                        Read record.
 100  CALL ZFIO ('READ', TLUN, TIND, NBYTES, LREC, IERR)
C                                        If EOF close file.
      IF (IERR.EQ.4) CALL ZCLOSE (TLUN, TIND, JERR)
      IF (IERR.EQ.0) CALL H2CHR (NBYTES, 1, LREC, REC)
C
 999  RETURN
      END

      SUBROUTINE ZTRLOG (LLEN, LOGNAM, XLEN, XLATED, XLNB, IERR)
C-----------------------------------------------------------------------
C! translate a logical name
C# Z2 System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Translate a logical name.
C   Inputs:
C      LLEN     I*2         Length of LOGNAM (i.e., as in LEN (LOGNAM))
C      LOGNAM   C*(*)       Logical name
C      XLEN     I*2         Length of XLATED (i.e., as in LEN (XLATED))
C   Output:
C      XLATED   C*(*)       Translation
C      XLNB     I*2         Position of the last non-blank character in
C                           the translation
C      IERR     I*2         Error return code: 0 => no error
C                              1 => no translation (no message)
C                              2 => other error
C                              3 => non-disk device
C   VMS version - calls ZERROR for system errors => should not be
C   called by routines called by MSGWRT.  In UNIX, no messages since
C   called by ZDAOPN,... which are called by MSGWRT.
C-----------------------------------------------------------------------
      INTEGER   LLEN, XLEN, XLNB, IERR
      CHARACTER LOGNAM*(*), XLATED*(*)
C
      CHARACTER TLATED*128, THOLD*256, CTEMP*256, TLOG*128
      INTEGER*2 ITEM2(8)
      INTEGER*4 SYS$TRNLNM, ITEM4(4), JERR, LLNB, LHOLD, TLNB, I, J,
     *   ID, IT, SYS$GETDVIW, DEVTYP
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE '($LNMDEF)'
      INCLUDE '($DVIDEF)'
      INCLUDE '($DCDEF)'
      INCLUDE '($SSDEF)'
      EQUIVALENCE (ITEM2(1), ITEM4(1))
C-----------------------------------------------------------------------
      IERR = 0
      XLNB = 0
      XLATED = ' '
      LHOLD = 0
      TLOG = LOGNAM
      ID = 0
C                                       Set up item list.
      ITEM2(1) = LEN (TLATED)
      ITEM2(2) = LNM$_STRING
      ITEM4(2) = %LOC (TLATED)
      ITEM4(3) = %LOC (TLNB)
      ITEM4(4) = 0
C                                       Get last non-blank in TLOG.
 10   LLNB = INDEX (TLOG, ' ') - 1
      IF (LLNB.LE.0) LLNB = LEN (TLOG)
      IF (TLOG(LLNB:LLNB).EQ.':') LLNB = LLNB - 1
      TLNB = 0
      TLATED = ' '
C                                       Translate logical name.
      JERR = SYS$TRNLNM (LNM$M_CASE_BLIND, 'LNM$FILE_DEV',
     *   TLOG(1:LLNB), ,ITEM2)
C                                       Error or done
 20   IF (JERR.NE.1) THEN
         IERR = 0
         IF (JERR.NE.SS$_NOLOGNAM) THEN
            CALL ZERROR ('ZTRLOG', JERR, ' ', -999, .FALSE.)
            IERR = 2
C                                       is "logical" a disk device
         ELSE IF (ID.LE.0) THEN
C                                       Set up item list.
            ITEM2(1) = 4
            ITEM2(2) = DVI$_DEVCLASS
            ITEM4(2) = %LOC (DEVTYP)
            ITEM4(3) = 0
            ITEM4(4) = 0
            JERR = SYS$GETDVIW ( , , TLOG(1:LLNB), ITEM2, , , , )
            IF ((JERR.NE.1) .OR. (DEVTYP.NE.DC$_DISK)) THEN
               IERR = 1
               IF (JERR.EQ.1) THEN
                  IERR = 3
                  LLNB = MIN (LLNB, 50)
                  WRITE (MSGTXT,1020) TLOG(1:LLNB)
                  CALL MSGWRT (6)
                  END IF
               END IF
            END IF
         IF (IERR.EQ.0) THEN
            IF (LHOLD.GT.0) THEN
               XLATED = TLOG(1:LLNB) // THOLD(1:LHOLD)
            ELSE
               XLATED = TLOG(1:LLNB)
               END IF
            XLNB = LLNB + LHOLD
            END IF
C                                       prepare to try another layer
      ELSE
         ID = ID + 1
         IF (LHOLD.GT.0) THEN
            CTEMP = THOLD
            I = 1
            IF ((TLATED(TLNB:TLNB).EQ.':') .AND. (CTEMP(1:1).EQ.':'))
     *         I = 2
            IF ((TLATED(TLNB:TLNB).EQ.']') .AND. (CTEMP(1:1).EQ.':'))
     *         I = 2
            IF ((TLATED(TLNB:TLNB).EQ.']') .AND. (CTEMP(1:2).EQ.':['))
     *         THEN
               TLNB = TLNB - 1
               I = 3
               END IF
            THOLD = TLATED(1:TLNB) // CTEMP(I:LHOLD)
            LHOLD = LHOLD - I + 1 + TLNB
         ELSE
            THOLD = TLATED
            LHOLD = TLNB
            END IF
         I = INDEX (THOLD, ':')
         J = INDEX (THOLD, '[')
         IT = TLNB + 1
         IF (I.GT.0) THEN
            IF (J.GT.0) IT = MIN (I, J)
            IF (J.LE.0) IT = I
         ELSE
            IF (J.GT.0) IT = J
            END IF
         IF ((IT.EQ.1) .OR. (ID.GT.20)) THEN
            JERR = 999
            GO TO 20
         ELSE
            CTEMP = THOLD(IT:)
            TLOG = THOLD(:IT-1)
            THOLD = CTEMP
            LHOLD = LHOLD - IT + 1
            GO TO 10
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('ZTRLOG: DEVICE ',A,' IS NOT A DISK')
      END

      SUBROUTINE ZVTVO2 (FCB, PNAME, IERR)
C-----------------------------------------------------------------------
C! open connection in client (virtual-TV) to server (remote, real-TV)
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZVTVO2 opens the connection in the Virtual TV program to the
C   remote computer which provides the actual TV device.
C   Inputs:
C      FCB     I(*)   File descriptor
C      PNAME   H*48   Environment variable (logical) "TVDEVn" identifies
C                     which TV is used and points to further ID info
C   Output:
C      IERR    I      Error: 0 => okay
C   Generic version - stub
C-----------------------------------------------------------------------
      HOLLERITH PNAME(*)
      INTEGER   FCB(*), IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 8
      WRITE (MSGTXT,1000)
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZVTVO2: REQUIRES DEVELOPMENT; GENERIC IS A STUB')
      END

      SUBROUTINE CVCMUL (A, I, B, C, J, N)
C-----------------------------------------------------------------------
C! FPS AP 120B load module
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   MICROCODE FOR FPS AP-120B ARRAY PROCESSOR
C   CVCMUL multiplies a scalar complex value times the complex
C   conjugate of a complex vector producing a real vector
C
C    CALLING SEQUENCE - CALL CVCMUL (A, I, B, C, J, N)
C       A = Source complex vector base address
C       I = Increment of A
C       B = Address of scalar (real part)
C       C = Destination real vector base address
C       J = Increment for C
C       N = Element count (number of reals)
C
C    C(K) = REAL(B) * A(K) + IMAG(B) * A(K+1)
C
C    Timing = 1.0 N + 3.0 microseconds
C    Should work on either fast or slow AP memory.
C    Programmer = W. D. Cotton, July 1980.
C-----------------------------------------------------------------------
      INTEGER*2 CODE(105), SLIST(16), A, I, B, C, J, N, J1, J2, J3,
     *   J4, J5, J6
      COMMON /SPARY/SLIST
      EQUIVALENCE (J1, SLIST( 1))
      EQUIVALENCE (J2, SLIST( 2))
      EQUIVALENCE (J3, SLIST( 3))
      EQUIVALENCE (J4, SLIST( 4))
      EQUIVALENCE (J5, SLIST( 5))
      EQUIVALENCE (J6, SLIST( 6))
      DATA CODE(1) /  26/
      DATA CODE(    2),CODE(    3),CODE(    4),CODE(    5)/
     *   Z4088,Z0000,Z0000,Z0030/
      DATA CODE(    6),CODE(    7),CODE(    8),CODE(    9)/
     *   Z310C,Z0000,Z0000,Z0000/
      DATA CODE(   10),CODE(   11),CODE(   12),CODE(   13)/
     *   Z0294,Z0000,Z0000,Z0010/
      DATA CODE(   14),CODE(   15),CODE(   16),CODE(   17)/
     *   Z4154,Z0000,Z4A04,Z0000/
      DATA CODE(   18),CODE(   19),CODE(   20),CODE(   21)/
     *   Z4000,Z01F2,Z0000,Z0030/
      DATA CODE(   22),CODE(   23),CODE(   24),CODE(   25)/
     *   Z0000,Z00E0,Z0000,Z0000/
      DATA CODE(   26),CODE(   27),CODE(   28),CODE(   29)/
     *   Z0000,Z0000,Z1A00,Z8000/
      DATA CODE(   30),CODE(   31),CODE(   32),CODE(   33)/
     *   Z0000,Z0000,Z0000,Z0010/
      DATA CODE(   34),CODE(   35),CODE(   36),CODE(   37)/
     *   Z0000,Z0000,Z0100,Z1700/
      DATA CODE(   38),CODE(   39),CODE(   40),CODE(   41)/
     *   Z0294,Z0000,Z0000,Z1F00/
      DATA CODE(   42),CODE(   43),CODE(   44),CODE(   45)/
     *   Z0000,Z01D2,Z0020,Z1B00/
      DATA CODE(   46),CODE(   47),CODE(   48),CODE(   49)/
     *   Z0003,ZE000,Z0000,Z0000/
      DATA CODE(   50),CODE(   51),CODE(   52),CODE(   53)/
     *   Z2040,Z0000,ZC005,Z1F30/
      DATA CODE(   54),CODE(   55),CODE(   56),CODE(   57)/
     *   Z0000,Z0000,Z0000,Z1F00/
      DATA CODE(   58),CODE(   59),CODE(   60),CODE(   61)/
     *   Z0001,Z9400,Z0140,Z0010/
      DATA CODE(   62),CODE(   63),CODE(   64),CODE(   65)/
     *   Z0295,Z8000,Z0100,Z1700/
      DATA CODE(   66),CODE(   67),CODE(   68),CODE(   69)/
     *   Z210C,Z01D2,Z0000,Z1F70/
      DATA CODE(   70),CODE(   71),CODE(   72),CODE(   73)/
     *   Z0000,Z0052,Z0000,Z0000/
      DATA CODE(   74),CODE(   75),CODE(   76),CODE(   77)/
     *   Z0000,Z004A,Z0020,Z1B00/
      DATA CODE(   78),CODE(   79),CODE(   80),CODE(   81)/
     *   Z0000,Z0000,Z0020,Z1B00/
      DATA CODE(   82),CODE(   83),CODE(   84),CODE(   85)/
     *   Z0000,Z0000,ZC005,Z1F00/
      DATA CODE(   86),CODE(   87),CODE(   88),CODE(   89)/
     *   Z0000,Z0000,Z0000,Z1F00/
      DATA CODE(   90),CODE(   91),CODE(   92),CODE(   93)/
     *   Z0001,Z9400,Z0140,Z0000/
      DATA CODE(   94),CODE(   95),CODE(   96),CODE(   97)/
     *   Z1031,Z8012,Z0000,Z0000/
      DATA CODE(   98),CODE(   99),CODE(  100),CODE(  101)/
     *   Z210C,Z0000,Z0000,Z0070/
      DATA CODE(  102),CODE(  103),CODE(  104),CODE(  105)/
     *   Z0003,ZE8E0,Z0000,Z0000/
C-----------------------------------------------------------------------
      J1 = A
      J2 = I
      J3 = B
      J4 = C
      J5 = J
      J6 = N
      CALL APEX (CODE, 0, SLIST, 6)
C
 999  RETURN
      END

      SUBROUTINE QUVIN (APCORE, UV, VIS, WORK, L, M, LROW, NS, INCS, NF,
     *   INCF, CNT, FLAG)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Interpolate visibility model from a grid.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2000, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Vector Version
C   Interpolates model visibility values from a grid, corrects the
C   model for the phase of the z*w term and adds the model to the data.
C   Inputs:
C      UV    I  Base address of U,V vector
C      VIS   I  Base address of visibility
C      WORK  I  Base address of work vector length CNT*4 words
C      L     I  Length of visibility record
C               interpolation fns tabulated every 1/200 cell.
C      M     I  Width of interpolation fn support size,  also
C               the number of rows kept in AP (must be odd)
C      LROW  I  length of a row (V)
C      NS    I  Number of correlators (Stokes parm.) to process.
C      INCS  I  Increment between correlators.
C      NF    I  Number of frequencies to process.
C      INCF  I  Increment between frequencies.
C      CNT   I  Number of visibility points.
C      FLAG  I  1 => add model, -1 => add i (SQRT(-1)) times
C               model.
C   Also expects necessary constants in following AP locations:
C          0 = U scaling to cells.
C          1 = V scaling to cells
C          2 = DXC = -2 * Pi * delta RA (in cells)
C          3 = DYC = -2 * Pi * delta DEC (cells)
C          4 = DZC = -2 * Pi * delta Z (in radians) for 1st
C              frequency channel.
C          5 = Used as work space.
C          6 = Used as work space.
C          7 = ROW = lowest central row of the interpolation (INTEGER)
C          8 = G = Address of base address of grid (INTEGER)
C          9 = CX = Address of base address of row interpolation
C              function (INTEGER)
C          10 = Used as work space.
C          11 = Used as work space.
C          15 = Factor for data (0 -> return only model, 1 data+-model)
C          16...15+NS = an array of correlator factors.
C              To subtract the model these should be negative.
C          20...20+NF-2 = differential frequency scaling table
C               for channels after the first one.
C               FREQ(n) = (1+MD(19+n-1)) * FREQ(n-1) for n>1
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   UV, VIS, WORK, L, M, LROW, NS, INCS, NF, INCF, CNT,
     *   FLAG
C
      INTEGER   IIF, UV1, UV2, IWORK1, IWORK2, VVIS, WORK1, VVIS1,
     *   JLOOP, FVIS, LOOP, IVAL1, IVAL2, IVAL3
      LONGINT   IUV, IW, IUV1, IW1, IW2, CORR, IV, LTEMP
      DOUBLE PRECISION FAC0, FAC1, FAC2, FAC3, FAC4, FACC, VALUE, DTEMP
      LOGICAL   SHIFT
      EQUIVALENCE (LTEMP, DTEMP)
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF ((CNT.LE.0) .OR. (NS.LE.0) .OR. (NF.LE.0)) GO TO 999
C                                       Setup
      UV1 = UV + 1
      UV2 = UV1 + 1
      WORK1 = WORK + 1
      IWORK1 = WORK + 2
      IWORK2 = IWORK1 + 1
      FVIS = VIS
      FAC0 = APCORE(PSAPOF)
      FAC1 = APCORE(1+PSAPOF)
      FAC2 = APCORE(2+PSAPOF)
      FAC3 = APCORE(3+PSAPOF)
      FAC4 = APCORE(4+PSAPOF)
C                                       Check if shift wanted
      SHIFT = (ABS (FAC2).GT.1.0E-20) .OR. (ABS (FAC3).GT.1.0E-20)
C                                       Setup U,V,W
      IUV = UV + PSAPOF
      IUV1 = UV1 + PSAPOF
      IW = WORK + PSAPOF
      INCLUDE 'INCS:ZVND.INC'
      DO 100 LOOP = 1,CNT
C                                       Save u,v
         APCORE(IW) = APCORE(IUV)
         APCORE(IW+1) = APCORE(IUV+1)
C                                       Scale u,v to cells.
         APCORE(IUV) = APCORE(IUV) * FAC0
         APCORE(IUV1) = APCORE(IUV1) * FAC1
C                                       Update pointers
         IUV = IUV + L
         IUV1 = IUV1 + L
         IW = IW + 4
 100     CONTINUE
C                                       Loop over frequency
      DO 800 IIF = 1,NF
         VVIS = FVIS
         CORR = 15 + PSAPOF
         IF (IIF.GT.1) THEN
C                                       Scale u and v
            VALUE = APCORE(18+PSAPOF+IIF)
            FAC4 = FAC4 + FAC4 * VALUE
            IUV = UV + PSAPOF
            DO 110 LOOP = 1,CNT
               APCORE(IUV) = APCORE (IUV) + VALUE * APCORE(IUV)
               APCORE(IUV+1) = APCORE (IUV+1) + VALUE * APCORE(IUV+1)
               IUV = IUV + L
 110           CONTINUE
            END IF
C                                       Shift position (z*w) term.
         IF (SHIFT) THEN
C                                       Fill array for Shift
            IUV = UV + PSAPOF
            IW2 = IWORK1 + 1 + PSAPOF
      INCLUDE 'INCS:ZVND.INC'
            DO 120 LOOP = 1,CNT
C                                       Set phase for shift
               APCORE(IW2) = APCORE(IUV) * FAC2 +
     *                       APCORE(IUV+1) * FAC3 +
     *                       APCORE(IUV+2) * FAC4
               IUV = IUV + L
               IW2 = IW2 + 4
 120           CONTINUE
C                                       Calc Cos and Sin of phase
            CALL QRECT1 (APCORE, IWORK1, 4, IWORK1, 4, CNT)
         ELSE
C                                       Else, No shift
            IW1 = IWORK1 + PSAPOF
      INCLUDE 'INCS:ZVND.INC'
            DO 130 LOOP = 1,CNT
               APCORE(IW1) = 1.0
               APCORE(IW1+1) = 0.0
               IW1 = IW1 + 4
 130           CONTINUE
C                                       end if shift
            END IF
C                                       Interpolate from grid.
         DTEMP = APCORE(8+PSAPOF)
         IVAL1 = LTEMP
         DTEMP = APCORE(9+PSAPOF)
         IVAL2 = LTEMP
         DTEMP = APCORE(7+PSAPOF)
         IVAL3 = LTEMP
         CALL QINTG (APCORE, UV, IWORK1, IWORK1, IVAL1, IVAL2, M, LROW,
     *      L, CNT, IVAL3)
C                                       Model values left in IWORK1
C                                       Conjugate if necessary.
         IF (FLAG.LE.0) THEN
            IW1 = IWORK1 + 1 + PSAPOF
      INCLUDE 'INCS:ZVND.INC'
            DO 300 LOOP = 1,CNT
               APCORE(IW1) = -APCORE(IW1)
               IW1 = IW1 + 4
 300           CONTINUE
            END IF
C                                       Loop over correlators.
         DO 600 JLOOP = 1,NS
C                                       Add component parts.
            FACC = APCORE(CORR+1)
            IV = VVIS + PSAPOF
            IW1 = IWORK1 + PSAPOF
C                                       just model, drop data
            IF (APCORE(15+PSAPOF).EQ.0.0) THEN
               DO 500 LOOP = 1,CNT
                  APCORE(IV) = APCORE(IW1) * FACC
                  APCORE(IV+1) = APCORE(IW1+1) * FACC
                  IV = IV + L
                  IW1 = IW1 + 4
 500              CONTINUE
C                                       data +- model
            ELSE
      INCLUDE 'INCS:ZVND.INC'
               DO 510 LOOP = 1,CNT
                  APCORE(IV) = APCORE(IV) + APCORE(IW1) * FACC
                  APCORE(IV+1) = APCORE(IV+1) + APCORE(IW1+1) * FACC
                  IV = IV + L
                  IW1 = IW1 + 4
 510              CONTINUE
               END IF
C                                       Update pointers.
            CORR = CORR + 1
            VVIS = VVIS + INCS
            VVIS1 = VVIS + 1
 600        CONTINUE
C                                       Update pointers for next freq.
         FVIS = FVIS + INCF
 800     CONTINUE
C                                       Restore u,v
      IW = WORK + PSAPOF
      IUV = UV + PSAPOF
      INCLUDE 'INCS:ZVND.INC'
      DO 850 LOOP = 1,CNT
         APCORE(IUV) = APCORE(IW)
         APCORE(IUV+1) = APCORE(IW+1)
         IW = IW + 4
         IUV = IUV + L
 850     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE UVGRID (IFIELD, SCRWRK, DISKI, CNOSCI, SCROUT, CATUVR,
     *   JBUFSZ, FREQID, BUFF1, BUFF2, BUFF3, IRET)
C-----------------------------------------------------------------------
C! Grids uv data to be FFTed.
C# AP-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 1999-2000, 2006-2008
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVGRID convolves uv data onto a grid using AP routines.
C   The visibilities are convolved onto the grid using the convolving
C   function specified by CTYPX,CTYPY,XPARM,YPARM.  The defaults for
C   these values must be filled in by a call to GRDFLT.
C   The gridded data is phase rotated so that the map center comes out
C   at location ICNTRX,ICNTRY.  If requested, a uv taper is applied to
C   the visibility weights before gridding.  If necessary, a three
C   dimension phase reference position  shift is done in AP1GRD.
C   If more than one channels are to be gridded together, UVGRID loops
C   over the frequency channels in an outer loop, reading the grid and
C   uv data several times and writing the grid several times.  This
C   bandwidth synthesis (BS) process will use the SCRWRK file.
C   For bandwidth synthesis both the SCROUT and SCRWRK files should be
C   big enough for an extra m rows, where m is the half width of the
C   X convolving function.
C      This version uses a scrolling buffer as large as possible using
C   both the primary and secondary AP memory; 1/4 of the memory is used
C   as the uv data bufferwhen possible.  Bandwidth synthesis is done
C   using as many channels as possible.  The number of channels is
C   determined by the width of the scrolling buffer, the channel
C   separations and the highest row number on which data occurs.
C      Zero spacing flux densities are gridded if provided.
C   Uses AIPS LUNs 18, 20, 21
C   Input uv data file in UV file CNOSCI.
C   Output grid file in image file SCROUT although SCROUT and SCRWRK may
C   be switched if bandwidth synthesis is used.
C   Inputs:
C      IFIELD      I     Field number to grid, if 0 then grid a beam.
C      SCRWRK      I     /CFILES/ file number for work file,
C                        (used for bandwidth synthesis)
C      DISKI       I     Input file disk number for catalogd files,
C                        .LE. 0 => /CFILES/ scratch file.
C      CNOSCI      I     Input file catalog slot number or /CFILES/
C                        scratch file number.
C      DISKO       I     Output file disk number for catalogd files,
C                        .LE. 0 => /CFILES/ scratch file.
C      SCROUT      I     /CFILES/ scratch file number of output file
C      CATUVR(256) R     UV data catalog header record.
C      JBUFSZ      I     Size in bytes of buffers. Dimension of
C                        BUFF1,2,3  must be at least 4096 words
C      FREQID      I     Id number of FQ entry, if it exists.
C   From commons: (Includes DGDS, DMPR, DUVH, CGDS, CMPR, CUVH)
C      NVIS         I    Number of visibility records (/UVHDR/)
C      LREC         I    Number of (real) words per visibility record
C                        (/UVHDR/)
C      NCHAVG       I    Number of frequency channels to grid
C                        together.
C      FLDSZ(2,*)   I    Dimension of map in RA, Dec (cells)
C      CELLSG(2)    R    The cell spacing in X and Y in arcseconds.
C      CHUV1        I    First channel number in file to grid
C                        (1 relative)
C      FREQ         D    Reference frequency (Hz) (/UVHDR/)
C      JLOCF        I    0 relative number of the frequency axis,
C                        (/UVHDR/)
C      TFLUXG       R    The total flux density removed from the data,
C                        this will be subtracted from the zero spacing
C                        flux before gridding.
C      CTYPX,CTYPY  I    Convolving function types for RA and Dec
C      XPARM(10)    R    Convolving function parameters for RA
C                        XPARM(1) = support half width.
C      YPARM(10)    R    Convolving function parameters for Dec.
C      BLMAX        R    Maximum baseline length allowed in 1000s of
C                        wavelengths.
C      BLMIN        R    Minimum baseline length allowed in 1000s of
C                        wavelengths.
C      GUARDB       R(2) Fraction of UMAX and VMAX to blank on edge of
C                        field
C      DOZERO       L    If true then do zero spacing flux.
C      ZEROSP(5)    R    Zero spacing flux, 1=>flux density (Jy)
C                        5 => weight to use.
C                        polarization.
C      DOTAPE       L    True if taper requested.
C      TAPERU,TAPERV R   TAPER (to 30%) in u and v (kilolamda)
C      NXBEM,NYBEM  I    The size of the BEAM in pixels.
C      FREQG(*)     D    Frequencies of the channels
C      FREQUV       D    Reference frequency for u,v, and w.
C      NGRDAT       L    If FALSE get map size, scaling etc. parms
C                        from the model map cat. header. If TRUE
C                        then the values filled in by GRDAT must
C                        already be filled into the common.
C   The following must be provided if NGRDAT is .TRUE.
C      XFLD,YFLD(*)    R    Field of view in RA and Dec (arcseconds)
C      DXCG,DYCG,DZCG  R    2*pi*(delta ra, delta dec, and delta z)
C                           to be used in AP1GRD to shift positions.
C                           (u,v and w are in cells). one per field.
C      SCLUG,SCLVG,SCLWG R   Conversion factors for u,v and w from
C                           wavelengths at the reference frequency
C                           to cells. one set per field.
C      ICNTRX,ICNTRY(*) I   The center pixel in X and Y for each
C                           field.
C   The following must be provided if NGRDAT is .FALSE.
C      CCDISK(16)  I     Disk numbers of the output images.
C      CCCNO(16)   I     Catalog slot numbers of output images.
C   Output:
C      SCRWRK      I     /CFILES/ file number for work file,
C                        (used for bandwidth synthesis)
C      SCROUT      I     /CFILES/ scratch file number of output file
C      BUFF1       R     Working buffer
C      BUFF2       R     Working buffer
C      BUFF3       R     Working buffer (buffers should be contigious
C                        in memory)
C      IRET        I     Return error code. 0=>OK, error otherwise.
C   Output via common:
C      BEMMAX      R     Sum of weights = normalization factor
C      GUAXAU,GUAXAV R   Max U, V in data set
C      GUAXBU,GUAXBV R   Max U, V used in grid
C   Usage Notes:
C    1) The input uvdata file is, with one exception, assumed to be
C     accurately described by the contents of CATUVR and the common
C     /UVHDR/ (includes DUVH, CUVH).  The exception is that the
C     frequencies of the channels are given by the common array FREQG.
C     The u,v, and w are assumes to be given by the common variable
C     FREQUV.
C    2) the contents of common /UVHDR/ (=includes DUVH, CUVH)
C     are filled in by UVPGET from the catalog header; UVPGET should
C     be called before calling UVGRID.
C    3) if NGRDAT is .FALSE. then the properties (e.g. shift) of the
C     desired output image are assumed to be described in the catalog
C     header of the existant file pointed to by CCDISK,CCCNO(IFIELD).
C    4) only one polarization will be processed and the input data is
C     assumed to be in the desired Stokes' type (i.e. I, Q, U, V etc.)
C     In the general case this will require reformatting the data.
C     This can be accomplished via CALCOP to do the whole file or
C     UVGET or SET1VS & GET1VS which work a record at a time.
C     Multiple channels may be gridded together a la bandwidth
C     synthesis by specifying NCHAVG > 1. One channel of several
C     channels may be gridded using CHUV1 > 1.
C    5) the random parameters in the data should include, in order,
C     u, v, w, weight (optional), time (optional) and baseline
C     (optional).  While the last are optional and not used, the last
C     words of random parameters are used as work space and, if they
C     are missing, u, v, and w may be clobbered.  The weights are
C     required but may be passed either as random parameters or as
C     part of the regular data array, CATUVR should tell which.
C    6) The necessary image normalization constant for proper
C     normalization of the FFTed image is produced only by a call
C     with IFIELD=0 to grid the sampling function.  Therefore,
C     UVGRID must be called to grid the sampling function IRREGARDLESS
C     of whether or not a beam will be produced.
C    7) The gridding convolution function parameters must be completely
C     specified.  The defaults should be filled in by a call to
C     GRDFLT before calling UVGRID.
C    8) Multiple IFs can be processed using the common frequency table
C     FREQG
C-----------------------------------------------------------------------
      INTEGER   IFIELD, SCRWRK, DISKI, CNOSCI, SCROUT, JBUFSZ, FREQID,
     *   IRET
      REAL      CATUVR(256), BUFF1(*), BUFF2(*), BUFF3(*)
C
      INTEGER   VO, BO, VREAD, LLVIS, LUNUV, LUN1, LUN2, IFACT, INPTR,
     *   IERR, KNPTR, JNPTR, NIO, NPOINT, NXO2, ILENBU, ICENX, ICENY,
     *   INDS2, NX, NY, IFILE1, IFILE2, FLIST(22,2), VSOFF, LVIS, WTOFF,
     *   IWOFF, LOCHAN, MXROGD, NROGRD, NCHGRD, KAP, U, CY, CX, VIS, WT,
     *   IVIS, ILOOP, I, J, IDATA, UV, ITEMP, LLREC, N, NO2, M, MO2,
     *   LROW, ROWSIZ, MCHGRD, INDEX, NROWS, MAXREC, APSIZE, APSMWT,
     *   EXCESS, LOGRID, CPASS, NCPASS, RPASS, NRPASS, IUMIN, IUMAX,
     *   USTRT, USTOP, UCOUNT, MAXU, ERRCNT, APCONI(3), LFIELD, NEED,
     *   MSGSAV, OUTD, OUTC
      LOGICAL   T, F, DOSHFT, BEAM, ALLROW, ONZE
      REAL      APCONS(20), UMIN, UMAX, UIN, VIN, WEIGHT, FLUXZ, TUC,
     *   TVC, SSCLU, FRSTU, UUMAXO, VVMAXO, BLMN2O, BLMX2O, ZSCLU,
     *   ZSCLV, ZSCLW, XXFLD, YYFLD, DDXS(3), FFRAC, SUMWT,
     *   ONESUM, BLEN, BLMN2, BLMX2, UUMAX, VVMAX, DU, DV, UUMAXG,
     *   VVMAXG, UMAT(3,3), PMAT(3,3)
      DOUBLE PRECISION   WX, WY, GFACT, FREQLO, FREQHI, XRA, XDEC
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMPR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      SAVE VO, BO, ERRCNT
      DATA T, F /.TRUE.,.FALSE./
      DATA VO, BO /0, 1/,  ERRCNT /0/
      DATA LUNUV, LUN1, LUN2 /18, 20, 21/
C-----------------------------------------------------------------------
      IRET = 0
      SUMWT = 0.0
      UCOUNT = 0
      IF ((GUARDB(1).LT.0.0) .OR. (GUARDB(1).GT.0.9)) GUARDB(1) = 0.0
      IF ((GUARDB(2).LT.0.0) .OR. (GUARDB(2).GT.0.9)) GUARDB(2) = 0.0
      GUAXAU = 0.
      GUAXAV = 0.
      GUAXBU = 0.
      GUAXBV = 0.
      GUACNT = 0
      IF (DISKI.GT.0) THEN
         OUTD = DISKI
         OUTC = CNOSCI
      ELSE
         OUTD = SCRVOL(CNOSCI)
         OUTC = SCRCNO(CNOSCI)
         END IF
C                                       Do zero spacing once each pass
      ONZE = F
      LFIELD = MAX (1, ABS(IFIELD))
C                                       Get field info. if nec.
      IF (.NOT.NGRDAT) THEN
         CALL GRDAT (T, IFIELD, CATUVR, BUFF1, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Fill channel table.

      IF ((IFIELD.LE.0) .AND. (LFIELD.EQ.1)) THEN
         CALL FRQTAB (DISKI, CNOSCI, LUNUV, CATUVR, FREQID, BUFF1, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      IF (DO3DIM) THEN
         MSGTXT = 'WARNING: UVGRID CALLED WITH DO3DIM TRUE'
         CALL MSGWRT (6)
         CALL XYSHFT (RA, DEC, XSHIFT(LFIELD), YSHIFT(LFIELD), MAPROT,
     *      XRA, XDEC)
         CALL PRJMAT (RA, DEC, UVROT, XRA, XDEC, MAPROT, UMAT, PMAT)
         END IF
C                                       Set parameters for beam/map.
      BEAM = IFIELD.LE.0
C                                       Map.
      IF (IFIELD.GT.0) THEN
         NX = FLDSZ(1,IFIELD)
         NY = FLDSZ(2,IFIELD)
         ICENX = ICNTRX(IFIELD)
         ICENY = ICNTRY(IFIELD)
         ZSCLU = 1.0 / (RAD2AS / (NX * ABS (CELLSG(1))))
C                                       Flip sign on v to make maps come
C                                       out upside down.
         ZSCLV =  - 1.0 / (RAD2AS / (NY * CELLSG(2)))
         ZSCLW = 1.0
         XXFLD = XFLD(IFIELD)
         YYFLD = YFLD(IFIELD)
         DDXS(1) = -DXCG(IFIELD)
         DDXS(2) = -DYCG(IFIELD)
         DDXS(3) = -DZCG(IFIELD)
         IF (DO3DIM) CALL PRJMUL (2, DDXS, PMAT, DDXS)
C                                       Beam
      ELSE
         NX = NXBEM(LFIELD)
         NY = NYBEM(LFIELD)
         ICENX = NX / 2
         ICENY = NY / 2 + 1
         ZSCLU = SCLUG(1) * NX / FLDSZ(1,LFIELD)
         ZSCLV = SCLVG(1) * NY / FLDSZ(2,LFIELD)
         ZSCLW = 1.0E-6
         XXFLD = ABS (CELLSG(1)) * NX
         YYFLD = ABS (CELLSG(2)) * NY
         DDXS(1) = 0.0
         DDXS(2) = 0.0
         DDXS(3) = 0.0
         END IF
      DOSHFT = (DDXS(1).NE.0.0) .OR. (DDXS(2).NE.0.0)
C                                       Setup I/O
C                                       Set UV data I/O length.
      ILENBU = ((JBUFSZ - NBPS) / 2) / LREC - 2
      ILENBU = MAX (ILENBU, 1)
      NXO2 = NX / 2
C                                       Make sure an ODD number of rows
C                                       is being kept in the AP.
      NO2 = MAX (YPARM(1) , 1.0) + 0.1
      N   = NO2 * 2 + 1
      MO2 = MAX (XPARM(1) , 1.0) + 0.1
      M   = MO2 * 2 + 1
      LLREC = LREC
      LROW = NY
C                                       IFACT is the number of REAL
C                                       accumulators in GRID per cell
      IFACT = 2
      ROWSIZ = IFACT * LROW
C                                       Frequency scaling constants
      DV = RAD2AS / (NY * CELLSG(2))
      DU = RAD2AS / (NX * ABS (CELLSG(1)))
C                                       Stay away from edge of grid.
      UUMAXO = (NXO2 - 0.5 - MAX (3, MO2)) * DU
      VVMAXO = (NY/2 - 0.5 - MAX (3, NO2)) * DV
C                                       Set baseline limits (round out)
      BLMN2O = 0.999E6 * BLMIN * BLMIN
      BLMX2O = 1.001E6 * BLMAX * BLMAX
      IF (BLMX2O.LE.1.0) BLMX2O = 1.0E20
C                                       Set up for APIO to transfer
C                                       the GRID to and from the AP.
      IFILE1 = 2
      IFILE2 = 1
C                                       Init FLIST
      CALL FILL (22, 0, FLIST(1,1))
      CALL FILL (22, 0, FLIST(1,2))
      FLIST(1,1) = LUN1
      FLIST(1,2) = LUN2
      FLIST(2,1) = SCROUT
      FLIST(2,2) = SCRWRK
      FLIST(13,1) = JBUFSZ
C                                       Set grid size
      FLIST(5,1) = ROWSIZ
C                                       Number of rows for write
      FLIST (6,1) = NXO2 + 1
      FLIST(10,1) = FLIST(6,1)
C                                       Set window - write backwards
      FLIST(9,1) = 1
      FLIST(11,1) = FLIST(5,1)
      FLIST(12,1) = 1
C                                       Copy first file FLIST to second
      CALL COPY (10, FLIST(4,1), FLIST(4,2))
C                                       Determine no. rows in AP -
C                                       any excess over allowing 1/4 for
C                                       data buffer goes to extra rows.
      NEED = 1.34 * (30 + NCHAVG + 100 * (N + M) + (NXO2+M)*ROWSIZ)
      NEED = NEED / 1024
C                                       Grab AP to init PSAPNW
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL QINIT (NEED, 0, KAP)
      MSGSUP = MSGSAV
      IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
         NEED = 1.34 * (30 + NCHAVG + 100 * (N + M) + (NXO2/8+M)*ROWSIZ)
         NEED = NEED / 1024
         NEED = MIN (32*1024, NEED) + 2
         CALL QINIT (NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            IRET = 8
            MSGTXT = 'UVGRID UNABLE TO GET DESIRED MEMORY'
            GO TO 995
            END IF
         END IF
      APSIZE = PSAPNW * 1024
      EXCESS = ((APSIZE * 3) / 4) - 30 - NCHAVG - (100 * (N + M))
      MXROGD = MAX ((EXCESS/ROWSIZ)-1, M)
C                                       grid no more than all rows
      MXROGD = MIN (MXROGD, NXO2+M)
C                                       Set AP pointers
      LOGRID = APSIZE - ((MXROGD+1) * ROWSIZ) - 1
C                                       Set AP locations for conv. fn.
      CY = LOGRID - 100 * N - 5
      CX = CY     - 100 * M - 1
C                                       AP index to beam sum of weights
      APSMWT = 21 + NCHAVG
C                                       UV data starts after weights
      UV = APSMWT + 2
C                                       Set AP data freq. increment.
      LVIS = INCF
      IF ((INCIF.GT.0) .AND. (INCIF.LT.INCF)) LVIS = INCIF
      LLVIS = LVIS
C                                       Find where weight is.
C                                       IWOFF + => Offset in rec.
C                                       IWOFF - => Offset in vis.
      IWOFF = 0
      CALL AXEFND (4, 'WEIG', KIPTPN, CATUVR(KHPTP), IWOFF, IERR)
C                                       Make Taper widths convenient
      TUC = 0.0
      TVC = 0.0
      IF (DOTAPE) THEN
         IF (TAPERU.GT.0.) TUC = LOG(.3) / (TAPERU * 1E3 /
     *      206265. * XXFLD) ** 2
         IF (TAPERV.GT.0.) TVC = LOG(.3) / (TAPERV * 1E3 /
     *      206265. * YYFLD) ** 2
         END IF
C                                       Shift the map center
C                                       here in the gridding routine.
C                                       ICENX and ICENY define the
C                                       pixel number of the map center.
      WX = (-TWOPI * (ICENX-1-NX/2)) / NX
      WY = (-TWOPI * (ICENY-1-NY/2)) / NY
C                                       Set AP gridding constants.
      APCONS(1) = COS ((NX / 2) * WX)
      APCONS(2) = SIN ((NX / 2) * WX)
      APCONS(3) = COS (WY)
      APCONS(4) = SIN (WY)
      APCONS(5) = COS (-WX)
      APCONS(6) = SIN (-WX)
      APCONS(7) = 1.0
      APCONS(8) = 0.0
      APCONS(9) = 0.0
      APCONS(10) = TUC
      APCONS(11) = TVC
      APCONI(1) =  CX
      APCONI(2) =  CY
C                                       Determine the maximum number
C                                       of visibility points which
C                                       fit in the AP.
      MAXREC = (CX - UV) / LREC - 5
      ILENBU = MIN (MAXREC, ILENBU)
C                                       Open UV files
      IF (DO3DIM) THEN
         CALL UVPROT ('READ', DISKI, CNOSCI, LUNUV, INDS2, DO3DIM,
     *      MFIELD, UMATS, 1.0, 0.0, NVIS, LREC, ILENBU, JBUFSZ, BUFF1,
     *      NIO, INPTR, FRSTU, OUTD, OUTC, IRET)
      ELSE
         CALL UVPREP ('READ', DISKI, CNOSCI, LUNUV, INDS2, NVIS, LREC,
     *      ILENBU, JBUFSZ, BUFF1, NIO, INPTR, FRSTU, IRET)
         END IF
      IF (IRET.NE.0) GO TO 999
C                                       Rescale FRSTU by max frequency
      FRSTU = FRSTU * MAX (FREQG(CHUV1), FREQG(CHUV1+NCHAVG-1)) / FREQUV
C                                       Determine Maximum U (in cells)
      MAXU  = INT ((ABS(FRSTU) * ZSCLU) + 2.)
C                                       limit U to max that will fit
      MAXU  = MIN (MAXU, NXO2)
C                                       calc number needed
      NROGRD = MAXU + M
C                                       do all rows fit in ap?
      ALLROW = (MXROGD.GE.NROGRD)
C                                       number of rows in a pass
      NROWS  = MIN(NROGRD,MXROGD)
C                                       if all rows fit, 1 pass
      IF (ALLROW) THEN
         NRPASS = 1
      ELSE
C                                       else, how many row passes?
         NRPASS = (MAXU + 1)/(NROWS - M + 1)
C                                       round up if not equal
         IF (NRPASS*(NROWS-M+1).LT.(MAXU+1)) NRPASS = NRPASS + 1
         END IF
C                                       Determine Number of chan Passes
      CALL UVAPAS (NCHAVG, MAXU, NROWS-M+1, FREQG(CHUV1), FREQUV, 0,
     *   NCPASS, LOCHAN, NCHGRD, FREQLO, FREQHI, BUFF2)
C                                       tell user rows in AP
      IF ((BEAM) .AND. (LFIELD.EQ.1)) THEN
         WRITE (MSGTXT,1010,ERR=100) NCPASS, NRPASS
         IF ((NCPASS.NE.1) .OR. (NRPASS.NE.1)) CALL MSGWRT (3)
         IF (ALLROW) THEN
            WRITE (MSGTXT,1020,ERR=100) NROWS, PSAPNW, MXROGD
         ELSE
            WRITE (MSGTXT,1030,ERR=100) NROWS, PSAPNW
            END IF
         CALL MSGWRT (3)
C                                       tell user max base line
         WRITE (MSGTXT,1035,ERR=100) FRSTU, MAXU
         CALL MSGWRT (3)
C                                       tell user channels
        IF (NCHAVG.GT.1) THEN
            WRITE (MSGTXT,1036,ERR=100) NCHAVG, FREQG(CHUV1),
     *         FREQG(CHUV1+NCHAVG-1)
         ELSE
            WRITE (MSGTXT,1037,ERR=100) FREQG(CHUV1)
            END IF
         CALL MSGWRT (3)
         END IF
C                                       jump on write error
 100  CONTINUE
C-----------------------------------------------------------------------
C                                       Clear grid.
      CALL QVCLR (LOGRID, 1, APSIZE-LOGRID-1)
      CALL QWAIT
C                                       Grid data.
C                                       Bandwidth synthesis loop
      DO 600 CPASS = 1,NCPASS
C                                       Determine Num Chan to average
         CALL UVAPAS (NCHAVG, MAXU, NROWS-M+1, FREQG(CHUV1), FREQUV,
     *      CPASS, NCPASS, LOCHAN, NCHGRD, FREQLO, FREQHI, BUFF2)
         MCHGRD = NCHGRD
C                                       Load frequency scaling table
         CALL QWAIT
         CALL QPUT (BUFF2, 20, MCHGRD, 2)
         IF (DOTAPE) MCHGRD = -MCHGRD
C                                       Offset VIS to freq channel.
         VSOFF = NRPARM + (LOCHAN+CHUV1-2) * LVIS
         VIS = UV + VSOFF
C                                       If COMPLEX axis more then
C                                       2 long Vis has weight.
C                                       weight is in random parameters
         IF (LVIS.LE.2) THEN
            WTOFF = IWOFF
C                                       Weight in vis, index to channel
         ELSE
            WTOFF = VSOFF + 2
            END IF
C                                       set index relative to AP buffer
         WT = UV + WTOFF
C                                       Create Convolving function
         CALL CONVFN (CX, CTYPX, XPARM, BUFF2)
         CALL CONVFN (CY, CTYPY, YPARM, BUFF2)
C                                       write needed rows
         FLIST(6,IFILE1) = NXO2+1
         FLIST(10,IFILE1) = FLIST(6,IFILE1)
C                                       Set freq. scaling factors
         FFRAC = (FREQG(LOCHAN+CHUV1-1) / FREQUV) - 1.0D0
         SSCLU = FFRAC * ZSCLU + ZSCLU
         GFACT = 1.0D0 / ((FREQLO/FREQUV) * ZSCLU)
C                                       Set limits.
C                                       Rescale baseline limits.
         BLMN2 = BLMN2O / ((1.0D0 + FFRAC) ** 2)
         BLMX2 = BLMX2O / ((1.0D0 + FFRAC) ** 2)
         UUMAX = UUMAXO / (1.0D0 + FFRAC)
         VVMAX = VVMAXO / (1.0D0 + FFRAC)
         UUMAXG = NXO2 * DU * (1. - GUARDB(1)) / (1.0D0 + FFRAC)
         VVMAXG = NY/2 * DV * (1. - GUARDB(2)) / (1.0D0 + FFRAC)
         UUMAXG = MIN (UUMAXG, UUMAX)
         VVMAXG = MIN (VVMAXG, VVMAX)
C                                       Put gridding constants into AP
         APCONS(12) = FFRAC*ZSCLU + ZSCLU
         APCONS(13) = FFRAC*ZSCLV + ZSCLV
         APCONS(14) = FFRAC*ZSCLW + ZSCLW
         APCONS(15) = DDXS(1) / ZSCLU
         APCONS(16) = DDXS(2) / ZSCLV
         APCONS(17) = DDXS(3) / ZSCLW
         CALL QWAIT
         CALL QPUT (APCONS, 0, 17, 2)
         CALL QPUT (APCONI, 17, 3, 1)
C                                       IF Second file is used
C                                       Switch files: 2=>1, 1=>2
         IF ((CPASS.EQ.1) .OR. (.NOT.ALLROW)) THEN
            IFILE1 = 3 - IFILE1
            IFILE2 = 3 - IFILE2
            END IF
C                                       for all row passes
         DO 500 RPASS = 1, NRPASS
C                                       Calc min and max U for pass
C                                       Must be room for M extra rows
            IUMAX = MAXU - (NROWS-M+1)*(RPASS-1)
            IUMIN = MAX(IUMAX - (NROWS-M), 0)
C                                       Init for next read.
            VREAD = VO
            CALL UVINIT ('READ', LUNUV, INDS2, NVIS, VO, LREC, ILENBU,
     *         JBUFSZ, BUFF1, BO, INPTR, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1060) IRET
               GO TO 995
               END IF
C                                       if not first row pass, shift
            IF (RPASS.GT.1) THEN
C                                       always move M-1=2*MO2 rows
               USTOP = IUMAX+MO2
               CALL APSHFT (MO2, USTOP, IUMIN-MO2, ROWSIZ, LOGRID,
     *           APSIZE)
               END IF
C                                       If not first BS Pass
            IF (CPASS.GT.1 .AND. (.NOT.ALLROW)) THEN
C                                       load rows not shifted
               USTRT = IUMIN-MO2
               USTOP = IUMAX-MO2
C                                       if first pass, load all rows
               IF (RPASS.EQ.1) USTOP = NXO2
C                                       if last pass, stop at U=-MO2
               IF (RPASS.EQ.NRPASS) USTRT = IUMIN - MO2
C                                       READ needed rows
               FLIST(6,IFILE2) = NXO2+1+MO2
               FLIST(10,IFILE2) = FLIST(6,IFILE2)
C                                       load previous values in AP
               CALL APLOAD (USTRT, USTOP, IUMIN-MO2, ROWSIZ, LOGRID,
     *            APSIZE, FLIST(1, IFILE2), BUFF3, IRET)
               IF (IRET.NE.0) GO TO 999
C                                       end if loading previous pass
               END IF
C                                       set min and max this pass
            UMAX = (IUMAX + 0.5) * GFACT
            UMIN = (IUMIN - 0.5) * GFACT
C                                       loop forever, read all UVdata
            DO 270 ILOOP = 1,1000000
C                                       read one UVdata Buffer
               CALL UVDISK ('READ', LUNUV, INDS2, BUFF1, NIO, INPTR,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1100) IRET
                  GO TO 995
                  END IF
C                                       if no more data, exit
               IF (NIO.LE.0) GO TO 275
C                                       set UV buffer indicies
               IDATA = UV
               NPOINT = 0
               JNPTR = INPTR
               KNPTR = INPTR
C                                       for all vis points in buffer
               DO 260 IVIS = 1,NIO
                  IF (DO3DIM) CALL PRJMUL (1, BUFF1(JNPTR), UMAT,
     *               BUFF1(JNPTR))
C                                       input U value
                  UIN = ABS (BUFF1(JNPTR))
                  VIN = ABS (BUFF1(JNPTR+1))
                  GUAXAU = MAX (GUAXAU, UIN)
                  GUAXAV = MAX (GUAXAV, VIN)
C                                       If datum on current rows
                  IF ((UIN.GT.UMIN) .AND. (UIN.LE.UMAX)) THEN
C                                       calc baseline length squared
                     BLEN = UIN*UIN + VIN*VIN
C                                       Check if uv in range.
                     IF ((BLEN.GE.BLMN2) .AND. (BLEN.LE.BLMX2)) THEN
C                                       If inside guard band
                        IF ((UIN.LE.UUMAXG) .AND. (VIN.LE.VVMAXG)) THEN
C                                       if making the synthesized beam
C                                       BEAM replace data with (1,0)
                           IF (BEAM) CALL UVSETB (VSOFF, LVIS, UMAX,
     *                        UMIN, SSCLU, NCHGRD, BUFF1(JNPTR))
C                                       Check if U neg.
C                                       Flip U, V, W, conjugate data.
                           IF (BUFF1(JNPTR).LT.0.0) CALL UVCONJ (VSOFF,
     *                        LVIS, NCHGRD, 1, 2, BUFF1(JNPTR))
C                                       count points, update pointer
                           NPOINT = NPOINT + 1
C                                       if not same point, copy
                           IF (KNPTR.NE.JNPTR) CALL RCOPY (LREC,
     *                        BUFF1(JNPTR), BUFF1(KNPTR))
C                                       update output pointer
                           KNPTR  = KNPTR + LREC
                           GUAXBU = MAX (GUAXBU, UIN)
                           GUAXBV = MAX (GUAXBV, VIN)
                           GUACNT = GUACNT + 1
                           END IF
C                                       Error: outside UVRANGE
                     ELSE
                        CALL UVLIMT (SQRT(BLMN2O), SQRT(BLMX2O), UUMAXO,
     *                     VVMAXO, IVIS, UIN*(1.+FFRAC), VIN*(1.+FFRAC),
     *                     ERRCNT)
                        END IF
C                                       end if in current rows
                     END IF
                  JNPTR = JNPTR + LREC
C                                       end for all vis loop
 260              CONTINUE
C                                       if some good points found
               IF (NPOINT.GT.0) THEN
C                                       Load into AP.
                  CALL QWR
C                                       Keep track of number of vis read
                  VREAD = VREAD + NPOINT
                  ITEMP = LREC * NPOINT
                  CALL QPUT (BUFF1(INPTR), IDATA, ITEMP, 2)
                  IDATA = IDATA + ITEMP
                  CALL QWAIT
                  END IF
C                                       Do zero spacing flux densities
               IF ((DOZERO) .AND. (.NOT.ONZE) .AND. (IUMIN.LE.0)) THEN
C                                       for cells around u=v=0
                  DO 267 I = -1,1
C                                       for V = -? to ? lambdas
                     VIN = I * GFACT
                     DO 265 J = 0,1
C                                       scale cell to UV lambdas
                        UIN = J * GFACT
C                                       calc zerospacing weight
                        CALL UVZRWT (UIN, VIN, BEAM, ZEROSP, TFLUXG,
     *                     FLUXZ, WEIGHT)
C                                       If significant Weight
                        IF (WEIGHT.GT.1.0E-6) THEN
C                                       put zerospacing in UV data
                           CALL UVSETZ (UIN, VIN, WTOFF, VSOFF, LVIS,
     *                        FLUXZ, WEIGHT, NCHGRD, BUFF1)
                           CALL QWR
C                                       put in zerosp in ap
                           CALL QPUT (BUFF1(1), IDATA, LREC, 2)
C                                       count points
                           NPOINT = NPOINT + 1
                           IDATA = IDATA + LREC
                           CALL QWAIT
                           END IF
 265                    CONTINUE
 267                 CONTINUE
                  ONZE = T
C                                       end if do zero spacing flux
                  END IF
C                                       if some good points found
               IF (NPOINT.GT.0) THEN
C                                       Set GRID in AP MD(20)
                  APCONI(3) = LOGRID
C                                       Put row number in AP MD(8)
                  APCONS(9) = IUMIN
                  CALL QPUT (APCONS(9), 8, 1, 2)
                  CALL QPUT (APCONI, 17, 3, 1)
                  CALL QWAIT
                  ITEMP = - NPOINT
                  IF (DOSHFT) ITEMP = -ITEMP
                  CALL Q1GRD (UV ,VIS, WT, LLREC, LLVIS, NO2, M,
     *               LROW, ITEMP, MCHGRD)
                  CALL QWR
C                                       end if points found
                  END IF
C                                       All UV data finished, process.
  270          CONTINUE
C                                       Jump here on end of UV data
  275       CONTINUE
C                                       calc AP rows to sum/write
            USTRT = IUMIN + MO2
C                                       If last pass, sum negative rows
            IF (RPASS.EQ.NRPASS) USTRT = -MO2
            USTOP = IUMAX + MO2
C                                       If sum weights and last chan.
            IF (BEAM .AND. (CPASS.EQ.NCPASS)) THEN
               CALL APSUM (USTRT, USTOP, IUMIN-MO2, ROWSIZ, LOGRID,
     *            APSMWT, LROW, ONESUM)
C                                       double sum for conjugation
               SUMWT = SUMWT + (2 * ONESUM)
C                                       end if beam grid done
               END IF
C                                       if first pass stop at top rows
            IF (RPASS.EQ.1) USTOP = NXO2
C                                       if very last pass start at u=0
            IF (NRPASS.EQ.RPASS) USTRT = 0
C                                       if last channel pass
            IF (CPASS.GE.NCPASS) THEN
               CALL APFNSH (USTRT, USTOP, IUMIN-MO2, MAXU, MO2, ROWSIZ,
     *            LROW, LOGRID, APSIZE, WX)
               END IF
C                                       if time to write
            IF (CPASS.EQ.NCPASS .OR. (.NOT. ALLROW)) THEN
C                                       if final pass
               IF (CPASS.EQ.NCPASS) THEN
C                                       Write only from NXO2 to 0
                  FLIST(6,IFILE1) = NXO2+1
               ELSE
C                                       Else write from NXO2 to - MO2
                  FLIST(6,IFILE1) = NXO2+1+MO2
                  IF (NRPASS.EQ.RPASS) USTRT = -MO2
                  END IF
               FLIST(10,IFILE1) = FLIST(6,IFILE1)
C                                       write out finished rows
               CALL APWRIT (USTRT, USTOP, IUMIN-MO2, ROWSIZ, LOGRID,
     *            FLIST(1,IFILE1), APSIZE, BUFF2, IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
C                                       tell progress
            IF ((BEAM) .AND. (LFIELD.EQ.1)) THEN
               WRITE (MSGTXT,1300) CPASS, RPASS, IUMAX, IUMIN, VREAD
               CALL MSGWRT (4)
               END IF
C                                       End Rows Loop
 500        CONTINUE
C                                       if all rows not in AP
      IF ((CPASS.LT.NCPASS) .AND. (.NOT.ALLROW)) THEN
         CALL QWAIT
C                                       at end, Flush buffer with 'INIT'
         CALL APIO ('INIT', FLIST(1, IFILE1), LOGRID, BUFF2, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1210) IRET, U
            GO TO 995
            END IF
         END IF
C                                       End Band. Synth. (BS) loop
 600     CONTINUE
      CALL QWAIT
C                                       Give up AP
      CALL QRLSE
C                                       Close files
      CALL ZCLOSE (LUNUV, INDS2, IRET)
      CALL APIO ('CLOS', FLIST(1,IFILE1), LOGRID, BUFF2, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1340) IFILE1, IRET
         GO TO 995
         END IF
      CALL APIO ('CLOS', FLIST(1,IFILE2), LOGRID, BUFF3, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1330) IFILE2, IRET
         GO TO 995
         END IF
C                                       Set sum of weights
      IF (BEAM) THEN
         BEMMAX(LFIELD) = SUMWT
         WRITE (MSGTXT,1350) LFIELD, BEMMAX(LFIELD)
         CALL MSGWRT (4)
         END IF
C                                       Must switch SCRWRK and SCROUT
      IF (IFILE1.NE.1) THEN
         INDEX = SCRWRK
         SCRWRK = SCROUT
         SCROUT = INDEX
         END IF
      GO TO 999
C                                       Error
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('UVGRID: ',I4,' Channel Pass(es);',I4,' Row Pass(es)')
 1020 FORMAT ('UVGRID: All  ',I5,' Rows in',I6,'k AP (',I5,' Rows Max)')
 1030 FORMAT ('UVGRID: Only ',I5,' Rows in',I6,'k AP')
 1035 FORMAT ('UVGRID: Max U Baseline ',F12.0,' lambda (=',I5,' cells)')
 1036 FORMAT ('UVGRID: Ave',I5,' Channels; ',1PE12.6,' to ',E12.6,' Hz')
 1037 FORMAT ('UVGRID: Frequency ',1PE12.6,' Hz')
 1060 FORMAT ('UVGRID: ERROR',I3,' INITILIZING FILE')
 1100 FORMAT ('UVGRID: READ ERROR IN VISIBILITY FILE, IER=',I3)
 1210 FORMAT ('UVGRID: ERROR',I3,' WRITING GRID ROW ',I5)
 1220 FORMAT ('UVGRID: MIN,MAX R=',2F12.0,', MAX U,V=',2F12.0)
 1300 FORMAT ('UVGRID: End Pass ',I3,',',I3,': Rows',I5,'-',I4,
     *        ', with',I8,' Pts')
 1330 FORMAT ('UVGRID: TROUBLE CLOSING OUTPUT FILE',I3,', IER=',I3)
 1340 FORMAT ('UVGRID: TROUBLE CLOSING INPUT  FILE',I3,', IER=',I3)
 1350 FORMAT ('Field',I5,' Sum of gridding weights = ',1PE12.5)
      END

LOCAL INCLUDE 'MEDI.INC'
      INTEGER   CATI1(256), CATI2(256), CATI3(256), CATI4(256),
     *   CATB(256,4), CATIO(256,2)
      REAL      CATR1(256), CATR2(256), CATR3(256), CATR4(256)
      HOLLERITH CATH1(256), CATH2(256), CATH3(256), CATH4(256)
      DOUBLE PRECISION CATD1(128),  CATD2(128), CATD3(128), CATD4(128)
      REAL      IROW(8192,4), FREQ1, FREQ2, LNFREQ, FMIN,
     *   FMAX, CPARM(20), XN(2), XX(2)
      CHARACTER NAMIN(4)*12, CLSIN(4)*6, NAMOUT(2)*12, CLSOUT(2)*6,
     *   ALGO*4
      LOGICAL   XBLFLG, BFLAG, DOFILE(6), PLAIN
      INTEGER   IBLC(7,4), ITRC(7,4), NPI(7,4), NPO(7), FBL(2), ILUN(4),
     *   IIND(4), OLUN(2), OIND(2), ISSEQ(4), IDSEQ(2), NAX, NRDIM(4),
     *   CTYPE, IUSER, IPOINT, FCVOL(6), FCCNO(6)
      COMMON /MEDICM/ CATB, CATIO, IROW, FREQ1, FREQ2, LNFREQ,
     *   FMIN, FMAX, CPARM, XN, XX, XBLFLG, BFLAG, FBL, IBLC, ITRC,
     *   NPI, NPO, ILUN, IIND, OLUN, OIND, ISSEQ, IDSEQ, NAX, NRDIM,
     *   CTYPE, IUSER, IPOINT, DOFILE, PLAIN, FCVOL, FCCNO
      COMMON /MEDICH/ NAMIN, CLSIN, NAMOUT, CLSOUT, ALGO
      EQUIVALENCE (CATI1, CATR1, CATD1, CATH1, CATB(1,1))
      EQUIVALENCE (CATI2, CATR2, CATD2, CATH2, CATB(1,2))
      EQUIVALENCE (CATI3, CATR3, CATD3, CATH3, CATB(1,3))
      EQUIVALENCE (CATI4, CATR4, CATD4, CATH4, CATB(1,4))
      INCLUDEW 'INCS:DCAT.INC'
      INTEGER IMEDIA, IGNORE, NOISEV, CLIPMN, CLIPMX, ISNR, NOISEO
      PARAMETER (IMEDIA=1, IGNORE=-999, NOISEV=11, CLIPMN=9, CLIPMX=10)
      PARAMETER (ISNR=15, NOISEO=13)
LOCAL END
      PROGRAM MEDI
C-----------------------------------------------------------------------
C! Combine four input maps by median filtering to make output map.
C# Map-util SPECTRAL POLARIZATION ANALYSIS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1999, 2009-2010, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  MEDI is a task in which four input images are combined on
C  a pixel by pixel level to produce an output image and an optional
C  deviation image.   The MEDIan, like the AVERAGE, is used to estimate
C  the most likely (true) value of an observable.  The average is a
C  more efficient estimator of a value when the noise of the measurement
C  is gaussian distributed with zero mean.   However in the presence of
C  outliers, the MEDIAN is a more efficient estimator.
C
C  MEDIAN Details:  In the case of one or two un-blanked pixel values,
C  the MEDIAN is the average of the un-blanked values.  The deviation
C  image pixel is blanked.  In the case of 3 un-blanked pixel values,
C  The middle of the three values is the median, and the deviation
C  image contains the average of the high and low pixels, minus the
C  middle pixel.   In the case of 4 un-blanked input values, the median
C  is the average of the middle two values and the deviation image is
C  the average of the high and low values, minus the average of the
C  middle two values.
C
C   Inputs: (from AIPS)
C   USERID......The ID of the owner of the images. 0 => current
C               user, 32000 => any user.
C   INNAME......First image name.     Standard defaults.
C   INCLASS.....First image class.    Standard defaults.
C   INSEQ.......First image seq. #.   0 => highest.
C   INDISK......Disk drive # for the first image.  0 => any.
C   IN2NAME.....Second image name.    Standard defaults.
C   IN2CLASS....Second image class.   Standard defaults.
C   IN2SEQ......Second image seq. #.  0 => highest.
C   IN2DISK.....Disk drive # for the second image.  0 => any.
C   IN3NAME.....First noise image name.     Standard defaults.
C   IN3CLASS....First noise image class.    Standard defaults.
C   IN3SEQ......First noise image seq. #.   0 => highest.
C   IN3DISK.....Disk # for first noise image.  0 => any.
C   IN4NAME.....Second noise image name.    Standard defaults.
C   IN4CLASS....Second noise image class.   Standard defaults.
C   IN4SEQ......Second noise image seq. #.  0 => highest.
C   IN4DISK.....Disk # for second noise image.  0 => any.
C   DOALIGN.....Controls how the four images are to be aligned (see HELP
C               DOALIGN).  True (>.1) means that the images must agree
C               in their coordinates, though not necessarily in the
C               reference pixel position.  Alignment is by coordinate
C               values (if DOALIGN > -0.1) or by offsets from the
C               reference pixel positions (if DOALIGN <= -0.1).  NOTE:
C               all real axes (>1 point) are aligned.  If DOALIGN = -2,
C               the headers are ignored and the images are aligned at
C               pixel (1,1,...).
C   OUTNAME.....Output image name.    Standard defaults.
C   OUTCLASS....Output image class.   Standard behavior with default =
C               either the output STOKES in string form or the OPCODE if
C               the output STOKES is the same as the first input image.
C               The noise image has the 6th character of class set to N.
C   OUTSEQ......Output image seq. #.  0 => highest unique.
C   OUTDISK.....Output disk number. 0 => highest with space.
C   BLC.........Bottom left corner of the 1st input image. The other
C               images are aligned by coordinates (see DOALIGN) on all
C               axes having > 1 point.  The other images may have fewer
C               real axes than the 1st.  The 4 windows must have the
C               same dimension on the first 2 axes, but the task will
C               select a smaller window than was specified if needed to
C               overlap the 4 images.
C   TRC.........Top right corner of input images. (See BLC.)
C   APARM.......Parameters needed for algorithm:
C      APARM(1), APARM(2), APARM(3), APARM(4) used to scale images
C           APARM(1) = 0 => APARM(1) = 1.0
C           APARM(2) = 0 => APARM(2) = 1.0
C           APARM(3) = 0 => APARM(3) = 1.0
C           APARM(4) = 0 => APARM(4) = 1.0
C      APARM(8) >  0  => Use 0.0 for clipped & illegal values
C               <= 0  => Use blanking for clipped & illegal values
C      APARM(9)  = Clip if MAP(I) < APARM(9),  image units.
C      APARM(10) = Clip if MAP(I) > APARM(10), image units.
C           0 means no clippng.
C   BPARM.......Parameters needed noise calculation and control:
C      BPARM(1) = 1-sigma level on input maps.
C                 0 => ignore noise
C      BPARM(2) NOT USED
C      BPARM(3) = false (<= 0) => output normal image
C               = true  (>  0) => output normal and sigma image
C                 Blanking is the same for both settings of B(3).
C      BPARM(4) <= 0.5  => Blank output map using input map values
C               else    => Blank output map using output map sigma
C               >= 1.5  => Blank output map using output noise image
C      BPARM(5) = Error on output map value above which output
C                 pixel is blanked (if BPARM(4) = 1) 0 -> FMIN
C               = S/N ratio of output map value below which output
C                 pixel is blanked (if BPARM(4) = 2) 0 -> 0.05
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   IRET, IERR, IWIN(4), ISWIN(4), NBY, NX, NY, IDEPTH(5),
     *   IBLKOF, NBYBUF, ISPOS(4), IDPOS(2), I3, I4, I5, I6, I7, I, IY
      REAL      XBUFF(8192,2)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'MEDI.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGNAM /'MEDI  '/
      DATA ISWIN /0,0,0,0/
C-----------------------------------------------------------------------
C                                        Initialize input maps
      IRET = 16
      CALL MEDIIN (PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL PMEDIN (CPARM, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL FILL (4, 1, ISPOS)
      CALL FILL (2, 1, IDPOS)
C                                        Do-loop limits: window
      NBY = 2
      NBYBUF = 8192 * NBY
      NX = NPO(1)
      NY = NPO(2)
      DO 70 I7 = 1,NPO(7)
      DO 69 I6 = 1,NPO(6)
      DO 68 I5 = 1,NPO(5)
      DO 67 I4 = 1,NPO(4)
      DO 66 I3 = 1,NPO(3)
C                                        Initialize input maps
         DO 10 I = 1,4
            IF (DOFILE(I)) THEN
               CALL FILL (5, 1, IDEPTH(1))
               IF (NRDIM(I).GE.3) IDEPTH(1) = I3 - 1 + IBLC(3,I)
               IF (NRDIM(I).GE.4) IDEPTH(2) = I4 - 1 + IBLC(4,I)
               IF (NRDIM(I).GE.5) IDEPTH(3) = I5 - 1 + IBLC(5,I)
               IF (NRDIM(I).GE.6) IDEPTH(4) = I6 - 1 + IBLC(6,I)
               IF (NRDIM(I).GE.7) IDEPTH(5) = I7 - 1 + IBLC(7,I)
               CALL COMOFF (NAX, NPI(1,I), IDEPTH, IBLKOF, IERR)
               IF (IERR.NE.0) GO TO 995
               IBLKOF = IBLKOF + 1
               IWIN(1) = IBLC(1,I)
               IWIN(2) = IBLC(2,I)
               IWIN(3) = ITRC(1,I)
               IWIN(4) = ITRC(2,I)
               CALL MINIT ('READ', ILUN(I), IIND(I), NPI(1,I), NPI(2,I),
     *            IWIN, IROW(1,I), NBYBUF, IBLKOF, IERR)
C                                        If error reading file, ignore
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1010) I, IERR
                  DOFILE(I) = .FALSE.
                  END IF
               END IF
 10         CONTINUE
C                                        Initialize output file
         IDEPTH(1) = I3
         IDEPTH(2) = I4
         IDEPTH(3) = I5
         IDEPTH(4) = I6
         IDEPTH(5) = I7
         CALL COMOFF (NAX, NPO, IDEPTH, IBLKOF, IERR)
         IF (IERR.NE.0) GO TO 995
         IBLKOF = IBLKOF + 1
         ISWIN(1) = 1
         ISWIN(2) = 1
         ISWIN(3) = NPO(1)
         ISWIN(4) = NPO(2)
         DO 20 I = 1,2
            IF (DOFILE(I+4)) THEN
               CALL MINIT ('WRIT', OLUN(I), OIND(I), NX, NY, ISWIN,
     *            XBUFF(1,I), NBYBUF, IBLKOF, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1020) I, IERR
                  GO TO 980
                  END IF
               END IF
 20         CONTINUE
C                                        Loop over rows
         CALL FILL (4, 1, ISPOS)
C                                        IF no file, blank row
         IF (.NOT.DOFILE(3)) CALL RFILL (NX, FBLANK, IROW(1,3))
         IF (.NOT.DOFILE(4)) CALL RFILL (NX, FBLANK, IROW(1,4))
         DO 50 IY = 1,NY
            DO 30 I = 1,4
               IF (DOFILE(I)) THEN
                  CALL MDISK ('READ', ILUN(I), IIND(I), IROW(1,I),
     *               ISPOS(I), IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1030) IY, I, IERR
                     GO TO 980
                     END IF
                  END IF
 30            CONTINUE
            DO 40 I = 1,2
               IF (DOFILE(I+4)) THEN
                  CALL MDISK ('WRIT', OLUN(I), OIND(I), XBUFF(1,I),
     *               IDPOS(I), IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1040) IY, I, IERR
                     GO TO 980
                     END IF
                  END IF
 40            CONTINUE
            CALL XMEDIN (NX, IROW(ISPOS(1),1), IROW(ISPOS(2),2),
     *         IROW(ISPOS(3),3), IROW(ISPOS(4),4), CPARM,
     *         XBUFF(IDPOS(1),1), XBUFF(IDPOS(2),2))
 50         CONTINUE
C                                        Write the last buffer
         DO 60 I = 1,2
            IF (DOFILE(I+4)) THEN
               CALL MDISK ('FINI', OLUN(I), OIND(I), XBUFF(1,I),
     *            IDPOS(I), IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1060) I, IERR
                  GO TO 980
                  END IF
               END IF
 60         CONTINUE
 66      CONTINUE
 67      CONTINUE
 68      CONTINUE
 69      CONTINUE
 70      CONTINUE
C                                        Create and write HI file
      CALL MEDIHI (IRET)
      GO TO 995
C                                        Error return
 980  CALL MSGWRT (7)
C
 995  CALL DIE (IRET, IROW)
C
 999  STOP
C-----------------------------------------------------------------------
 1010 FORMAT ('COULD NOT INITIALIZE INPUT FILE #',I2,'  IER=',I7)
 1020 FORMAT ('COULD NOT INITIALIZE OUTPUT FILE 3',I2,'  IER=',I7)
 1030 FORMAT ('COULD NOT READ LINE',I4,'  MAP #',I2,'  IER=',I7)
 1040 FORMAT ('COULD NOT WRITE LINE',I4,'  MAP #',I2,'  IER=',I7)
 1060 FORMAT ('COULD NOT WRITE LAST LINE, MAP #',I2,'.  IER=',I7)
      END
      SUBROUTINE MEDIIN (PRGNAM, IER)
C-----------------------------------------------------------------------
C   MEDIIN gets the inputs for MEDI, opens and checks the input images,
C   creates the output image(s), and prepares parameters in common for
C   the later stages of MEDI.
C   Inputs:
C      PRGNAM   C*6   Program name
C   Outputs:
C      IER      I     Error return: 0-->  Okay
C                        3-->  Cannot create and open output file
C                        2-->  Cannot open either input map
C                        1-->  Error in getting input parameters
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   IER
C
      CHARACTER IDCDEF*6, PHNAME*48, MTYPE*2, STOKES*8, COPCOD(1)*4,
     *   CHTMP*8, CHTMP1*8
      INTEGER   I, IERR, IRETCD, INPRMS, NB, INC, J, I1, IROUND, K
      LOGICAL   REDUCE, T
      REAL      STOKI(2), STOKO, EPS, X, AXV
      REAL      XSEQ1, XDSK1, XSEQ2, XDSK2, XSEQ3, XDSK3, XSEQ4, XDSK4,
     *   SEQOUT, DSKOUT, C(20), BLC(7), TRC(7), GRIDCR
      HOLLERITH XNAM1(3), XCLS1(2), XNAM2(3), XCLS2(2), XNAM3(3),
     *   XCLS3(2), XNAM4(3), XCLS4(2), XNAMOU(3), XCLSOU(2)
      DOUBLE PRECISION    DAXV
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'MEDI.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMMON /INPARM/ XNAM1, XCLS1, XSEQ1, XDSK1, XNAM2, XCLS2, XSEQ2,
     *   XDSK2, XNAM3, XCLS3, XSEQ3, XDSK3, XNAM4, XCLS4, XSEQ4, XDSK4,
     *   GRIDCR, XNAMOU, XCLSOU, SEQOUT, DSKOUT, BLC, TRC, C
      DATA EPS /0.2/
      DATA T /.TRUE./
      DATA STOKES /'STOKES  '/
      DATA COPCOD /'MEDI'/
C-----------------------------------------------------------------------
C                                        Initialize file and header I/O
      ILUN(1) = 17
      ILUN(2) = 18
      ILUN(3) = 19
      ILUN(4) = 20
      OLUN(1) = 21
      OLUN(2) = 22
C
      CALL ZDCHIN (T, IROW)
      CALL VHDRIN
      NSCR = 0
      NCFILE = 0
      IER = 0
C                                        Get inputs from AIPS
      INPRMS = 70
      CALL GTPARM (PRGNAM, INPRMS, RQUICK, XNAM1, IROW, IERR)
      IRETCD = IERR
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (7)
         END IF
      IF (RQUICK) CALL RELPOP (IRETCD, IROW, IERR)
      IF (IRETCD.NE.0) GO TO 980
C                                       Change input OPCODE - char
      CTYPE = 1
      ALGO(1:1) = 'M'
      ALGO(2:2) = 'E'
      ALGO(3:3) = 'D'
      ALGO(4:4) = 'I'
      CALL RCOPY (20, C, CPARM)
      PLAIN = .FALSE.
C                                        Open 4 input files
      DOFILE(1) = CPARM(1).NE.IGNORE
      DOFILE(2) = CPARM(2).NE.IGNORE
      DOFILE(3) = CPARM(3).NE.IGNORE
      DOFILE(4) = CPARM(4).NE.IGNORE
C                                        Open output file
      DOFILE(5) = .TRUE.
C                                        Should Noise image be saved?
      DOFILE(6) = CPARM(NOISEO).GT.0.0
C                                        Transfer inputs into integer
C                                        variables
      FCVOL(1) = IROUND (XDSK1)
      FCVOL(2) = IROUND (XDSK2)
      FCVOL(3) = IROUND (XDSK3)
      FCVOL(4) = IROUND (XDSK4)
      ISSEQ(1) = IROUND (XSEQ1)
      ISSEQ(2) = IROUND (XSEQ2)
      ISSEQ(3) = IROUND (XSEQ3)
      ISSEQ(4) = IROUND (XSEQ4)
      FCVOL(5) = IROUND (DSKOUT)
      FCVOL(6) = IROUND (DSKOUT)
      IDSEQ(1) = IROUND (SEQOUT)
      IDSEQ(2) = IROUND (SEQOUT)
      IUSER = NLUSER
C                                       Hollerith -> Char.
      CALL H2CHR (12, 1, XNAM1, NAMIN(1))
      CALL H2CHR (6, 1, XCLS1, CLSIN(1))
      CALL H2CHR (12, 1, XNAM2, NAMIN(2))
      CALL H2CHR (6, 1, XCLS2, CLSIN(2))
      CALL H2CHR (12, 1, XNAM3, NAMIN(3))
      CALL H2CHR (6, 1, XCLS3, CLSIN(3))
      CALL H2CHR (12, 1, XNAM4, NAMIN(4))
      CALL H2CHR (6, 1, XCLS4, CLSIN(4))
      CALL H2CHR (12, 1, XNAMOU, NAMOUT(1))
      CALL H2CHR (6, 1, XCLSOU, CLSOUT(1))
      CALL H2CHR (12, 1, XNAMOU, NAMOUT(2))
      CALL H2CHR (6, 1, XCLSOU, CLSOUT(2))
C                                        Open both input maps
      MTYPE = 'MA'
      DO 35 I = 1,4
         IF (DOFILE(I)) THEN
            CALL MAPOPN ('READ', FCVOL(I), NAMIN(I), CLSIN(I), ISSEQ(I),
     *         MTYPE, IUSER, ILUN(I), IIND(I), FCCNO(I), CATBLK,
     *         IROW(1,I), IERR)
            CALL COPY (256, CATBLK, CATB(1,I))
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1025) I,IERR
               CALL MSGWRT (7)
               GO TO 960
               END IF
            NCFILE = NCFILE + 1
            FRW(NCFILE) = 0
            FVOL(NCFILE) = FCVOL(I)
            FCNO(NCFILE) = FCCNO(I)
            NB = CATBLK(KIDIM)
            CALL FILL (KICTPN, 1, NPI(1,I))
            CALL COPY (NB, CATBLK(KINAX), NPI(1,I))
            NRDIM(I) = NB
            DO 30 J = 1,NB
               NPI(J,I) = MAX (1, NPI(J,I))
               IF (NPI(J,I).LE.1) NRDIM(I) = NRDIM(I) - 1
 30            CONTINUE
            END IF
 35      CONTINUE
C                                        Set up some needed header vals
      REDUCE = .FALSE.
      NAX = CATI1(KIDIM)
      CALL WINDOW (NAX, NPI(1,1), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 960
      DO 40 I = 1,7
         IBLC(I,1) = BLC(I) + EPS
         ITRC(I,1) = TRC(I) + EPS
         NPO(I) = ITRC(I,1) - IBLC(I,1) + 1
 40      CONTINUE
C                                       Are input maps coincident?
C                                       Set 2nd map corners
      INC = 2
      DO 70 K = 2,4
         IF (DOFILE(K)) THEN
            CALL COPY (256, CATB(1,K), CATBLK)
            DO 65 I = 1,7
               J = I - 1
C                                       null axis
               IBLC(I,K) = 1
               ITRC(I,K) = 1
               IF (NPI(I,K).GT.1) THEN
                  AXV = CATR(KRCRP+J) - CATR1(KRCRP+J) + IBLC(I,1)
                  IF (GRIDCR.LT.-1.5) AXV = IBLC(I,1)
                  IF (GRIDCR.GT.-0.1) THEN
                     DAXV = CATD1(KDCRV+J) + (IBLC(I,1) -
     *                  CATR1(KRCRP+J)) * CATR1(KRCIC+J)
                     IF (CATR(KRCIC+J).EQ.0.0) GO TO 75
                     AXV = (DAXV - CATD(KDCRV+J)) / CATR(KRCIC+J) +
     *                  CATR(KRCRP+J)
                     END IF
                  IBLC(I,K) = IROUND (AXV)
                  IF ((GRIDCR.GE.0.1) .AND. (ABS(AXV-IBLC(I,K)).GT.EPS))
     *               GO TO 75
                  ITRC(I,K) = IBLC(I,K) + ITRC(I,1) - IBLC(I,1)
C                                       smaller subimage required?
                  IF (IBLC(I,K).LT.1) THEN
                     IBLC(I,1) = IBLC(I,1) + 1 - IBLC(I,K)
                     BLC(I) = IBLC(I,1)
                     IF (K.GT.2) IBLC(I,2) = IBLC(I,2) + 1 - IBLC(I,K)
                     IF (K.GT.3) IBLC(I,3) = IBLC(I,3) + 1 - IBLC(I,K)
                     REDUCE = .TRUE.
                     IBLC(I,K) = 1
                     END IF
                  IF (ITRC(I,K).GT.NPI(I,K)) THEN
                     ITRC(I,1) = ITRC(I,1) + NPI(I,K) - ITRC(I,K)
                     TRC(I) = ITRC(I,1)
                     IF (K.GT.2) ITRC(I,2) = ITRC(I,2) + NPI(I,K) -
     *                  ITRC(I,K)
                     IF (K.GT.3) ITRC(I,3) = ITRC(I,3) + NPI(I,K) -
     *                  ITRC(I,K)
                     REDUCE = .TRUE.
                     ITRC(I,K) = NPI(I,K)
                     END IF
                  IF (IBLC(I,1).GT.ITRC(I,1)) GO TO 75
                  NPO(I) = ITRC(I,1) - IBLC(I,1) + 1
C                                        Check coincidence
                  IF (GRIDCR.GE.0.1) THEN
                     IPOINT = KHCTP+J*INC
                     CALL H2CHR (8, 1, CATH(IPOINT), CHTMP)
                     CALL H2CHR (8, 1, CATH1(IPOINT), CHTMP1)
                     IF (CHTMP.NE.CHTMP1) GO TO 75
                     X = EPS * EPS * ABS(CATR1(KRCIC+J))
                     IF (ABS(CATR(KRCIC+J)-CATR1(KRCIC+J)).GT.X)
     *                  GO TO 75
                     IF (ABS(CATR(KRCRT+J)-CATR1(KRCRT+J)).GT.1.)
     *               GO TO 75
                     END IF
                  END IF
 65            CONTINUE
            END IF
 70      CONTINUE
      GO TO 80
C                                        Maps not coincident
 75   WRITE (MSGTXT,1075) I
      CALL MSGWRT (7)
      GO TO 960
C                                       Create output map
C                                       Get stokes value of input maps
C                                       Insert proper Stokes value
 80   MSGTXT = 'MEDIIN: input maps coincident on reduced subimage only'
      IF (REDUCE) CALL MSGWRT (6)
      XX(1) = -1.0E30
      XX(2) = -1.0E30
      XN(1) = 1.0E30
      XN(2) = 1.0E30
      BFLAG = .FALSE.
      CALL COPY (256, CATI1, CATBLK)
      INC = 2
      STOKO = -1
      DO 85 I = 1,NAX
         IPOINT = KHCTP+(I-1)*INC
         CALL H2CHR (8, 1, CATH(IPOINT), CHTMP)
         IF (CHTMP.EQ.STOKES) GO TO 95
 85      CONTINUE
C                                        No Stokes axis
      STOKI(1) = -10
      GO TO 110
 95   I1 = KDCRV + I - 1
      STOKI(1) = CATD(I1) + CATR(KRCIC+I-1) * (IBLC(I,1) -
     *   CATR(KRCRP+I-1))
      STOKI(2) = CATD2(I1) + CATR2(KRCIC+I-1) * (IBLC(I,2) -
     *   CATR2(KRCRP+I-1))
C                                        Various cases
      IF (STOKI(1).EQ.STOKI(2)) STOKO = STOKI(1)
      IF (NPO(I).LE.1) CATD1(I1) = STOKO
      IF ((CTYPE.NE.5) .OR. ((STOKI(1).EQ.2) .AND. (STOKI(2).EQ.3)))
     *   GO TO 110
         WRITE (MSGTXT,1100)
         CALL MSGWRT (6)
C                                        Default out class
 110  IDCDEF = ' '
      J = STOKO
      IF (STOKO.EQ.STOKI(1)) J = 1
      IF (J.LE.4) IDCDEF(:4) = COPCOD(CTYPE)
C                                        Set header values for output
C                                        map
      CALL MAKOUT (NAMIN(1), CLSIN(1), ISSEQ(1), IDCDEF, NAMOUT(1),
     *   CLSOUT(1), IDSEQ(1))
      CALL CHR2H (12, NAMOUT(1), KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLSOUT(1), KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = IDSEQ(1)
      CATBLK(KIIMU) = NLUSER
      CALL SUBHDR (BLC, TRC, 1.0, 1.0)
C                                        Put in map units
      CALL MCREAT (FCVOL(5), FCCNO(5), IROW, IERR)
      IDSEQ(1) = CATI1(KIIMS)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) IERR
         CALL MSGWRT (8)
         GO TO 950
         END IF
      NCFILE = NCFILE + 1
      FRW(NCFILE) = 2
      FVOL(NCFILE) = FCVOL(5)
      FCNO(NCFILE) = FCCNO(5)
C                                       Copy header keywords from first
C                                       input.
      CALL KEYCOP (FCVOL(1), FCCNO(1), FCVOL(5), FCCNO(5), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1135) IERR
         CALL MSGWRT (7)
C                                       Let it slide.
         IERR = 0
         END IF
C                                        Open the output file
      CALL ZPHFIL ('MA', FCVOL(5), FCCNO(5), 1, PHNAME, IERR)
      CALL ZOPEN (OLUN(1), OIND(1), FCVOL(5), PHNAME, T, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1136) IERR
         CALL MSGWRT (7)
         GO TO 950
         END IF
      CALL COPY (256, CATBLK, CATIO(1,1))
C                                       Create noise image
      IF (DOFILE(6)) THEN
         NAMOUT(2) = NAMOUT(1)
         CALL CHR2H (12, NAMOUT(2), KHIMNO, CATH(KHIMN))
         CLSOUT(2) = CLSOUT(1)
         CLSOUT(2)(1:1) = 'D'
         CLSOUT(2)(2:2) = 'E'
         CLSOUT(2)(3:3) = 'V'
         CLSOUT(2)(4:4) = 'I'
         CALL CHR2H (6, CLSOUT(2), KHIMCO, CATH(KHIMC))
         CATBLK(KIIMS) = IDSEQ(2)
         CATBLK(KIIMU) = NLUSER
         CALL MCREAT (FCVOL(6), FCCNO(6), IROW, IERR)
         IDSEQ(2) = CATI1(KIIMS)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1110) IERR
            CALL MSGWRT (8)
            GO TO 950
            END IF
         NCFILE = NCFILE + 1
         FRW(NCFILE) = 2
         FVOL(NCFILE) = FCVOL(6)
         FCNO(NCFILE) = FCCNO(6)
C                                       Copy header keywords from first
C                                       input.
         CALL KEYCOP (FCVOL(1), FCCNO(1), FCVOL(6), FCCNO(6), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1135) IERR
            CALL MSGWRT (7)
C                                       Let it slide.
            IERR = 0
            END IF
C                                        Open the output file
         CALL ZPHFIL ('MA', FCVOL(6), FCCNO(6), 1, PHNAME, IERR)
         CALL ZOPEN (OLUN(2), OIND(2), FCVOL(6), PHNAME, T, T, T, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1136) IERR
            CALL MSGWRT (7)
            GO TO 950
            END IF
         CALL COPY (256, CATBLK, CATIO(1,2))
         END IF
      GO TO 999
C-----------------------------------------------------------------------
C                                        Error returns
C                                        Failed to create output file
 950  IER = IER + 1
C                                        Error in MAPOPN
 960  IER = IER + 1
C                                        Error in getting parameters
 980  IER = IER + 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('MEDIIN: COULD NOT GET PARMS.  IER=',I7)
 1025 FORMAT ('MEDIIN: COULD NOT OPEN MAP # ',I1,'  IER=',I7)
 1075 FORMAT ('MEDIIN: INPUT MAPS ARE NOT COINCIDENT ON AXIS',I2)
 1100 FORMAT ('WARNING: angle map output not Polarization Angle')
 1110 FORMAT ('MEDIIN: COULD NOT CREATE OUTPUT MAP.  IER=',I7)
 1135 FORMAT ('MEDIIN: ERROR ', I3,' COPYING KEYWORDS - CONTINUING')
 1136 FORMAT ('MEDIIN: COULD NOT OPEN OUTPUT MAP.  IER=',I7)
      END
      SUBROUTINE PMEDIN (C, IER)
C-----------------------------------------------------------------------
C   PMEDIN writes output describing the algorithm, prepares default
C   values and obtains necessary parameters for MEDIN.
C   Inputs:
C      C(20)     R     The algorithm parameters
C   Outputs:
C      IER       I     Error code: 0 --> okay
C                                  1 --> not okay
C      FREQ1     R     Frequency of first map
C      FREQ2     R     Frequency of second map
C      LNFREQ    R     Log(FREQ1/FREQ2)
C      FBLANK    R     Blanking value used in scratch file
C      FMIN      R     Minimum Value to be used in all maps
C      FMAX      R     Maximum Value to be used in all maps
C-----------------------------------------------------------------------
      INTEGER   IER, I
      REAL      C(20)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'MEDI.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      FMIN = MAX (ABS(CATR1(KRDMX)), ABS(CATR1(KRDMN)))
      FMAX = MAX (ABS(CATR2(KRDMX)), ABS(CATR2(KRDMN)))
C                                       Initialize
      IER = 0
      XBLFLG = C(8).LE.0.0
C                                       Median Value 'MEDI'
C                                       For up to 4 input images
      DO 299 I = 1,4
C                                       If scaling constants zero => 1.
         IF (C(I).EQ.0.0) C(I) = 1.0
C                                       If not ignoring input
         IF (C(I).NE.IGNORE) THEN
            WRITE (MSGTXT,1280) C(I), I
            CALL MSGWRT (2)
            END IF
 299     CONTINUE

C                                       Any blanking
      FMIN = C(CLIPMN)
      FMAX = C(CLIPMX)
      IF (XBLFLG) THEN
         MSGTXT = 'Magic blanking used for clipped & illegal values'
      ELSE
         MSGTXT = 'Zero replaces clipped & illegal values'
         END IF
      CALL MSGWRT (2)
C                                       Blanking is on input map values
      IF (C(14).LE.0.5) THEN
         IF ((C(CLIPMN).NE.0.0) .OR. (C(CLIPMX).NE.0.0)) THEN
            WRITE (MSGTXT,1902) C(CLIPMN), C(CLIPMX)
            CALL MSGWRT (2)
            END IF
C                                       Blanking is on output S/N
      ELSE IF (C(14).GE.1.5) THEN
         WRITE (MSGTXT,1905) C(ISNR)
         IF (C(ISNR).GT.0.0) CALL MSGWRT (2)
C                                       Blanking is on output sigma
      ELSE
         WRITE (MSGTXT,1910) C(ISNR)
         IF (C(ISNR).GT.0.0) CALL MSGWRT (2)
         END IF
C                                       Map noise numbers
      IF (C(NOISEV).GT.0.0) THEN
         WRITE (MSGTXT,1920) C(NOISEV)
         CALL MSGWRT (2)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1280 FORMAT ('Median:',1PE11.3,'*Map(',I1,')')
 1902 FORMAT ('Clipping based on',1PE11.3,' in Map(1) or ',1PE11.3,
     *   ' in Map(2)')
 1905 FORMAT ('Blanking done if output S/N is less than',F8.4)
 1910 FORMAT ('Blanking done if output sigma exceeds',F8.4)
 1920 FORMAT ('Using input MAPs noise level',1PE11.3)
      END
      SUBROUTINE XMEDIN (NX, V1, V2, S1, S2, C, R1, R2)
C-----------------------------------------------------------------------
C   XMEDIN combines two pixel rows V1 and V2 with noise rows S1 and S2
C   to form result row R1 and noise row R2.  The algorithm is always
C   median filtering of the 4 values.
C   Inputs:
C      NX     I       Number of pixels in each vector.
C      V1     R(NX)   The pixel values of the input map 1
C      V2     R(NX)   The pixel values of the input map 2
C      S1     R(NX)   The noise values of the input map 1
C      S2     R(NX)   The noise values of the input map 2
C      C      R(20)   Up to 20 inputs parameters
C   Outputs:
C      R1     R(NX)   The result of the combination
C      R2     R(NX)   The noise of the combination
C-----------------------------------------------------------------------
      INTEGER   NX
      REAL      V1(*), V2(*), S1(*), S2(*), R1(*), R2(*), C(20)
C
      INTEGER   I, NVALUE
      REAL      SN, BRES, VALUES(10)
      LOGICAL   CLPSIG, CLPSN
      INCLUDE 'MEDI.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Clip on Signal Image/Noise value
      CLPSN  = (C(14).GE.1.5) .AND. (C(ISNR).GT.0.0)
C                                       Clip on Noise Image /Noise value
      CLPSIG = (C(14).LT.1.5) .AND. (C(14).GT.0.5) .AND.(C(ISNR).GT.0.0)
C                                       Value for blanked on output
      BRES = FBLANK
      IF (.NOT.XBLFLG) BRES = 0.0
C                                       'MEDI'
      DO 100 I = 1,NX
C                                       Prepare to count values
         NVALUE = 1
         VALUES(NVALUE) = C(1)*V1(I)
C                                       if not blanked value
         IF ((V1(I).NE.FBLANK) .AND. (C(1) .NE. IGNORE) .AND.
     *       (FMIN.EQ.0. .OR. VALUES(NVALUE).GE.FMIN) .AND.
     *       (FMAX.EQ.0. .OR. VALUES(NVALUE).LE.FMAX))
     *      NVALUE = NVALUE + 1
C                                       save in non-blanked slot
         VALUES(NVALUE) = C(2)*V2(I)
C                                       if not blanked value
         IF ((V2(I).NE.FBLANK) .AND. (C(2) .NE. IGNORE) .AND.
     *       (FMIN.EQ.0. .OR. VALUES(NVALUE).GE.FMIN) .AND.
     *       (FMAX.EQ.0. .OR. VALUES(NVALUE).LE.FMAX))
     *      NVALUE = NVALUE + 1
C                                       save in non-blanked slot
         VALUES(NVALUE) = C(3)*S1(I)
C                                       if not blanked value
         IF ((S1(I).NE.FBLANK) .AND. (C(3) .NE. IGNORE) .AND.
     *       (FMIN.EQ.0. .OR. VALUES(NVALUE).GE.FMIN) .AND.
     *       (FMAX.EQ.0. .OR. VALUES(NVALUE).LE.FMAX))
     *      NVALUE = NVALUE + 1
C                                       save in non-blanked slot
         VALUES(NVALUE) = C(4)*S2(I)
C                                       if not blanked value
         IF ((S2(I).NE.FBLANK) .AND. (C(4) .NE. IGNORE) .AND.
     *       (FMIN.EQ.0. .OR. VALUES(NVALUE).GE.FMIN) .AND.
     *       (FMAX.EQ.0. .OR. VALUES(NVALUE).LE.FMAX))
     *      NVALUE = NVALUE + 1
C                                       fix value count
         NVALUE = NVALUE - 1
C                                       if no unblanked values
         IF (NVALUE .LE. 0) THEN
            R1(I) = FBLANK
            R2(I) = FBLANK
C                                       if only one value
         ELSE IF (NVALUE .EQ. 1) THEN
            R1(I) = VALUES(1)
            R2(I) = FBLANK
         ELSE
C                                       if more than 1 value
            CALL EXCLUD( NVALUE, VALUES, R1(I), R2(I))
         END IF
C
 100     CONTINUE
      GO TO 900
C                                       Common processing
 900  DO 910 I = 1,NX
C                                       if clip on singal/noise
         IF (CLPSN .AND. R1(I).NE.FBLANK) THEN
            SN = ABS (R1(I)) / C(NOISEV)
            IF (SN.LT.C(ISNR)) R1(I) = FBLANK
C                                       else if clip on noise/noise
         ELSE IF (CLPSIG) THEN
            IF (R2(I).EQ.FBLANK) THEN
               R1(I) = FBLANK
            ELSE
               SN = ABS (R2(I)) / C(NOISEV)
               IF ( SN.GT.C(ISNR)) R1(I) = FBLANK
               END IF
            ENDIF
C                                       if blank, flag both
         IF (R1(I).EQ.FBLANK) R1(I) = BRES
         IF (R2(I).EQ.FBLANK) R2(I) = BRES
C                                       Get max/min
         IF (R1(I).NE.FBLANK) THEN
            XX(1) = MAX (XX(1), R1(I))
            XN(1) = MIN (XN(1), R1(I))
         ELSE
            BFLAG = .TRUE.
            END IF
         IF (R2(I).NE.FBLANK) THEN
            XX(2) = MAX (XX(2), R2(I))
            XN(2) = MIN (XN(2), R2(I))
         END IF
 910     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE EXCLUD ( NVALUE, VALUES, OUTVAL, OUTVL2)
C-----------------------------------------------------------------------
C   EXCLUD averages several pixel values, excluding the extreama.  For a
C   Small number (ie 2, 3 or 4) this function is the same as the median.
C   Inputs:
C      NVALUE   I       Number of values to examine
C      VALUES   R()     Number of values to average with extreama exclud
C   Output:
C      OUTVAL   R       Value of array with extreama excluded
C      OUTVL2   R       sum of values not used
C-----------------------------------------------------------------------
      INTEGER   NVALUE
      REAL VALUES(*), OUTVAL, OUTVL2
C-----------------------------------------------------------------------
      INTEGER   I
      REAL      SUM, MINVAL, MAXVAL
C-----------------------------------------------------------------------
C                                       Initialize sum and extreama
      SUM    = VALUES(1)
      MINVAL = VALUES(1)
      MAXVAL = VALUES(1)
C                                       for all other values
      DO 100 I = 2, NVALUE
         SUM = SUM + VALUES(I)
         IF (MINVAL .LT. VALUES(I)) THEN
            MINVAL = VALUES(I)
         ELSE IF (MAXVAL .GT. VALUES(I)) THEN
            MAXVAL = VALUES(I)
         END IF
 100     CONTINUE
C                                       If possible to exclude 2
      IF (NVALUE .GT. 2) THEN
C                                       Exclude min and max
         OUTVAL = (SUM - MINVAL - MAXVAL) / (NVALUE-2.)
         OUTVL2 = (SUM / NVALUE) - OUTVAL
C                                       If only a pair of values
      ELSE IF (NVALUE .EQ. 2) THEN
C                                       Just average
         OUTVAL = SUM * 0.5
         OUTVL2 = SUM - OUTVAL
      ELSE
C                                       Else output value
         OUTVAL = SUM
C                                       blank second value
         OUTVL2 = 0
      END IF
C
 999  RETURN
      END
      SUBROUTINE MEDIHI (IRET)
C-----------------------------------------------------------------------
C   MEDIHI creates and writes the HI file associated with task MEDI.
C   Outputs:
C      IRET   I      > 0 => output all blanks
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER HILINE*72, ABUNIT(3)*8, FTYPE(2)*8, NOTTYP*2
      INTEGER   NHISTF, IHDLUN, IHSLUN, I, IER, IERR, IBUFF1(256), J,
     *    IBUFF2(256), IPTR, ITEMP, FU
      REAL      TEMP
      LOGICAL   TRUE, FALSE
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'MEDI.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (IBUFF1(1),IROW(1,1)),  (IBUFF2(1),IROW(257,1))
      DATA NHISTF, IHDLUN, IHSLUN /2,27,28/
      DATA ABUNIT /'ANGLE   ', 'RADIANS ', 'ROT.MS. '/
      DATA TRUE, FALSE /.TRUE.,.FALSE./
      DATA FTYPE /'IMAGE','DEVI '/
      DATA NOTTYP /'CC'/
C-----------------------------------------------------------------------
C                                       Initialize HITAB
      CALL HIINIT (NHISTF)
      IRET = 0
      DO 200 J = 2,1,-1
         IF (DOFILE(4+J)) THEN
C                                       Test validity of result
            IF (XX(J).LT.XN(J)) THEN
               IRET = 4
               WRITE (MSGTXT,1000) FTYPE(J)
               CALL MSGWRT (8)
               GO TO 999
            ELSE IF (XX(J).EQ.XN(J)) THEN
               WRITE (MSGTXT,1001) FTYPE(J), XX(J)
               CALL MSGWRT (6)
               END IF
C                                       Insert header parameters
            CALL COPY (256, CATIO(1,J), CATBLK)
            CATR(KRDMN) = XN(J)
            CATR(KRDMX) = XX(J)
C                                        Put in inhibited pixel value
            CATR(KRBLK) = 0.0
            IF (BFLAG) CATR(KRBLK) = FBLANK
C                                       Fix strange units
            FU = 0
            TEMP = 90. / 3.14159
            IF (FU.GT.0) CALL CHR2H (8, ABUNIT(FU), 1, CATH(KHBUN))
C                                       Create and open new HI file
            CALL HICREA (IHDLUN, FCVOL(4+J), FCCNO(4+J), CATBLK, IBUFF2,
     *         IERR)
            IPTR = IBUFF2(3)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1010) FTYPE(J), IERR
               CALL MSGWRT (7)
               GO TO 200
               END IF
C                                       Copy both input HI files
            DO 50 I = 1,4
               IF (DOFILE(I)) THEN
                  WRITE (HILINE,1020) I
                  CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
                  IF (IERR.NE.0) GO TO 190
                  ITEMP = HITAB(IPTR+2)
                  CALL HIOPEN (IHSLUN, FCVOL(I), FCCNO(I), IBUFF1,IERR)
                  IF (IERR.NE.0) GO TO 30
                  CALL HICOPY (IHSLUN, IBUFF1, IHDLUN, IBUFF2, IERR)
                  CALL HICLOS (IHSLUN, FALSE, IBUFF1, IER)
                  IF (IERR.EQ.0) GO TO 50
                     IF (IERR.GE.100) HITAB(IPTR+2) = ITEMP
 30                  WRITE (MSGTXT,1030) I, IERR
                     CALL MSGWRT (6)
                     WRITE (HILINE,1031)
                     CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
                     IF (IERR.NE.0) GO TO 190
                  END IF
 50            CONTINUE
            WRITE (HILINE,1050)
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            WRITE (HILINE,1055) TSKNAM, RLSNAM, IUSER
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
C                                       Add input parameters
            CALL HENCO1 (TSKNAM, NAMIN(1), CLSIN(1), ISSEQ(1), FCVOL(1),
     *         IHDLUN, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            IF (DOFILE(2))
     *         CALL HENCO2 (TSKNAM, NAMIN(2), CLSIN(2), ISSEQ(2),
     *         FCVOL(2), IHDLUN, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            IF (DOFILE(3))
     *         CALL HENCO3 (TSKNAM, NAMIN(3), CLSIN(3), ISSEQ(3),
     *         FCVOL(3), IHDLUN, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            IF (DOFILE(4))
     *         CALL HENCO4 (TSKNAM, NAMIN(4), CLSIN(4), ISSEQ(4),
     *         FCVOL(4), IHDLUN, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            CALL HENCOO (TSKNAM, NAMOUT(J), CLSOUT(J), IDSEQ(J),
     *         FCVOL(4+J), IHDLUN, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            WRITE (HILINE,1094) TSKNAM, (IBLC(I,1), I = 1,7)
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            WRITE (HILINE,1096) TSKNAM, (ITRC(I,1), I = 1,7)
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            IF ((NRDIM(1).GT.2) .AND. (NRDIM(2).LE.2)) THEN
               WRITE (HILINE,1098) TSKNAM
               CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
               END IF
C                                       Parameters
            WRITE (HILINE,1101) TSKNAM, (I, CPARM(I), I = 1,2)
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            WRITE (HILINE,1101) TSKNAM, (I, CPARM(I), I = 3,4)
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            WRITE (HILINE,1102) TSKNAM, (I, CPARM(I), I = 5,6)
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
C                                       blanking
            IF (CPARM(8).LE.0.0) WRITE (HILINE,1110) TSKNAM
            IF (CPARM(8).GT.0.0) WRITE (HILINE,1111) TSKNAM
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
C                                       clip on inputs
            IF ((CPARM(CLIPMN).NE.0.0) .OR.
     *          (CPARM(CLIPMX).NE.0.0)) THEN
               WRITE (HILINE,1112) TSKNAM,CPARM(CLIPMN),CPARM(CLIPMX)
               CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
               END IF
C                                       Noise value
            IF (CPARM(NOISEV).NE.0.0) THEN
               WRITE (HILINE,1130) TSKNAM, CPARM(NOISEV), 1
               CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
               END IF
            IF (IERR.NE.0) GO TO 190
C                                       Noise limit
            IF ((CPARM(13).GT.0.0) .AND. (CPARM(16).GT.0.0)) THEN
               WRITE (HILINE,1131) TSKNAM, CPARM(16)
               CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
               END IF
C                                       Noise clipping on SNR
            IF ((CPARM(14).GT.0.5) .OR. (CPARM(15).GT.0.0)) THEN
               WRITE (HILINE,1140) TSKNAM, CPARM(15)
               IF (CPARM(14).GE.1.5) WRITE (HILINE,1141) TSKNAM,
     *            CPARM(15)
               CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
               END IF
C                                       Close HI file
 190        CALL HICLOS (IHDLUN, TRUE, IBUFF2, IER)
            WRITE (MSGTXT,1900) FTYPE(J)
            IF ((IER.NE.0) .OR. (IERR.NE.0)) WRITE (MSGTXT,1901)
     *         FTYPE(J), IERR, IER
            CALL MSGWRT (2)
C                                        Copy tables
            CALL ALLTAB (1, NOTTYP, IHSLUN, IHDLUN, FCVOL(1),
     *         FCVOL(4+J), FCCNO(1), FCCNO(4+J), CATBLK, IBUFF1, IBUFF2,
     *         IERR)
            IF (IERR.GT.2) THEN
               MSGTXT = 'ERROR COPYING TABLE FILES'
               CALL MSGWRT (6)
               END IF
C                                       Close map file
            CALL MAPCLS ('INIT', FCVOL(4+J), FCCNO(4+J), OLUN(J),
     *         OIND(J), CATBLK, TRUE, IBUFF2, IERR)
            NCFILE = NCFILE - 1
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1910) FTYPE(J), IERR
               CALL MSGWRT (6)
               END IF
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OUTPUT ',A5,' FILE COMPLETELY BLANKED -- QUITTING')
 1001 FORMAT ('Output ',A5,' FILE constant at',1PE13.5,
     *   ' -- saving it anyway')
 1010 FORMAT ('MEDIHI: could not create HISTORY FOR ',A5,' FILE.  IER=',
     *   I5)
 1020 FORMAT (31X,'/ History of input map', I2)
 1030 FORMAT ('WARNING COULD NOT OPEN/COPY INPUT HI FILE=',I2,
     *   '.  IER=',I7)
 1031 FORMAT (31X,'/ NO HISTORY TO BE FOUND')
 1050 FORMAT (31X,'/ End of old histories')
 1055 FORMAT (A6,'RELEASE=',A7,' '' USERID=',I5)
 1094 FORMAT (A6,'BLC=',7I5,' / Bottom left corner')
 1096 FORMAT (A6,'TRC=',7I5,' / Top right corner')
 1098 FORMAT (A6,'/ Single plane of Map 2 applied to all planes of',
     *   ' Map 1')
 1101 FORMAT (A6,2('A(',I1,')=',1PE12.4,2X))
 1102 FORMAT (A6,2('A(',I1,')=',1PE12.4,2X),' / clip limits')
 1110 FORMAT (A6,'/ Undefined pixels magic-value blanked')
 1111 FORMAT (A6,'/ Undefined pixels set to zero')
 1112 FORMAT (A6,' > ',1PE12.4,' < ',1PE12.4,'/ Clip levels')
 1130 FORMAT (A6,'SIGMA=',1PE12.4,'  /Input images noise level')
 1131 FORMAT (A6,'B(6)=',1PE12.4,'  / Output sigma limit')
 1140 FORMAT (A6,'B(5)=',1PE12.4,'  / Max unblanked noise')
 1141 FORMAT (A6,'B(5)=',1PE12.4,'  / Min unblanked sig/noise')
 1900 FORMAT ('History file created and written for ',A5,' file')
 1901 FORMAT ('HISTORY FILE FOR ',A5,' INCOMPLETE.  IERRS =',2I7)
 1910 FORMAT ('WARNING MEDIHI COULD NOT CLOSE OUTPUT ',A5,
     *   ' FILE.  IER=',I7)
      END

      SUBROUTINE QINTG (UV, MOD, PHAS, GRID, INTP, M, LROW, INC, NMOD)
C-----------------------------------------------------------------------
C! FPS AP version: Interpolates model visibilities from a grid
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FPS AP version
C   Interpolates model visibilities from a grid, corrects the phase and
C   returns the value in the array pointed to by MOD.  Assumes that the
C   observations are never within M/2 of the outside edge of the grid.
C   Inputs:
C    UV    I  Base address of (u,v) values in cells.
C    MOD   I  Base address for resultant model. (increment=4)
C    PHAS  I  Phase correction, complex value to be multiplied by
C               model vis. Increment = 4.
C    GRID  I  GRID = base address of gridded model vis. Order
C               assumed to be the  following  for each of the M rows:
C                  1) 2 * LROW visibilities
C    INTP  I  base address of interpolation function.
C    M     I  number of rows kept in the AP. Also support size of
C               interp. fn
C    LROW  I  length of a row.
C    INC   I  increment for UV.
C    NMOD  I  number of model values to compute.
C     All AP memory values are assumed floating.
C     It is assumed that all values of v correspond to row M/2.
C-----------------------------------------------------------------------
      INTEGER   UV, MOD, PHAS, GRID, INTP, M, LROW, INC,  NMOD
      INTEGER*2 IUV, IMOD, IPHAS, IGRID, IINTP, IM, ILROW, IINC,  INMOD
C-----------------------------------------------------------------------
C                                        Convert inputs to unsigned I*2
      IF (UV.LT.32768) IUV = UV
      IF (UV.GE.32768) IUV = UV - 65536
      IF (MOD.LT.32768) IMOD = MOD
      IF (MOD.GE.32768) IMOD = MOD - 65536
      IF (PHAS.LT.32768) IPHAS = PHAS
      IF (PHAS.GE.32768) IPHAS = PHAS - 65536
      IF (GRID.LT.32768) IGRID = GRID
      IF (GRID.GE.32768) IGRID = GRID - 65536
      IF (INTP.LT.32768) IINTP = INTP
      IF (INTP.GE.32768) IINTP = INTP - 65536
      IF (M.LT.32768) IM = M
      IF (M.GE.32768) IM = M - 65536
      IF (LROW.LT.32768) ILROW = LROW
      IF (LROW.GE.32768) ILROW = LROW - 65536
      IINC = INC
      IF (NMOD.LT.32768) INMOD = NMOD
      IF (NMOD.GE.32768) INMOD = NMOD - 65536
C                                        Call FPS routine.
      CALL APINT (IUV, IMOD, IPHAS, IGRID, IINTP, IM, ILROW, IINC,
     *   INMOD)
C
 999  RETURN
      END

      SUBROUTINE KEYCOP (DISKIN, CNOIN, DISKO, CNOOUT, IERR)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Copy any file catalog keyword/value pairs from one file to another.
C   Inputs:
C      DISKIN  I  Input file disk number.
C      CNOIN   I  Input file catalog slot number
C      DISKO   I  Output file disk number.
C      CNOOUT  I  Output file catalog slot number
C   Outputs:
C      IERR    I  Error code, 0=OK else CATKEY error.
C-----------------------------------------------------------------------
      INTEGER   DISKIN, CNOIN, DISKO, CNOOUT, IERR
C
      INTEGER   XMXKEY
C                                       XMXKEY = max number of keywords
      PARAMETER (XMXKEY=100)
      CHARACTER KEYWRD(XMXKEY)*8
      INTEGER NUMKEY, LOCS(XMXKEY), KEYTYP(XMXKEY), VALUES(2*XMXKEY),
     *   BUFFER(256)
C-----------------------------------------------------------------------
C                                       Input and output the same?
      IF ((DISKIN.EQ.DISKO) .AND. (CNOIN.EQ.CNOOUT)) GO TO 999
C                                       Read old keyword/value pairs
      NUMKEY = XMXKEY
      CALL CATKEY ('ALL ', DISKIN, CNOIN, KEYWRD, NUMKEY, LOCS, VALUES,
     *   KEYTYP, BUFFER, IERR)
C                                       Write to output file
      IF ((IERR.EQ.0) .AND. (NUMKEY.GT.0))
     *   CALL CATKEY ('WRIT', DISKO, CNOOUT, KEYWRD, NUMKEY, LOCS,
     *   VALUES, KEYTYP, BUFFER, IERR)
C
 999  RETURN
      END
 

      SUBROUTINE QSEARC (NF, NT, MF, MT, ND, NR, APIAD, APINTR, APFIN)
C-----------------------------------------------------------------------
C! Pseudo AP routine: VLBI fringe search with FFT.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   QSEARC is a routine to do a gridded fringe search by means of
C   padded FFTs.  The number (size) of the FFTs is NF (MT) +
C   NR (MF).
C   Inputs:
C      NF       I  No. frequency channels.
C      NT       I  No. time points.
C      MF       I  No. points for freq. FFT.
C      MT       I  No. points for time FFT.
C      ND       I  No. delay channels to search.
C      NR       I  No. rate channels to search.
C      APIAD    I   Base address input data: 2 * NT * NF words used
C      APINTR   I   Base address work area: 2 * NF * NR used
C      APFIN    I   Base address work areas: 2 * NR * ND + max(MT,MF)
C   Output: (in AP memory)
C      0 => 1 dim. array index for peak.
C      1 => peak amplitude
C      2 => peak phase.
C
C   SGI MP version.  Uses routines from complib.sgimath.
C-----------------------------------------------------------------------
      INTEGER   NF, NT, MF, MT, ND, NR, APIAD, APINTR, APFIN
C
      INTEGER   DDATA, INTER, FINAL, LOC1, MF2, MT2, NN, NR2, ND2, NT2,
     *   LOOP, PEAK, ITEMP, I, PTR
C
      INTEGER   MAXSIZ
      PARAMETER (MAXSIZ = 8192)
      COMPLEX   WORK(MAXSIZ), COEFF(MAXSIZ + 15)
C
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                        Set pointers.
      MF2 = MF * 2
      MT2 = MT * 2
      NT2 = NT * 2
      NR2 = NR * 2
      ND2 = ND * 2
      DDATA = APIAD
      INTER = APINTR
      FINAL = APFIN
      NN = NR * ND
C                                        Do first XFORM,
      CALL CFFT1DI (MT, COEFF)
C$DOACROSS LOCAL(PTR, ITEMP, I, WORK, LOOP), SHARED(MT, APCORE)
      DO 100 LOOP = 1, NF
         PTR = DDATA + NT2 * (LOOP - 1)
         DO 110 I = 1, MT
            IF (I .LE. NT) THEN
               WORK(I) = CMPLX (APCORE(PTR + 2 * (I - 1) + 1),
     *                          APCORE(PTR + 2 * (I - 1) + 2))
            ELSE
               WORK(I) = CMPLX (0.0, 0.0)
            END IF
  110    CONTINUE
C                                        Do time FFT.
         CALL CFFT1D (+1, MT, WORK, 1, COEFF)
C                                         Save first half
         ITEMP = NR / 2 + 1
         LOC1 = INTER + NR2 * (LOOP  - 1)
         DO 120 I = 1, ITEMP
            APCORE(LOC1 + 2 * (I - 1) + 1) = REAL (WORK(I))
            APCORE(LOC1 + 2 * (I - 1) + 2) = AIMAG (WORK(I))
  120    CONTINUE
C                                         Save second half
         LOC1 = LOC1 + ITEMP * 2
         ITEMP = NR / 2
         DO 130 I = 1, ITEMP
            APCORE(LOC1 + 2 * (I - 1) + 1) = REAL (WORK(MT-NR/2+I))
            APCORE(LOC1 + 2 * (I - 1) + 2) = AIMAG (WORK(MT-NR/2+I))
  130    CONTINUE
  100 CONTINUE
C                                         Second transform loop.
      CALL CFFT1DI (MF, COEFF)
C$DOACROSS LOCAL(PTR, ITEMP, I, WORK, LOOP), SHARED(MF, APCORE)
      DO 200 LOOP = 1, NR
         PTR = INTER + 2 * (LOOP - 1)
         DO 210 I = 1, MF
            IF (I .LE. NF) THEN
               WORK(I) = CMPLX (APCORE(PTR + NR2 * (I - 1) + 1),
     *                          APCORE(PTR + NR2 * (I - 1) + 2))
            ELSE
               WORK(I) = CMPLX (0.0, 0.0)
            END IF
  210    CONTINUE
C                                         Freq. FFT.
         CALL CFFT1D (+1, MF, WORK, 1, COEFF)
C                                         Save first half
         ITEMP = ND / 2 + 1
         LOC1 = FINAL + ND2 * (LOOP - 1)
         DO 220 I = 1, ITEMP
            APCORE(LOC1 + 2 * (I - 1) + 1) = REAL (WORK(I))
            APCORE(LOC1 + 2 * (I - 1) + 2) = AIMAG (WORK(I))
  220    CONTINUE
C                                         Save second half
         LOC1 = LOC1 + ITEMP * 2
         ITEMP = ND / 2
         DO 230 I = 1, ITEMP
            APCORE(LOC1 + 2 * (I - 1) + 1) = REAL (WORK(MF-ND/2+I))
            APCORE(LOC1 + 2 * (I - 1) + 2) = AIMAG (WORK(MF-ND/2+I))
  230    CONTINUE
  200 CONTINUE
C                                         Find max amp.
      CALL QCVMMA (FINAL, 2, 0, NN)
      PEAK = SPAD(15)
C                                         Save index in AP LOC 0 I
      APCORI(1) = SPAD(15)
C                                         Polar conversion.
      PEAK = (PEAK * 2) - 2
      LOC1 = FINAL + PEAK
      CALL QPOLAR (LOC1, 2, 1, 2, 1)
C
 999  RETURN
      END

LOCAL INCLUDE 'BLAVG.INC'
C                                       Local include for BLAVG
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER  CATIN(256), CATOUT(256), SEQIN, SEQOUT, DISKIN, DISKO,
     *   BCHANN, ECHANN, BIFF, EIFF, TNF, TNIF, TNS, INCFB, INCIFB,
     *   NUMHIS, JBUFSZ, ILOCWT, NRPARO, OANT1, OANT2, ANTIDX(256),
     *   STKRL, STKLR
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2), XSOUR(4,30)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, HISCRD(10)*64
      REAL   XSIN, XDISIN, XSOUT, XDISO, XFQID, XBCHAN, XECHAN, XBIF,
     *   XEIF, XTIME(8), XANTS(50), XFLAG, XDOCAL, XGUSE, XSOLIN,
     *   XREF, BADD(10), BUFF1(UVBFSS), BUFF2(UVBFSS), DTUTC, XSUBA
      LOGICAL   ISCOMP
      INTEGER ACSIZE
C                                       ACSIZE = size of accum. array
      PARAMETER (ACSIZE = 2500000)
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
      COMMON /HDRS/ CATIN, CATOUT
      COMMON /INPTS/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XTIME, XFQID,
     *   XBCHAN, XECHAN, XBIF, XEIF, XANTS, XFLAG, XSUBA, XDOCAL, XGUSE,
     *   XNAMOU, XCLAOU, XSOUT, XDISO, XSOLIN, XREF, BADD,
     *   SEQIN, SEQOUT, DISKIN, DISKO, BCHANN, ECHANN, BIFF, EIFF, TNF,
     *   TNIF, TNS, INCFB, INCIFB, NUMHIS, ILOCWT, NRPARO, ISCOMP,
     *   ANTIDX, DTUTC, OANT1, OANT2, STKRL, STKLR
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, HISCRD
LOCAL END
      PROGRAM BLAVG
C-----------------------------------------------------------------------
C! Average cross-polarized uv data over baselines.
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1999-2000, 2004, 2006-2009, 2015, 2018,
C;  Copyright (C) 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   The primary function of UVAVG is to average data which it does
C   if any OPCODE except 'MERG' is used.
C
C   UVAVG averages a uv data set to a maximum time given by YINC.
C   Data can be in either 'TB' or 'BT' order.  The accumulation buffer
C   has a maximum size that will allow 8 correlators on 30 stations
C   or 128 spectral channels on 7 stations for the 'TB' sort order with
C   10 parameters in the PARMS array.  The data is averaged weighted by
C   the data weights.  The PARMS are averaged weighted by the largest
C   weight in the data record except the baseline number, for which
C   the last one is passed.
C
C   For OPCODE='MERG', UVAVG performs the merge function previously
C   by VBMRG.  The time specified by YINC is taken to be the average
C   time of the input data.  In each input time on each baseline,
C   only one data point is selected and passed.  This is useful for
C   VLB data processed with multiple passes so that there are multiple
C   copies of some data.  It is also useful for putting together
C   polarization data sets when different polarizations were processed
C   separately.
C
C   If XINC if greater than 1, only every XINC'th group of output
C   records (eg all baselines for an average interval) will be written.
C   This should be useful in creating small data sets that still have
C   about the uv coverage of a large data set and still has points
C   appropriately alligned for self cal.  Might be used, for example
C   in the first iterations of hybrid mapping.
C
C   Based on program UVAVG
C   Inputs:
C   AIPS adverb  Prg. name.          Description.
C   INNAME         NAMEIN        Name of input UV data.
C   INCLASS        CLAIN         Class of input UV data.
C   INSEQ          SEQIN         Seq. of input UV data.
C   INDISK         DISKIN        Disk number of input UV data.
C   OUTNAME        NAMOUT        Name of the output uv file.
C   OUTCLASS       CLAOUT        Class of the output uv file.
C   OUTSEQ         SEQOUT        Seq. number of output uv data.
C   OUTDISK        DISKO         Disk number of the output file.
C   YINC           YINC          Integration time (sec) min=0.2
C   XINC           XINC          Write only XINC'th output recs.
C   OPCODE         OPCODE        Average or merge.
C   BLAVG Programmer: K. J. Leppanen  Apr. 1994.
C   UVAVG Programmer R. C. Walker, Feb. 1984.
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGM*6
      INCLUDE 'BLAVG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA PRGM /'BLAVG '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL BLAVIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Average data
      CALL BLAVUV (IRET)
C                                       Update history and copy tables
      IF (IRET.EQ.0) CALL BLAVHI
C                                       close down
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE BLAVIN (PRGM, JERR)
C-----------------------------------------------------------------------
C   BLAVIN gets input parameters for BLAVG and creates an output file
C   if necessary.
C   Inputs:  PRGM   C*6      Task name
C   Output:  JERR   I        Error code: quit if > 0.
C-----------------------------------------------------------------------
      CHARACTER  STAT*4, PRGM*6, UTYPE*2
      HOLLERITH CATH(256)
      INTEGER   LUNAN, ANVER, IROUND, JERR, NPARM, IERR, OLDCNO,
     *   I, J, FLAG, REFANT
      LOGICAL   T, F, SELECT, EXCLUD
      REAL      CATR(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'BLAVG.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      DATA T, F /.TRUE.,.FALSE./
      DATA LUNAN /27/
C-----------------------------------------------------------------------
C                                       Initialize I/O
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL SELINI
C
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 213
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.EQ.0) GO TO 10
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
C                                       Restart AIPS
 10   IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
      IF (XSOLIN .LT. 0.001) XSOLIN = 1.0
      XSOLIN = XSOLIN / 1440.0
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      DO 15 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 15      CONTINUE
C                                       Put data selection criteria
C                                       into correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      CALL RCOPY (8, XTIME, TIMRNG)
      DXTIME = 1.0/86400.0
      FRQSEL = IROUND(XFQID)
      IF (FRQSEL .LT. 1) FRQSEL = 1
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 20      CONTINUE
      SUBARR = IROUND (XSUBA)
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      FGVER = IROUND (XFLAG)
      CLUSE = IROUND (XGUSE)
      REFANT = IROUND (XREF)
C                                       Antenna selection
C                                       ANTIDX(I) = 0 -> ant. I excluded
      EXCLUD = F
      SELECT = F
      DO 22 I = 1,256
         ANTIDX(I) = 0
 22      CONTINUE
      FLAG = 1
      DO 24 I = 1,50
         ANTENS(I) = IROUND (XANTS(I))
         IF (IABS (ANTENS(I)) .GT. 256) THEN
            WRITE (MSGTXT,1020)
            JERR = 5
            GO TO 990
            END IF
         IF (ANTENS(I) .LT. 0) EXCLUD = T
         IF (ANTENS(I) .NE. 0) THEN
            ANTIDX(IABS(ANTENS(I))) = FLAG
            SELECT = T
            END IF
 24      CONTINUE
      IF (EXCLUD .OR. .NOT.SELECT) FLAG = 0
      J = 1
      DO 26 I = 1,256
         IF (ANTIDX(I) .EQ. FLAG) THEN
            ANTIDX(I) = J
            J = J + 1
         ELSE
            ANTIDX(I) = 0
            END IF
 26      CONTINUE
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
C                                       Error finding file.
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
C                                       Error copying CATBLK.
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Copy old CATBLK
      CALL COPY (256, CATBLK, CATIN)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Number of Stokes, IF, channels.
      TNS = 1
      IF (JLOCS.GT.0) TNS = CATBLK(KINAX+JLOCS)
      TNIF = 1
      IF (JLOCIF.GT.0) TNIF = CATBLK(KINAX+JLOCIF)
      TNF = 1
      IF (JLOCF.GT.0) TNF = CATBLK(KINAX+JLOCF)
C                                       Channels for phase alignment
      BCHANN = IROUND (XBCHAN)
      BCHANN = MAX (1, MIN (BCHANN, TNF))
      ECHANN = IROUND (XECHAN)
      IF (ECHANN.LT.BCHANN) ECHANN = TNF
      ECHANN = MAX (1, MIN (ECHANN, TNF))
C                                       IFs to use for phase alignm.
C                                       BIFF < 0 => don't use that IF
      BIFF = IROUND (XBIF)
      EIFF = IROUND (XEIF)
      IF (BIFF.LT.0) THEN
         WRITE (MSGTXT,1045) IABS (BIFF)
         CALL MSGWRT(2)
      ELSE
         BIFF = MAX (1, MIN (BIFF, TNIF))
         IF (EIFF.LT.BIFF) EIFF = TNIF
         EIFF = MAX (1, MIN (EIFF, TNIF))
         END IF
C                                       Check if RL and LR present.
      IF (ICOR0-TNS+1 .NE. -4) THEN
         WRITE (MSGTXT,1050)
         JERR = 5
         GO TO 990
         END IF
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Check if sort order 'TB'
      IF (ISORT.NE.'TB') THEN
         WRITE (MSGTXT,1051) ISORT
         JERR = 5
         GO TO 990
         END IF
C                                       Get AN table
      ANVER = 1
      CALL ANTINI ('READ', BUFF1, DISKIN, OLDCNO, ANVER, CATIN, LUNAN,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, NUMORB, XYZHAN, TFRAME,
     *   NOPCAL, ANTNIF, ANFQID, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1052) IERR
         JERR = 5
         GO TO 990
         END IF
C                                       Antenna numbers for output
      IANRNO = 1
      CALL TABAN ('READ', BUFF1, IANRNO, ANKOLS, ANNUMV, ANNAME, STAXYZ,
     *   ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN, POLTYA, POLAA,
     *   POLCA, POLTYB, POLAB, POLCB, IERR)
      OANT1 = NOSTA
      IANRNO = 2
      CALL TABAN ('READ', BUFF1, IANRNO, ANKOLS, ANNUMV, ANNAME, STAXYZ,
     *   ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN, POLTYA, POLAA,
     *   POLCA, POLTYB, POLAB, POLCB, IERR)
      OANT2 = NOSTA
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1052) IERR
         JERR = 5
         GO TO 990
         END IF
      CALL TABIO ('CLOS', 1, IANRNO, BUFF1, BUFF1, JERR)
      IF (REFANT.GT.0) THEN
         IF (REFANT.GT.OANT1) THEN
C                                       RL->RR, LR->LL
            OANT2 = REFANT
            STKRL = -1
            STKLR = -2
            END IF
         IF (REFANT.LE.OANT1) THEN
C                                       RL->LL, LR->RR
            OANT1 = REFANT
            STKRL = -2
            STKLR = -1
            END IF
      ELSE
         WRITE (MSGTXT,1053)
         JERR = 5
         GO TO 990
         END IF
C                                       Message about output baseline
      WRITE (MSGTXT,1054) OANT1,OANT2
      CALL MSGWRT(2)
C                                       Data time - UTC
      DTUTC = DATUTC / 86400.0
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Output file will have only
C                                       RL&LR disguised as RR&LL
      CATBLK(KINAX+JLOCS) = 2
      CATD(KDCRV+JLOCS) = -1.0D0
      CATR(KRCIC+JLOCS) = -1.0
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1055) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                        Put input file in READ
      UTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      SEQOUT = CATBLK(KIIMS)
C                                        Copy new CATBLK
      CALL COPY (256, CATBLK, CATOUT)
      JERR = 0
C                                       copy keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BLAVIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1020 FORMAT ('BLAVIN: SPECIFIED ANTENNA NUMBERS OUT OF RANGE')
 1030 FORMAT ('BLAVIN: ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,
     *   ' DISK=',I3,' USID=',I5)
 1040 FORMAT ('BLAVIN: ERROR',I3,' COPYING CATBLK ')
 1045 FORMAT ('Not using IF',I3,' for phase alignment')
 1050 FORMAT ('BLAVIN: STOKES RL OR LR MISSING')
 1051 FORMAT ('BLAVIN: SORT ORDER ',A2,' NOT TB AS REQUIRED')
 1052 FORMAT ('BLAVIN: ERROR',I3,' READING ANTENNA TABLE')
 1053 FORMAT ('BLAVIN: REFERENCE ANTENNA MUST BE SPECIFIED')
 1054 FORMAT ('OUTPUT BASELINE ',I3,' -',I3)
 1055 FORMAT ('BLAVIN: ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE BLAVUV (IRET)
C-----------------------------------------------------------------------
C   BLAVUV sends uv data one point at a time to the average/merge
C   routine and then writes the modified data if requested.
C   Input in common:
C      ISCOMP  L  If true data is compressed
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER PHNAME(6)*48
      INTEGER   IRET, IPTRO, LUNO, LRECO, INDO, NIOLIM, NIOUT, KBIND,
     *   IA1, IA2, ILENBU, VO, BO, NUMVIS, XCOUNT
      LOGICAL   T, F
      INCLUDE 'BLAVG.INC'
      REAL      BASEL, RPARMS(20)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA VO, BO /0, 1/
      DATA LUNO /17/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       LRECO = length of output rec.
      LRECO = (LREC - NRPARM) * 2 / TNS + NRPARM
C                                       NRPARO = # RPARMS in output
      NRPARO = NRPARM
C                                       Open input file
      CALL UVGET ('INIT', RPARMS, BUFF1, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Update parameters for buffers
C                                       having only two stokes
      LREC = (LREC - NRPARM) * 2 / TNS + NRPARM
      INCFB = INCF
      INCIFB = INCIF
      IF (JLOCF.GT.JLOCS) INCFB = INCF * 2 / TNS
      IF (JLOCIF.GT.JLOCS) INCIFB = INCIF * 2 / TNS
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, PHNAME, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, PHNAME, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init counters.
      NUMVIS = 0
C                                       Loop
C                                       Read vis. record.
 100     CALL UVGET ('READ', RPARMS, BUFF1, IRET)
C                                        Test for end of data
         IF (IRET.LT.0) GO TO 200
         IF (IRET.NE.0) GO TO 999
C                                        Prepare to call BLAVDO
            IF (ILOCB.GE.0) THEN
               BASEL = RPARMS(ILOCB+1)
               IA1 = BASEL / 256. + 0.1
               IA2 = BASEL - IA1*256. + 0.1
            ELSE
               IA1 = RPARMS(ILOCA1+1) + 0.1
               IA2 = RPARMS(ILOCA2+1) + 0.1
               END IF
C                                        No zero baselines
            IF (IA1.EQ.IA2) GO TO 190
C                                        Use antenna index numbers
            IA1 = ANTIDX(IA1)
            IA2 = ANTIDX(IA2)
C                                        Baseline wanted?
            IF (IA1.EQ.0 .OR. IA2.EQ.0) GO TO 190
C                                        Be sure antenna numbers are
C                                        in the expected order.
            IF (IA1 .GE. IA2) THEN
               WRITE (MSGTXT,1110)
               IRET = 7
               GO TO 990
               END IF
            NUMVIS = NUMVIS + 1
            CALL BLAVDO (NUMVIS, RPARMS(ILOCT+1), BUFF1, RPARMS,
     *         IA1, IA2, IRET, LUNO, INDO, NIOLIM, LRECO, IPTRO,
     *         NIOUT, XCOUNT)
C                                       Error (fatal)
            IF (IRET.LE.0) GO TO 190
               WRITE (MSGTXT,1120) IRET
               GO TO 990
 190        CONTINUE
         GO TO 100
C                                       Final call to BLAVDO.
 200  NUMVIS = -1
      CALL BLAVDO (NUMVIS, RPARMS(ILOCT+1), BUFF1, RPARMS, IA1, IA2,
     *   IRET, LUNO, INDO, NIOLIM, LRECO, IPTRO, NIOUT, XCOUNT)
      IF (IRET.LE.0) GO TO 250
         WRITE (MSGTXT,1120) IRET
         GO TO 990
C                                       Recover output CATBLK
 250  CALL COPY (256, CATOUT, CATBLK)
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL UVGET ('CLOSE', RPARMS, BUFF1, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('BLAVUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('BLAVUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1110 FORMAT ('BLAVUV: ANTENNA NUMBERS NOT IN INCREASING ORDER IN BASL',
     *  ' NO')
 1120 FORMAT ('BLAVUV: BLAVDO ERROR',I3)
      END
      SUBROUTINE BLAVHI
C-----------------------------------------------------------------------
C   BLAVHI copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP(16)*2, HILINE*72, LABEL*8
      INTEGER   LUN1, LUN2, IERR, I
      INTEGER   NONOT
      LOGICAL   T
      INCLUDE 'BLAVG.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA LUN1, LUN2, T /27,28, .TRUE./
      DATA NONOT /16/
      DATA NOTTYP /'NX','SN','CL','AT','CT','FG','BP','VT','IM','MC',
     *   'TY', 'PC', 'HF', 'GC', 'CQ', 'BL'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.LE.2) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
C                                       New history
 10   CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM,NAMOUT,CLAOUT,SEQOUT,DISKO,LUN2,
     *   BUFF2,IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Add selection/calibration
C                                       criteria:
C                                       Sources
      WRITE (HILINE,3000) TSKNAM
      IF (NSOUWD.LE.0) CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (NSOUWD.LE.0) GO TO 25
C                                       Included or excluded?
      WRITE (HILINE,3001) TSKNAM
      IF (DOSWNT) WRITE (HILINE,3002) TSKNAM
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       1st 2 and label.
      WRITE (HILINE,3003) TSKNAM, SOURCS(1), SOURCS(2)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      IF (NSOUWD.LE.2) GO TO 25
C                                       Rest of sources
      DO 20 I = 3,NSOUWD,2
         WRITE (HILINE,3004) TSKNAM, SOURCS(I), SOURCS(I+1)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
 20      CONTINUE
 25   CONTINUE
C                                       Timerange
      CALL HITIME (TSTART, TEND, LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Flag table
      WRITE (HILINE,3014) TSKNAM, FGVER
      IF (DOFLAG) CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Calibration info
C                                       Gain tables
      IF (DOCAL) WRITE (HILINE,3019) TSKNAM, CLUSE
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any other history
      IF (NUMHIS.LE.0) GO TO 200
         WRITE (LABEL,1010) TSKNAM
         DO 100 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
 100     CONTINUE
C                                       Close HI file
 200   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO,
     *   FCNO(2), FCNO(1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.LE.2) GO TO 300
         WRITE (MSGTXT,1019)
         CALL MSGWRT (6)
C                                        Update CATBLK.
 300   CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST', BUFF1,
     *   IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BLAVHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,' /')
 1019 FORMAT ('BLAVHI: ERROR COPYING TABLES')
 3000 FORMAT (A6,' SOURCES = ''''     /All sources selected')
 3001 FORMAT (A6,' /Sources excluded:')
 3002 FORMAT (A6,' /Sources included:')
 3003 FORMAT (A6,' SOURCES = ''',A16,''',''',A16,'''')
 3004 FORMAT (A6,'          ,''',A16,''',''',A16,'''')
 3014 FORMAT (A6,' FLAGVER =',I3,' /Flagging table used')
 3019 FORMAT (A6,' GAINUSE = ',I3,' /CL table applied')
      END
      SUBROUTINE BLAVDO (NUMVIS, T, VIS, RPARM, IA1, IA2,
     *   IRET, LUNO, INDO, NIOLIM, LRECO, IPTRO, NIOUT, XCOUNT)
C-----------------------------------------------------------------------
C   BLAVDO averages cross-hand visibilities in time and over baselines.
C   Inputs:
C      NUMVIS     I    Visibility number, -1=> final call, no data
C                      passed but allows any operations to be completed.
C                      Data sent back will be wirtten to output file.
C      T          R    Time in days since 0 IAT on the first day for
C                      which there is data.
C      RPARM(*)   I    Random parameter array which includes U,V,W etc
C                      but also any other random parameters.
C      VIS(3,*)   R    Vis data in order real, imaginary, weight (Jy)
C      IA1        I    First antenna number
C      IA2        I    Second antenna number (IA2 must be > IA1)
C      LUNO       I    Unit number for output.
C      INDO       I    For output, from ZOPEN
C      NIOLIM     I    Maximum number or records per buffer.
C      IPTRO      I    Output pointer - initialize before first call.
C      NIOUT      I    Number of records in buffer.  Init before first
C                                 call
C      XCOUNT     I    Output record counter.  Init before first call.
C   Inputs from COMMON
C      NRPARM     I    # random parameters.
C      CATBLK(256)I    Catalog header record.
C   Output:
C      RPARM      R    Modified random parameter array. NB U,V,W, time
C                      and baseline should not be modified in RPARM
C      VIS        R    Visibilities
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C   Output in COMMON
C      NUMHIS     I    # history entries (max. 10)
C      HISCRD(NUMHIS) C   History records
C      CATBLK     I    Catalog header block
C-----------------------------------------------------------------------
C                                        Declares for call.
      INTEGER   IA1, IA2, NUMVIS, IRET, LUNO, INDO, NIOLIM, IPTRO,
     *   NIOUT, LRECO, XCOUNT
      REAL      T, VIS(*), RPARM(10)
C                                       Main declares.
      INTEGER   KREC, KLIM, I2TMP, REFIF, JRET, VISIDX, BUFIDX, AVGIDX,
     *   OUTIDX, IDAY, NIOFLS, STK, I, ICHAN, IFNO, ICOR, KBIND, MCOR,
     *   NMCOR, KBUFF, BLCUR, NCOPY, CURSRC, LSTSRC, CURFQ, LBAS, IBAS,
     *   KBAS
      REAL      DIV, WGT, AVGWGT, TLAST, CT, TCHK, OPARM(10)
      DOUBLE PRECISION X8
      INCLUDE 'BLAVG.INC'
      REAL      AVGBUF(UVBFSS), UNITYV(UVBFSS)
      REAL      VBUFF(ACSIZE)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      SAVE VBUFF, AVGBUF, UNITYV, NCOPY, TLAST, MCOR, NMCOR,
     *   KLIM, OPARM, REFIF
C-----------------------------------------------------------------------
      IRET = -1
C                                        Initial call
      IF (NUMVIS.EQ.1) THEN
         NUMHIS = 0
C                                        Number of visibilities in
C                                        output file.
         NCOPY = LRECO - NRPARO
C                                        Check PARM array.
C                                        Check for unknown parameters.
         IF ((.NOT.ISCOMP .AND. (NRPARM.GT.8)) .OR.
     *         (ISCOMP .AND. (NRPARM.GT.10))) THEN
            WRITE (MSGTXT,1040) NRPARM
            CALL MSGWRT (8)
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),1040)
            END IF
C                                        Initialize OPARM to 1.0
         CALL RFILL (NRPARM, 1.0, OPARM)
C                                        Set constant output RPARM's
C                                        Baseline to OANT1-OANT2
         IF (ILOCB.GE.0) THEN
            OPARM(ILOCB+1) = 256 * OANT1 + OANT2
         ELSE
            OPARM(ILOCA1+1) = OANT1
            OPARM(ILOCA2+1) = OANT2
            END IF
C                                        u,v,w to zero
         OPARM(ILOCU+1) = 0.0
         OPARM(ILOCV+1) = 0.0
         OPARM(ILOCW+1) = 0.0
C                                        Integration time
         IF (ILOCIT.GT.0) OPARM(ILOCIT+1) = XSOLIN*86400.0
C                                        Set counters etc.
         XCOUNT = 0
         TLAST = -1.0
         TCHK = -1.0
         BLCUR = -1
         MCOR = (LREC - NRPARM) / CATBLK(KINAX)
         NMCOR = MCOR * 3
         CURSRC = -1
         IF (ILOCSU.GE.0) CURSRC = RPARM(1+ILOCSU) + 0.5
         LSTSRC = CURSRC
         CURFQ = 1
         IF (ILOCFQ.GE.0) CURFQ = RPARM(1+ILOCFQ) + 0.5
C                                        Normalize phase for this IF #
         REFIF = BIFF
         IF (BIFF.LT.1) REFIF = 1
         IF (BIFF.EQ.-1) REFIF = 2
C                                        Limit to accumulation buffer.
         KLIM = ACSIZE - (1 + NRPARM + NMCOR)
C                                        Set unity visibility buffer
         DO 80 I = 1,MCOR
            VISIDX = (I-1) * 3
            UNITYV(VISIDX+1) = 1.0
            UNITYV(VISIDX+2) = 0.0
            UNITYV(VISIDX+3) = 1.0
 80         CONTINUE
C                                        Reset accumulation buffer
         I2TMP = ACSIZE
         CALL RFILL (I2TMP, 0.0, VBUFF)
         END IF
C                                        End of special first record
C                                        processing.
C
C                                        If in final call, skip tests.
      IF (NUMVIS.NE.-1) THEN
C                                        Get UT from data time
         CT = T - DTUTC
C                                        Get baseline.
         IF (ILOCB.GE.0) THEN
            IBAS = RPARM(ILOCB+1) + 0.1
         ELSE
            IBAS = RPARM(1+ILOCA1) + 0.1
            IBAS = 32768 * IBAS + RPARM(1+ILOCA2) + 0.1
            END IF
C                                        Be sure of sort order.
         IF (CT.LT.TCHK .AND. (IBAS.EQ.BLCUR)) THEN
            WRITE (MSGTXT,1090)
            CALL MSGWRT (8)
            IRET = 4
            GO TO 999
            END IF
         END IF
C                                        Source Number, FQ id
      CURSRC = -1
      IF (ILOCSU.GE.0) CURSRC = RPARM(1+ILOCSU) + 0.5
      CURFQ = 1
      IF (ILOCFQ.GE.0) CURFQ = RPARM(1+ILOCFQ) + 0.5
      IF (CURFQ .NE. FRQSEL) THEN
         WRITE (MSGTXT,1095)
         CALL MSGWRT (8)
         IRET = 4
         GO TO 999
         END IF
C                                        Check if output needed.
      IF ((CT.GT.TLAST) .OR. (NUMVIS.EQ.-1) .OR.
     *   (CURSRC.NE.LSTSRC)) THEN
C                                        No output for first record.
         IF (NUMVIS.EQ.1) GO TO 180
C                                        Average baselines
            DO 120 KREC = 1,LBAS
               KBUFF = (KREC-1) * (1+NRPARM+NMCOR) + 1
               IF (KBUFF .GT. KLIM) GO TO 120
C                                        Weight for RPARM.
C                                        Will be 0.0 if no valid data
               WGT = VBUFF(KBUFF)
               IF (WGT.GT.0.0) THEN
C                                        Align phases.
                  IF (AVGWGT.GT.0.0) CALL ROTATE (VBUFF(KBUFF+NRPARM+1),
     *               AVGBUF(NRPARM+1), BIFF, EIFF, BCHANN, ECHANN)
C                                        Average visibilities
                  AVGIDX = NRPARM
                  DO 110 I = 1,MCOR
                     BUFIDX = KBUFF + AVGIDX
                     AVGBUF(AVGIDX+1) = AVGBUF(AVGIDX+1) +
     *                  VBUFF(BUFIDX+1)
                     AVGBUF(AVGIDX+2) = AVGBUF(AVGIDX+2) +
     *                  VBUFF(BUFIDX+2)
                     AVGBUF(AVGIDX+3) = AVGBUF(AVGIDX+3) +
     *                  VBUFF(BUFIDX+3)
                     AVGIDX = AVGIDX + 3
 110                 CONTINUE
C                                        Average time
                  AVGBUF(ILOCT+1) = AVGBUF(ILOCT+1) +
     *               VBUFF(KBUFF+ILOCT+1)
C                                        Source number
                  IF (ILOCSU.GE.0) AVGBUF(ILOCSU+1) =
     *               VBUFF(KBUFF+ILOCSU+1)
C                                        Sum RPARM weight
                  AVGWGT = AVGWGT + WGT
                  END IF
 120           CONTINUE
C                                        No data - no output
            IF (AVGWGT.GT.0.0) THEN
C                                        Set output RPARM
C                                        Time (weighted)
               OPARM(ILOCT+1) = AVGBUF(ILOCT+1) / AVGWGT
C                                        Source number
               IF (ILOCSU.GE.0) OPARM(ILOCSU+1) =
     *            AVGBUF(ILOCSU+1)
C                                        Freq ID
               IF (ILOCFQ.GE.0) OPARM(ILOCFQ+1) = FRQSEL
C                                        Copy new parms array to
C                                        output buffer.
               CALL RCOPY (NRPARM, OPARM, BUFF2(IPTRO))
C                                        Rotate phases so as to set
C                                        first IF to appr. zero
               CALL ROTATE (AVGBUF(NRPARM+1), UNITYV, REFIF, REFIF,
     *            BCHANN, ECHANN)
C                                        Compressed?
               IF (ISCOMP) THEN
C                                        Normalize data
                  AVGIDX = NRPARM
                  DO 130 I = 1,MCOR
                     IF (AVGBUF(AVGIDX+3).GT.0.0) THEN
                        DIV = 1.0 / AVGBUF(AVGIDX+3)
                        AVGBUF(AVGIDX+1) = AVGBUF(AVGIDX+1) * DIV
                        AVGBUF(AVGIDX+2) = AVGBUF(AVGIDX+2) * DIV
                     ELSE
C                                       No data
                        AVGBUF(AVGIDX+1) = 0.0
                        AVGBUF(AVGIDX+2) = 0.0
                        AVGBUF(AVGIDX+3) = -1.0
                        END IF
                     AVGIDX = AVGIDX + 3
 130                 CONTINUE
C                                       Pack/copy to output buffer
                  CALL ZUVPAK (NCOPY, AVGBUF(NRPARM+1),
     *               BUFF2(IPTRO+ILOCWT), BUFF2(IPTRO+NRPARO))
               ELSE
C                                       Uncompressed data:
C                                       Normalize
                  AVGIDX = NRPARM
                  DO 140 I = 1,MCOR
                     OUTIDX = IPTRO + AVGIDX - 1
                     IF (AVGBUF(AVGIDX+3).GT.0.0) THEN
                        DIV = 1.0 / AVGBUF(AVGIDX+3)
                        BUFF2(OUTIDX+1) = AVGBUF(AVGIDX+1) * DIV
                        BUFF2(OUTIDX+2) = AVGBUF(AVGIDX+2) * DIV
                        BUFF2(OUTIDX+3) = AVGBUF(AVGIDX+3)
                     ELSE
C                                       No data
                        BUFF2(OUTIDX+1) = 0.0
                        BUFF2(OUTIDX+2) = 0.0
                        BUFF2(OUTIDX+3) = -1.0
                        END IF
                     AVGIDX = AVGIDX + 3
 140                 CONTINUE
                  END IF
C                                        Update counters.
               XCOUNT = XCOUNT + 1
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
C                                        Write output
C                                        Only actually write when
C                                        the buffer is full.
               IF (NIOUT.GE.NIOLIM) THEN
C                                        Use NIOUT instead of NIOLIM
C                                        so last record ok.
                  CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOUT,
     *               KBIND, JRET)
                  IF (JRET.NE.0) THEN
                     WRITE (MSGTXT,1113) JRET
                     IRET = 5
                     GO TO 999
                     END IF
                  IPTRO = KBIND
                  NIOLIM = NIOUT
                  NIOUT = 0
                  END IF
               END IF
C                                        Close up after last record.
            IF (NUMVIS.EQ.-1) THEN
C                                        First write any unwritten
C                                        data.
               IF (NIOUT.GT.0) THEN
                  CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOUT,
     *               KBIND, JRET)
                  IF (JRET.NE.0) THEN
                     WRITE (MSGTXT,1113) JRET
                     CALL MSGWRT (8)
                     IRET = 9
                     GO TO 999
                     END IF
                  END IF
C                                        Then flush buffers to output
               NIOFLS = 0
               CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOFLS, KBIND,
     *            JRET)
               IF (JRET.NE.0) THEN
                  WRITE (MSGTXT,1130) JRET
                  CALL MSGWRT (8)
                  IRET = 6
                  GO TO 999
                  END IF
C                                        Write average time to history
               XSOLIN = XSOLIN * 1440.0
               NUMHIS = NUMHIS + 1
               WRITE (HISCRD(NUMHIS),1140) XSOLIN
C                                        Write no. written to history.
               NUMHIS = NUMHIS + 1
               WRITE (HISCRD(NUMHIS),1150) XCOUNT
               WRITE (MSGTXT,1150) XCOUNT
               CALL MSGWRT (5)
               GO TO 999
               END IF
C
C                                        First record, skip to here.
  180       CONTINUE
C                                        Set up for next integration
         IDAY = CT
         X8 = (CT-IDAY) / XSOLIN
         TLAST = IDAY + DINT (X8) * XSOLIN + XSOLIN
         TCHK = TLAST - 1.1 * XSOLIN
C                                        Reset accumulators, etc.
         I2TMP = LBAS * (1+NRPARM+NMCOR)
         IF (I2TMP .GT. ACSIZE) I2TMP = ACSIZE
         CALL RFILL (I2TMP, 0.0, VBUFF)
         AVGWGT = 0.0
         CALL RFILL (UVBFSS, 0.0, AVGBUF)
         BLCUR = IBAS
         LSTSRC = CURSRC
         LBAS = 0
         END IF
C                                        End of write stuff
C
C                                        Accumulate current datum.
C                                        Get baseline number for accum.
      KBAS = (IA2-1)*(IA2-2)/2 + IA1
C                                        Update the largest baseline #
      IF (KBAS .GT. LBAS) LBAS = KBAS
C                                        Get index of first element of
C                                        accumulation buffer for this
C                                        baseline.  That element will
C                                        accumulate the weight for PARMS
      KBUFF = (KBAS - 1) * (NRPARM + 1 + NMCOR) + 1
C                                        Check that accumulation
C                                        buffer is not exceeded.
      IF (KBUFF .GT. KLIM) THEN
         WRITE (MSGTXT,1180) KBUFF
         CALL MSGWRT (8)
         IRET = 12
         GO TO 999
         END IF
C                                        Initialize parms weight.
      WGT = 0.0
C                                        Loop over stokes RL and LR
      STK = STKRL
      DO 360 ICOR = -3,-4,-1
         DO 340 IFNO = 1,TNIF
            VISIDX = ABS (ICOR-ICOR0)*INCS + (IFNO-1)*INCIF
            BUFIDX = KBUFF + NRPARM + (-1-STK)*INCS + (IFNO-1)*INCIFB
            DO 320 ICHAN = 1,TNF
C                                        Check weight.
               IF (VIS(VISIDX+3).GT.0.0) THEN
C                                        Accumulate crosspol. data.
C                                        Average
                  VBUFF(BUFIDX+1) =
     *               VBUFF(BUFIDX+1) + VIS(VISIDX+1) * VIS(VISIDX+3)
                  VBUFF(BUFIDX+2) =
     *               VBUFF(BUFIDX+2) + VIS(VISIDX+2) * VIS(VISIDX+3)
                  VBUFF(BUFIDX+3) = VBUFF(BUFIDX+3) + VIS(VISIDX+3)
C                                         Use largest weight for time
                  WGT = MAX (WGT, VIS(VISIDX+3))
                  END IF
               VISIDX = VISIDX + INCF
               BUFIDX = BUFIDX + INCFB
 320           CONTINUE
 340        CONTINUE
         STK = STKLR
 360     CONTINUE
C                                         Accumulate RPARMS only if
C                                         some data was good.
      IF (WGT.GT.0.0) THEN
         VBUFF(KBUFF+ILOCT+1) =
     *      VBUFF(KBUFF+ILOCT+1) + RPARM(ILOCT+1)*WGT
C                                        Accumulate weights.
         VBUFF(KBUFF) = VBUFF(KBUFF) + WGT
C                                        Don't weight source id.
         IF (ILOCSU.GE.0) VBUFF(KBUFF+ILOCSU+1) = RPARM(ILOCSU+1)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('BLAVDO: NO. OF PARAMETERS ',I3,
     *   ' NOT NORMAL - AVG MAY BE BAD')
 1090 FORMAT ('BLAVDO: RECORDS NOT IN TIME (TB) ORDER')
 1095 FORMAT ('BLAVDO: ILLEGAL FREQUENCY ID')
 1113 FORMAT ('BLAVDO: ERROR',I3,' WRITING VIS FILE')
 1130 FORMAT ('BLAVDO: ERROR',I3,' CLOSING VIS FILE')
 1140 FORMAT ('BLAVDO: Average time=',F7.2,' min.')
 1150 FORMAT ('BLAVDO: ',I10,' Visibility records written')
 1180 FORMAT ('BLAVDO: Parameter ACSIZE too small (',I8,' )')
      END
      SUBROUTINE ROTATE (VIS, VISREF, BIFN, EIFN, BCHN, ECHN)
C-----------------------------------------------------------------------
C   ROTATE rotates the phases of the input visibilities to match the
C   phases of the reference visibilities. The value of rotation is
C   determined separately for RL and LR from all channels specified
C   by BIFN, EIFN, BCHN and ECHN, and then applied to all cross-hand
C   channels in VIS. It is assumed that the pointers in COMMON /UVHDR/
C   are valid for VIS.
C   Inputs:
C      VIS(*)     R    Visibility data record
C      VISREF(*)  R    Reference visibility record
C      BIFN       I    First IF for phase comparison. If < 0, all the
C                      IFs except this are included (EIFN is ignored).
C      EIFN       I    Last IF for phase comparison
C      BCHN       I    First channel for phase comparison
C      ECHN       I    Last channel for phase comparison
C   Inputs from COMMON
C      TNF        I    # channels in VIS
C      TNIF       I    # IF in VIS
C      TNS        I    # Stokes in VIS
C   Output:
C      VIS        R    Visibility data record rotated in phase
C   Programmer: K. J. Leppanen, Apr. 1994.
C-----------------------------------------------------------------------
      REAL     VIS(*), VISREF(*)
      INTEGER  BIFN, EIFN, BCHN, ECHN
      INTEGER  ICOR, IFNO, ICHAN, INDEX, BADIF
      COMPLEX  CVIS, CREF, SUM, PHASOR
C
      INCLUDE 'BLAVG.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       See if an IF should be excluded
      BADIF = 0
      IF (BIFN .LT. 1) THEN
         BADIF = IABS (BIFN)
         BIFN = 1
         EIFN = TNIF
         END IF
C                                       Stokes RL and LR in the buffers
      DO 50 ICOR = 0,1
C                                       Find the rotation phasor
C                                       by channelwise division
         SUM = CMPLX (0.0,0.0)
         DO 20 IFNO = BIFN,EIFN
            IF (IFNO .EQ. BADIF) GO TO 20
            INDEX = ICOR*INCS + (IFNO-1)*INCIFB + (BCHN-1)*INCFB
            DO 10 ICHAN = BCHN,ECHN
               IF ((VIS(INDEX+3).GT.0.0) .AND. (VISREF(INDEX+3).GT.0.0))
     *            THEN
                  CVIS = CMPLX (VIS(INDEX+1),VIS(INDEX+2))
                  IF (CABS(CVIS).GT.1.0E-8) THEN
                     CREF = CMPLX (VISREF(INDEX+1),VISREF(INDEX+2))
                     SUM = SUM + CVIS / CABS (CVIS) / CREF * CABS (CREF)
     *                  * VIS(INDEX+3) * VISREF(INDEX+3)
                     END IF
                  END IF
               INDEX = INDEX + INCFB
 10            CONTINUE
 20         CONTINUE
C                                       Rotate the data
C                                       (all channels and IFs)
         IF (CABS(SUM).GE.1.0E-8) THEN
            PHASOR = CABS (SUM) / SUM
            DO 40 IFNO = 1,TNIF
               INDEX = ICOR*INCS + (IFNO-1)*INCIFB
               DO 30 ICHAN = 1,TNF
                  CVIS = CMPLX (VIS(INDEX+1),VIS(INDEX+2)) * PHASOR
                  VIS(INDEX+1) = REAL (CVIS)
                  VIS(INDEX+2) = AIMAG (CVIS)
                  INDEX = INDEX + INCFB
 30               CONTINUE
 40            CONTINUE
            END IF
 50      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE BOXSMO (WIDTH, X, Y, N, YS)
C-----------------------------------------------------------------------
C! Does boxcar smoothing of an irregularly spaced array.
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   BOXSMO does a box car (running mean) smoothing of irregularly
C   spaced points.
C    Inputs:
C      WIDTH      R    Width of boxcar in same units as X
C      X(N)       R    Absissae of points to be smoothed.
C      Y(N)       R    Values to be smoothed.
C      N          I    Number of points to smooth.
C    Output:
C      YS(N)      R    Smoothed values.
C-----------------------------------------------------------------------
      INTEGER   N, FIRST, COUNT, I, CURRNT, LIMIT
      REAL      WIDTH, X(N), Y(N), YS(N), XLAST, XFIRST, SUM, HWIDTH,
     *   AVG
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
      IF (WIDTH.LE.0.0) GO TO 900
C                                       Initialize.
      FIRST = 1
      CURRNT = 0
      XLAST = X(1) + WIDTH
      HWIDTH = WIDTH * 0.5
      SUM = 0.0
      COUNT = 0
C                                       Average window at start.
      I = 0
 50      I = I + 1
         IF (I.GT.N) GO TO 60
         IF (X(I).GT.XLAST) GO TO 60
            SUM = SUM + Y(I)
            COUNT = COUNT + 1
            GO TO 50
C                                       Finished sum over window.
 60   AVG = SUM / MAX (1, COUNT)
C                                       Fill in average value.
      XLAST = X(1) + HWIDTH
 70      CURRNT = CURRNT + 1
C                                       Check if finished
         IF (CURRNT.GT.N) GO TO 999
C                                       Check if within 1/2 width
C                                       of start.
         IF (X(CURRNT).GT.XLAST) GO TO 110
            YS(CURRNT) = AVG
            GO TO 70
C                                       Begin main loop.
 100     CURRNT = CURRNT + 1
         IF (CURRNT.GT.N) GO TO 999
 110     XFIRST = X(CURRNT) - HWIDTH
         XLAST = X(CURRNT) + HWIDTH
C                                       Check if running into window at
C                                       the end.
         IF (XLAST .GE. X(N)) GO TO 200
C                                       Init sum.
         SUM = 0.0
         COUNT = 0
         LIMIT = FIRST
         DO 150 I = LIMIT,N
C                                       Check if point too early.
            IF (X(I).GE.XFIRST) GO TO 120
C                                       Too early, reset FIRST.
               FIRST = I + 1
               GO TO 150
C                                       Check if too late.
 120        IF (X(I).GT.XLAST) GO TO 160
C                                       Sum.
               SUM = SUM + Y(I)
               COUNT = COUNT + 1
 150           CONTINUE
C                                       Average window.
 160     YS(CURRNT) = SUM / MAX (1, COUNT)
         GO TO 100
C                                       Do end window.
 200  SUM = 0.0
      COUNT = 0
      XFIRST = X(N)- WIDTH
C                                       Sum over end window.
      DO 210 I = FIRST,N
         IF (X(I).LT.XFIRST) GO TO 210
            SUM = SUM + Y(I)
            COUNT = COUNT + 1
 210        CONTINUE
      AVG = SUM / MAX (1, COUNT)
      DO 250 I = CURRNT,N
         YS(I) = AVG
 250     CONTINUE
      GO TO 999
C                                       WIDTH .le. 0, copy.
 900  CALL RCOPY (N, Y, YS)
C
 999  RETURN
      END

      SUBROUTINE ZMOUN2 (MOUNT, IDRIVE, IDENS, NTAPED, NPOPS, NUSER,
     *   MSG, SYSERR, IERR)
C-----------------------------------------------------------------------
C! mount or dismount magnetic tape device
C# Z2 Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Issue software mount or dismount for a given tape drive - the lowest
C   level Z routine called by ZMOUNT.
C   Inputs:
C      MOUNT    I      Operation: 1 => mount, 0 => dismount
C      IDRIVE   I      Drive number
C      IDENS    I      Density
C      NTAPED   I      Number of tape drives
C      NPOPS    I      Pops number
C      NUSER    I      User AIPS number
C   Output:
C      MSG      C*80   Error message buffer
C      SYSERR   I      System error code (for ZERROR)
C      IERR     I      Error return code: 0 => no error
C                        1 => error
C   VMS version
C-----------------------------------------------------------------------
      INTEGER   MOUNT, IDRIVE, IDENS, NTAPED, NPOPS, SYSERR, IERR,
     *            NUSER
      CHARACTER MSG*80
C
      INTEGER   ISTRUC(13)
      INTEGER*2 HSTRUC(26), IOSB(4)
      INTEGER   I, JERR, PID, MNTCNT, MYPID, FLAG, JDENS, MAXBLK,
     *   SYS$GETJPIW, SYS$GETDVIW, SYS$MOUNT, SYS$DISMOU
      CHARACTER DTAPE*5, PROCES*15
      HOLLERITH TAPE(2)
      INCLUDE '($MNTDEF)'
      INCLUDE '($JPIDEF)'
      INCLUDE '($DVIDEF)'
      EQUIVALENCE (ISTRUC, HSTRUC)
C-----------------------------------------------------------------------
      IERR = 0
      SYSERR = 0
      MSG = ' '
C                                       Construct character string
C                                       descriptor for tape logical name
      I = IDRIVE - 1
      DTAPE = 'MT00:'
      CALL ZEHEX (I, 1, DTAPE(4:4))
C                                       Dismount the tape
      IF (MOUNT.LE.0) THEN
         JERR = SYS$DISMOU (DTAPE,)
         IF (JERR.NE.1) SYSERR = JERR
C                                       Mount section.
      ELSE
C                                       Check for device already
C                                       mounted. VMS 3.2 gets very upset
C                                       over mounting tapes /FOR twice.
         PID = 0
         HSTRUC(1) = 4
         HSTRUC(2) = DVI$_PID
         ISTRUC(2) = %LOC (PID)
         ISTRUC(3) = 0
         HSTRUC(7) = 4
         HSTRUC(8) = DVI$_MOUNTCNT
         ISTRUC(5) = %LOC (MNTCNT)
         ISTRUC(6) = 0
         ISTRUC(7) = 0
         JERR = SYS$GETDVIW ( , , DTAPE, ISTRUC, , , ,)
C                                       Someone has tape mounted.
         IF (MNTCNT.GT.0) THEN
C                                       Get my PID
            HSTRUC(1) = 4
            HSTRUC(2) = JPI$_PID
            ISTRUC(2) = %LOC (MYPID)
            ISTRUC(3) = 0
            ISTRUC(4) = 0
            JERR = SYS$GETJPIW ( , , , ISTRUC, , ,)
C                                       I own tape.
            IF (PID.EQ.MYPID) THEN
               MSG = 'Tape drive already mounted by this process'
C                                       Someone else has tape.
            ELSE
               HSTRUC(1) = 15
               HSTRUC(2) = JPI$_PRCNAM
               ISTRUC(2) = %LOC (PROCES)
               ISTRUC(3) = 0
               ISTRUC(4) = 0
               JERR = SYS$GETJPIW ( , PID, , ISTRUC, IOSB, , )
               IF (JERR.NE.1) PROCES = 'ANOTHER USER'
               IF (IOSB(1).NE.1) PROCES = 'ANOTHER USER'
               MSG = 'TAPE DRIVE IS STILL ALLOCATED BY ' // PROCES
               IERR = 1
               END IF
            GO TO 999
C                                       Try to mount tape.
         ELSE
            CALL CHR2H (5, DTAPE, 1, TAPE)
            HSTRUC(1) = 8
            HSTRUC(2) = MNT$_DEVNAM
            ISTRUC(2) = %LOC (TAPE)
            ISTRUC(3) = 0
            FLAG = MNT$M_FOREIGN + MNT$M_MESSAGE + MNT$M_NOASSIST
            HSTRUC(7) = 4
            HSTRUC(8) = MNT$_FLAGS
            ISTRUC(5) = %LOC (FLAG)
            ISTRUC(6) = 0
            MAXBLK = 2048
            HSTRUC(13) = 4
            HSTRUC(14) = MNT$_BLOCKSIZE
            ISTRUC(8) = %LOC (MAXBLK)
            ISTRUC(9) = 0
            JDENS = IDENS
            HSTRUC(19) = 4
            HSTRUC(20) = MNT$_DENSITY
            ISTRUC(11) = %LOC (JDENS)
            ISTRUC(12) = 0
            ISTRUC(13) = 0
            JERR = SYS$MOUNT (ISTRUC)
            IF (JERR.NE.1) THEN
               SYSERR = JERR
               MSG = 'ERROR AROSE ON ACTUAL SYS$MOUNT CALL'
               IERR = 1
            ELSE
               MSG = 'Mounted on VMS tape drive'
               END IF
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE AU9C (BRANCH)
C-----------------------------------------------------------------------
C! verbs to set initial guesses for slice model fits using TEK graphics
C# POPS-appl Graphics Slice
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2000, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AU9C is a package for interactive determination of initial guesses
C   for 1D and 2D (someday soon) Gaussian fitting.
C   Inputs:
C      BRANCH   I   1 = TKSET set guess all components.
C                   2 = TKSET1 set guess one component.
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      CHARACTER PRGNAM*6, CDUM*1
      INTEGER   INGAUS, INODIM, ISTART, IEND, IERR, IDUM, I, J
      REAL      RDUM(2), GP(2,4), GW(3,4), GM(4), GP1(8), GW1(12)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTKS.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (GP1, GP), (GW1, GW)
      DATA PRGNAM /'AU9C  '/
C-----------------------------------------------------------------------
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.2)) GO TO 999
      ERRNUM = 37
      IF (NTKDEV.LE.0) GO TO 980
      ERRNUM = 0
C                                       Check inputs
      CALL ADVERB ('NGAUSS', 'I', 1, 0, INGAUS, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IF (INGAUS.LT.1) INGAUS = 1
      IF (INGAUS.GT.4) INGAUS = 4
      CALL ADVERB ('GPOS', 'R', 8, 0, IDUM, GP1, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('GWIDTH', 'R', 12, 0, IDUM, GW1, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('GMAX', 'R', 4, 0, IDUM, GM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
C                                       Open Tektonix device
      CALL ZTKOPN (IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TEK OPEN ERROR'
         CALL MSGWRT (6)
         GO TO 975
         END IF
C                                       Set location common.
      CALL SLOCIN (INODIM)
C
      CALL ZTKCLS (IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TEK CLOSE ERROR'
         CALL MSGWRT (6)
         GO TO 975
         END IF
C
      GO TO (100, 200), BRANCH
C-----------------------------------------------------------------------
C                                       TKSET (set all components)
C-----------------------------------------------------------------------
 100  CONTINUE
         ISTART = 1
         IEND = INGAUS
         CALL RFILL (8, 0.0, GP)
         CALL RFILL (12, 0.0, GW)
         CALL RFILL (4, 0.0, GM)
         GO TO 220
C-----------------------------------------------------------------------
C                                       TKSET1 (set 1 component)
C-----------------------------------------------------------------------
 200  CONTINUE
         IF ((SP.LT.1) .OR. (STACK(SP).EQ.2)) THEN
            ERRNUM = 8
            GO TO 980
            END IF
         ISTART = V(SP) + .01
         IF ((ISTART.GT.INGAUS) .OR. (ISTART.LT.1)) GO TO 970
         IEND = ISTART
         SP = SP - 1
C                                       Set initial center, halfwidth,
C                                       amp, using tektronix cursor.
 220     IF (INODIM.EQ.1) THEN
            DO 230 I = ISTART,IEND
               DO 229 J = 1,4
                  CALL ZTKOPN (IERR)
                  IF (IERR.NE.0) THEN
                     MSGTXT = 'TEK OPEN ERROR'
                     CALL MSGWRT (6)
                     GO TO 975
                     END IF
                  CALL SET1DG (I, I, GP, GW, GM, IERR)
                  CALL ZTKCLS (IDUM)
                  IF (IERR.EQ.0) GO TO 230
                  MSGTXT = 'Let''s try again'
                  IF (J.LT.4) CALL MSGWRT (2)
 229              CONTINUE
               IF (I.EQ.ISTART) GO TO 975
               GO TO 240
 230           CONTINUE
 240        CALL ADVRBS ('GPOS', 'R', 8, 0, IDUM, GP1, CDUM)
            IF (ERRNUM.NE.0) GO TO 980
            CALL ADVRBS ('GWIDTH', 'R', 12, 0, IDUM, GW1, CDUM)
            IF (ERRNUM.NE.0) GO TO 980
            CALL ADVRBS ('GMAX', 'R', 4, 0, IDUM, GM, CDUM)
            END IF
         GO TO 980
C-----------------------------------------------------------------------
C                                       Error handling.
 970  WRITE (MSGTXT,1970) ISTART, INGAUS
      CALL MSGWRT (6)
C
 975  ERRNUM = 101
 980  IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1970 FORMAT ('COMPONENT',I7,' OUT OF RANGE 1 -',I4)
      END

      SUBROUTINE FNDEFF (NIF, FF, RXBAND, NANT, CALIN, BUFF, VEFF)
C-----------------------------------------------------------------------
C! find the efficiencies to apply with these data
C# Utility UV VLA Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2014
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Finds efficiencies from table for EVLA
C   Inputs:
C      NIF      I      Number IFs
C      FF       D(*)   Frequencies of IFs GHz
C      RXBAND   C*(*)  Data are all in this receiver band:
C                         4 P L S C X U K A Q are the known ones
C      NANT     I      Number antennas
C      CALIN    C*48   text file of efficiencies
C   Outputs:
C      BUFF     R(*)   scratch buffer for table reading
C      VEFF     R(*)   Efficiencies (2,MAXIF,MAXANT)
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NIF, NANT
      DOUBLE PRECISION FF(*)
      CHARACTER RXBAND*(*), CALIN*(*)
      REAL      BUFF(3,MAXIF,*), VEFF(2,MAXIF,*)
C                                       default table number values
      INTEGER   NEFF
      PARAMETER (NEFF = 42)
C
      INTEGER   I, J, LUN, LUNTMP, MSGSAV, IANT, KBLIM, KBP, IA, IA1,
     *   IA2, IERR, FIND, JTRIM, LRX
      DOUBLE PRECISION X
      CHARACTER LINE*132
      REAL      TF(NEFF), TE(NEFF), D, W, VV, FREQ, RR, LL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C                                       default table frequencies
      DATA TF / 1.0,  1.1,  1.2,  1.3,  1.4,  1.5,  1.6,  1.7,  1.8,
     *    1.9,  2.0,  2.0,  2.3,  2.7,  3.0,  3.5,  3.7,  4.0,  4.0,
     *    5.0,  6.0,  7.0,  8.0,  8.0, 12.0, 12.0, 13.0, 14.0, 15.0,
     *   16.0, 17.0, 18.0, 19.0, 24.0, 26.0, 26.5, 28.0, 33.0, 38.0,
     *   40.0, 43.0, 48.0/
C                                       Rick Perley efficiencies
      DATA TE /0.45, 0.48, 0.48, 0.45, 0.46, 0.45, 0.43, 0.44, 0.44,
     *   0.49, 0.48, 0.52, 0.52, 0.51, 0.53, 0.55, 0.53, 0.54, 0.55,
     *   0.54, 0.56, 0.62, 0.64, 0.60, 0.60, 0.65, 0.65, 0.62, 0.58,
     *   0.59, 0.60, 0.60, 0.57, 0.52, 0.48, 0.50, 0.49, 0.42, 0.35,
     *   0.29, 0.28, 0.26/
C-----------------------------------------------------------------------
      LRX = JTRIM (RXBAND)
      LUN = LUNTMP (2)
      IERR = -2
      MSGSAV = MSGSUP
      MSGSUP = 32000
      IF (CALIN.NE.' ') THEN
         CALL ZTXOPN ('QRED', LUN, FIND, CALIN, .FALSE., IERR)
         IF (IERR.EQ.0) THEN
            CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
            IF (IERR.EQ.0) THEN
               IF (LINE(:18).NE.'; VLA.EFFICIENCIES') IERR = -1
               END IF
            CALL ZTCLOS (LUN, FIND, I)
            END IF
         END IF
      IF (IERR.NE.0) THEN
         CALIN = 'AIPSIONS:VLA.EFFICIENCIES'
         CALL ZTXOPN ('QRED', LUN, FIND, CALIN, .FALSE., IERR)
         IF (IERR.EQ.0) THEN
            CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
            IF (IERR.EQ.0) THEN
               IF (LINE(:18).NE.'; VLA.EFFICIENCIES') IERR = -1
               END IF
            CALL ZTCLOS (LUN, FIND, I)
            END IF
         END IF
C                                       text file present
      MSGSUP = MSGSAV
      IF (IERR.EQ.0) THEN
         I = 3 * MAXIF * NANT
         CALL RFILL (I, 0.0, BUFF)
         CALL ZTXOPN ('QRED', LUN, FIND, CALIN, .FALSE., IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'RE-OPENING EFFICIENCIES FILE'
            CALL MSGWRT (7)
            GO TO 200
            END IF
 10      CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
         IF (IERR.EQ.0) THEN
            KBLIM = JTRIM (LINE)
            IF ((KBLIM.GT.0) .AND. (LINE(:1).NE.';') .AND.
     *         (RXBAND.EQ.LINE(:LRX))) THEN
C                                       parse
               KBP = LRX + 1
               CALL GETNUM (LINE, KBLIM, KBP, X)
               IF (X.EQ.DBLANK) GO TO 10
               IANT = X + 0.1
               IF (IANT.GT.NANT) GO TO 10
               CALL GETNUM (LINE, KBLIM, KBP, X)
               IF (X.EQ.DBLANK) GO TO 10
               FREQ = X
               CALL GETNUM (LINE, KBLIM, KBP, X)
               IF (X.EQ.DBLANK) GO TO 10
               RR = X
               CALL GETNUM (LINE, KBLIM, KBP, X)
               IF (X.EQ.DBLANK) GO TO 10
               LL = X
               IF (IANT.LE.0) THEN
                  IA1 = 1
                  IA2 = NANT
               ELSE
                  IA1 = IANT
                  IA2 = IANT
                  END IF
               DO 40 IA = IA1,IA2
                  DO 30 I = 1,NIF
                     IF (FREQ.LE.FF(I)) THEN
                        BUFF(1,I,IA) = FREQ
                        BUFF(2,I,IA) = RR
                        BUFF(3,I,IA) = LL
                     ELSE IF (BUFF(1,I,IA).EQ.0.0) THEN
                        BUFF(1,I,IA) = FREQ
                        BUFF(2,I,IA) = RR
                        BUFF(3,I,IA) = LL
                     ELSE IF (BUFF(1,I,IA).GT.0.0) THEN
                        D = FREQ - BUFF(1,I,IA)
                        IF (D.LE.0.0) THEN
                           VEFF(1,I,IA) = (RR + BUFF(2,I,IA)) / 2.0
                           VEFF(2,I,IA) = (LL + BUFF(3,I,IA)) / 2.0
                        ELSE
                           W = (FREQ - FF(I)) / D
                           VEFF(1,I,IA) = W * BUFF(2,I,IA) +
     *                        (1.0-W) * RR
                           VEFF(2,I,IA) = W * BUFF(3,I,IA) +
     *                        (1.0-W) * LL
                           END IF
                        BUFF(1,I,IA) = -1.0
                        END IF
 30                  CONTINUE
 40               CONTINUE
               END IF
            GO TO 10
         ELSE
            CALL ZTCLOS (LUN, FIND, I)
            IF (IERR.NE.2) THEN
               WRITE (MSGTXT,1000) IERR, 'READING EFFICIENCIES FILE'
               CALL MSGWRT (7)
               GO TO 200
            ELSE
               MSGTXT = 'Using efficiencies table from text file'
               CALL MSGWRT (6)
               I = JTRIM (CALIN)
               MSGTXT = '   CALIN = ''' // CALIN(:I) // ''''
               CALL MSGWRT (6)
               IERR = 0
               DO 60 IA = 1,NANT
                  DO 50 I = 1,NIF
                     IF (BUFF(1,I,IA).GT.0.0) THEN
                        VEFF(1,I,IA) = BUFF(2,I,IA)
                        VEFF(2,I,IA) = BUFF(3,I,IA)
                        BUFF(1,I,IA) = -1.0
                        END IF
 50                  CONTINUE
 60               CONTINUE
               END IF
            END IF
         END IF
C                                       default table
 200  IF (IERR.NE.0) THEN
         MSGTXT = 'Using default efficiencies table'
         CALL MSGWRT (6)
         DO 240 I = 1,NIF
            IF (FF(I).LT.TF(1)) THEN
               VV = TE(1)
            ELSE IF (FF(I).GE.TF(NEFF)) THEN
               VV = TE(NEFF)
            ELSE
               DO 210 J = 1,NEFF-1
                  IF ((FF(I).GE.TF(J)) .AND. (FF(I).LT.TF(J+1))) THEN
                     D = TF(J+1) - TF(J)
                     IF (D.LE.0.0) THEN
                        VV = TE(J)
                     ELSE
                        W = (TF(J+1) - FF(I)) / D
                        VV = W * TE(J) + (1.0-W) * TE(J+1)
                        END IF
                     GO TO 220
                     END IF
 210              CONTINUE
               END IF
 220        DO 230 J = 1,NANT
               VEFF(1,I,J) = VV
               VEFF(2,I,J) = VV
 230           CONTINUE
 240        CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FNDEFF: ERROR',I4,1X,A)
      END

      SUBROUTINE FNDVAR (IFIELD, WTIN, IERR)
C-----------------------------------------------------------------------
C! Tim Cornwell routine: Convert errors in Jy/beam to Jy per cell
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Convert errors in Jy/beam into Jy/cell for interferometer images
C
C   Programmer =  T.J. Cornwell      October 1985
C-----------------------------------------------------------------------
      INTEGER   WTIN, IFIELD, JLIM
      REAL      RSWT, RSWTSQ, RNXY, RTEMP
      INTEGER   AKOPEN, AKCESS, AKCLOS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C
      IERR = 0
C
      IF (NY.GE.24096) THEN
         RVAR(IFIELD) = 10.0
         MSGTXT = 'FNDVAR: NY >= 24096!: USING NPOINTS = 10.0'
         CALL MSGWRT (4)
         GO TO 999
         END IF
C
      RSWT   = 0.0
      RSWTSQ = 0.0
      RNXY = REAL(NX)*REAL(NY)
C
      IF (AKOPEN (WTIN, 1, 'READ', BUFFR1).NE.0) GO TO 990
C                                       Begin loop thru map.
      JLIM = NX / 2 + 1
      DO 125 IY = 1,JLIM
         IF (AKCESS(WTIN, BUFFR1).NE.0) GO TO 990
         I1 = BIND(1)
      INCLUDE 'INCS:ZVND.INC'
         DO 120 IX = 1,NY
            RTEMP = BUFFR1(I1)**2 + BUFFR1(I1+1)**2
            RSWT   = RSWT   + SQRT(RTEMP)
            RSWTSQ = RSWTSQ + RTEMP
            I1 = I1 + 2
 120        CONTINUE
 125     CONTINUE
      IF (AKCLOS (WTIN, BUFFR1).NE.0) GO TO 990
C
C
      RSWTSQ = RNXY * RSWTSQ
      RVAR(IFIELD) = SQRT (RSWTSQ / RSWT**2)
C
      GO TO 999
C
 990  WRITE (MSGTXT,1100)
      CALL MSGWRT (8)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('FNDVAR')
      END

      SUBROUTINE AIPINI (TTY, PRGNAM, IERR)
C-----------------------------------------------------------------------
C! does all AIPS initializations for a stand-alone program
C# Service System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This program makes the initializations needed for a stand-alone task
C   using the AIPS data files, I/O system, message loging, etc.  It also
C   opens the terminal for use with ZTTYIO.
C   Inputs:
C      TTY      I(2)   (1) LUN to use for the terminal.
C      PRGNAM   C*6    program name
C   Output:
C      TTY      I(2)   (2) FTAB index of open terminal.
C      IERR     I      Error return - can't open terminal
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   TTY(2), IERR
C
      CHARACTER CANAME*48
      LOGICAL   T, F, FILAI2, FILAIP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Is this 'FILAI2' (only used in
C                                       VMS installation)
      FILAI2 = PRGNAM.EQ.'FILAI2'
C                                       Is this 'FILAIP' (used by non-
C                                       VMS installations)
      FILAIP = PRGNAM.EQ.'FILAIP'
C                                       Device characteristics common
C                                       (get parameters from disk file
C                                       unless this is FILAI2 or FILAIP)
      TSKNAM = PRGNAM
      IF ((FILAI2) .OR. (FILAIP)) THEN
         CALL ZDCHIN (F)
      ELSE
         CALL ZDCHIN (T)
         END IF
C                                       AIPS inits: message common
      CALL ZMYVER
C                                       Create accounting entry (unless
C                                       this is FILAI2 or FILAIP)
      IF ((.NOT.FILAI2) .AND. (.NOT.FILAIP)) CALL ACOUNT (1)
C                                       Image header pointers
      CALL VHDRIN
C                                       If this is VMS specific FILAI2,
C                                       open logical unit 6, else open
C                                       logical unit 5
      IF (FILAI2) THEN
         CALL ZMSGOP (TTY(1), TTY(2), 1, CANAME, IERR)
      ELSE
         CALL ZTTOPN (TTY(1), TTY(2), IERR)
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'NINER.INC'
C                                       Local include for NINER
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO,
     *   CATOLD(256), JBUFSZ, ICODE, SCRTCH(512)
      LOGICAL   DROP1
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, OPCODE*4
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2), XOPCOD(1),
     *   OLDH(256)
      REAL      XSEQIN, XDISKI, XSEQO, XDISKO, BLC(7), TRC(7),
     *   CPARM(10), DPARM(10), BUFF1(MABFSS), BUFF2(MABFSS), OLDR(256)
      DOUBLE PRECISION OLDD(128)
      EQUIVALENCE (CATOLD, OLDR, OLDH, OLDD)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XNAMOU, XCLAOU,
     *   XSEQO, XDISKO, BLC, TRC, XOPCOD, CPARM, DPARM
      COMMON /PNINER/ CATOLD, DROP1, SEQIN, SEQOUT, DISKIN, DISKO,
     *   NEWCNO, OLDCNO, JBUFSZ, ICODE
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, OPCODE
      COMMON /BUFRS/ BUFF1, BUFF2, SCRTCH
      INCLUDE 'INCS:DCAT.INC'
LOCAL END
      PROGRAM NINER
C-----------------------------------------------------------------------
C! Filters an image.
C# MAP Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000, 2008, 2010, 2015, 2022, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   NINER allows a user to apply 3x3 filters to images.  It uses the
C   'scrolling buffer' concept with space for a 3-row buffer.  It
C   provides a framework which allows the implementation of any
C   operator which depends only on the nine pixels of the 3x3 matrix
C   surrounding and including a given pixel position.  NINER can handle
C   up to 7 dimensional images in either integer or real format and
C   supports blanking.  A subimage of the input image may be selected.
C   The various types of filters are listed in the OPCODE section of
C   the HELP file.  The necessary control information can be passed to
C   the program via OPCODE, CPARM, and DPARM.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLAOUT        Class of the output image.
C                                   Default is input class.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      OPCODE         OPCODE        User specified opcode.
C      CPARM(10)      CPARM         User specified array.
C      DPARM(10)      DPARM         User specified array.
C   Written by: Thad A. Polk & Donald C. Wells
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'NINER.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'NINER '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL NININ (PRGM, IRET)
C                                       Call routine that sends data
C                                       to the user routine.
      IF (IRET.EQ.0) CALL NINSND (IRET)
      IF (IRET.EQ.0) CALL NINHIS
C                                       Close down files, etc.
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE NININ (PRGN, IRET)
C-----------------------------------------------------------------------
C   NININ gets input parameters for NINER and creates an output file.
C   Inputs:  PRGN    C*6       Program name
C   Output:  IRET    I         Error code: 0 => ok
C                                4 => user routine detected error.
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in NINER for more details.
C
C-----------------------------------------------------------------------
      CHARACTER  STAT*4, PRGN*6, BLANK*6, MTYPE*2
      INTEGER   IRET, IERR, NPARM, IROUND
      INCLUDE 'NINER.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA BLANK /'      '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 49
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO = IROUND (XDISKO)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, 'READ', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Copy old CATBLK to new.
      CALL COPY (256, CATOLD, CATBLK)
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATOLD(KIDIM), CATOLD(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get user modification to CATBLK
      IRET = 4
      CALL NININI (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create output file.
      NEWCNO = 1
      IRET = 4
      CALL MCREAT (DISKO, NEWCNO, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('NININ: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('NININ: ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE NINSND (IRET)
C-----------------------------------------------------------------------
C   NINSND sends image one row at a time to the user supplied
C   routine and then writes the modified data.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER IFILE*48
      INTEGER   IRET, IROUND, LUNI, LUNO, NYI, NXI, WINI(4), NXO, NYO,
     *   WINO(4), BOI, BOO, LIM2, LIM3, LIM4, LIM5, LIM6, LIM7, I1, I2,
     *   I3, I4, I5, I6, I7, IPOS(7), CORN(7), BOTEMP, KOFF, LIMO,
     *   LIMIT, IBIND, OBIND, INDI, INDO, LIM1, DIDRET, OUTCNT
      LOGICAL   T, F, BLNKD
      INCLUDE 'NINER.INC'
      REAL      OUTMAX, OUTMIN, RDATA(MAXIMG)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNI, LUNO /16,17/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Setup for I/O
      NXI = CATOLD(KINAX)
      NYI = CATOLD(KINAX+1)
      NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      OUTMAX = -1.0E20
      OUTMIN = 1.0E20
      BLNKD = F
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
      KOFF = 0
      IF (DROP1) KOFF = -1
      CORN(7) = 1
      LIMO = CATBLK(KINAX) - 1
      IF (DROP1) LIMO = 0
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         CORN(7+KOFF) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            CORN(6+KOFF) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               CORN(5+KOFF) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  CORN(4+KOFF) = I4
                  DO 300 I3 = 1,LIM3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     CORN(3+KOFF) = I3
C                                       Init. files, first input.
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1099) IRET
            GO TO 990
            END IF
         BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'READ', IRET
            GO TO 990
            END IF
C                                       Init output file.
         IF ((.NOT.DROP1) .OR. (I3.LE.1)) THEN
            CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORN(3), BOTEMP,
     *         IRET)
            BOO = BOTEMP + 1
            CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO, BUFF2,
     *         JBUFSZ, BOO, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1100) 'WRIT', IRET
               GO TO 990
               END IF
            END IF
         DIDRET = 0
         OUTCNT = LIM2
         DO 220 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
C                                       Read.
            CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'READ', IRET
               GO TO 990
               END IF
C                                       Copy to buffer.
            DO 165 I1 = 1,LIM1
               RDATA(I1) = BUFF1(IBIND+I1-1)
 165           CONTINUE
C                                       Write.
C                                       Check for deferred output.
            IF (((.NOT.DROP1) .OR. (I2.LE.1)) .AND. (DIDRET.GE.0)) THEN
               CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IRET)
               OBIND = OBIND - 1
               OUTCNT = OUTCNT - 1
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1120) 'WRIT', IRET
                  GO TO 990
                  END IF
               END IF
C                                       Call DONINE
            IF (DIDRET.GE.0) OBIND = OBIND + 1
            CALL DONINE (IPOS, RDATA, BUFF2(OBIND), IRET)
            DIDRET = IRET
C                                       error
            IF (DIDRET.GT.0) THEN
               WRITE (MSGTXT,1180) IRET
               GO TO 990
C                                       Check max, min, blanking.
C                                       output not deferred
            ELSE IF (DIDRET.EQ.0) THEN
               LIMIT = OBIND + LIMO
               DO 200 I1 = OBIND,LIMIT
                  BLNKD = BLNKD .OR. (BUFF2(I1).EQ.FBLANK)
                  IF (BUFF2(I1).NE.FBLANK) THEN
                     OUTMAX = MAX (OUTMAX, BUFF2(I1))
                     OUTMIN = MIN (OUTMIN, BUFF2(I1))
                     END IF
 200              CONTINUE
               END IF
 220        CONTINUE
C                                       Read out any remaining rows
C                                       from DONINE.
         DO 260 I2 = 1,OUTCNT
            IPOS(1) = -1
C                                       Check if write requested.
            IF (.NOT.DROP1) THEN
               CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IRET)
               OBIND = OBIND - 1
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1120) 'WRIT', IRET
                  GO TO 990
                  END IF
               END IF
C                                       Call DONINE
            OBIND = OBIND + 1
            CALL DONINE (IPOS, RDATA, BUFF2(OBIND), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1180) IRET
               GO TO 990
               END IF
C                                       Check max, min, blanking.
            LIMIT = OBIND + LIMO
            DO 250 I1 = OBIND,LIMIT
               BLNKD = BLNKD .OR. (BUFF2(I1).EQ.FBLANK)
               IF (BUFF2(I1).NE.FBLANK) THEN
                  OUTMAX = MAX (OUTMAX, BUFF2(I1))
                  OUTMIN = MIN (OUTMIN, BUFF2(I1))
                  END IF
 250           CONTINUE
 260        CONTINUE
C                                       Flush buffer.
         IF ((.NOT.DROP1) .OR. (I3.GE.LIM3)) THEN
            CALL MDISK ('FINI', LUNO, INDO, BUFF2, OBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'FINI', IRET
               GO TO 990
               END IF
C                                       Update CATBLK.
            CATR(KRDMX) = OUTMAX
            CATR(KRDMN) = OUTMIN
            CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRTCH,
     *         IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1260) IRET
               GO TO 990
               END IF
            END IF
 300     CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Mark blanking in CATBLK.
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
C                                       Close input map.
      CALL ZCLOSE (LUNI, INDI, IRET)
C                                       Final call to functions
      IPOS(1) = -2
      CALL DONINE (IPOS, RDATA, BUFF2, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1180) IRET
         GO TO 990
         END IF
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('NINSND: ERROR',I3,' OPENING INPUT FILE')
 1020 FORMAT ('NINSND: ERROR',I5,' OPENING OUTPUT FILE')
 1099 FORMAT ('NINSND: COMOF3 ERROR',I3)
 1100 FORMAT ('NINSND: INIT-FOR-',A4,' ERROR',I3)
 1120 FORMAT ('NINSND: ',A4,' ERROR',I3)
 1180 FORMAT ('NINSND: DONINE ERROR',I3)
 1260 FORMAT ('NINSND: CATIO ERROR',I3,' UPDATING CATBLK')
      END
      SUBROUTINE NINHIS
C-----------------------------------------------------------------------
C   NINHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, NOTTYP*2
      INTEGER   LUN1, LUN2, IERR
      LOGICAL   T
      INCLUDE 'NINER.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NOTTYP /'CC'/
C-----------------------------------------------------------------------
C                                       copy most header keywords
      CALL KEYPCP (DISKIN, OLDCNO, DISKO, NEWCNO, 0, ' ', IERR)
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   SCRTCH(257), SCRTCH, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 20
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, SCRTCH,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       BLC
      WRITE (HILINE,2000) TSKNAM, BLC
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       TRC
      WRITE (HILINE,2001) TSKNAM, TRC
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       OPCODE
      WRITE (HILINE,2002) TSKNAM, OPCODE
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       Close HI file
 20   CALL HICLOS (LUN2, T, SCRTCH, IERR)
C                                        Copy tables
      CALL ALLTAB (1, NOTTYP, LUN1, LUN2, DISKIN, DISKO, OLDCNO,
     *   NEWCNO, CATBLK, SCRTCH(257), SCRTCH, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('NINHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 2000 FORMAT (A6,' BLC =',6(F6.0,','),F6.0)
 2001 FORMAT (A6,' TRC =',6(F6.0,','),F6.0)
 2002 FORMAT (A6,' OPCODE = ''',A4,'''')
      END
      SUBROUTINE NININI (IRET)
C-----------------------------------------------------------------------
C   NININI is a routine in which the user performs several operations
C   associated with beginning the task.
C   The following functions are performed in NININI:
C       1) Modifying the catalog header block to represent the
C   output file.
C       2) Checking the input image and/or input parameters.
C   A returned value of IRET .NE. 0 will cause the task to terminate.
C       3) Setting default values of some of the input parameters
C   (OUTNAME, OUTCLASS, OUTSEQ, OUTDISK, TRC and BLC defaults are
C   set elsewhere).  As currently set the default OPCODE is the
C   first value in the array CODES which is set in a data statment.
C
C    Input:
C     CATBLK(256)    I     Output catalog header, also CATR, CATD
C     CATOLD(256)    I     Input catalog header, also OLDR, OLDD
C    Output:
C     CATBLK(256)    I     Modified output catalog header.
C     IRET           I     Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER FCHARS(3)*4, BLANK*8, CHTMP*4, CODES(15)*4
      INTEGER   LIMIT, I, FIRSTI, FIRSTO, IRET
      INTEGER   NCODE, INDXI, INDEX
      LOGICAL   LDROP1
      INCLUDE 'NINER.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA FCHARS /'FREQ','VELO','FELO'/
      DATA BLANK /'        '/
C                                       # and value of OPCODEs
      DATA NCODE /15/
      DATA CODES /'SOBL', 'KRSH', 'WALL', 'NINE', 'NORT','NE  ',
     *    'EAST','SE  ', 'SOUT', 'SW  ', 'WEST', 'NW  ','MSK1',
     *    'MSK2','MSK3'/
C                                       If LDROP1 is .TRUE. then the
C                                       first axis will be dropped,
C                                       (ie, one value results from
C                                       the operation on each row.)
      DATA LDROP1 /.FALSE./
C-----------------------------------------------------------------------
C                                       Set DROP1
      DROP1 = LDROP1
C                                       Set default OPCODE
      ICODE = 1
      DO 10 I = 1,NCODE
         ICODE = I
         IF (OPCODE.EQ.CODES(I)) GO TO 50
 10      CONTINUE
C                                       Default OPCODE is first.
      OPCODE = CODES(1)
      ICODE = 1
C                                       Set axes in output CATBLK.
 50   FIRSTI = -1
      FIRSTO = -1
      LIMIT = CATOLD(KIDIM)
      IF (DROP1) THEN
         LIMIT = LIMIT - 1
         FIRSTI = 0
         END IF
C                                       Copy/update axis values
      DO 80 I = 1,LIMIT
         CATBLK(KINAX+FIRSTO+I) = TRC(I+FIRSTI+1) -
     *      BLC(I+FIRSTI+1) + 1.01
         CATR(KRCRP+FIRSTO+I) = OLDR(KRCRP+FIRSTI+I) - BLC(I+FIRSTI+1)
     *      + 1.0
         CATR(KRCIC+FIRSTO+I) = CATR(KRCIC+FIRSTI+I)
         CATD(KDCRV+FIRSTO+I) = OLDD(KDCRV+FIRSTI+I)
         INDXI = KHCTP + (I+FIRSTI) * 2
         INDEX = KHCTP + (I-1) * 2
         CALL CHCOPY (8, 1, OLDH(INDXI), 1, CATH(INDEX))
         IF (CATBLK(KIALT).NE.0) THEN
            CALL H2CHR (4, 1, CATH(INDEX), CHTMP)
            IF ((CHTMP.EQ.FCHARS(1)) .OR. (CHTMP.EQ.FCHARS(2)) .OR.
     *         (CHTMP.EQ.FCHARS(3))) CATR(KRARP) = CATR(KRARP) -
     *         BLC(FIRSTI+I+1) + 1.0
            END IF
 80      CONTINUE
C                                       If DROP1 reset CATBLK(KIDIM)
C                                       and blank last axis type.
      IF (DROP1) THEN
         CATBLK(KIDIM) = CATOLD(KIDIM) - 1
         INDEX = KHCTP + CATBLK(KIDIM) * 2
         CALL CHR2H (8, BLANK, 1, CATH(INDEX))
         INDEX = CATBLK(KIDIM)
         CATD(KDCRV+INDEX) = 0.0D0
         CATR(KRCRP+INDEX) = 0.0
         CATR(KRCIC+INDEX) = 0.0
         CATBLK(KINAX+INDEX) = 0
         END IF
C                                       Set output image type
C                                       Put other checks here.
C                                       Finished.
      IRET = 0
C
 999  RETURN
      END
      SUBROUTINE DONINE (IPOS, RDATA, RESULT, IRET)
C-----------------------------------------------------------------------
C   This subroutine allows operations on an image one row at a time.
C   Input RDATA are Real with blanking if necessary; output values
C   are R   which may also be blanked.  The calling routine keeps track
C   of max., min. and the occurence of blanking.  CATBLK(KINAX) values
C   per call are expected returned.
C   NOTE: blanked values are denoted by the value of the common variable
C   FBLANK.
C       DONINE accumulates a scrolling buffer by returning a negative
C   value of IRET.  This tells the calling routine to defer writing the
C   next row.  When rows are deferred an equal number of calls to
C   DONINE will be made with no input data; this allows reading out any
C   rows left in DONINEs internal buffers.  Such a "no input call" is
C   indicated by a value of IPOS(1) of -1.  The writing of the returned
C   values of these "no input calls" is NOT deferred.
C
C       If IRET .GT. 0 then the output file will be destroyed.
C
C       The current contents of CATBLK will be written back to the
C   catalog after the last call to DONINE.
C
C   Inputs:
C      IPOS(7)   I    BLC (input image) of first value in RDATA
C                     IPOS(1) = -1 => no input data this call.
C                     IPOS(2) = -2 => last call (no input data).
C      RDATA(*)   R    Input row, magic value blanked.
C   Values from commons:
C      ICODE     I    Opcode number from list in NININI.
C      FBLANK    R    Value of blanked pixel.
C      CPARM(10) R    Input adverb array.
C      DPARM(10) R    Input adverb array.
C      CATBLK    I    Output catalog header (also CATR, CATD)
C      CATOLD    I    Input catalog header (also OLDR, OLDD)
C      DROP1     L    True if one output value per call.
C   Output:
C      RESULT(*) R    Output row.
C      IRET      I    Return code   0 => OK
C                               >0 => error, terminate.
C   Output in COMMON
C     CATBLK     I    Catalog header block
C-----------------------------------------------------------------------
      INTEGER   IRET, IPOS(7)
      REAL      RDATA(*), RESULT(*)
      INTEGER   LROW, I, J, K, I3, J3, IBLC1
      LOGICAL   PRTD
      INCLUDE 'NINER.INC'
      REAL      WSUM, DSUM, MAXDIF, WSUM9, RIGHT, LEFT, XSUM, TOP,
     *   BOTTOM, YSUM, SSUM, TSUM, BUFFER(MAXIMG,3), BLKARR(MAXIMG),
     *   WINDOW(9), WIND33(3,3), FILT(9,11), PRODCT
      SAVE LROW, IBLC1, PRTD, WSUM9, BLKARR, BUFFER
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (WIND33, WINDOW)
C                                       Each row is a built-in filter
      DATA FILT / 1.,  1.,  1.,  1., -2.,  1., -1., -1., -1.,
     *            1.,  1.,  1., -1., -2.,  1., -1., -1.,  1.,
     *           -1.,  1.,  1., -1., -2.,  1., -1.,  1.,  1.,
     *           -1., -1.,  1., -1., -2.,  1.,  1.,  1.,  1.,
     *           -1., -1., -1.,  1., -2.,  1.,  1.,  1.,  1.,
     *            1., -1., -1.,  1., -2., -1.,  1.,  1.,  1.,
     *            1.,  1., -1.,  1., -2., -1.,  1.,  1., -1.,
     *            1.,  1.,  1.,  1., -2., -1.,  1., -1., -1.,
     *            0., -1.,  0., -1.,  4., -1.,  0., -1.,  0.,
     *           -1., -1., -1., -1.,  8., -1., -1., -1., -1.,
     *            1., -2.,  1., -2.,  4., -2.,  1., -2.,  1./
C-----------------------------------------------------------------------
      IRET = 0
C                                       Check if last call (no input
C                                       data).
      IF (IPOS(1).LE.-2) GO TO 900
C                                       Check if first call per plane.
      IF (IPOS(2).LE.BLC(2)) THEN
C                                       First call per plane.
C                                       Initialize row length, WSUM,
C                                       and CPARM's.
         LROW = (TRC(1) - BLC(1) + 1.01)
         IBLC1 = BLC(2) + 0.1
         PRTD = .FALSE.
C                                       Get appropriate data for filter
         IF ((ICODE.GE.5) .AND. (ICODE.LE.15)) THEN
            DO 40 J = 1,9
               CPARM(J) = FILT(J,ICODE-4)
  40           CONTINUE
            END IF
         IF ((ICODE.GE.4) .AND. (ICODE.LE.15)) THEN
            WSUM9 = 0.0
            DO 80 J = 1,9
               WSUM9 = WSUM9 + CPARM(J)
  80           CONTINUE
            END IF
C                                       Initialize blank array
         DO 120 I = 1,LROW
            BLKARR(I) = FBLANK
 120        CONTINUE
         DO 130 I = 2,3
            CALL RCOPY (LROW, BLKARR, BUFFER(1, I))
 130        CONTINUE
         END IF
C                                       Branch here for subsequent
C                                       calls.
C                                       Print out row number every
C                                       tenth row if appropriate
      IF ((MOD(IPOS(2),100).EQ.0) .AND. (IPOS(2).GE.IBLC1) .AND.
     *   (IPOS(2).LE.TRC(2)) .AND. (DPARM(2).NE.-1) .AND. (.NOT.PRTD))
     *   THEN
         WRITE (MSGTXT,1000) IPOS(2)
         CALL MSGWRT (4)
         IF (IPOS(2).EQ.TRC(2)) PRTD = .TRUE.
         END IF
C                                       Copy top two vectors into bottom
C                                       two vectors of buffer array
      DO 140 I = 1,2
         CALL RCOPY (LROW, BUFFER(1, I+1), BUFFER(1, I))
 140     CONTINUE
C                                       No input, copy blanks into
C                                       buffer array
      IF (IPOS(1).LT.0) THEN
         CALL RCOPY (LROW, BLKARR, BUFFER(1, 3))
C                                       Copy data into buffer array
      ELSE
         CALL RCOPY (LROW, RDATA, BUFFER(1, 3))
         END IF
C                                       Defer call
      IF ((IPOS(2).LE.IBLC1) .AND. (IPOS(1).NE.-1)) THEN
         IRET = -1
         GO TO 999
         END IF
      DO 500 I = 1,LROW
C                                       Form window array
         DO 190 J3 = 1,3
            DO 180 I3 = 1,3
               IF ((I.LE.1) .AND. (I3.LE.1)) THEN
                  WIND33(I3,J3) = FBLANK
               ELSE IF ((I.GE.LROW) .AND. (I3.GE.3)) THEN
                  WIND33(I3,J3) = FBLANK
               ELSE
                  WIND33(I3, J3) = BUFFER(I - 2 + I3, J3)
                  END IF
 180           CONTINUE
 190        CONTINUE
C                                       'SOBL' branch - default
         IF ((ICODE.GT.15) .OR. (ICODE.LT.2)) THEN
            DO 200 J = 1,9
               IF (WINDOW(J).EQ.FBLANK) GO TO 395
 200           CONTINUE
            RIGHT = WINDOW(3) + 2*WINDOW(6) + WINDOW(9)
            LEFT = WINDOW(1) + 2*WINDOW(4) + WINDOW(7)
            XSUM = RIGHT - LEFT
            TOP = WINDOW(1) + 2*WINDOW(2) + WINDOW(3)
            BOTTOM = WINDOW(7) + 2*WINDOW(8) + WINDOW(9)
            YSUM = TOP - BOTTOM
            RESULT(I) = SQRT(XSUM**2 + YSUM**2) + WINDOW(5)*DPARM(1)
C                                       'KRSH' branch
         ELSE IF (ICODE.EQ.2) THEN
C                                       Find max of 5*SSUM - 3*TSUM
            DO 210 J = 1,9
               IF (WINDOW(J).EQ.FBLANK) GO TO 395
 210           CONTINUE
            MAXDIF = 0.0
            I3 = 1
            J3 = 1
            SSUM = 0.0
            TSUM = 0.0
            DO 245 K = 1,8
               MAXDIF = MAX (MAXDIF, ABS(5*SSUM - 3*TSUM))
               SSUM = 0.0
               TSUM = 0.0
               DO 240 J = 1,9
                  IF (J.LE.3) THEN
                     SSUM = SSUM + WIND33(I3, J3)
                  ELSE IF (J.LE.8) THEN
                     TSUM = TSUM + WIND33(I3, J3)
                     END IF
                  IF ((J3.EQ.1) .AND. (I3.NE.3)) THEN
                     I3 = I3 + 1
                  ELSE IF ((I3.EQ.3) .AND. (J3.NE.3)) THEN
                     J3 = J3 + 1
                  ELSE IF ((J3.EQ.3) .AND. (I3.NE.1)) THEN
                     I3 = I3 - 1
                  ELSE
                     J3 = J3 - 1
                     END IF
 240              CONTINUE
 245           CONTINUE
            RESULT(I) = MAX (1.0, MAXDIF)
            RESULT(I) = MAXDIF
C                                       'WALL' branch
         ELSE IF (ICODE.EQ.3) THEN
            IF ((WINDOW(5).EQ.FBLANK).OR.(WINDOW(5).LE.0.0)) GO TO 395
            DO 260 J = 2,8,2
               IF (WINDOW(J).EQ.FBLANK) GO TO 395
 260           CONTINUE
            PRODCT = WINDOW(2)*WINDOW(4)*WINDOW(6)*WINDOW(8)
            IF (PRODCT.LE.0.0) GO TO 395
            RESULT(I) = 0.25 * LOG10 ((WINDOW(5)**4)/ PRODCT)
C
C
C                                       Normal area operator branch
C
         ELSE IF (WSUM9.NE.0.0) THEN
C                                       Non-zero integral case
C                                       Form weighted sum
            WSUM = 0.0
            DSUM = 0.0
            DO 370 J = 1, 9
               IF (WINDOW(J).NE.FBLANK) THEN
                  WSUM = WSUM + CPARM(J)
                  DSUM = DSUM + CPARM(J) * WINDOW(J)
                  END IF
 370           CONTINUE
            IF ((WSUM.EQ.0.0).OR.(WINDOW(5).EQ.FBLANK)) GO TO 395
               RESULT(I) = (DSUM / WSUM) + WINDOW(5)*DPARM(1)
C                                       Zero integral case
         ELSE
            DSUM = 0.0
            DO 390 J = 1, 9
               IF (WINDOW(J).EQ.FBLANK) GO TO 395
               DSUM = DSUM + CPARM(J) * WINDOW(J)
 390           CONTINUE
            RESULT(I) = DSUM + WINDOW(5)*DPARM(1)
            END IF
         GO TO 500
C                                       blank output
 395     RESULT(I) = FBLANK
 500     CONTINUE
      GO TO 999
C                                       Last call - do history etc.
 900  CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Currently on row number', I6)
      END

LOCAL INCLUDE 'ANTAB.INC'
C                                       Include ANTAB
C                                       Local include for ANTAB;
C                                       requires PUVD.INC
      INTEGER MXFQID
C                                       Max. no. of FQ IDs
      PARAMETER (MXFQID = 25)
C
      HOLLERITH XNAMEI(3), XCLAIN(2), XINFIL(12)
C                                       extra stations to ignore
      INTEGER NIGNOR
      PARAMETER (NIGNOR = 10)
      HOLLERITH HIGNOR(2,NIGNOR)
      CHARACTER CIGNOR(NIGNOR)*8
      COMMON /MJUN2/ CIGNOR
C
      CHARACTER LNAME*12, LCLASS*6, LINFIL*48
      REAL XINDIS, XINSEQ, XSUBA, XTYVER, XGCVER, XBLVER, XPRTLV,
     *   XOFFS, DELTAT
      INTEGER INDISK, INSEQ, ISUBA, ITYVER, IGCVER, IBLVER, IPRTLV
C                                       Input parameters
      COMMON /INPARM/ XNAMEI, XCLAIN, XINSEQ, XINDIS, XINFIL,
     *   XSUBA, XTYVER, XGCVER, XBLVER, HIGNOR, XPRTLV, XOFFS
      COMMON /INVAL/ INSEQ, INDISK, ISUBA, ITYVER, IGCVER, IBLVER,
     *   IPRTLV, DELTAT
      COMMON /CHVAL/ LNAME, LCLASS, LINFIL
C                                       Buffers
      INTEGER BUFF1(512), BUFF2(512)
      COMMON /WRKBUF/ BUFF1, BUFF2
C                                       General global variables
      LOGICAL WBFAC, WGAIN, WTSYS
      INTEGER IFQUV(MXFQID), NFQUV, ILUNF, IFINDF, ICNO, NIFUV,
     *   NPOLUV, IPOLUV, ILUN1, ILUN2, IGCTMP, ITYTMP, IREFDY,
     *   ILOYR, IGCVIN, ITYVIN, IDATE(3)
      COMMON /GLBLVR/ IFQUV, NFQUV, ILUNF, IFINDF, ICNO, NIFUV,
     *   NPOLUV, IPOLUV, ILUN1, ILUN2, IGCTMP, ITYTMP, IREFDY,
     *   ILOYR, IGCVIN, ITYVIN, WBFAC, WGAIN, WTSYS, IDATE
C                                       Index table
      INTEGER MAXNX
      PARAMETER (MAXNX = 524288)
      REAL TIMENX(2, MAXNX)
      INTEGER INXSOU(MAXNX), INXFQ(MAXNX), NXDAT
      COMMON /NXCOM/ TIMENX, INXSOU, INXFQ, NXDAT
C                                       FQ information
      DOUBLE PRECISION DFRQTB(MXFQID,MAXIF,2)
      COMMON /FQCOM/ DFRQTB
C                                       Baseline factors
      REAL BFAC(MAXANT,MAXANT)
      COMMON /BSLCOM/ BFAC
LOCAL END
LOCAL INCLUDE 'DUM.INC'
      INTEGER   MXDUM
      PARAMETER (MXDUM = 16000000)
      DOUBLE PRECISION DUMMY(MXDUM)
      COMMON /DUMCOM/ DUMMY
LOCAL END
      PROGRAM ANTAB
C-----------------------------------------------------------------------
C! Read VLBI amplitude calibration file into AIPS.
C# UV Calibration EXT-util VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1999, 2005, 2007, 2010-2015, 2022, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task ANTAB read a user-supplied amplitude calibration text file
C   and updates the TY, GC and BL tables accordingly.
C   Inputs:
C      AIPS adverb      Local var.     Description
C      INNAME           LNAME          Input uv file name
C      INCLASS          LCLASS         Class of input uv file.
C      INSEQ            INSEQ          Seq. no. of input uv file.
C      INDISK           INDISK         Disk no. of input file.
C      INFILE           LINFIL         Ext. calibration file name.
C      SUBARRAY         ISUBA          Subarray number.
C      TYVER            ITYVER         TY table to update (Tsys)
C      GCVER            IGCVER         GC table to update (gains)
C      BLVER            IBLVER         BL table to update (basl.)
C      PRTLEV           IPRTLV         Print/debug level.
C----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ANTAB.INC'
      CHARACTER LPGM*6
      INTEGER   IRET, NTABGC
      DATA LPGM /'ANTAB '/
C----------------------------------------------------------------------
C                                       Get input parameters and perform
C                                       general initialisation.
      CALL ANTBIN (LPGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Read calibration information
C                                       from the aux. text file.
C                                       get size of GC table
      CALL TXTCHK (NTABGC, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Read calibration information
C                                       from the aux. text file.
C                                       write to GC and TY tables
      CALL TXTCAL (NTABGC, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Consolidate TY, BL and GC tables
      CALL TBCONS (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Update history file
      CALL ANTBHI (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Close down files/exit
990   CALL DIE (IRET, BUFF1)
C
999   STOP
      END
      SUBROUTINE ANTBIN (LPGM, IRET)
C-----------------------------------------------------------------------
C   Read input parameters for ANTAB and perform general initialisation.
C   Inputs:
C      LPGM    C*6  Task name.
C   Outputs:
C      IRET    I    Return code (0 => ok.)
C-----------------------------------------------------------------------
      CHARACTER LPGM*6
      INTEGER IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ANTAB.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DMSG.INC'
      LOGICAL WTRUE, WFALSE, WTABLE, WEXIST, WFITS, WMULTI
      CHARACTER LSTAT*4, LTYPE*2, LDATE*8
      INTEGER NPARM, IERR, I
      DATA WTRUE, WFALSE /.TRUE., .FALSE./
C-----------------------------------------------------------------------
      IRET = 0
C                                       LUN for reading text file
      ILUNF = 10
C                                       Assign general LUNs for
C                                       table I/O.
      ILUN1 = 27
      ILUN2 = 28
C                                       Initialise AIPS from disk
      CALL ZDCHIN (WTRUE, BUFF1)
C                                       Compute pointers for catalog
C                                       records.
      CALL VHDRIN
C                                       Initialise /CFILES/
      NSCR = 0
      NCFILE = 0
C
      NPARM = 25 + 2*NIGNOR
      CALL GTPARM (LPGM, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = WTRUE
         IRET = 1
C                                       Check if intiator (AIPS)
C                                       not found.
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IERR.NE.0) IRET = 1
C                                       Abort if error obtaining
C                                       input parameters.
      IF (IRET.NE.0) GO TO 999
C                                       Convert input parameters.
      CALL H2CHR (12, 1, XNAMEI, LNAME)
      CALL H2CHR (6, 1, XCLAIN, LCLASS)
      CALL H2CHR (48, 1, XINFIL, LINFIL)
      DO 1 I = 1,NIGNOR
         CALL H2CHR (8, 1, HIGNOR(1,I), CIGNOR(I))
 1       CONTINUE
      INSEQ = XINSEQ
      INDISK = XINDIS
      ISUBA = XSUBA
      ISUBA = MAX (ISUBA, 1)
      ITYVER = XTYVER
      ITYVER = MAX (ITYVER, 0)
      ITYVIN = ITYVER
      IGCVER = XGCVER
      IGCVER = MAX (IGCVER, 0)
      IGCVIN = IGCVER
      IBLVER = XBLVER
      IBLVER = MAX (IBLVER, 0)
      IPRTLV = XPRTLV
C                                       increasing scans in minutes
      DELTAT = XOFFS/(60*24)
C                                       Find u-v file in catalog dir.
      LSTAT = 'SRCH'
      LTYPE = 'UV'
      ICNO = 1
      CALL CATDIR ('SRCH', INDISK, ICNO, LNAME, LCLASS, INSEQ, LTYPE,
     *   NLUSER, LSTAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR, LNAME, LCLASS, INSEQ, INDISK
         IRET = 2
         GO TO 990
         END IF
C                                       Read catalog header; mark
C                                       file status as 'WRITE'
      CALL CATIO ('READ', INDISK, ICNO, CATBLK, 'WRIT', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR, LNAME, LCLASS, INSEQ, INDISK
         IRET = 3
         GO TO 990
         END IF
C                                       Add to /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = INDISK
      FCNO(NCFILE) = ICNO
      FRW(NCFILE) = 1
C                                       Get u-v header information.
      CALL UVPGET (IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         IRET = 4
         GO TO 990
         END IF
C                                       cannot do multiple subarray data
      CALL FNDEXT ('AN', CATBLK, I)
      IF (I.GT.1) THEN
         MSGTXT = 'I DO NOT DO MULTIPLE SUBARRAY DATA WELL'
         CALL MSGWRT (6)
         MSGTXT = 'RUN ANTAB ONCE FOR EACH SUBARRAY IN THE DATA SET'
         CALL MSGWRT (6)
         MSGTXT = 'IT IS BETTER TO USE ANTAB BEFORE USUBA OR DBCON'
         CALL MSGWRT (6)
         END IF
C                                       Multi-source or single source ?
      CALL MULSDB (CATBLK, WMULTI)
      IF (WMULTI) THEN
         CALL ISTAB ('SU', INDISK, ICNO, 1, ILUN1, BUFF1, WTABLE,
     *      WEXIST, WFITS, IERR)
         WMULTI = WTABLE .AND. WEXIST .AND. (IERR.EQ.0)
         END IF
      IF (.NOT.WMULTI) THEN
         WRITE (MSGTXT,1080)
         IRET = 5
         GO TO 990
         END IF
C                                       Read NX table into memory
      CALL NXREAD (IERR)
      IF (IERR.NE.0) THEN
         IRET = 6
         GO TO 999
         END IF
C                                       Read FQ table information
      CALL FQREAD (IRET)
      IF (IERR.NE.0) THEN
         IRET = 7
         GO TO 999
         END IF
C                                       Read AN table information
      CALL GETANT (INDISK, ICNO, ISUBA, CATBLK, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IRET = 8
         GO TO 999
         END IF
C                                       Open calibration text file.
      CALL ZTXOPN ('READ', ILUNF, IFINDF, LINFIL, WFALSE, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1100) IERR, LINFIL
         IRET = 9
         GO TO 990
         END IF
C                                       Extract reference date and
C                                       calculate reference day no.
      CALL H2CHR (8, 1, CATH(KHDOB), LDATE)
      CALL DATEST (LDATE, IDATE)
      CALL DAYYR (IDATE(1), IDATE(2), IDATE(3), IREFDY, ILOYR)
C                                       Determine FQ-ID/IF/polzn. ranges
C                                       in the uv-data file and so
C                                       determine the ranges in the
C                                       associated tables.
      IF (JLOCIF.GT.0) THEN
         NIFUV = CATBLK(KINAX+JLOCIF)
      ELSE
         NIFUV = 1
         END IF
      IF (JLOCS.GT.0) THEN
         NPOLUV = MIN (2, CATBLK(KINAX+JLOCS))
      ELSE
         NPOLUV = 1
         END IF
      IPOLUV = 1
C                                       First polzn (RCP,Xlin) = 1
      IF ((ICOR0.EQ.-1).OR.(ICOR0.EQ.-5)) IPOLUV = 1
C                                       (LCP,Ylin) = 2
      IF ((ICOR0.EQ.-2).OR.(ICOR0.EQ.-6)) IPOLUV = 2
C                                       For all multi-Stokes datasets
C                                       expect both R and L in the
C                                       tables.
      IF (NPOLUV.GT.1) IPOLUV = 1
C
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C
999   RETURN
C-----------------------------------------------------------------------
1000  FORMAT ('ANTBIN: ERR',I3,' OBTAINING INPUT PARAMETERS')
1020  FORMAT ('ANTBIN: ERR',I3,' FINDING ',A12,'.',A6,'.',I4,'.',I3)
1040  FORMAT ('ANTBIN: ERR',I3,' READING HEADER ',A12,'.',A6,'.',I4,
     *   '.',I3)
1060  FORMAT ('ANTBIN: ERR',I3,' DECODING HEADER')
1080  FORMAT ('ANTBIN: FILE NOT MULTI-SOURCE OR BAD SU TABLE')
1100  FORMAT ('ANTBIN: ERR',I3,' OPENING ',A48)
      END
      SUBROUTINE NXREAD (IRET)
C-----------------------------------------------------------------------
C   Subroutine to read the NX table into memory
C   Outputs:
C      IRET    I    Return code (0 => ok)
C-----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ANTAB.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      LOGICAL WTABLE, WEXIST, WFITS
      REAL TIME, TINT
      INTEGER NXKOLS(MAXNXC), NXNUMV(MAXNXC), IERR, I, INXRNO, IDSOUR,
     *   ISUBNX, ISTART, IEND, IFQID, NROW, NVISMX, J
C-----------------------------------------------------------------------
C                                       Initialisation
      IRET = 0
      NXDAT = 0
C                                       Does an NX table exist ?
      CALL ISTAB ('NX', INDISK, ICNO, 1, ILUN1, BUFF1, WTABLE, WEXIST,
     *   WFITS, IERR)
      IF ((IERR.NE.0).OR.(.NOT.(WEXIST.AND.WTABLE))) THEN
         IRET = 1
         WRITE (MSGTXT,1020)
         GO TO 990
         END IF
C                                       Open the NX table
      CALL NDXINI ('READ', BUFF1, INDISK, ICNO, 1, CATBLK, ILUN1,
     *   INXRNO, NXKOLS, NXNUMV, IERR)
      IF (IERR.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Read table into memory
      NROW = BUFF1(5)
      NVISMX = 0
      DO 100 I = 1, NROW
         CALL TABNDX ('READ', BUFF1, INXRNO, NXKOLS, NXNUMV, TIME,
     *      TINT, IDSOUR, ISUBNX, ISTART, IEND, IFQID, IERR)
C                                       Record de-selected ?
         IF (IERR.EQ.-1) GO TO 100
         IF (IERR.NE.0) THEN
            IRET = 3
            WRITE (MSGTXT,1100) IERR
            GO TO 990
            END IF
C                                       Update maximum vis. no.
         NVISMX = MAX (NVISMX, IEND)
C                                       Correct subarray ?
         IF (ISUBNX.NE.ISUBA) GO TO 100
C                                       NX buffer too small ?
         NXDAT = NXDAT + 1
         IF (NXDAT.GT.MAXNX) THEN
            IRET = 4
            WRITE (MSGTXT,1120)
            GO TO 990
            END IF
C
         TIMENX(1,NXDAT) = TIME - TINT / 2.0
         TIMENX(2,NXDAT) = TIME + TINT / 2.0
         INXSOU(NXDAT) = IDSOUR
         INXFQ(NXDAT) = IFQID
100      CONTINUE
C                                       Close NX table
      CALL TABIO ('CLOS', 0, INXRNO, BUFF2, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IRET = 4
         WRITE (MSGTXT,1140) IERR
         GO TO 990
         END IF
C                                       Determine whether NX table is
C                                       current by matching Nvis in
C                                       catalog hdr. with NVISMX from
C                                       NX table.
      IF (NVISMX.NE.CATBLK(KIGCN)) THEN
         IRET = 5
         WRITE (MSGTXT,1160)
         GO TO 990
         END IF
C                                       Any valid scans found ?
      IF (NXDAT.EQ.0) THEN
         IRET = 6
         WRITE (MSGTXT,1180)
         GO TO 990
         END IF
C                                       Compile table of all unique
C                                       FQ_IDs in the data. Use
C                                       information read from the NX
C                                       table.
      NFQUV = 0
      DO 200 I = 1, NXDAT
         DO 150 J = 1, NFQUV
            IF (IFQUV(J).EQ.INXFQ(I)) GO TO 200
150         CONTINUE
C                                       New FQ-ID found
         NFQUV = NFQUV + 1
         IF (NFQUV.GT.MXFQID) THEN
            WRITE (MSGTXT,1150)
            IRET = 11
            GO TO 990
            END IF
         IFQUV(NFQUV) = INXFQ(I)
200      CONTINUE
C
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C
999   RETURN
C-----------------------------------------------------------------------
1020  FORMAT ('NXREAD: NO VALID NX TABLE FOUND - RUN INDXR')
1040  FORMAT ('NXREAD: ERR',I3,' OPENING NX TABLE')
1100  FORMAT ('NXREAD: ERR',I3,' READING NX TABLE')
1120  FORMAT ('NXREAD: INCREASE PARAMETER MAXNX')
1140  FORMAT ('NXREAD: ERR',I3,' CLOSING NX TABLE')
1160  FORMAT ('NXREAD: NX TABLE OLD - RUN INDXR')
1180  FORMAT ('NXREAD: NO SCANS FOR SUBARRAY',I4)
1150  FORMAT ('NXREAD: PARAMETER MXFQID NEEDS TO BE INCREASED')
      END
      SUBROUTINE FQREAD (IRET)
C-----------------------------------------------------------------------
C   Subroutine to read parts of the FQ table into memory
C   Outputs:
C      IRET    I    Return code (0 => ok)
C-----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ANTAB.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DOUBLE PRECISION DFOFF(MAXIF), DBAND, DEDGE
      REAL      FINC(MAXIF)
      INTEGER   ISBAND(MAXIF), NIF, I, J, IVER, IERR, NDIM
      CHARACTER BNDCOD(MAXIF)*8
C-----------------------------------------------------------------------
      IRET = 0
C                                       Initialization
      NDIM = 2 * MXFQID * MAXIF
      CALL DFILL (NDIM, 0.0D0, DFRQTB)
C                                       Read FQ/CH data into memory
      DO 100 I = 1, NFQUV
         IVER = 1
         CALL CHNDAT ('READ', BUFF1, INDISK, ICNO, IVER, CATBLK, ILUN1,
     *      NIF, DFOFF, ISBAND, FINC, BNDCOD, IFQUV(I), IERR)
         IF (IERR.NE.0) THEN
            IRET = 1
            WRITE (MSGTXT,1100) IERR
            GO TO 990
            END IF
C                                       Loop over the IFs
         DO 80 J = 1,NIF
            DBAND = FINC(J) * CATBLK(KINAX+JLOCF)
            DEDGE = DFOFF(J) + CATD(KDCRV+JLOCF)
            IF (ISBAND(J).EQ.-1) DEDGE = DEDGE - DBAND
C                                       Convert to MHz
            DFRQTB(I,J,1) = DEDGE / 1.0D6
            DFRQTB(I,J,2) = (DEDGE + DBAND) / 1.0D6
80          CONTINUE
100      CONTINUE
C
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Exit
999   RETURN
C-----------------------------------------------------------------------
1100  FORMAT ('FQREAD: ERR',I3,' READING FQ/CH TABLE')
      END
      SUBROUTINE TXTCHK (NTABGC, IRET)
C----------------------------------------------------------------------
C   Read the auxillary calibration file solely to determine NTABGC
C   Output:
C      NTABGC   I   The maximum number of terms in the gain curve
C      IRET     I   Return code (0 => ok)
C----------------------------------------------------------------------
      INTEGER   NTABGC, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PGCV.INC'
      INCLUDE 'ANTAB.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INTEGER   NPARS, NKEYW, MXPOLY, MEXTRA
      PARAMETER (NKEYW = 34, MXPOLY = 10)
      PARAMETER (MEXTRA = MXPOLY + 2*MAXIF + MAXANT + NIGNOR)
      PARAMETER (NPARS = NKEYW + MEXTRA)
C
      LOGICAL   WEOF, WERROR, WTABL, IGMODE, ISVLBA
      CHARACTER LPARS(NPARS)*8, LMARK*8, LINDEX*8, LINDX2*8,
     *   LPOLY*8, LVALS(NPARS)*8, LKEY*8, LDUMMY*8
      DOUBLE PRECISION DVALS(NPARS)
      REAL      POLY(MXPOLY), POLIN(MXPOLY), OFFST, GDEC
      INTEGER   IMAPDF(2,MAXIF), LUNTMP, NCOLDF, I, J, JENTRY, IOFF,
     *   KMODE, ITYP, ISTN, JSTN, NDIM, IGTYPE, IERR, NPOLY, NVALS,
     *   NTAB, NPASSA, NPASSB, IKEY, ANVER, IPLUN
      INCLUDE 'DUM.INC'
C                                       Recognized KEYIN keywords
      DATA LPARS /'CONTROL ', 'BASELINE', 'GAIN    ', 'TSYS    ',
     *   'TANT    ', 'B       ', 'FT      ', 'TIMEOFF ', 'SRC/SYS ',
     *   'RANGE   ', 'RANGE   ', 'DPFU    ', 'DPFU    ',
     *   'FREQ    ', 'FREQ    ', 'RCP     ', 'LCP     ',
     *   'OFFSET  ', 'EL??    ', 'EQUAT   ', 'ALTAZ   ', 'GCNRAO  ',
     *   'TABLE   ', 'DEC     ',
     *   'A00     ', 'A11O    ', 'A10     ', 'A11E    ', 'A21O    ',
     *   'A20     ', 'A21E    ', 'A22O    ', 'A22E    ', 'A30     ',
     *   MEXTRA * '        '/
      DATA LMARK, LINDEX, LINDX2, LPOLY /'/', 'INDEX','INDEX2', 'POLY'/
C-----------------------------------------------------------------------
C                                       Initialize commons
      NDIM = MAXANT * MAXANT
      CALL RFILL (NDIM, 0.0, BFAC)
      WBFAC = .FALSE.
      WGAIN = .FALSE.
      WTSYS = .FALSE.
C                                       Find out if array is VLBA
C                                       for warning about legacy
C                                       files (see...)
      ANVER = 1
      IPLUN = LUNTMP(1)
      CALL ANTINI ('READ', BUFF1, INDISK, ICNO, ANVER, CATBLK, IPLUN,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING AN TABLE'
         GO TO 990
         END IF
      CALL TABIO ('CLOS', 1, IANRNO, BUFF1, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 999
      ISVLBA = ANAME(1:4).EQ.'VLBA'
C                                       initial need unknown
      NTABGC = 0
C
C                                       Set default mapping of Tsys
C                                       column entries to IF/polzn.
C                                       Assume IF and polzn. range
C                                       present in the uv-file are in
C                                       the calibration text file in
C                                       IF-polzn order.
      NDIM = 2 * MAXIF
      CALL FILL (NDIM, 0, IMAPDF)
      JENTRY = 1
      DO 40 I = 1, NIFUV
         DO 20 J = IPOLUV, (IPOLUV+NPOLUV-1)
            IMAPDF(J,I) = JENTRY
            JENTRY = JENTRY + 1
20          CONTINUE
40       CONTINUE
C                                       Default no. of Tsys columns.
      NCOLDF = NIFUV * NPOLUV
C                                       Add keyword POLY to list
      IOFF = NKEYW
      DO 50 I = 1, MXPOLY
         LPARS(I+IOFF) = LPOLY
50       CONTINUE
C                                       Add keywords INDEX and INDEX2
C                                       to list
      IOFF = IOFF + MXPOLY
      DO 60 I = 1, MAXIF
         LPARS(I+IOFF) = LINDEX
         LPARS(I+MAXIF+IOFF) = LINDX2
60       CONTINUE
C                                       Add antenna names as keywords
      IOFF = IOFF + 2 * MAXIF
      DO 70 I = 1, MAXANT
         IF (I.LE.NSTNS) LPARS(I+IOFF) = STNNAM(I)
70       CONTINUE
C                                       IOFF points to end of current LPARS
      IOFF = IOFF + NSTNS
      NPASSA = 0
      DO 72 I = 1,NIGNOR
C                                       examine one entry in CIGNOR at a time
         IF (CIGNOR(I)(1:1).EQ.' ') GO TO 72
         DO 71 J = 1,IOFF
C                                       if entry already appears in LPARS,
C                                       skip it
            IF (CIGNOR(I).EQ.LPARS(J)) GO TO 72
 71         CONTINUE
C                                       CIGNOR entry didnt appear in LPARS
         IOFF = IOFF + 1
C                                       add it.
         LPARS(IOFF) = CIGNOR(I)
         NPASSA = NPASSA + 1
 72      CONTINUE
      IF (NPASSA.NE.0) THEN
         WRITE (MSGTXT, 1072) NPASSA
         CALL MSGWRT (8)
         NPASSB = IOFF - NPASSA
         END IF
C                                       While (NOT EOF and NOT ERROR) do
C                                       Read record;
80    CONTINUE
C                                       Set defaults
      DO 100 J = 1, NPARS
         DVALS(J) = DBLANK
         LVALS(J) = '        '
100      CONTINUE
C                                       Echo KEYIN input if verbose
C                                       print level selected.
      KMODE = 0
      IGMODE = .FALSE.
C
      CALL KEYIN (LPARS, DVALS, LVALS, NPARS, LMARK, KMODE, ILUNF,
     *   IFINDF, IERR)
      WEOF = (IERR.EQ.1)
      WERROR = (IERR.NE.0).AND.(.NOT.WEOF)
      IF (WERROR) THEN
         WRITE (MSGTXT,1000) IERR, 'READING KEYIN FILE'
         GO TO 900
         END IF
C                                       EOF or ERROR encountered
      IF (WEOF.OR.WERROR) GO TO 900
C                                       check if any of the 'ignorable'
C                                       stations were encountered?
      IF (NPASSA.NE.0) THEN
         DO 119 I = NPASSB+1,NPASSB+NPASSA
            IF (DVALS(I).NE.DBLANK) IGMODE = .TRUE.
 119        CONTINUE
         END IF
C                                       Determine record type
      ITYP = 0
      DO 120 I = 1, 5
         IF (DVALS(I).NE.DBLANK) ITYP = I
120      CONTINUE
C                                       Extract first two station
C                                       names in this record
      IOFF = NKEYW + MXPOLY + 2*MAXIF
      ISTN = 0
      JSTN = 0
      DO 130 I = 1, NSTNS
         IF ((DVALS(I+IOFF).NE.DBLANK).AND.(ISTN.EQ.0)) THEN
            ISTN = I
         ELSE IF ((DVALS(I+IOFF).NE.DBLANK).AND.(JSTN.EQ.0)) THEN
            JSTN = I
            END IF
130      CONTINUE
C                                       Case (record_type) of:
C                                       0: Unidentified
      IF (ITYP.EQ.0) THEN
C                                       1: Control group
      ELSE IF (ITYP.EQ.1) THEN
C                                       2: Baseline group
      ELSE IF (ITYP.EQ.2) THEN
C                                       3: Gain record
      ELSE IF (ITYP.EQ.3) THEN
C                                       Extract gain curve type
         IGTYPE = 0
         LKEY = 'EQUAT'
         IF (DVALS(IKEY(LKEY,LPARS,NPARS)).NE.DBLANK) IGTYPE = 1
         LKEY = 'ALTAZ'
         IF (DVALS(IKEY(LKEY,LPARS,NPARS)).NE.DBLANK) IGTYPE = 2
         LKEY = 'EL??'
         IF (DVALS(IKEY(LKEY,LPARS,NPARS)).NE.DBLANK) IGTYPE = 3
         LKEY = 'GCNRAO'
         IF (DVALS(IKEY(LKEY,LPARS,NPARS)).NE.DBLANK) IGTYPE = 4
         WERROR = (IGTYPE.EQ.0)
         IF (WERROR) THEN
            WRITE (MSGTXT,1415)
            GO TO 850
         END IF
C                                       Is the Gain_curve_type
C                                       Tabulated [ or polynomial ? ]
         LKEY = 'TABLE'
         WTABL = (DVALS(IKEY(LKEY,LPARS,NPARS)).NE.DBLANK) .AND.
     *      ((IGTYPE.EQ.1) .OR. (IGTYPE.EQ.2) .OR. (IGTYPE.EQ.3))
C                                       Station must be specified.
         IF (ISTN.EQ.0) THEN
            IF (IGMODE) THEN
C                                       If gain_curve_type is TABLE,
C                                       extra step
               IF (WTABL) GO TO 425
C                                       otherwise skip this record
               GO TO 850
               END IF
            WRITE (MSGTXT,1400)
            WERROR = .TRUE.
            GO TO 850
            END IF
C                                       Initialisation
         GDEC = FBLANK
C                                       Case (Gain_curve_type) of:
C                                       1,2,3: HA, ZA, ELEV
         IF ((IGTYPE.EQ.1) .OR. (IGTYPE.EQ.2) .OR. (IGTYPE.EQ.3)) THEN
C                                       Declination specified ? Only
C                                       allowed for HA gain curves.
            GDEC = FBLANK
            IF (IGTYPE.EQ.1) THEN
               LKEY = 'DEC'
               J = IKEY (LKEY, LPARS, NPARS)
               IF (DVALS(J).NE.DBLANK) GDEC = DVALS(J)
               END IF
C                                       Extract polynomial coeff.
C                                       unless tabulated values expected
            IF (.NOT.WTABL) THEN
               CALL RFILL (MXPOLY, 0.0, POLIN)
               LKEY = 'POLY'
               J = IKEY (LKEY, LPARS, NPARS)
               NPOLY = 0
               DO 420 I = J, (J+MXPOLY-1)
                  IF (DVALS(I).NE.DBLANK) THEN
                     NPOLY = I - J + 1
                     POLIN(NPOLY) = DVALS(I)
                     END IF
 420              CONTINUE
C                                       Offset only allowed for simple
C                                       polynomial.
               OFFST = 0.0
               LKEY = 'OFFSET'
               J = IKEY (LKEY, LPARS, NPARS)
               IF (DVALS(J).NE.DBLANK) OFFST = DVALS(J)
C                                       Adjust poly. coeff. for
C                                       non-zero offset
               IF (OFFST.NE.0.0) THEN
                  CALL POLADJ (POLIN, POLY, NPOLY, OFFST)
               ELSE
                  CALL RCOPY (NPOLY, POLIN, POLY)
                  END IF
               END IF
            END IF
C                                       4: Spherical harmonic coeff.
C                                          for NRAO 140 ft
         IF (IGTYPE.EQ.4) THEN
            NPOLY = 10
            CALL RFILL (MXPOLY, 0.0, POLY)
            LKEY = 'A00'
            J = IKEY(LKEY,LPARS,NPARS)
            IF (DVALS(J).NE.DBLANK) POLY(1) = DVALS(J)
            LKEY = 'A10'
            J = IKEY(LKEY,LPARS,NPARS)
            IF (DVALS(J).NE.DBLANK) POLY(2) = DVALS(J)
            LKEY = 'A11E'
            J = IKEY(LKEY,LPARS,NPARS)
            IF (DVALS(J).NE.DBLANK) POLY(3) = DVALS(J)
            LKEY = 'A11O'
            J = IKEY(LKEY,LPARS,NPARS)
            IF (DVALS(J).NE.DBLANK) POLY(4) = DVALS(J)
            LKEY = 'A20'
            J = IKEY(LKEY,LPARS,NPARS)
            IF (DVALS(J).NE.DBLANK) POLY(5) = DVALS(J)
            LKEY = 'A21E'
            J = IKEY(LKEY,LPARS,NPARS)
            IF (DVALS(J).NE.DBLANK) POLY(6) = DVALS(J)
            LKEY = 'A21O'
            J = IKEY(LKEY,LPARS,NPARS)
            IF (DVALS(J).NE.DBLANK) POLY(7) = DVALS(J)
            LKEY = 'A22E'
            J = IKEY(LKEY,LPARS,NPARS)
            IF (DVALS(J).NE.DBLANK) POLY(8) = DVALS(J)
            LKEY = 'A22O'
            J = IKEY(LKEY,LPARS,NPARS)
            IF (DVALS(J).NE.DBLANK) POLY(9) = DVALS(J)
            LKEY = 'A30'
            J = IKEY(LKEY,LPARS,NPARS)
            IF (DVALS(J).NE.DBLANK) POLY(10) = DVALS(J)
            END IF
C                                       Endcase (gain_curve_type)
C                                       Read tabulated gain values
 425     IF (WTABL) THEN
            KMODE = 3
            NTAB = MXDUM
            CALL KEYIN (LDUMMY, DUMMY, LVALS, NTAB, LMARK, KMODE,
     *         ILUNF, IFINDF, IERR)
            WEOF = (IERR.EQ.1)
            WERROR = ((IERR.NE.0) .AND. (.NOT.WEOF))
            IF (WERROR.OR.WEOF) THEN
               WRITE (MSGTXT,1000) IERR, 'READING TABULATED GAINS'
               GO TO 990
               END IF
            END IF
C                                       you can only get here if IGMODE = T
         IF ((ISTN.EQ.0).AND.IGMODE) GO TO 850
C
         IF (WTABL) THEN
            NTABGC = MAX (NTABGC, NTAB/2)
         ELSE
            NTABGC = MAX (NTABGC, NPOLY)
            END IF
C                                       4: Tsys/Tant group
      ELSE IF ((ITYP.EQ.4) .OR. (ITYP.EQ.5)) THEN
C
C                                       Read TSYS or TANT values
         KMODE = 3
         NVALS = MXDUM
         CALL KEYIN (LDUMMY, DUMMY, LVALS, NVALS, LMARK, KMODE,
     *      ILUNF, IFINDF, IERR)
         WEOF = (IERR.EQ.1)
         WERROR = ((IERR.NE.0) .AND. (.NOT.WEOF))
         IF (WERROR .OR. WEOF) THEN
            WRITE (MSGTXT,1520) IERR, LPARS(ITYP)
            GO TO 850
            END IF
         END IF
C                                       Endcase (record_type)
850   IF (.NOT.(WERROR.OR.WEOF)) GO TO 80
C                                       Endwhile
900   IF (WERROR) THEN
C                                       General error in cal. proc.
         IRET = 9
         GO TO 990
         END IF
      GO TO 995
C                                       Error
 990  CALL MSGWRT (8)
C                                       Hard close before exit
 995  CALL ZTXCLS (ILUNF, IFINDF, IERR)
      IF (IRET.EQ.0) THEN
         CALL ZTXOPN ('READ', ILUNF, IFINDF, LINFIL, .FALSE., IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1995) IERR, LINFIL
            IRET = 9
            CALL MSGWRT (8)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TXTCHK: ERROR',I3,' ON ',A)
 1072 FORMAT ('TXTCHK: Added ',I3,' ignorable stations')
 1400 FORMAT ('TXTCHK: GAIN RECORD MISSING STATION NAME')
 1415 FORMAT ('TXTCHK: NO GAIN CURVE TYPE SPECIFIED')
 1520 FORMAT ('TXTCHK: ERROR',I3,' READING ',A4,' VALUES')
 1995 FORMAT ('CHK ERROR',I3,' RE-OPENING ',A)
      END
      SUBROUTINE TXTCAL (NTABGC, IRET)
C----------------------------------------------------------------------
C   Read the auxillary calibration file.
C   Input:
C      NTABGC   I   Number terms in gain curve max
C   Output:
C      IRET     I   Return code (0 => ok)
C----------------------------------------------------------------------
      INTEGER   NTABGC, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PGCV.INC'
      INCLUDE 'ANTAB.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INTEGER   NPARS, NKEYW, MXPOLY, MEXTRA
      PARAMETER (NKEYW = 34, MXPOLY = 10)
      PARAMETER (MEXTRA = MXPOLY + 2*MAXIF + MAXANT + NIGNOR)
      PARAMETER (NPARS = NKEYW + MEXTRA)
C
      LOGICAL   WEOF, WERROR, WALLFQ, WTABL, WTSVLA, WRANGE, WSOME,
     *   IGMODE, ISVLBA, PRTWRN
      CHARACTER LPARS(NPARS)*8, LMARK*8, LINDEX*8, LINDX2*8,
     *   LPOLY*8, LVALS(NPARS)*8, LKEY*8, OBSCOD*8, LDUMMY*8
      DOUBLE PRECISION DVALS(NPARS), DSKY1, DSKY2, REFFRQ
      REAL      POLY(MXPOLY), POLIN(MXPOLY), OFFST, CHNBW, REFPIX, GDEC,
     *   PSS(2), FT, TIMOFF, RTIME, TIMETY, TINTTY,TLOW, THIGH, TMIND,
     *   XVALGC(2,MAXIF), SENSGC(2,MAXIF), TSYST(2,MAXIF),
     *   TANT(2,MAXIF), YVALGC(2,MAXIF,MXTBGC), GAINGC(2,MAXIF,MXTBGC)
      INTEGER   IMAPDF(2,MAXIF), IMAP(2,MAXIF), GCKOLS(MAXGCC),
     *   GCNUMV(MAXGCC), TYKOLS(MAXTYC), TYNUMV(MAXTYC), LUNTMP, NCOLDF,
     *   NCOLKY, I, J, K, M, MM, JENTRY, IOFF, KMODE, ITYP, ISTN, JSTN,
     *   NSKIP, NDIM, IGTYPE, IGPOL, IERR, IGCRNO, NPOLGC,
     *   NOSTKD, STK1, NOBAND, NOCHAN, ITYRNO, NPOLTY, NIFTY, NPOLY,
     *   NVALS, NTAB, NCOLK, NCOLJ, IDAY, IHOUR, ISOUNX, IFQDNX, JPOL,
     *   JIF, IANTTY, ISUBTY, NFOUND, KPOL, NPASSA, NPASSB, IANTGC,
     *   ISUBGC, IFQDGC, ITPGC(2,MAXIF), NTGC(2,MAXIF), IXTGC(2,MAXIF),
     *   IYTGC(2,MAXIF), IKEY, ANVER, IPLUN
      INCLUDE 'DUM.INC'
C                                       Recognized KEYIN keywords
      DATA LPARS /'CONTROL ', 'BASELINE', 'GAIN    ', 'TSYS    ',
     *   'TANT    ', 'B       ', 'FT      ', 'TIMEOFF ', 'SRC/SYS ',
     *   'RANGE   ', 'RANGE   ', 'DPFU    ', 'DPFU    ',
     *   'FREQ    ', 'FREQ    ', 'RCP     ', 'LCP     ',
     *   'OFFSET  ', 'EL??    ', 'EQUAT   ', 'ALTAZ   ', 'GCNRAO  ',
     *   'TABLE   ', 'DEC     ',
     *   'A00     ', 'A11O    ', 'A10     ', 'A11E    ', 'A21O    ',
     *   'A20     ', 'A21E    ', 'A22O    ', 'A22E    ', 'A30     ',
     *   MEXTRA * '        '/
      DATA LMARK, LINDEX, LINDX2, LPOLY /'/', 'INDEX','INDEX2', 'POLY'/
C-----------------------------------------------------------------------
C                                       Initialize commons
      NDIM = MAXANT * MAXANT
      CALL RFILL (NDIM, 0.0, BFAC)
      WBFAC = .FALSE.
      WGAIN = .FALSE.
      WTSYS = .FALSE.
C                                       Find out if array is VLBA
C                                       for warning about legacy
C                                       files (see...)
      PRTWRN = .FALSE.
      ANVER = 1
      IPLUN = LUNTMP(1)
      CALL ANTINI ('READ', BUFF1, INDISK, ICNO, ANVER, CATBLK, IPLUN,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      CALL TABIO ('CLOS', 1, IANRNO, BUFF1, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 999
      ISVLBA = ANAME(1:4).EQ.'VLBA'
C                                       Append results of present
C                                       run to the specified GC table,
C                                       which is consolidated later.
C                                       Open GC table for write
      NPOLGC = NPOLUV
      CALL H2CHR (8, 1, CATH(KHOBS), OBSCOD)
      NOSTKD = CATBLK(KINAX+JLOCS)
      STK1 = ICOR0
      NOBAND = NIFUV
      NOCHAN = CATBLK(KINAX+JLOCF)
      REFFRQ = CATD(KDCRV+JLOCF)
      CHNBW = CATR(KRCIC+JLOCF)
      REFPIX = CATR(KRCRP+JLOCF)
C
      I = NTABGC
      CALL GCINI ('WRIT', BUFF1, INDISK, ICNO, IGCVER, CATBLK, ILUN1,
     *   IGCRNO, GCKOLS, GCNUMV, NPOLGC, NOBAND, I, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
      IF (I.LT.NTABGC) THEN
         IRET = 10
         WRITE (MSGTXT,1065) I, NTABGC
         GO TO 990
         END IF
      NTABGC = I
C                                       Append results of present
C                                       run to the specified TY table,
C                                       which is consolidated later.
C                                       Open TY table for write
      NPOLTY = NPOLUV
      NIFTY = NIFUV
      CALL TYINI ('WRIT', BUFF2, INDISK, ICNO, ITYVER, CATBLK, ILUN2,
     *   ITYRNO, TYKOLS, TYNUMV, NPOLTY, NIFTY, IERR)
      IF (IERR.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1070) IERR
         GO TO 990
         END IF
C
C                                       Set default mapping of Tsys
C                                       column entries to IF/polzn.
C                                       Assume IF and polzn. range
C                                       present in the uv-file are in
C                                       the calibration text file in
C                                       IF-polzn order.
      NDIM = 2 * MAXIF
      CALL FILL (NDIM, 0, IMAPDF)
      JENTRY = 1
      DO 40 I = 1, NIFUV
         DO 20 J = IPOLUV, (IPOLUV+NPOLUV-1)
            IMAPDF(J,I) = JENTRY
            JENTRY = JENTRY + 1
20          CONTINUE
40       CONTINUE
C                                       Default no. of Tsys columns.
      NCOLDF = NIFUV * NPOLUV
C                                       Add keyword POLY to list
      IOFF = NKEYW
      DO 50 I = 1, MXPOLY
         LPARS(I+IOFF) = LPOLY
50       CONTINUE
C                                       Add keywords INDEX and INDEX2
C                                       to list
      IOFF = IOFF + MXPOLY
      DO 60 I = 1, MAXIF
         LPARS(I+IOFF) = LINDEX
         LPARS(I+MAXIF+IOFF) = LINDX2
60       CONTINUE
C                                       Add antenna names as keywords
      IOFF = IOFF + 2 * MAXIF
      DO 70 I = 1, MAXANT
         IF (I.LE.NSTNS) LPARS(I+IOFF) = STNNAM(I)
70       CONTINUE
C                                       IOFF points to end of current LPARS
      IOFF = IOFF + NSTNS
      NPASSA = 0
      DO 72 I = 1,NIGNOR
C                                       examine one entry in CIGNOR at a time
         IF (CIGNOR(I)(1:1).EQ.' ') GO TO 72
         DO 71 J = 1,IOFF
C                                       if entry already appears in LPARS,
C                                       skip it
            IF (CIGNOR(I).EQ.LPARS(J)) GO TO 72
 71         CONTINUE
C                                       CIGNOR entry didnt appear in LPARS
         IOFF = IOFF + 1
C                                       add it.
         LPARS(IOFF) = CIGNOR(I)
         NPASSA = NPASSA + 1
 72      CONTINUE
      IF (NPASSA.NE.0) THEN
         WRITE (MSGTXT, 1072) NPASSA
         CALL MSGWRT (8)
         NPASSB = IOFF - NPASSA
         END IF
C
      NSKIP = 0

C                                       While (NOT EOF and NOT ERROR) do
C                                         Read record;
C
80    CONTINUE
C                                       Set defaults
      DO 100 J = 1, NPARS
         DVALS(J) = DBLANK
         LVALS(J) = '        '
100      CONTINUE
C                                       Echo KEYIN input if verbose
C                                       print level selected.
      KMODE = 0
      IF (IPRTLV.GT.0) KMODE = 1
      IGMODE = .FALSE.
C
      CALL KEYIN (LPARS, DVALS, LVALS, NPARS, LMARK, KMODE, ILUNF,
     *   IFINDF, IERR)
      WEOF = (IERR.EQ.1)
      WERROR = (IERR.NE.0).AND.(.NOT.WEOF)
      IF (WERROR) THEN
         WRITE (MSGTXT,1100) IERR
         GO TO 900
         END IF
C                                       EOF or ERROR encountered
      IF (WEOF.OR.WERROR) GO TO 900
C                                       check if any of the 'ignorable'
C                                       stations were encountered?
      IF (NPASSA.NE.0) THEN
         DO 119 I = NPASSB+1,NPASSB+NPASSA
            IF (DVALS(I).NE.DBLANK) IGMODE = .TRUE.
 119        CONTINUE
         END IF
C                                       Determine record type
      ITYP = 0
      DO 120 I = 1, 5
         IF (DVALS(I).NE.DBLANK) ITYP = I
120      CONTINUE
C                                       Extract first two station
C                                       names in this record
      IOFF = NKEYW + MXPOLY + 2*MAXIF
      ISTN = 0
      JSTN = 0
      DO 130 I = 1, NSTNS
         IF ((DVALS(I+IOFF).NE.DBLANK).AND.(ISTN.EQ.0)) THEN
            ISTN = I
         ELSE IF ((DVALS(I+IOFF).NE.DBLANK).AND.(JSTN.EQ.0)) THEN
            JSTN = I
            END IF
130      CONTINUE
C                                       Case (record_type) of:
C                                       0: Unidentified
      IF (ITYP.NE.0) GO TO 200
         NSKIP = NSKIP + 1
         GO TO 850
C                                       1: Control group
200   IF (ITYP.NE.1) GO TO 300
C                                       Extract and decode INDEX
C                                       record if specified. This
C                                       then becomes the default
C                                       index for all stations.
         LKEY = 'INDEX'
         J = IKEY (LKEY, LPARS, NPARS)
         LKEY = 'INDEX2'
         K = IKEY (LKEY, LPARS, NPARS)
         IF ((DVALS(J).NE.DBLANK).OR.(DVALS(K).NE.DBLANK)) THEN
            NDIM = 2 * MAXIF
            CALL FILL (NDIM, 0, IMAPDF)
            IF (DVALS(J).NE.DBLANK) CALL DECOD (LVALS(J), MAXIF,
     *         IPOLUV, NPOLUV, NIFUV, IMAPDF, MAXIF, NCOLJ, IERR)
            WERROR = (IERR.NE.0)
            IF (DVALS(K).NE.DBLANK) CALL DECOD (LVALS(K), MAXIF,
     *         IPOLUV, NPOLUV, NIFUV, IMAPDF, MAXIF, NCOLK, IERR)
            NCOLDF = MAX (NCOLJ, NCOLK)
            IF (NCOLDF.GT.MAXIF) THEN
               WERROR = .TRUE.
               WRITE (MSGTXT,1510) MAXIF
               GO TO 850
               END IF
            WERROR = (WERROR.OR.(IERR.NE.0))
            END IF
C
         GO TO 850
C                                       2: Baseline group
300   IF (ITYP.NE.2) GO TO 400
C                                       Are both stations present ?
         IF ((ISTN.EQ.0).OR.(JSTN.EQ.0)) THEN
            IF (IGMODE) GO TO 850
            WRITE (MSGTXT,1150)
            WERROR = .TRUE.
            GO TO 850
            END IF
C                                       Extract baseline factor
         LKEY = 'B'
         J = IKEY (LKEY, LPARS, NPARS)
         IF (DVALS(J).NE.DBLANK) BFAC(TELNO(ISTN),TELNO(JSTN)) =
     *      DVALS(J)
         WBFAC = .TRUE.
C                                       Message about record processed
         WRITE (MSGTXT,1300) STNNAM(ISTN), STNNAM(JSTN)
         CALL MSGWRT (4)
C
         GO TO 850
C                                       3: Gain record
400    IF (ITYP.NE.3) GO TO 425
C                                       First, check gain_curve_type
C
C                                       Extract gain curve type
          IGTYPE = 0
          LKEY = 'EQUAT'
          IF (DVALS(IKEY(LKEY,LPARS,NPARS)).NE.DBLANK) IGTYPE = 1
          LKEY = 'ALTAZ'
          IF (DVALS(IKEY(LKEY,LPARS,NPARS)).NE.DBLANK) IGTYPE = 2
          LKEY = 'EL??'
          IF (DVALS(IKEY(LKEY,LPARS,NPARS)).NE.DBLANK) IGTYPE = 3
          LKEY = 'GCNRAO'
          IF (DVALS(IKEY(LKEY,LPARS,NPARS)).NE.DBLANK) IGTYPE = 4
          WERROR = (IGTYPE.EQ.0)
          IF (WERROR) THEN
             WRITE (MSGTXT,1415)
             GO TO 850
             END IF
C                                       Is the Gain_curve_type
C                                       Tabulated [ or polynomial ? ]
          LKEY = 'TABLE'
          WTABL = (DVALS(IKEY(LKEY,LPARS,NPARS)).NE.DBLANK) .AND.
     *       ((IGTYPE.EQ.1) .OR. (IGTYPE.EQ.2) .OR. (IGTYPE.EQ.3))
C
C
C                                       Station must be specified.
          IF (ISTN.EQ.0) THEN
             IF (IGMODE) THEN
C                                       If gain_curve_type is TABLE, extra step
                IF (WTABL) GO TO 425
C                                       otherwise skip this record
                GO TO 850
                END IF
             WRITE (MSGTXT,1400)
             WERROR = .TRUE.
             GO TO 850
             END IF
C                                       Extract Jy/K
          CALL RFILL (2, 0.0, PSS)
          LKEY = 'DPFU'
          J = IKEY (LKEY, LPARS, NPARS)
          IF ((DVALS(J).EQ.DBLANK).AND.(DVALS(J+1).EQ.DBLANK)) THEN
             WERROR = .TRUE.
             WRITE (MSGTXT,1410)
             GO TO 850
          ELSE
             IF (DVALS(J).NE.DBLANK) PSS(1) = DVALS(J)
             IF (DVALS(J+1).NE.DBLANK) PSS(2) = DVALS(J+1)
             END IF
C                                       Only one DPFU specified
          IF (PSS(1).EQ.0.0) PSS(1) = PSS(2)
          IF (PSS(2).EQ.0.0) PSS(2) = PSS(1)
C
C                                       Initialisation
          GDEC = FBLANK
C                                       Case (Gain_curve_type) of:
C                                       1,2,3: HA, ZA, ELEV
          IF ((IGTYPE.EQ.1).OR.(IGTYPE.EQ.2).OR.(IGTYPE.EQ.3)) THEN
C
C                                       Declination specified ? Only
C                                       allowed for HA gain curves.
             GDEC = FBLANK
             IF (IGTYPE.EQ.1) THEN
                LKEY = 'DEC'
                J = IKEY (LKEY, LPARS, NPARS)
                IF (DVALS(J).NE.DBLANK) GDEC = DVALS(J)
                END IF
C                                       Extract polynomial coeff.
C                                       unless tabulated values expected
             IF (.NOT.WTABL) THEN
                CALL RFILL (MXPOLY, 0.0, POLIN)
                LKEY = 'POLY'
                J = IKEY (LKEY, LPARS, NPARS)
                NPOLY = 0
                DO 420 I = J, (J+MXPOLY-1)
                  IF (DVALS(I).NE.DBLANK) THEN
                     NPOLY = I - J + 1
                     POLIN(NPOLY) = DVALS(I)
                     END IF
420               CONTINUE
C                                       Offset only allowed for simple
C                                       polynomial.
                OFFST = 0.0
                LKEY = 'OFFSET'
                J = IKEY (LKEY, LPARS, NPARS)
                IF (DVALS(J).NE.DBLANK) OFFST = DVALS(J)
C                                       Adjust poly. coeff. for
C                                       non-zero offset
                IF (OFFST.NE.0.0) THEN
                   CALL POLADJ (POLIN, POLY, NPOLY, OFFST)
                ELSE
                   CALL RCOPY (NPOLY, POLIN, POLY)
                   END IF
                END IF
             END IF
C                                       4: Spherical harmonic coeff.
C                                          for NRAO 140 ft.
          IF (IGTYPE.EQ.4) THEN
             CALL RFILL (MXPOLY, 0.0, POLY)
             LKEY = 'A00'
             J = IKEY(LKEY,LPARS,NPARS)
             IF (DVALS(J).NE.DBLANK) POLY(1) = DVALS(J)
             LKEY = 'A10'
             J = IKEY(LKEY,LPARS,NPARS)
             IF (DVALS(J).NE.DBLANK) POLY(2) = DVALS(J)
             LKEY = 'A11E'
             J = IKEY(LKEY,LPARS,NPARS)
             IF (DVALS(J).NE.DBLANK) POLY(3) = DVALS(J)
             LKEY = 'A11O'
             J = IKEY(LKEY,LPARS,NPARS)
             IF (DVALS(J).NE.DBLANK) POLY(4) = DVALS(J)
             LKEY = 'A20'
             J = IKEY(LKEY,LPARS,NPARS)
             IF (DVALS(J).NE.DBLANK) POLY(5) = DVALS(J)
             LKEY = 'A21E'
             J = IKEY(LKEY,LPARS,NPARS)
             IF (DVALS(J).NE.DBLANK) POLY(6) = DVALS(J)
             LKEY = 'A21O'
             J = IKEY(LKEY,LPARS,NPARS)
             IF (DVALS(J).NE.DBLANK) POLY(7) = DVALS(J)
             LKEY = 'A22E'
             J = IKEY(LKEY,LPARS,NPARS)
             IF (DVALS(J).NE.DBLANK) POLY(8) = DVALS(J)
             LKEY = 'A22O'
             J = IKEY(LKEY,LPARS,NPARS)
             IF (DVALS(J).NE.DBLANK) POLY(9) = DVALS(J)
             LKEY = 'A30'
             J = IKEY(LKEY,LPARS,NPARS)
             IF (DVALS(J).NE.DBLANK) POLY(10) = DVALS(J)
             END IF
C                                       Endcase (gain_curve_type)
C
C                                       Extract polzn. type
          IGPOL = 0
          LKEY = 'RCP'
          IF (DVALS(IKEY(LKEY,LPARS,NPARS)).NE.DBLANK) IGPOL = 1
          LKEY = 'LCP'
          IF (DVALS(IKEY(LKEY,LPARS,NPARS)).NE.DBLANK) IGPOL = 2
C                                       Extract sky freq. range for
C                                       this gain information.
          LKEY = 'FREQ'
          J = IKEY (LKEY, LPARS, NPARS)
          DSKY1 = DVALS(J)
          DSKY2 = DVALS(J+1)
C                                       Valid freq. range ?
          WALLFQ = (DSKY1.EQ.DBLANK).OR.(DSKY2.EQ.DBLANK).OR.
     *       (DSKY1.GT.DSKY2)
C
C                                       Gain record (cont''d)
 425      IF (ITYP.NE.3) GO TO 500
C
C                                       Read tabulated gain values
          IF (WTABL) THEN
             KMODE = 3
             IF (IPRTLV.GT.0) KMODE = 4
             NTAB = MXDUM
             CALL KEYIN (LDUMMY, DUMMY, LVALS, NTAB, LMARK, KMODE,
     *          ILUNF, IFINDF, IERR)
             WEOF = (IERR.EQ.1)
             WERROR = ((IERR.NE.0).AND.(.NOT.WEOF))
             IF (WERROR.OR.WEOF) THEN
                WRITE (MSGTXT,1420) IERR
                GO TO 990
                END IF
             END IF
C                                       you can only get here if IGMODE = T
          IF ((ISTN.EQ.0).AND.IGMODE) GO TO 850
C
C                                       Antenna no./ subarray
         IANTGC = TELNO(ISTN)
         ISUBGC = ISUBA
C                                       Loop over FQ-ID/IF/polzn.
         DO 490 I = 1, NFQUV
            IFQDGC = IFQUV(I)
C                                       Fill gain table record
            WSOME = .FALSE.
            NDIM = 2 * MAXIF
            CALL FILL (NDIM, 0, ITPGC)
            CALL FILL (NDIM, 0, NTGC)
            CALL FILL (NDIM, 0, IXTGC)
            CALL FILL (NDIM, 0, IYTGC)
            CALL RFILL (NDIM, FBLANK, XVALGC)
            CALL RFILL (NDIM, FBLANK, SENSGC)
            NDIM = 2 * MAXIF * MXTBGC
            CALL RFILL (NDIM, FBLANK, YVALGC)
            CALL RFILL (NDIM, FBLANK, GAINGC)

            DO 480 J = 1, NIFUV
C                                       Selected by FREQ ?
               IF ((.NOT.WALLFQ).AND.((DFRQTB(I,J,1).LT.DSKY1).OR.
     *            (DFRQTB(I,J,2).GT.DSKY2))) GO TO 480
C                                       Loop over polarization
               DO 470 K = 1, NPOLUV
                  JPOL = K + IPOLUV - 1
C                                       Selected by polarization ?
                  IF ((IGPOL.NE.0).AND.(IGPOL.NE.JPOL)) GO TO 470
                  WSOME = .TRUE.
C                                       Deg. per flux unit
                  IF (JPOL.EQ.1) SENSGC(K,J) = PSS(1)
                  IF (JPOL.EQ.2) SENSGC(K,J) = PSS(2)
C                                       Case (gain_curve_type) of:
C                                       1,2,3: HA, ZA, ELEV
                  IF ((IGTYPE.EQ.1).OR.(IGTYPE.EQ.2).OR.
     *               (IGTYPE.EQ.3)) THEN
C                                       Y-value type
                     IF (IGTYPE.EQ.1) IYTGC(K,J) = 3
                     IF (IGTYPE.EQ.2) IYTGC(K,J) = 2
                     IF (IGTYPE.EQ.3) IYTGC(K,J) = 1
C                                       X-value
                     XVALGC(K,J) = GDEC
C                                       X-type
                     IF (GDEC.EQ.FBLANK) THEN
                        IXTGC(K,J) = 0
                     ELSE
                        IXTGC(K,J) = 4
                        END IF
C                                       Tabulated values or polynomial ?
                     IF (WTABL) THEN
C                                       Tabulated values
                        ITPGC(K,J) = 1
C                                       Must be an even number of values
                        IF (MOD(NTAB,2).NE.0) THEN
                           WERROR = .TRUE.
                           WRITE (MSGTXT,1425)
                           GO TO 850
                           END IF
                        MM = 1
                        DO 440 M = 1, (NTAB-1), 2
                           YVALGC(K,J,MM) = DUMMY(M)
                           GAINGC(K,J,MM) = DUMMY(M+1)
                           MM = MM + 1
440                        CONTINUE
                        NTGC(K,J) = MM - 1
C
                     ELSE IF (NPOLY.NE.0) THEN
C                                       Polynomial
                        ITPGC(K,J) = 2
                        NTGC(K,J) = NPOLY
                        DO 450 M = 1,NPOLY
                           YVALGC(K,J,M) = FBLANK
                           GAINGC(K,J,M) = POLY(M)
450                        CONTINUE
                        END IF
                     END IF
C                                       4: Spherical harmonic coeff (2-D)
                  IF (IGTYPE.EQ.4) THEN
                     ITPGC(K,J) = 3
C                                       Only allow (90-DEC,HA)
                     IXTGC(K,J) = 5
                     IYTGC(K,J) = 3
                     XVALGC(K,J) = FBLANK
                     MM = 0
                     DO 460 M = 1,MXPOLY
                        YVALGC(K,J,M) = FBLANK
                        GAINGC(K,J,M) = POLY(M)
                        IF (POLY(M).NE.0.0) MM = M
460                     CONTINUE
                     NTGC(K,J) = MM
                     END IF
C
470               CONTINUE
480            CONTINUE
C                                       Write GC record
            IF (WSOME) THEN
               CALL TABGC ('WRIT', BUFF1, IGCRNO, GCKOLS, GCNUMV,
     *            NPOLGC, NTABGC, IANTGC, ISUBGC, IFQDGC, ITPGC,
     *            NTGC, IXTGC, IYTGC, XVALGC, YVALGC, GAINGC,
     *            SENSGC, IERR)
               IF (IERR.NE.0) THEN
                  WERROR = .TRUE.
                  WRITE (MSGTXT,1480) IERR
                  GO TO 850
                  END IF
               END IF
            WGAIN = .TRUE.
490         CONTINUE
C                                       Message about record processed
         WRITE (MSGTXT,1490) STNNAM(ISTN)
         CALL MSGWRT (4)
C
         GO TO 850
C                                       4: Tsys/Tant group
500   IF ((ITYP.NE.4).AND.(ITYP.NE.5)) GO TO 850
C                                       Station must be specified
         WERROR = .FALSE.
         IF (ISTN.EQ.0) THEN
            IF (.NOT.IGMODE) THEN
               WRITE (MSGTXT,1500) LPARS(ITYP)
               WERROR = .TRUE.
               GO TO 850
               END IF
            GO TO 525
            END IF
C                                       Should not use *cal.vlba calibration
C                                       files on RDBE data.  Issue warning if:
C                                       (1) not Y; (2) is VLBA; (3) after
C                                       Jan 2014 but before October 2015;
C                                       and (4) the warning has
C                                       not been printed before.
         IF (STNNAM(ISTN)(1:1).NE.'Y'.AND.ISVLBA.AND..NOT.PRTWRN) THEN
           IF ((IDATE(1).GE.14.AND.IDATE(2).GT.1).AND.
     *     (IDATE(1).LT.16.OR.(IDATE(1).EQ.15.AND.IDATE(2).GT.10)))THEN
               PRTWRN = .TRUE.
               WRITE(MSGTXT,1600)
               CALL MSGWRT(8)
               WRITE(MSGTXT,1610)
               CALL MSGWRT(8)
               WRITE(MSGTXT,1620)
               CALL MSGWRT(8)
               WRITE(MSGTXT,1630)
               CALL MSGWRT(8)
               WRITE(MSGTXT,1640)
               CALL MSGWRT(8)
               WRITE(MSGTXT,1650)
               CALL MSGWRT(8)
              ENDIF
            ENDIF
C                                       Extract FT, TIMEOFF, SRC/SYS
C                                       and RANGE
         FT = 1.0
         LKEY = 'FT'
         J = IKEY (LKEY, LPARS, NPARS)
         IF (DVALS(J).NE.DBLANK) FT = DVALS(J)
         TIMOFF = 0.0
         LKEY = 'TIMEOFF'
         J = IKEY (LKEY, LPARS, NPARS)
         IF (DVALS(J).NE.DBLANK) TIMOFF = DVALS(J) / 86400.0D0
         LKEY = 'SRC/SYS'
         J = IKEY (LKEY, LPARS, NPARS)
         WTSVLA = (DVALS(J).NE.DBLANK)
         TLOW = 0.0
         THIGH = FBLANK
         LKEY = 'RANGE'
         J = IKEY (LKEY, LPARS, NPARS)
         IF (DVALS(J).NE.DBLANK) TLOW = DVALS(J)
         IF (DVALS(J+1).NE.DBLANK) THIGH = DVALS(J+1)
C                                       Decode INDEX or INDEX2 keywords
         LKEY = 'INDEX'
         J = IKEY (LKEY, LPARS, NPARS)
         LKEY = 'INDEX2'
         K = IKEY (LKEY, LPARS, NPARS)
         IF ((DVALS(J).NE.DBLANK).OR.(DVALS(K).NE.DBLANK)) THEN
            NDIM = 2 * MAXIF
            CALL FILL (NDIM, 0, IMAP)
            IF (DVALS(K).NE.DBLANK) CALL DECOD (LVALS(K), MAXIF,
     *         IPOLUV, NPOLUV, NIFUV, IMAP, MAXIF, NCOLK, IERR)
            WERROR = (IERR.NE.0)
            IF (DVALS(J).NE.DBLANK) CALL DECOD (LVALS(J), MAXIF,
     *         IPOLUV, NPOLUV, NIFUV, IMAP, MAXIF, NCOLJ, IERR)
            WERROR = (WERROR.OR.(IERR.NE.0))
            NCOLKY = MAX (NCOLK, NCOLJ)
            IF (NCOLKY.GT.MAXIF) THEN
               WERROR = .TRUE.
               WRITE (MSGTXT,1510) MAXIF
               GO TO 850
               END IF
         ELSE
C                                       Else use default mapping
            NDIM = 2 * MAXIF
            CALL COPY (NDIM, IMAPDF, IMAP)
            NCOLKY = NCOLDF
            END IF
C
      IF (WERROR) GO TO 850
C
 525  CONTINUE
C
C                                       Read TSYS or TANT values
      KMODE = 3
      IF (IPRTLV.GT.0) KMODE = 4
      NVALS = MXDUM
      CALL KEYIN (LDUMMY, DUMMY, LVALS, NVALS, LMARK, KMODE,
     *   ILUNF, IFINDF, IERR)
      WEOF = (IERR.EQ.1)
      WERROR = ((IERR.NE.0).AND.(.NOT.WEOF))
      IF (WERROR.OR.WEOF) THEN
         WRITE (MSGTXT,1520) IERR, LPARS(ITYP)
         GO TO 850
         END IF
      IF ((ISTN.EQ.0).AND.IGMODE) GO TO 850
C                                       Fill TY table record
      I = 1
      NFOUND = 0
C                                       While (I <= Nvals) do
530   IF (I.GT.NVALS) GO TO 590
C                                       Compute time relative to
C                                       reference day.
         RTIME = DUMMY(I) - IREFDY
C                                       Experiments going over year-end
         IF (ABS(RTIME+ILOYR).LT.ABS(RTIME)) RTIME = RTIME + ILOYR
         IF (ABS(RTIME-ILOYR).LT.ABS(RTIME)) RTIME = RTIME - ILOYR
         RTIME = RTIME + DUMMY(I+1) / 24.0D0 + TIMOFF
C                                       Check that time is valid
C                                       No experiment assumed to last
C                                       longer than two weeks.
         WERROR = ((RTIME.GT.14).OR.(DUMMY(I).GT.366).OR.
     *      (DUMMY(I).LT.1).OR.(DUMMY(I+1).LT.0.0).OR.
     *      (DUMMY(I+1).GT.24.0))
         IF (WERROR) THEN
C                                       Report bad time
            IDAY = DUMMY(I)
            IHOUR = DUMMY(I+1)
            TMIND = (DUMMY(I+1) - IHOUR) * 60.0
            WRITE (MSGTXT,1530) DUMMY(I), DUMMY(I+1), NFOUND,
     *         STNNAM(ISTN)
            GO TO 850
            END IF
C                                       Skip if this time not in the
C                                       uv-data file.
         CALL NXSRCH (RTIME, ISOUNX, IFQDNX)
         IF (ISOUNX.LE.0) GO TO 560
C                                       Enough values left to read ?
         WERROR = (WERROR.OR.((I+NCOLKY+1).GT.NVALS))
         IF (WERROR) THEN
            WRITE (MSGTXT,1535) LPARS(ITYP)
            GO TO 850
            END IF
C                                       Initialise the Tsys and Tant
C                                       arrays.
         WSOME = .FALSE.
         NDIM = 2 * MAXIF
         CALL RFILL (NDIM, FBLANK, TSYST)
         CALL RFILL (NDIM, FBLANK, TANT)
C                                       Process the Tsys/Tant values
         DO 545 KPOL = 1, NPOLUV
            JPOL = KPOL + IPOLUV - 1
            DO 535 JIF = 1, NIFUV
C                                       Check mapping of col. to pol/IF
               JENTRY = IMAP(JPOL,JIF)
               IF (JENTRY.LE.0) GO TO 535
               K = I + JENTRY + 1
C                                       Check permitted range
               IF (THIGH.NE.FBLANK) THEN
                  WRANGE = ((DUMMY(K).GE.TLOW).AND.(DUMMY(K).LE.THIGH))
               ELSE
                  WRANGE = .TRUE.
                  END IF
               IF ((DUMMY(K).LE.0.0).OR.(ABS(DUMMY(K)-999.9).LT.0.05)
     *            .OR.(.NOT.WRANGE))
     *            THEN
C                                       Invalid temperature
                  IF (ITYP.EQ.4) TSYST(KPOL,JIF) = FBLANK
                  IF (ITYP.EQ.5) TANT(KPOL,JIF) = FBLANK
               ELSE
C                                       Valid temperature
                  WSOME = .TRUE.
                  IF (ITYP.EQ.4) THEN
                     TSYST(KPOL,JIF) = FT * DUMMY(K)
C                                       Mark Ta/Tsys by setting Tant
C                                       to -1.0
                     IF (WTSVLA) TANT(KPOL,JIF) = -1.0
                     END IF
                  IF (ITYP.EQ.5) TANT(KPOL,JIF) = DUMMY(K)
                  END IF
535            CONTINUE
545         CONTINUE
C                                       Write the TY record
         TIMETY = RTIME
         TINTTY = 0.0
         IANTTY = TELNO(ISTN)
         ISUBTY = ISUBA
         IF (WSOME) THEN
            CALL TABTY ('WRIT', BUFF2, ITYRNO, TYKOLS, TYNUMV, NPOLTY,
     *         NIFTY, TIMETY, TINTTY, ISOUNX, IANTTY, ISUBTY, IFQDNX,
     *         TSYST, TANT, IERR)
            IF (IERR.NE.0) THEN
               WERROR = .TRUE.
               WRITE (MSGTXT,1545) IERR
               GO TO 850
               END IF
            END IF
         WTSYS = .TRUE.
         NFOUND = NFOUND + 1
C                                       Increment pointer in array of
C                                       Tsys or Tant values.
560      I = I + NCOLKY + 2
         GO TO 530
C                                       Endwhile
590   CONTINUE
C                                       Message about data loaded
      WRITE (MSGTXT,1590) NFOUND, LPARS(ITYP), STNNAM(ISTN)
      CALL MSGWRT (4)
      GO TO 850
C                                       Endcase (record_type)
850   IF (.NOT.(WERROR.OR.WEOF)) GO TO 80
C                                       Endwhile
900   IF (WERROR) THEN
C                                       General error in cal. proc.
         IRET = 9
         GO TO 990
         END IF
C                                       Message about records skipped
      WRITE (MSGTXT,1900) NSKIP
      CALL MSGWRT (4)
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Hard close before exit
999   CALL TABIO ('CLOS', 0, IGCRNO, BUFF1, BUFF1, IERR)
      CALL TABIO ('CLOS', 0, ITYRNO, BUFF2, BUFF2, IERR)
      CALL ZTXCLS (ILUNF, IFINDF, IERR)
      RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('TXTCAL: ERROR ',I3,' READING AN TABLE')
 1050 FORMAT ('TXTCAL: ERROR',I3,' CREATING GC TABLE')
 1065 FORMAT ('TXTCAL: EXISTING GC TABLE HAS',I4,' TERMS, NEED',I4)
 1070 FORMAT ('TXTCAL: ERROR',I3,' CREATING TY TABLE')
 1072 FORMAT ('TXTCAL: Added ',I3,' ignorable stations')
 1100 FORMAT ('TXTCAL: ERROR',I3,' READING CAL. FILE')
 1150 FORMAT ('TXTCAL: BASELINE RECORD WITHOUT TWO ANTENNAS')
 1300 FORMAT ('Baseline record read for: ',A8,' - ',A8)
 1400 FORMAT ('TXTCAL: GAIN RECORD MISSING STATION NAME')
 1410 FORMAT ('TXTCAL: GAIN RECORD MISSING DPFU (K/JY)')
 1415 FORMAT ('TXTCAL: NO GAIN CURVE TYPE SPECIFIED')
 1420 FORMAT ('TXTCAL: ERROR',I3,' READING TABULATED GAINS')
 1425 FORMAT ('TXTCAL: ODD NUMBER OF TABULATED GAIN VALUES')
 1480 FORMAT ('TXTCAL: ERROR',I3,' WRITING TO GC TABLE')
 1490 FORMAT ('Gain curve read for station: ',A8)
 1500 FORMAT ('TXTCAL: ',A4,' RECORD MISSING STATION NAME')
 1510 FORMAT ('TXTCAL: NO. OF INDEXED COLUMNS EXCEEDS: ',I3)
 1520 FORMAT ('TXTCAL: ERROR',I3,' READING ',A4,' VALUES')
 1530 FORMAT ('TXTCAL: BAD TIME: ',2F8.2,' after',I4,
     *   ' entries: ', A8)
 1535 FORMAT ('TXTCAL: INCOMPLETE ENTRY OF ',A4,' VALUES')
 1545 FORMAT ('TXTCAL: ERROR',I3,' WRITING TY TABLE')
 1590 FORMAT (I6,1X,A4,' records read for station: ',A8)
 1600 FORMAT ('! WARNING: If you are using Tsys infomation from the
     * *cal.vlba')
 1610 FORMAT ('! file for projects observed between the dates of
     * January 1,')
 1620 FORMAT ('! 2014 and October 19, 2015 then please be aware that
     * this data is')
 1630 FORMAT ('! from the VLBA LEGACY system.  The LEGACY system has
     * a different')
 1640 FORMAT ('! signal path from the RDBE/MARK5C system.  Do not
     * use *cal.vlba')
 1650 FORMAT ('! file FROM DATES ABOVE unless you understand what you
     * are doing.')
 1900 FORMAT (I6,' unidentified records skipped on input')
      END
      FUNCTION IKEY (LKEY, LPARS, NPARS)
C-----------------------------------------------------------------------
C   Routine to search array LPARS for string LKEY
C   Inputs:
C      LKEY    C*8     String to search for
C      LPARS   C*8(*)  Array to be searched
C      NPARS   I       Length of LPARS
C   Outputs:
C      IKEY    I       Index in LPARS; 0 if not found.
C-----------------------------------------------------------------------
      INTEGER IKEY, NPARS
      CHARACTER*8 LKEY, LPARS(NPARS)
C
      INCLUDE 'INCS:DMSG.INC'
      INTEGER I
C-----------------------------------------------------------------------
      I = 1
C                                       While (I < N) and (Not Found) do
20    IF ((I.GT.NPARS).OR.(LKEY.EQ.LPARS(I))) GO TO 50
         I = I + 1
         GO TO 20
C
50    IF (I.GT.NPARS) THEN
         WRITE (MSGTXT,1000) LKEY
         CALL MSGWRT (8)
         STOP
         END IF
C                                       Exit
      IKEY = I
      RETURN
C----------------------------------------------------------------------
1000  FORMAT ('FATAL ERROR: CONTACT AIPS ADMIN; LKEY=',A8)
      END
      SUBROUTINE TBCONS (IRET)
C----------------------------------------------------------------------
C   Consolidate the TY, GC and BL tables
C   Outputs:
C      IRET    I    Return code (0 => ok)
C----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ANTAB.INC'
      INCLUDE 'INCS:DCAT.INC'
C----------------------------------------------------------------------
      IRET = 0
C                                       Consolidate the GC table
      IF (WGAIN) THEN
C                                       Gain table entries were written
         CALL GCCONS (IRET)
      ELSE IF (IGCVIN.EQ.0) THEN
C                                       Null GC table was created
         CALL RMEXT (INDISK, ICNO, 'GC', IGCVER, CATBLK, BUFF1, IRET)
         END IF
      IF (IRET.NE.0) GO TO 999
C                                       Consolidate TY table
      IF (WTSYS) THEN
C                                       TY entries were written
         CALL TYCONS (IRET)
      ELSE IF (ITYVIN.EQ.0) THEN
C                                       Null TY table was created
         CALL RMEXT (INDISK, ICNO, 'TY', ITYVER, CATBLK, BUFF1, IRET)
         END IF
      IF (IRET.NE.0) GO TO 999
C                                       Consolidate BL table
      IF (WBFAC) CALL BLCONS (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Exit
999   RETURN
      END
      SUBROUTINE ANTBHI (IRET)
C----------------------------------------------------------------------
C   Subroutine to update the history file
C   Output:
C      IRET    I    Return code (0 => ok)
C----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ANTAB.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      LOGICAL WUPDAT
      CHARACTER LHIREC*72, LTIME*20
      INTEGER IERR, LDATE(3), ITIME(3)
C----------------------------------------------------------------------
      IRET = 0
C
      CALL HIINIT (3)
C                                       Open history table
      CALL HIOPEN (ILUN1, INDISK, ICNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
C                                       Task name and time
      CALL ZDATE (LDATE)
      CALL ZTIME (ITIME)
      CALL TIMDAT (ITIME, LDATE, LTIME(13:20), LTIME(1:12))
      WRITE (LHIREC,1010) TSKNAM, RLSNAM, LTIME(1:12), LTIME(13:20)
      CALL HIADD (ILUN1, LHIREC, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       UV-file name
      WRITE (LHIREC,1020) TSKNAM, LNAME, LCLASS, INDISK, INSEQ
      CALL HIADD (ILUN1, LHIREC, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Calibration file name
      WRITE (LHIREC,1040) TSKNAM, LINFIL
      CALL HIADD (ILUN1, LHIREC, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Subarray
      WRITE (LHIREC,1060) TSKNAM, ISUBA
      CALL HIADD (ILUN1, LHIREC, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       TYVER, GCVER, BLVER
      WRITE (LHIREC,1080) TSKNAM, ITYVER, IGCVER, IBLVER
      CALL HIADD (ILUN1, LHIREC, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Close HI file
      WUPDAT = .TRUE.
      CALL HICLOS (ILUN1, WUPDAT, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 980
      GO TO 999
C                                       Error
980   WRITE (MSGTXT,1980) IERR
C
990   CALL MSGWRT (8)
C                                       Exit
999   RETURN
C----------------------------------------------------------------------
1000  FORMAT ('ANTBHI: ERROR',I3,' OPENING HI TABLE')
1010  FORMAT (A6,' RELEASE: ',A8,' START TIME: ',A12,2X,A8)
1020  FORMAT (A6,' INNAME= ',A12,'.',A6,'.',I3,'.',I4)
1040  FORMAT (A6,' INFILE= ',A48)
1060  FORMAT (A6,' SUBARRAY= ',I4)
1080  FORMAT (A6,' TYVER= ',I4,' GCVER= ',I4,' BLVER= ',I4)
1980  FORMAT ('ANTBHI: ERROR',I3,' PROCESSING HISTORY FILE')
      END
      SUBROUTINE POLADJ (POLIN, POLOUT, N, OFFSET)
C-----------------------------------------------------------------------
C   Adjust 1-D polynomial coefficients for x-axis offset
C   Inputs:
C      POLIN   R(*) Input polynomial coefficients (ascending order)
C      N       I    Dimension of POLIN
C      OFFSET  R    Desired offset in x-abscissa
C   Outputs:
C      POLOUT  R(*) Transformed polynomial coefficients.
C-----------------------------------------------------------------------
      INTEGER N
      REAL POLIN(N), POLOUT(N), OFFSET
C
      DOUBLE PRECISION DSUM, DOFF, DCOMB
      INTEGER J, K, JJ, KK
C-----------------------------------------------------------------------
      DO 200 J = 1, N
         JJ = J - 1
         DSUM = DBLE (POLIN(J))
         DO 100 K = J+1, N
            KK = K - 1
            DOFF = DBLE (OFFSET)
            DSUM = DSUM + POLIN(K) * DCOMB (KK,JJ) * DOFF ** (KK-JJ)
100         CONTINUE
         POLOUT(J) = DSUM
200      CONTINUE
C                                       Exit
      RETURN
      END
      FUNCTION DCOMB (N, K)
C-----------------------------------------------------------------------
C   Coefficient for offset adjustment of polynomial coefficients
C   Inputs:
C      N       I   No of coefficients in series
C      K       I   (Order+1) of x term for which factor required
C   Output:
C      DCOMB   D   Factor for x**(k-1); combinatorial (N K)
C------------------------------------------------------------------------
      DOUBLE PRECISION DCOMB
      INTEGER N, K
C
      DOUBLE PRECISION DNUM, DENOM
      INTEGER I
C------------------------------------------------------------------------
      DCOMB = 0.0D0
      IF (K.GT.N) GO TO 999
      DNUM = 1.0D0
      DENOM = 1.0D0
C                                       Denominator
      DO 100 I = 1, K
         DENOM = DENOM * DBLE (I)
100      CONTINUE
C                                       Numerator
      DO 200 I = (1-K), 0
         DNUM = DNUM * DBLE (N + I)
200      CONTINUE
C
      IF (DENOM.NE.0.0D0) THEN
         DCOMB = DNUM / DENOM
      ELSE
         DCOMB = 1.0D0
         END IF
C                                       Exit
999   RETURN
      END
      SUBROUTINE DECOD (LINDX, NINDX, IPOLUV, NPOLUV, NIFUV, IMAP,
     *   NMAP, NCOL, IRET)
C------------------------------------------------------------------------
C   Subroutine to decode the INDEX or INDEX2 keyword strings
C   Inputs:
C      LINDX   C(*)*8   Input keyword string
C      NINDX   I        Dimension of LINDX
C      IPOLUV  I        Start polarization allowed (1=R; 2=L)
C      NPOLUV  I        No. of polarizations (1 or 2)
C      NIFUV   I        Maximum IF number allowed
C      NMAP    I        Dimension of IMAP
C   Outputs:
C      IMAP    I(2,*)   Mapping of polzn./IF to column no.
C      NCOL    I        No. of columns in keyword string
C      IRET    I        Return code (0 => ok)
C------------------------------------------------------------------------
      INTEGER NINDX, IPOLUV, NPOLUV, NIFUV, NMAP, NCOL, IRET
      CHARACTER*8 LINDX(NINDX)
      INTEGER IMAP(2,NMAP)
C
      INCLUDE 'INCS:DMSG.INC'
      INTEGER IENTRY
C------------------------------------------------------------------------
C                                       Initialisation
      IRET = 0
      NCOL = 0
      IENTRY = 1
C                                       While (Entry_no < Nindx) and
C                                         (Not Error) do
 50   IF ((IENTRY.GT.NINDX).OR.(IRET.NE.0)) GO TO 500
C                                       Skip blank entries
         IF (LINDX(IENTRY).EQ.'        ') GO TO 200
         NCOL = IENTRY
C                                       Parse and update IMAP
         CALL PARSE (LINDX(IENTRY), IPOLUV, NPOLUV, NIFUV, IENTRY,
     *      IMAP, NMAP, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1500)
            CALL MSGWRT (8)
            END IF
C
200      IENTRY = IENTRY + 1
         GO TO 50
C                                       Endwhile
500   CONTINUE
C
      RETURN
C-------------------------------------------------------------------------
1500  FORMAT ('DECOD: ERROR DECODING INDEX KEYWORD')
      END
      SUBROUTINE PARSE (LSTR, IPOLUV, NPOLUV, NIFUV, IENTRY, IMAP,
     *   NMAP, IRET)
C-----------------------------------------------------------------------
C   Subroutine to parse each INDEX or INDEX2 entry and update IMAP
C   Inputs:
C      LSTR     C*8    Input string
C      IPOLUV   I      Lowest allowed polarization (R=1; L=2)
C      NPOLUV   I      Max. no. of polzns. in table (1 or 2)
C      NIFUV    I      Max. no. IF's in data
C      IENTRY   I      Entry no. in INDEX keyword string
C      NMAP     I      Dimension of IMAP
C   Outputs:
C      IMAP     I(2,*) Map of polzn./IF to column no. in cal file
C      IRET     I      Return code (0 => ok)
C-----------------------------------------------------------------------
      CHARACTER LSTR*8
      INTEGER IPOLUV, NPOLUV, NIFUV, IENTRY, NMAP, IRET
      INTEGER IMAP(2,NMAP)
C
      INCLUDE 'INCS:DMSG.INC'
      LOGICAL WPROC, WVALID
      CHARACTER LPOPT(2), LOPER, LCHAR
      INTEGER JVALS(3), JPTR, J, NUMBER, ITYPE, K, IERR
      DATA LPOPT /'R', 'L'/
C-----------------------------------------------------------------------
C                                       Parse the entry
      J = 1
      IRET = 0
C                                       Reset stacks
      LOPER = ' '
      JPTR = 0
C                                       While (Not End_of_string) and
C                                             (Not Error) do
50    IF ((J.GT.8).OR.(IRET.NE.0)) GO TO 500
C                                       Get next symbol
         CALL GETSYM (LSTR, J, NUMBER, LCHAR, ITYPE)
C                                       End of string ?
         WPROC = (J.GT.8)
C                                       Case symbol_type of:
C                                       1: Character
         IF (ITYPE.NE.1) GO TO 200
C                                       Case Character of:
C                                       '|': process sub-string
            IF (LCHAR.NE.'|') GO TO 100
               WPROC = .TRUE.
               GO TO 180
C                                       ':': skip
100         IF (LCHAR.NE.':') GO TO 120
               GO TO 180
C                                       'R','L','X': valid operands
120         WVALID = .FALSE.
            DO 130 K = IPOLUV, (IPOLUV+NPOLUV-1)
               IF (LCHAR.EQ.LPOPT(K)) WVALID = .TRUE.
130            CONTINUE
            WVALID = (WVALID.OR.(LCHAR.EQ.'X'))
C
            IF (.NOT.WVALID) GO TO 150
C                                       Add to operand stack (should
C                                       not contain anything yet)
            IF (LOPER.NE.' ') THEN
               IRET = 3
               WRITE (MSGTXT,1130) LSTR
            ELSE
               LOPER = LCHAR
C                                       Reset number stack
               JPTR = 0
               END IF
C
            GO TO 180
C                                       Other character: error
150         IRET = 1
            WRITE (MSGTXT,1150) LCHAR, LSTR
            GO TO 180
C                                       Endcase (Character)
180         GO TO 350
C                                       2: Number; add to stack
200      IF (ITYPE.NE.2) GO TO 350
            JPTR = JPTR + 1
            IF (JPTR.GT.3) THEN
               IRET = 2
               WRITE (MSGTXT,1200) LSTR
               END IF
            IF (IRET.EQ.0) JVALS(JPTR) = NUMBER
            GO TO 350
C                                       Endcase (Symbol_type)
350      CONTINUE
C                                       Time to process the stacks ?
      IF (WPROC.AND.(IRET.EQ.0)) CALL PROCES (LOPER, JVALS, JPTR,
     *   IMAP, NMAP, NIFUV, IENTRY, IERR)
      IF (IERR.NE.0) THEN
         IRET = 9
C                                       Describe the error type
         IF (IERR.EQ.1) WRITE (MSGTXT,1351) LSTR
         IF (IERR.EQ.2) WRITE (MSGTXT,1352) LSTR
         IF (IERR.EQ.3) WRITE (MSGTXT,1353) LSTR
         IF (IERR.EQ.4) WRITE (MSGTXT,1354) LSTR
         IF (IERR.EQ.5) WRITE (MSGTXT,1355) LSTR
         END IF
C
      GO TO 50
C                                       Endwhile
500   IF (IRET.NE.0) CALL MSGWRT (8)
      RETURN
C-----------------------------------------------------------------------
1130  FORMAT ('PARSE: DOUBLE OPERAND: ',A8)
1150  FORMAT ('PARSE: INVALID CHARACTER (OR STOKES): ',A1,' IN: ',A8)
1200  FORMAT ('PARSE: TOO MANY NUMBERICAL ARGUMENTS: ',A8)
1351  FORMAT ('PARSE: NO ARGUMENT EXPECTED FOR X OPERAND: ',A8)
1352  FORMAT ('PARSE: UNIDENTIFIED OPERAND: ',A8)
1353  FORMAT ('PARSE: NO IF RANGE SPECIFIED: ',A8)
1354  FORMAT ('PARSE: IFNO. OUT OF RANGE: ',A8)
1355  FORMAT ('PARSE: NON-UNIQUE MAPPING: ',A8)
      END
      SUBROUTINE PROCES (LOPER, JVALS, JPTR, IMAP, NMAP, NIFUV,
     *   IENTRY, IRET)
C-----------------------------------------------------------------------
C   Process the operand and number stacks created by PARSE
C   Inputs:
C      JVALS   I(3)   Number stack (three deep)
C      NMAP    I      Dimension of IMAP
C      NIFUV   I      Max. no. of allowed IF's
C      IENTRY  I      Entry no. in INDEX keyword list
C   Input/output:
C      LOPER   C*1    Operand stack (one deep)
C      JPTR    I      Pointer to JVALS
C   Outputs:
C      IMAP    I(2,*) Map of polzn./IF to column number in cal. file
C      IRET    I      Return code (0 => ok)
C-----------------------------------------------------------------------
      CHARACTER LOPER
      INTEGER NMAP, IMAP(2,NMAP), JVALS(3), NIFUV, IENTRY, JPTR, IRET
C
      INTEGER KPOL, ISTART, IEND, INCIF, K
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Case Operand of:
C                                       'X':
      IF (LOPER.NE.'X') GO TO 100
C                                       No number argument expected
         IF (JPTR.NE.0) IRET = 1
         GO TO 450
C                                       'R','L': process
100   IF ((LOPER.NE.'R').AND.(LOPER.NE.'L')) GO TO 200
C                                       Check the number stack
         IF (JPTR.GT.0) THEN
            IF (JPTR.EQ.1) THEN
C                                       eg. 'R1'
               ISTART = JVALS(1)
               IEND = ISTART
               INCIF = 1
               END IF
            IF (JPTR.EQ.2) THEN
C                                       eg. 'R1:2'
               ISTART = JVALS(1)
               IEND = JVALS(2)
               INCIF = 1
               END IF
            IF (JPTR.EQ.3) THEN
C                                       eg. 'R10:16:2'
               ISTART = JVALS(1)
               IEND = JVALS(2)
               INCIF = JVALS(3)
               END IF
C                                       Check IF ranges
            IF ((ISTART.GT.IEND).OR.(IEND.GT.NIFUV)) IRET = 4
            IF (IRET.GT.0) GO TO 450
C                                       Update IMAP
            IF (LOPER.EQ.'R') KPOL = 1
            IF (LOPER.EQ.'L') KPOL = 2
            DO 170 K = ISTART, IEND, INCIF
               IF ((IMAP(KPOL,K).NE.IENTRY).AND.(IMAP(KPOL,K).NE.0))
     *            IRET = 5
               IMAP(KPOL,K) = IENTRY
170            CONTINUE
C
         ELSE
C                                       Number stack is empty
            IRET = 3
            END IF
         GO TO 450
C                                       Unidentified operand: error
200    IRET = 2
       GO TO 450
C                                       Endcase
450   CONTINUE
C                                       Reset stacks
      LOPER = ' '
      JPTR = 0
C
      RETURN
      END
      SUBROUTINE GETSYM (LSTR, I, NUM, LCHAR, ITYPE)
C-----------------------------------------------------------------------
C   Get the next symbol from an input string
C   Inputs:
C      LSTR   C*8   Input string to search
C   Input/output:
C      I      I     Current pointer in LSTR
C   Output:
C      NUM    I     Numerical value of symbol
C      LCHAR  C*1   Character symbol
C      ITYPE  I     Symbol type (1=character; 2=number; 0=none found)
C-----------------------------------------------------------------------
      CHARACTER LSTR*8, LCHAR
      INTEGER I, NUM, ITYPE
C
      LOGICAL WEND
      CHARACTER LDIGIT(10)
      INTEGER J, K
      DATA LDIGIT /'0','1','2','3','4','5','6','7','8','9'/
C----------------------------------------------------------------------
      NUM = 0
      LCHAR = ' '
      ITYPE = 0
      WEND = .FALSE.
C                                       Repeat
C                                        Case (Character) of:
C                                        SPACE: skip
50    IF (LSTR(I:I).NE.' ') GO TO 100
         GO TO 300
C                                        CHARACTER:
100   J = 0
      DO 120 K = 1, 10
         IF (LSTR(I:I).EQ.LDIGIT(K)) J = K
120      CONTINUE
      IF (J.NE.0) GO TO 150
C
         IF (ITYPE.EQ.2) THEN
            WEND = .TRUE.
            I = I - 1
         ELSE
            LCHAR = LSTR(I:I)
            ITYPE = 1
            END IF
         GO TO 300
C                                        DIGIT:
150   NUM = 10 * NUM + (J - 1)
      ITYPE = 2
      GO TO 300
C                                        Endcase
300   CONTINUE
C                                       Until (end_of_string) or
C                                          (character_found) or
C                                          (end_of_number)
      I = I + 1
      IF ((I.LE.8).AND.(ITYPE.NE.1).AND.(.NOT.WEND)) GO TO 50
C                                       Exit
      RETURN
      END
      SUBROUTINE DAYYR (IYR, IMONTH, IDAY, IDAYNO, ILOYR)
C-----------------------------------------------------------------------
C   Subroutine to compute day number (Jan 1 = 1) from Gregorian date
C   Inputs:
C      IYR     I   Year number (eg. 1994)
C      IMONTH  I   Month number (Jan=1, Feb=2,.., Dec=12)
C      IDAY    I   Day of month
C   Outputs:
C      IDAYNO  I   Day number (Jan. 1 = 1)
C      ILOYR   I   No. of days in year (365 or 366)
C----------------------------------------------------------------------
      INTEGER IYR, IMONTH, IDAY, IDAYNO, ILOYR
C
      LOGICAL WLEAP
      INTEGER IDSUM(12)
      DATA IDSUM /0,31,59,90,120,151,181,212,243,273,304,334/
C----------------------------------------------------------------------
      IDAYNO = IDSUM(IMONTH) + IDAY
      ILOYR = 365
C                                       Leap year ?
      WLEAP = (MOD(IYR,4).EQ.0)
C                                       Centurial leap years ?
      IF (WLEAP.AND.(MOD(IYR,100).EQ.0)) WLEAP = (MOD(IYR,400).EQ.0)
C
      IF (WLEAP.AND.(IMONTH.GT.2)) IDAYNO = IDAYNO + 1
      IF (WLEAP) ILOYR = 366
      RETURN
      END
      SUBROUTINE NXSRCH (RTIME, ISOUID, IFQID)
C----------------------------------------------------------------------
C   Search the NX table for the source and freq. ID. at a given time
C   Inputs:
C      RTIME   R   Input time relative to the ref. date (in days)
C   Outputs:
C      ISOUID  I   Source id. (0 if not found)
C      IFQID   I   FQ. id.
C---------------------------------------------------------------------
      REAL RTIME
      INTEGER ISOUID, IFQID
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ANTAB.INC'
      INTEGER I
C---------------------------------------------------------------------
      ISOUID = 0
      IFQID = 0
C                                       Search the NX table
      DO 100 I = 1, NXDAT
         IF ((RTIME .GE. (TIMENX(1,I) - DELTAT)) .AND.
     *      (RTIME .LE.  (TIMENX(2,I) + DELTAT))) THEN
            ISOUID = INXSOU(I)
            IFQID = INXFQ(I)
            END IF
100      CONTINUE
C                                       Exit
      RETURN
      END
      SUBROUTINE GCCONS (IRET)
C----------------------------------------------------------------------
C   Consolidate the GC table; later entries overwrite previous entries.
C   Output:
C      IRET    I    Return code (0 => ok)
C----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PGCV.INC'
      INCLUDE 'ANTAB.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INTEGER MXKINX
      PARAMETER (MXKINX = 1024)
      REAL XVALGC(2,MAXIF), YVALGC(2,MAXIF,MXTBGC),
     *   GAINGC(2,MAXIF,MXTBGC), SENSGC(2,MAXIF), XVALG2(2,MAXIF),
     *   YVALG2(2,MAXIF,MXTBGC), GAING2(2,MAXIF,MXTBGC),
     *   SENSG2(2,MAXIF)
      INTEGER IGCRNO, GCKOLS(MAXGCC), GCNUMV(MAXGCC), NPOLGC, NTABGC,
     *   NOBAND, IERR, IANTGC, ISUBGC, IFQDGC,
     *   ITPGC(2,MAXIF), NTGC(2,MAXIF), IXTGC(2,MAXIF), IYTGC(2,MAXIF),
     *   IANTG2, ISUBG2, IFQDG2, ITPG2(2,MAXIF), NTG2(2,MAXIF),
     *   IXTG2(2,MAXIF), IYTG2(2,MAXIF), IGCRN2, MSGSAV
      INTEGER NKINDX, KINDX(MXKINX), I, J, NROW, JPOL, JIF, M
C----------------------------------------------------------------------
      IRET = 0
C                                       Open input GC table
      CALL GCINI ('READ', BUFF1, INDISK, ICNO, IGCVER, CATBLK, ILUN1,
     *   IGCRNO, GCKOLS, GCNUMV, NPOLGC, NOBAND, NTABGC, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C
      NKINDX = 0
      NROW = BUFF1(5)
C                                       Check table size
      IF (MXKINX.LT.NROW) THEN
         IRET = 6
         WRITE (MSGTXT,1030)
         GO TO 990
         END IF
C                                       Compile index
      DO 100 I = 1, NROW
         IGCRNO = I
         CALL TABGC ('READ', BUFF1, IGCRNO, GCKOLS, GCNUMV, NPOLGC,
     *      NTABGC, IANTGC, ISUBGC, IFQDGC, ITPGC, NTGC, IXTGC,
     *      IYTGC, XVALGC, YVALGC, GAINGC, SENSGC, IERR)
         IF (IERR.EQ.-1) GO TO 100
         IF (IERR.NE.0) THEN
            IRET = 2
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Add to keyword index
         NKINDX = NKINDX + 1
         KINDX(NKINDX) = (ISUBGC - 1) * MAXANT * MXFQID +
     *      (IFQDGC - 1) * MAXANT + IANTGC
100      CONTINUE
C                                       Open output table
      IGCTMP = 0
      CALL GCINI ('WRIT', BUFF2, INDISK, ICNO, IGCTMP, CATBLK, ILUN2,
     *   IGCRN2, GCKOLS, GCNUMV, NPOLGC, NOBAND, NTABGC, IERR)
      IF (IERR.NE.0) THEN
         IRET = 3
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       Write consolidated table
      DO 300 I = 1,NKINDX
C                                       Skip records already processed
         IF (KINDX(I).LE.0) GO TO 300
C                                       Read record
         IGCRNO = I
         CALL TABGC ('READ', BUFF1, IGCRNO, GCKOLS, GCNUMV, NPOLGC,
     *      NTABGC, IANTGC, ISUBGC, IFQDGC, ITPGC, NTGC, IXTGC, IYTGC,
     *      XVALGC, YVALGC, GAINGC, SENSGC, IERR)
         IF (IERR.EQ.-1) GO TO 300
         IF (IERR.NE.0) THEN
            IRET = 4
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C
         DO 200 J = (I+1), NKINDX
C                                       Look for records with
C                                       matching keywords
            IF (KINDX(J).EQ.KINDX(I)) THEN
C                                       Read matching record
               IGCRNO = J
               CALL TABGC ('READ', BUFF1, IGCRNO, GCKOLS, GCNUMV,
     *            NPOLGC, NTABGC, IANTG2, ISUBG2, IFQDG2, ITPG2, NTG2,
     *            IXTG2, IYTG2, XVALG2, YVALG2, GAING2, SENSG2, IERR)
               IF (IERR.EQ.-1) GO TO 200
               IF (IERR.NE.0) THEN
                  IRET = 4
                  WRITE (MSGTXT,1050) IERR
                  GO TO 990
                  END IF
C                                       Consolidate the two records
               DO 150 JPOL = 1,NPOLGC
                  DO 120 JIF = 1,NOBAND
C                                       Skip null records
                     IF (ITPG2(JPOL,JIF).EQ.0) GO TO 120
C
                     IF ((ITPGC(JPOL,JIF).EQ.0).OR.
     *                  ((ITPG2(JPOL,JIF).EQ.ITPGC(JPOL,JIF)).AND.
     *                  ((IXTG2(JPOL,JIF).EQ.IXTGC(JPOL,JIF)).AND.
     *                  (XVALG2(JPOL,JIF).EQ.XVALGC(JPOL,JIF))))) THEN
C                                       Overwrite the earlier record
                        ITPGC(JPOL,JIF) = ITPG2(JPOL,JIF)
                        NTGC(JPOL,JIF) = NTG2(JPOL,JIF)
                        IXTGC(JPOL,JIF) = IXTG2(JPOL,JIF)
                        IYTGC(JPOL,JIF) = IYTG2(JPOL,JIF)
                        XVALGC(JPOL,JIF) = XVALG2(JPOL,JIF)
                        SENSGC(JPOL,JIF) = SENSG2(JPOL,JIF)
                        DO 115 M = 1, NTABGC
                           YVALGC(JPOL,JIF,M) = YVALG2(JPOL,JIF,M)
                           GAINGC(JPOL,JIF,M) = GAING2(JPOL,JIF,M)
115                        CONTINUE
C                                       Mark 2nd record as processed
                        KINDX(J) = 0
                        END IF
120                  CONTINUE
150               CONTINUE
C
               END IF
200         CONTINUE
C                                       Write output record
            CALL TABGC ('WRIT', BUFF2, IGCRN2, GCKOLS, GCNUMV, NPOLGC,
     *         NTABGC, IANTGC, ISUBGC, IFQDGC, ITPGC, NTGC, IXTGC,
     *         IYTGC, XVALGC, YVALGC, GAINGC, SENSGC, IERR)
            IF (IERR.NE.0) THEN
               IRET = 5
               WRITE (MSGTXT,1200) IERR
               GO TO 990
               END IF
C
300      CONTINUE
C                                       Close the tables
      CALL TABIO ('CLOS', 0, IGCRNO, BUFF1, BUFF1, IERR)
      CALL TABIO ('CLOS', 0, IGCRN2, BUFF2, BUFF2, IERR)
C                                       Delete the old table
      CALL RMEXT (INDISK, ICNO, 'GC', IGCVER, CATBLK, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IRET = 7
         WRITE (MSGTXT,1300) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Copy new to old
      MSGSAV = MSGSUP
      MSGSUP = 31999
      CALL TABCOP ('GC', IGCTMP, IGCVER, ILUN1, ILUN2, INDISK, INDISK,
     *   ICNO, ICNO, CATBLK, BUFF1, BUFF2, IERR)
      MSGSUP = MSGSAV
      IF (IERR.NE.0) THEN
         IRET = 8
         WRITE (MSGTXT,1310) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Delete 2nd copy of new table
      CALL RMEXT (INDISK, ICNO, 'GC', IGCTMP, CATBLK, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IRET = 7
         WRITE (MSGTXT,1300) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Close tables
      IF (IRET.NE.1) CALL TABIO ('CLOS', 0, IGCRNO, BUFF1, BUFF1, IERR)
      IF (IRET.NE.3) CALL TABIO ('CLOS', 0, IGCRN2, BUFF2, BUFF2, IERR)
C                                       Exit
999   RETURN
C----------------------------------------------------------------------
1020  FORMAT ('GCCONS: ERROR',I3,' OPENING GC TABLE')
1030  FORMAT ('GCCONS: CONTACT AIPS ADMIN: PARAMETER MXKINX TOO SMALL')
1050  FORMAT ('GCCONS: ERROR',I3,' READING GC TABLE')
1200  FORMAT ('GCCONS: ERROR',I3,' WRITING GC TABLE')
1300  FORMAT ('GCCONS: ERROR',I3,' DELETING TY TABLE')
1310  FORMAT ('GCCONS: ERROR',I3,' COPYING TY TABLE')
      END
      SUBROUTINE TYCONS (IRET)
C----------------------------------------------------------------------
C   Consolidate the TY table; new entries overwrite older ones.
C   Outputs:
C      IRET    I    Return code (0 => ok)
C----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ANTAB.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INTEGER MXKINX
      PARAMETER (MXKINX = 200000)
      LOGICAL WMATCH, WTYRAT, WTYSYS, WTYANT
      REAL TIMETY, TINTTY, TSYST(2,MAXIF), TANT(2,MAXIF), TIMET2,
     *   TINTT2, TSYST2(2,MAXIF), TANT2(2,MAXIF), TIMNDX(MXKINX)
      INTEGER ITYRNO, ITYRN2, TYKOLS(MAXTYC), TYNUMV(MAXTYC), NPOLTY,
     *   NIFTY, IERR, ITYSOU, ITYANT, ITYSUB, ITYFQD, IT2SOU, IT2ANT,
     *   IT2SUB, IT2FQD, MSGSAV
      INTEGER NKINDX, KINDX(MXKINX), INDXSU(MXKINX), I, J, JPOL, JIF,
     *   NROW
C----------------------------------------------------------------------
      IRET = 0
C                                       Open input TY table
      CALL TYINI ('READ', BUFF1, INDISK, ICNO, ITYVER, CATBLK, ILUN1,
     *   ITYRNO, TYKOLS, TYNUMV, NPOLTY, NIFTY, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C
      NROW = BUFF1(5)
      NKINDX = 0
C                                       Check table size
      IF (MXKINX.LT.NROW) THEN
         IRET = 6
         WRITE (MSGTXT,1030)
         GO TO 990
         END IF
C                                       Compile index
      DO 100 I = 1, NROW
         ITYRNO = I
         CALL TABTY ('READ', BUFF1, ITYRNO, TYKOLS, TYNUMV, NPOLTY,
     *      NIFTY, TIMETY, TINTTY, ITYSOU, ITYANT, ITYSUB, ITYFQD,
     *      TSYST, TANT, IERR)
         IF (IERR.EQ.-1) GO TO 100
         IF (IERR.NE.0) THEN
            IRET = 2
            WRITE (MSGTXT,1100) IERR
            GO TO 990
            END IF
C                                       Add to keyword index
         NKINDX = NKINDX + 1
         KINDX(NKINDX) = (ITYSUB - 1) * MAXANT * MXFQID +
     *      (ITYFQD - 1) * MAXANT + ITYANT
         TIMNDX(NKINDX) = TIMETY
         INDXSU(NKINDX) = ITYSOU
100      CONTINUE
C                                       Open output table
      ITYTMP = 0
      CALL TYINI ('WRIT', BUFF2, INDISK, ICNO, ITYTMP, CATBLK, ILUN2,
     *   ITYRN2, TYKOLS, TYNUMV, NPOLTY, NIFTY, IERR)
      IF (IERR.NE.0) THEN
         IRET = 3
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       Write consolidated table
      DO 300 I = 1, NKINDX
C                                       Skip records already processed
         IF (KINDX(I).LE.0) GO TO 300
C                                       Read record
         ITYRNO = I
         CALL TABTY ('READ', BUFF1, ITYRNO, TYKOLS, TYNUMV, NPOLTY,
     *      NIFTY, TIMETY, TINTTY, ITYSOU, ITYANT, ITYSUB, ITYFQD,
     *      TSYST, TANT, IERR)
         IF (IERR.EQ.-1) GO TO 300
         IF (IERR.NE.0) THEN
            IRET = 4
            WRITE (MSGTXT,1100) IERR
            GO TO 990
            END IF
C
         DO 200 J = (I+1), NKINDX
C                                       Look for matching keywords
            WMATCH = ((KINDX(I).EQ.KINDX(J)).AND.(TIMNDX(J).EQ.
     *         TIMNDX(I)).AND.(INDXSU(I).EQ.INDXSU(J)))
            IF (WMATCH) THEN
C                                       Read matching record
               ITYRNO = J
               CALL TABTY ('READ', BUFF1, ITYRNO, TYKOLS, TYNUMV,
     *            NPOLTY, NIFTY, TIMET2, TINTT2, IT2SOU, IT2ANT,
     *            IT2SUB, IT2FQD, TSYST2, TANT2, IERR)
               IF (IERR.EQ.-1) GO TO 200
               IF (IERR.NE.0) THEN
                  IRET = 4
                  WRITE (MSGTXT,1100) IERR
                  GO TO 990
                  END IF
C                                       Consolidate the two records
               DO 150 JPOL = 1, NPOLTY
                  DO 120 JIF = 1, NIFTY
C                                       Skip blank records
                     IF ((TSYST2(JPOL,JIF).EQ.FBLANK).AND.
     *                  ((TANT2(JPOL,JIF).EQ.FBLANK).OR.
     *                  (TANT2(JPOL,JIF).LT.0.0))) GO TO 120
C                                       Determine record type
                     WTYRAT = ((TSYST2(JPOL,JIF).NE.FBLANK).AND.
     *                  (TANT2(JPOL,JIF).LT.0.0))
                     WTYSYS = ((TSYST2(JPOL,JIF).NE.FBLANK).AND.
     *                  (TANT2(JPOL,JIF).EQ.FBLANK))
                     WTYANT = ((TSYST2(JPOL,JIF).EQ.FBLANK).AND.
     *                  (TANT2(JPOL,JIF).NE.FBLANK))
C                                       New record is Ta/Tsys
                     IF (WTYRAT) THEN
                        TSYST(JPOL,JIF) = TSYST2(JPOL,JIF)
                        TANT(JPOL,JIF) = TANT2(JPOL,JIF)
                        END IF
C                                       New record is Tsys
                     IF (WTYSYS) THEN
                        TSYST(JPOL,JIF) = TSYST2(JPOL,JIF)
                        IF (TANT(JPOL,JIF).LT.0.0)
     *                     TANT(JPOL,JIF) = FBLANK
                        END IF
C                                       New record is Tant
                     IF (WTYANT) THEN
                        IF (TANT(JPOL,JIF).LT.0.0)
     *                     TSYST(JPOL,JIF) = FBLANK
                        TANT(JPOL,JIF) = TANT2(JPOL,JIF)
                        END IF
120                  CONTINUE
150               CONTINUE
C                                       Mark 2nd record as processed
               KINDX(J) = 0
C
               END IF
200         CONTINUE
C                                       Write output record
         CALL TABTY ('WRIT', BUFF2, ITYRN2, TYKOLS, TYNUMV, NPOLTY,
     *      NIFTY, TIMETY, TINTTY, ITYSOU, ITYANT, ITYSUB, ITYFQD,
     *      TSYST, TANT, IERR)
         IF (IERR.NE.0) THEN
            IRET = 5
            WRITE (MSGTXT,1200) IERR
            GO TO 990
            END IF
C
300   CONTINUE
C                                       Close the tables
      CALL TABIO ('CLOS', 0, ITYRNO, BUFF1, BUFF1, IERR)
      CALL TABIO ('CLOS', 0, ITYRN2, BUFF2, BUFF2, IERR)
C                                       Delete the old table
      CALL RMEXT (INDISK, ICNO, 'TY', ITYVER, CATBLK, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IRET = 7
         WRITE (MSGTXT,1300) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Copy new to old
      MSGSAV = MSGSUP
      MSGSUP = 31999
      CALL TABCOP ('TY', ITYTMP, ITYVER, ILUN1, ILUN2, INDISK,
     *   INDISK, ICNO, ICNO, CATBLK, BUFF1, BUFF2, IERR)
      MSGSUP = MSGSAV
      IF (IERR.NE.0) THEN
         IRET = 8
         WRITE (MSGTXT,1310) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Delete 2nd copy of new table
      CALL RMEXT (INDISK, ICNO, 'TY', ITYTMP, CATBLK, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IRET = 7
         WRITE (MSGTXT,1300) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
      IF (IRET.NE.1) CALL TABIO ('CLOS', 0, ITYRNO, BUFF1, BUFF1, IERR)
      IF (IRET.NE.3) CALL TABIO ('CLOS', 0, ITYRN2, BUFF2, BUFF2, IERR)
C                                       Exit
999   RETURN
C---------------------------------------------------------------------
1020  FORMAT ('TYCONS: ERROR',I3,' OPENING TY TABLE')
1030  FORMAT ('TYCONS: CONTACT AIPS ADMIN: PARAMETER MXKINX TOO SMALL')
1100  FORMAT ('TYCONS: ERROR',I3,' READING TY TABLE')
1200  FORMAT ('TYCONS: ERROR',I3,' WRITING TY TABLE')
1300  FORMAT ('TYCONS: ERROR',I3,' DELETING TY TABLE')
1310  FORMAT ('TYCONS: ERROR',I3,' COPYING TY TABLE')
      END
      SUBROUTINE BLCONS (IRET)
C---------------------------------------------------------------------
C   Consolidate the BL table; newer entries overwrite older ones
C   Outputs:
C      IRET    I     Return code (0 => ok)
C---------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ANTAB.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DMSG.INC'
      REAL FACMUL(2,2,MAXIF), FACADD(2,2,MAXIF), BLTIME, BLFAC
      INTEGER IBLRNO, BLNUMV(MAXBLC), BLKOLS(MAXBLC), IERR, NPOLBL,
     *   NIFBL, IBLSOU, IBLFQD, NROW, I, IBLANT, JBLANT, JIF, JPOL,
     *   NDIM, NANTBL, IBLSUB, JFQID, J
C--------------------------------------------------------------------
      IRET = 0
C                                       Open input BL table
      NPOLBL = NPOLUV
      NIFBL = NIFUV
      NANTBL = NSTNS
      CALL BLINI ('WRIT', BUFF1, INDISK, ICNO, IBLVER, CATBLK, ILUN1,
     *   IBLRNO, BLKOLS, BLNUMV, NANTBL, NPOLBL, NIFBL, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C
      NROW = BUFF1(5)
      DO 100 I = 1, NROW
C                                       Read record
         IBLRNO = I
         CALL TABBL ('READ', BUFF1, IBLRNO, BLKOLS, BLNUMV, NPOLBL,
     *      BLTIME, IBLSOU, IBLSUB, IBLANT, JBLANT, IBLFQD,
     *      FACMUL, FACADD, IERR)
         IF (IERR.EQ.-1) GO TO 100
         IF (IERR.NE.0) THEN
            IRET = 2
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Is there an entry for this
C                                       baseline ?
         BLFAC = BFAC(IBLANT,JBLANT)
         IF (BLFAC.GT.0.0) THEN
            DO 50 JIF = 1, NIFBL
               DO 40 JPOL = 1, NPOLBL
                  FACMUL(1,JPOL,JIF) = BLFAC
                  FACMUL(2,JPOL,JIF) = 0.0
40                CONTINUE
50             CONTINUE
C                                       Mark as used
            BFAC(IBLANT,JBLANT) = 0.0
C                                       Re-write record
            IBLRNO = I
            CALL TABBL ('WRIT', BUFF1, IBLRNO, BLKOLS, BLNUMV, NPOLBL,
     *         BLTIME, IBLSOU, IBLSUB, IBLANT, JBLANT, IBLFQD, FACMUL,
     *         FACADD, IERR)
            IF (IERR.NE.0) THEN
               IRET = 3
               WRITE (MSGTXT,1060) IERR
               GO TO 990
               END IF
            END IF
100      CONTINUE
C                                       Append new entries to end
C                                       of table
      IBLRNO = NROW + 1
      DO 300 I = 1, NSTNS
         IBLANT = TELNO(I)
         DO 200 J = 1, NSTNS
            JBLANT = TELNO(J)
            BLFAC = BFAC(IBLANT,JBLANT)
            IF (BLFAC.GT.0.0) THEN
C                                       Write a record for each FQID
               DO 180 JFQID = 1, NFQUV
                  IBLFQD = IFQUV(JFQID)
C                                       Initialise new BL record
                  NDIM = 4 * MAXIF
                  CALL RFILL (NDIM, 0.0, FACADD)
                  BLTIME = 0.0
                  IBLSOU = -1
                  IBLSUB = ISUBA
C                                       Loop over IF/polzn.
                  DO 150 JIF = 1, NIFBL
                     DO 140 JPOL = 1, NPOLBL
                        FACMUL(1,JPOL,JIF) = BLFAC
                        FACMUL(2,JPOL,JIF) = 0.0
140                     CONTINUE
150                  CONTINUE
C                                       Write new record
                  CALL TABBL ('WRIT', BUFF1, IBLRNO, BLKOLS, BLNUMV,
     *               NPOLBL, BLTIME, IBLSOU, IBLSUB, IBLANT, JBLANT,
     *               IBLFQD, FACMUL, FACADD, IERR)
                  IF (IERR.NE.0) THEN
                     IRET = 4
                     WRITE (MSGTXT,1060) IERR
                     GO TO 990
                     END IF
180               CONTINUE
               END IF
200         CONTINUE
300      CONTINUE
C                                       Close BL table
      CALL TABIO ('CLOS', 0, IBLRNO, BUFF1, BUFF1, IERR)
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C
999   IF (IRET.NE.0) CALL TABIO ('CLOS', 0, IBLRNO, BUFF1, BUFF1, IERR)
C                                       Exit
      RETURN
C------------------------------------------------------------------------
1020  FORMAT ('BLCONS: ERROR',I3,' OPENING BL TABLE')
1050  FORMAT ('BLCONS: ERROR',I3,' READING BL TABLE')
1060  FORMAT ('BLCONS: ERROR',I3,' WRITING BL TABLE')
      END

      SUBROUTINE HIADDN (LUN, N, HILINE, BUF, CHK, IERR)
C-----------------------------------------------------------------------
C! Writes one history line to several history files
C# History
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   HIADDN is used by HIMERG for output to avoid large numbers of loops.
C   Inputs:
C      LUN  I(N)     Input LUNs.
C      CHK  I(N)     Only write if CHK(I) = 0.
C      N             Number of files (including "dummies").
C      HILINE        String to add.
C   In/Out:
C      BUF  I(256,N) Working buffers
C      IERR I        Error code = max error code generated by HIADD
C-----------------------------------------------------------------------
      INTEGER   N, IERR
      INTEGER   LUN(*), CHK(*), BUF(256,*)
      CHARACTER HILINE*(*)
      INTEGER   J, JER
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      DO 10 J = 1,N
         IF (CHK(J) .NE. 0) GO TO 10
            CALL HIADD (LUN(J), HILINE, BUF(1,J), JER)
            IF (JER .NE. 0) THEN
               WRITE (MSGTXT,1910) JER, J
               CHK(J) = -1
               IERR = MAX(IERR,JER)
               END IF
 10      CONTINUE
      RETURN
C-----------------------------------------------------------------------
 1910 FORMAT ('HIADDN ADD ERROR',I7,' ON OUTPUT FILE',I3)
      END

      SUBROUTINE ACSHFT (DATA, ISB, NIFRQ, DELI, WORK, ISMTH)
C-----------------------------------------------------------------------
C! Frequency shift spectra
C# UV IO-appl Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998-1999
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to perform the frequency shift for AC data.
C   The imaginary part is zeroed on entry.
C   Inputs:
C      ISB           I        Sideband
C      NFRQ          I        No. freq. channels in spectrum
C      DELI          D        No. channels to shift spectrum
C      WORK(*)       R        Work array (same size as data array)
C      ISMTH         I        0 => no smoothing
C                             1 => hanning smooth while shifting
C   Input/output:
C      DATA(2,*)     R        The total-power spectrum to be shifted.
C                             DATA(1,*) is the real part DATA(2,*) is
C                             the imaginary part (0).
C                             Will also contain shifted result
C-----------------------------------------------------------------------
      REAL    DATA(2,*), WORK(*)
      DOUBLE PRECISION  DELI
      INTEGER   ISB, NIFRQ, ISMTH
C
      REAL    ADELI, STORE, DELA, CDA, SDA, CA, SA, RFACT, AVG
      INTEGER   NFRQ, NFRQ2, NSHIFT, I, N, K, NTRANS, FFTDIR
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      NFRQ = NIFRQ

      RFACT = 1.0
      NFRQ2 = NFRQ * 2
C                                       Reflect spectrum
      NSHIFT = NFRQ2 + 2
      AVG = DATA(1,1)
      DATA(2,1) = 0.0
      DO 10 I = 2,NFRQ
         N = NSHIFT - I
         AVG = AVG + DATA(1,I)
         DATA(1,N) = DATA(1,I)
         DATA(2,I) = 0.
         DATA(2,N) = 0.
 10      CONTINUE
      AVG = AVG / NFRQ
      DATA(1,NFRQ+1) = AVG
      DATA(2,NFRQ+1) = 0.
C                                       Do FFT
      NTRANS = NFRQ2
      FFTDIR = ISB
      CALL FOURG (DATA, NTRANS, FFTDIR, WORK)
C
      ADELI = DELI
C                                       Determine shift parms
C                                       Set normalization
C                                       (ie divide by NFRQ2)
      DELA  = TWOPI * ADELI / NFRQ2
      CDA   = COS( DELA )
      SDA   = SIN( DELA )
      CA    = 1.0 / NFRQ2
      SA    = 0.0
C                                       Multiply correlation function
C                                       by the complex exponent
C                                       corresponding to the spectrum
C                                       shift and smoothing function.
      DO 200 I = 1,NFRQ
         K = NFRQ2 + 1 - I
C
         STORE     = DATA(1,I)
         DATA(1,I) = RFACT * (DATA(1,I) * CA  -  DATA(2,I) * SA)
         DATA(2,I) = RFACT * (    STORE * SA  +  DATA(2,I) * CA)
C
         STORE = CA
         CA    =    CA * CDA  -  SA * SDA
         SA    = STORE * SDA  +  SA * CDA
C
         IF (ISMTH.EQ.1) RFACT = 0.5*(1.0+COS(PI*I/NFRQ))
         STORE = DATA(1,K)
         DATA(1,K) = RFACT * (DATA(1,K) * CA + DATA(2,K) * SA)
         DATA(2,K) = RFACT * (-STORE * SA    + DATA(2,K) * CA)
C
  200 CONTINUE
C                                       Transform to spectrum
      FFTDIR = -FFTDIR
      CALL FOURG ( DATA, NTRANS, FFTDIR, WORK )
C                                       Zero image part
      DO 300 I = 1,NFRQ
C         DATA(1,I) = DATA(1,I) + 1.0
         DATA(2,I) = 0.0
  300    CONTINUE
C
 999  RETURN
      END

      SUBROUTINE QCLNSU (COMP, LMAP, L1MAP, L2MAP, IBX, IBY, JNDEX,
     *   INDEX)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Low level Clark CLEAn routine
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   QCLNSU does a CLEAN on a list of residuals using a given beam
C   patch
C    Inputs:
C      COMP(4)  R    Component vector:
C                 0 => intensity
C                 1 => x in cells
C                 2 => Y in cells
C                 3 => CLEAN loop gain (fractional)
C      LMAP     I    number of residuals
C      L1MAP    I    First residual in Y window
C      L2MAP    I    Last residual in Y window
C      IBX,IBY  I    Beam patch half width in X and Y
C                    Residuals with delta X or Y from the component
C                    position in COMP .GE. IBX,IBY are to be ignored.
C      JNDEX    I    0 - rel Index in FLUX, IX, IY of next residual
C                    to sub.
C   Input From Vector Work common:
C      IWVEC3   I    = IX, X pixel location of residuals
C      IWVEC4   I    = IY, Y pixel location of residuals
C      WKVEC5   R    = FLUX, Residual flux density
C      WKVEC6,7 R    = BEAM, BEAM patch.
C   Output:
C      INDEX    I    Index in FLUX of next residual.
C   Useage notes:
C     The following common work vectors are used:
C      IWVEC8   = IDXRAY  => array of x pixel offsets
C                 also FLXTMP => temporary flux array
C      IWVEC9   = IDYRAY  => array of y pixel offsets
C      IWVECA   = IB      => indirect address array
C      IWVECB   = BEMADR  => Beam address array
C      WKVECC   = BEMTMP  => Beam address array
C   CRI version.
C-----------------------------------------------------------------------
      INTEGER   ISAMAX, KMAX, INCX, IDXRAY(1),  IDYRAY(1), IADX(1)
      INTEGER   L21MAP, NIB, IB(1)
      INTEGER   AMAP, LMAP, ABEAM, BBEAM, IBX, IBY, IDX, IDY,
     *   L1MAP, L2MAP, INDEX, BOFF, BEMADR(1), LROW, LIMIT, ADDR,
     *   JCOMP, JAMAP, JBBEAM, LOOP, XCOMP, YCOMP, X, Y, N1, JNDEX
      INTEGER   IX(1), IY(1)
      REAL      SUBT, COMP(4), BEAM(1), FLUX(1), BEMTMP(1),
     *   FLXTMP(1), XMAX, AXMAX
      INCLUDE 'INCS:DAPC.INC'
      EQUIVALENCE (IDXRAY, FLXTMP, IWVEC8), (IDYRAY, IADX, IWVEC9),
     *   (IB, IWVECA), (BEMADR, IWVECB), (BEMTMP, WKVECC)
      EQUIVALENCE (IX, IWVEC3),
     *   (IY, IWVEC4), (FLUX, WKVEC5), (BEAM, WKVEC6)
      DATA N1 /1/
C-----------------------------------------------------------------------
      LROW = 2 * IBY - 1
      BOFF = (IBX-1) * LROW + IBY
      IF (LMAP.LE.0) GO TO 999
C                                        Get component to be CLEANed
      XCOMP = COMP(2) + 0.5
      YCOMP = COMP(3) + 0.5
      SUBT = COMP(1) * COMP(4)
C                                       Get residual x offsets
      INCLUDE 'INCS:ZVND.INC'
      DO 50 LOOP = L1MAP,L2MAP
         IDXRAY(LOOP) = IX(LOOP+JNDEX) - XCOMP
         IADX(LOOP) = ABS (IDXRAY(LOOP))
 50      CONTINUE
C                                        Compress x window
      L21MAP = L2MAP - L1MAP + 1
      CALL WHENILT (L21MAP, IADX(L1MAP), N1, IBX, IB, NIB)
C                                       Compress IDXRAY, IY
      CALL GATHER (NIB, IDXRAY, IDXRAY(L1MAP), IB)
      CALL GATHER (NIB, IDYRAY, IY(L1MAP+JNDEX), IB)
C                                       Get residual y offsets
      INCLUDE 'INCS:ZVND.INC'
      DO 60 LOOP = 1,NIB
         IDYRAY(LOOP) = IDYRAY(LOOP) - YCOMP
 60      CONTINUE
C                                        Compute beam address
      INCLUDE 'INCS:ZVND.INC'
      DO 110 LOOP = 1,NIB
         BEMADR(LOOP) = BOFF + IDXRAY(LOOP) * LROW + IDYRAY(LOOP)
 110     CONTINUE
C                                       Gather beam
      CALL GATHER (NIB, BEMTMP, BEAM, BEMADR)
C                                       Gather fluxes, overwriting
C                                       IDXRAY.
      CALL GATHER (NIB, FLXTMP, FLUX(L1MAP+JNDEX), IB)
C                                        Subtraction loop
      INCLUDE 'INCS:ZVND.INC'
      DO 120 LOOP = 1,NIB
         FLXTMP(LOOP) = FLXTMP(LOOP) - SUBT * BEMTMP(LOOP)
 120     CONTINUE
C                                       Scatter new residuals back
      CALL SCATTER (NIB, FLUX(L1MAP+JNDEX), IB, FLXTMP)
C                                        Find largest mag. residual
      INCX = 1
      KMAX = ISAMAX (LMAP, FLUX(1+JNDEX), INCX)
      COMP(1) = FLUX (KMAX+JNDEX)
      COMP(2) = IX(KMAX+JNDEX)
      COMP(3) = IY(KMAX+JNDEX)
C                                        Save index of next max.
      INDEX = KMAX
C
 999  RETURN
      END

      SUBROUTINE FWRITE (FDVEC, TBIND, TAPBUF, FITBLK, IERR)
C-----------------------------------------------------------------------
C! converts FITS header to AIPS header and displays it with MSGWRT
C# Tape FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999, 2003, 2007, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FWRITE converts a FITS header record (2880 8-bit characters) to
C   the local character form, parses it, and prints a summary using
C   MSGWRT.
C   Inputs:
C      FDVEC   I(50)       TAPIO control parms (1st record read as FITS
C                          with blocking up to 10 and infinite reads
C                          allowed)
C   In/out:
C      TBIND   I           Pointer to data in TAPBUF
C      TAPBUF  I(*)        TAPIO I/O buffer (1st tape record already
C                          read)
C   Output:
C      FITBLK  C*2880      Work buffer: 1 header record
C      IERR    I           Error codes from IO system
C-----------------------------------------------------------------------
      INTEGER   FDVEC(50), TBIND, TAPBUF(*), IERR
      CHARACTER FITBLK*2880
C
      CHARACTER PTYPES(20)*8, ORIGIN*8, TAPEDA*8, CTEST*8
      DOUBLE PRECISION PSCAL(20), POFF(20), BSCALE(2), BZERO(2)
      INTEGER   GROUP, TABLES, I, NC, JJ, MSGLEV, BITPIX, NAXIS, NPV(4),
     *   USED(300)
      LOGICAL   LEND, UVTABL
      REAL      PCMATX(7,7), CDMATX(7,7), PVMATX(7,7)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA MSGLEV /3/
      DATA ORIGIN, TAPEDA /'ORIGIN ', 'DATE '/
C-----------------------------------------------------------------------
C                                       Initialize header, et al.
      TABLES = 0
      DO 10 I = 1,20
         PSCAL(I) = 0.0D0
         POFF(I) = 0.0D0
         PTYPES(I) = ' '
 10      CONTINUE
      CALL RFILL (49, 0.0, CDMATX)
      CALL RFILL (49, 0.0, PCMATX)
      CALL RFILL (49, 0.0, PVMATX)
      CALL FILL (4, 0, NPV)
      CALL FILL (300, 0, USED)
      NAXIS = 0
      BSCALE(1) = 1.0D0
      BZERO(1) = 0.0D0
      BSCALE(2) = 1.0D0
      BZERO(2) = 0.0D0
      GROUP = 0
      CALL FILL (256, 0, CATBLK)
      I = (6 + KIPTPN + KICTPN) * 2
      CALL RFILL (I, HBLANK, CATH(1))
      CALL RFILL (5, HBLANK, CATH(KHIMN))
C                                       Read loop
      DO 30 JJ = 1,30000
         IF (JJ.GT.1) THEN
            CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         CALL ZC8CL (2880, 1, TAPBUF(TBIND), FITBLK)
C                                       Parse cards individually
         DO 20 NC = 1,36
            I = (NC-1) * 80 + 1
            CTEST = FITBLK(I:I+7)
            IF ((CTEST.EQ.TAPEDA) .OR. (CTEST.EQ.ORIGIN)) THEN
               MSGTXT = FITBLK(I:I+63)
               CALL MSGWRT (MSGLEV)
               END IF
            CALL FPARSE (NC, FITBLK, PSCAL, POFF, PTYPES, TABLES, LEND,
     *         GROUP, BITPIX, BSCALE, BZERO, NAXIS, NPV, UVTABL, USED,
     *         IERR)
            IF (LEND) GO TO 50
            IF ((IERR.EQ.1) .AND. ((CTEST(:2).EQ.'CD') .OR.
     *         (CTEST(:2).EQ.'PC') .OR. (CTEST(:2).EQ.'PV')))
     *         CALL PCCARD (GROUP, FITBLK(I:I+79), PCMATX, CDMATX,
     *         PVMATX)
 20         CONTINUE
 30      CONTINUE
C                                       test for uv tables
 50   IF (UVTABL) THEN
         MSGTXT = 'Reading uv table data'
         CALL MSGWRT (MSGLEV)
         IF ((NPV(1).GT.0) .OR. (NPV(2).GT.0)) THEN
            WRITE (MSGTXT,1050) NPV(1), NPV(2)
            CALL MSGWRT (MSGLEV)
            WRITE (MSGTXT,1055) NPV(3), NPV(4)
            CALL MSGWRT (MSGLEV)
            END IF
         IF ((CATBLK(KINAX)/100.EQ.7777777) .AND.
     *      (CATBLK(KINAX+1).EQ.0)) THEN
            MSGTXT = 'Header information located later in file'
            CALL MSGWRT (MSGLEV)
            MSGTXT = 'use PRTTP rather than TPHEAD to read this UV info'
            CALL MSGWRT (MSGLEV)
            GO TO 999
            END IF
         END IF
C                                       PC -> CROTA
C                                       CD -> CDELT, CROTA
      CALL PCHDR (PCMATX, CDMATX, PVMATX)
C                                       Output the stuff
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
      IF (CATBLK(KIPCN).GT.0) CALL CHR2H (2, 'UV', KHPTYO, CATH(KHPTY))
      CALL MSGHDR (MSGLEV, PSCAL, POFF, PTYPES, TABLES, BITPIX, BSCALE,
     *   BZERO)
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('Piece',I3,' of',I3,' in the full data set')
 1055 FORMAT ('Visibilities',I9,' through',I9,' from original')
      END

C   Observing position class: name = 'POSITION'
C-----------------------------------------------------------------------
C! Object Oriented AIPS Fortran "Observing position" class library
C# Map-util Utility Object-Oriented
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998-1999, 2004, 2006, 2015, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Contains pointing position and phase center shift information.
C
C   Class Public members:
C      OBSRA     D   Pointing position: RA (degrees)
C      OBSDEC    D   Pointing position: Dec (degrees)
C      XSHIFT    R   Phase shift in RA (degrees)
C      YSHIFT    R   Phase shift in Dec (degrees)
C
C   Public functions:
C      PSNGET (name, keywrd, type, dim, value, valuec, ierr)
C         Return position member.
C      PSNPUT (name, keywrd, type, dim, value, valuec, ierr)
C         Store position member.
C      PSNCVT (in, xyzi, out, xyzo, ierr)
C         Convert pixel position in one image to pixel position in
C         another.
C      PSNCV3 (in, xyzi, out, which, tza, cpa, spa, pbfwhm, fbwsq, c123,
C         xyzo, ierr)
C         Convert pixel positions correcting for array plane
C         misorientation and radial scaling.
C      PSNPIX (in, x, y, xpix, ypix, ierr)
C         Determine the pixel location for a given x,y coordinate.
C      PSNVAL (in, xpix, ypix, x, y, z, ierr)
C         Determine the location for a given pixel.
C      PSNANG (in, x, y, radius, ierr)
C         Determine the distance to the pointing position
C
LOCAL INCLUDE 'POSITION.INC'
C                                       Position info
      CHARACTER IMAGE1*32, IMAGE2*32
      INTEGER   ITI, ITO
      REAL      EPOK, CDELT1(7), CDELT2(7), CRPIX1(7), CRPIX2(7)
      DOUBLE PRECISION RA0, DEC0, RAC, DECC
      COMMON /PSNCOM/ RA0, DEC0, RAC, DECC,
     *   EPOK, CDELT1, CDELT2, CRPIX1, CRPIX2,
     *   ITI, ITO
      COMMON /PSNCMC/ IMAGE1, IMAGE2
      INTEGER   IDUM(20)
      REAL      RDUM(20)
      LOGICAL   LDUM(20)
      DOUBLE PRECISION DDUM(10)
      EQUIVALENCE (DDUM, RDUM,LDUM, IDUM)
      COMMON /POFORT/ DDUM
LOCAL END
LOCAL INCLUDE 'POSMEMS.INC'
C                                       POSITION class include
      INTEGER   NMEML
      PARAMETER (NMEML = 4)
      CHARACTER MEMS(NMEML)*8, THSCLS*16
      DATA MEMS /'OBSRA','OBSDEC','XSHIFT','YSHIFT'/
      DATA THSCLS /'POSITION'/
LOCAL END
      SUBROUTINE PSNGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public
C   Return position member.
C   Inputs:
C      NAME    C*?    Object name
C      KEYWRD  C*(*)  Keyword in form 'mem1.mem2...'
C   Outputs:
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of the array.
C      VALUE   ?     associated value (non character)
C      VALUEC  C*?   associated value (character)
C      IERR    I     Error code, 0=OK.  1=> did not find.,
C                    2= Input error.
C-----------------------------------------------------------------------
      INTEGER   TYPE, DIM(*), IERR
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC(*)*(*)
      DOUBLE PRECISION VALUE(*)
C
      INTEGER   IMEM, LOOP, OBJNUM, POINT
      CHARACTER MEMBER*16
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'POSITION.INC'
      INCLUDE 'POSMEMS.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Lookup NAME
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Look for base class.member name
C                                       in KEYWRD.
      POINT = INDEX (KEYWRD, '.')
C                                       No base classes exist for this
C                                       class.
      IF (POINT.GE.1) THEN
         IERR = 2
         MSGTXT = 'NO BASE CLASSES FOR CLASS ' // THSCLS
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Save member name
      IF (POINT.LE.0) THEN
         MEMBER = KEYWRD
      ELSE
         MEMBER = KEYWRD(1:POINT-1)
         END IF
C                                       Search list of recognized
C                                       members.
      IMEM = -1
      DO 10 LOOP = 1,NMEML
         IF (MEMBER.EQ.MEMS(LOOP)) IMEM = LOOP
 10      CONTINUE
C                                       Find it?
      IF (IMEM.LE.0) THEN
         IERR = 2
         MSGTXT = 'UNRECOGNIZED ' // THSCLS // ' MEMBER ' // MEMBER
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Fetch value:
         CALL OBGET (OBJNUM, KEYWRD(POINT+1:), TYPE, DIM, VALUE, VALUEC,
     *      IERR)
C                                       Message if not found
         IF (IERR.EQ.1) THEN
            MSGTXT = 'MEMBER ' // MEMBER // ' NOT FOUND'
            CALL MSGWRT (6)
            MSGTXT = 'OBJECT =' // NAME
            CALL MSGWRT (6)
            END IF
C
 999  RETURN
      END
      SUBROUTINE PSNPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public
C   Store position member.
C   Inputs:
C      NAME    C*?    Object name
C      KEYWRD  C*(*)  Keyword in form 'mem1.mem2...'
C   Outputs:
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of the array.
C      VALUE   ?     associated value (non character)
C      VALUEC  C*?   associated value (character)
C      IERR    I     Error code, 0=OK.  1=> did not find.,
C                    2= Input error.
C-----------------------------------------------------------------------
      INTEGER   TYPE, DIM(*), VALUE(*), IERR
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC(*)*(*)
C
      INTEGER   IMEM, LOOP, OBJNUM, POINT
      CHARACTER MEMBER*16
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'POSITION.INC'
      INCLUDE 'POSMEMS.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Lookup NAME
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Look for base class.member name
C                                       in KEYWRD.
      POINT = INDEX (KEYWRD, '.')
C                                       No base classes exist for this
C                                       class.
      IF (POINT.GE.1) THEN
         IERR = 2
         MSGTXT = 'NO BASE CLASSES FOR CLASS ' // THSCLS
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Save member name
      IF (POINT.LE.0) THEN
         MEMBER = KEYWRD
      ELSE
         MEMBER = KEYWRD(1:POINT-1)
         END IF
C                                       Search list of recognized
C                                       members.
      IMEM = -1
      DO 10 LOOP = 1,NMEML
         IF (MEMBER.EQ.MEMS(LOOP)) IMEM = LOOP
 10      CONTINUE
C                                       Find it?
      IF (IMEM.LE.0) THEN
         IERR = 2
         MSGTXT = 'UNRECOGNIZED ' // THSCLS // ' MEMBER ' // MEMBER
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Fetch value:
         CALL OBPUT (OBJNUM, KEYWRD(POINT+1:), TYPE, DIM, VALUE, VALUEC,
     *      IERR)
C                                       Message if not stored
         IF (IERR.NE.0) THEN
            MSGTXT = 'MEMBER ' // MEMBER // ' COULD NOT BE STORED'
            CALL MSGWRT (6)
            MSGTXT = 'OBJECT =' // NAME
            CALL MSGWRT (6)
            END IF
C
 999  RETURN
      END
      SUBROUTINE PSNCVT (IN, XYZI, OUT, XYZO, IERR)
C-----------------------------------------------------------------------
C   Public
C   Convert pixel position in one image to pixel position in another.
C   Inputs:
C      IN      C*?    Input image object
C      XYZI    R(7)   Pixel position in IN
C      OUT     C*?    Output image object
C   Outputs:
C      XYZO    R(7)   Pixel position in OUT.
C      IERR    I      Error code, 0=OK.
C-----------------------------------------------------------------------
      CHARACTER IN*(*), OUT*(*)
      REAL      XYZI(7), XYZO(7)
      INTEGER   IERR
C
      INTEGER   TYPE, DIM(7), I, IDEP(5), IROUND
      LOGICAL   SWAPOK
      CHARACTER CDUMMY*1
      DOUBLE PRECISION X, Y, Z
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'POSITION.INC'
      DATA SWAPOK /.FALSE./
C-----------------------------------------------------------------------
      IERR = 0
C                                       Get info for input image if
C                                       necessary.
      IF (IN.NE.IMAGE1) THEN
         IMAGE1 = IN
C                                       Get catalog header
         CALL OBHGET (IN, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 990
         DO 10 I = 1,5
            IDEP(I) = IROUND (XYZI(I+2))
 10         CONTINUE
         LOCNUM = 1
         CALL SETLOC (IDEP, SWAPOK)
         ITI = 1
         IF (LABTYP(LOCNUM).LT.44) ITI = 2
         IF (LABTYP(LOCNUM).LT.22) ITI = 3
         RA0 = 0.0D0
         DEC0 = 0.0D0
         END IF
C                                       Get info for input image if
C                                       necessary.
      IF (OUT.NE.IMAGE2) THEN
         IMAGE2 = OUT
C                                       Get catalog header
         CALL OBHGET (OUT, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 990
         DO 20 I = 1,5
            IDEP(I) = IROUND (XYZO(I+2))
 20         CONTINUE
         LOCNUM = 2
         CALL SETLOC (IDEP, SWAPOK)
         ITO = 1
         IF (LABTYP(LOCNUM).LT.44) ITO = 2
         IF (LABTYP(LOCNUM).LT.22) ITO = 3
         CALL IMDGET (OUT, 'EPOCH', TYPE, DIM, DDUM, CDUMMY, IERR)
         EPOK = RDUM(1)
         IF (IERR.NE.0) GO TO 990
C                                       appropriate?
         IF ((CORTYP(1).LT.1) .OR. (CORTYP(2).LT.1) .OR.
     *      (CORTYP(1).GT.2) .OR. (CORTYP(2).GT.2)) THEN
            IF (CORTYP(2).NE.CORTYP(1)) THEN
               MSGTXT = 'PSNCVT: IMPROPER COMBINATION OF COORDINATES'
               CALL MSGWRT (8)
               IERR = 8
               GO TO 990
               END IF
            IF (ITI.NE.ITO) THEN
               MSGTXT = 'PSNCVT: IMPROPER COORDINATES FOR CONVERSION'
               CALL MSGWRT (8)
               IERR = 8
               GO TO 990
               END IF
            END IF
         END IF
C                                       Get position of input
      LOCNUM = 1
      CALL XYVAL (XYZI(1), XYZI(2), X, Y, Z, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Convert types if necessary
      IF (ITI.NE.ITO) THEN
         IF (CORTYP(LOCNUM).EQ.1) THEN
            CALL COORDT (ITI, ITO, X, Y, EPOK, X, Y, IERR)
         ELSE
            CALL COORDT (ITI, ITO, Y, X, EPOK, Y, X, IERR)
            END IF
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       same order
      IF (CORTYP(1).EQ.CORTYP(2)) THEN
C                                       Get corresponding pixel in OUT
         LOCNUM = 2
         CALL XYPIX (X, Y, XYZO(1), XYZO(2), IERR)
         IF (IERR.NE.0) GO TO 990
C                                       reverse order
      ELSE
         LOCNUM = 2
         CALL XYPIX (Y, X, XYZO(1), XYZO(2), IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  MSGTXT = 'PSNCVT: ERROR CONVERTING PIXEL POSITIONS FOR ' // IN
      CALL MSGWRT (7)
      MSGTXT = '  TO ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE PSNCV3 (IN, XYZI, OUT, WHICH, TZA, CPA, SPA, PBFWHM,
     *   FBWSQ, C123, XYZO, IERR)
C-----------------------------------------------------------------------
C   Public
C   Convert pixel position in one image to pixel position in another
C   correcting for array plane misorientation and radial scaling.  The
C   pixel coordinate is scaled radially from the antenna pointing center
C   to allow correction for primary beam variation across the bandpass.
C   The scaling is in the sense of from true to apparent positions.
C      The image scaling will be done if either PBFWHM or C0 is greater
C   than 0; C0 is the constant scaling term.  The full scaling factor
C   is:
C      factor = (C0 - FBWSQ * rnsq * (C1 + rnsq * (C2 + rnsq * C3)))
C   where rnsq = (radial_distance / PBFWHM) ** 2
C   Note: the 3-D correction is only defined if the output image can
C   accurately described by a single pair of parallactic and zenith
C   angles.  If no 3-D corrections are desired use TZA = 0, CPA = 1 and
C   SPA = 0.
C   Inputs:
C      IN      C*?    Input image object
C      XYZI    R(7)   Pixel position in IN
C      OUT     C*?    Output image object
C      WHICH   L      TRUE => use coordinates in OUT to compute the
C                     3D and radial corrections, else use IN.
C      TZA     R      Tan (Zenith angle) of output image
C      CPA     R      Cos (Paralactic angle) of output image
C      SPA     R      Sin (Paralactic angle) of output image
C      PBFWHM  R      Primary beam FWHM at nomimal frequency (deg)
C                     If zero then no correction is done.
C      FBWSQ   R      Square of fractional bandpass.
C      C123    R(4)   Primary beam shape and scaling parameters: C0, C1,
C                     C2, C3
C   Outputs:
C      XYZO    R(7)   Pixel position in OUT.
C      IERR    I      Error code, 0=OK.
C-----------------------------------------------------------------------
      CHARACTER IN*(*), OUT*(*)
      REAL      XYZI(7), TZA, CPA, SPA, XYZO(7), PBFWHM, FBWSQ, C123(4)
      LOGICAL   WHICH
      INTEGER   IERR
C
      INTEGER   TYPE, DIM(7), I, IDEP(5), IROUND
      LOGICAL   SWAPOK, DO3D, DORAD, SAME
      REAL      RSC, RAD, RADR, RNORM, RNSQ
      CHARACTER CDUMMY*1
      DOUBLE PRECISION X, Y, Z, LL, MM, LLP, MMP, DD, XR, YR, CRVAL(7)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'POSITION.INC'
      DATA SWAPOK /.FALSE./
C-----------------------------------------------------------------------
      IERR = 0
      DO3D = TZA.NE.0.0
      DORAD = (PBFWHM.GT.0.0) .OR. (C123(1).GT.0.0)
C                                       Get info for input image if
C                                       necessary.
      IF (IN.NE.IMAGE1) THEN
         IMAGE1 = IN
C                                       Get catalog header
         CALL OBHGET (IN, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 990
         DO 10 I = 1,5
            IDEP(I) = IROUND (XYZI(I+2))
 10         CONTINUE
         LOCNUM = 1
         CALL SETLOC (IDEP, SWAPOK)
         IF ((AXTYP(LOCNUM).NE.1) .OR. (CORTYP(LOCNUM).LT.1) .OR.
     *      (CORTYP(LOCNUM).GT.2)) THEN
            IERR = 1
            MSGTXT = 'COORDINATES INAPPROPRIATE FOR 3D CORRECTION'
            CALL MSGWRT (7)
            GO TO 990
            END IF
         RA0 = 0.0D0
         DEC0 = 0.0D0
         ITI = 1
         IF (LABTYP(LOCNUM).LT.44) ITI = 2
         IF (LABTYP(LOCNUM).LT.22) ITI = 3
         IF (.NOT.WHICH) THEN
            CALL IMDGET (IN, 'CRVAL', TYPE, DIM, DDUM, CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 990
            CALL DPCOPY (DIM(1), DDUM, CRVAL)
            RAC = CRVAL(CORTYP(LOCNUM))
            DECC = CRVAL(3-CORTYP(LOCNUM))
            RAC = COND2R * RAC
            DECC = COND2R * DECC
            IF ((ABS (RAC).LE.1.0D-10) .AND. (ABS (DECC).LE.1.0D-10))
     *         THEN
               IERR = 1
               MSGTXT = 'TANGENT POSITION NOT IN HEADER'
               CALL MSGWRT (7)
               GO TO 990
               END IF
            CALL IMDGET (IN, 'EPOCH', TYPE, DIM, DDUM, CDUMMY, IERR)
            EPOK = RDUM(1)
            IF (IERR.NE.0) GO TO 990
            CALL PSNGET (IN, 'OBSRA', TYPE, DIM, DDUM, CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 990
            RA0 = DDUM(1)
            CALL PSNGET (IN, 'OBSDEC', TYPE, DIM, DDUM, CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 990
            DEC0 = DDUM(1)
            RA0 = COND2R * RA0
            DEC0 = COND2R * DEC0
            IF ((ABS (RA0).LE.1.0D-10) .AND. (ABS (DEC0).LE.1.0D-10))
     *         THEN
               IERR = 1
               MSGTXT = 'POINTING POSITION NOT IN HEADER'
               CALL MSGWRT (7)
               GO TO 990
               END IF
            END IF
C                                       Other geometry
         CALL IMDGET (IN, 'CDELT', TYPE, DIM, DDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL RCOPY (DIM(1), RDUM, CDELT1)
         CALL IMDGET (IN, 'CRPIX', TYPE, DIM, DDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL RCOPY (DIM(1), RDUM, CRPIX1)
         END IF
C                                       Get info for input image if
C                                       necessary.
      IF (OUT.NE.IMAGE2) THEN
         IMAGE2 = OUT
C                                       Get catalog header
         CALL OBHGET (OUT, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 990
         DO 20 I = 1,5
            IDEP(I) = IROUND (XYZO(I+2))
 20         CONTINUE
         LOCNUM = 2
         CALL SETLOC (IDEP, SWAPOK)
         IF ((AXTYP(LOCNUM).NE.1) .OR. (CORTYP(LOCNUM).LT.1) .OR.
     *      (CORTYP(LOCNUM).GT.2)) THEN
            IERR = 1
            MSGTXT = 'COORDINATES INAPPROPRIATE FOR 3D CORRECTION'
            CALL MSGWRT (7)
            GO TO 990
            END IF
         ITO = 1
         IF (LABTYP(LOCNUM).LT.44) ITO = 2
         IF (LABTYP(LOCNUM).LT.22) ITO = 3
         IF (WHICH) THEN
            CALL IMDGET (OUT, 'CRVAL', TYPE, DIM, DDUM, CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 990
            CALL DPCOPY (DIM(1), DDUM, CRVAL)
            RAC = CRVAL(CORTYP(LOCNUM))
            DECC = CRVAL(3-CORTYP(LOCNUM))
            RAC = COND2R * RAC
            DECC = COND2R * DECC
            IF ((ABS (RAC).LE.1.0D-10) .AND. (ABS (DECC).LE.1.0D-10))
     *         THEN
               IERR = 1
               MSGTXT = 'TANGENT POSITION NOT IN HEADER'
               CALL MSGWRT (7)
               GO TO 990
               END IF
            CALL IMDGET (OUT, 'EPOCH', TYPE, DIM, DDUM, CDUMMY, IERR)
            EPOK = RDUM(1)
            IF (IERR.NE.0) GO TO 990
            CALL PSNGET (OUT, 'OBSRA', TYPE, DIM, DDUM, CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 990
            RA0 = DDUM(1)
            CALL PSNGET (OUT, 'OBSDEC', TYPE, DIM, DDUM, CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 990
            DEC0 = DDUM(1)
            RA0 = COND2R * RA0
            DEC0 = COND2R * DEC0
            IF ((ABS (RA0).LE.1.0D-10) .AND. (ABS (DEC0).LE.1.0D-10))
     *         THEN
               IERR = 1
               MSGTXT = 'POINTING POSITION NOT IN HEADER'
               CALL MSGWRT (7)
               GO TO 990
               END IF
            END IF
C                                       Other geometry
         CALL IMDGET (OUT, 'CDELT', TYPE, DIM, DDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL RCOPY (DIM(1), RDUM, CDELT2)
         CALL IMDGET (OUT, 'CRPIX', TYPE, DIM, DDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL RCOPY (DIM(1), RDUM, CRPIX2)
         END IF
C                                       two positions or one
      SAME = (ABS(RAC-RA0).LT.4.D-9) .AND. (ABS(DECC-DEC0).LT.4.D-9)
C                                       Get position of input
      LOCNUM = 1
      CALL XYVAL (XYZI(1), XYZI(2), X, Y, Z, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (CORTYP(LOCNUM).EQ.2) THEN
         Z = X
         X = Y
         Y = Z
         END IF
C                                       Convert types if necessary
      IF (ITI.NE.ITO) THEN
         CALL COORDT (ITI, ITO, X, Y, EPOK, X, Y, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       output image
      IF (WHICH) LOCNUM = 2
      X = X * COND2R
      Y = Y * COND2R
C                                       Convert to direction cosines
C                                       wrt to tangent point
      IF (DO3D) THEN
         CALL DIRCOS (AXFUNC(KLOCL(LOCNUM)+1,LOCNUM), RAC, DECC, X, Y,
     *      LL, MM, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Get apparent position
         DD = SQRT (1.0D0 - LL*LL - MM*MM) - 1.0D0
         LLP = LL - DD * TZA * SPA
         MMP = MM - DD * TZA * CPA
         IF ((.NOT.SAME) .OR. (.NOT.DORAD)) THEN
            CALL NEWPOS (AXFUNC(KLOCL(LOCNUM)+1,LOCNUM), RAC, DECC, LLP,
     *         MMP, X, Y, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
         END IF
C                                       Make radial scaling corrections.
      IF (DORAD) THEN
         IF ((.NOT.SAME) .OR. (.NOT.DO3D)) THEN
            CALL DIRCOS (AXFUNC(KLOCL(LOCNUM)+1,LOCNUM), RA0, DEC0, X,
     *         Y, LLP, MMP, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
         XR = LLP
         YR = MMP
         RADR = SQRT (XR*XR + YR*YR)
         RAD = RADR / COND2R
         IF (PBFWHM.GT.0.0) THEN
            RNORM = RAD / PBFWHM
            RNSQ = RNORM * RNORM
         ELSE
            RNSQ = 0.0
            END IF
         RSC = (C123(1) - FBWSQ * RNSQ * (C123(2) + RNSQ * (C123(3) +
     *      RNSQ * C123(4))))
         LLP = LLP * RSC
         MMP = MMP * RSC
C                                       Convert back to position.
         CALL NEWPOS (AXFUNC(KLOCL(LOCNUM)+1,LOCNUM), RA0, DEC0, LLP,
     *      MMP, X, Y, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
      X = X / COND2R
      Y = Y / COND2R
C                                       Get corresponding pixel in OUT
      LOCNUM = 2
      IF (CORTYP(LOCNUM).EQ.2) THEN
         Z = X
         X = Y
         Y = X
         END IF
      CALL XYPIX (X, Y, XYZO(1), XYZO(2), IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'PSNCV3: ERROR CONVERTING PIXEL POSITIONS FOR ' // IN
      CALL MSGWRT (7)
      MSGTXT = '  TO ' // OUT
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE PSNPIX (IN, X, Y, XPIX, YPIX, IERR)
C-----------------------------------------------------------------------
C   Public
C   Determine pixel position of a given x,y coordinate (e.g. RA, Dec)
C   Inputs:
C      IN      C*?    Input image object
C      X       D      First axis coordinate in header units (degrees)
C      Y       D      Sedond axis coordinate in header units (degrees)
C   Outputs:
C      XPIX    R      First axis pixel number corresponding to (X,Y)
C      YPIX    R      Second axis pixel number corresponding to (X,Y)
C      IERR    I      Error code, 0=OK.
C-----------------------------------------------------------------------
      CHARACTER IN*(*)
      DOUBLE PRECISION X, Y
      REAL      XPIX, YPIX
      INTEGER   IERR
C
      INTEGER   IDEP(5)
      LOGICAL   SWAPOK
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'POSITION.INC'
      DATA SWAPOK /.FALSE./
C-----------------------------------------------------------------------
      IERR = 0
C                                       Get info for input image if
C                                       necessary.
      IF (IN.NE.IMAGE1) THEN
         IMAGE1 = IN
C                                       Get catalog header
         CALL OBHGET (IN, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL FILL (5, 1, IDEP)
         LOCNUM = 1
         CALL SETLOC (IDEP, SWAPOK)
         ITI = 1
         IF (LABTYP(LOCNUM).LT.44) ITI = 2
         IF (LABTYP(LOCNUM).LT.22) ITI = 3
         RA0 = 0.0D0
         DEC0 = 0.0D0
         END IF
C                                       Get pixel value
      LOCNUM = 1
      CALL XYPIX (X, Y, XPIX, YPIX, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'PSNPIX: ERROR FINDING PIXEL IN ' // IN
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE PSNVAL (IN, XPIX, YPIX, X, Y, Z, IERR)
C-----------------------------------------------------------------------
C   Public
C   Determine the coordinate value of a given pixel in an image.
C   Inputs:
C      IN      C*?    Input image object
C      XPIX    R      Pixel location, x-coordinate
C      YPIX    R      Pixel location, y-coordinate
C   Outputs:
C      X       D      X-coordinate value at pixel location
C      Y       D      Y-coordinate value at pixel location
C      Z       D      Z-coordinate value (if part of a position
C                     pair with either X or Y)
C      IERR    I      Error code, 0=OK.
C-----------------------------------------------------------------------
      CHARACTER IN*(*)
      DOUBLE PRECISION X, Y, Z
      REAL      XPIX, YPIX
      INTEGER   IERR
C
      INTEGER   IDEP(5)
      LOGICAL   SWAPOK
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'POSITION.INC'
      DATA SWAPOK /.FALSE./
C-----------------------------------------------------------------------
      IERR = 0
C                                       Get info for input image if
C                                       necessary.
      IF (IN.NE.IMAGE1) THEN
         IMAGE1 = IN
C                                       Get catalog header
         CALL OBHGET (IN, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL FILL (5, 1, IDEP)
         LOCNUM = 1
         CALL SETLOC (IDEP, SWAPOK)
         ITI = 1
         IF (LABTYP(LOCNUM).LT.44) ITI = 2
         IF (LABTYP(LOCNUM).LT.22) ITI = 3
         RA0 = 0.0D0
         DEC0 = 0.0D0
         END IF
C                                       Get coordinate value
      LOCNUM = 1
      CALL XYVAL (XPIX, YPIX, X, Y, Z, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'PSNVAL: ERROR FINDING COORDINATES IN ' // IN
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE PSNANG (IN, X, Y, RADIUS, IERR)
C-----------------------------------------------------------------------
C   Public
C   Determine the angle from a point to the pointing position
C   Inputs:
C      IN       C*?   Input image object
C      X        R     Point offset in arc sec from ref pixel in X
C      Y        R     Point offset in arc sec from ref pixel in Y
C   Outputs:
C      RADIUS   R     Separation from pointing position
C      IERR     I     Error code, 0=OK.
C-----------------------------------------------------------------------
      CHARACTER IN*(*)
      REAL      X, Y, RADIUS
      INTEGER   IERR
C
      REAL      XPIX, YPIX
      DOUBLE PRECISION XX, YY, ZZ
      INTEGER   IDEP(5), DIM(7), TYPE
      LOGICAL   SWAPOK
      CHARACTER CDUMMY*1
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'POSITION.INC'
      DATA SWAPOK /.FALSE./
C-----------------------------------------------------------------------
      IERR = 0
C                                       Get info for input image if
C                                       necessary.
      IF ((IN.NE.IMAGE1) .OR. ((RA0.EQ.0.0D0) .AND. (DEC0.EQ.0.0D0)))
     *   THEN
         IMAGE1 = IN
C                                       Get catalog header
         CALL OBHGET (IN, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL FILL (5, 1, IDEP)
         LOCNUM = 1
         CALL SETLOC (IDEP, SWAPOK)
         ITI = 1
         IF (LABTYP(LOCNUM).LT.44) ITI = 2
         IF (LABTYP(LOCNUM).LT.22) ITI = 3
         IF ((AXTYP(LOCNUM).LT.1) .OR. (AXTYP(LOCNUM).GT.3)) THEN
            IERR = 2
            MSGTXT = 'CELESTIAL COORDINATES NOT IN FIRST AXES'
            CALL MSGWRT (7)
            GO TO 990
            END IF
         CALL IMDGET (IN, 'EPOCH', TYPE, DIM, DDUM, CDUMMY, IERR)
         EPOK = RDUM(1)
         IF (IERR.NE.0) GO TO 990
         CALL PSNGET (IN, 'OBSRA', TYPE, DIM, DDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
         RA0 = DDUM(1)
         CALL PSNGET (IN, 'OBSDEC', TYPE, DIM, DDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
         DEC0 = DDUM(1)
         IF ((ABS (RA0).LE.1.0D-10) .AND. (ABS (DEC0).LE.1.0D-10)) THEN
            MSGTXT = 'POINTING POSITION NOT IN HEADER'
            CALL MSGWRT (7)
            IF (CORTYP(LOCNUM).EQ.1) THEN
               RA0 = RPVAL(1,LOCNUM)
               DEC0 = RPVAL(2,LOCNUM)
            ELSE IF (CORTYP(LOCNUM).EQ.2) THEN
               RA0 = RPVAL(2,LOCNUM)
               DEC0 = RPVAL(1,LOCNUM)
            ELSE
               IERR = 1
               GO TO 990
               END IF
            END IF
C                                       Convert types if necessary
         IF (ITI.NE.1) THEN
            CALL COORDT (1, ITI, RA0, DEC0, EPOK, RA0, DEC0, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
         RA0 = COND2R * RA0
         DEC0 = COND2R * DEC0
         END IF
C                                       convert to pixel
      LOCNUM = 1
      XPIX = RPLOC(1,LOCNUM) + X / AXINC(1,LOCNUM)
      YPIX = RPLOC(2,LOCNUM) + Y / AXINC(2,LOCNUM)
      CALL XYVAL (XPIX, YPIX, XX, YY, ZZ, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       fix transpositions
      IF (CORTYP(LOCNUM).EQ.2) THEN
         ZZ = YY
         YY = XX
         XX = YY
      ELSE IF (CORTYP(LOCNUM).EQ.3) THEN
         YY = ZZ
      ELSE IF (CORTYP(LOCNUM).EQ.4) THEN
         YY = XX
         XX = ZZ
      ELSE IF (CORTYP(LOCNUM).EQ.5) THEN
         XX = YY
         YY = ZZ
      ELSE IF (CORTYP(LOCNUM).EQ.6) THEN
         XX = ZZ
         END IF
      XX = COND2R * XX
      YY = COND2R * YY
      ZZ = SIN (YY) * SIN (DEC0) + COS (YY) * COS (DEC0) * COS (XX-RA0)
      RADIUS = ACOS (ZZ) / COND2R
      GO TO 999
C                                       Error
 990  MSGTXT = 'PSNANG: ERROR FINDING COORDINATES IN ' // IN
      CALL MSGWRT (7)
      IMAGE1 = ' '
C
 999  RETURN
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCLN.INC'
      INTEGER NPARMS
      PARAMETER (NPARMS=53)
      INTEGER AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                      1        2         3          4
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C            5          6          7         8
     *   'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK',
C            9       10        11        12       13       14      15
     *   'BCHAN', 'ECHAN', 'CHANNEL', 'NCHAV', 'CHINC', 'STOKES', 'BIF',
C          16       17         18        19         20         21
     *   'EIF', 'OUTNAME', 'OUTDISK', 'OUTSEQ', 'OUTVER', 'CELLSIZE',
C           22         23        24         25         26        27
     *   'IMSIZE', 'NFIELD', 'FLDSIZE', 'RASHIFT', 'DECSHIFT', 'NBOXES',
C           28       29         30        31       32        33
     *   'CLBOX', 'UVTAPER', 'UVRANGE', 'UVWTFN', 'UVBOX', 'ZEROSP',
C           34       35       36      37      38         39        40
     *   'XTYPE', 'YTYPE', 'XPARM', 'YPARM', 'GAIN', 'FLUX', 'MINPATCH',
C           41      42       43      44      45     46       47
     *   'NITER', 'BCOMP', 'BMAJ', 'BMIN', 'BPA', 'PHAT', 'FACTOR',
C            48         49      50        51          52     53
     *   'CMETHOD', 'CPARM', 'GUARD', 'MAXPIXEL', 'BADDISK', 'INFILE'/
C                    1       2       3       4       5       6
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOACAR, OOACAR,
C           7      8       9       10      11       12     13
     *   OOAINT, OOAINT, OOAINT, OOAINT, OOAINT, OOAINT, OOAINT,
C          14      15       16      17      18      19      20     21
     *   OOACAR, OOAINT,  OOAINT, OOACAR, OOAINT, OOAINT, OOAINT, OOARE,
C          22      23      24     25     26      27      28     29
     *    OOAINT,OOAINT, OOAINT, OOARE, OOARE, OOAINT, OOAINT, OOARE,
C          30      31      32     33      34      35     36     37
     *   OOARE, OOACAR, OOAINT, OOARE, OOAINT, OOAINT, OOARE, OOARE,
C          38     39      40      41      42     43     44     45
     *   OOARE, OOARE, OOAINT, OOAINT, OOAINT, OOARE, OOARE, OOARE,
C          46     47      48     49     50     51       52    53
     *   OOARE, OOARE, OOACAR, OOARE, OOARE, OOAINT, OOAINT, OOACAR/
C                   1    2    3    4     5    6    7    8    9    10
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 12,1, 6,1, 1,1, 1,1, 1,1, 1,1,
C         11   12   13   14   15   16    17   18   19   20   21   22
     *   1,1, 1,1, 1,1, 4,1, 1,1, 1,1, 12,1, 1,1, 1,1, 1,1, 2,1, 2,1,
C         23   24             25        26   27   28        29   30
     *   1,1, 2,MAXAFL, MAXAFL,1, MAXAFL,1, 1,1, 4,MXCLBX, 2,1, 2,1,
C         31   32   33   34    35    36   37   38   39   40    41
     *   2,1, 1,1, 5,1, 1,1, 1,1, 10,1, 10,1, 1,1, 1,1, 1,1, 1,1,
C              42   43   44   45   46   47   48   49    50   51    52
     *   MAXAFL,1, 1,1, 1,1, 1,1, 1,1, 1,1, 4,1, 10,1, 2,1, 1,1, 10,1,
C          53
     *   48,1/
LOCAL END
LOCAL INCLUDE 'IMAGWIN.INC'
      LONGINT   WINP
      INTEGER   WINM, WINW, WIN(2)
      COMMON /IMAWIN/ WINP, WINM, WINW, WIN
LOCAL END
      PROGRAM WFCLN
C-----------------------------------------------------------------------
C! Wide field and/or widefrequency  CLEANing/imaging task.
C# Task AP Imaging OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000, 2002-2003, 2005-2006, 2008, 2012
C;  Copyright (C) 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Barry Clark CLEAN
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, CLEAN*32, UVDATA*32
      INTEGER  IRET, BUFF1(256)
      INCLUDE 'IMAGWIN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'WFCLN'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL WFCLIN (PRGM, CLEAN, UVDATA, IRET)
C                                       CLEAN
      IF (IRET.EQ.0) CALL WFLEAN (CLEAN, UVDATA, IRET)
C                                       History
      IF (IRET.EQ.0) CALL WFCHIS (CLEAN, UVDATA)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE WFCLIN (PRGN, CLEAN, UVDATA, IRET)
C-----------------------------------------------------------------------
C   WFCLIN gets input parameters for WFCLN and creates the CLEAN object.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      CLEAN   C*32 Name of CLEAN object (contains output objects)
C      UVDATA  C*32 Name of input uv data.
C      IRET    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6, CLEAN*(*), UVDATA*(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PMAD.INC'
      INCLUDE 'INPUT.INC'
      INTEGER   NKEY1, NKEY2, NKEY3, NKEY4, NKEY5
C                                       NKEY1=no. adverbs to copy to
C                                       CLEAN object
      PARAMETER (NKEY1=13)
C                                       NKEY2 = no. adverb for UVDATA
      PARAMETER (NKEY2=18)
C                                       NKEY3 = no. adverb for UVWORK
      PARAMETER (NKEY3=3)
C                                       NKEY4 = no. adverbs for BEAM
      PARAMETER (NKEY4=4)
C                                       NKEY5 = no. adverbs for CLEANO
      PARAMETER (NKEY5=14)
      INTEGER   DIM(7), TYPE, NBOXES(MAXFLD), BCHAN, ECHAN, NWORDS,
     *   NAXIS(7), I, IMSI(2), IMSIZE(2,MAXFLD), NPTWO, IS,
     *   FLDSIZ(2,MAXFLD), NXFLD, NYFLD, NXBEM, NYBEM, MAXNX, MAXNY,
     *   MINNX, MINNY, NITER, EDGEX, EDGEY, NFIELD, CHINC, NCHAV,
     *   BMSIZ(2), BIF, EIF, IFINDX, FQINDX, BMSSZ(2), IROUND, DUMMY
      LONGINT   KP
      LOGICAL   NOREST, DODFT, DOSCAL
      REAL      BMAJ, BMIN, BPA, CPARM(10), RASH(MAXFLD), DECSH(MAXFLD),
     *   CELLS(2), DU, DV, UMAX, VMAX, GUARDB(2), GUAU, GUAV, UVTAPR(2),
     *   UTFACT(2)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32,
     *   INK2(NKEY2)*8, OUTK2(NKEY2)*32, INK3(NKEY3)*8, OUTK3(NKEY3)*32,
     *   INK4(NKEY4)*8, OUTK4(NKEY4)*32, INK5(NKEY5)*8, OUTK5(NKEY5)*32,
     *   CLEANO(MAXFLD)*32, BEAM*32, UVWORK*32, STOKES*4, CLASS*6,
     *   CLTYPE*2, CHTYPE*4, CLNTYP*8, CNAME*8, KEYW*8, TINAME*12,
     *   TONAME*12, CDUMMY*1, FILEIN*48
      INCLUDE 'IMAGWIN.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to CLEAN object
C                   1        2        3       4       5
      DATA INK1 /'GAIN', 'FLUX', 'PHAT', 'NITER', 'BCOMP',
C           6       7       8       9         10         11       12
     *   'BMAJ', 'BMIN', 'BPA', 'FACTOR', 'MINPATCH', 'OUTVER', 'CPARM',
C            13
     *   'MAXPIXEL'/
C                                       Rename
C                    1        2         3        4
      DATA OUTK1 /'GAIN', 'MINFLUX', 'PHAT', 'NITER',
C           5          6           7           8            9
     *   'BCOMP', 'BEAM.BMAJ', 'BEAM.BMIN', 'BEAM.BPA', 'FACTOR',
C           10          11         12       13
     *   'MINPATCH', 'VERSION', 'CPARM', 'MAXNRES'/
C                                       Adverbs for UVDATA object
C                    1         2         3         4        5
      DATA INK2 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'BCHAN',
C          6        7      8       9         10        11         12
     *   'ECHAN', 'BIF', 'EIF', 'STOKES', 'UVRANGE', 'CHINC', 'CMETHOD',
C          13           14         15         16       17         18
     *   'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK', 'UVWTFN', 'NCHAV'/
C                                       Rename
C                   1       2         3       4        5        6
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'BCHAN', 'ECHAN',
C          7      8       9         10         11        12
     *   'BIF', 'EIF', 'STOKES', 'UVRNG', 'CHINC', 'MODMETH',
C          13           14         15         16        17        18
     *   'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK', 'UVWTFN', 'NCHAV'/
C                                       Adverbs for UVWORK object
C                    1        2         3
      DATA INK3 /'CHINC', 'CMETHOD', 'GUARD'/
C                                       Rename
C                    1         2          3
      DATA OUTK3 /'CHINC', 'MODMETH', 'GUARDBND'/
C                                       Adverbs for BEAM image object
C                    1          2          3         4
      DATA INK4 /'OUTNAME', 'OUTSEQ', 'OUTDISK', 'CELLSIZE'/
C                                       Rename
C                    1       2       3         4
      DATA OUTK4 /'NAME', 'IMSEQ', 'DISK', 'CELLSIZE'/
C                                       Adverbs for CLEANO image object
C                    1         2         3           4          5
      DATA INK5 /'OUTNAME', 'OUTSEQ', 'OUTDISK', 'CELLSIZE', 'RASHIFT',
C            6          7        8        9       10        11
     *   'DECSHIFT', 'XTYPE', 'YTYPE', 'XPARM', 'YPARM', 'ZEROSP',
C            12        13        14
     *   'UVTAPER', 'UVWTFN' ,'UVBOX'/
C                                       Rename
C                   1        2       3          4          5
      DATA OUTK5 /'NAME', 'IMSEQ', 'DISK', 'CELLSIZE', 'RASHIFT',
C             6         7        8        9       10        11
     *   'DECSHIFT', 'CTYPX', 'CTYPY', 'XPARM', 'YPARM', 'ZEROSP',
C            12        13       14
     *   'UVTAPER', 'UVWTFN' ,'UVBOX'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Declare 'PARANGLE' a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'PARANGLE'
      CALL OBVHKW (CNAME, KEYW, OOARE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Declare 'ZENANGLE' a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'ZENANGLE'
      CALL OBVHKW (CNAME, KEYW, OOARE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       BADDISK
      CALL OGET ('Input', 'BADDISK', TYPE, DIM, IBAD, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       CLEANing?
      CALL OGET ('Input', 'NITER', TYPE, DIM, NITER, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Default output Name = input
      CALL OGET ('Input', 'INNAME', TYPE, DIM, DUMMY, TINAME, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'OUTNAME', TYPE, DIM, DUMMY, TONAME, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (TONAME.EQ.'    ') THEN
         CALL OPUT ('Input', 'OUTNAME', TYPE, DIM, DUMMY, TINAME, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Default NFIELD=1
      CALL OGET ('Input', 'NFIELD', TYPE, DIM, NFIELD, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IF ((NFIELD.LE.0) .OR. (NFIELD.GT.MAXAFL)) THEN
         IF (NFIELD.LE.0) NFIELD = 1
         IF (NFIELD.GT.MAXAFL) NFIELD = MAXAFL
         CALL OPUT ('Input', 'NFIELD', TYPE, DIM, NFIELD, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Create CLEAN object
      CLEAN = 'CLEAN process object'
      CALL CREATE (CLEAN, 'CLEAN', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, CLEAN, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Convert BMAJ, BMIN to degrees
      CALL OGET ('Input', 'BMAJ', TYPE, DIM, BMAJ, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      BMAJ = BMAJ / 3600.0
      CALL OPUT (CLEAN, 'BEAM.BMAJ', TYPE, DIM, BMAJ, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'BMIN', TYPE, DIM, BMIN, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      BMIN = BMIN / 3600.0
      CALL OPUT (CLEAN, 'BEAM.BMIN', TYPE, DIM, BMIN, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Set CLEAN type
      CLNTYP = 'UV'
      DIM(1) = LEN (CLNTYP)
      DIM(2) = 1
      CALL OPUT (CLEAN, 'CLEANTYP', OOACAR, DIM, DUMMY, CLNTYP, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Set default stokes.
      CALL OGET ('Input', 'STOKES', TYPE, DIM, DUMMY, STOKES, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (STOKES .EQ. '    ') STOKES = 'I    '
      CALL OPUT ('Input', 'STOKES', TYPE, DIM, DUMMY, STOKES, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create other objects
C                                       UVDATA
      UVDATA = 'Input UVdata'
      CALL CREATE (UVDATA, 'UVDATA', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, UVDATA, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Get IF channel selection
      CALL SECSLT (UVDATA, BIF, EIF, BCHAN, ECHAN, STOKES, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       All Stokes', IF, channels
      CALL SECSAV (UVDATA, 1, 0, 1, 0, '    ', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Open UVDATA to be sure it's OK.
      CALL OOPEN (UVDATA, 'READ', IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OCLOSE (UVDATA, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Reset Selection
      CALL SECSAV (UVDATA, BIF, EIF, BCHAN, ECHAN, STOKES, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       UVWORK
      UVWORK = 'UVdata work object'
      CALL CREATE (UVWORK, 'UVDATA', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY3, INK3, OUTK3, UVWORK, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       BEAM
      BEAM = 'BEAM image for CLEAN'
      CALL CREATE (BEAM, 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY4, INK4, OUTK4, BEAM, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Classes derived from Stokes'
      CLASS = STOKES(1:1) // 'BEAM'
      DIM(1) = 6
      CALL OPUT (BEAM, 'CLASS', OOACAR, DIM, DUMMY, CLASS, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       CLEAN
C                                       Get number of fields
      CALL OGET ('Input', 'NFIELD', TYPE, DIM, NFIELD, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DO 50 I = 1,NFIELD
         WRITE (CLEANO(I),1000) I
         CALL CREATE (CLEANO(I), 'IMAGE', IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
         CALL IN2OBJ ('Input', NKEY5, INK5, OUTK5, CLEANO(I), IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Class from stokes
         IF (NITER.GT.0) THEN
            CLTYPE = 'CL'
         ELSE
            CLTYPE = 'IM'
            END IF
         CLASS = STOKES(1:1) // CLTYPE
         IF (I.LE.999) THEN
            WRITE (CLASS(4:6),1040) I
         ELSE
            WRITE (CLASS(3:6),1041) I
            END IF
         DIM(1) = LEN (CLASS)
         DIM(2) = 1
         CALL OPUT (CLEANO(I), 'CLASS', OOACAR, DIM, DUMMY, CLASS, IRET)
         IF (IRET.NE.0) GO TO 999
 50      CONTINUE
C                                       Attach Images etc. to CLEAN
C                                       Number of fields
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (CLEAN, 'NIMAGES', OOAINT, DIM, NFIELD, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       UVWORK
      DIM(1) = LEN (UVWORK)
      DIM(2) = 1
      CALL OPUT (CLEAN, 'UVDATA', OOACAR, DIM, DUMMY, UVWORK, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       BEAM image
      DIM(1) = LEN (BEAM)
      CALL OPUT (CLEAN, 'DIRTBEAM', OOACAR, DIM, DUMMY, BEAM, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       CLEAN image(s)
      DIM(1) = LEN (CLEANO(1))
      DIM(2) = NFIELD
      CALL OPUT (CLEAN, 'CLEANI', OOACAR, DIM, DUMMY, CLEANO, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Process other info
C                                       Field size
      CALL OGET ('Input', 'FLDSIZE', TYPE, DIM, FLDSIZ, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Min. image sizes
      CALL OGET ('Input', 'IMSIZE', TYPE, DIM, IMSI, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       No images smaller than 64
      IMSI(1) = MAX (IMSI(1), 64)
      IMSI(2) = MAX (IMSI(2), 64)
      MAXNX = 0
      MAXNY = 0
      MINNX = MAXIMG
      MINNY = MAXIMG
      DO 70 I = 1,MAXAFL
         IF (FLDSIZ(1,I).LE.0) FLDSIZ(1,I) = IMSI(1) - 10
         IF (FLDSIZ(2,I).LE.0) FLDSIZ(2,I) = IMSI(2) - 10
C                                       Next largest power of two
         NXFLD = NPTWO (FLDSIZ(1,I))
         NYFLD = NPTWO (FLDSIZ(2,I))
         IMSIZE(1,I) = MAX (IMSI(1), NXFLD)
         IMSIZE(2,I) = MAX (IMSI(2), NYFLD)
         MAXNX = MAX (MAXNX, IMSIZE(1,I))
         MAXNY = MAX (MAXNY, IMSIZE(2,I))
         MINNX = MIN (MINNX, IMSIZE(1,I))
         MINNY = MIN (MINNY, IMSIZE(2,I))
 70      CONTINUE
      DIM(1) = 2
      DIM(2) = MAXFLD
      CALL OPUT (CLEANO(1), 'IMSIZE', OOAINT, DIM, IMSIZE, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(2) = 1
      DO 80 I = 2,NFIELD
         CALL OPUT (CLEANO(I), 'IMSIZE', OOAINT, DIM, IMSIZE(1,I),
     *      CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
 80      CONTINUE
C                                       Beam size
      CALL OGET ('Input', 'NITER', TYPE, DIM, NITER, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Control information.
      CALL OGET ('Input', 'CPARM', TYPE, DIM, CPARM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DODFT = CPARM(4) .GT. 0.0
C                                       Beam same size as image for DFT.
      IF (DODFT) THEN
         NXBEM = MAXNX
         NYBEM = MAXNY
      ELSE
         NXBEM = MIN (MAXNX*2, 2048)
         NYBEM = MIN (MAXNY*2, 2048)
         END IF
C                                       If not cleaning make beam =
C                                       field 1.
      IF (NITER.LE.0) THEN
         NXBEM = IMSIZE(1,1)
         NYBEM = IMSIZE(2,1)
         END IF
      BMSIZ(1) = NXBEM
      BMSIZ(2) = NYBEM
      DIM(1) = 2
      DIM(2) = 1
      CALL OPUT (BEAM, 'IMSIZE', OOAINT, DIM, BMSIZ, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Define the clean boxes from input
C                                       file or program inputs
C
      CALL OGET ('Input', 'INFILE', TYPE, DIM, DUMMY, FILEIN, IRET)
      IF (IRET.NE.0) GO TO 999
C
      WINM = MIN (MXNBOX, MXNBFL/NFIELD)
      WINW = 4 * NFIELD * WINM
      NWORDS = (WINW - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', 'WFCLN', NWORDS, WIN(1), WINP, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Use INFILE
      IF (FILEIN(1:1).NE.'  ') THEN
         CALL WINDF (WIN(1+WINP), NBOXES, NFIELD, IMSIZE, FLDSIZ,
     *      FILEIN, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'WFCLIN: Error in defining clean boxes from file'
            CALL MSGWRT(7)
         ENDIF
         DIM(1) = NFIELD
         DIM(2) = 1
         CALL OPUT (CLEAN, 'NBOXES', OOAINT, DIM, NBOXES, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         DIM(1) = 4 * NFIELD
         DIM(2) = WINM
         CALL OPUT (CLEAN, 'WINDOW', OOAINT, DIM, WIN(1+WINP), CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Use program inputs
      ELSE
         CALL FILL (MAXFLD, 1, NBOXES)
         CALL OGET ('Input', 'NBOXES', TYPE, DIM, NBOXES, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         IF (NBOXES(1).GT.0) THEN
            IS = 2
         ELSE
            NBOXES(1) = 1
            IS = 1
            END IF
         DIM(1) = NFIELD
         DIM(2) = 1
         CALL OPUT (CLEAN, 'NBOXES', OOAINT, DIM, NBOXES, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Window
         CALL FILL (WINW, 0, WIN(1+WINP))
         CALL OGET ('Input', 'CLBOX', TYPE, DIM, WIN(1+WINP), CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Fill in higher windows
C                                       or all if NBOXES <= 0
         DO 100 I = IS,NFIELD
            KP = (I-1) * 4 + WINP
C                                       fill window from IMSIZE and
C                                       FLDSIZE
            EDGEX = IMSIZE(1,I) - FLDSIZ(1,I)
            EDGEY = IMSIZE(2,I) - FLDSIZ(2,I)
            WIN(1+KP) = EDGEX / 2
            WIN(2+KP) = EDGEY / 2
            WIN(3+KP) = IMSIZE(1,I) - EDGEX / 2
            WIN(4+KP) = IMSIZE(2,I) - EDGEY / 2
 100        CONTINUE
         DIM(1) = 4 * NFIELD
         DIM(2) = WINM
         CALL OPUT (CLEAN, 'WINDOW', OOAINT, DIM, WIN(1+WINP), CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Free dynamic memory
C                                       Really should go to HI but
      CALL ZMEMRY ('FREE', 'WFCLN', WINW, WIN(1), WINP, IRET)
C                                       Restore?
      CALL OGET ('Input', 'BMAJ', TYPE, DIM, BMAJ, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'BMIN', TYPE, DIM, BMIN, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'BPA', TYPE, DIM, BPA, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      NOREST = BMAJ .LT. 0.0
      DIM(1) = 1
      CALL OPUT (CLEAN, 'NORESTOR', OOALOG, DIM, NOREST, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Channel stuff
C                                       Default BCHAN, ECHAN
      CALL OGET ('Input', 'BCHAN', TYPE, DIM, BCHAN, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'ECHAN', TYPE, DIM, ECHAN, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Find size of freq. axis.
      CALL UVDFND (UVDATA, 2, 'FREQ', FQINDX, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET (UVDATA, 'UV_DESC.NAXIS', TYPE, DIM, NAXIS, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      IF (IRET.NE.0) GO TO 999
      BCHAN = MAX (BCHAN, 1)
      IF (ECHAN.LE.0) ECHAN = NAXIS(FQINDX)
      DIM(1) = 1
      IF ((ECHAN.GT.NAXIS(FQINDX)) .OR. (ECHAN.LT.BCHAN)) THEN
         IRET = 5
         WRITE (MSGTXT,1100) BCHAN, ECHAN, NAXIS(FQINDX)
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL OPUT (CLEAN, 'BCHAN', OOAINT, DIM, BCHAN, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (CLEAN, 'ECHAN', OOAINT, DIM, ECHAN, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Save in Inputs for history
      CALL OPUT ('Input', 'BCHAN', OOAINT, DIM, BCHAN, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT ('Input', 'ECHAN', OOAINT, DIM, ECHAN, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       IF numbers
C                                       Default BIF, EIF
      CALL OGET ('Input', 'BIF', TYPE, DIM, BIF, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'EIF', TYPE, DIM, EIF, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL UVDFND (UVDATA, 2, 'IF  ', IFINDX, IRET)
      IRET = 0
      IF (IFINDX.GT.0) THEN
C                                       Find size of IF axis.
         CALL OGET (UVDATA, 'UV_DESC.NAXIS', TYPE, DIM, NAXIS, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         BIF = MAX (1, BIF)
         IF (EIF.LE.0) EIF = NAXIS(IFINDX)
         IF ((EIF.GT.NAXIS(IFINDX)) .OR. (EIF.LT.BIF)) THEN
            IRET = 5
            WRITE (MSGTXT,1101) BIF, EIF, NAXIS(IFINDX)
            CALL MSGWRT (8)
            GO TO 999
            END IF
      ELSE
         BIF = 1
         EIF = 1
         END IF
C                                       Save in Inputs for history
      DIM(1) = 1
      CALL OPUT ('Input', 'BIF', OOAINT, DIM, BIF, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT ('Input', 'EIF', OOAINT, DIM, EIF, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Line or continuum
      CALL OGET ('Input', 'CHINC', TYPE, DIM, CHINC, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'NCHAV', TYPE, DIM, NCHAV, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CHINC = MAX (1, CHINC)
      NCHAV = MAX (1, NCHAV)
      IF ((NCHAV.LE.ECHAN-BCHAN) .AND. ((ECHAN-BCHAN)/CHINC.GT.0)) THEN
         CHTYPE = 'LINE'
         IF ((ECHAN-BCHAN)/CHINC+1.GT.46655) THEN
            MSGTXT = 'CAN ONLY DO 46655 CHANNELS AT A TIME IN LINE'
            CALL MSGWRT (8)
            IRET = 5
            GO TO 999
            END IF
      ELSE
         CHTYPE = 'SUM '
         NCHAV = ECHAN - BCHAN + 1
         NCHAV = MAX (1, NCHAV)
         CHINC = NCHAV
C         NCHAV = NCHAV * (EIF - BIF + 1)
C         NCHAV = MAX (1, NCHAV)
         END IF
C                                       Save value
      CALL OPUT ('Input', 'NCHAV', TYPE, DIM, NCHAV, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy UV descriptors to BEAM
      DIM(1) = LEN (CHTYPE)
      DIM(2) = 1
      CALL OPUT (BEAM, 'CHTYPE', OOACAR, DIM, DUMMY, CHTYPE, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL U2IDES (UVDATA, BEAM, .FALSE., IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy UV descriptors to Images
      DO 200 I = 1,NFIELD
         CALL OPUT (CLEANO(I), 'CHTYPE', OOACAR, DIM, DUMMY, CHTYPE,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         CALL U2IDES (UVDATA, CLEANO(I), .FALSE., IRET)
         IF (IRET.NE.0) GO TO 999
 200     CONTINUE
C                                       Scale residuals?
      DOSCAL = CPARM(5) .GT. 0.0
      DIM(1) = 1
      DIM(2) = 1
      CALL OPUT (CLEAN, 'SCALERES', OOALOG, DIM, DOSCAL, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      BMSSZ(1) = IROUND (CPARM(6))
      BMSSZ(2) = IROUND (CPARM(7))
      IF (BMSSZ(1).LE.0) BMSSZ(1) = 5
      IF (BMSSZ(2).LE.0) BMSSZ(2) = 5
      DIM(1) = 2
      CALL OPUT (CLEAN, 'BMSCLSZ', OOAINT, DIM, BMSSZ, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Special treatment: DFT imaging
      IF (DODFT) THEN
C                                       Set shift for DFT
         CALL OGET ('Input', 'RASHIFT', TYPE, DIM, RASH, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OGET ('Input', 'DECSHIFT', TYPE, DIM, DECSH, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         DIM(1) = 1
         CALL OPUT (CLEANO(1), 'XSHIFT', OOARE, DIM, RASH(1), CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT (CLEANO(1), 'YSHIFT', OOARE, DIM, DECSH(1), CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
C                                       MINPATCH = 50
         CALL OPUT (CLEAN, 'MINPATCH', OOAINT, DIM, 50, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       MAXPATCH = 50
         CALL OPUT (CLEAN, 'MAXPATCH', OOAINT, DIM, 50, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Guard band in uv grids.
      CALL OGET ('Input', 'CELLSIZE', TYPE, DIM, CELLS, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       UV Cellsize for smallest image
      DU = RAD2AS / (MINNX * ABS (CELLS(1)))
      DV = RAD2AS / (MINNY * CELLS(2))
C                                       Set limits.
      UMAX = (MINNX/2-1.0) * DU
      VMAX = (MINNY/2-1.0) * DV
C                                       Add maximum of user specified
C                                       guardband or 7 cells.
      CALL OGET ('Input', 'UVTAPER', TYPE, DIM, UVTAPR, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'GUARD', TYPE, DIM, GUARDB, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       default guard band widths
      UTFACT(1) = 1.0
      IF (UVTAPR(1).GT.0.0) UTFACT(1) =  EXP (LOG(0.3) *
     *   ((UMAX*0.7) / (1000. * UVTAPR(1)))**2)
      UTFACT(1) = 0.3 * SQRT (UTFACT(1))
      GUAU = 7.0 * DU
      IF (GUARDB(1).LT.-0.001) THEN
         GUARDB(1) = GUAU / UMAX
      ELSE IF ((GUARDB(1).LE.0.001) .OR. (GUARDB(1).GT.0.9)) THEN
         GUARDB(1) = UTFACT(1)
         END IF
      GUAU = MAX (GUAU, GUARDB(1)*UMAX)
      UTFACT(2) = 1.0
      IF (UVTAPR(2).GT.0.0) UTFACT(2) =  EXP (LOG(0.3) *
     *   ((VMAX*0.7) / (1000. * UVTAPR(2)))**2)
      UTFACT(2) = 0.3 * SQRT (UTFACT(2))
      GUAV = 7.0 * DV
      IF (GUARDB(2).LT.-0.001) THEN
         GUARDB(2) = GUAV / VMAX
      ELSE IF ((GUARDB(2).LE.0.001) .OR. (GUARDB(2).GT.0.9)) THEN
         GUARDB(2) = UTFACT(2)
         END IF
      GUAV = MAX (GUAV, GUARDB(2)*VMAX)
      GUARDB(1) = GUAU / UMAX
      GUARDB(2) = GUAV / VMAX
      CALL OUVPUT (UVDATA, 'GUARDBND', TYPE, DIM, GUARDB, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OUVPUT (UVDATA, 'GUARDEF', TYPE, DIM, UTFACT, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OUVPUT(UVDATA, 'CELLSIZE', TYPE, DIM, CELLS, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      UMAX = UMAX - GUAU
      VMAX = VMAX - GUAV
      DIM(1) = 1
      DIM(2) = 1
      CALL OUVPUT (UVDATA, 'UMAX', OOARE, DIM, UMAX, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OUVPUT (UVDATA, 'VMAX', OOARE, DIM, VMAX, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLEAN field number ',I5)
 1040 FORMAT (I3.3)
 1041 FORMAT (I4.4)
 1100 FORMAT ('BCHAN - ECHAN =',I5,' -',I5,' NOT IN RANGE 1 -',I5)
 1101 FORMAT ('BIF - EIF =',I4,' -',I4,' NOT IN RANGE 1 -',I4)
      END
      INTEGER FUNCTION NPTWO (N)
C-----------------------------------------------------------------------
C   Function to determine the next highest power of two for an integer.
C   Input:
C      N       I  Integer
C   Output:
C      NPTWO   I  Next highest power of two
C-----------------------------------------------------------------------
      INTEGER   N
C
      INTEGER   IPOW
      REAL      POW
C-----------------------------------------------------------------------
      POW = LOG (1.0*N) / LOG (2.0) + 0.99999
      IPOW = POW
      NPTWO = 2 ** IPOW
 999  RETURN
      END
      SUBROUTINE WFLEAN (CLEAN, UVDATA, IERR)
C-----------------------------------------------------------------------
C   Does CLEAN, looping over channels
C   Inputs:
C      CLEAN   C*?  Name of CLEAN process object
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER CLEAN*(*), UVDATA*32
      INTEGER   IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ICHAN, BCHAN, ECHAN, CHINC, CHANN, TYPE, DIM(7), NCHAV,
     *   I, NFIELD, JCHAN, DUMMY, LCHAN, NIF, BIF, EIF, NCHAVG, LECHAN,
     *   NUMCH
      LOGICAL   DOPBFM, DODFT, DOWARN, DOMAX
      REAL      CPARM(10), SPINDX, FSCAL, PBFSIZ, AVGTIM, PANGL, ZANGL
      DOUBLE PRECISION PBFREQ(MAXIF), UVFREQ
      CHARACTER UVWORK*32, CLEANO(MAXFLD)*32, CHTYPE*4, FTTYPE*4,
     *   CDUMMY*1
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Control information.
      CALL OGET (CLEAN, 'CPARM', TYPE, DIM, CPARM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      PBFSIZ = CPARM(1)
      DOPBFM = PBFSIZ .GT. 0.0
      SPINDX = CPARM(2)
      FSCAL = CPARM(3)
      DODFT = CPARM(4) .GT. 0.0
C                                       Uv work object
      CALL OGET (CLEAN, 'UVDATA', TYPE, DIM, DUMMY, UVWORK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       CLEAN image object
      CALL OGET (CLEAN, 'CLEANI', TYPE, DIM, DUMMY, CLEANO, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Line or continuum
      CALL OGET (CLEANO(1), 'CHTYPE', TYPE, DIM, DUMMY, CHTYPE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Find number of channels
      CALL OGET (CLEAN, 'BCHAN', TYPE, DIM, BCHAN, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (CLEAN, 'ECHAN', TYPE, DIM, ECHAN, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      BCHAN = MAX (1, BCHAN)
      ECHAN = MAX (BCHAN, ECHAN)
      CALL OGET ('Input', 'CHINC', TYPE, DIM, CHINC, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CHINC = MAX (1, CHINC)
      CALL OGET ('Input', 'CHANNEL', TYPE, DIM, CHANN, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CHANN = MAX (BCHAN, CHANN)
      CALL OGET ('Input', 'NCHAV', TYPE, DIM, NCHAV, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      NCHAV = MAX (1, NCHAV)
      NUMCH = (ECHAN - BCHAN + 1 - NCHAV) / CHINC + 1
      LECHAN = BCHAN + CHINC*NUMCH - 1
      CALL OGET ('Input', 'BIF', TYPE, DIM, BIF, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET ('Input', 'EIF', TYPE, DIM, EIF, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      NIF = MAX (1, EIF - BIF + 1)
      IF ((CHTYPE.NE.'LINE') .AND. (NCHAV.GT.CHINC)) CHINC = NCHAV
      CALL OPUT (UVDATA, 'CALEDIT.BCHAN', OOAINT, DIM, CHANN, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
      JCHAN = CHANN + (ECHAN - BCHAN)
      JCHAN = MIN (ECHAN, CHANN+NCHAV-1)
      CALL OPUT (UVDATA, 'CALEDIT.ECHAN', OOAINT, DIM, JCHAN, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Force create of UVWORK
      CALL OCLONE (UVDATA, UVWORK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open CLEAN
      CALL OOPEN (CLEAN, 'DEST', IERR)
      IF (IERR.NE.0) GO TO 999
      DOWARN = .TRUE.
C                                       Loop over channel
      DO 600 ICHAN = CHANN,LECHAN,CHINC
         DOMAX = ICHAN+CHINC.GT.LECHAN
C                                       Copy uv data to work object, set
C                                       channel.
         DIM(1) = 1
         DIM(2) = 1
         DIM(3) = 0
         CALL OPUT (UVDATA, 'CALEDIT.BCHAN', OOAINT, DIM, ICHAN, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         JCHAN = ICHAN + NCHAV - 1
         NCHAVG = NCHAV * NIF
         CALL OPUT (UVDATA, 'CALEDIT.ECHAN', OOAINT, DIM, JCHAN, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Progress message
         WRITE (MSGTXT,1000) ICHAN, JCHAN, NIF
         CALL MSGWRT (4)
C                                       Select/correct
         CALL WFCOPY (UVDATA, UVWORK, SPINDX, FSCAL, DOWARN, IERR)
         IF (IERR.NE.0) GO TO 999
         DOWARN = .FALSE.
C                                       Special options
C                                       Primary beam corrections
         IF (DOPBFM) THEN
C                                       Freq array
            CALL UVFRQS (UVDATA, UVFREQ, PBFREQ, IERR)
            IF (IERR.NE.0) GO TO 999
            DIM(1) = 1
            DIM(2) = 1
            CALL OPUT (UVWORK, 'DOPBFM', OOALOG, DIM, DOPBFM, CDUMMY,
     *         IERR)
            IF (IERR.NE.0) GO TO 999
            CALL OPUT (UVWORK, 'PBFSIZ', OOARE, DIM, PBFSIZ, CDUMMY,
     *         IERR)
            IF (IERR.NE.0) GO TO 999
            DIM(1) = NCHAVG
            CALL OPUT (UVWORK, 'PBFREQ', OOADP, DIM, PBFREQ, CDUMMY,
     *         IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
C                                       DFT or FFT
         IF (DODFT) THEN
            FTTYPE = 'DFT'
         ELSE
            FTTYPE = 'FFT'
            END IF
         DIM(1) = LEN (FTTYPE)
         CALL OPUT (CLEANO(1), 'FTTYPE', OOACAR, DIM, DUMMY, FTTYPE,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Uniform weighting
C                                       Set channel in CLEAN
         DIM(1) = 1
         LCHAN = (ICHAN - BCHAN) / CHINC + 1
         CALL OPUT (CLEAN, 'CHANNEL', OOAINT, DIM, LCHAN, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OPUT (CLEAN, 'UVCHAN', OOAINT, DIM, 1, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OPUT (CLEAN, 'NCHAV', OOAINT, DIM, NCHAVG, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Set CC version, (line only)
         IF (CHTYPE.EQ.'LINE') THEN
            CALL OPUT (CLEAN, 'VERSION', OOAINT, DIM, LCHAN, CDUMMY,
     *         IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
C                                       Uniform weight/beam mod
         CALL OUNFWT (UVWORK, CLEANO(1), IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Clean
         CALL CLNUV (CLEAN, DOMAX, IERR)
         IF (IERR.NE.0) GO TO 999
 600     CONTINUE
C                                       How many fields?
      CALL OGET (CLEAN, 'NIMAGES', TYPE, DIM, NFIELD, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Close CLEAN
      CALL OCLOSE (CLEAN, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Observing geometry
C                                       Get average time
      CALL WFTAV (UVDATA, AVGTIM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get parallactic, zenith angles
      CALL WFPARG (UVDATA, AVGTIM, PANGL, ZANGL, IERR)
      IF (IERR.NE.0) GO TO 999
      DO 700 I = 1,NFIELD
C                                       Save observing geometry on CLEAN
C                                       images
         DIM(1) = 1
         DIM(2) = 1
         CALL OPUT (CLEANO(I), 'PARANGLE', OOARE, DIM, PANGL, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OPUT (CLEANO(I), 'ZENANGLE', OOARE, DIM, ZANGL, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
 700     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Beginning channel',I5,' through',I5,' with',I3,' IFs')
      END
      SUBROUTINE WFTAV (UVDATA, AVGTIM, IERR)
C-----------------------------------------------------------------------
C   Determines the average time of a data set. Averages time in GST and
C   then converts back to Solar time on day 0.  This avoids the problems
C   associated with observations spanning several days.
C      NOTE: this routine uses "AP" memory for scratch memory
C   Inputs:
C      UVDATA C*?  UV residual file from previous CLEAN
C   Output:
C      AVGTIM R Average time in days.
C      IERR   I Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER UVDATA*(*)
      REAL      AVGTIM
      INTEGER   IERR
C
      INTEGER   COUNT, JLOCT, TYPE, DIM(3), LERR
      REAL      RP(50), VIS(3,10000)
      DOUBLE PRECISION GSTIA0, DEGPDY, SUMR, SUMI, TIME, GST0, ROTRAT
      CHARACTER TABLE*32, CDUM*1
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      CALL APOBJ ('OPEN', 'WFTAV', IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Get time information from AN
C                                       table.
      TABLE = 'Temporary AN table for WFTAV'
      CALL UV2TAB (UVDATA, TABLE, 'AN', 1, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL TABOPN (TABLE, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
      CALL TABGET (TABLE, 'KEY.GSTIA0', TYPE, DIM, GSTIA0, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL TABGET (TABLE, 'KEY.DEGPDY', TYPE, DIM, DEGPDY, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL TABCLO (TABLE, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Delete object
      CALL TABDES (TABLE, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Convert units to radians
      GST0 = GSTIA0 * DG2RAD
      ROTRAT = DEGPDY * DG2RAD
C                                       Open uv data
      CALL OUVOPN (UVDATA, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Which random parameter
      CALL UVDFND (UVDATA, 1, 'TIME', JLOCT, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'WFTAV:TROUBLE FINDING RANDOM PARAMETER TIME'
         CALL MSGWRT (7)
         GO TO 990
         END IF
      SUMR = 0.0
      SUMI = 0.0
      COUNT = 0
C                                       Loop thru data
 100  CALL UVREAD (UVDATA, RP, VIS, IERR)
         IF (IERR.GT.0) THEN
            GO TO 990
         ELSE IF (IERR.EQ.0) THEN
C                                       Convert time to GST(radians)
            TIME = RP(JLOCT) * ROTRAT + GST0
C                                       Sum as sine and cosine
            COUNT = COUNT + 1
            SUMR = SUMR + COS (TIME)
            SUMI = SUMI + SIN (TIME)
            GO TO 100
            END IF
C                                       Close
      IERR = 0
      CALL OUVCLO (UVDATA, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Average as cosine and sine to
C                                       deal with periodic nature of GST
      IF (COUNT.GT.0) THEN
         AVGTIM = ATAN2 (SUMI, SUMR+1.0D-20)
      ELSE
         MSGTXT = 'WFTAV: NO VISIBILITIES'
         CALL MSGWRT (7)
         IERR = 5
         GO TO 990
         END IF
C                                       Convert time back to solar
      AVGTIM = (AVGTIM - GST0)
      IF (AVGTIM.LE.0.0) AVGTIM = AVGTIM + TWOPI
      IF (AVGTIM.LE.0.0) AVGTIM = AVGTIM + TWOPI
      AVGTIM = AVGTIM / ROTRAT
      CALL APOBJ ('CLOSE', 'WFTAV', LERR)
      GO TO 999
C                                       Error
 990  CALL APOBJ ('CLOSE', 'WFTAV', LERR)
 995  MSGTXT = 'WFTAV: ERROR AVERAGING TIME FOR ' // UVDATA
      CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE WFPARG (UVDATA, AVGTIM, PANGL, ZANGL, IERR)
C-----------------------------------------------------------------------
C   Determines the observing geometry from the average time.
C   Inputs:
C      UVDATA C*?  UV residual file from previous CLEAN
C      AVGTIM R Average time in days.
C   Output:
C      PANGL  R Parallactic angle in degrees.
C      ZANGL  R Zenith angle in degrees.
C      IERR   I Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER UVDATA*(*)
      REAL      AVGTIM, PANGL, ZANGL
      INTEGER   IERR
C
      INTEGER   ANT, SUBARR, SOURID
      CHARACTER TABLE*32
      REAL      PANG, EL, HA, ZA
      DOUBLE PRECISION TIME
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
C-----------------------------------------------------------------------
      IERR = 0
      TABLE = 'Temporary table for WFPARG'
      CALL UV2TAB (UVDATA, TABLE, 'AN', 1, IERR)
C                                       Get parallactic angle
      ANT = 1
      SUBARR = 1
      SOURID = -1
      CALL OSUPAN (TABLE, ANT, SUBARR, SOURID, AVGTIM, PANG, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Get elevation
      TIME = AVGTIM
      CALL OSUELV (TABLE, ANT, SUBARR, SOURID, TIME, HA, EL, ZA, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Delete object
      CALL TABDES (TABLE, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Convert to degrees.
      PANGL = PANG * 57.296
C                                       Get zenith angle
      ZANGL = 90.0 - EL * 57.296
      GO TO 999
C                                       Error
 990  MSGTXT = 'WFPARG: ERROR DETERMINING OBSERVING GEOMETRY'
      CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE WFCOPY (UVIN, UVOUT, SPINDX, FSCAL, DOWARN, IERR)
C-----------------------------------------------------------------------
C   Copies one uv data object to another with application of any
C   calibration editing, and selection criteria.
C   Data are scaled in frequency to remove a  spectral index of SPINDX
C   and corrected to the reference frequency.  Also, u, v and w are
C   scaled by FSCAL.
C   NOTE: This routine will only handle up to 1024 correlations in a vis.
C   Inputs:
C      UVIN    C*?  Name of input uvdata object.  All specified
C                   selection, editing and calibration are applied.
C      UVOUT   C*?  Name of output uvdata object.  May be UVIN.
C      DOWARN  L    Do warning messages about data selection?
C   Inputs attached to UVIN
C      UMAX    R    Maximum acceptable U in wavelengths (default all)
C      VMAX    R    Maximum acceptable V in wavelengths (default all)
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER UVIN*(*), UVOUT*(*)
      REAL      SPINDX, FSCAL
      INTEGER   IERR
      LOGICAL   DOWARN
C
      INTEGER   COUNT, TYPE, DIM(7), SUBA, NCOR, NAXIS(7), NSTOK, I, J,
     *   K, INDEX, JLOCS, INDXU, INDXV, INDXW, MSGSAV, DUMMY, TCOUNT,
     *   LERR
      CHARACTER SORD*2, CDUMMY*1
      REAL      RP(50), VS(3,1024), FS(1024), FST, UMAX, VMAX, AUMAX,
     *   BUMAX, AVMAX, BVMAX, GUARDB(2), UTFACT(2), UU, VV, CELLS(2)
      DOUBLE PRECISION FREQS(1024), UVFREQ, DSUM, AVGFRQ, FRMULT
      LOGICAL   EXIST, DOSCLU
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PAOOF.INC'
C-----------------------------------------------------------------------
      CALL APOBJ ('OPEN', 'WFCOPY', IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Open input.
      CALL OUVOPN (UVIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Create output if necessary
      CALL OBFEXS (UVOUT, EXIST, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (.NOT.EXIST) THEN
         CALL OUVCLN (UVIN, UVOUT, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       U,V limits
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL OUVGET (UVIN, 'UMAX', TYPE, DIM, UMAX, CDUMMY, IERR)
      MSGSUP = MSGSAV
C                                       Default = all
      IF (IERR.EQ.1) THEN
         UMAX = 1.0E30
         IERR = 0
         END IF
      IF (IERR.NE.0) GO TO 980
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL OUVGET (UVIN, 'VMAX', TYPE, DIM, VMAX, CDUMMY, IERR)
      MSGSUP = MSGSAV
C                                       Default = all
      IF (IERR.EQ.1) THEN
         VMAX = 1.0E30
         IERR = 0
         END IF
      IF (IERR.NE.0) GO TO 980
C                                       Actual guardband
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL OUVGET (UVIN, 'GUARDBND', TYPE, DIM, GUARDB, CDUMMY, IERR)
      MSGSUP = MSGSAV
      IF (IERR.EQ.1) THEN
         GUARDB(1) = 0.0
         GUARDB(2) = 0.0
         IERR = 0
         END IF
      IF (IERR.NE.0) GO TO 980
C                                       Default guardband
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL OUVGET (UVIN, 'GUARDEF', TYPE, DIM, UTFACT, CDUMMY, IERR)
      MSGSUP = MSGSAV
      IF (IERR.EQ.1) THEN
         UTFACT(1) = 0.0
         UTFACT(2) = 0.0
         IERR = 0
         END IF
      IF (IERR.NE.0) GO TO 980
C                                       Intended cellsize
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL OUVGET (UVIN, 'CELLSIZE', TYPE, DIM, CELLS, CDUMMY, IERR)
      MSGSUP = MSGSAV
      IF (IERR.EQ.1) THEN
         CELLS(1) = 1.0
         CELLS(2) = 1.0
         IERR = 0
         END IF
      IF (IERR.NE.0) GO TO 980
C                                       Open output
      CALL OUVOPN (UVOUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy UVDESC
      CALL UVDSCP (UVIN, UVOUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Subarray number
      CALL SECGET (UVIN, 'SUBARR', TYPE, DIM, SUBA, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (SUBA.LE.0) SUBA = 1
C                                       NCORR
      CALL UVDGET (UVIN, 'NCORR', TYPE, DIM, NCOR, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Frequency info
      DOSCLU = FSCAL .GT. 0.0
C                                       Uv data pointers
      CALL UVDFND (UVIN, 2, 'STOKES', JLOCS, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL UVDFND (UVIN, 1, 'UU-L', INDXU, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE FINDING RANDOM PARAMETER UU-L'
         GO TO 980
         END IF
      CALL UVDFND (UVIN, 1, 'VV-L', INDXV, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE FINDING RANDOM PARAMETER VV-L'
         GO TO 980
         END IF
      CALL UVDFND (UVIN, 1, 'WW-L', INDXW, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE FINDING RANDOM PARAMETER WW-L'
         GO TO 980
         END IF
C                                       UV axis descriptor
C                                       NAXIS
      CALL UVDGET (UVIN, 'NAXIS', TYPE, DIM, NAXIS, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Number of polarizations
      NSTOK = NAXIS(JLOCS)
C                                       Freq array
      CALL UVFRQS (UVIN, UVFREQ, FREQS, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Average frequency
      COUNT = 0
      DSUM = 0.0D0
      K = 0
      FRMULT = 0.0D0
      DO 30 I = 1,NCOR,NSTOK
         K = K + 1
         DSUM = DSUM + FREQS(K)
         FRMULT = MAX (FRMULT, FREQS(K))
         COUNT = COUNT + 1
 30      CONTINUE
      FRMULT = FRMULT / UVFREQ
      AVGFRQ = DSUM / COUNT
C                                       Frequency scaling: Stokes is
C                                       always before IF and Freq.
      INDEX = 0
      K = 0
      DO 50 I = 1,NCOR,NSTOK
         K = K + 1
         FST = (AVGFRQ / FREQS(K)) ** SPINDX
         DO 40 J = 1,NSTOK
            INDEX = INDEX + 1
            FS(INDEX) = FST
 40         CONTINUE
 50      CONTINUE
C                                       Initialize visibility count
      COUNT = 0
      TCOUNT = 0
      AUMAX = 0.0
      AVMAX = 0.0
      BUMAX = 0.0
      BVMAX = 0.0
      UMAX = UMAX / FRMULT
      VMAX = VMAX / FRMULT
      IF (SUBA.GT.1) THEN
         CALL UVDGET (UVOUT, 'GCOUNT', TYPE, DIM, COUNT, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       Loop thru data
 100     CALL UVREAD (UVIN, RP, VS, IERR)
         IF (IERR.LT.0) GO TO 200
         IF (IERR.GT.0) GO TO 990
C                                       Want this one?
         UU = ABS (RP(INDXU))
         VV = ABS (RP(INDXV))
         AUMAX = MAX (UU, AUMAX)
         AVMAX = MAX (VV, AVMAX)
         TCOUNT = TCOUNT + 1
         IF ((UU.LE.UMAX) .AND. (VV.LE.VMAX)) THEN
            BUMAX = MAX (UU, BUMAX)
            BVMAX = MAX (VV, BVMAX)
C                                       Scale u, v, w
            IF (DOSCLU) THEN
               RP(INDXU) = RP(INDXU) * FSCAL
               RP(INDXV) = RP(INDXV) * FSCAL
               RP(INDXW) = RP(INDXW) * FSCAL
               END IF
C                                       Scale vis
            DO 150 I = 1,NCOR
               VS(1,I) = VS(1,I) * FS(I)
               VS(2,I) = VS(2,I) * FS(I)
 150           CONTINUE
            COUNT = COUNT + 1
            CALL UVWRIT (UVOUT, RP, VS, IERR)
            IF (IERR.GT.0) GO TO 990
            END IF
         GO TO 100
 200     IERR = 0
C                                       Warnings ?
      IF (DOWARN) THEN
         IF (TCOUNT.GT.COUNT) THEN
            WRITE (MSGTXT,1200) COUNT, TCOUNT
            CALL MSGWRT (6)
         ELSE
            WRITE (MSGTXT,1201) COUNT
            CALL MSGWRT (3)
            END IF
C                                       data outside grid?
         UMAX = UMAX * FRMULT
         VMAX = VMAX * FRMULT
         AUMAX = AUMAX * FRMULT
         AVMAX = AVMAX * FRMULT
         BUMAX = BUMAX * FRMULT
         BVMAX = BVMAX * FRMULT
         IF ((AUMAX.GT.UMAX) .OR. (AVMAX.GT.VMAX)) THEN
            MSGTXT = '**** WARNING data discarded outside usable part'
     *         // ' of UV plane ****'
            CALL MSGWRT (6)
            IF (AUMAX.GT.UMAX) THEN
               UU = UMAX/AUMAX * ABS(CELLS(1))
               WRITE (MSGTXT,1210) 'U', AUMAX, UMAX
               CALL MSGWRT (6)
               WRITE (MSGTXT,1211) UU, ABS(CELLS(1))
               CALL MSGWRT (6)
               WRITE (MSGTXT,1212) 'U', GUARDB(1)
               CALL MSGWRT (6)
               END IF
            IF (AVMAX.GT.VMAX) THEN
               VV = VMAX/AVMAX * ABS(CELLS(2))
               WRITE (MSGTXT,1210) 'V', AVMAX, VMAX
               CALL MSGWRT (6)
               WRITE (MSGTXT,1211) VV, CELLS(2)
               CALL MSGWRT (6)
               WRITE (MSGTXT,1212) 'V', GUARDB(2)
               CALL MSGWRT (6)
               END IF
            END IF
         IF ((BUMAX.GT.UMAX*(1.-1.2*UTFACT(1))/(1.0-GUARDB(1))) .OR.
     *      (BVMAX.GT.VMAX*(1.-1.2*UTFACT(2))/(1.0-GUARDB(2)))) THEN
            MSGTXT = '**** WARNING data included out of inner portion'
     *         // ' of UV plane ****'
            CALL MSGWRT (6)
            MSGTXT = '**** Watch for high-frequency & other poor ' //
     *         'cleaning effects ****'
            CALL MSGWRT (6)
            END IF
         END IF
C                                       Better be some data
      IF (COUNT.LE.0) THEN
         IERR = 7
         MSGTXT = 'WFCOPY: NO DATA SELECTED'
         GO TO 980
         END IF
C                                       Set amount of output data
      DIM(1) = 1
      DIM(2) = 1
      CALL UVDPUT (UVOUT, 'GCOUNT', OOAINT, DIM, COUNT, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Sort order the same as input if
C                                       subarray 1, else undefined
      CALL UVDGET (UVIN, 'SORTORD', TYPE, DIM, DUMMY, SORD, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (SUBA.GT.1) SORD = '  '
      CALL UVDPUT (UVOUT, 'SORTORD', TYPE, DIM, DUMMY, SORD, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy relevant tables
      CALL UVDTCO (UVIN, UVOUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Close files, update disk
      CALL OUVCLO (UVIN, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OUVCLO (UVOUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Mark output as valid
      DIM(1) = 1
      CALL FSTPUT (UVOUT, 'VALID', OOALOG, DIM, .TRUE., CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL APOBJ ('CLOSE', 'WFCOPY', LERR)
      GO TO 999
C                                       Error
 980  CALL MSGWRT (7)
 990  CALL APOBJ ('CLOSE', 'WFCOPY', LERR)
 995  MSGTXT = 'WFCOPY: ERROR COPYING ' // UVIN
      CALL MSGWRT (7)
      MSGTXT = 'TO ' // UVOUT
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1200 FORMAT ('WFCOPY: Only',I9,' samples of',I9,' fell on UV grid')
 1201 FORMAT ('WFCOPY: Copied',I9,' visibilities to be imagied')
 1210 FORMAT ('**** Actual ',A,'max',1PE11.4,' exceeds limit',1PE11.4,
     *   8X,'****')
 1211 FORMAT ('**** Use cellsize <',F8.4,' not',F8.4,
     *   ' to get all the data ****')
 1212 FORMAT ('**** using a ',A,' guard band of',F7.3,' of a radius',
     *   13X,'****')
      END
      SUBROUTINE WFCHIS (CLEAN, UVDATA)
C-----------------------------------------------------------------------
C   Routine to write history file to output CLEAN image object.
C   Inputs:
C      CLEAN   C*?  CLEAN process object
C      UVDATA  C*?  Input UV data
C-----------------------------------------------------------------------
      CHARACTER CLEAN*(*), UVDATA*32
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NADV
      PARAMETER (NADV=45)
      CHARACTER CLEANO(MAXFLD)*32, BEAM*32, LIST(NADV)*8, CDUMMY*1
      INTEGER   IERR, TYPE, DIM(7), NFIELD, I, DUMMY
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'IN2NAME', 'IN2SEQ',
     *   'BCHAN', 'ECHAN', 'CHANNEL', 'NCHAV', 'CHINC', 'STOKES', 'BIF',
     *   'EIF', 'OUTNAME', 'OUTDISK', 'OUTSEQ', 'CELLSIZE', 'IMSIZE',
     *   'NFIELD', 'FLDSIZE', 'RASHIFT', 'DECSHIFT', 'NBOXES', 'CLBOX',
     *   'UVTAPER', 'UVRANGE', 'UVWTFN', 'UVBOX', 'ZEROSP', 'XTYPE',
     *   'YTYPE', 'XPARM', 'YPARM', 'GAIN', 'FLUX', 'MINPATCH', 'NITER',
     *   'BCOMP', 'BMAJ', 'BMIN', 'BPA', 'PHAT', 'FACTOR', 'CMETHOD',
     *   'CPARM'/
C-----------------------------------------------------------------------
C                                       How many fields
      CALL OGET ('Input', 'NFIELD', TYPE, DIM, NFIELD, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       CLEAN names
      CALL OGET (CLEAN, 'CLEANI', TYPE, DIM, DUMMY, CLEANO, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Loop over cleans
      DO 100 I = 1,NFIELD
C                                        Copy old history
         CALL OHCOPY (UVDATA, CLEANO(I), IERR)
         IF (IERR.NE.0) GO TO 990
C                                        New additions - copy adverb
C                                       values.
         CALL OHLIST ('Input', LIST, NADV, CLEANO(I), IERR)
         IF (IERR.NE.0) GO TO 990
 100     CONTINUE
C                                       Beam
      CALL OGET (CLEAN, 'DIRTBEAM', TYPE, DIM, DUMMY, BEAM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Old history
      CALL OHCOPY (UVDATA, BEAM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                        New additions - copy adverb
C                                       values.
      CALL OHLIST ('Input', LIST, NADV, BEAM, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // CLEANO(I)
      CALL MSGWRT (4)
C
 999  RETURN
      END
      SUBROUTINE WINDF (WIN, NBOXES, NFIELD, IMSIZE, FLDSIZ, INFILE,
     *   IERR)
C-----------------------------------------------------------------------
C   Fills the WIN array with clean box definitions taken from INFILE
C   Inputs:
C      INFILE   C*48        User provided file name containing box defs
C      NFIELD   I           Number of fields defined
C   Outputs:
C      WIN      I*4*MXNBOX*MAXFLD   Array containing clean boxes
C      NBOXES   I*MAXFLD    Array containing number of boxes/field
C      IERR     I           Error return code:
C                              0 => no error
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCLN.INC'
      CHARACTER INFILE*48
      INTEGER   NFIELD, WIN(4,NFIELD,*), NBOXES(MAXFLD)
      INTEGER   IMSIZE(2,MAXFLD), FLDSIZ(2,MAXFLD)
      INTEGER   IERR, LUN, I, J, ISUBF, I1, I2
      INTEGER   EDGEX, EDGEY, IFIELD, IBLCX, IBLCY, ITRCX, ITRCY, LIMIT
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      LIMIT = MIN (MXNBOX, MXNBFL/NFIELD)
C                                        Open clean box file
      LUN = 78
      CALL CBOPEN (LUN, INFILE, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'WINDF: Error opening clean box file'
         CALL MSGWRT (6)
         GO TO 999
         END IF

C                                        Similar default conditions , i.e.
C                                        define "overall" box for each
C                                        field
      I = 4 * NFIELD * LIMIT
      CALL FILL (I, 0, WIN)
      DO 10 I = 1,NFIELD
         NBOXES(I) = 1
         EDGEX = IMSIZE(1,I) - FLDSIZ(1,I)
         EDGEY = IMSIZE(2,I) - FLDSIZ(2,I)
         WIN(1,I,1) = EDGEX / 2
         WIN(2,I,1) = EDGEY / 2
         WIN(3,I,1) = IMSIZE(1,I) - EDGEX / 2
         WIN(4,I,1) = IMSIZE(2,I) - EDGEY / 2
 10      CONTINUE
C                                        Enter box parameters from file
      DO 200 I = 1,NFIELD
         REWIND (LUN)
         ISUBF = 0
         DO 100 J = 1,50000
            READ (LUN,*,END=110,ERR=110) IFIELD, IBLCX, IBLCY, ITRCX,
     *         ITRCY
            IF ((IFIELD.EQ.I) .AND. (ISUBF.LT.LIMIT)) THEN
               ISUBF = ISUBF + 1
               WIN(1,I,ISUBF) = IBLCX
               WIN(2,I,ISUBF) = IBLCY
               WIN(3,I,ISUBF) = ITRCX
               WIN(4,I,ISUBF) = ITRCY
               END IF
 100        CONTINUE
 110     NBOXES(I) = MAX(ISUBF,1)
 200     CONTINUE
C
      MSGTXT = 'WINDF: Number of clean boxes/field read as follows:'
      CALL MSGWRT(3)
      I1 = 1
 210  I2 = MIN (I1+3, NFIELD)
         WRITE (MSGTXT,1000) (J, NBOXES(J), J = I1,I2)
         CALL MSGWRT(3)
         IF (I2.LT.NFIELD) GO TO 210
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (4('FLD',I3.2,':',I5,3X))
      END
      SUBROUTINE CBOPEN (LUN, INFILE, IERR)
C-----------------------------------------------------------------------
C   Opens the clean box information file.
C
C   Inputs:
C      LUN      I           Logical unit number
C      INFILE   C*48        User provided file name
C   Outputs:
C      IERR     I           Error return code:
C                              0 => no error
C                              1 => error
C
C   Generic version.
C-----------------------------------------------------------------------
      INTEGER   LUN
      CHARACTER INFILE*48
      INTEGER   IERR
      INTEGER   XLNB, ITRIM, IOSVAL
      LOGICAL   EXISTS
      CHARACTER FILSPC*256
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Assume success.
      IERR = 0
      EXISTS = .FALSE.
C                                       Determine full name
      CALL ZFULLN (INFILE, ' ', ' ', FILSPC, IERR)
      IF (IERR.NE.0) THEN
         IERR = 4
         GO TO 999
      END IF
      XLNB = ITRIM (FILSPC)
      WRITE (MSGTXT,1000)
      CALL MSGWRT (2)
      WRITE (MSGTXT,1001) FILSPC(1:MIN (56, XLNB))
      CALL MSGWRT (2)
      IF (XLNB.GT.56) THEN
         WRITE (MSGTXT,1001) FILSPC(57:XLNB)
         CALL MSGWRT (2)
      END IF
C                                       Check for existence.
      INQUIRE (FILE=FILSPC(1:XLNB), EXIST=EXISTS)
C                                       Found it?
      IF (.NOT.EXISTS) THEN
C                                       Can't find it.
         IERR = 1
         WRITE (MSGTXT,1030)
         CALL MSGWRT (6)
         WRITE (MSGTXT,1031) FILSPC(1:XLNB)
         CALL MSGWRT (6)
      ELSE
C                                       Found it, now open it.
         OPEN (UNIT=LUN, FILE=FILSPC(1:XLNB), STATUS='OLD',
     .         IOSTAT=IOSVAL)
C                                       OPEN error?
         IF (IOSVAL.NE.0) THEN
            IERR = 1
            WRITE (MSGTXT,1040) IOSVAL
            CALL MSGWRT (6)
            WRITE (MSGTXT,1031) FILSPC(1:XLNB)
            CALL MSGWRT (6)
         ELSE
C                                       Rewind.
            REWIND (LUN)
         END IF
      END IF
C                                       Exit.
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CBOPEN: Opening CLEAN box file =')
 1001 FORMAT ('CBOPEN: ',A)
 1030 FORMAT ('CBOPEN: UNABLE TO FIND FILE = ')
 1031 FORMAT ('CBOPEN: ',A48)
 1040 FORMAT ('CBOPEN: FORTRAN OPEN ERROR = ',I6,' FOR FILE =')
      END

LOCAL INCLUDE 'IM2CC.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO,
     *   CATOLD(256), JBUFSZ, NX, NY, IBLC(7), ITRC(7), INX, INY, JNX,
     *   JNY
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      REAL      XSEQIN, XDISKI, XSEQO, XDISKO, BLC(7), TRC(7), ICUT,
     *   FLUX, XNX, XNY, XIMSIZ(2), BUFF1(MABFSS), BUFF2(MABFSS), BMAREA
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XNAMOU, XSEQO,
     *   XDISKO, BLC, TRC, ICUT, FLUX, XNX, XNY, XIMSIZ
      COMMON /CHPARM/ NAMEIN, CLAIN, NAMOUT, CLAOUT
      COMMON /PARMS/ CATOLD, SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO,
     *   OLDCNO, JBUFSZ, NX, NY, IBLC, ITRC, INX, INY, BMAREA, JNX, JNY
      COMMON /BUFRS/ BUFF1, BUFF2
LOCAL END
      PROGRAM IM2CC
C-----------------------------------------------------------------------
C! Task to convert a model image to multi-facet files with CC tables
C# Map-util Calibration Imaging
C-----------------------------------------------------------------------
C;  Copyright (C) 2011-2012, 2015-2016, 2019-2020
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   IM2CC converts model image to multi-facet images with CC files
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      ICUT           ICUT          CC only if abs value > ICUT
C      FLUX           FLUX          CC only if value > FLUX
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'IM2CC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'IM2CC '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL IM2CCI (PRGM, IRET)
C                                       do the work
      IF (IRET.EQ.0) CALL IM2CCD (IRET)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE IM2CCI (PRGN, IRET)
C-----------------------------------------------------------------------
C   IM2CCI starts up the task, sets windows
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, MTYPE*2, UNITS*8, TUNITS*8
      INTEGER   IERR, NPARM, IROUND, I
      REAL      RTEMP, OLDR(256)
      INCLUDE 'IM2CC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      EQUIVALENCE (CATOLD, OLDR)
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 32
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO = IROUND (XDISKO)
      NX = IROUND (XNX)
      NY = IROUND (XNY)
      IF (NX.LT.1) NX = 5
      IF (NY.LT.1) NY = 5
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, 'READ', BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1040) IRET
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Copy old CATBLK to new.
      CALL COPY (256, CATOLD, CATBLK)
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATOLD(KIDIM), CATOLD(KINAX), BLC, TRC, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Set integer windows
      DO 10 I = 1,7
         IBLC(I) = IROUND (BLC(I))
         ITRC(I) = IROUND (TRC(I))
 10      CONTINUE
C                                       round up for facet size
      INX = (ITRC(1) - IBLC(1)) / NX + 1
      INY = (ITRC(2) - IBLC(2)) / NY + 1
C                                       init location common
      LOCNUM = 2
      CALL SETLOC (IBLC(3), .FALSE.)
      IF (AXTYP(LOCNUM).NE.1) THEN
         IRET = 10
         MSGTXT = 'AXIS TYPES NOT AS EXPECTED'
         GO TO 990
         END IF
C                                       units conversion
      CALL H2CHR (8, 1, CATH(KHBUN), UNITS)
      TUNITS = UNITS
      CALL CHLTOU (8, TUNITS)
      IF (TUNITS.EQ.'JY/PIXEL') THEN
         BMAREA = 1.0
      ELSE IF (TUNITS.EQ.'JY/BEAM') THEN
         BMAREA = 1.1331 * CATR(KRBMJ) * CATR(KRBMN)
         RTEMP = ABS (CATR(KRCIC) * CATR(KRCIC+1))
         IF ((BMAREA.GT.0.0) .AND. (RTEMP.GT.0.0)) THEN
            BMAREA = BMAREA / RTEMP
            MSGTXT = 'CONVOLVED IMAGES DO NOT MAKE GOOD MODELS'
            CALL MSGWRT (6)
         ELSE
            MSGTXT = 'BEAM AREA IS INDETERMINATE, USING 1.0'
            CALL MSGWRT (7)
            BMAREA = 1.0
            END IF
      ELSE
         BMAREA = 1.0
         MSGTXT = 'UNITS TAKEN AS JY/PIXEL, BUT ARE ACTUALLY ' // UNITS
         CALL MSGWRT (7)
         END IF
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('IM2CCI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE IM2CCD (IRET)
C-----------------------------------------------------------------------
C   IM2CCD loops over the subimages, creating the files, making the CC
C   files and images and updating the headers.
C   Output:
C      IRET   I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER IFILE*48
      INTEGER   IROUND, LUNI, LUNO, NYI, NXI, WINI(4), NXO, NYO, JPAN,
     *   WINO(4), BOI, BOO, I1, I2, I3, I4, I5, I6, I7, IPOS(5), JPLAN,
     *   CORN(5), BOTEMP, CCBUFF(512), CCLUN, CCRNO, CCKOLS(7), IXP,
     *   CCNUMV(7), NCOL, IBIND, OBIND, INDI, INDO, NCC, NCCM, NCCT,
     *   IYP, ITYPE, KEY(2,2), KEYSUB(2,2), VER, XOFF, YOFF, XXTRA,
     *   YXTRA, I, NXX, NYY
      REAL      OUTMAX, OUTMIN, OLD4(256), XPIX, YPIX, VAL, XX, YY,
     *   CCP(4), FKEY(2,2), ZZ
      DOUBLE PRECISION    OLD8(128), RA, DEC, XRA, XDEC, Z
      LOGICAL   T, F, BLNKD
      INCLUDE 'IM2CC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      EQUIVALENCE (CATOLD, OLD4, OLD8)
      EQUIVALENCE (I3, IPOS(1)), (I4, IPOS(2)), (I5, IPOS(3)),
     *   (I6, IPOS(4)), (I7, IPOS(5))
      DATA LUNI, LUNO /66,67/
      DATA T, F /.TRUE.,.FALSE./
      DATA KEYSUB /1,1,1,1/
      DATA FKEY /-1.0, 0.0, 1.0, 0.0/
      DATA KEY / 1, 0, 2, 0/
C-----------------------------------------------------------------------
C                                       panel loop
      JPAN = 0
      ZZ = 0.0
C                                       Open the data files
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, JPAN, 'OPEN INPUT IMAGE FILE'
         GO TO 990
         END IF
      NXI = CATOLD(KINAX)
      NYI = CATOLD(KINAX+1)
      ITYPE = 1
      DO 900 IYP = 1,NY
         DO 800 IXP = 1,NY
            JPAN = JPAN + 1
            WINI(1) = IBLC(1) + (IXP-1) * INX
            WINI(2) = IBLC(2) + (IYP-1) * INY
            WINI(3) = WINI(1) + INX - 1
            WINI(4) = WINI(2) + INY - 1
            IF (WINI(3).GT.ITRC(1)) WINI(3) = ITRC(1)
            IF (WINI(4).GT.ITRC(2)) WINI(4) = ITRC(2)
            NXO = WINI(3) - WINI(1) + 1
            NYO = WINI(4) - WINI(2) + 1
            NXX = NXO
            NYY = NYO
            IF (XIMSIZ(1).GT.NXX) NXX = XIMSIZ(1) + 0.1
            IF (XIMSIZ(2).GT.NYY) NYY = XIMSIZ(2) + 0.1
C                                       power 2 above that
            CALL POWER2 (NXX, JNX)
            IF (JNX.LT.NXX) JNX = JNX * 2
            CALL POWER2 (NYY, JNY)
            IF (JNY.LT.NYY) JNY = JNY * 2
            XOFF = (JNX - NXO) / 2
            XXTRA = JNX - NXO - XOFF
            YOFF = (JNY - NYO) / 2
            YXTRA = JNY - NYO - YOFF
C                                       output size
            CATBLK(KINAX) = JNX
            CATBLK(KINAX+1) = JNY
C                                       coordinate info re old img
            XPIX = WINI(1) + NXO/2 - 1
            YPIX = WINI(2) + NYO/2
            IF (CORTYP(LOCNUM).EQ.1) THEN
               CALL XYVAL (XPIX, YPIX, XRA, XDEC, Z, IRET)
               RA = CATD(KDCRV)
               DEC = CATD(KDCRV+1)
            ELSE IF (CORTYP(LOCNUM).EQ.2) THEN
               CALL XYVAL (XPIX, YPIX, XDEC, XRA, Z, IRET)
               RA = CATD(KDCRV+1)
               DEC = CATD(KDCRV)
               END IF
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, JPAN, 'FIND REF COORDINATE'
               GO TO 990
               END IF
            CATR(KRCRP) = OLD4(KRCRP) - WINI(1) + 1 + XOFF
            CATR(KRCRP+1) = OLD4(KRCRP+1) - WINI(2) + 1 + YOFF
            CATR(KRXSH) = XRA - RA
            CATR(KRYSH) = XDEC - DEC
C                                       create output image
            WRITE (CLAOUT,1010) JPAN
            CALL CHR2H (6, CLAOUT, KHIMCO, CATR(KHIMC))
            SEQOUT = IROUND (XSEQO)
            CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
            NEWCNO = 1
            CALL MCREAT (DISKO, NEWCNO, BUFF1, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, JPAN, 'CREATE OUTPUT IMAGE'
               GO TO 990
               END IF
            NCFILE = NCFILE + 1
            FVOL(NCFILE) = DISKO
            FCNO(NCFILE) = NEWCNO
            FRW(NCFILE) = 2
C                                       open output
            CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
            CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, T, T, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, JPAN, 'OPEN OUTPUT IMAGE'
               GO TO 990
               END IF
C                                       Setup for I/O
            WINO(1) = 1
            WINO(2) = 1
            WINO(3) = CATBLK(KINAX)
            WINO(4) = CATBLK(KINAX+1)
            OUTMAX = -1.0E20
            OUTMIN = 1.0E20
            BLNKD = F
C                                       Loop
            JPLAN = 0
            NCCM = 0
            NCCT = 0
            DO 700 I7 = IBLC(7),ITRC(7)
               CORN(5) = I7 - IBLC(7) + 1
               DO 600 I6 = IBLC(6),ITRC(6)
                  CORN(4) = I6 - IBLC(6) + 1
                  DO 500 I5 = IBLC(5),ITRC(5)
                     CORN(3) = I5 - IBLC(5) + 1
                     DO 400 I4 = IBLC(4),ITRC(4)
                        CORN(2) = I4 - IBLC(4) + 1
                        DO 300 I3 = IBLC(3),ITRC(3)
                           CORN(1) = I3 - IBLC(3) + 1
                           JPLAN = JPLAN + 1
C                                       Create CC table
                           NCOL = 3
                           CCLUN = 18
                           NCC = 0
                           CALL CCMINI ('WRIT', CCBUFF, DISKO, NEWCNO,
     *                        JPLAN, CATBLK, CCLUN, CCRNO, CCKOLS,
     *                        CCNUMV, NCOL, IRET)
                           IF (IRET.NE.0) THEN
                              WRITE (MSGTXT,1000) IRET, JPAN,
     *                           'CREATE CC TABLE'
                              GO TO 990
                              END IF
C                                       Init. files, first input.
                           CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX),
     *                        IPOS, BOTEMP, IRET)
                           BOI = BOTEMP + 1
                           CALL MINIT ('READ', LUNI, INDI, NXI, NYI,
     *                        WINI, BUFF1, JBUFSZ, BOI, IRET)
                           IF (IRET.NE.0) THEN
                              WRITE (MSGTXT,1000) IRET, JPAN,
     *                           'INIT READ INPUT IMAGE'
                              GO TO 990
                              END IF
C                                       Init output file.
                           CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX),
     *                        CORN, BOTEMP, IRET)
                           BOO = BOTEMP + 1
                           CALL MINIT ('WRIT', LUNO, INDO, JNX, JNY,
     *                        WINO, BUFF2, JBUFSZ, BOO, IRET)
                           IF (IRET.NE.0) THEN
                              WRITE (MSGTXT,1000) IRET, JPAN,
     *                           'INIT WRIT OUTPUT IMAGE'
                              GO TO 990
                              END IF
                           DO 200 I2 = 1,YOFF
                              CALL MDISK ('WRIT', LUNO, INDO, BUFF2,
     *                           OBIND, IRET)
                              IF (IRET.NE.0) THEN
                                 WRITE (MSGTXT,1000) IRET, JPAN,
     *                              'WRITE OUTPUT IMAGE'
                                 GO TO 990
                                 END IF
                              CALL RFILL (JNX, 0.0, BUFF2(OBIND))
 200                          CONTINUE
                           DO 220 I2 = WINI(2),WINI(4)
C                                       Read.
                              CALL MDISK ('READ', LUNI, INDI, BUFF1,
     *                           IBIND, IRET)
                              IF (IRET.NE.0) THEN
                                 WRITE (MSGTXT,1000) IRET, JPAN,
     *                              'READ INPUT IMAGE'
                                 GO TO 990
                                 END IF
                              CALL MDISK ('WRIT', LUNO, INDO, BUFF2,
     *                           OBIND, IRET)
                              IF (IRET.NE.0) THEN
                                 WRITE (MSGTXT,1000) IRET, JPAN,
     *                              'WRITE OUTPUT IMAGE'
                                 GO TO 990
                                 END IF
C                                       copy values
                              CALL RFILL (XOFF, 0.0, BUFF2(OBIND))
                              CALL RFILL (XXTRA, 0.0,
     *                           BUFF2(OBIND+JNX-XXTRA))
                              DO 210 I1 = 1,NXO
                                 VAL = BUFF1(IBIND+I1-1)
                                 BUFF2(OBIND+I1-1+XOFF) = VAL
                                 IF (VAL.NE.FBLANK) THEN
                                    OUTMAX = MAX (OUTMAX, VAL)
                                    OUTMIN = MIN (OUTMIN, VAL)
C                                       output a CC comp
                                    IF ((VAL.GT.FLUX) .AND.
     *                                 (ABS(VAL).GT.ICUT)) THEN
                                       VAL = VAL / BMAREA
                                       XX = (I1+WINI(1)-1-OLD4(KRCRP)) *
     *                                    OLD4(KRCIC)
                                       YY= (I2 - OLD4(KRCRP+1)) *
     *                                    OLD4(KRCIC+1)
                                       CALL TABCCM ('WRIT', CCBUFF,
     *                                    CCRNO, CCKOLS, CCNUMV, NCOL,
     *                                    XX, YY, ZZ, VAL, ITYPE, CCP,
     *                                    IRET)
                                       IF (IRET.NE.0) THEN
                                          WRITE (MSGTXT,1000) IRET,
     *                                       JPAN, 'WRITE CC TABLE'
                                          GO TO 990
                                          END IF
                                       NCC = NCC + 1
                                       END IF
                                 ELSE
                                    BLNKD = .TRUE.
                                    END IF
 210                             CONTINUE
 220                          CONTINUE
                           DO 230 I2 = 1,YXTRA
                              CALL MDISK ('WRIT', LUNO, INDO, BUFF2,
     *                           OBIND, IRET)
                              IF (IRET.NE.0) THEN
                                 WRITE (MSGTXT,1000) IRET, JPAN,
     *                              'WRITE OUTPUT IMAGE'
                                 GO TO 990
                                 END IF
                              CALL RFILL (JNX, 0.0, BUFF2(OBIND))
 230                          CONTINUE
C                                       Flush buffer.
                           CALL MDISK ('FINI', LUNO, INDO, BUFF2, OBIND,
     *                        IRET)
                           IF (IRET.NE.0) THEN
                              WRITE (MSGTXT,1000) IRET, JPAN,
     *                           'FINI WRITE OUTPUT IMAGE'
                              GO TO 990
                              END IF
C                                       close CC
                           CALL TABCCM ('CLOS', CCBUFF, CCRNO, CCKOLS,
     *                        CCNUMV, NCOL, XX, YY, ZZ, VAL, ITYPE, CCP,
     *                        IRET)
                           IF (IRET.NE.0) THEN
                              WRITE (MSGTXT,1000) IRET, JPAN,
     *                           'CLOSE CC TABLE'
                              GO TO 990
                              END IF
                           NCCM = MAX (NCCM, NCC)
                           NCCT = NCCT + NCC
 300                       CONTINUE
 400                    CONTINUE
 500                 CONTINUE
 600              CONTINUE
 700           CONTINUE
C                                       close output map
            CALL ZCLOSE (LUNO, INDO, IRET)
C                                       did we do anything?
            IF (NCCT.GT.0) THEN
C                                       Update CATBLK.
               CATR(KRBLK) = 0.0
               IF (BLNKD) CATR(KRBLK) = FBLANK
               CATR(KRDMX) = OUTMAX
               CATR(KRDMN) = OUTMIN
               CATBLK(KINIT) = NCCM
C                                       history
               CALL IM2CCH (NCCM, NCCT)
C                                       sort
               VER = 1
               CALL TABSRT (DISKO, NEWCNO, 'CC', VER, VER, KEY, KEYSUB,
     *            FKEY, CCBUFF, CATBLK, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, JPAN, 'SORT THE CC TABLE'
                  GO TO 990
                  END IF
C                                       update catalog
               CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'CLWR', BUFF1,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, JPAN,
     *               'UPDATE CATALOG HEADER'
                  GO TO 990
                  END IF
               NCFILE = NCFILE - 1
C                                       destroy the file
            ELSE
C                                       update catalog
               CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'CLWR', BUFF1,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, JPAN,
     *               'UPDATE CATALOG HEADER'
                  GO TO 990
                  END IF
               NCFILE = NCFILE - 1
C                                       now destroy
               CALL MDESTR (DISKO, NEWCNO, CATBLK, BUFF1, I, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, JPAN,
     *               'DESTROY EMPTY OUTPUT FACET'
                  GO TO 990
                  END IF
               JPAN = JPAN - 1
               END IF
 800        CONTINUE
 900     CONTINUE
      CALL ZCLOSE (LUNI, INDI, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('IM2CCD: ERROR',I3,' PANEL',I3,' ON ',A)
 1010 FORMAT ('IMC',I3.3)
      END
      SUBROUTINE IM2CCH (NCCM, NCCT)
C-----------------------------------------------------------------------
C   AHEHIS copies and updates history file.
C-----------------------------------------------------------------------
      INTEGER   NCCM, NCCT
C
      CHARACTER LINE*80, NOTTYP*2
      INTEGER   LUN1, LUN2, IERR
      LOGICAL   T
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'IM2CC.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NOTTYP /'CC'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       BLC
      WRITE (LINE,2000) TSKNAM, IBLC
      CALL HIADD (LUN2, LINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       TRC
      WRITE (LINE,2001) TSKNAM, ITRC
      CALL HIADD (LUN2, LINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       abs value cutoff
      WRITE (LINE,2002) TSKNAM, ICUT
      CALL HIADD (LUN2, LINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       cutoff
      WRITE (LINE,2003) TSKNAM, FLUX
      CALL HIADD (LUN2, LINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       panel numbers
      WRITE (LINE,2004) TSKNAM, NX, NY
      CALL HIADD (LUN2, LINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       CCs written
      IF (NCCT.GT.NCCM) THEN
         WRITE (LINE,2005) TSKNAM, NCCM
         CALL HIADD (LUN2, LINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       Total CCs written
      WRITE (LINE,2006) TSKNAM, NCCT
      CALL HIADD (LUN2, LINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (1, NOTTYP, LUN1, LUN2, DISKIN, DISKO, OLDCNO,
     *   NEWCNO, CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('im2cch: ERROR',I3,' COPY/OPEN HISTORY FILE')
 2000 FORMAT (A6,'BLC =',6(I6,','),I6)
 2001 FORMAT (A6,'TRC =',6(I6,','),I6)
 2002 FORMAT (A6,'ICUT=',F10.4,'  / abs(pixel) > ICUT to include')
 2003 FORMAT (A6,'FLUX=',F10.4,'  / pixel value > FLUX to include')
 2004 FORMAT (A6,'NX=',I3,' NY=',I3,'  / number panels in X and Y')
 2005 FORMAT (A6,'NCCMAX=',I12,'  / max number CCs in any table')
 2006 FORMAT (A6,'NCCTOT=',I12,'  / total number CCs in all tables')
      END

      SUBROUTINE GETSYM (LBUFF, NPNT, SYM, IERR)
C-----------------------------------------------------------------------
C! returns next symbol in character-form card image
C# Parsing FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   GETSYM scrutinizes a card image to look for the next symbol.  A
C   symbol begins with a letter and contains up to eight alpha-numeric
C   characters (A-Z,0-9,_).  This routine is used for interpreting a
C   FITS tape and for interpreting the HI files.
C   Inputs:
C      LBUFF  C*80  Loose packed card image
C      NPNT   I     Pointer to first character
C   Output:
C      NPNT   I     Pointer value after getting symbol
C      SYM    C*8   Symbol, padded with blanks
C      IERR   I     Return code
C                      0--> Found legal symbol followed by '='
C                      1--> Ran off the end of the card
C                      2--> Symbol had >8 characters
C                      3--> Found legal symbol with no '='
C                           or SYM is HISTORY or COMMENT
C                      4--> Found a '/' symbol
C                      5--> Symbol contains an illegar char
C-----------------------------------------------------------------------
      CHARACTER LBUFF*80, SYM*8
      INTEGER   NPNT, IERR
C
      CHARACTER LCH*1, TSYM*8
      INTEGER   LPNT, LIMIT, IC, NKAR
      DATA LIMIT /80/
C-----------------------------------------------------------------------
C                                      Initialization
      NKAR = 0
      IERR = 0
      SYM = ' '
C                                       Check card limit
 10   IF (NPNT.GT.LIMIT) GO TO 980
C                                       Skip leading blanks
         LCH = LBUFF(NPNT:NPNT)
         IF (LCH.NE.' ') GO TO 20
            NPNT = NPNT + 1
            GO TO 10
C                                       Is the first character legal?
 20   IC = ICHAR(LCH)
      IF ((IC.GE.ICHAR('A')) .AND. (IC.LE.ICHAR('Z'))) GO TO 40
C                                       If we find a '/', good bye
         IF (LCH.EQ.'/') GO TO 940
C                                       Not legal.  Skip to next blank
 30      NPNT = NPNT + 1
         IF (NPNT.GT.LIMIT) GO TO 980
            LCH = LBUFF(NPNT:NPNT)
            IF (LCH.NE.' ') GO TO 30
C                                       Found another blank. begin
C                                       searching again
         NPNT = NPNT + 1
         GO TO 10
C                                       Find rest of symbol
 40   LPNT = NPNT
 50   NKAR = NKAR + 1
      IF (NKAR.LE.8) TSYM(NKAR:NKAR) = LCH
         NPNT = NPNT + 1
         IF (NPNT.GT.LIMIT) GO TO 980
         LCH = LBUFF(NPNT:NPNT)
         IC = ICHAR(LCH)
C                                       Is the character legal?
         IF ((IC.GE.ICHAR('A')) .AND. (IC.LE.ICHAR('Z'))) GO TO 50
         IF ((IC.GE.ICHAR('0')) .AND. (IC.LE.ICHAR('9'))) GO TO 50
         IF (LCH.EQ.'_') GO TO 50
         IF (LCH.EQ.'-') GO TO 50
C                                       Have we hit a ' ' or
C                                          a '='?
      IF (LCH.EQ.'=') GO TO 70
      IF (LCH.EQ.' ') GO TO 65
C                                       Illegal char.  Look for
C                                          the next space.
 62   NPNT = NPNT + 1
      IF (NPNT.GT.LIMIT) GO TO 980
      IF (LBUFF(NPNT:NPNT).NE.' ') GO TO 62
      GO TO 930
C                                       Look for an '='
C                                         or an end of card
 65   NPNT = NPNT + 1
      IF (NPNT.GT.LIMIT) GO TO 67
      IF (LBUFF(NPNT:NPNT).EQ.' ') GO TO 65
      IF (LBUFF(NPNT:NPNT).EQ.'=') GO TO 70
C                                       Legal symbol with no '='
 67   IERR = 3
      NPNT = NPNT - 2
C                                      Legal symbol with an '='
 70   NPNT = NPNT + 1
      IF (NKAR.GT.8) GO TO 970
C                                       Pack symbol
      SYM = TSYM(1:NKAR)
      IF (IERR.NE.0) GO TO 999
C                                       Check for HISTORY =, etc.
      IERR = 3
      IF (SYM.EQ.'HISTORY ') GO TO 999
      IF (SYM.EQ.'COMMENT ') GO TO 999
      IERR = 0
      GO TO 999
C
C-----------------------------------------------------------------------
C
C                                       Symbol contains illegal char
 930  IERR = 5
      GO TO 999
C                                       Found a '/' symbol
 940  IERR = 4
      NPNT = NPNT + 1
      GO TO 999
C                                       Symbol has more than 8 char
 970  IERR = 2
      GO TO 999
C                                       Ran out of card
 980  IERR = 1
C
 999  RETURN
      END

      SUBROUTINE ISLAND (NPKMAX, NX, NY, IMAGE, CUTT, PKWIN, NPK)
C-----------------------------------------------------------------------
C! finds connect regions of emmision (adapted from SAD)
C# Map Modeling Imaging
C-----------------------------------------------------------------------
C;  Copyright (C) 2009, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Find points in the residual map whose values are greater than CUTT.
C   All such points which touch each other, either along grid lines or
C   diagonals, are considered to be one "island".  Give each distinct
C   island its own number and compute a rectangular window that just
C   contains that island.
C   Inputs
C      NPKMAX   I      Maximum allowed number of islands
C      NX       I      X dimension
C      NY       I      Y dimension
C      IMAGE    R(*,*) image itself
C   Outputs:
C      PKWIN    R(4,NPKMAX)   A list of minX,minY,maxX,maxY window
C                      corners for islands
C      NPK      I      Number of islands found
C   Routines adapted from SAD which retains its own versions of them
C-----------------------------------------------------------------------
      INTEGER   NPKMAX, NX, NY, PKWIN(4,*), NPK
      REAL      CUTT, IMAGE(NX,NY)
C
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   OLD(MAXIMG), NEW(MAXIMG), I, J, LOCWIN(4)
      LOGICAL   DIAG
      SAVE OLD, NEW
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      NPK = 0
      LOCWIN(1) = 1
      LOCWIN(2) = 1
      LOCWIN(3) = NX
      LOCWIN(4) = NY
      DIAG = NPKMAX.GT.0
C                                       Initialize previous ine
      CALL FILL (NX, 0, OLD)
C
      DO 200 J = 1,NY
         DO 100 I = 1,NX
C                                       Is point above cutoff?
            IF ((IMAGE(I,J).EQ.FBLANK) .OR. (IMAGE(I,J).LT.CUTT)) THEN
               NEW(I) = 0
C                                       Are any adjacent points, on
C                                       currnt Line or previous line
C                                       already marked?
            ELSE IF ((I.GT.1) .AND. (NEW(I-1).GT.0)) THEN
               NEW(I) = NEW(I-1)
C                                       link to previous now?
               IF ((DIAG) .AND. (I.LT.NX) .AND. (OLD(I+1).GT.0))
     *            CALL MERGPK (NEW(I), OLD(I+1), LOCWIN, NPK, PKWIN,
     *            OLD, NEW)
            ELSE IF ((DIAG) .AND. (I.GT.1) .AND. (OLD(I-1).NE.0)) THEN
               NEW(I) = OLD(I-1)
C                                       Is this A link between two
C                                       previous distinct islands?
               IF ((I.LT.NX) .AND. (OLD(I+1).GT.0)) CALL MERGPK (NEW(I),
     *            OLD(I+1), LOCWIN, NPK, PKWIN, OLD, NEW)
            ELSE IF (OLD(I).NE.0) THEN
               NEW(I) = OLD(I)
            ELSE IF ((DIAG) .AND. (I.LT.NX) .AND. (OLD(I+1).NE.0)) THEN
               NEW(I) = OLD(I+1)
C                                       Totally new island
C                                       skip ADDPK
            ELSE IF (NPK.LT.ABS(NPKMAX)) THEN
               NEW(I) = NPK + 1
               NPK  = NEW(I)
               PKWIN(1,NPK) = I
               PKWIN(2,NPK) = J
               PKWIN(3,NPK) = I
               PKWIN(4,NPK) = J
               GO TO 100
            ELSE
               NEW(I) = 0
               END IF
C                                       New addition to old island
            IF (NEW(I).NE.0) CALL ADDPK (PKWIN, I, J, NEW(I))
 100        CONTINUE
C                                       Get ready for next line.
         CALL COPY (NX, NEW(LOCWIN(1)), OLD(LOCWIN(1)))
 200     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE ADDPK (PKWIN, I, J, IPK)
C-----------------------------------------------------------------------
C   Add a single point with coordinates I,J to an existing island by
C   adjusting the boundaries of the Island
C-----------------------------------------------------------------------
      INTEGER PKWIN(4,*), I, J, IPK
C-----------------------------------------------------------------------
      PKWIN(1,IPK) = MIN (PKWIN(1,IPK), I)
      PKWIN(3,IPK) = MAX (PKWIN(3,IPK), I)
      PKWIN(4,IPK) = J
C
 999  RETURN
      END
      SUBROUTINE MERGPK (IPK, JPK, WIN, NPK, PKWIN, OLD, NEW)
C-----------------------------------------------------------------------
C   Merge two Islands together by finding max boundaries
C   Inputs:
C      IPK     I        first island number
C      JPK     I        second island number
C      WIN     I(4)     full blc,trc window
C   In/Out:
C      NPK     I        Maximum island number - reduced if = higher
C      PKWIN   I(4,*)   windows for islands - higher set to zero
C      OLD     I(*)     window number for previous row - higher set to
C                       lower
C      NEW     I(*)     window number for current row - higher set to
C                       lower
C-----------------------------------------------------------------------
      INTEGER   IPK, JPK, WIN(4), NPK, PKWIN(4,*), OLD(*), NEW(*)
C
      INTEGER   I, IL, IH
C-----------------------------------------------------------------------
      IF (IPK.NE.JPK) THEN
         IL = MIN (IPK, JPK)
         IH = MAX (IPK, JPK)
C                                       get extrema in lower # island
         PKWIN(1,IL) = MIN (PKWIN(1,IPK), PKWIN(1,JPK))
         PKWIN(2,IL) = MIN (PKWIN(2,IPK), PKWIN(2,JPK))
         PKWIN(3,IL) = MAX (PKWIN(3,IPK), PKWIN(3,JPK))
         PKWIN(4,IL) = MAX (PKWIN(4,IPK), PKWIN(4,JPK))
C                                       null upper number island
         PKWIN(1,IH) = 0
         PKWIN(2,IH) = 0
         PKWIN(3,IH) = 0
         PKWIN(4,IH) = 0
C                                       drop upper island
         IF (NPK.EQ.IH) NPK = NPK - 1
         DO 20 I = WIN(1),WIN(3)
            IF (OLD(I).EQ.IH) OLD(I) = IL
            IF (NEW(I).EQ.IH) NEW(I) = IL
 20         CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE COORDD (N, RAD, CHM, HM, SEC)
C-----------------------------------------------------------------------
C! converts angles between degrees and sexagesimal format
C# Utility Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   COORDD Converts RA and DEC to and from degrees under control of N.
C   Inputs:
C      N    I        OPcode: 1 degrees to RA
C                            2 degrees to DEC
C                            3 RA to degrees
C                            4 DEC to degrees
C   In/out:
C      RAD  D        The angle in degrees
C      CHM  C*1      The sign of the sexagesimal number (or a digit
C                    for hundreds or days
C      HM   I(2)     The angle in RA/dec as
C                    HM(1)   Hours or Degrees
C                    HM(2)   Minutes of time or arc
C      SEC  R    The rest of the Ra/dec : seconds of time or arc
C-----------------------------------------------------------------------
      CHARACTER CHM*1
      INTEGER   HM(2), N
      REAL      SEC
      DOUBLE PRECISION  RAD
C
      CHARACTER LOCHAR(10)*1
      INTEGER   I
      DOUBLE PRECISION  TEMP, CON, F15, F60
      INCLUDE 'INCS:DMSG.INC'
      DATA LOCHAR /'1','2','3','4','5','6','7','8','9','*'/
C-----------------------------------------------------------------------
C                                       Error in N
      IF ((N.LT.1) .OR. (N.GT.4)) GO TO 900
      F15 = 15.0D0
      F60 = 60.0D0
      CON = 3600.D0
C                                       From degrees
      IF (N.GT.2) GO TO 50
         TEMP = RAD
         IF ((N.EQ.1) .AND. (TEMP.LT.0.0D0)) TEMP = TEMP + 360.0D0
         IF ((N.EQ.2) .AND. (TEMP.LT.-90.0D0)) TEMP = TEMP + 360.0D0
         CHM = ' '
         IF (N.EQ.1) TEMP = TEMP / F15
C                                       Check on sign
         IF (TEMP.GE.0.0D0) GO TO 10
            TEMP = -TEMP
            CHM = '-'
            GO TO 20
C                                       longitude leading digits
 10      IF (N.EQ.1) GO TO 15
            I = TEMP / 100.0D0
            IF (I.LE.0) GO TO 20
               IF (I.LE.9) CHM = LOCHAR(I)
               IF (I.GE.10) CHM = LOCHAR(10)
               TEMP = TEMP - 100.0D0 * I
               GO TO 20
C                                       RA: days part
 15      CONTINUE
            I = TEMP / 24.0D0
            IF (I.LE.0) GO TO 20
               IF (I.LE.9) CHM = LOCHAR(I)
               IF (I.GE.10) CHM = LOCHAR(10)
               TEMP = TEMP - 24.0D0 * I
C                                       Separate into h m s
 20      TEMP = TEMP * CON
         HM(1) = TEMP / CON
         TEMP = TEMP - HM(1) * CON
         HM(2) = TEMP / F60
         SEC = TEMP - HM(2) * F60
         GO TO 999
C                                       Convert to degrees
 50   CONTINUE
         TEMP = F60 * (F60 * HM(1) + HM(2)) + SEC
         IF (N.EQ.3) TEMP = TEMP * F15
         IF (CHM.EQ.'-') TEMP = -TEMP
         RAD = TEMP / CON
         IF ((CHM.EQ.' ') .OR. (CHM.EQ.'-')) GO TO 999
            DO 55 I = 1,9
               IF (CHM.EQ.LOCHAR(I)) GO TO 60
 55            CONTINUE
            I = 0
 60         IF (N.EQ.2) RAD = RAD + I * 24.0D0
            IF (N.EQ.4) RAD = RAD + I * 100.0D0
            GO TO 999
C                                       Error return
 900  WRITE (MSGTXT,1900) N
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('COORDD: IMPROPER CONTROL PARAMETER. N= ',I4)
      END

      SUBROUTINE APLOAD (APCORE, USTRT, USTOP, UZERO, ROWSIZ, LOGRID,
     *   APSIZE, FLIST, BUFFER, IRET)
C-----------------------------------------------------------------------
C! AP routine: Load AP with Grid file from disk
C# AP-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C AP LOAD: Loads the AP with rows of GRIDDED UV data
C   Inputs:
C      USTRT   I    Start U row to load
C      USTOP   I    Stop  U row to load
C      UZERO   I    Row number of minimum row in AP to be processed
C                   (Often Location of row U=0 in AP)
C      ROWSIZ  I    Length of a Row in AP, number of reals
C      LOGRID  I    Index of start of rows in AP (0 relative)
C      APSIZE  I    Size of AP in REALs
C      FLIST   I(*) File description array
C   Outputs:
C      BUFFER  R(*) Scratch Buffer containing
C      IRET    I    return code, O=OK else APIO return code
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   USTRT, USTOP, UZERO, ROWSIZ, LOGRID, APSIZE, FLIST(*),
     *          IRET
      REAL BUFFER(*)
C
      INTEGER IU, U, EROW
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (UZERO.GT.USTRT) THEN
         IRET = UZERO*1000 + USTRT
         WRITE (MSGTXT,1000,ERR=999) USTRT, UZERO
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       wait for AP to FINISH
      CALL QWAIT
C                                       load previous values in AP
      DO 100 IU = USTRT, USTOP
C                                       convert to decreasing U
         U = USTOP - IU + USTRT
C                                       load AP from top down
         EROW = LOGRID + ((U-UZERO)*ROWSIZ)
C                                       keep output below AP top
         EROW = MIN( EROW, APSIZE-ROWSIZ-1)
C                                       Copy row to AP
         CALL APIO (APCORE, 'READ', FLIST, EROW, BUFFER, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1070,ERR=999) IRET
            CALL MSGWRT (8)
            WRITE (MSGTXT,1080,ERR=999) USTRT, U, USTOP
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       wait for AP to FINISH
         CALL QWAIT
 100     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('APLOAD: ERROR! AP START,',I6,', BEFORE ZERO',I6)
 1070 FORMAT ('APLOAD: ERROR=',I5,' READING GRID FILE')
 1080 FORMAT ('APLOAD: USTRT=',I5,', U=',I5,', USTOP=',I5)
      END

      SUBROUTINE ZMOUN2 (MOUNT, IDRIVE, IDENS, NTAPED, NPOPS, NUSER,
     *   MSG, SYSERR, IERR)
C-----------------------------------------------------------------------
C! mount or dismount magnetic tape device
C# Z2 Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Issue software mount or dismount for a given tape drive - the lowest
C   level Z routine called by ZMOUNT.
C   Inputs:
C      MOUNT    I      Operation: 1 => mount, 0 => dismount
C      IDRIVE   I      Drive number
C      IDENS    I      Density
C      NTAPED   I      Number of tape drives
C      NPOPS    I      Pops number
C      NUSER    I      User AIPS number
C   Output:
C      MSG      C*80   Error message buffer
C      SYSERR   I      System error code (for ZERROR call)
C      IERR     I      Error return code: 0 => no error
C                        1 => error
C   Mac version - stubbed pending a tape drive to test it
C-----------------------------------------------------------------------
      INTEGER   MOUNT, IDRIVE, IDENS, NTAPED, NPOPS, SYSERR, IERR,
     *            NUSER
      CHARACTER MSG*80
C-----------------------------------------------------------------------
      IERR = 8
      MSG = 'ZMOUN2: STUBBED PENDING LATER DEVELOPMENT'
      SYSERR = 0
C
 999  RETURN
      END

      SUBROUTINE ATFPNT (X0, LII, BII, X, Y)
C-----------------------------------------------------------------------
C! Routine to calculate X-Y coords from galactic coords
C# Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Routine to calculate X-Y coords from galactic coords
C    Inputs:
C     XO        R       Semi-major axis
C     LII       R       Longitude
C     BII       R       Latitude
C    Outputs:
C     X         R       X position from centre of plot
C     Y         R       Y position from centre
C-----------------------------------------------------------------------
      REAL TETA, PHI, X, Y, X0
      REAL LII, BII
C-----------------------------------------------------------------------
C
      PHI = BII*0.01745329
      IF (LII .GT. 180.) LII = LII-360.
      TETA = LII*0.01745329
      X = -X0*COS(PHI)*SIN(TETA/2.)/(SQRT(1.+COS(PHI)*COS(TETA/2.)))
      Y = X0/2.*SIN(PHI)/(SQRT(1.+COS(PHI)*COS(TETA/2.)))
C
 999  RETURN
      END

      SUBROUTINE QINTP (APCORE, UV, VIS, PHAS, GRID, INTP, M, LROW, INC,
     *   NVIS)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Interpolates model visibilities from a grid.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FORTRAN version of FPS Array processor microcode.
C   QINTP Interpolates model visibilities from a grid,
C   corrects the phase and subtracts from the observations.
C   Assumes that the observations are never within M/2
C   of the outside edge of the grid.
C   Inputs:
C      UV    I  Base address of (u,v) values in cells.
C      VIS   I  Base address of (complex) visibilities.
C      PHAS  I  Base address of phase correction, complex value
C               to be multiplied by model vis.
C      GRID  I  Base address of gridded model vis. Order assumed to
C               be the following  for each of the M rows:
C                              1) 2 * LROW visibilities
C      INTP  I  Base address of interpolation function.
C      M     I  Number of rows kept in the AP.  Also support size of
C               interp. fn.
C      LROW  I  Length of a row.
C      INC   I  Increment for UV,VIS and PHAS
C      NVIS  I  Number of visibility points to grid.
C   All AP memory values are assumed floating.
C   It is assumed that all values of v correspond to row M/2.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   UV, VIS, PHAS, GRID, INTP, M, LROW, INC, NVIS
C
      LONGINT   JUV, JVIS, JPHAS, JGRID, JINTP, JCX, JCY, JG, JJCX
      INTEGER   INCR, HAF, IRND, IX, IY, JNO2, JN, JJLOOP
      DOUBLE PRECISION X, XX, Y, SUMRE, SUMIM, REMOD, IMMOD, SUMR, SUMI
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IRND(XX) = INT (XX + SIGN (0.5D0, XX))
C-----------------------------------------------------------------------
C                                       Convert addresses to 1 rel.
      JUV = UV + PSAPOF
      JVIS = VIS + PSAPOF
      JPHAS = PHAS + PSAPOF
      JGRID = GRID + PSAPOF
      JINTP = INTP + PSAPOF
      JNO2 = M / 2
      JN = M
      HAF = LROW / 2 - JNO2
      INCR = 2 * LROW - 2 * JN
C                                        Loop over visibilities.
      INCLUDE 'INCS:ZVND.INC'
      DO 300 JJLOOP = 1,NVIS
C                                        Determine location.
         X = APCORE(JUV+1)
         Y = APCORE(JUV)
C                                        Deter. interp. fn loc.
         JCX = IRND (200.D0 * (IRND (X) - X - 0.5D0))
         JCY = IRND (200.D0 * (IRND (Y) - Y - 0.5D0))
         JCX = JCX + JINTP + 200
         JCY = JCY + JINTP + 200
C                                        Determine grid loc.
         JG = 2 * (IRND (X) + HAF)
         JG = JG + JGRID
C                                        Save JCX
         JJCX = JCX
C                                        Init. sums.
         SUMRE = 0.0
         SUMIM = 0.0
C                                        Interpolation loop
      INCLUDE 'INCS:ZVND.INC'
         DO 200 IY = 1,M
            JCX = JJCX
            SUMR = 0.0D0
            SUMI = 0.0D0
      INCLUDE 'INCS:ZVND.INC'
            DO 100 IX = 1,JN
C                                        Interpolate.
               SUMR = SUMR + APCORE(JG) * APCORE(JCX)
               SUMI = SUMI + APCORE(JG+1) * APCORE(JCX)
C                                        Update pointers.
               JCX = JCX + 200
               JG = JG + 2
 100           CONTINUE
C                                       Update sums
            SUMRE = SUMRE + SUMR * APCORE(JCY)
            SUMIM = SUMIM + SUMI * APCORE(JCY)
C                                        Update pointers.
            JCY = JCY + 200
            JG = JG + INCR
 200        CONTINUE
C                                        Correct phase.
         REMOD = APCORE(JPHAS) * SUMRE - APCORE(JPHAS+1) * SUMIM
         IMMOD = APCORE(JPHAS) * SUMIM + APCORE(JPHAS+1) * SUMRE
C                                        Subtract from data
         APCORE(JVIS) = APCORE(JVIS) - REMOD
         APCORE(JVIS+1) = APCORE(JVIS+1) - IMMOD
C                                       Update for next vis.
         JUV = JUV + INC
         JVIS = JVIS + INC
         JPHAS = JPHAS + INC
 300     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE FINDIT (LUN, FIND, IREC, JREC, JBUFSZ, BUFF1, ITIME,
     *   IRET)
C-----------------------------------------------------------------------
C! Tries to find integration time in a uv data set
C# UV
C-----------------------------------------------------------------------
C;  Copyright (C) 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Find integration time in open uv data set
C   Inputs:
C      LUN      I      LUN open data set
C      FIND     I      FTAB pointer open data set
C      IREC     I      Initial data record
C      JREC     I      Last data record
C      JBUFSZ   I      size of buffer in AIPS bytes
C   Outputs:
C      BUFF1    R(*)   I/O buffer
C      ITIME    R      integration time in seconds
C      IRET     I      Error code
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IREC, JREC, JBUFSZ, IRET
      REAL      BUFF1(*), ITIME
C
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INTEGER   I, ILENBU, VO, MVIS, BO, CREC, IN, NDIFF, JTIME, LTIME,
     *   TDIFF, CNT(10000), IP(4), IM(4), IBIND, INIO, NDBG, M
      CHARACTER SORT*2
      REAL      TEST, MULT, SN, SX
      DOUBLE PRECISION S, SS, NS
      DATA VO, BO /0, 1/
      DATA MULT /864000./
C-----------------------------------------------------------------------
C                                       can we do this?
      ITIME = 0.0
      IF (ILOCIT.LT.0) THEN
         CALL H2CHR (2, 1, CATH(KITYP), SORT)
         IF ((SORT(:1).NE.'T') .AND. (SORT(2:).NE.'T')) THEN
            IRET = 10
            MSGTXT = 'DATA SET LACKS INTTIME, NOT IN TIME ORDER'
            GO TO 980
            END IF
         END IF
C                                       init the I/O
      ILENBU = 0
      VO = MAX (0, IREC-1)
      MVIS = JREC - IREC + 1
      CALL UVINIT ('READ', LUN, FIND, MVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT IO FROM INPUT DATA SET'
         GO TO 980
         END IF
      CREC = IREC
      NDIFF = 0
      LTIME = -1000.0
      TDIFF = 1000000
      CALL FILL (10000, 0, CNT)
      NDBG = 0
      NS = 0.0D0
      S = 0.0D0
      SS = 0.0D0
      SN = 1.E10
      SX = -SN
      M = 0
 20   CALL UVDISK ('READ', LUN, FIND, BUFF1, INIO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ INPUT DATA SET'
         GO TO 980
         END IF
      DO 100 IN = 1,INIO
C                                       easy check
         IF (ILOCIT.GE.0) THEN
            IF (ITIME.LE.0.0) ITIME = BUFF1(IBIND+ILOCIT)
            TEST = BUFF1(IBIND+ILOCIT)
            IF (ABS(TEST-ITIME).GT.0.05) NDIFF = NDIFF + 1
            M = M + 1
            S = S + TEST
            SS = SS + TEST*TEST
            NS = NS + 1.0D0
            SN = MIN (TEST, SN)
            SX = MAX (TEST, SX)
         ELSE
            JTIME = MULT * BUFF1(IBIND+ILOCT) + 0.5
            IF (LTIME.LT.0) LTIME = JTIME
            I = JTIME - LTIME
            IF ((I.LT.10000) .AND. (I.GT.0)) THEN
               CNT(I) = CNT(I) + 1
               NDBG = NDBG + 1
c               dbg(1,ndbg) = i
c               dbg(2,ndbg) = crec
               END IF
            LTIME = JTIME
            END IF
         IBIND = IBIND + LREC
         CREC = CREC + 1
 100     CONTINUE
      IF (CREC.LT.JREC) GO TO 20
C                                       analyze, report
      IF (ILOCIT.GE.0) THEN
         WRITE (MSGTXT,1100) ITIME
         CALL MSGWRT (5)
         WRITE (MSGTXT,1101) NDIFF, M
         CALL REFRMT (MSGTXT, '_', I)
         CALL MSGWRT (5)
         IF (NDIFF.GT.0) THEN
            S = S / NS
            SS = SS/NS - S * S
            IF (SS.GT.0.0D0) SS = SQRT (SS)
            WRITE (MSGTXT,1102) S, SS
            CALL MSGWRT (5)
            WRITE (MSGTXT,1103) SN, SX
            CALL MSGWRT (5)
            END IF
      ELSE
         CALL FILL (4, 0, IP)
         CALL FILL (4, 0, IM)
         DO 120 I = 1,10000
            IF (CNT(I).GT.IM(1)) THEN
               IM(4) = IM(3)
               IP(4) = IP(3)
               IM(3) = IM(2)
               IP(3) = IP(2)
               IM(2) = IM(1)
               IP(2) = IP(1)
               IP(1) = I
               IM(1) = CNT(I)
            ELSE IF (CNT(I).GT.IM(2)) THEN
               IM(4) = IM(3)
               IP(4) = IP(3)
               IM(3) = IM(2)
               IP(3) = IP(2)
               IP(2) = I
               IM(2) = CNT(I)
            ELSE IF (CNT(I).GT.IM(3)) THEN
               IM(4) = IM(3)
               IP(4) = IP(3)
               IM(3) = CNT(I)
               IP(3) = I
            ELSE IF (CNT(I).GT.IM(4)) THEN
               IM(4) = CNT(I)
               IP(4) = I
               END IF
 120        CONTINUE
         ITIME = IP(1) / 10.0
         WRITE (MSGTXT,1120) ITIME
         CALL MSGWRT (5)
         WRITE (MSGTXT,1121) IM, IP
         CALL REFRMT (MSGTXT, '_', I)
         CALL MSGWRT (5)
         WRITE (MSGTXT,1122) NDBG
         CALL MSGWRT (5)
         END IF
      GO TO 999
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FINDIT ERROR',I4,' ON ',A)
 1100 FORMAT ('FINDIT: INTTIM parameter yields',F7.2,' seconds')
 1101 FORMAT (I10,' of_',I10,' samples disagreed')
 1102 FORMAT ('MEAN INTTIM',F7.2,' +-',F7.2)
 1103 FORMAT ('MIN INTTIM',F7.2,' MAX',F7.2)
 1120 FORMAT ('FINDIT time samples yield',F7.1,' seconds int time')
 1121 FORMAT ('Peaks',4('_',I7),' at',4I5)
 1122 FORMAT ('Total number of intervals',I8)
      END

      SUBROUTINE GR3DUV (APCORE, IFIELD, DISKI, CNOSCI, SCROUT, CATUVR,
     *   JBUFSZ, FREQID, BUFF1, BUFF2, IRET)
C-----------------------------------------------------------------------
C! Grids uv data to be FFTed, allows partial mis-sort after reprojection
C# AP-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 1999-2000, 2006-2009, 2017, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GR3DUV convolves uv data onto a grid using AP routines.  It differs
C   from older gridding subroutines in that it expects the data to be
c   only roughly sorted (after re-projecting uvw to the current field)
C   rather than exactly sorted as assumed by the older routines.  (Sort
C   is irrelevant if the grid fits in the AP of course.)
C   The visibilities are convolved onto the grid using the convolving
C   function specified by CTYPX,CTYPY,XPARM,YPARM.  The defaults for
C   these values must be filled in by a call to GRDFLT.
C   The gridded data is phase rotated so that the map center comes out
C   at location ICNTRX,ICNTRY.  If requested, a uv taper is applied to
C   the visibility weights before gridding.  If necessary, a three
C   dimension phase reference position shift is done in AP1GRD.
C   If multiple channels are to be gridded together, GR3DUV loops
C   over the frequency channels in an inner loop, reading the grid only
C   onces and the uv data only a couple of times at most.  For bandwidth
C   synthesis the SCROUT file should be big enough for an extra m rows,
C   where m is the half width of the X convolving function.
C      This version uses a scrolling buffer as large as possible using
C   both the primary and secondary AP memory; 1/4 of the memory is used
C   as the uv data buffer when possible.
C      Zero spacing flux densities are gridded if provided.
C   Uses AIPS LUNs 18, 20
C   Input uv data file in UV file CNOSCI.
C   Output grid file in image file SCROUT.
C   Inputs:
C      IFIELD      I     Field number to grid, if 0 then grid a beam.
C      DISKI       I     Input file disk number for catalogd files,
C                        .LE. 0 => /CFILES/ scratch file.
C      CNOSCI      I     Input file catalog slot number or /CFILES/
C                        scratch file number.
C      SCROUT      I     /CFILES/ scratch file number of output file
C      CATUVR(256) R     UV data catalog header record.
C      JBUFSZ      I     Size in bytes of buffers. Dimension of
C                        BUFF1,2,3  must be at least 4096 words
C      FREQID      I     Id number of FQ entry, if it exists.
C   From commons: (Includes DGDS, DMPR, DUVH, CGDS, CMPR, CUVH)
C      NVIS         I    Number of visibility records (/UVHDR/)
C      LREC         I    Number of (real) words per visibility record
C                        (/UVHDR/)
C      NCHAVG       I    Number of frequency channels to grid together.
C      FLDSZ(2,*)   I    Dimension of map in RA, Dec (cells)
C      CELLSG(2)    R    The cell spacing in X and Y in arcseconds.
C      DO3DIM       L    Do 3d rotation of uvw's as well as phases.
C      CHUV1        I    First channel number in file to grid
C                        (1 relative)
C      FREQ         D    Reference frequency (Hz) (/UVHDR/)
C      JLOCF        I    0 relative number of the frequency axis,
C                        (/UVHDR/)
C      TFLUXG       R    The total flux density removed from the data,
C                        this will be subtracted from the zero spacing
C                        flux before gridding.
C      CTYPX,CTYPY  I    Convolving function types for RA and Dec
C      XPARM(10)    R    Convolving function parameters for RA
C                        XPARM(1) = support half width.
C      YPARM(10)    R    Convolving function parameters for Dec.
C      BLMAX        R    Maximum baseline length allowed in 1000s of
C                        wavelengths.
C      BLMIN        R    Minimum baseline length allowed in 1000s of
C                        wavelengths.
C      GUARDB       R(2) Fraction of UMAX and VMAX to blank on edge of
C                        field
C   GR3DUV will still do zero-spacing insertion.  This is not
C   recommended.  Do it in copying the uv data to start with.
C      DOZERO       L    If true then do zero spacing flux.
C      ZEROSP(5)    R    Zero spacing flux, 1=>flux density (Jy)
C                        5 => weight to use.
C                        polarization.
C      DOTAPE       L    True if taper requested.
C      TAPERU,TAPERV R   TAPER (to 30%) in u and v (kilolamda)
C      NXBEM,NYBEM  I    The size of the BEAM in pixels.
C      FREQG(*)     D    Frequencies of the channels
C      FREQUV       D    Reference frequency for u,v, and w.
C      NGRDAT       L    If FALSE get map size, scaling etc. parms
C                        from the model map cat. header. If TRUE
C                        then the values filled in by GRDAT must
C                        already be filled into the common.
C   The following must be provided if NGRDAT is .TRUE.
C      XFLD,YFLD(*)    R    Field of view in RA and Dec (arcseconds)
C      DXCG,DYCG,DZCG  R    2*pi*(delta ra, delta dec, and delta z)
C                           to be used in AP1GRD to shift positions.
C                           (u,v and w are in cells). one per field.
C      SCLUG,SCLVG,SCLWG R   Conversion factors for u,v and w from
C                           wavelengths at the reference frequency
C                           to cells. one set per field.
C      ICNTRX,ICNTRY(*) I   The center pixel in X and Y for each
C                           field.
C      UVROT, MAPROT        Rotations (usually = here)
C   The following must be provided if NGRDAT is .FALSE.
C      CCDISK(16)  I     Disk numbers of the output images.
C      CCCNO(16)   I     Catalog slot numbers of output images.
C   Output:
C      SCROUT      I     /CFILES/ scratch file number of output file
C      BUFF1       R     Working buffer
C      BUFF2       R     Working buffer
C      IRET        I     Return error code. 0=>OK, error otherwise.
C   Output via common:
C      BEMMAX      R     Sum of weights = normalization factor
C      GUAXAU,GUAXAV R   Max U, V in data set
C      GUAXBU,GUAXBV R   Max U, V used in grid
C   Usage Notes:
C    1) The input uvdata file is, with one exception, assumed to be
C     accurately described by the contents of CATUVR and the common
C     /UVHDR/ (includes DUVH, CUVH).  The exception is that the
C     frequencies of the channels are given by the common array FREQG.
C     The u,v, and w are assumes to be given by the common variable
C     FREQUV.
C    2) the contents of common /UVHDR/ (=includes DUVH, CUVH)
C     are filled in by UVPGET from the catalog header; UVPGET should
C     be called before calling GR3DUV.
C    3) if NGRDAT is .FALSE. then the properties (e.g. shift) of the
C     desired output image are assumed to be described in the catalog
C     header of the existant file pointed to by CCDISK,CCCNO(IFIELD).
C    4) only one polarization will be processed and the input data is
C     assumed to be in the desired Stokes' type (i.e. I, Q, U, V etc.)
C     In the general case this will require reformatting the data.
C     This can be accomplished via CALCOP to do the whole file or
C     UVGET or SET1VS & GET1VS which work a record at a time.
C     Multiple channels may be gridded together a la bandwidth
C     synthesis by specifying NCHAVG > 1. One channel of several
C     channels may be gridded using CHUV1 > 1.
C    5) the random parameters in the data should include, in order,
C     u, v, w, weight (optional), time (optional) and baseline
C     (optional).  While the last are optional and not used, the last
C     words of random parameters are used as work space and, if they
C     are missing, u, v, and w may be clobbered.  The weights are
C     required but may be passed either as random parameters or as
C     part of the regular data array, CATUVR should tell which.
C    6) The necessary image normalization constant for proper
C     normalization of the FFTed image is produced only by a call
C     with IFIELD=0 to grid the sampling function.  Therefore,
C     GR3DUV must be called to grid the sampling function IRREGARDLESS
C     of whether or not a beam will be produced.
C    7) The gridding convolution function parameters must be completely
C     specified.  The defaults should be filled in by a call to
C     GRDFLT before calling GR3DUV.
C    8) Multiple IFs can be processed using the common frequency table
C     FREQG
C    9) No sort order is assumed, but the data must be in approximate XY
C     order if the grid is too large to fit in the AP otherwise.  The
C     routine will die if there is a failure to fit for any reason.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   IFIELD, DISKI, CNOSCI, SCROUT, JBUFSZ, FREQID, IRET
      REAL      CATUVR(256), BUFF1(*), BUFF2(*)
C
      INTEGER   VO, BO, VREAD, LLVIS, IFACT, IERR, KNPTR, JNPTR,
     *   NIO, NXO2, ILENBU, ICENX, ICENY, NX, NY, WIN(4), LOCS, KEYTYP,
     *   VSOFF, LVIS, WTOFF, I1, I2, END1, END2, IROUND, IWOFF, MXROGD,
     *   NROGRD, KAP, CY, CX, VIS, WT, IVIS, I, UV, LUV, INCNT, CNT,
     *   ITEMP, LLREC, N, NO2, M, MO2, LROW, ROWSIZ, MCHGRD, NROWS,
     *   MAXREC, SIZEAP, APSMWT, EXCESS, LOGRID, USTRT, USTOP, UCOUNT,
     *   MAXU, APCONI(3), UHI, ULO, VOL(2), FILCNO(2), LUN(2), IND(2),
     *   BIND(2), IU, LFIELD, VLAST, NFAIL, MAXVIS, I2FMAX, NEED
      LOGICAL   T, F, DOSHFT, BEAM, ALLROW, DONE
      REAL      APCONS(20), UMIN, UMAX, UIN, VIN, WEIGHT, FLUXZ, TUC,
     *   TVC, SSCLU, FRSTU, UUMAXO, VVMAXO, BLMN2O, BLMX2O, ZSCLU,
     *   ZSCLV, ZSCLW, XXFLD, YYFLD, DDXS(3), FFRAC, SUMWT,
     *   ONESUM, BLEN, BLMN2, BLMX2, UUMAX, VVMAX, DU, DV, UUMAXG,
     *   VVMAXG, TEMP, UU, UMAT(3,3), PMAT(3,3), RPCONI(3)
      DOUBLE PRECISION   WX, WY, GFACT, FREQLO, FREQHI, XRA, XDEC
      CHARACTER PHNAME*48
      EQUIVALENCE (APCONI, RPCONI)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMPR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA LUN /18, 20/
C-----------------------------------------------------------------------
      IRET = 0
      BO = 1
      VO = 0
      VREAD = 0
      SUMWT = 0.0
      UCOUNT = 0
      IF ((GUARDB(1).LT.0.0) .OR. (GUARDB(1).GT.0.9)) GUARDB(1) = 0.0
      IF ((GUARDB(2).LT.0.0) .OR. (GUARDB(2).GT.0.9)) GUARDB(2) = 0.0
      GUAXAU = 0.
      GUAXAV = 0.
      GUAXBU = 0.
      GUAXBV = 0.
      GUACNT = 0
C                                       Set parameters for beam/map.
      BEAM = IFIELD.LE.0
      LFIELD = MAX (1, ABS(IFIELD))
C                                       Get field info. if nec.
      IF (.NOT.NGRDAT) THEN
         CALL GRDAT (T, IFIELD, CATUVR, BUFF1, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Fill channel table.
      IF ((IFIELD.LT.0) .AND. (LFIELD.EQ.1)) THEN
         CALL FRQTAB (DISKI, CNOSCI, LUN, CATUVR, FREQID, BUFF1, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      CALL XYSHFT (RA, DEC, XSHIFT(LFIELD), YSHIFT(LFIELD), MAPROT,
     *      XRA, XDEC)
      IF (DO3DIM) THEN
         CALL PRJMAT (RA, DEC, UVROT, XRA, XDEC, MAPROT, UMAT, PMAT)
      ELSE
         CALL P2DMAT (RA, DEC, UVROT, XRA, XDEC, MAPROT, UMAT, PMAT)
         END IF
C                                       Max, min Freq
      FREQHI = FREQG(CHUV1)
      FREQLO = FREQG(CHUV1)
      DO 10 I = 1,NCHAVG
         FREQHI = MAX (FREQHI, FREQG(CHUV1+I-1))
         FREQLO = MIN (FREQLO, FREQG(CHUV1+I-1))
 10      CONTINUE
C                                       Map.
      IF (IFIELD.GT.0) THEN
         NX = FLDSZ(1,IFIELD)
         NY = FLDSZ(2,IFIELD)
         ICENX = ICNTRX(IFIELD)
         ICENY = ICNTRY(IFIELD)
         ZSCLU = 1.0 / (RAD2AS / (NX * ABS (CELLSG(1))))
C                                       Flip sign on v to make maps come
C                                       out upside down.
         ZSCLV =  - 1.0 / (RAD2AS / (NY * CELLSG(2)))
         ZSCLW = 1.0
         XXFLD = XFLD(IFIELD)
         YYFLD = YFLD(IFIELD)
         DDXS(1) = -DXCG(IFIELD)
         DDXS(2) = -DYCG(IFIELD)
         DDXS(3) = -DZCG(IFIELD)
         CALL PRJMUL (2, DDXS, PMAT, DDXS)
C                                       Beam
      ELSE
         NX = NXBEM(LFIELD)
         NY = NYBEM(LFIELD)
         ICENX = NX / 2
         ICENY = NY / 2 + 1
         ZSCLU = SCLUG(1) * NX / FLDSZ(1,LFIELD)
         ZSCLV = SCLVG(1) * NY / FLDSZ(2,LFIELD)
         ZSCLW = 1.0E-6
         XXFLD = ABS (CELLSG(1)) * NX
         YYFLD = ABS (CELLSG(2)) * NY
         DDXS(1) = 0.0
         DDXS(2) = 0.0
         DDXS(3) = 0.0
         END IF
      DOSHFT = (DDXS(1).NE.0.0) .OR. (DDXS(2).NE.0.0)
C                                       Setup I/O:
C                                       Open UV data file IO
      IF (DISKI.GT.0) THEN
         VOL(1) = DISKI
         FILCNO(1) = CNOSCI
         CALL ZPHFIL ('UV', VOL(1), FILCNO(1), 1, PHNAME, IERR)
      ELSE
         VOL(1) = SCRVOL(CNOSCI)
         FILCNO(1) = SCRCNO(CNOSCI)
         CALL ZPHFIL ('SC', VOL(1), FILCNO(1), 1, PHNAME, IERR)
         END IF
      CALL ZOPEN (LUN(1), IND(1), VOL(1), PHNAME, T, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN', 'UV data scratch file'
         GO TO 990
         END IF
C                                       Open output grid (SC always)
      VOL(2) = SCRVOL(SCROUT)
      FILCNO(2) = SCRCNO(SCROUT)
      CALL ZPHFIL ('SC', VOL(2), FILCNO(2), 1, PHNAME, IERR)
      CALL ZOPEN (LUN(2), IND(2), VOL(2), PHNAME, T, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN', 'Grid file'
         GO TO 990
         END IF
C                                       Set UV data I/O length.
      ILENBU = ((JBUFSZ - NBPS) / 2) / LREC - 2
      ILENBU = MAX (ILENBU, 1)
      NXO2 = NX / 2
C                                       Make sure an ODD number of rows
C                                       is being kept in the AP.
      NO2 = MAX (YPARM(1) , 1.0) + 0.1
      N   = NO2 * 2 + 1
      MO2 = MAX (XPARM(1) , 1.0) + 0.1
      M   = MO2 * 2 + 1
      LLREC = LREC
      LROW = NY
C                                       IFACT is the number of REAL
C                                       accumulators in GRID per cell
      IFACT = 2
      ROWSIZ = IFACT * LROW
C                                       Frequency scaling constants
      DV = RAD2AS / (NY * CELLSG(2))
      DU = RAD2AS / (NX * ABS (CELLSG(1)))
C                                       Stay away from edge of grid.
      UUMAXO = (NXO2 - 0.5 - MAX (3, MO2)) * DU
      VVMAXO = (NY/2 - 0.5 - MAX (3, NO2)) * DV
C                                       Set baseline limits (round out)
      BLMN2O = 0.999E6 * BLMIN * BLMIN
      BLMX2O = 1.001E6 * BLMAX * BLMAX
      IF (BLMX2O.LE.1.0) BLMX2O = 1.0E20
C                                       Set window - write backwards
      WIN(1) = 1
      WIN(2) = NXO2 + 1
      WIN(3) = ROWSIZ
      WIN(4) = 1
C                                       Determine no. rows in AP -
C                                       any excess over allowing 1/4 for
C                                       data buffer goes to extra rows.
      MAXREC = 256
      NEED = MAXREC * LREC + 30 + NCHAVG + (100 * (N + M)) +
     *   (NXO2+M) + ROWSIZ
      NEED = NEED / 1024
      CALL QINIT (APCORE, NEED, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
         NEED = MAXREC * LREC + 30 + NCHAVG + (100 * (N + M)) +
     *      (NXO2/10+M) + ROWSIZ
         NEED = NEED / 1024
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            IRET = 8
            MSGTXT = 'GR3DUV CANNOT GET DESIRED MEMORY'
            CALL MSGWRT (8)
            GO TO 999
            END IF
         END IF
      SIZEAP = PSAPNW * 1024
      MAXREC = MIN (2048, (SIZEAP/40)/LREC) + 5
      EXCESS = SIZEAP - MAXREC * LREC - 30 - NCHAVG - (100 * (N + M))
      MXROGD = EXCESS / ROWSIZ - 1
      IF (MXROGD.LT.M) THEN
         IRET = 8
         MSGTXT = 'GR3DUV CANNOT GET ENOUGH MEMORY'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       grid no more than all rows
      MXROGD = MIN (MXROGD, NXO2+M)
C                                       Set AP pointers
      LOGRID = SIZEAP - ((MXROGD+1) * ROWSIZ) - 1
C                                       Set AP locations for conv. fn.
      CY = LOGRID - 100 * N - 5
      CX = CY     - 100 * M - 1
C                                       AP index to beam sum of weights
      APSMWT = 21 + NCHAVG
C                                       UV data starts after weights
      UV = APSMWT + 2
C                                       Set AP data freq. increment.
      LVIS = INCF
      IF ((INCIF.GT.0) .AND. (INCIF.LT.INCF)) LVIS = INCIF
      LLVIS = LVIS
C                                       Find where weight is.
C                                       IWOFF + => Offset in rec.
C                                       IWOFF - => Offset in vis.
      IWOFF = 0
      CALL AXEFND (4, 'WEIG', KIPTPN, CATUVR(KHPTP), IWOFF, IERR)
C                                       Make Taper widths convenient
      TUC = 0.0
      TVC = 0.0
      IF (DOTAPE) THEN
         IF (TAPERU.GT.0.) TUC = LOG(.3) / (TAPERU * 1E3 /
     *      206265. * XXFLD) ** 2
         IF (TAPERV.GT.0.) TVC = LOG(.3) / (TAPERV * 1E3 /
     *      206265. * YYFLD) ** 2
         END IF
C                                       Shift the map center
C                                       here in the gridding routine.
C                                       ICENX and ICENY define the
C                                       pixel number of the map center.
      WX = (-TWOPI * (ICENX-1-NX/2)) / NX
      WY = (-TWOPI * (ICENY-1-NY/2)) / NY
C                                       Set AP gridding constants.
      APCONS(1) = COS ((NX / 2) * WX)
      APCONS(2) = SIN ((NX / 2) * WX)
      APCONS(3) = COS (WY)
      APCONS(4) = SIN (WY)
      APCONS(5) = COS (-WX)
      APCONS(6) = SIN (-WX)
      APCONS(7) = 1.0
      APCONS(8) = 0.0
      APCONS(9) = 0.0
      APCONS(10) = TUC
      APCONS(11) = TVC
      APCONI(1) = CX
      APCONI(2) = CY
      APCONI(3) = LOGRID
C                                       Determine the maximum number
C                                       of visibility points which
C                                       fit in the AP.
      MAXREC = (CX - UV) / LREC - 5
      ILENBU = MIN (MAXREC, ILENBU)
C                                       get the max U
      FRSTU = -1.0E3
      CALL CATKEY ('REED', VOL(1), FILCNO(1), 'MAXBLINE', 1, LOCS,
     *   FRSTU, KEYTYP, BUFF1, IERR)
      IF (IERR.NE.0) FRSTU = -1.E3
      IF (FRSTU.LE.0.0) FRSTU = NXO2 / ZSCLU
C                                       Rescale FRSTU by max frequency
      ULO = FRSTU * FREQLO / FREQUV * ZSCLU
      UHI = FRSTU * FREQHI / FREQUV * ZSCLU + 2.0
      IF ((UHI.GT.NXO2) .OR. (UHI.LE.0.0)) THEN
         NROWS = NXO2 * (FREQHI - FREQLO) / FREQUV + M + 0.99
      ELSE
         NROWS = UHI - ULO + M
         END IF
      IF (NROWS.GE.MXROGD) THEN
         WRITE (MSGTXT,1010) NROWS, MXROGD
         CALL MSGWRT (8)
         IRET = 8
         GO TO 999
         END IF
      FRSTU = FRSTU * FREQHI / FREQUV
C                                       Determine Maximum U (in cells)
      MAXU = INT ((ABS(FRSTU) * ZSCLU) + 2.)
      UHI = MAXU + MO2 + 1
      UHI = MIN (UHI, NXO2)
C                                       limit U to max that will fit
      MAXU = MIN (MAXU, NXO2)
C                                       calc number needed
      NROGRD = MAXU + M + 2
C                                       do all rows fit in ap?
      ALLROW = (MXROGD.GE.NROGRD)
C                                       number of rows at a time
      NROWS = MIN (NROGRD, MXROGD)
      ULO = UHI - NROWS
      ULO = MAX (ULO, -MO2-1)
      NROWS = UHI - ULO + 1
C                                       tell user rows in AP
      IF ((BEAM) .AND. (LFIELD.EQ.1)) THEN
         IF (ALLROW) THEN
            WRITE (MSGTXT,1020,ERR=20) NROWS, PSAPNW, MXROGD
         ELSE
            WRITE (MSGTXT,1030,ERR=20) NROWS, PSAPNW
            IF (ISORT(1:1).NE.'X') THEN
               CALL MSGWRT (8)
               MSGTXT = 'GR3DUV: DATA MUST BE XY SORTED, NOT ' // ISORT
               GO TO 990
               END IF
            END IF
         CALL MSGWRT (2)
C                                       tell user max base line
         WRITE (MSGTXT,1035,ERR=20) FRSTU, MAXU
         CALL MSGWRT (2)
C                                       tell user channels
         IF (NCHAVG.GT.1) THEN
            WRITE (MSGTXT,1036,ERR=20) NCHAVG, FREQLO, FREQHI
         ELSE
            WRITE (MSGTXT,1037,ERR=20) FREQG(CHUV1)
            END IF
         CALL MSGWRT (2)
         END IF
C                                       jump on write error
C                                       Clear grid.
 20   CALL QVCLR (APCORE, LOGRID, 1, SIZEAP-LOGRID-1)
      CALL QWAIT
C                                       freq scaling array
      MCHGRD = NCHAVG
      IF (NCHAVG.GT.1) THEN
         DO 25 I = 2,NCHAVG
            BUFF2(I-1) = 0.0
            IF (FREQG(I-1).GT.0.0D0) BUFF2(I-1) = FREQG(I) / FREQG(I-1)
     *         - 1.0D0
 25         CONTINUE
         CALL QWAIT
         CALL QPUT (APCORE, BUFF2, 20, MCHGRD, 2)
         END IF
C                                       Grid data.
      IF (DOTAPE) MCHGRD = -MCHGRD
C                                       Offset VIS to freq channel.
      VSOFF = NRPARM + (CHUV1-1) * LVIS
      VIS = UV + VSOFF
C                                       If COMPLEX axis more then
C                                       2 long Vis has weight.
C                                       weight is in random parameters
      IF (LVIS.LE.2) THEN
         WTOFF = IWOFF
C                                       Weight in vis, index to channel
      ELSE
         WTOFF = VSOFF + 2
         END IF
C                                       set index relative to AP buffer
      WT = UV + WTOFF
C                                       Create Convolving function
      CALL CONVFN (APCORE, CX, CTYPX, XPARM, BUFF2)
      CALL CONVFN (APCORE, CY, CTYPY, YPARM, BUFF2)
C                                       Set freq. scaling factors
      FFRAC = (FREQG(CHUV1) / FREQUV) - 1.0D0
      SSCLU = FFRAC * ZSCLU + ZSCLU
      GFACT = 1.0D0 / ((FREQLO/FREQUV) * ZSCLU)
      UMAX = (UHI + 0.5) * GFACT
      UMIN = (ULO - 0.5) * GFACT
C                                       Set limits.
C                                       Rescale baseline limits.
      BLMN2 = BLMN2O / ((1.0D0 + FFRAC) ** 2)
      BLMX2 = BLMX2O / ((1.0D0 + FFRAC) ** 2)
      UUMAX = UUMAXO / (1.0D0 + FFRAC)
      VVMAX = VVMAXO / (1.0D0 + FFRAC)
      UUMAXG = NXO2 * DU * (1. - GUARDB(1)) / (1.0D0 + FFRAC)
      VVMAXG = NY/2 * DV * (1. - GUARDB(2)) / (1.0D0 + FFRAC)
      UUMAXG = MIN (UUMAXG, UUMAX)
      VVMAXG = MIN (VVMAXG, VVMAX)
C                                       Put gridding constants into AP
      APCONS(12) = FFRAC*ZSCLU + ZSCLU
      APCONS(13) = FFRAC*ZSCLV + ZSCLV
      APCONS(14) = FFRAC*ZSCLW + ZSCLW
      APCONS(15) = DDXS(1) / ZSCLU
      APCONS(16) = DDXS(2) / ZSCLV
      APCONS(17) = DDXS(3) / ZSCLW
      CALL QWAIT
      CALL QPUT (APCORE, APCONS, 0, 17, 2)
      CALL QPUT (APCORE, RPCONI, 17, 3, 1)
C                                       Init for write
      CALL MINIT ('WRIT', LUN(2), IND(2), ROWSIZ, NXO2+1, WIN, BUFF2,
     *   JBUFSZ, BO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT', 'WRITE GRIDDED DATA'
         GO TO 990
         END IF
      IF (NXO2.GT.UHI) THEN
         N = JBUFSZ / 2
         CALL RFILL (N, 0.0, BUFF2)
         N = NXO2 - UHI
         DO 90 I = 1,N
            CALL MDISK ('WRIT', LUN(2), IND(2), BUFF2, BIND(2), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRIT', 'GRIDDED DATA'
               GO TO 990
               END IF
 90         CONTINUE
         END IF
      LUV = UV
      INCNT = 0
      CNT = 0
      VLAST = 0
C                                       Init for UV read.
 95   VO = VLAST
      MAXVIS = NVIS - VO
      CALL UVINIT ('READ', LUN(1), IND(1), MAXVIS, VO, LREC, ILENBU,
     *   JBUFSZ, BUFF1, BO, BIND(1), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT', 'UV DATA'
         GO TO 990
         END IF
      NFAIL = 0
      VLAST = NVIS + 1
      I2FMAX = -MO2 - 1
C                                       read one UVdata Buffer
 100  CALL UVDISK ('READ', LUN(1), IND(1), BUFF1, NIO, BIND(1), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ', 'UV DATA'
         GO TO 990
         END IF
C                                       if more data
      IF (NIO.GT.0) THEN
C                                       set UV buffer indicies
         JNPTR = BIND(1)
         KNPTR = BIND(1)
C                                       for all vis points in buffer
         DO 150 IVIS = 1,NIO
            VO = VO + 1
C                                       input U value
            CALL PRJMUL (1, BUFF1(JNPTR), UMAT, BUFF1(JNPTR))
            UIN = ABS (BUFF1(JNPTR))
            VIN = ABS (BUFF1(JNPTR+1))
            GUAXAU = MAX (GUAXAU, UIN)
            GUAXAV = MAX (GUAXAV, VIN)
            UU = UIN * ZSCLU
            TEMP = UU * FREQHI / FREQUV + 1.0
            I2 = IROUND (TEMP) + MO2
            TEMP = UU * FREQLO / FREQUV - 1.0
            I1 = IROUND (TEMP) - MO2
C                                       not in current buffer
            IF (I1.LT.ULO) THEN
               VLAST = MIN (VLAST, VO-1)
               I2FMAX = MAX (I2FMAX, I2)
               NFAIL = NFAIL + 1
               IF (NFAIL.GT.1000) GO TO 160
C                                       is in current buffer
            ELSE IF (I2.LE.UHI) THEN
               NFAIL = 0
C                                       calc baseline length squared
               BLEN = UIN*UIN + VIN*VIN
C                                       Check if uv in range.
               IF ((BLEN.GE.BLMN2) .AND. (BLEN.LE.BLMX2)) THEN
C                                       If inside guard band
                  IF ((UIN.LE.UUMAXG) .AND. (VIN.LE.VVMAXG)) THEN
C                                       if making the synthesized beam
C                                       BEAM replace data with (1,0)
                     IF (BEAM) CALL UVSETB (VSOFF, LVIS, UMAX, UMIN,
     *                  SSCLU, NCHAVG, BUFF1(JNPTR))
C                                       Flip U, V, W, conjugate data.
                     IF (BUFF1(JNPTR).LT.0.0) CALL UVCONJ (VSOFF, LVIS,
     *                  NCHAVG, 1, 2, BUFF1(JNPTR))
C                                       count points, update pointer
                     CNT = CNT + 1
C                                       if not same point, copy
                     IF (KNPTR.NE.JNPTR) CALL RCOPY (LREC, BUFF1(JNPTR),
     *                  BUFF1(KNPTR))
C                                       update output pointer
                     KNPTR  = KNPTR + LREC
                     GUAXBU = MAX (GUAXBU, UIN)
                     GUAXBV = MAX (GUAXBV, VIN)
                     GUACNT = GUACNT + 1
                     END IF
                  END IF
               END IF
            JNPTR = JNPTR + LREC
C                                       does this fill the AP?
            IF (CNT+INCNT.GE.MAXREC) THEN
C                                       load any data
               IF (CNT.GT.0) THEN
                  N = LREC * CNT
                  VREAD = VREAD + CNT
                  CALL QPUT (APCORE, BUFF1(KNPTR-N), LUV, N, 2)
                  CALL QWD
                  INCNT = INCNT + CNT
                  LUV = LUV + N
                  CNT = 0
                  KNPTR = BIND(1)
                  END IF
C                                       grid loaded data
               IF (INCNT.GT.0) THEN
C                                       Put row number in AP MD(8)
                  APCONS(9) = ULO + MO2
                  CALL QPUT (APCORE, APCONS(9), 8, 1, 2)
                  CALL QWAIT
                  ITEMP = -INCNT
                  IF (DOSHFT) ITEMP = -ITEMP
                  CALL Q1GRD (APCORE, UV ,VIS, WT, LLREC, LLVIS, NO2, M,
     *               LROW, ITEMP, MCHGRD)
                  CALL QWR
                  INCNT = 0
                  LUV = UV
                  END IF
               END IF
 150        CONTINUE
C                                       if some good points found
         IF (CNT.GT.0) THEN
C                                       Load into AP.
            CALL QWR
            VREAD = VREAD + CNT
            N = LREC * CNT
            CALL QPUT (APCORE, BUFF1(BIND(1)), LUV, N, 2)
            LUV = LUV + N
            INCNT = INCNT + CNT
            CALL QWAIT
            CNT = 0
            END IF
C                                       loop for data
         GO TO 100
         END IF
C                                       need to finish part of grid
 160  DONE = (ULO.LE.(-MO2)) .OR. (VLAST.GT.NVIS)
C                                       load any data
      IF (CNT.GT.0) THEN
         N = LREC * CNT
         VREAD = VREAD + CNT
         CALL QPUT (APCORE, BUFF1(KNPTR-N), LUV, N, 2)
         CALL QWD
         LUV = LUV + N
         INCNT = INCNT + CNT
         CNT = 0
         KNPTR = BIND(1)
         END IF
C                                       Do zero spacing flux densities
      IF ((DONE) .AND. (DOZERO)) THEN
         VIN = 0.0
         UIN = 0.0
C                                       calc zerospacing weight
         IF (BEAM) THEN
            FLUXZ = 1.
         ELSE
            FLUXZ = ZEROSP(1) - TFLUXG
            END IF
         WEIGHT = ZEROSP(5)
         CALL UVZRSP (WTOFF, VSOFF, LVIS, FLUXZ, WEIGHT, NCHAVG, BUFF1)
         CNT = CNT + 1
         VREAD = VREAD + CNT
         N = LREC * CNT
         CALL QPUT (APCORE, BUFF1, LUV, N, 2)
         LUV = LUV + N
         INCNT = INCNT + CNT
         CALL QWAIT
         END IF
C                                       grid loaded data
      IF (INCNT.GT.0) THEN
C                                       Put row number in AP MD(8)
         APCONS(9) = ULO + MO2
         CALL QPUT (APCORE, APCONS(9), 8, 1, 2)
         CALL QWAIT
         ITEMP = -INCNT
         IF (DOSHFT) ITEMP = -ITEMP
         CALL Q1GRD (APCORE, UV ,VIS, WT, LLREC, LLVIS, NO2, M, LROW,
     *      ITEMP, MCHGRD)
         CALL QWR
         INCNT = 0
         LUV = UV
         END IF
C                                       Finish computations
      IF (DONE) THEN
         USTRT = -MO2
      ELSE
         USTRT = MAX (ULO, I2FMAX+1)
         END IF
      USTOP = UHI
      IF (BEAM) THEN
         CALL APSUM (APCORE, USTRT, USTOP, ULO, ROWSIZ, LOGRID, APSMWT,
     *      LROW, ONESUM)
         SUMWT = SUMWT + (2 * ONESUM)
         END IF
         CALL APFNSH (APCORE, USTRT, USTOP, ULO, MAXU, MO2, ROWSIZ,
     *      LROW, LOGRID,SIZEAP, WX)
      N = USTOP - MAX (-1, I2FMAX)
      DO 165 I = 1,N
         IU = UHI + 1 - I
         CALL MDISK ('WRIT', LUN(2), IND(2), BUFF2, BIND(2), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRIT', 'GRIDDED DATA'
            GO TO 990
            END IF
         IF (IU.GE.ULO) THEN
            END1 = LOGRID + (IU - ULO) * ROWSIZ
            CALL QGET (APCORE, BUFF2(BIND(2)), END1, ROWSIZ, 2)
         ELSE
            CALL RFILL (ROWSIZ, 0.0, BUFF2(BIND(2)))
            END IF
 165     CONTINUE
      CALL QWAIT
C                                       move remaining grid up
      IF (.NOT.DONE) THEN
         END2 = (UHI - ULO + 1) * ROWSIZ - 1 + LOGRID
         IF (I2FMAX.GE.ULO) THEN
            N = (I2FMAX - ULO + 1) * ROWSIZ
            END1 = LOGRID + N - 1
            CALL QVMOV (APCORE, END1, -1, END2, -1, N)
         ELSE
            N = 0
            END IF
C                                       and zero new part
         END2 = END2 - N - LOGRID + 1
         CALL QVCLR (APCORE, LOGRID, 1, END2)
         UHI = I2FMAX
         ULO = UHI - NROWS + 1
         UMAX = (UHI + 0.5) * GFACT
         UMIN = (ULO - 0.5) * GFACT
         GO TO 95
         END IF
C                                       Give up AP
      CALL QRLSE
C                                       Close files
      CALL ZCLOSE (LUN(1), IND(1), IERR)
      CALL MDISK ('FINI', LUN(2), IND(2), BUFF2, BIND(2), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINISH', 'GRIDDED DATA'
         GO TO 990
         END IF
      IRET = IERR
      CALL ZCLOSE (LUN(2), IND(2), IRET)
C                                       Set sum of weights
      IF (BEAM) THEN
         BEMMAX(LFIELD) = SUMWT
         WRITE (MSGTXT,1170) LFIELD, BEMMAX(LFIELD)
         CALL MSGWRT (4)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
      IRET = MAX (1, IRET)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GR3DUV ERROR',I4,1X,A,'ING ',A)
 1010 FORMAT ('GR3DUV: REQUIRES',I5,' ROWS, BUT ONLY',I5,' WILL FIT')
 1020 FORMAT ('GR3DUV: All  ',I5,' Rows in',I6,'k AP (',I5,' Rows Max)')
 1030 FORMAT ('GR3DUV: Only ',I5,' Rows in',I6,'k AP')
 1035 FORMAT ('GR3DUV: Max U Baseline ',F12.0,' lambda (=',I5,' cells)')
 1036 FORMAT ('GR3DUV: Ave',I5,' Channels:',1PE13.6,' to',E13.6,' Hz')
 1037 FORMAT ('GR3DUV: Frequency',1PE13.6,' Hz')
 1170 FORMAT ('Field',I5,' Sum of gridding weights =',1PE132.5)
      END

LOCAL INCLUDE 'TRANS.INC'
      CHARACTER INNAME*12, INCLAS*6, OUTNAM*12, OUTCLS*6, OPCODE*14
      HOLLERITH XINNAM(3), XINCLA(2), XOUTNA(3), XOUTCL(2), XOPCOD(4)
      REAL      INSEQ, INDISK, OUTSEQ, OUTDSK, BLC(7), TRC(7),
     * BADISK(10)
      REAL      RMAX, RMIN
      INTEGER   RIAX(7), RSGN(7), NPI(7), NSI(7), DONMAX, INLUN, ININD,
     *   OUTLUN, OUTIND, WORK(512)
C
      COMMON /INPARM/ XINNAM, XINCLA, INSEQ, INDISK, XOUTNA, XOUTCL,
     *   OUTSEQ, OUTDSK, BLC, TRC, XOPCOD, BADISK
      COMMON /CHPARM/ INNAME, INCLAS, OUTNAM, OUTCLS, OPCODE
      COMMON /TRACOM/ RMIN, RMAX, DONMAX, RIAX, RSGN,
     *   NPI, NSI, INLUN, ININD, OUTLUN, OUTIND
      COMMON /TRABUF/ WORK
LOCAL END
      PROGRAM TRANS
C-----------------------------------------------------------------------
C! Generalized 7-D matrix transposition program
C# Map-util Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2005, 2008-2010, 2012-2013, 2016, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TRANS is a generalized 7-dimensional matrix transposition program
C   which runs under control of AIPS.
C   Adverbs: INNAME    R(3)    Input image: name 12 packed chars
C            INCLASS   R(2)               : class 6 packed chars
C            INSEQ     R                  : seq #
C            INDISK    R                  : disk number
C            OUTNAME   R(3)    Ouput image: name 12 packed chars
C            OUTCLASS  R(2)               : class 6 packed chars
C            OUTSEQ    R                  : seq # , 0 => low unique
C            OUTDISK   R                  : disk #, 0 => INDISK
C            BLC       R(7)    Subimage input: bottom left corner
C            TRC       R(7)                  : top right corner
C            TRACODE   R(4)    New axis order in terms of old axis
C                              numbers: <= 14 packed chars.
C            BADDISK   R(10)   List of disks to avoid for scratch files
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   RSC1, RSC2
      PARAMETER (RSC1 = 4096)
      PARAMETER (RSC2 = 64)
C
      CHARACTER PHNAME*48
      INTEGER   IAX(7), IERR, JJ, KVOL, NN, BYTPIX, NPST(7), I, IRET
      LOGICAL   T, DONE
      LONGINT   PBUF1
      INTEGER   NBUF1, NBUF2
      REAL      RBUF2(RSC2*MAXIMG), RBUF1(2)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'TRANS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       initialization, get parms
C                                       create output map
      CALL TRAINI (IERR)
      IF (IERR.NE.0) GO TO 900
C                                       get big memory
      NBUF2 = MAXIMG * RSC2 * 2
      NBUF1 = (MAXIMG * RSC1 - 1) / 1024 + 1
      NBUF1 = MIN (NBUF1, KAPWRD)
      CALL ZMEMRY ('GET ', TSKNAM, NBUF1, RBUF1, PBUF1, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'COULD NOT GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
      NBUF1 = 2048 * NBUF1
      JJ = RIAX(1)
      KVOL = FVOL(1)
      BYTPIX = 2
C                                       Short rows w subimage or swap
      IF (NSI(1)*BYTPIX.GT.NBPS/2) GO TO 100
         DO 20 I = 1,7
            IF ((RSGN(I).LT.0) .OR. (NSI(I).LT.NPI(I))) GO TO 25
 20         CONTINUE
         GO TO 100
C                                       Do simple subarray op.
 25      DONE = .TRUE.
         DO 30 I = 1,7
            IAX(I) = I
            DONE = (DONE) .AND. (IAX(I).EQ.RIAX(I))
 30         CONTINUE
         OUTLUN = INLUN + 1
C                                       Create scratch
         IF (DONE) GO TO 35
            CALL MAPSNC (CATBLK(KIDIM), NSI, KVOL, OUTLUN, OUTIND, WORK,
     *         IERR)
            IF (IERR.NE.0) GO TO 900
            KVOL = SCRVOL(NSCR)
            GO TO 40
C                                       Open final output file
 35      CONTINUE
            CALL ZPHFIL ('MA', FVOL(2), FCNO(2), 1, PHNAME, IERR)
            CALL ZOPEN (OUTLUN, OUTIND, FVOL(2), PHNAME, T, T, T, IERR)
            IF (IERR.EQ.0) GO TO 40
               WRITE (MSGTXT,1035) IERR
               CALL MSGWRT (8)
               GO TO 900
C                                       Do it finally
 40      CALL TRAROW (IAX, NBUF1, NBUF2, RBUF1(1+PBUF1), RBUF2, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL ZCLOSE (INLUN, ININD, IERR)
C                                       Pass along scratch file
         IF (DONE) GO TO 400
            INLUN = OUTLUN
            ININD = OUTIND
            CALL FILL (7, 1, RSGN)
            CALL COPY (7, NSI, NPI)
C                                       X axis is involved!
 100  IF (JJ.EQ.1) GO TO 300
C                                       prepare submatrix for X x Y
         IF ((JJ.EQ.2) .AND. (RSGN(1).GT.0) .AND. (RSGN(2).GT.0)
     *      .AND. (DONMAX.GT.0)) GO TO 200
C                                       Axes to do this time: mostly
C                                       no movement, swap JJ with 2
            DO 120 I = 1,7
               IAX(I) = I
               NPST(I) = NSI(I)
 120           CONTINUE
            NPST(2) = NSI(JJ)
            NPST(JJ) = NSI(2)
            IAX(2) = JJ
            IAX(JJ) = 2
C                                       Create, open scratch file
            OUTLUN = INLUN + 1
            CALL MAPSNC (CATBLK(KIDIM), NPST, KVOL, OUTLUN, OUTIND,
     *         WORK, IERR)
            IF (IERR.NE.0) GO TO 900
            KVOL = SCRVOL(NSCR)
C                                       Read-scatter write: apply
C                                       subim, find max/min
            CALL TRAROW (IAX, NBUF1, NBUF2, RBUF1(1+PBUF1), RBUF2, IERR)
            IF (IERR.NE.0) GO TO 900
            CALL ZCLOSE (INLUN, ININD, IERR)
C                                       pass along new input file
            INLUN = OUTLUN
            ININD = OUTIND
C                                       update tables to reflect change
            CALL FILL (7, 1, RSGN)
            CALL COPY (7, NSI, NPI)
            IF (JJ.LE.2) GO TO 200
               DO 140 I = 1,7
                  IF (RIAX(I).NE.JJ) GO TO 130
                     RIAX(I) = 2
                     NPI(2) = NSI(JJ)
                     GO TO 140
 130              IF (RIAX(I).NE.2) GO TO 140
                     RIAX(I) = JJ
                     NPI(JJ) = NSI(2)
 140              CONTINUE
C                                       X with Y transpose
C                                       this is not last step
 200     IF (RIAX(2).EQ.1) GO TO 220
            DO 210 I = 3,7
               IAX(I) = I
 210           CONTINUE
            IAX(1) = 2
            IAX(2) = 1
            NN = NPI(2)
            NPI(2) = NPI(1)
            NPI(1) = NN
            OUTLUN = INLUN + 1
            CALL MAPSNC (CATBLK(KIDIM), NPI, KVOL, OUTLUN, OUTIND, WORK,
     *         IERR)
            IF (IERR.NE.0) GO TO 900
            NPI(1) = NPI(2)
            NPI(2) = NN
            KVOL = SCRVOL(NSCR)
            GO TO 230
C                                       This is the last step
 220     CONTINUE
            CALL COPY (7, RIAX, IAX)
            OUTLUN = INLUN + 1
C                                       Open output map as out file
            CALL ZPHFIL ('MA', FVOL(2), FCNO(2), 1, PHNAME, IERR)
            CALL ZOPEN (OUTLUN, OUTIND, FVOL(2), PHNAME, T, T, T, IERR)
            IF (IERR.EQ.0) GO TO 230
               WRITE (MSGTXT,1035) IERR
               CALL MSGWRT (8)
               GO TO 900
C                                       Do X with Y
C                                       swap which is large buffer
 230     CALL TRAXPO (IAX, NBUF2, NBUF1, RBUF2, RBUF1(1+PBUF1), IERR)
         IF (IERR.NE.0) GO TO 900
         CALL ZCLOSE (INLUN, ININD, IERR)
C                                       Pass along file if not done
         IF (RIAX(2).EQ.1) GO TO 400
            INLUN = OUTLUN
            ININD = OUTIND
C                                       Bring parms up to date
            DO 240 I = 1,7
               RSGN(I) = 1
               IF (RIAX(I).NE.2) GO TO 235
                  RIAX(I) = 1
                  GO TO 240
 235           IF (RIAX(I).EQ.1) RIAX(I) = 2
 240           CONTINUE
            NN = NPI(2)
            NPI(2) = NPI(1)
            NPI(1) = NN
C                                       Final read-scatter write
 300  OUTLUN = INLUN + 1
      CALL ZPHFIL ('MA', FVOL(2), FCNO(2), 1, PHNAME, IERR)
      CALL ZOPEN (OUTLUN, OUTIND, FVOL(2), PHNAME, T, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1035) IERR
         CALL MSGWRT (8)
         GO TO 900
         END IF
C                                       Do it
      CALL TRAROW (RIAX, NBUF1, NBUF2, RBUF1(1+PBUF1), RBUF2, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Final header update...
 400  IRET = 0
      IF (DONMAX.NE.2) THEN
         CATR(KRDMX) = RMAX
         CATR(KRDMN) = RMIN
         CALL CATIO ('UPDT', FVOL(2), FCNO(2), CATBLK, 'REST',
     *      WORK, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1400) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      GO TO 990
C                                       ERRORS: close files
 900  IRET = 8
C                                       Clear files, restart AIPS, etc
 990  CALL DIE (IRET, WORK)
C
 999  STOP
C-----------------------------------------------------------------------
 1035 FORMAT ('UNABLE TO OPEN OUTPUT FILE: IERR=',I7)
 1400 FORMAT ('WARNING: MAX/MIN NOT UPDATED IN HEADER: IERR=',I7)
      END
      SUBROUTINE TRAINI (IERR)
C-----------------------------------------------------------------------
C   TRAINI performs initializations for program TRANS: init basic
C   commons, open input map, create output map (including HI file),
C   and interpret transposition code.
C   Output: IERR   I       0 => ok, rest => quit
C   Output commons:
C      /MAPHDR/ new map header
C      /CFILES/ file handling for die: init, enter catlgd files
C      /TRACOM/ task parms
C      /INPARM/ input parms with defaults filled in
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6, NUMBER(7)*1, FCHARS(3)*4, CTEMP*8, MTYPE*2,
     *   IT*1, NOTTYP*2
      INTEGER   NPARMS, IERR, IRET, IER, IUSER, S2B(256), IS, ITMP,
     *   LUNH1, LUNH2, I, INC, ISEQ,  J, K, L, M, NAX, IROUND, NONOT,
     *   NAXP(7)
      REAL      S4B(128)
      DOUBLE PRECISION    S8B(64)
      LOGICAL   T, EQUAL
      INCLUDE 'TRANS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (S2B, S4B, S8B)
      DATA NPARMS, PRGNAM / 42, 'TRANS '/
      DATA NUMBER /'1','2','3','4','5','6','7'/
      DATA LUNH1, LUNH2 /27, 28/
      DATA T /.TRUE./
      DATA FCHARS /'FREQ','VELO','FELO'/
      DATA NONOT, NOTTYP /0, '  '/
C-----------------------------------------------------------------------
C                                       File init
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NCFILE = 0
      NSCR = 0
C                                       Get parms from AIPS
      CALL GTPARM (PRGNAM, NPARMS, RQUICK, XINNAM, WORK, IERR)
      IRET = IERR
      IF (IRET.NE.0) THEN
         IF (IRET.EQ.1) GO TO 999
            WRITE (MSGTXT,1000)
            CALL MSGWRT (9)
         END IF
      IF (RQUICK) CALL RELPOP (IRET, WORK, IER)
      IF (IRET.NE.0) GO TO 999
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XINNAM, INNAME)
      CALL H2CHR (6, 1, XINCLA, INCLAS)
      CALL H2CHR (12, 1, XOUTNA, OUTNAM)
      CALL H2CHR (6, 1, XOUTCL, OUTCLS)
      CALL H2CHR (14, 1, XOPCOD, OPCODE)
C                                       Open input map
      FVOL(1) = IROUND (INDISK)
      FRW(1) = 0
      ISEQ = IROUND (INSEQ)
      IUSER = NLUSER
      INLUN = 16
      MTYPE = 'MA'
      CALL MAPOPN ('READ', FVOL, INNAME, INCLAS, ISEQ, MTYPE, IUSER,
     *   INLUN, ININD, FCNO, CATBLK, WORK, IERR)
      IF (IERR.GT.1) THEN
         WRITE (MSGTXT,1010)
         CALL MSGWRT (8)
         GO TO 999
         END IF
      NCFILE = 1
C                                       Check/set window
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Fill in defaults
      IF (OUTDSK.GT.NVOL) OUTDSK = FVOL(1)
      I = IROUND (OUTSEQ)
      CALL MAKOUT (INNAME, INCLAS, ISEQ, '      ', OUTNAM, OUTCLS, I)
      OUTSEQ = I
      DO 25 I = 1,10
         IBAD(I) = IROUND (BADISK(I))
 25      CONTINUE
C                                       Default transpose, set subim
      DONMAX = 2
      DO 30 I = 1,7
         RIAX(I) = I
         RSGN(I) = 1
         NPI(I) = MAX (1, CATBLK(KINAX+I-1))
         NSI(I) = TRC(I) - BLC(I) + 1.01
         IF (NSI(I).LT.NPI(I)) DONMAX = 0
         NAXP(I) = NSI(I)
         IF (NSI(I).LE.1) NAXP(I) = 0
 30      CONTINUE
C                                       What transpose requested
      J = 0
      M = 0
      DO 55 I = 1,7
         IS = 1
         J = J + 1
         IT = OPCODE(J:J)
         IF ((IT.NE.' ') .AND. (IT.NE.',')) THEN
            IF (IT.EQ.'-') THEN
               IS = -1
               J = J + 1
               IT = OPCODE(J:J)
               END IF
            DO 45 K = 1,7
               IF (IT.EQ.NUMBER(K)) THEN
C                                       check for duplicate
                  DO 40 L = 1,M
                     IF (RIAX(L).EQ.K) GO TO 900
 40                  CONTINUE
                  M = M + 1
                  RIAX(M) = K
                  RSGN(K) = IS
                  NAXP(K) = 0
                  GO TO 55
                  END IF
 45            CONTINUE
            GO TO 900
            END IF
 55      CONTINUE
      J = 0
      DO 60 I = 1,7
         J = J + NAXP(I)
 60      CONTINUE
      IF (J.GT.0) THEN
         MSGTXT = 'YOU DID NOT SPECIFY ALL REAL AXES'
         CALL MSGWRT (8)
         GO TO 900
         END IF
C                                       max/min setup
      IF (DONMAX.NE.2) THEN
         RMAX = CATR(KRDMN)
         RMIN = CATR(KRDMX)
         END IF
C                                       build new header
C                                       WARNING: this may be too naive
C                                       re coord increments, rotation
      CALL COPY (256, CATBLK, S2B)
      NAX = S2B(KIDIM)
      INC = 2
      DO 110 I = 1,NAX
         K = RIAX(I)
         CATBLK(KINAX+I-1) = NSI(K)
         ITMP = KHCTP+(K-1)*INC
         CALL H2CHR (8, 1, S4B(ITMP), CTEMP)
         ITMP = KHCTP+(I-1)*INC
         CALL CHR2H (8, CTEMP, 1, CATH(ITMP))
         CATD(KDCRV+I-1) = S8B(KDCRV+K-1)
         CATR(KRCIC+I-1) = S4B(KRCIC+K-1) * RSGN(K)
         CATR(KRCRT+I-1) = S4B(KRCRT+K-1)
         CATR(KRCRP+I-1) = S4B(KRCRP+K-1) - BLC(K) + 1.0
         IF (RSGN(K).LT.0) CATR(KRCRP+I-1) = TRC(K) - S4B(KRCRP+K-1)
     *      + 1.0
         IF (CATBLK(KIALT).NE.0) THEN
            EQUAL = .FALSE.
            ITMP = KHCTP+(K-1)*INC
            CALL H2CHR (4, 1, S4B(ITMP), CTEMP)
            DO 105 J = 1,3
               IF (.NOT.EQUAL) EQUAL = FCHARS(J).EQ.CTEMP(:4)
 105           CONTINUE
            IF (EQUAL) THEN
               IF (RSGN(K).LT.0) THEN
                  CATR(KRARP) = TRC(K) - CATR(KRARP) + 1.0
               ELSE
                  CATR(KRARP) = CATR(KRARP) - BLC(K) + 1.0
                  END IF
               END IF
            END IF
 110     CONTINUE
C                                       create the output map
      CATBLK(KIIMS) = OUTSEQ + 0.01
      FVOL(2) = IROUND (OUTDSK)
      FRW(2) = 2
      CALL CHR2H (12, OUTNAM, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, OUTCLS, KHIMCO, CATH(KHIMC))
      CALL MCREAT (FVOL(2), FCNO(2), WORK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110)
         CALL MSGWRT (8)
         GO TO 999
         END IF
      NCFILE = 2
C                                       copy keywords
      CALL KEYCOP (FVOL(1), FCNO(1), FVOL(2), FCNO(2), IERR)
C                                       History file create & add
      CALL HIINIT (3)
      CALL HISCOP (LUNH1, LUNH2, FVOL(1), FVOL(2), FCNO(1), FCNO(2),
     *   CATBLK, WORK(257), WORK, IERR)
      IF (IERR.GE.3) GO TO 130
      CALL HENCO1 (PRGNAM, INNAME, INCLAS, ISEQ, FVOL(1), LUNH2,
     *   WORK, IERR)
      IF (IERR.NE.0) GO TO 130
      CALL HENCOO (PRGNAM, OUTNAM, OUTCLS, CATBLK(KIIMS), FVOL(2),
     *   LUNH2, WORK, IERR)
      IF (IERR.NE.0) GO TO 130
      WRITE (MSGTXT,1120) PRGNAM, BLC
      CALL HIADD (LUNH2, MSGTXT, WORK, IERR)
      IF (IERR.NE.0) GO TO 130
      WRITE (MSGTXT,1121) PRGNAM, TRC
      CALL HIADD (LUNH2, MSGTXT, WORK, IERR)
      IF (IERR.NE.0) GO TO 130
      WRITE (MSGTXT,1122) PRGNAM, OPCODE
      CALL HIADD (LUNH2, MSGTXT, WORK, IERR)
 130  CALL HICLOS (LUNH2, T, WORK, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUNH1, LUNH2, FVOL(1), FVOL(2),
     *   FCNO(1), FCNO(2), CATBLK, WORK(257), WORK, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
      IERR = 0
      GO TO 999
C                                       Error in parse
 900  WRITE (MSGTXT,1900) OPCODE
      CALL MSGWRT (8)
      IERR = 2
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FAILS TO GET PARMS FROM AIPS')
 1010 FORMAT ('FAILS TO FIND AND OPEN INPUT IMAGE')
 1110 FORMAT ('FAILS TO CREATE OUTPUT IMAGE')
 1120 FORMAT (A6,'BLC= ',6(F5.0,','),F5.0,' / Input image')
 1121 FORMAT (A6,'TRC= ',6(F5.0,','),F5.0,' / Input image')
 1122 FORMAT (A6,'TRANCOD=''',A14,''' / Output axis order')
 1900 FORMAT ('IMPROPER TRANSPOSITION CODE ',A14)
      END
      SUBROUTINE TRAROW (IAX, NBUF1, NBUF2, RBUF1, RBUF2, IERR)
C-----------------------------------------------------------------------
C   TRAROW transposes axes 2, 3, 4, 5, 6, and 7 with each other
C   performing sub-imaging, order reversal, etc. on the way.
C   An especially difficult swap is one in which there is more than 1
C   row/sector and axis 2 is switching with axes 3, 4, 5, 6, or 7.
C   For this case, the routine assumes that any subimaging, order
C   reversal, etc has already been done.  Note this well!!!!!
C   Input:
C      IAX    I(7)   IAX(out axis #) = in axis # (n.b. IAX(1)=1
C                       required by this subroutine)
C   Output:
C      IERR   I      Error code: > 0 => quit
C   Common /TRACOM/ mostly:
C      DONMAX  >0 => max/min known, use NPI as input/output img size
C              =0 => max/min must be found.  Use NPI as input size,
C                    NSI as output size, & use BLC,TRC on the input
C      NPI(7) # points on input axes 1 - 7
C      NSI(7) # points desired on input axes 1 - 7 = (TRC-BLC+1)
C      INLUN, ININD   input file already open
C      OUTLUN, OUTIND  output file already open
C   Only DONMAX is alterred by this subroutine.
C-----------------------------------------------------------------------
      INTEGER   IAX(7), NBUF1, NBUF2, IERR
      REAL      RBUF1(*), RBUF2(*)
C
      INTEGER   JAX(7), IS(7), IOF(7), IWIN(4), IDEPTH(5), JDEPTH(5),
     *   IXL, I3A, I3B, I4A, I4B, I5A, I5B, I6A, I6B, I7A, I7B, I3, I4,
     *   I5, I6, I7, NX, NY, IB, NBYTES, BLKLX, IBLKOF, ISC, IRC, IDX,
     *   OWIN(4), IYL, NVPBUF, OBLKOF, NPST(7), OUTPOS, OBZERO, IBZERO,
     *   OUTPS0, I, I0, I2, IL, NYO, NYI, IYI, INBYTS, INPOS, IYI1, IYO,
     *   IYO1, J, NRIPS, NRIR, NS1, NS2, NV1, NV2, NVPS, NPL, LBYTES,
     *   JJO, JJ3, II3
      REAL      R
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'TRANS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA OWIN /4*0/
C-----------------------------------------------------------------------
C                                       Compute addressing pointers
      IDX = 0
C                                       Windows, more addr. pointers
      IF (DONMAX.LE.0) THEN
         IXL = 0
         I3A = BLC(3) + 0.01
         I4A = BLC(4) + 0.01
         I5A = BLC(5) + 0.01
         I6A = BLC(6) + 0.01
         I7A = BLC(7) + 0.01
         I3B = TRC(3) + 0.01
         I4B = TRC(4) + 0.01
         I5B = TRC(5) + 0.01
         I6B = TRC(6) + 0.01
         I7B = TRC(7) + 0.01
         IWIN(1) = BLC(1) + 0.01
         IWIN(2) = BLC(2) + 0.01
         IWIN(3) = TRC(1) + 0.01
         IWIN(4) = TRC(2) + 0.01
         DO 15 I = 1,7
            IF (IAX(I).NE.I) IXL = 1
            NPST(I) = NSI(IAX(I))
            JAX(IAX(I)) = I
            IS(I) = 1
            IOF(I) = -BLC(I) - 0.01
            IF (RSGN(I).GT.0) GO TO 15
               IS(I) = -1
               IOF(I) = IOF(I) + 1 - NSI(I)
 15         CONTINUE
         IF (IXL.EQ.0) THEN
            MSGTXT = 'Begin subimaging'
         ELSE
            MSGTXT = 'Begin row swap with subimaging'
            END IF
         CALL MSGWRT (2)
      ELSE
         MSGTXT = 'Begin row swap'
         CALL MSGWRT (2)
         I3A = 1
         I4A = 1
         I5A = 1
         I6A = 1
         I7A = 1
         I3B = MAX (1, NPI(3))
         I4B = MAX (1, NPI(4))
         I5B = MAX (1, NPI(5))
         I6B = MAX (1, NPI(6))
         I7B = MAX (1, NPI(7))
         IWIN(1) = 1
         IWIN(2) = 1
         IWIN(3) = NPI(1)
         IWIN(4) = NPI(2)
         DO 25 I = 1,7
            NPST(I) = NPI(IAX(I))
            JAX(IAX(I)) = I
            IS(I) = 1
            IOF(I) = -1
            IF (RSGN(I).LE.0) THEN
               IS(I) = -1
               IOF(I) = -NPI(I)
               END IF
 25         CONTINUE
         END IF
C                                       x-axis handling code
      IXL = 1
      IF (RSGN(1).LE.0) IXL = IXL + 1
      IF (DONMAX.LE.0) IXL = IXL + 2
      IB = 2
      NX = IWIN(3) - IWIN(1) + 1
      NY = IWIN(4) - IWIN(2) + 1
      NBYTES = NX * 2
      BLKLX = 1 + (NBYTES-1)/NBPS
      NBYTES = BLKLX * NBPS
C                                       Type of write to use
      IYL = 1
      IF (IAX(2).NE.2) IYL = 2
      IF ((NX*2.LE.NBPS/2) .AND. (IAX(2).NE.2)) GO TO 500
C                                       Read Y backwards?
      IF (RSGN(2).LE.0) THEN
         I = IWIN(2)
         IWIN(2) = IWIN(4)
         IWIN(4) = I
         END IF
      IF (IYL.GT.1) THEN
         NVPBUF = NBYTES / 2
         IRC = BLKLX
C                                       can we do multipl planes?
         NPL = (NBUF1 / 2) / (NVPBUF * NY)
      ELSE
         NPL = 1
         END IF
C                                       NO or plane swap
      IF ((NPL.LT.2) .OR. (IYL.LE.1)) THEN
C                                       READ LOOP: plane by plane
         DO 150 I7 = I7A,I7B
         DO 149 I6 = I6A,I6B
         DO 148 I5 = I5A,I5B
         DO 147 I4 = I4A,I4B
         DO 146 I3 = I3A,I3B
C                                       set up read op
            IDEPTH(1) = I3
            IDEPTH(2) = I4
            IDEPTH(3) = I5
            IDEPTH(4) = I6
            IDEPTH(5) = I7
            CALL COMOFF (CATBLK(KIDIM), NPI, IDEPTH, IBLKOF, IERR)
            IF (IERR.NE.0) GO TO 999
            IBLKOF = IBLKOF + 1
            CALL MINIT ('READ', INLUN, ININD, NPI(1), NPI(2), IWIN,
     *         RBUF2, NBUF2, IBLKOF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1100) IERR, I3, I4
               GO TO 990
               END IF
C                                       prepare write parms
            DO 110 I = 3,7
               J = JAX(I) - 2
               IF (J.GT.0) JDEPTH(J) = (IDEPTH(I-2)+IOF(I))*IS(I) + 1
 110           CONTINUE
C                                       Use MINIT for plane swaps
            IF (IYL.LE.1) THEN
               CALL COMOFF (CATBLK(KIDIM), NPST, JDEPTH, OBLKOF, IERR)
               IF (IERR.NE.0) GO TO 999
               OBLKOF = OBLKOF + 1
               CALL MINIT ('WRIT', OUTLUN, OUTIND, NX, NY, OWIN, RBUF1,
     *            NBUF1, OBLKOF, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1110) IERR
                  GO TO 990
                  END IF
               END IF
C                                       LOOP: over rows
            DO 145 I2 = 1,NY
C                                       read a row
               CALL MDISK ('READ', INLUN, ININD, RBUF2, INPOS, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1115) IERR
                  GO TO 990
                  END IF
C                                       plane swaps
               IF (IYL.EQ.1) THEN
                  CALL MDISK ('WRIT', OUTLUN, OUTIND, RBUF1, OUTPOS,
     *               IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1120) IERR
                     GO TO 990
                     END IF
C                                       last write done ?
               ELSE
                  IB = 3 - IB
                  IF (IDX.GE.2) THEN
                     CALL ZWAIT (OUTLUN, OUTIND, IB, IERR)
                     IF (IERR.NE.0) THEN
                        WRITE (MSGTXT,1120) IERR
                        GO TO 990
                        END IF
                     END IF
C                                       block to write
                  JDEPTH(JAX(2)-2) = I2
                  CALL COMOFF (CATBLK(KIDIM), NPST, JDEPTH, OBLKOF,
     *               IERR)
                  IF (IERR.NE.0) GO TO 999
                  IF (IDX.LT.10) IDX = IDX + 1
                  I = IAX(2)
                  ISC = (IDEPTH(I-2)+IOF(I))*IS(I)
                  OUTPOS = 1 + (IB-1) * NVPBUF
                  ISC = IRC * ISC
                  OBLKOF = OBLKOF + ISC
                  OBLKOF = OBLKOF + 1
                  END IF
C                                       move X row
C                                       real, forward
               IF (IXL.EQ.1) THEN
                  CALL RCOPY (NX, RBUF2(INPOS), RBUF1(OUTPOS))
C                                       real, backward
               ELSE IF (IXL.EQ.2) THEN
                  J = INPOS + NX
                  DO 115 I = 1,NX
                     RBUF1(OUTPOS+I-1) = RBUF2(J-I)
 115                 CONTINUE
C                                       real, forward
               ELSE IF (IXL.EQ.3) THEN
                  J = INPOS - 1
                  DO 120 I = 1,NX
                     R = RBUF2(J+I)
                     RBUF1(OUTPOS+I-1) = R
                     IF (R.NE.FBLANK) THEN
                        RMAX = MAX (R, RMAX)
                        RMIN = MIN (R, RMIN)
                        END IF
 120                 CONTINUE
C                                       real, backward
               ELSE IF (IXL.EQ.4) THEN
                  J = INPOS + NX
                  DO 125 I = 1,NX
                     R = RBUF2(J-I)
                     RBUF1(OUTPOS+I-1) = R
                     IF (R.NE.FBLANK) THEN
                        RMAX = MAX (R, RMAX)
                        RMIN = MIN (R, RMIN)
                        END IF
 125                 CONTINUE
                  END IF
C                                       Write the row
               IF (IYL.NE.1) THEN
                  CALL ZMIO ('WRIT', OUTLUN, OUTIND, OBLKOF, NBYTES,
     *               RBUF1(OUTPOS), IB, IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1220) IERR
                     GO TO 990
                     END IF
                  END IF
 145           CONTINUE
            IF (IYL.EQ.1) THEN
               CALL MDISK ('FINI', OUTLUN, OUTIND, RBUF1, OUTPOS, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1120) IERR
                  GO TO 990
                  END IF
               END IF
 146        CONTINUE
 147        CONTINUE
 148        CONTINUE
 149        CONTINUE
 150        CONTINUE
C                                       Wait for all writes to finish
         IF (IYL.NE.1) THEN
            IB = 3 - IB
            CALL ZWAIT (OUTLUN, OUTIND, IB, IERR)
            IB = 3 - IB
            IF (IERR.EQ.0) CALL ZWAIT (OUTLUN, OUTIND, IB, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1250) IERR
               GO TO 990
               END IF
            END IF
C                                       READ LOOP: multiple planes
      ELSE
         DO 290 I7 = I7A,I7B
         DO 289 I6 = I6A,I6B
         DO 288 I5 = I5A,I5B
         DO 287 I4 = I4A,I4B
         DO 286 I3 = I3A,I3B,NPL
            JJ3 = I3 + NPL - 1
            JJ3 = MIN (JJ3, I3B)
            LBYTES = NBYTES * (JJ3 - I3 + 1)
            IDEPTH(1) = I3
            IDEPTH(2) = I4
            IDEPTH(3) = I5
            IDEPTH(4) = I6
            IDEPTH(5) = I7
            DO 250 II3 = I3,JJ3
C                                       set up read op
               IDEPTH(1) = II3
               CALL COMOFF (CATBLK(KIDIM), NPI, IDEPTH, IBLKOF, IERR)
               IF (IERR.NE.0) GO TO 999
               IBLKOF = IBLKOF + 1
               CALL MINIT ('READ', INLUN, ININD, NPI(1), NPI(2), IWIN,
     *            RBUF2, NBUF2, IBLKOF, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1100) IERR, I3, I4
                  GO TO 990
                  END IF
C                                       prepare write parms
               DO 210 I = 3,7
                  J = JAX(I) - 2
                  IF (J.GT.0) JDEPTH(J) = (IDEPTH(I-2)+IOF(I))*IS(I) + 1
 210              CONTINUE
C                                       LOOP: over rows
               IF (RSGN(3).LE.0) THEN
                  JJO = (JJ3-II3) * NBYTES/2 + 1
               ELSE
                  JJO = (II3-I3) * NBYTES/2 + 1
                  END IF
               DO 245 I2 = 1,NY
C                                       read a row
                  CALL MDISK ('READ', INLUN, ININD, RBUF2, INPOS, IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1115) IERR
                     GO TO 990
                     END IF
C                                       set outpos
                  OUTPOS = JJO + (I2-1) * LBYTES/2
C                                       move X row
C                                       real, forward
                  IF (IXL.EQ.1) THEN
                     CALL RCOPY (NX, RBUF2(INPOS), RBUF1(OUTPOS))
C                                       real, backward
                  ELSE IF (IXL.EQ.2) THEN
                     J = INPOS + NX
                     DO 220 I = 1,NX
                        RBUF1(OUTPOS+I-1) = RBUF2(J-I)
 220                    CONTINUE
C                                       real, forward
                  ELSE IF (IXL.EQ.3) THEN
                     J = INPOS - 1
                     DO 230 I = 1,NX
                        R = RBUF2(J+I)
                        RBUF1(OUTPOS+I-1) = R
                        IF (R.NE.FBLANK) THEN
                           RMAX = MAX (R, RMAX)
                           RMIN = MIN (R, RMIN)
                           END IF
 230                    CONTINUE
C                                       real, backward
                  ELSE IF (IXL.EQ.4) THEN
                     J = INPOS + NX
                     DO 240 I = 1,NX
                        R = RBUF2(J-I)
                        RBUF1(OUTPOS+I-1) = R
                        IF (R.NE.FBLANK) THEN
                           RMAX = MAX (R, RMAX)
                           RMIN = MIN (R, RMIN)
                           END IF
 240                    CONTINUE
                     END IF
 245              CONTINUE
 250           CONTINUE
C                                       now do writes
C                                       prepare write parms
C                                       LOOP: over rows
            DO 270 I2 = 1,NY
               INPOS = 1 + (I2 - 1) * LBYTES/2
               IB = 3 - IB
               IF (IDX.GE.2) THEN
                  CALL ZWAIT (OUTLUN, OUTIND, IB, IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1120) IERR
                     GO TO 990
                     END IF
                  END IF
C                                      block to write
               JDEPTH(JAX(2)-2) = I2
               CALL COMOFF (CATBLK(KIDIM), NPST, JDEPTH, OBLKOF, IERR)
               IF (IERR.NE.0) GO TO 999
               IF (IDX.LT.10) IDX = IDX + 1
               I = IAX(2)
               IF (I.EQ.3) THEN
C                  ISC = (I3 + IOF(I)) * IS(I)
                  ISC = I3 - 1
               ELSE
                  ISC = (IDEPTH(I-2) + IOF(I)) * IS(I)
                  END IF
               ISC = IRC * ISC
               OBLKOF = OBLKOF + ISC
               OBLKOF = OBLKOF + 1
C                                       Write the row
               CALL ZMIO ('WRIT', OUTLUN, OUTIND, OBLKOF, LBYTES,
     *            RBUF1(INPOS), IB, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1220) IERR
                  GO TO 990
                  END IF
 270           CONTINUE
 286        CONTINUE
 287        CONTINUE
 288        CONTINUE
 289        CONTINUE
 290        CONTINUE
C                                       Wait for all writes to finish
         IB = 3 - IB
         CALL ZWAIT (OUTLUN, OUTIND, IB, IERR)
         IB = 3 - IB
         IF (IERR.EQ.0) CALL ZWAIT (OUTLUN, OUTIND, IB, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1250) IERR
            GO TO 990
            END IF
         END IF
      IF (DONMAX.EQ.0) DONMAX = 1
      GO TO 999
C                                       Special case: short row move
C                                       No subimaging!
 500  IL = NBPS / (NX * 2)
      NV2 = NBUF2 / 2
      NV1 = NBUF1 / 2
      NVPS = NBPS / 2
      NS1 = NV1 / NVPS
      NS2 = NV2 / NVPS
C                                       Nullify relevant outer loop
      IF (IAX(2).EQ.3) THEN
         NYO = I3B
         I3B = 1
      ELSE IF (IAX(2).EQ.4) THEN
         NYO = I4B
         I4B = 1
      ELSE IF (IAX(2).EQ.5) THEN
         NYO = I5B
         I5B = 1
      ELSE IF (IAX(2).EQ.6) THEN
         NYO = I6B
         I6B = 1
      ELSE IF (IAX(2).EQ.7) THEN
         NYO = I7B
         I7B = 1
         END IF
C                                       Input buffer big enough?
 510  IF (NS1.LE.(NS2-1)/IL+2) THEN
         NS2 = NS2 - 1
         GO TO 510
         END IF
      NYI = NPI(2)
C                                       Outer loops over most things
      DO 570 I7 = I7A,I7B
      DO 569 I6 = I6A,I6B
      DO 568 I5 = I5A,I5B
      DO 567 I4 = I4A,I4B
      DO 566 I3 = I3A,I3B
         IDEPTH(1) = I3
         IDEPTH(2) = I4
         IDEPTH(3) = I5
         IDEPTH(4) = I6
         IDEPTH(5) = I7
         DO 520 I = 3,7
            J = JAX(I) - 2
            IF (J.GT.0) JDEPTH(J) = IDEPTH(I-2)
 520        CONTINUE
C                                       Loop over sectors output ax 2
         DO 560 IYO = 1,NYO,IL
            NRIPS = MIN (IL, NYO-IYO+1)
            OBZERO = (IYO-1) / IL + 1
C                                       Loop over input ax 2 by output
C                                       buffer's full size
            DO 550 IYI = 1,NYI,NS2
               NRIR = MIN (NS2, NYI-IYI+1)
               I0 = (IYI-1) / IL
               J = (IYI+NRIR-2) / IL
               INBYTS = (J - I0 + 1) * NBPS
               IBZERO = I0 + 1
C                                       Fill output buffer by reading
C                                       NRIR rows from each of NRIPS
C                                       planes
               DO 535 IYO1 = 1,NRIPS
                  IDEPTH(IAX(2)-2) = IYO + IYO1 - 1
                  CALL COMOFF (CATBLK(KIDIM), NPI, IDEPTH, IBLKOF, IERR)
                  IBLKOF = IBLKOF + IBZERO
                  CALL ZMIO ('READ', INLUN, ININD, IBLKOF, INBYTS,
     *               RBUF1, 1, IERR)
                  IF (IERR.EQ.0) CALL ZWAIT (INLUN, ININD, 1, IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1115) IERR
                     GO TO 990
                     END IF
                  OUTPS0 = (IYO1 - 1) * NX + 1
                  DO 530 IYI1 = 1,NRIR
                     I = IYI + IYI1 - 1
                     INPOS = 1 + NX * MOD (I-1, IL) + NVPS *
     *                  ((I-1)/IL - I0)
                     OUTPOS = OUTPS0 + (IYI1-1) * NVPS
                     CALL RCOPY (NX, RBUF1(INPOS), RBUF2(OUTPOS))
 530                 CONTINUE
 535              CONTINUE
C                                       Write out completed sectors
               DO 540 IYI1 = 1,NRIR
                  OUTPOS = 1 + (IYI1 - 1) * NBPS / 2
                  JDEPTH(JAX(2)-2) = IYI + IYI1 - 1
                  CALL COMOFF (CATBLK(KIDIM), NPST, JDEPTH, OBLKOF,
     *               IERR)
                  OBLKOF = OBLKOF + OBZERO
                  CALL ZMIO ('WRIT', OUTLUN, OUTIND, OBLKOF, NBPS,
     *               RBUF2(OUTPOS), 1, IERR)
                  IF (IERR.EQ.0) CALL ZWAIT (OUTLUN, OUTIND, 1, IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1120) IERR
                     GO TO 990
                     END IF
 540              CONTINUE
 550           CONTINUE
 560        CONTINUE
 566     CONTINUE
 567     CONTINUE
 568     CONTINUE
 569     CONTINUE
 570     CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('TRAROW: IO ERROR ON INIT READ',3I7)
 1110 FORMAT ('TRAROW: IO ERROR MINI3 WRITE',I7)
 1115 FORMAT ('TRAROW: IO ERROR ON READ',I7)
 1120 FORMAT ('TRAROW: IO ERROR ON WRITE',I7)
 1220 FORMAT ('TRAROW: IO ERROR ON INIT WRITE',I7)
 1250 FORMAT ('TRAROW: IO ERROR ON LAST WRITE',I7)
      END
      SUBROUTINE TRAXPO (IAX, NBUF1, NBUF2, RBUF1, RBUF2, IERR)
C-----------------------------------------------------------------------
C   TRAXPO performs the axis 1 with axis 2 transposition either in
C   core or with a two-pass disk-based method.  At the same time it
C   can swap axes 3 through 7 with themselves.  It does not perform
C   subarray selection nor find the output max/min.  These, if
C   needed, must be done first via a pass through TRAROW.
C   Inputs:
C      IAX     I(7)   IAX(output axis #) = input axis number
C      NBUF1   I      Size of 1st buffer in AIPS bytes
C      NBUF2   I      Size of 1st buffer in AIPS bytes
C   Output:
C      RBUF1   R(*)   I/O buffer (larger)
C      RBUF2   R(*)   I/O buffer (smaller)
C      IERR    I      IO error codes: >0 => quit
C-----------------------------------------------------------------------
      INTEGER   IAX(7), NBUF1, NBUF2, IERR
      REAL      RBUF1(*), RBUF2(*)
C
      INTEGER   JAX(7), IS(7), IOF(7), NPST(7), NBYPV, NVPS, NV1, NV2,
     *   NX, NY, AXI1, AXI2, NRI, NRO, IWIN(4), JWIN(4), IDEPTH(5),
     *   IBLKOF, OBLKOF, AXO1, AXO2, INPOS, NVGR, NGR, LUNSCR, INDSCR,
     *   ILX1, ILX2, ILY1, ILY2, NRM, NB, IOFF, JOFF, KOFF, NWM, NGPS,
     *   LSECT, NSECT, NXGR, NYGR, I, J, K, I2, I3, I4, I5, I6, I7,
     *   I3B, I4B, I5B, I6B, I7B, OUTPOS, BLKLX, JDEPTH(5), I1, I1B,
     *   IER, NBYTES, ISIZE, NSPGG, NSOFF, IGR, IGR0
      CHARACTER PHNAME*48
      LOGICAL   T
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'TRANS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
      INDSCR = 0
C                                       Get reverse of IAX
      DO 10 I = 1,7
         JAX(IAX(I)) = I
         NPST(I) = NPI(IAX(I))
         IF (RSGN(I).GT.0) THEN
            IS(I) = 1
            IOF(I) = 0
         ELSE
            IS(I) = -1
            IOF(I) = -1 - NPI(I)
            END IF
 10      CONTINUE
C                                       Outer DO loop limits, counters
      I3B = MAX (1, NPI(3))
      I4B = MAX (1, NPI(4))
      I5B = MAX (1, NPI(5))
      I6B = MAX (1, NPI(6))
      I7B = MAX (1, NPI(7))
C                                       Buffer sizes etc
      NBYPV = 2
      NVPS = NBPS / NBYPV
      NV1 = NBUF1 / NBYPV
      NV2 = NBUF2 / NBYPV
      NX = NPI(1)
      NY = NPI(2)
      BLKLX = (NY*NBYPV - 1) / NBPS + 1
      IF (NX*NBYPV.LE.NBPS/2) THEN
         ILX1 = NBPS / (NX * NBYPV)
         AXI1 = NX
         AXI2 = NVPS
      ELSE
         ILX1 = 1
         AXI1 = 0
         AXI2 = (1 + (NX-1)/NVPS) * NVPS
         END IF
      ILX2 = ((NV2 / 2) / AXI2) * 2
      NRI = ILX1 * ILX2
C                                       In core transpose!
      IF (NY.GT.NRI) GO TO 100
         IWIN(1) = 1
         IWIN(2) = 1
         WRITE (MSGTXT,1020)
         CALL MSGWRT (2)
         DO 90 I7 = 1,I7B
         DO 89 I6 = 1,I6B
         DO 88 I5 = 1,I5B
         DO 87 I4 = 1,I4B
         DO 86 I3 = 1,I3B
            IWIN(3) = NX
            IWIN(4) = NY
            IDEPTH(1) = I3
            IDEPTH(2) = I4
            IDEPTH(3) = I5
            IDEPTH(4) = I6
            IDEPTH(5) = I7
            CALL COMOFF (CATBLK(KIDIM), NPI, IDEPTH, IBLKOF, IERR)
            IF (IERR.NE.0) GO TO 999
            IBLKOF = IBLKOF + 1
            CALL MINIT ('READ', INLUN, ININD, NX, NY, IWIN, RBUF2,
     *         NBUF2, IBLKOF, IERR)
            IF (IERR.EQ.0) GO TO 24
               WRITE (MSGTXT,1024) IERR
               GO TO 990
C                                       Write bias in file
 24         DO 25 I = 3,7
               JDEPTH(JAX(I)-2) = (IDEPTH(I-2) + IOF(I))*IS(I)
 25            CONTINUE
            CALL COMOFF (CATBLK(KIDIM), NPST, JDEPTH, OBLKOF, IERR)
            IF (IERR.NE.0) GO TO 999
            OBLKOF = OBLKOF + 1
C                                       Read full plane
            DO 30 I = 1,NY
               CALL MDISK ('READ', INLUN, ININD, RBUF2, INPOS, IERR)
               IF (IERR.EQ.0) GO TO 30
                  WRITE (MSGTXT,1025) I,INPOS,IERR
                  GO TO 990
 30            CONTINUE
C                                       Write full plane
            IWIN(3) = NY
            IWIN(4) = NX
            CALL MINIT ('WRIT', OUTLUN, OUTIND, NY, NX, IWIN, RBUF1,
     *         NBUF1, OBLKOF, IERR)
            IF (IERR.EQ.0) GO TO 34
               WRITE (MSGTXT,1034) IERR
               GO TO 990
 34         DO 80 I = 1,NX
               CALL MDISK ('WRIT', OUTLUN, OUTIND, RBUF1, OUTPOS, IERR)
               IF (IERR.EQ.0) GO TO 35
                  WRITE (MSGTXT,1030) IERR
                  GO TO 990
 35            IF (ILX1.GT.1) GO TO 55
                  IOFF = I - AXI2
                  DO 50 J = 1,NY
                     IOFF = IOFF + AXI2
                     RBUF1(OUTPOS+J-1) = RBUF2(IOFF)
 50                  CONTINUE
                  GO TO 80
 55            CONTINUE
                  J = 0
                  DO 70 I2 = 1,ILX2
                     IOFF = I - AXI1 + (I2-1) * AXI2
                     DO 69 I1 = 1,ILX1
                        IOFF = IOFF + AXI1
                        RBUF1(OUTPOS+J) = RBUF2(IOFF)
                        J = J + 1
                        IF (J.EQ.NY) GO TO 80
 69                     CONTINUE
 70                  CONTINUE
 80            CONTINUE
            CALL MDISK ('FINI', OUTLUN, OUTIND, RBUF1, INPOS, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1030) IERR
               GO TO 990
               END IF
 86         CONTINUE
 87         CONTINUE
 88         CONTINUE
 89         CONTINUE
 90         CONTINUE
         GO TO 999
C                                       HARD CASE!!!
C                                       need a scratch file, 2 passes
 100  WRITE (MSGTXT,1100)
      CALL MSGWRT (2)
      IF (NY*NBYPV.GT.NBPS/2) GO TO 105
         ILY1 = NBPS / (NY * NBYPV)
         AXO1 = NY
         AXO2 = NVPS
         GO TO 110
 105  CONTINUE
         ILY1 = 1
         AXO1 = 0
         AXO2 = (1 + (NY-1)/NVPS) * NVPS
 110  ILY2 = ((NV2 / 2) / AXO2) * 2
      NRO = ILY1 * ILY2
      NRI = ILX1 * ILX2
C                                       Compute size of blocks hold
C                                       NRI points of NRO output rows
      NVGR = (1 + (NRI*NRO - 1)/NVPS) * NVPS
      IF (NVGR.LE.NV1) GO TO 115
         ILX2 = ILX2 / 2
         ILY2 = ILY2 / 2
         GO TO 110
 115  NGR = (1 + (NY-1)/NRI) * (1 + (NX-1)/NRO)
      NGPS = NVPS / (NRI * NRO)
      IF (NGPS.GT.1) THEN
         NVGR = NRI * NRO
         NSPGG = 0
         ISIZE = (NGR / NGPS) * NVPS * NBYPV
      ELSE
         NSPGG = NVGR / NVPS
         ISIZE = NGR * NVGR * NBYPV
         END IF
C                                       Requires image < 4 Gbytes
      ISIZE = (ISIZE - 1) / 512 + 1
      CALL SCREAT (ISIZE, WORK, IERR)
      IF (IERR.NE.0) GO TO 999
      LUNSCR = OUTLUN + 1
      CALL ZPHFIL ('SC', SCRVOL(NSCR), SCRCNO(NSCR), 1, PHNAME, IERR)
      CALL ZOPEN (LUNSCR, INDSCR, SCRVOL(NSCR), PHNAME, T, T, T, IERR)
      IF (IERR.NE.0) GO TO 999
      JWIN(1) = 1
      JWIN(2) = 1
      JWIN(3) = NVGR
      JWIN(4) = NGR
      IWIN(1) = 1
      DO 250 I7 = 1,I7B
      DO 249 I6 = 1,I6B
      DO 248 I5 = 1,I5B
      DO 247 I4 = 1,I4B
      DO 246 I3 = 1,I3B
C                                       Read file depth
         IDEPTH(1) = I3
         IDEPTH(2) = I4
         IDEPTH(3) = I5
         IDEPTH(4) = I6
         IDEPTH(5) = I7
         CALL COMOFF (CATBLK(KIDIM), NPI, IDEPTH, IBLKOF, IERR)
         IF (IERR.NE.0) GO TO 995
         IBLKOF = IBLKOF + 1
C                                       Out file depth
         DO 120 I = 3,7
            JDEPTH(JAX(I)-2) = (IDEPTH(I-2)+IOF(I)) * IS(I)
 120        CONTINUE
         CALL COMOFF (CATBLK(KIDIM), NPST, JDEPTH, OBLKOF, IERR)
         IF (IERR.NE.0) GO TO 995
         OBLKOF = OBLKOF + 1
C                                       Init scratch for write
         CALL MINIT ('WRIT', LUNSCR, INDSCR, NVGR, NGR, JWIN, RBUF1,
     *      NBUF1, 1, IERR)
         IF (IERR.EQ.0) GO TO 125
            WRITE (MSGTXT,1120) IERR
            GO TO 990
C                                       Pass 1: build scratch of NRI
C                                       points for each of NRO rows
C                                       in each scratch "row"
 125     DO 190 I2 = 1,NY,NRI
            IWIN(2) = I2
            NRM = MIN (NY-I2+1, NRI)
            IWIN(4) = I2 + NRM - 1
            IWIN(3) = NX
            CALL MINIT ('READ', INLUN, ININD, NX, NY, IWIN, RBUF2,
     *         NBUF2, IBLKOF, IERR)
            IF (IERR.EQ.0) GO TO 130
               WRITE (MSGTXT,1125) IERR
               GO TO 990
C                                       read in the NRI rows
 130        DO 135 I = 1,NRM
               CALL MDISK ('READ', INLUN, ININD, RBUF2, INPOS, IERR)
               IF (IERR.EQ.0) GO TO 135
                  WRITE (MSGTXT,1025) IERR
                  GO TO 990
 135           CONTINUE
            NB = (NX*NRI-1) / (NRO*NRI) + 1
            IOFF = 0
            DO 185 I = 1,NB
               CALL MDISK ('WRIT', LUNSCR, INDSCR, RBUF1, OUTPOS, IERR)
               IF (IERR.EQ.0) GO TO 140
                  WRITE (MSGTXT,1135) IERR
                  GO TO 990
 140           JOFF = OUTPOS - NRI - 1
               DO 180 K = 1,NRO
                  IOFF = IOFF + 1
                  IF (IOFF.GT.NX) GO TO 190
                     KOFF = IOFF - AXI2
                     JOFF = JOFF + NRI
                     IF (ILX1.GT.1) GO TO 160
                        DO 155 J = 1,NRM
                           KOFF = KOFF + AXI2
                           RBUF1(JOFF+J) = RBUF2(KOFF)
 155                       CONTINUE
                        GO TO 180
 160                 CONTINUE
                        J = 0
                        DO 175 I1B = 1,ILX2
                           KOFF = IOFF + (I1B-1)*AXI2 - AXI1
                           DO 174 I1 = 1,ILX1
                              J = J + 1
                              KOFF = KOFF + AXI1
                              RBUF1(JOFF+J) = RBUF2(KOFF)
                              IF (J.EQ.NRM) GO TO 180
 174                          CONTINUE
 175                       CONTINUE
 180              CONTINUE
 185           CONTINUE
 190        CONTINUE
         CALL MDISK ('FINI', LUNSCR, INDSCR, RBUF1, OUTPOS, IERR)
         IF (IERR.EQ.0) GO TO 200
            WRITE (MSGTXT,1135) IERR
            GO TO 990
C                                       Parms for reading scratch file
 200     NBYTES = MAX (NVGR, NVPS) * NBYPV
         NXGR = 1 + (NX-1)/NRO
         NYGR = 1 + (NY-1)/NRI
         IGR0 = 0
         LSECT = -1000
         DO 245 I2 = 1,NX,NRO
            IWIN(3) = NY
            IWIN(2) = I2
            NWM = MIN (NX-I2+1, NRO)
            IWIN(4) = I2 + NWM - 1
            CALL MINIT ('WRIT', OUTLUN, OUTIND, NY, NX, IWIN, RBUF2,
     *         NBUF2, OBLKOF, IERR)
            IF (IERR.EQ.0) GO TO 205
               WRITE (MSGTXT,1200) IERR
               GO TO 990
C                                       Read all groups having data
C                                       for rows I2 - I2+NRO-1
 205        IGR0 = IGR0 + 1
            IGR = IGR0 - NXGR
            NB = (NY * NRO - 1) / (NRO*NRI) + 1
            DO 230 I = 1,NB
               IGR = IGR + NXGR
               IF (NGPS.GT.1) THEN
                  NSECT = (IGR-1) / NGPS + 1
                  NSOFF = MOD (IGR-1, NGPS) * NVGR + 1
               ELSE
                  NSECT = (IGR - 1) * NSPGG + 1
                  NSOFF = 1
                  END IF
               IF (NSECT.NE.LSECT) THEN
                  LSECT = NSECT
                  CALL ZMIO ('READ', LUNSCR, INDSCR, NSECT, NBYTES,
     *               RBUF1, 1, IERR)
                  IF (IERR.EQ.0) CALL ZWAIT (LUNSCR, INDSCR, 1, IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1205) IERR
                     GO TO 990
                     END IF
                  END IF
               IOFF = (I-1) * NRI + 1
               IF (IOFF.GT.NY) GO TO 235
               NRM = MIN (NRI, NY-IOFF+1)
               JOFF = NSOFF - NRI
               IF (ILY1.LE.1) THEN
                  IOFF = IOFF - AXO2
                  DO 215 K = 1,NWM
                     JOFF = JOFF + NRI
                     IOFF = IOFF + AXO2
                     CALL RCOPY (NRM, RBUF1(JOFF), RBUF2(IOFF))
 215                 CONTINUE
               ELSE
                  K = 0
                  DO 225 I1B = 1,ILY2
                     KOFF = IOFF + (I1B-1)*AXO2 - AXO1
                     DO 224 I1 = 1,ILY1
                        JOFF = JOFF + NRI
                        KOFF = KOFF + AXO1
                        CALL RCOPY (NRM, RBUF1(JOFF), RBUF2(KOFF))
                        K = K + 1
                        IF (K.EQ.NWM) GO TO 230
 224                    CONTINUE
 225                 CONTINUE
                  END IF
 230           CONTINUE
C                                       Write it all out
 235        DO 240 I = 1,NWM
               CALL MDISK ('WRIT', OUTLUN, OUTIND, RBUF2, INPOS, IERR)
               IF (IERR.EQ.0) GO TO 240
                  WRITE (MSGTXT,1030) IERR
                  GO TO 990
 240           CONTINUE
            CALL MDISK ('FINI', OUTLUN, OUTIND, RBUF2, INPOS, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1030) IERR
               GO TO 990
               END IF
 245        CONTINUE
 246     CONTINUE
 247     CONTINUE
 248     CONTINUE
 249     CONTINUE
 250     CONTINUE
      GO TO 995
C
 990  CALL MSGWRT (8)
C
 995  IF (INDSCR.GT.0) CALL ZCLOSE (LUNSCR, INDSCR, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('Begin in-core x-y transpose')
 1024 FORMAT ('TRAXPO: INIT INPUT READ ERROR',I7)
 1034 FORMAT ('TRAXPO: INIT OUTPUT WRITE ERROR',I7)
 1025 FORMAT ('TRAXPO: INPUT FILE READ ERROR',3I7)
 1030 FORMAT ('TRAXPO: OUTPUT FILE WRITE ERROR',3I7)
 1100 FORMAT ('Begin disk-based x-y transpose')
 1120 FORMAT ('TRAXPO: SCRATCH INIT WRITE ERROR',I7)
 1125 FORMAT ('TRAXPO: INPUT INIT READ ERROR',I7)
 1135 FORMAT ('TRAXPO: SCRATCH FILE WRITE ERROR',I7)
 1200 FORMAT ('TRAXPO: OUTPUT INIT WRITE ERROR',I7)
 1205 FORMAT ('TRAXPO: SCRATCH FILE READ ERROR',I7)
      END

      REAL FUNCTION MEDIAN (N, A)
C-----------------------------------------------------------------------
C! Finds the median using method due to Wirth
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 2010
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Find the median of an array
C   Use Niklaus Wirth's algorithm to find Kth ordered element in an
C   array.  From page 84 of: "Algorithms + Data Structures = Programs"
C   Input:
C      N        I      Length of array
C   In/out:
C      A        R(*)   Data array (will be reordered)
C
C   Input/output:
C      MEDIAN   R      The (N+1)/2 element
C-----------------------------------------------------------------------
      INTEGER   N
      REAL      A(*)
C
      REAL      NWIRTH
      INTEGER   K
C-----------------------------------------------------------------------
      K = (N + 1) / 2
      MEDIAN = NWIRTH (A, N, K)
C
 999  RETURN
      END
      REAL FUNCTION NWIRTH (A, N, K)
C-----------------------------------------------------------------------
C   Use Niklaus Wirth's algorithm to find Kth ordered element in an
C   array.  From page 84 of: "Algorithms + Data Structures = Programs"
C   Input:
C      N        I      Length of array
C      K        I
C   In/out:
C      A        R(*)   Data array (will be reordered)
C   Output:
C      NWIRTH   R      The Kth element in array A
C-----------------------------------------------------------------------
      INTEGER   N, K
      REAL      A(*)
C
      REAL      X, T
      INTEGER   I, J, L, M
C-----------------------------------------------------------------------
C                                       Standard FORTRAN goes 1:N
C                                       Wirth used 0:N-1
      L = 1
      M = N
 10   IF (L.LT.M) THEN
         X = A(K)
         I = L
         J = M
 20      IF (I.LE.J) THEN
 30         IF (A(I).LT.X) THEN
               I = I + 1
               GO TO 30
               END IF
 40         IF (X.LT.A(J)) THEN
               J = J - 1
               GO TO 40
               END IF
           IF (I.LE.J) THEN
               T = A(I)
               A(I) = A(J)
               A(J) = T
               I = I + 1
               J = J - 1
               END IF
            GO TO 20
            END IF
         IF (J.LT.K) L = I
         IF (K.LT.I) M = J
         GO TO 10
         END IF
C
      NWIRTH = A(K)
C
 999  RETURN
      END

LOCAL INCLUDE 'PPAPP.INC'
      INCLUDE 'INCS:PUVD.INC'
C
      CHARACTER NAMEIN*12, CLAIN*6, NAMIN2*12, CLAIN2*6
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAME2(3), XCLAI2(2)
      REAL      XSIN, XDISIN, XSIN2, XDISI2, XFQID, XSUBA, XINVER,
     *   XBPVER, XPDVER
      INTEGER   DISKIN, SEQIN, CNOIN, DISKI2, SEQIN2, CNOIN2,
     *   BUFFER(512), SUBARR, FRQSEL, BCHAN, BIF, INVERS, BPVER, PDVER,
     *   BPVOUT, PDVOUT, CPVER, CPVOUT, PPOL
C
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAME2, XCLAI2,
     *   XSIN2, XDISI2, XFQID, XSUBA, XINVER, XBPVER, XPDVER
      COMMON /CHPARM/ NAMEIN, CLAIN, NAMIN2, CLAIN2
      COMMON /INFOLS/ DISKIN, SEQIN, CNOIN, DISKI2, SEQIN2, CNOIN2,
     *   BUFFER, SUBARR, FRQSEL, BCHAN, BIF, INVERS, BPVER, PDVER,
     *   BPVOUT, PDVOUT, CPVER, CPVOUT, PPOL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
LOCAL END
      PROGRAM PPAPP
C-----------------------------------------------------------------------
C! PPAPP applies the Right - Left polarization phase difference
C# Calibration UV VLA VLB polarization
C-----------------------------------------------------------------------
C;  Copyright (C) 2019, 2021-2022, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task PPAPP applies the R-L phase difference spectrum to a 2nd UV
C   data set's BP table
C   Inputs:
C      AIPS Adverb   Prg. Name          Description
C      INNAME         NAME          File name to be corrected
C      INCLASS        CLASS         File class to be corrected
C      INSEQ          SEQ           File sequence number.
C      INDISK         DISK          Disk volume on which file resides.
C      IN2NAME        NAME          File name with PP table.
C      IN2CLASS       CLASS         File class
C      IN2SEQ         SEQ           File sequence number.
C      IN2DISK        DISK          Disk volume on which file resides.
C      FREQID         FRQSEL        Frequency ID number
C      SUBARRAY       SUBARR        Subarray
C      INVERS         INVERS        PP version
C      BPVER                        BP table to correct
C-----------------------------------------------------------------------
      INCLUDE 'PPAPP.INC'
      CHARACTER PRGM*6
      INTEGER   IRET, NCH, NIF
      DOUBLE PRECISION PHASES(MAXCIF)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'PPAPP '/
C-----------------------------------------------------------------------
C                                       Get input parameters
C                                       get correction
      CALL PPAPIN (PRGM, NCH, NIF, PHASES, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       apply correction
      CALL PPAPPL (NCH, NIF, PHASES, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       History file ??
      CALL PPAPHI (NCH, NIF)
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE PPAPIN (PRGN, NCH, NIF, PHASES, IRET)
C-----------------------------------------------------------------------
C   RLDIN gets input parameters for PPAPP
C   Inputs:
C      PRGN    C*6       Program name (2 chars/word)
C   Output:
C      NCH     I         Number channels in phases
C      NIF     I         Number IFs in phases
C      PHASES  D(*)      Phase correction in degrees
C      IRET    I         Error code: 0 => ok
C                           5 => catalog troubles
C                           8 => can't start
C   Commons:
C      /INPARM/ all input adverbs in order given by INPUTS file
C      /MAPHDR/ INNAME file catalog header to be corrected
C   See prologue comments in PPAPP for more details.
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   NCH, NIF, IRET
      DOUBLE PRECISION PHASES(*)
C
      CHARACTER STAT*4, STATUS*4, UTYPE*2
      INTEGER   IROUND, NPARM, IERR
      LOGICAL   F
      INCLUDE 'PPAPP.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
C                                       Get input parameters.
      NPARM = 19
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .FALSE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFFER, IERR)
      IF (IRET.NE.0) GO TO 999
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAME2, NAMIN2)
      CALL H2CHR (6, 1, XCLAI2, CLAIN2)
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      SEQIN2 = IROUND (XSIN2)
      DISKI2 = IROUND (XDISI2)
      INVERS = IROUND (XINVER)
      BPVER = IROUND (XBPVER)
      PDVER = IROUND (XPDVER)
      FRQSEL = IROUND (XFQID)
      SUBARR = IROUND (XSUBA)
      SUBARR = MAX (1, SUBARR)
      FRQSEL = MAX (1, FRQSEL)
C                                       Get CATBLK of PP file
      CNOIN2 = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKI2, CNOIN2, NAMIN2, CLAIN2, SEQIN2,
     *   UTYPE, NLUSER, STAT, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMIN2, CLAIN2, SEQIN2, DISKI2,
     *      NLUSER
         GO TO 990
         END IF
      STATUS = 'REST'
      CALL CATIO ('READ', DISKI2, CNOIN2, CATBLK, STATUS, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING HEADER 2'
         GO TO 990
         END IF
C                                       Get uv header info.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       get the correction
      CALL PPAPPG (NCH, NIF, PHASES, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'GETTING PP DATA'
         GO TO 990
         END IF
C                                       Get CATBLK file to correct.
      CNOIN = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       writing the bP file
      STATUS = 'WRIT'
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, STATUS, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING HEADER FILE TO CORRECT'
         GO TO 990
         END IF
C                                       Mark in CFILES
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 1
C                                       Mark 2nd in CFILES
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKI2
      FCNO(NCFILE) = CNOIN2
      FRW(NCFILE) = 0
C                                       Get uv header info.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       check polarization
      IF (PPOL.EQ.1) THEN
         IF ((ICOR0.GE.-4) .AND. (ICOR0.LE.-1)) GO TO 999
         MSGTXT = 'PP FILE POLARIZATION DOES NOT MATCH'
         IRET = 11
      ELSE IF (PPOL.EQ.2) THEN
         IF ((ICOR0.GE.-8) .AND. (ICOR0.LE.-5)) GO TO 999
         MSGTXT = 'PP FILE POLARIZATION DOES NOT MATCH'
         IRET = 11
      ELSE
         MSGTXT = 'PP FILE POLARIZATION UNKNOWN, CONTINUING'
         CALL MSGWRT (6)
         GO TO 999
         END IF
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PPAPIN: ERROR',I3,' ON ',A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
      END
      SUBROUTINE PPAPPG (NCH, NIF, PHASES, IRET)
C-----------------------------------------------------------------------
C   PPAPG finds the correction data from file 2
C   spectrum
C   Output:
C      NCH      I      Number channels in PHASES
C      NIF      I      Number IFs in PHASES
C      PHASES   d(*)   Phase corrections in degrees
C      IRET
C-----------------------------------------------------------------------
      INTEGER   NCH, NIF, IRET
      DOUBLE PRECISION PHASES(*)
C
      INCLUDE 'PPAPP.INC'
      INTEGER   VER, LUN, LUNTMP, PPBUFF(512), IPPRNO, PPKOLS(5),
     *   PPNUMV(5), IROW, SUBAPP, FRQAPP
      REAL      TIME
      DOUBLE PRECISION ERRORS(MAXCIF)
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
      VER = INVERS
      LUN = LUNTMP(1)
      CALL PPINI ('READ', PPBUFF, DISKI2, CNOIN2, VER, CATBLK, LUN,
     *   IPPRNO, PPKOLS, PPNUMV, NIF, NCH, BIF, BCHAN, PPOL, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING PHASE DIFF TABLE'
         GO TO 990
         END IF
      INVERS = VER
      IPPRNO = 1
      CALL TABPP ('READ', PPBUFF, IPPRNO, PPKOLS, PPNUMV, TIME, SUBAPP,
     *   FRQAPP, PHASES, ERRORS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING PHASE DIFFERENCE TABLE'
         GO TO 990
         END IF
C                                       Data selection
      IF ((SUBAPP.GT.0) .AND. (SUBARR.GT.0) .AND. (SUBARR.NE.SUBAPP))
     *   GO TO 110
      IF ((FRQAPP.GT.0) .AND. (FRQSEL.GT.0) .AND. (FRQSEL.NE.FRQAPP))
     *   GO TO 110
C                                       subarray and freqid match
      IF (IRET.EQ.0) GO TO 200
 110  IRET = 10
      MSGTXT = 'MATCHING PP DATA NOT FOUND'
      GO TO 990
C                                       success
 200  CALL TABPP ('CLOS', PPBUFF, IPPRNO, PPKOLS, PPNUMV, TIME, SUBAPP,
     *   FRQAPP, PHASES, ERRORS, IROW)
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PPFILE: ERROR',I4,' ON ',A)
      END
      SUBROUTINE PPAPPL (NCH, NIF, PHASES, IRET)
C-----------------------------------------------------------------------
C   PPAPPL applies the phases found from IN2NAME to a BP table belonging
C   to INNAME.
C   Inputs
C      NCH      I      Number spectral channels
C      NIF      I      Number ifs in PHASES
C      PHASES   D(*)   Phase corrections to apply (deg)
C   Output
C      IRET     I      Error code
C-----------------------------------------------------------------------
      INTEGER   NCH, NIF, IRET
      DOUBLE PRECISION PHASES(NCH,NIF)
C
      INCLUDE 'PPAPP.INC'
      INTEGER   NUMTA, LUN1, LUN2, TABUF1(512), TABUF2(512), IBPRNO,
     *   BPKOLS(MAXBPC), BPNUMV(MAXBPC), NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *   LCHAN, NUMSHF, NREC, IREC, SOURID, SUBA, ANT, FREQID, LI, LC,
     *   REFANT(2), CPNUMV(6), CPKOLS(6), ICPRNO, PDKOLS(9), PDNUMV(9),
     *   IPDRNO, JNX, VER, PDKOLO(9), PDNUMO(9)
      DOUBLE PRECISION TIME, CHSHFT(MAXIF)
      REAL      CF, SF, LOWSHF, DELSHF, INTERV, BANDW, WEIGHT(2*MAXIF),
     *   BNDPAS(2,MAXCIF), XT, YT, VFLUX(4,MAXCIF), PHDIFF(MAXCIF)
      CHARACTER LBPTYP*8, SOURSE*16, POLTYP*8
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (BNDPAS, VFLUX)
      DATA LUN1, LUN2 /79, 78/
C-----------------------------------------------------------------------
      CALL FNDEXT ('BP', CATBLK, NUMTA)
      IF ((BPVER.LE.0) .OR. (BPVER.GT.NUMTA)) BPVER = NUMTA
      BPVOUT = NUMTA + 1
C                                       modify existing BP table
      IF (BPVER.GT.0) THEN
         MSGTXT = 'Updating existing BP table, writing new one'
         CALL MSGWRT (5)
         CALL BPINI ('READ', TABUF2, DISKIN, CNOIN, BPVER, CATBLK, LUN2,
     *      IBPRNO, BPKOLS, BPNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *      LCHAN, NUMSHF, LOWSHF, DELSHF, LBPTYP, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OLD BP TABLE'
            GO TO 990
            END IF
         CALL BPINI ('WRIT', TABUF1, DISKIN, CNOIN, BPVOUT, CATBLK,
     *      LUN1, IBPRNO, BPKOLS, BPNUMV, NUMANT, NUMPOL, NUMIF,
     *      NUMFRQ, LCHAN, NUMSHF, LOWSHF, DELSHF, LBPTYP, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OLD BP TABLE'
            GO TO 990
            END IF
         NREC = TABUF2(5)
         DO 50 IREC = 1,NREC
            IBPRNO = IREC
            CALL TABBP ('READ', TABUF2, IBPRNO, BPKOLS, BPNUMV, NUMIF,
     *         NUMFRQ, NUMPOL, TIME, INTERV, SOURID, SUBA, ANT, BANDW,
     *         CHSHFT, FREQID, REFANT, WEIGHT, BNDPAS, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ OLD BP TABLE'
               GO TO 990
               END IF
            IF (((SUBA.LE.0) .OR. (SUBARR.LE.0) .OR. (SUBA.EQ.SUBARR))
     *         .AND. ((FREQID.LE.0) .OR. (FRQSEL.LE.0) .OR.
     *         (FREQID.EQ.FRQSEL)) .AND. (IRET.GT.-2)) THEN
               DO 30 LI = 1,NIF
                  JNX = (LI + BIF - 2) * NUMFRQ + BCHAN + NUMFRQ*NUMIF
                  DO 20 LC = 1,NCH
                     XT = BNDPAS(1,JNX)
                     YT = BNDPAS(2,JNX)
                     IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK) .AND.
     *                  (PHASES(LC,LI).NE.DBLANK)) THEN
                        CF = COS (PHASES(LC,LI)*DG2RAD)
                        SF = SIN (PHASES(LC,LI)*DG2RAD)
                        BNDPAS(1,JNX) = XT*CF - YT*SF
                        BNDPAS(2,JNX) = XT*SF + YT*CF
                        END IF
                     JNX = JNX + 1
 20                  CONTINUE
 30               CONTINUE
               END IF
            IBPRNO = IREC
            CALL TABBP ('WRIT', TABUF1, IBPRNO, BPKOLS, BPNUMV, NUMIF,
     *         NUMFRQ, NUMPOL, TIME, INTERV, SOURID, SUBA, ANT, BANDW,
     *         CHSHFT, FREQID, REFANT, WEIGHT, BNDPAS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITE NEW BP TABLE'
               GO TO 990
               END IF
 50         CONTINUE
         CALL TABIO ('CLOS', 0, IBPRNO, TABUF2, TABUF2, LI)
         CALL TABIO ('CLOS', 0, IBPRNO, TABUF1, TABUF1, LI)
         WRITE (MSGTXT,1050) 'BP', BPVER, BPVOUT
         CALL MSGWRT (5)
C                                       complain there is none
      ELSE
         MSGTXT = 'NO BP TABLE TO BE CORRECTED'
         CALL MSGWRT (8)
         END IF
C                                       CP file if any
      CALL FNDEXT ('PD', CATBLK, NUMTA)
      IF ((PDVER.LE.0) .OR. (PDVER.GT.NUMTA)) PDVER = NUMTA
      PDVOUT = NUMTA + 1
      CALL FNDEXT ('CP', CATBLK, NUMTA)
      CPVER = MAX (1, MIN (NUMTA, PDVER)) + 1
 200  CPVER = CPVER - 1
      IF (VER.GT.0) THEN
         CALL CPINI ('READ', TABUF2, DISKIN, CNOIN, CPVER, CATBLK, LUN2,
     *      ICPRNO, CPKOLS, CPNUMV, NUMIF, NUMFRQ, FREQID, IRET)
         IF (((FREQID.GT.0) .AND.(FRQSEL.GT.0) .AND. (FRQSEL.NE.FREQID))
     *      .OR. (IRET.NE.0)) THEN
            CALL TABIO ('CLOS', 0, ICPRNO, TABUF2, TABUF2, LI)
            GO TO 200
            END IF
         MSGTXT = 'Updating existing CP table, writing new one'
         CALL MSGWRT (5)
         CPVOUT = NUMTA + 1
         CALL CPINI ('WRIT', TABUF1, DISKIN, CNOIN, CPVOUT, CATBLK,
     *      LUN1, ICPRNO, CPKOLS, CPNUMV, NUMIF, NUMFRQ, FREQID, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN NEW CP TABLE'
            GO TO 990
            END IF
         NREC = TABUF2(5)
         DO 250 IREC = 1,NREC
            ICPRNO = IREC
            CALL TABCP ('READ', TABUF2, ICPRNO, CPKOLS, CPNUMV, NUMIF,
     *         NUMFRQ, SOURSE, SOURID, VFLUX, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ OLD CP TABLE'
               GO TO 990
               END IF
            DO 230 LI = 1,NIF
               JNX = (LI + BIF - 2) * NUMFRQ + BCHAN
               DO 220 LC = 1,NCH
                  IF (PHASES(LC,LI).NE.DBLANK) THEN
                     CF = COS (PHASES(LC,LI)*DG2RAD)
                     SF = SIN (PHASES(LC,LI)*DG2RAD)
                     XT = VFLUX(2,JNX)
                     YT = VFLUX(3,JNX)
                     VFLUX(2,JNX) = XT*CF - YT*SF
                     VFLUX(3,JNX) = XT*SF + YT*CF
                     END IF
                  JNX = JNX + 1
 220              CONTINUE
 230           CONTINUE
            ICPRNO = IREC
            CALL TABCP ('WRIT', TABUF1, ICPRNO, CPKOLS, CPNUMV, NUMIF,
     *         NUMFRQ, SOURSE, SOURID, VFLUX, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITE NEW CP TABLE'
               GO TO 990
               END IF
 250        CONTINUE
         CALL TABIO ('CLOS', 0, ICPRNO, TABUF2, TABUF2, LI)
         CALL TABIO ('CLOS', 0, ICPRNO, TABUF1, TABUF1, LI)
         WRITE (MSGTXT,1050) 'CP', CPVER, CPVOUT
         CALL MSGWRT (5)
         END IF
C                                       PD update
      CALL FNDEXT ('PD', CATBLK, NUMTA)
      IF (NUMTA.LE.0) GO TO 999
      MSGTXT = 'Updating existing PD table, writing new one'
      CALL MSGWRT (5)
      IF ((PDVER.LT.1) .OR. (PDVER.GT.NUMTA)) PDVER = NUMTA
      CALL PDINI ('READ', TABUF2, DISKIN, CNOIN, PDVER, CATBLK, LUN2,
     *   IPDRNO, PDKOLS, PDNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *   POLTYP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OLD PD TABLE FOR READ'
         GO TO 990
         END IF
      PDVOUT = NUMTA + 1
      CALL PDINI ('WRIT', TABUF1, DISKIN, CNOIN, PDVOUT, CATBLK, LUN1,
     *   IPDRNO, PDKOLO, PDNUMO, NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *   POLTYP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'RE-OPEN OLD PD TABLE FOR WRITE'
         GO TO 990
         END IF
      NREC = TABUF2(5)
      DO 360 IREC = 1,NREC
         IPDRNO = IREC
         CALL TABPD ('READ', TABUF2, IPDRNO, PDKOLS, PDNUMV, NUMIF,
     *      NUMFRQ, NUMPOL, ANT, SUBA, FREQID, REFANT, PHDIFF, BNDPAS,
     *      IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ PD TABLE'
            GO TO 990
            END IF
         IF (((SUBA.LE.0) .OR. (SUBARR.LE.0) .OR. (SUBA.EQ.SUBARR))
     *      .AND. (IRET.GT.-3)) THEN
C                                       Just add to phase difference
            IF (POLTYP.EQ.'ORI-ELP') THEN
               DO 320 LI = 1,NIF
                  JNX = (LI + BIF - 2) * NUMFRQ + BCHAN
                  DO 310 LC = 1,NCH
                     IF (PHASES(LC,LI).NE.DBLANK) PHDIFF(JNX) =
     *                  PHDIFF(JNX) + PHASES(LC,LI) * DG2RAD
                     JNX = JNX + 1
 310                 CONTINUE
 320              CONTINUE
C                                       correct D terms
            ELSE
               DO 350 LI = 1,NIF
                  JNX = (LI + BIF - 2) * NUMFRQ + BCHAN
                  DO 330 LC = 1,NCH
                     XT = BNDPAS(1,JNX)
                     YT = BNDPAS(2,JNX)
                     IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK) .AND.
     *                  (PHASES(LC,LI).NE.DBLANK)) THEN
                        CF = COS (PHASES(LC,LI)*DG2RAD)
                        SF = SIN (PHASES(LC,LI)*DG2RAD)
                        BNDPAS(1,JNX) = XT*CF - YT*SF
                        BNDPAS(2,JNX) = XT*SF + YT*CF
                        END IF
                     JNX = JNX + 1
 330                 CONTINUE
C                                       2nd polarization opposite
                  JNX = (LI + BIF - 2) * NUMFRQ + BCHAN +
     *               NUMFRQ * NUMIF
                  DO 340 LC = 1,NCH
                     XT = BNDPAS(1,JNX)
                     YT = BNDPAS(2,JNX)
                     IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK) .AND.
     *                  (PHASES(LC,LI).NE.DBLANK)) THEN
                        CF = COS (PHASES(LC,LI)*DG2RAD)
                        SF = SIN (PHASES(LC,LI)*DG2RAD)
                        BNDPAS(1,JNX) = XT*CF + YT*SF
                        BNDPAS(2,JNX) = YT*CF - XT*SF
                        END IF
                     JNX = JNX + 1
 340                 CONTINUE
 350              CONTINUE
               END IF
            END IF
         IPDRNO = IREC
         CALL TABPD ('WRIT', TABUF1, IPDRNO, PDKOLO, PDNUMO, NUMIF,
     *      NUMFRQ, NUMPOL, ANT, SUBA, FREQID, REFANT, PHDIFF, BNDPAS,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'RE-WRITE PD TABLE'
            GO TO 990
            END IF
 360     CONTINUE
      CALL TABIO ('CLOS', 0, IPDRNO, TABUF1, TABUF1, LI)
      CALL TABIO ('CLOS', 0, IPDRNO, TABUF2, TABUF2, LI)
      WRITE (MSGTXT,1050) 'PD', PDVER, PDVOUT
      CALL MSGWRT (5)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PPAPPL: ERROR',I4,' ON ',A)
 1050 FORMAT ('Updated ',A,' version',I4, ' to new version',I4)
      END
      SUBROUTINE PPAPHI (NCH, NIF)
C-----------------------------------------------------------------------
C   writes HI records when solution is appled to data
C-----------------------------------------------------------------------
      INTEGER   NCH, NIF
C
      INCLUDE 'PPAPP.INC'
      INTEGER   LUN, LUNTMP, TIME(3), DATE(3), IERR, BUFF2(256)
      CHARACTER CTIME(2)*12, HILINE*72
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Write History.
      LUN = LUNTMP (1)
      CALL HIINIT (3)
C                                       Open old history
      CALL HIOPEN (LUN, DISKIN, CNOIN, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,1000) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       file with PP table
      CALL HENCO2 (TSKNAM, NAMIN2, CLAIN2, SEQIN2, DISKI2, LUN, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1010) TSKNAM, FRQSEL
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1011) TSKNAM, SUBARR
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1012) TSKNAM, INVERS
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1013) TSKNAM, BIF, NIF
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1014) TSKNAM, BCHAN, NCH
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1015) TSKNAM, 'BP', BPVER, 'BP'
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1016) TSKNAM, 'BP', BPVOUT, 'BP'
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      IF ((PDVER.GT.0) .AND. (PDVOUT.GT.0)) THEN
         WRITE (HILINE,1015) TSKNAM, 'PD', PDVER, 'PD'
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         WRITE (HILINE,1016) TSKNAM, 'PD', PDVOUT, 'PD'
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
      IF ((CPVER.GT.0) .AND. (CPVOUT.GT.0)) THEN
         WRITE (HILINE,1015) TSKNAM, 'CP', CPVER, 'CP'
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         WRITE (HILINE,1016) TSKNAM, 'CP', CPVOUT, 'CP'
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       Close HI file
 200  CALL HICLOS (LUN, .TRUE., BUFF2, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 1010 FORMAT (A6,'FREQID   =',I4,'   / Frequency ID number')
 1011 FORMAT (A6,'SUBARRAY =',I4,'   /Subarray number')
 1012 FORMAT (A6,'INVERS   =',I4,'   / PP file version')
 1013 FORMAT (A6,'BIF =',I3,' NIF =',I3,'  /PP file begin, # IFs')
 1014 FORMAT (A6,'BCHAN=',I5,' NCHAN =',I5,
     *   '  /PP file spectral channels')
 1015 FORMAT (A6,A2,'VER    =',I4,'   / ',A2,' table corrected')
 1016 FORMAT (A6,A2,'VOUT   =',I4,'   / ',A2,' new table')
      END

LOCAL INCLUDE 'DFTIM.INC'
C                                       Local include for DFTIM
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IMGLIM
      PARAMETER (IMGLIM=10000)
C
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMEO(3), XCLAOU(2), XOPTYP(1),
     *   XSOUR(4), XCALC, XSTOK
      REAL      XSIN, XDISIN, XSOU, XDISOU, UVRANG(2), TIMER(8),
     *   SHIFT(2), SOLINT, SCANL, DOEBAR, XQUAL, XBAND, XFREQ, XFQID,
     *   XSUBA, XBIF, XEIF, XBCHAN, XECHAN, XCHAVG, XANT(50), XBASL(50),
     *   XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER,
     *   XSMOTH(3), BADD(10)
      DOUBLE PRECISION FOFF(MAXIF), DXC, DYC, DZC, RAS, DECS, OFREQ,
     *   FREQS(16384)
      REAL      BUFF1(UVBFSS), TIMR(IMGLIM), TBEG, TFIN, FRPIX, TAVG,
     *   FINC(MAXIF)
      CHARACTER NAMEIN*12, CLAIN*6, NAMEOU*12, CLAOU*6, OPTYPE*4
      INTEGER   SEQIN, DISKIN, SEQOU, DISKOU, LUNI, INDI, JBUFSZ,
     *   NPARMS, NCHAVG, FREQID, KNCS, KNCF, KNCIF, NY, CATOLD(256),
     *   NXANT, IXANT(50), NXBASL, IXBASL(50), STKVAL, IOPT, IDIF
      LOGICAL   NOUVR, ISFREQ, DESEL
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMEO, XCLAOU,
     *   XSOU, XDISOU, XOPTYP, UVRANG, TIMER, SHIFT, XSTOK, SOLINT,
     *   SCANL, DOEBAR, XSOUR, XQUAL, XCALC, XBAND, XFREQ, XFQID, XSUBA,
     *   XBIF, XEIF, XBCHAN, XECHAN, XCHAVG, XANT, XBASL, XDOCAL, XGUSE,
     *   XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH, BADD
      COMMON /BUFRS/ BUFF1, JBUFSZ
      COMMON /FTPCOM/ FOFF, CATOLD, FREQS, OFREQ, DXC, DYC, DZC, RAS,
     *   DECS, FINC, TIMR, TBEG, TFIN, TAVG, FRPIX, NOUVR, SEQIN,
     *   DISKIN, LUNI, INDI, NPARMS, FREQID, KNCS, KNCF, KNCIF, SEQOU,
     *   DISKOU, NY, NCHAVG, ISFREQ, NXANT, NXBASL, IXANT, IXBASL,
     *   DESEL, STKVAL, IOPT, IDIF
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMEOU, CLAOU, OPTYPE
C                                                          End DFTIM.
LOCAL END
      PROGRAM DFTIM
C-----------------------------------------------------------------------
C! images summed uv data for a position in the sky as a function of time
C# UV Analysis
C-----------------------------------------------------------------------
C;  Copyright (C) 2017-2018, 2020, 2022-2023, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DFTIM creates an image file to display the DFT of the visibilities
C   for an arbitrary position in the sky.  Plots resulting flux on
C   frequency and time axes.
C   NOTE 1: DFTIM wants the first key of the sort order of the UV data
C           base to be TIME.
C   NOTE 2: At present, DFTIM will only plot up to IMGLIM bins. For 5 s
C           averages this means roughly 14 hours of imaging. For 1
C           min averages, more than 7 days, etc.
C   Inputs:
C     INNAME         NAMEIN        Name of input UV data.
C     INCLASS        CLAIN         Class of input UV data.
C     INSEQ          SEQIN         Seq. of input UV data.
C     INDISK         DISKIN        Disk number of input VU data.
C     UVRANGE....Range of UV projected spacings to include (Klambda)
C     TIMER......Selection parameters:
C        1 = Start IAT day (day 0 = first day in data base)
C        2 = Start IAT hour
C        3 = Start IAT minute
C        4 = Start IAT second
C        5 = Stop IAT day (day 0 = first day in data base)
C        6 = Stop IAT hour
C        7 = Stop IAT minute
C        8 = Stop IAT second
C     SHIFT 1 = Offset in right ascension (asec)
C           2 = Offset in declination (asec)
C     SOLINT = averaging interval in sec
C     DOEBAR > 0 write error image too
C   DFTPL written by T. Bastian, Univ. of Colorado, Aug. 1986
C   Used UVPLT as task template.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   NX, NWORDS, IRET
      REAL      IMAGE(2), ERROR(2), WEIGHT(2)
      LONGINT   PIMAGE, PERROR, PWEIGH
      INCLUDE 'DFTIM.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'DFTIM '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL DFTIMI (PRGM, NX, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       allocate image
      NWORDS = (3 * NX * IMGLIM - 1) / 1024 + 4
      CALL ZMEMRY ('GET ', PRGM, NWORDS, IMAGE, PIMAGE, IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', PRGM, NWORDS, ERROR, PERROR,
     *   IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', PRGM, NWORDS, WEIGHT, PWEIGH,
     *   IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'FAILED TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 995
         END IF
C                                       Do DFT's
      CALL DFTIMC (NX, IMAGE(1+PIMAGE), ERROR(1+PERROR),
     *   WEIGHT(1+PWEIGH), IRET)
      IF (IRET.NE.0) GO TO 995
C                                       output
      CALL DFTIMO (NX, IMAGE(1+PIMAGE), ERROR(1+PERROR), IRET)
C                                       Close down
 995  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE DFTIMI (PRGM, NX, JERR)
C-----------------------------------------------------------------------
C   DFTIMI gets input parameters for DFTIM .
C   Inputs:
C      PRGM    C*6    Program name
C   Output:
C      NX      I      Number spectral channels
C      JERR    I      Error code: 0 => ok, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   NX, JERR
C
      INCLUDE 'DFTIM.INC'
      CHARACTER BNDCOD(MAXIF)*8, CSTOK(8)*4, OPTS(8)*4
      INTEGER   OLDCNO, IUSER, I, IERR, IROUND, FQVER, NIF, CHBUFF(512),
     *   ISBAND(MAXIF), LUNCH, LF, LC, IC
      REAL      CATR(256), RPARM(20)
      LOGICAL   T
      DOUBLE PRECISION RA0, DEC0, CATD(128), DFREQ, DFREQS
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (CATBLK, CATR, CATD)
      DATA T /.TRUE./
      DATA CSTOK /'RR', 'LL', 'I', 'V', 'Q', 'U', 'VV', 'HH'/
      DATA OPTS /'REAL', 'IMAG', 'SAMP', 'AMP', 'PHAS', 'ADIF', 'VDIF',
     *   'PDIF'/
C-----------------------------------------------------------------------
C                                       Init IO et al.
      CALL ZDCHIN (T, BUFF1)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARMS = 167
      CALL GTPARM (PRGM, NPARMS, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         JERR = 8
         RQUICK = .TRUE.
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR, 'GETTING USER ADVERB VALUES'
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      IUSER = NLUSER
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      SEQOU = IROUND (XSOU)
      DISKOU = IROUND (XDISOU)
      TBEG = TIMER(1) + (TIMER(2)+(TIMER(3)+TIMER(4)/60.)/60.)/24.
      TFIN = TIMER(5) + (TIMER(6)+(TIMER(7)+TIMER(8)/60.)/60.)/24.
      IF (TFIN.LE.TBEG) TFIN = 1.E6
      IF (TBEG.LE.0.0) TBEG = -1.E6
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMEO, NAMEOU)
      CALL H2CHR (6, 1, XCLAOU, CLAOU)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      CALL H2CHR (4, 1, XSTOK, STOKES)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      DO 5 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 5       CONTINUE
      CALL H2CHR (16, 1, XSOUR(1), SOURCS(1))
      SELQUA = IROUND (XQUAL)
      NCHAVG = XCHAVG + 0.1
      NCHAVG = MAX (1, NCHAVG)
      STKVAL = 0
      IOPT = 1
      DO 10 I = 1,8
         IF (OPTYPE.EQ.OPTS(I)) IOPT = I
 10      CONTINUE
      OPTYPE = OPTS(IOPT)
      IDIF = IROUND (SCANL) / 2
      IDIF = MAX (1, IDIF)
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = .FALSE.
      CALL RCOPY (8, TIMER, TIMRNG)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
      BCHAN = XBCHAN
      ECHAN = XECHAN
      BIF = XBIF
      EIF = XEIF
C                                       Test UV range
      NOUVR = .FALSE.
      IF ((UVRANG(1).GE.UVRANG(2)) .OR. (UVRANG(1).LT.0.0)) THEN
         NOUVR = .TRUE.
         UVRANG(1) = 0.0
         UVRANG(2) = 1.E10
         END IF
      UVRNG(1) = UVRANG(1)
      UVRNG(2) = UVRANG(2)
      UVRANG(1) = UVRANG(1) * 1.0E3
      UVRANG(2) = UVRANG(2) * 1.0E3
C                                       Antennas
      CALL SETANT (50, XANT, XBASL, NXANT, NXBASL, IXANT, IXBASL, DESEL)
      IF ((NXANT.LE.0) .AND. (NXBASL.GT.0)) THEN
         CALL COPY (NXBASL, IXBASL, IXANT)
         NXANT = NXBASL
         NXBASL = 0
         END IF
C                                       Get CATBLK from UVGET
      CALL UVGET ('INIT', RPARM, BUFF1, IERR)
      IF (IERR.LT.0) THEN
         MSGTXT = 'INITIAL UVGET RETURNS NO DATA FOUND'
         GO TO 980
      ELSE IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INITIAL UVGET CALL'
         GO TO 980
         END IF
C                                       save adverbs
      XSIN = IUSEQ
      XDISIN = IUDISK
      CALL CHR2H (12, UNAME, 1, XNAMEI)
      CALL CHR2H (6, UCLAS, 1, XCLAIN)
      OLDCNO = IUCNO
      NCHAVG = MIN (NCHAVG, ECHAN-BCHAN+1)
      NX = (ECHAN - BCHAN + 1) / NCHAVG
      ECHAN = BCHAN - 1 + NX * NCHAVG
      NX = NX * (EIF - BIF + 1)
      XBCHAN = BCHAN
      XECHAN = ECHAN
      XBIF = BIF
      XEIF = EIF
      XSUBA = SUBARR
      CALL UVGET ('CLOS', RPARM, BUFF1, IERR)
      IF (NCFILE.LE.0) THEN
         NCFILE = 1
         FVOL(NCFILE) = IUDISK
         FCNO(NCFILE) = IUCNO
         FRW(NCFILE) = 0
         END IF
      CALL COPY (256, CATUV, CATBLK)
      CALL COPY (256, CATUV, CATOLD)
C                                       UVPGET was called for output
      IF ((ILOCSU.GE.0) .OR. ((RA.EQ.0.0D0) .AND. (DEC.EQ.0.0D0))) THEN
         IERR = 8
         MSGTXT = 'YOU MUST SELECT ONLY ONE SOURCE'
         GO TO 980
         END IF
C                                       Source offsets
      RA0 = RA
      DEC0 = DEC
      IF (COS(DG2RAD*DEC0).NE.0.0D0) RA = RA0 + SHIFT(1) / 3600.D0
     *   / COS(DG2RAD * DEC0)
      DEC = DEC + SHIFT(2) / 3600.D0
      RAS = RA
      DECS = DEC
      DXC = SIN (DG2RAD * (RA-RA0)) * COS (DEC * DG2RAD)
      DYC = COS (DEC0 * DG2RAD) * SIN (DEC * DG2RAD) -
     *   SIN (DEC0 * DG2RAD) * COS (DEC * DG2RAD) *
     *   COS ((RA - RA0) * DG2RAD)
      DZC = SIN (DG2RAD * DEC0) * SIN (DG2RAD * DEC) +
     *   COS (DG2RAD * DEC0) * COS (DG2RAD * DEC) *
     *   COS (DG2RAD * (RA - RA0)) - 1.0D0
      DXC = TWOPI * DXC
      DYC = TWOPI * DYC
      DZC = TWOPI * DZC
C                                       Sort order OK ?
      IF (ISORT(:1).NE.'T') THEN
         MSGTXT = 'FIRST KEY OF SORT ORDER MUST BE TIME !!'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 999
         END IF
C                                       Frequency and bandwidth
      IF (JLOCIF.LT.0) THEN
         FOFF(1) = 0.0D0
         FINC(1) = CATR(KRCIC+JLOCF)
      ELSE
         FQVER = 1
         LUNCH = 87
         CALL CHNDAT ('READ',  CHBUFF, DISKIN, OLDCNO, FQVER, CATBLK,
     *      LUNCH, NIF, FOFF, ISBAND, FINC, BNDCOD, FREQID, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR
            CALL MSGWRT (7)
            JERR = 1
            GO TO 999
            END IF
         END IF
      OFREQ = CATD(KDCRV+JLOCF)
      FRPIX = CATR(KRCRP+JLOCF)
C                                       compute frequency array
      IC = 0
      ISFREQ = .TRUE.
      DO 40 LF = BIF,EIF
         DO 30 LC = BCHAN,ECHAN,NCHAVG
            IC = IC + 1
            FREQS(IC) = FOFF(LF) + FINC(LF) * (LC + (NCHAVG-1.0)/2.0 -
     *         FRPIX)
            IF (IC.EQ.2) THEN
               DFREQ = FREQS(2) - FREQS(1)
               DFREQS = ABS(DFREQ) / 100.0D0
            ELSE IF (IC.GT.2) THEN
               IF (ABS(FREQS(IC)-FREQS(IC-1)-DFREQ).GT.DFREQS)
     *            ISFREQ = .FALSE.
               END IF
 30         CONTINUE
 40      CONTINUE
      IF (ISFREQ) THEN
         MSGTXT = 'Freqencies on a fixed grid, will use FREQ axis'
      ELSE
         MSGTXT = 'Frequencies not all on same grid, FQ axis needed'
         END IF
      CALL MSGWRT (2)
C                                       Update catalog header.
      FRW(NCFILE) = 0
      JERR = 0
C                                       Check correlator display
      DO 50 I = 1,8
         IF (STOKES.EQ.CSTOK(I)) THEN
            STKVAL = I
            GO TO 999
            END IF
 50      CONTINUE
C                                       Stokes unavailable
      WRITE (MSGTXT,1900) STOKES
      JERR = 1
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DFTIMI: ERROR',I3,' ON ',A)
 1050 FORMAT ('ERROR',I5,' READING FREQUENCIES WITH CHNDAT')
 1900 FORMAT ('REQUESTED STOKES PARAMETER ''',A,''' NOT ALLOWED')
      END
      SUBROUTINE DFTIMC (NX, IMAGE, ERROR, WEIGHT, IRET)
C-----------------------------------------------------------------------
C   DFTIMC accumlates the flux density for each averaging interval as
C   well as an estimate of the error. Also sets scaling for later use.
C   Inputs:
C      NX      I      X pixels in image
C   Output:
C      IMAGE   R(*)   DFT image
C      ERROR   R(*)   Error estimate
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NX, IRET
      REAL      IMAGE(NX,3,*), ERROR(NX,3,*), WEIGHT(NX,3,*)
C
      INCLUDE 'DFTIM.INC'
      INTEGER   FLAG, NUMVIS, XUMVIS, I, IA1, IA2
      REAL      VIS(UVBFSS), RPARM(20), BASEN
      DOUBLE PRECISION T1, T2
      LOGICAL   REQBAS
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C                                       Set up binning
      I = 3 * NX * IMGLIM
      CALL RFILL (I, 0.0, IMAGE)
      CALL RFILL (I, 0.0, ERROR)
      CALL RFILL (I, 0.0, WEIGHT)
C                                       Get start/stop times
      CALL TBTIME (TBEG, TFIN, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINDING START AND STOP TIMES'
         GO TO 990
         END IF
C                                       set bin count, T averaging
      IF (SOLINT.LE.0.001) SOLINT = 864. * (TFIN - TBEG)
      TAVG = SOLINT / 86400.
      T1 = TBEG
      T2 = T1 + TAVG
      NY = 1
C                                       Init vis file for read.
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT UV IO'
         GO TO 990
         END IF
      NUMVIS = 0
      XUMVIS = 0
      KNCS = INCS
      KNCF = INCF
      KNCIF = INCIF
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING UV DATA'
         GO TO 990
      ELSE IF (IRET.EQ.0) THEN
C                                       antenna/baseline
         IF (ILOCB.GE.0) THEN
            BASEN = RPARM(1+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
            END IF
         IF (.NOT.REQBAS (IA1, IA2, DESEL, IXANT, NXANT, IXBASL,
     *      NXBASL)) GO TO 100
C                                       Is this a valid point ?
 125     CALL WANTED (RPARM, VIS, T1, T2, FLAG)
C                                       Bad point, try again
         IF (FLAG.EQ.1) GO TO 100
C                                       End of time search
         IF (FLAG.EQ.3) GO TO 200
C                                       Next time interval
         IF (FLAG.EQ.2) THEN
            TIMR(NY) = (T1+T2)/2.
            T1 = T2
            T2 = T1 + TAVG
            NY = NY + 1
            GO TO 125
            END IF
C                                       Good point
         CALL DODFT (RPARM, VIS, T1, T2, FLAG, NY, NX, IMAGE,
     *      ERROR, WEIGHT, IRET)
         XUMVIS = XUMVIS + 1
         GO TO 100
         END IF
C                                       Any valid points
 200  IF (XUMVIS.LE.1) THEN
         IRET = 4
         WRITE (MSGTXT,1200) XUMVIS
         GO TO 990
         END IF
      FLAG = 2
      CALL DODFT (RPARM, VIS, T1, T2, FLAG, NY, NX, IMAGE, ERROR,
     *   WEIGHT, IRET)
C                                       close UV data
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DFTIMC: ERROR',I3,' ON ',A)
 1200 FORMAT ('FOUND',I5,' POINTS: NOT VERY INTERESTING')
      END
      SUBROUTINE WANTED (RPBUF, VIS, T1, T2, FLAG)
C-----------------------------------------------------------------------
C   WANTED determines whether the current visibility sample is valid
C   and selected via the selection parameters.
C   Inputs:
C      RPBUF   R(*)   Random parameters
C      VIS     R(*)   Visibilities
C      T1      D      Start desired time range
C      T2      D      End desired time range
C   Outputs:
C      FLAG    I      0 => data selected as good
C                     1    data NO GOOD
C                     2    time exceeds T2
C                     3    time exceeds TFIN
C-----------------------------------------------------------------------
      REAL      RPBUF(*), VIS(*)
      DOUBLE PRECISION T1, T2
      INTEGER   FLAG
C
      REAL      TEMP
      INTEGER   LAD, IIF, ICH, IROUND
      LOGICAL   GOOD, ANY
      INCLUDE 'DFTIM.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
      FLAG = 1
C                                       Check FREQID
      IF (ILOCFQ.GE.0) THEN
         IIF = IROUND (RPBUF(1+ILOCFQ))
         IF ((FREQID.GT.0) .AND. (IIF.GT.0) .AND. (IIF.NE.FREQID))
     *      GO TO 999
         END IF
C                                       Check UV range
      IF (.NOT.NOUVR) THEN
         TEMP = SQRT (RPBUF(1+ILOCU)**2 + RPBUF(1+ILOCV)**2)
         IF ((TEMP.LT.UVRANG(1)) .OR. (TEMP.GT.UVRANG(2))) GO TO 999
         END IF
C                                       Are data flagged?
      ANY = .FALSE.
      DO 20 IIF = BIF,EIF
         DO 10 ICH = BCHAN,ECHAN
            LAD = 1 + (IIF-BIF)*KNCIF + (ICH-BCHAN)*KNCF
            GOOD = VIS(LAD+2).GT.0.0
            ANY = ANY .OR. GOOD
 10         CONTINUE
 20      CONTINUE
      IF (.NOT.ANY) GO TO 999
C                                       Test time range
      TEMP = RPBUF(1+ILOCT)
      IF (TEMP.LT.T1) GO TO 999
      FLAG = 2
      IF (TEMP.GE.T2) GO TO 999
      FLAG = 3
      IF (TEMP.GT.TFIN) GO TO 999
      FLAG = 0
C
 999  RETURN
      END
      SUBROUTINE DODFT (RPBUF, VIS, T1, T2, FLAG, IY, NX, IMAGE,
     *   ERROR, WEIGHT, IRET)
C-----------------------------------------------------------------------
C   DODFT computes the DFT for a given set of visibilities with the
C   proper sky offset applied.
C   Inputs:
C      RPBUF    R(*)   one visibility record - random parameters
C      VIS      R(*)   one visibility record - data
C      T1       D      Start of interval
C      T2       D      End of interval
C      FLAG     I      If 0, continue summing DFT
C                      If 2, wrap it up, clear
C      IY       I      row number in images
C      NX       I      size of images
C   In/out
C      IMAGE    R(*)   image
C      ERROR    R(*)   error
C      WEIGHT   R(*)   weight
C   Outputs:
C      XY       R(2)   X, Y values
C      Z        R      Error on Y
C      IRET     I      0 => operation sucessful
C                      1 => trouble
C                      -1 => no data to average
C-----------------------------------------------------------------------
      INTEGER   FLAG, IY, NX, IRET
      REAL      RPBUF(*), VIS(*), IMAGE(NX,3,*), ERROR(NX,3,*),
     *   WEIGHT(NX,3,*)
      DOUBLE PRECISION T1, T2
C
      REAL      TR, TI, UU, VV, WW, SMN, TNR, XX, WT, DELS, TNI, TNA,
     *   TA, ER, EI
      DOUBLE PRECISION AFREQ
      INTEGER   IIF, ICH, LAD, IX, LCH, LY, J, L1, L2, L
      INCLUDE 'DFTIM.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       loop over IF and channel
      IF (FLAG.EQ.0) THEN
         IX = 0
         DO 50 IIF = BIF,EIF
            DO 40 ICH = BCHAN,ECHAN,NCHAVG
               IX = IX + 1
               DO 30 LCH = ICH,ICH+NCHAVG-1
                  LAD = 1 + (LCH-BCHAN)*KNCF + (IIF-BIF)*KNCIF
                  AFREQ = OFREQ + FOFF(IIF) + (LCH-FRPIX) * FINC(IIF)
C                                       Set U and V
                  UU = RPBUF(ILOCU+1) * AFREQ / OFREQ
                  VV = RPBUF(ILOCV+1) * AFREQ / OFREQ
                  WW = RPBUF(ILOCW+1) * AFREQ / OFREQ
C                                       Find visibilities and weights
                  IF (VIS(LAD+2).GT.0.0) THEN
                     TR = VIS(LAD)
                     TI = VIS(LAD+1)
                     WT = VIS(LAD+2)
C                                       sum it up
                     XX = UU * DXC + VV * DYC + WW * DZC
                     TNR = TR * COS (XX) + TI * SIN (XX)
                     IMAGE(IX,1,IY) = IMAGE(IX,1,IY) + WT * TNR
                     ERROR(IX,1,IY) = ERROR(IX,1,IY) + WT * TNR * TNR
                     WEIGHT(IX,1,IY) = WEIGHT(IX,1,IY) + WT
                     TNI = TI * COS (XX) - TR * SIN (XX)
                     IMAGE(IX,2,IY) = IMAGE(IX,2,IY) + WT * TNI
                     ERROR(IX,2,IY) = ERROR(IX,2,IY) + WT * TNI * TNI
                     WEIGHT(IX,2,IY) = WEIGHT(IX,2,IY) + WT
                     TNA = SQRT (TNR*TNR + TNI*TNI)
                     IMAGE(IX,3,IY) = IMAGE(IX,3,IY) + WT * TNA
                     ERROR(IX,3,IY) = ERROR(IX,3,IY) + WT * TNA * TNA
                     WEIGHT(IX,3,IY) = WEIGHT(IX,3,IY) + WT
                     END IF
 30               CONTINUE
 40            CONTINUE
 50         CONTINUE
C                                      Finish up full image
      ELSE
         IRET = -1
         DO 90 LY = 1,IY
            DO 80 IX = 1,NX
               IF (IOPT.LE.3) THEN
                  IF (WEIGHT(IX,IOPT,LY).GT.0.0) THEN
                     SMN = IMAGE(IX,IOPT,LY) / WEIGHT(IX,IOPT,LY)
                     DELS = ERROR(IX,IOPT,LY) / WEIGHT(IX,IOPT,LY) -
     *                  SMN*SMN
                     DELS = SQRT (MAX (0.0, DELS))
                     IMAGE(IX,3,LY) = SMN
                     ERROR(IX,3,LY) = DELS
                     IRET = 0
                  ELSE
                     IMAGE(IX,3,LY) = FBLANK
                     ERROR(IX,3,LY) = FBLANK
                     END IF
               ELSE IF ((WEIGHT(IX,1,LY).GT.0.0) .AND.
     *            (WEIGHT(IX,2,LY).GT.0.0)) THEN
                  TNR = IMAGE(IX,1,LY) / WEIGHT(IX,1,LY)
                  TNI = IMAGE(IX,2,LY) / WEIGHT(IX,2,LY)
                  TNA = SQRT (TNR*TNR + TNI*TNI)
                  TR = ERROR(IX,1,LY) / WEIGHT(IX,1,LY) - TNR*TNR
                  TR = SQRT (MAX (0.0, TR))
                  TI = ERROR(IX,2,LY) / WEIGHT(IX,2,LY) - TNI*TNI
                  TI = SQRT (MAX (0.0, TI))
                  IF (TNA.LE.0.0) THEN
                     IMAGE(IX,3,LY) = FBLANK
                     ERROR(IX,3,LY) = FBLANK
C                                       AMP
                  ELSE IF (IOPT.EQ.4) THEN
                     IMAGE(IX,3,LY) = TNA
                     ERROR(IX,3,LY) = SQRT ((TNR*TR)**2 + (TNI*TI)**2) /
     *                  TNA
C                                       PHAS
                  ELSE IF (IOPT.EQ.5) THEN
                     IMAGE(IX,3,LY) = ATAN2 (TNI, TNR) * RAD2DG
                     ERROR(IX,3,LY) = SQRT ((TNI*TR)**2 + (TNR*TI)**2) /
     *                  TNA**2 * RAD2DG
C                                       xDIF
                  ELSE
                     L1 = MAX (1, LY-IDIF)
                     L2 = MIN (IY, LY+IDIF)
                     TR = 0.
                     TI = 0.
                     TA = 0.
                     J = 0
                     DO 60 L = L1,L2
                        IF (WEIGHT(IX,1,L).GT.0.0) THEN
                           TR = IMAGE(IX,1,L) / WEIGHT(IX,1,L)
                           TI = IMAGE(IX,2,L) / WEIGHT(IX,2,L)
                           TA = SQRT (TNR*TNR + TNI*TNI)
                           TNR = TNR + TR
                           TNI = TNI + TI
                           TNA = TNA + TA
                           J = J + 1
                           END IF
 60                     CONTINUE
                     TNR = TNR / J
                     TNI = TNI / J
                     TNA = TNA / J
                     TR = IMAGE(IX,1,LY) / WEIGHT(IX,1,LY)
                     TI = IMAGE(IX,2,LY) / WEIGHT(IX,2,LY)
                     TA = SQRT (TNR*TNR + TNI*TNI)
                     ER = ERROR(IX,1,LY) / WEIGHT(IX,1,LY) - TR*TR
                     ER = SQRT (MAX (0.0, ER))
                     EI = ERROR(IX,2,LY) / WEIGHT(IX,2,LY) - TI*TI
                     EI = SQRT (MAX (0.0, EI))
C                                       ADIF
                     IF (IOPT.EQ.6) THEN
                        IMAGE(IX,3,LY) = TA - TNA
                        ERROR(IX,3,LY) = SQRT ((TR*ER)**2 +
     *                     (TI*EI)**2) / TA
C                                       VDIF
                     ELSE IF (IOPT.EQ.7) THEN
                        ERROR(IX,3,LY) = SQRT ((TR*ER)**2 +
     *                     (TI*EI)**2) / TA
                        IMAGE(IX,3,LY) = SQRT ((TR-TNR)**2 +
     *                     (TI-TNI)**2)
C                                       PDIF
                     ELSE IF (IOPT.EQ.8) THEN
                        ERROR(IX,3,LY) = SQRT ((TI*ER)**2 + (TR*EI)**2)/
     *                     TA**2 * RAD2DG
                        TI = TI - TNI
                        TR = TR - TNR
                        IF ((TR.NE.0.0) .OR. (TI.NE.0.0)) THEN
                           IMAGE(IX,3,LY) = ATAN2 (TI, TR) * RAD2DG
                        ELSE
                           IMAGE(IX,3,LY) = 0.0
                           END IF
                        END IF
                     END IF
               ELSE
                  IMAGE(IX,3,LY) = FBLANK
                  ERROR(IX,3,LY) = FBLANK
                  END IF
 80            CONTINUE
 90         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE DFTIMO (NX, IMAGE, ERROR, IRET)
C-----------------------------------------------------------------------
C   DFTIMO constructs an image header and writes out the waterfall
C   image and possibly the error as well
C   Inputs:
C      NX      I      Image X pixels
C      IMAGE   R(*)   Image(NX,NY)
C      ERROR   R(*)   Error(NX,NY)
C   Outputs:
C      IRET    I      Error condition
C-----------------------------------------------------------------------
      INTEGER   NX, IRET
      REAL      IMAGE(NX,3,*), ERROR(NX,3,*)
C
      INCLUDE 'DFTIM.INC'
      INTEGER   IX, IY, I, J, SLOT, LUNO, INDO, BIND, WIN(4), BOI,
     *   VSTOK(8)
      REAL      BMIN, BMAX, CATOR(256), CATR(256)
      LOGICAL   WASBLK
      DOUBLE PRECISION CATOD(128), CATD(128)
      HOLLERITH CATOH(256), CATH(256)
      CHARACTER PHNAME*48
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      EQUIVALENCE (CATOLD, CATOD, CATOR, CATOH)
      DATA LUNO /39/
      DATA VSTOK /-1, -2, 1, 4, 2, 3, -5, -6/
C-----------------------------------------------------------------------
C                                       make up a header
      CALL COPY (256, CATOLD, CATBLK)
      CALL UVPGET (IRET)
C
      CALL CHR2H (8, 'JANSKYS', 1, CATH(KHBUN))
      IF (OPTYPE(:1).EQ.'P') CALL CHR2H (8, 'DEGREES', 1, CATH(KHBUN))
C                                       random parameters
      J = KHPTP
      I = 2 * KIPTPN
      CALL RFILL (I, HBLANK, CATH(J))
C                                       axis parameters
      DO 20 I = 1,KICTPN
         J = I - 1
         CALL RFILL (2, HBLANK, CATH(KHCTP+2*J))
         CATR(KRCIC+J) = 1.0
         CATR(KRCRP+J) = 1.0
         CATBLK(KINAX+J) = 1
 20      CONTINUE
      CATBLK(KIGCN) = 0
      CATBLK(KIPCN) = 0
C                                       extensions
      CALL CATCLR (CATBLK)
C                                       now details
      CATBLK(KINAX) = NX
      IF (ISFREQ) THEN
         CATBLK(KIDIM) = 3
         CALL CHR2H (8, 'FREQ    ', 1, CATH(KHCTP))
         CATD(KDCRV) = OFREQ + FREQS(1)
         CATR(KRCIC) = FREQS(2) - FREQS(1)
      ELSE
         CATBLK(KIDIM) = 4
         CALL CHR2H (8, 'FQID    ', 1, CATH(KHCTP))
         CATD(KDCRV) = 1.0D0
         CALL CHR2H (8, 'FREQ    ', 1, CATH(KHCTP+6))
         CATBLK(KINAX+3) = 1
         CATD(KDCRV+3) = OFREQ
         CATR(KRCIC+3) = FINC(1)
         END IF
      CALL CHR2H (8, 'TIME    ', 1, CATH(KHCTP+2))
      CATBLK(KINAX+1) = NY
      CATD(KDCRV+1) = TIMR(1)
      CATR(KRCIC+1) = TAVG
      CALL CHR2H (8, 'STOKES  ', 1, CATH(KHCTP+4))
      CATBLK(KINAX+2) = 1
      J = STKVAL
      CATD(KDCRV+2) = VSTOK(J)
      IF (CATD(KDCRV+2).LT.0.0D0) CATR(KRCIC+2) = -1.0
      IF ((JLOCR.GE.0) .AND. (JLOCD.GE.0)) THEN
         J = CATBLK(KIDIM)
         CATBLK(KIDIM) = J + 2
         CALL CHR2H (8, 'RA---SIN', 1, CATH(KHCTP+2*J))
         CALL CHR2H (8, 'DEC--SIN', 1, CATH(KHCTP+2*J+2))
         CATR(KRCIC+J) = 0.0
         CATR(KRCIC+J+1) = 0.0
         CATD(KDCRV+J) = RAS
         CATD(KDCRV+J+1) = DECS
         END IF
      IF (NAMEOU.EQ.' ') NAMEOU = NAMEIN
      IF (CLAOU.EQ.' ') CLAOU = TSKNAM
      CALL CHR2H (12, NAMEOU, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOU, KHIMCO, CATH(KHIMN))
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHIMN))
      CATBLK(KIIMS) = SEQOU
      CALL MCREAT (DISKOU, SLOT, BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATE OUTPUT IMAGE FILE'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKOU
      FCNO(NCFILE) = SLOT
      FRW(NCFILE) = 2
C                                       start IO
      CALL ZPHFIL ('MA', DISKOU, SLOT, 1, PHNAME, IRET)
      CALL ZOPEN (LUNO, INDO, DISKOU, PHNAME, .TRUE., .TRUE., .TRUE.,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT IMAGE'
         GO TO 990
         END IF
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NX
      WIN(4) = NY
      BOI = 1
      CALL MINIT ('WRIT', LUNO, INDO, NX, NY, WIN, BUFF1, JBUFSZ, BOI,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT I/O TO OUTPUT IMAGE'
         GO TO 990
         END IF
      WASBLK = .FALSE.
      BMIN = 1.E10
      BMAX = -BMIN
      DO 50 IY = 1,NY
         CALL MDISK ('WRIT', LUNO, INDO, BUFF1, BIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT IMAGE'
            GO TO 990
            END IF
         DO 40 IX = 1,NX
            IF (IMAGE(IX,3,IY).EQ.FBLANK) THEN
               WASBLK = .TRUE.
            ELSE
               BMIN = MIN (BMIN, IMAGE(IX,3,IY))
               BMAX = MAX (BMAX, IMAGE(IX,3,IY))
               END IF
            BUFF1(BIND+IX-1) = IMAGE(IX,3,IY)
 40         CONTINUE
 50      CONTINUE
      CALL MDISK ('FINI', LUNO, INDO, BUFF1, BIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINISH WRITING OUTPUT IMAGE'
         GO TO 990
         END IF
      CALL ZCLOSE (LUNO, INDO, IRET)
      CATR(KRDMX) = BMAX
      CATR(KRDMN) = BMIN
      CATR(KRBLK) = 0.0
      IF (WASBLK) CATR(KRBLK) = FBLANK
C                                       history
      CALL DFTIMH (NX, DISKOU, SLOT, IUCNO, IRET)
C                                       error image
      IF (DOEBAR.GT.0.0) THEN
         CLAOU = 'DFTerr'
         CALL CHR2H (6, CLAOU, KHIMCO, CATH(KHIMN))
         CATBLK(KIIMS) = SEQOU
         CALL MCREAT (DISKOU, SLOT, BUFF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATE ERROR IMAGE FILE'
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKOU
         FCNO(NCFILE) = SLOT
         FRW(NCFILE) = 2
C                                       start IO
         CALL ZPHFIL ('MA', DISKOU, SLOT, 1, PHNAME, IRET)
         CALL ZOPEN (LUNO, INDO, DISKOU, PHNAME, .TRUE., .TRUE., .TRUE.,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING ERROR IMAGE'
            GO TO 990
            END IF
         WIN(1) = 1
         WIN(2) = 1
         WIN(3) = NX
         WIN(4) = NY
         BOI = 1
         CALL MINIT ('WRIT', LUNO, INDO, NX, NY, WIN, BUFF1, JBUFSZ, BOI
     *      ,IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT I/O TO ERROR IMAGE'
            GO TO 990
            END IF
         WASBLK = .FALSE.
         BMIN = 1.E10
         BMAX = -BMIN
         DO 90 IY = 1,NY
            CALL MDISK ('WRIT', LUNO, INDO, BUFF1, BIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITING ERROR IMAGE'
               GO TO 990
               END IF
            DO 80 IX = 1,NX
               IF (ERROR(IX,3,IY).EQ.FBLANK) THEN
                  WASBLK = .TRUE.
               ELSE
                  BMIN = MIN (BMIN, ERROR(IX,3,IY))
                  BMAX = MAX (BMAX, ERROR(IX,3,IY))
                  END IF
               BUFF1(BIND+IX-1) = ERROR(IX,3,IY)
 80            CONTINUE
 90         CONTINUE
         CALL MDISK ('FINI', LUNO, INDO, BUFF1, BIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'FINISH WRITING ERROR IMAGE'
            GO TO 990
            END IF
         CALL ZCLOSE (LUNO, INDO, IRET)
         CATR(KRDMX) = BMAX
         CATR(KRDMN) = BMIN
         CATR(KRBLK) = 0.0
         IF (WASBLK) CATR(KRBLK) = FBLANK
C                                       history
         CALL DFTIMH (NX, DISKOU, SLOT, IUCNO, IRET)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DFTIMO: ERROR',I4,' ON ',A)
      END
      SUBROUTINE DFTIMH (NX, DISK, CNO, INCNO, IRET)
C-----------------------------------------------------------------------
C   writes history to DFTIM
C   Inputs:
C      DISK   I   Disk number
C      CNO    I   Catalog number of output image
C   Output
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   NX, DISK, CNO, INCNO, IRET
C
      INCLUDE 'DFTIM.INC'
      INTEGER   LUN1, LUN2, IBUFF(256), OBUFF(256), I, VER, NI,
     *   FQID, IFSIDE, LF, LC
      CHARACTER HILINE*72, CLASS*6, BNDCOD*8
      DOUBLE PRECISION IFFREQ
      REAL      IFCHW, IFTBW
      HOLLERITH CATH(256)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (CATBLK, CATH)
      DATA LUN1, LUN2 / 45,46/
C-----------------------------------------------------------------------
C                                       Initialize HITAB
      CALL HIINIT (3)
C                                       Create and copy history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISK, INCNO, CNO, CATBLK, IBUFF,
     *   OBUFF, IRET)
      IF (IRET.GT.3) GO TO 999
      IF (IRET.EQ.3) GO TO 100
C                                       Add SUBIM history.
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, OBUFF,
     *   IRET)
      IF (IRET.NE.0) GO TO 100
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), CLASS)
      CALL HENCOO (TSKNAM, NAMEOU, CLASS, CATBLK(KIIMS), DISK, LUN2,
     *   OBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       shift
      WRITE (HILINE,2000) TSKNAM, SHIFT
      CALL HIADD (LUN2, HILINE, OBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       NCHAVG
      WRITE (HILINE,2001) TSKNAM, NCHAVG
      CALL HIADD (LUN2, HILINE, OBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       SOLINT
      WRITE (HILINE,2002) TSKNAM, SOLINT
      CALL HIADD (LUN2, HILINE, OBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       OPTYPE
      WRITE (HILINE,2003) TSKNAM, OPTYPE
      CALL HIADD (LUN2, HILINE, OBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       cal adverbs
      CALL CALHIS (LUN2, OBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       close
 100  CALL HICLOS (LUN2, .TRUE., OBUFF, I)
C                                       write FQ table
      IF (.NOT.ISFREQ) THEN
         VER = 1
         NI = 1
         CALL FQINI ('WRIT', FQBUFF, DISK, CNO, VER, CATBLK, LUN1,
     *      IFQRNO, FQKOLS, FQNUMV, NI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATING FQ TABLE'
            CALL MSGWRT (8)
            GO TO 200
            END IF
C                                       write
         IFSIDE = 1
         I = 0
         BNDCOD = ' '
         DO 120 LF = BIF,EIF
            DO 110 LC = BCHAN,ECHAN,NCHAVG
               I = I + 1
               IFQRNO = I
               IFFREQ = FREQS(I)
               FQID = I
               IFCHW = FINC(LF)*NCHAVG
               IFTBW = FINC(LF)*NCHAVG
               CALL TABFQ ('WRIT', FQBUFF, IFQRNO, FQKOLS, FQNUMV, NI,
     *            FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITING FQ TABLE'
                  CALL MSGWRT (8)
                  GO TO 200
                  END IF
 110           CONTINUE
 120        CONTINUE
         CALL TABFQ ('CLOS', FQBUFF, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *      FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, I)
         END IF
C
 200  CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'CLWR', IBUFF, I)
      IF (I.NE.0) THEN
         WRITE (MSGTXT,1000) I, 'ON UPDATE HEADER WITH CATIO'
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DFTIMH: ERROR',I4,' ON ',A)
 2000 FORMAT (A6,'SHIFT=',F9.4,',',F9.4,4X,'/ position shift in asec')
 2001 FORMAT (A6,'NCHAVG=',I4,18X,'/ channels averaged')
 2002 FORMAT (A6,'SOLINT=',F7.1,15X,'/ seconds averaging time')
 2003 FORMAT (A6,'OPTYPE=''',A,'''',15X,'/ type of data imaged')
      END

LOCAL INCLUDE 'CONPL.INC'
      CHARACTER NAMEIN*12, CLAIN*6, OUTFIL*48
      HOLLERITH XNAMIN(3), XCLAIN(2), XOUFIL(12)
      REAL      XSIN, XDISIN, XTYPE, XPARM(10), BPARM(10), DOCIRC,
     *   XDOTV, XGRCH
      INTEGER   SBUF(1024), CXTYPE, SEQIN, DISKIN, PVER, CNO, NPARM,
     *   GRCHN, TVCHN, TVCORN(4)
      LOGICAL   SCALEM(2,2), DOTV
C                                       Include for CONPL.
      COMMON /INPARM/ XNAMIN, XCLAIN, XSIN, XDISIN, XTYPE, XPARM,
     *   XOUFIL, BPARM, DOCIRC, XDOTV, XGRCH
      COMMON /CHPARM/ NAMEIN, CLAIN, OUTFIL
      COMMON /BUFRS/ SBUF
      COMMON /UVPCOM/ SCALEM, SEQIN, DISKIN, CNO, NPARM, CXTYPE,
     *   GRCHN, TVCHN, TVCORN, DOTV, PVER
LOCAL END
       PROGRAM CONPL
C-----------------------------------------------------------------------
C!  Task plots AIPS convolving functions
C#  Imaging AP Plot
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2008-2009, 2015, 2019-2020
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CONPL plots an AIPS convolving function
C   Inputs:
C     INNAME         NAMEIN        Name of main input file
C     INCLASS        CLAIN         Class of main input file
C     INSEQ          SEQIN         Seq. of main input file
C     INDISK         DISKIN        Disk number of main input file.
C     BPARM......Plot control parameters:
C        1 = Minimum of X-axis.
C        2 = Maximum of X-axis (if = BPARM(1) do self-scale in X).
C        3 = Minimum of Y-axis.
C        4 = Maximum of Y-axis (if = BPARM(3) do self-scale in Y).
C     DOTV........> 0 => plot directly on the TV device, otherwise
C                 make a plot file for later display on one or
C                 more devices (including the TV if desired).
C     GRCHAN......Graphics channel (1 - 3) to use for line drawing.
C                 0 => 1.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IERR, IRET
      INCLUDE 'CONPL.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'CONPL '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL CONIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Do plot
      CALL CONPLT (IRET)
C                                       Clear catlg on error
 990  IF ((IRET.EQ.0) .OR. (NCFILE.LT.1) .OR. (FRW(1).GT.0) .OR.
     *   (DOTV)) GO TO 995
         CALL DELEXT ('PL', FVOL(1), FCNO(1), 'READ', CATBLK, SBUF,
     *      PVER, IERR)
         NCFILE = NCFILE - 1
C                                       Close down
 995  CALL DIE (IRET, SBUF)
C
 999  STOP
      END
      SUBROUTINE CONIN (PRGM, JERR)
C-----------------------------------------------------------------------
C   CONIN gets input parameters for CONPL .
C   Inputs:  PRGM   C*6)      Program name
C   Output:  JERR   I         Error code: 0 => ok, else quit
C-----------------------------------------------------------------------
      CHARACTER INTYPE*2, STAT*4, PRGM*6
      INTEGER  JERR, IUSER, IERR, IROUND
      LOGICAL   T
      INCLUDE 'CONPL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init IO et al.
      CALL ZDCHIN (.TRUE., SBUF)
      CALL VHDRIN
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
      PVER = 10000
C                                       Get input parameters.
      NPARM = 43
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMIN, SBUF, IERR)
      IF (IERR.EQ.0) GO TO 10
         JERR = 8
         RQUICK = .TRUE.
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
C                                       Restart AIPS
 10   IF (RQUICK) CALL RELPOP (JERR, SBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 0
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMIN, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (48, 1, XOUFIL, OUTFIL)
C                                       Crunch input parameters.
      IUSER = NLUSER
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
C                                       Get CATBLK from file.
      CNO = 1
      INTYPE = ' '
      CALL CATDIR ('SRCH', DISKIN, CNO, NAMEIN, CLAIN, SEQIN, INTYPE,
     *   IUSER, STAT, SBUF, IERR)
      IF (IERR.EQ.0) GO TO 20
         WRITE (MSGTXT,1010) IERR, NAMEIN, CLAIN, SEQIN, DISKIN, IUSER
         GO TO 990
 20   STAT = 'WRIT'
      IF (DOTV) STAT = 'READ'
      CALL CATIO ('READ', DISKIN, CNO, CATBLK, STAT, SBUF, IERR)
      IF (IERR.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) IERR
         GO TO 990
 30   NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 1
      XSIN = SEQIN
      XDISIN = DISKIN
C                                       Set gridding function defaults.
      CXTYPE = IROUND (XTYPE)
      CXTYPE = ABS (CXTYPE)
      IF (CXTYPE.GT.10) CXTYPE = CXTYPE - 10
      CALL GRDFLT (CXTYPE, CXTYPE, XPARM, XPARM)
C                                       Update catalog header for PL
      FRW(NCFILE) = 0
      PVER = 0
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', DISKIN, FCNO(1), CATBLK, SBUF, T, 'READ',
     *      PVER, IERR)
         IF (IERR.NE.0) THEN
            NCFILE = NCFILE - 1
            WRITE (MSGTXT,1060) IERR
            GO TO 990
            END IF
         END IF
C                                       Autoscale ?
      SCALEM(1,1) = BPARM(1).GE.BPARM(2)
      SCALEM(2,1) = BPARM(3).GE.BPARM(4)
      SCALEM(1,2) = BPARM(5).GE.BPARM(6)
      SCALEM(2,2) = BPARM(7).GE.BPARM(8)
      GO TO 999
C                                       Error message
 990  CALL MSGWRT (8)
      JERR = 5
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CONIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('ERROR',I4,' FINDING ',A12,'.',A6,'.',I4,' DISK',I2,
     *   ' USER',I5)
 1020 FORMAT ('ERROR',I4,' READING CATALOG HEADER')
 1060 FORMAT ('ERROR',I5,' ADDING PL FILE TO HEADER')
      END
      SUBROUTINE CONPLT (IRET)
C-----------------------------------------------------------------------
C   CONPLT actually plots table data.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C                          1 => failed to add to catalog
C                          2 => failed to create
C                          3 => graph file write error
C                          4 => UV file IO error
C-----------------------------------------------------------------------
      CHARACTER TEXT*1024, PFILE*48, TIME*8, DATE*12, CHTYPS(6)*10
      INTEGER   BUFFER(256), IERR, ITYPE, IPSIZE, I, IRET, MM, LIM, NN,
     *   LUNPL, FINDPL, IAPARM(8), INCHAR, INP, J, K, IT(3), ID(3),
     *   NUMPRM(6), NGOOD(2), NNOFIT(2), KAP, XCEN, XSIZ(3), LIM2,
     *   XCEN2, FTSIZ, L, TLUN, TIND, ITRIM, IL
      REAL      BLC(2), TRC(2), CHOUT(4), XYRATO, DX, CBUF(8192),
     *   DY, XY(2), XYSCL(2), XYOFF(2), TEMP, DBUF(8192), EBUF(8192),
     *   XSCAL, FTFAC, FTMAX
      LOGICAL   DOGRID, DOWN
      DOUBLE PRECISION APCORE(2)
      INCLUDE 'CONPL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DAPM.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUNPL, TLUN /26, 3/
      DATA NUMPRM /1, 3, 2, 4, 2, 4/
      DATA CHTYPS /'PILL BOX', 'EXPONTIAL', 'SIN(X) / X', 'EXP * SINC',
     *   'SPHEROIDAL', 'EXP*BESSJ1'/
      DATA XSIZ /850, 510, 1100/
      DATA FTSIZ /2048/
C-----------------------------------------------------------------------
      NGOOD(1) = 0
      NNOFIT(1) = 0
      NGOOD(2) = 0
      NNOFIT(2) = 0
      IRET = 1
C                                       Open text file
      TIND = 0
      IF (OUTFIL.NE.' ') THEN
         CALL ZTXOPN ('WRIT', TLUN, TIND, OUTFIL, .TRUE., IERR)
         IF (IERR.NE.0) THEN
            OUTFIL = ' '
            TIND = 0
            END IF
         END IF
C                                       Open AP
C                                       default will be enough
      CALL QINIT (APCORE, 0, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
         IRET = 10
         MSGTXT = 'CANNOT GET ANY AP MEMORY'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Compute function
      XSCAL = 0.01
      MM = MAX (XPARM(1), 1.0) + 0.001
      MM = 2 * MM + 1
      LIM = 100 * MM + 1
      XCEN = 50 * MM + 1
      CALL CONVFN (APCORE, 1, CXTYPE, XPARM, CBUF)
      IF (SCALEM(1,1)) THEN
         BPARM(1) = - 0.5 * MM
         BPARM(2) = 0.5 * MM
         END IF
      IF (SCALEM(2,1)) THEN
         BPARM(3) = 1.E6
         BPARM(4) = -BPARM(3)
         DO 10 I = 1,LIM
            BPARM(3) = MIN (BPARM(3), CBUF(I))
            BPARM(4) = MAX (BPARM(4), CBUF(I))
 10         CONTINUE
         END IF
C                                       Adjust the scales
      DO 20 I = 1,2
         XYSCL(I) = BPARM(2*I)
         XYOFF(I) = BPARM(2*I-1)
         TEMP = 0.035 * (XYSCL(I) - XYOFF(I))
         XYSCL(I) = XYSCL(I) + TEMP
         XYOFF(I) = XYOFF(I) - TEMP
         IF (XYSCL(I).EQ.XYOFF(I)) GO TO 999
         XYSCL(I) = XSIZ(I) / (XYSCL(I)-XYOFF(I))
 20      CONTINUE
C                                       Fill in last of actual parms
      BPARM(2) = XSIZ(1)/XYSCL(1) + XYOFF(1)
      BPARM(4) = XSIZ(2)/XYSCL(2) + XYOFF(2)
      BPARM(1) = XYOFF(1)
      BPARM(3) = XYOFF(2)
C                                       Create plot file
      CALL ZPHFIL ('PL', DISKIN, FCNO(1), PVER, PFILE, IERR)
      IF (IERR.NE.0) GO TO 999
      IPSIZE = 0
      ITYPE = 60
      CALL GINIT (DISKIN, FCNO(1), PFILE, IPSIZE, ITYPE, NPARM, XNAMIN,
     *   DOTV, TVCHN, GRCHN, TVCORN, CATBLK, BUFFER, LUNPL, FINDPL,
     *   IERR)
      IRET = 2
      IF (IERR.NE.0) GO TO 999
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = XSIZ(1)
      TRC(2) = XSIZ(3)
      XYRATO = 1.0
      CHOUT(1) = 9.0
      CHOUT(2) = 3.0
      CHOUT(3) = 0.5
      CHOUT(4) = 4.0
      IRET = 3
      CALL FILL (5, 1, IAPARM)
C                                       Set up location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      DO 30 I = 1,2
         RPLOC(I,LOCNUM) = BLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I)
         AXINC(I,LOCNUM) = 1.0 / XYSCL(I)
 30      CONTINUE
      CPREF(1,LOCNUM) = ' '
      CPREF(2,LOCNUM) = ' '
      CTYP(1,LOCNUM) = 'PIXELS'
      CTYP(2,LOCNUM) = 'CONVOLUTION FUNCTION'
      CALL CHNTIC (BLC, TRC, INP)
      IF (INP.GT.0) CHOUT(1) = 4.5 + INP
C                                       Init for line drawing.
      CALL GINITL (BLC, TRC, XYRATO, CHOUT, IAPARM, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 975
C                                       Reset for half drawing
      BLC(2) = TRC(2) - XSIZ(2)
      RPLOC(2,LOCNUM) = BLC(2)
C                                       Draw border
      CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (BLC(1), BLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (TRC(1), BLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (TRC(1), TRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (BLC(1), TRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Top labels: type & name
      DX = 0.0
      DY = CHOUT(4) - 1.5
      CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, TIME, DATE)
      WRITE (TEXT,1030) PVER, DATE, TIME
      INCHAR = 51
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Text file header
      IF (OUTFIL.NE.' ') THEN
         IL = ITRIM (TEXT)
         CALL ZTXIO ('WRIT', TLUN, TIND, TEXT(:IL), IERR)
         IF (IERR.NE.0) OUTFIL = ' '
         END IF
      IF (OUTFIL.NE.' ') THEN
         TEXT = '******** Convolution function ********'
         IL = ITRIM (TEXT)
         CALL ZTXIO ('WRIT', TLUN, TIND, TEXT(:IL), IERR)
         IF (IERR.NE.0) OUTFIL = ' '
         END IF
C                                       Top labels: convolution type
      DY = DY - 1.6
      CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      WRITE (TEXT,1031) CHTYPS(CXTYPE), (XPARM(I), I = 1,NUMPRM(CXTYPE))
      INCHAR = 18 + 8 * NUMPRM(CXTYPE)
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Text file parameters, type
      IF (OUTFIL.NE.' ') THEN
         IL = ITRIM (TEXT)
         CALL ZTXIO ('WRIT', TLUN, TIND, TEXT(:IL), IERR)
         IF (IERR.NE.0) OUTFIL = ' '
         END IF
      IF (OUTFIL.NE.' ') THEN
         TEXT = 'X cells    func'
         IL = ITRIM (TEXT)
         CALL ZTXIO ('WRIT', TLUN, TIND, TEXT(:IL), IERR)
         IF (IERR.NE.0) OUTFIL = ' '
         END IF
C                                       Put on labels and ticks
      DOGRID = DOCIRC.GT.0.0
      CALL CLAB1 (BLC, TRC, CHOUT, 3, XYRATO, DOGRID, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Read table file:
      DX = 0.005 * XYSCL(1)
      DOWN = .FALSE.
C                                       Loop
      DO 50 I = 1,LIM
         XY(1) = XSCAL * (I - XCEN)
         XY(2) = CBUF(I)
         IF (OUTFIL.NE.' ') THEN
            IF ((I.GE.XCEN) .AND. (MOD(I-XCEN,2).EQ.0)) THEN
               WRITE (TEXT,1035) XY
               IL = ITRIM (TEXT)
               CALL ZTXIO ('WRIT', TLUN, TIND, TEXT(:IL), IERR)
               IF (IERR.NE.0) OUTFIL = ' '
               END IF
            END IF
         DO 40 J = 1,2
            XY(J) = XYSCL(J) * (XY(J) - XYOFF(J))
            XY(J) = XY(J) + BLC(J)
            IF ((XY(J).LT.BLC(J)) .OR. (XY(J).GT.TRC(J))) THEN
               NNOFIT(1) = NNOFIT(1) + 1
               DOWN = .FALSE.
               GO TO 50
               END IF
 40         CONTINUE
         NGOOD(1) = NGOOD(1) + 1
         IF (DOWN) THEN
            CALL GVEC (XY(1), XY(2), BUFFER, IRET)
         ELSE
            CALL GPOS (XY(1), XY(2), BUFFER, IRET)
            END IF
         IF (IRET.NE.0) GO TO 970
         DOWN = .TRUE.
 50      CONTINUE
C                                       S/N computations
      IF (BPARM(9).LE.-1.0) THEN
         LIM2 = LIM * 2 - 1
         XCEN2 = LIM
C                                       autocorrelation of C.F.
         NN = 2 * MM - 1
         CALL RFILL (LIM2, 0.0, DBUF)
         DO 110 I = 1,NN
            L = (I - (NN+1)/2) * 100 + XCEN2
            DO 105 J = 1,LIM
               K = J + XCEN2 - L
               IF ((K.GE.1) .AND. (K.LE.LIM)) DBUF(L) = DBUF(L) +
     *            CBUF(J) * CBUF(K)
 105           CONTINUE
 110        CONTINUE
C                                       Fourier transform it
         FTFAC = TWOPI / (100.0 * FTSIZ)
         XCEN = FTSIZ/2 + 1
         FTMAX = -1.E10
         DO 120 I = 1,FTSIZ
            TEMP = FTFAC * (I - XCEN)
            EBUF(I) = 0.0
            DO 115 J = 1,NN
               K = (J - (NN+1)/2) * 100
               EBUF(I) = EBUF(I) + COS (TEMP*K) * DBUF(K+XCEN2)
 115           CONTINUE
            FTMAX = MAX (FTMAX, EBUF(I))
 120        CONTINUE
         IF (FTMAX.NE.0.0) THEN
            DO 125 I = 1,FTSIZ
               EBUF(I) = EBUF(I) / FTMAX
 125           CONTINUE
            END IF
         END IF
C                                       Plot the other half: FFT
      IF (BPARM(9).LE.0.0) THEN
         LIM = FTSIZ
         XCEN = LIM/2 + 1
         I = 4 * LIM
         CALL GRDTAB (APCORE, LIM, XCEN, CXTYPE, XPARM, 0, I, DBUF)
         CALL QGET (APCORE, CBUF, 0, LIM, 2)
         CALL QWD
         XSCAL = 1.0 / LIM
         IF (SCALEM(1,2)) THEN
            BPARM(5) = -0.5
            BPARM(6) = 0.5 - XSCAL
            END IF
C                                       Noise-to-signal
         IF (BPARM(9).LE.-1.0) THEN
            FTMAX = CBUF(XCEN) * SQRT (MAX (1.E-10, EBUF(XCEN)))
            DO 130 I = 1,FTSIZ
               CBUF(I) = CBUF(I) * SQRT (MAX (1.E-10, EBUF(I))) / FTMAX
 130           CONTINUE
            END IF
C                                       Log
         IF (BPARM(10).GT.1.5) THEN
            IF (BPARM(9).LE.-1.0) THEN
               CTYP(2,LOCNUM) = 'LOG (SIGNAL / NOISE)'
            ELSE
               CTYP(2,LOCNUM) = 'LOG (FFT (CONV FUNC))'
               END IF
            DO 140 I = 1,LIM
               IF (CBUF(I).NE.0.0) THEN
                  CBUF(I) = -LOG10 (ABS (CBUF(I)))
               ELSE
                  CBUF(I) = 0.0
                  END IF
 140           CONTINUE
         ELSE IF (BPARM(10).GT.0.0) THEN
            IF (BPARM(9).LE.-1.0) THEN
               CTYP(2,LOCNUM) = 'SIGNAL / NOISE'
            ELSE
               CTYP(2,LOCNUM) = 'FFT (CONV FUNC)'
               END IF
            DO 145 I = 1,LIM
               IF (CBUF(I).NE.0.0) THEN
                  CBUF(I) = 1.0 / CBUF(I)
               ELSE
                  CBUF(I) = 0.0
                  END IF
 145           CONTINUE
         ELSE
            IF (BPARM(9).LE.-1.0) THEN
               CTYP(2,LOCNUM) = 'NOISE / SIGNAL'
            ELSE
               CTYP(2,LOCNUM) = '1 / FFT (CONV FUNC)'
               END IF
            END IF
         CTYP(1,LOCNUM) = 'IMAGE DIAMETERS'
C                                       Convolve conv func w Gaussian
      ELSE
         CTYP(2,LOCNUM) = 'SMOOTHED CONV FUNC'
         CALL RCOPY (LIM, CBUF, DBUF)
         LIM2 = LIM
         TEMP = SQRT ((300. * BPARM(9))**2 + (LIM)**2)
         LIM = TEMP / 2
         LIM = 2 * LIM + 1
         XCEN2 = (LIM2+1)/2
         XCEN = (LIM+1)/2
         FTFAC = 4.0 * LOG (2.0) / BPARM(9) / BPARM(9) / 1.0E4
         FTMAX = -1.E10
         DO 160 I = 1,LIM
            CBUF(I) = 0.0
            DO 155 J = 1,LIM2
               TEMP = FTFAC * ((J - I - XCEN2 + XCEN) ** 2)
               IF (TEMP.LT.10.0) CBUF(I) = CBUF(I) + DBUF(J) *
     *            EXP (-TEMP)
 155           CONTINUE
            FTMAX = MAX (FTMAX, CBUF(I))
 160        CONTINUE
         IF (FTMAX.NE.0.0) THEN
            DO 165 I = 1,LIM
               CBUF(I) = CBUF(I) / FTMAX
 165           CONTINUE
            END IF
         IF (SCALEM(1,2)) THEN
            BPARM(5) = (1 - XCEN) * XSCAL
            BPARM(6) = (LIM - XCEN) * XSCAL
            END IF
         END IF
C                                       self-scale Y values
      IF (SCALEM(2,2)) THEN
         BPARM(7) = 1.E6
         BPARM(8) = -BPARM(7)
         DO 215 I = 1,LIM
            BPARM(7) = MIN (BPARM(7), CBUF(I))
            BPARM(8) = MAX (BPARM(8), CBUF(I))
 215        CONTINUE
         END IF
C                                       Adjust the scales
      DO 220 I = 1,2
         XYSCL(I) = BPARM(4+2*I)
         XYOFF(I) = BPARM(3+2*I)
         TEMP = 0.035 * (XYSCL(I) - XYOFF(I))
         XYSCL(I) = XYSCL(I) + TEMP
         XYOFF(I) = XYOFF(I) - TEMP
         IF (XYSCL(I).EQ.XYOFF(I)) GO TO 999
         XYSCL(I) = XSIZ(I) / (XYSCL(I)-XYOFF(I))
 220     CONTINUE
C                                       Fill in last of actual parms
      BPARM(6) = XSIZ(1)/XYSCL(1) + XYOFF(1)
      BPARM(8) = XSIZ(2)/XYSCL(2) + XYOFF(2)
      BPARM(5) = XYOFF(1)
      BPARM(7) = XYOFF(2)
C                                       bottom half coords
      BLC(2) = 0.0
      TRC(2) = XSIZ(2)
      DO 230 I = 1,2
         RPLOC(I,LOCNUM) = BLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I)
         AXINC(I,LOCNUM) = 1.0 / XYSCL(I)
 230     CONTINUE
C                                       Draw border
      CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (BLC(1), BLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (TRC(1), BLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (TRC(1), TRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (BLC(1), TRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Text file header
      IF (OUTFIL.NE.' ') THEN
         TEXT = '****** ' // CTYP(2,LOCNUM)(:ITRIM(CTYP(2,LOCNUM))) //
     *      ' vs ' // CTYP(1,LOCNUM)(:ITRIM(CTYP(1,LOCNUM)))  //
     *      ' ******'
         IL = ITRIM (TEXT)
         CALL ZTXIO ('WRIT', TLUN, TIND, TEXT(:IL), IERR)
         IF (IERR.NE.0) OUTFIL = ' '
         END IF
C                                       Put on labels and ticks
      CALL CLAB1 (BLC, TRC, CHOUT, 3, XYRATO, DOGRID, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Read table file:
      DOWN = .FALSE.
C                                       Loop
      DO 250 I = 1,LIM
         XY(1) = XSCAL * (I - XCEN)
         XY(2) = CBUF(I)
         IF (OUTFIL.NE.' ') THEN
            IF ((I.GE.XCEN) .AND. (MOD(I-XCEN,2).EQ.0)) THEN
               WRITE (TEXT,1235) XY
               IL = ITRIM (TEXT)
               CALL ZTXIO ('WRIT', TLUN, TIND, TEXT(:IL), IERR)
               IF (IERR.NE.0) OUTFIL = ' '
               END IF
            END IF
         DO 240 J = 1,2
            XY(J) = XYSCL(J) * (XY(J) - XYOFF(J))
            XY(J) = XY(J) + BLC(J)
            IF ((XY(J).LT.BLC(J)) .OR. (XY(J).GT.TRC(J))) THEN
               NNOFIT(2) = NNOFIT(2) + 1
               DOWN = .FALSE.
               GO TO 250
               END IF
 240        CONTINUE
         NGOOD(2) = NGOOD(2) + 1
         IF (DOWN) THEN
            CALL GVEC (XY(1), XY(2), BUFFER, IRET)
         ELSE
            CALL GPOS (XY(1), XY(2), BUFFER, IRET)
            END IF
         IF (IRET.NE.0) GO TO 970
         DOWN = .TRUE.
 250     CONTINUE
C                                       Done: finish plot
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.NE.0) GO TO 975
         IRET = 0
         GO TO 990
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 990
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         END IF
      IF (TIND.GT.0) CALL ZTXCLS (TLUN, TIND, IERR)
      GO TO 999
C                                       No catalog update
C                                       Messages
 990  WRITE (MSGTXT,1990) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT(1)+NNOFIT(2).GT.0) THEN
         WRITE (MSGTXT,1991) NNOFIT
         CALL MSGWRT (2)
         END IF
      IF (.NOT.DOTV) THEN
         CALL HIPLOT (DISKIN, FCNO(1), PVER, BUFFER, IERR)
         WRITE (MSGTXT,1993) PVER
         CALL MSGWRT (2)
         END IF
      IF (TIND.GT.0) CALL ZTXCLS (TLUN, TIND, IERR)
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('Plot file version',I4,'  created ',A12,A8)
 1031 FORMAT (A,' PARMS =',8F8.4)
 1035 FORMAT (F7.3,F8.3)
 1235 FORMAT (2F9.3)
 1970 FORMAT ('CONPLT: Error during graphing. will try to finish',
     *   ' partial graph')
 1990 FORMAT ('CONPLT: ',2I8,' points plotted')
 1991 FORMAT ('CONPLT: ',2I8,' points did not fit')
 1993 FORMAT ('CONPLT: Plot file version',I4,' created.')
      END

      SUBROUTINE MADD (INLUN1, INLUN2, OUTLUN, FACT1, FACT2,
     *   DATA1, DATA2, DATA3, XMIN, XMAX, BLANK, IERR)
C-----------------------------------------------------------------------
C! Routine to add windows of open images.
C# IO-wawa Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   MADD (for use with WAWA IO only) will add one windowed section of
C   an open map file to another windowed section of an open map file and
C   put the results into another open windowed file.  The second input
C   map may be the same as the output map (opened under a different LUN)
C   if the windows do not overlap or overlap exactly.
C   THIS PROGRAM USES COMMON MAPHDR AS A WORK BUFFER.
C    Inputs:
C          INLUN1  I   input map 1 LUN.
C          INLUN2  I   input map 2 LUN.
C          OUTLUN  I   output map LUN.
C          FACT1   R   multiplication factor for map 1.
C          FACT2   R   multiplication factor for map 2.
C          DATA1   R(*)   IO buffer big enough for 1 row.
C          DATA2   R(*)   IO buffer big enough for 1 row.
C          DATA3   R(*)   IO buffer big enough for 1 row.  If input
C                  map two is the same as the output map, and the
C                  windows overlap exactly, this buffer can be the
C                  same as DATA2.
C     Outputs:
C          XMIN    R   map min of windowed output map.
C          XMAX    R   map max of windowed output map.
C          BLANK   L   True if magic value blank pixel found else false
C          IERR    I   standard WAWA IO error code.
C-----------------------------------------------------------------------
      CHARACTER C0*12
      REAL      DATA1(*), DATA2(*), DATA3(*)
      REAL      FACT1, FACT2, XMAX, XMIN, D0
      INTEGER   IBLC1(7), ITRC1(7), IBLC2(7), ITRC2(7), IBLC3(7),
     *   ITRC3(7), IERR, INODI1, INODI2, INODI3, INVOL2, OUTLUN,
     *   INLUN1, IPIXS1, IPIXS2, IPIXS3, IPIXS4, IPIXS5, IPIXS6, IPIXS7,
     *   IDMAX, IDIM, INSLT2, OUTSLT, OUTVOL, IPTR, INLUN2,
     *   I7, I6, I5, I4, I3, I2, I1
      LOGICAL   DOCLR, T, F, BLANK
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T /.TRUE./, F /.FALSE./
C-----------------------------------------------------------------------
C                                       Initialize XMIN and XMAX
      XMIN = 1.0E30
      XMAX = - XMIN
      BLANK = F
C                                       Get window information
      CALL GETWIN (INLUN1, INODI1, IBLC1, ITRC1, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GETWIN (INLUN2, INODI2, IBLC2, ITRC2, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GETWIN (OUTLUN, INODI3, IBLC3, ITRC3, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Verify windows match.
      IDMAX = MAX (INODI1, INODI2)
      IDMAX = MAX (IDMAX, INODI3)
      DO 20 IDIM = 1,IDMAX
         IF (((ITRC1(IDIM) - IBLC1(IDIM)).NE.(ITRC2(IDIM) - IBLC2(IDIM))
     *      .AND. ((ITRC1(IDIM) - IBLC1(IDIM))).NE.(ITRC3(IDIM) -
     *      IBLC3(IDIM))))
     *      GO TO 980
 20      CONTINUE
C                                       Figure out if IN/OUT file.
      DO 70 IPTR = 1,EFIL
         IF (FILTAB(POLUN,IPTR).NE.INLUN2) GO TO 30
            INSLT2 = FILTAB(POCAT,IPTR)
            INVOL2 = FILTAB(POVOL,IPTR)
C
 30      CONTINUE
         IF (FILTAB(POLUN,IPTR).NE.OUTLUN) GO TO 70
            OUTSLT = FILTAB(POCAT,IPTR)
            OUTVOL = FILTAB(POVOL,IPTR)
 70      CONTINUE
C                                       If in equals out we must clear
C                                       READ later on.
      DOCLR = F
      IF ((OUTVOL.EQ.INVOL2) .AND. (OUTSLT.EQ.INSLT2)) DOCLR = T
C                                       Do add.
      IPIXS1 = ITRC1(1) - IBLC1(1) + 1
      IPIXS2 = ITRC1(2) - IBLC1(2) + 1
      IPIXS3 = ITRC1(3) - IBLC1(3) + 1
      IPIXS4 = ITRC1(4) - IBLC1(4) + 1
      IPIXS5 = ITRC1(5) - IBLC1(5) + 1
      IPIXS6 = ITRC1(6) - IBLC1(6) + 1
      IPIXS7 = ITRC1(7) - IBLC1(7) + 1
      DO 700 I7 = 1,IPIXS7
      DO 600 I6 = 1,IPIXS6
      DO 500 I5 = 1,IPIXS5
      DO 400 I4 = 1,IPIXS4
      DO 300 I3 = 1,IPIXS3
      DO 200 I2 = 1,IPIXS2
         CALL MAPIO ('READ', INLUN1, DATA1, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL MAPIO ('READ', INLUN2, DATA2, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       If IN2 = OUT we must clear this
C                                       READ so we can set WRIT status.
         IF (.NOT.DOCLR) GO TO 80
            CALL CATDIR ('CSTA', INVOL2, INSLT2, C0, C0, D0, C0, D0,
     *         'CLRD', CATBLK, IERR)
            DOCLR = F
C
 80      CONTINUE
         DO 100 I1 = 1,IPIXS1
            IF ((DATA1(I1).NE.FBLANK) .AND. (DATA2(I1).NE.FBLANK))
     *         THEN
C                                       Not blanked pixel.
               DATA3(I1) = FACT1 * DATA1(I1) + FACT2 * DATA2(I1)
               XMIN = MIN (XMIN, DATA3(I1))
               XMAX = MAX (XMAX, DATA3(I1))
C                                       Blanked pixel.
            ELSE
               DATA3(I1) = FBLANK
               BLANK = T
               END IF
C
 100        CONTINUE
         CALL MAPIO ('WRIT', OUTLUN, DATA3, IERR)
         IF (IERR.NE.0) GO TO 999
 200     CONTINUE
 300     CONTINUE
 400     CONTINUE
 500     CONTINUE
 600     CONTINUE
 700     CONTINUE
      GO TO 999
C                                       Window mis-match error.
 980  CONTINUE
      IERR = 16
C
 999  RETURN
      END

      SUBROUTINE MINSK (LUN, FIND, LROW, NROW, ISTRT, NSKIP, BUFF,
     *   XBUFSZ, BO, NBUF, IERR)
C-----------------------------------------------------------------------
C! inits use of MSKIP to read noncontiguous, evenly spaced rows in a map
C# AP-fft Map-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   MINSK initializes the use of MSKIP to read noncontigious but evenly
C   spaced rows in a map.  Read is double buffered if possible; in which
C   case MINSK initiates the first read.  Single buffering is used if
C   the desired data cannot be double buffered.  If more data is
C   required than will fit in the buffer, multiple (NBUF) equally filled
C   buffers are obtained by NBUF calls to MSKIP.
C   Inputs:
C      LUN    I     Logical unit number.
C      FIND   I     pointer to FTAB returned by ZOPEN.
C      LROW   I     Length of a row in pixels.
C      NROW   I     Total number of rows this plane.
C      ISTRT  I     First row for read.
C      NSKIP  I     Number of rows to skip.
C      BUFF   R(*)  Output buffer.
C      XBUFSZ  I     Buffer size in AIPS bytes.
C      BO     I     Block offset
C      NBUF   I     factor times which LROW is multiplied normally = 1.
C   OUTPUT:
C     NBUF    I     number of buffer fulls to complete read of row.
C                   MSKIP must be called this number of times to
C                   complete the read.
C     IERR    I     Error code: 0 = OK
C                        1 = file not open
C                        2 = input error
C                        4 = tried to read past end of map.
C                      10+ = 10 + ZMIO or ZWAIT error.
C   FTAB assigments:
C              0 = LUN
C              1 =
C              2 = BO block offset
C              3 =
C              4 = length of row / [5] in bytes
C              5 = multiplier of [4]
C              6 = next record number.
C              7 = record increment+1 (total increment)
C              8 = # calls per record.
C              9 = record call # (when MSKIP is called)
C             10 = bytes / call
C             11 = buffer flag, -1= single, 1=>current buffer is 1
C                  2=>current buffer=2 (buffer already read)
C             12 = buffer size in pixels (1/2 for double buffering)
C             13 = NROW (the number of rows to read)
C             14 = BTYOFF the byte offset when double buffering.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, LROW, NROW, ISTRT, NSKIP, XBUFSZ, BO, NBUF,
     *   IERR
      REAL      BUFF(*)
      INTEGER   NBYTES, NSEC, IER, KBUFSZ, XNBUF, TEMP, BUFSZ
      DOUBLE PRECISION DPTEMP
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Check input values.
      IERR = 2
      CALL POWER2 (XBUFSZ, BUFSZ)
C                                       See if first row.GT.last row.
      IF (ISTRT.GT.NROW) GO TO 999
C                                       See if file open.
      IERR = 1
      IF (LUN.NE.FTAB(FIND)) GO TO 999
      IERR = 0
C                                       Store input values.
      FTAB(FIND+2) = BO
      FTAB(FIND+6) = ISTRT
      FTAB(FIND+7) = NSKIP
      FTAB(FIND+9) = 1
      FTAB(FIND+11) = -1
      FTAB(FIND+12) = BUFSZ / 2
      FTAB(FIND+13) = NROW
      FTAB(FIND+14) = 0
C                                       See if double, single or
C                                       multiple buffering.
      XNBUF = 2 * LROW * NBUF
C                                       Check if XNBUF an exact multiple
C                                       of NBPS.
      TEMP = MOD (XNBUF, NBPS)
      KBUFSZ = 0
      IF (ABS(TEMP).GE.1) KBUFSZ = NBPS
C                                       Double buffer, fill FTAB.
      IF (((XNBUF+KBUFSZ)*2).LE.BUFSZ) THEN
         FTAB(FIND+4) = XNBUF
         FTAB(FIND+5) = 1
         FTAB(FIND+6) = FTAB(FIND+6) + NSKIP
         FTAB(FIND+8) = 1
         FTAB(FIND+10) = XNBUF
         FTAB(FIND+11) = 1
         FTAB(FIND+12) = BUFSZ / 4
         FTAB(FIND+13) = FTAB(FIND+13) + ISTRT
C                                       Initiate first read.
C                                       Get byte offset.
         DPTEMP = (ISTRT-1) * XNBUF
         DPTEMP = DPTEMP / NBPS + BO
         NSEC = DPTEMP
         FTAB(FIND+14) = (DPTEMP-NSEC) * NBPS + 0.3D0
C                                       Do I/O
         NBYTES = FTAB(FIND+14) + FTAB(FIND+10)
         CALL ZMIO ('READ', LUN, FIND, NSEC, NBYTES, BUFF, 1, IER)
         IERR = IERR + 10 * IER
         GO TO 999
      ELSE
C                                       Single buffer or multbuffer
C                                       Multiple buffer loads, see how
C                                       many.
         NBUF = (XNBUF + KBUFSZ - 1) / BUFSZ + 1
         NBUF = MAX (1, NBUF)
C                                          Fill FTAB.
         FTAB(FIND+4) = XNBUF / (2 * NBUF)
         FTAB(FIND+5) = 2 * NBUF
         FTAB(FIND+8) = NBUF
         FTAB(FIND+10) = XNBUF / NBUF
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'FGPRT.INC'
C                                       Local include for FGPRT
      INCLUDE 'INCS:DSEL.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XPRINT(12)
      REAL      XSIN, XDISIN, XFLAG, XTIME(8), XFQID, XSUBA, XBIF, XEIF,
     *   XBCHAN, XECHAN, DOCRT,
     *   SCRBUF(512), BUFF2(UVBFSS)
      INTEGER   SEQIN, DISKIN, JBUFSZ, CNO, NUMIFS, NUMCHN,
     *   FGCNT(MAXANT,MAXANT), NUMA
      CHARACTER NAMEIN*12, CLAIN*6, XSOUR(30)*16, LPNAME*48
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XFLAG, XXSOUR,
     *   XTIME, XFQID, XSUBA, XBIF, XEIF, XBCHAN, XECHAN, DOCRT, XPRINT
      COMMON /FGPRTP/ SEQIN, DISKIN, CNO, NUMIFS, NUMCHN, FGCNT, NUMA
      COMMON /CHARPM/ NAMEIN, CLAIN, XSOUR, LPNAME
      COMMON /BUFRS/ SCRBUF, BUFF2, JBUFSZ
      INCLUDE 'INCS:DMSG.INC'
C                                       End local include for FGPRT
LOCAL END
      PROGRAM FGPRT
C-----------------------------------------------------------------------
C! counts samples within limits in an FG table
C# Utility UV editing hardcopy
C-----------------------------------------------------------------------
C;  Copyright (C) 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'FGPRT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'FGPRT'/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL FGPRTI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine to count
      CALL FGPRTC (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       now display the result
      CALL FGPRTT (IRET)
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE FGPRTI (PRGN, JERR)
C-----------------------------------------------------------------------
C   FGPRTI gets input parameters for FGPRT
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, I
      REAL      CATR(256)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'FGPRT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 155
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      IF ((IERR.NE.0) .OR. (NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   DOCRT = MIN (-1.0, DOCRT)
      IF (DOCRT.GT.0.0) RQUICK = .FALSE.
      CALL H2CHR (48, 1, XPRINT, LPNAME)
      IF (RQUICK) RQUICK = LPNAME.NE.' '
      IF (RQUICK) CALL RELPOP (IERR, SCRBUF, JERR)
      IF (IERR.NE.0) GO TO 999
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), SOURCS(I))
 10      CONTINUE
      DISKIN = IROUND (XDISIN)
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.EQ.0) SUBARR = 1
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
C                                       Get CATBLK from old file.
      CNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1030) JERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, CNO, CATBLK, 'REST', SCRBUF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1000) JERR, 'READING HEADR'
         GO TO 990
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
         NUMIFS = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         NUMIFS = CATBLK(KINAX+JLOCIF)
         BIF = MIN (MAX (1, BIF), NUMIFS)
         IF (EIF.LT.BIF) EIF = NUMIFS
         END IF
      NUMCHN = CATBLK(KINAX+JLOCF)
      BCHAN = IROUND (XBCHAN)
      ECHAN = IROUND (XECHAN)
      IF ((BCHAN.LE.0) .OR. (BCHAN.GT.NUMCHN)) BCHAN = 1
      IF ((ECHAN.LE.0) .OR. (ECHAN.GT.NUMCHN)) ECHAN = NUMCHN
      IF (BCHAN.GT.ECHAN) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
C                                       Freq id
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
C                                       antenna info
      CALL GETANT (DISKIN, CNO, SUBARR, CATBLK, SCRBUF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1000) JERR, 'GETTING ANTENNA INFO'
         GO TO 990
         END IF
      NUMA = NSTNS
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, CNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', SCRBUF, JERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 0
C                                       list of source numbers
      CALL FNDEXT ('SU', CATBLK, I)
      IF (I.LE.0) THEN
         NSOUWD = 0
      ELSE
         CALL FNDSOU (DISKIN, CNO, SOURCS, SCRBUF, NSOUWD, DOSWNT,
     *      SOUWAN, JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1000) JERR, 'FINDING SOURCE LIST'
            GO TO 990
            END IF
         END IF
      I = MAXANT * MAXANT
      CALL FILL (I, 0, FGCNT)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FGPRTI: ERROR',I3,1X,A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
      END
      SUBROUTINE FGPRTC (IRET)
C-----------------------------------------------------------------------
C   FGPRTC counts in a baseline based way the flags
C   Outprt:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'FGPRT.INC'
      INTEGER   FGLUN, FGBUF(512), IVER, I, J, IFGRNO, FGKOLS(MAXFGC),
     *   FGNUMV(MAXFGC), IROW, NROWS, SOURID, SUBA, FREQID, ANTS(2),
     *   IFS(2), CHANS(2), II, JJ
      REAL      TIMER(2)
      CHARACTER REASON*24
      LOGICAL   PFLAGS(4)
      DATA FGLUN /29/
C-----------------------------------------------------------------------
      CALL FNDEXT ('FG', CATBLK, I)
      IVER = XFLAG
      IF (IVER.LE.0) IVER = I
      IF (IVER.LE.0) THEN
         MSGTXT = 'NO FLAG TABLE FOUND'
         IRET = 10
         GO TO 990
         END IF
C                                       open flag table
      CALL FLGINI ('READ', FGBUF, DISKIN, CNO, IVER, CATBLK, FGLUN,
     *   IFGRNO, FGKOLS, FGNUMV, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING THE FG TABLE'
         GO TO 990
         END IF
      NROWS = FGBUF(5)
      DO 100 IROW = 1,NROWS
         IFGRNO = IROW
         CALL TABFLG ('READ', FGBUF, IFGRNO, FGKOLS, FGNUMV, SOURID,
     *      SUBA, FREQID, ANTS, TIMER, IFS, CHANS, PFLAGS, REASON,
     *      IRET)
         IF ((FRQSEL.GT.0) .AND. (FREQID.GT.0) .AND. (FREQID.NE.FRQSEL))
     *      GO TO 100
         IF ((SUBARR.GT.0) .AND. (SUBA.GT.0) .AND. (SUBARR.NE.SUBA))
     *      GO TO 100
         IF ((TSTART.GT.TIMER(2)) .OR. (TEND.LT.TIMER(1))) GO TO 100
         IF (IFS(2).EQ.0) IFS(2) = NUMIFS
         IF (CHANS(2).EQ.0) CHANS(2) = NUMCHN
         IF ((BIF.GT.IFS(2)) .OR. (EIF.LT.IFS(1))) GO TO 100
         IF ((BCHAN.GT.CHANS(2)) .OR. (ECHAN.LT.CHANS(1))) GO TO 100
         IF ((NSOUWD.GT.0) .AND. (SOURID.GT.0)) THEN
            DO 20 I = 1,NSOUWD
               IF ((SOURID.EQ.SOUWAN(I)) .AND. DOSWNT) GO TO 30
               IF ((SOURID.EQ.SOUWAN(I)) .AND. (.NOT.DOSWNT)) GO TO 100
 20            CONTINUE
            IF (DOSWNT) GO TO 100
            END IF
C                                       we want this one
C                                       single baseline
 30      IF ((ANTS(1).GT.0) .AND. (ANTS(2).GT.0)) THEN
            I = MIN (ANTS(1), ANTS(2))
            J = MAX (ANTS(1), ANTS(2))
            IF (PFLAGS(1)) FGCNT(J,I) = FGCNT(J,I) + 1
            IF (PFLAGS(2)) FGCNT(I,J) = FGCNT(I,J) + 1
C                                       single antenna
         ELSE IF (ANTS(1).GT.0) THEN
            II = ANTS(1)
            DO 40 JJ = 1,NUMA
               I = MIN (II, JJ)
               J = MAX (II, JJ)
               IF (PFLAGS(1)) FGCNT(J,I) = FGCNT(J,I) + 1
               IF (PFLAGS(2)) FGCNT(I,J) = FGCNT(I,J) + 1
 40            CONTINUE
C                                       all baselines
         ELSE
            DO 60 I = 1,NUMA-1
               DO 50 J = I+1,NUMA
                  IF (PFLAGS(1)) FGCNT(J,I) = FGCNT(J,I) + 1
                  IF (PFLAGS(2)) FGCNT(I,J) = FGCNT(I,J) + 1
 50               CONTINUE
 60            CONTINUE
            END IF
 100     CONTINUE
      CALL TABFLG ('CLOS', FGBUF, IFGRNO, FGKOLS, FGNUMV, SOURID,
     *   SUBA, FREQID, ANTS, TIMER, IFS, CHANS, PFLAGS, REASON, I)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FGPRTC: ERROR',I4,' ON ',A)
      END
      SUBROUTINE FGPRTT (IRET)
C-----------------------------------------------------------------------
C   FGPRTT does the actual printing of the counts
C   Outputs:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'FGPRT.INC'
      INTEGER   I, J, MAXCNT, NCOLPV, PAGE, IPCNT, NUMPRT, NPASS, IPASS,
     *   IOFF, ITEMP, COLPNT, LUNP, FINDP, ICOL, IROW, NACROS
      REAL      TEMP
      CHARACTER TITL1*132, TITL2*132, LINE*132, SCRTCH*132, ENTRY*10
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      MAXCNT = 0
      DO 20 I = 1,NUMA
         DO 10 J = 1,NUMA
            MAXCNT = MAX (MAXCNT, FGCNT(I,J))
 10         CONTINUE
 20      CONTINUE
      IF (MAXCNT.LE.0) THEN
         MSGTXT = 'NO FLAGS COUNTED'
         GO TO 990
         END IF
      TEMP = MAXCNT
      TEMP = LOG10 (TEMP)
      NCOLPV = TEMP + 2.0
      NCOLPV = MAX (NCOLPV, 3)
C                                       Init printer
      PAGE = 0
      IPCNT = 980
      TITL1 = ' '
      TITL2 = ' '
      LINE = ' '
C                                       Open output device
      IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
      CALL LPOPEN (LPNAME, DOCRT, LUNP, FINDP, NACROS, SCRBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING THE PRINTER'
         GO TO 990
         END IF
      NUMPRT = (NACROS-5) / NCOLPV
      NUMPRT = MIN (NUMPRT, NUMA)
      NPASS = ((NUMA+0.0) / NUMPRT) + 0.999

      DO 100 IPASS = 1,NPASS
         IOFF = (IPASS-1) * NUMPRT
         IF (IOFF+NUMPRT.GT.NUMA) NUMPRT = NUMA - IOFF
C                                          first page titles
         IF ((IPASS.EQ.1) .OR. (DOCRT.GT.-2.5)) THEN
            WRITE (LINE,1020) NAMEIN, CLAIN, SEQIN, DISKIN, NLUSER, BIF
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 950
            END IF
         IF (DOCRT.GT.-2.5) THEN
            WRITE (LINE,1021) BIF, EIF, BCHAN, ECHAN
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 950
            WRITE (LINE,1023) 'FG', FGVER
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 950
            END IF
         TITL1 = 'Number of flags by baseline'
         IF (DOCRT.GT.-2.5) THEN
            LINE = ' '
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 950
            LINE = TITL1
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 950
            LINE = ' '
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 950
            END IF
         ITEMP = 11 - NCOLPV
         COLPNT = 6
         DO 30 ICOL = 1,NUMPRT
            WRITE (ENTRY,1120) ICOL+IOFF
            TITL2(COLPNT:) = ENTRY(ITEMP:10)
            COLPNT = COLPNT + NCOLPV
 30         CONTINUE
         LINE = TITL2
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 950
         DO 50 IROW = 1,NUMA
            WRITE (LINE,1030) IROW
            COLPNT = 6
            DO 40 ICOL = 1,NUMPRT
               I = ICOL+IOFF
               WRITE (ENTRY,1120) FGCNT(I,IROW)
               LINE(COLPNT:) = ENTRY(ITEMP:10)
               COLPNT = COLPNT + NCOLPV
 40            CONTINUE
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 950
 50         CONTINUE
C                                       new page?
         IF (IPCNT.GT.(PRTMAX+1)/2) THEN
            LINE = ' '
            TITL1 = ' '
            TITL2 = ' '
            IPCNT = 998
            END IF
 100     CONTINUE
      GO TO 999
C                                       CRT error
 950  IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1950) IRET
         CALL MSGWRT (8)
         IRET = 1
      ELSE
         IRET = -1
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FGPRTT ERROR',I4,' ON ',A)
 1020 FORMAT ('File = ',A12,'.',A6,'.',I4,' Vol =',I2,'  Userid =',I5,
     *   3X,' IF =',I3)
 1021 FORMAT ('Flags include IFs',I3,' -',I3,'  channels',I6,' -',I6)
 1023 FORMAT ('Listing ',A2,' table, version ',I3)
 1030 FORMAT (I4)
 1120 FORMAT (I10)
 1950 FORMAT ('ERROR',I5,' DOING I/O TO PRINT DEVICE')
      END

      SUBROUTINE BDINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IBDRNO, BDKOLS, BDNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ, IERR)
C-----------------------------------------------------------------------
C! Create/open/initialize bandpass (BD) table
C# EXT-util Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2009, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes blcal bandpass (BD) extension tables.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'WRIT' = create/init for write or read
C                        'READ' = open for read only
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      LUN      I        Logical unit number to use
C   Input/output
C      VER      I        BD file version
C      CATBLK   I(256)   Catalog header block.
C   Input (create) / output (pre-existing)
C      NUMANT   I        Number of antennas
C      NUMPOL   I        Number of polarizations.
C      NUMIF    I        Number of IFs
C      NUMFRQ   I        Number of frequency channels
C   Output:
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      IBDRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      BDKOLS   I(MAXBDC)   The column pointer array in order:
C                        TIME, SOURID, SUBARRAY, ANTENNA1, ANTENNA2,
C                        FREQID, REAL1, IMAG1,
C                        Following used if 2 polarizations per IF
C                        REAL2, IMAG2.
C     BDNUMV    I(MAXBDC)   Element count in each column.
C     IERR      I        Return error code, 0=>OK, else TABINI or TABIO
C                        error.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXBDC, MAXBDK, WRDBDK
      PARAMETER (MAXBDC = 14)
      PARAMETER (MAXBDK = 4)
      PARAMETER (WRDBDK = 4)
C
      CHARACTER OPCODE*4
      INTEGER   BUFFER(*), DISK, CNO, VER, CATBLK(256), LUN, IBDRNO,
     *   BDKOLS(MAXBDC), BDNUMV(MAXBDC), NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *   IERR
C
      HOLLERITH HOLTMP(6)
      CHARACTER TTITLE*56, TITLE(MAXBDC)*24, UNITS(MAXBDC)*8,
     *   KEYW(MAXBDK)*8
      INTEGER   NKEY, NREC, DATP(128,2), NCOL, NTT, DTYP(MAXBDC), NDATA,
     *   KLOCS(MAXBDK), KEYVAL(WRDBDK), KEYTYP(MAXBDK), IPOINT, MSGSAV,
     *   I, NC, JERR, ITRIM, ITEMP(6)
      REAL      KEYVAR(WRDBDK)
      LOGICAL   DOREAD, NEWFIL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (KEYVAL, KEYVAR), (HOLTMP, ITEMP)
      DATA NTT /56/
      DATA TTITLE /'AIPS UV DATA FILE BLCHN BANDPASS TABLE'/
      DATA DTYP /22, 5*14, 8*2/
      DATA TITLE /'TIME RANGE', 'SOURCE ID ', 'SUBARRAY ', 'ANTENNA1 ',
     *   'ANTENNA2 ', 'FREQ ID ', 'REAL 1 ', 'IMAG 1 ',
     *   'REAL 2 ', 'IMAG 2 ', 'REAL 3 ', 'IMAG 3 ',
     *   'REAL 4 ', 'IMAG 4 '/
      DATA KEYW /'NO_ANT', 'NO_POL', 'NO_IF', 'NO_CHAN'/
      DATA UNITS /'DAYS ', 13*' '/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NREC = 500
      NKEY = 9
      NDATA = MAXBDC
      CALL FILL (NDATA, 0, BDKOLS)
      CALL FILL (NDATA, 0, BDNUMV)
C                                       Fill in types
      IF (.NOT.DOREAD) THEN
         NCOL = 6 + NUMPOL * 2
         CALL COPY (NDATA, DTYP, DATP(1,2))
C                                       Correct for real/imag
         DATP(7,2) = DTYP(7) + 10*NUMFRQ*NUMIF
         DATP(8,2) = DTYP(8) + 10*NUMFRQ*NUMIF
         DATP(9,2) = DTYP(9) + 10*NUMFRQ*NUMIF
         DATP(10,2) = DTYP(10) + 10*NUMFRQ*NUMIF
         DATP(11,2) = DTYP(11) + 10*NUMFRQ*NUMIF
         DATP(12,2) = DTYP(12) + 10*NUMFRQ*NUMIF
         DATP(13,2) = DTYP(13) + 10*NUMFRQ*NUMIF
         DATP(14,2) = DTYP(14) + 10*NUMFRQ*NUMIF
      ELSE
         NCOL = 0
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'BD', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'BDINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
      MSGSAV = MSGSUP
C                                       Get number of scans
      IBDRNO = BUFFER(5) + 1
      IF (DOREAD) IBDRNO = 1
      NKEY = MAXBDK
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 10 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'BDINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'BDINI', IERR)
               GO TO 990
               END IF
 10         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       Set keyword values
C                                       No. antennas.
         KLOCS(1) = 1
         KEYTYP(1) = 4
         KEYVAL(1) = NUMANT
C                                       No. Polarizations
         KLOCS(2) = 2
         KEYTYP(2) = 4
         KEYVAL(2) = NUMPOL
C                                       No. IFs
         KLOCS(3) = 3
         KEYTYP(3) = 4
         KEYVAL(3) = NUMIF
C                                       No. CHAN
         KLOCS(4) = 4
         KEYTYP(4) = 4
         KEYVAL(4) = NUMFRQ
C                                       Only write if just created.
         CALL TABKEY ('WRIT', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'BDINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         MSGSUP = 32000
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         MSGSUP = MSGSAV
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'BDINI', IERR)
            GO TO 990
            END IF
C                                       Retrieve keyword values
C                                       No. antennas.
         IPOINT = KLOCS(1)
         IF (IPOINT.GT.0) NUMANT = KEYVAL(IPOINT)
C                                       No. polarizations
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. IFs
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       No. CHAN
         IPOINT = KLOCS(4)
         IF (IPOINT.GT.0) NUMFRQ = KEYVAL(IPOINT)
         END IF
      IERR = 0
C                                      Get array indices
C                                      Cover your ass from FNDCOL -
C                                      close to flush the buffers and
C                                      then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, ITEMP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'BDINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'BD', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'BDINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (NDATA, TITLE, 24, .TRUE., BUFFER, BDKOLS, JERR)
C                                      Get array indices and no. values
      NCOL = 6 + NUMPOL * 2
      DO 150 I = 1,NCOL
         IPOINT = BDKOLS(I)
         IF (IPOINT.GT.0) THEN
            BDKOLS(I) = DATP(IPOINT,1)
            BDNUMV(I) = DATP(IPOINT,2) / 10
            IF (BDNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            BDKOLS(I) = -1
            BDNUMV(I) = 0
            IF ((NUMPOL.GT.1) .OR. (I.LE.NDATA-4)) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1101) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('BDINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('BDINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('BDINI: ERROR INITIALIZING BANDPASS TABLE FOR ',A)
      END

      SUBROUTINE YFIND (MAXPL, TYPE, IPL, UNIQUE, CATBLK, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! determines the unique TV image of desired type, returns catalog block
C# Y0 TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YFIND determines which of the visible TV images the user wishes
C   to select.  The TV must already be open.
C   Inputs:
C      MAXPL   I        Highest plane number allowed (i.e. do graphics
C                       count?)
C      TYPE    C*2      2-char image type to restrict search
C   Output:
C      IPL     I        Plane number found
C      UNIQUE  L        T => only one image visible now
C                           (all types except zeroed ones ('ZZ'))
C      CATBLK  I(256)   Image catalog block found
C      SCRTCH  I(256)   Scratch buffer
C      IERR    I        Error code: 0 => ok
C                          1 => no image
C                          2 => IO error in image catalog
C                          3 => TV error
C                         10 => > 1 image of requested type
C   Virtual TV version.
C-----------------------------------------------------------------------
      CHARACTER TYPE*2
      LOGICAL   UNIQUE
      INTEGER   SCRTCH(256), MAXPL, IPL, CATBLK(256), IERR
C
      INTEGER   ONPL, ZOR, IXT(2), CATI(256), I
      REAL      CATR(256), XT(2)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DVTV.INC'
      INCLUDE 'INCS:DTVC.INC'
      EQUIVALENCE (IXT, XT)
      EQUIVALENCE (CATI, CATH, CATR, CATD, BUFFER(1025))
C-----------------------------------------------------------------------
C                                       Which planes are on ?
      IERR = 1
      UNIQUE = .TRUE.
      ONPL = 0
      DO 10 I = 1,4
         ONPL = ZOR (ONPL, TVLIMG(I))
 10      CONTINUE
      IF (ONPL.EQ.0) GO TO 999
C                                       set up write
      BUFFER(1) = MAXPL
      CALL ZCLC8 (2, TYPE, 1, XT)
      CALL ZI16IL (1, 1, IXT, BUFFER(2))
      BUFSW = 2
      BUFSR = 303
      CALL MKYBUF ('READ', 'YFIND', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
C                                       unpack answers
      IF (IERR.EQ.0) THEN
         CALL UNYBUF (BUFSR, BUFFER, HEADER)
         IPL = BUFFER(3)
         UNIQUE = BUFFER(4).GT.0
         CALL HDRBUF (2, CATI, CATH, CATR, CATD, BUFFER(5))
         CALL COPY (256, CATI, CATBLK)
         END IF
C
 999  RETURN
      END

      SUBROUTINE FIELDF (BOXFIL, NFIELD, MFIELD, RA, DEC, MROTAT,
     *   FLDSIZ, RASH, DECSH, BCOMP, IERR)
C-----------------------------------------------------------------------
C! read field parameters from text file
C# AP Imaging
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2001, 2003, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Fills field parameters from the user test file F lines
C   Inputs:
C      BOXFIL   C*48     User provided file name containing box defs
C      NFIELD   I        Number of fields defined for field parms
C      MFIELD   I        Number of fields for BCOMP
C      RA       D        UV data set RA in degrees
C      DEC      D        UV data set Dec in degrees
C      MROTAT   R        Total rotation in degrees CCW from North
C   In/Out:
C      WIN      I(2,*)   image field sizes
C      RASH     R(*)     RA shift
C      DECSH    R(*)     Declination shift
C      BCOMP    I(*)     Subtract initial components 1-BCOMP(i)
C   Outputs:
C      IERR     I        Error return code: 0 => no error
C-----------------------------------------------------------------------
      CHARACTER BOXFIL*48
      INTEGER   NFIELD, MFIELD, FLDSIZ(2,*), BCOMP(*), IERR
      REAL      MROTAT, RASH(*), DECSH(*)
      DOUBLE PRECISION RA, DEC
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   LUN, I, J, FIND, KBP, I1, I2, ICNT(MAXFLD)
      CHARACTER LINE*132, SIGN*1
      DOUBLE PRECISION X, XRA, XDEC
      REAL      TRASH, TDECSH
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      CALL FILL (MAXFLD, 0, ICNT)
C                                        Open clean box file
      LUN = 11
      CALL ZTXOPN ('READ', LUN, FIND, BOXFIL, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN'
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                        Enter parameters from file
      I2 = 0
      DO 50 I = 1,500000
         CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
         IF (IERR.EQ.2) GO TO 60
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPEN'
            CALL MSGWRT (6)
            GO TO 995
            END IF
         CALL CHTRIM (LINE, 132, LINE, J)
C                                       parse for field:
C                                       #, fldsiz, rash, decsh
         IF ((LINE(:1).EQ.'F') .OR. (LINE(:1).EQ.'f')) THEN
            KBP = 2
            CALL GETNUM (LINE, 132, KBP, X)
            IF (X.EQ.DBLANK) GO TO 50
            IF (X.GE.0.0D0) THEN
               I1 = X + 0.50D0
            ELSE
               I1 = X - 0.50D0
               END IF
            IF ((I1.GE.1) .AND. (I1.LE.NFIELD)) THEN
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 990
               FLDSIZ(1,I1) = X + 0.50D0
               IF (X.LT.0.0D0) FLDSIZ(1,I1) = -1
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 990
               FLDSIZ(2,I1) = X + 0.50D0
               IF (X.LT.0.0D0) FLDSIZ(2,I1) = -1
               CALL GETNUM (LINE, 132, KBP, XRA)
               IF (X.EQ.DBLANK) GO TO 990
               CALL GETNUM (LINE, 132, KBP, XDEC)
               IF (X.EQ.DBLANK) GO TO 990
               ICNT(I1) = ICNT(I1) + 1
               IF (ICNT(I1).GT.1) THEN
                  IF ((ABS(RASH(I1)-XRA).GT.1.D-4) .OR.
     *               (ABS(DECSH(I1)-XDEC).GT.1.D-4)) THEN
                     WRITE (MSGTXT,1010) I1
                     CALL MSGWRT (7)
                     WRITE (MSGTXT,1015) RASH(I1), DECSH(I1),
     *                  XRA, XDEC
                     CALL MSGWRT (7)
                     IERR = 10
                     GO TO 995
                     END IF
                  END IF
               RASH(I1) = XRA
               DECSH(I1) = XDEC
               I2 = I2 + 1
               END IF
C                                       parse for ra/dec field
C                                       # fldsiz ra (HH MM SS) Dec (+-
C                                       DD MM SS)
         ELSE IF ((LINE(:1).EQ.'C') .OR. (LINE(:1).EQ.'c')) THEN
            KBP = 2
            CALL GETNUM (LINE, 132, KBP, X)
            IF (X.EQ.DBLANK) GO TO 50
            IF (X.GE.0.0D0) THEN
               I1 = X + 0.50D0
            ELSE
               I1 = X - 0.50D0
               END IF
            IF ((I1.GE.1) .AND. (I1.LE.NFIELD)) THEN
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 990
               FLDSIZ(1,I1) = X + 0.50D0
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 990
               FLDSIZ(2,I1) = X + 0.50D0
C                                       RA
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 990
               XRA = X
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 990
               XRA = XRA + X/60.0D0
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 990
               XRA = XRA + X/3600.0D0
               XRA = XRA * 15.0D0
C                                       Sign
               J = KBP
 40            IF (J.GT.132) GO TO 990
               IF (LINE(J:J).EQ.' ') THEN
                  J = J + 1
                  GO TO 40
                  END IF
               SIGN = LINE(J:J)
C                                       DEC
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 990
               XDEC = ABS(X)
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 990
               XDEC = XDEC + X/60.0D0
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 990
               XDEC = XDEC + X/3600.0D0
               IF (SIGN.EQ.'-') XDEC = -XDEC
C                                       to shifts
               CALL SHFTXY (RA, DEC, MROTAT, XRA, XDEC, TRASH,
     *            TDECSH)
C                                       check
               ICNT(I1) = ICNT(I1) + 1
               IF (ICNT(I1).GT.1) THEN
                  IF ((ABS(RASH(I1)-TRASH).GT.1.D-4) .OR.
     *               (ABS(DECSH(I1)-TDECSH).GT.1.D-4)) THEN
                     WRITE (MSGTXT,1010) I1
                     CALL MSGWRT (7)
                     WRITE (MSGTXT,1015) RASH(I1), DECSH(I1),
     *                  TRASH, TDECSH
                     CALL MSGWRT (7)
                     IERR = 10
                     GO TO 995
                     END IF
                  END IF
C                                       to shifts
               RASH(I1) = TRASH
               DECSH(I1) = TDECSH
               I2 = I2 + 1
               END IF
C                                       #, BCOMP(#)
         ELSE IF ((LINE(:1).EQ.'B') .OR. (LINE(:1).EQ.'b')) THEN
            KBP = 2
            CALL GETNUM (LINE, 132, KBP, X)
            IF (X.EQ.DBLANK) GO TO 50
            IF (X.GE.0.0D0) THEN
               I1 = X + 0.50D0
            ELSE
               I1 = X - 0.50D0
               END IF
            IF ((I1.GE.1) .AND. (I1.LE.MFIELD)) THEN
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) GO TO 990
               BCOMP(I1) = X + 0.50D0
               I2 = I2 + 1
               END IF
            END IF
 50      CONTINUE
 60   CALL ZTXCLS (LUN, FIND, I)
      IERR = 0
C
      IF (I2.GT.0) THEN
         IERR = -I2
         MSGTXT = 'FIELDF: Final field parameters and # read are:'
         CALL MSGWRT (3)
         DO 80 J = 1,NFIELD
            WRITE (MSGTXT,1070) 'Field', J, FLDSIZ(1,J), FLDSIZ(2,J),
     *         RASH(J), DECSH(J), BCOMP(J)
            CALL MSGWRT (3)
 80         CONTINUE
         END IF
      GO TO 999
C
 990  WRITE (MSGTXT,1990) I
      CALL MSGWRT (6)
      IERR = 1
 995  CALL ZTXCLS (LUN, FIND, I)

 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FIELDF: ERROR',I4,1X,A,'ING BOXFILE')
 1010 FORMAT ('FIELDF: FACET',I5,' BOXFILE HAS 2 COORDINATE CARDS;')
 1015 FORMAT ('        SHIFTS',2F11.3,2X,2F11.3)
 1070 FORMAT (A5,I5,2I5,2(1PE12.4),I11)
 1990 FORMAT ('FIELDF: PARSING ERROR ON LINE',I4)
      END

      SUBROUTINE CCSGRD (APCORE, IFIELD, DOSUM, SCRGRD, SCRWRK, JBUFSZ,
     *   BUFF1, BUFF2, BUFF3, IRET)
C-----------------------------------------------------------------------
C! Transforms CLEAN components to a grid.
C# AP-util Map UV Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 1999, 2001, 2006, 2008, 2015, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CCSGRD transforms CLEAN components to GRD file.
C   GRD file is zeroed if IFIELD=1 before filling.
C   Input:
C      IFIELD   I      FIELD number for grid.
C      DOSUM    L      If true sum the flux in each field
C      SCRGRD   I      /CFILES/ file number for grid file.
C      SCRWRK   I      /CFILES/ file number for work file
C      JBUFSZ   I      Size of the buffers in bytes. The dimension of
C                      the buffers must be at least 4096.
C      MFREQ    I      Current frequency channel.
C      CLEAN components for field IFIELD.
C   Output:
C      BUFF1    R(*)   Work buffer
C      BUFF2    R(*)   Work buffer
C      BUFF3    R(*)   Work buffer
C      IRET     I      Error return
C   Transform of additional CLEAN components left in GRD file.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   IFIELD, SCRGRD, SCRWRK, JBUFSZ, IRET
      REAL      BUFF1(*), BUFF2(*), BUFF3(*)
      LOGICAL   DOSUM
C
      INTEGER   FIRST, NUMBER, MAXCMP, NUMCLN, JNUM, NAPGAU, NAPEX1,
     *   NAPGRD, NAPCMP, NAPCMS, APBUF, ONENY, TWONY, WRK1, WRK2, NWORD,
     *   APSIZ, FLIST(22,2), NLOAD, I, JLIM, NX, NY, IT1
      LOGICAL   T, F, WFIRST, DOGAUS
      REAL      GPARMS(3), DU, DV, UU
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DAPM.INC'
      DATA APBUF / 1 /
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      WFIRST = T
      NX = FLDSZ(1,IFIELD) * OSFX + 0.1
      NY = FLDSZ(2,IFIELD) * OSFY + 0.1
C                                       Initialize flux sums.
      IF (DOSUM) FLUXG(IFIELD) = 0.0
C                                       Determine Area assignments in AP
      ONENY = NY
      TWONY = 2 * NY
      NAPGRD = 100
      WRK1 = ONENY + 1
      WRK2 = TWONY + 1
      NAPCMP = NAPGRD + WRK2
      NAPGAU = NAPCMP + WRK2
      NAPEX1 = NAPGAU + WRK1
      NAPCMS = NAPEX1 + WRK1
C                                       Set up for APIO
      CALL FILL (22, 0, FLIST)
C                                       LUNs
      FLIST(1,1) = LUNS(4)
C                                       /CFILES/ numbers
      FLIST(2,1) = SCRGRD
C                                       Size
      FLIST(5,1) = NY * 2
      FLIST(6,1) = NX / 2 + 1
C                                       Buffer size
      FLIST(13,1) = JBUFSZ
C                                       Second file
      CALL COPY (22, FLIST(1,1), FLIST(1,2))
      FLIST(1,2) = LUNS(5)
      FLIST(2,2) = SCRWRK
C                                       Determine maximum number of comp
C                                       per pass.
      APSIZ = PSAPNW * 1024
      MAXCMP = (APSIZ - NAPCMS) / 5
      NUMCLN = NCLNG(IFIELD) - NSUBG(IFIELD) + 1
      FIRST = NSUBG(IFIELD)
      APBUF = 2
C                                       Determine size of AP buffer for
      NLOAD = NAPGAU - 3
C                                       Begin component loop.
 10      NUMBER = MIN (MAXCMP, NUMCLN)
C                                       Load CLEAN components this pass.
         JNUM = NUMBER
         CALL GRDCRM (APCORE, IFIELD, DOSUM, NAPCMS, APBUF, FIRST,
     *      NUMBER, NLOAD, GPARMS, JBUFSZ, BUFF1, BUFF2, BUFF3, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Gaussian model?
         DOGAUS = (GPARMS(1).GT.0.0) .AND. (GPARMS(2).GT.0.0)
         IF (DOGAUS) THEN
            IF ((NX*CELLSG(1).EQ.0.0) .OR. (NY*CELLSG(2).EQ.0.0)) THEN
               IRET = 8
               MSGTXT = 'NX, NY, OR CELLSG 0!!!'
               CALL MSGWRT (8)
               GO TO 999
               END IF
            DU = RAD2AS / (NX * ABS(CELLSG(1)))
            DV = RAD2AS / (NY * ABS(CELLSG(2)))
            END IF
C                                       Begin loop thru map.
         JLIM = NX / 2 + 1
         DO 150 I = 1,JLIM
C                                       If not first pass read old grid
            CALL QWR
            IF (.NOT.WFIRST) THEN
               CALL APIO (APCORE, 'READ', FLIST(1,1), NAPGRD, BUFF2,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1080) IRET,I
                  GO TO 990
                  END IF
C                                       Clear grid.
            ELSE
               CALL QVCLR (APCORE, NAPGRD, 1, TWONY)
               CALL QWR
               END IF
            CALL QWD
C                                       Gaussian taper then crunch
            IF (DOGAUS) THEN
               UU = DU * (I-1)
               CALL QTAPER (APCORE, GPARMS, UU, DV, ONENY, NAPGAU)
               CALL QGRDCC (APCORE, NAPCMS, NAPGAU, NAPCMP, NAPGRD,
     *            ONENY, NUMBER)
C                                       Crunch data.
            ELSE
               CALL QGRDCC (APCORE, NAPCMS, -1, NAPCMP, NAPGRD, ONENY,
     *            NUMBER)
               END IF
C                                       Write file back to disk.
            CALL QWR
            CALL APIO (APCORE, 'WRIT', FLIST(1,2), NAPGRD, BUFF1, IRET)
            IF (IRET.EQ.0) GO TO 150
               WRITE (MSGTXT,1090) IRET, I
               GO TO 990
 150        CONTINUE
C                                       End of this pass, close files.
         CALL APIO (APCORE, 'CLOS', FLIST(1,1), NAPGRD, BUFF2, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1150) IRET
            CALL MSGWRT (8)
            END IF
         CALL APIO (APCORE, 'CLOS', FLIST(1,2), NAPGRD, BUFF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1150) IRET
            CALL MSGWRT (8)
            END IF
         FIRST = FIRST + JNUM
         NUMCLN = NUMCLN - JNUM
         WFIRST = F
C                                       Switch WRK and GRID files.
         IT1 = SCRWRK
         SCRWRK = SCRGRD
         SCRGRD = IT1
         FLIST(2,1) = SCRGRD
         FLIST(2,2) = SCRWRK
C                                       Check if time for roller
C                                       Check for more CLEAN components.
         NWORD = APSIZ
         IF (FIRST.LE.NCLNG(IFIELD)) THEN
            CALL QROLL (APCORE, NWORD, BUFF3, JBUFSZ, IRET)
            IF (IRET.NE.0) GO TO 999
            GO TO 10
            END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1090 FORMAT ('CCSGRD: WRITE ERROR ',I3,' GRID ROW ',I6)
 1080 FORMAT ('CCSGRD: ERROR ',I3,' READ GRID ROW ',I6)
 1150 FORMAT ('CCSGRD: ERROR ',I3,' CLOSING GRID FILE')
      END

      SUBROUTINE YGYHDR (OP, NPIXEL, XINIT, YINIT, IANGLE, CHANNL,
     *   PLANES, PACKED, BYPIFM, BYTE, ADDWRT, ACCUM, VRTRTC, HEADER,
     *   IERR)
C-----------------------------------------------------------------------
C! builds basic TV IO header to write gray scale data
C# Y3 TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YGYHDR builds an TV header to write image data.  The actual IO
C   must be done by calls to YIMGIO or Z...XF.
C   Inputs:
C      OP      C*4     'READ' from TV or 'WRIT' to TV
C      NPIXEL  I       number of pixel values to IO
C      XINIT   I       first pixel X coordinate (1-512, 1 -> LHS)
C      YINIT   I       first pixel Y coordinate (1-512, 1 -> bot)
C      IANGLE  I       (0 => data IO horizontal to right, 1 => up,
C                      2 => to left, 3 => down)
C      CHANNL  I       channel select bit mask
C      PLANES  I       bit plane select bit mask
C      PACKED  L       T => 2 values/word, F => 1 value/word
C      BYPIFM  L       F => IFM lookup applied to data (write)
C      BYTE    L       T => 8 values/byte (needs XINIT = 8*n+1)
C      ADDWRT  L       T => OR data with present memory contents
C      ACCUM   L       T => use 16-bit accumulator mode
C      VRTRTC  L       T => do it only during vertical retrace
C   Output:
C      HEADER  I(8)    header to be sent to TV
C      IERR    I       error code of 0 => ok
C                                    2 => input error
C   NO TV (WITH SIMPLE HEADERS) VERSION - this is a level 3 IIS function
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   NPIXEL, XINIT, YINIT, IANGLE, CHANNL, PLANES,
     *   HEADER(8), IERR
      LOGICAL   PACKED, BYPIFM, BYTE, ADDWRT, ACCUM, VRTRTC
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'YGYHDR: THERE IS NO TV WITH SIMPLE HEADERS CONFIGURED'
      CALL MSGWRT (8)
C
 999  RETURN
      END

      SUBROUTINE SETANT (N, XANT, XBAS, NXANT, NXBAS, IANT, IBAS, DESEL)
C-----------------------------------------------------------------------
C! Builds a list of antennas and baselines from standard adverbs
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Converts standard adverbs ANTENNAS and BASELINE into integer lists,
C   counts, and the DESEL flag.
C   Inputs:
C      N       I      Dimension of XANT, etc.
C      XANT    R(N)   ANTENNAS adverb
C      XBAS    R(N)   BASELINE adverb
C   Outputs:
C      NXANT   I      Number of unique antennas in IANT
C      NXBAS   I      Number of unique antennas in IBAS
C      IANT    I(N)   List of unique antenna numbers
C      IBAS    I(N)   List of unique antenna numbers
C      DESEL   L      These lists are deselected (T) or selected (F)
C-----------------------------------------------------------------------
      INTEGER   N, NXANT, NXBAS, IANT(*), IBAS(*)
      REAL      XANT(*), XBAS(*)
      LOGICAL   DESEL
C
      INTEGER   I, II, J, IROUND
C-----------------------------------------------------------------------
      DESEL = .FALSE.
      NXANT = 0
      NXBAS = 0
      DO 40 I = 1,N
         II = IROUND (XANT(I))
         IF (II.NE.0) THEN
            II = ABS (II)
            DO 10 J = 1,NXANT
               IF (II.EQ.IANT(J)) GO TO 20
 10            CONTINUE
            NXANT = NXANT + 1
            IANT(NXANT) = II
            IF (XANT(I).LT.0.0) DESEL = .TRUE.
            END IF
 20      II = IROUND (XBAS(I))
         IF (II.NE.0) THEN
            II = ABS (II)
            DO 30 J = 1,NXBAS
               IF (II.EQ.IBAS(J)) GO TO 40
 30            CONTINUE
            NXBAS = NXBAS + 1
            IBAS(NXBAS) = II
            IF (XBAS(I).LT.0.0) DESEL = .TRUE.
            END IF
 40      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE YSCROL (CHANNL, SCROLX, SCROLY, VRTRTC, IERR)
C-----------------------------------------------------------------------
C! write the scroll registers (shift location of 1 or more TV channels)
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YSCROL writes the scroll registers on the TV.
C   Inputs:
C      CHANNL   I   bit map channel select: bits 1-NGRAY gray channels,
C                   bit NGRAY+1 => all graphics
C      VRTRTC   L   T => do it on vertical retrace only
C   In/Out:
C      SCROLX   I   amount of X scroll (>0 to right)
C      SCROLY   I   amount of Y scroll (>0 upwards)
C   Output:
C      IERR     I   error from Z...XF : 0 => ok, 2 => input error
C   YSCROL updates the scroll variables in /TVDEV/ common
C   IIS Model 70 version
C-----------------------------------------------------------------------
      INTEGER   CHANNL, SCROLX, SCROLY, IERR
      LOGICAL   VRTRTC
C
      INTEGER   UNIT, HEADER(8), BUFFER(2), BUFSIZ, NB, BITS(16), I,
     *   ITEMP, BIT16, IC, ZOR, ZAND
      LOGICAL   COMAND
      INCLUDE 'INCS:DTVC.INC'
      DATA UNIT, COMAND, BUFSIZ / 6, .FALSE., 2/
      DATA BIT16 /-32768/
C-----------------------------------------------------------------------
C                                        write: set buffer
      BUFFER(1) = MOD (16*MAXXTV(1)-SCROLX, MAXXTV(1))
      BUFFER(2) = MOD (16*MAXXTV(2)+SCROLY, MAXXTV(2))
      BUFFER(1) = (BUFFER(1) / SCXINC) * SCXINC
      BUFFER(2) = (BUFFER(2) / SCYINC) * SCYINC
      ITEMP = 2 ** NGRAY - 1
      IC = ZAND (CHANNL, ITEMP)
      IF (IC.NE.CHANNL) IC = ZOR (IC, BIT16)
C                                        header & IO
      CALL YMKHDR ('WRIT', UNIT, COMAND, BUFSIZ, 0, 0, IC, 0, VRTRTC,
     *   HEADER)
      NB = 2 * BUFSIZ
      CALL ZM70XF ('WRIT', NB, HEADER, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        reset common scroll record
      CALL ZGTBIT (16, IC, BITS)
      DO 10 I = 1,NGRAY
         IF (BITS(I).EQ.1) THEN
            TVSCRX(I) = -BUFFER(1)
            TVSCRY(I) = BUFFER(2)
            END IF
 10      CONTINUE
      IF (BITS(16).EQ.1) THEN
         TVSCRX(NGRAY+1) = -BUFFER(1)
         TVSCRY(NGRAY+1) = BUFFER(2)
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'UVDIF.INC'
C                                       Local include for UVDIF
      INCLUDE 'INCS:ZPBUFSZ.INC'
      CHARACTER NAME*12, CLASS*6, NAME2*12, CLASS2*12, OPCODE*4,
     *   LPNAME*48, TITL1*132, TITL2*132, SCRTCH*132, LINE*132
      HOLLERITH XNAME(3), XCLASS(2), XNAME2(3), XCLAS2(2),
     *   XOPCOD, CAT2H(256), XLPNAM(12)
      REAL      XSEQ, XDISK, XSEQ2, XDISK2, XNCH, XBIF, XNIT, UVRANG(2),
     *   DOAC, APARM(10), DOCRT
      REAL      BUFF(UVBFSS), BUFF2(UVBFSS), RADIUS(2), POSANG(2),
     *   FMAX(4), CAT2R(256), UVM, XAMP, XWT, NWT
      DOUBLE PRECISION CAT2D(128)
      LOGICAL   DOMAX, DOUVBX, ISUVR, ISCMP1, ISCMP2, DOFLAG, DOACOR,
     *   DOXCOR
      INTEGER   LUN, FIND, PLUN, PIND, CNO, ISTKS, NCH, BIF, SEQ, DISK,
     *   USERID, LUN2, FIND2, CNO2, SEQ2, DISK2, NITER, CAT2I(256),
     *   IPCNT, PAGE, NACROS, KLOCWT, LLOCWT, NRP1, NRP2, LREC2,
     *   I1LOCU, I1LOCV, I1LOCW, I1LOCB, I1LOCT, I1LOCS, I1LOCF,
     *   I1LOSA, I1LOA1, I1LOA2,
     *   I2LOCU, I2LOCV, I2LOCW, I2LOCB, I2LOCT, I2LOCS, I2LOCF,
     *   I2LOSA, I2LOA1, I2LOA2
C                                       Local include for UVDIF
      COMMON /INPARM/ XNAME, XCLASS, XSEQ, XDISK, XNAME2, XCLAS2, XSEQ2,
     *   XDISK2, XNCH, XBIF, XNIT, UVRANG, DOAC, XOPCOD, APARM, DOCRT,
     *   XLPNAM
      COMMON /CHPARM/ NAME, CLASS, NAME2, CLASS2, OPCODE, LPNAME,
     *   TITL1, TITL2, LINE, SCRTCH
      COMMON /FNDUVC/ BUFF, BUFF2, RADIUS, POSANG, FMAX, NITER,
     *   DOMAX, DOUVBX, ISUVR, ISCMP1, ISCMP2, LUN, FIND, LUN2, FIND2,
     *   NCH, BIF, PLUN, PIND, CNO, CNO2, ISTKS, SEQ, DISK, SEQ2, DISK2,
     *   USERID, PAGE, IPCNT, NACROS, KLOCWT, LLOCWT, UVM, XAMP, XWT,
     *   NWT, NRP1, NRP2, LREC2, DOFLAG, DOACOR, DOXCOR,
     *   I1LOCU, I1LOCV, I1LOCW, I1LOCB, I1LOCT, I1LOCS, I1LOCF, I1LOSA,
     *   I1LOA1, I1LOA2, I2LOCU, I2LOCV, I2LOCW, I2LOCB, I2LOCT, I2LOCS,
     *   I2LOCF, I2LOSA, I2LOA1, I2LOA2
      COMMON /MAP2HD/ CAT2I
      EQUIVALENCE (CAT2I, CAT2R, CAT2H, CAT2D)
LOCAL END
LOCAL INCLUDE 'BUFFS.INC'
      INCLUDE 'ZPBUFSZ.INC'
      REAL      LBUFF(UVBFSS), KBUFF(UVBFSS), KBUFF2(UVBFSS),
     *   LBUFF2(UVBFSS)
      COMMON /UVDUFS/ LBUFF, KBUFF, LBUFF2, KBUFF2
LOCAL END
      PROGRAM UVDIF
C-----------------------------------------------------------------------
C! UVDIF prints the differences between two uv data sets
C# UV UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1999, 2002-2004, 2007-2009, 2015-2016,
C;  Copyright (C) 2020, 2022, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVDIF is an AIPS system task to locate questionable data in a
C   catalogd UV data base and to print them.  Compares 2 data sets.
C   Inputs:
C     USERID    R         User number
C     INNAME    R(3)      File name: 12 chars
C     INCLASS   R(2)      File class: 6 chars
C     INSEQ     R         File seq #
C     INDISK    R         Disk volume on which file resides
C     IN2NAME   R(3)      File name: 12 chars
C     IN2CLASS  R(2)      File class: 6 chars
C     IN2SEQ    R         File seq #
C     IN2DISK   R         Disk volume on which file resides
C     CHANNEL   R         Spectral channel number
C     BIF       R         IF to test.
C     NITER     R         Limit on number of lines to print
C     UVRANGE   R(2)      Range of wavelengths to check in 1000's
C     OPCODE    R         Opcode: 4 chars
C                            'CLIP' : print high flux diffs
C                            'UVBX' : print high u,v,w diffs
C                            else do both
C     APARM     R(10)     (1) max cutoff IPOL (Jy) flux diff
C                         (2) max cutoff cross-pol (Jy)
C                         (3) max cutoff u,v,w diff (wavelengths)
C     DOCRT     R         > 0 -> use CRT, else line printer
C     OUTPRINT  H         File name to keep printer output
C-----------------------------------------------------------------------
      LOGICAL   RQUICK
      INTEGER   IRET
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'UVDIF.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Init, open file
      CALL FNDUIN (RQUICK, IRET)
C                                       Get scales
      IF (IRET.EQ.0) CALL FNDUSC (IRET)
C                                       Do it
      IF (IRET.EQ.0) THEN
         IF (OPCODE.EQ.'UVBX') THEN
            CALL FNDUBX (IRET)
         ELSE IF (OPCODE.EQ.'CLIP') THEN
            CALL FNDUCL (IRET)
         ELSE
            CALL FNDUPR (IRET)
            END IF
         END IF
C                                       Close up shop
      IRET = MAX (0, IRET)
      CALL DIETSK (IRET, RQUICK, BUFF)
C
 999  STOP
      END
      SUBROUTINE FNDUIN (RQUICK, IRET)
C-----------------------------------------------------------------------
C   FNDUIN inits the task FNDUV and opens the UV file and printer.
C   Outputs:
C      RQUICK   L    T => AIPS has been restarted
C      IRET     I    error code: 0 => keep going, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, ITYPE*2, CTEMP1*8, CTEMP2*8, UTYPE*2, SCRSTR*132
      LOGICAL   RQUICK
      INTEGER   IRET
      LOGICAL   F, EQUAL
      INTEGER   NPARM,I, J, IERR, INC, NT, IROUND, NCOUNT, TTY(2)
      DOUBLE PRECISION   DEPS
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'UVDIF.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA F /.FALSE./
      DATA PRGM /'UVDIF '/
C-----------------------------------------------------------------------
C                                       Init I/O
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Get input parameters.
      NPARM = 44
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAME, BUFF, IRET)
      IF (IRET.EQ.0) GO TO 10
         RQUICK = .TRUE.
         IF (IRET.EQ.1) GO TO 999
C                                       Restart AIPS.
 10   IF ((IRET.NE.0) .OR. (NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   DOCRT = MIN (-1.0, DOCRT)
      CALL H2CHR (48, 1, XLPNAM, LPNAME)
      IF (DOCRT.GT.0.0) RQUICK = .FALSE.
      IF ((IRET.EQ.0) .AND. (RQUICK)) RQUICK = LPNAME.NE.' '
      IF (RQUICK) CALL RELPOP (IRET, BUFF, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 8
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XNAME, NAME)
      CALL H2CHR (6, 1, XCLASS, CLASS)
      CALL H2CHR (12, 1, XNAME2, NAME2)
      CALL H2CHR (6, 1, XCLAS2, CLASS2)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      DOFLAG = APARM(6).GT.0.99
      DOACOR = DOAC.GT.0.0
      DOXCOR = .TRUE.
      IF ((DOACOR) .AND. (APARM(7).GT.0.0)) DOXCOR = .FALSE.
C                                       Decode input.
      USERID = NLUSER
      SEQ = IROUND (XSEQ)
      DISK = IROUND (XDISK)
      SEQ2 = IROUND (XSEQ2)
      DISK2 = IROUND (XDISK2)
      BIF = IROUND (XBIF)
      BIF = MAX (1, BIF)
      NCH = IROUND (XNCH)
      NCH = MAX (1, NCH)
      NITER = IROUND (XNIT)
      IF (NITER.LE.0) NITER = 5 * (PRTMAX - 7) - 4
      IF (UVRANG(1).LE.0.0) UVRANG(1) = 0.0
      IF (UVRANG(2).LE.UVRANG(1)) UVRANG(2) = 1.E9
      ISUVR = (UVRANG(1).GT.0.001) .OR. (UVRANG(2).LT.9.8E8)
      DOMAX = OPCODE.EQ.'CLIP'
      DOUVBX = OPCODE.EQ.'UVBX'
      IF ((DOMAX) .OR. (DOUVBX)) GO TO 15
         DOMAX = .TRUE.
         DOUVBX = .TRUE.
C                                       Stokes
 15   ISTKS = 8
C                                       Open file 2 and get CAT2.
      LUN2 = 17
      ITYPE = ' '
      CALL MAPOPN ('READ', DISK2, NAME2, CLASS2, SEQ2, ITYPE, USERID,
     *   LUN2, FIND2, CNO2, CAT2I, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1035) IERR
         CALL MSGWRT (8)
         GO TO 940
         END IF
      ISCMP2 = CAT2I(KINAX).EQ.1
      NRP2 = CAT2I(KIPCN)
      CALL COPY (256, CAT2I, CATBLK)
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 950
      LREC2 = LREC
      I2LOCU = ILOCU
      I2LOCV = ILOCV
      I2LOCW = ILOCW
      I2LOCB = ILOCB
      I2LOCT = ILOCT
      I2LOCS = ILOCSU
      I2LOCF = ILOCFQ
      I2LOSA = ILOCSA
      I2LOA1 = ILOCA1
      I2LOA2 = ILOCA2
C                                       Open file and get CATBLK.
      LUN = 16
      UTYPE = 'UV'
      CALL MAPOPN ('READ', DISK, NAME, CLASS, SEQ, UTYPE, USERID, LUN,
     *   FIND, CNO, CATBLK, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1025) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Get info from CATBLK.
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 950
      I1LOCU = ILOCU
      I1LOCV = ILOCV
      I1LOCW = ILOCW
      I1LOCB = ILOCB
      I1LOCT = ILOCT
      I1LOCS = ILOCSU
      I1LOCF = ILOCFQ
      I1LOSA = ILOCSA
      I1LOA1 = ILOCA1
      I1LOA2 = ILOCA2
C                                       Compressed?
      ISCMP1 = CATBLK(KINAX).EQ.1
      NRP1 = CATBLK(KIPCN)
C                                       Check IF
      IF ((JLOCIF.LE.0) .OR. (CATBLK(KINAX+JLOCIF).LE.1)) BIF = 1
      IF ((JLOCIF.GT.0) .AND. (BIF.GT.CATBLK(KINAX+JLOCIF))) THEN
         WRITE (MSGTXT,1030) BIF, CATBLK(KINAX+JLOCIF)
         CALL MSGWRT (8)
         GO TO 950
         END IF
C                                       Check spectral channel.
      IF (CATBLK(KINAX+JLOCF).LE.1) NCH = 1
      IF (NCH.GT.CATBLK(KINAX+JLOCF)) THEN
         WRITE (MSGTXT,1032) NCH, CATBLK(KINAX+JLOCF)
         CALL MSGWRT (8)
         GO TO 950
         END IF
C                                       Compare headers
      EQUAL = ITYPE.EQ.'SC'
      IF (ITYPE.NE.'SC') THEN
         IF (APARM(5).LT.1.5) THEN
            IF (ABS(CATBLK(KIGCN)-CAT2I(KIGCN)).GT.5) GO TO 49
            END IF
         IF (CATBLK(KIDIM).NE.CAT2I(KIDIM)) GO TO 49
         INC = 2
         NT = CATBLK(KIDIM)
         IF (NT.GT.4) NT = 4
         DO 45 I = 2,NT
            J = I - 1
            DEPS = 0.01 * ABS(CATR(KRCIC+J))
            IF (DEPS.LE.0.0D0) DEPS = 1.0D-4
            IF (CATBLK(KINAX+J).NE.CAT2I(KINAX+J)) GO TO 49
            IF (APARM(5).LT.0.5) THEN
               IF (ABS(CATR(KRCRP+J)-CAT2R(KRCRP+J)).GT.DEPS) GO TO 49
               IF (ABS(CATD(KDCRV+J)-CAT2D(KDCRV+J)).GT.DEPS) GO TO 49
               IF (ABS(CATR(KRCIC+J)-CAT2R(KRCIC+J)).GT.DEPS) GO TO 49
               END IF
            IF (APARM(5).LT.1.5) THEN
               J = KHCTP + J * INC
               CALL H2CHR (8, 1, CATH(J), CTEMP1)
               CALL H2CHR (8, 1, CAT2H(J), CTEMP2)
               IF (CTEMP1.NE.CTEMP2) GO TO 49
               END IF
 45         CONTINUE
         IF (CATBLK(KIGCN).NE.CAT2I(KIGCN)) THEN
            MSGTXT = 'WARNING: 2 DATASETS NOT QUITE THE SAME SIZE'
            CALL MSGWRT (6)
            END IF
         GO TO 50
C                                       no match
 49      CONTINUE
            WRITE (MSGTXT,1049)
            CALL MSGWRT (8)
            GO TO 940
         END IF
C                                       check line count
 50   IF ((DOCRT.LE.0.0) .AND. (LPNAME.EQ.' ')) THEN
         NCOUNT = 0
         IRET = 0
         MSGTXT = 'Checking count of lines for direct output to printer'
         CALL MSGWRT (2)
         IF (OPCODE.EQ.'UVBX') THEN
            CALL CHKUBX (NCOUNT, IRET)
         ELSE IF (OPCODE.EQ.'CLIP') THEN
            CALL CHKUCL (NCOUNT, IRET)
         ELSE
            CALL CHKUPR (NCOUNT, IRET)
            END IF
         IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) THEN
            IF ((NCOUNT.GT.1000) .AND.(IRET.EQ.0)) IRET = -1
         ELSE IF ((IRET.EQ.0) .AND. (NCOUNT.GT.500)) THEN
            TTY(1) = 5
            CALL ZOPEN (TTY(1), TTY(2), 1, SCRSTR, .FALSE., .FALSE.,
     *         .TRUE., IRET)
            MSGTXT = 'PROBLEM OPENING TERMINAL'
            IF (IRET.GT.0) GO TO 990
            WRITE (SCRSTR,1050) NCOUNT
            CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRSTR, IRET)
            MSGTXT = 'PROBLEM DOING IO TO TERMINAL'
            IF (IRET.GT.0) GO TO 990
            SCRSTR = 'Do you really want to print this much??' //
     *         ' Enter Y or y if so'
            CALL INQSTR (TTY, SCRSTR, 1, CTEMP1, IRET)
            IF (IRET.GT.0) GO TO 990
            IF ((CTEMP1(:1).NE.'y') .AND. (CTEMP1(:1).NE.'Y')) THEN
               SCRSTR = 'Good choice - save trees'
               IRET = -1
            ELSE
               SCRSTR = 'OKAY, printing anyway'
               END IF
            CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRSTR, I)
            CALL ZCLOSE (TTY(1), TTY(2), I)
            END IF
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Open printer
      IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
      CALL LPOPEN (LPNAME, DOCRT, PLUN, PIND, NACROS, BUFF, IERR)
      IF (IERR.NE.0) GO TO 940
      IRET = 1
      IPCNT = 998
      PAGE = 0
      TITL1 = ' '
      TITL2 = ' '
C                                       function parameters
      IF (DOMAX) THEN
         IF (APARM(4).EQ.0.0) APARM(4) = 1.E8
         IF ((APARM(2).LE.0.0) .AND. (APARM(1).LE.0.0)) APARM(1) = 1.0
         IF ((APARM(2).LE.0.0) .AND. (APARM(1).GT.0.0)) APARM(2) = 1.E8
         IF ((APARM(1).LE.0.0) .AND. (APARM(2).GT.0.0)) APARM(1) = 1.E8
         IF ((APARM(1).LT.1.E5) .AND. (DOCRT.GT.-2.5)) THEN
            WRITE (LINE,1060) APARM(1)
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 940
            END IF
         IF ((APARM(2).LT.1.E5) .AND. (DOCRT.GT.-2.5)) THEN
            WRITE (LINE,1061) APARM(2)
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 940
            END IF
         IF ((ABS(APARM(4)).LT.1.E5) .AND. (DOCRT.GT.-2.5)) THEN
            IF (APARM(4).GT.0.0) THEN
               WRITE (LINE,1062) APARM(4)
            ELSE
               WRITE (LINE,1063) -APARM(4)
               END IF
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 940
            END IF
         END IF
C                                       Test values of U, V, W
      IF (DOUVBX) THEN
         IF (APARM(3).LE.0.0) APARM(3) = 1000.
         IF (DOCRT.GT.-2.5) THEN
            WRITE (LINE,1065) APARM(3)
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 940
            END IF
         APARM(3) = APARM(3) / 1000.0
         END IF
C                                       Scale UVRANG
      IF ((ISUVR) .AND. (DOCRT.GT.-2.5)) THEN
         WRITE (LINE,1070) UVRANG
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 940
         END IF
      UVRANG(1) = UVRANG(1) * UVRANG(1)
      UVRANG(2) = UVRANG(2) * UVRANG(2)
      IRET = 0
      GO TO 999
C                                       Close map on error
 940  CALL MAPCLS ('READ', DISK2, CNO2, LUN2, FIND2, CAT2I, F, BUFF2,
     *    IERR)
      IF (IERR.EQ.0) GO TO 950
         WRITE (MSGTXT,1940) IERR
         CALL MSGWRT (6)
 950  CALL MAPCLS ('READ', DISK, CNO, LUN, FIND, CATBLK, F, BUFF, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1950) IERR
C
 990     CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1025 FORMAT ('ERROR:',I7,' OPENING 1ST UV FILE')
 1030 FORMAT ('IF',I5,' .GT. MAX =',I5)
 1032 FORMAT ('CHANNEL',I5,' .GT. MAX =',I5)
 1035 FORMAT ('ERROR:',I7,' OPENING 2ND UV FILE')
 1049 FORMAT ('HEADERS DO NOT MATCH')
 1050 FORMAT ('Requested print job is',I10,' lines long!')
 1060 FORMAT ('Will print all total int. points   >',F12.6,' JY')
 1061 FORMAT ('Will print all polarization points >',F12.6,' JY')
 1062 FORMAT ('Will print all weight points       >',F12.6,
     *   ' and flagging')
 1063 FORMAT ('Will print all weight points       >',F12.6,
     *   ' flagging ignored')
 1065 FORMAT ('Will print all uv differences      >',F12.6,' lambda')
 1070 FORMAT ('Limited to baselines between',2(1PE13.4),' klambda')
 1940 FORMAT ('ERROR:',I7,' CLOSING 2ND UV FILE ')
 1950 FORMAT ('ERROR:',I7,' CLOSING 1ST UV FILE ')
      END
      SUBROUTINE FNDUSC (IRET)
C-----------------------------------------------------------------------
C   FNDUSC reads the UV files and determines extrema for u-v-w, flux,
C   and weight.
C   Output:
C      IRET   I   Return code: 0 success or user requests end, else bad
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'UVDIF.INC'
      INTEGER   JADR(8), BIND, CINC, BUFSZ, J, LENBU, MVIS, IA1, IA2,
     *   ICH1, IERR, JERR, KK, IPINT, NIO, NNCH, NUMCH, LRECF, NUMCHM,
     *   BO, VO, COUNT, NCORR, DPTR, IERR1
      REAL   VIS(3,8), TEMP, UVN
      INCLUDE 'BUFFS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PUVD.INC'
      DATA LENBU, BO, VO /16, 1, 0/
C-----------------------------------------------------------------------
      IRET = 8
      CINC = 2
C                                       Set up for compressed data.
      NCORR = (LREC - NRPARM) / CATBLK(KINAX)
      LRECF = NRPARM + 3 * NCORR
      DPTR = 1 + NRPARM
      CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), KLOCWT,
     *   JERR)
      IF (ISCMP1 .AND. ((JERR.NE.0) .OR. (KLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Determine no. channels to do
      FREQ = FREQ - (CATR(KRCRP+JLOCF)-NCH) * CATR(KRCIC+JLOCF)
      NUMCHM = CATBLK(KINAX+JLOCF) - NCH + 1
      IF (NCORR.GT.1) NUMCHM = 1
      NUMCH = (NACROS - 52) / (15 * NCOR)
      NUMCH = MAX (1, MIN (NUMCH, NUMCHM))
      ICH1 = NCH
      NNCH = NCH - 1
C                                       Make sure NITER is OK
      XAMP = 0.
      UVM = 0.
      XWT = 0.
      NWT = 1.E10
C                                       Initialize reading VIS. file.
      LENBU = 0
      BUFSZ = UVBFSS * 2
      CALL UVINIT ('READ', LUN, FIND, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFF, BO, BIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
      COUNT = 0
C                                       Counters to uncompressed
      IF (ISCMP1) THEN
         INCF = 3 * INCF
         INCS = 3 * INCS
         INCIF = 3 * INCIF
         END IF
C                                       Try to handle line
      CALL SETVIS (ICH1, NUMCH, BIF, MVIS, JADR, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1075)
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Start looping thru data.
 100  CONTINUE
C                                       Read buffer.
         CALL UVDISK ('READ', LUN, FIND, BUFF, NIO, BIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR, COUNT
            CALL MSGWRT (8)
            GO TO 999
            END IF
         IPINT = BIND - LREC
C                                       Loop thru buffer.
         DO 175 J = 1,NIO
C                                       Update counters
            COUNT = COUNT + 1
            IPINT = IPINT + LREC
C                                       Compressed?
            IF (ISCMP1) THEN
               CALL RCOPY (NRP1, BUFF(IPINT), KBUFF)
               CALL ZUVXPN (NCORR, BUFF(IPINT+NRP1),
     *            BUFF(IPINT+KLOCWT), KBUFF(DPTR))
            ELSE
               CALL RCOPY (LRECF, BUFF(IPINT), KBUFF)
               END IF
C                                       Convert uvw to kilo lamda.
            IF (I1LOCB.GE.0) THEN
               IA1 = KBUFF(1+I1LOCB)/256. + 0.1
               IA2 = KBUFF(1+I1LOCB) - IA1*256. + 0.1
            ELSE
               IA1 = KBUFF(1+I1LOA1) + 0.1
               IA2 = KBUFF(1+I1LOA2) + 0.1
               END IF
            IF (IA1.EQ.IA2) THEN
               IF (.NOT.DOACOR) GO TO 175
            ELSE
               IF (.NOT.DOXCOR) GO TO 175
               END IF
            UVM = MAX (UVM, KBUFF(1+I1LOCU))
            UVM = MAX (UVM, KBUFF(1+I1LOCV))
            UVM = MAX (UVM, KBUFF(1+I1LOCW))
            UVN = 0.0
            UVN = MIN (UVN, KBUFF(1+I1LOCU))
            UVN = MIN (UVN, KBUFF(1+I1LOCV))
            UVN = MIN (UVN, KBUFF(1+I1LOCW))
            UVM = MAX (UVM, -10.0*UVN)
C                                       Convert to VIS
            CALL GETVIS (MVIS, JADR, KBUFF(DPTR), VIS, IERR1)
C                                       Accumulate statistics
            DO 115 KK = 1,MVIS
               XWT = MAX (XWT, ABS(VIS(3,KK)))
               IF (VIS(3,KK).NE.0.0) NWT = MIN (NWT, ABS(VIS(3,KK)))
               IF (IA1.EQ.IA2) THEN
                  TEMP = VIS(1,KK)
               ELSE
                  TEMP = SQRT (VIS(1,KK)*VIS(1,KK) +
     *               VIS(2,KK)*VIS(2,KK))
                  END IF
               XAMP = MAX (XAMP, TEMP)
               XAMP = MAX (XAMP, -10.0*TEMP)
 115           CONTINUE
 175        CONTINUE
         IF ((COUNT.LT.15000) .AND. (NIO.GT.0)) GO TO 100
C
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1060 FORMAT ('ERROR:',I7,' INITIALIZING 1ST UV FILE')
 1075 FORMAT ('REQUESTED STOKES TYPE NOT AVAILABLE IN DATA SET')
 1100 FORMAT ('ERROR:',I7,' READING 1ST UV FILE VIS BLOCK ',I9)
      END
      SUBROUTINE FNDUPR (IRET)
C-----------------------------------------------------------------------
C   FNDUPR reads the UV files and prints those samples meeting the
C   criteria given by OPCODE and APARM.
C   Output:
C      IRET   I   Return code: 0 success or user requests end, else bad
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'UVDIF.INC'
      CHARACTER  CHS1*1, CHS2*1, ISTOKE(6)*2, JSTOKE(4,2)*2,TCHAR*12,
     *   LLCH*4, MMCH*4, KEYWRD*8
      LOGICAL   F, DOIT, EQUAL, FDOIT, UDOIT, SDOIT, NOPRNT, DOLAST,
     *   SRDOIT
      INTEGER   ICH(4), JADR(8), BIND, CINC, ITYPE(8), BUFSZ, HM(2),
     *   DD(2), J, ITT(4), LENBU, IWT(6), PHASE(8), INDEX, MVIS, IROUND,
     *   I, L, IA1, IA2, ICH1, ICH2, IERR, JERR, II, JJ, KK, KKK, IPINT,
     *   JCOR, LIMIT2, NIO, NNCH, NUMCH, K, LRECF, NUMCHM, OTYPE,
     *   BIND2, NIO2, IPINT2, NB, IB1, IB2, IERR2, BO, VO, XCOUNT,
     *   COUNT, IAPCNT, FCOUNT, UCOUNT, SCOUNT, NCORR, DIFCNT, LRECA,
     *   NUMKEY, LOCS, KEYTYP, DPTR, LA1, LA2, LB1, LB2, IERR1, SRCONT
      REAL   RSEC, DSEC, AMP(8), VIS(3,8), TEMP, TPHS, R, RADEG, U, V,
     *   W, XX, YY, YAMP, UVN, RMS, WTSC, U2, V2, W2, VIS2(3,8),
     *   XDAY, XDAY2, DIFMAX, RATMAX, RATRMS, DIFMIN, LDAY, LDAY2
      DOUBLE PRECISION DIF, SUMDIF, SUMDI2, MAXDIF, VMXDIF
      INCLUDE 'BUFFS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PUVD.INC'
      DATA F /.FALSE./
      DATA JSTOKE /'RR','LL','RL','LR', 'I ','Q ','U ','V '/
      DATA LENBU, BO, VO /16, 1, 0/
      DATA TCHAR /' Amp Phas Wt'/
C-----------------------------------------------------------------------
      IRET = 8
      RADEG = 180.0 / 3.14159
      CINC = 2
      FCOUNT = 0
      UCOUNT = 0
      SCOUNT = 0
      SRCONT = 0
      NOPRNT = .FALSE.
C                                       range parameters
      UVM = 0.001 * UVM
      IF (XWT.LE.0.0) THEN
         XWT = 1.0
         NWT = 1.0
         END IF
      TEMP = LOG10 (XWT/0.995)
      I = TEMP + 99.0
      I =  100 - I
      WTSC = 10.0 ** I
      TEMP = NWT * WTSC
      IF (TEMP.LT.1.0) THEN
         MSGTXT = 'Full dynamic range of weights cannot be printed'
         CALL MSGWRT (6)
         END IF
C                                       Set up for compressed data.
      NCORR = (LREC - NRPARM) / CATBLK(KINAX)
      LRECF = 3 * NCORR
      DPTR = 1 + MAX (NRP1, NRP2)
      LRECA = LRECF + DPTR - 1
      CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), KLOCWT,
     *   JERR)
      IF (ISCMP1 .AND. ((JERR.NE.0) .OR. (KLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL AXEFND (8, 'WEIGHT  ', CAT2I(KIPCN), CAT2H(KHPTP), LLOCWT,
     *   JERR)
      IF (ISCMP2 .AND. ((JERR.NE.0) .OR. (LLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Initialize difference statistics
      DIFCNT = 0
      SUMDIF = 0.0D0
      SUMDI2 = 0.0D0
      DIFMAX = -1.0E10
      DIFMIN = 1.0E10
      MAXDIF = 0.0D0
      VMXDIF = 0.0D0
C                                        Determine no. channels to do
      FREQ = FREQ - (CATR(KRCRP+JLOCF)-NCH) * CATR(KRCIC+JLOCF)
      NUMCHM = CATBLK(KINAX+JLOCF) - NCH + 1
      NUMCH = (NACROS - 52) / (15 * NCOR)
      NUMCH = MIN (NUMCH, NUMCHM)
      OTYPE = 1
      IF ((NUMCHM.GT.1) .AND. (NACROS.LE.80) .AND. (NCOR.EQ.1)) OTYPE =
     *   2
      IF ((OTYPE.EQ.2) .AND. (NACROS.LE.72)) OTYPE = 3
      IF (OTYPE.GT.1) NUMCH = 2
      IF (NUMCH.LT.1) THEN
         NUMCH = 1
         IF (NACROS.LE.80) OTYPE = 2
         IF (NACROS.LE.72) OTYPE = 3
         IF (NCOR.NE.2) THEN
            OTYPE = 4
            IF (NACROS.LE.80) OTYPE = 5
            IF (NACROS.LE.72) OTYPE = 6
            END IF
         END IF
      LIMIT2 = NCOR * NUMCH
      ICH1 = NCH
      ICH2 = NCH + NUMCH - 1
      NNCH = NCH - 1
      CALL FILL (8, 3, ITYPE)
      DO 10 II = 1,LIMIT2,NCOR
         NNCH = NNCH + 1
         DO 9 JJ = 1,NCOR
            INDEX = II + JJ - 1
            ICH(INDEX) = NNCH
            TEMP = CATD(KDCRV+JLOCS) + (JJ-CATR(KRCRP+JLOCS)) *
     *         CATR(KRCIC+JLOCS)
            I = IROUND(TEMP)
            L = 2
            IF (I.LT.0) L = 1
            I = ABS(I)
            ISTOKE(INDEX) = JSTOKE(I,L)
            ITYPE(INDEX) = 2
            IF (I+L.LE.3) ITYPE(INDEX) = 1
 9          CONTINUE
 10      CONTINUE
C                                       Convert coordinates.
      CALL H2CHR (4, 1, CATH(KHCTP+JLOCR*CINC), LLCH)
      CALL H2CHR (4, 1, CATH(KHCTP+JLOCD*CINC), MMCH)
      EQUAL = LLCH(1:2).EQ.'RA'
      IF (EQUAL) THEN
         CALL COORDD (1, RA, CHS1, HM, RSEC)
      ELSE
         CALL COORDD (2, RA, CHS1, HM, RSEC)
         END IF
      CALL COORDD (2, DEC, CHS2, DD, DSEC)
      FREQ = FREQ * 1.0E-9
C                                       Make sure NITER is OK
      IF (NITER.GT.NVIS) NITER = NVIS
C                                       Write header
      IF (DOCRT.GT.-2.5) THEN
         LINE = ' '
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       source names
         IF (NACROS.GE.90) THEN
            WRITE (LINE,1020) 1, NAME, CLASS, SEQ, DISK, USERID, ICH1,
     *         ICH2, BIF
         ELSE
            WRITE (LINE,1021) 1, NAME, CLASS, SEQ, DISK, USERID, ICH1,
     *         ICH2, BIF
            END IF
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         IF (NACROS.GE.90) THEN
            WRITE (LINE,1020) 2, NAME2, CLASS2, SEQ2, DISK2, USERID,
     *         ICH1, ICH2, BIF
         ELSE
            WRITE (LINE,1021) 2, NAME2, CLASS2, SEQ2, DISK2, USERID,
     *         ICH1, ICH2, BIF
            END IF
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1025) SOURCE, LLCH, CHS1, HM, RSEC, MMCH, CHS2, DD,
     *      DSEC
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1030) FREQ, NCOR, NVIS, ISORT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         IF (WTSC.NE.1.0) THEN
            WRITE (LINE,1031) WTSC
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         END IF
C                                       Page titles
      IF (OTYPE.EQ.1) WRITE (TITL1,1040) SOURCE, FREQ, ISORT,
     *   (ICH(JCOR), ISTOKE(JCOR), JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.2) WRITE (TITL1,1041) SOURCE, FREQ, ISORT,
     *   (ICH(JCOR), ISTOKE(JCOR), JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.3) WRITE (TITL1,1042) SOURCE, FREQ, ISORT,
     *   (ICH(JCOR), ISTOKE(JCOR), JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.4) WRITE (TITL1,1043) SOURCE, FREQ, ISORT,
     *   (ICH(JCOR), ISTOKE(JCOR), JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.5) WRITE (TITL1,1044) SOURCE, FREQ, ISORT,
     *   (ICH(JCOR), ISTOKE(JCOR), JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.6) WRITE (TITL1,1045) SOURCE, ISORT,
     *   (ICH(JCOR), ISTOKE(JCOR), JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.1) WRITE (TITL2,1050) (TCHAR, JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.2) WRITE (TITL2,1051) (TCHAR, JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.3) WRITE (TITL2,1052) (TCHAR, JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.4) WRITE (TITL2,1053) (TCHAR, JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.5) WRITE (TITL2,1054) (TCHAR, JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.6) WRITE (TITL2,1055) (TCHAR, JCOR = 1,LIMIT2)
      IF (DOCRT.GT.-2.5) THEN
         LINE = ' '
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, TITL1,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, TITL2,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
      IF (DOCRT.GT.-2.5) THEN
         LINE = ' '
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
C                                       Initialize reading VIS. file.
      LENBU = 0
      BUFSZ = UVBFSS * 2
      CALL UVINIT ('READ', LUN, FIND, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFF, BO, BIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         CALL MSGWRT (8)
         GO TO 900
         END IF
      CALL UVINIT ('READ', LUN2, FIND2, NVIS, VO, LREC2, LENBU, BUFSZ,
     *   BUFF2, BO, BIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1065) IERR
         CALL MSGWRT (8)
         GO TO 900
         END IF
      COUNT = 0
      XCOUNT = -1
      PAGE = 1
      IAPCNT = 0
C                                       Try to handle line
      CALL SETVIS (ICH1, NUMCH, BIF, MVIS, JADR, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1075)
         CALL MSGWRT (8)
         GO TO 900
         END IF
C                                       Start looping thru data.
 100  CONTINUE
C                                       Read buffer.
         COUNT = COUNT + 1
         CALL UVDISK ('READ', LUN, FIND, BUFF, NIO, BIND, IERR)
         IF (IERR.EQ.0) GO TO 105
            WRITE (MSGTXT,1100) IERR, COUNT
            CALL MSGWRT (8)
            GO TO 900
 105     CALL UVDISK ('READ', LUN2, FIND2, BUFF2, NIO2, BIND2, IERR)
         IF (IERR.EQ.0) GO TO 110
            WRITE (MSGTXT,1105) IERR, COUNT
            CALL MSGWRT (8)
            GO TO 900
 110     DOLAST = (NIO.LE.0) .OR. (NIO2.LE.0)
         IPINT = BIND - LREC
         IPINT2 = BIND2 - LREC2
         NIO = MAX (1, NIO)
C                                       Loop thru buffer.
         DO 175 J = 1,NIO
C                                       Update counters
            XCOUNT = XCOUNT + 1
            IPINT = IPINT + LREC
            IPINT2 = IPINT2 + LREC2
C                                       CONVERT
            IF (.NOT.DOLAST) THEN
C                                       Compressed?
               CALL RCOPY (NRP1, BUFF(IPINT), KBUFF)
               IF (ISCMP1) THEN
                  CALL ZUVXPN (NCORR, BUFF(IPINT+NRP1),
     *               BUFF(IPINT+KLOCWT), KBUFF(DPTR))
               ELSE
                  CALL RCOPY (LRECF, BUFF(IPINT+NRP1), KBUFF(DPTR))
                  END IF
               CALL RCOPY (NRP2, BUFF2(IPINT2), KBUFF2)
               IF (ISCMP2) THEN
                  CALL ZUVXPN (NCORR, BUFF2(IPINT2+NRP2),
     *               BUFF2(IPINT2+LLOCWT), KBUFF2(DPTR))
               ELSE
                  CALL RCOPY (LRECF, BUFF2(IPINT2+NRP2), KBUFF2(DPTR))
                  END IF
               END IF
C                                       TEST
            IF (XCOUNT.GT.0) THEN
               SRDOIT = .FALSE.
               SDOIT = .FALSE.
               UDOIT = .FALSE.
               FDOIT = .FALSE.
C                                       Decode time.
               LDAY = LBUFF(1+I1LOCT)
               LDAY2 = LBUFF2(1+I2LOCT)
               IF ((LDAY.LT.0.0) .OR. (LDAY.GT.1000.)) SDOIT = .TRUE.
               IF ((LDAY2.LT.0.0) .OR. (LDAY2.GT.1000.)) SDOIT = .TRUE.
               CALL TODHMS (LDAY, ITT)
C                                       Determine antennas.
               IF (I1LOCB.GE.0) THEN
                  LA1 = LBUFF(1+I1LOCB)/256. + 0.1
                  LA2 = LBUFF(1+I1LOCB) - LA1*256. + 0.1
               ELSE
                  LA1 = LBUFF(1+I1LOA1) + 0.1
                  LA2 = LBUFF(1+I1LOA2) + 0.1
                  END IF
               IF (LA1.EQ.LA2) THEN
                  IF (.NOT.DOACOR) GO TO 170
               ELSE
                  IF (.NOT.DOXCOR) GO TO 170
                  END IF
               IF (I2LOCB.GE.0) THEN
                  LB1 = LBUFF2(1+I2LOCB)/256. + 0.1
                  LB2 = LBUFF2(1+I2LOCB) - LB1*256. + 0.1
               ELSE
                  LB1 = LBUFF2(1+I2LOA1) + 0.1
                  LB2 = LBUFF2(1+I2LOA2) + 0.1
                  END IF
               IF (TYPUVD.LE.0) THEN
                  IF ((LA1.LE.0) .OR. (LA1.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LA2.LE.0) .OR. (LA2.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LB1.LE.0) .OR. (LB1.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LB2.LE.0) .OR. (LB2.GT.MAXANT)) SDOIT = .TRUE.
                  END IF
C                                       Sort order swap ?
               IF ((ABS(LDAY-LDAY2).GT.1.2E-5) .OR. (LA1.NE.LB1) .OR.
     *            (LA2.NE.LB2)) THEN
C                                       Decode time.
                  XDAY = KBUFF(1+I1LOCT)
                  XDAY2 = KBUFF2(1+I2LOCT)
C                                       Determine antennas.
                  IF (I1LOCB.GE.0) THEN
                     IA1 = KBUFF(1+I1LOCB)/256. + 0.1
                     IA2 = KBUFF(1+I1LOCB) - IA1*256. + 0.1
                  ELSE
                     IA1 = KBUFF(1+I1LOA1) + 0.1
                     IA2 = KBUFF(1+I1LOA2) + 0.1
                     END IF
                  IF (I2LOCB.GE.0) THEN
                     IB1 = KBUFF2(1+I2LOCB)/256. + 0.1
                     IB2 = KBUFF2(1+I2LOCB) - IB1*256. + 0.1
                  ELSE
                     IB1 = KBUFF2(1+I2LOA1) + 0.1
                     IB2 = KBUFF2(1+I2LOA2) + 0.1
                     END IF
                  SRDOIT = (LA1.EQ.IB1) .AND. (LA2.EQ.IB2) .AND.
     *               (LB1.EQ.IA1) .AND. (LB2.EQ.IA2) .AND.
     *               (ABS(LDAY-XDAY2).LE.1.2E-5) .AND.
     *               (ABS(XDAY-LDAY2).LE.1.2E-5) .AND. (.NOT.DOLAST)
C                                       Yes: swap buffers
                  IF (SRDOIT) THEN
                     SRCONT = SRCONT + 1
                     LDAY2 = XDAY2
                     LB1 = IB1
                     LB2 = IB2
                     CALL RCOPY (LRECA, LBUFF2, KBUFF2)
                     IF (ISCMP2) THEN
                        CALL RCOPY (NRP2, BUFF2(IPINT2), LBUFF2)
                        CALL ZUVXPN (NCORR, BUFF2(IPINT2+NRP2),
     *                     BUFF2(IPINT2+LLOCWT), LBUFF2(DPTR))
                     ELSE
                        CALL RCOPY (LRECA, BUFF2(IPINT2), LBUFF2)
                        END IF
C                                       No: error
                  ELSE
                     SDOIT = .TRUE.
                     END IF
                  END IF
C                                       Convert uvw to kilo lamda.
               U = LBUFF(1+I1LOCU) * 0.001
               V = LBUFF(1+I1LOCV) * 0.001
               W = LBUFF(1+I1LOCW) * 0.001
               U2 = LBUFF2(1+I2LOCU) * 0.001
               V2 = LBUFF2(1+I2LOCV) * 0.001
               W2 = LBUFF2(1+I2LOCW) * 0.001
               UVM = MAX (UVM, U)
               UVM = MAX (UVM, V)
               UVM = MAX (UVM, W)
               UVN = U
               UVN = MIN (UVN, V)
               UVN = MIN (UVN, W)
               UVM = MAX (UVM, -10.0*UVN)
               R = U * U + V * V
C                                       UV box and range
               IF (.NOT.SDOIT) THEN
                  IF ((R.LT.UVRANG(1)) .OR. (R.GT.UVRANG(2))) GO TO 170
                  IF (DOUVBX) THEN
                     IF ((ABS(U-U2).GT.APARM(3)) .OR. (ABS(V-V2).GT.
     *                  APARM(3)) .OR. (ABS(W-W2).GT.APARM(3)))
     *                  UDOIT = .TRUE.
                     END IF
                  END IF
C                                       Convert to VIS
               CALL GETVIS (MVIS, JADR, LBUFF(DPTR), VIS, IERR1)
               CALL GETVIS (MVIS, JADR, LBUFF2(DPTR), VIS2, IERR2)
               IF ((IERR1.NE.0) .AND. (IERR2.NE.0)) GO TO 170
               FDOIT = (IERR1.NE.IERR2) .AND. (APARM(4).GT.0.0)
C                                       Accumulate statistics
               DOIT = FDOIT .OR. UDOIT .OR. SDOIT
               IF (.NOT.DOIT) THEN
                  DO 115 KK = 1,MVIS
                     IF ((VIS(3,KK).GT.0.0) .OR. (VIS2(3,KK).GT.0.0)
     *                  .OR. (DOFLAG)) THEN
                        DIFMAX = MAX (DIFMAX, VIS(1,KK), VIS(2,KK))
                        DIFMAX = MAX (DIFMAX, VIS2(1,KK), VIS2(2,KK))
                        DIFMIN = MIN (DIFMIN, VIS(1,KK), VIS(2,KK))
                        DIFMIN = MIN (DIFMIN, VIS2(1,KK), VIS2(2,KK))
                        DIF = VIS2(1,KK) - VIS(1,KK)
                        DIFCNT = DIFCNT + 1
                        SUMDIF = SUMDIF + DIF
                        SUMDI2 = SUMDI2 + DIF*DIF
                        IF (ABS(DIF).GT.MAXDIF) THEN
                           MAXDIF = ABS (DIF)
                           VMXDIF = MAX (ABS(VIS2(1,KK)),
     *                        ABS(VIS(1,KK)))
                           END IF
                        DIF = VIS2(2,KK) - VIS(2,KK)
                        DIFCNT = DIFCNT + 1
                        SUMDIF = SUMDIF + DIF
                        SUMDI2 = SUMDI2 + DIF*DIF
                        IF (ABS(DIF).GT.MAXDIF) THEN
                           MAXDIF = ABS (DIF)
                           VMXDIF = MAX (ABS(VIS2(2,KK)),
     *                        ABS(VIS(2,KK)))
                           END IF
                        END IF
 115                 CONTINUE
                  END IF
C                                       Do we want this one
               IF ((.NOT.DOIT) .AND. (DOMAX)) THEN
                  DO 130 K = 1,MVIS
                     IF ((ITYPE(K).LE.2) .AND. ((VIS(3,K).GT.0.0) .OR.
     *                  (VIS2(3,K).GT.0.0) .OR. (DOFLAG))) THEN
                        IF (ABS(VIS(1,K)-VIS2(1,K)).GT.APARM(ITYPE(K)))
     *                     FDOIT = .TRUE.
                        IF (ABS(VIS(2,K)-VIS2(2,K)).GT.APARM(ITYPE(K)))
     *                     FDOIT = .TRUE.
                        IF (APARM(4).GT.0.0) THEN
                           IF (ABS(VIS(3,K)-VIS2(3,K)).GT.APARM(4))
     *                        FDOIT = .TRUE.
                           IF ((VIS(3,K).LE.0.0).AND.(VIS2(3,K).GT.0.0))
     *                        FDOIT = .TRUE.
                           IF ((VIS(3,K).GT.0.0).AND.(VIS2(3,K).LE.0.0))
     *                        FDOIT = .TRUE.
                        ELSE
                           IF (ABS(ABS(VIS(3,K))-ABS(VIS2(3,K))).GT.
     *                        -APARM(4)) FDOIT = .TRUE.
                           END IF
                        END IF
 130                 CONTINUE
                  DOIT = FDOIT
                  END IF
               IF (.NOT.DOIT) GO TO 170
               IF (IAPCNT.GE.NITER) NOPRNT = .TRUE.
               IF ((NOPRNT) .AND. (DOCRT.GT.0.0)) GO TO 200
               IF (.NOT.NOPRNT) IAPCNT = IAPCNT + 1
               IF (FDOIT) FCOUNT = FCOUNT + 1
               IF (UDOIT) UCOUNT = UCOUNT + 1
               IF (SDOIT) SCOUNT = SCOUNT + 1
               IF (NOPRNT) GO TO 170
C                                       Get vis.
               DO 165 NB = 1,2
               K = 0
               YAMP = 0.0
               DO 140 KK = ICH1,ICH2
                  DO 139 KKK = 1,NCOR
                     K = K + 1
                     INDEX = 1 + (KK-1) * INCF + (KKK-1) * INCS +
     *                  (BIF-1) * INCIF + MAX (NRP1, NRP2)
                     IF (NB.EQ.1) THEN
                        XX = LBUFF(INDEX)
                        YY = LBUFF(INDEX+1)
                        TPHS = LBUFF(INDEX+2)
                     ELSE
                        XX = LBUFF2(INDEX)
                        YY = LBUFF2(INDEX+1)
                        TPHS = LBUFF2(INDEX+2)
                        END IF
                     TPHS = MAX (-99.0, MIN (99.0, TPHS*WTSC))
                     IWT(K) = IROUND (TPHS)
                     IF (LA1.EQ.LA2) THEN
                        AMP(K) = XX
                        TPHS = 0.0
                     ELSE
                        AMP(K) = SQRT(XX*XX+YY*YY)
                        TPHS = 57.296 * ATAN2 (YY, XX+1.0E-20)
                        END IF
                     PHASE(K) = IROUND (TPHS)
                     XAMP = MAX (XAMP, AMP(K))
                     YAMP = MIN (YAMP, AMP(K))
 139                 CONTINUE
 140              CONTINUE
               IF (NB.NE.1) THEN
                  LA1 = LB1
                  LA2 = LB2
                  U = U2
                  V = V2
                  W = W2
                  CALL TODHMS (LDAY2, ITT)
                  END IF
C                                       Write VIS data: CRT
               XAMP = MAX (XAMP, -10.0*YAMP)
C                                       low UVW, low flux
               IF ((XAMP.GT.99.9) .AND. (OTYPE.GT.2)) GO TO 150
                  IF ((UVM.GT.9999.98) .AND. (OTYPE.LT.5)) GO TO 145
                     IF (OTYPE.EQ.1) WRITE (LINE,1140,ERR=160)
     *                  XCOUNT, ITT, LA1, LA2, U, V, W,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     IF (OTYPE.EQ.2) WRITE (LINE,1141,ERR=160)
     *                  XCOUNT, ITT, LA1, LA2, U, V,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     IF (OTYPE.EQ.3) WRITE (LINE,1142,ERR=160)
     *                  XCOUNT, ITT, LA1, LA2, U, V,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     IF (OTYPE.EQ.4) WRITE (LINE,1143,ERR=160)
     *                  XCOUNT, ITT, LA1, LA2, U, V,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     IF (OTYPE.EQ.5) WRITE (LINE,1144,ERR=160)
     *                  XCOUNT, ITT, LA1, LA2,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     IF (OTYPE.EQ.6) WRITE (LINE,1145,ERR=160)
     *                  ITT(2), ITT(3), ITT(4), LA1, LA2,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     GO TO 160
C                                       High UVW, low flux
 145              CONTINUE
                     IF (OTYPE.EQ.1) WRITE (LINE,1146,ERR=160)
     *                  XCOUNT, ITT, LA1, LA2, U, V, W,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     IF (OTYPE.EQ.2) WRITE (LINE,1147,ERR=160)
     *                  XCOUNT, ITT, LA1, LA2, U, V,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     IF (OTYPE.EQ.3) WRITE (LINE,1148,ERR=160)
     *                  XCOUNT, ITT, LA1, LA2, U, V,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     IF (OTYPE.EQ.4) WRITE (LINE,1149,ERR=160)
     *                  XCOUNT, ITT, LA1, LA2, U, V,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     GO TO 160
C                                       low UVW, higher flux
 150           CONTINUE
                  IF ((UVM.GT.9999.98) .AND. (OTYPE.LT.5)) GO TO 155
                     IF (OTYPE.EQ.3) WRITE (LINE,1150,ERR=160)
     *                  XCOUNT, ITT, LA1, LA2, U, V,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     IF (OTYPE.EQ.4) WRITE (LINE,1151,ERR=160)
     *                  XCOUNT, ITT, LA1, LA2, U, V,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     IF (OTYPE.EQ.5) WRITE (LINE,1152,ERR=160)
     *                  XCOUNT, ITT, LA1, LA2,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     IF (OTYPE.EQ.6) WRITE (LINE,1153,ERR=160)
     *                  ITT(2), ITT(3), ITT(4), LA1, LA2,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     GO TO 160
C                                       High UVW, higher flux
 155              CONTINUE
                     IF (OTYPE.EQ.3) WRITE (LINE,1155,ERR=160)
     *                  XCOUNT, ITT, LA1, LA2, U, V,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     IF (OTYPE.EQ.4) WRITE (LINE,1156,ERR=160)
     *                  XCOUNT, ITT, LA1, LA2, U, V,
     *                  (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
 160           CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2,
     *            LINE, IPCNT, PAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 900
 165           CONTINUE
               END IF
 170        IF (DOLAST) THEN
               GO TO 200
            ELSE
               CALL RCOPY (LRECA, KBUFF, LBUFF)
               CALL RCOPY (LRECA, KBUFF2, LBUFF2)
               END IF
 175        CONTINUE
         GO TO 100
C                                       Number lines printed
 200  IF (DOCRT.LE.0.0) THEN
         LINE = ' '
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1200) IAPCNT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      WRITE (MSGTXT,1200) IAPCNT
      IF (IAPCNT.GT.0) THEN
         CALL MSGWRT (5)
      ELSE
         CALL MSGWRT (3)
         END IF
      IF ((IAPCNT.LT.NITER) .OR. (NITER.EQ.NVIS)) GO TO 210
         IF (DOCRT.LE.0.0) THEN
            WRITE (LINE,1202)
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         IPCNT = IPCNT + 2
         WRITE (MSGTXT,1203)
         CALL MSGWRT (6)
 210  IPCNT = IPCNT + 2
      IF (DOCRT.LE.0.0) THEN
         WRITE (LINE,1210) FCOUNT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1211) UCOUNT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1212) SCOUNT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1213) SRCONT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      WRITE (MSGTXT,1210) FCOUNT
      IF (FCOUNT.GT.0) THEN
         CALL MSGWRT (5)
      ELSE
         CALL MSGWRT (3)
         END IF
      WRITE (MSGTXT,1211) UCOUNT
      IF (UCOUNT.GT.0) THEN
         CALL MSGWRT (5)
      ELSE
         CALL MSGWRT (3)
         END IF
      WRITE (MSGTXT,1212) SCOUNT
      IF (SCOUNT.GT.0) THEN
         CALL MSGWRT (5)
      ELSE
         CALL MSGWRT (3)
         END IF
      WRITE (MSGTXT,1213) SRCONT
      IF (SRCONT.GT.0) THEN
         CALL MSGWRT (5)
      ELSE
         CALL MSGWRT (3)
         END IF
C                                       Write statistics in header of
C                                       first input file
 900  IF (DIFCNT.LT.2) THEN
         MSGTXT = 'NO POINTS EVEN CHECKED FOR DIFFERENCES IN FLUX'
         CALL MSGWRT (7)
         DIFMAX = 1.0E12
         DIFMIN = 1.0E12
         DIFCNT = 2
         SUMDIF = 1.
         SUMDI2 = 2.
         END IF
      DIFMAX = MAX (ABS(DIFMAX), ABS(DIFMIN))
      SUMDIF = SUMDIF / DIFCNT
      SUMDI2 = SUMDI2 / DIFCNT
      RMS = SQRT (ABS (SUMDI2 - SUMDIF*SUMDIF) / (DIFCNT-1))
      RATMAX = MAXDIF / DIFMAX
      RATRMS = RMS / DIFMAX
      IF ((IERR.EQ.0) .AND. (DOCRT.LE.0.0)) THEN
         IF (DOCRT.GT.-2.5) THEN
            LINE = ' '
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         WRITE (LINE,1900) MAXDIF, RMS
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1901) RATMAX, RATRMS
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1902) DIFMAX, VMXDIF
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      WRITE (MSGTXT,1900) MAXDIF, RMS
      CALL MSGWRT (5)
      WRITE (MSGTXT,1901) RATMAX, RATRMS
      CALL MSGWRT (5)
      WRITE (MSGTXT,1902) DIFMAX, VMXDIF
      CALL MSGWRT (5)
      RATMAX = MAX (RATMAX, 1.57683E-30)
      RATRMS = MAX (RATRMS, 1.57683E-30)
      NUMKEY = 1
      LOCS = 1
      KEYTYP = 2
      KEYWRD = 'RATMAX  '
      CALL CATKEY ('WRIT', DISK, CNO, KEYWRD, NUMKEY, LOCS, RATMAX,
     *   KEYTYP,  LBUFF, JERR)
      KEYWRD = 'RATRMS  '
      CALL CATKEY ('WRIT', DISK, CNO, KEYWRD, NUMKEY, LOCS, RATRMS,
     *   KEYTYP,  LBUFF, JERR)
C                                       Close files.
      IF (IERR.LE.0) IRET = 0
      CALL LPCLOS (PLUN, PIND, IPCNT, IERR)
C
      CALL MAPCLS ('READ', DISK, CNO, LUN, FIND, CATBLK, F, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1910) IERR
         CALL MSGWRT (6)
         END IF
      CALL MAPCLS ('READ', DISK2, CNO2, LUN2, FIND2, CAT2I, F, BUFF,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1920) IERR
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('File',I1,' = ',A12,'.',A6,'.',I4,'   Vol =',I2,
     *   '    UserID =',I5,5X,'Channels =',I5,' to ',I5,' BIF=',I3)
 1021 FORMAT (I1,1X,A12,'.',A6,'.',I4,'  Vol=',I2,'  User=',I5,
     *   '  Chan=',I4,' to',I4,'  IF=',I3)
 1025 FORMAT ('Source= ',A8,3X,A4,' = ',A1,I2.2,I3.2,F6.2,3X,A4,' = ',
     *   A1,I2.2,I3.2,F5.1)
 1030 FORMAT ('Freq=',F13.9,' GHz   ncor=',I3,'   No. vis=',I10,
     *   '   Sort order= ',A2)
 1031 FORMAT ('Weights have been multiplied by',1PE10.2)
 1040 FORMAT ('Source= ',A8,4X,'Freq= ',F13.9,4X,'Sort= ',A2,1X,
     *   5(4X,I4,1X,A2,4X))
 1041 FORMAT (A,4X,'Freq=',F13.9,4X,'Sort= ',A2,1X,5(4X,I4,1X,A2,4X))
 1042 FORMAT (A,4X,'Freq=',F13.9,4X,'Sort= ',A2,1X,4(3X,I4,1X,A2,4X))
 1043 FORMAT (A,4X,'Freq=',F13.9,4X,'Sort= ',A2,4(3X,I4,1X,A2,4X))
 1044 FORMAT (A,F13.9,1X,A2,4(3X,I4,1X,A2,4X))
 1045 FORMAT (A,2X,A2,2X,4(3X,I4,1X,A2,4X))
 1050 FORMAT ('  Vis #',5X,'IAT',6X,'Ant   U(Klam)  V(Klam)  W(Klam)',
     *   5(3X,A))
 1051 FORMAT ('  Vis #',5X,'IAT',6X,'Ant   U(Klam)  V(Klam)',5(3X,A))
 1052 FORMAT ('  Vis #',5X,'IAT',6X,'Ant   U(Klam)  V(Klam)',4(2X,A))
 1053 FORMAT (' Vis #',5X,'IAT',6X,'Ant   U(Klam)  V(Klam)',4(2X,A))
 1054 FORMAT (' Vis #',5X,'IAT',6X,'Ant ',4(2X,A))
 1055 FORMAT (2X,'IAT',5X,'Ant ',4(2X,A))
 1060 FORMAT ('ERROR:',I7,' INITIALIZING 1ST UV FILE')
 1065 FORMAT ('ERROR:',I7,' INITIALIZING 2ND UV FILE')
 1075 FORMAT ('REQUESTED STOKES TYPE NOT AVAILABLE IN DATA SET')
 1100 FORMAT ('ERROR:',I7,' READING 1ST UV FILE VIS BLOCK ',I9)
 1105 FORMAT ('ERROR:',I7,' READING 2ND UV FILE VIS BLOCK ',I9)
 1140 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,3F9.2,5(F8.3,I4,I3))
 1141 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F9.2,5(F8.3,I4,I3))
 1142 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F9.2,4(F7.3,I4,I3))
 1143 FORMAT (I6,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F9.2,4(F7.3,I4,I3))
 1144 FORMAT (I6,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,4(F7.3,I4,I3))
 1145 FORMAT (I2.2,2(':',I2.2),I3,'-',I2,4(F7.3,I4,I3))
 1146 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,3F9.0,5(F8.3,I4,I3))
 1147 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F9.0,5(F8.3,I4,I3))
 1148 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F9.0,4(F7.3,I4,I3))
 1149 FORMAT (I6,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F9.0,4(F7.3,I4,I3))
 1150 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F9.2,4(F7.1,I4,I3))
 1151 FORMAT (I6,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F9.2,4(F7.1,I4,I3))
 1152 FORMAT (I6,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,4(F7.1,I4,I3))
 1153 FORMAT (I2.2,2(':',I2.2),I3,'-',I2,4(F7.1,I4,I3))
 1155 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F9.0,4(F7.1,I4,I3))
 1156 FORMAT (I6,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F9.0,4(F7.1,I4,I3))
 1200 FORMAT (I5,' Points printed')
 1202 FORMAT ('0********** PRINT LIMIT REACHED: MORE POINTS MAY EXIST',
     *   ' **********')
 1203 FORMAT ('WARNING: PRINT LIMIT REACHED, NOT ALL POINTS LISTED')
 1210 FORMAT (I8,' Points found for flux differences')
 1211 FORMAT (I8,' Points found for u,v,w differences')
 1212 FORMAT (I8,' Points found for other differences')
 1213 FORMAT (I8,' Points swapped for apparent sort order reversal')
 1900 FORMAT ('Visibilty Max diff      =',1PE11.3,'  RMS      =',E11.3)
 1901 FORMAT ('Visibilty Max diff/peak =',1PE11.3,'  RMS/peak =',E11.3)
 1902 FORMAT ('Visibility peak',1PE11.3,'  Visibility at max diff',
     *   E11.3)
 1910 FORMAT ('ERROR:',I7,' CLOSING 1ST UV FILE ')
 1920 FORMAT ('ERROR:',I7,' CLOSING 2ND UV FILE ')
      END
      SUBROUTINE SETVIS (ICH, NCH, IFNUM, MVIS, JADR, IERR)
C-----------------------------------------------------------------------
C   SETVIS setup the array JADR for reformatting uv data.  There is also
C   a check to make sure the desired data is available.  Calls to GETVIS
C   will reformat the data.  Needs values set by UVPGET and VHDRIN.
C   Only 1 IF will be processed.
C   Inputs:
C      ICH     I      First line channel desired.
C      NCH     I      Number of line channels desired
C      IFNUM   I      IF number wanted.
C   Output:
C      MVIS    I      Number of visibilities in requested output format
C      JADR    I(*)   Pointers to the first and second visibility
C                     input records to be used in the output record.
C      IERR    I      Error flag. 0 =>OK, otherwise data unavailable.
C   Common (input):
C      /MAPHDR/  must have uv header
C      /UVHDR/   must be initialized by UVPGET
C-----------------------------------------------------------------------
      INTEGER   ICH, NCH, IFNUM, MVIS, JADR(*), IERR
C
      INTEGER   JNCS, JNCF, JNCIF, I, IOFF
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IERR = 1
C                                       Set pointers.
      JNCS = INCS / 3
      JNCF = INCF / 3
      JNCIF = INCIF / 3
      IF (JNCIF.LT.1) JNCIF = 1
      IF ((ICH.LT.1) .OR. (ICH+NCH-1.GT.CATBLK(KINAX+JLOCF))) GO TO 999
      IOFF = (IFNUM-1) * JNCIF + (ICH-1) * JNCF
C                                       Check IF
      IF ((IFNUM.GT.1) .AND. (IFNUM.GT.CATBLK(KINAX+JLOCIF))) GO TO 999
      IF (IFNUM.LE.0) GO TO 999
C                                       pure correlators
      IERR = 0
      MVIS = NCOR * NCH
      DO 10 I = 1,MVIS
         JADR(I) = IOFF + (I-1) * JNCS + 1
         IF (MOD(I,NCOR).EQ.0) IOFF = IOFF + JNCF
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE GETVIS (MVIS, JADR, DATA, VIS, IERR)
C-----------------------------------------------------------------------
C   GETVIS gets and reformats uv data. Requires setup by SETVIS.
C   Inputs:
C      MVIS          I    Number of visibilities wanted.
C      JADR(MVIS)    I    Pointers set by SETVIS.
C      DATA(3,*)     R    Visibility portion of input data.
C   Outputs:
C      VIS(3,MVIS)   R    Visibilities.
C      IERR          I    Error code, 0=>OK,
C                            2 = bad input.
C-----------------------------------------------------------------------
      INTEGER   MVIS, JADR(*), IERR
      REAL      DATA(3,*), VIS(3,*)
C
      INTEGER   I, IP
C-----------------------------------------------------------------------
      VIS(1,1) = 0.0
      VIS(2,1) = 0.0
      VIS(3,1) = 0.0
C                                       Check input.
      IERR = 2
      IF (MVIS.LE.0) GO TO 999
      IERR = 1
      DO 50 I = 1,MVIS
         IP = JADR(I)
         VIS(1,I) = DATA(1,IP)
         VIS(2,I) = DATA(2,IP)
         VIS(3,I) = DATA(3,IP)
         IF (VIS(3,I).GT.0.0) IERR = 0
 50      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE FNDUBX (IRET)
C-----------------------------------------------------------------------
C   FNDUBX reads the UV files and prints those samples showing
C   differences in u,v,w.
C   Output:
C      IRET   I   Return code: 0 success or user requests end, else bad
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'UVDIF.INC'
      CHARACTER  CHS1*1, CHS2*1, ISTOKE(6)*2, JSTOKE(4,2)*2,TCHAR*12,
     *   LLCH*4, MMCH*4, KEYWRD*8
      LOGICAL   F, DOIT, EQUAL, FDOIT, UDOIT, SDOIT, NOPRNT, DOLAST,
     *   SRDOIT
      INTEGER   ICH(4), JADR(8), BIND, CINC, ITYPE(8), BUFSZ, HM(2),
     *   DD(2), J, ITT(4), LENBU, IWT(6), PHASE(8), INDEX, MVIS, IROUND,
     *   I, L, IA1, IA2, ICH1, ICH2, IERR, JERR, II, JJ, KK, KKK, IPINT,
     *   JCOR, LIMIT2, NIO, NNCH, NUMCH, K, LRECF, NUMCHM, OTYPE, LCOR,
     *   BIND2, NIO2, IPINT2, NB, IB1, IB2, IERR2, BO, VO, XCOUNT,
     *   COUNT, IAPCNT, FCOUNT, UCOUNT, SCOUNT, NCORR, DIFCNT, LRECA,
     *   NUMKEY, LOCS, KEYTYP, DPTR, LA1, LA2, LB1, LB2, IERR1, SRCONT
      REAL   RSEC, DSEC, AMP(8), VIS(3,8), TEMP, TPHS, R, RADEG, U, V,
     *   W, XX, YY, YAMP, UVN, RMS, WTSC, U2, V2, W2, VIS2(3,8),
     *   XDAY, XDAY2, DIFMAX, RATMAX, RATRMS, DIFMIN, LDAY, LDAY2
      DOUBLE PRECISION DIF, SUMDIF, SUMDI2, MAXDIF, VMXDIF
      INCLUDE 'BUFFS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PUVD.INC'
      DATA F /.FALSE./
      DATA JSTOKE /'RR','LL','RL','LR', 'I ','Q ','U ','V '/
      DATA LENBU, BO, VO /16, 1, 0/
      DATA TCHAR /' Amp Phas Wt'/
C-----------------------------------------------------------------------
      IRET = 8
      RADEG = 180.0 / 3.14159
      CINC = 2
      FCOUNT = 0
      UCOUNT = 0
      SCOUNT = 0
      SRCONT = 0
      NOPRNT = .FALSE.
C                                       range parameters
      UVM = 0.001 * UVM
      IF (XWT.LE.0.0) THEN
         XWT = 1.0
         NWT = 1.0
         END IF
      TEMP = LOG10 (XWT/0.995)
      I = TEMP + 99.0
      I =  100 - I
      WTSC = 10.0 ** I
      TEMP = NWT * WTSC
      IF (TEMP.LT.1.0) THEN
         MSGTXT = 'Full dynamic range of weights cannot be printed'
         CALL MSGWRT (6)
         END IF
C                                       Set up for compressed data.
      NCORR = (LREC - NRPARM) / CATBLK(KINAX)
      LRECF = 3 * NCORR
      DPTR = 1 + MAX (NRP1, NRP2)
      LRECA = LRECF + DPTR - 1
      CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), KLOCWT,
     *   JERR)
      IF (ISCMP1 .AND. ((JERR.NE.0) .OR. (KLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL AXEFND (8, 'WEIGHT  ', CAT2I(KIPCN), CAT2H(KHPTP), LLOCWT,
     *   JERR)
      IF (ISCMP2 .AND. ((JERR.NE.0) .OR. (LLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Initialize difference statistics
      DIFCNT = 0
      SUMDIF = 0.0D0
      SUMDI2 = 0.0D0
      DIFMAX = -1.0E10
      DIFMIN = 1.0E10
      MAXDIF = 0.0D0
      VMXDIF = 0.0D0
C                                        Determine no. channels to do
      FREQ = FREQ - (CATR(KRCRP+JLOCF)-NCH) * CATR(KRCIC+JLOCF)
      NUMCHM = CATBLK(KINAX+JLOCF) - NCH + 1
      LCOR = MIN (2, NCOR)
      NUMCH = (NACROS - 61) / (16 * LCOR)
      NUMCH = MIN (NUMCH, NUMCHM)
      OTYPE = 1
      IF (NUMCH.LT.1) THEN
         NUMCH = 1
         IF (NACROS.LE.80) LCOR = 1
         IF (NACROS.LE.72) OTYPE = 2
         END IF
      LIMIT2 = LCOR * NUMCH
      ICH1 = NCH
      ICH2 = NCH + NUMCH - 1
      NNCH = NCH - 1
      CALL FILL (8, 3, ITYPE)
      DO 10 II = 1,LIMIT2,LCOR
         NNCH = NNCH + 1
         DO 9 JJ = 1,LCOR
            INDEX = II + JJ - 1
            ICH(INDEX) = NNCH
            TEMP = CATD(KDCRV+JLOCS) + (JJ-CATR(KRCRP+JLOCS)) *
     *         CATR(KRCIC+JLOCS)
            I = IROUND(TEMP)
            L = 2
            IF (I.LT.0) L = 1
            I = ABS(I)
            ISTOKE(INDEX) = JSTOKE(I,L)
            ITYPE(INDEX) = 2
            IF (I+L.LE.3) ITYPE(INDEX) = 1
 9          CONTINUE
 10      CONTINUE
C                                       Convert coordinates.
      CALL H2CHR (4, 1, CATH(KHCTP+JLOCR*CINC), LLCH)
      CALL H2CHR (4, 1, CATH(KHCTP+JLOCD*CINC), MMCH)
      EQUAL = LLCH(1:2).EQ.'RA'
      IF (EQUAL) THEN
         CALL COORDD (1, RA, CHS1, HM, RSEC)
      ELSE
         CALL COORDD (2, RA, CHS1, HM, RSEC)
         END IF
      CALL COORDD (2, DEC, CHS2, DD, DSEC)
      FREQ = FREQ * 1.0E-9
C                                       Make sure NITER is OK
      IF (NITER.GT.NVIS) NITER = NVIS
C                                       Write header
      IF (DOCRT.GT.-2.5) THEN
         LINE = ' '
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       source names
         IF (NACROS.GE.90) THEN
            WRITE (LINE,1020) 1, NAME, CLASS, SEQ, DISK, USERID, ICH1,
     *         ICH2, BIF
         ELSE
            WRITE (LINE,1021) 1, NAME, CLASS, SEQ, DISK, USERID, ICH1,
     *         ICH2, BIF
            END IF
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         IF (NACROS.GE.90) THEN
            WRITE (LINE,1020) 2, NAME2, CLASS2, SEQ2, DISK2, USERID,
     *         ICH1, ICH2, BIF
         ELSE
            WRITE (LINE,1021) 2, NAME2, CLASS2, SEQ2, DISK2, USERID,
     *         ICH1, ICH2, BIF
            END IF
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1025) SOURCE, LLCH, CHS1, HM, RSEC, MMCH, CHS2, DD,
     *      DSEC
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1030) FREQ, NCOR, NVIS, ISORT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         IF (WTSC.NE.1.0) THEN
            WRITE (LINE,1031) WTSC
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         END IF
C                                       Page titles
      IF (OTYPE.EQ.1) WRITE (TITL1,1040) SOURCE, FREQ, ISORT,
     *   (ICH(JCOR), ISTOKE(JCOR), JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.2) WRITE (TITL1,1041) SOURCE, FREQ, ISORT,
     *   (ICH(JCOR), ISTOKE(JCOR), JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.1) WRITE (TITL2,1050) (TCHAR, JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.2) WRITE (TITL2,1051) (TCHAR, JCOR = 1,LIMIT2)
      IF (DOCRT.GT.-2.5) THEN
         LINE = ' '
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, TITL1,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, TITL2,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
      IF (DOCRT.GT.-2.5) THEN
         LINE = ' '
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
C                                       Initialize reading VIS. file.
      LENBU = 0
      BUFSZ = UVBFSS * 2
      CALL UVINIT ('READ', LUN, FIND, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFF, BO, BIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         CALL MSGWRT (8)
         GO TO 900
         END IF
      CALL UVINIT ('READ', LUN2, FIND2, NVIS, VO, LREC2, LENBU, BUFSZ,
     *   BUFF2, BO, BIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1065) IERR
         CALL MSGWRT (8)
         GO TO 900
         END IF
      COUNT = 0
      XCOUNT = -1
      PAGE = 1
      IAPCNT = 0
C                                       Try to handle line
      CALL SETVIS (ICH1, NUMCH, BIF, MVIS, JADR, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1075)
         CALL MSGWRT (8)
         GO TO 900
         END IF
C                                       Start looping thru data.
 100  CONTINUE
C                                       Read buffer.
         COUNT = COUNT + 1
         CALL UVDISK ('READ', LUN, FIND, BUFF, NIO, BIND, IERR)
         IF (IERR.EQ.0) GO TO 105
            WRITE (MSGTXT,1100) IERR, COUNT
            CALL MSGWRT (8)
            GO TO 900
 105     CALL UVDISK ('READ', LUN2, FIND2, BUFF2, NIO2, BIND2, IERR)
         IF (IERR.EQ.0) GO TO 110
            WRITE (MSGTXT,1105) IERR, COUNT
            CALL MSGWRT (8)
            GO TO 900
 110     DOLAST = (NIO.LE.0) .OR. (NIO2.LE.0)
         IPINT = BIND - LREC
         IPINT2 = BIND2 - LREC2
         NIO = MAX (1, NIO)
C                                       Loop thru buffer.
         DO 175 J = 1,NIO
C                                       Update counters
            XCOUNT = XCOUNT + 1
            IPINT = IPINT + LREC
            IPINT2 = IPINT2 + LREC2
C                                       CONVERT
            IF (.NOT.DOLAST) THEN
C                                       Compressed?
               CALL RCOPY (NRP1, BUFF(IPINT), KBUFF)
               IF (ISCMP1) THEN
                  CALL ZUVXPN (NCORR, BUFF(IPINT+NRP1),
     *               BUFF(IPINT+KLOCWT), KBUFF(DPTR))
               ELSE
                  CALL RCOPY (LRECF, BUFF(IPINT+NRP1), KBUFF(DPTR))
                  END IF
               CALL RCOPY (NRP2, BUFF2(IPINT2), KBUFF2)
               IF (ISCMP2) THEN
                  CALL ZUVXPN (NCORR, BUFF2(IPINT2+NRP2),
     *               BUFF2(IPINT2+LLOCWT), KBUFF2(DPTR))
               ELSE
                  CALL RCOPY (LRECF, BUFF2(IPINT2+NRP2), KBUFF2(DPTR))
                  END IF
               END IF
C                                       TEST
            IF (XCOUNT.GT.0) THEN
               SRDOIT = .FALSE.
               SDOIT = .FALSE.
               UDOIT = .FALSE.
               FDOIT = .FALSE.
C                                       Decode time.
               LDAY = LBUFF(1+I1LOCT)
               LDAY2 = LBUFF2(1+I2LOCT)
               IF ((LDAY.LT.0.0) .OR. (LDAY.GT.1000.)) SDOIT = .TRUE.
               IF ((LDAY2.LT.0.0) .OR. (LDAY2.GT.1000.)) SDOIT = .TRUE.
               CALL TODHMS (LDAY, ITT)
C                                       Determine antennas.
               IF (I1LOCB.GE.0) THEN
                  LA1 = LBUFF(1+I1LOCB)/256. + 0.1
                  LA2 = LBUFF(1+I1LOCB) - LA1*256. + 0.1
               ELSE
                  LA1 = LBUFF(1+I1LOA1) + 0.1
                  LA2 = LBUFF(1+I1LOA2) + 0.1
                  END IF
               IF (LA1.EQ.LA2) THEN
                  IF (.NOT.DOACOR) GO TO 170
               ELSE
                  IF (.NOT.DOXCOR) GO TO 170
                  END IF
               IF (I2LOCB.GE.0) THEN
                  LB1 = LBUFF2(1+I2LOCB)/256. + 0.1
                  LB2 = LBUFF2(1+I2LOCB) - LB1*256. + 0.1
               ELSE
                  LB1 = LBUFF2(1+I2LOA1) + 0.1
                  LB2 = LBUFF2(1+I2LOA2) + 0.1
                  END IF
               IF (TYPUVD.LE.0) THEN
                  IF ((LA1.LE.0) .OR. (LA1.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LA2.LE.0) .OR. (LA2.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LB1.LE.0) .OR. (LB1.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LB2.LE.0) .OR. (LB2.GT.MAXANT)) SDOIT = .TRUE.
                  END IF
C                                       Sort order swap ?
               IF ((ABS(LDAY-LDAY2).GT.1.2E-5) .OR. (LA1.NE.LB1) .OR.
     *            (LA2.NE.LB2)) THEN
C                                       Decode time.
                  XDAY = KBUFF(1+I1LOCT)
                  XDAY2 = KBUFF2(1+I2LOCT)
C                                       Determine antennas.
                  IF (I1LOCB.GE.0) THEN
                     IA1 = KBUFF(1+I1LOCB)/256. + 0.1
                     IA2 = KBUFF(1+I1LOCB) - IA1*256. + 0.1
                  ELSE
                     IA1 = KBUFF(1+I1LOA1) + 0.1
                     IA2 = KBUFF(1+I1LOA2) + 0.1
                     END IF
                  IF (I2LOCB.GE.0) THEN
                     IB1 = KBUFF2(1+I2LOCB)/256. + 0.1
                     IB2 = KBUFF2(1+I2LOCB) - IB1*256. + 0.1
                  ELSE
                     IB1 = KBUFF2(1+I2LOA1) + 0.1
                     IB2 = KBUFF2(1+I2LOA2) + 0.1
                     END IF
                  SRDOIT = (LA1.EQ.IB1) .AND. (LA2.EQ.IB2) .AND.
     *               (LB1.EQ.IA1) .AND. (LB2.EQ.IA2) .AND.
     *               (ABS(LDAY-XDAY2).LE.1.2E-5) .AND.
     *               (ABS(XDAY-LDAY2).LE.1.2E-5) .AND. (.NOT.DOLAST)
C                                       Yes: swap buffers
                  IF (SRDOIT) THEN
                     SRCONT = SRCONT + 1
                     LDAY2 = XDAY2
                     LB1 = IB1
                     LB2 = IB2
                     CALL RCOPY (LRECA, LBUFF2, KBUFF2)
                     CALL RCOPY (NRP2, BUFF2(IPINT2), LBUFF2)
                     IF (ISCMP2) THEN
                        CALL ZUVXPN (NCORR, BUFF2(IPINT2+NRP2),
     *                     BUFF2(IPINT2+LLOCWT), LBUFF2(DPTR))
                     ELSE
                        CALL RCOPY (LRECF, BUFF2(IPINT2+NRP2),
     *                     LBUFF2(DPTR))
                        END IF
C                                       No: error
                  ELSE
                     SDOIT = .TRUE.
                     END IF
                  END IF
C                                       Convert uvw to kilo lamda.
               U = LBUFF(1+I1LOCU) * 0.001
               V = LBUFF(1+I1LOCV) * 0.001
               W = LBUFF(1+I1LOCW) * 0.001
               U2 = LBUFF2(1+I2LOCU) * 0.001
               V2 = LBUFF2(1+I2LOCV) * 0.001
               W2 = LBUFF2(1+I2LOCW) * 0.001
               UVM = MAX (UVM, U)
               UVM = MAX (UVM, V)
               UVM = MAX (UVM, W)
               UVN = U
               UVN = MIN (UVN, V)
               UVN = MIN (UVN, W)
               UVM = MAX (UVM, -10.0*UVN)
               R = U * U + V * V
C                                       UV box and range
               IF (.NOT.SDOIT) THEN
                  IF ((R.LT.UVRANG(1)) .OR. (R.GT.UVRANG(2))) GO TO 170
                  IF (DOUVBX) THEN
                     IF ((ABS(U-U2).GT.APARM(3)) .OR. (ABS(V-V2).GT.
     *                  APARM(3)) .OR. (ABS(W-W2).GT.APARM(3)))
     *                  UDOIT = .TRUE.
                     END IF
                  END IF
C                                       Convert to VIS
               CALL GETVIS (MVIS, JADR, LBUFF(DPTR), VIS, IERR1)
               CALL GETVIS (MVIS, JADR, LBUFF2(DPTR), VIS2, IERR2)
               IF ((IERR1.NE.0) .AND. (IERR2.NE.0)) GO TO 170
               FDOIT = (IERR1.NE.IERR2) .AND. (APARM(4).GT.0.0)
C                                       Accumulate statistics
               DOIT = FDOIT .OR. UDOIT .OR. SDOIT
               IF (.NOT.DOIT) THEN
                  DO 115 KK = 1,MVIS
                     IF ((VIS(3,KK).GT.0.0) .OR. (VIS2(3,KK).GT.0.0)
     *                  .OR. (DOFLAG)) THEN
                        DIFMAX = MAX (DIFMAX, VIS(1,KK), VIS(2,KK))
                        DIFMAX = MAX (DIFMAX, VIS2(1,KK), VIS2(2,KK))
                        DIFMIN = MIN (DIFMIN, VIS(1,KK), VIS(2,KK))
                        DIFMIN = MIN (DIFMIN, VIS2(1,KK), VIS2(2,KK))
                        DIF = VIS2(1,KK) - VIS(1,KK)
                        DIFCNT = DIFCNT + 1
                        SUMDIF = SUMDIF + DIF
                        SUMDI2 = SUMDI2 + DIF*DIF
                        IF (ABS(DIF).GT.MAXDIF) THEN
                           MAXDIF = ABS (DIF)
                           VMXDIF = MAX (ABS(VIS2(1,KK)),
     *                        ABS(VIS(1,KK)))
                           END IF
                        DIF = VIS2(2,KK) - VIS(2,KK)
                        DIFCNT = DIFCNT + 1
                        SUMDIF = SUMDIF + DIF
                        SUMDI2 = SUMDI2 + DIF*DIF
                        IF (ABS(DIF).GT.MAXDIF) THEN
                           MAXDIF = ABS (DIF)
                           VMXDIF = MAX (ABS(VIS2(2,KK)),
     *                        ABS(VIS(2,KK)))
                           END IF
                        END IF
 115                 CONTINUE
                  END IF
               IF (.NOT.DOIT) GO TO 170
               IF (IAPCNT.GE.NITER) NOPRNT = .TRUE.
               IF ((NOPRNT) .AND. (DOCRT.GT.0.0)) GO TO 200
               IF (.NOT.NOPRNT) IAPCNT = IAPCNT + 1
               IF (FDOIT) FCOUNT = FCOUNT + 1
               IF (UDOIT) UCOUNT = UCOUNT + 1
               IF (SDOIT) SCOUNT = SCOUNT + 1
               IF (NOPRNT) GO TO 170
C                                       Get vis.
               DO 165 NB = 1,2
               K = 0
               YAMP = 0.0
               DO 140 KK = ICH1,ICH2
                  DO 139 KKK = 1,LCOR
                     K = K + 1
                     INDEX = 1 + (KK-1) * INCF + (KKK-1) * INCS +
     *                  (BIF-1) * INCIF + MAX (NRP1, NRP2)
                     IF (NB.EQ.1) THEN
                        XX = LBUFF(INDEX)
                        YY = LBUFF(INDEX+1)
                        TPHS = LBUFF(INDEX+2)
                     ELSE
                        XX = LBUFF2(INDEX)
                        YY = LBUFF2(INDEX+1)
                        TPHS = LBUFF2(INDEX+2)
                        END IF
                     TPHS = MAX (-99.0, MIN (99.0, TPHS*WTSC))
                     IWT(K) = IROUND (TPHS)
                     IF (LA1.EQ.LA2) THEN
                        AMP(K) = XX
                        TPHS = 0.0
                     ELSE
                        AMP(K) = SQRT(XX*XX+YY*YY)
                        TPHS = 57.296 * ATAN2 (YY, XX+1.0E-20)
                        END IF
                     PHASE(K) = IROUND (TPHS)
                     XAMP = MAX (XAMP, AMP(K))
                     YAMP = MIN (YAMP, AMP(K))
 139                 CONTINUE
 140              CONTINUE
               IF (NB.NE.1) THEN
                  LA1 = LB1
                  LA2 = LB2
                  U = U2
                  V = V2
                  W = W2
                  CALL TODHMS (LDAY2, ITT)
                  END IF
C                                       Write VIS data: CRT
               XAMP = MAX (XAMP, -10.0*YAMP)
C                                       low UVW
               IF (UVM.LE.9999.98) THEN
                  IF (OTYPE.EQ.1) THEN
                     WRITE (LINE,1140,ERR=160) XCOUNT, ITT, LA1, LA2, U,
     *                  V, W, (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                  ELSE
                     WRITE (LINE,1141,ERR=160) XCOUNT, ITT, LA1, LA2, U,
     *                  V, (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     END IF
C                                       High UVW
               ELSE
                  IF (OTYPE.EQ.1) THEN
                     WRITE (LINE,1146,ERR=160) XCOUNT, ITT, LA1, LA2, U,
     *                  V, W, (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                  ELSE
                     WRITE (LINE,1147,ERR=160) XCOUNT, ITT, LA1, LA2, U,
     *                  V, (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                     END IF
                  END IF
 160           CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2,
     *            LINE, IPCNT, PAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 900
 165           CONTINUE
               END IF
 170        IF (DOLAST) THEN
               GO TO 200
            ELSE
               CALL RCOPY (LRECA, KBUFF, LBUFF)
               CALL RCOPY (LRECA, KBUFF2, LBUFF2)
               END IF
 175        CONTINUE
         GO TO 100
C                                       Number lines printed
 200  IF (DOCRT.LE.0.0) THEN
         IF (DOCRT.GT.-2.5) THEN
            LINE = ' '
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         WRITE (LINE,1200) IAPCNT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      WRITE (MSGTXT,1200) IAPCNT
      IF (IAPCNT.GT.0) THEN
         CALL MSGWRT (5)
      ELSE
         CALL MSGWRT (3)
         END IF
      IF ((IAPCNT.LT.NITER) .OR. (NITER.EQ.NVIS)) GO TO 210
         IF (DOCRT.LE.0.0) THEN
            WRITE (LINE,1202)
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         IPCNT = IPCNT + 2
         WRITE (MSGTXT,1203)
         CALL MSGWRT (6)
 210  IPCNT = IPCNT + 2
      IF (DOCRT.LE.0.0) THEN
         WRITE (LINE,1210) FCOUNT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1211) UCOUNT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1212) SCOUNT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1213) SRCONT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      WRITE (MSGTXT,1210) FCOUNT
      IF (FCOUNT.GT.0) THEN
         CALL MSGWRT (5)
      ELSE
         CALL MSGWRT (3)
         END IF
      WRITE (MSGTXT,1211) UCOUNT
      IF (UCOUNT.GT.0) THEN
         CALL MSGWRT (5)
      ELSE
         CALL MSGWRT (3)
         END IF
      WRITE (MSGTXT,1212) SCOUNT
      IF (SCOUNT.GT.0) THEN
         CALL MSGWRT (5)
      ELSE
         CALL MSGWRT (3)
         END IF
      WRITE (MSGTXT,1213) SRCONT
      IF (SRCONT.GT.0) THEN
         CALL MSGWRT (5)
      ELSE
         CALL MSGWRT (3)
         END IF
C                                       Write statistics in header of
C                                       first input file
 900  IF (DIFCNT.LT.2) THEN
         DIFMAX = 1.0E12
         DIFMIN = 1.0E12
         DIFCNT = 2
         SUMDIF = 1.
         SUMDI2 = 2.
         END IF
      DIFMAX = MAX (ABS(DIFMAX), ABS(DIFMIN))
      SUMDIF = SUMDIF / DIFCNT
      SUMDI2 = SUMDI2 / DIFCNT
      RMS = SQRT (ABS (SUMDI2 - SUMDIF*SUMDIF) / (DIFCNT-1))
      RATMAX = MAXDIF / DIFMAX
      RATRMS = RMS / DIFMAX
      IF ((IERR.EQ.0) .AND. (DOCRT.LE.0.0)) THEN
         IF (DOCRT.GT.-2.5) THEN
            LINE = ' '
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         WRITE (LINE,1900) MAXDIF, RMS
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1901) RATMAX, RATRMS
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1902) DIFMAX, VMXDIF
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      WRITE (MSGTXT,1900) MAXDIF, RMS
      CALL MSGWRT (5)
      WRITE (MSGTXT,1901) RATMAX, RATRMS
      CALL MSGWRT (5)
      WRITE (MSGTXT,1902) DIFMAX, VMXDIF
      CALL MSGWRT (5)
      RATMAX = MAX (RATMAX, 1.57683E-30)
      RATRMS = MAX (RATRMS, 1.57683E-30)
      NUMKEY = 1
      LOCS = 1
      KEYTYP = 2
      KEYWRD = 'RATMAX  '
      CALL CATKEY ('WRIT', DISK, CNO, KEYWRD, NUMKEY, LOCS, RATMAX,
     *   KEYTYP,  LBUFF, JERR)
      KEYWRD = 'RATRMS  '
      CALL CATKEY ('WRIT', DISK, CNO, KEYWRD, NUMKEY, LOCS, RATRMS,
     *   KEYTYP,  LBUFF, JERR)
C                                       Close files.
      IF (IERR.LE.0) IRET = 0
      CALL LPCLOS (PLUN, PIND, IPCNT, IERR)
C
      CALL MAPCLS ('READ', DISK, CNO, LUN, FIND, CATBLK, F, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1910) IERR
         CALL MSGWRT (6)
         END IF
      CALL MAPCLS ('READ', DISK2, CNO2, LUN2, FIND2, CAT2I, F, BUFF,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1920) IERR
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('File',I1,' = ',A12,'.',A6,'.',I4,'   Vol =',I2,
     *   '    UserID =',I5,5X,'Channels =',I5,' to ',I5,' BIF=',I3)
 1021 FORMAT (I1,1X,A12,'.',A6,'.',I4,'  Vol=',I2,'  User=',I5,
     *   '  Chan=',I4,' to',I4,'  IF=',I3)
 1025 FORMAT ('Source= ',A8,3X,A4,' = ',A1,I2.2,I3.2,F6.2,3X,A4,' = ',
     *   A1,I2.2,I3.2,F5.1)
 1030 FORMAT ('Freq=',F13.9,' GHz   ncor=',I3,'   No. vis=',I10,
     *   '   Sort order= ',A2)
 1031 FORMAT ('Weights have been multiplied by',1PE10.2)
 1040 FORMAT ('Source= ',A8,4X,'Freq= ',F13.9,4X,'Sort= ',A2,10X,
     *   4(5X,I4,1X,A2,4X))
 1041 FORMAT (A,4X,'Freq=',F13.9,4X,'Sort= ',A2,7X,2(4X,I4,1X,A2,4X))
 1050 FORMAT ('  Vis #',5X,'IAT',6X,'Ant      U(Klam)     V(Klam)',
     *   '     W(Klam)',4(4X,A))
 1051 FORMAT ('  Vis #',5X,'IAT',6X,'Ant      U(Klam)     V(Klam)',
     *   2(3X,A))
 1060 FORMAT ('ERROR:',I7,' INITIALIZING 1ST UV FILE')
 1065 FORMAT ('ERROR:',I7,' INITIALIZING 2ND UV FILE')
 1075 FORMAT ('REQUESTED STOKES TYPE NOT AVAILABLE IN DATA SET')
 1100 FORMAT ('ERROR:',I7,' READING 1ST UV FILE VIS BLOCK ',I9)
 1105 FORMAT ('ERROR:',I7,' READING 2ND UV FILE VIS BLOCK ',I9)
 1140 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,3F12.5,4(F9.3,I4,I3))
 1141 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F12.5,2(F8.3,I4,I3))
 1146 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,3F12.3,4(F9.3,I4,I3))
 1147 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F12.3,2(F8.3,I4,I3))
 1200 FORMAT (I5,' Points printed')
 1202 FORMAT ('0********** PRINT LIMIT REACHED: MORE POINTS MAY EXIST',
     *   ' **********')
 1203 FORMAT ('WARNING: PRINT LIMIT REACHED, NOT ALL POINTS LISTED')
 1210 FORMAT (I8,' Points found for flux differences')
 1211 FORMAT (I8,' Points found for u,v,w differences')
 1212 FORMAT (I8,' Points found for other differences')
 1213 FORMAT (I8,' Points swapped for apparent sort order reversal')
 1900 FORMAT ('Visibilty Max diff      =',1PE11.3,'  RMS      =',E11.3)
 1901 FORMAT ('Visibilty Max diff/peak =',1PE11.3,'  RMS/peak =',E11.3)
 1902 FORMAT ('Visibility peak',1PE11.3,'  Visibility at max diff',
     *   E11.3)
 1910 FORMAT ('ERROR:',I7,' CLOSING 1ST UV FILE ')
 1920 FORMAT ('ERROR:',I7,' CLOSING 2ND UV FILE ')
      END
      SUBROUTINE FNDUCL (IRET)
C-----------------------------------------------------------------------
C   FNDUPR reads the UV files and prints those samples meeting the
C   criteria given by OPCODE and APARM.
C   Output:
C      IRET   I   Return code: 0 success or user requests end, else bad
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'UVDIF.INC'
      CHARACTER  CHS1*1, CHS2*1, ISTOKE(6)*2, JSTOKE(4,2)*2, TCHAR*20,
     *   LLCH*4, MMCH*4, KEYWRD*8
      LOGICAL   F, DOIT, EQUAL, FDOIT, SDOIT, NOPRNT, DOLAST, SRDOIT
      INTEGER   ICH(4), JADR(8), BIND, CINC, ITYPE(8), BUFSZ, HM(2),
     *   DD(2), J, ITT(4), LENBU, IWT(6), IPHASE(8), INDEX, MVIS,
     *   IROUND, I, L, IA1, IA2, ICH1, ICH2, IERR, JERR, II, JJ, KK,
     *   KKK, IPINT, JCOR, LIMIT2, NIO, NNCH, NUMCH, K, LRECF, NUMCHM,
     *   OTYPE, BIND2, NIO2, IPINT2, NB, IB1, IB2, IERR2, BO, VO,
     *   XCOUNT, COUNT, IAPCNT, FCOUNT, SCOUNT, NCORR, DIFCNT, LRECA,
     *   NUMKEY, LOCS, KEYTYP, DPTR, LA1, LA2, LB1, LB2, IERR1, SRCONT
      REAL   RSEC, DSEC, AMP(8), VIS(3,8), TEMP, TPHS, R, RADEG, U, V,
     *   W, XX, YY, YAMP, UVN, RMS, WTSC, U2, V2, W2, VIS2(3,8),
     *   XDAY, XDAY2, DIFMAX, RATMAX, RATRMS, DIFMIN, LDAY, LDAY2,
     *   PHASE(8)
      DOUBLE PRECISION DIF, SUMDIF, SUMDI2, MAXDIF
      INCLUDE 'BUFFS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PUVD.INC'
      DATA F /.FALSE./
      DATA JSTOKE /'RR','LL','RL','LR', 'I ','Q ','U ','V '/
      DATA LENBU, BO, VO /16, 1, 0/
C-----------------------------------------------------------------------
      IRET = 8
      RADEG = 180.0 / 3.14159
      CINC = 2
      FCOUNT = 0
      SCOUNT = 0
      SRCONT = 0
      NOPRNT = .FALSE.
C                                       Set up for compressed data.
      NCORR = (LREC - NRPARM) / CATBLK(KINAX)
      LRECF = 3 * NCORR
      DPTR = 1 + MAX (NRP1, NRP2)
      LRECA = LRECF + DPTR - 1
      CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), KLOCWT,
     *   JERR)
      IF (ISCMP1 .AND. ((JERR.NE.0) .OR. (KLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL AXEFND (8, 'WEIGHT  ', CAT2I(KIPCN), CAT2H(KHPTP), LLOCWT,
     *   JERR)
      IF (ISCMP2 .AND. ((JERR.NE.0) .OR. (LLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Initialize difference statistics
      DIFCNT = 0
      SUMDIF = 0.0D0
      SUMDI2 = 0.0D0
      DIFMAX = -1.0E10
      DIFMIN = 1.0E10
      MAXDIF = -1.0E10
C                                        Determine no. channels to do
      FREQ = FREQ - (CATR(KRCRP+JLOCF)-NCH) * CATR(KRCIC+JLOCF)
      NUMCHM = CATBLK(KINAX+JLOCF) - NCH + 1
      NUMCH = (NACROS - 25) / (19 * NCOR)
      NUMCH = MIN (NUMCH, NUMCHM)
      OTYPE = 1
      IF (NUMCH.LT.1) THEN
         NUMCH = 1
         OTYPE = 2
         IF (NACROS.LT.84) OTYPE = 3
         END IF
      LIMIT2 = NCOR * NUMCH
      ICH1 = NCH
      ICH2 = NCH + NUMCH - 1
      NNCH = NCH - 1
      CALL FILL (8, 3, ITYPE)
      DO 10 II = 1,LIMIT2,NCOR
         NNCH = NNCH + 1
         DO 9 JJ = 1,NCOR
            INDEX = II + JJ - 1
            ICH(INDEX) = NNCH
            TEMP = CATD(KDCRV+JLOCS) + (JJ-CATR(KRCRP+JLOCS)) *
     *         CATR(KRCIC+JLOCS)
            I = IROUND(TEMP)
            L = 2
            IF (I.LT.0) L = 1
            I = ABS(I)
            ISTOKE(INDEX) = JSTOKE(I,L)
            ITYPE(INDEX) = 2
            IF (I+L.LE.3) ITYPE(INDEX) = 1
 9          CONTINUE
 10      CONTINUE
C                                       range parameters
      IF (XWT.LE.0.0) THEN
         XWT = 1.0
         NWT = 1.0
         END IF
      TEMP = LOG10 (XWT/0.995)
      I = TEMP + 99.0
      I =  100 - I
      IF (OTYPE.EQ.1) I = I + 1
      WTSC = 10.0 ** I
      TEMP = NWT * WTSC
      IF (TEMP.LT.1.0) THEN
         MSGTXT = 'Full dynamic range of weights cannot be printed'
         CALL MSGWRT (6)
         END IF
C                                       Convert coordinates.
      CALL H2CHR (4, 1, CATH(KHCTP+JLOCR*CINC), LLCH)
      CALL H2CHR (4, 1, CATH(KHCTP+JLOCD*CINC), MMCH)
      EQUAL = LLCH(1:2).EQ.'RA'
      IF (EQUAL) THEN
         CALL COORDD (1, RA, CHS1, HM, RSEC)
      ELSE
         CALL COORDD (2, RA, CHS1, HM, RSEC)
         END IF
      CALL COORDD (2, DEC, CHS2, DD, DSEC)
      FREQ = FREQ * 1.0E-9
C                                       Make sure NITER is OK
      IF (NITER.GT.NVIS) NITER = NVIS
C                                       Write header
      IF (DOCRT.GT.-2.5) THEN
         LINE = ' '
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       source names
         IF (NACROS.GE.90) THEN
            WRITE (LINE,1020) 1, NAME, CLASS, SEQ, DISK, USERID, ICH1,
     *         ICH2, BIF
         ELSE
            WRITE (LINE,1021) 1, NAME, CLASS, SEQ, DISK, USERID, ICH1,
     *         ICH2, BIF
            END IF
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         IF (NACROS.GE.90) THEN
            WRITE (LINE,1020) 2, NAME2, CLASS2, SEQ2, DISK2, USERID,
     *         ICH1, ICH2, BIF
         ELSE
            WRITE (LINE,1021) 2, NAME2, CLASS2, SEQ2, DISK2, USERID,
     *         ICH1, ICH2, BIF
            END IF
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1025) SOURCE, LLCH, CHS1, HM, RSEC, MMCH, CHS2, DD,
     *      DSEC
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1030) FREQ, NCOR, NVIS, ISORT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         IF (WTSC.NE.1.0) THEN
            WRITE (LINE,1031) WTSC
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         END IF
C                                       Page titles
      IF (OTYPE.EQ.1) WRITE (TITL1,1040) SOURCE, FREQ, ISORT,
     *   (ICH(JCOR), ISTOKE(JCOR), JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.2) WRITE (TITL1,1041) SOURCE, FREQ, ISORT,
     *   (ICH(JCOR), ISTOKE(JCOR), JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.3) WRITE (TITL1,1042) SOURCE, FREQ,
     *   (ICH(JCOR), ISTOKE(JCOR), JCOR = 1,LIMIT2)
      IF (OTYPE.EQ.1) THEN
         TCHAR = '   Amp    Phase  Wt'
         WRITE (TITL2,1050) (TCHAR, JCOR = 1,LIMIT2)
      ELSE IF (OTYPE.EQ.2) THEN
         TCHAR = '  Amp   Phas Wt'
         WRITE (TITL2,1051) (TCHAR, JCOR = 1,LIMIT2)
      ELSE
         TCHAR = '  Amp  Phas Wt'
         WRITE (TITL2,1052) (TCHAR, JCOR = 1,LIMIT2)
         END IF
      IF (DOCRT.GT.-2.5) THEN
         LINE = ' '
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, TITL1,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, TITL2,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
      IF (DOCRT.GT.-2.5) THEN
         LINE = ' '
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
C                                       Initialize reading VIS. file.
      LENBU = 0
      BUFSZ = UVBFSS * 2
      CALL UVINIT ('READ', LUN, FIND, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFF, BO, BIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         CALL MSGWRT (8)
         GO TO 900
         END IF
      CALL UVINIT ('READ', LUN2, FIND2, NVIS, VO, LREC2, LENBU, BUFSZ,
     *   BUFF2, BO, BIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1065) IERR
         CALL MSGWRT (8)
         GO TO 900
         END IF
      COUNT = 0
      XCOUNT = -1
      PAGE = 1
      IAPCNT = 0
C                                       Try to handle line
      CALL SETVIS (ICH1, NUMCH, BIF, MVIS, JADR, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1075)
         CALL MSGWRT (8)
         GO TO 900
         END IF
C                                       Start looping thru data.
 100  CONTINUE
C                                       Read buffer.
         COUNT = COUNT + 1
         CALL UVDISK ('READ', LUN, FIND, BUFF, NIO, BIND, IERR)
         IF (IERR.EQ.0) GO TO 105
            WRITE (MSGTXT,1100) IERR, COUNT
            CALL MSGWRT (8)
            GO TO 900
 105     CALL UVDISK ('READ', LUN2, FIND2, BUFF2, NIO2, BIND2, IERR)
         IF (IERR.EQ.0) GO TO 110
            WRITE (MSGTXT,1105) IERR, COUNT
            CALL MSGWRT (8)
            GO TO 900
 110     DOLAST = (NIO.LE.0) .OR. (NIO2.LE.0)
         IPINT = BIND - LREC
         IPINT2 = BIND2 - LREC2
         NIO = MAX (1, NIO)
C                                       Loop thru buffer.
         DO 175 J = 1,NIO
C                                       Update counters
            XCOUNT = XCOUNT + 1
            IPINT = IPINT + LREC
            IPINT2 = IPINT2 + LREC2
C                                       CONVERT
            IF (.NOT.DOLAST) THEN
C                                       Compressed?
               CALL RCOPY (NRP1, BUFF(IPINT), KBUFF)
               IF (ISCMP1) THEN
                  CALL ZUVXPN (NCORR, BUFF(IPINT+NRP1),
     *               BUFF(IPINT+KLOCWT), KBUFF(DPTR))
               ELSE
                  CALL RCOPY (LRECF, BUFF(IPINT+NRP1), KBUFF(DPTR))
                  END IF
               CALL RCOPY (NRP2, BUFF2(IPINT2), KBUFF2)
               IF (ISCMP2) THEN
                  CALL ZUVXPN (NCORR, BUFF2(IPINT2+NRP2),
     *               BUFF2(IPINT2+LLOCWT), KBUFF2(DPTR))
               ELSE
                  CALL RCOPY (LRECF, BUFF2(IPINT2+NRP2), KBUFF2(DPTR))
                  END IF
               END IF
C                                       TEST
            IF (XCOUNT.GT.0) THEN
               SRDOIT = .FALSE.
               SDOIT = .FALSE.
               FDOIT = .FALSE.
C                                       Decode time.
               LDAY = LBUFF(1+I1LOCT)
               LDAY2 = LBUFF2(1+I2LOCT)
               IF ((LDAY.LT.0.0) .OR. (LDAY.GT.1000.)) SDOIT = .TRUE.
               IF ((LDAY2.LT.0.0) .OR. (LDAY2.GT.1000.)) SDOIT = .TRUE.
               CALL TODHMS (LDAY, ITT)
C                                       Determine antennas.
               IF (I1LOCB.GE.0) THEN
                  LA1 = LBUFF(1+I1LOCB)/256. + 0.1
                  LA2 = LBUFF(1+I1LOCB) - LA1*256. + 0.1
               ELSE
                  LA1 = LBUFF(1+I1LOA1) + 0.1
                  LA2 = LBUFF(1+I1LOA2) + 0.1
                  END IF
               IF (LA1.EQ.LA2) THEN
                  IF (.NOT.DOACOR) GO TO 170
               ELSE
                  IF (.NOT.DOXCOR) GO TO 170
                  END IF
               IF (I2LOCB.GE.0) THEN
                  LB1 = LBUFF2(1+I2LOCB)/256. + 0.1
                  LB2 = LBUFF2(1+I2LOCB) - LB1*256. + 0.1
               ELSE
                  LB1 = LBUFF2(1+I2LOA1) + 0.1
                  LB2 = LBUFF2(1+I2LOA2) + 0.1
                  END IF
               IF (TYPUVD.LE.0) THEN
                  IF ((LA1.LE.0) .OR. (LA1.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LA2.LE.0) .OR. (LA2.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LB1.LE.0) .OR. (LB1.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LB2.LE.0) .OR. (LB2.GT.MAXANT)) SDOIT = .TRUE.
                  END IF
C                                       Sort order swap ?
               IF ((ABS(LDAY-LDAY2).GT.1.2E-5) .OR. (LA1.NE.LB1) .OR.
     *            (LA2.NE.LB2)) THEN
C                                       Decode time.
                  XDAY = KBUFF(1+I1LOCT)
                  XDAY2 = KBUFF2(1+I2LOCT)
C                                       Determine antennas.
                  IF (I1LOCB.GE.0) THEN
                     IA1 = KBUFF(1+I1LOCB)/256. + 0.1
                     IA2 = KBUFF(1+I1LOCB) - IA1*256. + 0.1
                  ELSE
                     IA1 = KBUFF(1+I1LOA1) + 0.1
                     IA2 = KBUFF(1+I1LOA2) + 0.1
                     END IF
                  IF (I2LOCB.GE.0) THEN
                     IB1 = KBUFF2(1+I2LOCB)/256. + 0.1
                     IB2 = KBUFF2(1+I2LOCB) - IB1*256. + 0.1
                  ELSE
                     IB1 = KBUFF2(1+I2LOA1) + 0.1
                     IB2 = KBUFF2(1+I2LOA2) + 0.1
                     END IF
                  SRDOIT = (LA1.EQ.IB1) .AND. (LA2.EQ.IB2) .AND.
     *               (LB1.EQ.IA1) .AND. (LB2.EQ.IA2) .AND.
     *               (ABS(LDAY-XDAY2).LE.1.2E-5) .AND.
     *               (ABS(XDAY-LDAY2).LE.1.2E-5) .AND. (.NOT.DOLAST)
C                                       Yes: swap buffers
                  IF (SRDOIT) THEN
                     SRCONT = SRCONT + 1
                     LDAY2 = XDAY2
                     LB1 = IB1
                     LB2 = IB2
                     CALL RCOPY (LRECA, LBUFF2, KBUFF2)
                     IF (ISCMP2) THEN
                        CALL RCOPY (NRP2, BUFF2(IPINT2), LBUFF2)
                        CALL ZUVXPN (NCORR, BUFF2(IPINT2+NRP2),
     *                     BUFF2(IPINT2+LLOCWT), LBUFF2(DPTR))
                     ELSE
                        CALL RCOPY (LRECF, BUFF2(IPINT2+NRP2),
     *                     LBUFF2(DPTR))
                        END IF
C                                       No: error
                  ELSE
                     SDOIT = .TRUE.
                     END IF
                  END IF
C                                       Convert uvw to kilo lamda.
               U = LBUFF(1+I1LOCU) * 0.001
               V = LBUFF(1+I1LOCV) * 0.001
               W = LBUFF(1+I1LOCW) * 0.001
               U2 = LBUFF2(1+I2LOCU) * 0.001
               V2 = LBUFF2(1+I2LOCV) * 0.001
               W2 = LBUFF2(1+I2LOCW) * 0.001
               UVM = MAX (UVM, U)
               UVM = MAX (UVM, V)
               UVM = MAX (UVM, W)
               UVN = U
               UVN = MIN (UVN, V)
               UVN = MIN (UVN, W)
               UVM = MAX (UVM, -10.0*UVN)
               R = U * U + V * V
C                                       UV box and range
               IF (.NOT.SDOIT) THEN
                  IF ((R.LT.UVRANG(1)) .OR. (R.GT.UVRANG(2))) GO TO 170
                  END IF
C                                       Convert to VIS
               CALL GETVIS (MVIS, JADR, LBUFF(DPTR), VIS, IERR1)
               CALL GETVIS (MVIS, JADR, LBUFF2(DPTR), VIS2, IERR2)
               IF ((IERR1.NE.0) .AND. (IERR2.NE.0)) GO TO 170
               FDOIT = (IERR1.NE.IERR2) .AND. (APARM(4).GT.0.0)
C                                       Accumulate statistics
               DOIT = FDOIT .OR. SDOIT
               IF (.NOT.DOIT) THEN
                  DO 115 KK = 1,MVIS
                     IF ((VIS(3,KK).GT.0.0) .OR. (VIS2(3,KK).GT.0.0)
     *                  .OR. (DOFLAG)) THEN
                        DIFMAX = MAX (DIFMAX, VIS(1,KK), VIS(2,KK))
                        DIFMAX = MAX (DIFMAX, VIS2(1,KK), VIS2(2,KK))
                        DIFMIN = MIN (DIFMIN, VIS(1,KK), VIS(2,KK))
                        DIFMIN = MIN (DIFMIN, VIS2(1,KK), VIS2(2,KK))
                        DIF = VIS2(1,KK) - VIS(1,KK)
                        DIFCNT = DIFCNT + 1
                        SUMDIF = SUMDIF + DIF
                        SUMDI2 = SUMDI2 + DIF*DIF
                        MAXDIF = MAX (MAXDIF, ABS (DIF))
                        DIF = VIS2(2,KK) - VIS(2,KK)
                        DIFCNT = DIFCNT + 1
                        SUMDIF = SUMDIF + DIF
                        SUMDI2 = SUMDI2 + DIF*DIF
                        MAXDIF = MAX (MAXDIF, ABS (DIF))
                        END IF
 115                 CONTINUE
                  END IF
C                                       Do we want this one
               IF ((.NOT.DOIT) .AND. (DOMAX)) THEN
                  DO 130 K = 1,MVIS
                     IF ((ITYPE(K).LE.2) .AND. ((VIS(3,K).GT.0.0) .OR.
     *                  (VIS2(3,K).GT.0.0) .OR. (DOFLAG))) THEN
                        IF (ABS(VIS(1,K)-VIS2(1,K)).GT.APARM(ITYPE(K)))
     *                     FDOIT = .TRUE.
                        IF (ABS(VIS(2,K)-VIS2(2,K)).GT.APARM(ITYPE(K)))
     *                     FDOIT = .TRUE.
                        IF (APARM(4).GT.0.0) THEN
                           IF (ABS(VIS(3,K)-VIS2(3,K)).GT.APARM(4))
     *                        FDOIT = .TRUE.
                           IF ((VIS(3,K).LE.0.0).AND.(VIS2(3,K).GT.0.0))
     *                        FDOIT = .TRUE.
                           IF ((VIS(3,K).GT.0.0).AND.(VIS2(3,K).LE.0.0))
     *                        FDOIT = .TRUE.
                        ELSE
                           IF (ABS(ABS(VIS(3,K))-ABS(VIS2(3,K))).GT.
     *                        -APARM(4)) FDOIT = .TRUE.
                           END IF
                        END IF
 130                 CONTINUE
                  DOIT = FDOIT
                  END IF
               IF (.NOT.DOIT) GO TO 170
               IF (IAPCNT.GE.NITER) NOPRNT = .TRUE.
               IF ((NOPRNT) .AND. (DOCRT.GT.0.0)) GO TO 200
               IF (.NOT.NOPRNT) IAPCNT = IAPCNT + 1
               IF (FDOIT) FCOUNT = FCOUNT + 1
               IF (SDOIT) SCOUNT = SCOUNT + 1
               IF (NOPRNT) GO TO 170
C                                       Get vis.
               DO 165 NB = 1,2
               K = 0
               YAMP = 0.0
               DO 140 KK = ICH1,ICH2
                  DO 139 KKK = 1,NCOR
                     K = K + 1
                     INDEX = 1 + (KK-1) * INCF + (KKK-1) * INCS +
     *                  (BIF-1) * INCIF + MAX (NRP1, NRP2)
                     IF (NB.EQ.1) THEN
                        XX = LBUFF(INDEX)
                        YY = LBUFF(INDEX+1)
                        TPHS = LBUFF(INDEX+2)
                     ELSE
                        XX = LBUFF2(INDEX)
                        YY = LBUFF2(INDEX+1)
                        TPHS = LBUFF2(INDEX+2)
                        END IF
                     IF (OTYPE.EQ.1) THEN
                        TPHS = MAX (-999.0, MIN (999.0, TPHS*WTSC))
                     ELSE
                        TPHS = MAX (-99.0, MIN (99.0, TPHS*WTSC))
                        END IF
                     IWT(K) = IROUND (TPHS)
                     IF (LA1.EQ.LA2) THEN
                        AMP(K) = XX
                        TPHS = 0.0
                     ELSE
                        AMP(K) = SQRT(XX*XX+YY*YY)
                        TPHS = 57.296 * ATAN2 (YY, XX+1.0E-20)
                        END IF
                     PHASE(K) = TPHS
                     IPHASE(K) = IROUND (TPHS)
                     XAMP = MAX (XAMP, AMP(K))
                     YAMP = MIN (YAMP, AMP(K))
 139                 CONTINUE
 140              CONTINUE
               IF (NB.NE.1) THEN
                  LA1 = LB1
                  LA2 = LB2
                  U = U2
                  V = V2
                  W = W2
                  CALL TODHMS (LDAY2, ITT)
                  END IF
C                                       Write VIS data: CRT
               XAMP = MAX (XAMP, -10.0*YAMP)
C                                       low flux
               IF ((XAMP.LE.99.9) .OR. ((OTYPE.EQ.1) .AND.
     *            (XAMP.LE.999.9))) THEN
                  IF (OTYPE.EQ.1) WRITE (LINE,1140,ERR=160) XCOUNT, ITT,
     *               LA1, LA2, (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                  IF (OTYPE.EQ.2) WRITE (LINE,1141,ERR=160) XCOUNT, ITT,
     *               LA1, LA2, (AMP(K), IPHASE(K), IWT(K), K = 1,LIMIT2)
                  IF (OTYPE.EQ.3) WRITE (LINE,1152,ERR=160) XCOUNT,
     *               ITT(2), ITT(3), ITT(4), LA1, LA2,
     *              (AMP(K), IPHASE(K), IWT(K), K = 1,LIMIT2)
               ELSE
                  IF (OTYPE.EQ.1) WRITE (LINE,1150,ERR=160) XCOUNT, ITT,
     *               LA1, LA2, (AMP(K), PHASE(K), IWT(K), K = 1,LIMIT2)
                  IF (OTYPE.EQ.2) WRITE (LINE,1151,ERR=160) XCOUNT, ITT,
     *               LA1, LA2, (AMP(K), IPHASE(K), IWT(K), K = 1,LIMIT2)
                  IF (OTYPE.EQ.3) WRITE (LINE,1152,ERR=160) XCOUNT,
     *               ITT(2), ITT(3), ITT(4), LA1, LA2,
     *              (AMP(K), IPHASE(K), IWT(K), K = 1,LIMIT2)
                  END IF
 160           CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2,
     *            LINE, IPCNT, PAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 900
 165           CONTINUE
               END IF
 170        IF (DOLAST) THEN
               GO TO 200
            ELSE
               CALL RCOPY (LRECA, KBUFF, LBUFF)
               CALL RCOPY (LRECA, KBUFF2, LBUFF2)
               END IF
 175        CONTINUE
         GO TO 100
C                                       Number lines printed
 200  IF (DOCRT.LE.0.0) THEN
         IF (DOCRT.GT.-2.5) THEN
            LINE = ' '
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         WRITE (LINE,1200) IAPCNT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      WRITE (MSGTXT,1200) IAPCNT
      IF (IAPCNT.GT.0) THEN
         CALL MSGWRT (5)
      ELSE
         CALL MSGWRT (3)
         END IF
      IF ((IAPCNT.LT.NITER) .OR. (NITER.EQ.NVIS)) GO TO 210
         IF (DOCRT.LE.0.0) THEN
            WRITE (LINE,1202)
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         IPCNT = IPCNT + 2
         WRITE (MSGTXT,1203)
         CALL MSGWRT (6)
 210  IPCNT = IPCNT + 2
      IF (DOCRT.LE.0.0) THEN
         WRITE (LINE,1210) FCOUNT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1212) SCOUNT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1213) SRCONT
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      WRITE (MSGTXT,1210) FCOUNT
      IF (FCOUNT.GT.0) THEN
         CALL MSGWRT (5)
      ELSE
         CALL MSGWRT (3)
         END IF
      WRITE (MSGTXT,1212) SCOUNT
      IF (SCOUNT.GT.0) THEN
         CALL MSGWRT (5)
      ELSE
         CALL MSGWRT (3)
         END IF
      WRITE (MSGTXT,1213) SRCONT
      IF (SRCONT.GT.0) THEN
         CALL MSGWRT (5)
      ELSE
         CALL MSGWRT (3)
         END IF
C                                       Write statistics in header of
C                                       first input file
 900  IF (DIFCNT.LT.2) THEN
         MSGTXT = 'NO POINTS EVEN CHECKED FOR DIFFERENCES IN FLUX'
         CALL MSGWRT (7)
         DIFMAX = 1.0E12
         DIFMIN = 1.0E12
         DIFCNT = 2
         SUMDIF = 1.
         SUMDI2 = 2.
         END IF
      DIFMAX = MAX (ABS(DIFMAX), ABS(DIFMIN))
      SUMDIF = SUMDIF / DIFCNT
      SUMDI2 = SUMDI2 / DIFCNT
      RMS = SQRT (ABS (SUMDI2 - SUMDIF*SUMDIF) / (DIFCNT-1))
      RATMAX = MAXDIF / DIFMAX
      RATRMS = RMS / DIFMAX
      IF ((IERR.EQ.0) .AND. (DOCRT.LE.0.0)) THEN
         IF (DOCRT.GT.-2.5) THEN
            LINE = ' '
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         WRITE (LINE,1900) RATMAX, RATRMS
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      WRITE (MSGTXT,1900) RATMAX, RATRMS
      CALL MSGWRT (5)
      RATMAX = MAX (RATMAX, 1.57683E-30)
      RATRMS = MAX (RATRMS, 1.57683E-30)
      NUMKEY = 1
      LOCS = 1
      KEYTYP = 2
      KEYWRD = 'RATMAX  '
      CALL CATKEY ('WRIT', DISK, CNO, KEYWRD, NUMKEY, LOCS, RATMAX,
     *   KEYTYP,  LBUFF, JERR)
      KEYWRD = 'RATRMS  '
      CALL CATKEY ('WRIT', DISK, CNO, KEYWRD, NUMKEY, LOCS, RATRMS,
     *   KEYTYP,  LBUFF, JERR)
C                                       Close files.

      IF (IERR.LE.0) IRET = 0
      CALL LPCLOS (PLUN, PIND, IPCNT, IERR)
C
      CALL MAPCLS ('READ', DISK, CNO, LUN, FIND, CATBLK, F, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1910) IERR
         CALL MSGWRT (6)
         END IF
      CALL MAPCLS ('READ', DISK2, CNO2, LUN2, FIND2, CAT2I, F, BUFF,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1920) IERR
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('File',I1,' = ',A12,'.',A6,'.',I4,'   Vol =',I2,
     *   '    UserID =',I5,5X,'Channels =',I5,' to ',I5,' BIF=',I3)
 1021 FORMAT (I1,1X,A12,'.',A6,'.',I4,'  Vol=',I2,'  User=',I5,
     *   '  Chan=',I4,' to',I4,'  IF=',I3)
 1025 FORMAT ('Source= ',A8,3X,A4,' = ',A1,I2.2,I3.2,F6.2,3X,A4,' = ',
     *   A1,I2.2,I3.2,F5.1)
 1030 FORMAT ('Freq=',F13.9,' GHz   ncor=',I3,'   No. vis=',I10,
     *   '   Sort order= ',A2)
 1031 FORMAT ('Weights have been multiplied by',1PE10.2)
 1040 FORMAT (A8,F13.9,1X,A2,1X,5(6X,I4,1X,A2,6X))
 1041 FORMAT (A8,F13.9,1X,A2,4(4X,I4,1X,A2,4X))
 1042 FORMAT (A8,F13.9,4(4X,I4,1X,A2,3X))
 1050 FORMAT ('  Vis #',5X,'IAT',6X,'Ant ',5A19)
 1051 FORMAT ('  Vis #',5X,'IAT',6X,'Ant ',4A15)
 1052 FORMAT ('  Vis #',4X,'IAT',4X,'Ant ',4A14)
 1060 FORMAT ('ERROR:',I7,' INITIALIZING 1ST UV FILE')
 1065 FORMAT ('ERROR:',I7,' INITIALIZING 2ND UV FILE')
 1075 FORMAT ('REQUESTED STOKES TYPE NOT AVAILABLE IN DATA SET')
 1100 FORMAT ('ERROR:',I7,' READING 1ST UV FILE VIS BLOCK ',I9)
 1105 FORMAT ('ERROR:',I7,' READING 2ND UV FILE VIS BLOCK ',I9)
 1140 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,5(F9.4,F6.1,I4))
 1141 FORMAT (I6,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,4(F8.4,I4,I3))
 1150 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,5(F9.3,F6.1,I4))
 1151 FORMAT (I6,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,4(F8.2,I4,I3))
 1152 FORMAT (I6,I3,'/',I2.2,':',I2.2,I3,'-',I2,4(F7.1,I4,I3))
 1200 FORMAT (I5,' Points printed')
 1202 FORMAT ('0********** PRINT LIMIT REACHED: MORE POINTS MAY EXIST',
     *   ' **********')
 1203 FORMAT ('WARNING: PRINT LIMIT REACHED, NOT ALL POINTS LISTED')
 1210 FORMAT (I8,' Points found for flux differences')
 1212 FORMAT (I8,' Points found for other differences')
 1213 FORMAT (I8,' Points swapped for apparent sort order reversal')
 1900 FORMAT ('Visibilty Max diff/peak =',1PE11.3,'  RMS/peak =',E11.3)
 1910 FORMAT ('ERROR:',I7,' CLOSING 1ST UV FILE ')
 1920 FORMAT ('ERROR:',I7,' CLOSING 2ND UV FILE ')
      END
      SUBROUTINE CHKUBX (NCOUNT, IRET)
C-----------------------------------------------------------------------
C   FNDUBX reads the UV files and counts print lines showing
C   differences in u,v,w.
C   Output:
C      NCOUNT   I   Count of lines
C      IRET     I   Return 0 success or user requests end, else bad
C-----------------------------------------------------------------------
      INTEGER   NCOUNT, IRET
C
      INCLUDE 'UVDIF.INC'
      LOGICAL   F, DOIT, FDOIT, UDOIT, SDOIT, NOPRNT, DOLAST, SRDOIT
      INTEGER   JADR(8), BIND, CINC, BUFSZ, J, ITT(4), LENBU, MVIS, I,
     *   IA1, IA2, ICH1, IERR, JERR, IPINT, NIO, NUMCH, LRECF, NUMCHM,
     *   LCOR, BIND2, NIO2, IPINT2, IB1, IB2, IERR2, BO, VO, XCOUNT,
     *   COUNT, IAPCNT, NCORR, LRECA, DPTR, LA1, LA2, LB1, LB2, IERR1,
     *   SRCONT
      REAL   VIS(3,8), TEMP, R, U, V, W, WTSC, U2, V2, W2, VIS2(3,8),
     *   XDAY, XDAY2, LDAY, LDAY2
      INCLUDE 'BUFFS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PUVD.INC'
      DATA F /.FALSE./
      DATA LENBU, BO, VO /16, 1, 0/
C-----------------------------------------------------------------------
      IRET = 8
      CINC = 2
      SRCONT = 0
      NOPRNT = .FALSE.
C                                       range parameters
      IF (XWT.LE.0.0) THEN
         XWT = 1.0
         NWT = 1.0
         END IF
      TEMP = LOG10 (XWT/0.995)
      I = TEMP + 99.0
      I =  100 - I
      WTSC = 10.0 ** I
      TEMP = NWT * WTSC
C                                       Set up for compressed data.
      NCORR = (LREC - NRPARM) / CATBLK(KINAX)
      LRECF = 3 * NCORR
      DPTR = 1 + MAX (NRP1, NRP2)
      LRECA = LRECF + DPTR - 1
      CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), KLOCWT,
     *   JERR)
      IF (ISCMP1 .AND. ((JERR.NE.0) .OR. (KLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL AXEFND (8, 'WEIGHT  ', CAT2I(KIPCN), CAT2H(KHPTP), LLOCWT,
     *   JERR)
      IF (ISCMP2 .AND. ((JERR.NE.0) .OR. (LLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                        Determine no. channels to do
      NUMCHM = CATBLK(KINAX+JLOCF) - NCH + 1
      LCOR = MIN (2, NCOR)
      NUMCH = (NACROS - 61) / (16 * LCOR)
      NUMCH = MAX (1, MIN (NUMCH, NUMCHM))
      ICH1 = NCH
C                                       Make sure NITER is OK
      IF (NITER.GT.NVIS) NITER = NVIS
C                                       Write header
      IF (DOCRT.GT.-2.5) THEN
         NCOUNT = NCOUNT + 5
         IF (WTSC.NE.1.0) NCOUNT = NCOUNT + 1
         END IF
C                                       Page titles
      IF (DOCRT.GT.-2.5) NCOUNT = NCOUNT + 1
      NCOUNT = NCOUNT + 2
      IF (DOCRT.GT.-2.5) NCOUNT = NCOUNT + 1
C                                       Initialize reading VIS. file.
      LENBU = 0
      BUFSZ = UVBFSS * 2
      CALL UVINIT ('READ', LUN, FIND, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFF, BO, BIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         CALL MSGWRT (8)
         GO TO 900
         END IF
      CALL UVINIT ('READ', LUN2, FIND2, NVIS, VO, LREC2, LENBU, BUFSZ,
     *   BUFF2, BO, BIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1065) IERR
         CALL MSGWRT (8)
         GO TO 900
         END IF
      COUNT = 0
      XCOUNT = -1
      IAPCNT = 0
C                                       Try to handle line
      CALL SETVIS (ICH1, NUMCH, BIF, MVIS, JADR, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1075)
         CALL MSGWRT (8)
         GO TO 900
         END IF
C                                       Start looping thru data.
 100  CONTINUE
C                                       Read buffer.
         COUNT = COUNT + 1
         CALL UVDISK ('READ', LUN, FIND, BUFF, NIO, BIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR, COUNT
            CALL MSGWRT (8)
            GO TO 900
            END IF
         CALL UVDISK ('READ', LUN2, FIND2, BUFF2, NIO2, BIND2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1105) IERR, COUNT
            CALL MSGWRT (8)
            GO TO 900
            END IF
         DOLAST = (NIO.LE.0) .OR. (NIO2.LE.0)
         IPINT = BIND - LREC
         IPINT2 = BIND2 - LREC2
         NIO = MAX (1, NIO)
C                                       Loop thru buffer.
         DO 175 J = 1,NIO
C                                       Update counters
            XCOUNT = XCOUNT + 1
            IPINT = IPINT + LREC
            IPINT2 = IPINT2 + LREC2
C                                       CONVERT
            IF (.NOT.DOLAST) THEN
C                                       Compressed?
               CALL RCOPY (NRP1, BUFF(IPINT), KBUFF)
               IF (ISCMP1) THEN
                  CALL ZUVXPN (NCORR, BUFF(IPINT+NRP1),
     *               BUFF(IPINT+KLOCWT), KBUFF(DPTR))
               ELSE
                  CALL RCOPY (LRECF, BUFF(IPINT+NRP1), KBUFF(DPTR))
                  END IF
               CALL RCOPY (NRP2, BUFF2(IPINT2), KBUFF2)
               IF (ISCMP2) THEN
                  CALL ZUVXPN (NCORR, BUFF2(IPINT2+NRP2),
     *               BUFF2(IPINT2+LLOCWT), KBUFF2(DPTR))
               ELSE
                  CALL RCOPY (LRECF, BUFF2(IPINT2+NRP2), KBUFF2(DPTR))
                  END IF
               END IF
C                                       TEST
            IF (XCOUNT.GT.0) THEN
               SRDOIT = .FALSE.
               SDOIT = .FALSE.
               UDOIT = .FALSE.
               FDOIT = .FALSE.
C                                       Decode time.
               LDAY = LBUFF(1+I1LOCT)
               LDAY2 = LBUFF2(1+I2LOCT)
               IF ((LDAY.LT.0.0) .OR. (LDAY.GT.1000.)) SDOIT = .TRUE.
               IF ((LDAY2.LT.0.0) .OR. (LDAY2.GT.1000.)) SDOIT = .TRUE.
               CALL TODHMS (LDAY, ITT)
C                                       Determine antennas.
               IF (I1LOCB.GE.0) THEN
                  LA1 = LBUFF(1+I1LOCB)/256. + 0.1
                  LA2 = LBUFF(1+I1LOCB) - LA1*256. + 0.1
               ELSE
                  LA1 = LBUFF(1+I1LOA1) + 0.1
                  LA2 = LBUFF(1+I1LOA2) + 0.1
                  END IF
               IF (LA1.EQ.LA2) THEN
                  IF (.NOT.DOACOR) GO TO 170
               ELSE
                  IF (.NOT.DOXCOR) GO TO 170
                  END IF
               IF (I2LOCB.GE.0) THEN
                  LB1 = LBUFF2(1+I2LOCB)/256. + 0.1
                  LB2 = LBUFF2(1+I2LOCB) - LB1*256. + 0.1
               ELSE
                  LB1 = LBUFF2(1+I2LOA1) + 0.1
                  LB2 = LBUFF2(1+I2LOA2) + 0.1
                  END IF
               IF (TYPUVD.LE.0) THEN
                  IF ((LA1.LE.0) .OR. (LA1.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LA2.LE.0) .OR. (LA2.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LB1.LE.0) .OR. (LB1.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LB2.LE.0) .OR. (LB2.GT.MAXANT)) SDOIT = .TRUE.
                  END IF
C                                       Sort order swap ?
               IF ((ABS(LDAY-LDAY2).GT.1.2E-5) .OR. (LA1.NE.LB1) .OR.
     *            (LA2.NE.LB2)) THEN
C                                       Decode time.
                  XDAY = KBUFF(1+I1LOCT)
                  XDAY2 = KBUFF2(1+I2LOCT)
C                                       Determine antennas.
                  IF (I1LOCB.GE.0) THEN
                     IA1 = KBUFF(1+I1LOCB)/256. + 0.1
                     IA2 = KBUFF(1+I1LOCB) - IA1*256. + 0.1
                  ELSE
                     IA1 = KBUFF(1+I1LOA1) + 0.1
                     IA2 = KBUFF(1+I1LOA2) + 0.1
                     END IF
                  IF (I2LOCB.GE.0) THEN
                     IB1 = KBUFF2(1+I2LOCB)/256. + 0.1
                     IB2 = KBUFF2(1+I2LOCB) - IB1*256. + 0.1
                  ELSE
                     IB1 = KBUFF2(1+I2LOA1) + 0.1
                     IB2 = KBUFF2(1+I2LOA2) + 0.1
                     END IF
                  SRDOIT = (LA1.EQ.IB1) .AND. (LA2.EQ.IB2) .AND.
     *               (LB1.EQ.IA1) .AND. (LB2.EQ.IA2) .AND.
     *               (ABS(LDAY-XDAY2).LE.1.2E-5) .AND.
     *               (ABS(XDAY-LDAY2).LE.1.2E-5) .AND. (.NOT.DOLAST)
C                                       Yes: swap buffers
                  IF (SRDOIT) THEN
                     SRCONT = SRCONT + 1
                     LDAY2 = XDAY2
                     LB1 = IB1
                     LB2 = IB2
                     CALL RCOPY (LRECA, LBUFF2, KBUFF2)
                     CALL RCOPY (NRP2, BUFF2(IPINT2), LBUFF2)
                     IF (ISCMP2) THEN
                        CALL ZUVXPN (NCORR, BUFF2(IPINT2+NRP2),
     *                     BUFF2(IPINT2+LLOCWT), LBUFF2(DPTR))
                     ELSE
                        CALL RCOPY (LRECF, BUFF2(IPINT2+NRP2),
     *                     LBUFF2(DPTR))
                        END IF
C                                       No: error
                  ELSE
                     SDOIT = .TRUE.
                     END IF
                  END IF
C                                       Convert uvw to kilo lamda.
               U = LBUFF(1+I1LOCU) * 0.001
               V = LBUFF(1+I1LOCV) * 0.001
               W = LBUFF(1+I1LOCW) * 0.001
               U2 = LBUFF2(1+I2LOCU) * 0.001
               V2 = LBUFF2(1+I2LOCV) * 0.001
               W2 = LBUFF2(1+I2LOCW) * 0.001
               R = U * U + V * V
C                                       UV box and range
               IF (.NOT.SDOIT) THEN
                  IF ((R.LT.UVRANG(1)) .OR. (R.GT.UVRANG(2))) GO TO 170
                  IF (DOUVBX) THEN
                     IF ((ABS(U-U2).GT.APARM(3)) .OR. (ABS(V-V2).GT.
     *                  APARM(3)) .OR. (ABS(W-W2).GT.APARM(3)))
     *                  UDOIT = .TRUE.
                     END IF
                  END IF
C                                       Convert to VIS
               CALL GETVIS (MVIS, JADR, LBUFF(DPTR), VIS, IERR1)
               CALL GETVIS (MVIS, JADR, LBUFF2(DPTR), VIS2, IERR2)
               IF ((IERR1.NE.0) .AND. (IERR2.NE.0)) GO TO 170
               FDOIT = (IERR1.NE.IERR2) .AND. (APARM(4).GT.0.0)
C                                       Accumulate statistics
               DOIT = FDOIT .OR. UDOIT .OR. SDOIT
               IF (.NOT.DOIT) GO TO 170
               IF (IAPCNT.GE.NITER) NOPRNT = .TRUE.
               IF (.NOT.NOPRNT) IAPCNT = IAPCNT + 1
               IF (.NOT.NOPRNT) NCOUNT = NCOUNT + 1
               END IF
 170        IF (DOLAST) THEN
               GO TO 200
            ELSE
               CALL RCOPY (LRECA, KBUFF, LBUFF)
               CALL RCOPY (LRECA, KBUFF2, LBUFF2)
               END IF
 175        CONTINUE
         GO TO 100
C                                       Number lines printed
 200  IF (DOCRT.GT.-2.5) NCOUNT = NCOUNT + 1
      NCOUNT = NCOUNT + 1
      IF ((IAPCNT.GE.NITER) .AND. (NITER.NE.NVIS)) THEN
         IF (DOCRT.LE.0.0) NCOUNT = NCOUNT + 1
         IPCNT = IPCNT + 2
         END IF
      IPCNT = IPCNT + 2
      NCOUNT = NCOUNT + 4
C                                       Write statistics in header of
C                                       first input file
 900  IF (IERR.EQ.0) THEN
         IF (DOCRT.GT.-2.5) NCOUNT = NCOUNT + 1
         NCOUNT = NCOUNT + 1
         END IF
C                                       Close files.
      IF (IERR.LE.0) IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1060 FORMAT ('CHKUBK ERROR:',I7,' INITIALIZING 1ST UV FILE')
 1065 FORMAT ('CHKUBX ERROR:',I7,' INITIALIZING 2ND UV FILE')
 1075 FORMAT ('CHKUBX: REQUESTED STOKES TYPE NOT AVAILABLE IN DATA SET')
 1100 FORMAT ('CHKUBX ERROR:',I7,' READING 1ST UV FILE VIS BLOCK ',I9)
 1105 FORMAT ('CHKUBX ERROR:',I7,' READING 2ND UV FILE VIS BLOCK ',I9)
      END
      SUBROUTINE CHKUCL (NCOUNT, IRET)
C-----------------------------------------------------------------------
C   CHKUPR reads the UV files and counts those samples meeting the
C   criteria given by OPCODE and APARM.
C   Output:
C      NCOUNT   I   Count of lines
C      IRET     I   Return 0 success or user requests end, else bad
C-----------------------------------------------------------------------
      INTEGER   NCOUNT, IRET
C
      INCLUDE 'UVDIF.INC'
      LOGICAL   F, DOIT, FDOIT, SDOIT, NOPRNT, DOLAST, SRDOIT
      INTEGER   JADR(8), BIND, CINC, ITYPE(8), BUFSZ,  J, LENBU, INDEX,
     *   MVIS, IROUND, I, L, IA1, IA2, ICH1, IERR, JERR, II, JJ, IPINT,
     *   LIMIT2, NIO, NUMCH, K, LRECF, NUMCHM, BIND2, NIO2, IPINT2, IB1,
     *   IB2, IERR2, BO, VO, XCOUNT, COUNT, IAPCNT, NCORR, LRECA, DPTR,
     *   LA1, LA2, LB1, LB2, IERR1, SRCONT
      REAL   VIS(3,8), TEMP, R, U, V, W, WTSC, U2, V2, W2, VIS2(3,8),
     *   XDAY, XDAY2, LDAY, LDAY2
      INCLUDE 'BUFFS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PUVD.INC'
      DATA F /.FALSE./
      DATA LENBU, BO, VO /16, 1, 0/
C-----------------------------------------------------------------------
      IRET = 8
      CINC = 2
      SRCONT = 0
      NOPRNT = .FALSE.
C                                       Set up for compressed data.
      NCORR = (LREC - NRPARM) / CATBLK(KINAX)
      LRECF = 3 * NCORR
      DPTR = 1 + MAX (NRP1, NRP2)
      LRECA = LRECF + DPTR - 1
      CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), KLOCWT,
     *   JERR)
      IF (ISCMP1 .AND. ((JERR.NE.0) .OR. (KLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL AXEFND (8, 'WEIGHT  ', CAT2I(KIPCN), CAT2H(KHPTP), LLOCWT,
     *   JERR)
      IF (ISCMP2 .AND. ((JERR.NE.0) .OR. (LLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                        Determine no. channels to do
      NUMCHM = CATBLK(KINAX+JLOCF) - NCH + 1
      NUMCH = (NACROS - 25) / (19 * NCOR)
      NUMCH = MAX (1, MIN (NUMCH, NUMCHM))
      LIMIT2 = NCOR * NUMCH
      ICH1 = NCH
      CALL FILL (8, 3, ITYPE)
      DO 10 II = 1,LIMIT2,NCOR
         DO 9 JJ = 1,NCOR
            INDEX = II + JJ - 1
            TEMP = CATD(KDCRV+JLOCS) + (JJ-CATR(KRCRP+JLOCS)) *
     *         CATR(KRCIC+JLOCS)
            I = IROUND(TEMP)
            L = 2
            IF (I.LT.0) L = 1
            I = ABS(I)
            ITYPE(INDEX) = 2
            IF (I+L.LE.3) ITYPE(INDEX) = 1
 9          CONTINUE
 10      CONTINUE
C                                       range parameters
      IF (XWT.LE.0.0) THEN
         XWT = 1.0
         NWT = 1.0
         END IF
      TEMP = LOG10 (XWT/0.995)
      I = TEMP + 99.0
      I =  100 - I
      WTSC = 10.0 ** I
      TEMP = NWT * WTSC
C                                       Make sure NITER is OK
      IF (NITER.GT.NVIS) NITER = NVIS
C                                       Write header
      IF (DOCRT.GT.-2.5) THEN
         NCOUNT = NCOUNT + 6
         IF (WTSC.NE.1.0) NCOUNT = NCOUNT + 1
         END IF
      NCOUNT = NCOUNT + 2
      IF (DOCRT.GT.-2.5) NCOUNT = NCOUNT + 1
C                                       Initialize reading VIS. file.
      LENBU = 0
      BUFSZ = UVBFSS * 2
      CALL UVINIT ('READ', LUN, FIND, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFF, BO, BIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         CALL MSGWRT (8)
         GO TO 900
         END IF
      CALL UVINIT ('READ', LUN2, FIND2, NVIS, VO, LREC2, LENBU, BUFSZ,
     *   BUFF2, BO, BIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1065) IERR
         CALL MSGWRT (8)
         GO TO 900
         END IF
      COUNT = 0
      XCOUNT = -1
      IAPCNT = 0
C                                       Try to handle line
      CALL SETVIS (ICH1, NUMCH, BIF, MVIS, JADR, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1075)
         CALL MSGWRT (8)
         GO TO 900
         END IF
C                                       Start looping thru data.
 100  CONTINUE
C                                       Read buffer.
         COUNT = COUNT + 1
         CALL UVDISK ('READ', LUN, FIND, BUFF, NIO, BIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR, COUNT
            CALL MSGWRT (8)
            GO TO 900
            END   IF
         CALL UVDISK ('READ', LUN2, FIND2, BUFF2, NIO2, BIND2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1105) IERR, COUNT
            CALL MSGWRT (8)
            GO TO 900
            END IF
         DOLAST = (NIO.LE.0) .OR. (NIO2.LE.0)
         IPINT = BIND - LREC
         IPINT2 = BIND2 - LREC2
         NIO = MAX (1, NIO)
C                                       Loop thru buffer.
         DO 175 J = 1,NIO
C                                       Update counters
            XCOUNT = XCOUNT + 1
            IPINT = IPINT + LREC
            IPINT2 = IPINT2 + LREC2
C                                       CONVERT
            IF (.NOT.DOLAST) THEN
C                                       Compressed?
               CALL RCOPY (NRP1, BUFF(IPINT), KBUFF)
               IF (ISCMP1) THEN
                  CALL ZUVXPN (NCORR, BUFF(IPINT+NRP1),
     *               BUFF(IPINT+KLOCWT), KBUFF(DPTR))
               ELSE
                  CALL RCOPY (LRECF, BUFF(IPINT+NRP1), KBUFF(DPTR))
                  END IF
               CALL RCOPY (NRP2, BUFF2(IPINT2), KBUFF2)
               IF (ISCMP2) THEN
                  CALL ZUVXPN (NCORR, BUFF2(IPINT2+NRP2),
     *               BUFF2(IPINT2+LLOCWT), KBUFF2(DPTR))
               ELSE
                  CALL RCOPY (LRECF, BUFF2(IPINT2+NRP2), KBUFF2(DPTR))
                  END IF
               END IF
C                                       TEST
            IF (XCOUNT.GT.0) THEN
               SRDOIT = .FALSE.
               SDOIT = .FALSE.
               FDOIT = .FALSE.
C                                       Decode time.
               LDAY = LBUFF(1+I1LOCT)
               LDAY2 = LBUFF2(1+I2LOCT)
               IF ((LDAY.LT.0.0) .OR. (LDAY.GT.1000.)) SDOIT = .TRUE.
               IF ((LDAY2.LT.0.0) .OR. (LDAY2.GT.1000.)) SDOIT = .TRUE.
C                                       Determine antennas.
               IF (I1LOCB.GE.0) THEN
                  LA1 = LBUFF(1+I1LOCB)/256. + 0.1
                  LA2 = LBUFF(1+I1LOCB) - LA1*256. + 0.1
               ELSE
                  LA1 = LBUFF(1+I1LOA1) + 0.1
                  LA2 = LBUFF(1+I1LOA2) + 0.1
                  END IF
               IF (LA1.EQ.LA2) THEN
                  IF (.NOT.DOACOR) GO TO 170
               ELSE
                  IF (.NOT.DOXCOR) GO TO 170
                  END IF
               IF (I2LOCB.GE.0) THEN
                  LB1 = LBUFF2(1+I2LOCB)/256. + 0.1
                  LB2 = LBUFF2(1+I2LOCB) - LB1*256. + 0.1
               ELSE
                  LB1 = LBUFF2(1+I2LOA1) + 0.1
                  LB2 = LBUFF2(1+I2LOA2) + 0.1
                  END IF
               IF (TYPUVD.LE.0) THEN
                  IF ((LA1.LE.0) .OR. (LA1.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LA2.LE.0) .OR. (LA2.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LB1.LE.0) .OR. (LB1.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LB2.LE.0) .OR. (LB2.GT.MAXANT)) SDOIT = .TRUE.
                  END IF
C                                       Sort order swap ?
               IF ((ABS(LDAY-LDAY2).GT.1.2E-5) .OR. (LA1.NE.LB1) .OR.
     *            (LA2.NE.LB2)) THEN
C                                       Decode time.
                  XDAY = KBUFF(1+I1LOCT)
                  XDAY2 = KBUFF2(1+I2LOCT)
C                                       Determine antennas.
                  IF (I1LOCB.GE.0) THEN
                     IA1 = KBUFF(1+I1LOCB)/256. + 0.1
                     IA2 = KBUFF(1+I1LOCB) - IA1*256. + 0.1
                  ELSE
                     IA1 = KBUFF(1+I1LOA1) + 0.1
                     IA2 = KBUFF(1+I1LOA2) + 0.1
                     END IF
                  IF (I2LOCB.GE.0) THEN
                     IB1 = KBUFF2(1+I2LOCB)/256. + 0.1
                     IB2 = KBUFF2(1+I2LOCB) - IB1*256. + 0.1
                  ELSE
                     IB1 = KBUFF2(1+I2LOA1) + 0.1
                     IB2 = KBUFF2(1+I2LOA2) + 0.1
                     END IF
                  SRDOIT = (LA1.EQ.IB1) .AND. (LA2.EQ.IB2) .AND.
     *               (LB1.EQ.IA1) .AND. (LB2.EQ.IA2) .AND.
     *               (ABS(LDAY-XDAY2).LE.1.2E-5) .AND.
     *               (ABS(XDAY-LDAY2).LE.1.2E-5) .AND. (.NOT.DOLAST)
C                                       Yes: swap buffers
                  IF (SRDOIT) THEN
                     SRCONT = SRCONT + 1
                     LDAY2 = XDAY2
                     LB1 = IB1
                     LB2 = IB2
                     CALL RCOPY (LRECA, LBUFF2, KBUFF2)
                     IF (ISCMP2) THEN
                        CALL RCOPY (NRP2, BUFF2(IPINT2), LBUFF2)
                        CALL ZUVXPN (NCORR, BUFF2(IPINT2+NRP2),
     *                     BUFF2(IPINT2+LLOCWT), LBUFF2(DPTR))
                     ELSE
                        CALL RCOPY (LRECF, BUFF2(IPINT2+NRP2),
     *                     LBUFF2(DPTR))
                        END IF
C                                       No: error
                  ELSE
                     SDOIT = .TRUE.
                     END IF
                  END IF
C                                       Convert uvw to kilo lamda.
               U = LBUFF(1+I1LOCU) * 0.001
               V = LBUFF(1+I1LOCV) * 0.001
               W = LBUFF(1+I1LOCW) * 0.001
               U2 = LBUFF2(1+I2LOCU) * 0.001
               V2 = LBUFF2(1+I2LOCV) * 0.001
               W2 = LBUFF2(1+I2LOCW) * 0.001
               R = U * U + V * V
C                                       UV box and range
               IF (.NOT.SDOIT) THEN
                  IF ((R.LT.UVRANG(1)) .OR. (R.GT.UVRANG(2))) GO TO 170
                  END IF
C                                       Convert to VIS
               CALL GETVIS (MVIS, JADR, LBUFF(DPTR), VIS, IERR1)
               CALL GETVIS (MVIS, JADR, LBUFF2(DPTR), VIS2, IERR2)
               IF ((IERR1.NE.0) .AND. (IERR2.NE.0)) GO TO 170
               FDOIT = (IERR1.NE.IERR2) .AND. (APARM(4).GT.0.0)
C                                       Accumulate statistics
               DOIT = FDOIT .OR. SDOIT
C                                       Do we want this one
               IF ((.NOT.DOIT) .AND. (DOMAX)) THEN
                  DO 130 K = 1,MVIS
                     IF ((ITYPE(K).LE.2) .AND. ((VIS(3,K).GT.0.0) .OR.
     *                  (VIS2(3,K).GT.0.0) .OR. (DOFLAG))) THEN
                        IF (ABS(VIS(1,K)-VIS2(1,K)).GT.APARM(ITYPE(K)))
     *                     FDOIT = .TRUE.
                        IF (ABS(VIS(2,K)-VIS2(2,K)).GT.APARM(ITYPE(K)))
     *                     FDOIT = .TRUE.
                        IF (APARM(4).GT.0.0) THEN
                           IF (ABS(VIS(3,K)-VIS2(3,K)).GT.APARM(4))
     *                        FDOIT = .TRUE.
                           IF ((VIS(3,K).LE.0.0).AND.(VIS2(3,K).GT.0.0))
     *                        FDOIT = .TRUE.
                           IF ((VIS(3,K).GT.0.0).AND.(VIS2(3,K).LE.0.0))
     *                        FDOIT = .TRUE.
                        ELSE
                           IF (ABS(ABS(VIS(3,K))-ABS(VIS2(3,K))).GT.
     *                        -APARM(4)) FDOIT = .TRUE.
                           END IF
                        END IF
 130                 CONTINUE
                  DOIT = FDOIT
                  END IF
               IF (.NOT.DOIT) GO TO 170
               IF (IAPCNT.GE.NITER) NOPRNT = .TRUE.
               IF (.NOT.NOPRNT) IAPCNT = IAPCNT + 1
               IF (.NOT.NOPRNT) NCOUNT = NCOUNT + 1
               END IF
 170        IF (DOLAST) THEN
               GO TO 200
            ELSE
               CALL RCOPY (LRECA, KBUFF, LBUFF)
               CALL RCOPY (LRECA, KBUFF2, LBUFF2)
               END IF
 175        CONTINUE
         GO TO 100
C                                       Number lines printed
 200  IF (DOCRT.GT.-2.5) NCOUNT = NCOUNT + 1
      NCOUNT = NCOUNT + 1
      IF ((IAPCNT.LT.NITER) .OR. (NITER.EQ.NVIS)) GO TO 210
         NCOUNT = NCOUNT + 1
         IPCNT = IPCNT + 2
 210  IPCNT = IPCNT + 2
      NCOUNT = NCOUNT + 3
C                                       Write statistics in header of
C                                       first input file
 900  IF (IERR.EQ.0) THEN
         IF (DOCRT.GT.-2.5) NCOUNT = NCOUNT + 1
         NCOUNT = NCOUNT + 1
         END IF
C                                       Close files.
      IF (IERR.LE.0) IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1060 FORMAT ('CHKUCL ERROR:',I7,' INITIALIZING 1ST UV FILE')
 1065 FORMAT ('CHKUCL ERROR:',I7,' INITIALIZING 2ND UV FILE')
 1075 FORMAT ('CHKUCL: REQUESTED STOKES TYPE NOT AVAILABLE IN DATA SET')
 1100 FORMAT ('CHKUCL ERROR:',I7,' READING 1ST UV FILE VIS BLOCK ',I9)
 1105 FORMAT ('CHKUCL ERROR:',I7,' READING 2ND UV FILE VIS BLOCK ',I9)
      END
      SUBROUTINE CHKUPR (NCOUNT, IRET)
C-----------------------------------------------------------------------
C   CHKUPR reads the UV files and counts those samples meeting the
C   criteria given by OPCODE and APARM.
C   Output:
C      NCOUNT   I   Count of lines
C      IRET     I   Return 0 success or user requests end, else bad
C-----------------------------------------------------------------------
      INTEGER   NCOUNT, IRET
C
      INCLUDE 'UVDIF.INC'
      LOGICAL   F, DOIT, FDOIT, UDOIT, SDOIT, NOPRNT, DOLAST,
     *   SRDOIT
      INTEGER   JADR(8), BIND, CINC, ITYPE(8), BUFSZ, J, ITT(4),
     *   LENBU, INDEX, MVIS, IROUND, I, L, IA1, IA2, ICH1, IERR, JERR,
     *   II, JJ, IPINT, LIMIT2, NIO, NNCH, NUMCH, K, LRECF, NUMCHM,
     *   BIND2, NIO2, IPINT2, IB1, IB2, IERR2, BO, VO, XCOUNT,
     *   COUNT, IAPCNT, NCORR, LRECA, DPTR, LA1, LA2, LB1, LB2, IERR1,
     *   SRCONT
      REAL   VIS(3,8), TEMP, R, U, V, W, WTSC, U2, V2, W2, VIS2(3,8),
     *   XDAY, XDAY2, LDAY, LDAY2
      INCLUDE 'BUFFS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PUVD.INC'
      DATA F /.FALSE./
      DATA LENBU, BO, VO /16, 1, 0/
C-----------------------------------------------------------------------
      IRET = 8
      CINC = 2
      SRCONT = 0
      NOPRNT = .FALSE.
C                                       range parameters
      IF (XWT.LE.0.0) THEN
         XWT = 1.0
         NWT = 1.0
         END IF
      TEMP = LOG10 (XWT/0.995)
      I = TEMP + 99.0
      I =  100 - I
      WTSC = 10.0 ** I
      TEMP = NWT * WTSC
      IF (TEMP.LT.1.0) THEN
         MSGTXT = 'Full dynamic range of weights cannot be printed'
         CALL MSGWRT (6)
         END IF
C                                       Set up for compressed data.
      NCORR = (LREC - NRPARM) / CATBLK(KINAX)
      LRECF = 3 * NCORR
      DPTR = 1 + MAX (NRP1, NRP2)
      LRECA = LRECF + DPTR - 1
      CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), KLOCWT,
     *   JERR)
      IF (ISCMP1 .AND. ((JERR.NE.0) .OR. (KLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL AXEFND (8, 'WEIGHT  ', CAT2I(KIPCN), CAT2H(KHPTP), LLOCWT,
     *   JERR)
      IF (ISCMP2 .AND. ((JERR.NE.0) .OR. (LLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                        Determine no. channels to do
      NUMCHM = CATBLK(KINAX+JLOCF) - NCH + 1
      NACROS = 132
      NUMCH = (NACROS - 52) / (15 * NCOR)
      NUMCH = MAX (1, MIN (NUMCH, NUMCHM))
      LIMIT2 = NCOR * NUMCH
      ICH1 = NCH
      NNCH = NCH - 1
      CALL FILL (8, 3, ITYPE)
      DO 10 II = 1,LIMIT2,NCOR
         NNCH = NNCH + 1
         DO 9 JJ = 1,NCOR
            INDEX = II + JJ - 1
            TEMP = CATD(KDCRV+JLOCS) + (JJ-CATR(KRCRP+JLOCS)) *
     *         CATR(KRCIC+JLOCS)
            I = IROUND(TEMP)
            L = 2
            IF (I.LT.0) L = 1
            I = ABS(I)
            ITYPE(INDEX) = 2
            IF (I+L.LE.3) ITYPE(INDEX) = 1
 9          CONTINUE
 10      CONTINUE
C                                       Make sure NITER is OK
      IF (NITER.GT.NVIS) NITER = NVIS
C                                       Write header
      IF (DOCRT.GT.-2.5) THEN
         NCOUNT = NCOUNT + 5
         IF (WTSC.NE.1.0) NCOUNT = NCOUNT + 1
         END IF
      IF (DOCRT.GT.-2.5) NCOUNT = NCOUNT + 2
      NCOUNT = NCOUNT + 2
C                                       Initialize reading VIS. file.
      LENBU = 0
      BUFSZ = UVBFSS * 2
      CALL UVINIT ('READ', LUN, FIND, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFF, BO, BIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         CALL MSGWRT (8)
         GO TO 900
         END IF
      CALL UVINIT ('READ', LUN2, FIND2, NVIS, VO, LREC2, LENBU, BUFSZ,
     *   BUFF2, BO, BIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1065) IERR
         CALL MSGWRT (8)
         GO TO 900
         END IF
      COUNT = 0
      XCOUNT = -1
      IAPCNT = 0
C                                       Try to handle line
      CALL SETVIS (ICH1, NUMCH, BIF, MVIS, JADR, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1075)
         CALL MSGWRT (8)
         GO TO 900
         END IF
C                                       Start looping thru data.
 100  CONTINUE
C                                       Read buffer.
         COUNT = COUNT + 1
         CALL UVDISK ('READ', LUN, FIND, BUFF, NIO, BIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR, COUNT
            CALL MSGWRT (8)
            GO TO 900
            END IF
         CALL UVDISK ('READ', LUN2, FIND2, BUFF2, NIO2, BIND2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1105) IERR, COUNT
            CALL MSGWRT (8)
            GO TO 900
            END IF
         DOLAST = (NIO.LE.0) .OR. (NIO2.LE.0)
         IPINT = BIND - LREC
         IPINT2 = BIND2 - LREC2
         NIO = MAX (1, NIO)
C                                       Loop thru buffer.
         DO 175 J = 1,NIO
C                                       Update counters
            XCOUNT = XCOUNT + 1
            IPINT = IPINT + LREC
            IPINT2 = IPINT2 + LREC2
C                                       CONVERT
            IF (.NOT.DOLAST) THEN
C                                       Compressed?
               CALL RCOPY (NRP1, BUFF(IPINT), KBUFF)
               IF (ISCMP1) THEN
                  CALL ZUVXPN (NCORR, BUFF(IPINT+NRP1),
     *               BUFF(IPINT+KLOCWT), KBUFF(DPTR))
               ELSE
                  CALL RCOPY (LRECF, BUFF(IPINT+NRP1), KBUFF(DPTR))
                  END IF
               CALL RCOPY (NRP2, BUFF2(IPINT2), KBUFF2)
               IF (ISCMP2) THEN
                  CALL ZUVXPN (NCORR, BUFF2(IPINT2+NRP2),
     *               BUFF2(IPINT2+LLOCWT), KBUFF2(DPTR))
               ELSE
                  CALL RCOPY (LRECF, BUFF2(IPINT2+NRP2), KBUFF2(DPTR))
                  END IF
               END IF
C                                       TEST
            IF (XCOUNT.GT.0) THEN
               SRDOIT = .FALSE.
               SDOIT = .FALSE.
               UDOIT = .FALSE.
               FDOIT = .FALSE.
C                                       Decode time.
               LDAY = LBUFF(1+I1LOCT)
               LDAY2 = LBUFF2(1+I2LOCT)
               IF ((LDAY.LT.0.0) .OR. (LDAY.GT.1000.)) SDOIT = .TRUE.
               IF ((LDAY2.LT.0.0) .OR. (LDAY2.GT.1000.)) SDOIT = .TRUE.
               CALL TODHMS (LDAY, ITT)
C                                       Determine antennas.
               IF (I1LOCB.GE.0) THEN
                  LA1 = LBUFF(1+I1LOCB)/256. + 0.1
                  LA2 = LBUFF(1+I1LOCB) - LA1*256. + 0.1
               ELSE
                  LA1 = LBUFF(1+I1LOA1) + 0.1
                  LA2 = LBUFF(1+I1LOA2) + 0.1
                  END IF
               IF (LA1.EQ.LA2) THEN
                  IF (.NOT.DOACOR) GO TO 170
               ELSE
                  IF (.NOT.DOXCOR) GO TO 170
                  END IF
               IF (I2LOCB.GE.0) THEN
                  LB1 = LBUFF2(1+I2LOCB)/256. + 0.1
                  LB2 = LBUFF2(1+I2LOCB) - LB1*256. + 0.1
               ELSE
                  LB1 = LBUFF2(1+I2LOA1) + 0.1
                  LB2 = LBUFF2(1+I2LOA2) + 0.1
                  END IF
               IF (TYPUVD.LE.0) THEN
                  IF ((LA1.LE.0) .OR. (LA1.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LA2.LE.0) .OR. (LA2.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LB1.LE.0) .OR. (LB1.GT.MAXANT)) SDOIT = .TRUE.
                  IF ((LB2.LE.0) .OR. (LB2.GT.MAXANT)) SDOIT = .TRUE.
                  END IF
C                                       Sort order swap ?
               IF ((ABS(LDAY-LDAY2).GT.1.2E-5) .OR. (LA1.NE.LB1) .OR.
     *            (LA2.NE.LB2)) THEN
C                                       Decode time.
                  XDAY = KBUFF(1+I1LOCT)
                  XDAY2 = KBUFF2(1+I2LOCT)
C                                       Determine antennas.
                  IF (I1LOCB.GE.0) THEN
                     IA1 = KBUFF(1+I1LOCB)/256. + 0.1
                     IA2 = KBUFF(1+I1LOCB) - IA1*256. + 0.1
                  ELSE
                     IA1 = KBUFF(1+I1LOA1) + 0.1
                     IA2 = KBUFF(1+I1LOA2) + 0.1
                     END IF
                  IF (I2LOCB.GE.0) THEN
                     IB1 = KBUFF2(1+I2LOCB)/256. + 0.1
                     IB2 = KBUFF2(1+I2LOCB) - IB1*256. + 0.1
                  ELSE
                     IB1 = KBUFF2(1+I2LOA1) + 0.1
                     IB2 = KBUFF2(1+I2LOA2) + 0.1
                     END IF
                  SRDOIT = (LA1.EQ.IB1) .AND. (LA2.EQ.IB2) .AND.
     *               (LB1.EQ.IA1) .AND. (LB2.EQ.IA2) .AND.
     *               (ABS(LDAY-XDAY2).LE.1.2E-5) .AND.
     *               (ABS(XDAY-LDAY2).LE.1.2E-5) .AND. (.NOT.DOLAST)
C                                       Yes: swap buffers
                  IF (SRDOIT) THEN
                     SRCONT = SRCONT + 1
                     LDAY2 = XDAY2
                     LB1 = IB1
                     LB2 = IB2
                     CALL RCOPY (LRECA, LBUFF2, KBUFF2)
                     IF (ISCMP2) THEN
                        CALL RCOPY (NRP2, BUFF2(IPINT2), LBUFF2)
                        CALL ZUVXPN (NCORR, BUFF2(IPINT2+NRP2),
     *                     BUFF2(IPINT2+LLOCWT), LBUFF2(DPTR))
                     ELSE
                        CALL RCOPY (LRECA, BUFF2(IPINT2), LBUFF2)
                        END IF
C                                       No: error
                  ELSE
                     SDOIT = .TRUE.
                     END IF
                  END IF
C                                       Convert uvw to kilo lamda.
               U = LBUFF(1+I1LOCU) * 0.001
               V = LBUFF(1+I1LOCV) * 0.001
               W = LBUFF(1+I1LOCW) * 0.001
               U2 = LBUFF2(1+I2LOCU) * 0.001
               V2 = LBUFF2(1+I2LOCV) * 0.001
               W2 = LBUFF2(1+I2LOCW) * 0.001
               R = U * U + V * V
C                                       UV box and range
               IF (.NOT.SDOIT) THEN
                  IF ((R.LT.UVRANG(1)) .OR. (R.GT.UVRANG(2))) GO TO 170
                  IF (DOUVBX) THEN
                     IF ((ABS(U-U2).GT.APARM(3)) .OR. (ABS(V-V2).GT.
     *                  APARM(3)) .OR. (ABS(W-W2).GT.APARM(3)))
     *                  UDOIT = .TRUE.
                     END IF
                  END IF
C                                       Convert to VIS
               CALL GETVIS (MVIS, JADR, LBUFF(DPTR), VIS, IERR1)
               CALL GETVIS (MVIS, JADR, LBUFF2(DPTR), VIS2, IERR2)
               IF ((IERR1.NE.0) .AND. (IERR2.NE.0)) GO TO 170
               FDOIT = (IERR1.NE.IERR2) .AND. (APARM(4).GT.0.0)
C                                       Accumulate statistics
               DOIT = FDOIT .OR. UDOIT .OR. SDOIT
C                                       Do we want this one
               IF ((.NOT.DOIT) .AND. (DOMAX)) THEN
                  DO 130 K = 1,MVIS
                     IF ((ITYPE(K).LE.2) .AND. ((VIS(3,K).GT.0.0) .OR.
     *                  (VIS2(3,K).GT.0.0) .OR. (DOFLAG))) THEN
                        IF (ABS(VIS(1,K)-VIS2(1,K)).GT.APARM(ITYPE(K)))
     *                     FDOIT = .TRUE.
                        IF (ABS(VIS(2,K)-VIS2(2,K)).GT.APARM(ITYPE(K)))
     *                     FDOIT = .TRUE.
                        IF (APARM(4).GT.0.0) THEN
                           IF (ABS(VIS(3,K)-VIS2(3,K)).GT.APARM(4))
     *                        FDOIT = .TRUE.
                           IF ((VIS(3,K).LE.0.0).AND.(VIS2(3,K).GT.0.0))
     *                        FDOIT = .TRUE.
                           IF ((VIS(3,K).GT.0.0).AND.(VIS2(3,K).LE.0.0))
     *                        FDOIT = .TRUE.
                        ELSE
                           IF (ABS(ABS(VIS(3,K))-ABS(VIS2(3,K))).GT.
     *                        -APARM(4)) FDOIT = .TRUE.
                           END IF
                        END IF
 130                 CONTINUE
                  DOIT = FDOIT
                  END IF
               IF (.NOT.DOIT) GO TO 170
               IF (IAPCNT.GE.NITER) NOPRNT = .TRUE.
               IF (.NOT.NOPRNT) IAPCNT = IAPCNT + 1
               IF (NOPRNT) GO TO 170
               NCOUNT = NCOUNT + 1
               END IF
 170        IF (DOLAST) THEN
               GO TO 200
            ELSE
               CALL RCOPY (LRECA, KBUFF, LBUFF)
               CALL RCOPY (LRECA, KBUFF2, LBUFF2)
               END IF
 175        CONTINUE
         GO TO 100
C                                       Number lines printed
 200  NCOUNT = NCOUNT + 2
      IF ((IAPCNT.LT.NITER) .OR. (NITER.EQ.NVIS)) GO TO 210
         NCOUNT = NCOUNT + 1
         IPCNT = IPCNT + 2
 210  IPCNT = IPCNT + 2
      NCOUNT = NCOUNT + 4
C                                       Write statistics in header of
C                                       first input file
 900  IF (IERR.EQ.0) THEN
         IF (DOCRT.GT.-2.5) NCOUNT = NCOUNT + 1
         NCOUNT = NCOUNT + 1
         END IF
C                                       Close files.
      IF (IERR.LE.0) IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1060 FORMAT ('CHKUPR ERROR:',I7,' INITIALIZING 1ST UV FILE')
 1065 FORMAT ('CHKUPR ERROR:',I7,' INITIALIZING 2ND UV FILE')
 1075 FORMAT ('CHKUPR REQUESTED STOKES TYPE NOT AVAILABLE IN DATA SET')
 1100 FORMAT ('CHKUPR ERROR:',I7,' READING 1ST UV FILE VIS BLOCK ',I9)
 1105 FORMAT ('CHKUPR ERROR:',I7,' READING 2ND UV FILE VIS BLOCK ',I9)
      END

      SUBROUTINE SYINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   ISYRNO, SYKOLS, SYNUMV, NUMANT, NUMPOL, NUMIF, IERR)
C-----------------------------------------------------------------------
C! Creates/opens/initializes SysPower (SY) table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2010, 2013, 2017, 2019, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes calibration extension tables.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                           'WRIT' = create/init for write or read
C                           'READ' = open for read only
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      VER      I        SY file version
C      CATBLK   I(256)   Catalog header block.
C      LUN      I        Logical unit number to use
C   Input/output
C      NUMANT   I        Number of antennas
C      NUMPOL   I        Number of IFs per pair
C      NUMIF    I        Number of IF pairs
C   Output:
C      ISYRNO   I        Next record number, start of the file
C                        if 'READ', the last+1 if WRITE
C      SYKOLS   I(12)    The column pointer array: time, interval,
C                        source, antenna, subarray, freqid, Pdif1,
C                        Psum1, Gb1, Pdif2, Psum2, Gb2
C      SYNUMV   I(12)    Element count in each column.
C      IERR     I        Return error code, 0=>OK, else TABINI or TABIO
C                        error.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, ISYRNO,
     *   SYKOLS(*), SYNUMV(*), NUMANT, NUMPOL, NUMIF, IERR
C
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH HOLTMP(6)
      CHARACTER TTITLE*56, TITLE(MAXSYC)*24, UNITS(MAXSYC)*8, KEYW(4)*8
      INTEGER   NKEY, NREC, DATP(128,2), NCOL, NTT, DTYP(MAXSYC), NDATA,
     *   KLOCS(4), KEYVAL(4), IPOINT, JERR, J, KEYTYP(4), I, MSGSAV, NC,
     *   ITRIM, ITEMP(6)
      LOGICAL   T, DOREAD, NEWFIL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (HOLTMP, ITEMP)
      DATA T /.TRUE./
      DATA NTT /56/
      DATA TTITLE /'AIPS EVLA SysPower TABLE '/
C                                       Values >10 are scalar
      DATA DTYP /11, 12, 5*14, 6*2/
C                                       NOTE: Change PCLTAB.INC when
C                                       changing the table columns.
      DATA TITLE /'TIME           ', 'TIME INTERVAL           ',
     *   'CAL TYPE                ', 'SOURCE ID               ',
     *   'ANTENNA NO.             ', 'SUBARRAY                ',
     *   'FREQ ID                 ', 'POWER DIF1              ',
     *   'POWER SUM1              ', 'POST GAIN1              ',
     *   'POWER DIF2              ', 'POWER SUM2              ',
     *   'POST GAIN2              '/
      DATA KEYW /'NO_IF', 'NO_POL', 'NO_ANT', 'REVISION'/
      DATA UNITS /2*'DAYS', 5*' ', 2*'COUNTS', ' ', 2*'COUNTS', ' '/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NREC = 1000
      NCOL = 7 + NUMPOL * 3
      IF (DOREAD) NCOL = 0
      NKEY = 4
      NDATA = MAXSYC
      CALL FILL (NDATA, 0, SYKOLS)
      CALL FILL (NDATA, 0, SYNUMV)
C                                       Fill in types
      IF (.NOT.DOREAD) THEN
         CALL COPY (NDATA, DTYP, DATP(1,2))
         DO 10 J = 1,NDATA
            IF (DTYP(J).LT.10) DATP(J,2) = DTYP(J) + 10 * NUMIF
 10         CONTINUE
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'SY', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'SYINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
C                                       Get number of records
      ISYRNO = BUFFER(5) + 1
      IF (DOREAD) ISYRNO = 1
      NKEY = 3
      MSGSAV = MSGSUP
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 40 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'SYINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'SYINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       Set keyword values
C                                       No. antennas.
         KLOCS(1) = 1
         KEYTYP(1) = 4
         KEYVAL(1) = NUMIF
C                                       No. polarizations
         KLOCS(2) = 2
         KEYTYP(2) = 4
         KEYVAL(2) = NUMPOL
C                                       No. IFs.
         KLOCS(3) = 3
         KEYTYP(3) = 4
         KEYVAL(3) = NUMANT
C                                       revision
         KLOCS(4) = 4
         KEYTYP(4) = 4
         KEYVAL(4) = 1
C                                       Only write if just created.
         NKEY = 4
         CALL TABKEY (OPCODE, KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'SYINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords ignore revision
      ELSE
         MSGSUP = 32000
         NKEY = 3
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         MSGSUP = MSGSAV
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'SYINI', IERR)
            GO TO 990
            END IF
C                                       Retrieve keyword values
C                                       No. IF pairs.
         IPOINT = KLOCS(1)
         IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       No. IFs per pair.
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. antennas.
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) NUMANT = KEYVAL(IPOINT)
         END IF
C                                       Get array indices
C                                       Cover your ass from FNDCOL -
C                                       close to flush the buffers and
C                                       then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KEYVAL, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'SYINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'SY', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'SYINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (MAXSYC, TITLE, 24, T, BUFFER, SYKOLS, JERR)
C                                      Get array indices and no. values
      NCOL = 7 + NUMPOL * 3
      DO 150 I = 1,NCOL
         IPOINT = SYKOLS(I)
         IF (IPOINT.GT.0) THEN
            SYKOLS(I) = DATP(IPOINT,1)
            SYNUMV(I) = DATP(IPOINT,2) / 10
            IF (SYNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               IF (I.NE.3) CALL MSGWRT (6)
               END IF
         ELSE
            SYKOLS(I) = -1
            SYNUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            IF (I.NE.3) CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('SYINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('SYINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('SYINI: ERROR INITIALIZING SYSPOWER TABLE FOR ',A4)
      END

LOCAL INCLUDE 'SUFIX.INC'
C                                       Local include for SUFIX
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4,30), XCALC(1), XNAMOU(3),
     *   XCLAOU(2), XXSTOK(1), XSNAME(4), XSCODE(1)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XSUBA, XBIF, XEIF, XBCHAN, XECHAN, XDOCAL, XGUSE, XDOPOL,
     *   XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH(3), XDOAC, XSOUT,
     *   XDISO, TB(30), TE(30), COORD(6), BADD(10),
     *   SCRBUF(256), BUFF2(UVBFSS)
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, JBUFSZ, ILOCWT,
     *   CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO,
     *   LRECO, NRPRMI, NRPRMO, OLDCNO, NEWCNO, NEWNUM, NTIMES
      LOGICAL   ISCOMP, OLDSRC
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, SNAME*16,
     *   SCODE*4
      DOUBLE PRECISION NEWRA, NEWDEC
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XXSTOK, XTIME, XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF, XBCHAN,
     *   XECHAN, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND,
     *   XBPVER, XSMOTH, XDOAC, XNAMOU, XCLAOU, XSOUT, XDISO, TB, TE,
     *   XSNAME, XSCODE, COORD, BADD
      COMMON /SUFIXP/ CATOLD, NEWRA, NEWDEC, SEQIN, SEQOUT, DISKIN,
     *   DISKO, ILOCWT, INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO,
     *   LRECO, NRPRMI, NRPRMO, ISCOMP, OLDCNO, NEWCNO, NEWNUM, NTIMES,
     *   OLDSRC
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, SNAME, SCODE
      COMMON /BUFRS/ SCRBUF, BUFF2, JBUFSZ
C                                       End local include for SUFIX
LOCAL END
      PROGRAM SUFIX
C-----------------------------------------------------------------------
C! Changes to new source number in up to 30 time ranges
C# Utility UV UV-util VLA VLB Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2009-2012, 2018, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SUFIX copies a data set with calibration and changes the source
C   number assigned to the vis within up to 30 time ranges.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C   full set of calibration adverbs
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      KEYSTRNG       SNAME         new source name
C      SOUCODE        SCODE         new source cal code
C      COORDINA       COORD         source coordinates
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'SUFIX.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'SUFIX '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL SUFIXI (PRGM, IRET)
C                                       Call routine that does it
      IF (IRET.EQ.0) CALL SUFIXD (IRET)
C                                       history, copy tables
C                                       fix output SU table
      IF (IRET.EQ.0) CALL SUFIXH
C                                       Close down files, etc.
      CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE SUFIXI (PRGN, JERR)
C-----------------------------------------------------------------------
C   SUFIXI gets input parameters for SUFIX and creates an output file
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, NFREQ, LUN
      LOGICAL   MATCH
      REAL      CATR(256), RPARM(20)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128), DCOORD(6)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'SUFIX.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      DATA BLANK  /' '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 246
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (4, 1, XXSTOK, STOKES)
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
      CALL H2CHR (16, 1, XSNAME, SNAME)
      CALL H2CHR (4, 1, XSCODE, SCODE)
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = XDOAC.GT.0.0
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NFREQ = CATBLK(KINAX+JLOCF)
      BCHAN = IROUND (XBCHAN)
      ECHAN = IROUND (XECHAN)
      IF ((BCHAN.LE.0) .OR. (BCHAN.GT.NFREQ)) BCHAN = 1
      IF ((ECHAN.LE.0) .OR. (ECHAN.GT.NFREQ)) ECHAN = NFREQ
      IF (BCHAN.GT.ECHAN) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       time ranges
      NTIMES = 30
      DO 20 I = 1,30
         IF ((TB(I).LE.0.0) .OR. (TE(I).LE.0.0) .OR. (TE(I).LT.TB(I)))
     *      THEN
            NTIMES = I - 1
            GO TO 25
            END IF
 20      CONTINUE
 25   IF (NTIMES.LT.1) THEN
         JERR = 10
         MSGTXT = 'NO VALID TIME RANGES SPECIFIED'
         GO TO 990
         END IF
C                                       get new source number
      DO 30 I = 1,6
         DCOORD(I) = COORD(I)
 30      CONTINUE
      NEWRA = DCOORD(1)*15.0D0 + DCOORD(2)/4.0D0 + DCOORD(3)/240.0D0
      NEWDEC = ABS (DCOORD(4)) + ABS (DCOORD(5)) / 60.0D0 +
     *   ABS (DCOORD(6)) / 3600.0D0
      IF ((DCOORD(4).LT.0.0) .OR. (DCOORD(5).LT.0.0) .OR.
     *   (DCOORD(6).LT.0.0)) NEWDEC = -NEWDEC
      CALL SUCHEK (SNAME, SCODE, NEWRA, NEWDEC, DISKIN, OLDCNO, NEWNUM,
     *   JERR)
      IF (JERR.GT.0) THEN
         MSGTXT = 'SUCHEK REPORTS FAILURE - QUITTING'
         GO TO 990
         END IF
      OLDSRC = NEWNUM.LT.0
      NEWNUM = ABS (NEWNUM)
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, SCRBUF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, SCRBUF, IERR)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       read compressed => write compr.
      IF (ISCOMP) THEN
         CATBLK(KINAX) = 1
         I = CATBLK(KIPCN)
         CALL CHR2H (8, 'WEIGHT  ', 1, CATH(KHPTP+2*I))
         CALL CHR2H (8, 'SCALE   ', 1, CATH(KHPTP+2*I+2))
         CATBLK(KIPCN) = I + 2
         ILOCWT = I
         END IF
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((CCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', SCRBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
      NEWCNO = CCNO
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', SCRBUF, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       Copy any header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SUFIXI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('SUFIXI: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE SUFIXD (IRET)
C-----------------------------------------------------------------------
C   SUFIXD sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48
      INTEGER   IPTRO, LUNO, INDO, ILENBU, KBIND, NIOUT, NIOLIM, BO, VO,
     *   NUMVIS, XCOUNT, NCORO, NCOPY, CATMP(256), RNXRET
      LOGICAL   T, F
      INCLUDE 'SUFIX.INC'
      REAL      VIS(UVBFSS), RPARM(20)
      DOUBLE PRECISION UVSCAL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA LUNO /17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Number of visibilities in input
C                                       and output files.
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       defend cat header from UVGET
      CALL COPY (256, CATBLK, CATMP)
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL COPY (256, CATMP, CATBLK)
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
      NUMVIS = 0
      XCOUNT = 0
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
      IF ((FREQ.GT.0.0D0) .AND. (UVFREQ.GT.0.0D0)) THEN
         UVSCAL = FREQ / UVFREQ
      ELSE
         UVSCAL = 1.0D0
         END IF
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over buffer
      ELSE IF (IRET.EQ.0) THEN
         NUMVIS = NUMVIS + 1
         RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
         RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
         RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
C                                       call user routine
         CALL SUFIXS (NUMVIS, RPARM(1+ILOCT), RPARM(1+ILOCSU), IRET)
C                                       Error (fatal)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
C                                       Copy to output.
         ELSE IF (IRET.EQ.0) THEN
            XCOUNT = XCOUNT + 1.0D0
            CALL RCOPY (NRPRMI, RPARM, BUFF2(IPTRO))
C                                       update NX table
            CALL RNXUPD (RPARM, RNXRET)
C                                       Compressed
            IF (ISCOMP) THEN
               CALL ZUVPAK (NCORO, VIS, BUFF2(IPTRO+ILOCWT),
     *            BUFF2(IPTRO+NRPRMO))
            ELSE
               CALL RCOPY (NCOPY, VIS, BUFF2(IPTRO+NRPRMO))
               END IF
            IPTRO = IPTRO + LRECO
            NIOUT = NIOUT + 1
            END IF
C                                       Write vis record.
         IF (NIOUT.GE.NIOLIM) THEN
            CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1150) IRET
               GO TO 990
               END IF
            IPTRO = KBIND
            NIOUT = 0
            END IF
C                                       Read next buffer.
         GO TO 100
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
C                                       close NX table
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SUFIXD: ERROR',I3,' OPEN/INIT INPUT VIS FILE')
 1010 FORMAT ('SUFIXD: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('SUFIXD: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1100 FORMAT ('SUFIXD: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('SUFIXD: SUFIXS ERROR',I3)
 1150 FORMAT ('SUFIXD: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE SUFIXH
C-----------------------------------------------------------------------
C   SUFIXH copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, DSIGN*1
      INTEGER   LUN1, LUN2, IERR, RH, RM, DD, DM
      REAL      RS, DS
      DOUBLE PRECISION D
      INCLUDE 'SUFIX.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1, LUN2 /27,28/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   SCRBUF, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
C                                       calibration history
      CALL CALHIS (LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       source stuff
      IF (.NOT.OLDSRC) THEN
         WRITE (HILINE,1100) TSKNAM, SNAME
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
         WRITE (HILINE,1101) TSKNAM, SCODE
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
         WRITE (HILINE,1102) TSKNAM, NEWNUM
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
         D = NEWRA / 15.0D0
         RH = D
         D = (D - RH) * 60.0D0
         RM = D
         RS = (D - RM) * 60.0D0
         D = NEWDEC
         DSIGN = ' '
         IF (D.LT.0.0) DSIGN = '-'
         DD = D
         D = (D - DD) * 60.0D0
         DM = D
         DS = (D - DM) * 60.0D0
         WRITE (HILINE,1103) TSKNAM, RH, RM, RS, DSIGN, DD, DM, DS
         IF (HILINE(23:23).EQ.' ') HILINE(23:23) = '0'
         IF (HILINE(37:37).EQ.' ') HILINE(37:37) = '0'
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
      ELSE
         WRITE (HILINE,1110) TSKNAM, NEWNUM
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
         END IF
C                                       Close HI file
 100  CALL HICLOS (LUN2, .TRUE., BUFF2, IERR)
C                                       Copy tables
      CALL COPTAB (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'SUFIXH: ERROR COPYING TABLES TO OUTPUT UV'
         CALL MSGWRT (6)
         END IF
      IF (.NOT.OLDSRC) CALL SUPDAT (DISKO, NEWCNO, SNAME, SCODE,
     *   NEWRA, NEWDEC, NEWNUM, IERR)
C                                       Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRBUF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SUFIXH: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1100 FORMAT (A6,'NEWNAME = ''',A,'''  / new source name')
 1101 FORMAT (A6,'NEWCODE = ''',A,'''',12X,'  / new source calcode')
 1102 FORMAT (A6,'NEWNUM  = ',I5,12X,'  / new source number')
 1103 FORMAT (A6,'NEWCOORD= ',I2.2,':',I2.2,':',F6.3,1X,A1,I2.2,':',
     *   I2.2,':',F5.2,'  / new source coordinates')
 1110 FORMAT (A6,'NEWNUM  = ',I5,12X,'  / old source number matched')
      END
      SUBROUTINE SUFIXS (NUMVIS, T, S, IRET)
C-----------------------------------------------------------------------
C   Fixes source number if T in specified ranges
C   Inputs:
C      NUMVIS   I       Visibility number
C      T        R       Time in days since 0 IAT on the first day for
C                       which there is data
C      S        R       Source number
C   From Common:
C      TB       R(30)   Start times
C      TE       R(30)   End times
C      NTIMES   I       Number valid times in TB, TE
C      NEWNUM   I       New source number
C   Output:
C      S         R      Source number
C      IRET      I      Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IRET
      REAL      T, S
C
      INTEGER   I
      INCLUDE 'SUFIX.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.GT.0) THEN
         DO 10 I = 1,NTIMES
            IF ((T.GE.TB(I)) .AND. (T.LE.TE(I))) THEN
               S = NEWNUM
               GO TO 999
               END IF
 10         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE SUCHEK (SNAME, SCODE, SRA, SDEC, DISK, CNO, NEWNUM,
     *   IERR)
C-----------------------------------------------------------------------
C   SUCHEK looks through the source table and finds the highest source
C   number within the table.  It also checks that SNAME does not occur
C   in the table.  If it does it will alter SNAME to avoid a conflict.
C   Inputs:
C      DISK     I      Disk volume number
C      CNO      I      Catalog number
C   In/Out
C      SNAME    C*16   Source name
C   Output:
C      NEWNUM   I      New source number to use
C      IERR     I      Error code
C-----------------------------------------------------------------------
      CHARACTER SNAME*(*), SCODE*(*)
      DOUBLE PRECISION SRA, SDEC
      INTEGER   DISK, CNO, NEWNUM, IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   SUBUFF(512), VER, LUN, NUMIF, FREQID, ISURNO, NREC,
     *   SUKOLS(MAXSUC), SUNUMV(MAXSUC), JTRIM, IREC, NFIX, IDSOU,
     *   QUAL
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4, EHEX*36
      REAL      FLUX(4,MAXIF)
      DOUBLE PRECISION DEPS, FREQO(MAXIF), BANDW, RAEPO, DECEPO, RAAPP,
     *   DECAPP, LSRVEL(MAXIF), LRESTF(MAXIF), PMRA, PMDEC, EPOCH,
     *   RAOBS, DECOBS
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA EHEX /'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
C-----------------------------------------------------------------------
      DEPS = 0.1D0 / 3600.0D0
      VER = 1
      LUN = 28
      CALL SOUINI ('READ', SUBUFF, DISK, CNO, VER, CATBLK, LUN, NUMIF,
     *   VELTYP, VELDEF, FREQID, ISURNO, SUKOLS, SUNUMV, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING INPUT SU TABLE'
         GO TO 990
         END IF
      NREC = SUBUFF(5)
      NFIX = 0
      IREC = JTRIM (SNAME)
      IF (SNAME.EQ.' ') SNAME = 'NEW SOURCE'
C                                       read SU table
 10   NEWNUM = 0
      DO 30 IREC = 1,NREC
         ISURNO = IREC
         CALL TABSOU ('READ', SUBUFF, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF, PMRA,
     *      PMDEC, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READING INPUT SU TABLE'
            GO TO 990
            END IF
         NEWNUM = MAX (NEWNUM, IDSOU)
         IF (SNAME.EQ.SOUNAM) THEN
            IF ((SCODE.EQ.CALCOD) .AND. (ABS(SRA-RAEPO).LE.DEPS) .AND.
     *         (ABS(SDEC-DECEPO).LE.DEPS)) THEN
               NEWNUM = -IDSOU
               WRITE (MSGTXT,1010) IDSOU
               CALL MSGWRT (5)
               GO TO 40
               END IF
            WRITE (MSGTXT,1011) SNAME, SOUNAM
            CALL MSGWRT (7)
            NFIX = NFIX + 1
            IF (NFIX.LT.37) THEN
               SNAME(16:16) = EHEX(NFIX:NFIX)
               GO TO 10
            ELSE
               MSGTXT = 'RENAMING HAS FAILED - QUITTING'
               IERR = 10
               GO TO 990
               END IF
            END IF
 30      CONTINUE
C                                       a new number
      NEWNUM = NEWNUM + 1
      WRITE (MSGTXT,1030) NEWNUM
      CALL MSGWRT (3)
C                                       close table
 40   CALL TABSOU ('CLOS', SUBUFF, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *   SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *   EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF, PMRA,
     *   PMDEC, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING INPUT SU TABLE'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SUCHEK ERROR',I4,' ON ',A)
 1010 FORMAT ('Requested source matches number',I4,
     *   '; will use that one')
 1011 FORMAT ('REQUESTED NAME ''',A,''' MATCHES EXISTING ''',A,'''')
 1030 FORMAT ('Using new source number',I4)
      END
      SUBROUTINE SUPDAT (DISK, CNO, SNAME, SCODE, NEWRA, NEWDEC, NEWNUM,
     *   IERR)
C-----------------------------------------------------------------------
C   SUCHEK looks through the source table and finds the highest source
C   number within the table.  It also checks that SNAME does not occur
C   in the table.  If it does it will alter SNAME to avoid a conflict.
C   Inputs:
C      DISK     I      Disk volume number
C      CNO      I      Catalog number
C      SNAME    C*16   Source name
C      SCODE    C*4    New source calcode
C      NEWRA    D      New source RA
C      NEWDEC   D      New source Dec
C      NEWNUM   I      New source number to use
C   Output:
C      IERR     I      Error code
C-----------------------------------------------------------------------
      CHARACTER SNAME*(*), SCODE*(*)
      INTEGER   DISK, CNO, NEWNUM, IERR
      DOUBLE PRECISION NEWRA, NEWDEC
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   SUBUFF(512), VER, LUN, NUMIF, FREQID, ISURNO, NREC,
     *   SUKOLS(MAXSUC), SUNUMV(MAXSUC), IDSOU, QUAL
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4
      REAL      FLUX(4,MAXIF)
      DOUBLE PRECISION FREQO(MAXIF), BANDW, RAEPO, DECEPO, RAAPP,
     *   DECAPP, LSRVEL(MAXIF), LRESTF(MAXIF), PMRA, PMDEC, EPOCH,
     *   RAOBS, DECOBS
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      VER = 1
      LUN = 28
      CALL SOUINI ('WRIT', SUBUFF, DISK, CNO, VER, CATBLK, LUN, NUMIF,
     *   VELTYP, VELDEF, FREQID, ISURNO, SUKOLS, SUNUMV, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING OUTPUT SU TABLE'
         GO TO 990
         END IF
      NREC = SUBUFF(5)
      ISURNO = NREC + 1
      IDSOU = NEWNUM
      SOUNAM = SNAME
      QUAL = 0
      CALCOD = SCODE
      CALL RFILL (4*NUMIF, 0.0, FLUX)
      CALL DFILL (NUMIF, 0.0D0, FREQO)
      BANDW = 0.0D0
      RAEPO = NEWRA
      DECEPO = NEWDEC
      RAAPP = 0.0D0
      DECAPP = 0.0D0
      EPOCH = CATR(KREPO)
      CALL DFILL (NUMIF, 0.0D0, LSRVEL)
      CALL DFILL (NUMIF, 0.0D0, LRESTF)
      PMRA = 0.0D0
      PMDEC = 0.0
      RAOBS = RAEPO
      DECOBS = DECEPO
      CALL TABSOU ('WRIT', SUBUFF, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *   SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *   EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF, PMRA,
     *   PMDEC, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'WRITING OUTPUT SU TABLE'
         GO TO 990
         END IF
      CALL TABSOU ('CLOS', SUBUFF, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *   SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *   EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF, PMRA,
     *   PMDEC, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING OUTPUT SU TABLE'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SUPDAT ERROR',I4,' ON ',A)
      END

      PROGRAM PLCUB
C-----------------------------------------------------------------------
C! Plots intensity vs x for a grid in y and z.
C# Plot-appl Map Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2002-2003, 2009, 2012, 2014-2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Plots intensity as a function of the variable along the first axis
C   in panels, which are positioned according to the coordinate values
C   along axes # 2 and # 3.
C      Adverb    in program     description
C      USERID       USER        USER ID. ignored
C      INNAME        NAM        Image name (name)
C      INCLASS       CLS        Image name (class)
C      INSEQ        SQIN        Image name (seq. #)
C      INDISK       DKIN        Disk drive #
C      BLC           BLC        Bottom left corner image. 0=> all
C      TRC           TRC        Top right corner image.   0=> all
C      LTYPE        TYPE        Type of labeling. See PLCUB.HLP
C      APARM       APARM        Plotting parameters:
C                               (1) Number panels in x direction
C                               (2) Number panels in y direction
C                               (3) label type for panels
C                               (4) y value (map units) for x panel axis
C                               (5) x value (x units) for y panel axis
C                               (6) No. of points in Hanning smooth of
C                                   x-axis.   <=3 ==> no smooth, must be
C                                   odd integer.
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C-----------------------------------------------------------------------
C                                    max. no of points in Hanning smooth
C                                    kernel, MUST be odd
      INTEGER MAXCO
      PARAMETER (MAXCO = 15)
      INCLUDE 'INCS:PMAD.INC'
C
      CHARACTER PHNM*48, TEXT(2)*80, MTYPE*2, NAM*12, CLS*6, PGMNAM*6,
     *   STAT*4
      HOLLERITH XNAM(3), XCLS(2)
      INTEGER   VOL, SEQ, USR, LUN, IND, CNR, CATBLK(256), SCR(256),
     *   IER, NAX, PAX(7), DPT(5), BOF, WIN(4), GFIND, IBF(MABFSS), NBF,
     *   JTOT, KTOT, JP, KP, JPAG, KPAG, NPARM, IRET, IT, JT, KT,
     *   LABEL, VER, GLUN, LTP, I, NTEXT, KI, JI, IROUND, IYINC, IZINC,
     *   IPTYPE, IERR, NSMTH, GRCHN, TVCHN, TVCORN(4), PLTYPE
      REAL      CATR(256), RBF(MABFSS), USER, SQIN, DKIN, BLC(7),
     *   TRC(7), LP(2), RP(2), CHOUT(4), TYPE, AMX, AMN, APARM(10),
     *   LC(7), RC(7), UNITY, ARR(MAXIMG+8), YINC, ZINC, PIXR(2),
     *   RANGE(2), MBLC(7), MTRC(7), XTRA1, XTRA2, XTRA3, XTRA4, YGAP,
     *   ZOFF, ARRS(MAXIMG+8), COEFFS(MAXCO), XDOTV, XGRCH
      DOUBLE PRECISION    CATD(128), YX, XY
      LOGICAL   T, F, DONCR, SLICE, FBL, DOTV, FRLABL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DGPH.INC'
      COMMON /MAPHDR/ CATBLK
      COMMON /INPARM/ USER, XNAM, XCLS, SQIN, DKIN, BLC, TRC, YINC,
     *   ZINC, PIXR, TYPE, APARM, XDOTV, XGRCH
      EQUIVALENCE (CATBLK, CATR, CATD)
      EQUIVALENCE (IBF(1), RBF(1))
      DATA UNITY /1./
      DATA T, F /.TRUE.,.FALSE./
      DATA PGMNAM / 'PLCUB '/
      DATA LUN /16/
C-----------------------------------------------------------------------
C                                        fill common IDCH
C                                        enter parameter values
      DONCR = F
      NPARM = 39
      CALL SETUP (PGMNAM, NPARM, USER, SCR, IRET)
      IF (IRET.NE.0) GO TO 990
      IRET = 8
      NBF = MABFSS * 2
C                                        interpret input
      CALL H2CHR (12, 1, XNAM, NAM)
      CALL H2CHR (6, 1, XCLS, CLS)
      SEQ  = SQIN + 0.01
      VOL  = DKIN + 0.01
      USER = NLUSER
      USR  = NLUSER
      LTP  = IROUND (TYPE)
      I = MOD (ABS(LTP), 100)
      IF ((I.EQ.0) .OR. (I.GT.10)) THEN
         IF (LTP.LT.0) THEN
            LTP = (LTP/100) * 100 - 3
         ELSE
            LTP = (LTP/100)*100 + 3
            END IF
         END IF
      TYPE = LTP
      JTOT = APARM(1) + 0.01
      KTOT = APARM(2) + 0.01
      IYINC = YINC + 0.01
      IF (IYINC.LE.0) IYINC = 1
      YINC = IYINC
      IZINC = ZINC + 0.01
      IF (IZINC.LE.0) IZINC = 1
      ZINC = IZINC
      LABEL = IROUND (APARM(3))
      I = MOD (ABS(LABEL), 100)
      FRLABL = I.LT.11
      IF ((I.EQ.0) .OR. (I.GT.10)) LABEL = LTP
      APARM(3) = LABEL
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
C                                        generate Hanning smooth coeffs
      NSMTH = IROUND (APARM(6))
      IF (NSMTH.LE.2) THEN
        NSMTH = 1
      ELSE IF (NSMTH.GT.MAXCO) THEN
        NSMTH = MAXCO
        WRITE (MSGTXT,400) NSMTH
        CALL MSGWRT (8)
      ELSE IF (MOD(NSMTH,2).EQ.0) THEN
        NSMTH = NSMTH + 1
        WRITE (MSGTXT,500) NSMTH
        CALL MSGWRT (8)
        END IF
      IF (NSMTH.GE.3) CALL HCOEFF (NSMTH, COEFFS)
C                                        open map for read
      MTYPE = 'MA'
      STAT = 'HDWR'
      IF (DOTV) STAT = 'READ'
      CALL MAPOPN (STAT, VOL, NAM, CLS, SEQ, MTYPE, USR, LUN, IND,
     *   CNR, CATBLK, SCR, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1000) IER
         CALL MSGWRT (8)
         GO TO 990
         END IF
      NCFILE = 1
      FVOL(1) = VOL
      FCNO(1) = CNR
      FRW(1) = 1
      IF (DOTV) FRW(1) = 0
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IER)
      IF (IER.NE.0) GO TO 990
      SQIN = SEQ
      DKIN = VOL
      CALL RNGSET (PIXR, CATR(KRDMX), CATR(KRDMN), RANGE)
      PIXR(1) = RANGE(1)
      AMN = PIXR(1)
      PIXR(2) = RANGE(2)
      AMX = PIXR(2)
C                                        interpret header contents
      NAX = CATBLK(KIDIM)
C                                        fill some arrays
      DO 15 I = 1,NAX
         PAX(I) = CATBLK(KINAX+I-1)
 15      CONTINUE
      DO 20 I = 3,7
         DPT(I-2) = BLC(I)
 20      CONTINUE
C                                       I/O windows
      WIN(1) = BLC(1) + 0.001
      WIN(2) = BLC(2) + 0.001
      WIN(3) = TRC(1) + 0.001
      WIN(4) = TRC(2) + 0.001
C                                       total # panels in x, y
      KT = TRC(3) - BLC(3) + 1.001
      JT = TRC(2) - BLC(2) + 1.001
      IT = TRC(1) - BLC(1) + 1.001
      KT = (KT - 1) / IZINC + 1
      TRC(3) = BLC(3) + (KT - 1) * IZINC
      JT = (JT - 1) / IYINC + 1
      TRC(2) = BLC(2) + (JT - 1) * IYINC
C                                       # panels/page in x, y
      IF (JTOT.LE.0) JTOT = MIN (5, JT)
      IF (KTOT.LE.0) KTOT = JTOT
      JTOT = MIN (JTOT, JT)
      KTOT = MIN (KTOT, KT)
      APARM(1) = JTOT
      APARM(2) = KTOT
C                                        # pages in x, y
      JPAG = (JT - 1) / JTOT + 1
      KPAG = (KT - 1) / KTOT + 1
C                                        y-value x-axis
      YX = APARM(4)
      XY = APARM(5)
      IF (AMX.LT.YX) AMX = YX
      IF (AMN.GT.YX) AMN = YX
      CALL RCOPY (7, BLC, MBLC)
      CALL RCOPY (7, TRC, MTRC)
      ZOFF = ((YX - AMN) / (AMX - AMN)) * 0.9 * IZINC
      XTRA1 = 0.035 * JTOT * IYINC
      XTRA2 = 0.035 * KTOT * IZINC + ZOFF
      XTRA3 = (0.9 + 0.035 * JTOT) * IYINC
      XTRA4 = (0.9 + 0.035 * KTOT) * IZINC - ZOFF
      PLTYPE = MOD (ABS(LABEL), 100)
      IF (PLTYPE.EQ.2) THEN
         XTRA1 = XTRA1 + 0.0405 * JTOT * IYINC
         XTRA2 = XTRA2 + 0.0405 * KTOT * IZINC
      ELSE IF (PLTYPE.GT.2) THEN
         XTRA1 = XTRA1 + 0.0810 * JTOT * IYINC
         XTRA2 = XTRA2 + 0.0405 * KTOT * IZINC
         END IF
C                                        end of general initialization
C                                        start individual pages of plots
      DO 230 KP = 1,KPAG
C
         LC(3) = MBLC(3) + (KP-1) * KTOT * IZINC
         RC(3) = LC(3) + (KTOT - 1) * IZINC
         IF (RC(3).GT.MTRC(3)) LC(3) = LC(3) - RC(3) + MTRC(3)
         IF (RC(3).GT.MTRC(3)) RC(3) = MTRC(3)
         KT = RC(3) - LC(3) + 1.001
C
         DO 220 JP = 1,JPAG
C
            LC(2) = MBLC(2) + (JP-1) * JTOT * IYINC
            RC(2) = LC(2) + (JTOT - 1) * IYINC
            IF (RC(2).GT.MTRC(2)) LC(2) = LC(2) - RC(2) + MTRC(2)
            IF (RC(2).GT.MTRC(2)) RC(2) = MTRC(2)
            JT = RC(2) - LC(2) + 1.001
            WIN(2) = LC(2) + 0.001
            WIN(4) = RC(2) + 0.001
C                                       actual plot corners
            BLC(1) = WIN(2) - XTRA1
            BLC(2) = LC(3) - XTRA2
            TRC(1) = WIN(4) + XTRA3
            TRC(2) = RC(3) + XTRA4
C                                       avoid single pixel
 101        GPHIX1 = BLC(1) + 0.999
            GPHIX2 = TRC(1) + 0.001
            IF (GPHIX1.EQ.GPHIX2) THEN
               BLC(1) = BLC(1) - 0.1
               TRC(1) = TRC(1) + 0.1
               GO TO 101
               END IF
 102        GPHIY1 = BLC(2) + 0.999
            GPHIY2 = TRC(2) + 0.001
            IF (GPHIY1.EQ.GPHIY2) THEN
               BLC(2) = BLC(2) - 0.1
               TRC(2) = TRC(2) + 0.1
               GO TO 102
               END IF
            BLC(3) = MBLC(1)
            TRC(3) = MTRC(1)
C                                       add plot file to header
            VER = 0
            IF (.NOT.DOTV) THEN
               CALL MADDEX ('PL', VOL, CNR, CATBLK, SCR, T, 'WRIT', VER,
     *            IER)
               IF (IER.NE.0) THEN
                  WRITE (MSGTXT,1100) IER
                  CALL MSGWRT (6)
                  NCFILE = 0
                  GO TO 990
                  END IF
               END IF
C                                        physical plot file name
            CALL ZPHFIL ('PL', VOL, CNR, VER, PHNM, IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,1110) IER
               CALL MSGWRT (5)
               GO TO 990
               END IF
C                                       swap axes
            CALL CYCPER
C                                       set labeling for page
            SLICE = .FALSE.
            CALL RFILL (4, 0.0, CHOUT)
            DPT(1) = (MTRC(1) + MBLC(1)) / 2.0
            LOCNUM = 1
            CALL LABINI (BLC, TRC, DPT, CHOUT, LTP, SLICE, YGAP, TEXT,
     *         NTEXT)
C                                       open plot file
            IPTYPE = 13
            CALL GINIT (VOL, CNR, PHNM, 0, IPTYPE, NPARM, USER, DOTV,
     *         TVCHN, GRCHN, TVCORN, CATBLK, SCR, GLUN, GFIND, IER)
            DONCR = IER.EQ.0
            IF (IER.EQ.0) CALL GINITL (BLC, TRC, UNITY, CHOUT, DPT, SCR,
     *         IER)
            IF (IER.EQ.0) CALL GLTYPE (1, SCR, IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,1140) IER
               CALL MSGWRT (5)
               GO TO 980
               END IF
C                                       label page plot
            CALL LAB (BLC, TRC, LTP, TEXT, NTEXT, VER, CHOUT, YGAP,
     *         SCR, IER)
C                                       put axes back
            CALL CYCPER
            CALL CYCPER
C                                       go along third axis
            DO 170 KI = 1,KT,IZINC
               DPT(1) = LC(3) + (KI - 1)
               CALL COMOFF (NAX, PAX, DPT, BOF, IER)
               BOF = BOF + 1
               CALL MINIT ('READ', LUN, IND, PAX(1), PAX(2), WIN, IBF,
     *            NBF, BOF, IER)
               IF (IER.NE.0) GO TO 980
C                                        handle one plane
               LP(2) = LC(3) + (KI - 1) - ZOFF
               RP(2) = LP(2) + 0.9 * IZINC
               DO 160 JI = 1,JT
C                                       read one line
                  CALL LINIO ('READ', LUN, IND, RBF, IT, ARR, 1, FBLANK,
     *                IER)
                  IF (IER.NE.0) GO TO 980
                  IF (MOD(JI-1,IYINC).NE.0) GO TO 160
                  LP(1) = LC(2) + (JI - 1)
                  RP(1) = LP(1) + 0.9 * IYINC
C                                       ticks, axes current panel
                  IF (FRLABL) THEN
                     CALL FRAM (LP, RP, ZOFF, PIXR, MBLC, MTRC, JI, KI,
     *                  LABEL, YX, XY, SCR, IER)
                     IF (IER.NE.0) GO TO 980
                     END IF
C                                       Optionally smooth and plot data
                  IF (NSMTH.GE.3) CALL HANNSM (NSMTH, COEFFS, IT, ARR,
     *                                         ARRS, FBL)
                  IF ( (NSMTH.GE.3) .AND. (.NOT.FBL)) THEN
                     CALL PAR (LP, RP, IT, PIXR, ARRS, FBLANK, SCR, IER)
                  ELSE
                     CALL PAR (LP, RP, IT, PIXR, ARR, FBLANK, SCR, IER)
                     END IF
                  IF (IER.NE.0) THEN
                     WRITE (MSGTXT,1160) IER
                     CALL MSGWRT (5)
                     GO TO 980
                     END IF
 160              CONTINUE
C                                       go to next plane
 170           CONTINUE
C                                       close down this plot
            GPHPAG = (JP.LT.JPAG) .OR. (KP.LT.KPAG)
            CALL GFINIS (SCR, IER)
            IF (IER.LT.0) GO TO 240
            IF (IER.EQ.0) GO TO 210
               WRITE (MSGTXT,1200) IER
               CALL MSGWRT (5)
               GO TO 980
 210        IF (.NOT.DOTV) THEN
               WRITE (MSGTXT,1210) VER
               CALL MSGWRT (2)
               CALL HIPLOT (FVOL(1), FCNO(1), VER, SCR, IERR)
               END IF
            DONCR = .FALSE.
C
 220        CONTINUE
 230     CONTINUE
C                                       finished with cube
 240  IRET = 0
      GO TO 990
C                                       error
 980  IF ((DONCR) .AND. (.NOT.DOTV)) THEN
         CALL DELEXT ('PL', FVOL(1), FCNO(1), 'WRIT', CATBLK, SCR, VER,
     *      IER)
         CALL ZCLOSE (GLUN, GFIND, IER)
         CALL ZDESTR (VOL, PHNM, IER)
         NCFILE = NCFILE - 1
         END IF
C
 990  CALL DIE (IRET, SCR)
 999  STOP
C-----------------------------------------------------------------------
 400  FORMAT ('DECREASING HANNING SMOOTHING LENGTH TO MAXIMUM = ', I3)
 500  FORMAT ('INCREASING HANNING SMOOTHING LENGTH TO ', I3)
 1000 FORMAT ('MAPOPN: ERROR # ',I5)
 1100 FORMAT ('MADDEX: ERROR # ',I5)
 1110 FORMAT ('ZPHFIL: ERROR # ',I5)
 1140 FORMAT ('GINITL: ERROR # ',I5)
 1160 FORMAT ('PLOT X: ERROR # ',I5)
 1210 FORMAT ('Created PLot file version',I4)
 1200 FORMAT ('GFINIS: ERROR # ',I5)
      END
      SUBROUTINE LAB (BLC, TRC, ILTYPE, TEXT, NTEXT, IVER, CH, YGAP,
     *   IBUFF, IERR)
C-----------------------------------------------------------------------
C   LAB is a labeling routine, labeling the x- and y-axes either with
C   the coordinate designator or with the appropriate units + prefix.
C   Inputs:  BLC      R(2)   X and Y pixels to form bottom left hand
C                     corner of the graph.
C            TRC      R(2)   X and Y pixels to form the top right hand
C                     corner of the graph.
C            LTYPE    I   label type: 1 none, 2 no ticks, 3 RA/DEC
C                         4 center relative
C            TEXT     C(2)*80    lower line text
C            NTEXT    I          number lines lower text
C            IVER     I          plot file version number
C   In/out:  YGAP     R          place to put lower lines
C            IBUFF    I(256)   the updated graphics output buffer.
C            IERR     I   error indicator:
C                         0 = No error.
C-----------------------------------------------------------------------
      CHARACTER TEXT(2)*80, ATIME*8, ADATE*12, CHTM18*18
      HOLLERITH CATH(256)
      INTEGER   ILTYPE, IBUFF(256), IERR, NTEXT, IVER, ITCHAR
      REAL      BLC(2), TRC(2), YGAP, CH(4), CATR(256)
      REAL      DCX, DCY, UNITY
      INTEGER   ID(3), IT(3), I, IANGL, INCHAR, LTYPE, CATBLK(256)
      DOUBLE PRECISION    CATD(128)
      LOGICAL   F
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      DATA UNITY /1.0/
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      LTYPE = MOD (ABS (ILTYPE), 100)
C                                       Draw borders.
      CALL GPOS (BLC(1), BLC(2), IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL GVEC (TRC(1), BLC(2), IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL GVEC (TRC(1), TRC(2), IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL GVEC (BLC(1), TRC(2), IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL GVEC (BLC(1), BLC(2), IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      IF (LTYPE.EQ.1) GO TO 999
C                                       Axis labels, ticks
      CALL CLAB1 (BLC, TRC, CH, ILTYPE, UNITY, F, IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Extra lines (center rels)
      IF ((NTEXT.GT.0) .AND. (LTYPE.LT.7)) THEN
         DCX = 0.0
         IANGL = 0
         DO 10 I = 1,NTEXT
            CALL GPOS (BLC(1), BLC(2), IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
            DCY = -YGAP
            CALL CHTRIM (TEXT(I), 80, TEXT(I), INCHAR)
            CALL GCHAR (INCHAR, IANGL, DCX, DCY, TEXT(I), IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
            YGAP = YGAP + 1.333
 10         CONTINUE
         END IF
C                                       Source name, stokes, freq.
      IF (LTYPE.LT.7) THEN
         CALL GPOS (BLC(1), TRC(2), IBUFF, IERR)
         IF (IERR.NE.0) GO TO 980
         DCX = 0.0
         DCY = 0.5
         IANGL = 0
         CALL H2CHR (8, 1, CATH(KHOBJ), TEXT(1))
         INCHAR = 11
         IF (TEXT(1).EQ.' ') INCHAR = 1
         IF (NCHLAB(1,LOCNUM).GT.0) THEN
            IF (INCHAR.GT.1) TEXT(1)(INCHAR-1:INCHAR-1) = '_'
            TEXT(1)(INCHAR:) = SAXLAB(1,LOCNUM)(1:NCHLAB(1,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(1,LOCNUM)
            END IF
         IF (NCHLAB(2,LOCNUM).GT.0) THEN
            IF (INCHAR.GT.1) TEXT(1)(INCHAR-1:INCHAR-1) = '_'
            TEXT(1)(INCHAR:) = SAXLAB(2,LOCNUM)(1:NCHLAB(2,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(2,LOCNUM)
            END IF
C                                       image name
         IF (INCHAR.GT.1) TEXT(1)(INCHAR-1:INCHAR-1) = '_'
         CALL H2CHR (12, KHIMNO, CATH(KHIMN), CHTM18(1:12))
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), CHTM18(13:18))
         ITCHAR = INCHAR
         CALL NAMEST (CHTM18, CATBLK(KIIMS), TEXT(1)(INCHAR:), ITCHAR)
         CALL REFRMT (TEXT(1), '_', INCHAR)
         CALL GCHAR (INCHAR, IANGL, DCX, DCY, TEXT(1), IBUFF, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Date/time version
         IF (ILTYPE.GT.1) THEN
            CALL GPOS (BLC(1), TRC(2), IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
            DCY = DCY + 1.333
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (TEXT(1),1020) IVER, ADATE, ATIME
            CALL REFRMT (TEXT(1), '_', INCHAR)
            CALL GCHAR (INCHAR, IANGL, DCX, DCY, TEXT(1), IBUFF, IERR)
            END IF
         END IF
      IF (IERR.EQ.0) GO TO 999
C                                       Graph drawing error.
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('PLot file version',I4,'__created ',A12,A8)
 1980 FORMAT ('GRAPH LABEL WRITING ERROR. IERR =',I5)
      END
      SUBROUTINE FRAM (LBLC, LTRC, ZOFF, PIXR, MBLC, MTRC, JI, KI,
     *   LABEL, YX, XY, IBUFF, IERR)
C-----------------------------------------------------------------------
C   FRAM writes tick marks and tick labels to a plot file: 1 panel
C   Inputs: LBLC  R(2)     X AND Y pixels to form bottom left hand
C                          corner of the panel
C           LTRC  R(2)     X and Y pixels to form the top right hand
C                          corner of the panel.
C           ZOFF  R        offset in pixels to horiz axis
C           PIXR  R(2)     intensity range
C           MBLC  R(7)     map BLC
C           MTRC  R(7)     map TRC
C           JI    I        column number (left = 1)
C           KI    I        row number  (bottom = 1)
C           LABEL I        requested label type (revised as needed)
C           YX    D        y-value x-axis
C           XY    D        X-value Y-axis
C   In/out: IBUFF I(256)   buffer being used for output to
C                          the graphics file.
C   Output: IERR  I        error code: 0 => ok
C                             2 => graph drawing error
C                             3 => tic algorithm fails
C-----------------------------------------------------------------------
      CHARACTER TEXT(2)*80, PREFIX(11)*5
      DOUBLE PRECISION    YX, XY, AXY, FQFREQ
      REAL      LBLC(2), LTRC(2), ZOFF, PIXR(2), MBLC(7), MTRC(7)
      INTEGER   JI, KI, LABEL, IBUFF(256), IERR
      INTEGER   IDROP(2), INOSL, IDEPTH(5), NTEXT, I, J
      REAL      Y, PBLC(2), PTRC(2), XBLC(7), XTRC(7), YGAP, CH(4),
     *   UNITY, FQFINC
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA UNITY /1.0/
      DATA PREFIX /'FEMTO', 'ATO  ', 'PICO ', 'NANO ', 'MICRO','MILLI',
     *   '     ', 'KILO ', 'MEGA ', 'GIGA ', 'TERA '/
C-----------------------------------------------------------------------
C                                       set up label common: slice
      IDROP(1) = 0
      IDROP(2) = 0
      INOSL = MTRC(1) - MBLC(1) + 1.001
      CALL RCOPY (7, MBLC, XBLC)
      CALL RCOPY (7, MBLC, XTRC)
      XTRC(1) = MTRC(1)
      XBLC(2) = LBLC(1)
      XTRC(2) = LBLC(1)
      XBLC(3) = LBLC(2)
      XTRC(3) = LBLC(2)
      PBLC(2) = LBLC(2)
      PTRC(2) = LTRC(2)
      LOCNUM = 1
      FQFREQ = 0.0D0
      FQFINC = 0.0
      CALL SLBINI (IDROP, INOSL, PIXR, PBLC, PTRC, XBLC, XTRC, FQFREQ,
     *   FQFINC, IDEPTH, LABEL, YGAP, CH, TEXT, NTEXT)
      CALL GLTYPE (1, IBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       bugger x axis
      AXINC(1,LOCNUM) = AXINC(1,LOCNUM) * (PTRC(1) - PBLC(1)) / (LTRC(1)
     *   - LBLC(1))
      PTRC(1) = LTRC(1)
      PBLC(1) = LBLC(1)
      RPLOC(1,LOCNUM) = (LTRC(1) + LBLC(1)) / 2.0
      AXY = XY
      IF (CPREF(1,LOCNUM).NE.' ') THEN
         J = 0
         DO 10 I = 1,11
            IF (CPREF(1,LOCNUM).EQ.PREFIX(I)) J = I
 10         CONTINUE
         IF (J.GT.0) AXY = AXY * (1000.0D0 ** (7-J))
         END IF
      IF ((JI.NE.1) .OR. (KI.NE.1)) THEN
         CPREF(1,LOCNUM) = ' '
         CTYP(1,LOCNUM) = ' '
         CPREF(2,LOCNUM) = ' '
         CTYP(2,LOCNUM) = ' '
         END IF
      CALL CLAB2 (PBLC, PTRC, CH, LABEL, UNITY, YX, AXY, IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       draw 2 axis lines
      Y = LBLC(1)
      IF (AXINC(1,LOCNUM).NE.0) Y = (AXY - RPVAL(1,LOCNUM)) /
     *   AXINC(1,LOCNUM) + RPLOC(1,LOCNUM)
      IF ((Y.LT.LBLC(1)) .OR. (Y.GT.LTRC(1))) Y = LBLC(1)
      CALL GPOS (Y, LBLC(2), IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL GVEC (Y, LTRC(2), IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      Y = LBLC(2) + ZOFF
      CALL GPOS (LBLC(1), Y, IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL GVEC (LTRC(1), Y, IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      GO TO 999
C                                       error
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('FRAM: PLOT ERROR',I6)
      END
      SUBROUTINE PAR (LBLC, LTRC, IT, PIXR, ARR, BL, IBUFF, IERR)
C-----------------------------------------------------------------------
C   PAR plots the row.
C-----------------------------------------------------------------------
      INTEGER   IT, IBUFF(256), IERR, I
      REAL      LBLC(2), LTRC(2), ARR(*), XP, YP, XPX, YPX, BL, PIXR(2),
     *   XS, YS
      LOGICAL   DOWN
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Clipping on intensities
      DO 10 I = 1,IT
         IF (ARR(I).NE.BL) ARR(I) = MAX (PIXR(1), MIN (PIXR(2),
     *      ARR(I)))
 10      CONTINUE
C                                       map pixels=>plot pixels
      XS = (LTRC(1) - LBLC(1)) / (IT - 1)
      XP = LBLC(1)
      YS = (LTRC(2) - LBLC(2)) / (PIXR(2) - PIXR(1))
      YP = LBLC(2)
C
      DOWN = .FALSE.
C
      CALL GLTYPE (2, IBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      DO 30 I = 1,IT
         IF (ARR(I).EQ.BL) THEN
            DOWN = .FALSE.
         ELSE
            XPX = XS * (I-1) + XP
            YPX = YS * (ARR(I)-PIXR(1)) + YP
            IF (DOWN) THEN
               CALL GVEC (XPX, YPX, IBUFF, IERR)
            ELSE
               CALL GPOS (XPX, YPX, IBUFF, IERR)
               END IF
            IF (IERR.NE.0) GO TO 999
            DOWN = .TRUE.
            END IF
 30      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE CYCPER
C-----------------------------------------------------------------------
C   Performs cyclic permutation of header elements pertaining to
C   axes # 1, 2, AND 3.
C-----------------------------------------------------------------------
      INTEGER   CATBLK(256), ITEM(4)
      REAL      CATR(256), RTEM(2)
      HOLLERITH CATH(256), HTEMP(2)
      DOUBLE PRECISION CATD(128), DTEM
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK, CATH, CATR, CATD)
      EQUIVALENCE (DTEM, RTEM(1), ITEM(1))
C-----------------------------------------------------------------------
C                                        random parameter types
      HTEMP(1) = CATH(KHPTP)
      HTEMP(2) = CATH(KHPTP+1)
      CATH(KHPTP) = CATH(KHPTP+2)
      CATH(KHPTP+1) = CATH(KHPTP+3)
      CATH(KHPTP+2) = CATH(KHPTP+4)
      CATH(KHPTP+3) = CATH(KHPTP+5)
      CATH(KHPTP+4) = HTEMP(1)
      CATH(KHPTP+5) = HTEMP(2)
C                                        coordinate type
      HTEMP(1) = CATH(KHCTP)
      HTEMP(2) = CATH(KHCTP+1)
      CATH(KHCTP) = CATH(KHCTP+2)
      CATH(KHCTP+1) = CATH(KHCTP+3)
      CATH(KHCTP+2) = CATH(KHCTP+4)
      CATH(KHCTP+3) = CATH(KHCTP+5)
      CATH(KHCTP+4) = HTEMP(1)
      CATH(KHCTP+5) = HTEMP(2)
C                                        coord. value ref. pixel
      DTEM         = CATD(KDCRV)
      CATD(KDCRV)   = CATD(KDCRV+1)
      CATD(KDCRV+1) = CATD(KDCRV+2)
      CATD(KDCRV+2) = DTEM
C                                        coord. value incr. along axis
      RTEM(1)      = CATR(KRCIC)
      CATR(KRCIC)   = CATR(KRCIC+1)
      CATR(KRCIC+1) = CATR(KRCIC+2)
      CATR(KRCIC+2) = RTEM(1)
C                                        coord. ref. pixel
      RTEM(1)      = CATR(KRCRP)
      CATR(KRCRP)   = CATR(KRCRP+1)
      CATR(KRCRP+1) = CATR(KRCRP+2)
      CATR(KRCRP+2) = RTEM(1)
C                                        coord. rotation angles
      RTEM(1)      = CATR(KRCRT)
      CATR(KRCRT)   = CATR(KRCRT+1)
      CATR(KRCRT+1) = CATR(KRCRT+2)
      CATR(KRCRT+2) = RTEM(1)
C                                        # pixels on each axis
      ITEM(1)      = CATBLK(KINAX)
      CATBLK(KINAX)   = CATBLK(KINAX+1)
      CATBLK(KINAX+1) = CATBLK(KINAX+2)
      CATBLK(KINAX+2) = ITEM(1)
C
 999  RETURN
      END
      SUBROUTINE HCOEFF (NSMTH, COEFFS)
C-----------------------------------------------------------------------
C   Work out binomial weights or coefficients
C   Input:
C      NSMTH   I    Number of points to smooth over
C   Output:
C      COEFFS  R    Weights for data points
C-----------------------------------------------------------------------
      INTEGER NSMTH
      REAL COEFFS(NSMTH)
      INTEGER N, K, I
      REAL NFAC, NKFAC, KFAC, SUM
C-----------------------------------------------------------------------
      N = NSMTH - 1
      CALL FACT (N, NFAC)
C
      SUM = 0.0
      DO 100 I = 1, NSMTH
         K = I - 1
         CALL FACT (N-K, NKFAC)
         CALL FACT (K, KFAC)
         COEFFS(I) = NFAC / (NKFAC * KFAC)
         SUM = COEFFS(I) + SUM
 100     CONTINUE
C
      DO 200 I = 1, NSMTH
         COEFFS(I) = COEFFS(I) / SUM
 200     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE FACT (N, NFAC)
C-----------------------------------------------------------------------
C   Find n!  use real numbers so can have reasonable sized arguments
C   Input:
C      N      I     Number to find the factorial of
C   Output:
C      NFAC   R     Results
C-----------------------------------------------------------------------
      INTEGER N, I
      REAL NFAC
C-----------------------------------------------------------------------
      NFAC = 1.0
      I = N
C
      IF (I.EQ.0) THEN
         GO TO 999
      ELSE
 100     IF (I.EQ.1) THEN
            GO TO 999
         ELSE
            NFAC = I * NFAC
            I = I - 1
            END IF
         GO TO 100
         END IF
C
 999  RETURN
      END
      SUBROUTINE HANNSM (NSMTH, COEFFS, IT, ARR, ARRS, FBL)
C-----------------------------------------------------------------------
C   Hanning smooth array
C   Input:
C      NSMTH    I    Number of points to smooth over
C      COEFFS   R    Weights
C      IT       I    Number of data points
C      ARR      R    Data array
C   Output:
C      ARRS     R    Smoothed array
C      FBL      L    True if a blank was in this array, the
C                       unsmoothed data are plotted in this case.
C-----------------------------------------------------------------------
      INTEGER IT, NSMTH, IEND, I, J, K, IBL
      LOGICAL FBL
      REAL ARR(IT), ARRS(IT), COEFFS(NSMTH), SUM
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA IBL /0/
C-----------------------------------------------------------------------
      IEND = (NSMTH - 1) / 2
      FBL = .FALSE.
C
      DO 200 I = 1,IT
C                                       Don't try to handle blanks
         IF (ARR(I).EQ.FBLANK) THEN
            IF (IBL.EQ.0) THEN
               WRITE (MSGTXT,1000)
               CALL MSGWRT (8)
               IBL = 1
               END IF
            FBL = .TRUE.
            GO TO 999
            END IF
C
         SUM = 0.0
         K = 1
C                                      Make some attempt to deal with ends
         DO 100 J = I-IEND, I+IEND
            IF (J.LT.1) THEN
               SUM = SUM + COEFFS(K)*ARR(1)
            ELSE IF (J.GT.IT) THEN
               SUM = SUM + COEFFS(K)*ARR(IT)
            ELSE
               SUM = SUM + COEFFS(K)*ARR(J)
               END IF
            K = K + 1
 100        CONTINUE
         ARRS(I) = SUM
 200     CONTINUE
C
 999  RETURN
C-------------------------------------------------------------------
 1000 FORMAT ('HANNSM: WARNING, I DON''T HANDLE BLANKS, SOME
     * ROW(S) UNSMOOTHED')
      END

LOCAL INCLUDE 'UVDI1.INC'
C                                       Local include for UVDI1
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   CATIN(256), SEQIN, SEQ2IN, SEQOUT, DISKIN, DIS2IN,
     *   DISKO, NUMHIS, JBUFSZ, CAT1(256), CAT2(256), CAT3(256), NANT,
     *   ILOCWT, MTYPE, NVOUT, LUNI, LUNO, INDI, INDO, IND, CNO1, CNO2,
     *   CNOO, NRPAR1, SCRTCH(512)
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAM2I(3), XCL2IN(2), XNAMOU(3),
     *   XCLAOU(2), CATH1(256), CATH2(256), CATH3(256), CATIH(256)
      CHARACTER NAMEIN*12, CLAIN*6, NAM2IN*12, CLA2IN*6, NAMOUT*12,
     *   CLAOUT*6, HISCRD(10)*64, ONAME*48
      REAL      XSIN, XDISIN, XS2IN, XDI2IN, XSOUT, XDISO, XINC, YINC,
     *   ZINC, BUFF1(UVBFSS), BUFF2(UVBFSS), CATR1(256), CATR2(256),
     *   CATR3(256), CATIR(256)
      DOUBLE PRECISION CATD1(128), CATD2(128), CATD3(128), CATID(128)
      LOGICAL   LTB, ISCOMP
C                                       ACSIZE = size of accum. array
      INTEGER ACSIZE
      PARAMETER (ACSIZE = 2500000)
      COMMON /BUFRS/ BUFF1, BUFF2, SCRTCH, JBUFSZ
      COMMON /OLDHDR/ CATIN, LTB, NANT
      COMMON /INPTS/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAM2I, XCL2IN,
     *   XS2IN, XDI2IN, XNAMOU, XCLAOU, XSOUT, XDISO, XINC, YINC,
     *   ZINC
      COMMON /PVALS/ SEQIN, SEQ2IN, SEQOUT,  DISKIN, DIS2IN, DISKO,
     *   NUMHIS, ILOCWT, MTYPE, NVOUT, ISCOMP, LUNI, LUNO, INDI, INDO,
     *   IND, NRPAR1, CNO1, CNO2, CNOO
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAM2IN, CLA2IN, NAMOUT, CLAOUT,
     *   HISCRD, ONAME
      COMMON /MAP2HD/ CAT1, CAT2, CAT3
      EQUIVALENCE (CAT1, CATR1, CATH1, CATD1)
      EQUIVALENCE (CAT2, CATR2, CATH2, CATD2)
      EQUIVALENCE (CAT3, CATR3, CATH3, CATD3)
      EQUIVALENCE (CATIN, CATIR, CATIH, CATID)
LOCAL END
      PROGRAM UVDI1
C-----------------------------------------------------------------------
C! Subtract one time UV data from the other UV data
C# UV
C-----------------------------------------------------------------------
C;  Copyright (C) 2007-2009, 2011, 2015-2016, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVDI1 subtracts the given one time UV data from the other UV data
C   The one time UV data can be created averaging UV data by time using
C   very large averaging time at the task UVAVG.
C   UVAVG (OPCODE = 'SUBT') prepares such one time UV data and then
C   subtracts it from the original UV data.
C   UVDI1 picks up the one time UV data from somewhere.
C
C   If XINC if greater than 1, only every XINC'th group of output
C   records (eg all baselines for an average interval) will be written.
C
C   Inputs:
C   AIPS adverb  Prg. name.          Description.
C   INNAME         NAMEIN        Name of input UV data.
C   INCLASS        CLAIN         Class of input UV data.
C   INSEQ          SEQIN         Seq. of input UV data.
C   INDISK         DISKIN        Disk number of input UV data.
C   IN2NAME        NAM2IN        Name of input UV data.
C   IN2CLASS       CLA2IN        Class of input UV data.
C   INSEQ          SEQ2IN        Seq. of input UV data.
C   INDISK         DIS2IN        Disk number of input UV data.

C   OUTNAME        NAMOUT        Name of the output uv file.
C   OUTCLASS       CLAOUT        Class of the output uv file.
C   OUTSEQ         SEQOUT        Seq. number of output uv data.
C   OUTDISK        DISKO         Disk number of the output file.
C   XINC           XINC          Write only XINC'th output recs.
C   YINC           YINC          Integration time (sec) min=0.2
C   ZINC           ZINC          Input averaging time (sec)
C   UVDI1 Programmer L.R. Kogan, Jan 2007.
C-----------------------------------------------------------------------
      INTEGER   IRET
      REAL      YINCUR
      CHARACTER PRGM*6
      INCLUDE 'UVDI1.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'UVDI1 '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL UVAVIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
      YINCUR = YINC
      DO 100 IND = 1,2
C                                       IND=1 reading the one time UV
C                                       data using subroutine UVAVDO
C                                       averaging over the large time
C                                       (10days) and store it at VBUFF1
         IF (IND.EQ.1) THEN
            YINC = 10.0
C                                       subtracting the found complex
C                                       number at IND=1 (VBUFF1)
C                                       from the regular averaged data
C                                       using averaging with given YINC
         ELSE
            YINC = YINCUR
            END IF
         CALL UVAVUV (IRET)
         IF (IRET.NE.0) GO TO 990
 100     CONTINUE
C
      CALL UVAVHI
C                                       close down
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE UVAVIN (PRGM, JERR)
C-----------------------------------------------------------------------
C   UVAVIN gets input parameters for UVDI1 and creates an output file
C   if necessary.
C   Inputs:  PRGM   C*6      Task name
C   Output:  JERR   I        Error code: quit if > 0.
C-----------------------------------------------------------------------
      CHARACTER STAT*4, PRGM*6, UTYPE*2
      INTEGER   IROUND, JERR, NPARM, IERR,  NUMAN(513), LUN, ITEMP,
     *   NIF1, NIF2, NS1, NS2, NF1, NF2
      REAL      FACT, RTEMP
      LOGICAL   T, F
      LOGICAL   TABLE, FITASC, IS1MS, IS2MS
      INCLUDE 'UVDI1.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Initialize I/O
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 24
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.EQ.0) GO TO 10
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
C                                       Restart AIPS
 10   IF (RQUICK) CALL RELPOP (JERR, SCRTCH, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      SEQ2IN = IROUND (XS2IN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DIS2IN = IROUND (XDI2IN)
      DISKO = IROUND (XDISO)
C                                       average time in days
      YINC = MAX (0.2, YINC) / 86400.0
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAM2I, NAM2IN)
      CALL H2CHR (6, 1, XCL2IN, CLA2IN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       Open the first file
C                                       and get catalog at CAT1
      CNO1 = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNO1, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
C                                       Error finding file.
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C
      CALL CATIO ('READ', DISKIN, CNO1, CAT1, 'READ', SCRTCH, IERR)
C                                       Error copying CATBLK.
      IF (IERR.GT.1) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                        Update /CFILE/
      NCFILE = NCFILE + 1
C                                       NCFILE = 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNO1
      FRW(NCFILE) = 0

C                                       See if multisource
      LUN = 29
      CALL MULSDB (CAT1, IS1MS)
      IF (IS1MS) THEN
         CALL ISTAB ('SU', DISKIN, CNO1, 1, LUN, SCRTCH, TABLE, IS1MS,
     *      FITASC, IERR)
         IS1MS = IS1MS .AND. (IERR.EQ.0)
         END IF
C                                       Open the second file
C                                       and get catalog at CAT2
      CNO2 = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DIS2IN, CNO2, NAM2IN, CLA2IN, SEQ2IN,
     *   UTYPE, NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAM2IN, CLA2IN, SEQ2IN, DIS2IN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DIS2IN, CNO2, CAT2, 'READ', SCRTCH, IERR)
C                                       Error copying CATBLK.
      IF (IERR.GT.1) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Copy CAT2 => CATBLK
      CALL COPY (256, CAT2, CATBLK)
      CALL UVPGET (JERR)
C                                       Number of stokes, IF, F for
C                                       the second UV data
      NS2 =  CAT2(KINAX + JLOCS)
      NIF2 = CAT2(KINAX + JLOCIF)
      NF2  = CAT2(KINAX + JLOCF)
C                                        Update /CFILE/
      NCFILE = NCFILE + 1
C                                       NCFILE = 2
      FVOL(NCFILE) = DIS2IN
      FCNO(NCFILE) = CNO2
      FRW(NCFILE) = 0
C                                       See if multisource
      CALL MULSDB (CAT2, IS2MS)
      IF (IS2MS) THEN
         CALL ISTAB ('SU', DIS2IN, CNO2, 1, LUN, SCRTCH, TABLE, IS2MS,
     *      FITASC, IERR)
         IS2MS = IS2MS .AND. (IERR.EQ.0)
         END IF
C                                       Can't subtract
      IF (IS2MS)  THEN
         JERR = 2
         MSGTXT = 'THE SECOND UV FILE MUST BE A SINGLE SOURCE FILE'
         GO TO 990
         END IF
C                                       Copy old CATBLK
      CALL COPY (256, CAT1, CATBLK)
      CALL COPY (256, CATBLK, CATIN)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Number of stokes, IF, F for
C                                       the first UV data
      NS1 =  CAT1(KINAX + JLOCS)
      NIF1 = CAT1(KINAX + JLOCIF)
      NF1  = CAT1(KINAX + JLOCF)
C                                       Stokes numbers identical?
      IF (NS1.NE.NS2) THEN
         JERR = 2
         MSGTXT = 'CANNOT SUBTRACT: DIFFERENT NUMBER STOKES'
         GO TO 990
         END IF
C                                       IF numbers identical?
      IF (NIF1.NE.NIF2) THEN
         JERR = 2
         MSGTXT = 'CANNOT SUBTRACT: DIFFERENT NUMBER IFS'
         GO TO 990
         END IF
C                                       F numbers identical?
      IF (NF1.NE.NF2) THEN
         JERR = 2
         MSGTXT = 'CANNOT SUBTRACT: DIFFERENT NUMBER FREQUENCIES'
         GO TO 990
         END IF
C
      LTB = F
      NANT = 2
C                                       Check if sort order 'TB' or 'BT'
      IF ((ISORT.NE.'BT') .AND. (ISORT.NE.'TB')) THEN
         WRITE (MSGTXT,1050) ISORT
         JERR = 5
         GO TO 990
         END IF
C                                       If 'TB', see if accum. buffers
C                                       will be large enough
      IF (ISORT.EQ.'TB') THEN
         LTB = T
C                                       Get number of antennas from AN
C                                       file.
         LUN = 29
         CALL GETNAN (DISKIN, CNO1, CATIN, LUN, SCRTCH, NUMAN, IERR)
         NANT = NUMAN(2)
C                                       If failed, assume 28.
         IF ((IERR.NE.0) .OR. (NANT.LE.0)) THEN
            WRITE (MSGTXT,1052)
            CALL MSGWRT (6)
            NANT = 28
            END IF
C                                       Allow a maximum of 50 antennas
         IF ((LTB) .AND. (NANT.GT.50)) THEN
            WRITE (MSGTXT,1053)
            JERR = 10
            GO TO 990
            END IF
         END IF
C                                       Set def. outname to inname 1
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      CNOO = 1
C
      FRW(NCFILE+1) = 3
      JERR = 4
C                                       Adjust output size if ZINC is
C                                       non-zero
      IF ((ZINC.GT.0.0) .AND. (YINC.GT.0.0)) THEN
         FACT = ZINC / (YINC * 86400.0)
         ITEMP = CATBLK(KIGCN)
         RTEMP = ITEMP
         RTEMP = RTEMP * (FACT+0.15)
         CATBLK(KIGCN) = IROUND(RTEMP)
         END IF
C
      NVOUT = CATBLK(KIGCN)
      CALL UVCREA (DISKO, CNOO, SCRTCH, IERR)
      IF ((ZINC.GT.0.0) .AND. (YINC.GT.0.0)) CATBLK(KIGCN) = ITEMP
C                                       output catblk modified by UVCREA
      CALL COPY (256, CATBLK, CAT3)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1055) IERR
            GO TO 990
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         ELSE IF ((CNOO.NE.CNO1) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
C                                       Recover existing CATBLK
         ELSE
            FRW(NCFILE+1) = 2
            CALL CATIO ('READ', DISKO, CNOO, CATBLK, 'WRIT', SCRTCH,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1065) IERR
               CALL MSGWRT (6)
               END IF
            END IF
         END IF
C                                       NCFILE = 3
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CNOO
      FRW(NCFILE) = 2
      SEQOUT = CATBLK(KIIMS)
      JERR = 0
C                                       copy header keywords
      CALL KEYCOP (DISKIN, CNO1, DISKO, CNOO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVAVIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('UVAVIN: ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,
     *   ' DISK=',I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' READING CATALOG HEADER FOR INPUT FILE')
 1050 FORMAT ('UVAVIN: SORT ORDER ',A2,' NOT BT OR TB AS REQUIRED')
 1052 FORMAT ('UVAVIN: COULD NOT GET NUMBER OF ANTENNAS FROM AN FILE',
     *   ' - ASSUME 28')
 1053 FORMAT ('UVAVIN: MORE THAN 50 ANTENNAS IN AN FILE - SORT TO BT')
 1055 FORMAT ('UVAVIN: ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('UVAVIN: MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('UVAVIN: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE UVAVUV (IRET)
C-----------------------------------------------------------------------
C   UVAVUV sends uv data one point at a time to the average/merge
C   routine and then writes the modified data if requested.
C   Input in common:
C      ISCOMP  L  If true data is compressed
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER PHNAME(6)*48
      INTEGER   IRET, INIO, IPTRI, IPTRO, LRECO, NIOLIM, NIOUT, KBIND,
     *   IA1, IA2, IBIND, ILENBU, I, VO, BO, NUMVIS, XCOUNT, NCORR
      LOGICAL   T, F
      INCLUDE 'UVDI1.INC'
      REAL      CBUFF(UVBFSS)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      LUNI = 16
      LUNO = 17
      IF (IND.EQ.1) THEN
C                                       Copy CAT of the second file
         CALL COPY (256, CAT2, CATBLK)
C                                       Compressed data?
         ISCOMP = CATBLK(KINAX).EQ.1
C                                       Find weight and scale.
         IF (ISCOMP) THEN
            CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH2(KHPTP),
     *         ILOCWT, IRET)
            IF (IRET.NE.0) THEN
               MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
               IRET = 9
               GO TO 990
               END IF
            END IF
C                                       Get uv header info.
         CALL UVPGET (IRET)
C                                       store NRPARM at IND = 1
         NRPAR1 = NRPARM
C                                       Number of visibilities in the
C                                       second input file.
         NCORR = (LREC - NRPARM) / CATBLK(KINAX)
C                                       Open and init for read
C                                       the second file
         CALL ZPHFIL ('UV', DIS2IN, CNO2, 1, PHNAME, IRET)
         CALL ZOPEN (LUNI, INDI, DIS2IN, PHNAME, T, F, F, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET
            GO TO 990
            END IF
C                                       second pass
      ELSE
C                                       Copy CAT of the output
         CALL COPY (256, CAT3, CATBLK)
C                                       Compressed data?
         ISCOMP = CATBLK(KINAX).EQ.1
C                                       Find weight and scale.
         IF (ISCOMP) THEN
            CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH3(KHPTP),
     *         ILOCWT, IRET)
            IF (IRET.NE.0) THEN
               MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
               IRET = 9
               GO TO 990
               END IF
            END IF
C                                       Get uv header info.
         CALL UVPGET (IRET)
C                                       Number of visibilities in the
C                                       first input and output file.
         NCORR = (LREC - NRPARM) / CATBLK(KINAX)
C                                       Open and init for read
C                                       the first file
         CALL ZPHFIL ('UV', DISKIN, CNO1, 1, PHNAME, IRET)
         CALL ZOPEN (LUNI, INDI, DISKIN, PHNAME, T, F, F, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET
            GO TO 990
            END IF
C                                       Open vis file for write
C                                       for IND=2 only
         CALL ZPHFIL ('UV', DISKO, CNOO, 1, ONAME, IRET)
         CALL ZOPEN (LUNO, INDO, DISKO, ONAME, T, F, F, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1010) IRET
            GO TO 990
            END IF
C                                       Init vis file for write
C                                       LRECO = length of output rec.
         LRECO = LREC
         ILENBU = 0
         CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU,
     *      JBUFSZ, BUFF2, BO, KBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1020) IRET
            GO TO 990
            END IF
         IPTRO = KBIND
         NIOUT = 0
         NIOLIM = ILENBU
         END IF
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
C                                       Init counters.
      NUMVIS = 0
C                                       Loop
C                                       Read vis. record.
 100  CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                        Test for end of data
      ELSE IF (INIO.GT.0) THEN
C                                        Prepare to call UVAVDO
C                                        Loop through data in buffer
         DO 190 I = 1,INIO
            IPTRI = IBIND + (I-1)*LREC
            IF (ILOCB.GE.0) THEN
               IA2 = BUFF1(IPTRI+ILOCB) + 0.1
               IA1 = IA2 / 256
               IA2 = IA2 - IA1*256
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               END IF
            NUMVIS = NUMVIS + 1
C                                       Compressed data.
            IF (ISCOMP) THEN
               CALL ZUVXPN (NCORR, BUFF1(IPTRI+NRPARM),
     *            BUFF1(IPTRI+ILOCWT), CBUFF)
               CALL UVAVDO (NUMVIS, BUFF1(IPTRI+ILOCT), IA1, IA2, CBUFF,
     *            BUFF1(IPTRI), IRET, NIOLIM, LRECO, IPTRO, NIOUT,
     *            XCOUNT)
C                                       Un compressed data
            ELSE
               CALL UVAVDO (NUMVIS, BUFF1(IPTRI+ILOCT), IA1, IA2,
     *            BUFF1(IPTRI+NRPARM), BUFF1(IPTRI), IRET, NIOLIM,
     *            LRECO, IPTRO, NIOUT, XCOUNT)
               END IF
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
               END IF
 190        CONTINUE
         GO TO 100
         END IF
C                                       Final call to UVAVDO.
      NUMVIS = -1
      CALL UVAVDO (NUMVIS, BUFF1(IPTRI+ILOCT), IA1, IA2,
     *   BUFF1(IPTRI+NRPARM), BUFF1(IPTRI), IRET, NIOLIM, LRECO, IPTRO,
     *   NIOUT, XCOUNT)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
         END IF
C                                       Close input file
      CALL ZCLOSE (LUNI, INDI, IRET)
C                                       Compress and close output file.
      IF (IND.EQ.2) THEN
         NVIS = XCOUNT
         CALL ZCLOSE (LUNO, INDO, IRET)
         END IF
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVAVUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1010 FORMAT ('UVAVUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1020 FORMAT ('UVAVUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('UVAVUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('UVAVUV: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('UVAVUV: UVAVDO ERROR',I3)
      END
      SUBROUTINE UVAVHI
C-----------------------------------------------------------------------
C   UVAVHI copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP(1)*2, HILINE*72, LABEL*8
      INTEGER   LUN1, LUN2, IERR, I, NONOT
      LOGICAL   T
      INCLUDE 'UVDI1.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2, T /27,28, .TRUE./
      DATA NONOT, NOTTYP /1,'NX'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, CNO1, CNOO, CATBLK,
     *   SCRTCH, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 20
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCO2 (TSKNAM, NAM2IN, CLA2IN, SEQ2IN, DIS2IN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
C                                      Add any other history
      IF (NUMHIS.GT.0) THEN
         WRITE (LABEL,1010) TSKNAM
         DO 15 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 20
 15         CONTINUE
         END IF
C                                       Close HI file
 20   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO, CNO1, CNOO,
     *   CATBLK, SCRTCH, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1019)
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, CNOO, CATBLK, 'REST', SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVAVHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,'/')
 1019 FORMAT ('UVAVHI: ERROR COPYING TABLES')
      END
      SUBROUTINE UVAVDO (NUMVIS, T, IA1, IA2, VIS, RPARM, IRET, NIOLIM,
     *   LRECO, IPTRO, NIOUT, XCOUNT)
C-----------------------------------------------------------------------
C   UVAVDO averages a uv data set in time.
C   Inputs:
C      NUMVIS     I    Visibility number, -1=> final call, no data
C                      passed but allows any operations to be completed.
C                      Data sent back will be wirtten to output file.
C      T          R    Time in days since 0 IAT on the first day for
C                      which there is data.
C      IA1        I    First antenna number
C      IA2        I    Second antenna number
C      RPARM(*)   I    Random parameter array which includes U,V,W etc
C                      but also any other random parameters.
C      VIS(3,*)   R    Vis data in order real, imaginary, weight (Jy)
C      NIOLIM     I    Maximum number or records per buffer.
C      IPTRO      I    Output pointer - initialize before first call.
C      NIOUT      I    Number of records in buffer.  Init before first
C                                 call
C      XCOUNT     I    Output record counter.  Init before first call.
C   Inputs from COMMON
C      NRPARM     I    # random parameters.
C      NCOR       I    # correlators
C      CATBLK(256)I    Catalog header record.
C   Output:
C      RPARM      R    Modified random parameter array. NB U,V,W, time
C                      and baseline should not be modified in RPARM
C      VIS        R    Visibilities
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C   Output in COMMON
C      NUMHIS     I    # history entries (max. 10)
C      HISCRD(NUMHIS) C   History records
C      CATBLK     I    Catalog header block
C   Programmer: R. C. Walker  Feb. 1984, L.R. Kogan Jan. 2007
C-----------------------------------------------------------------------
C                                        Declares for call.
      INTEGER   IA1, IA2, IRET, NIOLIM, IPTRO, NIOUT, LRECO, IP, I2TMP
      REAL      T, VIS(3,*), RPARM(*)
      INTEGER   NUMVIS, XCOUNT
C
      INTEGER   ANOTA(20)
      CHARACTER OUTRAN(20)*8
C                                       Main declares.
      INTEGER MXINDX
      INTEGER KBUFF1, INDEX1
C                                       Accumulation buffer
C                                       index size.
      PARAMETER (MXINDX = 1136)
      INTEGER   IIREC, IIREC2, ILEN, LUNSS, JERR, JRET, INDEX, IDAY,
     *   IBAS, BLCUR, KBAS, INDEX2, NIOFLS, INDEXV, I, KBIND, MCOR,
     *   NMCOR, LBAS, KBUFF, ITIME, IWORK(MXINDX), ITT, NCOPY, ANVER,
     *   CURSOU, LSTSOU, CURFQ, LSTFQ, NFQID, KREC, KFQID, IFQTRA(64),
     *   K, KLIM
      REAL      DIV, WGT, TLAST, CT, TCHK, TYINC, OPARM(20),
     *   TIMES(3,MXINDX), WORK(2,MXINDX)
      DOUBLE PRECISION X8, NXINC, XINC8
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'UVDI1.INC'
      REAL      RESULT(UVBFSS)
C                                        For accumulation.
C                                        enough for 32 chan, 3 words/ch.
C                                        27 stations plus 8 PARMS +
C                                        1 word for a PARMS weight.
C                                        Space will be reconfigured for
C                                        each data set.
C                                        Adequacy was checked in UVAVIN
      REAL      VBUFF(ACSIZE), DTUTC
      REAL      VBUFF1(ACSIZE), VRE, VIM
      LOGICAL   ITPRT
      INTEGER   IIA1, IIA2
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      SAVE VBUFF, NCOPY, DTUTC, TLAST, BLCUR, MCOR, NMCOR, LBAS,
     *   XINC8, IIREC, IIREC2, ILEN, NXINC, LSTSOU, NFQID, IFQTRA, KLIM,
     *   ANOTA, TCHK, LSTFQ
      SAVE VBUFF1
      DATA LUNSS /27/
C-----------------------------------------------------------------------
      IRET = -1
C                                        Initial call
      IF (NUMVIS.EQ.1) THEN
         NUMHIS = 0
C                                       Number of visibilities in input
C                                       and output files.
         NCOPY = LRECO - NRPARM
C                                        Get data time - UTC
         DTUTC = 0.0
         ANVER = 1
         CALL ANTINI ('READ', VBUFF, FVOL(NCFILE), FCNO(NCFILE), ANVER,
     *      CATIN, LUNSS, IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0,
     *      DEGPDY, SAFREQ, RDATE, POLRXY, UT1UTC, DTUTC, TIMSYS,
     *      ANAME, XYZHAN, TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, JERR)
         DTUTC = DTUTC / 86400.0
         CALL TABIO ('CLOS', 1, IANRNO, VBUFF, VBUFF, JERR)
C                                       warning/type random parameters
         CALL  LISRAN (OUTRAN, ANOTA)
C                                        Set counters etc.
         XCOUNT = 0
         TLAST = -1.0
         BLCUR = -1
         TCHK = -1.0
         MCOR = (LREC - NRPARM) / CATBLK(KINAX)
         NMCOR = MCOR * 3
         LBAS = 1
         IF (LTB) LBAS = NANT*(NANT+1)/2
         XINC8 = MAX (1.0, XINC)
         CURSOU = -1
         IF (ILOCSU.GE.0) CURSOU = RPARM(1+ILOCSU) + 0.5
         LSTSOU = CURSOU
         CURFQ = -1
         IF (ILOCFQ.GE.0) CURFQ = RPARM(1+ILOCFQ) + 0.5
         LSTFQ = CURFQ
C                                        Limit to accumulation buffer.
         KLIM = ACSIZE - (1 + NRPARM + NMCOR)
C                                        Reset FQ ID index
         NFQID = 0
         CALL FILL (64, 0, IFQTRA)
C                                        For sorts
         ILEN = 3
         I2TMP = MXINDX
         CALL RFILL (I2TMP, 0.0, TIMES)
C                                        Reset accumulation buffer
         I2TMP = ACSIZE
         CALL RFILL (I2TMP, 0.0, VBUFF)
C                                        Set up to write first record
C                                        and avoid round off problems.
         NXINC = -0.999D0
         END IF
C                                        End of special first record
C                                        processing.
C                                        If in final call, skip tests.
      IF (NUMVIS.NE.-1) THEN
C                                        Be sure antenna numbers are
C                                        in the expected order.
         IF (IA1.GT.IA2) THEN
            WRITE (MSGTXT,1050)
            CALL MSGWRT (8)
            IRET = 7
            GO TO 999
            END IF
C                                        Get UT from data time
         CT = T - DTUTC
C                                        Get baseline.
         IBAS = 32768 * IA1 + IA2
C                                        Be sure of sort order.
         IF ((CT.LT.TCHK) .AND. (IBAS.EQ.BLCUR)) THEN
            WRITE (MSGTXT,1090)
            CALL MSGWRT (8)
            IRET = 4
            GO TO 999
            END IF
         END IF
C                                       Source Number, FQ id
      CURSOU = -1
      IF (ILOCSU.GE.0) CURSOU = RPARM(1+ILOCSU) + 0.5
      CURFQ = -1
      IF (ILOCFQ.GE.0) CURFQ = RPARM(1+ILOCFQ) + 0.5
C                                       Check if output needed.
      IF ((CT.GT.TLAST) .OR. (NUMVIS.EQ.-1) .OR.
     *   ((.NOT.LTB) .AND. (IBAS.NE.BLCUR)).OR.
     *   (CURSOU.NE.LSTSOU)) THEN
C                                        No output for first record.
         IF (NUMVIS.EQ.1) GO TO 180
C                                        Test if output should be
C                                        skipped.
            NXINC = NXINC + 1.D0
            IF ((XINC.GT.1.5) .AND. (MOD(NXINC,XINC8).GT.0.5D0))
     *         GO TO 128
C                                        Loop through the accumulation
C                                        buffer, extracting an
C                                        index of time and baseline
C                                        keys, which are later sorted.
               IIREC = LBAS * NFQID
C                                        Warning if MXINDX exceeded.
               IF (IIREC .GT. MXINDX) THEN
                  WRITE (MSGTXT, 1160) IIREC
                  CALL MSGWRT (8)
                  IRET = 10
                  GO TO 999
                  ENDIF
               DO 100 K = 1, IIREC
                  KREC = (K-1) * (1+NRPARM+NMCOR) + 1
                  IF (KREC .GT. KLIM) GO TO 100
                  WGT = VBUFF(KREC)
                  TIMES(3,K) = K
                  IF (WGT .GT. 0.0) THEN
                     TIMES(1,K) = VBUFF(KREC+ILOCT+1) / WGT
                     TIMES(2,K) = 4096.0 * IA1 + IA2
                  ELSE
                     TIMES(1,K) = 0.0
                     TIMES(2,K) = 0.0
                     ENDIF
  100             CONTINUE
C                                        Sort index of keys TIMES
C                                        to TB or BT order.
               IIREC2 = IIREC + 2
               IF (LTB) CALL OSORT (TIMES, IIREC, IIREC2, 1, 2,
     *               ILEN, WORK, IWORK, JERR)
               IF ((.NOT.LTB).AND.(IIREC.GT.1)) CALL OSORT (TIMES,
     *            IIREC, IIREC2, 2, 1, ILEN, WORK, IWORK, JERR)
               IF (JERR.GT.0) THEN
                  WRITE (MSGTXT,1104)
                  CALL MSGWRT (8)
                  IRET = 8
                  GO TO 999
                  END IF
C                                        Now write in time order.
               ITPRT = .TRUE.
               DO 126 ITIME = 1,IIREC
                  ITT  = IIREC - ITIME + 1
                  KREC = TIMES(3,ITT)
                  KBUFF = (KREC-1) * (1+NRPARM+NMCOR) + 1
                  IF (KBUFF .GT. KLIM) GO TO 126
C                                        Weight for RPARM.
C                                        Will be 0.0 if no valid data
                  WGT = VBUFF(KBUFF)
C                                        No data - no output
                  IF(WGT.LE.0.0) GO TO 124
C                                        Normalize RPARM's
                     DO 105 IP = 1,NRPARM
C                                        Re: WGT for merge will be 1.0
                        IF (ANOTA(IP).EQ.2) THEN
                           OPARM(IP) = VBUFF(KBUFF+IP) / WGT
                        ELSE
                           OPARM(IP) = VBUFF(KBUFF+IP)
                           END IF
 105                    CONTINUE
C                                        Baseline number. Not weighted
C                    OPARM(ILOCB+1) = VBUFF(KBUFF+ILOCB+1)
C                                        Source number. Not weighted
C                    IF (ILOCSU.GE.0) OPARM(ILOCSU+1) =
C    *                  VBUFF(KBUFF+ILOCSU+1)
C                                        FQ id. Not weighted
C                    IF (ILOCFQ.GE.0) OPARM(ILOCFQ+1) =
C    *                  VBUFF(KBUFF+ILOCFQ+1)
C                                        Integration time, not
C                                        weighted
C                    IF (ILOCIT.GT.0) OPARM(ILOCIT+1) =
C    *                  VBUFF(KBUFF+ILOCIT+1)
C                                        Copy new parms array to
C                                        output buffer.
                     CALL RCOPY (NRPARM, OPARM, BUFF2(IPTRO))
C                                       Compressed?
                     IF (ISCOMP) THEN
C                                        Normalize data. Correlator loop
                        DO 110 I = 1,MCOR
                           INDEX2 = (I-1)*3
                           INDEXV = KBUFF + NRPARM + (I-1)*3
                           IF (VBUFF(INDEXV+3).GT.0.0) THEN
                              DIV = 1.0 / VBUFF(INDEXV+3)
                              RESULT(INDEX2+1) = VBUFF(INDEXV+1) * DIV
                              RESULT(INDEX2+2) = VBUFF(INDEXV+2) * DIV
                              RESULT(INDEX2+3) = VBUFF(INDEXV+3)
C                                       store the result of IND = 1
                              IF (IND .EQ. 1) THEN
                                 VBUFF1(INDEXV+1) = VBUFF(INDEXV+1)*DIV
                                 VBUFF1(INDEXV+2) = VBUFF(INDEXV+2)*DIV
C                                       print out the full averaged
C                                       data for IF=1, channel=1
                                 IF (I .EQ. 1) THEN
                                    IF (ITPRT) THEN
                                       WRITE (MSGTXT,2800)
                                       CALL MSGWRT (6)
                                       WRITE (MSGTXT,2900)
                                       CALL MSGWRT (6)
                                       ITPRT = .FALSE.
                                       END IF
                                    IF (ILOCB.GE.0) THEN
                                       IIA1 = VBUFF(KBUFF+ILOCB+1)/256 +
     *                                    0.1
                                       IIA2 = VBUFF(KBUFF+ILOCB+1) -
     *                                    IIA1*256 + 0.1
                                    ELSE
                                       IIA1 = VBUFF(KBUFF+ILOCA1+1)+0.1
                                       IIA2 = VBUFF(KBUFF+ILOCA2+1)+0.1
                                       END IF
C                                    VRE = VBUFF(INDEXV+1)*DIV
C                                    VIM = VBUFF(INDEXV+2)*DIV
                                    VRE = VBUFF1(INDEXV+1)
                                    VIM = VBUFF1(INDEXV+2)
                                    WRITE (MSGTXT,3000) IIA1, IIA2, VRE,
     *                                 VIM, SQRT (VRE*VRE+VIM*VIM),
     *                                 ATAN2(VIM,VRE)*180.0/3.1415926
                                    CALL MSGWRT (6)
                                    END IF
                                 END IF
C
                           ELSE
C                                       No data
                              RESULT(INDEX2+1) = 0.0
                              RESULT(INDEX2+2) = 0.0
                              RESULT(INDEX2+3) = -1.0
                              END IF
 110                       CONTINUE
C                                       Pack/copy to output buffer
                        INDEX2 = IPTRO + NRPARM + (I-1)*3 - 1
                        CALL ZUVPAK (NCOPY, RESULT, BUFF2(IPTRO+ILOCWT),
     *                     BUFF2(IPTRO+NRPARM))
                     ELSE
C                                       Uncompressed data:
C                                       Normalize data. Correlator loop
                        DO 115 I = 1,MCOR
                           INDEX2 = IPTRO + NRPARM + (I-1)*3 - 1
                           INDEXV = KBUFF + NRPARM + (I-1)*3
                           IF (VBUFF(INDEXV+3).GT.0.0) THEN
                              DIV = 1.0 / VBUFF(INDEXV+3)
                              BUFF2(INDEX2+1) = VBUFF(INDEXV+1) * DIV
                              BUFF2(INDEX2+2) = VBUFF(INDEXV+2) * DIV
                              BUFF2(INDEX2+3) = VBUFF(INDEXV+3)
C                                       store the result of IND = 1
                              IF (IND .EQ. 1) THEN
                                 VBUFF1(INDEXV+1) = VBUFF(INDEXV+1)*DIV
                                 VBUFF1(INDEXV+2) = VBUFF(INDEXV+2)*DIV
C                                       print out the full averaged
C                                       data for IF=1, channel=1
                                 IF (I .EQ. 1) THEN
                                    IF (ITPRT) THEN
                                       WRITE (MSGTXT,2800)
                                       CALL MSGWRT (6)
                                       WRITE (MSGTXT,2900)
                                       CALL MSGWRT (6)
                                       ITPRT = .FALSE.
                                       END IF
                                    IF (ILOCB.GE.0) THEN
                                       IIA1 = VBUFF(KBUFF+ILOCB+1) / 256
     *                                    + 0.1
                                       IIA2 = VBUFF(KBUFF+ILOCB+1) -
     *                                    IIA1*256 + 0.1
                                    ELSE
                                       IIA1 = VBUFF(KBUFF+ILOCA1+1)+0.1
                                       IIA2 = VBUFF(KBUFF+ILOCA2+1)+0.1
                                       END IF
                                    VRE = VBUFF1(INDEXV+1)
                                    VIM = VBUFF1(INDEXV+2)
                                    WRITE (MSGTXT,3000) IIA1, IIA2, VRE,
     *                                 VIM, SQRT (VRE*VRE+VIM*VIM),
     *                                 ATAN2 (VIM,VRE)*180.0/3.1415926
                                    CALL MSGWRT (6)
                                    END IF
                                 END IF


                           ELSE
C                                       No data
                              BUFF2(INDEX2+1) = 0.0
                              BUFF2(INDEX2+2) = 0.0
                              BUFF2(INDEX2+3) = -1.0
                              END IF
 115                       CONTINUE
                        END IF
C                                        Update counters.
                     XCOUNT = XCOUNT + 1
C                                        Writing beyond EOF ?
                     IF (XCOUNT.GT.NVOUT) THEN
                        K = MAX (5000, NVOUT/10)
                        CALL UVSIZE (LRECO, K, IP)
                        CALL ZEXPND (LUNO, DISKO, ONAME, IP, IRET)
                        IF (IRET.EQ.0) THEN
                           NVOUT = NVOUT + K
                        ELSE
                           WRITE (MSGTXT,1060) IRET
                           CALL MSGWRT (8)
                           GO TO 999
                           END IF
                        END IF
C                                       skip writng output for IND=1
                     IF (IND .EQ. 1) GO TO 116
                     IPTRO = IPTRO + LRECO
                     NIOUT = NIOUT + 1
C                                        Write output
C                                        Only actually write when
C                                        the buffer is full.
                     IF (NIOUT.GE.NIOLIM) THEN
C                                        Use NIOUT instead of NIOLIM
C                                        so last record ok.
                        CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOUT,
     *                     KBIND, JRET)
                        IF (JRET.NE.0) THEN
                           WRITE (MSGTXT,1113) JRET
                           IRET = 5
                           GO TO 999
                           END IF
                        IPTRO = KBIND
                        NIOLIM = NIOUT
                        NIOUT = 0
                        END IF
  116                CONTINUE
C                                        Jump here if no data for bas.
  124             CONTINUE
C                                        End of baseline loop.
  126          CONTINUE
C                                        Jump here if output not
C                                        written
  128       CONTINUE
C                                        Close up after last record.
            IF (NUMVIS.EQ.-1) THEN
C                                       First write any unwritten
C                                       data.
C
C                                       skip writng output for IND=1
               IF (IND .EQ. 1) GO TO 129
               IF (NIOUT.GT.0) THEN
                  CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOUT,
     *               KBIND, JRET)
                  IF (JRET.NE.0) THEN
                     WRITE (MSGTXT,1113) JRET
                     CALL MSGWRT (8)
                     IRET = 9
                     GO TO 999
                     END IF
                  END IF
C                                        Then flush buffers to output
               NIOFLS = 0
               CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOFLS, KBIND,
     *            JRET)
               IF (JRET.NE.0) THEN
                  WRITE (MSGTXT,1130) JRET
                  CALL MSGWRT (8)
                  IRET = 6
                  GO TO 999
                  END IF
  129          CONTINUE
C                                        Tell history
               YINC = YINC * 86400.0
               NUMHIS = NUMHIS + 1
               WRITE (HISCRD(NUMHIS),1135) YINC
C                                        Tell history about reduced
C                                        output.
               IF (XINC.GT.1.0) THEN
                  NUMHIS = NUMHIS + 1
                  WRITE (HISCRD(NUMHIS),1145) XINC
                  END IF
C                                        Write no. written to history.
               IF (IND .EQ. 2) THEN
                  NUMHIS = NUMHIS + 1
                  WRITE (HISCRD(NUMHIS),1150) XCOUNT
                  WRITE (MSGTXT,1150) XCOUNT
                  CALL MSGWRT (5)
                  END IF
C
                  GO TO 999
               END IF
C
C                                        First record, skip to here.
  180    CONTINUE
C                                        Set up for next integration
CRCW                                     Removed 0.95 here
         IDAY = CT
         TYINC =  YINC
         X8 = (CT-IDAY) / TYINC
         TLAST = IDAY + DINT (X8) * TYINC + TYINC
         TCHK = TLAST - 1.1 * TYINC
C                                        Reset accumulators, etc.
         I2TMP = LBAS * NFQID * (1+NRPARM+NMCOR)
         IF (I2TMP .GT. ACSIZE) I2TMP = ACSIZE
         CALL RFILL (I2TMP, 0.0, VBUFF)
         BLCUR = IBAS
         LSTSOU = CURSOU
         LSTFQ = CURFQ
C                                        Reset FQ ID index
         NFQID = 0
         CALL FILL (64, 0, IFQTRA)
         END IF
C                                        Accumulate current datum.
C                                        Get baseline number for accum.
      KBAS = 1
      IF (LTB) KBAS = IA2*(IA2-1)/2 + IA1
C                                        Get FQ ID for accumulation.
      IF (CURFQ .GT. 64) THEN
         WRITE (MSGTXT,1170) CURFQ
         CALL MSGWRT (8)
         IRET = 11
         GO TO 999
         ENDIF
C                                        Update FQ ID index for
C                                        this accumulation.
      IF (CURFQ .GT. 0) THEN
         IF (IFQTRA(CURFQ) .EQ. 0) THEN
            NFQID = NFQID + 1
            IFQTRA(CURFQ) = NFQID
            ENDIF
         KFQID = IFQTRA(CURFQ)
      ELSE
         KFQID = 1
         NFQID = 1
      ENDIF
C                                        Get index of first element of
C                                        accumulation buffer for this
C                                        baseline.  That element will
C                                        accumulate the weight for PARMS
      KBUFF = (KBAS - 1 + (KFQID - 1) * LBAS) * (NRPARM + 1 + NMCOR) + 1
C                                       use the index of the VBUFF1
C                                       as it was stored
      KBUFF1 =(KBAS - 1 + (KFQID - 1) * LBAS) * (NRPAR1 + 1 + NMCOR) + 1
C                                        Check that accumulation
C                                        buffer is not exceeded.
      IF (KBUFF .GT. KLIM) THEN
         WRITE (MSGTXT,1180) KBUFF
         CALL MSGWRT (8)
         IRET = 12
         GO TO 999
         ENDIF
C                                        Initialize parms weight.
      WGT = 0.0
      DO 220 I = 1,MCOR
         INDEX = KBUFF + NRPARM + (I-1)*3
C                                        Check weight.
         IF (VIS(3,I).GT.0.0) THEN
C                                        Accumulate vis data.
C                                       Average
            IF (IND .EQ. 1) THEN
C                                       regular accumulation
               VBUFF(INDEX+1) = VBUFF(INDEX+1) +
     *            VIS(1,I)*VIS(3,I)
               VBUFF(INDEX+2) = VBUFF(INDEX+2) +
     *            VIS(2,I)*VIS(3,I)
               VBUFF(INDEX+3) = VBUFF(INDEX+3) + VIS(3,I)
            ELSE
               INDEX1 = KBUFF1 + NRPAR1 + (I-1)*3
C                                       subtruct the value calculated
C                                       at IND=1
               VBUFF(INDEX+1) = VBUFF(INDEX+1) +
     *                (VIS(1,I)-VBUFF1(INDEX1+1))*VIS(3,I)
C     *                (VIS(1,I)-VBUFF1(INDEX+1))*VIS(3,I)
               VBUFF(INDEX+2) = VBUFF(INDEX+2) +
     *            (VIS(2,I)-VBUFF1(INDEX1+2))*VIS(3,I)
C     *            (VIS(2,I)-VBUFF1(INDEX+2))*VIS(3,I)
               VBUFF(INDEX+3) = VBUFF(INDEX+3) + VIS(3,I)
               END IF
C                                         Use largest weight for uv etc
            WGT = MAX (WGT, VIS(3,I))
            END IF
 220     CONTINUE
C                                         Accumulate PARMS only if some
C                                         data was good.
      IF (WGT.GT.0.0) THEN
C                                        For merge.
         DO 240 IP = 1,NRPARM
            IF (ANOTA(IP).EQ.2) THEN
               VBUFF(KBUFF+IP) = VBUFF(KBUFF+IP) + RPARM(IP)*WGT
            ELSE IF (ANOTA(IP).EQ.1) THEN
               VBUFF(KBUFF+IP) = VBUFF(KBUFF+IP) + RPARM(IP)
            ELSE
               IF (VBUFF(KBUFF+IP).EQ.0.0) VBUFF(KBUFF+IP) =
     *            RPARM(IP)
               END IF
  240       CONTINUE
C                                        Accumulate weights.
         VBUFF(KBUFF) = VBUFF(KBUFF) + WGT
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('UVAVDO: ANTENNA NUMBERS NOT IN ',
     *      'INCREASING ORDER IN BASL NO')
 1060 FORMAT ('UVAVDO: ERROR',I6,' EXPANDING OUTPUT FILE')
 1090 FORMAT ('UVAVDO: RECORDS NOT IN TIME (TB) ORDER')
 1104 FORMAT ('UVAVDO: SOMETHING WRONG WITH SORT')
 1113 FORMAT ('UVAVDO: ERROR',I3,' WRITING VIS FILE')
 1130 FORMAT ('UVAVDO: ERROR',I3,' CLOSING VIS FILE')
 1135 FORMAT ('UVAVDO: Average time=',F9.2,' sec.')
 1145 FORMAT ('UVAVDO: only one in ',F6.0,' output records actually',
     *        ' written.')
 1150 FORMAT ('UVAVDO: ',I10,' Visibility records written')
 1160 FORMAT ('UVAVDO: Parameter MXINDX too small (',I5,' )')
 1170 FORMAT ('UVAVDO: Increase IFQTRA dimension to at least',I5)
 1180 FORMAT ('UVAVDO: Parameter ACSIZE too small (',I8,' )')
 2800 FORMAT (10X, 'Parameters of averaged VISs used for subtraction')
 2900 FORMAT ('  IF=1, CHAN=1|  ', 'Basel  ', '   Re   ',
     *        '     Im   ','    Amp   ', '    Phas  ')
 3000 FORMAT (16X, I2, '-', I2, 2X, F8.4, 2X,F8.4, 2X,F8.4,4X, F6.1)
      END

      SUBROUTINE NCALC (INIT, VOBS, IS, JS, WT, NUMBL, REFANT, MODE,
     *   MINNO, GAERR, CONFAC, G, NREF, PRTLV, FFLIM, FFLAST, FRAC, RMS,
     *   IERR)
C-----------------------------------------------------------------------
C! Gain Soln: Does least sq. gain solution with amplitude constraints.
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004-2005, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   NCALC computes antenna gains.  Will add penalty term to constrain
C   the amplitude of the gains.  Penalty term is proportional to the
C   difference in the current gain RMS (in sigmas) from the expected
C   value.
C   Inputs:
C      INIT     L        T -> start with (1,0) compute NREF if needed
C                        F -> start with GLAST, keep NREF as is
C      VOBS     R(2,*)   Averaged visibility (real, imaginary)
C      IS       I(*)     Array of first antenna numbers.
C      JS       I(*)     Array of second antenna numbers.
C      NUMBL    I        Number of observations.
C      REFANT   I        Desired reference antenna.
C      MODE     I        Solution mode: 0 = full gain soln.
C                           1 = phase only keep ampl. info.
C                           2 = phase only discard ampl. info.
C                        + 10 * weight func (1 sqrt, 2 4th root, 3 -> 1
C      MINNO    I        Min. number of antennas acceptable.
C      GAERR    R(*)     Standard deviations of the assumed
C                        distributions of the amplitudes of the gains.
C                        Used to constrain the solutions.
C      CONFAC   R        Factor to multiply times the penalty term to
C                        increase or decrease its importance.
C      PRTLV    I        Print level,   0 = none
C                           1 = print (MSGWRT) soln.
C                           2 = print RMS at each iteration
C                           3 = print data plus soln.
C      FFLIM    R        Limit clip to max (std, FFLIM) * rms
C      FFLAST   R        Mark bad those data with closure error >
C                        FFLAST * rms closure error on last iteration
C   In/out:
C      WT       R(*)     Array of visibility weights - adjusted for
C                        amplitude normalizations and weight function
C   Outputs:
C      G        R(2,*)   Antenna gains to be applied (real, imaginary)
C                        returnsd 1,0 for missing antennas
C      NREF     I        Reference antenna used.
C      RMS      R        RMS closure error
C      IERR     I        Return error code 0 = OK
C                           1 = no valid data
C                           2 = didn't converge
C                           3 = too few antennas
C   Task BPASS does not change reference if it is set and sets it if
C   it needs to.
C-----------------------------------------------------------------------
      LOGICAL   INIT
      INTEGER   IS(*), JS(*), NUMBL, REFANT, MODE, MINNO, NREF, PRTLV,
     *   IERR, IIER
      REAL      VOBS(2,*), WT(*), GAERR(*), CONFAC, G(2,*), FFLIM,
     *   FFLAST, FRAC, RMS
C
      INTEGER   ITRMAX
      PARAMETER (ITRMAX = 10)
C
      INTEGER   LDH, N
      INTEGER   IARG1, IARG2, MAXANS, K, KK, J, JJ, I, II, L, LL, NT,
     *   NTD, MODESV, IT, ITMAX, IIP, JJP, IIA, JJA, ID2, LMODE, LWT,
     *   ITER, ITRMIN
      REAL      XRE, XIM, XAMP, XPHAS, XXX, PH, AMP, SUMWT, FF(ITRMAX),
     *   Z(2), ZR, ZI, QQ, XX, YY, GG(ITRMAX)
      DOUBLE PRECISION S, SL, PENSUM, GN, W, RCOND, DET(2),
     *   TOL, XLAM, C, AI, AJ, PI, PJ, SR, SI, CR, CI
      LOGICAL   DORMS
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:GAIN.INC'
      INTEGER   IA(MAXANT), IB(MAXANT), INERT(3), KPVT(MAXPRM)
      REAL      SWT(MAXANT), GLAST(2,MAXANT)
      INCLUDE 'INCS:DMSG.INC'
      COMMON /GLASTS/ GLAST
      DATA ITMAX/50/, TOL/1D-6/
      DATA GG /7.0, 5.0, 4.0, 3.5, 3.0, 2.8, 2.6, 2.4, 2.2, 2.5/
C-----------------------------------------------------------------------
      IERR = 1
      IF (NUMBL.LE.0) GO TO 999
      CALL RCOPY (ITRMAX, GG, FF)
      DO 5 I = 1,ITRMAX
         FF(I) = MAX (FF(I), FFLIM)
 5       CONTINUE
      IF (FFLAST.GE.1.0) FF(ITRMAX) = FFLAST
C                                       interpret mode
      LMODE = MOD (MODE, 10)
      ITRMIN = ITRMAX
      IF (LMODE.GT.3) THEN
         ITRMIN = 1
         LMODE = LMODE - 4
         END IF
      LWT = MODE / 10
C                                       inits
      LDH = MAXPRM
      MAXANS = MAXANT
      DO 10 I = 1,MAXANS
         SWT(I) = 0.0
 10      CONTINUE
      NT = 0
      SUMWT = 0.0
C                                       Determine which antennas have
C                                       data. NT is the highest
C                                       numbered antenna with data
C                                       present. SWT(K) is the sum of
C                                       data weights involving antenna
C                                       K. SUMWT is the sum of all data
C                                        weights.
      DO 20 K = 1,NUMBL
         I = IS(K)
         J = JS(K)
         NT = MAX (NT,J)
C                                       Assume that any 0 observations
C                                       ought to have been flagged, and
C                                       insist on non negative weights:
         XXX = SQRT (VOBS(1,K)*VOBS(1,K) + VOBS(2,K)*VOBS(2,K))
         IF (XXX.EQ.0.0) WT(K) = 0.0
         IF (WT(K).GT.0.) THEN
C                                       In case MODE=2, so that
C                                       amplitude info. is to be
C                                       ignored, give the obs. unit
C                                       modulus:
            IF (LMODE.EQ.2) THEN
               VOBS(1,K) = VOBS(1,K) / XXX
               VOBS(2,K) = VOBS(2,K) / XXX
               WT(K) = WT(K) * XXX * XXX
               END IF
            CALL REWAIT (LWT, WT(K))
            SWT(I) = SWT(I) + WT(K)
            SWT(J) = SWT(J) + WT(K)
            SUMWT = SUMWT + WT(K)
C                                       If PRTLV .ge. 3  print data.
            IF ((PRTLV.GE.3) .AND. (WT(K).GT.1.0E-20)) THEN
               XRE = VOBS(1,K) + 1.0E-20
               XIM = VOBS(2,K)
               XAMP = SQRT (XRE * XRE + XIM * XIM)
               XPHAS = 57.296 * ATAN2 (XIM, XRE)
               WRITE (MSGTXT,1010) I, J, XAMP, XPHAS
               CALL MSGWRT (3)
               END IF
         ELSE
            WT(K) = 0.0
            END IF
 20      CONTINUE
C                                       Check whether any data were
C                                       present:
      IF (SUMWT.EQ.0.) GO TO 999
      IF ((TSKNAM.EQ.'BPASS') .AND. (REFANT.GT.0) .AND.
     *   (SWT(REFANT).LE.0.0)) GO TO 999
C                                       init solutions
      DO 25 I = 1,MAXANS
         IF ((INIT) .OR. (SWT(I).LE.0.0)) THEN
            G(1,I) = 1.0
            G(2,I) = 0.0
         ELSE
            G(1,I) = GLAST(1,I) * COS (GLAST(2,I))
            G(2,I) = GLAST(1,I) * SIN (GLAST(2,I))
            END IF
 25      CONTINUE
C                                       Check the reference antenna for
C                                       presence of data.
C                                       Choose another, if need be:
      IF ((INIT) .OR. (NREF.LE.0) .OR. (NREF.GT.MAXANS)) THEN
         NREF = REFANT
         IF ((NREF.LT.1) .OR. (NREF.GT.MAXANS) .OR. (SWT(NREF).LE.0.0))
     *      THEN
            XXX = 0.0
            DO 30 I = 1,NT
               IF (SWT(I).GT.XXX) THEN
                  XXX = SWT(I)
                  NREF = I
                  END IF
 30            CONTINUE
            IF (TSKNAM.EQ.'BPASS') REFANT = NREF
            END IF
         END IF
C                                       Check for plenty of antennae,
C                                       and count the number (NTD)
C                                       with data:
      NTD = 0
      DO 40 I = 1,NT
         IF (SWT(I).GT.0.0) NTD = NTD + 1
 40      CONTINUE
      IERR = 3
      IF (NTD.LT.MINNO) GO TO 999
      DORMS = (2.5*(NTD-1).LE.NUMBL)
C                                       Assign a new antenna numbering,
C                                       based only on those antennas
C                                       with data present.  Assign 1
C                                       to the reference antenna.
C                                       Store the assignments in IA,
C                                       and let IB be the inverse
C                                       permutation.
      IA(1) = NREF
      IB(NREF) = 1
      K = 1
      DO 50 I = 1,NT
         IF ((SWT(I).GT.0.0) .AND. (I.NE.NREF)) THEN
            K = K + 1
            IA(K) = I
            IB(I) = K
            END IF
 50      CONTINUE
C                                       Set initial guesses to zero for
C                                       the arguments of the gains,
C                                       stored in XPRM(1),...,
C                                       XPRM(NTD-1),and
C                                       to unity for their moduli,
C                                       stored in XPRM(NTD),...,
C                                       XPRM(2*NTD-1).
C                                       Also initialize the correction
C                                       vector, STEP, to 0.
C                                       N is the total number of real
C                                       unknowns.
      N = 2 * NTD - 1
      IF ((LMODE.EQ.1) .OR. (LMODE.EQ.2)) N = NTD - 1
      DO 60 I = 1,N
         IF (INIT) THEN
            IF (I.LT.NTD) THEN
               XPRM(I) = 0.0D0
            ELSE
               XPRM(I) = 1.0D0
               END IF
         ELSE
            IF (I.LT.NTD) THEN
               K = IA(I+1)
               XPRM(I) = GLAST(2,K)
            ELSE
               K = IA(I+1-NTD)
               XPRM(I) = GLAST(1,K)
               END IF
            K = IA(I)
            END IF
         STEP(I) = 0.0D0
 60      CONTINUE
      MODESV = LMODE
C                                       Robust iteration
      IF (.NOT.DORMS) ITRMIN = ITRMAX
      DO 400 ITER = ITRMIN,ITRMAX
C                                       When solving for amplitude and
C                                       phase solutions, first converge
C                                       upon `phase-only' (MODE=1) soln
         IF (((LMODE.EQ.0) .OR. (LMODE.EQ.3)) .AND. (ITER.LT.ITRMIN+5))
     *      THEN
            LMODE = 1
            N = NTD - 1
            END IF
C                                       Loop-back point to do amp/phase
 100     CONTINUE
C
C                                       Iterate:
         DO 250 IT = 1,ITMAX
C                                       Zero the gradient and
C                                       Hessian arrays:
            DO 110 I = 1,N
               GRAD(I) = 0.0
               DO 105 J = 1,N
                  HESS(I,J) = 0.0
 105              CONTINUE
 110           CONTINUE
C                                       On first iteration, calculate
C                                       the objective function, SL:
            IF (IT.EQ.1) CALL NEVAL (XPRM, 0.0D0, STEP, VOBS, IS, JS,
     *         IA, WT, NUMBL, NTD, LMODE, PRTLV, GAERR, CONFAC, G, SL,
     *         PENSUM)
C                                       Accumulate (half) the gradient
C                                       of S and (half) the Hessian:
            DO 130 K = 1,NUMBL
               IF (WT(K).LE.0.) GO TO 130
               I = IS(K)
               J = JS(K)
               II = IB(I)
               JJ = IB(J)
               IIP = II - 1
               JJP = JJ - 1
               PI = 0.0D0
               PJ = 0.0D0
               IF (I.NE.NREF) PI = XPRM(IIP)
               IF (J.NE.NREF) PJ = XPRM(JJP)
               SR = SIN (PJ - PI) * VOBS(1,K)
               SI = SIN (PJ - PI) * VOBS(2,K)
               CR = COS (PJ - PI) * VOBS(1,K)
               CI = COS (PJ - PI) * VOBS(2,K)
               IF ((LMODE.NE.1) .AND. (LMODE.NE.2)) THEN
                  IIA = NTD + II - 1
                  JJA = NTD + JJ - 1
                  AI = XPRM(IIA)
                  AJ = XPRM(JJA)
                  END IF
               IF (I.EQ.NREF) THEN
                  IF ((LMODE.EQ.1) .OR. (LMODE.EQ.2)) THEN
                     GRAD(JJP) = GRAD(JJP) + WT(K) * (SR + CI)
                     HESS(JJP,JJP) = HESS(JJP,JJP) + WT(K) * (CR - SI)
                  ELSE
                     GRAD(JJP) = GRAD(JJP) + WT(K) * AI * AJ * (SR + CI)
                     GRAD(IIA) = GRAD(IIA) + WT(K) * AJ * (AI*AJ-CR+SI)
                     GRAD(JJA) = GRAD(JJA) + WT(K) * AI * (AI*AJ-CR+SI)
                     HESS(JJP,JJP) = HESS(JJP,JJP) + WT(K) * AI * AJ *
     *                  (CR - SI)
                     HESS(IIA,IIA) = HESS(IIA,IIA) + WT(K) * AJ**2
                     HESS(JJA,JJA) = HESS(JJA,JJA) + WT(K) * AI**2
                     IARG1 = MIN (IIA, JJA)
                     IARG2 = MAX (IIA, JJA)
                     HESS(IARG1,IARG2) = HESS(IARG1,IARG2)
     *                  + WT(K) * (2.0D0 * AI * AJ - CR + SI)
                     IARG1 = MIN (IIA, JJP)
                     IARG2 = MAX (IIA, JJP)
                     HESS(IARG1,IARG2) = HESS(IARG1,IARG2)
     *                  + WT(K) * AJ * (SR + CI)
                     HESS(JJP,JJA) = HESS(JJP,JJA) + WT(K) * AI *
     *                  (SR + CI)
                     END IF
               ELSE IF (J.EQ.NREF) THEN
                  IF ((LMODE.EQ.1) .OR. (LMODE.EQ.2)) THEN
                     GRAD(IIP) = GRAD(IIP) - WT(K) * (SR + CI)
                     HESS(IIP,IIP) = HESS(IIP,IIP) + WT(K) * (CR - SI)
                  ELSE
                     GRAD(IIP) = GRAD(IIP) - WT(K) * AI * AJ * (SR + CI)
                     GRAD(IIA) = GRAD(IIA) + WT(K) * AJ * (AI * AJ -
     *                  CR + SI)
                     GRAD(JJA) = GRAD(JJA) + WT(K) * AI * (AI * AJ -
     *                  CR + SI)
                     HESS(IIP,IIP) = HESS(IIP,IIP) + WT(K) * AI * AJ *
     *                  (CR - SI)
                     HESS(IIA,IIA) = HESS(IIA,IIA) + WT(K) * AJ**2
                     HESS(JJA,JJA) = HESS(JJA,JJA) + WT(K) * AI**2
                     IARG1 = MIN (IIA, JJA)
                     IARG2 = MAX (IIA, JJA)
                     HESS(IARG1,IARG2) = HESS(IARG1,IARG2)
     *                  + WT(K) * (2.0D0 * AI * AJ - CR + SI)
                     HESS(IIP,IIA) = HESS(IIP,IIA) - WT(K) * AJ *
     *                  (SR + CI)
                     IARG1 = MIN (IIP, JJA)
                     IARG2 = MAX (IIP, JJA)
                     HESS(IARG1,IARG2) = HESS(IARG1,IARG2)
     *                  - WT(K) * AI * (SR + CI)
                     END IF
               ELSE
                  IF ((LMODE.EQ.1) .OR. (LMODE.EQ.2)) THEN
                     GRAD(IIP) = GRAD(IIP) - WT(K) * (SR + CI)
                     GRAD(JJP) = GRAD(JJP) + WT(K) * (SR + CI)
                     HESS(IIP,IIP) = HESS(IIP,IIP) + WT(K) * (CR - SI)
                     HESS(JJP,JJP) = HESS(JJP,JJP) + WT(K) * (CR - SI)
                     IARG1 = MIN (IIP, JJP)
                     IARG2 = MAX (IIP, JJP)
                     HESS(IARG1,IARG2) = HESS(IARG1,IARG2)
     *                  - WT(K) * (CR - SI)
                  ELSE
                     GRAD(IIP) = GRAD(IIP) - WT(K) * AI * AJ * (SR + CI)
                     GRAD(JJP) = GRAD(JJP) + WT(K) * AI * AJ * (SR + CI)
                     GRAD(IIA) = GRAD(IIA) + WT(K) * AJ * (AI * AJ -
     *                  CR + SI)
                     GRAD(JJA) = GRAD(JJA) + WT(K) * AI * (AI * AJ -
     *                  CR + SI)
                     HESS(IIP,IIP) = HESS(IIP,IIP) + WT(K) * AI * AJ *
     *                  (CR - SI)
                     HESS(JJP,JJP) = HESS(JJP,JJP) + WT(K) * AI * AJ *
     *                  (CR - SI)
                     IARG1 = MIN (IIP, JJP)
                     IARG2 = MAX (IIP, JJP)
                     HESS(IARG1,IARG2) = HESS(IARG1,IARG2)
     *                  - WT(K) * AI * AJ * (CR - SI)
                     HESS(IIA,IIA) = HESS(IIA,IIA) + WT(K) * AJ**2
                     HESS(JJA,JJA) = HESS(JJA,JJA) + WT(K) * AI**2
                     IARG1 = MIN (IIA, JJA)
                     IARG2 = MAX (IIA, JJA)
                     HESS(IARG1,IARG2) = HESS(IARG1,IARG2)
     *                  + WT(K) * (2.0D0 * AI * AJ - CR + SI)
                     HESS(IIP,IIA) = HESS(IIP,IIA) - WT(K) * AJ *
     *                  (SR + CI)
                     IARG1 = MIN (IIA, JJP)
                     IARG2 = MAX (IIA, JJP)
                     HESS(IARG1,IARG2) = HESS(IARG1,IARG2)
     *                  + WT(K) * AJ * (SR + CI)
                     IARG1 = MIN (IIP, JJA)
                     IARG2 = MAX (IIP, JJA)
                     HESS(IARG1, IARG2) = HESS(IARG1,IARG2)
     *                  - WT(K) * AI * (SR + CI)
                     HESS(JJP,JJA) = HESS(JJP,JJA) + WT(K) * AI *
     *                  (SR + CI)
                     END IF
                  END IF
 130           CONTINUE
C                                       Add in the amplitude penalty
C                                       terms:
            IF (LMODE.EQ.3) THEN
               XLAM = PENSUM - NTD
               C = 0.1 * CONFAC
               DO 150 I = 1,NTD
                  K = IA(I)
                  KK = NTD + I - 1
                  GRAD(KK) = GRAD(KK) + 2.0D0*C * XLAM *
     *               (XPRM(KK) - 1.0D0) / GAERR(K)**2
                  HESS(KK,KK) = HESS(KK,KK) + 2.0D0*C * XLAM /
     *               GAERR(K)**2
                  DO 140 J = I,NTD
                     L = IA(J)
                     LL = NTD + J - 1
                     HESS(KK,LL) = HESS(KK,LL) + 4.0D0 * C *
     *                  (XPRM(LL) - 1.0D0) * (XPRM(KK) - 1.0D0)
     *                  / (GAERR(L) * GAERR(K))**2
 140                 CONTINUE
 150              CONTINUE
               END IF
C                                       Fill in the lower triangular
C                                       part of the Hessian:
            DO 160 I = 2,N
               JJ = I - 1
               DO 155 J = 1,JJ
                  HESS(I,J) = HESS(J,I)
 155              CONTINUE
 160           CONTINUE
C                                       Save the Hessian, in case
C                                       that it's indefinite:
            DO 170 I = 1,N
               DO 165 J = 1,N
                  SHESS(I,J) = HESS(I,J)
 165              CONTINUE
 170           CONTINUE
C                                       Calculate and print the
C                                       Euclidean norm of the gradient,
C                                       in order to monitor the
C                                       progress toward a critical
C                                       point:
            CALL DNRM2 (N, GRAD, 1, GN)
            IF (PRTLV.GE.2) THEN
               WRITE (MSGTXT,1000) IT,GN
               CALL MSGWRT (3)
               END IF
C                                       Factor the Hessian, and obtain
C                                       an estimate of its cond. no.:
            CALL DSICO (HESS, LDH, N, KPVT, RCOND, GWORK)
            IF (PRTLV.GE.2) THEN
               WRITE (MSGTXT,1001) RCOND
               CALL MSGWRT (3)
               END IF
C                                       Compute determinant and inertia:
            IF ((1.0D0+RCOND).NE.1.0D0) THEN
               CALL DSIDI (HESS, LDH, N, KPVT, DET, INERT, GWORK, 110)
               ID2 = DET(2)
               IF (PRTLV.GE.2) THEN
                  WRITE (MSGTXT,1002) DET(1), ID2, INERT
                  CALL MSGWRT (3)
                  END IF
               END IF
C                                       If the Hessian is indefinite
C                                       or singular, use Greenstadt's
C                                       modification:
            IF ((INERT(1).NE.N) .OR. ((1.0D0+RCOND).EQ.1.0D0)) THEN
               CALL GM (N, SHESS, HESS, GWORK, LDH, GRAD, IIER)
               IF (IIER.NE.0) GO TO 999
C                                       Solve for the Newton correction
C                                       (to be placed in GRAD):
            ELSE
               CALL DSISL (HESS, LDH, N, KPVT, GRAD)
               END IF
C                                       Take a damped Newton step:
            DO 180 I = 1,N
               STEP(I) = GRAD(I)
               IF (I.GE.NTD.AND.XPRM(I) - STEP(I).LE.0.)
     *            STEP(I) = 0.5 * XPRM(I)
 180           CONTINUE
            W = 1.
            DO 190 KK = 1,8
               CALL NEVAL (XPRM, W, STEP, VOBS, IS, JS, IA, WT, NUMBL,
     *            NTD, LMODE, PRTLV, GAERR, CONFAC, G, S, PENSUM)
               IF (S.LT.SL) GO TO 200
               IF (KK.LE.4) W = 0.5 * W
               IF (KK.GT.4) W = 0.1 * W
 190           CONTINUE
            GO TO 260
 200        IF ((ABS (1.0D0-S/SL).LE.5.0D-6) .AND. (GN.LT.1.)) GO TO 260
            SL = S
            DO 210 I = 1,N
               XPRM(I) = XPRM(I) - W * STEP(I)
 210           CONTINUE
C                                       not yet converged?
            DO 220 I = 1,N
               IF (ABS (STEP(I)).GT.(ABS (XPRM(I)) + 1D-3) * TOL)
     *            GO TO 250
 220           CONTINUE
            GO TO 260
 250        CONTINUE
         IERR = 2
         IF (LMODE.EQ.MODESV) GO TO 999
C                                       converged switch to A&P
 260     IF (MODESV.NE.LMODE) THEN
            LMODE = MODESV
            N = 2 * NTD - 1
            GO TO 100
            END IF
C                                       squirrel away results
         PH = 0.0
         AMP = 1.0
         DO 270 I = 1,NTD
            K = IA(I)
            IF ((LMODE.EQ.0) .OR. (LMODE.EQ.3)) AMP = XPRM(NTD+I-1)
            IF (I.GT.1) PH = XPRM(I-1)
            G(1,K) = AMP * COS (PH)
            G(2,K) = AMP * SIN (PH)
            GLAST(1,K) = AMP
            GLAST(2,K) = PH
 270        CONTINUE
C                                       find statistics
         S = 0.0
         XXX = 1.0
         DO 280 K = 1,NUMBL
            IF (WT(K).GT.0.0) THEN
               II = IS(K)
               JJ = JS(K)
               Z(1) = G(1,JJ)
               Z(2) = - G(2,JJ)
               ZR = G(1,II) * Z(1) - G(2,II) * Z(2)
               ZI = G(1,II) * Z(2) + G(2,II) * Z(1)
               IF (LMODE.EQ.1) XXX = SQRT ((VOBS(1,K)*VOBS(1,K)) +
     *            (VOBS(2,K)*VOBS(2,K)))
               Z(1) = VOBS(1,K)/XXX - ZR
               Z(2) = VOBS(2,K)/XXX - ZI
               QQ = Z(1) * Z(1) + Z(2) * Z(2)
               S = S + WT(K) * QQ
               END IF
 280        CONTINUE
         RMS = SQRT (S/SUMWT)
C                                       drop some of the extremes
         SUMWT = 0.0
         XXX = 1.0
         CALL RFILL (MAXANS, 0.0, SWT)
         IF (.NOT.DORMS) RMS = 1.0E10
         DO 310 K = 1,NUMBL
            II = IS(K)
            JJ = JS(K)
            IF (WT(K).NE.0.0) THEN
               WT(K) = ABS (WT(K))
               Z(1) = G(1,JJ)
               Z(2) = - G(2,JJ)
               ZR = G(1,II) * Z(1) - G(2,II) * Z(2)
               ZI = G(1,II) * Z(2) + G(2,II) * Z(1)
               IF (LMODE.EQ.1) XXX = SQRT ((VOBS(1,K)*VOBS(1,K)) +
     *            (VOBS(2,K)*VOBS(2,K)))
               Z(1) = ABS (VOBS(1,K)/XXX - ZR) / RMS
               Z(2) = ABS (VOBS(2,K)/XXX - ZI) / RMS
               IF (((Z(1).GT.FF(ITER)) .OR. (Z(2).GT.FF(ITER))) .AND.
     *            (DORMS)) THEN
                  WT(K) = -WT(K)
               ELSE
                  SWT(II) = SWT(II) + WT(K)
                  SWT(JJ) = SWT(JJ) + WT(K)
                  SUMWT = SUMWT + WT(K)
                  END IF
               END IF
 310        CONTINUE
 400     CONTINUE
      IERR = 0
      IF (.NOT.DORMS) RMS = 0.0
C                                       fraction excluded
      XX = 0.0
      YY = 0.0
      DO 410 K = 1,NUMBL
         IF (WT(K).NE.0.0) THEN
            XX = XX + 1.0
            IF (WT(K).LT.0.0) YY = YY + 1.0
            END IF
 410     CONTINUE
      FRAC = 1.0
      IF (XX.GT.0.0) FRAC = YY / XX
C                                       print results
      IF (PRTLV.GE.1) THEN
         AMP = 1.0
         DO 540 I = 1,NT
            IF (SWT(I).GT.0.) THEN
               K = IB(I)
               IF (LMODE.EQ.0.OR.LMODE.EQ.3) AMP = XPRM(NTD+K-1)
               PH = 0.0
               IF (K.GT.1) PH = 57.2958 * ATAN2 (G(2,I), G(1,I))
               WRITE (MSGTXT,1100) I, AMP, PH
               CALL MSGWRT (3)
               END IF
 540        CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Iteration #',I4,'   gradient norm=',1PE15.5)
 1001 FORMAT ('Reciprocal cond. no.=',1PE15.5)
 1002 FORMAT ('Det.=',F15.5,'E',I4,'   Inertia=',3I3)
 1010 FORMAT ('Baseline ',I3,'-',I3,' Amp=',F10.5,' Phase=',F6.1)
 1100 FORMAT ('Ant=',I4,' Amp=',1PE15.5,' Phase=',0PF8.3)
      END

      SUBROUTINE GTTELL (NPARMS, OPTELL, PARMS, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! gets any parameters sent to task by AIPS verb TELL
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GTTELL gets any parameters sent to the current task by AIPS verb
C   TELL.  All entries for the task in the TC file are cleared and the
C   most recent is returned to the calling routine.
C   Inputs:
C      NPARMS   I         Number REAL parameters
C                         < 0 => clean out all pending TELLs for this
C                                task.  Return nothing.
C   Output:
C      OPTELL   C*4       Opcode from TELL
C      PARMS    R(*)      Returned parameters
C      SCRTCH   I(256)    Scratch buffer
C      IERR     I         0 => okay (no parms)
C                         1 => okay (got parms)
C                         2 => TELL orders quit
C                         3 => TELL orders abort
C   Note: if GTTELL encounters an internal error, i.e. file open, read,
C   etc. failure, it returns IERR = 0 after emitting a message.
C-----------------------------------------------------------------------
      INTEGER   NPARMS, SCRTCH(256), IERR
      CHARACTER OPTELL*4
      REAL      PARMS(*)
C
      INTEGER   JERR, NX, IXL, IX, I, LTI(2), LUNTC, FINDTC, IREC
      LOGICAL   T, F, GOTONE(16)
      CHARACTER PHNAME*48, TNAME*6
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNTC /13/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IERR = 0
C                                       Open TC file
      CALL ZPHFIL ('TC', 1, 0, 1, PHNAME, JERR)
      CALL ZOPEN (LUNTC, FINDTC, 1, PHNAME, F, T, T, JERR)
      IF (JERR.EQ.0) GO TO 20
         WRITE (MSGTXT,1000) JERR
         CALL MSGWRT (6)
         GO TO 999
C                                       Read directory record
 20   IREC = (NPOPS - 1) / 2 + 1
      CALL ZFIO ('READ', LUNTC, FINDTC, IREC, SCRTCH, JERR)
      IF (JERR.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) JERR
         CALL MSGWRT (6)
         GO TO 900
C                                       Are we marked there?
 30   NX = 0
      IXL = (NPOPS + 1 - 2*IREC) * 128 + 1
      IX = IXL - 8
      DO 35 I = 1,16
         IX = IX + 8
         CALL H2CHR (6, 1, SCRTCH(IX), TNAME)
         GOTONE(I) = (TSKNAM.EQ.TNAME) .AND. ((SCRTCH(IX+4).EQ.NLUSER)
     *      .OR. (NPARMS.LT.0))
         IF (GOTONE(I)) NX = NX + 1
 35      CONTINUE
      IF (NX.EQ.0) GO TO 900
      LTI(1) = 0
      LTI(2) = 0
      IX = IXL - 6
      NX = 0
      DO 45 I = 1,16
         IX = IX + 8
         IF (GOTONE(I)) THEN
            IF (SCRTCH(IX).LT.LTI(1)) GO TO 45
            IF ((SCRTCH(IX).GT.LTI(1)) .OR. (SCRTCH(IX+1).GE.LTI(2)))
     *         THEN
               LTI(1) = SCRTCH(IX)
               LTI(2) = SCRTCH(IX+1)
               NX = I
               END IF
            END IF
 45      CONTINUE
      IF (NX.GT.0) GO TO 50
         WRITE (MSGTXT,1045)
         CALL MSGWRT (6)
         GO TO 900
C                                       Clear entries
 50   IX = IXL - 8
      DO 55 I = 1,16
         IX = IX + 8
         IF (GOTONE(I)) CALL FILL (8, 0, SCRTCH(IX))
 55      CONTINUE
      CALL ZFIO ('WRIT', LUNTC, FINDTC, IREC, SCRTCH, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1055) JERR
         CALL MSGWRT (6)
         GO TO 900
         END IF
C                                       Read data
      IF (NPARMS.GE.0) THEN
         IREC = 18 + (NPOPS-1) * 16 + NX
         CALL ZFIO ('READ', LUNTC, FINDTC, IREC, SCRTCH, JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1020) JERR
            CALL MSGWRT (6)
            GO TO 900
            END IF
 70      CALL H2CHR (4, 1, SCRTCH(1), OPTELL)
         I = NPARMS
         IF (I.GT.0) CALL COPY (I, SCRTCH(2), PARMS)
         IERR = 1
         IF (OPTELL.EQ.'QUIT') IERR = 2
         IF (OPTELL.EQ.'ABOR') IERR = 3
         END IF
C                                       Close file
 900  CALL ZCLOSE (LUNTC, FINDTC, JERR)
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GTTELL: ERROR',I7,' OPENING TELL COMMUNICATION FILE')
 1020 FORMAT ('GTTELL: ERROR',I7,' READING TELL COMMUNICATION FILE')
 1045 FORMAT ('GTTELL: LOGIC ERROR WITH TIMES')
 1055 FORMAT ('GTTELL: ERROR',I7,' WRITING TELL COMMUNICATION FILE')
      END

      SUBROUTINE TABLIN (NAXIS1, FDVEC, TBIND, NCNTR, TAPBUF, LINE,
     *   IERR)
C-----------------------------------------------------------------------
C! reads a line from the data portion of a FITS extension of type TABLE
C# FITS tape EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   This routine will read a line from the data section of a FITS
C   extension file of type TABLE.  Limited to tables lines <= 2880 chars
C   Inputs:
C      NAXIS1   I      Length of table line.
C      FDVEC    I(50)  File descriptor vector for TAPIO input
C   In/Out:
C      NCNTR    I      Current character position in buffer.
C      TBIND    I      Buffer pointer in TAPBUF
C      TAPBUF   I(?)   Tape I/O buffer.
C   Outputs:
C      LINE     C*(*)  Output of table line in local characters.
C      IERR     I      Error code. 0=ok else TAPIO error.
C-----------------------------------------------------------------------
      CHARACTER LINE*(*)
      INTEGER   NAXIS1, FDVEC(50), TBIND, NCNTR, TAPBUF(*), IERR
C
      INTEGER   IELIN, ILEN, ISTART
C-----------------------------------------------------------------------
C                                       Copy line or partial line from
C                                       buffer.
      IELIN = NCNTR + NAXIS1 - 1
      IELIN = MIN (2880, IELIN)
      ILEN = IELIN - NCNTR + 1
      IF (ILEN.GT.0) CALL ZC8CL (ILEN, NCNTR, TAPBUF(TBIND), LINE)
C                                       Read next block.
      IF (ILEN.LT.NAXIS1) THEN
         CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) GO TO 999
         ISTART = ILEN + 1
         ILEN = NAXIS1 - ILEN
         NCNTR = 1
         CALL ZC8CL (ILEN, NCNTR, TAPBUF(TBIND), LINE(ISTART:))
         END IF
C
      NCNTR = NCNTR + ILEN
C
 999  RETURN
      END

LOCAL INCLUDE 'SUBIM.INC'
      INCLUDE 'INCS:PMAD.INC'
      HOLLERITH XNAMIN(3), XCLSIN(2), XNMOUT(3), XCLOUT(2), XOPCOD(1)
      REAL      SEQIN, DSKIN, SEQOUT, DSKOUT, BLC(7), TRC(7), XINC,
     *   YINC, ZINC
      CHARACTER NAMIN*12, CLSIN*6, NAMOUT*12, CLSOUT*6, OPCODE*4,
     *   IMTYPE*2
      LOGICAL   DOMATH, DOAVE, DOMIN, DOMAX, DOSUM
      INTEGER   ISSEQ, ISVOL, ISSLOT, IDSEQ, IDVOL, IDSLOT, IXINC,
     *   IYINC, IZINC, ISBUFF(MABFSS), IDBUFF(MABFSS), ISLUN, ISIND,
     *   IDLUN, IDIND, IDIMS(7), SCRTCH(256), ISWIN(4), INDX3L, INDX3U,
     *   INDX4L, INDX4U, INDX5L, INDX5U, INDX6L, INDX6U, INDX7L, INDX7U,
     *   INODIM
      REAL      RSBUFF(MABFSS), RDBUFF(MABFSS)
C
      EQUIVALENCE (RSBUFF, ISBUFF, SCRTCH), (RDBUFF, IDBUFF)
      COMMON /INPARM/ XNAMIN, XCLSIN, SEQIN, DSKIN, XNMOUT, XCLOUT,
     *   SEQOUT, DSKOUT, BLC, TRC, XINC, YINC, ZINC, XOPCOD
      COMMON /SUBIMP/ ISSEQ, ISVOL, ISSLOT, IDSEQ, IDVOL, IDSLOT, IXINC,
     *   IYINC, IZINC, DOMATH, DOAVE, DOMIN, DOMAX, ISLUN, ISIND, IDLUN,
     *   IDIND, IDIMS, INDX3L, INDX3U, INDX4L, INDX4U, INDX5L, INDX5U,
     *   INDX6L, INDX6U, INDX7L, INDX7U, ISWIN, INODIM, DOSUM
      COMMON /SUBIMB/ RSBUFF, RDBUFF
      COMMON /SUBIMC/ NAMIN, CLSIN, NAMOUT, CLSOUT, OPCODE, IMTYPE
LOCAL END
      PROGRAM SUBIM
C-----------------------------------------------------------------------
C! Task to copy subarray of image to another file
C# Map-util Spectral Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2009, 2013, 2015, 2017, 2022, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SUBIM will copy a subarray of a cataloged file to a new file and
C   insert a catalog entry for the new file. Multi-dimensional rec-
C   tangles may be selected.  This routine runs as a detached task
C   initiated from AIPS.  It copies any tables found.
C   INPUTS:  (from AIPS)
C            INNAME     R(3)   the entry name for the source file.  If
C                       blank the first match consistent with the other
C                       parameters is used.
C            INCLASS    R(2)   the class of the source file.  If blank
C                       the first match consistent with the other
C                       parameters is used.
C            INSEQ      R   the sequence number of the source file.  If
C                       zero the first match consistent with the other
C                       parameters is used.
C            INDISK     R   the disk volume number of the source file.
C                       If zero all disks are searched and the first
C                       match found is used.
C            OUTNAME    R(3)   the name of the new subimage file.  If
C                       blank the value in INNAME will be used.
C            OUTCLASS   R(2)   the class of the new subimage file.  If
C                       blank the value in INCLASS will be used.
C            OUTSEQ     R   the sequence number for the new subimage
C                       file.  If zero the first sequence number that
C                       will produce a unique file specification is
C                       used.
C            OUTDISK    R   the disk volume number for the new subimage
C                       file.  If zero the new file will be created
C                       on the same disk as the old file.
C            BLC        R(7)   the coordinate in the source file to
C                       become the bottom left hand coordinate (1,1)
C                       of the subimage.  BLC(1) is the X value and
C                       BLC(2) is the Y value.  The first coordinate
C                       IN the source map is (1,1). Any BLC(I) equal
C                       to zero defaults to 1.
C            TRC        R(7)   the coordinate in the source file to
C                       become the top right hand corner of the
C                       subimage.  The conventions used for BLC hold.
C            XINC       The X increment to use when selecting X pixels
C                       from the source file. Any TRC(I) equal to zero
C                       defaults to the maximum corresponding dimension
C                       in the source file header.
C            YINC       The Y increment to use when selecting lines
C                       from the source file.
C            ZINC       The Z increment (on plane 3)
C            OPCODE     '   ' take the nth value
C                       'AVE' Average values in XINC, YINC box
C                       'MIN' Take Minimum value in XINC, YINC box
C                       'MAX' Take Maximum value in XINC, YINC box
C                       'SUM' Sum values
C-----------------------------------------------------------------------
      INCLUDE 'SUBIM.INC'
      INTEGER   IRET, NX, NY, NWORDS, IERR
      CHARACTER PRGNAM*6
      LONGINT   PIMAGE, PWEIGH
      REAL      IMAGE(2), WEIGHT(2)
      INTEGER   COUNT(2)
      EQUIVALENCE (COUNT, WEIGHT)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA PRGNAM /'SUBIM'/
C-----------------------------------------------------------------------
C                                       init and create output file
      CALL SUBIMI (PRGNAM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       average over ZINC
      IF ((DOMATH) .AND. (IZINC.GT.1)) THEN
         NX = ((ISWIN(3) - ISWIN(1)) / IXINC) + 1
         NY = ((ISWIN(4) - ISWIN(2)) / IYINC) + 1
         NWORDS = (NX * NY - 1) / 1024 + 3
         CALL ZMEMRY ('GET ', TSKNAM, NWORDS, IMAGE, PIMAGE, IRET)
         IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, WEIGHT,
     *      PWEIGH, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'FAILED TO GET NEEDED DYNAMIC MEMORY'
            CALL MSGWRT (8)
         ELSE
            CALL SUBIMF (NX, NY, IMAGE(1+PIMAGE), COUNT(1+PWEIGH), IRET)
            END IF
C                                       simpler subim
      ELSE
         CALL SUBIMD (IRET)
         END IF
C                                       history
      IF (IRET.EQ.0) CALL SUBIMH
C                                       Release AIPS if wait state.
 990  IF ((DOMATH) .AND. (IZINC.GT.1)) CALL ZMEMRY ('FRAL', TSKNAM,
     *   NWORDS, IMAGE, PIMAGE, IERR)
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE SUBIMI (PRGNAM, IRET)
C-----------------------------------------------------------------------
C   Init the task and crete the output image
C   Inputs:
C      PRGNAM   C*6   Task name
C   Outputs:
C      IRET     I     Error code: > 0 => quit
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*(*)
      INTEGER   IRET
C
      INCLUDE 'SUBIM.INC'
      INTEGER   INPRMS, IERR, IROUND, IUSER, I
      LOGICAL   CHANGE
      CHARACTER MTYPE*2, IDNAME*12, IDCLAS*6, CBLANK*6
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA CBLANK /' '/
C-----------------------------------------------------------------------
C                                       Initialize the I/O parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NCFILE = 0
      NSCR = 0
C                                       Get input values from AIPS.
      INPRMS = 32
      CALL GTPARM (PRGNAM, INPRMS, RQUICK, XNAMIN, SCRTCH, IERR)
      IRET = IERR
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (7)
         END IF
C
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 8
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
      CALL H2CHR (12, 1, XNMOUT, NAMOUT)
      CALL H2CHR (6, 1, XCLOUT, CLSOUT)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
C                                       Average, Minimum or Maximum
      DOAVE = OPCODE(:3).EQ.'AVE'
      DOMIN = OPCODE(:3).EQ.'MIN'
      DOMAX = OPCODE(:3).EQ.'MAX'
      DOSUM = OPCODE(:3).EQ.'SUM'
      DOMATH= DOMIN .OR. DOMAX .OR. DOAVE .OR. DOSUM
C                                       Set initial values.
      ISVOL = IROUND (DSKIN)
      ISSEQ = IROUND (SEQIN)
      IDVOL = IROUND (DSKOUT)
      IDSEQ = IROUND (SEQOUT)
      IXINC = IROUND (XINC)
      IYINC = IROUND (YINC)
      IZINC = IROUND (ZINC)
      IXINC = MAX (1, IXINC)
      IYINC = MAX (1, IYINC)
      IZINC = MAX (1, IZINC)
      XINC = IXINC
      YINC = IYINC
      ZINC = IZINC
      IUSER = NLUSER
      ISLUN = 17
      IDLUN = 18
C                                       Open source file.
      IMTYPE = '  '
      CALL MAPOPN ('READ', ISVOL, NAMIN, CLSIN, ISSEQ, IMTYPE, IUSER,
     *   ISLUN, ISIND, ISSLOT, CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = ISVOL
      FCNO(NCFILE) = ISSLOT
      FRW(NCFILE) = 0
      IF ((IMTYPE.EQ.'UV') .OR. (CATBLK(KIPCN).GT.0)) THEN
         MSGTXT = 'DOES NOT WORK ON UV DATA SETS'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Save source file dim values.
      CALL COPY (7, CATBLK(KINAX), IDIMS)
C                                       Set default values BLC, TRC.
      INODIM = CATBLK(KIDIM)
      CALL WINDOW (INODIM, IDIMS, BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Build new file cat name.
      IDNAME = NAMOUT
      IDCLAS = CLSOUT
      CALL MAKOUT (NAMIN, CLSIN, ISSEQ, CBLANK, IDNAME, IDCLAS, IDSEQ)
      IF (IDNAME.EQ.'SCRATCH FILE') IDNAME = 'WAS SCRATCH'
C                                       Set header values needed
C                                       by MCREAT.
      CALL SUBHDR (BLC, TRC, XINC, YINC, ZINC)
      CALL CHR2H (12, IDNAME, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, IDCLAS, KHIMCO, CATH(KHIMC))
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
      CATBLK(KIIMS) = IDSEQ
      NAMOUT = IDNAME
      CLSOUT = IDCLAS
C                                       Create new cataloged file.
      CALL MCREAT (IDVOL, IDSLOT, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      IDSEQ = CATBLK(KIIMS)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = IDVOL
      FCNO(NCFILE) = IDSLOT
      FRW(NCFILE) = 2
C                                       Copy any header keywords
      CALL KEYCOP (ISVOL, ISSLOT, IDVOL, IDSLOT, IERR)
C                                       Allow failure
      IERR = 0
C                                       Open new file.
      MTYPE = 'MA'
      CALL MAPOPN ('INIT', IDVOL, IDNAME, IDCLAS, IDSEQ, MTYPE, IUSER,
     *   IDLUN, IDIND, IDSLOT, CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      IRET = 0
      CHANGE = .FALSE.
      I = BLC(1) + IXINC * (CATBLK(KINAX) - 1) + 0.1
      IF (I.NE.TRC(1)) THEN
         CHANGE = .TRUE.
         TRC(1) = I
         END IF
      I = BLC(2) + IYINC * (CATBLK(KINAX+1) - 1) + 0.1
      IF (I.NE.TRC(2)) THEN
         CHANGE = .TRUE.
         TRC(2) = I
         END IF
      I = BLC(3) + IZINC * (CATBLK(KINAX+2) - 1) + 0.1
      IF (I.NE.TRC(3)) THEN
         CHANGE = .TRUE.
         TRC(3) = I
         END IF
      IF (CHANGE) THEN
         MSGTXT = 'TRC ALTERED TO MATCH INCREMENTS'
         CALL MSGWRT (6)
         END IF
      ISWIN(1) = IROUND (BLC(1))
      ISWIN(2) = IROUND (BLC(2))
      ISWIN(3) = IROUND (TRC(1))
      ISWIN(4) = IROUND (TRC(2))
      INDX3L = IROUND (BLC(3))
      INDX3U = IROUND (TRC(3))
      INDX4L = IROUND (BLC(4))
      INDX4U = IROUND (TRC(4))
      INDX5L = IROUND (BLC(5))
      INDX5U = IROUND (TRC(5))
      INDX6L = IROUND (BLC(6))
      INDX6U = IROUND (TRC(6))
      INDX7L = IROUND (BLC(7))
      INDX7U = IROUND (TRC(7))
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR GETTING PARAMETERS FROM AIPS. ERR=',I5)
      END
      SUBROUTINE SUBIMD (IRET)
C-----------------------------------------------------------------------
C   Does simpler SUBIM operation - either taking single voxels or
C   averaging only in X and Y.
C   Outputs:
C      IRET   I   > 0 => failure
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'SUBIM.INC'
C
      REAL      TEMP, RMAX, RMIN, SUMBUF(MABFSS)
      INTEGER   IBLKOF, IDEPTH(5), IDWIN(4), I, IDPOS, IDX, IDY, II,
     *   III, INDEX, IM, INDX3, INDX4, INDX5, INDX6, INDX7, ISPOS, ISX,
     *   ISY, NBY, NCOUNT(MAXIMG)
      LOGICAL   MAP, SAVE, WASBLK
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (MAP, SAVE)
      DATA MAP /.TRUE./
C-----------------------------------------------------------------------
      WASBLK = .FALSE.
      NBY = 2 * MABFSS
C
      ISX = ISWIN(3) - ISWIN(1) + 1
      ISY = ISWIN(4) - ISWIN(2) + 1
      IDX = ((ISWIN(3) - ISWIN(1)) / IXINC) + 1
      IDY = ((ISWIN(4) - ISWIN(2)) / IYINC) + 1
C                                       Window for destination file.
      IDWIN(1) = 1
      IDWIN(2) = 1
      IDWIN(3) = IDX
      IDWIN(4) = IDY
C                                       Init values for loop.
      RMIN = MAX (1.0E20, ABS(CATR(KRDMX)), ABS(CATR(KRDMN)))
      RMAX = -RMIN
C                                       Loop for all possible planes.
      DO 200 INDX7 = INDX7L,INDX7U
      DO 199 INDX6 = INDX6L,INDX6U
      DO 198 INDX5 = INDX5L,INDX5U
      DO 197 INDX4 = INDX4L,INDX4U
      DO 196 INDX3 = INDX3L,INDX3U,IZINC
C                                       Set corner selection.
         IDEPTH(1) = INDX3
         IDEPTH(2) = INDX4
         IDEPTH(3) = INDX5
         IDEPTH(4) = INDX6
         IDEPTH(5) = INDX7
C                                       Block offset for source file.
         CALL COMOFF (INODIM, IDIMS, IDEPTH, IBLKOF, IRET)
         IF (IRET.NE.0) GO TO 999
         IBLKOF = IBLKOF + 1
C                                       Initialize for double buffering
         CALL MINIT ('READ', ISLUN, ISIND, IDIMS(1), IDIMS(2), ISWIN,
     *      RSBUFF, NBY, IBLKOF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            CALL MSGWRT (7)
            GO TO 999
            END IF
C                                       Find block offset for subimage.
         IDEPTH(1) = (INDX3 - INDX3L) / IZINC + 1
         IDEPTH(2) = INDX4 - INDX4L + 1
         IDEPTH(3) = INDX5 - INDX5L + 1
         IDEPTH(4) = INDX6 - INDX6L + 1
         IDEPTH(5) = INDX7 - INDX7L + 1
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH, IBLKOF,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         IBLKOF = IBLKOF + 1
C
         CALL MINIT ('WRIT', IDLUN, IDIND, IDX, IDY, IDWIN, RDBUFF, NBY,
     *      IBLKOF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1110) IRET
            CALL MSGWRT (7)
            GO TO 999
            END IF
C                                       Read from source, write to
C                                       subimage file.
         CALL FILL (IDX, 0, NCOUNT)
         DO 150 I = 1,ISY
C                                       read all rows
            CALL MDISK ('READ', ISLUN, ISIND, RSBUFF, ISPOS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1115) IRET
               CALL MSGWRT (7)
               GO TO 999
               END IF
C                                       If do math on region
C                                       Init index to write buffer.
            IM = 0
C                                       for all ranges on row
            DO 130 II = 1,ISX,IXINC
C                                       Increment tranfer index
               IM = IM + 1
C                                       For all pixels in range
               IF (DOMATH) THEN
                  DO 120 III = 1,IXINC
C                                       Calc index to range
                     INDEX = II + III - 2
C                                       If still in range
                     IF ((INDEX.GE.0) .AND. (INDEX.LT.ISX)) THEN
                        TEMP = RSBUFF(ISPOS+INDEX)
C                                       If not blanked
                        IF (TEMP.NE.FBLANK) THEN
C                                       If no counts yet
C                                       Just copy value
                           IF (NCOUNT(IM).EQ.0) THEN
                              SUMBUF(IM) = TEMP
C                                       Add to sum
                           ELSE IF ((DOAVE) .OR. (DOSUM)) THEN
                              SUMBUF(IM) = SUMBUF(IM) + TEMP
C                                       Return minimum
                           ELSE IF (DOMIN) THEN
                              SUMBUF(IM) = MIN (SUMBUF(IM),TEMP)
C                                       Return Maximum
                           ELSE IF (DOMAX) THEN
                              SUMBUF(IM) = MAX (SUMBUF(IM),TEMP)
                              END IF
C                                       increment unblanked pixel count
                           NCOUNT(IM) = NCOUNT(IM) + 1
                           END IF
                        END IF
 120                 CONTINUE
               ELSE IF (MOD(I-1,IYINC).EQ.0) THEN
                  SUMBUF(IM) = RSBUFF(ISPOS+II-1)
                  NCOUNT(IM) = 1
                  END IF
 130           CONTINUE
C                                       Do actual write
C                                       If last of range and math
            IF ((I/IYINC)*IYINC.EQ.I) THEN
C                                       "write" to set index
               CALL MDISK ('WRIT', IDLUN, IDIND, RDBUFF, IDPOS, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1120) IRET
                  CALL MSGWRT (7)
                  GO TO 999
                  END IF
C                                       Init transfer index
               IM = 0
C                                       Scale, Get Min, Max
               DO 140 II = 1,ISX,IXINC
C                                       Increment transfer index
                  IM = IM + 1
C                                       If averaging
C                                       If unblanked data, scale
                  IF (NCOUNT(IM).GT.0) THEN
C                                       Transfer extream or Scale Sum
                     IF (DOAVE) THEN
                        TEMP = SUMBUF(IM) / NCOUNT(IM)
                     ELSE
                        TEMP = SUMBUF(IM)
                        END IF
C                                       Else blanked
                  ELSE
                     TEMP = FBLANK
                     END IF
C                                       Record extreama
                  IF (TEMP.NE.FBLANK) THEN
                     RMAX = MAX (RMAX, TEMP)
                     RMIN = MIN (RMIN, TEMP)
                  ELSE
                     WASBLK = .TRUE.
                     END IF
C                                       Transfer data
                  RDBUFF(IDPOS+IM-1) = TEMP
 140              CONTINUE
C                                       If averaging, init re-counts
               CALL FILL (IDX, 0, NCOUNT)
               END IF
C                                       End for all rows loop
 150        CONTINUE
C                                       Write last buffer.
         CALL MDISK ('FINI', IDLUN, IDIND, RDBUFF, IDPOS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1150) IRET
            CALL MSGWRT (7)
            GO TO 999
            END IF
 196     CONTINUE
 197     CONTINUE
 198     CONTINUE
 199     CONTINUE
 200     CONTINUE
C                                       Create new header.
C                                       Start with old header info.
      IF (RMAX.EQ.RMIN) THEN
         WRITE (MSGTXT,1200) RMAX
         CALL MSGWRT (6)
      ELSE IF (RMAX.LT.RMIN) THEN
         MSGTXT = 'NO VALID PIXELS FOUND'
         CALL MSGWRT (7)
         END IF
      CATR(KRDMN) = RMIN
      CATR(KRDMX) = RMAX
      CATR(KRBLK) = 0.0
      IF (WASBLK) CATR(KRBLK) = FBLANK
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('MINIT READ ERROR',I5)
 1110 FORMAT ('MINIT WRITE ERROR',I5)
 1115 FORMAT ('DOUBLE BUFFERED READ ERROR',I5)
 1120 FORMAT ('DOUBLE BUFFERED WRITE ERROR',I5)
 1150 FORMAT ('MDISK FINI ERROR',I5)
 1200 FORMAT ('Warning: subimage constant at',1PE13.5)
      END
      SUBROUTINE SUBIMF (NX, NY, IMAGE, COUNT, IRET)
C-----------------------------------------------------------------------
C   Does simpler SUBIM operation - either taking single voxels or
C   averaging only in X and Y.
C   Note that DOMATH is true and IZINC > 1 in this routine
C   Outputs:
C      IRET   I   > 0 => failure
C-----------------------------------------------------------------------
      INTEGER   NX, NY, COUNT(NX,NY), IRET
      REAL      IMAGE(NX,NY)
C
      INCLUDE 'SUBIM.INC'
C
      REAL      TEMP, RMAX, RMIN
      INTEGER   IBLKOF, IDEPTH(5), IDWIN(4), I, IDPOS, IDX, IDY, II,
     *   III, INDEX, IM, IN, INDX3, INDX4, INDX5, INDX6, INDX7, ISPOS,
     *   ISX, ISY, NBY, NPTS, INSX3
      LOGICAL   MAP, SAVE, WASBLK
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (MAP, SAVE)
      DATA MAP /.TRUE./
C-----------------------------------------------------------------------
      WASBLK = .FALSE.
      NBY = 2 * MABFSS
C
      ISX = ISWIN(3) - ISWIN(1) + 1
      ISY = ISWIN(4) - ISWIN(2) + 1
      IDX = (ISWIN(3) - ISWIN(1)) / IXINC + 1
      IDY = (ISWIN(4) - ISWIN(2)) / IYINC + 1
C                                       Window for destination file.
      IDWIN(1) = 1
      IDWIN(2) = 1
      IDWIN(3) = NX
      IDWIN(4) = NY
      NPTS = NX * NY
C                                       Init values for loop.
      RMIN = MAX (1.0E20, ABS(CATR(KRDMX)), ABS(CATR(KRDMN)))
      RMAX = -RMIN
C                                       Loop for all possible planes.
      DO 200 INDX7 = INDX7L,INDX7U
      DO 199 INDX6 = INDX6L,INDX6U
      DO 198 INDX5 = INDX5L,INDX5U
      DO 197 INDX4 = INDX4L,INDX4U
      DO 196 INDX3 = INDX3L,INDX3U,IZINC
C                                       zero summing locations
         CALL RFILL (NPTS, 0.0, IMAGE)
         CALL FILL (NPTS, 0, COUNT)
C                                       Find block offset for subimage.
         IDEPTH(1) = (INDX3 - INDX3L) / IZINC + 1
         IDEPTH(2) = INDX4 - INDX4L + 1
         IDEPTH(3) = INDX5 - INDX5L + 1
         IDEPTH(4) = INDX6 - INDX6L + 1
         IDEPTH(5) = INDX7 - INDX7L + 1
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH, IBLKOF,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         IBLKOF = IBLKOF + 1
C
         CALL MINIT ('WRIT', IDLUN, IDIND, NX, NY, IDWIN, RDBUFF, NBY,
     *      IBLKOF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1110) IRET
            CALL MSGWRT (7)
            GO TO 999
            END IF
C                                       loop over input planes
C                                       for this output plane
         DO 150 INSX3 = INDX3,INDX3+IZINC-1
C                                       Set corner selection.
            IDEPTH(1) = INSX3
            IDEPTH(2) = INDX4
            IDEPTH(3) = INDX5
            IDEPTH(4) = INDX6
            IDEPTH(5) = INDX7
C                                       Block offset for source file.
            CALL COMOFF (INODIM, IDIMS, IDEPTH, IBLKOF, IRET)
            IF (IRET.NE.0) GO TO 999
            IBLKOF = IBLKOF + 1
C                                       Initialize for double buffering
            CALL MINIT ('READ', ISLUN, ISIND, IDIMS(1), IDIMS(2), ISWIN,
     *         RSBUFF, NBY, IBLKOF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1100) IRET
               CALL MSGWRT (7)
               GO TO 999
               END IF
C                                       Read from source, add to
C                                       subimage array
            DO 140 I = 1,ISY
C                                       read all rows
               CALL MDISK ('READ', ISLUN, ISIND, RSBUFF, ISPOS, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1115) IRET
                  CALL MSGWRT (7)
                  GO TO 999
                  END IF
C                                       Init index to write buffer.
               IM = 0
               IN = (I - 1) / IYINC + 1
               DO 130 II = 1,ISX,IXINC
                  IM = IM + 1
C                                       For all pixels in range
                  DO 120 III = 1,IXINC
C                                       Calc index to range
                     INDEX = II + III - 2
C                                       If still in range
                     IF ((INDEX.GE.0) .AND. (INDEX.LT.ISX)) THEN
                        TEMP = RSBUFF(ISPOS+INDEX)
                        IF (TEMP.NE.FBLANK) THEN
C                                       If no counts yet
C                                       Just copy value
                           IF (COUNT(IM,IN).LE.0) THEN
                              IMAGE(IM,IN) = TEMP
C                                       Add to sum
                           ELSE IF (DOAVE) THEN
                              IMAGE(IM,IN) = IMAGE(IM,IN) + TEMP
C                                       Return minimum
                           ELSE IF (DOMIN) THEN
                              IMAGE(IM,IN) = MIN (IMAGE(IM,IN), TEMP)
C                                       Return Maximum
                           ELSE IF (DOMAX) THEN
                              IMAGE(IM,IN) = MAX (IMAGE(IM,IN), TEMP)
                              END IF
                           COUNT(IM,IN) = COUNT(IM,IN) + 1
                           END IF
                        END IF
 120                 CONTINUE
 130              CONTINUE
 140           CONTINUE
 150        CONTINUE
C                                       Do actual write whole plane
         DO 170 I = 1,IDY
C                                       The first write sets up indicies
            CALL MDISK ('WRIT', IDLUN, IDIND, RDBUFF, IDPOS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) IRET
               CALL MSGWRT (7)
               GO TO 999
               END IF
            DO 160 II = 1,IDX
C                                       average
               IF (COUNT(II,I).GT.0) THEN
                  IF (DOAVE) THEN
                     TEMP = IMAGE(II,I) / COUNT(II,I)
                  ELSE
                     TEMP = IMAGE(II,I)
                     END IF
                  RMAX = MAX (RMAX, TEMP)
                  RMIN = MIN (RMIN, TEMP)
               ELSE
                  TEMP = FBLANK
                  WASBLK = .TRUE.
                  END IF
               RDBUFF(IDPOS+II-1) = TEMP
 160           CONTINUE
 170        CONTINUE
C                                       Write last buffer.
         CALL MDISK ('FINI', IDLUN, IDIND, RDBUFF, IDPOS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1150) IRET
            CALL MSGWRT (7)
            GO TO 999
            END IF
 196     CONTINUE
 197     CONTINUE
 198     CONTINUE
 199     CONTINUE
 200     CONTINUE
C                                       Create new header.
C                                       Start with old header info.
      IF (RMAX.EQ.RMIN) THEN
         WRITE (MSGTXT,1200) RMAX
         CALL MSGWRT (6)
      ELSE IF (RMAX.LT.RMIN) THEN
         MSGTXT = 'NO VALID PIXELS FOUND'
         CALL MSGWRT (7)
         END IF
      CATR(KRDMN) = RMIN
      CATR(KRDMX) = RMAX
      CATR(KRBLK) = 0.0
      IF (WASBLK) CATR(KRBLK) = FBLANK
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('MINIT READ ERROR',I5)
 1110 FORMAT ('MINIT WRITE ERROR',I5)
 1115 FORMAT ('DOUBLE BUFFERED READ ERROR',I5)
 1120 FORMAT ('DOUBLE BUFFERED WRITE ERROR',I5)
 1150 FORMAT ('MDISK FINI ERROR',I5)
 1200 FORMAT ('WARNING: SUBIMAGE CONSTANT AT',1PE13.5)
      END
      SUBROUTINE SUBIMH
C-----------------------------------------------------------------------
C   copies tables, writes history
C-----------------------------------------------------------------------
C
      INCLUDE 'SUBIM.INC'
C
      INTEGER   IH1LUN, IH2LUN, NFILES, IERR
      CHARACTER NOTTYP*2, HILINE*72
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA IH1LUN, IH2LUN /27, 28/
      DATA NOTTYP /'  '/
      DATA NFILES /2/
C-----------------------------------------------------------------------
C                                       Initialize HITAB
      CALL HIINIT (NFILES)
C                                       Create and copy history file.
      CALL HISCOP (IH1LUN, IH2LUN, ISVOL, IDVOL, ISSLOT, IDSLOT,
     *   CATBLK, ISBUFF, IDBUFF, IERR)
      IF (IERR.GT.3) GO TO 300
      IF (IERR.EQ.3) GO TO 220
C                                       Add SUBIM history.
      CALL HENCO1 (TSKNAM, NAMIN, CLSIN, ISSEQ, ISVOL, IH2LUN,
     *   IDBUFF, IERR)
      IF (IERR.NE.0) GO TO 220
      WRITE (HILINE,1210) IMTYPE, NLUSER
      CALL HIADD (IH2LUN, HILINE, IDBUFF, IERR)
      IF (IERR.NE.0) GO TO 220
      CALL HENCOO (TSKNAM, NAMOUT, CLSOUT, IDSEQ, IDVOL, IH2LUN,
     *   IDBUFF, IERR)
      IF (IERR.NE.0) GO TO 220
      WRITE (HILINE,1211) ISWIN(1), ISWIN(2), INDX3L, INDX4L, INDX5L,
     *   INDX6L, INDX7L
      CALL HIADD (IH2LUN, HILINE, IDBUFF, IERR)
      IF (IERR.NE.0) GO TO 220
      WRITE (HILINE,1212) ISWIN(3), ISWIN(4), INDX3U, INDX4U, INDX5U,
     *   INDX6U, INDX7U
      CALL HIADD (IH2LUN, HILINE, IDBUFF, IERR)
      IF (IERR.NE.0) GO TO 220
      WRITE (HILINE,1213) IXINC
      CALL HIADD (IH2LUN, HILINE, IDBUFF, IERR)
      IF (IERR.NE.0) GO TO 220
      WRITE (HILINE,1214) IYINC
      CALL HIADD (IH2LUN, HILINE, IDBUFF, IERR)
      IF (IERR.NE.0) GO TO 220
      WRITE (HILINE,1215) IZINC
      CALL HIADD (IH2LUN, HILINE, IDBUFF, IERR)
      IF (IERR.NE.0) GO TO 220
      WRITE (HILINE,1216) OPCODE
      CALL HIADD (IH2LUN, HILINE, IDBUFF, IERR)
 220  CALL HICLOS (IH2LUN, .TRUE., IDBUFF, IERR)
C                                       Copy CC files and others
 300  CALL ALLTAB (0, NOTTYP, IH1LUN, IH2LUN, ISVOL, IDVOL, ISSLOT,
     *   IDSLOT, CATBLK, ISBUFF, IDBUFF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1210 FORMAT ('SUBIM INTYPE =''',A2,'''',6X,'USERID=',I5)
 1211 FORMAT ('SUBIM BLC    =',2(I5,','),4(I5,','),I5)
 1212 FORMAT ('SUBIM TRC    =',2(I5,','),4(I5,','),I5)
 1213 FORMAT ('SUBIM XINC   =',I5)
 1214 FORMAT ('SUBIM YINC   =',I5)
 1215 FORMAT ('SUBIM ZINC   =',I5)
 1216 FORMAT ('SUBIM OPCODE = ''',A,'''')
      END
      SUBROUTINE SUBHDR (BLC, TRC, XINC, YINC, ZINC)
C-----------------------------------------------------------------------
C   SUBHDR corrects the header for subimaging: changes number of points
C   on the axes, the reference pixels, and the alternate axis (freq vs
C   velocity) reference pixel.  It corrects the first two axes for use
C   of pixel increments - namely the reference pixel and the axis incr.
C   Inputs:
C      BLC    R(7)        Bottom left corner to use
C      TRC    R(7)        Top right corner to use
C      XINC   R           Pixel increment on first axis
C      YINC   R           Pixel increment on second axis
C   Common:
C      /MAPHDR/ CATBLK     map header (in/out)
C-----------------------------------------------------------------------
      REAL      BLC(7), TRC(7), XINC, YINC, ZINC
C
      CHARACTER FCHARS(3)*4, CHTEMP*4
      HOLLERITH CATH(256)
      REAL      CATR(256), AINC(7)
      INTEGER   IPL, IPH, CATBLK(256), NAX, I, J
      DOUBLE PRECISION    CATD(128)
      INCLUDE 'INCS:DHDR.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK, CATH, CATR, CATD)
      DATA FCHARS /'FREQ','VELO','FELO'/
C-----------------------------------------------------------------------
C                                       Regular axis parameters
      NAX = CATBLK(KIDIM)
      CALL RFILL (7, 1.0, AINC)
      IF (XINC.GT.0.001) AINC(1) = XINC
      IF (YINC.GT.0.001) AINC(2) = YINC
      IF (ZINC.GT.0.001) AINC(3) = ZINC
      DO 10 I = 1,NAX
         IPL = BLC(I) + 0.01
         IPH = TRC(I) + 0.01
         CATBLK(KINAX+I-1) = (IPH - IPL) / AINC(I) + 1
         CATR(KRCRP+I-1) = (CATR(KRCRP+I-1) - IPL) / AINC(I) + 1.
         CATR(KRCIC+I-1) = CATR(KRCIC+I-1) * AINC(I)
 10      CONTINUE
C                                       Alternate axis
      IF (CATBLK(KIALT).NE.0) THEN
         DO 25 I = 1,NAX
            IPL = KHCTP + (I-1) * 2
            CALL H2CHR (4, 1, CATH(IPL), CHTEMP)
            DO 20 J = 1,3
C                                       Found one
               IF (FCHARS(J).EQ.CHTEMP) THEN
                  IPL = BLC(I) + 0.01
                  CATR(KRARP) = (CATR(KRARP) - IPL) / AINC(I) + 1.0
                  GO TO 999
                  END IF
 20            CONTINUE
 25         CONTINUE
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'SPCOR.INC'
C                                       Local include for SPCOR
C                                       inputs, headers
      HOLLERITH XNAME1(3), XNAME2(3), XNAME3(3), XCLAS1(2), XCLAS2(2),
     *   XCLAS3(2), XNAMEO(3), XCLASO(2)
      REAL      XSEQ1, XSEQ2, XSEQ3, XDISK1, XDISK2, XDISK3, XBLC(7),
     *   XTRC(7), XSEQO, XDISKO, PBPARM(7), XFREQ, XCOORD(6), RADIUS,
     *   DOBLNK, DOINV
      CHARACTER NAME1*12, NAME2*12, NAME3*12, NAMEO*12, CLAS1*6,
     *    CLAS2*6, CLAS3*6, CLASO*6
      INTEGER   SEQ1, SEQ2, SEQ3, SEQO, DISK1, DISK2, DISK3, DISKO,
     *   CATII(256,3), CATOI(256), CNO1, CNO2, CNO3, CNOO
      REAL      CATIR(256,3), CATOR(256)
      HOLLERITH CATIH(256,3), CATOH(256)
      DOUBLE PRECISION CATID(128,3), CATOD(128)
      EQUIVALENCE (CATII, CATIH, CATIR, CATID)
      EQUIVALENCE (CATOI, CATOR, CATOH, CATOD)
      COMMON /INPARM/ XNAME1, XCLAS1, XSEQ1, XDISK1, XNAME2, XCLAS2,
     *   XSEQ2, XDISK2, XNAME3, XCLAS3, XSEQ3, XDISK3, XBLC, XTRC,
     *   XNAMEO, XCLASO, XSEQO, XDISKO, PBPARM, XFREQ, XCOORD, RADIUS,
     *   DOBLNK, DOINV
      COMMON /HDRS/ CATII, CATOI
      COMMON /OTHERS/ SEQ1, SEQ2, SEQ3, SEQO, DISK1, DISK2, DISK3,
     *   DISKO, CNO1, CNO2, CNO3, CNOO
      COMMON /OTHERC/ NAME1, CLAS1, NAME2, CLAS2, NAME3, CLAS3, NAMEO,
     *   CLASO
C                                       buffers
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SCRBUF(512), JBUFSZ
      REAL      BUFF1(MABFSL), BUFF2(MABFSL)
      COMMON /BUFRS/ BUFF1, BUFF2, SCRBUF, JBUFSZ

C                                       coordinate parameters
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   LDEP(7), FQAX
      REAL      XPIX0, YPIX0, XINC, YINC
      DOUBLE PRECISION FREQS(MAXCHA), RAD0, DECD0, FRL0, POL0, COSR,
     *   SINR, RREFR, DREFR, RPTR, DPTR, DPTRC, DPTRS, X, Y, LAMBDA,
     *   RLAMBD, REFREQ
      COMMON /PBCHDR/ FREQS, X, Y, LAMBDA, RLAMBD, RAD0, DECD0, FRL0,
     *   POL0, COSR, SINR, RREFR, DREFR, RPTR, DPTR, DPTRC, DPTRS,
     *   REFREQ, XPIX0, YPIX0, XINC, YINC, LDEP, FQAX
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
LOCAL END
      PROGRAM SPCOR
C-----------------------------------------------------------------------
C! Task to correct an image for the primary beam and spectral index
C# Map-util Map
C-----------------------------------------------------------------------
C;  Copyright (C) 2011-2012, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SPCOR corrects an image for the primary beam response and/or for the
C   spectral index shown in a 2nd (and 3rd) image.  The primary image
C   may be a cube in any transposition, the spectral index images must
C   dingle planes.
C   INPUTS:
C      INNAME(3)                Image name (name)
C      INCLASS(2)                 Image name (class)
C      INSEQ                      Image name (seq. #)
C      INDISK                     Disk unit # of image
C      IN2NAME(3)               Image name (name) Spectral index
C      IN2CLASS(2)                Image name (class)
C      IN2SEQ                     Image name (seq. #)
C      IN2DISK                    Disk unit # of image
C      IN3NAME(3)               Image name (name) curvature
C      IN3CLASS(2)                Image name (class)
C      IN3SEQ                     Image name (seq. #)
C      IN3DISK                    Disk unit # of image
C      BLC(7)                   Bottom left corner to model
C      TRC(7)                   Top right corner to model
C      OUTNAME (3)              Output image name (name)
C      OUTCLASS(2)                Output image name (class)
C      OUTSEQ                     Output image name (seq. #)
C      OUTDISK                    Output image disk
C      PBPARM.......Control parameters:
C             (1)..Primary beam cutoff level.  0 => .023.  Pixels
C                  having lower sensitivity are blanked. >= 1 => no
C                  primary beam
C             (2)..> 0 => use PBPARM(3)-DPARM(7) to describe the
C                  primary beam.
C                  <= 0 => use parameters appropriate to VLA.
C             (3)..The beam is described by the function:
C                     PBPARM(3) + X*PBPARM(4) + X*X*PBPARM(5) +
C                        X*X*X*PBPARM(6) + X*X*X*X*PBPARM(7)
C                  where X is the square of the angular distance from
C                  the pointing position in arc minutes times the
C                  frequency in GHz.
C      X                        Reference to this frequency in GHz
C      RA(4)                    Pointing right ascension
C      DEC(4)                   Pointing declination
C      DOINVERS                 do inverse of correction
C-----------------------------------------------------------------------
      INTEGER   IRET, NWORDS, NIMAGE, NX2, NX3, NY2, NY3
      CHARACTER PRGNAM*6
      LONGINT   PSP0, PSP1
      REAL      SP0(2), SP1(2)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'SPCOR.INC'
      DATA PRGNAM /'SPCOR'/
C-----------------------------------------------------------------------
C                                       get inputs, create output
      CALL SPCORI (PRGNAM, NIMAGE, IRET)
      IF (IRET.NE.0) GO TO 900
C                                       read in spectral index images
      PSP0 = 0
      PSP1 = 0
      IF (NIMAGE.GE.2) THEN
         NX2 = CATII(KINAX,2)
         NY2 = CATII(KINAX+1,2)
         NWORDS = (NX2 * NY2 - 1) / 1024 + 5
         CALL ZMEMRY ('GET ', TSKNAM, NWORDS, SP0, PSP0, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY NEEDED'
            CALL MSGWRT (8)
            GO TO 900
            END IF
         CALL SPCORF (2, NX2, NY2, SP0(1+PSP0), IRET)
         IF (IRET.NE.0) GO TO 900
         END IF
      IF (NIMAGE.EQ.3) THEN
         NX3 = CATII(KINAX,2)
         NY3 = CATII(KINAX+1,3)
         NWORDS = (NX3 * NY3 - 1) / 1024 + 5
         CALL ZMEMRY ('GET ', TSKNAM, NWORDS, SP1, PSP1, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY NEEDED'
            CALL MSGWRT (8)
            GO TO 900
            END IF
         CALL SPCORF (3, NX3, NY3, SP1(1+PSP1), IRET)
         IF (IRET.NE.0) GO TO 900
         END IF
C                                       do it
      CALL SPCORD (NIMAGE, NX2, NY2, SP0(1+PSP0), NX3, NY3, SP1(1+PSP1),
     *   IRET)
      IF (IRET.EQ.0) CALL SPCORH (NIMAGE)
C
 900  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE SPCORI (PRGNAM, NIMAGE, IRET)
C-----------------------------------------------------------------------
C   Gets the inputs for SPCOR and creates the output image
C   Inputs:
C      PRGNAM   C*6   Program name
C   Outputs:
C      NIMAGE   I     Number of input images 1, 2, or 3
C      IRET     I     Error code
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*(*)
      INTEGER   NIMAGE, IRET
C
      INTEGER   NPARM, IERR, IROUND
      CHARACTER PTYPE*2, STAT*4
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'SPCOR.INC'
C-----------------------------------------------------------------------
C                                       init system
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NCFILE = 0
      NSCR = 0
      JBUFSZ = MABFSL
C                                       get input adverbs
      NPARM = 59
      CALL GTPARM (PRGNAM, NPARM, RQUICK, XNAME1, SCRBUF, IERR)
      IRET = IERR
      IF (IERR.NE.0) THEN
         RQUICK = .FALSE.
         WRITE (MSGTXT,1000) IERR, 'GETTING ADVERB VALUES'
         GO TO 990
         END IF
      IF (RQUICK) CALL RELPOP (IRET, SCRBUF, IERR)
C                                       hollerith -> char etc
      CALL H2CHR (12, 1, XNAME1, NAME1)
      CALL H2CHR (12, 1, XNAME2, NAME2)
      CALL H2CHR (12, 1, XNAME3, NAME3)
      CALL H2CHR (12, 1, XNAMEO, NAMEO)
      CALL H2CHR (6, 1, XCLAS1, CLAS1)
      CALL H2CHR (6, 1, XCLAS2, CLAS2)
      CALL H2CHR (6, 1, XCLAS3, CLAS3)
      CALL H2CHR (6, 1, XCLASO, CLASO)
      SEQ1 = IROUND (XSEQ1)
      SEQ2 = IROUND (XSEQ2)
      SEQ3 = IROUND (XSEQ3)
      SEQO = IROUND (XSEQO)
      DISK1 = IROUND (XDISK1)
      DISK2 = IROUND (XDISK2)
      DISK3 = IROUND (XDISK3)
      DISKO = IROUND (XDISKO)
C                                       find input image
      CNO1 = 1
      PTYPE = 'MA'
      CALL CATDIR ('SRCH', DISK1, CNO1, NAME1, CLAS1, SEQ1, PTYPE,
     *   NLUSER, STAT, SCRBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, NAME1, CLAS1, SEQ1, DISK1
         GO TO 990
         END IF
      CALL CATIO ('READ', DISK1, CNO1, CATBLK, 'READ', SCRBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ IMAGE 1 HEADER'
         GO TO 990
         END IF
      CALL COPY (256, CATBLK, CATII(1,1))
      NIMAGE = 1
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK1
      FCNO(NCFILE) = CNO1
      FRW(NCFILE) = 0
      IF ((NAME2.NE.' ') .AND. (CLAS2.NE.' ')) THEN
         CNO2 = 1
         PTYPE = 'MA'
         CALL CATDIR ('SRCH', DISK2, CNO2, NAME2, CLAS2, SEQ2, PTYPE,
     *      NLUSER, STAT, SCRBUF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, NAME2, CLAS2, SEQ2, DISK2
            GO TO 990
            END IF
         CALL CATIO ('READ', DISK2, CNO2, CATII(1,2), 'READ', SCRBUF,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ IMAGE 2 HEADER'
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISK2
         FCNO(NCFILE) = CNO2
         FRW(NCFILE) = 0
         NIMAGE = 2
         END IF
      IF ((NIMAGE.EQ.2) .AND. (NAME3.NE.' ') .AND. (CLAS3.NE.' ')) THEN
         CNO3 = 1
         PTYPE = 'MA'
         CALL CATDIR ('SRCH', DISK3, CNO3, NAME3, CLAS3, SEQ3, PTYPE,
     *      NLUSER, STAT, SCRBUF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, NAME3, CLAS3, SEQ3, DISK3
            GO TO 990
            END IF
         CALL CATIO ('READ', DISK3, CNO3, CATII(1,3), 'READ', SCRBUF,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ IMAGE 3 HEADER'
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISK3
         FCNO(NCFILE) = CNO3
         FRW(NCFILE) = 0
         NIMAGE = 3
         END IF
C                                       check windows
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), XBLC, XTRC, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'SETTING WINDOW PARAMETERS'
         GO TO 990
         END IF
C                                       get frequency list
      CALL SPCORS (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       prepare output
      CALL MAKOUT (NAME1, CLAS1, SEQ1, PRGNAM, NAMEO, CLASO, SEQO)
      CALL SUBHDR (XBLC, XTRC, 1.0, 1.0)
      CALL CHR2H (12, NAMEO, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLASO, KHIMCO, CATH(KHIMN))
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
      CATBLK(KIIMS) = SEQO
C                                       create it
      CALL MCREAT (DISKO, CNOO, SCRBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATING OUTPUT IMAGE'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CNOO
      FRW(NCFILE) = 2
C                                       Copy any header keywords
      CALL KEYCOP (DISK1, CNO1, DISKO, CNOO, IRET)
      IRET = 0
      CALL COPY (256, CATBLK, CATOI)
C                                       pointing position
      RAD0 = ABS (XCOORD(1)) + ABS (XCOORD(2))/60.0D0 +
     *   ABS (XCOORD(3))/3600.0D0
      IF ((XCOORD(1).LT.0.0) .OR. (XCOORD(2).LT.0.0) .OR.
     *   (XCOORD(3).LT.0.0)) RAD0 = -RAD0
      RAD0 = RAD0 * 15.0D0
      DECD0 = ABS(XCOORD(4)) + ABS(XCOORD(5))/60.0D0 +
     *   ABS(XCOORD(6))/3600.0D0
      IF ((XCOORD(4).LT.0.0) .OR. (XCOORD(5).LT.0.0) .OR.
     *   (XCOORD(6).LT.0.0)) DECD0 = -DECD0
      IF ((RAD0.EQ.0.0D0) .AND. (DECD0.EQ.0.0D0)) THEN
         RAD0 = CATID(KDORA,1)
         DECD0 = CATID(KDODE,1)
         END IF
C
 990  IF (IRET.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPCORI: ERROR',I3,' ON ',A)
 1010 FORMAT ('SPCORI: ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3)
      END
      SUBROUTINE SPCORS (IRET)
C-----------------------------------------------------------------------
C   SPCORS computes or reads the list of frequencies
C   Outputs:
C      IRET   I   >0 => error
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IAX, I, J, VER, LUN, IFQRNO, FQKOLS(MAXFQC), NF,
     *   FQNUMV(MAXFQC), NUMIF, FQID, IFSIDE, IREC, NREC, FAX, IBLC,
     *   ITRC
      DOUBLE PRECISION IFFREQ, CV, CI, CP, FV
      REAL      IFCHW, IFTBW
      CHARACTER TEMP*4, BNDCOD*8
      INCLUDE 'SPCOR.INC'
C-----------------------------------------------------------------------
      I = KHCTP
      IAX = 0
      FAX = 0
      DO 10 J = 1,CATII(KIDIM,1)
         CALL H2CHR (4, 1, CATIH(I,1), TEMP)
         I = I + 2
         IF (TEMP.EQ.'FREQ') FAX = J
         IF (TEMP.EQ.'FQID') IAX = J
 10      CONTINUE
      IF (FAX.LE.0) THEN
         MSGTXT = 'FREQ AXIS NOT FOUND'
         IRET = 10
         GO TO 990
         END IF
C                                       reference freq
      IF (XFREQ.GT.0.0) THEN
         REFREQ = XFREQ
      ELSE
         REFREQ = CATID(KDCRV+FAX-1,1) / 1.D9
         END IF
C                                       axis set up
      IF (IAX.GT.0) THEN
         J = IAX
      ELSE
         J = FAX
         END IF
      FQAX = J
      IBLC = XBLC(J) + 0.1
      ITRC = XTRC(J) + 0.1
      CV = CATID(KDCRV+J-1,1)
      CI = CATIR(KRCIC+J-1,1)
      CP = CATIR(KRCRP+J-1,1)
      FV = CATID(KDCRV+FAX-1,1)
      NF = CATII(KINAX+J-1,1)
C                                       regular axis
      IF (IAX.EQ.0) THEN
         DO 40 I = 1,NF
            FREQS(I) = CV + (I - CP) * CI
 40         CONTINUE
C                                       read FQ table
      ELSE
         VER = 1
         LUN = 44
         NUMIF = 1
         CALL FQINI ('READ', SCRBUF, DISK1, CNO1, VER, CATII, LUN,
     *      IFQRNO, FQKOLS, FQNUMV, NUMIF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING FQ TABLE'
            GO TO 990
            END IF
         NREC = SCRBUF(5)
C                                       read
         CALL DFILL (ITRC, -1.0D0, FREQS)
         DO 50 IREC = 1,NREC
            CALL TABFQ ('READ', SCRBUF, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *         FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING FQ TABLE'
               GO TO 990
               END IF
            I = (FQID - CV) / CI + CP + 0.5
            IF ((I.GE.1) .AND. (I.LE.NF)) FREQS(I) = IFFREQ
     *         + FV
 50         CONTINUE
         CALL TABFQ ('CLOS', SCRBUF, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *      FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IREC)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPCORS: ERROR',i3,' ON ',A)
      END
      SUBROUTINE SPCORF (N, NX, NY, IMAGE, IRET)
C-----------------------------------------------------------------------
C   SPCORF reads in image N to memory - note that it reads one plane
C   which should be all there is
C   Inputs:
C      N       I          image number (2, 3)
C      NX      I          number X pixels
C      NY      I          number Y pixels
C   Outputs:
C      IMAGE   R(NX,NY)   image values
C      IRET    I          error code
C-----------------------------------------------------------------------
      INTEGER   N, NX, NY, IRET
      REAL      IMAGE(NX,NY)
C
      INTEGER   WIN(4), DEPTH(5), BLKOF, IY, LUN, IND, IPOS
      CHARACTER PHNAME*48
      INCLUDE 'SPCOR.INC'
      DATA DEPTH /5*1/
      DATA LUN /44/
C-----------------------------------------------------------------------
C                                       init IO
      IF (N.EQ.2) THEN
         CALL ZPHFIL ('MA', DISK2, CNO2, 1, PHNAME, IRET)
         CALL ZOPEN (LUN, IND, DISK2, PHNAME, .TRUE., .TRUE., .TRUE.,
     *      IRET)
      ELSE IF (N.EQ.3) THEN
         CALL ZPHFIL ('MA', DISK3, CNO3, 1, PHNAME, IRET)
         CALL ZOPEN (LUN, IND, DISK3, PHNAME, .TRUE., .TRUE., .TRUE.,
     *      IRET)
      ELSE
         IRET = 10
         GO TO 999
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING SPECTRAL INDEX IMAGE'
         GO TO 990
         END IF
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NX
      WIN(4) = NY
      CALL COMOFF (CATII(KIDIM,N), CATII(KINAX,N), DEPTH, BLKOF, IRET)
      BLKOF = BLKOF + 1
      CALL MINIT ('READ', LUN, IND, NX, NY, WIN, BUFF1, JBUFSZ, BLKOF,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT I/O TO SPECTRAL INDEX IMAGE'
         GO TO 990
         END IF
C                                       read and close
      DO 20 IY = 1,NY
         CALL MDISK ('READ', LUN, IND, BUFF1, IPOS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING SPECTRAL INDEX IMAGE'
            GO TO 990
            END IF
         CALL RCOPY (NX, BUFF1(IPOS), IMAGE(1,IY))
 20      CONTINUE
      CALL ZCLOSE (LUN, IND, IRET)
C                                       set location common
      LOCNUM = N
      CALL COPY (256, CATII(1,N), CATBLK)
      CALL SETLOC (DEPTH, .FALSE.)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPCORF: ERROR',I3,' ON ',A)
      END
      SUBROUTINE SPCORH (NIMAGE)
C-----------------------------------------------------------------------
c   write HI to output
C-----------------------------------------------------------------------
      INTEGER   NIMAGE
C
      INTEGER   LUN1, LUN2, IERR, IBLC(7), ITRC(7), I, RA(2), DEC(2),
     *   NONOT
      REAL      RAS, DECS
      CHARACTER HILINE*72, CHRASN*1, CHDCSN*1, NOTTYP*2
      INCLUDE 'SPCOR.INC'
      DATA LUN1, LUN2 /27,28/
      DATA NONOT, NOTTYP /1, 'CC'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
      CALL COPY (256, CATOI, CATBLK)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISK1, DISKO, CNO1, CNOO, CATBLK,
     *   SCRBUF(257), SCRBUF, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 60
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAME1, CLAS1, SEQ1, DISK1, LUN2, SCRBUF,
     *   IERR)
      IF (IERR.NE.0) GO TO 60
      IF (NIMAGE.GE.2) THEN
         CALL HENCO2 (TSKNAM, NAME2, CLAS2, SEQ2, DISK2, LUN2, SCRBUF,
     *      IERR)
         IF (IERR.NE.0) GO TO 60
         END IF
      IF (NIMAGE.GE.3) THEN
         CALL HENCO3 (TSKNAM, NAME3, CLAS3, SEQ3, DISK3, LUN2, SCRBUF,
     *      IERR)
         IF (IERR.NE.0) GO TO 60
         END IF
      CALL HENCOO (TSKNAM, NAMEO, CLASO, SEQO, DISKO, LUN2, SCRBUF,
     *   IERR)
      IF (IERR.NE.0) GO TO 60
C                                       corners
      DO 10 I = 1,7
         IBLC(I) = XBLC(I) + 0.1
         ITRC(I) = XTRC(I) + 0.1
 10      CONTINUE
      WRITE (HILINE,1010) TSKNAM, 'BLC', IBLC
      CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 60
      WRITE (HILINE,1010) TSKNAM, 'TRC', ITRC
      CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 60
C                                       if primary beam
      IF (PBPARM(1).LT.1.0) THEN
C                                          Pointing RA and DEC
         CALL COORDD (1, RAD0, CHRASN, RA, RAS)
         CALL COORDD (2, DECD0, CHDCSN, DEC, DECS)
         WRITE (HILINE,1020) TSKNAM, CHRASN, RA, RAS
         CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 60
         WRITE (HILINE,1021) TSKNAM, CHDCSN, DEC, DECS
         CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 60
C                                       cutoff level
         WRITE (HILINE,1025) TSKNAM, PBPARM(1)
         CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 60
C                                       beam shape
         WRITE (HILINE,1030) TSKNAM, 1.0
         CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 60
         WRITE (HILINE,1031) TSKNAM, PBPARM(3)
         CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 60
         WRITE (HILINE,1032) TSKNAM, PBPARM(4)
         CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 60
         WRITE (HILINE,1033) TSKNAM, PBPARM(5)
         CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 60
         WRITE (HILINE,1034) TSKNAM, PBPARM(6)
         CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 60
         WRITE (HILINE,1035) TSKNAM, PBPARM(7)
         CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 60
         WRITE (HILINE,1036) TSKNAM
         CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 60
C                                       no primary beam
      ELSE
         HILINE = TSKNAM // '/ No primary beam correction applied'
         CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 60
         END IF
C                                       Reference freq
      WRITE (HILINE,1040) TSKNAM, REFREQ
      CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 60
C                                       spectral index parms
      IF (NIMAGE.GE.2) THEN
         WRITE (HILINE,1041) TSKNAM, RADIUS
         CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 60
         IF (DOBLNK.GT.0.0) THEN
            HILINE = TSKNAM // '/ output blanked when spectral index'
     *         // ' blanked'
         ELSE
            HILINE = TSKNAM // '/ output not blanked when spectral'
     *         // ' index blanked'
            END IF
         END IF
C                                       DOINVERS
      IF (DOINV.GT.0.0) THEN
         HILINE = TSKNAM // '/ inverse correction actually done'
         CALL HIADD (LUN2, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 60
         END IF
      GO TO 70
C                                       HI error
 60   WRITE (MSGTXT,1060) IERR
      CALL MSGWRT (7)
C
 70   CALL HICLOS (LUN2, .TRUE., SCRBUF, IERR)
C                                       Copy tables
C                                       omit CC files - not true after
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISK1, DISKO, CNO1, CNOO,
     *   CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GE.1) THEN
         WRITE (MSGTXT,1070) IERR
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPCORH: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,A,'=',3(I6,','),3(I4,','),I4)
 1020 FORMAT (A6,'PRA= ',A1,I2.2,I3.2,F7.3,'  / pointing position')
 1021 FORMAT (A6,'PDec= ',A1,I2.2,I3.2,F6.2,'  / pointing position')
 1025 FORMAT (A6,'Beamcut=',F9.5,3X,'/Clip outside this beam value')
 1030 FORMAT (A6,'/ Beam = ',1PE13.6,' +',5X,'/ Beam  model')
 1031 FORMAT (A6,'/',8X,1PE13.6,' * X +')
 1032 FORMAT (A6,'/',8X,1PE13.6,' * X*X +')
 1033 FORMAT (A6,'/',8X,1PE13.6,' * X*X*X +')
 1034 FORMAT (A6,'/',8X,1PE13.6,' * X*X*X*X')
 1035 FORMAT (A6,'/',8X,1PE13.6,' * X*X*X*X*X')
 1036 FORMAT (A6,'/ Where X = [Angle(arcmin) * f(GHz)]**2')
 1040 FORMAT (A6,'RefFreq=',F9.4,' / GHz reference frequency')
 1041 FORMAT (A6,'RADIUS=',F7.2,' / pixels smoothing radius')
 1060 FORMAT ('CANNOT ADD LINES TO HI FILE.  IER=',I8)
 1070 FORMAT ('ERROR ',I3,' COPYING TABLES')
      END
      SUBROUTINE SPCORD (NIMAGE, NX2, NY2, SP0, NX3, NY3, SP1, IRET)
C-----------------------------------------------------------------------
C   SPCORD actually reads the input and causes the corrections to be
C   made to the output
C   Inputs:
C      NIMAGE   I            Number images used
C      NX2      I            Number X pixels spectral index image
C      NY2      I            Number Y pixels spectral index image
C      SP0      R(NX2,NY2)   Spectral index image
C      NX3      I            Number X pixels spectral curvature image
C      NY3      I            Number Y pixels spectral curvature image
C      SP1      R(NX3,NY3)   Spectral curvature image
C   Outputs:
C      IRET     I            Error code
C-----------------------------------------------------------------------
      INTEGER   NIMAGE, NX2, NY2, NX3, NY3, IRET
      REAL      SP0(NX2,NY2), SP1(NX3,NY3)
C
      INTEGER   I3, I4, I5, I6, I7, IBLC(7), ITRC(7), IDEPTH(7), LUNI,
     *   LUNO, NX, NY, IWIN(4), NXO, NYO, OWIN(4), INDI, INDO, IPOSI,
     *   IPOSO, ODEPTH(5), I, IBLKOF, IX, IY, IP
      REAL      DMAX, DMIN, CORFAC
      LOGICAL   BLANKD
      CHARACTER PHNAME*48
      INCLUDE 'SPCOR.INC'
      DATA LUNI, LUNO /27,28/
C-----------------------------------------------------------------------
      BLANKD = .FALSE.
      DMAX = -1.E20
      DMIN = 1.E20
C                                       windows
      DO 10 I = 1,7
         IBLC(I) = XBLC(I) + 0.1
         ITRC(I) = XTRC(I) + 0.1
 10      CONTINUE
      NX = CATII(KINAX,1)
      NY = CATII(KINAX+1,1)
      IWIN(1) = IBLC(1)
      IWIN(2) = IBLC(2)
      IWIN(3) = ITRC(1)
      IWIN(4) = ITRC(2)
      NXO = CATOI(KINAX)
      NYO = CATOI(KINAX+1)
      OWIN(1) = 1
      OWIN(2) = 1
      OWIN(3) = NXO
      OWIN(4) = NYO
C                                       open files
      CALL ZPHFIL ('MA', DISK1, CNO1, 1, PHNAME, IRET)
      CALL ZOPEN (LUNI, INDI, DISK1, PHNAME, .TRUE., .TRUE., .TRUE.,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT IMAGE'
         GO TO 990
         END IF
      CALL ZPHFIL ('MA', DISKO, CNOO, 1, PHNAME, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, PHNAME, .TRUE., .TRUE., .TRUE.,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT IMAGE'
         GO TO 990
         END IF
C                                       I/O
      IDEPTH(1) = IBLC(1)
      IP = 0
      CALL COPY (256, CATII(1,1), CATBLK)
      DO 100 I7 = IBLC(7),ITRC(7)
      DO 99 I6 = IBLC(6),ITRC(6)
      DO 98 I5 = IBLC(5),ITRC(5)
      DO 97 I4 = IBLC(4),ITRC(4)
      DO 96 I3 = IBLC(3),ITRC(3)
         IP = IP + 1
         IF (MOD(IP,20).EQ.0) THEN
            WRITE (MSGTXT,1001) IP
            CALL MSGWRT (2)
            END IF
C                                       position computing init
         CALL FILL (7, 0, LDEP)
C                                       Set corner selection.
         IDEPTH(3) = I3
         IDEPTH(4) = I4
         IDEPTH(5) = I5
         IDEPTH(6) = I6
         IDEPTH(7) = I7
C                                       Block offset for source file.
         CALL COMOFF (CATII(KIDIM,1), CATII(KINAX,1), IDEPTH(3), IBLKOF,
     *      IRET)
         IBLKOF = IBLKOF + 1
C                                       coordinate setup for file 1
         LOCNUM = 1
         CALL SETLOC (IDEPTH(3), .FALSE.)
C                                       init read
         CALL MINIT ('READ', LUNI, INDI, NX, NY, IWIN, BUFF1, JBUFSZ,
     *      IBLKOF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT I/O FROM INPUT IMAGE'
            GO TO 990
            END IF
C                                       output
         ODEPTH(1) = I3 - IBLC(3) + 1
         ODEPTH(2) = I4 - IBLC(4) + 1
         ODEPTH(3) = I5 - IBLC(5) + 1
         ODEPTH(4) = I6 - IBLC(6) + 1
         ODEPTH(5) = I7 - IBLC(7) + 1
C                                       Block offset for source file.
         CALL COMOFF (CATOI(KIDIM), CATOI(KINAX), ODEPTH, IBLKOF, IRET)
         IBLKOF = IBLKOF + 1
C                                       init read
         CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, OWIN, BUFF2, JBUFSZ,
     *      IBLKOF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT I/O TO OUTPUT IMAGE'
            GO TO 990
            END IF
C                                       read/write plane
         DO 70 IY = IBLC(2),ITRC(2)
            CALL MDISK ('READ', LUNI, INDI, BUFF1, IPOSI, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING INPUT IMAGE'
               GO TO 990
               END IF
            CALL MDISK ('WRIT', LUNO, INDO, BUFF2, IPOSO, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT IMAGE'
               GO TO 990
               END IF
            IDEPTH(2) = IY
            DO 50 IX = 1,NXO
               IF (BUFF1(IPOSI+IX-1).NE.FBLANK) THEN
                  IDEPTH(1) = IX + IBLC(1) - 1
                  CALL SPDOIT (IDEPTH, NIMAGE, NX2, NY2, SP0, NX3, NY3,
     *               SP1, CORFAC, IRET)
               ELSE
                  CORFAC = 0.0
                  IRET = 0
                  END IF
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET,
     *               'RETURNED FROM SPEC INDEX CORR'
                  GO TO 990
               ELSE IF (CORFAC.LE.0.0) THEN
                  BUFF2(IPOSO+IX-1) = FBLANK
                  BLANKD = .TRUE.
               ELSE
                  IF (DOINV.GT.0.0) THEN
                     BUFF2(IPOSO+IX-1) = BUFF1(IPOSI+IX-1) * CORFAC
                  ELSE
                     BUFF2(IPOSO+IX-1) = BUFF1(IPOSI+IX-1) / CORFAC
                     END IF
                  DMAX = MAX (DMAX, BUFF2(IPOSO+IX-1))
                  DMIN = MIN (DMAX, BUFF2(IPOSO+IX-1))
                  END IF
 50            CONTINUE
 70         CONTINUE
         CALL MDISK ('FINI', LUNO, INDO, BUFF2, IPOSO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'FINISHING OUTPUT IMAGE'
            GO TO 990
            END IF
 96      CONTINUE
 97      CONTINUE
 98      CONTINUE
 99      CONTINUE
 100     CONTINUE
C                                       close
      CALL ZCLOSE (LUNI, INDI, IY)
      CALL ZCLOSE (LUNO, INDO, IY)
C                                       extrema
      CATOR(KRDMX) = DMAX
      CATOR(KRDMN) = DMIN
      IF (BLANKD) THEN
         CATOR(KRBLK) = FBLANK
      ELSE
         CATOR(KRBLK) = 0.0
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPCORD: ERROR',I3,' ON ',A)
 1001 FORMAT ('SPCORD: at plane',I6)
      END
      SUBROUTINE SPDOIT (IPOS, NIMAGE, NX2, NY2, SP0, NX3, NY3, SP1,
     *   CORFAC, IRET)
C-----------------------------------------------------------------------
C   SPDOIT does all the hard work - computes the coordinate at each
C   pixel, gets the spectral index image value, gets the primary beam
C   value and corrects the output.
C   Inputs:
C      IPOS     I(7)         Input image pixel position
C      NIMAGE   I            Number images used
C      NX2      I            Number X pixels spectral index image
C      NY2      I            Number Y pixels spectral index image
C      SP0      R(NX2,NY2)   Spectral index image
C      NX3      I            Number X pixels spectral curvature image
C      NY3      I            Number Y pixels spectral curvature image
C      SP1      R(NX3,NY3)   Spectral curvature image
C   Outputs:
C      CORFAC   R            Correction factor to divide into image
C      IRET     I            error code
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), NIMAGE, NX2, NY2, NX3, NY3, IRET
      REAL      SP0(NX2,NY2), SP1(NX3,NY3), CORFAC
C
      REAL      PBCORR, PBCORF, SPCORF, SPCORR
      DOUBLE PRECISION DX, DY, DT
      LOGICAL   FIRST, DOREF, OUTSID
      CHARACTER ARRAY*8
      INCLUDE 'SPCOR.INC'
      INCLUDE 'INCS:PSTD.INC'
      SAVE FIRST, PBCORR, SPCORR, ARRAY, DOREF, DX, DY, DT
      DATA FIRST /.TRUE./
C-----------------------------------------------------------------------
      IRET = 0
      DOREF = .FALSE.
C                                       Pointing pixel 1st time in
      IF (FIRST) THEN
         IF ((RAD0.EQ.0.0D0) .AND. (DECD0.EQ.0.0D0)) THEN
            RAD0 = CATID(KDCRV+KLOCL(LOCNUM)-1,1)
            DECD0 = CATID(KDCRV+KLOCM(LOCNUM)-1,1)
            END IF
         CALL H2CHR (8, 1, CATIH(KHTEL,1), ARRAY)
         RLAMBD = VELITE / (REFREQ * 1.D9)
         DOREF = .TRUE.
         XINC = CATIR(KRCIC+KLOCL(LOCNUM),1) * COND2R
         YINC = CATIR(KRCIC+KLOCM(LOCNUM),1) * COND2R
         IRET = 2
         IF ((XINC.EQ.0.0) .OR. (YINC.EQ.0.0)) GO TO 999
         COSR = COS (ROT(LOCNUM) * COND2R)
         SINR = SGNROT(LOCNUM) * SIN (ROT(LOCNUM) * COND2R)
         RREFR = CATID(KDCRV+KLOCL(LOCNUM),1) * COND2R
         DREFR = CATID(KDCRV+KLOCM(LOCNUM),1) * COND2R
         RPTR = RAD0 * COND2R
         DPTR = DECD0 * COND2R
         DPTRS = SIN (DPTR)
         DPTRC = COS (DPTR)
         CALL DIRCOS (AXFUNC(KLOCL(LOCNUM)+1,LOCNUM), RREFR, DREFR,
     *      RPTR, DPTR, X, Y, IRET)
         IF (IRET.NE.0) GO TO 999
         YPIX0 = (Y * COSR - X * SINR) / YINC +
     *      CATIR(KRCRP+KLOCM(LOCNUM),1)
         XPIX0 = (X * COSR + Y * SINR) / XINC +
     *      CATIR(KRCRP+KLOCL(LOCNUM),1)
         FIRST = .FALSE.
         END IF
C                                       Frequency
      IF (IPOS(KLOCF(LOCNUM)+1).NE.LDEP(KLOCF(LOCNUM)+1)) THEN
         FRL0 = FREQS(IPOS(KLOCF(LOCNUM)+1))
         LAMBDA = VELITE / FRL0
         END IF
C                                       Position term
      IF ((IPOS(KLOCL(LOCNUM)+1).NE.LDEP(KLOCL(LOCNUM)+1)) .OR.
     *   (IPOS(KLOCM(LOCNUM)+1).NE.LDEP(KLOCM(LOCNUM)+1))) THEN
         DOREF = .TRUE.
C                                       Accurate method
C                                       Offset, rotation to position
         DX = (IPOS(KLOCL(LOCNUM)+1) - CATIR(KRCRP+KLOCL(LOCNUM),1))
     *      * XINC
         DY = (IPOS(KLOCM(LOCNUM)+1) - CATIR(KRCRP+KLOCM(LOCNUM),1))
     *      * YINC
         DT = DX * COSR - DY * SINR
         DY = DY * COSR + DX * SINR
         DX = DT
         CALL NEWPOS (AXFUNC(KLOCL(LOCNUM)+1,LOCNUM), RREFR, DREFR,
     *      DX, DY, X, Y, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       get actual angle
         DT = DPTRS * SIN(Y) + DPTRC * COS(Y) * COS(RPTR-X)
         IF (DT.GT.1.0D0) DT = 1.0D0
         IF (DT.LT.-1.0D0) DT = -1.0D0
         POL0 = RAD2DG * ACOS (DT)
         END IF
C                                       PB correction factor
      IF (PBPARM(1).GE.1.0) THEN
         PBCORF = 1.0
         PBCORR = 1.0
      ELSE
         CALL PBCALC (POL0, LAMBDA, ARRAY, PBPARM(2), PBCORF, OUTSID)
         IF ((OUTSID) .OR. (PBCORF.LT.PBPARM(1))) PBCORF = 0.0
         IF (DOREF) THEN
            CALL PBCALC (POL0, RLAMBD, ARRAY, PBPARM(2), PBCORR, OUTSID)
            IF ((OUTSID) .OR. (PBCORR.LT.PBPARM(1))) PBCORR = 0.0
            END IF
         IF (PBCORR.GT.0.0) THEN
            PBCORF = PBCORF / PBCORR
         ELSE
            PBCORF = 0.0
            END IF
         END IF
C                                       SP index correction
      IF (NIMAGE.LT.2) THEN
         SPCORR = 1.0
         SPCORF = 1.0
      ELSE
         CALL SPCALC (X, Y, LAMBDA, NIMAGE, NX2, NY2, SP0, NX3, NY3,
     *      SP1, SPCORF)
         IF (DOREF) CALL SPCALC (X, Y, RLAMBD, NIMAGE, NX2, NY2, SP0,
     *      NX3, NY3, SP1, SPCORR)
         IF (SPCORR.GT.0.0) THEN
            SPCORF = SPCORF / SPCORR
         ELSE IF (DOBLNK.GT.0.0) THEN
            SPCORF = 0.0
         ELSE
            SPCORF = 1.0
            END IF
         END IF
C                                       final corr
      CORFAC = PBCORF * SPCORF
C                                       remember where we were
      CALL COPY (7, IPOS, LDEP)
      IRET = 0
C
 999  RETURN
      END
      SUBROUTINE SPCALC (XX, YY, LAMB, NIMAGE, NX2, NY2, SP0, NX3, NY3,
     *   SP1, CORFAC)
C-----------------------------------------------------------------------
C   SPCALC finds the spectral index for the specified coordinate and
C   returns a correction factor to divide into the image to get the
C   image at 1 GHz.
C   Inputs
C      XX       D            RA in radians
C      YY       D            DEC in radians
C      LAMBD    D            Wavelength in meters
C      NIMAGE   I            Number images used
C      NX2      I            Number X pixels spectral index image
C      NY2      I            Number Y pixels spectral index image
C      SP0      R(NX2,NY2)   Spectral index image
C      NX3      I            Number X pixels spectral curvature image
C      NY3      I            Number Y pixels spectral curvature image
C      SP1      R(NX3,NY3)   Spectral curvature image
C   Output:
C      CORFAC   R            Correction factor: 0.0 -> problem
C-----------------------------------------------------------------------
      INTEGER   NIMAGE, NX2, NY2, NX3, NY3
      REAL      SP0(NX2,NY2), SP1(NX3,NY3), CORFAC
      DOUBLE PRECISION XX, YY, LAMB
C
      INTEGER   IRET
      REAL      XPIX, YPIX, SP0VAL, SP1VAL
      DOUBLE PRECISION FREQ, DX, DY
      INCLUDE 'SPCOR.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      CORFAC = 0.0
      IF (RADIUS.LT.SQRT(0.5)) RADIUS = SQRT (0.5)
C                                       frequency
      FREQ = VELITE / LAMB / 1.D9
      FREQ = LOG10 (FREQ)
      DX = XX * RAD2DG
      DY = YY * RAD2DG
C                                       spectral index image
      LOCNUM = 2
      CALL XYPIX (DX, DY, XPIX, YPIX, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL SPTERP (NX2, NY2, SP0, XPIX, YPIX, RADIUS, SP0VAL)
      IF (SP0VAL.EQ.FBLANK) GO TO 999
C                                       curvature
      IF (NIMAGE.LE.2) THEN
         SP1VAL = 0.0
      ELSE
         LOCNUM = 3
         CALL XYPIX (DX, DY, XPIX, YPIX, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL SPTERP (NX3, NY3, SP1, XPIX, YPIX, RADIUS, SP1VAL)
         IF (SP1VAL.EQ.FBLANK) GO TO 999
         END IF
C                                       restore main image
      LOCNUM = 1
C                                       corr factor
      CORFAC = (SP0VAL + SP1VAL * FREQ) * FREQ
      CORFAC = 10.0 ** CORFAC
C
 999  RETURN
      END
      SUBROUTINE SPTERP (NX, NY, SP, XPIX, YPIX, RADIUS, SPVAL)
C-----------------------------------------------------------------------
C   SPTERP finds the average value in image SP in a radius around a
C   pixel position
C   Inputs
C      NX       I          x dimension of SP
C      NY       I          Y dimension of SP
C      SP       R(NX,NY)   Image
C      XPIX     R          X pixel center
C      YPIX     R          Y pixel center
C      RADIUS   R          radius of averaging area
C   Outputs:
C      SPVAL    R          average value of FBLANK if fail or all blank
C-----------------------------------------------------------------------
      INTEGER   NX, NY
      REAL      SP(NX,NY), XPIX, YPIX, RADIUS, SPVAL
C
      INTEGER   IX, X1, X2, IY, Y1, Y2
      REAL      SUM, SW, R, RR, W, RS
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      SPVAL = FBLANK
C                                       set area
      RR = 2.0 * RADIUS
      X1 = XPIX - RR + 0.99
      X2 = XPIX + RR
      Y1 = YPIX - RR + 0.99
      Y2 = YPIX + RR
      X1 = MAX (1, X1)
      Y1 = MAX (1, Y1)
      X2 = MIN (NX, X2)
      Y2 = MIN (NY, Y2)
C                                       sum
      RS = RADIUS * RADIUS
      RR = 4. * RS
      SW = 0.0
      SUM = 0.0
      DO 20 IY = Y1,Y2
         DO 10 IX = X1,X2
            R = (IX-XPIX)**2 + (IY-YPIX)**2
            IF ((R.LE.RR) .AND. (SP(IX,IY).NE.FBLANK)) THEN
               W = EXP (-R / RS)
               SW = SW + W
               SUM = SUM + W * SP(IX,IY)
               END IF
 10         CONTINUE
 20      CONTINUE
C                                       average
      IF (SW.GT.0) SPVAL = SUM / SW
C
 999  RETURN
      END

LOCAL INCLUDE 'OFLAG.INC'
      INCLUDE 'INCS:DOFV.INC'
      HOLLERITH XINNAM(3), XINCLS(2)
      REAL      XSEQ, XDISK, XVER, XFLAG, XFGOUT, DETIME, DOFLAG,
     *   FPARM(30), BADD(10)
      CHARACTER INNAM*12, INCLS*6, INEXT*2, ANNAME*8, OBSCOD*8, OBSDAT*8
      INTEGER   SCRBUF(256), OFBUFF(512), INSEQ, INDISK, INVERS, CNO,
     *   IUSER, IOFRNO, OFKOLS(MAXOFC), OFNUMV(MAXOFC), TABVER, NPOL,
     *   NIF, FGVERI, FGVERO, FGBUFF(512), IDOFLG, NFLBIT(32), NFLLEV,
     *   NFLAG, NANT(513), NBDBIT(32)
      COMMON /INPARM/ XINNAM, XINCLS, XSEQ, XDISK, XVER, XFLAG, XFGOUT,
     *   DETIME, DOFLAG, FPARM, BADD
      COMMON /CHPARM/ INNAM, INCLS, INEXT, ANNAME, OBSCOD, OBSDAT
      COMMON /OFLAGC/ SCRBUF, FGBUFF, OFBUFF, INSEQ, INDISK, INVERS,
     *   CNO, IUSER, IOFRNO, OFKOLS, OFNUMV, TABVER, NPOL, NIF, FGVERI,
     *   FGVERO, IDOFLG, NFLBIT, NFLLEV, NFLAG, NANT, NBDBIT
LOCAL END
      PROGRAM OFLAG
C-----------------------------------------------------------------------
C! Task to convert OF table flag info into FG table flags
C# Calibration EXT-appl EXT-util Editing
C-----------------------------------------------------------------------
C;  Copyright (C) 2008, 2015-2016, 2018, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   OFLAG is an AIPS task to convert flagging info in an on-line flag
C   table (OF) to a standard aips flag table (FG)
C   AIPS adverbs:                     Use:
C     INNAME     INNAM(3)    Image name: standard defaults, wildcards
C     INCLASS    INCLS(2)    Image class: ditto
C     INSEQ      INSEQ       Image sequence number: ditto
C     INDISK     INDISK      Image disk number: 0 -> any
C     INEXT      INEXT       Extension type: '  ' => 'TA'
C     INVERS     INVERS      Extension version number
C     FLAGVER    FGVERI      Input FG table copied
C     OUTFGVER   FGVERO      Output FG table
C     DOFLAG     DOFLAG      Allowed status cutoff
C     FPARM      FPARM(30)   Flag if bit(i) set and FPARM(i) > 0
C-----------------------------------------------------------------------
      INTEGER   IRET
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'OFLAG.INC'
C-----------------------------------------------------------------------
C                                       Get parms, open things
      CALL OFLGIN (IRET)
C                                       do printing
      IF (IRET.EQ.0) CALL OFLGDO (IRET)
C                                       HI writing
      IF (IRET.EQ.0) CALL OFLGHI
C                                       close down
      CALL DIE (IRET, OFBUFF)
C
 999  STOP
      END
      SUBROUTINE OFLGIN (IRET)
C-----------------------------------------------------------------------
C   OFLGIN performs initialization for AIPS task OFLAG.  It gets the
C   adverbs, opens the catalog file for 'READ', opens the table
C   extension
C   file, and opens the output device.
C   Output: IRET    I      Error code: 0 => keep going, else quit.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER INTYP*2, STAT*4, PRGN*6
      INTEGER   NPARM, IROUND, OFLUN, IERR, IFG, FGLUN, I
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'OFLAG.INC'
      DATA OFLUN, FGLUN, INTYP /27, 28, 'UV'/
      DATA PRGN /'OFLAG '/
C-----------------------------------------------------------------------
C                                       AIPS init
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NCFILE = 0
      NSCR = 0
C                                       get adverbs
      NPARM = 52
      IRET = 0
      CALL GTPARM (PRGN, NPARM, RQUICK, XINNAM, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) THEN
            GO TO 999
         ELSE
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
            END IF
         END IF
C                                       restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRBUF, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> Char
      CALL H2CHR (12, 1, XINNAM, INNAM)
      CALL H2CHR (6, 1, XINCLS, INCLS)
      INEXT = 'OF'
C                                       find image file
      INSEQ = IROUND (XSEQ)
      INDISK = IROUND (XDISK)
      INVERS = IROUND (XVER)
      IUSER = NLUSER
      FGVERI = IROUND (XFLAG)
      FGVERO = IROUND (XFGOUT)
      IDOFLG = IROUND (DOFLAG)
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
C                                       find data set
      CNO = 1
      CALL CATDIR ('SRCH', INDISK, CNO, INNAM, INCLS, INSEQ, INTYP,
     *   IUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, INNAM, INCLS, INSEQ, INTYP,
     *      INDISK, IUSER
         GO TO 990
         END IF
C                                       Get catblk, mark file read
      CALL CATIO ('READ', INDISK, CNO, CATBLK, 'REST', SCRBUF, IERR)
      IF ((IERR.GT.0) .AND. (IERR.LT.5)) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       flag versions
      CALL FNDEXT ('FG', CATBLK, IFG)
      IF (FGVERI.GT.IFG) FGVERI = -1
      IF (FGVERI.EQ.0) FGVERI = IFG
      IF ((FGVERO.LE.0) .OR. (FGVERO.GT.IFG)) FGVERO = IFG + 1
C                                       copy old FG table
      IF ((FGVERI.GT.0) .AND. (FGVERO.GT.IFG)) THEN
         CALL TABCOP ('FG', FGVERI, FGVERO, OFLUN, FGLUN, INDISK,
     *      INDISK, CNO, CNO, CATBLK, OFBUFF, FGBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1030) IRET, FGVERI, FGVERO
            GO TO 990
            END IF
         END IF
C                                       number antennas
      CALL GETNAN (INDISK, CNO, CATBLK, OFLUN, OFBUFF, NANT, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1035) IRET
         GO TO 990
         END IF
C                                       Open table file
      CALL OFINI ('READ', OFBUFF, INDISK, CNO, INVERS, CATBLK, OFLUN,
     *   IOFRNO, OFKOLS, OFNUMV, NIF, NPOL, ANNAME, OBSCOD, OBSDAT,
     *   TABVER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1040) IRET, INEXT, INVERS
      ELSE IF (TABVER.NE.2) THEN
         WRITE (MSGTXT,1045) TABVER
         IRET = 10
         END IF
C
 990  IF (IRET.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' FINDING INPUT ADVERBS')
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,1X,A2,
     *   'DISK=',I2,' USER=',I5)
 1020 FORMAT ('ERROR',I5,' READING CATBLK FROM CATALOG FILE')
 1030 FORMAT ('ERROR',I5,' COPYING OLD FLAG TABLE')
 1035 FORMAT ('ERROR',I5,' CHECKING ANTENNA TABLES')
 1040 FORMAT ('ERROR',I5,' OPENING ',A2,' TABLE VERS=',I6)
 1045 FORMAT ('OF TABLE FORMAT VERSION',I4,' NOT RECOGNIZED')
      END
      SUBROUTINE OFLGDO (IRET)
C-----------------------------------------------------------------------
C   OFLGDO reads, formats, and prints an OF table extension file
C   Output:
C      IRET   I   Error code: 0 => OK or user terminates,
C                    2 => error writing, 3 => error reading
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'OFLAG.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IRNO, SOURCE, IANT, SUBID, FREQID, ANFLAG, NS, ECOUNT,
     *   BCHAN, ECHAN, IFGRNO, STATUS(2,MAXIF), LP, LIF, BITS(32), I,
     *   FGKOLS(MAXFGC), FGNUMV(MAXFGC), JANT, FGLUN, KANT, IA1, IA2,
     *   NFG
      REAL      TIME, BTIME, ETIME
      CHARACTER VSYM(32)*8, REASON*24, STREAS*24, STOKES*4, STPAT(2,3)*4
      LOGICAL   DOFL(2,MAXIF), DOIT, ALL
      INCLUDE 'INCS:DMSG.INC'
      DATA VSYM /'RefPoint', 'Shadowed', 'OffSourc', '1 LOLock',
     *   'TsysFluc', 'Operator', 'BETotPow', 'BEFilter', 'L8Module',
     *   'L6Module', 'SubRefle', 'SouChang', 'PhSwitch', 'RndTrip',
     *   18*'????????'/
      DATA FGLUN /28/
      DATA STPAT /'1001','0110','1011','0111','1010','0101'/
C-----------------------------------------------------------------------
      NFLLEV = 0
      NFLAG = 0
      CALL FILL (32, 0, NFLBIT)
      CALL FILL (32, 0, NBDBIT)
      WRITE (STREAS,1000) IDOFLG
      ECOUNT = OFBUFF(5)
      BCHAN = 0
      ECHAN = 0
      JANT = 0
      IF (DETIME.LE.0.02) DETIME = 0.02
      DETIME = DETIME / (3600.0 * 24.0)
C                                       loop over file
      DO 100 IRNO = 1,ECOUNT
         IOFRNO = IRNO
         CALL TABOF ('READ', OFBUFF, IOFRNO, OFKOLS, OFNUMV, TIME,
     *      SOURCE, IANT, SUBID, FREQID, ANFLAG, STATUS, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1010) IRET, IRNO
            CALL MSGWRT (8)
            GO TO 970
         ELSE IF (IRET.EQ.0) THEN
            I = 2 * LIF
            CALL LFILL (I, .FALSE., DOFL)
            CALL ZGTBIT (32, ANFLAG, BITS)
            NS = 1
            REASON = ' '
            DO 10 I = 1,30
               IF ((FPARM(I).GT.0.0) .AND. (BITS(I).GT.0)) THEN
                  NFLBIT(I) = NFLBIT(I) + 1
                  IF (ANNAME.NE.'VLA') THEN
                     IF (NS.LE.22) THEN
                        WRITE (REASON(NS:),1001) I
                        NS = NS + 3
                        END IF
                  ELSE
                     IF (NS.LE.17) THEN
                        REASON(NS:) = VSYM(I)
                        NS = NS + 8
                        END IF
                     END IF
                  END IF
 10            CONTINUE
C                                       antenna fully flagged
            DOIT = .FALSE.
            IF (REASON.NE.' ') THEN
               I = 2 * LIF
               CALL LFILL (I, .TRUE., DOFL)
               DOIT = .TRUE.
               ALL = .TRUE.
C                                       check status
            ELSE IF (IDOFLG.GT.0) THEN
               ALL = .TRUE.
               DO 20 LIF = 1,NIF
                  DO 15 LP = 1,NPOL
                     DOFL(LP,LIF) = STATUS(LP,LIF).GE.IDOFLG
                     IF (DOFL(LP,LIF)) THEN
                        NFLLEV = NFLLEV + 1
                        REASON = STREAS
                        DOIT = .TRUE.
                     ELSE
                        ALL = .FALSE.
                        END IF
 15                  CONTINUE
 20               CONTINUE
               END IF
C                                       write some flags
            IF (DOIT) THEN
C                                       count bad bits even if ignored
               IF (IDOFLG.GT.0) THEN
                  DO 25 I = 1,30
                     IF (BITS(I).GT.0) NBDBIT(I) = NBDBIT(I) + 1
 25                  CONTINUE
                  END IF
               BTIME = TIME - DETIME
               ETIME = TIME + DETIME
C                                       all
               IF (ALL) THEN
                  CALL FLAGUP ('FLAG', FGLUN, INDISK, CNO, FGVERO,
     *               FGBUFF, IFGRNO, FGKOLS, FGNUMV, SOURCE, 1, SUBID,
     *               FREQID, 1, IANT, JANT, BTIME, ETIME, 1, NIF, BCHAN,
     *               ECHAN, '1111', REASON, NFG, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1020) IRET, IFGRNO
                     CALL MSGWRT (8)
                     GO TO 970
                     END IF
                  NFLAG = NFLAG + NFG
C                                       by pieces
               ELSE
                  DO 40 LP = 1,NPOL
                     DO 35 LIF = 1,NIF
                        IF (DOFL(LP,LIF)) THEN
                           IF ((LP.EQ.1) .AND. (NPOL.EQ.2) .AND.
     *                        (DOFL(2,LIF))) THEN
                              CALL FLAGUP ('FLAG', FGLUN, INDISK,
     *                           CNO, FGVERO, FGBUFF, IFGRNO, FGKOLS,
     *                           FGNUMV, SOURCE, 1, SUBID, FREQID, 1,
     *                           IANT, JANT, BTIME, ETIME, LIF, LIF,
     *                           BCHAN, ECHAN, '1111', REASON, NFG,
     *                           IRET)
                              DOFL(2,LIF) = .FALSE.
                              IF (IRET.NE.0) THEN
                                 WRITE (MSGTXT,1020) IRET, IFGRNO
                                 CALL MSGWRT (8)
                                 GO TO 970
                                 END IF
                              NFLAG = NFLAG + NFG
                           ELSE
                              DO 30 KANT = 1,NANT(SUBID+1)
                                 IF (KANT.LT.IANT) THEN
                                    STOKES = STPAT(LP,1)
                                    IA1 = KANT
                                    IA2 = IANT
                                 ELSE IF (KANT.EQ.IANT) THEN
                                    STOKES = STPAT(LP,2)
                                    IA1 = KANT
                                    IA2 = KANT
                                 ELSE
                                    STOKES = STPAT(LP,3)
                                    IA1 = IANT
                                    IA2 = KANT
                                    END IF
                                 CALL FLAGUP ('FLAG', FGLUN, INDISK,
     *                              CNO, FGVERO, FGBUFF, IFGRNO, FGKOLS,
     *                              FGNUMV, SOURCE, 1, SUBID, FREQID, 1,
     *                              IA1, IA2, BTIME, ETIME, LIF, LIF,
     *                              BCHAN, ECHAN, STOKES, REASON, NFG,
     *                              IRET)
                                 IF (IRET.NE.0) THEN
                                    WRITE (MSGTXT,1020) IRET, IFGRNO
                                    CALL MSGWRT (8)
                                    GO TO 970
                                    END IF
                                 NFLAG = NFLAG + NFG
 30                              CONTINUE
                              END IF
                           END IF
 35                     CONTINUE
 40                  CONTINUE
                  END IF
               END IF
            END IF
 100     CONTINUE
C                                       close down
 970  CALL TABOF ('CLOS', OFBUFF, IOFRNO, OFKOLS, OFNUMV, TIME, SOURCE,
     *   IANT, SUBID, FREQID, ANFLAG, STATUS, I)
      CALL FLAGUP ('CLOS', FGLUN, INDISK, CNO, FGVERO, FGBUFF, IFGRNO,
     *   FGKOLS, FGNUMV, SOURCE, 1, SUBID, FREQID, 1, IANT, JANT, BTIME,
     *   ETIME, 1, NIF, BCHAN, ECHAN, '1111', REASON, NFG, I)
      IRET = MAX (0, IRET)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Status code >',I4)
 1001 FORMAT ('B',I2.2)
 1010 FORMAT ('ERROR',I5,' READING OF TABLE ROW',I10)
 1020 FORMAT ('ERROR',I5,' WRITING FG TABLE ROW',I10)
      END
      SUBROUTINE OFLGHI
C-----------------------------------------------------------------------
C   Add info in history file
C-----------------------------------------------------------------------
C
      INTEGER   LUNH, IRET, DATE(3), TIME(3), I
      CHARACTER HILINE*72, CTIME*8, CDATE*12, VSYM(32)*8
      INCLUDE 'OFLAG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LUNH /27/
      DATA VSYM /'RefPoint', 'Shadowed', 'OffSourc', '1 LOLock',
     *   'TsysFluc', 'Operator', 'BETotPow', 'BEFilter', 'L8Module',
     *   'L6Module', 'SubRefle', 'SouChang', 'PhSwitch', 'RndTrip',
     *   18*'????????'/
C-----------------------------------------------------------------------
C                                       Open history file
      CALL HIINIT (2)
      CALL HIOPEN (LUNH, INDISK, CNO, SCRBUF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Write time and date on old file
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME, CDATE)
      WRITE (HILINE,1000) TSKNAM, RLSNAM, CDATE, CTIME
      CALL HIADD (LUNH, HILINE, SCRBUF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       versions
      WRITE (HILINE,1010) TSKNAM, INVERS
      CALL HIADD (LUNH, HILINE, SCRBUF, IRET)
      IF (IRET.NE.0) GO TO 100
      IF (FGVERI.GT.0) THEN
         WRITE (HILINE,1011) TSKNAM, FGVERI
         CALL HIADD (LUNH, HILINE, SCRBUF, IRET)
         IF (IRET.NE.0) GO TO 100
         END IF
      WRITE (HILINE,1012) TSKNAM, FGVERO
      CALL HIADD (LUNH, HILINE, SCRBUF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       time expansion
      DETIME = DETIME * (3600.0 * 24.0)
      WRITE (HILINE,1015) TSKNAM, DETIME
      CALL HIADD (LUNH, HILINE, SCRBUF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       total flags
      WRITE (HILINE,1020) TSKNAM, NFLAG
      CALL HIADD (LUNH, HILINE, SCRBUF, IRET)
      IF (IRET.NE.0) GO TO 100
      MSGTXT = HILINE(9:)
      CALL MSGWRT (4)
C                                       status clip
      IF (IDOFLG.GT.0) THEN
         WRITE (HILINE,1025) TSKNAM, IDOFLG
         CALL HIADD (LUNH, HILINE, SCRBUF, IRET)
         IF (IRET.NE.0) GO TO 100
         WRITE (HILINE,1026) TSKNAM, NFLLEV
         CALL HIADD (LUNH, HILINE, SCRBUF, IRET)
         IF (IRET.NE.0) GO TO 100
         MSGTXT = HILINE(9:)
         CALL MSGWRT (4)
         END IF
      DO 20 I = 1,30
         IF ((FPARM(I).GT.0.0) .AND. (NFLBIT(I).GT.0)) THEN
            IF (ANNAME.EQ.'VLA') THEN
               WRITE (HILINE,1030) TSKNAM, I, VSYM(I)
            ELSE
               WRITE (HILINE,1031) TSKNAM, I
               END IF
            CALL HIADD (LUNH, HILINE, SCRBUF, IRET)
            IF (IRET.NE.0) GO TO 100
            WRITE (HILINE,1031) TSKNAM, NFLBIT(I)
            CALL HIADD (LUNH, HILINE, SCRBUF, IRET)
            IF (IRET.NE.0) GO TO 100
            IF (ANNAME.EQ.'VLA') THEN
               WRITE (MSGTXT,1035) NFLBIT(I), I, VSYM(I)
            ELSE
               WRITE (MSGTXT,1036) NFLBIT(I), I
               END IF
            CALL MSGWRT (4)
            END IF
         IF ((NBDBIT(I).GT.0) .AND. (NBDBIT(I).NE.NFLBIT(I))) THEN
            IF (ANNAME.EQ.'VLA') THEN
               WRITE (MSGTXT,1037) NBDBIT(I), I, VSYM(I)
            ELSE
               WRITE (MSGTXT,1038) NBDBIT(I), I
               END IF
            CALL MSGWRT (4)
            END IF
 20      CONTINUE
C
 100  CALL HICLOS (LUNH, .TRUE., SCRBUF, IRET)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',A12,2X,A8)
 1010 FORMAT (A6,'INVERS  =',I5,5X,'/ OF table version input')
 1011 FORMAT (A6,'FLAGVER =',I5,5X,'/ FG version copied to output FG')
 1012 FORMAT (A6,'OUTFGVER=',I5,5X,'/ FG version written')
 1015 FORMAT (A6,'DETIME=',F7.2,5X,'/ sec expand time of OF record')
 1020 FORMAT (A6,'/ Wrote  ',I10,' flag commands to FG table')
 1025 FORMAT (A6,'DOFLAG  =',I5,5X,'/ flag status >= DOFLAG')
 1026 FORMAT (A6,'/ Flagged',I10,' correlators solely because of',
     *   ' status')
 1030 FORMAT (A6,'FPARM(',I2,') = 1',3X,'/ Flag if bit for ',A,' set')
 1031 FORMAT (A6,'FPARM(',I2,') = 1',3X,'/ Flag if bit set')
 1035 FORMAT ('Flagged',I10,' samples for bit',I3,' =''',A,'''')
 1036 FORMAT ('Flagged',I10,' samples for bit',I3)
 1037 FORMAT ('Found  ',I10,' samples for bit',I3,' =''',A,'''')
 1038 FORMAT ('Found  ',I10,' samples for bit',I3)
      END

      SUBROUTINE INTEDG (BLC, TRC, XL, YL, XU, YU, NO, XO, YO)
C-----------------------------------------------------------------------
C! returns intersections of a line with the edges of a box
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   INTEDG takes the corners of a box and the end points of a line and
C   returns the 0, 1 or 2 coordinate pairs at which the line crosses
C   the box.  NOTE: 1 point must be outside the box or NO = 0.
C   See also LINLIM.
C   Inputs:
C      BLC    R(2)        Bottom left corner of box
C      TRC    R(2)        Top right corner of box
C      XL     R           X coordinate of end point 1 of line
C      YL     R           Y coordinate of end point 1 of line
C      XU     R           X coordinate of end point 2 of line
C      YU     R           Y coordinate of end point 2 of line
C   Output:
C      NO     I           Number of intersections (0, 1, or 2)
C                           -1 => both points inside
C      XO     R(2)        X coordinates of intersections
C      YO     R(2)        Y coordinates of intersections
C-----------------------------------------------------------------------
      REAL      BLC(2), TRC(2), XL, YL, XU, YU, XO(2), YO(2)
      INTEGER   NO
C
      REAL      X, Y
C-----------------------------------------------------------------------
C                                       Check for all in
      NO = -1
      IF ((XL.GE.BLC(1)) .AND. (XL.LE.TRC(1)) .AND. (YL.GE.BLC(2)) .AND.
     *   (YL.LE.TRC(2)) .AND. (XU.GE.BLC(1)) .AND. (XU.LE.TRC(1)) .AND.
     *   (YU.GE.BLC(2)) .AND. (YU.LE.TRC(2))) GO TO 999
C                                       Check for all off
      NO = 0
      IF (((XL.LT.BLC(1)) .AND. (XU.LT.BLC(1))) .OR. ((XL.GT.TRC(1))
     *   .AND. (XU.GT.TRC(1))) .OR. ((YL.LT.BLC(2)) .AND.
     *   (YU.LT.BLC(2))) .OR. ((YL.GT.TRC(2)) .AND. (YU.GT.TRC(2))))
     *   GO TO 999
C                                       Left edge
      IF (((XL.LE.BLC(1)) .OR. (XU.LE.BLC(1))) .AND. (XL.NE.XU)) THEN
         Y = YL + (BLC(1)-XL) * (YU-YL) / (XU-XL)
         IF ((Y.GT.BLC(2)) .AND. (Y.LT.TRC(2))) THEN
            NO = NO + 1
            XO(NO) = BLC(1)
            YO(NO) = Y
            END IF
         END IF
C                                       Right edge
      IF (((XL.GE.TRC(1)) .OR. (XU.GE.TRC(1))) .AND. (XL.NE.XU)) THEN
         Y = YL + (TRC(1)-XL) * (YU-YL) / (XU-XL)
         IF ((Y.GT.BLC(2)) .AND. (Y.LT.TRC(2))) THEN
            NO = NO + 1
            XO(NO) = TRC(1)
            YO(NO) = Y
            END IF
         END IF
C                                       Bottom edge
      IF (((YL.LE.BLC(2)) .OR. (YU.LE.BLC(2))) .AND. (YL.NE.YU)) THEN
         X = XL + (BLC(2)-YL) * (XU-XL) / (YU-YL)
         IF ((X.GE.BLC(1)) .AND. (X.LE.TRC(1))) THEN
            NO = NO + 1
            YO(NO) = BLC(2)
            XO(NO) = X
            END IF
         END IF
C                                       Top edge
      IF (((YL.GE.TRC(2)) .OR. (YU.GE.TRC(2))) .AND. (YL.NE.YU)) THEN
         X = XL + (TRC(2)-YL) * (XU-XL) / (YU-YL)
         IF ((X.GE.BLC(1)) .AND. (X.LE.TRC(1))) THEN
            NO = NO + 1
            YO(NO) = TRC(2)
            XO(NO) = X
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE HIOPEN (HLUN, KVOL, CNO, BUFFER, IERR)
C-----------------------------------------------------------------------
C! opens a history file, preparing common pointers and reading record 1
C# History
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   HIOPEN opens a history file in HITAB and FTAB
C   Inputs:
C      HLUN    I         desired lun
C      KVOL    I         disk number
C      CNO     I         catalog number
C   Output:
C      BUFFER  I(256)    first record in HI file
C      IERR    I         0 - ok
C                        1 - lun in use
C                        2 - no room for lun
C                        3 - other ZOPEN errors
C                        4 - IO errors
C                        5 - file does not exist
C-----------------------------------------------------------------------
      INTEGER   HLUN, KVOL, CNO, BUFFER(256), IERR
C
      CHARACTER HNAME*48
      INTEGER   IND, HPTR, IER
      LOGICAL   T, F
      INCLUDE 'INCS:DHIS.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                        open in HITAB
      CALL HILOCT ('OPEN', HLUN, HPTR, IERR)
      IF (IERR.NE.0) GO TO 999
      HITAB(HPTR+4) = KVOL
      HITAB(HPTR+5) = CNO
      HITAB(HPTR+6) = 1
C                                        open physical file
      CALL ZPHFIL ('HI', KVOL, CNO, 1, HNAME, IERR)
      CALL ZOPEN (HLUN, IND, KVOL, HNAME, F, T, T, IERR)
      IF (IERR.EQ.0) GO TO 20
         IER = IERR
         IF ((IER.NE.1) .AND. (IER.NE.5)) IERR = 3
         IF (IER.EQ.5) IERR = 2
         IF (IER.EQ.2) IERR = 5
         GO TO 900
C                                        read record one
 20   CALL ZFIO ('READ', HLUN, IND, 1, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 30
         IERR = 4
         GO TO 900
C                                        fill in HITAB
 30   HITAB(HPTR+1) = IND
      HITAB(HPTR+2) = BUFFER(1)
      HITAB(HPTR+3) = BUFFER(2)
      HITAB(HPTR+4) = KVOL
      HITAB(HPTR+5) = CNO
      HITAB(HPTR+6) = 1
      BUFFER(3) = HPTR
      GO TO 999
C                                        error
 900  CALL FILL (NHIWRD, 0, HITAB(HPTR))
      IF (IERR.EQ.4) CALL ZCLOSE (HLUN, IND, IER)
C
 999  RETURN
      END

      SUBROUTINE UVMTYP (IFIELD, METHOD, NCHAN, DODFT, TIMDFT, TIMFFT)
C-----------------------------------------------------------------------
C! Determines relative CPU times for DFT or gridded interpolation.
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2004, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVMTYP decides whether it is faster to do the DFT or FFT model
C   subtraction.  Calls a Q (QMTYP) routine to allow this decision to
C   be made on a machine dependent basis.
C   Input:
C      IFIELD   I    Field number; 0 -> all
C      METHOD   I    1=>gridded, -1=>DFT, 0=>chose.
C      NCHAN    I    Number of frequency channels to subtract.
C   Output:
C      DODFT    L    If true use DFT method.
C      TIMDFT   R    Estimate of time for DFT in sec.
C      TIMFFT   R    Estimate of time for FFT/grid. interpolation.
C-----------------------------------------------------------------------
      INTEGER   IFIELD, METHOD, NCHAN
      LOGICAL   DODFT
      REAL      TIMDFT, TIMFFT
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NCC(MAXFLD), NXX(MAXFLD), NYY(MAXFLD), I4CHAN, I4FLD, I
      LOGICAL   LFORCE, FORCED
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
      TIMDFT = 0.0
      TIMFFT = 0.0
C                                       Check if user specified.
      DODFT = METHOD.LT.0
C                                       Setup for QMTYP
      IF (METHOD.EQ.0) THEN
         I4CHAN = NCHAN
         IF (IFIELD.LE.0) THEN
            I4FLD = MFIELD
            DO 10 I = 1,MFIELD
               NCC(I) = NCLNG(I) - NSUBG(I) + 1
               NXX(I) = FLDSZ(1,I)
               NYY(I) = FLDSZ(2,I)
 10            CONTINUE
            LFORCE = FORCED (MFIELD, FLDSZ(1,1))
         ELSE
            I4FLD = 1
            NCC(1) = NCLNG(IFIELD) - NSUBG(IFIELD) + 1
            NXX(1) = FLDSZ(1,IFIELD)
            NYY(1) = FLDSZ(2,IFIELD)
            LFORCE = FORCED (1, FLDSZ(1,IFIELD))
            END IF
C                                       Compute times.
         CALL QMTYP (I4FLD, NCC, NVIS, I4CHAN, NXX, NYY, TIMDFT, TIMFFT)
C                                       See which one is faster.
         DODFT = (TIMDFT.LT.1.1*TIMFFT) .OR. LFORCE
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZACTV9 (FLEN, FULNAM, PLEN, CPNAME, IDBG, PID, SYSERR,
     *   IERR)
C-----------------------------------------------------------------------
C! starts requested load module under requested process name
C# Z2 System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Creates a sub process with a name equal to CPNAME a detached process
C   named 'QMNGR'.  Uses load module FULNAM.
C   Inputs:
C      FLEN     I          Length in characters of "FULNAM"
C      FULNAM   C*(FLEN)   Full path name of the required executable
C                          module
C      PLEN     I          Length in characters of "CPNAME"
C      CPNAME   C*(plen)   Desired process name
C      IDBG     I          1 => start in DEBUGger if possible
C                          0 => use no DEBUGger if possible
C                          Ignore on CPNAME='AIPSn','BATERn'
C   In/Out:
C      PID      I(4)       Process identification information:
C                          In:  PID(1) user number for systems which
C                                      use it (= 0 otherwise and on all
C                                      AIPSB invocations)
C                          Out: PID(2) process ID number from "fork"
C                               PID(3) not used
C                               PID(4) not used
C   Output:
C      SYSERR   I          System error code (i.e., errno) if error
C      IERR     I          Error return code: 0 => no error
C                              1 => error
C   VMS Version
C-----------------------------------------------------------------------
      INTEGER   FLEN, PLEN, IDBG, PID(4), SYSERR, IERR
      CHARACTER FULNAM*(*), CPNAME*(*)
C
      CHARACTER VERS*64
      INTEGER   BASPRI, SYS$CREPRC, LIB$SPAWN, ILEN, I
      INCLUDE '($PRCDEF)'
C-----------------------------------------------------------------------
      IERR = 2
C                                       Batch system control program
      IF (CPNAME(1:5).EQ.'QMNGR') THEN
C                                       Translate AIPS_VERSION as far
C                                       as possible
         CALL ZTRLOG (12, 'AIPS_VERSION', 64, VERS, ILEN, IERR)
C                                       Trim closing bracket
         ILEN = ILEN - 1
C                                       Create a detached process
C                                       Use interactive priority for
C                                       now. It will drop when a task
C                                       starts.
         BASPRI = 4
         SYSERR = SYS$CREPRC (PID(2), 'SYS$SYSTEM:LOGINOUT.EXE',
     *      VERS(:ILEN)//'SYSTEM.VMS]QMNGR.COM',
     *      VERS(:ILEN)//'ERRORS]QMNGR.LOG', , , ,
     *      CPNAME(1:PLEN),%VAL(BASPRI), , ,
     *      %VAL(PRC$M_DETACH))
C                                       Subprocess.
      ELSE
C                                       Spawn subprocess.
C                                       Use parent's SYS$INPUT and
C                                       SYS$OUTPUT to prevent
C                                       terminal allocation.
         IF (IDBG.LE.0) THEN
            SYSERR = LIB$SPAWN ('RUN/NODEBUG '//FULNAM(1:FLEN),,, 1,
     *         CPNAME(1:PLEN),,,,,,,)
         ELSE
            SYSERR = LIB$SPAWN ('RUN '//FULNAM(1:FLEN),,, 1,
     *         CPNAME(1:PLEN),,,,,,,)
            END IF
         END IF
      IF (SYSERR.EQ.1) THEN
         IERR = 0
         SYSERR = 0
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'MANDL.INC'
C                                       Local Include for MANDL
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQOUT, DISKO, NEWCNO, NUMHIS, JBUFSZ, ICODE
      HOLLERITH XSOURC(2), XNAMOU(3), XCLAOU(2)
      CHARACTER SOURCE*8, NAMOUT*12, CLAOUT*6, HISCRD(10)*64
      REAL      XMSIZE(2), CELLS(2), XSEQO, XDISKO,
     *   CPARM(10), BUFFER(MABFSS)
      COMMON /INPARM/ XSOURC, XMSIZE, CELLS, XNAMOU, XCLAOU, XSEQO,
     *   XDISKO, CPARM
      COMMON /PARMS/ SEQOUT, DISKO, NEWCNO, JBUFSZ, ICODE, NUMHIS
      COMMON /BUFRS/ BUFFER
      COMMON /CHRCOM/ SOURCE, NAMOUT, CLAOUT, HISCRD
LOCAL END
      PROGRAM MANDL
C-----------------------------------------------------------------------
C! Makes an image of a portion of the Mandelbrot set
C# Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MANDL Creates a setion of the Mandelbrot set.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      SOURCE         SOURCE        Object name.
C      IMSIZE         XMSIZE        Image size in pixels.
C      CELLSIZE       CELLS         Pixel size in first two dim.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLAOUT        Class of the output image.
C                                   Default is input class.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      CPARM(10)      CPARM         User specified array.
C                                   1:Xmin;2:Ymin;3:Xmax;4:Ymax
C                                   5:Max Value for Set (0=> 256)
C   Programmer Glen Langston, October 1987
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'MANDL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'MANDL '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL MANIN (PRGM, IRET)
C                                       Call routine that sends data
C                                       to the user routine.
      IF (IRET.EQ.0) CALL SENDMA (IRET)
C                                       History
      IF (IRET.EQ.0) CALL CANHIS
C                                       Close down files, etc.
      CALL DIE (IRET, BUFFER)
C
      STOP
      END
      SUBROUTINE MANIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   MANIN gets input parameters for MANDL and creates an output file.
C   Inputs:  PRGN    C*6       Program name
C   Output:  IRET    I         Error code: 0 => ok
C                                4 => user routine detected error.
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in MANDL for more details.
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6, OLDNAM*12, BLANK*6
      INTEGER   IERR, NPARM, IROUND
      LOGICAL   T, F
      INCLUDE 'MANDL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA BLANK /'      '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
C     NPARM = 2 + 2 + 2 + 3 + 2 + 1 + 1+ 10 = 23
      NPARM = 23
      CALL GTPARM (PRGN, NPARM, RQUICK, XSOURC, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 10
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
C                                       Restart AIPS
 10   IF (RQUICK) CALL RELPOP (IRET, BUFFER, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQOUT = IROUND (XSEQO)
      DISKO = IROUND (XDISKO)
      CALL H2CHR (8, 1, XSOURC, SOURCE)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       Init CATBLK.
      CALL CATINI (CATBLK)
C                                       Create new file.
C                                       Put values in CATBLK.
      OLDNAM = 'MANDLELBROT '
      CALL MAKOUT (OLDNAM, BLANK, 0, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
      CATBLK(KIIMS) = SEQOUT
C                                       Get user modification to CATBLK
      IRET = 4
      CALL NEWHED (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create output file.
      NEWCNO = 1
      IRET = 4
      CALL MCREAT (DISKO, NEWCNO, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 70
         WRITE (MSGTXT,1060) IERR
         GO TO 990
 70   NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
C                                       Set obs. date=current date.
      CALL CHCOPY (8, 1, CATH(KHDMP), 1, CATH(KHDOB))
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MANIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1060 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE SENDMA (IRET)
C-----------------------------------------------------------------------
C   SENDMA accepts an image one row at a time from the user supplied
C   routine.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER IFILE*48
      INTEGER   IRET, LUNO,
     *   NXO, NYO, WINO(4), BOO, LIM2, LIM3, LIM4,
     *   LIM5, LIM6, LIM7, I1, I2, I3, I4, I5, I6, I7, IPOS(7),
     *   LIMO, LIMIT, OBIND, LUN1, LUN2, INDO, LIM1
      REAL      OUTMAX, OUTMIN
      LOGICAL   T, F, BLNKD
      INCLUDE 'MANDL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNO, LUN1, LUN2 /16,17,18/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Create scratch file.
C                                       Open vis file for write
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, F, F, IRET)
      IF (IRET.LE.0) GO TO 30
         WRITE (MSGTXT,1020) IRET
         GO TO 990
C                                       Setup for I/O
 30   NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      OUTMAX = -1.0E20
      OUTMIN = 1.0E20
      BLNKD = F
C                                       Setup for looping
      LIM1 = MAX (1, CATBLK(KINAX))
      LIM2 = MAX (1, CATBLK(KINAX+1))
      LIM3 = MAX (1, CATBLK(KINAX+2))
      LIM4 = MAX (1, CATBLK(KINAX+3))
      LIM5 = MAX (1, CATBLK(KINAX+4))
      LIM6 = MAX (1, CATBLK(KINAX+5))
      LIM7 = MAX (1, CATBLK(KINAX+6))
      IPOS(1) = 1
      LIMO = CATBLK(KINAX) - 1
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = I4
                  DO 300 I3 = 1,LIM3
      IPOS(3) = I3
C                                       Init output file.
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IPOS(3), BOO, IRET)
      BOO = BOO + 1
      CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO, BUFFER, JBUFSZ,
     *   BOO, IRET)
      IF (IRET.EQ.0) GO TO 120
         WRITE (MSGTXT,1100) 'WRIT', IRET
         GO TO 990
 120  DO 250 I2 = 1,LIM2
         IPOS(2) = I2
C                                       Write.
         CALL MDISK ('WRIT', LUNO, INDO, BUFFER, OBIND, IRET)
         OBIND = OBIND - 1
         IF (IRET.EQ.0) GO TO 180
            WRITE (MSGTXT,1120) 'WRIT', IRET
            GO TO 990
C                                       Call MAKMAP
 180     OBIND = OBIND + 1
         CALL MAKMAP (IPOS, BUFFER(OBIND), IRET)
         IF (IRET.EQ.0) GO TO 190
            WRITE (MSGTXT,1180) IRET
            GO TO 990
C                                       Check max, min, blanking.
 190     LIMIT = OBIND + LIMO
         DO 200 I1 = OBIND,LIMIT
            BLNKD = BLNKD .OR. (BUFFER(I1).EQ.FBLANK)
            IF (BUFFER(I1).EQ.FBLANK) GO TO 200
               OUTMAX = MAX (OUTMAX, BUFFER(I1))
               OUTMIN = MIN (OUTMIN, BUFFER(I1))
 200           CONTINUE
 250     CONTINUE
C                                       Dump plane to output.
C                                       Flush buffer.
      CALL MDISK ('FINI', LUNO, INDO, BUFFER, OBIND, IRET)
      IF (IRET.EQ.0) GO TO 260
         WRITE (MSGTXT,1120) 'FINI', IRET
         GO TO 990
C                                       Update CATBLK.
 260  CATR(KRDMX) = OUTMAX
      CATR(KRDMN) = OUTMIN
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', BUFFER, IRET)
      IF (IRET.EQ.0) GO TO 300
         WRITE (MSGTXT,1260) IRET
         GO TO 990
 300  CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Mark blanking in CATBLK.
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
C                                       Final call to MAKMAP
      IPOS(1) = -1
      CALL MAKMAP (IPOS, BUFFER, IRET)
      IF (IRET.EQ.0) GO TO 710
         WRITE (MSGTXT,1180) IRET
         GO TO 990
 710  CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('SENDMA: ERROR',I3,' OPENING SCRATCH FILE')
 1100 FORMAT ('SENDMA: INIT-FOR-',A4,' ERROR',I3)
 1120 FORMAT ('SENDMA: ',A4,' ERROR',I3)
 1180 FORMAT ('SENDMA: MAKMAP ERROR',I3)
 1260 FORMAT ('SENDMA: CATIO ERROR',I3,' UPDATING CATBLK')
      END
      SUBROUTINE CANHIS
C-----------------------------------------------------------------------
C   CANHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, ATIME*8, ADATE*12, LABEL*8
      INTEGER   LUN, IERR, I, TIME(3), DATE(3)
      LOGICAL   T, F
      INCLUDE 'MANDL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN /27/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Create/open hist. file.
      CALL HICREA (LUN, DISKO, NEWCNO, CATBLK, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 999
C                                       Get current date/time.
 10   CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
C                                       Write first record.
      WRITE (MSGTXT,1010) TSKNAM, NLUSER, ADATE, ATIME
      HILINE = MSGTXT
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       New history
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN,
     *   BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       SOURCE
      WRITE (HILINE,2000) TSKNAM, SOURCE
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       IMSIZE
      WRITE (HILINE,2001) TSKNAM, XMSIZE
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       CELLSIZE
      WRITE (HILINE,2002) TSKNAM, CELLS
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       Area
      WRITE (HILINE,2003) TSKNAM, CPARM(1), CPARM(2),CPARM(3),CPARM(4)
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       AIPS release
      WRITE (HILINE,2004) TSKNAM, RLSNAM
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 20
C                                      Add any user supplied history.
      IF (NUMHIS.LE.0) GO TO 20
         WRITE (LABEL,1011) TSKNAM
         DO 15 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 20
 15         CONTINUE
C                                       Close HI file
 20   CALL HICLOS (LUN, T, BUFFER, IERR)
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', BUFFER, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CANHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,'/ Image created by user',I5,' at ',A12,2X,A8)
 1011 FORMAT (A6,' /')
 2000 FORMAT (A6,' SOURCE = ',1H',A8,1H')
 2001 FORMAT (A6,' IMSIZE = ', 2F8.0)
 2002 FORMAT (A6,' CELLSIZE = ',2F10.5)
 2003 FORMAT (A6,' Min = ( ',F8.5,',',F8.5,'); Max = ( ',
     *                        F8.5,',',F8.5,')')
 2004 FORMAT (A6,' RELEASE = ''',A7,' ''')
      END
      SUBROUTINE NEWHED (IRET)
C-----------------------------------------------------------------------
C   NEWHED is a routine in which the user performs several operations
C   associated with beginning the task.
C   Input:
C      CATBLK(256)    I     Output catalog header, also CATR, CATD, CATH
C                           The OUTNAME, OUTCLASS, OUTSEQ are entered
C                           elsewhere.
C   Output:
C      CATBLK(256)    I     Modified output catalog header.
C      IRET           I     Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER FCHARS(3)*4, UNITS(10)*8, ATYPES(7)*8
      INTEGER   I, NAXIS, IRET, IROUND, NX, NY, INDEX, MAXVAL
      REAL      XMIN, YMIN, XMAX, YMAX
      REAL      XRANGE, YRANGE, XSCALE, YSCALE
      INCLUDE 'MANDL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA FCHARS /'FREQ','VELO','FELO'/
C                                       Output units for each OPCODE.
      DATA UNITS /'COUNTS  ',9*'        '/
C                                       Number of axes and types.
C                                       (Set for two axes = Ra, Dec.)
      DATA NAXIS  /2/
      DATA ATYPES /' X      ', ' Y      ', 'STOKES  ', 'FREQ    ',
     *   3*'        '/
C-----------------------------------------------------------------------
C                                       Set default OPCODE
      ICODE = 1
C                                       Set output units.
      CALL CHR2H (8, UNITS(ICODE), 1, CATH(KHBUN))
C                                       Fill axis type from ATYPES
      DO 30 I = 1,NAXIS
         INDEX = KHCTP + (I-1) * 2
         CALL CHR2H (8, ATYPES(I), 1, CATH(INDEX))
 30      CONTINUE
C
C                                       Fill in values.
      IF (XMSIZE(1).LT.2) XMSIZE(1) = 256
      IF (XMSIZE(2).LT.2) XMSIZE(2) = 256
      CATBLK(KINAX) = MAX (IROUND (XMSIZE(1)), 1)
      CATBLK(KINAX+1) = MAX (IROUND (XMSIZE(2)), 1)
      NX = CATBLK(KINAX)
      NY = CATBLK(KINAX+1)
C                                       Calculate mandlebort specific
C                                       Values, scale etc
C                                       RANGEs must be greater than zero
      XMIN = CPARM(1)
      YMIN = CPARM(2)
      XMAX = CPARM(3)
      YMAX = CPARM(4)
      IF (XMAX-XMIN.EQ.0.0) CPARM(1) = -2.
      IF (XMAX-XMIN.EQ.0.0) CPARM(3) =  1.
      IF (YMAX-YMIN.EQ.0.0) CPARM(2) = -1.5
      IF (YMAX-YMIN.EQ.0.0) CPARM(4) =  1.5
      XMIN = CPARM(1)
      YMIN = CPARM(2)
      XMAX = CPARM(3)
      YMAX = CPARM(4)
C                                       IF YMAX not Set, make a square
      IF (YMAX.EQ.0) YMAX = YMIN + XMAX - XMIN
      CPARM(4) = YMAX
C                                       Max Number of iterations must be
C                                       greater than 1 and less than i*2
      MAXVAL = CPARM(5)
      IF (MAXVAL.LT.2) MAXVAL = 255
      CPARM(5) = MAXVAL
C                                       Calculate cell size from max
C                                       and min use the smaller cell
C                                       size.
      XRANGE = XMAX - XMIN
      YRANGE = YMAX - YMIN
      XSCALE = 3 / 256.
      YSCALE = 3 / 256.
      IF (XRANGE.NE.0.) XSCALE = XRANGE / NX
      IF (YRANGE.NE.0.) YSCALE = YRANGE / NY
C                                       if cells is not specified
C                                       use calculation from range
      IF (CELLS(1).EQ.0) CELLS(1) = XSCALE
      IF (CELLS(2).EQ.0) CELLS(2) = YSCALE
C                                       Subsequent calls.
      CATR(KRCIC) = CELLS(1)
      CATR(KRCIC+1) = CELLS(2)
C                                       Init. ref value for pixel
C                                       location.
      CATD(KDCRV) =   ((XMAX+XMIN)/2.) - (CELLS(1)*NX/2.)
      CATD(KDCRV+1) = ((YMAX+YMIN)/2.) - (CELLS(2)*NY/2.)
C                                       Fill other character strings.
C                                       Object.
      CALL CHR2H (8, SOURCE, 1, CATH(KHOBJ))
C                                       Set number of axes.
      CATBLK(KIDIM) = NAXIS
C                                       Miscellaneous items.
C                                       Epoch.
      CATR(KREPO) = 0.0
C                                       Finished.
      IRET = 0
      GO TO 999
C
 999  RETURN
      END
      SUBROUTINE MAKMAP (IPOS, RESULT, IRET)
C-----------------------------------------------------------------------
C   Returns Mandelbrot image.
C   Inputs:
C      IPOS(7)   I    BLC (input image) of first value in DATA
C   Values from commons:
C      ICODE     I    Opcode number from list in NEWHED.
C      CPARM(10) R    Input adverb array.
C      DPARM(10) R    Input adverb array.
C      CATBLK    I    Output catalog header (also CATR, CATD)
C   Output:
C      RESULT(*) R    Output row.
C      IRET      I    Return code   0 => OK
C                               >0 => error, terminate.
C   Output in COMMON
C      NUMHIS     I    # history entries (max. 10)
C      HISCRD(NUMHIS) C*64   History records
C      CATBLK     I    Catalog header block
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), NX, I, IRET
      REAL      RESULT(*)
      REAL   XMIN, YMIN, XSCALE, YSCALE, X,Y
      INTEGER   M, MAXVAL
      INCLUDE 'MANDL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Check if last call
      IF (IPOS(1).LT.0) GO TO 999
C                                       Set length of a row.
      NX = CATBLK(KINAX)
      XMIN = CPARM(1)
      YMIN = CPARM(2)
      XSCALE = CELLS(1)
      YSCALE = CELLS(2)
      MAXVAL = CPARM(5)
C                                       Subsequent calls.
C                                       Calc Y coordinate for this row
      Y = (YSCALE*IPOS(2)) + YMIN
C                                       Create map row by calling MAND
      DO 300 I = 1,NX
         X = (XSCALE*I) + XMIN
         CALL MAND (X, Y, MAXVAL, M)
         RESULT(I) = M
 300  CONTINUE
C
 999  RETURN
      END
      SUBROUTINE MAND (X, Y, MAXVAL, KOUNT)
C-----------------------------------------------------------------------
C   Calculates the mandelbrot integer for the point x,y in the plane.
C   Input:
C    X,Y      R   Complex coordinate of point for calculation
C    MAXVAL   I   Max Value returned by MAND = Number of iterations
C Output
C    KOUNT    I   Number between 1 and some limit
C-----------------------------------------------------------------------
      REAL      X, Y
      INTEGER   KOUNT, MAXVAL, LOOP
      REAL      Z1, Z2, ZNEXT1, ZMAG2
C --------------------------------------------------------------
C                               initialize squared value
      Z1 = 0.0
      Z2 = 0.0
C                               for a limited number of times
      DO 100 LOOP = 1,MAXVAL-1
         KOUNT = LOOP
         Z1 = Z1 + X
         Z2 = Z2 + Y
C                               complex squaring
         ZNEXT1 = (Z1*Z1) - (Z2*Z2)
         Z2 = 2 * Z1 * Z2
         Z1 = ZNEXT1
C                               calcuate magnitude squared
         ZMAG2 = (Z1*Z1) + (Z2*Z2)
C                               if zmag is greater than 2, exit
         IF (ZMAG2.GT.4) GO TO 999
100      CONTINUE
C
999   RETURN
      END

      PROGRAM SHOPA
C-----------------------------------------------------------------------
C! Extracts one liners and catagories from text files
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Program to extract the shopping list information from text files.
C   Reads SHOPA.LIS for a list of files to process, one name
C   per line.; the input files are assumed to have the name "name.type"
C   where type can be FOR ,C, HLP, MAR or TEX.  The first line of
C   SHOPA.LIS is expected to contain the name of the directory being
C   processed.
C      A logical or enviroment variable named MYDIR must be defined
C   before running SHOPA.
C      The output will be written to a file named SHOPA.OUT and will
C   consist of one line per category for each file.  The output line
C   will be:
C   <category> <name> <directory> <type> <one line description>
C-----------------------------------------------------------------------
      INTEGER MAXTYP
      PARAMETER (MAXTYP = 5)
      CHARACTER INLINE*100, ONELIN*100, OUTLIN*200, INFIL*48, OUTFIL*48,
     *   LFIL*48, SUBNAM*20, NAME*10, TYPE*10, DIRECT*40, CH1LIN*10,
     *   CHCAT*10, TYPES(MAXTYP)*10, TYP1LN(MAXTYP)*10, CATS(50)*20,
     *   TYPCAT(MAXTYP)*10
      INTEGER   LOOP, IOERR, ITYPE, SCRLEN, TYPLEN(MAXTYP), BLNK1,
     *   LEND, NUMCAT, LEN, LCATS, BUFFER(512), LUNI, LUNO, FINDI,
     *   FINDO, LUNL, FINDL, JTRIM, ISL, IST, JT
      LOGICAL   DONE, IS1LIN, ISCAT, GOT1LN, GOTCAT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA TYPES  /'FOR','C','MAR','HLP','TEX'/
      DATA TYP1LN /'C!','/*!', ';!',';!', '%!'/
      DATA TYPCAT /'C#','/*#', ';#',';#', '%#'/
      DATA TYPLEN / 2,   3,     2,   2,    2/
      DATA LUNI, LUNO, LUNL /16, 17, 18/
C-----------------------------------------------------------------------
C                                       AIPS system start up stuff
      TSKNAM ='SHOPA'
      NPOPS = 1
      MSGKIL = 32000
      MSGSUP = 32000
      CALL ZDCHIN (.FALSE., BUFFER)
      MSGKIL = 32000
      DEVTAB(LUNI) = 3
      DEVTAB(LUNO) = 3
      DEVTAB(LUNL) = 3
C                                       Get list of routines
      LFIL = 'MYDIR:SHOPA.LIS'
      CALL ZTXOPN ('READ', LUNL, FINDL, LFIL, .FALSE., IOERR)
      IF (IOERR.NE.0) GO TO 999
C                                       Get directory name
      CALL ZTXIO ('READ', LUNL, FINDL, DIRECT, IOERR)
      IF (IOERR.NE.0) GO TO 900
      JT = JTRIM (DIRECT)
C                                       Open output file
      OUTFIL = 'MYDIR:SHOPA.OUT'
      CALL ZTXOPN ('WRIT', LUNO, FINDO, OUTFIL, .TRUE., IOERR)
      IF (IOERR.NE.0) GO TO 900
C                                       Begin looping over files
 100     CALL ZTXIO ('READ', LUNL, FINDL, INLINE, IOERR)
         IF (IOERR.NE.0) GO TO 900
         JT = JTRIM (INLINE)
         IF (INLINE.EQ.' ') GO TO 900
C                                       Is this a qualified name?
         ISL = INDEX (INLINE, '/')
         IST = ISL
 105     IF (IST.GT.0) THEN
            IST = INDEX (INLINE(ISL+1:), '/')
            ISL = ISL + IST
            GO TO 105
            END IF
         SUBNAM = INLINE(ISL+1:)
C                                       Find first blank or '.'
         BLNK1 = INDEX (SUBNAM,'.')
C                                       Form input names etc
         INFIL = DIRECT(1:JTRIM(DIRECT)) // ':'// SUBNAM
         LEND = BLNK1 + INDEX (SUBNAM(BLNK1+1:), ' ')
         NAME = SUBNAM(1:BLNK1-1)
         TYPE = SUBNAM(BLNK1+1:LEND)
C                                       Must have type
         IF (TYPE.EQ.'  ') THEN
            WRITE (6,1100) SUBNAM
            GO TO 100
            END IF
C                                       Set up for this type.
         ITYPE = 0
         DO 110 LOOP = 1,MAXTYP
            IF (TYPE.EQ.TYPES(LOOP)) ITYPE = LOOP
 110        CONTINUE
         IF (ITYPE.EQ.0) THEN
C                                       Unknown type
            WRITE (6,1110) SUBNAM
            GO TO 100
            END IF
         SCRLEN = TYPLEN(ITYPE)
         CH1LIN = TYP1LN(ITYPE)
         CHCAT = TYPCAT(ITYPE)
C                                       Open input file
         CALL ZTXOPN ('READ', LUNI, FINDI, INFIL, .FALSE., IOERR)
         IF (IOERR.NE.0) GO TO 100
C                                       Digest file:
         DONE = .FALSE.
         GOT1LN = .FALSE.
         GOTCAT = .FALSE.
         NUMCAT = 0
C                                       Read line loop
 200        CALL ZTXIO ('READ', LUNI, FINDI, INLINE, IOERR)
C                                       End of file?
            IF (IOERR.EQ.2) GO TO 600
C                                       Error?
            IF (IOERR.GT.0) GO TO 590
            JT = JTRIM (INLINE)
C                                       Want this one?
            IS1LIN = INLINE(1:SCRLEN) .EQ. CH1LIN(1:SCRLEN)
            ISCAT = INLINE(1:SCRLEN) .EQ. CHCAT(1:SCRLEN)
C                                       Save one liner
C            IF (IS1LIN) ONELIN = INLINE(SCRLEN+1:)
            IF (IS1LIN) CALL WONLIN (INLINE(SCRLEN+1:), ONELIN)
            GOT1LN = GOT1LN .OR. IS1LIN
C                                       Read categories
            IF (ISCAT) THEN
               LEN = JTRIM (INLINE(SCRLEN+1:))
               LCATS = 20
               CALL RWORDS (INLINE(SCRLEN+1:), LEN, NUMCAT, LCATS, CATS)
               END IF
            GOTCAT = GOTCAT .OR. ISCAT
C                                       Done? - may be several category
C                                       lines.
            DONE = GOT1LN .AND. GOTCAT .AND. (.NOT.ISCAT)
            IF (DONE) GO TO 600
C                                       Next line
            GO TO 200
C                                       Error - close file
 590     WRITE (6,1590) SUBNAM
C                                       End - close file
 600     CALL ZTXCLS (LUNI, FINDI, IOERR)
         IF (IOERR.NE.0) GO TO 900
C                                       Write output
         IF (DONE) THEN
C                                       One line per category
            DO 700 LOOP = 1,NUMCAT
               OUTLIN = '''' // CATS(LOOP)(1:JTRIM(CATS(LOOP))) // ''' '
     *            //
     *            '''' // NAME(1:JTRIM(NAME)) // ''' ' //
     *            '''' // DIRECT(1:JTRIM(DIRECT)) // ''' ' //
     *            '''' // TYPE(1:JTRIM(TYPE)) // ''' ' //
     *            '''' // ONELIN(1:JTRIM(ONELIN)) // ''''
               CALL ZTXIO ('WRIT', LUNO, FINDO,
     *            OUTLIN(1:JTRIM(OUTLIN)), IOERR)
               IF (IOERR.NE.0) GO TO 900
 700           CONTINUE
            END IF
C                                       Next file
         GO TO 100
C                                       Done - close files
 900  CALL ZTXCLS (LUNO, FINDO, IOERR)
      CALL ZTXCLS (LUNL, FINDL, IOERR)
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT (A20)
 1100 FORMAT (' FILE TYPE MUST BE SPECIFIED FOR ',A)
 1110 FORMAT (' UNKNOWN FILE TYPE: ',A)
 1590 FORMAT (' ERROR READING FILE ',A)
      END
      SUBROUTINE RWORDS (LINE, LEN, NWORD, LWORDS, WORDS)
C-----------------------------------------------------------------------
C   Routine to get a list of words from a string:
C   Inputs:
C      LINE   C*(*)      Line to be scanned
C      LEN    I          Length of LINE to be searched.
C   Inputs/outputs:
C      NWORD  I          Number of values in WORDS
C      LWORD  I          Max number of characters in WORDS
C      WORDS  C(*)*LWORD Array or words
C-----------------------------------------------------------------------
      INTEGER   LEN, NWORD, LWORDS
      CHARACTER LINE*(*), WORDS(*)*(*)
C
      INTEGER   POINT, WEND
C-----------------------------------------------------------------------
      POINT = 1
C                                       Loop finding words
C                                       Find next nonblank or end
 100  IF (POINT.GE.LEN) GO TO 999
      IF (LINE(POINT:POINT).NE.' ') THEN
C                                       Found start of word
         WEND = POINT + INDEX (LINE(POINT:LEN), ' ')
C                                       Last on line?
         IF (WEND.EQ.POINT) WEND = LEN + 1
C                                       Snatch word
         NWORD = NWORD + 1
         WORDS(NWORD)(1:LWORDS) = LINE(POINT:WEND-1)
         POINT = WEND
         GO TO 100
      ELSE
C                                       Blank
         POINT = POINT + 1
         GO TO 100
         END IF
C
 999  RETURN
      END
      SUBROUTINE WONLIN (INLINE, ONELIN)
C-----------------------------------------------------------------------
C   Routine to extract one line information from INLINE and writting it
C   to ONELIN.  Single quotes are doubled to preserve them inside of the
C   character string.
C   Input:
C      INLINE  C*(*)  Input text string
C   Output:
C      ONELINE C*(*)  Output text string
C-----------------------------------------------------------------------
      CHARACTER INLINE*(*), ONELIN*(*)
C
      INTEGER   LENG, LOOP, POINT
      CHARACTER CHAR1*1, TCHAR*1
      DATA TCHAR /''''/
C-----------------------------------------------------------------------
C                                       Initialize
      LENG = LEN (INLINE)
      ONELIN = ' '
      POINT = 1
C                                       Copy doubling single quotes.
      DO 100 LOOP = 1,LENG
         CHAR1 = INLINE(LOOP:LOOP)
         IF (CHAR1.EQ.TCHAR) THEN
            ONELIN(POINT:POINT+1) = TCHAR // TCHAR
            POINT = POINT + 2
         ELSE
            ONELIN(POINT:POINT) = CHAR1
            POINT = POINT + 1
            END IF
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE READPL (TTYPE, IVOL, CNO, IVER, CATBLK, FDVEC, INBLK,
     *   TBIND, TAPBUF, IRET)
C-----------------------------------------------------------------------
C! Reads a FITS plot/slice file pretending to be a FITS binary table
C# EXT-util FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 2024-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Reads FITS pseudo-table = aips PL file, creates and fills the file
C   Inputs
C      TTYPE    C*2      File type PL, SL
C      IVOL     I        Output file disk
C      CNO      I        Output file catalog number
C      IVER     I        Output PL version
C      INBLK    I        Number of 2880-byte records to read
C   In/out
C      CATBLK   I(256)   header
C      FDVEC    I(*)     I/O control array
C      TBIND    I        I/O pointer
C      TAPBUF   I(*)     I/O buffer
C   Output
C      IRET     I        Error code
C-----------------------------------------------------------------------
      CHARACTER TTYPE*2
      INTEGER   IVOL, CNO, IVER, CATBLK(256), FDVEC(*), INBLK, TBIND,
     *   TAPBUF(*), IRET
C
      INTEGER   LUN, FIND, IBUFF(256), IPOS, IC, IREC, FBUFF(720),
     *   ISIZE, I, FPOS, LUNTMP
      CHARACTER PHNAME*48
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      FIND = 0
C                                       PL in header
      CALL MADDEX (TTYPE, IVOL, CNO, CATBLK, IBUFF, .TRUE., 'UPDT',
     *   IVER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'ADDING PL FILE TO HEADER'
         GO TO 980
         END IF
      WRITE (MSGTXT,1010) TTYPE, IVER
      CALL MSGWRT (3)
C                                       create file
      ISIZE = (INBLK * 720) / 256
      CALL ZPHFIL (TTYPE, IVOL, CNO, IVER, PHNAME, IRET)
      CALL ZCREAT (IVOL, PHNAME, ISIZE, .FALSE., I, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATING ' // TTYPE // ' FILE'
         GO TO 970
         END IF
C                                       open
      LUN = LUNTMP (1)
      CALL ZOPEN (LUN, FIND, IVOL, PHNAME, .FALSE., .TRUE., .TRUE.,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING ' // TTYPE //
     *      'FILE TO WRITE'
         GO TO 960
      END IF
C                                       write the file
      IREC = 0
      IPOS = 1
      DO 100 I = 1,INBLK
         CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING FITS FILE FOR ' // TTYPE
     *         // ' FILE'
            GO TO 960
            END IF
         CALL ZI32IL (720, 1, TAPBUF(TBIND), FBUFF)
         FPOS = 1
 20      IC = 257 - IPOS
         IF (IC+FPOS.LT.721) THEN
            CALL COPY (IC, FBUFF(FPOS), IBUFF(IPOS))
            IPOS = IPOS + IC
            FPOS = FPOS + IC
         ELSE
            IC = 721 - FPOS
            CALL COPY (IC, FBUFF(FPOS), IBUFF(IPOS))
            IPOS = IPOS + IC
            FPOS = FPOS + IC
            END IF
         IF (IPOS.GT.256) THEN
            IREC = IREC + 1
            CALL ZFIO ('WRIT', LUN, FIND, IREC, IBUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITING ' // TTYPE // ' FILE'
               GO TO 960
               END IF
            IPOS = 1
            END IF
         IF (FPOS.LT.721) GO TO 20
 100     CONTINUE
C                                       close
      IF ((IPOS.GT.1) .AND. (IREC.LT.ISIZE)) THEN
         IREC = IREC + 1
         CALL ZFIO ('WRIT', LUN, FIND, IREC, IBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING ' // TTYPE //
     *         ' FILE LAST RECORD'
            GO TO 960
            END IF
         END IF
      CALL ZCLOSE (LUN, FIND, IC)
      GO TO 999
C
 960  CALL MSGWRT (8)
      CALL ZDESTR (IVOL, PHNAME, IC)
      IF (IC.NE.0) THEN
         WRITE (MSGTXT,1000) IC, 'FAILED TO DELETE BAD ' // TTYPE //
     *      ' FILE'
         CALL MSGWRT (8)
         END IF
      GO TO 975
C
 970  CALL MSGWRT (8)
 975  CALL DELEXT ('PL', IVOL, CNO, 'WRWR', CATBLK, FBUFF, IVER, IC)
      IF (IC.NE.0) THEN
         WRITE (MSGTXT,1000) IC, 'FAILED TO DELETE BAD ' // TTYPE //
     *      ' FROM HEADER'
         CALL MSGWRT (8)
         END IF
      IF (FIND.GT.0) CALL ZCLOSE (LUN, FIND, IC)
      GO TO 999
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('READPL ERROR',I5,' ON ',A)
 1010 FORMAT ('Reading ',A,' file version',I5)
      END

      SUBROUTINE MAPOPN (OP, IVOL, NAMEIN, CLASIN, SEQIN, TYPIN, USID,
     *   LUN, IND, CNO, CATBLK, WBUFF, IERR)
C-----------------------------------------------------------------------
C! open file pointed to by catalog entry and mark the entry busy
C# Catalog IO-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MAPOPN opens a map file marking the catalog entry for the desired
C   type of operation.
C   Inputs:
C      OP      C*4     Operation: READ, WRIT, or INIT where INIT is for
C                      known creation processes (it ignores current file
C                      status & leaves it unchanged).  Also: HDWR for
C                      use when the header is being changed, but the
C                      data are to be read only.
C      LUN     I       Logical unit # to use
C   In/out:
C      NAMEIN  C*12    Image name (name)
C      CLASIN  C*6     Image name (class)
C      SEQIN   I       Image name (seq.#)
C      USID    I       User identification #
C      IVOL    I       Input disk unit
C      TYPIN   C*2     Physical type of file
C   Outputs:
C      IND     I       FTAB pointer
C      CNO     I       Catalog slot containing map
C      CATBLK  I(256)  Buffer containing current catalog block
C      WBUFF   I(256)  Working buffer for CATIO and CATDIR
C      IERR    I       Error output: 0 = OK
C                         2 = Can't open WRIT because file busy
C                             or can't READ because file marked WRITE
C                         3 = File not found
C                         4 = Catalog i/o error
C                         5 = Illegal OP code
C                         6 = Can't open file
C-----------------------------------------------------------------------
      CHARACTER OP*4, NAMEIN*(*), CLASIN*(*), TYPIN*2
      INTEGER   IVOL, SEQIN, USID, LUN, IND, CNO, CATBLK(256),
     *   WBUFF(256), IERR
C
      CHARACTER  STAT*4, UNCODE(4)*4, STCODE(4)*4, MNAME*48,
     *   OPCODE(4)*4
      INTEGER   IOP, NOP, OPERR, IER, JER, DUM
      LOGICAL   T, EXCL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA DUM, OPERR /1, 5/
      DATA T /.TRUE./
      DATA STCODE /'READ', 'WRIT', 'REST', 'WRIT'/
      DATA UNCODE /'CLRD', 'CLWR', 'REST', 'CLWR'/
      DATA NOP, OPCODE /4, 'READ', 'WRIT', 'INIT', 'HDWR'/
C-----------------------------------------------------------------------
C                                       get op code
      IERR = 0
      JER = 4
      DO 10 IOP = 1,NOP
         IF (OP.EQ.OPCODE(IOP)) GO TO 20
 10      CONTINUE
      IERR = OPERR
      GO TO 999
C                                       Find and open map
 20   CNO = 1
      CALL CATDIR ('SRCH', IVOL, CNO, NAMEIN, CLASIN, SEQIN, TYPIN,
     *    USID, STAT, WBUFF, IER)
      IF (IER.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) NAMEIN, CLASIN, SEQIN, TYPIN, USID
         CALL MSGWRT (7)
         IERR = 3
         GO TO 999
C                                       read catblock: set end status
 30   CALL CATIO ('READ', IVOL, CNO, CATBLK, STCODE(IOP), WBUFF, JER)
      IF (JER.EQ.0) GO TO 50
C                                       Catalog i/o errors
         IF (JER.GT.3) GO TO 40
            IERR = 4
            WRITE (MSGTXT,1030) JER
            GO TO 980
C                                       Branch according to OP
 40      IF (IOP.EQ.3) GO TO 50
C                                       For READ now an error
C                                       For write on busy real error
         IERR = 2
         WRITE (MSGTXT,1040) NAMEIN, CLASIN, SEQIN
         GO TO 980
C                                       Open the file
 50   CALL ZPHFIL (TYPIN, IVOL, CNO, 1, MNAME, IER)
      EXCL = (IOP.EQ.2) .OR. (IOP.EQ.3)
      CALL ZOPEN (LUN, IND, IVOL, MNAME, T, EXCL, T, IER)
      IF (IER.EQ.0) GO TO 999
         IERR = 6
         WRITE (MSGTXT,1050) NAMEIN, CLASIN, SEQIN, IER
         GO TO 980
C-----------------------------------------------------------------------
C                                       errors
 980  CALL MSGWRT (8)
      IF (JER.NE.4) CALL CATDIR ('CSTA', IVOL, CNO, NAMEIN, CLASIN, DUM,
     *   TYPIN, DUM, UNCODE(IOP), CATBLK, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT (A12,'.',A6,'.',I4,' ',A2,I5,' NOT FOUND')
 1030 FORMAT ('MAPOPN: CATALOG I/O ERROR =',I5)
 1040 FORMAT ('MAPOPN: ERROR ',A12,'.',A6,'.',I4,' TOO BUSY')
 1050 FORMAT ('CANT OPEN ',A12,'.',A6,'.',I4,' IER=',I4)
      END

      SUBROUTINE ZDEAXF (OPER, BUFF, NBYTE, PA, PB, WAIT, IERR)
C-----------------------------------------------------------------------
C! do IO to DeAnza TV
C# Z TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Queue an I/O operation to the DeAnza TV device, and wait for
C   completion if requested.
C   Inputs:
C       OPER    C*4     Operation code
C       BUFF    I(?)    User i/o buffer
C       NBYTE   I       Number of bytes to be transferred
C       PA      I       1st extra parameter
C       PB      I       2nd extra parameter
C       WAIT    L       If .TRUE. wait for completion before return
C  Outputs:
C       IERR    I       Error code
C   Calls to ZDEAXF map one to one to calls to IP8 routines in the
C   DeAnza IP8500 level 0 software package.  I replaced them here for
C   the following reasons:
C   (1)  I don't like EXTERNALs scattered all over the code, so now they
C        are all concentrated here in 1 subroutine.
C   (2)  If you want to do any asynchronous calls, the event flag
C        numbers, IOSBs and other such structures are now contained in
C        the standard AIPS FTAB structure, instead of being buried in
C        IP8500 code.  Thus calls to ZWAIT (TVLUN, IERR) etc. will do
C        the right thing.  I do not use this in the current
C        implimentation.
C   This effort may have been misguided, but now its done.  If you
C   want to go back to IP8 calls, it won't be much work.
C                               W. Jaffe     Nov-1983
C   Generic version - calls ZDEAX2, ZIPACK to make 16-bit buffers
C-----------------------------------------------------------------------
      CHARACTER OPER*(*)
      INTEGER   BUFF(*), NBYTE, PA, PB, IERR, I
      LOGICAL   WAIT
C
      CHARACTER*4 OPERS(20)
      INTEGER   NOPERS, FCBOFF, IOP, TVBUFF(2048), NWORD
      LOGICAL   F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA F /.FALSE./
      DATA NOPERS /20/
      DATA (OPERS(I),I=1,20) /'DAT ','DET ','LR  ','RR  ','WI  ',
     *   'RI  ','LCR ','RCR ','BMC ','LMC ','LPR ','RPR ','LVR ',
     *   'RVR ','LWA ','RWA ','LPA ','RPA ','WR  ','BPA '/
C-----------------------------------------------------------------------
C                                       check OPER
      DO 10 IOP = 1,NOPERS
         IF (OPER.EQ.OPERS(IOP)) GO TO 20
 10      CONTINUE
      WRITE (MSGTXT,1010) OPER
      IERR = 2
      GO TO 995
C                                       Not open
 20   IF (FTAB(TVIND).EQ.TVLUN) GO TO 30
         WRITE (MSGTXT,1020)
         IERR = 1
         GO TO 995
C                                       locate UFT
 30   FCBOFF = TVIND + NMOFF
C                                       pack to 16 bits
      NWORD = (NBYTE + 1) / 2
      CALL ZIPACK ('LTOS', NWORD, BUFF, 1, TVBUFF)
C                                       Set up IO call
      CALL ZDEAX2 (FTAB(FCBOFF), IOP, OPER, TVBUFF, NBYTE, PA, PB,
     *   WAIT, IERR)
C                                       unpack to 32 bits
      IF (IERR.EQ.0) THEN
         CALL ZIPACK ('STOL', NWORD, BUFF, 1, TVBUFF)
C                                       or report error
      ELSE
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (7)
         CALL ZERROR ('ZDEAX2', FTAB(FCBOFF+FCBERR), ' ', FTAB(FCBOFF),
     *      F)
         END IF
      GO TO 999
C
 995  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ZDEAXF: OPER ''',A4,''' NOT RECOGNIZED')
 1020 FORMAT ('ZDEAXF: TV NOT OPEN IN FTAB')
 1030 FORMAT ('ZDEAXF: ERROR',I5,' RETURNED BY ZDEAX2')
      END

      SUBROUTINE INVERT (MINP, MINV, N, IERR)
C-----------------------------------------------------------------------
C! Routine to invert a matrix by Gaussian elimination
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 2001
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Routine to invert a matrix by Gaussian elimination
C   Sizes maxed at 64 x 64
C   Inputs:
C      MINP      R(N,N)  The input matrix
C      N         I       Order of the matrix
C   Output:
C      MINV      R(N,N)  The inverse matrix
C      IERR I    Error code, 0=OK,
C                1=matrix singular.
C-----------------------------------------------------------------------
      INTEGER N, IERR
      INTEGER N2, I, J, K, IJ
      DOUBLE PRECISION MINP(*), MINV(*)
      DOUBLE PRECISION D(64,128), ALPHA, BETA
      DOUBLE PRECISION A(64,64)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       store the input matrix in the
C                                       two dimension array
      DO 20 I = 1,N
         DO 10 J = 1,N
            IJ = J + (I-1)*N
            A(I,J) = MINP(IJ)
   10       CONTINUE
   20    CONTINUE
C
      N2 = 2*N
      DO 40 I = 1,N
         DO 30 J = 1,N
            D(I,J) = A(I,J)
            D(I,N+J) = 0.
   30       CONTINUE
         D(I,N+I) = 1.
   40    CONTINUE
C                                       Do the reduction
      DO 80 I = 1,N
         ALPHA = D(I,I)
         IF(ALPHA .EQ. 0.) GO TO 300
         DO 50 J = 1,N2
            D(I,J) = D(I,J)/ALPHA
   50       CONTINUE
         DO 70 K = 1,N
            IF((K-I).EQ.0) GO TO 70
            BETA = D(K,I)
            DO 60 J = 1,N2
               D(K,J) = D(K,J) - BETA*D(I,J)
   60          CONTINUE
   70       CONTINUE
   80    CONTINUE
C                                       Copy result into output matrix
       DO 100 I = 1,N
          DO 90 J = 1,N
             IJ = J + (I-1)*N
             MINV(IJ) = D(I,J+N)
   90        CONTINUE
  100     CONTINUE
       GO TO 999
 300   IERR = 1
       WRITE (MSGTXT,1000)
       CALL MSGWRT (5)
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('*** ERROR: SINGULAR MATRIX ***')
      END

      SUBROUTINE QCFT1D (SIGN, LEN, ARRAY, WSAVE)
C-----------------------------------------------------------------------
C! Pseudo AP routine: complex-to-complex 1D FFT
C# AP-FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 2006, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Replace the first LEN elements by either their unnormalized
C   discrete Fourier transform
C
C   for all j = 1 .. LEN
C      ARRAY'(j) = sum over k = 1 .. LEN of
C         ARRAY(j) * exp (SIGN * -i * (j-1) * (k-1) * 2 * pi / LEN)
C
C   where SIGN is +1 or -1.  Note that SIGN = +1 gives the Fourier
C   transform while SIGN = -1 gives an inverse Fourier transform.
C   The results of this routine are undefined if SIGN has any other
C   value.  Calling QCFT1D with SIGN = +1 and then with SIGN = -1
C   on has the effect of multiplying each element of the array by
C   LEN.
C
C   WSAVE must have been initialized for the specified value of LEN
C   (which must be positive) by calling QCFT1I and should not have
C   been modified.
C
C   The combination of QCFT1I and QCFT1D is should be used in
C   preference to the older routine QXFOUR for the following
C   reasons
C
C   1) QCFT1D may be used for any length of Fourier transform while
C      QXFOUR is limited to powers of two and has a fixed maximum
C      size.
C   2) The default implementation of QCFT1D is approximately
C      twice as fast as QXFOUR in most cases.  Optimized versions
C      for specific machines may be 3 to 4 times faster than
C      QXFOUR.
C   Input:
C      SIGN     I      Direction of transform
C      LEN      I      The length of the FFT
C      WSAVE    R(*)   Initialized workspace (from QCFT1I)
C   Input/Output:
C      ARRAY      C(*)       Array to be transformed: replaced by its
C                            transform
C-----------------------------------------------------------------------
      INTEGER   SIGN, LEN
      COMPLEX   ARRAY(*)
      REAL      WSAVE(*)
C-----------------------------------------------------------------------
C                                       Default version uses FFTPACK
      IF (SIGN.EQ.1) THEN
         CALL CFFTF (LEN, ARRAY, WSAVE, WSAVE)
      ELSE
         CALL CFFTB (LEN, ARRAY, WSAVE, WSAVE)
         END IF
C
      RETURN
      END

      SUBROUTINE OE2VEC (SEMIMA, ECCEN, INCLIN, RAANOD, APERIG, MANMLY,
     *                   POS, VEL)
C-----------------------------------------------------------------------
C! Convert orbital elements to position and velocity vectors
C# Util Orbits
C-----------------------------------------------------------------------
C;  Copyright (C) 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Convert a set of orbital elements for an Earth satellite into a
C   position and velocity vector in the intertial frame to which the
C   elements are referred.  The Cartesian coordinates are a right handed
C   set with axis 1 pointing towards RA 0, Dec 0 and with axis 2
C   pointing towards to North celestial pole.
C
C
C   Inputs:
C      SEMIMA    D          Semimajor axis (m)
C      ECCEN     D          Eccentricity
C      INCLIN    D          Inclination (radians)
C      RAANOD    D          Right ascension of ascending node (radians)
C      APERIG    D          Argument of perigee (radians)
C      MANMLY    D          Mean anomaly (radians)
C
C   Outputs:
C      POS       D(3)       Position vector (m)
C      VEL       D(3)       Velocity vector (m s**-1)
C
C   References:
C     "Orbital Motion", A.E. Roy, Institute of Physics Press, 1988
C     (Chapter 4)
C-----------------------------------------------------------------------
      DOUBLE PRECISION SEMIMA, ECCEN, INCLIN, RAANOD, APERIG, MANMLY,
     *                 POS(3), VEL(3)
C
C     Local variables
C
C     E      Eccentric anomaly
C     R      Length of radius vector (m)
C     V      Velocity (m s**-1)
C     F      True anomaly (radians)
C     PHI    Angle between velocity vector and radius vector (radians)
C
      DOUBLE PRECISION E, R, V, F, PHI
C
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PEARTH.INC'
C-----------------------------------------------------------------------
C
C     Solve Kepler's equation for the eccentric anomaly:
C
      CALL SLVKEP (MANMLY, ECCEN, E, 1.0D-10)
C
      R = SEMIMA * (1.0D0 - ECCEN * COS (E))
      V = SQRT (EMU * (2.0D0 / R - 1.0D0 / SEMIMA))
      F = 2.0 * ATAN (SQRT ((1.0D0 + ECCEN) / (1.0D0 - ECCEN))
     *                      * TAN (E / 2.0D0))
      PHI = ASIN (SQRT ((SEMIMA ** 2 * (1.0D0 - ECCEN ** 2)
     *                   / (R * (2.0D0 * SEMIMA - R)))))
C
C     PHI is ambiguous here but E is not and cos(PHI) must have the
C     same sign as sin(E).
C
      IF (E .GT. PI) THEN
         PHI = PI - PHI
      END IF
C
      POS(1) = R * (COS (RAANOD) * COS (APERIG + F)
     *              - SIN (RAANOD) * SIN (APERIG + F) * COS (INCLIN))
      POS(2) = R * (SIN (RAANOD) * COS (APERIG + F)
     *              + COS (RAANOD) * SIN (APERIG + F) * COS (INCLIN))
      POS(3) = R * SIN (APERIG + F) * SIN (INCLIN)
C
      VEL(1) = V * (COS (RAANOD) * COS (APERIG + F + PHI)
     *              - SIN (RAANOD) * SIN (APERIG + F + PHI )
     *                * COS (INCLIN))
      VEL(2) = V * (SIN (RAANOD) * COS (APERIG + F + PHI)
     *              + COS (RAANOD) * SIN (APERIG + F + PHI)
     *                * COS (INCLIN))
      VEL(3) = V * SIN (APERIG + F + PHI) * SIN (INCLIN)
C
      END

LOCAL INCLUDE 'DIFUV.INC'
C                                       Local include for DIFUV
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAME2(3), XCLAS2(2),
     *   XNAMOU(3), XCLAOU(2), XOPTYP(1), XOUTPR(12)
      REAL      XSIN, XDISIN, XS2, XDISK2, XSOUT, XDISO, SOLINT,
     *   DOOUTP, DOPRIN, DOCRT, XCENT, BUFF1(UVBFSS), BUFF2(UVBFSS),
     *   BUFFO(UVBFSS), DIFPIX
      INTEGER   SEQIN, SEQ2, SEQOUT, DISKIN, DISK2, DISKO, JBUFSZ,
     *   ILOCWT, CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO,
     *   INCIFO, LRECI, LRECO, NRPRMI, NRPRMO, CAT2(256), NVS2, NRPRM2,
     *   LREC2, NVIS2, ILOCW1, ILOCW2, JLOCA1, JLOCA2, JLOCT, JLOCB,
     *   OLDCNO, NEWCNO
      LOGICAL   ISCOMP, DOOUT, DOPRT
      CHARACTER NAMEIN*12, CLAIN*6, NAME2*12, CLAS2*6, OPTYPE*4,
     *   NAMOUT*12, CLAOUT*6, OUTPRT*48
      DOUBLE PRECISION UVSCAL
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAME2, XCLAS2,
     *   XS2, XDISK2, XNAMOU, XCLAOU, XSOUT, XDISO, SOLINT, XOPTYP,
     *   DOOUTP, DOPRIN, DOCRT, XOUTPR, XCENT
      COMMON /DIFUVP/ UVSCAL, SEQIN, SEQ2, SEQOUT, DISKIN, DISK2, DISKO,
     *   ILOCWT, INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO,LRECI,
     *   LRECO, NRPRMI, NRPRMO, ISCOMP, NVS2, NRPRM2, LREC2,NVIS2,
     *   ILOCW1, ILOCW2, DIFPIX, JLOCA1, JLOCA2, JLOCT, JLOCB, OLDCNO,
     *   NEWCNO, DOOUT, DOPRT
      COMMON /CHARPM/ NAMEIN, CLAIN, NAME2, CLAS2, NAMOUT, CLAOUT,
     *   OPTYPE, OUTPRT
      COMMON /BUFRS/ CATOLD, CAT2, BUFF1, BUFF2, BUFFO, JBUFSZ
C                                       End local include for DIFUV
LOCAL END
      PROGRAM DIFUV
C-----------------------------------------------------------------------
C! Differences two matching uv data sets
C# Utility UV Singledish modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1996-1997, 1999-2000, 2008-2009, 2014-2015, 2021-2022,
C;  Copyright (C) 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DIFUV differences two data sets which must match very closely.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of 1st input UV data.
C      INCLASS        CLAIN         Class of 1st input UV data.
C      INSEQ          SEQIN         Seq. of 1st input UV data.
C      INDISK         DISKIN        Disk number of 1st input VU data.
C      IN2NAME        NAME2         Name of 2nd input file.
C      IN2CLASS       CLAS2         Class of 2nd input file.
C      IN2SEQ         SEQ2          Seq. no. of 2nd input file.
C      IN2DISK        DISK2         Vol. no. of 2nd input file.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is 1st input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      DOPRINT        DOPRIN        > 0 stats not uv output
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'DIFUV.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'DIFUV '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL DIFUIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL DIFUDO (IRET)
      IF (IRET.NE.0) GO TO 990
      IF (DOOUT) CALL DIFUHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE DIFUIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   DIFUIN gets input parameters for DIFUV and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER  STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX
      LOGICAL   T
      INCLUDE 'DIFUV.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK  /'      '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 39
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
      IF ((DOPRIN.GT.0.0) .AND. (DOCRT.GT.0.0)) RQUICK = .FALSE.
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAME2, NAME2)
      CALL H2CHR (6, 1, XCLAS2, CLAS2)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (48, 1, XOUTPR, OUTPRT)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      IF ((OPTYPE.NE.'DIV') .AND. (OPTYPE.NE.'DDIV')) OPTYPE = 'SUB'
      DOOUT = (DOPRIN.LE.0.0) .OR. (DOOUTP.GT.0.0)
      DOPRT = (DOPRIN.GT.0.0)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      SEQ2 = IROUND (XS2)
      DISKIN = IROUND (XDISIN)
      DISK2 = IROUND (XDISK2)
      DISKO = IROUND (XDISO)
      IF (SOLINT.LE.0.0) SOLINT = 1.0/6000.0
      SOLINT = SOLINT / (24. * 60.)
C                                       Open 2nd file
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISK2, OLDCNO, NAME2, CLAS2, SEQ2, PTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAME2, CLAS2, SEQ2, DISK2,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISK2, OLDCNO, CATBLK, 'READ', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK2
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CAT2)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      CALL UVPGET (IERR)
      NVS2 = (LREC - NRPARM) / CATBLK(KINAX)
      NRPRM2 = NRPARM
      LREC2 = LREC
      NVIS2 = NVIS
      JLOCA1 = ILOCA1
      JLOCA2 = ILOCA2
      JLOCT = ILOCT
      JLOCB = ILOCB
C                                       Find weight and scale.
      IF (ISCOMP) THEN
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCW2,
     *      IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Compressed data?
      IF (ISCOMP.NEQV.(CATBLK(KINAX).EQ.1)) THEN
         MSGTXT = 'BOTH FILES MUST BE COMPRESSED OR NOT COMPRESSED'
         JERR = 10
         GO TO 990
         END IF
C                                       Check input file compatibility
      IF (NVS2.NE.((LREC-NRPARM)/CATBLK(KINAX))) THEN
         JERR = 4
         MSGTXT = 'INPUT FILES ARE INCOMPATIBLE'
         GO TO 990
         END IF
C                                       Find weight and scale.
      IF (ISCOMP) THEN
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       more tests
      IF ((NVIS.NE.NVIS2) .OR. (ILOCWT.NE.ILOCW2) .OR.
     *   (NRPRM2.NE.NRPARM)) THEN
         MSGTXT = '*** WARNING: UV FILES DO NOT EXACTLY MATCH ***'
         CALL MSGWRT (6)
         MSGTXT = '*** THIS OPERATION MAY NOT BE FUNCTIONAL   ***'
         CALL MSGWRT (6)
         END IF
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
      IF (JLOCF.LT.0) XCENT = -1.0
      IF (XCENT.LE.0.0) THEN
         UVSCAL = 1.0D0
         DIFPIX = 0.0
      ELSE
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
         UVSCAL = CATD(KDCRV+JLOCF) / FREQ
         END IF
C                                       Put new values in CATBLK.
      IF (DOOUT) THEN
         CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT,
     *      SEQOUT)
         CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
         CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
         NEWCNO = 1
         FRW(NCFILE+1) = 3
         JERR = 4
         CALL UVCREA (DISKO, NEWCNO, BUFF1, IERR)
         IF (IERR.NE.0) THEN
            IF (IERR.NE.2) THEN
               WRITE (MSGTXT,1050) IERR
               GO TO 990
               END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
            IF ((NEWCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
               WRITE (MSGTXT,1060)
               GO TO 990
               END IF
C                                       Recover existing CATBLK
            FRW(NCFILE+1) = 2
            CALL CATIO ('READ', DISKO, NEWCNO, CATBLK, 'WRIT', BUFF1,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1065) IERR
               CALL MSGWRT (6)
               END IF
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKO
         FCNO(NCFILE) = NEWCNO
         FRW(NCFILE) = FRW(NCFILE) - 1
C                                       Save output file info
         CALL UVPGET (JERR)
         IF (JERR.NE.0) GO TO 999
         INCX = CATBLK(KINAX)
         LRECO = LREC
         NRPRMO = NRPARM
         INCSO = INCS / INCX
         INCFO = INCF / INCX
         INCIFO = INCIF / INCX
         END IF
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy keywords
      IF (DOOUT) CALL KEYCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DIFUIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('DIFUIN: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE DIFUDO (IRET)
C-----------------------------------------------------------------------
C   DIFUDO sends uv data one point at a time to the difference routine.
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48, IFILE*48
      INTEGER   INIO, IPTR1, IPTRO, LUN1, LUN2, LUNO, IND1, IND2, INDO,
     *   ILENBU, KBIND, NIOUT, NIOLIM, BIND1, I, IA1, IA2, INCX, BO, VO,
     *   NUMVIS, XCOUNT, NCORI, NCORO, NCOPY, BIND2, IPTR2, JA1, JA2,
     *   MVIS, RNXRET
      LOGICAL   T, F
      INCLUDE 'DIFUV.INC'
      REAL      BASEN, CBUFF(UVBFSS), DBUFF(UVBFSS), RESULT(UVBFSS)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2, LUNO /16, 17, 18/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
      IF (ISCOMP) INCX = 3
      MVIS = MIN (NVIS, NVIS2)
C                                       Number of visibilities in input
C                                       and output files.
      NCORI = (LRECI - NRPRMI) / CATOLD(KINAX)
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISK2, FCNO(1), 1, IFILE, IRET)
      CALL ZOPEN (LUN2, IND2, DISK2, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN 2nd UV file'
         GO TO 990
         END IF
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUN1, IND1, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN 1st UV file'
         GO TO 990
         END IF
C                                       Open vis file for write
      IF (DOOUT) THEN
         CALL ZPHFIL ('UV', DISKO, NEWCNO, 1, OFILE, IRET)
         CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN output file'
            GO TO 990
            END IF
C                                       Init vis file for write
         ILENBU = 0
         CALL UVINIT ('WRIT', LUNO, INDO, MVIS, VO, LRECO, ILENBU,
     *      JBUFSZ, BUFFO, BO, KBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT output file'
            GO TO 990
            END IF
         IPTRO = KBIND
         NIOUT = 0
         NIOLIM = ILENBU
         END IF
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUN2, IND2, MVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF2, BO, BIND2, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT 2nd input file'
         GO TO 990
         END IF
      ILENBU = 0
      CALL UVINIT ('READ', LUN1, IND1, MVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, BIND1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT 1st input file'
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       make an index table
      IF (DOOUT) THEN
         CALL RNXGET (DISKIN, OLDCNO, CATOLD)
         CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
         END IF
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUN2, IND2, BUFF2, INIO, BIND2, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ 2nd input file'
            GO TO 990
            END IF
         IPTR2 = BIND2
         CALL UVDISK ('READ', LUN1, IND1, BUFF1, INIO, BIND1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ 1st input file'
            GO TO 990
            END IF
         IPTR1 = BIND1
C                                       Out of data?
         IF (INIO.LE.0) GO TO 200
C                                       Loop over buffer
         DO 190 I = 1,INIO
            IF (ILOCB.GE.0) THEN
               BASEN = BUFF1(IPTR1+ILOCB)
               IA1 = BASEN / 256. + 0.1
               IA2 = BASEN - IA1*256. + 0.1
            ELSE
               IA1 = BUFF1(IPTR1+ILOCA1) + 0.1
               IA2 = BUFF1(IPTR1+ILOCA2) + 0.1
               END IF
            IF (JLOCB.GE.0) THEN
               BASEN = BUFF2(IPTR2+JLOCB)
               JA1 = BASEN / 256. + 0.1
               JA2 = BASEN - JA1*256. + 0.1
            ELSE
               JA1 = BUFF2(IPTR2+JLOCA1) + 0.1
               JA2 = BUFF2(IPTR2+JLOCA2) + 0.1
               END IF
            NUMVIS = NUMVIS + 1
            BUFF1(IPTR1+ILOCU) = BUFF1(IPTR1+ILOCU) * UVSCAL
            BUFF1(IPTR1+ILOCV) = BUFF1(IPTR1+ILOCV) * UVSCAL
            BUFF1(IPTR1+ILOCW) = BUFF1(IPTR1+ILOCW) * UVSCAL
C                                      Call difference routine.
            IF ((ABS(BUFF1(IPTR1+ILOCT)-BUFF2(IPTR2+JLOCT)).LE.SOLINT)
     *         .AND. (IA1.EQ.JA1) .AND. (IA2.EQ.JA2)) THEN
C                                       Compressed data.
               IF (ISCOMP) THEN
                  CALL ZUVXPN (NCORI, BUFF1(IPTR1+NRPRMI),
     *               BUFF1(IPTR1+ILOCWT), CBUFF)
                  CALL ZUVXPN (NCORI, BUFF2(IPTR2+NRPRM2),
     *               BUFF2(IPTR2+ILOCW2), DBUFF)
                  CALL DIFUVF (NUMVIS, CBUFF, DBUFF, INCX, RESULT, IRET)
C                                       Un compressed data
               ELSE
                  CALL DIFUVF (NUMVIS, BUFF1(IPTR1+NRPRMI),
     *               BUFF2(IPTR2+NRPRMI), INCX, RESULT, IRET)
                  END IF
C                                       Error (fatal)
               IF (IRET.GT.0) THEN
                  WRITE (MSGTXT,1120) IRET
                  GO TO 990
C                                       Copy to output.
               ELSE IF ((IRET.EQ.0) .AND. (DOOUT)) THEN
                  XCOUNT = XCOUNT + 1.0D0
                  CALL RCOPY (NRPRMO, BUFF1(IPTR1), BUFFO(IPTRO))
C                                       update NX table
                  CALL RNXUPD (BUFF1(IPTR1), RNXRET)
C                                       Compressed
                  IF (ISCOMP) THEN
                     CALL ZUVPAK (NCORO, RESULT, BUFFO(IPTRO+ILOCWT),
     *                  BUFFO(IPTRO+NRPRMO))
                  ELSE
                     CALL RCOPY (NCOPY, RESULT, BUFFO(IPTRO+NRPRMO))
                     END IF
                  IPTRO = IPTRO + LRECO
                  NIOUT = NIOUT + 1
                  END IF
               END IF
C                                       OK, but no output please
            IPTR1 = IPTR1 + LRECI
            IPTR2 = IPTR2 + LRECI
C                                       Write vis record.
            IF ((DOOUT) .AND. (NIOUT.GE.NIOLIM)) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFFO, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRIT output file'
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
C                                       Read next buffer.
         GO TO 100
C                                       Final call to DIFUVF.
 200  NUMVIS = -1
      CALL DIFUVF (NUMVIS, BUFF1, BUFF2, INCX, RESULT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
         END IF
C                                       Finish write
      IF (DOOUT) THEN
         NIOUT = - NIOUT
         CALL UVDISK ('FLSH', LUNO, INDO, BUFFO, NIOUT, KBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'FLSH output file'
            GO TO 990
            END IF
C                                       Compress output file.
         NVIS = XCOUNT
         CALL UCMPRS (NVIS, DISKO, NEWCNO, LUNO, CATBLK, IRET)
         CALL ZCLOSE (LUNO, INDO, IRET)
         CALL RNXCLS (RNXRET)
         IF (RNXRET.NE.0) THEN
            MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
            CALL MSGWRT (7)
            END IF
         END IF
C                                       Close files
      CALL ZCLOSE (LUN1, IND1, IRET)
      CALL ZCLOSE (LUN2, IND2, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DIFUDO: ERROR',I3,' ON ',A)
 1120 FORMAT ('DIFUDO: DIFUVF ERROR',I3)
      END
      SUBROUTINE DIFUHI
C-----------------------------------------------------------------------
C   DIFUHI copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP*2, HILINE*72
      INTEGER   LUN1, LUN2, IERR, NONOT
      LOGICAL   T
      INCLUDE 'DIFUV.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T  /.TRUE./
      DATA NONOT, NOTTYP /0, '  '/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFFO, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFFO,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCO2 (TSKNAM, NAME2, CLAS2, SEQ2, DISK2, LUN2, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFFO,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
C                                       optype
      WRITE (HILINE,1010) TSKNAM, OPTYPE
      CALL HIADD (LUN2, HILINE, BUFFO, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, BUFFO, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO,
     *   FCNO(NCFILE), FCNO(NCFILE-1), CATBLK, BUFF1, BUFFO, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1200)
         CALL MSGWRT (6)
         END IF
      CALL CENTFQ (DISKO, FCNO(NCFILE-1), DIFPIX, BUFF1, BUFFO, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'DIFUHI: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST',
     *   BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DIFUHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,'OPTYPE = ''',A,'''  / operation done')
 1200 FORMAT ('DIFUHI: ERROR COPYING TABLES')
      END
      SUBROUTINE DIFUVF (NUMVIS, VIS1, VIS2, INCX, RESULT, IRET)
C-----------------------------------------------------------------------
C   Differences VIS1 - VIS2.
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      VIS1    R(INCX,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                   NOTE: INCX may be any value .GE. 2
C      VIS2    R(INCX,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                   NOTE: INCX may be any value .GE. 2
C   Inputs from COMMON:
C      RA         D       Right ascension (1950) of phase center. (deg)
C      DEC        D       Declination (1950) of phase center. (deg)
C      FREQ       D       Frequency of observation (Hz)
C      NRPARM     I       # random parameters.
C      NCOR       I       # correlators
C      CATBLK     I(256)  Catalog header record. See Going Aips for
C                         details.
C      LRECI      I    Input file record length
C      NRPRMI     I    Input number of random parameters.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
c      LRECO      I    Output file record length
C      NRPRMO     I    Output number of random parameters.
C      INCSO      I    Output Stokes' increment in vis.
C      INCFO      I    Output frequency increment in vis.
C      INCIFO     I    Output IF increment in vis.
C   Output:
C      RESULT  R(INCX,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C   Output in COMMON:
C      CATBLK    I         Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, INCX, IRET
      REAL      VIS1(INCX,*), VIS2(INCX,*), RESULT(INCX,*)
C
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXO, INDEXI
      COMPLEX   CVIS1, CVIS2, CRES
      REAL      W1, W2
      INCLUDE 'DIFUV.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.GT.0) THEN
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
         DO 40 JIF = 1,NIF
            DO 30 JF = 1,NF
               DO 20 JS = 1,NS
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  IF (DOOUT) THEN
                     INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *                  (JS-1) * INCSO + 1
                  ELSE
                     INDEXO = INDEXI
                     END IF
                  W1 = VIS1(3,INDEXI)
                  W2 = VIS2(3,INDEXI)
                  IF (OPTYPE.EQ.'SUB') THEN
                     RESULT(1,INDEXO) = VIS1(1,INDEXI) - VIS2(1,INDEXI)
                     RESULT(2,INDEXO) = VIS1(2,INDEXI) - VIS2(2,INDEXI)
                     IF (W1*W2.NE.0.0) RESULT(3,INDEXO) =
     *                  ABS (W1 * W2) / (ABS(W1) + ABS(W2))
                  ELSE
                     CVIS1 = CMPLX (VIS1(1,INDEXI), VIS1(2,INDEXI))
                     CVIS2 = CMPLX (VIS2(1,INDEXI), VIS2(2,INDEXI))
                     CRES = CMPLX (0.0, 0.0)
                     IF (ABS(CVIS2).GT.0.0) CRES = CVIS1 / CVIS2
                     RESULT(1,INDEXO) = REAL (CRES)
                     IF (OPTYPE.EQ.'DDIV') RESULT(1,INDEXO) =
     *                  RESULT(1,INDEXO) - 1.0
                     RESULT(2,INDEXO) = AIMAG (CRES)
                     IF (W1*W2.NE.0.0) RESULT(3,INDEXO) =
     *                  (ABS(CVIS2)**4) * ABS (W1 * W2) /
     *                  ((ABS(CVIS1)**2) * ABS(W1) +
     *                  (ABS(CVIS2)**2) * ABS(W2))
                     END IF
                  IF ((W1.LT.0.) .OR. (W2.LT.0.)) RESULT(3,INDEXO) =
     *               -ABS (RESULT(3,INDEXO))
                  IF ((W1.EQ.0.) .OR. (W2.EQ.0.)) RESULT(3,INDEXO) = 0.0
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
C                                       last call - no vis
      ELSE
         END IF
C
      IF (DOPRT) CALL DIFCNT (NUMVIS, RESULT)
C
 999  RETURN
      END
      SUBROUTINE DIFCNT (NUMVIS, RESULT)
C-----------------------------------------------------------------------
C   DIFCNT sums statistics and then reports them
C   Inputs:
C      NUMVIS   I        Vis number: 1 -> init. count; > 1 count; < 0
C                        report
C      RESULT   R(3,*)   Current data
C-----------------------------------------------------------------------
      INTEGER   NUMVIS
      REAL      RESULT(3,*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   JIF, JF, JS, JT, NIF, NF, NS, INDEXI, IRET, LUNP, FINDP,
     *   NACROS, BUFFER(256), PAGE, IPCNT
      DOUBLE PRECISION  SUMS(3,5,MAXCIF), AV(3), RM(3), MX(3), MN(3)
      CHARACTER TITL1*132, TITL2*132, LINE*132, SCRTCH*132
      INCLUDE 'DIFUV.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      SAVE NIF, NF, NS, SUMS
C----------------------------------------------------------------------
C                                       init
      IF (NUMVIS.EQ.1) THEN
         JS = 15 * MAXCIF
         CALL DFILL (JS, 0.0D0, SUMS)
         DO 10 JT = 1,3
            DO 9 JS = 1,MAXCIF
               SUMS(JT,5,JS) = 1.D10
 9             CONTINUE
 10         CONTINUE
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
         END IF
C                                       sum
      IF (NUMVIS.GT.0) THEN
         DO 50 JIF = 1,NIF
            DO 40 JF = 1,NF
               DO 30 JS = 1,NS
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  IF (RESULT(3,INDEXI).GT.0.0) THEN
                     DO 20 JT = 1,3
                        SUMS(JT,1,INDEXI) = SUMS(JT,1,INDEXI) +
     *                     RESULT(JT,INDEXI)
                        SUMS(JT,2,INDEXI) = SUMS(JT,2,INDEXI) +
     *                     RESULT(JT,INDEXI)**2
                        SUMS(JT,3,INDEXI) = SUMS(JT,3,INDEXI) + 1.D0
                        SUMS(JT,4,INDEXI) = MAX (SUMS(JT,4,INDEXI),
     *                     ABS (RESULT(JT,INDEXI)))
                        SUMS(JT,5,INDEXI) = MIN (SUMS(JT,5,INDEXI),
     *                     ABS (RESULT(JT,INDEXI)))
 20                     CONTINUE
                     END IF
 30               CONTINUE
 40            CONTINUE
 50         CONTINUE
C                                       report
      ELSE
         CALL LPOPEN (OUTPRT, DOCRT, LUNP, FINDP, NACROS, BUFFER, IRET)
         IF (IRET.NE.0) THEN
            FINDP = 0
            WRITE (MSGTXT,1000) IRET, 'OPENING PRINT OUTPUT'
            GO TO 980
            END IF
         NACROS = 132
         TITL1 = ' '
         TITL1(22:) = 'Average'
         TITL1(52:) = 'RMS'
         TITL1(82:) = 'Maximum'
         TITL1(112:) = 'Minimum'
         WRITE (TITL2,1050)
         PAGE = 0
         IPCNT = 980
         DO 90 JS = 1,NS
            LINE = ' '
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 970
            DO 80 JIF = 1,NIF
               DO 70 JF = 1,NF
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  DO 60 JT = 1,3
                     AV(JT) = 0.0D0
                     RM(JT) = 0.0D0
                     IF (SUMS(JT,3,INDEXI).GE.1.0D0) THEN
                        AV(JT) = SUMS(JT,1,INDEXI) / SUMS(JT,3,INDEXI)
                        RM(JT) = SUMS(JT,2,INDEXI) / SUMS(JT,3,INDEXI) -
     *                     AV(JT)*AV(JT)
                        RM(JT) = SQRT (MAX (0.0D0, RM(JT)))
                     END IF
                     MX(JT) = SUMS(JT,4,INDEXI)
                     MN(JT) = SUMS(JT,5,INDEXI)
 60                  CONTINUE
                  WRITE (LINE,1060) JS, JIF, JF, AV, RM, MX, MN
                  CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *               LINE, IPCNT, PAGE, SCRTCH, IRET)
                  IF (IRET.NE.0) GO TO 970
 70               CONTINUE
 80            CONTINUE
            LINE = ' '
            IPCNT = 1001
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 970
            IPCNT = 999
 90         CONTINUE
         END IF
      GO TO 990
C
 970  IF (IRET.LT.0) THEN
         MSGTXT = 'Stopping print at your request'
      ELSE
         WRITE (MSGTXT,1000) IRET, 'TRYING TO PRINT'
         END IF
 980  CALL MSGWRT (8)
C
 990  IF (FINDP.GT.0) CALL LPCLOS (LUNP, FINDP, IPCNT, JT)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DIFCNT ERROR',I4,' ON ',A)
 1050 FORMAT ('P IF  Chan ',4('Real part',1X,'Imag part',2X,'Weight',
     *   3X))
 1060 FORMAT (I1,I3,I6,12(1PE10.2))
      END

      SUBROUTINE AU5F (BRANCH)
C-----------------------------------------------------------------------
C! verbs to delete boxes
C# POPS-appl TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2006, 2008, 2012, 2021, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AU5C performs additional TV image formation functions:
C   BRANCH = 1   DELBOX    delete boxes interactively
C          = 2   DFILEBOX  delete boxes from a box file
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      INCLUDE 'INCS:PCLN.INC'
      CHARACTER LINTYP*2, PRGNAM*6, CDUM*1, BOXFIL*48, TXLINE*132,
     *   ATIME*8, ADATE*12, SCNAME*256, CLASS*6, ULOG*24, UNAME*48,
     *   TMLINE*132
      LOGICAL   UNIQUE, SAVEBU
      INTEGER   J, POTERR, IERR, IPLAN, IPL, I, IROUND, IBUF(1280), NBO,
     *   IGR(2), IDUM, INBO, IFIELD, TXLUN, TXIND, TXLUN2, TXIND2,
     *   IBX(4), ITIME(3),IDATE(3), MSGSAV, KBP, JTRIM, IOFF, COLP
      REAL      BB(7,MXNBOX), TT(7,MXNBOX), BXX(100), BYY(100), RDUM(2),
     *   RIBUF(4096), BOX(4,MXCLBX)
      DOUBLE PRECISION X
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PUVD.INC'
      COMMON /AIPSCR/ RIBUF
      EQUIVALENCE (BXX, BB),  (BYY, TT)
      EQUIVALENCE (IBUF, RIBUF)
      DATA PRGNAM /'AU5C  '/
C-----------------------------------------------------------------------
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.2)) GO TO 999
C                                        Open the TV
      POTERR = 101
      CALL TVOPEN (IBUF, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Get a plane and image
      LINTYP = 'MA'
      CALL TVFIND (NGRAY, LINTYP, IPLAN, UNIQUE, CATBLK, IBUF, IERR)
      IF (IERR.NE.0) GO TO 975
      CALL ADVERB ('GRCHAN',  'I', 1, 0, IGR(1), RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IGR(1) = MOD (IGR(1), 10)
      CALL ADVERB ('GR2CHAN',  'I', 1, 0, IGR(2), RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IF (IGR(1).EQ.0) IGR(1) = 3
      IF (IGR(2).EQ.0) IGR(2) = MIN (7, IGR(1) + 4)
C                                        Branch to OP
      GO TO (100, 200), BRANCH
C-----------------------------------------------------------------------
C                                       DELBOX
C                                       reset NBOXES boxes with graphics
C-----------------------------------------------------------------------
 100  CALL ADVERB ('NBOXES',  'I', 1, 0, INBO, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      NBO = INBO
      IF (NBO.LE.0) THEN
         MSGTXT = 'DELBOX MUST START WITH SOME BOXES!'
         CALL MSGWRT (8)
         POTERR = 101
         GO TO 975
         END IF
C                                       pick up old Boxes & convert
      CALL ADVERB ('CLBOX', 'R', 200, 0, IDUM, BOX, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      DO 110 I = 1,NBO
         BB(1,I) = BOX(1,I)
         BB(2,I) = BOX(2,I)
         TT(1,I) = BOX(3,I)
         TT(2,I) = BOX(4,I)
 110     CONTINUE
C                                       init image catalog
      IPL = NGRAY + IGR(1)
      CALL YCINIT (IPL, IBUF)
      IPL = NGRAY + IGR(2)
      CALL YCINIT (IPL, IBUF)
      CALL GRBOXD (IGR, NBO, BB, TT, IBUF, IERR)
      IF (IERR.NE.0) THEN
         POTERR = 49
         GO TO 975
         END IF
      IF (NBO.NE.INBO) THEN
         WRITE (MSGTXT,1100) INBO, NBO
         CALL MSGWRT (6)
         CALL ADVRBS ('NBOXES',  'I', 1, 0, NBO, RDUM, CDUM)
         END IF
      CALL RFILL (200, 0.0, BOX)
      DO 120 I = 1,NBO
         BOX(1,I) = BB(1,I)
         BOX(2,I) = BB(2,I)
         BOX(3,I) = TT(1,I)
         BOX(4,I) = TT(2,I)
         WRITE (MSGTXT,1101) I, (BOX(J,I), J = 1,4)
         CALL MSGWRT (2)
 120     CONTINUE
      CALL ADVRBS ('CLBOX', 'R', 200, 0, IDUM, BOX, CDUM)
      POTERR = 0
      GO TO 975
C-----------------------------------------------------------------------
C                                       DFILEBOX
C                                       delete boxes with graphics
C                                       write to text file
C-----------------------------------------------------------------------
C                                       open file in FILEBOX
 200  CALL ADVERB ('NFIELD', 'I', 1, 0, IFIELD, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IF ((IFIELD.LT.1) .OR. (IFIELD.GT.MAXFLD)) THEN
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), CLASS)
         IF ((CLASS(4:4).LT.'0') .OR. (CLASS(4:4).GT.'9')) THEN
            IF (CLASS(5:6).EQ.'  ') THEN
               IFIELD = 1
            ELSE
               CALL ZREHEX (2, CLASS(5:6), IFIELD)
               IFIELD = IFIELD + 1
               END IF
         ELSE IF ((CLASS(5:5).LT.'0') .OR. (CLASS(5:5).GT.'9') .OR.
     *      (CLASS(6:6).LT.'0') .OR. (CLASS(6:6).GT.'9')) THEN
            IFIELD = 0
         ELSE
            READ (CLASS(4:6),1200) IFIELD
            END IF
         IF ((IFIELD.GE.1) .AND. (IFIELD.LE.MAXFLD)) THEN
            WRITE (MSGTXT,1201) CLASS, IFIELD
         ELSE
            IFIELD = 1
            MSGTXT = 'Class no help: Field 1 assumed'
            END IF
         CALL MSGWRT (2)
         END IF
      CALL ADVERB ('BOXFILE', 'C', 1, 48, IDUM, RDUM, BOXFIL)
      IF (ERRNUM.NE.0) GO TO 975
      TXLUN = 3
      TXLUN2 = 11
      NBO = 0
      IOFF = 0
      SAVEBU = .FALSE.
      SCNAME = ' '
C                                       Read in pre-existing
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL ZTXOPN ('QRED', TXLUN, TXIND, BOXFIL, .TRUE., IERR)
      MSGSUP = MSGSAV
      IF (IERR.EQ.0) THEN
C                                       do a backup file
         COLP = INDEX (BOXFIL, ':')
         IF (COLP.LE.1) THEN
            MSGTXT = 'WARNING: NO LOGICAL: BACKUP FILE IN $FITS'
            CALL MSGWRT (6)
            CALL ZFULLN (' ', 'FITS', 'FILEBOX', SCNAME, IERR)
         ELSE
            ULOG = BOXFIL(:COLP-1)
            UNAME = BOXFIL(COLP+1:)
            CALL ZFULLN (' ', ULOG, UNAME, SCNAME, IERR)
            END IF
         POTERR = 55
         IF (IERR.NE.0) GO TO 970
         CALL ZTXOPN ('QWRT', TXLUN2, TXIND2, SCNAME, .FALSE., IERR)
         IF (IERR.NE.0) GO TO 970
         DO 210 I = 1,100000
            CALL ZTXIO ('READ', TXLUN, TXIND, TXLINE, IERR)
            IF (IERR.EQ.2) GO TO 215
            IF (IERR.NE.0) GO TO 965
            J = JTRIM (TXLINE)
            J = MAX (1, J)
            CALL ZTXIO ('WRIT', TXLUN2, TXIND2, TXLINE(:J), IERR)
            IF (IERR.NE.0) GO TO 965
 210        CONTINUE
 215     SAVEBU = .TRUE.
C                                       close both
         CALL ZTXCLS (TXLUN, TXIND, IERR)
         CALL ZTXCLS (TXLUN2, TXIND2, IERR)
         POTERR = 55
C                                       this is less dangerous!
         CALL ZTXZAP (TXLUN, BOXFIL, IERR)
         CALL ZTXOPN ('WRIT', TXLUN, TXIND, BOXFIL, .FALSE., IERR)
         IF (IERR.NE.0) GO TO 971
         CALL ZTXOPN ('QRED', TXLUN2, TXIND2, SCNAME, .FALSE., IERR)
         IF (IERR.NE.0) GO TO 970
         POTERR = 50
C                                       read back backup to new orig.
         DO 230 I = 1,100000
            CALL ZTXIO ('READ', TXLUN2, TXIND2, TXLINE, IERR)
            IF (IERR.EQ.2) GO TO 235
            IF (IERR.NE.0) GO TO 965
            CALL CHTRIM (TXLINE, 132, TMLINE, J)
            KBP = 1
            IF (TMLINE(:1).EQ.' ') GO TO 220
            IF (TMLINE(:1).LT.'0') GO TO 220
            IF (TMLINE(:1).GT.'9') GO TO 220
            CALL GETNUM (TMLINE, 132, KBP, X)
            IF ((ERRNUM.NE.0) .OR. (X.EQ.DBLANK)) GO TO 965
            RDUM = X
            J = IROUND (RDUM)
            IF (J.NE.IFIELD) GO TO 220
C                                       window to read in
            CALL GETNUM (TMLINE, 132, KBP, X)
            IF ((ERRNUM.NE.0) .OR. (X.EQ.DBLANK)) GO TO 965
            RDUM = X
            IBX(1) = IROUND (RDUM)
            CALL GETNUM (TMLINE, 132, KBP, X)
            IF ((ERRNUM.NE.0) .OR. (X.EQ.DBLANK)) GO TO 965
            RDUM = X
            IBX(2) = IROUND (RDUM)
            CALL GETNUM (TMLINE, 132, KBP, X)
            IF ((ERRNUM.NE.0) .OR. (X.EQ.DBLANK)) GO TO 965
            RDUM = X
            IBX(3) = IROUND (RDUM)
            CALL GETNUM (TMLINE, 132, KBP, X)
            IF ((ERRNUM.NE.0) .OR. (X.EQ.DBLANK)) GO TO 965
            RDUM = X
            IBX(4) = IROUND (RDUM)
C                                       keep this
            NBO = NBO + 1
            BB(1,NBO) = IBX(1)
            BB(2,NBO) = IBX(2)
            TT(1,NBO) = IBX(3)
            TT(2,NBO) = IBX(4)
            GO TO 230
C                                       otherwise write to scratch
 220        J = JTRIM (TXLINE)
            J = MAX (1, J)
            CALL ZTXIO ('WRIT', TXLUN, TXIND, TXLINE(:J), IERR)
            IF (IERR.NE.0) GO TO 965
 230        CONTINUE
 235     CALL ZTXCLS (TXLUN2, TXIND2, IERR)
C                                       create a new BOXFILE
      ELSE
         POTERR = 55
         CALL ZTXOPN ('WRIT', TXLUN, TXIND, BOXFIL, .FALSE., IERR)
         IF (IERR.NE.0) GO TO 975
         END IF
C                                       add the time
      CALL ZTIME (ITIME)
      CALL ZDATE (IDATE)
      CALL TIMDAT (ITIME, IDATE, ATIME, ADATE)
      TXLINE = '#  FILEBOX: ' // ADATE // ATIME
      J = JTRIM (TXLINE)
      POTERR = 50
      CALL ZTXIO ('WRIT', TXLUN, TXIND, TXLINE(:J), IERR)
      IF (IERR.NE.0) GO TO 970
      POTERR = 31
      IPL = NGRAY + IGR(1)
      CALL YCINIT (IPL, IBUF)
      IPL = NGRAY + IGR(2)
      CALL YCINIT (IPL, IBUF)
      INBO = NBO
      IF (INBO.LE.0) THEN
         MSGTXT = 'NO BOXES FOUND - DOING NOTHING'
         CALL MSGWRT (7)
      ELSE
         WRITE (MSGTXT,1240) NBO
         CALL MSGWRT (3)
         CALL GRBOXD (IGR, NBO, BB, TT, IBUF, IERR)
         IF (IERR.NE.0) THEN
            POTERR = 49
            MSGTXT = 'TRYING TO SAVE BOXES ANYWAY - YOU MAY HAVE TO '
     *         // 'EDIT THE FILE'
            CALL MSGWRT (6)
            END IF
         IF (NBO.NE.INBO) THEN
            WRITE (MSGTXT,1100) INBO, NBO
            CALL MSGWRT (6)
            END IF
         POTERR = 50
         DO 250 I = 1,NBO
C                                       round
            IF (BB(1,I).LT.-0.5) THEN
               IBX(1) = IROUND (BB(1,I))
               IBX(2) = IROUND (BB(2,I))
               IBX(3) = IROUND (TT(1,I))
               IBX(4) = IROUND (TT(2,I))
            ELSE
               IBX(1) = BB(1,I) + 0.01
               IBX(2) = BB(2,I) + 0.01
               IBX(3) = TT(1,I) + 0.99
               IBX(4) = TT(2,I) + 0.99
               END IF
            WRITE (MSGTXT,1245) IFIELD, I, IBX
            CALL MSGWRT (2)
            WRITE (TXLINE,1246) IFIELD, IBX
            CALL CHTRIM (TXLINE, 132, TXLINE, J)
            CALL ZTXIO ('WRIT', TXLUN, TXIND, TXLINE(:J), IERR)
            IF (IERR.NE.0) GO TO 970
 250        CONTINUE
         END IF
      SAVEBU = .FALSE.
      POTERR = 0
      GO TO 970
C-----------------------------------------------------------------------
C                                        Close downs
 965  CALL ZTXCLS (TXLUN2, TXIND2, IERR)
 970  CALL ZTXCLS (TXLUN, TXIND, IERR)
 971  IF (SCNAME.NE.' ') THEN
         IF (SAVEBU) THEN
            MSGTXT = 'BOXFILE backup saved in file:'
            CALL MSGWRT (8)
            MSGTXT = SCNAME
            CALL MSGWRT (8)
         ELSE
            CALL ZTXZAP (TXLUN2, SCNAME, IERR)
            END IF
         END IF
 975  CALL TVCLOS (IBUF, IERR)
C
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.EQ.0) GO TO 999
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('NBOXES reset from',I4,' to',I4)
 1101 FORMAT ('BOX(',I3,') = ',4F8.2)
 1200 FORMAT (I3)
 1201 FORMAT ('Class ',A,' implies field number',I3)
 1240 FORMAT (I4,' boxes to be reset - some may not be visible')
 1245 FORMAT ('FIELD',I3.2,' BOX(',I3.3,') = ',4I7.4)
 1246 FORMAT (I4,4I7)
      END

      SUBROUTINE ZFORMF (STR)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Returns a string which will cause a form feed (page eject) to occur
C   when printed from within a text file.  Used by PRTLIN.
C   In/out (Common LPINIT) :
C      LPEXST   L       In: if false, return a ' ' for the FF
C                       Out: true
C   Output:
C      STR      C*(*)   String filled with trailing blanks.
C   Generic version - for ASCII computers, returns a value of 12, base
C   10 (014, base 8) in the first character.  Used to avoid a form feed
C   for the first call, but this leads to appended print files not being
C   separated by real form feeds.  The AIPS F2PS filter will not produce
C   a blank page when the file begins with a form feed.
C-----------------------------------------------------------------------
      CHARACTER STR*(*)
C
      INTEGER   IFF
C     LOGICAL   LPEXST
C     COMMON /LPINIT/ LPEXST
      DATA IFF /12/
C-----------------------------------------------------------------------
C                                       blank fill
      STR = ' '
C                                       form feed
      STR(:1) = CHAR (IFF)
C
 999  RETURN
      END

LOCAL INCLUDE 'PLOTC.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
C
      CHARACTER NAMEIN*12, CLAIN*6, PRTASK*8, INEXT*2, OPCODE*4,
     *   PFILE*48, CPOL(4)*2, CHIF*8
      HOLLERITH XPRTSK(2), XNAMEI(3), XCLAIN(2), XSOUR(4,30), XSTOK(1),
     *   XEXT(1), XOPCOD(1)
      REAL   XSIN, XDISIN, XBCHAN, XECHAN, XNCHAV, XCHINC, XBIF, XEIF,
     *   DO3COL, XVERS, CROWDD, XREF, SOLINT, XTIME(8), XDOTV, XGRCH,
     *   XYRATO
      REAL      BUFF1(UVBFSS), XYSCL(3), XYOFF(3), RPARM(20), XYMIN(3),
     *   XYMAX(3), TRC(2), BLC(2), CHOUT(4), TSTR, TFIN
      INTEGER   SEQIN, DISKIN, LUNI, INDI, NCH, VER, JBUFSZ, CNOIN,
     *   NFRQ, GRCHN, TVCHN, TVCORN(4), CHINC, SBUFF(512), INVERS,
     *   NPARMS, NPOL, NNVIS, NCHAV, DOPLAN, BUFFER(2556), LUNPL, FINDPL
      LOGICAL   DOTV
      COMMON /INPARM/ XPRTSK, XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR,
     *   XSTOK, XBCHAN, XECHAN, XNCHAV, XCHINC, XBIF, XEIF, DO3COL,
     *   XEXT, XVERS, CROWDD, XOPCOD, XREF, SOLINT, XTIME, XDOTV,
     *   XGRCH, XYRATO
      COMMON /CHPARM/ NAMEIN, CLAIN, OPCODE, PFILE, PRTASK, CPOL, INEXT,
     *   CHIF
      COMMON /BUFRS/ BUFF1, SBUFF, RPARM, JBUFSZ, BUFFER
      COMMON /UVPCOM/ XYSCL, XYOFF, XYMIN, XYMAX, DOTV, SEQIN, DISKIN,
     *   LUNI, INDI, NCH, VER, CNOIN, NFRQ, TVCHN, GRCHN, TVCORN, CHINC,
     *   NPARMS, NPOL, NNVIS, NCHAV, DOPLAN, TRC, BLC, LUNPL, FINDPL,
     *   CHOUT, INVERS, TSTR, TFIN
LOCAL END
      PROGRAM PLOTC
C-----------------------------------------------------------------------
C! PLOTC plots colors with labels for a variety of tasks
C# EXT-appl Graphics Plot appl UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2018-2019, 2022, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PLOTC plots uv data . A 'PL' extension file is made which can
C   be displayed in the usual ways .
C   Inputs:
C     INNAME         NAMEIN        Name of input UV data.
C     INCLASS        CLAIN         Class of input UV data.
C     INSEQ          SEQIN         Seq. of input UV data.
C     INDISK         DISKIN        Disk number of input VU data.
C     BIF            BIF           IF number to start
C     EIF            EIF           Through IF number
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, PLNAME*48
      INTEGER   IRET, TVPLAN(2), NX, NY, NZ, NWORDS, IERR
      LONGINT   PTVPLN
      INCLUDE 'PLOTC.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA PRGM /'PLOTC '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL UVPIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       make plane memory: TV
      IF (DOPLAN.LE.2) THEN
         NX = GPHSCX + 1.01
         NY = GPHSCY + 1.01
C                                       plot file
      ELSE
         NX = TRC(1) - BLC(1) + 1.01
         NY = TRC(2) - BLC(2) + 1.01
         END IF
      NZ = 1
      IF (MOD(DOPLAN,2).EQ.0) NZ = 3
      NWORDS = (NX * NY * NZ - 1) / 1024 + 4
      CALL ZMEMRY ('GET ', 'PLPLAN', NWORDS, TVPLAN, PTVPLN, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 995
         END IF
      NWORDS = NX * NY * NZ
      CALL FILL (NWORDS, 0, TVPLAN(1+PTVPLN))
C                                       call routine for each task
      IF (PRTASK.EQ.'UVPLT') THEN
         CALL CUVPLT (NX, NY, NZ, TVPLAN(1+PTVPLN), IRET)
      ELSE IF ((PRTASK.EQ.'EDITA') .OR. (PRTASK.EQ.'EDITR') .OR.
     *   (PRTASK.EQ.'SNEDT')) THEN
         CALL CEDITA (NX, NY, NZ, TVPLAN(1+PTVPLN), IRET)
      ELSE IF ((PRTASK.EQ.'SNPLT') .OR. (PRTASK.EQ.'ELFIT') .OR.
     *   (PRTASK.EQ.'ELINT')) THEN
         CALL CSNPLT (NX, NY, NZ, TVPLAN(1+PTVPLN), IRET)
      ELSE IF (PRTASK.EQ.'VPLOT') THEN
         CALL CVPLOT (NX, NY, NZ, TVPLAN(1+PTVPLN), IRET)
      ELSE IF (PRTASK.EQ.'ANBPL') THEN
         CALL CANBPL (NX, NY, NZ, TVPLAN(1+PTVPLN), IRET)
      ELSE IF (PRTASK.EQ.'SNIFS') THEN
         CALL CSNIFS (NX, NY, NZ, TVPLAN(1+PTVPLN), IRET)
      ELSE IF ((PRTASK.EQ.'BPEDT') .OR. (PRTASK.EQ.'PCEDT')) THEN
         CALL CBPEDT (NX, NY, NZ, TVPLAN(1+PTVPLN), IRET)
         END IF
C                                       Clear catlg on error
      IF ((IRET.NE.0) .AND. (NCFILE.GE.1) .AND. (FRW(1).LE.0) .AND.
     *   (.NOT.DOTV)) THEN
         CALL ZPHFIL ('PL', FVOL(1), FCNO(1), VER, PLNAME, IERR)
         CALL ZDESTR (FVOL(1), PLNAME, IERR)
         CALL DELEXT ('PL', FVOL(1), FCNO(1), 'READ', CATBLK, SBUFF,
     *      VER, IERR)
         CALL ZCLOSE (LUNI, INDI, IERR)
         NCFILE = NCFILE - 1
         END IF
C                                       Close down
 995  CALL DIE (IRET, SBUFF)
C
 999  STOP
      END
      SUBROUTINE UVPIN (PRGM, IRET)
C-----------------------------------------------------------------------
C   UVPIN gets input parameters for PLOTC .
C   Inputs:
C      PRGM   C*6   Program name
C   Output:
C      IRET   I     Error code: 0 => ok, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
C
      CHARACTER UTYPE*2, STAT*4, POLS(13)*2
      INTEGER   IUSER, I, IERR, IROUND, LUNTB, LTYPE, IDEPTH(5), ITYPE,
     *   IPSIZE, J
      LOGICAL   T, F
      REAL      DX, DY, CATR(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'PLOTC.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DTVC.INC'
      EQUIVALENCE (CATD, CATR, CATBLK)
      DATA T, F /.TRUE., .FALSE./
      DATA LUNTB /19/
      DATA IDEPTH /5*1/
      DATA POLS /'HV','VH','HH','VV','LR','RL','LL','RR',' ',' I',' Q',
     *   ' U',' V'/
C-----------------------------------------------------------------------
C                                       Init IO et al.
      TSKNAM = PRGM
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
      CHIF = 'IF'
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
      VER = 10000
      NPOL = 0
C                                       Get input parameters.
      NPARMS = 154
      CALL GTPARM (PRGM, NPARMS, RQUICK, XPRTSK, SBUFF, IERR)
      IF (IERR.NE.0) THEN
         IRET = 8
         RQUICK = .TRUE.
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SBUFF, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> Char
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (8, 1, XPRTSK, PRTASK)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      CALL H2CHR (4, 1, XSTOK, STOKES)
      CALL H2CHR (2, 1, XEXT, INEXT)
      IF ((PRTASK.EQ.'SNPLT') .OR. (PRTASK.EQ.'ELFIT') .OR.
     *   (PRTASK.EQ.'SNIFS') .OR. (PRTASK.EQ.'ELINT')) THEN
         DO 25 I = 1,30
            CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 25         CONTINUE
         END IF
      DO3COL = MAX (1.0, DO3COL)
C                                       Crunch input parameters.
      IUSER = NLUSER
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      INVERS = XVERS + 0.1
      TVCHN = 1
C                                       Get CATBLK from file.
      LUNI = 48
      UTYPE = 'UV'
      STAT = 'HDWR'
      IF (DOTV) STAT = 'READ'
      CALL MAPOPN (STAT, DISKIN, NAMEIN, CLAIN, SEQIN, UTYPE, IUSER,
     *   LUNI, INDI, CNOIN, CATBLK, SBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1035) IERR
         GO TO 990
         END IF
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
      XDISIN = DISKIN
      XSIN = SEQIN
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 1
      IF (DOTV) FRW(NCFILE) = 0
      XSIN = SEQIN
      XDISIN = DISKIN
      CALL COPY (256, CATBLK, CATUV)
      IF (PRTASK.EQ.'ELINT') THEN
         INEXT = 'SN'
         DO3COL = 2.0
         END IF
      IF ((PRTASK.EQ.'SNPLT') .OR. (PRTASK.EQ.'ELFIT') .OR.
     *   (PRTASK.EQ.'SNIFS') .OR. (PRTASK.EQ.'ELINT')) THEN
         CALL FNDEXT (INEXT, CATBLK, J)
         IF ((VER.LT.1) .OR. (VER.GT.J)) INVERS = J
         XVERS = INVERS
         END IF
C                                       Get uv header info.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       time range
      IF ((XTIME(1)+XTIME(2)+XTIME(3)+XTIME(4)) .EQ.0.0)
     *   XTIME(1)=-1.0E6
      IF ((XTIME(5)+XTIME(6)+XTIME(7)+XTIME(8)) .EQ.0.0)
     *   XTIME(5)=1.0E6
      TSTR = XTIME(1) + XTIME(2) / 24. + XTIME(3) / (24. * 60.)
     *   + XTIME(4) / (24. * 60. * 60.)
      TFIN = XTIME(5) + XTIME(6) / 24. + XTIME(7) / (24. * 60.)
     *   + XTIME(8) / (24. * 60. * 60.)
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      IUDISK = DISKIN
      IUCNO = CNOIN
      USEQ = SEQIN
C
      BCHAN = IROUND (XBCHAN)
      BCHAN = MAX (1, BCHAN)
      IF (BCHAN.GT.CATBLK(KINAX+JLOCF)) BCHAN = CATBLK(KINAX+JLOCF)
      ECHAN = IROUND (XECHAN)
      IF (ECHAN.GT.CATBLK(KINAX+JLOCF)) ECHAN = CATBLK(KINAX+JLOCF)
      IF (ECHAN.LT.BCHAN) ECHAN = CATBLK(KINAX+JLOCF)
      CHINC = IROUND (XCHINC)
      NCHAV = IROUND (XNCHAV)
      NCHAV = MAX (1, MIN (ECHAN-BCHAN+1, NCHAV))
      CHINC = IROUND (XCHINC)
      IF (CHINC.LE.0) CHINC = NCHAV
      IF (NCHAV.GE.ECHAN-BCHAN+1) CHINC = NCHAV
      I = (ECHAN - BCHAN) / CHINC
      ECHAN = BCHAN + I * CHINC
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      XBCHAN = BCHAN
      XECHAN = ECHAN
      XBIF = BIF
      XEIF = EIF
      XCHINC = CHINC
      LUNPL = 28
C                                       extension file?
C                                       init plot
C                                       Update catalog header.
      VER = 0
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', DISKIN, FCNO(1), CATBLK, SBUFF, T, 'READ',
     *      VER, IRET)
         FRW(NCFILE) = 0
         IF (IRET.NE.0) NCFILE = NCFILE - 1
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       number stokes
      CALL UVGET ('INIT', RPARM, BUFF1, IRET)
      IF (IRET.GT.0) GO TO 999
      NPOL = CATBLK(KINAX+JLOCS)
      DO 30 I = 1,NPOL
         J = CATD(KDCRV+JLOCS) + (I - CATR(KRCRP+JLOCS)) *
     *      CATR(KRCIC+JLOCS) + 9.5
         CPOL(I) = POLS(J)
 30      CONTINUE
      CALL UVGET ('CLOS', RPARM, BUFF1, IRET)
      CALL COPY (256, CATUV, CATBLK)
C                                       Create plot file
      CALL ZPHFIL ('PL', DISKIN, FCNO(1), VER, PFILE, IERR)
      IF (IERR.NE.0) GO TO 999
      IPSIZE = 0
      ITYPE = 52
      CALL GINIT (DISKIN, FCNO(1), PFILE, IPSIZE, ITYPE, NPARMS, XPRTSK,
     *   DOTV, TVCHN, GRCHN, TVCORN, CATBLK, BUFFER, LUNPL, FINDPL,
     *   IERR)
      IRET = 2
      IF (IERR.NE.0) GO TO 999
C                                       character surrounding
      CALL RFILL (4, 0.5, CHOUT)
      LTYPE = 3
      CHOUT(1) = 3.5
      CHOUT(2) = 4.0
      CHOUT(4) = CHOUT(4) + 2.833
      IF (PRTASK.EQ.'ELFIT') DO3COL = 2.0
      IF (((PRTASK.EQ.'SNPLT') .OR. (PRTASK.EQ.'ELFIT') .OR.
     *   (PRTASK.EQ.'ELINT')) .AND. (DO3COL.GT.1.5)) THEN
         CHOUT(1) = 17
         CHOUT(2) = 0.5
      ELSE IF (PRTASK.EQ.'SNIFS') THEN
         CHOUT(1) = 7.5
      ELSE IF ((PRTASK.EQ.'BPEDT') .OR. (PRTASK.EQ.'PCEDT')) THEN
         CHOUT(1) = 13
         END IF
C                                       default XYRATIO
      IF (XYRATO.LT.0.01) THEN
         IF (DOTV) THEN
            DX = WINDTV(3) - WINDTV(1) + 1 - CSIZTV(1) * (CHOUT(1)
     *         + CHOUT(3))
            DY = WINDTV(4) - WINDTV(2) + 1 - CSIZTV(2) * (CHOUT(2)
     *         + CHOUT(4))
            XYRATO = 1.0
            IF (DY.GT.0.0) XYRATO = DX / DY
         ELSE
            XYRATO = 1.0
            END IF
         END IF
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      IF ((.NOT.DOTV) .AND. (XYRATO.NE.1.0)) THEN
         IF (XYRATO.GT.1.0) THEN
            I = 1000.0 / XYRATO + 0.5
            TRC(2) = I
         ELSE
            I = 1000.0 * XYRATO + 0.5
            TRC(2) = I
            END IF
         END IF
C                                       plot memory
      DOPLAN = 0
      IF (DOTV) THEN
         DOPLAN = 1
      ELSE
         DOPLAN = 3
         END IF
      IF (DO3COL.GT.0.0) DOPLAN = DOPLAN + 1
C                                       Init for line drawing.
      CALL GINITL (BLC, TRC, XYRATO, CHOUT, IDEPTH, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 999
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVPIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1035 FORMAT ('ERROR',I3,' FINDING THE UV DATA SET')
      END
      SUBROUTINE PLCOL3 (COLV, ICOL)
C-----------------------------------------------------------------------
C   Color integers returned
C   Input:
C      COLV   R      Color level 0 - 1
C   Output
C      ICOL   I(3)   R, G, B colors (0 to 1) * 32767
C-----------------------------------------------------------------------
      REAL      COLV
      INTEGER   ICOL(3)
C
      INTEGER   I
      REAL      COL(3)
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
      IF (MAXINT.LE.0) MAXINT = 8191
      CALL COLOR3 (COLV, .FALSE., COL)
      DO 10 I = 1,3
         ICOL(I) = COL(I) * MAXINT + 0.5
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE CUVPLT (NX, NY, NZ, TVPLAN, IRET)
C-----------------------------------------------------------------------
C   CUVPLT plots the color scheme used by UVPLT
C   Inputs:
C      NX       I      Number X pixels in TVPLAN
C      NY       I      Number Y pixels in TVPLAN
C      NZ       I      Number Z pixels in TVPLAN
C   In/out
C      TVPLAN   I(*)   Image memory - 0 on input
C   Output
C      IRET     I      Erroro code
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, TVPLAN(NX,NY,*), IRET
C
      INTEGER   IX, IY, MX, MY, ICOL(3), JJJ, IIF, IIC, IIP, IY1, IY2,
     *   IX1, IX2, JX, ID(3), IT(3), INCHAR
      REAL      COLV, DCOLV, DX, DY, SX, RX
      CHARACTER TIME*8, DATE*12, TEXT*80
      INCLUDE 'PLOTC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
      JJJ = (ECHAN - BCHAN) / CHINC + 1
      JJJ = (EIF - BIF + 1) * JJJ * NPOL
      DCOLV = 0.97 / (JJJ - 1.0)
C                                       sizes of things
      MX = NX / (JJJ / NPOL)
      MY = NY / NPOL
      IF (MX.LT.2) THEN
         MSGTXT = 'TOO MANY CHANNELS FOR GOOD DISPLAY'
         CALL MSGWRT (7)
         MX = 1
         END IF
C                                       do it
      COLV = 0.0
      JX = 1
      DO 100 IIF = BIF,EIF
         DO 90 IIC = BCHAN,ECHAN,CHINC
            IX1 = JX
            IX2 = JX + MAX (0, MX-2)
            JX = JX + MX
            DO 80 IIP = 1,NPOL
               IY1 = 1 + (IIP-1) * MY
               IY2 = IY1 + MY - 2
               IF (NPOL.EQ.1) IY2 = NY
               CALL PLCOL3 (COLV, ICOL)
               COLV = COLV + DCOLV
               DO 30 IY = IY1,IY2
                  DO 20 IX = IX1,IX2
                     TVPLAN(IX,IY,1) = ICOL(1)
                     TVPLAN(IX,IY,2) = ICOL(2)
                     TVPLAN(IX,IY,3) = ICOL(3)
 20                  CONTINUE
 30               CONTINUE
 80            CONTINUE
 90         CONTINUE
 100     CONTINUE
C                                       draw the array
      IF (DOTV) THEN
         CALL DRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
      ELSE
         CALL GRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
         END IF
      IF (IRET.NE.0) GO TO 975
C                                       Draw border
      CALL GLTYPE (1, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), BLC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), BLC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Stokes labels: Y axis
      SX = (TRC(2) - BLC(2)) / NPOL
      SX = SX / 2.0
      RX = SX
      DY = -0.5
      DX = -2.5
      DO 110 IIP = 1,NPOL
         CALL GPOS (BLC(1), SX, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL GCHAR (2, 0, DX, DY, CPOL(IIP), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         SX = SX + 2.0*RX
 110     CONTINUE
C                                       Frequency, IF: X axis
      IF (DOTV) THEN
         CALL DRAXIS (NX, MX, IRET)
      ELSE
         CALL GRAXIS (NX, MX, IRET)
         END IF
      IF (IRET.NE.0) GO TO 970
C                                       Top labels: date and time
      DX = 0.0
      DY = CHOUT(4) - 1.5
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, TIME, DATE)
      WRITE (TEXT,1030) VER, DATE, TIME
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      DY = DY - 1.333
C                                       top: type
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      TEXT = '3-COLOR PLOT FOR TASK ' // PRTASK
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Done: finish plot
      CALL GFINIS (BUFFER, IRET)
      IF (IRET.NE.0) GO TO 975
      IF (.NOT.DOTV) THEN
         WRITE (MSGTXT,1900) VER
         CALL MSGWRT (2)
         END IF
      IRET = 0
      GO TO 990
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      CALL GFINIS (BUFFER, IRET)
      IF (IRET.EQ.0) GO TO 990
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IRET)
         CALL ZDESTR (DISKIN, PFILE, IRET)
         END IF
      GO TO 999
C
 990  CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('Plot file version',I4,' _created ',A12,A8)
 1900 FORMAT ('Plot file version',I4,' created')
 1970 FORMAT ('CUVPLT: ERROR DURING GRAPHING. WILL TRY TO FINISH',
     *   ' PARTIAL GRAPH')
      END
      SUBROUTINE DRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
C-----------------------------------------------------------------------
C   Draw TVPLAN into memory planes of TV only
C   Inputs:
C      NX       I      X dimension
C      NY       I      Y dimension
C      TVPLAN   I(*)   plane to draw
C   Outputs:
C      BUFFER   I(*)   plot buffer
C      IRET     I      error code
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, TVPLAN(NX,NY,*), BUFFER(*), IRET
C
      INTEGER   LX, IY, LY, CHAN, LC
      INCLUDE 'INCS:DGPH.INC'
C-----------------------------------------------------------------------
C                                       3 color grey scale
      DO 50 LC = 1,NZ
         CHAN = GPHTVC(LC)
         CALL GCINIT (CHAN, LC, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       load image
         LX = GPHIX0
         LY = GPHIY0 - 1
         DO 30 IY = 1,NY
            LY = LY + 1
            CALL YIMGIO ('WRIT', CHAN, LX, LY, 0, NX,
     *         TVPLAN(1,IY,LC), IRET)
            IF (IRET.NE.0) GO TO 999
 30         CONTINUE
 50      CONTINUE

 999  RETURN
      END
      SUBROUTINE GRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
C-----------------------------------------------------------------------
C   Draw TVPLAN into a plot file
C   Inputs:
C      NX       I      X dimension
C      NY       I      Y dimension
C      NZ       I      Z dimension (1 B&W, 3 color)
C      TVPLAN   I(*)   plane to draw
C   Outputs:
C      BUFFER   I(*)   plot buffer
C      IRET     I      error code
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, TVPLAN(NX,NY,*), BUFFER(*), IRET
C
      INTEGER   LX, IY, LY, IGLO, IGHI
      REAL      RANGES(2,3), X, Y
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
      IF (MAXINT.LE.0) MAXINT = 8191
C                                       3 color grey scale
      IGLO = 0
      IGHI = MAXINT
      RANGES(1,1) = 0.0
      RANGES(2,1) = MAXINT
      RANGES(1,2) = 0.0
      RANGES(2,2) = MAXINT
      RANGES(1,3) = 0.0
      RANGES(2,3) = MAXINT
      CALL GINITC (IGLO, IGHI, RANGES, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       load image
      LX = GPHIX1
      X = LX
      LY = GPHIY1 - 1
      DO 20 IY = 1,NY
         LY = LY + 1
         Y = LY
         CALL GPOS (X, Y, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL G3COLR (NX, 0, TVPLAN(1,IY,1), TVPLAN(1,IY,2),
     *      TVPLAN(1,IY,3), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 999
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE DRAXIS (NX, MX, IRET)
C-----------------------------------------------------------------------
C   DRAXIS plots the X axis labels for a FREQ, IF axis on the TV
C   Inputs:
C      NX     I   Number points on X axis
C      MX     I   Number points per channel incl a blank
C   Outputs:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   NX, MX, IRET
C
      INCLUDE 'PLOTC.INC'
      INTEGER   IIF, NC, IX(2), IY(2), CHAN, J, LX, LY, IANGL, IG1, IC,
     *   IIC, XX(2), DT, DD, JTRIM, JC, LEIF
      CHARACTER CIF*8
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      NC = (ECHAN - BCHAN) / CHINC + 1
      CHAN = GPHTVG(GPHLTY)
      IG1 = CHAN - NGRAY
C                                       IF values and boundaries
      IF ((ECHAN.GT.BCHAN) .AND. (EIF.GE.BIF)) THEN
         IY(1) = GPHIY0 - 1.5 * CSIZTV(2)
         IY(2) = IY(1) - 2.0 * CSIZTV(2)
      ELSE
         IY(1) = GPHIY0 - 0.2 * CSIZTV(2)
         IY(2) = IY(1) - 1.8 * CSIZTV(2)
         END IF
      IX(1) = GPHIX0
      IX(2) = IX(1)
      IF (EIF.GE.BIF) THEN
         CALL IMVECT ('ONNN', CHAN, 2, IX, IY, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
      JC = JTRIM (CHIF)
      LY = (1.2*IY(2) + 0.8*IY(1) - CSIZTV(2)) / 2.0
      LX = IX(1) - (JC+0.5) * CSIZTV(1)
      IANGL = 0
      CALL IMANOT ('WRIT', IG1, LX, LY, IANGL, 0, CHIF(:JC), BUFFER,
     *   IRET)
      IF (IRET.NE.0) GO TO 990
      IF (EIF.GE.BIF) THEN
         IX(1) = IX(1) - 1
         DO 30 IIF = BIF,EIF
            WRITE (CIF,1000) IIF
            CALL CHTRIM (CIF, 8, CIF, J)
            LX = IX(1) + (MX * NC - J * CSIZTV(1)) / 2
            CALL IMANOT ('WRIT', IG1, LX, LY, IANGL, 0, CIF(:J), BUFFER,
     *         IRET)
            IF (IRET.NE.0) GO TO 990
            IX(1) = IX(1) + NC * MX
            IX(2) = IX(1)
            CALL IMVECT ('ONNN', CHAN, 2, IX, IY, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 990
 30         CONTINUE
         END IF
C                                       channels
      IF (BCHAN.GE.ECHAN) GO TO 999
      WRITE (CIF,1000) ECHAN
      CALL CHTRIM (CIF, 8, CIF, J)
      LEIF = MAX (BIF, EIF)
C                                       label each one
      IY(1) = GPHIY0
      IY(2) = IY(1) + 1.5*CSIZTV(2)
      IF (J*CSIZTV(1).LT.MX-1) THEN
         XX(1) = GPHIX0
         DO 130 IIF = BIF,LEIF
            XX(2) = XX(1)
            IC = BCHAN + (CHINC - 1) / 2
            LY = GPHIY0 - 1.5*CSIZTV(2)
            XX(1) = XX(1) + NC * MX
            DO 120 IIC = BCHAN,ECHAN,CHINC
               WRITE (CIF,1000) IC
               CALL CHTRIM (CIF, 8, CIF, J)
               LX = XX(2) + (MX - J * CSIZTV(1)) / 2
               CALL IMANOT ('WRIT', IG1, LX, LY, IANGL, 0, CIF(:J),
     *            BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               IX(1) = XX(2) + MX / 2
               IX(2) = IX(1)
               CALL IMVECT ('ONNN', CHAN, 2, IX, IY, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               XX(2) = XX(2) + MX
               IC = IC + CHINC
 120           CONTINUE
 130        CONTINUE
C                                       label every other one
      ELSE IF (J*CSIZTV(1).LT.2*MX-1) THEN
         XX(1) = GPHIX0 + MX + (MX-1) / 2
         DO 150 IIF = BIF,LEIF
            XX(2) = XX(1)
            IC = BCHAN + CHINC
            LY = GPHIY0 - 1.5*CSIZTV(2)
            XX(1) = XX(1) + NC * MX
            DO 140 IIC = BCHAN,ECHAN,2*CHINC
               IF (IC.GT.ECHAN) GO TO 150
               WRITE (CIF,1000) IC
               CALL CHTRIM (CIF, 8, CIF, J)
               LX = XX(2) - (J * CSIZTV(1)) / 2
               CALL IMANOT ('WRIT', IG1, LX, LY, IANGL, 0, CIF(:J),
     *            BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               IX(1) = XX(2)
               IX(2) = IX(1)
               CALL IMVECT ('ONNN', CHAN, 2, IX, IY, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               XX(2) = XX(2) + 2*MX
               IC = IC + 2*CHINC
 140           CONTINUE
 150        CONTINUE
C                                       standard ticks
      ELSE
         IC = ECHAN - BCHAN
         IF (IC.GT.600) THEN
            DT = 200
         ELSE IF (IC.GT.300) THEN
            DT = 100
         ELSE IF (IC.GT.60) THEN
            DT = 20
         ELSE
            DT = 10
            END IF
         XX(1) = GPHIX0
         XX(2) = XX(1) + NC * MX
         XX(1) = GPHIX0 + (MX-1)/2
         XX(2) = XX(1) + (NC-1) * MX
         LY = GPHIY0 - 1.5*CSIZTV(2)
         DO 170 IIF = BIF,LEIF
            DD = (BCHAN / DT) * DT
            IF (DD.LT.BCHAN) DD = DD + DT
 160        IF (DD.LT.ECHAN) THEN
               WRITE (CIF,1000) DD
               CALL CHTRIM (CIF, 8, CIF, J)
               LX = FLOAT (DD - BCHAN) / FLOAT (ECHAN - BCHAN) *
     *            (XX(2) - XX(1)) + 0.5 + XX(1)
               IX(1) = LX
               IX(2) = LX
               LX = LX - (J * CSIZTV(1))/2
               CALL IMVECT ('ONNN', CHAN, 2, IX, IY, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               CALL IMANOT ('WRIT', IG1, LX, LY, IANGL, 0, CIF(:J),
     *            BUFFER, IRET)
               DD = DD + DT
               GO TO 160
               END IF
            XX(1) = XX(1) + NC * MX
            XX(2) = XX(2) + NC * MX
 170        CONTINUE
         END IF
      GO TO 999
C
 990  WRITE (MSGTXT,1990) IRET
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I8)
 1990 FORMAT ('DRAXIS: TV ERROR',I5,' PLOTTING X AXIS')
      END
      SUBROUTINE GRAXIS (NX, MX, IRET)
C-----------------------------------------------------------------------
C   GRAXIS plots the X axis labels for a FREQ, IF axis in a plot file
C   Inputs:
C      NX     I   Number points on X axis
C      MX     I   Number points per channel incl a blank
C   Outputs:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   NX, MX, IRET
C
      INCLUDE 'PLOTC.INC'
      INTEGER   IIF, NC, J, IC, IIC, XX(2), DT, DD, JC, JTRIM, LEIF
      CHARACTER CIF*8
      REAL      DX, DY, RX(2), RY(2), LX, LY
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      NC = (ECHAN - BCHAN) / CHINC + 1
C                                       IF values and boundaries
      IF ((ECHAN.GT.BCHAN) .AND. (EIF.GE.BIF)) THEN
         RY(1) = GPHIY1 - 1.5 * 9
         RY(2) = RY(1) - 2.0 * 9
      ELSE
         RY(1) = GPHIY1 - 0.2 * 9
         RY(2) = RY(1) - 1.8 * 9
         END IF
      RX(1) = GPHIX1
      RX(2) = RX(1)
      IF (EIF.GE.BIF) THEN
         CALL GPOS (RX(1), RY(1), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 990
         CALL GVEC (RX(2), RY(2), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
      DX = 0.0
      DY = 0.0
      LY = GPHIY1
      LX = RX(1)
      JC = JTRIM (CHIF)
      DX = -1.5
      DY = -JC - 0.5
      IF (BCHAN.GE.ECHAN) DY = -1.6
      CALL GPOS (LX, LY, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 990
      CALL GCHAR (2, 0, DX, DY, CHIF(:JC), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 990
      IF (EIF.GE.BIF) THEN
         RX(1) = RX(1) - 1
         DO 30 IIF = BIF,EIF
            WRITE (CIF,1000) IIF
            CALL CHTRIM (CIF, 8, CIF, J)
            LX = RX(1) + (MX * NC) / 2
            DX = -J/2.0
            CALL GPOS (LX, LY, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 990
            CALL GCHAR (J, 0, DX, DY, CIF(:J), BUFFER, IRET)
            IF (IRET.NE.0) GO TO 990
            RX(1) = RX(1) + NC * MX
            RX(2) = RX(1)
            CALL GPOS (RX(1), RY(1), BUFFER, IRET)
            IF (IRET.NE.0) GO TO 990
            CALL GVEC (RX(2), RY(2), BUFFER, IRET)
            IF (IRET.NE.0) GO TO 990
 30         CONTINUE
         END IF
C                                       channels
      IF (BCHAN.GE.ECHAN) GO TO 999
      WRITE (CIF,1000) ECHAN
      CALL CHTRIM (CIF, 8, CIF, J)
      LEIF = MAX (EIF, BIF)
C                                       label each one
      RY(1) = GPHIY1
      RY(2) = RY(1) + 1.5*9
      IF (J*7.LT.MX-1) THEN
         XX(1) = GPHIX1
         DO 130 IIF = BIF,LEIF
            XX(2) = XX(1)
            IC = BCHAN + (CHINC - 1) / 2
            LY = GPHIY1
            DY = -1.5
            XX(1) = XX(1) + NC * MX
            DO 120 IIC = BCHAN,ECHAN,CHINC
               WRITE (CIF,1000) IC
               CALL CHTRIM (CIF, 8, CIF, J)
               LX = XX(2) + MX/2
               DX = -J/2.0
               CALL GPOS (LX, LY, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               CALL GCHAR (J, 0, DX, DY, CIF(:J), BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               RX(1) = XX(2) + MX / 2
               RX(2) = RX(1)
               CALL GPOS (RX(1), RY(1), BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               CALL GVEC (RX(2), RY(2), BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               XX(2) = XX(2) + MX
               IC = IC + CHINC
 120           CONTINUE
 130        CONTINUE
C                                       label every other one
      ELSE IF (J*7.LT.2*MX-1) THEN
         XX(1) = GPHIX1 + MX + (MX-1)/2
         DO 150 IIF = BIF,LEIF
            XX(2) = XX(1)
            IC = BCHAN + CHINC
            LY = GPHIY1
            DY = -1.5
            XX(1) = XX(1) + NC * MX
            DO 140 IIC = BCHAN,ECHAN,2*CHINC
               IF (IC.GT.ECHAN) GO TO 150
               WRITE (CIF,1000) IC
               CALL CHTRIM (CIF, 8, CIF, J)
               LX = XX(2)
               DX = -J/2.0
               CALL GPOS (LX, LY, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               CALL GCHAR (J, 0, DX, DY, CIF(:J), BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               RX(1) = XX(2)
               RX(2) = RX(1)
               CALL GPOS (RX(1), RY(1), BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               CALL GVEC (RX(2), RY(2), BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               XX(2) = XX(2) + 2*MX
               IC = IC + 2*CHINC
 140           CONTINUE
 150        CONTINUE
C                                       standard ticks
      ELSE
         IC = ECHAN - BCHAN
         IF (IC.GT.600) THEN
            DT = 200
         ELSE IF (IC.GT.300) THEN
            DT = 100
         ELSE IF (IC.GT.60) THEN
            DT = 20
         ELSE
            DT = 10
            END IF
         XX(1) = GPHIX1 + MX/2 - 1
         XX(2) = XX(1) + (NC-1) * MX
         LY = GPHIY1
         DY = -1.5
         DO 170 IIF = BIF,LEIF
            DD = (BCHAN / DT) * DT
            IF (DD.LT.BCHAN) DD = DD + DT
 160        IF (DD.LT.ECHAN) THEN
               WRITE (CIF,1000) DD
               CALL CHTRIM (CIF, 8, CIF, J)
               LX = FLOAT (DD - BCHAN) / FLOAT (ECHAN - BCHAN) *
     *            (XX(2) - XX(1)) + XX(1)
               RX(1) = LX
               RX(2) = LX
               DX = -J/2.0
               CALL GPOS (RX(1), RY(1), BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               CALL GVEC (RX(2), RY(2), BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               CALL GPOS (LX, LY, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               CALL GCHAR (J, 0, DX, DY, CIF(:J), BUFFER, IRET)
               IF (IRET.NE.0) GO TO 990
               DD = DD + DT
               GO TO 160
               END IF
            XX(1) = XX(1) + NC * MX
            XX(2) = XX(2) + NC * MX
 170        CONTINUE
         END IF
      GO TO 999
C
 990  WRITE (MSGTXT,1990) IRET
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I8)
 1990 FORMAT ('GRAXIS: PLOT ERROR',I5,' PLOTTING X AXIS')
      END
      SUBROUTINE CEDITA (NX, NY, NZ, TVPLAN, IRET)
C-----------------------------------------------------------------------
C   CEDITA plots the color scheme used by EDITA, EDITR, SNEDT
C   Inputs:
C      NX       I      Number X pixels in TVPLAN
C      NY       I      Number Y pixels in TVPLAN
C      NZ       I      Number Z pixels in TVPLAN
C   In/out
C      TVPLAN   I(*)   Image memory - 0 on input
C   Output
C      IRET     I      Erroro code
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, TVPLAN(NX,NY,*), IRET
C
      INTEGER   IX, IY, MX, MY, ICOL(3), JJJ, IIF, IIP, IY1, IY2, IX1,
     *   IX2, JX, ID(3), IT(3), INCHAR
      REAL      COLV, DCOLV, DX, DY, SX, RX
      CHARACTER TIME*8, DATE*12, TEXT*80
      INCLUDE 'PLOTC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
      BCHAN = 0
      ECHAN = 0
      CHINC = 1
      NPOL = MAX (1, MIN (2, NPOL))
      JJJ = (EIF - BIF + 1) * NPOL
      DCOLV = 0.97 / MAX (1, JJJ-1)
C                                       sizes of things
      MX = NX / (JJJ / NPOL)
      MY = NY / NPOL
      IF (MX.LT.2) THEN
         MSGTXT = 'TOO MANY IFS FOR GOOD DISPLAY'
         CALL MSGWRT (7)
         MX = 1
         END IF
C                                       do it
      COLV = 0.0
      JX = 1
      DO 100 IIF = BIF,EIF
         IX1 = JX
         IX2 = JX + MAX (0, MX-2)
         JX = JX + MX
         DO 80 IIP = 1,NPOL
            IY1 = 1 + (IIP-1) * MY
            IY2 = IY1 + MY - 2
            IF (NPOL.EQ.1) IY2 = NY
            CALL PLCOL3 (COLV, ICOL)
            COLV = COLV + DCOLV
            DO 30 IY = IY1,IY2
               DO 20 IX = IX1,IX2
                  TVPLAN(IX,IY,1) = ICOL(1)
                  TVPLAN(IX,IY,2) = ICOL(2)
                  TVPLAN(IX,IY,3) = ICOL(3)
 20               CONTINUE
 30            CONTINUE
 80         CONTINUE
 100     CONTINUE
C                                       draw the array
      IF (DOTV) THEN
         CALL DRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
      ELSE
         CALL GRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
         END IF
      IF (IRET.NE.0) GO TO 975
C                                       Draw border
      CALL GLTYPE (1, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), BLC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), BLC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Stokes labels: Y axis
      SX = (TRC(2) - BLC(2)) / NPOL
      SX = SX / 2.0
      RX = SX
      DY = -0.5
      DX = -2.5
      DO 110 IIP = 1,NPOL
         CALL GPOS (BLC(1), SX, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL GCHAR (2, 0, DX, DY, CPOL(IIP), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         SX = SX + 2.0*RX
 110     CONTINUE
C                                       Frequency, IF: X axis
      IF (DOTV) THEN
         CALL DRAXIS (NX, MX, IRET)
      ELSE
         CALL GRAXIS (NX, MX, IRET)
         END IF
      IF (IRET.NE.0) GO TO 970
C                                       Top labels: date and time
      DX = 0.0
      DY = CHOUT(4) - 1.5
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, TIME, DATE)
      WRITE (TEXT,1030) VER, DATE, TIME
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      DY = DY - 1.333
C                                       top: type
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      TEXT = '3-COLOR PLOT FOR TASK ' // PRTASK
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Done: finish plot
      CALL GFINIS (BUFFER, IRET)
      IF (IRET.NE.0) GO TO 975
      IF (.NOT.DOTV) THEN
         WRITE (MSGTXT,1900) VER
         CALL MSGWRT (2)
         END IF
      IRET = 0
      GO TO 990
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      CALL GFINIS (BUFFER, IRET)
      IF (IRET.EQ.0) GO TO 990
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IRET)
         CALL ZDESTR (DISKIN, PFILE, IRET)
         END IF
      GO TO 999
C
 990  CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('Plot file version',I4,' _created ',A12,A8)
 1900 FORMAT ('Plot file version',I4,' created')
 1970 FORMAT ('CEDITA: ERROR DURING GRAPHING. WILL TRY TO FINISH',
     *   ' PARTIAL GRAPH')
      END
      SUBROUTINE CSNPLT (NX, NY, NZ, TVPLAN, IRET)
C-----------------------------------------------------------------------
C   CEDITA plots the color scheme used by SNPLT
C   Inputs:
C      NX       I      Number X pixels in TVPLAN
C      NY       I      Number Y pixels in TVPLAN
C      NZ       I      Number Z pixels in TVPLAN
C   In/out
C      TVPLAN   I(*)   Image memory - 0 on input
C   Output
C      IRET     I      Erroro code
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, TVPLAN(NX,NY,*), IRET
C
      INCLUDE 'PLOTC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSOU.INC'
      INTEGER   IX, IY, MY, ICOL(3), JJJ, IY1, IY2, IX1, IX2, ID(3),
     *   IT(3), INCHAR, SOUKOL, NKEY, NREC, NCOL, I, DATP(128,2), NROWS,
     *   GNRECI(XCLRSZ), SID(500), NID, NSOUR, SCNT(5000), STRANS(5000),
     *   ISLUN, ISOU, JTRIM, NSOU, IQUAL(30), IDUM(2)
      REAL      COLV, DCOLV, DX, DY, SX, RX, GNREC(XCLRSZ), TEMP
      CHARACTER TIME*8, DATE*12, TEXT*80, COLTAB*24, SNAMES(5000)*16
      EQUIVALENCE (GNREC, GNRECI)
      DATA COLTAB /'SOURCE ID'/
      DATA ISLUN /25/
C-----------------------------------------------------------------------
C                                       same scheme as EDITA when IF/pol
      IF ((DO3COL.LT.1.5) .AND. (PRTASK.NE.'ELFIT')) THEN
         CALL CEDITA (NX, NY, NZ, TVPLAN, IRET)
         GO TO 999
         END IF
C                                       source = color, must read table
      CALL FNDEXT (INEXT, CATBLK, JJJ)
      IF (JJJ.LE.0) THEN
         MSGTXT = 'NO TABLES OF TYPE ' // INEXT // ' FOUND'
         IRET = 9
         GO TO 980
         END IF
      IF (INVERS.LE.0) INVERS = JJJ
      IF (INVERS.GT.JJJ) INVERS = JJJ
C                                       Look up sources
      NID = 500
      NSOUR = 30
      MSGSUP = 32000
      CALL FILL (NSOUR, -1, IQUAL)
      CALL SOURNU (SOURCS, IQUAL, NSOUR, DISKIN, CNOIN, NID, BUFF1, SID,
     *   IRET)
      MSGSUP = 0
      IF (IRET.LT.0) THEN
         MSGTXT = 'SPECIFIED SOURCE(S) NOT FOUND - CONTINUING'
         CALL MSGWRT (6)
         END IF
      IF (IRET.NE.0) NID = 0
C                                       Open table
      ICLUN = 28
      NKEY = 0
      NREC = 0
      NCOL = 0
      ICLRNO = 1
      CALL TABINI ('READ', INEXT, DISKIN, CNOIN, INVERS, CATBLK, ICLUN,
     *   NKEY, NREC, NCOL, DATP, CLBUFF, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1001) IRET, INEXT, INVERS
         GO TO 980
         END IF
C                                       Get number of records
      NCLINR = CLBUFF(5)
      NROWS = NCLINR
      CALL FNDCOL (1, COLTAB, 24, .TRUE., CLBUFF, IDUM, IRET)
      SOUKOL = IDUM(1)
      IF ((IRET.GE.1) .AND. (IRET.LE.10)) THEN
         MSGTXT = 'SOURCE ID COLUMN NOT FOUND'
         GO TO 980
         END IF
      SOUKOL = DATP(SOUKOL,1)
      CALL FILL (5000, 0, SCNT)
C                                       get source numbers used
      DO 100 ICLRNO = 1,NCLINR
         CALL TABIO ('READ', 0, ICLRNO, GNREC, CLBUFF, IRET)
         IF (IRET.LT.0) GO TO 100
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING TABLE'
            GO TO 990
            END IF
         ISOU = GNRECI(SOUKOL)
C                                       source selection
         IF (NID.GT.0) THEN
            DO 10 I = 1,NID
               IF (ISOU.EQ.SID(I)) GO TO 20
 10            CONTINUE
            GO TO 100
            END IF
 20      IF ((ISOU.GT.0) .AND. (ISOU.LE.5000)) SCNT(ISOU) = SCNT(ISOU)+1
 100     CONTINUE
      CALL TABIO ('CLOS', 0, ICLRNO, GNREC, CLBUFF, IRET)
C                                       source number translation
      NSOU = 0
      CALL FILL (5000, 0, STRANS)
      DO 110 I = 1,5000
         IF (SCNT(I).GT.0) THEN
            NSOU = NSOU + 1
            STRANS(NSOU) = I
            END IF
 110     CONTINUE
      IF (NSOU.LE.0) THEN
         MSGTXT = 'NO SOURCES FOUND: CHECK INEXT, SOURCES'
         IRET = 8
         GO TO 980
         END IF
C                                       source names
      DO 120 I = 1,NSOU
         MSGSUP = 32000
         ISOU = STRANS(I)
         CALL GETSOU (ISOU, DISKIN, CNOIN, CATBLK, ISLUN, IRET)
         MSGSUP = 0
         JJJ = JTRIM (SNAME)
         SNAMES(I) = ' '
         IF (JJJ.GT.0) SNAMES(I) = SNAME
 120     CONTINUE
      DCOLV = 0.97 / MAX (1, NSOU-1)
      IRET = 0
C                                       sizes of things
      MY = NY / NSOU
C                                       do it
      COLV = 0.0
      IX1 = 1
      IX2 = NX
      DO 150 ISOU = 1,NSOU
         IY1 = 1 + (ISOU-1) * MY
         IY2 = IY1 + MY - 2
         CALL PLCOL3 (COLV, ICOL)
         COLV = COLV + DCOLV
         DO 140 IY = IY1,IY2
            DO 130 IX = IX1,IX2
               TVPLAN(IX,IY,1) = ICOL(1)
               TVPLAN(IX,IY,2) = ICOL(2)
               TVPLAN(IX,IY,3) = ICOL(3)
 130           CONTINUE
 140        CONTINUE
 150     CONTINUE
C                                       draw the array
      IF (DOTV) THEN
         CALL DRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
      ELSE
         CALL GRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
         END IF
      IF (IRET.NE.0) GO TO 975
C                                       Draw border
      CALL GLTYPE (1, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), BLC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), BLC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Stokes labels: Y axis
      TEMP = NSOU * MY
      TEMP = TEMP / NY
      SX = TEMP * (TRC(2) - BLC(2)) / NSOU
      SX = SX / 2.0
      RX = SX
      DY = -0.5
      DX = -2.5
      DO 170 ISOU = 1,NSOU
         CALL GPOS (BLC(1), SX, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         JJJ = JTRIM (SNAMES(ISOU))
         DX = -JJJ - 0.5
         CALL GCHAR (JJJ, 0, DX, DY, SNAMES(ISOU)(:JJJ), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         SX = SX + 2.0*RX
 170     CONTINUE
C                                       Top labels: date and time
      DX = 0.0
      DY = CHOUT(4) - 1.5
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, TIME, DATE)
      WRITE (TEXT,1030) VER, DATE, TIME
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      DY = DY - 1.333
C                                       top: type
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      TEXT = '3-COLOR PLOT FOR TASK ' // PRTASK
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Done: finish plot
      CALL GFINIS (BUFFER, IRET)
      IF (IRET.NE.0) GO TO 975
      IF (.NOT.DOTV) THEN
         WRITE (MSGTXT,1900) VER
         CALL MSGWRT (2)
         END IF
      IRET = 0
      GO TO 990
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      CALL GFINIS (BUFFER, IRET)
      IF (IRET.EQ.0) GO TO 990
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IRET)
         CALL ZDESTR (DISKIN, PFILE, IRET)
         END IF
      GO TO 999
C
 980  CALL MSGWRT (8)
      GO TO 970
C
 990  CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CSNPLT ERROR',I4,' ON ',A)
 1001 FORMAT ('CSNPLT ERROR ',I3,' OPENING ',A,' TABLE NO. ',I3)
 1030 FORMAT ('Plot file version',I4,' _created ',A12,A8)
 1900 FORMAT ('Plot file version',I4,' created')
 1970 FORMAT ('CSNPLT: ERROR DURING GRAPHING. WILL TRY TO FINISH',
     *   ' PARTIAL GRAPH')
      END
      SUBROUTINE CVPLOT (NX, NY, NZ, TVPLAN, IRET)
C-----------------------------------------------------------------------
C   CVPLOT plots the color scheme used by VPLOT
C   Inputs:
C      NX       I      Number X pixels in TVPLAN
C      NY       I      Number Y pixels in TVPLAN
C      NZ       I      Number Z pixels in TVPLAN
C   In/out
C      TVPLAN   I(*)   Image memory - 0 on input
C   Output
C      IRET     I      Erroro code
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, TVPLAN(NX,NY,*), IRET
C
      INTEGER   IX, IY, MX, MY, ICOL(3), JJJ, IIF, IIC, IIP, IY1, IY2,
     *   IX1, IX2, JX, ID(3), IT(3), INCHAR, IROUND
      REAL      COLV, DCOLV, DX, DY, SX, RX
      CHARACTER TIME*8, DATE*12, TEXT*80
      INCLUDE 'PLOTC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
C                                       interpret CROWDED
      JJJ = IROUND (CROWDD)
      IF (JJJ.EQ.1) THEN
         EIF = 0
         BIF = 0
      ELSE IF (JJJ.EQ.2) THEN
         BCHAN = 0
         ECHAN = 0
      ELSE IF (JJJ.NE.3) THEN
         EIF = 0
         BIF = 0
         ECHAN = 0
         BCHAN = 0
         END IF
      JJJ = (ECHAN - BCHAN) / CHINC + 1
      JJJ = (EIF - BIF + 1) * JJJ * NPOL
      IF (JJJ.LE.1) THEN
         IRET = 1
         WRITE (MSGTXT,1000) CROWDD
         CALL MSGWRT (8)
         GO TO 999
         END IF
      DCOLV = 0.97 / (JJJ - 1.0)
C                                       sizes of things
      MX = NX / (JJJ / NPOL)
      MY = NY / NPOL
      IF (MX.LT.2) THEN
         MSGTXT = 'TOO MANY CHANNELS FOR GOOD DISPLAY'
         CALL MSGWRT (7)
         MX = 1
         END IF
C                                       do it
      COLV = 0.0
      JX = 1
      DO 100 IIF = BIF,EIF
         DO 90 IIC = BCHAN,ECHAN,CHINC
            IX1 = JX
            IX2 = JX + MAX (0, MX-2)
            JX = JX + MX
            DO 80 IIP = 1,NPOL
               IY1 = 1 + (IIP-1) * MY
               IY2 = IY1 + MY - 2
               IF (NPOL.EQ.1) IY2 = NY
               CALL PLCOL3 (COLV, ICOL)
               COLV = COLV + DCOLV
               DO 30 IY = IY1,IY2
                  DO 20 IX = IX1,IX2
                     TVPLAN(IX,IY,1) = ICOL(1)
                     TVPLAN(IX,IY,2) = ICOL(2)
                     TVPLAN(IX,IY,3) = ICOL(3)
 20                  CONTINUE
 30               CONTINUE
 80            CONTINUE
 90         CONTINUE
 100     CONTINUE
C                                       draw the array
      IF (DOTV) THEN
         CALL DRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
      ELSE
         CALL GRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
         END IF
      IF (IRET.NE.0) GO TO 975
C                                       Draw border
      CALL GLTYPE (1, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), BLC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), BLC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Stokes labels: Y axis
      SX = (TRC(2) - BLC(2)) / NPOL
      SX = SX / 2.0
      RX = SX
      DY = -0.5
      DX = -2.5
      DO 110 IIP = 1,NPOL
         CALL GPOS (BLC(1), SX, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL GCHAR (2, 0, DX, DY, CPOL(IIP), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         SX = SX + 2.0*RX
 110     CONTINUE
C                                       Frequency, IF: X axis
      IF (DOTV) THEN
         CALL DRAXIS (NX, MX, IRET)
      ELSE
         CALL GRAXIS (NX, MX, IRET)
         END IF
      IF (IRET.NE.0) GO TO 970
C                                       Top labels: date and time
      DX = 0.0
      DY = CHOUT(4) - 1.5
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, TIME, DATE)
      WRITE (TEXT,1030) VER, DATE, TIME
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      DY = DY - 1.333
C                                       top: type
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      WRITE (TEXT, 1100) PRTASK, CROWDD
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Done: finish plot
      CALL GFINIS (BUFFER, IRET)
      IF (IRET.NE.0) GO TO 975
      IF (.NOT.DOTV) THEN
         WRITE (MSGTXT,1900) VER
         CALL MSGWRT (2)
         END IF
      IRET = 0
      GO TO 990
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      CALL GFINIS (BUFFER, IRET)
      IF (IRET.EQ.0) GO TO 990
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IRET)
         CALL ZDESTR (DISKIN, PFILE, IRET)
         END IF
      GO TO 999
C
 990  CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('COLOR NOT USED WITH NPOL=1 AND CROWDED=',F5.1)
 1030 FORMAT ('Plot file version',I4,' _created ',A12,A8)
 1100 FORMAT ('3-COLOR PLOT FOR TASK ',A6,' CROWDED =',F5.1)
 1900 FORMAT ('Plot file version',I4,' created')
 1970 FORMAT ('CVPLOT: ERROR DURING GRAPHING. WILL TRY TO FINISH',
     *   ' PARTIAL GRAPH')
      END
      SUBROUTINE CANBPL (NX, NY, NZ, TVPLAN, IRET)
C-----------------------------------------------------------------------
C   CANBPL plots the color scheme used by ANBPL
C   Inputs:
C      NX       I      Number X pixels in TVPLAN
C      NY       I      Number Y pixels in TVPLAN
C      NZ       I      Number Z pixels in TVPLAN
C   In/out
C      TVPLAN   I(*)   Image memory - 0 on input
C   Output
C      IRET     I      Erroro code
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, TVPLAN(NX,NY,*), IRET
C
      INTEGER   IX, IY, MX, MY, ICOL(3), JJJ, IIF, IIP, IY1, IY2, IX1,
     *   IX2, JX, ID(3), IT(3), INCHAR
      REAL      COLV, DCOLV, DX, DY, SX, RX
      CHARACTER TIME*8, DATE*12, TEXT*80
      INCLUDE 'PLOTC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
C                                       interpret OPCODE
      BCHAN = 0
      ECHAN = 0
      IF (OPCODE.EQ.'ALST') THEN
         EIF = 0
         BIF = 0
      ELSE IF (OPCODE.EQ.'ALIF') THEN
         NPOL = 1
      ELSE IF (OPCODE.NE.'ALSI') THEN
         MSGTXT = 'ASSUMING OPCODE = ''ALSI'''
         CALL MSGWRT (2)
         OPCODE = 'ALSI'
         END IF
      JJJ = (EIF - BIF + 1) * NPOL
      IF (JJJ.LE.1) THEN
         IRET = 1
         WRITE (MSGTXT,1000)
         CALL MSGWRT (8)
         GO TO 999
         END IF
      DCOLV = 0.97 / (JJJ - 1.0)
C                                       sizes of things
      MX = NX / (JJJ / NPOL)
      MY = NY / NPOL
      IF (MX.LT.2) THEN
         MSGTXT = 'TOO MANY CHANNELS FOR GOOD DISPLAY'
         CALL MSGWRT (7)
         MX = 1
         END IF
C                                       do it
      COLV = 0.0
      JX = 1
      DO 100 IIF = BIF,EIF
         IX1 = JX
         IX2 = JX + MAX (0, MX-2)
         JX = JX + MX
         DO 80 IIP = 1,NPOL
            IY1 = 1 + (IIP-1) * MY
            IY2 = IY1 + MY - 2
            IF (NPOL.EQ.1) IY2 = NY
            CALL PLCOL3 (COLV, ICOL)
            COLV = COLV + DCOLV
            DO 30 IY = IY1,IY2
               DO 20 IX = IX1,IX2
                  TVPLAN(IX,IY,1) = ICOL(1)
                  TVPLAN(IX,IY,2) = ICOL(2)
                  TVPLAN(IX,IY,3) = ICOL(3)
 20               CONTINUE
 30            CONTINUE
 80         CONTINUE
 100     CONTINUE
C                                       draw the array
      IF (DOTV) THEN
         CALL DRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
      ELSE
         CALL GRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
         END IF
      IF (IRET.NE.0) GO TO 975
C                                       Draw border
      CALL GLTYPE (1, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), BLC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), BLC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Stokes labels: Y axis
      IF (OPCODE.NE.'ALIF') THEN
         SX = (TRC(2) - BLC(2)) / NPOL
         SX = SX / 2.0
         RX = SX
         DY = -0.5
         DX = -2.5
         DO 110 IIP = 1,NPOL
            CALL GPOS (BLC(1), SX, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 970
            CALL GCHAR (2, 0, DX, DY, CPOL(IIP), BUFFER, IRET)
            IF (IRET.NE.0) GO TO 970
            SX = SX + 2.0*RX
 110        CONTINUE
         END IF
C                                       Frequency, IF: X axis
      IF (DOTV) THEN
         CALL DRAXIS (NX, MX, IRET)
      ELSE
         CALL GRAXIS (NX, MX, IRET)
         END IF
      IF (IRET.NE.0) GO TO 970
C                                       Top labels: date and time
      DX = 0.0
      DY = CHOUT(4) - 1.5
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, TIME, DATE)
      WRITE (TEXT,1030) VER, DATE, TIME
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      DY = DY - 1.333
C                                       top: type
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      WRITE (TEXT,1100) PRTASK, OPCODE
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Done: finish plot
      CALL GFINIS (BUFFER, IRET)
      IF (IRET.NE.0) GO TO 975
      IF (.NOT.DOTV) THEN
         WRITE (MSGTXT,1900) VER
         CALL MSGWRT (2)
         END IF
      IRET = 0
      GO TO 990
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      CALL GFINIS (BUFFER, IRET)
      IF (IRET.EQ.0) GO TO 990
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IRET)
         CALL ZDESTR (DISKIN, PFILE, IRET)
         END IF
      GO TO 999
C
 990  CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('COLOR NOT USED WITH NUMBER POLARIZATIONS AND IFS',
     *   ' REQUESTED')
 1030 FORMAT ('Plot file version',I4,' _created ',A12,A8)
 1100 FORMAT ('3-COLOR PLOT FOR TASK ',A6,' OPCODE = ',A)
 1900 FORMAT ('Plot file version',I4,' created')
 1970 FORMAT ('CANBPL: ERROR DURING GRAPHING. WILL TRY TO FINISH',
     *   ' PARTIAL GRAPH')
      END
      SUBROUTINE CSNIFS (NX, NY, NZ, TVPLAN, IRET)
C-----------------------------------------------------------------------
C   CSNIFS plots the color scheme used by SNIFS
C   Inputs:
C      NX       I      Number X pixels in TVPLAN
C      NY       I      Number Y pixels in TVPLAN
C      NZ       I      Number Z pixels in TVPLAN
C   In/out
C      TVPLAN   I(*)   Image memory - 0 on input
C   Output
C      IRET     I      Erroro code
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, TVPLAN(NX,NY,*), IRET
C
      INCLUDE 'PLOTC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANS.INC'
      INTEGER   IX, IY, MY, ICOL(3), JJJ, IY1, IY2, IX1, IX2, ID(3),
     *   IT(3), INCHAR, SOUKOL, NKEY, NREC, NCOL, I, SUBA, KOLS(3),
     *   DATP(128,2), NROWS, GNRECI(XCLRSZ), SID(500), NID, NSOUR,
     *   ISLUN, ISOU, NCOLOR, TIMKOL, ANTKOL, REFANT, IANT, IIP, JX, MX,
     *   IQUAL(30)
      REAL      COLV, DCOLV, DX, DY, SX, RX, GNREC(XCLRSZ), TIME, TBEG
      CHARACTER CTIME*8, DATE*12, TEXT*80, COLTAB(3)*24
      DOUBLE PRECISION GNRECD(XCLRSZ/2)
      EQUIVALENCE (GNRECD, GNREC, GNRECI)
      DATA COLTAB /'SOURCE ID', 'TIME', 'ANTENNA NO.'/
      DATA ISLUN /25/
C-----------------------------------------------------------------------
C                                       all antenna - just uses max ant
      IF (OPCODE.EQ.'ALAN') THEN
         SUBA = 1
         CALL GETANT (DISKIN, CNOIN, SUBA, CATBLK, BUFF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING ANTENNA TABLE'
            GO TO 980
            END IF
         NCOLOR = NSTNS
         CHIF = 'ANTENNA'
C                                       count = color, must read table
      ELSE
         OPCODE = 'ALTI'
         CHIF = 'SAMPLE'
         CALL FNDEXT (INEXT, CATBLK, JJJ)
         IF (JJJ.LE.0) THEN
            MSGTXT = 'NO TABLES OF TYPE ' // INEXT // ' FOUND'
            IRET = 9
            GO TO 980
            END IF
         IF (INVERS.LE.0) INVERS = JJJ
         IF (INVERS.GT.JJJ) INVERS = JJJ
C                                       Look up sources
         NID = 500
         NSOUR = 30
         MSGSUP = 32000
         CALL FILL (30, -1, IQUAL)
         CALL SOURNU (SOURCS, IQUAL, NSOUR, DISKIN, CNOIN, NID, BUFF1,
     *      SID, IRET)
         MSGSUP = 0
         IF (IRET.LT.0) THEN
            MSGTXT = 'SPECIFIED SOURCE(S) NOT FOUND - CONTINUING'
            CALL MSGWRT (6)
            END IF
         IF (IRET.NE.0) NID = 0
C                                       Open table
         ICLUN = 28
         NKEY = 0
         NREC = 0
         NCOL = 0
         ICLRNO = 1
         CALL TABINI ('READ', INEXT, DISKIN, CNOIN, INVERS, CATBLK,
     *      ICLUN, NKEY, NREC, NCOL, DATP, CLBUFF, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1001) IRET, INEXT, INVERS
            GO TO 980
            END IF
C                                       Get number of records
         NCLINR = CLBUFF(5)
         NROWS = NCLINR
         CALL FNDCOL (3, COLTAB, 24, .TRUE., CLBUFF, KOLS, IRET)
         IF ((IRET.GE.1) .AND. (IRET.LE.10)) THEN
            MSGTXT = 'REQUIRED COLUMNS NOT FOUND'
            GO TO 980
            END IF
         SOUKOL = DATP(KOLS(1),1)
         TIMKOL = DATP(KOLS(2),1)
         ANTKOL = DATP(KOLS(3),1)
         IF (SOLINT.LE.0.0) SOLINT = 600
         SOLINT = SOLINT / (24.0 * 3600.0)
         REFANT = XREF + 0.1
         REFANT = MAX (1, REFANT)
         TBEG = -100.0
C                                       get source numbers used
         NCOLOR = 0
         DO 100 ICLRNO = 1,NCLINR
            CALL TABIO ('READ', 0, ICLRNO, GNREC, CLBUFF, IRET)
            IF (IRET.LT.0) GO TO 100
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING TABLE'
               GO TO 990
               END IF
            ISOU = GNRECI(SOUKOL)
            IANT = GNRECI(ANTKOL)
            IF (IANT.NE.REFANT) GO TO 100
C                                       source selection
            IF (NID.GT.0) THEN
               DO 10 I = 1,NID
                  IF (ISOU.EQ.SID(I)) GO TO 20
 10               CONTINUE
               GO TO 100
               END IF
 20         IF (INEXT.EQ.'TY') THEN
               TIME = GNREC(TIMKOL)
            ELSE
               TIME = GNRECD(TIMKOL)
               END IF
            IF (TBEG.LT.-10.) THEN
               TBEG = TIME
               NCOLOR = 1
            ELSE IF (TIME.GT.TBEG+SOLINT) THEN
               GO TO 105
            ELSE
               NCOLOR = NCOLOR + 1
               END IF
 100        CONTINUE
 105     CALL TABIO ('CLOS', 0, ICLRNO, GNREC, CLBUFF, IRET)
         END IF
      IF (NCOLOR.LE.0) THEN
         MSGTXT = 'NO RECORDS FOUND: CHECK INEXT, SOURCES'
         IRET = 8
         GO TO 980
         END IF
C                                       so do it
      NPOL = MIN (2, NPOL)
      NCOLOR = NCOLOR * NPOL
      DCOLV = 0.97 / MAX (1, NCOLOR-1)
      IRET = 0
C                                       sizes of things
      NCOLOR = NCOLOR / NPOL
      MX = NX / NCOLOR
      MY = NY / NPOL
C                                       do it
      COLV = 0.0
      JX = 1
      DO 150 ISOU = 1,NCOLOR
         IX1 = JX
         IX2 = JX + MAX (0, MX-2)
         JX = JX + MX
         DO 145 IIP = 1,NPOL
            IY1 = 1 + (IIP-1) * MY
            IY2 = IY1 + MY - 2
            IF (NPOL.EQ.1) IY2 = NY
            CALL PLCOL3 (COLV, ICOL)
            COLV = COLV + DCOLV
            DO 140 IY = IY1,IY2
               DO 130 IX = IX1,IX2
                  TVPLAN(IX,IY,1) = ICOL(1)
                  TVPLAN(IX,IY,2) = ICOL(2)
                  TVPLAN(IX,IY,3) = ICOL(3)
 130              CONTINUE
 140           CONTINUE
 145        CONTINUE
 150     CONTINUE
C                                       draw the array
      IF (DOTV) THEN
         CALL DRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
      ELSE
         CALL GRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
         END IF
      IF (IRET.NE.0) GO TO 975
C                                       Draw border
      CALL GLTYPE (1, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), BLC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), BLC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Stokes labels: Y axis
      SX = (TRC(2) - BLC(2)) / NPOL
      SX = SX / 2.0
      RX = SX
      DY = -0.5
      DX = -2.5
      DO 160 IIP = 1,NPOL
         CALL GPOS (BLC(1), SX, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL GCHAR (2, 0, DX, DY, CPOL(IIP), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         SX = SX + 2.0*RX
 160     CONTINUE
C                                       Frequency, IF: X axis
      BCHAN = 1
      ECHAN = NCOLOR
      BIF = 0
      EIF = -1
      IF (DOTV) THEN
         CALL DRAXIS (NX, MX, IRET)
      ELSE
         CALL GRAXIS (NX, MX, IRET)
         END IF
      IF (IRET.NE.0) GO TO 970
C                                       Top labels: date and time
      DX = 0.0
      DY = CHOUT(4) - 1.5
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, CTIME, DATE)
      WRITE (TEXT,1030) VER, DATE, CTIME
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      DY = DY - 1.333
C                                       top: type
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      TEXT = '3-COLOR PLOT FOR TASK ' // PRTASK // ' OPCODE = ' //
     *   OPCODE
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Done: finish plot
      CALL GFINIS (BUFFER, IRET)
      IF (IRET.NE.0) GO TO 975
      IF (.NOT.DOTV) THEN
         WRITE (MSGTXT,1900) VER
         CALL MSGWRT (2)
         END IF
      IRET = 0
      GO TO 990
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      CALL GFINIS (BUFFER, IRET)
      IF (IRET.EQ.0) GO TO 990
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IRET)
         CALL ZDESTR (DISKIN, PFILE, IRET)
         END IF
      GO TO 999
C
 980  CALL MSGWRT (8)
      GO TO 970
C
 990  CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CSNIFS ERROR',I4,' ON ',A)
 1001 FORMAT ('CSNIFS ERROR ',I3,' OPENING ',A,' TABLE NO. ',I3)
 1030 FORMAT ('Plot file version',I4,' _created ',A12,A8)
 1900 FORMAT ('Plot file version',I4,' created')
 1970 FORMAT ('CSNPLT: ERROR DURING GRAPHING. WILL TRY TO FINISH',
     *   ' PARTIAL GRAPH')
      END
      SUBROUTINE CBPEDT (NX, NY, NZ, TVPLAN, IRET)
C-----------------------------------------------------------------------
C   CBPEDT plots the color scheme used by BPEDT and PCEDT
C   Inputs:
C      NX       I      Number X pixels in TVPLAN
C      NY       I      Number Y pixels in TVPLAN
C      NZ       I      Number Z pixels in TVPLAN
C   In/out
C      TVPLAN   I(*)   Image memory - 0 on input
C   Output
C      IRET     I      Erroro code
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, TVPLAN(NX,NY,*), IRET
C
      INCLUDE 'PLOTC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DTVC.INC'
      INTEGER   IX, IY, MY, ICOL(3), JJJ, IY1, IY2, IX1, IX2, ID(3), I,
     *   IT(3), INCHAR, NKEY, NREC, NCOL, KOLS(2), DATP(128,2), NROWS,
     *   GNRECI(XBPRSZ),ISLUN, ISOU, NCOLOR, TIMKOL, ANTKOL, REFANT,
     *   IANT, IIP, JX, MX, JTT(4), MAXCOL
      REAL      COLV, DCOLV, DX, DY, SX, RX, GNREC(XBPRSZ), TIME,
     *   TIMES(500), TEMP
      CHARACTER CTIME*8, DATE*12, TEXT*80, COLBP(2)*24, COLPC(2)*24,
     *   COLTAB(2)*24, TSIGN*1
      DOUBLE PRECISION GNRECD(XBPRSZ/2)
      EQUIVALENCE (GNRECD, GNREC, GNRECI)
      DATA COLBP /'TIME', 'ANTENNA'/
      DATA COLPC /'TIME', 'ANTENNA_NO'/
      DATA ISLUN /25/
C-----------------------------------------------------------------------
      IF (PRTASK.EQ.'PCEDT') THEN
         INEXT = 'PC'
         COLTAB(1) = COLPC(1)
         COLTAB(2) = COLPC(2)
      ELSE
         INEXT = 'BP'
         COLTAB(1) = COLBP(1)
         COLTAB(2) = COLBP(2)
         END IF
      IF (DOTV) THEN
         MAXCOL = (WINDtv(4) - WINDTV(2)) / CSIZTV(2) - 2
      ELSE
         MAXCOL = 90
         END IF
      CALL FNDEXT (INEXT, CATBLK, JJJ)
      IF (JJJ.LE.0) THEN
         MSGTXT = 'NO TABLES OF TYPE ' // INEXT // ' FOUND'
         IRET = 9
         GO TO 980
         END IF
      IF (INVERS.LE.0) INVERS = JJJ
      IF (INVERS.GT.JJJ) INVERS = JJJ
C                                       Open table
      ICLUN = 28
      NKEY = 0
      NREC = 0
      NCOL = 0
      ICLRNO = 1
      CALL TABINI ('READ', INEXT, DISKIN, CNOIN, INVERS, CATBLK,
     *   ICLUN, NKEY, NREC, NCOL, DATP, CLBUFF, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1001) IRET, INEXT, INVERS
         GO TO 980
         END IF
C                                       Get number of records
      NCLINR = CLBUFF(5)
      NROWS = NCLINR
      CALL FNDCOL (2, COLTAB, 24, .TRUE., CLBUFF, KOLS, IRET)
      IF ((IRET.GE.1) .AND. (IRET.LE.10)) THEN
         MSGTXT = 'REQUIRED COLUMNS NOT FOUND'
         GO TO 980
         END IF
      TIMKOL = DATP(KOLS(1),1)
      ANTKOL = DATP(KOLS(2),1)
      REFANT = XREF + 0.1
      REFANT = MAX (1, REFANT)
C                                       get times used
      NCOLOR = 0
      DO 100 ICLRNO = 1,NCLINR
         CALL TABIO ('READ', 0, ICLRNO, GNREC, CLBUFF, IRET)
         IF (IRET.LT.0) GO TO 100
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING TABLE'
            GO TO 990
            END IF
         IANT = GNRECI(ANTKOL)
         IF (IANT.NE.REFANT) GO TO 100
         TIME = GNRECD(TIMKOL)
         IF (TIME.GT.TFIN) THEN
            GO TO 105
         ELSE IF (TIME.GE.TSTR) THEN
            NCOLOR = NCOLOR + 1
            TIMES(NCOLOR) = TIME
            IF (NCOLOR.EQ.MAXCOL) THEN
               MSGTXT = 'MAXCOL EXCEEDED: ONLY SOME TIMES SHOWN'
               CALL MSGWRT (6)
               GO TO 105
               END IF
            END IF
 100     CONTINUE
 105  CALL TABIO ('CLOS', 0, ICLRNO, GNREC, CLBUFF, IRET)
      IF (NCOLOR.LE.0) THEN
         MSGTXT = 'NO RECORDS FOUND: CHECK INVERS, REFANT'
         IRET = 8
         GO TO 980
         END IF
C                                       so do it
      DCOLV = 0.97 / MAX (1, NCOLOR-1)
      IRET = 0
C                                       sizes of things
      MX = NX
      MY = NY / NCOLOR
C                                       do it
      COLV = 0.0
      JX = 1
      DO 150 ISOU = 1,NCOLOR
         IX1 = JX
         IX2 = JX + MX - 1
         IY1 = 1 + (ISOU-1) * MY
         IY2 = IY1 + MY - 2
         CALL PLCOL3 (COLV, ICOL)
         COLV = COLV + DCOLV
         DO 140 IY = IY1,IY2
            DO 130 IX = IX1,IX2
               TVPLAN(IX,IY,1) = ICOL(1)
               TVPLAN(IX,IY,2) = ICOL(2)
               TVPLAN(IX,IY,3) = ICOL(3)
 130           CONTINUE
 140        CONTINUE
 150     CONTINUE
C                                       draw the array
      IF (DOTV) THEN
         CALL DRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
      ELSE
         CALL GRPLAN (NX, NY, NZ, TVPLAN, BUFFER, IRET)
         END IF
      IF (IRET.NE.0) GO TO 975
C                                       Draw border
      CALL GLTYPE (1, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), BLC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), BLC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Stokes labels: Y axis
      TEMP = MY * NCOLOR
      TEMP = TEMP / NY
      SX = TEMP * (TRC(2) - BLC(2)) / NCOLOR
      SX = SX / 2.0
      RX = SX
      DY = -0.5
      CALL T2DHMS (TIMES(NCOLOR), TSIGN, JTT)
      IF (JTT(1).GT.99) THEN
         I = 1
      ELSE IF (JTT(1).GT.9) THEN
         I = 2
      ELSE IF (JTT(1).GT.0) THEN
         I = 3
      ELSE
         I = 5
         END IF
      DX = -13.5 + I
      DO 160 IIP = 1,NCOLOR
         CALL GPOS (BLC(1), SX, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL T2DHMS (TIMES(IIP), TSIGN, JTT)
         WRITE (TEXT,1160) JTT
         CALL GCHAR (13-I, 0, DX, DY, TEXT(I:12), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         SX = SX + 2.0*RX
 160     CONTINUE
C                                       Top labels: date and time
      DX = 0.0
      DY = CHOUT(4) - 1.5
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, CTIME, DATE)
      WRITE (TEXT,1030) VER, DATE, CTIME
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      DY = DY - 1.333
C                                       top: type
      CALL GPOS (BLC(1), TRC(2), BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
      TEXT = '3-COLOR PLOT FOR TASK ' // PRTASK
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Done: finish plot
      CALL GFINIS (BUFFER, IRET)
      IF (IRET.NE.0) GO TO 975
      IF (.NOT.DOTV) THEN
         WRITE (MSGTXT,1900) VER
         CALL MSGWRT (2)
         END IF
      IRET = 0
      GO TO 990
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      CALL GFINIS (BUFFER, IRET)
      IF (IRET.EQ.0) GO TO 990
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IRET)
         CALL ZDESTR (DISKIN, PFILE, IRET)
         END IF
      GO TO 999
C
 980  CALL MSGWRT (8)
      GO TO 970
C
 990  CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CBPEDT ERROR',I4,' ON ',A)
 1001 FORMAT ('CBPEDT ERROR ',I3,' OPENING ',A,' TABLE NO. ',I3)
 1030 FORMAT ('Plot file version',I4,' _created ',A12,A8)
 1160 FORMAT (I3,'/',2(I2.2,':'),I2.2)
 1900 FORMAT ('Plot file version',I4,' created')
 1970 FORMAT ('CBPEDT: ERROR DURING GRAPHING. WILL TRY TO FINISH',
     *   ' PARTIAL GRAPH')
      END

      PROGRAM ADVHLP
C-----------------------------------------------------------------------
C! Extracts adverbs from help files
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Program to extract the adverb list from all task, verb, proc, etc
C   help files.  It writes a text file of the task name and the adverb
C   in 2 columns.
C      A logical or enviroment variable named MYDIR must be defined
C   before running ADVHLP.
C      The output will be written to a file named ADVHLP.OUT.
C-----------------------------------------------------------------------
      CHARACTER INLINE*100, OUTLIN*24, INFIL*48, OUTFIL*48, LFIL*48,
     *   SUBNAM*12, ADVNAM*10, SYM*12
      INTEGER   IOERR, BUFFER(512), LUNI, LUNO, FINDI, FINDO, LUNL,
     *   FINDL, JTRIM, JT, J, IERR, NP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LUNI, LUNO, LUNL /16, 17, 18/
C-----------------------------------------------------------------------
C                                       AIPS system start up stuff
      TSKNAM ='ADVHLP'
      NPOPS = 1
      MSGKIL = 32000
      MSGSUP = 32000
      CALL ZDCHIN (.FALSE., BUFFER)
      MSGKIL = 32000
      DEVTAB(LUNI) = 3
      DEVTAB(LUNO) = 3
      DEVTAB(LUNL) = 3
C                                       Get list of routines
      LFIL = 'MYDIR:HLPA.LIST'
      CALL ZTXOPN ('READ', LUNL, FINDL, LFIL, .FALSE., IOERR)
      IF (IOERR.NE.0) GO TO 999
C                                       Open output file
      OUTFIL = 'MYDIR:ADVHLP.OUT'
      CALL ZTXOPN ('WRIT', LUNO, FINDO, OUTFIL, .TRUE., IOERR)
      IF (IOERR.NE.0) GO TO 900
C                                       Begin looping over files
 100     CALL ZTXIO ('READ', LUNL, FINDL, INLINE, IOERR)
         IF (IOERR.NE.0) GO TO 900
         JT = JTRIM (INLINE)
         IF (INLINE.EQ.' ') GO TO 900
         IF (INLINE(JT-3:JT).EQ.'.HLP') JT = JT - 4
         SUBNAM = INLINE(:JT)
C                                       Form input names etc
         INFIL = 'HLPFIL:' // SUBNAM(:JT) // '.HLP'
C                                       Open input file
         CALL ZTXOPN ('QRED', LUNI, FINDI, INFIL, .FALSE., IOERR)
         IF (IOERR.NE.0) GO TO 100
C                                       Digest file:
C                                       Read line loop
 200        CALL ZTXIO ('READ', LUNI, FINDI, INLINE, IOERR)
C                                       End of file?
            IF (IOERR.EQ.2) GO TO 600
C                                       Error?
            IF (IOERR.GT.0) GO TO 590
            J = JTRIM (INLINE)
C                                       Categories
            IF (INLINE(:2).NE.';#') GO TO 200
            NP = 3
            CALL CHLTOU (J, INLINE)
            CALL GETSYM (INLINE, NP, SYM, IERR)
            IF ((IERR.NE.0) .AND. (IERR.NE.3)) THEN
               WRITE (6,1200) IERR, SUBNAM(:JT), INLINE(:20)
               GO TO 600
               END IF
            IF (SYM.EQ.'ADVERB') GO TO 600
            IF (SYM.EQ.'OBSOLETE') GO TO 600
            IF (SYM.EQ.'INFORMATION') GO TO 600
            IF ((SYM.NE.'PROCEDURE') .AND. (SYM.NE.'PSEUDOVERB') .AND.
     *         (SYM.NE.'TASK') .AND. (SYM.NE.'RUN') .AND.
     *         (SYM.NE.'VERB')) THEN
               WRITE (6,1205) SUBNAM(:JT), SYM
               GO TO 600
               END IF
C                                       skip copyleft
 210        CALL ZTXIO ('READ', LUNI, FINDI, INLINE, IOERR)
C                                       End of file?
            IF (IOERR.EQ.2) GO TO 600
C                                       Error?
            IF (IOERR.GT.0) GO TO 590
            IF (INLINE(:1).EQ.';') GO TO 210
C                                       next 2 lines
            CALL ZTXIO ('READ', LUNI, FINDI, INLINE, IOERR)
C                                       End of file?
            IF (IOERR.EQ.2) GO TO 600
C                                       Error?
            IF (IOERR.GT.0) GO TO 590
            IF (INLINE(:4).EQ.'----') GO TO 600
C                                       read for adverbs
 220        CALL ZTXIO ('READ', LUNI, FINDI, INLINE, IOERR)
C                                       End of file?
            IF (IOERR.EQ.2) GO TO 600
C                                       Error?
            IF (IOERR.GT.0) GO TO 590
            IF (INLINE(:1).EQ.';') GO TO 210
            IF (INLINE(:4).NE.'----') THEN
               ADVNAM = INLINE(:9)
               OUTLIN = SUBNAM // '  ' // ADVNAM
               IF (ADVNAM.NE.' ') THEN
                  CALL ZTXIO ('WRIT', LUNO, FINDO, OUTLIN, IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (6,1220) IERR, SUBNAM, ADVNAM
                     GO TO 600
                     END IF
                  END IF
               GO TO 220
               END IF
            GO TO 600
C                                       Error - close file
 590     WRITE (6,1590) SUBNAM
C                                       End - close file
 600     CALL ZTXCLS (LUNI, FINDI, IOERR)
         IF (IOERR.NE.0) GO TO 900
C                                       Next file
         GO TO 100
C                                       Done - close files
 900  CALL ZTXCLS (LUNO, FINDO, IOERR)
      CALL ZTXCLS (LUNL, FINDL, IOERR)
 999  STOP
C-----------------------------------------------------------------------
 1200 FORMAT (' ERROR',I3,' ON ',A,1X,A)
 1205 FORMAT (' UNKNOWN TYPE ON ',A,' = ',A)
 1220 FORMAT (' ERROR',I4,' ON ',A,' ',A)
 1590 FORMAT (' ERROR READING FILE ',A)
      END
      SUBROUTINE GETSYM (LBUFF, NPNT, SYM, IERR)
C-----------------------------------------------------------------------
C   GETSYM scrutinizes a card image to look for the next symbol.  A
C   symbol begins with a letter and contains up to eight alpha-numeric
C   characters (A-Z,0-9,_).  This routine is used for interpreting a
C   FITS tape and for interpreting the HI files.
C   Inputs:
C      LBUFF  C*80  Loose packed card image
C      NPNT   I     Pointer to first character
C   Output:
C      NPNT   I     Pointer value after getting symbol
C      SYM    C*8   Symbol, padded with blanks
C      IERR   I     Return code
C                      0--> Found legal symbol followed by '='
C                      1--> Ran off the end of the card
C                      2--> Symbol had too many characters
C                      3--> Found legal symbol with no '='
C                           or SYM is HISTORY or COMMENT
C                      4--> Found a '/' symbol
C                      5--> Symbol contains an illegar char
C-----------------------------------------------------------------------
      CHARACTER LBUFF*(*), SYM*(*)
      INTEGER   NPNT, IERR
C
      CHARACTER LCH*1, TSYM*20
      INTEGER   LPNT, LIMIT, IC, NKAR, NKL
      DATA LIMIT /80/
C-----------------------------------------------------------------------
C                                       Initialization
      LIMIT = LEN (LBUFF)
      NKL = LEN (SYM)
      NKAR = 0
      IERR = 0
      SYM = ' '
C                                       Check card limit
 10   IF (NPNT.GT.LIMIT) GO TO 980
C                                       Skip leading blanks
         LCH = LBUFF(NPNT:NPNT)
         IF (LCH.NE.' ') GO TO 20
            NPNT = NPNT + 1
            GO TO 10
C                                       Is the first character legal?
 20   IC = ICHAR(LCH)
      IF ((IC.GE.ICHAR('A')) .AND. (IC.LE.ICHAR('Z'))) GO TO 40
C                                       If we find a '/', good bye
         IF (LCH.EQ.'/') GO TO 940
C                                       Not legal.  Skip to next blank
 30      NPNT = NPNT + 1
         IF (NPNT.GT.LIMIT) GO TO 980
            LCH = LBUFF(NPNT:NPNT)
            IF (LCH.NE.' ') GO TO 30
C                                       Found another blank. begin
C                                       searching again
         NPNT = NPNT + 1
         GO TO 10
C                                       Find rest of symbol
 40   LPNT = NPNT
 50   NKAR = NKAR + 1
      IF (NKAR.LE.NKL) TSYM(NKAR:NKAR) = LCH
         NPNT = NPNT + 1
         IF (NPNT.GT.LIMIT) GO TO 980
         LCH = LBUFF(NPNT:NPNT)
         IC = ICHAR(LCH)
C                                       Is the character legal?
         IF ((IC.GE.ICHAR('A')) .AND. (IC.LE.ICHAR('Z'))) GO TO 50
         IF ((IC.GE.ICHAR('0')) .AND. (IC.LE.ICHAR('9'))) GO TO 50
         IF (LCH.EQ.'_') GO TO 50
         IF (LCH.EQ.'-') GO TO 50
C                                       Have we hit a ' ' or
C                                          a '='?
      IF (LCH.EQ.'=') GO TO 70
      IF (LCH.EQ.' ') GO TO 65
C                                       Illegal char.  Look for
C                                          the next space.
 62   NPNT = NPNT + 1
      IF (NPNT.GT.LIMIT) GO TO 980
      IF (LBUFF(NPNT:NPNT).NE.' ') GO TO 62
      GO TO 930
C                                       Look for an '='
C                                         or an end of card
 65   NPNT = NPNT + 1
      IF (NPNT.GT.LIMIT) GO TO 67
      IF (LBUFF(NPNT:NPNT).EQ.' ') GO TO 65
      IF (LBUFF(NPNT:NPNT).EQ.'=') GO TO 70
C                                       Legal symbol with no '='
 67   NPNT = NPNT - 2
C                                      Legal symbol with an '='
 70   NPNT = NPNT + 1
      IF (NKAR.GT.NKL) GO TO 970
C                                       Pack symbol
      SYM = TSYM(1:NKAR)
      IF (IERR.NE.0) GO TO 999
C                                       Check for HISTORY =, etc.
      IF (SYM.EQ.'HISTORY ') GO TO 999
      IF (SYM.EQ.'COMMENT ') GO TO 999
      IERR = 0
      GO TO 999
C
C-----------------------------------------------------------------------
C
C                                       Symbol contains illegal char
 930  IERR = 5
      GO TO 999
C                                       Found a '/' symbol
 940  IERR = 4
      NPNT = NPNT + 1
      GO TO 999
C                                       Symbol has more than 8 char
 970  IERR = 2
      GO TO 999
C                                       Ran out of card
 980  IERR = 1
C
 999  RETURN
      END

      DOUBLE PRECISION FUNCTION DFMACH(JOB)
C-----------------------------------------------------------------------
C! Function to compute machine dependent parameters.
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      INTEGER   JOB
C
C     SMACH COMPUTES MACHINE PARAMETERS OF FLOATING POINT
C     ARITHMETIC FOR USE IN TESTING ONLY.  NOT REQUIRED BY
C     LINPACK PROPER.
C
C     IF TROUBLE WITH AUTOMATIC COMPUTATION OF THESE QUANTITIES,
C     THEY CAN BE SET BY DIRECT ASSIGNMENT STATEMENTS.
C     ASSUME THE COMPUTER HAS
C
C        B = BASE OF ARITHMETIC
C        T = NUMBER OF BASE  B  DIGITS
C        L = SMALLEST POSSIBLE EXPONENT
C        U = LARGEST POSSIBLE EXPONENT
C
C     THEN
C
C        EPS = B**(1-T)
C        TINY = 100.0*B**(-L+T)
C        HUGE = 0.01*B**(U-T)
C
C     DFMACH SAME AS SMACH EXCEPT T, L, U APPLY TO
C     DOUBLE PRECISION.
C
C     CMACH SAME AS SMACH EXCEPT IF COMPLEX DIVISION
C     IS DONE BY
C
C        1/(X+I*Y) = (X-I*Y)/(X**2+Y**2)
C
C     THEN
C
C        TINY = SQRT(TINY)
C        HUGE = SQRT(HUGE)
C
C
C     JOB IS 1, 2 OR 3 FOR EPSILON, TINY AND HUGE, RESPECTIVELY.
C
      DOUBLE PRECISION EPS, TINY, HUGE, S
C-----------------------------------------------------------------------
      EPS = 1.0D0
      S = 2.0D0
 10   IF (S.GT.1.0D0) THEN
         EPS = EPS/2.0D0
         S = 1.0D0 + EPS
         GO TO 10
         END IF
      EPS = 2.0D0*EPS
C
      S = 1.0D0
 20   IF (S*1.0D0.NE.0.0D0) THEN
         TINY = S
         S = S / 16.0D0
         GO TO 20
         END IF
      TINY = (TINY / EPS) * 100.0
      HUGE = 1.0D0 / TINY
C
      DFMACH = EPS
      IF (JOB.EQ.2) DFMACH = TINY
      IF (JOB.EQ.3) DFMACH = HUGE
C
      RETURN
      END

      SUBROUTINE ZGNAME (NAME, IERR)
C-----------------------------------------------------------------------
C! get name of current process
C# Z System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Get the name of the current process.
C   Output:
C      NAME   C*6   Current process name
C      IERR   I     Error return code: 0 => no error
C                      1 => error
C   VMS version
C-----------------------------------------------------------------------
      CHARACTER NAME*6
      INTEGER   IERR
C
      INTEGER   SYS$GETJPIW, I, J1, J2, IT, ITEM(4)
      INTEGER*2 ITEM2(8)
      CHARACTER UNAME*15
      INCLUDE '($JPIDEF)'
      EQUIVALENCE (ITEM2, ITEM)
C-----------------------------------------------------------------------
C                                       Get name
      ITEM2(1) = 15
      ITEM2(2) = JPI$_PRCNAM
      ITEM(2) = %LOC (UNAME)
      ITEM(3) = 0
      ITEM(4) = 0
      IERR = SYS$GETJPIW ( , , , ITEM, , , )
      IERR = IERR - 1
C                                       Move chars to output
      NAME = ' '
      DO 10 I = 1,6
         IT = ICHAR (UNAME(I:I))
         IF (IT.EQ.0) GO TO 999
         NAME(I:I) = UNAME(I:I)
 10      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ANSAME (IUDISK, IUCNO, CATBLK, ALLSUB)
C-----------------------------------------------------------------------
C! Do all antenna files match
C# EXT-util UV VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1998, 2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   checks that all antenna files are the same.
C   Inputs:
C      IUDISK   I   Disk number
C      IUCNO    I   Catalog number
C      CATBLK   I(256)   Catablog block
C   Output:
C      ALLSUB   L   True => they are the same
C-----------------------------------------------------------------------
      INTEGER   IUDISK, IUCNO, CATBLK(256)
      LOGICAL   ALLSUB
C
      INTEGER   NUMSUB, IS, IA, ANBUFF(512,2), ILUN(2), IERR, NANT
C                                       Modified include DANT: 2 bufs
      INCLUDE 'INCS:PUVD.INC'
C                                       Declarations for ANTINI
      INTEGER   ANKOLS(MAXANC,2), ANNUMV(MAXANC,2), NUMORB(2),
     *   NOPCAL(2), ANTNIF(2), ANFQID(2), IANRNO(2)
      CHARACTER ANAME(2)*8, RDATE(2)*8,TIMSYS(2)*8, XYZHAN(2)*8,
     *   TFRAME(2)*8
      REAL      POLRXY(2,2), UT1UTC(2), DATUTC(2)
      DOUBLE PRECISION  ARRAYC(3,2), GSTIA0(2), DEGPDY(2), SAFREQ(2)
C                                       Declarations for TABAN
      INTEGER   NOSTA(2), MNTSTA(2)
      CHARACTER ANNAME(2)*8, POLTYA(2)*2, POLTYB(2)*2
      REAL      STAXOF(2), POLAA(2), POLCA(2*MAXIF,2), POLAB(2),
     *   POLCB(2*MAXIF,2), DIAMAN(2), FWHMAN(MAXIF,2)
      DOUBLE PRECISION  STAXYZ(3,2), ORBPRM(6,2)
C                                       End modified include.
      INCLUDE 'INCS:DMSG.INC'
      DATA ILUN /110,111/
C-----------------------------------------------------------------------
C                                       is there a question
      CALL FNDEXT ('AN', CATBLK, NUMSUB)
C                                       yes: compare #1 with each
      IF (NUMSUB.GT.1) THEN
         DO 100 IS = 2,NUMSUB
            IA = 0
            CALL ANTINI ('READ', ANBUFF(1,2), IUDISK, IUCNO, IS,
     *         CATBLK, ILUN(2), IANRNO(2), ANKOLS(1,2), ANNUMV(1,2),
     *         ARRAYC(1,2), GSTIA0(2), DEGPDY(2), SAFREQ(2), RDATE(2),
     *         POLRXY(1,2), UT1UTC(2), DATUTC(2), TIMSYS(2), ANAME(2),
     *         XYZHAN(2), TFRAME(2), NUMORB(2), NOPCAL(2), ANTNIF(2),
     *         ANFQID(2), IERR)
            IF (IERR.EQ.2) GO TO 100
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'INIT', IS
               GO TO 990
               END IF
            CALL ANTINI ('READ', ANBUFF(1,1), IUDISK, IUCNO, 1,
     *         CATBLK, ILUN(1), IANRNO(1), ANKOLS(1,1), ANNUMV(1,1),
     *         ARRAYC(1,1), GSTIA0(1), DEGPDY(1), SAFREQ(1), RDATE(1),
     *         POLRXY(1,1), UT1UTC(1), DATUTC(1), TIMSYS(1), ANAME(1),
     *         XYZHAN(1), TFRAME(1), NUMORB(1), NOPCAL(1), ANTNIF(1),
     *         ANFQID(1), IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'INIT', 1
               GO TO 980
               END IF
C                                       Headers match?
            IF (ABS(ARRAYC(1,1)-ARRAYC(1,2)).GT.1.0D0) GO TO 900
            IF (ABS(ARRAYC(2,1)-ARRAYC(2,2)).GT.1.0D0) GO TO 900
            IF (ABS(ARRAYC(3,1)-ARRAYC(3,2)).GT.1.0D0) GO TO 900
            IF (ABS(GSTIA0(1)-GSTIA0(2)).GT.0.1D0) GO TO 900
            IF (ABS(SAFREQ(1)-SAFREQ(2)).GT.0.1D0) GO TO 900
            IF (RDATE(1).NE.RDATE(2)) GO TO 900
            IF (TIMSYS(1).NE.TIMSYS(2)) GO TO 900
            IF (ANAME(1).NE.ANAME(2)) GO TO 900
            IF (NUMORB(1).NE.NUMORB(2)) GO TO 900
            IF (ANTNIF(1).NE.ANTNIF(2)) GO TO 900
            IF (XYZHAN(1).NE.XYZHAN(2)) GO TO 900
            IF (TFRAME(1).NE.TFRAME(2)) GO TO 900
            NANT = ANBUFF(5,1)
            IF (NANT.NE.ANBUFF(5,2)) GO TO 900
C                                       read the an tables
            DO 90 IA = 1,NANT
               CALL TABAN ('READ', ANBUFF(1,1), IANRNO(1), ANKOLS(1,1),
     *            ANNUMV(1,1), ANNAME(1), STAXYZ(1,1), ORBPRM(1,1),
     *            NOSTA(1), MNTSTA(1), STAXOF(1), DIAMAN(1),
     *            FWHMAN(1,1), POLTYA(1), POLAA(1), POLCA(1,1),
     *            POLTYB(1), POLAB(1), POLCB(1,1), IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ', 1
                  GO TO 970
                  END IF
               CALL TABAN ('READ', ANBUFF(1,2), IANRNO(2), ANKOLS(1,2),
     *            ANNUMV(1,2), ANNAME(2), STAXYZ(1,2), ORBPRM(1,2),
     *            NOSTA(2), MNTSTA(2), STAXOF(2), DIAMAN(1),
     *            FWHMAN(1,2), POLTYA(2), POLAA(2), POLCA(1,2),
     *            POLTYB(2), POLAB(2), POLCB(1,2), IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ', IS
                  GO TO 970
                  END IF
C                                       compare
               IF (ANNAME(1).NE.ANNAME(2)) GO TO 900
               IF (ABS(STAXYZ(1,1)-STAXYZ(1,2)).GT.1.0D0) GO TO 900
               IF (ABS(STAXYZ(2,1)-STAXYZ(2,2)).GT.1.0D0) GO TO 900
               IF (ABS(STAXYZ(3,1)-STAXYZ(3,2)).GT.1.0D0) GO TO 900
               IF (ABS(DIAMAN(1)-DIAMAN(2)).GT.0.1) GO TO 900
               IF (NOSTA(1).NE.NOSTA(2)) GO TO 900
               IF (MNTSTA(1).NE.MNTSTA(2)) GO TO 900
               IF (POLTYA(1).NE.POLTYA(2)) GO TO 900
               IF (POLTYB(1).NE.POLTYB(2)) GO TO 900
 90            CONTINUE
            CALL TABIO ('CLOS', 0, IANRNO(1), ANBUFF(1,1), ANBUFF(1,1),
     *         IERR)
            CALL TABIO ('CLOS', 0, IANRNO(2), ANBUFF(1,2), ANBUFF(1,2),
     *         IERR)
 100        CONTINUE
         ALLSUB = .TRUE.
         END IF
      GO TO 999
C
 900  WRITE (MSGTXT,1900) IS, IA
 970  CALL MSGWRT (6)
      CALL TABIO ('CLOS', 0, IANRNO(1), ANBUFF(1,1), ANBUFF(1,1), IERR)
      CALL TABIO ('CLOS', 0, IANRNO(2), ANBUFF(1,2), ANBUFF(1,2), IERR)
      GO TO 999
C
 980  CALL MSGWRT (6)
      CALL TABIO ('CLOS', 0, IANRNO(2), ANBUFF(1,2), ANBUFF(1,2), IERR)
      GO TO 999
C
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ANSAME: ERROR',I5,1X,A,'ING AN TABLE',I4)
 1900 FORMAT ('ANSAME: AN TABLE',I4,' DOES NOT MATCH AN TABLE 1 AT',
     *   ' ANTENNA',I3)
      END

      SUBROUTINE QRECT1 (APCORE, A, I, C, K, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Vector angle to sine and cosine conversion.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Vector polar to sine and cosine calculation:
C       C(mK)   = COS (A(mI+1))
C       C(mK+1) = SIN (A(mI+1)) for m = 0 to N-1
C   Inputs:
C      A  I  Source vector base address
C      I  I  A address increment (normally 2 * integer)
C      C  I  Destination vector base address
C      K  I  C address increment (normally 2 * integer)
C      N  I  Element count
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   A, I, C, K, N
C
      LONGINT   JA, JC
      INTEGER   LOOP
      DOUBLE PRECISION CSER, SSER
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (N.GT.0) THEN
C                                       Addresses 1-rel + angle in
C                                       second arg for QRECT compatable
         JA = A + 1 + PSAPOF
         JC = C + PSAPOF
C                                       Loop
      INCLUDE 'INCS:ZVND.INC'
         DO 100 LOOP = 1,N
C                                       get cos and sin of phase
            CSER = COS (APCORE(JA))
            SSER = SIN (APCORE(JA))
C                                       X=cos and Y=sin
            APCORE(JC+1) = SSER
            APCORE(JC)   = CSER
            JA = JA + I
            JC = JC + K
 100        CONTINUE
         END IF
C
 999  RETURN
      END

C    Printer Class Module
C-----------------------------------------------------------------------
C! Object Oriented AIPS Fortran "Printer" class library
C# Map-util Utility Object-Oriented
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999, 2004, 2007, 2015, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C    A Printer object is an interface to the line printer, or, as a user
C    option, printer line output on the terminal.  Only one printer
C    object may be active (open) at a  time.
C       Usage notes:
C    1) A printer object may be associated with an image or uvdata
C    object before opening by setting the value of 'PRINTOBJ' before
C    opening.  When the printer object is then opened a header is
C    written describing that object.
C    Class public members:
C      PRINTOBJ  C*32  Name of associated uvdata or image object.
C      LPFILE    C*48  Name of printer file.
C      DOCRT     I     If >0 use terminal, else printer.
C    Following only after opening:
C      TITLE1    C*132 First page title
C      TITLE2    C*132 Second page title
C
C   Class  private data:
C      MYNAME    C*32  Name of open printer
C      POBJ      C*32  Name of associated object
C      DOCRT     R     Interactive or batch printer
C      NACROS    I     Number of columns in output
C      NLINE     I     Line number on page
C      IPAGE     I     Page number.
C      PRTLUN    I     Printer LUN (1)
C      PRTIND    I     Printer FTAB pointer.
C
C   Public functions:
C     PRTCRE (name, ierr)
C        Creates a printer object with name "name".
C     PRTDES (name, ierr)
C        Destroys the printer object with name "name";
C     PRTZAP (name, ierr)
C        Destroys the printer object with name "name";
C        (Same as PRTDES)
C     PRTOPN (name, status, ierr)
C        Opens a printer object, writing header if appropriate
C     PRTCLO (name, ierr)
C        Closes a printer object, spooling output if appropriate
C     PRTGET (name, keywrd, type, dim, value, valuec, ierr)
C        Return keyword value.
C     PRTPUT (name, keywrd, type, dim, value, valuec, ierr)
C        Store keyword value.
C     PRTWRI (name, line, quit, ierr)
C        Send a line to the printer.
C     PRTNUP (name, ierr)
C        Force new page on next write.
C     PRTCNT (name, quit, ierr)
C        For interactive use ask user if he/she wishes to continue.
C
C   Private functions:
C      PRBGET (name, keywrd, type, dim, value, valuec, ierr)
C         Fetches private member.
C      PRBPUT (name, keywrd, type, dim, value, valuec, ierr)
C         Stores private member.
C      PRTUVH (name, ierr)
C         Print uvdata header
C      PRTIMH (name, ierr)
C         Print image header
C      PRTTBH (name, ierr)
C         Print table header
C-----------------------------------------------------------------------
LOCAL INCLUDE 'PRINT.INC'
C                                       Include for CLEAN class.
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INTEGER   NACROS, NLINE, IPAGE, PRTLUN, PRTIND
      LOGICAL   ACTIVE
      REAL      DOCRT
      CHARACTER MYNAME*32, POBJ*32, TITLE1*132, TITLE2*132, SCRAT*132
      COMMON /PRTCCM/ DOCRT, ACTIVE, NACROS, NLINE, IPAGE, PRTLUN,
     *   PRTIND
      COMMON /PRTMCC/ MYNAME, POBJ, TITLE1, TITLE2, SCRAT
      INTEGER   IDUM(20)
      REAL      RDUM(20)
      LOGICAL   LDUM(20)
      DOUBLE PRECISION DDUM(10)
      EQUIVALENCE (DDUM, RDUM,LDUM, IDUM)
      COMMON /PRFORT/ DDUM
C                                                          End PRINT.INC
LOCAL END
      SUBROUTINE PRTCRE (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Creates an PRINTER object with name "name"
C   Inputs:
C      NAME  C*?   The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'PRINT.INC'
      INTEGER  IDIM(7)
      CHARACTER BNAME*32, LPFILE*48, CDUMMY*1
      DATA BNAME /'    '/
      DATA LPFILE /'    '/
C-----------------------------------------------------------------------
      IERR = 0
C                                       Create AIPS object
      CALL OBCREA (NAME, 'PRINTER ', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Initilize - ass. obj.
      IDIM(1) = LEN (BNAME)
      IDIM(2) = 1
      IDIM(3) = 0
      CALL PRTPUT (NAME, 'PRINTOBJ', OOACAR, IDIM, IDUM, BNAME, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Printer file
      IDIM(1) = LEN (LPFILE)
      IDIM(2) = 1
      IDIM(3) = 0
      CALL PRTPUT (NAME, 'LPFILE', OOACAR, IDIM, IDUM, LPFILE, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       printer
      IDIM(1) = 1
      IDUM(1) = -1
      CALL PRTPUT (NAME, 'DOCRT', OOAINT, IDIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'PRTCRE: ERROR CREATING ' // NAME
      CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE PRTDES (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Destroys the PRINTER object with name "name";
C   Inputs:
C      NAME  C*?   The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C-----------------------------------------------------------------------
      IERR = 0
C                                       Close
      CALL PRTCLO (NAME, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Delete object
      CALL OBFREE (NAME, IERR)
C
 999  RETURN
      END
      SUBROUTINE PRTZAP (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Destroys the PRINTER object with name "name"; same as PRTDES.
C   Inputs:
C      NAME  C*?   The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INCLUDE 'PRINT.INC'
C-----------------------------------------------------------------------
      CALL PRTDES (NAME,IERR)
C
 999  RETURN
      END
      SUBROUTINE PRTOPN (NAME, STATUS, IERR)
C-----------------------------------------------------------------------
C   Public
C   Opens a PRINTER file.  Marks PRINTER common as active.
C   Writes a header for associated object if appropriate.
C   Inputs:
C      NAME   C*?   The name of the object.
C      STATUS C*4   Not used.
C   Output:
C      IERR  I     Error return code, 0=OK, 5=data invalid
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), STATUS*4
      INTEGER   IERR
C
      INCLUDE 'PRINT.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DDCH.INC'
      INTEGER   DIM(7), TYPE, OBJNUM, CLASNO, IDOCRT, IROUND
      CHARACTER LPNAME*48, CNAME*8, CDUMMY*1
C-----------------------------------------------------------------------
      IERR = 0
C                                       PRINTER common must be inactive
      IF (ACTIVE) THEN
         IERR = 1
         MSGTXT = 'PRTOPN: ATTEMPT TO ACTIVATE SECOND PRINTER OBJECT'
         GO TO 990
         END IF
      ACTIVE = .TRUE.
C                                       Save name
      MYNAME = NAME
C                                       Open printer
      CALL PRTGET (NAME, 'PRINTOBJ', TYPE, DIM, IDUM, POBJ, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL PRTGET (NAME, 'LPFILE', TYPE, DIM, IDUM, LPNAME, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL PRTGET (NAME, 'DOCRT', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      IDOCRT = IDUM(1)
      DOCRT = IDOCRT
C                                       open printer excl
      CALL LPOPEN (LPNAME, DOCRT, PRTLUN, PRTIND, NACROS, SBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) PRTLUN, IERR
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       Init page, line count, titles
      NLINE = 990
      IPAGE = 0
      TITLE1 = ' '
      TITLE2 = ' '
C                                       How many columns?
      IDOCRT = IROUND (DOCRT)
      DIM(1) = 1
      DIM(2) = 1
      IDUM(1) = IDOCRT
      CALL PRTPUT (NAME, 'DOCRT', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      IDUM(1) = NACROS
      CALL PRTPUT (NAME, 'NACROS', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Print header?
      IF (POBJ.NE.'    ') THEN
C                                       Get object class.
         CALL OBNAME (POBJ, OBJNUM, IERR)
         IF (IERR.NE.0) GO TO 995
         CALL OBCLAS (OBJNUM, CLASNO, CNAME, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
         CNAME = '      '
         END IF
      IF (CNAME.EQ.'UVDATA') THEN
C                                       UV data
         CALL PRTUVH (NAME, IERR)
      ELSE IF (CNAME.EQ.'IMAGE') THEN
C                                       Image
         CALL PRTIMH (NAME, IERR)
      ELSE IF (CNAME.EQ.'TABLE') THEN
C                                       Table
         CALL PRTTBH (NAME, IERR)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
 995  MSGTXT = 'PRTOPN: ERROR OPENING ' // NAME
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PRINTER LUN',I3,' OPEN ERR =',I6)
      END
      SUBROUTINE PRTCLO (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Closes PRINTER spooling output to printer if necessary.
C   Inputs:
C      NAME  C*?   The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INCLUDE 'PRINT.INC'
      INCLUDE 'INCS:CLASSIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       No action if inactive
      IF (.NOT.ACTIVE) GO TO 999
C                                       Make sure right one
      IF (NAME.NE.MYNAME) THEN
         IERR = 2
         MSGTXT = 'ATTEMPT TO ACCESS CLOSED PRINT OBJECT'
         GO TO 990
         END IF
C                                       Close print.
      CALL LPCLOS (PRTLUN, PRTIND, NLINE, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Mark as inactive
      ACTIVE = .FALSE.
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
 995  MSGTXT = 'PRTCLO: ERROR CLOSING ' // NAME
      CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE PRTGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Returns the dimensionality and value(s) associated with a given
C   keyword.
C   Inputs:
C      NAME     C*?   The name of the object.
C      KEYWRD   C*?   The name of the keyword in form 'MEM1.MEM2...'
C   Outputs:
C      TYPE     I     Data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM      I(*)  Dimensionality of value, an axis dimension of zero
C                     means that that dimension and higher are
C                     undefined.
C      VALUE    ?(*)  The value associated with keyword.
C      VALUEC   C*?   Associated value (character)
C      IERR     I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC(*)*(*)
      INTEGER   TYPE, DIM(*), VALUE(*), IERR
C
      INTEGER   OBJNUM
C-----------------------------------------------------------------------
      IERR = 0
C                                       Is this a base class?
      CALL PRBGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       IERR = 1 means not recognized.
      IF (IERR.EQ.1) THEN
C                                       Lookup NAME
         CALL OBNAME (NAME, OBJNUM, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL  OBGET (OBJNUM, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C
 999  RETURN
      END
      SUBROUTINE PRTPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Stores the value (array) associated with a given keyword.
C   Inputs:
C      NAME     C*?   The name of the object.
C      KEYWRD   C*?   The name of the keyword in form 'MEM1.MEM2...'
C      TYPE     I     Data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM      I(*)  Dimensionality of value, an axis dimension of zero
C                     means that that dimension and higher are
C                     undefined.
C      VALUE    ?(*)  The value associated with keyword.
C      VALUEC   C*?   Associated value (character)
C   Outputs:
C      IERR     I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC(*)*(*)
      INTEGER   TYPE, DIM(*), VALUE(*), IERR
C
      INTEGER   OBJNUM
C-----------------------------------------------------------------------
      IERR = 0
C                                       Is this a base class?
      CALL PRBPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       IERR = 1 means not recognized.
      IF (IERR.EQ.1) THEN
C                                       Lookup NAME
         CALL OBNAME (NAME, OBJNUM, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OBPUT (OBJNUM, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C
 999  RETURN
      END
      SUBROUTINE PRTWRI (NAME, LINE, QUIT, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Writes line to printer
C   Inputs:
C      NAME     C*?   The name of the object.
C      LINE     C*?   Line to be printed
C   Outputs:
C      QUIT     L     If true, user requests that task quit.
C      IERR     I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), LINE*(*)
      LOGICAL   QUIT
      INTEGER   IERR
C
      INCLUDE 'PRINT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Check that it is active
      IF (.NOT.ACTIVE) THEN
         IERR = 2
         MSGTXT = 'PRINTER INACTIVE'
         GO TO 990
         END IF
C                                       Make sure right one
      IF (NAME.NE.MYNAME) THEN
         IERR = 2
         MSGTXT = 'ATTEMPT TO ACCESS CLOSED PRINT OBJECT'
         GO TO 990
         END IF
C                                       Print it.
      CALL PRTLIN (PRTLUN, PRTIND, DOCRT, NACROS, TITLE1, TITLE2, LINE,
     *   NLINE, IPAGE, SCRAT, IERR)
C                                       User wants to quit?
      IF (IERR.LT.0) THEN
         QUIT = .TRUE.
         IERR = 0
      ELSE
         QUIT = .FALSE.
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
      MSGTXT = 'PRTWRI: ERROR WRITING ' // NAME
      CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE PRTNUP (NAME, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Force new page on next write.
C   Inputs:
C      NAME     C*?   The name of the object.
C   Outputs:
C      IERR     I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INCLUDE 'PRINT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Make sure right one
      IF (NAME.NE.MYNAME) THEN
         IERR = 2
         MSGTXT = 'ATTEMPT TO ACCESS CLOSED PRINT OBJECT'
         GO TO 990
         END IF
C                                       Set line number
      NLINE = 999
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
      MSGTXT = 'PRTNUP: ERROR WRITING ' // NAME
      CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE PRTCNT (NAME, QUIT, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Ask interactive user to quit or continue?
C   Inputs:
C      NAME     C*?   The name of the object.
C   Outputs:
C      QUIT     L     If true, user requests that task quit.
C      IERR     I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      LOGICAL   QUIT
      INTEGER   IERR
C
      INCLUDE 'PRINT.INC'
C-----------------------------------------------------------------------
      IERR = 0
      NLINE = 1001
C                                       Make sure right one
      IF (NAME.NE.MYNAME) THEN
         IERR = 2
         MSGTXT = 'ATTEMPT TO ACCESS CLOSED PRINT OBJECT'
         GO TO 990
         END IF
C                                       ask
      CALL PRTLIN (PRTLUN, PRTIND, DOCRT, NACROS, TITLE1, TITLE2,
     *   TITLE1, NLINE, IPAGE, SCRAT, IERR)
C                                       User wants to quit?
      IF (IERR.LT.0) THEN
         QUIT = .TRUE.
         IERR = 0
      ELSE
         QUIT = .FALSE.
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
      MSGTXT = 'PRTCNT: ERROR WRITING ' // NAME
      CALL MSGWRT (8)
C
 999  RETURN
      END
C
C   Private functions:
C
      SUBROUTINE PRBGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Private
C   If KEYWRD refers to a recognized member base class then fetch the
C   value.
C   Inputs:
C      NAME     C*?   The name of the object.
C      KEYWRD   C*?   Keyword in form 'mem1.mem2...'
C   Outputs:
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of value, an axis dimension of zero
C                    means that that dimension and higher are
C                    undefined.
C      VALUE   ?     associated value (non character)
C      VALUEC  C*?   associated value (character)
C      IERR    I     Error code, 0=OK.  1=> did not find., 2=Failed
C-----------------------------------------------------------------------
      INTEGER   TYPE, DIM(*), VALUE(*), IERR
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC(*)*(*)
C
      INTEGER   POINT, NMEMS, IMEM, LOOP
      PARAMETER (NMEMS = 2)
      CHARACTER MEMBER*16, MEMS(NMEMS)*16
      INCLUDE 'PRINT.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA MEMS /'TITLE1', 'TITLE2'/
C-----------------------------------------------------------------------
      IERR = 1
C                                       Look for base class.member name
C                                       in KEYWRD.
      POINT = INDEX (KEYWRD, '.')
      IF (POINT.LE.0) THEN
         MEMBER = KEYWRD
      ELSE
         MEMBER = KEYWRD(1:POINT-1)
         END IF
C                                       Search list of recognized base
C                                       classes.
      IMEM = -1
      DO 10 LOOP = 1,NMEMS
         IF (MEMBER.EQ.MEMS(LOOP)) IMEM = LOOP
 10      CONTINUE
C                                       If no base class and member not
C                                       recognized then return.
      IF ((IMEM.LE.0) .AND. (POINT.LE.0)) GO TO 999
C                                       Find it?, if not, complain and
C                                       die.
      IF (IMEM.LE.0) THEN
         IERR = 2
         MSGTXT = 'PRBGET: UNKNOWN MEMBER: ' // MEMBER // ' IN ' // NAME
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Get from common
      GO TO (110,120), IMEM
C                                       TITLE1
 110     VALUEC(1) = TITLE1
         TYPE = OOACAR
         DIM(1) = LEN (TITLE1)
         DIM(2) = 1
         GO TO 900
C                                       TITLE2
 120     VALUEC(1) = TITLE2
         TYPE = OOACAR
         DIM(1) = LEN (TITLE2)
         DIM(2) = 1
         GO TO 900
 900  IERR = 0
C
 999  RETURN
      END
      SUBROUTINE PRBPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Private
C   If KEYWRD refers to a recognized member base class then store the
C   value.
C   Inputs:
C      NAME    C*?   The name of the object.
C      KEYWRD  C*?   Keyword in form 'mem1.mem2...'
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of value, an axis dimension of zero
C                    means that that dimension and higher are
C                    undefined.
C      VALUE   ?     associated value (non character)
C      VALUEC  C*?   associated value (character)
C   Outputs:
C      IERR    I     Error code, 0=OK.  1=> did not find.
C-----------------------------------------------------------------------
      INTEGER   TYPE, DIM(*), VALUE(*), IERR
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC(*)*(*)
C
      INTEGER   POINT, NMEMS, IMEM, LOOP
      PARAMETER (NMEMS = 2)
      CHARACTER MEMBER*16, MEMS(NMEMS)*16
      INCLUDE 'PRINT.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA MEMS /'TITLE1', 'TITLE2'/
C-----------------------------------------------------------------------
      IERR = 1
C                                       Save member name
      POINT = INDEX (KEYWRD, '.')
      IF (POINT.LE.0) THEN
         MEMBER = KEYWRD
      ELSE
         MEMBER = KEYWRD(1:POINT-1)
         END IF
C                                       Search list of recognized base
C                                       classes.
      IMEM = -1
      DO 10 LOOP = 1,NMEMS
         IF (MEMBER.EQ.MEMS(LOOP)) IMEM = LOOP
 10      CONTINUE
C                                       If no base class and member not
C                                       recognized then return.
      IF ((IMEM.LE.0) .AND. (POINT.LE.0)) GO TO 999
C                                       Find it?, if not, complain and
C                                       die.
      IF (IMEM.LE.0) THEN
         IERR = 2
         MSGTXT = 'PRBPUT: UNKNOWN MEMBER: ' // MEMBER // ' IN ' // NAME
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Save in common
      GO TO (110,120), IMEM
C                                       TITLE1
 110     TITLE1 = VALUEC(1)
         GO TO 900
C                                       TITLE2
 120     TITLE2 = VALUEC(1)
         GO TO 900
 900  IERR = 0
C
 999  RETURN
      END
      SUBROUTINE PRTUVH (NAME, IERR)
C-----------------------------------------------------------------------
C   Private
C   Print uv data header.
C   Inputs:
C      NAME    C*?   The name of the uvdata object.
C   Outputs:
C      IERR    I     Error code, 0=OK.  1=> did not find.
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER NAME*(*)
C
      INCLUDE 'PRINT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INTEGER   TYPE, DIM(3), SEQ, DISK, INDXF, INDXSU, INDXRA, INDXDC,
     *   LLHM(2), MMHM(2), NCOR, NVIS, BUFNO
      LOGICAL   DOSOU
      REAL      LLSEC, MMSEC
      DOUBLE PRECISION CRVAL(7)
      CHARACTER LINE*132, ONAME*12, CLASS*6, OBJECT*8, LLCH*1, MMCH*1,
     *   CTYPE(7)*8, ISORT*2, OBSDAT*8, ADATE*12, CDUMMY*1
C-----------------------------------------------------------------------
      IERR = 0
C                                       Open and close associated object
C                                       if not OPEN
      CALL OBINFO (POBJ, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 995
      IF (BUFNO.LE.0) THEN
         CALL OUVOPN (POBJ, 'READ', IERR)
         IF (IERR.NE.0) GO TO 995
         CALL OUVCLO (POBJ, IERR)
         IF (IERR.NE.0) GO TO 995
         END IF
C                                       File info
      CALL FNAGET (POBJ, 'NAME', TYPE, DIM, IDUM, ONAME, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL FNAGET (POBJ, 'CLASS', TYPE, DIM, IDUM, CLASS, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL FNAGET (POBJ, 'IMSEQ', TYPE, DIM, IDUM, CDUMMY, IERR)
      SEQ = IDUM(1)
      IF (IERR.NE.0) GO TO 995
      CALL FNAGET (POBJ, 'DISK', TYPE, DIM, IDUM, CDUMMY, IERR)
      DISK = IDUM(1)
      IF (IERR.NE.0) GO TO 995
      WRITE (LINE,1050) ONAME, CLASS, SEQ, DISK, NLUSER
      CALL PRTLIN (PRTLUN, PRTIND, DOCRT, NACROS, TITLE1, TITLE2, LINE,
     *   NLINE, IPAGE, SCRAT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Coordinates
      CALL UVDGET (POBJ, 'CRVAL', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL DPCOPY (DIM(1), DDUM, CRVAL)
      CALL UVDGET (POBJ, 'CTYPE', TYPE, DIM, IDUM, CTYPE, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Is source random parameter
C                                       present?
      CALL UVDFND (POBJ, 1, 'SOURCE', INDXSU, IERR)
C                                       May not be there
      DOSOU = (IERR.EQ.0) .AND. (INDXSU.GT.0)
      IERR = 0
C                                       Single source
      IF (.NOT.DOSOU) THEN
C                                       Need RA axis
         CALL UVDFND (POBJ, 2, 'RA', INDXRA, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'TROUBLE FINDING RA AXIS'
            GO TO 990
            END IF
C                                       Need MM axis
         CALL UVDFND (POBJ, 2, 'DEC', INDXDC, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'TROUBLE FINDING DEC AXIS'
            GO TO 990
            END IF
C                                       Get various information
         CALL UVDGET (POBJ, 'OBJECT', TYPE, DIM, IDUM, OBJECT, IERR)
         IF (IERR.NE.0) GO TO 995
C                                       Crack position
         CALL COORDD (1, CRVAL(INDXRA), LLCH, LLHM, LLSEC)
         CALL COORDD (2, CRVAL(INDXDC), MMCH, MMHM, MMSEC)
C                                       Source info
         WRITE (LINE,1055) OBJECT, CTYPE(INDXRA), LLCH, LLHM, LLSEC,
     *      CTYPE(INDXDC), MMCH, MMHM, MMSEC
         CALL PRTLIN (PRTLUN, PRTIND, DOCRT, NACROS, TITLE1, TITLE2,
     *      LINE, NLINE, IPAGE, SCRAT, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE
C                                       Multi source - give obs. date
         CALL UVDGET (POBJ, 'DATE-OBS', TYPE, DIM, IDUM, OBSDAT, IERR)
         IF (IERR.NE.0) GO TO 995
         CALL DATDAT (OBSDAT, ADATE)
         LINE = 'Multisource uv data file observed on ' // ADATE
         CALL PRTLIN (PRTLUN, PRTIND, DOCRT, NACROS, TITLE1, TITLE2,
     *      LINE, NLINE, IPAGE, SCRAT, IERR)
         IF (IERR.NE.0) GO TO 995
         END IF
C                                       Other info
C                                       Need FREQ axis
      CALL UVDFND (POBJ, 2, 'FREQ', INDXF, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE FINDING FREQ AXIS'
         GO TO 990
         END IF
      CALL UVDGET (POBJ, 'NCORR', TYPE, DIM, IDUM, CDUMMY, IERR)
      NCOR = IDUM(1)
      IF (IERR.NE.0) GO TO 995
      CALL UVDGET (POBJ, 'GCOUNT', TYPE, DIM, IDUM, CDUMMY, IERR)
      NVIS = IDUM(1)
      IF (IERR.NE.0) GO TO 995
      CALL UVDGET (POBJ, 'SORTORD', TYPE, DIM, IDUM, ISORT, IERR)
      IF (IERR.NE.0) GO TO 995
      WRITE (LINE,1060) CRVAL(INDXF)*1.0D-9, NCOR, NVIS, ISORT
      CALL PRTLIN (PRTLUN, PRTIND, DOCRT, NACROS, TITLE1, TITLE2, LINE,
     *   NLINE, IPAGE, SCRAT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Blank line
      LINE = ' '
      CALL PRTLIN (PRTLUN, PRTIND, DOCRT, NACROS, TITLE1, TITLE2, LINE,
     *   NLINE, IPAGE, SCRAT, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
 995  MSGTXT = 'PRTUVH: ERROR WRITING HEADER FOR ' // POBJ
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('File = ',A12,'.',A6,'.',I4,'   Vol =',I2,4X,'Userid =',
     *   I5)
 1055 FORMAT ('Source= ',A,3X,A,' = ',A1,I2.2,I3.2,F6.2,3X,A,' = ',
     *   A1,I2.2,I3.2,F5.1)
 1060 FORMAT ('Freq=',F13.9,' GHz   Ncor=',I3,'   No. vis=',I10,
     *   '   Sort order= ',A2)
      END
      SUBROUTINE PRTIMH (NAME, IERR)
C-----------------------------------------------------------------------
C   Private
C   Print image header.
C   Inputs:
C      NAME    C*?   The name of the image object.
C   Outputs:
C      IERR    I     Error code, 0=OK.  1=> did not find.
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER NAME*(*)
C
      INCLUDE 'PRINT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INTEGER   TYPE, DIM(3), SEQ, DISK, INDXF, INDXRA, INDXDC,
     *   LLHM(2), MMHM(2), BUFNO
      REAL      LLSEC, MMSEC
      DOUBLE PRECISION CRVAL(7)
      CHARACTER LINE*132, ONAME*12, CLASS*6, OBJECT*8, LLCH*1, MMCH*1,
     *   CTYPE(7)*8, CDUMMY*1
C-----------------------------------------------------------------------
      IERR = 0
C                                       Open and close associated object
C                                       if not OPEN
      CALL OBINFO (POBJ, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 995
      IF (BUFNO.LE.0) THEN
         CALL IMGOPN (POBJ, 'READ', IERR)
         IF (IERR.NE.0) GO TO 995
         CALL IMGCLO (POBJ, IERR)
         IF (IERR.NE.0) GO TO 995
         END IF
C                                       File info
      CALL FNAGET (POBJ, 'NAME', TYPE, DIM, IDUM, ONAME, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL FNAGET (POBJ, 'CLASS', TYPE, DIM, IDUM, CLASS, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL FNAGET (POBJ, 'IMSEQ', TYPE, DIM, IDUM, CDUMMY, IERR)
      SEQ = IDUM(1)
      IF (IERR.NE.0) GO TO 995
      CALL FNAGET (POBJ, 'DISK', TYPE, DIM, IDUM, CDUMMY, IERR)
      DISK = IDUM(1)
      IF (IERR.NE.0) GO TO 995
      WRITE (LINE,1050) ONAME, CLASS, SEQ, DISK, NLUSER
      CALL PRTLIN (PRTLUN, PRTIND, DOCRT, NACROS, TITLE1, TITLE2, LINE,
     *   NLINE, IPAGE, SCRAT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Coordinates
      CALL IMGET (POBJ, 'CRVAL', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL DPCOPY (DIM(1), DDUM, CRVAL)
      CALL IMGET (POBJ, 'CTYPE', TYPE, DIM, IDUM, CTYPE, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Need RA axis
      CALL UVDFND (POBJ, 2, 'RA--', INDXRA, IERR)
      IF ((IERR.EQ.0) .AND. (INDXRA.GT.0)) THEN
         CALL COORDD (1, CRVAL(INDXRA), LLCH, LLHM, LLSEC)
      ELSE
         CALL COORDD (1, 0.0D0, LLCH, LLHM, LLSEC)
         END IF
C                                       Need Dec axis
      CALL UVDFND (POBJ, 2, 'DEC-', INDXDC, IERR)
      IF ((IERR.EQ.0) .AND. (INDXDC.GT.0)) THEN
         CALL COORDD (2, CRVAL(INDXDC), MMCH, MMHM, MMSEC)
      ELSE
         CALL COORDD (2, 0.0D0, MMCH, MMHM, MMSEC)
         END IF
C                                       Get various information
      CALL IMGET (POBJ, 'OBJECT', TYPE, DIM, IDUM, OBJECT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Source info
      WRITE (LINE,1055) OBJECT, CTYPE(INDXRA), LLCH, LLHM, LLSEC,
     *   CTYPE(INDXDC), MMCH, MMHM, MMSEC
      CALL PRTLIN (PRTLUN, PRTIND, DOCRT, NACROS, TITLE1, TITLE2, LINE,
     *   NLINE, IPAGE, SCRAT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Other info
C                                       Need FREQ axis
      CALL UVDFND (POBJ, 2, 'FREQ', INDXF, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE FINDING FREQ AXIS'
         GO TO 990
         END IF
      WRITE (LINE,1060) CRVAL(INDXF)*1.0D-9
      CALL PRTLIN (PRTLUN, PRTIND, DOCRT, NACROS, TITLE1, TITLE2, LINE,
     *   NLINE, IPAGE, SCRAT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Blank line
      LINE = ' '
      CALL PRTLIN (PRTLUN, PRTIND, DOCRT, NACROS, TITLE1, TITLE2, LINE,
     *   NLINE, IPAGE, SCRAT, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
 995  MSGTXT = 'PRTIMH: ERROR WRITING HEADER FOR ' // POBJ
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('File = ',A12,'.',A6,'.',I4,'   Vol =',I2,4X,'Userid =',
     *   I5)
 1055 FORMAT ('Source= ',A,3X,A,' = ',A1,I2.2,I3.2,F6.2,3X,A,' = ',
     *   A1,I2.2,I3.2,F5.1)
 1060 FORMAT ('Freq=',F13.9,' GHz ')
      END
      SUBROUTINE PRTTBH (NAME, IERR)
C-----------------------------------------------------------------------
C   Private
C   Print table header.
C   Inputs:
C      NAME    C*?   The name of the table object.
C   Outputs:
C      IERR    I     Error code, 0=OK.  1=> did not find.
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER NAME*(*)
C
      INCLUDE 'PRINT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INTEGER   TYPE, DIM(3), SEQ, DISK, BUFNO, TDISK, TCNO, TVER, NROW
      CHARACTER LINE*132, ONAME*12, CLASS*6, TBTYPE*2, TLABEL*56,
     *   CDUMMY*1
C-----------------------------------------------------------------------
      IERR = 0
C                                       Open and close associated object
C                                       if not OPEN
      CALL OBINFO (POBJ, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 995
      IF (BUFNO.LE.0) THEN
         CALL IMGOPN (POBJ, 'READ', IERR)
         IF (IERR.NE.0) GO TO 995
         CALL IMGCLO (POBJ, IERR)
         IF (IERR.NE.0) GO TO 995
         END IF
C                                       File info
      CALL FNAGET (POBJ, 'NAME', TYPE, DIM, IDUM, ONAME, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL FNAGET (POBJ, 'CLASS', TYPE, DIM, IDUM, CLASS, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL FNAGET (POBJ, 'IMSEQ', TYPE, DIM, IDUM, CDUMMY, IERR)
      SEQ = IDUM(1)
      IF (IERR.NE.0) GO TO 995
      CALL FNAGET (POBJ, 'DISK', TYPE, DIM, IDUM, CDUMMY, IERR)
      DISK = IDUM(1)
      IF (IERR.NE.0) GO TO 995
      WRITE (LINE,1050) ONAME, CLASS, SEQ, DISK, NLUSER
      CALL PRTLIN (PRTLUN, PRTIND, DOCRT, NACROS, TITLE1, TITLE2, LINE,
     *   NLINE, IPAGE, SCRAT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Table label
      CALL TABGET (POBJ, 'LABEL', TYPE, DIM, IDUM, TLABEL, IERR)
      IF (IERR.NE.0) GO TO 995
      LINE = TLABEL
      CALL PRTLIN (PRTLUN, PRTIND, DOCRT, NACROS, TITLE1, TITLE2, LINE,
     *   NLINE, IPAGE, SCRAT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Table type
      CALL TBLKUP (POBJ, TDISK, TCNO, TBTYPE, TVER, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Get number of rows
      CALL TABGET (POBJ, 'NROW', TYPE, DIM, IDUM, CDUMMY, IERR)
      NROW = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      WRITE (LINE,1065) TBTYPE, TVER, NROW
      CALL PRTLIN (PRTLUN, PRTIND, DOCRT, NACROS, TITLE1, TITLE2, LINE,
     *   NLINE, IPAGE, SCRAT, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Blank line
      LINE = ' '
      CALL PRTLIN (PRTLUN, PRTIND, DOCRT, NACROS, TITLE1, TITLE2, LINE,
     *   NLINE, IPAGE, SCRAT, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
 995  MSGTXT = 'PRTTBH: ERROR WRITING HEADER FOR ' // POBJ
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('File = ',A12,'.',A6,'.',I4,'   Vol =',I2,4X,'Userid =',
     *   I5)
 1065 FORMAT ('Table of type ', A2, ', version ',I3,' contains ',I8,
     *   ' rows')
      END

      SUBROUTINE VTTELL (ITER, FINISH, TVFLD, TVPASS, IRET)
C-----------------------------------------------------------------------
C! Tim Cornwell Routine: checks TELL file.
C# Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   VTTELL checks the TELL file to see if anything is waiting for VTESS.
C   If so, it picks up the parms (via GTTELL), interprets them, and
C   sends them back to the rest of the task to handle.
C   Input:
C      ITER     I   Current iterations
C   In/out:
C      FINISH   L   T => this is last iteration
C      TVFLD    I   Field to display, <= 0 no TV
C      TVPASS   I   =1 => do TV display with init and ask
C   Output:
C      IRET     I   0 => okay, 99 => abort now
C-----------------------------------------------------------------------
      INTEGER   ITER, TVFLD, TVPASS, IRET
      LOGICAL   FINISH
C
      CHARACTER OPTELL*4
      INTEGER   NPARMS, SCRTCH(256), IROUND, I, ITV
      REAL      XNITER, XERROR(64), XXDOTV, XPRLEV
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /VTTLL/ XNITER, XERROR, XXDOTV, XPRLEV
C-----------------------------------------------------------------------
C                                       Check TELL file
      IRET = 0
      NPARMS = 67
      CALL GTTELL (NPARMS, OPTELL, XNITER, SCRTCH, IERR)
      WRITE (MSGTXT,1000) OPTELL
      IF (IERR.NE.0) CALL MSGWRT (4)
      IF (IERR.EQ.2) FINISH = .TRUE.
      IF (IERR.EQ.3) IRET = 99
      IF (IERR.NE.1) GO TO 999
C                                       install parms
      DO 10 I = 1,NFIELD
         IF (I.LE.64) THEN
            IF (XERROR(I).GT.0.0) FRES(I) = XERROR(I)
         ELSE
            FRES(I) = XERROR(64)
            END IF
 10      CONTINUE
C                                       number iterations, quit
      IF (XNITER.LT.-0.01) DOSTOP = .TRUE.
      IF (ABS(XNITER).GE.1.0) VMLIM = ABS(XNITER) + 0.01
      IF (ITER.GE.VMLIM) FINISH = .TRUE.
      LNGOUT = .FALSE.
      IF (XPRLEV.GT.0.0) LNGOUT = .TRUE.
C                                       TV display: which field
      ITV = IROUND (XXDOTV)
      IF (NTVDEV.LE.0) ITV = 0
      IF (ITV.GT.2) ITV = 1
      IF ((TVPASS.LT.10) .AND. (ITV.NE.TVFLD)) TVPASS = 1
      TVFLD = ITV
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Received ',A4,' operation from TELL')
      END

      SUBROUTINE ZMIO (OPER, LUN, FIND, BLKNO, NBYTES, BUFF, IBUFF,
     *   IERR)
C-----------------------------------------------------------------------
C! random-access, quick return (double buffer) disk IO for large blocks
C# Z IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2004, 2007-2008, 2011, 2018, 2021, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Low level random access, large block, double buffered device I/O.
C   Inputs:
C      OPER     C*4   Operation code 'READ' or 'WRIT'
C      LUN      I     Logical unit number
C      FIND     I     Index in FTAB to file control block for LUN
C      BLKNO    I     Beginning virtual block number (1-relative).
C                     Block size is given by NBPS in /DCHCOM/.
C      NBYTES   I     Number of AIPS-bytes to transfer (an AIPS-byte is
C                     1/2 a local integer).
C      IBUFF    I     Buffer number to use (1 or 2)
C   In/out:
C      BUFF     I(*)  I/O buffer
C   Output:
C      IERR     I     Error return code: 0 => no error
C                        1 => file not open
C                        2 => input error
C                        3 => I/O error
C                        4 => end of file
C   Generic version - does SYSTYP='VMS' differently with double
C   buffering and CHARACTER to ZMI2 while UNIX does not actually do
C   double buffering since lower level routines are pure wait mode
C   routines anyway.    VMS COMMENTED OUT
C   No longer performs I/O to TV devices (15MAR84), to tape devices
C   (15APR87), and to Tektronix devices (15JUL87) release.
C-----------------------------------------------------------------------
      CHARACTER OPER*4
      INTEGER   LUN, FIND, BLKNO, NBYTES, BUFF(*), IBUFF, IERR
C
      INTEGER   ERRLUN, FCBOFF, IEREOF, IBYTES
      LOGICAL   T
      HOLLERITH HOPER
      CHARACTER MSG*80
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE 'INCS:DSUMIO.INC'
      DATA T, ERRLUN, IEREOF /.TRUE., 12, 4/
C-----------------------------------------------------------------------
C                                       Check inputs.
      IERR = 2
C                                       Valid opcode?
      MSG = ' '
      IF ((OPER.NE.'READ') .AND. (OPER.NE.'WRIT')) THEN
         WRITE (MSG,1000) OPER
C                                       LUN in range?
      ELSE IF ((LUN.LE.0) .OR. (LUN.GT.128-NTAPED)) THEN
         WRITE (MSG,1010) LUN
C                                       Does not handle message files.
      ELSE IF (LUN.EQ.ERRLUN) THEN
         WRITE (MSG,1020) LUN
C                                       Does not handle TVs (as of
C                                       the 15MAR84 release).
      ELSE IF (DEVTAB(LUN).EQ.4) THEN
         WRITE (MSG,1030)
C                                       Does not handle tapes (as of
C                                       the 15APR87 release).
      ELSE IF ((LUN.LT.129) .AND. (LUN.GE.129-NTAPED)) THEN
         WRITE (MSG,1040)
C                                       Does not handle Tektronix I/O
C                                       (as of the 15JUL87 release).
      ELSE IF (LUN.EQ.7) THEN
         WRITE (MSG,1050)
C                                       Valid block # requested?
      ELSE IF (BLKNO.LE.0) THEN
         WRITE (MSG,1060) BLKNO
C                                       Valid # bytes requested?
C                                       256 Mwords for now
      ELSE IF ((NBYTES.LT.0) .OR. (NBYTES.GE.536870912)) THEN
         IBYTES = NBYTES * (NBITWD / 16)
         WRITE (MSG,1070) IBYTES
C                                       Proper device type?
      ELSE IF (MOD (DEVTAB(LUN), 2).EQ.1) THEN
         WRITE (MSG,1080) LUN, DEVTAB(LUN)
C                                       File open in FTAB?
      ELSE IF (FTAB(FIND).NE.LUN) THEN
         IERR = 1
         WRITE (MSG,1090) LUN
C                                       Proper buffer # specified?
      ELSE IF ((IBUFF.NE.1) .AND. (IBUFF.NE.2)) THEN
         WRITE (MSG,1100) IBUFF
         END IF
      IF (MSG.NE.' ') THEN
         MSGTXT = MSG
         GO TO 995
         END IF
C                                       Calculate FTAB offset to file
C                                       control block for buffer #.
      IBYTES = NBYTES * (NBITWD / 16)
      IF (OPER.EQ.'READ') THEN
         NRCOUN(1) = NRCOUN(1) + 1
         NRBYTE(1) = NRBYTE(1) + IBYTES
      ELSE
         NWCOUN(1) = NWCOUN(1) + 1
         NWBYTE(1) = NWBYTE(1) + IBYTES
         END IF
      FCBOFF = FIND + MOFF
      CALL CHR2H (4, OPER, 1, HOPER)
      CALL ZMI2 (HOPER, FTAB(FCBOFF), BUFF, BLKNO, NBYTES, IERR)
C                                       Do it.
C                                       Check for good start of I/O.
      IF ((IERR.NE.0) .AND. (IERR.NE.IEREOF)) THEN
         IBYTES = NBYTES * (NBITWD / 16)
         WRITE (MSGTXT,1900) OPER, LUN, BLKNO, IBYTES
         CALL MSGWRT (7)
         CALL ZERROR ('ZMI2', FTAB(FCBOFF+FCBERR), ' ', FTAB(FCBOFF), T)
         END IF
      GO TO 999
C
 995  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZMIO: INVALID OPERATION = ',A4)
 1010 FORMAT ('ZMIO: LUN = ',I6,' OUT OF RANGE')
 1020 FORMAT ('ZMIO: ILLEGAL LUN = ',I3)
 1030 FORMAT ('ZMIO: DOES NOT PERFORM TV I/O AS OF 15MAR84')
 1040 FORMAT ('ZMIO: DOES NOT PERFORM TAPE I/O AS OF 15APR87')
 1050 FORMAT ('ZMIO: DOES NOT PERFORM TEKTRONIX I/O AS OF 15JUL87')
 1060 FORMAT ('ZMIO: INVALID BLOCK NUMBER = ',I12)
 1070 FORMAT ('ZMIO: INVALID BYTE REQUEST =',I12,' (8-BIT BYTES)')
 1080 FORMAT ('ZMIO: IMPROPER DEVICE TYPE DEVTAB(',I2,') = ',I2)
 1090 FORMAT ('ZMIO: LUN = ',I3,' NOT OPEN IN FTAB')
 1100 FORMAT ('ZMIO: INVALID BUFFER NUMBER = ',I2)
 1900 FORMAT ('ZMIO: OPER=',A4,' LUN=',I3,' BLKNO=',I10,' 8-BIT-BYTES=',
     *   I10)
      END

      SUBROUTINE ZVTPRC (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C! closes channel in server (real-tape) to client (virtual-tape)
C# Tape Z
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Close the virtual tape device channel: from receiver point of view
C   Inputs:
C      LUN    I   Logical unit number
C      FIND   I   Index in FTAB to file control block for LUN
C   Output:
C      IERR   I   Error return code: 0 => no error
C                    1 => close error or flush error
C                    2 => file already closed in FTAB
C                    3 => both errors
C                    4 => erroneous LUN
C   Generic version - uses ZVTPC3.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
C
      INTEGER   JERR
      LOGICAL   F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                       Locate LUN in FTAB.
 20   IERR = 0
      CALL LSERCH ('SRCH', LUN, FIND, F, JERR)
C                                       LUN already closed in FTAB.
      IF (JERR.NE.0) THEN
         IERR = 2
         WRITE (MSGTXT,1020) LUN
         GO TO 995
         END IF
C                                       Deassign socket
 30   CALL ZVTPC3 (FTAB(FIND+NMOFF), JERR)
      IF (JERR.NE.0) THEN
         IERR = IERR + 2
         WRITE (MSGTXT,1030) JERR
         CALL MSGWRT (7)
         END IF
C                                       Clear FTAB entry.
 40   CALL LSERCH ('CLOS', LUN, FIND, F, JERR)
C                                       LUN already closed in FTAB.
      IF (JERR.EQ.0) GO TO 999
         IERR = IERR + 2
         WRITE (MSGTXT,1040) LUN
C
 995  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('ZVTPRC: LUN = ',I2,' ALREADY CLOSED IN FTAB ON SEARCH')
 1030 FORMAT ('ZVTPRC/ZVTPC3 ERROR',I3,' DEASSIGNING THE TAPE SOCKET')
 1040 FORMAT ('ZVTPRC: LUN = ',I2,' ALREADY CLOSED IN FTAB ON CLOSE')
      END

      SUBROUTINE TABAN (OPCODE, BUFFER, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *   STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN, POLTYA,
     *   POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
C-----------------------------------------------------------------------
C! I/O to antenna tables (following initialization by ANTINI)
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2008-2009, 2013, 2016, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to Antenna tables. Usually used after setup by ANTINI.
C   Inputs:
C      OPCODE   C*4     Operation code:
C                       'READ' = read entry from table.
C                       'WRIT' = write entry in table.
C                       'CLOS' = close file, flush on write
C      BUFFER   I(512)  I/O buffer and related storage, also defines
C                       file if open. Should have been returned by
C                       ANTINI or TABINI.
C      IANRNO   I       Next scan number to read or write.
C      ANKOLS   I(14)   The column pointer array in order, ANNAME,
C                       STABXYZ, ORBPARM, NOSTA, MNTSTA, STAXOF, DIAMAN,
C                       FWHMAN, POLTYA, POLAA, POLCALA, POLTYB, POLAB,
C                       POLCALB
C      ANNUMV   I(14)   Element count in each column.
C   Input/output: (written to or read from antenna file)
C      ANNAME   C*8     Station name
C      STAXYZ   D(3)    X,Y,Z offset from array center
C      ORBPRM   D(?)    Orbital parameters.
C      NOSTA    I       Station number
C      MNTSTA   I       Mount type, 0=altaz, 1=equatorial, 2=orbiting
C                       3=X-Y (east-west, Hobart), 6 = array,
C                       4=Right-handed Nasmyth, 5=Left-handed Nasmyth
C      STAXOF   R       Axis offset
C      DIAMAN   R       Antenna diameter in meters
C      FWHMAN   R(*)    FWHM (degrees/meter) of single dish each IF
C                       scales as wavelength
C      POLTYA   C*2     Feed A feed poln. type 'R','L','X','Y'
C      POLAA    R       Feed A feed position angle.
C      POLCA    R(?)    Feed A poln. cal parameter. (note 2)
C      POLTYB   C*2     Feed B feed poln. type 'R','L','X','Y'
C      POLAB    R       Feed B feed position angle.
C      POLCB    R(?)    Feed B poln. cal parameters.
C   Output:
C      IANRNO   I       Next GAIN number.
C      IERR     I       Error code, 0=>OK else TABIO error.
C                       Note: -1=> read but record deselected.
C   Usage NOTE: use the include 'DANT.INC' for the declarations in
C   ANTINI and TABAN.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER ANBSIZ
      PARAMETER (ANBSIZ=5*MAXIF+50)
C                                       Any changes here should also be
C                                       done in DANT.INC
      INTEGER   NOSTA, MNTSTA, ANKOLS(MAXANC), ANNUMV(MAXANC), IANRNO
      CHARACTER ANNAME*8, POLTYA*2, POLTYB*2
      REAL      STAXOF, DIAMAN, FWHMAN(MAXIF), POLAA, POLCA(2*MAXIF),
     *   POLAB, POLCB(2*MAXIF)
      DOUBLE PRECISION  STAXYZ(3), ORBPRM(6)
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), IERR
C
      INTEGER   RECI(ANBSIZ), KOLS(MAXANC), NAMKOL, STAKOL, ORBKOL,
     *   NOSKOL, MNTKOL, XOFKOL, DIAKOL, FWKOL, TPAKOL, PLAKOL, PCAKOL,
     *   TPBKOL, PLBKOL, PCBKOL, NCOPY
      LOGICAL   DOREAD, DOCLOS
      REAL      RECORD(ANBSIZ)
      HOLLERITH RECH(ANBSIZ)
      DOUBLE PRECISION RECD(ANBSIZ/2)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (KOLS(1), NAMKOL), (KOLS(2), STAKOL),
     *   (KOLS(3), ORBKOL), (KOLS(4),NOSKOL), (KOLS(5), MNTKOL),
     *   (KOLS(6), XOFKOL), (KOLS(7), DIAKOL), (KOLS(8), FWKOL),
     *   (KOLS(9), TPAKOL), (KOLS(10), PLAKOL),(KOLS(11), PCAKOL),
     *   (KOLS(12),TPBKOL), (KOLS(13), PLBKOL), (KOLS(14), PCBKOL)
      EQUIVALENCE (RECD, RECORD, RECI, RECH)
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
      DOCLOS = OPCODE.EQ.'CLOS'
C                                       Branch for CLOS
      IF (DOCLOS) GO TO 800
C                                       Set pointers
      CALL COPY (14, ANKOLS, KOLS)
C                                       If write fill RECORD
      IF (.NOT.DOREAD) THEN
C                                       Antenna name
         CALL CHR2H (8, ANNAME, 1, RECH(NAMKOL))
C                                       Antenna location
         NCOPY = ANNUMV(2)
         CALL DPCOPY (NCOPY, STAXYZ, RECD(STAKOL))
C                                       Orbital parameters
         NCOPY = ANNUMV(3)
         CALL DPCOPY (NCOPY, ORBPRM, RECD(ORBKOL))
C                                       Antenna number
         RECI(NOSKOL) = NOSTA
C                                       Mount type
         RECI(MNTKOL) = MNTSTA
C                                       Axis offset
         RECORD(XOFKOL) = STAXOF
C                                       diameter
         IF (DIAKOL.GT.0) THEN
            RECORD(DIAKOL) = DIAMAN
            END IF
C                                       FWHM sd beam
         IF (FWKOL.GT.0) THEN
            NCOPY = ANNUMV(8)
            CALL RCOPY (NCOPY, FWHMAN, RECORD(FWKOL))
            END IF
C                                       Polarization type A
         RECORD(TPAKOL) = HBLANK
         CALL CHR2H (1, POLTYA, 1, RECH(TPAKOL))
C                                       Polarization angle A
         RECORD(PLAKOL) = POLAA
C                                       Polarization cal. const. A
         NCOPY = ANNUMV(11)
         CALL RCOPY (NCOPY, POLCA, RECORD(PCAKOL))
C                                       Polarization type B
         RECORD(TPBKOL) = HBLANK
         CALL CHR2H (1, POLTYB, 1, RECH(TPBKOL))
C                                       Polarization angle B
         RECORD(PLBKOL) = POLAB
C                                       Polarization cal. const. B
         NCOPY = ANNUMV(14)
         CALL RCOPY (NCOPY, POLCB, RECORD(PCBKOL))
         END IF
C                                       Process record.
      CALL TABIO (OPCODE, 0, IANRNO, RECORD, BUFFER, IERR)
      IANRNO = IANRNO + 1
      IF (IERR.GT.0) GO TO 990
C                                       If READ pick data from RECORD.
      IF (DOREAD) THEN
C                                       Antenna name
         CALL H2CHR (8, 1, RECH(NAMKOL), ANNAME)
C                                       Antenna location
         NCOPY = ANNUMV(2)
         CALL DPCOPY (NCOPY, RECD(STAKOL), STAXYZ)
C                                       Orbital parameters
         NCOPY = ANNUMV(3)
         CALL DPCOPY (NCOPY, RECD(ORBKOL), ORBPRM)
C                                       Antenna number
         NOSTA = RECI(NOSKOL)
C                                       Mount type
         MNTSTA = RECI(MNTKOL)
C                                       Axis offset
         STAXOF = RECORD(XOFKOL)
C                                       diameter
         IF (DIAKOL.GT.0) THEN
            DIAMAN = RECORD(DIAKOL)
         ELSE
            DIAMAN = 0.0
            END IF
C                                       FWHM sd beam
         IF (FWKOL.GT.0) THEN
            NCOPY = ANNUMV(8)
            CALL RCOPY (NCOPY, RECORD(FWKOL), FWHMAN)
         ELSE
            CALL RFILL (MAXIF, 0.0, FWHMAN)
            END IF
C                                       Polarization type A
         POLTYA = ' '
         CALL H2CHR (1, 1, RECH(TPAKOL), POLTYA)
C                                       Polarization angle A
         POLAA = RECI(PLAKOL)
C                                       Polarization cal. const. A
         NCOPY = ANNUMV(11)
         CALL RCOPY (NCOPY, RECORD(PCAKOL), POLCA)
C                                       Polarization type B
         POLTYB = ' '
         CALL H2CHR (1, 1, RECH(TPBKOL), POLTYB)
C                                       Polarization angle B
         POLAB = RECI(PLBKOL)
C                                       Polarization cal. const. B
         NCOPY = ANNUMV(14)
         CALL RCOPY (NCOPY, RECORD(PCBKOL), POLCB)
         END IF
      GO TO 999
C                                       Close
 800  CALL TABIO ('CLOS', 0, IANRNO, RECORD, BUFFER, IERR)
      IF (IERR.GT.0) GO TO 990
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1800) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1800 FORMAT ('TABAN: TABIO ERROR',I5)
      END

      SUBROUTINE LG2BIT (N, LGA, BITA, IDIR)
C-----------------------------------------------------------------------
C! Converts between bit arrays and logical arrays
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C      Given an N-element logical array, LGA, LG2BIT encodes the
C  logical flags as bit flags packed within an M-element integer
C  array, where M = ceil(N/NBITWD); except that when the direction
C  flag, IDIR, is nonpositive, the inverse operation is performed.
C  Input:
C      N     I    Number of flags
C      IDIR  I     Direction flag:  when IDIR>0 an array of
C                  packed bit flags is produced from an array
C                  of logical flags; otherwise an array of logical
C                  flags is produced from an array of packed bit flags.
C  Input/Output (depending on IDIR):
C      LGA   L(N)     Logical array
C      BITA  I(ceil(N/NBITWD))     Integer array of packed bit flags.
C-----------------------------------------------------------------------
      INTEGER   N, BITA(1), IDIR, BITS(64), K, KK, I, M
      LOGICAL   LGA(N), T, F
      INCLUDE 'INCS:DDCH.INC'
      DATA T, F /.TRUE., .FALSE./
C-----------------------------------------------------------------------
      M = (N-1)/NBITWD+1
      KK = 0
      IF (IDIR.LE.0) GO TO 40
C                                       Pack logical to bit array
         DO 30 K = 1,M
            DO 10 I = 1,NBITWD
               KK = KK+1
               BITS(I) = 0
               IF (LGA(KK)) BITS(I) = 1
               IF (KK.GE.N) GO TO 20
 10            CONTINUE
 20         CALL ZPTBIT (NBITWD, BITA(K), BITS)
 30         CONTINUE
         GO TO 999
C                                       Unpack bits to logical array.
 40   CONTINUE
      DO 60 K = 1,M
         CALL ZGTBIT (NBITWD, BITA(K), BITS)
         DO 50 I = 1,NBITWD
            KK = KK+1
            LGA(KK) = F
            IF (BITS(I).EQ.1) LGA(KK) = T
            IF (KK.EQ.N) GO TO 999
 50         CONTINUE
 60      CONTINUE
C
 999  RETURN
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QGRD2 (UV, VIS, WT, GRID, CONX, CONY, NO2, M, LROW)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Convolves linear polarization data onto a grid.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Convolves linear polarization visibility data into a grid.
C   It accumulates two independent visibility channels with the
C   convolution function and weighting.
C   Data is ignored if weight non-positive or the datum is too far off
C   the edge of the grid.
C   Inputs:
C      UV    I  Location of (u,v) values in cells.
C      VIS   I  Location of (complex) visibilities.
C               Expects Re1, Im1, Re2, Im2
C      WT    I  Weight for data. Assumes any tapering
C               has already been done.
C      GRID  I  base address of gridded data.
C               Order assumed to be the following
C               for each of the M rows:
C                1) 2 * LROW visibilities
C                2) 2 * LROW visibilities, Vis 2
C      CONX  I  base address of X convolving fn.
C      CONY  I  base address of Y convolving fn.
C      NO2   I  INT( (# cells used on a row) / 2 )
C      M     I  number of rows kept in the AP.
C      LROW  I  length of a row ( max. X).
C   In the above, X refers to rows and y to columns
C   in the gridded data, NOT on the sky.  The total
C   numbers of rows and cells used on a row should be odd.
C   All AP memory I/O values are assumed floating.
C   It is assumed that all values of v correspond to row M/2.
C-----------------------------------------------------------------------
      INTEGER   UV, VIS, WT, GRID, CONX, CONY,
     *   NO2, M, LROW, N, IADD, IX, IY, INCR
      INTEGER   JUV, JVIS, JWT, JGRID, JCONX, JCONY, JCX, JCY, JA, JG,
     *   JJCX, IFIX, IRND
      REAL   AIM1, AIM2, CWT, RE1, RE2, X, XX, XWT, Y, TCWT
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C     IRND(XX) = INT (XX + SIGN (0.5, XX))
      IRND(XX) = NINT(XX)
C                                        Convert addresses to 1 rel.
      JUV = UV + 1
      JVIS = VIS + 1
      JWT = WT + 1
      JGRID = GRID + 1
      JCONX = CONX + 1
      JCONY = CONY + 1
      N = NO2 * 2 + 1
C                                        Check weight.
      XWT = APCORE(JWT)
      IF (XWT.LE.0.0) GO TO 999
C                                        Determine loaction.
      X = APCORE(JUV+1)
      Y = APCORE(JUV)
C                                        Deter. conv. fn loc.
      JCX = JCONX + IRND (100. * (IRND (X)-X-0.5)) + 100
      JCY = JCONY + IRND (100. * (IRND (Y)-Y-0.5)) + 100
C                                        Determine grid loc.
      JG = JGRID
      JA = JGRID + 2 * LROW
C                                        Check end of row.
      IX = IRND (X) + LROW / 2 + 1
      IADD = LROW - NO2 - IX
      IF (IADD.GE.0) GO TO 10
C                                        Will hit end of row.
         N = N + IADD
         IF (N.LE.0) GO TO 999
C                                        Check front of row.
 10      CONTINUE
      IX = IX - NO2 - 1
      IF (IX.GE.0) GO TO 20
C                                        Will hit front of row
         N = N + IX
         IF (N.LE.0) GO TO 999
         JCX = JCX - IX * 100
         GO TO 30
C                                        Finish grid address.
 20      CONTINUE
      JA = JA + 2 * IX
      JG = JG + 2 * IX
 30   CONTINUE
C                                        Save JCX
      JJCX = JCX
C                                        Get visibility
      RE1 = APCORE(JVIS)
      AIM1 = APCORE(JVIS+1)
      RE2 = APCORE(JVIS+2)
      AIM2 = APCORE(JVIS+3)
C                                        Set increment
      INCR = 4 * LROW - 2 * N
C                                        Gridding loop
C@DIR IGNORE RECRDEPS(APCORE)
      DO 200 IY = 1,M
         JCX = JJCX
         TCWT = APCORE(JCY) * XWT
C@DIR IGNORE RECRDEPS(APCORE)
         DO 100 IX = 1,N
C                                        Compute weight.
            CWT = APCORE(JCX) * TCWT
C                                        Sum to grid.
            APCORE(JG) = APCORE(JG) + CWT * RE1
            APCORE(JG+1) = APCORE(JG+1) + CWT * AIM1
            APCORE(JA) = APCORE(JA) + CWT * RE2
            APCORE(JA+1) = APCORE(JA+1) + CWT * AIM2
C                                        Update pointers.
            JCX = JCX + 100
            JG = JG + 2
            JA = JA + 2
 100        CONTINUE
C                                        Update pointers.
         JCY = JCY + 100
         JG = JG + INCR
         JA = JA + INCR
 200     CONTINUE
C
 999  RETURN
      END

      PROGRAM POLCO
C-----------------------------------------------------------------------
C! Removed the bias from polarized intensity maps.
C# Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2008-2009, 2017
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   POLCO corrects the bias in total polarized intensity maps which
C   occurs when the Q and U maps (gaussian statistics) are combined.
C   A maximum likelihood estimator is used.
C     Inputs:
C        USERID               Owner of the image
C        INNAME(3)            Image name (name)
C        INCLASS(2)           Image name (class)
C        INSEQ                Image name (seq. #)
C        INDISK               Disk # of image
C        OUTNAME(3)           Output image name (name)
C        OUTCLASS(2)          Output image name (class)
C        OUTSEQ               Output image name (seq. #)
C        OUTDISK              Disk # of output image
C        PIXSTD               Sigma of noise distribution in Q or U map
C        PCUT                 Blank below P/sigma = PCUT
C        OPCODE               Type of blanking (zeros or magic no.)
C        BADDISK(10)          Disks to avoid for scratch
C        Neil Killeen June 1983.
C        Major revision, April 1986, to output only floating point maps
C        and increase accuracy of correction algorithm.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER DEFNAM*36, OUTNAM*36, INNAM*36, PRGNAM*6, CHTMP*4
      HOLLERITH MAP
      INTEGER   CATIN(256), CATBLK(256), LIN, LOUT, NPARMS,
     *   IERR, IER, INSL, OUTSL, NROWS, NPIX, I, J, L, IROUND, OUTVOL
      REAL   RPARM(28), CATIR(256), CATR(256), BLKVAL, NBLANK,
     *   PDATA(MAXIMG), SIGMA,  BLRAT, POVSIG, DMIN, DMAX
      DOUBLE PRECISION CATID(128), CATD(128)
C
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DITB.INC'
C
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATIN, CATIR, CATID) , (CATBLK, CATR, CATD)
C
      DATA PRGNAM /'POLCO '/
      DATA LIN, LOUT /17, 18/
C-----------------------------------------------------------------------
C                                       Start up task and get inputs
      NPARMS = 27
      IER = 0
      CALL TSKBEG (PRGNAM, NPARMS, RPARM(2), IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         GO TO 900
 10   RPARM(1) = NLUSER
C                                       Setup namestring
      CALL CHR2H (4, 'MA  ', 1, MAP)
      CALL H2WAWA (RPARM(2), RPARM(5), RPARM(7), MAP, RPARM(8),
     *   RPARM(1), INNAM)
C                                       Open input map
      CALL OPENCF (LIN, INNAM, IERR)
      IF (IERR.EQ.0) GO TO 40
         WRITE (MSGTXT,2000) IERR
         GO TO 900
C                                       Get header
 40   CALL GETHDR (LIN, CATIN, IERR)
      IF (IERR.EQ.0) GO TO 50
         WRITE (MSGTXT,2500) IERR
         GO TO 900
C                                       Create output namestrings
 50   DEFNAM = INNAM
      CALL H2WAWA (RPARM(9), RPARM(12), RPARM(14), MAP, RPARM(15),
     *   RPARM(1), OUTNAM)
C                                       Create output map header
      DO 60  I = 1,256
         CATBLK(I) = CATIN(I)
 60      CONTINUE
C                                       Fill bad disk array
      DO 65 I = 1, 10
         IBAD(I) = IROUND (RPARM(I+18))
 65      CONTINUE
C                                       Create output map
      CALL MAPCR (DEFNAM, OUTNAM, CATBLK, IERR)
      IF (IERR.EQ.0) GO TO 70
         WRITE (MSGTXT,3000) IERR
         GO TO 900
C                                       Open output map
 70   CALL OPENCF (LOUT, OUTNAM, IERR)
      IF (IERR.EQ.0) GO TO 80
         WRITE (MSGTXT,4000) IERR
         GO TO 990
C                                       Get some parameters
 80   INSL = FILTAB(POCAT,6)
      OUTSL = FILTAB(POCAT,7)
      OUTVOL = FILTAB(POVOL,7)
      NPIX = CATIN(KINAX)
      NROWS = CATIN(KINAX+1)
      SIGMA = RPARM(16)
      BLRAT = RPARM(17)
C                                       Min  PCUT = 2-sigma
      WRITE (MSGTXT,4500) BLRAT
      CALL MSGWRT (8)
C                                       Set up blanks counter & extrema
      NBLANK = 0.0
      CALL H2CHR (4, 1, RPARM(18), CHTMP)
      IF (CHTMP.EQ.'ZERO') THEN
         BLKVAL = 0.0
      ELSE
         BLKVAL = INDEF
         END IF
      DMIN = 1.0E30
      DMAX = -1.0
C                                       Loop over rows
      DO 160 J = 1, NROWS
C                                       Read in a row of data
        CALL MAPIO ('READ', LIN, PDATA, IERR)
        IF (IERR.EQ.0) GO TO 120
           WRITE (MSGTXT,5000) J,IERR
           GO TO 900
C                                       Loop over row pixels
 120      DO 140  L = 1,NPIX
             IF (PDATA(L).EQ.INDEF) THEN
                PDATA(L) = BLKVAL
             ELSE
                POVSIG = PDATA(L) / SIGMA
C                                       Make the correction
                IF (POVSIG.GT.BLRAT) THEN
                   CALL MAXLIK (PDATA(L), POVSIG)
                   IF (PDATA(L).NE.INDEF) THEN
                      DMAX = MAX (DMAX, PDATA(L))
                      DMIN = MIN (DMIN, PDATA(L))
                   ELSE
                      PDATA(L) = BLKVAL
                      END IF
C                                       P/sig < min val, pixel blanked
                ELSE
                   PDATA(L) = BLKVAL
                   END IF
                END IF
             IF (PDATA(L).EQ.BLKVAL) NBLANK = NBLANK + 1.0
 140         CONTINUE
C                                       Write output row
        CALL MAPIO ('WRIT', LOUT, PDATA, IERR)
        IF (IERR.EQ.0) GO TO 150
           WRITE (MSGTXT,6000) J,IERR
           GO TO 900
 150       CONTINUE
 160  CONTINUE
C                                       Update header and close maps
      IF (NBLANK.GT.0.5 .AND. BLKVAL.NE.INDEF) DMIN = 0.0
      CATR(KRDMN) = DMIN
      CATR(KRDMX) = DMAX
      IF (BLKVAL.EQ.INDEF .AND. NBLANK.GT.0.5) CATR(KRBLK) = INDEF
      CALL CATIO ('UPDT', OUTVOL, OUTSL, CATBLK, 'REST', WBUFF, IERR)
      CALL FILCLS (LIN)
      CALL FILCLS (LOUT)
C                                       Tell user how many pixels
C                                       blanked
      WRITE (MSGTXT,7000) NBLANK
      CALL MSGWRT (8)
C                                       Add history file
      CALL POLCHI (INNAM, OUTNAM, INSL, OUTSL, SIGMA, BLRAT, IERR)
      IF (IERR.EQ.0) GO TO 180
         WRITE (MSGTXT,9000) IERR
         GO TO 900
 180  CALL CLENUP
      GO TO 990
C                                       Error return
 900  IER = 1
      CALL MSGWRT (8)
      CALL CLENUP
C                                       Normal return
 990  CALL TSKEND (IER)
      STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('TSKBEG:COULD NOT GET INPUTS. IERR = ',I6)
 2000 FORMAT ('OPENCF:COULD NOT OPEN INPUT MAP. IERR = ',I6)
 2500 FORMAT ('GETHDR:COULD NOT READ IN HEADER. IERR = ',I6)
 3000 FORMAT ('MAPCR:COULD NOT CREATE OUTPUT MAP. IERR = ',I6)
 4000 FORMAT ('OPENCF:COULD NOT OPEN OUTPUT MAP. IERR = ',I6)
 4500 FORMAT ('Blanking below ',F6.2,'-sigma')
 5000 FORMAT ('MAPIO:COULD NOT READ LINE # ',I5,'IERR = ',I6)
 6000 FORMAT ('MAPIO:COULD NOT WRITE LINE # ',I5,'IERR = ',I6)
 7000 FORMAT ('There are ', 1PE13.6,' blank pixels in the output image')
 9000 FORMAT ('POLCHI:COULD NOT MAKE HISTORY FILE. IERR = ',I6)
      END
      SUBROUTINE MAXLIK (P, RAT)
C-----------------------------------------------------------------------
C   MAXLIK estimates the intrinsic total polarized intensity from the
C   observed total polarized intensity with the maximum likelihood
C   estimator (see Killeen, Bicknell, and Ekers, ApJ, 1986, 302, 306).
C   The m.l. solution is not analytic. This subroutine uses an
C   asymptotic solution with an empirically determined correction.
C   when RAT >=2.  Otherwise, it uses a Wardle and Kronberg estimation
C   intended mostly to give a better estimate of the noise.
C    Inputs:
C        P               R     On input, P is the observed total
C                              polarized intensity
C        RAT             R     The ratio of the observed total polarized
C                              intensity to the standard deviation of
C                              the (assumed equal) Gaussian
C                              distributions of the Stokes Q or U maps.
C                              It is assumed that RAT>=2.
C    Output:
C        P               R     On output, P is the estimated intrinsic
C                              total polarized intensity.
C-----------------------------------------------------------------------
      REAL   P, RAT, DELTA, C(4), L2, L3, L4, PFAC
      INCLUDE 'INCS:DDCH.INC'
      DATA C /1.283, -12.586, 13.858, -7.686/
C-----------------------------------------------------------------------
      IF (RAT.GE.2.0) THEN
         L2 = LOG10 (RAT)
         L3 = L2 * L2
         L4 = L2 * L3
         PFAC = SQRT (1.0 - (1.0 / (RAT*RAT)))
C
         IF (RAT.GE.5.0) THEN
            DELTA = 0.0
            P = P * PFAC
         ELSE
            DELTA = 10.0**(C(1) + C(2) * L2 + C(3) * L3 + C(4) * L4)
            P = P * (PFAC - DELTA)
            END IF
      ELSE IF (RAT.GT.0.0) THEN
         PFAC = 1.0 - (1.2 / RAT) ** 2
         IF (PFAC.GE.0.0) THEN
            PFAC = SQRT (PFAC)
         ELSE
            PFAC = -SQRT(-PFAC)
            END IF
         P = PFAC * P
      ELSE
         P = FBLANK
         END IF
C
      RETURN
      END
      SUBROUTINE POLCHI (INNAM, OUTNAM, INSL, OUTSL, SIGMA, BLRAT, IERR)
C-----------------------------------------------------------------------
C        POLCHI creates and writes the HI file for the task POLCO
C    Inputs:
C        INNAM(9)         C*36  Input map namestring
C        OUTNAM(9)        C*36  Output map namestring
C        INSL             I     Slot number for input map
C        OUTSL            I     Slot number for output map
C        SIGMA            R     Input sigma on Q or U map
C        BLRAT            R     Blank below P/sigma = BLRAT
C   Outputs:
C        IERR             I     Error return
C                               0-> okay
C                               1-> no good
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6, INNAM*36, OUTNAM*36, HILINE*72,
     *   INAME*12, ICLASS*6, ONAME*12, OCLASS*6, PTYPE*2
      INTEGER   IER, IERR, NHISTF, LHIN, LHOUT, INSL, OUTSL, IVOL, OVOL,
     *   IBUFF1(256), IBUFF2(256), CATBLK(256), ISEQ, OSEQ, USID
      REAL      BLRAT, SIGMA
      LOGICAL   T
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      COMMON /MAPHDR/ CATBLK
      DATA NHISTF /2/, LHIN, LHOUT /27, 28/
      DATA PRGNAM /'POLCO '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init HI
      CALL HIINIT (NHISTF)
      IER = 0
      CALL WAWA2A (INNAM, INAME, ICLASS, ISEQ, PTYPE, IVOL, USID)
      CALL WAWA2A (OUTNAM, ONAME, OCLASS, OSEQ, PTYPE, OVOL, USID)
C                                       copy some keywords
      CALL KEYPCP (IVOL, INSL, OVOL, OUTSL, 0, ' ', IERR)
C                                       Copy old to new
      CALL HISCOP (LHIN, LHOUT, IVOL, OVOL, INSL, OUTSL, CATBLK, IBUFF1,
     *   IBUFF2, IERR)
      IF (IERR.LT.3) GO TO 10
         WRITE (MSGTXT,500) IERR
         GO TO 900
C                                       Add INNAME
 10   CALL HENCO1 (PRGNAM, INAME, ICLASS, ISEQ, IVOL, LHOUT, IBUFF2,
     *   IERR)
       IF (IERR.EQ.0) GO TO 20
          WRITE (MSGTXT,1000) IERR
          GO TO 900
C                                       Add OUTNAME
 20   CALL HENCOO (PRGNAM, ONAME, OCLASS, OSEQ, OVOL, LHOUT, IBUFF2,
     *   IERR)
      IF (IERR.EQ.0) GO TO 30
         WRITE (MSGTXT,2000) IERR
         GO TO 900
C                                       Now add sigma
 30   WRITE (HILINE,3000) PRGNAM, SIGMA
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      IF (IERR.EQ.0) GO TO 40
         WRITE (MSGTXT,3500) IERR
         GO TO 900
C                                       Now add blrat
 40   WRITE (HILINE,4000) PRGNAM, BLRAT
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      IF (IERR.EQ.0) GO TO 950
         WRITE (MSGTXT,5000) IERR
 900  CALL MSGWRT (8)
 950  CALL HICLOS (LHOUT, T, IBUFF2, IERR)
 999  RETURN
C-----------------------------------------------------------------------
  500 FORMAT ('HISCOP: SERIOUS ERROR COPYING OLD HISTORY FILE TO NEW. ',
     *   ' IERR = ',I3)
 1000 FORMAT ('HENCO1: COULD NOT WRITE INNAME ETC. TO HISTORY FILE.',
     *   ' IERR = ',I3)
 2000 FORMAT ('HENCOO: COULD NOT WRITE OUTNAME ETC. TO HISTORY FILE.',
     *   ' IERR = ',I3)
 3000 FORMAT (A6, 1X, '  SIGMA =',1PE13.6)
 3500 FORMAT ('HIADD: COULD NOT ADD SIGMA TO HISTORY FILE. IERR = ', I3)
 4000 FORMAT (A6, 1X, '  PCUT = ', 1PE10.3)
 5000 FORMAT ('HIADD: COULD NOT ADD PCUT TO HISTORY FILE. IERR = ', I3)
      END

      SUBROUTINE SDCGET (TIME, IERR)
C-----------------------------------------------------------------------
C! Sets up to interpolate in Single dish calibration (CS) table.
C# SDish Calibration EXP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Single dish calibration routine
C    Sets up for interpolation in cal (CS) table, reads values from cal
C    table.  Assumes only valid, selected data in open cal table.
C    Uses calls to TABIO directly for efficiency.
C     Inputs:
C      TIME         R    Current data time.
C     Inputs from common /SELCAL/:
C      CLBUFF(*)    I    Cal table I/O TABIO buffer
C      ICLRNO       I    Current cal record number
C      NCLINR       I    Number of cal records in file.
C      NUMANT       I    Number of beams
C      NUMPOL       I    Number of IFs per group (polarizations)
C      NUMIF        I    Number of IFs.
C     Output:
C      IERR         I    Return error code 0=>OK, else failed.
C     Output to common /SELCAL/:
C      CALTAB(*,2)  R    Cal. table from cal table file
C                        Values in order:
C                        By beam (NUMANT)
C                           By IF (NUMIF)
C                              By Polarization (NUMPOL)
C                                  Amplitude factor,
C                                  offset (before factor)
C                                  RA correction
C                                  Dec correction.
C      LCLTAB       I   Number of values in CALTAB per entry (4)
C      CALTIM(3)    R    Time of two cal. entries; third value is
C                        time of current values.
C      ICALP1       I    Pointer in CALTAB, CALTIM to previous time.
C      ICALP2       I    Pointer in CALTAB, CALTIM to next time.
C-----------------------------------------------------------------------
      INTEGER   IERR, BEMNO, IFNO, LGREC,
     *   LGRECF, TIMKOL, RAKOL, DECKOL, BEMKOL, SUBKOL,
     *   F1KOL, O1KOL, RF1KOL, DF1KOL, F2KOL, O2KOL, RF2KOL, DF2KOL,
     *   RECI(1), IFOFF, I, INDEX, LIMIT, NBLANK
      LOGICAL   T, F, GOT1
      REAL      TIME
      DOUBLE PRECISION    RECD(1), CURTIM
      INCLUDE 'INCS:PUVD.INC'
      REAL     RECR(5+8*MAXIF)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (RECI, RECR, RECD)
      EQUIVALENCE (CLKOLS(1), TIMKOL),
     *   (CLKOLS(2),RAKOL), (CLKOLS(3), DECKOL),
     *   (CLKOLS(4),BEMKOL), (CLKOLS(5), SUBKOL),
     *   (CLKOLS(6), F1KOL), (CLKOLS(7),O1KOL),
     *   (CLKOLS(8), RF1KOL), (CLKOLS(9), DF1KOL),
     *   (CLKOLS(10), F2KOL), (CLKOLS(11),O2KOL),
     *   (CLKOLS(12), RF2KOL), (CLKOLS(13), DF2KOL)
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Check if first call
      IF (ICALP2.LE.0) THEN
C                                       Blank fill CALTAB
         NBLANK = NUMANT * (EIF-BIF+1) * NUMPOL * LCLTAB
         DO 40 I = 1,NBLANK
            CALTAB(I,1) = FBLANK
            CALTAB(I,2) = FBLANK
 40         CONTINUE
C                                       Read until selected time.
         LGREC = NUMPOL * LCLTAB
         LGRECF = LGREC * (EIF - BIF + 1)
         ICALP1 = 2
         ICALP2 = 1
         GOT1 = F
         LIMIT = ICLRNO
         DO 90 I = LIMIT,NCLINR
            ICLRNO = I
            CALL TABIO ('READ', 0, ICLRNO, RECR, CLBUFF, IERR)
            IF (IERR.LT.0) GO TO 90
            IF (IERR.NE.0) GO TO 990
C                                       Check SUBARRAY
            IF ((RECI(SUBKOL).NE.SUBARR) .AND. (RECI(SUBKOL).GT.0))
     *         GO TO 90
C                                       See if time past data time.
            IF (RECR(TIMKOL).GT.TIME) GO TO 100
C                                       Fill in values
            GOT1 = T
            CALTIM(1) = RECR(TIMKOL)
C                                       Loop over IF
            BEMNO = RECI(BEMKOL)
            DO 80 IFNO = BIF,EIF
               IFOFF = IFNO - 1
               INDEX = LGRECF * (BEMNO-1) +  LGREC * (IFNO-BIF) + 1
               CALTAB(INDEX,1) = RECR(F1KOL+IFOFF)
               CALTAB(INDEX+1,1) = RECR(O1KOL+IFOFF)
               CALTAB(INDEX+2,1) = RECR(DF1KOL+IFOFF)
               CALTAB(INDEX+3,1) = RECR(RF1KOL+IFOFF)
C                                       Second polarization
               IF (NUMPOL.GT.1) THEN
                  INDEX = INDEX + LCLTAB
                  CALTAB(INDEX,1) = RECR(F2KOL+IFOFF)
                  CALTAB(INDEX+1,1) = RECR(O2KOL+IFOFF)
                  CALTAB(INDEX+2,1) = RECR(RF2KOL+IFOFF)
                  CALTAB(INDEX+3,1) = RECR(DF2KOL+IFOFF)
                  END IF
 80            CONTINUE
 90         CONTINUE
C                                       After time, see if have before
C                                       Only have cal after data time.
 100     IF (.NOT.GOT1) THEN
            ICALP1 = -1
            ICALP2 = 1
            GO TO 310
            END IF
         END IF
C                                       Next record
C                                       Initialize CALTAB
 300  ICALP1 = ICALP2
      ICALP2 = 3 - ICALP2
C                                       Check if Cal. table exhausted,
C                                       If so just mark tables,
      IF (ICLRNO.GE.NCLINR) ICALP2 = -1
      IF (ICLRNO.GE.NCLINR) GO TO 999
C                                       Blank fill table
 310  NBLANK = NUMANT * (EIF-BIF+1) * NUMPOL * LCLTAB
      DO 340 I = 1,NBLANK
         CALTAB(I,ICALP2) = FBLANK
 340     CONTINUE
      LIMIT = ICLRNO
      DO 390 I = LIMIT,NCLINR
         ICLRNO = I
         CALL TABIO ('READ', 0, ICLRNO, RECR, CLBUFF, IERR)
         IF (IERR.LT.0) GO TO 390
         IF (IERR.NE.0) GO TO 990
C                                       Check SUBARRAY
         IF ((RECI(SUBKOL).NE.SUBARR) .AND. (RECI(SUBKOL).GT.0) .AND.
     *      (SUBARR.NE.0)) GO TO 390
         IF (I.EQ.LIMIT) CURTIM = RECR(TIMKOL)
C                                       See if time past data time.
         IF (RECR(TIMKOL).GT.CURTIM) GO TO 400
         CALTIM(ICALP2) = CURTIM
C                                       Fill in values
         GOT1 = T
C                                       Loop over IF
         BEMNO = RECI(BEMKOL)
         DO 380 IFNO = BIF,EIF
            IFOFF = IFNO - 1
            INDEX = LGRECF * (BEMNO-1) +  LGREC * (IFNO-BIF) + 1
            CALTAB(INDEX,ICALP2) = RECR(F1KOL+IFOFF)
            CALTAB(INDEX+1,ICALP2) = RECR(O1KOL+IFOFF)
            CALTAB(INDEX+2,ICALP2) = RECR(RF1KOL+IFOFF)
            CALTAB(INDEX+3,ICALP2) = RECR(DF1KOL+IFOFF)
            IF (NUMPOL.LE.1) GO TO 360
C                                       Second polarization
               INDEX = INDEX + LCLTAB
               CALTAB(INDEX,ICALP2) = RECR(F2KOL+IFOFF)
               CALTAB(INDEX+1,ICALP2) = RECR(O2KOL+IFOFF)
               CALTAB(INDEX+2,ICALP2) = RECR(RF2KOL+IFOFF)
               CALTAB(INDEX+3,ICALP2) = RECR(DF2KOL+IFOFF)
 360           CONTINUE
 380        CONTINUE
 390     CONTINUE
C                                       Finished file
      ICLRNO = NCLINR
      GO TO 999
C                                       Check if correct time
 400  IF (CURTIM.LT.TIME) GO TO 300
      GO TO 999
C                                       TABIO error
 990  WRITE (MSGTXT,1400) IERR
C                                       Error
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1400 FORMAT ('SDCGET: ERROR ',I3,' READING CALIBRATION TABLE')
      END

      SUBROUTINE LPCLOS (LUN, FIND, LINES, IERR)
C-----------------------------------------------------------------------
C! closes open line printer operation (actual printer, file, terminal)
C# IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2007, 2016
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Close the file associated with LUN removing any exclusive use state
C   and clear the FTAB entry for the LUN.
C   Inputs:
C      LUN      I        Logical unit number
C      FIND     I        Index in FTAB to file control block for LUN
C      LINES    I        Number of lines printed in current page
C                        < 0 -> do NOT print on line printer
C   Output:
C      IERR     I        Error return code: 0 => no error
C                           1 => close error
C                           2 => file already closed in FTAB
C                           3 => both errors
C                           4 => erroneous LUN
C   92.01.15 PPM: MAP never initialized.  Screws up if it happened to be
C                 .true. (on HP's).
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, LINES, IERR
C
      INTEGER   JERR, I, J
      LOGICAL   MAP
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
C-----------------------------------------------------------------------
C                                       Make sure this is false!!!
      MAP = .FALSE.
C                                       Line printer?
      IF (LUN.EQ.1) THEN
         IF (LINES.GE.0) THEN
            CALL ZENDPG (LINES)
            CALL ZLPCLS (LUN, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) 'ZLPCLS', IERR
               CALL MSGWRT (7)
               IERR = 1
               END IF
         ELSE
            IERR = 0
            END IF
C                                       Terminal
      ELSE IF (LUN.EQ.5) THEN
         CALL ZTTCLS (LUN, FIND, IERR)
         IF (IERR.NE.0) THEN
            IF (FTAB(FIND+1+NFCBER).GT.0) THEN
               CALL ZERROR ('ZTTCLS', FTAB(FIND+1+NFCBER), ' ', -999,
     *            .FALSE.)
            ELSE
               WRITE (MSGTXT,1000) 'ZTTCLS', IERR
               CALL MSGWRT (7)
               END IF
            IERR = 1
            END IF
C                                       Text file
      ELSE IF (LUN.EQ.3) THEN
         CALL ZTXCLS (LUN, FIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) 'ZTXCLS', IERR
            CALL MSGWRT (7)
            END IF
         GO TO 999
C                                       Unknown Fortran device LUN.
      ELSE
         WRITE (MSGTXT,1010) LUN
         IERR = 4
         GO TO 995
         END IF
C                                       Clear FTAB entry for LUN 1, 5.
      CALL LSERCH ('CLOS', LUN, FIND, MAP, JERR)
      IF (JERR.NE.0) THEN
         IERR = IERR + 2
         WRITE (MSGTXT,1100) LUN
         GO TO 995
         END IF
      CALL FSERCH (FIND, I, J, JERR)
      IF (JERR.EQ.0) THEN
         IF (I.EQ.1) DEVNAM(J) = ' '
         IF (I.EQ.2) NONNAM(J) = ' '
         IF (I.EQ.3) MAPNAM(J) = ' '
         END IF
      GO TO 999
C
 995  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('LPCLOS: ',A,' RETURNS ERROR = ',I4)
 1010 FORMAT ('LPCLOS: UNKNOWN FORTRAN DEVICE.  LUN = ',I2)
 1100 FORMAT ('LPCLOS: LUN = ',I2,' ALREADY CLOSED IN FTAB ON CLOSE')
      END

      SUBROUTINE FOINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IFORNO, FOKOLS, FONUMV, NUMANT, NUMIF, IERR)
C-----------------------------------------------------------------------
C! Creates/opens/initializes frequency offset (FO) table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2009, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes frequency offset extension tables.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                           'WRIT' = create/init for write or read
C                           'READ' = open for read only
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                           file if open.
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      VER      I        FO file version
C      CATBLK   I(256)   Catalog header block.
C      LUN      I        Logical unit number to use
C   Input/output
C      NUMANT   I        Number of antennas
C      NUMIF    I        Number of IF pairs
C   Output:
C      ICLRNO   I        Next scan number, start of the file if 'READ',
C                           the last+1 if WRITE
C      CLKOLS   I(6)     The column pointer array in order
C      CLNUMV   I(6)     Element count in each column.
C      IERR     I        Return error code, 0=>OK, else TABINI or TABIO
C                           error.
C-----------------------------------------------------------------------
      INTEGER   MAXFOC
      PARAMETER (MAXFOC = 7)
C
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, IFORNO,
     *   FOKOLS(MAXFOC), FONUMV(MAXFOC), NUMANT, NUMIF, IERR
C
      HOLLERITH HOLTMP(6)
      CHARACTER TTITLE*56, TITLE(MAXFOC)*24, UNITS(MAXFOC)*8, KEYW(3)*8
      INTEGER   NKEY, NREC, DATP(128,2), NCOL, NTT, DTYP(MAXFOC), NDATA,
     *   KLOCS(3), KEYVAL(3), IPOINT, JERR, J, KEYTYP(3), I, REVNO,
     *   MSGSAV, NC, JTRIM, FOREVN, ITEMP(6)
      LOGICAL   T, DOREAD, NEWFIL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (HOLTMP, ITEMP)
      DATA T /.TRUE./
      DATA TTITLE /'AIPS UV DATA FILE FREQUENCY OFFSET TABLE'/
C                                       Values >10 are scalar
      DATA DTYP /11,12,4*14,2/
C                                       NOTE: Change PCLTAB.INC when
C                                       changing the table columns.
      DATA TITLE /'TIME', 'TIME INTERVAL', 'SOURCE ID', 'ANTENNA NO.',
     *   'SUBARRAY', 'FREQ ID', 'DOPPOFF'/
      DATA KEYW /'NO_ANT', 'NO_IF', 'REVISION'/
      DATA UNITS /'DAYS','DAYS', 4*' ', 'HZ'/
      DATA FOREVN /1/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NREC = 1000
      NCOL = MAXFOC
      IF (DOREAD) NCOL = 0
      NKEY = 3
      NDATA = MAXFOC
      CALL FILL (NDATA, 0, FOKOLS)
      CALL FILL (NDATA, 0, FONUMV)
C                                       Fill in types
      IF (.NOT.DOREAD) THEN
         CALL COPY (NDATA, DTYP, DATP(1,2))
         DO 10 J = 1,NDATA
            IF (DTYP(J).LT.10) DATP(J,2) = DTYP(J) + 10 * NUMIF
 10         CONTINUE
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'FO', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'CALINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
C                                       Get number of records
      IFORNO = BUFFER(5) + 1
      IF (DOREAD) IFORNO = 1
      NKEY = 3
      MSGSAV = MSGSUP
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 40 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'CALINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'CALINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         NTT = JTRIM (TTITLE)
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       Set keyword values
C                                       No. antennas.
         KLOCS(1) = 1
         KEYTYP(1) = 4
         KEYVAL(1) = NUMANT
C                                       No. IFs
         KLOCS(2) = 2
         KEYTYP(2) = 4
         KEYVAL(2) = NUMIF
C                                       Revision number from PCLTAB.INC
         REVNO = FOREVN
         KLOCS(3) = IPOINT
         KEYTYP(3) = 4
         KEYVAL(3) = REVNO
C                                       Only write if just created.
         CALL TABKEY (OPCODE, KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'CALINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         MSGSUP = 32000
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         MSGSUP = MSGSAV
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'CALINI', IERR)
            GO TO 990
            END IF
C                                       Retrieve keyword values
C                                       No. antennas.
         IPOINT = KLOCS(1)
         IF (IPOINT.GT.0) NUMANT = KEYVAL(IPOINT)
C                                       No. IF pairs
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       Revision level
         IPOINT = KLOCS(3)
         REVNO = -1
         IF (IPOINT.GT.0) REVNO = KEYVAL(IPOINT)
         END IF
C                                       Get array indices
C                                       Cover your ass from FNDCOL -
C                                       close to flush the buffers and
C                                       then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KEYVAL, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'CALINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'FO', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'CALINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (MAXFOC, TITLE, 24, T, BUFFER, FOKOLS, JERR)
C                                      Get array indices and no. values
      NCOL = MAXFOC
      DO 150 I = 1,NCOL
         IPOINT = FOKOLS(I)
         IF (IPOINT.GT.0) THEN
            FOKOLS(I) = DATP(IPOINT,1)
            FONUMV(I) = DATP(IPOINT,2) / 10
            IF (FONUMV(I).LE.0) THEN
               NC = JTRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            FOKOLS(I) = -1
            FONUMV(I) = 0
            NC = JTRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('FOINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('FOINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('FOINI: ERROR INITIALIZING CALIBRATION TABLE FOR ',A4)
      END

      SUBROUTINE GRAYPX (NPIX, IANGL, IVALS, BUFF, IERR)
C-----------------------------------------------------------------------
C! writes an array of grey values into a plot file or to the TV
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GRAYPX places a "write string of gray values" command in the
C   graphics file.  The gray values are clipped using range given in the
C   call to GINITG and placed in graphics file.  The command form is:
C            I          opcode (7)
C            I          NPIX: number of values
C            I          IANGL; 0 horizontal, 1 vertical
C            I(NPIX)    clipped gray values
C   NOTE: this command may extend over more than 1 physical record
C   in the file!!!!!!!!!!
C   May go to TV in that mode instead.
C   Inputs:
C      NPIX   I          number of pixel values
C      IANGL  I          direction code: 0 horizontal, 1 vertical
C      IVALS  I(NPIX)    pixel values
C   In/out:
C      BUFF   I(256)     graphics working buffer
C   Output:
C      IERR   I          error code:  0 => ok
C                                     1 => disk error
C                                     2 => input data error
C-----------------------------------------------------------------------
      INTEGER   NPIX, IANGL, IVALS(*), BUFF(256), IERR
C
      INTEGER   OPCODE, NEED, I, IER, JANGL, MPIX, LPIX
      REAL      GROFF, GRSCAL
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA OPCODE, NEED /7, 254/
C-----------------------------------------------------------------------
      IERR = 0
      IF (NPIX.LE.0) GO TO 999
      IF (GPHTHI.LE.GPHTLO) THEN
         IERR = 2
         WRITE (MSGTXT,1000)
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Plot file
      IF (.NOT.GPHDOT) THEN
C                                        write record if needed
         IERR = 1
         IF (GPHPOS.GE.NEED) THEN
            CALL GPHWRT (BUFF, IER)
            IF (IER.NE.0) GO TO 999
            END IF
C                                        add variables
         BUFF(GPHPOS+1) = OPCODE
         BUFF(GPHPOS+2) = NPIX
         BUFF(GPHPOS+3) = IANGL
         GPHPOS = GPHPOS + 3
C                                        add gray vals: write rec as
C                                        needed
         DO 20 I = 1,NPIX
            IF (GPHPOS.GE.256) THEN
               CALL GPHWRT (BUFF, IER)
               IF (IER.NE.0) GO TO 999
               END IF
            GPHPOS = GPHPOS + 1
            BUFF(GPHPOS) = MAX (GPHTLO, MIN (GPHTHI, IVALS(I)))
 20         CONTINUE
         IERR = 0
C                                       TV
      ELSE
         GROFF = GPHTLO
         GRSCAL = REAL (MAXINT) / (REAL (GPHTHI) - REAL (GPHTLO))
C                                       NOTE: plot file angle 1 => 3
         JANGL = IANGL
         IF (JANGL.EQ.1) JANGL = 3
         MPIX = NPIX
         GPHNGR = GPHNGR + 1
C                                        update catalog, screen
         CALL GCINIT (GPHTVC(1), 0, IERR)
         TVSUBR = 'GCINIT'
         IF (IERR.NE.0) GO TO 960
         LPIX = 1
         DO 110 I = 1,MPIX
            GPHSCR(I) = MAX (GPHTLO, MIN (GPHTHI, IVALS(I)))
            GPHSCR(I) = (GPHSCR(I) - GROFF) * GRSCAL + 0.5
 110        CONTINUE
         IF (JANGL.EQ.0) THEN
            IF ((GPHIYL.LT.1) .OR. (GPHIYL.GT.MAXXTV(2))) THEN
               GPHERG = GPHERG + 1
               GO TO 999
               END IF
            IF (GPHIXL+MPIX-1.GT.MAXXTV(1)) THEN
               GPHERG = GPHERG + 1
               MPIX = MAXXTV(1) + 1 - GPHIXL
               END IF
            IF (GPHIXL.LE.0) THEN
               LPIX = 2 - GPHIXL
               MPIX = MPIX - LPIX + 1
               GPHERG = GPHERG + 1
               END IF
         ELSE IF (JANGL.EQ.3) THEN
            IF ((GPHIXL.LT.1) .OR. (GPHIXL.GT.MAXXTV(1))) THEN
               GPHERG = GPHERG + 1
               GO TO 999
               END IF
            IF (GPHIYL-MPIX+1.LT.1) THEN
               GPHERG = GPHERG + 1
               MPIX = GPHIYL
               END IF
            IF (GPHIYL.GT.MAXXTV(2)) THEN
               LPIX = GPHIYL - MAXXTV(2) + 1
               MPIX = MPIX - LPIX + 1
               GPHERG = GPHERG + 1
               END IF
            END IF
         IF (MPIX.LE.0) GO TO 999
C                                        send to TV
         CALL YIMGIO ('WRIT', GPHTVC, GPHIXL, GPHIYL, JANGL, MPIX,
     *      GPHSCR(LPIX), IERR)
         TVSUBR = 'YIMGIO'
         IF (IERR.NE.0) GO TO 960
         GPHCNT = GPHCNT + 8
         IF (GPHCNT.GT.5000) THEN
            CALL YHOLD ('OFFF', IER)
            CALL YHOLD ('ONNN', IER)
            GPHCNT = 0
            END IF
         END IF
      GO TO 999
C                                       TV error
 960  WRITE (MSGTXT,1960) TVSUBR, IERR
      CALL MSGWRT (7)
      IERR = 2
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GRAYPX: GINITG WAS NOT CALLED')
 1960 FORMAT ('GRAYPX: TV ROUTINE ',A,' RETURNS ERROR',I5)
      END

      SUBROUTINE COLORH (NLEVS, STEPS, LOOPS, LITE, SATUR, HUE, GAMMA,
     *   IERR)
C-----------------------------------------------------------------------
C! writes OFM with color contour helix in lightness-hue-saturation space
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2008
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   COLORH uses an STC algorithm to produce color contouring along a
C   helix in the lightness-hue-saturation space.
C   Inputs:
C      NLEVS   I          number of intensities (256 or 1024)
C      STEPS   I          number of output colors (1 - 1024)
C      LOOPS   I          number of loops of helix
C      LITE    R(2)       min,max lightness (0.-100.)
C      SATUR   R(2)       min,max saturation (0.-100.)
C      HUE     R          start hue in degrees (0-360.)
C      GAMMA   R          gamma correction power (2.7 or 1.8 ok?)
C   Output:
C      IERR    I          error code of ZM70XF
C-----------------------------------------------------------------------
      INTEGER    NLEVS, STEPS, LOOPS, IERR
      REAL       LITE(2), SATUR(2), HUE, GAMMA
C
      INCLUDE 'INCS:PTVC.INC'
      INTEGER    NSTEPS, NLOOPS, IWID, KOLR, ISTRT, IT, NSTEP, LEVS, NW
      REAL       HSTEP, ZSTEP1, ALPHA, BETA, GAMINV, H, DTOR, Z, X, S,
     *   A, B, L, Y3, Y, COLR, COLX(3), COLY(3), COLZ(3), LBUF(TVMOFM,3)
      LOGICAL     VRTRTC
      INCLUDE 'INCS:DTVC.INC'
      DATA  COLX /  0.125, -1.090,  2.580/,
     *      COLY / -0.295,  2.040, -1.150/,
     *      COLZ /  1.170,  0.058, -0.422/
      DATA VRTRTC, DTOR /.TRUE., 0.017452393/
C-----------------------------------------------------------------------
C                                        check input some
      IERR = 2
      IF (GAMMA.LE.0.0) GO TO 999
      NW = TVMOFM
      LEVS = MIN (OFMINP+1, NLEVS)
      IF (LEVS.LT.32) LEVS = LUTOUT + 1
      IF (LEVS.GT.OFMINP+1) LEVS = OFMINP + 1
      NSTEPS = MAX (2, MIN (LEVS, STEPS))
      NLOOPS = MAX (1, MIN (256, LOOPS))
C
      HSTEP =  (DTOR * 360.0 * NLOOPS) / NSTEPS
      ZSTEP1 = NSTEPS - 1
      ALPHA = (LITE(2) - LITE(1)) / ZSTEP1
      BETA = SATUR(2) - SATUR(1)
      IWID = LEVS / NSTEPS
      GAMINV = 1.0 / GAMMA
      IT = OFMINP + 1
      CALL RFILL (IT, 0.0, LBUF(1,1))
      CALL RFILL (IT, 0.0, LBUF(1,2))
      CALL RFILL (IT, 0.0, LBUF(1,3))
C                                           loop over steps
      ISTRT = 1
      H = HUE * DTOR - HSTEP
      DO 20 NSTEP = 1,NSTEPS
         Z = NSTEP - 1
         X = (Z+Z) / ZSTEP1 - 1.0
         S = BETA * (1.0-X*X) + SATUR(1)
         H = H + HSTEP
         A = S * COS(H)
         B = S * SIN(H)
         L = ALPHA * Z  +  LITE(1)
C                                           LAB colors to RGB colors
         Y3 = (L + 16.0) / 116.0
         Y = Y3 ** 3
         X = (A/500.0 + Y3) ** 3
         Z = (Y3 - B/200.0) ** 3
         IF (ABS(GAMINV-1.).LT.0.02) THEN
            DO 10 KOLR = 1,3
               COLR = X * COLX(KOLR) + Y * COLY(KOLR) + Z * COLZ(KOLR)
               CALL RFILL (IWID, COLR, LBUF(ISTRT,KOLR))
 10            CONTINUE
         ELSE
            DO 15 KOLR = 1,3
               COLR = X * COLX(KOLR) + Y * COLY(KOLR) + Z * COLZ(KOLR)
               COLR = MAX (0.0, MIN (1.0, COLR))
               COLR = COLR ** GAMINV
               CALL RFILL (IWID, COLR, LBUF(ISTRT,KOLR))
 15            CONTINUE
            END IF
         ISTRT = ISTRT + IWID
 20      CONTINUE
C                                        loop over colors r g b
      LBUF(1,1) = 0.
      LBUF(1,2) = 0.
      LBUF(1,3) = 0.
      CALL OFMIO ('WRIT', NW, LEVS, VRTRTC, LBUF, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END

      SUBROUTINE OERROR
C-----------------------------------------------------------------------
C! gives user error message, resets parameters to read next input line
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2009, 2013, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  OERROR displays the error message on the users terminal.  It then
C  re-initializes AIPS variables and returns to main AIPS.
C-----------------------------------------------------------------------
      CHARACTER MESAGE(100)*12, MES1(50)*12, MES2(50)*12, KPAC*20,
     *   SCNAME*24
      LOGICAL   F
      INTEGER   IERR, FIND, KBP, KD, KD1, IR, LUN
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DSMS.INC'
      INCLUDE 'INCS:DIO.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DRUN.INC'
      EQUIVALENCE (MESAGE(1), MES1(1)),    (MESAGE(51), MES2(1))
C-----------------------------------------------------------------------
      DATA MES1
C          1               2               3
     *    /'BLEW CORE!  ', 'SYMBOL?     ', 'BAD ( OR )  ',
     *     'LINE SIZE   ', 'SYMBOL SIZE!', 'ARRAY LIMITS',
     *     'STACK LIMITS', 'SYNTAX!     ', 'CHARACTER?  ',
     *     'PRINT       ', 'NO PROGRAM  ', 'ARG LIST?   ',
C         13              14              15
     *     'STRING SIZE ', 'ALREADY DF  ', 'CONTROL     ',
     *     'LOGIC EXP?  ', 'FOR---END?  ', 'INF LOOP?   ',
     *     'NO OPERATOR!', 'DIVIDE BY 0 ', 'IF OR LOOP! ',
     *     'READ        ', 'DATA TYPE?  ', 'USING WHAT? ',
C         25              26              27
     *     'PROTECTED!  ', 'SQRT NEGTIVE', 'NUMBER SIZE ',
     *     'RUN IN A RUN', 'LOG NEGATIVE', 'VERS TOO OLD',
     *     'UNAVAILABLE!', 'BOUNDARY LIM', 'CTLG PROBLEM',
     *     'HISTORY FILE', 'FIT FAILS   ', 'NO PROC MODE',
C         37              38              39
     *     'TEKS IN USE ', 'VERS TOO NEW', 'NOT YES / NO',
     *     'BATCH ERROR ', 'NO RET CODE ', 'TASK ACTIVE ',
     *     'NOT TASK    ', 'SYNC. FAILS ', 'FILE MISSING',
     *     'NO DESTROY  ', 'INVALID TAPE', 'TAPE PROBLEM',
     *     'TV PROBLEM  ', 'DISK PROBLEM'/
      DATA MES2
C         51              52              53
     *    /'TV UNAVAILAB', 'OPEN FILE?  ', 'NOT IN RUN  ',
     *     'NOT INPUTS  ', 'CREATE FILE?', 'CLOSE FILE? ',
     *     'PRINTER ERR.', 'FILE NOT OPN', 'TEXT READER ',
     *     'NOT IN BATCH', 'DISK PROBLEM', 'BAD EXPONENT',
C         63              64              65
     *     'TXT WRIT ERR', '????????????', '????????????',
     *     '????????????', '????????????', '????????????',
     *     '????????????', 'ONLY IN PROC', 'NOT IN PROC ',
     *     'ADVERB TYPE!', 'ADVERB SIZE!', 'BLEW TEMP K!',
C         75              76              77
     *     'BLEW TEMP C!', 'NOT PSEUDO #', 'TV ROAM MODE',
     *     '????????????', '????????????', '????????????',
     *     '????????????', '????????????', '????????????',
     *     '????????????', '????????????', '????????????',
C         87              88              89
     *     '????????????', '????????????', '????????????',
     *     '????????????', '????????????', '????????????',
     *     '????????????', '????????????', '????????????',
     *     '????????????', '????????????', '????????????',
     *     '????????????', 'ABORT!!!    '/
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                       basic message
      IF ((ERRNUM.GE.1) .AND. (ERRNUM.LE.100)) THEN
C                                       SYMBOL special case
         IF ((ERRNUM.EQ.2) .OR. (ERRNUM.EQ.72) .OR. (ERRNUM.EQ.73)) THEN
            KPAC = ' '
            CALL H2CHR (NKAR, 1, KPAK, KPAC)
            WRITE (MSGTXT,1000) MESAGE(ERRNUM), KPAC
C                                       regular OR internal codes
         ELSE IF ((ERRNUM.GE.61) .AND. (ERRNUM.LT.70)) THEN
            WRITE (MSGTXT,1015) MESAGE(ERRNUM), IERROR(1), IERROR(2)
         ELSE
            WRITE (MSGTXT,1000) MESAGE(ERRNUM)
            END IF
         CALL MSGWRT (7)
         END IF
C                                       debug traceback
      IF (IDEBUG.GE.0) THEN
         KD1 = MIN (5, ERRLEV)
         WRITE (MSGTXT,1025) ERRNUM, ERRLEV, (PNAME(KD), KD = 1,KD1)
         CALL MSGWRT (6)
         END IF
C                                       set to abort
      IF ((ERRNUM.NE.100) .AND. (ISBTCH.NE.32000)) GO TO 40
      IF ((NPOPS.LE.NINTRN) .AND. (ISBTCH.NE.32000) .AND.
     *   (TSKNAM(1:5).NE.'AIPSC')) GO TO 40
         ERRNUM = -2
         GO TO 999
C                                       close RUN file
 40   IF ((IUNIT.EQ.2) .OR. (IUNIT.EQ.5)) THEN
         DO 50 IR = 1,NUMRUN
            KD = NUMRUN + 1 - IR
            LUN = LUNRUN(KD)
            CALL LSERCH ('SRCH', LUN, FIND, F, IERR)
            IF (IERR.EQ.0) CALL ZTCLOS (LUN, FIND, IERR)
 50         CONTINUE
         IF (IUNIT.EQ.5) THEN
            SCNAME = 'RUNFIL:COMPRESS.N.UUU'
            SCNAME(12:15) = HSTNAM(:4)
            CALL ZEHEX (NPOPS, 1, SCNAME(17:17))
            CALL ZEHEX (NLUSER, 3, SCNAME(19:21))
            MSGTXT = 'RUN FILE: $RUNFIL/' // SCNAME(8:)
            CALL MSGWRT (8)
            MSGTXT = 'AFTER FIXING PROBLEMS AND RENAMIMG TO DROP PERIOD'
            CALL MSGWRT (8)
            MSGTXT = 'PROTECTED => REDEFINING STANDARD PROC/ADVERB'
            CALL MSGWRT (8)
            END IF
         END IF
C                                       reset pointers
      IUNIT = 1
      IF ((NPOPS.GT.NINTRN) .OR. (TSKNAM(1:5).EQ.'AIPSC')) IUNIT = 3
      NUMRUN = 0
      MODE = 0
      L = 1
      KBP = 1
      ERRLEV = 0
      ERRNUM = 0
      IPT = '>'
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A12,2X,A20)
 1015 FORMAT (A12,3X,'CODES: ',2I7)
 1025 FORMAT ('TRACE: #',I6,' LEVS',I4,' NAMES',5(1X,A6))
      END

      SUBROUTINE STEPCH (EPOCH, INTEPC, TABEPC, STREPC, LABEPC)
C-----------------------------------------------------------------------
C! Sets up Coordinate transformation using Real epoch value
C# Math Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Sets up Coordinate transformation using Real epoch value
C   Inputs:
C      EPOCH    R      Epoch 
C   Outputs:
C      INTEPC   I      Integer Epoch index
C      TABEPC   C*8    Table Label For Epoch
C      STREPC   C*40   CRDTRN 40 chracter string name of Epoch
C      LABEPC   C*80   Label for Epoch
C   This procedure is used with CRDSET and CRDTRN
C-----------------------------------------------------------------------
      REAL      EPOCH
      INTEGER   INTEPC
      CHARACTER TABEPC*8, STREPC*40, LABEPC*80
C                                       Number of coordinate systems
      INTEGER   NCRD
      PARAMETER (NCRD=7)
      INTEGER   IROUND, I, J
      CHARACTER CRDNAM(NCRD)*40, TABEPO(NCRD)*8
      DATA CRDNAM/'EQUATORIAL B1950.0',
     *   'EQUATORIAL b1900.0',
     *   'EQUATORIAL J2000.0',
     *   'GALACTIC',
     *   'OLD GALACTIC (OHLSSON)',
     *   'OLD GALACTIC (VAN TULDER)',
     *   'SUPERGALACTIC (REVISED)'/
C                                       8 character version of CRDNAM
      DATA TABEPO/'B1950.0 ','b1900.0 ','J2000.0 ','Galactic',
     *            'Gal OHLS','Gal VanT','SuperGal'/
C-----------------------------------------------------------------------
C                                       Determine coordinate transform
C                                       for CRDTRN
      INTEPC = IROUND (EPOCH) 
C                                       Default is J 2000
      IF ((EPOCH.LE.0.5) .OR. (EPOCH.GE.7.5)) INTEPC = 3
      IF ((EPOCH.GT.1000) .AND. (EPOCH.LT.1999.5)) INTEPC = 1
C                                       If Epoch near a date
      IF (ABS(EPOCH-1900.).LT.1) INTEPC = 2
      IF (ABS(EPOCH-2000.).LT.1) INTEPC = 3
C                                       First is 1900
      IF (EPOCH.EQ.1) INTEPC = 2
C                                       Second is 1950
      IF (EPOCH.EQ.2) INTEPC = 1
C                                       Transfer name
      STREPC = CRDNAM(INTEPC)   
      TABEPC = TABEPO(INTEPC)
      LABEPC = ' '
C                                       Handle individual years.
C                                       (assume b????)
C                                       Write Year to character
      IF ((EPOCH.GT.1000) .AND. (EPOCH.LT.1999.5)) THEN
         WRITE (STREPC(13:),1000, ERR=999) EPOCH
         END IF
C                                       Find begin and end of label
      CALL TXTLEN (STREPC, I, J)
C                                       If no blanks
C                                       Use beginning to end
      IF (J.LE.0) THEN
         J = I-1
         I = 1
         END IF
C                                       Prepare to Tell user
      TABEPC = TABEPO(MIN(MAX(1,INTEPC),NCRD))
      LABEPC = 'Star positions in '//STREPC(I:J)//' Coordinates'
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (F9.4)
      END

      SUBROUTINE ZTAP2 (OP, FCB, IERR)
C-----------------------------------------------------------------------
C! position (forward/back record/file), write EOF, etc. for tapes
C# Z2 Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Performs standard tape manipulating functions.
C   Inputs:
C      OP      C*4   Operation to be performed:
C                    'REWI' = rewind the tape on unit LUN
C                    'ADVF' = advance file marks
C                    'BAKF' = backspace file marks.
C                    'ADVR' = advance records
C                    'BAKR' = backspace records.
C                    'WEOF' = write end of file on unit LUN
C                    'BEGW' = mark to begin write (bakf/weof..)
C                    'AEOI' = advance to end-of-information (eg 2 EOFs)
C      FCB     I(*)  File control block for open tape device
C   Outputs:
C      IERR  I       Error return: 0 => ok
C                       3 = I/O error.
C                       4 = End Of File
C                       5 = Beginning Of Medium
C                       6 = End Of Medium
C   VMS version
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   FCB(*), IERR
C
      INTEGER   FUNC, P1, JERR, SYS$QIOW, ITEMP(2), I, ZAND
      INTEGER*2 I2TEMP(4)
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE '($IODEF)'
      INCLUDE '($SSDEF)'
      INCLUDE '($MTDEF)'
      EQUIVALENCE (I2TEMP, ITEMP)
C-----------------------------------------------------------------------
C                                       Check/set opcodes
      IF (OP.EQ.'REWI') THEN
         FUNC = IO$_REWIND
         P1 = 0
      ELSE IF (OP.EQ.'ADVF') THEN
         FUNC = IO$_SKIPFILE
         P1 = 1
      ELSE IF (OP.EQ.'ADVR') THEN
         FUNC = IO$_SKIPRECORD
	 P1 = 1
      ELSE IF (OP.EQ.'BAKF') THEN
         FUNC = IO$_SKIPFILE
         P1 = -1
      ELSE IF (OP.EQ.'BAKR') THEN
         FUNC = IO$_SKIPRECORD
         P1 = -1
      ELSE IF (OP.EQ.'WEOF') THEN
         FUNC = IO$_WRITEOF
         P1 = 0
      ELSE
         IERR = 2
         GO TO 999
         END IF
C                                       Do the QIO
      IF (P1.NE.0) THEN
         JERR = SYS$QIOW (%VAL(FCB(1+FCBSP1)), %VAL(FCB(1+FCBFD)),
     *      %VAL(FUNC), FCB(1+FCBSP2), , , %VAL(P1), , , , , )
      ELSE
         JERR = SYS$QIOW (%VAL(FCB(1+FCBSP1)), %VAL(FCB(1+FCBFD)),
     *      %VAL(FUNC), FCB(1+FCBSP2), , , , , , , , )
         END IF
C                                       error testing
      ITEMP(1) = FCB(1+FCBSP2)
      ITEMP(2) = FCB(2+FCBSP2)
      IF (JERR.NE.1) THEN
         IERR = 3
         FCB(1+FCBERR) = JERR
      ELSE
         JERR = I2TEMP(1)
         IF (JERR.NE.1) THEN
            FCB(1+FCBERR) = JERR
            IERR = 3
            IF (JERR.EQ.SS$_ENDOFFILE) THEN
               IERR = 4
C                                       test for BOM, EOM
               IF (ZAND(MT$M_BOT,ITEMP(2)).NE.0) IERR = 5
               IF (ZAND(MT$M_EOT,ITEMP(2)).NE.0) IERR = 6
C                                       EOM test
            ELSE IF (JERR.EQ.SS$_ENDOFTAPE) THEN
               IERR = 6
C                                       EOV should have another code
            ELSE IF (JERR.EQ.SS$_ENDOFVOLUME) THEN
               IERR = 4
C                                       Test for BOT for Kennedy drives
            ELSE IF (ZAND(MT$M_BOT,ITEMP(2)).NE.0) THEN
               IERR = 5
               END IF
         ELSE
            IERR = 0
            FCB(1+FCBERR) = 0
C                                       test for BOM
            IF (ZAND(MT$M_BOT,ITEMP(2)).NE.0) IERR = 5
            IF (ZAND(MT$M_EOT,ITEMP(2)).NE.0) IERR = 6
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE RECONV (CMAJ, CMIN, CPA, RMAJ, RMIN, RPA, FMAJ, FMIN,
     *   FPA, IERR)
C-----------------------------------------------------------------------
C! convolves two gaussians
C# Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   RECONV convolves a gaussian "beam" with a gaussian component.
C   Inputs:
C      CMAJ     R    Point source major axis
C      CMIN     R    Point source minor axis
C      CPA      R    Point source position angle of major axis
C      RMAJ     R    Real major axis
C      RMIN     R    Real minor axis
C      RPA      R    Real position angle of major axis
C   Outputs:
C      FMAJ     R    Fitted major axis
C      FMIN     R    Fitted minor axis
C      FPA      R    Fitted position angle of major axis
C      IERR     I    Error return: 0 => ok
C                         1-> unable to deconvolve
C-----------------------------------------------------------------------
      INTEGER   IERR
      REAL      FMAJ, FMIN, FPA, CMAJ, CMIN, CPA, RMAJ, RMIN, RPA
C
      REAL      CMJ2, CMN2, FMJ2, FMN2, CONST, RHOC, SIGIC2, DET, RMJ2,
     *   RMN2, DEN
      DATA CONST /28.647888/
C-----------------------------------------------------------------------
C                                       Get useful constants
      CMJ2 = CMAJ * CMAJ
      CMN2 = CMIN * CMIN
      RMJ2 = RMAJ * RMAJ
      RMN2 = RMIN * RMIN
      SIGIC2 = (RPA - CPA) / CONST
      DEN = CMJ2 - CMN2 + COS(SIGIC2) * (RMJ2 - RMN2)
      DET = SIN(SIGIC2) * (RMJ2 - RMN2)
      IF ((DET.EQ.0.0) .AND. (DEN.EQ.0.0)) THEN
         FPA = 0.0
      ELSE
         FPA = ATAN2 (DET, DEN)
         END IF
      DET = RMJ2 + RMN2 + CMJ2 + CMN2
      RHOC = COS (FPA)
      IF (RHOC.NE.0.0) THEN
         FMJ2 = (DET + DEN / RHOC) / 2.0
         FMN2 = (DET - DEN / RHOC) / 2.0
      ELSE
         FMJ2 = DET / 2.0
         FMN2 = FMJ2
         END IF
C                                       fix units
      FPA = FPA * CONST  + CPA
      FMAJ = SQRT (ABS (FMJ2))
      FMIN = SQRT (ABS (FMN2))
      FPA = MOD (FPA+720.0, 180.0)
      IF (FMAJ.LT.FMIN) THEN
         DET = FMAJ
         FMAJ = FMIN
         FMIN = DET
         FPA = MOD (FPA + 450.0, 180.0)
         END IF
      IERR = 0
      IF ((FMJ2.LE.0.0) .OR. (FMN2.LE.0.0)) IERR = 1
C
 999  RETURN
      END

      SUBROUTINE TKCLR (IERR)
C-----------------------------------------------------------------------
C! clears the TK graphics screen
C# Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TKCLR will clear the screen for a Tektronix 401n.
C   Output:
C      IERR    I     Error code from the last I/O routine. 0=ok.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   IT
      REAL      TEKPAG
      DATA TEKPAG /1.5/
C-----------------------------------------------------------------------
C                                       Put opcode 27 and 12 in the
C                                       buffer.
      IT = 27
      CALL ZTKBUF (IT, 1, IERR)
      IF (IERR.NE.0) GO TO 999
      IT = 12
      CALL ZTKBUF (IT, 1, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Flush the buffer (write buffer
C                                       to the device).
      CALL TEKFLS (IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Wait 1.5 seconds while the
C                                       screen is being cleared.
      CALL ZDELAY (TEKPAG, IERR)
C
 999  RETURN
      END

      SUBROUTINE IDAMAX (N, DX, INCX, IDMX)
C-----------------------------------------------------------------------
C! Finds Max. abs. element of a DP vector.
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C     FINDS THE INDEX OF ELEMENT HAVING MAX. ABSOLUTE VALUE.
C     JACK DONGARRA, LINPACK, 3/11/78. EWG MADE IT A SUBROUTINE
C-----------------------------------------------------------------------
      DOUBLE PRECISION DX(*), DMAX
      INTEGER     I, INCX, IX, N, IDMX
C-----------------------------------------------------------------------
      IDMX = 0
      IF (N.LT.1) GO TO 999
      IDMX = 1
      IF (N.EQ.1) GO TO 999
      IF (INCX.EQ.1) GO TO 20
C
C        CODE FOR INCREMENT NOT EQUAL TO 1
C
      IX = 1
      DMAX = ABS(DX(1))
      IX = IX + INCX
      DO 10 I = 2,N
         IF (ABS(DX(IX)).LE.DMAX) GO TO 5
         IDMX = I
         DMAX = ABS(DX(IX))
    5    IX = IX + INCX
   10 CONTINUE
      GO TO 999
C
C        CODE FOR INCREMENT EQUAL TO 1
C
   20 DMAX = ABS(DX(1))
      DO 30 I = 2,N
         IF (ABS(DX(I)).LE.DMAX) GO TO 30
         IDMX = I
         DMAX = ABS(DX(I))
   30 CONTINUE
C
 999  RETURN
      END

C   UVDATA Class utility module
C-----------------------------------------------------------------------
C! Object Oriented AIPS Fortran "UVDATA" utility module.
C# Ext-util Utility Object-Oriented
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000, 2010, 2012, 2015, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Public functions:
C
C   UVPHAS (uvin, uvout, ierr)
C      Does time averaging with RMS checking
C
C  OOA Fronts to AIPS uv data specific routines:
C-----------------------------------------------------------------------
LOCAL INCLUDE 'UVSTUFF.INC'
      INTEGER   MXVS
C                                       MXVS = maximum np. correlations
C                                       in a record.
      PARAMETER (MXVS = 2048)
C                                        Local Info for uv util.
      REAL     RP(50), VS(3,MXVS)
      COMMON /UVULCM/ RP, VS
LOCAL END
      SUBROUTINE UVPHAS (UVIN, UVOUT, IERR)
C-----------------------------------------------------------------------
C   UVdata class utility routine
C   Baseline dependent time averaging of a uv data set.
C   Inputs:
C      UVIN    C*?   Name of input uvdata object.
C      UVOUT   C*?   Name of output uvdata object.
C   Inputs from UVIN Object.
C      MAXATIME R    Maximum averaging time in seconds
C      MINSNR   R    Maximum field of view in arc min.
C   Output:
C       IERR   I     Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER UVIN*(*), UVOUT*(*)
      INTEGER   IERR
C
      INCLUDE 'UVSTUFF.INC'
C                                       Small Vis Amplitude
      REAL    EPSILN
C                                       Max time bins, Uv storage buff
      INTEGER   MXTIME, MXBUFF, MXVIS, MXANT
      PARAMETER (EPSILN=1.0E-10, MXTIME=10000, MXBUFF=100*3*MXVS,
     *   MXVIS=10000, MXANT=30)
      CHARACTER SRTORD*2, CDUMMY*1
      INTEGER   TYPE, DIM(3), COUNT, LREC, NRPARM, NCOR, ILOCU, ILOCV,
     *   ILOCW, ILOCT, ILOCB, ILOCSU, ILOCFQ, ILOCA1, ILOCA2, ILOCSA,
     *   JLOCC, JLOCS, JLOCF, JLOCIF, JLOCR, JLOCD, INCS, INCF, INCIF,
     *   ANTCNT(MXANT), NTIME, I, ANTONE, ANTTWO, PRTCNT, ANTLST, ANT1,
     *   ANT2, NANT, NCOTS, MXINTB, DUMMY
      REAL      RPA(15), VSS(3,MXVS), VSSRMS(3,MXVS), RPSAV(15,MXVIS),
     *   MXATIM, MINSNR, TIME, COTIME, COTIM2, PHSTIM, INTIME, AVETIM,
     *   VECSCL, COAVER, AVEOUT, PRTLEV, ANTBIN(MXANT), VISTOP(3,4),
     *   VISBUF(MXBUFF), TIMBIN(MXTIME), DELTIM(MXTIME), COTS(MXTIME),
     *   MDCOTM, MEDIAN
      LOGICAL   NEXT, DOSU, DOFQ, EOF, DOCOAV
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Init times
      NTIME = 0
      PRTCNT = 0
      ANTLST = 0
      NCOTS = 0
      MXINTB = 0
C                                       Request Stokes I
      DIM(1)=4
      DIM(2)=1
      DIM(3)=0
      CALL SECPUT (UVIN, 'STOKES   ', OOACAR, DIM, DUMMY, 'I   ', IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'SECPUT ERROR SELECTING STOKES = I'
         CALL MSGWRT (5)
         GO TO 990
         END IF
C                                       Open input
      CALL OUVOPN (UVIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Chack that it is visibility data
      CALL UVDGET (UVIN, 'TYPEUVD', TYPE, DIM, DUMMY, SRTORD, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (SRTORD(:1).NE.'U') THEN
         MSGTXT = 'UVPHAS DOES NOT WORK FOR DATA OF TYPE ''' //
     *      SRTORD // ''''
         IERR = 8
         GO TO 995
         END IF
C                                       Check that sort = B*
      CALL UVDGET (UVIN, 'SORTORD', TYPE, DIM, DUMMY, SRTORD, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (SRTORD.NE.'BT') THEN
         MSGTXT = 'UVPHAS: DATA NOT IN BT ORDER, USE UVSRT'
         IERR = 5
         GO TO 995
         END IF
C                                       Create output object
      CALL OCLONE (UVIN, UVOUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Open output
      CALL OUVOPN (UVOUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 990
      COUNT = 0
C                                       Zero number of visibilities
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      CALL UVDPUT (UVOUT, 'GCOUNT', OOAINT, DIM, COUNT, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Maximum time for coherent average
      CALL OUVGET (UVIN, 'MAXATIME', TYPE, DIM, MXATIM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       If zero max ave time, ave all
      IF (MXATIM.LE.1.E-10) MXATIM = 1.E10
C                                       Get SNR level to flag
      CALL OUVGET (UVIN, 'MINSNR', TYPE, DIM, MINSNR, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Get Vector/Scalar ratio limit
      CALL OUVGET (UVIN, 'VECSCL', TYPE, DIM, VECSCL, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Get CoherentAverage Flag
      CALL OUVGET (UVIN, 'COAVER', TYPE, DIM, COAVER, CDUMMY, IERR)
      DOCOAV = COAVER.GT.0.0
C                                       Output data timer interval
      CALL OUVGET (UVIN, 'AVEOUT', TYPE, DIM, AVEOUT, CDUMMY, IERR)
C                                       Determine amount to print
      CALL OUVGET (UVIN, 'PRTLEV', TYPE, DIM, PRTLEV, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Tell User
      WRITE (MSGTXT,1100) MXATIM
      IF (DOCOAV) CALL MSGWRT (3)
      WRITE (MSGTXT,1105) MINSNR
      CALL MSGWRT (3)
      WRITE (MSGTXT,1110) VECSCL
      CALL MSGWRT (3)
      WRITE (MSGTXT,1120) AVEOUT
      CALL MSGWRT (3)
C                                       Convert time (minutes) to days
      AVEOUT = AVEOUT / (24.*60.)
      MXATIM = MXATIM / (24.*60.)
      IF (DOCOAV) THEN
         MSGTXT = 'UVPHAS: Doing Baseline Based Coherence Time Averages'
         CALL MSGWRT (3)
         END IF
C                                       Get Uv data pointers
      CALL UVDPNT (UVIN, ILOCU, ILOCV, ILOCW, ILOCT, ILOCB, ILOCSU,
     *   ILOCFQ, ILOCA1, ILOCA2, ILOCSA, JLOCC, JLOCS, JLOCF, JLOCR,
     *   JLOCD, JLOCIF, INCS, INCF, INCIF, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Init antenna count bins
      CALL RFILL (MXANT, 0.0, ANTBIN)
      CALL FILL (MXANT, 0, ANTCNT)
C                                       Which random parameters to check
      DOSU = ILOCSU.GE.1
      DOFQ = ILOCFQ.GE.1
C                                       LREC
      CALL UVDGET (UVIN, 'LREC', TYPE, DIM, LREC, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       NRPARM
      CALL UVDGET (UVIN, 'NRPARM', TYPE, DIM, NRPARM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Number of correlators
      CALL UVDGET (UVIN, 'NCORR', TYPE, DIM, NCOR, CDUMMY, IERR)
      NCOR = MAX(NCOR, 1)
C                                       Check that it fits
      IF (NCOR.GT.MXVS) THEN
         WRITE (MSGTXT,1000) NCOR, MXVS
         IERR = 5
         GO TO 995
         END IF
C                                       Loop through input data
 100     CALL UVREAD (UVIN, RP, VS, IERR)
         IF (IERR.GT.0) GO TO 990
C                                       Note end of File
         EOF = (IERR.LT.0)
C                                       New baseline
         IF (ILOCB.GT.0) THEN
            NEXT = RP(ILOCB).NE.RPSAV(ILOCB,1)
         ELSE
            NEXT = (RP(ILOCA1).NE.RPSAV(ILOCA1,1)) .OR.
     *         (RP(ILOCA2).NE.RPSAV(ILOCA2,1))
            END IF
C                                       New source
         NEXT = NEXT .OR. (DOSU .AND. (RP(ILOCSU).NE.RPSAV(ILOCSU,1)))
C                                       New FQid
         NEXT = NEXT .OR. (DOFQ .AND. (RP(ILOCFQ).NE.RPSAV(ILOCFQ,1)))
C                                       If new or end of file and data
         IF (((NEXT .OR. EOF) .AND. (NTIME.GT.0)) .OR.
     *      (NTIME.GE.MXTIME)) THEN
C                                       Average Random Parameters
            CALL RPAVE (ILOCU, ILOCV, ILOCW, ILOCT, NRPARM,
     *         1, NTIME, RPA, RPSAV)
C                                       Decode Antenna numbers
            IF (ILOCB.GT.0) THEN
               ANT1 = ANTONE(RPA(ILOCB))
               ANT2 = ANTTWO(RPA(ILOCB))
            ELSE
               ANT1 = RPA(ILOCA1) + 0.1
               ANT2 = RPA(ILOCA2) + 0.1
               END IF
C                                       Get average, RMS Vis
            CALL VRMS (NCOR, 1, NTIME, MXBUFF, VSS, VSSRMS, VISBUF)
            CALL RCOPY (12, VSS, VISTOP)
C                                       Flag wild visibilities
            CALL VFLAG (NCOR, 1, NTIME, MXBUFF, MINSNR, VSS,
     *         VSSRMS, VISBUF)
C                                       Get cooherence time
            CALL VCOHER (NCOR, 1, 1, ILOCT, 1, NTIME,
     *         VECSCL, MXBUFF, RPSAV, VISBUF, COTIME)
C                                       Fix No Coherence time case
            IF (COTIME.GT.0.0) THEN
C                                       Flag vis within coherence
               CALL VCOFLG (NCOR, ILOCT, 1, NTIME, MINSNR, MXBUFF,
     *            RPSAV, VISBUF, COTIME)
C                                       Get cooherence time again
               CALL VCOHER (NCOR, 1, 1, ILOCT, 1, NTIME,
     *            VECSCL, MXBUFF, RPSAV, VISBUF, COTIM2)
            ELSE
C                                       Else use integration as coher.
               COTIM2 = RPSAV(ILOCT,MIN(2,NTIME))-RPSAV(ILOCT,1)
               END IF
C                                       Debug
            IF ((PRTLEV.GT.PRTCNT) .OR. (ANT1.NE.ANTLST)) THEN
               WRITE (MSGTXT,1300) ANT1, ANT2, NTIME, COTIME*24*60,
     *           COTIM2*24.*60., (VSS(1,I),VSSRMS(1,I),
     *           SQRT(VSS(1,I)**2+VSS(2,I)**2)/MAX(EPSILN,VSSRMS(3,I)),
     *           I=1,1)
               CALL MSGWRT (3)
               END IF
            ANTLST = ANT1
            PRTCNT = PRTCNT + 1
C                                       Save conherence time measure
            ANTBIN(ANT1) = ANTBIN(ANT1) + COTIM2
            ANTCNT(ANT1) = ANTCNT(ANT1) + 1
            ANTBIN(ANT2) = ANTBIN(ANT2) + COTIM2
            ANTCNT(ANT2) = ANTCNT(ANT2) + 1
C                                       Record coherenc time
            IF (COTIM2.GT.0) THEN
               NCOTS = NCOTS + 1
               COTS(NCOTS) = COTIM2
            ELSE
C                                       Else use integration as coher.
               COTIM2 = RPSAV(ILOCT,MIN(2,NTIME))-RPSAV(ILOCT,1)
               END IF
C                                       If writing coherent averages
            IF ((DOCOAV) .AND. (COTIME.GT.0.)) THEN
C                                       average no longer than max allow
               AVETIM = MIN (COTIM2, MXATIM)
C                                       if coherence > ave/? then write
               IF (COTIM2.GT.AVEOUT/1.5)
C                                       Do coherent average and write
     *            CALL VCAOUT (NCOR, ILOCU, ILOCV, ILOCW, ILOCT, NRPARM,
     *               1, NTIME, MXBUFF, RPSAV, UVOUT, COUNT, AVETIM,
     *               AVEOUT, VISBUF, IERR)
            ELSE
C                                       Else, Just write unflagged data
               CALL VOUT (NCOR, 1, NTIME, MXBUFF, RPSAV, UVOUT,
     *            COUNT, VISBUF, IERR)
               END IF
            IF (IERR.GT.0) GO TO 990
C                                       If more integration times
            IF (NTIME.GT.MXINTB) THEN
C                                       Use times to calculate Deltas
               DO 800 I = 1,NTIME-1
                  DELTIM(I) = TIMBIN(I+1) - TIMBIN(I)
 800              CONTINUE
C                                       Itegration time is median delta
               I = NTIME - 1
               IF (I.GT.2) THEN
                  INTIME = MEDIAN (I, DELTIM)
               ELSE IF (I.EQ.2) THEN
                  INTIME = MIN (DELTIM(1), DELTIM(2))
               ELSE
                  INTIME = DELTIM(1)
                  END IF
               INTIME = DELTIM(MAX(1,(NTIME-1)/2))
               MXINTB = NTIME
               END IF
C                                       End if Finished average
C                                       Re init time bins
            IF (.NOT. EOF) NTIME = 0
            END IF
C                                       Exit on End of File
         IF (EOF) GO TO 200
C                                       If first, init vis buffer
C         IF (NTIME.LE.0)
C     *      CALL RFILL (MIN(MXBUFF,MXTIME*NCOR*3), 0.0, VISBUF)
C                                       Accumulate
         TIME = RP(ILOCT)
C                                       Save random parms
         CALL RPPUT (NRPARM, TIME, NTIME, TIMBIN, RP, RPSAV)
C                                       Save visability
         CALL VPUT (NCOR, NTIME, MXBUFF, VS, VISBUF)
C                                       Loop for next vis
         GO TO 100
C                                       Done
 200  IERR = 0
C                                       Better be some data
      IF (COUNT.LE.0) THEN
         IERR = 7
         MSGTXT = 'UVPHAS: NO DATA SELECTED'
         GO TO 995
      ELSE
         WRITE (MSGTXT,1250) COUNT
         CALL MSGWRT (4)
         END IF
C                                       Close files
      CALL OUVCLO (UVIN, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OUVCLO (UVOUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy tables
      CALL UVCALT (UVIN, UVOUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Prepare to calculate average T
      NANT = 0
      COTIME = 0.0
      PHSTIM = 1E20
C                                       Report antenna coherence times
      DO 700 I = 1,MXANT
C                                       If counts for this antenna
         IF (ANTCNT(I).GT.0) THEN
C                                       Calc Average coherence time
            WRITE (MSGTXT,1400) I, ANTCNT(I),
     *         24.0*60.*ANTBIN(I)/ANTCNT(I)
            CALL MSGWRT (3)
            NANT = NANT + 1
            COTIME = COTIME + (ANTBIN(I)/ANTCNT(I))
            PHSTIM = MIN (PHSTIM, ANTBIN(I)/ANTCNT(I))
            END IF
 700     CONTINUE
C                                       Report times
      IF (MXINTB.GT.1) THEN
C                                       Return median delta time (Min)
         WRITE (MSGTXT,1600) INTIME*24.*60.
      ELSE
         INTIME = 0
         WRITE (MSGTXT,1510) NTIME, TIMBIN(1)
         END IF
      CALL MSGWRT (3)
C                                       Do statistical analysis of times
      IF (NCOTS.GT.3) THEN
C                                       Sort into decending order
C        CALL RSORT(NCOTS, COTS)
C                                       transfer median coherence
C                                       This was WRONG
C        MDCOTM = COTS(3*NCOTS/4)
         MDCOTM = MEDIAN (NCOTS, COTS)
C                                       use report median coherence
         WRITE (MSGTXT,1520) NCOTS, 24.*60.*MDCOTM
         CALL MSGWRT (3)
C                                       Record min phase time
         PHSTIM = MIN (MDCOTM, PHSTIM)
         END IF
C                                       Report Average coherence time
      IF (NANT.GT.0) THEN
         WRITE (MSGTXT, 1450) NANT, 24.0*60.*COTIME/NANT
         CALL MSGWRT (5)
         PHSTIM = MAX (INTIME, PHSTIM)
         WRITE (MSGTXT, 1460) NANT, 24.0*60.*PHSTIM
         CALL MSGWRT (5)
C                                       Create a keyword
         CALL OBVHKW ('UVDATA   ', 'PHASETIM', 2, IERR)
C                                       Record min coherence time
         CALL OPUT (UVOUT, 'PHASETIM', OOARE, DIM, PHSTIM, CDUMMY, IERR)
         END IF
      GO TO 999
C                                       Error
 995  CALL MSGWRT (7)
 990  MSGTXT = 'UVPHAS: ERROR COPYING ' // UVIN
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVPHAS: TOO MANY CORRELATIONS ', I6,' > ', I6)
 1100 FORMAT ('UVPHAS: Maximum time period for ave. of Vis.',F11.2,
     *   ' Minutes')
 1105 FORMAT ('UVPHAS: Flagging vis with Deviation        >',F11.2,
     *   ' Sigma')
 1110 FORMAT ('UVPHAS: Coherence from Vector/Scalar Ratio <',F11.2)
 1120 FORMAT ('UVPHAS: Visibilities written at intervals of',F11.2,
     *   ' Minutes')
 1250 FORMAT ('UVPHAS: Wrote ',I7,' visibilities')
 1300 FORMAT (I2,'-',I2,' (',I4,') T=',F6.2,',',F6.2,
     *        ' V=',4(F8.3,'+/-',F7.3,F7.2))
 1400 FORMAT ('UVPHAS: Ant.',I3,' in',I4,' Baselines:',F10.3,
     *       ' Minutes Coherence')
 1450 FORMAT ('UVPHAS:',I3,' Antennas have ',F10.3,' Average Coherence',
     *       ' Time (Min)')
 1460 FORMAT ('UVPHAS:',I3,' Antennas have ',F10.3,' Minimum Coherence',
     *       ' Time (Min)')
 1520 FORMAT ('UVPHAS:',I5,' Coher. times',F10.3,' Median  Coherence',
     *       ' Time (Min)')
 1510 FORMAT ('UVPHAS:',I10,' Obs. times :',1PE12.5,' Days')
 1600 FORMAT ('UVPHAS:',1PE10.2,' Integration interval (Min)')
      END
      SUBROUTINE VPUT (NCOR, ITIME, MXBUFF, VIS, VISBUF)
C-----------------------------------------------------------------------
C! copies one visibility to buffer
C   Inputs:
C      NCOR    I          Number of stokes in vis
C                         or Init zero flag
C      ITIME   I          Time index for vis
C      MXBUFF  I          Maximum buffer size
C      VIS     R(3,NCOR)  Vis
C   In/Output:
C      VISBUF  R(NREAL)   Output array
C-----------------------------------------------------------------------
      INTEGER   NCOR, ITIME, MXBUFF
C
      INCLUDE 'UVSTUFF.INC'
      REAL      VIS(3,MXVS), VISBUF(*)
C
      INTEGER   I, K, TOFF, IOFF
C-----------------------------------------------------------------------
C                                       If valid vis and time
      IF ((NCOR.GT.0) .AND. (ITIME.GT.0)) THEN
C                                       Calc time offset
         TOFF = NCOR*(ITIME-1)*3
C                                       For all correlators
         DO 10 I = 1,NCOR
C                                       Calc correlator offset
            IOFF = 3*(I-1) + TOFF
C                                       Exit on end of buffer
            IF (IOFF+3.GT.MXBUFF) GO TO 999
C                                       For Real Imaginary Weight
            DO 9 K = 1,3
               VISBUF(IOFF+K) = VIS(K,I)
 9             CONTINUE
 10         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE VGET (NCOR, ITIME, MXBUFF, VIS, VISBUF)
C-----------------------------------------------------------------------
C   copies one visibility from buffer
C   Inputs:
C      NCOR    I          Number of stokes in vis
C                         or Init zero flag
C      ITIME   I          Time index for vis
C      MXBUFF  I          Maximum buffer size
C      VIS     R(3,NCOR)  Vis
C   In/Output:
C      VISBUF  R(NREAL)   Output array
C-----------------------------------------------------------------------
      INTEGER   NCOR, ITIME, MXBUFF
      INCLUDE 'UVSTUFF.INC'
      REAL      VIS(3,MXVS), VISBUF(MXVS)
C
      INTEGER   I, K, TOFF, IOFF
C-----------------------------------------------------------------------
C                                       If channels in data
      IF ((NCOR.GT.0) .AND. (ITIME.GT.0)) THEN
C                                       Calc time offset
         TOFF = NCOR*(ITIME-1)*3
C                                       For all correlators
         DO 10 I = 1,NCOR
C                                       Calc correlator offset
            IOFF = 3*(I-1) + TOFF
C                                       Exit on end of buffer
            IF (IOFF+3.GT.MXBUFF) GOTO 999
C                                       For Real, Imaginary, Weight
            DO 9 K = 1,3
               VIS(K,I) = VISBUF(IOFF+K)
 9             CONTINUE
 10         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE VDEL (NCOR, ITIME, NTIME, VIS, VISBUF)
C-----------------------------------------------------------------------
C! deletes on visibility from the buffer
C   Inputs:
C      NCOR    I          Number of stokes in vis
C                         or Init zero flag
C      ITIME   I          Time index for vis
C      VIS     R(3,NCOR)  Vis
C   In/Output:
C      VISBUF  R(NREAL)   Output array
C-----------------------------------------------------------------------
      INTEGER   NCOR, ITIME, NTIME
      INCLUDE 'UVSTUFF.INC'
      REAL      VIS(3,MXVS), VISBUF(MXVS)
C
      INTEGER   J, TOFF, JOFF
C-----------------------------------------------------------------------
C                                       If channels in data
      IF ((NCOR.GT.0) .AND. (ITIME.GT.0) .AND. (ITIME.LE.NTIME)) THEN
C                                       Calc time offset
         TOFF = NCOR*(ITIME-1)*3
C                                       For all other vis + 1 blank vis
         DO 100 J = ITIME+1,NTIME+1
C                                       Calc  Vis offset
            JOFF = TOFF + 3*NCOR*(J-1)
C                                       Overwrite previous vis
            CALL COPY (NCOR*3, VISBUF(JOFF+3*NCOR), VISBUF(JOFF))
 100        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE VAVE (NCOR, ITIME1, ITIME2, MXBUFF, VIS, VISBUF)
C-----------------------------------------------------------------------
C! Vector average buffer visabilities to VIS
C   Inputs:
C      NCOR    I          Number of stokes in vis
C                         or Init zero flag
C      ITIME1  I          Start Time index for vis
C      ITIME2  I          Stop  Time index for vis
C      MXBUF   I          Maximum buffer size
C      VIS     R(3,NCOR)  Vis
C   In/Output:
C      VISBUF  R(NREAL)   Output array
C-----------------------------------------------------------------------
      INTEGER   NCOR, ITIME1, ITIME2, MXBUFF
      INCLUDE 'UVSTUFF.INC'
      REAL      VIS(3,MXVS), VISBUF(MXVS)
C
      INTEGER   I, J
      REAL      VIS2(3,MXVS), WEIGHT
C-----------------------------------------------------------------------
      IF ((NCOR.GT.0) .AND. (ITIME1.GT.0) .AND. (ITIME2.GE.ITIME1)) THEN
C                                       Zero output vis
         CALL VZERO (NCOR, VIS)
C                                       For all vis.
         DO 200 J = ITIME1,ITIME2
C                                       Get vis
            CALL VGET (NCOR, J, MXBUFF, VIS2, VISBUF)
C                                       For all correlators
            DO 100 I = 1,NCOR
C                                       if positive weight
               WEIGHT = VIS2(3,I)
               IF (WEIGHT.GT.0.) THEN
                  VIS(1,I) = VIS(1,I) + VIS2(1,I)*WEIGHT
                  VIS(2,I) = VIS(2,I) + VIS2(2,I)*WEIGHT
                  VIS(3,I) = VIS(3,I) + WEIGHT
                  END IF
 100           CONTINUE
C                                       End for all vis loop
 200        CONTINUE
C                                       For all correlators
            DO 300 I = 1,NCOR
C                                       If positive count
               IF (VIS(3,I).GT.0.0) THEN
C                                       Rescale
                  VIS(1,I) = VIS(1,I) / VIS(3,I)
                  VIS(2,I) = VIS(2,I) / VIS(3,I)
                  END IF
 300           CONTINUE
C                                       If ok command
         END IF
      RETURN
      END
      SUBROUTINE VRMS (NCOR, ITIME1, ITIME2, MXBUFF, VIS, VIS2, VISBUF)
C-----------------------------------------------------------------------
C! Vector RMS average buffer visabilities to VIS
C   Inputs:
C      NCOR    I          Number of stokes in vis
C                         or Init zero flag
C      ITIME1  I          Start Time index for vis
C      ITIME2  I          Stop  Time index for vis
C      MXBUF   I          Maximum buffer size
C      VIS     R(3,NCOR)  Average Vis
C      VIS2    R(3,NCOR)  RMS Vis,  VIS(3,*) = Scalar Amplitude
C   In/Output:
C      VISBUF  R(NREAL)   Output array
C-----------------------------------------------------------------------
      INTEGER   NCOR, ITIME1, ITIME2, MXBUFF
      INCLUDE 'UVSTUFF.INC'
      REAL      VIS(3,MXVS), VIS2(3,MXVS), VISBUF(MXVS)
C
      INTEGER   I, J, VISCNT(MXVS)
      REAL      VIS3(3,MXVS), ONEOVN
C-----------------------------------------------------------------------
      IF ((NCOR.GT.0) .AND. (ITIME1.GT.0) .AND. (ITIME2.GE.ITIME1)) THEN
C                                       Init correlator counts
         CALL FILL (NCOR, 0, VISCNT)
C                                       Zero output vis
         CALL VZERO (NCOR, VIS)
C                                       Zero square sum vis
         CALL VZERO (NCOR, VIS2)
C                                       For all vis.
         DO 200 J = ITIME1,ITIME2
C                                       Get vis
            CALL VGET (NCOR, J, MXBUFF, VIS3, VISBUF)
C                                       For all correlators
            DO 100 I = 1,NCOR
C                                       if positive weight
               IF (VIS3(3,I).GT.0.) THEN
C                                       Sum for Average
                  VIS(1,I) = VIS(1,I) + VIS3(1,I)
                  VIS(2,I) = VIS(2,I) + VIS3(2,I)
                  VIS(3,I) = VIS(3,I) + VIS3(3,I)
C                                       Sum for square average
                  VIS2(1,I) = VIS2(1,I) + VIS3(1,I)**2
                  VIS2(2,I) = VIS2(2,I) + VIS3(2,I)**2
C                                       Calc Scalar Amplitude
                  VIS2(3,I) = VIS2(3,I) +
     *                        SQRT(VIS3(1,I)**2 + VIS3(2,I)**2)
C                                       Increment count
                  VISCNT(I) = VISCNT(I) + 1
                  END IF
C                                       End for all correlatores loop
 100           CONTINUE
C                                       End for all vis loop
 200        CONTINUE
C                                       For all correlators
            DO 300 I = 1,NCOR
C                                       If positive count
               IF (VISCNT(I).GT.0) THEN
C                                       ONEOVN
                  ONEOVN = 1.0 / VISCNT(I)
C                                       calc average
                  VIS(1,I) = VIS(1,I) * ONEOVN
                  VIS(2,I) = VIS(2,I) * ONEOVN
C                                       calc RMS**2
                  VIS2(1,I) = (VIS2(1,I) * ONEOVN) - VIS(1,I)**2
                  VIS2(2,I) = (VIS2(2,I) * ONEOVN) - VIS(2,I)**2
C                                       calc RMS from RMS**2
                  IF (VISCNT(I).GT.1) THEN
                     VIS2(1,I) = SQRT(ABS(VIS2(1,I)))
                     VIS2(2,I) = SQRT(ABS(VIS2(2,I)))
                  ELSE
                     VIS2(1,I) = 1.E20
                     VIS2(2,I) = 1.E20
                     END IF
C                                       calc average scalar amplitude
                  VIS2(3,I) = VIS2(3,I) * ONEOVN
C                                       Else no data, set RMS large
               ELSE
                  VIS2(1,I) = 1.E20
                  VIS2(2,I) = 1.E20
                  END IF
 300           CONTINUE
C                                       If ok command
         END IF
      RETURN
      END
      SUBROUTINE VSRATI (NCOR, CORSTR, CORSTP, ITIME1, ITIME2, ITIME3,
     *   VECSCL, MXBUFF, VISBUF)
C-----------------------------------------------------------------------
C! Vector/Scalar average ratio limit.  This routine finds the time index
C  at which the Vector/Scalar amplitude ratio drops below VECSCL
C   Inputs:
C      NCOR    I          Number of stokes in vis
C      CORSTR  I          Start correlator for coherence check
C      CORSTP  I          Stop  correlator for coherence check
C      ITIME1  I          Start Time index for vis
C      ITIME2  I          Stop  Time index for vis
C      VECSCL  I          Vector/scalar average limit
C      MXBUF   I          Maximum buffer size
C      VISBUF  R(NREAL)   Buffer of visibilities to examine
C   In/Output:
C      ITIME3  I          Coherence time limit
C-----------------------------------------------------------------------
      INTEGER   NCOR, CORSTR, CORSTP, ITIME1, ITIME2, ITIME3, MXBUFF
      INCLUDE 'UVSTUFF.INC'
      REAL      VECSCL, VISBUF(*)
C
      INTEGER   I, J, VISCNT(MXVS)
      REAL      VIS(3,MXVS), VIS3(3,MXVS)
C-----------------------------------------------------------------------
C                                       Init time index to last time
      ITIME3 = ITIME2
C                                       If valid vis
      IF ((NCOR.GT.0) .AND. (ITIME1.GT.0) .AND. (ITIME2.GT.ITIME1)) THEN
C                                       Init correlator counts
         CALL FILL (NCOR, 0, VISCNT)
C                                       Zero output vis
         CALL VZERO (NCOR, VIS)
C                                       For all vis.
         DO 200 J = ITIME1,ITIME2
C                                       Get vis
            CALL VGET (NCOR, J, MXBUFF, VIS3, VISBUF)
C                                       For parallel all correlators
            DO 100 I = CORSTR,CORSTP
C                                       if positive weight
               IF (VIS3(3,I).GT.0.) THEN
C                                       Sum for Vector Average
                  VIS(1,I) = VIS(1,I) + VIS3(1,I)
                  VIS(2,I) = VIS(2,I) + VIS3(2,I)
C                                       Calc Scalar Amplitude
                  VIS(3,I) = VIS(3,I) +
     *                        SQRT(VIS3(1,I)**2 + VIS3(2,I)**2)
C                                       Increment count
                  VISCNT(I) = VISCNT(I) + 1
C                                       If more than 1 vis.
                  IF (VISCNT(I).GT.1) THEN
C                                       See if limit is exceeded.
                     IF (SQRT(VIS(1,I)**2 + VIS(2,I)**2).LT.
     *                   VECSCL*VIS(3,I)) THEN
C                                       Current Vis -1 is limit.
                        ITIME3 = MAX (J-1, ITIME1)
C                                       Exit, limit found
                        GO TO 300
                        END IF
                     END IF
C                                       End if more than 1 point
                  END IF
C                                       End for all correlatores loop
 100           CONTINUE
C                                       End for all vis loop
 200        CONTINUE
C                                       Jump here on limit exceeded
 300     CONTINUE
C                                       End if valid request
      END IF
      RETURN
      END
      SUBROUTINE RPPUT (NRPARM, TIME, NTIME, TIMBIN, RPARM, RPBUF)
C-----------------------------------------------------------------------
C! Select time bin and put the random parameter in a buffer
C   Inputs:
C      NCOR    I          Number of stokes in vis
C                         or Init zero flag
C      ITIME   I          Time index for vis
C      MXBUFF  I          Maximum buffer size
C      VIS     R(3,NCOR)  Vis
C   In/Output:
C      VISBUF  R(NREAL)   Output array
C-----------------------------------------------------------------------
      INTEGER   NRPARM, NTIME
      REAL      TIME, RPARM(*), RPBUF(15,*), TIMBIN(*)
C-----------------------------------------------------------------------
C                                       A new time, count it
      NTIME = NTIME + 1
      TIMBIN(NTIME) = TIME
C                                       If valid random parm
      IF ((NRPARM.GT.0) .AND. (NTIME.GT.0)) THEN
C                                       First vis random parms
         CALL RCOPY (NRPARM, RPARM, RPBUF(1,NTIME))
         END IF
C
      RETURN
C-----------------------------------------------------------------------
      END
      SUBROUTINE RPDEL (NRPARM, ITIME, NTIME, TIMBIN, RPBUF)
C-----------------------------------------------------------------------
C! Delete random parameter from list
C   Inputs:
C      NPARM   I          Number of stokes in vis
C                         or Init zero flag
C      ITIME   I          Time index for vis
C      MXBUFF  I          Maximum buffer size
C      VIS     R(3,NCOR)  Vis
C   In/Output:
C      VISBUF  R(NREAL)   Output array
C-----------------------------------------------------------------------
      INTEGER   NRPARM, ITIME, NTIME
      REAL      RPBUF(15,*), TIMBIN(*)
C
      INTEGER   I
C-----------------------------------------------------------------------
C                                       If not at end of list
      IF (ITIME.LT.NTIME) THEN
C                                       for all later vis
         DO 100 I = ITIME+1,NTIME
C                                       copy over previous random parms
            CALL COPY (NRPARM, RPBUF(1,I), RPBUF(1,I-1))
C                                       copy over prevous time bin
            TIMBIN(I-1) = TIMBIN(I)
 100        CONTINUE
         END IF
C                                       reset total times count
      NTIME = NTIME - 1
      RETURN
C-----------------------------------------------------------------------
      END
      SUBROUTINE RPAVE (ILOCU, ILOCV, ILOCW, ILOCT, NRPARM,
     *   ITIME1, ITIME2, RPARM, RPBUF)
C-----------------------------------------------------------------------
C! Select time bin and put the random parameter in a buffer
C   Inputs:
C      NCOR    I          Number of stokes in vis
C                         or Init zero flag
C      ITIME1  I          Start Time index for vis
C      ITIME2  I          Stop  Time index for vis
C      MXBUFF  I          Maximum buffer size
C      VIS     R(3,NCOR)  Vis
C   In/Output:
C      VISBUF  R(NREAL)   Output array
C-----------------------------------------------------------------------
      INTEGER   ILOCU, ILOCV, ILOCW, ILOCT, NRPARM, ITIME1, ITIME2
      REAL      RPARM(*), RPBUF(15,*)
C
      INTEGER   I
C-----------------------------------------------------------------------
C                                       If valid random parm
      IF ((NRPARM.GT.0) .AND. (ITIME1.GT.0) .AND. (ITIME2.GE.ITIME1))
     *   THEN
C                                       Init output vis
         CALL COPY (NRPARM, RPBUF(1,ITIME1), RPARM)
C                                       If more than 1 vis
         IF (ITIME2-ITIME1.GT.0) THEN
C                                       Sum visibiliities
            DO 100 I = ITIME1+1,ITIME2
C                                       Add elements
               RPARM(ILOCU) = RPARM(ILOCU) + RPBUF(ILOCU,I)
               RPARM(ILOCV) = RPARM(ILOCV) + RPBUF(ILOCV,I)
               RPARM(ILOCW) = RPARM(ILOCW) + RPBUF(ILOCW,I)
               RPARM(ILOCT) = RPARM(ILOCT) + RPBUF(ILOCT,I)
 100           CONTINUE
C                                       scale for average
            RPARM(ILOCU) = RPARM(ILOCU)/(ITIME2 - ITIME1 + 1.0)
            RPARM(ILOCV) = RPARM(ILOCV)/(ITIME2 - ITIME1 + 1.0)
            RPARM(ILOCW) = RPARM(ILOCW)/(ITIME2 - ITIME1 + 1.0)
            RPARM(ILOCT) = RPARM(ILOCT)/(ITIME2 - ITIME1 + 1.0)
C                                       End if more than 1 vis
            END IF
         END IF
C
      RETURN
C-----------------------------------------------------------------------
      END
      INTEGER FUNCTION ANTONE(BASELN)
      REAL BASELN
C                                       Crack First antenna number
      ANTONE = INT(BASELN)/256
      RETURN
C-----------------------------------------------------------------------
      END
      INTEGER FUNCTION ANTTWO(BASELN)
C-----------------------------------------------------------------------
      REAL BASELN
C                                       Crack second antenna number
      ANTTWO = MOD(INT(BASELN),256)
      RETURN
C-----------------------------------------------------------------------
      END
      SUBROUTINE VFLAG (NCOR, ITIME1, ITIME2, MXBUFF, MINSNR, VISAVE,
     *   VISRMS, VISBUF)
C-----------------------------------------------------------------------
C! Vector/Scalar average ratio limit.  This routine finds the time index
C  at which the Vector/Scalar amplitude ratio drops below VECSCL
C   Inputs:
C      NCOR    I          Number of stokes in vis
C                         or Init zero flag
C      ITIME1  I          Start Time index for vis
C      ITIME2  I          Stop  Time index for vis
C      VECSCL  I          Vector/scalar average limit
C      MXBUF   I          Maximum buffer size
C      VISAVE  R(NREAL)   Average visibility buffer
C      VISRMS  R(NREAL)   RMS visibility buffer
C      VISBUF  R(NREAL)   Buffer of visibilities to examine
C---------------------------------------------------------------------
      INTEGER   NCOR, ITIME1, ITIME2, MXBUFF
      INCLUDE 'UVSTUFF.INC'
      REAL      MINSNR, VISAVE(3,MXVS), VISRMS(3,MXVS), VISBUF(*)
C
      REAL      EPSILN
C                                       Small Vis Amplitude
      PARAMETER (EPSILN=1.0E-10)
      INTEGER   I, LOOP
      LOGICAL   ONZE, FLAGED
      REAL      VIS(3,MXVS)
      SAVE      ONZE
      DATA      ONZE/.FALSE./
C-----------------------------------------------------------------------
C                                       For all visibilities
      DO 200 LOOP = ITIME1,ITIME2
C                                       Get vis
         CALL VGET (NCOR, LOOP, MXBUFF, VIS, VISBUF)
C                                       Assume no flagging
         FLAGED = .FALSE.
C                                       If SNR is sufficient
         DO 100 I = 1,NCOR
C                                       If RMS known and unflagged
            IF ((VISRMS(1,I).GT.EPSILN) .AND.
     *         (VISRMS(2,I).GT.EPSILN) .AND. (VIS(3,I).GT.0.0)) THEN
C                                       If visibility exceeds minrms
               IF ((ABS(VIS(1,I)-VISAVE(1,I)).GT.MINSNR*VISRMS(1,I))
     *            .OR.
     *            (ABS(VIS(2,I)-VISAVE(2,I)).GT.MINSNR*VISRMS(2,I)))
     *            THEN
                  VIS(3,I) = -VIS(3,I)
                  FLAGED = .TRUE.
                  END IF
C                                       End if Data exceeds limits
               END IF
C                                       If an unflaged vis, keep data
 100        CONTINUE
            ONZE = .TRUE.
C                                       If data changed, put it back
            IF (FLAGED) CALL VPUT (NCOR, LOOP, MXBUFF, VIS, VISBUF)
 200     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE VOUT (NCOR, ITIME1, ITIME2, MXBUFF, RPSAV, UVOUT,
     *   COUNT, VISBUF, IERR)
C-----------------------------------------------------------------------
C! Write out Visibilities for one baseline
C   Inputs:
C      NCOR    I          Number of stokes in vis
C      ITIME1  I          Start Time index for vis
C      ITIME2  I          Stop  Time index for vis
C      MXBUF   I          Maximum buffer size
C      RPSAV   R(*)       Average random parameters
C      VISBUF  R(NREAL)   Buffer of visibilities to examine
C      UVOUT   C*?        Name of output data object
C   In/Output:
C      COUNT   I          Count of written visibilities
C   Output:
C      IERR    I          Error return code, 0=OK
C---------------------------------------------------------------------
      INTEGER   NCOR, ITIME1, ITIME2, MXBUFF, COUNT, IERR
      CHARACTER UVOUT*(*)
      INCLUDE 'UVSTUFF.INC'
      REAL      RPSAV(15,*), VISBUF(*)
C
      INTEGER   LOOP
      REAL      VIS(3,MXVS)
C-----------------------------------------------------------------------
C                                       For all visibilities
      DO 100 LOOP = ITIME1,ITIME2
C                                       Get vis
         CALL VGET (NCOR, LOOP, MXBUFF, VIS, VISBUF)
C                                       Write it
         CALL V1OUT (NCOR, MXBUFF, RPSAV(1,LOOP), VIS, UVOUT,
     *   COUNT, VISBUF, IERR)
C
 100     CONTINUE
 999  RETURN
      END
      SUBROUTINE V1OUT (NCOR, MXBUFF, RPARM, VIS, UVOUT,
     *   COUNT, VISBUF, IERR)
C-----------------------------------------------------------------------
C! Writes out 1 random parameter, Visibility pair for one baseline
C   Inputs:
C      NCOR    I          Number of stokes in vis
C      MXBUF   I          Maximum buffer size
C      RPARM   R(*)       Random parameters
C      VIS     R(*)       Visibility
C      VISBUF  R(NREAL)   Buffer of visibilities to examine
C      UVOUT   C*?        Name of output data object
C   In/Output:
C      COUNT   I          Count of written visibilities
C   Output:
C      IERR    I          Error return code, 0=OK
C---------------------------------------------------------------------
      INTEGER   NCOR, MXBUFF, COUNT, IERR
      CHARACTER UVOUT*(*)
      INCLUDE 'UVSTUFF.INC'
      REAL      RPARM(15), VIS(3,MXVS), VISBUF(*)
C
      INTEGER   I
      LOGICAL   FLAGED
C-----------------------------------------------------------------------
C                                       Assume flagged
      FLAGED = .TRUE.
C                                       If SNR is sufficient
      DO 100 I = 1,NCOR
C                                       If RMS known and unflagged
         IF (VIS(3,I).GT.0.0) FLAGED = .FALSE.
 100     CONTINUE
C                                       If unflagged element
      IF (.NOT.FLAGED) THEN
         COUNT = COUNT + 1
         CALL UVWRIT (UVOUT, RPARM, VIS, IERR)
         IF (IERR.GT.0) GO TO 999
         END IF
 999  RETURN
      END
      SUBROUTINE VCAOUT (NCOR, ILOCU, ILOCV, ILOCW, ILOCT, NRPARM,
     *   ITIME1, ITIME2, MXBUFF, RPSAV, UVOUT, COUNT, AVETIM, AVEOUT,
     *   VISBUF, IERR)
C-----------------------------------------------------------------------
C! Write out Visibilities for one baseline
C   Inputs:
C      NCOR    I          Number of stokes in vis
C      ITIME1  I          Start Time index for vis
C      ITIME2  I          Stop  Time index for vis
C      MXBUF   I          Maximum buffer size
C      RPSAV   R(*)       Average random parameters
C      VISBUF  R(NREAL)   Buffer of visibilities to examine
C      UVOUT   C*?        Name of output data object
C      AVETIM  R          Average time (days) for baseline
C      AVEOUT  R          Interval to write out UV data (time between vis)
C   In/Output:
C      COUNT   I          Count of written visibilities
C   Output:
C      IERR    I          Error return code, 0=OK
C---------------------------------------------------------------------
      INTEGER   NCOR, ILOCU, ILOCV, ILOCW, ILOCT, NRPARM,
     *   ITIME1, ITIME2, MXBUFF, COUNT, IERR
      CHARACTER UVOUT*(*)
      INCLUDE 'UVSTUFF.INC'
      REAL      RPSAV(15, *), AVETIM, AVEOUT, VISBUF(*)
C
      INTEGER   J, LOOP, ISTART, ISTOP
      REAL      VIS(3,MXVS), RPARM(15), AVETM2, TIME, TSTART, TSTOP,
     *   FSTIME, LSTIME, PRETIM
C-----------------------------------------------------------------------
C                                       Average 1/2 range, time limit
      AVETM2 = AVETIM / 2.0
      FSTIME = RPSAV(ILOCT,ITIME1)
      LSTIME = RPSAV(ILOCT,ITIME2)
      PRETIM = -1E20
C                                       For all visibilities
      DO 300 LOOP = ITIME1,ITIME2
C                                       Get current time
         TIME = RPSAV(ILOCT,LOOP)
C                                       IF Time to aver and output
         IF (TIME-PRETIM.GE.AVEOUT) THEN
C                                       Average and output
            ISTART = 0
            ISTOP  = 0
C                                       If at begin or end of times
            IF ((TIME-AVETM2.LE.FSTIME) .OR. (LOOP.LE.ITIME1)) THEN
C                                       At beginning
               TSTART = FSTIME
               ISTART = ITIME1
               TSTOP  = MIN(FSTIME + AVETM2, LSTIME)
               END IF
C                                       If at end of time
            IF ((TIME+AVETM2.GE.LSTIME) .OR. (LOOP.GE.ITIME2)) THEN
               TSTOP = LSTIME
               ISTOP = ITIME2
               TSTART = MAX(LSTIME - AVETM2, FSTIME)
               END IF
C                                       If Start not set
            IF (ISTART.LE.0) THEN
C                                       Get start, stop times
               TSTART = TIME - AVETM2
               ISTART = ITIME1
C                                       Find start time, go backwards
               DO 100 J = LOOP-1, ITIME1, -1
C                                       If time before start time
                  IF (RPSAV(ILOCT,J).LT.TSTART) THEN
C
                     ISTART = J + 1
C                                       Exit when time found
                     GO TO 110
                     END IF
 100              CONTINUE
 110           CONTINUE
C                                       End if setting start
               END IF
C                                       if stop not set
            IF (ISTOP.LE.0) THEN
               TSTOP  = TIME + AVETM2
               ISTOP  = ITIME2
               DO 200 J = LOOP+1,ITIME2
C                                       If time after stop time
                  IF (RPSAV(ILOCT,J).GT.TSTOP) THEN
C
                     ISTOP = J - 1
C                                       Exit when time found
                     GO TO 210
                     END IF
 200              CONTINUE
 210           CONTINUE
C                                       End if setting stop
               END IF
C                                       Average random parms
            CALL RPAVE (ILOCU, ILOCV, ILOCW, ILOCT, NRPARM,
     *      ISTART, ISTOP, RPARM, RPSAV)
C                                       Reset time to current time
            RPARM(ILOCT) = TIME
C                                       Now average vis
            CALL VAVE (NCOR, ISTART, ISTOP, MXBUFF, VIS, VISBUF)
C                                       Write out result
            CALL V1OUT (NCOR, MXBUFF, RPARM, VIS, UVOUT,
     *         COUNT, VISBUF, IERR)
C                                       record time last written
            PRETIM = TIME
C                                       End if time to write
            END IF
C                                       End for all vis loop
 300     CONTINUE
      RETURN
      END
      SUBROUTINE VCOHER (NCOR, CORSTR, CORSTP, ILOCT, ITIME1, ITIME2,
     *   VECSCL, MXBUFF, RPSAV, VISBUF, COTIME)
C-----------------------------------------------------------------------
C! Get average coherence time
C   Inputs:
C      NCOR    I          Number of stokes in vis
C      CORSTR  I          Start correlator for coherence check
C      CORSTP  I          Stop  correlator for coherence check
C      ILOCT   I          Index to location of Time in random param.
C      ITIME1  I          Start Time index for vis
C      ITIME2  I          Stop  Time index for vis
C      VECSCL  R          Vector/Scalar Average limit
C      MXBUF   I          Maximum buffer size
C      RPSAVF  R(15,MXVIS)Random paramter buffer
C      VISBUF  R(NREAL)   Buffer of visibilities to examine
C   Output:
C      COTIME  R          Average coherence time
C---------------------------------------------------------------------
      INTEGER   NCOR, CORSTR, CORSTP, ILOCT, ITIME1, ITIME2, MXBUFF
      INCLUDE 'UVSTUFF.INC'
      REAL      VECSCL, RPSAV(15,*), COTIME, VISBUF(*)
C
      INTEGER   I, LOOP, NCOTIM, ICOTIM, ILAST
      LOGICAL   FLAGED
      REAL      VIS(3,MXVS)
C-----------------------------------------------------------------------
C                                       Init count of coherence times
      NCOTIM = 0
      COTIME = 0.
      ILAST  = 0
C                                       For all visibilities
      DO 200 LOOP = ITIME1,ITIME2
C                                       Get vis
         CALL VGET (NCOR, LOOP, MXBUFF, VIS, VISBUF)
C                                       Assume flagged
         FLAGED = .TRUE.
C                                       for all coherence correlators
         DO 100 I = CORSTR,CORSTP
C                                       If unflagged
            IF (VIS(3,I).GT.0.0) FLAGED = .FALSE.
 100        CONTINUE
C                                       If unflagged element
         IF ((.NOT.FLAGED) .AND. (LOOP.GT.ILAST)) THEN
C                                       Get coherence time
            CALL VSRATI (NCOR, CORSTR, CORSTP, LOOP, ITIME2, ICOTIM,
     *         VECSCL, MXBUFF, VISBUF)
C                                       If limit was found
            IF ((ICOTIM.GT.LOOP) .AND. (ICOTIM.LE.ITIME2)) THEN
C                                       Add coherence time to average
               COTIME = RPSAV(ILOCT, ICOTIM) - RPSAV(ILOCT, LOOP) +
     *                  COTIME
               NCOTIM = NCOTIM + 1
               END IF
C                                       Record end of last Coherence
            ILAST = ICOTIM
C                                       End if unflagged vis
            END IF
 200     CONTINUE
C                                       If points in average
      IF (NCOTIM.GT.0) THEN
         COTIME = COTIME / NCOTIM
      ELSE
C                                       Else use total time range
         IF (ITIME2.GT.ITIME1) THEN
            COTIME = RPSAV(ILOCT, ITIME1+1) - RPSAV(ILOCT,ITIME1)
            END IF
         END IF
 999  RETURN
      END
      SUBROUTINE VCOFLG (NCOR, ILOCT, ITIME1, ITIME2, MINSNR,
     *   MXBUFF, RPSAV, VISBUF, COTIME)
C-----------------------------------------------------------------------
C! Gets RMS and Flags visibilities within 1 coherence time
C   Inputs:
C      NCOR    I          Number of stokes in vis
C      ILOCT   I          Index to location of Time in random param.
C      ITIME1  I          Start Time index for vis
C      ITIME2  I          Stop  Time index for vis
C      MINSNR  R          Maximum diviation from Mean (Sigma)
C      MXBUF   I          Maximum buffer size
C      RPSAV   R(15,MXVIS)Random paramter buffer
C      COTIME  R          Average coherence time
C Input/Output:
C      VISBUF  R(NREAL)   Buffer of visibilities to examine
C-----------------------------------------------------------------------
      INTEGER   NCOR, ILOCT, ITIME1, ITIME2, MXBUFF
      INCLUDE 'UVSTUFF.INC'
      REAL      MINSNR, RPSAV(15,*), COTIME, VISBUF(*)
C
      INTEGER   LOOP, ISTART, ISTOP
      REAL      TSTART, TSTOP, VSS(3,MXVS), VSSRMS(3,MXVS)
C-----------------------------------------------------------------------
C                                       Only Flag if more than 2 vis
      IF (ABS(ITIME2-ITIME1).GT.2) THEN
C                                       Init average loop
         ISTART = ITIME1
         TSTART = RPSAV(ILOCT,ISTART)
C                                       For all visibilities
         DO 100 LOOP = ITIME1+1,ITIME2
            TSTOP = RPSAV(ILOCT, LOOP)
            ISTOP = LOOP - 1
C                                       If stop time > coherence
            IF (ABS(TSTOP-TSTART).GT.COTIME) THEN
C                                       If near end use all
               IF (ABS(LOOP-ITIME2).LT.3) ISTOP = ITIME2
C                                       If enough points, flag
               IF (ISTOP-ISTART.GT.2) THEN
C                                       Get average, RMS Vis
                  CALL VRMS (NCOR, ISTART, ISTOP, MXBUFF, VSS,
     *               VSSRMS, VISBUF)
C                                       Flag wild visibilities
                  CALL VFLAG (NCOR, ISTART, ISTOP, MXBUFF, MINSNR,
     *               VSS, VSSRMS, VISBUF)
C                                       End if enough points
               END IF
C                                       Reset start index
            ISTART = MIN (ISTOP+1, ITIME2)
            TSTART = RPSAV(ILOCT,ISTART)
C                                       End if coherence exceeded
            END IF
 100     CONTINUE
C                                       End if enough visibilities
         END IF
      RETURN
      END
      SUBROUTINE VZERO (NCOR, VIS)
C-----------------------------------------------------------------------
C   Zero the visibility array
C   Input:
C      NCOR   I            Number of correlators to zero
C   Output:
C      VIS    R((3,NCOR)   Visibility array, zeroed
C-----------------------------------------------------------------------
      INTEGER   NCOR
      REAL      VIS(3,*)
C
      INCLUDE 'UVSTUFF.INC'
      INTEGER   I
C-----------------------------------------------------------------------
      DO 100 I = 1,NCOR
         VIS(1,I) = 0.0
         VIS(2,I) = 0.0
         VIS(3,I) = 0.0
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE QCVMMA (APCORE, A, I, C, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Max. square of modulus of complex vector.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006-2007, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Find the maximum of the square modulus of a complex vector.
C      max (A(mI)**2 + A(mI+1)**2)      over m = 0 to N-1
C   Inputs:
C      A  I  Source vector base address
C      I  I  Increment of A (normally 2 * integer)
C      C  I  Destination vector.
C               0 = MAX(A ** 2) (real)
C               1  = location of max  (integer)
C      N  I  Element count
C   Also:
C            SPAD(15) = index of max.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   A, I, C, N
C
      INTEGER   II
      LONGINT   JA, JC, JI, TEST
      DOUBLE PRECISION VMAX, AMPL, DTEST
      EQUIVALENCE (DTEST, TEST)
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Addresses 1-rel
      JC = C + PSAPOF
      JA = A + PSAPOF
C                                       Init. max.
      VMAX = APCORE(JA)*APCORE(JA) + APCORE(JA+1)*APCORE(JA+1)
      JI = JA
      SPAD(15) = 1
C                                       Find max.
C                                       Note: contains a dependency.
      DO 100 II = 1,N
         AMPL = APCORE(JA)*APCORE(JA) + APCORE(JA+1)*APCORE(JA+1)
         IF (AMPL.GT.VMAX) THEN
            VMAX = AMPL
            JI = JA
            SPAD(15) = II
            END IF
         JA = JA + I
 100     CONTINUE
      APCORE(JC) = VMAX
      TEST = JI - PSAPOF
      APCORE(JC+1) = DTEST
C
 999  RETURN
      END

      SUBROUTINE FNDEXT (ITYPE, IHBLK, IVER)
C-----------------------------------------------------------------------
C! returns latest version number of specified extension file type
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FNDEXT will find the latest version number of a particular
C   extension file type.  If no type exists then zero is returned.
C   Inputs:
C      ITYPE   C*2     extension file type, example PL, HI.
C      IHBLK   I(256)  current catalog block.
C   Output:
C      IVER    I       latest version number of extension file.
C-----------------------------------------------------------------------
      CHARACTER ITYPE*2
      INTEGER   IHBLK(256), IVER
C
      CHARACTER TTYPE*2
      INTEGER   I, NEXTF
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      IVER = 0
C                                       Find extension ITYPE.
      CALL  FXHDEX (IHBLK)
      NEXTF = KHEXT + KIEXTN - 1
      DO 20 I = KHEXT,NEXTF
         CALL H2CHR (2, 1, IHBLK(I), TTYPE)
         IF (TTYPE.EQ.ITYPE) THEN
            IVER = IHBLK(KIVER+I-KHEXT)
            GO TO 999
            END IF
 20      CONTINUE
C
 999  RETURN
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QVCLIP (A, I, B, C, D, L, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Vector clip.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Limits the values in a vector to a specified range:
C     D(mL) = B     if A(mI) < B
C           = A(mI) if B <= A(mI) < C
C           = C     if C <= A(mI)    for m = 0 to N-1
C   Inputs:
C      A  I  First source vector base address
C      I  I  A address increment
C      B  I  Address of lower limit
C      C  I  Address of upper limit
C      D  I  Destination vector base address
C      L  I  D address increment
C      N  I  Element count
C-----------------------------------------------------------------------
      INTEGER   A, I, II, B, C, D, L, N, JA, JD
      REAL      VMAX, VMIN, VX
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Addresses 1-rel
      JA = A + 1
      JD = D + 1
C                                       Get limits
      VMIN = APCORE(B+1)
      VMAX = APCORE(C+1)
C                                       Loop
C@DIR IGNORE RECRDEPS(APCORE)
      DO 100 II = 1,N
         VX = APCORE(JA)
         IF (VX.GE.VMIN) GO TO 50
            APCORE(JD) = VMIN
            GO TO 90
 50      IF (VX.LE.VMAX) GO TO 60
            APCORE(JD) = VMAX
            GO TO 90
C                                       Save result
 60      APCORE(JD) = VX
C                                       Update pointers
 90      JA = JA + I
         JD = JD + L
 100     CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'TABED.INC'
C                                       Local include for TABED
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO, IVER,
     *   OVER, NUMTAB, CATOLD(256), CATBLK(256), BC, EC
      LOGICAL   SAME, SAMOUT
      HOLLERITH XNAMEI(3), XCLAIN(2), XXEXT, XNAMOU(3), XCLAOU(2), XXOP,
     *   XXKEY(2), XXKEYS(4)
      CHARACTER NAMEIN*12, CLAIN*6, XEXT*4, NAMOUT*12, CLAOUT*6, XOP*4,
     *   XKEY*8, XKEYS*16, TABTYP*2
      REAL      XSEQIN, XDISKI, XIVER, XSEQO, XDISKO, XOVER, XBC, XEC,
     *   APARM(10), XKEYV(2), XTIME(8)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XXEXT, XIVER,
     *   XNAMOU, XCLAOU, XSEQO, XDISKO, XOVER, XBC, XEC, XXOP, APARM,
     *   XXKEY, XKEYV, XXKEYS, XTIME
      COMMON /EDTINF/ CATOLD, SAME, SAMOUT, SEQIN, SEQOUT, DISKIN,
     *   DISKO, NEWCNO, OLDCNO, IVER, OVER, NUMTAB, BC, EC
      COMMON /CHRCOM/ NAMEIN, CLAIN, XEXT, NAMOUT, CLAOUT, XOP, XKEY,
     *   XKEYS, TABTYP
      COMMON /MAPHDR/ CATBLK
LOCAL END
      PROGRAM TABED
C-----------------------------------------------------------------------
C! Edits AIPS tables files
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2005-2008, 2014, 2016, 2021, 2026
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TABED edits AIPS extention tables files.
C   Adverbs:
C    INNAME      Input image name (name)
C    INCLASS     Input image name (class)
C    INSEQ       Input image name (seq. #)
C    INDISK      Input image disk unit #
C    INEXT       Input table extension type
C    INVERS      Input table file version no., -1=>all
C    OUTNAME     Output image name (name) NB: Def. output = input
C    OUTCLASS    Output image name (class)
C    OUTSEQ      Output image name (seq. #)
C    OUTDISK     Output image disk unit #.
C    OUTVERS     Output table file version., -1=>same as input
C    BCOUNT      Beginning row to copy
C    ECOUNT      Last row to copy: 0 => end
C    OPTYPE      'COPY','ADD ','MULT','DIV ',
C                'REPL','CLIP','DELE','INSR'
C                'KEY '
C    APARM       Column selection parameters:
C                1: Col. number.
C                2: Low subscript
C                3: High subscript
C                4: Keyword data type (1-6)
C                5: test col.
C                6: test value
C                7: test tolerance, 8: test subscript, 9: no. char.
C    KEYWORD     Name of table keyword.
C    KEYVALUE    Value given to numeric parm.
C    KEYSTRNG    Value given to a character-valued parameter.
C    TIMERANG    Time range to use.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, BUFFER(256), LOOP, LIM1, LIM2, NUMSEL, NFLAG,
     *   NPFLAG
      LOGICAL   NOTIME, ISCHAR
      INCLUDE 'TABED.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA PRGM /'TABED '/
C-----------------------------------------------------------------------
C                                       Initialize
      CALL TEDIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 995
      NFLAG = 0
      NPFLAG = 0
      NUMSEL = 0
C                                       Edit tables
      LIM1 = IVER
      LIM2 = IVER + NUMTAB - 1
      DO 100 LOOP = LIM1,LIM2
         IVER = LOOP
         IF (SAMOUT) OVER = LOOP
         CALL TEDITR (NOTIME, ISCHAR, NUMSEL, NFLAG, NPFLAG, IRET)
         IF (IRET.NE.0) GO TO 995
 100     CONTINUE
C                                       Add history to output
      CALL TEDHIS (NOTIME, ISCHAR, NUMSEL, NFLAG, NPFLAG)
C                                       Close down files, etc
 995  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE TEDIN (PRGM, IRET)
C-----------------------------------------------------------------------
C   Initialization subroutine for TABED
C   Inputs:  PRGM    C*6       Program name
C   Output:  IRET    I         Error code: 0 => ok
C                                4 => user routine detected error.
C                                5 => catalog troubles
C                                8 => can't start
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
C
      CHARACTER TYPE*2, STAT*4
      HOLLERITH CATOH(256)
      INTEGER   BUFF1(256), NPARM, IROUND, IERR
      INCLUDE 'TABED.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATOLD, CATOH)
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      IRET = 0
      BC = 10000000
      EC = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 46
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO = IROUND (XDISKO)
      IVER = IROUND (XIVER)
      OVER = IROUND (XOVER)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XXEXT, XEXT)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (4, 1, XXOP, XOP)
      CALL H2CHR (8, 1, XXKEY, XKEY)
      CALL H2CHR (16, 1, XXKEYS, XKEYS)
      TABTYP = XEXT(1:2)
C                                       APARM defaults
      IF (APARM(8).LT.0.5) APARM(8) = 1
      IF (APARM(9).LT.0.5) APARM(9) = 8
C                                       Find input
      OLDCNO = 1
      TYPE = '  '
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, TYPE,
     *   NLUSER, STAT, BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Default output = input
      IF (NAMOUT.EQ.' ') NAMOUT = NAMEIN
      IF (CLAOUT.EQ.' ') CLAOUT = CLAIN
      IF (SEQOUT.LE.0) SEQOUT = SEQIN
      IF (DISKO.LE.0) DISKO = DISKIN

      SAME = (NAMOUT.EQ.NAMEIN) .AND. (CLAOUT.EQ.CLAIN) .AND.
     *   (SEQOUT.EQ.SEQIN) .AND. (DISKO.EQ.DISKIN)
C                                       If OPTYPE='KEY ' SAME is true
      SAME = SAME .OR. (XOP.EQ.'KEY ')
      SAMOUT = (OVER.LT.0) .OR. (IVER.LT.0)
C                                       Output = input
      IF (SAME) THEN
         NEWCNO = OLDCNO
         IF (OVER.LE.0) OVER = IVER
C                                       Find output
      ELSE
         NEWCNO = 1
         TYPE = '  '
         CALL CATDIR ('SRCH', DISKO, NEWCNO, NAMOUT, CLAOUT, SEQOUT,
     *      TYPE, NLUSER, STAT, BUFF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1030) IRET, NAMOUT, CLAOUT, SEQOUT, DISKO,
     *         NLUSER
            GO TO 990
            END IF
         END IF
      STAT = 'READ'
      IF (SAME) STAT = 'REST'
C                                       Read old CATBLK and mark 'READ'
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, STAT, BUFF1, IRET)
      IF ((IRET.GT.0) .AND. (IRET.LT.5)) THEN
         WRITE (MSGTXT,1040) IRET
         GO TO 990
         END IF
      IF (.NOT.SAME) THEN
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKIN
         FCNO(NCFILE) = OLDCNO
         FRW(NCFILE) = 0
         END IF
C                                       Check number of tables
      CALL FNDEXT (TABTYP, CATOLD, NUMTAB)
      NUMTAB = MAX (1, NUMTAB)
C                                       See if all tables wanted
      IF (IVER.LT.0) THEN
         IVER = 1
      ELSE
         NUMTAB = 1
         END IF
C                                       Read new CATBLK and mark 'WRIT'
      CALL CATIO ('READ', DISKO, NEWCNO, CATBLK, 'WRIT', BUFF1, IRET)
      IF ((IRET.GT.0) .AND. (IRET.LT.5)) THEN
         WRITE (MSGTXT,1040) IRET
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 1
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' GETTING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE TEDITR (NOTIME, ISCHAR, NUMSEL, NFLAG, NPFLAG, IRET)
C-----------------------------------------------------------------------
C   Subroutine to edit Tables
C   Output:
C      NOTIME   L    If true, no "TIME" column was present.
C      ISCHAR   L    If true, the operation involved character input.
C      NUMSEL   I    Number of records selected.
C      NFLAG    I    Number records flagged
C      IRET     I    Return code, 0=OK, else failed.
C-----------------------------------------------------------------------
      INTEGER   NUMSEL, NFLAG, NPFLAG, IRET
      LOGICAL   NOTIME, ISCHAR
C
      INTEGER   MAXKEY, MAXREC
C                                       MAXKEY = Max. no. keyword/value
C                                       pairs.
      PARAMETER (MAXKEY=1024)
C                                       MAXREC = Dimension of REC.
      INCLUDE 'INCS:PUVD.INC'
      PARAMETER (MAXREC=XBPRSZ)
      CHARACTER CHTIME*24, CHTRUE*8, OPCOD(9)*4, DTYPE(6)*8,
     *   COLPAC*1024, KEYDUM(MAXKEY)*8
      HOLLERITH RECH(MAXREC), VALH(2)
      INTEGER   BUFFER(512,2), LUN1, LUN2, NOPT, IOPT, I, IROUND, IBIN,
     *   IBOUT, NREC, NCOL, DATP(128,2), IRCODE, NKEY, KOLS(10), TIMKOL,
     *   REC(MAXREC), TYPCOD, CHKKOL, LOCS(MAXKEY), KEYTYP(MAXKEY),
     *   DATKOL, DATKLT, ARGI, NCHAR, LENGTH, VALUE(2*MAXKEY), I1, I2,
     *   IKEY, ICHPAT(8), CHKLEN, CHKPNT, NCOMP, NUMIN, NUMOUT, RNOIN,
     *   RNOOUT, LOOP, LIMIT1, LIMIT2, N, MFLAG, MPFLAG, MUMSEL
      LOGICAL   T, NEWTAB, EQUAL, ARGL, DOTR, DOTD, DOCHK, CHKI, CHKR,
     *   CHKD, CHKCH, VALL, LARRAY(100), FLAG, PFLAG
      REAL     VALR(2), RECR(MAXREC), ARGR, ARG2
      DOUBLE PRECISION T1, T2, TIME, RECD(MAXREC/2), ARGD, CHKVAL,
     *   CHKTOL, VALD, TEMPD, CHECK
      INCLUDE 'TABED.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (REC, RECH, RECR, RECD)
      EQUIVALENCE (VALUE, VALH, VALL, VALR, VALD)
      DATA CHTIME, CHTRUE /'TIME                    ','.TRUE.  '/
      DATA LUN1, LUN2 /27,28/
      DATA NOPT /9/
      DATA T /.TRUE./
      DATA OPCOD /'COPY','ADD ','MULT','DIV ','CLIP','REPL','DELE',
     *   'UFLG','KEY '/
      DATA DTYPE /'DOUBLE  ', 'SINGLE  ', 'CHAR    ',
     *   'LOGICAL ', 'INTEGER ', 'INTEGER '/
C-----------------------------------------------------------------------
      NOTIME = .TRUE.
      MUMSEL = 0
      MFLAG = 0
      MPFLAG = 0
C                                       Find OPcode
      IOPT = 0
      DO 40 I = 1,NOPT
         IF (XOP.EQ.OPCOD(I)) IOPT = I
 40      CONTINUE
      IF (IOPT.LE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1040) XOP
         GO TO 990
         END IF
C                                       Same table?
      SAME = SAME .AND. ((OVER.EQ.0) .OR. (OVER.EQ.IVER))
C                                       On 'COPY' output must be
C                                       .NOT.SAME
      IF (SAME .AND. (IOPT.EQ.1)) THEN
         OVER = 0
         SAME = .FALSE.

      ELSE IF ((IOPT.EQ.7) .OR. (IOPT.EQ.8) .OR. (SAME)) THEN
         APARM(10) = -1.0
         END IF
C                                       For KEYWORD open read first.
      IF (IOPT.EQ.NOPT) THEN
         DISKO = DISKIN
         NEWCNO = OLDCNO
         OVER = IVER
         CALL COPY (256, CATBLK, CATOLD)
         END IF
C                                       Open table(s)
      IBIN = 1
      IBOUT = 2
      IF (SAME) IBOUT = IBIN
      CALL TABINI ('READ', TABTYP, DISKIN, OLDCNO, IVER, CATOLD, LUN1,
     *   NKEY, NREC, NCOL, DATP, BUFFER(1,IBIN), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) IRET, 'READ', TABTYP, IVER
         GO TO 990
         END IF
C                                       If SAME close and reopen WRITE
      IF (SAME) THEN
         OVER = IVER
         CALL TABIO ('CLOS', IRCODE, RNOIN, REC, BUFFER(1,IBIN), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1800) IRET, TABTYP, IVER
            GO TO 990
            END IF
         END IF
C                                       Open output
      IKEY = NKEY
      NREC = BUFFER(5,IBIN)
      CALL TABINI ('WRIT', TABTYP, DISKO, NEWCNO, OVER, CATBLK, LUN2,
     *   IKEY, NREC, NCOL, DATP, BUFFER(1,IBOUT), IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET, 'WRIT', TABTYP, IVER
         GO TO 990
         END IF
      NEWTAB = IRET.LT.0
C                                       Mark output as unsorted
      BUFFER(43,IBOUT) = 0
      BUFFER(44,IBOUT) = 0
C                                       See if A "TIME" axis exists
      IKEY = 1
      MSGSUP = 32000
      CALL FNDCOL (IKEY, CHTIME, 24, T, BUFFER(1,IBIN), KOLS, IRET)
      MSGSUP = 0
      NOTIME = IRET.NE.0
      IRET = 0
      I = KOLS(1)
      TIMKOL = DATP(I,1)
      DOTR = (.NOT.NOTIME) .AND. (MOD (DATP(I,2), 10).EQ.2)
      DOTD = (.NOT.NOTIME) .AND. (MOD (DATP(I,2), 10).EQ.1)
C                                       Set time range
      T1 = XTIME(1) + (XTIME(2) / 24.0) + (XTIME(3) / 1440.0) +
     *   (XTIME(4) / 86400.0)
      T2 = XTIME(5) + (XTIME(6) / 24.0) + (XTIME(7) / 1440.0) +
     *   (XTIME(8) / 86400.0)
      IF (ABS(T1).LE.1.0E-10) THEN
         T1 = -100000.0
         XTIME(1) = -100000.0
         END IF
      IF (ABS(T2).LE.1.0E-10) THEN
         T2 = 100000.0
         XTIME(5) = 100000.0
         END IF
      NOTIME = NOTIME .OR. ((T1.LT.-99999.0) .AND. (T2.GT.99999.0))
      TIME = (T1 + T2) * 0.5D0
C                                       New table, copy keywords. etc.
      IF (NEWTAB) CALL TABUP (BUFFER, NCOL, NKEY, REC, VALUE,
     *   LOCS, KEYTYP, KEYDUM, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Non-KEYWORD operations
      IF (IOPT.NE.NOPT) THEN
C                                       Get number of input records
         NUMIN = BUFFER(5,IBIN)
C                                       Get number of records in output
         NUMOUT = BUFFER(5,IBOUT)
C                                       Setup for checking column value.
         DOCHK = APARM(5).GT.0.0
         CHKKOL = IROUND (APARM(5))
         CHKI = (DOCHK) .AND. (MOD (DATP(CHKKOL,2), 10).EQ.6)
         CHKI = (DOCHK) .AND. (MOD (DATP(CHKKOL,2), 10).EQ.4)
         CHKCH = (DOCHK) .AND. (MOD (DATP(CHKKOL,2), 10).EQ.3)
         CHKR = (DOCHK) .AND. (MOD (DATP(CHKKOL,2), 10).EQ.2)
         CHKD = (DOCHK) .AND. (MOD (DATP(CHKKOL,2), 10).EQ.1)
         DOCHK = DOCHK .AND. (CHKI.OR.CHKR.OR.CHKD.OR.CHKCH)
         CHKLEN = DATP(CHKKOL,2) / 10
         CHKKOL = DATP(CHKKOL,1)
         CHKVAL = APARM(6)
         CHKTOL = APARM(7)
         CHKPNT = APARM(8) + 0.5
         IF (CHKPNT.LT.1) CHKPNT = 1
         IF (CHKPNT.GT.CHKLEN) CHKPNT = CHKLEN
         APARM(8) = CHKPNT
C                                       Special for character test.
         IF (CHKCH) THEN
            NCOMP = APARM(9) + 0.5
            CALL PSFORM (NCOMP, XKEY, ICHPAT)
            END IF
C                                       Find data type code and column
C                                       pointer for column to work on.
         I = IROUND (APARM(1))
C                                       No col for "COPY","DELE","UFLG"
         IF (IOPT.EQ.1) I = 1
         IF (IOPT.GT.6) I = 1
         IF ((I.LT.1) .OR. (I.GT.NCOL)) THEN
            IRET = 1
            WRITE (MSGTXT,1120) I, NCOL
            GO TO 990
            END IF
         TYPCOD = MOD (DATP(I,2), 10)
         LENGTH = DATP(I,2) / 10
         N = LENGTH
         DATKOL = DATP(I,1)
C                                       No col. for "COPY"
         IF (IOPT.EQ.1) TYPCOD = 0
         ISCHAR = (TYPCOD.EQ.3) .OR. (TYPCOD.EQ.5) .OR. (TYPCOD.EQ.7)
C                                       Set array limits
         I1 = IROUND (APARM(2))
         I2 = IROUND (APARM(3))
         IF (I1.LE.0) I1 = 1
         IF (I2.LE.0) I2 = LENGTH
         IF (I2.GT.LENGTH) I2 = LENGTH
C                                       Check allowed operations for
C                                       data types:
         IF ((IOPT.GE.2) .AND. (IOPT.LE.5) .AND. (ISCHAR)) THEN
            IRET = 3
            WRITE (MSGTXT,1150) XOP, DTYPE(TYPCOD)
            GO TO 990
            END IF
C                                       need a value
         IF ((IOPT.GT.1) .AND. (IOPT.LT.7)) THEN
C                                       Get operand in correct form
C                                       Double precision
            CALL POPSRD ('R2D', XKEYV, ARGD)
C                                       Single precision
            ARGR = XKEYV(1)
            ARG2 = XKEYV(2)
C                                       Integer
            IF (TYPCOD.EQ.4) ARGI = IROUND (ARGR)
C                                       No. char.
            NCHAR = I2 - I1 + 1
            NCHAR = MIN (16, LENGTH, NCHAR)
C                                       Logical
            ARGL = CHTRUE .EQ. XKEYS(1:8)
            END IF
C                                       Loop thru table
         LIMIT1 = 1
         IF (XBC.GT.0.1) LIMIT1 = XBC + 0.5
         IF (LIMIT1.GT.NUMIN) LIMIT1 = NUMIN
         BC = MIN (LIMIT1, BC)
         LIMIT2 = NUMIN
         IF (XEC.GT.0.1) LIMIT2 = XEC + 0.5
         IF (LIMIT2.GT.NUMIN) LIMIT2 = NUMIN
         EC = MAX (LIMIT2, EC)
         IRCODE = 0
         RNOOUT = NUMOUT
         DO 200 LOOP = 1,NUMIN
            FLAG = .FALSE.
            PFLAG = .FALSE.
C                                       Read input record.
            RNOIN = LOOP
            CALL TABIO ('READ', IRCODE, RNOIN, REC, BUFFER(1,IBIN),
     *         IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1160) IRET, 'READ', RNOIN
               GO TO 990
               END IF
C                                       Ignore blanked except UFLG
            IF (IRET.LT.0) THEN
               PFLAG = .TRUE.
               FLAG = .TRUE.
               IF (IOPT.NE.8) GO TO 180
            ELSE
               IF (IOPT.EQ.8) GO TO 180
               END IF
            IF ((LOOP.LT.LIMIT1) .OR. (LOOP.GT.LIMIT2)) GO TO 180
C                                       Check time
            IF (DOTR) TIME = RECR(TIMKOL)
            IF (DOTD) TIME = RECD(TIMKOL)
            IF ((TIME.LT.T1) .OR. (TIME.GT.T2)) GO TO 180
C                                       Check test col:
            IF (CHKI) CHECK = REC(CHKKOL+CHKPNT-1)
            IF (CHKR) CHECK = RECR(CHKKOL+CHKPNT-1)
            IF (CHKD) CHECK = RECD(CHKKOL+CHKPNT-1)
C                                       Character test
            IF (CHKCH) THEN
               CALL H2CHR (CHKLEN, 1, RECH(CHKKOL), COLPAC)
               CALL CHWMAT (NCOMP, XKEY, ICHPAT, CHKPNT, COLPAC, EQUAL)
               CHECK = CHKVAL + 10.0 + 10.0 * CHKTOL
               IF (EQUAL) CHECK = CHKVAL
               END IF
            IF (DOCHK .AND. (ABS (CHECK-CHKVAL).GT.CHKTOL)) GO TO 180
C                                       Count records selected.
            MUMSEL = MUMSEL + 1
            DATKLT = DATKOL + I1 - 1
C                                       Characters (REPL only)
            IF (TYPCOD.EQ.3) THEN
               CALL CHR2H (NCHAR, XKEYS, I1, RECH(DATKOL))
C                                       Logical (REPL only)
            ELSE IF ((TYPCOD.EQ.5) .OR. (TYPCOD.EQ.7)) THEN
               CALL LG2BIT (N, LARRAY, REC(DATKOL), -1)
               DO 110 I = I1,I2
                  LARRAY(I) = ARGL
 110              CONTINUE
               CALL LG2BIT (N, LARRAY, REC(DATKOL), 1)
C                                       ADD
            ELSE IF (IOPT.EQ.2) THEN
               DO 120 I = I1,I2
                  IF (TYPCOD.EQ.1) RECD(DATKLT) = RECD(DATKLT) + ARGD
                  IF (TYPCOD.EQ.2) RECR(DATKLT) = RECR(DATKLT) + ARGR
                  IF (TYPCOD.EQ.4) REC(DATKLT) = REC(DATKLT) + ARGI
                  DATKLT = DATKLT + 1
 120              CONTINUE
C                                       MULT
            ELSE IF (IOPT.EQ.3) THEN
               DO 130 I = I1,I2
                  IF (TYPCOD.EQ.1) RECD(DATKLT) = RECD(DATKLT) * ARGD
                  IF (TYPCOD.EQ.2) RECR(DATKLT) = RECR(DATKLT) * ARGR
                  IF (TYPCOD.EQ.4) REC(DATKLT) = REC(DATKLT) * ARGI
                  DATKLT = DATKLT + 1
 130              CONTINUE
C                                       DIV
            ELSE IF (IOPT.EQ.4) THEN
               DO 140 I = I1,I2
                  IF (TYPCOD.EQ.1) RECD(DATKLT) = RECD(DATKLT) / ARGD
                  IF (TYPCOD.EQ.2) RECR(DATKLT) = RECR(DATKLT) / ARGR
                  IF (TYPCOD.EQ.4) REC(DATKLT) = REC(DATKLT) / ARGI
                  DATKLT = DATKLT + 1
 140              CONTINUE
C                                       CLIP
            ELSE IF (IOPT.EQ.5) THEN
               DO 150 I = I1,I2
                  IF (TYPCOD.EQ.1) TEMPD = RECD(DATKLT)
                  IF (TYPCOD.EQ.2) TEMPD = RECR(DATKLT)
                  IF (TYPCOD.EQ.4) TEMPD = REC(DATKLT)
                  IF (ARGR.LT.ARG2) THEN
                     IF ((TEMPD.LT.ARGR) .OR. (TEMPD.GT.ARG2))
     *                  FLAG = .TRUE.
                  ELSE
                     IF ((TEMPD.GE.ARG2) .AND. (TEMPD.LE.ARGR))
     *                  FLAG = .TRUE.
                     END IF
                  DATKLT = DATKLT + 1
 150              CONTINUE
C                                       REPL
            ELSE IF (IOPT.EQ.6) THEN
               DO 160 I = I1,I2
                  IF (TYPCOD.EQ.1) RECD(DATKLT) = ARGD
                  IF (TYPCOD.EQ.2) RECR(DATKLT) = ARGR
                  IF (TYPCOD.EQ.4) REC(DATKLT) = ARGI
                  DATKLT = DATKLT + 1
 160              CONTINUE
C                                       DELE, UFLG
            ELSE IF ((IOPT.EQ.7) .OR. (IOPT.EQ.8)) THEN
               FLAG = .NOT.FLAG
               END IF
            GO TO 190
C                                       do not copy all??
 180        IF (APARM(10).GT.0.0) GO TO 200
C                                       output
 190        IF (SAME) THEN
               RNOOUT = RNOIN
            ELSE
               RNOOUT = RNOOUT + 1
               END IF
            IF (FLAG) THEN
               IF (PFLAG) THEN
                  MPFLAG = MPFLAG + 1
               ELSE
                  MFLAG = MFLAG + 1
                  END IF
               CALL TABIO ('FLAG', IRCODE, RNOOUT, REC, BUFFER(1,IBOUT),
     *            IRET)
            ELSE
               CALL TABIO ('WRIT', IRCODE, RNOOUT, REC, BUFFER(1,IBOUT),
     *            IRET)
               END IF
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1160) IRET, 'WRIT', RNOOUT
               GO TO 990
               END IF
 200        CONTINUE
C                                       Tell number of records selected
         WRITE (MSGTXT,1200) MUMSEL
         CALL MSGWRT (4)
         WRITE (MSGTXT,1201) MFLAG
         IF (MFLAG.GT.0) CALL MSGWRT (4)
         WRITE (MSGTXT,1202) MPFLAG
         IF (MPFLAG.GT.0) CALL MSGWRT (4)
         NUMSEL = NUMSEL + MUMSEL
         NFLAG = NFLAG + MFLAG
         NPFLAG = NPFLAG + MPFLAG
C                                       Keyword operations
      ELSE
         NKEY = 1
         KEYTYP(1) = IROUND (APARM(4))
C                                       6 (short integer) now 4
         IF (KEYTYP(1).EQ.6) KEYTYP(1) = 4
C                                       single precision deprecated too
         IF (KEYTYP(1).EQ.2) KEYTYP(1) = 1
         ISCHAR = (KEYTYP(1).EQ.3) .OR. (KEYTYP(1).EQ.5) .OR.
     *      (KEYTYP(1).EQ.7)
C                                       Enter data in VALUE via
C                                       EQUIVALENCE
         VALD = 0.0D0
         CALL POPSRD ('R2D', XKEYV, TEMPD)
         IF (KEYTYP(1).EQ.1) VALD = TEMPD
         IF (KEYTYP(1).EQ.3) CALL CHR2H (8, XKEYS(1:8), 1, VALH(1))
         IF (KEYTYP(1).EQ.4) VALUE(1) = IROUND (XKEYV(1))
         IF (KEYTYP(1).EQ.5) VALL = CHTRUE .EQ. XKEYS(1:8)
         LOCS(1) = 1
         NOTIME = .TRUE.
C                                       Write/update keyword.
         CALL TABKEY ('WRIT', XKEY, NKEY, BUFFER(1,IBOUT), LOCS, VALUE,
     *      KEYTYP, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1500) IRET
            GO TO 990
            END IF
         END IF
C                                       Close tables
      CALL TABIO ('CLOS', IRCODE, RNOIN, REC, BUFFER(1,IBIN), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1800) IRET, TABTYP, IVER
         GO TO 990
         END IF
      IF (.NOT.SAME) THEN
         CALL TABIO ('CLOS', IRCODE, RNOOUT, REC, BUFFER(1,IBOUT), IRET)
         IF (IRET.NE.0) WRITE (MSGTXT,1800) IRET, TABTYP, OVER
         END IF
C                                       Error
 990  IF (IRET.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('UNKNOWN OPTYPE = ',A4)
 1100 FORMAT ('TABINI ERROR ',I3,' OPEN FOR ',A4,1X,A2,', TABLE ',
     *   ' VER=',I3)
 1120 FORMAT ('COLUMN ',I3,' OUT OF RANGE (1:',I4,')')
 1150 FORMAT ('OPTYPE ',A4,' INAPPROPRIATE FOR DATA TYPE ',A8)
 1160 FORMAT ('TABIO ERROR',I3,1X,A4,'ING RECORD ',I7)
 1200 FORMAT (I8, ' Records selected')
 1201 FORMAT (I8, ' Records of these were flagged')
 1202 FORMAT (I8, ' Records were previously flagged')
 1500 FORMAT ('TABKEY ERROR',I3,' WRITING/UPDATING TABLE KEYWORD')
 1800 FORMAT ('TABIO ERROR ',I3,' CLOSING ',A2,' TABLE VER=',I3)
      END
      SUBROUTINE TEDHIS (NOTIME, ISCHAR, NUMSEL, NFLAG, NPFLAG)
C-----------------------------------------------------------------------
C   Add reference in output history
C   Input:
C      NOTIME   L   If true then no time selection was done.
C      ISCHAR   L   If true operation used character input
C      NUMSEL   I   Number of records selected.
C      NFLAG    I   Number records flagged
C      NPFLAG   I   Number records previously flagged
C-----------------------------------------------------------------------
      LOGICAL   NOTIME, ISCHAR
      INTEGER   NUMSEL, NFLAG, NPFLAG
C
      CHARACTER HILINE*72, CTIME(2)*12
      INTEGER   BUFFER(1024), LUN1, IRET, IAPARM(10), I, IROUND,
     *   TIME(3), DATE(3)
      REAL      TIME1, TIME2
      LOGICAL   T
      INCLUDE 'TABED.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      DATA LUN1 /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN1, DISKO, NEWCNO, BUFFER, IRET)
      IF (IRET.GT.2) THEN
         WRITE (MSGTXT,1070) IRET
         CALL MSGWRT (6)
         GO TO 250
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,1100) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN1, HILINE, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 250
C                                       Input file
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN1, BUFFER,
     *   IRET)
      IF (IRET.NE.0) GO TO 250
C                                       Type and version
      IF (NUMTAB.GT.1) THEN
         IVER = IROUND (XIVER)
         OVER = IROUND (XOVER)
         END IF
      WRITE (HILINE,2000) TSKNAM, TABTYP, IVER, OVER
      CALL HIADD (LUN1, HILINE, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 250
C                                       BCOUNT, ECOUNT
      IF (XOP.NE.'KEY ') THEN
         WRITE (HILINE,2001) TSKNAM, BC, EC
         CALL HIADD (LUN1, HILINE, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 250
         END IF
C                                       OPTYPE
      WRITE (HILINE,2002) TSKNAM, XOP
      CALL HIADD (LUN1, HILINE, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 250
C                                       APARM (integer)
      DO 150 I = 1,10
         IAPARM(I) = IROUND (APARM(I))
 150     CONTINUE
      WRITE (HILINE,2003) TSKNAM, (IAPARM(I), I=1,5)
      CALL HIADD (LUN1, HILINE, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 250
C                                       Test values
      IF (APARM(5).GT.0.001) THEN
         WRITE (HILINE,3004) TSKNAM, APARM(6), APARM(7)
         CALL HIADD (LUN1, HILINE, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 250
         WRITE (HILINE,3005) TSKNAM, IAPARM(8), IAPARM(9)
         CALL HIADD (LUN1, HILINE, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 250
         END IF
C                                       KEYWORD
      IF (('KEY '.EQ.XOP) .OR. (APARM(5).GT.0.1)) THEN
         WRITE (HILINE,2004) TSKNAM, XKEY
         CALL HIADD (LUN1, HILINE, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 250
         END IF
C                                       KEYSTRING
      IF (ISCHAR) THEN
         WRITE (HILINE,2005) TSKNAM, XKEYS
         CALL HIADD (LUN1, HILINE, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 250
C                                       KEYVALUE
      ELSE
         WRITE (HILINE,2006) TSKNAM, XKEYV
         CALL HIADD (LUN1, HILINE, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 250
         END IF
C                                       TIMERANG
      IF (.NOT.NOTIME) THEN
         TIME1 = XTIME(1) + (XTIME(2) / 24.0) + (XTIME(3) / 1440.0) +
     *      (XTIME(4) / 86400.0)
         TIME2 = XTIME(5) + (XTIME(6) / 24.0) + (XTIME(7) / 1440.0) +
     *      (XTIME(8) / 86400.0)
         CALL HITIME (TIME1, TIME2, LUN1, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 250
         END IF
C                                       Number of records selected
      IF (XOP.NE.'KEY ') THEN
         WRITE (HILINE,2008) TSKNAM, NUMSEL
         CALL HIADD (LUN1, HILINE, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 250
         IF (NFLAG.GT.0) THEN
            WRITE (HILINE,2009) TSKNAM, NFLAG
            CALL HIADD (LUN1, HILINE, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 250
            END IF
         IF (NPFLAG.GT.0) THEN
            WRITE (HILINE,2010) TSKNAM, NPFLAG
            CALL HIADD (LUN1, HILINE, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 250
            END IF
         END IF
C                                       Close HI file
 250  CALL HICLOS (LUN1, T, BUFFER, IRET)
 999  RETURN
C-----------------------------------------------------------------------
 1070 FORMAT ('ERROR',I3,' OPENING HISTORY FILE')
 1100 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 2000 FORMAT (A6,' INEXT=''',A2,''' INVERS=',I4,' OUTVERS=', I4)
 2001 FORMAT (A6,' BCOUNT =',I8,' ECOUNT =',I8,' /Range of rows')
 2002 FORMAT (A6,' OPTYPE = ''',A4,''' /Operation code')
 2003 FORMAT (A6,' APARM=',4(I6,','),I6,' /Control info')
 3004 FORMAT (A6,' APARM(6)=',1PE13.5,', APARM(7)=',1E13.5,
     *   ' /Test value, tol.')
 3005 FORMAT (A6,' APARM(8)=',I6,', APARM(9)=',I6,
     *   ' /Test subscript, no. char.')
 2004 FORMAT (A6,' KEYWORD = ''',A8,'''')
 2005 FORMAT (A6,' KEYSTRING = ''',A16,''' /Char. operand')
 2006 FORMAT (A6,' KEYVALUE = ',1PE15.7,',',E15.7,' /Num. operand')
 2008 FORMAT (A6,' / ',I8,' Records selected')
 2009 FORMAT (A6,' / ',I8,' Records flagged')
 2010 FORMAT (A6,' / ',I8,' Records previously flagged')
      END
      SUBROUTINE TABUP (BUFFER, NCOL, NKEY, REC, VALUE, LOCS, KEYTYP,
     *     KEYDUM, IRET)
C-----------------------------------------------------------------------
C   Routine to update the header of a newly created table.
C   Inputs:
C    Buffer(512,2)   I    TABIO buffer of the old (*,1) and new (*,2)
C                         tables.
C    NCOL            I    Number of columns
C    NKEY            I    Number of keywords
C  Output:
C    REC(XBPRSZ)     I    Record array for I/O
C    VALUE(*)        I    Array for TABKEY.
C    LOCS(*)         I    Array for TABKEY.
C    KEYTYP(*)       I    Array for TABKEY.
C    KEYDUM(*)       C*8  Work array for keyword names.
C    IRET            I    Error code, 0=OK, else TABIO or TABKEY error.
C-----------------------------------------------------------------------
      INTEGER   BUFFER(512,2), NCOL, NKEY, REC(*), VALUE(*), LOCS(*),
     *   KEYTYP(*), IRET
      CHARACTER KEYDUM(NKEY)*8
C
      INTEGER   IKEY, IRCODE, NTT, IRNO
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Update keywords
C                                       Read
      IKEY = NKEY
      CALL TABKEY ('ALL ', KEYDUM, IKEY, BUFFER(1,1), LOCS, VALUE,
     *   KEYTYP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Write
      CALL TABKEY ('WRIT', KEYDUM, IKEY, BUFFER(1,2), LOCS, VALUE,
     *   KEYTYP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1050) IRET
         GO TO 990
         END IF
C                                       Copy  labels, units
      DO 100 IRNO = 1,NCOL
C                                       Col. labels.
         IRCODE = 3
C                                       Read
         CALL TABIO ('READ', IRCODE, IRNO, REC, BUFFER(1,1), IRET)
         IF (IRET.NE.0) GO TO 980
C                                       Write
         CALL TABIO ('WRIT', IRCODE, IRNO, REC, BUFFER(1,2), IRET)
         IF (IRET.NE.0) GO TO 980
C                                       Units
         IRCODE = 4
C                                       Read
         CALL TABIO ('READ', IRCODE, IRNO, REC, BUFFER(1,1), IRET)
         IF (IRET.NE.0) GO TO 980
C                                       Write
         CALL TABIO ('WRIT', IRCODE, IRNO, REC, BUFFER(1,2), IRET)
         IF (IRET.NE.0) GO TO 980
 100     CONTINUE
C                                       Fill in Table title
      NTT = 14
      CALL RCOPY (NTT, BUFFER(101,1), BUFFER(101,2))
      GO TO 999
C                                       TABIO error
 980  WRITE (MSGTXT,1980) IRET
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TABKEY ERROR',I3,' READ-FOR-COPY TABLE KEYWORDS')
 1050 FORMAT ('TABKEY ERROR',I3,' WRITE-FOR-COPY TABLE KEYWORDS')
 1980 FORMAT ('TABUP: TABIO ERROR',I3,' UPDATING NEW HEADER')
      END

      SUBROUTINE POLCHK (PPLOT, POLPLT)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2007, 2018, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  Routine to decide of the requested polzn plot type is valid.
C  Input:
C    PPLOT      C*8      requested pol operation, can be one of:
C                        ' ', 'RL/RR', 'LR/RR', 'LL/RR'
C                             'RL/LL', 'LR/LL', 'RR/LL'
C                             'Q/I', 'U/I', 'V/I'
C                        also linears
C  Output:
C    POLPLT     I        Integer plottype corresponding to the above
C                        0,    1,       2,       3,
C                              4,       5,       6
C                              7      8      9
C                        0 => don't perform the polzn operation.
C
C  Uses FNDPOL to determine if the operation is valid.
C-----------------------------------------------------------------------
      CHARACTER PPLOT*8
      INTEGER   POLPLT
C
      INTEGER   KLEN, IERR, ITRIM
      CHARACTER STKCHR*4
C-----------------------------------------------------------------------
      POLPLT = 0
C                                       Check validity of the string
      KLEN = ITRIM(PPLOT)
C                                       circular feeds
      IF ((KLEN.EQ.5) .AND. (PPLOT(3:3).EQ.'/')) THEN
         IF ((PPLOT(1:2).NE.'RL') .AND. (PPLOT(1:2).NE.'LR') .AND.
     *      (PPLOT(1:2).NE.'RR') .AND. (PPLOT(1:2).NE.'LL') .AND.
     *      (PPLOT(1:2).NE.'VH') .AND. (PPLOT(1:2).NE.'HV') .AND.
     *      (PPLOT(1:2).NE.'VV') .AND. (PPLOT(1:2).NE.'HH')) GO TO 999
         IF ((PPLOT(4:5).NE.'RL') .AND. (PPLOT(4:5).NE.'LR') .AND.
     *      (PPLOT(4:5).NE.'RR') .AND. (PPLOT(4:5).NE.'LL') .AND.
     *      (PPLOT(4:5).NE.'VH') .AND. (PPLOT(4:5).NE.'HV') .AND.
     *      (PPLOT(4:5).NE.'VV') .AND. (PPLOT(4:5).NE.'HH')) GO TO 999
         IF (PPLOT(1:2).EQ.PPLOT(4:5)) GO TO 999
C                                       Set up for FNDPOL
         IF ((PPLOT(1:2).EQ.'RR') .OR. (PPLOT(1:2).EQ.'LL') .OR.
     *      (PPLOT(1:2).EQ.'VV') .OR. (PPLOT(1:2).EQ.'HH')) THEN
            STKCHR = 'HALF'
         ELSE
            STKCHR = 'FULL'
            END IF
         CALL FNDPOL (STKCHR, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Set up POLPLT
         IF (STKCHR.EQ.'HALF') THEN
            IF (PPLOT(1:2).EQ.'RR') POLPLT = 6
            IF (PPLOT(1:2).EQ.'LL') POLPLT = 3
            IF (PPLOT(1:2).EQ.'VV') POLPLT = 6
            IF (PPLOT(1:2).EQ.'HH') POLPLT = 3
         ELSE IF (STKCHR.EQ.'FULL') THEN
            IF (PPLOT(4:5).EQ.'RR') THEN
               IF (PPLOT(1:2).EQ.'RL') POLPLT = 1
               IF (PPLOT(1:2).EQ.'LR') POLPLT = 2
            ELSE IF (PPLOT(4:5).EQ.'VV') THEN
               IF (PPLOT(1:2).EQ.'VH') POLPLT = 1
               IF (PPLOT(1:2).EQ.'HV') POLPLT = 2
            ELSE
               IF (PPLOT(1:2).EQ.'RL') POLPLT = 4
               IF (PPLOT(1:2).EQ.'LR') POLPLT = 5
               IF (PPLOT(1:2).EQ.'HV') POLPLT = 4
               IF (PPLOT(1:2).EQ.'VH') POLPLT = 5
               END IF
            END IF
C                                       true stokes
      ELSE IF ((KLEN.EQ.3) .AND. (PPLOT(2:3).EQ.'/I')) THEN
         STKCHR = 'IQUV'
         CALL FNDPOL (STKCHR, IERR)
         IF (IERR.NE.0) GO TO 999
         IF (PPLOT(1:1).EQ.'Q') POLPLT = 7
         IF (PPLOT(1:1).EQ.'U') POLPLT = 8
         IF (PPLOT(1:1).EQ.'V') POLPLT = 9
         END IF
C
 999  RETURN
      END

      SUBROUTINE VSFDFT (APCORE, CHANEL, NCHAN, DISKI, CNOSCI, DISKO,
     *   CNOSCO, IFIELD, DOSUM, DOMSG, MAXBWC, BWCOR, FRQCOR, CATR,
     *   JBUFSZ, BUFF1, BUFF2, IBUFF, IRET)
C-----------------------------------------------------------------------
C! Compute DFT of model with frequency corrections and add to uv data.
C# AP-appl UV Map Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999-2001, 2003, 2006-2009, 2013-2014,
C;  Copyright (C) 2019-2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Add the DFT Fourier transform of a bandwidth smearing corrected
C   image model to a uv  data set.   Only point models are processed.
C   Can also optionally correct the values of u,v, and w for errors in
C   the reference  frequency.
C   Inputs:
C      CHANEL   I        Frequency channel
C      NCHAN    I        Number of frequency channels.
C      DISKI    I        Input file disk number for cataloged files,
C                        .LE. 0 => /CFILES/ scratch file.
C      CNOSCI   I        Input file catalog slot number or /CFILES/
C                        scratch file number.
C      DISKO    I        Output file disk number for cataloged files,
C                        .LE. 0 => /CFILES/ scratch file.
C      IFIELD   I        Field to do (0 -> all)
C      DOSUM    L        If true sum the flux in each field
C      DOMSG    L        If true give percent done messages.
C      MAXBWC   R        Maximum bandwidth smearing correction in %
C      BWCOR    R        Bandwidth correction factor. 0 => no corr.
C                        Multiplied times nominal (CATBLK) bandwidth.
C      FRQCOR   R        Ref. frequency correction factor. 0 => no corr.
C      JBUFSZ   I        Size of BUFF1,2, IBUFF in AIPS bytes, each
C                        must be at least 4096 words.
C   Inputs: from commons
C      MFIELD   I        Number of fields
C      NCLNG    I(16)    Number of components per field.
C      NSUBG    I(16)    The next component to subtract.
C      CCDISK   I(16)    Disk numbers of the clean images.
C      CCCNO    I(16)    Catalog slot numbers of clean images.
C      CCVER    I(*)     CC file version number for each field.
C      NGRDAT   L        If FALSE get map size, scaling etc. parms
C                        from the model map cat. header. If TRUE
C                        then the values filled in by GRDAT must
C                        already be filled into the common.
C      LREC     I        Length in words of vis record.
C      NVIS     I        Number of vis. records
C      NONEG    L        Stop reading comps. from a file past the first
C                        negative component.
C      LIMFLX   R        Stop if abs(flux) < LIMFLX
C      DOPTMD   L        Use the point model specified by PTFLX, PTRAOF,
C                        PTDCOF
C      PTFLX    R        Point model flux density (Jy) (I pol. only)
C      PTRAOF   R        Point model RA offset from uv phase center
C                        (asec)
C      PTDCOF   R        Point model Dec. offset from uv phase center
C      PARMOD   R(6)     Model parameters for non point models; used
C                        only if DOPTMD is true.
C                        1=> model type, 0=point,
C   In/out:
C      CNOSCO   I        IN: output file catalog slot number or /CFILES/
C                        scratch file number. Will create a scratch file
C                        if CNOSCO and DISKO .le. 0.
C                        Out: file /CFILES/ number if created.
C      CATR     R(256)   Output UV data catalog header record; frequency
C                        may be updated.
C   Output:
C      BUFF1    R(*)     I/O buffers.
C      BUFF2    R(*)     I/O buffers.
C      IBUFF    I(*)     I/O Buffer.
C      IRET     I        Return code, 0 => ok, otherwise not.
C                            9 => Buffers too small to load AP.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   CHANEL, NCHAN, DISKI, CNOSCI, DISKO, CNOSCO, IFIELD,
     *   JBUFSZ, IBUFF(*), IRET
      LOGICAL   DOSUM, DOMSG
      REAL      MAXBWC, BWCOR, FRQCOR, BUFF1(*), BUFF2(*), CATR(256)
C
      CHARACTER NAME*48, ERRTXT*40
      INTEGER   JNCOMP, CCOUNT, XNCOMP, MXCMP, CURCMP, JT, IADR, MSGSAV,
     *   NCOMP, J, MCOMP, VO, BO, ISIZE, INIO, MMCOMP, NNCOR, IDATA, UV,
     *   LLREC, IAPBUF, IAPCC, IAPCT, LMCOMP, IAPTMP, VIS, WRK, LLNMOD,
     *   MCHAN, JNCS, JNCF, KAP, SFLAG, APSIZ, MXCC, INIO2, LUNC, VOL,
     *   INDEX, ITYPE, NIOUT, KBIND, LENBU, LENMOD, JLREC, JNREC, FINDI,
     *   FINDO, I, LUNI, LUNO, ITIME(3), IBIND, LFIELD, NKEY, APFSCL,
     *   IPCLST, IPCDNE, NCALL, NTIMES, LRPARM, APBWC, LF1, LF2, NEED,
     *   KLNBL2(256), scrtch(256)
      REAL      XXOFF, YYOFF, ZZOFF, FACT2(4), BWPRM(5), BWFAC, FQFAC,
     *   XYZ(3), XP(3), UMAT(3,3), PMAT(3,3)
      DOUBLE PRECISION XTLST, PCTOT, PCLST, FREQC, FRQADD, XRA, XDEC,
     *   XPR, YPR, CONST, CONST2
      LOGICAL   T, F
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      LOGICAL   DONE(MAXFLD), ONZE, DO3D
      INTEGER   CCKOLS(MAXCCC), CCNUMV(MAXCCC), CCNCOL, CCRNO, CCTYPE
      REAL      XX, YY, ZZ, FLUX, PARMS(3)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMPR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      PARAMETER (CONST = DG2RAD * TWOPI)
      SAVE ONZE
      DATA VO, BO, MXCC /0, 1, 1024/
      DATA LUNI, LUNO, LUNC /22,23,29/
      DATA T, F /.TRUE.,.FALSE./, ONZE/.FALSE./
C-----------------------------------------------------------------------
C                                       CONST2 converts FWHM(deg) to
C                                       coefficients for u*u, v*v, u*v
      CONST2 = DG2RAD * (PI / 1.17741022D0) * SQRT (0.5D0)
C                                       Tell kind of operation.
      MSGTXT = 'VSFDFT: Begin DFT model calculation with corrections'
      CALL MSGWRT (2)
C                                       Tell about bandwidth smearing
C                                       correction.
      IF (MAXBWC.GT.1.0E-20) THEN
         WRITE (MSGTXT,1000) MAXBWC
         CALL MSGWRT (4)
         END IF
C                                       Tell about bandwidth correction.
      BWFAC = 1.0
      IF (BWCOR.GT.1.0E-20) THEN
         WRITE (MSGTXT,1001) BWCOR
         CALL MSGWRT (4)
         BWFAC = BWCOR
         END IF
C                                       Tell about ref. freq. correction.
      FQFAC = 1.0
      FREQC = FREQ
      FRQADD = 0.0D0
      IF (FRQCOR.GT.1.0E-20) THEN
         WRITE (MSGTXT,1002) FRQCOR
         CALL MSGWRT (4)
         FQFAC = FRQCOR
         FREQC = FREQ * FQFAC
         FRQADD = FREQC - FREQ
C                                       Update catalog frequency
         IADR = (KDCRV+JLOCF-1) * NWDPDP + 1
         CALL COPY (NWDPDP, FREQC, CATR(IADR))
         END IF
      MCHAN = NCHAN
      NNCOR = 1
C                                       Get un-compressed UV increments
      CALL UVINCS (INCS, INCF, INCIF, NRPARM, LREC, JNCS, JNCF, LRPARM,
     *   LLREC)
      LFIELD = 0
      CCOUNT = 0
      IF (IFIELD.LE.0) THEN
         LF1 = 1
         LF2 = MFIELD
      ELSE
         LF1 = IFIELD
         LF2 = IFIELD
         END IF
C                                       Decide component type.
C                                       From model passed
      IF (DOPTMD) THEN
C                                       From CC table, field 1
      ELSE
         LFIELD = LF1
C                                       If NGRDAT read CLEAN CATBLK.
         IF (NGRDAT) THEN
            ERRTXT = 'READING CLEAN CATBLK'
            CALL CATIO ('READ', CCDISK(LFIELD), CCCNO(LFIELD), KLNBLK,
     *         'REST', SCRTCH, IRET)
            IF ((IRET.GT.0) .AND. (IRET.LT.5)) GO TO 990
C                                       Get field info. if nec.
         ELSE
            CALL GRDAT (F, LFIELD, CATR, IBUFF(2049), IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
         JNREC = 1
         JLREC = 0
         NKEY = 0
C                                       Make sure this header applies
C                                       to this image
         CALL CATIO ('READ', CCDISK(LFIELD), CCCNO(LFIELD), KLNBL2,
     *      'REST', SCRTCH, IRET)
         IF ((IRET.NE.0) .AND. (IRET.LT.5)) THEN
            ERRTXT =  'READ HEADER WITH CATIO'
            GO TO 990
            END IF
C                                       Tabini can update header on disk
         ERRTXT = 'OPENING CLEAN COMPS FILE'
         CALL CCMINI ('READ', IBUFF, CCDISK(LFIELD), CCCNO(LFIELD),
     *      ABS(CCVER(LFIELD)), KLNBL2, LUNC, CCRNO, CCKOLS, CCNUMV,
     *      CCNCOL, IRET)
         IF (IRET.GT.1) GO TO 990
C                                       Close CLEAN components file.
         CALL TABCCM ('CLOS', IBUFF, CCRNO, CCKOLS, CCNUMV,
     *      CCNCOL, XX, YY, ZZ, FLUX, CCTYPE, PARMS, IRET)
         END IF
C                                       Determine no. CC to sub.
      XNCOMP = 0
      DO 10 LFIELD = LF1,LF2
         DONE(LFIELD) = F
         XNCOMP = XNCOMP + NCLNG(LFIELD) - NSUBG(LFIELD) + 1
 10      CONTINUE
C                                       Check for point model.
      IF (DOPTMD) XNCOMP = 1
C                                       Tell model type once
      IF (.NOT. ONZE) THEN
C                                       Tell model type
         MSGTXT = 'VSFDFT: Model components of type Point'
         CALL MSGWRT (2)
         ONZE = .NOT. ONZE
C                                       Check Buffer size
         IF (XNCOMP.GT.10 .AND. (JBUFSZ/2 .LT. 4096)) THEN
            MSGTXT = 'VSFDFT: SCRATCH BUFFER TO SMALL FOR CCs!'
            CALL MSGWRT (8)
            IRET = 9
            GO TO 999
            END IF
         END IF
C                                       Set model length
      LENMOD = 9
C                                       Determine size of uv I/O and
C                                       the number of CC that will fit.
      LENBU = ((JBUFSZ-2*NBPS) / 2) / (LLREC*2)
C                                       How much data fits in AP?
      JT = 100 + LENBU * LLREC
      IF (MXCC.GT.JT) JT = MXCC
      NEED = JT + NCHAN + (XNCOMP+2)*LENMOD
      NEED = NEED / 1024
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL QINIT (APCORE, NEED, 0, KAP)
      MSGSUP = MSGSAV
      IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
         NEED = JT + NCHAN + (XNCOMP/10+2)*LENMOD
         NEED = NEED / 1024
         NEED = MIN (32*1024, NEED) + 2
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
             IRET = 8
             MSGTXT = 'VISDFT CANNOT GET NEEDED MEMORY'
             GO TO 995
             END IF
          END IF
      APSIZ = PSAPNW * 1024
      CALL QRLSE
      MXCMP = (APSIZ - JT - NCHAN)  / LENMOD
      MXCMP = MXCMP - 2
C                                       Set AP pointers.
C                                       UV=UV pointer, VIS=vis pointer
C                                       IAPCC=CLEAN components pointer.
      IDATA = 15 + NCHAN
      UV = IDATA + ILOCU
      APBWC = IDATA + LENBU * LLREC
      APFSCL = APBWC + 5
      IAPCC = APFSCL + 2
      LLNMOD = LENMOD
      LFIELD = LF1 - 1
C                                       Compute number of passes.
      NTIMES = (1.0 * XNCOMP) / MXCMP + 0.99999
      NTIMES = MAX (NTIMES, 1)
C                                       Open uv files.
C                                       Set input file name.
      IF (DISKI.LE.0) THEN
         VOL = SCRVOL(CNOSCI)
         CALL ZPHFIL ('SC', VOL, SCRCNO(CNOSCI), 1, NAME, IRET)
      ELSE
         VOL = DISKI
         CALL ZPHFIL ('UV', VOL, CNOSCI, 1, NAME, IRET)
         END IF
C                                       Open input file.
      ERRTXT = 'OPEN-FOR-READ VIS FILE'
      CALL ZOPEN (LUNI, FINDI, VOL, NAME, T, F, T, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Create scratch file if necessary
      IF ((DISKO.LE.0) .AND. (CNOSCO.EQ.0)) THEN
         CALL UVSIZE (NVIS, LREC, ISIZE)
         ERRTXT = 'CREATING SCRATCH FILE'
         CALL SCREAT (ISIZE, BUFF2, IRET)
         CNOSCO = NSCR
         IF (IRET.GT.0) THEN
            IF (IRET.EQ.1) ERRTXT = 'NO SPACE FOR SCRATCH FILE'
            GO TO 990
            END IF
C                                       End if creating scratch file
         END IF
C                                       Open vis file for write.
      IF (DISKO.LE.0) THEN
         VOL = SCRVOL(CNOSCO)
         CALL ZPHFIL ('SC', VOL, SCRCNO(CNOSCO), 1, NAME, IRET)
      ELSE
         VOL = DISKO
         CALL ZPHFIL ('UV', VOL, CNOSCO, 1, NAME, IRET)
         END IF
      ERRTXT = 'OPEN-FOR-WRITE VIS FILE'
      CALL ZOPEN (LUNO, FINDO, VOL, NAME, T, F, T, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Loop, adding max component
C                                       in AP each pass
      DO 500 NCALL = 1,NTIMES
C                                       Setup for % done messages.
         PCTOT = NVIS
         PCLST = PCTOT * (NCALL - 1)
         IPCLST = (100. / NTIMES ) * (NCALL - 1)
C                                       Set AP loc for next CC load
         IAPCT = IAPCC
C                                       Determine. no. this pass.
         MMCOMP = 0
         NCOMP = MIN( MXCMP, XNCOMP)
C                                       Grab AP.
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
            MSGTXT = 'VSFDFT: BIZARRE FAILURE TO GET AP MEMORY'
            IRET = 10
            GO TO 995
            END IF
C                                       Initialize REAL time clock for
C                                       AP roller.
         CALL ZTIME (ITIME)
         XTLST = (ITIME(1) * 60.00) + ITIME(2) + (ITIME(3) / 60.0)
C                                       If Not single component model.
         IF (.NOT. DOPTMD) THEN
C                                       Find next FIELD.
C                                       Loop back here for next field.
 70         LFIELD = LFIELD + 1
C                                       See if done.
            IF (LFIELD.GT.LF2) GO TO 150
            IF (DONE(LFIELD)) GO TO 70
C                                       See if there are CCs.
            IF ((NSUBG(LFIELD).GT.NCLNG(LFIELD))) GO TO 70
C                                       If NGRDAT read CLEAN CATBLK.
            IF (NGRDAT) THEN
               ERRTXT = 'READING CLEAN CATBLK'
               CALL CATIO ('READ', CCDISK(LFIELD), CCCNO(LFIELD),
     *            KLNBLK, 'REST', SCRTCH, IRET)
               IF ((IRET.GT.0) .AND. (IRET.LT.5)) GO TO 990
C                                       Get field info. if nec.
            ELSE
               CALL GRDAT (F, LFIELD, CATR, IBUFF(2049), IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
C                                       Set field center offsets.
            XXOFF = DXCG(LFIELD) * CCROT + DYCG(LFIELD) * SSROT
            YYOFF = DYCG(LFIELD) * CCROT - DXCG(LFIELD) * SSROT
            ZZOFF = DZCG(LFIELD)
            CALL XYSHFT (RA, DEC, XSHIFT(LFIELD), YSHIFT(LFIELD),
     *         MAPROT, XRA, XDEC)
            IF (DO3DIM) THEN
               CALL PRJMAT (RA, DEC, UVROT, XRA, XDEC, MAPROT, UMAT,
     *            PMAT)
            ELSE
               CALL P2DMAT (RA, DEC, UVROT, XRA, XDEC, MAPROT, UMAT,
     *            PMAT)
               END IF
C                                       Load CLEAN components into AP.
C                                       Open components file.
            JNREC = 1
            JLREC = 0
            NKEY = 0
            ERRTXT = 'OPENING CLEAN COMPS FILE'
            CALL CCMINI ('READ', IBUFF, CCDISK(LFIELD), CCCNO(LFIELD),
     *         ABS(CCVER(LFIELD)), KLNBLK, LUNC, CCRNO, CCKOLS, CCNUMV,
     *         CCNCOL, IRET)
            IF (IRET.GT.1) GO TO 990
            CCRNO = NSUBG(LFIELD)
            DO3D = CCNUMV(4).GT.0
C                                       Make sure that there are some
            IF (IBUFF(5).LE.0) GO TO 140
            IF (NCLNG(LFIELD).LE.0) NCLNG(LFIELD) = IBUFF(5)
C                                       Loop loading components.
            IAPBUF = 10
            CURCMP = MMCOMP + 1
C                                       Check next component
            IF (CCRNO.GT.NCLNG(LFIELD)) GO TO 140
            DO 130 J = CURCMP,NCOMP,MXCC
               JT = J - 1
               JNCOMP = 0
               MCOMP = NCOMP - J + 1
               IF (MCOMP.GT.MXCC) MCOMP = MXCC
               IF (MCOMP.GT.(NCLNG(LFIELD)-NSUBG(LFIELD)+1))
     *            MCOMP = NCLNG(LFIELD) - NSUBG(LFIELD) + 1
               DO 110 I = 1,MCOMP
C                                       Check if finished field
                  IF (CCRNO.GT.NCLNG(LFIELD)) GO TO 120
                  CALL TABCCM ('READ', IBUFF, CCRNO, CCKOLS, CCNUMV,
     *               CCNCOL, XX, YY, ZZ, FLUX, CCTYPE, PARMS, IRET)
                  IF (IRET.GT.0) THEN
                     WRITE (MSGTXT,1090) IRET, CCRNO
                     GO TO 995
                     END IF
C                                        Check that point comp.
                  JT = JT + 1
                  ITYPE = CCTYPE
                  IF ((ITYPE.EQ.0) .AND. (IRET.EQ.0)) THEN
C                                       Check negative component limit
                     DONE(LFIELD) = (NONEG.AND.(FLUX.LE.0.0))
     *                  .OR. (ABS(FLUX).LT.LIMFLX)
                     IF (DONE(LFIELD)) THEN
                        NCLNG(LFIELD) = CCRNO - 1
                        GO TO 120
                        END IF
C                                       If req. sum flux
                     IF (DOSUM) THEN
                        FLUXG(LFIELD) = FLUXG(LFIELD) + FLUX
                        TFLUXG = TFLUXG + FLUX
                        END IF
                     JNCOMP = JNCOMP + 1
                     CCOUNT = CCOUNT + 1
                     IF (DO3D) THEN
                        BUFF1(JNCOMP) = XX * CONST
                        BUFF1(1024+JNCOMP) = YY * CONST
                        BUFF1(2048+JNCOMP) = ZZ * CONST
                     ELSE
                        XP(1) = (XX + XPOFF(LFIELD)) * CONST
                        XP(2) = (YY + YPOFF(LFIELD)) * CONST
                        XP(3) = 0.0
                        CALL PRJMUL (2, XP, UMAT, XYZ)
                        BUFF1(JNCOMP) = XYZ(1) + XXOFF
                        BUFF1(1024+JNCOMP) = XYZ(2) + YYOFF
                        BUFF1(2048+JNCOMP) = XYZ(3) + ZZOFF
                        END IF
                     BUFF1(3072+JNCOMP) = FLUX
                     END IF
 110              CONTINUE
C                                       Load components
 120           IF (JNCOMP.GT.0) THEN
                  LMCOMP = JNCOMP
                  MMCOMP = MMCOMP + LMCOMP
C                                       Load into AP
                  IAPBUF = 10
C                                       x component
                  CALL QPUT (APCORE, BUFF1, IAPBUF, LMCOMP, 2)
                  IAPTMP = IAPCT + 6
                  CALL QWD
                  CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD, LMCOMP)
                  CALL QWR
C                                       y component
                  CALL QPUT (APCORE, BUFF1(1025), IAPBUF, LMCOMP, 2)
                  IAPTMP = IAPCT + 7
                  CALL QWD
                  CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD, LMCOMP)
                  CALL QWR
C                                       z component
                  CALL QPUT (APCORE, BUFF1(2049), IAPBUF, LMCOMP, 2)
                  IAPTMP = IAPCT + 8
                  CALL QWD
                  CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD, LMCOMP)
                  CALL QWR
C                                       Flux density
                  CALL QPUT (APCORE, BUFF1(3073), IAPBUF, LMCOMP, 2)
                  CALL QWD
C                                       Move flux to location.
                  CALL QVMOV (APCORE, IAPBUF, 1, IAPCT, LLNMOD, LMCOMP)
                  CALL QWR
                  IAPCT = IAPCT + (LLNMOD * LMCOMP)
                  END IF
C                                       Check if finished field.
               IF ((CCRNO.GT.NCLNG(LFIELD)) .OR. DONE(LFIELD))
     *            GO TO 140
 130           CONTINUE
C                                       Close CLEAN components file.
 140        CALL TABCCM ('CLOS', IBUFF, CCRNO, CCKOLS, CCNUMV,
     *         CCNCOL, XX, YY, ZZ, FLUX, CCTYPE, PARMS, IRET)
C                                       Update field sub. count.
            NSUBG(LFIELD) = CCRNO
C                                       Check if need another field.
            IF (JT.LT.NCOMP) GO TO 70
C                                      Check no. comps.
 150        IF ((MMCOMP.EQ.0) .AND. (NCALL.EQ.1)) THEN
               ERRTXT = 'NO POINT COMPONENTS FOUND'
               IRET = 1
               GO TO 990
               END IF
C                                       No comps on later pass is OK
            IF (MMCOMP.LE.0) GO TO 510
C                                       Load correlator factors
            CALL GETCTL (CATR, FACT2, IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Else, single component model.
         ELSE
            CALL RFILL (LENMOD, 0.0, BUFF1)
            BUFF1(7) = PTRAOF * CONST / 3600.
            BUFF1(8) = PTDCOF * CONST / 3600.
C                                       single comp uses W term
            XPR = PTRAOF / 206264.81D0
            YPR = PTDCOF / 206264.81D0
            BUFF1(9) = -(SQRT (1.0D0 - XPR*XPR - YPR*YPR) - 1.0D0) *
     *         206264.81D0 * CONST / 3600.D0
C                                       Point
            BUFF1(1) = PTFLX
            MMCOMP = 1
            CALL QPUT (APCORE, BUFF1, IAPCC, LLNMOD, 2)
            IAPCT = IAPCC + LLNMOD
C                                       Set Stokes for point model
            FACT2(1) = 1.0
            FACT2(2) = 1.0
            NSTOK = 1
            IF ((CATR(KRCIC+JLOCS).LT.0.0) .AND. (NCOR.GE.2)) NSTOK = 2
            IF ((NSTOK.EQ.2) .AND. (ABS (ICOR0).EQ.2)) NSTOK = 1
C                                       End if not single comp. model
            END IF
C                                       Bandwidth smearing correction
C                                       terms
         IF (MAXBWC.GT.1.0E-20) THEN
C                                       Fractional bandwidth
            BWPRM(1) = BWFAC * CATR(KRCIC+JLOCF) / FREQC
C                                       "X" pos correction from point to
C                                       tangent point.
            BWPRM(2) = 0.0
C                                       "Y" pos corr
            BWPRM(3) = 0.0
C                                       "Z" pos corr.
            BWPRM(4) = 0.0
C                                       Max. correction
            BWPRM(5) = 1.0 + 0.01 * MAXBWC
         ELSE
            BWPRM(1) = 0.0
            BWPRM(2) = 0.0
            BWPRM(3) = 0.0
            BWPRM(4) = 0.0
            BWPRM(5) = 0.0
            END IF
         CALL QPUT (APCORE, BWPRM, APBWC, 5, 2)
C                                       Frequency scaling factor
         BWPRM(1) = FQFAC
         CALL QPUT (APCORE, BWPRM, APFSCL, 1, 2)
C                                       Correct for FACGRD
         NNCOR = NSTOK
         FACT2(1) = FACT2(1) * FACGRD(1)
         FACT2(2) = FACT2(2) * FACGRD(1)
         WRK = MCHAN + 2
         CALL QPUT (APCORE, FACT2, WRK, NNCOR, 2)
         SFLAG = 1
C                                       Set flag for UPOL and RL,LR data
         IF ((KSTOK.EQ.3) .AND. (ICOR0.LT.0)) SFLAG = -1
C                                       Set vis pointer
         VIS = IDATA + LRPARM + (CHANEL-1) * JNCF + (VOFF/INCS)*JNCS
C                                       Fill frequency table
         BUFF2(1) = ((FREQG(CHANEL) + FRQADD) / FREQC) - 1.0D0
         IF (NCHAN.GT.1) THEN
            DO 175 I = 2,NCHAN
               INDEX = CHANEL + I - 1
               BUFF2(I) = ((FREQG(INDEX)+FRQADD) /
     *            (FREQC+FRQADD)) - 1.0D0
 175           CONTINUE
            END IF
         CALL QWD
         CALL QPUT (APCORE, BUFF2, 2, MCHAN, 2)
         CALL QWAIT
C                                       Init for read & write
C                                       visibility file
C                                       Init vis file for write
         ERRTXT = 'INIT-FOR-READ VIS FILE'
         CALL UVINIT ('READ', LUNI, FINDI, NVIS, VO, LREC, LENBU,
     *      JBUFSZ, BUFF1, BO, IBIND, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Init vis file for read.
         ERRTXT = 'INIT-FOR-WRITE VIS FILE'
         CALL UVINIT ('WRIT', LUNO, FINDO, NVIS, VO, LREC, LENBU,
     *      JBUFSZ, BUFF2, BO, KBIND, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Subtract model from vis data.
C                                       Loop:  Read vis. record.
 200        CONTINUE
            ERRTXT = 'READING VIS FILE'
            CALL UVDISK ('READ', LUNI, FINDI, BUFF1, INIO2, IBIND, IRET)
            INIO = INIO2
            IF (IRET.NE.0) GO TO 990
C                                       Exit if no more data
            IF (INIO.LE.0) GO TO 300
C                                       Uncompress Vis and put in AP
            CALL BUFPUT (APCORE, INIO, NRPARM, LREC, LLREC, IDATA,
     *         BUFF1(IBIND), IBUFF(1))
C                                       Point
            CALL QPTADC (APCORE, IAPCC, UV, VIS, APBWC, LLREC, JNCF,
     *         JNCS, MMCOMP, INIO, MCHAN, NNCOR, SFLAG)
C                                       Frequency scaling of u, v, w
            IF (FRQCOR.GT.1.0E-20) THEN
               CALL QVSMUL (APCORE, UV, LLREC, APFSCL, UV, LLREC, INIO)
               CALL QVSMUL (APCORE, UV+1, LLREC, APFSCL, UV+1, LLREC,
     *            INIO)
               CALL QVSMUL (APCORE, UV+2, LLREC, APFSCL, UV+2, LLREC,
     *            INIO)
               END IF
C                                       Get UVs from AP (maybe pack UV)
            CALL BUFGET (APCORE, INIO, NRPARM, LREC, LLREC, IDATA,
     *         BUFF2(KBIND), IBUFF(1))
C                                       Write vis record.
            NIOUT = INIO
            ERRTXT = 'WRITING VIS FILE'
            CALL UVDISK ('WRIT', LUNO, FINDO, BUFF2, NIOUT, KBIND, IRET)
            IF (IRET.NE.0) GO TO 990
C                                       Check if time for % done
C                                       message.
            PCLST = PCLST + NIOUT
            IPCDNE = (100.0 / NTIMES) * (PCLST / PCTOT) + 0.5
            IPCDNE = IPCDNE - MOD (IPCDNE, 10)
C                                       Write % done message.
            IF ((IPCDNE.GT.IPCLST) .AND. (DOMSG)) THEN
               WRITE (MSGTXT,1240) IPCDNE
               CALL MSGWRT (2)
               IPCLST = IPCDNE
               END IF
C                                       Check if time for AP roller
            CALL QROLL (APCORE, IAPCT, IBUFF, JBUFSZ, IRET)
            IF (IRET.NE.0) GO TO 999
            GO TO 200
C                                       Finish write
 300     CALL QRLSE
         NIOUT = 0
         ERRTXT = 'FLUSHING VIS FILE'
         CALL UVDISK ('FLSH', LUNO, FINDO, BUFF2, NIOUT, KBIND, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Update no. comp. left.
         XNCOMP = XNCOMP - MXCMP
C                                       Check if done.
         IF (XNCOMP.LE.0.01) GO TO 510
C                                       Input now output.
C                                       Close old input
         CALL ZCLOSE (LUNI, FINDI, IRET)
C                                       Set new input file name.
         IF (DISKO.LE.0) THEN
            VOL = SCRVOL(CNOSCO)
            CALL ZPHFIL ('SC', VOL, SCRCNO(CNOSCO), 1, NAME, IRET)
         ELSE
            VOL = DISKO
            CALL ZPHFIL ('UV', VOL, CNOSCO, 1, NAME, IRET)
            END IF
C                                       Open new input file.
         ERRTXT = 'OPEN-FOR-READ VIS FILE'
         CALL ZOPEN (LUNI, FINDI, VOL, NAME, T, F, T, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Open vis file for write.
C                                       Set output file name.
C                                       End big loop, N Comps per pass
 500     CONTINUE
C                                       Close files
 510  CALL ZCLOSE (LUNI, FINDI, IRET)
      CALL ZCLOSE (LUNO, FINDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  WRITE(MSGTXT,2000,ERR=999) IRET, ERRTXT
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VSFDFT: Max. bandwidth smearing correction=',F7.0,'%')
 1001 FORMAT ('VSFDFT: Bandwidth correction factor =',F10.5)
 1002 FORMAT ('VSFDFT: Ref. freq. correction factor =',F10.5)
 1090 FORMAT ('VSFDFT: ERROR',I5,' READING CLEAN COMPS REC',I5)
 1240 FORMAT ('Model computation is ',I5,' percent complete')
 2000 FORMAT ('VSFDFT: ERROR',I5,' ',A)
      END

LOCAL INCLUDE 'SNREF.INC'
C                                       Local include for SNREF
      INCLUDE 'INCS:PUVD.INC'
C                                       Input parameters
      REAL      XSIN, XDISIN, XNVER, XBAND, XFREQ, XFQID, XSUBA, KEEP
      HOLLERITH XNAMEI(3), XCLAIN(2), XTYPE(1)
      CHARACTER NAMEIN*12, CLAIN*6, TYPE*2
C                                       Program info
      REAL      TSTART, TSTOP, GMMOD, SELBAN
      INTEGER   SEQIN, DISKIN, CNOIN, IVER, BIF, EIF, NCOUNT, ICODE,
     *   NPARMS, NID, SID(500), SUMSTK, FRQSEL, IANT, SUBARR,
     *   MUMPOL, MUMIF, MUMANT, NUMPTS(MAXANT), NANREC(MAXANT),
     *   FANREC(MAXANT), NUMREF(MAXANT)
      DOUBLE PRECISION FOFF(MAXIF), SELFRQ, GNRECD(XCLRSZ/2)
C                                       SN/CL table info
      INTEGER CLBUFF(512), NCLINR, NUMANT, NUMPOL, NUMIF, ICLRNO,
     *   KOLS(40), KOLTYP(40), KOLDIM(40), ICLUN, GNRECI(XCLRSZ),
     *   TIMKOL, INTKOL, SOUKOL, ANTKOL, SUBKOL, FRQKOL, IFRKOL,
     *   GEOKOL, DOPKOL, ATMKOL, DATKOL,
     *   MB1KOL, RE1KOL, IM1KOL, DL1KOL, RA1KOL, WT1KOL, RF1KOL, TS1KOL,
     *   TA1KOL, CK1KOL, DC1KOL, DS1KOL, DD1KOL,
     *   MB2KOL, RE2KOL, IM2KOL, DL2KOL, RA2KOL, WT2KOL, RF2KOL, TS2KOL,
     *   TA2KOL, CK2KOL, DC2KOL, DS2KOL, DD2KOL,
     *   MBKOL(4), REKOL(4), IMKOL(4), DLKOL(4), RAKOL(4), WTKOL(4),
     *   RFKOL(4), TSKOL(4), TAKOL(4), CKKOL(4), DCKOL(4), DSKOL(4),
     *   DDKOL(4), STKOL(4),
     *   DOPLKL, DOP3KL, CLTIME, CABKOL, ST1KOL, ST2KOL
      REAL GNREC(XCLRSZ)
C                                       Constants
      DOUBLE PRECISION SIDER, CLIGHT
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XTYPE, XNVER,
     *   XBAND, XFREQ, XFQID, XSUBA, KEEP
      COMMON /VPARM/ SEQIN, DISKIN, CNOIN, IVER, BIF, EIF, NCOUNT,
     *   ICODE, NPARMS, IANT
      COMMON /VGNCOM/ SELFRQ, TSTART, TSTOP, SELBAN, GMMOD,
     *   NID, SID, SUMSTK, FRQSEL, SUBARR, MUMPOL, MUMIF,
     *   MUMANT, NUMPTS,  NANREC, FANREC, NUMREF
      COMMON /VGNCHR/ NAMEIN, CLAIN, TYPE
      COMMON /TABCOM/ GNREC, CLBUFF, NCLINR, NUMANT, NUMPOL, NUMIF,
     *   ICLRNO, KOLS, KOLTYP, KOLDIM, ICLUN,
     *   MBKOL, REKOL, IMKOL, DLKOL, RAKOL, WTKOL, RFKOL, TSKOL,
     *   TAKOL, CKKOL, DCKOL, DSKOL, DDKOL, STKOL,
     *   DOPLKL, DOP3KL, CLTIME
      COMMON /CONST/ SIDER, CLIGHT, FOFF
      EQUIVALENCE (GNREC, GNRECD, GNRECI)
      EQUIVALENCE (KOLS(1), TIMKOL), (KOLS(2), INTKOL),
     *   (KOLS(3), SOUKOL), (KOLS(4), ANTKOL), (KOLS(5), SUBKOL),
     *   (KOLS(6), FRQKOL), (KOLS(7), IFRKOL),
     *   (KOLS(8), GEOKOL), (KOLS(9), DOPKOL), (KOLS(10), ATMKOL),
     *   (KOLS(11), DATKOL)
      EQUIVALENCE (KOLS(12), MB1KOL),
     *   (KOLS(13), RE1KOL), (KOLS(14), IM1KOL),
     *   (KOLS(15), RA1KOL), (KOLS(16), DL1KOL), (KOLS(17), WT1KOL),
     *   (KOLS(18), RF1KOL), (KOLS(19), TS1KOL), (KOLS(20), TA1KOL),
     *   (KOLS(21), CK1KOL), (KOLS(22), DC1KOL),
     *   (KOLS(23), DS1KOL), (KOLS(24), DD1KOL)
      EQUIVALENCE (KOLS(25), MB2KOL),
     *   (KOLS(26), RE2KOL), (KOLS(27), IM2KOL),
     *   (KOLS(28), RA2KOL), (KOLS(29), DL2KOL), (KOLS(30), WT2KOL),
     *   (KOLS(31), RF2KOL), (KOLS(32), TS2KOL), (KOLS(33), TA2KOL),
     *   (KOLS(34), CK2KOL), (KOLS(35), DC2KOL),
     *   (KOLS(36), DS2KOL), (KOLS(37), DD2KOL),
     *   (KOLS(38), CABKOL), (KOLS(39), ST1KOL), (KOLS(40), ST2KOL)
C                                                          End SNREF
LOCAL END
      PROGRAM SNREF
C-----------------------------------------------------------------------
C! Determines reference antenna with min R-L variability
C# UV EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2012, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SNREF plots SN or CL extension files. A 'PL' extension file is made
C   which can be displayed in the usual ways .
C   Inputs:
C      INNAME.....UV file name (name).       Standard defaults.
C      INCLASS....UV file name (class).      Standard defaults.
C      INSEQ......UV file name (seq. #).     0 => highest.
C      INDISK.....Disk unit #.               0 => any.
C      INEXT......'SN','TY','PC' or 'CL' table to be plotted
C      INVERS.....Version number of table to plot, 0=>highest no.
C-----------------------------------------------------------------------
C
      CHARACTER PRGN*6
      REAL      SNVALS(2)
      LONGINT   PSNVAL
      INTEGER   IRET, MVAL, NWORDS, NROWS
      INCLUDE 'SNREF.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGN /'SNREF '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL SNPIN (PRGN, NROWS, IRET)
      MUMANT = MAX (1, MUMANT)
      MVAL = 1 + MUMPOL*MUMIF
      MVAL = MAX (MVAL, 5)
      NWORDS = (MVAL * NROWS - 1) / 1024  + 21
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, SNVALS, PSNVAL, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         END IF
C                                       read data to figure out
C                                       distribution
      NWORDS = NWORDS * 1024
      IF (IRET.EQ.0) CALL SNPCNT (NWORDS, IRET)
C                                       Fetch data, determine values
      IF (IRET.EQ.0) CALL SNPREF (MUMANT, SNVALS(1+PSNVAL), IRET)
      IF (IRET.LT.0) IRET = 0
C                                       Close down
      CALL DIE (IRET, CLBUFF)
C
 999  STOP
      END
      SUBROUTINE SNPIN (PRGN, NROWS, IERR)
C-----------------------------------------------------------------------
C   Gets the inputs parameters for SNREF.
C   Inputs:
C      PRGN    C*6  Program name
C   Output in common:
C      SUMSTK  I    Selected Stokes 0=both, 1=R, 2=L, 4=difference
C   Output:
C      IERR    I    Error code: 0 => ok
C      ICODE   I    1='PHAS', 2='AMP ', 3='DELA', 4='RATE', 5='TSYS',
C                   6='SUM ', 7='DOPL', 8='SNR', 9='MDEL', 10='TANT',
C                   11='ATM', 12='GEO', 13='CCAL', 14='DDLY'
C                   15='REAL', 16='IMAG', 17='IFR', 18='PDIF',
C                   19='PSUM', 20=PGN ', 21='PON ', 22='POFF', 23-'PSYS'
C-----------------------------------------------------------------------
      INTEGER   NROWS, IERR
      CHARACTER PRGN*6
C
      INTEGER   NCODE, NTPLT
C
      PARAMETER (NCODE=23, NTPLT=5)
C
      CHARACTER STAT*4, TYPTMP*2
      INTEGER   IRET, BUFF(256), IROUND, LUN, FRQTMP, VER, NIF, JERR,
     *   BUFFER(512)
      LOGICAL   MATCH
      INCLUDE 'SNREF.INC'
      INTEGER   ISBAND(MAXIF)
      REAL      FINC(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      NPARMS = 14
C                                        Get input parameters.
      CALL SETUP (PRGN, NPARMS, XNAMEI, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRET = 8
         RQUICK = .FALSE.
         GO TO 990
         END IF
C                                       Decode inputs.
C                                       characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (2, 1, XTYPE, TYPE)
      IF (TYPE.EQ.' ') TYPE ='SN'
      CALL FILL (MAXANT, 0, NUMPTS)
C                                       Integers
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      IVER = IROUND (XNVER)
      SUMSTK = 3
      ICODE = 1
C                                       we are looking at R-L
      MUMPOL = 1
C                                       Time range
      TSTART = 0.0
      TSTOP = 999.0
C                                       Find input catalog
      CNOIN = 1
      TYPTMP = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, TYPTMP,
     *   NLUSER, STAT, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      'UV', NLUSER
         GO TO 990
         END IF
C                                       Save name class etc.
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
      XDISIN = DISKIN
      XSIN = SEQIN
C                                       Read catalog header
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'WRIT', BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FCNO(NCFILE) = CNOIN
      FVOL(NCFILE) = DISKIN
      FRW(NCFILE) = 1
      XDISIN = DISKIN
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 990
      SEQIN = CATBLK(KIIMS)
      XSIN = SEQIN
C                                       Subarray
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LE.0) SUBARR = 1
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.GE.0) THEN
         LUN = 25
         CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *      FRQSEL, IERR)
         IF (.NOT.MATCH) THEN
            WRITE (MSGTXT,1070)
            IERR = 1
            GO TO 990
            END IF
         IF (IERR.GT.0) GO TO 999
         END IF
      BIF = 1
      EIF = 1
      IF (JLOCIF.GE.0) EIF = CATBLK(KINAX+JLOCIF)
C                                       get frequencies
      VER = 1
      LUN = 25
      IF (FRQSEL.LE.0) FRQTMP = 1
      IF (FRQSEL.GT.0) FRQTMP = FRQSEL
      CALL CHNDAT ('READ', BUFFER, DISKIN, CNOIN, VER, CATBLK, LUN,
     *   NIF, FOFF, ISBAND, FINC, BNDCOD, FRQTMP, JERR)
C                                       Get antenna names
      CALL GETANT (DISKIN, CNOIN, MAX (1, SUBARR), CATBLK, BUFFER, JERR)
      MUMANT = NSTNS
C                                       Open table to check
C                                       Open SN, CL, TY or PC table
      IF ((TYPE.EQ.'SN') .OR. (TYPE.EQ.'CL')) THEN
         CALL SNPOPN (NROWS, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Invalid table type
      ELSE
         IERR = 5
         MSGTXT = 'INVALID TABLE TYPE =' // TYPE
         GO TO 990
         END IF
      XNVER = IVER
      MUMIF = EIF - BIF + 1
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR;',I7,'GETTING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',I3,
     *   ' TYPE=',A2,' USER=',I4)
 1040 FORMAT ('ERROR',I3,' COPYING CATALOG HEADER')
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
      END
      SUBROUTINE SNPOPN (NROWS, IERR)
C-----------------------------------------------------------------------
C   Routine to open SN, CL table and get necessary information
C   Input from Common:
C      TYPE     C*2  'SN', 'CL'
C      DISKIN   I     Disk number
C      CNOIN    I     Catalog slot number
C      CATBLK   I(*)  Catalog header
C      SUMSTK   I     Stokes type requested 0=both, 1=R, 2=L,
C                     3=difference, 4=ratio
C   Output:
C      IERR     I     Error code, 0=OK else failed.
C   Output in common:
C      ICLRNO       I    Current cal record number
C      NCLINR       I    Number of gain records in file.
C      NUMANT       I    Number of antennas
C      NUMPOL       I    Number of polarizations
C      NUMIF        I    Number of IFs.
C      KOLS         I(*) Column pointers
C      KOLTYP       I(*) Column data types
C      KOLDIM       I(*) Column dimension
C-----------------------------------------------------------------------
      INTEGER   NROWS, IERR
      INCLUDE 'SNREF.INC'
C
      CHARACTER KEYW(4)*8, COLHD1(11)*24, COLHD2(13)*24, COLHD3(13)*24,
     *   COLTAB(40)*24, COLHED(37)*24, KEYSN(4)*8
      INTEGER   NKEY, NREC, NCOL, DATP(128,2), IPOINT, KEYTYP(4),
     *   KLOCS(4), KEYVAL(6), I, KP, MSGSAV
      LOGICAL   T
      REAL      KEYVR(6)
      DOUBLE PRECISION KEYVAD
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      EQUIVALENCE (KEYVAL, KEYVR)
      EQUIVALENCE (COLHED(1), COLHD1), (COLHED(12), COLHD2),
     *   (COLHED(25), COLHD3)
      DATA COLHD1 /'TIME                    ',
     *   'TIME INTERVAL           ',
     *   'SOURCE ID               ', 'ANTENNA NO.             ',
     *   'SUBARRAY                ', 'FREQ ID                 ',
     *   'I.FAR.ROT               ',
     *   'GEODELAY                ', 'DOPPOFF                 ',
     *   'ATMOS                   ', 'DATMOS                  '/
      DATA COLHD2 /'MBDELAY1      ',
     *   'REAL1                   ', 'IMAG1                   ',
     *   'RATE 1                  ', 'DELAY 1                 ',
     *   'WEIGHT 1                ', 'REFANT 1                ',
     *   'TSYS 1                  ', 'TANT 1                  ',
     *   'CLOCK 1                 ', 'DCLOCK 1                ',
     *   'DISP 1                  ', 'DDISP 1                 '/
      DATA COLHD3 /'MBDELAY2      ',
     *   'REAL2                   ', 'IMAG2                   ',
     *   'RATE 2                  ', 'DELAY 2                 ',
     *   'WEIGHT 2                ', 'REFANT 2                ',
     *   'TSYS 2                  ', 'TANT 2                  ',
     *   'CLOCK 2                 ', 'DCLOCK 2                ',
     *   'DISP 2                  ', 'DDISP 2                 '/
      DATA KEYSN /'NO_ANT  ', 'NO_POL  ', 'NO_IF   ','MGMOD   '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Open table
      ICLUN = 28
      NKEY = 0
      NREC = 0
      NCOL = 0
      ICLRNO = 1
      CALL TABINI ('READ', TYPE, DISKIN, CNOIN, IVER, CATBLK, ICLUN,
     *   NKEY, NREC, NCOL, DATP, CLBUFF, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1100) IERR, TYPE, IVER
         GO TO 980
         END IF
C                                       Get number of scans
      NCLINR = CLBUFF(5)
      NROWS = NCLINR
C                                       Check if empty
      IF (NCLINR.LE.0) THEN
         IERR = 6
         MSGTXT = 'ERROR: SELECTED TABLE IS EMPTY'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Get column pointers
      NKEY = 40
      DO 10 I = 1,NKEY
         COLTAB(I) = COLHED(I)
 10      CONTINUE
      CALL FNDCOL (NKEY, COLTAB, 24, T, CLBUFF, KOLS, IERR)
      IF ((IERR.GE.1) .AND. (IERR.LE.10)) GO TO 999
      IERR = 0
C                                       Time column logical number
      CLTIME = KOLS(1)
C                                       Convert to pointers, types
      DO 20 I = 1,NKEY
         KP = KOLS(I)
         IF (KP.GT.0) THEN
            KOLS(I) = DATP(KP,1)
            KOLTYP(I) = MOD (DATP(KP,2), 10)
            KOLDIM(I) = DATP(KP,2) / 10
         ELSE
            KOLS(I) = -1
            KOLTYP(I) = -1
            KOLDIM(I) = 0
            END IF
 20      CONTINUE
C                                       Table keywords
      NKEY = 4
      DO 30 I = 1,NKEY
         KEYW(I) = KEYSN(I)
 30      CONTINUE
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL TABKEY ('READ', KEYW, NKEY, CLBUFF, KLOCS, KEYVAL, KEYTYP,
     *   IERR)
      MSGSUP = MSGSAV
      IF ((IERR.GE.1) .AND. (IERR.LE.20)) GO TO 999
      IERR = 0
C                                       No. antennas.
      NUMANT = NSTNS
      IPOINT = KLOCS(1)
      IF (IPOINT.GT.0) NUMANT = KEYVAL(IPOINT)
C                                       No. poln.
      NUMPOL = 1
      IPOINT = KLOCS(2)
      IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. IF
      NUMIF = 1
      IPOINT = KLOCS(3)
      IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       Mean gain modulus
      GMMOD = 1.0
      IPOINT = KLOCS(4)
      IF (IPOINT.GT.0) THEN
         IF (KEYTYP(4).EQ.1) THEN
            CALL RCOPY (NWDPDP, KEYVR(IPOINT), KEYVAD)
         ELSE
            KEYVAD = KEYVR(IPOINT)
            END IF
         IF (KEYVAD.GT.0.0) GMMOD = 1.0 / KEYVAD
         END IF
C                                       Set pointers
      DOPKOL = DOPKOL + BIF - 1
      DOP3KL = DOPKOL + EIF - 1
      DOPLKL = DOPKOL
C                                       1st poln
      MBKOL(1) = MB1KOL
      REKOL(1) = RE1KOL + BIF - 1
      IMKOL(1) = IM1KOL + BIF - 1
      DLKOL(1) = DL1KOL + BIF - 1
      RAKOL(1) = RA1KOL + BIF - 1
      WTKOL(1) = WT1KOL + BIF - 1
      RFKOL(1) = RF1KOL + BIF - 1
      TSKOL(1) = TS1KOL + BIF - 1
      TAKOL(1) = TA1KOL + BIF - 1
      CKKOL(1) = CK1KOL
      DCKOL(1) = DC1KOL
      DSKOL(1) = DS1KOL
      DDKOL(1) = DD1KOL
      STKOL(1) = ST1KOL + BIF - 1
C                                       2nd Poln
      MBKOL(2) = MB2KOL
      REKOL(2) = RE2KOL + BIF - 1
      IMKOL(2) = IM2KOL + BIF - 1
      DLKOL(2) = DL2KOL + BIF - 1
      RAKOL(2) = RA2KOL + BIF - 1
      WTKOL(2) = WT2KOL + BIF - 1
      RFKOL(2) = RF2KOL + BIF - 1
      TSKOL(2) = TS2KOL + BIF - 1
      TAKOL(2) = TA2KOL + BIF - 1
      CKKOL(2) = CK2KOL
      DCKOL(2) = DC2KOL
      DSKOL(2) = DS2KOL
      DDKOL(2) = DD2KOL
      STKOL(2) = ST2KOL + BIF - 1
C                                       Phase, amplitude, summary
      IF ((REKOL(1).LT.0) .AND. (IMKOL(1).LT.0)) GO TO 500
      IF ((REKOL(2).LT.0) .OR. (IMKOL(2).LT.0)) GO TO 500
      GO TO 999
C                                       Requested data not in table
 500  WRITE(MSGTXT,1500) 'PHAS', TYPE
      IERR = 10
      GO TO 980
C                                       Error
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ERROR ',I3,' OPENING ',A,' TABLE NO. ',I3)
 1500 FORMAT (' REQUESTED DATA ',A,' NOT IN ',A,' TABLE ')
      END
      SUBROUTINE SNPCNT (NWORDS, IERR)
C-----------------------------------------------------------------------
C   SNPCNT reads the SN or CL table to find the number of samples for
C   each antenna
C   Input:
C      NWORDS   I      Number words in work space
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NWORDS, IERR
C
      LOGICAL   NODATA, OKAY
      INTEGER   I, NP, IIS, IIF, IP1
      REAL      TB, TE, GTIME
      INCLUDE 'SNREF.INC'
      REAL      VALUE(2*MAXIF), VALUE2(2*MAXIF)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      CALL FILL (MAXANT, 0, NANREC)
      CALL FILL (MAXANT, 0, NUMREF)
      NODATA = .TRUE.
      TB = 1.0E5
      TE = -1.0E5
C                                       Loop thru data
      NP = MUMPOL * MUMIF
      DO 100 ICLRNO = 1,NCLINR
         CALL TABIO ('READ', 0, ICLRNO, GNREC, CLBUFF, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
C                                       Record within specified
C                                       time range ?
         IF (KOLTYP(CLTIME).EQ.1) THEN
            GTIME = GNRECD(TIMKOL)
         ELSE
            GTIME = GNREC(TIMKOL)
            END IF
         IF ((GTIME.LT.TSTART) .OR. (GTIME.GT.TSTOP)) GO TO 100
C                                       Freq id
         IF ((GNRECI(FRQKOL).GT.0) .AND. (GNRECI(FRQKOL).NE.FRQSEL)
     *      .AND. (FRQSEL.GT.0)) GO TO 100
C                                       Subarray
         IF ((GNRECI(SUBKOL).GT.0) .AND. (SUBARR.GT.0) .AND.
     *      (GNRECI(SUBKOL).NE.SUBARR)) GO TO 100
C                                      Get start, stop times
         TB = MIN (TB, GTIME)
         TE = MAX (TE, GTIME)
C                                       Get value
         CALL SNPDAT (VALUE, VALUE2, OKAY)
C                                       Max. - Min
         IF (OKAY) THEN
            IANT = GNRECI(ANTKOL)
            NODATA = .FALSE.
            NANREC(IANT) = NANREC(IANT) + 1
            DO 70 IIS = 1,MUMPOL
               IP1 = RFKOL(IIS) - 1
               DO 60 IIF = BIF,EIF
                  IP1 = IP1 + 1
                  IANT = GNRECI(IP1)
                  NUMREF(IANT) = NUMREF(IANT) + 1
 60               CONTINUE
 70            CONTINUE
            END IF
 100     CONTINUE
      FANREC(1) = 1
      DO 120 I = 2,MAXANT
         FANREC(I) = FANREC(I-1) + NANREC(I-1)
 120     CONTINUE
      IF (NWORDS.LT.FANREC(MAXANT)+NANREC(MAXANT)) THEN
         MSGTXT = 'MEMORY TOO SMALL'
         IERR = 10
         END IF
C
 990  IF (IERR.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SNPMAX: ERROR =',I3,' FROM TABIO')
      END
      SUBROUTINE SNPDAT (VALUE, VALUE2, OKAY)
C-----------------------------------------------------------------------
C   Routine to get the specified value from a SN/CL table entry
C   Input from common:
C      GNREC    R(*)  Table record
C      ICODE    I     Plot code
C      SUMSTK   I     Selected Stokes 0=both, 1=R, 2=L, 3=Difference
C   Also uses pointers etc. set in SNPOPN
C   Output:
C      VALUE    R(*)   Table value, magic value blanked (amp on ICODE 6)
C      OKAY     L      Some values are good
C-----------------------------------------------------------------------
      REAL      VALUE(*), VALUE2(*)
      LOGICAL   OKAY
C
      INTEGER   IIS, IIF, IP1, IP2, LP, JP1, JP2
      REAL      AMP1, AMP2
      INCLUDE 'SNREF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       In case the data is bad
      LP = MUMPOL * MUMIF
      CALL RFILL (LP, FBLANK, VALUE)
      CALL RFILL (LP, FBLANK, VALUE2)
C                                       Select data type
C                                       Phase (deg)
      DO 110 IIS = 1,MUMPOL
         LP = IIS - MUMPOL
         IP1 = REKOL(IIS) - 1
         JP1 = IMKOL(IIS) - 1
         IP2 = REKOL(2) - 1
         JP2 = IMKOL(2) - 1
         DO 105 IIF = 1,MUMIF
            IP1 = IP1 + 1
            JP1 = JP1 + 1
            IP2 =  IP2 + 1
            JP2 = JP2 + 1
            LP = LP + MUMPOL
            IF ((GNREC(IP1).NE.FBLANK) .AND. (GNREC(JP1).NE.FBLANK)
     *         .AND. (GNREC(IP2).NE.FBLANK) .AND.
     *         (GNREC(JP2).NE.FBLANK)) THEN
               AMP1 = SQRT (GNREC(IP1)**2 + GNREC(JP1)**2)
               AMP2 = SQRT (GNREC(IP1)**2 + GNREC(JP1)**2)
               IF ((AMP1.GT.0.0) .OR. (AMP2.GT.0.0)) THEN
                  VALUE(LP) = GNREC(IP1)/AMP1 - GNREC(IP2)/AMP2
                  VALUE2(LP) = GNREC(JP1)/AMP1 - GNREC(JP2)/AMP2
                  END IF
               END IF
 105        CONTINUE
 110     CONTINUE
C
      OKAY = .TRUE.
      LP = MUMPOL * MUMIF
      DO 910 IIS = 1,LP
         IF (VALUE(IIS).NE.FBLANK) GO TO 999
 910     CONTINUE
      OKAY = .FALSE.
C
 999  RETURN
      END
      SUBROUTINE SNPREF (NA, WORK, IRET)
C-----------------------------------------------------------------------
C   SNPREF loops over antenna - making a copy of the SN or CL table,
C   re-referencing it to the antenna, and the getting the R-L values
C   and computing the rms and extrema for each choice and then
C   deleting the temporary file.  Finally, it takes the best choice
C   and makes a new SN or CL table for it referenced to that choice.
C   Inputs:
C      NA       I      Number antennas
C   Outputs:
C      SNVALS   R(*)   Data work area (*)
C      IRET     I      Error code, 0=OK else failed
C-----------------------------------------------------------------------
      INTEGER   NA, IRET
      REAL      WORK(*)
C
      INCLUDE 'SNREF.INC'
      INTEGER   LA, OVER, NVER, BUFF1(256), BUFF2(256), LUN1, LUN2, IA,
     *   LKEY, LKOLS(18), IPNT, NKEY, I, NREC, NCOL, IERR, NUMROW, LOOP,
     *   JKOLS(18), IIF, ANTMIN(MAXIF), OVRMIN, IP, NUMP, NUMI, NUMA,
     *   CLKOLS(MAXCLC), CLNUMV(MAXCLC), NUMN, OVERAN(MAXANT),
     *   CATSAV(256)
      REAL      ANTRMS(MAXANT,MAXIF), ANTMAX(MAXANT,MAXIF), SMOTIM(3),
     *   MINRMS(MAXIF), OVRMS, SUM, RANOD(25), DECNOD(25)
      LOGICAL   ISAPPL
      CHARACTER KEYS(18)*24, PHNAME*48
      LOGICAL   OKAY
      DOUBLE PRECISION FREQIF, VSUM(2,MAXANT,MAXIF),
     *   VSUMS(2,MAXANT,MAXIF), VCOUNT(2,MAXANT,MAXIF)
      REAL      VALUE(2*MAXIF), VALUE2(2*MAXIF)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA LUN1, LUN2 /47,48/
      DATA KEYS /'ANTENNA NO.             ',
     *   'REFANT 1                ', 'SUBARRAY                ',
     *   'WEIGHT 1                ', 'TIME                    ',
     *   'REAL1                   ', 'IMAG1                   ',
     *   'DELAY 1                 ', 'RATE 1                  ',
     *   'ANTENNA NO.             ',
     *   'REFANT 2                ', 'SUBARRAY                ',
     *   'WEIGHT 2                ', 'TIME                    ',
     *   'REAL2                   ', 'IMAG2                   ',
     *   'DELAY 2                 ', 'RATE 2                  '/
C-----------------------------------------------------------------------
C                                       close the table
      CALL TABIO ('CLOS', 0, ICLRNO, GNREC, CLBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OPEN INPUT TABLE'
         GO TO 990
         END IF
      CALL COPY (256, CATBLK, CATSAV)
C                                       zero save arrays
      I = MAXANT * MAXIF
      CALL RFILL (I, 0.0, ANTRMS)
      CALL RFILL (I, 0.0, ANTMAX)
C                                       version numbers
      CALL FNDEXT (TYPE, CATBLK, NVER)
      IF ((IVER.LE.0) .OR. (IVER.GT.NVER)) IVER = NVER
      OVER = NVER + 1
C                                       Smoothing times
      SMOTIM(1) = 1.0E-6
      SMOTIM(2) = 1.0E-6
      SMOTIM(3) = 1.0E-6
C                                       loop over antenna
      DO 100 LA = 1,NA
C                                       skip if no records
         IF (NANREC(LA).LE.0) GO TO 100
C                                       copy the table to sc vers
         MSGSUP = 31999
         OVERAN(LA) = OVER
         CALL TABCOP (TYPE, IVER, OVER, LUN1, LUN2, DISKIN, DISKIN,
     *      CNOIN, CNOIN, CATBLK, BUFF1, BUFF2, IRET)
         MSGSUP = 0
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, LA, 'COPYING TABLE FOR WORK'
            GO TO 990
            END IF
         IF (KEEP.GT.0.0) THEN
            WRITE (MSGTXT,1005) TYPE, OVER, LA
            CALL MSGWRT (3)
            END IF
C                                       open the file
         ICLUN = 28
         NKEY = 0
         NREC = 0
         NCOL = 0
         ICLRNO = 1
         IF (TYPE.EQ.'SN') THEN
            CALL SNINI ('WRIT', CLBUFF, DISKIN, CNOIN, OVER, CATBLK,
     *         ICLUN, ICLRNO, CLKOLS, CLNUMV, NUMA, NUMP, NUMI, NUMN,
     *         GMMOD, RANOD, DECNOD, ISAPPL, IRET)
         ELSE
            CALL CALINI ('WRIT', CLBUFF, DISKIN, CNOIN, OVER, CATBLK,
     *         ICLUN, ICLRNO, CLKOLS, CLNUMV, NUMA, NUMP, NUMI, NUMN,
     *         GMMOD, IRET)
            END IF
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1010) IRET, LA, 'OPEN SC TABLE'
            GO TO 990
            END IF
         NUMROW = CLBUFF(5)
         NKEY = 9
         LKEY = 24
         CALL FNDCOL (NKEY, KEYS, LKEY, .TRUE., CLBUFF, LKOLS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, LA, 'FIND SC TABLE KEYS'
            GO TO 990
            END IF
         CALL FNDCOL (NKEY, KEYS(10), LKEY, .TRUE., CLBUFF, LKOLS(10),
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, LA, 'FIND SC TABLE KEYS'
            GO TO 990
            END IF
         DO 10 LOOP = 1,18
            IPNT = LKOLS(LOOP)
            LKOLS(LOOP) = CLKOLS(IPNT)
 10         CONTINUE
C                                       re-reference
         DO 30 IA = 1,NA
            IF (NUMREF(IA).GT.0) THEN
               CALL COPY (18, LKOLS, JKOLS)
               DO 20 IIF = BIF,EIF
                  FREQIF = FREQ + FOFF(IIF)
                  CALL CALREF (IA, LA, SUBARR, JKOLS(1), FREQIF, SMOTIM,
     *               NUMROW, CLBUFF, WORK(1), WORK(1+NUMROW),
     *               WORK(1+2*NUMROW), WORK(1+3*NUMROW),
     *               WORK(1+4*NUMROW),IERR)
                  CALL CALREF (IA, LA, SUBARR, JKOLS(10), FREQIF,
     *               SMOTIM, NUMROW, CLBUFF, WORK(1), WORK(1+NUMROW),
     *               WORK(1+2*NUMROW), WORK(1+3*NUMROW),
     *               WORK(1+4*NUMROW), IRET)
                  IF ((IERR.EQ.1) .OR. (IRET.EQ.1)) GO TO 90
                  IRET = MAX (IERR, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1010) IRET, LA,
     *                  'REREFERENCING TO ANTENNA'
                     GO TO 990
                     END IF
C                                       Update column pointers for IF
                  JKOLS(2) = JKOLS(2) + 1
                  JKOLS(4) = JKOLS(4) + 1
                  JKOLS(6) = JKOLS(6) + 1
                  JKOLS(7) = JKOLS(7) + 1
                  JKOLS(8) = JKOLS(8) + 1
                  JKOLS(9) = JKOLS(9) + 1
                  JKOLS(11) = JKOLS(11) + 1
                  JKOLS(13) = JKOLS(13) + 1
                  JKOLS(15) = JKOLS(15) + 1
                  JKOLS(16) = JKOLS(16) + 1
                  JKOLS(17) = JKOLS(17) + 1
                  JKOLS(18) = JKOLS(18) + 1
 20               CONTINUE
               END IF
 30         CONTINUE
C                                       read through table get rms
         I = 2 * MAXANT * MAXIF
         CALL DFILL (I, 0.0D0, VSUM)
         CALL DFILL (I, 0.0D0, VSUMS)
         CALL DFILL (I, 0.0D0, VCOUNT)
         DO 50 ICLRNO = 1,NUMROW
            CALL TABIO ('READ', 0, ICLRNO, GNREC, CLBUFF, IRET)
            IF (IRET.LT.0) GO TO 50
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1010) IRET, LA, 'READ SC TABLE'
               GO TO 990
               END IF
C                                       Freq id
            IF ((GNRECI(FRQKOL).GT.0) .AND. (GNRECI(FRQKOL).NE.FRQSEL)
     *         .AND. (FRQSEL.GT.0)) GO TO 50
C                                       Subarray
            IF ((GNRECI(SUBKOL).GT.0) .AND. (SUBARR.GT.0) .AND.
     *         (GNRECI(SUBKOL).NE.SUBARR)) GO TO 50
            IANT = GNRECI(ANTKOL)
C                                       Get value
            CALL SNPDAT (VALUE, VALUE2, OKAY)
C                                       Max. - Min
            IF (OKAY) THEN
               IP = 0
               DO 40 IIF = 1,MUMIF
                  IP = IP + 1
                  IF (VALUE(IP).NE.FBLANK) THEN
                     VSUM(1,IANT,IIF) = VSUM(1,IANT,IIF) + VALUE(IP)
                     VSUMS(1,IANT,IIF) = VSUMS(1,IANT,IIF) + VALUE(IP)
     *                  * VALUE(IP)
                     VCOUNT(1,IANT,IIF) = VCOUNT(1,IANT,IIF) + 1.0D0
                     END IF
                  IF (VALUE2(IP).NE.FBLANK) THEN
                     VSUM(2,IANT,IIF) = VSUM(2,IANT,IIF) + VALUE2(IP)
                     VSUMS(2,IANT,IIF) = VSUMS(2,IANT,IIF) + VALUE2(IP)
     *                  * VALUE2(IP)
                     VCOUNT(2,IANT,IIF) = VCOUNT(2,IANT,IIF) + 1.0D0
                     END IF
 40               CONTINUE
               END IF
 50         CONTINUE
C                                       rms
         DO 70 IIF = BIF,EIF
            IP = 0
            DO 60 IA = 1,NA
               IF ((VCOUNT(1,IA,IIF).GT.0.0D0) .AND.
     *            (VCOUNT(2,IA,IIF).GT.0.0D0)) THEN
                  VSUM(1,IA,IIF) = VSUM(1,IA,IIF) / VCOUNT(1,IA,IIF)
                  VSUMS(1,IA,IIF) = VSUMS(1,IA,IIF) / VCOUNT(1,IA,IIF)
     *               - VSUM(1,IA,IIF) * VSUM(1,IA,IIF)
                  VSUM(2,IA,IIF) = VSUM(2,IA,IIF) / VCOUNT(2,IA,IIF)
                  VSUMS(2,IA,IIF) = VSUMS(2,IA,IIF) / VCOUNT(2,IA,IIF)
     *               - VSUM(2,IA,IIF) * VSUM(2,IA,IIF)
                  IP = IP + 1
                  ANTRMS(LA,IIF) = ANTRMS(LA,IIF) + SQRT (MAX (0.0D0,
     *               VSUMS(1,IA,IIF) + VSUMS(2,IA,IIF)))
                  END IF
 60            CONTINUE
            IF (IP.GT.0) ANTRMS(LA,IIF) = ANTRMS(LA,IIF) / IP
 70         CONTINUE
C                                       close and delete
 90      CALL TABIO ('CLOS', 0, ICLRNO, GNREC, CLBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, LA, 'CLOS SC TABLE'
            GO TO 990
            END IF
         IF (KEEP.GT.0.0) THEN
            OVER = OVER + 1
         ELSE
            CALL DELEXT (TYPE, DISKIN, CNOIN, 'WRWR', BUFF1, BUFF2,
     *         OVER, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, LA, 'DELETE SC TABLE'
               GO TO 990
               END IF
            CALL COPY (256, CATSAV, CATBLK)
            CALL ZPHFIL (TYPE, DISKIN, CNOIN, OVER, PHNAME, IERR)
            CALL ZDESTR (DISKIN, PHNAME, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, LA, 'DESTROYING TEMP TABLE'
               GO TO 990
               END IF
            END IF
 100     CONTINUE
C                                       now which is best?
      CALL RFILL (MAXIF, 1.E10, MINRMS)
      CALL FILL (MAXIF, 0, ANTMIN)
      OVRMIN = 0
      OVRMS = 1.E10
      DO 120 LA = 1,NA
         IP = 0
         SUM = 0.0
         DO 110 IIF = BIF,EIF
            IF (ANTRMS(LA,IIF).GT.0.0) THEN
               IP = IP + 1
               SUM = SUM + ANTRMS(LA,IIF)*ANTRMS(LA,IIF)
               IF (ANTRMS(LA,IIF).LT.MINRMS(IIF)) THEN
                  MINRMS(IIF) = ANTRMS(LA,IIF)
                  ANTMIN(IIF) = LA
                  END IF
               END IF
 110        CONTINUE
         IF (IP.GT.0) THEN
            SUM = SQRT (SUM / IP)
            IF (SUM.LT.OVRMS) THEN
               OVRMS = SUM
               OVRMIN = LA
               END IF
            END IF
 120     CONTINUE
      WRITE (MSGTXT,1120) OVRMIN, OVRMS
      CALL MSGWRT (5)
      DO 130 IIF = BIF,EIF
         WRITE (MSGTXT,1125) IIF, ANTMIN(IIF), MINRMS(IIF)
         CALL MSGWRT (5)
 130     CONTINUE
      IIF = BIF
 140  LOOP = MIN (EIF, BIF+7)
      MSGTXT = '*****  R-L rmses by reference antenna and IF *****'
      CALL MSGWRT (4)
      WRITE (MSGTXT,1140) (I, I = IIF,LOOP)
      CALL MSGWRT (4)
      DO 150 LA = 1,NA
         IF (NANREC(LA).GT.0) THEN
            WRITE (MSGTXT,1145) LA, (ANTRMS(LA,I), I = IIF,LOOP)
            CALL MSGWRT (4)
            END IF
 150     CONTINUE
      IIF = LOOP + 1
      IF (IIF.LE.EIF) GO TO 140
C                                       get best SN/CL table
      LA = OVRMIN
      IF (KEEP.LE.0.0) THEN
         OVERAN(LA) = OVER
         CALL TABCOP (TYPE, IVER, OVER, LUN1, LUN2, DISKIN, DISKIN,
     *      CNOIN, CNOIN, CATBLK, BUFF1, BUFF2, IRET)
         MSGSUP = 0
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, LA, 'COPYING TABLE FOR WORK'
            GO TO 990
            END IF
C                                       open the file
         ICLUN = 28
         NKEY = 0
         NREC = 0
         NCOL = 0
         ICLRNO = 1
         IF (TYPE.EQ.'SN') THEN
            CALL SNINI ('WRIT', CLBUFF, DISKIN, CNOIN, OVER, CATBLK,
     *         ICLUN, ICLRNO, CLKOLS, CLNUMV, NUMA, NUMP, NUMI, NUMN,
     *         GMMOD, RANOD, DECNOD, ISAPPL, IRET)
         ELSE
            CALL CALINI ('WRIT', CLBUFF, DISKIN, CNOIN, OVER, CATBLK,
     *         ICLUN, ICLRNO, CLKOLS, CLNUMV, NUMA, NUMP, NUMI, NUMN,
     *         GMMOD, IRET)
            END IF
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1010) IRET, LA, 'OPEN SC TABLE'
            GO TO 990
            END IF
         NUMROW = CLBUFF(5)
         NKEY = 9
         LKEY = 24
         CALL FNDCOL (NKEY, KEYS, LKEY, .TRUE., CLBUFF, LKOLS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, LA, 'FIND SC TABLE KEYS'
            GO TO 990
            END IF
         CALL FNDCOL (NKEY, KEYS(10), LKEY, .TRUE., CLBUFF, LKOLS(10),
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, LA, 'FIND SC TABLE KEYS'
            GO TO 990
            END IF
         DO 210 LOOP = 1,18
            IPNT = LKOLS(LOOP)
            LKOLS(LOOP) = CLKOLS(IPNT)
 210        CONTINUE
C                                       re-reference
         DO 230 IA = 1,NA
            IF (NUMREF(IA).GT.0) THEN
               CALL COPY (18, LKOLS, JKOLS)
               DO 220 IIF = BIF,EIF
                  FREQIF = FREQ + FOFF(IIF)
                  CALL CALREF (IA, LA, SUBARR, JKOLS(1), FREQIF, SMOTIM,
     *               NUMROW, CLBUFF, WORK(1), WORK(1+NUMROW),
     *               WORK(1+2*NUMROW), WORK(1+3*NUMROW),
     *               WORK(1+4*NUMROW), IERR)
                  CALL CALREF (IA, LA, SUBARR, JKOLS(10), FREQIF,
     *               SMOTIM, NUMROW, CLBUFF, WORK(1), WORK(1+NUMROW),
     *               WORK(1+2*NUMROW), WORK(1+3*NUMROW),
     *               WORK(1+4*NUMROW), IRET)
                  IRET = MAX (IERR, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1010) IRET, LA,
     *                  'REREFERENCING TO ANTENNA'
                     GO TO 990
                     END IF
C                                       Update column pointers for IF
                  JKOLS(2) = JKOLS(2) + 1
                  JKOLS(4) = JKOLS(4) + 1
                  JKOLS(6) = JKOLS(6) + 1
                  JKOLS(7) = JKOLS(7) + 1
                  JKOLS(8) = JKOLS(8) + 1
                  JKOLS(9) = JKOLS(9) + 1
                  JKOLS(11) = JKOLS(11) + 1
                  JKOLS(13) = JKOLS(13) + 1
                  JKOLS(15) = JKOLS(15) + 1
                  JKOLS(16) = JKOLS(16) + 1
                  JKOLS(17) = JKOLS(17) + 1
                  JKOLS(18) = JKOLS(18) + 1
 220              CONTINUE
               END IF
 230        CONTINUE
         END IF
      WRITE (MSGTXT,1150) TYPE, OVERAN(LA), LA
      CALL MSGWRT (5)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SNPREF: ERROR =',I3,' ON ',A)
 1005 FORMAT (A,' version ',I4,' will be referenced to antenna',I3)
 1010 FORMAT ('SNPREF: ERROR =',I3,' ANTENNA ',I3,' ON ',A)
 1120 FORMAT ('Best antenna is',I3,' with',1PE12.4,' rms')
 1125 FORMAT ('IF',I3,' best antenna is',I3,' with',1PE12.4,' rms')
 1140 FORMAT ('ANT\\IF',I4,7I7)
 1145 FORMAT (I3,8F7.4)
 1150 FORMAT (A,' version',I4,' is referenced to best antenna',I3)
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QVINDE (A, B, J, C, K, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Vector index (gather)
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Vector gather:
C        C(mK) = A(r)  where r = fix(B(mJ))
C                      for m = 0,N-1
C   Inputs:
C      A  I  Source vector base address
C      B  I  Index vector base address.
C      J  I  A address increment
C      C  I  Destination vector base address
C      K  I  C address increment
C      N  I  Element count
C-----------------------------------------------------------------------
      INTEGER   A, B, J, C, K, N, JA, JB, JC, LOOP, ITEMP
      REAL      VALUE, TEMP(1024)
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
      IF (N.GT.1024) THEN
         WRITE(*,*) '******ERROR in QVINDE *****'
         WRITE(*,*) 'N = ', N
         GOTO 999
      ENDIF
C                                       Addresses 1-rel
      JA = A + 1
      JB = B + 1
      JC = C + 1
      JBP = JB
      DO 50 LOOP = 1,N
         TEMP(LOOP) = SIGN(0.5, APCORE(JBP))
         JBP = JBP + J
 50      CONTINUE
C                                       Loop
C@DIR IGNORE RECRDEPS(APCORE)
      DO 100 LOOP = 1,N
         ITEMP = APCORE(JB) + TEMP(LOOP)
         APCORE(JC) = APCORE(JA+ITEMP)
         JB = JB + J
         JC = JC + K
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE UVMSUB (APCORE, DISKI, CNOSCI, DISKO, CNOSCO, IFIELD,
     *   MODEL, METHOD, CHANEL, NCHAN, DOSUM, DOMSG, CATBLK, JBUFSZ,
     *   FREQID, BUFF1, BUFF2, BUFF3, IRET)
C-----------------------------------------------------------------------
C! Subtracts the Fourier transform of a model from a uv data set.
C# AP-util UV Map Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 1999-2000, 2008-2009, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVMSUB subtracts a clean model or an image from a set of uv data.
C   Extensive use is made of commons to communicate with UVMSUB, in
C   particular /MAPDES/ (include DGDS.INC) contains most
C   of the critical information about the CLEAN components files or
C   images to be subtracted.  Common /UVHDR/ (filled in by UVPGET) is
C   presumed to describe the uv data files.
C      Also fills in frequency table (NCHANG, FREQG) in includes
C   DGDS.INC
C   Inputs:
C      DISKI    I        Input disk number. if <= 0 then input is a
C                        scratch file.
C      CNOSCI   I        Input file catalog slot number or /CFILES/
C                        scratch file number.
C      DISKO    I        Output disk number. if <= 0 then output is a
C                        scratch file.
C      CNOSCO   I        Output file catalog slot number or /CFILES/
C                        scratch file number.
C      IFIELD   I        If CC, field number (0 -> all)
C      MODEL    I        1=> clean components, 2=>image.
C      METHOD   I        1=>gridded, -1=>DFT, 0=>chose.
C      CHANEL   I        First uv data channel to subtract.
C      NCHAN    I        Number of frequency channels to subtract.
C      DOSUM    L        If true then sum component fluxes in FLUXG,
C                        TFLUXG.
C      DOMSG    L        If true give percent done messages for DFT.
C      CATBLK   I(256)   UV data catalog header record.
C      JBUFSZ   I        Size of BUFF1,2,3 in bytes, must be at least
C                        4096 words.
C      FREQID   I        Freq ID number, if it exists.
C   Inputs from COMMON /MAPDES/:
C      MFIELD   I        Number of fields
C      NSUBG    I(*)     Number of components already sub.
C      NCLNG    I(*)     Number of components per field.
C      CCDISK   I(*)     Disk numbers for CC files
C      CCCNO    I(*)     Catalog slot numbers for CC files.
C      CCVER    I(*)     CC file version number for each field.
C      FACGRD   R(2)     Value to multiply clean component fluxes
C                        by before subtraction (negative for sum).
C                        FACGRD(2) is for data and 0 or 1 only values
C                        used.  Model added not subtracted when data are
C                        ignored.
C      NONEG    L        Stop reading comps. from a file past the first
C                        negative component.
C      LIMFLX   R        Stop reading comps < LIMFLX in abs value
C      DOPTMD   L        Use the point model specified by PTFLX, PTRAOF,
C                        PTDCOF (DFT modeling ONLY)
C      PTFLX    R        Point model flux density (Jy) (I pol. only)
C      PTRAOF   R        Point model RA offset from uv phase center
C                        (arcsec)
C      PTDCOF   R        Point model Dec. offset from uv phase center
C   Input from COMMON /UVHDR/:
C      LREC     I        Length of visibility record.
C      NVIS     I        Number of visibility records.
C      NRPARM   I        "Random" parameters before data, can be used
C                        to skip observed values when computing model.
C   Output:
C      BUFF1    R(*)     Work buffers.
C      BUFF2    R(*)     Work buffers.
C      BUFF3    R(*)     Work buffers.
C      IRET     I        Return error code. 0=>OK, otherwise failed.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   DISKI, CNOSCI, DISKO, CNOSCO, IFIELD, MODEL, METHOD,
     *   CHANEL, NCHAN, CATBLK(256), JBUFSZ, IRET
      LOGICAL   DOSUM, DOMSG
      REAL      BUFF1(*), BUFF2(*), BUFF3(*)
C
      INTEGER   SCRGRD, SCRWRK, DISK, CNO, LUN, INMETH, OUMETH, FREQID
      LOGICAL   DODFT, LTEMP
      REAL      TIMDFT, TIMFFT
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSCD.INC'
      SAVE LUN, SCRGRD, SCRWRK
      DATA SCRGRD, SCRWRK /0, 0/, LUN /27/
C-----------------------------------------------------------------------
      IRET = 0
      NGRDAT = .FALSE.
C                                       Store CATBLK for later use
      IF (.NOT.DATDIV) THEN
         CALL COPY (256, CATBLK, SCRCAT)
         SCLREC = LREC
         SCRPRM = NRPARM
         COMPDT = CATBLK(KINAX).EQ.1
         IF (COMPDT) THEN
            CALL AXEFND (8, 'WEIGHT  ', SCRCAT(KIPCN), SCRHOL(KHPTP),
     *         WTLOC, IRET)
            IF ((IRET.NE.0) .OR. (WTLOC.LT.0)) THEN
               IRET = 5
               MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED'
     *            // ' DATA'
               CALL MSGWRT (8)
               GO TO 999
               END IF
            IRET = 0
            END IF
         END IF
C                                       If using a scratch file
      IF (DISKI.LE.0) THEN
         DISK = SCRVOL(CNOSCI)
         CNO = SCRCNO(CNOSCI)
      ELSE
         DISK = DISKI
         CNO = CNOSCI
         END IF
C                                       Fill Frequency table.
      CALL FRQTAB (DISK, CNO, LUN, CATBLK, FREQID, BUFF1, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Decide model computation method.
      INMETH = METHOD
      DODFT = (METHOD.LT.0) .AND. (MODEL.EQ.1)
C                                       DFT only for pt. model
      CALL UVMTYP (IFIELD, METHOD, NCHAN, LTEMP, TIMDFT, TIMFFT)
      IF (MODEL.EQ.1) DODFT = LTEMP
      DODFT = DODFT .OR. DOPTMD
      OUMETH = 1
      IF (DODFT) OUMETH = -1
C                                       If doing DFT model subtraction
      IF (DODFT) THEN
         CALL VISDFT (APCORE, 'SUB ', CHANEL, NCHAN, DISKI, CNOSCI,
     *      DISKO, CNOSCO, IFIELD, DOSUM, DOMSG, CATBLK, JBUFSZ, BUFF1,
     *      BUFF2, BUFF3, IRET)
C                                       Gridded interpolation method.
      ELSE
         DOFFT = (MODEL.EQ.2) .OR. (MODEL.EQ.3)
         CALL GRDSUB (APCORE, MODEL, DOSUM, SCRGRD, SCRWRK, DISKI,
     *      CNOSCI, DISKO, CNOSCO, IFIELD, CHANEL, NCHAN, CATBLK,
     *      JBUFSZ, BUFF1,BUFF2, BUFF3, IRET)
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'PFPL2.INC'
C                                       PLTLAB declarations.
      REAL      CHOUT(4), YGAP
      INTEGER   NTEXT, NTEXT2, PCODES(5)
      CHARACTER TEXT(2)*80, TEXT2(2)*80, XUNIT*20, YUNIT*20, TITLE*80
C                                       Plot labeling parameters.
      COMMON /PLTLAB/ CHOUT, YGAP, NTEXT, NTEXT2, PCODES
      COMMON /PLCLAB/ TEXT, TEXT2, XUNIT, YUNIT, TITLE
C                                       INPARM declarations.
      REAL      PRUSER, NAMIN(3), CLSIN(2), SEQIN, DSKIN, BLC(7),
     *   TRC(7), PIXRNG(2), XLTYPE, XDOTV, XGRCH
C                                       Parameters from AIPS.
      COMMON /INPARM/ PRUSER, NAMIN, CLSIN, SEQIN, DSKIN, BLC, TRC,
     *   PIXRNG, XLTYPE, XDOTV, XGRCH
LOCAL END
      PROGRAM PFPL2
C-----------------------------------------------------------------------
C! Plot paraform task: X axis = slice of X-Y axes; Y = other plot value
C# Plot
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2002, 2009, 2012, 2014-2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PFPL2 (paraform plot program 2) is designed to be a model for
C   writing tasks to do plotting in AIPS.  This program is designed
C   for reading a map and creating a plot file to be associated
C   with the map.  This task assumes that the X axis of the plot is a
C   slice of the X-Y axes of the map and the Y axis of the plot is
C   some other value such as intensity.  Plot labels for the Y axis
C   come from a data statement found in the main program.  Labeling
C   the X axis in a way that works for all types of data is a complex
C   problem and is handled automatically (with luck) by this program.
C   An example of this type of plot is the slice plot produced by
C   calling task SLICE to produce a slice file followed by using task
C   SL2PL to produce a plot file.  For other types of plots see
C   programs PFPL1 and PFPL3.
C   The program will do the following steps:
C     1. Open a map file corresponding to the user's inputs from AIPS.
C     2. Create an extension file of type PL (plot) to be associated
C        with the map file.  The header of the map file will be
C        updated to include this new extension file.
C     3. Write the plot file records to draw the borders and labels
C        of the plot.  The programmer can customize this section of
C        the program by changing data statements in subroutine PLTOR2.
C     4. Write the rest of the plot file records to the plot file.
C        This is done by subroutine PLTOR2.  The current routine
C        draws a plot of map intensities through a slice of the map.
C        This program uses no interpolation and is NOT adequate for
C        a production program.  See the code in program SLICE for a
C        good set of interpolation routines.  The programmer will
C        have to modify the code in subroutine PLTOR2 for his/her
C        needs.
C     5. Do the necessary clean up functions, write end of plot
C        records, close all files, etc.
C
C   IMPORTANT NOTE: to avoid confusion, this task should be renamed.
C   To rename (max. 5 char) and install the new task:
C     1. Copy the source code to a new file with the name
C        NEWNAME.FOR.
C     2. Using the source editor, change all references to PFPL2 to
C        NEWNAME.  It is especially important to change the string
C        entered into array PRGM at or near line 61 to the new name.
C     3. Copy help/inputs file PFPL2.HLP to inputs file NEWNAME.HLP.
C        Update the inputs, help and explain sections.
C     4. Compile and link edit with the APL and NOTST subroutine
C        libraries from AIPS.
C     5. Modify the comments at the top of this program to help
C        others understand what the program does.
C     6. Change the assignment statements to array variable PCODES
C        and the data statements for NTEXT, TEXT, XUNIT, YUNIT and
C        TITLE in the main program to get the type of axis labeling
C        you want.  Then add code to PLTOR2 to do the plotting.
C     7. While debugging your program, set IDEBUG to 1 to have plot
C        files kept despite program failures.  DUMP routines can be
C        run on them to determine what did go to the plot file and
C        and to help figure out what went wrong.  Set IDEBUG to 0
C        before releasing the program to other users.
C
C    Inputs:   (from AIPS)
C       USERID   R      user number, 0 means use logon user
C                       number, 32000 means any user can be accessed.
C       INNAME   R(3)   name of primary file.
C       INCLASS  R(2)   class of primary file.
C       INSEQ    R      sequence number of primary file.
C       NDISK    R      disk volume number. 0 means try all.
C       BLC      R(7)   the starting coordinates for the slice.
C                       BLC(1) is the X coordinate and
C                       BLC(2) is the Y coordinate.  The first
C                       coordinate in the input image is (1,1).
C       TRC      R(7)   the ending coordinate for the slice.
C       PIXRANGE R(2)   Sets the upper and lower limit on intensity
C                       of values to appear in the slice.  0, 0
C                       defaults to range in map header.
C       LTYPE    R      Label type.
C       DOTV     R      > 0 => TV, else plot file
C       GRCHAN   R      graphics channel to use (0 => 1)
C-----------------------------------------------------------------------
C                                       local declarations
      CHARACTER ATEXT(2)*80, AXUNIT*20, AYUNIT*20, ATITLE*80, PRGNAM*6
      INTEGER   IMLUN, NPARMS, IERR, INTEXT, IDEBUG, IROUND, IPTYPE, I
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DPLT.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'PFPL2.INC'
      DATA IMLUN /16/
      DATA PRGNAM /'PFPL2 '/
C                                       Data statements to control the
C                                       text at the bottom of the plot.
C                                       INTEXT is the number of text
C                                       lines.
      DATA INTEXT /2/
      DATA ATEXT /'This is some text at the bottom of the plot ',
     *     'This is the second line '/
C                                       Units to use if PCODES(2)
C                                       .NE. 0 and PCODES(3) .NE. 0.
      DATA AXUNIT, AYUNIT /'XUNIT','YUNIT'/
C                                       Title if PCODES(4) .NE. 0.
      DATA ATITLE /'TITLE'/
C-----------------------------------------------------------------------
C                                       Copy from DATA to Commons
      IBLKSZ = MABFSS
      GPHIND = 0
      NTEXT = INTEXT
      XUNIT = AXUNIT
      YUNIT = AYUNIT
      TITLE = ATITLE
      TEXT(1) = ATEXT(1)
      TEXT(2) = ATEXT(2)
C                                       Don't delete plot file on error
      IDEBUG = 1
C                                       This is the number of REAL*4
C                                       words to get from AIPS.
      NPARMS = 27
C                                       Plot type PFPL2 paraform
      IPTYPE = 11
C                                       Get parms from AIPS, open map
C                                       file, create plot file,
      CALL PF2INI (PRGNAM, NPARMS, IMLUN, IPTYPE, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       These are parameters to
C                                       control labeling.
C                                       Label type from user input.
      PCODES(1) = IROUND (XLTYPE)
      I = MOD (ABS(PCODES(1)), 100)
      IF ((I.EQ.0) .OR. (I.GT.10)) THEN
         IF (PCODES(1).GE.0) THEN
            PCODES(1) = (PCODES(1)/100)*100 + 3
         ELSE
            PCODES(1) = (PCODES(1)/100)*100 - 3
            END IF
         END IF
      XLTYPE = PCODES(1)
C                                       Use "standard" labeling for
C                                       X axis based on map header.
      PCODES(2) = 0
C                                       Use intensity value in header
C                                       for Y axis label.
      PCODES(3) = 0
C                                       Use "standard" title line
      PCODES(4) = 0
C                                       Not now used
      PCODES(5) = 0
C                                       Do plotting.  This routine must
C                                       be modified by the programmer.
      CALL PLTOR2 (IERR)
C                                       Shutdown.
 900  CALL PLEND (IERR, IDEBUG)
C
 999  STOP
      END
      SUBROUTINE PF2INI (PRGNAM, NPARMS, IMLUN, IPTYPE, IERR)
C-----------------------------------------------------------------------
C   This routine does all the intial set up.  Get parms from AIPS,
C   open the map file, create the plot file and write the plot file
C   records to do the plot labeling.
C   Inputs:
C      PRGNAM  C*6   Name of this program.
C      NPARMS  I     Number of R words to get from AIPS.
C      IMLUN   I     The logical unit number to use for the map file.
C      IPTYPE  I     Plot file type: 1 misc., 2 CNTR, 3 GREYS, 4 PROFL,
C                    5 SL2PL, 6 PCNTR, 7 IMEAN (hist), 8 UVPLT,
C                    9 GNPLT, 10 VBPLT, 11 PFPLn, 12 GAPLT, 13 PLCUB,
C                    14 IMVIM, 15 TAPLT.  Use 1 unless your inputs match
C                    those of these tasks - or take a new number, but
C                    AIPSUB:AU8A will need to know about it too.
C   Output:
C      IERR    I     Error code. 0=ok.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   NPARMS, IMLUN, IPTYPE, IERR
C
      CHARACTER NAME*36, FNAME*12, FCLASS*6, FPTYPE*2, STAT*4
      INTEGER   IWORK(256), FSEQ, FVOL, FUSID
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DPLT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'PFPL2.INC'
C-----------------------------------------------------------------------
C                                       Get parameters from AIPS, init
C                                       AIPS I/O, other startup things.
      CALL SETUP (PRGNAM, NPARMS, PRUSER, IWORK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open the map file.
      CALL H2CHR (12, 1, NAMIN, FNAME)
      CALL H2CHR (6, 1, CLSIN, FCLASS)
      FSEQ = SEQIN + 0.01
      FVOL = DSKIN + 0.01
      PRUSER = NLUSER
      FUSID = NLUSER
      CALL A2WAWA (FNAME, FCLASS, FSEQ, 'MA', FVOL, FUSID, NAME)
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
      STAT = 'HDWR'
      IF (DOTV) STAT = 'READ'
      CALL INTMIO (IMLUN, STAT, NAME, BLC, TRC, IBLKSZ, CATBLK,
     *   IMSTUF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       fix to do one plane only
      CALL RCOPY (5, BLC(3), TRC(3))
      IMSTUF(22) = IMSTUF(21)
      IMSTUF(24) = IMSTUF(23)
      IMSTUF(26) = IMSTUF(25)
      IMSTUF(28) = IMSTUF(27)
      IMSTUF(30) = IMSTUF(29)
C                                       Find actual range of map values
      CALL RNGSET (PIXRNG, CATR(KRDMX), CATR(KRDMN), RANGE)
C                                       Fill in defaults
      CALL WAWA2A (NAME, FNAME, FCLASS, FSEQ, FPTYPE, FVOL, FUSID)
      CALL CHR2H (12, FNAME, 1, NAMIN)
      CALL CHR2H (6, FCLASS, 1, CLSIN)
      SEQIN = FSEQ
      DSKIN = FVOL
      PIXRNG(1) = RANGE(1)
      PIXRNG(2) = RANGE(2)
C                                       Create and open plot file.
      CALL PLMAKE (NPARMS, PRUSER, IPTYPE, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE PLTOR2 (IERR)
C-----------------------------------------------------------------------
C  This routine writes all of the plot commands (including the axis
C  drawing and labeling commands) into the plot file.
C  Input from common:
C     BLC      R(7)   Bottom left corner of plot.
C     TRC      R(7)   Top right corner of plot.
C  Output:
C    IERR      I      Error code.  0=ok.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'INCS:PMAD.INC'
      REAL      X, Y, ROW(MAXIMG), DX, DY, XVAL, YVAL
      INTEGER   INOSL, I, II, IY, IROUND, IX, ICUR, IXEND
      LOGICAL   EOF, DOWN
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DPLT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'PFPL2.INC'
C-----------------------------------------------------------------------
C                                       Number of points in slice.
      INOSL = 500
C                                       Set up commons for plotting.
      CALL PLINI2 (INOSL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Do axis labeling.
      CALL PLABL2 (IERR)
      IF (IERR.NE.0) GO TO 999
C                                    ** Plot specific statements.
C                                       Calculate some counters.
      DX = (TRC(1) - BLC(1)) / (INOSL - 1)
      DY = (TRC(2) - BLC(2)) / (INOSL - 1)
C                                       Read 1st row.
      CALL GETROW (IMSTUF, IOBLK, ROW, EOF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Determine which end of buffer to
C                                       start from.
      IXEND = 1
      IF (BLC(1).GT.TRC(1)) IXEND = IMSTUF(9)
C                                       Position at 1st value.
      CALL GLTYPE (2, PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      XVAL = 1.0
      YVAL = ROW(IXEND)
      CALL PLPOS (XVAL, YVAL, IERR)
      IF (IERR.NE.0) GO TO 999
      DOWN = YVAL.NE.FBLANK
C                                       Calculate X and Y
      DO 30 I = 2,INOSL
         X = (I - 1) * DX + IXEND
         Y = (I - 1) * DY + BLC(2)
C                                       Find nearest X and Y.
         IY = IROUND (Y)
         IX = IROUND (X)
C                                       See if correct row is in core,
C                                       if not read.
         DO 10 II = 1,100
C                                       IMSTUF(31) has Y pixel number
C                                       of current line in buffer ROW.
            ICUR = IMSTUF(31)
            IF (IY.EQ.ICUR) GO TO 20
               CALL GETROW (IMSTUF, IOBLK, ROW, EOF, IERR)
               IF (IERR.NE.0) GO TO 999
 10         CONTINUE
C                                       Read too many records.
         WRITE (MSGTXT,1010)
         CALL MSGWRT (8)
         IERR = 1
         GO TO 999
C                                       Draw line.
 20      YVAL = ROW(IX)
         IF (YVAL.NE.FBLANK) THEN
            XVAL = I
            IF (DOWN) THEN
               CALL PLVEC (XVAL, YVAL, IERR)
            ELSE
               CALL PLPOS (XVAL, YVAL, IERR)
               END IF
            IF (IERR.NE.0) GO TO 999
            END IF
         DOWN = YVAL.NE.FBLANK
 30      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('PLTOR2: MIX UP IN COUNTING ROWS.')
      END
      SUBROUTINE PLINI2 (INOSL, IERR)
C-----------------------------------------------------------------------
C   This routine will set up the location commons for the plot file.
C   Inputs:
C      INOSL   I       Number of points in slice.
C    Output:
C      IERR    I       Error code. 0=OK.
C   Common:
C      BLC     R(7)    Lower left corner
C      TRC     R(7)    Upper right corner
C      RANGE   R(2)    Plot range
C-----------------------------------------------------------------------
      INTEGER   INOSL, IERR
C
      REAL      YRANGE, XRANGE, HISCAL, FQFINC
      DOUBLE PRECISION FQFREQ
      INTEGER   IDROP(2), IDEPT(5), LTYPE
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DPLT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'PFPL2.INC'
      DATA HISCAL /3200.0/
C-----------------------------------------------------------------------
C                                       Range completely specified by
C                                       input blc, trc, i.e., no drops.
      IDROP(1) = 0
      IDROP(2) = 0
C                                       Set up default scaling parms.
      XSCAL = 1.0
      YSCAL = 1.0
      XOFF = 0.0
      YOFF = 0.0
C                                       Probably necessary to rescale
C                                       Y to prevent integer overflow
C                                       in low-level graphics routines.
      YRANGE = RANGE(2) - RANGE(1)
      PTRC(2) = RANGE(2)
      PBLC(2) = RANGE(1)
C                                       Rescale Y values
      IF ((YRANGE.GE.HISCAL) .OR. (YRANGE.LE.10.0)) THEN
         YSCAL = HISCAL / YRANGE
         YOFF = - RANGE(1) * YSCAL
         PTRC(2) = HISCAL
         PBLC(2) = 0.0
         YRANGE = HISCAL
         END IF
C                                       Standard slice labeling init.
      LOCNUM = 1
      FQFINC = 0.0
      FQFREQ = 0.0D0
      CALL SLBINI (IDROP, INOSL, RANGE, PBLC, PTRC, BLC, TRC, FQFREQ,
     *   FQFINC, IDEPT, PCODES(1), YGAP, CHOUT, TEXT2, NTEXT2)
      LTYPE = MOD (ABS(PCODES(1)),100)
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7))
     *   CHOUT(2) = CHOUT(2) + NTEXT * 1.333
C                                       Change labeling to XUNIT if
C                                       programmer wants.
      IF (PCODES(2).GT.0) CTYP(1,LOCNUM) = XUNIT
C                                       Fill in units for YUNIT.
      IF (PCODES(3).GT.0) CTYP(2,LOCNUM) = YUNIT
C                                       Square plot.
      XRANGE = PTRC(1) - PBLC(1)
      XY = YRANGE / XRANGE
C                                       Write intialization records
C                                       into plot file.
C                                       initialize line drawing
      CALL GINITL (PBLC, PTRC, XY, CHOUT, IDEPT, PLTBLK, IERR)
C
 999  RETURN
      END
      SUBROUTINE PLABL2 (IERR)
C-----------------------------------------------------------------------
C   This program uses the values set in PLINI2 and passed through
C   commons LOCATI, LOCATC, and PLTCOM to do the axes labeling.
C   Commons:
C      /LOCATI/  (from incs:DLOC.INC)
C      /LOCATC/  (from incs:DLOC.INC)
C      /PLTCOM/  (from incs:DPLT.INC)
C   Output:
C      IERR    I      Error code. 0=ok.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      LOGICAL   F
      REAL      DCX, DCY
      INTEGER   I, IANGLE, INCHAR, IT(3), ID(3), LABEL, LTYPE
      CHARACTER WRKTXT*80, ATIME*8, ADATE*12, ANAME*18
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DPLT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'PFPL2.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      LABEL = PCODES(1)
      LTYPE = MOD (ABS(PCODES(1)), 100)
      CALL GLTYPE (1, PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        Tics and tic labels
      CALL CLAB1 (PBLC, PTRC, CHOUT, LABEL, XY, F, PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        draw rectangle
      CALL GPOS (PBLC(1), PBLC(2), PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (PTRC(1), PBLC(2), PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (PTRC(1), PTRC(2), PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (PBLC(1), PTRC(2), PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (PBLC(1), PBLC(2), PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       title line
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
C                                       Standard map title line.
         IF (PCODES(4).EQ.0) THEN
            CALL H2CHR (8, 1, CATH(KHOBJ), TITLE)
            INCHAR = 12
            IF (TITLE.EQ.' ') INCHAR = 1
            IF (NCHLAB(1,LOCNUM).GT.0) THEN
               IF (INCHAR.GT.1) TITLE(INCHAR-1:INCHAR-1) = '_'
               TITLE(INCHAR:) = SAXLAB(1,LOCNUM)(1:NCHLAB(1,LOCNUM))
               INCHAR = INCHAR + 3 + NCHLAB(1,LOCNUM)
               END IF
            IF (NCHLAB(2,LOCNUM).GT.0) THEN
               IF (INCHAR.GT.1) TITLE(INCHAR-1:INCHAR-1) = '_'
               TITLE(INCHAR:) = SAXLAB(2,LOCNUM)(1:NCHLAB(2,LOCNUM))
               INCHAR = INCHAR + 3 + NCHLAB(2,LOCNUM)
               END IF
            IF (INCHAR.GT.1) TITLE(INCHAR-1:INCHAR-1) = '_'
            CALL H2CHR (18, 1, CATH(KHIMN), ANAME)
            CALL NAMEST (ANAME, CATBLK(KIIMS), TITLE(INCHAR:), I)
            CALL REFRMT (TITLE, '_', INCHAR)
            END IF
         CALL GPOS (PBLC(1), PTRC(2), PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         DCX = 0.0
         DCY = 0.5
         IANGLE = 0
         CALL CHTRIM (TITLE, 80, TITLE, INCHAR)
         CALL GCHAR (INCHAR, IANGLE, DCX, DCY, TITLE, PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Date/time version
      IF ((LABEL.GT.1) .AND. (LTYPE.LT.7)) THEN
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, ATIME, ADATE)
         WRITE (WRKTXT,1020) IVER, ADATE, ATIME
         DCY = DCY + 1.333
         CALL GPOS (PBLC(1), PTRC(2), PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL REFRMT (WRKTXT, '_', INCHAR)
         CALL GCHAR (INCHAR, IANGLE, DCX, DCY, WRKTXT, PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Label X axis.
      IF ((NTEXT2.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7))
     *   THEN
         DCX = 0.0
         IANGLE = 0
         DO 30 I = 1,NTEXT2
            WRKTXT = TEXT2(I)
            CALL CHTRIM (WRKTXT, 80, WRKTXT, INCHAR)
            DCY = -YGAP
            YGAP = YGAP + 1.333
            CALL GPOS (PBLC(1), PBLC(2), PLTBLK, IERR)
            CALL GCHAR (INCHAR, IANGLE, DCX, DCY, WRKTXT, PLTBLK, IERR)
            IF (IERR.NE.0) GO TO 999
 30         CONTINUE
         END IF
C                                       Text at bottom.
      IF ((NTEXT2.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7))
     *   THEN
         DCX = 0.0
         IANGLE = 0
         DO 40 I = 1,NTEXT
            WRKTXT = TEXT(I)
            CALL CHTRIM (WRKTXT, 80, WRKTXT, INCHAR)
            DCY = -YGAP
            YGAP = YGAP + 1.333
            CALL GPOS (PBLC(1), PBLC(2), PLTBLK, IERR)
            CALL GCHAR (INCHAR, IANGLE, DCX, DCY, WRKTXT, PLTBLK, IERR)
            IF (IERR.NE.0) GO TO 999
 40         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('PLOT FILE VERSION',I4,'__CREATED ',A,A)
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NPARMS
      PARAMETER (NPARMS=17)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                      1         2          3        4         5
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INVERS',
C            6         7           8           9      10     11
     *   'FREQID', 'SUBARRAY', 'TIMERANG', 'BIF', 'EIF', 'ANTENNAS',
C            12        13         14          15        16       17
     *   'DOHIST', 'CROWDED', 'DO3COLOR', 'ANTUSE', 'APARM', 'BADDISK'/
C                    1       2       3       4       5
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOAINT,
C          6       7       8      9       10      11
     *   OOAINT, OOAINT, OOARE, OOAINT, OOAINT, OOAINT,
C          12      13      14     15      16     17
     *   OOAINT, OOAINT, OOARE, OOAINT, OOARE, OOAINT/
C                   1     2     3     4     5
      DATA AVDIM /12,1,  6,1,  1,1,  1,1,  1,1,
C         6     7     8     9     10     11
     *   1,1,  1,1,  8,1,  1,1,  1,1,  50,1,
C         12    13    14    15    16    17
     *   1,1,  1,1,  1,1, 50,1, 10,1, 10,1/
LOCAL END
      PROGRAM PCEDT
C-----------------------------------------------------------------------
C! Edit the PC table with a graphical editor
C# Task AP OOP UV EDITING TV-APPL CALIBRATION VLBI
C-----------------------------------------------------------------------
C;  Copyright (C) 2016, 2018, 2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TY table data used for uv editing
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, UVDATA*32, TBEDIT*32, TBTYPE*2
      INTEGER  IRET, BUFF1(256)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'PCEDT'/
C-----------------------------------------------------------------------
      TBTYPE = 'PC'
C                                       Startup
      CALL EDITIN (PRGM, UVDATA, TBEDIT, TBTYPE, IRET)
C                                       CLEAN
      IF (IRET.EQ.0) CALL EDITIT (UVDATA, TBEDIT, TBTYPE, IRET)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE EDITIN (PRGN, UVDATA, TBEDIT, TBTYPE, IERR)
C-----------------------------------------------------------------------
C   EDITIN gets input parameters for PCEDT, creates the EDIT object.
C   Inputs:
C      PRGN     C*6    Program name
C   Output:
C      UVDATA   C*32   Name of input uv data. - as master
C      TBEDIT   C*32   Name of table object to be used in editing
C      IERR     I      Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER PRGN*6, UVDATA*(*), TBEDIT*(*), TBTYPE*2
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NKEY1, NKEY2
C                                       NKEY1 = # adverbs FOR UVDATA
      PARAMETER (NKEY1=5)
C                                       NKEY2 = # adverbs for TBEDIT
      PARAMETER (NKEY2=15)
      INTEGER   DIM(7), TYPE, IDUM(2), BIF, EIF, NIF, SUBA, PCVERI,
     *   PCV, I
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32, CDUMMY*1, PCIN*32, TBINP*32
      LOGICAL   EXIST
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to UVDATA object
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'DOHIST'/
C                                       Rename
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'DOHIST'/
C                                       Adverbs for TBINP object
      DATA INK2 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INVERS',
     *   'FREQID', 'SUBARRAY', 'TIMERANG', 'BIF', 'EIF', 'ANTENNAS',
     *   'ANTUSE', 'CROWDED', 'DO3COLOR', 'APARM'/
C                                       Rename
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'VER',
     *   'FRQSEL', 'SUBARR', 'TIMERANG', 'BIF', 'EIF', 'ANTENNAS',
     *   'ANTS2USE', 'CROWDED', 'DO3COLOR', 'APARM'/
C-----------------------------------------------------------------------
C                                       Startup interactive
      CALL AV2INT (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IERR)
      IF (IERR.NE.0) GO TO 999
      RQUICK = .FALSE.
C                                       SUBARRAY
      CALL OGET ('Input', 'SUBARRAY', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      SUBA = MAX (1, IDUM(1))
      IDUM(1) = SUBA
      CALL OPUT ('Input', 'SUBARRAY', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Create UV master object
      UVDATA = 'UVDATA master input object'
      CALL CREATE (UVDATA, 'UVDATA', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, UVDATA, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open UVDATA to be sure it's OK
      CALL OOPEN (UVDATA, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OCLOSE (UVDATA, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Find highest PC table.
      PCIN = 'Temporary PC table for PCEDT'
      PCV = 1
      CALL UV2TAB (UVDATA, PCIN, 'PC', PCV, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TBLHIV (PCIN, PCV, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TABDES (PCIN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET ('Input', 'INVERS', TYPE, DIM, IDUM, CDUMMY, IERR)
      PCVERI = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      IF ((PCVERI.LE.0) .OR. (PCVERI.GT.PCV)) PCVERI = PCV
      IDUM(1) = PCVERI
      CALL OPUT ('Input', 'INVERS', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Create TBINP object
      TBINP = TBTYPE // ' temporary table to be used in copying'
      CALL CREATE (TBINP, 'TABLE', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, TBINP, IERR)
      IF (IERR.NE.0) GO TO 999
      DIM(1) = 2
      DIM(2) = 1
      CALL OPUT (TBINP, 'TBLTYPE', OOACAR, DIM, IDUM, TBTYPE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Use input for editing
C                                       Open TBINP to be sure it's OK.
      CALL OOPEN (TBINP, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (TBINP, 'KEY.NO_BAND', TYPE, DIM, IDUM, CDUMMY, IERR)
      NIF = IDUM(1)
      IF ((IERR.NE.0) .OR. (NIF.LE.0)) NIF = 1
      CALL OCLOSE (TBINP, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       BADDISK
      CALL OGET ('Input', 'BADDISK', TYPE, DIM, IBAD, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       IF numbers
C                                       Default BIF, EIF
      CALL OGET ('Input', 'BIF', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      BIF = IDUM(1)
      CALL OGET ('Input', 'EIF', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      EIF = IDUM(1)
      BIF = MAX (1, BIF)
      BIF = MIN (BIF, NIF)
      IF (EIF.LT.BIF) EIF = NIF
      EIF = MIN (EIF, NIF)
C                                       Save in Inputs for history
      DIM(1) = 1
      IDUM(1) = BIF
      CALL OPUT ('Input', 'BIF', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OPUT (TBINP, 'BIF', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IDUM(1) = EIF
      CALL OPUT ('Input', 'EIF', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OPUT (TBINP, 'EIF', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       copy to new PC table
      TBEDIT = 'PC table to be used in editing'
      CALL CREATE (TBEDIT, 'TABLE', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       copy the object parts
      CALL TBCOPY (TBINP, TBEDIT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       did not get adverbs
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, TBedit, IERR)
      IF (IERR.NE.0) GO TO 999
      DIM(1) = 2
      DIM(2) = 1
      CALL OPUT (TBINP, 'TBLTYPE', OOACAR, DIM, IDUM, TBTYPE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       new version
      DIM(1) = 1
      DIM(2) = 1
      I = PCV + 1
      IDUM(1) = I
      CALL OPUT (TBEDIT, 'VER', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (MSGTXT,1010) PCVERI, I
      CALL MSGWRT (3)
C                                       Make sure output doesn't exist
      CALL OBFEXS (TBEDIT, EXIST, IERR)
      IERR = 0
      IF (EXIST) THEN
         CALL TABRMV (TBEDIT, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       copy contents
      CALL TBLCOP (TBINP, TBEDIT, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('Copying PC table version',I4,' to new version',I4)
      END
      SUBROUTINE EDITIT (UVDATA, TBEDIT, TBTYPE, IERR)
C-----------------------------------------------------------------------
C   Does the editing
C   Inputs:
C      UVDATA   C*32   Name of input uv data. - as master
C      TBEDIT   C*32   Name of PC table data
C      TBTYPE   C*2    Type of table
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER UVDATA*(*), TBEDIT*(*), TBTYPE*2
C
      CHARACTER UVEDIT*32, STATUS*4, TVDEVC*32
      INTEGER   JERR, DUMMY, DIM(7)
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       open TV object
      TVDEVC = 'PCEDT task TV object'
      CALL TVDCRE (TVDEVC, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL TVDOPN (TVDEVC, STATUS, IERR)
      IF (IERR.NE.0) GO TO 985
C                                       open edit object
      UVEDIT = 'PCEDT task EDIT object'
      CALL EDICRE (UVEDIT, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL EDIOPN (UVEDIT, STATUS, IERR)
      IF (IERR.NE.0) GO TO 975
C                                       Insert object info
      DIM(1) = LEN(UVDATA)
      DIM(2) = 1
      CALL EDIPUT (UVEDIT, 'UVMASTER', OOACAR, DIM, DUMMY, UVDATA, IERR)
      IF (IERR.NE.0) GO TO 980
      DIM(1) = LEN(TBEDIT)
      CALL EDIPUT (UVEDIT, 'TBEDIT', OOACAR, DIM, DUMMY, TBEDIT, IERR)
      IF (IERR.NE.0) GO TO 980
      DIM(1) = LEN(TVDEVC)
      CALL EDIPUT (UVEDIT, 'TVDEVICE', OOACAR, DIM, DUMMY, TVDEVC, IERR)
      IF (IERR.NE.0) GO TO 980
      DIM(1) = 1
C                                       do it
      CALL EDITPC ('INIT', UVEDIT, TBTYPE, IERR)
C                                       Clean up - no apply
C                                       These zap TBEDIT
      IF (IERR.NE.0) THEN
         IF (IERR.LT.0) THEN
            CALL EDITPC ('ABOR', UVEDIT, TBTYPE, JERR)
            IERR = 0
         ELSE
            CALL EDITPC ('KILL', UVEDIT, TBTYPE, JERR)
            END IF
C                                       apply FG and clean up
      ELSE
         CALL EDITPC ('APPL', UVEDIT, TBTYPE, IERR)
         CALL TABCLO (TBEDIT, JERR)
         CALL TABDES (TBEDIT, JERR)
         END IF
C                                       Delete object
      CALL EDICLO (UVEDIT, JERR)
 975  CALL EDIDES (UVEDIT, JERR)
C                                       close and delete TV device
 980  CALL TVDCLO (TVDEVC, JERR)
 985  CALL TVDDES (TVDEVC, JERR)
C                                       error message
 990  IF (IERR.NE.0) THEN
         MSGTXT = 'ERROR EDITING ' // TBEDIT
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
      END

      SUBROUTINE TVMENU (TYPE, NCOL, NROWS, GRCHS, TOPSEP, SIDSEP,
     *   ISHELP, CHOICS, TIMLIM, LEAVE, NTITLE, TITLE, CHOICE, TVBUTT,
     *   SCRTCH, IERR)
C-----------------------------------------------------------------------
C! displays a menu, reads the user choise with time limit
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1999-2000, 2009, 2013-2015, 2021-2023, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Displays a menu on a graphics channel, interactively highlights the
C   currently selected item, provides help, returns if item selected or
C   time limit exceeded.
C   Inputs:
C      TYPE     I      How to arrange columns: 0 left justified,
C                         1 right justified, 2 centered,
C                        -1 split to edges (NCOL=2)
C      NCOL     I      Number of columns
C      NROWS    I(*)   Number rows in each column
C      GRCHS    I(2)   Graphics channels to use for (1) menu (default 1)
C                         (2) highlight (default omit)
C                         If GRCHS(1) < 0, use abs(GRCHS(1)) w no init
C                         i.e. this menu is already written there
C      TOPSEP   I      > 0 => separate menu from top by TOPSEP pixels
C      SIDSEP   I      > 0 => separate left edge (type 0) in pixels
C                             separate right edge (type 1) in pixels
C      CHOICS   C(*)*?  Strings of menu items
C      TIMLIM   I      Return after TIMLIM seconds even if no button
C                         0 => infinite time limit
C      LEAVE    L(*)   T => leave the 2 graphics planes on, subscriot
C                      same as selected CHOICS.  Do not zoom.
C      NTITLE   I      Number of lines in TITLE  0 -> none
C      TITLE    C(*)*(*)  TitleS to menu ' ' => none
C   In/out:
C      ISHELP   C*6    Name of interactive help file = 'HLPishelp.HLP'
C                      ' ' -> none, set to ' ' if an error occurs
C   Outputs:
C      CHOICE   I      Chosen item from the list
C      TVBUTT   I      Selected button: 0 => timed out
C      SCRTCH   I(*)   buffer
C      IERR     I      Error code: 2 input error
C   Limits: 20 columns, 40 rows/column
C-----------------------------------------------------------------------
      INTEGER   TYPE, NCOL, NROWS(*), GRCHS(2), TOPSEP, SIDSEP, TIMLIM,
     *   CHOICE, NTITLE, TVBUTT, SCRTCH(*), IERR
      CHARACTER CHOICS(*)*(*), ISHELP*(*), TITLE(*)*(*)
      LOGICAL   LEAVE(*)
C
      INTEGER   LMAX, CMAX
      PARAMETER (LMAX = 100)
      PARAMETER (CMAX = 30)
C
      INTEGER   IX, IY, QUAD, IBUT, ITW(3), CTW(3), GR1, GR2,
     *   IXC(2,CMAX), NCH(LMAX,CMAX), NCHM(CMAX), IYC(LMAX), RMAX,
     *   MCH(2), PROW, PCOL, NEDGE, IS, TIME0, TIMEC, LTIME, TIMOFF,
     *   SVZOOM(3), ISC(CMAX), I, J, MWIN(4), LX, LY, IXP(5), IYP(5),
     *   ICOL, IROW, LCOL, LROW, NC, MENU0, JTRIM, NROW, IROUND, JERR,
     *   MSWIN(4), MSCHAR, NNCHAR(CMAX), LTITLE, SIDS, IYD, IY0
      REAL      PPOS(2), RPOS(2)
      LOGICAL   DOMENU, DOTITL, DOIT, F, TIMED
      CHARACTER ROUTIN*6, PS*128
      SAVE MSWIN, MSCHAR
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA F /.FALSE./
      DATA MSWIN, MSCHAR /4*0, 0/
C-----------------------------------------------------------------------
 1    IERR = 2
      IF ((NCOL.LE.0) .OR. (NCOL.GT.CMAX)) GO TO 999
      SIDS = MAX (0, SIDSEP)
      IF (TYPE.EQ.2) SIDS = 0
      CALL COPY (3, TVZOOM, SVZOOM)
      IYD = 1.5*CSIZTV(2) + 0.5
      TIMED = .FALSE.
      LTITLE = MAX (0, NTITLE)
      DO 5 I = LTITLE,1,-1
         NNCHAR(I) = JTRIM (TITLE(I))
         IF (TITLE(I).EQ.' ') NNCHAR(I) = 0
         IF ((I.EQ.LTITLE) .AND. (NNCHAR(I).LE.0)) LTITLE = LTITLE - 1
 5       CONTINUE
C                                       channels
      GR1 = ABS (GRCHS(1))
      IF ((GR1.LT.1) .OR. (GR1.GT.NGRAPH)) GR1 = 1
      GR2 = ABS (GRCHS(2))
      GR2 = MIN (GR2, NGRAPH)
      IF (GR2.EQ.GR1) GR2 = 0
      GR1 = GR1 + NGRAY
      GR2 = GR2 + NGRAY
      TVBUTT = 0
      CHOICE = 0
C                                       plan menu
      IS = 1
      NC = 0
      RMAX = 0
      IF ((NNCHAR(1).GT.0) .OR. (MSCHAR.GT.0)) RMAX = 2
      DO 20 I = 1,NCOL
         IX = NROWS(I)
         IF ((IX.LE.0) .OR. (IX.GT.LMAX)) GO TO 999
         NCHM(I) = 1
         RMAX = MAX (RMAX, IX)
         ISC(I) = IS - 1
         DO 10 J = 1,IX
            NCH(J,I) = JTRIM (CHOICS(IS))
            IF (CHOICS(IS).EQ.' ') NCH(J,I) = 1
            NCHM(I) = MAX (NCHM(I), NCH(J,I))
            IS = IS + 1
 10         CONTINUE
         NC = NC + NCHM(I)
 20      CONTINUE
      NEDGE = MAX (2, (CSIZTV(1)+1)/2)
 25   MCH(1) = 2 * (2 + NEDGE + (NCOL-1) * (1+NEDGE)) + CSIZTV(1) * NC
      IF (MCH(1).GT.MAXXTV(1)) THEN
         NEDGE = NEDGE - 1
         IF (NEDGE.GT.0) GO TO 25
            MSGTXT = 'TV SCREEN TOO NARROW.  BUY A BIGGER ONE'
            CALL MSGWRT (9)
            I = CSIZTV(1) / 7
            IF (I.GT.1) THEN
               I = I - 1
               CSIZTV(1) = 7 * I
               CSIZTV(2) = 9 * I
               CALL YCMULT (I, IERR)
               MSGTXT = 'TRYING BY REDUCING CHAR MULT'
               CALL MSGWRT (6)
               IF (IERR.EQ.0) GO TO 1
               END IF
            IERR = 8
            GO TO 999
         END IF
C                                       init
      PROW = 0
      PCOL = 0
C                                       offzoom
      TVZOOM(1) = 0
      TVZOOM(2) = MAXXTV(1)/2
      TVZOOM(3) = MAXXTV(2)/2
      IF ((SVZOOM(1).NE.TVZOOM(1)) .OR. (SVZOOM(2).NE.TVZOOM(2)) .OR.
     *   (SVZOOM(3).NE.TVZOOM(3))) THEN
         CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), .FALSE., IERR)
         ROUTIN = 'YZOOMC'
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       check window of TV
      DOMENU = GRCHS(1).GE.0
      DOTITL = GRCHS(2).GE.0
      CALL YWINDO ('READ', WINDTV, IERR)
      ROUTIN = 'YWINDO'
      IF (IERR.NE.0) GO TO 990
      IF ((WINDTV(1).NE.MSWIN(1)) .OR. (WINDTV(2).NE.MSWIN(2)) .OR.
     *   (WINDTV(3).NE.MSWIN(3)) .OR. (WINDTV(4).NE.MSWIN(4))) THEN
         DOMENU = .TRUE.
         DOTITL = .TRUE.
         END IF
      IF (MSCHAR.GT.NNCHAR(1)) THEN
         DOTITL = .TRUE.
         IF (GR2.LE.0) DOMENU = .TRUE.
         END IF
      CALL COPY (4, WINDTV, MSWIN)
C                                       clear, init, select
      CALL YHOLD ('ONNN', I)
      IF (DOMENU) THEN
         CALL YZERO (GR1, IERR)
         ROUTIN = 'YZERO'
         IF (IERR.NE.0) GO TO 900
         END IF
      CALL YSLECT ('ONNN', GR1, 0, SCRTCH, IERR)
      ROUTIN = 'YSLECT'
      IF (IERR.NE.0) GO TO 900
      IF (GR2.GT.0) THEN
         IF (DOTITL) THEN
            CALL YZERO (GR2, IERR)
            ROUTIN = 'YZERO'
            IF (IERR.NE.0) GO TO 900
            END IF
         CALL YSLECT ('ONNN', GR2, 0, SCRTCH, IERR)
         ROUTIN = 'YSLECT'
         IF (IERR.NE.0) GO TO 900
         END IF
C                                       plan menu
      IF (MCH(1).LT.MSWIN(3)-MSWIN(1)) THEN
         MWIN(1) = MSWIN(1)
         MWIN(3) = MSWIN(3)
      ELSE
         MWIN(1) = (MAXXTV(1) - MCH(1)) / 2 + 1
         MWIN(3) = MWIN(1) + MCH(1) - 1
         END IF
      MCH(2) = MAX (0, TOPSEP) + IYD * (LTITLE + RMAX) + 2*NEDGE
      IF (MCH(2).LT.MSWIN(4)-MSWIN(2)) THEN
         MWIN(2) = MSWIN(2)
         MWIN(4) = MSWIN(4)
      ELSE
         MWIN(2) = (MAXXTV(2) - MCH(2)) / 2 + 1
         MWIN(4) = MWIN(2) + MCH(2) - 1
         END IF
      IF ((MWIN(1).LT.1) .OR. (MWIN(2).LT.1) .OR. (MWIN(3).GT.MAXXTV(1))
     *   .OR. (MWIN(4).GT.MAXXTV(2))) THEN
         MSGTXT = 'MENU IS TOO LARGE FOR THE TV SCREEN'
         IERR = 8
         CALL YHOLD ('FFFF', I)
         CALL MSGWRT (8)
         I = CSIZTV(1) / 7
         IF (I.GT.1) THEN
            I = I - 1
            CSIZTV(1) = 7 * I
            CSIZTV(2) = 9 * I
            CALL YCMULT (I, IERR)
            MSGTXT = 'TRYING BY REDUCING CHAR MULT'
            CALL MSGWRT (6)
            IF (IERR.EQ.0) GO TO 1
            END IF
         GO TO 999
         END IF
      MENU0 = MWIN(1) + 4 + SIDS
      IF (TYPE.EQ.1) MENU0 = MWIN(3) - MCH(1) - SIDS
      IF (TYPE.EQ.2) MENU0 = (MWIN(3) - MWIN(1) + 1 - MCH(1)) / 2 +
     *   MWIN(1)
C                                       write menu if needed, get
C                                       points
      ROUTIN = 'IMCHAR'
      IX = 3 + NEDGE + MENU0
      IY = MWIN(4) - IYD - MAX (0, TOPSEP)
      IF (LTITLE.GT.0) THEN
         DO 27 I = 1,LTITLE
            IF (GR2.GT.0) THEN
               CALL IMCHAR (GR2, IX, IY, 0, 0, TITLE(I)(:NNCHAR(I)),
     *            SCRTCH, IERR)
            ELSE
               CALL IMCHAR (GR1, IX, IY, 0, 0, TITLE(I)(:NNCHAR(I)),
     *            SCRTCH, IERR)
               END IF
            IF (IERR.NE.0) GO TO 900
            IY = IY - IYD
 27         CONTINUE
         END IF
      IY = IY - 2*NEDGE
      IY0 = IY
      MSCHAR = NNCHAR(1)
      IS = 1
      DO 35 LCOL = 1,NCOL
         NROW = NROWS(LCOL)
         IXC(1,LCOL) = IX
         IXC(2,LCOL) = IX + NCHM(LCOL)*CSIZTV(1) - 1
         IY = IY0
         DO 30 LROW = 1,NROW
            IYC(LROW) = IY
            IF (DOMENU) THEN
               NC = NCH(LROW,LCOL)
               PS = CHOICS(IS)(1:NC)
               CALL IMCHAR (GR1, IX, IY, 0, 0, PS(1:NC), SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 900
               IS = IS + 1
               END IF
            IY = IY - IYD
 30         CONTINUE
         IF ((LCOL.EQ.1) .AND. (TYPE.LT.0) .AND. (NCOL.EQ.2)) THEN
            IX = MWIN(3) - NCHM(2)*CSIZTV(1) - 2 - NEDGE - SIDS
         ELSE
            IX = IX + 2 + 2*NEDGE + NCHM(LCOL)*CSIZTV(1)
            END IF
 35      CONTINUE
C                                       write border lines
      IF (DOMENU) THEN
         RPOS(1) = MAXXTV(1) / 2
         RPOS(2) = MAXXTV(2) / 2
         IY = IY0 + IYD
         DO 40 LCOL = 1,NCOL
            IX = IXC(1,LCOL) - 2 - NEDGE
            LX = 4 + 2*NEDGE + NCHM(LCOL)*CSIZTV(1)
            LY = NROWS(LCOL) * IYD + (CSIZTV(2)+1)/2
            IXP(1) = IX
            IYP(1) = IY
            IXP(2) = IX + LX - 1
            IYP(2) = IYP(1)
            IXP(3) = IXP(2)
            IYP(3) = IY - LY + 1
            IXP(4) = IXP(1)
            IYP(4) = IYP(3)
            IXP(5) = IXP(1)
            IYP(5) = IYP(1)
            CALL IMVECT ('ONNN', GR1, 5, IXP, IYP, SCRTCH, IERR)
            ROUTIN = 'IMVECT'
            IF (IERR.NE.0) GO TO 900
            IX = IX + 1
            IY = IY - 1
            LX = LX - 2
            LY = LY - 2
            IXP(1) = IX
            IYP(1) = IY
            IXP(2) = IX + LX - 1
            IYP(2) = IYP(1)
            IXP(3) = IXP(2)
            IYP(3) = IY - LY + 1
            IXP(4) = IXP(1)
            IYP(4) = IYP(3)
            IXP(5) = IXP(1)
            IYP(5) = IYP(1)
            CALL IMVECT ('ONNN', GR1, 5, IXP, IYP, SCRTCH, IERR)
            ROUTIN = 'IMVECT'
            IF (IERR.NE.0) GO TO 900
            IX = IX + LX - 1
            IY = IY + 1
 40         CONTINUE
         END IF
      CALL YHOLD ('FFFF', I)
      CALL ZTIME (ITW)
      TIME0 = ITW(3) + 60 * (ITW(2) + 60*ITW(1))
      LTIME = TIME0
      TIMOFF = 0
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      IF (TIMLIM.GT.0) THEN
         WRITE (MSGTXT,1040) TIMLIM
         CALL MSGWRT (1)
         END IF
      IF (ISHELP.NE. ' ') THEN
         MSGTXT = 'Press buttons A, B, or C to choose an operation'
         CALL MSGWRT (1)
         MSGTXT = 'Press button D for on-line help'
         CALL MSGWRT (1)
      ELSE
         MSGTXT = 'Press ANY button to choose an operation'
         CALL MSGWRT (1)
         END IF
C                                       read cursor
 50   CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IERR)
      ROUTIN = 'YCURSE'
      IF (IERR.NE.0) GO TO 800
C                                       check time out
      CALL ZTIME (CTW)
      TIMEC = CTW(3) + 60 * (CTW(2) + 60*CTW(1)) + TIMOFF
      IF (TIMEC-LTIME.LT.-1) THEN
         TIMOFF = TIMOFF + 86400
         TIMEC = TIMEC + 86400
         END IF
      LTIME = TIMEC
      IF ((TIMLIM.GT.0) .AND. (LTIME-TIME0.GT.TIMLIM)) THEN
         TIMED = .TRUE.
         GO TO 800
         END IF
C                                       did something happen
      CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
      IF (.NOT.DOIT) GO TO 50
C                                       find the choice
         IX = IROUND (RPOS(1))
         IY = IROUND (RPOS(2))
         ICOL = 0
         DO 55 LCOL = 1,NCOL
            IF ((IX.GE.IXC(1,LCOL)-2) .AND. (IX.LE.IXC(2,LCOL)+2))
     *         ICOL = LCOL
 55         CONTINUE
         IF (ICOL.LE.0) GO TO 50
         IROW = 0
         NROW = NROWS(ICOL)
         DO 60 LROW = 1,NROW
            IF (IY.GT.IYC(NROW+1-LROW)-2) IROW = NROW + 1 - LROW
 60         CONTINUE
         IF (IROW.EQ.0) GO TO 50
         IF (NCH(IROW,ICOL).EQ.0) GO TO 50
         IF (GR2.GT.0) THEN
            IF ((PCOL.NE.ICOL) .OR. (PROW.NE.IROW)) THEN
C                                       restore choice
               ROUTIN = 'IMCHAR'
               IF ((PCOL.GT.0) .AND. (PROW.GT.0)) THEN
                  CALL YHOLD ('ONNN', I)
                  NC = NCH(PROW,PCOL)
                  PS(1:NC) = ' '
                  CALL IMCHAR (GR2, IXC(1,PCOL), IYC(PROW), 0, 0,
     *               PS(1:NC), SCRTCH, IERR)
                  IF (IERR.NE.0) GO TO 800
                  PS(1:NC) = CHOICS(PROW+ISC(PCOL))(1:NC)
                  CALL IMCHAR (GR1, IXC(1,PCOL), IYC(PROW), 0, 0,
     *               PS(1:NC), SCRTCH, IERR)
                  IF (IERR.NE.0) GO TO 800
                  CALL YHOLD ('OFFF', I)
                  END IF
C                                       highlight choice
               NC = NCH(IROW,ICOL)
               PS(1:NC) = CHOICS(IROW+ISC(ICOL))(1:NC)
               CALL IMCHAR (GR2, IXC(1,ICOL), IYC(IROW), 0, 0, PS(1:NC),
     *            SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 800
               PCOL = ICOL
               PROW = IROW
               END IF
            END IF
C                                       help if D and can
         IF ((IBUT.GE.8) .AND. (ISHELP.NE.' ')) THEN
            NC = NCH(IROW,ICOL)
            PS = CHOICS(IROW+ISC(ICOL))(1:NC)
            JERR = 0
            IF (PS.NE.' ') CALL TSKHLP (PS, NC, ISHELP, JERR)
            IBUT = 0
            IF (JERR.LE.0) THEN
               TIME0 = LTIME
            ELSE
               ISHELP = ' '
               END IF
C                                       leave on button A, B, C
         ELSE IF (IBUT.GT.0) THEN
            TVBUTT = IBUT
            CHOICE = PROW + ISC(PCOL)
            GO TO 800
            END IF
         GO TO 50
C                                       turn off the cursor
 800  CALL YCURSE ('OFFF', F, F, RPOS, QUAD, IBUT, JERR)
C                                       turn off the choices
 900  CALL YHOLD ('ONNN', I)
      IF ((.NOT.LEAVE(CHOICE)) .OR. (TIMED)) THEN
         CALL YSLECT ('OFFF', GR1, 0, SCRTCH, JERR)
         IF (GR2.GT.0) CALL YSLECT ('OFFF', GR2, 0, SCRTCH, JERR)
         END IF
C                                       fix menu
      IF ((GR2.GT.0).AND. (PCOL.GT.0) .AND. (PROW.GT.0)) THEN
         ROUTIN = 'IMCHAR'
         NC = NCH(PROW,PCOL)
         PS(1:NC) = ' '
         CALL IMCHAR (GR2, IXC(1,PCOL), IYC(PROW), 0, 0, PS(1:NC),
     *      SCRTCH, JERR)
         PS(1:NC) = CHOICS(PROW+ISC(PCOL))(1:NC)
         CALL IMCHAR (GR1, IXC(1,PCOL), IYC(PROW), 0, 0, PS(1:NC),
     *      SCRTCH, JERR)
         END IF
      IF (IERR.EQ.0) THEN
         CALL COPY (3, SVZOOM, TVZOOM)
         IF (.NOT.LEAVE(CHOICE)) CALL YZOOMC (TVZOOM(1), TVZOOM(2),
     *      TVZOOM(3), F, JERR)
         END IF
      IF (LTITLE.GT.0) THEN
         IX = 3 + NEDGE + MENU0
         IY = MWIN(4) - 12 - CSIZTV(2) - MAX (0, TOPSEP)
            PS = ' '
         DO 910 I = 1,LTITLE
            NC = JTRIM (TITLE(I))
            IF (GR2.GT.0) THEN
               CALL IMCHAR (GR1, IX, IY, 0, 0, PS(:NC), SCRTCH, JERR)
            ELSE
               CALL IMCHAR (GR2, IX, IY, 0, 0, PS(:NC), SCRTCH, JERR)
               END IF
            IF (IERR.NE.0) GO TO 990
            IY = IY - IYD
 910        CONTINUE
         END IF
      CALL YHOLD ('OFFF', I)
C                                       force buffer to TV
      CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, JERR)
C
 990  IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1990) IERR, ROUTIN
         CALL MSGWRT (6)
         CALL YHOLD ('FFFF', I)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('You have',I6,' seconds to select a menu item by:')
 1990 FORMAT ('TVMENU: TV I/O ERROR',I7,' FROM ',A)
      END

LOCAL INCLUDE 'MODIM.INC'
C                                       Local include for MODIM
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   MAXGAU
      PARAMETER (MAXGAU = 9999)
C
      HOLLERITH XNAMEI(3), XCLASI(2), XNAMEQ(3), XCLASQ(2), XNAMEU(3),
     *   XCLASU(2), XNAMOU(3), XOPCOD(1), XOPTYP(1), XINLST(12)
      REAL      XSEQI, XDISKI, XSEQQ, XDISKQ, XSEQU, XDISKU, XSEQO,
     *   XDISKO, BLC(7), TRC(7), FLUX, FACTOR, COORD(6), XIMSIZ(2),
     *   CELLS(2), APARM(10)
      REAL      BUFF(MABFSL), IONE(MAXGAU), QONE(MAXGAU), UONE(MAXGAU),
     *   SPIX(MAXGAU), RM(MAXGAU), RMTHIK(MAXGAU), FPOS(2,MAXGAU),
     *   FWID(3,MAXGAU)
      INTEGER   SEQI(3), SEQO(3), DISKI(3), DISKO(3), NPOL, NEWCNO(3),
     *   OLDCNO(3), JBUFSZ, CATOLD(256,3), CATNEW(256,3), ICODE, NGAUSS,
     *   SCRTCH(256), ICODES(MAXGAU), SPIXDO
      CHARACTER NAMEI(3)*12, CLASI(3)*6, NAMOUT*12, CLASO(3)*6,
     *   OPCODE*4, INLIST*48, OPTYPE*4
      LOGICAL   DONEW, FQAXIS
      DOUBLE PRECISION FQVAL(MAXGAU)
      HOLLERITH CATHO(256,3)
      EQUIVALENCE (CATOLD, CATHO)
      COMMON /INPARM/ XNAMEI, XCLASI, XSEQI, XDISKI, XNAMEQ, XCLASQ,
     *   XSEQQ, XDISKQ, XNAMEU, XCLASU, XSEQU, XDISKU, XNAMOU, XSEQO,
     *   XDISKO, BLC, TRC, FLUX, FACTOR, XOPCOD, XOPTYP, XINLST, COORD,
     *   XIMSIZ, CELLS, APARM
      COMMON /CHRCOM/ NAMEI, CLASI, NAMOUT, CLASO, OPCODE, OPTYPE,
     *   INLIST
      COMMON /PARMS/ FQVAL, CATOLD, CATNEW, SEQI, SEQO, DISKI, DISKO,
     *   NPOL,NEWCNO, OLDCNO, JBUFSZ, ICODE, DONEW, NGAUSS, SPIXDO,
     *   FQAXIS
      COMMON /BUFRS/ IONE, QONE, UONE, SPIX, RM, RMTHIK, FPOS, FWID,
     *   ICODES, BUFF, SCRTCH
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C                                       End MODIM
LOCAL END
      PROGRAM MODIM
C-----------------------------------------------------------------------
C! Adds a model to a pair of new or old Q and U image cubes
C# Map Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 2012-2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MODIM is an AIPS task to modify an image by a model
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEI         Name of Q input image.
C      INCLASS        CLASI         Class of Q input image.
C      INSEQ          SEQI          Seq. of Q input image.
C      INDISK         DISKI         Disk number of Q input image.
C      IN2NAME        NAMEI         Name of U input image.
C      IN2CLASS       CLASI         Class of U input image.
C      IN2SEQ         SEQI          Seq. of U input image.
C      IN2DISK        DISKI         Disk number of U input image.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLASO         Class of the output image.
C                                   Default is input class.
C      OUTSEQ         SEQO          Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      OPCODE         OPCODE        User specified opcode.
C      FLUX           FLUX          Noise level in Jy/Pix.
C      FACTOR         FACTOR        Multiplying factor for previous
C                                   data.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, NX, NY, NEED
      LONGINT   PIMAGE
      REAL      IMAGE(2)
      INCLUDE 'MODIM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'MODIM '/
C-----------------------------------------------------------------------
C                                       Get inputs, create output file
      CALL MODIMI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       get memory for 1 plane
      NX = CATBLK(KINAX)
      NY = CATBLK(KINAX+1)
      NEED = (NX * NY - 1) / 1024 + 2
      CALL ZMEMRY ('GET ', TSKNAM, NEED, IMAGE, PIMAGE, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'FAILED TO GET NEEDED DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       Apply model to image
      CALL MODIMD (NX, NY, IMAGE(1+PIMAGE), IRET)
C                                       Add history
      IF (IRET.EQ.0) CALL MODIMH
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE MODIMI (PRGN, IRET)
C-----------------------------------------------------------------------
C   MODIMI gets input parameters for MODIM and creates an output file.
C   Inputs:
C      PRGN    C*6       Program name
C   Output:
C      IRET    I         Error code: 0 => ok
C                           4 => user routine detected error.
C                           5 => catalog troubles
C                           8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   IRET
C
      CHARACTER STAT*4, MTYPE*2, CODES(6)*4
      INTEGER   IERR, NPARM, IROUND, NCODE, I, FQAX
      INCLUDE 'MODIM.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA NCODE /6/
      DATA CODES /'POIN','GAUS','DISK','RECT','SPHE','EXPD'/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSL
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 76
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
      NPOL = 1
C                                       Crunch input parameters.
      SEQI(1) = IROUND (XSEQI)
      SEQI(2) = IROUND (XSEQQ)
      SEQI(3) = IROUND (XSEQU)
      SEQO(1) = IROUND (XSEQO)
      SEQO(2) = IROUND (XSEQO)
      SEQO(3) = IROUND (XSEQO)
      DISKI(1) = IROUND (XDISKI)
      DISKI(2) = IROUND (XDISKQ)
      DISKI(3) = IROUND (XDISKU)
      DISKO(1) = IROUND (XDISKO)
      DISKO(2) = IROUND (XDISKO)
      DISKO(3) = IROUND (XDISKO)
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEI(1))
      CALL H2CHR (6, 1, XCLASI, CLASI(1))
      CALL H2CHR (12, 1, XNAMEQ, NAMEI(2))
      CALL H2CHR (6, 1, XCLASQ, CLASI(2))
      CALL H2CHR (12, 1, XNAMEU, NAMEI(3))
      CALL H2CHR (6, 1, XCLASU, CLASI(3))
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CLASO(1) = 'IMODEL'
      CLASO(2) = 'QMODEL'
      CLASO(3) = 'UMODEL'
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      CALL H2CHR (48, 1, XINLST, INLIST)
      IF (INLIST.EQ.' ') THEN
         MSGTXT = 'AN INLIST MUST BE SPECIFIED'
         GO TO 990
         END IF
C                                       Set default OPCODE
      ICODE = 2
      DO 10 I = 1,NCODE
         IF (OPCODE.EQ.CODES(I)) ICODE = I
 10      CONTINUE
C                                       Default to point model if nec.
      OPCODE = CODES(ICODE)
      MSGTXT = 'Using default OPCODE = ''' // OPCODE // ''''
      CALL MSGWRT (3)
C                                       get components, err msg if error
      SPIXDO = 0
      CALL READIT (IERR)
      IF (IERR.NE.0) GO TO 990
      IF (SPIXDO.EQ.2) THEN
         IF (OPTYPE.EQ.'GAUS') SPIXDO = 3
         IF (OPTYPE.EQ.'EXP ') SPIXDO = 4
         END IF
      WRITE (MSGTXT,1005) NGAUSS
      CALL MSGWRT (3)
      IF (NGAUSS.LE.0) THEN
         IRET = 10
         GO TO 999
         END IF
      IF (NPOL.EQ.1) THEN
         DONEW = (NAMEI(1).EQ.' ')
      ELSE
         DONEW = (NAMEI(1).EQ.' ') .OR. (NAMEI(2).EQ.' ') .OR.
     *      (NAMEI(3).EQ.' ')
         END IF
C                                       Get CATBLK from old file.
      MTYPE = 'MA'
      IF (.NOT.DONEW) THEN
         DO 20 I = 1,NPOL
            OLDCNO(I) = 1
            CALL CATDIR ('SRCH', DISKI(I), OLDCNO(I), NAMEI(I),
     *         CLASI(I), SEQI(I), MTYPE, NLUSER, STAT, SCRTCH, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1010) IERR, NAMEI(I), CLASI(I), SEQI(I),
     *            DISKI(I), NLUSER
               GO TO 990
               END IF
C                                       Read CATBLK and mark 'READ'.
            CALL CATIO ('READ', DISKI(I), OLDCNO(I), CATOLD(1,I),
     *         'READ', SCRTCH, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1020) IERR, I
               GO TO 990
               END IF
            NCFILE = NCFILE + 1
            FVOL(NCFILE) = DISKI(I)
            FCNO(NCFILE) = OLDCNO(I)
            FRW(NCFILE) = 0
            CALL AXEFND (4, 'FQID', CATOLD(KIDIM,I), CATHO(KHCTP,I),
     *         FQAX, IERR)
            IF (I.EQ.1) THEN
               FQAXIS = (IERR.EQ.0) .AND. (FQAX.GE.0)
               IF (FQAXIS) THEN
                  CALL FNDFQ (I, IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1015) IERR, I
                     GO TO 990
                     END IF
                  END IF
            ELSE IF (FQAXIS) THEN
               IF ((IERR.NE.0) .OR. (FQAX.LT.0)) THEN
                  MSGTXT = 'Q OR U IMAGE HAS NO FQID AXIS'
                  IERR = 10
                  GO TO 990
               ELSE
                  CALL FNDFQ (I, IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1015) IERR, I
                     GO TO 990
                     END IF
                  END IF
               END IF
 20         CONTINUE
C                                       Make a new header
      ELSE
         CALL RFILL (7, 0.0, BLC)
         CALL RFILL (7, 0.0, TRC)
         CALL NEWHDR
         FQAXIS = .FALSE.
         END IF
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATOLD(KIDIM,1), CATOLD(KINAX,1), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       create outputs
      DO 40 I = 1,NPOL
C                                       Copy old CATBLK to new.
         CALL COPY (256, CATOLD(1,I), CATBLK)
C                                       Put new values in CATBLK.
         CALL MAKOUT (NAMEI(I), CLASI(I), SEQI(I), '      ', NAMOUT,
     *      CLASO(I), SEQO(I))
         CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, CLASO(I), KHIMCO, CATH(KHIMC))
         CATBLK(KIIMS) = SEQO(I)
C                                       Get user modification to CATBLK
         IF (.NOT.DONEW) CALL IMMHED
C                                       Create output file.
         NEWCNO(I) = 1
         IRET = 4
         CALL MCREAT (DISKO(I), NEWCNO(I), SCRTCH, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR, I
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKO(I)
         FCNO(NCFILE) = NEWCNO(I)
         FRW(NCFILE) = 2
         SEQO(I) = CATBLK(KIIMS)
C                                       keywords copied mostly
         IF (.NOT.DONEW) CALL KEYPCP (DISKI(I), OLDCNO(I), DISKO(I),
     *      NEWCNO(I), 0, ' ', IERR)
         CALL COPY (256, CATBLK, CATNEW(1,I))
 40      CONTINUE
C                                       init random number generator
      IF (FLUX.GT.0.0) CALL RANDIN (I)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MODIMI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1005 FORMAT ('Will use',I5,' model components')
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1015 FORMAT ('ERROR',I4,' READING FQ TABLE FOR IMAGE',I2)
 1020 FORMAT ('ERROR',I3,' COPYING CATBLK IMAGE',I2)
 1030 FORMAT ('MODIMI: ERROR',I3,' CREATING OUTPUT FILE',I2)
      END
      SUBROUTINE FNDFQ (IMAGE, IERR)
C-----------------------------------------------------------------------
C   FNDFQ reads the values of the FQ table
C   Inputs:
C      IMAGE   I   Which image: 1 get values, 2 and 3 check them
C   Outputs:
C      IERR    I   0 okay, 10 not match, else I/O error
C-----------------------------------------------------------------------
      INTEGER   IMAGE, IERR
C
      INCLUDE 'MODIM.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   I, J, FQAX, FRAX, FQBUF(512), FQKOLS(MAXFQC),
     *   FQNUMV(MAXFQC), IFQRNO, IFQ, FQID, IFSIDE, FQVER, NUMIF,
     *   NUMREC, LUN, LUNTMP, IQFREQ
      REAL      IFCHW, IFTBW
      DOUBLE PRECISION IFFREQ, FREQV
      CHARACTER BNDCOD*8
C-----------------------------------------------------------------------
      CALL COPY (256, CATOLD(1,IMAGE), CATBLK)
      J = IMAGE
      CALL AXEFND (4, 'FREQ', CATBLK(KIDIM), CATH(KHCTP), FRAX, IERR)
      IF ((IERR.NE.0) .OR. (FRAX.LT.0)) THEN
         WRITE (MSGTXT,1000) 'NO FREQ AXIS', J
         IERR = 10
         GO TO 990
         END IF
      CALL AXEFND (4, 'FQID', CATBLK(KIDIM), CATH(KHCTP), FQAX, IERR)
      IF ((IERR.NE.0) .OR. (FRAX.LT.0)) THEN
         WRITE (MSGTXT,1000) 'NO FQID AXIS', J
         IERR = 10
         GO TO 990
         END IF
      LUN = LUNTMP (1)
      FQVER = 1
      CALL FQINI ('READ', FQBUF, DISKI(J), OLDCNO(J), FQVER, CATBLK,
     *   LUN, IFQRNO, FQKOLS, FQNUMV, NUMIF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, 'OPENING FQ FILE', J
         GO TO 990
         END IF
      NUMREC = FQBUF(5)
      DO 20 IFQRNO = 1,NUMREC
         IFQ = IFQRNO
         CALL TABFQ ('READ', FQBUF, IFQ, FQKOLS, FQNUMV, NUMIF, FQID,
     *      IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, 'READING FQ TABLE', J
            GO TO 990
            END IF
         IQFREQ = (FQID - CATD(KDCRV+FQAX)) / CATR(KRCIC+FQAX) +
     *      CATR(KRCRP+FQAX)
         I = IQFREQ + 0.1D0
         IF ((I.GE.1) .AND. (I.LE.CATBLK(KIDIM+FQAX))) THEN
            FREQV = IFFREQ + CATD(KDCRV+FRAX)
            IF (J.EQ.1) THEN
               FQVAL(I) = FREQV
            ELSE
               IF (ABS(FQVAL(I)-FREQV).GT.0.01*IFCHW) THEN
                  IERR = 10
                  WRITE (MSGTXT,1000) 'FQ VALUES DO NOT MATCH', J
                  GO TO 990
                  END IF
               END IF
            END IF
 20      CONTINUE
      CALL TABFQ ('CLOS', FQBUF, IFQ, FQKOLS, FQNUMV, NUMIF, FQID,
     *   IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FNDFQ: ERROR ',A,' IMAGE',I2)
 1010 FORMAT ('FNDFQ: ERROR',I3,' ON ',A,' IMAGE',I2)
      END
      SUBROUTINE NEWHDR
C-----------------------------------------------------------------------
C   NEWHDR makes up image headers from scratch
C-----------------------------------------------------------------------
C
      INTEGER   DATE(3), I
      CHARACTER STRNG*8
      INCLUDE 'MODIM.INC'
C-----------------------------------------------------------------------
C                                       blank slate
      CALL CATINI (CATBLK)
      CALL CHR2H (8, 'IQUmodel', 1, CATH(KHOBJ))
      CALL CHR2H (8, 'JY/BEAM ', 1, CATH(KHBUN))
      CALL ZDATE (DATE)
      WRITE (STRNG,1000) DATE
      CALL CHR2H (8, STRNG, 1, CATH(KHDMP))
      CALL CHR2H (8, STRNG, 1, CATH(KHDOB))
      CATR(KREPO) = 2000.0
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
      CATBLK(KIDIM) = 4
C                                       RA
      I = XIMSIZ(1) + 0.5
      IF (I.LE.0) I = 512
      CATBLK(KINAX) = I
      CATD(KDCRV) = (COORD(1)*15.D0 + COORD(2)/4.D0 + COORD(3)/240.D0)
      CATR(KRCRP) = (I + 1) / 2
      IF (CELLS(1).EQ.0.0) CELLS(1) = 1.
      CATR(KRCIC) = -ABS(CELLS(1)) / 3600.0
      CALL CHR2H (8, 'RA---SIN', 1, CATH(KHCTP))
C                                       DEC
      I = XIMSIZ(2) + 0.5
      IF (I.LE.0) I = 512
      CATBLK(KINAX+1) = I
      CATD(KDCRV+1) = (COORD(4) + COORD(5)/60.D0 + COORD(6)/3600.D0)
      CATR(KRCRP+1) = (I + 2) / 2
      IF (CELLS(1).EQ.0.0) CELLS(1) = 1.
      CATR(KRCIC+1) = ABS(CELLS(1)) / 3600.0
      CALL CHR2H (8, 'DEC--SIN', 1, CATH(KHCTP+2))
C                                       FREQ
      I = APARM(3) + 0.5
      IF (I.LE.0) I = 512
      CATBLK(KINAX+2) = I
      CATD(KDCRV+2) = APARM(1) * 1.D9
      CATR(KRCRP+2) = 1.0
      IF (APARM(2).EQ.0.0) APARM(2) = 0.001
      CATR(KRCIC+2) = APARM(2) * 1.E9
      CALL CHR2H (8, 'FREQ    ', 1, CATH(KHCTP+4))
C                                       STOKES
      CATBLK(KINAX+3) = 1
      CATD(KDCRV+3) = 1.0D0
      CATR(KRCRP+3) = 1.0
      CATR(KRCIC+3) = 1.0
      CALL CHR2H (8, 'STOKES  ', 1, CATH(KHCTP+6))
C                                       clean beam fake
      CATR(KRBMJ) = 3.0 * ABS (CATR(KRCIC))
      CATR(KRBMN) = 3.0 * ABS (CATR(KRCIC))
C                                       to output
      CALL COPY (256, CATBLK, CATOLD(1,1))
      CATD(KDCRV+3) = 2.0D0
      CALL COPY (256, CATBLK, CATOLD(1,2))
      CATD(KDCRV+3) = 3.0D0
      CALL COPY (256, CATBLK, CATOLD(1,3))
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I4,2I2.2)
      END
      SUBROUTINE IMMHED
C-----------------------------------------------------------------------
C   Adjust the output header for blc, trc
C-----------------------------------------------------------------------
C
      CHARACTER FCHARS(3)*4, CHTMP*4
      INTEGER   LIMIT, I, INDEX
      INCLUDE 'MODIM.INC'
      DATA FCHARS /'FREQ','VELO','FELO'/
C-----------------------------------------------------------------------
C                                       Set axes in output CATBLK.
      LIMIT = CATBLK(KIDIM)
C                                       Copy/update axis values
      DO 80 I = 1,LIMIT
         CATBLK(KINAX+I-1) = TRC(I) - BLC(I) + 1.01
         CATR(KRCRP+I-1) = CATR(KRCRP+I-1) - BLC(I) + 1.0
         IF (CATBLK(KIALT).NE.0) THEN
            INDEX = KHCTP + (I-1) * 2
            CALL H2CHR (4, 1, CATH(INDEX), CHTMP)
            IF ((CHTMP.EQ.FCHARS(1)) .OR. (CHTMP.EQ.FCHARS(2)) .OR.
     *         (CHTMP.EQ.FCHARS(3))) CATR(KRARP) = CATR(KRARP) -
     *         BLC(I) + 1.0
            END IF
 80      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE READIT (IRET)
C-----------------------------------------------------------------------
C   Prepares list of components for adverbs or text file
C   Output
C      IRET   I   Error code
C   rest in Common
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'MODIM.INC'
      INTEGER   TLUN, TIND, LUNTMP, LLIM, LP, I, JTRIM, J
      REAL      BMAJ, BMIN, BPA, XINC
      CHARACTER LINE*132
      DOUBLE PRECISION X
C-----------------------------------------------------------------------
C                                       width defaults
      XINC = ABS (CATR(KRCIC))
      BMAJ = 0.0
      IF (XINC.GT.0.0) THEN
         BMAJ = CATR(KRBMJ) / XINC
         BMIN = CATR(KRBMN) / XINC
         BPA = CATR(KRBPA)
         END IF
      IF ((BMAJ.LE.0.0) .OR. (BMIN.LE.0.0)) THEN
         BMAJ = 3.0
         BMIN = 3.0
         BPA = 0.0
         END IF
C                                       read text file
      TLUN = LUNTMP (2)
C                                       open the text file
      CALL ZTXOPN ('READ', TLUN, TIND, INLIST, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN TEXT FILE'
         GO TO 999
         END IF
      NGAUSS = 0
 100  CALL ZTXIO ('READ', TLUN, TIND, LINE, IRET)
      IF ((IRET.EQ.0) .AND. (NGAUSS.LT.MAXGAU)) THEN
         LLIM = JTRIM (LINE)
C                                       blanks, comments
         IF (LLIM.LE.0) GO TO 100
         IF (LINE(1:1).EQ.'#') GO TO 100
C                                       parse
C                                       I flux
         LP = 1
         CALL GETNUM (LINE, LLIM, LP, X)
         IF ((X.EQ.DBLANK) .OR. (X.EQ.0.0D0)) THEN
            GO TO 100
         ELSE
            NGAUSS = NGAUSS + 1
            IONE(NGAUSS) = X
            END IF
C                                       Q flux
         CALL GETNUM (LINE, LLIM, LP, X)
         IF (X.EQ.DBLANK) THEN
            NGAUSS = NGAUSS - 1
            GO TO 100
         ELSE
            QONE(NGAUSS) = X
            IF (X.NE.0.0D0) NPOL = 3
            END IF
C                                       U flux
         CALL GETNUM (LINE, LLIM, LP, X)
         IF (X.EQ.DBLANK) THEN
            NGAUSS = NGAUSS - 1
            GO TO 100
         ELSE
            UONE(NGAUSS) = X
            IF (X.NE.0.0D0) NPOL = 3
            END IF
C                                       Spectral index
         CALL GETNUM (LINE, LLIM, LP, X)
         IF (X.EQ.DBLANK) THEN
            NGAUSS = NGAUSS - 1
            GO TO 100
         ELSE
            SPIX(NGAUSS) = X
            END IF
C                                       RM
         CALL GETNUM (LINE, LLIM, LP, X)
         IF (X.EQ.DBLANK) THEN
            NGAUSS = NGAUSS - 1
            GO TO 100
         ELSE
            RM(NGAUSS) = X
            END IF
C                                       RM thickness
         CALL GETNUM (LINE, LLIM, LP, X)
         IF (X.EQ.DBLANK) THEN
            NGAUSS = NGAUSS - 1
            GO TO 100
         ELSE
            RMTHIK(NGAUSS) = X
            IF (X.GT.0.0D0) SPIXDO = 2
            END IF
C                                       position
         CALL GETNUM (LINE, LLIM, LP, X)
         IF (X.EQ.DBLANK) THEN
            NGAUSS = NGAUSS - 1
            GO TO 100
         ELSE
            FPOS(1,NGAUSS) = X
            END IF
         CALL GETNUM (LINE, LLIM, LP, X)
         IF (X.EQ.DBLANK) THEN
            NGAUSS = NGAUSS - 1
            GO TO 100
         ELSE
            FPOS(2,NGAUSS) = X
            END IF
C                                       width
         CALL RFILL (3, 0.0, FWID(1,NGAUSS))
         DO 110 J = 1,3
            IF (LP.LE.LLIM) THEN
               CALL GETNUM (LINE, LLIM, LP, X)
               IF (X.EQ.DBLANK) THEN
                  NGAUSS = NGAUSS - 1
                  GO TO 100
               ELSE
                  FWID(J,NGAUSS) = X
                  END IF
               END IF
 110        CONTINUE
C                                       model type
         ICODES(NGAUSS) = 0
         IF (LP.LE.LLIM) THEN
            CALL GETNUM (LINE, LLIM, LP, X)
            IF (X.EQ.DBLANK) THEN
               NGAUSS = NGAUSS - 1
               GO TO 100
            ELSE
               ICODES(NGAUSS) = X + 0.01
               END IF
            END IF
         IF ((ICODES(NGAUSS).LT.1) .OR. (ICODES(NGAUSS).GT.6))
     *      ICODES(NGAUSS) = ICODE
         GO TO 100
C                                       real error
      ELSE IF ((IRET.GT.0) .AND. (IRET.NE.2)) THEN
         WRITE (MSGTXT,1000) IRET, 'READING TEXT FILE'
         GO TO 999
C                                       EOF
      ELSE
         CALL ZTXCLS (TLUN, TIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING TEXT FILE'
            GO TO 999
            END IF
         END IF
C                                       check defaults
      DO 120 I = 1,NGAUSS
         IF ((FWID(1,I).LE.0.0) .OR. (FWID(2,I).LE.0.0)) THEN
            FWID(1,I) = BMAJ
            FWID(2,I) = BMIN
            FWID(3,I) = BPA
            END IF
 120     CONTINUE
C                                       MSGWRT left to caller
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('READIT ERROR',I4,' ON ',A)
      END
      SUBROUTINE MODIMD (NX, NY, IMAGE, IRET)
C-----------------------------------------------------------------------
C   MODIMD read in the input images one plane at a time, adds the model
C   appropriate to that plane, and then writes out the plane
C   Input:
C      NX      I      Number X pixels
C      NY      I      Nu,ber Y pixels
C   Output:
C      IMAGE   R(*)   Adequate memory for a plane
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NX, NY, IRET
      REAL      IMAGE(NX,*)
C
      CHARACTER IFILE*48, POLS(3)*1
      INTEGER   IROUND, LUNI, LUNO, NYI, NXI, WINI(4), NXO, NYO,
     *   WINO(4), BOI, BOO, LIM2, LIM3, LIM4, LIM5, LIM6, LIM7, I3, I4,
     *   I5, I6, I7, IPOS(7), CORN(7), BOTEMP, LIMO, IBIND, OBIND, INDI,
     *   INDO, LIM1, FRAX, J, IX, IY
      REAL      OUTMAX, OUTMIN
      DOUBLE PRECISION LAMBSQ, FREQ
      LOGICAL   T, F, BLNKD
      INCLUDE 'MODIM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUNI, LUNO /16,17/
      DATA T, F /.TRUE.,.FALSE./
      DATA POLS /'I','Q','U'/
C-----------------------------------------------------------------------
C                                       loop over polarization
      DO 100 J = 1,NPOL
         MSGTXT = 'Beginning ' // POLS(J) // ' polarization processing'
         CALL MSGWRT (2)
         CALL COPY (256, CATNEW(1,J), CATBLK)
         IF (FQAXIS) THEN
            CALL AXEFND (4, 'FQID', CATBLK(KIDIM), CATH(KHCTP), FRAX,
     *         IRET)
         ELSE
            CALL AXEFND (4, 'FREQ', CATBLK(KIDIM), CATH(KHCTP), FRAX,
     *         IRET)
            END IF
         IF (IRET.NE.0) THEN
            MSGTXT = 'CANNOT FIND FREQ/FQID AXIS'
            GO TO 990
            END IF
C                                       Open and init for read
         IF (.NOT.DONEW) THEN
            CALL ZPHFIL ('MA', DISKI(J), OLDCNO(J), 1, IFILE, IRET)
            CALL ZOPEN (LUNI, INDI, DISKI(J), IFILE, T, F, T, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'OPEN INPUT', J
               GO TO 990
               END IF
            END IF
         CALL ZPHFIL ('MA', DISKO(J), NEWCNO(J), 1, IFILE, IRET)
         CALL ZOPEN (LUNO, INDO, DISKO(J), IFILE, T, T, T, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OUPUT', J
            GO TO 990
            END IF
C                                       Setup for I/O
         NXI = CATOLD(KINAX,J)
         NYI = CATOLD(KINAX+1,J)
         NXO = CATBLK(KINAX)
         NYO = CATBLK(KINAX+1)
         WINI(1) = IROUND (BLC(1))
         WINI(2) = IROUND (BLC(2))
         WINI(3) = IROUND (TRC(1))
         WINI(4) = IROUND (TRC(2))
         WINO(1) = 1
         WINO(2) = 1
         WINO(3) = NXO
         WINO(4) = NYO
         OUTMAX = -1.0E30
         OUTMIN = 1.0E30
         BLNKD = F
C                                       Setup for looping
         LIM1 = TRC(1) - BLC(1) + 1.01
         LIM2 = TRC(2) - BLC(2) + 1.01
         LIM3 = TRC(3) - BLC(3) + 1.01
         LIM4 = TRC(4) - BLC(4) + 1.01
         LIM5 = TRC(5) - BLC(5) + 1.01
         LIM6 = TRC(6) - BLC(6) + 1.01
         LIM7 = TRC(7) - BLC(7) + 1.01
         CORN(7) = 1
         LIMO = CATBLK(KINAX) - 1
C                                       Loop
         IPOS(1) = WINI(1)
         DO 90 I7 = 1,LIM7
            IPOS(7) = BLC(7) + I7 - 0.9
            CORN(7) = I7
            DO 85 I6 = 1,LIM6
               IPOS(6) = BLC(6) + I6 - 0.9
               CORN(6) = I6
               DO 80 I5 = 1,LIM5
                  IPOS(5) = BLC(5) + I5 - 0.9
                  CORN(5) = I5
                  DO 75 I4 = 1,LIM4
                     IPOS(4) = BLC(4) + I4 - 0.9
                     CORN(4) = I4
                     DO 70 I3 = 1,LIM3
                        IPOS(3) = BLC(3) + I3 - 0.9
                        CORN(3) = I3
C                                       Init. files, first input.
                        IF (DONEW) THEN
                           IY = NX * NY
                           CALL RFILL (IY, 0.0, IMAGE)
                        ELSE
                           CALL COMOFF (CATOLD(KIDIM,J),
     *                        CATOLD(KINAX,J), IPOS(3), BOTEMP,IRET)
                           BOI = BOTEMP + 1
                           CALL MINIT ('READ', LUNI, INDI, NXI, NYI,
     *                        WINI, BUFF, JBUFSZ, BOI, IRET)
                           IF (IRET.NE.0) THEN
                              WRITE (MSGTXT,1000) IRET, 'INIT INPUT', J
                              GO TO 990
                              END IF
                           DO 20 IY = 1,LIM2
                              IPOS(2) = BLC(2) + IY - 0.99
C                                       Read.
                              CALL MDISK ('READ', LUNI, INDI, BUFF,
     *                           IBIND, IRET)
                              IF (IRET.NE.0) THEN
                                 WRITE (MSGTXT,1000) IRET, 'READ INPUT',
     *                              J
                                 GO TO 990
                                 END IF
                              CALL RCOPY (NXO, BUFF(IBIND), IMAGE(1,IY))
 20                           CONTINUE
                           END IF
C                                       compute the model even lower
                        IF (FQAXIS) THEN
                           FREQ = FQVAL(IPOS(FRAX+1))
                        ELSE
                           FREQ = CATD(KDCRV+FRAX) + CATR(KRCIC+FRAX) *
     *                        (IPOS(FRAX+1) - CATR(KRCRP+FRAX))
                           END IF
                        LAMBSQ = (VELITE / FREQ) ** 2
                        CALL THEMOD (J, FREQ, LAMBSQ, NX, NY, IMAGE)
                        DO 30 IY = 1,NYO
                           DO 25 IX = 1,NXO
                              IF (IMAGE(IX,IY).EQ.FBLANK) THEN
                                 BLNKD  = .TRUE.
                              ELSE
                                 OUTMAX = MAX (OUTMAX, IMAGE(IX,IY))
                                 OUTMIN = MIN (OUTMIN, IMAGE(IX,IY))
                                 END IF
 25                           CONTINUE
 30                        CONTINUE
C                                       Init output file.
                        CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX),
     *                     CORN(3), BOTEMP, IRET)
                        BOO = BOTEMP + 1
                        CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO,
     *                     BUFF, JBUFSZ, BOO, IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET, 'INIT OUTPUT', J
                           GO TO 990
                           END IF
                        DO 40 IY = 1,LIM2
                           IPOS(2) = BLC(2) + IY - 0.99
C                                       Write.
                           CALL MDISK ('WRIT', LUNO, INDO, BUFF, OBIND,
     *                        IRET)
                           IF (IRET.NE.0) THEN
                              WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT',
     *                           J
                              GO TO 990
                              END IF
                           CALL RCOPY (NX, IMAGE(1,IY), BUFF(OBIND))
 40                        CONTINUE
C                                       Flush buffer.
                        CALL MDISK ('FINI', LUNO, INDO, BUFF, OBIND,
     *                     IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET,
     *                        'FINISH OUTPUT', J
                           GO TO 990
                           END IF
 70                     CONTINUE
 75                  CONTINUE
 80               CONTINUE
 85            CONTINUE
 90         CONTINUE
C                                       Mark blanking in CATBLK.
         CATR(KRBLK) = 0.0
         IF (BLNKD) CATR(KRBLK) = FBLANK
         CATR(KRDMX) = OUTMAX
         CATR(KRDMN) = OUTMIN
         CALL COPY (256, CATBLK, CATNEW(1,J))
         CALL CATIO ('UPDT', DISKO(J), NEWCNO(J), CATBLK, 'REST',
     *      SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'UPDATING HEADER OF', J
            GO TO 990
            END IF
C                                       Close images
         IF (.NOT.DONEW) CALL ZCLOSE (LUNI, INDI, IRET)
         CALL ZCLOSE (LUNO, INDO, IRET)
 100     CONTINUE
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MODIMD: ERROR',I3,' ON ',A,' FILE',I2)
      END
      SUBROUTINE THEMOD (J, FREQ, LAMBSQ, NX, NY, IMAGE)
C-----------------------------------------------------------------------
C   Apply model to one plane of the image
C   Inputs:
C      J        I      J = 1 -> I, J = 2 -> Q, J = 3 -> U
C      FREQ     D      Frequency in Hz
C      LAMBSQ   D      Lambda squared im m^2
C      NX       I      Number X pixels
C      NY       I      Number Y pixels
C   In/out
C      IMAGE    R(NX,*)   image
C-----------------------------------------------------------------------
      INTEGER   J, NX, NY
      REAL      IMAGE(NX,*)
      DOUBLE PRECISION FREQ, LAMBSQ
C
      INCLUDE 'MODIM.INC'
      REAL      XX, YY, CPHI(MAXGAU), SPHI(MAXGAU), R, ANOISE, FMAX
      INTEGER   IX, IY, II, JJ, K, ISET, IXBLC, IYBLC, I
      REAL      MV, RSUM
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      SAVE ISET, IYBLC, IXBLC, CPHI, SPHI
      DATA ISET /0/
C-----------------------------------------------------------------------
C                                       Initialize constants
      IF (ISET.EQ.0) THEN
         ISET = 1
         DO 10 I = 1,NGAUSS
            CPHI(I) = COS (FWID(3,I) * DG2RAD)
            SPHI(I) = SIN (FWID(3,I) * DG2RAD)
 10         CONTINUE
C                                       Convert x-window to integers
         IXBLC = BLC(1) + 0.01
         IYBLC = BLC(2) + 0.01
         END IF
C                                       Loop over image and apply model
C                                       Point
      DO 130 IY = 1,NY
         JJ = IY + IYBLC - 1
         DO 120 IX = 1,NX
            II = IX + IXBLC - 1
            RSUM = 0.0
            DO 110 K = 1,NGAUSS
               IF (ICODES(K).EQ.1) THEN
                  R = (II-FPOS(1,K))**2 + (JJ-FPOS(2,K))**2
                  IF (R.LE.0.25) THEN
                     CALL ROTMES (J, IONE(K), QONE(K), UONE(K), RM(K),
     *                  RMTHIK(K), SPIX(K), FREQ, LAMBSQ, SPIXDO, FMAX)
                     RSUM = RSUM + FMAX
                     END IF
               ELSE IF (ICODES(K).EQ.2) THEN
                  CALL RADPOS (II, JJ, FPOS(1,K), FWID(1,K), CPHI(K),
     *               SPHI(K), XX, YY, R)
                  IF (R.LT.2.0) THEN
                     MV =  EXP (-2.772588722 * R * R)
                     CALL ROTMES (J, IONE(K), QONE(K), UONE(K), RM(K),
     *                  RMTHIK(K), SPIX(K), FREQ, LAMBSQ, SPIXDO, FMAX)
                     RSUM = RSUM + MV * FMAX
                     END IF
               ELSE IF (ICODES(K).EQ.3) THEN
                  CALL RADPOS (II, JJ, FPOS(1,K), FWID(1,K), CPHI(K),
     *               SPHI(K), XX, YY, R)
                  IF (R.LE.0.5) THEN
                     CALL ROTMES (J, IONE(K), QONE(K), UONE(K), RM(K),
     *                  RMTHIK(K), SPIX(K), FREQ, LAMBSQ, SPIXDO, FMAX)
                     RSUM = RSUM + FMAX
                     END IF
               ELSE IF (ICODES(K).EQ.4) THEN
                  CALL RADPOS (II, JJ, FPOS(1,K), FWID(1,K), CPHI(K),
     *               SPHI(K), XX, YY, R)
                  IF ((ABS(XX).LE.0.5) .AND. (ABS(YY).LE.0.5)) THEN
                     CALL ROTMES (J, IONE(K), QONE(K), UONE(K), RM(K),
     *                  RMTHIK(K), SPIX(K), FREQ, LAMBSQ, SPIXDO, FMAX)
                     RSUM = RSUM + FMAX
                     END IF
               ELSE IF (ICODES(K).EQ.5) THEN
                  CALL RADPOS (II, JJ, FPOS(1,K), FWID(1,K), CPHI(K),
     *               SPHI(K), XX, YY, R)
                  IF (R.LT.0.5) THEN
                     MV = SQRT (1.0 - 4.0 * R * R)
                     CALL ROTMES (J, IONE(K), QONE(K), UONE(K), RM(K),
     *                  RMTHIK(K), SPIX(K), FREQ, LAMBSQ, SPIXDO, FMAX)
                     RSUM = RSUM + MV * FMAX
                     END IF
               ELSE IF (ICODES(K).EQ.6) THEN
                  CALL RADPOS (II, JJ, FPOS(1,K), FWID(1,K), CPHI(K),
     *               SPHI(K), XX, YY, R)
                  IF (R.LT.8.0) THEN
                     MV = EXP (-1.386294361 * R)
                     CALL ROTMES (J, IONE(K), QONE(K), UONE(K), RM(K),
     *                  RMTHIK(K), SPIX(K), FREQ, LAMBSQ, SPIXDO, FMAX)
                     RSUM = RSUM + MV * FMAX
                     END IF
                  END IF
 110           CONTINUE
C
            IMAGE(IX,IY) = FACTOR * IMAGE(IX,IY) + RSUM
C                                       Add random noise?
            IF (FLUX.GT.0.0) THEN
               CALL NOISE (ANOISE)
               IMAGE(IX,IY) = IMAGE(IX,IY) + ANOISE * FLUX
               END IF
 120        CONTINUE
 130     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE RADPOS (I, J, FP, FW, CPHI, SPHI, XX, YY, R)
C-----------------------------------------------------------------------
C   Work out distance of current pixel from model center and normalize
C   by the FWHM and correct for p.a. of model
C   Inputs:
C      I      I      X pixel
C      J      I      Y pixel
C      FP     R(2)   Component X,Y center pixels
C      FW     R(3)   Component Bmaj, Bmin, Bpa (pixels, pixel, deg)
C      CPHI   R      Cos (Bpa)
C      SPHI   R      Sin (Bpa)
C   Outputs:
C      XX     R      Normalized X position
C      YY     R      Normalized Y position
C      R      R      Normalized radius of current pixel from model
C                     center
C   Disks and rectangles extend only to R=0.5 or XX,YY=0.5
C-----------------------------------------------------------------------
      INTEGER   I, J
      REAL      FP(2), FW(3), CPHI, SPHI, XX, YY, R
C
      REAL      X, Y
C-----------------------------------------------------------------------
      X = I - FP(1)
      Y = J - FP(2)
      XX = (Y * CPHI - X * SPHI) / FW(1)
      YY = (X * CPHI + Y * SPHI) / FW(2)
      R = SQRT (XX**2 + YY**2)
C
      RETURN
      END
      SUBROUTINE NOISE (A)
C-----------------------------------------------------------------------
C   NOISE generates a random number approximately distributed in a
C   Gaussian manner about zero.  It does it by summing a uniformly-
C   distributed random number 12 times.
C   Output:
C      A   R       The current sample from the gaussian distribution
C-----------------------------------------------------------------------
      REAL      A, B
      INTEGER   J
C-----------------------------------------------------------------------
      A = -6.0
      DO 10 J = 1,12
         CALL RANDUM (B)
         A = A + B
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE ROTMES (J, IONE, QONE, UONE, RM, RMTHIK, SPIX, FREQ,
     *   LAMBSQ, SPIXDO, FMAX)
C-----------------------------------------------------------------------
C   ROTMES computes the rotation measure rotated Q or U
C   Inputs:
C      J        I   1 want I, 2 want Q, 3 want U
C      IONE     R   I at FREQ=1.E9
C      QONE     R   Q at FREQ=1.E9
C      UONE     R   U at FREQ=1.E9
C      RM       R   Rotation measure in radians/m^2
C      SPIX     R   Spectral index
C      LAMBSQ   D   Lambda squared in m^2
C      SPIXDO   I   Type of thickness model (2, 3, 4)
C   Outputs
C      FMAX     R   The Q or U at this lambda
C-----------------------------------------------------------------------
      INTEGER   J, SPIXDO
      REAL      IONE, QONE, UONE, RM, RMTHIK, SPIX, FMAX
      DOUBLE PRECISION FREQ, LAMBSQ
C
      REAL      SPHI, CPHI, FACTOR
      DOUBLE PRECISION LAMONE, XX, DSINCS
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      FACTOR = (FREQ/1.D9) ** SPIX
      IF (RMTHIK.NE.0.0) THEN
         XX = RMTHIK * LAMBSQ
         FACTOR = FACTOR * DSINCS (SPIXDO, 0, XX)
         END IF
      IF (J.GT.1) THEN
         LAMONE = (VELITE / 1.D9) ** 2
         SPHI = FACTOR * SIN (2.0 * RM * (LAMBSQ - LAMONE))
         CPHI = FACTOR * COS (2.0 * RM * (LAMBSQ - LAMONE))
         END IF
      IF (J.EQ.1) THEN
         FMAX = FACTOR * IONE
      ELSE IF (J.EQ.2) THEN
         FMAX = QONE * CPHI - UONE * SPHI
      ELSE
         FMAX = UONE * CPHI + QONE * SPHI
         END IF
C
 999  RETURN
      END
      DOUBLE PRECISION FUNCTION DSINCS (MODEL, TYPE, XX)
C-----------------------------------------------------------------------
C   returns sin(xx)/xx on type 0 and d (sin(xx)/xx) / dx on type 1
C   Inputs:
C      MODEL   I   2 - sin(x)/x, 3 Gauss, 4 exp
C      TYPE    I   0 - return function, 1 return derivative
C      XX      D   argument
C   Output
C     DSINCS   D   function value or derivative
C-----------------------------------------------------------------------
      INTEGER   MODEL, TYPE
      DOUBLE PRECISION XX
C
      DOUBLE PRECISION F
C                                       1.8954 radians is the half-power
C                                       of sin(x) / x
C-----------------------------------------------------------------------
      DSINCS = 0.0D0
C                                       SIN(X)/X function
      IF (MODEL.EQ.2) THEN
         IF (TYPE.EQ.0) THEN
            IF (ABS(XX).LE.1.D-5) THEN
               DSINCS = 1.0D0 - XX*XX / 6.0D0 + XX*XX*XX*XX / 120.0D0
            ELSE
               DSINCS = SIN (XX) / XX
               END IF
C                                       SIN(X)/X derivative
         ELSE IF (TYPE.EQ.1) THEN
            IF (ABS(XX).LE.1.D-5) THEN
               DSINCS = -XX/3.D0 + XX*XX*XX/30.D0 -
     *            XX*XX*XX*XX*XX/840.D0
            ELSE
               DSINCS = (XX * COS(XX) - SIN(XX)) / (XX*XX)
               END IF
            END IF
C                                       Gauss function
      ELSE IF (MODEL.EQ.3) THEN
         F = -LOG (2.0D0) / (1.8954 * 1.8954)
         IF (TYPE.EQ.0) THEN
            DSINCS = EXP (F * XX * XX)
C                                       Gauss derivative
         ELSE IF (TYPE.EQ.1) THEN
            DSINCS = 2.0 * XX * F * EXP (F * XX * XX)
            END IF
C                                       Exp function
      ELSE IF (MODEL.EQ.4) THEN
         F = -LOG (2.0D0) / 1.8954
         IF (TYPE.EQ.0) THEN
            DSINCS = EXP (F * ABS(XX))
C                                       Exp derivative
         ELSE IF (TYPE.EQ.1) THEN
            DSINCS = F * EXP (F * ABS(XX))
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE MODIMH
C-----------------------------------------------------------------------
C   MODIMH copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER ATIME*8, ADATE*12, HILINE*72, NOTTYP*2, CODES(6)*4,
     *   TCODES(3)*4
      INTEGER   LUN1, LUN2, IERR, I, NCOMP, J, TIME(3), DATE(3)
      INCLUDE 'MODIM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN1, LUN2 /27,28/
      DATA NOTTYP /'CC'/
      DATA CODES /'POIN','GAUS','DISK','RECT','SPHE','EXPD'/
      DATA TCODES /'SLAB', 'GAUS', 'EXP '/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
      DO 100 J = 1,NPOL
         CALL COPY (256, CATNEW(1,J), CATBLK)
C                                       Copy/open history file.
         IF (.NOT.DONEW) THEN
            CALL HISCOP (LUN1, LUN2, DISKI(J), DISKO(J), OLDCNO(J),
     *         NEWCNO(J), CATBLK, SCRTCH, BUFF, IERR)
            IF (IERR.GT.2) THEN
               WRITE (MSGTXT,1000) IERR, 'COPYING HI FILE', J
               CALL MSGWRT (6)
               GO TO 20
               END IF
C                                       New history
            IF (J.EQ.1) THEN
               CALL HENCO1 (TSKNAM, NAMEI(J), CLASI(J), SEQI(J),
     *            DISKI(J), LUN2, BUFF, IERR)
            ELSE IF (J.EQ.2) THEN
               CALL HENCO2 (TSKNAM, NAMEI(J), CLASI(J), SEQI(J),
     *            DISKI(J), LUN2, BUFF, IERR)
            ELSE
               CALL HENCO3 (TSKNAM, NAMEI(J), CLASI(J), SEQI(J),
     *            DISKI(J), LUN2, BUFF, IERR)
               END IF
            IF (IERR.NE.0) GO TO 20
C                                       BLC
            WRITE (HILINE,2000) TSKNAM, BLC
            CALL HIADD (LUN2, HILINE, BUFF, IERR)
            IF (IERR.NE.0) GO TO 20
C                                       TRC
            WRITE (HILINE,2001) TSKNAM, TRC
            CALL HIADD (LUN2, HILINE, BUFF, IERR)
            IF (IERR.NE.0) GO TO 20
C                                       need new HI file
         ELSE
C                                       Create/open hist. file.
            CALL HICREA (LUN2, DISKO(J), NEWCNO(J), CATBLK, BUFF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'CREATING HI FILE', J
               CALL MSGWRT (6)
               GO TO 20
               END IF
C                                       Get current date/time.
            CALL ZDATE (DATE)
            CALL ZTIME (TIME)
            CALL TIMDAT (TIME, DATE, ATIME, ADATE)
C                                       Write first record.
            WRITE (HILINE,1010) TSKNAM, NLUSER, ADATE, ATIME
            CALL HIADD (LUN2, HILINE, BUFF, IERR)
            IF (IERR.NE.0) GO TO 20
            END IF
C                                       outname
         CALL HENCOO (TSKNAM, NAMOUT, CLASO(J), SEQO(J), DISKO(J), LUN2,
     *      BUFF, IERR)
         IF (IERR.NE.0) GO TO 20
C                                       Components
         NCOMP = NGAUSS
         NCOMP = MAX (1, MIN (9, NCOMP))
         IF (NGAUSS.GT.NCOMP) THEN
            MSGTXT = 'ONLY FIRST 9 LISTED IN HI'
            IF (J.EQ.1) CALL MSGWRT (2)
            END IF
         WRITE (HILINE,2003) TSKNAM, NGAUSS
         CALL HIADD (LUN2, HILINE, BUFF, IERR)
         IF (IERR.NE.0) GO TO 20

         DO 10 I = 1,NCOMP
C                                       IONE
            WRITE (HILINE,2004) TSKNAM, I, IONE(I)
            CALL HIADD (LUN2, HILINE, BUFF, IERR)
            IF (IERR.NE.0) GO TO 20
C                                       QONE
            WRITE (HILINE,2005) TSKNAM, I, QONE(I)
            CALL HIADD (LUN2, HILINE, BUFF, IERR)
            IF (IERR.NE.0) GO TO 20
C                                       UONE
            WRITE (HILINE,2006) TSKNAM, I, UONE(I)
            CALL HIADD (LUN2, HILINE, BUFF, IERR)
            IF (IERR.NE.0) GO TO 20
C                                       SPIX
            WRITE (HILINE,2007) TSKNAM, I, SPIX(I)
            CALL HIADD (LUN2, HILINE, BUFF, IERR)
            IF (IERR.NE.0) GO TO 20
C                                       RM
            WRITE (HILINE,2008) TSKNAM, I, RM(I)
            CALL HIADD (LUN2, HILINE, BUFF, IERR)
            IF (IERR.NE.0) GO TO 20
C                                       RMTHICK
            WRITE (HILINE,2009) TSKNAM, I, RMTHIK(I)
            CALL HIADD (LUN2, HILINE, BUFF, IERR)
            IF (IERR.NE.0) GO TO 20
C                                       FPOS
            WRITE (HILINE,2010) TSKNAM, I, FPOS(1,I), FPOS(2,I)
            CALL HIADD (LUN2, HILINE, BUFF, IERR)
            IF (IERR.NE.0) GO TO 20
C                                       BMAJ
            IF (ICODES(I).NE.1) THEN
               WRITE (HILINE,2011) TSKNAM, I, FWID(1,I), FWID(2,I),
     *            FWID(3,I)
               CALL HIADD (LUN2, HILINE, BUFF, IERR)
               IF (IERR.NE.0) GO TO 20
               END IF
C                                       OPCODE
            WRITE (HILINE,2012) TSKNAM, I, CODES(ICODES(I))
            CALL HIADD (LUN2, HILINE, BUFF, IERR)
            IF (IERR.NE.0) GO TO 20
 10         CONTINUE
C                                       FLUX
         WRITE (HILINE,2020) TSKNAM, FLUX
         CALL HIADD (LUN2, HILINE, BUFF, IERR)
         IF (IERR.NE.0) GO TO 20
C                                       FACTOR
         WRITE (HILINE,2021) TSKNAM, FACTOR
         CALL HIADD (LUN2, HILINE, BUFF, IERR)
         IF (IERR.NE.0) GO TO 20
C                                       OPTYPE
         IF (SPIXDO.GT.0) THEN
            WRITE (HILINE,2022) TSKNAM, TCODES(SPIXDO-1)
            CALL HIADD (LUN2, HILINE, BUFF, IERR)
            IF (IERR.NE.0) GO TO 20
            END IF
C                                       Close HI file
 20      CALL HICLOS (LUN2, .TRUE., BUFF, IERR)
C                                        Copy tables
         IF (.NOT.DONEW) THEN
            CALL ALLTAB (1, NOTTYP, LUN1, LUN2, DISKI(J), DISKO(J),
     *         OLDCNO(J), NEWCNO(J), CATBLK, BUFF, SCRTCH, IERR)
            IF (IERR.GT.2) THEN
               MSGTXT = 'ERROR COPYING TABLE FILES'
               CALL MSGWRT (6)
               END IF
            END IF
C                                        Update CATBLK.
         CALL CATIO ('UPDT', DISKO(J), NEWCNO(J), CATBLK, 'REST',
     *      SCRTCH, IERR)
 100     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MODIMH: ERROR',I3,' ON ',A,' FILE',I2)
 1010 FORMAT (A6,'/ Image created by user',I5,' at ',A12,2X,A8)
 2000 FORMAT (A6,'BLC =',7F6.0)
 2001 FORMAT (A6,'TRC =',7F6.0)
 2003 FORMAT (A6,'NGAUSS=',I6,'    total number components')
 2004 FORMAT (A6,'IONE(',I4,')  =',1PE12.4,12X,'/ JY/BEAM')
 2005 FORMAT (A6,'QONE(',I4,')  =',1PE12.4,12X,'/ JY/BEAM')
 2006 FORMAT (A6,'UONE(',I4,')  =',1PE12.4,12X,'/ JY/BEAM')
 2007 FORMAT (A6,'SPIX(',I4,')  =',1PE12.4,12X,'/ unitless')
 2008 FORMAT (A6,'RM(',I4,')    =',1PE12.4,12X,'/ RAD/M/M')
 2009 FORMAT (A6,'RMTHICK(',I4,')  =',F8.2,',',F8.2,7X,'/ RAD/M/M')
 2010 FORMAT (A6,'FPOS(',I4,')  =',F8.2,',',F8.2,7X,'/ pixels')
 2011 FORMAT (A6,'FWIDTH(',I4,') =',F7.3,',',F7.3,',',F6.1,
     *   '  / Maj pix, Min pix, PA deg')
 2012 FORMAT (A6,'OPCODE(',I4,') = ''',A4,'''',12X,'/ component type')
 2020 FORMAT (A6,'FLUX = ',1PE12.4,5X,'/ noise added')
 2021 FORMAT (A6,'FACTOR = ',1PE12.4,5X,'/ Applied to input data')
 2022 FORMAT (A6,'OPTYPE = ''',A4,'''',12X,'/ thickness model')
      END

      SUBROUTINE GETTIM (DISK, CNO, BUFFTM, CATBLK, YEAR, RDAY, IATUT,
     *   IRET)
C-----------------------------------------------------------------------
C! Determine time info from AN table
C# Table Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2001, 2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to determine the year and day number of observation from the
C   antenna table.
C   Inputs:
C      DISK     I      Disk # containing AN table
C      CNO      I      Cat. #
C      BUFFTM   I(*)   Work buffer
C      CATBLK   I(*)   Catalogue header
C   Outputs:
C      YEAR     I      Year
C      RDAY     I      Reference day of observation
C      IATUT    R      data time - UTC time difference (secs)
C      IRET     I      Error, = 0 => OK
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, BUFFTM(*), CATBLK(*), YEAR, RDAY, IRET
      REAL      IATUT
C
      INTEGER   IDD, IMM, IVER, LUN, ID(3)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LUN /40/
C-----------------------------------------------------------------------
      IRET = 0
C                                       Read AN table
      IVER = 0
      CALL ANTINI ('READ', BUFFTM, DISK, CNO, IVER, CATBLK, LUN, IANRNO,
     *   ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE, POLRXY,
     *   UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB, NOPCAL,
     *   ANFQID, ANTNIF, IRET)
      IATUT = DATUTC
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Decode date
      CALL DATEST (RDATE, ID)
      YEAR = ID(1)
      IMM = ID(2)
      IDD = ID(3)
C                                       Determine day number
      CALL DAYNUM (YEAR, IDD, IMM, RDAY)
C                                       This should no longer be
C                                       necessary:
CC                                       Correct IATUTC if = 0
C      IF (IATUT.EQ.0.0) THEN
C         CALL JULDAY (RDATE, JD)
C         TJD = JD - 2400000.5D0
C         IATUT = TAI (TJD)
C         END IF
C                                       Close AN extension file
      CALL TABIO ('CLOS', 1, IANRNO, BUFFTM, BUFFTM, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1200) IRET
         GO TO 990
         END IF
      GO TO 999
C                                       Write error message
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETTIM: ERROR',I3,' OPEN-FOR READ AN FILE')
 1200 FORMAT ('GETTIM: ERROR',I3,' CLOSING AN FILE')
      END

      SUBROUTINE MAPSIZ (NAX, NP, ISIZE)
C-----------------------------------------------------------------------
C! returns the file size needed to hold the specified image in AIPS
C# Map-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MAPSIZ computes the correct number of bytes to request from ZCREAT
C   for a file using map IO methods.
C   Inputs:
C      NAX    I        # axes
C      NP     I(NAX)   Number of points on each axis
C   Output:
C      ISIZE  I        File size in AIPS blocks (256 integers)
C-----------------------------------------------------------------------
      INTEGER   NAX, NP(*), ISIZE
C
      INTEGER   I
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Number sectors/plane
      ISIZE = 2 * NP(1)
      IF ((NAX.GE.2) .AND. (ISIZE.LE.NBPS/2)) GO TO 10
         ISIZE = 1 + (ISIZE-1) / NBPS
         IF (NAX.GE.2) ISIZE = ISIZE * NP(2)
         GO TO 20
 10   CONTINUE
         ISIZE = NBPS / ISIZE
         ISIZE = 1 + (NP(2)-1) / ISIZE
C                                       Number sectors -> bytes
 20   ISIZE = ISIZE * (NBPS / 512)
      IF (NAX.LE.2) GO TO 999
         DO 30 I = 3,NAX
            ISIZE = ISIZE * NP(I)
 30         CONTINUE
C
 999  RETURN
      END

      SUBROUTINE SETBSC (RMAX, RMIN, BSC, BZE)
C-----------------------------------------------------------------------
C! determines scaling/offset parameters to convert image to integer
C# Map-util FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   SETBSC computes the data scaling parameters for conversion from
C   floating point to integer maps.  Its intent is to have a true data
C   0 value be an exact integer on output.
C   Inputs:
C      RMAX   R      Highest data value
C      RMIN   R      Lowest data value
C   Output:
C      BSC    D      Multiplier: real = BSC * integer + BZE
C      BZE    D      Offset: ditto
C   Common
C      /DCHCOM/ for NBITWD  (to force 16 or 32 bit, then - save local
C                           NBITWD, set 16/32, call SETBSC, restore
C                           local NBITWD)
C-----------------------------------------------------------------------
      REAL      RMAX, RMIN
      DOUBLE PRECISION BSC, BZE
C
      DOUBLE PRECISION DMAX, DMIN, DT, DTT
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Basic scaling
      DMAX = RMAX
      DMIN = RMIN
      DT = 2.0D0 ** MIN (32, NBITWD) - 8.0D0
      BSC = (DMAX - DMIN) / DT
      BZE = (DMAX + DMIN) / 2.0D0
C                                       constant image
      IF (BSC.NE.0.0D0) GO TO 10
         BSC = 1.0D0
         GO TO 999
C                                       reset for 0.0 integer
 10   DT = -BZE / BSC
      DT = DT + 0.5D0
      DTT = MOD (DT, 1.0D0)
      IF ((DT.LT.0.0D0) .AND. (DTT.GT.0.0D0)) DTT = 1.0D0 - DTT
      DT = DT - DTT
      BZE = -DT * BSC
C
 999  RETURN
      END

LOCAL INCLUDE 'SNRMS.INC'
      INTEGER   NCODE
      PARAMETER (NCODE=27)
C                                       Local include for SNRMS
      INCLUDE 'INCS:PUVD.INC'
C                                       Input parameters
      REAL      XSIN, XDISIN, XNVER, XQUAL, XTIME(8), XBAND, XFREQ,
     *   XFQID, XSUBA, XBIF, XEIF, XANT(50), XREF, XPCNUM, CUTOFF,
     *   DOCRT
      HOLLERITH XNAMEI(3), XCLAIN(2), XTYPE(1), XXSOUR(4,30), XXSTOK(1),
     *   XOPTY(1), XOUTPR(12)
      CHARACTER NAMEIN*12, CLAIN*6, TYPE*2, XSOUR(30)*16, XSTOK*4,
     *   OPTYPE*4, OUTPRT*48, TITL1*256, TITL2*256
C                                       Program info
C
      INTEGER   MXSCAN
      PARAMETER (MXSCAN=5000)
C
      REAL      TSTART, TSTOP, TINT, XYSCL(2), XYOFF(2), YYMX(10),
     *   YYMN(10), XMX, XMN, XMXW, XMNW, GMMOD, RATFAC(MAXIF), SELBAN,
     *   XSTART, XSTOP, CHOUT(4), XXMIN(MAXANT), XXMAX(MAXANT),
     *   YYMIN(2,MAXIF,MAXANT,10), TSCAN(MXSCAN), PPMAX(2,MAXIF,MAXANT),
     *   YYMAX(2,MAXIF,MAXANT,10), PPMIN(2,MAXIF,MAXANT), PRAN(2,2),
     *   DO3COL, TCAL(4,MAXIF,MAXANT), CSMIN, CSMAX
      INTEGER   SEQIN, DISKIN, CNOIN, IVER, BIF, ANTS(50), NCOUNT,
     *   ICODES(10), NCODES, NPARMS, NID, SID(500), NANTSL, NPLOTS,
     *   SUMSTK, ISTOK, FRQSEL, GRCHN, TVCHN, TVCORN(4), XVAR,
     *   ISOU, OSOU, IANT, EIF, ITPLOT, ITVER, PCNUM, LABEL, SUBARR,
     *   MUMPOL, MUMIF, MUMANT, NTONE, NUMPTS(MAXANT), ISYM,
     *   BSYM, NANREC(MAXANT), FANREC(MAXANT), NOSCAN, STRANS(MXSCAN),
     *   REFANT, MAXREC, LUNP, FINDP, NACROS, IPCNT
      LOGICAL   DOAWNT, DOTV, NNODAT, DOLINE, SWAP, REREF, DOTEX
      DOUBLE PRECISION SELFRQ, JD0, GNRECD(XCLRSZ/2)
C                                       SN/CL table info
      INTEGER CLBUFF(512), NCLINR, NUMANT, NUMPOL, NUMIF, ICLRNO,
     *   KOLS(40), KOLTYP(40), KOLDIM(40), ICLUN, GNRECI(XCLRSZ),
     *   TIMKOL, INTKOL, SOUKOL, ANTKOL, SUBKOL, FRQKOL, IFRKOL,
     *   GEOKOL, DOPKOL, ATMKOL, DATKOL,
     *   MB1KOL, RE1KOL, IM1KOL, DL1KOL, RA1KOL, WT1KOL, RF1KOL, TS1KOL,
     *   TA1KOL, CK1KOL, DC1KOL, DS1KOL, DD1KOL,
     *   MB2KOL, RE2KOL, IM2KOL, DL2KOL, RA2KOL, WT2KOL, RF2KOL, TS2KOL,
     *   TA2KOL, CK2KOL, DC2KOL, DS2KOL, DD2KOL,
     *   MBKOL(4), REKOL(4), IMKOL(4), DLKOL(4), RAKOL(4), WTKOL(4),
     *   RFKOL(4), TSKOL(4), TAKOL(4), CKKOL(4), DCKOL(4), DSKOL(4),
     *   DDKOL(4), STKOL(4),
     *   DOPLKL, DOP3KL, CLTIME, CABKOL, ST1KOL, ST2KOL
      REAL GNREC(XCLRSZ)
C                                       Constants
      DOUBLE PRECISION SIDER, CLIGHT
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XTYPE, XNVER,
     *   XXSOUR, XQUAL, XTIME, XXSTOK, XBAND, XFREQ, XFQID, XSUBA, XBIF,
     *   XEIF, XANT, XOPTY, XREF, XPCNUM, CUTOFF, DOCRT, XOUTPR
      COMMON /VPARM/ SEQIN, DISKIN, CNOIN, IVER, BIF, EIF, ANTS, NCOUNT,
     *   ICODES, NCODES, NPARMS, GRCHN, TVCHN, TVCORN, XVAR, ISOU, OSOU,
     *   IANT, ITPLOT, ITVER, PCNUM, DOTV, NNODAT, LABEL, CHOUT, DO3COL,
     *   DOLINE, NOSCAN, TSCAN, STRANS, SWAP, REREF, REFANT, MAXREC,
     *   LUNP, FINDP, NACROS, IPCNT, DOTEX
      COMMON /VGNCOM/ SELFRQ, JD0,
     *   TSTART, TSTOP, TINT, XYSCL, XYOFF, SELBAN, XMX, XMN, XMXW,
     *   XMNW, XSTART, XSTOP, GMMOD, RATFAC, NID, SID, NANTSL, PRAN,
     *   NPLOTS, DOAWNT, ISTOK, SUMSTK, FRQSEL,
     *   SUBARR, MUMPOL, MUMIF, MUMANT, NUMPTS, NTONE,
     *   XXMIN, XXMAX, YYMIN, YYMAX, PPMIN, PPMAX, YYMX, YYMN, ISYM,
     *   BSYM, TCAL, NANREC, FANREC, CSMIN, CSMAX
      COMMON /VGNCHR/ NAMEIN, CLAIN, TYPE, XSOUR, XSTOK, OPTYPE,
     *   OUTPRT, TITL1, TITL2
      COMMON /TABCOM/ GNREC, CLBUFF, NCLINR, NUMANT, NUMPOL, NUMIF,
     *   ICLRNO, KOLS, KOLTYP, KOLDIM, ICLUN,
     *   MBKOL, REKOL, IMKOL, DLKOL, RAKOL, WTKOL, RFKOL, TSKOL,
     *   TAKOL, CKKOL, DCKOL, DSKOL, DDKOL, STKOL,
     *   DOPLKL, DOP3KL, CLTIME
      COMMON /CONST/ SIDER, CLIGHT
      EQUIVALENCE (GNREC, GNRECD, GNRECI)
      EQUIVALENCE (KOLS(1), TIMKOL), (KOLS(2), INTKOL),
     *   (KOLS(3), SOUKOL), (KOLS(4), ANTKOL), (KOLS(5), SUBKOL),
     *   (KOLS(6), FRQKOL), (KOLS(7), IFRKOL),
     *   (KOLS(8), GEOKOL), (KOLS(9), DOPKOL), (KOLS(10), ATMKOL),
     *   (KOLS(11), DATKOL)
      EQUIVALENCE (KOLS(12), MB1KOL),
     *   (KOLS(13), RE1KOL), (KOLS(14), IM1KOL),
     *   (KOLS(15), RA1KOL), (KOLS(16), DL1KOL), (KOLS(17), WT1KOL),
     *   (KOLS(18), RF1KOL), (KOLS(19), TS1KOL), (KOLS(20), TA1KOL),
     *   (KOLS(21), CK1KOL), (KOLS(22), DC1KOL),
     *   (KOLS(23), DS1KOL), (KOLS(24), DD1KOL)
      EQUIVALENCE (KOLS(25), MB2KOL),
     *   (KOLS(26), RE2KOL), (KOLS(27), IM2KOL),
     *   (KOLS(28), RA2KOL), (KOLS(29), DL2KOL), (KOLS(30), WT2KOL),
     *   (KOLS(31), RF2KOL), (KOLS(32), TS2KOL), (KOLS(33), TA2KOL),
     *   (KOLS(34), CK2KOL), (KOLS(35), DC2KOL),
     *   (KOLS(36), DS2KOL), (KOLS(37), DD2KOL),
     *   (KOLS(38), CABKOL), (KOLS(39), ST1KOL), (KOLS(40), ST2KOL)
C                                                          End SNRMS
LOCAL END
      PROGRAM SNRMS
C-----------------------------------------------------------------------
C! Prints statitics from a SN, TY, PC or CL table
C# UV Plot EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SNRMS plots SN or CL extension files. A 'PL' extension file is made
C   which can be displayed in the usual ways .
C   Inputs:
C      INNAME.....UV file name (name).       Standard defaults.
C      INCLASS....UV file name (class).      Standard defaults.
C      INSEQ......UV file name (seq. #).     0 => highest.
C      INDISK.....Disk unit #.               0 => any.
C      INEXT......'SN','TY','PC' or 'CL' table to be plotted
C      INVERS.....Version number of table to plot, 0=>highest no.
C      SOURCES....Source list.  '*' = all; a "-" before a source
C                 name means all except ANY source named.
C      TIMERANG...Time range of the data to be plotted. In order:
C                 Start day, hour, min. sec,
C                 end day, hour, min. sec. Days relative to ref.
C                 date.
C      STOKES.....The desired Stokes type of the output data:
C                 'R' = RCP, 'L' = LCP, 'DIFF' = difference
C      BIF........IF to plot
C      ANTENNAS...A list of the antennas to be plotted. All 0 => all.
C                 If any number is negative then all antennas listed
C                 are NOT to be plotted and all others are.
C      OPTYPE.....Data to be plotted: 'PHAS' = phase, 'AMP '=  ampl.,
C                 'DELA' = delay, 'RATE' = rate, 'TSYS' = sys. temp.
C                 'SUM ' = summary, 'DOPL' = doppler offset, 'SNR' =
C                 signal to noise ratio, 'CCAL' = cable-cal,
C                 'DDLY' = dispersive delay  'IFR' Faraday rotation
C                 '    ' => 'PHAS'
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      REAL      PLTPTS(2), STATS(2)
      LONGINT   PPLTPT, PSTAT
      INTEGER   IRET, MVAL, NWORDS, NROWS
      INCLUDE 'SNRMS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGN /'SNRMS '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL SNPIN (PRGN, NROWS, IRET)
      MUMANT = MAX (1, MUMANT)
      MVAL = 3 + MUMPOL*MUMIF
      NWORDS = (MVAL * NROWS - 1) / 1024  + 21
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, PLTPTS, PPLTPT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         END IF
C                                       read data to figure out
C                                       distribution
      NWORDS = NWORDS * 1024
      IF (IRET.EQ.0) CALL SNPCNT (NWORDS, IRET)
      NWORDS = (MAXREC - 1) / 1024 + 4
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, STATS, PSTAT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         END IF
C                                       Fetch data, determine scaling
      IF (IRET.EQ.0) CALL SNPMAX (MVAL, PLTPTS(1+PPLTPT), IRET)
C                                       Re-reference
      IF ((IRET.EQ.0) .AND. (REREF)) CALL SNPREF (MVAL,
     *   PLTPTS(1+PPLTPT), IRET)
C                                       Do print out
      IF (IRET.EQ.0) CALL SNPRNT (MVAL, MUMANT, PLTPTS(1+PPLTPT),
     *   STATS(1+PSTAT), IRET)
      CALL LPCLOS (LUNP, FINDP, IPCNT, MVAL)
      IF (IRET.LT.0) IRET = 0
C                                       Close down
      CALL DIE (IRET, CLBUFF)
C
 999  STOP
      END
      SUBROUTINE SNPIN (PRGN, NROWS, IERR)
C-----------------------------------------------------------------------
C   Gets the inputs parameters for SNRMS.
C   Inputs:
C      PRGN    C*6  Program name
C   Output in common:
C      SUMSTK  I    Selected Stokes 0=both, 1=R, 2=L, 4=difference
C   Output:
C      IERR    I    Error code: 0 => ok
C      ISTOK   I    1 = R, 2 = L
C      ICODE   I    1='PHAS', 2='AMP ', 3='DELA', 4='RATE', 5='TSYS',
C                   6='SUM ', 7='DOPL', 8='SNR', 9='MDEL', 10='TANT',
C                   11='ATM', 12='GEO', 13='CCAL', 14='DDLY'
C                   15='REAL', 16='IMAG', 17='IFR', 18='PDIF',
C                   19='PSUM', 20=PGN ', 21='PON ', 22='POFF', 23='PSYS'
C                   24='PDGN', 25='PSGN', 26='POWR', 27='PODB'
C-----------------------------------------------------------------------
      INTEGER   NROWS, IERR
      CHARACTER PRGN*6
C
      INTEGER   NTPLT
      PARAMETER (NTPLT=5)
C
      INCLUDE 'SNRMS.INC'
      CHARACTER STAT*4, CODE(NCODE)*4, TYPTMP*2, TPLOT(NTPLT)*4
      INTEGER   IRET, BUFF(256), I, J, K, JERR, QUAL(30), NSOUR,
     *   BUFFER(512), IROUND, LUN, VER, NIF, NSTOK, FRQTMP, ICODE
      LOGICAL T, F, MATCH, ISTYPE
      DOUBLE PRECISION FOFF(MAXIF)
      INTEGER   ISBAND(MAXIF)
      REAL      FINC(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA CODE /'PHAS', 'AMP ', 'DELA', 'RATE', 'TSYS', 'SUM ', 'DOPL',
     *   'SNR ', 'MDEL', 'TANT', 'ATM ', 'GEO ', 'CCAL', 'DDLY', 'REAL',
     *   'IMAG', 'IFR ', 'PDIF', 'PSUM', 'PGN ', 'PON ', 'POFF', 'PSYS',
     *   'PDGN', 'PSGN', 'POWR', 'PODB'/
      DATA TPLOT /'ALIF', 'ALST', 'ALSI', 'IFDF', 'IFRA'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      OSOU = -1
      NPARMS = 211
      TSKNAM = PRGN
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE.)
C                                       Initialize header index values.
      CALL VHDRIN
C                                       Zero counters for DIE.
      NCFILE = 0
      NSCR = 0
      CALL FILL (10, 0, IBAD)
C                                       Get input values from AIPS.
      IERR = 0
      CALL GTPARM (PRGN, NPARMS, RQUICK, XNAMEI, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IERR = 1
         IRET = 8
         RQUICK = .FALSE.
         GO TO 990
         END IF
      IF (DOCRT.GT.0.0) RQUICK = .FALSE.
      IF (RQUICK) CALL RELPOP (IERR, BUFF, I)
C                                       Decode inputs.
C                                       characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (2, 1, XTYPE, TYPE)
      CALL H2CHR (4, 1, XXSTOK, XSTOK)
      CALL H2CHR (4, 1, XOPTY, OPTYPE)
      CALL H2CHR (48, 1, XOUTPR, OUTPRT)
      DOTEX = (DOCRT.GT.132) .OR. (DOCRT.LT.-3.0)
      DOCRT = MIN (132., DOCRT)
      IF (DOCRT.LT.-3.0) DOCRT = -1.0
C                                       OPTYPE='REAL', 'IMAG' only for
C                                       SN table
      IF ((OPTYPE.EQ.'REAL' .OR. OPTYPE.EQ.'IMAG')
     *   .AND. (TYPE.NE.'SN' .AND. TYPE.NE.'CL')) THEN
         MSGTXT = '!!OPTYPE=REAL/IMAG works only with SN/CL table!!'
         CALL MSGWRT (8)
         IERR = 1
         GO TO 999
         END IF
C
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
         QUAL(I) = IROUND (XQUAL)
 20      CONTINUE
      IF (TYPE.EQ.' ') TYPE ='SN'
      CUTOFF = MAX (0.0, CUTOFF)
      IF ((TYPE.EQ.'TY') .OR. (TYPE.EQ.'PC') .OR. (TYPE.EQ.'SY'))
     *   CUTOFF = -1000.0
      CALL FILL (MAXANT, 0, NUMPTS)
C                                       Do not treat the weight for TY
C                                       and PC because these tables do
C                                       not have weight's collumn
      XTYPE = HBLANK
      CALL CHR2H (2, TYPE, 1, XTYPE)
C                                       Integers
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      IVER = IROUND (XNVER)
      PCNUM = IROUND (XPCNUM)
      IF (PCNUM.LE.0) PCNUM = 1
C                                       plot types
      REREF = (OPTYPE.EQ.'RPHS') .OR. (OPTYPE.EQ.'RDLY')
      IF (REREF) THEN
         REFANT = XREF + 0.1
         IF (OPTYPE.EQ.'RPHS') OPTYPE = 'PHAS'
         IF (OPTYPE.EQ.'RDLY') OPTYPE = 'DELA'
         BSYM = MAX (1, BSYM)
         IF (REFANT.LE.0) THEN
            MSGTXT = 'OPTYPE ''RPHS'' REQUIRES A REFANT'
            CALL MSGWRT (8)
            IERR = 10
            GO TO 999
            END IF
         END IF
      ICODE = 1
      DO 30 I = 1,NCODE
         IF (OPTYPE.EQ.CODE(I)) ICODE = I
 30      CONTINUE
      CALL CHR2H (4, CODE(ICODE), 1, XOPTY)
      NCODES = 1
      ICODES(1) = ICODE
C                                       Time range
      TSTART = XTIME(1) + (XTIME(2) / 24.0) + (XTIME(3) / (24.0*60.0)) +
     *   (XTIME(4) / (24.0*3600.0))
      TSTOP = XTIME(5) + (XTIME(6) / 24.0) + (XTIME(7) / (24.0*60.0)) +
     *   (XTIME(8) / (24.0*3600.0))
      IF (TSTART.GE.TSTOP) THEN
         TSTART = 0.0
         TSTOP = 999.0
         END IF
C                                       Find input catalog
      CNOIN = 1
      TYPTMP = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, TYPTMP,
     *   NLUSER, STAT, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      'UV', NLUSER
         GO TO 990
         END IF
C                                       Save name class etc.
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
      XDISIN = DISKIN
      XSIN = SEQIN
C                                       Read catalog header
      STAT = 'READ'
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, STAT, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FCNO(NCFILE) = CNOIN
      FVOL(NCFILE) = DISKIN
      FRW(NCFILE) = 0
      XDISIN = DISKIN
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 990
      SEQIN = CATBLK(KIIMS)
      XSIN = SEQIN
C                                       Subarray
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.EQ.0) SUBARR = 1
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.GE.0) THEN
         LUN = 25
         CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *      FRQSEL, IERR)
         IF (.NOT.MATCH) THEN
            WRITE (MSGTXT,1070)
            IERR = 1
            GO TO 990
            END IF
         IF (IERR.GT.0) GO TO 999
         END IF
C                                       IF'S
      IF (JLOCIF.GE.0) THEN
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, CATBLK(KINAX+JLOCIF)))
         EIF = IROUND (XEIF)
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         IF (EIF.GT.CATBLK(KINAX+JLOCIF)) EIF = CATBLK(KINAX+JLOCIF)
      ELSE
         BIF = 1
         EIF = 1
         END IF
C                                       Look up sources
      NID = 500
      NSOUR = 30
      MSGSUP = 32000
      CALL SOURNU (XSOUR, QUAL, NSOUR, DISKIN, CNOIN, NID, BUFFER, SID,
     *   JERR)
      MSGSUP = 0
      IF (JERR.LT.0) THEN
         MSGTXT = 'SPECIFIED SOURCE(S) NOT FOUND - CONTINUING'
         CALL MSGWRT (6)
         END IF
      IF (JERR.NE.0) NID = 0
C                                       Check antennas desired.
      NANTSL = 0
      DOAWNT = T
      DO 70 J = 1,50
         ANTS(J) = IROUND (XANT(J))
         IF (ANTS(J).LT.0) DOAWNT = F
C                                       Make positive
         ANTS(J) = ABS (ANTS(J))
         IF (NANTSL.LT.1) GO TO 60
            DO 50 K = 1,NANTSL
               IF (ANTS(J).EQ.ANTS(K)) ANTS(J) = 0
 50            CONTINUE
C                                       Check for multiple entries
 60      IF (ABS (ANTS(J)).GE.1) NANTSL = J
 70      CONTINUE
C                                       Make sure not too many
      IF (NANTSL.GT.MAXANT) NANTSL = MAXANT
C                                       need REFANT to rereference
      IF ((NANTSL.GT.0) .AND. (REREF)) THEN
         K = 0
         DO 75 J = 1,NANTSL
            IF (ANTS(J).EQ.REFANT) K = J
 75         CONTINUE
         IF (DOAWNT) THEN
            IF (K.EQ.0) THEN
               NANTSL = NANTSL + 1
               ANTS(NANTSL) = REFANT
               MSGTXT = 'YOU LEFT OUT REFANT - FIXING THAT'
               CALL MSGWRT (7)
               END IF
         ELSE
            IF (K.GT.0) THEN
               ANTS(K) = 0
               IF (K.EQ.NANTSL) NANTSL = NANTSL - 1
               MSGTXT = 'YOU INCLUDED REFANT TO BE AVOIDED - FIXING'
               CALL MSGWRT (7)
               END IF
            END IF
         END IF
C                                       Get antenna names
      CALL GETANT (DISKIN, CNOIN, MAX (1, SUBARR), CATBLK, BUFFER, JERR)
      MUMANT = NSTNS
      IF (MUMANT.LE.1) THEN
         MUMANT = MAXANT
         TIMLAB = 'IAT'
         END IF
      CALL JULDAY (RDATE, JD0)
C                                       Rate scaling to Hz
      DO 80 I = BIF,EIF
         RATFAC(I-BIF+1) = FREQ
 80      CONTINUE
      IF ((OPTYPE.EQ.'RATE') .OR. (ISTYPE(4))) THEN
         VER = 1
         LUN = 25
         IF (FRQSEL.LE.0) FRQTMP = 1
         IF (FRQSEL.GT.0) FRQTMP = FRQSEL
         CALL CHNDAT ('READ', BUFFER, DISKIN, CNOIN, VER, CATBLK, LUN,
     *      NIF, FOFF, ISBAND, FINC, BNDCOD, FRQTMP, JERR)
         IF (JERR.EQ.0) THEN
            DO 85 I = BIF,EIF
               RATFAC(I-BIF+1) = FREQ + FOFF(I)
 85         CONTINUE
            END IF
         END IF
C                                       Check Stokes' (R or IPOL)
C                                       Set stokes request
      NSTOK = CATBLK(KINAX+JLOCS)
      MUMPOL = 1
      IF ((ICOR0.EQ.1) .OR. (ICOR0.EQ.-2) .OR. (ICOR0.EQ.-6) .OR.
     *   (((ICOR0.EQ.-1) .OR. (ICOR0.EQ.-5)) .AND. (NSTOK.EQ.1))) THEN
         ISTOK = ABS (ICOR0)
         SUMSTK = 1
         XSTOK = 'I'
         IF (ICOR0.EQ.-2) XSTOK='L'
         IF (ICOR0.EQ.-1) XSTOK='R'
      ELSE IF (ICOR0.EQ.-1) THEN
         IF ((XSTOK.EQ.'R') .OR. (XSTOK.EQ.'RR')) THEN
            ISTOK = 1
            SUMSTK = 1
            XSTOK = 'R'
         ELSE IF ((XSTOK.EQ.'L') .OR. (XSTOK.EQ.'LL')) THEN
            ISTOK = 2
            SUMSTK = 2
            XSTOK = 'L'
         ELSE
            ISTOK = 1
            SUMSTK = 0
            XSTOK = 'R&L'
            IF (ICODES(1).NE.6) MUMPOL = 2
            END IF
      ELSE IF (ICOR0.EQ.-5) THEN
         IF ((XSTOK.EQ.'V') .OR. (XSTOK.EQ.'VV')) THEN
            ISTOK = 1
            SUMSTK = 1
            XSTOK = 'V'
         ELSE IF ((XSTOK.EQ.'H') .OR. (XSTOK.EQ.'HH')) THEN
            ISTOK = 2
            SUMSTK = 2
            XSTOK = 'H'
         ELSE
            ISTOK = 1
            SUMSTK = 0
            XSTOK = 'V&H'
            IF (ICODES(1).NE.6) MUMPOL = 2
            END IF
         END IF
      CALL CHR2H (4, XSTOK, 1, XXSTOK)
C                                       Open table to check
C                                       Open SN, CL, TY or PC table
      IF ((TYPE.EQ.'SN') .OR. (TYPE.EQ.'CL') .OR. (TYPE.EQ.'TY') .OR.
     *   (TYPE.EQ.'PC') .OR. (TYPE.EQ.'SY')) THEN
         CALL SNPOPN (NROWS, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Invalid table type
      ELSE
         IERR = 5
         MSGTXT = 'INVALID TABLE TYPE =' // TYPE
         GO TO 990
         END IF
C                                       Get TCals
      IF ((TYPE.EQ.'SY') .AND. (ISTYPE(23))) THEN
         J = 0
         CALL GETCDS (DISKIN, CNOIN, J, SUBARR, FRQSEL, CATBLK, TCAL,
     *      JERR)
         IF (JERR.NE.0) GO TO 999
         END IF
      XNVER = IVER
      MUMIF = EIF - BIF + 1
      IF (ITPLOT.GE.4) MUMIF = 1
      IF (ICODES(1).EQ.6) MUMIF = 1
      XBIF = BIF
      XEIF = EIF
      CSMAX = -100000
      CSMIN = 1000000
      CALL RFILL (MAXANT, 1.E5, XXMIN)
      CALL RFILL (MAXANT, -1.E5, XXMAX)
      I = 2 * MAXIF * MAXANT
      CALL RFILL (I, 1.E8, PPMIN)
      CALL RFILL (I, -1.E8, PPMAX)
      I = I * 10
      CALL RFILL (I, 1.E8, YYMIN)
      CALL RFILL (I, -1.E8, YYMAX)
      CALL RFILL (10, -1.E8, YYMX)
      CALL RFILL (10,  1.E8, YYMN)
      NOSCAN = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR;',I7,'GETTING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',I3,
     *   ' TYPE=',A2,' USER=',I4)
 1040 FORMAT ('ERROR',I3,' COPYING CATALOG HEADER')
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
      END
      SUBROUTINE SNPOPN (NROWS, IERR)
C-----------------------------------------------------------------------
C   Routine to open SN, CL, PC, TY, SY table and get necessary
C   information
C   Input from Common:
C      TYPE     C*2  'SN', 'CL', 'PC', 'TY', SY
C      DISKIN   I     Disk number
C      CNOIN    I     Catalog slot number
C      CATBLK   I(*)  Catalog header
C      SUMSTK   I     Stokes type requested 0=both, 1=R, 2=L,
C   Output:
C      IERR     I     Error code, 0=OK else failed.
C   Output in common:
C      ICLRNO       I    Current cal record number
C      NCLINR       I    Number of gain records in file.
C      NUMANT       I    Number of antennas
C      NUMPOL       I    Number of polarizations
C      NUMIF        I    Number of IFs.
C      ITVER        I    Version number opened.
C      KOLS         I(*) Column pointers
C      KOLTYP       I(*) Column data types
C      KOLDIM       I(*) Column dimension
C-----------------------------------------------------------------------
      INTEGER   NROWS, IERR
      INCLUDE 'SNRMS.INC'
C
      INTEGER MAXPCC
      PARAMETER (MAXPCC = 40)
      CHARACTER KEYW(4)*8, COLHD1(11)*24, COLHD2(13)*24, COLHD3(13)*24,
     *   COLTAB(40)*24, COLHED(37)*24, COLPC(MAXPCC)*24, KEYSN(4)*8,
     *   KEYPC(3)*8, COLPC1(20)*24, COLPC2(20)*24
      INTEGER   NKEY, NREC, NCOL, DATP(128,2), IPOINT, KEYTYP(4),
     *   KLOCS(4), KEYVAL(6), I, KP, MSGSAV
      LOGICAL   T, ISTYPE, DOM
      REAL      KEYVR(6)
      DOUBLE PRECISION KEYVAD
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      EQUIVALENCE (KEYVAL, KEYVR)
      EQUIVALENCE (COLHED(1), COLHD1), (COLHED(12), COLHD2),
     *   (COLHED(25), COLHD3)
      EQUIVALENCE (COLPC(1), COLPC1), (COLPC(21), COLPC2)
      DATA COLHD1 /'TIME                    ',
     *   'TIME INTERVAL           ',
     *   'SOURCE ID               ', 'ANTENNA NO.             ',
     *   'SUBARRAY                ', 'FREQ ID                 ',
     *   'I.FAR.ROT               ',
     *   'GEODELAY                ', 'DOPPOFF                 ',
     *   'ATMOS                   ', 'DATMOS                  '/
      DATA COLHD2 /'MBDELAY1      ',
     *   'REAL1                   ', 'IMAG1                   ',
     *   'RATE 1                  ', 'DELAY 1                 ',
     *   'WEIGHT 1                ', 'REFANT 1                ',
     *   'TSYS 1                  ', 'TANT 1                  ',
     *   'CLOCK 1                 ', 'DCLOCK 1                ',
     *   'DISP 1                  ', 'DDISP 1                 '/
      DATA COLHD3 /'MBDELAY2      ',
     *   'REAL2                   ', 'IMAG2                   ',
     *   'RATE 2                  ', 'DELAY 2                 ',
     *   'WEIGHT 2                ', 'REFANT 2                ',
     *   'TSYS 2                  ', 'TANT 2                  ',
     *   'CLOCK 2                 ', 'DCLOCK 2                ',
     *   'DISP 2                  ', 'DDISP 2                 '/
      DATA COLPC1 /'TIME                ',
     *   'TIME_INTERVAL           ', 'SOURCE_ID               ',
     *   'ANTENNA_NO              ', 'ARRAY                   ',
     *   'FREQID                  ', 'DUM1                    ',
     *   'DUM2                    ', 'DUM3                    ',
     *   'DUM4                    ', 'DUM5                    ',
     *   'PC_FREQ 1               ', 'PC_REAL 1               ',
     *   'PC_IMAG 1               ', 'PC_RATE 1               ',
     *   'DUM6                    ', 'DUM7                    ',
     *   'DUM8                    ', 'DUM9                    ',
     *   'DUM10                   ' /
      DATA COLPC2 /'DUM11                   ',
     *   'DUM12                   ', 'DUM13                   ',
     *   'DUM14                   ', 'PC_FREQ 2               ',
     *   'PC_REAL 2               ', 'PC_IMAG 2               ',
     *   'PC_RATE 2               ', 'DUM15                   ',
     *   'DUM16                   ', 'DUM17                   ',
     *   'DUM18                   ', 'DUM19                   ',
     *   'DUM20                   ', 'DUM21                   ',
     *   'DUM22                   ', 'DUM23                   ',
     *   'CABLE_CAL               ', 'STATE 1                 ',
     *   'STATE 2                 ' /
      DATA KEYSN /'NO_ANT  ', 'NO_POL  ', 'NO_IF   ','MGMOD   '/
      DATA KEYPC /'NO_POL  ', 'NO_BAND ', 'NO_TONES' /
      DATA T /.TRUE./
C-----------------------------------------------------------------------
      IF (TYPE.EQ.'SY') THEN
         DO 110 I = 1,NCODES
            IF ((ICODES(I).LT.18) .OR. (ICODES(I).GT.25)) THEN
               MSGTXT = 'DATA OF REQUESTED TYPE NOT IN SY TABLES'
               IERR = 5
               GO TO 980
               END IF
 110        CONTINUE
         END IF
      IF ((ISTYPE(3)) .AND. ((TYPE.EQ.'TY') .OR. (TYPE.EQ.'PC'))) THEN
         MSGTXT = 'NO SINGLEBAND DELAY IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ISTYPE(4)) .AND. (TYPE.EQ.'TY')) THEN
         MSGTXT = 'NO RESIDUAL RATE IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ISTYPE(5)) .AND. (TYPE.NE.'TY')) THEN
         MSGTXT = 'NO TSYS IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ISTYPE(7)) .AND. (TYPE.NE.'CL')) THEN
         MSGTXT = 'NO DOPPLER OFFSET IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ISTYPE(8)) .AND. ((TYPE.EQ.'TY') .OR. (TYPE.EQ.'PC'))) THEN
         MSGTXT = 'NO SNR IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ISTYPE(9)) .AND. ((TYPE.EQ.'TY') .OR. (TYPE.EQ.'PC'))) THEN
         MSGTXT = 'NO MULTIBAND DELAY IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ISTYPE(10)) .AND. (TYPE.NE.'TY')) THEN
         MSGTXT = 'NO TANT IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ISTYPE(11)) .AND. (TYPE.NE.'CL')) THEN
         MSGTXT = 'NO ATMOS. DELAY IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ISTYPE(12)) .AND. (TYPE.NE.'CL')) THEN
         MSGTXT = 'NO GEOM. DELAY IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ISTYPE(13)) .AND. (TYPE.NE.'PC')) THEN
         MSGTXT = 'NO CABLE CAL IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ISTYPE(14)) .AND. (TYPE.NE.'CL') .AND. (TYPE.NE.'SN')) THEN
         MSGTXT = 'NO DISP. DELAY IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
      IF ((ISTYPE(17)) .AND. (TYPE.NE.'CL') .AND. (TYPE.NE.'SN')) THEN
         MSGTXT = 'NO FARADAY ROT. IN THIS TABLE TYPE - CHECK INEXT'
         IERR = 5
         GO TO 980
         END IF
C                                       Open table
      ICLUN = 28
      NKEY = 0
      NREC = 0
      NCOL = 0
      ICLRNO = 1
      CALL TABINI ('READ', TYPE, DISKIN, CNOIN, IVER, CATBLK, ICLUN,
     *   NKEY, NREC, NCOL, DATP, CLBUFF, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1100) IERR, TYPE, IVER
         GO TO 980
         END IF
      ITVER = IVER
C                                       Get number of scans
      NCLINR = CLBUFF(5)
      NROWS = NCLINR
C                                       Check if empty
      IF (NCLINR.LE.0) THEN
         IERR = 6
         MSGTXT = 'ERROR: SELECTED TABLE IS EMPTY'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Get column pointers
      NKEY = 40
      IF (TYPE.EQ.'PC') NKEY = MAXPCC
      DO 10 I = 1,NKEY
         IF (TYPE.EQ.'PC') THEN
            COLTAB(I) = COLPC(I)
         ELSE
            COLTAB(I) = COLHED(I)
            END IF
 10      CONTINUE
C                                       SY uses Re/Im/Wt for
C                                       DIF, SUM, GAIN
      IF (TYPE.EQ.'SY') THEN
         COLTAB(13) = 'POWER DIF1'
         COLTAB(14) = 'POWER SUM1'
         COLTAB(17) = 'POST GAIN1'
         COLTAB(21) = 'CAL TYPE'
         COLTAB(26) = 'POWER DIF2'
         COLTAB(27) = 'POWER SUM2'
         COLTAB(30) = 'POST GAIN2'
         COLTAB(34) = 'CAL TYPE'
         END IF
      CALL FNDCOL (NKEY, COLTAB, 24, T, CLBUFF, KOLS, IERR)
      IF ((IERR.GE.1) .AND. (IERR.LE.10)) GO TO 999
      IERR = 0
C                                       Time column logical number
      CLTIME = KOLS(1)
C                                       Convert to pointers, types
      DO 20 I = 1,NKEY
         KP = KOLS(I)
         IF (KP.GT.0) THEN
            KOLS(I) = DATP(KP,1)
            KOLTYP(I) = MOD (DATP(KP,2), 10)
            KOLDIM(I) = DATP(KP,2) / 10
         ELSE
            KOLS(I) = -1
            KOLTYP(I) = -1
            KOLDIM(I) = 0
            END IF
 20      CONTINUE
C                                       Table keywords
      NKEY = 4
      IF (TYPE.EQ.'PC') NKEY = 3
      DO 30 I = 1,NKEY
         IF (TYPE .EQ. 'PC') THEN
            KEYW(I) = KEYPC(I)
         ELSE
            KEYW(I) = KEYSN(I)
            END IF
 30      CONTINUE
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL TABKEY ('READ', KEYW, NKEY, CLBUFF, KLOCS, KEYVAL, KEYTYP,
     *   IERR)
      MSGSUP = MSGSAV
      IF ((IERR.GE.1) .AND. (IERR.LE.20)) GO TO 999
      IERR = 0
C                                       Retrieve keyword values: PC
      IF (TYPE.EQ.'PC') THEN
         NUMANT = NSTNS
         GMMOD = 1.0
C                                       No. poln.
         NUMPOL = 1
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. IF
         NUMIF = 1
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       No. tones
         NTONE = 1
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) NTONE = KEYVAL(IPOINT)
C                                       Retrieve keyword values: other
      ELSE
         NTONE = 1
C                                       No. antennas.
         NUMANT = NSTNS
         IPOINT = KLOCS(1)
         IF (IPOINT.GT.0) NUMANT = KEYVAL(IPOINT)
C                                       No. poln.
         NUMPOL = 1
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. IF
         NUMIF = 1
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       Mean gain modulus
         GMMOD = 1.0
         IPOINT = KLOCS(4)
         IF (IPOINT.GT.0) THEN
            IF (KEYTYP(4).EQ.1) THEN
               CALL DPCOPY (1, KEYVR(IPOINT), KEYVAD)
            ELSE
               KEYVAD = KEYVR(IPOINT)
               END IF
            IF (KEYVAD.GT.0.0) GMMOD = 1.0 / KEYVAD
            END IF
         END IF
C                                       Set pointers
      DOPKOL = DOPKOL + BIF - 1
      DOP3KL = DOPKOL + EIF - 1
      DOPLKL = DOPKOL
      IF (TYPE.NE.'PC') PCNUM = 1
      IF (PCNUM.GT.NTONE) PCNUM = 1
      PCNUM = MAX (1, PCNUM)
C                                       1st poln
      IF ((ISTOK.EQ.ABS (ICOR0)) .OR. (ISTOK.EQ.ABS (ICOR0+4))) THEN
         MBKOL(1) = MB1KOL
         REKOL(1) = RE1KOL + ((BIF-1) * NTONE) + PCNUM - 1
         IMKOL(1) = IM1KOL + ((BIF-1) * NTONE) + PCNUM - 1
         DLKOL(1) = DL1KOL + BIF - 1
         RAKOL(1) = RA1KOL + BIF - 1
         WTKOL(1) = WT1KOL + BIF - 1
         RFKOL(1) = RF1KOL + BIF - 1
         TSKOL(1) = TS1KOL + BIF - 1
         TAKOL(1) = TA1KOL + BIF - 1
         CKKOL(1) = CK1KOL
         DCKOL(1) = DC1KOL
         DSKOL(1) = DS1KOL
         DDKOL(1) = DD1KOL
         STKOL(1) = ST1KOL + BIF - 1
C                                       2nd poln
      ELSE
         MBKOL(1) = MB2KOL
         REKOL(1) = RE2KOL + ((BIF-1) * NTONE) + PCNUM - 1
         IMKOL(1) = IM2KOL + ((BIF-1) * NTONE) + PCNUM - 1
         DLKOL(1) = DL2KOL + BIF - 1
         RAKOL(1) = RA2KOL + BIF - 1
         WTKOL(1) = WT2KOL + BIF - 1
         RFKOL(1) = RF2KOL + BIF - 1
         TSKOL(1) = TS2KOL + BIF - 1
         TAKOL(1) = TA2KOL + BIF - 1
         CKKOL(1) = CK2KOL
         DCKOL(1) = DC2KOL
         DSKOL(1) = DS2KOL
         DDKOL(1) = DD2KOL
         STKOL(1) = ST2KOL + BIF - 1
         END IF
C                                       2nd Poln
      MBKOL(2) = MB2KOL
      REKOL(2) = RE2KOL + ((BIF-1) * NTONE) + PCNUM - 1
      IMKOL(2) = IM2KOL + ((BIF-1) * NTONE) + PCNUM - 1
      DLKOL(2) = DL2KOL + BIF - 1
      RAKOL(2) = RA2KOL + BIF - 1
      WTKOL(2) = WT2KOL + BIF - 1
      RFKOL(2) = RF2KOL + BIF - 1
      TSKOL(2) = TS2KOL + BIF - 1
      TAKOL(2) = TA2KOL + BIF - 1
      CKKOL(2) = CK2KOL
      DCKOL(2) = DC2KOL
      DSKOL(2) = DS2KOL
      DDKOL(2) = DD2KOL
      STKOL(2) = ST2KOL + BIF - 1
C                                       Phase, amplitude, summary
      DOM = .FALSE.
      IF ((ISTYPE(1)) .OR. (ISTYPE(2)) .OR. (ISTYPE(6))
     *      .OR. (ISTYPE(15)) .OR. (ISTYPE(16))
     *      .OR. (ISTYPE(24)) .OR. (ISTYPE(25))) THEN
         IF ((REKOL(1).LT.0) .AND. (IMKOL(1).LT.0)) GO TO 500
         IF (((MUMPOL.EQ.2)) .AND. ((REKOL(2).LT.0) .OR.
     *      (IMKOL(2).LT.0))) GO TO 500
         END IF
C                                       Singleband Delay
      IF (ISTYPE(3)) THEN
         IF (DLKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (DLKOL(2).LT.0)) GO TO 500
         END IF
C                                       Rate
      IF (ISTYPE(4)) THEN
         IF (RAKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (RAKOL(2).LT.0)) GO TO 500
         END IF
C                                       System temperature
      IF (ISTYPE(5)) THEN
         IF (TSKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (TSKOL(2).LT.0)) GO TO 500
         END IF
C                                       Doppler offset
      IF (ISTYPE(7)) THEN
         IF (DOPLKL.LT.0) GO TO 500
C                                       Only 1 value
         MUMPOL = 1
         SUMSTK = 0
         BIF = 1
         EIF = 1
         CUTOFF = -1000.0
         END IF
C                                       SNR
      IF (ISTYPE(8)) THEN
         IF (WTKOL(1).LT.0) GO TO 500
         IF ((SUMSTK.GE.3) .AND. (WTKOL(2).LT.0)) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (WTKOL(2).LT.0)) GO TO 500
         END IF
C                                       MDEL (multiband delay)
      IF (ISTYPE(9)) THEN
         IF (MBKOL(1).LT.0) GO TO 500
         IF ((SUMSTK.GE.3) .AND. (MBKOL(2).LT.0)) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (MBKOL(2).LT.0)) GO TO 500
C                                       Only 1 per poln
         BIF = 1
         EIF = 1
         CUTOFF = -1000.0
         END IF
C                                       IF Antenna Temp
      IF (ISTYPE(10)) THEN
         IF (TAKOL(1).LT.0) GO TO 500
         IF ((SUMSTK.GE.3) .AND. (TAKOL(2).LT.0)) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (TAKOL(2).LT.0)) GO TO 500
         END IF
C                                       Atmosphere
      IF (ISTYPE(11)) THEN
         IF (ATMKOL.LT.0) GO TO 500
C                                       Only 1 value
         MUMPOL = 1
         SUMSTK = 0
         BIF = 1
         EIF = 1
         CUTOFF = -1000.0
         END IF
C                                       If geometric delay
      IF (ISTYPE(12)) THEN
         IF (WTKOL(1).LT.0) GO TO 500
C                                       Only 1 value
         MUMPOL = 1
         SUMSTK = 0
         BIF = 1
         EIF = 1
         CUTOFF = -1000.0
         END IF
C                                       If cable cal
      IF (ISTYPE(13)) THEN
         IF (CABKOL.LT.0) GO TO 500
C                                       Only 1 value
         MUMPOL = 1
         SUMSTK = 0
         BIF = 1
         EIF = 1
         CUTOFF = -1000.0
         END IF
C                                       DDLY (dispersive delay)
      IF (ISTYPE(14)) THEN
         IF (DSKOL(1).LT.0) GO TO 500
         IF ((SUMSTK.GE.3) .AND. (DSKOL(2).LT.0)) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (DSKOL(2).LT.0)) GO TO 500
C                                       Only 1 per poln
         BIF = 1
         EIF = 1
         CUTOFF = -1000.0
         SUMSTK = MIN (SUMSTK, 3)
         END IF
C                                       Ionospheric Faraday rotation
      IF (ISTYPE(17)) THEN
         IF (IFRKOL.LT.0) GO TO 500
C                                       Only 1 value
         MUMPOL = 1
         BIF = 1
         EIF = 1
         CUTOFF = -1000.0
         END IF
C                                       SY Pdif
      IF (ISTYPE(18)) THEN
         IF (REKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (REKOL(2).LT.0)) GO TO 500
         END IF
C                                       SY Psum
      IF (ISTYPE(19)) THEN
         IF (IMKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (IMKOL(2).LT.0)) GO TO 500
         END IF
C                                       SY post gain
      IF (ISTYPE(20)) THEN
         IF (WTKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (WTKOL(2).LT.0)) GO TO 500
         END IF
C                                       SY Pon and Poff
      IF ((ISTYPE(21)) .OR. (ISTYPE(22))) THEN
         IF (REKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (REKOL(2).LT.0)) GO TO 500
         IF (IMKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (IMKOL(2).LT.0)) GO TO 500
         IF (WTKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (WTKOL(2).LT.0)) GO TO 500
         END IF
C                                       SY TSYS
      IF (ISTYPE(23)) THEN
         IF (REKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (REKOL(2).LT.0)) GO TO 500
         IF (IMKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (IMKOL(2).LT.0)) GO TO 500
         END IF
      GO TO 999
C                                       Requested data not in table
 500  WRITE(MSGTXT,1500) OPTYPE, TYPE
      IERR = 10
      GO TO 980
C                                       Error
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ERROR ',I3,' OPENING ',A,' TABLE NO. ',I3)
 1500 FORMAT (' REQUESTED DATA ',A,' NOT IN ',A,' TABLE ')
      END
      LOGICAL FUNCTION ISTYPE (FTYPE)
C-----------------------------------------------------------------------
C   ISTYPE inquires if type in list of requested types
C   Inputs:
C      FTYPE    I   Test type
C   Output:
C      ISTYPE   L   T => TYPE in ICODES
C-----------------------------------------------------------------------
      INTEGER   FTYPE
C
      INTEGER   I
      INCLUDE 'SNRMS.INC'
C-----------------------------------------------------------------------
      ISTYPE = .FALSE.
      DO 10 I = 1,NCODES
         IF (ICODES(I).EQ.FTYPE) ISTYPE = .TRUE.
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SNPCNT (NWORDS, IERR)
C-----------------------------------------------------------------------
C   SNPCNT reads the SN or CL table to find the number of samples for
C   each antenna
C   Input:
C      NWORDS   I      Size of work array
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NWORDS, IERR
C
      INCLUDE 'SNRMS.INC'
      LOGICAL   NODATA, OKAY
      INTEGER   I, NP, IFNUM, SCNT(MXSCAN)
      REAL      TB, TE, GTIME, XVARIB, CSOU
      REAL      VALUE(2*MAXIF,10)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      CALL FILL (MAXANT, 0, NANREC)
      CALL FILL (MXSCAN, 0, SCNT)
      NODATA = .TRUE.
      TB = 1.0E5
      TE = -1.0E5
      XVAR = 1
      IF ((XVAR.EQ.1) .AND. (TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TB = TSTART
         TE = TSTOP
         END IF
      XMX = TE
      XMN = TB
      XMXW = TE
      XMNW = TB
C                                       Loop thru data
      TINT = -1.0
      IF (INTKOL.LE.0) TINT = 10.0 / 86400.0
      NP = MUMPOL * MUMIF
      DO 100 ICLRNO = 1,NCLINR
         CALL TABIO ('READ', 0, ICLRNO, GNREC, CLBUFF, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
C                                       Solution interval
         IF (TINT.LE.0) TINT = GNREC(INTKOL)
C                                       Check weight per IF
C                                       If weight < CUTOFF them
C                                       set amp, phase, delay and
C                                       rate to FBLANK FOR EACH IF
         IF ((CUTOFF.GE.0.0) .AND. (WT1KOL.GT.0)) THEN
            IF (NUMPOL.EQ.2) THEN
               IF ((SUMSTK.EQ.0) .OR. (SUMSTK.GE.3)) THEN
                  DO 5 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(1) + IFNUM) = FBLANK
                       GNREC(IMKOL(1) + IFNUM) = FBLANK
                       GNREC(DLKOL(1) + IFNUM) = FBLANK
                       GNREC(RAKOL(1) + IFNUM) = FBLANK
                       ENDIF
                    IF (GNREC(WTKOL(2) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(2) + IFNUM) = FBLANK
                       GNREC(IMKOL(2) + IFNUM) = FBLANK
                       GNREC(DLKOL(2) + IFNUM) = FBLANK
                       GNREC(RAKOL(2) + IFNUM) = FBLANK
                       ENDIF
5                 CONTINUE
               ELSE IF (SUMSTK.EQ.1) THEN
                  DO 15 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(1) + IFNUM) = FBLANK
                       GNREC(IMKOL(1) + IFNUM) = FBLANK
                       GNREC(DLKOL(1) + IFNUM) = FBLANK
                       GNREC(RAKOL(1) + IFNUM) = FBLANK
                       ENDIF
15                CONTINUE
               ELSE IF (SUMSTK.EQ.2) THEN
                  DO 25 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(2) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(2) + IFNUM) = FBLANK
                       GNREC(IMKOL(2) + IFNUM) = FBLANK
                       GNREC(DLKOL(2) + IFNUM) = FBLANK
                       GNREC(RAKOL(2) + IFNUM) = FBLANK
                       ENDIF
25                CONTINUE
                  END IF
               END IF
            IF (NUMPOL.EQ.1) THEN
                  DO 35 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(1) + IFNUM) = FBLANK
                       GNREC(IMKOL(1) + IFNUM) = FBLANK
                       GNREC(DLKOL(1) + IFNUM) = FBLANK
                       GNREC(RAKOL(1) + IFNUM) = FBLANK
                       ENDIF
35                CONTINUE
               END IF
            END IF
C                                       Record within specified
C                                       time range ?
         IF (KOLTYP(CLTIME).EQ.1) THEN
            GTIME = GNRECD(TIMKOL)
         ELSE
            GTIME = GNREC(TIMKOL)
            END IF
         IF ((GTIME.LT.TSTART) .OR. (GTIME.GT.TSTOP)) GO TO 100
C                                       Freq id
         IF ((GNRECI(FRQKOL).GT.0) .AND. (GNRECI(FRQKOL).NE.FRQSEL)
     *      .AND. (FRQSEL.GT.0)) GO TO 100
C                                       Subarray
         IF (TYPE.NE.'PC') THEN
            IF ((GNRECI(SUBKOL).GT.0) .AND. (SUBARR.GT.0) .AND.
     *         (GNRECI(SUBKOL).NE.SUBARR)) GO TO 100
            END IF
C                                       Antenna?
         IANT = GNRECI(ANTKOL)
         IF (NANTSL.GT.0) THEN
            DO 50 I = 1,NANTSL
               IF ((IANT.EQ.ANTS(I)).AND.DOAWNT) GO TO 60
               IF ((IANT.EQ.ANTS(I)).AND.(.NOT.DOAWNT)) GO TO 100
 50            CONTINUE
            IF (DOAWNT) GO TO 100
            END IF
C                                       Check source
 60      IF (NID.GT.0) THEN
            ISOU = GNRECI(SOUKOL)
            DO 70 I = 1,NID
               IF (ISOU.EQ.SID(I)) GO TO 80
 70            CONTINUE
            GO TO 100
            END IF
C                                      Get start, stop times
 80      TB = MIN (TB, GTIME)
         TE = MAX (TE, GTIME)
C                                       Get value
         CALL SNPDAT (VALUE, XVARIB, CSOU, OKAY)
C                                       Max. - Min
         IF (((OKAY) .OR. (BSYM.GT.0)) .AND. (XVARIB.NE.FBLANK)) THEN
            IF (OKAY) NODATA = .FALSE.
            NANREC(IANT) = NANREC(IANT) + 1
            I = CSOU + 0.1
            IF ((I.GT.0) .AND. (I.LE.MXSCAN)) SCNT(I) = SCNT(I) + 1
            END IF
 100     CONTINUE
      IERR = MAX (0, IERR)
      FANREC(1) = 1
      MAXREC = NANREC(1)
      DO 120 I = 2,MAXANT
         FANREC(I) = FANREC(I-1) + NANREC(I-1)
         MAXREC = MAX (MAXREC, NANREC(I))
 120     CONTINUE
      IF (NWORDS.LT.FANREC(MAXANT)+NANREC(MAXANT)) THEN
         MSGTXT = 'MEMORY TOO SMALL'
         IERR = 10
         END IF
C                                       source number translation
      NP = 0
      CALL FILL (MXSCAN, 0, STRANS)
      DO 130 I = 1,MXSCAN
         IF (SCNT(I).GT.0) THEN
            NP = NP + 1
            STRANS(I) = NP
            END IF
 130     CONTINUE
C
 990  IF (IERR.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SNPCNT: ERROR =',I3,' FROM TABIO')
      END
      SUBROUTINE SNPMAX (NV, PLTPTS, IERR)
C-----------------------------------------------------------------------
C   SNPMAX reads the SN or CL table to find the max and min values for
C   each station or IF prior to plotting.
C   Input:
C      NV       I      Number values per time (source, T, X, n*Y)
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      PLTPTS   R(*)   Data to be plotted (NV, *)
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NV, IERR
      REAL      PLTPTS(NV,*)
C
      LOGICAL   NODATA, OKAY
      INTEGER   I, NP, NN, IP, IIF, IIS, IFNUM, IS, KK
      REAL      TB, TE, TMAX, TMIN, GTIME, XVARIB, CSOU, TEMP
      INCLUDE 'SNRMS.INC'
      REAL      VALUE(2*MAXIF,10)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      NODATA = .TRUE.
      TB = 1.0E5
      TE = -1.0E5
      IF ((XVAR.EQ.1) .AND. (TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TB = TSTART
         TE = TSTOP
         END IF
      XMX = TE
      XMN = TB
      XMXW = TE
      XMNW = TB
C                                       Loop thru data
      TINT = -1.0
      IF (INTKOL.LE.0) TINT = 10.0 / 86400.0
      NP = MUMPOL * MUMIF
      DO 100 ICLRNO = 1,NCLINR
         CALL TABIO ('READ', 0, ICLRNO, GNREC, CLBUFF, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
C                                       Solution interval
         IF (TINT.LE.0) TINT = GNREC(INTKOL)
C                                       Check weight per IF
C                                       If weight < CUTOFF them
C                                       set amp, phase, delay and
C                                       rate to FBLANK FOR EACH IF
         IF ((CUTOFF.GE.0.0) .AND. (WT1KOL.GT.0)) THEN
            IF (NUMPOL.EQ.2) THEN
               IF ((SUMSTK.EQ.0) .OR. (SUMSTK.GE.3)) THEN
                  DO 5 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(1) + IFNUM) = FBLANK
                       GNREC(IMKOL(1) + IFNUM) = FBLANK
                       GNREC(DLKOL(1) + IFNUM) = FBLANK
                       GNREC(RAKOL(1) + IFNUM) = FBLANK
                       ENDIF
                    IF (GNREC(WTKOL(2) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(2) + IFNUM) = FBLANK
                       GNREC(IMKOL(2) + IFNUM) = FBLANK
                       GNREC(DLKOL(2) + IFNUM) = FBLANK
                       GNREC(RAKOL(2) + IFNUM) = FBLANK
                       ENDIF
5                 CONTINUE
               ELSE IF (SUMSTK.EQ.1) THEN
                  DO 15 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(1) + IFNUM) = FBLANK
                       GNREC(IMKOL(1) + IFNUM) = FBLANK
                       GNREC(DLKOL(1) + IFNUM) = FBLANK
                       GNREC(RAKOL(1) + IFNUM) = FBLANK
                       ENDIF
15                CONTINUE
               ELSE IF (SUMSTK.EQ.2) THEN
                  DO 25 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(2) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(2) + IFNUM) = FBLANK
                       GNREC(IMKOL(2) + IFNUM) = FBLANK
                       GNREC(DLKOL(2) + IFNUM) = FBLANK
                       GNREC(RAKOL(2) + IFNUM) = FBLANK
                       ENDIF
25                CONTINUE
                  END IF
               END IF
            IF (NUMPOL.EQ.1) THEN
                  DO 35 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(1) + IFNUM) = FBLANK
                       GNREC(IMKOL(1) + IFNUM) = FBLANK
                       GNREC(DLKOL(1) + IFNUM) = FBLANK
                       GNREC(RAKOL(1) + IFNUM) = FBLANK
                       ENDIF
35                CONTINUE
               END IF
            END IF
C                                       Record within specified
C                                       time range ?
         IF (KOLTYP(CLTIME).EQ.1) THEN
            GTIME = GNRECD(TIMKOL)
         ELSE
            GTIME = GNREC(TIMKOL)
            END IF
         IF ((GTIME.LT.TSTART) .OR. (GTIME.GT.TSTOP)) GO TO 100
C                                       Freq id
         IF ((GNRECI(FRQKOL).GT.0) .AND. (GNRECI(FRQKOL).NE.FRQSEL)
     *      .AND. (FRQSEL.GT.0)) GO TO 100
C                                       Subarray
         IF (TYPE.NE.'PC') THEN
            IF ((GNRECI(SUBKOL).GT.0) .AND. (SUBARR.GT.0) .AND.
     *         (GNRECI(SUBKOL).NE.SUBARR)) GO TO 100
            END IF
C                                       Antenna?
         IANT = GNRECI(ANTKOL)
         IF (NANTSL.GT.0) THEN
            DO 50 I = 1,NANTSL
               IF ((IANT.EQ.ANTS(I)).AND.DOAWNT) GO TO 60
               IF ((IANT.EQ.ANTS(I)).AND.(.NOT.DOAWNT)) GO TO 100
 50            CONTINUE
            IF (DOAWNT) GO TO 100
            END IF
C                                       Check source
 60      IF (NID.GT.0) THEN
            ISOU = GNRECI(SOUKOL)
            DO 70 I = 1,NID
               IF (ISOU.EQ.SID(I)) GO TO 80
 70            CONTINUE
            GO TO 100
            END IF
C                                      Get start, stop times
 80      TB = MIN (TB, GTIME)
         TE = MAX (TE, GTIME)
C                                       Get value
         CALL SNPDAT (VALUE, XVARIB, CSOU, OKAY)
C                                       Max. - Min
         IF (((OKAY) .OR. (BSYM.GT.0)) .AND. (XVARIB.NE.FBLANK)) THEN
            IF (OKAY) NODATA = .FALSE.
C                                       Put in array
            NUMPTS(IANT) = NUMPTS(IANT) + 1
            NN = FANREC(IANT) + NUMPTS(IANT) - 1
            IS = CSOU + 0.1
            IF ((IS.GT.0) .AND. (IS.LE.MXSCAN)) CSOU = STRANS(IS)
            PLTPTS(1,NN) = CSOU
            PLTPTS(2,NN) = GTIME
            PLTPTS(3,NN) = XVARIB
            KK = 4
            DO 81 I = 1,NCODES
               CALL RCOPY (NP, VALUE(1,I), PLTPTS(KK,NN))
               KK = KK + NP
 81            CONTINUE
            IF (ICODES(1).EQ.6) CALL RCOPY (NP, VALUE(1,2),
     *         PLTPTS(KK,NN))
            IF (XVAR.NE.6) THEN
               XMX = MAX (XMX, XVARIB)
               XMN = MIN (XMN, XVARIB)
            ELSE
               TEMP = XVARIB
               IF (TEMP.LT.0.0) TEMP = TEMP + 360.
               XMX = MAX (XMX, TEMP)
               XMN = MIN (XMN, TEMP)
               IF (TEMP.GT.180.0) TEMP = TEMP - 360
               XMXW = MAX (XMXW, TEMP)
               XMNW = MIN (XMNW, TEMP)
               END IF
            XXMAX(IANT) = MAX (XXMAX(IANT), XVARIB)
            XXMIN(IANT) = MIN (XXMIN(IANT), XVARIB)
            CSMIN = MIN (CSMIN, CSOU)
            CSMAX = MAX (CSMAX, CSOU)
C                                       If not a summary plot
            DO 95 KK = 1,NCODES
               IP = 0
               DO 90 IIF = 1,MUMIF
                  DO 85 IIS = 1,MUMPOL
                     IP = IP + 1
                     IF (VALUE(IP,KK).NE.FBLANK) THEN
                        YYMX(KK) = MAX (YYMX(KK), VALUE(IP,KK))
                        YYMN(KK) = MIN (YYMN(KK), VALUE(IP,KK))
                        IF (ICODES(KK).EQ.1) THEN
                           IF (VALUE(IP,KK).LE.-180.0) THEN
                              VALUE(IP,KK) = VALUE(IP,KK) + 360.
                           ELSE IF (VALUE(IP,KK).GT.180.) THEN
                              VALUE(IP,KK) = VALUE(IP,KK) - 360.
                              END IF
                           YYMIN(IIS,IIF,IANT,KK) = MIN (VALUE(IP,KK),
     *                        YYMIN(IIS,IIF,IANT,KK))
                           YYMAX(IIS,IIF,IANT,KK) = MAX (VALUE(IP,KK),
     *                        YYMAX(IIS,IIF,IANT,KK))
                           IF (VALUE(IP,KK).LT.0.0) VALUE(IP,KK) =
     *                        VALUE(IP,KK) + 360.0
                           PPMIN(IIS,IIF,IANT) = MIN (VALUE(IP,KK),
     *                        PPMIN(IIS,IIF,IANT))
                           PPMAX(IIS,IIF,IANT) = MAX (VALUE(IP,KK),
     *                        PPMAX(IIS,IIF,IANT))
                        ELSE IF (ICODES(KK).EQ.6) THEN
                           YYMIN(1,1,1,KK) = MIN (VALUE(IP,KK),
     *                        YYMIN(1,1,1,KK))
                           YYMAX(1,1,1,KK) = MAX (VALUE(IP,KK),
     *                        YYMAX(1,1,1,KK))
                           IF (VALUE(IP,2).LE.-180.0) THEN
                              VALUE(IP,2) = VALUE(IP,2) + 360.
                           ELSE IF (VALUE(IP,2).GT.180.) THEN
                              VALUE(IP,2) = VALUE(IP,2) - 360.
                              END IF
                           YYMIN(2,1,1,KK) = MIN (VALUE(IP,2),
     *                        YYMIN(2,1,1,KK))
                           YYMAX(2,1,1,KK) = MAX (VALUE(IP,2),
     *                        YYMAX(2,1,1,KK))
                           IF (VALUE(IP,2).LT.0.0) VALUE(IP,2) =
     *                        VALUE(IP,2) + 360.
                           PPMIN(1,1,1) = MIN (VALUE(IP,2),
     *                        PPMIN(1,1,1))
                           PPMAX(1,1,1) = MAX (VALUE(IP,2),
     *                        PPMAX(1,1,1))
                        ELSE
                           YYMIN(IIS,IIF,IANT,KK) = MIN (VALUE(IP,KK),
     *                        YYMIN(IIS,IIF,IANT,KK))
                           YYMAX(IIS,IIF,IANT,KK) = MAX (VALUE(IP,KK),
     *                        YYMAX(IIS,IIF,IANT,KK))
                           END IF
                        END IF
 85                  CONTINUE
 90               CONTINUE
 95            CONTINUE
            END IF
 100     CONTINUE
      IERR = MAX (0, IERR)
C                                       Set actual X range
      SWAP = .FALSE.
      IF (XVAR.EQ.1) THEN
         XSTART = TB
         XSTOP = TE
      ELSE IF (XVAR.EQ.6) THEN
         IF (XMX-XMN.LE.XMXW-XMNW) THEN
            XSTART = XMN
            XSTOP  = XMX
         ELSE
            XSTART = XMNW
            XSTOP  = XMXW
            SWAP = .TRUE.
            END IF
      ELSE
         XSTART = XMN
         XSTOP  = XMX
         END IF
C                                       Check for no data
      IF (NODATA) THEN
         IERR = 6
         MSGTXT = 'NO DATA SELECTED'
         GO TO 990
         END IF
C                                       check and set scaling
      IF ((XVAR.EQ.1) .AND. (TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TMAX = (XSTOP + 0.03 * (XSTOP - XSTART)) * 360.0
         TMIN = (XSTART- 0.03 * (XSTOP - XSTART)) * 360.0
      ELSE IF ((XVAR.EQ.1) .OR. (XVAR.EQ.3) .OR. (XVAR.EQ.4)) THEN
         TMAX = (XSTOP + 0.1 * (XSTOP - XSTART)) * 360.0
         TMIN = (XSTART- 0.1 * (XSTOP - XSTART)) * 360.0
      ELSE
         TMAX = (XSTOP + 0.1 * (XSTOP - XSTART))
         TMIN = (XSTART- 0.1 * (XSTOP - XSTART))
         END IF
C                                       If start time is stop time,
      IF (ABS (TMAX-TMIN) .LT. 0.01) THEN
         TMIN = MAX( TMIN-0.005, 0.0)
         TMAX = TMIN + 0.01
         END IF
      TSTART = TB
      TSTOP = TE
      XYOFF(1) = TMIN
      XYSCL(1) = 1000.0 / (TMAX - TMIN)
      PRAN(1,1) = TMIN
      PRAN(2,1) = TMAX
C                                       Send back time range
      XTIME(1) = TSTART
      XTIME(2) = 0.0
      XTIME(3) = 0.0
      XTIME(4) = 0.0
      XTIME(5) = TSTOP
      XTIME(6) = 0.0
      XTIME(7) = 0.0
      XTIME(8) = 0.0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SNPMAX: ERROR =',I3,' FROM TABIO')
      END
      SUBROUTINE SNPREF (NV, PLTPTS, IERR)
C-----------------------------------------------------------------------
C   SNPMAX re-references the phases in PLTPTS and recomputes min/max
C   Input:
C      NV       I      Number values per time (source, T, X, n*Y)
C   In/Output:
C      PLTPTS   R(*)   Data to be plotted (NV, *)
C   Outputs
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NV, IERR
      REAL      PLTPTS(NV,*)
C
      INTEGER   JANT, IA, IR, NREC, NMISS, NP, I, IP, IIF, IIS, IREC,
     *   RREC, JREC
      REAL      EPS, PH
      INCLUDE 'SNRMS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA EPS /1.E-6/
C-----------------------------------------------------------------------
      NP = MUMPOL * MUMIF
      I = 2 * MAXIF * MAXANT
      CALL RFILL (I, 1.E8, PPMIN)
      CALL RFILL (I, -1.E8, PPMAX)
      I = I * 10
      CALL RFILL (I, 1.E8, YYMIN)
      CALL RFILL (I, -1.E8, YYMAX)
      CALL RFILL (10, -1.E8, YYMX)
      CALL RFILL (10,  1.E8, YYMN)
C                                       loop over all antennas except
      RREC = NUMPTS(REFANT)
      DO 50 JANT = 1,MUMANT
         NMISS = 0
         IF (JANT.EQ.REFANT) GO TO 50
         IA = FANREC(JANT) - 1
         NREC = NUMPTS(JANT)
         DO 40 IREC = 1,NREC
            IA = IA + 1
C                                       seek a match
            IR = FANREC(REFANT) - 1
            DO 10 JREC = 1,RREC
               IR = IR + 1
               IF ((PLTPTS(1,IR).EQ.PLTPTS(1,IA)) .AND.
     *            (ABS(PLTPTS(2,IR)-PLTPTS(2,IA)).LE.EPS)) GO TO 15
 10            CONTINUE
C                                       not match
            NMISS = NMISS + 1
            CALL RFILL (NP, FBLANK, PLTPTS(3,IA))
            GO TO 40
C                                       close enough
 15         IP = 3
            DO 30 IIF = 1,MUMIF
               DO 20 IIS = 1,MUMPOL
                  IP = IP + 1
                  IF ((PLTPTS(IP,IR).EQ.FBLANK) .OR.
     *               (PLTPTS(IP,IA).EQ.FBLANK)) THEN
                     PLTPTS(IP,IA) = FBLANK
C                                       phase
                  ELSE IF (ICODES(1).EQ.1) THEN
                     PH = PLTPTS(IP,IA) - PLTPTS(IP,IR)
                     IF (PH.LT.-180.0) PH = PH + 360.0
                     IF (PH.GT.180.0) PH = PH - 360.0
                     PLTPTS(IP,IA) = PH
                     YYMX(1) = MAX (YYMX(1), PH)
                     YYMN(1) = MIN (YYMN(1), PH)
                     YYMIN(IIS,IIF,JANT,1) = MIN (PH,
     *                  YYMIN(IIS,IIF,JANT,1))
                     YYMAX(IIS,IIF,JANT,1) = MAX (PH,
     *                  YYMAX(IIS,IIF,JANT,1))
                     IF (PH.LT.0.0) PH = PH + 360.0
                     PPMIN(IIS,IIF,JANT) = MIN (PH,
     *                  PPMIN(IIS,IIF,JANT))
                     PPMAX(IIS,IIF,JANT) = MAX (PH,
     *                  PPMAX(IIS,IIF,JANT))
C                                       delay
                  ELSE
                     PH = PLTPTS(IP,IA) - PLTPTS(IP,IR)
                     PLTPTS(IP,IA) = PH
                     YYMX(1) = MAX (YYMX(1), PH)
                     YYMN(1) = MIN (YYMN(1), PH)
                     YYMIN(IIS,IIF,JANT,1) = MIN (PH,
     *                  YYMIN(IIS,IIF,JANT,1))
                     YYMAX(IIS,IIF,JANT,1) = MAX (PH,
     *                  YYMAX(IIS,IIF,JANT,1))
                     END IF
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
         IF (NMISS.GT.0) THEN
            WRITE (MSGTXT,1090) NMISS, NREC, JANT
            CALL MSGWRT (7)
            END IF
 50      CONTINUE
C                                       zero out refant
      IR = FANREC(REFANT) - 1
      NREC = NUMPTS(REFANT)
      JANT = REFANT
      DO 80 IREC = 1,NREC
         IR = IR + 1
         IP = 3
         DO 70 IIF = 1,MUMIF
            DO 60 IIS = 1,MUMPOL
               IP = IP + 1
               IF (PLTPTS(IP,IR).NE.FBLANK) THEN
                  PLTPTS(IP,IR) = 0.0
                  YYMIN(IIS,IIF,JANT,1) = 0.0
                  YYMAX(IIS,IIF,JANT,1) = 0.0
                  PPMIN(IIS,IIF,JANT) = 0.0
                  PPMAX(IIS,IIF,JANT) = 0.0
                  END IF
 60            CONTINUE
 70         CONTINUE
 80      CONTINUE
C
      IERR = 0
 999  RETURN
C-----------------------------------------------------------------------
 1090 FORMAT ('Points misaligned',I6,' of',I7,' antenna',I4)
      END
      SUBROUTINE GETSCL (KK, LST1, LST2, LIF1, LIF2, LANT, DOIT)
C-----------------------------------------------------------------------
C   GETSCL converts a number of max/min's to a scale
C   Inputs:
C      KK      I   parameter number
C      LST1    I   1st Stokes
C      LST2    I   Upper Stokes
C      LIF1    I   1st IF number
C      LIF2    I   1st IF number
C      LANT    I   Antenna number
C   Output:
C      DOIT    L      There were valid values
C   Output in common
C      XYSCL   R(2)   Scaling - only 2nd one changed
C      XYOFF   R(2)   Offset  - only second one changed
C-----------------------------------------------------------------------
      INTEGER   KK, LST1, LST2, LIF1, LIF2, LANT
      LOGICAL   DOIT
C
      INCLUDE 'SNRMS.INC'
      INTEGER   IST, IIF
      REAL      YMX, YMN, PMX, PMN, TMAX, TMIN, TDIF, TOLER(30), SIZEY
C                                       Minimum value range for each
C                                       ICODE
C                  phs    amp    delay    rate    Tsys Summary doppler
      DATA TOLER /0.001, 0.001, 1.0E-12, 1.0E-8, 0.001,  0.01,  0.001,
C                  snr  MB delay   Tant    Atm dly  geo dly  ccal
     *            0.001, 1.0E-12, 0.000001, 1.0E-12, 1.0E-12, 1.0E-14,
C                  ddely   real   imag  Faraday Pdif   Psum   Pgn
     *            1.0E-12, 0.001, 0.001, 0.005, 0.001, 0.001, 1.E-5,
C                 Pon   Poff  Psys   PDgain PSgain
     *            0.01, 0.01, 0.01,  0.001, 0.001, 5*0.0/
C-----------------------------------------------------------------------
      DOIT = .FALSE.
      YMX = -1.E8
      YMN = -YMX
      PMX = YMX
      PMN = YMN
      DO 30 IIF = LIF1,LIF2
         DO 20 IST = LST1,LST2
            IF (YYMAX(IST,IIF,LANT,KK).GE.YYMIN(IST,IIF,LANT,KK)) THEN
               DOIT = .TRUE.
               YMX = MAX (YMX, YYMAX(IST,IIF,LANT,KK))
               YMN = MIN (YMN, YYMIN(IST,IIF,LANT,KK))
               IF (ICODES(KK).EQ.1) THEN
                  PMX = MAX (PMX, PPMAX(IST,IIF,LANT))
                  PMN = MIN (PMN, PPMIN(IST,IIF,LANT))
                  END IF
               END IF
 20         CONTINUE
 30      CONTINUE
      IF ((ICODES(KK).EQ.1) .AND. (PMX-PMN.LT.YMX-YMN)) THEN
         YMX = PMX
         YMN = PMN
         END IF
      SIZEY = 1000.0 / NCOUNT
      TMAX = YMX + 0.1 * (YMX - YMN)
      TMIN = YMN - 0.1 * (YMX - YMN)
      IF (ABS (TMAX-TMIN) .LT. TOLER(ICODES(KK))) THEN
         TMAX = TMAX + TOLER(ICODES(KK))
         TMIN = TMIN - TOLER(ICODES(KK))
         END IF
      TDIF = TMAX - TMIN
      IF (ABS (TDIF).LE.1.0E-25) TDIF = 1.0E-25
      XYOFF(2) = TMIN
      XYSCL(2) = 1000.0 / TDIF / NCOUNT
      PRAN(1,2) = TMIN
      PRAN(2,2) = TMAX
C
 999  RETURN
      END
      SUBROUTINE SNPDAT (VALUE, XVARIB, CSOU, OKAY)
C-----------------------------------------------------------------------
C   Routine to get the specified value from a SN/CL/TY table entry
C   Input from common:
C      GNREC    R(*)  Table record
C      ICODE    I     Plot code
C      SUMSTK   I     Selected Stokes 0=both, 1=R, 2=L, 3=Difference
C   Also uses pointers etc. set in SNPOPN
C   Output:
C      VALUE    R(*)   Table value, magic value blanked (amp on ICODE 6)
C      XVARIB   R      Value of associated x-axis variable
C      CSOU     R      source number
C      OKAY     L      Some values are good
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      REAL      VALUE(2*MAXIF,*), XVARIB, CSOU
      LOGICAL   OKAY
C
      INTEGER   IIS, IIF, IP1, IP2, LP, JP1, JP2, KP1, KK, ICODE,
     *   JIF
      REAL      AVAL, PVAL, AM, PH, V, S, TC
      LOGICAL   T, GOT
      INCLUDE 'SNRMS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       In case the data is bad
      LP = MUMPOL * MUMIF
      CALL XCALC (XVARIB, CSOU)
      DO 900 KK = 1,NCODES
         ICODE = ICODES(KK)
         CALL RFILL (LP, FBLANK, VALUE(1,KK))
C                                       Select data type
C                                       Phase (deg)
         IF (ICODE.EQ.1) THEN
            DO 110 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = REKOL(IIS) - NTONE
               JP1 = IMKOL(IIS) - NTONE
               IF (ITPLOT.GE.4) THEN
                  IP2 = REKOL(IIS+2) - NTONE
                  JP2 = IMKOL(IIS+2) - NTONE
               ELSE
                  IP2 = REKOL(2) - NTONE
                  JP2 = IMKOL(2) - NTONE
                  END IF
               DO 105 IIF = 1,MUMIF
                  IP1 = IP1 + NTONE
                  JP1 = JP1 + NTONE
                  IP2 =  IP2 + NTONE
                  JP2 = JP2 + NTONE
                  LP = LP + MUMPOL
                  IF ((GNREC(IP1).NE.FBLANK) .AND.
     *               (GNREC(JP1).NE.FBLANK)) THEN
                     VALUE(LP,KK) = 57.296 *
     *                  ATAN2 (GNREC(JP1), GNREC(IP1) + 1.0E-20)
                     END IF
 105              CONTINUE
 110           CONTINUE
C                                       Amplitude
         ELSE IF (ICODE.EQ.2) THEN
            DO 130 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = REKOL(IIS) - NTONE
               JP1 = IMKOL(IIS) - NTONE
               IF (ITPLOT.GE.4) THEN
                  IP2 = REKOL(IIS+2) - NTONE
                  JP2 = IMKOL(IIS+2) - NTONE
               ELSE
                  IP2 = REKOL(2) - NTONE
                  JP2 = IMKOL(2) - NTONE
                  END IF
               DO 125 IIF = 1,MUMIF
                  IP1 = IP1 + NTONE
                  JP1 = JP1 + NTONE
                  IP2 =  IP2 + NTONE
                  JP2 = JP2 + NTONE
                  LP = LP + MUMPOL
                  IF ((GNREC(IP1).NE.FBLANK) .AND.
     *               (GNREC(JP1).NE.FBLANK)) THEN
                     VALUE(LP,KK) = GMMOD *
     *                  SQRT ((GNREC(IP1)**2) + (GNREC(JP1)**2))
                     END IF
 125              CONTINUE
 130           CONTINUE
C                                       Delay (sec)
         ELSE IF (ICODE.EQ.3) THEN
            DO 150 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = DLKOL(IIS) - 1
               IF (ITPLOT.GE.4) THEN
                  IP2 = DLKOL(IIS+2) - 1
               ELSE
                  IP2 = DLKOL(2) - 1
                  END IF
               DO 145 IIF = 1,MUMIF
                  IP1 = IP1 + 1
                  IP2 =  IP2 + 1
                  LP = LP + MUMPOL
                  IF (GNREC(IP1).NE.FBLANK) THEN
                     VALUE(LP,KK) = GNREC(IP1)
                     END IF
 145              CONTINUE
 150           CONTINUE
C                                       Rate (Hz)
         ELSE IF (ICODE.EQ.4) THEN
            DO 170 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = RAKOL(IIS) - NTONE
               IF (ITPLOT.GE.4) THEN
                  IP2 = RAKOL(IIS+2) - NTONE
                  JIF = IP2 - IP1 + 1
               ELSE
                  IP2 = RAKOL(2) - NTONE
                  END IF
               DO 165 IIF = 1,MUMIF
                  IP1 = IP1 + NTONE
                  IP2 = IP2 + NTONE
                  LP = LP + MUMPOL
                  IF (SUMSTK.EQ.3) JIF = IIF
                  IF (GNREC(IP1).NE.FBLANK) THEN
                     VALUE(LP,KK) = GNREC(IP1) * RATFAC(IIF)
                     END IF
 165              CONTINUE
 170           CONTINUE
C                                       System temperature (K)
         ELSE IF (ICODE.EQ.5) THEN
            DO 190 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = TSKOL(IIS) - 1
               IP2 = IP1
               IF (ITPLOT.GE.4) THEN
                  IP2 = TSKOL(IIS+2) - 1
               ELSE
                  IP2 = TSKOL(2) - 1
                  END IF
               DO 185 IIF = 1,MUMIF
                  IP1 = IP1 + 1
                  IP2 =  IP2 + 1
                  LP = LP + MUMPOL
                  IF (ABS(GNREC(IP1)-999.0).LT.0.1) GNREC(IP1) = FBLANK
                  IF (ABS(GNREC(IP2)-999.0).LT.0.1) GNREC(IP2) = FBLANK
                  IF (GNREC(IP1).NE.FBLANK) THEN
                     VALUE(LP,KK) = GNREC(IP1)
                     END IF
 185              CONTINUE
 190           CONTINUE
C                                       Extreme amplitude or phase
C                                       Selected IF
         ELSE IF (ICODE.EQ.6) THEN
            AVAL = 0.0
            PVAL = 0.0
            GOT = .FALSE.
            DO 210 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = REKOL(IIS) - 1
               JP1 = IMKOL(IIS) - 1
               IP2 = REKOL(2) - 1
               JP2 = IMKOL(2) - 1
               DO 205 IIF = BIF,EIF
                  IP1 = IP1 + 1
                  JP1 = JP1 + 1
                  IP2 = IP2 + 1
                  JP2 = JP2 + 1
                  LP = LP + MUMPOL
                  IF ((GNREC(IP1).EQ.FBLANK) .OR.
     *               (GNREC(JP1).EQ.FBLANK)) GO TO 205
                  AM = SQRT ((GNREC(IP1)**2) + (GNREC(JP1)**2))
                  IF (ABS(AM).GT.ABS(AVAL)) AVAL = AM
                  PH = 57.296 * ATAN2 (GNREC(JP1),GNREC(IP1)+1.0E-20)
                  IF (ABS(PH).GT.ABS(PVAL)) PVAL = PH
                  GOT = T
                  IF ((NUMPOL.GT.1) .AND. (SUMSTK.EQ.0)) THEN
                     IF ((GNREC(IP2).NE.FBLANK) .AND.
     *                  (GNREC(JP2).NE.FBLANK)) THEN
                        AM = SQRT ((GNREC(IP2)**2)+(GNREC(JP2)**2))
                        IF (ABS(AM).GT.ABS(AVAL)) AVAL = AM
                        PH = 57.296 *
     *                     ATAN2 (GNREC(JP2), GNREC(IP2)+1.0E-20)
                        IF (ABS(PH).GT.ABS(PVAL)) PVAL = PH
                        END IF
                     END IF
 205              CONTINUE
 210           CONTINUE
            IF (GOT) THEN
               VALUE(1,KK) = AVAL
               VALUE(1,2) = PVAL
               END IF
C                                       Doppler offset (Hz)
         ELSE IF (ICODE.EQ.7) THEN
            IF (GNREC(DOPLKL).NE.FBLANK) THEN
               VALUE(LP,KK) = GNREC(DOPLKL)
               END IF
C                                       SNR (no units)
         ELSE IF (ICODE.EQ.8) THEN
            DO 250 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = WTKOL(IIS) - 1
               IP2 = WTKOL(2) - 1
               DO 245 IIF = 1,MUMIF
                  IP1 = IP1 + 1
                  IP2 =  IP2 + 1
                  LP = LP + MUMPOL
                  IF (GNREC(IP1).NE.FBLANK) THEN
                     VALUE(LP,KK) = GNREC(IP1)
                     END IF
 245              CONTINUE
 250           CONTINUE
C                                       Multiband Delay (sec)
         ELSE IF (ICODE.EQ.9) THEN
            DO 270 IIS = 1,MUMPOL
               LP = IIS
               IP1 = MBKOL(IIS)
               IP2 = MBKOL(2)
               IF (GNREC(IP1).NE.FBLANK) THEN
                  VALUE(LP,KK) = GNREC(IP1)
                  END IF
 270           CONTINUE
C                                       Tant (K)
         ELSE IF (ICODE.EQ.10) THEN
            DO 290 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = TAKOL(IIS) - 1
               DO 285 IIF = 1,MUMIF
                  IP1 = IP1 + 1
                  LP = LP + MUMPOL
                  IF (ABS(GNREC(IP1)-999.0).LT.0.1) GNREC(IP1) = FBLANK
                  IF (ABS(GNREC(IP2)-999.0).LT.0.1) GNREC(IP2) = FBLANK
                  IF (GNREC(IP1).NE.FBLANK) THEN
                     VALUE(LP,KK) = GNREC(IP1)
                     END IF
 285              CONTINUE
 290           CONTINUE
C                                       Atmos. Delay (sec)
         ELSE IF (ICODE.EQ.11) THEN
            IF (GNREC(ATMKOL).NE.FBLANK) VALUE(LP,KK) = GNREC(ATMKOL)
C                                       Geometric Delay (sec)
         ELSE IF (ICODE.EQ.12) THEN
            IF (GNRECD(GEOKOL).NE.DBLANK) VALUE(LP,KK) = GNRECD(GEOKOL)
C                                       Cable cal (sec)
         ELSE IF (ICODE.EQ.13) THEN
            IF (GNRECD(CABKOL).NE.DBLANK) VALUE(LP,KK) = GNRECD(CABKOL)
C                                       Dispersive Delay (sec)
         ELSE IF (ICODE.EQ.14) THEN
            DO 370 IIS = 1,MUMPOL
               LP = IIS
               IP1 = DSKOL(IIS)
               IF (GNREC(IP1).NE.FBLANK) THEN
                  VALUE(LP,KK) = GNREC(IP1)
                  END IF
 370           CONTINUE
C                                       REAL
         ELSE IF (ICODE.EQ.15) THEN
            DO 395 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = REKOL(IIS) - NTONE
               DO 390 IIF = 1,MUMIF
                  IP1 = IP1 + NTONE
                  LP = LP + MUMPOL
                  IF ( GNREC(IP1).NE.FBLANK ) THEN
                     VALUE(LP,KK) = GMMOD * GNREC(IP1)
                     END IF
 390              CONTINUE
 395           CONTINUE
C                                       IMAG
         ELSE IF (ICODE.EQ.16) THEN
            DO 420 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               JP1 = IMKOL(IIS) - NTONE
               DO 415 IIF = 1,MUMIF
                  JP1 = JP1 + NTONE
                  LP = LP + MUMPOL
                  IF (GNREC(JP1).NE.FBLANK) THEN
                     VALUE(LP,KK) = GMMOD * GNREC(JP1)
                     END IF
 415              CONTINUE
 420           CONTINUE
C                                       Atmos. Delay (sec)
         ELSE IF (ICODE.EQ.17) THEN
            IF (GNREC(IFRKOL).NE.FBLANK) VALUE(LP,KK) = GNREC(IFRKOL)
C                                       PDIF, PSUM, PGN
         ELSE IF ((ICODE.GE.18) .AND. (ICODE.LE.20)) THEN
            DO 430 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IF (ICODE.EQ.18) THEN
                  IP1 = REKOL(IIS) - NTONE
               ELSE IF (ICODE.EQ.19) THEN
                  IP1 = IMKOL(IIS) - NTONE
               ELSE
                  IP1 = WTKOL(IIS) - NTONE
                  END IF
               DO 425 IIF = 1,MUMIF
                  IP1 = IP1 + NTONE
                  LP = LP + MUMPOL
                  IF (GNREC(IP1).NE.FBLANK) THEN
                     VALUE(LP,KK) = GNREC(IP1)
                     END IF
 425               CONTINUE
 430           CONTINUE
C                                       PON, POFF
         ELSE IF ((ICODE.GE.21) .AND. (ICODE.LE.22)) THEN
            S = 1.0
            IF (ICODE.EQ.22) S = -1.0
            DO 440 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = REKOL(IIS) - NTONE
               JP1 = IMKOL(IIS) - NTONE
               KP1 = WTKOL(IIS) - NTONE
               DO 435 IIF = 1,MUMIF
                  IP1 = IP1 + NTONE
                  JP1 = JP1 + NTONE
                  KP1 = KP1 + NTONE
                  LP = LP + MUMPOL
                  IF ((GNREC(IP1).NE.FBLANK) .AND.
     *               (GNREC(JP1).NE.FBLANK).AND. (GNREC(KP1).NE.FBLANK)
     *               .AND.(GNREC(KP1).NE.0.0)) THEN
                     V = (GNREC(JP1) + S*GNREC(IP1)) / (2.0*GNREC(KP1))
                     VALUE(LP,KK) = V
                     END IF
 435              CONTINUE
 440           CONTINUE
C                                       PSYS = PSUM / PDIF = Tsys/Tcal
         ELSE IF (ICODE.EQ.23) THEN
            DO 450 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = REKOL(IIS) - NTONE
               JP1 = IMKOL(IIS) - NTONE
               DO 445 IIF = 1,MUMIF
                  IP1 = IP1 + NTONE
                  JP1 = JP1 + NTONE
                  LP = LP + MUMPOL
                  IF ((CKKOL(1).GT.0) .AND. (GNRECI(CKKOL(1)).EQ.1))
     *               THEN
                     TC = TCAL(ISTOK+IIS+1,IIF-1+BIF,IANT)
                  ELSE
                     TC = TCAL(ISTOK+IIS-1,IIF-1+BIF,IANT)
                     END IF
                  IF (TC.LE.0.0) TC = FBLANK
                  IF ((GNREC(IP1).NE.FBLANK) .AND.
     *               (GNREC(JP1).NE.FBLANK).AND. (GNREC(IP1).GT.0.0)
     *               .AND. (TC.NE.FBLANK)) THEN
                     V = GNREC(JP1) / GNREC(IP1) / 2.0 * TC
                     VALUE(LP,KK) = V
                     END IF
 445              CONTINUE
 450           CONTINUE
C                                       PDIF, PSUM corr by PGN
         ELSE IF ((ICODE.GE.24) .AND. (ICODE.LE.25)) THEN
            DO 460 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IF (ICODE.EQ.24) THEN
                  IP1 = REKOL(IIS) - NTONE
               ELSE
                  IP1 = IMKOL(IIS) - NTONE
                  END IF
               JP1 = WTKOL(IIS) - NTONE
               DO 455 IIF = 1,MUMIF
                  IP1 = IP1 + NTONE
                  JP1 = JP1 + NTONE
                  LP = LP + MUMPOL
                  IF ((GNREC(IP1).NE.FBLANK) .AND.
     *               (GNREC(JP1).NE.FBLANK)) THEN
                     V = 4096. * GNREC(JP1) * GNREC(JP1)
                     VALUE(LP,KK) = GNREC(IP1) / V
                     END IF
 455               CONTINUE
 460           CONTINUE
C                                       Gains as powers
         ELSE IF ((ICODE.EQ.26) .OR. (ICODE.EQ.27)) THEN
            DO 470 IIS = 1,MUMPOL
               LP = IIS - MUMPOL
               IP1 = REKOL(IIS) - NTONE
               JP1 = IMKOL(IIS) - NTONE
               DO 465 IIF = 1,MUMIF
                  IP1 = IP1 + NTONE
                  JP1 = JP1 + NTONE
                  LP = LP + MUMPOL
                  IF ((GNREC(IP1).NE.FBLANK) .AND.
     *               (GNREC(JP1).NE.FBLANK)) THEN
                     VALUE(LP,KK) = GMMOD *
     *                  ((GNREC(IP1)**2) + (GNREC(JP1)**2))
                     IF (VALUE(LP,KK).EQ.0.0) THEN
                        VALUE(LP,KK) = FBLANK
                     ELSE IF (ICODE.EQ.27) THEN
                        VALUE(LP,KK) = -10.0 * LOG10 (VALUE(LP,KK))
                     ELSE
                        VALUE(LP,KK) = 1.0 / VALUE(LP,KK)
                        END IF
                     END IF
 465              CONTINUE
 470           CONTINUE
            END IF
 900     CONTINUE
C
      OKAY = .TRUE.
      LP = MUMPOL * MUMIF
      DO 910 IIS = 1,LP
         IF (VALUE(IIS,KK).NE.FBLANK) GO TO 999
 910     CONTINUE
      OKAY = .FALSE.
C
 999  RETURN
      END
      SUBROUTINE SNPRNT (NV, NA, PLTPTS, STATS, IRET)
C-----------------------------------------------------------------------
C   SNPRNT the data thru calls to PRNTSN.
C   Input:
C      NV       I      Number values per antenna (source, T, X, Y data)
C      NA       I      Number antennas in data array
C      PLTPTS   R(*)   Data (NV,*)
C   Output:
C      IRET     I      Return code, 0=OK else failed
C-----------------------------------------------------------------------
      INTEGER   NV, NA, IRET
      REAL      PLTPTS(NV,*), STATS(*)
C
      INTEGER   IPLT, IIF, IIS
      INCLUDE 'SNRMS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       Now print
      DO 100 IPLT = 1,MUMANT
         DO 90 IIF = 1,MUMIF
            DO 80 IIS = 1,MUMPOL
               CALL PRNTSN (IIS, IIF, IPLT, NV, PLTPTS, STATS, IRET)
               IF (IRET.NE.0) GO TO 999
 80            CONTINUE
 90         CONTINUE
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE PRNTSN (LST, LIF, ANTNO, NV, PLTPTS, STATS, IRET)
C-----------------------------------------------------------------------
C   PLTSN actually prints the data.
C   Input:
C      LST      I      1st Stokes this plot
C      LIF      I      1st IF this plot
C      ANTNO    I      Antenna number
C      NV       I      Number values
C      PLTPTS   R(*)   Data to plot (NV,*)
C   Output:
C      STATS    R(*)   scratch buffer for medians
C      IRET     I      Return code, 0 => OK, otherwise abort.
C                       -1 => user request termination
C                        1 => failed to add to catalog
C                        2 => failed to create
C                        3 => graph file write error
C                        4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   LST, LIF, ANTNO, NV, IRET
      REAL      PLTPTS(NV,*), STATS(*)
C
      INCLUDE 'SNRMS.INC'
C
      CHARACTER CHTMP*18, AUNITS(NCODE+2)*8, LINE*256, SCRTCH*256,
     *   CHTYPE(NCODE+2)*16
      INTEGER   BUFFER(256), INCHAR, INP, I, NGOOD, JCODE, NN, IP, NNN,
     *   J, JTRIM, NBLANK, PAGE, LANTNO
      REAL      VALUE, MEDIAN, MED, MAD, XMAX, XMIN
      LOGICAL   T, F, FIRST
      DOUBLE PRECISION SUM, SUMS
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      SAVE FIRST, LANTNO
      DATA LANTNO /0/
      DATA T, F /.TRUE.,.FALSE./
      DATA AUNITS /'Degrees','Gain','Seconds','Hz','Kelvin',' ','Hz',
     *             'SNR', 'Seconds', 'Kelvin', 'Seconds', 'Seconds',
     *             'Seconds','Sec/m**2','Gain','Gain','Rad/m**2',
     *             'Counts', 'Counts', 'Gain', 'Counts', 'Counts',
     *             'Kelvin', 'Counts', 'Counts', 'Gain^-2', 'db',
     *             'Degrees', 'PCamp'/
      DATA CHTYPE /'Gain phs', 'Gain amp', 'Delay','Rate','Tsys',
     *             ' ', 'Doppler offset', 'SNR', 'Multiband delay',
     *             'Tant', 'Atmosphere delay', 'Geometric Delay',
     *             'Cable Cal','Dispersive delay', 'Real', 'Imag',
     *             'Ion. Faraday rot', 'Power difference',
     *             'Power sum', 'Post gain', 'Power NT on',
     *             'Power NT off', 'Tsys', 'Pdif/Pgain**2',
     *             'Psum/Pgain**2', 'Rel. Power', 'Power db',
     *             'Phase-cal Phase', 'Phase-cal Ampl'/
      DATA FIRST /.TRUE./
C-----------------------------------------------------------------------
      IRET = 0
C
      JCODE = ICODES(1)
      IF (TYPE.EQ.'PC') THEN
         IF (JCODE.EQ.1) JCODE = NCODE+1
         IF (JCODE.EQ.2) JCODE = NCODE+2
         END IF
C                                       Start printing
      IF (FIRST) THEN
C                                       Open "line printer"
         IF (OUTPRT.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
         LUNP = 3
         CALL LPOPEN (OUTPRT, DOCRT, LUNP, FINDP, NACROS, BUFFER, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING THE LINE PRINTER'
            GO TO 990
            END IF
         IF (DOTEX) NACROS = 256
C                                       TITLE ONE
         INCHAR = 16
         INP = 1
         TITL1 = CHTYPE(JCODE)
         IF (ICOR0.LT.-4) THEN
            IF (TITL1(1:3).EQ.'R-L') THEN
               TITL1(1:3) = 'V-H'
            ELSE IF (TITL1(:3).EQ.'R/L') THEN
               TITL1(1:3) = 'V/H'
               END IF
            END IF
         CALL CHTRIM (TITL1, INCHAR, TITL1, INP)
         INP = INP + 1
         IF (XVAR.EQ.1) THEN
            TITL1(INP:INP+16) = ' vs '// TIMLAB(1:3) // ' time for '
            INP = INP + 17
         ELSE IF (XVAR.EQ.2) THEN
            TITL1(INP:INP+17) = ' vs elevation for '
            INP = INP + 18
         ELSE IF (XVAR.EQ.3) THEN
            TITL1(INP:INP+10) = ' vs HA for '
            INP = INP + 11
         ELSE IF (XVAR.EQ.4) THEN
            TITL1(INP:INP+16) = ' vs LST time for '
            INP = INP + 17
         ELSE IF (XVAR.EQ.5) THEN
            TITL1(INP:INP+17) = ' vs parallactic angle for '
            INP = INP + 26
         ELSE IF (XVAR.EQ.6) THEN
            TITL1(INP:INP+17) = ' vs azimuth for '
            INP = INP + 16
            END IF
C                                       File name
         CALL H2CHR (18, KHIMNO, CATH(KHIMN), CHTMP)
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), CHTMP(13:18))
         CALL NAMEST (CHTMP, CATBLK(KIIMS), TITL1(INP:), INCHAR)
         CALL REFRMT (TITL1, ' ', INCHAR)
C                                       TITLE TWO
         WRITE (TITL2,2000)
         IF (DOTEX) WRITE (TITL2,2001)
         IPCNT = 998
         PAGE = 0
         FIRST = .FALSE.
         END IF
C                                       new ant
      IF (ANTNO.LE.LANTNO) THEN
         LINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 960
         LANTNO = ANTNO
         END IF
C                                       Loop
      IP = (LIF-1) * MUMPOL + LST + 3
      NGOOD = 0
      NBLANK = 0
      SUM = 0.0D0
      SUMS = 0.0D0
      MED = 0.0
      MAD = 0.0
      XMAX = -1.E10
      XMIN = 1.E10
C                                       Point plot
      DO 20 NN = 1,NUMPTS(ANTNO)
         NNN = NN - 1 + FANREC(ANTNO)
         VALUE = PLTPTS(IP,NNN)
         IF (VALUE.EQ.FBLANK) THEN
            NBLANK = NBLANK + 1
         ELSE
            NGOOD = NGOOD + 1
            STATS(NGOOD) = VALUE
            SUM = SUM + VALUE
            SUMS = SUMS + VALUE * VALUE
            XMAX = MAX (XMAX, VALUE)
            XMIN = MIN (XMIN, VALUE)
            END IF
 20      CONTINUE
C                                       average
      IF (NGOOD.GT.0) THEN
         SUM = SUM / NGOOD
         SUMS = SUMS / NGOOD - SUM * SUM
         IF (SUMS.GT.0.0) THEN
            SUMS = SQRT (SUMS)
         ELSE
            SUMS = -1.0D0
            END IF
         MED = MEDIAN (NGOOD, STATS)
         DO 30 I = 1,NGOOD
            STATS(I) = ABS (STATS(I) - MED)
 30         CONTINUE
         MAD = 1.4826 * MEDIAN (NGOOD, STATS)
         END IF
C                                       write it
      IF ((NGOOD.LE.0) .AND. (NBLANK.LE.0)) GO TO 999
      IF ((ABS(XMAX).GT.0.1) .AND. (ABS(XMAX).LT.1000000.) .AND.
     *   (XMIN.GT.-100000.)) THEN
         IF (DOTEX) THEN
            WRITE (LINE,2020) ANTNO, LIF+BIF-1, LST, NGOOD, XMAX, XMIN,
     *         SUM, SUMS, MED, MAD, NBLANK, STNNAM(ANTNO)
         ELSE
            WRITE (LINE,2030) ANTNO, LIF+BIF-1, LST, NGOOD, XMAX, XMIN,
     *         SUM, SUMS, MED, MAD, NBLANK, STNNAM(ANTNO)
            END IF
      ELSE
         IF (DOTEX) THEN
            WRITE (LINE,2021) ANTNO, LIF+BIF-1, LST, NGOOD, XMAX, XMIN,
     *         SUM, SUMS, MED, MAD, NBLANK, STNNAM(ANTNO)
         ELSE
            WRITE (LINE,2031) ANTNO, LIF+BIF-1, LST, NGOOD, XMAX, XMIN,
     *         SUM, SUMS, MED, MAD, NBLANK, STNNAM(ANTNO)
            END IF
         END IF
      J = JTRIM (LINE)
      CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *   LINE(:J), IPCNT, PAGE, SCRTCH, IRET)
      IF (IRET.EQ.0) GO TO 999
C
 960  WRITE (MSGTXT,1000) IRET, 'PRINTING'
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PRNTSN ERROR',I4,' ON ',A)
 2000 FORMAT ('Ant  IF S   Ngood        Max        Min        Avg',
     *   '        Rms     Median     Madrms  Nblank  Station')
 2001 FORMAT ('Ant &   IF &  S &    Ngood &         Max &         Min',
     *   ' &         Avg &         Rms &      Median &      Madrms & ',
     *   '  Nblank &   Station')
 2020 FORMAT (I3,' & ',I4,' & ',I2,' & ',I8,' & ',6(F11.3,' & '),I8,
     *   ' & ',2X,A)
 2021 FORMAT (I3,' & ',I4,' & ',I2,' & ',I8,' & ',6(1PE11.3,' & '),I8,
     *   ' & ',2X,A)
 2030 FORMAT (I3,I4,I2,I8,6F11.3,I8,2X,A)
 2031 FORMAT (I3,I4,I2,I8,6(1PE11.3),I8,2X,A)
      END
      SUBROUTINE XCALC (XVARIB, XSOU)
C-----------------------------------------------------------------------
C  Routine to use the source and antenna geometry information in order
C  to return the requested value of the x-variable against which the
C  data is to be plotted.
C  Inputs (in common):
C    XVAR        I       Type of variable to calculate:
C                        1 = time (easy)
C                        2 = source elevation
C                        3 = HA
C                        4 = LST
C                        5 = Parallactic angle
C                        6 = Azimuth
C  Output:
C    XVARIB      R       Value of requested variable
C                        Time, LST (days)
C                        Elevation, HA (degrees)
C    XSOU        I       source number
C----------------------------------------------------------------------
      REAL    XVARIB, XSOU
C
      REAL    HA, EL, PA, AZ, TT
      INTEGER IERR, ISLUN, CSOU, I
      DOUBLE PRECISION LST, TIME, LTIME, DRA, DDEC
      LOGICAL PLANET
      INCLUDE 'SNRMS.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      SAVE LTIME, DRA, DDEC
      DATA ISLUN /25/
      DATA LTIME /-1.D0/
C-----------------------------------------------------------------------
      CSOU = GNRECI(SOUKOL)
      XSOU = CSOU
C                                      Time
      IF (KOLTYP(CLTIME).EQ.1) THEN
         TIME = GNRECD(TIMKOL)
      ELSE
         TIME = GNREC(TIMKOL)
         END IF
      IF (XVAR.EQ.1) THEN
         XVARIB = TIME
         GO TO 999
         END IF
C
C                                      Get source parameters
      IF ((OSOU.EQ.-1) .OR. (CSOU.NE.OSOU) .OR.
     *   (ABS(TIME-LTIME).GT.1.E-6)) THEN
         I = MSGSUP
         MSGSUP = 32000
         TT = TIME
         CALL FNDCOO (0, JD0, CSOU, DISKIN, CNOIN, CATBLK, ISLUN, TT,
     *      DRA, DDEC, PLANET, IERR)
         MSGSUP = I
         OSOU = CSOU
         LTIME = TIME
         END IF
C                                      Geometry parameters
      CALL ANTGEO (IANT, TIME, DRA, DDEC, HA, EL, LST, PA, AZ)
      IF (XVAR.EQ.2) THEN
         XVARIB = EL * RAD2DG
      ELSE IF (XVAR.EQ.3) THEN
         XVARIB = HA / TWOPI
      ELSE IF (XVAR.EQ.4) THEN
         XVARIB = LST / TWOPI
      ELSE IF (XVAR.EQ.5) THEN
         XVARIB = PA * RAD2DG
      ELSE IF (XVAR.EQ.6) THEN
         XVARIB = AZ * RAD2DG
         IF (XVARIB.LT.0.0) XVARIB = XVARIB + 360.0
         END IF
      IF (EL.LT.0.0) XVARIB = FBLANK
C
 999  RETURN
      END
      SUBROUTINE ANTGEO (ANTNO, TIME, DRA, DDEC, HA, EL, ANTLST, PA, AZ)
C-----------------------------------------------------------------------
C   Subroutine to compute the apparent source elevations based on source
C   and antenna coordinates in common.  The routines GETANT and GETSOU
C   should be called before this routine to put the correct values in
C   the relevant commons.
C   Inputs:
C      ANTNO      I    Antenna number
C      TIME       D    Current data time (days).
C      DRA        D    Apparent RA of source
C      DDEC       D    Apparent Declination of source.
C   Input from common:
C      STNLAT     D(*) Antenna latitude (rad).
C      STNLON     D(*) Antenna east longitudes (rad).
C      GSTIAT     D    GST at IAT=0 of reference day (rad).
C      ROTIAT     D    Rotation of the earth rate in IAT.
C   Output:
C      HA         R    Source hour angle (rad)
C      EL         R    Source elevation (rad)
C      ANTLST     D    Antenna LST (rad)
C      PA         R    Parallactic angle (rad)
C      AZ         R    Azimuth (rad)
C-----------------------------------------------------------------------
      INTEGER   ANTNO
      DOUBLE PRECISION TIME, ANTLST, DRA, DDEC
      REAL      HA, EL, PA, AZ
C
      LOGICAL   ISVLA
      DOUBLE PRECISION HRANG, ARLONG, ARLAT, DARG, DARG2, DAZ
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANS.INC'
C-----------------------------------------------------------------------
C                                       Antenna LST
      ANTLST = GSTIAT + STNLON(ANTNO) + TIME * ROTIAT
C                                       Hour angle
      HRANG = ANTLST - DRA
      HRANG = DMOD (HRANG, TWOPI)
      IF (HRANG.GT.PI) HRANG = HRANG - TWOPI
      IF (HRANG.LT.-PI) HRANG = HRANG + TWOPI
      HA = HRANG
C                                       Elevation angle
      DARG = SIN (STNLAT(ANTNO)) * SIN (DDEC) + COS (STNLAT(ANTNO))
     *   * COS (DDEC) * COS (HRANG)
      EL = (PI/2.0D0 - ACOS (DARG))
C                                       AZ = ATAN2(SD*CL - CD*SL*CH,
C                                       CD*SH)
      DARG = SIN (DDEC) * COS (STNLAT(ANTNO)) -
     *       COS (DDEC) * SIN (STNLAT(ANTNO)) * COS(HRANG)
      DARG2 = COS (DDEC) * SIN (HRANG)
      DAZ = ATAN2 (DARG, DARG2)
      DAZ = MOD (DAZ - PI/2.0D0, TWOPI)
      IF (DAZ.LT.0.0D0) DAZ = DAZ + TWOPI
      AZ = DAZ
C                                       Is this the VLA?
      ISVLA = (ABS (CNTRX + 1.601162D6) .LE. 10.0D0) .AND.
     *   (ABS (CNTRY + 5.042003D6) .LE. 10.0D0) .AND.
     *   (ABS (CNTRZ - 3.554915D6) .LE. 10.0D0)
C                                       All VLA antennas have the same
C                                       parallactic angle.
      PA = 0.0
      IF (ISVLA) THEN
         ARLONG = ATAN2 (CNTRY, CNTRX)
         ARLAT = ASIN (CNTRZ / SQRT (CNTRX*CNTRX + CNTRY*CNTRY +
     *      CNTRZ*CNTRZ))
      ELSE
         ARLONG = STNLON(ANTNO)
         ARLAT = STNLAT(ANTNO)
         END IF
C                                       Dont compute Equatorial or space
      IF ((MNTYP(ANTNO).NE.1) .AND. (MNTYP(ANTNO).NE.2)) THEN
C                                       Antenna LST
         HRANG = GSTIAT + ARLONG + TIME * ROTIAT
C                                       Hour angle
         HRANG = HRANG - DRA
C                                       Parallactic angle
         PA = ATAN2 (COS (ARLAT) * SIN (HRANG),
     *     (SIN (ARLAT) * COS (DDEC) -
     *     COS (ARLAT) * SIN (DDEC) * COS(HRANG)))
C                                       EW-mount
         IF (MNTYP(ANTNO).EQ.3) THEN
            PA =  ATAN2 (COS(HRANG), SIN(HRANG)*SIN(DDEC))
C                                       Right  Nasmyth
         ELSE IF (MNTYP(ANTNO).EQ.4) THEN
            PA = PA + EL
C                                       Left Nasmyth
         ELSE IF (MNTYP(ANTNO).EQ.5) THEN
            PA = PA -EL
C                                       Right BWG
         ELSE IF (MNTYP(ANTNO).EQ.6) THEN
            PA = PA -AZ+EL
C                                       Left BWG
         ELSE IF (MNTYP(ANTNO).EQ.7) THEN
            PA = PA -EL+AZ
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZTPOPD (LUN, FCB, ANAME, MODE, IERR)
C-----------------------------------------------------------------------
C! open a pseudo-tape, sequential disk file for FITS
C# Z2 Tape FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999, 2001-2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Open a logical, sequential (pseudo-tape) disk file (exclusive use
C   and wait for availability are assumed) using random access Fortran
C   I/O.
C   Inputs:
C      FCB     I(*)   File I/O control block
C      ANAME   H*256  Physical file name
C      MODE    I      0 = 'READ' disk, 2 = 'WRIT' or read disk
C   Output:
C      IERR    I      Error return code: 0 = no error
C                        2 = file not found
C                        6 = other open errors
C                        7 = illegal file name (translation fails)
C                        8 = 'write' file already exists
C   Generic version -  LRECL in bytes, supports Digital in words too
C   Uses Fortran I/O - replace with C I/O for UNIX which will allow
C   files > 2 Gbyte.
C-----------------------------------------------------------------------
      INTEGER   LUN, FCB(*), MODE, IERR
      HOLLERITH ANAME(64)
C
      INTEGER   ITRIM, FLEN, IOSVAL, LREC
      LOGICAL   EXISTS
      CHARACTER PNAME*256, FILNAM*256, LSTAT*3
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
C-----------------------------------------------------------------------
      CALL H2CHR (256, 1, ANAME, PNAME)
C                                       Form full path name of file.
      CALL ZFULLN (PNAME, 'FITS', ' ', FILNAM, IERR)
      IF (IERR.NE.0) THEN
         IERR = 7
         GO TO 999
         END IF
      FLEN = ITRIM (FILNAM)
      IF (MSGSUP.NE.32000) THEN
         WRITE (MSGTXT,1000)
         CALL MSGWRT (2)
         WRITE (MSGTXT,1001) FILNAM(1:MIN (56, FLEN))
         CALL MSGWRT (2)
         IF (FLEN.GT.56) THEN
            WRITE (MSGTXT,1001) FILNAM(57:FLEN)
            CALL MSGWRT (2)
            END IF
         END IF
C                                       Check for existence of file.
      INQUIRE (FILE=FILNAM(:FLEN), EXIST=EXISTS)
C                                       Read only
      IF (MODE.EQ.0) THEN
         LSTAT = 'OLD'
C                                       File should already exist.
         IF (.NOT.EXISTS) THEN
            IERR = 2
            WRITE (MSGTXT,1010)
            END IF
C                                       Read and write
      ELSE
         LSTAT = 'NEW'
C                                       File should NOT already exist.
         IF (EXISTS) THEN
            IERR = 8
            WRITE (MSGTXT,1015)
            END IF
         END IF
C                                       Open the file for unformatted,
C                                       random access - RECL in bytes
      IF (IERR.EQ.0) THEN
         LREC = 2880
         IF ((SYSTYP.EQ.'VMS') .OR. (SYSTYP.EQ.'DEC') .OR.
     *      (SYSTYP.EQ.'ULTR')) LREC = LREC / 4
         OPEN (UNIT=LUN, FILE=FILNAM(:FLEN), ACCESS='DIRECT', RECL=LREC,
     *      FORM='UNFORMATTED', STATUS=LSTAT, IOSTAT=IOSVAL)
         IF (IOSVAL.NE.0) THEN
            IERR = 6
            FCB(1+FCBERR) = IOSVAL
            WRITE (MSGTXT,1020) IOSVAL
            END IF
         END IF
C                                       messages
      IF (IERR.NE.0) CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZTPOPD: using translated file name =')
 1001 FORMAT ('ZTPOPD: ',A)
 1010 FORMAT ('ZTPOPD: FILE NOT FOUND')
 1015 FORMAT ('ZTPOPD: FILE ALREADY EXISTS')
 1020 FORMAT ('ZTPOPD: FORTRAN OPEN ERROR = ',I6)
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QUVINT (UV, VIS, WORK, L, G, CX, M, LROW, NFREQ,
     *   CNT, SCR)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Interpolate model visibility from grid.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Interpolates model visibility values from a grid, corrects the model
C   for the phase of the z*w term and subtracts the model from the data.
C   Will loop over several frequency channels.  Two words of work space
C   are assumed in front of the visibilities.
C   Inputs:
C      UV    I  Base address of U,V vector
C      VIS   I  Base address of visibility
C      WORK  I  Base address of complex work vector length CNT
C      L     I  Length of visibility record
C      G     I  Base address of grid
C      CX    I  Base address of row interpolation function
C               interpolation fns tabulated every 1/200 cell.
C      M     I  Width of interpolation fn support size,  also
C               the number of rows kept in AP (must be odd)
C      LROW  I  length of a row (V)
C      NFREQ I  Number of frequencies to process.
C      CNT   I  Number of visibility points.
C      SCR   I  Base address of scratch complex vector
C               in each vis rec, inc=L.
C   NOTE: only really works for one frequency (unless they are
C   very close)
C     Also expects necessary constants in following AP locations:
C          0 = U scaling to cells
C          1 = V scaling to cells
C          2 = DXC = -2 * Pi * delta RA (in cells)
C          3 = DYC = -2 * Pi * delta DEC (cells)
C          4 = DZC = -2 * Pi * delta Z (in radians) for 1st
C              frequency channel.
C          5 = Used as work space.
C          6 = Used as work space.
C          16...16+NFREQ-2 = Differential frequency scaling table
C               for channels after the first one.
C               FREQ(n) = (1+MD(16+n-1)) * FREQ(n-1) FOR n>1
C-----------------------------------------------------------------------
      INTEGER   UV, VIS, WORK, L, G, CX, SCR, M, LROW, CNT, NFREQ,
     *   UV1, UV2, IWORK1, IWORK2, IFQ, VVIS, LOOP
C-----------------------------------------------------------------------
      IF (CNT.LE.0) GO TO 999
C                                       Setup
      UV1 = UV + 1
      UV2 = UV1 + 1
      VVIS = VIS
      IWORK1 = SCR
      IWORK2 = IWORK1 + 1
C                                       Save u,v
      CALL QCVMOV (UV, L, WORK, 2, CNT)
C                                       Init. w scaling.
      CALL QCVMOV (4, 2, 5, 2, 1)
C                                       Scale u,v,w to cells.
      CALL QVSMUL (UV, L, 0, UV, L, CNT)
      CALL QVSMUL (UV1, L, 1, UV1, L, CNT)
C                                       Frequency looping, rescale uv
      DO 200 LOOP = 1,NFREQ
C                                       Don't rescale on first pass
         IF (LOOP.EQ.1) GO TO 110
            IFQ = 14 + LOOP
            CALL QVSMA (UV, L, IFQ, UV, L, UV, L, CNT)
            CALL QVSMA (UV1, L, IFQ, UV1, L, UV1, L, CNT)
            CALL QVSMA (5, 1, IFQ, 5, 1, 5, 1, 1)
C                                       Shift position (z*w) term.
 110     CALL QVSMUL (UV2, L, 5, IWORK1, L, CNT)
         CALL QVSMA (UV, L, 2, IWORK1, L, IWORK1, L, CNT)
         CALL QVSMA (UV1, L, 3, IWORK1, L, IWORK1, L, CNT)
         CALL QVSIN (IWORK1, L, IWORK2, L, CNT)
         CALL QVCOS (IWORK1, L, IWORK1, L, CNT)
C                                       Interpolate
         CALL QINTP (UV, VVIS, IWORK1, G, CX, M, LROW, L, CNT)
         VVIS = VVIS + 2
 200     CONTINUE
C                                       Restore u,v
      CALL QCVMOV (WORK, 2, UV, L, CNT)
C
 999  RETURN
      END

      SUBROUTINE YGRAFX (OP, GRFX, RED, GREEN, BLUE, IERR)
C-----------------------------------------------------------------------
C! read/write TV graphics colors
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YGRAFX modifies the colour of the graphics or cursor.
C   Inputs:
C      OP       C*4   READ or WRITE graphics colour assignment.
C      GRFX     I     Cursor (0), or graphics plane number.
C   In/Out:
C      RED      R     Red,   0.0 - 1.0
C      GREEN    R     Green, 0.0 - 1.0
C      BLUE     R     Blue,  0.0 - 1.0
C   Output:
C      IERR     I     Error status, 0 means success.
C   Generic (stubbed) version.
C   Author:Mark Calabretta, Australia Telescope.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   GRFX, IERR
      REAL      BLUE, GREEN, RED
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Disappoint the user.
      IERR = 1
      MSGTXT = 'CURSOR/GRAPHICS COLOR OPERATIONS ARE NOT IMPLEMENTED.'
      CALL MSGWRT (8)
C
 999  RETURN
      END

      SUBROUTINE GNINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   GNROW, GNCOLS, GNNUMV, NUMPOL, NUMIF, NTABS, TABREV, IRET)
C-----------------------------------------------------------------------
C! Intialize a FITS interchange gain curve table for reading
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1998, 2006-2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Verify that a temporary gain curve table is a valid FITS
C   interferometry data interchange table and, if so, open it for
C   reading.
C   Inputs:
C      OPCODE      C*4        Operation code:
C                               'READ' - open for read only
C      DISK        I          Disk to use.
C      CNO         I          Catalog slot number
C      CATBLK      I(256)     Catalog header block
C      LUN         I          Logical unit number to use
C   Input/output:
C      BUFFER      I(512)     Table I/O control block and buffer
C      VER         I          GN file version (if VER = 0 when GNINI
C                               is called the the GN table with the
C                               highest version number will be
C                               initialized provided that one exists and
C                               VER will be set to its version number)
C   Output:
C      GNROW       I          Next GN table row to read (1)
C      GNCOLS      I(MAXGNC)  Column pointers in the order
C                                1  ANTENNA_NO
C                                2  ARRAY
C                                3  FREQID
C                                4  TYPE_1
C                                5  NTERM_1
C                                6  X_TYP_1
C                                7  Y_TYP_1
C                                8  X_VAL_1
C                                9  Y_VAL_1
C                               10  GAIN_1
C                               11  SENS_1
C                               12  TYPE_2
C                               13  NTERM_2
C                               14  X_TYP_2
C                               15  Y_TYP_2
C                               16  X_VAL_1
C                               17  Y_VAL_1
C                               18  GAIN_2
C                               19  SENS_2
C      GNNUMV      I(MAXGNC)  Column dimensions in the same order as
C                               GNCOLS
C      NUMIF       I          Number of IFs covered by the table
C      TABREV      I          Table revision number
C      IRET        I          Return code:
C                               0 -> table open
C                               1 -> table format is not valid
C                               2 -> table format is valid but exceeds
C                                    an AIPS limit
C                               3 -> an I/O error was detected
C                             999 -> subroutine call was invalid
C   Notes:
C      GC tables should be converted to AIPS GC tables when read from
C      FITS interferometry data interchange files.
C
C      NUMIF is set to the value of the NO_BAND keyword and need not
C      correspond to the number of IFs in the root data file (its value
C      may be greater than or equal to this quantity).
C
C      The table will be left open if IRET = 1 or 2 on exit but will
C      not be safe for reading using TABGN.  The state of the table
C      will be indeterminate if IRET = 3.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PTAB.INC'
      INCLUDE 'INCS:PGNV.INC'
C
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, GNROW,
     *   GNCOLS(MAXGNC), GNNUMV(MAXGNC), NUMPOL, NUMIF, NTABS,
     *   TABREV, IRET
C
C     Local variables:
C
C     NKEY     Number of keywords to read from table
C     NCOL     Number of columns in table
C     NREC     Number of records by which to extend table (unused)
C     DATP     Table pointers and type codes
C     NGNKEY   Number of keywords to read from table (parameter)
C     GNKEYW   Keywords to be read
C     KEYLOC   Keyword pointers
C     KEYTYP   Keyword type codes
C     KEYVAL   Keyword value buffer
C     CURREV   Current GN revision number (parameter)
C     CTITLE   Column titles (indexed by column and table revision)
C     CTYPE    Column types(indexed by column and table revision)
C     CDIM     Column dimensions (indexed by column and table revision)
C     XTYPE    Expected column type codes for current table (indexed
C                by column)
C     XDIM     Expected column dimensions for current table (indexed by
C                column)
C     COLS     Column pointers
C     COL      Column number
C     KEYW     Keyword number
C     TYPE     Type of current column
C     MSGSAV   Saved message suppression level
C
      INTEGER   NKEY, NCOL, NREC, DATP(128,2)
C
      INTEGER   NGNKEY
      PARAMETER (NGNKEY = 4)
      CHARACTER GNKEYW(NGNKEY)*8
      INTEGER   KEYLOC(NGNKEY), KEYTYP(NGNKEY), KEYVAL(2 * NGNKEY)
C
      INTEGER   CURREV
      PARAMETER (CURREV = 1)
      CHARACTER CTITLE(MAXGNC, CURREV)*24
      INTEGER   CTYPE(MAXGNC, CURREV), CDIM(MAXGNC, CURREV)
      INTEGER   XTYPE(MAXGNC), XDIM(MAXGNC), COLS(MAXGNC)
C
      INTEGER   COL, KEYW, TYPE
      INTEGER   MSGSAV
C
      INTEGER   ITRIM, NC, JERR, IPOINT
      EXTERNAL  ITRIM
C
      INCLUDE 'INCS:DMSG.INC'
C                                       Keywords
      DATA GNKEYW /'TABREV  ', 'NO_POL  ', 'NO_BAND ', 'NO_TABS '/
C                                       Columns for TABREV 1
      DATA (CTITLE(COL, 1), COL = 1, MAXGNC)
     *   /'ANTENNA_NO              ', 'ARRAY                   ',
     *    'FREQID                  ', 'TYPE_1                  ',
     *    'NTERM_1                 ', 'X_TYP_1                 ',
     *    'Y_TYP_1                 ', 'X_VAL_1                 ',
     *    'Y_VAL_1                 ', 'GAIN_1                  ',
     *    'SENS_1                  ', 'TYPE_2                  ',
     *    'NTERM_2                 ', 'X_TYP_2                 ',
     *    'Y_TYP_2                 ', 'X_VAL_2                 ',
     *    'Y_VAL_2                 ', 'GAIN_2                  ',
     *    'SENS_2                  '/
      DATA (CTYPE(COL, 1), COL = 1, MAXGNC)
     *   / TABINT, TABINT, TABINT, TABINT, TABINT,
     *     TABINT, TABINT, TABFLT, TABFLT, TABFLT,
     *     TABFLT, TABINT, TABINT, TABINT, TABINT,
     *     TABFLT, TABFLT, TABFLT, TABFLT /
      DATA (CDIM(COL, 1), COL = 1, MAXGNC)
     *   / 1, 1, 1, 0, 0, 0, 0, 0, 0, 0,
     *     0, 0, 0, 0, 0, 0, 0, 0, 0 /
C-----------------------------------------------------------------------
C                                       open table - only READ allowed
      IF (OPCODE.EQ.'READ') THEN
         NKEY = NGNKEY
         NCOL = MAXGNC
         NREC = 0
         CALL TABINI (OPCODE, 'GN', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *      NREC, NCOL, DATP, BUFFER, IRET)
         IF (IRET.EQ.0) THEN
            GNROW = 1
C           Read the TABREV and NO_BAND keywords (the others will have
C           been used to associate this table with a file but are not
C           necessary to interpret the table) while supressing messages
C           from TABKEY:
            MSGSAV = MSGSUP
            MSGSUP = 32000
            NKEY = NGNKEY
            CALL TABKEY ('READ', GNKEYW, NKEY, BUFFER, KEYLOC, KEYVAL,
     *         KEYTYP, IRET)
            MSGSUP = MSGSAV
C                                       Check the revision number:
            IF (IRET.EQ.0) THEN
               IF (KEYTYP(1).EQ.TABINT) THEN
                  TABREV = KEYVAL(KEYLOC(1))
                  IF ((TABREV.LT.1) .OR. (TABREV.GT.CURREV)) THEN
                     WRITE (MSGTXT,9000) VER
                     CALL MSGWRT (6)
                     WRITE (MSGTXT,9001) TABREV
                     CALL MSGWRT (6)
                     IRET = 1
                     END IF
               ELSE
                  WRITE (MSGTXT,9000) VER
                  CALL MSGWRT (6)
                  WRITE (MSGTXT,9002) GNKEYW(1), 'INTEGER'
                  CALL MSGWRT (6)
                  IRET = 1
                  END IF
C                                       Check the NO_POL keyword
               IF (KEYTYP(2).EQ.TABINT) THEN
                  NUMPOL = KEYVAL(KEYLOC(2))
                  IF ((NUMPOL.LT.1) .OR. (NUMPOL.GT.2)) THEN
                     WRITE (MSGTXT,9000) VER
                     CALL MSGWRT (6)
                     WRITE (MSGTXT,9002) GNKEYW(2), 'VALID'
                     CALL MSGWRT (6)
                     IRET = 1
                     END IF
               ELSE
                  WRITE (MSGTXT,9000) VER
                  CALL MSGWRT (6)
                  WRITE (MSGTXT,9002) GNKEYW(2), 'INTEGER'
                  CALL MSGWRT (6)
                  IRET = 1
                  END IF
C                                       Check the NO_BAND keyword
               IF (KEYTYP(3).EQ.TABINT) THEN
                  NUMIF = KEYVAL(KEYLOC(3))
                  IF (NUMIF.LT.0) THEN
                     WRITE (MSGTXT,9000) VER
                     CALL MSGWRT (6)
                     WRITE (MSGTXT,9002) GNKEYW(3), 'POSITIVE'
                     CALL MSGWRT (6)
                     IRET = 1
                  ELSE IF (NUMIF.GT.MAXIF) THEN
                     WRITE (MSGTXT,9003) VER
                     CALL MSGWRT (6)
                     WRITE (MSGTXT,9004) GNKEYW(3), NUMIF, MAXIF
                     CALL MSGWRT (6)
                     IRET = 2
                     END IF
               ELSE
                  WRITE (MSGTXT,9000) VER
                  CALL MSGWRT (6)
                  WRITE (MSGTXT,9002) GNKEYW(3), 'INTEGER'
                  CALL MSGWRT (6)
                  IRET = 1
                  END IF
C                                       Check the NO_TABS keyword
               IF (KEYTYP(4).EQ.TABINT) THEN
                  NTABS = KEYVAL(KEYLOC(4))
                  IF (NTABS.LT.0) THEN
                     WRITE (MSGTXT,9000) VER
                     CALL MSGWRT (6)
                     WRITE (MSGTXT,9002) GNKEYW(4), 'POSITIVE'
                     CALL MSGWRT (6)
                     IRET = 1
                  ELSE IF (NTABS.GT.MXTBGN) THEN
                     WRITE (MSGTXT,9003) VER
                     CALL MSGWRT (6)
                     WRITE (MSGTXT,9004) GNKEYW(4), NTABS, MXTBGN
                     CALL MSGWRT (6)
                     IRET = 2
                     END IF
               ELSE
                  WRITE (MSGTXT,9000) VER
                  CALL MSGWRT (6)
                  WRITE (MSGTXT,9002) GNKEYW(4), 'INTEGER'
                  CALL MSGWRT (6)
                  IRET = 1
                  END IF
C                                       List missing keywords:
            ELSE IF (IRET.GT.20) THEN
               WRITE (MSGTXT,9000) VER
               CALL MSGWRT (6)
               DO 10 KEYW = 1,NGNKEY
                  IF (KEYLOC(KEYW) .LE. 0) THEN
                     WRITE (MSGTXT,9005) GNKEYW(KEYW)
                     CALL MSGWRT (6)
                     END IF
 10               CONTINUE
               IRET = 1
            ELSE
               CALL TABERR ('READ', 'TABKEY', 'GNINI ', IRET)
               IRET = 3
               END IF
C                                       Decode and verify the column
C                                       structure of the table
            IF (IRET.EQ.0) THEN
C                                       1 <= TABREV <= CURREV
C                                       0 <= NUMIF <= MAXIF
C                                       1 <= NUMPOL <= 2
C                                       0 <= NTABS <= MXTBGN
               CALL COPY (MAXGNC, CTYPE(1, TABREV), XTYPE)
               CALL COPY (MAXGNC, CDIM(1, TABREV), XDIM)
               NCOL = 3 + 8 * NUMPOL
               DO 20 COL = 1,NCOL
                  IF (((COL.GE.4) .AND. (COL.LE.8)) .OR. (COL.EQ.19)
     *                .OR. ((COL.GE.11) .AND. (COL.LE.16))) THEN
                     XDIM(COL) = NUMIF
                  ELSE IF ((COL.EQ.9) .OR. (COL.EQ.10) .OR. (COL.EQ.17)
     *               .OR. (COL.EQ.18)) THEN
                     XDIM(COL) = NTABS * NUMIF
                     END IF
 20               CONTINUE
               CALL FNDCOL (NCOL, CTITLE(1,TABREV), 24, .TRUE., BUFFER,
     *            COLS, JERR)
               IF ((JERR.EQ.0) .OR. (JERR.GT.10)) THEN
                  DO 40 COL = 1,NCOL
                     IPOINT = COLS(COL)
                     NC = ITRIM (CTITLE(COL,TABREV))
                     IF (IPOINT.GT.0) THEN
                        GNCOLS(COL) = DATP(IPOINT,1)
                        GNNUMV(COL) = DATP(IPOINT,2) / 10
                        IF (GNNUMV(COL).LE.0) THEN
                           WRITE (MSGTXT,1100) CTITLE(COL,TABREV)(:NC)
                           CALL MSGWRT (6)
                           END IF
                        TYPE = MOD (DATP(IPOINT,2), 10)
                        IF (TYPE.NE.XTYPE(COL)) THEN
                           WRITE (MSGTXT,9000) VER
                           CALL MSGWRT (6)
                           WRITE (MSGTXT,9030) CTITLE(COL, TABREV)(:NC)
                           CALL MSGWRT (6)
                           GNCOLS(COL) = -1
                           GNNUMV(COL) = 0
                           END IF
C                                       Check dimensions:
                        IF (GNNUMV(COL).NE.XDIM(COL)) THEN
                           WRITE (MSGTXT,9000) VER
                           CALL MSGWRT (6)
                           WRITE (MSGTXT,9031) CTITLE(COL, TABREV)(:NC),
     *                        GNNUMV(COL), XDIM(COL)
                           CALL MSGWRT (6)
                           GNCOLS(COL) = -1
                           GNNUMV(COL) = 0
                           END IF
                     ELSE
                        WRITE (MSGTXT,1101) CTITLE(COL,TABREV)(:NC)
                        CALL MSGWRT (6)
                        GNCOLS(COL) = -1
                        GNNUMV(COL) = 0
                        END IF
 40                  CONTINUE
               ELSE
                  CALL TABERR ('FIND', 'FNDCOL', 'GNINI ', IRET)
                  IRET = 3
                  END IF
               END IF
         ELSE
            CALL TABERR (OPCODE, 'TABINI', 'GNINI ', IRET)
            IRET = 3
            END IF
      ELSE
         WRITE (MSGTXT,9040) OPCODE
         IRET = 999
         END IF
c
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('GNINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('GNINI: ''',A,''' COLUMN NOT FOUND')
 9000 FORMAT ('GNINI: GAIN CURVE (GN) TABLE ', I3, ' IS NOT VALID')
 9001 FORMAT ('GNINI: UNRECOGNIZED REVISION NUMBER ', I3)
 9002 FORMAT ('GNINI: ', A, ' KEYWORD DOES NOT HAVE ', A, ' VALUE')
 9003 FORMAT ('GNINI: GAIN CURVE (GN) TABLE ', I3,
     *        'CANNOT BE USED BY AIPS')
 9004 FORMAT ('GNINI: ', A, ' VALUE ', I4, ' EXCEEDS LIMIT OF ', I4)
 9005 FORMAT ('GNINI: KEYWORD ', A, ' IS MISSING')
 9030 FORMAT ('GNINI: COLUMN ''', A, ''' HAS WRONG TYPE')
 9031 FORMAT ('GNINI: COLUMN ''', A, ''' HAS DIMENSION ', I4, ' NOT ',
     *        I4)
 9040 FORMAT ('GNINI: UNRECOGNIZED OPCODE ''', A, '''')
      END

      SUBROUTINE PLNGET (IDISK, ICNO, CORN, JWIN, XOFF, YOFF, NOSCR,
     *   NX, NY, BUFF1, BUFF2, BUFSZ1, BUFSZ2, LUN1, LUN2, IRET)
C-----------------------------------------------------------------------
C! reads subimage of a plane and writes it to scratch file with shifts
C# Map-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2021-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GETPLN reads a selected portion of a selected plane parallel to the
C   front and writes it into a specified scratch file.  The output file
C   will be zero padded and a shift of the center may be specified.  If
C   the input window is unspecified (0's) and the output file is smaller
C   than the input file, the NX x NY region about position (MX/2+1-OFFX,
C   MY/2+1-OFFY) in the input map will be used where MX,MY is the size
C   of the input map.  NOTE: unlike the 1995 PLNGET this does not
C   rotate about the edges.  If the shifted image does not fit an error
C   is instead generated.  All 2021 uses have small shifts other than
C   FFTIM and that should also fit into the output.
C   Inputs:
C      IDISK    I      Input image disk number.
C      ICNO     I      Input image catalog slot number.
C      CORN     I(7)   BLC in input image (1 & 2 ignored)
C      JWIN     I(4)   Window in plane.
C      XOFF     I      offset in cells in first dimension of the center
C                      from MX/2+1 (MX 1st dim. of input win.)
C      YOFF     I      offset in cells in second dimension of the center
C                      from MY/2+1 (MY 2nd dim. of input win.)
C      NOSCR    I      Scratch file number in common /CFILES/ for outpu.
C      NX       I      Dimension of output file in X
C      NY       I      Dimension of output file in Y
C      BUFF1    R(*)   Work buffer
C      BUFF2    R(*)   Work buffer.
C      BUFSZ1   I      Size in AIPS bytes of BUFF1
C      BUFSZ2   I      Size in AIPS bytes of BUFF2
C      LUN1     I      Logical unit number for input file
C      LUN2     I      Logical unit number to use for output
C   Output:
C      IRET     I      Return error code, 0 => OK,
C                       1 = couldn't copy input CATBLK
C                       2 = wrong number of bits/pixel in input map.
C                       3 = input map has inhibit bits.
C                       4 = couldn't open output map file.
C                       5 = couldn't init input map.
C                       6 = couldn't init output map.
C                       7 = read error input map.
C                       8 = write error output map.
C                       9 = error computing block offset
C                       10 = output file too small.
C   Common:
C      /MAPHDR/ CATBLK  is set to the input file CATBLK.
C   Programmer: W. D. Cotton, May 1982.
C-----------------------------------------------------------------------
      INTEGER   IDISK, ICNO, CORN(7), JWIN(4), XOFF, YOFF, NOSCR, NX,
     *   NY, BUFSZ1, BUFSZ2, LUN1, LUN2, IRET
      REAL      BUFF1(*), BUFF2(*)
C
      CHARACTER PHNAME*48, IFILE*48
      INTEGER   IERR, WIN(4), FIND1, FIND2, BIND1, BIND2, BO, RBO, I4,
     *   IFIRST, ILAST, KORN(7), IADD, IOFF, MX, MY, JOFF1, JOFF2, OFFX,
     *   OFFY, IWIN(4), MMX, MMY, DORND
      LOGICAL   T, F
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA RBO /1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IRET = 0
      OFFX = XOFF
      OFFY = YOFF
      FIND1 = 0
      FIND2 = 0
C                                       Read input CATBLK
      CALL CATIO ('READ', IDISK, ICNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1000) IERR, 'READING FILE HEADER'
         GO TO 990
         END IF
C                                       Make sure there are NO blanks
      IF (CATR(KRBLK).NE.0.0) THEN
         IRET = 3
         WRITE (MSGTXT,1010)
         GO TO 990
         END IF
C                                       Determine mapsize
      MX = CATBLK(KINAX)
      MY = CATBLK(KINAX+1)
C                                       Check defaults on IWIN
      CALL COPY (4, JWIN, IWIN)
      IF ((MX.GT.NX) .AND. ((IWIN(1).EQ.0) .OR. (IWIN(3).EQ.0))) THEN
         IWIN(1) = (MX/2+1) - (NX/2) - OFFX
         IWIN(3) = (MX/2+1) + (NX/2-1) - OFFX
         OFFX = 0
         END IF
      IF ((MY.GT.NY) .AND. ((IWIN(2).EQ.0).OR.(IWIN(3).EQ.0))) THEN
         IWIN(2) = (MY/2+1) - (NY/2) - OFFY
         IWIN(4) = (MY/2+1) + (NY/2-1) - OFFY
         OFFY = 0
         END IF
      IF (IWIN(1).LE.0) IWIN(1) = 1
      IF (IWIN(2).LE.0) IWIN(2) = 1
      IF ((IWIN(3).LE.0) .OR. (IWIN(3).GT.MX)) IWIN(3) = MX
      IF ((IWIN(4).LE.0) .OR. (IWIN(4).GT.MY)) IWIN(4) = MY
C                                        Determine input window size.
      MMX = IWIN(3) - IWIN(1) + 1
      MMY = IWIN(4) - IWIN(2) + 1
C                                        Determine first and last
C                                        output rows for read.
      IFIRST = ((NY - MMY) / 2.0) + 1.6 - OFFY
      ILAST = IFIRST + (IWIN(4) - IWIN(2))
      IF ((IFIRST.LT.1) .OR. (ILAST.GT.NY)) THEN
         WRITE (MSGTXT,1020) 'Y', IFIRST, ILAST, NY
         IRET = 10
         GO TO 990
         END IF
      IADD = (NX - MMX) / 2.0 + 0.6
      JOFF1 = IADD - OFFX + 1
      JOFF2 = JOFF1 + MMX - 1
      DORND = 0
      IF (JOFF1.EQ.0) THEN
         DORND = -1
         JOFF1 = 1
         END IF
      IF (JOFF2.EQ.NX+1) THEN
         DORND = +1
         JOFF2 = NX
         END IF
      IF (DORND.NE.0) MMX = MMX - 1
      IF ((JOFF1.LT.1) .OR. (JOFF2.GT.NX)) THEN
         WRITE (MSGTXT,1020) 'X', JOFF1, JOFF2, NX
         IRET = 10
         GO TO 990
         END IF
C                                        Check defaults on CORN
      IERR = 0
      DO 45 I4 = 1,KICTPN
         KORN(I4) = 1
         IF (I4.LE.CATBLK(KIDIM)) THEN
            KORN(I4) = MAX (CORN(I4), 1)
            IF (CATBLK(KINAX+I4-1).LE.1) KORN(I4) = 1
            IF (CATBLK(KINAX+I4-1).LT.KORN(I4)) IERR = 2
            END IF
 45      CONTINUE
C                                       Set input BLOCK offset.
      IF (IERR.EQ.0) THEN
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), KORN(3), BO, IERR)
         BO = BO + 1
         END IF
      IF (IERR.NE.0) THEN
         IRET = 9
         WRITE (MSGTXT,1000) IERR, 'COMPUTING BLOCK OFFSET'
         GO TO 990
         END IF
C                                       Set window for output.
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NX
      WIN(4) = NY
C                                        Make sure input window .le.
C                                        output file size.
      IF ((NX.LT.MMX) .OR. (NY.LT.MMY)) THEN
         IRET = 10
         WRITE (MSGTXT,1050) NX, NY, MMX, MMY
         GO TO 990
         END IF
C                                       Open output map file.
      CALL ZPHFIL ('SC', SCRVOL(NOSCR), SCRCNO(NOSCR), 1, PHNAME, IERR)
      CALL ZOPEN (LUN2, FIND2, SCRVOL(NOSCR), PHNAME, T, T, F, IERR)
      IF (IERR.NE.0) THEN
         IRET = 4
         WRITE (MSGTXT,1000) IERR, 'OPENING OUTPUT FILE'
         GO TO 990
         END IF
C                                       Open input file.
      CALL ZPHFIL ('MA', IDISK, ICNO, 1, IFILE, IERR)
      CALL ZOPEN (LUN1, FIND1, IDISK, IFILE, T, T, F, IERR)
      IF (IERR.NE.0) THEN
         IRET = 4
         WRITE (MSGTXT,1000) IERR, 'OPENING INPOUT FILE'
         CALL MSGWRT (8)
         GO TO 980
         END IF
C                                       Init files.
      CALL MINIT ('READ', LUN1, FIND1, MX, MY, IWIN, BUFF1, BUFSZ1, BO,
     *   IERR)
      IF (IERR.NE.0) THEN
         IRET = 5
         WRITE (MSGTXT,1000) IERR, 'INITING OUTPUT FILE I/O'
         GO TO 970
         END IF
      CALL MINIT ('WRIT', LUN2, FIND2, NX, NY, WIN, BUFF2, BUFSZ2, RBO,
     *   IERR)
      IF (IERR.NE.0) THEN
         IRET = 6
         WRITE (MSGTXT,1000) IERR, 'INITING INPUT FILE I/O'
         GO TO 970
         END IF
C                                       Finally do what you're here for
      DO 200 I4 = 1,NY
C                                       Write real map.
         CALL MDISK ('WRIT', LUN2, FIND2, BUFF2, BIND2, IERR)
         IF (IERR.NE.0) THEN
            IRET = 8
            WRITE (MSGTXT,1090) IERR, I4
            GO TO 970
            END IF
C                                       Zero fill output row.
         CALL RFILL (NX, 0.0, BUFF2(BIND2))
C                                       Check if data for this row.
         IF ((I4.GE.IFIRST) .AND. (I4.LE.ILAST)) THEN
C                                       Read map row.
            CALL MDISK ('READ', LUN1, FIND1, BUFF1, BIND1, IERR)
            IF (IERR.NE.0) THEN
               IRET = 7
               WRITE (MSGTXT,1105) IERR, I4
               GO TO 970
               END IF
C                                       Move to output buffer.
            IOFF = BIND2 + JOFF1
            IF (DORND.EQ.-1) THEN
               CALL RCOPY (MMX, BUFF1(BIND1+1), BUFF2(IOFF-1))
               BUFF2(BIND2+MMX) = BUFF1(BIND1)
            ELSE
               CALL RCOPY (MMX, BUFF1(BIND1), BUFF2(IOFF-1))
               IF (DORND.EQ.1) BUFF2(BIND2) = BUFF1(BIND1+MMX)
               END IF
            END IF
 200     CONTINUE
C                                       Finish write.
      CALL MDISK ('FINI', LUN2, FIND2, BUFF2, BIND2, IERR)
      IF (IERR.NE.0) THEN
         IRET = 8
         WRITE (MSGTXT,1090) IERR, NY
         END IF
C                                       Close real map file.
 970  IF (IRET.NE.0) CALL MSGWRT (8)
      IF (FIND1.GT.0) CALL ZCLOSE (LUN1, FIND1, IERR)
C                                       Close integer map file.
 980  IF (FIND2.GT.0) CALL ZCLOSE (LUN2, FIND2, IERR)
      GO TO 999
C                                       message only
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PLNGET: ERROR',I3,' ON ', A)
 1010 FORMAT ('PLNGET: MAP IS BLANKED AND I AM NOT ALLOWED TO HANDLE',
     *   ' IT')
 1020 FORMAT ('PLNGET: ',A,' OFFSET SHIFTS OUTSIDE OUTPUT:',2I6,
     *   ' OUTSIDE 1-',I6)
 1050 FORMAT ('PLNGET: OUTPUT MAP TOO SMALL',2I6,' .LT. ',2I6)
 1090 FORMAT ('PLNGET: WRITE ERROR',I3,' ROW ',I5)
 1105 FORMAT ('PLNGET: READ ERROR',I3,' ROW ',I5)
      END

      SUBROUTINE YTVCLS (BUF, IERR)
C-----------------------------------------------------------------------
C! close the TV, including TV device and TV control/parameter disk file
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YTVCLS closes the TV device and the TV status disk file, updating
C   the information on the disk.  Actual device call done by YTVCL2.
C   Outputs:
C      BUF   I(256)     Scratch buffer
C      IERR  I          Error code : 0 => ok
C                          else as returned by ZFIO
C                          11 => close disk error
C                          12 => close device error
C   Virtual TV (by communication) version.
C-----------------------------------------------------------------------
      INTEGER   IERR, BUF(256)
C
      INTEGER   JERR, IDUMMY
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
C                                       send closing info
      BUFSW = 0
      BUFSR = 0
      CALL MKYBUF ('WRIT', 'YTVCLS', BUFSW, BUFSR, IDUMMY, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
C                                       Close TV device
      CALL YTVCL2 (TVLUN, TVIND, JERR)
      IF (IERR.EQ.0) IERR = JERR
C
      TVLUN = 0
      TVLUN2 = 0
      TVIND2 = 0
      TVIND = 0
C
 999  RETURN
      END

      SUBROUTINE TVZOME (IERR)
C-----------------------------------------------------------------------
C! interactive TV zooming
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Interactive TV zooming
C   Outputs:
C      IERR     I      Error code
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   IMAG, MAG, IX, IY, IBUT, QUAD, ITW(3), I, LMAGL
      REAL      RPOS(2), PPOS(2)
      LOGICAL   T, F, DOIT
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                        general parameters
      QUAD = -1
      RPOS(1) = 0.0
      RPOS(2) = 0.0
      CALL ZTIME (ITW)
C                                        TVZOOM
      MSGTXT = 'Cursor position controls center point of zoom'
      CALL MSGWRT (1)
      MSGTXT = 'Hit buttons A or B to increment magnification'
      CALL MSGWRT (1)
      MSGTXT = 'Hit button C to decrement magnification'
      CALL MSGWRT (1)
      MSGTXT = 'Hit button D to exit'
      CALL MSGWRT (1)
C                                        set up for 0 zoom
      IMAG = 0
      IX = (WINDTV(1) + WINDTV(3)) / 2 + 1
      IY = (WINDTV(2) + WINDTV(4)) / 2
      RPOS(1) = IX - 1
      RPOS(2) = IY
      PPOS(1) = RPOS(1)
      PPOS(2) = RPOS(2)
      LMAGL = ABS(MXZOOM) + 1
C                                        reset zoom and cursor so that
C                                        cursor is centered and on the
C                                        zoom center
 20   CALL YZOOMC (IMAG, IX, IY, F, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IERR)
      IF (IERR.NE.0) GO TO 900
      IF (IBUT.GT.7) GO TO 900
      I = 2
C                                        read cursor until moves
 30   CALL YCURSE ('READ', F, T, RPOS, QUAD, IBUT, IERR)
         IF (IERR.NE.0) GO TO 900
         IF (IBUT.GT.7) GO TO 900
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF ((DOIT) .AND. ((IBUT.NE.0) .OR. (IMAG.NE.0))) THEN
C                                        new zoom center & factor
            IF ((IBUT.GT.0) .AND. (IBUT.LT.4)) IMAG = IMAG + 1
            IF (IBUT.GE.4) IMAG = IMAG - 1
            IF (IMAG.LT.0) IMAG = LMAGL - 1
            IMAG = MOD (IMAG, LMAGL)
            IF (IBUT.GT.0) THEN
               CALL YWINDO ('READ', WINDTV, IERR)
               IF (IERR.NE.0) GO TO 900
               END IF
            IX = (WINDTV(1) + WINDTV(3)) / 2
            IY = (WINDTV(2) + WINDTV(4)) / 2
            IF (IMAG.EQ.0) THEN
               MAG = 1
               IX = IX + 1
            ELSE
               MAG = IMAG + 1
               IF (MXZOOM.GT.0) MAG = 2 ** IMAG
               IX = (MAG*(RPOS(1)-1.0) - IX) / (MAG-1) + 1.0
               IX = MAX (1, MIN (MAXXTV(1), IX))
               IY = MAXXTV(2) - (MAG * (MAXXTV(2)-RPOS(2)) - IY)
     *            / (MAG-1)
               IY = MAX (1, MIN (MAXXTV(2), IY))
               END IF
            GO TO 20
         ELSE
            GO TO 30
            END IF
C                                        messages on error
 900  IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1910) IERR
         CALL MSGWRT (7)
         END IF
C
C
 999  RETURN
C-----------------------------------------------------------------------
 1910 FORMAT ('TVZOME: TV ACTION ERROR CODE',I7)
      END

      PROGRAM FILAI2
C-----------------------------------------------------------------------
C! FILAI2 creates and initializes files needed to run AIPS.
C# Service
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2002, 2005, 2007-2008, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FILAI2 is a service program designed to create and initialize
C   the files needed to run AIPS.  It may be used to alter the AIPS
C   configuration already in use as well.  In either case, it
C   creates and initializes all basic AIPS files except the memory file
C   (created in this program but initialized by POPSGN).  If a catalog
C   file already exists it will not be re-initialized. This program is
C   similiar to FILAIP except inputs are read from a text file SYSPARM.
C-----------------------------------------------------------------------
      CHARACTER MPASS*12, PHNAME*48, FTYP(13)*2, PRGNAM*6, MNAME*8,
     *   VER*20, MSGBUF*80, LPASS*12
      HOLLERITH APASS(3)
      INTEGER  I, J, CMAX, IC, NREC, ZBUF(256), IT, IERR, TTY(2),
     *   BUFFER(256), LUN, FIND, NL, IN, IQ, SCRTCH(256), IVOL, IRNO,
     *   TXTLUN, TXTIND, TTYLUN, TTYIND, LTVDEV, I4T, ISIZE, LSIZE
      REAL      ANSWER(22), TKANS(2), TVANS(20), ROBUFF(256)
      LOGICAL   T, F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PKSZ.INC'
      EQUIVALENCE (BUFFER, ROBUFF)
      EQUIVALENCE (TTY(1), TTYLUN),  (TTY(2), TTYIND)
      DATA MPASS /'AMANAGER    '/
      DATA T, F /.TRUE.,.FALSE./
      DATA PRGNAM /'FILAI2'/
      DATA FTYP /'BQ','BA','CA','TD','IC','MS','ME','SP','AC','TP',
     *   'GR','PW','TC'/
      DATA MNAME /'SYSPARM '/
      DATA LUN, TXTLUN, TTYLUN /15, 11, 6/
C-----------------------------------------------------------------------
C                                       basic init
      CALL AIPINI (TTY, PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 990
      MSGSUP = 32000
      CALL YTVCIN
C                                       Open text file
      CALL ZPHFIL ('RT', 1, 0, 1, PHNAME, IERR)
      VER = 'NEW'
      CALL ZTOPEN (TXTLUN, TXTIND, 1, PHNAME, MNAME, VER, T, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         GO TO 999
 10   CALL RFILL (20, 0.0, TVANS)
      CALL RFILL (2, 0.0, TKANS)
C                                       Read so far unused character
C                                       stuff from front of file.
      CALL ZTREAD (TXTLUN, TXTIND, MSGBUF, IERR)
      CALL ZTREAD (TXTLUN, TXTIND, MSGBUF, IERR)
      CALL ZTREAD (TXTLUN, TXTIND, MSGBUF, IERR)
      CALL ZTREAD (TXTLUN, TXTIND, MSGBUF, IERR)
C                                       Read system name.
      CALL ZTREAD (TXTLUN, TXTIND, MSGBUF, IERR)
      SYSNAM = MSGBUF
C                                       Get basic data from text
C                                       file.
      DO 15 I = 1,19
         CALL ZTREAD (TXTLUN, TXTIND, MSGBUF, IERR)
         ANSWER(I) = 0.0
         READ (MSGBUF,1001,ERR=15) ANSWER(I)
 15      CONTINUE
C                                       Read TK parameters.
      IF (ANSWER(17).EQ.0) GO TO 18
         DO 16 I = 1,2
            CALL ZTREAD (TXTLUN, TXTIND, MSGBUF, IERR)
            READ (MSGBUF,1001,ERR=16) TKANS(I)
 16         CONTINUE
 18   CONTINUE
C                                       Read tv parameters.
      IF (ANSWER(18).EQ.0) GO TO 21
         IC = 2 + (2 * ANSWER(18) )
         DO 20 I = 1,IC
            CALL ZTREAD (TXTLUN, TXTIND, MSGBUF, IERR)
            READ (MSGBUF,1001,ERR=20) TVANS(I)
 20         CONTINUE
 21   CONTINUE
      I = ANSWER(2)
      IF ((I.GT.0) .AND. (I.LE.9)) NVOL = I
      UCTSIZ = ABS (ANSWER(6))
      IF (UCTSIZ.GT.46655) UCTSIZ = 46655
      UCTSIZ = MAX (100, UCTSIZ)
      CMAX = UCTSIZ
C                                       # interactive, batch AIPS
      I = ANSWER(4) + .01
      J = ANSWER(5) + .01
      IF (I.LE.0) I = 1
      I = MIN (I, 35)
      IC = I
      IF (J.GT.0) IC = I + 1 + J
      IF ((I.LE.0) .OR. (IC.GT.35)) J = 0
      NINTRN = I
      NBATQS = J
C                                       # interactive devices
      NTVDEV = ANSWER(18) + .01
      IF (J.GE.0) NTKDEV = ANSWER(17) + .01
      CALL FILL (256, 0, ZBUF)
      LTVDEV = NTVDEV
C                                       # of tape drives
      I = ANSWER(3) + .01
      IF ((I.GT.0) .AND. (I.LE.9)) NTAPED = I
C                                       Is this job ok?
C                                       Does password file exist
      CALL ZPHFIL (FTYP(12), 1, 0, 0, PHNAME, IERR)
      CALL ZEXIST (1, PHNAME, ISIZE, IERR)
      IF (IERR.EQ.1) GO TO 100
C                                       Ask for password
         IF (IERR.NE.0) GO TO 30
            CALL PASWRD (SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 995
            GO TO 100
 30      CONTINUE
            WRITE (MSGTXT,1030) IERR
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT,IERR)
C-----------------------------------------------------------------------
C                                       Batch queuing
 100  IF (NBATQS.LE.0) GO TO 150
         IT = 1
         ISIZE = NBATQS
         CALL ZPHFIL (FTYP(IT), 1, 0, 0, PHNAME, IERR)
         CALL ZDESTR (1, PHNAME, IERR)
         CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
         IF (IERR.EQ.0) GO TO 110
            WRITE (MSGTXT,1100) FTYP(IT), IERR
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
            GO TO 150
 110     CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
         IF (IERR.EQ.0) GO TO 120
            WRITE (MSGTXT,1110) FTYP(IT), IERR
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
            GO TO 150
 120     DO 125 I = 1,NBATQS
            IRNO = I
            CALL ZFIO ('WRIT', LUN, FIND, IRNO, ZBUF, IERR)
            IF (IERR.EQ.0) GO TO 125
               WRITE (MSGTXT,1120) FTYP(IT), IERR, I
               CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
               GO TO 130
 125        CONTINUE
 130     CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Batch work files
 150  IF (NBATQS.LE.0) GO TO 200
         IT = 2
         NL = 252 / 22
         ISIZE = 100/NL + 1
         CALL FILL (256, 0, BUFFER)
         BUFFER(2) = 2
         BUFFER(3) = 1
         NL = NINTRN + 1
         DO 180 IN = 1,NL
            DO 170 IQ = 1,NBATQS
               CALL ZPHFIL (FTYP(IT), 1, IQ, IN, PHNAME, IERR)
               CALL ZDESTR (1, PHNAME, IERR)
               CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
               IF (IERR.EQ.0) GO TO 160
                  WRITE (MSGTXT,1100) FTYP(IT), IERR, IN, IQ
                  CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT,IERR)
                  GO TO 170
 160           BUFFER(4) = LSIZE
               CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
               IF (IERR.EQ.0) GO TO 165
                  WRITE (MSGTXT,1110) FTYP(IT), IERR, IN, IQ
                  CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT,IERR)
                  GO TO 170
 165           CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1120) FTYP(IT), IERR, IN, IQ
                  CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT,IERR)
                  END IF
               CALL ZCLOSE (LUN, FIND, IERR)
 170           CONTINUE
 180        CONTINUE
C-----------------------------------------------------------------------
C                                       File catalog
C                                       This portion not used now
C                                       Inits public catalog files
 200  IF (UCTSIZ.GT.0) GO TO 250
      IT = 3
      NL = 256 / 11
      ISIZE = 2 + CMAX + (CMAX-1)/NL
      DO 240 IVOL = 1,NVOL
         CALL ZPHFIL (FTYP(IT), IVOL, 0, 0, PHNAME, IERR)
         CALL ZCREAT (IVOL, PHNAME, ISIZE, F, LSIZE, IERR)
         IF (IERR.EQ.0) GO TO 210
            IF (IERR.EQ.1) GO TO 205
               WRITE (MSGTXT,1100) FTYP(IT), IERR, IVOL
               CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
               GO TO 240
 205        CONTINUE
               WRITE (MSGTXT,1205) IVOL
               CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
               GO TO 240
C
 210     CALL ZOPEN (LUN, FIND, IVOL, PHNAME, F, T, T, IERR)
         IF (IERR.EQ.0) GO TO 215
            WRITE (MSGTXT,1110) FTYP(IT), IERR, IVOL
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
            GO TO 240
 215     CALL FILL (256, 0, BUFFER)
         BUFFER(1) = IVOL
         BUFFER(3) = CMAX
         CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
         IF (IERR.EQ.0) GO TO 220
            WRITE (MSGTXT,1120) FTYP(IT), IERR, IVOL, 1
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
            GO TO 235
 220     IC = 2 + CMAX
         BUFFER(3) = 0
         DO 225 I = 1,256,NL
            BUFFER(I) = -1
 225        CONTINUE
         DO 230 I = IC,NREC
            IRNO = I
            CALL ZFIO ('WRIT', LUN, FIND, IRNO, BUFFER, IERR)
            IF (IERR.EQ.0) GO TO 230
               WRITE (MSGTXT,1120) FTYP(IT), IERR, IVOL, I
               CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
               GO TO 235
 230        CONTINUE
 235     CALL ZCLOSE (LUN, FIND, IERR)
 240     CONTINUE
C-----------------------------------------------------------------------
C                                       Task data communications
 250  IT = 4
      ISIZE = 4 * 35 + 1
      CALL ZPHFIL (FTYP(IT), 1, 0, 4, PHNAME, IERR)
      CALL ZDESTR (1, PHNAME, IERR)
      CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
      IF (IERR.EQ.0) GO TO 255
         WRITE (MSGTXT,1100) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         GO TO 300
 255  CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.EQ.0) GO TO 260
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         GO TO 300
 260  ZBUF(256) = 4
      CALL ZFIO ('WRIT', LUN, FIND, 1, ZBUF, IERR)
      ZBUF(256) = 0
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1120) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         END IF
      CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Image catalogs
C                                       Television devices: no files
C                                       needed
 300  IT = 5
      IC = NTVDEV
C                                       Graphics devices
      NREC = 1295
      ISIZE = NREC
      CALL ZPHFIL (FTYP(IT), 1, 0, 0, PHNAME, IERR)
      CALL ZDESTR (1, PHNAME, IERR)
      CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1100) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         GO TO 350
         END IF
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         GO TO 350
         END IF
      DO 340 I = 1,1295
         CALL ZFIO ('WRIT', LUN, FIND, I, ZBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1120) FTYP(IT), IERR, I
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
            GO TO 345
            END IF
 340     CONTINUE
 345  CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Message files: user #1
 350  IT = 6
      NL = 255 / 31
      NREC = 4
      ISIZE = NREC
      CALL FILL (256, 0, BUFFER)
      IVOL = 1
      CALL ZPHFIL (FTYP(IT), IVOL, NLUSER, 0, PHNAME, IERR)
      CALL ZCREAT (IVOL, PHNAME, ISIZE, F, LSIZE, IERR)
      IF (IERR.EQ.0) GO TO 355
         IF (IERR.EQ.1) GO TO 353
            WRITE (MSGTXT,1100) FTYP(IT), IERR
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
            GO TO 400
 353     CONTINUE
            WRITE (MSGTXT,1353)
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
            GO TO 400
C
 355  BUFFER(2) = LSIZE
      CALL ZOPEN (LUN, FIND, IVOL, PHNAME, F, T, T, IERR)
      IF (IERR.EQ.0) GO TO 360
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         GO TO 400
 360  CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1100) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         END IF
      CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Memory files: create only
 400  NREC = KBLOCK + LBLOCK
      IC = NINTRN + 1
      IF (NBATQS.GT.0) IC = NINTRN + 1 + NBATQS + 1
      ISIZE = NREC
      IT = 7
      DO 410 I = 1,IC
         J = I - 1
         CALL ZPHFIL (FTYP(IT), 1, 0, J, PHNAME, IERR)
         CALL ZDESTR (1, PHNAME, IERR)
         CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
         IF (IERR.EQ.0) GO TO 410
            WRITE (MSGTXT,1100) FTYP(IT), IERR, J
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
 410     CONTINUE
C-----------------------------------------------------------------------
C                                       System parameters file
      IT = 8
      NREC = 1
      ISIZE = NREC
      CALL ZPHFIL (FTYP(IT), 1, 0, 0, PHNAME, IERR)
      CALL ZDESTR (1, PHNAME, IERR)
      CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
      IF (IERR.EQ.0) GO TO 455
         WRITE (MSGTXT,1100) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         GO TO 500
 455  CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.EQ.0) GO TO 460
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         GO TO 500
 460  CALL FILL (256, 0, BUFFER)
      BUFFER(1) = NVOL
      BUFFER(2) = NTAPED
C                                       Num of lines/CRT page
      BUFFER(3) = ANSWER(8) + .01
C                                       Num of lines/printer page.
      BUFFER(4) = ANSWER(9) + .01
      BUFFER(5) = NBATQS
C                                       Plotter num of X dots/page
      BUFFER(6) = ANSWER(10) + .01
C                                       Plotter num of Y dots/page
      BUFFER(7) = ANSWER(11) + .01
C                                       Plotter num of X dots/character
      BUFFER(8) = ANSWER(12) + .01
C                                       Plotter num of Y dots/character
      BUFFER(9) = ANSWER(13) + .01
      BUFFER(10) = NINTRN
C                                       Words in AP.
C                                       Zero won't work even for pseudo
      BUFFER(11) = ANSWER(16) + .01
      IF (BUFFER(11).EQ.0) BUFFER(11) = KAPWRD
      BUFFER(11) = MIN (BUFFER(11), KAPWRD)
      BUFFER(12) = NTVDEV
      BUFFER(13) = NTKDEV
C                                       Num users allowed acc to TVs
      BUFFER(64) = TVANS(1)
C                                       Num users allowed acc to TKs
      BUFFER(65) = TKANS(1) + .01
      BUFFER(66) = UCTSIZ
C                                       Max user number.
      BUFFER(67) = ANSWER(7) + .01
      BUFFER(68) = 132
C                                       words in 2nd AP memory
      BUFFER(69) = 0
C                                       Floating pt values.
      XPRDMM = ANSWER(14)
      XTKDMM = TKANS(2)
      ROBUFF(71) = XPRDMM
      ROBUFF(72) = XTKDMM
      CALL CHR2H (20, SYSNAM, 1, ROBUFF(73))
      CALL RCOPY (15, TIMEDA, ROBUFF(78))
      ROBUFF(93) = TIMESG
      ROBUFF(94) = TIMEMS
      ROBUFF(95) = TIMESC
      ROBUFF(96) = TIMECA
      CALL RCOPY (4, TIMEBA, ROBUFF(97))
      CALL RCOPY (3, TIMEAP, ROBUFF(101))
      BUFFER(224) = MAXXTK(1)
      BUFFER(225) = MAXXTK(2)
      BUFFER(226) = CSIZTK(1)
      BUFFER(227) = CSIZTK(2)
      BUFFER(228) = PRDELE
      ROBUFF(238) = AIPSMK
      IF (ROBUFF(238).LE.0.0) ROBUFF(238) = 500.0
C                                       Set device table.
      CALL COPY (50, DEVTAB, BUFFER(14))
      CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1120) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         END IF
      CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Accounting
 500  IT = 9
      NREC = 100
      ISIZE = NREC
      CALL FILL (256, 0, BUFFER)
      BUFFER(3) = 9
      BUFFER(4) = 256 / BUFFER(3)
      CALL ZPHFIL (FTYP(IT), 1, 0, 0, PHNAME, IERR)
      CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
      IF (IERR.EQ.0) GO TO 510
         IF (IERR.EQ.1) GO TO 505
            WRITE (MSGTXT,1100) FTYP(IT), IERR
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
            GO TO 550
 505     CONTINUE
            WRITE (MSGTXT,1505)
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
            GO TO 550
 510  NREC = LSIZE
      I4T = NREC * BUFFER(4) - 1
      BUFFER(2) = I4T
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.EQ.0) GO TO 520
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         GO TO 550
 520  CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1120) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         END IF
      CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Tape drive dummy files
 550  IF (NTAPED.LE.0) GO TO 600
         NREC = 0
         ISIZE = 1
         IT = 10
         DO 560 I = 1,NTAPED
            CALL ZPHFIL (FTYP(IT), 1, 1, I, PHNAME, IERR)
            CALL ZDESTR (1, PHNAME, IERR)
            CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
            IF (IERR.EQ.0) GO TO 560
               WRITE (MSGTXT,1100) FTYP(IT), IERR
               CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
 560        CONTINUE
C-----------------------------------------------------------------------
C                                       Gripes
 600  IT = 11
      NREC = 100
      ISIZE = NREC
      CALL FILL (256, 0, BUFFER)
      BUFFER(3) = 2
      BUFFER(4) = 1
      CALL ZPHFIL (FTYP(IT), 1, 0, 0, PHNAME, IERR)
      CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
      IF (IERR.EQ.0) GO TO 610
         IF (IERR.EQ.1) GO TO 605
            WRITE (MSGTXT,1100) FTYP(IT), IERR
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
            GO TO 650
 605     CONTINUE
            WRITE (MSGTXT,1605)
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
            GO TO 650
 610  BUFFER(1) = LSIZE
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.EQ.0) GO TO 620
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         GO TO 650
 620  CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1120) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         END IF
      CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Password file
 650  IT = 12
      I = 3
      J = 256 / I
      NREC = (USELIM-1) / J + 1
      ISIZE = NREC
      CALL ZPHFIL (FTYP(IT), 1, 0, 0, PHNAME, IERR)
      CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
      IF (IERR.EQ.0) GO TO 660
C                                       Creation error other than
C                                       the file already exists.
         IF (IERR.EQ.1) GO TO 655
            WRITE (MSGTXT,1100) FTYP(IT), IERR
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
            GO TO 700
C                                       PW file exists. Do not init.
 655     CONTINUE
            WRITE (MSGTXT,1655)
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
            GO TO 700
C
 660  LPASS = ' '
      CALL PASENC (LPASS, APASS)
      J = 3 * J
      DO 665 I = 1,J,3
         CALL RCOPY (3, APASS, ROBUFF(I))
 665     CONTINUE
      CALL PASENC (MPASS, ROBUFF(1))
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.EQ.0) GO TO 670
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         GO TO 700
 670  DO 680 I = 1,NREC
         IRNO = I
         CALL ZFIO ('WRIT', LUN, FIND, IRNO, BUFFER, IERR)
         IF (I.EQ.1) CALL RCOPY (3, APASS, ROBUFF(1))
         IF (IERR.EQ.0) GO TO 680
            WRITE (MSGTXT,1120) FTYP(IT), IERR
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
            GO TO 690
 680     CONTINUE
 690  CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Task communications (SHOW, TELL)
 700  IT = 13
      IC = NINTRN + 1
      IF (NBATQS.GT.0) IC = IC + NBATQS + 1
      ISIZE = 18 + 16 * IC
      CALL ZPHFIL (FTYP(IT), 1, 0, 1, PHNAME, IERR)
      CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
      IF (IERR.LE.1) GO TO 705
         WRITE (MSGTXT,1100) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         GO TO 750
 705  CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.EQ.0) GO TO 710
         WRITE (MSGTXT,1110) FTYP(IT), IERR
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
         GO TO 750
 710  DO 715 IRNO = 1,18
         CALL ZFIO ('WRIT', LUN, FIND, IRNO, ZBUF, IERR)
         IF (IERR.EQ.0) GO TO 715
            WRITE (MSGTXT,1120) FTYP(IT), IERR
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
            GO TO 720
 715     CONTINUE
 720  CALL ZCLOSE (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C                                       Enough for now!!
 750  GO TO 900
C
 900  WRITE (MSGTXT,1900)
      CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
      GO TO 995
 990  WRITE (MSGTXT,1990) IERR
      CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
C
 995  CALL ZCLOSE (TTYLUN, TTYIND, IERR)
      CALL ACOUNT (2)
C
 999  STOP
C-----------------------------------------------------------------------
 1001 FORMAT (F10.4)
 1000 FORMAT ('** ERROR **. CANNOT FIND FILE SYSPARM.  IERR=', I7)
 1030 FORMAT ('** ERROR',I7,' FROM ZEXIST ON PASSWORD FILE ***')
 1100 FORMAT ('FILE TYPE ',A2,' CREATE ERR',4I7)
 1110 FORMAT ('FILE TYPE ',A2,' OPEN ERR',4I7)
 1120 FORMAT ('FILE TYPE ',A2,' WRITE ERR',4I7)
 1205 FORMAT ('Catalog file on vol', I3,
     *   ' already exists. not superseded.')
 1353 FORMAT ('Message file user 1 already exists. Not superseded.')
 1505 FORMAT ('Accounting file already exists, not superseded.')
 1605 FORMAT ('Gripe file already exists, not superseded.')
 1655 FORMAT ('Password file already exists. Not superseded.')
 1900 FORMAT ('FILAI2: File creation/init complete')
 1990 FORMAT ('ERROR',I7,' IN TERMINAL IO')
      END

      SUBROUTINE OFINI (OPCODE, OFBUFF, DISK, CNO, VER, CATBLK, LUNOF,
     *   IOFRNO, OFKOLS, OFNUMV, NIF, NPOL, ANNAME, OBSCOD, OBSDAT,
     *   TABVER, IERR)
C-----------------------------------------------------------------------
C! Create/open/initialize Online Flags (OF) table
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2003, 2006, 2008, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes Online Flags (OF) extension tables.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'WRIT' = create/init for write or read
C                        'READ' = open for read only
C      OFBUFF   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      VER      I        OF file version
C      CATBLK   I(256)   Catalog header block.
C      LUNOF    I        Logical unit number to use
C   Input (create) / output (pre-existing) (file keywords):
C      NIF      I        Number of IFs
C      NPOL     I        Number polarizations (1 or 2)
C      ANNAME   C*8      Array name
C      OBSCOD   C*8      Observing code.
C      OBSDAT   C*8      Observing date.
C      TABVER   I        Table revision number.
C      OFNUMV   I(MAXOFC)   Element count in each column. On input only
C                        used if the file is created.
C   Output:
C      IOFRNO   I        Next record number, start of the file if
C                        'READ', the last+1 if WRITE
C      OFKOLS   I(MAXOFC)   The column pointer array in order defined in
C                        DOFV.INC.
C      IERR     I        Return error code, 0=>OK, else TABINI or TABIO
C                        error.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:DOFV.INC'
      CHARACTER OPCODE*4, ANNAME*8, OBSCOD*8, OBSDAT*8
      INTEGER   OFBUFF(512), DISK, CNO, VER, CATBLK(256), LUNOF, IOFRNO,
     *   OFKOLS(MAXOFC), OFNUMV(MAXOFC), TABVER, NIF, NPOL, IERR
C
      CHARACTER TTITLE*56, TITLE(MAXOFC)*24, UNITS(MAXOFC)*8,
     *   KEYWRD(NKEYOF)*8
      INTEGER    NKEY, NREC, DATP(128,2), NCOL, KLOCS(NKEYOF), I, JERR,
     *   KEYTYP(NKEYOF), NTTOF, NDATA, IPOINT, DTYP(MAXOFC), ITEMP(6),
     *   KEYI(NKYWOF), NC, ITRIM
      REAL      KEYR(NKYWOF)
      DOUBLE PRECISION KEYD(NKYWO2)
      HOLLERITH KEYH(NKYWOF), HOLTMP(6)
      LOGICAL    DOREAD, NEWFIL, T
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (KEYI, KEYR, KEYD, KEYH)
      EQUIVALENCE (HOLTMP, ITEMP)
      DATA NTTOF / 56 /
      DATA TTITLE / 'VLA ON-LINE FLAGS TABLE' /
      DATA KEYWRD /'NO_IF', 'NO_POL', 'ANNAME', 'OBSCODE', 'RDATE',
     *   'REVISION' /
C                                       NOTE: change DOFV.INC if the
C                                       columns are changed.
      DATA TITLE /'TIME', 'SOURCE ID', 'ANTENNA NO.', 'SUBARRAY',
     *   'FREQ ID', 'ANT FLAG', 'STATUS 1', 'STATUS 2'/
      DATA UNITS /'DAYS', 7*' ' /
      DATA T / .TRUE. /
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Set up needed variables
      NREC = 1000
      NCOL = MAXOFC - 2 + NPOL
      IF (DOREAD) NCOL = 0
      NKEY = NKEYOF
      NDATA = MAXOFC
      CALL FILL (NDATA, 0, OFKOLS)
      CALL FILL (NDATA, 0, OFNUMV)
C                                       Fill in types, lengths
C                                       See Going AIPS Vol 2 p13-3.
      IF (.NOT.DOREAD) THEN
         DTYP(OFRTIM) = TABFLT + 10
         DTYP(OFISID) = TABINT + 10
         DTYP(OFIANT) = TABINT + 10
         DTYP(OFISUB) = TABINT + 10
         DTYP(OFIFQI) = TABINT + 10
         DTYP(OFIANF) = TABINT + 10
         DTYP(OFIST1) = TABINT + 10 * NIF
         DTYP(OFIST2) = TABINT + 10 * NIF
         CALL COPY (NCOL, DTYP, DATP(1,2))
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'OF', DISK, CNO, VER, CATBLK, LUNOF, NKEY,
     *   NREC, NCOL, DATP, OFBUFF, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'OFINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
C                                       Get number of records
      IOFRNO = OFBUFF(5) + 1
      IF (DOREAD) IOFRNO = 1
      NKEY = NKEYOF
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 40 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, OFBUFF, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'OFINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, OFBUFF, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'OFINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTTOF, TTITLE, 1, OFBUFF(101))
C                                       Set keyword values
C                                       Number of IFs
         KLOCS(1) = 1
         KEYTYP(1) = TABINT
         KEYI(KLOCS(1)) = NIF
C                                       Number of Polarizations
         KLOCS(2) = 2
         KEYTYP(2) = TABINT
         KEYI(KLOCS(2)) = NPOL
C                                       arrat name
         KLOCS(3) = 3
         KEYTYP(3) = TABHOL
         CALL CHR2H (8, ANNAME, 1, KEYI(KLOCS(3)))
C                                       Observing code
         KLOCS(4) = 5
         KEYTYP(4) = TABHOL
         CALL CHR2H (8, OBSCOD, 1, KEYI(KLOCS(4)))
C                                       Observing date
         KLOCS(5) = 7
         KEYTYP(5) = TABHOL
         CALL CHR2H (8, OBSDAT, 1, KEYI(KLOCS(5)))
C                                       Table revision number
         KLOCS(6) = 9
         KEYTYP(6) = TABINT
         KEYI(KLOCS(6)) = OFREV
C                                       Write to the OF table
         CALL TABKEY ('WRIT', KEYWRD, NKEYOF, OFBUFF, KLOCS, KEYI,
     *      KEYTYP, IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'OFINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         CALL TABKEY ('READ', KEYWRD, NKEYOF, OFBUFF, KLOCS, KEYI,
     *      KEYTYP, IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'OFINI', IERR)
            GO TO 990
            END IF
C                                       Number of IFs
         NIF = KEYI(KLOCS(1))
C                                       Number polarizations
         NPOL = KEYI(KLOCS(2))
C                                       Observing code
         CALL H2CHR (8, 1, KEYH(KLOCS(3)), ANNAME)
C                                       Observing code
         CALL H2CHR (8, 1, KEYH(KLOCS(4)), OBSCOD)
C                                       Observing date
         CALL H2CHR (8, 1, KEYH(KLOCS(5)), OBSDAT)
C                                       Table revision number
         TABVER = KEYI(KLOCS(6))
         END IF
C                                       Get array indices
C                                       Cover your ass from FNDCOL -
C                                       close to flush the buffers and
C                                       then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KEYI, OFBUFF, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'OFINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'OF', DISK, CNO, VER, CATBLK, LUNOF, NKEY,
     *   NREC, NCOL, DATP, OFBUFF, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'OFINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (MAXOFC, TITLE, 24, T, OFBUFF, OFKOLS, JERR)
C                                       Get array indices and no. values
      NCOL = MAXOFC - 2 + NPOL
      IF (NPOL.LT.2) OFNUMV(OFIST2) = 0
      DO 150 I = 1,NCOL
         IPOINT = OFKOLS(I)
         IF (IPOINT.GT.0) THEN
            OFKOLS(I) = DATP(IPOINT,1)
            OFNUMV(I) = DATP(IPOINT,2) / 10
            IF (OFNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            OFKOLS(I) = -1
            OFNUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('OFINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('OFINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('OFINI: ERROR INITIALIZING ON-LINE FLAGS TABLE FOR ', A4)
      END

LOCAL INCLUDE 'BDAPL.INC'
C                                       local include for BDAPL
      INTEGER   SEQ1, SEQ2, SEQO, DISK1, DISK2, DISKO, CNO1, CNO2, CNOO,
     *   VERS, NUMPOL, NUMFRQ, NUMIF, NUMANT, CATOLD(256,2)
      CHARACTER NAME1*12, NAME2*12, NAMEO*12, CLAS1*6, CLAS2*6, CLASO*6
      HOLLERITH XNAM1(3), XNAM2(3), XNAMO(3), XCLAS1(2), XCLAS2(2),
     *   XCLASO(2)
      REAL      XSEQ1, XSEQ2, XSEQO, XDISK1, XDISK2, XDISKO, XVERS,
     *   XCENT, DIFPIX
      DOUBLE PRECISION UVSCAL
      COMMON /INPARM/ XNAM1, XCLAS1, XSEQ1, XDISK1, XNAM2, XCLAS2,
     *   XSEQ2, XDISK2, XVERS, XNAMO, XCLASO, XSEQO, XDISKO, XCENT
      COMMON /VALS/ CATOLD, UVSCAL, SEQ1, SEQ2, SEQO, DISK1, DISK2,
     *   DISKO, CNO1, CNO2, CNOO, VERS, NUMPOL, NUMFRQ, NUMIF, NUMANT,
     *   DIFPIX
      COMMON /CHVALS/ NAME1, NAME2, NAMEO, CLAS1, CLAS2, CLASO
LOCAL END
      PROGRAM BDAPL
C-----------------------------------------------------------------------
C! Applies BD table of one file to another
C# UV Calibration EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2013-2015, 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BDAPL applies a BD table of one file to another writing a 3rd
C   UV data set
C   Adverbs:
C      INNAME      UV data set to calibrate: name
C      INCLASS     UV data set to calibrate: class
C      INSEQ       UV data set to calibrate: seq #
C      INDISK      UV data set to calibrate: disk
C      IN2NAME     UV data set with BD table: name
C      IN2CLASS    UV data set with BD table: class
C      IN2SEQ      UV data set with BD table: seq #
C      INDISK      UV data set with BD table: class
C      BLVERS      BD table version #
C      OUTNAME     Output UV data set: name
C      OUTCLASS    Output UV data set: class
C      OUTSEQ      Output UV data set: seq #
C      OUTDISK     Output UV data set: disk
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      REAL      BDVALS(2)
      LONGINT   PBDVAL
      INTEGER   IRET, SCRTCH(256)
      INCLUDE 'BDAPL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'BDAPL '/
C-----------------------------------------------------------------------
C                                       Initialize
      CALL BDAPLI (PRGM, BDVALS, PBDVAL, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Edit tables
      CALL BDAPLD (NUMPOL, NUMFRQ, NUMIF, NUMANT, BDVALS(1+PBDVAL),
     *   IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Add history to output
      CALL BDAPLH
C                                       Close down files, etc
 995  CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE BDAPLI (PRGM, BDVALS, PBDVAL, IRET)
C-----------------------------------------------------------------------
C   Starts up BDAPL, sets common variables, allocates big memory and
C   fills it with the BD table values
C   Inputs:
C      PRGM     C*6    Program name
C   Outputs:
C      BDVALS   R(*)   Address for large memory to be based
C      PBDVAL   L      Pointer into BDVALS for large memory
C      IRET     I      Error code
C-----------------------------------------------------------------------
      CHARACTER PRGM*(*)
      REAL      BDVALS(*)
      LONGINT   PBDVAL
      INTEGER   IRET
C
      CHARACTER TYPE*2, STAT*4, BLANK*6
      INTEGER   SCRTCH(256), NPARM, IROUND, IERR, IVER, LUN, LUNTMP,
     *   BDBUFF(512), BDKOLS(10), BDNUMV(10), IBDRNO, NEED, INCX
      INCLUDE 'INCS:PUVD.INC'
      REAL      BNDPAS(2*MAXCIF)
      INCLUDE 'BDAPL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK /' '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 23
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAM1, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAM1, NAME1)
      CALL H2CHR (12, 1, XNAM2, NAME2)
      CALL H2CHR (12, 1, XNAMO, NAMEO)
      CALL H2CHR (6, 1, XCLAS1, CLAS1)
      CALL H2CHR (6, 1, XCLAS2, CLAS2)
      CALL H2CHR (6, 1, XCLASO, CLASO)
      SEQ1 = XSEQ1 + 0.1
      SEQ2 = XSEQ2 + 0.1
      SEQO = XSEQO + 0.1
      DISK1 = XDISK1 + 0.1
      DISK2 = XDISK2 + 0.1
      DISKO = XDISKO + 0.1
      VERS = IROUND (XVERS)
C                                       Find input
      TYPE = 'UV'
      CNO1 = 1
      CALL CATDIR ('SRCH', DISK1, CNO1, NAME1, CLAS1, SEQ1, TYPE,
     *   NLUSER, STAT, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET, NAME1, CLAS1, SEQ1, DISK1, NLUSER
         GO TO 990
         END IF
C                                       Read old CATBLK and mark 'READ'
      CALL CATIO ('READ', DISK1, CNO1, CATBLK, 'READ', SCRTCH, IRET)
      IF ((IRET.GT.0) .AND. (IRET.LT.5)) THEN
         WRITE (MSGTXT,1040) IRET
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK1
      FCNO(NCFILE) = CNO1
      FRW(NCFILE) = 0
      CALL COPY (256, CATBLK, CATOLD(1,1))
C                                       BD file data set
      IF (SEQ2.LE.0) SEQ2 = SEQ1
      IF (DISK2.LE.0) DISK2 = DISK1
      IF (NAME2.EQ.' ') NAME2 = NAME1
      IF (CLAS2.EQ.' ') CLAS2 = CLAS1
      CNO2 = 1
      CALL CATDIR ('SRCH', DISK2, CNO2, NAME2, CLAS2, SEQ2, TYPE,
     *   NLUSER, STAT, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET, NAME2, CLAS2, SEQ2, DISK2, NLUSER
         GO TO 990
         END IF
C                                       Read old CATBLK and mark 'READ'
      CALL CATIO ('READ', DISK2, CNO2, CATBLK, 'READ', SCRTCH, IRET)
      IF ((IRET.GT.0) .AND. (IRET.LT.5)) THEN
         WRITE (MSGTXT,1040) IRET
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK2
      FCNO(NCFILE) = CNO2
      FRW(NCFILE) = 0
C                                       check on BD table
      CALL FNDEXT ('BD', CATBLK, IVER)
      IF (IVER.LE.0) THEN
         MSGTXT = 'IN2NAME DOES NOT HAVE A BD TABLE'
         IRET = 10
         GO TO 990
         END IF
      IF ((VERS.LE.0) .OR. (VERS.GT.IVER)) VERS = IVER
      CALL COPY (256, CATBLK, CATOLD(1,2))
C                                       channel, IF structure
      CALL COPY (256, CATOLD(1,1), CATBLK)
      CALL UVPGET (IRET)
C                                       open BD file
      LUN= LUNTMP (1)
      CALL BDINI ('READ', BDBUFF, DISK2, CNO2, VERS, CATOLD(1,2), LUN,
     *   IBDRNO, BDKOLS, BDNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ, IRET)
      IF (CATBLK(KINAX+JLOCS).LT.NUMPOL) THEN
         MSGTXT = 'INPUT FILE HAS TOO FEW POLARIZATIONS'
         IRET = 9
         GO TO 990
         END IF
      IF (CATBLK(KINAX+JLOCF).NE.NUMFRQ) THEN
         MSGTXT = 'INPUT FILE DOES NOT MATCH NUMBER CHANNELS'
         IRET = 9
         GO TO 990
         END IF
      IF (CATBLK(KINAX+JLOCIF).NE.NUMIF) THEN
         MSGTXT = 'INPUT FILE DOES NOT MATCH NUMBER IFS'
         IRET = 9
         GO TO 990
         END IF
C                                       allocate memory
      NEED = NUMANT * NUMANT * NUMFRQ * NUMIF * NUMPOL
      NEED = (NEED - 1) / 1024 + 2
      CALL ZMEMRY ('GET ', TSKNAM, NEED, BDVALS, PBDVAL, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'COULD NOT GET NEEDED DYNAMIC MEMORY'
         GO TO 990
         END IF
      NEED = NEED * 1024
      CALL RFILL (NEED, FBLANK, BDVALS(1+PBDVAL))
C                                       read BD table
      CALL BDREAD (NUMPOL, NUMANT, NUMIF, NUMFRQ, BDVALS(1+PBDVAL),
     *   BNDPAS, BDBUFF, BDKOLS, BDNUMV, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       create output file
C                                       Put new values in CATBLK.
      IF (JLOCF.LT.0) XCENT = -1.
      IF (XCENT.LE.0.0) THEN
         UVSCAL = 1.0D0
         DIFPIX = 0.0
      ELSE
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
         UVSCAL = CATD(KDCRV+JLOCF) / FREQ
         END IF
      CALL MAKOUT (NAME1, CLAS1, SEQ1, BLANK, NAMEO, CLASO, SEQO)
      CALL CHR2H (12, NAMEO, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLASO, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQO
      CNOO = 1
      CALL UVCREA (DISKO, CNOO, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, 'CREATING OUTPUT FILE'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CNOO
      FRW(NCFILE) = 2
C                                       Copy any header keywords
      CALL KEYCOP (DISK1, CNO1, DISKO, CNOO, IRET)
      IF (IRET.NE.0) GO TO 999
      SEQO = CATBLK(KIIMS)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' GETING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',I3,
     *   ' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1010 FORMAT ('BDAPLI ERROR',I5,' ON ',A)
      END
      SUBROUTINE BDREAD (NUMPOL, NUMANT, NUMIF, NUMFRQ, BDVALS, BNDPAS,
     *   BDBUFF, BDKOLS, BDNUMV, IRET)
C-----------------------------------------------------------------------
C   Reads in the bd table and closes it at the end
C   Inputs:
C      NUMPOL   I      Number polarizations (1, 2)
C      NUMANT   I      Max antenna number
C      NUMIF    I      Number IFs
C      NUMFRQ   I      Number spectral channels
C      BDKOLS   I(*)   Column pointers
C      BDNUMV   I(*)   Column sizes
C   In/Out
C      BDVALS   R(*)   BD table array
C      BDBUFF   I(*)   BD table IO control block
C   Output:
C      IRET     I      Error code
C-----------------------------------------------------------------------
      INTEGER   NUMPOL, NUMANT, NUMIF, NUMFRQ, BDBUFF(*), BDKOLS(*),
     *   BDNUMV(*), IRET
      REAL      BDVALS(NUMFRQ,NUMIF,NUMANT,NUMANT,*),
     *   BNDPAS(2,NUMFRQ,NUMIF,*)
C
      INTEGER   IBDRNO, IROW, NROWS, LP, LI, LF, SOURID, SUBA, ANT1,
     *   ANT2, FREQID
      REAL      TIME(2), DBG(2,256,2)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      NROWS = BDBUFF(5)
      DO 100 IROW = 1,NROWS
         IBDRNO = IROW
         CALL TABBD ('READ', BDBUFF, IBDRNO, BDKOLS, BDNUMV, NUMIF,
     *      NUMFRQ, NUMPOL, TIME, SOURID, SUBA, ANT1, ANT2, FREQID,
     *      BNDPAS, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING BD TABLE'
            GO TO 990
            END IF
         CALL RCOPY (1024, BNDPAS, DBG)
         DO 50 LP = 1,NUMPOL
            DO 40 LI = 1,NUMIF
               DO 30 LF = 1,NUMFRQ
                  BDVALS(LF,LI,ANT1,ANT2,LP) = BNDPAS(1,LF,LI,LP)
                  BDVALS(LF,LI,ANT2,ANT1,LP) = BNDPAS(2,LF,LI,LP)
 30               CONTINUE
 40            CONTINUE
 50         CONTINUE
 100     CONTINUE
      CALL TABBD ('CLOS', BDBUFF, IBDRNO, BDKOLS, BDNUMV, NUMIF,
     *   NUMFRQ, NUMPOL, TIME, SOURID, SUBA, ANT1, ANT2, FREQID,
     *   BNDPAS, IRET)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BDREAD ERROR:',I5,' ON ',A)
      END
      SUBROUTINE BDAPLD (NP, NF, NI, NA, BDVALS, IRET)
C-----------------------------------------------------------------------
C   BPAPLD applies the BD corrections to the data writing out the new
C   UV data set
C   Inputs:
C      NP       I      Number polarizations (1, 2)
C      NF       I      Number spectral channels
C      NI       I      Number IFs
C      NA       I      Max antenna number
C      BDVALS   R(*)   BD table values (f,i,a1,a2,p)
C   Outputs:
C      IRET     I      Error code
C-----------------------------------------------------------------------
      INTEGER   NP, NF, NI, NA, IRET
      REAL      BDVALS(NF,NI,NA,NA,*)
C
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'BDAPL.INC'
      INTEGER   LUNI, INDI, LUNO, INDO, NCOPY, NCORO, ILENBU, VO, BO,
     *   IPTRO, NIOUT, NIOLIM, JBUFSZ, NUMVIS, ILOCWT, RNXRET, IBIND,
     *   KBIND, INIO, I, IPTRI
      REAL      BUFFI(UVBFSS), BUFFO(UVBFSS), UBUFF(UVBFSS)
      CHARACTER FILE*48
      LOGICAL   T, F, ISCOMP
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA T,F /.TRUE.,.FALSE./
      DATA LUNI, LUNO /28,29/
C-----------------------------------------------------------------------
C                                       visibility file
      CALL ZPHFIL ('UV', DISK1, CNO1, 1, FILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISK1, FILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN INPUT UV'
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CNOO, 1, FILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, FILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OUTPUT UV'
         GO TO 990
         END IF
C                                       Find weight and scale.
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            IRET = 9
            GO TO 990
            END IF
         END IF
C                                       Init vis file for write
      NCOPY = LREC - NRPARM
      NCORO = (LREC - NRPARM) / CATBLK(KINAX)
      ILENBU = 0
      VO = 0
      BO = 1
      JBUFSZ = UVBFSS  * 2
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LREC, ILENBU,
     *   JBUFSZ, BUFFO, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT OUTPUT UV'
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, ILENBU,
     *   JBUFSZ, BUFFI, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT INPUT UV'
         GO TO 990
         END IF
      NUMVIS = 0
C                                       make an index table
      CALL RNXGET (DISK1, CNO1, CATOLD(1,1))
      CALL RNXINI (DISKO, CNOO, CATBLK, RNXRET)
C                                       Loop
C                                       Read vis. record.
 100  CALL UVDISK ('READ', LUNI, INDI, BUFFI, INIO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ INPUT UV DATA'
         GO TO 990
         END IF
      IF (INIO.GT.0) THEN
         IPTRI = IBIND
         DO 190 I = 1,INIO
C                                       move random parameters
            BUFFI(IPTRI+ILOCU) = BUFFI(IPTRI+ILOCU) * UVSCAL
            BUFFI(IPTRI+ILOCV) = BUFFI(IPTRI+ILOCV) * UVSCAL
            BUFFI(IPTRI+ILOCW) = BUFFI(IPTRI+ILOCW) * UVSCAL
            CALL RCOPY (NRPARM, BUFFI(IPTRI), BUFFO(IPTRO))
C                                       compressed
            IF (ISCOMP) THEN
               CALL ZUVXPN (NCORO, BUFFI(IPTRI+NRPARM),
     *            BUFFI(IPTRI+ILOCWT), UBUFF)
               CALL SCALIT (NF, NI, NA, NP, BDVALS, BUFFO(IPTRO), UBUFF,
     *            IRET)
               IF (IRET.EQ.0) CALL ZUVPAK (NCORO, UBUFF,
     *            BUFFO(IPTRO+ILOCWT), BUFFO(IPTRO+NRPARM))
C                                       Decide if it's kept, select
            ELSE
               CALL SCALIT (NF, NI, NA, NP, BDVALS, BUFFO(IPTRO),
     *            BUFFI(IPTRI+NRPARM), IRET)
               IF (IRET.EQ.0) CALL RCOPY (NCOPY, BUFFI(IPTRI+NRPARM),
     *            BUFFO(IPTRO+NRPARM))
               END IF
            NUMVIS = NUMVIS + 1
            IF (MOD(NUMVIS-1,50000).EQ.0) THEN
               WRITE (MSGTXT,1010) NUMVIS
               CALL MSGWRT (2)
               END IF
            NIOUT = NIOUT + 1
C                                       update NX table
            CALL RNXUPD (BUFFO(IPTRO), RNXRET)
            IPTRI = IPTRI + LREC
            IPTRO = IPTRO + LREC
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFFO, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRIT OUTPUT UV'
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
         GO TO 100
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFFO, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINISH OUTPUT UV'
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = NUMVIS
      CALL UCMPRS (NVIS, DISKO, CNOO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BDAPLD ERROR',I5,' ON ',A)
 1010 FORMAT ('At visibility',I10)
      END
      SUBROUTINE SCALIT (NF, NI, NA, NP, BDVALS, RPARM, VIS, IRET)
C-----------------------------------------------------------------------
C   SCALIT applies the scaling to a visibility sample
C   Inputs:
C      NP       I      Number polarizations (1, 2)
C      NF       I      Number spectral channels
C      NI       I      Number IFs
C      NA       I      Max antenna number
C      BDVALS   R(*)   BD table values (f,i,a1,a2,p)
C      RPARM    R(*)   Input random parameters
C   in/out
C      VIS      R(*)   Output data
C   Outputs
C      IRET     I      Error code
C-----------------------------------------------------------------------
      INTEGER   NF, NI, NA, NP, IRET
      REAL      BDVALS(NF,NI,NA,NA,*), RPARM(*), VIS(3,*)
C
      INTEGER   IA1, IA2, LI, LF, LP, INCX, LNCIF, LNCF, LNCS, IND
      REAL      BASL, CR, CI, TR, TI
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (ILOCB.GE.0) THEN
         BASL = RPARM(1+ILOCB)
         IA1 = BASL / 256.0 + 0.01
         IA2 = (BASL - IA1*256) + 0.01
      ELSE
         IA1 = RPARM(1+ILOCA1) + 0.1
         IA2 = RPARM(1+ILOCA2) + 0.1
         END IF
      INCX = CATBLK(KINAX)
      LNCIF = INCIF / INCX
      LNCF = INCF / INCX
      LNCS = INCS / INCX
      IF (IA1.NE.IA2) THEN
C                                       blank improper
         IF ((IA1.LE.0) .OR. (IA2.LE.0) .OR. (IA1.GT.NA) .OR.
     *      (IA2.GT.NA)) THEN
            DO 30 LP = 1,NP
               DO 20 LI = 1,NI
                  IND = 1 + (LI - 1) * LNCIF + (LP - 1) * LNCS
                  DO 10 LF = 1,NF
                     VIS(3,IND) = -ABS(VIS(3,IND))
                     IND = IND + LNCF
 10                  CONTINUE
 20               CONTINUE
 30            CONTINUE
C                                       cal
         ELSE
            DO 80 LP = 1,NP
               DO 70 LI = 1,NI
                  IND = 1 + (LI - 1) * LNCIF + (LP - 1) * LNCS
                  DO 60 LF = 1,NF
                     IF (VIS(3,IND).GT.0.0) THEN
                        CR = BDVALS(LF,LI,IA1,IA2,LP)
                        CI = -BDVALS(LF,LI,IA2,IA1,LP)
                        TR = CR * VIS(1,IND) + CI * VIS(2,IND)
                        TI = CR * VIS(2,IND) - CI * VIS(1,IND)
                        VIS(1,IND) = TR
                        VIS(2,IND) = TI
                        CR = CR * CR + CI * CI
                        IF (CR.GT.0.0) THEN
                           VIS(3,IND) = VIS(3,IND) / CR
                        ELSE
                           VIS(3,IND) = 0.0
                           END IF
                        END IF
                     IND = IND + LNCF
 60                  CONTINUE
 70               CONTINUE
 80            CONTINUE
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE BDAPLH
C-----------------------------------------------------------------------
C   writes HIstory and copies tables
C-----------------------------------------------------------------------
C
      CHARACTER HILINE*72, NOTTYP(2)*2
      INTEGER   LUN1, LUN2, IERR, NONOT, BUFF1(256), BUFF2(256)
      INCLUDE 'BDAPL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1, LUN2 /27,28/
      DATA NONOT, NOTTYP /2, 'NX','BD'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISK1, DISKO, CNO1, CNOO, CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAME1, CLAS1, SEQ1, DISK1, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      IF ((DISK1.NE.DISK2) .OR. (CNO1.NE.CNO2)) THEN
         CALL HENCO2 (TSKNAM, NAME2, CLAS2, SEQ2, DISK2, LUN2, BUFF2,
     *      IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
      CALL HENCOO (TSKNAM, NAMEO, CLASO, SEQO, DISKO, LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       BD table version written
      WRITE (HILINE,1010) TSKNAM, VERS
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Close HI file
 190  CALL HICLOS (LUN2, .TRUE., BUFF2, IERR)
C                                       Copy tables
 200  CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISK1, DISKO, CNO1,
     *   CNOO, CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR IN COPYING TABLES TO OUTPUT FILE'
         CALL MSGWRT (6)
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (DISKO, CNOO, DIFPIX, BUFF1, BUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'BDAPLH: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK
      CALL CATIO ('UPDT', DISKO, CNOO, CATBLK, 'REST', BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' COPYING TO NEW HI FILE')
 1010 FORMAT (A6,'BLVERS = ',I3,' / BD table used')
      END

      SUBROUTINE UNPACK (N, KF, KT)
C-----------------------------------------------------------------------
C! converts a packed character buffer into one with 1 character/integer
C# Obsolete Character
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   UNPACK unpacks a tight to a loose character buffer.  The operation
C   is defined as X/Y = X/b, Y/b.
C   Inputs:
C      N   I         # characters in input buffer
C      KF  R(*)      input tight buffer
C   Outputs:
C      KT  I(N)      output loose buffer
C-----------------------------------------------------------------------
      HOLLERITH KF(*)
      INTEGER   N, KT(*)
C
      INTEGER   J1, J2, IT, KTP, I, IBLANK
      HOLLERITH RBLANK
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (IBLANK, RBLANK)
C-----------------------------------------------------------------------
      RBLANK = HBLANK
      IF (N.LE.0) GO TO 999
         KTP = 1
         DO 10 I = 1, N
            KT(KTP) = IBLANK
            J1 = (I-1) / 4 + 1
            J2 = MOD (I-1, 4) + 1
            CALL ZGETCH (IT, KF(J1), J2)
            CALL ZPUTCH (IT, KT(KTP), 1)
            KTP = KTP + 1
 10         CONTINUE
C
 999  RETURN
      END

      SUBROUTINE EULROT (AZ1, POL1, EULER, AZ2, POL2, ROTN)
C-----------------------------------------------------------------------
C! Apply Euler angle based rotation of spherical coordinates.
C# Math Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   EULROT applies the Euler angle based rotation of spherical
C   coordinates.
C   Inputs
C      AZ1     D      Azimuthal and polar angles in the old
C      POL1    D      coordinate system, in degrees.
C      EULER   D(5)   Euler angles for the rotation.
C                     1) (PHI0) Longitude of the ascending node in the
C                        old system, in degrees.  The ascending node is
C                        the point of intersection of the equators of
C                        the two systems such that the equator of the
C                        new system crosses from south to north as
C                        viewed in the old system.
C                     2) (THETA) The angle between the poles of the two
C                        systems.  THETA is positive for a positive
C                        rotation about the ascending node.
C                     3) (PHI) Longitude of the ascending node in the
C                        new system, in degrees. 
C                     4) (CTHETA) = cos(THETA).
C                     5) (STHETA) = sin(THETA).
C   Outputs;
C      AZ2     D      Azimuthal and polar angles in the new coordinate
C      POL2    D      system, in degrees.  AZ2 lies between 0 and 360
C      ROTN    D      The position angle of the old pole at the
C                     specified point, in degrees.
C   Algorithm:
C      A coordinate rotation specified by the three Euler angles.
C   Notes:
C      1) Longitude at the poles in the new system is consistent with
C         that specified in the old system.  This may be important
C         when dealing with map projections in which the poles are
C         represented by finite line segments.  Such is the case for
C         cylindrical projections for example.
C   Author: Mark Calabretta, Australia Telescope.
C      Origin; 1988/Oct/05. Code last modified; 1990/Aug/15
C-----------------------------------------------------------------------
      DOUBLE PRECISION   AZ1, POL1, EULER(5), AZ2, POL2, ROTN
C
      DOUBLE PRECISION   AZ1P, CAZ1P, CPOL1, CTHETA, D2R, PHI0, PHI, PI,
     *   R2D, SAZ1P, SPOL1, STHETA, THETA, X, Y
      PARAMETER (PI = 3.141592653589793238462643D0)
      PARAMETER (D2R = PI/180D0)
      PARAMETER (R2D = 180D0/PI)
C-----------------------------------------------------------------------
C                                       The following assignments are
C                                       made for convenience
      PHI0   = EULER(1)
      THETA  = EULER(2)
      PHI    = EULER(3)
      CTHETA = EULER(4)
      STHETA = EULER(5)
C                                       Compute trigonometric functions
C                                       of the old coordinates
      AZ1P  = AZ1 - PHI0
      CAZ1P = COS (AZ1P*D2R)
      SAZ1P = SIN (AZ1P*D2R)
      CPOL1 = COS (POL1*D2R)
      SPOL1 = SIN (POL1*D2R)
C                                       Compute the azimuthal angle in
C                                       the new system
      X = CPOL1 * CAZ1P
      Y = CPOL1 * SAZ1P *CTHETA + SPOL1 * STHETA
      IF ((X.NE.0D0) .OR. (Y.NE.0D0)) THEN
         AZ2 = PHI + ATAN2 (Y, X) * R2D
C                                       Longitude at the poles in the
C                                       new system is consistent with
C                                       that specified in the old system
      ELSE
         AZ2 = PHI + AZ1P
         END IF
C                                       Compute the polar angle in the
C                                       new system
      POL2 = ASIN (SPOL1*CTHETA - CPOL1*STHETA*SAZ1P) * R2D
C                                       Compute the position angle of
C                                       the old pole at this point
      X = SAZ1P * STHETA * SPOL1 + CTHETA * CPOL1
      Y = CAZ1P * STHETA
      ROTN = ATAN2 (Y, X) * R2D
C                                       Normalize
      AZ2 = MOD (AZ2, 360D0)
      IF (AZ2.LT.0D0) AZ2 = AZ2 + 360D0
C
 999  RETURN
      END

      SUBROUTINE QGET (APCORE, HOST, AP, N, TYPE)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Move data from pseudo-AP memory to "host".
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Transfer data from pseudo-AP core to normal core
C   Inputs:
C      AP     I  Target area in AP; 0-relative
C      N      I  Number of elements
C      TYPE   I  Data type:
C                 1     data is INTEGER in host
C                 else  data is REAL    in host
C   Output:
C      HOST   R/I(*)  Data array in "host"
C   NOTE WELL: the data in the AP is DOUBLE PRECISION and INTEGER*8
C   DO NOT LIE ABOUT THE TYPE YOU WANT OR YOU WILL GET BAD VALUES
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   AP, N, TYPE
      REAL      HOST(*)
C
      INTEGER   I
      LONGINT   JAP
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (TYPE.GT.2) GO TO 999
      IF (N.LE.0) GO TO 999
C                                       Integer data
      IF (TYPE.EQ.1) THEN
         CALL QGET2 (APCORE, HOST, AP, N)
C                                       Real data
      ELSE
         JAP = AP + PSAPOF - 1
         DO 50 I = 1,N
            HOST(I) = APCORE(JAP+I)
 50         CONTINUE
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER   NPARMS
C                                       NPARMS=no. adverbs passed.
      PARAMETER (NPARMS=12)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                                       NOTE: Uses values in PAOOF.INC
C                                       Adverb names
C                     1         2          3        4         5
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INEXT',
C           6         7         8          9         10        11
     *   'INVERS', 'OUTEXT', 'OUTVERS', 'BCOUNT', 'ECOUNT', 'COLNAME',
C           12
     *   'OUTCOL'/
C                                       Adverb data types (PAOOF.INC)
C                    1       2       3       4       5
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOACAR,
C          6       7       8       9       10      11
     *   OOAINT, OOACAR, OOAINT, OOAINT, OOAINT, OOACAR,
c          12
     *   OOACAR/
C                                       Adverb dimensions (as 2D)
C                   1    2    3    4    5
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 2,1,
C         6    7    8    9    10    11
     *   1,1, 2,1, 1,1, 1,1, 1,1, 16,30,
C          12
     *   16,30/
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(10)
      LOGICAL   LDUM(10)
      REAL      RDUM(10)
      DOUBLE PRECISION DDUM(5)
      EQUIVALENCE (DDUM, RDUM, IDUM, LDUM)
      COMMON /TBDIFG/ DDUM
LOCAL END
      PROGRAM TBSUB
C-----------------------------------------------------------------------
C! Select a subset of a table and write a new table.
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2009, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Copy a subset of one table to a new table
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, INTAB*36, OUTTAB*36
      INTEGER  IRET, BUFF1(256)
      DATA PRGM /'TBSUB '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL SUBTIN (PRGM, INTAB, OUTTAB, IRET)
C                                       Process table
      IF (IRET.EQ.0) CALL SUBTAB (INTAB, OUTTAB, IRET)
C                                       History
      IF (IRET.EQ.0) CALL SUBTHI (OUTTAB)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE SUBTIN (PRGN, INTAB, OUTTAB, IRET)
C-----------------------------------------------------------------------
C   SUBTIN gets input parameters for TBSUB and creates the input and
C   output objects
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6, INTAB*(*), OUTTAB*(*)
C
      INTEGER   NKEY1, NKEY2
C                                       NKEY1=no. adverbs to copy to
C                                       INTAB
      PARAMETER (NKEY1=9)
C                                       NKEY2=no. adverbs to copy to
C                                       OUTTAB
      PARAMETER (NKEY2=7)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to INTAB
C                   1         2          3        4         5
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INEXT',
C           6         7                   9
     *   'INVERS', 'BCOUNT', 'ECOUNT', 'COLNAME'/
C                                       May rename adverbs to INTAB
C                    1       2        3        4       5
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'TBLTYPE',
C           6      7         8         9
     *   'VER', 'BCOUNT', 'ECOUNT', 'COLNAME'/
C                                       Adverbs to copy to OUTTAB
C                   1         2          3        4         5
      DATA INK2 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'OUTEXT',
C           6         7
     *   'OUTVERS', 'OUTCOL'/
C                                       May rename adverbs to OUTTAB
C                    1       2        3        4       5
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'TBLTYPE',
C           6      7
     *   'VER', 'OUTCOL'/
C-----------------------------------------------------------------------
C                                       Startup,  returns "Input" object
C                                       containing POPS adverbs
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create input object
      INTAB = 'Input table'
      CALL CREATE (INTAB, 'TABLE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, INTAB, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create Output Object
      OUTTAB = 'Output table'
      CALL CREATE (OUTTAB, 'TABLE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, OUTTAB, IRET)
      IF (IRET.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE SUBTAB (INTAB, OUTTAB, IERR)
C-----------------------------------------------------------------------
C   Copy table.
C   Inputs:
C      INTAB   C*   Name of input table object.
C      OUTTAB  C*   Name of output table object.
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*), OUTTAB*(*)
      INTEGER   IERR
C
      INTEGER   MAXSIZ
C                                       MAXSIZ = max table entry size as
C                                       reals or characters.
      PARAMETER (MAXSIZ = 5000)
      INTEGER   ROW, NCOMP, TYPE, DIM(7), NCOL, ICOLS(256), OCOLS(256),
     *   BC, EC, I, OROW
      REAL      NVALS(MAXSIZ)
      CHARACTER CVALS*(MAXSIZ), CDUMMY*1
      INCLUDE 'GFORT'
C-----------------------------------------------------------------------
C                                       Open input table
      CALL OOPEN (INTAB, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
C                                        Deal with headers
      CALL THEAD (INTAB, OUTTAB, NCOL, ICOLS, OCOLS, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        Open output table
      CALL OOPEN (OUTTAB, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get number of entries
      CALL OGET (INTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IERR)
      NCOMP = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'BCOUNT', TYPE, DIM, IDUM, CDUMMY, IERR)
      BC = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      BC = MIN (MAX (BC, 1), NCOMP)
      CALL OGET (INTAB, 'ECOUNT', TYPE, DIM, IDUM, CDUMMY, IERR)
      EC = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      IF (EC.LE.0) EC = NCOMP
C                                       Convert tables
      OROW = 0
      DO 100 ROW = BC,EC
         OROW = OROW + 1
         DO 50 I = 1,NCOL
            CALL TABDGT (INTAB, ROW, ICOLS(I), TYPE, DIM, NVALS, CVALS,
     *         IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TABDPT (OUTTAB, OROW, OCOLS(I), TYPE, DIM, NVALS,
     *         CVALS, IERR)
            IF (IERR.NE.0) GO TO 999
 50         CONTINUE
 100     CONTINUE
C                                       Close tables
      CALL OCLOSE (INTAB, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OCLOSE (OUTTAB, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE SUBTHI (OUTTAB)
C-----------------------------------------------------------------------
C   Routine to write history file to output table object.
C   Inputs:
C      OUTTAB  C*?  Output table object
C-----------------------------------------------------------------------
      CHARACTER OUTTAB*(*)
C
      INTEGER   NADV
      PARAMETER (NADV=11)
      CHARACTER LIST(NADV)*8
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'INEXT', 'INVERS',
     *   'BCOUNT', 'ECOUNT', 'COLNAME', 'OUTEXT', 'OUTVERS', 'OUTCOL'/
C-----------------------------------------------------------------------
C                                       Add task label to history
      CALL OHTIME (OUTTAB, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy adverb values.
      CALL OHLIST ('Input', LIST, NADV, OUTTAB, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // OUTTAB
      CALL MSGWRT (4)
 999  RETURN
      END
      SUBROUTINE THEAD (INTAB, OUTTAB, NCOL, ICOLS, OCOLS, IERR)
C-----------------------------------------------------------------------
C   Set header stuff
C   Inputs:
C      INTAB   C*?  Name of input table object
C      OUTTAB  C*?  Name of output table object
C   Output:
C      NCOL    I    The number of columns to copy
C      ICOLS   I    List of column numbers in input table
C      OCOLS   I    List of column numbers in output table
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*), OUTTAB*(*)
      INTEGER   NCOL, ICOLS(*), OCOLS(*), IERR
C
C                                        MAXCOL = max number cols.
      INTEGER   MAXCOL
      PARAMETER (MAXCOL=128)
      CHARACTER COL*8, COLLAB(MAXCOL)*16, CLAB*(16*MAXCOL), TTITLE*56,
     *   OUTLAB(MAXCOL)*16, OLAB*(16*MAXCOL),
     *   TITLE(MAXCOL)*24, CTITLE*(24*MAXCOL),
     *   UNITS(MAXCOL)*8, CUNITS*(MAXCOL*8),
     *   OUTT(MAXCOL)*24, COUTT*(MAXCOL*24),
     *   OUTU(MAXCOL)*8, COUTU*(MAXCOL*8), CDUMMY*1
      INTEGER   TYPE, DIM(7), COLTYP(MAXCOL), COLDIM(MAXCOL), I, J,
     *   OUTTYP(MAXCOL), OUTDIM(MAXCOL), NC, IEND, JEND, NICOL
      LOGICAL   BADCOL
      INCLUDE 'GFORT'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
C                                       Need to equivalence character
C                                       arrays for OGET/OPUT
      EQUIVALENCE (COLLAB, CLAB), (TITLE, CTITLE), (UNITS, CUNITS)
      EQUIVALENCE (OUTT, COUTT), (OUTU, COUTU), (OUTLAB, OLAB)
C-----------------------------------------------------------------------
      NCOL = 0
      BADCOL = .FALSE.
C                                        Fetch Input table info
      CALL OGET (INTAB, 'COLNAME', TYPE, DIM, IDUM, CLAB, IERR)
      IF (IERR.NE.0) GO TO 999
      NICOL = DIM(2)
      CALL OGET (INTAB, 'NCOL', TYPE, DIM, IDUM, CDUMMY, IERR)
      NC = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'LABEL', TYPE, DIM, IDUM, TTITLE, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'COLABEL', TYPE, DIM, IDUM, CTITLE, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'COLUNIT', TYPE, DIM, IDUM, CUNITS, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'COLTYPE', TYPE, DIM, COLTYP, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'COLDIM', TYPE, DIM, COLDIM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        Fetch output col. labels
      CALL OGET (OUTTAB, 'OUTCOL', TYPE, DIM, IDUM, OLAB, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        Look up columns in input
      DO 500 I = 1,NICOL
C                                        Blank entry?
         IF (COLLAB(I).NE.' ') THEN
C                                        Given column number?
            IF (COLLAB(I)(1:5) .EQ. 'COL#(') THEN
C                                       Parse column number.
               JEND = INDEX (COLLAB(I), ')') - 1
C                                        Found closing )?
               IF (JEND.LE.0) GO TO 310
               IEND = MAX (JEND, 6)
               COL = ' '
               COL(14-IEND:8) = COLLAB(I)(6:IEND)
               READ (COL,1000,ERR=310) J
C                                       Valid column number?
               IF ((J.LE.0) .OR. (J.GT.NC)) THEN
C                                        Invalid column number
                  MSGTXT = 'INVALID COLUMN NUMBER: ' // COLLAB(I)
                  CALL MSGWRT (6)
                  BADCOL = .TRUE.
                  GO TO 500
                  END IF
C                                       Looks OK - process
               GO TO 320
            ELSE
C                                       Check list of column names
               DO 300 J = 1,NC
                  IF (COLLAB(I).EQ.TITLE(J)(1:16)) GO TO 320
 300             CONTINUE
               END IF
C                                        If it got here the column
C                                        wasn't found.
            MSGTXT = 'COULD NOT FIND COLUMN: '// COLLAB(I)
            CALL MSGWRT (6)
            MSGTXT = 'CHECK SPELLING, IGNORING REQUEST'
            CALL MSGWRT (6)
            BADCOL = .TRUE.
            GO TO 500
C                                        Decode error for col.
 310        MSGTXT = 'ERROR DECODING COLUMN NUMBER: ' // COLLAB(I)
            CALL MSGWRT (6)
            BADCOL = .TRUE.
            GO TO 500
C                                        OK: Save column values
 320        NCOL = NCOL + 1
            ICOLS(NCOL) = J
            OCOLS(NCOL) = NCOL
            OUTT(NCOL) = TITLE(J)
C                                        Change label?
            IF (OUTLAB(I).NE.' ') OUTT(NCOL) = OUTLAB(I)
            OUTU(NCOL) = UNITS(J)
            OUTTYP(NCOL) = COLTYP(J)
            OUTDIM(NCOL) = COLDIM(J)
            END IF
 500     CONTINUE
C                                        Better have some columns
      IF (NCOL.LE.0) THEN
         MSGTXT = 'ERROR: NO COLUMNS SELECTED'
         CALL MSGWRT (8)
         IERR = 5
         GO TO 999
         END IF
C                                        Warn if bad columns detected.
      IF (BADCOL) THEN
         MSGTXT = 'Warning: Problems were encountered in selecting' //
     *      ' some columns'
         CALL MSGWRT (6)
         END IF
C                                        Set values for new table
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      IDUM(1) = NCOL
      CALL  OPUT (OUTTAB, 'NCOL', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      DIM(1) = 56
      CALL OPUT (OUTTAB, 'LABEL', OOACAR, DIM, IDUM, TTITLE, IERR)
      IF (IERR.NE.0) GO TO 999
      DIM(1) = 24
      DIM(2) = NCOL
      CALL OPUT (OUTTAB, 'COLABEL', OOACAR, DIM, IDUM, COUTT, IERR)
      IF (IERR.NE.0) GO TO 999
      DIM(1) = 8
      CALL OPUT (OUTTAB, 'COLUNIT', OOACAR, DIM, IDUM, COUTU, IERR)
      IF (IERR.NE.0) GO TO 999
      DIM(1) = NCOL
      DIM(2) = 1
      CALL OPUT (OUTTAB, 'COLTYPE', OOAINT, DIM, OUTTYP, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OPUT (OUTTAB, 'COLDIM', OOAINT, DIM, OUTDIM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I8)
      END

      SUBROUTINE DAT2JD (IT, JD)
C-----------------------------------------------------------------------
C! converts date and time to a Julian date
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DAT2JD converts current date/time to Real*8 Julian Date
C   Inputs:
C      IT   I(6)   yy,mm,dd  hh,mm,ss  (binary)
C                  yy should be full year: if < 40 => 2000+, else 1900+
C   Output:
C      JD   D      Julian date
C-----------------------------------------------------------------------
      INTEGER   IT(6)
      DOUBLE PRECISION  JD
C
      INTEGER   MY, MM, IC
      DOUBLE PRECISION  DCE, EPS, DYA, DMA, DZERO, D60, D24, D2, D4, D5
      DATA DCE /146097.0D0/,     DYA /1461.0D0/
      DATA DMA /153.0D0/,        EPS /0.01D0/
      DATA D2, D4, D5, D24, D60 /2.D0,4.D0,5.D0,24.D0,60.D0/
      DATA DZERO /1721119.0D0/
C-----------------------------------------------------------------------
      MY = IT(1)
      IF (MY.LT.40) MY = MY + 2000
      IF (MY.LT.200) MY = MY + 1900
      IF (IT(2).GT.2) THEN
         MM = IT(2) - 3
      ELSE
         MM = IT(2) + 9
         MY = MY - 1
         END IF
 10   IC = MY / 100
      MY = MY - IC * 100
      JD = AINT ((DCE*IC)/D4 + EPS)  +  AINT ((DYA*MY)/D4 + EPS)
     *   + AINT ((DMA*MM+D2)/D5 + EPS)  +  IT(3) + DZERO - 0.5
     *   + ((IT(6)/D60 + IT(5))/D60 + IT(4))/D24
C
 999  RETURN
      END

      SUBROUTINE ZTPOPR (LUN, FIND, IVOL, PNAME, OPER, IERR)
C-----------------------------------------------------------------------
C! open  remote tape or pseudo-tape device
C# Tape Z2
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2002, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Open a remote tape drive on a computer supporting the TPMON protocol
C   for sequential, "map" (double buffered, asynchronous) I/O or open
C   a pseudo-tape sequential disk file.  Exclusive use and wait to open
C   are assumed.
C   Inputs:
C      LUN     I       Logical unit number (129 > LUN >= 129 - NTAPED
C                         => tape, else disk)
C      FIND    I       Pointer into FTAB (open)
C      IVOL    I       Tape drive #
C      PNAME   C*48    tape logical name (AMT0n) or
C                      disk physical file name (logical:file)
C      OPER    C*4     'READ' => read only or 'WRIT' => read/write
C   Output:
C      IERR    I       Error return code: 0 => no error
C                         2 => file not found
C                         4 => exclusive use denied
C                         6 => other open errors
C   Common:
C      TPDNAM  C       Remote machine name for pseudo-tapes
C   Generic version - checks logical (real tapes) then calls ZVTPO2.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IVOL, IERR
      CHARACTER PNAME*48, OPER*4
C
      INTEGER   ITRIM, I, J, IBUF(20), NBACK, NBACKE
      CHARACTER XLATED*256, LNAME*48
      HOLLERITH HLATED(64), HBUF(20)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (IBUF, HBUF)
      DATA NBACKE /0/
C-----------------------------------------------------------------------
C                                       tape
      IF ((LUN.LT.129) .AND. (LUN.GE.129-NTAPED)) THEN
         I = ITRIM (PNAME)
         CALL ZTRLOG (I, PNAME, 256, XLATED, J, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'ZMOUNT: UNABLE TO TRANSLATE LOGICAL NAME ='
            CALL MSGWRT (7)
            MSGTXT = '''' // PNAME(:I) // ''''
            CALL MSGWRT (7)
            MSGTXT = 'DID YOU DO A MOUNT???'
            CALL MSGWRT (7)
            GO TO 999
            END IF
         LNAME = ' '
C                                       pseudo-tape
      ELSE
         XLATED = 'aipsmt0:' // TPDNAM
         LNAME = PNAME
         END IF
C                                       call ZVTPO2: open socket
      I = ITRIM (XLATED)
      CALL CHR2H (256, XLATED, 1, HLATED)
      CALL ZVTPO2 (FTAB(FIND+MOFF), I, HLATED, IERR)
      IF (IERR.NE.0) THEN
          WRITE (MSGTXT,1000) IERR
          CALL MSGWRT (7)
          GO TO 999
          END IF
C                                       Open tape device
C                                       pack buffer: header
      CALL ZCLC8 (8, 'ZTPOPN  ', 1, HBUF)
      CALL ZILI32 (1, 15, 3, IBUF)
      CALL ZILI32 (1, 0, 4, IBUF)
      CALL ZILI32 (1, 0, 5, IBUF)
C                                       pack buffer: data
      CALL ZILI32 (1, LUN, 6, IBUF)
      CALL ZILI32 (1, IVOL, 7, IBUF)
      CALL ZCLC8 (4, OPER, 29, HBUF)
      CALL ZCLC8 (48, LNAME, 33, HBUF)
C
      NBACK = NBACKE
      CALL ZVTPX2 (FTAB(FIND+MOFF), 15, NBACK, IBUF, IERR)
      IF (IERR.EQ.4) THEN
         WRITE (MSGTXT,1025)
         CALL MSGWRT (7)
      ELSE IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1005) IERR
         CALL MSGWRT (7)
      ELSE
         CALL ZI32IL (1, 5, IBUF, IERR)
         IF (IERR.NE.0) THEN
            IF (XLATED(7:7).EQ.'0' .AND. IERR.EQ.8) THEN
               WRITE (MSGTXT, 1030)
            ELSE
               WRITE (MSGTXT,1010) IERR
               END IF
            CALL MSGWRT (7)
            END IF
         END IF
      IF ((IERR.EQ.0) .AND. (NBACK.NE.NBACKE)) THEN
         WRITE (MSGTXT,1015) NBACK, NBACKE
         CALL MSGWRT (6)
         END IF
C                                       Close on error
      IF (IERR.NE.0) THEN
         CALL ZVTPC2 (FTAB(FIND+MOFF), I)
         IF (I.NE.0) THEN
            WRITE (MSGTXT,1020) I
            CALL MSGWRT (7)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZTPOPR: ZVTPO2 RETURNS ERROR CODE',I7)
 1005 FORMAT ('ZTPOPR: ZVTPX2 RETURNS ERROR CODE',I7)
 1010 FORMAT ('ZTPOPR: REMOTE TAPE SYSTEM RETURNS ERROR CODE',I7)
 1015 FORMAT ('ZTPOPR: WARNING - GOT BACK',I3,' WORDS, EXPECTED',I3)
 1020 FORMAT ('ZTPOPR: ERROR',I5,' CLOSING THE SOCKET TOO')
 1025 FORMAT ('ZTPOPR: AIPS TPHOSTS PERMISSION DENIED ON REMOTE HOST')
 1030 FORMAT ('ZTPOPR: FILE EXISTS ON REMOTE DISK, CANNOT OVERWRITE IT')
      END

      SUBROUTINE OTBSRT (DISK, CNO, TYPE, INVER, OUTVER, BUFFER, BUFSZ,
     *   TABUFF, CATBLK, KEY, FKEY, ISCR, IERR)
C-----------------------------------------------------------------------
C! Copies sorted table from scratch file to table form
C# Ext-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2003, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Reads old numbers from the scratch file and writes the new table
C   file. Called by TABSRT.
C   Inputs:
C      DISK     I        Disk number of the file.
C      CNO      I        Catalog slot number.
C      TYPE     C*2      Two character type code (e.g. 'CC')
C      INVER    I        Input version number
C      OUTVER   I        Output version number
C      BUFFER   I(*)     I/O work buffer
C      BUFSZ    I        Size of BUFFER in bytes.
C      TABUFF   I(512)   Buffer large enough to handle I/O to table.
C                        File assumed previously opened and the values
C                        for the input file are in the array and the
C                        input table file should be open.
C      CATBLK   I(256)   Catalog header record.
C      KEY      I(2,2)   Sort keys: may be linear combination of two
C                        numeric value columns.  KEY contains the column
C                        numbers and FKEY contains the factors.  If the
C                        column is a string (bit or char.) then
C                        FKEY(1,n)=first char/bit and FKEY(2,n)=number
C                        of char/bit and KEY(2,n) is ignored.
C                        KEY(2,n)=0 => ignore, <0 => use abs. value.
C                        Column no. is the logical number.
C      FKEY     R(2,2)   Key coefficients, 0 => 1, see above.
C      ISCR     I        /CFILES/ scratch file number of scratch file.
C      LENBU    I        Buffer length in records.
C   Output:
C       IERR    I        Return error code: 0 = OK
C                           8 = I/O error.
C   Usage note: all files will be closed on successful return.
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, INVER, OUTVER, BUFSZ, BUFFER(*), TABUFF(*),
     *   CATBLK(256), KEY(2,2), ISCR, IERR
      CHARACTER TYPE*2
      REAL      FKEY(2,2)
C
      CHARACTER PHNAME*48, ERRTYP(7)*4, CHTMP*2, OUTNAM*48
      INTEGER   FINDO, FINDN, IER, OVO, I, J, LIM, LER, LTYE, NTYE, II,
     *   IND, LUN, BIND, NIO, LUNNEW, LUNOLD, NIOUT, NPRPLR, NLRPPR,
     *   IROFF, LRECO, NICOPY, IBOFF, BO, VO, NUMREC, RECNO, IRNO,
     *   RFIRST, OLDRNO, MRNO, NFIRST, ISIZE, LSIZE, OTVER
      LOGICAL   T, F, BIG
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA BO, VO /1, 0/
      DATA ERRTYP /' OLD',' NEW', 'OPEN','READ','WRIT','CREA', 'SCR '/
C-----------------------------------------------------------------------
C                                       Get number of records.
      NUMREC = TABUFF(5)
C                                       Open scratch (index) file.
      LUN = 16
      CALL ZPHFIL ('SC', SCRVOL(ISCR), SCRCNO(ISCR), 1, PHNAME, IERR)
      CALL ZOPEN (LUN, IND, SCRVOL(ISCR), PHNAME, T, T, T, IERR)
      IF (IERR.NE.0) THEN
         IND = 0
         WRITE (MSGTXT,1000) IERR, 'READ'
         GO TO 995
         END IF
C                                       Init scratch file.
      LRECO = 2 + TABUFF(8)
      NICOPY = TABUFF(8)
      NIOUT = 1
      CALL UVINIT ('READ', LUN, IND, NUMREC, VO, LRECO, NIOUT, BUFSZ,
     *   BUFFER, BO, BIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, 'READ'
         GO TO 995
         END IF
C                                       Find in catalog header
      OVO = 0
      CALL FXHDEX (CATBLK)
      DO 30 I = 1,KIEXTN
         II = KHEXT + I - 1
         CALL H2CHR (2, 1, CATBLK(II), CHTMP)
         IF (TYPE.EQ.CHTMP) OVO = I
 30      CONTINUE
C                                       Set output version number
      LIM = CATBLK(KIVER+OVO-1) + 1
      IF ((OVO.LE.0) .OR. (LIM.LE.0)) THEN
         IERR = 2
         MSGTXT = 'ERROR IN CATALOG HEADER - NO EXTENSION OF TYPE '
     *      // TYPE
         GO TO 995
         END IF
      IF (OUTVER.LE.0) OUTVER = LIM
      IF (OUTVER.GT.LIM) OUTVER = LIM
C                                       Get number of records in file
      MRNO = TABUFF(1)
C                                       Get LUN, FIND for old file
      LUNOLD = TABUFF(81)
      LUNNEW = LUNOLD - 1
      FINDO = TABUFF(82)
C                                       Get control info.
      BIG = TABUFF(9).LT.0
      NPRPLR = 1
      NLRPPR = 1
C                                       No. log. rec / phys. rec
      IF (TABUFF(9).GT.0) NLRPPR = TABUFF(9)
C                                       No. phys. rec / log. rec
      IF (TABUFF(9).LT.0) NPRPLR = -TABUFF(9)
      OLDRNO = -1
C                                       Initialize control record.
C                                       Set sort order
      TABUFF(43) = KEY(1,1)
      IF (TABUFF(43).LT.0) TABUFF(43) = 256 - KEY(1,1)
      TABUFF(44) = KEY(1,2)
      IF (TABUFF(44).LT.0) TABUFF(44) = 256 - KEY(1,2)
      IF (FKEY(1,1).LT.0.0) TABUFF(43) = -TABUFF(43)
      IF (FKEY(1,2).LT.0.0) TABUFF(44) = -TABUFF(44)
C                                       Other control info.
      TABUFF(32) = DISK
      CALL ZDATE (TABUFF(33))
      CALL ZTIME (TABUFF(36))
      CALL ZPHFIL (TYPE, DISK, CNO, OUTVER, OUTNAM, IER)
      CALL CHR2H (48, OUTNAM, 1, TABUFF(17))
      CALL CHR2H (6, TSKNAM, 1, TABUFF(39))
C                                       Go to SC file
      OTVER = 2
      CALL ZPHFIL ('SC', DISK, CNO, OTVER, PHNAME, IER)
      ISIZE = MRNO
C                                       Does it already exist
      CALL ZEXIST (DISK, PHNAME, LSIZE, IERR)
C                                       destroy mystery one
      IF (IERR.NE.1) THEN
         CALL ZDESTR (DISK, PHNAME, IERR)
         WRITE (MSGTXT,1022) IERR
         IF (IERR.GT.2) GO TO 995
         END IF
C                                       Create
      CALL ZCREAT (DISK, PHNAME, ISIZE, F, LSIZE, IERR)
      LTYE = 7
      NTYE = 6
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1020) IERR
         IF (IERR.EQ.3) MSGTXT = 'OTBSRT: INSUFFICIENT SPACE ON DISK'
         IF (IERR.EQ.5) WRITE (MSGTXT,1021)
         GO TO 995
         END IF
C                                       Open output (SC) file
      CALL ZOPEN (LUNNEW, FINDN, DISK, PHNAME, F, T, T, IERR)
      LTYE = 7
      IF (IERR.NE.0) THEN
         NTYE = 3
         FINDN = 0
         GO TO 800
         END IF
C                                       Write first record
      IRNO = 1
      NTYE = 5
      CALL ZFIO ('WRIT', LUNNEW, FINDN, IRNO, TABUFF, IERR)
      IF (IERR.NE.0) GO TO 800
C                                       Copy remaining header records
      NFIRST = TABUFF(50)
      DO 50 IRNO = 2,NFIRST
         LTYE = 1
         NTYE = 4
         CALL ZFIO ('READ', LUNOLD, FINDO, IRNO, TABUFF(257), IERR)
         IF (IERR.NE.0) GO TO 800
         LTYE = 7
         NTYE = 5
         CALL ZFIO ('WRIT', LUNNEW, FINDN, IRNO, TABUFF(257), IERR)
         IF (IERR.NE.0) GO TO 800
 50      CONTINUE
C                                       Begin loop copying records
      DO 300 RECNO = 1,NUMREC
C                                       Read next index
         CALL UVDISK ('READ', LUN, IND, BUFFER, NIO, BIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) 'READ', IERR
            CALL MSGWRT (8)
            GO TO 800
            END IF
C                                       Check if BIG
         IF (.NOT.BIG) THEN
C                                       Get file record number and
C                                       word offset.
            RFIRST = (RECNO-1) / NLRPPR
            IRNO = NFIRST + RFIRST
            IROFF = (RECNO - (RFIRST * NLRPPR) - 1) * TABUFF(8)
C                                       If new record and OLDRNO.gt.0
C                                       write last record.
            IF ((IRNO.NE.OLDRNO) .AND. (OLDRNO.GT.0)) THEN
               NTYE = 5
               LTYE = 7
               CALL ZFIO ('WRIT', LUNNEW, FINDN, OLDRNO, TABUFF(257),
     *            IERR)
               IF (IERR.NE.0) GO TO 800
               END IF
            OLDRNO = IRNO
C                                       Copy record
            CALL COPY (NICOPY, BUFFER(BIND+2), TABUFF(257+IROFF))
C                                       Big records
         ELSE
C                                       Get file record number.
            IRNO = NFIRST + (RECNO-1) * NPRPLR
C                                       Loop
            DO 290 J = 1,NPRPLR
C                                       Set offset
               IBOFF = 2 + (J-1) * 256
               NTYE = 5
               LTYE = 2
               CALL ZFIO ('WRIT', LUNNEW, FINDN, IRNO,
     *            BUFFER(BIND+IBOFF), IERR)
               IF (IERR.NE.0) GO TO 800
C                                       Update record pointers
               IRNO = IRNO + 1
 290           CONTINUE
            END IF
 300     CONTINUE
C                                       Flush output buffer if nec.
      NTYE = 5
      LTYE = 7
      IF (.NOT.BIG) THEN
         CALL ZFIO ('WRIT', LUNNEW, FINDN, OLDRNO, TABUFF(257), IERR)
         IF (IERR.NE.0) GO TO 800
         END IF
      GO TO 950
C                                       Error, destroy file.
 800  IF (FINDN.GT.0) CALL ZCLOSE (LUNNEW, FINDN, LER)
      CALL ZDESTR (DISK, PHNAME, LER)
      FINDN = 0
C                                       Report error
      WRITE (MSGTXT,1900) IERR, ERRTYP(NTYE), ERRTYP(LTYE),
     *   TYPE, INVER, OUTVER
      IF (IERR.GT.0) CALL MSGWRT (6)
C                                       Close files
 950  CALL ZCLOSE (LUN, IND, LER)
      CALL ZCLOSE (LUNOLD, FINDO, LER)
      IF (FINDN.GT.0) CALL ZCLOSE (LUNNEW, FINDN, LER)
C                                       remove any old OUTVER and
C                                       rename SC to OUTVER
      IF (IERR.EQ.0) THEN
         CALL ZEXIST (DISK, OUTNAM, LSIZE, IERR)
         IF (IERR.EQ.0) CALL ZDESTR (DISK, OUTNAM, IERR)
         IF (IERR.GT.2) THEN
            WRITE (MSGTXT,1950) IERR
            CALL MSGWRT (8)
            CALL ZDESTR (DISK, PHNAME, LER)
         ELSE
            CALL ZRENAM (DISK, PHNAME, OUTNAM, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1955) IERR
               CALL MSGWRT (8)
               CALL ZDESTR (DISK, PHNAME, LER)
               END IF
            END IF
         END IF
C                                       No error only:
C                                       Update CATBLK
      IF (IERR.EQ.0) THEN
         I = KIVER + OVO - 1
         CATBLK(I) = MAX (OUTVER, CATBLK(I))
         IF (CATBLK(I).GE.LIM) CALL CATIO ('UPDT', DISK, CNO, CATBLK,
     *      'REST', TABUFF, IERR)
         END IF
      GO TO 999
C                                       Error
 995  CALL MSGWRT (8)
      IF (IND.GT.0) CALL ZCLOSE (LUN, IND, LER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OTBSRT: ERROR',I3,' OPEN FOR ',A4,' INPUT FILE')
 1010 FORMAT ('OTBSRT: ERROR',I3,' INIT FOR ',A4,' INPUT FILE')
 1020 FORMAT ('OTBSRT: ERROR',I3,' CREATING OUTPUT TABLE FILE')
 1021 FORMAT ('OTBSRT: DISK PROHIBITED FOR CREATING OUTPUT TABLE FILE')
 1022 FORMAT ('OTBSRT: ERROR',I5,' DELETING ANTIQUE SCRATCH TABLE')
 1050 FORMAT ('OTBSRT:',A4,' ERROR ',I3,' ON INPUT FILE')
 1900 FORMAT ('OTBSRT: ERROR',I5,1X,A4,'ING ',A4,1X,A2,' FILE VERS',
     *   I4,' TO',I4)
 1950 FORMAT ('OTBSRT: ERROR',I5,' REMOVING OLD COPY OF EXTENSION FILE')
 1955 FORMAT ('OTBSRT: ERROR',I5,' ERROR RENAMING SCR TABLE TO OUTPUT')
      END

      SUBROUTINE YCREAD (IPLANE, IX, IY, CATBLK ,IERR)
C-----------------------------------------------------------------------
C! read the image catalog, return image header for TV only
C# Y0 TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Read image catalog block into CATBLK - TV only (TK in TKCATL)
C   Inputs:
C      IPLANE  I       plane containing image whose block is wanted
C      IX      I       X pixel coordinate of a point within image
C      IY      I       Y pixel coordinate of point within image
C   Outputs:
C      CATBLK  I(256)  Image catalog block
C      IERR    I       error codes: 0 => ok
C                         1 => IX, IY lies outside image
C                         2 => Catalog i/o errors
C                         3 => refers to TK device
C   VERSION for TV by COMMUNICATION
C-----------------------------------------------------------------------
      INTEGER   IPLANE, IX, IY, CATBLK(256), IERR
C
      INTEGER   CATI(256)
      HOLLERITH CATH(256)
      REAL      CATR(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DVTV.INC'
      EQUIVALENCE (CATI, CATH, CATR, CATD, BUFFER(1025))
C-----------------------------------------------------------------------
C                                       send request
      BUFSR = 302
      BUFSW = 3
      BUFFER(1) = IPLANE
      BUFFER(2) = IX
      BUFFER(3) = IY
C                                       do it
      CALL MKYBUF ('READ', 'YCREAD', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
C                                       unpack header
      IF (IERR.EQ.0) THEN
         CALL UNYBUF (BUFSR, BUFFER, HEADER)
         CALL HDRBUF (2, CATI, CATH, CATR, CATD, BUFFER(4))
         CALL COPY (256, CATI, CATBLK)
         END IF
C
 999  RETURN
      END

      SUBROUTINE AU9A (BRANCH)
C-----------------------------------------------------------------------
C! verbs to read TEK cursor and display pixel, sky, image values
C# POPS-appl Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000, 2002, 2007, 2009, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Activate, read, interpret TEKTRONIX 4012 cursor for the following
C   verbs:
C      BRANCH   I      1 TKXY     find map pixel coordinate for cursor.
C                      2 TKPOS    find sky coordinate for cursor.
C                      3 TKVAL    find Y value.
C                      4 TKERASE  Erase screen
C   Outputs:
C      PIXXY    R(2)   map pixel positions set by TKXY.
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      CHARACTER UNITS*8, SPTXT*20, PREFIX*5, PRGNAM*6, CDUM*1
      DOUBLE PRECISION SKYPOS(3)
      REAL      RPOS(2), XFAC, XOFF, PIXMAX, PIXMIN, VY0, VY1, VX0, VX1,
     *   PY0, PY1, DX, DY, S, YVAL, PIXX(7), TKPAWS, VZ0, VZ1, RDUM(2)
      INTEGER   IOBLK(256), I, I4XTRA, ICH, IERR, IERR2, ILEN, IPX0,
     *   IPX1, IPY0, IPY1, ITX0, ITX1, ITY0, ITY1, ITYPE, IX, IY, IT,
     *   INOSL, IDROP(2), I2TMP1, IDUM
      LOGICAL   FLAG, TKOPEN, SPECTR
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTKS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGNAM /'AU9A '/
      DATA TKPAWS /1.5/
C-----------------------------------------------------------------------
      TKOPEN = .FALSE.
      ERRNUM = 15
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.4)) GO TO 980
      ERRNUM = 37
      IF (NTKDEV.LE.0) GO TO 980
      ERRNUM = 0
C                                       Open the TEK
      CALL ZTKOPN (IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TEKTRONIX OPEN ERROR'
         CALL MSGWRT (6)
         GO TO 970
         END IF
      TKOPEN = .TRUE.
      IF (BRANCH.EQ.4) GO TO 90
C                                       Read TEK image catalog header.
      IX = 0
      IY = 0
      CALL TKCATL ('READ', IX, IY, CATBLK, IERR)
      IF ((IERR.GT.0) .AND. (IERR.NE.11)) THEN
         MSGTXT = 'TEKTRONIX CATALOG ERROR'
         GO TO 960
         END IF
C                                       Set some header values.
      ITYPE = CATBLK(IIPLT)
      ITX0 = CATBLK(IICOR)
      ITY0 = CATBLK(IICOR+1)
      ITX1 = CATBLK(IICOR+2)
      ITY1 = CATBLK(IICOR+3)
      IPX0 = CATBLK(IIWIN)
      IPY0 = CATBLK(IIWIN+1)
      IPX1 = CATBLK(IIWIN+2)
      IPY1 = CATBLK(IIWIN+3)
C                                       Treat KNTR plots like CNTR
      IF (ITYPE.EQ.18) ITYPE = 2
C                                       Test for invalid plot type.
C                                       TKVAL and not slice plot.
      IF ((BRANCH.EQ.2) .AND. (ITYPE.NE.5)) THEN
         MSGTXT = 'TKVAL CAN BE USED ONLY WITH SLICE PLOTS.'
         GO TO 960
         END IF
C
      GO TO (15, 40, 40, 15, 40, 40), ITYPE
C                                       Invalid plot type.
         WRITE (MSGTXT,1010) ITYPE
         GO TO 960
C                                       Misc plot type.
 15      WRITE (MSGTXT,1015)
         GO TO 960
C                                       Profile plot type.
 20      WRITE (MSGTXT,1020)
         GO TO 960
C                                       Open TEKTRONIX device.
C                                       read cursor & close
 40   CALL TKCURS (IOBLK, IX, IY, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TEKTRONIX READ CURSOR ERROR'
         GO TO 960
         END IF
C                                       Check for pixel off plot.
      IF (((IX.LT.ITX0) .OR. (IX.GT.ITX1)) .OR.
     *   ((IY.LT.ITY0) .OR. (IY.GT.ITY1))) THEN
         WRITE (MSGTXT,1040) IX, IY, ITX0, ITX1, ITY0, ITY1
         GO TO 960
         END IF
C                                       Find the map pixel position.
C                                       Determine type of plot.
      GO TO (15, 60, 60, 20, 70, 60), ITYPE
C                                       Contour or grey scale
C                                       or polarization vector.
 60      RPOS(1) = REAL(IX - ITX0) / REAL(ITX1 - ITX0)
     *      * (IPX1 - IPX0)   +  IPX0
         RPOS(2) = REAL(IY - ITY0) / REAL(ITY1 - ITY0)
     *      * (IPY1 - IPY0)   +  IPY0
         GO TO 90
C                                       Slice file.
C                                       Set slice vector pixel coord.
 70   CONTINUE
         I4XTRA = IIOTH + 3
         IDROP(1) = CATBLK(IIOTH+1)
         IDROP(2) = CATBLK(IIOTH+2)
         INOSL = IPX1 - IPX0 + IDROP(1) + IDROP(2) + 1
         VX0 = CATR(I4XTRA  )
         VY0 = CATR(I4XTRA+1)
         VX1 = CATR(I4XTRA+2)
         VY1 = CATR(I4XTRA+3)
         VZ0 = CATR(I4XTRA+4)
         VZ1 = CATR(I4XTRA+5)
         SPECTR = ABS(VZ1-VZ0).GE.1.0
         IF (SPECTR) THEN
            DX = (VZ1 - VZ0) / INOSL
            VZ0 = VZ0 + DX * IDROP(1)
            VZ1 = VZ1 - DX * IDROP(2)
            RPOS(1) = REAL(IX - ITX0) / REAL(ITX1 - ITX0)
     *         * (VZ1 - VZ0) + VZ0
            RPOS(2) = 0.0
         ELSE
            DX = (VX1 - VX0) / INOSL
            DY = (VY1 - VY0) / INOSL
            VX0 = VX0 + DX * IDROP(1)
            VY0 = VY0 + DY * IDROP(1)
            VX1 = VX1 - DX * IDROP(2)
            VY1 = VY1 - DY * IDROP(2)
            RPOS(1) = REAL(IX - ITX0) / REAL(ITX1 - ITX0)
     *         * (VX1 - VX0) + VX0
            RPOS(2) = REAL(IX - ITX0) / REAL(ITX1 - ITX0)
     *         * (VY1 - VY0) + VY0
            END IF
C                                       Branch to correct verb.
 90   GO TO (100, 200, 300, 400), BRANCH
C-----------------------------------------------------------------------
C                                       TKPOS
C                                       Calc & print sky coordinates.
C-----------------------------------------------------------------------
C                                       print freq position for spectra
 100     IF (SPECTR) THEN
            CALL H2CHR (8, 1, CATH(KHCTP+4), UNITS)
            SKYPOS(1) = CATD(KDCRV+2) + (RPOS(1)-CATR(KRCRP+2)) *
     *         CATR(KRCIC+2)
            CALL AXSTRN (UNITS, SKYPOS(1), 2, I, MSGTXT)
            CALL MSGWRT (5)
            RPOS(1) = (VX0 + VX1) / 2.0
            RPOS(2) = (VY0 + VY1) / 2.0
            MSGTXT = 'Centered on XY coordinate:'
            CALL MSGWRT (5)
            END IF
C                                       then do sky coordinate
         LOCNUM = 1
         CALL MP2SKY (RPOS, SKYPOS, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR
            GO TO 960
            END IF
         IF ((AXTYP(LOCNUM).EQ.2) .OR. (AXTYP(LOCNUM).EQ.3)) CALL AXSTRN
     *      (CTYP(3,LOCNUM), SKYPOS(3), KLOCA(LOCNUM), NCHLAB(1,LOCNUM),
     *      SAXLAB(1,LOCNUM))
         WRITE (MSGTXT,1105)
         ICH = 9
         DO 110 I = 1,2
            I2TMP1 = I - 1
            CALL AXSTRN (CTYP(I,LOCNUM), SKYPOS(I), I2TMP1, ILEN, SPTXT)
            MSGTXT(ICH:) = SPTXT(:ILEN)
            ICH = ILEN + ICH + 2
 110        CONTINUE
         CALL MSGWRT (5)
         WRITE (MSGTXT,1105)
         ICH = 9
         DO 120 I = 1,2
            IF (NCHLAB(I,LOCNUM).LE.0) GO TO 120
               MSGTXT(ICH:) = SAXLAB(I,LOCNUM)(:NCHLAB(I,LOCNUM))
               ICH = NCHLAB(I,LOCNUM) + ICH + 2
 120        CONTINUE
         IF (ICH.GT.9) CALL MSGWRT (5)
         GO TO 980
C-----------------------------------------------------------------------
C                                       TKVAL
C-----------------------------------------------------------------------
C                                       Slice plot only
 200     PIXMAX = CATR(IRRAN+1)
         PIXMIN = CATR(IRRAN)
         XFAC = 39999.0 / (PIXMAX - PIXMIN)
         XOFF = 40000.0 - XFAC * PIXMAX
         PY0 = (IPY0 - XOFF) / XFAC
         PY1 = (IPY1 - XOFF) / XFAC
         YVAL = REAL(IY - ITY0) / REAL(ITY1 - ITY0)
     *      * (PY1 - PY0)  +  PY0
         RDUM(1) = YVAL
         CALL ADVRBS ('PIXVAL', 'R', 1, 0, IDUM, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
C                                       Get rational units.
         S = YVAL
         CALL METSCA (S, PREFIX, FLAG)
         CALL H2CHR (8, 1, CATH(KHBUN), UNITS)
C                                       Print Y value.
         IF (FLAG) WRITE (MSGTXT,1200) S, UNITS
         IF (.NOT.FLAG) WRITE (MSGTXT,1202) S, PREFIX, UNITS
         CALL MSGWRT (5)
         GO TO 980
C-----------------------------------------------------------------------
C                                       TKXY
C-----------------------------------------------------------------------
 300     IF (SPECTR) THEN
            PIXX(3) = RPOS(1)
            RPOS(1) = (VX0 + VX1) / 2.0
            RPOS(2) = (VY0 + VY1) / 2.0
            WRITE (MSGTXT,1300) RPOS, PIXX(3)
         ELSE
            PIXX(3) = CATBLK(IIDEP)
            WRITE (MSGTXT,1300) RPOS
            END IF
         PIXX(1) = RPOS(1)
         PIXX(2) = RPOS(2)
         CALL MSGWRT (5)
         DO 310 I = 4,7
            PIXX(I) = CATBLK(IIDEP+I-3)
 310        CONTINUE
         CALL ADVRBS ('PIXXY', 'R', 7, 0, IDUM, PIXX, CDUM)
         GO TO 980
C-----------------------------------------------------------------------
C                                       TKERASE
C-----------------------------------------------------------------------
C                                       init the TEK catalog file
 400  CALL TKCATL ('INIT', IX, IY, CATBLK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1400) 'INIT CATALOG', IERR
         GO TO 960
         END IF
C                                       Clear screen.
      IT = 27
      CALL ZTKBUF (IT, 1, IERR)
      IT = 12
      IF (IERR.EQ.0) CALL ZTKBUF (IT, 1, IERR)
      IF (IERR.EQ.0) CALL TEKFLS (IERR)
      CALL ZDELAY (TKPAWS, IERR)
      IF (IERR.EQ.0) GO TO 980
      WRITE (MSGTXT,1400) 'PAGE SCREEN', IERR
C-----------------------------------------------------------------------
C                                       message and close
 960  CALL MSGWRT (6)
C
 970  ERRNUM = 101
 980  IF (TKOPEN) THEN
         CALL ZTKCLS (IERR2)
         IF (IERR2.NE.0) THEN
            MSGTXT = 'TEKTRONIX CLOSE ERROR'
            CALL MSGWRT (6)
            END IF
         END IF
      IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('INVALID MAP TYPE =',I7)
 1015 FORMAT ('INVALID PLOT TYPE = MISCELLANEOUS')
 1020 FORMAT ('INVALID PLOT TYPE = PROFILE')
 1040 FORMAT ('X,Y',2I6,' OUT OF RNG X0,X1,Y0,Y1=',4I6)
 1100 FORMAT ('TKPOS: ERROR',I3,' CONVERTING TO SKY COORDINATES')
 1105 FORMAT ('Skypos:   ')
 1200 FORMAT ('Y value =',E12.4,1X,A8)
 1202 FORMAT ('Y value =',F8.3,1X,A5,1X,A8)
 1300 FORMAT ('IMXY: ',3F7.2)
 1400 FORMAT ('ON ',A,' ERROR',I6)
      END

      SUBROUTINE FILSWP (FIL1, FIL2)
C-----------------------------------------------------------------------
C! Tim Cornwell routine: switch file info
C# IO-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Swap the data in the VM file info arrays between FIL1 and FIL2,
C   effectively swapping the files.  Note that the value of FIL1
C   and FIL2 do not change.
C   Inputs:
C      FIL1    I      Index to first file info
C      FIL2    I      Index to second file info
C   In/out Common DTESS.INC :
C      SCRNM   I(*)   Scratch file common index ? - swapped
C   In/out Common DTCIO.INC :
C      VMVOL   I(*)   File disk volume number - swapped
C      VMFILE  C*(*)  File name - swapped
C      VMBO    I(*)   File disk block offset - swapped
C   Programmer =  T.J. Cornwell      December 1987
C-----------------------------------------------------------------------
      INTEGER    FIL1, FIL2
C
      INTEGER    ITEMP
      CHARACTER  CHTEMP*48
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
      ITEMP = VMVOL(FIL1)
      VMVOL(FIL1) = VMVOL(FIL2)
      VMVOL(FIL2) = ITEMP
C
      CHTEMP = VMFILE(FIL1)
      VMFILE(FIL1) = VMFILE(FIL2)
      VMFILE(FIL2) = CHTEMP
C
      ITEMP = SCRNM(FIL1)
      SCRNM(FIL1) = SCRNM(FIL2)
      SCRNM(FIL2) = ITEMP
C
      ITEMP = VMBO(FIL1)
      VMBO(FIL1) = VMBO(FIL2)
      VMBO(FIL2) = ITEMP
C
 999  RETURN
      END

      SUBROUTINE CHMATC (NA, JA, CA, NB, JB, CB, NP)
C-----------------------------------------------------------------------
C! searches one HOLLERITH string for the occurrence of another
C# Character
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   searches one HOLLERITH string for the occurrence of another string.
C   Inputs: NA   I        Number of characters in CA (start at JA)
C           JA   I        Start at char position JA in CA
C           CA   H(*)     Packed substring to be found in CB
C           NB   I        Number of characters in CB (n.b. TOTAL)
C           JB   I        Start search at offset in CB
C           CB   H(*)     Packed string.
C   Output: NP   I        start position in CB of CA, 0 if none.
C                         w.r.t. start of string
C-----------------------------------------------------------------------
      HOLLERITH CA(*), CB(*)
      INTEGER   NA, NB, NP, JA, JB
C
      INTEGER   I, NT, J1, J2, IT, ITA, ITB
C-----------------------------------------------------------------------
      NP = 0
      NT = NB - JB - NA + 2
      IF (NT.LE.0) GO TO 999
      J1 = (JA - 1) / 4 + 1
      J2 = JA - (J1-1) * 4
      CALL ZGETCH (ITA, CA(J1), J2)
      DO 20 NP = 1,NT
         J1 = (NP + JB - 2) / 4 + 1
         J2 = NP + JB - 1 - (J1-1) * 4
         CALL ZGETCH (IT, CB(J1), J2)
         IF (IT.NE.ITA) GO TO 20
            IF (NA.EQ.1) GO TO 30
            DO 10 I = 2,NA
               J1 = (I+JA-2) / 4 + 1
               J2 = I + JA - 1 - (J1-1) * 4
               CALL ZGETCH (ITB, CA(J1), J2)
               J1= (NP+JB+I-3) / 4 + 1
               J2 = NP + JB + I - 2 - (J1-1) * 4
               CALL ZGETCH (IT, CB(J1), J2)
               IF (ITB.NE.IT) GO TO 20
 10            CONTINUE
            GO TO 30
 20      CONTINUE
      NP = 0
      GO TO 999
C                                       answer wrt start CB
 30   NP = NP + JB - 1
C
 999  RETURN
      END

      SUBROUTINE ZRENA2 (OLDNAM, NEWNAM, SYSERR, IERR)
C-----------------------------------------------------------------------
C! rename a file
C# Z2 IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Renames a file.
C   Inputs:
C      OLDNAM   H*48   Old physical file name (Hollerith for Macro...)
C      NEWNAM   H*48   New physical file name (Hollerith for Macro...)
C   Output:
C      SYSERR   I      System error code
C      IERR     I      Error return code: 0 => no error
C                         2 => old file not found
C                         3 => device not found
C                         4 => old file busy
C                         6 => new name already exists
C                         7 => other
C   Generic version - STUB
C-----------------------------------------------------------------------
      HOLLERITH OLDNAM(12), NEWNAM(12)
      INTEGER   SYSERR, IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'ZRENA2 REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (9)
C
 999  RETURN
      END

      SUBROUTINE ZOLAVF (FCB, NFILES, IERR)
C-----------------------------------------------------------------------
C! advance files on an on-line "tape" device
C# Z2 IO-basic Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Advance files for on-line "tape devices"
C   Inputs:
C      FCB      I(*)   File control block for opened tape drive
C      NFILES   I      = 0 - start today's files
C                      < 0 - start yesterday's file
C                      > 0 - end of todays's file
C   Output:
C      IERR    I      Error return code: 0 => no error
C                        1 => at start today's despite NFILES < 0
C                        2 => no such operation
C                              3 => device not found
C                              6 => other open error
C   Generic version - stub
C-----------------------------------------------------------------------
      INTEGER   FCB(*), NFILES, IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'ZOLAVF REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (9)
C
 999  RETURN
      END

      SUBROUTINE ZMCACL (NBYTES, INBUF, OUTBUF, LASTCH)
C-----------------------------------------------------------------------
C! convert Modcomp compressed ASCII to Hollerith characters (for FILLR)
C# Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Convert Modcomp compressed ASCII characters to local uncompressed
C   characters.  Successive calls will append data to the end of the
C   output buffer.  One compressed record is processed per call.
C
C   NOTE: this routine will not work in place.
C
C   Modcomp compressed ASCII format for each logical record:
C      BYTE              Use
C       0     ASCII ETX (Hex 03)
C       1     checksum (optional)
C      2-3    byte count, negative => end of file (not on tape?)
C             (NOTE: may be bytes 1-2)
C      4-     Compressed ASCII characters.  A NULL (Hex 00) terminates.
C             A negative value (most significant bit on) indicates a
C             repetition of the previous character the number of times
C             indicated by the absolute value of the negative number.
C             Example: an ASCII 'C' followed by a byte with the HEX
C             value FF (2's complement -1) indicates two 'C's.
C
C   Inputs:
C      INBUF    I(*)        Input buffer of Modcomp compressed ASCII
C                           packed characters
C   In/out:
C      NBYTES   I           (In)  Maximum number of bytes to convert
C                           (Out) Number of bytes added to the output
C                                 buffer
C      LASTCH   I           Position of the next character in the output
C                           buffer (zero before first call)
C   Output:
C      OUTBUF   I(*)        Output buffer containing packed characters
C                           (due to the expansion of the data, the size
C                           of the output buffer is not strictly
C                           predictable)
C   Generic version (stubbed).
C-----------------------------------------------------------------------
      HOLLERITH OUTBUF(*)
      INTEGER   NBYTES, INBUF(*), LASTCH
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (NLUSER.LT.0) GO TO 999
         WRITE (MSGTXT,1000)
         CALL MSGWRT (8)
         STOP 'ZMCACL NEEDS LOCAL DEVELOPMENT'
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZMCACL: THIS ROUTINE REQUIRES LOCAL DEVELOPMENT')
      END

      SUBROUTINE TPHEAD (FDVEC, NWORD, FITS, TBIND, TAPBUF, IERR)
C-----------------------------------------------------------------------
C! reads a tape record, advances over label file, decides if it's FITS
C# Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   TPHEAD reads a tape header into TAPBUF.  It tests it for being a
C   FITS header by looking for 'SIMPLE  = '.  If that fails it checks
C   for tape label marks 'VOL1', 'HDR1', etc.  If they are found it
C   advances file and repeats. If not, it tests for an IBM "DECMAP"
C   header by checking the axis dimensions.
C   Inputs:
C      FDVEC   I(50)     TAPIO IO control data
C      NWORD   I         Number of words to read
C      FITS    I         if = 1 and NWORD = 1440, then caller is 
C                        expecting a FITS header record other than the
C                        1st
C   Outputs:
C      FITS    I         1 => it is the first record of a FITS header
C                        -1 => "FITS" but SIMPLE = F or bad length
C                        2 => IBM MAP, 3 => Export format UV data
C      TAPBUF  I(NWORD)  Buffer to receive header
C      IERR    I         error return: 0 = O.K.
C                           Other = return from MINI3 or MDISK
C                           10    = neither FITS nor DEC nor Export
C-----------------------------------------------------------------------
      INTEGER   FDVEC(50), NWORD, FITS, TBIND, TAPBUF(*), IERR
C
      CHARACTER CDATA*80, HDRTYP(7)*4
      INTEGER   IEREOF, IEREOM, I(2), IT, LUN, TIND, IFITS, J
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA IEREOF, IEREOM /4,6/
      DATA HDRTYP /'VOL1','HDR1','HDR2','EOF1','EOF2','EOV1','EOV2'/
C-----------------------------------------------------------------------
C                                       read one record, allow more
      IFITS = FITS
      FDVEC(31) = 0
      FDVEC(32) = 0
      LUN = FDVEC(1)
      TIND = FDVEC(40)
C                                       suppress messages
 10   MSGSUP = 32000
      CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
      MSGSUP = 0
      IF ((IERR.NE.0) .AND. (IERR.NE.10)) GO TO 980
C                                       FITS ?
      CALL ZC8CL (80, 1, TAPBUF(TBIND), CDATA)
      IF (CDATA(:10).EQ.'SIMPLE  = ') THEN
         FITS = 1
         IF (IERR.EQ.10) THEN
            IERR = 0
            FITS = -1
         ELSE
            IT = INDEX (CDATA, '/')
            IF (IT.LE.0) IT = 80
            DO 15 J = 11,IT
               IF (CDATA(J:J).NE.' ') THEN
                  IF (CDATA(J:J).NE.'T') FITS = -1
                  GO TO 970
                  END IF
 15            CONTINUE
            FITS = -1
            END IF
         GO TO 970
         END IF
      IERR = 0
C                                       Check for labeled tape
      DO 20 IT = 1,7
         IF (CDATA(1:4).EQ.HDRTYP(IT)) GO TO 30
 20      CONTINUE
C                                       Must be an IBM header
C                                       Check for Export tape
      CALL ZI16IL (1, 1, TAPBUF(TBIND), I)
      IF ((I(1).LE.1) .OR. (I(1).GT.4008)) GO TO 25
         FITS = 3
         CALL ZC8CL (4, 9, TAPBUF(TBIND), CDATA)
         IF (CDATA(1:4).EQ.'RUN ') GO TO 999
         IF (CDATA(1:4).EQ.'DEF ') GO TO 999
C                                       check bound on DEC dims
 25   FITS = 2
      CALL ZI16IL (2, 17, TAPBUF(TBIND), I)
      IF ((I(1).GE.16) .AND. (I(2).GE.16) .AND. (I(1).LE.4096) .AND.
     *   (I(2).LE.4096)) GO TO 999
         FITS = IFITS
         IF ((NWORD.EQ.1440) .AND. (IFITS.EQ.1)) GO TO 999
         IERR = 10
         MSGTXT = 'TPHEAD: NOT FITS, IBM-MAP, OR UV-EXPORT HEADER'
         GO TO 990
C                                       EOVolume label
 30   IF (IT.GE.6) THEN
         MSGTXT = 'END OF MULTI-TAPE VOLUME FOUND.  MOUNT NEXT TAPE'
         IERR = 6
C                                       Skip label file & retry
      ELSE
         WRITE (MSGTXT,1040) HDRTYP(IT)
         CALL MSGWRT (2)
         DO 45 J = 1,6
            MSGSUP = 32000
            CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
            MSGSUP = 0
            IF (IERR.EQ.IEREOF) GO TO 10
            IF ((IERR.NE.0) .AND. (IERR.NE.10)) GO TO 980
 45         CONTINUE
         MSGTXT = 'TAPE LABEL FILE TOO LONG - ERROR'
         IERR = 10
         END IF
      GO TO 990
C                                        errors
 970  IF (FITS.LT.0) THEN
         WRITE (MSGTXT,1970) FDVEC(42)
         GO TO 990
         END IF
      GO TO 999
 980  IF (IERR.EQ.IEREOF) THEN
         MSGTXT = 'TPHEAD:  END-OF-FILE = END-OF-INFORMATION?'
      ELSE IF (IERR.EQ.IEREOM) THEN
         MSGTXT = 'TPHEAD:  END-OF-INFORMATION'
      ELSE
         WRITE (MSGTXT,1980) IERR
         END IF
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('Skipping tape label file of type ',A)
 1970 FORMAT ('NON-STANDARD FITS HEADER OF LENGTH',I7,' BYTES READ')
 1980 FORMAT ('TPHEAD: I/O ERROR = ',I6)
      END

      SUBROUTINE LMDER1 (FCN, M, N, X, FVEC, FJAC, LDFJAC, TOL, INFO,
     *   IPVT, WA, LWA)
C-----------------------------------------------------------------------
C! minimize the sum of squares of M nonlinear functions in N variables
C# Modeling Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   The purpose of LMDER1 is to minimize the sum of the squares of M
C   nonlinear functions in N variables by a modification of the
C   Levenberg-Marquardt algorithm. This is done by using the more
C   general least-squares solver LMDER. The user must provide a
C   subroutine which calculates the functions and the Jacobian.
C   Subprograms called
C      User-supplied ...... FCN
C      Minpack-supplied ... LMDER
C   Argonne National Laboratory. Minpack project. March 1980.
C   Burton S. Garbow, Kenneth E. Hillstrom, Jorge J. More
C   Inputs:
C      FCN     EXTERNAL The name of the user-supplied subroutine
C                   which calculates the functions and the jacobian.
C                   FCN must be declared in an external statement in
C                   the user calling program, and should be written
C                   as follows:
C *********************************************************************
C         SUBROUTINE FCN (M, N, X, FVEC, FJAC, LDFJAC, IFLAG)
C         INTEGER  M, N, LDFJAC
C         INTEGER  IFLAG
C         DOUBLE PRECISION X(N), FVEC(M), FJAC(LDFJAC,N)
C         ----------
C         IF IFLAG = 1 Calculate the functions at X and return this
C                      vector in FVEC. Do not alter FJAC.
C         IF IFLAG = 2 Calculate the Jacobian at X and return
C                      this matrix in FJAC. Do not alter FVEC.
C         ----------
C         RETURN
C         END
C         The value of IFLAG should not be changed by FCN unless the
C         user wants to terminate execution of LMDER1.
C         In this case set IFLAG to a negative INTEGER.
C**********************************************************************
C      M       I     The number of functions (adj. array dim.).
C      N       I     The number of variables (adj. array dim.;
C                    N must not exceed M).
C      X       D(N)  contains an initial estimate of the
C                    solution vector.
C      TOL     D     termination occurs when the algorithm estimates
C                    either that the relative error in the sum of
C                    squares is at most TOL or that the relative error
C                    between X and the solution is at most TOL.
C   Outputs:
C      X       D(N)  contains the final estimate of the solution vector.
C      FVEC    D(M)  contains the functions evaluated at the output X.
C      FJAC    D(M,N)   The upper N by N submatrix of FJAC contains an
C                    upper triangular matrix R with diagonal elements of
C                    nonincreasing magnitude such that
C                             T     T           T
C                            P *(JAC *JAC)*P = R *R,
C                    where P is a permutation matrix and JAC is the
C                    final calculated Jacobian. Column J of P is column
C                    IPVT(J) (see below) of the identity matrix. The
C                    lower trapezoidal part of FJAC contains information
C                    generated during the computation of R.
C      LDFJAC   I    variable not less than M which specifies the
C                    leading dimension of the array FJAC
C                    (adj. array dim.).
C      INFO     I    If the user has terminated execution, INFO is
C                    set to the (negative) value of IFLAG. SEE
C                    description of FCN. otherwise, INFO is set
C                    as follows:
C
C                    INFO = 0  Improper input parameters.
C
C                    INFO = 1  Algorithm estimates that the relative
C                    error in the sum of squares is at most TOL.
C
C                    INFO = 2  Algorithm estimates that the relative
C                    error between X and the solution is at most TOL.
C
C                    INFO = 3  Conditions for INFO = 1 and INFO = 2
C                    both hold.
C
C                    INFO = 4  FVEC is orthogonal to the columns of the
C                    Jacobian to machine precision.
C
C                    INFO = 5  Number of calls to FCN with IFLAG = 1 HAS
C                    reached 100*(N+1).
C
C                    INFO = 6  TOL is too small. No further reduction in
C                    the sum of squares is possible.
C
C                    INFO = 7  TOL is too small. no further improvement
C                    in the approximate solution X is possible.
C
C      IPVT    I(N)  Defines a permutation matrix P such that
C                            JAC*P = Q*R,
C                    where JAC is the final calculated Jacobian, Q is
C                    orthogonal (not stored), and R is upper triangular
C                    with diagonal elements of nonincreasing magnitude.
C                    column J of P is column IPVT(J) of the identity
C                    matrix.
C      WA      D(LWA)  work array.
C      LWA     I     length of WA not less than 5*N+M (adj. array dim.)
C-----------------------------------------------------------------------
      EXTERNAL  FCN
      INTEGER   FCN, M, N, LDFJAC, LWA, INFO, IPVT(N)
      DOUBLE PRECISION TOL, X(N), FVEC(M), FJAC(LDFJAC,N), WA(LWA)
C
      INTEGER   MAXFEV, MODE, NFEV, NJEV, NPRINT
      DOUBLE PRECISION FACTOR, FTOL, GTOL, XTOL, ZERO
      DATA FACTOR,ZERO /1.0D2,0.0D0/
C-----------------------------------------------------------------------
      INFO = 0
C                                       Check the input parameters for
C                                       errors.
      IF ((N.LE.0) .OR. (M.LT.N) .OR. (LDFJAC.LT.M) .OR. (TOL.LT.ZERO)
     *   .OR. (LWA.LT.5*N+M)) GO TO 999
C                                       Call LMDER.
      MAXFEV = 100 * (N + 1)
      FTOL = TOL
      XTOL = TOL
      GTOL = ZERO
      MODE = 1
      NPRINT = 0
      CALL LMDER (FCN, M, N, X, FVEC, FJAC, LDFJAC, FTOL, XTOL, GTOL,
     *   MAXFEV, WA(1), MODE, FACTOR, NPRINT, INFO, NFEV, NJEV, IPVT,
     *   WA(N+1), WA(2*N+1), WA(3*N+1), WA(4*N+1), WA(5*N+1))
      IF (INFO.EQ.8) INFO = 4
C
 999  RETURN
      END

LOCAL INCLUDE 'SDVEL.INC'
      INCLUDE 'INCS:DSEL.INC'
C                                      Character declerations
      CHARACTER  NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      COMMON /CHPARM/ NAMEIN, CLAIN, NAMOUT, CLAOUT
C                                      Input parameters
      HOLLERITH  XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      REAL       XSIN, XDISIN, XSOUT, XDSOUT, XFLAG, XTIME(8),
     *   XPARM(10), XCO(6), XBADD(10), TIME1, TIME2
      INTEGER   SEQIN, CNOIN, DISKIN, SEQOUT, CNOOUT, DISOUT, UVBFSZ,
     *   CNTFLG, CNTMSG, COTYPE
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XCLAOU,
     *   XSOUT, XDSOUT, XFLAG, XTIME, XPARM, XCO, XBADD,
     *   SEQIN, CNOIN, DISKIN, SEQOUT, CNOOUT, DISOUT, UVBFSZ, CNTFLG,
     *   CNTMSG, TIME1, TIME2, COTYPE
C                                      Buffers
      REAL      BUFFER(UVBFSS), BUFF1(512), BUFFC(3*MAXCIF),
     *   BUFF2(UVBFSS)
      COMMON /CMBUFF/ BUFFER, BUFFC, BUFF2, BUFF1
C                                      File Control
      INTEGER   ICHLUN, NDECOM, DECOM(2,MAXIF*4), LLOCWT, LLOCSC, ILOCSC
      COMMON /FILCON/ ICHLUN, NDECOM, DECOM, LLOCWT, LLOCSC, ILOCSC
C                                      Misc. parameters
      DOUBLE PRECISION RAPP0, DAPP0, FRFROM, REFRA, REFDEC, USRRA,
     *   USRDEC
      INTEGER   KSEQO, NUMFRQ, INCFU, INCIFU, INCSU
      LOGICAL   WUVCMP, NEWSCN, NEWOFF
      COMMON /OPARM/ RAPP0, DAPP0, FRFROM, REFRA, REFDEC, USRRA, USRDEC,
     *   KSEQO, NUMFRQ, INCFU, INCIFU, INCSU, WUVCMP, NEWSCN, NEWOFF
C                                       O/P catalogue
      INTEGER   CATOUT(256)
      HOLLERITH CATOH(256)
      DOUBLE PRECISION CATOD(128)
      REAL      CATOR(256)
      COMMON /OUTHDR/ CATOUT
      EQUIVALENCE (CATOUT, CATOH, CATOR, CATOD)
C                                       Flag table info
      INTEGER   FKNCOR, FKNCF, FKNCIF, FKNCS, FKCOR0
C                                       FLAG table info
      COMMON /SDVLFG/ FKNCOR, FKNCF, FKNCIF, FKNCS, FKCOR0
LOCAL END
      PROGRAM SDVEL
C-----------------------------------------------------------------------
C! SDVEL shifts spectral-line single-dish data to a specified velocity.
C# Calibration Spectral UV VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1997-1998, 2001, 2004-2009, 2011, 2015, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SDVEL will shift spectral line data to a specified velocity.  The
C   program assumes that the telescope has tracked the velocity in the
C   header for the reference coordinates in the header.  It then shifts
C   each spectrum so that that velocity is wrt the actual coordinate
C   observed rather than the reference coordinate.  It works only on
C   single-source, single-dish uv data sets.
C   Unlike CVEL this does not require any Q routines
C   Inputs:
C      AIPS adverb          Description.
C      INNAME.....Input UV file name (name).      Standard defaults.
C      INCLASS....Input UV file name (class).     Standard defaults.
C      INSEQ......Input UV file name (seq. #).    0 => highest.
C      INDISK.....Disk drive # of input UV file.  0 => any.
C      OUTNAME....Output UV file name.            Standard defaults.
C      OUTCLASS...Output UV file name (class).    Standard defaults.
C      OUTSEQ.....Output UV file name (seq. #).   0 => highest unique
C      OUTDISK....Disk drive # of output UV file. 0 => highest with
C                 space for the file.
C      FLAGVER....Flag file to apply (< 0 -> none)
C      DPARM......Controls:
C                 (1) Tells the task when to compute the reference
C                 doppler shift.
C                 0 -> only at the start using the reference coordinate.
C                 1 -> only at the start, but using the first coordinate.
C                 2 -> on each "off" scan (detected by a missing scan
C                 number) using the last coordinate before the off.
C                 3 -> on each scan using the last coordinate of the
C                 previous scan.
C                 (2) A warning is issued if the shift exceeds DPARM(2)
C                 channels.  0 -> NCHAN/20.  The task limits the number
C                 of consecutive samples warned to 10 but if there are
C                 then good samples, it will resume warnings on the next
C                 "bad".
C                 (3) A sample is deleted if the shift exceeds DPARM(3)
C                 channels.  0 -> NCHAN.  This may be used to detect and
C                 flag periods in which the antenna is blown way off
C                 course.
C      BADDISK....Disks to avoid for scratch files.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'SDVEL.INC'
      DATA PRGM /'SDVEL '/
C-----------------------------------------------------------------------
C                                       Get input parameters
C                                       and open O/P file.
      CALL SDVLIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Read, shift and write
      CALL CVSHFT (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Update history
      CALL SDVLHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE SDVLIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   SDVLIN gets the input parms for SDVEL, fins the input file
C   opens the output file and performs some checks on the
C   validity of the SDVEL operation.
C   Inputs:
C      PRGN   C*6   Program name
C   Output:
C     JERR    I     Error code: 0 => ok
C                               5 => catalog troubles
C                               8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH CATH(256)
      CHARACTER STAT*4, PRGN*6, UTYPE*2, CHSCAN*8
      INTEGER   JERR, NUMHIS, NPARM, IROUND, IERR, I, CATSAV(256),
     *   KEY(2,2), NREAD, TVER, MODE, KEYSUB(2,2)
      REAL      FKEY(2,2)
      LOGICAL   F, TABLE, EXIST, FITASC, ISNEG
      INCLUDE 'SDVEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      EQUIVALENCE (CATBLK, CATH)
      DATA F /.FALSE./
      DATA KEY  /5,0, 1,0/
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      TSKNAM = PRGN
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 49
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       Obtain disc parms
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISOUT = IROUND (XDSOUT)
C                                       Check file exists
      CNOIN = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1001) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       If it does extract the CATBLK
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'READ', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1002) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 0
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      IF (TYPUVD.NE.1) THEN
         WRITE (MSGTXT,1005) TYPUVD
         JERR = 8
         GO TO 990
         END IF
      CALL H2CHR (8, 1, CATH(KHPTP+2*ILOCU), CHSCAN)
      COTYPE = -1
      IF (CHSCAN.EQ.'RA') COTYPE = 0
      IF (CHSCAN.EQ.'GLON') COTYPE = 1
      IF (CHSCAN.EQ.'ELON') COTYPE = 2
      IF (CHSCAN.NE.'RA') THEN
         MSGTXT = 'HANDLES ONLY RA/DEC COORDS, NOT ' // CHSCAN
         JERR = 8
         GO TO 990
         END IF
      IF (JLOCIF.GE.0) THEN
         MSGTXT = 'DOES NOT HANDLE MULTIPLE IFS'
         JERR = 8
         IF (CATBLK(KINAX+JLOCIF).GT.1) GO TO 990
         END IF
C                                       SCAN pointer
      CHSCAN = 'SCAN'
      CALL AXEFND (4, CHSCAN, CATBLK(KIPCN), CATH(KHPTP), ILOCSC, IERR)
      IF (IERR.NE.0) ILOCSC = -1
C                                       Compressed data?
      WUVCMP = CATBLK(KINAX).EQ.1
C                                       BADDISK
      DO 10 I = 1,10
         IBAD(I) = IROUND (XBADD(I))
 10      CONTINUE
C                                       Put selection criteria into
C                                       correct common.
      FGVER = IROUND (XFLAG)
      DOFLAG = FGVER.GE.0
C                                       Set LUN's
C                                       UV LUN
      IULUN = 26
C                                       FG table LUN
      IFLUN = 30
C                                       Check if single source file
      CALL ISTAB ('SU', DISKIN, CNOIN, 1, IFLUN, BUFF1, TABLE, EXIST,
     *   FITASC, IERR)
C                                       If single give warning message.
      IF ((ILOCSU.GE.0) .OR. ((EXIST) .AND. (TABLE))) THEN
         MSGTXT = 'WARNING: SOURCE TABLE AND/OR IDS IGNORED!'
         CALL MSGWRT (7)
         END IF
C                                       If multi-source file sort the
C                                       CL table to time-ant order.
C                                       Put new values in CATOUT
      CALL COPY (256, CATBLK, CATSAV)
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      CCNO = 1
      CALL UVCREA (DISOUT, CCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         JERR = 8
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FCNO(NCFILE) = CCNO
      FVOL(NCFILE) = DISOUT
      FRW(NCFILE) = 2
      CALL COPY (256, CATBLK, CATOUT)
      CALL COPY (256, CATSAV, CATBLK)
C                                       Set output CNO
      CNOOUT = CCNO
C                                       copy keywords
      CALL KEYCOP (DISKIN, CNOIN, DISOUT, CNOOUT, IERR)
C                                       Fill AN information
C                                       into common in DANS.INC
      CALL GETANT (DISKIN, CNOIN, SUBARR, CATBLK, BUFF1, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1070) JERR
         GO TO 990
         END IF
C
      NUMFRQ = CATBLK(KINAX+JLOCF)
      UVBFSZ = UVBFSS * 2
C                                       Init Flag file
      CALL FNDEXT ('FG', CATBLK, TVER)
      DOFLAG = DOFLAG .AND. (TVER.GT.0)
      TIMORD = ISORT(1:1).EQ.'T'
      IF (DOFLAG) THEN
         MSGTXT = 'Some data may be flagged and interpolated'
         CALL MSGWRT (3)
         TMFLST = -1.0E20
         NUMFLG = 0
         FKNCOR = NCOR
         FKCOR0 = ICOR0
         FKNCF = INCF / CATBLK(KINAX)
         FKNCIF = INCIF / CATBLK(KINAX)
         FKNCS = INCS / CATBLK(KINAX)
         MSGSUP = 32000
C                                       Reformat table?
         CALL FGREFM (DISKIN, CNOIN, FGVER, CATBLK, IFLUN, JERR)
         CALL FLGINI ('READ', FGBUFF, DISKIN, CNOIN, FGVER, CATBLK,
     *      IFLUN, IFGRNO, FGKOLS, FGNUMV, JERR)
         MSGSUP = 0
         IF (JERR.NE.0) THEN
            DOFLAG = F
C                                       Sort to time order.
         ELSE IF (FGBUFF(43).NE.KEY(1,1)) THEN
            CALL TABIO ('CLOS', 0, NREAD, BUFFER, FGBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TABSRT (DISKIN, CNOIN, 'FG', FGVER, FGVER, KEY, KEYSUB,
     *         FKEY, FGBUFF, CATBLK, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       Re initialize.
            CALL FLGINI ('READ', FGBUFF, DISKIN, CNOIN, FGVER, CATBLK,
     *         IFLUN, IFGRNO, FGKOLS, FGNUMV, IERR)
            END IF
         END IF
      IF (DOFLAG) THEN
         WRITE (MSGTXT,1035) FGVER
      ELSE
         MSGTXT = 'Applying no flag table to the input data'
         END IF
      CALL MSGWRT (3)
C                                       First set freq. selection
      BCHAN = 1
      ECHAN = NUMFRQ
      BIF = 1
      EIF = 1
      IF (JLOCIF.GE.0) EIF = CATBLK(KINAX+JLOCIF)
C                                       Disk, volume no.
      IUDISK = DISKIN
      IUCNO = CNOIN
C                                       Pointers for freq/IF/Stokes
      KNCF = INCF / CATBLK(KINAX)
      KNCIF = INCIF / CATBLK(KINAX)
      KNCS = INCS / CATBLK(KINAX)
C                                       No antenna selection
      CALL FILL (MAXANT, 0, ANTENS)
C                                       Copy CATBLK to CATUV
      CALL COPY (256, CATBLK, CATUV)
C                                       Position controls:
      MODE = IROUND (XPARM(1))
      IF ((MODE.LT.0) .OR. (MODE.GT.3)) MODE = 0
      XPARM(1) = MODE
      MODE = IROUND (XPARM(2))
      IF ((MODE.LT.0) .OR. (MODE.GT.2)) MODE = 0
      XPARM(2) = MODE
      ISNEG = (XCO(1).LT.0.0) .OR. (XCO(2).LT.0.0) .OR. (XCO(3).LT.0.0)
      USRRA = ABS (XCO(1)) + ABS (XCO(2))/60.0D0 + ABS (XCO(3))/3600.0D0
      IF (ISNEG) USRRA = -USRRA
      USRRA = USRRA * 15.0D0
      ISNEG = (XCO(4).LT.0.0) .OR. (XCO(5).LT.0.0) .OR. (XCO(6).LT.0.0)
      USRDEC = ABS(XCO(4)) + ABS(XCO(5))/60.0D0 + ABS(XCO(6))/3600.0D0
      IF (ISNEG) USRDEC = -USRDEC
      GO TO 999
C                                       Write the error message
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SDVLIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1001 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1002 FORMAT ('SDVLIN: ERROR',I3,' COPYING CATBLK')
 1005 FORMAT ('WORKS ON SINGLEDISH DATA ONLY, NOT TYPE',I3)
 1035 FORMAT ('SDVLIN: applying flag table version',I5,' to the data')
 1050 FORMAT ('SDVLIN: ERROR',I3,' CREATING OUTPUT FILE')
 1070 FORMAT ('SDVLIN: ERROR',I3,' OBTAINING ANTENNA INFORMATION')
      END
      SUBROUTINE CVSHFT (IRET)
C-----------------------------------------------------------------------
C   CVSHFT reads the UV data, shifts it to the new velocity/frequency
C   and writes it to the O/P file.
C   Outputs:
C      IRET   I   Return error code, 0=>OK, otherwise error.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH CATH(256)
      CHARACTER NAME*48, SNAMES*8, TC1*1, TC2*1
      INTEGER   VISOFF, JBUFSZ, IRET, LUN, FIND, BIND, LENBU, INIO, NIO,
     *   LRECO, NOPOL, NPERC, BO, I, XCOUNT, NCORI, ONXRNO,
     *   JNXRNO, SBCHAN, SECHAN, J, LDATA, KBIND, TIT1(3),
     *   TIT2(3), JERR, IBIND, NCOPY, VISNUM, COUNTD, CNTLSG
      LOGICAL   T, F, DROP
      REAL      VISIN(3*MAXCIF), WORK(3*MAXCIF), TIME, RPARM(20),
     *   REPDEL, CATR(256), FTIME, LTIME, REPMAX(2), TS1, TS2
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'SDVEL.INC'
      INCLUDE 'INCS:DCVL.INC'
      EQUIVALENCE (CATBLK, CATH, CATR)
      DATA T, F /.TRUE.,.FALSE./
      DATA LUN, BO /40,1/
C-----------------------------------------------------------------------
C                                       Set lengths of input axes.
      NOPOL = CATBLK(KINAX+JLOCS)
      NUMFRQ = CATBLK(KINAX+JLOCF)
      NEWSCN = .TRUE.
      NEWOFF = .TRUE.
      RAPP0 = -1000.
      DAPP0 = -1000.
      CNTMSG = 0
      CNTLSG = 0
      CNTFLG = 0
      IF (XPARM(3).LE.0.0) XPARM(3) = NUMFRQ / 20.0
      IF (XPARM(4).LE.0.0) XPARM(4) = NUMFRQ
      TIME1 = (XTIME(2) + (XTIME(3) + XTIME(4)/60.0) / 60.0) / 24.0
     *   + XTIME(1)
      TIME2 = (XTIME(6) + (XTIME(7) + XTIME(8)/60.0) / 60.0) / 24.0
     *   + XTIME(5)
      IF (TIME2.LE.0.0) TIME2 = 1.E6
C                                       Assume no IF
      CNNIF = 1
      CFOFF(1) = 0
      CSBAND(1) = 1
      CFINC(1) = CATR(KRCIC+JLOCF)
      CALL H2CHR (8, 1, CATH(KHOBJ), SNAMES)
C                                       Get data compression pointers
      INCFU = INCF
      INCIFU = INCIF
      INCSU = INCS
      IF (WUVCMP) THEN
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), LLOCWT,
     *      JERR)
         IF ((JERR.NE.0) .OR. (LLOCWT.LT.0)) THEN
            IRET = 5
            MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
            GO TO 990
            END IF
         CALL AXEFND (8, 'SCALE   ', CATBLK(KIPCN), CATH(KHPTP), LLOCSC,
     *      JERR)
         SBCHAN = 0
         SECHAN = 0
         CALL CMPARM (1, 1, 1, NUMFRQ, SBCHAN, SECHAN, NDECOM, DECOM)
         INCFU = INCF * 3
         INCIFU = INCIF * 3
         INCSU = INCS * 3
         END IF
      NCORI = (LREC - NRPARM) / CATBLK(KINAX)
      NCOPY = LREC - NRPARM
C
      LENBU = 1
      LRECO = LREC
      JBUFSZ = UVBFSS * 2
C                                       Open input data file
      CALL ZPHFIL ('UV', DISKIN, CNOIN, 1, UFILE, IRET)
      CALL ZOPEN (IULUN, IUFIND, DISKIN, UFILE, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN', 'INPUT'
         GO TO 990
         END IF
      CALL UVINIT ('READ', IULUN, IUFIND, NVIS, VISOFF, LREC, LENBU,
     *   JBUFSZ, BUFF2, BO, IBIND, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT', 'INPUT'
         GO TO 990
         END IF
C                                       Open output file.
      CALL ZPHFIL ('UV', DISOUT, CNOOUT, 1, NAME, IRET)
      CALL ZOPEN (LUN, FIND, DISOUT, NAME, T, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN', 'OUTPUT'
         GO TO 990
         END IF
C                                       Init output vis file for write
      CALL UVINIT ('WRIT', LUN, FIND, CATBLK(KIGCN), VISOFF,
     *   LRECO, LENBU, JBUFSZ, BUFFER, BO, BIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT', 'OUTPUT'
         GO TO 990
         END IF
      IF (WUVCMP) KBIND = BIND
C                                       Do the shift
      XCOUNT = 0
      NPERC = 10
C                                       Loop over visibilities
      ONXRNO = 0
      JNXRNO = 1
      VISNUM = 1
      FTIME = 0.0
      LTIME = 0.0
      DO 100 I = 1,NVIS
C                                       Read input data
         CALL UVDISK ('READ', IULUN, IUFIND, BUFF2, INIO, IBIND, IRET)
         IF ((IRET.EQ.4) .OR. (INIO.LE.0)) GO TO 110
         IF (IRET.NE.0) GO TO 999
         TIME = BUFF2(IBIND+ILOCT)
         IF ((TIME.LT.TIME1) .OR. (TIME.GT.TIME2)) GO TO 100
         CALL RCOPY (NRPARM, BUFF2(IBIND), RPARM)
         IF (WUVCMP) THEN
            CALL ZUVXPN (NCORI, BUFF2(IBIND+NRPARM),
     *         BUFF2(IBIND+LLOCWT), VISIN)
         ELSE
            CALL RCOPY (NCOPY, BUFF2(IBIND+NRPARM), VISIN)
            END IF
C                                       Flagging ?
         IF (DOFLAG) THEN
            CALL CVFLAG (RPARM, VISIN, DROP, IRET)
C                                       Remove fully flagged samples
            IF (DROP) GO TO 100
            IF (IRET.NE.0) GO TO 999
            END IF
C                                       Message every scan
         TIME = BUFF2(IBIND+ILOCT)
         IF (FTIME.LE.0.0) FTIME = TIME
         IF (ILOCSC.GE.0) THEN
            JNXRNO = BUFF2(IBIND+ILOCSC)
            IF (JNXRNO.NE.ONXRNO) THEN
               IF (ONXRNO.GT.0) THEN
                  IF ((XPARM(1).EQ.2.0) .AND. (JNXRNO-ONXRNO.GT.1))
     *               NEWOFF = .TRUE.
                  IF (XPARM(1).LE.1.) NEWOFF = .TRUE.
                  CALL TFDHMS (FTIME, 1, TC1, TIT1, TS1)
                  CALL TFDHMS (LTIME, 1, TC2, TIT2, TS2)
                  WRITE (MSGTXT,1010) ONXRNO, SNAMES, TIT1, TS1, TIT2,
     *               TS2
                  IF (MSGTXT(38:38).EQ.' ') MSGTXT(38:38) = '0'
                  IF (MSGTXT(55:55).EQ.' ') MSGTXT(55:55) = '0'
                  CALL MSGWRT (3)
                  IF (COUNTD.GT.0) THEN
                     REPDEL = REPDEL / COUNTD
                     WRITE (MSGTXT,1015) REPMAX(1), REPDEL, REPMAX(2)
                     CALL MSGWRT (3)
                     END IF
                  END IF
               NEWSCN = .TRUE.
               FTIME = TIME
               ONXRNO = JNXRNO
               REPDEL = 0.0
               REPMAX(1) = 10000.0
               REPMAX(2) = -10000.0
               COUNTD = 0
            ELSE
               NEWSCN = .FALSE.
               END IF
            END IF
         LTIME = TIME
C                                       Shift desired sources
         IF (NEWOFF) FRFROM = -1000.0D0
         IF (VISNUM.EQ.1) THEN
            RAPP0 = USRRA
            DAPP0 = USRDEC
            END IF
         CALL DSHIFT (DISKIN, CNOIN, RPARM, VISIN, WORK, WUVCMP, VISNUM,
     *      XPARM, RAPP0, DAPP0, FRFROM, REPDEL, REPMAX, COUNTD, CNTMSG,
     *      CNTLSG, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1050) IRET
            GO TO 990
C                                       skip = flagged
         ELSE IF (IRET.LT.0) THEN
            CNTFLG = CNTFLG + 1
C                                       Write new
         ELSE
            VISNUM = VISNUM + 1
            NEWSCN = .FALSE.
            NEWOFF = .FALSE.
C
            CALL RCOPY (NRPARM, RPARM, BUFFER(BIND))
            LDATA = LREC - NRPARM
            IF (WUVCMP) THEN
               LDATA = LDATA * 3
               CALL RCOPY (LDATA, VISIN, BUFFC)
            ELSE
               CALL RCOPY (LDATA, VISIN, BUFFER(BIND+NRPARM))
               END IF
C                                       Write new
            NIO = 1
            XCOUNT = XCOUNT + 1
            IF (WUVCMP) THEN
               DO 90 J = 1, NDECOM
                  CALL ZUVPAK (DECOM(1,J), BUFFC, BUFFER(BIND+LLOCWT),
     *               BUFFER(BIND+NRPARM))
 90               CONTINUE
               CALL UVDISK ('WRIT', LUN, FIND, BUFFER, NIO, KBIND, IRET)
               BIND = KBIND
            ELSE
               CALL UVDISK ('WRIT', LUN, FIND, BUFFER, NIO, BIND, IRET)
               END IF
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRIT', 'OUTPUT'
               GO TO 990
               END IF
            END IF
 100     CONTINUE
C                                       If FINISH shut down output
 110  NVIS = XCOUNT
C                                       Flush output
      NIO = 0
      IF (WUVCMP) THEN
         CALL UVDISK ('FLSH', LUN, FIND, BUFFER, NIO, KBIND, IRET)
      ELSE
         CALL UVDISK ('FLSH', LUN, FIND, BUFFER, NIO, BIND, IRET)
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FLUSH', 'OUTPUT'
         GO TO 990
         END IF
C                                       Final message
      CALL TFDHMS (FTIME, 1, TC1, TIT1, TS1)
      CALL TFDHMS (LTIME, 1, TC2, TIT2, TS2)
      WRITE (MSGTXT,1010) ONXRNO, SNAMES, TIT1, TS1, TIT2, TS2
      IF (MSGTXT(38:38).EQ.' ') MSGTXT(38:38) = '0'
      IF (MSGTXT(55:55).EQ.' ') MSGTXT(55:55) = '0'
      CALL MSGWRT (3)
      IF (COUNTD.GT.0) THEN
         REPDEL = REPDEL / COUNTD
         WRITE (MSGTXT,1015) REPMAX(1), REPDEL, REPMAX(2)
         CALL MSGWRT (3)
         END IF
      IF (CNTMSG.GT.0) THEN
          WRITE (MSGTXT,1110) CNTMSG
          CALL MSGWRT (6)
          END IF
      IF (CNTFLG.GT.0) THEN
          WRITE (MSGTXT,1111) CNTFLG
          CALL MSGWRT (6)
          END IF
C                                       Compress output file.
      NVIS = XCOUNT + VISOFF
      CALL UCMPRS (NVIS, DISOUT, CNOOUT, LUN, CATOUT, IRET)
C                                       Close files
      CALL ZCLOSE (LUN, FIND, IRET)
      CALL ZCLOSE (IULUN, IUFIND, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CVSHFT: ERROR',I5,1X,A,'ING ',A,' FILE')
 1010 FORMAT ('Shift scan',I6,' source ',A8,I4,'/',2(I2.2,':'),F4.1,
     *   ' -',I4,'/',2(I2.2,':'),F4.1)
 1015 FORMAT (5X,'Min, Avg, Max shift =',2(F12.5,','),F12.5)
 1050 FORMAT ('CVSHFT: ERROR',I3,' RETURNED FROM DSHIFT')
 1110 FORMAT ('There were',I7,' apparently excessive shifts performed')
 1111 FORMAT ('There were',I7,' excessive shifts deleted')
      END
      SUBROUTINE DSHIFT (DISKIN, CNOIN, RPARMS, VIS, WORK, WUVCMP,
     *   VISNUM, XPARM, RAPP0, DAPP0, FRFROM, REPDEL, REPMAX, COUNTD,
     *   CNTMSG, CNTLSG, IRET)
C-----------------------------------------------------------------------
C   DSHIFT calculates the necessary channel shift and does it by calling
C   the routine ACSHFT
C   Input:
C      DISKIN   I        Volume number
C      CNOIN    I        File catalogue number
C      WUVCMP   L        Input/output data are compressed
C      VISNUM   I        Visibility number. 1 => some things need to be
C                        opened. -1 => some need to be closed.
C      XPARM    R(*)     (1) = 0 => start with ref coord, else 1st
C                           coord
C                        (2) warning level - shifts > xparm(2) warned
C                        (3) delete it level - shifts > xparm(3) flagged
C   Input/Output:
C      RPARMS   R(*)     Random parameters
C      VIS      R(3,*)   The complex visibility + weight; On output will
C                        contain the shifted data.
C      RAPP0    D        Apparent RA of date of ref < 0 => compute
C      DAPP0    D        Apparent RA of date of ref < -90 => compute
C      FRFROM   D        Velocity ref channel freq of current ref,
C                        <= 0.0 => compute please
C      REPDEL   R        Sum of shifts
C      REPMAX   R(2)     Min, Max of shifts
C      COUNTD   I        Number in sum
C   Output:
C      WORK     R(*)     Work buffer (>= 8192)
C      IRET     I        Error code, = 0 => OK
C-----------------------------------------------------------------------
      INTEGER   DISKIN, CNOIN, VISNUM, COUNTD, IRET, CNTMSG, CNTLSG
      INTEGER DIR
      REAL      RPARMS(*), VIS(*), XPARM(*), WORK(*), REPDEL, REPMAX(2)
      LOGICAL   WUVCMP
      DOUBLE PRECISION RAPP0, DAPP0, FRFROM, OBSPOS(3)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IANT1, IANT2, I, IPOL, IFRQ, INDEX, ISB, FINDEX,
     *   TIT(3), NFREQ, INCSU, INCIFU, INCFU, OLDSOU, NNIF, SUBARR,
     *   GAMMA, ISMTH, NDAY, IIYEAR, LIMMSG
      DOUBLE PRECISION FINT, DOPVEL, VELTOT, FREQTO, DELI, LRAPP, LDAPP,
     *   XRA, XDEC, JD, EQUIN, UT, DTIME, DXANT, DYANT, DZANT, VSUN,
     *   LRAPPF, LDAPPF, EUT, EDELI, JDA, ARRLON
      LOGICAL   DOINTP, ALLFLG, VLA
      REAL   VISTMP(2,MAXCHA), TMPWT(MAXCHA), INTWTS(MAXCHA), TS, UTT,
     *   TEMP, POLAR(2)
      CHARACTER TC*1, HDATE*8
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DCVL.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DAPM.INC'
      SAVE LRAPP, LDAPP, FREQTO, LRAPPF, LDAPPF, EDELI, EUT, OLDSOU
      DATA LRAPP, LDAPP, FREQTO, EDELI, EUT /5 * -1000.0D0/
      DATA LIMMSG /10/
      DATA OBSPOS, POLAR /3 * 0.0D0, 2 * 0.0/
C-----------------------------------------------------------------------
      VLA = .TRUE.
C                                       Close down stuff
      IF (VISNUM.EQ.-1) THEN
         IRET = 0
         GO TO 999
         END IF
C                                       Initialize stuff
      NFREQ = CATBLK(KINAX+JLOCF)
      IF (VISNUM.EQ.1) THEN
C                                       Do we use PSAP FFT
         POWRTO = .FALSE.
         DO 10 GAMMA = 1,15
            IF ((2**GAMMA).EQ.NFREQ) THEN
               POWRTO = .TRUE.
               NXTTWO = NFREQ
               END IF
 10         CONTINUE
C                                       If not, is it a prime number
         IF (.NOT.POWRTO) CALL ISPRIM (NFREQ, PRIME, NXTTWO)
         USEAP = .FALSE.
         IF (POWRTO .OR. PRIME) USEAP = .TRUE.
C                                       AP NOT NEEDED
         IF (USEAP) THEN
            NCMPLX = NXTTWO * 2 * 2
            APBEG = 0
            APTYPE = 2
            NROLL = -1
            NBYTES = 0
            END IF
C
         OLDSOU = -1
         REPDEL = 0.0
         REPMAX(1) = 10000.0
         REPMAX(2) = -10000.0
         COUNTD = 0
C                                       Determine year and ref.day
C                                       number of observation
         CALL GETTIM (DISKIN, CNOIN, WORK, CATBLK, IYEAR,
     *      IRDAY, IATUT, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'YEAR AND DAY NUMBER'
            GO TO 990
            END IF
C                                       Set frequency info.
         NNIF = 1
C                                       Fill AN information
C                                       into common in DANS.INC
         SUBARR = 1
         CALL GETANT (DISKIN, CNOIN, SUBARR, CATBLK, WORK, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'ANTENNA LOCATIONS'
            GO TO 990
            END IF
C                                       Correct station positions for
C                                       centre array offset if non-zero
C                                       go to left-hand system
         ARRLON = 0.0D0
         IF ((ABS(CNTRX).GT.1.D2) .AND. (ABS(CNTRY).GT.1.D2) .AND.
     *      (ABS(CNTRZ).GT.1.D2)) ARRLON = ATAN2 (CNTRY, CNTRX)
         DO 20 I = 1,MAXANT
            ANTX(I) = CNTRX + STNX(I)*COS(ARRLON) - STNY(I)*SIN(ARRLON)
            ANTY(I) = CNTRY + STNY(I)*COS(ARRLON) + STNX(I)*SIN(ARRLON)
            ANTY(I) = -ANTY(I)
            ANTZ(I) = CNTRZ + STNZ(I)
 20         CONTINUE
C                                       Precess ref coord to apparent
         IF ((RA.EQ.0 0D0) .AND. (DEC.EQ.0.0D0)) THEN
            RA = CATD(KDORA)
            DEC = CATD(KDODE)
            END IF
         CALL JULDAY (RDATE, JDA)
         CALL H2CHR (8, 1, CATH(KHDOB), HDATE)
         CALL JULDAY (HDATE, JD)
         IF (ABS(JD-JDA).GT.10.0D0) THEN
            WRITE (MSGTXT,1020) HDATE, RDATE
            CALL MSGWRT (7)
            END IF
         JD = JD + RPARMS(ILOCT+1)
         EQUIN = CATR(KREPO)
         IF (ABS(XPARM(2)-2.0).LT.0.5) THEN
            RA = RAPP0
            DEC = DAPP0
            END IF
         XRA = RA * DG2RAD
         XDEC = DEC * DG2RAD
         DIR = 1
         CALL JPRECS (JD, EQUIN, 0.1D0, DIR, .FALSE., OBSPOS, POLAR,
     *      XRA, XDEC, RAPP0, DAPP0)
C
C         CALL PRECES (JD, EQUIN, 0.1D0, XRA, XDEC, RAPP0, DAPP0, .TRUE.,
C     *      .FALSE., .FALSE., 0.0D0, 0.0D0, 0.0D0, .FALSE.)
         RAPP0 = RAPP0 * RAD2DG
         DAPP0 = DAPP0 * RAD2DG
         IF (ABS(XPARM(2)-1.0).LT.0.5) THEN
            LRAPP = RPARMS(1+ILOCU) - RA + RAPP0
            LDAPP = RPARMS(1+ILOCV) - DEC + DAPP0
         ELSE
            LRAPP = RAPP0
            LDAPP = DAPP0
            END IF
         END IF
C
      INCSU = INCS
      INCIFU = INCIF
      INCFU = INCF
      IF (WUVCMP) THEN
         INCSU = INCS * 3
         INCIFU = INCIF * 3
         INCFU = INCF * 3
         END IF
C                                       Determine time
      UT = RPARMS(ILOCT+1) - (IATUT/86400.D0)
C                                       Antenna numbers
      IF (ILOCB.GE.0) THEN
         IANT1 = RPARMS(ILOCB+1) / 256 + 0.1
         IANT2 = RPARMS(ILOCB+1) - 256 * IANT1 + 0.1
      ELSE
         IANT1 = RPARMS(ILOCA1+1) + 0.1
         IANT2 = RPARMS(ILOCA2+1) + 0.1
         END IF
      IF (IANT1.NE.IANT2) THEN
         WRITE (MSGTXT,1021) IANT1, IANT2
         IRET = 8
         GO TO 990
         END IF
C                                       Get basic freq. parms
      CALL GETFRQ (OLDSOU, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FREQ./VEL. PARMS'
         GO TO 990
         END IF
C                                       Determine reference velocity/fr
      IIYEAR = IYEAR
      NDAY = IRDAY + UT
      DTIME = UT - (NDAY-IRDAY)
      DXANT = ANTX(IANT1)
      DYANT = ANTY(IANT1)
      DZANT = ANTZ(IANT1)
C                                       Determine reference velocity/fr

      IF (FRFROM.LE.0.0D0) THEN
         IF (ABS(XPARM(2)-1.0).LT.0.5) THEN
            IF (ABS(XPARM(1)).LT.0.5) THEN
               LRAPP = RPARMS(1+ILOCU) - RA + RAPP0
               LDAPP = RPARMS(1+ILOCV) - DEC + DAPP0
               END IF
         ELSE
            LRAPP = RAPP0
            LDAPP = DAPP0
            END IF
         LRAPPF = LRAPP
         LDAPPF = LDAPP
         XRA = LRAPP * DG2RAD
         XDEC = LDAPP * DG2RAD
         CALL DOPLR (XRA, XDEC, IIYEAR, NDAY, DTIME, DXANT, DYANT,
     *      DZANT, VSUN, DOPVEL)
         VELTOT = CATD(KDARV) + DOPVEL
         IF (HELIO) VELTOT = VELTOT - VSUN
         IF (.NOT.RADIO) THEN
            FRFROM = RSTFRQ(1) / (1.D0 + VELTOT / VELITE)
         ELSE
            FRFROM = RSTFRQ(1) * (1.D0 - VELTOT / VELITE)
            END IF
         END IF
C                                       Determine current
      XRA = RPARMS(1+ILOCU) - RA + RAPP0
      XDEC = RPARMS(1+ILOCV) - DEC + DAPP0
      IF ((XRA.NE.LRAPP) .OR. (XDEC.NE.LDAPP) .OR. (FREQTO.LE.0.0)) THEN
         LRAPP = XRA
         LDAPP = XDEC
         XRA = LRAPP * DG2RAD
         XDEC = LDAPP * DG2RAD
         CALL DOPLR (XRA, XDEC, IIYEAR, NDAY, DTIME, DXANT, DYANT,
     *      DZANT, VSUN, DOPVEL)
         VELTOT = CATD(KDARV) + DOPVEL
         IF (HELIO) VELTOT = VELTOT - VSUN
         IF (.NOT.RADIO) THEN
            FREQTO = RSTFRQ(1) / (1.D0 + VELTOT / VELITE)
         ELSE
            FREQTO = RSTFRQ(1) * (1.D0 - VELTOT / VELITE)
            END IF
         END IF
C                                       Required pixel shift
      FINT = CFINC(1) * CSBAND(1)
      DELI = (FRFROM - FREQTO) / FINT
      REPDEL = REPDEL + DELI
      COUNTD = COUNTD + 1
      TEMP = DELI
      REPMAX(1) = MIN (REPMAX(1), TEMP)
      REPMAX(2) = MAX (REPMAX(2), TEMP)
C                                       If shift too large, flag
      IF (ABS(DELI).GT.XPARM(4)) THEN
         IRET = -1
         GO TO 999
         END IF
C                                       If shift too large, give warning
      IF (ABS(DELI).GT.XPARM(3)) THEN
         IF (((EDELI.NE.DELI) .OR. (EUT.NE.UT)) .AND.
     *      (CNTLSG.LE.LIMMSG)) THEN
            UTT = UT
            CALL TFDHMS (UTT, 1, TC, TIT, TS)
            WRITE (MSGTXT,1030) TIT, TS, DELI
            IF (MSGTXT(27:27).EQ.' ') MSGTXT(27:27) = '0'
            CALL MSGWRT (6)
            WRITE (MSGTXT,1031) LRAPPF, LDAPPF, LRAPP, LDAPP
            CALL MSGWRT (6)
            CNTLSG = CNTLSG + 1
         ELSE IF (CNTLSG.EQ.LIMMSG+1) THEN
            MSGTXT = 'Warning: further consecutive warnings suppressed'
            CALL MSGWRT (6)
            CNTLSG = CNTLSG + 1
            END IF
         CNTMSG = CNTMSG + 1
         EDELI = DELI
         EUT = UT
      ELSE
         CNTLSG = 0
         END IF
C                                       Loop and shift
      DO 100 IPOL = 1,NCOR
C                                       Copy data to temp array.
         DOINTP = .FALSE.
         INDEX = 1 + (IPOL-1) * INCSU
         DO 40 IFRQ = 1,NFREQ
            FINDEX = INDEX + (IFRQ-1) * INCFU
            VISTMP(1,IFRQ) = VIS(FINDEX)
            VISTMP(2,IFRQ) = VIS(FINDEX+1)
            TMPWT(IFRQ)    = VIS(FINDEX+2)
            IF (TMPWT(IFRQ).LE.0.0) DOINTP = .TRUE.
 40         CONTINUE
C                                       Deal with flagged spectral data
         ALLFLG = .FALSE.
         IF (DOINTP) CALL SPINTP (NFREQ, VISTMP, TMPWT, INTWTS, ALLFLG)
         IF (ALLFLG) THEN
            DO 50 IFRQ = 1,NFREQ
               FINDEX = INDEX + (IFRQ-1) * INCFU
               VIS(FINDEX+2) = -ABS(VIS(FINDEX+2))
 50            CONTINUE
C                                       Shift it!
         ELSE
            ISB = CSBAND(1)
            ISMTH = 0
            CALL ACSHFT (VISTMP, ISB, NFREQ, DELI, WORK, ISMTH)
C                                       Copy data back to vis array
            DO 60 IFRQ = 1,NFREQ
               FINDEX = INDEX + (IFRQ-1) * INCFU
               VIS(FINDEX) = VISTMP(1,IFRQ)
               VIS(FINDEX+1) = VISTMP(2,IFRQ)
               VIS(FINDEX+2) = TMPWT(IFRQ)
 60            CONTINUE
             END IF
 100      CONTINUE
      GO TO 999
C                                       Write Error message
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DSHIFT: ERROR',I4,' DETERMINING ',A)
 1020 FORMAT ('WARNING: HEADER DATE ',A,', AN FILE DATE ',A,' DIFFER')
 1021 FORMAT ('DSHIFT: BASELINE',I3,'-',I2,' NOT SINGLEDISH')
 1030 FORMAT ('WARNING: Time =',I4,'/',2(I2.2,':'),F4.1,
     *   ' channel shift =',F15.3)
 1031 FORMAT (6X,'Ref RA/Dec',2F10.5,' current',2F10.5)
      END
      SUBROUTINE SDVLHI
C-----------------------------------------------------------------------
C   SDVLHI copies and updates history file.  It also copies any tables
C   extension files.
C    Input from common:
C     DISOUT    I    Output file disk number
C     CNOOUT    I    Output file catalog slot number.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP(5)*2,LINE*72
      INTEGER   IERR, LUN1, LUN2, NONOT
      REAL      BUFFH(1024)
      LOGICAL   T
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'SDVEL.INC'
      EQUIVALENCE (BUFFER(1025), BUFFH)
      DATA LUN1, LUN2 /28,29/
      DATA NONOT, NOTTYP /2, 'CH','FQ','  ','  ','  '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISOUT, CNOIN,
     *   CNOOUT, CATOUT, BUFF1, BUFFH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFFH,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL H2CHR (12, KHIMNO, CATOH(KHIMN), NAMOUT)
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, CATOUT(KIIMS), DISOUT, LUN2,
     *   BUFFH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Input flagging
      IF (FGVER.GT.0) THEN
         WRITE (LINE,2001) TSKNAM, FGVER
         CALL HIADD (LUN2, LINE, BUFFH, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       Time range
      CALL HITIME (TIME1, TIME2, LUN2, BUFFH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Excessive shift flagging
      IF (CNTFLG.GT.0) THEN
         WRITE (LINE,2002) TSKNAM, CNTFLG, XPARM(4)
         CALL HIADD (LUN2, LINE, BUFFH, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
      IF (CNTMSG.GT.0) THEN
         WRITE (LINE,2003) TSKNAM, CNTMSG, XPARM(3)
         CALL HIADD (LUN2, LINE, BUFFH, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
      LINE = TSKNAM
      IF (XPARM(1).LE.0.0) THEN
         LINE(7:) = '/ One reference velocity at center coordinate'
      ELSE IF (XPARM(1).EQ.1.0) THEN
         LINE(7:) = '/ One reference velocity at first coordinate'
      ELSE IF (XPARM(1).EQ.2.0) THEN
         LINE(7:) = '/ New reference velocity at each off scan'
      ELSE IF (XPARM(1).EQ.3.0) THEN
         LINE(7:) = '/ New reference velocity at each scan'
      ELSE
         LINE(7:) = '/ REFERENCE VELOCITY SETTING NOT PROPERLY DEFINED'
         END IF
      CALL HIADD (LUN2, LINE, BUFFH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, BUFFH, IERR)
      IF (DOFLAG) THEN
         NONOT = NONOT + 1
         NOTTYP(NONOT) = 'FG'
         MSGTXT = 'Flag table applied - not copied to output'
         CALL MSGWRT (3)
         MSGTXT = 'If spectral flagging requested, spectra will have'
         CALL MSGWRT (3)
         MSGTXT = 'been interpolated before shifting'
         CALL MSGWRT (3)
         END IF
C
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISOUT, CNOIN,
     *   CNOOUT, CATOUT, BUFF1, BUFFH, IERR)
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISOUT, CNOOUT, CATOUT, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SDVLHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 2001 FORMAT (A6,'/ Edited using FG table version',I3)
 2002 FORMAT (A6,'/ Flagged',I6,' shifts >',F8.2,' channels - ',
     *   'data deleted')
 2003 FORMAT (A6,'/ Found',I8,' shifts >',F8.2,' channels - ',
     *   'data shifted')
      END
      SUBROUTINE CVFLAG (RPARM, VISIN, DROP, IERR)
C-----------------------------------------------------------------------
C   Flags data specified in flagging table
C   Inputs:
C      RPARM(*)   R    Random parameter array
C      VISIN(3,*)   R    Visibility array
C   Inputs from include DSEL.INC:
C      CURSOU     I    Current source number
C      NUMFLG     I    Number of flagging entries.
C      TMFLST     R    Time of last visibility for which flagging
C                      was checked.
C      FLGSOU(*)  I    Source id numbers to flag, 0=all.
C      FLGANT(*)  I    Antenna numbers to flag, 0=all.
C      FLGBAS(*)  I    Baseline (A1*32768+A2) numbers to flag, 0=all.
C      FLGSUB(*)  I    Subarray numbers to flag, 0=all.
C      FLGFQD(*)  I    Freqid numbers to flag, <=0=all.
C                      Following should have defaults filled in.
C      FLGBIF(*)  I    First IF to flag.
C      FLGEIF(*)  I    Highest IF to flag.
C      FLGBCH(*)  I    First channel to flag.
C      FLGECH(*)  I    Highest channel to flag.
C      FLGPOL(4,*)L    Flags for the polarizations, should correspond
C                      to selected polarization types.
C   Output:
C      RPARM(*)   R    Random parameter array
C      VISIN(3,*)   R    Visibility array
C      DROP       L    True if data all flagged.
C      IERR       I    Return code, 0=OK, else CVNXFG error number.
C-----------------------------------------------------------------------
      INTEGER   IERR, IFLAG, KBASE, A1, A2, FLGA, SUBA, JIF, JCHAN,
     *   JPOLN, LIMF1, LIMF2, LIMC1, LIMC2, INDEX, STADD, IPOLPT
      LOGICAL   DROP, GOOD
      REAL      TIME, SUM, RPARM(*), VISIN(3,*)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'SDVEL.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
C-----------------------------------------------------------------------
      IERR = 0
      DROP = .FALSE.
C                                       Check if new time
      TIME = RPARM(1+ILOCT)
      IF (TMFLST.LT.TIME) CALL CVNXFG (TIME, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Check if there are current flags
      IF (NUMFLG.LE.0) GO TO 999
C                                       Loop thru flagging criteria
      IF (ILOCB.GE.0) THEN
         KBASE = RPARM(1+ILOCB) + 0.1
         A1 = KBASE / 256
         A2 = KBASE - 256 * A1
         SUBA = (RPARM(1+ILOCB) - KBASE) * 100.0 + 1.5
      ELSE
         A1 = RPARM(1+ILOCA1) + 0.1
         A2 = RPARM(1+ILOCA2) + 0.1
         SUBA = RPARM(1+ILOCSA) + 0.1
         END IF
      KBASE = 32768 * A1 + A2
      DO 500 IFLAG = 1,NUMFLG
C                                       Check time if needed
         IF (.NOT.TIMORD) THEN
            IF ((TIME.LT.FLGTST(IFLAG)) .OR. (TIME.GT.FLGTND(IFLAG)))
     *         GO TO 500
            END IF
C                                       Check antenna
         FLGA = FLGANT(IFLAG)
         IF ((FLGA.NE.0) .AND. (FLGA.NE.A1) .AND. (FLGA.NE.A2))
     *      GO TO 500
C                                       Check baseline
         IF ((FLGBAS(IFLAG).NE.0) .AND. (FLGBAS(IFLAG).NE.KBASE))
     *      GO TO 500
C                                       Check subarray
         IF ((FLGSUB(IFLAG).NE.0) .AND. (FLGSUB(IFLAG).NE.SUBA))
     *      GO TO 500
C                                       Some data to be flagged
C                                       Set limits
         LIMF1 = FLGBIF(IFLAG)
         LIMF2 = FLGEIF(IFLAG)
         LIMC1 = FLGBCH(IFLAG)
         LIMC2 = FLGECH(IFLAG)
C                                       Loop over polarizations
         IPOLPT = ABS(FKCOR0) - 1
         DO 400 JPOLN = 1,FKNCOR
            IF (FLGPOL(JPOLN+IPOLPT,IFLAG)) THEN
               STADD = (JPOLN-1) * FKNCS + 1
C                                       Loop over IF
               DO 300 JIF = LIMF1,LIMF2
                  INDEX = STADD + (JIF-1) * FKNCIF + (LIMC1-1) * FKNCF
                  IF (LIMC1.EQ.LIMC2) THEN
C                                       Single channel
                     VISIN(3,INDEX) = - ABS (VISIN(3,INDEX))
                  ELSE
C                                       Loop over channel
                     DO 200 JCHAN = LIMC1,LIMC2
C                                       Flag
                        VISIN(3,INDEX) = - ABS (VISIN(3,INDEX))
                        INDEX = INDEX + FKNCF
 200                    CONTINUE
                     END IF
 300              CONTINUE
               END IF
 400        CONTINUE
 500     CONTINUE
C                                       Check if data all bad
      GOOD = .FALSE.
C                                       Loop over polarizations
      DO 520 JPOLN = 1,FKNCOR
         INDEX = 1 + (JPOLN-1) * FKNCS
C                                       Multiple channels
         SUM = 0.0
         DO 510 JCHAN = 1,NUMFRQ
            SUM = SUM + MAX (0.0, VISIN(3,INDEX))
            INDEX = INDEX + FKNCF
 510        CONTINUE
         GOOD = GOOD .OR. (SUM.GT.0.0)
 520     CONTINUE
      DROP = .NOT.GOOD
C
 999  RETURN
      END
      SUBROUTINE CVNXFG (TIME, IERR)
C-----------------------------------------------------------------------
C   Updates flagging tables in common fron an FG table.
C   Inputs:
C      TIME         R    Current time (days) for flag entries
C   Inputs from common /CFMINF/(INCLUDEs C/DSEL.INC):
C      NUMFLG       I    number of current FLAG entries.
C      FGKOLS(MAXFGC) I    The column pointer array in order, SOURCE,
C                        SUBARRAY, FREQID, ANTS, TIMERANG, IFS, CHANS,
C                        PFLAGS, REASON
C      FGNUMV(MAXFGC) I    Element count for each column
C      IFGRNO       I    Current FLAG file record.
C   Output to common /CFMINF/:
C      NUMFLG     I    Number of flagging entries.
C      TMFLST     R    Time of last visibility for which flagging
C                      was checked.
C      FLGSOU(*)  I    Source id numbers to flag, 0=all.
C      FLGANT(*)  I    Antenna numbers to flag, 0=all.
C      FLGBAS(*)  I    Baseline (A1*32768+A2) numbers to flag, 0=all.
C      FLGSUB(*)  I    Subarray numbers to flag, 0=all.
C      FLGFQD(*)  I    Freqid numbers to flag, <=0=all.
C                      Following should have defaults filled in.
C      FLGBIF(*)  I    First IF to flag.
C      FLGEIF(*)  I    Highest IF to flag.
C      FLGBCH(*)  I    First channel to flag.
C      FLGECH(*)  I    Highest channel to flag.
C      FLGPOL(4,*)L    Flags for the polarizations, should correspond
C                      to selected polarization types.
C      FLGTST(*)  R    Start time of flag.
C      FLGTND(*)  R    End time of flag.
C   Output:
C      IERR       I    Return code, 0=OK, else TABIO error number.
C-----------------------------------------------------------------------
      REAL      TIME
      INTEGER   IERR
C
      INTEGER   NDROP, LIMIT, RECI(30), MXFLG, SOUKOL, SUBKOL, FRQKOL,
     *   ANTKOL, TIMKOL, IFKOL, CHKOL, POLKOL, REAKOL, A1, A2, IT, I4,
     *   NFGREC, I, LIMIT4
      REAL      RECORD(31)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'SDVEL.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      EQUIVALENCE (RECORD, RECI)
      EQUIVALENCE (FGKOLS(1), SOUKOL), (FGKOLS(2), SUBKOL),
     *   (FGKOLS(3), FRQKOL), (FGKOLS(4), ANTKOL), (FGKOLS(5),TIMKOL),
     *   (FGKOLS(6), IFKOL),  (FGKOLS(7), CHKOL), (FGKOLS(8), POLKOL),
     *   (FGKOLS(9), REAKOL)
      DATA I4 /4/
C-----------------------------------------------------------------------
      IERR = 0
      MXFLG = MAXFLG
      TMFLST = TIME
C                                       Check if any flags expired.
 10   NDROP = 0
C                                       Find highest number expired flag
      IF ((NUMFLG.GT.0) .AND. (TIMORD)) THEN
         DO 20 I = 1,NUMFLG
            IF (FLGTND(I).LT.TIME) NDROP = I
 20         CONTINUE
         END IF
C                                       Compress, dropping flag.
      IF (NDROP.GT.0) THEN
         IF (NDROP.LT.NUMFLG) THEN
            LIMIT = NDROP + 1
            DO 150 I = LIMIT,NUMFLG
               IT = I - 1
               FLGTST(IT) = FLGTST(I)
               FLGTND(IT) = FLGTND(I)
               FLGSOU(IT) = FLGSOU(I)
               FLGANT(IT) = FLGANT(I)
               FLGFQD(IT) = FLGFQD(I)
               FLGBAS(IT) = FLGBAS(I)
               FLGSUB(IT) = FLGSUB(I)
               FLGBIF(IT) = FLGBIF(I)
               FLGEIF(IT) = FLGEIF(I)
               FLGBCH(IT) = FLGBCH(I)
               FLGECH(IT) = FLGECH(I)
               FLGPOL(1,IT) = FLGPOL(1,I)
               FLGPOL(2,IT) = FLGPOL(2,I)
               FLGPOL(3,IT) = FLGPOL(3,I)
               FLGPOL(4,IT) = FLGPOL(4,I)
 150           CONTINUE
            END IF
         NUMFLG = NUMFLG - 1
         GO TO 10
         END IF
C                                       Find next valid flag.
      NFGREC = FGBUFF(5)
C                                       Loop through records
C                                       Check if list exhausted
      IF (IFGRNO.GT.NFGREC) GO TO 999
 310  LIMIT4 = IFGRNO
      DO 360 I = LIMIT4,NFGREC
         IFGRNO = I
         IERR = 1
C                                       Read record.
         CALL TABIO ('READ', 0, IFGRNO, RECORD, FGBUFF, IERR)
C                                       Check if flagged
         IF (IERR.LT.0) GO TO 360
C                                       Check error
         IF (IERR.GT.0) GO TO 999
C                                       Check time.
         IF (TIME.LT.RECORD(TIMKOL)) GO TO 999
         IF (TIME.LE.RECORD(TIMKOL+1)) GO TO 500
 360     CONTINUE
C                                       No flags - bail out.
      IERR = 0
      GO TO 999
C                                       Next entry
 500  NUMFLG = NUMFLG + 1
C                                       Check if too big
      IERR = 0
      IF (NUMFLG.GT.MXFLG) THEN
         IERR = 0
         WRITE (MSGTXT,1500) MXFLG
         CALL MSGWRT (8)
         IF (TIMORD) THEN
            MSGTXT = 'USE UVCOP TO APPLY THE FG TABLE'
         ELSE
            MSGTXT = 'SORT TO TIME ORDER TO APPLY THE FG TABLE'
            END IF
         GO TO 990
         END IF
C                                       Fill in tables
      FLGTST(NUMFLG) = RECORD(TIMKOL)
      FLGTND(NUMFLG) = RECORD(TIMKOL+1)
      FLGSOU(NUMFLG) = RECI(SOUKOL)
      FLGFQD(NUMFLG) = RECI(FRQKOL)
      A1 = MIN (RECI(ANTKOL), RECI(ANTKOL+1))
      A2 = MAX (RECI(ANTKOL), RECI(ANTKOL+1))
      IF (A1.LE.0) THEN
         FLGANT(NUMFLG) = A2
         FLGBAS(NUMFLG) = 0
      ELSE
         FLGANT(NUMFLG) = RECI(ANTKOL)
         FLGBAS(NUMFLG) = A1*32768 + A2
         END IF
      FLGSUB(NUMFLG) = RECI(SUBKOL)
      FLGBIF(NUMFLG) = RECI(IFKOL)
      FLGEIF(NUMFLG) = RECI(IFKOL+1)
      IF (FLGBIF(NUMFLG).LE.0) FLGBIF(NUMFLG) = 1
      IF (FLGEIF(NUMFLG).LE.0) THEN
         IF (JLOCIF.GT.0) FLGEIF(NUMFLG) = CATBLK (KINAX+JLOCIF)
         IF (JLOCIF.LE.0) FLGEIF(NUMFLG) = 1
         END IF
      FLGBCH(NUMFLG) = RECI(CHKOL)
      FLGECH(NUMFLG) = MIN (CATBLK(KINAX+JLOCF), RECI(CHKOL+1))
      IF (FLGBCH(NUMFLG).LE.0) FLGBCH(NUMFLG) = 1
      IF (FLGECH(NUMFLG).LE.0) FLGECH(NUMFLG) = CATBLK (KINAX+JLOCF)
      CALL LG2BIT (I4, FLGPOL(1,NUMFLG), RECI(POLKOL), -1)
C                                       Increment flag counter
      IFGRNO = IFGRNO + 1
C                                       Loop back for next
      IF (IFGRNO.LE.NFGREC) GO TO 310
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1500 FORMAT ('TOO MANY FLAGS AT SAME TIME (>',I4,')')
      END
      DOUBLE PRECISION FUNCTION TAI (UTC)
C-----------------------------------------------------------------------
C  Increment to be applied to Coordinated Universal Time UTC to give
C  International Atomic Time TAI
C
C  Inputs:
C     UTC      D      UTC as a modified JD (JD-2400000.5)
C
C  Result:  TAI-UTC in seconds
C
C  Pre 1972 January 1 a fixed value of 10 sec is returned.
C
C     :-----------------------------------------:
C     :                                         :
C     :                IMPORTANT                :
C     :                                         :
C     :  This routine must be updated on each   :
C     :     occasion that a leap second is      :
C     :                announced                :
C     :                                         :
C     :  Latest leap second:  1990 January 1    :
C     :                                         :
C     :-----------------------------------------:
C
C  P.T.Wallace   Starlink   21 November 1989
C-----------------------------------------------------------------------
      DOUBLE PRECISION UTC
      DOUBLE PRECISION DT
C-----------------------------------------------------------------------
      DT = 10D0
C                                         1972 July 1
      IF (UTC.GE.41498D0) DT=11D0
C                                         1973 January 1
      IF (UTC.GE.41683D0) DT=12D0
C                                         1974 January 1
      IF (UTC.GE.42048D0) DT=13D0
C                                         1975 January 1
      IF (UTC.GE.42413D0) DT=14D0
C                                         1976 January 1
      IF (UTC.GE.42778D0) DT=15D0
C                                         1977 January 1
      IF (UTC.GE.43144D0) DT=16D0
C                                         1978 January 1
      IF (UTC.GE.43509D0) DT=17D0
C                                         1979 January 1
      IF (UTC.GE.43874D0) DT=18D0
C                                         1980 January 1
      IF (UTC.GE.44239D0) DT=19D0
C                                         1981 July 1
      IF (UTC.GE.44786D0) DT=20D0
C                                         1982 July 1
      IF (UTC.GE.45151D0) DT=21D0
C                                         1983 July 1
      IF (UTC.GE.45516D0) DT=22D0
C                                         1985 July 1
      IF (UTC.GE.46247D0) DT=23D0
C                                         1988 January 1
      IF (UTC.GE.47161D0) DT=24D0
C                                         1990 January 1
      IF (UTC.GE.47892D0) DT=25D0
C
      TAI=DT
      RETURN
      END
      SUBROUTINE GETFRQ (OLDSOU, IRET)
C-----------------------------------------------------------------------
C   Routine to get all freq, vel type parameters needed for the
C   shifting routine  This is a restricted version for single-dish, 1
C   IF, single-source data sets.
C   Inputs:
C      OLDSOU   I
C   Input in common:
C      CATBLK   I(256)   Catalog header - UVPGET called
C   Outputs in common:
C      REFFRQ   D(NIF)   Freq. (Hz) of ref. pixel - same one to which
C                        VEL refers.
C      RSTFRQ   D(NIF)   Rest freq. (Hz) of the transition in each IF
C      VEL      D(NIF)   Desired velocity of the reference pixel of each
C                        IF (m/s)
C      HELIO    L        .TRUE. if velocity reference frame is
C                        heliocentric/barycentric.
C      RADIO    L        .TRUE. if velocity follows radio definition.
C      SOUDUN   I(*)     > 0 if source already dealt with
C   Output:
C      IRET              I        Error: = 0 => all OK
C-----------------------------------------------------------------------
      INTEGER   OLDSOU, IRET
C
      INTEGER   ALTAX, I, ITRIM
      REAL      RTEMP
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCVL.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Set base ref. freq.
      IF (OLDSOU.GT.0) GO TO 999
      OLDSOU = 1
C                                       Get frequency info.
      CFOFF(1) = 0.0D0
      CSBAND(1) = 1
      CFINC(1) = CATR(KRCIC+JLOCF)
C                                       Extract information from
C                                       alternate reference pixels
      ALTAX = CATBLK (KIALT)
C                                       Check if vel info available
      HELIO = .FALSE.
      RADIO = .FALSE.
      IF (ALTAX.GT.256) THEN
         RADIO = .TRUE.
         ALTAX = ALTAX - 256
         END IF
      IF (ALTAX.EQ.2) HELIO = .TRUE.
C                                       Inform user
      IF (HELIO) THEN
         MSGTXT = 'Velocity type is heliocentric; definition is'
      ELSE
         MSGTXT = 'Velocity type is LSR; definition is'
         END IF
      I = ITRIM (MSGTXT) + 2
      IF (RADIO) THEN
         MSGTXT(I:) = 'Radio'
      ELSE
         MSGTXT(I:) = 'Optical'
         END IF
      CALL MSGWRT (4)
C                                       Determine freq. of ref pixel,
      REFFRQ(1) = CATD(KDCRV+JLOCF) + CFOFF(1)
C                                       For single source files, there
C                                       can be only one rest frequency
C                                       for all IFs (nowhere to store
C                                       more than one).
C
C                                       Determine rest freq. of line
C                                       from user or header and
C                                       replicate to all IFs
      RSTFRQ(1) = CATD(KDRST)
C                                       Inform user
      RTEMP = RSTFRQ(1) / 1.0E6
      IF (RSTFRQ(1).LE.0.1D0) THEN
         WRITE (MSGTXT,1000) RTEMP
         IRET = 1
         GO TO 990
      ELSE
         WRITE (MSGTXT,1001) RTEMP
         CALL MSGWRT (4)
         END IF
C                                       Find from header, a velocity
C                                       (REFVEL) and the pixel to which
C                                       it refers (ALTRFP)
      RTEMP = CATD(KDARV) / 1.0E3
      WRITE (MSGTXT,1005) RTEMP, CATR(KRARP)
      CALL MSGWRT (4)
      VEL(1) = CATD(KDARV)
      GO TO 999
C                                       Write error message
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Rest frequency = ',F16.6,' MHz: ILLEGAL')
 1001 FORMAT ('Rest frequency = ',F16.6,' MHz')
 1005 FORMAT ('Velocity is',F11.3,' km/s at pixel',F8.2)
      END

      SUBROUTINE TABST (OPCODE, BUFFER, ISTRNO, STKOLS, STNUMV, STXY,
     *   STWID, STTYPE, STCOMM, IERR)
C-----------------------------------------------------------------------
C! REads/writes ST (stars) tables
C# EXT-util Plot
C-----------------------------------------------------------------------
C;  Copyright (C) 2011, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   creates and/or opens for writing (and reading) a specified ST table
C   for star positions/widths
C   Inputs:
C      OPCODE   C*4      READ or WRIT (create only if none previously)
C      STKOLS   I(7)     Column pointers
C      STNUMV   I(7)     Coumn counts
C   In/out: (basic)
C      BUFFER   I(512)   TABIO control buffer
C      ISTRNO   I        Record number
C      STXY     D(2)     X, Y values
C      STWID    R(3)     Major, minor axes, position angle
C      STTYPE   I        Star type code
C      STCOMM   C*24     Star label or comment
C   Output:
C      IERR     I        Error codes from TABINI or TABIO
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, STCOMM*24
      INTEGER   BUFFER(512), ISTRNO, STKOLS(*), STNUMV(*), STTYPE, IERR
      REAL      STWID(3)
      DOUBLE PRECISION STXY(2)
C
      INTEGER   NCOLS, NVALS
      PARAMETER (NCOLS = 7)
      PARAMETER (NVALS = 14)
      INTEGER   KOLS(NCOLS), XKOL, YKOL, MAJKOL, MINKOL, PAKOL, TYPKOL,
     *   COMKOL, RECI(NVALS), IROUND
      REAL      RECR(NVALS)
      DOUBLE PRECISION RECD(NVALS/2)
      HOLLERITH RECH(NVALS)
      EQUIVALENCE (RECR, RECI, RECH, RECD)
      EQUIVALENCE (KOLS(1), XKOL), (KOLS(2), YKOL), (KOLS(3), MAJKOL),
     *   (KOLS(4), MINKOL), (KOLS(5), PAKOL), (KOLS(6), TYPKOL),
     *   (KOLS(7), COMKOL)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Close
      IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, ISTRNO, RECR, BUFFER, IERR)
         IF (IERR.GT.0) GO TO 980
         GO TO 999
         END IF
C                                       local copy column pointers
      CALL COPY (NCOLS, STKOLS, KOLS)
C                                       fill record
      IF (OPCODE.EQ.'WRIT') THEN
         RECD(XKOL)   = STXY(1)
         RECD(YKOL)   = STXY(2)
         IF (STNUMV(3).GT.0) RECR(MAJKOL) = STWID(1)
         IF (STNUMV(4).GT.0) RECR(MINKOL) = STWID(2)
         IF (STNUMV(5).GT.0) RECR(PAKOL ) = STWID(3)
         IF (STNUMV(6).GT.0) RECR(TYPKOL) = STTYPE
         CALL CHR2H (STNUMV(7), STCOMM, 1, RECH(COMKOL))
         END IF
C                                       Process record.
 10   CALL TABIO (OPCODE, 0, ISTRNO, RECR, BUFFER, IERR)
      ISTRNO = ISTRNO + 1
      IF (IERR.GT.0) GO TO 980
C                                       If READ pick data from RECR.
      IF (OPCODE.EQ.'READ') THEN
         STWID(1) = 0.0
         STWID(2) = 0.0
         STWID(3) = 0.0
         STTYPE   = 3
         STCOMM = ' '
         STXY(1)  = RECD(XKOL)
         STXY(2)  = RECD(YKOL)
         IF (STNUMV(3).GT.0) STWID(1) = RECR(MAJKOL)
         IF (STNUMV(4).GT.0) STWID(2) = RECR(MINKOL)
         IF (STNUMV(5).GT.0) STWID(3) = RECR(PAKOL)
         IF (STNUMV(6).GT.0) STTYPE   = IROUND (RECR(TYPKOL))
         IF (STNUMV(7).GT.0) CALL H2CHR (STNUMV(7), 1, RECH(COMKOL),
     *      STCOMM)
         END IF
      GO TO 999
C                                       Error
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('TABST: TABIO ERROR',I3)
      END

      SUBROUTINE SWAPAX (CATBLK, CATH, CATR, CATD, IAXIS1, IAXIS2, IERR)
C-----------------------------------------------------------------------
C! swaps the values for two axes
C# Header
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  SWAPAX (swap axis) will swap the header values for two given axes
C  in an image header.
C  INOUT:  CATBLK  I(256)   Image header integer values.
C          CATH    H(256)   Image header HOLLERITH values (usually
C                           equivalenced to CATBLK).
C          CATR    R(256)   Image header real values (usually
C                           equivalenced to CATBLK).
C          CATD    D(128)   Image header Real*8 values.
C  IN:     IAXIS1  I   One of the axis to switch.
C          IAXIS2  I   The other axis.
C  OUT:    IERR    I   0=ok, 1=IAXIS1 or IAXIS2 > 7 or < 1.
C-----------------------------------------------------------------------
      INTEGER   CATBLK(256), IAXIS1, IAXIS2, IERR
      DOUBLE PRECISION CATD(128)
      REAL      CATR(256)
      HOLLERITH CATH(256)
C
      HOLLERITH HTEMP
      INTEGER   ITEMP, IS1, IS2
      DOUBLE PRECISION DTEMP
      REAL      RTEMP
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Check axis ranges.
      IF ((IAXIS1.LT.1) .OR. (IAXIS1.GT.KICTPN)) GO TO 990
      IF ((IAXIS2.LT.1) .OR. (IAXIS2.GT.KICTPN)) GO TO 990
      IERR = 0
C                                       Coordinate type.
      IS1 = (IAXIS1 - 1) * 2 + KHCTP
      IS2 = (IAXIS2 - 1) * 2 + KHCTP
      HTEMP = CATH(IS1)
      CATH(IS1) = CATH(IS2)
      CATH(IS2) = HTEMP
      HTEMP = CATH(IS1+1)
      CATH(IS1+1) = CATH(IS2+1)
      CATH(IS2+1) = HTEMP
C                                       Coordinate value at ref pixel.
      DTEMP = CATD(KDCRV+IAXIS1-1)
      CATD(KDCRV+IAXIS1-1) = CATD(KDCRV+IAXIS2-1)
      CATD(KDCRV+IAXIS2-1) = DTEMP
C                                       Coordinate value increment.
      RTEMP = CATR(KRCIC+IAXIS1-1)
      CATR(KRCIC+IAXIS1-1) = CATR(KRCIC+IAXIS2-1)
      CATR(KRCIC+IAXIS2-1) = RTEMP
C                                       Coordinate reference pixel.
      RTEMP = CATR(KRCRP+IAXIS1-1)
      CATR(KRCRP+IAXIS1-1) = CATR(KRCRP+IAXIS2-1)
      CATR(KRCRP+IAXIS2-1) = RTEMP
C                                       Coordinate rotation angles.
      RTEMP = CATR(KRCRT+IAXIS1-1)
      CATR(KRCRT+IAXIS1-1) = CATR(KRCRT+IAXIS2-1)
      CATR(KRCRT+IAXIS2-1) = RTEMP
C                                       No. of pixels on axis.
      ITEMP = CATBLK(KINAX+IAXIS1-1)
      CATBLK(KINAX+IAXIS1-1) = CATBLK(KINAX+IAXIS2-1)
      CATBLK(KINAX+IAXIS2-1) = ITEMP
      GO TO 999
C                                       Axis range error.
 990  WRITE (MSGTXT,1990) IAXIS1, IAXIS2
      CALL MSGWRT (6)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1990 FORMAT ('SWAPAX: AXIS RANGE ERROR. IAXIS1, IAXIS2 =',2I6)
      END

      SUBROUTINE BPSHFT (SPECT, NCOR, NIF, NCHAN, KSNCS, KSNCIF,
     *   KSNCF, SHIFT, DATTYP)
C-----------------------------------------------------------------------
C! Control frequency shift of cross power spectra
C# UV IO-appl Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  A routine to control the shifting of spectral data. It does the shift
C  on each IF and polzn spectrum independently.
C
C  Input/Output:
C     SPECT(*)        R        Input spectrum, output shifted spectrum
C  Input:
C     NCOR            I        # polzns
C     NIF             I        # IFs
C     NCHAN           I        # channels
C     KSNCS           I        polzn increment in buffer
C     KSNCIF          I        IF increment in buffer
C     KSNCF           I        channel increment in buffer
C     SHIFT(*)        D        shift (in channels) to be performed,
C                              IF dependent
C     DATTYP          I        Type of data that was used to form the
C                              BP table: 0 = don't know, assume x-p
C                                        1 = x-p
C                                        2 = t-p
C                                        3 = both
C-----------------------------------------------------------------------
      REAL SPECT(*)
      DOUBLE PRECISION SHIFT(*)
      INTEGER NCOR, NIF, NCHAN, KSNCS, KSNCIF, KSNCF, DATTYP
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER IPOL, IFNO, INDEX, IFRQ, FINDEX, ISB, ISMTH
      LOGICAL DOINTP, ALLFLG
      REAL    VISTMP(2,MAXCHA), TMPWT(MAXCHA), INTWTS(MAXCHA)
      SAVE VISTMP, TMPWT, INTWTS
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      DO 300 IPOL = 1,NCOR
         DO 200 IFNO = 1,NIF
C                                       Copy data to temp array.
            DOINTP = .FALSE.
            INDEX = 1 + (IPOL-1) * KSNCS + (IFNO-1) * KSNCIF
            DO 120 IFRQ = 1,NCHAN
               FINDEX = INDEX + (IFRQ-1) * KSNCF
               VISTMP(1,IFRQ) = SPECT(FINDEX)
               VISTMP(2,IFRQ) = SPECT(FINDEX+1)
               TMPWT(IFRQ) = 1.0
               IF ((SPECT(FINDEX).EQ.FBLANK) .OR.
     *            (SPECT(FINDEX+1).EQ.FBLANK)) TMPWT(IFRQ) = -1.0
               IF (TMPWT(IFRQ).LE.0.0) DOINTP = .TRUE.
 120         CONTINUE
C                                       Deal with flagged
C                                       spectral data
            ALLFLG = .FALSE.
            IF (DOINTP) CALL SPINTP (NCHAN, VISTMP, TMPWT,
     *         INTWTS, ALLFLG)
            IF (ALLFLG) THEN
               DO 125 IFRQ = 1,NCHAN
                  FINDEX = INDEX + (IFRQ-1) * KSNCF
                  SPECT(FINDEX) = FBLANK
                  SPECT(FINDEX+1) = FBLANK
 125              CONTINUE
               GO TO 200
               END IF
C                                       Shift it!
            ISB = 1
            IF (DATTYP.EQ.2) THEN
               ISMTH = 1
               CALL TPSHFT (VISTMP, NCHAN, SHIFT(IFNO), INTWTS, ISMTH)
            ELSE
               CALL XCSHNQ (VISTMP, ISB, NCHAN, SHIFT(IFNO), INTWTS)
               END IF
C                                       Copy data back to vis
C                                       array
            DO 140 IFRQ = 1,NCHAN
               FINDEX = INDEX + (IFRQ-1) * KSNCF
               IF (DATTYP.EQ.2) THEN
                  SPECT(FINDEX) = SQRT (VISTMP(1,IFRQ)*VISTMP(1,IFRQ)
     *               + VISTMP(2,IFRQ)*VISTMP(2,IFRQ))
                  SPECT(FINDEX+1) = 0.0
               ELSE
                  SPECT(FINDEX) = VISTMP(1,IFRQ)
                  SPECT(FINDEX+1) = VISTMP(2,IFRQ)
                  END IF
 140           CONTINUE
 200        CONTINUE
 300     CONTINUE
C
      RETURN
      END

      SUBROUTINE CTICS (LAXIS, BLC, TRC, XYRATO, YX, DOACRS, IBUFF,
     *   IERR)
C-----------------------------------------------------------------------
C! writes tick marks and tick labels to a plot file
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998-2003, 2013-2014
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CTICS writes tick marks and tick labels to a plot file.
C   If CPREF(IAX) and CTYP(IAX) are all blank, no tick labels are done.
C   Inputs:
C      LAXIS   I        1 => horizontal,  2 => vertical full plots
C                       3 => horiz subplot 4 => vertical subplot
C      BLC     R(2)     X and Y pixels to form bottom left hand
C                       corner of the graph.
C      TRC     R(2)     X and Y pixels to form the top right hand
C                       corner of the graph.
C      XYRATO  R        X to Y scaling factor
C      YX      D        LAXIS=3: plot x axis at y = YX; 4: plot y axis
C                       at x = YX - out range => BLC(1,2) value
C      DOACRS  L        Do coordinate grid (T) or just ticks (F)
C   In/out:
C      IBUFF   I(256)   buffer being used for output to
C                       the graphics file.
C   Outputs:
C      IERR    I        error code: 0 => ok
C                                   1 => bad IAXIS
C                                   2 => graph drawing error
C                                   3 => tic algorithm fails
C-----------------------------------------------------------------------
      INTEGER   LAXIS, IBUFF(256), IERR
      REAL      BLC(2), TRC(2), XYRATO
      DOUBLE PRECISION YX
      LOGICAL   DOACRS
C
      CHARACTER SPRTXT*80, SUBR*6, CHDL*4
      DOUBLE PRECISION DEG, DEGC, DTX, DX, DTY, DY, PT5SEC, TICX, TICY,
     *   DEGC0, DEG0, XDT, YDT, DEGC1, LDX, LDY, LLDX, LLDY, UPLIM,
     *   LOLIM, AYX, XUPLIM, XLOLIM, DZ
      REAL      DCX, DSP, X, Y, TICT, DCY, XT, YT, TICL, BX(2), BY(2),
     *   PRX, PRY, DXLIM, DYLIM, LBLC(2), LTRC(2)
      INTEGER   HML(2), IAXIS, AXISTP, I, IANGL, ILEN, ITRY, COOTYP,
     *   INOI, JERR, KERR, I1,I2, J1, J2, J
      LOGICAL   NONUM, FIRST, UP, NPOLE, SPOLE
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
      IAXIS = LAXIS
      IF (LAXIS.GT.2) IAXIS = IAXIS - 2
      LBLC(1) = BLC(1) - 0.5
      LBLC(2) = BLC(2) - 0.5
      LTRC(1) = TRC(1) + 0.5
      LTRC(2) = TRC(2) + 0.5
C                                       Assign initial values.
      IANGL = 0
C                                       Find value at BLC.
C                                       vertical
      IF (IAXIS.EQ.2) THEN
         AYX = YX
         CALL TICINC (LAXIS, LBLC, LTRC, XYRATO, AYX, DEGC, DEG, INOI,
     *      TICX, TICY, TICL, PT5SEC, ITRY, KERR)
         IF (KERR.NE.0) THEN
            IF (KERR.GT.0) IERR = 3
            GO TO 999
            END IF
         DCX = -1.0
         DCY = -0.5
         AXISTP = LABTYP(LOCNUM) / 10
C                                       horizontal
      ELSE IF (IAXIS.EQ.1) THEN
         DCX = 0.5
         DCY = -1.5
         AYX = YX
         CALL TICINC (LAXIS, LBLC, LTRC, XYRATO, AYX, DEGC, DEG, INOI,
     *      TICX, TICY, TICL, PT5SEC, ITRY, KERR)
         IF (KERR.NE.0) THEN
            IF (KERR.GT.0) IERR = 3
            GO TO 999
            END IF
         AXISTP = MOD (LABTYP(LOCNUM), 10)
      ELSE
         GO TO 990
         END IF
C                                       Determine possible tic intervls
      NONUM = (CPREF(IAXIS,LOCNUM).EQ.' ') .AND.
     *   (CTYP(IAXIS,LOCNUM).EQ.' ')
      COOTYP = 2
      IF ((AXISTP.EQ.5) .OR. (AXISTP.GE.7)) COOTYP = 1
      LDX = RPVAL(1,LOCNUM)
      LLDX = RPVAL(1,LOCNUM)
      LDY = RPVAL(2,LOCNUM)
      LLDY = RPVAL(2,LOCNUM)
C                                       Draw tic marks and values.
      HML(1) = -32000
      HML(2) = -32000
      CHDL = '$$$$'
      DEGC0 = DEGC
      FIRST = .TRUE.
      DEG0 = DEG
      DEGC1 = DEGC0 - DEG
      DO 50 I = 1,INOI
C                                       vertical full plot
         IF (LAXIS.EQ.2) THEN
            DY = DEGC
            CALL FNDX (BLC(1), DY, DX, JERR)
            IF (JERR.NE.0) GO TO 40
            CALL XYPIX (DX, DY, X, Y, JERR)
            IF (X.GT.BLC(1)+0.1) GO TO 40
            X = MIN (X, BLC(1))
C                                       horizontal full plot
         ELSE IF (LAXIS.EQ.1) THEN
            DX = DEGC
            CALL FNDY (BLC(2), DX, DY, JERR)
            IF (JERR.NE.0) GO TO 40
            CALL XYPIX (DX, DY, X, Y, JERR)
            IF (Y.GT.BLC(2)+0.1) GO TO 40
            Y = MIN (Y, BLC(2))
C                                       vertical subplot
         ELSE IF (LAXIS.EQ.4) THEN
            DY = DEGC
            DX = AYX
            CALL XYPIX (DX, DY, X, Y, JERR)
C                                       horizontal subplot
         ELSE
            DX = DEGC
            DY = AYX
            CALL XYPIX (DX, DY, X, Y, JERR)
            END IF
         IF (JERR.NE.0) GO TO 40
C                                       Convert degrees to pixels.
         IF ((X.LT.LBLC(1)-0.01) .OR. (X.GT.LTRC(1)+0.01)) GO TO 40
         IF ((Y.LT.LBLC(2)-0.01) .OR. (Y.GT.LTRC(2)+0.01)) GO TO 40
         IF (DX.NE.LDX) LLDX = LDX
         IF (DY.NE.LDY) LLDY = LDY
         LDX = DX
         LDY = DY
         CALL GPOS (X, Y, IBUFF, IERR)
         SUBR = 'GPOS'
         IF (IERR.NE.0) GO TO 980
C                                       Find end of tic.
         DTX = DX + SIGN (1.0, AXINC(1,LOCNUM)) * TICX
         DTY = DY + SIGN (1.0, AXINC(2,LOCNUM)) * TICY
         CALL XYPIX (DTX, DTY, XT, YT, JERR)
         IF (JERR.NE.0) GO TO 20
         TICT = SQRT ((XT-X)**2 + (YT-Y)**2)
         IF (TICL.LE.0.) TICL = 1.
         IF ((TICT.GT.TICL) .OR. (TICT.LT.0.1*TICL)) THEN
            IF (TICT.EQ.0.0) GO TO 20
            DTX = DX + SIGN (1.0, AXINC(1,LOCNUM)) * TICX * TICL / TICT
            DTY = DY + SIGN (1.0, AXINC(2,LOCNUM)) * TICY * TICL / TICT
            CALL XYPIX (DTX, DTY, XT, YT, JERR)
            IF (JERR.NE.0) GO TO 20
            END IF
         IF ((XT.LT.LBLC(1)-0.01) .OR. (XT.GT.LTRC(1)+0.01)) GO TO 20
         IF ((YT.LT.LBLC(2)-0.01) .OR. (YT.GT.LTRC(2)+0.01)) GO TO 20
C                                       Simple tick: even with DOACROS
C                                       Position at end of tic.
         CALL GPOS (XT, YT, IBUFF, IERR)
         SUBR = 'GPOS'
         IF (IERR.NE.0) GO TO 980
C                                       Draw back to border.
         CALL GVEC (X, Y, IBUFF, IERR)
         SUBR = 'GVEC'
         IF (IERR.NE.0) GO TO 980
         DEGC1 = DEGC - DEG
         IF (FIRST) DEGC0 = DEGC
         FIRST = .FALSE.
C                                       Convert degrees to DEC/RA.
 20      IF (.NOT.NONUM) THEN
C                                       labels offset
            IF ((LAXIS.EQ.3) .OR. (LAXIS.EQ.4)) THEN
               IF (LAXIS.EQ.3) CALL FNDY (BLC(2), DX, DY, JERR)
               IF (LAXIS.EQ.4) CALL FNDX (BLC(1), DY, DX, JERR)
               IF (JERR.NE.0) GO TO 40
               CALL XYPIX (DX, DY, X, Y, JERR)
               IF (JERR.NE.0) GO TO 40
               END IF
C                                       Position for labels
            CALL GPOS (X, Y, IBUFF, IERR)
            SUBR = 'GPOS'
            IF (IERR.NE.0) GO TO 980
C                                       label string
            CALL TICSTR (ITRY, DEGC, PT5SEC, AXISTP, COOTYP, CHDL, HML,
     *         SPRTXT, ILEN)
            DSP = DCX - ILEN
            CALL GCHAR (ILEN, IANGL, DSP, DCY, SPRTXT, IBUFF, IERR)
            SUBR = 'GCHAR'
            IF (IERR.NE.0) GO TO 980
            END IF
 40      DEGC = DEGC - DEG
 50      CONTINUE
C                                       No top/right in subplots
      IF (((LAXIS.EQ.1) .OR. (LAXIS.EQ.2)) .AND. (.NOT.DOACRS)) THEN
C                                       Draw tics for other side.
C                                       Same intervals but not
C                                       necessarily same values.
         IF (IAXIS.NE.1) THEN
            CALL TICINC (6, LBLC, LTRC, XYRATO, AYX, DEGC, DEG, INOI,
     *         TICX, TICY, TICL, PT5SEC, ITRY, KERR)
C                                       horizontal
         ELSE
            CALL TICINC (5, LBLC, LTRC, XYRATO, AYX, DEGC, DEG, INOI,
     *         TICX, TICY, TICL, PT5SEC, ITRY, KERR)
            END IF
         IF (KERR.NE.0) INOI = 0
C                                       Loop for other border.
         DO 90 I= 1,INOI
            IF (IAXIS.NE.1) THEN
               DY = DEGC
               CALL FNDX (TRC(1), DY, DX, JERR)
               IF (JERR.NE.0) GO TO 80
               CALL XYPIX (DX, DY, X, Y, JERR)
               IF (X.LT.TRC(1)-0.1) GO TO 80
               X = MAX (X, TRC(1))
            ELSE
               DX = DEGC
               CALL FNDY (TRC(2), DX, DY, JERR)
               IF (JERR.NE.0) GO TO 80
               CALL XYPIX (DX, DY, X, Y, JERR)
               IF (Y.LT.TRC(2)-0.1) GO TO 80
               Y = MAX (Y, TRC(2))
               END IF
            IF (JERR.NE.0) GO TO 80
C                                       Convert degrees to pixels.
            IF ((X.LT.LBLC(1)-0.01) .OR. (X.GT.LTRC(1)+0.01)) GO TO 80
            IF ((Y.LT.LBLC(2)-0.01) .OR. (Y.GT.LTRC(2)+0.01)) GO TO 80
C                                       Find end of tic.
            DTX = DX - SIGN (1.0, AXINC(1,LOCNUM)) * TICX
            DTY = DY - SIGN (1.0, AXINC(2,LOCNUM)) * TICY
            CALL XYPIX (DTX, DTY, XT, YT, JERR)
            IF (JERR.NE.0) GO TO 80
            TICT = SQRT ((XT-X)**2 + (YT-Y)**2)
            IF ((TICT.GT.TICL) .OR. (TICT.LT.0.1*TICL)) THEN
               IF (TICT.EQ.0.0) GO TO 80
               DTX = DX - SIGN (1.0, AXINC(1,LOCNUM)) * TICX * TICL/TICT
               DTY = DY - SIGN (1.0, AXINC(2,LOCNUM)) * TICY * TICL/TICT
               CALL XYPIX (DTX, DTY, XT, YT, JERR)
               IF (JERR.NE.0) GO TO 80
               END IF
            IF ((XT.LT.LBLC(1)-0.01) .OR. (XT.GT.LTRC(1)+0.01)) GO TO 80
            IF ((YT.LT.LBLC(2)-0.01) .OR. (YT.GT.LTRC(2)+0.01)) GO TO 80
C                                       Simple ticks only
C                                       Position at end of tic.
            CALL GPOS (XT, YT, IBUFF, IERR)
            SUBR = 'GPOS'
            IF (IERR.NE.0) GO TO 980
C                                       Draw back to border.
            CALL GVEC (X, Y, IBUFF, IERR)
            SUBR = 'GVEC'
            IF (IERR.NE.0) GO TO 980
 80         DEGC = DEGC - DEG
 90         CONTINUE
         END IF
C                                       Full curves from top?
      IF ((DOACRS) .AND. (LAXIS.LE.2)) THEN
C                                       Simple coordinates
         PRX = -1.E10
         PRY = -1.E10
         IF (AXTYP(LOCNUM).NE.1) THEN
            DEGC = DEGC0 + 5 * DEG0
            LOLIM = DEGC1 - 5 * DEG0
 100        DEGC = DEGC - DEG0
            IF ((DEGC.GT.LOLIM) .AND. (DEG0.LT.0.0D0)) GO TO 999
            IF ((DEGC.LT.LOLIM) .AND. (DEG0.GT.0.0D0)) GO TO 999
C                                       Find start
C                                       vertical full plot
            IF (LAXIS.EQ.2) THEN
               DY = DEGC
               CALL FNDX (BLC(1), DY, DX, JERR)
               IF (JERR.NE.0) GO TO 100
C                                       horizontal full plot
            ELSE
               DX = DEGC
               CALL FNDY (BLC(2), DX, DY, JERR)
               IF (JERR.NE.0) GO TO 100
               END IF
C                                       Convert to pixels.
            CALL XYPIX (DX, DY, X, Y, JERR)
            IF (JERR.NE.0) GO TO 100
            BX(1) = X
            BY(1) = Y
C                                       Find end
C                                       vertical full plot
            IF (LAXIS.EQ.2) THEN
               DY = DEGC
               CALL FNDX (TRC(1), DY, DX, JERR)
               IF (JERR.NE.0) GO TO 100
C                                       horizontal full plot
            ELSE
               DX = DEGC
               CALL FNDY (TRC(2), DX, DY, JERR)
               IF (JERR.NE.0) GO TO 100
               END IF
C                                       Convert to pixels.
            CALL XYPIX (DX, DY, X, Y, JERR)
            IF (JERR.NE.0) GO TO 100
            BX(2) = X
            BY(2) = Y
            CALL PLOTWO (LBLC, LTRC, BX, BY, PRX, PRY, .FALSE., .FALSE.,
     *         IBUFF, JERR)
            GO TO 100
C                                       celestial coordinates
         ELSE
            DEG0 = ABS(DEG0)
C                                       Find range of parameters
            NPOLE = .FALSE.
            IF (CORTYP(LOCNUM).EQ.1) THEN
               DY = 90.0D0
               DX = 0.0D0
            ELSE
               DY = 0.0D0
               DX = 90.0D0
               END IF
            CALL XYPIX (DX, DY, X, Y, JERR)
            IF (JERR.EQ.0) THEN
               NPOLE = (X.GE.LBLC(1)) .AND. (X.LE.LTRC(1)) .AND.
     *            (Y.GE.LBLC(2)) .AND. (Y.LE.LTRC(2))
               END IF
            SPOLE = .FALSE.
            IF (CORTYP(LOCNUM).EQ.1) THEN
               DY = -90.0D0
               DX = 0.0D0
            ELSE
               DY = 0.0D0
               DX = -90.0D0
               END IF
            CALL XYPIX (DX, DY, X, Y, JERR)
            IF (JERR.EQ.0) THEN
               SPOLE = (X.GE.LBLC(1)) .AND. (X.LE.LTRC(1)) .AND.
     *            (Y.GE.LBLC(2)) .AND. (Y.LE.LTRC(2))
               END IF
            XUPLIM = -400.
            XLOLIM = 400.
            UPLIM = -400.
            LOLIM = 400.
            I1 = LBLC(1) + 0.01
            I2 = LTRC(1) + 0.01
            J1 = LBLC(2) + 0.01
            J2 = LTRC(2) + 0.01
            X = I2
            Y = J1
            CALL XYVAL (X, Y, DX, DY, DZ, JERR)
            IF (JERR.EQ.0) THEN
               XUPLIM = MAX (XUPLIM, DX)
               XLOLIM = MIN (XLOLIM, DX)
               UPLIM = MAX (UPLIM, DY)
               LOLIM = MIN (LOLIM, DY)
               END IF
            Y = J2
            CALL XYVAL (X, Y, DX, DY, DZ, JERR)
            IF (JERR.EQ.0) THEN
               XUPLIM = MAX (XUPLIM, DX)
               XLOLIM = MIN (XLOLIM, DX)
               UPLIM = MAX (UPLIM, DY)
               LOLIM = MIN (LOLIM, DY)
               END IF
            X = I1
            CALL XYVAL (X, Y, DX, DY, DZ, JERR)
            IF (JERR.EQ.0) THEN
               XUPLIM = MAX (XUPLIM, DX)
               XLOLIM = MIN (XLOLIM, DX)
               UPLIM = MAX (UPLIM, DY)
               LOLIM = MIN (LOLIM, DY)
               END IF
            DO 210 J = J1,J2,5
               DO 200 I = I1,I2,5
                  X = I
                  Y = J
                  CALL XYVAL (X, Y, DX, DY, DZ, JERR)
                  IF (JERR.EQ.0) THEN
                     XUPLIM = MAX (XUPLIM, DX)
                     XLOLIM = MIN (XLOLIM, DX)
                     UPLIM = MAX (UPLIM, DY)
                     LOLIM = MIN (LOLIM, DY)
                     END IF
 200              CONTINUE
 210           CONTINUE
            IF (NPOLE) THEN
               IF (CORTYP(LOCNUM).EQ.1) THEN
                  UPLIM = 90.0D0
               ELSE
                  XUPLIM = 90.0D0
                  END IF
               END IF
            IF (SPOLE) THEN
               IF (CORTYP(LOCNUM).EQ.1) THEN
                  LOLIM = -90.0D0
               ELSE
                  XLOLIM = -90.0D0
                  END IF
               END IF
C                                       nearly full circle -> full
            IF (CORTYP(LOCNUM).EQ.1) THEN
               IF (XUPLIM-XLOLIM.GT.358.) THEN
                  XUPLIM = XUPLIM + 1.0
                  XLOLIM = XLOLIM - 1.0
                  END IF
            ELSE
               IF (UPLIM-LOLIM.GT.358.) THEN
                  UPLIM = UPLIM + 1.0
                  LOLIM = LOLIM - 1.0
                  END IF
               END IF
            DXLIM = MAX (1.2, 0.05*(LTRC(1)-LBLC(1)))
            DYLIM = MAX (1.2, 0.05*(LTRC(2)-LBLC(2)))
C                                       plot X
            IF (IAXIS.EQ.1) THEN
               XDT = DEG0
               YDT = MIN (1.0, 0.01*(LTRC(2)-LBLC(2))) *
     *            ABS (AXINC(2,LOCNUM))
               I = (XUPLIM + DEG0) / DEG0
               XUPLIM = I * DEG0
               I = (XLOLIM - DEG0) / DEG0
               XLOLIM = I * DEG0
               IF (CORTYP(LOCNUM).EQ.2) THEN
                  IF (XUPLIM.GT.90.0D0) XUPLIM = XUPLIM - DEG0
                  IF (XUPLIM.GT.90.0D0) XUPLIM = XUPLIM - DEG0
                  IF (XLOLIM.LT.-90.0D0) XLOLIM = XLOLIM + DEG0
                  IF (XLOLIM.LT.-90.0D0) XLOLIM = XLOLIM + DEG0
                  END IF
               UPLIM = UPLIM + 5*YDT
               LOLIM = LOLIM - 5*YDT
C                                       plot loop main axis
               DX = XLOLIM - XDT
 220           UP = .TRUE.
               DX = DX + XDT
               IF (DX.LE.XUPLIM) THEN
                  DY = LOLIM - YDT
 230              DY = DY + YDT
                  IF (DY.LE.UPLIM) THEN
                     CALL XYPIX (DX, DY, X, Y, JERR)
                     IF (JERR.NE.0) THEN
                        UP = .TRUE.
                     ELSE IF ((X.GE.LBLC(1)) .AND. (X.LE.LTRC(1)) .AND.
     *                  (Y.GE.LBLC(2)) .AND. (Y.LE.LTRC(2))) THEN
                        IF ((ABS(X-PRX).GT.DXLIM) .OR.
     *                     (ABS(Y-PRY).GT.DYLIM)) UP = .TRUE.
                        IF (UP) THEN
                           CALL GPOS (X, Y, IBUFF, JERR)
                           UP = .FALSE.
                        ELSE
                           CALL GVEC (X, Y, IBUFF, JERR)
                           END IF
                        PRX = X
                        PRY = Y
                     ELSE
                        UP = .TRUE.
                        END IF
                     GO TO 230
                     END IF
                  GO TO 220
                  END IF
C                                       plot Y
            ELSE
               I = (UPLIM + DEG0) / DEG0
               UPLIM = I * DEG0
               I = (LOLIM - DEG0) / DEG0
               LOLIM = I * DEG0
               IF (CORTYP(LOCNUM).EQ.1) THEN
                  IF (UPLIM.GT.90.0D0) UPLIM = UPLIM - DEG0
                  IF (UPLIM.GT.90.0D0) UPLIM = UPLIM - DEG0
                  IF (LOLIM.LT.-90.0D0) LOLIM = LOLIM + DEG0
                  IF (LOLIM.LT.-90.0D0) LOLIM = LOLIM + DEG0
                  END IF
               XDT = MIN (1.0, 0.01*(LTRC(1)-LBLC(1))) *
     *            ABS (AXINC(1,LOCNUM))
               YDT = DEG0
               XUPLIM = XUPLIM + 5*XDT
               XLOLIM = XLOLIM - 5*XDT
C                                       plot loop main axis
               DY = LOLIM - YDT
 240           UP = .TRUE.
               DY = DY + YDT
               IF (DY.LE.UPLIM) THEN
                  DX = XLOLIM - XDT
 250              DX = DX + XDT
                  IF (DX.LE.XUPLIM) THEN
                     CALL XYPIX (DX, DY, X, Y, JERR)
                     IF (JERR.NE.0) THEN
                        UP = .TRUE.
                     ELSE IF ((X.GE.LBLC(1)) .AND. (X.LE.LTRC(1)) .AND.
     *                     (Y.GE.LBLC(2)) .AND. (Y.LE.LTRC(2))) THEN
                        IF ((ABS(X-PRX).GT.DXLIM) .OR.
     *                     (ABS(Y-PRY).GT.DYLIM)) UP = .TRUE.
                        IF (UP) THEN
                           CALL GPOS (X, Y, IBUFF, JERR)
                           UP = .FALSE.
                        ELSE
                           CALL GVEC (X, Y, IBUFF, JERR)
                           END IF
                        PRX = X
                        PRY = Y
                     ELSE
                        UP = .TRUE.
                        END IF
                     GO TO 250
                     END IF
                  GO TO 240
                  END IF
               END IF
            END IF
         END IF
      GO TO 999
C                                       Graph drawing error.
 980  WRITE (MSGTXT,1980) IERR, SUBR
      CALL MSGWRT (7)
      IERR = 2
      GO TO 999
C                                       Invalid axis type.
 990  WRITE (MSGTXT,1990)
      CALL MSGWRT (8)
      IERR = 1
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('CTICS: GRAPH LABEL WRITING ERROR',I5,' FROM ',A)
 1990 FORMAT ('CTICS: INVALID AXIS TYPE.')
      END

      SUBROUTINE REBLNK (STRING, INX)
C-----------------------------------------------------------------------
C! removes ALL blanks from formatted strings
C# Character Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   When formatting a string, it is usually necessary to specify large I
C   formats because (for example) channel numbers can be in the 1000's.
C   But they usually are not so all the blanks look dumb.  REBLNK
C   compresses the string dropping ALL blanks.
C   Input/output:
C      STRING   C*(*)   String to be modified.
C   Output:
C      INX      I       Last non-blank character in STRING
C-----------------------------------------------------------------------
      CHARACTER STRING*(*)
      INTEGER   INX
C
      INTEGER   OP, L, JTRIM, BP
C-----------------------------------------------------------------------
      OP = 0
      L = JTRIM (STRING)
      INX = 0
      IF (L.EQ.0) GO TO 999
      DO 10 BP = 1,L
         IF (STRING(BP:BP).NE.' ') THEN
            OP = OP + 1
            STRING(OP:OP) = STRING(BP:BP)
            INX = OP
            END IF
 10      CONTINUE
      IF (INX.LT.L) STRING(INX+1:) = ' '
C
 999  RETURN
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QFINGR (U, ROW, MO2, LROW, TYPE)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Finish gridding row of uv data.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Vectorizing compiler version (also OK for Scalar).
C   FINGRD Does various tasks associated with completion of gridding
C   a row.  If U is within 1/2 support of 0 the symmetric row is
C   conjugated, flipped and added.  Next two conjugate rows are
C   formed, vis1 + i*vis2 (for beams, vis2 is the sampling function=
C   the sum of the weights).  Finally rows are rotated so that
C   zero column (assumed LROW/2+1) goes to the first column.
C   If U=0 the space for the next row down is used.
C   Inputs:
C      U     I  U in cells (non-negative)
C      ROW   I  Base address of Grid row of interest
C      MO2   I  Half the number of rows kept in the AP.
C      LROW  I  Length of row (no. vis)
C      TYPE  I  1 for IPOL,IBEM maps
C               2 for Q,U maps
C               3 for V maps.
C               4 for two line maps.
C   Also expects necessary constants in following AP locations:
C           0 = COS(PHASE0)           to shift map center
C           1 = SIN(PHASE0)
C           2 = COS(DELPHR)           for rotating down rows
C           3 = SIN(DELPHR)
C           4 = COS(DELPHC)           for rotating down columns
C           5 = SIN(DELPHC)
C           6 = 1.0
C           7 = 0.0
C-----------------------------------------------------------------------
      INTEGER   U, ROW, MO2, LROW, TYPE, ROW2, CROW, CRWI,
     *   SYM, REND, LROW1, CROW2, LL, LROWT4, LROWT2,
     *   LOOP, JA, JB, JC, JD, NO2
      REAL   AR, AI, BR, BI
      DOUBLE PRECISION DAR, DAI, CPHS, SPHS
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      LROWT2 = LROW + LROW
      LROWT4 = LROWT2 + LROWT2
      LL = LROW
      CROW = ROW + LROWT2
      CROW2 = CROW + 2
      LROW1 = LROW - 1
C                                       For VPOL zero weights
      IF (TYPE.NE.3) GO TO 100
         CRWI = CROW + 1
         CALL QVMOV (CRWI, 2, CROW, 2, LROW)
C                                       Check if near origin.
 100  IF (U.GT.MO2) GO TO 300
C                                       Near origin, add symmetric
C                                       points.
         ROW2 = ROW + 2
         SYM = ROW - (LROWT4 * (U + U))
C                                       If U=0 move 0 row 1 slot lower
C                                       and work from there.
         IF (U.GT.0) GO TO 200
            SYM = ROW - LROWT4
            JA = ROW + 1
            JC = SYM + 1
CC@DIR IGNORE RECRDEPS(APCORE)
C           DO 140 LOOP = 1,LROWT4
C              APCORE(JC) = APCORE(JA)
C              JA = JA + 1
C              JC = JC + 1
C140           CONTINUE
            CALL SCOPY(LROWT4,APCORE(JA),1,APCORE(JC),1)
C           CALL QVMOV (ROW, 1, SYM, 1, LROWT4)
 200     REND = SYM + LROWT2 - 2
C                                       First visibility.
         JA = ROW2 + 1
         JC = REND + 1
C@DIR IGNORE RECRDEPS(APCORE)
         DO 150 LOOP = 1,LROW1
            APCORE(JA) = APCORE(JA) + APCORE(JC)
            APCORE(JA+1) = APCORE(JA+1) - APCORE(JC+1)
            JA = JA + 2
            JC = JC - 2
 150        CONTINUE
C                                       End cell
         APCORE(ROW+1) = APCORE(ROW+1) + APCORE(SYM+1)
         APCORE(ROW+2) = APCORE(ROW+2) - APCORE(SYM+2)
C         CALL QCVJAD (ROW2, 2, REND, -2, ROW2, 2, LROW1)
C         CALL QCVJAD (ROW, 2, SYM, 2, ROW, 2, 1)
C                                       Second visibility
         REND = REND + LROWT2
         SYM = SYM + LROWT2
         JA = CROW2 + 1
         JC = REND + 1
C@DIR IGNORE RECRDEPS(APCORE)
         DO 160 LOOP = 1,LROW1
            APCORE(JA) = APCORE(JA) + APCORE(JC)
            APCORE(JA+1) = APCORE(JA+1) - APCORE(JC+1)
            JA = JA + 2
            JC = JC - 2
 160        CONTINUE
C                                       End cell
         APCORE(CROW+1) = APCORE(CROW+1) + APCORE(SYM+1)
         APCORE(CROW+2) = APCORE(CROW+2) - APCORE(SYM+2)
C         CALL QCVJAD (CROW2, 2, REND, -2, CROW2, 2, LROW1)
C         CALL QCVJAD (CROW, 2, SYM, 2, CROW, 2, 1)
C                                       Form conjugate rows.
 300  CALL QGRDMI (ROW, CROW, LROW)
C                                       Rotate zero to first column.
      SYM = CROW + LL
      JA = CROW
      JB = ROW
      JC = SYM
      JD = ROW + LL
C@DIR IGNORE RECRDEPS(APCORE)
      DO 350 LOOP = 1,LROW
         AR = APCORE(JA+LOOP)
         BR = APCORE(JB+LOOP)
         APCORE(JA+LOOP) = APCORE(JC+LOOP)
         APCORE(JB+LOOP) = APCORE(JD+LOOP)
         APCORE(JC+LOOP) = AR
         APCORE(JD+LOOP) = BR
 350     CONTINUE
C      CALL QVSWAP (CROW, 1, SYM, 1, LROW)
      SYM = ROW + LL
C      CALL QVSWAP (ROW, 1, SYM, 1, LROW)
C                                       Rotate map center.
      CALL QPHSRO (ROW, 2, ROW, 2, 0, 2, LROW)
      APCORE(2) = -APCORE(2)
      APCORE(4) = -APCORE(4)
C      CALL QVNEG (1, 2, 1, 2, 2)
      CALL QPHSRO (CROW, 2, CROW, 2, 0, 2, LROW)
C                                       Reverse Conjugate row.
      CRWI = CROW + 3
C      CALL QVRVRS (CROW2, 2, LROW1)
C      CALL QVRVRS (CRWI, 2, LROW1)
      JC = CROW2 + 1
      JD = CRWI + 1
      JA = JC + (LROW1 - 1) * 2
      JB = JD + (LROW1 - 1) * 2
      NO2 = LROW1 / 2
C@DIR IGNORE RECRDEPS(APCORE)
      DO 360 LOOP = 1,NO2
         AR = APCORE(JC)
         BR = APCORE(JD)
         APCORE(JC) = APCORE(JA)
         APCORE(JD) = APCORE(JB)
         APCORE(JA) = AR
         APCORE(JB) = BR
         JA = JA - 2
         JB = JB - 2
         JC = JC + 2
 360     JD = JD + 2
C                                       Update for next row
      APCORE(2) = -APCORE(2)
      APCORE(4) = -APCORE(4)
C      CALL QVNEG (1, 2, 1, 2, 2)
      DAR = APCORE(1)
      DAI = APCORE(2)
      CPHS = APCORE(5)
      SPHS = APCORE(6)
      APCORE(1) = DAR * CPHS - DAI * SPHS
      APCORE(2) = DAI * CPHS + DAR * SPHS
C      CALL QPHSRO (0, 2, 0, 2, 4, 6, 1)
C
 999  RETURN
      END

      PROGRAM STRAN
C-----------------------------------------------------------------------
C! Compares two ST tables and calculate an image coordinate transform
C# EXT-util Map-util Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2009, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   STRAN reads in an ST table with the PIXELS of an image which contain
C   stars and a second ST table with COORDINATES.  The two tables
C   are compared, and a coordinate transformation is calculated.
C    INPUTS:   (from AIPS)
C              USERID   R      user 0 means use logon user number,
C                              32000 means any user can be accessed.
C              INNAME   R(3)   name of primary file.
C              INCLASS  R(2)   class of primary file.
C              INSEQ    R      sequence number of primary file.
C              INDISK   R      disk volume number. 0 means try all.
C              INVERS   R      ST table with pixel locations
C              IN2VERS  R      ST table with coordinates
C              BPARM    R(10)  Input Parameters
C              CPARM    R(10)  Input Parameters
C              DPARM    R(10)  Input Parameters
C-----------------------------------------------------------------------
C                                       Max Stars, Triangles and FITS
      INTEGER   MXSTAR, MXTRIA, MXFIT,MXFIT2
      PARAMETER (MXSTAR=2000, MXTRIA=4000, MXFIT=50, MXFIT2=100)
      DOUBLE PRECISION RADIAN, DEGRES
      PARAMETER (RADIAN=57.295779513,DEGRES=0.017453292519943295769)
      CHARACTER PRGNAM*6, HILINE*72, NAMIN*12, CLSIN*6, TYPIN*2,
     *   ATIME*8, ADATE*12, NAMES(MXSTAR)*20, SBUF*80
      HOLLERITH XNAMIN(3), XCLSIN(2), STLABL(6)
      REAL      DSKIN, SEQIN, DXPOS, DYPOS, POSANG, TRIA(3,MXTRIA),
     *   TRIB(3,MXTRIA), MINFIT, XINVER, MAXPIX, MINPIX, MINARC, MAXARC,
     *   MINDIF, MINRAT, RMSUM, RMSFIT(MXFIT2), BPARM(10), CPARM(10),
     *   DPARM(10), SA(2,MXSTAR), SB(2,MXSTAR), STRMIN(MXSTAR),
     *   ROKTRI(5,MXFIT2), RES(2,MXSTAR), MINRAD, XIN2VR, XY(2,MXSTAR),
     *   AD(2,MXSTAR), XY3(2,3), AD3(2,3), RMATCH, ESTXIN, ESTYIN,
     *   ESTINR, ESTORI, ESTORR, ESTRA, ESTRAR, ESTDEC, ESTDER, MINRA,
     *   MAXRA, MINDEC, MAXDEC
      DOUBLE PRECISION ANGLE, REFINC(2), REFVAL(2), REFPIX(2),
     *   MINANG, MAXANG, MINXIN, MAXXIN, MINYIN, MAXYIN, XPOS, YPOS
      INTEGER  IWBUFF(256), IMFIND, ITRIA(3,MXTRIA), ITRIB(3,MXTRIA),
     *   INVER, NSTA, NSTB, DEPTH(5), IFIT, ISAVE, IRMSTR(MXFIT2),
     *   IMLUN, IERR, IRETCD, ISEQ, INPRMS, ISLOT, IUSER, IVOL, ISTAR,
     *   IROUND, HLUN, IT(3), ID(3), IER, MINSTR, BSTFIT, NSTFIT,
     *   NOKFIT, IN2VER, NTRA, NTRB, IA, IB, NUMFIT, CATOLD(256), IDIST,
     *   JDIST, MAXDIS, MINDIS, MAXTRI, PLEV, ISTMIN(MXSTAR), DISINC
      LOGICAL   T, SAVE, QUICK, GOODFT, DOHEAD, DOPRT
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /INPARM/ XNAMIN, XCLSIN, SEQIN, DSKIN, XINVER, XIN2VR,
     *   BPARM, CPARM, DPARM
      COMMON /STRAND/ XPOS, YPOS, DXPOS, DYPOS, POSANG, STLABL
      DATA IMLUN, HLUN /16, 29/
      DATA PRGNAM /'STRAN '/
      DATA TYPIN /'  '/
      DATA T /.TRUE./, DOHEAD/.FALSE./
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      SAVE = .TRUE.
      GOODFT = .FALSE.
      CALL FILL( 5, 1, DEPTH)
C                                       Get input values from AIPS.
      INPRMS = 39
      IRETCD = 0
      CALL GTPARM (PRGNAM, INPRMS, QUICK, XNAMIN, IWBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRETCD = 8
         END IF
      IF (QUICK) CALL RELPOP (IRETCD, IWBUFF, IERR)
      IF (IRETCD.NE.0) GO TO 990
      IRETCD = 0
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
C
      ISEQ = IROUND (SEQIN)
      IVOL = IROUND (DSKIN)
      IUSER = NLUSER
      IN2VER = IROUND (XIN2VR)
      INVER  = MAX( 0, IROUND (XINVER))
C                                       If header should be updated
      DOHEAD = BPARM(1) .GT. 0.00001
C                                       User parameters
      MAXTRI = BPARM(2)
C                                       Print Level
      PLEV   = IROUND (BPARM(3))
C                                       set max triangles default
      IF (MAXTRI.LE.0) MAXTRI = MXTRIA
C                                       Tell user
      IF (DOHEAD) THEN
         MSGTXT = 'Image header WILL be updated'
      ELSE
         MSGTXT = 'Image header will NOT be updated'
         END IF
      CALL MSGWRT (3)
      WRITE (MSGTXT,1060) MAXTRI
      CALL MSGWRT (3)
C                                       Min and Max Trisides (pixels)
      MINPIX = ABS (CPARM(1))
      MAXPIX = ABS (CPARM(2))
      IF (MAXPIX.LE.MINPIX) MAXPIX = 1000.
C                                       Min and Max sides (arcseconds)
      MINARC = ABS (CPARM(3)) / 3600.
      MAXARC = ABS (CPARM(4)) / 3600.
      MINARC = MAX (MINARC, 1./3600.)
      IF (MAXARC.LE.MINARC) MAXARC = 10.
C                                       Minimum dif for match (Pix)
      MINRAD = ABS (CPARM(5))
C                                       Default match distance (pixels)
      IF (MINRAD.LE.0.0 .OR. MINRAD.GT.1.0E6) MINRAD = 4
C                                       Minimum Number of stars
      MINSTR = IROUND (CPARM(6))
      IF (MINSTR.LT.4) MINSTR = 7
C                                       Triangle Minimum difference
      MINDIF = ABS (CPARM(7))
      IF (MINDIF.LE.0.0) MINDIF = 0.025
C                                       Triangle Min side ratio
      MINRAT = CPARM(8)
      IF (MINRAT.LE.0.0) MINRAT = 0.8
C                                       Report inputs
      WRITE (MSGTXT,1070) MINPIX, MAXPIX, ' Pixels'
      CALL MSGWRT(3)
      WRITE (MSGTXT,1070) MINARC*3600., MAXARC*3600., ' Arc-sec'
      CALL MSGWRT(3)
      WRITE (MSGTXT,1080) INT(MINRAD)
      CALL MSGWRT(3)
      WRITE (MSGTXT,1090) MINDIF
      CALL MSGWRT(3)
      WRITE (MSGTXT,1100) MINRAT
      CALL MSGWRT(3)
C                                       Open map file & get header.
      CALL MAPOPN ('HDWR', IVOL, NAMIN, CLSIN, ISEQ, TYPIN, IUSER,
     *   IMLUN, IMFIND, ISLOT, CATBLK, IWBUFF, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Save the header if a failure
      CALL COPY(256, CATBLK, CATOLD)
C                                       If optical probably Tangent
      CALL CHR2H (4, '-ARC', 1, CATH(KHCTP+1))
      CALL CHR2H (4, '-ARC', 1, CATH(KHCTP+3))
C                                       Fill in defaults in PARMS
      DSKIN = IVOL
C                                       Set Match Range
      MAXDIS = MINRAD
      MINDIS = MAX ( 1, MAXDIS/2)
C                                       Try 2 different ranges
      DISINC = MAX ( MAXDIS-MINDIS, 1)
C                                       Estimated Pixel Increment +
C                                       error
      ESTXIN = DPARM(1)
      ESTINR = ABS( DPARM(2))
C                                       Default is header value
      IF (ABS(ESTXIN) .LT. 1.E-10) ESTXIN = CATR(KRCIC) * 3600.
C                                       Default accuracy is 20%
      IF (ABS(ESTINR) .LT. 1.E-10) ESTINR = ABS(ESTXIN)/5.
C                                       Min/Max inc degree/pixel
      MINXIN = (ESTXIN - ESTINR) / 3600.
      MAXXIN = (ESTXIN + ESTINR) / 3600.
C                                       Estimated Pixel Increment +
C                                       error
      ESTYIN = DPARM(3)
      ESTINR = ABS( DPARM(4))
C                                       Default is header value
      IF (ABS(ESTYIN) .LT. 1.E-10) ESTYIN = CATR(KRCIC+1)*3600.
C                                       Default accuracy is 20%
      IF (ABS(ESTINR) .LT. 1.E-10) ESTINR = ABS(ESTYIN)/5.
C                                       Min/Max inc degree/pixel
      MINYIN = (ESTYIN - ESTINR) / 3600.
      MAXYIN = (ESTYIN + ESTINR) / 3600.
C                                       Estimated Orientation
      ESTORI = DPARM(5)
      ESTORR = ABS( DPARM(6))
C                                       Default is 0. +/- 10
      IF (ESTORR.LE.0.0) ESTORR = 5
      MINANG = ESTORI - ESTORR
      MAXANG = ESTORI + ESTORR
C                                       Estimated RA
      ESTRA  = DPARM(7)
      ESTRAR = ABS( DPARM(8))
C                                       Default is header value
      IF (ESTRA  .LE. 0.0) ESTRA  = CATD(KDCRV)
      IF (ESTRAR .LE. 0.0) ESTRAR = 2.
C                                       Estimated Dec
      ESTDEC = DPARM(9)
      ESTDER = DPARM(10)
      IF (ESTDEC .EQ. 0.0) ESTDEC = CATD(KDCRV+1)
      IF (ESTDER .LE. 0.0) ESTDER = 2.
C                                       Convert to ranges
      MINRA  = ESTRA  - ESTRAR
      MAXRA  = ESTRA  + ESTRAR
      MINDEC = ESTDEC - ESTDER
      MAXDEC = ESTDEC + ESTDER
C                                       Tell User
      WRITE (MSGTXT,1110) MINXIN, MAXXIN, 'X-Increm'
      CALL MSGWRT(3)
      WRITE (MSGTXT,1110) MINYIN, MAXYIN, 'Y-Increm'
      CALL MSGWRT(3)
      WRITE (MSGTXT,1110) MINRA, MAXRA, 'RA'
      CALL MSGWRT(3)
      WRITE (MSGTXT,1110) MINDEC, MAXDEC, 'DEC'
      CALL MSGWRT(3)
      WRITE (MSGTXT,1110) MINANG, MAXANG, 'Rotation'
      CALL MSGWRT(3)
C                                       Read pixel list
      CALL STREAD (IVOL, ISLOT, INVER, MINPIX, 1.0, 1.0E5, 1.0, 1.0E5,
     *   NSTA, SA, IERR)
      IF (IERR.NE.0 .OR. NSTA.LE.2) THEN
         MSGTXT = 'ERROR READING ST TABLE WITH PIXEL INFORMATION'
         CALL MSGWRT(8)
         GO TO 980
         END IF
C                                       Read coordinate stars
      CALL STREAD (IVOL, ISLOT, IN2VER, MINARC, MINRA, MAXRA, MINDEC,
     *   MAXDEC, NSTB, SB, IERR)
      IF (IERR.NE.0 .OR. NSTB.LE.2) THEN
         MSGTXT = 'ERROR READING ST TABLE WITH COORDINATE INFO'
         CALL MSGWRT(8)
         GO TO 980
         END IF
C                                       If printing
      IF (PLEV.GT.2) THEN
C                                       Print pixel stars
         MSGTXT = 'Pixel location star list:'
         CALL MSGWRT(3)
C                                       for all pixel stars
         DO 50 IA = 1, NSTA
            WRITE (MSGTXT, 1040) IA, SA(1,IA), SA(2,IA)
            CALL MSGWRT(3)
 50         CONTINUE
         MSGTXT = 'Coordinate location star list:'
         CALL MSGWRT(3)
         DO 60 IB = 1, NSTB
            WRITE (MSGTXT, 1040) IB, SB(1,IB), SB(2,IB)
            CALL MSGWRT(3)
 60         CONTINUE
C                                       End if Printing
         END IF
C                                       Make a list of pixel triangles
      CALL TRILST( NSTA, MAXTRI, MINPIX, MAXPIX, MINRAT, SA, .FALSE.,
     *   NTRA, ITRIA, TRIA)
      WRITE (MSGTXT,1050) NTRA,'first '
      CALL MSGWRT(3)
C                                       Make a list of pixel triangles
      CALL TRILST( NSTB, MAXTRI, MINARC, MAXARC, MINRAT, SB, .TRUE.,
     *   NTRB, ITRIB, TRIB)
      WRITE (MSGTXT,1050) NTRB,'second'
      CALL MSGWRT(3)
C                                       Try to match Triangles
      REFPIX(1) = CATR(KRCRP)
      REFPIX(2) = CATR(KRCRP+1)
C                                       If Map header is non-zero`
      IF (CATD(KDCRV).NE.0.0) THEN
C                                       Use header as ref value
         REFVAL(1) = CATD(KDCRV)
         REFVAL(2) = CATD(KDCRV+1)
      ELSE
C                                       Use guess as field center
         REFVAL(1) = ESTRA
         REFVAL(2) = ESTDEC
         END IF
C                                       Init count of fits
      NOKFIT = 0
C                                       Init increment
      REFINC(1)  = CATR(KRCIC)
      REFINC(2)  = CATR(KRCIC+1)
C                                       If using header as a guess
      IF (BPARM(4).LT.1) THEN
C                                       Set default info
         NOKFIT = NOKFIT + 1
C                                       First try is image header
         ROKTRI(1,NOKFIT) = REFVAL(1)
         ROKTRI(2,NOKFIT) = REFVAL(2)
C                                       save original inc + value
         ROKTRI(3,NOKFIT) = CATR(KRCIC)
         ROKTRI(4,NOKFIT) = CATR(KRCIC+1)
         ROKTRI(5,NOKFIT) = CATR(KRCRT)
C
         MSGTXT = 'First trial fit uses image header'
         CALL MSGWRT(3)
         WRITE (MSGTXT,1190) NOKFIT, REFVAL(1), REFVAL(2)
         CALL MSGWRT(3)
         WRITE (MSGTXT,1195) NOKFIT,REFINC(1)*3600.,REFINC(2)*3600.,
     *      ANGLE
         CALL MSGWRT(3)
C                                       If estimate different
         IF (ROKTRI(1,1).NE.ESTRA .OR. ROKTRI(2,1).NE.ESTDEC .OR.
     *       ROKTRI(3,1).NE.ESTXIN/3600. .OR.
     *       ROKTRI(4,1).NE.ESTYIN/3600. .OR.
     *       ROKTRI(5,1).NE.ESTORI) THEN
            NOKFIT = NOKFIT + 1
C                                       First try is image header
            ROKTRI(1,NOKFIT) = ESTRA
            ROKTRI(2,NOKFIT) = ESTDEC
C                                       save original inc + value
            ROKTRI(3,NOKFIT) = ESTXIN /3600.
            ROKTRI(4,NOKFIT) = ESTYIN /3600.
            ROKTRI(5,NOKFIT) = ESTORI
            MSGTXT = 'Second Trial uses input estimate Parameters'
            CALL MSGWRT(3)
            WRITE (MSGTXT,1190) NOKFIT, ESTRA, ESTDEC
            CALL MSGWRT(3)
            WRITE (MSGTXT,1195) NOKFIT, ESTXIN, ESTYIN, ESTORI
            CALL MSGWRT(3)
C                                       End if estimate different
            END IF
C                                       End if not using header
         END IF
C                                       Init fit results, RMS, N stars
      CALL RFILL (MXFIT2, 1.0E20, RMSFIT)
      CALL FILL  (MXFIT2, 1,      IRMSTR)
C                                       Set Labels
      NAMES(1) = 'ONE'
      NAMES(2) = 'TWO'
      NAMES(3) = 'THR'
C                                       For all triangles in first list
      DO 200 IA = 1, NTRA
C                                       Transfer to work array
         XY3(1,1) = SA(1,ITRIA(1,IA))
         XY3(2,1) = SA(2,ITRIA(1,IA))
C                                       Pixels for star 2
         XY3(1,2) = SA(1,ITRIA(2,IA))
         XY3(2,2) = SA(2,ITRIA(2,IA))
C                                       Pixels for star 3
         XY3(1,3) = SA(1,ITRIA(3,IA))
         XY3(2,3) = SA(2,ITRIA(3,IA))
C                                       report progress
         IF ((IA/300)*300.EQ.IA) THEN
            WRITE (MSGTXT,1300) IA, NOKFIT
            CALL MSGWRT(3)
            END IF
C                                       For all triangles in second list
         DO 100 IB = 1, NTRB
C                                       IF printing
           IF (PLEV.GT.3 .AND. IA.EQ.IB) THEN
              WRITE (MSGTXT,1160) 'Pixel',IA, TRIA(1,IA),
     *               TRIA(2,IA), TRIA(3,IA)
              CALL MSGWRT(3)
              WRITE (MSGTXT,1160) 'Coord',IB, TRIB(1,IB),
     *            TRIB(2,IB), TRIB(3,IB)
              CALL MSGWRT(3)
              END IF
C                                       If triangles sides similar
           IF (ABS((TRIA(2,IA)/TRIB(2,IB))-1.) .LT. MINDIF) THEN
C                                       If other two sides similar
              IF (ABS((TRIA(3,IA)/TRIB(3,IB))-1.) .LT. MINDIF) THEN
C                                       We have a match! find transform
C                                       Transfer stars to work arrays
C                                       Coords for star 1
                 AD3(1,1) = SB(1,ITRIB(1,IB))
                 AD3(2,1) = SB(2,ITRIB(1,IB))
C                                       Coords for star 2
                 AD3(1,2) = SB(1,ITRIB(2,IB))
                 AD3(2,2) = SB(2,ITRIB(2,IB))
C                                       Coords for star 3
                 AD3(1,3) = SB(1,ITRIB(3,IB))
                 AD3(2,3) = SB(2,ITRIB(3,IB))
C                                       IF printing
                 IF (PLEV.GT.3) THEN
                    WRITE (MSGTXT,1168) IA, ITRIA(1,IA), ITRIA(2,IA),
     *                 ITRIA(3,IA)
                    CALL MSGWRT(3)
                    WRITE (MSGTXT,1168) IB, ITRIB(1,IB), ITRIB(2,IB),
     *                 ITRIB(3,IB)
                    CALL MSGWRT(3)
                    WRITE (MSGTXT,1170) XY3(1,1),XY3(2,1),
     *                  AD3(1,1), AD3(2,1)
                    CALL MSGWRT(3)
                    WRITE (MSGTXT,1170) XY3(1,2),XY3(2,2),
     *                  AD3(1,2), AD3(2,2)
                    CALL MSGWRT(3)
                    WRITE (MSGTXT,1170) XY3(1,3),XY3(2,3),
     *                  AD3(1,3), AD3(2,3)
                    CALL MSGWRT(3)
                    END IF
C                                       Refpix is center coord
                 CALL XTRFIT (3, 3, XY3, AD3, NAMES, .FALSE., REFPIX,
     *              REFVAL, REFINC, ANGLE, RES, IERR)
C                                       If angle is ok
                 IF ((ANGLE.GT.MINANG    .AND.ANGLE    .LT.MAXANG).OR.
     *               (ANGLE+180.GT.MINANG.AND.ANGLE+180.LT.MAXANG).OR.
     *               (ANGLE-180.GT.MINANG.AND.ANGLE-180.LT.MAXANG))
     *              THEN
C                                       If location is ok
                    IF (REFINC(1).GT.MINXIN .AND.
     *                  REFINC(1).LT.MAXXIN .AND.
     *                  REFINC(2).GT.MINYIN .AND.
     *                  REFINC(2).LT.MAXYIN .AND.
     *                  REFVAL(1).GT.MINRA  .AND.
     *                  REFVAL(1).LT.MAXRA  .AND.
     *                  REFVAL(2).GT.MINDEC .AND.
     *                  REFVAL(2).LT.MAXDEC) THEN
C                                       Looks like a good fit
                       NOKFIT = NOKFIT + 1
C                                       Save Transformation
                       ROKTRI(1,NOKFIT) = REFVAL(1)
                       ROKTRI(2,NOKFIT) = REFVAL(2)
                       ROKTRI(3,NOKFIT) = REFINC(1)
                       ROKTRI(4,NOKFIT) = REFINC(2)
                       ROKTRI(5,NOKFIT) = ANGLE
C                                       Tell user
                       IF (PLEV.GT.0) THEN
                          WRITE (MSGTXT,1180) IA, IB
                          CALL MSGWRT(3)
                          WRITE (MSGTXT,1190) NOKFIT,
     *                        REAL(REFVAL(1)), REAL(REFVAL(2))
                          CALL MSGWRT(3)
                          WRITE (MSGTXT,1195) NOKFIT,
     *                       REAL(REFINC(1)*3600.),
     *                       REAL(REFINC(2)*3600.), REAL(ANGLE)
                          CALL MSGWRT(3)
                          END IF
C                                       If enough good fits, exit
                       IF (NOKFIT.GE.MXFIT) GO TO 210
C                                       End if OK location
                       END IF
C                                       End if an OK angle
                    END IF
C                                       End if C sides similar
                 END IF
C                                       End if B sides similar
              END IF
C                                       End for all B triangles
 100       CONTINUE
C                                       End for all A triangles
 200     CONTINUE
C                                       Jump here on enough fits
 210  CONTINUE
C                                       Finished triangle search
      WRITE (MSGTXT,1200) NOKFIT
      CALL MSGWRT(3)
C                                       For all Distances to max
      DO 550 JDIST = MINDIS, MAXDIS, DISINC
C                                       Work from big to small distances
         IDIST = MAXDIS + MINDIS - JDIST
C                                       Tell User
         WRITE (MSGTXT,1400) IDIST
         CALL MSGWRT(3)
C                                       Test again fits found so far
         NUMFIT = NOKFIT
C                                       For all OK FITS
         DO 500 IFIT = 1, NUMFIT
C                                       Compare all fits
C                                       Set Match Distance
            RMATCH = MIN ( REAL(IDIST), MINRAD)
C                                       Put transformation in header
            REFVAL(1) = ROKTRI(1,IFIT)
            REFVAL(2) = ROKTRI(2,IFIT)
            REFINC(1) = ROKTRI(3,IFIT)
            REFINC(2) = ROKTRI(4,IFIT)
C                                       Set rotation angle
            ANGLE     = ROKTRI(5,IFIT)
            CALL STMAT (NSTA, SA, NSTB, SB, REFVAL, REFINC, REFPIX,
     *            ANGLE, STRMIN, ISTMIN)
C                                       Init count of stars in fit
            NSTFIT = 0
C                                       For All stars in coord list
            DO 400 IB = 1, NSTB
C                                       If star is close to Pixel
               IF (STRMIN(IB).LT.RMATCH) THEN
C                                       Found a star match
                  NSTFIT = NSTFIT + 1
                  IA = ISTMIN(IB)
C                                       Put pix, ra and Dec in list
                  XY(1,NSTFIT) = SA(1,IA)
                  XY(2,NSTFIT) = SA(2,IA)
                  AD(1,NSTFIT) = SB(1,IB)
                  AD(2,NSTFIT) = SB(2,IB)
                  WRITE(NAMES(NSTFIT),1350) IA
C                                       If enough stars, exit
                  IF (NSTFIT.GE.MXSTAR) GO TO 420
C                                       End if a match
                  END IF
C                                       End if a star matchs
 400           CONTINUE
C                                       Jump on enough matched stars
 420        CONTINUE
C                                       Need minimum number of stars
            IF (NSTFIT.GE.MINSTR) THEN
C                                       Watch out for repeated matchs
C                                       Reset estimates
               REFVAL(1) = ROKTRI(1,IFIT)
               REFVAL(2) = ROKTRI(2,IFIT)
C                                       Now do fit again.
               CALL XTRFIT (3, NSTFIT, XY, AD, NAMES, .FALSE.,
     *              REFPIX, REFVAL, REFINC, ANGLE, RES, IERR)
C                                       If location is still OK
               IF (REFINC(1).GT.MINXIN .AND.
     *             REFINC(1).LT.MAXXIN .AND.
     *             REFINC(2).GT.MINYIN .AND.
     *             REFINC(2).LT.MAXYIN .AND.
     *             REFVAL(1).GT.MINRA  .AND.
     *             REFVAL(1).LT.MAXRA  .AND.
     *             REFVAL(2).GT.MINDEC .AND.
     *             REFVAL(2).LT.MAXDEC) THEN
C                                       Now do fit again.
C                                       Assume few arc second RMS
                  RMSUM = 1.0E21
C                                       Best fit should have low RMS
                  IF (NSTFIT.GE.MINSTR) THEN
C                                       Else calc RMS
                     RMSUM = 0.
C                                       For all stars in fits
                     DO 430 ISTAR = 1, NSTFIT
C                                       Sum RMS for each STAR
                        RMSUM = RMSUM +
     *                     SQRT(RES(1,ISTAR)**2+RES(2,ISTAR)**2)
 430                    CONTINUE
C                                       Correct RMS for number of stars
                     RMSUM = RMSUM / (REAL(NSTFIT)-3.)
C                                       Save Transformation
                     GOODFT = .TRUE.
C                                       If enought stars to get rms
                     END IF
C                                       If fit is better
                  IF (RMSUM.LT.RMSFIT(IFIT)*0.999) THEN
C                                       Do not print again
                     DOPRT = .FALSE.
C                                       Do same fit again with printing
                     IF (PLEV.GT.0.OR.IDIST.LE.MINDIS) DOPRT=.TRUE.
C
                     CALL XTRFIT (3, NSTFIT, XY, AD, NAMES,
     *                      DOPRT, REFPIX, REFVAL, REFINC, ANGLE,
     *                      RES, IERR)
C                                       Save fit in old slot if last
                     IF (IDIST.EQ.MAXDIS .OR. NOKFIT.GE.MXFIT2) THEN
                        ISAVE = IFIT
                     ELSE
C                                       Else save fit in a new slot
                        NOKFIT = NOKFIT + 1
                        ISAVE = NOKFIT
                        END IF
                     ROKTRI(1,ISAVE) = REFVAL(1)
                     ROKTRI(2,ISAVE) = REFVAL(2)
                     ROKTRI(3,ISAVE) = REFINC(1)
                     ROKTRI(4,ISAVE) = REFINC(2)
                     ROKTRI(5,ISAVE) = ANGLE
C                                       Record RMS for fit
                     RMSFIT(ISAVE) = RMSUM
C                                       Keep track of total stars
                     IRMSTR(ISAVE) = NSTFIT
                     WRITE (MSGTXT,1500) 'Test', ISAVE, NSTFIT,
     *                     RMSUM*3600.
                     CALL MSGWRT(3)
C                                       End if Fit is better
                     END IF
C                                       End IF location still Good
                  END IF
C                                       End IF Enough Stars
               END IF
C                                       End Of for all fits loop
 500        CONTINUE
C                                       End of All distances loop
 550     CONTINUE
C                                       Init Best fit
      MINFIT = 1E20
      BSTFIT = 1
C                                       For ALL OK FITS
      DO 600 IFIT = 1, NOKFIT
C                                       IF A better fit
         IF (IRMSTR(IFIT).GE.MINSTR) THEN
            IF (MINFIT.GT.RMSFIT(IFIT)) THEN
C                                       Record RMS, FIT number
               MINFIT = RMSFIT(IFIT)
               BSTFIT = IFIT
               END IF
            END IF
C                                       End for all fits loop
 600     CONTINUE
C                                       If an OK fit
      IF (GOODFT .AND. IRMSTR(BSTFIT).GE.MINSTR) THEN
C                                       Tell User
         WRITE (MSGTXT,1500) 'Best',BSTFIT,IRMSTR(BSTFIT),
     *         RMSFIT(BSTFIT)*3600.
         CALL MSGWRT(3)
         WRITE (MSGTXT,1190) BSTFIT, ROKTRI(1,BSTFIT),
     *         ROKTRI(2,BSTFIT)
         CALL MSGWRT(3)
         WRITE (MSGTXT,1195) BSTFIT, ROKTRI(3,BSTFIT)*3600.,
     *         ROKTRI(4,BSTFIT)*3600., ROKTRI(5,BSTFIT)
         CALL MSGWRT(3)
C                                       Put results in header
         CATD(KDCRV)   = ROKTRI(1,BSTFIT)
         CATD(KDCRV+1) = ROKTRI(2,BSTFIT)
         CATR(KRCIC)   = ROKTRI(3,BSTFIT)
         CATR(KRCIC+1) = ROKTRI(4,BSTFIT)
C                                       Set rotation angle
         CATR(KRCRT)   = ROKTRI(5,BSTFIT)
         CATR(KRCRT+1) = ROKTRI(5,BSTFIT)
      ELSE
C                                       Tell user, no fit
         MSGTXT = 'No combination of stars gave a good FIT!'
         CALL MSGWRT(5)
         MSGTXT = 'Check that coordinate stars overlap with'
         CALL MSGWRT(5)
         MSGTXT = 'the pixel stars.  Also relax fit critera'
         CALL MSGWRT(5)
         END IF
C                                       If no good fit
      IF (.NOT. GOODFT .OR. .NOT. DOHEAD ) THEN
C                                       restore header
         CALL COPY ( 256, CATOLD, CATBLK)
         END IF
C                                       Add to history file
      CALL HIINIT (3)
      CALL HIOPEN (HLUN, IVOL, ISLOT, IWBUFF, IER)
      IF (IER.NE.0) GO TO 980
C     Prepare text and add to file
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, ATIME, ADATE)
      WRITE (SBUF,1211,ERR=215) TSKNAM, IN2VER, NSTA, ADATE, ATIME
 215  HILINE = SBUF
      CALL HIADD (HLUN, HILINE, IWBUFF, IER)
      CALL HICLOS (HLUN, T, IWBUFF, IER)
      GO TO 980
C                                       Close map file.
 980  CALL MAPCLS ('WRIT', IVOL, ISLOT, IMLUN, IMFIND, CATBLK, SAVE,
     *   IWBUFF, IERR)
C
 990  CALL DIETSK (IRETCD, QUICK, IWBUFF)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR GETTING PARAMETERS FROM AIPS. GTPARM ERR =',I5)
 1040 FORMAT ('Star',I5,' at ',F12.4,',',F12.4)
 1050 FORMAT ('Found',I5,' Triangles in ',A,' ST table ')
 1060 FORMAT ('Maximum number of triangles is',I6,' for the star lists')
 1080 FORMAT ('Match Stars within radius  of ',I6,' Pixels')
 1090 FORMAT ('Match Triangles with ratio differences     < ',F12.3)
 1070 FORMAT ('Triangle sides > ',F12.5,' and <',F13.5,A)
 1100 FORMAT ('Use only Triangles short/long length ratio > ',F12.3)
 1110 FORMAT ('Assuming Image > ',F12.5,' and <',F13.5,' Deg. ',A)
 1160 FORMAT (A,' Tri.',I5,' 1,2,3=',F10.4,',',F7.4,',',F7.4)
 1168 FORMAT ('Triangle ',I6,' is star numbers ',3I6)
 1170 FORMAT ('Match ',F10.4,',',F10.4,' with ',F10.4,',',F10.4)
 1180 FORMAT ('Triangles',I5,' and',I5,' Match.')
 1190 FORMAT ('Trial',I4,' RA, DEC:',1PE11.3,' ',E11.3,' degrees')
 1195 FORMAT ('Trial',I4,' Increm.:',1PE11.3,'"',E11.3,'"; Angle=',
     *         E8.1,' deg.')
 1200 FORMAT ('Finished Triangle Comparision:',I5,' Triangles Match')
 1211 FORMAT (A6,' Version=',I3,' Lines=',I5,
     *   '  / Image header updated ',A,A)
 1300 FORMAT ('Currently Comparing Triangle',I8,' (',I4,' Matches)')
 1350 FORMAT (I4)
 1400 FORMAT ('Testing Match Distance',I6,' Pixels ')
 1500 FORMAT (A,' Fit',I4,' has',I5,' Stars, RMS ',1PE9.2,'"')
      END
      SUBROUTINE TRILST( NSTARS, MXTRIA, MINSID, MAXSID, MINRAT, S,
     *   RADEC, NTRIAG, ITRI, TRI)
C-----------------------------------------------------------------------
C TRILST reads a list of stars and produces a list of triangles
C INPUT:
C    NSTARS    I   Number of stars in input list
C    MXTRIA    I   Maximum number of triangles to make
C    MINSID    R   Minimum Triangle side limit
C    MAXSID    R   Maximum Triangle side limit
C    MINRAT    R   Minimum Triangle side ratio (Reject narrow triangles)
C    S         R(2,NSTARS)  Star coordinates (pixels or degrees)
C    RADEC     L   If true, stars are RA and DEC coordinates (degrees)
C OUTPUT:
C    NTRIAG    I  Number of valid triangles found
C    ITRI      I(3, NTRIAG)  Index back into Star list
C    TRI       R(3, NTRIAG)  Lenghts of sides of triangles
C-----------------------------------------------------------------------
      INTEGER NSTARS, MXTRIA, NTRIAG, ITRI(3,*)
      LOGICAL RADEC
      REAL    MINSID, MAXSID, MINRAT, S(2,*), TRI(3,*)
C-----------------------------------------------------------------------
      INTEGER ISTAR, JSTAR, KSTAR, IORDER(3)
      REAL    SIDES(3), MXSID, MNSID, RANGE, AVE
      DOUBLE PRECISION  X0, Y0, X1, Y1, X2, Y2, DIST, SA
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Need three stars
      IF (NSTARS.LT.3 .OR. MXTRIA.LT.1) GO TO 999
C                                       Init upper/lower limit
      MXSID = MAXSID
      MNSID = MINSID
C                                       Tell User
      WRITE (MSGTXT,1000) NSTARS, MXTRIA
      CALL MSGWRT(3)
C                                       Loop here until not too many
C                                       triangles
 10   NTRIAG = 0
C                                       For all but two stars
      DO 300 ISTAR = 1, NSTARS-2
C                                       First star is the origine
C                                       If input is RA, DEC,
         X0 = S(1,ISTAR)
         Y0 = S(2,ISTAR)
C                                       for second of three stars
         DO 200 JSTAR = ISTAR+1, NSTARS-1
C                                       If input is RA, DEC,
            X1 = S(1,JSTAR)
            Y1 = S(2,JSTAR)
            IF (RADEC) THEN
               CALL ANGDIS( X0, Y0, X1, Y1, SA)
            ELSE
C                                       Else input is pixels
               SA = SQRT((X1-X0)**2  + (Y1-Y0)**2)
               END IF
C                                       If this pair is too extream
C                                       Go Get next pair
            IF (SA.LT.MNSID .OR. SA.GT.MXSID) GO TO 300
C                                       for third star
            DO 100 KSTAR = JSTAR+1, NSTARS
C                                       get third coordinates
               X2 = S(1,KSTAR)
               Y2 = S(2,KSTAR)
C                                       First side was set above
               SIDES(1) = SA
C                                       If input is RA, DEC,
               IF (RADEC) THEN
C                                       Calc other two sides
                  CALL ANGDIS( X0, Y0, X2, Y2, DIST)
                  SIDES(2) = DIST
                  CALL ANGDIS( X1, Y1, X2, Y2, DIST)
                  SIDES(3) = DIST
               ELSE
C                                       Else input is pixels
                  SIDES(2) = SQRT((X2-X0)**2  + (Y2-Y0)**2)
                  SIDES(3) = SQRT((X2-X1)**2  + (Y2-Y1)**2)
                  END IF
C                                       set side order
               IORDER(1) = ISTAR
               IORDER(2) = JSTAR
               IORDER(3) = KSTAR
C                                       sort side lengths
               IF (SIDES(1).LT.SIDES(3)) THEN
                  CALL RSWAP ( SIDES(1), SIDES(3))
                  CALL ISWAP ( IORDER(1), IORDER(3))
                  END IF
               IF (SIDES(2).LT.SIDES(3)) THEN
                  CALL RSWAP ( SIDES(2), SIDES(3))
                  CALL ISWAP ( IORDER(2), IORDER(3))
                  END IF
               IF (SIDES(1).LT.SIDES(2)) THEN
                  CALL RSWAP ( SIDES(1), SIDES(2))
                  CALL ISWAP ( IORDER(1), IORDER(2))
                  END IF
C                                       If an Not OK triangle
               IF (SIDES(1).GT.MXSID .OR. SIDES(3).LT.MNSID)
     *            GO TO 100

C                                       Now Triangle sorted A>B>C
C                                       Remove scale
               SIDES(3) = SIDES(3) / SIDES(1)
C                                       if two narrow a triangle
               IF (SIDES(3).LT.MINRAT) GO TO 100
C                                       Else an OK triangle
               SIDES(2) = SIDES(2) / SIDES(1)
               NTRIAG = NTRIAG + 1
C                                       Transfer to triangle list
               IF (NTRIAG.LT.MXTRIA) THEN
                  ITRI( 1, NTRIAG) = IORDER(1)
                  ITRI( 2, NTRIAG) = IORDER(2)
                  ITRI( 3, NTRIAG) = IORDER(3)
                  TRI ( 1, NTRIAG) = SIDES(1)
                  TRI ( 2, NTRIAG) = SIDES(2)
                  TRI ( 3, NTRIAG) = SIDES(3)
               ELSE
C                                       Else too many triangles
C                                       Limit max/min to find fewer
                  AVE   = (MXSID + MNSID)/2.
C                                       New range is half old
                  RANGE = (MXSID - MNSID)/4.
                  MNSID = AVE - RANGE
                  MXSID = AVE + RANGE
C                                       Exit when Min = Max
                  IF (MNSID.GE.MXSID*.99) THEN
                     GO TO 900
                  ELSE
C                                       Else reset count, start over
                     NTRIAG = 0
                     GO TO 10
                     END IF
                  END IF
C                                       End of all stars loops
 100           CONTINUE
 200        CONTINUE
 300     CONTINUE
 900  WRITE (MSGTXT,1100) MNSID, MXSID
      CALL MSGWRT(3)
C                                       Jump here on no more tris
 999  RETURN
C-----------------------------------------------------------------------
1000  FORMAT ('TRILST: Using',I7,' Stars to make upto',I6,' Triangles')
1100  FORMAT ('TRILST: Triangle side length between',F12.3,' and',
     *   F12.3)
      END
      SUBROUTINE ISWAP ( I, J )
C-----------------------------------------------------------------------
C ISWAP swaps the values of two integers
C-----------------------------------------------------------------------
      INTEGER I, J
C
      INTEGER T
C-----------------------------------------------------------------------
      T = I
      I = J
      J = T
C
 999  RETURN
      END
      SUBROUTINE STREAD (IVOL, CNO, VERS, MINDIS, MINX, MAXX, MINY,
     *   MAXY, NST, S, IERR)
C-----------------------------------------------------------------------
C   STREAD Reads a ST table and returns a list of ST coordinates.
C   Table version VERS is examined.  The ST file contains the center
C   position (RA-DEC, GLON-GLAT, ELON-ELAT) of each star and the
C   "uncertainties" in those star positions.  The plotted plus signs
C   are scaled by these uncertainties and then further scaled by
C   multiplying by FACTOR.
C   Inputs:
C      VERS    I         Desired ST file version number: 0 => high
C      IVOL    I         File disk number
C      CNO     I         File catalog number
C      MINDIS  R         Minimum distance between pairs of stars
C      MINX    R         Minimum X coordinate
C      MAXX    R         Maximum X coordinate
C      MINY    R         Minimum Y coordinate
C      MAXY    R         Maximum Y coordinate
C   Output:
C      NST     I         Actual number of stars read
C      S       R(2,NST)  X, Y position of the star
C      IERR    I         Error code: 0 => okay
C                                -1 => there was no ST file
C                                +1 => logical error in ST file
C                                +2 => IO error in ST file
C   Common:
C      /MAPHDR/ CATBLK input   Image header having the ST file
C-----------------------------------------------------------------------
      INTEGER   VERS, IVOL, CNO, NST, IERR
      REAL      MINX, MAXX, MINY, MAXY, MINDIS, S(2,*)
C                                       Max Numb Columns, Label length
      INTEGER MXSTCL, MXSTLB
      REAL TWOPI
      PARAMETER (MXSTCL=7, MXSTLB=24, TWOPI=6.283185)
      CHARACTER KEYS(MXSTCL)*8
      INTEGER   IOBUF(512), IV, I, NKEY, NCOL, NREC, DATP(128,2), LRNO,
     *   TABLUN, KOLS(MXSTCL), IER, ITYPE, SCRTCH(50), IST, NSTOUT
      REAL DX, DY, DIST
      DOUBLE PRECISION XPOS, YPOS
      LOGICAL   LORDER
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA TABLUN /27/
      DATA LORDER /.TRUE./
C-----------------------------------------------------------------------
C                                       Is there an ST file
      IERR = -1
      CALL FNDEXT ('ST', CATBLK, I)
C                                       If ST table not found
      IF (I.LE.0.OR.I.LT.VERS) GO TO 999
      IV = VERS
C                                       Open ST table file
      NKEY = 0
      NCOL = 0
      NREC = 0
      CALL TABINI ('READ', 'ST', IVOL, CNO, IV, CATBLK, TABLUN, NKEY,
     *   NREC, NCOL, DATP, IOBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, IV
         GO TO 990
         END IF
      NST = IOBUF(5)
C                                       Find needed columns
      CALL H2CHR (8, 1, CATH(KHCTP), KEYS(1))
      CALL H2CHR (8, 1, CATH(KHCTP+2), KEYS(2))
      KEYS(3) = 'DELT' // KEYS(1)(1:4)
      KEYS(4) = 'DELT' // KEYS(2)(1:4)
      KEYS(5) = 'POSANG'
      KEYS(6) = 'STARTYPE'
      KEYS(7) = 'LABEL'
      CALL FNDCOL (NCOL, KEYS, 8, LORDER, IOBUF, KOLS, IER)
      IF (IER.GT.0) THEN
         MSGTXT = 'STREAD: Assuming coordinates are First two '//
     *      'Columns of table'
         CALL MSGWRT(3)
         KOLS(1) = 1
         KOLS(2) = 2
         END IF

      WRITE (MSGTXT,1040) MINX, MAXX,' X coord'
      CALL MSGWRT(3)
      WRITE (MSGTXT,1040) MINY, MAXY,' Y coord'
      CALL MSGWRT(3)
C                                       Count
      NSTOUT = 0
C                                       I guess we can do it now
      LRNO = 0
      DO 100 IST = 1,NST
         CALL GETCOL (IST, KOLS(1), DATP, LRNO, IOBUF, ITYPE, XPOS,
     *      SCRTCH, IER)
         IF (IER.LT.0) GO TO 100
         IF (IER.NE.0) GO TO 975
         CALL GETCOL (IST, KOLS(2), DATP, LRNO, IOBUF, ITYPE, YPOS,
     *      SCRTCH, IER)
         IF (IER.NE.0) GO TO 975
C                                       Tell about first star
         IF (IST.EQ.1 .OR. IST.EQ.NST) THEN
            WRITE (MSGTXT, 1050) IST, XPOS, YPOS
            CALL MSGWRT(3)
            END IF
C                                       If outside range, get next
         IF (XPOS.LT.MINX .OR. XPOS.GT.MAXX .OR.
     *       YPOS.LT.MINY .OR. YPOS.GT.MAXY) GO TO 100
C                                       Get no more than needed stars
C                                       If not first star
         IF (NSTOUT.GT.0) THEN
C                                       Compare position with previous
            DX = S(1,NSTOUT) - XPOS
            DY = S(2,NSTOUT) - YPOS
            DIST = SQRT( DX**2 + DY**2)
C                                       If separation great enough
            IF (DIST.GT.MINDIS) THEN
C                                       Increase star count
               NSTOUT = NSTOUT + 1
C                                   Copy position to an array
               S(1,NSTOUT) = XPOS
               S(2,NSTOUT) = YPOS
               END IF
         ELSE
C                                   Else first star, save it
            NSTOUT = 1
            S(1,NSTOUT) = XPOS
            S(2,NSTOUT) = YPOS
            END IF
C                                   End for all stars loop
 100     CONTINUE
      IERR = 0
      NST = NSTOUT
      WRITE (MSGTXT,1100) NST, IV
      CALL MSGWRT (2)
      GO TO 985
C                                       Error print and close
 975  WRITE (MSGTXT,1975) IER
      IERR = 2
      CALL MSGWRT (8)
 985  CALL TABIO ('CLOS', 0, IST, SCRTCH, IOBUF, IER)
      GO TO 999
C                                       Error print
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('STREAD: ERROR',I5,' OPENING ST FILE VERSION',I4)
 1040 FORMAT ('STREAD: Selecting Stars >',F12.3,' and < ',F12.3,A)
 1050 FORMAT ('STREAD: Star',I8,' at position ',F13.4,',',F13.4)
 1100 FORMAT ('STREAD: Read',I8,' Positions from ST table version',I4)
 1975 FORMAT ('STREAD: I/O ERROR',I5,' IN STAR TABLE FILE')
      END
      SUBROUTINE ANGDIS (X0, Y0, X1, Y1, DIST)
C-----------------------------------------------------------------------
C Calculate the Angular Distance between two RA-Dec (GLAT-GLON) points
C INPUT:
C   X0,Y0  D   Coordinate of first  point (degrees)
C   X1,Y1  D   Coordinate of second point (degrees)
C Output:
C   DIST   D   Angular Distance between the two points (degrees)
C-----------------------------------------------------------------------
      DOUBLE PRECISION X0, Y0, X1, Y1, DIST
C-----------------------------------------------------------------------
      DOUBLE PRECISION DEGRES, COSDIS
      PARAMETER (DEGRES=0.017453292519943295769)
C-----------------------------------------------------------------------
C                                       Calc RA difference
      DIST   = (X0 - X1) * DEGRES
C
      COSDIS = ((SIN(Y0*DEGRES)*SIN(Y1*DEGRES)) +
     *          (COS(Y0*DEGRES)*COS(Y1*DEGRES)*COS(DIST)))
C                                       Distance is arc cos
      DIST   = ACOS( COSDIS) / DEGRES
C-----------------------------------------------------------------------
      RETURN
      END
      SUBROUTINE GETLOC( RA, DEC, REFVAL, REFINC, REFPIX, COSSIN, X, Y)
C-----------------------------------------------------------------------
C GETLOC get the pixel location for an input coordinate
C INPUT:
C   RA, DEC   R     RA and Dec of the star
C   REFVAL    D(2)  Reference Value of Image Header
C   REFINC    D(2)  Reference increment of image pixel
C   REFPIX    D(2)  Reference pixel of image
C   COSSIN    D(2)  Cos and Sin of image orientation
C OUTPUT:
C   X, Y      R     X and Y pixel location of star
C-----------------------------------------------------------------------
      REAL RA, DEC, X, Y
      DOUBLE PRECISION REFVAL(2), REFINC(2), REFPIX(2), COSSIN(2)
C-----------------------------------------------------------------------
      DOUBLE PRECISION DRA, DDEC, DEGRES
      PARAMETER (DEGRES=0.017453292519943295769)
C-----------------------------------------------------------------------
C (X1 - X0) = (RA- RA0) * COS(A) * INCRA -  (DEC - DEC0) * SIN(A)*INCDEC
C (Y1 - Y0) = (RA- RA0) * SIN(A) * INCRA +  (DEC - DEC0) * SIN(A)*INCDEC
      DRA    = (RA  - REFVAL(1))*COS(REFVAL(2)*DEGRES)/REFINC(1)
      DDEC   = (DEC - REFVAL(2))/REFINC(2)
C
      X      = ( DRA*COSSIN(1)) - (DDEC*COSSIN(2))
      Y      = ( DRA*COSSIN(2)) + (DDEC*COSSIN(1))
      X      = X + REFPIX(1)
      Y      = Y + REFPIX(2)
      RETURN
C-----------------------------------------------------------------------
      END
      SUBROUTINE STMAT (NSTA, SA, NSTB, SB, REFVAL, REFINC, REFPIX,
     *   ANGLE, STRMIN, ISTMIN)
C-----------------------------------------------------------------------
C STMAT get the pixel location for an input coordinate
C INPUT:
C   NSTA      I     Number of pixel stars
C   SA        R(2,NSTA) Pixel locations of  stars
C   NSTB      I     Number of coordinate stars
C   SB        R(2,NSTB) Coordiantes of Stars
C   REFVAL    D(2)  Reference Value of Image Header
C   REFINC    D(2)  Reference increment of image pixel
C   REFPIX    D(2)  Reference pixel of image
C   ANGLE     D(2)  orinentation angle image
C OUTPUT:
C   STRMIN    R(NSTB) Closest pixel star to coordinate star
C   ISTMIN    I(NSTB) Index to pixel star near coordiante star
C-----------------------------------------------------------------------
      INTEGER NSTA, NSTB, ISTMIN(*)
      REAL SA(2,*), SB(2,*), STRMIN(*)
      DOUBLE PRECISION REFVAL(2), REFINC(2), REFPIX(2), ANGLE
C-----------------------------------------------------------------------
      DOUBLE PRECISION DEGRES
      PARAMETER (DEGRES=0.017453292519943295769)
      INTEGER IA, IB, IC
      REAL    XPIX, YPIX, XDEL, YDEL, RDEL
      DOUBLE PRECISION COSSIN(2)
C-----------------------------------------------------------------------
C                                       Set orientation factors
      COSSIN(1) = COS(ANGLE*DEGRES)
      COSSIN(2) = SIN(ANGLE*DEGRES)
C                                       For All stars in coord list
      DO 200 IB = 1, NSTB
C                                       Calc pixel of Coords
         CALL GETLOC( SB(1,IB), SB(2,IB), REFVAL, REFINC,
     *      REFPIX, COSSIN, XPIX, YPIX)
C                                       Init Minimum distances
         STRMIN(IB) = 1.0E20
         ISTMIN(IB) = 0
C                                       Compare with pixel list
         DO 100 IA = 1, NSTA
C                                       Calc Pixel Difference
            XDEL = SA(1,IA) - XPIX
            YDEL = SA(2,IA) - YPIX
            RDEL = SQRT((XDEL*XDEL) + (YDEL*YDEL))
C                                       Is this the closest star?
            IF (RDEL.LT.STRMIN(IB)) THEN
C                                       Yes, Save distance, star
               STRMIN(IB) = RDEL
               ISTMIN(IB) = IA
               END IF
C                                       End For all stars with Coords
 100        CONTINUE
C                                       End For all Pixel Stars Loop
 200     CONTINUE
C                                       Now remove duplications
C                                       For All stars in coord list
      DO 400 IB = 1, NSTB-1
C                                       FOr all other stars c list
         DO 300 IC = IB+1, NSTB
C                                       IF the same star
            IF (ISTMIN(IB).EQ.ISTMIN(IC)) THEN
C                                       if first is closer
               IF (STRMIN(IB).LT.STRMIN(IC)) THEN
C                                       ignore second
                  STRMIN(IC) = 1.E20
               ELSE
C                                       else ignore first star
                  STRMIN(IB) = 1.E20
                  GO TO 400
                  END IF
C                                       End if Same star
               END IF
 300        CONTINUE
 400     CONTINUE
      RETURN
C-----------------------------------------------------------------------
      END

LOCAL INCLUDE 'DFCOR.INC'
C                                                          Include DFCOR
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCLTAB.INC'
C                                       Inputs and general info
      INTEGER NDAT
      PARAMETER (NDAT= 100000)
      INTEGER NLINES, IAN(NDAT)
      DOUBLE PRECISION  TMES(NDAT)
      REAL VERDEL(NDAT)
C                                       arrays of values for the given
C                                       calibrators
      INTEGER MDAT
      PARAMETER (MDAT= 100000)
      REAL APDLY(MDAT), ADPDLY(MDAT), ATIME(MDAT)
      INTEGER AANT(MDAT)
C
      INTEGER   SEQIN, SUBA, DISKIN, CNOIN, NUMHIS, CLVER, CLUSE,
     *   NSOUWD, SOUWAN(30),
     *   NSOCWD, SOCWAN(30),
     *   NANTSL, ANTENS(50), BIF, EIF, ISTOK,
     *   FREQID, NTERM, NCALLI, NCALID
      LOGICAL   DOSWNT, DOAWNT, DESEL, DOCWNT
      REAL      XSIN, XDISIN, XFQID, XBAND, XFREQ, XBIF, XEIF, XTIME(8),
     *   XANT(50), XSUBA, XGVER, XGUSE, BPARM(20), XBAD(10), SELBAN,
     *   AXOFF
      CHARACTER  HISCRD(30)*64, NAMEIN*12, CLAIN*6, XSOUR(30)*16,
     *   XCALS(30)*16, XSTOK*4, OPCODE*4, INFILE*48
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XXCALS(4,30),
     *   XXSTOK, XOPCOD, XINFIL(12)
      DOUBLE PRECISION FRQOFF(MAXIF), SELFRQ, JD0
C                                       Buffers and file info
      INTEGER   BUFFER(1024)
C                                       Important constants
      DOUBLE PRECISION PI, TWOPI, CLIGHT
      PARAMETER (PI=3.1415926536D0, TWOPI=6.2831853072D0,
     *   CLIGHT=2.997925D8)
C                                       Internal storage
      INTEGER   CLRECI(13+32*MAXIF), CLKOLS(MAXCLC), CLNUMV(MAXCLC),
     *   NUMANT, NUMPOL, NUMIF, ICODE, FIXCNT, TIMCL,  INTCL, SOUCL,
     *   ANTCL, SUBCL, FRQCL, IFRCL, GDLCL, DOPCL, ATMCL, DATMCL,
     *   MBD1CL, CLK1CL, DCK1CL, DIS1CL, DDS1CL, RE1CL, IM1CL, DE1CL,
     *   RA1CL, WE1CL, RF1CL, MBD2CL, CLK2CL, DCK2CL, DIS2CL, DDS2CL,
     *   RE2CL, IM2CL, DE2CL, RA2CL, WE2CL, RF2CL
      REAL      GMMOD, CLRECR(13+32*MAXIF), PARM(40), PANGLE(MAXANT)
      DOUBLE PRECISION COSDEC, SINDEC, CLRECD(13+32*MAXIF)
C                                       Inputs and general info
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XXSOUR, XXCALS,
     *   XXSTOK, XBAND, XFREQ, XFQID, XBIF, XEIF, XTIME, XANT, XSUBA,
     *   XGVER, XGUSE, XOPCOD, BPARM, XBAD, XINFIL, SELBAN, SEQIN,
     *   DISKIN, CNOIN, SUBA, CLVER, CLUSE
      COMMON /CINFO/ FRQOFF, SELFRQ, JD0, DOSWNT,
     *   DOCWNT,
     *   DOAWNT, DESEL, NSOUWD, SOUWAN,
     *   NSOCWD, SOCWAN,
     *   NANTSL, ANTENS, BIF, EIF, ISTOK, FREQID, NUMHIS

      COMMON /GETA/ NLINES, IAN, VERDEL
      COMMON /CALDAT/ NCALLI, APDLY, ADPDLY, ATIME, AANT, NCALID
      COMMON /GETAD/ TMES
      COMMON /CHRCOM/ HISCRD, NAMEIN, CLAIN, XSOUR,
     *   XCALS,
     *   XSTOK, OPCODE, INFILE
C                                       Buffers and file info
      COMMON /BUFRS/ BUFFER
C                                       Internal storage
      COMMON /CLRECC/ COSDEC, SINDEC, CLRECD,
     *   GMMOD, PARM, PANGLE, AXOFF, NTERM,
     *   FIXCNT, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, ICODE
      EQUIVALENCE (CLRECI, CLRECR, CLRECD)
      EQUIVALENCE (CLKOLS(CLDTIM), TIMCL), (CLKOLS(CLRTMI), INTCL),
     *   (CLKOLS(CLISID),SOUCL), (CLKOLS(CLIANT),ANTCL),
     *   (CLKOLS(CLISUB),SUBCL), (CLKOLS(CLIFQI),FRQCL),
     *   (CLKOLS(CLRIFR),IFRCL), (CLKOLS(CLDDEL),GDLCL),
     *   (CLKOLS(CLRDOP),DOPCL), (CLKOLS(CLRATM),ATMCL),
     *   (CLKOLS(CLRDAT),DATMCL)
      EQUIVALENCE (CLKOLS(CLRMD1),MBD1CL),
     *   (CLKOLS(CLRCK1),CLK1CL), (CLKOLS(CLRDC1),DCK1CL),
     *   (CLKOLS(CLRDS1),DIS1CL), (CLKOLS(CLRDD1),DDS1CL),
     *   (CLKOLS(CLRRE1),RE1CL), (CLKOLS(CLRIM1),IM1CL),
     *   (CLKOLS(CLRRA1),RA1CL), (CLKOLS(CLRDE1),DE1CL),
     *   (CLKOLS(CLRWE1),WE1CL), (CLKOLS(CLIRF1),RF1CL)
      EQUIVALENCE (CLKOLS(CLRMD2),MBD2CL),
     *   (CLKOLS(CLRCK2),CLK2CL), (CLKOLS(CLRDC2),DCK2CL),
     *   (CLKOLS(CLRDS2),DIS2CL), (CLKOLS(CLRDD2),DDS2CL),
     *   (CLKOLS(CLRRE2),RE2CL), (CLKOLS(CLRIM2),IM2CL),
     *   (CLKOLS(CLRRA2),RA2CL), (CLKOLS(CLRDE2),DE2CL),
     *   (CLKOLS(CLRWE2),WE2CL), (CLKOLS(CLIRF2),RF2CL)
C                                                          End DFCOR
LOCAL END
      PROGRAM DFCOR
C-----------------------------------------------------------------------
C! Determines applies difference calibration corrections to the CL table.
C# UV Calibration EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2003, 2007-2009, 2012, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task DFCOR applies corrections to CL tables.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'DFCOR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'DFCOR '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL CLCLIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Apply corrections
      CALL CLCUV (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Copy and update HI file.
      CALL CLCLHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE CLCLIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   CLCLIN gets input parameters for DFCOR.
C   Inputs:  PRGN    C*6       Program name
C   Output:  JERR    I         Error code: 0 => ok
C                                1 => Invalid request
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   JERR
C
      CHARACTER STAT*4, UTYPE*2
      LOGICAL   T, F, ALLANT, MATCH
      INTEGER   NPARM, IERR, I, NEXT, IARG, LIMIT, J, IROUND, LUN,
     *   LUN2, IIVER, NUMCL, TABUFF(512)
      INCLUDE 'DFCOR.INC'
      INTEGER   DUMMY(MAXIF)
      REAL      FINC(MAXIF), BUFF1(2048)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA LUN, LUN2  /29, 28/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
C      NPARM = 237
      NPARM = 357
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 10
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
C                                       Restart AIPS
 10   IF (RQUICK) CALL RELPOP (JERR, BUFFER, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      SUBA = XSUBA + 0.5
      IF (SUBA.LE.0) SUBA = 1
C
      DO 20 I = 1,10
         IBAD(I) = IROUND (XBAD(I))
 20      CONTINUE
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XXSTOK, XSTOK)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
C                                       default if ATMO
      IF (OPCODE.EQ.'   ') OPCODE = 'ATMO'
      CALL H2CHR (48, 1, XINFIL, INFILE)
      DO 25 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
         CALL H2CHR (16, 1, XXCALS(1,I), XCALS(I))
 25      CONTINUE
C                                       Find file, read CATBLK
      CNOIN = 1
      STAT = 'SRCH'
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'WRIT', BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      NRPARM = CATBLK(KIPCN)
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FREQID = IROUND (XFQID)
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FREQID, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       determine number of CL tables
      CALL FNDEXT ('CL', CATBLK, NUMCL)
      IF (NUMCL.LE.0) THEN
         MSGTXT = 'NO CL TABLES FOUND, CANNOT DFCOR'
         JERR = 1
         GO TO 990
         END IF
      CLVER = IROUND (XGVER)
      IF ((CLVER.LE.0) .OR. (CLVER.GT.NUMCL)) CLVER = NUMCL
      CLUSE = IROUND (XGUSE)
C                                       copy CLVER table to CLUSE table
      IF (CLUSE.NE.CLVER) THEN
         CLUSE = NUMCL + 1
         CALL TABCOP ('CL', CLVER, CLUSE, LUN, LUN2, DISKIN, DISKIN,
     *      CNOIN, CNOIN, CATBLK, BUFF1, TABUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
      ELSE IF (CLUSE.EQ.1) THEN
         JERR = 1
         MSGTXT = 'MODIFYING CL TABLE VER. 1 IS NOT ALLOWED'
         CALL MSGWRT (8)
         MSGTXT = 'USE GAINUSE = 0 TO MAKE A NEW ONE'
         GO TO 990
         END IF
      WRITE (MSGTXT,1055) CLVER, CLUSE
      CALL MSGWRT (4)
C                                       IF range
      BIF = IROUND (XBIF)
      EIF = IROUND (XEIF)
      IF (BIF.LE.0) BIF = 1
      IF ((EIF.LE.0) .AND. (JLOCIF.GT.0)) EIF = CATBLK(KINAX+JLOCIF)
      IF (EIF.LE.0) EIF = 1
      IF ((JLOCIF.GT.0) .AND. (BIF.GT.CATBLK(KINAX+JLOCIF)))
     *   BIF = CATBLK(KINAX+JLOCIF)
      IF ((JLOCIF.GT.0) .AND. (EIF.GT.CATBLK(KINAX+JLOCIF)))
     *   EIF = CATBLK(KINAX+JLOCIF)
C                                       Stokes' type.
      ISTOK = 0
      IF (XSTOK.EQ.'R   ') ISTOK = 1
      IF (XSTOK.EQ.'L   ') ISTOK = 2
      IF (XSTOK.EQ.'I   ') ISTOK = -1
C                                       Check Stokes'
      IF (ISTOK.EQ.0) THEN
C                                       If none selected take what you
C                                       have.
         IF ((CATBLK(KINAX+JLOCS).EQ.1) .AND. (ABS (CATD(KDCRV+JLOCS)
     *      +1.0D0).LE.0.5D0)) ISTOK = 1
         IF ((CATBLK(KINAX+JLOCS).EQ.1) .AND. (ABS (CATD(KDCRV+JLOCS)
     *      +2.0D0).LE.0.5D0)) ISTOK = 2
         IF ((CATBLK(KINAX+JLOCS).EQ.1) .AND. (ABS (CATD(KDCRV+JLOCS)
     *      -1.0D0).LE.0.5D0)) ISTOK = -1
      ELSE
C                                       Is selected Stokes' available?
         IF ((CATBLK(KINAX+JLOCS).EQ.1) .AND.
     *      (ABS (CATD(KDCRV+JLOCS)+ISTOK).GT.0.5D0)) THEN
            JERR = 1
            MSGTXT = 'STOKES ' // XSTOK // ' UNAVAILABLE IN DATA'
            GO TO 990
            END IF
         END IF
      IF ((ISTOK.EQ.2) .AND. (NCOR.EQ.1)) ISTOK = 1
C                                       Check sort order of input
      IF (ISORT(1:2).NE.'TB') THEN
         WRITE (MSGTXT,1060) ISORT
         JERR = 1
         GO TO 990
         END IF
      JERR = 0
C                                       Antenna list
      ALLANT = T
      DESEL = F
      DO 100 I = 1,50
         ANTENS(I) = 0
         ALLANT = ALLANT .AND. (ABS (XANT(I)).LE.1.0E-10)
         DESEL = DESEL .OR. (XANT(I).LT.-0.5)
 100     CONTINUE
      NEXT = 1
      IF (ALLANT) GO TO 160
C                                       Not all selected - make list
C                                       ANTENNAS array.
         DO 150 I = 1,50
            IARG = ABS (XANT(I)) + 0.5
            IF (IARG.EQ.0) GO TO 150
C                                       See if already have
               LIMIT = NEXT - 1
               IF (LIMIT.LT.1) GO TO 140
               DO 130 J = 1,LIMIT
                  IF (IARG.EQ.ANTENS(J)) GO TO 150
 130              CONTINUE
C                                       New antenna
 140              ANTENS(NEXT) = IARG
                  NEXT = NEXT + 1
 150           CONTINUE
 160  DOAWNT = .NOT. DESEL
      NANTSL = NEXT - 1
C                                       Get source numbers
      CALL FNDSOU (DISKIN, CNOIN, XSOUR, BUFFER, NSOUWD, DOSWNT,
     *   SOUWAN, JERR)
C                                       Get cal. source numbers
      CALL FNDSOU (DISKIN, CNOIN, XCALS, BUFFER, NSOCWD, DOCWNT,
     *   SOCWAN, JERR)
C                                       Number of calibrators should be
C                                      .LE.1
      IF (NSOCWD.GT.1 .OR. NSOCWD.EQ.0) THEN
         MSGTXT = 'Number of calibrators can not be >1'
         JERR = 1
         GO TO 990
         END IF
C                                       Source ID of the calibrator
      NCALID = SOCWAN(1)
      IF (JERR.NE.0) GO TO 999
C                                       Get antenna info
      CALL GETANT (DISKIN, CNOIN, SUBA, CATBLK, BUFFER, JERR)
      IF (JERR.NE.0) GO TO 999
      CALL JULDAY (RDATE, JD0)
C                                       Get IF information
      IIVER = 1
      CALL CHNDAT ('READ', BUFFER, DISKIN, CNOIN, IIVER, CATBLK, LUN,
     *   NUMIF, FRQOFF, DUMMY, FINC, BNDCOD, FREQID, JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Get observing bandwidth. Assume
C                                       all IFs have same increment.
      BANDW  = CATBLK(KINAX+JLOCF) * FINC(BIF)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLCLIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR: COPYING INPUT CL TO OUTPUT:',I4)
 1055 FORMAT ('CL VERSION INPUT',I4,' OUTPUT',I4)
 1060 FORMAT ('INPUT VIS RECORDS MISORDERED, SORTED = ',A2,
     *   ' SHOULD BE = TB')
       END
      SUBROUTINE CLCUV (IERR)
C-----------------------------------------------------------------------
C   CLCUV is called from DFCOR. CLCUV reads throught the CL table,
C   passing the records selected to the correction routine CLCCOR.
C   Output: IERR  I    Return code, 0=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   LUN, IRCODE, THSOU, LSTSOU, ANT, I, JERR, IFNO(2),
     *   ICLRNO, NUMREC, LOOP
      LOGICAL   SLCTD
      DOUBLE PRECISION TIMBEG, TIMEND
      INCLUDE 'DFCOR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN /29/
C-----------------------------------------------------------------------
      FIXCNT = 0
C                                       If OPCODE='POLR' modify AN table
      IF (OPCODE.EQ.'POLR') THEN
         IFNO(1) = BIF
         IFNO(2) = EIF
         IF ((EIF-BIF+1).GT.20) THEN
C                                       Too many IFs, > 20.
            IERR = 10
            I = EIF - BIF + 1
            WRITE (MSGTXT,1000) I
            GO TO 990
            END IF
         CALL ANTCOR (DISKIN, CNOIN, SUBA, CATBLK, IFNO, BPARM, BUFFER,
     *      FREQID, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Timerange
      TIMBEG = XTIME(1) + XTIME(2) / 24.0 + XTIME(3) / (24.0*60.0) +
     *   (XTIME(4) / (24.0*60.0*60.0))
      TIMEND = XTIME(5) + XTIME(6) / 24.0 + XTIME(7) / (24.0*60.0) +
     *   (XTIME(8) / (24.0*60.0*60.0))
      IF ((TIMEND.LT.TIMBEG) .OR. (TIMEND.LT.1.0E-5)) TIMEND = 1.0E20
C                                       If OPCODE='ANAX' modify AN table
C                                       and exclude time influence
      IF (OPCODE.EQ.'ANAX') THEN
         CALL AXCOR (DISKIN, CNOIN, SUBA, CATBLK, BUFFER, NANTSL,
     *      ANTENS, BPARM, IERR)
         IF (IERR.NE.0) GO TO 999
         TIMBEG = 0.0
         TIMEND = 1.0E20
         END IF
C                                       Open CL table
      NUMPOL = 1
      IF (CATBLK(KINAX+JLOCS).GT.1) NUMPOL = 2
      NUMIF = 1
      IF (JLOCIF.GT.0) NUMIF = CATBLK(KINAX+JLOCIF)
C                                       Reformat table?
      CALL CLREFM (DISKIN, CNOIN, CLUSE, CATBLK, LUN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL CALINI ('WRIT', BUFFER, DISKIN, CNOIN, CLUSE, CATBLK, LUN,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get number of records
      NUMREC = BUFFER(5)
      IF (NUMREC.LE.0) GO TO 999
      IRCODE = 0
C                                       Initial call to CLCCOR
      CALL CLCCOR (1, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Read the CL table the first time
C                                       to estimate delays & times of
C                                       the calibrator
C                                       Do it only if CALSOUR.NE.''
      IF (NSOCWD.EQ.0) GO TO 60
      DO 50 LOOP = 1,NUMREC
         ICLRNO = LOOP
         CALL TABIO ('READ', IRCODE, ICLRNO, CLRECI, BUFFER, IERR)
         IF (IERR.GT.0) GO TO 900
         IF (IERR.LT.0) GO TO 50
C                                       Check data
C                                       Time:
         IF ((CLRECD(TIMCL).LT.TIMBEG) .OR.
     *       (CLRECD(TIMCL).GT.TIMEND)) GO TO 50
C                                       Subarray
         IF ((CLRECI(SUBCL).NE.SUBA) .AND. (CLRECI(SUBCL).GT.0))
     *      GO TO 50
C                                       Freq id
         IF ((CLRECI(FRQCL).NE.FREQID) .AND. (CLRECI(FRQCL).GT.0) .AND.
     *      (FREQID.GT.0)) GO TO 50
         IF (NSOCWD.LE.0) GO TO 30
C                                       Check source
         THSOU = CLRECI(SOUCL)
         IF (.NOT.SLCTD (THSOU, SOCWAN, NSOCWD, DOCWNT)) GO TO 50
 30      LSTSOU = THSOU
C                                       Check antenna
         ANT = CLRECI(ANTCL)
         IF (.NOT.SLCTD (ANT, ANTENS, NANTSL, DOAWNT)) GO TO 50
C
         CALL CLCCOR (2, JERR)
         IF (JERR.NE.0) GO TO 50
   50    CONTINUE
C                                       Number of selected records
C                                       of the given calibrator
      NCALLI = FIXCNT
C                                       zero FIXCNT, NSOCWD
   60 CONTINUE
      NSOCWD = 0
      FIXCNT = 0
C                                       Update table
      DO 500 LOOP = 1,NUMREC
         ICLRNO = LOOP
         CALL TABIO ('READ', IRCODE, ICLRNO, CLRECI, BUFFER, IERR)
         IF (IERR.GT.0) GO TO 900
         IF (IERR.LT.0) GO TO 500
C                                       Check data
C                                       Time:
         IF ((CLRECD(TIMCL).LT.TIMBEG) .OR.
     *       (CLRECD(TIMCL).GT.TIMEND)) GO TO 500
C                                       Subarray
         IF ((CLRECI(SUBCL).NE.SUBA) .AND. (CLRECI(SUBCL).GT.0))
     *      GO TO 500
C                                       Freq id
         IF ((CLRECI(FRQCL).NE.FREQID) .AND. (CLRECI(FRQCL).GT.0) .AND.
     *      (FREQID.GT.0)) GO TO 500
         IF (NSOUWD.LE.0) GO TO 70
C                                       Check source
         THSOU = CLRECI(SOUCL)
         IF (.NOT.SLCTD (THSOU, SOUWAN, NSOUWD, DOSWNT)) GO TO 500
 70      LSTSOU = THSOU
C                                       Check antenna
         ANT = CLRECI(ANTCL)
         IF (.NOT.SLCTD (ANT, ANTENS, NANTSL, DOAWNT)) GO TO 500
C                                       Correct record.
         IF (OPCODE.EQ.'ANAX') THEN
            DO 100 I = 1, NANTSL
               IF (ANTENS(I).EQ.ANT) AXOFF = PARM(I)
  100          CONTINUE
            END IF
         CALL CLCCOR (2, JERR)
         IF (JERR.NE.0) GO TO 500
C                                       Rewrite record
         CALL TABIO ('WRIT', IRCODE, ICLRNO, CLRECI, BUFFER, IERR)
         IF (IERR.GT.0) GO TO 900
 500     CONTINUE
C                                       Final call to CLCCOR
      CALL CLCCOR (3, JERR)
C                                       Close table.
      CALL TABIO ('CLOS', IRCODE, LOOP, CLRECI, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 900
      GO TO 999
C                                       TABIO error
 900  WRITE (MSGTXT,1900) IERR
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TOO MANY IFS SPECIFIED, ',I3,' > 10')
 1900 FORMAT ('TABIO ERROR',I3,' CORRECTING CL TABLE')
      END
      SUBROUTINE CLCCOR (IOP, IERR)
C-----------------------------------------------------------------------
C   CLCCOR applies corrections to the CL record passed thru common
C   /CLRECC/.
C   Input:
C    IOP        I    Operation code, 1=init, 2=process, 3=finish
C   Input from common:
C    CLRECI(*)  I    The CL table record to be corrected.
C    BIF        I    First IF number
C    EIF        I    Highest IF number
C    ISTOK      I    Stokes number, 0=both, 1=first, 2=second.
C    OPCODE     C*4  Operation code.
C    ICODE      I    Operation code number, set on first call.
C    BPARM(20)  R    parameters.
C   Output in common:
C    CLRECI(*)  I    Modified record.
C   Output:
C    IERR       I    Error code, 0=OK, else failed.
C-----------------------------------------------------------------------
      INTEGER   IOP, IERR
C
      DOUBLE PRECISION  DEG2RD
      INTEGER  NOP
      PARAMETER (NOP=20, DEG2RD=57.29577951)
C
      CHARACTER CHTM8*8, OPS(NOP)*4, STRING*8
      INTEGER   I, IANT, LSTSOU, THSOU, LUN, NTERMS, LIM1, LIM2,
     *   IPNT, IINC, ANTNO
      REAL      XT, YT, XXT, YYT, FACTOR, HA, ZA, ELV, POLYN, PFAC,
     *   CFAC, SFAC, DX, DY, AZ, TIME
      DOUBLE PRECISION    FREQS, SINLAT, COSLAT, CLTIME, R8T1, R8T2,
     *   DRA, DDEC, TIMED
      LOGICAL   ISPLNT
      INCLUDE 'DFCOR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA OPS /'PHAS','OPAC','ADEL','GAIN','CLOC','POLR',
     *   'PANG','PONT','IONS','ANTP','PCAL','SBDL','SSLO','RATE','PCFX',
     *   'MBDL','ANAX','ATMO','DUMY','DUMY'/
      DATA LUN /28/
C-----------------------------------------------------------------------
C                                       Determine operation
      IF (IOP.EQ.2) GO TO 200
      IF (IOP.EQ.3) GO TO 900
C                                       Initialize - find OPCODE
      ICODE = -1
      DO 30 I = 1,NOP
         IF (OPS(I).EQ.OPCODE) ICODE = I
 30      CONTINUE
C                                       If an invalid opcode
      IF (ICODE.LE.0) THEN
         IERR = 1
C                                       Tell User
         WRITE (MSGTXT,1030) OPCODE
         GO TO 990
         END IF
C                                       History - OPCODE
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2040) OPCODE
C                                       Setup
      GO TO (50,55,55,60,70,50,75,80,85,90,95,100,105,45,
     *       110,100,120,130), ICODE
C                                       'RATE' (14)
C                                       Phase rotation
C                                       Phase at "origin"
 45      PARM(1) = BPARM(1) / DEG2RD
C                                       History
         WRITE( MSGTXT, 1045) BPARM(1), BIF, EIF
         CALL MSGWRT(3)
C                                       Else 'RATE' Phase Rotation
C                                       Phase rate (deg/day -> rad/sec)
         PARM(2) = BPARM(2) / DEG2RD / 86400.0
C                                       Time of "origin"
         PARM(3) = BPARM(3) + BPARM(4)/24.0 + BPARM(5)/(24.0*60.0)
     *           + BPARM(6)/(24.0*60.0*60.0)
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2100) BPARM(1)
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2110) BPARM(2)
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2120) (BPARM(I),I=3,6)
         WRITE (MSGTXT,2100) BPARM(1)
         CALL MSGWRT(3)
         WRITE (MSGTXT,2110) BPARM(2)
         CALL MSGWRT(3)
         WRITE (MSGTXT,2120) (BPARM(I),I=3,6)
         CALL MSGWRT(3)
C                                       Source number
         PARM(12) = -10
         GO TO 999
C                                       OPCODE='PHAS' (1) or 'POLR' (6)
C                                       Phase rotation
 50      LIM1 = 1
         LIM2 = EIF - BIF + 1
         DO 52 I = LIM1,LIM2
            IPNT = (I-1) * 2 + 1
            PARM(IPNT) = COS (BPARM(I) / DEG2RD)
            PARM(IPNT+1) = SIN (BPARM(I) / DEG2RD)
C                                       History
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),2050) I, BPARM(I)
C                                       Tell user
            WRITE( MSGTXT, 1050) I, BPARM(I), BIF + I - 1
            CALL MSGWRT(3)
 52         CONTINUE
C                                       Set only the 0th term for 'PHAS'
         IF (ICODE.EQ.1) THEN
            MSGTXT = 'Use OPCODE = "RATE" to Rotate Phase with Time'
            CALL MSGWRT(3)
            END IF
         GO TO 999
C                                       Atmosphere
C                                       Either opacity(2) or pressure(3)
 55      PARM(1) = BPARM(1)
C                                       Partial pressure of water (3)
         PARM(2) = BPARM(2)
C                                       Temperature
         PARM(3) = BPARM(3)
C                                       Tropospheric lapse rate
         IF (ABS (BPARM(4)).GT.1.0E-10) THEN
            PARM(4) = BPARM(4)
         ELSE
            PARM(4) = -4.0
            END IF
C                                       Height of tropospause
         IF (ABS (BPARM(5)).GT.1.0E-10) THEN
            PARM(5) = BPARM(5)
         ELSE
            PARM(5) = 15.0
            END IF
C                                       Scale height of water
         IF (ABS (BPARM(6)).GT.1.0E-10) THEN
            PARM(6) = BPARM(6)
         ELSE
            PARM(6) = 2.2
            END IF
C                                       Source number
         PARM(7) = -10
C                                       History
         NUMHIS = NUMHIS + 1
         IF (ICODE.EQ.2) WRITE (HISCRD(NUMHIS),2055) BPARM(1)
         IF (ICODE.EQ.3) THEN
            WRITE (HISCRD(NUMHIS),2056) PARM(1), PARM(2), PARM(3)
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),2057) PARM(4), PARM(5), PARM(6)
            END IF
         GO TO 999
C                                       Poly. gain curve
C                                       OPCODE='GAIN' (4)
 60      NTERMS = 0
         DO 65 I = 1,10
            PARM(I+1) = BPARM(I)
            IF (ABS (BPARM(I)).GT.1.0E-20) NTERMS = I
 65         CONTINUE
         PARM(1) = NTERMS
C                                       Last source number
         PARM(12) = -10
C                                       History
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2065) BPARM(1), BPARM(2), BPARM(3)
         IF (NTERMS.GT.3) THEN
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),2066) (BPARM(I),I=4,7)
            END IF
         IF (NTERMS.GT.7) THEN
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),2066) (BPARM(I),I=8,10)
            END IF
         GO TO 999
C                                       OPCODE = 'CLOC' (5)
C                                       Clock rate (nsec/day -> sec/sec)
 70      PARM(1) = BPARM(1) * 1.0E-9 / 86400.0
C                                       Clock value at origin
C                                       (nsec -> sec)
         PARM(2) = BPARM(2) * 1.0E-9
C                                       Time of origin
         PARM(3) = BPARM(3) + BPARM(4)/24.0 + BPARM(5)/(24.0*60.0)
     *           + BPARM(6)/(24.0*60.0*60.0)
C                                       Correction mode
         PARM(4) = BPARM(7)
         IF (BPARM(7).EQ.0) PARM(2) = 0.0
         IF (BPARM(7).LT.0.0 .OR. BPARM(7).GT.2) THEN
            WRITE (MSGTXT,1040) BPARM(7)
            IERR = 2
            GO TO 990
            END IF
C                                       Source number
         PARM(12) = -10
C                                       History
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2070) BPARM(1)
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2071) BPARM(2)
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2072) BPARM(3),BPARM(4),BPARM(5),
     *      BPARM(6)
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2073) BPARM(7)
         GO TO 999
C                                       OPCODE = 'PANG' (7)
C                                       Parallactic angle (PA) corr.
C                                       PARM(1) = +/- 1.0 factor
C                                       PARM(2) = fract. last time of PA
C                                       PARM(3) = last source id.
C                                       Set PARM(1) to remove or add
C                                       P.A. corrections. NOTE:
C                                       phase of R (pol. 1) decreases
C                                       with increasing PA.
 75      PARM(1) = 1.0
         IF (BPARM(1).GT.0.0) PARM(1) = -1.0
C                                       Initialize last time , source
         PARM(2) = -1.0
         PARM(3) = -2.0
C                                       History
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2075) BPARM(1)
         IF (BPARM(1).GT.0.0) WRITE (HISCRD(NUMHIS),2076) BPARM(1)
         GO TO 999
C                                       OPCODE = 'PONT' (8)
C                                       Corrects antenna gain for
C                                       gross pointing error.
C                                       Temp(1) = time gain measured
C                                       Temp(2) = rate of change of gain
 80      PARM(1) = XTIME(1) + XTIME(2)/24.0 + XTIME(3)/(24.0*60.0)
     *           + XTIME(4)/(24.0*60.0*60.0)
         PARM(2) = BPARM(1)
C                                       History
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2077) BPARM(1)
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2078) XTIME(1),XTIME(2),XTIME(3),
     *      XTIME(4)
         GO TO 999
C                                       OPCODE = 'IONS' (9)
C                                       Ionispheric Faraday rot. corr.
C                                       PARM(1) = model type
C                                       PARM(2) = last source number
 85      PARM(2) = -10
         IF (BPARM(1).GT.0.0) THEN
C                                       Chiu model, type 1
C                                       PARM(3)=Zurich sunspot number
C                                       PARM(4)=annual time (mo)
            PARM(1) = 1.0
            PARM(3) = BPARM(3)
C                                       Get day of year number
            CALL H2CHR (8, 1, CATH(KHDOB), CHTM8)
            CALL JULDAY (CHTM8, R8T1)
            IF (CHTM8(3:3).EQ.'/') THEN
               STRING = '01/01' // CHTM8(6:8)
            ELSE
               STRING = CHTM8(:4) // '0101'
               END IF
            CALL JULDAY (STRING, R8T2)
C                                       Annual time in months since
C                                       15 Dec
            PARM(4) = ((R8T1 - R8T2) + 16.0) / 30.0
            IF (PARM(4).GT.12.0) PARM(4) = PARM(4) - 12.0
C                                       History
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),2085) BPARM(1)
            GO TO 999
            END IF
C                                       No recognizible model
         IERR = 5
         MSGTXT = 'ERROR: NO RECOGNIZABLE IONISPHERIC MODEL'
         GO TO 990
C                                       OPCODE = 'ANTP' (10)
C                                       Antenna and source
C                                       position error,
C                                       Position correction:
 90      PARM(1) = BPARM(1)
         PARM(2) = BPARM(2)
         PARM(3) = BPARM(3)
C
         IF ((PARM(1).NE.0) .OR. (PARM(2).NE.0) .OR.
     *      (PARM(3).NE.0)) THEN
C                                       Must select one antenna
C                                       if antenna position
C                                       is corrected
            IF (DESEL .OR. NANTSL.NE.1) THEN
               IERR = 9
               WRITE (MSGTXT,1060)
               GO TO 990
               END IF
C                                       correct AN table
            ANTNO = XANT(1)
            CALL ANTMOD(DISKIN, CNOIN, SUBA, ANTNO, PARM, IERR)
            IF (IERR.NE.0) GO TO 990
C                                       The warning
            WRITE (MSGTXT,1075)
            CALL MSGWRT (8)
            WRITE (MSGTXT,1065)
            CALL MSGWRT (8)
            WRITE (MSGTXT,1066)
            CALL MSGWRT (8)
            WRITE (MSGTXT,1067)
            CALL MSGWRT (8)
            WRITE (MSGTXT,1075)
            CALL MSGWRT (8)
C                                       history
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),2088)
            END IF
C                                       correction RA and
C                                       declination in radians
         PARM(6) = BPARM(5)/3600.0/DEG2RD
         PARM(7) = BPARM(6)/3600.0/DEG2RD
C                                       Must select one source
C                                       if source position
C                                       is corrected
         IF ((PARM(6).NE.0) .OR. (PARM(7).NE.0)) THEN
            IF (.NOT.DOSWNT .OR. NSOUWD.NE.1) THEN
               IERR = 9
               WRITE (MSGTXT,1070)
               GO TO 990
               END IF
C                                       correct SU table
C                                       corrections in degrees,
C                                       given at the picture plane
            DX = BPARM(5)/3600.0
            DY = BPARM(6)/3600.0
            CALL SOUMOD(DISKIN, CNOIN, SOUWAN(1), DX, DY, IERR)
            IF (IERR.NE.0) GO TO 990
C                                       The warning
            WRITE (MSGTXT,1075)
            CALL MSGWRT (8)
            WRITE (MSGTXT,1080)
            CALL MSGWRT (8)
            WRITE (MSGTXT,1081)
            CALL MSGWRT (8)
            WRITE (MSGTXT,1082)
            CALL MSGWRT (8)
            WRITE (MSGTXT,1075)
            CALL MSGWRT (8)
C                                       history
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),2089)
            END IF
C                                       Last source number
         PARM(5) = -10
C                                       History
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2090) BPARM(1), BPARM(2), BPARM(3)
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2092) BPARM(5), BPARM(6)
         GO TO 999
C                                       OPCODE='PCAL' (11)
C                                       Replace complex gains
 95      LIM1 = 1
         LIM2 = EIF - BIF + 1
         IPNT = 1
         DO 97 I = LIM1,LIM2
            PARM(IPNT) = COS (BPARM(I) / DEG2RD)
            PARM(IPNT+1) = SIN (BPARM(I) / DEG2RD)
            IPNT = IPNT + 2
C                                       History
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),2095) I, BPARM(I)
 97         CONTINUE
         GO TO 999
C                                       OPCODE='SBDL'(12) or 'MBDL'(16)
C                                       Correction to residual delays
C                                       or corresponded multiband phase
 100     LIM1 = 1
         LIM2 = EIF - BIF + 1
         IPNT = 1
         DO 102 I = LIM1,LIM2
            PARM(IPNT) = BPARM(IPNT) * 1.0E-9
            IPNT = IPNT + 1
C                                       History
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),2099) I, BPARM(I)
 102        CONTINUE
         GO TO 999
C                                       OPCODE='SSLO' (13)
C                                       Correction for fringe stopping
C                                       using the wrong Signed Sum LOs.
C
 105     CONTINUE
         PARM(1) = BPARM(1) * 1.0E6
C                                       Last source number
         PARM(5) = -10
C                                       History
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS), 2130) BPARM(1)
         GO TO 999
C                                       OPCODE='PCFX' (15)
C                                       Patch up phase cals.
 110     LIM1 = 1
         LIM2 = EIF - BIF + 1
         IPNT = 1
         DO 112 I = LIM1,LIM2
            PARM(IPNT) = BPARM(I) / DEG2RD
            IPNT = IPNT + 1
C                                       History
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),2111) I, BPARM(I)
 112        CONTINUE
         GO TO 999
C                                       OPCODE='ANAX'(17) Correction
C                                       for antennas axis offset
 120     CONTINUE
         DO 125 I = 1, NANTSL
            PARM(I) = BPARM(I)
C                                       History
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),2200) I, BPARM(I), ANTENS(I)
  125       CONTINUE
C                                       last source number
         PARM(NANTSL+1) = -10
         GO TO 999
C                                       OPCODE='ATMO'(18) Correction
C                                       of the antenna list by the
C                                       vertical atmosphere delay
C                                       given at the INFILE
 130     CONTINUE
C                                       Source number
         PARM(1) = -10
         CALL GETINP (INFILE, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'Error reading INFILE'
            GO TO 990
            END IF
         GO TO 999
C                                       Process record
 200  FIXCNT = FIXCNT + 1
      IANT = CLRECI(ANTCL)
      GO TO (250,300,300,350,400,280,450,500,550,600,610,620,630,
     *       250,640,850,870,890),ICODE
C                                       'PHAS' (1) or 'RATE' (14)
 250     IF (ISTOK.NE.2) THEN
            CLTIME = CLRECD(TIMCL)
            IPNT = 1
            IINC = 2
C                                       If correcting Phase vs time
            IF (ICODE.EQ.14) THEN
               PFAC = ((CLTIME-PARM(3))*86400.0*PARM(2)) + PARM(1)
               CFAC = COS (PFAC)
               SFAC = SIN (PFAC)
               END IF
            DO 270 I = BIF,EIF
C                                       Use precomputed phases
               IF (ICODE.EQ.1) THEN
                  CFAC = PARM(IPNT)
                  SFAC = PARM(IPNT+1)
                  END IF
               XT = CLRECR(RE1CL+I-1)
               YT = CLRECR(IM1CL+I-1)
               IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
                  CLRECR(RE1CL+I-1) = XT * CFAC - YT * SFAC
                  CLRECR(IM1CL+I-1) = XT * SFAC + YT * CFAC
                  END IF
               IPNT = IPNT + IINC
 270           CONTINUE
            END IF
C
         IF (ISTOK.EQ.1) GO TO 999
C                                       'POLR' (6)  (LCP only)
 280     IPNT = 1
         IINC = 2
C                                       If correcting Phase vs time
         CLTIME = CLRECD(TIMCL)
         IF (ICODE.EQ.14) THEN
            PFAC = ((CLTIME-PARM(3))*86400.0*PARM(2)) + PARM(1)
            CFAC = COS (PFAC)
            SFAC = SIN (PFAC)
            END IF
C                                       For all IFs
         DO 290 I = BIF,EIF
C                                       Use precomputed phases
            IF (ICODE.EQ.1.OR.ICODE.EQ.6) THEN
               CFAC = PARM(IPNT)
               SFAC = PARM(IPNT+1)
               END IF
            XT = CLRECR(RE2CL+I-1)
            YT = CLRECR(IM2CL+I-1)
            IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
               CLRECR(RE2CL+I-1) = XT * CFAC - YT * SFAC
               CLRECR(IM2CL+I-1) = XT * SFAC + YT * CFAC
               END IF
            IPNT = IPNT + IINC
 290        CONTINUE
         GO TO 999
C                                       Atmosphere
C                                       Either opacity(2) or delay(3)
 300     CALL ATMOS (IERR)
         GO TO 999
C                                       Polynomial gain curve
C                                       GAIN
 350     LSTSOU = PARM(12) + 0.5
         THSOU = CLRECI(SOUCL)
         TIMED = CLRECD(TIMCL)
         TIME = TIMED
C                                       get source info
         CALL FNDCOO (0, JD0, THSOU, DISKIN, CNOIN, CATBLK, LUN, TIME,
     *      DRA, DDEC, ISPLNT, IERR)
         IF (IERR.NE.0) GO TO 999
         PARM(12) = THSOU
         FREQS = FREQ + FREQO(BIF)
         SINDEC = SIN (DDEC)
         COSDEC = COS (DDEC)
C                                       Compute zenith angle (deg).
         CALL COOELV (IANT, TIMED, DRA, DDEC, HA, ELV, AZ)
         COSLAT = COS (STNLAT(IANT))
         SINLAT = SIN (STNLAT(IANT))
         ZA = (1.570796327 - ELV)
         ZA = 180.0 * ZA / PI
         NTERMS = PARM(1) + 0.5
C                                       Polynomial expansion.
         FACTOR = POLYN (NTERMS, ZA, PARM(2))
         IF (ISTOK.NE.2) THEN
            DO 360 I = BIF,EIF
               XT = CLRECR(RE1CL+I-1)
               YT = CLRECR(IM1CL+I-1)
               IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
                  CLRECR(RE1CL+I-1) = XT * FACTOR
                  CLRECR(IM1CL+I-1) = YT * FACTOR
                  END IF
 360           CONTINUE
            END IF
         IF (ISTOK.NE.1) THEN
            DO 380 I = BIF,EIF
               XT = CLRECR(RE2CL+I-1)
               YT = CLRECR(IM2CL+I-1)
               IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
                  CLRECR(RE2CL+I-1) = XT * FACTOR
                  CLRECR(IM2CL+I-1) = YT * FACTOR
                  END IF
 380           CONTINUE
            END IF
         GO TO 999
C                                       Clock error
C                                       OPCODE='CLOK' (5)
 400     CALL CLOKER (IERR)
         GO TO 999
C                                       OPCODE='PANG' (7)
C                                       Parallactic angle correction
C                                       Check if source info current
 450     THSOU = CLRECI(SOUCL)
         LSTSOU = PARM(3) + 0.5
C                                       Check time.
         XT = CLRECD(TIMCL)
         I = XT
         YT = CLRECD(TIMCL) - I
C                                       0.02 sec. tolerance.
C                                       Get new source info.
         IF ((LSTSOU.NE.THSOU) .OR. (ABS(YT-PARM(2)).GT.2.315E-7)) THEN
            CALL FNDCOO (0, JD0, THSOU, DISKIN, CNOIN, CATBLK, LUN, XT,
     *         DRA, DDEC, ISPLNT, IERR)
            IF (IERR.NE.0) GO TO 999
            PARM(3) = THSOU
            CALL PARACO (XT, DRA, DDEC, PANGLE)
            PARM(2) = YT
            END IF
C                                       Apply (remove) correction
         IANT = CLRECI(ANTCL)
         XT = COS (PARM(1) * PANGLE(IANT))
         YT = SIN (PARM(1) * PANGLE(IANT))
C                                       Polarization 1 corrections:
         IF (ISTOK.NE.2) THEN
            DO 455 I = BIF,EIF
               XXT = CLRECR(RE1CL+I-1)
               YYT = CLRECR(IM1CL+I-1)
               IF ((XXT.NE.FBLANK) .AND. (YYT.NE.FBLANK)) THEN
                  CLRECR(RE1CL+I-1) = XXT*XT - YYT*YT
                  CLRECR(IM1CL+I-1) = XXT*YT + YYT*XT
                  END IF
 455           CONTINUE
            END IF
C                                       Polarization 2 corrections:
         IF (ISTOK.NE.1) THEN
            DO 460 I = BIF,EIF
               XXT = CLRECR(RE2CL+I-1)
               YYT = CLRECR(IM2CL+I-1)
               IF ((XXT.NE.FBLANK) .AND. (YYT.NE.FBLANK)) THEN
C                                       Opposite phase for Pol. 2.
                  CLRECR(RE2CL+I-1) = XXT*XT + YYT*YT
                  CLRECR(IM2CL+I-1) = -XXT*YT + YYT*XT
                  END IF
 460           CONTINUE
            END IF
         GO TO 999
C                                       Pointing correction
C                                       'PONT' (8)
 500     CLTIME = CLRECD(TIMCL)
         IF (CLTIME.LT.PARM(1)) GO TO 999
         FACTOR = (CLTIME - PARM(1)) * 24.0 * PARM(2)
         IF (ISTOK.NE.2) THEN
            DO 510 I = BIF,EIF
               IF ((CLRECR(RE1CL+I-1).NE.FBLANK) .AND.
     *            (CLRECR(IM1CL+I-1).NE.FBLANK)) THEN
                  XT = SQRT (CLRECR(RE1CL+I-1) * CLRECR(RE1CL+I-1) +
     *               CLRECR(IM1CL+I-1) * CLRECR(IM1CL+I-1))
                  XT = XT + FACTOR
                  CLRECR(RE1CL+I-1) = CLRECR(RE1CL+I-1) / SQRT(XT)
                  CLRECR(IM1CL+I-1) = CLRECR(IM1CL+I-1) / SQRT(XT)
                  END IF
 510           CONTINUE
            END IF
         IF (ISTOK.NE.1) THEN
            DO 520 I = BIF,EIF
               IF ((CLRECR(RE2CL+I-1).NE.FBLANK) .AND.
     *            (CLRECR(IM2CL+I-1).NE.FBLANK)) THEN
                  XT = SQRT (CLRECR(RE2CL+I-1) * CLRECR(RE2CL+I-1) +
     *               CLRECR(IM2CL+I-1) * CLRECR(IM2CL+I-1))
                  XT = XT + FACTOR
                  CLRECR(RE2CL+I-1) = CLRECR(RE2CL+I-1) / SQRT(XT)
                  CLRECR(IM2CL+I-1) = CLRECR(IM2CL+I-1) / SQRT(XT)
                  END IF
 520           CONTINUE
            END IF
         GO TO 999
C                                       Ionispheric Faraday rot (9)
 550     CALL FARADA (IERR)
         GO TO 999
C                                       Antenna and source
C                                       position error (10)
 600     CALL ANTPOS (IERR)
         GO TO 999
C                                       OPCODE='PCAL' (11)
C                                       Replace complex gains
 610     CALL REPGAI
         GO TO 999
C                                       OPCODE='SBDL' (12)
C                                       Correction to residual delays.
 620     CALL CORSBD
         GO TO 999
C                                       OPCODE='SSLO' (13)
C                                       Correction for fringe stopping
C                                       using the wrong Signed Sum LOs.
 630     CONTINUE
         CALL CORRFQ (IERR)
         GO TO 999
C                                       OPCODE='PCFX' (15)
C                                       PAtch Phase cals.
 640     CALL PTCHPC
         GO TO 999
C                                       OPCODE='MBDL' (16)
C                                       Correction to multiband phase
 850     CALL CORMBD
         GO TO 999
C                                       OPCODE='ANAX' (17)
C                                       Correction for antenna axis
C                                       offset
 870     CALL ANAXIS (IERR)
         GO TO 999
C                                       OPCODE='ATMO' (18)
C                                       Correction of the antenna list
C                                       by the vertical atmosphere
C                                       delay given at the INFILE
C
 890     CALL ATMOV (IERR)
         GO TO 999
C                                       Finish - number changed.
 900  NUMHIS= NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2900) FIXCNT
      WRITE (MSGTXT,2901) FIXCNT
      CALL MSGWRT (6)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('ERROR: UNKNOWN OPCODE: ',A4)
 1040 FORMAT ('ERROR: UNKNOWN CORRECTION MODE: ',F3.0)
 1045 FORMAT ('CLPARM( 1)=',F8.2,' / Phase(deg) to rotation for',
     *   ' IF(s)',I3,' to',I3)
 1050 FORMAT ('CLPARM(',I2,')=',F8.2,' / Phase(deg) to rotation for',
     *   ' IF ',I3)
 1060 FORMAT ('You have to select the one antenna corrected')
 1065 FORMAT ('!!! AN table is corrected for the selected antenna !!!')
 1066 FORMAT ('!!! So you should apply the corrected CL table     !!!')
 1067 FORMAT ('!!! to match the data. See HELP.                   !!!')
 1070 FORMAT ('You have to select the one source corrected')
 1075 FORMAT ('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!')
 1080 FORMAT ('!!! SU table is corrected for the selected source. !!!')
 1081 FORMAT ('!!! So you should apply the corrected CL table     !!!')
 1082 FORMAT ('!!! to match the data. See HELP.                   !!!')
 2040 FORMAT ('OPCODE = ''',A4,''' / Operation code')
 2050 FORMAT ('CLPARM(',I2,')=',F8.2,' / Phase(deg) to rotate gains')
 2055 FORMAT ('CLPARM(1)=',F8.2,' / Zenith opacity')
 2056 FORMAT ('CLPARM=',F8.2,',',F8.2,',',F8.2,
     *   ', / Atm. pres., PP H2O, Temp')
 2057 FORMAT ('      ',F8.2,',',F8.2,',',F8.2,' / Lapse, ht. ',
     *   ' tp, scl. ht. H20')
 2065 FORMAT ('CLPARM =',1PE12.5,2(',',E12.5),' / Gain curve')
 2066 FORMAT ('      ,',1PE12.5,3(',',E12.5))
 2070 FORMAT ('CLPARM(1)=',F8.3,' / Clock drift (nanosec/day)')
 2071 FORMAT ('CLPARM(2)=',F12.3,' / Clock at "zero" time (nsec)')
 2072 FORMAT (F3.0,1X,F3.0,F3.0,F4.1,' / "Zero" time')
 2073 FORMAT ('CLPARM(7)=',F4.0,' / Delay correction mode')
 2075 FORMAT ('CLPARM(1)=',F4.0,' / Parallactic angle correction',
     *   ' removed')
 2076 FORMAT ('CLPARM(1)=',F4.0,' / Parallactic angle correction',
     *   ' APPLIED')
 2077 FORMAT ('CLPARM(2)=',F10.4,' / Rate of change of gain (/hour)')
 2078 FORMAT (F3.0,1X,F3.0,F3.0,F4.1,' / Time when antenna gain set')
 2085 FORMAT ('CLPARM(2)=',F10.2,' / Chiu model sunspot number')
 2088 FORMAT ('!!! AN table is corrected for the selected antenna !!!')
 2089 FORMAT ('!!! SU table is corrected for the selected source !!!')
 2090 FORMAT ('CLPARM =',1PE12.5,2(',',E12.5),' / Ant. pos error')
 2092 FORMAT ('CLPARM(5,6) =',2(F9.4),' / Source position error')
 2095 FORMAT ('CLPARM(',I2,')=',F8.2,' / Complex gain phase(deg)')
 2099 FORMAT ('CLPARM(',I2,')=',F8.2,' / Residual delay corr. (nsec)')
 2100 FORMAT ('CLPARM(1)=',F8.3,' / Phase at "Zero" time (degrees)')
 2110 FORMAT ('CLPARM(2)=',F10.3,' / Phase rate (deg/day)')
 2111 FORMAT ('CLPARM(',I2,')=',F8.2,' / Phase relationship(deg)')
 2120 FORMAT (F3.0,1X,F3.0,F3.0,F4.1,' / "Zero" time')
 2130 FORMAT ('CLPARM(1)=',F8.8,' / SSLO Frequency error (MHz)')
 2200 FORMAT ('CLPARM(',I2,')=',F6.2,' /Axis offset (meters) for',
     *        ' antenna', I3)
 2900 FORMAT (' / ',I6,' Records modified')
 2901 FORMAT (I6,' Records modified')
      END
      SUBROUTINE CLCLHI
C-----------------------------------------------------------------------
C   CLCLHI copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, CTIME(2)*12, LABEL*8
      INTEGER   LUN1, IERR, I, TIME(3), DATE(3), LIMIT, LIMIT2, J
      REAL      TIMBEG, TIMEND
      LOGICAL   T
      INCLUDE 'DFCOR.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1 /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HIOPEN (LUN1, DISKIN, FCNO(NCFILE), BUFFER, IERR)
      IF (IERR.LE.2) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
C                                       Task message
 10   CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,1010) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN1, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Sources
         IF (NSOUWD.LE.0) THEN
            WRITE (HILINE,3000) TSKNAM
            CALL HIADD (LUN1, HILINE, BUFFER, IERR)
         ELSE
C                                       Included or excluded?
            WRITE (HILINE,3001) TSKNAM
            IF (DOSWNT) WRITE (HILINE,3002) TSKNAM
            CALL HIADD (LUN1, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 100
C                                       1st 2 and label.
            WRITE (HILINE,3003) TSKNAM, XSOUR(1), XSOUR(2)
            CALL HIADD (LUN1, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 100
            IF (NSOUWD.LE.2) GO TO 25
C                                       Rest of sources
            DO 20 I = 1,NSOUWD,2
               WRITE (HILINE,3004) TSKNAM, XSOUR(I), XSOUR(I+1)
               CALL HIADD (LUN1, HILINE, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 100
 20            CONTINUE
            END IF
C                                       Antennas
 25      IF (NANTSL.LE.0) THEN
            WRITE (HILINE,3005) TSKNAM
            CALL HIADD (LUN1, HILINE, BUFFER, IERR)
         ELSE
C                                       Included or excluded?
            WRITE (HILINE,3006) TSKNAM
            IF (DOAWNT) WRITE (HILINE,3007) TSKNAM
            CALL HIADD (LUN1, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 100
C                                       1st 12 and label.
            LIMIT = MIN (12, NANTSL)
            WRITE (HILINE,3008) TSKNAM, (ANTENS(J),J=1,LIMIT)
            CALL HIADD (LUN1, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 100
            IF (NANTSL.LE.12) GO TO 35
C                                       Rest of antennas
            DO 30 I = 13,NANTSL,12
               LIMIT = I
               LIMIT2 = I + 11
               LIMIT2 = MIN (NANTSL, LIMIT2)
               WRITE (HILINE,3009) TSKNAM, (ANTENS(J),J=LIMIT,LIMIT2)
               CALL HIADD (LUN1, HILINE, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 100
 30            CONTINUE
            END IF
C                                       Timerange
 35   TIMBEG = XTIME(1) + XTIME(2) / 24.0 + XTIME(3) / (24.0*60.0) +
     *   (XTIME(4) / (24.0*60.0*60.0))
      TIMEND = XTIME(5) + XTIME(6) / 24.0 + XTIME(7) / (24.0*60.0) +
     *   (XTIME(8) / (24.0*60.0*60.0))
      IF ((TIMEND.LT.TIMBEG) .OR. (TIMEND.LT.1.0E-5)) TIMEND = 1.0E20
      CALL HITIME (TIMBEG, TIMEND, LUN1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Stokes'
      WRITE (HILINE,2005) TSKNAM, XSTOK
      CALL HIADD (LUN1, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       IF range
      WRITE (HILINE,2004) TSKNAM, BIF, EIF
      CALL HIADD (LUN1, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       SUBARRAY, GAINVER, GAINUSE
      WRITE (HILINE,2002) TSKNAM, SUBA, CLVER, CLUSE
      CALL HIADD (LUN1, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                      Add any other history.
         IF (NUMHIS.LE.0) GO TO 100
         WRITE (LABEL,1011) TSKNAM
         HILINE(1:8) = LABEL(1:8)
         DO 90 I = 1,NUMHIS
            HILINE(9:72) = HISCRD(I)(1:64)
            CALL HIADD (LUN1, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 100
 90         CONTINUE
C                                       Close HI file
 100  CALL HICLOS (LUN1, T, BUFFER, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLCLHI: ERROR',I3,' OPENING HISTORY FILE')
 1010 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 1011 FORMAT (A6,'  ')
 2002 FORMAT (A6, ' SUBARRAY =',I3,' GAINVER = ',I4,
     *   ' GAINUSE = ',I4,' /CL table')
 2004 FORMAT (A6,' BIF =',I4,', EIF =',I4,'/ IF range')
 2005 FORMAT (A6,' STOKES = ''',A4,''' / Stokes type')
 3000 FORMAT (A6,' SOURCES = ''''     /All sources selected')
 3001 FORMAT (A6,' /Sources excluded:')
 3002 FORMAT (A6,' /Sources included:')
 3003 FORMAT (A6,' SOURCES = ''',A16,''',''',A16,'''')
 3004 FORMAT (A6,'          ,''',A16,''',''',A16,'''')
 3005 FORMAT (A6,' ANTENNAS = 0     /All antennas selected')
 3006 FORMAT (A6,' /Antennas excluded:')
 3007 FORMAT (A6,' /Antennas included:')
 3008 FORMAT (A6,' ANTENNAS = ',12(I3,' '))
 3009 FORMAT (A6,'            ',12(I3,' '))
      END
      SUBROUTINE ANTCOR (DISK, CNO, INVER, CATBLK, IFNO, PCOR, BUFFER,
     *   FREQID, IERR)
C-----------------------------------------------------------------------
C   ANTCOR corrects the left hand polarization solutions by a specified
C   amount.  The correction depends on the polarization solution type
C   indicated by the table header keyword 'POLTYPE'.
C   Inputs:
C      DISK      I      Volume number
C      CNO       I      Catalog slot number
C      INVER     I      Input version number (subarray number)
C      CATBLK(*) I      Catalog header block
C      IFNO(2)   I      Range of IFs; 0 => 1.
C      PCOR(*)   R      Phase offsets of IFs in degrees
C      BUFFER(*) I      I/O Buffer
C      FREQID    I      FQ ID user wishes to change
C   Output:
C      IERR      I      Error code, 0=OK, else failed.
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, INVER, CATBLK(256), IFNO(2), BUFFER(8),
     *   FREQID, IERR
      REAL      PCOR(*)
C
      CHARACTER    CHPOLT*8, CHSOL(4)*8, SOLTYP*8
      INTEGER   IIF, LUN, IANT, INDEX, LOCS, KEYTYP, ISTYPE, BIF, EIF,
     *   NXIF, NUMREC, IREF
      REAL      POLP1, POLP2, SPCOR, CPCOR
      HOLLERITH XSOLTY(2)
      INCLUDE 'INCS:PUVD.INC'
      REAL      PD(MAXIF)
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA CHSOL /'ORI-ELP ', 'APPROX  ', 'X-Y LIN', 'VLBI'/
      DATA CHPOLT /'POLTYPE '/
      DATA LUN /28/
C-----------------------------------------------------------------------
C                                      Open AN extension file.
      CALL ANTINI ('WRIT', BUFFER, DISK, CNO, INVER, CATBLK, LUN,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'WRIT'
         GO TO 990
         END IF
C                                       Check FREQID compatibility.
      IF ((ANFQID.GT.0) .AND. (FREQID.GT.0) .AND.
     *   (ANFQID.NE.FREQID)) THEN
         MSGTXT = 'WARNING - POTENTIALLY FATAL ERROR'
         CALL MSGWRT (4)
         MSGTXT = '   The polarization variables in your AN table have'
         CALL MSGWRT (4)
         WRITE (MSGTXT,1030) ANFQID
         CALL MSGWRT (4)
         WRITE (MSGTXT,1040) FREQID
         CALL MSGWRT (4)
         MSGTXT = '   Are you sure this is what you want to do?'
         CALL MSGWRT (4)
         END IF
      NUMREC = BUFFER(5)
C                                       IF range to modify.
C                                       This is a risky to tell the
C                                       number of IFs.
      NXIF = ANNUMV(9) / 2
      BIF = IFNO(1)
      IF (BIF.GT.NXIF) BIF = NXIF
      IF (BIF.LE.0) BIF = 1
      EIF = IFNO(2)
      IF (EIF.GT.NXIF) EIF = NXIF
      IF (EIF.LE.0) EIF = 1
C                                       Check solution type keyword.
      CALL TABKEY ('READ', CHPOLT, 1, BUFFER, LOCS, XSOLTY, KEYTYP,
     *   IERR)
      IF (IERR.EQ.0) GO TO 60
         WRITE (MSGTXT,1060) IERR
         GO TO 990
C                                       Decide solution type:
 60   ISTYPE = 0
      CALL H2CHR (8, 1, XSOLTY, SOLTYP)
      IF (SOLTYP.EQ.CHSOL(1)) ISTYPE = 1
      IF (SOLTYP.EQ.CHSOL(2)) ISTYPE = 2
      IF (SOLTYP.EQ.CHSOL(3)) ISTYPE = 3
      IF (SOLTYP.EQ.CHSOL(4)) ISTYPE = 4
      IF (ISTYPE.EQ.0) THEN
C                                       Unknown pol. solution type.
         IERR = 10
         WRITE (MSGTXT,1070) SOLTYP
         GO TO 990
         END IF
C                                       For ISTYPE=1 (ORI-ELP) only need
C                                       to modify R-L phase differences
      IF (SOLTYP.EQ.'ORI-ELP ') THEN
C                                       Close AN table
         CALL TABIO ('CLOS', 1, IANRNO, BUFFER, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1200) IERR
            GO TO 990
            END IF
C                                       Fetch old phase differences
         CALL PDRGET (DISK, CNO, INVER, LUN, CATBLK, NXIF, IREF, PD,
     *      BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Update values (radians)
         INDEX = 1
         DO 80 IIF = BIF,EIF
            PD(IIF) = PD(IIF) + PCOR(INDEX) * 1.745329E-2
            INDEX = INDEX + 1
 80         CONTINUE
C                                       Save results
         CALL PDRSET (DISK, CNO, INVER, LUN, CATBLK, NXIF, IREF, PD,
     *      BUFFER, IERR)
C                                       Done
         GO TO 999
         END IF
C                                       Read AN records
      DO 200 IANT = 1,NUMREC
         IANRNO = IANT
         CALL TABAN ('READ', BUFFER, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR, 'READ'
            GO TO 990
            END IF
C                                       Feed polarizations
         INDEX = 1 + (BIF-1) * 2
         DO 150 IIF = BIF,EIF
C                                       Make appropriate correction
            IF ((ISTYPE.GE.2) .AND. (ISTYPE.LE.4)) THEN
C                                       Linear approximation
               CPCOR = COS (PCOR(IIF-BIF+1) * 1.745329E-2)
               SPCOR = SIN (PCOR(IIF-BIF+1) * 1.745329E-2)
C                                       Right hand (or X) parameters
               POLP1 = POLCA(INDEX)
               POLP2 = POLCA(INDEX+1)
               POLCA(INDEX) = POLP1 * CPCOR - POLP2 * SPCOR
               POLCA(INDEX+1) = POLP2 * CPCOR + POLP1 * SPCOR
C                                       Left hand (or Y) parameters
               POLP1 = POLCB(INDEX)
               POLP2 = POLCB(INDEX+1)
               POLCB(INDEX) = POLP1 * CPCOR + POLP2 * SPCOR
               POLCB(INDEX+1) = POLP2 * CPCOR - POLP1 * SPCOR
            ELSE
C                                       Nothing for now
               CONTINUE
               END IF
            INDEX = INDEX + 2
 150        CONTINUE
C                                       Write record
         IANRNO = IANT
         CALL TABAN ('WRIT', BUFFER, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR, 'WRIT'
            GO TO 990
            END IF
 200     CONTINUE
C                                      Close AN extension files
      CALL TABIO ('CLOS', 1, IANRNO, BUFFER, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1200) IERR
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ANTCOR: ERROR',I3,' OPEN-FOR-',A4,'ING AN FILE')
 1030 FORMAT ('   previously been modified for FQID ',I3)
 1040 FORMAT ('   You are now changing them with FREQID =',I3)
 1060 FORMAT ('ANTCOR: ERROR',I3,' FINDING POL. SOLUTION TYPE KEYWORD')
 1070 FORMAT ('ANTCOR: UNKNOWN POLN. SOLN. TYPE = ',A8)
 1100 FORMAT ('ANTCOR: ERROR',I3,1X,A4,'ING AN FILE')
 1200 FORMAT ('ANTCOR: ERROR',I3,' CLOSING AN FILE')
      END
      SUBROUTINE AXCOR (DISK, CNO, INVER, CATBLK, BUFFER, NANTS, ANS,
     *   PAR, IERR)
C-----------------------------------------------------------------------
C   AXCOR corrects the axis offsets STAXOF in accordance of input
C   CLCORPRM
C   Inputs:
C      DISK      I      Volume number
C      CNO       I      Catalog slot number
C      INVER     I      Input version number (subarray number)
C      CATBLK(*) I      Catalog header block
C      NANTS     I      Number of selected antennas
C      ANS(*)    I      Array of selected anntennas' numbers
C      PAR(*)    R      Array of input parameters
C      BUFFER(*) I      I/O Buffer
C   Output:
C      IERR      I      Error code, 0=OK, else failed.
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, INVER, CATBLK(256), BUFFER(8), NANTS, ANS(*),
     *   IERR
      REAL      PAR(*)
C
      INTEGER   LUN, IANT,  NUMREC, I
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LUN /28/
C-----------------------------------------------------------------------
C                                      Open AN extension file.
      CALL ANTINI ('WRIT', BUFFER, DISK, CNO, INVER, CATBLK, LUN,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANFQID, ANTNIF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'WRIT'
         GO TO 990
         END IF
      NUMREC = BUFFER(5)
C                                       Read AN records
      DO 100 IANT = 1,NUMREC
         IANRNO = IANT
         CALL TABAN ('READ', BUFFER, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR, 'READ'
            GO TO 990
            END IF
C                                       Make appropriate correction
         DO 50 I = 1, NANTS
            IF (ANS(I).EQ.NOSTA) STAXOF = STAXOF + PAR(I)
   50       CONTINUE
C                                       Write record
         IANRNO = IANT
         CALL TABAN ('WRIT', BUFFER, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR, 'WRIT'
            GO TO 990
            END IF
 100     CONTINUE
C                                      Close AN extension files
      CALL TABIO ('CLOS', 1, IANRNO, BUFFER, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1200) IERR
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AXCOR: ERROR',I3,' OPEN-FOR-',A4,'ING AN FILE')
 1100 FORMAT ('AXCOR: ERROR',I3,1X,A4,'ING AN FILE')
 1200 FORMAT ('AXCOR: ERROR',I3,' CLOSING AN FILE')
      END
      SUBROUTINE ATMOS (IERR)
C-----------------------------------------------------------------------
C   Routine to determine and correct neutral atmospheric corrections.
C   Corrections are applied to the CL record in Common.
C   Control info from common:
C      ICODE    I    2 => Opacity, 3 => delay.
C      PARM(*)  R    (1) = Opacity (ICODE=2) or Atmos. press.(mbar)
C                        (ICODE=3)
C                    (2) = partial pressure of H2O (mbar).
C                    (3) = Temperature (deg C)
C                    (4) = Tropospheric lapse rate (K/km) (negative)
C                    (5) = Height of the tropopause (km).
C                    (6) = Scale height of water vapor (km)
C                    (7) = Last source ID number
C      ISTOK    I    Polarization to correct, 1=first, 2=second,
C                    0 = both
C   Output:
C      IERR     I    Return error code , 0=OK else failed.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   LSTSOU, THSOU, LUN, IANT, I, ITEMP
      REAL      XT, YT, FACTOR, PDLY, DPDLY, CFAC, SFAC, FQFAC, ZA, ARG,
     *   ELV, HA, AZ, TIME
      DOUBLE PRECISION HRANG, DARG, FREQS, SINLAT, COSLAT, TIMED, DRA,
     *   DDEC
      LOGICAL   ISPLNT
      INCLUDE 'DFCOR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA LUN /30/
C-----------------------------------------------------------------------
      LSTSOU = PARM(7) + 0.5
      THSOU = CLRECI(SOUCL)
      TIMED = CLRECD(TIMCL)
      TIME = TIMED
C                                       get source info
      CALL FNDCOO (0, JD0, THSOU, DISKIN, CNOIN, CATBLK, LUN, TIME,
     *   DRA, DDEC, ISPLNT, IERR)
      IF (IERR.NE.0) GO TO 999
      PARM(7) = THSOU
      FREQS = FREQ + FREQO(BIF)
      SINDEC = SIN (DDEC)
      COSDEC = COS (DDEC)
      IANT = CLRECI(ANTCL)
      CALL COOELV (IANT, CLRECD(TIMCL), DRA, DDEC, HA, ELV, AZ)
      HRANG = HA
      ZA = (1.570796327 - ELV)
      COSLAT = COS (STNLAT(IANT))
      SINLAT = SIN (STNLAT(IANT))
      DARG = SINLAT * SINDEC + COSLAT * COSDEC * COS (HRANG)
      IF (ICODE.EQ.3) GO TO 500
C                                       Transmission factor:
C                                       Modified cosecant law from
C                                       Chopo Ma's thesis:
      ARG = PARM(1) / (DARG + (0.00143 / (TAN(ELV) + 0.0045)))
C                                       Three term approx. of exp.
      FACTOR = 1.0 + ARG * (1.0 + 0.5 * ARG )
C                                       Need square root for
C                                       calibration table factor
      FACTOR = SQRT (FACTOR)
C
      IF (ISTOK.EQ.2) GO TO 150
      DO 100 I = BIF,EIF
         XT = CLRECR(RE1CL+I-1)
         YT = CLRECR(IM1CL+I-1)
         IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
            CLRECR(RE1CL+I-1) = XT * FACTOR
            CLRECR(IM1CL+I-1) = YT * FACTOR
            END IF
 100     CONTINUE
 150     IF (ISTOK.EQ.1) GO TO 999
      DO 200 I = BIF,EIF
         XT = CLRECR(RE2CL+I-1)
         YT = CLRECR(IM2CL+I-1)
         IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
            CLRECR(RE2CL+I-1) = XT * FACTOR
            CLRECR(IM2CL+I-1) = YT * FACTOR
            END IF
 200     CONTINUE
      GO TO 999
C                                       Phase delay
C                                       Get delay and rate
 500  CALL ATMFAZ (ELV, HA, STNLAT(IANT), DDEC, STNRAD(IANT), PARM(3),
     *   PARM(1), PARM(2), PARM(4), PARM(5), PARM(6), PDLY, DPDLY)
C                                       Atmospheric group delay
      IF (CLRECR(ATMCL).NE.FBLANK) CLRECR(ATMCL) = CLRECR(ATMCL) - PDLY
C                                       Atmospheric group delay rate
      IF (CLRECR(DATMCL).NE.FBLANK) CLRECR(DATMCL) = CLRECR(DATMCL) -
     *   DPDLY
      IF (ISTOK.EQ.2) GO TO 650
      DO 600 I = BIF,EIF
         FQFAC = (FREQS+FRQOFF(I)) * PDLY
         ITEMP = FQFAC
         FQFAC = TWOPI * (FQFAC - ITEMP)
         CFAC = COS (FQFAC)
         SFAC = SIN (FQFAC)
C                                       Phase
         XT = CLRECR(RE1CL+I-1)
         YT = CLRECR(IM1CL+I-1)
         IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
            CLRECR(RE1CL+I-1) = XT * CFAC - YT * SFAC
            CLRECR(IM1CL+I-1) = XT * SFAC + YT * CFAC
            END IF
C                                       Delay
         IF (CLRECR(DE1CL+I-1).NE.FBLANK)
     *      CLRECR(DE1CL+I-1) = CLRECR(DE1CL+I-1) + PDLY
C                                       Phase rate
         IF (CLRECR(RA1CL+I-1).NE.FBLANK)
     *      CLRECR(RA1CL+I-1) = CLRECR(RA1CL+I-1) + DPDLY
 600     CONTINUE
 650     IF (ABS(ISTOK).EQ.1) GO TO 999
      DO 700 I = BIF,EIF
         FQFAC = (FREQS+FRQOFF(I)) * PDLY
         ITEMP = FQFAC
         FQFAC = TWOPI * (FQFAC - ITEMP)
         CFAC = COS (FQFAC)
         SFAC = SIN (FQFAC)
C                                       Phase
         XT = CLRECR(RE2CL+I-1)
         YT = CLRECR(IM2CL+I-1)
         IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
            CLRECR(RE2CL+I-1) = XT * CFAC - YT * SFAC
            CLRECR(IM2CL+I-1) = XT * SFAC + YT * CFAC
            END IF
C                                       Delay
         IF (CLRECR(DE2CL+I-1).NE.FBLANK)
     *      CLRECR(DE2CL+I-1) = CLRECR(DE2CL+I-1) + PDLY
C                                       Phase rate
         IF (CLRECR(RA2CL+I-1).NE.FBLANK)
     *      CLRECR(RA2CL+I-1) = CLRECR(RA2CL+I-1) + DPDLY
 700     CONTINUE
C
 999  RETURN
      END
      REAL FUNCTION POLYN (NTERMS, ARG, COEF)
C-----------------------------------------------------------------------
C   Evaluates a polynomial function.
C    Inputs:
C     NTERMS    I    Number of terms (coefficients).
C     ARG       R    Argument of polynomial expansion.
C     COEF(*)   R    Coefficients.
C-----------------------------------------------------------------------
      INTEGER   NTERMS
      REAL      ARG, COEF(*)
C
      INTEGER   LOOP
      REAL      TEMP, SUM
C-----------------------------------------------------------------------
      SUM = COEF(1)
      TEMP = 1.0
      DO 100 LOOP = 2,NTERMS
         TEMP = TEMP * ARG
         SUM = SUM + COEF(LOOP) * TEMP
 100     CONTINUE
      POLYN = SUM
C
 999  RETURN
      END
      SUBROUTINE CLOKER (IERR)
C-----------------------------------------------------------------------
C   Routine to correct effects of clock error.
C   Corrections are applied to the CL record in Common.
C   Control info from common:
C    PARM(*)  R    (1) = Rate error (sec/sec)
C                  (2) = Clock error at t0 (sec)
C                  (3) = t0 (days)
C                  (4) = correction mode
C                        0 = rate correction added
C                        1 = rate + offset correction added
C                        2 = rate and offset replace table values.
C    ISTOK    I    Polarization to correct, 1=first, 2=second, 0 = both
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   LSTSOU, THSOU, LUN, I
      REAL      XT, YT, CFAC, SFAC, FQFAC, GDELAY, DGDELY, OLDDEL
      DOUBLE PRECISION    FREQS, CLTIME
      INCLUDE 'DFCOR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA LUN /30/
C-----------------------------------------------------------------------
      CONTINUE
      LSTSOU = PARM(12) + 0.5
      THSOU = CLRECI(SOUCL)
      IF (LSTSOU.NE.THSOU) THEN
C                                       Get source info
         CALL GETSOU (THSOU, DISKIN, CNOIN, CATBLK, LUN, IERR)
         IF (IERR.NE.0) GO TO 999
         PARM(12) = THSOU
         FREQS = FREQ + FREQO(BIF)
         END IF
      CLTIME = CLRECD(TIMCL)
      GDELAY = ((CLTIME - PARM(3)) * 86400.0 * PARM(1)) + PARM(2)
      DGDELY = PARM(1)
C                                       Clock
      IF (CLRECR(CLK1CL).NE.FBLANK) THEN
         IF (BPARM(7).NE.2) THEN
            CLRECR(CLK1CL) = CLRECR(CLK1CL) - GDELAY
            CLRECR(DCK1CL) = CLRECR(DCK1CL) - DGDELY
         ELSE IF (BPARM(7).EQ.2) THEN
            CLRECR(CLK1CL) = -GDELAY
            CLRECR(DCK1CL) = -DGDELY
            END IF
         END IF
      DO 100 I = BIF,EIF
         FQFAC = -TWOPI * (FREQS+FRQOFF(I)) * GDELAY
         CFAC = COS (FQFAC)
         SFAC = SIN (FQFAC)
C                                       Phase
         XT = CLRECR(RE1CL+I-1)
         YT = CLRECR(IM1CL+I-1)
         IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
            CLRECR(RE1CL+I-1) = XT * CFAC - YT * SFAC
            CLRECR(IM1CL+I-1) = XT * SFAC + YT * CFAC
            END IF
C                                       Delay
         IF (CLRECR(DE1CL+I-1).NE.FBLANK) THEN
            OLDDEL = CLRECR(DE1CL+I-1)
            IF (BPARM(7).NE.2) THEN
               CLRECR(DE1CL+I-1) = CLRECR(DE1CL+I-1) + GDELAY
            ELSE IF (BPARM(7).EQ.2) THEN
               CLRECR(DE1CL+I-1) = GDELAY
            END IF
         END IF
 100     CONTINUE
      IF (ISTOK.EQ.1) GO TO 999
C                                       Clock error.
      IF (CLRECR(CLK2CL).NE.FBLANK) THEN
         IF (BPARM(7).NE.2) THEN
            CLRECR(CLK2CL) = CLRECR(CLK2CL) - GDELAY
            CLRECR(DCK2CL) = CLRECR(DCK2CL) - DGDELY
         ELSE IF (BPARM(7).EQ.2) THEN
            CLRECR(CLK2CL) = -GDELAY
            CLRECR(DCK2CL) = -DGDELY
            END IF
         END IF
      DO 200 I = BIF,EIF
         FQFAC = -TWOPI * (FREQS + FRQOFF(I)) * GDELAY
         CFAC = COS (FQFAC)
         SFAC = SIN (FQFAC)
C                                       Phase
         XT = CLRECR(RE2CL+I-1)
         YT = CLRECR(IM2CL+I-1)
         IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
            CLRECR(RE2CL+I-1) = XT * CFAC - YT * SFAC
            CLRECR(IM2CL+I-1) = XT * SFAC + YT * CFAC
            END IF
C                                       Delay
         IF (CLRECR(DE2CL+I-1).NE.FBLANK) THEN
            OLDDEL = CLRECR(DE2CL+I-1)
            IF (BPARM(7).NE.2) THEN
               CLRECR(DE2CL+I-1) = CLRECR(DE2CL+I-1) + GDELAY
            ELSE IF (BPARM(7).EQ.2) THEN
               CLRECR(DE2CL+I-1) = GDELAY
            END IF
         END IF
 200     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE FARADA (IERR)
C-----------------------------------------------------------------------
C   Routine to determine and correct ionospheric Faraday rotation.
C   Corrections are applied to the CL record in Common.
C   Control info from common:
C    PARM(*)  R    (1) = Electron density model type.
C                        1 = Chiu, PARM(3) = Zurich Sunspot number,
C                                  PARM(4) = annual time (months).
C                  (2) = Last source ID number
C   Output:
C      IERR   I    Return error code, 0=OK
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   LSTSOU, THSOU, LUN, IANT, I
      REAL      XT, YT, XXT, YYT, PDLY(2), DPDLY(2), ZA, ARG, HA, ELV,
     *   GDLY(2), DGDLY(2), GDLYIF,PDLYIF, DGDLYI, DPDLYI, AZ, FR,
     *   DELDT, TIME
      DOUBLE PRECISION HRANG, DARG, FREQS, SINLAT, COSLAT, TIMED, DRA,
     *   DDEC
      LOGICAL   ISPLNT
      INCLUDE 'DFCOR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA LUN /30/
C-----------------------------------------------------------------------
      LSTSOU = PARM(2) + 0.5
      THSOU = CLRECI(SOUCL)
      TIMED = CLRECD(TIMCL)
      TIME = TIMED
C                                       get source info
      CALL FNDCOO (0, JD0, THSOU, DISKIN, CNOIN, CATBLK, LUN, TIME,
     *   DRA, DDEC, ISPLNT, IERR)
      IF (IERR.NE.0) GO TO 999
      PARM(2) = THSOU
      FREQS = FREQ + FREQO(BIF)
      SINDEC = SIN (DDEC)
      COSDEC = COS (DDEC)
      IANT = CLRECI(ANTCL)
C                                       Local apparent position and
C                                       derivitive.
      CALL COOELV (IANT, TIMED, DRA, DDEC, HA, ELV, AZ)
      HRANG = HA
      ZA = (1.570796327 - ELV)
      COSLAT = COS (STNLAT(IANT))
      SINLAT = SIN (STNLAT(IANT))
      DARG = SINLAT * SINDEC + COSLAT * COSDEC * COS (HRANG)
      DELDT = -(1.0 / SQRT (1.0 - DARG*DARG)) * COSLAT * COSDEC * SIN
     *   (HRANG) * TWOPI / 86400.0
      AZ = ATAN2 (-COSDEC*SIN (HRANG),
     *   (SINDEC*COSLAT - COSDEC*COS (HRANG)*SINLAT))
C                                       Compute Faraday rotation
      CALL FAROT (CLRECD(TIMCL), STNLAT(IANT), STNLON(IANT),
     *   STNRAD(IANT), AZ, ELV, DELDT, PARM, FR, PDLY, GDLY, DPDLY,
     *   DGDLY)
C                                       Apply corrections
C                                       Polarization 1 corrections:
      IF (ISTOK.NE.2) THEN
C                                       Dispersive delay=phase delay at
C                                       1 m wavelength
         IF (CLRECR(DIS1CL).NE.FBLANK) CLRECR(DIS1CL) = CLRECR(DIS1CL) -
     *      PDLY(1) / (2.997925E8 ** 2)
         IF (CLRECR(DDS1CL).NE.FBLANK) CLRECR(DDS1CL) = CLRECR(DDS1CL) -
     *      DPDLY(1) / (2.997925E8 ** 2)
         DO 100 I = BIF,EIF
C                                       Following for RCP
            GDLYIF = GDLY(1) / ((FREQS + FRQOFF(I)) ** 2)
            PDLYIF = PDLY(1) / ((FREQS + FRQOFF(I)) ** 2)
            DGDLYI = DGDLY(1) / ((FREQS + FRQOFF(I)) ** 2)
            DPDLYI = DPDLY(1) / ((FREQS + FRQOFF(I)) ** 2)
            CLRECR(RA1CL+I-1) = CLRECR(RA1CL+I-1) + DPDLYI
            CLRECR(DE1CL+I-1) = CLRECR(DE1CL+I-1) + GDLYIF
C***??? SIGN???
            ARG = -FR * ((CLIGHT / (FREQS + FRQOFF(I))) ** 2) +
     *         PDLYIF * TWOPI * (FREQS + FRQOFF(I))
            XT = COS (ARG)
            YT = SIN (ARG)
            XXT = CLRECR(RE1CL+I-1)
            YYT = CLRECR(IM1CL+I-1)
            IF ((XXT.NE.FBLANK) .AND. (YYT.NE.FBLANK)) THEN
               CLRECR(RE1CL+I-1) = XXT*XT - YYT*YT
               CLRECR(IM1CL+I-1) = XXT*YT + YYT*XT
               END IF
 100        CONTINUE
         END IF
C                                       Polarization 2 corrections:
      IF (ISTOK.NE.1) THEN
C                                       Dispersive delay=phase delay at
C                                       1 m wavelength
         IF (CLRECR(DIS2CL).NE.FBLANK) CLRECR(DIS2CL) = CLRECR(DIS2CL) -
     *      PDLY(2) / (2.997925E8 ** 2)
         IF (CLRECR(DDS2CL).NE.FBLANK) CLRECR(DDS2CL) = CLRECR(DDS2CL) -
     *      DPDLY(2) / (2.997925E8 ** 2)
         DO 200 I = BIF,EIF
C                                       Following for LCP
            GDLYIF = GDLY(2) / ((FREQS + FRQOFF(I)) ** 2)
            PDLYIF = PDLY(2) / ((FREQS + FRQOFF(I)) ** 2)
            DGDLYI = DGDLY(2) / ((FREQS + FRQOFF(I)) ** 2)
            DPDLYI = DPDLY(2) / ((FREQS + FRQOFF(I)) ** 2)
            CLRECR(RA2CL+I-1) = CLRECR(RA2CL+I-1) + DPDLYI
            CLRECR(DE2CL+I-1) = CLRECR(DE2CL+I-1) + GDLYIF
C***??? SIGN???
            ARG = FR * ((CLIGHT / (FREQS + FRQOFF(I))) ** 2) +
     *         PDLYIF * TWOPI * (FREQS + FRQOFF(I))
            XT = COS (ARG)
            YT = SIN (ARG)
            XXT = CLRECR(RE2CL+I-1)
            YYT = CLRECR(IM2CL+I-1)
            IF ((XXT.NE.FBLANK) .AND. (YYT.NE.FBLANK)) THEN
C                                       Opposite phase for Pol. 2.
               CLRECR(RE2CL+I-1) = XXT*XT + YYT*YT
               CLRECR(IM2CL+I-1) = -XXT*YT + YYT*XT
               END IF
 200        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE FAROT (TIME, LAT, LONG, RHO, AZ, EL, DELDT, PARM,
     *   FR, PDLY, GDLY, DPDLY, DGDLY)
C-----------------------------------------------------------------------
C   Routine to compute Faraday rotation values from one of various
C   ionospheric models.  Also returns Group and phase delay and
C   derivatives.
C    Inputs:
C     TIME        D    Time in days since 0 iat on reference date
C     LAT         D    Latitude of station (rad)
C     LONG        D    Longitude of station (rad)
C     RHO         D    Distance of station from earth center (m).
C     AZ          R    Azimuth (radians)
C     EL          R    Elevation (radians)
C     DELDT       R    Time derivative of EL (rad/sec)
C     PARM(*)     R    Model dependent parameters
C                      PARM(1) = model type
C                       1.0 = Chiu model
C                             BPARM(3) = Zurich sunspot number
C                             BPARM(4) = Time of year (mo)
C    Output:
C     FR          R    Faraday rotation in rad/m**2
C     PDLY(2)     R    Phase delay correction (poln 1 and 2) in sec *
C                      frequency**2
C     GDLY(2)     R    Group delay correction (poln 1 and 2) in sec *
C                      frequency**2
C     DPDLY(2)    R    Phase delay derivitive correction (sec/sec) *
C                      frequency**2. Assumes constant ionosphere.
C     DGDLY(2)    R    Group delay derivitive correction (sec/sec) *
C                      frequency**2. Assumes constant ionosphere.
C-----------------------------------------------------------------------
      DOUBLE PRECISION    TIME, LAT, LONG, RHO
      REAL      AZ, EL, DELDT, PARM(*), FR, PDLY(2), GDLY(2), DPDLY(2),
     *   DGDLY(2)
C
      REAL      TWOPI, CLIGHT
      PARAMETER (TWOPI = 6.2831853)
      PARAMETER (CLIGHT = 2.997925E8)
      INTEGER   ITYPE
      REAL      PEAKF2, MLAT, MLONG, GLAT, GLONG, ANNTIM, HEIOLD,
     *   LOCTIM, SUNSPT, ZCD, FACT, HEIGHT, MAGFLD, ZAFACT, RAD,
     *   H(3), THICK, PIO2, DZAFDT
      EXTERNAL PEAKF2
C                                       HEIGHT = height of F2 slab in m
C                                       This is modeled in SLABF2
      DATA HEIGHT /0.0/
      DATA PIO2 /1.570796327/
C-----------------------------------------------------------------------
C                                       path length factor
C***??? can do better
      ZAFACT = 1.0 / COS (PIO2 - EL)
C                                       Time derivative
      DZAFDT = -ZAFACT * ZAFACT * SIN (PIO2 - EL) * DELDT
C                                       Initial values
      FR = 0.0
      PDLY(1) = 0.0
      PDLY(2) = 0.0
      GDLY(1) = 0.0
      GDLY(2) = 0.0
      DPDLY(1) = 0.0
      DPDLY(2) = 0.0
      DGDLY(1) = 0.0
      DGDLY(2) = 0.0
C                                       Restart here if need to iterate
C                                       height.
 10   HEIOLD = HEIGHT
C                                       Get lat, long for sub
C                                       ionispheric location.
      FACT = (PIO2 - EL - ASIN ((RHO/(RHO+HEIGHT)) *
     *   COS (EL)))
      GLAT = LAT + COS (AZ) * FACT
      GLONG = LONG + SIN (AZ) * FACT
C                                       Convert to magnetic coordinates.
      CALL MAGCRD (GLAT, GLONG, MLAT, MLONG)
C                                       Branch on model type
      ITYPE = PARM(1) + 0.1
      IF ((ITYPE.LT.1) .OR. (ITYPE.GT.1)) ITYPE = 2
      GO TO (100,750), ITYPE
C                                       Chiu model
C                                       PARM(3) = Sunspot number
C                                       PARM(4) = annual time.
 100     ANNTIM = PARM(4)
         LOCTIM = (TIME * 6.283185308D0) - GLONG
         SUNSPT = PARM(3)
C                                       Find peak height and integral
         CALL SLABF2 (MLAT, ANNTIM, LOCTIM, SUNSPT, THICK, HEIGHT)
C                                       If HEIGHT disagrees with older
C                                       value then redo.
         IF (ABS (HEIGHT-HEIOLD).GT.1.0E4) GO TO 10
C                                       Zenith column density:
C                                       Units = m**-2
         ZCD = PEAKF2 (MLAT, MLONG, ANNTIM, LOCTIM, SUNSPT) * THICK
         GO TO 800
C                                       Unknown model (shouldn't get
C                                       here).
 750     ZCD = 0.0
         GO TO 800
C                                       Magnetic field model
 800  RAD = RHO + HEIGHT
      CALL MAGDIP (GLAT, GLONG, RAD, H)
C                                       Project along line of sight.
      MAGFLD = H(3) * COS (AZ) * COS (EL) +
     *         H(2) * SIN (AZ) * COS (EL) +
     *         H(1) * SIN (EL)
C                                       Faraday rotation, from
C                                       Pacholczyk, Radio Astrophysics,
C                                       1970, p 57 (eq 2.81).
C                                       in Rad/m**2
      FR = 0.93E6 * ZCD * MAGFLD * ZAFACT * 1.0E-4 /
     *   (TWOPI * TWOPI * CLIGHT * CLIGHT)
C                                       Group and Phase delay
C                                       From: Hagfors, Methods of
C                                       Experimental Physics,
C                                       Vol 12 B, Meeks, ed
C***??? is this right???
      PDLY(1) = -40.28 * ZCD * ZAFACT / CLIGHT
      PDLY(2) = PDLY(1)
      DPDLY(1) = -40.28 * ZCD * DZAFDT / CLIGHT
      DPDLY(2) = DPDLY(1)
      GDLY(1) = 40.28 * ZCD * ZAFACT / CLIGHT
      GDLY(2) = GDLY(1)
      DGDLY(1) = 40.28 * ZCD * DZAFDT / CLIGHT
      DGDLY(2) = DPDLY(1)
C
 999  RETURN
      END
      SUBROUTINE MAGCRD (GLAT, GLONG, MLAT, MLONG)
C-----------------------------------------------------------------------
C   MAGCRD converts geographic latitude and longitude into magnetic
C   latitude and longitude. Note that geographic longitude increases to
C   the West while magnetic longitude increases to the East.
C   Inputs:   GLAT     R     geographic latitude (radians)
C             GLONG    R     geographic east-longitude (radians)
C   Outputs:  MLAT     R     magnetic latitude (radians)
C             MLONG    R     magnetic east-longitude (radians)
C   Programmer: C. Flatters, Oct. 1987
C-----------------------------------------------------------------------
      REAL   GLAT, GLONG, MLAT, MLONG
C
      REAL   PI, CMLONG, GLATMP, GLONMP, SMLONG
      PARAMETER (PI = 3.141 592 65)
C                                       Geographic coordinates of
C                                       North magnetic pole.
      PARAMETER (GLATMP = 78.63 * PI / 180)
      PARAMETER (GLONMP = 289.85 * PI / 180)
C-----------------------------------------------------------------------
      MLAT = ASIN (SIN(GLAT) * SIN(GLATMP)
     *             + COS(GLAT) * COS(GLATMP) * COS(GLONG - GLONMP))
      CMLONG = (SIN(GLATMP) * SIN(MLAT) - SIN(GLAT))
     *         / (COS(GLATMP) * COS(MLAT))
      SMLONG = SIN(GLONG - GLONMP) * COS(GLAT) / COS(MLAT)
      MLONG = ATAN2 (SMLONG, CMLONG)
  999 RETURN
      END
      REAL FUNCTION PEAKF2 (MLAT, MLONG, ANNTIM, LOCTIM, SUNSPT)
C-----------------------------------------------------------------------
C   PEAKF2 returns the peak free electron density of the F2-layer in
C   electrons per cubic meter. This is derived from a phenomenological
C   model of the ionosphere (Chiu, J. At. Terr. Phys. 37, 1563; 1975).
C   Some formulae have been corrected according to the code fragment
C   IONDEM published as part of the International Reference Ionosphere
C   IRI-79 (Report UAG-82, 1981).
C   Inputs:
C      MLAT    R    magnetic latitude (radians)
C      MLONG   R    magnetic east-longitude (radians)
C      ANNTIM  R    annual time (months), beginning Dec 15th
C      LOCTIM  R    local time (radians)
C      SUNSPT  R    monthly smoothed Zurich relative sunspot
C                   number
C   Programmer: C. Flatters, Oct. 1987
C-----------------------------------------------------------------------
      REAL   MLAT, MLONG, ANNTIM, LOCTIM, SUNSPT
C
      REAL   ANNFN, BETA, BIGG, DIPFN, DIURNL, EQUATR, FOLD, G, GAMMA,
     *   KAPPA, LATFN, LONGFN, LPRIME, MAGDIP, NONPLR, PI, POLAR, PSI,
     *   Q, RHO, SIGMA, SOLAR, SOLDEC, TILT, W, X, XLONG, Y, ZETA
      EXTERNAL GAMMA, PSI
      PARAMETER (PI = 3.141 592 65)
      PARAMETER (TILT = -23.5 * PI / 180)
C-----------------------------------------------------------------------
C                                     Calculate magnetic dip angle.
      MAGDIP = ATAN (2 * SIN(MLAT) / COS(MLAT))
C                                     Calculate solar declination angle
      SOLDEC = ASIN (0.39795 * SIN (PI/6 * (ANNTIM - 3.167)))
C                                     Calculate the seasonal anomoly
C                                     parameter zeta.
      ZETA = SIN(SOLDEC) * SIN(MLAT)
C                                     Normalize sunspot number.
      RHO = SUNSPT / 100
C                                     Calculate the layer peak function.
C                                     This consists of a polar function
C                                     folded with a non-polar function.
C                                     The polar function dominates at
C                                     high latitudes while the non-polar
C                                     function dominates for lower
C                                     latitudes.
C                                     First calculate the folding factor
      FOLD = EXP (-1 * ((2.4 + (0.4 + 0.1*RHO) * SIN(MLAT)) ** 6)
     *   * COS(MLAT) ** 6)
C                                     Now the polar function. This is
C                                     omitted from Chiu's paper and has
C                                     been reconstructed from a program
C                                     fragment printed in Report UAG-82
C                                     (IRI-79).
      IF (MLAT.GE.0.0) THEN
         POLAR = (2 + 1.2 * RHO) * (1 + 0.3 * SIN (PI/12 * ANNTIM))
     *      * EXP(-1.2*(COS(MLAT + TILT * COS(LOCTIM)) - COS(MLAT)))
      ELSE
         XLONG = SIN(PI/12 * ANNTIM) * (0.5 * SIN(MLONG/2)
     *      - 0.5 * SIN(MLONG) - (MLONG/2)**8) - (1 + SIN(PI/12 *
     *      ANNTIM)) * COS(PI/6 * ANNTIM) * SIN(MLONG) /
     *      SQRT(ABS(SIN(MLONG))) * EXP (-4 * SIN(MLONG/2)**2)
         POLAR = (1 + 0.4 * (1 - SIN(PI/12 * ANNTIM)**2)
     *      * EXP(-1 * COS(MLONG/2 - PI/20)**4 * SIN(PI/12 * ANNTIM)))
     *      * (2.5 + 2 * RHO + COS(PI/6 * ANNTIM) * (0.5 + (1.3 + 0.2 *
     *      RHO) * COS(MLONG/2 - PI/20)**4) + (1.3 + 0.5 * RHO) *
     *      COS(LOCTIM - PI * (1 + XLONG)))
         END IF
C                                     The non-polar function is the
C                                     product of a solar cycle function,
C                                     a diurnal function, a latitudinal
C                                     function, an annual function, an
C                                     equatorial anomoly function, a
C                                     longitudinal function and a
C                                     magnetic dip function.
C                                     First the solar cycle function.
      SIGMA = 1 + RHO + 0.204 * RHO**2 + 0.03 * RHO**3
      IF (RHO.LE.1.1) THEN
         SOLAR = SIGMA
      ELSE
         SOLAR = 2.39 + 1.53 * (SIGMA - 2.39) * SIN(MLAT)**2
         END IF
C                                     The diurnal function.
      DIURNL = (0.9 + 0.32 * ZETA)
     *      * (1 + ZETA * COS(LOCTIM - PI/4)**2)
     *      * EXP(-1.1 * (1 + COS (LOCTIM - 0.873)))
C                                     The latitudinal function.
      LPRIME = EXP(3.0 * COS(MLAT/2 * (SIN(LOCTIM) - 1)))
      Q = 1 - 0.15 * EXP(-1 * SQRT((12 * MLAT + 4*PI/3) ** 2
     *   + (ANNTIM/2 - 3) ** 2))
      LATFN = (1.2 - 0.5 * COS(MLAT)**2)
     *   * (1 + 0.05 * RHO * SIN(MLAT)**3
     *   * COS(PI/6 * ANNTIM)) * LPRIME * Q
C                                     The annual function.
      BETA = 1.3 + 0.278 * RHO ** 2 * COS(0.5 * (MLAT - PI/4)) ** 2
     *   + 0.051 * RHO ** 3
      W = EXP (-BETA * (COS(PSI(MLAT, LOCTIM, SOLDEC)) - COS(MLAT)))
      KAPPA = 1 + 0.085 * (COS(MLAT - PI/6)
     *   * COS(PI/12 * (ANNTIM - 2)) ** 3
     *   + COS (MLAT + PI/4) * COS(PI/12 * (ANNTIM - 8)) ** 2)
      X = 0.7 * (KAPPA + 0.178 * RHO**2
     *   * COS(PI/3 * (ANNTIM - 4.3)) / SOLAR) * W
      Y = 0.2 * (1 - SIN(ABS(MLAT) - PI/6))
     *   * (1 + 0.6 * COS(PI/3 * (ANNTIM - 3.94)))
     *   * COS(PI/6 * (ANNTIM - 1))
     *   + (0.13 - 0.06 * SIN(ABS(ABS(MLAT) - PI/9)))
     *   * COS(PI/3 * (ANNTIM - 4.5))
     *   - (0.15 + 0.3 * SIN(ABS(MLAT)))
     *   * (1 - COS(LOCTIM)) ** 0.25
     *   * COS(PSI(MLAT, 0.0, SOLDEC)) ** 3
      ANNFN = X + Y/SOLAR
C                                       The equatorial function.
      BIGG = (1 + 0.6 * SQRT(RHO) - 0.2 * RHO)
     *   * EXP (0.25 * (1 + COS(LOCTIM - 0.873)))
     *   * COS(MLAT)**8 * COS(ABS(MLAT) - 0.2618)**12
      EQUATR = GAMMA(0.05, 0.5, ANNTIM)
     *   * (1 + BIGG) * (1 - 0.4 * COS(MLAT) ** 10)
     *   * (1 + 0.6 * COS(MLAT)**10 * COS(ANNTIM - PI/4)**2)
C                                       The longitudinal function.
      LONGFN = 1 + 0.1 * COS(MLAT)**3
     *   * COS(2 * (MLONG - 7*PI/18))
      G = 0.15 - (1 + RHO) * SIN(MLAT/2)**2
     *   * EXP (-0.33 * (ANNTIM - 6)**2)
C                                       The dip function.
      DIPFN = GAMMA(0.03, 0.5, ANNTIM)
     *   * (1 + G * EXP (-18 * (ABS(MAGDIP) - 2*PI/9)**2))
C                                       Now everything can be put
C                                       together.
      NONPLR = SOLAR * DIURNL * LATFN * ANNFN * EQUATR * LONGFN
     *   * DIPFN
      PEAKF2 = 0.66E11 * (FOLD * POLAR + (1 - FOLD) * NONPLR)
  999 RETURN
C-----------------------------------------------------------------------
      END
      REAL FUNCTION PSI (XI, ETA, SDEC)
C-----------------------------------------------------------------------
C PSI is the seasonal anomoly parameter psi(xi,eta). Psi(lat, pi) is
C the solar zenith angle at noon.
C
C Inputs:   XI       R     dummy variable
C           ETA      R     dummy variable
C           SDEC     R     solar declination angle (radians)
C   Programmer: C. Flatters, Oct. 1987
C-----------------------------------------------------------------------
      REAL   XI, ETA, SDEC
C-----------------------------------------------------------------------
      PSI = XI + SDEC * COS (ETA)
  999 RETURN
C
      END
      SUBROUTINE SLABF2 (MLAT, ANNTIM, LOCTIM, SUNSPT, THICK, HEIGHT)
C-----------------------------------------------------------------------
C   SLABF2 returns the slab thickness of the F2-layer according to a
C   phenomenological model of the ionosphere (Chiu, J. At. Terr. Phys.
C   37, 1563; 1975) in meters and the effective height of the slab.
C   Inputs:
C    MLAT    R    magnetic latitude (radians)
C    ANNTIM  R    annual time (months), beginning Dec 15th
C    LOCTIM  R    local time (radians)
C    SUNSPT  R    monthly smoothed Zurich relative sunspot
C                 number
C   Outputs:
C    THICK   R    Effective thickness of slab (m).
C    HEIGHT  R    Effective height of the slab (m).
C   Programmer: C. Flatters, Oct. 1987
C-----------------------------------------------------------------------
      REAL      MLAT, ANNTIM, LOCTIM, SUNSPT, THICK, HEIGHT
C
      INTEGER   ALT, I, UPLIM
      REAL      STEP
C                                     Integration step (km).
      PARAMETER (STEP = 1.0)
C                                     Upper limit for integration
C                                     (units of STEP)
      PARAMETER (UPLIM = 1024)
      REAL   ALTPK, PI, PROF, R, RHO, SOLDEC, ZETA
      PARAMETER (PI = 3.141 592 65)
C-----------------------------------------------------------------------
C                                     Calculate the solar declination
C                                     angle.
      SOLDEC = ASIN (0.39795 * SIN (PI/6 * (ANNTIM - 3.167)))
C                                     Calculate the seasonal anomoly
C                                     parameter zeta.
      ZETA = SIN(SOLDEC) * SIN(MLAT)
C                                     Normalize sunspot number.
      RHO = SUNSPT / 100
C                                     The altitude of the layer peak
C                                     must be calculated before
C                                     integrating the layer profile
      ALTPK = 240 + 75 * RHO + 83 * RHO * ZETA * COS(MLAT)
     *   + COS(LOCTIM - 4.5 * ABS(MLAT) - PI)
     *   + 10 * COS(MLAT) * COS(PI/3 * (ANNTIM - 4.5))
C                                       Now integrate over the profile.
C                                       Simpson's method is used. Most
C                                       vector compilers should
C                                       vectorize this loop.
      THICK = 0.0
      DO 10 I = 1, UPLIM
         ALT = I * STEP
         IF (ALT.GE.ALTPK) THEN
            R = (ALT - ALTPK) / (40 + 0.2 * ALTPK)
         ELSE
            R = (ALT - ALTPK) / (40 + 0.2 * ALT)
            END IF
         IF ((I.EQ.1) .OR. (I.EQ.UPLIM)) THEN
            PROF = 2.0/3.0 * EXP(1 - R - EXP(-R)) * 1000
         ELSE IF (MOD(I, 2).EQ.0) THEN
            PROF = 2.0 * 2.0/3.0 * EXP(1 - R - EXP(-R)) * 1000
         ELSE
            PROF = 4.0 * 2.0/3.0 * EXP(1 - R - EXP(-R)) * 1000
            END IF
         THICK = THICK + PROF
   10 CONTINUE
C                                       Effective height
      HEIGHT = ALTPK * 1000.0
  999 RETURN
C-----------------------------------------------------------------------
      END
      REAL FUNCTION GAMMA (A, B, ANNTIM)
C-----------------------------------------------------------------------
C   GAMMA returns the gamma function used in the Chiu ionosphere model.
C    Inputs:
C          A        R       dummy parameter
C          B        R       dummy parameter
C          ANNTIM   R       annual time (months), beginning Dec 15th
C   Programmer: C. Flatters, Oct. 1987
C-----------------------------------------------------------------------
      REAL   A, B, ANNTIM
C
      REAL   PI
      PARAMETER (PI = 3.141 592 65)
C-----------------------------------------------------------------------
      GAMMA = 1 + A * (B - COS (PI/3 * ANNTIM) + COS (PI/6 * ANNTIM))
  999 RETURN
      END
      SUBROUTINE MAGDIP (GLAT, GLONG, RADIUS, H)
C-----------------------------------------------------------------------
C   Routine to compute the earth's magnetic field strength from an
C   offset dipole model.  Adapted from Handbook of Geophysics and Space
C   Envirnoments (circa 1965) S. L. Valley ed. Air Force Cambridge
C   Research Laboratories and Chapman and Bartels, 1940, GEOPHYSICS,
C   Oxford)
C      NOTE: The Gaussian coefficients from Chapman and Bartels give
C   a slightly better representation of the field than Valley so these
C   values are used here.
C      Values of H returned are probably good to better than 20%.
C   At the VLA the model is 6% low in total intensity and 11 deg W in
C   magnetic declination.
C    Inputs:
C     GLAT    R    Geocentric latitude (radians)
C     GLONG   R    Geocentric EAST longitude (radians)
C     RADIUS  R    Distance from the center of the earth (m)
C    Output:
C     H(3)    R    Magnetic field vector (gauss),
C                  (1) = positive away from earth center,
C                  (2) = positive east,
C                  (3) = positive north.
C-----------------------------------------------------------------------
      REAL    GLAT, GLONG, RADIUS, H(3)
C
      REAL    RE, FACT, GLATMP, GLONMP, PI,H02, L0, L1, L2, E, SQRT3,
     *   G10, G11, G20, G21, G22, H11, H21, H22, X0, Y0, Z0
      PARAMETER (PI = 3.14159265)
C                                       Geographic coordinates of
C                                       North magnetic pole.
      PARAMETER (GLATMP = 78.63 * PI / 180)
      PARAMETER (GLONMP = 289.85 * PI / 180)
C                                       Gaussian coefficients(gauss):
C                                       From Handbook of Geophysics...
C                                       Epoch 1960.
C                                       Modified??????
C      PARAMETER (G10 = -0.30509)
C      PARAMETER (G11 = -0.02181/2.0)
C      PARAMETER (G20 = -0.02196/2.0)
C      PARAMETER (G21 =  0.05145/3.0)
C      PARAMETER (G22 =  0.01448/4.0)
C      PARAMETER (H11 =  0.05841/2.0)
C      PARAMETER (H21 = -0.03443/3.0)
C      PARAMETER (H22 =  0.00172/4.0)
C                                       Chapman values Epoch 1922
      PARAMETER (G10 = -.3095)
      PARAMETER (G11 = -.0226)
      PARAMETER (G20 = -.0067)
      PARAMETER (G21 = 0.0292)
      PARAMETER (G22 = 0.0143)
      PARAMETER (H11 = 0.0592)
      PARAMETER (H21 = -.0122)
      PARAMETER (H22 = 0.0113)
C                                       SQRT3 = sqrt (3.0)
      PARAMETER (SQRT3 = 1.732050808)
C                                       Compute dipole center in units
C                                       of earth radius.
      PARAMETER (H02 = G10*G10 + G11*G11 + H11*H11)
      PARAMETER (L0  = 2.0*G10*G20 + (G11*G21 + H11*H21) * SQRT3)
      PARAMETER (L1  = -G11*G20 + (G10*G21+G11*G22+H11*H22) * SQRT3)
      PARAMETER (L2 = -H11*G20 + (G10*H21-H11*G22+G11*H22) * SQRT3)
      PARAMETER (E = (L0*G10 + L1*G11 + L2*H11) / (4.0*H02))
      PARAMETER (X0 = (L1 - G11*E) / (3.0*H02))
      PARAMETER (Y0 = (L2 - H11*E) / (3.0*H02))
      PARAMETER (Z0 = (L0 - G10*E) / (3.0*H02))
      REAL   X0M, Y0M, Z0M, HMAG, HD(3), CLA, SLA, CLO, SLO
      DOUBLE PRECISION POS0(3), POS1(3), POSTMP(3), POST2(3), RADDIP,
     *   COLAT, LONDIP, CA, SA, CB, SB
C                                       RE = Radius of earth (avg polar
C                                       and equitorial)
      DATA RE /6367650.0/
C-----------------------------------------------------------------------
C                                       Center of dipole
      X0M = X0 * RE
      Y0M = Y0 * RE
      Z0M = Z0 * RE
C                                       Convert to earth center x,y,z
C                                       Here y=> 90 e long.
      POS0(1) = RADIUS * COS (GLAT) * COS (GLONG)
      POS0(2) = RADIUS * COS (GLAT) * SIN (GLONG)
      POS0(3) = RADIUS * SIN (GLAT)
C                                       Translate
      POSTMP(1) = POS0(1) - X0M
      POSTMP(2) = POS0(2) - Y0M
      POSTMP(3) = POS0(3) - Z0M
C                                       Rotate to dipole coord.
      CA = COS (GLONMP)
      SA = SIN (GLONMP)
      CB = SIN (GLATMP)
      SB = -COS (GLATMP)
      POST2(1) = (POSTMP(1)*CA + POSTMP(2)*SA) * CB +
     *   POSTMP(3) * SB
      POST2(2) = POSTMP(2) * CA - POSTMP(1) * SA
      POST2(3) = POSTMP(3) * CB - SB * (POSTMP(1)*CA + POSTMP(2)*SA)
C                                       Polar coordinates in dipole.
      RADDIP = SQRT (POST2(1)*POST2(1) + POST2(2)*POST2(2) +
     *   POST2(3)*POST2(3))
      COLAT = ACOS (POST2(3) / RADDIP)
      LONDIP = ATAN2 (POST2(2), POST2(1))
      CLA = SIN (COLAT)
      SLA = COS (COLAT)
      CLO = COS (LONDIP)
      SLO = SIN (LONDIP)
C                                       Terms of dipole, local
      FACT = SQRT (H02) * ((RE / RADDIP) ** 3)
      H(1) = -2.0 * FACT * COS (COLAT)
      H(2) = 0.0
      H(3) = FACT * SIN (COLAT)
C                                       Rotate to dipole centered
      HD(1) = (H(1)*CLA - H(3)*SLA) * CLO - H(2) * SLO
      HD(2) = H(2) * CLO + (H(1)*CLA - H(3)*SLA) * SLO
      HD(3) = H(3) * CLA + H(1) * SLA
C                                       Modulus of HD
      HMAG = SQRT (HD(1)*HD(1) + HD(2)*HD(2) + HD(3)*HD(3))
C                                       Find position 1 km from
C                                       position in the direction of HD.
      POST2(1) = POST2(1) + 1000.0 * HD(1) / HMAG
      POST2(2) = POST2(2) + 1000.0 * HD(2) / HMAG
      POST2(3) = POST2(3) + 1000.0 * HD(3) / HMAG
C                                       Rotate new position to earth
C                                       system.
      POSTMP(1) = (POST2(1)*CB - POST2(3)*SB) * CA - POST2(2) * SA
      POSTMP(2) = POST2(2) * CA + (POST2(1)*CB - POST2(3)*SB) * SA
      POSTMP(3) = POST2(3) * CB + POST2(1) * SB
C                                       Translate to earth center
      POS1(1) = POSTMP(1) + X0M
      POS1(2) = POSTMP(2) + Y0M
      POS1(3) = POSTMP(3) + Z0M
C                                       Earth centered field
      HD(1) = (POS1(1) - POS0(1)) * 0.001 * HMAG
      HD(2) = (POS1(2) - POS0(2)) * 0.001 * HMAG
      HD(3) = (POS1(3) - POS0(3)) * 0.001 * HMAG
C                                       Earth local field
      CLA = COS (GLAT)
      SLA = SIN (GLAT)
      CLO = COS (GLONG)
      SLO = SIN (GLONG)
      H(1) = (HD(1)*CLO + HD(2)*SLO) * CLA + HD(3) * SLA
      H(2) = HD(2) * CLO - HD(1) * SLO
      H(3) = HD(3) * CLA - (HD(1)*CLO + HD(2)*SLO) * SLA
C
 999  RETURN
      END
      SUBROUTINE ANTPOS (IERR)
C-----------------------------------------------------------------------
C   Routine to correct for errors in antenna and source position.
C   Corrections are applied to the CL record in Common.
C   Control info from common:
C      PARM(*)  R    (1) = "X" correction (m)
C                    (2) = "Y" correction (m)
C                    (3) = "Z" correction (m)
C                    (4) = 1 if RH, -1 if LH coordinates
C                    (5) = Last source ID number
C                    (6) = RA correction (radians)
C                    (7) = Declination correction (radians)
C                    (8) = 0 for VLBI; > 0 for VLA
C      ISTOK    I    Polarization to correct, 1=first, 2=second,
C                    0 = both
C   Output:
C      IERR     I    Return error code , 0=OK else failed.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   LSTSOU, THSOU, LUN, I, ITEMP, IANT
      REAL      XT, YT, CFAC, SFAC, FQFAC, EL, TIME
      DOUBLE PRECISION CHAD, SHAD, HA, HAD, TIMED, PRA, PDEC, FREQS,
     *   CIR, X, Y, Z, DELAYC, RATEC, DDEC, DRA, CI, RADSEC, DELAY,
     *   RATE, PDLY, DPDLY, HRANG, PII, TWOPII, SIND, COSD
      LOGICAL   ISPLNT
C                                       CI = 1/speed of light
      PARAMETER (CI = 1.0D0 / 2.997925D8)
C                                       RADSEC = earth rot rate in
C                                       rad/sec.
      PARAMETER (RADSEC = 3.1415926535897932384D0 / 43200.0D0)
      INCLUDE 'DFCOR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      SAVE  FREQS
      DATA LUN /30/
      DATA PII /3.141592653589793D0/, TWOPII /6.283185307179586D0/
C-----------------------------------------------------------------------
      LSTSOU = PARM(5) + 0.5
      THSOU = CLRECI(SOUCL)
      TIMED = CLRECD(TIMCL)
      TIME = TIMED
C                                       Get source info
      CALL FNDCOO (0, JD0, THSOU, DISKIN, CNOIN, CATBLK, LUN, TIME,
     *   PRA, PDEC, ISPLNT, IERR)
      IF (IERR.NE.0) GO TO 999
      PARM(5) = THSOU
      FREQS = FREQ + FREQO(BIF)
C                                       Declination
      SINDEC = SIN (PDEC)
      COSDEC = COS (PDEC)
C                                       Get local Hour angle
      IANT = CLRECI(ANTCL)
C                                       HA is double precision im the
C                                       SOUEL output
      CALL CSOUEL (IANT, TIMED, DRA, DDEC, HA, EL)
C                                       Get Greenwich hour angle
C                                       for VLBI and stay local one
C                                       for VLA
      IF ((ABS(ARRAYC(1)).LT.1.D2) .AND. (ABS(ARRAYC(2)).LT.1.D2) .AND.
     *   (ABS(ARRAYC(3)).LT.1.D2)) THEN
         HRANG = HA - STNLON(IANT)
         HRANG = DMOD (HRANG, TWOPII)
         IF (HRANG.GT. PII) HRANG = HRANG - TWOPII
         IF (HRANG.LT.-PII) HRANG = HRANG + TWOPII
         HA = HRANG
         END IF
C---------------------------------
      HAD = HA
      CHAD = COS (HAD)
      SHAD = SIN (HAD)
C                                       Antenna coordinates:
C                                       correct for handedness of
C                                       coordinates.
      X = STNX(IANT)
      Y = STNY(IANT)
      Z = STNZ(IANT)
      CIR = CI * RADSEC
C                                       Delay and rate in sec and
C                                       sec/sec. (want corrections).
C                                       The formulae are written
C                                       at the Right Hand coordinate
C                                       system.
C                                       not corrected delay and rate
      DELAY = CI * ((X * CHAD - Y * SHAD) * COSDEC + Z * SINDEC)
      RATE = CIR * (-X * SHAD - Y * CHAD) * COSDEC
C                                       correcte antenna coordinates
      X = X + PARM(1)
      Y = Y + PARM(2)
      Z = Z + PARM(3)
C                                       Source position error in RA
C                                       direction at the picture plane
      DRA = 0.0
      IF (COSDEC.NE.0.0) DRA = PARM(6) / COSDEC
C                                       Source position error in
C                                       declination direction
      DDEC = PARM(7)
C                                       correct hour angle
      CHAD = COS (HAD - DRA)
      SHAD = SIN (HAD - DRA)
C                                       correct declination
      SIND = SIN (PDEC + DDEC)
      COSD = COS (PDEC + DDEC)
C                                       corrected delay and rate
      DELAYC = CI * ((X * CHAD - Y * SHAD) * COSD + Z * SIND)
      RATEC = CIR * (-X * SHAD - Y * CHAD) * COSD
C                                       correction of delay and rate
      PDLY = DELAYC - DELAY
      DPDLY = RATEC - RATE
C                                       Correct CL record
C                                       Geometric delay (2 terms)
      IF (CLRECD(GDLCL).NE.DBLANK) CLRECD(GDLCL) = CLRECD(GDLCL) - PDLY
C                                       Second term
      IF ((CLNUMV(CLDDEL).GE.2) .AND. (CLRECD(GDLCL+1).NE.DBLANK))
     *   CLRECD(GDLCL+1) = CLRECD(GDLCL+1) - DPDLY
      IF (ISTOK.EQ.2) GO TO 650
      DO 600 I = BIF,EIF
         FQFAC = (FREQS+FRQOFF(I)) * PDLY
         ITEMP = FQFAC
         FQFAC = TWOPI * (FQFAC - ITEMP)
         CFAC = COS (FQFAC)
         SFAC = SIN (FQFAC)
C                                       Phase
         XT = CLRECR(RE1CL+I-1)
         YT = CLRECR(IM1CL+I-1)
         IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
            CLRECR(RE1CL+I-1) = XT * CFAC - YT * SFAC
            CLRECR(IM1CL+I-1) = XT * SFAC + YT * CFAC
            END IF
C                                       Delay
         IF (CLRECR(DE1CL+I-1).NE.FBLANK)
     *      CLRECR(DE1CL+I-1) = CLRECR(DE1CL+I-1) + PDLY
C                                       Phase rate
         IF (CLRECR(RA1CL+I-1).NE.FBLANK)
     *      CLRECR(RA1CL+I-1) = CLRECR(RA1CL+I-1) + DPDLY
 600     CONTINUE
 650     IF (ISTOK.EQ.1) GO TO 999
      DO 700 I = BIF,EIF
         FQFAC = (FREQS+FRQOFF(I)) * PDLY
         ITEMP = FQFAC
         FQFAC = TWOPI * (FQFAC - ITEMP)
         CFAC = COS (FQFAC)
         SFAC = SIN (FQFAC)
C                                       Phase
         XT = CLRECR(RE2CL+I-1)
         YT = CLRECR(IM2CL+I-1)
         IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
            CLRECR(RE2CL+I-1) = XT * CFAC - YT * SFAC
            CLRECR(IM2CL+I-1) = XT * SFAC + YT * CFAC
            END IF
C                                       Delay
         IF (CLRECR(DE2CL+I-1).NE.FBLANK)
     *      CLRECR(DE2CL+I-1) = CLRECR(DE2CL+I-1) + PDLY
C                                       Phase rate
         IF (CLRECR(RA2CL+I-1).NE.FBLANK)
     *      CLRECR(RA2CL+I-1) = CLRECR(RA2CL+I-1) + DPDLY
 700     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE REPGAI
C-----------------------------------------------------------------------
C   Routine to replace the complex gains with unit vectors of user
C   specified phase.  New values are written into the CL record in
C   Common.
C   Control info from common:
C      PARM(*)  R    (1,2) real,imaginary part of IF=BIF
C                    (3,4) real,imaginary part of IF=BIF+1 etc.
C      ISTOK    I    Polarization to correct, 1=first, 2=second,
C                    0 = both
C-----------------------------------------------------------------------
C
      INTEGER   I, IP
      INCLUDE 'DFCOR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       First polarization
      IF (ISTOK.NE.2) THEN
         IP = 1
         DO 100 I = BIF,EIF
            CLRECR(RE1CL+I-1) = PARM(IP)
            CLRECR(IM1CL+I-1) = PARM(IP+1)
            IP = IP + 2
 100        CONTINUE
         END IF
C                                       Second polarization
      IF (ISTOK.NE.1) THEN
         IP = 1
         DO 200 I = BIF,EIF
            CLRECR(RE2CL+I-1) = PARM(IP)
            CLRECR(IM2CL+I-1) = PARM(IP+1)
            IP = IP + 2
 200        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE CORSBD
C-----------------------------------------------------------------------
C   Routine to make an additive correction to the IF delay residuals in
C   the CL record in common.
C   Control info from common:
C      PARM(*)  R    The corrections, 1 per IF from BIF to EIF.
C      ISTOK    I    Polarization to correct, 1=first, 2=second,
C                    0 = both
C      FRQOFF   D(*) IF frequency offset table (Hz)
C-----------------------------------------------------------------------
C
      INTEGER   I, IP
      INCLUDE 'DFCOR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       First polarization
      IF (ISTOK.NE.2) THEN
         IP = 1
         DO 100 I = BIF,EIF
            IF (CLRECR(DE1CL+I-1).NE.FBLANK) CLRECR(DE1CL+I-1) =
     *         CLRECR(DE1CL+I-1) + PARM(IP)
            IP = IP + 1
 100        CONTINUE
         END IF
C                                       Second polarization
      IF (ISTOK.NE.1) THEN
         IP = 1
         DO 200 I = BIF,EIF
            IF (CLRECR(DE2CL+I-1).NE.FBLANK) CLRECR(DE2CL+I-1) =
     *         CLRECR(DE2CL+I-1) + PARM(IP)
            IP = IP + 1
 200        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE CORMBD
C-----------------------------------------------------------------------
C   Routine to make an correction to the IF phase corresponded
C   to a given multiband delay
C   Control info from common:
C      PARM(*)  R    The corrections, 1 per IF from BIF to EIF.
C      ISTOK    I    Polarization to correct, 1=first, 2=second,
C                    0 = both
C      FRQOFF   D(*) IF frequency offset table (Hz)
C-----------------------------------------------------------------------
C
      INCLUDE 'DFCOR.INC'
      INTEGER   I, IP
      REAL      PCOR, CPCOR(MAXIF), SPCOR(MAXIF), GR, GI
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Phase corrections
      IP = 1
      DO 50 I = BIF,EIF
         PCOR = -6.283185308 * FRQOFF(I) * PARM(IP)
         CPCOR(I) = COS (PCOR)
         SPCOR(I) = SIN (PCOR)
         IP = IP + 1
 50      CONTINUE
C                                       First polarization
      IF (ISTOK.NE.2) THEN
         IP = 1
         IF (CLRECR(MBD1CL).NE.FBLANK) CLRECR(MBD1CL) =
     *         CLRECR(MBD1CL) + PARM(IP)
         DO 100 I = BIF,EIF
C                                       Correct phase at each IF
            GR = CLRECR(RE1CL+I-1) * CPCOR(I) -
     *           CLRECR(IM1CL+I-1) * SPCOR(I)
            GI = CLRECR(RE1CL+I-1) * SPCOR(I) +
     *           CLRECR(IM1CL+I-1) * CPCOR(I)
            CLRECR(RE1CL+I-1) = GR
            CLRECR(IM1CL+I-1) = GI
            IP = IP + 1
 100        CONTINUE
         END IF
C                                       Second polarization
      IF (ISTOK.NE.1) THEN
         IP = 1
         IF (CLRECR(MBD2CL).NE.FBLANK) CLRECR(MBD2CL) =
     *         CLRECR(MBD2CL) + PARM(IP)
         DO 200 I = BIF,EIF
C                                       Correct phase at each IF
            GR = CLRECR(RE2CL+I-1) * CPCOR(I) -
     *           CLRECR(IM2CL+I-1) * SPCOR(I)
            GI = CLRECR(RE2CL+I-1) * SPCOR(I) +
     *           CLRECR(IM2CL+I-1) * CPCOR(I)
            CLRECR(RE2CL+I-1) = GR
            CLRECR(IM2CL+I-1) = GI
            IP = IP + 1
 200        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE CORRFQ (IERR)
C-----------------------------------------------------------------------
C   Routine to correct for a phase error caused by an error in the
C   Signed Sum of the LOs.
C   Corrections are applied to the CL record in Common.
C   Control info from common:
C      PARM(*)  R    (1) = Frequency error
C                    (4) = 1 if RH, -1 if LH coordinates
C                    (5) = Last source ID number
C      ISTOK    I    Polarization to correct, 1=first, 2=second,
C                    0 = both
C   Output:
C      IERR     I    Return error code , 0=OK else failed.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   LSTSOU, THSOU, LUN, I, ITEMP, IANT
      REAL      XT, YT, CFAC, SFAC, FQFAC, HA, EL, COSHA, SINHA, AZ,
     *   TIME
      DOUBLE PRECISION FREQS, D(3), S(3), CI, RADSEC, PDLY, TIMED, DRA,
     *   DDEC
      LOGICAL   ISPLNT
C                                       CI = 1/speed of light
      PARAMETER (CI = 1.0D0 / 2.997925D8)
C                                       RADSEC = earth rot rate in
C                                       rad/sec.
      PARAMETER (RADSEC = 3.1415926535897932384D0 / 43200.0D0)
      INCLUDE 'DFCOR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
C
      SAVE LSTSOU, THSOU, FREQS
      DATA LUN /30/
C-----------------------------------------------------------------------
      LSTSOU = PARM(5) + 0.5
      THSOU = CLRECI(SOUCL)
      TIMED = CLRECD(TIMCL)
      TIME = TIMED
C                                       get source info
      CALL FNDCOO (0, JD0, THSOU, DISKIN, CNOIN, CATBLK, LUN, TIME,
     *   DRA, DDEC, ISPLNT, IERR)
      IF (IERR.NE.0) GO TO 999
      PARM(5) = THSOU
      FREQS = FREQ + FREQO(BIF)
C                                       Declination
      SINDEC = SIN (DDEC)
      COSDEC = COS (DDEC)
C                                       Get Hour angle
      IANT = CLRECI(ANTCL)
      CALL COOELV (IANT, TIMED, DRA, DDEC, HA, EL, AZ)
      COSHA = COS (HA)
      SINHA = SIN (HA)
C                                       Antenna coordinates:
C                                       correct for handedness of
C                                       coordinates.
      D(1) = STNX(IANT)
      D(2) = STNY(IANT)
      D(3) = STNZ(IANT)
C                                       Source position
      S(1) =  COSDEC * COSHA
      S(2) = -COSDEC * SINHA
      S(3) =  SINDEC
C                                       Delay in sec.
      PDLY = CI * (S(1)*D(1) + S(2)*D(2) + S(3)*D(3))
C                                       Correct CL record
      IF (ISTOK.EQ.2) GO TO 650
      DO 600 I = BIF,EIF
         FQFAC = PARM(1) * PDLY
         ITEMP = FQFAC
         FQFAC = TWOPI * (FQFAC - ITEMP)
         CFAC = COS (FQFAC)
         SFAC = SIN (FQFAC)
C                                       Phase
         XT = CLRECR(RE1CL+I-1)
         YT = CLRECR(IM1CL+I-1)
         IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
            CLRECR(RE1CL+I-1) = XT * CFAC - YT * SFAC
            CLRECR(IM1CL+I-1) = XT * SFAC + YT * CFAC
            END IF
C                                       Delays and derivatives were
C                                       done correctly.
 600     CONTINUE
C
 650  IF (ISTOK.EQ.1) GO TO 999
      DO 700 I = BIF,EIF
         FQFAC = PARM(1) * PDLY
         ITEMP = FQFAC
         FQFAC = TWOPI * (FQFAC - ITEMP)
         CFAC = COS (FQFAC)
         SFAC = SIN (FQFAC)
C                                       Phase
         XT = CLRECR(RE2CL+I-1)
         YT = CLRECR(IM2CL+I-1)
         IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
            CLRECR(RE2CL+I-1) = XT * CFAC - YT * SFAC
            CLRECR(IM2CL+I-1) = XT * SFAC + YT * CFAC
            END IF
C                                       Delays and derivatives were
C                                       done correctly.
 700     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE PTCHPC
C-----------------------------------------------------------------------
C   Routine to patch phase cal values.
C   The expected relationship between the phase in the different IF is
C   given in PARM.  Any valid phases are used to estimate the blanked
C   phases.  If there are no blanked phases then the values in PARM are
C   used.   New values are written into the CL record in
C   Common.
C   Control info from common:
C      PARM(*)  R    Expected phase relationship of IF BIF-EIF (rad).
C      ISTOK    I    Polarization to correct, 1=first, 2=second,
C                    0 = both
C-----------------------------------------------------------------------
C
      INCLUDE 'DFCOR.INC'
      INTEGER   I, J, IP, COUNT
      REAL      FAZ(MAXIF), CSUM, SSUM
      LOGICAL   SOMGOD, ALGOOD, GOOD(MAXIF)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       First polarization
      IF (ISTOK.NE.2) THEN
C                                       Get existing phases
         SOMGOD = .FALSE.
         ALGOOD = .TRUE.
         IP = 1
         DO 20 I = BIF,EIF
            IF ((CLRECR(RE1CL+I-1).NE.FBLANK) .AND.
     *         (CLRECR(IM1CL+I-1).NE.FBLANK)) THEN
               FAZ(IP) = ATAN2 (CLRECR(IM1CL+I-1),
     *            CLRECR(RE1CL+I-1)+1.0E-20)
               SOMGOD = .TRUE.
               GOOD(IP) = .TRUE.
            ELSE
               FAZ(IP) = 0.0
               GOOD(IP) = .FALSE.
               ALGOOD = .FALSE.
               END IF
            IP = IP + 1
 20         CONTINUE
C                                       If all valid skip
         IF (ALGOOD) GO TO 500
C                                       If any good values use them to
C                                       estimate the others.
         IP = 1
         IF (SOMGOD) THEN
            DO 60 I = BIF,EIF
               IF (.NOT.GOOD(IP)) THEN
C                                       Average good phases
                  CSUM = 0.0
                  SSUM = 0.0
                  COUNT = 0
                  DO 40 J = BIF,EIF
                     IF (GOOD(J-BIF+1)) THEN
                        COUNT = COUNT + 1
                        CSUM =  CSUM + COS (FAZ(J-BIF+1) - PARM(J-BIF+1)
     *                     + PARM(IP))
                        SSUM =  SSUM + SIN (FAZ(J-BIF+1) - PARM(J-BIF+1)
     *                     + PARM(IP))
                        END IF
 40                  CONTINUE
                  IF (COUNT.GT.0) THEN
                     FAZ(IP) = ATAN2 (SSUM/COUNT, (CSUM/COUNT)+1.0E-20)
                  ELSE
                     FAZ(IP) = PARM(IP)
                     END IF
                  END IF
               IP = IP + 1
 60            CONTINUE
         ELSE
C                                       All blanked - use PARM phases
            DO 80 I = BIF,EIF
               FAZ(IP) = PARM(IP)
               IP = IP + 1
 80            CONTINUE
            END IF
C                                       Replace blanked values
         IP = 1
         DO 100 I = BIF,EIF
            IF (.NOT.GOOD(IP)) THEN
               CLRECR(RE1CL+I-1) = COS (FAZ(IP))
               CLRECR(IM1CL+I-1) = SIN (FAZ(IP))
               END IF
            IP = IP + 1
 100        CONTINUE
         END IF
C                                       Second polarization
 500  IF (ISTOK.NE.1) THEN
C                                       Get existing phases
         SOMGOD = .FALSE.
         ALGOOD = .TRUE.
         IP = 1
         DO 520 I = BIF,EIF
            IF ((CLRECR(RE2CL+I-1).NE.FBLANK) .AND.
     *         (CLRECR(IM2CL+I-1).NE.FBLANK)) THEN
               FAZ(IP) = ATAN2 (CLRECR(IM2CL+I-1),
     *            CLRECR(RE2CL+I-1)+1.0E-20)
               SOMGOD = .TRUE.
               GOOD(IP) = .TRUE.
            ELSE
               FAZ(IP) = 0.0
               GOOD(IP) = .FALSE.
               ALGOOD = .FALSE.
               END IF
            IP = IP + 1
 520        CONTINUE
C                                       If all valid skip
         IF (ALGOOD) GO TO 999
C                                       If any good values use them to
C                                       estimate the others.
         IP = 1
         IF (SOMGOD) THEN
            DO 560 I = BIF,EIF
               IF (.NOT.GOOD(IP)) THEN
C                                       Average good phases
                  CSUM = 0.0
                  SSUM = 0.0
                  COUNT = 0
                  DO 540 J = BIF,EIF
                     IF (GOOD(J-BIF+1)) THEN
                        COUNT = COUNT + 1
                        CSUM =  CSUM + COS (FAZ(J-BIF+1) - PARM(J-BIF+1)
     *                     + PARM(IP))
                        SSUM =  SSUM + SIN (FAZ(J-BIF+1) - PARM(J-BIF+1)
     *                     + PARM(IP))
                        END IF
 540                 CONTINUE
                  IF (COUNT.GT.0) THEN
                     FAZ(IP) = ATAN2 (SSUM/COUNT, (CSUM/COUNT)+1.0E-20)
                  ELSE
                     FAZ(IP) = PARM(IP)
                     END IF
                  END IF
               IP = IP + 1
 560           CONTINUE
         ELSE
C                                       All blanked - use PARM phases
            DO 580 I = BIF,EIF
               FAZ(IP) = PARM(IP)
               IP = IP + 1
 580           CONTINUE
            END IF
C                                       Replace blanked values
         IP = 1
         DO 600 I = BIF,EIF
            IF (.NOT.GOOD(IP)) THEN
               CLRECR(RE2CL+I-1) = COS (FAZ(IP))
               CLRECR(IM2CL+I-1) = SIN (FAZ(IP))
               END IF
            IP = IP + 1
 600        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE ANAXIS (IERR)
C-----------------------------------------------------------------------
C   Routine to correct for errors in antenna axis offset
C   Corrections are applied to the CL record in Common.
C   Control info from common:
C      PARM(1)  R    (1) = axis offset (m)
C   Output:
C      IERR     I    Return error code , 0=OK else failed.
C   All IFs and all polarizations are corrected
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   LSTSOU, THSOU, LUN, I, ITEMP, IANT, MOUNT
      REAL      XT, YT, CFAC, SFAC, FQFAC, HA, EL, CHA, SHA, AZ, TIME
      DOUBLE PRECISION FREQS, LAT, SL, CL, BRACK, SQR, CI, RADSEC,
     *   PDLY, DPDLY, TIMED, DRA, DDEC
      LOGICAL   ISPLNT
C                                       CI = 1/speed of light
      PARAMETER (CI = 1.0D0 / 2.997925D8)
C                                       RADSEC = earth rot rate in
C                                       rad/sec.
      PARAMETER (RADSEC = 3.1415926535897932384D0 / 43082.0D0)
      INCLUDE 'DFCOR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      SAVE  FREQS
      DATA LUN /30/
C-----------------------------------------------------------------------
      LSTSOU = PARM(NANTSL + 1) + 0.5
      THSOU = CLRECI(SOUCL)
      TIMED = CLRECD(TIMCL)
      TIME = TIMED
C                                       get source info
      CALL FNDCOO (0, JD0, THSOU, DISKIN, CNOIN, CATBLK, LUN, TIME,
     *   DRA, DDEC, ISPLNT, IERR)
      IF (IERR.NE.0) GO TO 999
      PARM(NANTSL + 1) = THSOU
      FREQS = FREQ + FREQO(BIF)
C                                       Declination
      SINDEC = SIN (DDEC)
      COSDEC = COS (DDEC)
      IANT = CLRECI(ANTCL)
C                                       Antenna mount
      MOUNT = MNTYP(IANT)
C                                       Altaz or EW/Nasmyth mount
C                       (folded cassegrain is a varient of Nasmyth)
      IF ((MOUNT.EQ.0) .OR. (MOUNT.GE.3)) THEN
C                                       Get Hour angle
         CALL COOELV (IANT, TIMED, DRA, DDEC, HA, EL, AZ)
         CHA = COS (HA)
         SHA = SIN (HA)
C                                       Antenna latitude
         LAT = STNLAT(IANT)
         SL = DSIN(LAT)
         CL = DCOS(LAT)
         BRACK = SL*SINDEC + CL*COSDEC*CHA
         SQR = DSQRT(1.D0 - BRACK*BRACK)
C                                       Delay and rate in sec and
C                                       sec/sec. (want corrections).
         PDLY = (AXOFF*CI) * SQR
         DPDLY = ((AXOFF*CI)*BRACK/SQR) * CL * COSDEC * SHA * RADSEC
C                                       XY-EW mount
      ELSE IF (MOUNT.EQ.3) THEN
         CHA = COS (HA)
         SHA = SIN (HA)
C                                       Antenna latitude
         LAT = STNLAT(IANT)
         SL = DSIN(LAT)
         CL = DCOS(LAT)
         BRACK = SHA*COSDEC
         SQR = DSQRT(1.D0 - BRACK*BRACK)
C                                       Delay and rate in sec and
C                                       sec/sec. (want corrections).
         PDLY = (AXOFF*CI) * SQR
         DPDLY = ((AXOFF*CI)*BRACK/SQR) * CL * COSDEC * SHA * RADSEC

C                                       Equatorial mount
      ELSE IF (MOUNT.EQ.1) THEN
         PDLY = AXOFF*CI*COSDEC
         DPDLY = 0.0
         END IF
C                                       Correct CL record
C                                       Geometric delay (2 terms)
      IF (CLRECD(GDLCL).NE.DBLANK) CLRECD(GDLCL) = CLRECD(GDLCL) - PDLY
C                                       Second term
      IF ((CLNUMV(CLDDEL).GE.2) .AND. (CLRECD(GDLCL+1).NE.DBLANK))
     *   CLRECD(GDLCL+1) = CLRECD(GDLCL+1) - DPDLY
C                                       Correct the first polarization
      DO 600 I = 1, NUMIF
         FQFAC = (FREQS+FRQOFF(I)) * PDLY
         ITEMP = FQFAC
         FQFAC = TWOPI * (FQFAC - ITEMP)
         CFAC = COS (FQFAC)
         SFAC = SIN (FQFAC)
C                                       Phase
         XT = CLRECR(RE1CL+I-1)
         YT = CLRECR(IM1CL+I-1)
         IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
            CLRECR(RE1CL+I-1) = XT * CFAC - YT * SFAC
            CLRECR(IM1CL+I-1) = XT * SFAC + YT * CFAC
            END IF
C                                       Delay
         IF (CLRECR(DE1CL+I-1).NE.FBLANK)
     *      CLRECR(DE1CL+I-1) = CLRECR(DE1CL+I-1) + PDLY
C                                       Phase rate
         IF (CLRECR(RA1CL+I-1).NE.FBLANK)
     *      CLRECR(RA1CL+I-1) = CLRECR(RA1CL+I-1) + DPDLY
 600     CONTINUE
C                                       Correct the second polarization
C                                       if it exists
         IF (NUMPOL. EQ. 2) THEN
            DO 700 I = 1, NUMIF
               FQFAC = (FREQS+FRQOFF(I)) * PDLY
               ITEMP = FQFAC
               FQFAC = TWOPI * (FQFAC - ITEMP)
               CFAC = COS (FQFAC)
               SFAC = SIN (FQFAC)
C                                       Phase
               XT = CLRECR(RE2CL+I-1)
               YT = CLRECR(IM2CL+I-1)
               IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
                  CLRECR(RE2CL+I-1) = XT * CFAC - YT * SFAC
                  CLRECR(IM2CL+I-1) = XT * SFAC + YT * CFAC
                  END IF
C                                       Delay
               IF (CLRECR(DE2CL+I-1).NE.FBLANK)
     *            CLRECR(DE2CL+I-1) = CLRECR(DE2CL+I-1) + PDLY
C                                       Phase rate
               IF (CLRECR(RA2CL+I-1).NE.FBLANK)
     *            CLRECR(RA2CL+I-1) = CLRECR(RA2CL+I-1) + DPDLY
  700          CONTINUE
            END IF
C
 999  RETURN
      END
      SUBROUTINE CSOUEL (ANTNO, TIME, DRA, DDEC, HA, EL)
C-----------------------------------------------------------------------
C   and antenna coordinates in common.  The routines GETANT and GETSOU
C   should be called before this routine to but the correct values in
C   the relevant commons.
C   Inputs:
C      ANTNO      I    Antenna number
C      TIME       D    Current data time (days).
C      DRA        D    Apparent RA of source
C      DDEC       D    Apparent Declination of source.
C   Input from common:
C      STNLAT     D(*) Antenna latitude (rad).
C      STNLON     D(*) Antenna east longitudes (rad).
C      GSTIAT     D    GST at IAT=0 of reference day (rad).
C      ROTIAT     D    Rotation of the earth rate in IAT.
C   Output:
C      HA         D    Source hour angle (rad) wrt to antenna
C      EL         R    Source elevation (rad) at antenna
C-----------------------------------------------------------------------
      INTEGER   ANTNO
      DOUBLE PRECISION TIME, DRA, DDEC, HA
      REAL      EL
C
      DOUBLE PRECISION HRANG, ANTLST, DARG, PI, TWOPI
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA PI /3.141592653589793/, TWOPI/6.283185307179586/
C-----------------------------------------------------------------------
C                                       Antenna LST
      ANTLST = GSTIAT + STNLON(ANTNO) + TIME * ROTIAT
C                                       Hour angle
      HRANG = ANTLST - DRA
C                                       Limit to between 0 and 2pi
      HRANG = DMOD( HRANG, TWOPI)
C                                       translate to between -pi and pi
      IF (HRANG.GT. PI) HRANG = HRANG - TWOPI
      IF (HRANG.LT.-PI) HRANG = HRANG + TWOPI
      HA = HRANG
C                                       Elevation angle
      DARG = SIN (STNLAT(ANTNO)) * SIN (DDEC) + COS (STNLAT(ANTNO))
     *   * COS (DDEC) * COS (HRANG)
      EL = (1.570796327 - ACOS (DARG))
C
 999  RETURN
      END
      SUBROUTINE ANTMOD (DISK, CNO, SUBA, ANTNO, PARM, IERR)
C-----------------------------------------------------------------------
C   Subroutine to make the correction of the selected antenna position
C   if OPCODE ='ANTP' and the antenna correction parameters are not
C   equal zero.
C   Inputs:
C      DISK       I    The file disk number
C      CNO        I    The file catalog slot number.
C      ANTNO      I    The antenna number
C      SUBA       I    Subarray number (AN table number)
C      PARM(*)    R    Array of corrections
C   Input from common:
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, SUBA, ANTNO, IERR
      REAL      PARM(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NENTRY, BUFFAN(512), I, LUN1
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANT.INC'
      DATA LUN1 /28/
C-----------------------------------------------------------------------
C                                       Open for write
      CALL ANTINI ('WRIT', BUFFAN, DISK, CNO, SUBA, CATBLK, LUN1,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1100) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Loop through AN rows correcting
C                                       the selected antenna position
      NENTRY = BUFFAN(5)
      DO 300 I = 1, NENTRY
         IANRNO = I
         CALL TABAN ('READ', BUFFAN, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1200) IERR, I
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       Put the correction here
         IF (NOSTA.EQ.ANTNO) THEN
            STAXYZ(1) = STAXYZ(1) + PARM(1)
            STAXYZ(2) = STAXYZ(2) + PARM(2)
            STAXYZ(3) = STAXYZ(3) + PARM(3)
            END IF
         IANRNO = I
         CALL TABAN ('WRIT', BUFFAN, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1300) IERR, I
            CALL MSGWRT (8)
            GO TO 999
            END IF
 300     CONTINUE
C                                       Close table
      CALL TABIO ('CLOS', 1, IANRNO, BUFFAN, BUFFAN, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1400) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ANTMOD: ERROR',I3,' READING OUTPUT AN TABLE')
 1200 FORMAT ('ANTMOD: ERROR',I3,' READING AN ROW ',I4)
 1300 FORMAT ('ANTMOD: ERROR',I3,' WRITING AN ROW ',I4)
 1400 FORMAT ('ANTMOD: ERROR',I3,' CLOSING OUTPUT AN TABLE')
      END
      SUBROUTINE SOUMOD (DISK, CNO, SOUS, DX, DY, IERR)
C-----------------------------------------------------------------------
C   Subroutine to make the correction of the selected source position
C   if OPCODE ='ANTP' and the source correction parameters are not
C   equal zero.
C   Inputs:
C      DISK       I    The file disk number
C      CNO        I    The file catalog slot number.
C      SOUS       I    The source ID number
C      DX         R    Correction at the picture plane in RA direction,
C                      in degrees.
C      DY         R    Correction at DEC, in degrees.
C   Input from common /MAPHDR/
C      CATBLK(256)  I    Catalog header record.
C-----------------------------------------------------------------------
C                                       Declarations for recalculation
C                                       aparent coordinates to epoch
      INTEGER IEQ, DIR
      REAL      REQ, POLAR(2)
      CHARACTER OBSDAT*8
      DOUBLE PRECISION JD, DELDAT, OBSPOS(3), RAATT, DECTT
      LOGICAL GR
C
      INTEGER   DISK, CNO, BUFFER(1024), SOUS, IERR
      REAL      DX, DY, DRA, COSDEC
C                                       Declarations for SOUINI
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER VELDEF*8, VELTYP*8, CALCOD*4, SOUNAM*16
      INTEGER   JERR, IDSOU, SUKOLS(MAXSUC), LUN, SUNUMV(MAXSUC),
     *   QUAL, NUMIF, NSOURC, I, ISURNO, SUFQID
      DOUBLE PRECISION    BANDW, RAEPO, DECEPO, EPOCH, RAAPP, DECAPP,
     *   PMRA, PMDEC, RAOBS, DECOBS
      REAL      FLUX(4,MAXIF)
      DOUBLE PRECISION    LSRVEL(MAXIF), FREQO(MAXIF), LRESTF(MAXIF)
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (IEQ, REQ)
      DATA DELDAT, OBSPOS, POLAR /1.D-6, 0.D0, 0.D0, 0.D0, 0., 0./
      DATA LUN /28/
C-----------------------------------------------------------------------
C                                       take RA, DEC(EPOC) from the
C                                       catalog
      RA = CATD(KDCRV+JLOCR)
      DEC = CATD(KDCRV+JLOCD)
C                                       Open for READ first to set
C                                       all variables
C                                       Open SU table
      CALL SOUINI ('READ', BUFFER, DISK, CNO, 1, CATBLK, LUN,
     *   NUMIF, VELDEF, VELTYP, SUFQID, ISURNO, SUKOLS, SUNUMV, JERR)
C                                       Go to modify the source
C                                       position at the header
C                                       if there is no SU table
      IF (JERR.NE.0) GO TO 400
C                                       then close
      CALL TABIO ('CLOS', 0, 1, BUFFER, BUFFER, JERR)
C                                       Open for write
      CALL SOUINI ('WRIT', BUFFER, DISK, CNO, 1, CATBLK, LUN,
     *   NUMIF, VELDEF, VELTYP, SUFQID, ISURNO, SUKOLS, SUNUMV, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1100)
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Loop through SU rows modifing
C                                       the selected source position
      NSOURC = BUFFER(5)
      DO 300 I = 1, NSOURC
C                                       Read record
         ISURNO = I
         CALL TABSOU ('READ', BUFFER, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF, PMRA,
     *      PMDEC, JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1200) I
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       Put the correction here
         IF (IDSOU.EQ.SOUS) THEN
C                                       Recalculate the source position
C                                       error in RA from the error at
C                                       the picture plane
            COSDEC = COS (DECAPP * DG2RAD)
            DRA = 0.0
            IF (COSDEC.NE.0.0) DRA = DX / COSDEC
            RAAPP  = RAAPP + DRA
            DECAPP = DECAPP + DY
C                                       Find RAEPO, DECEPO for
C                                       the given epoch
C
C                                       Find time of observation
            CALL H2CHR (8, 1, CATH(KHDOB), OBSDAT)
C                                       Find Julian day, JD
            CALL JULDAY(OBSDAT, JD)
            IEQ = CATBLK(KREPO)
            EPOCH = REQ
            RAATT = RAAPP * DG2RAD
            DECTT = DECAPP * DG2RAD
            GR = .TRUE.
            DIR = -1
            CALL JPRECS (JD, EPOCH, DELDAT, DIR, GR, OBSPOS, POLAR,
     *         RAEPO, DECEPO, RAATT, DECTT)
            RAEPO = RAEPO * RAD2DG
            DECEPO = DECEPO * RAD2DG
            END IF
         ISURNO = I
         CALL TABSOU ('WRIT', BUFFER, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF, PMRA,
     *      PMDEC, JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1300) I
            CALL MSGWRT (8)
            GO TO 999
            END IF
 300     CONTINUE
C
C                                       Close table
      CALL TABIO ('CLOS', 0, 1, BUFFER, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1400)
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Modify the epoc RA, DEC at the
C                                       header if there is only one
C                                       source at the SU table and
C                                       RA.NE.0 or DEC.NE.0 at the header
      IF ((NSOURC.EQ.1 .AND.
     *      (ABS(RA).GT.0.0001) .OR. ABS(DEC).GT.0.0001)) THEN
         CATD(KDCRV+JLOCR) = RAEPO
         CATD(KDCRV+JLOCD) = DECEPO
         CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'REST', BUFFER, IERR)
         END IF
      GO TO 999
C                                       Modify the epoc RA, DEC at the
C                                       header if there is no SU table
  400 CONTINUE
      WRITE (MSGTXT,1500)
      CALL MSGWRT (8)
C                                       Find time of observation
      CALL H2CHR (8, 1, CATH(KHDOB), OBSDAT)
C                                       Find Julian day, JD
      CALL JULDAY(OBSDAT, JD)
C                                       Find RAAPP, DECAP for
C                                       observation date.
      IEQ = CATBLK(KREPO)
      EPOCH = REQ
      RAEPO = RA * DG2RAD
      DECEPO = DEC * DG2RAD
      GR = .TRUE.
      DIR = 1
      CALL JPRECS (JD, EPOCH, DELDAT, DIR, GR, OBSPOS, POLAR,
     *   RAEPO, DECEPO, RAAPP, DECAPP)
      IERR = 0
C                                       Recalculate the source position
C                                       error in RA from the error at
C                                       the picture plane
      COSDEC = COS (DECAPP)
      DRA = 0.0
      IF (COSDEC.NE.0.0) DRA = DX / COSDEC
      RAAPP  = RAAPP + DRA*DG2RAD
      DECAPP = DECAPP + DY*DG2RAD
C                                       Find RAEPO, DECEPO for the
C                                       corrected RAAPP, DECAPP
      GR = .TRUE.
      DIR = -1
      CALL JPRECS (JD, EPOCH, DELDAT, DIR, GR, OBSPOS, POLAR,
     *   RAEPO, DECEPO, RAAPP, DECAPP)
      CATD(KDCRV+JLOCR) = RAEPO * RAD2DG
      CATD(KDCRV+JLOCD) = DECEPO * RAD2DG
      CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'REST', BUFFER, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('SOUMOD: SU table is not modifyed.',
     *   ' Error opening SU table')
 1200 FORMAT ('SOUMOD: SU table is not modifyed. Error reading row',I4)
 1300 FORMAT ('SOUMOD: SU table is not modifyed. Error writing row',I4)
 1400 FORMAT ('SOUMOD: Error closing SU table')
 1500 FORMAT ('SU table does not exist. So the source coordinates at',
     *   'the header are modified' )
      END
      SUBROUTINE GETINP (FILE, IERR)
C-----------------------------------------------------------------------
C  This subroutine reads, from an input file specified by name "file",
C  the list of the vertical atmosphere delays for the given antenna
C  and time.
C  The first (ascii) data record should specify NLINES, the number of
C  the lines.

C  Then, NLINES records must follow, each with three numbers:
C    The station number;
C    The time in dd:hh:mm:ss;
C    The vertical delay error in cm;
C   Inputs:
C    FILE     C*48  File name
C   Outputs in common:
C    NLINES    I     Number of data lines
C    IAN(*)    I     The antenna number
C    TMES(*)   D     The measurement time, in days
C    VERDEL(*) R     The atmosphere vertical delay, in cm
C   Outputs:
C    IERR     I     Return code, 0=>OK
C-----------------------------------------------------------------------
      CHARACTER FILE*48
      INTEGER   I, IERR
      INTEGER   LUN, FIND, NBYTES, KBP
      LOGICAL   F
C
      INTEGER  DD, HH, MM, JT, JTRIM
      REAL SS
      CHARACTER LINE*80
      DOUBLE PRECISION X
      INCLUDE 'DFCOR.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                       Open text file
      LUN = 10
      CALL ZTXOPN ('READ', LUN, FIND, FILE, F, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1001)
         GO TO 990
         END IF
C                                       Get number of lines
      CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
      IF (IERR.NE.0) GO TO 980
      JT = JTRIM (LINE)
C                                       Get value
      KBP = 1
      NBYTES = 80
      CALL GETNUM (LINE, NBYTES, KBP, X)
      NLINES = X + 0.1
C                                       Tell user
      WRITE (MSGTXT,2000) NLINES
      CALL MSGWRT (6)
C                                       Read measurment info
      DO 100 I = 1,NLINES
         CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
         IF (IERR.NE.0) GO TO 980
         JT = JTRIM (LINE)
C                                       Get values
         KBP = 1
C
         CALL GETNUM (LINE, NBYTES, KBP, X)
         IAN(I) = X
         CALL GETNUM (LINE, NBYTES, KBP, X)
         DD = X
         CALL GETNUM (LINE, NBYTES, KBP, X)
         HH = X
         CALL GETNUM (LINE, NBYTES, KBP, X)
         MM = X
         CALL GETNUM (LINE, NBYTES, KBP, X)
         SS = X
C                                       Tell user
         TMES(I) = DD + HH/24.0 + MM/(24.*60.) + SS/(24.*3600.)
         CALL GETNUM (LINE, NBYTES, KBP, X)
         VERDEL(I) = X
         WRITE (MSGTXT,2001) I, IAN(I), DD, HH, MM, SS, TMES(I),
     *      VERDEL(I)
         CALL MSGWRT (6)
 100     CONTINUE
C                                       close input file
      CALL ZTXCLS (LUN, FIND, IERR)
C
      GO TO 999
C                                       Read error
 980  WRITE (MSGTXT,1980) IERR
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1001 FORMAT ('ERROR ',I3,' OPENING  INFO TEXT FILE')
 1980 FORMAT ('ERROR ',I3,' READING ANTENNA INFO TEXT FILE')
 2000 FORMAT ('Number of lines = ',I4)
 2001 FORMAT (I4, I3, 1X, 3(I2,':'), F4.1, 2X, F10.8, F5.2)
      END
      SUBROUTINE ATMOV (IERR)
C-----------------------------------------------------------------------
C   Routine to apply atmospheric corrections to the given antenna
C   and time based on array given at INFILE
C   Corrections are applied to the CL record in Common.
C   Control info from common:
C      NLINES    I    number of elements at the following arrays
C      IAN(*)    I    array of antenna numbers
C      TMES(*)   D    array of measurement times, in days
C      VERDEL(*) R    array of atmosphere vertical delay, in cm
C      ISTOK     I    Polarization to correct, 1=first, 2=second,
C                    0 = both
C   Output:
C      IERR      I    Return error code , 0=OK else failed.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   LSTSOU, THSOU, LUN, IANT, I, ITEMP
      REAL      XT, YT, PDLY, DPDLY, CFAC, SFAC, FQFAC, ZA, ELV, HA,
     *   VERINT, DELL, DELR, DELDT, AZ, PDLYC, DPDLYC, DDELL, DDELR,
     *   TIME
      DOUBLE PRECISION FREQS, SINLAT, COSLAT, TCLT, TMESA, DRA, DDEC,
     *   TLEFT, TRIGHT
      LOGICAL   ISPLNT
C                                       speed of light (meters/sec)
      DOUBLE PRECISION VELITE
      PARAMETER (VELITE = 2.997924562D8)
      INCLUDE 'DFCOR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA LUN /30/
C-----------------------------------------------------------------------
      IERR = 0
C                                       time at the CL table line,
C                                       in days
      TCLT = CLRECD(TIMCL)
      TIME = TCLT
C                                       antenna number at the CL table
C                                       line
      IANT = CLRECI(ANTCL)
      PDLYC = 0
      DPDLYC = 0
C                                       Interpolate the calibrator
C                                       delays (rate) to the source time
C                                       DO it only for the second read
C                                       of the CL table, when the
C                                       calibrator data have been read
      IF (NSOCWD.EQ.0) THEN
C                                       do not correct calibrator???
C         IF (CLRECI(SOUCL).EQ.NCALID) GO TO 999
         TLEFT = 0
         TRIGHT = 100
         DO 90 I = 1, NCALLI
            TMESA = ATIME(I)
            IF (IANT.EQ.AANT(I)) THEN
               IF ((TMESA.GE.TCLT) .AND. (TMESA.LE.TRIGHT)) THEN
                  TRIGHT = TMESA
                  DELR = APDLY(I)
                  DDELR = ADPDLY(I)
                  END IF
               IF ((TMESA.LE.TCLT) .AND. (TMESA.GE.TLEFT)) THEN
                  TLEFT = TMESA
                  DELL = APDLY(I)
                  DDELL = ADPDLY(I)
                  END IF
               END IF
   90       CONTINUE
         IF (TRIGHT.EQ.100) THEN
            IF (TLEFT.EQ.0) THEN
               PDLYC = 0
               DPDLYC = 0
            ELSE
               PDLYC = DELL
               DPDLYC = DDELL
               END IF
         ELSE
            IF (TLEFT.EQ.0) THEN
               PDLYC = DELR
               DPDLYC = DDELR
            ELSE
C                                       make the interpolation itself
               IF (TRIGHT.EQ.TLEFT) THEN
                  PDLYC = DELL
                  DPDLYC = DDELL
               ELSE
                  PDLYC = DELL + (DELR-DELL) * (TCLT-TLEFT)/(TRIGHT
     *               -TLEFT)
                  DPDLYC = DDELL + (DDELR-DDELL) *
     *            (TCLT-TLEFT)/(TRIGHT-TLEFT)
                  END IF
               END IF
            END IF
         END IF
C                                       Interpolate the vertical
C                                       atmosphere delay given at the
C                                       array VERDEL(*) read from the
C                                       INFILE
      TLEFT = 0
      TRIGHT = 100
      DO 100 I = 1, NLINES
         TMESA = TMES(I)
         IF (IANT.EQ.IAN(I)) THEN
            IF ((TMESA.GT.TCLT) .AND. (TMESA.LT.TRIGHT)) THEN
               TRIGHT = TMESA
               DELR = VERDEL(I)
               END IF
            IF ((TMESA.LT.TCLT) .AND. (TMESA.GT.TLEFT)) THEN
               TLEFT = TMESA
               DELL = VERDEL(I)
               END IF
            END IF
  100    CONTINUE
      IF (TRIGHT.EQ.100) THEN
         IF (TLEFT.EQ.0) THEN
            VERINT = 0
         ELSE
            VERINT = DELL
            END IF
      ELSE
         IF (TLEFT.EQ.0) THEN
            VERINT = DELR
         ELSE
C                                       make the interpolation itself
            VERINT = DELL + (DELR-DELL) * (TCLT-TLEFT)/(TRIGHT-TLEFT)
            END IF
         END IF
C
C                                       VERINT is the interpolated
C                                       vertical atmosphere delay
C                                       at time of the CL table line
C
C                                       previous source ID
      LSTSOU = PARM(1) + 0.5
C                                       source ID at the CL table line
      THSOU = CLRECI(SOUCL)
C                                       get source info
      CALL FNDCOO (0, JD0, THSOU, DISKIN, CNOIN, CATBLK, LUN, TIME,
     *   DRA, DDEC, ISPLNT, IERR)
      IF (IERR.NE.0) GO TO 999
      PARM(1) = THSOU
      FREQS = FREQ + FREQO(BIF)
      SINDEC = SIN (DDEC)
      COSDEC = COS (DDEC)
C
      CALL COOELV (IANT, CLRECD(TIMCL), DRA, DDEC, HA, ELV, AZ)
C                                       zenith angle of the source
C                                       from the antenna
      ZA = (1.570796327 - ELV)
      COSLAT = COS (STNLAT(IANT))
      SINLAT = SIN (STNLAT(IANT))
C                                       The mapping function is
C                                       described by sec(ZA)
      IF (ELV.GT.0.05) THEN
         PDLY = ((VERINT/100) / SIN(ELV)) / VELITE
      ELSE
         PDLY = 0
         END IF
C                                       DELDT is derivative of ELV
C                                       (by time) multiplied by
C                                       COS(ELV)
      DELDT = -7.29211E-5 * SIN (HA) * COSLAT * COSDEC
C
      IF (ELV.GT.0.05) THEN
         DPDLY = -PDLY / SIN(ELV) * DELDT
      ELSE
         DPDLY = 0
         END IF
C                                       store arrays of PDLY and DPDLY
C                                       for the calibrator source
C                                       CALSOUR has to include only one
C                                       source
      IF (NSOCWD.EQ.1) THEN
         APDLY(FIXCNT) = PDLY
         ADPDLY(FIXCNT) = DPDLY
         ATIME(FIXCNT) = TCLT
         AANT(FIXCNT) = IANT
Ctemporally!!!!!!!!!
C         WRITE (MSGTXT,1000) FIXCNT, ATIME(FIXCNT), AANT(FIXCNT),
C     *      APDLY(FIXCNT), ADPDLY(FIXCNT)
C         CALL MSGWRT (8)
C 1000    FORMAT (I5, 1X, F8.6, 1X, I2, 1X, 1PE12.5, 1X, 1PE12.5)
         GO TO 999
         END IF
C                                       delay as the difference of the
C                                       source and calibrator delay
      PDLY = PDLY - PDLYC
C                                       delay rate  as the difference
C                                       of the source and calibrator
C                                       delay rate
C
      DPDLY = DPDLY - DPDLYC
C                                       Atmospheric group delay
      IF (CLRECR(ATMCL).NE.FBLANK) CLRECR(ATMCL) = CLRECR(ATMCL) - PDLY
C                                       Atmospheric group delay rate
      IF (CLRECR(DATMCL).NE.FBLANK) CLRECR(DATMCL) = CLRECR(DATMCL) -
     *   DPDLY
      IF (ISTOK.EQ.2) GO TO 650
      DO 600 I = BIF,EIF
         FQFAC = (FREQS+FRQOFF(I)) * PDLY
         ITEMP = FQFAC
         FQFAC = TWOPI * (FQFAC - ITEMP)
         CFAC = COS (FQFAC)
         SFAC = SIN (FQFAC)
C                                       Phase
         XT = CLRECR(RE1CL+I-1)
         YT = CLRECR(IM1CL+I-1)
         IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
            CLRECR(RE1CL+I-1) = XT * CFAC - YT * SFAC
            CLRECR(IM1CL+I-1) = XT * SFAC + YT * CFAC
            END IF
C                                       Delay
         IF (CLRECR(DE1CL+I-1).NE.FBLANK)
     *      CLRECR(DE1CL+I-1) = CLRECR(DE1CL+I-1) + PDLY
C                                       Phase rate
         IF (CLRECR(RA1CL+I-1).NE.FBLANK)
     *      CLRECR(RA1CL+I-1) = CLRECR(RA1CL+I-1) + DPDLY
 600     CONTINUE
 650     IF (ABS(ISTOK).EQ.1) GO TO 999
      DO 700 I = BIF,EIF
         FQFAC = (FREQS+FRQOFF(I)) * PDLY
         ITEMP = FQFAC
         FQFAC = TWOPI * (FQFAC - ITEMP)
         CFAC = COS (FQFAC)
         SFAC = SIN (FQFAC)
C                                       Phase
         XT = CLRECR(RE2CL+I-1)
         YT = CLRECR(IM2CL+I-1)
         IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
            CLRECR(RE2CL+I-1) = XT * CFAC - YT * SFAC
            CLRECR(IM2CL+I-1) = XT * SFAC + YT * CFAC
            END IF
C                                       Delay
         IF (CLRECR(DE2CL+I-1).NE.FBLANK)
     *      CLRECR(DE2CL+I-1) = CLRECR(DE2CL+I-1) + PDLY
C                                       Phase rate
         IF (CLRECR(RA2CL+I-1).NE.FBLANK)
     *      CLRECR(RA2CL+I-1) = CLRECR(RA2CL+I-1) + DPDLY
 700     CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'MTARS.INC'
C                                       Local include for MTARS
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   MAXGAU, MAXFRQ
      PARAMETER (MAXGAU = 9999)
      PARAMETER (MAXFRQ = 4000)
C
      HOLLERITH XINTXT(12), XINLIS(12), XOUTFI(12)
      REAL      FLUX
      REAL      QONE(MAXGAU), UONE(MAXGAU), SPIX(MAXGAU), RM(MAXGAU),
     *   RMTHIK(MAXGAU)
      INTEGER   THETYP(MAXGAU), NGAUSS, NFREQ, SCRTCH(256)
      CHARACTER INTEXT*48, INLIST*48, OUTFIL*48
      DOUBLE PRECISION FQVAL(MAXFRQ)
      COMMON /INPARM/ XINTXT, FLUX, XINLIS, XOUTFI
      COMMON /CHRCOM/ INTEXT, INLIST, OUTFIL
      COMMON /PARMS/ FQVAL, SCRTCH, NGAUSS, NFREQ
      COMMON /BUFRS/ QONE, UONE, SPIX, RM, RMTHIK, THETYP
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C                                       End MTARS
LOCAL END
      PROGRAM MTARS
C-----------------------------------------------------------------------
C! Makes a model of Q and U in a text file suitable for TARS
C# Map Modeling Polarization
C-----------------------------------------------------------------------
C;  Copyright (C) 2020
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MTARS writes a text file with a polarization model
C   Inputs:
C     AIPS adverb  Prg. name.          Description.
C      INTEXT                       text file with frequencies
C      FLUX                         Noise level in Jy
C      INLIST                       Model components
C      OUTFILE                      Output file
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'MTARS.INC'
      DATA PRGM /'MTARS '/
C-----------------------------------------------------------------------
C                                       Get inputs, create output file
      CALL MTARSI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Apply model to image
      CALL MTARSD (IRET)
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE MTARSI (PRGN, IRET)
C-----------------------------------------------------------------------
C   MTARSI gets input parameters for MTARS and creates an output file.
C   Inputs:
C      PRGN    C*6       Program name
C   Output:
C      IRET    I         Error code: 0 => ok
C                           4 => user routine detected error.
C                           5 => catalog troubles
C                           8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   IRET
C
      INTEGER   IERR, NPARM, I
      INCLUDE 'MTARS.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 37
      CALL GTPARM (PRGN, NPARM, RQUICK, XINTXT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Convert characters
      CALL H2CHR (48, 1, XINTXT, INTEXT)
      CALL H2CHR (48, 1, XINLIS, INLIST)
      CALL H2CHR (48, 1, XOUTFI, OUTFIL)
      IF ((INLIST.EQ.' ') .OR. (INTEXT.EQ.' ') .OR. (OUTFIL.EQ.' '))
     *   THEN
         MSGTXT = 'AN INTEXT, INLIST AND OUTFILE MUST BE SPECIFIED'
         GO TO 990
         END IF
C                                       get frequencies
      CALL GETFRQ (IERR)
      IF (IERR.NE.0) GO TO 999
C                                       get components, err msg if error
      CALL READIT (IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (MSGTXT,1005) NGAUSS
      CALL MSGWRT (3)
      IF (NGAUSS.LE.0) THEN
         IRET = 10
         GO TO 999
         END IF
C                                       init random number generator
      IF (FLUX.GT.0.0) CALL RANDIN (I)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MTARSI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1005 FORMAT ('Will use',I5,' model components')
      END
      SUBROUTINE GETFRQ (IRET)
C-----------------------------------------------------------------------
C   FNDFQ reads the values of the frequency table
C   Outputs:
C      IRET    I   0 okay, 10 not match, else I/O error
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'MTARS.INC'
      INTEGER   TLUN, TIND, LUNTMP, LLIM, LP, JTRIM
      CHARACTER LINE*132
      DOUBLE PRECISION X
C-----------------------------------------------------------------------
C                                       read text file
      TLUN = LUNTMP (2)
C                                       open the text file
      CALL ZTXOPN ('READ', TLUN, TIND, INTEXT, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN INTEXT FILE'
         GO TO 990
         END IF
      NGAUSS = 0
 100  CALL ZTXIO ('READ', TLUN, TIND, LINE, IRET)
      IF ((IRET.EQ.0) .AND. (NFREQ.LT.MAXFRQ)) THEN
         LLIM = JTRIM (LINE)
         LP = 1
         IF (LINE(:1).EQ.'#') GO TO 100
         IF (LINE(:1).EQ.';') GO TO 100
         CALL GETNUM (LINE, LLIM, LP, X)
         IF ((X.EQ.DBLANK) .OR. (X.EQ.0.0D0)) GO TO 100
         NFREQ = NFREQ + 1
         FQVAL(NFREQ) = X
         GO TO 100
      ELSE IF (IRET.EQ.2) THEN
         CALL ZTXCLS (TLUN, TIND, IRET)
      ELSE IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ INTEXT FILE'
         GO TO 990
         END IF
      WRITE (MSGTXT,1100) NFREQ
      CALL MSGWRT (4)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETFRQ: ERROR ',I4,' ON ',A)
 1100 FORMAT ('GETFRQ read',I5,' frequencies from INTEXT')
      END
      SUBROUTINE READIT (IRET)
C-----------------------------------------------------------------------
C   Prepares list of components for adverbs or text file
C   Output
C      IRET   I   Error code
C   rest in Common
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'MTARS.INC'
      INTEGER   TLUN, TIND, LUNTMP, LLIM, LP, JTRIM
      CHARACTER LINE*132
      DOUBLE PRECISION X
C-----------------------------------------------------------------------
C                                       read text file
      TLUN = LUNTMP (2)
C                                       open the text file
      CALL ZTXOPN ('READ', TLUN, TIND, INLIST, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN TEXT FILE'
         GO TO 999
         END IF
      NGAUSS = 0
 100  CALL ZTXIO ('READ', TLUN, TIND, LINE, IRET)
      IF ((IRET.EQ.0) .AND. (NGAUSS.LT.MAXGAU)) THEN
         LLIM = JTRIM (LINE)
C                                       blanks, comments
         IF (LLIM.LE.0) GO TO 100
         IF (LINE(1:1).EQ.'#') GO TO 100
         IF (LINE(1:1).EQ.';') GO TO 100
C                                       parse
C                                       Q flux
         LP = 1
         CALL GETNUM (LINE, LLIM, LP, X)
         IF ((X.EQ.DBLANK) .OR. (X.EQ.0.0D0)) THEN
            GO TO 100
         ELSE
            NGAUSS = NGAUSS + 1
            QONE(NGAUSS) = X
            END IF
C                                       U flux
         CALL GETNUM (LINE, LLIM, LP, X)
         IF (X.EQ.DBLANK) THEN
            NGAUSS = NGAUSS - 1
            GO TO 100
         ELSE
            UONE(NGAUSS) = X
            END IF
C                                       Spectral index
         CALL GETNUM (LINE, LLIM, LP, X)
         IF (X.EQ.DBLANK) THEN
            NGAUSS = NGAUSS - 1
            GO TO 100
         ELSE
            SPIX(NGAUSS) = X
            END IF
C                                       RM
         CALL GETNUM (LINE, LLIM, LP, X)
         IF (X.EQ.DBLANK) THEN
            NGAUSS = NGAUSS - 1
            GO TO 100
         ELSE
            RM(NGAUSS) = X
            END IF
C                                       RM thickness
         CALL GETNUM (LINE, LLIM, LP, X)
         IF (X.EQ.DBLANK) THEN
            NGAUSS = NGAUSS - 1
            GO TO 100
         ELSE
            RMTHIK(NGAUSS) = X
            END IF
C                                       the type
         CALL GETNUM (LINE, LLIM, LP, X)
         THETYP(NGAUSS) = 0
         IF (RMTHIK(NGAUSS).NE.0.0D0) THETYP(NGAUSS) = 1
         IF (X.NE.DBLANK) THEN
            THETYP(NGAUSS) = X + 0.1D0
            END IF
         GO TO 100
C                                       real error
      ELSE IF ((IRET.GT.0) .AND. (IRET.NE.2)) THEN
         WRITE (MSGTXT,1000) IRET, 'READING TEXT FILE'
         GO TO 990
C                                       EOF
      ELSE
         CALL ZTXCLS (TLUN, TIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING TEXT FILE'
            GO TO 990
            END IF
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('READIT ERROR',I4,' ON ',A)
      END
      SUBROUTINE MTARSD (IRET)
C-----------------------------------------------------------------------
C   MTARSD writes the output text file computing the model for each freq
C   Output:
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   TLUN, TIND, I, LUNTMP, JP, JTRIM
      CHARACTER LINE*132
      DOUBLE PRECISION QVAL, UVAL
      INCLUDE 'MTARS.INC'
C-----------------------------------------------------------------------
      TLUN = LUNTMP (2)
      CALL ZTXOPN ('WRIT', TLUN, TIND, OUTFIL, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTFILE'
         GO TO 990
         END IF
      WRITE (LINE,1045)
      JP = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TLUN, TIND, LINE(:JP), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITING OUTFILE'
         GO TO 990
         END IF
      DO 50 I = 1,NGAUSS
         WRITE (LINE,1050) I, QONE(I), UONE(I), SPIX(I), RM(I),
     *      RMTHIK(I)
         JP = JTRIM (LINE)
         CALL ZTXIO ('WRIT', TLUN, TIND, LINE(:JP), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTFILE'
            GO TO 990
            END IF
 50      CONTINUE
C                                       loop over frequency
      DO 100 I = 1,NFREQ
         CALL THEMOD (FQVAL(I), QVAL, UVAL)
         WRITE (LINE,1100) FQVAL(I), QVAL, UVAL
         JP = JTRIM (LINE)
         CALL ZTXIO ('WRIT', TLUN, TIND, LINE(:JP), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTFILE'
            GO TO 990
            END IF
 100     CONTINUE
      CALL ZTXCLS (TLUN, TIND, IRET)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MTARSD ERROR',I4,' ON ',A)
 1045 FORMAT ('; MTARS',4X,'#',4X,'Qpol',5X,'Upol',3X,'Spix',8X,'RM',
     *   3X,'Thick')
 1050 FORMAT ('; MTARS',I5,2F9.3,F7.2,F10.1,F7.1)
 1100 FORMAT (3(1PE13.5))
      END
      SUBROUTINE THEMOD (FREQ, QVAL, UVAL)
C-----------------------------------------------------------------------
C   Apply model to one frequency
C   Inputs:
C      FREQ     D      Frequency in Hz
C   In/out
C      QVAL     D      Qpol model value
C      UVAL     D      Upol model value
C-----------------------------------------------------------------------
      DOUBLE PRECISION FREQ, QVAL, UVAL
C
      INCLUDE 'MTARS.INC'
      REAL      ANOISE
      INTEGER   K
      DOUBLE PRECISION QSUM, USUM, QV, UV
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      QSUM = 0.0D0
      USUM = 0.0D0
      DO 100 K = 1,NGAUSS
         CALL ROTMES (QONE(K), UONE(K), RM(K), RMTHIK(K), SPIX(K), FREQ,
     *      THETYP(K), QV, UV)
         QSUM = QSUM + QV
         USUM = USUM + UV
C                                       Add random noise?
         IF (FLUX.GT.0.0) THEN
            CALL NOISE (ANOISE)
            QSUM = QSUM + ANOISE * FLUX
            CALL NOISE (ANOISE)
            USUM = USUM + ANOISE * FLUX
            END IF
 100     CONTINUE
      QVAL = QSUM
      UVAL = USUM
C
 999  RETURN
      END
      SUBROUTINE NOISE (A)
C-----------------------------------------------------------------------
C   NOISE generates a random number approximately distributed in a
C   Gaussian manner about zero.  It does it by summing a uniformly-
C   distributed random number 12 times.
C   Output:
C      A   R       The current sample from the gaussian distribution
C-----------------------------------------------------------------------
      REAL      A, B
      INTEGER   J
C-----------------------------------------------------------------------
      A = -6.0
      DO 10 J = 1,12
         CALL RANDUM (B)
         A = A + B
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE ROTMES (QONE, UONE, RM, RMTHIK, SPIX, FREQ, MODEL,
     *   QV, UV)
C-----------------------------------------------------------------------
C   ROTMES computes the rotation measure rotated Q or U
C   Inputs:
C      QONE     R   Q at FREQ=1.E9
C      UONE     R   U at FREQ=1.E9
C      RM       R   Rotation measure in radians/m^2
C      SPIX     R   Spectral index
C      FREQ     D   Frequency
C      MODEL    I   Type of thickness model (2, 3, 4)
C   Outputs
C      QV       D   The Q at this lambda
C      UV       D   The Q at this lambda
C-----------------------------------------------------------------------
      INTEGER   MODEL
      REAL      QONE, UONE, RM, RMTHIK, SPIX
      DOUBLE PRECISION FREQ, QV, UV
C
      REAL      SPHI, CPHI, FACTOR
      DOUBLE PRECISION LAMONE, XX, DSINCS, LAMBSQ
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      FACTOR = (FREQ/1.D9) ** SPIX
      LAMONE = (VELITE / 1.D9) **2
      LAMBSQ = (VELITE / FREQ) ** 2
      IF (RMTHIK.NE.0.0) THEN
         XX = RMTHIK * LAMBSQ
         FACTOR = FACTOR * DSINCS (MODEL, 0, XX)
         END IF
      SPHI = FACTOR * SIN (2.0 * RM * (LAMBSQ - LAMONE))
      CPHI = FACTOR * COS (2.0 * RM * (LAMBSQ - LAMONE))
      QV = QONE * CPHI - UONE * SPHI
      UV = UONE * CPHI + QONE * SPHI
C
 999  RETURN
      END
      DOUBLE PRECISION FUNCTION DSINCS (MODEL, TYPE, XX)
C-----------------------------------------------------------------------
C   returns sin(xx)/xx on type 0 and d (sin(xx)/xx) / dx on type 1
C   Inputs:
C      MODEL   I   1 - sin(x)/x, 2 Gauss, 3 exp
C      TYPE    I   0 - return function, 1 return derivative
C      XX      D   argument
C   Output
C     DSINCS   D   function value or derivative
C-----------------------------------------------------------------------
      INTEGER   MODEL, TYPE
      DOUBLE PRECISION XX
C
      DOUBLE PRECISION F
C                                       1.8954 radians is the half-power
C                                       of sin(x) / x
C-----------------------------------------------------------------------
      DSINCS = 0.0D0
C                                       SIN(X)/X function
      IF (MODEL.EQ.1) THEN
         IF (TYPE.EQ.0) THEN
            IF (ABS(XX).LE.1.D-5) THEN
               DSINCS = 1.0D0 - XX*XX / 6.0D0 + XX*XX*XX*XX / 120.0D0
            ELSE
               DSINCS = SIN (XX) / XX
               END IF
C                                       SIN(X)/X derivative
         ELSE IF (TYPE.EQ.1) THEN
            IF (ABS(XX).LE.1.D-5) THEN
               DSINCS = -XX/3.D0 + XX*XX*XX/30.D0 -
     *            XX*XX*XX*XX*XX/840.D0
            ELSE
               DSINCS = (XX * COS(XX) - SIN(XX)) / (XX*XX)
               END IF
            END IF
C                                       Gauss function
      ELSE IF (MODEL.EQ.2) THEN
         F = -LOG (2.0D0) / (1.8954 * 1.8954)
         IF (TYPE.EQ.0) THEN
            DSINCS = EXP (F * XX * XX)
C                                       Gauss derivative
         ELSE IF (TYPE.EQ.1) THEN
            DSINCS = 2.0 * XX * F * EXP (F * XX * XX)
            END IF
C                                       Exp function
      ELSE IF (MODEL.EQ.3) THEN
         F = -LOG (2.0D0) / 1.8954
         IF (TYPE.EQ.0) THEN
            DSINCS = EXP (F * ABS(XX))
C                                       Exp derivative
         ELSE IF (TYPE.EQ.1) THEN
            DSINCS = F * EXP (F * ABS(XX))
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE FFT842 (IN, N, X)
C-----------------------------------------------------------------------
C! VMS Pseudo AP routine:  Full Complex FFT routine.
C#AP-FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   This program replaces the complex vector  X by its finite discrete,
C   complex Fourier transform if IN = 0.  The inverse transform is
C   calculated for IN=1.  It performs as many base 8 iterations as
C   possible and then finishes with a base 4 iteration or a base 2
C   iteration if needed.
C   Inputs:
C      IN  I       Transform direction; 0=>forward, 1=>reverse.
C      N   I       Number of points in array (must be power of two).
C   Input/Output:
C      X   I(2,N)  Complex array to transform / array transformed
C   Code Modified from:
C   Subroutine FFT842, by Bergland and Dolan
C   Programs for  Digital Signal Processing, IEEE press, 1979.
C   Uses routines R2TX, R4TX, R8TX.
C-----------------------------------------------------------------------
      REAL       X(2,*), PI2, P7, R, FI
      INTEGER    L(15), L1, L2, L3, L4, L5, L6, L7, L8, L9, L10, L11,
     *   L12, L13, L14, L15, I, J, M, NT, N2POW, NTHPO, N, IN, N8POW,
     *   IPASS, NXTLT, LENGT, J1, J2, J3, J4, J5, J6, J7, J8, J9, J10,
     *   J11, J12, J13, J14, JI, IJ, NXTLT2
      COMMON /CON2/ PI2, P7
      EQUIVALENCE (L15, L(1)), (L14, L(2)), (L13, L(3)), (L12, L(4)),
     *   (L11, L(5)), (L10, L(6)), (L9, L(7)), (L8, L(8)), (L7, L(9)),
     *   (L6, L(10)), (L5, L(11)), (L4, L(12)), (L3, L(13)),
     *   (L2, L(14)), (L1, L(15))
C-----------------------------------------------------------------------
      PI2 = 8.0 * ATAN (1.0)
      P7 = 1.0 / SQRT (2.0)
      DO 10 I = 1,15
         M = I
         NT = 2 ** I
         IF (N.EQ.NT) GO TO 20
 10      CONTINUE
 20   N2POW = M
      NTHPO = N * 2
      IF (IN.EQ.1) GO TO 40
      DO 30 I = 1,N
         X(2,I) = -X(2,I)
 30      CONTINUE
 40   N8POW = N2POW / 3
      IF (N8POW.EQ.0) GO TO 60
C                                       Radix 8 passes, if any.
      DO 50 IPASS = 1,N8POW
         NXTLT = 2 ** (N2POW-3*IPASS)
         NXTLT2 = 2 * NXTLT
         LENGT = 8 * NXTLT2
         CALL R8TX (NXTLT2, NTHPO, LENGT, X(1,1), X(1,NXTLT+1),
     *      X(1,2*NXTLT+1), X(1,3*NXTLT+1), X(1,4*NXTLT+1),
     *      X(1,5*NXTLT+1), X(1,6*NXTLT+1),  X(1,7*NXTLT+1),
     *      X(2,1), X(2,NXTLT+1), X(2,2*NXTLT+1), X(2,3*NXTLT+1),
     *      X(2,4*NXTLT+1), X(2,5*NXTLT+1), X(2,6*NXTLT+1),
     *      X(2,7*NXTLT+1))
 50      CONTINUE
C                                       Is there a factor of 4 left?
 60   IF (N2POW-3*N8POW-1) 90, 70, 80
C                                       Go through the base 2 iteration
 70   CALL R2TX (NTHPO, X(1,1), X(1,2), X(2,1), X(2,2))
      GO TO 90
C                                       Go through the base 4 iteration
 80   CALL R4TX (NTHPO, X(1,1), X(1,2), X(1,3), X(1,4), X(2,1), X(2,2),
     *   X(2,3), X(2,4))
 90   DO 110 J = 1,15
         L(J) = 1
         IF ((J-N2POW) .LE. 0) L(J) = 2 ** (N2POW+1-J)
 110     CONTINUE
      IJ = 1
      DO 130 J1 = 1,L1
         DO 130 J2 = J1,L2,L1
            DO 130 J3 = J2,L3,L2
               DO 130 J4 = J3,L4,L3
                  DO 130 J5 = J4,L5,L4
                     DO 130 J6 = J5,L6,L5
                        DO 130 J7 = J6,L7,L6
                           DO 130 J8 = J7,L8,L7
                              DO 130 J9 = J8,L9,L8
                                 DO 130 J10 = J9,L10,L9
                                    DO 130 J11 = J10,L11,L10
      DO 130 J12 = J11,L12,L11
         DO 130 J13 = J12,L13,L12
            DO 130 J14 = J13,L14,L13
               DO 130 JI = J14,L15,L14
                  IF (IJ .GE. JI) GO TO 130
                     R = X(1,IJ)
                     X(1,IJ) = X(1,JI)
                     X(1,JI) = R
                     FI = X(2,IJ)
                     X(2,IJ) = X(2,JI)
                     X(2,JI) = FI
 130              IJ = IJ + 1
      IF (IN.EQ.1) GO TO 150
      DO 140 I = 1,N
         X(2,I) = -X(2,I)
 140     CONTINUE
 150  CONTINUE
 170  RETURN
      END

      SUBROUTINE STCLOS (IRNO, IVOL, ISLOT, OUVER, BUF, IERR)
C-----------------------------------------------------------------------
C! Close an open Star table
C# EXT-util Map-util Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C STCLOS Will Close an open star table.
C   INPUTS:
C     IRNO   I   Number of STars in Table
C     IVOL   I   Disk number containing the ST table.
C     ISLOT  I   Catalog number
C     OUVER  I   Output ST version number
C     BUF    I   I/O Buffer
C   OUTPUT
C     IERR   I   I/O error number. 0=> OK
C-----------------------------------------------------------------------
      INTEGER IRNO, IVOL, ISLOT, OUVER, BUF(*), IERR
      CHARACTER HILINE*72, ATIME*8, ADATE*12, SBUF*80
      REAL      DUMMY
      INTEGER  IWBUFF(256), HLUN, IT(3), ID(3), IER
      LOGICAL   T
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA HLUN /28/
      DATA T/.TRUE./
C-----------------------------------------------------------------------
C                                       Normal EOF
 200  CALL TABIO ('CLOS', 0, IRNO, DUMMY, BUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1150) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
      WRITE (MSGTXT,1210) IRNO, OUVER
      CALL MSGWRT (4)
C                                       Add to history file
      CALL HIINIT (3)
      CALL HIOPEN (HLUN, IVOL, ISLOT, IWBUFF, IER)
      IF (IER.NE.0) GO TO 999
C                                       Prepare text and add to file
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, ATIME, ADATE)
      WRITE (SBUF,1211,ERR=215) TSKNAM, OUVER, IRNO, ADATE, ATIME
 215  HILINE = SBUF
      CALL HIADD (HLUN, HILINE, IWBUFF, IER)
      CALL HICLOS (HLUN, T, IWBUFF, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1150 FORMAT ('STCLOS: ERROR',I4,' WRITING ST FILE')
 1210 FORMAT ('STCLOS: Wrote',I6,' lines in ST file version',I4)
 1211 FORMAT (A6,' Version=',I3,' Lines=',I5,
     *   '  / Star file created ',A,A)
      END

      PROGRAM GRKEY
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   This program reads one or more gripe files and constructs a series
C   of cross-reference/index listings, especially the 'keys'
C     which are embedded in the gripes. Optionally, it can also produce
C     TEX files of gripes sorted by person and key in order to simplify
C     the distribution of "tbc" gripes to the programmers.
C     DCW, NRAO-CV, Mar-Apr85.
C     Notes:
C     1. consider producing "finalrun{T}" sorted by gripers?
C-----------------------------------------------------------------------
      IMPLICIT    NONE
      INCLUDE     '($SSDEF)'
      INTEGER     MAXCHAR, MXKSTR, MXLGRI, MXPERS, NSKIP, NCOL, MXF,
     *            KEYFLD
      PARAMETER   (MAXCHAR=5000, MXKSTR=24, MXLGRI=201, MXPERS=20)
      PARAMETER   (NSKIP=MXKSTR+3, NCOL=6, MXF=20, KEYFLD=1+4+1)
      INTEGER     L5, L6, L1, ITRIM, ISTAT, NGRIPE, L4, I, J, L2,
     *   LGRIPE, STR$UPCASE, L3, L, K, LIB$DATE_TIME, L7,
     *   L8, LASTJ, MXLPRT, NKEYL, N1, N5, LL, KK
      CHARACTER   COMMAND*120, FILESPEC*40, L1FILE*(MXF), L4FILE*80,
     *   GRARGS(9)*(MAXCHAR), GRIPE*(MAXCHAR), NEWLIN,
     *   KEYSTR*(MXKSTR), L2FILE*(MXF), LASTKEY*(MXKSTR),
     *   FOLDED*(MXKSTR), PERSON*(MXPERS), LASTPER*(MXPERS),
     *   KGRIPE(MXLGRI)*(KEYFLD), CLASS*1, L3FILE*(MXF),
     *   SPECIAL*(MXPERS), CODE*1, KEYTMP*(MXKSTR+3),
     *   PERTMP*(MXPERS), PERTM2*(MXPERS), LASTHD*(MXPERS),
     *   DATETIM*23, MODDAT*17, DELETE*10, L7FILE*(MXF),
     *   L8FILE*(MXF), L7KEYF*(KEYFLD), L7LAST*(KEYFLD),
     *   CODTMP*1, KEYL(20)*(MXKSTR)
      LOGICAL     QUIT, EXTRA, TOTAL, ALLKEY, DOTEX, DOKEY
      DATA MXLPRT /MXLGRI/
      DATA N1,N5 /1,5/
C-----------------------------------------------------------------------
      NKEYL = 0
      L1 = 1
      L1FILE = 'GRKEYONE.TMP'
      L2 = 2
      L2FILE = 'GRKEYTWO.TMP'
      OPEN (UNIT=L2, FILE=L2FILE, STATUS='NEW',
     *   ACCESS='SEQUENTIAL', FORM='FORMATTED', RECORDTYPE='FIXED',
     *   RECL=(KEYFLD+MXKSTR+MXPERS+MXKSTR), CARRIAGECONTROL='LIST')
      L3 = 3
      L3FILE = 'GRKEYALL.LIS'
      OPEN (L3, FILE=L3FILE, STATUS='NEW')
      L4 = 4
      L5 = 5
      L6 = 6
      L7 = 7
      L7FILE = 'GRKEYISAM.TMP'
      L8 = 8
      NEWLIN = '|||'
      IF (LIB$DATE_TIME (DATETIM).NE.SS$_NORMAL) STOP 'Date failed!'
      WRITE (L3,1003)
      WRITE (L3,1007) DATETIM
C                                       Special listing?
 10   CONTINUE
         WRITE (L6,1010)
         SPECIAL = ' '
         READ (L5,1011,ERR=10,END=900) SPECIAL
 15   CONTINUE
         NKEYL = 0
         WRITE (L6,1015)
 16      NKEYL = NKEYL + 1
            WRITE (L6,1016) NKEYL
            READ (L5,1011,ERR=15,END=900) KEYL(NKEYL)
            IF (KEYL(NKEYL).NE.' ') THEN
               IF (STR$UPCASE(FOLDED, KEYSTR).NE.SS$_NORMAL)
     *            GO TO 990
               GO TO 16
               END IF
         NKEYL = NKEYL - 1
         IF ((SPECIAL.EQ.' ') .AND. (NKEYL.GT.0)) SPECIAL = 'Everyone'
C                                       Ask for listing options:
 20   CONTINUE
         WRITE (L6,1020)
         READ (L5,1021,ERR=20,END=900) TOTAL
 25   CONTINUE
         WRITE (L6,1025)
         READ (L5,1021,ERR=25,END=900) ALLKEY
 30   CONTINUE
         WRITE (L6,1030)
         READ (L5,1021,ERR=30,END=900) EXTRA
C                                       TEX file
      DOTEX = (SPECIAL.NE.' ') .OR. (NKEYL.GT.0)
      IF (DOTEX) THEN
         L8FILE = 'GRKEY' // SPECIAL(:ITRIM(SPECIAL)) // '.TEX'
         WRITE (L6,1035) L8FILE(:ITRIM(L8FILE))
         OPEN (L8, FILE=L8FILE, STATUS='NEW', ERR=10,
     *      CARRIAGECONTROL='LIST')
         WRITE (L8,1036)
         OPEN (L7, FILE=L7FILE, STATUS='SCRATCH', ACCESS='KEYED',
     *      CARRIAGECONTROL='LIST', FORM='FORMATTED',
     *      KEY=(1:KEYFLD:CHARACTER), ORGANIZATION='INDEXED',
     *      RECL = (KEYFLD+MAXCHAR), RECORDTYPE='FIXED')
         L7LAST = '<garp>'
         END IF
C                                       Get gripe file search string:
 40   WRITE (L6,1040)
      READ (L5,1011,ERR=40,END=900) FILESPEC
      IF (FILESPEC.EQ.' ') THEN
         IF (.NOT.DOTEX) FILESPEC = 'AIPSGRIP:GT%%%%,GX%%%%'
         IF (DOTEX) FILESPEC = 'AIPSGRIP:GT%%%%'
         END IF
C                                       Get directory of gripe files:
      COMMAND = 'DIR/NOHE/NOTR/VER=1/DAT/OUT=' //
     *   L1FILE(1:ITRIM(L1FILE)) // ' ' // FILESPEC
      CALL DCLCMD (L6, COMMAND, ISTAT)
      IF (ISTAT.NE.0) STOP 'Bad Status from DIR'
      OPEN (UNIT=L1, FILE=L1FILE, STATUS='OLD')
C                                       Loop to read gripe files:
 100  CONTINUE
         READ (L1,'(A64,/,21X,A17)',END=180) L4FILE, MODDAT
         WRITE (L3,'(1X,A,1X,A)') L4FILE(:ITRIM(L4FILE)), MODDAT
         WRITE (L6,'(1X,A,1X,A)') L4FILE(:ITRIM(L4FILE)), MODDAT
         OPEN (UNIT=L4, FILE=L4FILE, STATUS='OLD', ERR=980)
         I = INDEX (L4FILE, ']')
         CLASS = L4FILE(I+2:I+3)
C                                       loop to read the gripes:
 110     CONTINUE
            CALL GETGRI (L3, L4, NEWLIN, NGRIPE, GRIPE, GRARGS)
            IF (GRIPE.EQ.' ') GO TO 150
C                                       clean up PERSON string:
               PERSON = GRARGS(7)(2:(ITRIM(GRARGS(7))-1))
               IF (PERSON.EQ.' ') PERSON = '<blank>'
               IF (PERSON.EQ.'\ewg') PERSON = 'Eric'
               DO 115 K = 1,3
                  J = INDEX (PERSON, ',')
                  IF (J.NE.0) PERSON(J:J) = '/'
 115              CONTINUE
               DELETE = '   ??(())'
               KK = ITRIM (DELETE)
               DO 120 K = 1,KK
                  J = INDEX (PERSON, DELETE(K:K))
                  IF (J.EQ.1) PERSON = PERSON(J+1:)
                  IF (J.GT.1) PERSON = PERSON(:J-1) // PERSON(J+1:)
 120              CONTINUE
C                                       generate summary entries:
               KEYSTR = 'Final answers'
               IF (INDEX (GRARGS(9), '\newgripe').NE.0) KEYSTR =
     *            '\newgripe'
               IF (INDEX (GRARGS(9), '\tbcnew').NE.0) KEYSTR =
     *            '\tbcnew'
               IF ((KEYSTR(1:5).EQ.'Final') .AND.
     *            (INDEX (GRARGS(9), '\tbc').NE.0)) KEYSTR = '\tbc'
               IF ((KEYSTR(1:4).EQ.'\tbc') .AND.
     *            (INDEX (GRARGS(9), '\changed').NE.0)) KEYSTR =
     *             KEYSTR(:ITRIM(KEYSTR)) // '\changed'
               IF ((INDEX (GRARGS(9), '\changed').NE.0) .AND.
     *            (INDEX (GRARGS(9), '\tbc').EQ.0)) KEYSTR =
     *            '\changed [no \tbc]'
C                                       set suffix code:
               CODE = ' '
               IF (KEYSTR(1:5).EQ.'Final') CODE = 'f'
               IF (KEYSTR.EQ.'\tbcnew') CODE = 'n'
               IF (KEYSTR.EQ.'\tbc')   CODE = 't'
               IF (INDEX (KEYSTR, '\changed').NE.0) CODE = 'c'
               PERTMP = ' All gripes.'
               IF (STR$UPCASE(FOLDED, KEYSTR).NE.SS$_NORMAL)
     *            GO TO 990
               IF (TOTAL) WRITE (L2,1123) CLASS, NGRIPE, CODE,
     *            KEYSTR, PERTMP, FOLDED
               KEYSTR = 'Complete list'
               IF (STR$UPCASE(FOLDED, KEYSTR).NE.SS$_NORMAL)
     *            GO TO 990
               IF (TOTAL) WRITE (L2,1123) CLASS, NGRIPE, CODE,
     *            KEYSTR, PERTMP, FOLDED
C                                       all machines/sites:
               KEYSTR = '~' // GRARGS(2)
               IF (STR$UPCASE(FOLDED, KEYSTR).NE.SS$_NORMAL)
     *            GO TO 990
               IF (EXTRA) WRITE (L2,1123) CLASS, NGRIPE, CODE,
     *            KEYSTR, PERTMP, FOLDED
C                                       all gripers:
               KEYSTR = '~~' // GRARGS(3)
               IF (STR$UPCASE(FOLDED, KEYSTR).NE.SS$_NORMAL)
     *            GO TO 990
               IF (EXTRA) WRITE (L2,1123) CLASS, NGRIPE, CODE,
     *            KEYSTR, PERTMP, FOLDED
               IF (INDEX (GRIPE, '\key{').EQ.0) THEN
                  KEYSTR = '[no \key]'
                  IF (STR$UPCASE(FOLDED, KEYSTR).NE.SS$_NORMAL)
     *               GO TO 990
                  WRITE (L2,1123) CLASS, NGRIPE, CODE,
     *               KEYSTR, PERTMP, FOLDED
                  END IF
C                                       loop to scan for keys:
               I = 1
 125           CONTINUE
                  J = INDEX (GRIPE(I:), '\key{')
                  IF ((J.EQ.0) .AND. (I.GT.1)) GO TO 110
                  IF (J.GT.0) THEN
                     I = I + J - 1
                     J = MAX (INDEX (GRIPE(I:), '}'), N5) - 2
                     KEYSTR = GRIPE(I+5:I+J)
                  ELSE
                     KEYSTR = '[no \key]'
                     I = 1
                     END IF
                  I = I + 4
                  IF (KEYSTR.EQ.' ') KEYSTR = '[empty \key{}]'
                  IF (KEYSTR(1:4).EQ.'\tt ') KEYSTR = KEYSTR(5:)
                  IF (STR$UPCASE(FOLDED, KEYSTR).NE.SS$_NORMAL)
     *               GO TO 990
C                                       desired key?
                  DOKEY = NKEYL.LE.0
                  IF (.NOT.DOKEY) THEN
                     DO 130 J = 1,NKEYL
                        IF (KEYSTR.EQ.KEYL(J)) DOKEY = .TRUE.
 130                    CONTINUE
                     END IF
                  IF (.NOT.DOKEY) GO TO 125
C                                       decide whether to print:
                  IF ((PERSON(1:1).EQ.' ') .OR.
     *               (INDEX(PERSON, '/').GT.0) .OR.
     *               (INDEX(PERSON, '?').GT.0) .OR.
     *               (INDEX(PERSON, '<').GT.0) .OR.
     *               (INDEX(PERSON, '.').GT.0) .OR.
     *               (INDEX(PERSON, ',').GT.0) .OR.
     *               (INDEX(PERSON, '\').GT.0) .OR.
     *               (ITRIM(PERSON).GE.MXPERS) .OR.
     *               (INDEX(KEYSTR, '\').GT.0) .OR.
     *               (INDEX(KEYSTR, '{').GT.0) .OR.
     *               (J+1.GT.MXKSTR))THEN
                     WRITE (L3,1124) CLASS, NGRIPE, CODE, KEYSTR,
     *                  PERSON
                     WRITE (L6,1124) CLASS, NGRIPE, CODE, KEYSTR,
     *                  PERSON
                     END IF
                  PERTMP = ' All keys.'
                  IF (ALLKEY) WRITE (L2,1123) CLASS, NGRIPE, CODE,
     *               KEYSTR, PERTMP, FOLDED
C                 IF ((CODE.EQ.'f') .OR. (CODE.EQ.'c')) GO TO 125
C                                       loop for multiple-persons:
                  PERTMP = PERSON
                  CODTMP = CODE
 140              CONTINUE
                     J = INDEX (PERTMP, '/')
                     IF (J.EQ.0) J = ITRIM (PERTMP) + 1
                     PERTM2 = PERTMP(:J-1)
                     IF (PERTM2.EQ.'PatMoore') PERTM2 = 'Pat'
                     IF ((.NOT.DOTEX) .OR. (SPECIAL.EQ.PERTM2)
     *                     .OR. (SPECIAL.EQ.'Everyone')) THEN
                        WRITE (L2,1123) CLASS, NGRIPE, CODE,
     *                     KEYSTR, PERTM2, FOLDED
                        IF (DOTEX) THEN
                           WRITE (L7KEYF,1140) CLASS, NGRIPE, CODE
                           IF ((L7KEYF.NE.L7LAST) .AND. (CODE.NE.'f')
     *                        .AND. (CODE.NE.'c')) WRITE (L7,16051)
     *                        L7KEYF, GRIPE
                           L7LAST = L7KEYF
                           END IF
                        END IF
                     IF (PERTM2.EQ.PERTMP) PERTMP = ' '
                     IF (J.LT.MXPERS) PERTMP = PERTMP(J+1:)
                     CODTMP = 's'
                     IF (PERTMP.NE.' ') GO TO 140
                  GO TO 125
C                                       End of individual input file
 150     CLOSE (UNIT=L4)
         GO TO 100
C                                       End of reading inputs
 180  CLOSE (UNIT=L1)
      COMMAND = 'DEL/LOG ' // L1FILE(:ITRIM(L1FILE)) // '.*'
      CALL DCLCMD (L6, COMMAND, ISTAT)
      CLOSE (UNIT=L2, STATUS='KEEP')
C                                       Sort on the keystrings:
      WRITE (COMMAND,1160) (KEYFLD+MXKSTR+1), MXPERS,
     *            (KEYFLD+MXKSTR+MXPERS+1), MXKSTR, L2FILE, L2FILE
      CALL DCLCMD (L6, COMMAND, ISTAT)
      IF (ISTAT.NE.0) STOP 'The SORT gave a bad status!'
      COMMAND = 'PURGE/LOG ' // L2FILE
      CALL DCLCMD (L6, COMMAND, ISTAT)
      IF (ISTAT.NE.0) STOP 'The PURGE gave a bad status!'
C                                       Print the list:
      OPEN (L2, FILE=L2FILE, STATUS='OLD')
      QUIT = .FALSE.
      LASTKEY = ' '
      LGRIPE = 0
      LASTJ = - 1
      LASTHD = 'nothing'
      LASTPER = LASTHD
 210  CONTINUE
         READ (L2,1123,END=212,ERR=280) CLASS, J, CODE, KEYSTR,
     *                                                      PERSON
            IF ((J.NE.LASTJ).OR.(KEYSTR.NE.LASTKEY)) GO TO 7211
               DO 7210 L = L3,L6,(L6-L3)
 7210             WRITE (L,17210) CLASS, J, CODE
 7211       CONTINUE
            LASTJ = J
            LGRIPE = LGRIPE + 1
            WRITE (KGRIPE(LGRIPE),'(A1,I4.4,A1)') CLASS, J, CODE
            IF ((.NOT.DOTEX) .OR. (PERSON.EQ.' All gripes.')
     *         .OR. (PERSON.EQ.' All keys.')) GO TO 211
               IF ((CODE.EQ.'f') .OR. (CODE.EQ.'c')) GO TO 211
               READ (L7,16051,KEYEQ=KGRIPE(LGRIPE)) L7KEYF, GRIPE
               IF (L7KEYF.NE.KGRIPE(LGRIPE)) STOP 'Bad L7KEYF !?!'
               CALL WRIGRI (L3, L8, NEWLIN, GRIPE)
 211        CONTINUE
C            WRITE (L3,'('' debug:'',A,1X,A,1X,A)')
C     *                        KGRIPE(LGRIPE), KEYSTR, PERSON
            GO TO 213
 212     CONTINUE
            QUIT = .TRUE.
            KEYSTR = 'garbage'
            PERSON = KEYSTR
            LGRIPE = LGRIPE + 1
            KGRIPE(LGRIPE) = KEYSTR
 213     CONTINUE
         IF ((KEYSTR.EQ.LASTKEY) .AND. (PERSON.EQ.LASTPER) .AND.
     *      (LGRIPE.LT.MXLPRT)) GO TO 210
         IF (LASTPER.EQ.'nothing') GO TO 230
            IF (LASTPER.EQ.LASTHD) GO TO 220
               WRITE (L3,1007) DATETIM
               DO 214 L = L3,L6,(L6-L3)
 214              WRITE (L,1214) LASTPER
               LASTHD = LASTPER
 220        CONTINUE
            KEYTMP = '  -  -  -  -  -  -  -  -  -  -  -  -  -  -'
            KEYTMP(MXKSTR:) = '- ->'
            J = MIN (ITRIM (LASTKEY) + N1, MXKSTR)
            KEYTMP(:J) = LASTKEY(:J)
            DO 225 L = L3,L6,(L6-L3)
               J = MIN ((LGRIPE-N1), NCOL)
               WRITE (L,1220) KEYTMP, (KGRIPE(I), I = 1,J)
               IF (J.EQ.(LGRIPE-1)) GO TO 225
               DO 6224 J = (NCOL+1),(LGRIPE-1),NCOL
                  K = MIN ((J+NCOL-N1), (LGRIPE-N1))
 6224             WRITE (L,1221) (KGRIPE(I), I = J,K)
 225           CONTINUE
            KGRIPE(1) = KGRIPE(LGRIPE)
            LGRIPE = 1
 230     CONTINUE
         IF (QUIT) GO TO 290
         LASTKEY = KEYSTR
         LASTPER = PERSON
         GO TO 210
 280  STOP 'READ-Error at stmnt.210!'
 290  CONTINUE
      CLOSE (UNIT=L2)
      COMMAND = 'DEL/LOG ' // L2FILE(:ITRIM(L2FILE)) // '.*'
      CALL DCLCMD (L6, COMMAND, ISTAT)
      CLOSE (UNIT=L3, DISPOSE='KEEP')
      COMMAND = 'PUR/LOG ' // L3FILE(:ITRIM(L3FILE))
      CALL DCLCMD (L6, COMMAND, ISTAT)
      IF (DOTEX) THEN
         WRITE (L8,1290)
         CLOSE (UNIT=L8, DISPOSE='KEEP')
         COMMAND = 'PUR/LOG ' // L8FILE(:ITRIM(L8FILE))
         CALL DCLCMD (L6, COMMAND, ISTAT)
         CLOSE (UNIT=L7)
         END IF
C                                       Thats all, folks:
 900  CONTINUE
      COMMAND = 'DIR/DAT/SIZ GRKEY*'
      CALL DCLCMD (L6, COMMAND, ISTAT)
      GO TO 999
C                                       Error: stops
 980  STOP 'Could not OPEN the file!'
 990  STOP 'Casefold failed!'
C
 999  STOP
C-----------------------------------------------------------------------
 1010 FORMAT (' GRKEY: person name for a special listing: ', $)
 1011 FORMAT (A40)
 1015 FORMAT (' GRKEY: keyword name(s) for a special listing, ' ' ends')
 1016 FORMAT (' GRKEY: key number',I4,': ', $)
 1020 FORMAT (' GRKEY: produce the  "complete" list? T/F: ', $)
 1021 FORMAT (L1)
 1025 FORMAT (' GRKEY: produce the   "All key" list? T/F: ', $)
 1030 FORMAT (' GRKEY: produce the site/griper list? T/F: ', $)
 1035 FORMAT (' GRKEY:      special listing file will be: ', A)
 1036 FORMAT ('\input aipsgrip:gripemac5.tex', /, '\def\finalrun{F}', /)
 1040 FORMAT (' GRKEY: enter gripe file specification(s): ', $)
C
 1003 FORMAT (' ^PY^-'/' ^IOP^IL0600^IS404^IC1000^IJ00450^IT00700^PN^-')
 1007 FORMAT ('1               Gripe key listing prepared  ', A, /)
 1123 FORMAT (A1, I4.4, A1, A, A, A)
 1124 FORMAT (1X, A1, I4.4, A1, 1X, A, 1X, A)
 1140 FORMAT (A1, I4.4, A1)
16051 FORMAT (A<KEYFLD>, A<MAXCHAR>)
17210 FORMAT (' GRKEY: gripe ', A1, I4.4, A1, ' is a duplicate!')
 1160 FORMAT ('SOR/K=(POS:', I2, ',SIZ:', I2, ',ASC)',
     *           '/K=(POS:', I2, ',SIZ:', I2, ',ASC)',
     *           '/K=(POS:2,SIZ:4,ASC)/STAB ', A, 1X, A)
 1214 FORMAT ( '                             ------------', /,
     *         '                             ',A,           /,
     *         '                             ------------', /)
 1220 FORMAT (' ',        A, 1X, <NCOL>(A, 2X))
 1221 FORMAT (' ', <NSKIP>X, 1X, <NCOL>(A, 2X))
 1290 FORMAT (/, '\end')
      END

LOCAL INCLUDE 'BPSMO.INC'
      INCLUDE 'INCS:PUVD.INC'
      REAL      XSEQ, XDISK, XVER, XBCHAN, XECHAN, XDOWT, APARM(10)
      HOLLERITH XINNAM(3), XINCLS(2)
      CHARACTER INNAM*12, INCLS*6
      COMMON /INPARM/ XINNAM, XINCLS, XSEQ, XDISK, XVER, XBCHAN, XECHAN,
     *   XDOWT, APARM
      COMMON /CHPARM/ INNAM, INCLS
      INTEGER   MAXFQI, MAXSUB
      PARAMETER (MAXFQI=1000)
      PARAMETER (MAXSUB=100)
      INTEGER   INSEQ, INDISK, BPVER, CNO, IUSER, OUTVER, BPBUFO(512),
     *   OBPRNO, ISFQID(MAXFQI), ISANT(MAXANT+1), MAXREC, STYPE,
     *   BPKOLO(MAXBPC), BPNUMO(MAXBPC), ISUBAR(MAXSUB), BCHAN, ECHAN,
     *   DONORM
      DOUBLE PRECISION TIME, TIMBEG, TIMEND
      REAL      WEIGHT(2*MAXIF), BNDPAS(2,MAXCIF)
      LOGICAL   REPAIR
      COMMON /BPSMOC/ TIME, TIMBEG, TIMEND, BPBUFO, INSEQ, INDISK,
     *   BPVER, CNO, IUSER, OUTVER, OBPRNO, ISFQID, ISANT, ISUBAR,
     *   WEIGHT, BNDPAS, MAXREC, BPKOLO, BPNUMO, STYPE, BCHAN, ECHAN,
     *   DONORM, REPAIR
      INCLUDE 'INCS:DBPC.INC'
LOCAL END
      PROGRAM BPSMO
C-----------------------------------------------------------------------
C! Computes bandpass table at regular intervals from input one
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1996-1998, 2005, 2009, 2011-2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Smooths/interpolates bandpass table to regular intervals
C   Inputs from user
C      INNAME.....Input UV file name (name).      Standard defaults.
C      INCLASS....Input UV file name (class).     Standard defaults.
C      INSEQ......Input UV file name (seq. #).    0 => highest.
C      INDISK.....Disk drive # of input UV file.  0 => any.
C      BPVER......Specifies the version of the BP table to be read as
C                 input.   0 -> highest.
C                 The output version is always highest + 1.
C      APARM......Specifies the type of time smoothing to be applied to
C                 the bandpass table.
C              APARM(1) = type of smoothing to apply:
C                 0 => Two-point (linear between nearest neighbors)
C                 1 => Hanning (linear)
C                 2 => Gaussian
C                 3 => Boxcar
C                 4 => Sinc (i.e. sin(x)/x)
C              APARM(2) = the "diameter" of the function in hours, i.e.
C                 width between first nulls of Hanning triangle and sinc
C                 function, FWHM of Gaussian, width of Boxcar
C                 0 => 1 hour.
C              APARM(3) = the diameter over which the smoothing function
C                 has value in hours.  Defaults: 1, 3, 1, 4 times
C                 APARM(2) used when input APARM(3) < net APARM(2).
C              APARM(4) = increment between output bandpass solutions in
C                 hours.  0 -> 1 hour.
C-----------------------------------------------------------------------
      INTEGER   IRET
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'BPSMO.INC'
C-----------------------------------------------------------------------
C                                       Get parms, open things
      CALL BPSMIN (IRET)
C                                       do smoothing
      IF (IRET.EQ.0) CALL BPSMOT (IRET)
C                                       do history
      IF (IRET.EQ.0) CALL BPSMHI (IRET)
C                                       close down
      CALL DIE (IRET, BPBUFF)
C
 999  STOP
      END
      SUBROUTINE BPSMIN (IERR)
C-----------------------------------------------------------------------
C   BPSMIN performs initialization for AIPS task BPSMO.  It gets the
C   adverbs, opens the catalog file for 'WRIT', sorts and opens the BP
C   input file, creates the BP output file, and determines which FQs,
C   times, and antenna counts apply to the table.
C   Output:
C      IERR    I      Error code: 0 => keep going, else quit.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'BPSMO.INC'
      CHARACTER INTYP*2, STAT*4, PRGN*6, KEYS(2)*24, LTYPBP*8
      INTEGER   NPARM, IROUND, BPLUN, JERR, I, J, KEY(2,2), NKEY, ANTNO,
     *   SUBA, SOURID, BPREF(2), FREQID, OANTNO, BPLUNO, KOLS(2),
     *   MXFQID(MAXFQI), KEYSUB(2,2)
      REAL      FKEY(2,2), INTERV
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA BPLUN, BPLUNO, INTYP /27, 28, 'UV'/
      DATA PRGN /'BPSMO '/
      DATA NKEY /2/
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
      DATA KEYS /'ANTENNA ', 'TIME '/
C-----------------------------------------------------------------------
C                                       AIPS init
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NCFILE = 0
      NSCR = 0
C                                       get adverbs
      NPARM = 21
      IERR = 0
      CALL GTPARM (PRGN, NPARM, RQUICK, XINNAM, BPBUFF, JERR)
      IF (JERR.NE.0) THEN
         RQUICK = .TRUE.
         IERR = 8
         IF (JERR.EQ.1) THEN
            GO TO 999
         ELSE
            WRITE (MSGTXT,1000) JERR, 'GET INPUT ADVERBS'
            CALL MSGWRT (8)
            END IF
         END IF
C                                       restart AIPS
      IF (RQUICK) CALL RELPOP (IERR, BPBUFF, JERR)
      IF (IERR.NE.0) GO TO 999
C                                       Hollerith -> Char
      CALL H2CHR (12, 1, XINNAM, INNAM)
      CALL H2CHR (6, 1, XINCLS, INCLS)
      INSEQ = IROUND (XSEQ)
      INDISK = IROUND (XDISK)
      BPVER = IROUND (XVER)
      IUSER = NLUSER
      CNO = 1
      CALL CATDIR ('SRCH', INDISK, CNO, INNAM, INCLS, INSEQ, INTYP,
     *   IUSER, STAT, BPBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, INNAM, INCLS, INSEQ, INTYP,
     *      INDISK, IUSER
         GO TO 990
         END IF
C                                       Get catblk, mark file write
      CALL CATIO ('READ', INDISK, CNO, CATBLK, 'WRIT', BPBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READ CATALOG HEADER'
         GO TO 990
         END IF
      NCFILE = 1
      FVOL(1) = INDISK
      FCNO(1) = CNO
      FRW(1) = 1
C                                       Open BP file
      CALL BPREFM (INDISK, CNO, BPVER, CATBLK, BPLUN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL BPINI ('READ', BPBUFF, INDISK, CNO, BPVER, CATBLK, BPLUN,
     *   IBPRNO, BPKOLS, BPNUMV, NANTBP, NPOLBP, NIFBP, NCHNBP, BCHNBP,
     *   NUMSHF, LOWSHF, DELSHF, LTYPBP, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN INPUT BP TABLE'
         GO TO 990
         END IF
      WPOLY = LTYPBP.NE.' '
C                                       Set column pointers for sort
      CALL FNDCOL (NKEY, KEYS, 24, .TRUE., BPBUFF, KOLS, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FIND BP COLUMNS'
         GO TO 990
         END IF
C                                       Sort to ant-time order
      IF ((BPBUFF(43).NE.KOLS(1)) .OR. (BPBUFF(44).NE.KOLS(2))) THEN
C                                       Close
         CALL TABIO ('CLOS', 0, IBPRNO, BPBUFF, BPBUFF, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'CLOSE BP TABLE'
            GO TO 990
            END IF
C                                       sort
         KEY(1,1) = KOLS(1)
         KEY(2,1) = KOLS(1)
         KEY(1,2) = KOLS(2)
         KEY(2,2) = KOLS(2)
         CALL TABSRT (INDISK, CNO, 'BP', BPVER, BPVER, KEY, KEYSUB,
     *      FKEY, BPBUFF, CATBLK, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'SORT BP TABLE'
            GO TO 990
            END IF
C                                       Re-open BP table for read
         CALL BPINI ('READ', BPBUFF, INDISK, CNO, BPVER, CATBLK, BPLUN,
     *      IBPRNO, BPKOLS, BPNUMV, NANTBP, NPOLBP, NIFBP, NCHNBP,
     *      BCHNBP, NUMSHF, LOWSHF, DELSHF, LTYPBP, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPEN INPUT BP TABLE'
            GO TO 990
            END IF
         END IF
C                                       number of records
      NBPINR = BPBUFF(5)
      CALL FILL (MAXANT+1, 0, ISANT)
      CALL FILL (MAXSUB, 0, ISUBAR)
      CALL FILL (MAXFQI, 0, ISFQID)
      CALL FILL (MAXFQI, 0, MXFQID)
      MAXREC = 0
      TIMBEG = 1.E10
      TIMEND = -1.E10
      OANTNO = 0
      DO 50 I = 1,NBPINR
         CALL TABBP ('READ', BPBUFF, IBPRNO, BPKOLS, BPNUMV, NIFBP,
     *      NCHNBP, NPOLBP, TIME, INTERV, SOURID, SUBA, ANTNO,
     *      CHNBND, BPFREQ, FREQID, BPREF, WEIGHT, BNDPAS, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READ BP TABLE'
            GO TO 990
            END IF
         SUBA = MAX (1, SUBA)
         ISUBAR(SUBA) = ISUBAR(SUBA) + 1
         TIMBEG = MIN (TIMBEG, TIME)
         TIMEND = MAX (TIMEND, TIME)
         IF (ANTNO.NE.OANTNO) THEN
            DO 20 J = 1,MAXFQI
               MAXREC = MAX (MAXREC, MXFQID(J))
               MXFQID(J) = 0
 20            CONTINUE
            ISANT(ANTNO) = I
            OANTNO = ANTNO
            END IF
         IF (FREQID.GT.MAXFQI) THEN
            MSGTXT = 'TOO MANY FQ ENTRIES: QUITTING'
            IERR = 8
            GO TO 990
            END IF
         FREQID = MAX (1, FREQID)
         ISFQID(FREQID) = 1
         MXFQID(FREQID) = MXFQID(FREQID) + 1
 50      CONTINUE
      ISANT(ANTNO+1) = NBPINR+1
      DO 60 J = 1,MAXFQI
         MAXREC = MAX (MAXREC, MXFQID(J))
 60      CONTINUE
C                                       create new BP table
      OUTVER = 0
      CALL BPINI ('WRIT', BPBUFO, INDISK, CNO, OUTVER, CATBLK, BPLUNO,
     *   OBPRNO, BPKOLO, BPNUMO, NANTBP, NPOLBP, NIFBP, NCHNBP, BCHNBP,
     *   NUMSHF, LOWSHF, DELSHF, LTYPBP, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CREATE BP TABLE'
         GO TO 990
         END IF
C                                       set up APARM
      STYPE = IROUND (APARM(1))
      IF ((STYPE.LT.0) .OR. (STYPE.GT.4)) STYPE = 0.
      IF (APARM(2).LE.0.001) APARM(2) = 1.0
      IF (APARM(3).LT.APARM(2)) THEN
         APARM(3) = APARM(2)
         IF (STYPE.EQ.2) APARM(3) = 3.0 * APARM(3)
         IF (STYPE.EQ.4) APARM(3) = 4.0 * APARM(3)
         END IF
      REPAIR = APARM(4).LT.-0.001
      IF (APARM(4).LT.0.001) APARM(4) = 1.0
      APARM(2) = APARM(2) / 24.0
      APARM(3) = APARM(3) / 24.0
      APARM(4) = APARM(4) / 24.0
      IF ((WPOLY) .OR. (APARM(5).GT.0.001)) STYPE = STYPE + 100
C                                       set up normalization
      IF ((XBCHAN.LT.-0.0001) .OR. (WPOLY)) THEN
         BCHAN = -1
         ECHAN = -1
         DONORM = -1
      ELSE
         DONORM = 1
         IF (APARM(5).GT.0.001) DONORM = 2
         BCHAN = IROUND (XBCHAN)
         ECHAN = IROUND (XECHAN)
         IF ((BCHAN.EQ.0) .OR. (BCHAN.GT.NCHNBP)) THEN
            BCHAN = NCHNBP / 8.0 + 0.76
            BCHAN = MAX (1, BCHAN)
            ECHAN = NCHNBP + 1 - BCHAN
         ELSE
            ECHAN = MIN (ECHAN, NCHNBP)
            END IF
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPSMIN: ERROR',I5,' ON ',A)
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,1X,A2,
     *   'DISK=',I2,' USER=',I5)
      END
      SUBROUTINE BPSMOT (IERR)
C-----------------------------------------------------------------------
C   BPSMOT uses the open BP tables, reading one and writing a smoothed
C   output to the other.
C   Output:
C      IERR   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'BPSMO.INC'
      INTEGER   I, J, NWT, NBP, J1, J2, IA, ISU, IFQ, NREC, ITI, NT,
     *   SOURID, SUBA, ANTNO, FREQID, SOURD, BREF(2), BPREF(2), NWD,
     *   JERR, NOWAIT, IROUND
      LONGINT   LBP, LWT
      REAL      INTERV, TIMES(4000), INTRV, CHNB
      DOUBLE PRECISION BPFRQ(MAXIF)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      NWT = NPOLBP * NIFBP
      NBP = 2 * NPOLBP * NIFBP * NCHNBP
      NOWAIT = IROUND (XDOWT)
      IF (NOWAIT.EQ.0) NOWAIT = -1
      NOWAIT = MAX (-2, MIN (2, NOWAIT))
C                                       allocate summing memories
      NWD = NBP * MAXREC
      NWD = (NWD - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', 'BPSMOT', NWD, BPBUF, PBPBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'GET MEMORY FOR BP DATA'
         GO TO 990
         END IF
      NWD = NWT * MAXREC
      NWD = (NWD - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', 'BPSMOT', NWD, VLBUF, PVLBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'GET MEMORY FOR WT DATA'
         GO TO 990
         END IF
C                                       time parameters
      J1 = TIMBEG / APARM(4) + 0.0001
      J2 = (TIMEND - 0.0001) / APARM(4) + 1.0
      IF (J2.LT.J1) THEN
         MSGTXT = 'NO TIMES FOUND'
         IERR = 8
         GO TO 990
         END IF
      TIMBEG = J1 * APARM(4)
      TIMEND = J2 * APARM(4)
      NT = J2 - J1 + 1
C                                       loop over FQ and antenna
      DO 200 IFQ = 1,MAXFQI
         DO 150 ISU = 1,MAXSUB
            DO 100 IA = 1,NANTBP
               NREC = 0
C                                       loop over data records
               IF ((ISFQID(IFQ).GT.0) .AND. (ISANT(IA).GT.0) .AND.
     *            (ISUBAR(ISU).GT.0)) THEN
                  J1 = ISANT(IA)
                  J2 = ISANT(IA+1) - 1
                  LWT = 1 + PVLBUF
                  LBP = 1 + PBPBUF
                  DO 20 J = J1,J2
                     IBPRNO = J
                     CALL TABBP ('READ', BPBUFF, IBPRNO, BPKOLS, BPNUMV,
     *                  NIFBP, NCHNBP, NPOLBP, TIME, INTERV, SOURID,
     *                  SUBA, ANTNO, CHNBND, BPFREQ, FREQID, BPREF,
     *                  WEIGHT, BNDPAS, IERR)
                     IF (IERR.GT.0) THEN
                        WRITE (MSGTXT,1000) IERR, 'READ BP TABLE'
                        GO TO 990
                        END IF
                     IF (((FREQID.EQ.IFQ) .OR. (FREQID.LE.0)) .AND.
     *                  ((SUBA.EQ.ISU) .OR. (SUBA.LE.0)) .AND.
     *                  (ANTNO.EQ.IA)) THEN
                        NREC = NREC + 1
                        IF (NREC.EQ.1) THEN
                           SOURD = SOURID
                           CHNB = CHNBND
                           BREF(1) = BPREF(1)
                           BREF(2) = BPREF(2)
                           INTRV = INTERV
                           DO 10 I = 1,NIFBP
                              BPFRQ(I) = BPFREQ(I)
 10                           CONTINUE
                           END IF
                        TIMES(NREC) = TIME
                        CALL RCOPY (NWT, WEIGHT, VLBUF(LWT))
                        CALL RCOPY (NBP, BNDPAS, BPBUF(LBP))
                        LBP = LBP + NBP
                        LWT = LWT + NWT
                        END IF
 20                  CONTINUE
                  END IF
               IF (NREC.GT.0) THEN
                  LWT = 1 + PVLBUF
                  LBP = 1 + PBPBUF
                  TIME = TIMBEG - APARM(4)
                  IF (REPAIR) NT = NREC
                  DO 25 ITI = 1,NT
                     IF (REPAIR) THEN
                        TIME = TIMES(ITI)
                     ELSE
                        TIME = TIME + APARM(4)
                        END IF
                     CALL SMTHIT (TIME, STYPE, APARM(2), DONORM, BCHAN,
     *                  ECHAN, NIFBP, NCHNBP, NPOLBP, NREC, TIMES,
     *                  VLBUF(LWT), BPBUF(LBP), ITI, REPAIR, NOWAIT,
     *                  WEIGHT, BNDPAS)
                     CALL TABBP ('WRIT', BPBUFO, OBPRNO, BPKOLO, BPNUMO,
     *                  NIFBP, NCHNBP, NPOLBP, TIME, INTRV, SOURD, ISU,
     *                  IA, CHNB, BPFRQ, IFQ, BREF, WEIGHT, BNDPAS,
     *                  IERR)
                     IF (IERR.GT.0) THEN
                        WRITE (MSGTXT,1000) IERR, 'READ BP TABLE'
                        GO TO 990
                        END IF
 25                  CONTINUE
                  END IF
 100           CONTINUE
 150        CONTINUE
 200     CONTINUE
C                                       close
      CALL TABBP ('CLOS', BPBUFO, OBPRNO, BPKOLO, BPNUMO, NIFBP, NCHNBP,
     *   NPOLBP, TIME, INTRV, SOURD, ISU, IA, CHNB, BPFRQ, IFQ, BREF,
     *   WEIGHT, BNDPAS, JERR)
      CALL TABBP ('CLOS', BPBUFF, IBPRNO, BPKOLS, BPNUMV, NIFBP, NCHNBP,
     *   NPOLBP, TIME, INTERV, SOURID, SUBA, ANTNO, CHNBND, BPFREQ,
     *   FREQID, BPREF, WEIGHT, BNDPAS, JERR)
      GO TO 995
C
 990  CALL MSGWRT (8)
C
 995  CALL ZMEMRY ('QUIT', 'BPSMOT', NWD, BPBUF, PBPBUF, JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPSMOT: ERROR',I5,' ON ',A)
      END
      SUBROUTINE SMTHIT (TIME, STYPE, WIDTHS, DONORM, BCHAN, ECHAN,
     *   NIFBP, NCHNBP, NPOLBP, NREC, TIMES, WTBUF, BPBUF, ITI, REPAIR,
     *   DOWAIT, WEIGHT, BNDPAS)
C-----------------------------------------------------------------------
C   SMTHIT does all the work.
C   Inputs:
C      TIME     D      Time for output sample
C      STYPE    I      Smoothing type
C      WIDTHS   R(2)   Diameter and support of function in days
C      DONORM   I      Normalization control: -1 no, 1 scalar, 2 vector
C      BCHAN    I      Begin channel of normalization
C      ECHAN    I      End channel of normalization
C      NIFBP    I      Number of IFs
C      NCHNBP   I      Number of channels
C      NPOLBP   I      Number of polarizations
C      NREC     I      Number of times
C      TIMES    R(*)   Times   : R(NREC)
C      WTBUF    R(*)   Weights : R(NIFBP,NPOLBP,NREC)
C      BPBUF    C(*)   Bandpass: C(NCHNBP,NIFBP,NPOLBP,NREC)
C      ITI      I      Output matches the ITI record in WTBUF, BPBUF
C                      when REPAIR
C      REPAIR   L      T => change only if flagged
C      DOWAIT   I      < 0 => Ignore data weights in interpolation wts
C                      -1,1 => interpolate weights,
C                      -2,2 +> weight combination w weights
C   Output:
C      WEIGHT   R(*)   Weight  : R(NIFBP,NPOLBP)
C      BNDPAS   C(*)   Bandpass: C(NCHNBP,NIFBP,NPOLBP)
C   Changed to interpolate the weights rather than to do the full
C   noise combination formula which gives an intermediate (averaged)
C   point more weight than its parents.  The other form is left in
C   commented code lines.
C-----------------------------------------------------------------------
      DOUBLE PRECISION TIME
      INTEGER   STYPE, DONORM, BCHAN, ECHAN, NIFBP, NCHNBP, NPOLBP,
     *   NREC, ITI, DOWAIT
      REAL      WIDTHS(2), TIMES(NREC), WTBUF(NIFBP,NPOLBP,NREC),
     *   BPBUF(2,NCHNBP,NIFBP,NPOLBP,NREC), WEIGHT(NIFBP,NPOLBP),
     *   BNDPAS(2,NCHNBP,NIFBP,NPOLBP)
      LOGICAL   REPAIR
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   LI, LC, LP, LR, LR1, LR2, NW, NB, LSTYPE
      REAL      SR, DR, W, F, WFSUM, FFSUM, F2, W2, BR1, BR2, BI1, BI2,
     *   AX, A1, A2, WTSUM(MAXCHA), AMPSUM(MAXCHA)
      LOGICAL   SCALAR, NOWAIT, WTWAIT
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      NW = NIFBP * NPOLBP
      NB = 2 * NCHNBP * NW
      NOWAIT = DOWAIT.LE.0
      WTWAIT = ABS(DOWAIT).EQ.2
C                                       copy to output
      IF (REPAIR) THEN
         CALL RCOPY (NW, WTBUF(1,1,ITI), WEIGHT)
         CALL RCOPY (NB, BPBUF(1,1,1,1,ITI), BNDPAS)
C                                       are any flagged?
         DO 15 LP = 1,NPOLBP
            DO 10 LI = 1,NIFBP
               IF (WTBUF(LI,LP,ITI).LE.0.0) GO TO 20
 10            CONTINUE
 15         CONTINUE
         GO TO 999
         END IF
C                                       something to do
 20   SR = WIDTHS(2) / 2.0
      DR = WIDTHS(1) / 2.0
      LSTYPE = MOD (STYPE, 100)
      SCALAR = STYPE.LT.100
C                                       find times
      IF (LSTYPE.NE.0) THEN
         LR1 = NREC
         LR2 = 1
         DO 25 LR = 1,NREC
            IF (TIME-SR.LT.TIMES(LR)) LR1 = MIN (LR1, LR)
            IF (TIME+SR.GT.TIMES(LR)) LR2 = LR
 25         CONTINUE
         END IF
      NB = 2 * NCHNBP
C                                       loop over pol and IF
      DO 200 LP = 1,NPOLBP
         DO 195 LI = 1,NIFBP
            IF ((WTBUF(LI,LP,ITI).LE.0.0) .OR. (.NOT.REPAIR)) THEN
C                                       nearest neighbor
               IF (LSTYPE.EQ.0) THEN
C                                       find the nearest good ones
                  LR1 = 0
                  LR2 = NREC + 1
                  DO 100 LR = 1,NREC
                     IF (WTBUF(LI,LP,LR).GT.0.0) THEN
                        IF (TIME.GE.TIMES(LR)) LR1 = LR
                        IF (TIME.LE.TIMES(LR)) LR2 = MIN (LR, LR2)
                        END IF
 100                 CONTINUE
                  IF (LR1.LT.1) THEN
                     IF (LR2.GT.NREC) THEN
                        WEIGHT(LI,LP) = 0.0
                        CALL RFILL (NB, FBLANK, BNDPAS(1,1,LI,LP))
                        GO TO 195
                        END IF
                     LR1 = LR2
                  ELSE IF (LR2.GT.NREC) THEN
                     LR2 = LR1
                     END IF
C                                       only one
                  IF (LR1.EQ.LR2) THEN
                     WEIGHT(LI,LP) = WTBUF(LI,LP,LR1)
                     CALL RCOPY (NB, BPBUF(1,1,LI,LP,LR1),
     *                  BNDPAS(1,1,LI,LP))
C                                       linear interpolation
                  ELSE
                     SR = TIMES(LR2) - TIMES(LR1)
                     W = WTBUF(LI,LP,LR1)
                     W2 = WTBUF(LI,LP,LR2)
                     F = 1.0
                     IF (SR.GT.0.0) THEN
                        F = (TIMES(LR2) - TIME) / SR
                        F = MAX (0.0, MIN (1.0, F))
                        END IF
                     F2 = 1.0 - F
                     IF (NOWAIT) THEN
                        IF (WTWAIT) THEN
                           FFSUM = F * F / W  +  F2 * F2 / W2
                           WEIGHT(LI,LP) = 1.0 / FFSUM
                        ELSE
                           WEIGHT(LI,LP) = W * F + W2 * F2
                           END IF
                        W = F
                        W2 = F2
                     ELSE
                        WFSUM = W * F + W2 * F2
                        IF (WTWAIT) THEN
                           FFSUM = W * F * F  +  W2 * F2 * F2
                           WEIGHT(LI,LP) = WFSUM * WFSUM / FFSUM
                        ELSE
                           WEIGHT(LI,LP) = (W*W*F + W2*W2*F2) / WFSUM
                           END IF
                        W = W * F / WFSUM
                        W2 = W2 * F2 / WFSUM
                        END IF
                     DO 110 LC = 1,NCHNBP
                        BR1 = BPBUF(1,LC,LI,LP,LR1)
                        BR2 = BPBUF(1,LC,LI,LP,LR2)
                        BI1 = BPBUF(2,LC,LI,LP,LR1)
                        BI2 = BPBUF(2,LC,LI,LP,LR2)
                        IF ((BR1.NE.FBLANK) .AND. (BR2.NE.FBLANK) .AND.
     *                     (BI1.NE.FBLANK) .AND. (BI2.NE.FBLANK)) THEN
                           BNDPAS(1,LC,LI,LP) = W * BR1 + W2 * BR2
                           BNDPAS(2,LC,LI,LP) = W * BI1 + W2 * BI2
                           IF (SCALAR) THEN
                              AX = SQRT (BNDPAS(1,LC,LI,LP)**2 +
     *                           BNDPAS(2,LC,LI,LP)**2)
                              A1 = SQRT (BR1*BR1 + BI1*BI1)
                              A2 = SQRT (BR2*BR2 + BI2*BI2)
                              AX = (W * A1 + W2 * A2) / AX
                              BNDPAS(1,LC,LI,LP) = BNDPAS(1,LC,LI,LP)*AX
                              BNDPAS(2,LC,LI,LP) = BNDPAS(2,LC,LI,LP)*AX
                              END IF
                        ELSE IF ((BR1.NE.FBLANK) .AND. (BI1.NE.FBLANK))
     *                     THEN
                           BNDPAS(1,LC,LI,LP) = BR1
                           BNDPAS(2,LC,LI,LP) = BI1
                        ELSE
                           BNDPAS(1,LC,LI,LP) = BR2
                           BNDPAS(2,LC,LI,LP) = BI2
                           END IF
 110                    CONTINUE
                     END IF
C                                       function smoothing
               ELSE IF ((LSTYPE.GE.1) .AND. (LSTYPE.LE.4)) THEN
                  CALL RFILL (NB, 0.0, BNDPAS(1,1,LI,LP))
                  WEIGHT(LI,LP) = 0.0
                  WFSUM = 0.0
                  FFSUM = 0.0
                  CALL RFILL (NCHNBP, 0.0, WTSUM)
                  IF (SCALAR) CALL RFILL (NCHNBP, 0.0, AMPSUM)
                  DO 120 LR = LR1,LR2
                     SR = ABS (TIME - TIMES(LR))
                     CALL SFUNC (LSTYPE, DR, SR, F)
                     W2 = WTBUF(LI,LP,LR)
                     IF (W2.GT.0.0) THEN
                        IF (NOWAIT) THEN
                           W = F
                        ELSE
                           W = W2 * F
                           END IF
                        WFSUM = WFSUM + W
                        IF (WTWAIT) THEN
                           FFSUM = FFSUM + W * W / W2
                        ELSE
                           FFSUM = FFSUM + W2 * W
                           END IF
                        DO 115 LC = 1,NCHNBP
                           BR1 = BPBUF(1,LC,LI,LP,LR)
                           BI1 = BPBUF(2,LC,LI,LP,LR)
                           IF ((BR1.NE.FBLANK) .AND. (BI1.NE.FBLANK))
     *                        THEN
                              BNDPAS(1,LC,LI,LP) = BNDPAS(1,LC,LI,LP) +
     *                           W*BR1
                              BNDPAS(2,LC,LI,LP) = BNDPAS(2,LC,LI,LP) +
     *                           W*BI1
                              WTSUM(LC) = WTSUM(LC) + W
                              IF (SCALAR) AMPSUM(LC) = AMPSUM(LC) +
     *                           W * SQRT (BR1*BR1 + BI1*BI1)
                              END IF
 115                       CONTINUE
                        END IF
 120                 CONTINUE
C                                       scale
                  IF (WTWAIT) THEN
                     WEIGHT(LI,LP) = WFSUM * WFSUM / FFSUM
                  ELSE
                     WEIGHT(LI,LP) = FFSUM /  WFSUM
                     END IF
                  DO 130 LC = 1,NCHNBP
                     IF (WTSUM(LC).LE.0.0) THEN
                        BNDPAS(1,LC,LI,LP) = FBLANK
                        BNDPAS(2,LC,LI,LP) = FBLANK
                     ELSE
                        BNDPAS(1,LC,LI,LP) = BNDPAS(1,LC,LI,LP) /
     *                     WTSUM(LC)
                        BNDPAS(2,LC,LI,LP) = BNDPAS(2,LC,LI,LP) /
     *                     WTSUM(LC)
                        IF (SCALAR) THEN
                           A1 = SQRT (BNDPAS(1,LC,LI,LP)**2 +
     *                        BNDPAS(2,LC,LI,LP)**2)
                           AX = AMPSUM(LC) / WTSUM(LC)
                           IF (A1.GT.0.0) AX = AX / A1
                           BNDPAS(1,LC,LI,LP) = BNDPAS(1,LC,LI,LP) * AX
                           BNDPAS(2,LC,LI,LP) = BNDPAS(2,LC,LI,LP) * AX
                           END IF
                        END IF
 130                 CONTINUE
                  END IF
C                                       normalize: scalar
               IF (DONORM.EQ.1) THEN
                  F = 0.0
                  W = 0.0
                  DO 140 LC = BCHAN,ECHAN
                     IF (BNDPAS(1,LC,LI,LP).NE.FBLANK) THEN
                        F = F + SQRT (BNDPAS(1,LC,LI,LP)**2 +
     *                     BNDPAS(2,LC,LI,LP)**2)
                        W = W + 1.0
                        END IF
 140                 CONTINUE
                  IF ((W.GT.0.0) .AND. (F.GT.0.0)) THEN
                     F = F / W
                     DO 150 LC = 1,NCHNBP
                        IF (BNDPAS(1,LC,LI,LP).NE.FBLANK)
     *                     BNDPAS(1,LC,LI,LP) = BNDPAS(1,LC,LI,LP) / F
                        IF (BNDPAS(2,LC,LI,LP).NE.FBLANK)
     *                     BNDPAS(2,LC,LI,LP) = BNDPAS(2,LC,LI,LP) / F
 150                    CONTINUE
                     END IF
C                                       normalize: vector
               ELSE IF (DONORM.EQ.2) THEN
                  A1 = 0.0
                  A2 = 0.0
                  W = 0.0
                  DO 160 LC = BCHAN,ECHAN
                     IF (BNDPAS(1,LC,LI,LP).NE.FBLANK) THEN
                        A1 = A1 + BNDPAS(1,LC,LI,LP)
                        A2 = A2 + BNDPAS(1,LC,LI,LP)
                        W = W + 1.0
                        END IF
 160                 CONTINUE
                  F = SQRT (A1*A1 + A2*A2)
                  IF ((W.GT.0.0) .AND. (F.GT.0.0)) THEN
                     F = F / W
                     DO 170 LC = 1,NCHNBP
                        IF (BNDPAS(1,LC,LI,LP).NE.FBLANK)
     *                     BNDPAS(1,LC,LI,LP) = BNDPAS(1,LC,LI,LP) / F
                        IF (BNDPAS(2,LC,LI,LP).NE.FBLANK)
     *                     BNDPAS(2,LC,LI,LP) = BNDPAS(2,LC,LI,LP) / F
 170                    CONTINUE
                     END IF
                  END IF
               END IF
 195        CONTINUE
 200     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SFUNC (TYPE, XR, X, F)
C-----------------------------------------------------------------------
C   Evaluates a function of TYPE with function radius XR at X, returning
C   value in F
C   Inputs:
C      TYPE   I   Type: linear (Hanning), Gaussian, Boxcar, Sinc
C      XR     R   Radius of function
C      X      R   Location to evaluate the function
C   Output:
C      F      R   Function value
C-----------------------------------------------------------------------
      INTEGER   TYPE
      REAL      XR, X, F
C
      REAL      S
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      F = 0.0
C                                       Hanning
      IF (TYPE.EQ.1) THEN
         F = 1.0 - X / XR
         F = MAX (0.0, F)
C                                       Gaussian
      ELSE IF (TYPE.EQ.2) THEN
         S = LOG (2.0) / (XR * XR)
         F = EXP (- S * X * X)
C                                       Boxcar
      ELSE IF (TYPE.EQ.3) THEN
         IF (X.LT.XR) F = 1.0
C                                       Sinc
      ELSE IF (TYPE.EQ.4) THEN
         S = TWOPI * X / XR
         IF (S.EQ.0.0) THEN
            F = 1.0
         ELSE
            F = SIN (S) / S
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE BPSMHI (IRET)
C-----------------------------------------------------------------------
C   BPSMHI writes some history records to record what we did
C   Output:
C      IRET   I   Error code - always 0
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'BPSMO.INC'
      INTEGER   IERR, HIBUFF(256), IT(3), ID(3), IHLUN, LSTYPE, NF
      CHARACTER HILINE*72, ATIME*8, ADATE*12, CVECT(2)*6, CFUNC(5)*8
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA IHLUN /29/
      DATA CVECT /'SCALAR', 'VECTOR'/
      DATA CFUNC /'2-POINT', 'HANNING', 'GAUSSIAN', 'BOXCAR',
     *   'SINX / X'/
C-----------------------------------------------------------------------
      IRET = 0
C                                       Initialize HI common
      CALL HIINIT (3)
C                                       Open HI file
      CALL HIOPEN (IHLUN, INDISK, CNO, HIBUFF, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.EQ.5) THEN
            WRITE (MSGTXT,1000)
         ELSE
            WRITE (MSGTXT,1010) IERR
            END IF
         GO TO 990
         END IF
C                                       Header text
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, ATIME, ADATE)
      WRITE (HILINE,1020) TSKNAM, RLSNAM, ADATE, ATIME
      CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
      IF (IERR.NE.0) GO TO 90
C                                       versions
      WRITE (HILINE,1025) TSKNAM, BPVER, OUTVER
      CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
      IF (IERR.NE.0) GO TO 90
C                                       function type
      LSTYPE = MOD (STYPE, 100) + 1
      NF = 1
      IF (STYPE.GE.100) NF = 2
      APARM(4) = APARM(4) * 24.0
      WRITE (HILINE,1030) TSKNAM, CVECT(NF), CFUNC(LSTYPE), APARM(4)
      CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
      IF (IERR.NE.0) GO TO 90
C                                       width and support
      IF ((LSTYPE.GT.1) .AND. (LSTYPE.LE.5)) THEN
         APARM(2) = APARM(2) * 24.0
         APARM(3) = APARM(3) * 24.0
         WRITE (HILINE,1035) TSKNAM, APARM(2), APARM(3)
         CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
         IF (IERR.NE.0) GO TO 90
         END IF
C                                       normalization
      IF (DONORM.GT.0) THEN
         WRITE (HILINE,1040) TSKNAM, CVECT(DONORM), BCHAN, ECHAN
      ELSE
         WRITE (HILINE,1041) TSKNAM
         END IF
      CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
      IF (IERR.NE.0) GO TO 90
      GO TO 100
C                                       ERROR
 90   WRITE (MSGTXT,1090) IERR
      CALL MSGWRT (6)
C                                       Close file updating it
 100  CALL HICLOS (IHLUN, .TRUE., HIBUFF, IERR)
      GO TO 999
C
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPSMHI: HISTORY FILE DOES NOT EXIST')
 1010 FORMAT ('BPSMHI: ERROR',I5,' OPENING THE HISTORY FILE')
 1020 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',A12,2X,A8)
 1025 FORMAT (A6,'INVER =',I5,'   OUTVER =',I5,3X,
     *   '/ In/out BP file version numbers')
 1030 FORMAT (A6,'/ ',A,1X,A,' smoothing function every',F7.3,' hours')
 1035 FORMAT (A6,'FWIDTH=',F7.3,'  FSUPPORT=',F7.3,3X,
     *   '/ function width/support hours')
 1040 FORMAT (A6,'/ ',A,' normalization BCHAN=',I5,'  ECHAN=',I5)
 1041 FORMAT (A6,'/ no amplitude normalization')
 1090 FORMAT ('BPSMHI: ERROR',I5,' ADDING TO THE HISTORY FILE')
      END

      SUBROUTINE TAPIO (OP, FDVEC, BUFF, IBIND, IERR)
C-----------------------------------------------------------------------
C! read/writes tape and FITS disk files
C# tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000, 2003-2004, 2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TAPIO is primarily for reading and writing tapes but will also
C   work for disks for FITS files etc.  Disk files will be created and
C   expanded as necessary.  When a disk file is being written it is
C   compressed to its actual size when it is closed.
C   NOTE: TAPIO WORKS IN REAL (8-BIT) BYTES, NOT THE AIPS HALF-INTEGER
C   "BYTES".
C   Usage notes:
C     1) Zero fill FDVEC before filling in relevant values.
C     2) Opening the file.  If TAPIO determines that the file is not
C        open it will do so.  For disk files being opened for write
C        the file will be created.  Once the file is open the file
C        descriptor vector FDVEC must be used in each call.
C     3) Initialization.  TAPIO initializes the I/O using the values in
C        FDVEC when it opens the file.
C        If OP='OPxx' the file is created/opened but I/O is not
C        initialized; this allows positioning tapes before the actual
C        I/O starts. 'OPRD' means open for read, 'OPWT' means open for
C        write; 'OPWT' will cause the output file to be created if the
C        output is to disk.
C     4) Re-initialization.  If OP='BAKF' the file is repositioned at
C        the beginning of the current file, I/O will be reinitialized at
C        the next read call.  If OP='ADVF' then the tape is advanced to
C        the beginning of the next file and I/O is reinitialized at the
C        next read call.  These operations are only relevant to reading
C        files.
C     5) Closing the file.  The file may be closed with a call with
C        opcode 'CLOS'.
C     6) Writing variable length records.  If variable length records
C        are to be read or written FDVEC(19) should be set to 1.
C        On WRITE, the actual record size is assumed to be given by
C        the first I   word of the record.  TAPIO will not handle
C        blocked, variable length records.
C     7) Limited number of logical records.  If only a fixed number of
C        logical records are to be processed before reinitialization
C        put the number of such records in FDVEC(20).  After this number
C        of transfers the I/O will be left in an uninitialized state and
C        on the next call will be reinitialized (e.g. can change logical
C        record length).  DO NOT USE THIS WITH BLOCKING HOWEVER, the
C        last block will not be the correct length.
C
C   Tapes:  129-NTAPED <= LUN <= 128
C
C   Disks: any other LUN
C          for FITS format only (no blocking)
C          TAPIO requires that FDVEC(2) = 2880 OR 2560,
C                              FDVEC(31) = 0 on input
C          TAPIO sets FDVEC(6) = 1
C          The desired file name must be in FDVEC(7-30) packed string
C
C   Inputs:
C      OP     C*4     Operation code: 'READ','WRIT','CLOS','BAKF',
C                                     'ADVF',
C                                     'OPRD','OPWT' open for rd,wrt
C                                     'FLSH' flush write buffer, Weof
C   Input/Output:
C      FDVEC  I(50)   File descriptor vector.
C                     1 = LUN to use, set before first call.
C                         129-NTAPED to 128 => tape, else disk.
C                     2 = Logical record length in bytes (8-bit)
C                   3-4 = Buffer size in 8-bit bytes I
C                     5 = volumn number (disk or tape)
C                     6 = blocking factor (0=>1). Value returned on read
C                  7-30 = File name for disk files (24 char. packed)
C                    31 = 0 if fixed length, 1 if variable length
C                    32 = Max. number of logical records to process
C                         0 => infinity
C                 33-39   Reserved for future use
C                The following are used by TAPIO:
C                    40 = FTAB pointer
C                    41 = Number of logical records left to process
C                         (negative => ignore)
C                    42 = LBYTES - number of bytes read or written.
C                 43-50 = reserved for future use
C      BUFF   R(*)   Buffer for I/O must be large enough for the largest
C                    transfer rounded up to the next larger number of
C                    disk blocks.
C   Outputs:
C      IBIND  I      The location in BUFF of the start of the next
C                    record. Before the first write call this should
C                    be set to 1 to determine where to start filling
C                    BUFF. Note: IBIND points to the address in the
C                    I   array irregardless of the actual data type.
C     IERR    I      Error return: 0 => ok
C                             1 => error creating file
C                             2 => input error
C                             3 => i/o error on initialize
C                             4 => end of file
C                             5 => beginning of medium
C                             6 => end of medium
C                             7 => Buffer too small
C                             8 => error opening file.
C                             9 => error expanding
C                            10 => data record shorter than 1 logical
C   Usage notes: For map i/o the first 16 words in each FTAB entry
C   contain a user table to handle double buffer i/o,  the rest
C   contain system-dependent I/O tables.
C   FTAB user table   entries, with offsets from the FIND pointer are:
C      FTAB + 0 =>  LUN using this entry
C             1 =>  Number of blocks to extend the file when full
C             2 =>  Number of 8-bit bytes in a logical record
C             3 =>  Number of disk logical records in each transfer (1)
C             4 =>  Which buffer half currently doing  i/o; -1 =>
C                   single buffer,  the other buffer half is available.
C           5-6 =>  Block offset on disk file for next operation I
C           7-8 =>
C             9 =>  I/O opcode 0=read, 1=write
C            10 =>  1 => tape, 2 => disk
C            11 =>  Number of logical records per physical
C            12 =>  Number of logical records done for this physical.
C            13 =>  1 => I/O active, else inactive (not initialized).
C            14 =>  number bytes last read/write to buffer 1
C            15 =>  number bytes last read/write to buffer 2
C   To suppress messages about logical and physical record lengths
C   being incosistent, set MSGSUP to 1000 or greater.
C-----------------------------------------------------------------------
      INTEGER   FDVEC(50), BUFF(*), IBIND, IERR
      CHARACTER OP*4
C
      CHARACTER PHNAME*48
      LOGICAL   TAPE, DISK, DOREAD, DOWRIT
      INTEGER   JERR, IND, JBUF, MBYTE, I, NUMMSG, LBYTES, NRBPS,
     *   BUFISZ, NBITAB, NIPLR, IBY, I4TEMP, BUFSZ4, RECNO, BUFPNT,
     *   BUFPOL, NBYPWD, NFILES
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C
      SAVE NUMMSG
C-----------------------------------------------------------------------
      IERR = 2
      IBIND = 1
C                                       Initial parameters
      IND = FDVEC(40)
      NBITAB = NBITWD / 2
      NBYPWD = NBITWD / 8
      NRBPS = (NBPS * NBITAB) / 8
      NIPLR = (FDVEC(2) * 8 - 1) / NBITWD + 1
C                                       See if tape or disk.
C??                                     BETTER TEST HERE
      TAPE = (FDVEC(1).LT.129) .AND. (FDVEC(1).GE.129-NTAPED)
      DISK = .NOT.TAPE
      IF ((DISK) .AND. (FDVEC(2).NE.2880) .AND. (FDVEC(2).NE.2560))
     *   GO TO 985
      IF ((DISK) .AND. (FDVEC(31).NE.0)) GO TO 985
      IF (DISK) FDVEC(6) = 1
      BUFSZ4 = FDVEC(3)
      IF (BUFSZ4.GE.65536) BUFSZ4 = 65536 - 2 * NBYPWD
      FDVEC(3) = BUFSZ4
      BUFISZ = BUFSZ4 / NBYPWD
C??                                     CHECK HERE ON DEVTAB VALUE
      IF (MOD (DEVTAB(FDVEC(1)),2).EQ.1) GO TO 999
C                                       Test OPcode
      DOREAD = (OP.EQ.'OPRD') .OR. (OP.EQ.'READ')
      DOWRIT = (OP.EQ.'OPWT') .OR. (OP.EQ.'WRIT')
      IF ((DOWRIT) .OR. (DOREAD) .OR. (OP.EQ.'CLOS') .OR. (OP.EQ.'BAKF')
     *    .OR. (OP.EQ.'ADVF') .OR. (OP.EQ.'FLSH')) GO TO 10
         WRITE (MSGTXT,1000) OP
         GO TO 990
C                                       Check if CLOSE
 10   IERR = 0
      IF (OP.EQ.'CLOS') GO TO 900
      IF (OP.EQ.'FLSH') GO TO 900
C                                       Check if BAKF or ADVF
      IF ((OP.EQ.'BAKF') .OR. (OP.EQ.'ADVF')) GO TO 800
C                                       Check if Open but I/O inactive
      IF (((IND.GT.0) .AND. (FDVEC(1).EQ.FTAB(IND))) .AND.
     *   (FTAB(IND+13).NE.1)) GO TO 100
C                                       See if open and active.
      IF ((IND.GT.0) .AND. (FDVEC(1).EQ.FTAB(IND))) GO TO 500
C                                       Create/open/init
         PHNAME = ' '
         IF (TAPE) THEN
            CALL ZPHFIL ('MT', FDVEC(5), 1, 1, PHNAME, JERR)
            CALL CHR2H (48, PHNAME, 1, FDVEC(7))
            END IF
         CALL H2CHR (48, 1, FDVEC(7), PHNAME)
         IF (DOREAD) CALL ZTPOPN (FDVEC(1), IND, FDVEC(5), PHNAME,
     *      'READ', JERR)
         IF (DOWRIT) CALL ZTPOPN (FDVEC(1), IND, FDVEC(5), PHNAME,
     *      'WRIT', JERR)
C                                       Save number of blocks in file
         IF (JERR.NE.0) THEN
            IERR = 8
            WRITE (MSGTXT,1010) JERR
            FDVEC(40) = 0
            GO TO 990
            END IF
         FDVEC(40) = IND
C                                       Init previously inactive I/O
 100  CONTINUE
         FDVEC(42) = 0
         NUMMSG = -2
C                                       Fill values in FTAB
C                                       LUN
         FTAB(IND) = FDVEC(1)
C                                       Number of blocks to expand
         FTAB(IND+1) = 1000
C                                       Number of bytes in a logical
C                                       record.
         FTAB(IND+2) = FDVEC(2)
C                                       No. logical records per physical
         IF (FDVEC(6).LE.1) FDVEC(6) = 1
         FTAB(IND+11) = FDVEC(6)
C                                       Number of disk blocks per op.
         I4TEMP = FTAB(IND+11) * FTAB(IND+2)
         FTAB(IND+3) = 1
         FTAB(IND+13) = 0
C                                       Buffer size check
         FTAB(IND+4) = 1
         IF (BUFSZ4.GE.(2*I4TEMP)) GO TO 120
            FTAB(IND+4) = -1
C                                       Buffer too small
            IF ((BUFSZ4.GE.I4TEMP) .AND. (I4TEMP.LE.32766)) GO TO 120
               IERR = 7
               WRITE (MSGTXT,1100) BUFSZ4, I4TEMP
               IF (I4TEMP.GT.32766) WRITE (MSGTXT,1101) I4TEMP
               GO TO 990
C                                       Next disk block
 120     RECNO = 1
         FTAB(IND+5) = RECNO
C                                       Opcode
         FTAB(IND+9) = 0
         IF (DOWRIT) FTAB(IND+9) = 1
C                                       Medium type
         FTAB(IND+10) = 2
         IF (TAPE) FTAB(IND+10) = 1
C                                       No. logical rec. done
         FTAB(IND+12) = 0
C                                       Set buffer pointer
         BUFPNT = 1
C                                       Check limited no. records
         FDVEC(41) = -1
         IF (FDVEC(32).GT.0) FDVEC(41) = FDVEC(32)
C                                       Done if OP='OPxx'
         IF (OP(1:2).EQ.'OP') GO TO 999
C                                       I/O init w READ/WRIT call
C                                       Set I/O active flag
            FTAB(IND+13) = 1
C                                       WRITE
            IF (OP.NE.'WRIT') GO TO 150
C                                       If double buffering dummy
C                                       write to buffer 2
               IF (FTAB(IND+4).LE.0) GO TO 140
                  JBUF = 2
                  MBYTE = 0
                  FTAB(IND+4) = JBUF
                  FTAB(IND+13+JBUF) = MBYTE
                  CALL ZTPMIO ('WRIT', FTAB(IND), IND, MBYTE, BUFF,
     *               JBUF, IERR)
                  IF (IERR.NE.0) GO TO 980
C                                       Update pointers
 140           FTAB(IND+12) = FTAB(IND+12) + 1
               IF ((FTAB(IND+12)).GE.FTAB(IND+11)) BUFPNT = BUFISZ/2 + 1
               IF (FTAB(IND+4).LE.0) BUFPNT = 1
               IF ((FTAB(IND+12)).GE.FTAB(IND+11)) FTAB(IND+12) = 0
               IBIND = FTAB(IND+12) * NIPLR + BUFPNT
C                                       Check if done
               IF (FDVEC(41).GT.0) FDVEC(41)= FDVEC(41) - 1
               IF (FDVEC(41).EQ.0) FTAB(IND+13) = 0
C                                       Check if time to write
               IF ((FTAB(IND+11).GE.2) .AND. (FDVEC(41).NE.0)) GO TO 999
C                                       Wait for dummy write
                  IF (FTAB(IND+4).LE.0) GO TO 145
                     CALL ZTPWAT (FTAB(IND), IND, FTAB(IND+4), LBYTES,
     *                  IERR)
                     IF (IERR.EQ.4) GO TO 998
                     IF (IERR.NE.0) GO TO 980
                     FDVEC(42) = LBYTES
C                                       Write first buffer load.
 145              JBUF = 1
                  FTAB(IND+4) = JBUF
                  IF (FDVEC(31).EQ.1) THEN
                     CALL ZI16IL (1, 1, BUFF, IBY)
                     MBYTE = IBY
                  ELSE
                     MBYTE = FTAB(IND+2) * FTAB(IND+11)
                     END IF
                  FTAB(IND+13+JBUF) = MBYTE
                  CALL ZTPMIO ('WRIT', FTAB(IND), IND, MBYTE, BUFF,
     *               JBUF, IERR)
                  IF (IERR.EQ.4) GO TO 998
                  IF (IERR.NE.0) GO TO 980
C                                       Update record pointer
                  RECNO = RECNO + FTAB(IND+3)
                  FTAB(IND+5) = RECNO
                  GO TO 999
C                                       Start first READ
 150        CONTINUE
               JBUF = 1
               MBYTE = BUFSZ4
               IF (FTAB(IND+4).GT.0) MBYTE = MBYTE / 2
               IF (DISK) MBYTE = FDVEC(2)
               FTAB(IND+13+JBUF) = MBYTE
               CALL ZTPMIO ('READ', FTAB(IND), IND, MBYTE, BUFF, JBUF,
     *            IERR)
               IF (IERR.EQ.4) GO TO 998
               IF (IERR.NE.0) GO TO 980
C                                       Update block counter
               RECNO = RECNO + FTAB(IND+3)
               FTAB(IND+5) = RECNO
C                                       Set pointers etc.
               IBIND = 1
C                                       Wait for first
               JBUF = 1
               CALL ZTPWAT (FTAB(IND), IND, JBUF, LBYTES, IERR)
               IF (IERR.EQ.4) GO TO 998
               IF (IERR.EQ.0) GO TO 180
                  WRITE (MSGTXT,1600) IERR, OP
                  GO TO 990
C                                       Check bytes read
 180           FDVEC(42) = LBYTES
               IF ((LBYTES.LE.0) .AND. (MBYTE.GT.0)) GO TO 970
               IF (LBYTES.EQ.MBYTE) GO TO 190
                  IF (FDVEC(31).EQ.0) THEN
                     FTAB(IND+11) = LBYTES / FTAB(IND+2)
                     IF (FTAB(IND+11)*FTAB(IND+2).LT.LBYTES-2) THEN
                        NUMMSG = NUMMSG + 1
                        IF ((NUMMSG.LE.3) .AND. (MSGSUP.LT.1000)) THEN
                           WRITE (MSGTXT,1180) LBYTES, FTAB(IND+2)
                           CALL MSGWRT (6)
                           END IF
                        IERR = 10
                        END IF
                     IF (FTAB(IND+11).EQ.0) FTAB(IND+11) = 1
                  ELSE IF (NUMMSG.LE.1) THEN
                     CALL ZI16IL (1, 1, BUFF, IBY)
                     I = IBY
                     IF ((I.GT.FTAB(IND+2)) .OR. (ABS(I-LBYTES).GT.2))
     *                  THEN
                        NUMMSG = NUMMSG + 1
                        IF (LBYTES.GT.FTAB(IND+2)) THEN
                           WRITE (MSGTXT,1185) LBYTES, I, FTAB(IND+2)
                        ELSE
                           WRITE (MSGTXT,1186) LBYTES, I
                           END IF
                        CALL MSGWRT (6)
                        END IF
                     END IF
C                                       Check if done
 190           IF (FDVEC(41).GT.0) FDVEC(41)= FDVEC(41) - 1
               IF (FDVEC(41).EQ.0) THEN
                  FTAB(IND+13) = 0
                  GO TO 999
                  END IF
C                                       Done if single buffering
C                                       If double buffer and reading
C                                       start 2nd read
               IF (FTAB(IND+4).GE.0) THEN
                  JBUF = 2
                  FTAB(IND+4) = JBUF
                  BUFPNT = BUFISZ / 2 + 1
                  MBYTE = BUFSZ4 / 2
                  IF (DISK) MBYTE = FDVEC(2)
                  FTAB(IND+13+JBUF) = MBYTE
                  CALL ZTPMIO ('READ', FTAB(IND), IND, MBYTE,
     *               BUFF(BUFPNT), JBUF, JERR)
                  IF (JERR.NE.0) IERR = JERR
                  IF (JERR.EQ.4) GO TO 998
                  IF (JERR.NE.0) GO TO 980
C                                       Update block counter
                  RECNO = RECNO + FTAB(IND+3)
                  FTAB(IND+5) = RECNO
                  END IF
               GO TO 999
C-----------------------------------------------------------------------
C                                       Do later I/O operations
C                                       Set buffer pointer.
 500  CONTINUE
         BUFPOL = 1
         IF (FTAB(IND+4).EQ.1) BUFPOL = BUFISZ / 2 + 1
         FTAB(IND+12) = FTAB(IND+12) + 1
C                                       More logical records in physical
C                                       record.
         IF (FTAB(IND+12).GE.FTAB(IND+11)) GO TO 520
            IBIND = FTAB(IND+12) * NIPLR + BUFPOL
C                                       Check if done
            IF (FDVEC(41).GT.0) FDVEC(41)= FDVEC(41) - 1
            IF (FDVEC(41).EQ.0) FTAB(IND+13) = 0
            IF ((FDVEC(41).EQ.0) .AND. (OP.EQ.'WRIT')) GO TO 900
            GO TO 999
C                                       I/O time.
 520     RECNO = FTAB(IND+5)
C                                       Wait on last I/O if double
C                                       buffer.
 600     BUFPNT = 1
         IF (FTAB(IND+4).LT.0) GO TO 650
            JBUF = FTAB(IND+4)
            IF (JBUF.EQ.2) BUFPNT = BUFISZ / 2 + 1
            MBYTE = FTAB(IND+13+JBUF)
            CALL ZTPWAT (FTAB(IND), IND, JBUF, LBYTES, IERR)
            IF (IERR.EQ.4) GO TO 998
            IF (IERR.EQ.0) GO TO 640
               WRITE (MSGTXT,1600) IERR, OP
               GO TO 990
C                                       Check bytes
 640        FDVEC(42) = LBYTES
            IF ((LBYTES.LE.0) .AND. (MBYTE.GT.0)) GO TO 970
            IF (LBYTES.NE.MBYTE) THEN
               IF (FTAB(IND+9).NE.0) THEN
                  WRITE (MSGTXT,1640) LBYTES, MBYTE
                  IERR = 6
                  GO TO 990
               ELSE
                  IF (FDVEC(31).EQ.0) THEN
                     FTAB(IND+11) = LBYTES / FTAB(IND+2)
                     IF (FTAB(IND+11)*FTAB(IND+2).LT.LBYTES-2) THEN
                        NUMMSG = NUMMSG + 1
                        IF ((NUMMSG.LE.3) .AND. (MSGSUP.LT.1000)) THEN
                           WRITE (MSGTXT,1180) LBYTES, FTAB(IND+2)
                           CALL MSGWRT (6)
                           END IF
                        IERR = 10
                        END IF
                     IF (FTAB(IND+11).EQ.0) FTAB(IND+11) = 1
                  ELSE IF (NUMMSG.LE.1) THEN
                     CALL ZI16IL (1, 1, BUFF(BUFPNT), IBY)
                     I = IBY
                     IF ((I.GT.FTAB(IND+2)) .OR. (ABS(I-LBYTES).GT.2))
     *                  THEN
                        NUMMSG = NUMMSG + 1
                        IF (LBYTES.GT.FTAB(IND+2)) THEN
                           WRITE (MSGTXT,1185) LBYTES, I, FTAB(IND+2)
                        ELSE
                           WRITE (MSGTXT,1186) LBYTES, I
                           END IF
                        CALL MSGWRT (6)
                        END IF
                     END IF
                  END IF
               END IF
C                                       Check if done
 650     IBIND = BUFPNT
         IF (FDVEC(41).GT.0) FDVEC(41)= FDVEC(41) - 1
         IF (FDVEC(41).EQ.0) FTAB(IND+13) = 0
         I = 10000
         IF ((FDVEC(41).GE.0) .AND. (OP.EQ.'READ')) I = FDVEC(41) + 1
         IF ((FDVEC(41).GE.0) .AND. (OP.EQ.'READ') .AND.
     *      (FTAB(IND+4).GT.0)) I = FDVEC(41) + 1 - FTAB(IND+11)
         IF (I.LE.0) FTAB(IND+12) = 0
C                                       Do I/O
         IF (I.LE.0) GO TO 999
            MBYTE = BUFSZ4
            IF (FTAB(IND+4).GT.0) MBYTE = MBYTE / 2
            IF (OP.EQ.'WRIT') MBYTE = FTAB(IND+2) * FTAB(IND+12)
            IF ((FDVEC(31).EQ.1) .AND. (OP.EQ.'WRIT')) THEN
               CALL ZI16IL (1, 1, BUFF(BUFPOL), MBYTE)
               END IF
            IF (DISK) MBYTE = FDVEC(2)
            FTAB(IND+12) = 0
            IF (FTAB(IND+4).GT.0) FTAB(IND+4) = 3 - FTAB(IND+4)
            JBUF = 1
            IF (FTAB(IND+4).GT.0) JBUF = FTAB(IND+4)
            FTAB(IND+13+JBUF) = MBYTE
            CALL ZTPMIO (OP, FTAB(IND), IND, MBYTE, BUFF(BUFPOL), JBUF,
     *         JERR)
            IF (JERR.NE.0) IERR = JERR
            IF (JERR.EQ.4) GO TO 998
            IF (JERR.NE.0) GO TO 980
C                                       Update block counter
            RECNO = RECNO + FTAB(IND+3)
            FTAB(IND+5) = RECNO
C                                       If this is last, quit
            IF ((FDVEC(41).EQ.0) .AND. (OP.EQ.'WRIT')) GO TO 900
C                                       If single buffering, wait
            IF (FTAB(IND+4).GT.0) GO TO 999
               CALL ZTPWAT (FTAB(IND), IND, JBUF, LBYTES, JERR)
               IF (JERR.NE.0) IERR = JERR
               IF (JERR.EQ.4) GO TO 998
               IF (JERR.NE.0) GO TO 980
               FDVEC(42) = LBYTES
C                                       Check bytes read
               IF ((LBYTES.LE.0) .AND. (MBYTE.GT.0)) GO TO 970
               IF (LBYTES.NE.MBYTE) THEN
                  IF (FTAB(IND+9).NE.0) THEN
                     WRITE (MSGTXT,1640) LBYTES, MBYTE
                     IERR = 6
                     GO TO 990
                  ELSE
                     IF (FDVEC(31).EQ.0) THEN
                        FTAB(IND+11) = LBYTES / FTAB(IND+2)
                        IF (FTAB(IND+11)*FTAB(IND+2).LT.LBYTES-2) THEN
                           NUMMSG = NUMMSG + 1
                           IF ((NUMMSG.LE.3) .AND. (MSGSUP.LT.1000))
     *                        THEN
                              WRITE (MSGTXT,1180) LBYTES, FTAB(IND+2)
                              CALL MSGWRT (6)
                              END IF
                           IERR = 10
                           END IF
                        IF (FTAB(IND+11).EQ.0) FTAB(IND+11) = 1
                     ELSE IF (NUMMSG.LE.1) THEN
                        CALL ZI16IL (1, 1, BUFF, IBY)
                        I = IBY
                        IF ((I.GT.FTAB(IND+2)) .OR.
     *                     (ABS(I-LBYTES).GT.2)) THEN
                           NUMMSG = NUMMSG + 1
                           IF (LBYTES.GT.FTAB(IND+2)) THEN
                              WRITE (MSGTXT,1185) LBYTES, I, FTAB(IND+2)
                           ELSE
                              WRITE (MSGTXT,1186) LBYTES, I
                              END IF
                           CALL MSGWRT (6)
                           END IF
                        END IF
                     END IF
                  END IF
               GO TO 999
C-----------------------------------------------------------------------
C                                       BAKF operation
C                                       Reset record pointer
 800  RECNO = 1
      FDVEC(42) = 0
      IERR = 8
      IF ((IND.LE.0) .OR. (FTAB(IND).NE.FDVEC(1))) GO TO 999
      IERR = 0
      FTAB(IND+5) = RECNO
      IBIND = 1
      NFILES = 1
C                                       Wait on any pending read.
      IF ((FTAB(IND+4).LE.0) .OR. (FTAB(IND+13).NE.1)) GO TO 810
         CALL ZTPWAT (FTAB(IND), IND, FTAB(IND+4), LBYTES, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.4)) GO TO 980
         IF (IERR.EQ.4) THEN
            IF (OP.EQ.'ADVF') NFILES = 0
            IF (OP.EQ.'BAKF') NFILES = 2
            END IF
C                                       Reset I/O active flag
 810  FTAB(IND+13) = 0
      FTAB(IND+12) = 0
C                                       Reposition tape.
      IF ((FTAB(IND+10).EQ.1) .AND. (NFILES.GT.0)) THEN
         CALL ZTAPE (OP, FTAB(IND), IND, NFILES, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1810) IERR
            GO TO 990
            END IF
         END IF
      GO TO 999
C-----------------------------------------------------------------------
C                                       Close, flush
C                                       Wait for pending I/O
 900  IERR = 8
      FDVEC(42) = 0
      IF ((IND.LE.0) .OR. (FTAB(IND).NE.FDVEC(1))) GO TO 999
      IERR = 0
      IF (FTAB(IND+4).LE.0) GO TO 910
         CALL ZTPWAT (FTAB(IND), IND, FTAB(IND+4), LBYTES, IERR)
         IF ((IERR.EQ.4) .AND. (FTAB(IND+9).EQ.0)) IERR = 0
         IF (IERR.NE.0) GO TO 930
         FDVEC(42) = LBYTES
C                                       For blocked writes, flush
C                                       buffer.
 910  IF ((FTAB(IND+9).EQ.0) .OR. (FTAB(IND+11).LE.1)) GO TO 930
C                                       Check that something is in the
C                                       buffer.
      IF (FTAB(IND+12).LE.0) GO TO 930
         MBYTE = FTAB(IND+2) * FTAB(IND+12)
         IF (FTAB(IND+4).GT.0) FTAB(IND+4) = 3 - FTAB(IND+4)
         JBUF = 1
         IF (FTAB(IND+4).GT.0) JBUF = FTAB(IND+4)
         BUFPNT = 1 + (JBUF - 1) * (BUFISZ / 2)
         CALL ZTPMIO ('WRIT', FTAB(IND), IND, MBYTE, BUFF(BUFPNT), JBUF,
     *      JERR)
         IF (IERR.EQ.0) IERR = JERR
         IF (JERR.NE.0) GO TO 930
         CALL ZTPWAT (FTAB(IND), IND, JBUF, LBYTES, JERR)
         IF (IERR.EQ.0) IERR = JERR
C                                       Turn off things in case CLOS
C                                       follows FLSH
 930  FTAB(IND+4) = 0
      FTAB(IND+12) = 0
      IF (IERR.NE.0) GO TO 980
      IF (OP.EQ.'WRIT') GO TO 999
C                                       WEOF
      IF ((FTAB(IND+11).LE.0) .OR. (DISK) .OR. (FTAB(IND+9).EQ.0))
     *   GO TO 935
         I = 1
         CALL ZTAPE ('WEOF', FTAB(IND), IND, I, IERR)
         IF (IERR.EQ.0) GO TO 935
            WRITE (MSGTXT,1930) IERR
            CALL MSGWRT (6)
 935  FTAB(IND+11) = 0
C                                       Close file
 950  IF ((OP.EQ.'FLSH') .AND. (IERR.NE.0)) GO TO 980
      IF (OP.EQ.'FLSH') GO TO 998
         FDVEC(40) = 0
         CALL ZTPCLS (FTAB(IND), IND, JERR)
         IF (IERR.EQ.0) IERR = JERR
         IF (IERR.NE.0) GO TO 980
         GO TO 998
C                                       I/O error
 970  WRITE (MSGTXT,1970) LBYTES
      IERR = 4
      GO TO 990
 980  WRITE (MSGTXT,1980) IERR, OP
      GO TO 990
C                                       disk IO error
 985  WRITE (MSGTXT,1985) FDVEC(2), FDVEC(31)
C                                       error messages
 990  CALL MSGWRT (6)
C                                       Mark I/O inactive
 998  FTAB(IND+13) = 0
C                                       Don't wait after error
      FTAB(IND+4) = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TAPIO: OPCODE ',A4,' INVALID')
 1010 FORMAT ('TAPIO: ERROR ',I3,' OPENING FILE')
 1100 FORMAT ('TAPIO: BUFFER SIZE=',I6,' TOO SMALL, NEED',I6)
 1101 FORMAT ('TAPIO: RECORD SIZE=',I8,' TOO LARGE FOR I/O SYSTEM')
 1180 FORMAT ('TAPIO: RECORD LENGTH',I7,' INCONSISTENT WITH BLOCK SIZE',
     *   I6)
 1185 FORMAT ('TAPIO: LENGTH',I7,' INCONSISTENT W EXPECTED AND MAX',2I6)
 1186 FORMAT ('TAPIO: LENGTH',I7,' INCONSISTENT WITH EXPECTED',I6)
 1600 FORMAT ('TAPIO: ERROR ',I3,2X,A4,'ING FILE')
 1640 FORMAT ('TAPIO: WROTE',I6,' BYTES WHEN REQUESTED',I6,
     *   'END-OF-TAPE?')
 1810 FORMAT ('TAPIO: ERROR',I3,' POSITIONING TAPE')
 1930 FORMAT ('TAPIO: ERROR',I3,' WRITING END OF FILE MARKS')
 1970 FORMAT ('TAPIO: LBYTES=',I8,' BUT IERR = 0')
 1980 FORMAT ('TAPIO: ERROR',I3,' DOING I/O WITH OPCODE = ',A4)
 1985 FORMAT ('TAPIO: BYTES, TYPE=',I7,I3,
     *     ' SHOULD BE  2880 or 2560, 0')
      END

      SUBROUTINE YGRAFX (OP, GRFX, RED, GREEN, BLUE, IERR)
C-----------------------------------------------------------------------
C! read/write TV graphics colors
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YGRAFX modifies the colour of the graphics or cursor.
C   Inputs:
C      OP       C*4   READ or WRITE graphics colour assignment.
C      GRFX     I     Cursor (0), or graphics plane number.
C   In/Out:
C      RED      R     Red,   0.0 - 1.0
C      GREEN    R     Green, 0.0 - 1.0
C      BLUE     R     Blue,  0.0 - 1.0
C   Output:
C      IERR     I     Error status, 0 means success.
C   Version for IIS Models 70 and 75.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   GRFX, IERR
      REAL      BLUE, GREEN, RED
C
      INTEGER   CODE, IR, IG, IB, SCRTCH(256)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
C                                       Check inputs.
      IERR = 0
      IF ((GRFX.LT.0) .OR. (GRFX.GT.NGRAPH)) THEN
         WRITE (MSGTXT,1000) GRFX
         IERR = 2
         GO TO 990
         END IF
C                                       Change colors
      IF (OP.EQ.'WRIT') THEN
         IR = MAX (0.0, MIN (1.0, RED)) * 31.0 + 0.5
         IG = MAX (0.0, MIN (1.0, GREEN)) * 31.0 + 0.5
         IB = MAX (0.0, MIN (1.0, BLUE)) * 31.0 + 0.5
         CODE = (IR * 32 + IG) * 32 + IB
         IF (GRFX.EQ.0) THEN
            IF (CODE.LE.0) THEN
               MSGTXT = 'YGRAFX: CURSOR COLOR = 0 NOT ALLOWED'
               IERR = 2
               GO TO 990
               END IF
            YBUFF(8) = CODE
            CALL YGRAPH ('ONNN', 8, SCRTCH, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1010) IERR
               GO TO 990
               END IF
         ELSE
            YBUFF(GRFX) = CODE
            IB = 2 ** (GRFX + NGRAY - 1)
            IF (MOD(TVLIMG(1)/IB, 2).EQ.1) THEN 
               CALL YGRAPH ('ONNN', GRFX, SCRTCH, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1015) IERR, GRFX
                  GO TO 990
                  END IF
               END IF
            END IF

C                                       RGRFX opcode.
      ELSE IF (OP.EQ.'READ') THEN
         IF (YBUFF(8).EQ.0) CALL YGRAPH ('INIT', GRFX, SCRTCH, IERR)
         IF (GRFX.EQ.0) THEN
            CODE = YBUFF(8)
         ELSE
            CODE = YBUFF(GRFX)
            END IF
         IB = MOD (CODE, 32)
         CODE = CODE / 32
         IG = MOD (CODE, 32)
         CODE = CODE / 32
         IR = MOD (CODE, 32)
         RED   = IR / 31.0
         GREEN = IG / 31.0
         BLUE  = IB / 31.0
C                                       Unrecognized OP.
      ELSE
         MSGTXT = 'YGRAFX: Unrecognized OP code - ' // OP
         IERR = 2
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('YGRAFX: INVALID GRAPHICS PLANE NUMBER',I4)
 1010 FORMAT ('YGRAFX: ERROR',I3,' CHANGING CURSOR COLOR')
 1015 FORMAT ('YGRAFX: ERROR',I3,' CHANGING COLOR GRAPHICS CHANNEL',I3)
      END

LOCAL INCLUDE 'DCONV.INC'
C                                       Local include for DCONV
      INTEGER   JHDR(256)
      REAL      SQIN, SQLN, SQOU, DKIN, DKLN, DKOU, BMA, BMI, BPA,
     *   FACT, BLC(7), TRC(7), AP(10), BADD(10), STD, AVG, NITR
      HOLLERITH XNMIN(3), XCLIN(2), XNMLN(3), XCLLN(2), XNMOU(3),
     *   XCLOU(2), XOPC(1)
      CHARACTER NMIN*12, CLIN*6, NMLN*12, CLLN*6, NMOU*12, CLOU*6,
     *   OPC*4
      COMMON /INPARM/ XNMIN, XCLIN, SQIN, DKIN, XNMLN, XCLLN, SQLN,
     *   DKLN, XNMOU, XCLOU, SQOU, DKOU, BLC, TRC, XOPC, FACT, STD, AVG,
     *   NITR, BMA, BMI, BPA, AP, BADD
      COMMON /CHRCOM/ NMIN, CLIN, NMLN, CLLN, NMOU, CLOU, OPC
      COMMON /MAPHDR/ JHDR
LOCAL END
      PROGRAM DCONV
C-----------------------------------------------------------------------
C! Deconvolve a moment image(?).
C# Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2007-2009, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Deconvolution of (moment) maps
C   Parameters :
C   Keyword name Program name
C      USERID       USER        User number
C      INNAME       NMIN        Name input image
C      INCLASS      CLIN        Class input image
C      INSEQ        SQIN        Seq. # input image
C      INDISK       DKIN        Disk # input image
C      IN2NAME      NMLN        Name second input image
C      IN2CLASS     CLLN        Class second input image
C      IN2SEQ       SQLN        Seq. # second input image
C      IN2DISK      DKLN        Disk # second input image
C      OUTNAME      NMOU        Name output image
C      OUTCLASS     CLOU        Class output image
C      OUTSEQ       SQOU        Seq. # output image
C      OUTDISK      DKOU        Disk # output image
C      BLC           BLC        Lower left corner coordinates
C      TRC           TRC        Top right corner coordinates
C      OPCODE        OPC        'IN2C','UNWT'
C      FACTOR       FACT        Isolation criterion
C      PIXSTD        STD        Stopping criterion
C      NITER        NITR        Max. # iterations
C      BMAJ          BMA        Major axis beam (arcsec)
C      BMIN          BMI        Minor axis beam (arcsec)
C      BPA           BPA        Position angle major axis (degrees,N=>E)
C      APARM          AP        Parameters gain function (see EXPLAIN
C                               file)
C      BADDISK       IBAD       Disks to avoid for scratch
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   NMAX
      PARAMETER (NMAX = 11 * MAXIMG)
C
      CHARACTER PGMNAM*6, READ*4, WRIT*4, FINI*4, MA*2, UPDT*4, REST*4,
     *   INIT*4, CUNWT*4, BLANK*4
      INTEGER   IVOL, JVOL, LVOL, ISEQ, JSEQ, LSEQ, ITEMP, ILUN, JLUN,
     *   KLUN, LLUN, MLUN, ICN, JCN, LCN, IIND, JIND, KIND, LIND, MIND,
     *   NIND, CATBLK(256), LHDR(256), SCR(256), IER, IUSR, MYM, NTOT,
     *   NIT, ITER, NMN, NPARM, IRET, NBUF, BOF, IBFI(MABFSS),
     *   IBFJ(MABFSS), IBFK(MABFSS), IBFL(MABFSS), IBFM(MABFSS),
     *   IBFN(MABFSS), MM, LL, JJ, NXL, NYL, IVU, JVU, IVM, ILO, MX, MY,
     *   WINI(4), WINJ(4), WINL(4), POINT, PINDX, MXH, MYH, NLUN, IX,
     *   IY, JX, JY, J, I, IAV, NVALU, NISOL, N, IW, IV, IROUND, L27,
     *   L28
      HOLLERITH THDRH(256)
      REAL  CATR(256), SHDR(256), THDR(256), WT(3600), SUMW, SUMV,
     *   SIGMA, DELTA, RMSN, RMS, RMSR, RBFI(MABFSS), RBFJ(MABFSS),
     *   RBFK(MABFSS), RBFL(MABFSS), RBFM(MABFSS), RBFN(MABFSS),
     *   VU(NMAX), H(NMAX), VM(MABFSS), DRPX, DRPY, DRVX, DRVY,
     *   VAV(MABFSS), VSG(MABFSS), SUMVV, WGHT, WVEL, DELTB, EXPON, PI,
     *   DX, DY, INDE, AVCOR, AVCORN, WHM, MID, GAIN, VRES, V1, DLTOT,
     *   AVCORR
      CHARACTER HILINE*72, PHNAME*48
      DOUBLE PRECISION CATD(128), EHDR(128), FHDR(128)
      LOGICAL   T, F, OKAY, UNWT, LMTS
      INCLUDE 'DCONV.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATBLK(1), CATR(1), CATD(1))
      EQUIVALENCE (LHDR(1), SHDR(1), EHDR(1))
      EQUIVALENCE (JHDR(1), THDR(1), FHDR(1), THDRH(1))
      EQUIVALENCE (RBFI(1), IBFI(1))
      EQUIVALENCE (RBFJ(1), IBFJ(1))
      EQUIVALENCE (RBFK(1), IBFK(1))
      EQUIVALENCE (RBFL(1), IBFL(1))
      EQUIVALENCE (RBFM(1), IBFM(1))
      EQUIVALENCE (RBFN(1), IBFN(1))
      DATA CUNWT /'UNWT'/
      DATA PGMNAM, NPARM /'DCONV ', 63/
      DATA READ, WRIT, FINI, INIT, REST, UPDT
     *   /'READ','WRIT','FINI','INIT','REST','UPDT'/
      DATA MA, BLANK /'MA','    '/
      DATA T, F / .TRUE.,.FALSE. /
      DATA BOF /1/
      DATA ILUN, JLUN, KLUN, LLUN, MLUN, NLUN /16,17,18,19,20,21/
      DATA PI, L27, L28 /3.14159265, 27,28/
C-----------------------------------------------------------------------
C                                        fill common IDCH
      CALL ZDCHIN (T)
C                                        enter catalog pointers
      CALL VHDRIN
      INDE = FBLANK
      NSCR = 0
      NCFILE = 0
      NBUF = MABFSS * 2
C                                        Get parameter values
      CALL GTPARM (PGMNAM, NPARM, RQUICK, XNMIN, SCR, IRET)
      IF (IRET.EQ.0) GO TO 100
         IF (IRET.EQ.1) GO TO 999
         WRITE (MSGTXT,5050) IRET
         IRET = 16
         CALL MSGWRT (8)
 100  IF (RQUICK) CALL RELPOP (IRET, SCR, IER)
      IF (IRET.NE.0) GO TO 990
      IRET = 8
C                                        interpret input
      DO 10 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 10      CONTINUE
      ISEQ = IROUND (SQIN)
      IVOL = IROUND (DKIN)
      LSEQ = IROUND (SQLN)
      LVOL = IROUND (DKLN)
      JSEQ = IROUND (SQOU)
      JVOL = IROUND (DKOU)
      IUSR = NLUSER
      NIT  = IROUND (NITR)
      LMTS = (AP(1).NE.0.0) .OR. (AP(2).NE.0.0)
      MID  = (AP(2) + AP(1)) / 2.0
      WHM  = (AP(2) - AP(1)) / 2.0
C                                       Convert characters
      CALL H2CHR (12, 1, XNMIN, NMIN)
      CALL H2CHR (6, 1, XCLIN, CLIN)
      CALL H2CHR (12, 1, XNMLN, NMLN)
      CALL H2CHR (6, 1, XCLLN, CLLN)
      CALL H2CHR (12, 1, XNMOU, NMOU)
      CALL H2CHR (6, 1, XCLOU, CLOU)
      CALL H2CHR (4, 1, XOPC, OPC)
      UNWT = OPC.EQ.CUNWT
      IF (NIT.EQ.0) NIT  = 1
      IF (BMA.GT.0.0) GO TO 105
         WRITE (MSGTXT,5000)
         CALL MSGWRT (8)
         GO TO 990
 105  IF (BMI.LE.0.0) BMI = BMA
C                                        open input map
      CALL MAPOPN (READ, IVOL, NMIN, CLIN, ISEQ, MA, IUSR, ILUN, IIND,
     *   ICN, CATBLK, SCR, IER)
      IF (IER.EQ.0) GO TO 110
         WRITE (MSGTXT,5100) IER
         CALL MSGWRT (8)
         GO TO 980
 110  CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IER)
      IF (IER.EQ.0) GO TO 120
         GO TO 990
 120  IX = CATBLK(KINAX)
      IY = CATBLK(KINAX+1)
C
      IF (UNWT) GO TO 140
         CALL MAPOPN (READ, LVOL, NMLN, CLLN, LSEQ, MA, IUSR, LLUN,
     *      LIND, LCN, LHDR, SCR, IER)
         IF (IER.EQ.0) GO TO 130
            WRITE (MSGTXT,5100) IER
            CALL MSGWRT (8)
            GO TO 980
 130     OKAY = (CATBLK(KINAX).EQ.LHDR(KINAX)) .AND.
     *      (CATBLK(KINAX+1).EQ.LHDR(KINAX+1)) .AND.
     *      (CATR(KRCIC).EQ.SHDR(KRCIC)) .AND.
     *      (CATR(KRCIC+1).EQ.SHDR(KRCIC+1))
         DRPX = (SHDR(KRCRP) - CATR(KRCRP)) * CATR(KRCIC)
         DRPY = (SHDR(KRCRP+1) - CATR(KRCRP+1)) * CATR(KRCIC+1)
         DRVX = EHDR(KDCRV) - CATD(KDCRV)
         DRVY = EHDR(KDCRV+1) - CATD(KDCRV+1)
         OKAY = (OKAY) .AND. (ABS(DRPX-DRVX).LE.1.0E-6 * ABS(DRPX))
     *      .AND. (ABS(DRPY-DRVY).LE.1.0E-6 * ABS(DRPY))
         IF (OKAY) GO TO 140
            WRITE (MSGTXT,5120)
            CALL MSGWRT (8)
            GO TO 990
C                                        fill in output header
 140  CALL COPY (256, CATBLK, JHDR)
      IF (NMOU(1:4).EQ.BLANK(1:4)) NMOU = NMIN
      IF (CLOU(1:4).EQ.BLANK(1:4)) CLOU = CLIN
C                                        name, class, sequence
      CALL CHR2H (12, NMOU, KHIMNO, THDRH(KHIMN))
      CALL CHR2H (6, CLOU, KHIMCO, THDRH(KHIMC))
      JHDR(KIIMS) = JSEQ
C                                        points/axis, reference pixel
      JHDR(KINAX) = TRC(1) - BLC(1) + 1.0001
      JHDR(KINAX+1) = TRC(2) - BLC(2) + 1.0001
      THDR(KRCRP) = CATR(KRCRP)   - BLC(1) + 1.0
      THDR(KRCRP+1) = CATR(KRCRP+1) - BLC(2) + 1.0
      JX = JHDR(KINAX)
      JY = JHDR(KINAX+1)
C                                        map must be of type REAL
      THDR(KRBLK) = INDE
C                                        create output map using JHDR
      CALL MCREAT (JVOL, JCN, SCR, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,5150) IER
         CALL MSGWRT (8)
         GO TO 980
         END IF
C                                       copy keywords
      CALL KEYPCP (IVOL, ICN, JVOL, JCN, 0, ' ', IER)
C                                     *  open output map. MAPOPN is not
C                                     *  used, since MAPOPN with WRITE
C                                     *  implies exclusive use.
      CALL ZPHFIL (MA, JVOL, JCN, 1, PHNAME, IER)
C                                        open output map NOT exclusive
      CALL ZOPEN (JLUN, JIND, JVOL, PHNAME, T, F, T, IER)
      IF (IER.EQ.0) GO TO 160
         WRITE (MSGTXT,5200) IER
         CALL MSGWRT (8)
         GO TO 980
C                                        initialize reading
 160  WINI(1) = BLC(1) + 0.001
      WINI(2) = BLC(2) + 0.001
      WINI(3) = TRC(1) + 0.001
      WINI(4) = TRC(2) + 0.001
      CALL MINIT (READ, ILUN, IIND, IX, IY, WINI, IBFI, NBUF, BOF, IER)
      IF (IER.EQ.0) GO TO 170
         WRITE (MSGTXT,5300) IER
         CALL MSGWRT (8)
         GO TO 980
C                                        initialize writing
 170  WINJ(1) = 1
      WINJ(2) = 1
      WINJ(3) = JX
      WINJ(4) = JY
      CALL MINIT (WRIT, JLUN, JIND, JX, JY, WINJ, IBFL, NBUF, BOF, IER)
      IF (IER.EQ.0) GO TO 180
         WRITE (MSGTXT,5300) IER
         CALL MSGWRT (8)
         GO TO 980
C                                        read and write
 180  DO 200 J = 1,JY
         CALL LINIO (READ, ILUN, IIND, RBFI, JX, VU, 1, INDE, IER)
         IF (IER.EQ.0) GO TO 190
            WRITE (MSGTXT,5400) IER
            CALL MSGWRT (8)
            GO TO 980
 190     CALL LINIO (WRIT, JLUN, JIND, RBFL, JX, VU, 1, INDE, IER)
         IF (IER.EQ.0) GO TO 200
            WRITE (MSGTXT,5400) IER
            CALL MSGWRT (8)
            GO TO 980
 200     CONTINUE
C                                        flush buffer
      CALL LINIO (FINI, JLUN, JIND, RBFL, JX, VU, 1, INDE, IER)
C                                        open output map using new LUN
C                                        to call MINIT with READ later
      CALL ZOPEN (KLUN, KIND, JVOL, PHNAME, T, F, T, IER)
      IF (IER.EQ.0) GO TO 210
         WRITE (MSGTXT,5200) IER
         CALL MSGWRT (8)
         GO TO 980
 210  CALL BUNDEL (BMA, BMI, BPA, WT, MX, MY)
      IF (JX*MX.LE.NMAX) GO TO 220
         ITEMP = JX * MX
         WRITE (MSGTXT,5510) ITEMP, NMAX
         CALL MSGWRT (5)
         GO TO 980
 220  MXH = MX / 2
      MYH = MY / 2
      NXL = JX - MX + 1
      NYL = JY - MY + 1
      MYM = MY - 1
C                                        define new windows
      DO 230 I = 1,4
         WINL(I) = WINI(I)
 230     CONTINUE
      WINI(2) = WINI(2) + MYH
      WINI(4) = WINI(4) - MYH
C                                        fill arrays VAV, VSG, and H
      DO 240 I = 1,JX
         VAV(I) = INDE
         VSG(I) = INDE
         DO 239 J = 1,MY
            H(I + (J - 1) * JX) = 1.0
 239        CONTINUE
 240     CONTINUE
      IF (LMTS) GO TO 455
C-----------------------------------------------------------------------
C                                        scratch file intermezzo
C                                        create REAL scratch files
      IAV = 1
      CALL MAPSNC (2, JHDR(KINAX), IAV, MLUN, MIND, IBFM, IER)
      CALL MAPSNC (2, JHDR(KINAX), IAV, NLUN, NIND, IBFN, IER)
      IF (IER.EQ.0) GO TO 250
         WRITE (MSGTXT,6000) IER
         CALL MSGWRT (5)
         GO TO 980
 250  IF (UNWT) GO TO 260
C                                        prepare reading HI map
         CALL MINIT (READ, LLUN, LIND, IX, IY, WINL, IBFL, NBUF, BOF,
     *      IER)
         IF (IER.EQ.0) GO TO 260
            WRITE (MSGTXT,5300) IER
            CALL MSGWRT (8)
            GO TO 980
C                                        prepare reading map VU
 260  CALL MINIT (READ, KLUN, KIND, JX, JY, WINJ, IBFK, NBUF, BOF, IER)
      IF (IER.EQ.0) GO TO 270
         WRITE (MSGTXT,5300) IER
         CALL MSGWRT (8)
         GO TO 980
C                                        read first MY-1 lines to H
 270  IF (UNWT) GO TO 300
         PINDX = 0
         POINT = PINDX * JX + 1
         DO 290 J = 1, MYM
            CALL LINIO (READ, LLUN, LIND, RBFL, JX, H, POINT, INDE, IER)
            IF (IER.EQ.0) GO TO 280
               WRITE (MSGTXT,5400) IER
               CALL MSGWRT (8)
               GO TO 980
C                                        new pointer and -index
 280        PINDX = MOD (PINDX + 1, MY)
            POINT = PINDX * JX + 1
 290        CONTINUE
C                                        read first MY-1 lines to VU
C                                        pointer index, pointer
 300  PINDX = 0
      POINT = PINDX * JX + 1
      DO 320 J = 1, MYM
         CALL LINIO (READ, KLUN, KIND, RBFK, JX, VU, POINT, INDE, IER)
         IF (IER.EQ.0) GO TO 310
            WRITE (MSGTXT,5400) IER
            CALL MSGWRT (8)
            GO TO 980
C                                        new pointer and -index
 310     PINDX = MOD (PINDX + 1, MY)
         POINT = PINDX * JX + 1
 320     CONTINUE
C                                        prepare writing scratch files
      CALL MINIT (WRIT, MLUN, MIND, JX, JY, WINJ, IBFM, NBUF, BOF, IER)
      CALL MINIT (WRIT, NLUN, NIND, JX, JY, WINJ, IBFN, NBUF, BOF, IER)
      IF (IER.EQ.0) GO TO 330
         WRITE (MSGTXT,5300) IER
         CALL MSGWRT (5)
         GO TO 980
C                                        min. # points in beam within
C                                        5% level. (1.08 = ln20 / ln16)
 330  DX = -CATR(KRCIC)  * 3600.0
      DY = CATR(KRCIC+1) * 3600.0
      NMN = 1.08 * PI * BMA * BMI / DX / DY * FACT
      NVALU = 0
      NISOL = 0
C                                        write blanks in first lines
      DO 350 JJ = 1,MYH
         CALL LINIO (WRIT, MLUN, MIND, RBFM, JX, VAV, 1, INDE, IER)
         CALL LINIO (WRIT, NLUN, NIND, RBFN, JX, VSG, 1, INDE, IER)
         IF (IER.EQ.0) GO TO 350
            WRITE (MSGTXT,5400) IER
            CALL MSGWRT (8)
            GO TO 980
 350     CONTINUE
C                                        begin loop
      DO 430 JJ = 1,NYL
C                                        m-value central line
         MM = JJ + BLC(2) - 0.9999 + MYH
         IF (UNWT) GO TO 360
C                                        read next line in H
            CALL LINIO (READ, LLUN, LIND, RBFL, JX, H, POINT, INDE, IER)
            IF (IER.EQ.0) GO TO 360
               WRITE (MSGTXT,5400) IER
               CALL MSGWRT (8)
               GO TO 980
C                                        read next line in VU
 360     CALL LINIO (READ, KLUN, KIND, RBFK, JX, VU, POINT, INDE, IER)
         IF (IER.EQ.0) GO TO 370
            WRITE (MSGTXT,5400) IER
            CALL MSGWRT (8)
            GO TO 980
C                                        slide along central line
 370     DO 410 ILO = 1,NXL
C                                        l-value central point
            LL = ILO + BLC(1) - 0.9999 + MXH
            SUMW = 0.0
            SUMV = 0.0
            SUMVV = 0.0
C                                        index central point in VM
            IVM = ILO + MXH
C                                        index start central line in VU
            JVU = 1 + JX * MOD (MYH + 1 + PINDX, MY)
C                                        index central point in VU,H
            IVU = IVM + JVU - 1
            VAV(IVM) = INDE
            IF ((VU(IVU).EQ.INDE) .OR. (H(IVU).EQ.INDE)) GO TO 410
C                                        calculation in one point
               N = 0
               DO 390 J = 1,MY
                  DO 380 I = 1,MX
C                                        index in array WT
                     IW = I + (J - 1) * MX
C                                        index in arrays VU,H
                     IV = ILO + I - 1 + JX * MOD (J + PINDX, MY)
                     IF ((VU(IV).EQ.INDE) .OR. (H(IV).EQ.INDE))
     *                  GO TO 380
                     IF (WT(IW).EQ.0.0) GO TO 380
C                                        omit central point
                     IF (IV.EQ.IVU) GO TO 380
                        N = N + 1
                        WGHT = H(IV) * WT(IW)
                        WVEL = WGHT  * VU(IV)
                        SUMW = SUMW  + WGHT
                        SUMV = SUMV  + WVEL
                        SUMVV = SUMVV + WVEL * VU(IV)
 380                 CONTINUE
 390              CONTINUE
               NVALU = NVALU + 1
               IF (N.LT.NMN) GO TO 400
                  VAV(IVM) = SUMV  / SUMW
                  VSG(IVM) = SUMVV / SUMW - VAV(IVM) ** 2
                  IF (VSG(IVM).LT.0.0) VSG(IVM) = 0.0
                  VSG(IVM) = SQRT (VSG(IVM))
                  GO TO 410
 400           NISOL = NISOL + 1
 410           CONTINUE
C                                        write line to scratch maps
         CALL LINIO (WRIT, MLUN, MIND, RBFM, JX, VAV, 1, INDE, IER)
         CALL LINIO (WRIT, NLUN, NIND, RBFN, JX, VSG, 1, INDE, IER)
         IF (IER.EQ.0) GO TO 420
            WRITE (MSGTXT,5400) IER
            CALL MSGWRT (8)
            GO TO 980
C                                        new pointer index
 420     PINDX = MOD (PINDX + 1, MY)
         POINT = PINDX * JX + 1
C
 430     CONTINUE
C                                        write blanks in last lines
      DO 440 I = 1,JX
         VAV(I) = INDE
         VSG(I) = INDE
 440     CONTINUE
      DO 450 JJ = 1,MYH
         CALL LINIO (WRIT, MLUN, MIND, RBFM, JX, VAV, 1, INDE, IER)
         CALL LINIO (WRIT, NLUN, NIND, RBFN, JX, VSG, 1, INDE, IER)
         IF (IER.EQ.0) GO TO 450
            WRITE (MSGTXT,5400) IER
            CALL MSGWRT (8)
            GO TO 980
 450     CONTINUE
C                                        flush buffers
      CALL LINIO (FINI, MLUN, MIND, RBFM, JX, VAV, 1, INDE, IER)
      CALL LINIO (FINI, NLUN, NIND, RBFN, JX, VSG, 1, INDE, IER)
      WRITE (MSGTXT,5600) NVALU,NISOL
      CALL MSGWRT (5)
C                                        end scratch file intermezzo
C-----------------------------------------------------------------------
 455  ITER  = 1
      WRITE (MSGTXT,5520)
      CALL MSGWRT (5)
C                                        start iterations ************
 460  CONTINUE
C                                        (re)set variables
      SIGMA  = 0.0
      NTOT   = 0
      AVCORN = 0.0
      IF (UNWT) GO TO 470
C                                        prepare reading HI map
         CALL MINIT (READ, LLUN, LIND, IX, IY, WINL, IBFL, NBUF, BOF,
     *      IER)
         IF (IER.EQ.0) GO TO 470
            WRITE (MSGTXT,5300) IER
            CALL MSGWRT (8)
            GO TO 980
C                                        prepare reading map VU
 470  CALL MINIT (READ, KLUN, KIND, JX, JY, WINJ, IBFK, NBUF, BOF, IER)
      IF (IER.EQ.0) GO TO 480
         WRITE (MSGTXT,5300) IER
         CALL MSGWRT (8)
         GO TO 980
C                                        read first MY-1 lines to H
 480  IF (UNWT) GO TO 510
         PINDX = 0
         POINT = PINDX * JX + 1
         DO 500 J = 1,MYM
            CALL LINIO (READ, LLUN, LIND, RBFL, JX, H, POINT, INDE, IER)
            IF (IER.EQ.0) GO TO 490
               WRITE (MSGTXT,5400) IER
               CALL MSGWRT (8)
               GO TO 980
C                                        new pointer and -index
 490        PINDX = MOD (PINDX + 1, MY)
            POINT = PINDX * JX + 1
 500        CONTINUE
C                                        read first MY-1 lines to VU
C                                        pointer index, pointer
 510  PINDX = 0
      POINT = PINDX * JX + 1
      DO 530 J = 1,MYM
         CALL LINIO (READ, KLUN, KIND, RBFK, JX, VU, POINT, INDE, IER)
         IF (IER.EQ.0) GO TO 520
            WRITE (MSGTXT,5400) IER
            CALL MSGWRT (8)
            GO TO 980
C                                        new pointer and -index
 520     PINDX = MOD (PINDX + 1, MY)
         POINT = PINDX * JX + 1
 530     CONTINUE
C                                        prepare reading orig. map VM
      CALL MINIT (READ, ILUN, IIND, IX, IY, WINI, IBFI, NBUF, BOF, IER)
      IF (IER.EQ.0) GO TO 540
         WRITE (MSGTXT,5300) IER
         CALL MSGWRT (8)
         GO TO 980
C                                        prepare reading scratch maps
 540  IF (LMTS) GO TO 545
         CALL MINIT (READ, MLUN, MIND, JX, JY, WINJ, IBFM, NBUF, BOF,
     *      IER)
         CALL MINIT (READ, NLUN, NIND, JX, JY, WINJ, IBFN, NBUF, BOF,
     *      IER)
C                                        prepare writing output map
 545  CALL MINIT (WRIT, JLUN, JIND, JX, JY, WINJ, IBFJ, NBUF, BOF, IER)
      IF (IER.EQ.0) GO TO 550
         WRITE (MSGTXT,5300) IER
         CALL MSGWRT (8)
         GO TO 980
C                                        write blanks in first lines
 550  DO 560 JJ = 1,MYH
         IF (LMTS) GO TO 555
            CALL LINIO (READ, MLUN, MIND, RBFM, JX, VAV, 1, INDE, IER)
            CALL LINIO (READ, NLUN, NIND, RBFN, JX, VSG, 1, INDE, IER)
 555     CALL LINIO (WRIT, JLUN, JIND, RBFJ, JX, VAV, 1, INDE, IER)
         IF (IER.EQ.0) GO TO 560
            WRITE (MSGTXT,5400) IER
            CALL MSGWRT (8)
            GO TO 980
 560        CONTINUE
C                                        begin loop
      DO 680 JJ = 1,NYL
C                                        m-value central line
         MM = JJ + BLC(2) - 0.9999 + MYH
         IF (UNWT) GO TO 570
C                                        read next line in H
            CALL LINIO (READ, LLUN, LIND, RBFL, JX, H, POINT, INDE, IER)
            IF (IER.EQ.0) GO TO 570
               WRITE (MSGTXT,5400) IER
               CALL MSGWRT (8)
               GO TO 980
C                                        read next line in VU
 570     CALL LINIO (READ, KLUN, KIND, RBFK, JX, VU, POINT, INDE, IER)
         IF (IER.EQ.0) GO TO 580
            WRITE (MSGTXT,5400) IER
            CALL MSGWRT (8)
            GO TO 980
C                                        read comp. line from VM
 580     CALL LINIO (READ, ILUN, IIND, RBFI, JX, VM, 1, INDE, IER)
         IF (IER.EQ.0) GO TO 590
            WRITE (MSGTXT,5400) IER
            CALL MSGWRT (8)
            GO TO 980
C                                        read line from scratch #1
 590     IF (LMTS) GO TO 610
            CALL LINIO (READ, MLUN, MIND, RBFM, JX, VAV, 1, INDE, IER)
            IF (IER.EQ.0) GO TO 600
               WRITE (MSGTXT,5400) IER
               CALL MSGWRT (8)
               GO TO 980
C                                        read line from scratch #2
 600        CALL LINIO (READ, NLUN, NIND, RBFN, JX, VSG, 1, INDE, IER)
            IF (IER.EQ.0) GO TO 610
               WRITE (MSGTXT,5400) IER
               CALL MSGWRT (8)
               GO TO 980
C                                        slide along central line
 610     DO 660 ILO = 1,NXL
C                                        l-value central point
            LL   = ILO + BLC(1) - 0.9999 + MXH
            SUMV = 0.0
            SUMW = 0.0
            N = 0
C                                        index corrected pixel VM,VAV
            IVM = ILO + MXH
C                                        index start central line VU
            JVU = 1 + JX * MOD (MYH + 1 + PINDX, MY)
C                                        index corrected pixel VU,H
            IVU = IVM + JVU - 1
C                                        test if correctable pixel
            IF ((VU(IVU).EQ.INDE) .OR. (H(IVU).EQ.INDE)) GO TO 660
            IF ((.NOT.LMTS) .AND. (VAV(IVM).EQ.INDE)) GO TO 660
            IF ((LMTS) .AND. ((VU(IVU).LT.AP(1)) .OR.
     *         (VU(IVU).GT.AP(2)))) GO TO 660
C                                        correct one pixel
               DO 630 J = 1,MY
                  DO 620 I = 1,MX
C                                        index in array WT
                     IW = I + (J - 1) * MX
C                                        index in array VU
                     IV = ILO + I - 1 + JX * MOD (J + PINDX, MY)
                     IF ((VU(IV).EQ.INDE) .OR. (H(IV).EQ.INDE))
     *                  GO TO 620
                     IF ((LMTS) .AND. ((VU(IV).LT.AP(1)) .OR.
     *                   (VU(IV).GT.AP(2))))  GO TO 620
                     IF (WT(IW).EQ.0.0) GO TO 620
                        N = N + 1
                        WGHT = H(IV) * WT(IW)
                        SUMV = SUMV + WGHT * VU(IV)
                        SUMW = SUMW + WGHT
 620                 CONTINUE
 630              CONTINUE
               IF (N.LT.1) GO TO 660
C                                        correction
               VRES  = SUMV / SUMW
               DELTA = VM(IVM) - VRES
               GAIN  = 1.0
C                                        modify correction
               IF (LMTS) GO TO 640
                  DELTB = VU(IVU) - VAV(IVM)
                  IF (VSG(IVM).EQ.0.0) GO TO 650
                  GAIN  = 0.0
                  EXPON = (DELTB/VSG(IVM))**2 / 2.0
                  IF (EXPON.LT.2.0)  GAIN = EXP (-EXPON)
                  GO TO 650
 640           IF (AP(3).EQ.1.0) GO TO 645
C                                        triangular gain
                  GAIN = MAX (1.0-ABS(VU(IVU)-MID)/WHM, 0.0)
                  GO TO 650
C                                        rectangular gain
 645           CONTINUE
                  V1 = MIN (VU(IVU)+DELTA, AP(2))
                  V1 = MAX (V1, AP(1))
                  DELTA = V1 - VU(IVU)
 650           DELTA = DELTA * GAIN
               VU(IVU) = VU(IVU) + DELTA
               SIGMA = SIGMA + DELTA * DELTA
               NTOT = NTOT + 1
               DLTOT = ABS (VM(IVM) - VU(IVU))
               AVCORN = ((NTOT - 1) * AVCORN + DLTOT) / NTOT
 660           CONTINUE
C                                        write one corrected line
         CALL LINIO (WRIT, JLUN, JIND, RBFJ, JX, VU, JVU, INDE, IER)
         IF (IER.EQ.0) GO TO 670
            WRITE (MSGTXT,5400) IER
            CALL MSGWRT (8)
            GO TO 980
C                                        new pointer index
 670     PINDX = MOD (PINDX + 1, MY)
         POINT = PINDX * JX + 1
 680     CONTINUE
C                                        write blanks in last lines
      DO 690 JJ = 1,MYH
         IF (LMTS) GO TO 685
            CALL LINIO (READ, MLUN, MIND, RBFM, JX, VAV, 1, INDE, IER)
            CALL LINIO (READ, NLUN, NIND, RBFN, JX, VSG, 1, INDE, IER)
 685     CALL LINIO (WRIT, JLUN, JIND, RBFJ, JX, VAV, 1, INDE, IER)
         IF (IER.EQ.0) GO TO 690
            WRITE (MSGTXT,5400) IER
            CALL MSGWRT (8)
            GO TO 980
 690     CONTINUE
C                                        flush buffer
      CALL LINIO (FINI, JLUN, JIND, RBFJ, JX, VU, JVU, INDE, IER)
      RMSN   = SQRT (SIGMA / NTOT)
      IF (ITER.EQ.1) GO TO 700
         RMSR   = 100.0 * (RMS / RMSN - 1.0)
         AVCORR = 100.0 * (1.0 - AVCOR / AVCORN)
C                                        intermediate output line
         WRITE (MSGTXT,5800)   ITER, RMSN, RMSR, AVCORN, AVCORR
         CALL MSGWRT (5)
C                                        end criterion reached ?
         IF (RMSN.LT.STD.OR.ITER.GE.NIT.OR.AVCORR.LE.AVG) GO TO 720
         GO TO 710
 700  CONTINUE
         WRITE (MSGTXT,5900) ITER,RMSN,AVCORN
         CALL MSGWRT (5)
         IF (ITER.GE.NIT) GO TO 720
 710  ITER  = ITER + 1
      RMS   = RMSN
      AVCOR = AVCORN
      GO TO 460
C                                        end iterations ***********
C                                        close maps
 720  CALL MAPCLS (READ, IVOL, ICN, ILUN, IIND, CATBLK, F, SCR, IER)
      CALL MAPCLS (INIT, JVOL, JCN, JLUN, JIND, JHDR, T, SCR, IER)
      CALL MAPCLS (READ, JVOL, JCN, KLUN, KIND, JHDR, F, SCR, IER)
      IF (.NOT.UNWT) CALL MAPCLS (READ, LVOL, LCN, LLUN, LIND, LHDR, F,
     *   SCR, IER)
C                                        add history file
      CALL HIINIT (3)
      CALL HISCOP (L27, L28, IVOL, JVOL, ICN, JCN, JHDR, SCR, LHDR,
     *   IER)
      IF (IER.GE.4) GO TO 740
      CALL HENCO1 (PGMNAM, NMIN, CLIN, ISEQ, IVOL, L28, LHDR, IER)
      IF (IER.NE.0) GO TO 740
      CALL HENCO2 (PGMNAM, NMLN, CLLN, LSEQ, LVOL, L28, LHDR, IER)
      IF (IER.NE.0) GO TO 740
      CALL HENCOO (PGMNAM, NMOU, CLOU, JSEQ, JVOL, L28, LHDR, IER)
      IF (IER.NE.0) GO TO 740
      WRITE (HILINE,6075) BMA,BMI,BPA,ITER
      CALL HIADD (L28, HILINE, LHDR, IER)
      IF (IER.NE.0) GO TO 740
      CALL HICLOS (L28, T, LHDR, IER)
      IF (IER.NE.0) GO TO 740
      CALL CATIO (UPDT, JVOL, JCN, JHDR, REST, SCR, IER)
      IF (IER.EQ.0) GO TO 750
C                                       problems with history file
 740     WRITE (MSGTXT,6100)
         CALL MSGWRT (8)
         GO TO 990
C
 750  IRET = 0
      GO TO 990
C
 980  CALL MAPCLS (READ, IVOL, ICN, ILUN, IIND, CATBLK, F, SCR, IER)
      CALL MAPCLS (WRIT, JVOL, JCN, JLUN, JIND, CATBLK, F, SCR, IER)
      CALL MAPCLS (READ, JVOL, JCN, KLUN, KIND, CATBLK, F, SCR, IER)
      IF (.NOT.UNWT) CALL MAPCLS (READ, LVOL, LCN, LLUN, LIND, LHDR, F,
     *   SCR, IER)
C
 990  CALL DIE (IRET, SCR)
 999  STOP
C-----------------------------------------------------------------------
 5000 FORMAT ('Illegal BMAJ :  fatal...')
 5050 FORMAT ('GTPARM : IRET = ',I2)
 5100 FORMAT ('MAPOPN : IER  = ',I2)
 5120 FORMAT ('DCONV  : input maps not equivalent - FATAL')
 5150 FORMAT ('MCREAT : IER  = ',I2)
 5200 FORMAT ('ZOPEN  : IER  = ',I2)
 5300 FORMAT ('MINIT  : IER  = ',I2)
 5400 FORMAT ('LINIO  : IER  = ',I2)
 5510 FORMAT ('size x-axis * size beam is ',I5,' cannot exceed ',I5)
 5520 FORMAT (' iteration  rms    decrease (%) tot.av.corr.',
     *        'increase (%)')
 5600 FORMAT (1X,I5,' non-blanked values, ',I5,' isolated')
 5800 FORMAT (4X,I3,2X,G11.4,2X,G9.2,2X,G11.4,2X,G9.2)
 5900 FORMAT (4X,I3,2X,G11.4,13X,G11.4)
 6000 FORMAT ('MAPSNC : IER  = ',I2)
 6075 FORMAT (' major/minor axes:',2(1X,F5.1),' pos. angle: ',F6.1,I3,
     *        ' iterations')
 6100 FORMAT ('error in creating of/adding to history file')
      END
      SUBROUTINE BUNDEL (BMA, BMI, BPA, WT, NX, NY)
C-----------------------------------------------------------------------
C   Fills an array WT with weights according to a gaussian beam
C   with a major axis of BMA arcsec and a position angle of BPA
C   degrees, and a minor axis of BMI arcsec.  The weights start
C   in the lower left corner, and first fill the first row with
C   NX values.  Eventually NY rows are filled this way. The sum
C   of all weights is normalized to unity.
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NXH, NYH, I, J, K, CATBLK(256)
      REAL      BMA, BMI, BPA, WT(3600), X, Y, C4LN2, CRAD, SPA, CPA,
     *   EX, DX, DY, CATR(256), CMA, CMI, SMA, SMI, SUM
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DHDR.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK(1), CATR(1), CATD(1))
      DATA C4LN2, CRAD /2.7725887, 57.295780/
C-----------------------------------------------------------------------
      DX  = -CATR(KRCIC) * 3600.0
      DY  = CATR(KRCIC+1) * 3600.0
      SPA = SIN (BPA / CRAD)
      CPA = COS (BPA / CRAD)
C                                        1.04 is sqrt (ln 20 / ln 16)
C                                        to define 5% level.
      CMA = BMA * CPA * 1.04
      CMI = BMI * CPA * 1.04
      SMA = BMA * SPA * 1.04
      SMI = BMI * SPA * 1.04
C                                        beam surface
      NX  = 2 * SQRT (CMA * CMA + SMI * SMI) / DX
      NY  = 2 * SQRT (CMI * CMI + SMA * SMA) / DY
      NXH = NX / 2
      NYH = NY / 2
      NX  = 2 * NXH + 1
      NY  = 2 * NYH + 1
      K   = 0
      SUM = 0.0
C                                        fill array WT
      DO 20 J = 1,NY
         Y = (J - NYH - 1) * DY
         DO 10 I = 1,NX
            K  = K + 1
            X  = (I - NXH - 1) * DX
            EX = C4LN2 * ((X / BMA * SPA - Y / BMA * CPA) ** 2 +
     *                    (X / BMI * CPA + Y / BMI * SPA) ** 2)
            WT(K) = 0.0
            IF (EX.LT.3.0)  WT(K) = EXP (-EX)
            SUM = SUM + WT(K)
 10         CONTINUE
 20      CONTINUE
C                                        normalize
      K = 0
      DO 40 J = 1,NY
         DO 30 I = 1,NX
            K = K + 1
            WT(K) = WT(K) / SUM
 30         CONTINUE
 40      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE YSPLIT (OP, XSPLT , YSPLT , RCHANS, GCHANS, BCHANS,
     *   VRTRTC, IERR)
C-----------------------------------------------------------------------
C! set channel selection by split-screen quadrant
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YSPLIT reads/writes the look up table/ split screen control
C   registers of the TV - turns channels on/off by quadrant
C   Inputs:
C      OP       C*4    'READ' from TV, 'WRIT' to TV
C      VRTRTC   L      T => do on vertical retrace only
C   In/Out:
C      XSPLT    I      X position of split (1-512, 1 => LHS)
C      YSPLT    I      Y position of split (1-512, 1 => bot)
C      RCHANS   I(4)   chan select bit mask 4 quadrants : red
C      GCHANS   I(4)   chan select bit mask 4 quadrants : green
C      BCHANS   I(4)   chan select bit mask 4 quadrants : blue
C   Output:
C      IERR     I      error code of Z...XF: 0 => ok, 2 => input error
C   Quadrants are numbered CCW from top right!!!!
C   Version for TV by communication
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   XSPLT, YSPLT, RCHANS(4), GCHANS(4), BCHANS(4), IERR
      LOGICAL   VRTRTC
C
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      BUFFER(1) = 0
      IF (VRTRTC) BUFFER(1) = 1
C                                        write: set buffer
      IF (OP.EQ.'WRIT') THEN
         IERR = 2
         IF ((XSPLT.LT.1) .OR. (XSPLT.GT.MAXXTV(1))) GO TO 999
         IF ((YSPLT.LT.1) .OR. (YSPLT.GT.MAXXTV(2))) GO TO 999
         BUFFER(2) = XSPLT
         BUFFER(3) = YSPLT
         CALL COPY (4, RCHANS, BUFFER(4))
         CALL COPY (4, GCHANS, BUFFER(8))
         CALL COPY (4, BCHANS, BUFFER(12))
         BUFSW = 15
         BUFSR = 0
      ELSE
         BUFSW = 1
         BUFSR = 15
         END IF
C                                       do it
      CALL MKYBUF (OP, 'YSPLIT', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
C                                        reset common on write
      IF (IERR.EQ.0) THEN
         IF (OP.EQ.'WRIT') THEN
            TVSPLT(1) = XSPLT
            TVSPLT(2) = YSPLT
C                                        return data on read
         ELSE
            CALL UNYBUF (BUFSR, BUFFER, HEADER)
            XSPLT = BUFFER(2)
            YSPLT = BUFFER(3)
            CALL COPY (4, BUFFER(4), RCHANS)
            CALL COPY (4, BUFFER(8), GCHANS)
            CALL COPY (4, BUFFER(12), BCHANS)
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE YISDRM (OP, ADDR, NWORDS, GOADDR, BUFFER, IERR)
C-----------------------------------------------------------------------
C! read/write data memory of NRAO-ISU device
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YISDRM is a special Y routine for the NRAO Image Storage Unit -
C   a device interposed between the host CPU and the IIS Model 70 TV.
C   YISMPM reads or writes the data memory of the device.
C   Inputs:
C      OP      C*4     'READ', 'WRIT' to micro processor
C      ADDR    I       Desired micro processor address
C      NWORDS  I       Number of words in BUFFER
C      GOADDR  I       Microprocessor address to branch on completion
C   In/Out:
C      BUFFER  I(NWORDS)   code for/from micro processor
C   Output:
C      IERR    I       Error code of Z...XF: 0 okay, 2 input error.
C   IIS Model 70 version - allows an ISU
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   ADDR, NWORDS, GOADDR, BUFFER(*), IERR
C
      INTEGER   ISUOPC, HEADER(8), NB
      DATA ISUOPC /4/
C-----------------------------------------------------------------------
C                                       Build header
      HEADER(1) = 3
      HEADER(2) = -NWORDS
      HEADER(3) = ISUOPC
      IF (OP.EQ.'WRIT') HEADER(3) = ISUOPC - 1
      HEADER(4) = 0
      HEADER(5) = ADDR(2)
      HEADER(6) = ADDR(1)
      HEADER(7) = 0
      HEADER(8) = GOADDR
C                                       Do I/O
      NB = 2 * NWORDS
      CALL ZM70XF (OP, NB, HEADER, BUFFER, IERR)
C
 999  RETURN
      END

LOCAL INCLUDE 'UVLSF.INC'
C                                       Local include for UVLSF
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4), XCALC(1), XNAMOU(3),
     *   XCLAOU(2)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XSUBA, XBIF, XEIF, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER,
     *   XFLAG, XDOBND, XBPVER, XSMOTH(3), XDOAC, XSOUT, XDISO, XBCHAN,
     *   XECHAN, XCHSEL(4,20), XORD, DOOUT, XCHANF, MFLUX, RFLUX,
     *   SHIFT(2), XCENT, BADD(10),
     *   BUFF1(UVBFSS), BUFF2(UVBFSS), BUFF3(UVBFSS), FINC(MAXIF),
     *   DIFPIX
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, JBUFSZ, ILOCWT,
     *   CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECO,
     *   NRPRMI, NRPRMO, CHNSEL(3,20,MAXIF), LBIF, NCHSEL, CHFIT0,
     *   DISK2, SEQO2, CAT2(256), INCS2, INCF2, INCIF2, LREC2, NRPRM2,
     *   NORDER, NIF, NFREQ, LBCHAN, LECHAN, OLDCNO, NEWCNO(2), NFLUXF,
     *   ISBAND(MAXIF)
      LOGICAL   ISCOMP, DOFLUX, ADBACK
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      DOUBLE PRECISION FOFF(MAXIF)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XTIME, XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF, XDOCAL, XGUSE,
     *   XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH, XDOAC,
     *   XNAMOU, XCLAOU, XSOUT, XDISO, XBCHAN, XECHAN, XCHSEL, XORD,
     *   DOOUT, XCHANF, MFLUX, RFLUX, SHIFT, XCENT, BADD
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT
      COMMON /BUFRS/ BUFF1, BUFF2, BUFF3, JBUFSZ
      COMMON /INFO/ CATOLD, CAT2, FOFF, FINC, ISBAND, SEQIN, SEQOUT,
     *   DISKIN, DISKO, ILOCWT,INCSI, INCFI, INCIFI, INCSO, INCFO,
     *   INCIFO, LRECO, NRPRMI, NRPRMO, ISCOMP, CHNSEL, NCHSEL, CHFIT0,
     *   DISK2, SEQO2, INCS2, INCF2, INCIF2, LREC2, NRPRM2, DOFLUX,
     *   NORDER, NIF, NFREQ, LBCHAN, LECHAN, OLDCNO, NEWCNO, ADBACK,
     *   NFLUXF, LBIF, DIFPIX
LOCAL END
LOCAL INCLUDE 'UVLSF2.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   JJC, CHMASK(MAXCIF), NPTS, IOFF
      REAL      DATA(2,MAXCIF), AARRAY(5,5), CARRAY(5,5), GAMMA(5),
     *   MOMENT(15), POLYFN(5), POLAVG(5), POLXFN(MAXCIF,5), XBAR
      COMMON /GDATA/ POLXFN, DATA, AARRAY, CARRAY, GAMMA, MOMENT, XBAR,
     *   POLYFN, POLAVG, JJC, CHMASK, NPTS, IOFF
LOCAL END
      PROGRAM UVLSF
C-----------------------------------------------------------------------
C! Averages several channels and subtracts from uv data.
C# Utility UV UV-util VLA VLB SPECTRAL
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999-2000, 2007-2012, 2014-2015, 2017-2018,
C;  Copyright (C) 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVLSF averages a set of channels and subtracts them from another
C   range of channels.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C         calibration adverbs added
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      BCHAN          BCHAN         Start channel to write out
C      ECHAN          ECHAN         End channel to write out
C      CHANSEL(3,10)  CHNSEL        Channels to select for baseline
C      DOOUTPUT       DOOUT         > 0 => write fit uv data also
C      CHANNEL        CHFIT0        first fit channel out
C      SHIFT          SHIFT(2)      RA and Dec phase shift done before
C                                   fit and then undone.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'UVLSF.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'UVLSF '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL UVLSFI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Filter data.
      CALL UVLSFU (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL UVLSFH
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE UVLSFI (PRGN, JERR)
C-----------------------------------------------------------------------
C   UVLSFI gets input parameters for UVLSF and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      BCHAN   I  Lowest channel number to write.
C      ECHAN   I  Highest channel number to write.
C      ISCOMP  L  If true data is compressed
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, CATMP(256), J, K, K1, K2
      LOGICAL   T, MATCH
      INCLUDE 'UVLSF.INC'
      INCLUDE 'UVLSF2.INC'
      INTEGER   NW(MAXIF), LUN
      CHARACTER BNDCOD(MAXIF)*8
      REAL      CATR(256), RPARM(20)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      DATA BLANK /' '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 146
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (16, 1, XSOUR, SOURCS(1))
      SELQUA = IROUND (XQUAL)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
      DISK2 = DISKO
      SEQO2 = SEQOUT
      DOFLUX = (MFLUX.GT.0.0) .OR. (RFLUX.GT.0.0)
      IF (MFLUX.LE.0.0) MFLUX = 1.E20
      IF (RFLUX.LE.0.0) RFLUX = 1.E20
      NORDER = IROUND (XORD)
      ADBACK = NORDER.LT.0
      NORDER = ABS (NORDER)
      NORDER = MAX (0, MIN (4, NORDER))
      JJC = NORDER + 1
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = XDOAC.GT.0.0
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
        WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NIF = EIF - BIF + 1
      LBIF = BIF
      NFREQ = CATBLK(KINAX+JLOCF)
      LBCHAN = IROUND (XBCHAN)
      LECHAN = IROUND (XECHAN)
      CHFIT0 = IROUND (XCHANF)
      BCHAN = 1
      ECHAN = NFREQ
      IF ((CHFIT0.LE.0) .OR. (CHFIT0.GT.NFREQ)) CHFIT0 = IROUND
     *   (CATR(KRCRP+JLOCF))
      IF ((CHFIT0.LE.0) .OR. (CHFIT0.GT.NFREQ)) CHFIT0 = MAX (1,
     *   NFREQ/2)
      IF (DOOUT.GT.0.0) THEN
         WRITE (MSGTXT,1005) CHFIT0
         CALL MSGWRT (3)
         END IF
C
      IF ((LBCHAN.LE.0) .OR. (LBCHAN.GT.NFREQ)) LBCHAN = 1
      IF ((LECHAN.LE.0) .OR. (LECHAN.GT.NFREQ)) LECHAN = NFREQ
      IF (LBCHAN.GT.LECHAN) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       get freq info
      I = 1
      CALL CHNDAT ('READ', BUFF1, DISKIN, OLDCNO, I, CATBLK, LUN, K,
     *   FOFF, ISBAND, FINC, BNDCOD, FRQSEL, JERR)
      IF (JERR.GT.0) THEN
         MSGTXT = 'ERROR READING FQ FILE'
         GO TO 990
         END IF
C                                       Set fit windows
      I = 60 * MAXIF
      CALL FILL (I, 0, CHNSEL)
      CALL FILL (MAXIF, 0, NW)
      DO 20 J = 1,20
         K = IROUND (XCHSEL(2,J))
         IF (K.LE.0) GO TO 25
         K = IROUND (XCHSEL(4,J))
         IF ((K.LE.0) .OR. (K.GT.NIF)) THEN
            K1 = 1
            K2 = NIF
         ELSE
            K1 = K
            K2 = K
            END IF
         DO 15 K = K1,K2
            NW(K) = NW(K) + 1
            CHNSEL(1,NW(K),K) = MAX (0, IROUND (XCHSEL(1,J)))
            CHNSEL(2,NW(K),K) = MAX (0, IROUND (XCHSEL(2,J)))
            CHNSEL(3,NW(K),K) = MAX (1, IROUND (XCHSEL(3,J)))
 15         CONTINUE
 20      CONTINUE
C                                       If no channel selection
C                                       use 1 - NFREQ
 25   CALL FILL (MAXCIF, 0, CHMASK)
      DO 35 K = 1,NIF
         IOFF = (K - 1) * NFREQ
         IF (NW(K).LE.0) THEN
            NW(K) = 1
            CHNSEL(1,1,K) = 1
            CHNSEL(2,1,K) = NFREQ
            CHNSEL(3,1,K) = 1
            END IF
         DO 30 I = 1,NW(K)
            CHNSEL(1,I,K) = MAX (1, MIN (CHNSEL(1,I,K), NFREQ))
            IF (CHNSEL(2,I,K).LT.CHNSEL(1,I,K)) CHNSEL(2,I,K) = NFREQ
            CHNSEL(2,I,K) = MAX (1, MIN (CHNSEL(2,I,K), NFREQ))
            DO 28 J = CHNSEL(1,I,K),CHNSEL(2,I,K),CHNSEL(3,I,K)
               CHMASK(J+IOFF) = 1
 28            CONTINUE
 30         CONTINUE
 35      CONTINUE
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1035) IERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, BUFF1, IERR)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
      NRPRMI = NRPARM
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       read compressed => write compr.
      IF (ISCOMP) THEN
         CATBLK(KINAX) = 1
         I = CATBLK(KIPCN)
         CALL CHR2H (8, 'WEIGHT  ', 1, CATH(KHPTP+2*I))
         CALL CHR2H (8, 'SCALE   ', 1, CATH(KHPTP+2*I+2))
         CATBLK(KIPCN) = I + 2
         ILOCWT = I
         END IF
C                                       Frequency axis
      CATBLK(KINAX+JLOCF) = LECHAN - LBCHAN + 1
      CATR(KRCRP+JLOCF) = CATR(KRCRP+JLOCF) - LBCHAN + 1
      CATR(KRARP) = CATR(KRARP) - LBCHAN + 1
C                                       center frequencies
      IF (JLOCF.LT.0) XCENT = -1.
      IF (XCENT.GT.0.0) THEN
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
      ELSE
         DIFPIX = 0.0
         END IF
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((CCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
      NEWCNO(1) = CCNO
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                       copy header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       second output file
      IF (DOOUT.GT.0.0) THEN
         CALL COPY (256, CATBLK, CATMP)
         CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, 'BASFIT', KHIMCO, CATH(KHIMC))
         CATBLK(KIIMS) = SEQO2
C                                       continuum not compressed
         IF (ISCOMP) THEN
            CATBLK(KINAX) = 3
            CATBLK(KIPCN) = CATBLK(KIPCN) - 2
            END IF
C                                       Frequency axis
         CATBLK(KINAX+JLOCF) = 1
         CATR(KRCRP+JLOCF) = CATR(KRCRP+JLOCF) - CHFIT0 + 1
         CATR(KRARP) = CATR(KRARP) - CHFIT0 + 1
C                                       Create output file.
         NEWCNO(2) = 1
         FRW(NCFILE+1) = 3
         JERR = 4
         CALL UVCREA (DISK2, NEWCNO(2), BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISK2
         FCNO(NCFILE) = NEWCNO(2)
         FRW(NCFILE) = FRW(NCFILE) - 1
C                                       Save output file info
         CALL UVPGET (JERR)
         IF (JERR.NE.0) GO TO 999
         INCX = CATBLK(KINAX)
         LREC2 = LREC
         NRPRM2 = NRPARM
         INCS2 = INCS / INCX
         INCF2 = INCF / INCX
         INCIF2 = INCIF / INCX
         JERR = 0
C                                       copy header keywords
         CALL KEYCOP (DISKIN, OLDCNO, DISK2, NEWCNO(2), IERR)
C                                       save catblk
         SEQO2 = CATBLK(KIIMS)
         CALL COPY (256, CATBLK, CAT2)
         CALL COPY (256, CATMP, CATBLK)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVLSFI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1005 FORMAT ('Continuum written at channel =',I6)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('UVLSFI: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE UVLSFU (IRET)
C-----------------------------------------------------------------------
C   UVLSFU sends uv data one point at a time to the filtering
C   routine and then writes the modified data if requested.
C   Input in common:
C      BCHAN   I  Lowest channel number to write.
C      ECHAN   I  Highest channel number to write.
C      LRECO   I  Output file record length
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48
      INTEGER   IPTRO, LUNO, INDO, LUN2, IND2, ILENBU, KBIND, NIOUT,
     *   NIOLIM, IA1, IA2, BO, VO, NUMVIS,XCOUNT, NCORO, RNXRET, NCOPY,
     *   NCOR2, NCOP2, IPTR2, NIOU2, NIOLI2, CATMP(256), NBAD
      LOGICAL   T, F
      INCLUDE 'UVLSF.INC'
      REAL      DUM, VIS(UVBFSS), RESULT(UVBFSS), RESUL2(UVBFSS),
     *   RPARM(20)
      DOUBLE PRECISION UVSCAL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (BUFF1, VIS)
      DATA LUNO, LUN2 /17, 18/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Number of visibilities in input
C                                       and output files.
      NCORO = (LRECO - NRPRMO)
      IF (.NOT.ISCOMP) NCORO = NCORO / 3
      NCOPY = LRECO - NRPRMO
      NCOR2 = (LREC2 - NRPRM2) / 3
      NCOP2 = LREC2 - NRPRM2
      NBAD = 0
C                                       Open and init for read
C                                       defend cat header from UVGET
      CALL COPY (256, CATBLK, CATMP)
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL COPY (256, CATMP, CATBLK)
      CALL UVPGET (IRET)
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO(1), CATBLK, RNXRET)
C                                       Open vis file for write
      IF (DOOUT.GT.0.0) THEN
         CALL ZPHFIL ('UV', DISK2, NEWCNO(2), 1, OFILE, IRET)
         CALL ZOPEN (LUN2, IND2, DISK2, OFILE, T, F, F, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1010) IRET
            GO TO 990
            END IF
C                                       Init vis file for write
         ILENBU = 0
         CALL UVINIT ('WRIT', LUN2, IND2, NVIS, VO, LREC2, ILENBU,
     *      JBUFSZ, BUFF3, BO, KBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1020) IRET
            GO TO 990
            END IF
         IPTR2 = KBIND
         NIOU2 = 0
         NIOLI2 = ILENBU
         END IF
      NUMVIS = 0
      XCOUNT = 0
      IF ((FREQ.GT.0.0D0) .AND. (UVFREQ.GT.0.0D0)) THEN
         UVSCAL = FREQ / UVFREQ
      ELSE
         UVSCAL = 1.0D0
         END IF
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over
      ELSE IF (IRET.EQ.0) THEN
         IF (ILOCB.GE.0) THEN
            IA2 = RPARM(1+ILOCB) + 0.1
            IA1 = IA2 / 256
            IA2 = IA2 - IA1*256
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
            END IF
         NUMVIS = NUMVIS + 1
C                                       Call filtering routine.
         CALL UVLSFF (NUMVIS, RPARM(1+ILOCU), RPARM(1+ILOCV),
     *      RPARM(1+ILOCW), VIS, RESULT, RESUL2, IRET)
C                                       Branch on his return
C                                       Error (fatal)
         IF (IRET.GT.0) THEN
            NBAD = NBAD + 1
C                                       Copy to output.
         ELSE IF (IRET.EQ.0) THEN
            XCOUNT = XCOUNT + 1
C                                       update NX table
            CALL RNXUPD (RPARM, RNXRET)
            RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
            RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
            RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
            CALL RCOPY (NRPRMI, RPARM, BUFF2(IPTRO))
            IF (ISCOMP) THEN
               CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *            BUFF2(IPTRO+NRPRMO))
            ELSE
               CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
               END IF
            IPTRO = IPTRO + LRECO
            NIOUT = NIOUT + 1
            IF (DOOUT.GT.0.0) THEN
               CALL RCOPY (NRPRM2, RPARM, BUFF3(IPTR2))
               CALL RCOPY (NCOP2, RESUL2, BUFF3(IPTR2+NRPRM2))
               IPTR2 = IPTR2 + LREC2
               NIOU2 = NIOU2 + 1
               END IF
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET, XCOUNT
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
C                                       Write vis record.
            IF ((DOOUT.GT.0.0) .AND. (NIOU2.GE.NIOLI2)) THEN
               CALL UVDISK ('WRIT', LUN2, IND2, BUFF3, NIOLI2, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET, XCOUNT
                  GO TO 990
                  END IF
               IPTR2 = KBIND
               NIOU2 = 0
               END IF
            END IF
C                                       Read next buffer.
         GO TO 100
         END IF
C                                       Final call to UVLSFF.
      NUMVIS = -1
      CALL UVLSFF (NUMVIS, DUM, DUM, DUM, BUFF1, RESULT, RESUL2, IRET)
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET, XCOUNT
         GO TO 990
         END IF
C                                       Finish write
      IF (DOOUT.GT.0.0) THEN
         NIOU2 = - NIOU2
         CALL UVDISK ('FLSH', LUN2, IND2, BUFF3, NIOU2, KBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1150) IRET, XCOUNT
            GO TO 990
            END IF
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, NEWCNO(1), LUNO, CATBLK, IRET)
C                                       close NX table
      CALL RNXCLS (RNXRET)
C                                       compress other output file
      IF (DOOUT.GT.0.0) CALL UCMPRS (NVIS, DISK2, NEWCNO(2), LUN2, CAT2,
     *   IRET)
C                                       Close files
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IF (DOOUT.GT.0.0) CALL ZCLOSE (LUN2, IND2, IRET)
      IRET = 0
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      IF (NBAD.GT.0) THEN
         WRITE (MSGTXT,1200) NBAD
         CALL MSGWRT (6)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVLSFU: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1010 FORMAT ('UVLSFU: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('UVLSFU: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1100 FORMAT ('UVLSFU: ERROR',I3,' READING VIS FILE')
 1150 FORMAT ('UVLSFU: ERROR',I3,' WRITING VIS FILE AT VIS',I9)
 1200 FORMAT ('DELETED',I8,' VISIBILITIES - NOT ENOUGH VALID CHANNELS',
     *   ' TO FIT')
      END
      SUBROUTINE UVLSFH
C-----------------------------------------------------------------------
C   UVLSFH copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72
      INTEGER   LUN1, LUN2, IERR, I, K, INVER, OUVER
      LOGICAL   T
      INCLUDE 'UVLSF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO(1), CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
C                                       calibration adverbs
      CALL CALHIS (LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       BCHAN,ECHAN
      WRITE (HILINE,2000) TSKNAM, LBCHAN, LECHAN
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       shifts
      IF ((SHIFT(1).NE.0.0) .OR. (SHIFT(2).NE.0.0)) THEN
         WRITE (HILINE,2015) TSKNAM, SHIFT
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
         END IF
C                                      CHANSEL
      DO 25 K = 1,NIF
         DO 20 I = 1,20
            IF ((CHNSEL(1,I,K).GT.0) .AND.
     *         (CHNSEL(2,I,K).GE.CHNSEL(1,I,K))) THEN
               WRITE (HILINE,2020) TSKNAM, I, CHNSEL(1,I,K),
     *            CHNSEL(2,I,K), CHNSEL(3,I,K), K
               CALL HIADD (LUN2, HILINE, BUFF2, IERR)
               IF (IERR.NE.0) GO TO 100
               END IF
 20         CONTINUE
 25      CONTINUE
C                                       ORDER
      WRITE (HILINE,2025) TSKNAM, NORDER
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Close HI file
 100  CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL COPTAB (DISKIN, OLDCNO, DISKO, NEWCNO(1), IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'UVLSFH: ERROR COPYING TABLES TO LINE UV'
         CALL MSGWRT (6)
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (DISKO, NEWCNO(1), DIFPIX, BUFF1, BUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'UVLSFH: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO(1), CATBLK, 'REST', BUFF1, IERR)
C
      IF (DOOUT.GT.0.0) THEN
         CALL COPY (256, CAT2, CATBLK)
C                                       Copy/open history file.
         CALL HISCOP (LUN1, LUN2, DISKIN, DISK2, OLDCNO, NEWCNO(2),
     *      CATBLK, BUFF1, BUFF2, IERR)
         IF (IERR.GT.2) THEN
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (6)
            GO TO 200
            END IF
C                                       New history
         CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *      IERR)
         IF (IERR.NE.0) GO TO 200
         CALL HENCOO (TSKNAM, NAMOUT, 'BASFIT', SEQO2, DISK2, LUN2,
     *      BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       calibration adverbs
         CALL CALHIS (LUN2, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       selected channel
         WRITE (HILINE,2010) TSKNAM, CHFIT0
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       shifts
         IF ((SHIFT(1).NE.0.0) .OR. (SHIFT(2).NE.0.0)) THEN
            WRITE (HILINE,2015) TSKNAM, SHIFT
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 100
            END IF
C                                       CHANSEL
         DO 125 K = 1,NIF
            DO 120 I = 1,20
               IF ((CHNSEL(1,I,K).GT.0) .AND.
     *            (CHNSEL(2,I,K).GE.CHNSEL(1,I,K))) THEN
                  WRITE (HILINE,2020) TSKNAM, I, CHNSEL(1,I,K),
     *               CHNSEL(2,I,K), CHNSEL(3,I,K), K
                  CALL HIADD (LUN2, HILINE, BUFF2, IERR)
                  IF (IERR.NE.0) GO TO 200
                  END IF
 120           CONTINUE
 125        CONTINUE
C                                       ORDER
         WRITE (HILINE,2025) TSKNAM, NORDER
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       Close HI file
 200     CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                       copy new NX table
         INVER = 1
         OUVER = 1
         CALL TABCOP ('NX', INVER, OUVER, LUN1, LUN2, DISKO, DISK2,
     *      NEWCNO(1), NEWCNO(2), CATBLK, BUFF1, BUFF2, IERR)
C                                       Copy tables
         CALL COPTAB (DISKIN, OLDCNO, DISK2, NEWCNO(2), IERR)
         IF (IERR.GT.2) THEN
            MSGTXT = 'UVLSFH: ERROR COPYING TABLES TO CONTINUUM UV'
            CALL MSGWRT (6)
            END IF
C                                       Update CATBLK.
         CALL CATIO ('UPDT', DISK2, NEWCNO(2), CATBLK, 'REST', BUFF1,
     *      IERR)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVLSFH: ERROR',I3,' COPY/OPEN HISTORY FILE')
 2000 FORMAT (A6,'BCHAN =',I4,', ECHAN =',I4,
     *   ' / Output channel selection')
 2010 FORMAT (A6,'CHANNEL =',I5,5X,'/ Channel at which fit evaluated')
 2015 FORMAT (A6,'SHIFT =',F10.5,' , ',F10.5,' / shifts in asec before',
     *   ' fit')
 2020 FORMAT (A6,'CHANSEL(',I2,')=',I5,',',I5,',',I2,5X,
     *   '/ channels fit IF =',I3)
 2025 FORMAT (A6,'ORDER =',I3,10X,'/ order of polynomial fit')
      END
      SUBROUTINE UVLSFF (NUMVIS, U, V, W, VIS, RESULT, RESUL2, IRET)
C-----------------------------------------------------------------------
C   Routine to fit baseline to channels, subtract and perhaps flag
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      U       R    U in wavelengths
C      V       R    V in wavelengths
C      W       R    W in wavelengths
C      VIS     R(3,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C   Inputs from COMMON:
C      CHNSEL(3,10) Gives channel selection
C      BCHAN   I    Lowest channel number to write.
C      ECHAN   I    Highest channel number to write.
C      INCSI   I    Input Stokes' increment in vis.
C      INCFI   I    Input frequency increment in vis.
C      INCIFI  I    Input IF increment in vis.
C      LRECO   I    Output file record length
C      NRPRMO  I    Output number of random parameters.
C      INCSO   I    Output Stokes' increment in vis.
C      INCFO   I    Output frequency increment in vis.
C      INCIFO  I    Output IF increment in vis.
C   Output:
C      RESULT  R(3,*) Output visibilities selected in frequency.
C      RESUL2  R(3,*) Baseline fit value at CHFIT0
C      IRET    I  Return code   1 => don't write - not could fit
C                               0 => OK
C   Output in COMMON:
C      CATBLK    I         Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IRET
      REAL      U, V, W, VIS(3,*), RESULT(3,*), RESUL2(3,*)
C
      INTEGER   NPOLN, INDEX, OFF, IS, IIF, INDEX2, ICHAN, NSX
      REAL      SX, SSX, MSX, XX, SW, PARMS(9,2), CATR(256)
      COMPLEX   VS, ZZ
      DOUBLE PRECISION DXC, DYC, DZC, RFREQ, DFREQ, CFREQ, RA0, DEC0,
     *   TRUEF
      LOGICAL   FLGWT, DOSHIF, WASOK, SOMEOK
      INCLUDE 'UVLSF.INC'
      INCLUDE 'UVLSF2.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATR, CATBLK)
      SAVE NPOLN, DXC, DYC, DZC, RFREQ, DOSHIF
C-----------------------------------------------------------------------
C                                       Set up on first call
      IF (NUMVIS.EQ.1) THEN
         NFLUXF = 0
         NPOLN = CATBLK(KINAX+JLOCS)
C                                       shift parameters
         DOSHIF = (ABS(SHIFT(1)).GT.1E-6) .OR. (ABS(SHIFT(2)).GT.1E-6)
         IF (DOSHIF) THEN
            RFREQ = CATR(KRCRP+JLOCF)
            RA0 = RA
            DEC0 = DEC
            IF (COS(DG2RAD*DEC0).NE.0.0D0) RA = RA0 + SHIFT(1) / 3600.D0
     *         / COS(DG2RAD * DEC0)
            DEC = DEC + SHIFT(2) / 3600.D0
            DXC = SIN (DG2RAD * (RA-RA0)) * COS (DEC * DG2RAD)
            DYC = COS (DEC0 * DG2RAD) * SIN (DEC * DG2RAD) -
     *         SIN (DEC0 * DG2RAD) * COS (DEC * DG2RAD) *
     *         COS ((RA - RA0) * DG2RAD)
            DZC = SIN (DG2RAD * DEC0) * SIN (DG2RAD * DEC) +
     *         COS (DG2RAD * DEC0) * COS (DG2RAD * DEC) *
     *         COS (DG2RAD * (RA - RA0)) - 1.0D0
            DXC = TWOPI * DXC
            DYC = TWOPI * DYC
            DZC = TWOPI * DZC
            END IF
         END IF
      IRET = 0
      SOMEOK = .FALSE.
      IF (NUMVIS.GT.0) THEN
C                                       Loop over IF
         DO 400 IIF = 1,NIF
            IOFF = (IIF-1) * NFREQ
            TRUEF = 1.0D0 + FOFF(IIF+LBIF-1) / UVFREQ
            DFREQ = FINC(IIF+LBIF-1) /UVFREQ
C                                       Loop over Stokes
            DO 350 IS = 1,NPOLN
C                                       Offset in Stokes and IF
               OFF = (IS - 1) * INCSI + (IIF - 1) * INCIFI + 1
C                                       shift phases before fit
               IF (DOSHIF) THEN
                  DO 20 ICHAN = 1,NFREQ
                     INDEX = OFF + (ICHAN-1) * INCFI
                     CFREQ = TRUEF + DFREQ * (ICHAN - RFREQ)
                     XX = (U * DXC + V * DYC + W * DZC) * CFREQ
                     ZZ = CMPLX (COS(XX), -SIN(XX))
                     VS = CMPLX (VIS(1,INDEX), VIS(2,INDEX)) * ZZ
                     VIS(1,INDEX) = REAL (VS)
                     VIS(2,INDEX) = AIMAG (VS)
 20                  CONTINUE
                  END IF
C                                       move to array
               INDEX = OFF
               SW = 0.0
               DO 30 ICHAN = 1,NFREQ
                  IF (VIS(3,INDEX).GT.0) THEN
                     DATA(1,ICHAN) = VIS(1,INDEX)
                     DATA(2,ICHAN) = VIS(2,INDEX)
                     IF (CHMASK(ICHAN+IOFF).GT.0) SW = SW + VIS(3,INDEX)
                  ELSE
                     DATA(1,ICHAN) = FBLANK
                     DATA(2,ICHAN) = FBLANK
                     END IF
                  INDEX = INDEX + INCFI
 30               CONTINUE
C                                       init arrays
               CALL POLYIN (NFREQ, IRET)
               WASOK = IRET.EQ.0
C                                       solve
               IF (WASOK) THEN
                  CALL XBALMS (NFREQ, PARMS)
C                                       convert to model
                  CALL XBFUNC (NFREQ, PARMS)
                  SOMEOK = .TRUE.
                  END IF
C                                       Subtract baseline from input
C                                       if could get a fit
               INDEX = OFF + (LBCHAN - 1) * INCFI
               INDEX2 =  (IS - 1) * INCSO + (IIF - 1) * INCIFO + 1
               SSX = 0.0
               MSX = 0.0
               NSX = 0
               FLGWT = .FALSE.
C
      INCLUDE 'INCS:ZVND.INC'
               DO 300 ICHAN = LBCHAN,LECHAN
C                                       Subtract from vis.
                  IF (.NOT.WASOK) VIS(3,INDEX) = -ABS (VIS(3,INDEX))
                  IF (VIS(3,INDEX).GT.0.0) THEN
                     RESULT(1,INDEX2) = VIS(1,INDEX) - DATA(1,ICHAN)
                     RESULT(2,INDEX2) = VIS(2,INDEX) - DATA(2,ICHAN)
                     RESULT(3,INDEX2) = VIS(3,INDEX)
                  ELSE
                     RESULT(1,INDEX2) = VIS(1,INDEX)
                     RESULT(2,INDEX2) = VIS(2,INDEX)
                     RESULT(3,INDEX2) = VIS(3,INDEX)
                     END IF
                  IF ((DOFLUX) .AND. (RESULT(3,INDEX2).GT.0.0) .AND.
     *               (CHMASK(ICHAN+IOFF).GT.0)) THEN
                     SX = RESULT(1,INDEX2) * RESULT(1,INDEX2) +
     *                  RESULT(2,INDEX2) * RESULT(2,INDEX2)
                     SSX = SSX + SX
                     MSX = MAX (MSX, SX)
                     NSX = NSX + 1
                     END IF
                  IF ((ADBACK) .AND. (VIS(3,INDEX).GT.0.0)) THEN
                     RESULT(1,INDEX2) = RESULT(1,INDEX2) +
     *                  DATA(1,CHFIT0)
                     RESULT(2,INDEX2) = RESULT(2,INDEX2) +
     *                  DATA(2,CHFIT0)
                     END IF
C                                       shift phases back after fit
                  IF (DOSHIF) THEN
                     CFREQ = TRUEF + DFREQ * (ICHAN - RFREQ)
                     XX = (U * DXC + V * DYC + W * DZC) * CFREQ
                     ZZ = CMPLX (COS(XX), SIN(XX))
                     VS = CMPLX (RESULT(1,INDEX2), RESULT(2,INDEX2))*ZZ
                     RESULT(1,INDEX2) = REAL (VS)
                     RESULT(2,INDEX2) = AIMAG (VS)
                     END IF
                  INDEX = INDEX + INCFI
                  INDEX2 = INDEX2 + INCFO
 300              CONTINUE
               IF (NSX.GT.0) THEN
                  SSX = SQRT (SSX / NSX)
                  MSX = SQRT (MSX)
                  IF ((SSX.GT.RFLUX) .OR. (MSX.GT.MFLUX)) THEN
                     NFLUXF = NFLUXF + 1
                     INDEX2 =  (IS - 1) * INCSO + (IIF - 1) * INCIFO + 1
                     DO 310 ICHAN = LBCHAN,LECHAN
                        RESULT(3,INDEX2) = - ABS (RESULT(3,INDEX2))
                        INDEX2 = INDEX2 + INCFO
 310                    CONTINUE
                     FLGWT = .TRUE.
                     END IF
                  END IF
               IF (DOOUT.GT.0.0) THEN
                  INDEX2 =  (IS - 1) * INCS2 + (IIF - 1) * INCIF2 + 1
                  RESUL2(1,INDEX2) = DATA(1,CHFIT0)
                  RESUL2(2,INDEX2) = DATA(2,CHFIT0)
                  RESUL2(3,INDEX2) = SW
                  IF (FLGWT) RESUL2(3,INDEX2) = - ABS (SW)
C                                       shift phases back after fit
                  IF (DOSHIF) THEN
                     CFREQ = TRUEF + DFREQ * (CHFIT0 - RFREQ)
                     XX = (U * DXC + V * DYC + W * DZC) * CFREQ
                     ZZ = CMPLX (COS(XX), SIN(XX))
                     VS = CMPLX (RESUL2(1,INDEX2), RESUL2(2,INDEX2))*ZZ
                     RESUL2(1,INDEX2) = REAL (VS)
                     RESUL2(2,INDEX2) = AIMAG (VS)
                     END IF
                  END IF
 350           CONTINUE
 400        CONTINUE
         IF (SOMEOK) THEN
            IRET = 0
         ELSE
            IRET = 1
            END IF
C                                       last call
      ELSE
         IF (DOFLUX) THEN
            WRITE (MSGTXT,1500) NFLUXF
            IF (NFLUXF.LE.0) MSGTXT = 'No points flagged for excess'
     *         // ' residuals'
            CALL MSGWRT (6)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1500 FORMAT ('Flagged',I9,' time/IF/Stokes samples for excess',
     *   ' residuals')
      END
      SUBROUTINE POLYIN (NDATA, IERR)
C-----------------------------------------------------------------------
C   POLYIN prepares the parameters of a set of orthogonal polynomials.
C   All are carried in COMMON /GDATA/.
C   Input:
C      NDATA   I   Number of points in data array
C   Output:
C      IERR    I   0 ok, 1 no good data, 2 other singularity
C-----------------------------------------------------------------------
      INTEGER   NDATA, IERR
C
      REAL      PP, AL, SUM, TEMP
      INTEGER   MMAX, I, J, K, JJ, KK, N, MM
      INCLUDE 'UVLSF2.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       calculate moments
      MMAX = 2 * JJC - 1
      CALL RFILL (MMAX, 0.0, MOMENT)
      NPTS = 0
      DO 20 I = 1,NDATA
         IF ((CHMASK(I+IOFF).EQ.1) .AND. (DATA(1,I).NE.FBLANK)) THEN
            PP = 1
            AL = I + XBAR
            NPTS = NPTS + 1
            DO 15 J = 2,MMAX
               PP = PP * AL
               MOMENT(J) = MOMENT(J) + PP
 15            CONTINUE
            END IF
 20      CONTINUE
      IERR = 1
      IF (NPTS.LE.0) GO TO 999
      IERR = 2
      DO 25 J = 2,MMAX
         MOMENT(J) = MOMENT(J) / NPTS
 25      CONTINUE
      MOMENT(1) = 1.0
C                                       Matrix: P(K) = G(K) * (X**K
C                                        - SUM (A(K,J)*P(J)))
      MMAX = 25
      CALL RFILL (MMAX, 0.0, AARRAY)
      CALL RFILL (MMAX, 0.0, CARRAY)
      GAMMA(1) = 1.0
      DO 50 K = 2,JJC
         SUM = 0.0
         KK = K - 1
         DO 40 J = 1,KK
            AARRAY(K,J) = MOMENT(J+K-1)
            IF (J.GT.1) THEN
               JJ = J - 1
               DO 30 MM = 1,JJ
                  AARRAY(K,J) = AARRAY(K,J) - AARRAY(J,MM)*AARRAY(K,MM)
 30               CONTINUE
               END IF
            AARRAY(K,J) = AARRAY(K,J) * GAMMA(J)
            SUM = SUM + AARRAY(K,J) ** 2
 40         CONTINUE
         TEMP = MOMENT(2*K-1) - SUM
         IF (TEMP.LE.0.0) GO TO 999
         GAMMA(K) = 1.0 / SQRT (TEMP)
 50      CONTINUE
C                                       Matrix: P(K) = SUM (C(K,J) *
C                                                      X**J)
      CARRAY(1,1) = GAMMA(1)
      DO 65 K = 2,JJC
         CARRAY(K,K) = GAMMA(K)
         KK = K - 1
         DO 60 MM = 1,KK
            DO 55 N = MM,KK
               CARRAY(K,MM) = CARRAY(K,MM) - GAMMA(K) * AARRAY(K,N)
     *            * CARRAY(N,MM)
 55            CONTINUE
 60         CONTINUE
 65      CONTINUE
C                                       average of polynomials
      MMAX = 5
      CALL RFILL (MMAX, 0.0, POLAVG)
      DO 75 I = 1,NDATA
         CALL POLYEV (I)
         DO 70 J = 1,MMAX
            POLAVG(J) = POLAVG(J) + POLYFN(J)
            POLXFN(I,J) = POLYFN(J)
 70         CONTINUE
 75      CONTINUE
      DO 80 J = 1,MMAX
         POLAVG(J) = POLAVG(J) / NDATA
 80      CONTINUE
      IERR = 0
C
 999  RETURN
      END
      SUBROUTINE POLYEV (IX)
C-----------------------------------------------------------------------
C   POLYEV evaluates the orthogonal polynomials at the X value given.
C   Inputs:
C      IX   I   X position
C-----------------------------------------------------------------------
      INTEGER   IX
C
      REAL      AX
      INTEGER   J, K, KK
      INCLUDE 'UVLSF2.INC'
C-----------------------------------------------------------------------
      POLYFN(1) = 1.0
      AX = IX + XBAR
      DO 20 K = 2,JJC
         POLYFN(K) = AX**(K-1)
         KK = K-1
         DO 10 J = 1,KK
            POLYFN(K) = POLYFN(K) - AARRAY(K,J) * POLYFN(J)
 10         CONTINUE
         POLYFN(K) = POLYFN(K) * GAMMA(K)
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE XBALMS (INPTS, PARMS)
C-----------------------------------------------------------------------
C   XBALMS computes the answers
C   Inputs:
C      INPTS   I      Number data points
C   Output:
C      PARMS   R(9)   Answers (1 - 8), sigma ** 2 (9)
C-----------------------------------------------------------------------
      INTEGER   INPTS
      REAL      PARMS(9,2)
C
      INTEGER   I, J, K
      REAL      YBAR, YBAR2
      INCLUDE 'UVLSF2.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      DO 50 K = 1,2
C                                       clear sum variables
         DO 10 I = 1,9
            PARMS(I,K) = 0.0
 10         CONTINUE
         YBAR = 0.0
         YBAR2 = 0.0
C                                       sum: data, data**2
C                                       data*polyfunc(j)
         DO 30 I = 1,INPTS
            IF ((CHMASK(I+IOFF).EQ.1) .AND. (DATA(K,I).NE.FBLANK)) THEN
               YBAR = YBAR + DATA(K,I)
               YBAR2 = YBAR2 + DATA(K,I)**2
               DO 20 J = 1,JJC
                  PARMS(J,K) = PARMS(J,K) + DATA(K,I) * POLXFN(I,J)
 20               CONTINUE
               END IF
 30         CONTINUE
C                                       average
C                                       sigma**2=ybar2-sum(parms**2)
         YBAR = YBAR / NPTS
         YBAR2 = YBAR2 / NPTS
         PARMS(9,K) = YBAR2
         DO 40 J = 1,JJC
            PARMS(J,K) = PARMS(J,K) / NPTS
            PARMS(9,K) = PARMS(9,K) - PARMS(J,K)**2
 40         CONTINUE
 50      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE XBFUNC (NDATA, PARMS)
C-----------------------------------------------------------------------
C   XBFUNC computes the model
C   Inputs:
C      NDATA   I      Number of data points in row
C      PARMS   R(9,2)   factors of orthogonal polynomials
C   Common: /GDATA/
C      DATA    R(?)   Original slice data pointsreplaced by model
C-----------------------------------------------------------------------
      INTEGER   NDATA
      REAL      PARMS(9,2)
C
      INTEGER   I, J, K
      REAL      SUM
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'UVLSF2.INC'
C-----------------------------------------------------------------------
      DO 50 K = 1,2
         DO 20 I = 1,NDATA
            IF (DATA(K,I).NE.FBLANK) THEN
               SUM = 0.0
               DO 10 J = 1,JJC
                  SUM = SUM + PARMS(J,K) * POLXFN(I,J)
 10               CONTINUE
               DATA(K,I) = SUM
               END IF
 20         CONTINUE
 50      CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'FACES.INC'
      HOLLERITH XNAMEI(3), XCLASI(2), XNAMO(3), XXSOUR(4), XINFIL(12)
      REAL       DISKIN, XSEQ, XDISKO, CELSIZ(2), XSIZE(2), SHIFT(2),
     *   BMAJ, BFLUX, BPARM(10), PBPARM(7)
      COMMON /INPARM/ XNAMEI, XCLASI, XSEQ, DISKIN, XXSOUR, XNAMO,
     *   XDISKO, CELSIZ, XSIZE, SHIFT, BMAJ, BFLUX, BPARM, PBPARM,
     *   XINFIL
C
      DOUBLE PRECISION RA0, DEC0
      INTEGER   IMSIZE(2), OVRLAP, CATNO, SEQIN, IDISK, LUNNV, INDNV,
     *   ODISK, OSEQ, OCNO, OFIELD, SCRTCH(512)
      CHARACTER NAMEIN*12, CLASIN*6, NAMOUT*12, NVSSF*48, MSOURC*16,
     *   CLSOUT*6
      LOGICAL   DOGAUS
      COMMON /FACESP/ RA0, DEC0, SCRTCH, IMSIZE, OVRLAP, CATNO, SEQIN,
     *   IDISK, LUNNV, INDNV, ODISK, OSEQ, OCNO, OFIELD, DOGAUS
      COMMON /FACESC/ NAMEIN, CLASIN, CLSOUT, NVSSF, MSOURC, NAMOUT
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANT.INC'
LOCAL END
      PROGRAM FACES
C-----------------------------------------------------------------------
C! Make images/CCs from NVSS
C# Imaging Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 2000-2003, 2005, 2009, 2011-2012, 2015, 2019-2020,
C;  Copyright (C) 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FACES computes fields like SETFC, but then makes images of the
C   catalog sources that fall within the central fly's eye.  These
C   images with their CC files may be an initial model for calibration.
C   Fields with no sources are not written or counted.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME       XNAMEI/NAMEIN    Name of input UV data.
C      INCLASS      XCLASI/CLASIN    Class of input UV data.
C      INSEQ        SEQ/SEQIN        Seq. of input UV data.
C      INDISK       DISKIN/IDISK     Disk number of input UV data.
C      SOURCES      XXSOUR/SOURCE    Source which will be mapped.
C      OUTNAME      XNAMO/NAMOUT     Output file name
C      OUTDISK      ODISK            Output file disk number
C      CELLSIZE     CELSIZ           pixel size in image.
C      IMSIZE       XSIZE/IMSIZE     image size, also field size.
C      SHIFT        SHIFT            offset for all fields.
C      BPARM        BPARM            1. Fly-eye radius (deg)
C                                    2. Overlap in fly-eye
C      PBPARM       PBPARM           Primary beam cutoff, flag, parms
C      INFILE       XINFIL/NVSSF     NVSS input file name.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXF
      PARAMETER (MAXF=20*MAXFLD)
C
      CHARACTER PNAM*6, MTYPE*2, STAT*4, EXT*4, TYPE*2, PHNAME*48,
     *   ZTXO*4, ANVSSF*48
      INTEGER   NPARMS, IRET, IERR, IROUND, LUNSU, SQUAL, SOUID, NID,
     *   FREQAX, II, MLUN(2), MIND(2), CTTUV(256), JJ, I, NCC, IVER
      REAL      RADIUS, CTTUVR(256), AFLUX, CATR(256)
      DOUBLE PRECISION LAMBD, RAS(MAXF), DECS(MAXF), CTTUVD(128),
     *   CATD(128), DTEMP
      HOLLERITH CTTUVH(256), CATH(256)
      LOGICAL   NVOPEN, NEW, STD, MULTI
      INCLUDE 'FACES.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      EQUIVALENCE (CTTUV, CTTUVR, CTTUVH, CTTUVD)
      INCLUDE 'INCS:PSTD.INC'
      DATA NPARMS, PNAM /52, 'FACES '/
      DATA MLUN, LUNSU /16,17, 27/
      DATA NID, SQUAL /1, -1/
      DATA MTYPE /'UV'/
C-----------------------------------------------------------------------
C                                       initialize
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      NCFILE = 0
      ZTXO = 'READ'
C                                       get the input parameters
      CALL GTPARM (PNAM, NPARMS, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         RQUICK = .FALSE.
         IF (IERR.EQ.1) THEN
            MSGTXT = 'CANNOT FIND INITIATOR IN GTPARM'
            CALL MSGWRT (1)
            GO TO 999
         ELSE
            MSGTXT= 'DISK PROBLEMS IN GTPARM'
            CALL MSGWRT (6)
            GO TO 995
            END IF
         END IF
      IRET = 0
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
C                                       set parameters
      LUNNV = 11
      NVOPEN = .FALSE.
      IMSIZE(1) = IROUND (XSIZE(1))
      IMSIZE(2) = IROUND (XSIZE(2))
      OVRLAP = IROUND (BPARM(2))
      IF (OVRLAP.LT.2) OVRLAP = 5
      BPARM(2) = OVRLAP
      IF ((PBPARM(1).LE.0.0) .OR. (PBPARM(1).GT.0.9)) PBPARM(1) = 0.023
      IF (BPARM(3).LE.0.0) BPARM(3) = 1.0
      CALL H2CHR (12, 1, XNAMO, NAMOUT)
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLASI, CLASIN)
      CALL H2CHR (48, 1, XINFIL, NVSSF)
      SEQIN = IROUND (XSEQ)
      IDISK = IROUND (DISKIN)
      ODISK = IROUND (XDISKO)
      DOGAUS = BMAJ.LT.0.0
      BMAJ = ABS (BMAJ)
      IF ((BMAJ.GT.0.0) .AND. (CELSIZ(1).NE.0.0)) THEN
         BMAJ = BMAJ / ABS (CELSIZ(1))
      ELSE
         BMAJ = 3.0
         END IF
      OSEQ = 0
C                                       locate map in directory
      CATNO = 1
      CALL CATDIR ('SRCH', IDISK, CATNO, NAMEIN, CLASIN, SEQIN,
     *   MTYPE, NLUSER, STAT, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'REQUESTED DATA NOT FOUND IN CATALOG DIRECTORY'
         CALL MSGWRT (6)
         GO TO 995
         END IF
C                                       read catalog block
      CALL CATIO ('READ', IDISK, CATNO, CATBLK, 'REST', SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (6)
         GO TO 995
         END IF
      WRITE (MSGTXT,1010) NAMEIN, CLASIN, SEQIN, IDISK, CATNO
      CALL MSGWRT (3)
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 995
      CALL COPY (256, CATBLK, CTTUV)
      UNAME = NAMEIN
      UCLAS = CLASIN
      UDISK = IDISK
      USEQ = SEQIN
C                                       get antenna info
      IVER = 1
      CALL ANTINI ('READ', ANBUFF, IDISK, CATNO, IVER, CATBLK, LUNSU,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANFQID, ANTNIF, IERR)
      CALL TABIO ('CLOS', 0, 1, ANBUFF, ANBUFF, IERR)
C                                       single-source use UVPGET output
      CALL MULSDB (CATBLK, MULTI)
      IF (.NOT.MULTI) THEN
         SOUID = -1
         RA0 = RA
         DEC0 = DEC
         IF ((RA0.EQ.0.0D0) .AND. (DEC0.EQ.0.0D0)) THEN
            MSGTXT = 'CANNOT FIND SOURCE POSITION'
            GO TO 980
            END IF
C                                       multi-source get 1 source
      ELSE
         CALL H2CHR (16, 1, XXSOUR(1), MSOURC)
C                                       multi-source file, but no source
C                                       specified...
         IF (MSOURC.EQ.' ') THEN
            MSGTXT = 'MULTI-SOURCE FILE BUT NO SOURCE SPECIFIED!'
            GO TO 980
C                                       find source...
         ELSE
            CALL SOURNU (MSOURC, SQUAL, 1, IDISK, CATNO, NID, SCRTCH,
     *         SOUID, IRET)
            IF (IRET.EQ.0) THEN
               CALL GETSOU (SOUID, IDISK, CATNO, CATBLK, LUNSU, IRET)
               IF (IRET.EQ.0) THEN
                  DEC0 = DECEPO * RAD2DG
                  RA0 = RAEPO * RAD2DG
               ELSE
                  MSGTXT = 'ERROR ACCESSING SU EXTENSION'
                  GO TO 980
                  END IF
            ELSE
               MSGTXT = 'ERROR FINDING REQUESTED SOURCE'
               GO TO 980
               END IF
            END IF
         END IF
C                                       Get CELSIZ, IMSIZE
      RADIUS = BPARM(1)
      IF ((CELSIZ(1).LE.0.0) .OR. (CELSIZ(2).LE.0.0) .OR.
     *   (IMSIZE(1).LE.0) .OR. (IMSIZE(2).LE.0)) THEN
         CALL SETCEL (RADIUS, IMSIZE, CELSIZ, IRET)
         IF (IRET.NE.0) GO TO 995
         END IF
C                                       Compute fly's eye
      CALL FLYEYE (RADIUS, IMSIZE, CELSIZ, OVRLAP, SHIFT, RA0, DEC0,
     *   OFIELD, RAS, DECS, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Catalog file name
      IF (NVSSF.EQ.' ') THEN
         EXT = 'NVSS'
         IF (ABS(CATR(KREPO)-1950.0).LT.0.1) THEN
            NVSSF = 'AIPSTARS:NV50.0030'
         ELSE
            NVSSF = 'AIPSTARS:NV00.0030'
            END IF
         END IF
      ANVSSF = NVSSF
      STD = NVSSF(:8).EQ.'AIPSTARS'
      IF (DEC0+RADIUS.GT.90.0D0) STD = .FALSE.
      IF (DEC0-RADIUS.LT.-90.0D0) STD = .FALSE.
      IF (STD) THEN
         DTEMP = RADIUS / COS (DG2RAD * DEC0)
         IF (RA0-DTEMP.LT.0.0D0) STD = .FALSE.
         IF (RA0+DTEMP.GT.360.0D0) STD = .FALSE.
         END IF
C                                       make a subset file
      IF (OFIELD.GT.3) THEN
         AFLUX = BFLUX / BPARM(3)
         CALL SUBFLD (STD, AFLUX, RADIUS, RA0, DEC0, NVSSF, ANVSSF,
     *      IRET)
         IF (IRET.NE.0) GO TO 990
         ZTXO = 'QRED'
         STD = .FALSE.
         END IF
C                                       find frequency
      CALL AXEFND (4, 'FREQ', CATBLK(KIDIM), CATBLK(KHCTP), FREQAX,
     *   IRET)
      IF (IRET.EQ.0) THEN
         FREQ = CATD(KDCRV+FREQAX)
         LAMBD = VELITE / FREQ
      ELSE
         LAMBD = 0.0D0
         END IF
C                                       Prepare output file header
      CALL CHR2H (8, 'JY/BEAM ', 1, CATH(KHBUN))
      CALL CHR2H (8, 'RA---SIN', 1, CATH(KHCTP))
      CALL CHR2H (8, 'DEC--SIN', 1, CATH(KHCTP+2))
      CALL CHR2H (8, 'FREQ    ', 1, CATH(KHCTP+4))
      CALL CHR2H (8, 'STOKES  ', 1, CATH(KHCTP+6))
      CALL CHR2H (8, '        ', 1, CATH(KHCTP+8))
      CALL CHR2H (8, '        ', 1, CATH(KHCTP+10))
      CALL CHR2H (8, '        ', 1, CATH(KHCTP+12))
      CATBLK(KIGCN) = 0
      CATBLK(KIPCN) = 0
      CATBLK(KIDIM) = 4
      CATBLK(KINAX) = IMSIZE(1)
      CATBLK(KINAX+1) = IMSIZE(2)
      CATR(KRCRP) = IMSIZE(1)/2
      CATR(KRCRP+1) = IMSIZE(2)/2 + 1
      CATR(KRCRP+2) = 1.0
      CATR(KRCRP+3) = 1.0
      CALL FILL (5, 1, CATBLK(KINAX+2))
      CALL RFILL (7, 0.0, CATR(KRCRT))
      CALL RFILL (3, 1.0, CATR(KRCRP+4))
      CALL RFILL (3, 0.0, CATR(KRCRP+4))
      CATR(KRCIC) = -ABS(CELSIZ(1)) / 3600.0
      CATR(KRCIC+1) = ABS(CELSIZ(2)) / 3600.0
      CATR(KRCIC+2) = CTTUVR(KRCIC+JLOCF)
      CATR(KRCIC+3) = 1.0
      CATD(KDCRV+2) = CTTUVD(KDCRV+JLOCF)
      CATD(KDCRV+3) = 1.0D0
      CATD(KDCRV+4) = 0.0D0
      CATD(KDCRV+5) = 0.0D0
      CATD(KDCRV+6) = 0.0D0
      CATR(KRBMJ) = BMAJ * CATR(KRCIC+1)
      CATR(KRBMN) = CATR(KRBMJ)
      IF (NAMOUT.EQ.' ') NAMOUT = NAMEIN
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      TYPE = 'MA'
      CALL CHR2H (2, TYPE, KHPTYO, CATH(KHPTY))
      CATBLK(KIIMS) = OSEQ
      CATBLK(KIIMU) = NLUSER
C                                       loop over output fields
      JJ = 1
      NEW = .TRUE.
      DO 100 II = 1,OFIELD
         CATD(KDCRV) = RAS(II)
         CATD(KDCRV+1) = DECS(II)
         CATD(KDORA) = RA0
         CATD(KDODE) = DEC0
         CATR(KRDMX) = 0.0
         CATR(KRDMN) = 0.0
C                                       overwrite empty ones
C                                       create when last had something
         IF (NEW) THEN
            IF (JJ.GT.MAXFLD) THEN
               MSGTXT = 'WARNING: TOO MANY FIELDS'
               CALL MSGWRT (7)
               IF (JJ.GT.999) THEN
                  IRET = 10
                  GO TO 999
                  END IF
               END IF
            WRITE (CLSOUT,1020) JJ
            CALL CHR2H (6, CLSOUT, KHIMCO, CATH(KHIMC))
C                                       Create output map file.
            CALL MCREAT (ODISK, OCNO, SCRTCH, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1025) IRET, JJ
               GO TO 990
               END IF
            OSEQ = CATBLK(KIIMS)
            NEW = .FALSE.
C                                       Mark in /CFILE/
            NCFILE = NCFILE + 1
            FCNO(NCFILE) = OCNO
            FVOL(NCFILE) = ODISK
            FRW(NCFILE) = 2
C                                       open image file
            CALL ZPHFIL ('MA', ODISK, OCNO, 1, PHNAME, IERR)
            CALL ZOPEN (MLUN(2), MIND(2), ODISK, PHNAME, .TRUE.,
     *         .FALSE., .TRUE., IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1030) II, IRET
               CALL MSGWRT (8)
               GO TO 990
               END IF
            CALL MAPOPN ('INIT', ODISK, NAMOUT, CLSOUT, OSEQ, TYPE,
     *         NLUSER, MLUN, MIND, OCNO, CATBLK, SCRTCH, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1031) II, IRET
               CALL MSGWRT (8)
               GO TO 990
               END IF
            END IF
C                                       open catalog
         CALL ZTXOPN (ZTXO, LUNNV, INDNV, ANVSSF, .FALSE., IRET)
         ZTXO = 'QRED'
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1040) IRET
            GO TO 980
            END IF
         NVOPEN = .TRUE.
C                                       catalog sources to image
         CALL ADNVSS (STD, MLUN, MIND, II, RAS, DECS, JJ, NCC, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1050) II, IRET
            CALL MSGWRT (8)
            GO TO 990
            END IF
C                                       close catalog
         CALL ZTXCLS (LUNNV, INDNV, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1060) IERR
            CALL MSGWRT (6)
            END IF
         NVOPEN = .FALSE.
C                                       Keep this one
         IF (IRET.EQ.0) THEN
            CATBLK(KINIT) = NCC
            CATBLK(KITYP) = 2
C                                       History
            CALL FACEHI
C                                       close image
            CALL MAPCLS ('WRIT', ODISK, OCNO, MLUN, MIND, CATBLK,
     *         .TRUE., SCRTCH, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1070) II, IRET
               GO TO 980
               END IF
            NCFILE = NCFILE - 1
            CALL ZCLOSE (MLUN(2), MIND(2), IRET)
            JJ = JJ + 1
            NEW = .TRUE.
C                                       ignore this one
         ELSE
C                                       must destroy too
            IF (II.EQ.OFIELD) THEN
C                                       close image
               CALL MAPCLS ('WRIT', ODISK, OCNO, MLUN, MIND, CATBLK,
     *            .TRUE., SCRTCH, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1070) II, IERR
                  CALL MSGWRT (8)
                  END IF
               NCFILE = NCFILE - 1
               CALL ZCLOSE (MLUN(2), MIND(2), IRET)
               CALL MDESTR (ODISK, OCNO, CATBLK, SCRTCH, I, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1090) IERR, OCNO
                  CALL MSGWRT (8)
                  END IF
               END IF
            END IF
 100     CONTINUE
      GO TO 990
C                                       Error
 980  CALL MSGWRT (8)
C                                       close files and go to bed.
 990  IF (NVOPEN) CALL ZTXCLS (LUNNV, INDNV, IERR)
      IF (ANVSSF.NE.NVSSF) CALL ZTXZAP (LUNNV, ANVSSF, IERR)
C                                       close files and go to bed.
 995  CALL DIETSK (IRET, RQUICK, SCRTCH)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('CATIO ERROR NO', I5)
 1010 FORMAT ('Found ', A12, A6, ' Seq', I4, ' Disk:', I3,' in slot',
     *   I5)
 1020 FORMAT ('IMO',I3.3)
 1025 FORMAT ('ERROR',I5,' CREATING IMAGE FOR OUTPUT FIELD',I4)
 1030 FORMAT ('FIELD',I6,' ERROR',I5,' OPENING IMAGE FILE')
 1031 FORMAT ('FIELD',I6,' ERROR',I5,' OPENING IMAGE FILE A 2ND TIME')
 1040 FORMAT ('ERROR NO', I5, ' OPENING NVSS FILE')
 1050 FORMAT ('FIELD',I6,' ERROR',I5,' ADDING NVSS TO IMAGE FILE')
 1060 FORMAT ('ERROR NO', I5, ' CLOSING NVSS FILE')
 1070 FORMAT ('FIELD',I6,' ERROR',I5,' CLOSING IMAGE FILE')
 1090 FORMAT ('ERROR',I5,' DESTROYING THE FILE IN SLOT',I6)
      END
      SUBROUTINE SUBFLD (STD, AFLUX, RADIUS, RA0, DEC0, NVSSF, ANVSSF,
     *   IRET)
C-----------------------------------------------------------------------
C   Copies the portion of the NVSS file which may be useful to a scratch
C   file
C   Inputs:
C      STD      L      standard file
C      AFLUX    R      flux * beam limit / flux_rescale_factor
C      RADIUS   R      radius to include in degrees (2 X is kept)
C      RA0      D      center RA in deg
C      DEC0     D      center Declination in deg
C      NVSSF    C*48   input NVSS text file
C   Output:
C      ANVSSF   C*48   subset file to use
C      IRET     I      error code
C-----------------------------------------------------------------------
      LOGICAL   STD
      INTEGER   IRET
      REAL      AFLUX, RADIUS
      DOUBLE PRECISION RA0, DEC0
      CHARACTER NVSSF*(*), ANVSSF*(*)
C
      DOUBLE PRECISION SINDEC, COSDEC, SRA, XRA, XDEC, SINCAL, COSCAL,
     *   XD, XMIN, XMAX
      INTEGER   LUNNV, INDNV, LUNNO, INDNO, IS, OS, IFLUX, J, JTRIM,
     *   NMAX, NN, I, JT
      REAL      XF
      CHARACTER INLINE(25)*132
      LOGICAL   LSTD, DONE
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      SINDEC = SIN (DEC0*DG2RAD)
      COSDEC = COS (DEC0*DG2RAD)
      SRA = RA0 * DG2RAD
      DONE = .FALSE.
      LSTD = STD
      IF (STD) THEN
         XD = 2.5 * RADIUS / COSDEC
         XMIN = RA0 - XD
         XMAX = RA0 + XD
         LSTD = (XMIN.GT.0.0) .AND. (XMAX.LT.360.0)
         END IF
      IF (LSTD) THEN
         NMAX = 25
      ELSE
         NMAX = 1
         XMAX = 1.D4
         END IF
C                                       scratch file name
      ANVSSF = 'RUNFIL:NVSSHHHH.N.UUU'
      ANVSSF(12:15) = HSTNAM(:4)
      CALL ZEHEX (NPOPS, 1, ANVSSF(17:17))
      CALL ZEHEX (NLUSER, 3, ANVSSF(19:21))
C                                       open the files
      IS = 0
      OS = 0
      LUNNV = 11
      CALL ZTXOPN ('READ', LUNNV, INDNV, NVSSF, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET, 'OPEN NVSS'
         GO TO 990
         END IF
      LUNNO = 10
      CALL ZTXOPN ('WRIT', LUNNO, INDNO, ANVSSF, .FALSE., IRET)
      IF (IRET.EQ.5) THEN
         MSGTXT = 'Temporary file already exists - deleting'
         CALL MSGWRT (6)
         CALL ZTXZAP (LUNNO, ANVSSF, IRET)
         IF (IRET.EQ.0) CALL ZTXOPN ('WRIT', LUNNO, INDNO, ANVSSF,
     *      .FALSE., IRET)
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET, 'OPEN SUBSET FILE'
         GO TO 990
         END IF
C                                       loop in file
 10   NN = 1
 11   CALL ZTXIO ('READ', LUNNV, INDNV, INLINE(NN), IRET)
      IF (IRET.EQ.2) THEN
         NMAX = NN
         IRET = 0
         DONE = .TRUE.
         GO TO 15
      ELSE IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         CALL MSGWRT (6)
         GO TO 999
      ELSE
         JT = JTRIM (INLINE(NN))
         IF (INLINE(NN)(1:1).EQ.';') GO TO 11
         NN = NN + 1
         IF (NN.LE.NMAX) GO TO 11
         NN = NMAX
         END IF
C                                       finished a buffer
 15   IF (NMAX.GT.1) THEN
         READ (INLINE(NMAX),1010) XRA
         IF (XRA.LT.XMIN) GO TO 10
         NMAX = 1
         END IF
C                                       empty buffer
      DO 20 I = 1,NN
         READ (INLINE(I),1010) XRA, XDEC, IFLUX
         IF (XRA.GT.XMAX) GO TO 900
         XF = IFLUX / 1000.0
         IF (XF.GE.AFLUX) THEN
            XDEC = XDEC * DG2RAD
            XRA = XRA * DG2RAD
            SINCAL = SIN (XDEC)
            COSCAL = COS (XDEC)
            XD = SINCAL * SINDEC + COSCAL * COSDEC * COS(XRA - SRA)
            IF (XD.GT.1.0D0) THEN
               XD = 0.0D0
            ELSE
               XD = RAD2DG * ACOS (XD)
               END IF
            IS = IS + 1
            IF (XD.LE.2.0*RADIUS) THEN
               J = JTRIM (INLINE(I))
               CALL ZTXIO ('WRIT', LUNNO, INDNO, INLINE(I)(:J), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1020) IRET, 'WRITE SUBSET'
                  GO TO 990
                  END IF
               OS = OS + 1
               END IF
            END IF
 20      CONTINUE
      IF (.NOT.DONE) GO TO 10
C
 900  CALL ZTXCLS (LUNNV, INDNV, IRET)
      CALL ZTXCLS (LUNNO, INDNO, IRET)
      WRITE (MSGTXT,1900) OS, IS
      CALL MSGWRT (4)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('SUBFLD: ERROR',I6,' ',A)
 1010 FORMAT (F9.5,1X,F9.5,I7)
 1900 FORMAT ('Copied',I8,' OF',I8,' sources to smaller file for speed')
      END
      SUBROUTINE FLYEYE (RADIUS, IMSIZE, PIXSIZ, OVRLAP, SHIFT, RA0,
     *   DEC0, OFIELD, RAS, DECS, IERR)
C-----------------------------------------------------------------------
C   Writes fly's eye portion of BOXFILE
C   Inputs:
C      IMSIZE   I(2)   Output image size
C      PIXSIZ   R(2)   Pixel size (asec)
C      OVRLAP   I      Number pixels of overlap
C      SHIFT    R(2)   Shift all coordinates
C      RA0      D      Center RA in degrees
C      DEC0     D      Center Dec in degrees
C      LUNBX    I      LUN of Box file
C      INDBX    I      FTAB pointer of box file
C      RADIUS   R      In: Radius of fly's eye in degree
C   Output:
C      OFIELD   I      Number fields in fly's eye
C      RAS      D(*)   RA (deg) if each field
C      DECS     D(*)   Dec (deg) of each field
C      IERR     I      Error code
C-----------------------------------------------------------------------
      DOUBLE PRECISION RA0, DEC0, RAS(*), DECS(*)
      REAL      RADIUS, PIXSIZ(2), SHIFT(2)
      INTEGER   IMSIZE(2), OVRLAP, OFIELD, IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXF
      PARAMETER (MAXF=20*MAXFLD)
C
      DOUBLE PRECISION COSDEC, SINDEC, COSFLD, SINFLD, RA(MAXF), XD,
     *   DEC(MAXF), RA2, DEC2, DX, DY, XRA, XDEC, XSH(2), LL, MM,
     *   RA0R, DEC0R, DRADD, DRAD
      REAL      DIST(MAXF)
      LOGICAL   THIS1
      INTEGER   IFIELD, MFIELD, II, JJ, INDX(MAXF), I1, I2, JERR, I3, I4
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      IERR = 0
      CALL RFILL (MAXF, -1.0, DIST)
      COSDEC = COS (DEC0*DG2RAD)
      SINDEC = SIN (DEC0*DG2RAD)
      RA0R = RA0 * DG2RAD
      DEC0R = DEC0 * DG2RAD
      XSH(2) = SHIFT(2) / 3.6D3
      XSH(1) = SHIFT(1) / 3.6D3 / COSDEC
C                                       Spacing of imaging region (rad)
      DRAD = 0.5 * AS2RAD * PIXSIZ(1) * (IMSIZE(1) - OVRLAP)
      DX = 1.5 * DRAD
      DY = COS (30.0 * DG2RAD) * DRAD
C                                       field size in degrees
      DRADD = DRAD * RAD2DG / SQRT (2.0)
C                                       collect list
      IFIELD = 0
      MFIELD = 2.0 * SQRT (MAXF / PI)
      I2 = MFIELD/2 - 3
      I4 = I2 * (DX/DY) + 0.5
      I4 = (I4 / 2) * 2 - 1
      IF (MOD((2*I2+1)*I4+I2,2).EQ.1) I2 = I2 + 1
      I1 = -I2
      I3 = -I4
      THIS1 = .FALSE.
C                                       loop over declination
      DO 20 II = I1,I2
         MM = II * DY
C                                       loop over RA
         DO 10 JJ = I1,I2
            LL = JJ * DX
C                                       do every other possibility to
C                                       get hexagonal pattern
            THIS1 = .NOT.THIS1
            IF (THIS1) THEN
C                                       -> RA, Dec (-SIN projection)
               MSGSUP = 32000
               CALL NEWPOS (2, RA0R, DEC0R, LL, MM, XRA, XDEC, JERR)
               MSGSUP = 0
               IF (JERR.EQ.0) THEN
                  XRA = XRA * RAD2DG + XSH(1)
                  XDEC = XDEC * RAD2DG + XSH(2)
                  COSFLD = COS (XDEC*DG2RAD)
                  SINFLD = SIN (XDEC*DG2RAD)
                  XD = SINFLD * SINDEC +
     *               COSFLD * COSDEC * COS (XRA*DG2RAD - RA0R)
                  IF (XD.GT.1.0D0) THEN
                     XD = 0.0D0
                  ELSE
                     XD = RAD2DG * ACOS (XD)
                     END IF
                  IF (XD.LT.ABS(RADIUS)) THEN
                     IF (IFIELD.LT.MAXF) THEN
                        IFIELD = IFIELD + 1
                        RA(IFIELD) = XRA
                        DEC(IFIELD) = XDEC
                        DIST(IFIELD) = XD
                        INDX(IFIELD) = IFIELD
                     ELSE
                        MSGTXT = 'FLYEYE: NUMBER OF FIELDS EXCEEDED'
                        CALL MSGWRT (7)
                        IERR = 1
                        GO TO 999
                        END IF
                     END IF
                  END IF
               END IF
 10         CONTINUE
 20      CONTINUE
      MFIELD = IFIELD
C                                       sort on distances
      CALL BUBBLE (DIST, INDX, IFIELD, 1)
      I1 = IMSIZE(1) - OVRLAP
      I2 = IMSIZE(2) - OVRLAP
      OFIELD = 0
      DO 30 II = 1,MFIELD
         OFIELD = OFIELD + 1
         RA2 = RA(INDX(II))
         DEC2 = DEC(INDX(II))
         IF (RA2.LT.0.0D0) RA2 = RA2 + 360.0D0
         IF (RA2.GT.360.0D0) RA2 = RA2 - 360.0D0
         RAS(OFIELD) = RA2
         DECS(OFIELD) = DEC2
 30      CONTINUE
      WRITE (MSGTXT,1030) MFIELD, DIST(MFIELD)
      CALL MSGWRT (4)
      IF (DIST(MFIELD).LT.0.95*RADIUS) THEN
         MSGTXT = 'WARNING: THIS MAY NOT COVER THE DESIRED AREA'
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('FLYEYE found',I6,' fields to image to',F7.3,' deg')
      END
      SUBROUTINE ADNVSS (STD, MLUN, MIND, II, RAS, DECS, JJ, NCC, IRET)
C-----------------------------------------------------------------------
C   Searches the catalog for sources, adding those inside image II to
C   the image and the CC file (if this is the closest field).
C   Inputs:
C      STD      L      Standard input file
C      MLUN     I(2)   LUN of image file
C      MIND     I(2)   FTAB pointer of image file
C      II       I      Field number current image
C      RAS      D(*)   RA of center (degrees) all fields
C      DECS     D(*)   Dec of center (degrees) all fields
C      JJ       I      Current output field number
C   Output
C      NCC      I      Number Clean components
C      IRET     I      Error code
C-----------------------------------------------------------------------
      LOGICAL   STD
      DOUBLE PRECISION RAS(*), DECS(*)
      INTEGER   II, MLUN(2), MIND(2), JJ, NCC, IRET
C
      INCLUDE 'INCS:PSTD.INC'
      DOUBLE PRECISION SINDEC, COSDEC, SRA, XRA, XDEC, SINCAL, COSCAL,
     *   XD, LAMBD, XDMIN, SINFAC, COSFAC, FRA, XMIN, XMAX, XX, YY, ZZ
      REAL      XPIX, YPIX, XF, XB, PARMS(3), X, Y, Z
      INTEGER   LFLUX, DEPTH(5), IERR, I, J, NS, CCLUN, VER, NCOL,
     *   CCKOLS(7), CCNUMV(7), CCRNO, CCTYPE, NMAX, NN, K, JT, JTRIM
      CHARACTER INLINE(25)*132
      LOGICAL   OUTSID, DONE
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'FACES.INC'
      DATA DEPTH /5*1/
C-----------------------------------------------------------------------
      SINDEC = SIN (DEC0*DG2RAD)
      COSDEC = COS (DEC0*DG2RAD)
      SRA = RA0 * DG2RAD
      LAMBD = VELITE / CATD(KDCRV+2)
      CCLUN = 20
      VER = 1
      IF (DOGAUS) THEN
         NCOL = 7
         CCTYPE = 1
         PARMS(1) = BMAJ * CATR(KRCIC+1)
         PARMS(2) = PARMS(1)
         PARMS(3) = 0.0
      ELSE
         NCOL = 3
         CCTYPE = 0
         END IF
      CALL CCMINI ('WRIT', SCRTCH, ODISK, OCNO, VER, CATBLK, CCLUN,
     *   CCRNO, CCKOLS, CCNUMV, NCOL, IRET)
      IF (IRET.NE.0) GO TO 999
      Z = 0.0
C                                       init location common
      LOCNUM = 1
      CALL SETLOC (DEPTH, .FALSE.)
      NS = 0
      NCC = 0
      DONE = .FALSE.
C                                       find range
      IF (STD) THEN
         XMIN = 1.D4
         XMAX = -1.D4
         XPIX = CATBLK(KINAX)
         YPIX = CATBLK(KINAX+1)
         CALL XYVAL (1.0, 1.0, XX, YY, ZZ, J)
         XMIN = MIN (XMIN, XX)
         XMAX = MAX (XMAX, XX)
         CALL XYVAL (1.0, YPIX, XX, YY, ZZ, J)
         XMIN = MIN (XMIN, XX)
         XMAX = MAX (XMAX, XX)
         CALL XYVAL (XPIX, YPIX, XX, YY, ZZ, J)
         XMIN = MIN (XMIN, XX)
         XMAX = MAX (XMAX, XX)
         CALL XYVAL (XPIX, 1.0, XX, YY, ZZ, J)
         XMIN = MIN (XMIN, XX)
         XMAX = MAX (XMAX, XX)
         NMAX = 25
      ELSE
         NMAX = 1
         XMAX = 1.D4
         XMIN = -1.D4
         END IF
C                                       loop in file
 10   NN = 1
 11   CALL ZTXIO ('READ', LUNNV, INDNV, INLINE(NN), IRET)
      IF (IRET.EQ.2) THEN
         NMAX = NN
         IRET = 0
         DONE = .TRUE.
         GO TO 15
      ELSE IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         CALL MSGWRT (6)
         GO TO 999
      ELSE
         JT = JTRIM (INLINE(NN))
         IF (INLINE(NN)(1:1).EQ.';') GO TO 11
         NN = NN + 1
         IF (NN.LE.NMAX) GO TO 11
         NN = NMAX
         END IF
C                                       finished a buffer
 15   IF (NMAX.GT.1) THEN
         READ (INLINE(NMAX),1010) XRA
         IF (XRA.LT.XMIN) GO TO 10
         NMAX = 1
         END IF
C                                       empty buffer
      DO 30 K = 1,NN
         READ (INLINE(K),1010) XRA, XDEC, LFLUX
         IF (XRA.GT.XMAX) GO TO 900
C                                       in the image?
         CALL XYPIX (XRA, XDEC, XPIX, YPIX, IERR)
         IF ((IERR.EQ.0) .AND. (XPIX.GE.1.0) .AND. (YPIX.GE.1.0) .AND.
     *      (XPIX.LE.CATBLK(KINAX)) .AND. (YPIX.LE.CATBLK(KINAX+1)))
     *      THEN
            XDEC = XDEC * DG2RAD
            XRA = XRA * DG2RAD
            SINCAL = SIN (XDEC)
            COSCAL = COS (XDEC)
            XD = SINCAL * SINDEC + COSCAL * COSDEC * COS(XRA - SRA)
            IF (XD.GT.1.0D0) THEN
               XD = 0.0D0
            ELSE
               XD = RAD2DG * ACOS (XD)
               END IF
            CALL PBCALC (XD, LAMBD, ANAME, PBPARM(2), XB, OUTSID)
            IF (OUTSID) XB = 0.01
            XF = XB * LFLUX * BPARM(3) / 1000.0
            IF ((XB.GT.PBPARM(1)) .AND. (XF.GT.BFLUX)) THEN
C                                       add to image
               CALL ADDIMG (MLUN, MIND, BMAJ, XPIX, YPIX, XF, IRET)
               IF (IRET.NE.0) GO TO 999
               NS = NS + 1
C                                       Which image is closest?
               J = 0
               XDMIN = 1.E10
               DO 20 I = 1,OFIELD
                  SINFAC = SIN (DECS(I)*DG2RAD)
                  COSFAC = COS (DECS(I)*DG2RAD)
                  FRA = RAS(I) * DG2RAD
                  XD = SINCAL * SINFAC + COSCAL * COSFAC * COS(XRA-FRA)
                  IF (XD.GT.1.0D0) THEN
                     XD = 0.0D0
                  ELSE
                     XD = RAD2DG * ACOS (XD)
                     END IF
                  IF (ABS(XD).LT.XDMIN) THEN
                     XDMIN = ABS (XD)
                     J = I
                     END IF
 20               CONTINUE
C                                       Closest is this one
C                                       Add to CC file
               IF (J.EQ.II) THEN
                  NCC = NCC + 1
                  CCRNO = NCC
                  X = (XPIX - CATR(KRCRP)) * CATR(KRCIC)
                  Y = (YPIX - CATR(KRCRP+1)) * CATR(KRCIC+1)
                  CALL TABCCM ('WRIT', SCRTCH, CCRNO, CCKOLS, CCNUMV,
     *               NCOL, X, Y, Z, XF, CCTYPE, PARMS, IRET)
                  IF (IRET.NE.0) GO TO 999
                  END IF
               END IF
            END IF
 30      CONTINUE
      IF (.NOT.DONE) GO TO 10
C
 900  IF ((NS.GT.0) .OR. (NCC.GT.0)) THEN
         IRET = 0
         WRITE (MSGTXT,1030) II, NS, NCC, JJ
         CALL MSGWRT (4)
      ELSE
         IRET = -1
         WRITE (MSGTXT,1031) II, NS, NCC
         CALL MSGWRT (2)
         END IF
      CALL TABCCM ('CLOS', SCRTCH, CCRNO, CCKOLS, CCNUMV, NCOL, X, Y,
     *   Z, XF, CCTYPE, PARMS, I)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (F9.5,1X,F9.5,I7)
 1020 FORMAT ('ERROR',I5,' READING CATALOG FILE')
 1030 FORMAT ('Field',I5,':',I6,' sources,',I6,' CCs:',
     *   ' kept as output field',I4)
 1031 FORMAT ('Field',I5,':',I6,' sources,',I6,' CCs: discarded')
      END
      SUBROUTINE ADDIMG (MLUN, MIND, BMAJ, XPIX, YPIX, XF, IRET)
C-----------------------------------------------------------------------
C   Adds a Gaussian to the image
C   Inputs:
C      MLUN   I(2)   LUNs to use
C      MIND   I(2)   FTAB pointers
C      BMAJ   R      FWHM in pixels of Gaussian
C      XPIX   R      X pixel of Gaussian
C      YPIX   R      Y pixel of Gaussian
C      XF     R      Flux of Gaussian
C   Outputs:
C      IRET   I      I/O error code
C-----------------------------------------------------------------------
      INTEGER   MLUN(2), MIND(2), IRET
      REAL      BMAJ, XPIX, YPIX, XF
C
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   IX, IY, IWIN(4), NX, NY, ILX, BUFSZ, BLKOF, BIND1,
     *   BIND2, X1, X2
      REAL      BUFF1(MABFSS), BUFF2(MABFSS), W, A, YOFF, DMX
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      BUFSZ = 2 * MABFSS
      BLKOF = 1
      W = 4 * LOG (2.0) / (BMAJ**2)
      DMX = CATR(KRDMX)
C                                       X parameters
      NX = CATBLK(KINAX)
      IWIN(1) = 1
      IWIN(3) = NX
      X1 = XPIX - 2*BMAJ
      X1 = MAX (X1, 1)
      X2 = XPIX + 2*BMAJ + 0.9
      X2 = MIN (X2, NX)
C                                       Y is trickier
      ILX = NBPS / (2 * NX)
      ILX = MAX (ILX, 1)
      NY = CATBLK(KINAX+1)
      IWIN(2) = YPIX - 2.*BMAJ - 1
      IWIN(2) = MAX (0, IWIN(2))
      IWIN(2) = (IWIN(2)/ILX) * ILX + 1
      IWIN(2) = MAX (0, IWIN(2))
      IWIN(4) = YPIX + 2.*BMAJ + 0.9
      IWIN(4) = ((IWIN(4)+ILX-1)/ILX) * ILX
      IWIN(4) = MIN (IWIN(4), NY)
C                                       open for read
      CALL MINIT ('READ', MLUN(1), MIND(1), NX, NY, IWIN, BUFF1, BUFSZ,
     *   BLKOF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT 1'
         GO TO 990
         END IF
C                                       open for write
      CALL MINIT ('WRIT', MLUN(2), MIND(2), NX, NY, IWIN, BUFF2, BUFSZ,
     *   BLKOF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT 2'
         GO TO 990
         END IF
C                                       loop over set of rows
      DO 50 IY = IWIN(2),IWIN(4)
         CALL MDISK ('READ', MLUN(1), MIND(1), BUFF1, BIND1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ ROW'
            GO TO 990
            END IF
         CALL MDISK ('WRIT', MLUN(2), MIND(2), BUFF2, BIND2, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE ROW'
            GO TO 990
            END IF
         CALL RCOPY (NX, BUFF1(BIND1), BUFF2(BIND2))
         YOFF = (IY - YPIX) ** 2
         DO 30 IX = X1,X2
            A = W * ((IX-XPIX)**2 + YOFF)
            IF (A.LT.15.0) THEN
               BUFF2(BIND2+IX-1) = BUFF2(BIND2+IX-1) + XF * EXP (-A)
               DMX = MAX (DMX, BUFF2(BIND2+IX-1))
               END IF
 30         CONTINUE
 50      CONTINUE
C                                       finish the write
      CALL MDISK ('WRIT', MLUN(2), MIND(2), BUFF2, BIND2, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINISH WRITE'
         GO TO 990
         END IF
      CATR(KRDMX) = DMX
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ADDIMG: ERROR',I5,' ON ',A)
      END
      SUBROUTINE FACEHI
C-----------------------------------------------------------------------
C   write HIstory info to FACES output images
C-----------------------------------------------------------------------
C
      INTEGER   LUNH, IERR, I
      CHARACTER HILINE*72
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'FACES.INC'
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
      LUNH = 21
      CALL HICREA (LUNH, ODISK, OCNO, CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLASIN, SEQIN, IDISK, LUNH, SCRTCH,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLSOUT, OSEQ, ODISK, LUNH, SCRTCH,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
C                                       parms
      IF (BFLUX.GT.0.0) THEN
         WRITE (HILINE,1000) TSKNAM, BFLUX
         CALL HIADD (LUNH, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
      WRITE (HILINE,1001) TSKNAM, BPARM(1)
      CALL HIADD (LUNH, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1002) TSKNAM, OVRLAP
      CALL HIADD (LUNH, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1004) TSKNAM, BPARM(3)
      CALL HIADD (LUNH, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1003) TSKNAM, PBPARM(1)
      CALL HIADD (LUNH, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      IF (PBPARM(2).GT.0.0) THEN
         DO 20 I = 3,7
            WRITE (HILINE,1005) TSKNAM, I, PBPARM(I)
            CALL HIADD (LUNH, HILINE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 200
 20         CONTINUE
         END IF
C                                       Close HI file
 200  CALL HICLOS (LUNH, .TRUE., SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A,'FLUX    =',F8.5,9X,'/ beam*source flux limit')
 1001 FORMAT (A,'BPARM(1)=',F7.2,10X,'/ search radius (deg)')
 1002 FORMAT (A,'BPARM(1)=',I7,10X,'/ overlap pixels')
 1003 FORMAT (A,'BPARM(1)=',F7.3,10X,'/ primary beam cutoff')
 1004 FORMAT (A,'BPARM(3)=',F7.3,10X,'/ scale factor on NVSS fluxes')
 1005 FORMAT (A,'PBPARM(',I1,')=',1PE11.4,7X,'/ beam pattern parameter')
      END
      SUBROUTINE BUBBLE (ARRAY1, ARRAY2, NUMBER, DIRECT)
C-----------------------------------------------------------------------
C   In place bubble sort with tracking of swap indices
C   Inputs:
C      NUMBER   I      Number of samples to sort
C      DIRECT   I      Direction of sort (-1 descending)
C   In/Out:
C      ARRAY1   R(*)   Array to sort
C      ARRAY2   I(*)   Array rearranged along with ARRAY1
C-----------------------------------------------------------------------
      REAL      ARRAY1(*)
      INTEGER   ARRAY2(*), NUMBER, DIRECT
C
      INTEGER   I, J, IT
      REAL      RT
      LOGICAL   DONE
C-----------------------------------------------------------------------
      DONE = .FALSE.
      I = 1
C                                       descending order sort
      IF (DIRECT.EQ.-1) THEN
 10      IF ((I.LT.NUMBER) .AND. (.NOT.DONE)) THEN
            DONE = .TRUE.
            DO 20 J = NUMBER,I+1,-1
               IF (ARRAY1(J).GT.ARRAY1(J-1)) THEN
                  RT = ARRAY1(J)
                  ARRAY1(J) = ARRAY1(J-1)
                  ARRAY1(J-1) = RT
                  IT = ARRAY2(J)
                  ARRAY2(J) = ARRAY2(J-1)
                  ARRAY2(J-1) = IT
                  DONE = .FALSE.
                  END IF
 20            CONTINUE
            I = I + 1
            GO TO 10
            END IF
C                                       ascending order sort
      ELSE
 30      IF ((I.LT.NUMBER) .AND. (.NOT.DONE)) THEN
            DONE = .TRUE.
            DO 40 J = NUMBER,I+1,-1
               IF (ARRAY1(J).LT.ARRAY1(J-1)) THEN
                  RT = ARRAY1(J)
                  ARRAY1(J) = ARRAY1(J-1)
                  ARRAY1(J-1) = RT
                  IT = ARRAY2(J)
                  ARRAY2(J) = ARRAY2(J-1)
                  ARRAY2(J-1) = IT
                  DONE = .FALSE.
                  END IF
 40            CONTINUE
            I = I + 1
            GO TO 30
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE SETCEL (RADIUS, IMSIZE, CELSIZ, IERR)
C-----------------------------------------------------------------------
C   SETCEL reads the data to determine the max baseline and W and
C   determines the appropriate cellsize and imsize
C   Inputs
C      RADIUS   R      Maximum radius to use (deg)
C   Output:
C      IMSIZE   I(2)   Image size to use
C      CELSIZ   R(2)   Cell size in
C      IERR     I      Error code: > 0 failed
C-----------------------------------------------------------------------
      INTEGER   IMSIZE(2), IERR
      REAL      RADIUS, CELSIZ(2)
C
      INTEGER   J
      REAL      B, W, R, RPARM(20), VIS(24), FS, HPBW, MAXFR
      LOGICAL   LIMIT
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       minimize data
      BCHAN = 1
      ECHAN = 1
      BIF = 1
      EIF = 1
      CALL UVGET ('INIT', RPARM, VIS, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) 'INIT', IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
      B = 0
      W = 0
C                                       read loop
 100  CALL UVGET ('READ', RPARM, VIS, IERR)
      IF (IERR.NE.-1) THEN
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) 'READ', IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         R = RPARM(1+ILOCU)**2 + RPARM(1+ILOCV)**2
         B = MAX (B, R)
         W = MAX (W, ABS(RPARM(1+ILOCW)))
         GO TO 100
         END IF
C                                       close file
      CALL UVGET ('CLOS', RPARM, VIS, IERR)
      IF ((W.LE.0.0) .OR. (B.LE.0.0)) THEN
         IERR = 2
         MSGTXT = 'NO DATA FOUND: SET IMSIZE, CELLSIZE'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       set results
      B = SQRT (B)
C                                       min fringe spacing in asec
      FS = RAD2AS / B
C                                       basic cell FS/3
      FS = FS / 3.0
C                                       image size limited by W term
C                                       beam in radian
      HPBW = 3 * FS * AS2RAD
C                                       max field correct B/W
      MAXFR = SQRT (HPBW) / 3.0 * B / W
      R = RADIUS * DG2RAD
      LIMIT = R.LT.MAXFR
      IF (LIMIT) THEN
         MAXFR = R
         IF (((CELSIZ(1).LE.0.0) .OR. (CELSIZ(2).LE.0.0)) .AND.
     *      ((IMSIZE(1).LE.0) .OR. (IMSIZE(2).LE.0))) THEN
            CELSIZ(1) = FS
            CELSIZ(2) = FS
            END IF
         END IF
C                                       circular Clean
      J = 2 * MAXFR * RAD2AS / FS + 0.5
C                                       message
      WRITE (MSGTXT,1010) J, FS
      CALL MSGWRT (4)
C                                       now set IMSIZE given CELL
      IF ((CELSIZ(1).GT.0.0) .AND. (CELSIZ(2).GT.0.0)) THEN
         J = 2 * MAXFR * RAD2AS / CELSIZ(1) + 10.5
         IF (J.GT.11200) THEN
            IMSIZE(1) = 16384
         ELSE IF (J.GT.5600) THEN
            IMSIZE(1) = 8192
         ELSE IF (J.GT.2800) THEN
            IMSIZE(1) = 4096
         ELSE IF (J.GT.1400) THEN
            IMSIZE(1) = 2048
         ELSE IF (J.GT.700) THEN
            IMSIZE(1) = 1024
         ELSE IF (J.GT.350) THEN
            IMSIZE(1) = 512
         ELSE IF (J.GT.175) THEN
            IMSIZE(1) = 256
         ELSE IF (J.GT.87) THEN
            IMSIZE(1) = 128
         ELSE
            IMSIZE(1) = 64
            END IF
         IMSIZE(2) = IMSIZE(1)
C                                       or set CELL given IMSI
      ELSE IF ((IMSIZE(1).GT.0) .AND. (IMSIZE(2).GT.0)) THEN
         CELSIZ(1) = 2. * MAXFR * RAD2AS / (IMSIZE(1) - 10.)
         CELSIZ(2) = CELSIZ(1)
C                                       balance the two
      ELSE
         J = 2 * MAXFR * RAD2AS / FS + 20.5
         IF (J.GT.9200) THEN
            IMSIZE(1) = 16384
         ELSE IF (J.GT.4600) THEN
            IMSIZE(1) = 8192
         ELSE IF (J.GT.2300) THEN
            IMSIZE(1) = 4096
         ELSE IF (J.GT.1150) THEN
            IMSIZE(1) = 2048
         ELSE IF (J.GT.575) THEN
            IMSIZE(1) = 1024
         ELSE IF (J.GT.282) THEN
            IMSIZE(1) = 512
         ELSE IF (J.GT.141) THEN
            IMSIZE(1) = 256
         ELSE IF (J.GT.70) THEN
            IMSIZE(1) = 128
         ELSE
            IMSIZE(1) = 64
            END IF
         IMSIZE(2) = IMSIZE(1)
         CELSIZ(1) = 2. * MAXFR * RAD2AS / (IMSIZE(1) - 20.)
         CELSIZ(2) = CELSIZ(1)
         END IF
C                                       message
      WRITE (MSGTXT,1020) IMSIZE(1), CELSIZ(1)
      CALL MSGWRT (4)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UV DATA ',A,' ERROR',I5)
 1010 FORMAT ('SETCEL: recommends IMSIZE',I6,' CELLSIZE',F10.5)
 1020 FORMAT ('SETCEL: returns    IMSIZE',I6,' CELLSIZE',F10.5)
      END

      SUBROUTINE TABOTT (OPCODE, BUFFER, IERR)
C-----------------------------------------------------------------------
C! Does I/O to Index (OT) table opened by OTTINI
C# EXT-util UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2011, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to INDEX extention tables. Usually used after setup by
C   OTTINI.
C    Inputs:
C     OPCODE       C*4 Operation code:
C                      'READ' = read entry from table.
C                      'WRIT' = write entry in table.
C                      'CLOS' = close file, flush on write
C     BUFFER(512)  I   I/O buffer and related storage, also defines file
C                      if open. Should have been returned by OTTINI or
C                      TABINI.
C    Output:
C     IERR         I   Error code, 0=>OK else TABIO error.
C                      Note: -1=> read but record deselected.
C    Input/output written to or read from DOTTV.INC, COMMON /OTVALS/:
C     TIME8        D   Center time of the scan (Days)
C     DT           R   Duration of scan (days).
C     JDSOUR       I   Source ID as defined in then SOURCE table.
C     IANT         I   antenna number
C     OTT          L   Over the Top code.
C    Input/output written to or read from DOTTV.INC, COMMON /OTTABV/:
C     IOTRNO       I   Next scan number to read or write.
C     OTKOLS(MAXNXC)  I   The column pointer array in order, TIME,
C                         TIME INTERVAL, SOURCE ID, ANTENNA-NUMBER,
C                         OVER-THE-TOP
C     OTNUMV(MAXNXC)  I   Element count in each column, set by OTTINI.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DOTTV.INC'
      CHARACTER OPCODE*4
      DOUBLE PRECISION RECD(6)
      INTEGER   BUFFER(512), IERR, TIMKOL, INTKOL,
     *          SOUKOL, ANTKOL, OTTKOL, RECI(24)
      LOGICAL   DOREAD, DOCLOS, RECL(48)
      REAL      RECORD(12)
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (RECD, RECORD, RECI, RECL)
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
      DOCLOS = OPCODE.EQ.'CLOS'
C                                       Branch for CLOS
      IF (DOCLOS) GO TO 800
C                                       Set pointers
      TIMKOL = OTKOLS(1)
      INTKOL = OTKOLS(2)
      SOUKOL = OTKOLS(3)
      ANTKOL = OTKOLS(4)
      OTTKOL = OTKOLS(5)
C                                       If write fill RECORD
      IF (.NOT.DOREAD) THEN
         IF (TDUBL) THEN
            RECD(TIMKOL) = TIME8
         ELSE
            RECORD(TIMKOL) = TIME8
            END IF
         RECORD(INTKOL) = DT
         RECI(SOUKOL)   = JDSOUR
         RECI(ANTKOL)   = IANT
         RECL(OTTKOL)   = OTT
         END IF
C                                       Process record.
 50   CALL TABIO (OPCODE, 0, IOTRNO, RECORD, BUFFER, IERR)
      IOTRNO = IOTRNO + 1
      IF (IERR.GT.0) GO TO 990
C                                       If READ pick data from RECORD.
      IF (DOREAD) THEN
         IF (TDUBL) THEN
            TIME8  = RECD(TIMKOL)
         ELSE
            TIME8 = RECORD(TIMKOL)
            END IF
         DT     = RECORD(INTKOL)
         JDSOUR = RECI(SOUKOL)
         IANT   = RECI(ANTKOL)
         OTT    = RECL(OTTKOL)
         END IF
      GO TO 999
C                                       Close
 800  CALL TABIO ('CLOS', 0, IOTRNO, RECORD, BUFFER, IERR)
      IF (IERR.GT.0) GO TO 990
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1800) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1800 FORMAT ('TABOTT: TABIO ERROR',I3)
      END

      SUBROUTINE ZMSGXP (LUN, IVOL, PNAME, NREC, IERR)
C-----------------------------------------------------------------------
C! expand the message file
C# Z IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Increase the size of a message file (special version of ZEXPND that
C   writes error messages to the terminal only in order to avoid
C   recursion).
C   Inputs:
C      LUN     I      LUN of file open message file (must be 12)
C      IVOL    I      Disk volume containing file, 1,2,3,...
C      PNAME   C*48   Physical file name
C   In/Out:
C      NREC    I      # 256-integer records requested/received
C   Output:
C      IERR    I      Error return code: 0 => no error
C                        1 => input error
C                        2 => expansion error
C                        3 => ZEXIS2 error
C   UNICOS version - calls ZEXPN2, ZEXIS2.
C-----------------------------------------------------------------------
      INTEGER   LUN, IVOL, NREC, IERR
      CHARACTER PNAME*48
C
      INTEGER   FCBOFF, FIND, ERRLUN, ISIZE, LSIZE, JERR, SYSERR,
     *   LREC, KREC
      LOGICAL   MAP
      HOLLERITH ANAME(12)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA ERRLUN, MAP /12, .FALSE./
C-----------------------------------------------------------------------
C                                       Valid number of records.
      IERR = 1
      IF (NREC.GT.0) GO TO 10
         WRITE (6,1000) NREC
         GO TO 990
C                                       Valid volume?
 10   IF ((IVOL.GT.0) .OR. (IVOL.LE.NVOL)) GO TO 20
         WRITE (6,1010) IVOL
         GO TO 990
C                                       LUN must be ERRLUN.
 20   IF (LUN.EQ.ERRLUN) GO TO 30
         WRITE (6,1020) LUN, ERRLUN
         GO TO 990
C                                       Locate message file in FTAB.
 30   CALL LSERCH ('SRCH', LUN, FIND, MAP, IERR)
      IF (IERR.EQ.0) GO TO 40
         WRITE (6,1030) PNAME(1:24), LUN
         GO TO 990
C                                       Expand file.
 40   FCBOFF = FIND + NMOFF
C      CALL CHR2H (48, PNAME, 1, ANAME)
C                                       current size
C      CALL ZEXIS2 (ANAME, ISIZE, SYSERR, JERR)
      CALL ZEXIS2 (PNAME, ISIZE, SYSERR, JERR)
      IF (JERR.NE.0) THEN
         IERR = 3
         GO TO 999
         END IF
      LREC = NREC
      CALL ZEXPN2 (FTAB(FCBOFF), 0, NREC, IERR)
      IF (IERR.EQ.0) THEN
C         CALL ZEXIS2 (ANAME, LSIZE, SYSERR, JERR)
         CALL ZEXIS2 (PNAME, LSIZE, SYSERR, JERR)
         IF (JERR.NE.0) THEN
            IERR = 3
            GO TO 999
            END IF
         KREC = NREC
         NREC = LSIZE - ISIZE
         IF ((NREC.LT.KREC) .OR. (NREC.LT.LREC)) THEN
            WRITE (6,1040) LREC, KREC, NREC
            END IF
         GO TO 999
      ELSE
         IERR = 2
         WRITE (6,1045) PNAME(1:24), NREC
         END IF
C
 990  NREC = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (' ZMSGXP: INVALID RECORD REQUEST = ',I6)
 1010 FORMAT (' ZMSGXP: INVALID VOLUME REQUEST = ',I6)
 1020 FORMAT (' ZMSGXP: INVALID LUN = ',I2,'. MUST BE ',I2)
 1030 FORMAT (' ZMSGXP: FILE ',A24,' NOT OPEN IN FTAB.  LUN = ',I2)
 1040 FORMAT (' ZMSGXP: REQUEST, CLAIMED, ACTUAL',3I7,' BLOCKS')
 1045 FORMAT (' ZMSGXP: EXPANSION FAILED ON FILE ',A24,' NREC = ',I6)
      END

      SUBROUTINE OFMDIR (OPER, NAME, N, OFM, IERR)
C-----------------------------------------------------------------------
C! read, create/write, delete, or directory-list OFM save files
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2002, 2009, 2012, 2022, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does operations on files used to save OFMs - namely list directory,
C   read from disk, create and save to disk, and destroy.  The OFM file
C   is an AIPS ZTX... file normally save in the logical area 'AIPSOFM'
C   (system user # 1) or 'OFMFIL' (normal users).  Each record has the
C   form input intensity, ':', blue out, green out, red out.  All are
C   integers and the outs are scaled from 0 through 10000.  The file
C   names are xxxxxxxx.uuu where uuu is the user number in hex.  User 1
C   files may be read also from the AIPSOFM area.
C   Inputs:
C      OPER     C*4      'DIR', 'GET', 'QGET', 'SAVE', 'ZAP'
C      NAME     C*48     File name (without the ".uuu").  If a ':'
C                        appears, the name is assumed to be exact
C                        and may be anywhere on the disk.  Not used
C                        by 'DIR'.  Min match is used in 'GET's only.
C      N        I        First dimension of OFM
C   In/out:
C      OFM      R(N,3)   current OFM values - ignored in 'DIR', 'ZAP'
C                           'GET' returns the contents of a file
C                           'SAVE' writes the OFM to a file
C      IERR     I        error code: 0 okay
C                           50 'DISK PROBLEM'
C                           31 'UNAVAILABLE!' - bad OPER
C                           45 'FILE MISSING' - problem w NAME
C                          101 - file missing (GET) or present (SAVE)
C   The routine does no IO to the TV - that is the job of the calling
C   routine (if appropriate).
C-----------------------------------------------------------------------
      CHARACTER OPER*(*), NAME*48
      INTEGER   N, IERR
      REAL      OFM(N,3)
C
      INTEGER   POTERR, JERR, NNAM, NNAM2, NMAX, JTRIM, I, FLEN, J, J2,
     *   NCH, ICH, ILIS(400), IT, OFMLUN, OFMIND, IB, IG, IR, NMSG,
     *   NLEVS, IDATE(3), NGNU
      PARAMETER (NGNU = 23)
      LOGICAL   F, ISPEC, EXISTS
      CHARACTER HUSER*3, XLATED*256, FILSPC*256, ANAME*10, LINE*132,
     *   GPLBRK(2)*35, GPLDAT*16, GPLTXT(2,NGNU)*35, GPLTX1(2,10)*35,
     *   GPLTX2(2,10)*35, GPLTX3(2,NGNU-20)*35
      HOLLERITH NAMES(3,400)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      EQUIVALENCE (GPLTXT(1,1), GPLTX1(1,1))
      EQUIVALENCE (GPLTXT(1,11), GPLTX2(1,1))
      EQUIVALENCE (GPLTXT(1,21), GPLTX3(1,1))
      DATA F /.FALSE./
      DATA OFMLUN /11/
      DATA GPLDAT /'  Copyright (C) '/
      DATA GPLBRK /'-----------------------------------',
     *             '-----------------------------------'/
      DATA GPLTX1 /'  Associated Universities, Inc. Was',
     *             'hington DC, USA.                   ',
     *             '                                   ',
     *             '                                   ',
     *             '  This program is free software; yo',
     *             'u can redistribute it and/or       ',
     *             '  modify it under the terms of the ',
     *             'GNU General Public License as      ',
     *             '  published by the Free Software Fo',
     *             'undation; either version 2 of      ',
     *             '  the License, or (at your option) ',
     *             'any later version.                 ',
     *             '                                   ',
     *             '                                   ',
     *             '  This program is distributed in th',
     *             'e hope that it will be useful,     ',
     *             '  but WITHOUT ANY WARRANTY; without',
     *             ' even the implied warranty of      ',
     *             '  MERCHANTABILITY or FITNESS FOR A ',
     *             'PARTICULAR PURPOSE.  See the       '/
      DATA GPLTX2 /'  GNU General Public License for mo',
     *             're details.                        ',
     *             '                                   ',
     *             '                                   ',
     *             '  You should have received a copy o',
     *             'f the GNU General Public           ',
     *             '  License along with this program; ',
     *             'if not, write to the Free          ',
     *             '  Software Foundation, Inc., 675 Ma',
     *             'ssachusetts Ave, Cambridge,        ',
     *             '  MA 02139, USA.                   ',
     *             '                                   ',
     *             '                                   ',
     *             '                                   ',
     *             '  Correspondence concerning AIPS sh',
     *             'ould be addressed as follows:      ',
     *             '         Internet email: aipsmail@n',
     *             'rao.edu.                           ',
     *             '         Postal address: AIPS Proje',
     *             'ct Office                          '/
      DATA GPLTX3 /'                         National R',
     *             'adio Astronomy Observatory         ',
     *             '                         520 Edgemo',
     *             'nt Road                            ',
     *             '                         Charlottes',
     *             'ville, VA 22903-2475 USA           '/
C-----------------------------------------------------------------------
      POTERR = 50
      IF ((OPER.NE.'DIR') .AND. (OPER.NE.'GET') .AND. (OPER.NE.'SAVE')
     *   .AND. (OPER.NE.'ZAP') .AND. (OPER.NE.'QGET')) THEN
         MSGTXT = 'OFMDIR: UNKNOWN OPER ' // OPER
         POTERR = 31
         GO TO 985
         END IF
      ISPEC = F
      IF (OPER.NE.'DIR') ISPEC = INDEX(NAME,':').GT.0
      CALL ZEHEX (NLUSER, 3, HUSER)
C                                       get directory list
      IF ((OPER.EQ.'DIR') .OR. ((OPER.EQ.'GET') .AND. (.NOT.ISPEC)) .OR.
     *   ((OPER.EQ.'QGET') .AND. (.NOT.ISPEC)))
     *   THEN
         POTERR = 45
C                                       Look for user's files
         IF ((OPER.EQ.'GET') .OR. (OPER.EQ.'QGET')) THEN
            NCH = JTRIM (NAME)
            IF (NCH.LE.0) THEN
               MSGTXT = 'A FILE NAME MUST BE SPECIFIED'
               GO TO 985
               END IF
            IF (NLUSER.NE.1) THEN
               XLATED = 'OFMFIL:' // NAME(:NCH) // '*.' // HUSER
            ELSE
               XLATED = 'AIPSOFM:' // NAME(:NCH) // '*.' // HUSER
               END IF
         ELSE
            IF (NLUSER.NE.1) THEN
               XLATED = 'OFMFIL:*.' // HUSER
            ELSE
               XLATED = 'AIPSOFM:*.' // HUSER
               END IF
            END IF
         CALL ZFULLN (XLATED, ' ', ' ', FILSPC, JERR)
         IF (JERR.NE.0) GO TO 980
         FLEN = JTRIM (FILSPC)
         NMAX = 400
         CALL ZTXMA2 (FLEN, FILSPC, NMAX, 0, NNAM, NAMES(1,1), JERR)
         IF (JERR.GT.1) GO TO 970
         IF (JERR.EQ.1) NNAM = 0
         NNAM2 = 0
C                                       Look for system's files
         IF (NLUSER.NE.1) THEN
            IF ((OPER.EQ.'GET') .OR. (OPER.EQ.'QGET')) THEN
               XLATED = 'AIPSOFM:' // NAME(:NCH) // '*.000'
            ELSE
               XLATED = 'AIPSOFM:*.000'
               END IF
            CALL ZFULLN (XLATED, ' ', ' ', FILSPC, JERR)
            IF (JERR.NE.0) GO TO 980
            FLEN = JTRIM (FILSPC)
            NMAX = NMAX - NNAM
            I = NNAM + 1
            CALL ZTXMA2 (FLEN, FILSPC, NMAX, 0, NNAM2, NAMES(1,I),
     *         JERR)
            IF (JERR.GT.1) GO TO 970
            IF (JERR.EQ.1) NNAM2 = 0
            NNAM = NNAM + NNAM2
            END IF
         IF (NNAM.LE.0) THEN
            MSGTXT = 'NO OFM FILES FOUND'
            GO TO 985
            END IF
         END IF
C                                       Directory listing
      IF (OPER.EQ.'DIR') THEN
         NMAX = NNAM - NNAM2
         IF (NMAX.GT.0) THEN
            WRITE (MSGTXT,1000) NLUSER
            CALL MSGWRT (3)
            DO 20 I = 1,NMAX,5
               J2 = MIN (NMAX, I+4)
               MSGTXT = ' '
               DO 10 J = I,J2
                  CALL H2CHR (10, 1, NAMES(1,J), ANAME)
                  MSGTXT(13*(J-I)+1:) = ANAME
 10               CONTINUE
               CALL MSGWRT (3)
 20            CONTINUE
            END IF
         IF (NNAM2.GT.0) THEN
            MSGTXT = 'System-provided OFM files:'
            CALL MSGWRT (3)
            NMAX = NMAX + 1
            DO 40 I = NMAX,NNAM,5
               J2 = MIN (NNAM, I+4)
               MSGTXT = ' '
               DO 30 J = I,J2
                  CALL H2CHR (10, 1, NAMES(1,J), ANAME)
                  MSGTXT(13*(J-I)+1:) = ANAME
 30               CONTINUE
               CALL MSGWRT (3)
 40            CONTINUE
            END IF
         POTERR = 0
         GO TO 990
         END IF
C                                       GET: do min-match on names
      IF (((OPER.EQ.'GET') .OR. (OPER.EQ.'QGET')) .AND. (.NOT.ISPEC))
     *   THEN
         NCH = JTRIM (NAME)
         FLEN = 0
         DO 110 I = 1,NNAM
            CALL H2CHR (10, 1, NAMES(1,I), ANAME)
            ICH = JTRIM (ANAME)
            IT = I
            IF ((ICH.EQ.NCH) .AND. (ANAME.EQ.NAME)) GO TO 130
            IF ((ICH.GT.NCH) .AND. (ANAME(:NCH).EQ.NAME(:NCH))) THEN
               FLEN = FLEN + 1
               ILIS(FLEN) = I
               END IF
 110        CONTINUE
         IF (FLEN.LE.0) THEN
            MSGTXT = 'FILE ' // NAME(:NCH) // ' NOT FOUND'
            POTERR = 45
            GO TO 985
         ELSE IF (FLEN.EQ.1) THEN
            IT = ILIS(1)
            CALL H2CHR (10, 1, NAMES(1,IT), ANAME)
         ELSE
            MSGTXT = 'FILE NAME MIN-MATCH FAILURE; COULD BE:'
            CALL MSGWRT (6)
            POTERR = 101
            DO 120 I = 1,FLEN,5
               MSGTXT = ' '
               J2 = MIN (FLEN, I+4)
               DO 115 J = I,J2
                  CALL H2CHR (10, 1, NAMES(1,ILIS(J)), ANAME)
                  MSGTXT (13*(J-I)+1:) = ANAME
 115              CONTINUE
               CALL MSGWRT (6)
 120           CONTINUE
            GO TO 990
            END IF
 130     ICH = JTRIM (ANAME)
         IF ((IT.LE.NNAM-NNAM2) .AND. (NLUSER.NE.1)) THEN
            XLATED = 'OFMFIL:' // ANAME(:ICH) // '.' // HUSER
         ELSE
            XLATED = 'AIPSOFM:' // ANAME(:ICH) // '.000'
            END IF
      ELSE IF (ISPEC) THEN
         XLATED = NAME
         NCH = JTRIM (NAME)
         IF (NAME(NCH-3:NCH-3).NE.'.') XLATED = NAME(:NCH) //
     *      '.' // HUSER
      ELSE
         POTERR = 45
         NCH = JTRIM (NAME)
         IF (NCH.LE.0) THEN
            MSGTXT = 'A FILE NAME MUST BE SPECIFIED'
            GO TO 985
            END IF
         IF (NLUSER.NE.1) THEN
            XLATED = 'OFMFIL:' // NAME(:NCH) // '.' // HUSER
         ELSE
            XLATED = 'AIPSOFM:' // NAME(:NCH) // '.' // HUSER
            END IF
         END IF
C                                       Translate logical
      CALL ZFULLN (XLATED, ' ', ' ', FILSPC, JERR)
      IF (JERR.NE.0) GO TO 980
      FLEN = JTRIM (FILSPC)
C                                       does it exist?
      INQUIRE (FILE=FILSPC(:FLEN), EXIST=EXISTS)
      POTERR = 101
      IF (EXISTS) THEN
         IF (OPER.EQ.'SAVE') THEN
            MSGTXT = 'FILE ALREADY EXISTS: ' // FILSPC
            GO TO 985
            END IF
      ELSE
         IF (OPER.NE.'SAVE') THEN
            MSGTXT = 'FILE MISSING: ' // FILSPC
            IF (OPER.EQ.'ZAP') POTERR = 0
            GO TO 985
            END IF
         END IF
      J2 = OFMINP + 1
      IF ((OPER.EQ.'GET') .OR. (OPER.EQ.'QGET')) THEN
         IF (OPER.EQ.'GET') THEN
            CALL ZTXOPN ('READ', OFMLUN, OFMIND, XLATED, F, JERR)
         ELSE
            CALL ZTXOPN ('QRED', OFMLUN, OFMIND, XLATED, F, JERR)
            END IF
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1200) JERR, XLATED
            GO TO 985
            END IF
         NMSG = 0
         DO 210 I = 1,J2
 205        CALL ZTXIO ('READ', OFMLUN, OFMIND, LINE, JERR)
            IF (JERR.NE.0) THEN
               WRITE (MSGTXT,1210) JERR, 'READ', I
               IF (JERR.NE.2) GO TO 985
               J = 0
               IF (NLEVS.GT.0) J = J2 / NLEVS
               IF (NLEVS*J.NE.J2) GO TO 985
               GO TO 211
               END IF
            J = JTRIM (LINE)
C                                       skip comments
            IF (LINE(:1).EQ.';') GO TO 205
            IF (LINE(6:6).EQ.':') THEN
               READ (LINE,1215) J, IB, IG, IR
            ELSE
               READ (LINE,1216) J, IB, IG, IR
               END IF
            J = J + 1
            IF ((NMSG.LT.5) .AND. (I.NE.J)) THEN
               WRITE (MSGTXT,1220) J, I
               CALL MSGWRT (6)
               NMSG = NMSG + 1
               END IF
            NLEVS = J
            OFM(J,1) = IB / 10000.0
            OFM(J,2) = IG / 10000.0
            OFM(J,3) = IR / 10000.0
 210        CONTINUE
 211     CALL ZTXCLS (OFMLUN, OFMIND, JERR)
      ELSE IF (OPER.EQ.'SAVE') THEN
         CALL ZTXOPN ('WRIT', OFMLUN, OFMIND, XLATED, F, JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1200) JERR, XLATED
            GO TO 985
            END IF
C                                       comments at start
         NCH = JTRIM (NAME)
         LINE = ';;  ' // NAME(:NCH)
         NCH = JTRIM (LINE)
         CALL ZTXIO ('WRIT', OFMLUN, OFMIND, LINE(:NCH), JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1205) JERR, 'WRIT'
            GO TO 985
            END IF
         LINE = ';;' // GPLBRK(1) // GPLBRK(2)
         NCH = JTRIM (LINE)
         CALL ZTXIO ('WRIT', OFMLUN, OFMIND, LINE(:NCH), JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1205) JERR, 'WRIT'
            GO TO 985
            END IF
         CALL ZDATE (IDATE)
         IF (IDATE(1).LT.200) IDATE(1) = IDATE(1) + 1900
         WRITE (LINE,1300) GPLDAT, IDATE(1)
         NCH = JTRIM (LINE)
         CALL ZTXIO ('WRIT', OFMLUN, OFMIND, LINE(:NCH), JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1205) JERR, 'WRIT'
            GO TO 985
            END IF
         DO 310 J = 1,NGNU
            LINE = ';;' // GPLTXT(1,J) // GPLTXT(2,J)
            NCH = JTRIM (LINE)
            CALL ZTXIO ('WRIT', OFMLUN, OFMIND, LINE(:NCH), JERR)
            IF (JERR.NE.0) THEN
               WRITE (MSGTXT,1205) JERR, 'WRIT'
               GO TO 985
               END IF
 310        CONTINUE
         LINE = ';;' // GPLBRK(1) // GPLBRK(2)
         NCH = JTRIM (LINE)
         CALL ZTXIO ('WRIT', OFMLUN, OFMIND, LINE(:NCH), JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1205) JERR, 'WRIT'
            GO TO 985
            END IF
         NMSG = 0
         DO 320 J = 1,J2
            IB = OFM(J,1) * 10000.0 + 0.5
            IG = OFM(J,2) * 10000.0 + 0.5
            IR = OFM(J,3) * 10000.0 + 0.5
            I = J - 1
            IF (I.LE.9999) THEN
               WRITE (LINE,1310) I, IB, IG, IR
               CALL ZTXIO ('WRIT', OFMLUN, OFMIND, LINE(:24), JERR)
            ELSE
               WRITE (LINE,1311) I, IB, IG, IR
               CALL ZTXIO ('WRIT', OFMLUN, OFMIND, LINE(:25), JERR)
               END IF
            IF (JERR.NE.0) THEN
               WRITE (MSGTXT,1210) JERR, 'WRIT', J
               GO TO 985
               END IF
 320        CONTINUE
         CALL ZTXCLS (OFMLUN, OFMIND, JERR)
      ELSE IF (OPER.EQ.'ZAP') THEN
         CALL ZTXZAP (OFMLUN, XLATED, JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1400) JERR, XLATED
            GO TO 985
         ELSE
            MSGTXT = 'Deleted ' // XLATED(:72)
            CALL MSGWRT (2)
            END IF
         END IF
      POTERR = 0
      GO TO 990
C                                       Error messages
 970  WRITE (MSGTXT,1970) JERR, FILSPC
      GO TO 985
 980  WRITE (MSGTXT,1980) JERR, XLATED
C
 985  CALL MSGWRT (6)
C                                       return an error code
 990  IERR = POTERR
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OFM files belonging to user',I5)
 1200 FORMAT ('ERROR',I5,' OPENING ',A60)
 1205 FORMAT ('ERROR',I5,' ',A4,'ING COMMENT')
 1210 FORMAT ('ERROR',I5,' ',A4,'ING LINE',I5)
 1215 FORMAT (I4,2X,3I6)
 1216 FORMAT (I5,2X,3I6)
 1220 FORMAT ('WARNING: READ LINE ',I5,' EXPECTED LINE',I5)
 1300 FORMAT (';;',A,I4)
 1310 FORMAT (I4,' :',3I6)
 1311 FORMAT (I5,' :',3I6)
 1400 FORMAT ('ERROR',I5,' DELETING ',A60)
 1970 FORMAT ('ERROR',I5,' MATCHING ',A60)
 1980 FORMAT ('ERROR',I5,' TRANSLATING ',A57)
      END

      SUBROUTINE UVLIMT (BLMIN, BLMAX, UUMAX, VVMAX, IVIS, UIN, VIN,
     *   ERRCNT)
C-----------------------------------------------------------------------
C! Prints U-V point limits and increments error count
C# AP-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2001
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVLIMT prints the U-V limits for gridded uv-data and then
C   Prints the offending data point.   Only a few errors are printed.
C   The limits are only printed if ERRCNT is zero.
C   Inputs:
C      BLMIN       R     Minimum Baseline Radius (lambda)
C      BLMAX       R     Maximum Baseline Radius (lambda)
C      UUMAX       R     Maximum U baseline length (lambda)
C      VVMAX       R     Maximum V baseline length (lambda)
C      IVIS        I     U-V Point number
C      UIN         R     U baseline length of input point
C      VIN         R     V baseline length of input point
C   Input/Output
C      ERRCNT      I     Count of Error Messages printed (incremented)
C-----------------------------------------------------------------------
      REAL      BLMIN, BLMAX, UUMAX, VVMAX, UIN, VIN
      INTEGER   IVIS, ERRCNT
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       if not too many messages
      IF (ERRCNT.LT.10) THEN
C                                       Encode limits
         WRITE (MSGTXT,1100,ERR=900) BLMIN, BLMAX, UUMAX, VVMAX
         IF (ERRCNT.EQ.0) CALL MSGWRT (7)
C                                       tell user point lost
 900     WRITE (MSGTXT,1200,ERR=999) IVIS, UIN, VIN
         CALL MSGWRT (7)
C                                       tell that there are more
      ELSE IF (ERRCNT.EQ.10) THEN
         MSGTXT = 'UVLIMT: REMAINING MESSAGES SUPPRESSED'
         CALL MSGWRT (7)
         END IF
C                                       increment count
      ERRCNT = ERRCNT + 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('UVLIMT: LIMITS=',1PE9.2,1PE9.2,'; MAX U=',
     *         1PE9.2,', V=',1PE9.2)
 1200 FORMAT ('UVLIMT: Point',I9,'  (U=',F12.0,',V=',F12.0,') Dropped')
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QINIT (I1, I2, APNUM)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Initialize "AP".
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo AP version
C   Initialize the AP.  For the pseudo-AP the size of the arrays in
C   COMMON /APCORE/ are defined and the AP roller common is
C   initialized.
C   Inputs:
C      I1      I  Dummy
C      I2      I  Dummy
C   Outputs:
C      APNUM   I  AP number (Neg. to indicate virtual AP, ie.
C                 not to be rolled).
C   Output to common /BPROLC/
C      TRUEAP   L  True if a real AP (to be rolled) (FALSE)
C      XTLAST   D  Real time AP assigned (min).
C      DELTIM   D  Time interval between rolls (min).
C      DELAY    R  Time to delay task (seconds).
C-----------------------------------------------------------------------
      INTEGER   I1, I2, APNUM
      INTEGER   FFTSIZ, PAD4
      DOUBLE PRECISION AUX1(40000), AUX2(40000)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPC.INC'
      INCLUDE 'INCS:DBPR.INC'
      COMMON /SCFTCM/ FFTSIZ, FFTDIR, AUX1, AUX2
C-----------------------------------------------------------------------
C                                       Mark as non-rollable AP
      APNUM = -1
C                                       Fill values into /BPROLC/
      TRUEAP = .FALSE.
C                                       Delay time = 10 sec.
      DELAY = 10.0
C                                       Time between rolls = 5 min.
      DELTIM = 5.0D0
C                                       Set time.
      XTLAST = 0.0
C
      FFTSIZ = 0
C
      FFTDIR = 1
C
      KAPWRD = PKPWRD
      KAP2WD = MIN (PKPWD2, KAP2WD)
      IF (KAP2WD.LE.0) KAP2WD = PKPWD2
C
 999  RETURN
      END

LOCAL INCLUDE 'TVDIC.INC'
C                                                        Include TVDIC.
C                                       Local include for TVDIC.
      INCLUDE 'INCS:PMAD.INC'
      INCLUDE 'INCS:PTVC.INC'
C                                       Input parameters (see header
C                                       comments).
      INTEGER   FLMSIZ, FLMTYP, COPIES
      CHARACTER OUTPRT*48,COMMNT*48
C                                       Dimensions of work arrays.
C                                        MAXROW: maximum row size in
C                                                pixels
C                                        MAXPLN: maximum number of
C                                                grey-scale planes
C                                        MXGPLN: maximum number of
C                                                graphics planes
C                                        MAXLUT: maximum number of
C                                                entries in an LUT
C                                        MAXOFM: maximum number of
C                                                entries in an OFM
      INTEGER MAXROW, MAXPLN, MXGPLN, MAXLUT, MAXOFM
      PARAMETER (MAXROW = (MAXIMG))
      PARAMETER (MAXPLN = 4)
      PARAMETER (MXGPLN = 4)
      PARAMETER (MAXLUT = (TVMLUT)+1)
      PARAMETER (MAXOFM = (TVMOFM)+1)
C                                       LUT for image file.
      INTEGER DICLUN
      PARAMETER (DICLUN = 10)
C
      INTEGER   LUTDAT(MAXLUT, 3, MAXPLN), WINDOW(4)
      INTEGER   RBITS(MAXPLN), GBITS(MAXPLN), BBITS(MAXPLN)
      REAL      OFMDAT(MAXOFM, 3)
      INTEGER   GPMASK(MXGPLN)
C
      COMMON /PARM/   FLMSIZ, FLMTYP, COPIES
      COMMON /CHPARM/ OUTPRT, COMMNT
      COMMON /TVDATA/ LUTDAT, OFMDAT, WINDOW, RBITS, GBITS, BBITS,
     *                GPMASK
C                                                           End TVDIC.
LOCAL END
      PROGRAM TVDIC
C-----------------------------------------------------------------------
C! Copies a TV image to a Dicomed file recorder.
C# TV Film-Recorder
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2002, 2008
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TVDIC reads the current contents of an AIPS TV and writes them
C   to an NRAO-format Dicomed image file.
C
C   Adverbs:
C      Adverb name   Prgm. name   Description
C      OUTPRINT      OUTPRT       Name of output file
C      GRCHAN        GRCHAN       Graphics channels to read.
C      APARM(1)      FLMSIZ       Film size (enumerated)
C                                  0 -> 35mm
C                                  1 -> 2"x2"
C                                  2 -> 4"x5"
C      APARM(2)      FLMTYP       Film type (enumerated)
C                                  0 -> colour positive
C                                  1 -> colour negative
C                                  2 -> B/W negative
C      APARM(3)      COPIES       Number of copies (default: 1)
C-----------------------------------------------------------------------
      INTEGER   IRET, WBUFF(256)
C
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'TVDIC.INC'
C-----------------------------------------------------------------------
C                                       Initialize AIPS commons and
C                                       read and check input adverbs:
      CALL TVDCIN (IRET)
C
      IF (IRET.EQ.0) THEN
C                                       Open output file and TV device:
         CALL DCINIT (IRET)
         END IF
      IF (IRET.EQ.0) THEN
C                                       Copy screen image to output
C                                       file:
         CALL CPSCRN (IRET)
         END IF
      IF (IRET.EQ.0) THEN
C                                       Close output file and TV
C                                       device:
         CALL TVDFIN (IRET)
         END IF
C                                       Terminate task:
      CALL DIE (IRET, WBUFF)
      STOP
      END
      SUBROUTINE TVDCIN (IRET)
C-----------------------------------------------------------------------
C   Initialize AIPS commons and read and check input adverbs.  Restart
C   AIPS if the DOWAIT adverb is true.
C
C   Output parameters:
C      IRET     I      Return status.
C                       0 -> success
C                       1 -> failed to read adverbs
C                       2 -> failed to restart AIPS
C                       3 -> bad input adverb
C
C   Output in /PARM/ (TVDIC.INC):
C      FLMSIZ   I      Film size
C                       0 -> 35mm
C                       1 -> 2"x2"
C                       2 -> 4"x5"
C      FLMTYP   I      Film type
C                      0 -> Colour positive
C                      1 -> colour negative
C                      2 -> B/W negative
C      COPIES   I     Number of copies to make (COPIES > 0)
C
C   Output in /CHPARM/ (TVDIC.INC)
C      OUTPRT   C*48  Name of the image file or blank (if blank
C                      image file will not be saved).
C      COMMNT   C*48  User comment for image.
C
C   Output in /TVDATA/ (TVDIC.INC)
C      GPMASK   I(MXGPLN)   GPMASK(I) is true if graphics plane (I)
C                           should be in the output image.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   SCRTCH(256), NPARM, JRET
      CHARACTER PRGM*6
      REAL      APARM(10), XCOPIS
      HOLLERITH XOUTPR(12), XCMMNT(12)
C
      PARAMETER (NPARM = 12 + 1 + 10 + 1 + 12)
      PARAMETER (PRGM = 'TVDIC')
C
      COMMON /ADVERB/ XOUTPR, APARM, XCOPIS, XCMMNT
C
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'TVDIC.INC'
C-----------------------------------------------------------------------
C                                       Initialize device
C                                       characteristics common:
      CALL ZDCHIN (.TRUE., SCRTCH)
C                                       Initialize catalogue pointer
C                                       common:
      CALL VHDRIN
C                                       Initialize files common:
      NSCR = 0
      NCFILE = 0
C                                       Assume success:
      IRET = 0
C                                       Get input adverbs:
      CALL GTPARM (PRGM, NPARM, RQUICK, XOUTPR, SCRTCH, JRET)
      IF (JRET.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT, 1000) JRET
         CALL MSGWRT (8)
         END IF
C
      IF (RQUICK) THEN
C                                       Restart AIPS:
         CALL RELPOP (IRET, SCRTCH, JRET)
         IF (JRET.NE.0) THEN
            IRET = 2
            WRITE (MSGTXT, 1001) JRET
            CALL MSGWRT (8)
            END IF
         END IF
C                                       Unpack input parameters:
      IF (IRET.EQ.0) THEN
         CALL H2CHR (48, 1, XOUTPR, OUTPRT)
         FLMSIZ = NINT (APARM(1))
         IF ((FLMSIZ.LT.0) .OR. (FLMSIZ.GT.2)) THEN
            IRET = 3
            WRITE (MSGTXT, 1002) FLMSIZ
            CALL MSGWRT(8)
            END IF
         FLMTYP = NINT (APARM(2))
         IF ((FLMTYP.LT.0) .OR. (FLMTYP.GT.2)) THEN
            IRET = 3
            WRITE (MSGTXT, 1003) FLMTYP
            CALL MSGWRT (8)
            END IF
         COPIES = NINT (XCOPIS)
         IF (COPIES.LT.1) THEN
            COPIES = 1
         ELSE IF (COPIES.GT.999) THEN
            IRET = 3
            WRITE (MSGTXT, 1004) 999
            CALL MSGWRT (8)
            END IF
         CALL H2CHR (48, 1, XCMMNT, COMMNT)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FAILED TO READ ADVERBS: GTPARM ERROR ', I7)
 1001 FORMAT ('FAILED TO RESTART AIPS: RELPOP ERROR ', I2)
 1002 FORMAT ('INVALID FILM SIZE (APARM(1) = ', I5, ')')
 1003 FORMAT ('INVALID FILM TYPE (APARM(2) = ', I5, ')')
 1004 FORMAT ('TOO MANY COPIES REQUESTED (<', I4, ')')
      END
      SUBROUTINE DCINIT (IRET)
C-----------------------------------------------------------------------
C   Open the TV, read the TV parameters, open the image file and
C   write the image file header.
C
C   Output:
C      IRET      I      Return status
C                          0 -> success
C                          1 -> could not open TV
C                          2 -> internal array too small
C                          3 -> could not read current window
C                          4 -> could not read LUTs
C                          5 -> could not read OFMs
C                          6 -> could not read active planes
C                          6 -> could not open Dicomed file
C
C   Outputs in /TVDATA/ (TVDIC.INC)
C      WINDOW    I(4)   Current BLC (elements 1 and 2) and TRC
C                       (elements 3 and 4) of current TV viewport
C      LUTDAT    I(MAXLUT, 3, MAXPLN)
C                       Red (,1,), green (,2,), and blue (,3,)
C                       LUTs for each grey-scale plane.
C      OFMDAT    R(MAXOFM, 3)
C                       Red (,1), green (,2) and blue (,3) OFMs.
C      RBITS     I(MAXPLN)
C      GBITS     I(MAXPLN)
C      BBITS     I(MAXPLN)
C                       Red, green and blue plane bit masks.
C-----------------------------------------------------------------------
      INTEGER   IRET, SCRTCH(256)
C
      INTEGER   JRET, IPLANE, ICHAN, BPPIX, XSPLT, YSPLT, RCHANS(4),
     *   GCHANS(4), BCHANS(4), I
      INCLUDE   'INCS:DDCH.INC'
      INCLUDE   'INCS:DMSG.INC'
      INCLUDE   'INCS:DTVC.INC'
      INCLUDE   'TVDIC.INC'
C-----------------------------------------------------------------------
C                                       Assume success:
      IRET = 0
C                                       Open the TV device:
      CALL TVOPEN (SCRTCH, JRET)
      IF (JRET.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT, 1000) JRET
         CALL MSGWRT (8)
         END IF
C
      IF (IRET.EQ.0) THEN
C                                       Check that the internal arrays
C                                       are large enough for this
C                                       TV device:
         IF (NGRAY.GT.MAXPLN) THEN
            IRET = 2
            WRITE (MSGTXT, 1001) MAXPLN
            CALL MSGWRT (8)
            END IF
         IF (NGRAPH.GT.MXGPLN) THEN
            IRET = 2
            WRITE (MSGTXT, 1002) MXGPLN
            CALL MSGWRT (8)
            END IF
         IF ((MAXINT+1).GT.MAXLUT) THEN
            IRET = 2
            WRITE (MSGTXT, 1003) MAXLUT
            CALL MSGWRT (8)
            END IF
         IF ((OFMINP+1).GT.MAXOFM) THEN
            IRET = 2
            WRITE (MSGTXT, 1004) MAXOFM
            CALL MSGWRT (8)
            END IF
         END IF
C
      IF (IRET.EQ.0) THEN
C                                       Read current TV window:
         CALL YWINDO ('READ', WINDOW, JRET)
         IF (JRET.NE.0) THEN
            IRET = 3
            WRITE (MSGTXT, 1005) JRET
            CALL MSGWRT (8)
            END IF
         END IF
C
      IF (IRET.EQ.0) THEN
C                                       Check that the line buffer
C                                       is large enough to hold one
C                                       row from the current window:
         IF ((WINDOW(3)-WINDOW(1)+1).GT.MAXROW) THEN
            IRET = 2
            WRITE (MSGTXT, 1006) MAXROW
            CALL MSGWRT (8)
            END IF
         END IF
C
      IF (IRET.EQ.0) THEN
C                                       Read look-up table for each
C                                       grey-scale plane:
         DO 10 IPLANE = 1, NGRAY
            ICHAN = 2 ** (IPLANE-1)
            CALL YLUT ('READ', ICHAN, 4, .TRUE., LUTDAT(1, 1, IPLANE),
     *                 JRET)
            IF (JRET.NE.0) THEN
               IRET = 4
               WRITE (MSGTXT, 1007) JRET
               CALL MSGWRT (8)
               GO TO 999
               END IF
            CALL YLUT ('READ', ICHAN, 2, .TRUE., LUTDAT(1, 2, IPLANE),
     *                 JRET)
            IF (JRET.NE.0) THEN
               IRET = 4
               WRITE (MSGTXT, 1007) JRET
               CALL MSGWRT (8)
               GO TO 999
               END IF
            CALL YLUT ('READ', ICHAN, 1, .TRUE., LUTDAT(1, 3, IPLANE),
     *                 JRET)
            IF (JRET.NE.0) THEN
               IRET = 4
               WRITE (MSGTXT, 1007) JRET
               CALL MSGWRT (8)
               GO TO 999
               END IF
 10         CONTINUE
         END IF
C
      IF (IRET.EQ.0) THEN
C                                       Read OFMs:
         CALL YOFM ('READ', 4, .TRUE., OFMDAT(1, 1), JRET)
         IF (JRET.NE.0) THEN
            IRET = 5
            WRITE (MSGTXT, 1010) JRET
            CALL MSGWRT (8)
            GO TO 999
            END IF
         CALL YOFM ('READ', 2, .TRUE., OFMDAT(1, 2), JRET)
         IF (JRET.NE.0) THEN
            IRET = 5
            WRITE (MSGTXT, 1010) JRET
            CALL MSGWRT (8)
            GO TO 999
            END IF
         CALL YOFM ('READ', 1, .TRUE., OFMDAT(1, 3), JRET)
         IF (JRET.NE.0) THEN
            IRET = 5
            WRITE (MSGTXT, 1010) JRET
            CALL MSGWRT (8)
            GO TO 999
            END IF
         END IF
C
      IF (IRET.EQ.0) THEN
C                                       Find out which grey-scale
C                                       planes are enabled.
         CALL YSPLIT ('READ', XSPLT, YSPLT, RCHANS, GCHANS, BCHANS,
     *                .TRUE., JRET)
         IF (JRET.NE.0) THEN
            IRET = 6
            WRITE (MSGTXT, 1011) JRET
            CALL MSGWRT (8)
         ELSE
            CALL ZGTBIT(NGRAY, RCHANS(1), RBITS)
            CALL ZGTBIT(NGRAY, GCHANS(1), GBITS)
            CALL ZGTBIT(NGRAY, BCHANS(1), BBITS)
            END IF
         END IF
C                                       which graphics planes
      I = TVLIMG(1) / (2 ** NGRAY)
      CALL ZGTBIT (NGRAPH, I, GPMASK)
C
      IF (IRET.EQ.0) THEN
C                                       Open image file:
         IF (FLMTYP.EQ.2) THEN
            BPPIX = 8
         ELSE
            BPPIX = 24
            END IF
         CALL ZDICOP (DICLUN, SYSNAM, NLUSER, FLMSIZ, FLMTYP,
     *                COPIES, BPPIX, (WINDOW(3)-WINDOW(1)+1),
     *                (WINDOW(4)-WINDOW(2)+1), COMMNT, JRET)
         IF (JRET.NE.0) THEN
            IRET = 7
            WRITE (MSGTXT, 1012) JRET
            CALL MSGWRT (8)
            END IF
         END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CAN NOT OPEN TV: TVOPEN ERROR ', I3)
 1001 FORMAT ('TOO MANY GREY-SCALE PLANES FOR TVDIC (> ', I2, ')')
 1002 FORMAT ('TOO MANY GRAPHICS PLANES FOR TVDIC (> ', I2, ')')
 1003 FORMAT ('LUTS TOO LARGE FOR TVDIC (> ', I4, ' ENTRIES)')
 1004 FORMAT ('OFMS TOO LARGE FOR TVDIC (> ', I4, ' ENTRIES)')
 1005 FORMAT ('COULD NOT READ WINDOW: YWINDO ERROR ', I2)
 1006 FORMAT ('TV WINDOW TOO WIDE (> ', I5, ' PIXELS)')
 1007 FORMAT ('CAN NOT READ LUT: YLUT ERROR ', I2)
 1010 FORMAT ('CAN NOT READ OFM: YOFM ERROR ', I2)
 1011 FORMAT ('CAN NOT READ PLANE MASK: YSPLIT ERROR ', I2)
 1012 FORMAT ('CAN NOT OPEN OUTPUT FILE: ZDICOP ERROR ', I2)
      END
      SUBROUTINE CPSCRN (IRET)
C-----------------------------------------------------------------------
C   Copy the image on the screen to the output file.
C
C   Output:
C      IRET      I           Return status
C                              0 -> success
C                              1 -> can not read TV
C                              2 -> error writing file
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   JRET
      INTEGER   I, J, IROW, WIDTH
      REAL      RED, GREEN, BLUE
C                                       Scaling factor from OFM output
C                                       to film recorder input.
      REAL      SCALE
      PARAMETER (SCALE = 255.0)
C
      INCLUDE   'INCS:DDCH.INC'
      INCLUDE   'INCS:DMSG.INC'
      INCLUDE   'INCS:DTVC.INC'
      INCLUDE   'TVDIC.INC'
C
      INTEGER   ROUT(MAXROW), GOUT(MAXROW), BOUT(MAXROW)
      INTEGER   ROW(MAXROW)
      INTEGER   GCOLOR(3, MXGPLN)
C-----------------------------------------------------------------------
      IRET = 0
C                                       Calculate window width:
      WIDTH = WINDOW(3) - WINDOW(1) + 1
C                                       Set graphics plane colours:
      DO 10 I = 1, NGRAPH
         CALL YGRAFX ('READ', I, RED, GREEN, BLUE, JRET)
         IF (JRET.NE.0) THEN
            IRET = 1
            WRITE (MSGTXT, 1000) JRET
            CALL MSGWRT (8)
            GO TO 999
            END IF
         GCOLOR(1, I) = SCALE * RED
         GCOLOR(2, I) = SCALE * GREEN
         GCOLOR(3, I) = SCALE * BLUE
C                                       Adjust to bright white or black
C                                       if producing a greyscale image.
         IF ((FLMTYP.EQ.2) .AND. ((RED.GT.0.5).OR.(GREEN.GT.0.5).OR.
     *                            (BLUE.GT.0.5))) THEN
            GCOLOR(1, I) = SCALE
            GCOLOR(2, I) = SCALE
            GCOLOR(3, I) = SCALE
            END IF
   10    CONTINUE
C                                       Read each row in the window:
      DO 100 IROW = WINDOW(4), WINDOW(2), -1
C                                       Rows are reversed for efficiency
C                                       in writing Dicomed file.
C
C                                       Clear accumulators:
         DO 20 I = 1, WIDTH
            ROUT(I) = 0
            GOUT(I) = 0
            BOUT(I) = 0
   20       CONTINUE
C                                       Read grey-scale planes:
C                                       (Inner loop should vectorize.)
C                                       (Outer loop may be
C                                       parallelized.)
         DO 40 I = 1, NGRAY
            IF ((RBITS(I).NE.0) .OR. (GBITS(I).NE.0)
     *          .OR. (BBITS(I).NE.0)) THEN
               CALL YIMGIO('READ', I, WINDOW(1), IROW, 0, WIDTH, ROW,
     *                    JRET)
               IF (JRET.NE.0) THEN
                  IRET = 1
                  WRITE (MSGTXT, 1020) JRET
                  CALL MSGWRT (8)
                  GO TO 999
                  END IF
               DO 30 J = 1, WIDTH
                  ROUT(J) = ROUT(J) + RBITS(I) * LUTDAT(ROW(J), 1, I)
                  GOUT(J) = GOUT(J) + GBITS(I) * LUTDAT(ROW(J), 2, I)
                  BOUT(J) = BOUT(J) + BBITS(I) * LUTDAT(ROW(J), 3, I)
   30             CONTINUE
               END IF
   40       CONTINUE
C                                       Apply OFM (vectorizable):
         DO 50 I = 1, WIDTH
            ROUT(I) = NINT (SCALE * OFMDAT(ROUT(I), 1))
            GOUT(I) = NINT (SCALE * OFMDAT(GOUT(I), 2))
            BOUT(I) = NINT (SCALE * OFMDAT(BOUT(I), 3))
   50       CONTINUE
C                                       Add in requested graphics
C                                       overlays:
C                                       Planes are read in reverse order
C                                       since plane i should overlay
C                                       plane i+1.
C                                       (Inner loop should vectorize)
C                                       (Outer loop can NOT be made
C                                       parallel)
         DO 70 I = NGRAPH, 1, -1
            IF (GPMASK(I).GT.0) THEN
               CALL YIMGIO('READ', I + NGRAY, WINDOW(1), IROW, 0, WIDTH,
     *                     ROW, JRET)
               IF (JRET.NE.0) THEN
                  IRET = 1
                  WRITE (MSGTXT, 1020) JRET
                  CALL MSGWRT (8)
                  GO TO 999
                  END IF
               DO 60 J = 1, WIDTH
                  IF (ROW(J).NE.0) THEN
                     ROUT(J) = GCOLOR(1, I)
                     GOUT(J) = GCOLOR(2, I)
                     BOUT(J) = GCOLOR(3, I)
                     END IF
   60             CONTINUE
               END IF
   70       CONTINUE
C                                       Write out the finished row:
            CALL ZDICIO(DICLUN, FLMTYP, IROW-WINDOW(2)+1, ROUT, GOUT,
     *                  BOUT, WIDTH, JRET)
         IF (JRET.NE.0) THEN
            IRET = 2
            WRITE (MSGTXT, 1070) JRET
            CALL MSGWRT (8)
            GO TO 999
            END IF
C
  100    CONTINUE
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT('CAN NOT READ TV: YGRAFX ERROR ', I4)
 1020 FORMAT('CAN NOT READ TV: YIMGIO ERROR ', I2)
 1070 FORMAT('CAN NOT WRITE OUTPUT: ZDICIO ERROR ', I2)
      END
      SUBROUTINE TVDFIN (IRET)
C-----------------------------------------------------------------------
C   Close Dicomed output file and TV device and spool the Dicomed file
C   if necessary.
C
C   Output:
C      IRET        I         Return status
C                              0 -> success
C                              1 -> could not close TV
C                              2 -> could not close output file
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   JRET, SCRTCH(256)
C
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'TVDIC.INC'
C-----------------------------------------------------------------------
C                                       Close TV:
      CALL TVCLOS (SCRTCH, JRET)
      IF (JRET.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT, 1000) JRET
         CALL MSGWRT (8)
         END IF
C                                       If the program ran successfully
C                                       then close Dicomed file and
C                                       spool it to the film recorder if
C                                       that was requested.
      IF (IRET.EQ.0) THEN
         CALL ZDICCL (DICLUN, OUTPRT, JRET)
         IF (JRET.NE.0) THEN
            IRET = 2
            WRITE (MSGTXT, 1001) JRET
            CALL MSGWRT (8)
            END IF
         END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CAN NOT CLOSE TV: TVCLOS ERROR ', I3)
 1001 FORMAT ('CAN NOT CLOSE OUTPUT FILE: ZDICCL ERROR ', I2)
      END

LOCAL INCLUDE 'VBMRG.INC'
C                                       Local include for VBMRG
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   CATBLK(256), CATIN(256), SEQIN, SEQOUT, DISKIN, DISKO,
     *   NUMHIS,  JBUFSZ, LRECU, ILOCWT
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, HISCRD(4)*64
      REAL      XSIN, XDISIN, XSOUT, XDISO, YINC,
     *   BUFF1(UVBFSS), BUFF2(UVBFSS)
      LOGICAL   ISCOMP
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
      COMMON /INPTS/ XNAMEI, XCLAIN, XSIN, XDISIN,
     *   XNAMOU, XCLAOU, XSOUT, XDISO, YINC,
     *   SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS, LRECU, ISCOMP, ILOCWT
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, HISCRD
      COMMON /MAPHDR/ CATBLK
      COMMON /OLDHDR/ CATIN
LOCAL END
      PROGRAM VBMRG
C-----------------------------------------------------------------------
C! Merge uv records, remove redundant data
C# UV VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000, 2006, 2008-2009, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   VBMRG consolidates a VLBI uv data set.  Data must be initially in
C   baseline-time order ('BT') and the last visibility with the highest
C   weight for each correlator will be passes.  All data from the same
C   visibility will be combined into the same record.  Thus VBMRG will
C   remove redundant correlations of the same data and combine polar-
C   ization data into the same record.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input UV data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      YINC           YINC          Integration time (sec) min=0.2
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'VBMRG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'VBMRG '/
C-----------------------------------------------------------------------
C                                       Initialize I/O
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      TSKNAM = PRGM
C                                       Get input parameters and
C                                       create output file if nec.
      IRET = 0
      CALL VMRGIN (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL VMRGUV (IRET)
      IF (IRET.EQ.0) CALL VMRGHI
C                                       Close down
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE VMRGIN (JERR)
C-----------------------------------------------------------------------
C   VMRGIN gets input parameters for VBMRG and creates an output file
C   if necessary.
C   Inputs:
C      See prologue comments in VBMRG for more details.
C-----------------------------------------------------------------------
      CHARACTER STAT*4, BLANK*6, UTYPE*2
      HOLLERITH CATH(256)
      INTEGER   OLDCNO, IROUND, JERR, NPARM, IERR
      REAL      CATR(256)
      INCLUDE 'VBMRG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATR, CATH, CATBLK)
      DATA BLANK /'      '/
C-----------------------------------------------------------------------
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 15
      CALL GTPARM (TSKNAM, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (8)
         JERR = 8
         RQUICK = .FALSE.
         GO TO 999
         END IF
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
      YINC = MAX (0.2, YINC) / 86400.0
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       Restart AIPS.
      IERR = 0
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (6)
         END IF
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1015) IERR, NAMEIN, CLAIN, SEQIN, DISKIN, NLUSER
         CALL MSGWRT (8)
         JERR = 5
         GO TO 999
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (8)
         JERR = 5
         GO TO 999
         END IF
C                                       Copy old CATBLK
      CALL COPY (256, CATBLK, CATIN)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Disallow packed uv data
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
         LRECU = LREC * 3 - 2 * NRPARM
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
      ELSE
         LRECU = LREC
         END IF
C                                       Check if sort order 'BT'
      IF (ISORT.NE.'BT') THEN
         WRITE (MSGTXT,1050) ISORT
         JERR = 5
         GO TO 990
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT(1:12), KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT(1:6), KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) THEN
         WRITE (MSGTXT,1060) IERR
         JERR = 8
         GO TO 990
C                                        Update existing CATBLK
      ELSE IF (IERR.EQ.2) THEN
         FRW(NCFILE+1) = 2
         CALL CATIO ('WRIT', DISKO, CCNO, CATBLK, 'WRIT', BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1070) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                        Put input file in READ
      UTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
      GO TO 999
c
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('VMRGIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' RESTARTING AIPS')
 1015 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1020 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('SORT ORDER ',A2,' NOT BT AS REQUIRED')
 1060 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1070 FORMAT ('VMRGIN: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE VMRGUV (IRET)
C-----------------------------------------------------------------------
C   VMRGUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Output:
C      IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER OFILE*48, IFILE*48
      INTEGER   IRET, INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, LRECO,
     *   ILENBU, KBIND, NIOUT, NIOLIM, IBIND, I, BO, VO, NUMVIS, XCOUNT,
     *   NCORU
      LOGICAL   T, F
      INCLUDE 'VBMRG.INC'
      REAL       VBUFF(UVBFSL)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA VO, BO /0,1/
      DATA LUNI, LUNO /16,17/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1060) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1070) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
C                                       LRECO = length of output rec.
      LRECO = LREC
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1080) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1090) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
      NCORU = (LRECU - NRPARM) / 3
C                                       Loop
C                                       Read vis. record.
 95   CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
      ELSE IF (INIO.GT.0) THEN
         IPTRI = IBIND
         DO 190 I = 1,INIO
            NUMVIS = NUMVIS+1
C                                      Call user routine.
            IF (ISCOMP) THEN
               CALL RCOPY (NRPARM, BUFF1(IPTRI), VBUFF)
               CALL ZUVXPN (NCORU, BUFF1(IPTRI+NRPaRM),
     *            BUFF1(IPTRI+ILOCWT), VBUFF(NRPARM+1))
               CALL VMERGE (NUMVIS, BUFF1(IPTRI+ILOCT),
     *            VBUFF(1+NRPARM), VBUFF(1), IRET)
            ELSE
               CALL VMERGE (NUMVIS, BUFF1(IPTRI+ILOCT),
     *            BUFF1(IPTRI+NRPARM), BUFF1(IPTRI), IRET)
               END IF
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1.0D0
C                                       Copy to output.
               IF (ISCOMP) THEN
                  CALL RCOPY (NRPARM, VBUFF, BUFF2(IPTRO))
                  CALL ZUVPAK (NCORu, VBUFF(NRPARM+1),
     *               BUFF2(IPTRO+ILOCWT), BUFF2(IPTRO+NRPARM))
               ELSE
                  CALL RCOPY (LRECU, BUFF1(IPTRI), BUFF2(IPTRO))
                  END IF
               IPTRO = IPTRO + LREC
               NIOUT = NIOUT + 1
               END IF
            IPTRI = IPTRI + LREC
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1160) IRET
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
         GO TO 95
         END IF
C                                       Final call to VMERGE.
      NUMVIS = -1
      CALL VMERGE (NUMVIS, BUFF2(IPTRO+ILOCT), BUFF2(IPTRO+NRPARM),
     *   BUFF2(IPTRO), IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
      ELSE IF (IRET.EQ.0) THEN
         XCOUNT = XCOUNT + 1
         IPTRO = IPTRO+LRECO
         NIOUT = NIOUT + 1
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1160) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1060 FORMAT ('VMRGUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1070 FORMAT ('VMRGUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1080 FORMAT ('VMRGUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1090 FORMAT ('VMRGUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('VMRGUV: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('VMRGUV: VMERGE ERROR',I3)
 1160 FORMAT ('VMRGUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE VMRGHI
C-----------------------------------------------------------------------
C  VMRGHI copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP(1)*2, HILINE*72, LABEL*8
      INTEGER   LUN1, LUN2, NONOT, IERR
      LOGICAL   T
      INCLUDE 'VBMRG.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN1,LUN2/27,28/
      DATA  T /.TRUE./
      DATA NONOT, NOTTYP /0,'  '/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.LE.2) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (5)
         GO TO 20
C                                       New history
 10   CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
C                                      Add any user supplied history.
      IF (NUMHIS.LE.0) GO TO 20
         WRITE (LABEL,1010) TSKNAM
         HILINE = LABEL // HISCRD(1)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 20
 20   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO,
     *   FCNO(2), FCNO(1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.LE.2) GO TO 30
         WRITE (MSGTXT,1020) IERR
         IF (IERR.EQ.4) WRITE (MSGTXT,1021)
         CALL MSGWRT (6)
C                                        Update CATBLK.
 30   CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST', BUFF1,
     *   IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VMRGHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,' /')
 1020 FORMAT ('VMRGHI: ERROR',I3,' COPYING ANTENNA FILE')
 1021 FORMAT ('VMRGHI: NO ANTENNA FILES COPIED DESPITE INPUT HEADER')
      END
      SUBROUTINE VMERGE (NUMVIS, T, VIS, RPARM, IRET)
C-----------------------------------------------------------------------
C  VMERGE compresses a (VLBI) dataset.  The last, highest weight value
C  for each correlator is kept.
C  Inputs:
C     NUMVIS   I      Visibility number, -1 => final call, no data
C                     passed but allows any operations to be completed.
C                     Data sent back will be wirtten to output file.
C     T        R      Time in days since 0 on the first day for which
C                     there is data.
C     RPARM    R(*)   Random parameter array which includes U,V,W etc
C                     but also any other random parameters. followed by
C                     VIS data in 1 LRECU long array
C     VIS      R(3,*) Visibilities in order real, imaginary, weight (Jy)
C  Inputs from COMMON
C     NRPARM   I      # random parameters.
C     NCOR     I      # correlators
C     CATBLK   I(256) Catalog header record. See [DOC]HEADER for details
C  Output:
C     RPARM    R(*)    Modified random parameter array. NB U,V,W,
C                      time and baseline should not be modified in RPARM
C                      followed by VIS data in 1 LRECU long array
C     IRET     I       Return code  -1 => don't write
C                                0 => OK
C                               >0 => error, terminate.
C  Output in COMMON
C     NUMHIS     I    # history entries (max. 10)
C     HISCRD(16) R   History records
C     CATBLK     I    Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IRET
      REAL      T, VIS(3,*), RPARM(*)
C                                       XVBLEN = Length of record buffer
      INTEGER   LUNSS, JERR, INDEX, IDAY, MCOR, I, XCOUNT, XVBLEN,
     *   ITEMP, ANVER
      LOGICAL   SAMEB
      INCLUDE 'INCS:ZPBUFSZ.INC'
      PARAMETER (XVBLEN = UVBFSL)
      REAL   VBUFF(XVBLEN), TEMP, CATR(256), AMP1, AMP2, CT, TLAST
      DOUBLE PRECISION CATD(128), X8
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'VBMRG.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANT.INC'
      EQUIVALENCE (CATBLK, CATR, CATD)
      SAVE VBUFF, XCOUNT, TLAST, MCOR
      DATA LUNSS /27/
C-----------------------------------------------------------------------
      IRET = -1
C                                       initial call
      IF (NUMVIS.EQ.1) THEN
         XCOUNT = 0
C                                        Get Time - UTC
         DATUTC = 0.0
         ANVER = 1
         CALL ANTINI ('READ', VBUFF, FVOL(NCFILE), FCNO(NCFILE), ANVER,
     *      CATIN, LUNSS, IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0,
     *      DEGPDY, SAFREQ,RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME,
     *      XYZHAN, TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, JERR)
         CALL TABIO ('CLOS', 1, IANRNO, VBUFF, VBUFF, JERR)
         CT = T - DATUTC
         IDAY = CT
         X8 = (CT-IDAY) / YINC
         TLAST = IDAY + DINT (X8) * YINC + YINC
C                                        First vis., copy to buffer.
         CALL RCOPY (LRECU, RPARM(1), VBUFF(1))
         MCOR = (LRECU - NRPARM) / 3
C                                        Check that LREC .le. XVBLEN
         IF (LRECU.GT.XVBLEN) THEN
            ITEMP = XVBLEN
            WRITE (MSGTXT,1100) LRECU, ITEMP
            CALL MSGWRT (8)
            IRET = 8
            GO TO 999
            END IF
         END IF
C                                        Next datum.
      IF (NUMVIS.GE.1) THEN
         CT = T - DATUTC
C                                        Check time and baseline.
         IF (ILOCB.GE.0) THEN
            SAMEB = RPARM(1+ILOCB).EQ.VBUFF(1+ILOCB)
         ELSE
            SAMEB = (RPARM(1+ILOCA1).EQ.VBUFF(1+ILOCA1)) .AND.
     *         (RPARM(1+ILOCA2).EQ.VBUFF(1+ILOCA2)) .AND.
     *         (RPARM(1+ILOCSA).EQ.VBUFF(1+ILOCSA))
            END IF
         IF ((CT.LE.TLAST) .AND. (SAMEB)) THEN
C                                        "Old" vis. - compress
            DO 20 I = 1,MCOR
               INDEX = NRPARM + (I - 1)*3 + 1
C                                       Compare amplitudes iff
C                                       equal weights.
               IF (VIS(3,I).EQ.VBUFF(INDEX+2)) THEN
                  AMP1 = VBUFF(INDEX)*VBUFF(INDEX) + VBUFF(INDEX+1)*
     *               VBUFF(INDEX+1)
                  AMP2 = VIS(1,I)*VIS(1,I) + VIS(2,I)*VIS(2,I)
                  IF (AMP1.LT.0.25*AMP2) VBUFF(INDEX+2) = -10
                  IF (AMP2.LT.0.25*AMP1) VIS(3,I) = -10
                  END IF
               IF (VIS(3,I).GE.VBUFF(INDEX+2)) THEN
                  VBUFF(INDEX) = VIS(1,I)
                  VBUFF(INDEX+1) = VIS(2,I)
                  VBUFF(INDEX+2) = VIS(3,I)
                  END IF
 20            CONTINUE
C                                        "New" vis. - write
         ELSE
            XCOUNT = XCOUNT + 1
            DO 30 I = 1,LRECU
               TEMP = VBUFF(I)
               VBUFF(I) = RPARM(I)
               RPARM(I) = TEMP
 30            CONTINUE
            IDAY = CT
            X8 = (CT-IDAY) / YINC
            TLAST = IDAY + DINT(X8) * YINC + YINC
            IRET = 0
            END IF
C                                         Last datum.
      ELSE
         XCOUNT = XCOUNT + 1
         CALL RCOPY (LRECU, VBUFF, RPARM)
C                                        Write no. written to history.
         NUMHIS = 1
         WRITE (HISCRD,1999) XCOUNT
         WRITE (MSGTXT,1999) XCOUNT
         CALL MSGWRT (5)
         IRET = 0
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('RECORD LENGTH= ',I5,' GREATER THAN ',I5)
 1999 FORMAT (I10,' Visibility records written')
      END

      SUBROUTINE TABBD (OPCODE, BUFFER, IBDRNO, BDKOLS, BDNUMV, NUMIF,
     *   NUMFRQ, NUMPOL, TIME, SOURID, SUBA, ANT1, ANT2, FREQID,
     *   BNDPAS, IERR)
C-----------------------------------------------------------------------
C! Does I/O to BLCHN/BLPCL bandpass (BD) table opened by BDINI
C# EXT-util UV Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 2009, 2013, 2015, 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to bandpass (BD) extention tables. Usually used after
C   setup by BDINI.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'READ' = read entry from table.
C                        'WRIT' = write entry in table.
C                        'CLOS' = close file, flush on write
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open. Should have been returned by
C                        BDINI or TABINI.
C      IBDRNO   I        Next entry number to read or write.
C      BDKOLS   I(MAXBDC) The column pointer array in order,
C                        TIME, SOURID, SUBARRAY, ANTENNA1, ANTENNA2,
C                        FREQID, REAL1, IMAG1,
C                        Following used if 2 polarizations per IF
C                        REAL2, IMAG2.
C      BDNUMV   I(MAXBDC) Element count in each column.
C      NUMIF    I        Number of IF's
C      NUMFRQ   I        Number of chns
C      NUMPOL   I        Number of polarizations per IF.
C   Input/output: (written to or read from baseline file)
C      TIME    R(2)     Time range of record (Days)
C      SOURID  I        Source ID number.
C      SUBA    I        Subarray number.
C      ANT     I        Antenna number.
C      FREQID  I        Freq. id number
C      BNDPAS  C(n,m,p) Complex bandpass: m IFS; n channels; p polns
C   Output:
C      IBDRNO    I      Next solution number.
C      IERR      I      Error code, 0=>OK else TABIO error.
C                       Note: -3=> all flagged
C-----------------------------------------------------------------------
      INTEGER   MAXBDC
      PARAMETER (MAXBDC = 14)
C
      CHARACTER OPCODE*4
      INTEGER   BUFFER(*), IBDRNO, BDKOLS(MAXBDC), BDNUMV(MAXBDC),
     *   NUMIF, NUMFRQ, NUMPOL, SOURID, SUBA, ANT1, ANT2, FREQID, IERR
      REAL      TIME(2), BNDPAS(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   XBDRSZ
      PARAMETER (XBDRSZ = 6 + 8*MAXCIF)
C
      INTEGER   RECI(XBDRSZ), KOLS(MAXBDC), TIMKOL, SOUKOL, SUBKOL, J,
     *   ANT1KL, ANT2KL, FRQKOL, LOOP, NDATA, BDCNT, INDX, NNDX, RKOL,
     *   IKOL
      REAL      RECORD(XBDRSZ)
      DOUBLE PRECISION RECD(XBDRSZ/2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      SAVE RECORD
      EQUIVALENCE (KOLS(1), TIMKOL), (KOLS(2), SOUKOL),
     *   (KOLS(3), SUBKOL), (KOLS(4), ANT1KL), (KOLS(5), ANT2KL),
     *   (KOLS(6), FRQKOL)
      EQUIVALENCE (RECD, RECORD, RECI)
C-----------------------------------------------------------------------
      BDCNT = 0
C                                       Close
      IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, IBDRNO, RECORD, BUFFER, IERR)
         IF (IERR.GT.0) GO TO 980
         GO TO 999
         END IF
C                                       Check sizes
      NNDX = NUMPOL * NUMFRQ * NUMIF
      IF (NNDX.GT.MAXCIF) THEN
         IERR = 1
         MSGTXT = 'TABBD: RECORDS TOO BIG FOR BUFFERS'
         GO TO 985
         END IF
      IF (NNDX.LE.0) THEN
         IERR = 1
         MSGTXT = 'TABBD: ZERO SIZE DATA REQUESTED'
         GO TO 985
         END IF
      IF (NUMPOL.GT.4) THEN
         IERR = 1
         MSGTXT = 'TABBD: > 4 POLARIZATIONS IN BANDPASS TABLE!'
         GO TO 985
         END IF
C                                       Set pointers
      NDATA = MAXBDC
      CALL COPY (NDATA, BDKOLS, KOLS)
      NNDX = NUMFRQ * NUMIF
C                                       If write fill RECORD
      IF (OPCODE.NE.'READ') THEN
         RECORD(TIMKOL) = TIME(1)
         RECORD(TIMKOL+1) = TIME(2)
         RECI(SOUKOL) = SOURID
         RECI(SUBKOL) = SUBA
         RECI(ANT1KL) = ANT1
         RECI(ANT2KL) = ANT2
         IF (FRQKOL.GT.0) RECI(FRQKOL) = FREQID
C                                       All polarizations
         INDX = 0
         DO 30 J = 1,NUMPOL
            RKOL = KOLS(5+2*J)
            IKOL = KOLS(6+2*J)
            DO 20 LOOP = 1,NNDX
               INDX = INDX + 1
               RECORD(RKOL) = BNDPAS(INDX)
               INDX = INDX + 1
               RECORD(IKOL) = BNDPAS(INDX)
               RKOL = RKOL + 1
               IKOL = IKOL + 1
 20            CONTINUE
 30         CONTINUE
         END IF
C                                       Process record.
      CALL TABIO (OPCODE, 0, IBDRNO, RECORD, BUFFER, IERR)
      IBDRNO = IBDRNO + 1
      IF (IERR.GT.0) GO TO 980
C                                       If READ pick data from RECORD.
      IF (OPCODE.EQ.'READ') THEN
         TIME(1) = RECORD(TIMKOL)
         TIME(2) = RECORD(TIMKOL+1)
         SOURID = RECI(SOUKOL)
         SUBA   = RECI(SUBKOL)
         ANT1    = RECI(ANT1KL)
         ANT2    = RECI(ANT2KL)
         IF (FRQKOL.LE.0) THEN
            FREQID = 1
         ELSE
            FREQID = RECI(FRQKOL)
            END IF
C                                       First polarization
         INDX = 0
         DO 90 J = 1,NUMPOL
            RKOL = KOLS(5+2*J)
            IKOL = KOLS(6+2*J)
            DO 80 LOOP = 1,NNDX
               INDX = INDX + 1
               BNDPAS(INDX) = RECORD(RKOL)
               INDX = INDX + 1
               BNDPAS(INDX) = RECORD(IKOL)
               IF ((RECORD(RKOL).EQ.FBLANK) .OR.
     *            (RECORD(IKOL).EQ.FBLANK)) BDCNT = BDCNT + 1
               RKOL = RKOL + 1
               IKOL = IKOL + 1
 80            CONTINUE
 90         CONTINUE
         END IF
      IF (BDCNT.EQ.(NUMPOL*NUMIF*NUMFRQ)) IERR = -3
      GO TO 999
C                                       Error
 980  WRITE (MSGTXT,1980) IERR
C
 985  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('TABBD: TABIO ERROR',I3)
      END

LOCAL INCLUDE 'PVBPLT.INC'
C                                       Parameter include for VBPLT
      INTEGER   MAXCC
C                                       MAXCC = max. no. model
C                                       components.
      PARAMETER (MAXCC = 10000)
LOCAL END
LOCAL INCLUDE 'VBPLT.INC'
C                                       Local include for VBPLT
      INCLUDE 'PVBPLT.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:DMSG.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAM2I(3), XCLA2I(2), XXSTOK,
     *   XXSOUR(4,30), XXCALC, XPPLOT(2), XOPTYP
      CHARACTER NAMEIN*12, CLAIN*6, NAM2IN*12, CLA2IN*6, XSTOK*4,
     *   STANAM(MAXANT)*8, XSOUR(30)*16, XCALCO*4, PPLOT*8, OPTYPE*4
      REAL      USERID, XSIN, XDISIN, XS2IN, XDI2IN, XBCHAN, XECHAN,
     *   XBIF, XEIF, XINC, UVRANG(2), XTIME(8), XANT(50), XBASE(50),
     *   YTYPE, SOLINT, BPARM(10), XINV2, XNIT, XSUBA, XDOTV, XGRCH,
     *   XQUAL, XBAND, XFREQ, XFQID, XDOCAL, XGUSE, XDOPOL, XBLVER,
     *   XFLAG, XDOBND, XBPVER, XSMOTH(3), XSYM, XLABEL
      REAL      BUFF1(UVBFSS), XPOS(MAXCC), YPOS(MAXCC), SFLUX(MAXCC),
     *   GAUSA(MAXCC), GAUSB(MAXCC), GAUSC(MAXCC),
     *   ZTERM, IATUTC, UT1XXX
      INTEGER   JBUFSZ, NUMCC, NANT, NSRC, IDN(30), OLDCNO,
     *   CATKEP(256)
      LOGICAL   DOGAUS, DOSPHE, DOTV, MULTI, DOAVG, AMPVEC
      REAL      TBEG, TFIN, XYSCL(2), XYOFF(2), XYVALS(MAXANT,MAXANT),
     *   TIMMIN, TIMMAX, CHOUT(4)
      INTEGER   IAW1, IAW2, INC, SEQIN, DISKIN, LUNI, INDI, NPARMS,
     *   TYPEAX(2), NCH, IBIF, VER2, TESTEM(2), POLPLT, IPOLPT,
     *   OKDAT(MAXANT,MAXANT), ANTS(50), BASE(50), ISUB, NBASE,
     *   ANT1(MXBASE), ANT2(MXBASE), GRCHN, TVCHN, TVCORN(4),
     *   CHNSEL(3,10), NUMBAS, ANTLAB(MXBASE,2), DTYPE, LABEL
      LOGICAL   UVREV, SCALEM(2), NOUVR, FLOTEM, DROPEM, DOERRB,
     *   DECICL, INDECL
      DOUBLE PRECISION XB(MAXANT), YB(MAXANT), ZB(MAXANT), JDREF,
     *   AFREQ, GST0, ANLONG, OBSRA, OBSDEC
C                                       WARNING: many of these commons
C                                       are declared locally with
C                                       variables of different names!!!
      COMMON /INPARM/ USERID, XNAMEI, XCLAIN, XSIN, XDISIN,
     *   XNAM2I, XCLA2I, XS2IN, XDI2IN, XINV2, XNIT, XXSOUR, XQUAL,
     *   XXCALC, XBAND, XFREQ, XFQID, XBCHAN, XECHAN, XBIF, XEIF, XINC,
     *   UVRANG, XTIME, XXSTOK, XANT, XBASE, XDOCAL, XGUSE, XDOPOL,
     *   XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH, XSUBA, YTYPE,
     *   SOLINT, XOPTYP, BPARM, XPPLOT, XSYM, XLABEL, XDOTV, XGRCH
      COMMON /BUFRS/ BUFF1, JBUFSZ
      COMMON /VBPCOM/ TBEG, TFIN, XYSCL, XYOFF, XYVALS, TIMMIN,
     *   TIMMAX, UVREV, SCALEM, NOUVR, FLOTEM, DROPEM, IAW1, IAW2, INC,
     *   SEQIN, DISKIN, LUNI, INDI, TYPEAX, NCH, IBIF, VER2, TESTEM,
     *   OKDAT, POLPLT, IPOLPT, ANTS, BASE, ISUB, NBASE, ANT1, ANT2,
     *   GRCHN, TVCHN, TVCORN, NSRC, IDN, OLDCNO, CATKEP, NUMBAS,
     *   ANTLAB, DTYPE, CHNSEL, DOTV, DOERRB, MULTI, DOAVG, AMPVEC,
     *   DECICL, INDECL, NPARMS, LABEL, CHOUT
      COMMON /CANIN/ XB, YB, ZB, JDREF, AFREQ, GST0, ANLONG,
     *   OBSRA, OBSDEC, IATUTC, UT1XXX, NANT
      COMMON /COMPS/ XPOS, YPOS, SFLUX, GAUSA, GAUSB, GAUSC,
     *   ZTERM, DOGAUS, DOSPHE, NUMCC
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAM2IN, CLA2IN, XSTOK, STANAM,
     *   XSOUR, XCALCO, PPLOT, OPTYPE
LOCAL END
      PROGRAM VBPLT
C-----------------------------------------------------------------------
C! Plots selected uv data and model values.
C# UV Plot-appl VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   VBPLT plots uv data . A 'PL' extension file is made which can
C   be displayed in the usual ways .
C   Inputs:
C     USERID                       UV data file owner #
C     INNAME         NAMEIN        Name of input UV data.
C     INCLASS        CLAIN         Class of input UV data.
C     INSEQ          SEQIN         Seq. of input UV data.
C     INDISK         DISKIN        Disk number of input UV data.
C     IN2NAME        NAM2IN        CLEAN components file name.
C     IN2CLASS       CLA2IN        CLEAN components file class.
C     IN2SEQ         XS2IN         CLEAN components file sequence no.
C     IN2DISK        XDI2IN        CLEAN components file disk no.
C     IN2VERS        XINV2         CLEAN components file version no.
C     NITER          XNIT          Number of Clean Components.
C     BCHAN          BCHAN         Start channel for averaging
C     ECHAN          ECHAN         End channel for averaging
C     BIF            BIF           Start IF number for averaging
C     EIF            EIF           End IF number for averaging
C     XINC.......Skip this number of vis. records between plotting.
C     UVRANGE....Range of UV projected spacings to include (Klambda)
C     TIMERANG...Selection parameters:
C        1 = Start IAT day (day 0 = first day in data base)
C        2 = Start IAT hour
C        3 = Start IAT minute
C        4 = Start IAT second
C        5 = Stop IAT day (day 0 = first day in data base)
C        6 = Stop IAT hour
C        7 = Stop IAT minute
C        8 = Stop IAT second
C     STOKES....Stokes' type
C     ANTENNAS..Antenna numbers
C     BASELINE..Baselines.
C     YTYPE.....If > 0, plot error bars
C     SOLINT....pre-average time (mins)
C     BPARM......Control parameters:
C        1 = type of X-axis (where  1 = amplitude (Jy), 2 = phase
C           (degrees), 3 = u,v distance (klambda), 4 = u,v p.a.
C           (degrees, clockwise from v-axis), 5 = time (iat days),
C           6 = u, 7 = v, 8 = w (all in klambda), 9 = real part (Jy),
C           10 = imaginary part(Jy), and 11 = folded G.S.T.(hours),
C           12 = time (IAT hms), 13 = source no.,
C           14 = freqid, 15 = int. time, 16 = weight,
C           17 = RMS) 0 => 12
C        2 = type of Y-axis
C        3 = Do not autoscale if non-zero, use following values:
C        4 = Minimum of X-axis,
C        5 = Maximum of X-axis,
C        6 = Minimum of Y-axis.
C        7 = Maximum of Y-axis,
C        8 = Maximum number of plots per page (min 1)
C        9 = Interferometer type (where 0 = VLBI, 1 = VLA,
C            2 = MERLIN, 3 = WSRT)
C       10 > 0  => plot missing baselines (if there's a model)
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, MAXPLT
      INCLUDE 'VBPLT.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'VBPLT '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL VBPIN (PRGM, MAXPLT, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       determine scaling
      CALL SCALVB (MAXPLT, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Do plots
      CALL VBPLOT (MAXPLT, IRET)
      IRET = MAX (0, IRET)
C                                       Close down
 995  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE VBPIN (PRGM, MAXPLT, JERR)
C-----------------------------------------------------------------------
C   VBPIN gets input parameters for VBPLT .
C   Inputs:  PRGM   C*6       Program name
C   Output:  JERR   I         Error code: 0 => ok, else quit
C            MAXPLT I         Maximum number of plots per page.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, STOKTY(8)*4, UTYPE*2, STAT*4
      CHARACTER BLANK*4, AUTO*4, CROS*4
      INTEGER  JERR, MAXPLT, IERR, ITEMP, LIM1, NSTOK,
     *   IUSER, I, VER, L, J, MXANT, LUNA, NUMAN(2000), IROUND,
     *   LUN
      REAL      CATR(256), EPS
      LOGICAL   DOMODL, MATCH, TRYMOD, DESEL
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'VBPLT.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANS.INC'
      EQUIVALENCE (CATR, CATBLK)
      EQUIVALENCE (NUMAN, YPOS)
      DATA MXANT /MAXANT/
      DATA NSTOK, STOKTY /8,'RR  ','LL  ','RL  ','LR  ','I   ','Q   ',
     *   'U   ','V   '/
      DATA BLANK, AUTO, CROS /'    ', 'AUTO', 'CROS'/
C-------------------------------------------------------------------
C                                       Init IO et al.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      CALL SELINI
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARMS = 288
      CALL GTPARM (PRGM, NPARMS, RQUICK, USERID, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         JERR = 8
         RQUICK = .TRUE.
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
      WRITE (MSGTXT,4000)
      CALL MSGWRT (2)
C                                       Crunch input parameters.
      EPS = 0.1
      IUSER = ABS(USERID) + EPS
      IF (IUSER.EQ.0) IUSER = NLUSER
      IF (IUSER.EQ.32000) IUSER = 0
      IF (XINC.LT.1.0) XINC = 1.0
      INC = XINC + EPS
      SEQIN = XSIN + EPS
      DISKIN = XDISIN + EPS
      ISUB = XSUBA + EPS
      SUBARR = ISUB
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAM2I, NAM2IN)
      CALL H2CHR (6, 1, XCLA2I, CLA2IN)
      CALL H2CHR (4, 1, XXSTOK, XSTOK)
      CALL H2CHR (4, 1, XXSTOK, STOKES)
      CALL H2CHR (4, 1, XXCALC, XCALCO)
      CALL H2CHR (8, 1, XPPLOT, PPLOT)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      IF (XSYM.LT.0.0) XSYM = 0.0
      IF (XSYM.GT.1.0) XSYM = 1.0
C                                       'cros' or 'auto'
      IF ((OPTYPE .EQ. CROS) .OR. (OPTYPE .EQ. BLANK)) THEN
         DOACOR = .FALSE.
         DOXCOR = .TRUE.
      ELSE
         DOACOR = .TRUE.
         DOXCOR = .FALSE.
      END IF
      TRYMOD = ((NAM2IN(1:4).NE.'    ') .OR. (CLA2IN.NE.'      '))
C                                       Timerange
      TBEG = XTIME(1) + (XTIME(2)+(XTIME(3)+XTIME(4)/60.)/60.)/24.
      TFIN = XTIME(5) + (XTIME(6)+(XTIME(7)+XTIME(8)/60.)/60.)/24.
C                                       Test time, UV ranges
      IF (TFIN.LE.TBEG) TFIN = 1.0E10
      IF (UVRANG(2).LE.UVRANG(1)) UVRANG(2) = 1.0E10
      NOUVR = ABS (UVRANG(2) - UVRANG(1)) .LT. 0.01
      UVRANG(1) = UVRANG(1) * 1.0E3
      UVRANG(2) = UVRANG(2) * 1.0E3
C                                       Test type of plot
      IF ((BPARM(1).LT.1.0) .OR. (BPARM(1).GT.17.0)) BPARM(1) = 12.0
      IF ((BPARM(2).LT.1.0) .OR. (BPARM(2).GT.17.0)) BPARM(2) = 1.0
      IF ((BPARM(1).NE.3) .AND. ((BPARM(1).LT.6) .OR. (BPARM(1).GT.8)))
     *   GO TO 30
         BPARM(4) = BPARM(4) * 1.0E3
         BPARM(5) = BPARM(5) * 1.0E3
   30 IF ((BPARM(2).NE.3) .AND. ((BPARM(2).LT.6) .OR. (BPARM(2).GT.8)))
     *      GO TO 35
         BPARM(6) = BPARM(6) * 1.0E3
         BPARM(7) = BPARM(7) * 1.0E3
   35 XYSCL(1) = -1.0E10
      XYSCL(2) = XYSCL(1)
      XYOFF(1) = 1.E10
      XYOFF(2) = XYOFF(1)
      LIM1 = MXANT - 1
      DO 50 I = 1,LIM1
         L = I+1
         DO 40 J = L,MXANT
            XYVALS(I,J) = XYSCL(2)
            XYVALS(J,I) = XYOFF(2)
            OKDAT(I,J) = 1
            OKDAT(J,I) = 1
   40       CONTINUE
   50    CONTINUE
      DECICL = .FALSE.
C                                       If plotting uv only
C                                       then plot conjugate points
      ITEMP = BPARM(1) * BPARM(2) + 0.1
      UVREV = (ITEMP.EQ.42) .OR. (ITEMP.EQ.48) .OR. (ITEMP.EQ.56)
C                                       Autoscale ?
      SCALEM(1) = (BPARM(3).LE.0.0) .OR. (BPARM(4).EQ.BPARM(5))
      SCALEM(2) = (BPARM(3).LE.0.0) .OR. (BPARM(6).EQ.BPARM(7))
      DROPEM = (BPARM(9).LE.0.0)
      TESTEM(1) = 1
      IF (BPARM(4).GT.BPARM(5)) TESTEM(1) = -1
      IF ((BPARM(3).EQ.0.0) .OR. (BPARM(4).EQ.BPARM(5))) TESTEM(1) = 0
      TESTEM(2) = 1
      IF (BPARM(6).GT.BPARM(7)) TESTEM(2) = -1
      IF ((BPARM(3).EQ.0.0) .OR. (BPARM(6).EQ.BPARM(7))) TESTEM(2) = 0
      FLOTEM = (BPARM(3).EQ.0.0) .AND. (TESTEM(2).EQ.0)
C                                       Get CATBLK from file.
      DOERRB = YTYPE.GT.0.0
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = 1
      LABEL = IROUND (XLABEL)
      IF ((LABEL.EQ.0) .OR. (ABS(LABEL).GT.10)) LABEL = 3
      IF (LABEL.GT.7) LABEL = 7
      IF ((LABEL.GE.4) .AND. (LABEL.LE.6)) LABEL = 3
      IF (LABEL.LT.-7) LABEL = -7
      IF ((LABEL.LE.-4) .AND. (LABEL.GE.-6)) LABEL = -3
      CALL FILL (4, 0, TVCORN)
      LUNI = 16
      UTYPE = 'UV'
      OLDCNO = 1
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1030) JERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      XSIN = SEQIN
      XDISIN = DISKIN
      USERID = IUSER
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      CALL COPY (256, CATBLK, CATKEP)
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      IUDISK = UDISK
      IUCNO = OLDCNO
      NSRC = 0
      DO 75 I = 1,30
         SOURCS(I) = ' '
         CALL H2CHR (16, 1, XXSOUR(1,I), SOURCS(I))
         IF (SOURCS(I)(1:4).NE.'    ') NSRC = NSRC + 1
         CALSOU(I) = ' '
 75      CONTINUE
      SELQUA = IROUND (XQUAL)
      SELCOD = XCALCO
      CALL RCOPY (8, XTIME, TIMRNG)
      CALL RCOPY (2, UVRANG, UVRNG)
      DOCAL = XDOCAL.GT.0.0
      DOPOL = IROUND (XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      DOWTCL = .TRUE.
      BLVER = IROUND (XBLVER)
      FGVER = IROUND (XFLAG)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BPVER = IROUND (XBPVER)
      DOBAND = IROUND (XDOBND)
C                                       Spectral smoothing
      CALL RCOPY (3, XSMOTH, SMOOTH)
C                                       Multi-source
      CALL MULSDB (CATBLK, MULTI)
C                                       Check pre-average time
      SOLINT = SOLINT / 1440.0
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1070)
         JERR = 1
         CALL MSGWRT (6)
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       Test channel #
      BCHAN = IROUND (XBCHAN)
      BCHAN = MAX (1, MIN (BCHAN, CATBLK(KINAX+JLOCF)))
      ECHAN = IROUND (XECHAN)
      IF (ECHAN.EQ.0) ECHAN = BCHAN
      IF (ECHAN.LT.BCHAN) ECHAN = BCHAN
      ECHAN = MAX (1, MIN (ECHAN, CATBLK(KINAX+JLOCF)))
      DOAVG = ECHAN.GT.BCHAN
      IF (DOAVG) THEN
         WRITE (MSGTXT,1040) BCHAN, ECHAN
         CALL MSGWRT (6)
         END IF
      CALL FILL (30, 0, CHNSEL)
      CHNSEL(1,1) = 1
      CHNSEL(2,1) = CATBLK(KINAX+JLOCF)
      XBCHAN = BCHAN
      XECHAN = ECHAN
C                                       IF number
      IF (JLOCIF.GE.0) THEN
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, CATBLK(KINAX+JLOCIF)))
         EIF = IROUND (XEIF)
           IF (EIF.EQ.0) EIF = BIF
         IF (EIF.LT.BIF) EIF = BIF
         IF (BIF.GT.EIF) EIF = CATBLK(KINAX+JLOCIF)
         EIF = MAX (1, MIN (EIF, CATBLK(KINAX+JLOCIF)))
      ELSE
         BIF = 1
         EIF = 1
         END IF
      IF (.NOT.DOAVG) DOAVG = EIF.GT.BIF
      IF (EIF.GT.BIF) THEN
         WRITE (MSGTXT,1050) BIF, EIF
         CALL MSGWRT (6)
         END IF
      XBIF = BIF
      XEIF = EIF
C                                       Save results in input Parms
 90   TYPEAX(1) = BPARM(1) + EPS
      TYPEAX(2) = BPARM(2) + EPS
C                                       scalar avg. for weight
      AMPVEC = .FALSE.
      IF (TYPEAX(2) .EQ. 16) THEN
         AMPVEC = .TRUE.
         DTYPE = 3
         END IF
      IF (TYPEAX(2).EQ.1) DTYPE = 0
      IF (TYPEAX(2).EQ.2) DTYPE = 1
      IF (TYPEAX(2).EQ.17) DTYPE = 2
      DOMODL = (TYPEAX(1).NE.1) .AND. (TYPEAX(1).NE.2) .AND.
     *   (TYPEAX(1).NE.9) .AND. (TYPEAX(1).NE.10) .AND.
     *   ((TYPEAX(2).EQ.1) .OR. (TYPEAX(2).EQ.2) .OR. (TYPEAX(2).EQ.9)
     *   .OR. (TYPEAX(2).EQ.10))
C                                       Block model when can't handle
      IF (DOMODL .AND. MULTI .AND. (NSRC.NE.1)) THEN
         IF (TRYMOD) THEN
            WRITE (MSGTXT,1110)
            CALL MSGWRT (6)
            WRITE (MSGTXT,1120)
            CALL MSGWRT (6)
            WRITE (MSGTXT,1130)
            CALL MSGWRT (6)
            DOMODL = .FALSE.
            END IF
         END IF
      IF (.NOT.DOMODL) THEN
         DROPEM = .TRUE.
         XNIT = 0.
         NUMCC = 0
         END IF
C                                       Find baselines to plot
      LUNA = 28
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LE.0) SUBARR = 1
      CALL GETNAN (DISKIN, OLDCNO, CATBLK, LUNA, XPOS, NUMAN, JERR)
      IF (JERR.NE.0) GO TO 999
      CALL GETANT (DISKIN, OLDCNO, SUBARR, CATBLK, BUFF1, JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Fill in list of all antenna
C                                       - baseline pairs and names
      IF (.NOT.DOACOR) THEN
         NBASE = MXBASE
         CALL BASLST (NUMAN, SUBARR, XANT, XBASE, NBASE, ANT1, ANT2)
      ELSE IF (DOACOR) THEN
         NBASE = 0
         DO 100 I = 1,50
            ANT1(I) = IROUND (XANT(I))
            IF (ANT1(I).LT.0) DESEL = .TRUE.
            ANT1(I) = ABS(XANT(I))
            IF (ANT1(I).GT.0) THEN
               NBASE = NBASE + 1
               ANT2(I) = ANT1(I)
               END IF
  100       CONTINUE
         IF (ANT1(1).EQ.0) THEN
            NBASE = NUMAN(SUBARR+1)
            DO 120 I = 1, NBASE
               ANT1(I) = TELNO(I)
               ANT2(I) = ANT1(I)
  120          CONTINUE
            END IF
         END IF
C                                       Maximum number of
C                                       plots per page
      MAXPLT = 3
      IF (BPARM(8).GE.0.95) MAXPLT = BPARM(8) + EPS
      IF ((NBASE.EQ.1) .AND. ((ANT1(1).NE.0) .AND. (ANT2(1).NE.0)))
     *   MAXPLT = 1
      BPARM(8) = MAXPLT
C                                       Get antenna info.
      VER = XSUBA + 0.01
      CALL ANTIN (VER, BCHAN, IBIF, DISKIN, OLDCNO, FRQSEL, JERR)
      IF (JERR.NE.0) GO TO 999
      XSUBA = VER
C                                       Get CLEAN components.
      VER2 = XINV2 + 0.01
      IF (DOMODL) THEN
         IF (MULTI .AND. TRYMOD) THEN
            WRITE (MSGTXT,1100)
            CALL MSGWRT (6)
            WRITE (MSGTXT,1101)
            CALL MSGWRT (6)
            WRITE (MSGTXT,1102)
            CALL MSGWRT (6)
            CALL SOURNU (SOURCS, SELQUA, 1, DISKIN, OLDCNO, NSRC,
     *         BUFF1, IDN, JERR)
            CALL GETSOU (IDN(1), DISKIN, OLDCNO, CATBLK, LUN, JERR)
            RA = RAEPO * RAD2DG
            DEC = DECEPO * RAD2DG
            END IF
         CALL REEDIN (VER2, JERR)
         END IF
      IF (NUMCC.LE.0) DROPEM = .TRUE.
      XINV2 = VER2
      GO TO 999
C
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VBPIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1040 FORMAT ('Averaging from channel ',I4,'-',I4)
 1050 FORMAT ('Averaging from IF ',I4,'-',I4)
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
 1080 FORMAT ('Trying to plot indep. cl. phases, but ANTENNAS is ',
     *   'non - zero')
 1090 FORMAT ('Set ANTENNAS adverb array to 0')
 1100 FORMAT ('WARNING: You are attempting to plot a model against')
 1101 FORMAT ('         multi-source data, make sure you select the')
 1102 FORMAT ('         correct source and CC file.')
 1110 FORMAT ('You may be trying to plot a model without specifying')
 1120 FORMAT ('a sourcename - I do not allow that and am switching')
 1130 FORMAT ('that option off.')
 4000 FORMAT ('You are using a non-standard program')
      END
      SUBROUTINE SCALVB (MAXPLT, IRET)
C-----------------------------------------------------------------------
C   SCALVB sends uv points one at a time to XYOFF .
C   IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INCLUDE 'VBPLT.INC'
      INTEGER   IRET, MAXPLT, IARR, IARRW, I, NUMTEM,
     *   IA1, IA2, ILAST, MXANT, LOOP
      INTEGER   NUMVIS, XUMVIS, NUMFRQ, IPOL, ITIME(8), SCANUM
      REAL      XY(2), RPARM(20), SCANV(MXBASE), AVTIM, AVU, AVV, AVW,
     *   DMULT
      LOGICAL   GOOD, NOSCAL, NOACHK, KEEP, NUSCAN
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA MXANT /MAXANT/
C-----------------------------------------------------------------------
      RPARM(1) = FBLANK
      NOSCAL = (.NOT.SCALEM(1)) .AND. (.NOT.SCALEM(2))
      IRET = 0
      IF ((NOSCAL) .AND. (.NOT.DROPEM)) GO TO 999
      IARRW = ISUB
      IF (DROPEM) THEN
         DO 5 IA1 = 1,MXANT
            DO 5 IA2 = 1,MXANT
               OKDAT(IA1,IA2) = -1
 5          CONTINUE
         END IF
C                                       Check if valid POLTYP
      CALL COPY (256, CATBLK, CATUV)
      CALL POLCHK (PPLOT, POLPLT)
      IF (POLPLT.GT.0) THEN
         IF ((POLPLT.EQ.3) .OR. (POLPLT.EQ.6)) THEN
            STOKES='HALF'
         ELSE
            STOKES='FULL'
            END IF
         END IF
C                                       Set up for time
C                                       averaging
      IF (SOLINT.GT.0.0) THEN
         CALL COLSET (ANT1, ANT2, DISKIN, OLDCNO, NUMBAS, ANTLAB,
     *      IPOL, IRET)
         IF (IRET.GT.1) THEN
            WRITE (MSGTXT,1010) IRET
            GO TO 990
            END IF
C                                       ANTLAB(I,*) for 'auto'
         IF (DOACOR) THEN
            NUMBAS = NBASE
            DO 7 I = 1, MXANT
               IF (I .LE. NUMBAS) THEN
                  ANTLAB(I,1) = ANT1(I)
                  ANTLAB(I,2) = ANT2(I)
                  ANTENS(I) = ANT2(I)
               ELSE
                  ANTLAB(I,1) = 0
                  ANTLAB(I,2) = 0
                  ANTENS(I) = 0
                  END IF
    7          CONTINUE
            END IF
         END IF
C                                       Init vis file for read.
      CALL UVGET ('INIT', RPARM, BUFF1, IRET)
      IF (IRET.EQ.-1) GO TO 200
      IF (IRET.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IRET
         GO TO 990
 10   NUMVIS = 0
      XUMVIS = 0
C                                       Setup for antenna selection
      IAW1 = 0
      IAW2 = 0
      NOACHK =  (NBASE.EQ.1) .AND. (ANT1(1).EQ.0)
C                                       Loop
 100  CONTINUE
      IF (SOLINT.EQ.0.0) THEN
C                                       Read vis. record.
         CALL UVGET ('READ', RPARM, BUFF1, IRET)
         IF (IRET.EQ.-1) GO TO 200
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
C                                       Spectral averaging
         IF (DOAVG) THEN
            NUMFRQ = CATBLK(KINAX+JLOCF)
            NUMTEM = CATBLK(KINAX+JLOCS)
            CALL AVGCIF (BUFF1, NUMTEM, NUMFRQ, BCHAN, ECHAN, BIF,
     *         EIF, CHNSEL, KNCS, BUFF1)
            END IF
C                                       Modify VIS as appropriate
C                                       based on POLPLT.
         IF (POLPLT.GT.0) CALL POLVIS (BUFF1, POLPLT, IPOLPT)
C                                       Pick up some points
         IA1 = RPARM(1+ILOCB) / 256.
         IA2 = RPARM(1+ILOCB) - IA1*256. + 0.1
         NUMVIS = NUMVIS + 1
         KEEP = MOD(NUMVIS,INC) .EQ. 0
         IF (.NOT. KEEP) GO TO 100
C                                       Get array #
         IARR = (RPARM(1+ILOCB)-IA1*256.0-IA2) * 100.0 + 1.1
         RPARM(1+ILOCT) = RPARM(1+ILOCT) - (IARR-1)*5.
C                                       Check if desired array
         IF ((IARRW.NE.0) .AND. (IARR.NE.IARRW)) GO TO 130
C                                       Test antennas
         IF (NOACHK) GO TO 120
         DO 115 LOOP = 1,NBASE
            IF ((IA1.EQ.ANT1(LOOP)) .AND. ((IA2.EQ.ANT2(LOOP))
     *         .OR. (0.EQ.ANT2(LOOP)))) GO TO 120
 115        CONTINUE
C                                       Not wanted
         GO TO 130
C                                       Is this a valid point ?
 120     CALL WANTED (BUFF1, RPARM, IA1, IA2, GOOD)
C                                       Find scales
         IF ((.NOT.GOOD) .OR. (NOSCAL)) GO TO 130
         CALL FNDXY (BUFF1, RPARM, XY)
         CALL XYSCAL (NUMVIS, XY, MAXPLT, IA1, IA2, IRET)
         IF (IRET.LT.0) GO TO 130
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1110) IRET
            GO TO 990
            END IF
         XUMVIS = XUMVIS + 1
         OKDAT(IA1,IA2) = 1
         OKDAT(IA2,IA1) = 1
 130     ILAST = I
         IF ((NOSCAL) .AND. (GOOD)) OKDAT(IA1,IA2) = 1
         IF ((NOSCAL) .AND. (GOOD)) OKDAT(IA2,IA1) = 1
 150     CONTINUE
         GO TO 100
         END IF
C
      IF (SOLINT.GT.0.0) THEN
C                                       Read vis. recs and form
C                                       averages
         CALL BASAVG (NUMVIS, NUMBAS, ANTLAB, AMPVEC, DTYPE, SOLINT,
     *      CHNSEL, DOAVG, SCANV, ITIME, NUSCAN, SCANUM, RPARM,
     *      BUFF1, AVTIM, AVU, AVV, AVW, IRET)
         IF (IRET.LT.0) GO TO 200
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1100) IRET
            IRET = 4
            GO TO 990
            END IF
C                                       Pick up some points
         NUMVIS = NUMVIS + 1
         KEEP = MOD(NUMVIS,INC) .EQ. 0
         IF (.NOT. KEEP) GO TO 100
C                                       Get array #
         IARR = SUBARR
         AVTIM = AVTIM - (IARR-1)*5.
C                                       Check if desired array
         IF ((IARRW.NE.0) .AND. (IARR.NE.IARRW)) GO TO 100
C                                       Find scales
         DMULT = 1.0
         IF (DTYPE.EQ.1) DMULT = RAD2DG
         IF (.NOT.NOSCAL) THEN
            DO 160 I = 1, NUMBAS
               IA1 = ANTLAB(I,1)
               IA2 = ANTLAB(I,2)
C                                       time interval
               IF ((SCANV(I).NE.FBLANK) .AND.
     *              (AVTIM .LE. TFIN) .AND.
     *              (AVTIM .GE. TBEG)) THEN
                  XY(1) = AVTIM
                  XY(2) = SCANV(I) * DMULT
                  CALL XYSCAL (NUMVIS, XY, MAXPLT, IA1, IA2,
     *               IRET)
                  OKDAT(IA1,IA2) = 1
                  OKDAT(IA2,IA1) = 1
                  END IF
 160           CONTINUE
            END IF
         XUMVIS = XUMVIS + 1
         GO TO 100
         END IF
C                                       Any points found
 200  IF (NOSCAL) GO TO 220
         IF (XUMVIS.GT.1) GO TO 210
            IRET = 4
            WRITE (MSGTXT,1200) XUMVIS
            GO TO 990
C                                       Final call to XYSCL.
 210     NUMVIS = -1
         CALL XYSCAL (NUMVIS, XY, MAXPLT, IA1, IA2, IRET)
         IF (IRET.LE.0) GO TO 220
            WRITE (MSGTXT,1110) IRET
            GO TO 990
 220  IRET = 0
      CALL UVGET ('CLOS', RPARM, BUFF1, IRET)
      CALL COPY (256, CATKEP, CATBLK)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SCALVB: ERROR',I3,' INIT VIS FILE')
 1010 FORMAT ('SCALVB: ERROR',I3,' SETTING UP TIME AVG PARAMETERS')
 1100 FORMAT ('SCALVB: ERROR',I3,' READING VIS FILE')
 1110 FORMAT ('SCALVB: XYSCL ERROR',I3)
 1200 FORMAT ('FOUND',I4,' POINTS: NOT ENOUGH TO SELF-SCALE')
      END
      SUBROUTINE VBPLOT (MAXPLT, IRET)
C-----------------------------------------------------------------------
C   VBPLOT plots the data thru calls to PLTVB.  Its function depends
C   on whether all baselines were desired, baselines to one antenna
C   were desired or one baseline was desired.
C   Inputs:
C      MAXPLT    I    The maximum number of plots per page.
C   Outputs:
C      IRET      I     Error code, 0=>OK otherwise failed.
C-----------------------------------------------------------------------
      INTEGER   MAXPLT, IRET, IA1, IA2, IPLOT, LIM1, LIM2, LOOP, NLOOP,
     *   ILOOP, JJ
      REAL      DMS, DMO
      INCLUDE 'VBPLT.INC'
      INCLUDE 'INCS:DSEL.INC'
      REAL      AN1LIS(MXBASE), AN2LIS(MXBASE)
      INTEGER MXANT
      DATA MXANT /MAXANT/
C-----------------------------------------------------------
      IRET = 0
      IPLOT = 0
      DMS = XYSCL(2)
      DMO = XYOFF(2)
C                                        Check type of plots desired.
      IF ((NBASE.GT.1) .AND. (ANT2(1).GT.0)) GO TO 500
      IAW1 = ANT1(1)
      IAW2 = ANT2(1)
      IF (IAW2.GT.0) GO TO 300
      IF (IAW1.GT.0) GO TO 200
C                                        All baselines.
 100  LIM1 = NANT
      NLOOP = 0
      DO 120 IA1 = 1,LIM1
         LIM2 = IA1
         DO 110 IA2 = LIM2,NANT
            IF (OKDAT(IA1,IA2).GT.0) THEN
               NLOOP = NLOOP + 1
               AN1LIS(NLOOP) = IA1
               AN2LIS(NLOOP) = IA2
               END IF
 110        CONTINUE
 120     CONTINUE
      IF (NLOOP.LE.0) GO TO 980
      ILOOP = 0
      DO 140 IA1 = 1,LIM1
         LIM2 = IA1 + 1
         DO 130 IA2 = LIM2,NANT
            IF (OKDAT(IA1,IA2).GT.0) THEN
               ILOOP = ILOOP + 1
               IAW1 = IA1
               IAW2 = IA2
               IPLOT = MOD (IPLOT, MAXPLT) + 1
               IF (IPLOT.EQ.1) THEN
                  JJ = MIN (NLOOP-ILOOP+1, MAXPLT)
                  CALL RFILL (50, 0.0, XANT)
                  CALL RCOPY (JJ, AN1LIS(ILOOP), XANT)
                  CALL RCOPY (JJ, AN2LIS(ILOOP), XBASE)
                  END IF
               IF (ILOOP.GE.NLOOP) IPLOT = -IPLOT
               IF (FLOTEM) THEN
                  XYSCL(2) = XYVALS(IA1,IA2)
                  XYOFF(2) = XYVALS(IA2,IA1)
                  END IF
               CALL PLTVB (IPLOT, MAXPLT, DMS, DMO, IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
 130        CONTINUE
 140     CONTINUE
      GO TO 999
C                                        All baselines to one antenna.
 200  NLOOP = 0
      DO 210 LOOP = 1,NBASE
         IA1 = ANT1(LOOP)
         IA1 = MIN (NANT, IA1)
         DO 205 IA2 = 1,NANT
            IF ((IA1.LE.IA2) .AND. (OKDAT(IA1,IA2).GT.0)) THEN
               NLOOP = NLOOP + 1
               AN1LIS(NLOOP) = IA1
               AN2LIS(NLOOP) = IA2
               END IF
 205        CONTINUE
 210     CONTINUE
      IF (NLOOP.LE.0) GO TO 980
      ILOOP = 0
      DO 230 LOOP = 1,NBASE
         IA1 = ANT1(LOOP)
         IA1 = MIN (NANT, IA1)
         DO 220 IA2 = 1,NANT
            IF ((IA1.LE.IA2) .AND. (OKDAT(IA1,IA2).GT.0)) THEN
               ILOOP = ILOOP + 1
               IAW1 = MIN (IA1, IA2)
               IAW2 = MAX (IA1, IA2)
               IPLOT = MOD (IPLOT, MAXPLT) + 1
               IF (IPLOT.EQ.1) THEN
                  JJ = MIN (NLOOP-ILOOP+1, MAXPLT)
                  CALL RFILL (50, 0.0, XANT)
                  CALL RCOPY (JJ, AN1LIS(ILOOP), XANT)
                  CALL RCOPY (JJ, AN2LIS(ILOOP), XBASE)
                  END IF
               IF (ILOOP.EQ.NLOOP) IPLOT = -IPLOT
               IF (FLOTEM) THEN
                  XYSCL(2) = XYVALS(IAW1,IAW2)
                  XYOFF(2) = XYVALS(IAW2,IAW1)
                  END IF
               CALL PLTVB (IPLOT, MAXPLT, DMS, DMO, IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
 220        CONTINUE
 230     CONTINUE
      GO TO 999
C                                        One baseline.
 300  IPLOT = -1
      IA1 = ANT1(1)
      IA2 = ANT2(1)
      IF (OKDAT(IA1,IA2).LE.0) GO TO 980
      IA1 = MIN (IA1, NANT)
      IA2 = MIN (IA2, NANT)
      IAW1 = MIN (IA1, IA2)
      IAW2 = MAX (IA1, IA2)

      XANT(1) = IA1
      XBASE(1) = IA2
      XANT(2) = 0.
      IF (FLOTEM) THEN
C                                       temporaly IAW2 = MXANT
         IF (DOACOR) IAW2 = MXANT
         XYSCL(2) = XYVALS(IAW1,IAW2)
         XYOFF(2) = XYVALS(IAW2,IAW1)
         END IF
      IF (DOACOR)    IAW2 = IAW1
      CALL PLTVB (IPLOT, MAXPLT, DMS, DMO, IRET)
      GO TO 999
C                                       Random baselines
C                                       Find last plot
 500  NLOOP = 0
      DO 520 LOOP = 1,NBASE
         IA1 = ANT1(LOOP)
         IA2 = ANT2(LOOP)
         IF (OKDAT(IA1,IA2).GT.0) THEN
            NLOOP = NLOOP + 1
            AN1LIS(NLOOP) = IA1
            AN2LIS(NLOOP) = IA2
            END IF
 520     CONTINUE
      IF (NLOOP.LE.0) GO TO 980
C                                       Do plots
      ILOOP = 0
      DO 540 LOOP = 1,NBASE
         IA1 = ANT1(LOOP)
         IA2 = ANT2(LOOP)
         IF (OKDAT(IA1,IA2).GT.0) THEN
            ILOOP = ILOOP + 1
            IAW1 = IA1
            IAW2 = IA2
            IPLOT = MOD (IPLOT, MAXPLT) + 1
            IF (IPLOT.EQ.1) THEN
               JJ = MIN (NLOOP-ILOOP+1, MAXPLT)
               CALL RFILL (50, 0.0, XANT)
               CALL RCOPY (JJ, AN1LIS(ILOOP), XANT)
               CALL RCOPY (JJ, AN2LIS(ILOOP), XBASE)
               END IF
            IF (ILOOP.GE.NLOOP) IPLOT = -IPLOT
            IF (FLOTEM) THEN
C                                       temporaly IA2=MXANT
               IF (DOACOR) IA2 = MXANT
               XYSCL(2) = XYVALS(IA1,IA2)
               XYOFF(2) = XYVALS(IA2,IA1)
               END IF
            IF (DOACOR) IA2 = IA1
            CALL PLTVB (IPLOT, MAXPLT, DMS, DMO, IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
 540     CONTINUE
      GO TO 999
C                                       No baselines
 980  IRET = 8
      WRITE (MSGTXT,1980)
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('VBPLOT: NO BASELINES TO BE PLOTTED')
      END
      SUBROUTINE PLTVB (IPLOT, MAXPLT, DMS, DMO, IRET)
C-----------------------------------------------------------------------
C   PLTVB actually plots uv data one panel at a time.
C   Input:
C      IPLOT    I    Plot number on current page. If negative then this
C                   the last plot.
C      MAXPLT   I    The number of plots per page.
C   In/out:           (Changed to user value on .not.scalem(2))
C      DMS      I    Scaling parameter for max y range
C      DMO      I    Low value parm for max y range
C   Output:
C      IRET     I    Return code, 0 => OK, otherwise abort.
C                          1 => failed to add to catalog
C                          2 => failed to create
C                          3 => graph file write error
C                          4 => UV file IO error
C-----------------------------------------------------------------------
      INCLUDE 'VBPLT.INC'
      CHARACTER TEXT*132, PFILE*48, ATIME*8, CHTMP*18, UTYPE*2,
     *   ADATE*12, VERSUS*4, CHFOR*8, ASTS*4, CTEMP*12, STAT*4,
     *   AUNITS(8)*8, CHTYPE(17)*8, CHCOR(8)*4, POLLAB*5
      HOLLERITH CATH(256)
      INTEGER   IRET, IPLOT, MAXPLT, I, IDUM, OBUFF(1024), ITIME(8),
     *   SCANUM, NUMTEM, LTYPE, BUFFER(256), VER, IERR, ITYPE, IPSIZE,
     *   LUNPL, FINDPL, IAPARM(8), INCHAR, INP, LENBU, IA1, IA2, JJJ, J,
     *   CPTRIP(3), IARR, IARRW, IAXLAB, IAPLOT, IT(3), ID(3),
     *   SVAXTP(2), VO, BO, NGOOD, NNOFIT, NUMVIS, IDX1, IDX2, NUMFRQ
      REAL      BLC(2), TRC(2), XYRATO, DX, DY, TR, TI, XY(2), SWT,
     *   CATR(256), SIZE, GWT, GERR, RPARM(20), XTRC(2), XBLC(2),
     *   TLC(2), PLTINC, YYOFF(2), XZY(2), DMS, DMO, XMULT(2), XMIN,
     *   XMAX, YMIN, YMAX, XTEMP, SCANV(MXBASE), AVTIM, AVU, AVV, AVW,
     *   DMULT, SRPARM(20)
      DOUBLE PRECISION    TRA, TDEC, DTORAD
      LOGICAL   T, F, GOOD, CATUP, KEEP, CHSTAT, NUSCAN
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (CATUV, CATR, CATH)
      DATA VO, BO, LENBU, LUNPL /0, 1, 16, 26/
      DATA T, F /.TRUE.,.FALSE./
      DATA VERSUS, CHFOR, ASTS /' vs ',' for    ','****'/
      DATA AUNITS /'Janskys ', 'Degrees ',  'Wavlngth',
     *   'Degrees ', 'IAT days', 'GST hrs ','Seconds',
     *   ' '/
      DATA CHTYPE /'Ampltude', 'Phase   ', 'UV dist ',
     *   'UV pa   ', 'Time    ', 'U       ', 'V      ',
     *   'W       ', 'Real    ', 'Imag    ', 'GST     ',
     *   'Time    ', 'Source #', 'Freqid  ', 'Int.time',
     *   'Weight  ', 'Rms     '/
      DATA CHCOR /'RR  ','LL  ','RL  ','LR  ','Ipol','Vpol','Qpol',
     *   'Upol'/
C-----------------------------------------------------------------------
      CALL UVGET ('INIT', RPARM, BUFF1, IERR)
      CALL RFILL (20, 0.0, RPARM)
      RPARM(1) = FBLANK
      XSTOK = STOKES
      IBIF = BIF
      IF (IERR.EQ.-1) GO TO 200
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         CALL MSGWRT (8)
         IRET = 4
         GO TO 970
         END IF
      DTORAD = 3.14159265358979326D0 / 180.0D0
      NGOOD = 0
      NNOFIT = 0
      IRET = 1
      CATUP = T
      IARRW = ISUB
C                                       Determine status of file
      UTYPE = 'UV'
      CHSTAT = .FALSE.
      CALL CATDIR ('INFO', DISKIN, OLDCNO, CTEMP, CTEMP, IDUM,
     *   UTYPE, IDUM, STAT, OBUFF, IRET)
      IF (STAT.EQ.'READ') THEN
C                                       Change status
         STAT = 'CLRD'
         CALL CATDIR ('CSTA', DISKIN, OLDCNO, CTEMP, CTEMP, IDUM,
     *      UTYPE, IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'CLRD'
            CALL MSGWRT (6)
            GO TO 999
            END IF
         STAT = 'WRIT'
         CALL CATDIR ('CSTA', DISKIN, OLDCNO, CTEMP, CTEMP, IDUM,
     *      UTYPE, IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'WRIT'
            CALL MSGWRT (6)
            GO TO 999
            END IF
         CHSTAT = .TRUE.
         END IF
C                                       User sets the scales
      PLTINC = 1000. / MAXPLT
      DO 10 I = 1,2
         IF (SCALEM(I)) GO TO 10
            XYSCL(I) = BPARM(3+2*I)
            XYOFF(I) = BPARM(2+2*I)
            IF (XYSCL(I).EQ.XYOFF(I)) GO TO 999
            SIZE = 1000.
            IF (I.EQ.2) SIZE = PLTINC
            XYSCL(I) = SIZE / (XYSCL(I) - XYOFF(I))
            IF (I.EQ.1) GO TO 10
               DMS = XYSCL(I)
               DMO = XYOFF(I)
 10      CONTINUE
C                                       Fill in last of actual parms
 20   BPARM(5) = 1000.0 / XYSCL(1) + XYOFF(1)
      BPARM(7) = PLTINC / XYSCL(2) + XYOFF(2)
      BPARM(4) = XYOFF(1)
      BPARM(6) = XYOFF(2)
      SCALEM(1) = T
      SCALEM(2) = T
      IF (FLOTEM) BPARM(6) = 0.0
      IF (FLOTEM) BPARM(7) = 0.0
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      XYRATO = 1.0
      CALL FILL (5, 1, IAPARM)
C                                       Set window for current plot.
      XBLC(1) = BLC(1)
      XBLC(2) = 1000.0 - ABS (IPLOT) * PLTINC
      XTRC(1) = TRC(1)
      XTRC(2) = XBLC(2) + PLTINC - 1.0
      TLC(1) = XBLC(1)
      TLC(2) = XTRC(2)
C                                       Offsets for current plot.
      YYOFF(1) = XBLC(1)
      YYOFF(2) = XBLC(2)
C                                       Set up location common
 40   LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      IF (TYPEAX(1).EQ.12) LABTYP(LOCNUM) = 7
      IF (TYPEAX(2).EQ.12) LABTYP(LOCNUM) = 70
      CALL COPY (2, TYPEAX, SVAXTP)
      AXTYP(LOCNUM) = 0
      TR = PLTINC / DMS
      TI = TR
      CPREF(2,LOCNUM) = ' '
      IF (TYPEAX(2).NE.12) CALL METSCA (TR, CPREF(2,LOCNUM), GOOD)
      IF (TYPEAX(2).NE.12) XMULT(2) = TR / TI
      IF (TYPEAX(2).EQ.12) XMULT(2) = 360.0
      TR = 1000. / XYSCL(1)
      TI = TR
      CPREF(1,LOCNUM) = ' '
      IF (TYPEAX(1).NE.12) CALL METSCA (TR, CPREF(1,LOCNUM), GOOD)
      IF (TYPEAX(1).NE.12) XMULT(1) = TR / TI
      IF (TYPEAX(1).EQ.12) XMULT(1) = 360.0
      DO 50 I = 1,2
         SIZE = 1000.0
         IF (I.EQ.2) SIZE = PLTINC
         TR = SIZE / XYSCL(I)
         RPLOC(I,LOCNUM) = XBLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I) * XMULT(I)
         AXINC(I,LOCNUM) = TR * XMULT(I) / (XTRC(I) - XBLC(I))
         IF (TYPEAX(I).NE.12) GO TO 45
            CTYP(I,LOCNUM) = AUNITS(5)
            TYPEAX(I) = 5
            GO TO 50
 45      IF (TYPEAX(I).GT.5) CTYP(I,LOCNUM) = AUNITS(3)
         IF (TYPEAX(I).LE.5) CTYP(I,LOCNUM) = AUNITS(TYPEAX(I))
         IF ((TYPEAX(I).EQ.9) .OR. (TYPEAX(I).EQ.10))
     *      CTYP(I,LOCNUM) = AUNITS(1)
         IF (TYPEAX(I).EQ.11) CTYP(I,LOCNUM) = AUNITS(6)
         IF (TYPEAX(I).GT.12) CTYP(I,LOCNUM) = AUNITS(8)
         IF (TYPEAX(I).EQ.15) CTYP(I,LOCNUM) = AUNITS(7)
         IF (TYPEAX(I).EQ.17) CTYP(I,LOCNUM) = AUNITS(1)
 50      CONTINUE
C                                       Blank bottom label.
      IF ((IPLOT.GE.0) .AND. (ABS (IPLOT).NE.MAXPLT)) THEN
         CPREF(1,LOCNUM) = ' '
         CTYP(1,LOCNUM) = ' '
         END IF
C                                       Determine STOKES label
      POLLAB = XSTOK
      IF (POLPLT.GT.0) THEN
         IF (POLPLT.EQ.1) POLLAB = 'RL/RR'
         IF (POLPLT.EQ.2) POLLAB = 'LR/RR'
         IF (POLPLT.EQ.3) POLLAB = 'LL/RR'
         IF (POLPLT.EQ.4) POLLAB = 'RL/LL'
         IF (POLPLT.EQ.5) POLLAB = 'LR/LL'
         IF (POLPLT.EQ.6) POLLAB = 'RR/LL'
         END IF
      CALL CHR2H (8, POLLAB, 1, XPPLOT)
C                                       Create plot file
      IF (ABS (IPLOT).EQ.1) THEN
C                                       Update catalog header.
         VER = 0
         IF (.NOT.DOTV) THEN
            CALL MADDEX ('PL', DISKIN, OLDCNO, CATUV, BUFFER, CATUP,
     *         'WRIT', VER, IERR)
            IF (IERR.NE.0) THEN
               NCFILE = NCFILE - 1
               GO TO 999
               END IF
            END IF
         CALL ZPHFIL ('PL', DISKIN, OLDCNO, VER, PFILE, IERR)
         IF (IERR.NE.0) GO TO 960
         IPSIZE = 0
         ITYPE = 10
         CALL GINIT (DISKIN, OLDCNO, PFILE, IPSIZE, ITYPE, NPARMS,
     *      USERID, DOTV, TVCHN, GRCHN, TVCORN, CATUV, BUFFER, LUNPL,
     *      FINDPL, IERR)
         IRET = 2
         IF (IERR.NE.0) GO TO 960
         CALL RFILL (4, 0.5, CHOUT)
C                                       Note that TICINC not fully
C                                       initialized as yet. -> INP being
C                                       larger than may be actually
C                                       plotted on this subplot.  This
C                                       is probably desirable.
         CALL CHNTIC (XBLC, XTRC, INP)
         INP = MAX (INP, 3)
         LTYPE = ABS (LABEL)
         IF (LTYPE.EQ.2) CHOUT(1) = 2.5
         IF (LTYPE.GT.2) CHOUT(1) = INP + 3
         IF (LTYPE.GT.1) CHOUT(2) = 2.0
         IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
         IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = 3.333
         IF ((LABEL.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = CHOUT(4) +
     *      1.333
C                                       Init for line drawing.
         IRET = 3
         CALL GINITL (BLC, TRC, XYRATO, CHOUT, IAPARM, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         IF (.NOT.DOTV) THEN
            WRITE (MSGTXT,1010) VER
            CALL MSGWRT (2)
            END IF
         END IF
      IRET = 3
      CATUP = T
C                                       Set max and min of axis
      XMAX = TRC(1) / XYSCL(1) + XYOFF(1)
      XMIN = BLC(1) / XYSCL(1) + XYOFF(1)
      YMAX = PLTINC / XYSCL(2) + XYOFF(2)
      YMIN = BLC(2) / XYSCL(2) + XYOFF(2)
C                                       Draw border
      CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Top labels: type & name
      IF ((ABS(IPLOT).EQ.1) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
C                                       Data information
         DX = 0.0
         DY = 0.5
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         WRITE (TEXT,1040) BIF, EIF, BCHAN, ECHAN, POLLAB, VER2
         CALL TRIM (TEXT, 132, TEXT, INP)
         INCHAR = INP
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Plot type and file
         TEXT = ' '
         DY = DY + 1.333
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         INCHAR = 8
         INP = 1
         TEXT = ' '
         TEXT(INP:INP+7) = CHTYPE(TYPEAX(2))(1:8)
         CALL TRIM (TEXT, INCHAR, TEXT, INP)
         INCHAR = INP + 12
         INP = INP + 1
         TEXT(INP:INP+3) = VERSUS(1:4)
         INP = INP + 4
         TEXT(INP:INP+7) = CHTYPE(TYPEAX(1))(1:8)
         CALL TRIM (TEXT, INCHAR, TEXT, INP)
         INP = INP + 1
         TEXT(INP:INP+5) = CHFOR(1:5)
         INP = INP + 5
         CHTMP = NAMEIN // CLAIN
         CALL NAMEST (CHTMP, CATUV(KIIMS), TEXT(INP:), INCHAR)
         INP = INP + INCHAR - 1 + 4
         CALL TRIM (TEXT, 132, TEXT, INP)
         INCHAR = INP
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Date/time/version
         IF (LABEL.GT.1) THEN
            TEXT = ' '
            DY = DY + 1.333
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (TEXT,1030) VER, ADATE, ATIME
            INCHAR = 51
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
         END IF
C                                       Only label Y axis once.
      IAXLAB = MAXPLT / 2 + 1
      IAPLOT = ABS (IPLOT)
      IF ((IPLOT.GT.0) .AND. (IPLOT.NE.IAXLAB)) CPREF(2,LOCNUM) = '-1'
      IF ((IPLOT.LT.0) .AND. (IAPLOT.GT.IAXLAB)) CPREF(2,LOCNUM) = '-1'
C                                       Put on labels and ticks
      CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XYRATO, F, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      DX = 5.0
      DY = 5.0
      NUMVIS = 0
C                                       Initialize saved copy of
C                                       RPARM and saved weight
      CALL RCOPY (20, RPARM, SRPARM)
      SWT = 0.0
C                                       Loop
 100  CONTINUE
      IF (SOLINT.EQ.0.0) THEN
C                                       Read vis. record.
         CALL UVGET ('READ', RPARM, BUFF1, IERR)
         IF (IERR.EQ.-1) GO TO 200
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1100) IERR
            CALL MSGWRT (8)
            IRET = 4
            GO TO 970
            END IF
C                                       Spectral averaging
         IF (DOAVG) THEN
            NUMFRQ = CATBLK(KINAX+JLOCF)
            NUMTEM = CATBLK(KINAX+JLOCS)
            CALL AVGCIF (BUFF1, NUMTEM, NUMFRQ, BCHAN, ECHAN, BIF,
     *         EIF, CHNSEL, KNCS, BUFF1)
            END IF
C                                       Modify VIS as appropriate
C                                       based on POLPLT.
         IF (POLPLT.GT.0) CALL POLVIS (BUFF1, POLPLT, IPOLPT)
C                                       There are points this block
         IA1 = RPARM(1+ILOCB) / 256.
         IA2 = RPARM(1+ILOCB) - IA1*256. + 0.1
         NUMVIS = NUMVIS + 1
         KEEP = MOD(NUMVIS,INC) .EQ. 0
         IF (.NOT. KEEP) GO TO 100
C                                       Get array #
         IARR = (RPARM(1+ILOCB)-IA1*256.0-IA2) * 100.0 + 1.1
C                                       Check if desired array
         IF ((IARRW.NE.0) .AND. (IARR.NE.IARRW)) GO TO 130
         RPARM(1+ILOCT) = RPARM(1+ILOCT)-(IARR-1)*5.
C                                       Is this a valid point ?
         CALL WANTED (BUFF1, RPARM, IA1, IA2, GOOD)
C                                       Get and scale X, Y
         IF (.NOT.GOOD) GO TO 130
         CALL FNDXY (BUFF1, RPARM, XZY)
         GWT = BUFF1(3+IPOLPT*INCS)
         GERR = 0.0
         IF (GWT.GT.0.0) GERR = 1.0 / SQRT (GWT)
         IF (BPARM(2).EQ.2.0) THEN
            IDX1 = 1 + IPOLPT*INCS
            IDX2 = 2 + IPOLPT*INCS
            GWT = SQRT (BUFF1(IDX1)*BUFF1(IDX1) +
     *         BUFF1(IDX2)*BUFF1(IDX2))
            IF (GWT.GT.0.0) THEN
               GERR = (GERR / GWT) / DTORAD
            ELSE
               GERR = 0.0
               END IF
            END IF
         GERR = GERR * XYSCL(2)
         END IF
C                                       Time averaging section
      DMULT = 1.0
      IF (DTYPE.EQ.1) DMULT = RAD2DG
      IF (SOLINT.GT.0.0) THEN
C                                       Read vis. recs and form
C                                       averages
         ANTLAB(1,1) = IAW1
         ANTLAB(1,2) = IAW2
         NUMBAS = 1
C                                       Restore RPARM array and
C                                       first weight so that
C                                       BASAVG does not get
C                                       get confused
         CALL RCOPY (20, SRPARM, RPARM)
         BUFF1(3) = SWT
C
         CALL BASAVG (NUMVIS, NUMBAS, ANTLAB, AMPVEC, DTYPE, SOLINT,
     *      CHNSEL, DOAVG, SCANV, ITIME, NUSCAN, SCANUM, RPARM,
     *      BUFF1, AVTIM, AVU, AVV, AVW, IRET)
         IF (IRET.LT.0) GO TO 200
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1100) IRET
            IRET = 4
            GO TO 970
            END IF
C
         NUMVIS = NUMVIS + 1
         KEEP = MOD(NUMVIS,INC) .EQ. 0
         IF (.NOT. KEEP) GO TO 100
C                                       Get array #
         IA1 = ANTLAB(1,1)
         IA2 = ANTLAB(1,2)
         IARR = (RPARM(1+ILOCB)-IA1*256.0-IA2) * 100.0 + 1.1
C                                       Save a copy of the
C                                       random parameters and
C                                       the first weight for
C                                       BASAVG
         CALL RCOPY (20, RPARM, SRPARM)
         SWT = BUFF1(3)
C                                       Check if desired array
         IF ((IARRW.NE.0) .AND. (IARR.NE.IARRW)) GO TO 130
         RPARM(1+ILOCT) = AVTIM - (IARR-1)*5.
C                                       Is this a valid point ?
         IF (SCANV(1).EQ.FBLANK) BUFF1(3) = 0.0
         RPARM(ILOCU+1) = AVU
         RPARM(ILOCV+1) = AVV
         RPARM(ILOCW+1) = AVW
         CALL WANTED (BUFF1, RPARM, IA1, IA2, GOOD)
C                                       Get and scale X, Y
         IF (.NOT.GOOD) GO TO 130
         XZY(1) = RPARM(ILOCT+1)
         XZY(2) = SCANV(1) * DMULT
         GWT = BUFF1(3+IPOLPT*INCS)
         GERR = 0.0
         IF (GWT.GT.0.0) GERR = 1.0 / SQRT (GWT)
         IF (BPARM(2).EQ.2.0) THEN
            IDX1 = 1 + IPOLPT*INCS
            IDX2 = 2 + IPOLPT*INCS
            GWT = SQRT (BUFF1(IDX1)*BUFF1(IDX1) +
     *         BUFF1(IDX2)*BUFF1(IDX2))
            IF (GWT.GT.0.0) THEN
               GERR = (GERR / GWT) / DTORAD
            ELSE
               GERR = 0.0
               END IF
            END IF
         GERR = GERR * XYSCL(2)
         END IF

      DO 128 JJJ = 1,2
         DO 120 J = 1,2
            XY(J) = XYSCL(J) * (XZY(J)-XYOFF(J)) +
     *         YYOFF(J)
            IF ((XY(J).GE.XBLC(J)) .AND.
     *         (XY(J).LE.XTRC(J))) GO TO 120
            NNOFIT = NNOFIT + 1
            GO TO 127
 120        CONTINUE
         NGOOD = NGOOD + 1
C                                       Mark the point
         IF (DOERRB) THEN
            DY = 5.0
            IF ((GERR*2.0).GT.5.0) DY = GERR / 2.0
            END IF
         IF (XSYM.EQ.0.0) THEN
            XTEMP = XY(1) + DX
            CALL GPOS (XTEMP, XY(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            XTEMP = XY(1) - DX
            CALL GVEC (XTEMP, XY(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
         XTEMP = XY(2) + DY
         IF (XTEMP.GT.XTRC(2)) XTEMP = XTRC(2)
         CALL GPOS (XY(1), XTEMP, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         XTEMP = XY(2) - DY
         IF (XTEMP.LT.XBLC(2)) XTEMP = XBLC(2)
         CALL GVEC (XY(1), XTEMP, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Plot u,v,w ?
 127     IF (.NOT.UVREV) GO TO 130
         XZY(1) = -XZY(1)
         XZY(2) = -XZY(2)
 128     CONTINUE
 130  GO TO 100
C                                       Check if changed status
 200  IF (CHSTAT) THEN
         STAT = 'CLWR'
         CALL CATDIR ('CSTA', DISKIN, OLDCNO, CTEMP, CTEMP, IDUM,
     *      UTYPE, IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'CLWR'
            CALL MSGWRT (6)
            GO TO 999
            END IF
         STAT = 'READ'
         CALL CATDIR ('CSTA', DISKIN, OLDCNO, CTEMP, CTEMP, IDUM,
     *      UTYPE, IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'READ'
            CALL MSGWRT (6)
            GO TO 999
            END IF
         END IF
      CALL UVGET ('CLOS', RPARM, BUFF1, IERR)
C                                       Plot model
      TRA = RA
      TDEC = DEC
      IF ((ABS(RA-OBSRA).GT.1.5) .OR. (ABS(DEC-OBSDEC).GT.1.5))
     *   GO TO 205
         TRA = OBSRA
         TDEC = OBSDEC
 205  CALL VBMDL (TRA, TDEC, XMIN, XMAX, YMIN, YMAX, YYOFF, TLC,
     *   TYPEAX(1), TYPEAX(2), CPTRIP, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL COPY (2, SVAXTP, TYPEAX)
C                                       Done: finish plot
      WRITE (MSGTXT,1200) NGOOD, IAW1, IAW2
      CALL MSGWRT (2)
      WRITE (MSGTXT,1201) NNOFIT, IAW1, IAW2
      IF (NNOFIT.GE.1) CALL MSGWRT (2)
      IF ((IPLOT.GT.0) .AND. (ABS (IPLOT).LT.MAXPLT)) GO TO 210
         GPHPAG = IPLOT.GT.0
         CALL GFINIS (BUFFER, IERR)
         IF (IERR.GT.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, OLDCNO, VER, BUFFER, IERR)
            IERR = 0
            END IF
 210  IF (IERR.GT.0) GO TO 975
         IRET = MIN (IERR, 0)
         GO TO 999
C                                       ZPHFIL or GINIT failure.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      IF (.NOT.DOTV) THEN
         CALL DELEXT ('PL', DISKIN, OLDCNO, 'WRIT', CATUV, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
      GO TO 999
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      WRITE (MSGTXT,1200) NGOOD, IAW1, IAW2
      CALL MSGWRT (2)
      WRITE (MSGTXT,1201) NNOFIT, IAW1, IAW2
      IF (NNOFIT.GE.1) CALL MSGWRT (2)
      GPHPAG = IPLOT.GT.0
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.GT.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, OLDCNO, VER, BUFFER, IERR)
            IERR = 0
            END IF
         GO TO 999
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         CALL DELEXT ('PL', DISKIN, OLDCNO, 'WRIT', CATUV, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('PLot file version',I4,'  created.')
 1030 FORMAT ('PLot file version',I4,'  created ',A,A)
 1040 FORMAT ('IF ',I1,'-',I1,' CH ',I4,'-',I4,' STK ',A5,' CC ver ',I3)
 1050 FORMAT ('PLTVB: ERROR',I3,' INIT VIS FILE')
 1080 FORMAT ('PLTVB: ERROR ',I3,' CHANGING ',A4,' STATUS')
 1100 FORMAT ('PLTVB: ERROR',I3,' READING VIS FILE')
 1200 FORMAT ('PLTVB: ',I9,' points plotted: baseline ',I2,' - ',I2)
 1201 FORMAT ('PLTVB: ',I9,' points did not fit: baseline ',I2,' - ',I2)
 1960 FORMAT ('PLTVB: ERROR DURING GRAPH FILE CREATION')
 1970 FORMAT ('PLTVB: ERROR DURING GRAPHING. WILL TRY TO FINISH ',
     *   'PARTIAL GRAPH')
      END
      SUBROUTINE FNDXY (BUFR, RPARM, XY)
C-----------------------------------------------------------------------
C   FNDXY extracts the desired X and Y values from the Vis record.
C   Inputs:  BUFR   R(*)     Visibility record
C            RPARM  R(*)     Random parms
C   Outputs: XY     R(2)     X, Y values
C-----------------------------------------------------------------------
      REAL      BUFR(*), XY(2), RPARM(*)
      DOUBLE PRECISION    GMST, GAST
      REAL      TR, TI, R2D
      INTEGER   NV, I, J
      INCLUDE 'VBPLT.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA R2D /57.29578/
C-----------------------------------------------------------------------
C                                       Loop over axes
      DO 900 I = 1,2
         NV = 0
         TR = 0.0
         TI = 0.0
         XY(I) = 0.0
         J = TYPEAX(I)
         GO TO (100, 100, 300, 400, 500, 600, 700, 800, 100, 100,
     *          850, 500, 860, 870, 880, 890), J
C                                       amplitudes and phases
 100     TR = BUFR(1+IPOLPT*INCS)
         TI = BUFR(2+IPOLPT*INCS)
         GO TO 190
C                                       amplitude
 190     IF (J.GT.1) GO TO 200
         XY(I) = SQRT (TR*TR + TI*TI)
         GO TO 900
C                                       phase
 200     IF (J.GT.2) GO TO 250
         IF ((TI.NE.0.0) .OR. (TR.NE.0.0)) XY(I) = R2D *
     *      ATAN2 (TI, TR)
         GO TO 900
C                                       Real , Imag parts
 250     IF (J.EQ.9) XY(I) = TR
         IF (J.EQ.10) XY(I) = TI
         GO TO 900
C                                       U, V distance
 300     XY(I) = SQRT (RPARM(1+ILOCU)**2 + RPARM(1+ILOCV)**2)
         GO TO 900
C                                       U, V position angle
 400     TR = RPARM(1+ILOCU)
         TI = RPARM(1+ILOCV)
         IF ((TI.NE.0.0) .OR. (TR.NE.0.0)) XY(I) = R2D *
     *      ATAN2 (TI, TR)
         GO TO 900
C                                       Time
 500     XY(I) = RPARM(1+ILOCT)
         GO TO 900
C                                       U projected spacing
 600     XY(I) = RPARM(1+ILOCU)
         GO TO 900
C                                       V projected spacing
 700     XY(I) = RPARM(1+ILOCV)
         GO TO 900
C                                       W projected spacing
 800     XY(I) = RPARM(1+ILOCW)
         GO TO 900
C                                       Folded G.S.T.
 850     CALL SIDERL (JDREF, RPARM(1+ILOCT), IATUTC, GMST, GAST)
         XY(I) = GAST
         GO TO 900
C                                       Source no.
 860     IF (ILOCSU.GT.0) THEN
            XY(I) = RPARM(1+ILOCSU)
         ELSE
            XY(I) = 1.0
            END IF
         GO TO 900
C                                       FREQID
 870     IF (ILOCFQ.GT.0) THEN
            XY(I) = RPARM(1+ILOCFQ)
         ELSE
            XY(I) = 1.0
            END IF
         GO TO 900
C                                       Int. time
 880     IF (ILOCIT.GT.0) THEN
            XY(I) = RPARM(1+ILOCIT)
         ELSE
            XY(I) = 1.0
            END IF
         GO TO 900
C                                       Weight
 890     XY(I) = BUFR(3+IPOLPT*INCS)
 900     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE WANTED (BUFR, RPARM, IA1, IA2, GOOD)
C-----------------------------------------------------------------------
C   WANTED determines whether the current visibility sample is valid
C   and selected via the selection parameters.
C   Inputs:  BUFR   R(*)     Visibility record
C            RPARM  R(*)     Random parms
C            IA1    I        Ant number 1
C            IA2    I        Ant number 2
C   Outputs: GOOD   L        T => data valid and selected
C-----------------------------------------------------------------------
      REAL      BUFR(*), TEMP, RPARM(*)
      INTEGER   IA1, IA2
      LOGICAL   GOOD
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'VBPLT.INC'
C-----------------------------------------------------------------------
      GOOD = .FALSE.
C                                       Check UV range
      IF (NOUVR) GO TO 10
         TEMP = SQRT (RPARM(1+ILOCU)**2 + RPARM(1+ILOCV)**2)
         IF ((TEMP.LT.UVRANG(1)) .OR. (TEMP.GT.UVRANG(2))) GO TO 999
C                                       Test time range
 10   TEMP = RPARM(1+ILOCT)
      IF ((TEMP.LT.TBEG) .OR. (TEMP.GT.TFIN)) GO TO 999
C                                       Test antennas
      IF ((IAW1.NE.0) .AND. (IAW1.NE.IA1) .AND. (IAW1.NE.IA2)) GO TO 999
      IF ((IAW2.NE.0) .AND. (IAW2.NE.IA1) .AND. (IAW2.NE.IA2)) GO TO 999
C                                       Are data flagged?
      GOOD = BUFR(3+IPOLPT*INCS).GT.0.0
C
 999  RETURN
      END
      SUBROUTINE XYSCAL (NUMVIS, XY, MAXPLT, IA1, IA2, IRET)
C-----------------------------------------------------------------------
C   XYSCAL finds the scaling parameters needed to fit X and Y
C   into a 1000*1000 plotting area .
C   Inputs:
C      NUMVIS     I    Visibility number, -1=> final call, no data
C                      passed -> change to scaling factor from max/min
C      XY         R    plotted parameters .
C      MAXPLT     I    Maximum number of plots per page.
C      IA1, IA2   I82  Antenna numbers
C   Outputs:
C      XYOFF      R    when added to XY changes minimum to zero .
C      XYSCL      R    scale XY so that maximum is 1000.
C      IRET       I    Error return code , non-zero if error .
C
C   Programmer T. J. Cornwell, Oct.  1981.
C-----------------------------------------------------------------------
      INTEGER   IRET, MAXPLT, I, JJ, IA1, IA2, LA1, LA2, L, J,
     *   MXANT, LIM1, NUMVIS
      REAL      XY(2), SIZE
      LOGICAL   POSSDG
      INCLUDE 'VBPLT.INC'
      DATA MXANT /MAXANT/
C-----------------------------------------------------------------------
      IRET = 0
      POSSDG = (TYPEAX(2).GT.12)
C                                       Are they in requested range?
      IF (NUMVIS.LT.0) GO TO 100
         LA1 = MIN (IA1, IA2)
         LA2 = MAX (IA1, IA2)
C                                       for 'auto' data is at the
C                                       last column and last row
         IF (IA1 .EQ. IA2) THEN
            LA1 = IA1
            LA2 = MXANT
            END IF
         IRET = -1
         DO 10 I = 1,2
            IF (TESTEM(I).EQ.0) GO TO 10
               JJ = 2*I + 2
               IF ((BPARM(JJ).LT.BPARM(JJ+1)) .AND. ((XY(I).LT.
     *            BPARM(JJ)) .OR. (XY(I).GT.BPARM(JJ+1)))) GO TO 999
               IF ((BPARM(JJ).GT.BPARM(JJ+1)) .AND. ((XY(I).GT.
     *            BPARM(JJ)) .OR. (XY(I).LT.BPARM(JJ+1)))) GO TO 999
 10         CONTINUE
         IRET = 0
C                                       Find max, min from data
         DO 30 I = 1,2
            IF (.NOT.SCALEM(I)) GO TO 30
               IF (XY(I).LT.XYOFF(I)) XYOFF(I) = XY(I)
               IF (XY(I).GT.XYSCL(I)) XYSCL(I) = XY(I)
 30         CONTINUE
         IF (.NOT.FLOTEM) GO TO 999
            IF (XY(2).LT.XYVALS(LA2,LA1)) XYVALS(LA2,LA1) = XY(2)
            IF (XY(2).GT.XYVALS(LA1,LA2)) XYVALS(LA1,LA2) = XY(2)
            GO TO 999
C                                       Convert to scaling factors
C                                       add 20% for label.
 100  IF (.NOT.FLOTEM) GO TO 120
         LIM1 = MXANT - 1
         IF (POSSDG) THEN
            XYSCL(2) = XYSCL(2) + (XYSCL(2) * 0.05)
            XYOFF(2) = XYOFF(2) - (XYOFF(2) * 0.05)
            END IF
         DO 115 I = 1,LIM1
            L = I + 1
            DO 110 J = L,MXANT
               IF (XYVALS(J,I).LT.XYVALS(I,J)) GO TO 105
                  XYVALS(J,I) = XYOFF(2)
                  XYVALS(I,J) = XYSCL(2)
 105           XYVALS(I,J) = XYVALS(I,J) + 0.2 *
     *            (XYVALS(I,J) - XYVALS(J,I))
 110           CONTINUE
 115        CONTINUE
 120  XYSCL(2) = XYSCL(2) + 0.2 * (XYSCL(2) - XYOFF(2))
      DO 130 I = 1,2
         IF (.NOT.SCALEM(I)) GO TO 130
            IF (XYSCL(I).LE.XYOFF(I)) GO TO 980
C                                       Deal with U,V,W axes
            IF (.NOT.UVREV) GO TO 125
               XYSCL(I) = MAX (ABS(XYSCL(I)), ABS(XYOFF(I)))
               XYOFF(I) = -XYSCL(I)
 125        IF ((XYOFF(I).GT.0.0) .AND. (XYOFF(I).LT.0.1*XYSCL(I)))
     *         XYOFF(I) = 0.0
            IF ((XYOFF(I).GT.0.0) .AND. (XYOFF(I).LT.0.3*XYSCL(I)) .AND.
     *         (TYPEAX(I).EQ.1)) XYOFF(I) = 0.0
            SIZE = 0.025 * (XYSCL(I) - XYOFF(I))
            XYSCL(I) = XYSCL(I) + SIZE
            XYOFF(I) = XYOFF(I) - SIZE
            SIZE = 1000.
            IF (I.EQ.2) SIZE = 1000. / MAXPLT
            XYSCL(I) = SIZE / (XYSCL(I) - XYOFF(I))
 130     CONTINUE
      IF (.NOT.FLOTEM) GO TO 999
         LIM1 = MXANT - 1
         DO 150 I = 1,LIM1
            L = I + 1
            DO 140 J = L,MXANT
               IF (XYVALS(I,J).LE.XYVALS(J,I)) GO TO 980
C                                       Deal with U,V,W axes
               IF (.NOT.UVREV) GO TO 135
                  XYVALS(I,J) = MAX (ABS(XYVALS(I,J)),
     *               ABS(XYVALS(J,I)))
                  XYVALS(J,I) = -XYVALS(I,J)
 135           IF ((XYVALS(J,I).GT.0.0) .AND. (XYVALS(J,I).LT.
     *            0.1*XYVALS(I,J))) XYVALS(J,I) = 0.0
               IF ((XYVALS(J,I).GT.0.0) .AND. (TYPEAX(2).EQ.1) .AND.
     *            (XYVALS(J,I).LT.0.3*XYVALS(I,J))) XYVALS(J,I) = 0.0
               SIZE = 0.025 * (XYVALS(I,J) - XYVALS(J,I))
               XYVALS(I,J) = XYVALS(I,J) + SIZE
               XYVALS(J,I) = XYVALS(J,I) - SIZE
               SIZE = 1000. / MAXPLT
               XYVALS(I,J) = SIZE / (XYVALS(I,J) - XYVALS(J,I))
 140           CONTINUE
 150        CONTINUE
         GO TO 999
C
 980  IRET = 1
      WRITE (MSGTXT,1980) I
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('XYSCAL: AXIS',I2,' DEGENERATE')
      END
      SUBROUTINE MODSET (XMIN, XMAX, MPLO, NPLO, DRA, DDEC, CPTRIP,
     *   XDATA, YDATA, IERR)
C-----------------------------------------------------------------------
C   Subroutine to set up model values for a given set of clean
C   components and for a given pair of antennas, or closure triangle
C
C   Inputs: XMIN,XMAX R    min and max values of the X-axis
C           MPLO      I    type of X-axis: 1 --> amplitude
C                              2 --> phase
C                              3 --> u,v distance
C                              4 --> u,v p.a.
C                              5 --> time (iat days)
C                              6 --> u
C                              7 --> v
C                              8 --> w
C                              9 --> sine channel
C                             10 --> cosine channel
C                             11 --> GAST
C          NPLO      I     Type of Y-axis in the same manner
C          DRA,DDEC  D     Ra and Dec of the source at the epoch of
C                          observation (in degrees, and as D).
C          CPTRIP(3) I     if plotting closure phases, defines the
C                          3 antennas of the triplet
C   Input from common /COMPS/
C      XPOS(MAXCC)    R     Distance from ref. X-pixel in turns.
C      YPOS(MAXCC)    R     Distance from ref. Y-pixel in turns.
C      SFLUX(MAXCC)   R     Flux in pixel XX, YY in Jansky
C      GAUSA(MAXCC)   R     Gaussian coefficient for u*u
C      GAUSB(MAXCC)   R     Gaussian coefficient for u*v
C      GAUSC(MAXCC)   R     Gaussian coefficient for v*v
C      ZTERM         R     Z portion of map center shift.
C      NUMCC         I     Number of pixels actually processed.
C   This subroutine gets information from common /CANIN/ set up by
C   subroutine ANTIN
C-----------------------------------------------------------------------
      DOUBLE PRECISION    U(3), V(3), W(3), PI, TWOPI, DTR, HTR, FREP,
     *   BX(3), BY(3), BZ(3), B1(3), B2(3), GH(3), GMST, GAST, RA,
     *   DEC, DRA, DDEC, GSEC, AA, RATE
      REAL      XXPOS, PA, XDEL, XREL, HAI, BL, CSUM, SSUM, TEMP, AMODL,
     *   FAZ, ARG, XMIN, XMAX, XDATA(*), YDATA(2,*), FTEMP
      INTEGER   MPLO, NPLO, I, K, J, IERR, NUV, CPTRIP(3), IT1, IT2,
     *   IT3
      CHARACTER OPCODE*4
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'VBPLT.INC'
      DATA GSEC /1.0027375D0/
C-----------------------------------------------------------------------
      IF ((MPLO.LT.1) .OR. (MPLO.GT.15)) GO TO 990
C                                       program constants
      OPCODE = ' '
      PI = 3.14159265358979D0
      TWOPI = 2.D0 * PI
      DTR = PI / 180.D0
      HTR = PI / 12.D0
      U(1) = 0.0D0
      V(1) = 0.0D0
      W(1) = 0.0D0
      GAST = 0
      IERR = 1
      RA = DRA * DTR
      DEC = DDEC * DTR
      FREP = AFREQ
      IT1 = IAW1
      IT2 = IAW2
      IT3 = 1
C                                     divide X-axis into 200 pixels
      XDEL = (XMAX - XMIN) / 200.0
      XXPOS = XMIN - XDEL
C                                     if this is a IAT-plot:
C                                     compute GST at first time
C                                     interval
C      IF ((MPLO.EQ.5) .OR. (MPLO.EQ.11) .OR. (MPLO.EQ.12))
C     *   CALL SIDERL (JDREF, XMIN, IATUTC, GMST, GAST)
      IF ((MPLO.EQ.5) .OR. (MPLO.EQ.11) .OR. (MPLO.EQ.12)) THEN
         CALL GSTROT (JDREF, GMST, GAST, RATE)
         GAST = GAST * (24.D0/360.D0)
         GAST = GAST + ((XMIN*24.D0) * GSEC)
         GAST = MOD (GAST, 24.D0)
         END IF
C                                     determine baseline parms
      CALL BASLIN (XB(IT1), YB(IT1), ZB(IT1), XB(IT2), YB(IT2),
     *   ZB(IT2), XB(IT3), YB(IT3), ZB(IT3), OPCODE, FREP,
     *   ANLONG, BPARM(10), BX, BY, BZ, B1, B2, GH)
C
      XREL = XDEL
      IF ((MPLO.EQ.5).OR.(MPLO.EQ.12)) XDEL = XDEL * 24.0
      GAST = GAST - GSEC*XDEL
      ARG = -10.0
C                                     Baseline plots here
      DO 200 I = 1,200
         YDATA(1,I) = FBLANK
         YDATA(2,I) = FBLANK
         XXPOS = XXPOS + XREL
         XDATA(I) = XXPOS
C                                       compute u and v from X-axis type
         GO TO (210, 210, 70, 80, 15, 100, 110, 115, 210, 210, 30, 15,
     *      210, 210, 210), MPLO
C                                       IAT in days
  15        NUV = 1
            GAST = GAST + GSEC*XDEL
            GO TO 60
C                                       GST
 30         NUV = 1
            GAST = XDATA(I)
C                                       u,v,w from HA
 60         HAI = GAST*HTR - RA - GH(1)
            U(1) = B2(1) * SIN(HAI)
            V(1) = B1(1) * COS(DEC) - B2(1) * SIN(DEC) * COS(HAI)
            W(1) = B1(1) * SIN(DEC) + B2(1) * COS(DEC) * COS(HAI)
            GO TO 120
C                                       Baseline length
 70         BL = XDATA(I)
            FTEMP = B2(1) * COS(DEC)
            IF (FTEMP.EQ.0.0) GO TO 200
            TEMP =  B1(1)*B1(1) + B2(1)*B2(1) - BL*BL
            IF (TEMP.LT.0.0) GO TO 200
            TEMP = SQRT(TEMP)
            HAI = (-B1(1) * SIN(DEC) + TEMP) / FTEMP
            IF ((HAI.LT.-1.0) .OR. (HAI.GT.1.0)) GO TO 75
               HAI = ACOS(HAI)
               U(1) = B2(1) * SIN(HAI)
               V(1) = B1(1) * COS(DEC) - B2(1) * SIN(DEC) * COS(HAI)
               HAI = SQRT (U(1)*U(1) + V(1)*V(1))
               IF (ABS(HAI-BL).LT.1.E-4*BL) GO TO 78
 75         HAI = (-B1(1) * SIN(DEC) - TEMP) / FTEMP
            IF ((HAI.LT.-1.0) .OR. (HAI.GT.1.0)) GO TO 200
               HAI = ACOS(HAI)
               U(1) = B2(1) * SIN(HAI)
               V(1) = B1(1) * COS(DEC) - B2(1) * SIN(DEC) * COS(HAI)
               HAI = SQRT (U(1)*U(1) + V(1)*V(1))
               IF (ABS(HAI-BL).GT.1.E-3*BL) GO TO 200
 78         W(1) = B1(1) * SIN(DEC) + B2(1) * COS(DEC) * COS(HAI)
            U(2) = -U(1)
            V(2) = V(1)
            W(2) = W(1)
            NUV = 2
            GO TO 120
C                                       Baseline position angle
 80         PA = XDATA(I) * DTR
            FTEMP = B2(1) * (1.0 - (COS(DEC) * COS(PA)) ** 2)
            IF (FTEMP.EQ.0.0) GO TO 200
            TEMP = B2(1)*B2(1) - (B1(1)*B1(1) + B2(1)*B2(1))
     *         * ((COS(DEC)*COS(PA))**2)
            IF (SIN(DEC)*COS(PA).EQ.0.0) TEMP = 0.0
            IF (TEMP.LT.0.) GO TO 200
            TEMP = SIN(DEC) * COS(PA) * SQRT (TEMP)
            NUV = 1
            HAI = (B1(1) * COS(DEC) * COS(PA) * SIN(PA) + TEMP) / FTEMP
            IF ((HAI.LT.-1.0) .OR. (HAI.GT.1.0)) GO TO 85
               HAI = ASIN (HAI)
               U(1) = B2(1) * SIN(HAI)
               V(1) = B1(1) * COS(DEC) - B2(1) * SIN(DEC) * COS(HAI)
               W(1) = B1(1) * SIN(DEC) + B2(1) * COS(DEC) * COS(HAI)
               BL = ATAN2 (V(1), U(1)) / DTR
               IF (ABS(XDATA(I)-BL).LT.0.25) GO TO 120
 85         HAI = (B1(1) * COS(DEC) * COS(PA) * SIN(PA) - TEMP) / FTEMP
            IF ((HAI.LT.-1.0) .OR. (HAI.GT.1.0)) GO TO 200
               HAI = ASIN (HAI)
               U(1) = B2(1) * SIN(HAI)
               V(1) = B1(1) * COS(DEC) - B2(1) * SIN(DEC) * COS(HAI)
               W(1) = B1(1) * SIN(DEC) + B2(1) * COS(DEC) * COS(HAI)
               BL = ATAN2 (V(1), U(1)) / DTR
               IF (ABS(XDATA(I)-BL).LT.0.5) GO TO 120
               GO TO 200
C                                       Along U-axis
 100        U(1) = XDATA(I)
            U(2) = XDATA(I)
            IF (B2(1).EQ.0.0D0) GO TO 200
            TEMP = XDATA(I) / B2(1)
            IF ((TEMP.LT.-1.0) .OR. (TEMP.GT.1.0)) GO TO 200
            HAI = ASIN (TEMP)
            V(1) = B1(1) * COS(DEC) - B2(1) * SIN(DEC) * COS(HAI)
            W(1) = B1(1) * SIN(DEC) + B2(1) * COS(DEC) * COS(HAI)
            HAI = PI - HAI
            V(2) = B1(1) * COS(DEC) - B2(1) * SIN(DEC) * COS(HAI)
            W(2) = B1(1) * SIN(DEC) + B2(1) * COS(DEC) * COS(HAI)
            NUV = 2
            GO TO 120
C                                       Along V-axis
 110        V(1) = XDATA(I)
            V(2) = XDATA(I)
            TEMP = B2(1) * SIN(DEC)
            IF (TEMP.EQ.0.0) GO TO 200
            TEMP = (B1(1) * COS(DEC) - V(1)) / TEMP
            IF ((TEMP.LT.-1.0) .OR. (TEMP.GT.1.0)) GO TO 200
            HAI = ACOS (TEMP)
            U(1) = B2(1) * SIN(HAI)
            W(1) = B1(1) * SIN(DEC) + B2(1) * COS(DEC) * COS(HAI)
            U(2) = -U(1)
            W(2) = W(1)
            NUV = 2
            GO TO 120
C                                       Along W-axis
 115        W(1) = XDATA(I)
            W(2) = XDATA(I)
            TEMP = B2(1) * COS(DEC)
            IF (TEMP.EQ.0.0) GO TO 200
            TEMP = (W(1) - B1(1) * SIN(DEC)) / TEMP
            IF ((TEMP.LT.-1.0) .OR. (TEMP.GT.1.0)) GO TO 200
            HAI = ACOS (TEMP)
            U(1) = B2(1) * SIN(HAI)
            V(1) = B1(1) * COS(DEC) - B2(1) * SIN(DEC) * COS(HAI)
            U(2) = -U(1)
            V(2) = V(1)
            NUV = 2
            GO TO 120
C                                       Compute model values
 120     DO 190 J = 1,NUV
            CSUM = 0.0
            SSUM = 0.0
C                                       calculate model sin/cos amps.
C                                       Point and gaussian.
            IF (DOSPHE) GO TO 131
            IF (DOGAUS) GO TO 126
               DO 125 K = 1,NUMCC
                  FTEMP = SFLUX(K)
                  TEMP = U(J) * XPOS(K) + V(J) * YPOS(K) + W(J) * ZTERM
                  SSUM = SSUM + FTEMP * SIN (TEMP)
                  CSUM = CSUM + FTEMP * COS (TEMP)
 125              CONTINUE
               GO TO 138
C                                       Gaussian
 126     CONTINUE
               DO 130 K = 1,NUMCC
                  ARG = U(J)*U(J)*GAUSA(K) + U(J)*V(J)*GAUSB(K)
     *               + V(J)*V(J)*GAUSC(K)
                  IF (ARG.LE.-8.0) GO TO 130
                     FTEMP = SFLUX(K) * EXP(ARG)
                     TEMP = U(J)*XPOS(K) + V(J)*YPOS(K) + W(J)*ZTERM
                     SSUM = SSUM + FTEMP * SIN (TEMP)
                     CSUM = CSUM + FTEMP * COS (TEMP)
 130              CONTINUE
               GO TO 138
C                                       Spherical model
C                                       Trap very unresolved - needed to
C                                       prevent serious precision loss.
 131        CONTINUE
               DO 135 K = 1,NUMCC
                  AA = GAUSA(K) * SQRT (U(J)*U(J) + V(J)*V(J))
                  IF (AA.LT.6.28D-2) AA = 6.28D-2
                  FTEMP = 3.0D0 * SFLUX(K) *
     *               ((SIN(AA) / (AA*AA*AA)) - (COS(AA) / (AA*AA)))
                  TEMP = U(J) * XPOS(K) + V(J) * YPOS(K) + W(J) * ZTERM
                  SSUM = SSUM + FTEMP * SIN (TEMP)
                  CSUM = CSUM + FTEMP * COS (TEMP)
 135           CONTINUE
C                                       Finished computing model
 138        AMODL = SQRT (SSUM*SSUM + CSUM*CSUM)
            IF (NPLO.EQ.1) YDATA(J,I) = AMODL
            IF (NPLO.EQ.9) YDATA(J,I) = CSUM
            IF (NPLO.EQ.10) YDATA(J,I) = SSUM
            IF (NPLO.NE.2) GO TO 190
               IF (AMODL.LE.1.E-10) GO TO 190
               FAZ = ATAN2 (SSUM, CSUM) / DTR
 140           IF (FAZ.GT.180.0E0) FAZ = FAZ - 360.0E0
                  IF (FAZ.LT.-180.0E0) FAZ = FAZ + 360.0E0
                  IF (FAZ.GT.180.0E0) GO TO 140
                  IF (FAZ.LT.-180.0E0) GO TO 140
                  YDATA(J,I) = FAZ
 190        CONTINUE
 200     CONTINUE
 210  IERR = 0
      GO TO 999
C                                       bad X-axis type
 990  WRITE (MSGTXT,1990) MPLO
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1990 FORMAT ('MODSET: BAD X-AXIS CODE =',I6)
      END
      SUBROUTINE VBMDL (RA, DEC, XMIN, XMAX, YMIN, YMAX, YYOFF, TLC,
     *   MPLO, NPLO, CPTRIP, BUFFER, IERR)
C-----------------------------------------------------------------------
C   Main subroutine for plotting of a model:  If there is no model
C   (NUMCC .le. 0) VBMDL writes the baseline name and returns with
C   IERR=0.
C   Inputs:
C      RA,DEC            D     Ra and dec of the source in radians
C      XMIN,XMAX         R     Min and max of X-axis
C      YMIN,YMAX         R     Min and max of Y-axis
C      XYSCL(2)          R     Scaling factors
C      XYOFF(2)          R     Offset in plot
C      YYOFF(2)          R     Offset of the current plot.
C      TLC(2)            R     X, Y of top left corner of plot.
C      MPLO              I     Type of X-axis plot
C      NPLO              I     Type of Y-axis plot
C      CPTRIP(3)         I     Closure phase triplet plotted
C      IERR              I     Standard AIPS error code.
C-----------------------------------------------------------------------
      CHARACTER TEXT*132, MINUS*4
      INTEGER   MPLO, NPLO, IERR, BUFFER(1), INP, INCHAR, CPTRIP(3)
      LOGICAL   DOMDL
      REAL      XMIN, XMAX, YMIN, YMAX, YYOFF(2), TLC(2)
      DOUBLE PRECISION    RA, DEC
      REAL      XDATA(200), YDATA(2,200), XXXX(10), DX, DY
      INCLUDE 'VBPLT.INC'
      COMMON /CPLOTU/ XXXX
      DATA MINUS /'----'/
C-----------------------------------------------------------------------
C                                     Write baseline name on plot.
      TEXT = ' '
      INCHAR = 8
      INP = 1
      TEXT(INP:INP+7) = STANAM(IAW1)(1:8)
      CALL TRIM (TEXT, INCHAR, TEXT, INP)
      INCHAR = INP + 9
      INP = INP + 1
      TEXT(INP:INP) = MINUS(1:1)
      INP = INP + 1
      TEXT(INP:INP+7) = STANAM(IAW2)(1:8)
      CALL TRIM (TEXT, INCHAR, TEXT, INP)
      DX = 1.5
      DY = -1.5
      CALL GPOS (TLC(1), TLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 999
C                                     Check if model exists.
      DOMDL = (NPLO.EQ.1) .OR. (NPLO.EQ.2) .OR. (NPLO.EQ.9) .OR.
     *   (NPLO.EQ.10)
      IF ((NUMCC.LE.0) .OR. (.NOT.DOMDL)) GO TO 999
C                                     setup model
         CALL MODSET (XMIN, XMAX, MPLO, NPLO, RA, DEC, CPTRIP,
     *      XDATA, YDATA, IERR)
         IF (IERR.NE.0) GO TO 999
C                                     setup plotting common
         CALL PLTSET (XMIN, XMAX, YMIN, YMAX, XYSCL, XYOFF, YYOFF,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
C                                     plot model
         CALL MODPLT (MPLO, NPLO, XDATA, YDATA, BUFFER, IERR)
C
 999  RETURN
      END
      SUBROUTINE ANTIN (VER, NNCH, IIBIF, DISKI, CNOIN, FREQID, IERR)
C-----------------------------------------------------------------------
C   Selects station information and gets freq,and ref. date out of the
C   header for a given baseline.
C   Inputs:
C      VER           I    Antenna array number (AN file ver.)
C      NNCH          I    Frequency channel.
C      IIBIF         I    IF number.
C      DISKI         I    Vol number
C      CNOIN         I    CNO
C      FREQID        I    Selected FREQID
C   Outputs in common:
C      XA,YA,ZA(*)   D    Cartesian coordinates for stations in meters.
C      STANAM(*)     C*8  Names of stations
C      JDREF         D    Julian day# for the referens date.
C      AFREQ         D    Frequency of channel NNCH, IF IIBIF in Hz.
C      GST0          D    Greenwich sidereal time at UT=0 at ref.d
C      IATUTC        R    IAT-UTC in seconds.
C      UT1XXX        R    UT1-UTC in seconds.
C   Programmer: L.B.Baath   Onsala Space Observatory  30 october 1982
C-----------------------------------------------------------------------
      INTEGER   IERR, IA, LUNA, CNOIN, IABUF(512), VER, NIF, FREQID,
     *   NNCH, IIBIF, DISKI
      INCLUDE 'VBPLT.INC'
      CHARACTER STNAME*8, CHATCA*8
      INTEGER   ISBAND(MAXIF)
      REAL      FINC(MAXIF)
      DOUBLE PRECISION FOFF(MAXIF), DX, DY, DZ
      LOGICAL DOVLBI, DOATCA
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA CHATCA /'ATCA    '/
C-----------------------------------------------------------------------
C                                     open antenna file
      LUNA = 28
      CALL ANTINI ('READ', IABUF, DISKI, CNOIN, VER, CATBLK, LUNA,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GST0, DEGPDY, AFREQ, RDATE,
     *   POLRXY, UT1XXX, IATUTC, TIMSYS, ANAME, NUMORB, NOPCAL, ANFQID,
     *   IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 999
C                                     check for bad freq value
 10   IF ( AFREQ .EQ. 0.0D0 ) THEN
         AFREQ = CATD(KDCRV+JLOCF)
         END IF
      CALL JULDAY (RDATE, JDREF)
      DX = ARRAYC(1)
      DY = ARRAYC(2)
      DZ = ARRAYC(3)
      OBSRA = RA
      OBSDEC = DEC
      NANT = IABUF(5)
      ANLONG = 0.0D0
      IF ((DX.NE.0.0D0) .OR. (DY.NE.0.0D0)) ANLONG = ATAN2 (DY,DX)
C                                     Check if ATCA, which uses
C                                     earth-centre as array ref. pos.
C                                     but right handed coord. system
C                                     (VLBI uses lefthanded: Y=>-Y)
      DOATCA = ANAME .EQ. CHATCA
      DOVLBI = (ABS(DX).LE.1000.0D0) .AND. (ABS (DY).LE.1000.0D0)
     *    .AND. (ABS (DZ).LE.1000.0D0) .AND. (.NOT.DOATCA)
C                                     Get antenna info.
      DO 30 IA = 1,NANT
         IANRNO = IA
         CALL TABAN ('READ', IABUF, IANRNO, ANKOLS, ANNUMV,
     *      STNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.EQ.0) GO TO 20
            WRITE (MSGTXT,1010) IA, IERR
            CALL MSGWRT (8)
 20      XB(NOSTA) = STAXYZ(1) + DX
         IF (DOVLBI) THEN
            YB(NOSTA) = STAXYZ(2) + DY
            ELSE
            YB(NOSTA) = -(STAXYZ(2) + DY)
            END IF
         ZB(NOSTA) = STAXYZ(3) + DZ
         STANAM(NOSTA) = STNAME
 30      CONTINUE
C                                     close antenna file
      CALL TABIO ('CLOS', 1, IANRNO, IABUF, IABUF, IERR)
      IF (IERR.EQ.0) GO TO 40
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (8)
C                                       Get frequency info for correct
C                                       FREQID/IF combination from
C                                       FQ or CH table
 40   VER = 1
      CALL CHNDAT ('READ', IABUF, DISKI, CNOIN, VER, CATBLK, LUNA,
     *   NIF, FOFF, ISBAND, FINC, FREQID, IERR)
C                                       Correct freq. for channel NNCH
      AFREQ = AFREQ + FOFF(IIBIF) +
     *         (NNCH - CATR(KRCRP+JLOCF)) * FINC(IIBIF)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ANTIN: ERROR IN OPEN AN-FILE IERR = ',I6)
 1010 FORMAT ('ANTIN: ERROR IN FINDING STATION',I3,' IERR=',I3)
 1030 FORMAT ('ANTIN: ERROR IN CLOSING AN-FILE IERR = ',I6)
      END
      SUBROUTINE REEDIN (VER, IERR)
C-----------------------------------------------------------------------
C   Reads in up to MAXCC components from file CC.
C   If no file is found NUMCC is set to zero and the routine return
C   IERR = 0.
C   Will accept either points or gaussians.
C   Inputs:
C      VER           I     CLEAN components file version no.
C   Outputs:  In common /COMPS/
C      XPOS(MAXCC)    R     Distance from ref. X-pixel in turns.
C      YPOS(MAXCC)    R     Distance from ref. Y-pixel in turns.
C      SFLUX(MAXCC)   R     Flux in pixel XX, YY in Jansky
C      GAUSA(MAXCC)   R     Gaussian coefficient for u*u
C      GAUSB(MAXCC)   R     Gaussian coefficient for u*v
C      GAUSC(MAXCC)   R     Gaussian coefficient for v*v
C      ZTERM         R     Z portion of map center shift.
C      NUMCC         I     Number of pixels actually processed.
C-----------------------------------------------------------------------
      CHARACTER CHLL*8, CHRA*8, CHMM*8, CHDEC*8, KEYS(7)*8, UTYPE*2
      HOLLERITH CATCLH(256)
      INTEGER   NITER, LIMIT, I, NCOUNT
      INTEGER   IERR, IABUF(512), CNO,
     *   DISK2, SEQ2, IUSER, LUNA, LUNB, VER, NREC,
     *   NKEY, KOLS(7), RAKOL, DECKOL, FLXKOL, TYPKOL, BMAKOL, BMIKOL,
     *   BPAKOL, IBUFF1(1024), NKOL,
     *   INDA, CATCLN(256), ICLL, ICMM, IPOINT
      REAL      ABUF(256), PI, CONST, CATCLR(256),
     *   CCROT, SSROT, XXROT, YYROT,  XPOFF, YPOFF,
     *   EPS, RECORD(20), XTEMPC, TA, TB, AM, AN, MAPROT
      DOUBLE PRECISION    CATCLD(128), CLNRA, CLNDEC, RAOFF,
     *   DECOFF, XAOFF, XECOFF, DTORAD, A8BUF(128), RAX, DECX
      LOGICAL   T, F
      INCLUDE 'VBPLT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (CATCLN, CATCLR, CATCLH, CATCLD)
      EQUIVALENCE (IABUF, ABUF, A8BUF)
      EQUIVALENCE (IBUFF1, BUFF1)
      EQUIVALENCE (KOLS(1), RAKOL),       (KOLS(2), DECKOL),
     *   (KOLS(3), FLXKOL),               (KOLS(4), TYPKOL),
     *   (KOLS(5), BMAKOL),               (KOLS(6), BMIKOL),
     *   (KOLS(7), BPAKOL)
      DATA KEYS /'DELTAX  ','DELTAY  ','FLUX    ',
     *   'TYPE OBJ','MAJOR AX','MINOR AX','POSANGLE'/
      DATA T, F /.TRUE.,.FALSE./
      DATA PI /3.1415926/
      DATA CHLL, CHMM /'LL      ','MM      '/
      DATA CHRA, CHDEC /'RA---SIN','DEC--SIN'/
      DATA LUNA, LUNB /17, 18/
C-----------------------------------------------------------------------
      EPS = 0.1
      DISK2 = XDI2IN + EPS
      IUSER = USERID
      SEQ2 = XS2IN + EPS
      NITER = XNIT + EPS
      IF (NITER.GT.MAXCC) NITER = MAXCC
      NUMCC = 0
      IF ((NAM2IN.EQ.' ') .AND. (CLA2IN.EQ.' ')) GO TO 200
      IF (NITER.LE.0) GO TO 200
C                                      get CATCLN
      MSGSUP = 32000
C                                       Look for uv data
      UTYPE = 'UV'
      CALL MAPOPN ('READ', DISK2, NAM2IN, CLA2IN, SEQ2, UTYPE, IUSER,
     *   LUNA, INDA, CNO, CATCLN, IABUF, IERR)
C                                       If not try MA file
      IF (IERR.EQ.3) THEN
         UTYPE = 'MA'
         CALL MAPOPN ('READ', DISK2, NAM2IN, CLA2IN, SEQ2, UTYPE, IUSER,
     *      LUNA, INDA, CNO, CATCLN, IABUF, IERR)
         END IF
      MSGSUP = 0
      XS2IN = SEQ2
      XDI2IN = DISK2
      CALL CHR2H (12, NAM2IN, 1, XNAM2I)
      CALL CHR2H (6, CLA2IN, 1, XCLA2I)
C                                      If not found => no model plot.
      IF (IERR.EQ.0) GO TO 40
         IF (IERR.EQ.3) GO TO 200
            WRITE (MSGTXT,1035) IERR
            CALL MSGWRT (8)
            GO TO 999
C                                     Get RA and Dec offsets.
 40   CALL AXEFND (8, CHLL, KICTPN, CATCLR(KHCTP), ICLL, IERR)
      IF (IERR.NE.0) CALL AXEFND (2, CHRA, KICTPN, CATCLR(KHCTP), ICLL,
     *   IERR)
      WRITE (MSGTXT,1041) IERR, CHLL, CHRA
      IF (IERR.NE.0) GO TO 990
      CALL AXEFND (8, CHMM, KICTPN, CATCLR(KHCTP), ICMM, IERR)
      IF (IERR.NE.0) CALL AXEFND (3, CHDEC, KICTPN, CATCLR(KHCTP), ICMM,
     *   IERR)
      WRITE (MSGTXT,1041) IERR, CHMM, CHRA
      IF (IERR.NE.0) GO TO 990
C                                       Get RA and Dec offsets from
C                                       uv data reference position.
      DTORAD = 3.14159265358979326D0 / 180.0D0
      CONST = 1.745329E-2 * 2.0 * 3.1415926
      CLNRA = CATCLD(KDCRV+ICLL) + CATCLR(KRXSH)
      CLNDEC = CATCLD(KDCRV+ICMM) + CATCLR(KRYSH)
      RAX = RA + CATR(KRXSH)
      DECX = DEC + CATR(KRYSH)
      RAOFF = SIN (DTORAD * (CLNRA - RAX)) * COS (CLNDEC * DTORAD)
      DECOFF = COS (DECX * DTORAD) * SIN (CLNDEC * DTORAD) -
     *   SIN (DECX * DTORAD) * COS (CLNDEC * DTORAD) *
     *   COS ((CLNRA - RAX) * DTORAD)
C                                     Prepare to shift & rotate.
      XXROT = 0.0
      YYROT = 0.0
      CALL ROTFND (CATCLR, XXROT, IERR)
      CALL ROTFND (CATR, YYROT, IERR)
      MAPROT = YYROT - XXROT
C                                       Get reference pixel offsets
      CCROT = COS (1.745329E-2 * (XXROT))
      SSROT = SIN (1.745329E-2 * (XXROT))
      XPOFF = -(RAOFF * CCROT - DECOFF * SSROT) / DTORAD
      YPOFF= -(DECOFF * CCROT + RAOFF * SSROT) / DTORAD
      RAOFF = - RAOFF * DTORAD * 360.0D0
      DECOFF = -  DECOFF * DTORAD * 360.0D0
      CCROT = COS (1.745329E-2*(YYROT))
      SSROT = SIN (1.745329E-2*(YYROT))
      XAOFF = RAOFF * CCROT - DECOFF * SSROT
      XECOFF = DECOFF*CCROT+RAOFF*SSROT
      RAOFF = XAOFF
      DECOFF = XECOFF
      XAOFF = RAOFF / CONST
      XECOFF = DECOFF / CONST
      ZTERM = -0.5*CONST*(XAOFF*XAOFF+XECOFF*XECOFF)*
     *   1.745329E-2
      CCROT = COS (1.745329E-2 * (YYROT-XXROT))
      SSROT = SIN (1.745329E-2 * (YYROT-XXROT))
C                                       Get model.
C                                       Open CLEAN component file.
      NKOL = 0
      NREC = 1
      NKEY = 0
      NCOUNT = 0
      CALL TABINI ('READ', 'CC', DISK2, CNO, VER, CATCLN, LUNB, NKEY,
     *   NREC, NKOL, ABUF, BUFF1, IERR)
      IF (IERR.EQ.0) GO TO 60
         WRITE (MSGTXT,1000) IERR
         GO TO 990
 60   CALL RFILL (7, 0.0, RECORD)
C                                       Find columns (physical)
      TYPKOL = 7
      BMAKOL = 0
      BMIKOL = 0
      BPAKOL = 0
      NKEY = NKOL
      IF (NKEY.GT.7) NKEY = 7
      CALL FNDCOL (NKEY, KEYS, 8, F, BUFF1, KOLS, IERR)
      IF (IERR.EQ.0) GO TO 70
         WRITE (MSGTXT,1010) IERR
         GO TO 990
C                                       Get number of components
 70     LIMIT = IBUFF1(5)
        IF (NITER.LT.LIMIT) LIMIT = NITER
        DOGAUS = F
        DOSPHE = F
        DO 90 I = 1,LIMIT
            CALL TABIO ('READ', 0, I, RECORD, BUFF1, IERR)
            IF (IERR.EQ.0) GO TO 80
               IF (IERR.LT.0) GO TO 90
                  WRITE (MSGTXT,1030) IERR, I
                  GO TO 990
C                                       Deal with component.
 80            NCOUNT = NCOUNT + 1
C                                       No need to shift the components
C                                       since this already done in the
C                                       CLEANing task.
               XPOS(NCOUNT) = (RECORD(RAKOL) * CCROT +
     *            RECORD(DECKOL) * SSROT) * DTORAD * 2.0 * PI
               YPOS(NCOUNT) = (RECORD(DECKOL) * CCROT -
     *            RECORD(RAKOL) * SSROT) * DTORAD * 2.0 * PI
               SFLUX(NCOUNT) = RECORD(FLXKOL)
               GAUSA(NCOUNT) = 0
               GAUSB(NCOUNT) = 0
               GAUSC(NCOUNT) = 0
C                                       See if gaussian
               IF ((ABS (RECORD(TYPKOL)-1.).GT.0.5) .AND.
     *         (ABS (RECORD(TYPKOL)-3.).GT.0.5)) GO TO 90
C                                       Convert to radians
                  GAUSA(NCOUNT) = RECORD(BMAKOL) * DTORAD
                  GAUSB(NCOUNT) = RECORD(BMIKOL) * DTORAD
                  GAUSC(NCOUNT) = RECORD(BPAKOL) * DTORAD
                  IF (ABS (RECORD(TYPKOL)-1.).LT.0.5) DOGAUS = T
                  IF (ABS (RECORD(TYPKOL)-3.).LT.0.5) DOSPHE = T
 90               CONTINUE
C                                       Close CLNFIL.
      CALL TABIO ('CLOS', 0, IPOINT, RECORD, BUFF1, IERR)
      IF (IERR.EQ.0) GO TO 100
         WRITE (MSGTXT,1060) IERR
         GO TO 990
C                                       Unmark file
 100  CALL MAPCLS ('READ', DISK2, CNO, LUNA, INDA, CATCLN, F, ABUF,
     *   IERR)
      NUMCC = NCOUNT
C                                       Convert gaussian parameters
      IF ((NUMCC.LE.0) .OR. (.NOT.DOGAUS)) GO TO 160
         DO 150 I = 1,NUMCC
            XTEMPC = GAUSC(I)
            AM = COS ((XTEMPC+MAPROT)*3.1415927/180.)
            AN = SIN ((XTEMPC+MAPROT)*3.1415927/180.)
            TA = GAUSA(I) * 3.1415927 / 1.1774
            TB = GAUSB(I) * 3.1415927 / 1.1774
            GAUSA(I) = -(TA*TA*AM*AM + TB*TB*AN*AN)
            GAUSB(I) = -((TB*TB-TA*TA) * AN*AM)
            GAUSC(I) = -(TA*TA*AN*AN + TB*TB*AM*AM)
 150        CONTINUE
C                                       Convert sphere parameters
 160  IF ((NUMCC.LE.0) .OR. (.NOT.DOSPHE)) GO TO 200
         DO 170 I = 1,NUMCC
            GAUSA(I) = GAUSA(I) * 6.283185
 170        CONTINUE
C
 200  IERR = 0
      XNIT = NCOUNT
      IF ((NITER.LE.0) .OR. (NUMCC.LE.0)) XNIT = 0.0
      GO TO 999
C                                        Error.
 990  CALL MSGWRT (8)
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('REEDIN: ERROR',I3,' OPENING FILE ')
 1010 FORMAT ('REEDIN: ERROR',I3,' FINDING REQUIRED CC COLUMNS')
 1030 FORMAT ('REEDIN: READ ERROR',I3,' RECORD ',I5)
 1035 FORMAT ('REEDIN: ERROR IN OPENING FILE IERR = ',I5)
 1041 FORMAT ('REEDIN: ERROR',I3,' FINDING CLEAN AXIS ',A8,' OR ',A8)
 1060 FORMAT ('REEDIN: ERROR',I3,' CLOSING FILE ')
      END
      SUBROUTINE COLSET (ANT1, ANT2, DISKIN, CNOIN, NUMBAS, ANTLAB,
     *   IPOL, IRET)
C-----------------------------------------------------------------------
C   Routine to set up for column listing; checks that data in "TB"
C   order and prepares the list of antennas (ANTENS) for UVGET that
C   includes all antennas mentioned in either XANT or XBASE.
C   Also checks allowed Stokes types.
C   Input:
C      DISKIN             I    Data disc
C      CNOIN              I    Data seq #
C      ANT1(*)            I    Antenna array
C      ANT2(*)            I    Baseline array
C   Output:
C      NUMBAS             I    The number of baselines selected.
C      ANTLAB(MXBASE,2)   I    The First (*,1) and second (*,2) antenna
C                              numbers of each baseline selected.
C      IPOL               I    Polarization type 1=I,2=Q,3=U,4=V
C                              R or L => 1
C      IRET               I    Return code, 0=OK, else failed
C   Output in Common:
C      ANTENS(*)          I    Selected antenna numbers
C      STOKES             C*4? Stokes' parameter selected (changed if
C                              an unallowed type specified)
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER DISKIN, CNOIN, ANT1(*), ANT2(*)
      CHARACTER STO(8)*4
      INTEGER   NUMBAS, IPOL, IRET, I, J, K, NEXT, LIMIT, MXBAS,
     *   NUMAN(20), NOANT, IANT1, IANT2, IANT, LUN, NSTO, JANT, LIM,
     *   XANT(MXBASE), XBASE(MXBASE)
      LOGICAL   T, F, ALLANT, ALLBAS
      INTEGER   ANTLAB(MXBASE,2)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (NUMAN, UBUFF(1025))
      DATA NSTO, STO /8, 'I   ','Q   ','U   ','V   ','RR  ','LL  ',
     *   'RL  ','LR  '/
      DATA T, F /.TRUE.,.FALSE./
      DATA MXBAS /MXBASE/
C-----------------------------------------------------------------------
      IRET = 0
      CALL COPY (MXBASE, ANT1, XANT)
      CALL COPY (MXBASE, ANT2, XBASE)
C                                       Check Stokes
      DO 10 I = 1,NSTO
         IPOL = I
         IF (STOKES.EQ.STO(I)) GO TO 30
 10      CONTINUE
C                                       Not allowed type, use 'I' or
C                                       'RR' or 'LL'
         IF (ICOR0.GT.0) THEN
            WRITE (MSGTXT,1010) STOKES, STO(1)
            STOKES = STO(1)
            IPOL = 1
         ELSE IF (ICOR0.LT.0) THEN
            IF (ICOR0.EQ.-1) THEN
               WRITE (MSGTXT,1010) STOKES, STO(5)
               STOKES = STO(5)
               IPOL = 1
            ELSE IF (ICOR0.EQ.-2) THEN
               WRITE (MSGTXT,1010) STOKES, STO(6)
               STOKES = STO(6)
               IPOL = 1
               END IF
            END IF
         CALL MSGWRT (6)
 30   IF (IPOL.GT.4) IPOL = 1
C                                       Check sort order
      IF (ISORT.EQ.'TB') GO TO 50
         IRET = 1
         WRITE (MSGTXT,1030) ISORT
         GO TO 990
C                                       Check for all ant. selected
 50   ALLANT = T
      ALLBAS = T
      DO 100 I = 1,50
         ANTENS(I) = 0
         ALLANT = ALLANT .AND. (XANT(I).EQ.0)
         ALLBAS = ALLBAS .AND. (XBASE(I).EQ.0)
CCC         ALLANT = ALLANT .AND. (ABS (XANT(I)).LE.1.0E-10)
CCC         ALLBAS = ALLBAS .AND. (ABS (XBASE(I)).LE.1.0E-10)
 100     CONTINUE
      IF (ALLANT.OR.ALLBAS) GO TO 500
C                                       Not all selected - make list
         NEXT = 0
C                                       ANTENNAS array.
         DO 120 I = 1,50
            IF (XANT(I).EQ.0) GO TO 120
               NEXT = NEXT + 1
               ANTENS(NEXT) = XANT(I)
 120        CONTINUE
C                                       Remove duplicates
         CALL IMERGE (NEXT, ANTENS, NEXT)
C                                       Fix input array for latter
         DO 130 I = 1,50
            IF (I.LE.NEXT) XANT(I) = ANTENS(I)
            IF (I.GT.NEXT) XANT(I) = 0
 130        CONTINUE
C                                       BASELINE array.
         DO 150 I = 1,50
            IF (XBASE(I).EQ.0) GO TO 150
C                                       See if already have
               DO 140 J = 1, NEXT
                  IF (XBASE(I).EQ.ANTENS(J)) GO TO 150
 140              CONTINUE
C                                       New antenna
                  NEXT = NEXT + 1
                  ANTENS(NEXT) = XBASE(I)
 150        CONTINUE
C                                       Fill ANTLAB with baseline
C                                       numbers.
 500  DO 510 I = 1,MXBAS
         ANTLAB(I,1) = 0
         ANTLAB(I,2) = 0
 510     CONTINUE
C                                       Find number of antennas
      LUN = 28
      CALL GETNAN (DISKIN, CNOIN, CATBLK, LUN, UBUFF, NUMAN, IRET)
      IF ((IRET.EQ.0) .AND. (NUMAN(1).GE.SUBARR)) GO TO 530
C                                       If no AN tables assume that this
C                                       must be the VLA.
         IF (IRET.EQ.10) THEN
            MSGTXT = 'No AN tables - I assume that this must be VLA' //
     *         ' data with 28 antennas'
            CALL MSGWRT (5)
            NUMAN(1) = MAX (1, SUBARR)
            CALL FILL (NUMAN(1), 28, NUMAN(2))
            IRET = 0
            GO TO 530
            END IF
         IF (NUMAN(1).LE.SUBARR) WRITE (MSGTXT,1510) NUMAN(1),
     *      SUBARR
         IF (IRET.NE.0) WRITE (MSGTXT,1511) IRET
         IRET = 2
         GO TO 990
 530  NOANT = NUMAN(SUBARR+1)
      IF (SUBARR.LE.0) NOANT = NUMAN(2)
C                                       Fill  arrays
      NEXT = 1
      DO 600 I = 1,50
         IANT1 = XANT(I)
         IF (ALLANT) IANT1 = I
         IF ((IANT1.LE.0) .OR. (IANT1.GT.NOANT)) GO TO 600
         LIMIT = 1
         IF (ALLBAS) LIMIT = I + 1
         IF (LIMIT.GT.50) LIMIT = 50
         DO 590 J = LIMIT,50
            IANT2 = XBASE(J)
            IF (ALLBAS) IANT2 = J
            IF ((IANT2.LE.0) .OR. (IANT2.GT.NOANT)) GO TO 590
            IF (IANT1.EQ.IANT2) GO TO 590
            IF (ALLANT .AND. (IANT2.LT.IANT1)) GO TO 590
            IF (ALLANT.OR.ALLBAS.OR.(IANT2.GT.IANT1)) GO TO 580
C                                       Check for redundant baselines
            JANT = MIN (IANT1, IANT2)
            IANT = MAX (IANT1, IANT2)
            LIM = NEXT - 1
            DO 570 K = 1,LIM
               IF ((JANT.EQ.ANTLAB(K,1)) .AND. (IANT.EQ.ANTLAB(K,2)))
     *            GO TO 590
 570           CONTINUE
 580           ANTLAB(NEXT,1) = MIN (IANT1, IANT2)
               ANTLAB(NEXT,2) = MAX (IANT1, IANT2)
               NEXT = NEXT + 1
 590           CONTINUE
 600     CONTINUE
      NUMBAS = NEXT - 1
      IF (NUMBAS.GT.0) GO TO 999
C                                       No baselines
      IRET = 2
      WRITE (MSGTXT,1600)
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('Warning: Stokes=',A4,' not allowed, using Stokes=',A4)
 1030 FORMAT ('INCORRECT SORT ORDER = ',A2,' NOT TB')
 1510 FORMAT ('FEWER SUBARRAYS AVAILABLE (',I3,') THAN SPECIFIED ',I4)
 1511 FORMAT ('COLSET: GETNAN ERROR ',I3,' SEARCHING ANTENNA TABLES')
 1600 FORMAT ('ERROR: NO BASELINES SPECIFIED!')
      END
      SUBROUTINE BASAVG (NUMVIS, NUMBAS, ANTLAB, AMPVEC, DTYPE, DT,
     *   CHNSEL, DOSPEC, SCANV, TIME, NUSCAN, SCANUM, RPARM, VIS, AVTIM,
     *   AVU, AVV, AVW, IERR)
C-----------------------------------------------------------------------
C   Reads a uv data base and returns averages of amp, phase or the RMS
C   scatter for selected baselines.
C   Needs to be initialized by a call to UVGET.
C   The  order of the baselines returned in SCANV is defined by
C   the order in the array NATLAB.  All data specified  (channels, IFs)
C   are averaged but only one polarization is allowed.
C   Inputs:
C     NUMVIS       I    Current visibility number
C     NUMBAS       I    Number of baselines to average.
C     ANTLAB(MXBASE,2)  I    The First (*,1) and second (*,2) antenna
C                      numbers of each baseline selected.
C     AMPVEC       L    If true do ampscalar averaging else vector.
C     DTYPE        I    Output type, 0 => amplitude, 1=> phase,
C                       2 => amplitude RMS, 3 => weight.
C     DT           R    Averaging time in days
C     CHNSEL(3,10) I    Channel selection
C     DOSPEC       L    TRUE if spectral averaging to be done
C   Input/Output:
C     RPARM(20)    R    Random parameter array, first record of call.
C                      (1) = 'INDE' => don't use.
C                      (2) if single baseline averaged then RPARM
C                          reflects the data output.
C     VIS(3,*)     R    Visibility array, first record of call.
C   Outputs:
C     SCANV(MXBASE)R   The result for baselines in ANTLAB
C     TIME(8)      I    Time range, start, stop; days, hours, min, sec.
C                       Unless NUSCAN only first 4 values are set.
C     NUSCAN       L    True IF the first record in a new scan.
C     AVTIM        R    Average time (days) of output record
C     AVU          R    Average u of output record
C     AVV          R    Average v of output record
C     AVW          R    Average w of output record
C     IERR         I    Return code, 0 => OK, -1 => out of data,
C                       > 0 => failed.
C   Output to common in D/CSOU.INC
C     SNAME(4)     R    Source name (16 char. 4 / word.)
C     QUAL         I    Source qualifier.
C     CALCOD       R    Calibrator code 4 char.
C     FLUX(4,IF)   R    Total flux density I, Q, U, V pol, (Jy) each IF
C     FREQO(IF)    D    Frequency offset (Hz)
C   Note:   If the end of data is encountered (IERR=-1) then UVGET is
C   called with OPCODE='CLOS'.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      LOGICAL   AMPVEC, NUSCAN, DONE1, GOTDAT, DOSPEC
      INTEGER   DTYPE, TIME(8), NUMBAS, IERR, MXANT, I, JA1, JA2,
     *   SUNUM, JERR, ISLUN, IBASE, IVIS, COUNT(MXBASE), KVIS, SCANUM,
     *   CNTTIM, NUMFRQ, NUMPLZ, CHNSEL(3,10), ANTLAB(MXBASE,2),
     *   NUMVIS, IDAY, IVSCNT
      REAL      RPARM(20), VIS(3,*), DT, T1, AMP, SQRT, SUMTIM,
     *   WORK(MXBASE,4), TEMP, TEMP1, TEMP2, SCANV(MXBASE),
     *   SUMU, SUMV, SUMW, AVTIM, AVU, AVV, AVW, TLAST, CT, DTUTC
      DOUBLE PRECISION X8
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANT.INC'
      SAVE TLAST, DTUTC, IVSCNT
      DATA ISLUN /26/
      DATA MXANT /MAXANT/
C-----------------------------------------------------------------------
      IF (NUMVIS.EQ.0) THEN
         TLAST = -1.0
         DTUTC = DATUTC / 86400.0
         IVSCNT = 0
         END IF
C                                       See if first record read
      DONE1 = RPARM(1).NE.FBLANK
      GOTDAT = .FALSE.
      IERR = 0
C                                       Clear arrays
 10   CONTINUE
      DO 50 I = 1,NUMBAS
         COUNT(I) = 0
         WORK(I,1) = 0.0
         WORK(I,2) = 0.0
         WORK(I,3) = 0.0
         WORK(I,4) = 0.0
         SCANV(I) = FBLANK
 50      CONTINUE
      CNTTIM = 0
      SUMTIM = 0.0
      SUMU = 0.0
      SUMV = 0.0
      SUMW = 0.0
      AVTIM  = 0.0
      AVU = 0.0
      AVV = 0.0
      AVW = 0.0
C                                       Initialize time
      T1 = 1.0E10
C                                       Save scan number (0= no index)
      NUSCAN = SCANUM.NE.INXRNO
      SCANUM = INXRNO
      KVIS = (LREC-NRPARM) / 3
      NUMFRQ = CATBLK(KINAX+JLOCF)
      NUMPLZ = CATBLK(KINAX+JLOCS)
C                                       Loop reading data
 100     IF (.NOT.DONE1) THEN
            CALL UVGET ('READ', RPARM, VIS, IERR)
            IVSCNT = IVSCNT + 1
            END IF
         IF (IERR.GT.0) GO TO 999
         IF (IERR.EQ.-1) GO TO 500
         DONE1 = .FALSE.
C
         CT = RPARM(ILOCT+1) - DTUTC
C                                       Set up first time boundary
         IF (IVSCNT.EQ.1) THEN
            IDAY = CT
            X8 = (CT - IDAY) / DT
            TLAST = IDAY + DINT (X8) * DT + DT
            END IF
C                                       Spectral averaging
         IF ((DOSPEC) .AND. (IVSCNT.GT.0)) THEN
            CALL AVGCIF (VIS, NUMPLZ, NUMFRQ, BCHAN, ECHAN, BIF,
     *         EIF, CHNSEL, KNCS, VIS)
            END IF
C                                       Antenna numbers
         JA1 = RPARM(ILOCB+1) / 256. + 0.1
         JA2 = RPARM(ILOCB+1) - JA1 * 256 + 0.1
C                                       Find baseline
         DO 110 I = 1,NUMBAS
            IBASE = I
            IF ((JA1.EQ.ANTLAB(I,1) .AND. (JA2.EQ.ANTLAB(I,2))))
     *         GO TO 120
 110        CONTINUE
C                                       Not wanted
         GO TO 100
C
 120     GOTDAT = .TRUE.
C                                       Check if avg. or scan done
         IF ((INXRNO.GT.SCANUM) .OR. (IERR.LT.0) .OR.
     *      (CT.GT.TLAST)) GO TO 500
C                                       Time
         SUMTIM = SUMTIM + RPARM(ILOCT+1)
         SUMU = SUMU + RPARM(ILOCU+1)
         SUMV = SUMV + RPARM(ILOCV+1)
         SUMW = SUMW + RPARM(ILOCW+1)
         IF (T1.GT.1.0E9) T1 = RPARM(ILOCT+1)
         CNTTIM = CNTTIM + 1
C                                       Source no.
         SUNUM = CURSOU
         IF (AMPVEC) GO TO 200
C                                       Vector average:
      INCLUDE 'INCS:ZVD.INC'
            DO 150 IVIS = 1,KVIS
               IF (VIS(3,IVIS).LE.0.0) GO TO 150
               COUNT(IBASE) = COUNT(IBASE) + 1
               WORK(IBASE,1) = WORK(IBASE,1) + VIS(1,IVIS)
               WORK(IBASE,2) = WORK(IBASE,2) + VIS(2,IVIS)
               WORK(IBASE,3) = WORK(IBASE,3) + VIS(1,IVIS) ** 2
               WORK(IBASE,4) = WORK(IBASE,4) + VIS(2,IVIS) ** 2
 150           CONTINUE
         GO TO 100
C                                       Ampscalar averaging
      INCLUDE 'INCS:ZVD.INC'
 200     DO 250 IVIS = 1,KVIS
            IF (VIS(3,IVIS).LE.0.0) GO TO 250
            AMP = SQRT (VIS(1,IVIS) * VIS(1,IVIS) +
     *         VIS(2,IVIS) * VIS(2,IVIS))
            VIS(1,IVIS) = VIS(1,IVIS) + 1.0E-20
            COUNT(IBASE) = COUNT(IBASE) + 1
            WORK(IBASE,1) = WORK(IBASE,1) + AMP
            IF (DTYPE.EQ.1) WORK(IBASE,2) = WORK(IBASE,2) +
     *         ATAN2 (VIS(2,IVIS), VIS(1,IVIS))
            WORK(IBASE,3) = WORK(IBASE,3) + AMP*AMP
            WORK(IBASE,4) = WORK(IBASE,4) + VIS(3,IVIS)
 250        CONTINUE
            GO TO 100
C                                       Scan done
C                                       See if have any data.
 500  IF ((.NOT.GOTDAT) .AND. (IERR.EQ.0)) GO TO 10
      IF (.NOT.GOTDAT) GO TO 800
      IF (.NOT.AMPVEC) THEN
C                                       Vector averaging
         DO 550 I = 1,NUMBAS
C                                       Amplitude
            IF ((DTYPE.EQ.0) .AND. (COUNT(I).GT.0))
     *         SCANV(I) = SQRT (WORK(I,1)*WORK(I,1) +
     *            WORK(I,2)*WORK(I,2)) / COUNT(I)
C                                       Phase
            IF ((DTYPE.EQ.1) .AND. (COUNT(I).GT.0))
     *         SCANV(I) = ATAN2 (WORK(I,2), WORK(I,1)+1.0E-20)
C                                       RMS
            IF ((DTYPE.EQ.2) .AND. (COUNT(I).GT.2)) THEN
               TEMP1 = (COUNT(I) * WORK(I,3) - (WORK(I,1)**2))
               TEMP2 = (COUNT(I) * WORK(I,4) - (WORK(I,2)**2))
               TEMP = TEMP1 + TEMP2
               IF (TEMP.LT.0.0) TEMP = 0.0
               SCANV(I) = SQRT (TEMP) / COUNT(I)
               END IF
 550           CONTINUE
      ELSE
C                                       Else Amp scalar ave
         DO 650 I = 1,NUMBAS
C                                       Amplitude
            IF ((DTYPE.EQ.0) .AND. (COUNT(I).GT.0))
     *         SCANV(I) = WORK(I,1) / COUNT(I)
C                                       Phase
            IF ((DTYPE.EQ.1) .AND. (COUNT(I).GT.0))
     *         SCANV(I) = WORK(I,2) / COUNT(I)
C                                       RMS
            IF ((DTYPE.EQ.2) .AND. (COUNT(I).GT.2)) THEN
               TEMP = (COUNT(I) * WORK(I,3) - (WORK(I,1)**2))
               IF (TEMP.LT.0.0) TEMP = 0.0
               SCANV(I) = SQRT (TEMP) / COUNT(I)
               END IF
C                                       Weight
            IF ((DTYPE.EQ.3) .AND. (COUNT(I).GT.0))
     *         SCANV(I) = WORK(I,4) / COUNT(I)
 650        CONTINUE
C                                       end if vector averaging
         END IF
C                                       Get source info
      IF (.NOT.NUSCAN) GO TO 800
      CALL GETSOU (SUNUM, IUDISK, IUCNO, CATUV, ISLUN, JERR)
      IF (JERR.EQ.11) THEN
C                                       Didn't find source
         WRITE (MSGTXT,1750) SUNUM
         CALL MSGWRT (8)
         JERR = 0
         END IF
      IF (JERR.LE.0) GO TO 800
         IERR = JERR
         WRITE (MSGTXT,1700) JERR
         GO TO 990
C                                       Time
 800  T1 = 0
      IF (CNTTIM.GT.0) THEN
         T1 = SUMTIM / CNTTIM
         AVTIM = T1
         AVU = SUMU / CNTTIM
         AVV = SUMV / CNTTIM
         AVW = SUMW / CNTTIM
         END IF
      CALL TODHMS (T1, TIME)
C                                       Set up new time boundary
      IDAY = CT
      X8 = (CT - IDAY) / DT
      TLAST = IDAY + DINT (X8) * DT + DT
C                                       If end of data, close UVGET
CCC      IF (IERR.LT.0) CALL UVGET ('CLOS', RPARM, VIS, JERR)
CCC      IF (JERR.NE.0) IERR = JERR
CCC      IF ((IERR.LT.0) .AND. (.NOT.GOTDAT)) IERR = -2
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1700 FORMAT ('BASAVG: ERROR',I3,' READING SOURCE TABLE')
 1750 FORMAT ('BASAVG: SOURCE ',I3,' NOT IN SU TABLE')
      END
      SUBROUTINE BASLST (NUMAN, ISUB, ANTENN, BASELN, NBASE, ANT1, ANT2)
C-----------------------------------------------------------------------
C   Determine a list of selected antenna pairs from the standard
C   ANTENNA and BASELINE adverbs.  BASLST differs from AN10RS in that
C   BASLST will always produce a full list of antenna pairs while
C   AN10RS will produce an abbreviated list if there are no
C   entries in ANTENNAS or BASELINE.
C
C   Inputs:
C      NUMAN    I(51)   NUMAN(1) is the number of subarrays present.
C                       NUMAN(i) is the maximum antenna number for
C                       subarray i-1, for i > 1.
C      ISUB     I       The subarray number for which a list of
C                       baselines is required: must be greater than
C                       zero (and is not checked!).
C      ANTENN   R(50)   The values of the ANTENNAS adverb.
C      BASELN   R(50)   The values of the BASELINE adverb.
C
C   Input/output:
C      NBASE    I       The maximum number of baselines to list on
C                       input.  Either the number of baselines found
C                       or zero or zero on output.  A value of zero
C                       indicates that more than the maximum number of
C                       baselines met the selection criteria.
C
C   Outputs:
C      ANT1     I(*)    List of first elements of antenna pairs.
C      ANT2     I(*)    List of second elements of antenna pairs.
C                       For all i, 1 <= i <= NBASE, ANT2(i) > ANT1(i).
C-----------------------------------------------------------------------
      INTEGER   NUMAN(51), ISUB
      REAL      ANTENN(50), BASELN(50)
      INTEGER   NBASE, ANT1(*), ANT2(*)
C                                        DOSEL is true if baselines
C                                        listed in the adverbs are
C                                        to be deselected rather
C                                        selected.
      LOGICAL   DESEL
C                                        ANT lists the absolute values
C                                        of entries in the ANTENNAS
C                                        adverb, NANT is the number
C                                        of non-zero entries.
      INTEGER   ANT(50), NANT
C                                        BAS lists the absolute values
C                                        of entries in the BASELINE
C                                        adverb, NBAS is the number
C                                        of non-zero entries.
      INTEGER   BAS(50), NBAS
C                                        NREQ is the number of
C                                        baselines that match the
C                                        request criteria that have
C                                        been found so far.
      INTEGER   NREQ
C
      INTEGER   I, J
C
      LOGICAL   REQBAS
      EXTERNAL  REQBAS
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
C-----------------------------------------------------------------------
      IF ((ISUB.GT.0) .AND. (ISUB.LE.NUMAN(1))) THEN
         DESEL = .FALSE.
         NREQ = 0
         NANT = 0
         NBAS = 0
         DO 10 I = 1, 50
            IF (ANTENN(I).LT.0.0) DESEL = .TRUE.
            IF (ABS (ANTENN(I)).GT.0.5) THEN
               NANT = NANT + 1
               ANT(NANT) = NINT (ABS (ANTENN(I)))
               END IF
            IF (ABS (BASELN(I)).GT.0.5) THEN
               NBAS = NBAS + 1
               BAS(NBAS) = NINT (ABS (BASELN(I)))
               END IF
   10       CONTINUE
C                                       If NANT = 0 and NBAS > 0 then
C                                       the code below will fail, in
C                                       this case we need to fill up the
C                                       local array ANT with the antenna
C                                       numbers.
         IF ((NANT.EQ.0) .AND. (NBAS.GT.0)) THEN
            NANT = NUMAN(ISUB+1)
            DO 40 I = 1, NANT
               ANT(I) = TELNO(I)
   40          CONTINUE
            END IF
C
         DO 30 I = 1, NUMAN(ISUB+1) - 1
            DO 20 J = I+1, NUMAN(ISUB+1)
               IF (REQBAS (I, J, DESEL, ANT, NANT, BAS, NBAS)) THEN
                  IF (NREQ.EQ.NBASE) THEN
C                                        Too many baselines.
                     NBASE = 0
                     GO TO 999
                  ELSE
                     NREQ = NREQ + 1
                     ANT1(NREQ) = I
                     ANT2(NREQ) = J
                     END IF
                  END IF
   20          CONTINUE
   30       CONTINUE
         NBASE = NREQ
      ELSE
C                                        Non-existent subarray.
         NBASE = 0
         END IF
C
  999 RETURN
      END

      SUBROUTINE POPSRD (OP, RV, DV)
C-----------------------------------------------------------------------
C! Converts POPS double real to to/from true double precision
C# POPS
C-----------------------------------------------------------------------
C;  Copyright (C) 2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   POPSRD converts the 2 real representation of doubles to or from
C   true double precision
C   Input:
C      OP   C*(*)   'R2D' or 'D2R'
C   In/out:
C      RV   R(2)    Reals
C      DV   D       Double precision
C   This routine should not be optimized in order to avoid premature
C   conversion to real
C-----------------------------------------------------------------------
      CHARACTER OP*(*)
      REAL      RV(2)
      DOUBLE PRECISION DV
C
      DOUBLE PRECISION XX
C-----------------------------------------------------------------------
      IF (OP.EQ.'R2D') THEN
         DV = RV(1)
         IF (RV(2).NE.RV(1)) DV = DV + RV(2)
      ELSE IF (OP.EQ.'D2R') THEN
         RV(1) = DV
         XX = RV(1)
         XX = DV - XX
         RV(2) = XX
         END IF
C
 999  RETURN
      END

      SUBROUTINE SGLAST (IOP)
C-----------------------------------------------------------------------
C! does a SAVE or GET of the K array cataloged as LASTEXIT.
C# POPS-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2003-2004, 2021, 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SGLAST is an AIPS subroutine to GET or SAVE a special area called
C   LASTEXIT as a SAVE / GET file.
C   Input:
C      IOP   I     1 => get, 2 => save
C   Common scratch:
C      /AIPSCR/ I(4352)
C-----------------------------------------------------------------------
      INTEGER   IOP
C
      CHARACTER PHNAME*48, IOPRAT*4, PRGNAM*6, CNAME*12
      INTEGER   LOP, IERR, POTERR, I, J, IVER, JJ, LUNSG, FIND, LUN,
     *   ISIZE, LSIZE, IDPI
      LOGICAL   T, F, WASFIL, FIXIT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DIO.INC'
      DATA LUNSG /27/
      DATA T, F /.TRUE.,.FALSE./
      DATA PRGNAM /'SGLAST'/
C-----------------------------------------------------------------------
      IOPRAT = 'READ'
      IF (IOP.EQ.2) IOPRAT = 'WRIT'
      WASFIL = IOP.NE.2
      LOP = IOP + 2
C                                       locate desired file
      CALL SGLOCA (LOP, IVER, FIXIT)
C                                       cannot do fixit
      IF ((FIXIT) .AND. (IOPRAT.EQ.'READ') .AND. (ERRNUM.EQ.30)) THEN
         ERRNUM = 0
         JBUFF = 'GET LASTEXIT'
         HOLDUF = JBUFF
         IUNIT = 4
C                                       reset file size
         LPAGE = LBLOCK
         MPAGE = KBLOCK + LPAGE
         MSGTXT = 'Warning: out of date LASTEXIT to be corrected' //
     *      ' by GET LASTEXIT'
         CALL MSGWRT (6)
         GO TO 999
         END IF
      IF (ERRNUM.NE.0) GO TO 970
      POTERR = 0
      IF ((LOP.EQ.3) .AND. (IVER.EQ.0)) GO TO 970
      CALL ZPHFIL ('SG', 1, NLUSER, IVER, PHNAME, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       create file if needed
      IF (IOPRAT.EQ.'WRIT') THEN
         ISIZE = MPAGE + 1
         CALL ZEXIST (1, PHNAME, LSIZE, IERR)
         IF (IERR.EQ.0) CALL ZDESTR (1, PHNAME, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.1)) THEN
            POTERR = 50
            GO TO 970
            END IF
C                                       now create it
         CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.1)) THEN
            POTERR = 50
            GO TO 970
            END IF
         END IF
C                                       open SG file
      CALL ZOPEN (LUNSG, FIND, 1, PHNAME, F, T, T, IERR)
      POTERR = 101
      IF (IERR.NE.0) GO TO 965
      LUN = LUNSG
C                                       move K array
      JJ = MPAGE - LPAGE
      POTERR = 61
      IDPI = 2
      J = 1
      DO 35 I = 1,JJ
         CALL ZFIO (IOPRAT, LUN, FIND, IDPI, K(J), IERROR(1))
         IF (IERROR(1).NE.0) GO TO 960
         IDPI = IDPI + 1
         J = J + 256
 35      CONTINUE
C                                       move LISTF
      J = 1
      DO 40 I = 1,LPAGE
         CALL ZFIO (IOPRAT, LUN, FIND, IDPI, LISTF(J), IERROR(1))
         IF (IERROR(1).NE.0) GO TO 960
         IDPI = IDPI + 1
         J = J + 256
 40      CONTINUE
C                                       SG files: write time
      IF (IOP.EQ.2) THEN
         CALL FILL (256, 0, LISTF)
         CALL ZDATE (LISTF(1))
         CALL ZTIME (LISTF(4))
         IDPI = 1
         CALL ZFIO ('WRIT', LUNSG, FIND, IDPI, LISTF, IERR)
         END IF
C                                       Close down: normal
      POTERR = 0
      WASFIL = .TRUE.
      IF (IOP.EQ.2) THEN
         WRITE (MSGTXT,1951)
         CALL MSGWRT (3)
C                                       read - check quality
      ELSE
         CALL ADVERB ('INSEQ', 'I', 1, 1, I, I, CNAME)
         IF (ERRNUM.EQ.0) CALL ADVERB ('INNAME', 'C', 1, 12, I, I,
     *      CNAME)
         IF (ERRNUM.EQ.0) THEN
            WRITE (MSGTXT,1950)
            CALL MSGWRT (3)
         ELSE
            MSGTXT = 'READ LASTEXIT FILE OKAY, BUT CONTENTS WRONG'
            CALL MSGWRT (8)
            END IF
         END IF
C                                       close SG
 960  CALL ZCLOSE (LUNSG, FIND, IERR)
C                                       destroy new SG on err
 965  IF (.NOT.WASFIL) CALL ZDESTR (1, PHNAME, IERR)
C                                       close file ME
 970  CONTINUE
C
      IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.EQ.0) GO TO 999
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         WRITE (MSGTXT,1980) IOPRAT
C
 999  RETURN
C-----------------------------------------------------------------------
 1950 FORMAT ('Recovered POPS environment from last exit')
 1951 FORMAT ('Saved POPS environment in area named ''LASTEXIT''')
 1980 FORMAT ('UNABLE TO ',A,' SAVE/GET FILE NAMED LASTEXIT.  CHECK',
     *   ' $DA01:SG*')
      END

      SUBROUTINE CATIME (IOP, CATREC, IT)
C-----------------------------------------------------------------------
C! stores current, or recovers previous, date and time in packed format
C# Utility Catalog
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CATIME stores the current date and time in CATREC and IT (IOP=1) or
C   fills in IT from CATREC (IOP=2).
C   Inputs:
C      IOP     I      1 => current date, time to CATREC and IT
C                     2 => CATREC translated to IT
C   In/out:
C      CATREC  I(2)   YY+MM+DD, HH+MM+SS
C   Outputs:
C      IT      I(6)   YY (all digits), MM, DD, HH, MM, SS
C-----------------------------------------------------------------------
      INTEGER    IOP, CATREC(2), IT(6)
      INTEGER    J
C-----------------------------------------------------------------------
C                                       time -> CATREC and IT
      IF (IOP.EQ.1) THEN
         CALL ZDATE (IT(1))
         CALL ZTIME (IT(4))
         IF (IT(1).GT.200) IT(1) = IT(1) - 1900
         CATREC(1) = 256 * (256 * IT(1) + IT(2)) + IT(3)
         CATREC(2) = 256 * (256 * IT(4) + IT(5)) + IT(6)
         IT(1) = IT(1) + 1900
C                                       CATREC sets time in IT: date
      ELSE IF (IOP.EQ.2) THEN
         J = CATREC(1)
         IT(3) = MOD (J, 256)
         J = J / 256
         IT(2) = MOD (J, 256)
         IT(1) = J / 256 + 1900
C                                       CATREC sets time in IT: time
         J = CATREC(2)
         IT(6) = MOD (J, 256)
         J = J / 256
         IT(5) = MOD (J, 256)
         IT(4) = J / 256
C                                       Bad IOP
      ELSE
         CALL FILL (6, 0, IT)
         END IF
C
 999  RETURN
      END

      SUBROUTINE TKSLIN (IBR, ISLUN, ISFIND, LABEL, IMOD, RANGE, IDROP,
     *   BLC, TRC, XBLC, XTRC, RANGE2, XFAC, XOFF, CH, YGAP, TEXT,
     *   NTEXT, IFMOD, INPTS, IERR)
C-----------------------------------------------------------------------
C! initialize parameters for plotting a slice directly on a TK graphics
C# Slice Graphics Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2007, 2009, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Given an open slice file TKSLPL will read the first record, do the
C   necessary scaling and initialization of variables, and update the
C   image catalog header.
C   Inputs:
C      IBR     I      Type code: here only use is 3 - 6 plotting model,
C                     else data
C      ISLUN   I      logical unit no. of open slice file.
C      ISFIND  I      FTAB index for slice file.
C      LABEL   I      type of labeling: see adverb LTYPE
C      IDROP   I(2)   the number of slice points to omit from the
C                     beginning/end of the plot.
C   In/out:
C      IMOD    I      model no. to plot (IBR = 3 - 6  only). 0 means
C                     latest.
C      RANGE   R(2)   the minimum and maximum values allowed for
C                     the plot.  If RANGE(1) .GE. RANGE(2) then the map
C                     min and max will be used.
C   Output:
C      BLC     R(2)   bottom left corners of slice plot.
C      TRC     R(2)   top right corner of slice plot.
C      XBLC    R(7)   starting pixel coordinate of slice vector.
C      XTRC    R(7)   ending pixel coordinate of slice vector.
C      RANGE2  R(2)   min and max pixel values.
C      XFAC    R      XFAC * real Y value  +  XOFF = rescaled Y value
C                     between 1 and 4000.
C      XOFF    R      see XFAC.
C      CH      R(4)   Number chars to left,bot,right,top of plot
C      YGAP    R      Place to put first line of TEXT
C      TEXT    C(2)*80  Text to add at bot of plot
C      NTEXT   I      Numbers lines used in TEXT (0, 1, 2)
C      IFMOD   I      Block number of 1st gaussian model data.
C      INPTS   I      No. of points for this slice.
C      IERR    I      error code 0= none.
C  Common:
C      /TKSPCL/  SCALEX     R   X scale factor
C                SCALEY     R   Y scale factor.
C      /WORK/    ISBLK(256)     scratch
C      /MAPHDR/  CATBLK in/out  header - converted for image catlg
C-----------------------------------------------------------------------
      CHARACTER TEXT(2)*80
      INTEGER   IBR, ISLUN, ISFIND, LABEL, IMOD, IDROP(2), NTEXT,
     *   IFMOD, INPTS, IERR
      REAL      RANGE(2), BLC(2), TRC(2), XBLC(7), XTRC(7), RANGE2(2),
     *   XFAC, XOFF, CH(4), YGAP
C
      REAL      X, Y, PIXMAX, PIXMIN, RMAX, XBLC1, XBLC2, XTRC1, XTRC2,
     *   XBLC3, XTRC3, XX, XYRATO, XFLUX(2), RSBLK(256), DX, FQFINC
      INTEGER   I4XTRA, ISBLK(256), INMOD, ICHB, ICHL, ICHR, ICHT, IX1,
     *   IX2, IY1, IY2, NXA, NYA, IROUND
      CHARACTER JY*8, OPTYPE*4
      DOUBLE PRECISION DSBLK(128), FQFREQ
      LOGICAL   ISOLD
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTKS.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /WORK/ ISBLK
      EQUIVALENCE (RSBLK, ISBLK, DSBLK)
      DATA JY /'JY'/
C-----------------------------------------------------------------------
C                                       Read first slice file record
      CALL ZFIO ('READ', ISLUN, ISFIND, 1, ISBLK, IERR)
      IF (IERR.NE.0) GO TO 980
      INPTS = ISBLK(57)
C                                       Get, check g model data.
      IF ((IBR.GE.3) .AND. (IBR.LE.6)) THEN
         IFMOD = ISBLK(59)
         INMOD = ISBLK(58)
         IF (INMOD.EQ.0) GO TO 950
         IF (IMOD.GT.INMOD) GO TO 950
         IF (IMOD.LE.0) IMOD = INMOD
         END IF
C                                       Read 2nd slice rec (inputs).
      CALL ZFIO ('READ', ISLUN, ISFIND, 2, ISBLK, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       pick up image Blc, Trc; Sl size
      CALL RCOPY (7, RSBLK(19), XBLC)
      CALL RCOPY (7, RSBLK(26), XTRC)
      CALL RCOPY (2, RSBLK(34), XFLUX)
      CALL H2CHR (4, 1, RSBLK(33), OPTYPE)
      IF (OPTYPE.EQ.'FLUX') CALL CHR2H (8, JY, 1, CATH(KHBUN))
      IF ((OPTYPE.EQ.'AVER') .OR. (OPTYPE.EQ.'FLUX') .OR.
     *   (OPTYPE.EQ.'LGFL') .OR. (OPTYPE.EQ.'LNFL') .OR.
     *   (OPTYPE.EQ.'ADER') .OR. (OPTYPE.EQ.'FDER') .OR.
     *   (OPTYPE.EQ.'LGAV') .OR. (OPTYPE.EQ.'LNAV')) THEN
         ISOLD = .FALSE.
      ELSE
         ISOLD = .TRUE.
         END IF
      CALL RCOPY (2, RSBLK(34), XFLUX)
      IF (OPTYPE.EQ.'FLUX') CALL CHR2H (8, JY, 1, CATH(KHBUN))
      IF (OPTYPE.EQ.'LGFL') CALL CHR2H (8, 'LOG10 JY', 1, CATH(KHBUN))
      IF (OPTYPE.EQ.'LNFL') CALL CHR2H (8, 'LN (JY)', 1, CATH(KHBUN))
      IF (OPTYPE.EQ.'FDER') CALL CHR2H (8, 'dJY / dx', 1, CATH(KHBUN))
      IF (ISOLD) THEN
         FQFINC = 0.0
         FQFREQ = 0.0D0
      ELSE
         FQFINC = RSBLK(36)
         FQFREQ = DSBLK(19)
         END IF
C                                       Figure out range of pixel val.
C                                       Default to slice max min.
      IF (RANGE(1).GE.RANGE(2)) THEN
         RANGE(1) = XFLUX(1)
         RANGE(2) = XFLUX(2)
         END IF
C                                       Range in pixel values.
 20   DX = 0.03 * (RANGE(2) - RANGE(1))
      RANGE2(2) = RANGE(2) + DX
      RANGE2(1) = RANGE(1) - DX
C                                       Calc fac & offset to keep BLC
C                                       TRC within range to prevent
C                                       overflow in graphics routines.
      PIXMAX = RANGE2(2)
      PIXMIN = RANGE2(1)
      XFAC = 39999.0 / (PIXMAX - PIXMIN)
      XOFF = 40000.0 - XFAC * PIXMAX
      RANGE2(1) = XFAC * RANGE2(1) + XOFF
      RANGE2(2) = XFAC * RANGE2(2) + XOFF
      RMAX = 2.0 ** (NBITWD-1) - 1
C                                       Must reduce users max value.
      IF (RANGE2(2).GT.RMAX) THEN
         MSGTXT = '** WARNING ** REDUCING Y MAX INPUT BY USER'
         CALL MSGWRT (6)
         RANGE2(2) = RMAX
         END IF
C                                       Must increase users min.
      IF (RANGE2(1).LT.-RMAX) THEN
         MSGTXT = '** WARNING ** INCREASING Y MIN INPUT BY USER'
         CALL MSGWRT (6)
         RANGE2(1) = -RMAX
         END IF
C                                       Round and back calc range.
      RANGE2(1) = IROUND (RANGE2(1))
      RANGE2(2) = IROUND (RANGE2(2))
C                                       header max/min if needed
      IF (RANGE2(1).GE.RANGE2(2)) THEN
         RANGE(1) = CATR(KRDMN)
         RANGE(2) = CATR(KRDMX)
         GO TO 20
         END IF
      RANGE(1) = (RANGE2(1) - XOFF) / XFAC
      RANGE(2) = (RANGE2(2) - XOFF) / XFAC
      BLC(2) = RANGE2(1)
      TRC(2) = RANGE2(2)
C                                       Save original slice pts.
      XBLC1 = XBLC(1)
      XBLC2 = XBLC(2)
      XBLC3 = XBLC(3)
      XTRC1 = XTRC(1)
      XTRC2 = XTRC(2)
      XTRC3 = XTRC(3)
C                                       Initialize plot file line drw.
      CALL SLBINI (IDROP, INPTS, RANGE, BLC, TRC, XBLC, XTRC, FQFREQ,
     *   FQFINC, CATBLK(IIDEP), LABEL, YGAP, CH, TEXT, NTEXT)
      XYRATO = (TRC(2) - BLC(2)) / (TRC(1) - BLC(1))
      IX1 = BLC(1) + .5
      IY1 = BLC(2) + .5
      IX2 = TRC(1) + .5
      IY2 = TRC(2) + .5
      ICHL = CH(1) * CSIZTK(1) + .5
      ICHB = CH(2) * CSIZTK(2) + .5
      ICHR = CH(3) * CSIZTK(1) + .5
      ICHT = CH(4) * CSIZTK(2) + .5
      NYA = MAXXTK(2) - ICHT -ICHB -1
      NXA = MAXXTK(1) - ICHL - ICHR - 1
C                                       compute scaling
      X = IX2
      X = ABS (X - IX1)
      XX = X * XYRATO
      Y = IY2
      Y = ABS (Y - IY1)
      IF ((XX.LE.0.0) .OR. (Y.LE.0.0)) THEN
         MSGTXT = 'SCALING ERROR'
         CALL MSGWRT (8)
         IERR = 1
         GO TO 999
         END IF
      IF ((XX/Y).LE.FLOAT(NXA)/FLOAT(NYA)) THEN
         SCALEY = NYA / Y
         SCALEX = SCALEY * Y / X
      ELSE
         SCALEX = NXA / X
         SCALEY = SCALEX * X / Y
         END IF
C
      NXA = SCALEX * X + ICHL + ICHR
      RX0 = ICHL + MAX (0, MAXXTK(1)-NXA) / 2 + 1
      NYA = SCALEY * Y + ICHB + ICHT
      RY0 = ICHB + MAX (0, MAXXTK(2)-NYA) / 2 + 1
C                                       Put stuff in image catalog.
      CATBLK(IIWIN  ) = IX1
      CATBLK(IIWIN+1) = IY1
      CATBLK(IIWIN+2) = IX2
      CATBLK(IIWIN+3) = IY2
      CATBLK(IICOR  ) = RX0 + 0.5
      CATBLK(IICOR+1) = RY0 + 0.5
      CATBLK(IICOR+2) = RX0 + X * SCALEX + .5
      CATBLK(IICOR+3) = RY0 + Y * SCALEY + .5
      CATBLK(IIPLT) = 5
      CATBLK(IIOTH) = LABEL
      CATBLK(IIOTH+1) = IDROP(1)
      CATBLK(IIOTH+2) = IDROP(2)
      I4XTRA = IIOTH + 3
      CATR(I4XTRA  ) = XBLC1
      CATR(I4XTRA+1) = XBLC2
      CATR(I4XTRA+2) = XTRC1
      CATR(I4XTRA+3) = XTRC2
      CATR(I4XTRA+4) = XBLC3
      CATR(I4XTRA+5) = XTRC3
      I4XTRA = I4XTRA + 6
      I4XTRA = I4XTRA/2 + 1
      CATD(I4XTRA) = FQFREQ
      I4XTRA = 2*I4XTRA + 1
      CATR(I4XTRA) = FQFINC
      CATR(IRRAN) = RANGE(1)
      CATR(IRRAN+1) = RANGE(2)
C
      RX0 = RX0 - BLC(1) * SCALEX + .5
      RY0 = RY0 - BLC(2) * SCALEY + .5
      GO TO 999
C                                       Model requested not avail.
 950  WRITE (MSGTXT,1950) IMOD, INMOD
      CALL MSGWRT (6)
      IERR = 1
      GO TO 999
C                                       Error reading slice file.
 980  MSGTXT = 'ERROR READING SLICE FILE HEADER'
      CALL MSGWRT (8)
C                                       Return values.
 999  RETURN
C-----------------------------------------------------------------------
 1950 FORMAT ('GAUSSIAN MODEL',I6,' REQUESTED. ONLY',I6,' AVAILABLE.')
      END

      SUBROUTINE OBINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IOBRNO, OBKOLS, OBNUMV, IERR)
C----------------------------------------------------------------------
C! Creates and initializes a spacecraft orbit (OB) table
C# EXT-appl
C----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2000, 2006-2007, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C----------------------------------------------------------------------
C   Creates and initializes spacecraft orbit (OB) tables
C   Inputs:
C      OPCODE     C*4       Operation code:
C                           'WRIT' = create/init for write or read
C                           'READ' = open for read only
C      BUFFER     I(512)    I/O buffer and related storage, also
C                           defines file is open.
C      DISK       I         Disk volume
C      CNO        I         Catalog slot number
C      CATBLK     I(256)    Catalog header block
C      LUN        I         Logical unit number for table I/O
C   Input/output:
C      VER        I         OB table version
C   Output:
C      IOBRNO     I         Next row number; start of file if READ,
C                           the last record plus one if WRIT
C      OBKOLS     I(MAXOBC) The column pointer array in order:
C                           ANTENNA NO, SUBARRAY, TIME, ORBXYZ,
C                           VELXYZ, SUN ANGLE, ECLIPSE, ORIENTATION
C      OBNUMV     I(MAXOBC) Element count in each column
C      IERR       I         Return code (0=>ok, else error)
C----------------------------------------------------------------------
      INCLUDE 'INCS:POBV.INC'
      CHARACTER OPCODE*4
      INTEGER BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, IOBRNO,
     *   OBKOLS(MAXOBC), OBNUMV(MAXOBC), IERR
C
      INCLUDE 'INCS:PTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      LOGICAL T, DOREAD, NEWFIL
      CHARACTER LTOB(MAXOBC)*24, LTTOB*56, LUNTOB(MAXOBC)*8,
     *   LKEYOB(NKEYOB)*8
      INTEGER NREC, NCOL, NKEY, NDATA, DTYP(MAXOBC), DATP(128,2), I,
     *   ITEMP(6), NTTOB, IPOINT, IPT, KLOCS(NKEYOB), KEYVAL(NKEYOB),
     *   KEYTYP(NKEYOB), JERR, NC, ITRIM
      HOLLERITH HOLTMP(6)
      EQUIVALENCE (HOLTMP, ITEMP)
      DATA LTOB /'ANTENNA_NO              ',
     *   'SUBARRAY                ', 'TIME                    ',
     *   'ORBXYZ                  ', 'VELXYZ                  ',
     *   'SUN_ANGLE               ', 'ECLIPSE                 ',
     *   'ORIENTATION             '/
      DATA LTTOB /'SPACECRAFT ORBIT TABLE '/
      DATA LUNTOB /2*'        ', 'DAYS    ', 'METERS  ', 'M/SEC   ',
     *   'DEGREES ', 'DAYS    ', 'DEGREES '/
      DATA LKEYOB /'TABREV  '/
      DATA NTTOB /56/
      DATA T /.TRUE./
C----------------------------------------------------------------------
C                                       Initialization
      IERR = 0
C                                       Check OPCODE
      DOREAD = (OPCODE.EQ.'READ')
C                                       Set up needed variables
      NREC = 30
      NCOL = MAXOBC
      IF (DOREAD) NCOL = 0
      NKEY = NKEYOB
      NDATA = MAXOBC
      CALL FILL (NDATA, 0, OBKOLS)
      CALL FILL (NDATA, 0, OBNUMV)
C                                       Fill in types, lengths:
C                                       See Going AIPS, Vol 2, p13-3.
      IF (.NOT.DOREAD) THEN
         DTYP(OBIANT) = TABINT + 10
         DTYP(OBISUB) = TABINT + 10
         DTYP(OBDTIM) = TABDBL + 10
         DTYP(OBDPOS) = TABDBL + 10 * 3
         DTYP(OBDVEL) = TABDBL + 10 * 3
         DTYP(OBRANG) = TABFLT + 10 * 3
         DTYP(OBRECL) = TABFLT + 10 * 4
         DTYP(OBRORI) = TABFLT + 10
         CALL COPY (NCOL, DTYP, DATP(1,2))
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'OB', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'OBINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
C                                       Get number of records
      IOBRNO = BUFFER(5) + 1
      IF (DOREAD) IOBRNO = 1
      NKEY = NKEYOB
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Column labels
         DO 40 I = 1, NCOL
            CALL CHR2H (24, LTOB(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'OBINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, LUNTOB(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'OBINI', IERR)
               GO TO 990
               END IF
40          CONTINUE
C                                       Fill in table title
         CALL CHR2H (NTTOB, LTTOB, 1, BUFFER(101))
C                                       Write keywords if table created
         IPOINT = 1
         IPT = 1
C                                       Table revision
         KLOCS(IPT) = IPOINT
         KEYTYP(IPT) = TABINT
         KEYVAL(IPOINT) = IOBREV
C                                       Write to the OB table
         CALL TABKEY ('WRIT', LKEYOB, NKEYOB, BUFFER, KLOCS, KEYVAL,
     *      KEYTYP, IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'OBINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         CALL TABKEY ('READ', LKEYOB, NKEYOB, BUFFER, KLOCS, KEYVAL,
     *      KEYTYP, IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'OBINI', IERR)
            GO TO 990
            END IF
         END IF
C                                       Get array indices:
C                                       Prevent problems with FNDCOL -
C                                       close to flush the buffers
C                                       and then reopen.
      CALL TABIO ('CLOS', 0, 0, BUFFER, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'OBINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
C                                       Re-open
      CALL TABINI (OPCODE, 'OB', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'OBINI', IERR)
         GO TO 990
         END IF
C
      CALL FNDCOL (NDATA, LTOB, 24, T, BUFFER, OBKOLS, JERR)
C                                       Get array indices and no. val.
      DO 150 I = 1,NDATA
         IPOINT = OBKOLS(I)
         IF (IPOINT.GT.0) THEN
            OBKOLS(I) = DATP(IPOINT,1)
            OBNUMV(I) = DATP(IPOINT,2) / 10
            IF (OBNUMV(I).LE.0) THEN
               NC = ITRIM (LTOB(I))
               WRITE (MSGTXT,1100) LTOB(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            OBKOLS(I) = -1
            OBNUMV(I) = 0
            NC = ITRIM (LTOB(I))
            WRITE (MSGTXT,1101) LTOB(I)(:NC)
            CALL MSGWRT (6)
            END IF
150      CONTINUE
C
      GO TO 999
C                                       Error
990   WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C                                       Exit
999   RETURN
C----------------------------------------------------------------------
 1100 FORMAT ('OBINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('OBINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('OBINI: ERROR INITIALIZING SPACECRAFT ORBIT TABLE FOR ',
     *   A4)
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER   NPARMS
      PARAMETER (NPARMS=10)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                                       Uses PAOOF.INC
C                      1        2          3         4        5
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'OUTNAME',
C            6           7          8       9        10
     *   'OUTCLASS', 'OUTDISK', 'OUTSEQ', 'APARM', 'BADDISK'/
C                    1       2       3       4       5       6
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOACAR, OOACAR,
C           7       8      9       10
     *   OOAINT, OOAINT, OOARE, OOAINT/
C                   1    2    3    4    5    6    7    8     9    10
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 12,1, 6,1, 1,1, 1,1, 10,1, 10,1/
C        11   12   13    14   15   16   17   18   19   20   21   22
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(10)
      LOGICAL   LDUM(10)
      REAL      RDUM(10)
      DOUBLE PRECISION DDUM(5)
      EQUIVALENCE (DDUM, RDUM, IDUM, LDUM)
      COMMON /UBAVGG/ DDUM
LOCAL END
      PROGRAM UBAVG
C-----------------------------------------------------------------------
C! Baseline dependent time averaging of uv data
C# UV Object-Oriented
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Baseline dependent time averaging of uv data
C   INNAME                             Input UV data (name)
C   INCLASS                            Input UV data (class)
C   INSEQ                              Input UV data (seq. #)
C   INDISK                             Input UV data disk drive #
C   OUTNAME                            Output uvdata name (name)
C   OUTCLASS                           Output uv data class
C   OUTDISK                            Output uvdata disk drive #
C   OUTSEQ          -1.0    32000.0    Output seq. no.
C   APARM                              (1) max. time (sec)
C                                      (2) = fov (min)
C   BADDISK                            Disk drive #'s to avoid
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, UVIN*36, UVOUT*36
      INTEGER  IRET, BUFF(256)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'UBAVG '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL UBAIN (PRGM, UVIN, UVOUT, IRET)
C                                       Average
      IF (IRET.EQ.0) CALL UVBAVG (UVIN, UVOUT, IRET)
C                                       History
      IF (IRET.EQ.0) CALL UBAHIS (UVIN, UVOUT)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF)
C
 999  STOP
      END
      SUBROUTINE UBAIN (PRGN, UVIN, UVOUT, IRET)
C-----------------------------------------------------------------------
C   UBAIN gets input parameters for UBAVG and creates the input and
C   output objects
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      UVIN  C*?  Input uv data object
C      BEAM    C*?  Output beam object
C      UVOUT   C*?  Output Image object
C      IRET    I    Error code: 0 => ok, else failed.
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6, UVIN*(*), UVOUT*(*)
C
      INTEGER   NKEY1
C                                       NKEY1=no. adverbs to copy to
C                                       UVIN
      PARAMETER (NKEY1=8)
      INTEGER   IERR, DIM(7), TYPE
      REAL      APARM(10)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, CDUMMY*1
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to uv data
C                    1         2         3         4         5
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'OUTNAME',
C            6           7         8
     *   'OUTCLASS', 'OUTDISK', 'OUTSEQ'/
C                                       Rename to object
C                   1        2        3      4         5
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'OUTNAME',
C            6           7          8
     *   'OUTCLASS',  'OUTDISK', 'OUTSEQ'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       BADDISK
      CALL OGET ('Input', 'BADDISK', TYPE, DIM, IBAD, CDUMMY, IERR)
      IF (IRET.NE.0) GO TO 999
C                                       Check inputs and set defaults
C                                       Control array
      CALL OGET ('Input', 'APARM', TYPE, DIM, IDUM, CDUMMY, IRET)
      CALL RCOPY (DIM(1), RDUM,APARM)
      IF (IRET.NE.0) GO TO 999
C                                       Max time (default infinity)
      IF (APARM(1).LE.0.0001) APARM(1) = 1.0E20
C                                       FOV (default 20)
      IF (APARM(2).LE.0.0001) APARM(2) = 20.0
      CALL RCOPY (10, APARM, RDUM)
      CALL OPUT ('Input', 'APARM', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create input uv data object
      UVIN = 'Input uv data'
      CALL CREATE (UVIN, 'UVDATA', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, UVIN, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Output
      UVOUT = 'Output averaged uv data'
C                                       Max averaging time
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      RDUM(1) = APARM(1)
      CALL OPUT (UVIN, 'MAXATIME', OOARE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Max field of view (arcmin)
      RDUM(1) = APARM(2)
      CALL OPUT (UVIN, 'MAXFOV', OOARE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE UBAHIS (UVIN, UVOUT)
C-----------------------------------------------------------------------
C   Routine to write history file to output image object.
C   Inputs:
C      UVIN  C*?  UV data object
C      UVOUT   C*?  output image object
C-----------------------------------------------------------------------
      CHARACTER UVIN*(*), UVOUT*(*)
C
      INTEGER   NADV
      PARAMETER (NADV=5)
      CHARACTER LIST(NADV)*8
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'APARM'/
C-----------------------------------------------------------------------
C                                        Copy old history
      CALL OHCOPY (UVIN, UVOUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                        New additions - copy adverb
C                                        values.
      CALL OHLIST ('Input', LIST, NADV, UVOUT, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // UVOUT
      CALL MSGWRT (4)
C
 999  RETURN
      END

      SUBROUTINE ZCREA2 (PNAME, ABLOKS, QCREAT, ASIZE, SYSERR, IERR)
C-----------------------------------------------------------------------
C! create the specified disk file
C# Z2 IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2011
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  Create a disk file of the specified name and size with read/write
C  permission.
C  Inputs:
C     PNAME    H*48   Physical file name (H for lower level languages)
C     ABLOKS   I      Requested size of file in AIPS-blocks
C                        (256 local integers)
C     QCREAT   I      > 0 use quick file creation, else fill file w 0's
C  Output:
C     ASIZE    I      Actual size of file created in AIPS-bytes
C     SYSERR   I      System error code
C     IERR     I      Error return code: 0 => no error
C                        1 => file already exists
C                        2 => volume not found
C                        3 => insufficient space
C                        4 => other
C  Generic version - stub.
C-----------------------------------------------------------------------
      HOLLERITH PNAME(12)
      INTEGER   ABLOKS, QCREAT, ASIZE, SYSERR, IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'ZCREA2: REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (9)
C
 999  RETURN
      END

      SUBROUTINE TABBS (OPCODE, BUFFER, BSRNO, BSCOLS, BSNUMV, NUMIF,
     *   TIME, TIMINT, BASELN, SUBARR, STOKES, SOURCE, VAMP, SAMP, RMBD,
     *   MBDERR, MBDAMB, RSBD, SBDERR, SBDAMB, RRATE, RTERR, RTAMB,
     *   RACCEL, ACCERR, RPHASE, PHSERR, IRET)
C-----------------------------------------------------------------------
C! Read from or write to a baseline fringe solution (BS) table
C# Ext-util Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Read record number BSRNO from an open baseline fringe solution (BS)
C   table if OPCODE is 'READ', write record number BSRNO in an open
C   BS table if OPCODE is 'WRIT' or close an open BS table if OPCODE is
C   'CLOS'.
C
C   Inputs:
C      OPCODE   C*4           Operation code:
C                                'READ' - read a row from the table
C                                'WRIT' - write a row to the table
C                                'CLOS' - close the table
C      BSCOLS   I(*)          Column index from BSINI.
C      BSNUMV   I(*)          Column dimensions from BSINI.
C      NUMIF    I             Number of IFs in table.
C
C   Input/output:
C      BUFFER   I(1024)       I/O buffer and control structures.
C                              This is created by BSINI.
C      BSRNO    I             On input: record number to read or write
C                             On output: next record to read or write
C      TIME     D             Central time for record in days since
C                              0h UT on the reference date.
C      TIMINT   R             Time interval covered by record in days.
C      BASELN   I(2)          Antenna in interferemeter baseline.
C      SUBARR   I             Subarray number
C      STOKES   I             Stokes code: -1 - RR   -2 - LL
C                                          -3 - RL   -4 - LR
C                                          -5 - XX   -6 - YY
C                                          -7 - XY   -8 - YX
C      SOURCE   I             Source ID number
C      VAMP     R(*)          Vector amplitude/Jy
C      SAMP     R(*)          Scalar amplitude/Jy
C      RMBD     R             Residual multiband delay/sec
C      MBDERR   R             Multiband delay error/sec
C      MBDAMB   R             Multiband delay ambiguity/sec
C      RSBD     R(*)          Residual single-band delay/sec
C      SBDERR   R(*)          Single-band delay error/sec
C      SBDAMB   R             Single-band delay ambiguity/sec
C      RRATE    R(*)          Residual fringe rate/Hz
C      RTERR    R(*)          Fringe rate error/Hz
C      RTAMB    R             Fringe rate ambiguity/Hz
C      RACCL    R(*)          Residual fringe acceleration/Hz**2
C      ACCERR   R(*)          Fringe acceleration error/Hz**2
C      RPHASE   R(*)          Residual phase/degrees
C      PHSERR   R(*)          Phase error/degrees
C
C   Output:
C      IRET     I             Status:  0 - OK
C                                     -1 - row flagged (on READ)
C                                      1 - attempt to read beyond
C                                          end of table
C                                      2 - error detected
C                                      3 - unknown opcode
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   BUFFER(1024), BSRNO, BSCOLS(*), BSNUMV(*), NUMIF,
     *   BASELN(2), SUBARR, STOKES, SOURCE, IRET
      DOUBLE PRECISION TIME
      REAL      TIMINT, VAMP(*), SAMP(*), RMBD, MBDERR, MBDAMB, RSBD(*),
     *   SBDERR(*), SBDAMB, RRATE(*), RTERR(*), RTAMB, RACCEL(*),
     *   ACCERR(*), RPHASE(*), PHSERR(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PTAB.INC'
C                                        DREC = record interpreted as
C                                               double precision
C                                        RREC = record interpreted as
C                                               real
C                                        IREC = record interpreted as
C                                               integers
      DOUBLE PRECISION DREC(5)
      REAL      RREC(11 + 3 * MAXIF)
      INTEGER   IREC(11 + 3 * MAXIF)
      EQUIVALENCE (IREC, RREC, DREC)
C
      INTEGER   I
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (OPCODE.EQ.'READ') THEN
         CALL TABIO ('READ', TIOROW, BSRNO, IREC, BUFFER, IRET)
         IF (IRET.EQ.4) THEN
            IRET = 1
         ELSE IF (IRET.GT.0) THEN
            IRET = 2
            WRITE (MSGTXT, 1000)
            CALL MSGWRT(8)
         ELSE
            BSRNO = BSRNO + 1
            TIME = DREC(BSCOLS(1))
            TIMINT = RREC(BSCOLS(2))
            DO 10 I = 1, 2
               BASELN(I) = IREC(BSCOLS(3) + I - 1)
   10          CONTINUE
            SUBARR = IREC(BSCOLS(4))
            STOKES = IREC(BSCOLS(5))
            SOURCE = IREC(BSCOLS(6))
            RMBD = RREC(BSCOLS(9))
            MBDERR = RREC(BSCOLS(10))
            MBDAMB = RREC(BSCOLS(11))
            SBDAMB = RREC(BSCOLS(14))
            RTAMB = RREC(BSCOLS(17))
            DO 20 I = 1, NUMIF
               VAMP(I) = RREC(BSCOLS(7) + I - 1)
               SAMP(I) = RREC(BSCOLS(8) + I - 1)
               RSBD(I) = RREC(BSCOLS(12) + I - 1)
               SBDERR(I) = RREC(BSCOLS(13) + I - 1)
               RRATE(I) = RREC(BSCOLS(15) + I - 1)
               RTERR(I) = RREC(BSCOLS(16) + I - 1)
               RACCEL(I) = RREC(BSCOLS(18) + I - 1)
               ACCERR(I) = RREC(BSCOLS(19) + I - 1)
               RPHASE(I) = RREC(BSCOLS(20) + I - 1)
               PHSERR(I) = RREC(BSCOLS(21) + I - 1)
   20          CONTINUE
            IRET = 0
            END IF
      ELSE IF (OPCODE.EQ. 'WRIT') THEN
         DREC(BSCOLS(1)) = TIME
         RREC(BSCOLS(2)) = TIMINT
         DO 30 I = 1, 2
            IREC(BSCOLS(3) + I - 1) = BASELN(I)
   30       CONTINUE
         IREC(BSCOLS(4)) = SUBARR
         IREC(BSCOLS(5)) = STOKES
         IREC(BSCOLS(6)) = SOURCE
         RREC(BSCOLS(9)) = RMBD
         RREC(BSCOLS(10)) = MBDERR
         RREC(BSCOLS(11)) = MBDAMB
         RREC(BSCOLS(14)) = SBDAMB
         RREC(BSCOLS(17)) = RTAMB
         DO 40 I = 1, NUMIF
            RREC(BSCOLS(7) + I - 1) = VAMP(I)
            RREC(BSCOLS(8) + I - 1) = SAMP(I)
            RREC(BSCOLS(12) + I - 1) = RSBD(I)
            RREC(BSCOLS(13) + I - 1) = SBDERR(I)
            RREC(BSCOLS(15) + I - 1) = RRATE(I)
            RREC(BSCOLS(16) + I - 1) = RTERR(I)
            RREC(BSCOLS(18) + I - 1) = RACCEL(I)
            RREC(BSCOLS(19) + I - 1) = ACCERR(I)
            RREC(BSCOLS(20) + I - 1) = RPHASE(I)
            RREC(BSCOLS(21) + I - 1) = PHSERR(I)
   40       CONTINUE
         CALL TABIO ('WRIT', TIOROW, BSRNO, IREC, BUFFER, IRET)
         IF (IRET.NE.0) THEN
            IRET = 2
            WRITE (MSGTXT, 1040)
            CALL MSGWRT (8)
            END IF
         BSRNO = BSRNO + 1
      ELSE IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', TIOROW, BSRNO, IREC, BUFFER, IRET)
         IF (IRET.NE.0) THEN
            IRET = 2
            WRITE (MSGTXT, 1041)
            CALL MSGWRT (8)
            END IF
      ELSE
         IRET = 3
         WRITE (MSGTXT, 1042) OPCODE
         CALL MSGWRT (8)
         END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TABBS: ERROR READING FROM BASELINE SOLUTION TABLE')
 1040 FORMAT ('TABBS: ERROR WRITING TO BASELINE SOLUTION TABLE')
 1041 FORMAT ('TABBS: ERROR CLOSING BASELINE SOLUTION TABLE')
 1042 FORMAT ('TABBS: DO NOT RECOGNISE OPCODE ''', A4, '''')
      END

      SUBROUTINE ZDEACL (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C! close DeAnza TV device
C# Z TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZDEACL closes DeAnza TV device.
C   Inputs:
C      LUN    I   logical unit number
C      FIND   I   pointer into FTAB
C   Output:
C      IERR   I   error code: 0 -> no error
C                    1 -> Deaccess or Deassign error
C                    2 -> file already closed in FTAB
C                    3 -> both errors
C                    4 -> erroneous LUN
C   Generic version - calls ZDEAXF (deallocate) and ZDEAC2.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
C
      INTEGER   JERR, TVLUN, TVDEVN, FCBOFF, I, J
      LOGICAL   T, F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA TVLUN, TVDEVN /9, 4/
C-----------------------------------------------------------------------
      IERR = 4
C                                       Valid LUN?
      IF (LUN.EQ.TVLUN) GO TO 10
         WRITE (MSGTXT,1000) LUN
         GO TO 995
C                                       Valid device type?
 10   IF (DEVTAB(LUN).EQ.TVDEVN) GO TO 20
         WRITE (MSGTXT,1010) LUN, DEVTAB(LUN)
         GO TO 995
C                                       Locate LUN in FTAB.
 20   IERR = 0
      CALL LSERCH ('SRCH', LUN, FIND, F, JERR)
      IF (JERR.EQ.0) GO TO 30
         IERR = 2
         WRITE (MSGTXT,1020) LUN
         GO TO 995
C                                       deallocate DEANZA
 30   FCBOFF = FIND + NMOFF
      CALL ZDEAXF ('DET ', FTAB(FCBOFF), 0, 0, 0, T, JERR)
      IF (JERR.EQ.0) GO TO 40
         WRITE (MSGTXT,1030) JERR
         CALL MSGWRT (7)
C                                       Close the device.
 40   CALL ZDEAC2 (FTAB(FCBOFF), JERR)
      IF (JERR.EQ.0) GO TO 50
         IERR = 1
         WRITE (MSGTXT,1040) JERR
         CALL MSGWRT (7)
         CALL ZERROR ('ZDEAC2', FTAB(FCBOFF+FCBERR), ' ', FTAB(FCBOFF),
     *      F)
C                                       Clear FTAB entry.
 50   CALL LSERCH ('CLOS', LUN, FIND, F, JERR)
      IF (JERR.NE.0) THEN
         IERR = IERR + 2
         WRITE (MSGTXT,1050) LUN
      ELSE
         CALL FSERCH (FIND, I, J, JERR)
         IF (JERR.EQ.0) THEN
            IF (I.EQ.1) DEVNAM(J) = ' '
            IF (I.EQ.2) NONNAM(J) = ' '
            IF (I.EQ.3) MAPNAM(J) = ' '
            END IF
         GO TO 999
         END IF
C
 995  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZDEACL: INVALID LUN = ',I4)
 1010 FORMAT ('ZDEACL: DEVTAB(',I2,') = ',I2,' = INVALID DEVICE TYPE')
 1020 FORMAT ('ZDEACL: LUN = ',I2,' ALREADY CLOSED IN FTAB ON SEARCH')
 1030 FORMAT ('ZDEACL: ZDEAXF RETURNS ERROR = ',I6)
 1040 FORMAT ('ZDEACL: ZDEAC2 RETURNS ERROR = ',I6)
 1050 FORMAT ('ZDEACL: LUN = ',I2,' ALREADY CLOSED IN FTAB ON CLOSE')
      END

      SUBROUTINE TVLAB (BLC, TRC, LABEL, YGAP, TEXT, NTEXT, CH, DOGRID,
     *   IERR)
C-----------------------------------------------------------------------
C! labels axes on plot directly to a TV graphics device, draw ticks
C# Graphics Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2000, 2005, 2014, 2016, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TVLAB will write axis labeling to the TV for a plots:
C      draw borders, image name etc at top, text at bottom, axis labels,
C      and tick (via TKTICS)
C   Inputs:
C      BLC      R(2)     bottom left corner of the plot.
C      TRC      R(2)     top right corner of the plot.
C      LABEL    I        type of labeling: 1 none, 2 no ticks,
C                        3 Ra/Dec, 4 center-rel, 5 subim centered
C                        6 pixels, 7-10 as 3-6 no non-axis labels
C      YGAP     R        Number character lines below plot for TEXT
C      TEXT     C(2)*80  Text to put at bottom of plot
C      NTEXT    I        Number of lines of TEXT actually used
C                        If NTEXT > 0, TEXT is plotted on all LABEL vals
C      CH       R(4)     # chars to left,bot,right,top of plot
C      DOGRID   L        T => full coord. grid, else just ticks
C   Output:
C      IERR     I        error code, 0=ok, 1=problems.
C   Common:
C      /MAPHDR/  input  image header
C-----------------------------------------------------------------------
      INTEGER   LABEL, NTEXT, IERR
      REAL      BLC(2), TRC(2), YGAP, CH(4)
      CHARACTER TEXT(2)*80
      LOGICAL   DOGRID
C
      CHARACTER PLABEL(9)*16, SPTEXT*80, CHTMP*18, ELABEL(2)*8
      REAL      XYRATO, X, Y, RXT, RYT, ISCX, ISCY
      INTEGER   INCHAR, IANGL, I, ITRIM, IE, IEPO, IROUND, DCX, DCY,
     *   LLABEL
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DTVS.INC'
      DATA PLABEL /'Ecliptic Long.  ', 'Ecliptic Lat.   ',
     *   'Galactic Long.  ', 'Galactic Lat.   ', 'Right Ascension ',
     *   'Declination     ', 'Time (hours)    ', 'HA (hours)      ',
     *   'LST (hours)     '/
      DATA ELABEL /' (B1950)', ' (J2000)'/
C-----------------------------------------------------------------------
      CALL CHECKL ('TVLAB')
      XYRATO = (TRC(2) - BLC(2)) / (TRC(1) - BLC(1))
C                                       Draw border.
      CALL TVVEC (BLC(1), BLC(2), 1, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TVVEC (TRC(1), BLC(2), 2, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TVVEC (TRC(1), TRC(2), 2, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TVVEC (BLC(1), TRC(2), 2, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TVVEC (BLC(1), BLC(2), 2, IERR)
      IF (IERR.NE.0) GO TO 999
      LLABEL = MOD (ABS(LABEL), 100)
      IF (LLABEL.EQ.1) GO TO 999
C                                       Source name, stokes, freq.
      IF (LLABEL.LT.7) THEN
         DCX = BLC(1) * SCALEX + RX0
         DCY = TRC(2) * SCALEY + RY0 + 0.5 * CSIZTV(2) + 0.5
         IANGL = 0
         SPTEXT = ' '
         CALL H2CHR (8, 1, CATH(KHOBJ), SPTEXT)
         INCHAR = 12
         IF (NCHLAB(1,LOCNUM).GT.0) THEN
            SPTEXT(INCHAR:) = SAXLAB(1,LOCNUM)(:NCHLAB(1,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(1,LOCNUM)
            END IF
         IF (NCHLAB(2,LOCNUM).GT.0) THEN
            SPTEXT(INCHAR:) = SAXLAB(2,LOCNUM)(:NCHLAB(2,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(2,LOCNUM)
            END IF
C                                       Image name.
         CALL H2CHR (12, KHIMNO, CATH(KHIMN), CHTMP)
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), CHTMP(13:18))
         CALL NAMEST (CHTMP, CATBLK(KIIMS), SPTEXT(INCHAR:), I)
         INCHAR = INCHAR + I - 1
         IF (INCHAR.GT.0) THEN
            CALL IMCHAR (IGR, DCX, DCY, IANGL, 0, SPTEXT(:INCHAR),
     *         INBUF, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         END IF
C                                       Text at bottom
      IF (NTEXT.GT.0) THEN
         DCX = BLC(1) * SCALEX + RX0
         DCY = BLC(2) * SCALEY + RY0 - YGAP * CSIZTV(2)
         DO 20 I = 1,NTEXT
            CALL CHTRIM (TEXT(I), 80, TEXT(I), INCHAR)
            IF (INCHAR.GT.0) THEN
               CALL IMCHAR (IGR, DCX, DCY, 0, 0, TEXT(I)(:INCHAR),
     *            INBUF, IERR)
               IF (IERR.NE.0) GO TO 999
               DCY = DCY - 1.333 * CSIZTV(2)
               END IF
 20         CONTINUE
         END IF
C                                       Axis labels
      IEPO = IROUND (REPOCH(LOCNUM))
      IF (IEPO.EQ.1950) THEN
         IE = 1
      ELSE IF (IEPO.EQ.2000) THEN
         IE = 2
      ELSE
         IE = 0
         END IF
C                                       vertical axes
      I = LABTYP(LOCNUM) / 10
      IF (I.GT.9) I = 0
      Y = ((BLC(2) + TRC(2)) / 2.0) * SCALEY + RY0
      DCX = BLC(1)*SCALEX+RX0 - (CH(1)-0.5)*CSIZTV(1) + 0.5
      IANGL = 3
      IF (I.GT.0) THEN
         INCHAR = ITRIM(PLABEL(I))
         SPTEXT = PLABEL(I)
         IF ((IE.GT.0) .AND. ((I.EQ.5) .OR. (I.EQ.6))) THEN
            SPTEXT(INCHAR+1:) = ELABEL(IE)
            INCHAR = INCHAR + 8
            END IF
      ELSE
         SPTEXT = CPREF(2,LOCNUM) // ' ' // CTYP(2,LOCNUM)
         CALL CHTRIM (SPTEXT, 25, SPTEXT, INCHAR)
         CALL REFRMT (SPTEXT, '_', INCHAR)
         END IF
      DCY = Y + (INCHAR-2)*CSIZTV(2) / 2.0 + 0.5
      IF (INCHAR.GT.0) THEN
         CALL IMCHAR (IGR, DCX, DCY, IANGL, 0, SPTEXT(:INCHAR), INBUF,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       horizontal axes
      I = MOD (LABTYP(LOCNUM), 10)
      X = ((BLC(1) + TRC(1)) / 2.0) * SCALEX + RX0
      DCY = BLC(2) * SCALEY + RY0 - 2.833*CSIZTV(2)
      IF (MOD(LABEL,100).EQ.2) DCY = BLC(2)*SCALEY + RY0 - 1.5*CSIZTV(2)
      IANGL = 0
      IF (I.GT.0) THEN
         INCHAR = ITRIM (PLABEL(I))
         SPTEXT = PLABEL(I)
         IF ((IE.GT.0) .AND. ((I.EQ.5) .OR. (I.EQ.6))) THEN
            SPTEXT(INCHAR+1:) = ELABEL(IE)
            INCHAR = INCHAR + 8
            END IF
      ELSE
         SPTEXT = CPREF(1,LOCNUM) // ' ' // CTYP(1,LOCNUM)
         CALL CHTRIM (SPTEXT, 25, SPTEXT, INCHAR)
         CALL REFRMT (SPTEXT, '_', INCHAR)
         END IF
      DCX = X - (INCHAR*CSIZTV(1)) / 2.0
      IF (INCHAR.GT.0) THEN
         CALL IMCHAR (IGR, DCX, DCY, IANGL, 0, SPTEXT(:INCHAR), INBUF,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       do ticks
      IF (LLABEL.NE.2) THEN
         ISCX = 1.0 / SCALEX
         ISCY = 1.0 / SCALEY
         RXT = RX0 / SCALEX
         RYT = RY0 / SCALEY
         IF (AXINC(1,LOCNUM).NE.0) CALL ITICS (1, IGR-NGRAY, .FALSE.,
     *      RXT, RYT, ISCX, ISCY, BLC, TRC, DOGRID, INBUF, IERR)
         IF (AXINC(2,LOCNUM).NE.0) CALL ITICS (2, IGR-NGRAY, .FALSE.,
     *      RXT, RYT, ISCX, ISCY, BLC, TRC, DOGRID, INBUF, IERR)
         END IF
C
 999  RETURN
      END

      SUBROUTINE YMKHDR (OP, UNIT, COMAND, XFRCNT, XREG, YREG, ZREG,
     *   TREG, VRTRTC, HEADER)
C-----------------------------------------------------------------------
C! builds standard TV-IO header, used for IIS Models 70 and 75
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YMKHDR builds a standard TV header - no checksum, asserts advance X
C   on thing count and advance Y on X overflow
C   Inputs:
C      OP       C*4   'READ' from TV / 'WRIT' to TV
C      UNIT     I     TV subunit number
C      COMAND   L     T => command mode, F => data mode
C      XFRCNT   I     thing count: number of words to transfer not
C                     counting header / packed mode is number of bytes
C      XREG     I     low bits of address in subunit (0 - 511)
C      YREG     I     high bis of address in subunit (0 - 511)
C      ZREG     I     usually channel select mask
C      TREG     I     usually bit plane or subchannel select mask
C      VRTRTC   L     T => do IO only during vertical retrace
C   Output:
C      HEADER   I(8)  basic header
C   IIS Model 70 version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   UNIT, XFRCNT, XREG, YREG, ZREG, TREG, HEADER(8)
      LOGICAL   COMAND, VRTRTC
C
      INTEGER   BITS(16), BIT16
C-----------------------------------------------------------------------
C                                        build z8000
      CALL FILL (16, 0, BITS)
      BITS(16) = 1
      CALL ZPTBIT (16, BIT16, BITS)
C                                        build transfer ID
      IF (OP.EQ.'WRIT') BITS(16) = 0
      IF (VRTRTC) BITS(9) = 1
      CALL ZPTBIT (16, HEADER(1), BITS)
C                                        negative count
      HEADER(2) = -XFRCNT
C                                        subunit & command
      HEADER(3) = UNIT
      IF (COMAND) HEADER(3) = HEADER(3) + BIT16
C                                        force X,Y into range
      HEADER(5) = MOD (XREG+16384, 512) + BIT16
      HEADER(6) = MOD (YREG+16384, 512) + BIT16
C                                        pass Z,T registers
      HEADER(7) = ZREG
      HEADER(8) = TREG
C
 999  RETURN
      END

      SUBROUTINE ZLASOP (OP, LUN, FILNAM, IERR)
C-----------------------------------------------------------------------
C! open a laser printer print/plot file
C# Z2 Printer Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Open a file for printing a plot on a laser printer device.
C   Inputs:
C      OP       C*4     Operation code: 'OPEN', 'POPN'
C      LUN      I       Logical unit number for the laser device
C      FILNAM   C*(*)   File name
C   Output
C      IERR     I       Error code: 0 => okay
C   UNICOS version - simple Fortran open.
C-----------------------------------------------------------------------
      CHARACTER OP*4, FILNAM*(*)
      INTEGER   LUN, IERR
C
C-----------------------------------------------------------------------
      IF (OP.EQ.'POPN') THEN
         OPEN (UNIT=LUN, STATUS='NEW', FILE=FILNAM, IOSTAT=IERR,
     *      ACCESS='DIRECT', RECL=160)
      ELSE
         OPEN (UNIT=LUN, STATUS='NEW', FILE=FILNAM, IOSTAT=IERR)
         END IF
C
 999  RETURN
      END

      SUBROUTINE QVIDIV (APCORE, A, I, D1, D2, B, J, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Divide a vector by the product of two integers.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Divides the given vector by the product of two integers:
C        B(K) = A(K) / (D1 * D2)  for K = 0,N-1
C   Inputs:
C      A   I  Source vector base address.
C      I   I  Increment for A
C      D1  I  First dividend.
C      D2  I  Second dividend.
C      B   I  Destination vector base address.
C      J   I  Increment for B
C      N   I  Element count.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   A, I, D1, D2, B, J, N
C
      LONGINT   JA, JB
      INTEGER   LOOP
      DOUBLE PRECISION FACT
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Addresses 1-rel
      JA = A + PSAPOF
      JB = B + PSAPOF
C                                        Determine scaling factor.
      FACT = D1
      FACT = FACT * D2
      FACT = 1.0D0 / FACT
C                                       Loop, scaling vector.
      INCLUDE 'INCS:ZVND.INC'
      DO 100 LOOP = 1,N
         APCORE(JB) = FACT * APCORE(JA)
         JA = JA + I
         JB = JB + J
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE WHOAMI (INAME, INUM, IERR)
C-----------------------------------------------------------------------
C! given root task name, gets actual task name and finds NPOPS number
C# System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   WHOAMI obtains the actual task name, compares it to the root task
C   name, and determines the POPS number.
C   Inputs:
C      INAME  C*6   Root task name
C   Output:
C      INUM   I     POPS number
C      IERR   I     Error code: 0 => ok
C                      1 => illegal root
C                      2 => roots don't match
C                      3 => INUM out of range, illegal
C                      4 => other
C-----------------------------------------------------------------------
      CHARACTER INAME*6
      INTEGER   INUM, IERR
C
      INTEGER   IT, IP
      CHARACTER CNAME*6, CTEST*1
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Legal root?
      DO 10 IP = 1,6
         IF (INAME(IP:IP).EQ.' ') GO TO 20
 10      CONTINUE
      IERR = 1
      GO TO 999
C                                       Get real name
 20   IERR = 4
      CALL ZGNAME (CNAME, IT)
      IF (IT.NE.0) GO TO 999
C                                       Roots match?
      IP = IP - 1
      IERR = 2
      IF (IP.LT.1) GO TO 999
      IF (CNAME(1:IP).NE.INAME(1:IP)) GO TO 999
C                                       Get number
      IP = IP + 1
      CTEST = CNAME(IP:IP)
      IP = NINTRN
      IF (NBATQS.GT.0) IP = NINTRN + 1 + NBATQS
      CALL ZHEX10 (CTEST, INUM, IERR)
      IF ((INUM.LT.1) .OR. (INUM.GT.IP) .OR. (IERR.NE.0)) IERR = 3
C
 999  RETURN
      END

LOCAL INCLUDE 'UVAVG.INC'
C                                       Local include for UVAVG
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   CATIN(256), SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS,
     *   JBUFSZ, NANT, ILOCWT, MTYPE, NVOUT, LUNO, INDI, INDO,
     *   OLDCNO, NEWCNO, LRECO, NRPRMO, RNXRET, NSUBAR
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4,30), XCALC(1), XNAMOU(3),
     *   XCLAOU(2), XOPCOD(1), XOPTYP(1)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, OPCODE*4,
     *   OPTYPE*4, HISCRD(10)*64, ONAME*48
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XSUBA, XBIF, XEIF, XBCHAN, XECHAN, XDOCAL, XGUSE, XDOPOL,
     *   XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH(3), XDOAC, XSOUT,
     *   XDISO, XINC, YINC, ZINC, XCENT, BADD(10),
     *   SCRBUF(256), BUFF2(UVBFSS), DIFPIX
      LOGICAL   LTB, ISCOMP
      COMMON /BUFRS/ SCRBUF, BUFF2, JBUFSZ
      COMMON /OLDHDR/ CATIN, LTB, NANT
      COMMON /INPTS/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XTIME, XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF, XBCHAN, XECHAN,
     *   XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER,
     *   XSMOTH, XDOAC, XNAMOU, XCLAOU, XSOUT, XDISO, XINC, YINC, ZINC,
     *   XOPCOD, XOPTYP, XCENT, BADD
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, OPCODE, OPTYPE,
     *   HISCRD, ONAME
      COMMON /NEW/ SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS, ILOCWT, MTYPE,
     *   NVOUT, ISCOMP, LUNO, INDI, INDO, OLDCNO, NEWCNO, LRECO, NRPRMO,
     *   RNXRET, NSUBAR, DIFPIX
LOCAL END
      PROGRAM UVAVG
C-----------------------------------------------------------------------
C! Time average or merge uv data.
C# UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2000, 2006-2012, 2014-2016, 2018, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   The primary function of UVAVG is to average data which it does
C   if any OPCODE except 'MERG' is used.
C
C   UVAVG averages a uv data set to a maximum time given by YINC.
C   Data can be in either 'TB' or 'BT' order.  The accumulation buffer
C   is dynamic and may grow to the size needed.
C   The data is averaged weighted by the data weights.  The PARMS are
C   averaged weighted by the largest weight in the data record except
C   the baseline number, for which the last one is passed.
C
C   For OPCODE='MERG', UVAVG performs the merge function previously
C   by VBMRG.  The time specified by YINC is taken to be the average
C   time of the input data.  In each input time on each baseline,
C   only one data point is selected and passed.  This is useful for
C   VLB data processed with multiple passes so that there are multiple
C   copies of some data.  It is also useful for putting together
C   polarization data sets when different polarizations were processed
C   separately.
C
C   If XINC if greater than 1, only every XINC'th group of output
C   records (eg all baselines for an average interval) will be written.
C   This should be useful in creating small data sets that still have
C   about the uv coverage of a large data set and still has points
C   appropriately alligned for self cal.  Might be used, for example
C   in the first iterations of hybrid mapping.
C
C   Based on program AVER
C   Inputs:
C   AIPS adverb  Prg. name.          Description.
C   INNAME         NAMEIN        Name of input UV data.
C   INCLASS        CLAIN         Class of input UV data.
C   INSEQ          SEQIN         Seq. of input UV data.
C   INDISK         DISKIN        Disk number of input UV data.
C   OUTNAME        NAMOUT        Name of the output uv file.
C   OUTCLASS       CLAOUT        Class of the output uv file.
C   OUTSEQ         SEQOUT        Seq. number of output uv data.
C   OUTDISK        DISKO         Disk number of the output file.
C   YINC           YINC          Integration time (sec) min=0.2
C   XINC           XINC          Write only XINC'th output recs.
C   ZINC           ZINC          Input averaging time (sec)
C   OPCODE         OPCODE        Average or merge.
C   UVAVG Programmer R. C. Walker, Feb. 1984.
C   Removed adjustment of average time by 0.95  Dec 29, 1991 RCW
C   Tried to avoid thrashing on SPARCs by changing ACSIZE from
C      5000000 to 2500000 - worked!   Dec. 29, 1991 RCW
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGM*6
      INCLUDE 'UVAVG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'UVAVG '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL UVAVIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Average or merge data
      CALL UVAVUV (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       HI, tables
      CALL UVAVHI
C                                       close down
 990  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE UVAVIN (PRGM, JERR)
C-----------------------------------------------------------------------
C   UVAVIN gets input parameters for UVAVG and creates an output file
C   if necessary.
C   Inputs:  PRGM   C*6      Task name
C   Output:  JERR   I        Error code: quit if > 0.
C-----------------------------------------------------------------------
      CHARACTER STAT*4, PRGM*6, UTYPE*2
      INTEGER   IROUND, JERR, NPARM, IERR, NUMAN(513), LUN, ITEMP, I,
     *   NFREQ, INCX
      REAL      FACT, RTEMP, RPARM(20), CATR(256)
      DOUBLE PRECISION CATD(128)
      LOGICAL   F, MATCH
      HOLLERITH CATH(256)
      INCLUDE 'UVAVG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATH, CATR, CATD)
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                       Initialize I/O
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
      CALL SELINI
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
      NUMHIS = 0
C                                       Get input parameters.
      NPARM = 19 + 161
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
      YINC = MAX (0.2, YINC) / 86400.0
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = XDOAC.GT.0.0
C                                       Check OPTYPE
      MTYPE = 0
      IF (OPTYPE.EQ.'CROS') MTYPE = 1
      IF (OPTYPE.EQ.'AUTO') MTYPE = 2
      IF ((OPCODE.EQ.'MERG') .AND. (OPTYPE.EQ.'AUTO')) DOACOR = .TRUE.
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Get CATBLK from old file.
      OLDCNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, SCRBUF, IERR)
C                                       Error finding file.
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
C                                       Error copying CATBLK.
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Copy old CATBLK
      CALL COPY (256, CATBLK, CATIN)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      LTB = F
      NANT = 2
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NFREQ = CATBLK(KINAX+JLOCF)
      BCHAN = IROUND (XBCHAN)
      ECHAN = IROUND (XECHAN)
      IF ((BCHAN.LE.0) .OR. (BCHAN.GT.NFREQ)) BCHAN = 1
      IF ((ECHAN.LE.0) .OR. (ECHAN.GT.NFREQ)) ECHAN = NFREQ
      IF (BCHAN.GT.ECHAN) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       Check if sort order 'TB' or 'BT'
      IF ((ISORT.NE.'BT') .AND. (ISORT.NE.'TB')) THEN
         WRITE (MSGTXT,1050) ISORT
         JERR = 5
         GO TO 990
         END IF
C                                       need max ant number for TB
C                                       If 'TB', see if accum. buffers
C                                       will be large enough
      LTB = (ISORT.EQ.'TB')

C                                       Get number of antennas from AN
C                                       file.
      LUN = 29
      CALL GETNAN (DISKIN, OLDCNO, CATIN, LUN, SCRBUF, NUMAN, IERR)
      IF (IERR.EQ.0) THEN
         IF (SUBARR.GT.0) THEN
            NANT = NUMAN(1+SUBARR)
         ELSE
            NANT = 0
            DO 52 I = 1,NUMAN(1)
               NANT = MAX (NANT, NUMAN(1+I))
 52            CONTINUE
            END IF
         NSUBAR = NUMAN(1)
         END IF
C                                       If failed, assume 28.
      IF ((IERR.NE.0) .OR. (NANT.EQ.0)) THEN
         WRITE (MSGTXT,1052)
         CALL MSGWRT (6)
         NANT = 28
         END IF
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, BUFF2, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, BUFF2, IERR)
C                                       restore subarray if needed
      SUBARR = IROUND (XSUBA)
C                                       Put new values in CATBLK.
      IF (JLOCF.LT.0) XCENT = -1.
      IF (XCENT.GT.0.0) THEN
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
      ELSE
         DIFPIX = 0.0
         END IF
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       read compressed => write compr.
      IF (ISCOMP) THEN
         CATBLK(KINAX) = 1
         I = CATBLK(KIPCN)
         CALL CHR2H (8, 'WEIGHT  ', 1, CATH(KHPTP+2*I))
         CALL CHR2H (8, 'SCALE   ', 1, CATH(KHPTP+2*I+2))
         CATBLK(KIPCN) = I + 2
         ILOCWT = I
         END IF
C                                       Adjust output size if ZINC is
C                                       non-zero
      IF ((ZINC.GT.0.0) .AND. (YINC.GT.0.0)) THEN
         FACT = 3 * ZINC / (YINC * 86400.0)
         FACT = MIN (1.0, FACT)
         ITEMP = CATBLK(KIGCN)
         RTEMP = ITEMP
         RTEMP = RTEMP * FACT
         CATBLK(KIGCN) = IROUND(RTEMP)
         END IF
      NVOUT = CATBLK(KIGCN)
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1055) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((CCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            MSGTXT = 'UVAVIN: MAY OVERWRITE INPUT FILE ONLY.  QUITTING'
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', SCRBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
      NEWCNO = CCNO
      SEQOUT = CATBLK(KIIMS)
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      LRECO = LREC
      NRPRMO = NRPARM
C                                        Put input file in READ
      UTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, 'READ', SCRBUF, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
C                                       copy header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVAVIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('UVAVIN: ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,
     *   ' DISK=',I3,' USID=',I5)
 1035 FORMAT ('UVAVIN: UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('UVAVIN: ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('UVAVIN: SORT ORDER ',A2,' NOT BT OR TB AS REQUIRED')
 1052 FORMAT ('UVAVIN: COULD NOT GET NUMBER OF ANTENNAS FROM AN FILE',
     *   ' - ASSUME 28')
 1055 FORMAT ('UVAVIN: ERROR',I3,' CREATING OUTPUT FILE')
 1065 FORMAT ('UVAVIN: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE UVAVUV (IRET)
C-----------------------------------------------------------------------
C   UVAVUV sends uv data one point at a time to the average/merge
C   routine which also writes the modified data if requested.
C   Input in common:
C      ISCOMP   L   If true data is compressed
C   Output:
C      IRET     I   Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER    IRET
C
      INTEGER    IPTRO, ILENBU, NIOLIM, NIOUT, KBIND, IA1, IA2, ISUB,
     *   VO, BO, NUMVIS, XCOUNT, CATMP(256), NWORDS, ISUB1, ISUB2,
     *   TOTVIS
      LOGICAL   T, F
      INCLUDE 'UVAVG.INC'
      REAL      BASEL, VIS(UVBFSS), RPARM(20), VBUFF(2)
      DOUBLE PRECISION UVSCAL
      LONGINT   VBPTR
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DRNX.INC'
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      LUNO = 17
      IF (SUBARR.GT.0) THEN
         ISUB1 = SUBARR
         ISUB2 = SUBARR
      ELSE
         ISUB1 = 1
         ISUB2 = NSUBAR
         END IF
C                                       make buffer
      NWORDS = 1
      IF (LTB) NWORDS = (NANT * (NANT+1)) / 2
      NWORDS = ((1 + NRPRMO + 3* ((LRECO-NRPRMO)/CATBLK(KINAX))) *
     *   (NWORDS + 3) - 1) / 1024 + 2
      CALL ZMEMRY ('GET ', 'UVAVUV', NWORDS, VBUFF, VBPTR, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'ALLOCATE MEMORY'
         GO TO 990
         END IF
      NWORDS = NWORDS * 1024
C                                       Open vis file for write
C                                       for IND=2 only
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, ONAME, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, ONAME, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OUTPUT'
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT WRITE'
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATIN)
      CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
C                                       adjust min record gap since
C                                       we know what it should be
      RNXEPS = MAX (RNXEPS, 0.9*YINC)
C                                       uvw scale factor
      IF ((FREQ.GT.0.0D0) .AND. (UVFREQ.GT.0.0D0)) THEN
         UVSCAL = FREQ / UVFREQ
      ELSE
         UVSCAL = 1.0D0
         END IF
C                                       Init counters.
      TOTVIS = 0
C                                       Loop
      DO 110 SUBARR = ISUB1,ISUB2
C                                       defend cat header from UVGET
         CALL COPY (256, CATBLK, CATMP)
C                                       Open and init for read
         CALL UVGET ('INIT', RPARM, VIS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT INPUT'
            GO TO 990
            END IF
         CALL COPY (256, CATMP, CATBLK)
         NUMVIS = 0
C                                       Read vis. record.
 100     CALL UVGET ('READ', RPARM, VIS, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ INPUT'
            GO TO 990
C                                       Loop over buffer
         ELSE IF (IRET.EQ.0) THEN
            IF (ILOCB.GE.0) THEN
               BASEL = RPARM(1+ILOCB)
               IA1 = BASEL / 256. + 0.1
               IA2 = BASEL - IA1*256. + 0.1
               ISUB = (BASEL - IA1*256 - IA2) * 100.0 + 1.1
            ELSE
               IA1 = RPARM(1+ILOCA1) + 0.1
               IA2 = RPARM(1+ILOCA2) + 0.1
               ISUB = RPARM(1+ILOCSA) + 0.1
               END IF
            NUMVIS = NUMVIS + 1
            RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
            RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
            RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
            CALL UVAVDO (NUMVIS, RPARM(1+ILOCT), IA1, IA2, ISUB, VIS,
     *         RPARM, NWORDS, VBUFF(1+VBPTR), NIOLIM, IPTRO, NIOUT,
     *         XCOUNT, IRET)
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
               END IF
            GO TO 100
            END IF
C                                       Final call to UVAVDO.
         NUMVIS = -2
         IF (SUBARR.EQ.ISUB2) NUMVIS = -1
         CALL UVAVDO (NUMVIS, RPARM(1+ILOCT), IA1, IA2, ISUB, VIS,
     *      RPARM, NWORDS, VBUFF(1+VBPTR), NIOLIM, IPTRO, NIOUT, XCOUNT,
     *      IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
            END IF
         TOTVIS = TOTVIS + XCOUNT
         NVOUT = NVOUT - XCOUNT
C                                       Close input file
         CALL UVGET ('CLOS', RPARM, VIS, IRET)
 110     CONTINUE
C                                       close NX table
      CALL RNXCLS (RNXRET)
C                                       Compress and close
C                                       output file.
      NVIS = TOTVIS
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
C
      CALL ZMEMRY ('FREE', 'UVAVUV', NWORDS, VBUFF, VBPTR, IRET)
      IRET = 0
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVAVUV: ERROR',I3,' DOING ',A)
 1120 FORMAT ('UVAVUV: UVAVDO ERROR',I3)
      END
      SUBROUTINE UVAVHI
C-----------------------------------------------------------------------
C   UVAVHI copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, LABEL*8
      INTEGER   LUN1, LUN2, IERR, I
      INCLUDE 'UVAVG.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27, 28/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   SCRBUF, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 20
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
C                                       calibration history
      CALL CALHIS (LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                      Add any other history
      IF (NUMHIS.GT.0) THEN
         WRITE (LABEL,1010) TSKNAM
         DO 15 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 20
 15         CONTINUE
         END IF
C                                       Close HI file
 20   CALL HICLOS (LUN2, .TRUE., BUFF2, IERR)
C                                       Copy tables
      CALL COPTAB (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'UVAVHI: ERROR COPYING TABLES TO OUTPUT'
         CALL MSGWRT (6)
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (DISKO, NEWCNO, DIFPIX, BUFF2(1025), BUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'UVAVHI: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                       Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRBUF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVAVHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,'/')
      END
      SUBROUTINE UVAVDO (NUMVIS, T, IA1, IA2, ISUB, VIS, RPARM, ACSIZE,
     *   VBUFF, NIOLIM, IPTRO, NIOUT, XCOUNT, IRET)
C-----------------------------------------------------------------------
C   UVAVDO averages a uv data set in time.
C   Inputs:
C      NUMVIS     I    Visibility number, -1=> final call, no data
C                      passed but allows any operations to be completed.
C                      Data sent back will be wirtten to output file.
C      T          R    Time in days since 0 IAT on the first day for
C                      which there is data.
C      IA1        I    First antenna number
C      IA2        I    Second antenna number
C      ISUB       I    Subarray number
C      ACSIZE     I    Size of VBUFF
C      NIOLIM     I    Maximum number or records per buffer.
C      IPTRO      I    Output pointer - initialize before first call.
C      NIOUT      I    Number of records in buffer.  Init before first
C                                 call
C      XCOUNT     I    Output record counter.  Init before first call.
C   Inputs from COMMON
C      NRPARM     I    # random parameters.
C      NCOR       I    # correlators
C      CATBLK(256)I    Catalog header record.
C   In/Out:
C      RPARM    R(*)     Modified random parameter array. NB U,V,W, time
C                        and baseline should not be modified in RPARM
C      VIS      R(3,*)   Vis data in order real, imaginary, weight (Jy)
C      VBUFF    R(*)     Averaging buffer
C   Output:
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C   Output in COMMON
C      NUMHIS     I    # history entries (max. 10)
C      HISCRD(NUMHIS) C   History records
C      CATBLK     I    Catalog header block
C   Programmer: R. C. Walker  Feb. 1984
C-----------------------------------------------------------------------
      INTEGER   IA1, IA2, ISUB, ACSIZE, IRET, NIOLIM, IPTRO, NIOUT
      REAL      T, VIS(3,*), RPARM(*), VBUFF(*)
      INTEGER   NUMVIS, XCOUNT
C
C                                       Accumulation buffer
C                                       index size.
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MXINDX
      PARAMETER (MXINDX = MXBASE)
      CHARACTER OUTRAN(20)*8
      INTEGER   IIREC, IIREC2, ILEN, LUNSS, JERR, JRET, INDEX, IDAY,
     *   IBAS, BLCUR, KBAS, INDEX2, NIOFLS, INDEXV, I, KBIND, MCOR,
     *   NMCOR, LBAS, KBUFF, ITIME, IWORK(MXINDX), ITT, NCOPY, ANVER,
     *   CURSOU, LSTSOU, CURSUB, LSTSUB, KREC, K, KLIM, ANOTA(20), IP,
     *   I2TMP
      LOGICAL   MRG, ITPRT, DOTIME, DOGRID, DOGRIT
      REAL      DIV, WGT, TLAST, CT, TCHK, AMP1, AMP2, OPARM(20), TAVG,
     *   TIMES(3,MXINDX), WORK(2,MXINDX), TSUM, WSUM
      DOUBLE PRECISION X8, NXINC, XINC8
      INCLUDE 'UVAVG.INC'
      REAL      RESULT(UVBFSS), DTUTC
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      SAVE    NCOPY, DTUTC, TLAST, BLCUR, MCOR, MRG, NMCOR, LBAS,
     *   XINC8, IIREC, IIREC2, ILEN, NXINC, LSTSOU, KLIM, ANOTA, DOTIME,
     *   DOGRID, DOGRIT, TCHK, LSTSUB
      DATA LUNSS /27/
C-----------------------------------------------------------------------
      IRET = -1
C                                       Initial call
      IF (NUMVIS.EQ.1) THEN
C                                       Number of visibilities in input
C                                       and output files.
         NCOPY = LRECO - NRPRMO
C                                       Get data time - UTC
         DTUTC = 0.0
         ANVER = ISUB
         CALL ANTINI ('READ', VBUFF, FVOL(NCFILE), FCNO(NCFILE), ANVER,
     *      CATIN, LUNSS, IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0,
     *      DEGPDY, SAFREQ, RDATE, POLRXY, UT1UTC, DTUTC, TIMSYS,
     *      ANAME, XYZHAN, TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, JERR)
         DTUTC = DTUTC / 86400.0
         CALL TABIO ('CLOS', 1, IANRNO, VBUFF, VBUFF, JERR)
C                                       warning/type random parameters
         CALL LISRAN (OUTRAN, ANOTA)
C                                       Check if merge or average.
         MRG = OPCODE.EQ.'MERG'
         DOTIME = OPCODE.EQ.'TIME'
         DOGRID = OPCODE.EQ.'GRID'
         DOGRIT = OPCODE.EQ.'GRIT'
C                                       Set counters etc.
         XCOUNT = 0
         TLAST = -1.0
         BLCUR = -1
         TCHK = -1.0
         MCOR = (LRECO - NRPRMO) / CATBLK(KINAX)
         NMCOR = MCOR * 3
         LBAS = 1
         IF (LTB) LBAS = NANT*(NANT+1)/2
         XINC8 = MAX (1.0, XINC)
         CURSOU = -1
         IF (ILOCSU.GE.0) CURSOU = RPARM(1+ILOCSU) + 0.5
         LSTSOU = CURSOU
         CURSUB = ISUB
         LSTSUB = CURSUB
C                                       Limit to accumulation buffer.
         KLIM = ACSIZE - (1 + NRPRMO + NMCOR)
C                                       For sorts
         ILEN = 3
         I2TMP = MXINDX * ILEN
         CALL RFILL (I2TMP, 0.0, TIMES)
C                                       Reset accumulation buffer
         I2TMP = ACSIZE
         CALL RFILL (I2TMP, 0.0, VBUFF)
C                                       Set up to write first record
C                                       and avoid round off problems.
         NXINC = -0.999D0
         END IF
C                                       Have incoming data
      IF (NUMVIS.GE.0) THEN
C                                       Be sure antenna numbers are
C                                       in the expected order.
         IF (IA1.GT.IA2) THEN
            WRITE (MSGTXT,1000) IA1, IA2
            CALL MSGWRT (8)
            IRET = 7
            GO TO 999
            END IF
C                                       If merging but not this type
C                                       write it out
         IF (MRG) THEN
            IF (((MTYPE.EQ.1) .AND. (IA1.EQ.IA2)) .OR.
     *         ((MTYPE.EQ.2) .AND. (IA1.NE.IA2))) THEN
C                                       update NX table
               CALL RNXUPD (RPARM, RNXRET)
C                                       move data
               CALL RCOPY (NRPRMO, RPARM, BUFF2(IPTRO))
               IF (ISCOMP) THEN
                  DO 50 I = 1, MCOR
                     INDEX2 = (I-1)*3
                     RESULT(INDEX2+1) = VIS(1,I)
                     RESULT(INDEX2+2) = VIS(2,I)
                     RESULT(INDEX2+3) = VIS(3,I)
 50                  CONTINUE
                  CALL ZUVPAK (NCOPY, RESULT, BUFF2(IPTRO+ILOCWT),
     *               BUFF2(IPTRO+NRPRMO))
               ELSE
                  DO 60 I = 1,MCOR
                     INDEX2 = IPTRO + NRPRMO + (I-1)*3 - 1
                     BUFF2(INDEX2+1) = VIS(1,I)
                     BUFF2(INDEX2+2) = VIS(2,I)
                     BUFF2(INDEX2+3) = VIS(3,I)
 60                  CONTINUE
                  END IF
C                                       Update counters.
               XCOUNT = XCOUNT + 1
C                                       Writing beyond EOF ?
               IF (XCOUNT.GT.NVOUT) THEN
                  K = MAX (5000, NVOUT/10)
                  CALL UVSIZE (LRECO, K, IP)
                  CALL ZEXPND (LUNO, DISKO, ONAME, IP, IRET)
                  IF (IRET.EQ.0) THEN
                     NVOUT = NVOUT + K
                  ELSE
                     WRITE (MSGTXT,1060) IRET
                     CALL MSGWRT (8)
                     GO TO 999
                     END IF
                  END IF
C
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
C                                       Write output
               IF (NIOUT.GE.NIOLIM) THEN
C                                       Use NIOUT instead of NIOLIM
C                                       so last record ok.
                  CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOUT,
     *               KBIND, JRET)
                  IF (JRET.NE.0) THEN
                     WRITE (MSGTXT,1113) JRET
                     CALL MSGWRT (8)
                     IRET = 5
                     GO TO 999
                     END IF
                  IPTRO = KBIND
                  NIOLIM = NIOUT
                  NIOUT = 0
                  END IF
               GO TO 999
               END IF
            END IF
C                                       Get UT from data time
         CT = T - DTUTC
C                                       Get baseline.
         IBAS = 32768 * IA1 + IA2
C                                       Be sure of sort order.
         IF ((CT.LT.TCHK) .AND. (IBAS.EQ.BLCUR)) THEN
            WRITE (MSGTXT,1090)
            CALL MSGWRT (8)
            IRET = 4
            GO TO 999
            END IF
C                                       Source Number
         CURSOU = -1
         IF (ILOCSU.GE.0) CURSOU = RPARM(1+ILOCSU) + 0.5
         CURSUB = ISUB
         END IF
C                                       Check if output needed.
      IF ((CT.GT.TLAST) .OR. (NUMVIS.LT.0) .OR.
     *   ((.NOT.LTB) .AND. (IBAS.NE.BLCUR)) .OR.
     *   (CURSOU.NE.LSTSOU) .OR. (CURSUB.NE.LSTSUB)) THEN
C                                       No output for first record.
         IF (NUMVIS.NE.1) THEN
C                                       Test if output should be
C                                       skipped.
            NXINC = NXINC + 1.D0
            IF ((XINC.LE.1.5) .OR. (MOD(NXINC,XINC8).LE.0.5D0)) THEN
C                                       Loop through the accumulation
C                                       buffer, extracting an index
C                                       of time and baseline
C                                       keys, which are later sorted.
               IIREC = LBAS
C                                       Warning if MXINDX exceeded.
               IF (IIREC.GT.MXINDX) THEN
                  WRITE (MSGTXT,1160) IIREC
                  CALL MSGWRT (8)
                  IRET = 10
                  GO TO 999
                  END IF
               TSUM = 0.0
               WSUM = 0.0
               DO 100 K = 1,IIREC
                  KREC = (K-1) * (1 + NRPRMO + NMCOR) + 1
                  IF (KREC.LE.KLIM) THEN
                     WGT = VBUFF(KREC)
                     TIMES(3,K) = K
                     IF (WGT.GT.0.0) THEN
                        IF (DOTIME) THEN
                           WSUM = WSUM + WGT
                           TSUM = TSUM + VBUFF(KREC+ILOCT+1)
                           END IF
                        TIMES(1,K) = VBUFF(KREC+ILOCT+1) / WGT
                        TIMES(2,K) = 4096.0*IA1 + IA2
                     ELSE
                        TIMES(1,K) = 0.0
                        TIMES(2,K) = 0.0
                        END IF
                     END IF
  100             CONTINUE
               IF (WSUM.GT.0.0) TSUM = TSUM / WSUM
C                                       Sort index of keys TIMES
C                                       to TB or BT order.
               IIREC2 = IIREC + 2
               IF ((.NOT.DOTIME) .AND. (.NOT.DOGRID)) THEN
                  IF (LTB) THEN
                     CALL OSORT (TIMES, IIREC, IIREC2, 1, 2, ILEN, WORK,
     *                  IWORK, JERR)
                  ELSE IF (IIREC.GT.1) THEN
                     CALL OSORT (TIMES, IIREC, IIREC2, 2, 1, ILEN, WORK,
     *                  IWORK, JERR)
                     IF (JERR.GT.0) THEN
                        WRITE (MSGTXT,1104)
                        CALL MSGWRT (8)
                        IRET = 8
                        GO TO 999
                        END IF
                     END IF
                  END IF
C                                       Now write in time order.
               ITPRT = .TRUE.
               DO 126 ITIME = 1,IIREC
                  ITT  = IIREC - ITIME + 1
                  KREC = TIMES(3,ITT)
                  KBUFF = (KREC-1) * (1+NRPRMO+NMCOR) + 1
C                                       Weight for RPARM.
C                                       Will be 0.0 if no valid data
                  WGT = 0.0
                  IF (KBUFF.LE.KLIM) WGT = VBUFF(KBUFF)
C                                       No data - no output
                  IF (WGT.GT.0.0) THEN
C                                       Normalize RPARM's
C                                       Re: WGT for merge will be 1.0
                     DO 105 IP = 1,NRPRMO
                        IF (ANOTA(IP).EQ.2) THEN
                           OPARM(IP) = VBUFF(KBUFF+IP) / WGT
                        ELSE
                           OPARM(IP) = VBUFF(KBUFF+IP)
                           END IF
 105                    CONTINUE
                     IF (DOTIME) THEN
                        OPARM(1+ILOCT) = TSUM
                     ELSE IF (DOGRID) THEN
                        OPARM(1+ILOCT) = TAVG
                     ELSE
                        OPARM(1+ILOCT) = TIMES(1,ITT)
                        END IF
C                                       update NX table
                     CALL RNXUPD (OPARM, RNXRET)
                     CALL RCOPY (NRPRMO, OPARM, BUFF2(IPTRO))
C                                       Compressed?
                     IF (ISCOMP) THEN
C                                       Normalize data. Correlator loop
                        DO 110 I = 1,MCOR
                           INDEX2 = (I-1) * 3
                           INDEXV = KBUFF + NRPRMO + (I-1) * 3
                           IF (VBUFF(INDEXV+3).GT.0.0) THEN
                              DIV = 1.0 / VBUFF(INDEXV+3)
                              IF (MRG) DIV = 1.0
                              RESULT(INDEX2+1) = VBUFF(INDEXV+1) * DIV
                              RESULT(INDEX2+2) = VBUFF(INDEXV+2) * DIV
                              RESULT(INDEX2+3) = VBUFF(INDEXV+3)
C                                       No data
                           ELSE
                              RESULT(INDEX2+1) = 0.0
                              RESULT(INDEX2+2) = 0.0
                              RESULT(INDEX2+3) = -1.0
                              END IF
 110                       CONTINUE
C                                       Pack/copy to output buffer
                        INDEX2 = IPTRO + NRPRMO + (I-1)*3 - 1
                        CALL ZUVPAK (NCOPY, RESULT, BUFF2(IPTRO+ILOCWT),
     *                     BUFF2(IPTRO+NRPRMO))
                     ELSE
C                                       Uncompressed data:
C                                       Normalize data. Correlator loop
                        DO 115 I = 1,MCOR
                           INDEX2 = IPTRO + NRPRMO + (I-1)*3 - 1
                           INDEXV = KBUFF + NRPRMO + (I-1)*3
                           IF (VBUFF(INDEXV+3).GT.0.0) THEN
                              DIV = 1.0 / VBUFF(INDEXV+3)
                              IF (MRG) DIV = 1.0
                              BUFF2(INDEX2+1) = VBUFF(INDEXV+1) * DIV
                              BUFF2(INDEX2+2) = VBUFF(INDEXV+2) * DIV
                              BUFF2(INDEX2+3) = VBUFF(INDEXV+3)
C                                       No data
                           ELSE
                              BUFF2(INDEX2+1) = 0.0
                              BUFF2(INDEX2+2) = 0.0
                              BUFF2(INDEX2+3) = -1.0
                              END IF
 115                       CONTINUE
                        END IF
C                                        Update counters.
                     XCOUNT = XCOUNT + 1
C                                        Writing beyond EOF ?
                     IF (XCOUNT.GT.NVOUT) THEN
                        K = MAX (5000, NVOUT/10)
                        CALL UVSIZE (LRECO, K, IP)
                        CALL ZEXPND (LUNO, DISKO, ONAME, IP, IRET)
                        IF (IRET.EQ.0) THEN
                           NVOUT = NVOUT + K
                        ELSE
                           WRITE (MSGTXT,1060) IRET
                           CALL MSGWRT (8)
                           GO TO 999
                           END IF
                        END IF
                     IPTRO = IPTRO + LRECO
                     NIOUT = NIOUT + 1
C                                        Write output
C                                        Only actually write when
C                                        the buffer is full.
                     IF (NIOUT.GE.NIOLIM) THEN
C                                        Use NIOUT instead of NIOLIM
C                                        so last record ok.
                        CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOUT,
     *                     KBIND, JRET)
                        IF (JRET.NE.0) THEN
                           WRITE (MSGTXT,1113) JRET
                           CALL MSGWRT (8)
                           IRET = 5
                           GO TO 999
                           END IF
                        IPTRO = KBIND
                        NIOLIM = NIOUT
                        NIOUT = 0
                        END IF
C                                        Jump here if no data for bas.
                     END IF
C                                        End of baseline loop.
  126             CONTINUE
C                                        Jump here if output not
C                                        written
               END IF
C                                        Close up after last record.
            IF (NUMVIS.EQ.-1) THEN
C                                       First write any unwritten
C                                       data.
               IF (NIOUT.GT.0) THEN
                  CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOUT, KBIND,
     *               JRET)
                  IF (JRET.NE.0) THEN
                     WRITE (MSGTXT,1113) JRET
                     CALL MSGWRT (8)
                     IRET = 9
                     GO TO 999
                     END IF
                  END IF
C                                        Then flush buffers to output
               NIOFLS = 0
               CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOFLS, KBIND,
     *            JRET)
               IF (JRET.NE.0) THEN
                  WRITE (MSGTXT,1130) JRET
                  CALL MSGWRT (8)
                  IRET = 6
                  GO TO 999
                  END IF
C                                        Tell history if merge or avg.
               IF (MRG) THEN
                  NUMHIS = NUMHIS + 1
                  WRITE (HISCRD(NUMHIS),1140)
               ELSE
                  YINC = YINC * 86400.0
                  NUMHIS = NUMHIS + 1
                  WRITE (HISCRD(NUMHIS),1135) YINC
                  END IF
C                                        Tell history about reduced
C                                        output.
               IF (XINC.GT.1.0) THEN
                  NUMHIS = NUMHIS + 1
                  WRITE (HISCRD(NUMHIS),1145) XINC
                  END IF
C                                        Write no. written to history.
               NUMHIS = NUMHIS + 1
               WRITE (HISCRD(NUMHIS),1150) XCOUNT, LSTSUB
               WRITE (MSGTXT,1150) XCOUNT, LSTSUB
               CALL MSGWRT (5)
               GO TO 999
C                                        Write no. written to history.
            ELSE IF (NUMVIS.EQ.-2) THEN
               NUMHIS = NUMHIS + 1
               WRITE (HISCRD(NUMHIS),1150) XCOUNT, LSTSUB
               WRITE (MSGTXT,1150) XCOUNT, LSTSUB
               CALL MSGWRT (5)
               END IF
            END IF
C                                        Set up for next integration
CRCW                                     Removed 0.95 here
         IF ((LTB) .AND. (.NOT.DOGRID) .AND. (.NOT.DOGRIT)) THEN
            TLAST = CT + YINC
         ELSE
            IDAY = CT
            X8 = (CT-IDAY) / YINC
            TLAST = IDAY + DINT (X8) * YINC + YINC
            TAVG = TLAST - YINC/2.0
            END IF
         TCHK = TLAST - 1.1 * YINC
C                                        Reset accumulators, etc.
         I2TMP = LBAS * (1+NRPRMO+NMCOR)
         IF (I2TMP.GT.ACSIZE) I2TMP = ACSIZE
         CALL RFILL (I2TMP, 0.0, VBUFF)
         BLCUR = IBAS
         LSTSOU = CURSOU
         LSTSUB = CURSUB
         END IF
C                                        Accumulate current datum.
C                                        Get baseline number for accum.
      KBAS = 1
      IF (LTB) KBAS = IA2*(IA2-1)/2 + IA1
C                                        Get index of first element of
C                                        accumulation buffer for this
C                                        baseline.  That element will
C                                        accumulate the weight for PARMS
      KBUFF = (KBAS - 1) * (NRPRMO + 1 + NMCOR) + 1
C                                        Check that accumulation
C                                        buffer is not exceeded.
      IF (KBUFF.GT.KLIM) THEN
         WRITE (MSGTXT,1180) KBUFF
         CALL MSGWRT (8)
         IRET = 12
         GO TO 999
         END IF
C                                        Initialize parms weight.
      WGT = 0.0
      DO 220 I = 1,MCOR
         INDEX = KBUFF + NRPRMO + (I-1)*3
C                                        Check weight.
         IF (VIS(3,I).GT.0.0) THEN
C                                        Accumulate vis data.
            IF (MRG) THEN
C                                         Merge
C                                         Take correlator with the
C                                         highest weight.  Take latest
C                                         if equal weight unless there
C                                         is a big amplitude difference
               IF (VIS(3,I).EQ.VBUFF(INDEX+3)) THEN
                  AMP1 = VBUFF(INDEX+1)*VBUFF(INDEX+1) +
     *                   VBUFF(INDEX+2)*VBUFF(INDEX+2)
                  AMP2 = VIS(1,I)*VIS(1,I) + VIS(2,I)*VIS(2,I)
                  IF (AMP1.LT.0.25*AMP2) VBUFF(INDEX+3) = -10
                  IF (AMP2.LT.0.25*AMP1) VIS(3,I) = -10
                  END IF
               IF (VIS(3,I).GT.VBUFF(INDEX+3)) THEN
                  VBUFF(INDEX+1) = VIS(1,I)
                  VBUFF(INDEX+2) = VIS(2,I)
                  VBUFF(INDEX+3) = VIS(3,I)
C                                        Get PARMS from last record
C                                        from which any data is
C                                        accepted.
                  WGT = 1
                  END IF
            ELSE
C                                       Average
               VBUFF(INDEX+1) = VBUFF(INDEX+1) + VIS(1,I)*VIS(3,I)
               VBUFF(INDEX+2) = VBUFF(INDEX+2) + VIS(2,I)*VIS(3,I)
               VBUFF(INDEX+3) = VBUFF(INDEX+3) + VIS(3,I)
C                                         Use largest weight for uv etc
               WGT = MAX (WGT, VIS(3,I))
               END IF
            END IF
 220     CONTINUE
C                                         Accumulate PARMS only if some
C                                         data was good.
      IF (WGT.GT.0.0) THEN
C                                        For merge.
         IF (MRG) THEN
            DO 230 IP = 1,NRPRMO
               VBUFF(KBUFF+IP) = RPARM(IP)
 230           CONTINUE
C                                        Keep accumulated weight = 1
C                                        Unless there is no data.
            VBUFF(KBUFF) = WGT
         ELSE
            DO 240 IP = 1,NRPRMO
               IF (ANOTA(IP).EQ.2) THEN
                  VBUFF(KBUFF+IP) = VBUFF(KBUFF+IP) + RPARM(IP)*WGT
               ELSE IF (ANOTA(IP).EQ.1) THEN
                  VBUFF(KBUFF+IP) = VBUFF(KBUFF+IP) + RPARM(IP)
               ELSE
                  IF (VBUFF(KBUFF+IP).EQ.0.0) VBUFF(KBUFF+IP) =
     *               RPARM(IP)
                  END IF
 240           CONTINUE
C                                        Accumulate weights.
            VBUFF(KBUFF) = VBUFF(KBUFF) + WGT
C                                        Don't weight baseline number,
C                                        source, FQ id. or int. time
C           VBUFF(KBUFF+ILOCB+1) = RPARM(ILOCB+1)
C           IF (ILOCSU.GE.0) VBUFF(KBUFF+ILOCSU+1) = RPARM(ILOCSU+1)
C           IF (ILOCFQ.GE.0) VBUFF(KBUFF+ILOCFQ+1) = RPARM(ILOCFQ+1)
C           IF (ILOCIT.GE.0) VBUFF(KBUFF+ILOCIT+1) =
C    *         VBUFF(KBUFF+ILOCIT+1) + RPARM(ILOCIT+1)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVAVDO: ANTENNA NUMBERS NOT IN INCREASING ORDER',2I3)
 1060 FORMAT ('UVAVDO: ERROR',I6,' EXPANDING OUTPUT FILE')
 1090 FORMAT ('UVAVDO: RECORDS NOT IN TIME (TB) ORDER')
 1104 FORMAT ('UVAVDO: SOMETHING WRONG WITH SORT')
 1113 FORMAT ('UVAVDO: ERROR',I3,' WRITING VIS FILE')
 1130 FORMAT ('UVAVDO: ERROR',I3,' CLOSING VIS FILE')
 1135 FORMAT ('UVAVDO: Average time=',F9.2,' sec.')
 1140 FORMAT ('UVAVDO: Data merged by UVAVG')
 1145 FORMAT ('UVAVDO: only one in ',F6.0,' output records actually',
     *        ' written.')
 1150 FORMAT ('UVAVDO: ',I10,' Visibility records written, subarray',I3)
 1160 FORMAT ('UVAVDO: Parameter MXINDX too small (',I5,' )')
 1180 FORMAT ('UVAVDO: Parameter ACSIZE too small (',I8,' )')
      END

      SUBROUTINE UVGET (OPCODE, RPARM, VIS, IERR)
C-----------------------------------------------------------------------
C! Read UV data with optional calibration, editing, selection, etc.
C# UV IO-appl Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2000, 2004-2007, 2010-2012, 2015-2016, 2018,
C;  Copyright (C) 2022, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Subroutine to obtain data from a data base with optional application
C   of flaging and/or calibration information.  Reads data with a large
C   variety of selection criteria and will reformat the data as
C   necessary.  Does many of the startup operations, finds uv data file
C   etc, reads CATBLK and updates the DUVH.INC commons to reflect the
C   output rather than input data.
C      Most of the input to UVGET is through the commons in DSEL.INC;
C   the initial (default) values of these may be set using routine
C   SELINI.
C   Input:
C      OPCODE   C*4       Opcode:
C                         'INIT' => Open files Initialize I/O.
C                         'READ' => Read next specified record.
C                         'CLOS' => Close files.
C   Inputs via common /SELCAL/  (Include DSEL.INC)
C      UNAME    C*12      AIPS name of input file.
C      UCLAS    C*6       AIPS class of input file.
C      UDISK    R         AIPS disk of input file.
C      USEQ     R         AIPS sequence of input file.
C      SOURCS   C(30)*16  Names of up to 30 sources, *=>all
C                         First character of name '-' => all except
C                         those specified.
C      TIMRNG   R(8)      Start day, hour, min, sec, end day, hour,
C                         min, sec. 0's => all
C      UVRNG    R(2)      Minimum and maximum baseline lengths in
C                         1000's wavelengths. 0's => all
C      STOKES   C*4       Stokes types wanted.
C                         'I','Q','U','V','R','L','IQU','IQUV'
C                         '    '=> Leave data in same form as in input.
C      BCHAN    I         First channel number selected, 1 rel. to first
C                         channel in data base. 0 => all
C      ECHAN    I         Last channel selected. 0=>all
C      BIF      I         First IF number selected, 1 rel. to first
C                         IF in data base. 0 => all
C      EIF      I         Last IF selected. 0=>all
C      DOCAL    L         If true apply calibration, else not.
C      DOPOL    I         If true then correct for feed polarization
C                         based on antenna file info.
C      DOACOR   L         True if autocorrelations are requested.
C      DOWTCL   L         True if weight calibration wanted.
C      DOFQSL   L         True if FREQSEL random parm present (false)
C      FRQSEL   I         Default FQ table entry to select (-1)
C      SELBAN   R         Bandwidth (Hz) to select (-1.0)
C      SELFRQ   D         Frequency (Hz) to select (-1.0)
C      DOBAND   I         >0 if bandpass calibration. (-1)
C      PBPBUF   L         Pointer to memory for bandpass cal application
C      DOSMTH   I         if smoothing requested: 1 before, 1 after BP
C      SMOOTH   R(3)      Smoothing parameters (0.0s)
C      DXTIME   R         Integration time (days). Used when applying
C                         delay corrections to correct for delay error.
C      ANTENS   I(50)     List of antennas selected, 0=>all,
C                         any negative => all except those specified
C      SUBARR   I         Subarray desired, 0=>all which does not work
C                         if any calibration is applied.
C      FGVER    I         FLAG file version number, if < 0 then
C                         NO flagging is applied. 0 => use highest
C                         numbered table.
C      CLUSE    I         Cal (CL or SN) file version number to apply.
C      BLVER    I         BL Table to apply .le. 0 => none
C      BPVER    I         BP table to apply .le. 0 => none
C      INITVS   I         First visibility number to read in a single
C                         source file (default = 1).
C   Output:
C      RPARM    R(*)      Random parameter array of datum.
C      VIS      R(3,*)    Regular portion of visibility data.
C      IERR     I         Error code: 0 => OK,
C                             -1 => end of data
C                             >0 => failed, abort process.
C   Output in commons in DSEL.INC: The default values will be filled in
C   if null values were specified.
C      UVFREQ   D         Frequency corresponding to u,v,w
C      CATBLK   I(256)    Catalog header block, describes the output
C                         data rather than input.
C      NPRMIN   I         Number or random parameters in the input data.
C      TRANSL   L         If true translate data to requested Stokes'
C      CNTREC   I(2,3)    Record counts:
C                         (1&2,1) Previously flagged (partly, fully)
C                         (1&2,2) Flagged due to gains (part, full)
C                         (1&2,3) Good selected (part, full)
C      ISCMP    L         True if input data is compressed.
C      KLOCSU   I         0-rel random parm. pointer for source in input
C                         file.
C      KLOCFQ   I         0-rel random parm. pointer for FQ id in input
C                         file.
C      KLOCIF   I         0-rel random parm. pointer for IF in input
C                         file.
C      KLOCFY   I         0-rel random parm. pointer for freq. in input
C                         file.
C      KLOCWT   I         0-rel random parm. pointer for weight in
C                         input file.
C      KLOCSC   I         0-rel random parm. pointer for scale in
C                         input file.
C   Usage notes:
C    1) Include DSEL.INC should be declared in the main program or at a
C       level that they will not be overlaid while UVGET is in use (ie.
C       between the 'INIT' and 'CLOS' calls). SELINI can be used to
C       initialize the control variables in these commons.
C    2) If no sorting is done UVGET uses AIPS luns 25, 28, 29 and 30
C      (1 map, 3 non map files).  If sorting is done (usually possible)
C      then 8 map and 3 non map files are used (mostly on OPCODE='INIT')
C      and LUNs 16,17,18,19,20,21,22,23,24,25, 28,29,30,40,42,43,44,45.
C    3) OPCODE = 'INIT' does the following:
C      - The catalgue data file is located and the catalog header
C        record is read.
C      - The source file (if any) is read.
C      - The index file (if any) is initialized.
C      - The flag file (if any) is initialized and sorted if necessary
C        (Must be in time order).
C      - The gain table (if any) is initialized.
C      - The bandpass table (if any) is initialized
C      - The smoothing convolution table (if any) is initialized
C      - I/O to the input file is initialized.
C            The following LUNs may be used but will be closed on
C        return: 16, 17, 18, 19, 20, 21, 22, 23, 24
C            The following LUNs may be used but will be open on
C        return: 25 (uv data), 28 (NX table), 29 (CL or SN table),
C                30 (FG table), 40 (BL table), 41 (BP table).
C            NO data are returned from this call.
C    4) OPCODE = 'READ' reads one visibility record properly selected,
C       transformed (e.g. I pol.), calibrated and edited as requested
C       in the call with OPCODE = 'INIT'
C    5) OPCODE = 'CLOS' closes all files used by UVGET which are still
C       open.  No data are returned.
C    6) If DOCAL is true then the common array CNTREC will contain the
C       counts of records which are good or fully or partly flagged
C       both previously and due to flagged gain solutions.
C    7) Only one subarray can be calibrated at a time if DOPOL is true.
C       This is because the polarization information for only one
C       subarray is kept at a time.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      REAL      RPARM(*), VIS(3,*)
      INTEGER   IERR
C
      CHARACTER STAT*4, TYPTMP*2, ARNAME*8, KEYWRD*8
      INTEGER   IROUND, IUBIND, JERR, KEY(2,2), NFGBUF, I, ICNO, LENBU,
     *   NREAD, BO, VER, MMS, MMCH, MMIF, MSGSAV, NKEY, NREC, NCOL,
     *   KLOCS, KEYTYP, KEYV, NUMKEY, KEYSUB(2,2), LUDISK, LUCNO, LFGVER
      HOLLERITH CATH(256), KEYVAL(2)
      LOGICAL   T, F, GOTIT, TABLE, FQEXIS, FITASC, MATCH, DOWARN, SAME,
     *   ISCAL
      REAL      FKEY(2,2), TIMLST
      DOUBLE PRECISION DMULT
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DBPC.INC'
      INCLUDE 'INCS:DPDC.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      INCLUDE 'INCS:DCHND.INC'
      EQUIVALENCE (CATUV, CATH)
      SAVE TYPTMP, DOWARN, LUDISK, LUCNO, LFGVER, TIMLST
      DATA DOWARN /.TRUE./
      DATA T, F /.TRUE.,.FALSE./
      DATA KEY  /5,0,1,0/
      DATA FKEY /1.0,0.0,1.0,0.0/
      DATA KEYSUB /4*1/
      DATA BO /1/
      DATA LUDISK, LUCNO, LFGVER /-1, -1, -100/
C-----------------------------------------------------------------------
      IERR = 1
      MSGSAV = MSGSUP
C                                       Check OPCODE
      IF (OPCODE.EQ.'CLOS') GO TO 900
      IF (OPCODE.EQ.'READ') GO TO 300
      IF (OPCODE.NE.'INIT') THEN
         WRITE (MSGTXT,1000) OPCODE
         GO TO 990
         END IF
C                                       INIT.
C                                       Find file.
      IF (NCFILE.GE.FILIST) THEN
         MSGTXT = 'UVGET: FILE LIST OVERFLOWS'
         IERR = 9
         GO TO 990
         END IF
      NFGBUF = 512
      IUCNO = 1
      IUDISK = IROUND (UDISK)
      IUSEQ = IROUND (USEQ)
      TYPTMP = '  '
      CALL CATDIR ('SRCH', IUDISK, IUCNO, UNAME, UCLAS, IUSEQ, TYPTMP,
     *   NLUSER, STAT, UBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, UNAME, UCLAS, IUSEQ, IUDISK, NLUSER
         GO TO 990
      ELSE IF ((TYPTMP.NE.'UV') .AND. (TYPTMP.NE.'SC')) THEN
         IERR = 5
         WRITE (MSGTXT,1011) UNAME, UCLAS, IUSEQ, TYPTMP
         GO TO 990
         END IF
C                                       Read CATUV and mark 'READ'.
C                                       (Must be WRIT to create new
C                                       Cal table.)
      CALL CATIO ('READ', IUDISK, IUCNO, CATUV, 'READ', UBUFF, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.LT.5) THEN
            WRITE (MSGTXT,1020) IERR
            GO TO 990
         ELSE
            WRITE (MSGTXT,1021) IERR
            CALL MSGWRT (6)
            END IF
         END IF
C                                       Mark in CFILES
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = IUDISK
      FCNO(NCFILE) = IUCNO
      FRW(NCFILE) = 0
C                                       same as last time?
      SAME = (IUDISK.EQ.LUDISK) .AND. (IUCNO.EQ.LUCNO)
      LUDISK = IUDISK
      LUCNO = IUCNO
C                                       Save CFILES no. for later
      ICNO = NCFILE
C                                       Set /UVHDR/
      CALL COPY (256, CATUV, CATBLK)
      CALL UVPGET (IERR)
C                                       Save frequency of u,v,w
      UVFREQ = FREQ
C                                       Save no. random parms.
      NPRMIN = NRPARM
C                                       Save source no. pointer
      KLOCSU = ILOCSU
C                                       Is FREQSEL rand parm present
      DOFQSL = ILOCFQ.GT.0
      KLOCFQ = ILOCFQ
C                                       Save relevant pointers for
C                                       flagging
      KLOCIF = JLOCIF
      KLOCFY = JLOCF
C                                       Set defaults for file
      UDISK = IUDISK
      USEQ = CATUV(KIIMS)
C                                       Set LUNs
      IULUN = 25
      IXLUN = 28
      ICLUN = 29
      IFLUN = 30
      IBLUN = 40
      IPLUN = 42
      LUNSBP = 43
      IQLUN = 44
      IANLUN = 45
C                                       be friendly
C                                       Is there an FQ table
      IF (DOFQSL) THEN
         VER = 1
         CALL ISTAB ('FQ', IUDISK, IUCNO, VER, IQLUN, FQBUFF,
     *      TABLE, FQEXIS, FITASC, IERR)
         IF (.NOT.FQEXIS) THEN
            SELBAN = -1.0
            SELFRQ = -1.D0
            FRQSEL = -1
            GO TO 35
C                                       ISTAB reads 1st record
         ELSE
            IF (FQBUFF(5).LE.1) FRQSEL = 1
            END IF
         END IF
C                                       Check defaults
      IF ((SELBAN.LE.0.0) .AND. (SELFRQ.LE.0.D0)) THEN
         IF (DOFQSL .AND. (FRQSEL.LE.0)) THEN
            WRITE (MSGTXT,1070) FRQSEL
            IERR = 1
            GO TO 990
            END IF
         END IF
C                                       Frequency selection criteria
      IF ((SELBAN.GT.0.0) .OR. (SELFRQ.GT.0.D0)) THEN
C                                       Do SELBAN/SELFRQ match
C                                       FQ entries?
         VER = 1
         CALL FQMATC (IUDISK, IUCNO, CATUV, IQLUN, SELBAN, SELFRQ,
     *      MATCH, FRQSEL, IERR)
         IF (.NOT.MATCH) THEN
            WRITE (MSGTXT,1060)
            IERR = 1
            GO TO 990
            END IF
         END IF
C                                       Flagging
 35   CALL FNDEXT ('FG', CATBLK, VER)
      DOFLAG = (FGVER.GE.0) .AND. (VER.GT.0)
C                                       Timerange
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
C                                       Set time range.
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
C                                       UV range
      DOUVRA = (UVRNG(1).GT.0.0) .OR. (UVRNG(2).GT.0.0)
      IF (UVRNG(2).LE.0.0) UVRNG(2) = 1.0E10
      UVRA(1) = 1.0E6 * UVRNG(1) * UVRNG(1)
      UVRA(2) = 1.0E6 * UVRNG(2) * UVRNG(2)
      UVRA(1) = UVRA(1) - 1.0E-10
C                                       Channels
      IF (BCHAN.LE.0) BCHAN = 1
      IF (ECHAN.LE.0) ECHAN = CATUV(KINAX+JLOCF)
      IF (BCHAN.GT.CATUV(KINAX+JLOCF)) BCHAN = CATUV(KINAX+JLOCF)
      IF (ECHAN.GT.CATUV(KINAX+JLOCF)) ECHAN = CATUV(KINAX+JLOCF)
      BCHANS = BCHAN
      ECHANS = ECHAN
C                                       IF
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = MAX (1, MIN (BIF, CATUV(KINAX+JLOCIF)))
         IF (EIF.LT.BIF) EIF = CATUV(KINAX+JLOCIF)
         EIF = MAX (BIF, MIN (EIF, CATUV(KINAX+JLOCIF)))
         END IF
C                                       uvrange needs FQ info now
      CHNIF = 1
      FOFF(1) = 0.0D0
      IF (DOUVRA) THEN
         VER = 1
         CALL CHNDAT ('READ', FQBUFF, IUDISK, IUCNO, VER, CATUV, IQLUN,
     *      CHNIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IERR)
         IF ((IERR.NE.0) .AND. (EIF.GT.1)) THEN
            MSGTXT = 'UVRANGE APPLIED AT HEADER FREQUENCY ONLY'
            CALL MSGWRT (7)
            END IF
         END IF
C                                       Check sizes
      MMS  = MAX (1, CATBLK(KINAX+JLOCS))
      MMCH = MAX (1, CATBLK(KINAX+JLOCF))
      IF (JLOCIF.GT.0) THEN
         MMIF = MAX (1, CATBLK(KINAX+JLOCIF))
      ELSE
         MMIF = 1
         END IF
      IF ((MMCH.GT.MAXCHA) .OR. (MMIF.GT.MAXIF) .OR.
     *   (3*MMS*MMIF*MMCH.GT.UVBFSS)) THEN
         IERR = 1
         MSGTXT = 'UVGET: VISIBILITIES TOO BIG FOR BUFFERS'
         GO TO 990
         END IF
C                                       Convert STOKES depending on
C                                       present data types
      CALL FNDPOL (STOKES, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       See if data to be translated
      TRANSL = .NOT.((STOKES.EQ.' ') .OR.
     *   ((STOKES.EQ.'HALF') .AND. (ICOR0.LT.0)) .OR.
     *   ((STOKES.EQ.'FULL') .AND. (ICOR0.LT.0)))
C                                       Set poln. code.
      PMODE = 0
C                                       Init SOURCE file.
      CALL SOUFIL (IERR)
      IF ( IERR .NE. 0 ) GO TO 999
C                                       check on BL table
      CALL FNDEXT ('BL', CATBLK, VER)
      IF (VER.LE.0) BLVER = -1
      DOBL = BLVER.GE.0
C                                       Insist on TB Sort if calibration
C                                       or flagging being applied.
      TIMORD = ISORT(1:1).EQ.'T'
      IF (DOCAL .OR. DOBL .OR. (DOBAND.GT.1)) THEN
         IF (.NOT.TIMORD) THEN
            IERR = 1
            WRITE (MSGTXT,1050) ISORT
            GO TO 990
            END IF
         END IF
C                                       get antenna info always
      ISCAL = DOCAL .OR. DOBL .OR. (DOPOL.GT.0) .OR. (DOBAND.GT.0)
      IF (DOCAL .OR. DOBL .OR. (DOPOL.GT.0) .OR. (DOBAND.GT.0)) THEN
         CALL FNDEXT ('AN', CATBLK, VER)
         VER = MAX (1, VER)
         IF (VER.LE.1) SUBARR = 1
         IF ((SUBARR.LT.1) .OR. (SUBARR.GT.VER)) THEN
            IERR = 1
            WRITE (MSGTXT,1051) SUBARR
            IF (SUBARR.LE.0) THEN
               CALL MSGWRT (8)
               MSGTXT = 'SPLIT AND SPLAT CAN APPLY CAL TO ALL SUBARRAYS'
               END IF
            GO TO 990
            END IF
         CALL TABINI ('READ', 'AN', IUDISK, IUCNO, SUBARR, CATBLK,
     *      IFLUN, NKEY, NREC, NCOL, UBUFF, FGBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1052) SUBARR, IERR
            GO TO 990
            END IF
         KEYWRD = 'ARRNAM'
         CALL TABKEY ('READ', KEYWRD, 1, FGBUFF, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1053) SUBARR, IERR
            CALL MSGWRT (7)
         ELSE
            CALL H2CHR (8, 1, KEYVAL, ARNAME)
            IF (ARNAME.EQ.'EVLA') THEN
               NUMKEY = 1
               MSGSUP = 32000
               CALL CATKEY ('READ', IUDISK, IUCNO, 'CROSSPOW', NUMKEY,
     *            KLOCS, KEYV, KEYTYP, UBUFF, IERR)
               MSGSUP = MSGSAV
               IF (IERR.NE.0) KEYV = 1
               IF (KEYV.GE.1) DOWTCL = .FALSE.
               END IF
            END IF
         CALL TABIO ('CLOS', 0, 1, UBUFF, FGBUFF, IERR)
         END IF
C                                       Init Flag file
      TMFLST = -1.0E20
      NUMFLG = 0
      KNCOR = NCOR
      KCOR0 = ICOR0
      KNCF = INCF / CATUV(KINAX)
      KNCIF = INCIF / CATUV(KINAX)
      KNCS = INCS / CATUV(KINAX)
      UBUFSZ = UVBFSL * 2
      IF (DOFLAG) THEN
         MSGSUP = 32000
C                                       Reformat table?
         CALL FGREFM (IUDISK, IUCNO, FGVER, CATUV, IFLUN, JERR)
         CALL FLGINI ('READ', FGBUFF, IUDISK, IUCNO, FGVER, CATUV,
     *      IFLUN, IFGRNO, FGKOLS, FGNUMV, JERR)
         MSGSUP = MSGSAV
         IF (JERR.NE.0) DOFLAG = F
C                                       Resort if necessary.
         IF (DOFLAG .AND. (FGBUFF(43).NE.KEY(1,1))) THEN
C                                       Sort to time order.
            CALL TABIO ('CLOS', 0, NREAD, UBUFF, FGBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TABSRT (IUDISK, IUCNO, 'FG', FGVER, FGVER, KEY, KEYSUB,
     *         FKEY, FGBUFF, CATUV, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       Re initialize.
            CALL FLGINI ('READ', FGBUFF, IUDISK, IUCNO, FGVER, CATUV,
     *         IFLUN, IFGRNO, FGKOLS, FGNUMV, IERR)
            END IF
         END IF
      IF (((.NOT.SAME) .OR. (LFGVER.NE.FGVER)) .AND. (FGVER.GT.-99))
     *   THEN
         IF (DOFLAG) THEN
            WRITE (MSGTXT,1035) FGVER
         ELSE
            MSGTXT = 'UVGET: doing no flagging this time'
            END IF
         CALL MSGWRT (3)
         LFGVER = FGVER
         END IF
C                                       Set up data selection.
C                                       Restore CATUV to /MAPHDR/ -
C                                       TABSRT will destroy contents
      CALL COPY (256, CATUV, CATBLK)
      CALL DGINIT (STOKES, BCHAN, ECHAN, BIF, EIF, MVIS, JADR, SELFAC,
     *   ALLWT, PMODE, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (MVIS(1).GT.MAXCIF) THEN
         IERR = 1
         MSGTXT = 'UVGET: VISIBILITIES TOO BIG FOR BUFFERS'
         GO TO 990
         END IF
C                                       Init spectral smoothing table
      CALL SETSM (IERR)
      IF (IERR.NE.0) GO TO 999
      IF ((ECHANS.GT.ECHAN) .OR. (BCHANS.LT.BCHAN)) THEN
         DMULT = ECHANS - BCHANS + 1.0D0
         DMULT = DMULT / (ECHAN-BCHAN+1.0D0)
         MVIS(1) = MVIS(1) * DMULT + 0.1D0
         END IF
C                                       this overflows
C     IF (ECHAN-BCHAN+1.GT.0) MVIS(1) = MVIS(1) * (ECHANS-BCHANS+1) /
C    *   (ECHAN-BCHAN+1)
C                                       Set up for polarization
C                                       correction.
      IF (DOPOL.GT.0) THEN
         CALL POLSET (IERR)
      ELSE
         CALL GETANT (IUDISK, IUCNO, SUBARR, CATUV, POLCAL, IERR)
         END IF
      IF (IERR.NE.0) GO TO 999
C                                       Init BP file - May call TABSRT
      IF ((DOBAND.GT.0) .AND. (PBPBUF.EQ.0)) THEN
         CALL BPASET (IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Init Cal file - May call TABSRT
      CALL GAININ (IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Compressed data?
      ISCMP = CATBLK(KINAX).EQ.1
C                                       Find pointers for compressed
C                                       data
      IF (ISCMP) THEN
         CALL AXEFND (8, 'WEIGHT  ', CATUV(KIPCN), CATH(KHPTP), KLOCWT,
     *      JERR)
C                                       Must have this one
         IF ((JERR.NE.0) .OR. (KLOCWT.LT.0)) THEN
            IERR = 5
            MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
            GO TO 990
            END IF
         CALL AXEFND (8, 'SCALE   ', CATUV(KIPCN), CATH(KHPTP), KLOCSC,
     *      JERR)
C                                       Get data decompression pointers
         CALL CMPARM (BIF, EIF, BCHAN, ECHAN, BCHANS, ECHANS,
     *      NDECMP, DECMP)
      ELSE
         KLOCWT = -1
         KLOCSC = -1
         END IF
C                                       Restore CATUV to /MAPHDR/ -
C                                       TABSRT will destroy contents
      CALL COPY (256, CATUV, CATBLK)
C                                       Init INDEX file.
      MSGSUP = 32000
      CALL INDXIN (IERR)
      MSGSUP = MSGSAV
      IF (IERR.NE.0) GO TO 999
C                                       Warning on multi-source no NX
      IF ((INXRNO.LT.0) .AND. (KLOCSU.GE.0) .AND. (DOWARN)) THEN
         MSGTXT = '****** WARNING: NO NX TABLE IN MULTI-SOURCE FILE'
         CALL MSGWRT (7)
         MSGTXT = '******    SELECTION AND FLAGGING BY SOURCE DISABLED'
         CALL MSGWRT (7)
         MSGTXT = '******    YOU SHOULD RUN INDXR'
         CALL MSGWRT (7)
         DOWARN = .FALSE.
         END IF
C                                       Open UV file
      CALL ZPHFIL (TYPTMP, IUDISK, IUCNO, 1, UFILE, IERR)
      CALL ZOPEN (IULUN, IUFIND, IUDISK, UFILE, T, F, T, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1030) IERR
         GO TO 990
         END IF
C                                       Init I/O to uvfile
      IF (LSTVIS.GT.CATUV(KIGCN)) THEN
         LSTVIS = CATUV(KIGCN)
         FSTVIS = MIN (FSTVIS, MAX (1, LSTVIS-1))
         END IF
      NREAD = LSTVIS - FSTVIS + 1
      FSTRED = FSTVIS - 1
      FSTRD3 = FSTRED
      RECNO3 = FSTRED
      NREAD3 = NREAD
      FSTVS3 = FSTVIS - 1
      LSTVS3 = LSTVIS
      LRECIN = LREC
      LENBU = 0
C                                       No data
      IF (NREAD.LT.1) THEN
         IERR = -1
         MSGTXT = 'UVGET: NO DATA SELECTED'
         GO TO 990
         END IF
C                                       init read
      CALL UVINIT ('READ', IULUN, IUFIND, NREAD, FSTRED, LRECIN, LENBU,
     *   UBUFSZ, UBUFF, BO, IUBIND, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1045) IERR
         GO TO 990
         END IF
      DOUVIN = T
      LENBU3 = LENBU
      FSTVIS = 0
      LSTVIS = 0
CCCC
C                                       Look out for LL only.
C      IF ((ICOR0 .EQ. -2) .AND. (STOKES .EQ. 'HALF'))
C     *   PMODE = 9
CCCC
C                                       Correct CATBLK to output data
      CALL DGHEAD
C                                       Update /UVHDR/ common
      CALL UVPGET (JERR)
C                                       Reset number of Stokes wanted.
      IF (ICOR0.EQ.-1) KNCOR = NCOR
C                                       Init "last time"
      TIMLST = -1.0E10
      GO TO 999
C-----------------------------------------------------------------------
C                                       READ/select datum
C                                       Get next selected datum
 300  CALL DATGET (RPARM, VIS, TIMLST, JERR)
C                                       Check for end of file
      IERR = JERR
      IF (JERR.EQ.4) IERR = -1
      GO TO 999
C-----------------------------------------------------------------------
C                                       Close files
C                                       UV data file
 900  MSGSUP = 32000
      CALL ZCLOSE (IULUN, IUFIND, IERR)
      MSGSUP = MSGSAV
C                                       INDEX file
      IF (INXRNO.GT.0) CALL TABIO ('CLOS', 0, NREAD, UBUFF, NXBUFF,
     *   IERR)
C                                       Cal file
      IF (DOCAL) CALL TABIO ('CLOS', 0, NREAD, UBUFF, CLBUFF, IERR)
C                                       FLAG file
      IF (DOFLAG) CALL TABIO ('CLOS', 0, NREAD, UBUFF, FGBUFF, IERR)
C                                       BL file
      IF (DOBL) CALL TABIO ('CLOS', 0, NREAD, UBUFF, BLBUFF, IERR)
C                                       de-allocate memory
      IF ((DOBAND.GT.0) .AND. (PBPBUF.NE.0)) THEN
         CALL ZMEMRY ('FRAL', 'BPASET', 0, BPBUF, PBPBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1900) IERR, 'BANDPASS'
            CALL MSGWRT (6)
            END IF
         PBPBUF = 0
C                                       BP file
         CALL TABIO ('CLOS', 0, NREAD, UBUFF, BPBUFF, IERR)
         END IF
      IF ((DOPOL.GT.0) .AND. (PPOLCL.NE.0)) THEN
         CALL ZMEMRY ('FRAL', 'POLSET', 0, DTERMS, PDTERM, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1900) IERR, 'POLARIZATION'
            CALL MSGWRT (6)
            END IF
         PDTERM = 0
         PPOLCL = 0
         END IF
C                                       Clear status
      STAT = 'CLRD'
      CALL CATDIR ('CSTA', IUDISK, IUCNO, UNAME, UCLAS, IUSEQ, TYPTMP,
     *   NLUSER, STAT, UBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      IERR = 0
C                                       Clear /CFILES/ entry.
      GOTIT = F
      DO 910 I = 1,NCFILE
         GOTIT = GOTIT .OR.
     *      (((FVOL(I).EQ.IUDISK).AND.(FCNO(I).EQ.IUCNO)) .AND.
     *      (FRW(I).EQ.0))
         IF (GOTIT) THEN
            FVOL(I) = FVOL(I+1)
            FCNO(I) = FCNO(I+1)
            FRW(I) = FRW(I+1)
            END IF
 910     CONTINUE
      IF (GOTIT) NCFILE = NCFILE - 1
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVGET: UNKNOWN OPCODE: ',A4)
 1010 FORMAT ('UVGET: ERROR ',I3,' FINDING FILE:', A12,'.',A6,
     *   '.',I3,' DISK=',I2,' USER=',I5)
 1011 FORMAT ('UVGET: FOUND FILE:', A12,'.',A6,'.',I4,' TYPE ',A2,
     *   ' NOT UV OR SC')
 1020 FORMAT ('UVGET: ERROR ',I3,' READING DATA CATALOG HEADER')
 1021 FORMAT ('UVGET: WARNING',I3,' WITH DATA CATALOG HEADER STATUS')
 1030 FORMAT ('UVGET: ERROR ',I3,' OPENING UV DATA FILE')
 1035 FORMAT ('UVGET: Using flag table version',I4,' to edit data')
 1045 FORMAT ('UVGET: ERROR ',I3,' INITING UV DATA FILE')
 1050 FORMAT ('UVGET: DATA IN WRONG SORT ORDER = ',A2,' NOT T*')
 1051 FORMAT ('UVGET: SUBARRAY',I5,' NOT ACCEPTABLE WHEN CALIBRATING')
 1052 FORMAT ('UVGET: SUBARRAY',I3,' ERROR',I4,' OPENING AN TABLE')
 1053 FORMAT ('UVGET: SUBARRAY',I3,' ERROR',I4,' READING ARRAY NAME')
 1060 FORMAT ('UVGET: SELBAN & SELFRQ ADVERBS DO NOT MATCH DATA')
 1070 FORMAT ('UVGET: FREQID = ',I3,' FORBIDDEN, USE USEFUL VALUE')
 1900 FORMAT ('UVGET: ERROR',I4,' FREEING ',A,' CAL MEMORY')
      END

      SUBROUTINE EDITOR (BRANCH)
C-----------------------------------------------------------------------
C! does operations needed at start and end of editing existing procedure
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   EDITOR performs the operations required to begin and to stop
C   editing an existing procedure.
C   Inputs:
C      BRANCH   I  opcode: 1 - EDIT
C                          2 - ENDEDIT
C                          3 - MODIFY
C                          4 - ERASE
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      CHARACTER PRGNAM*6
      REAL      EPSILN
      INTEGER   POTERR, TSTACK(100), BPR(100), A(100), B(100), REASON,
     *   I, IT, LL, NT, LL1, NTHEN, NWHILE, NELSE, NEND, NENDR, NFOR
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DSMS.INC'
      INCLUDE 'INCS:DIO.INC'
      EQUIVALENCE (BPR (1), V(1)), (STACK(1), A(1)),  (CSTACK(1), B(1))
      DATA PRGNAM /'EDITOR'/
      DATA EPSILN /1.0E-6/
      DATA NTHEN, NWHILE, NELSE, NEND, NENDR, NFOR
     *   /   107,    109,   106,   22,    96,   21/
C-----------------------------------------------------------------------
      POTERR = 76
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.4)) GO TO 980
      GO TO (100, 200, 100, 100), BRANCH
C-----------------------------------------------------------------------
C                                       E D I T  <name>  <line>
C                                       M O D I F Y  <name>  <line>
C                                       D E L E T E <name> <lin1:lin2>
C-----------------------------------------------------------------------
C                                        get procedure name
 100  POTERR = 71
      IF (MODE.EQ.1) GO TO 980
      POTERR = 0
C                                       MODIFY is interactive only
      IF (BRANCH.EQ.3) THEN
         IF ((TSKNAM(1:5).EQ.'AIPSC') .OR. (NPOPS.GT.NINTRN) .OR.
     *      (ISBTCH.EQ.32000)) POTERR = 60
         IF (IUNIT.NE.1) POTERR = 53
         IF (POTERR.NE.0) GO TO 980
         END IF
      CALL GETFLD
      IF ((ERRNUM.NE.0) .OR. ((SYTYPE.NE.3) .AND. (SYTYPE.NE.4))) THEN
         WRITE (MSGTXT,1100) 'FIRST'
         CALL MSGWRT (6)
         IF (ERRNUM.EQ.0) POTERR = 11
         GO TO 980
         END IF
C                                        protect VLAGEN'd ones
      POTERR = 25
      IF (L.LT.K(7)) GO TO 980
      IP = TAG
      NAMEP = LOCSYM + 2
C                                        get line number
      CALL GETFLD
      IF ((ERRNUM.NE.0) .OR. (SYTYPE.NE.11)) THEN
         WRITE (MSGTXT,1100) 'SECOND'
         CALL MSGWRT (6)
         IF (ERRNUM.EQ.0) POTERR = 23
         GO TO 980
         END IF
      IPT = ';'
      LL = X(1)
      IF (BRANCH.EQ.3) X(1) = LL
      LL1 = LL
C                                       2nd line number on ERASE
      IF (BRANCH.EQ.4) THEN
         CALL GETFLD
         IF (ERRNUM.NE.0) GO TO 980
         IF ((TAG.GT.0) .AND. (TAG.NE.20)) THEN
            POTERR = 8
            IF (TAG.NE.15) GO TO 980
            CALL GETFLD
            IF (ERRNUM.NE.0) GO TO 980
            POTERR = 23
            IF (SYTYPE.NE.11) GO TO 980
            LL = X(1)
            IF (LL.LT.LL1) THEN
               I = LL1
               LL1 = LL
               LL = I
               END IF
            END IF
C                                       Check for line 1
         IF (LL1.LE.1) THEN
            WRITE (MSGTXT,1104)
            CALL MSGWRT (8)
            POTERR = 25
            GO TO 980
            END IF
         END IF
      DO 110 I = 1,LL
         IF (I.LE.LL1) LP = IP
         IP = K(IP)
         IF (IP.EQ.0) GO TO 120
 110     CONTINUE
C
 120  IF (IP.NE.0) IP = K(IP)
      XX = LL
      IF ((ABS(X(1)-XX).GT.EPSILN) .AND. (BRANCH.NE.4)) LP = K(LP)
      MODE = 1
      IF (BRANCH.EQ.3) MODE = 3
      LPGM = LP
      AP = 0
      IF (BRANCH.NE.4) GO TO 999
C-----------------------------------------------------------------------
C                                        ENDEDIT
C-----------------------------------------------------------------------
 200  MODE = 0
      AP = 0
      K(LPGM) = IP
C                                       Just like FINISH in PSEUDO.
      NT = 0
      POTERR = 11
      IF ((NAMEP.LT.200) .OR. (NAMEP.GT.KXORG)) GO TO 980
      L = K(NAMEP)
      POTERR = 11
      IF (L.EQ.0) GO TO 980
      NAMEP = 0
 210  LINK = K(L)
         L = L + 1
 215     L = L + 1
            IF (K(L).EQ.1) GO TO 240
C                                          THEN or WHILE.
            IF ((K(L).NE.NTHEN) .AND. (K(L).NE.NWHILE)) GO TO 225
 220           CALL PUSH (TSTACK, NT, L)
               IF (ERRNUM.NE.0) GO TO 980
               CALL PUSH (TSTACK, NT, K(L))
               IF (ERRNUM.NE.0) GO TO 980
               GO TO 215
C                                          ELSE or END.
 225        IF ((K(L).NE.NELSE) .AND. (K(L).NE.NEND) .AND.
     *         (K(L).NE.NENDR)) GO TO 230
               POTERR = 21
               IF (NT.EQ.0) GO TO 980
               CALL POP (TSTACK, NT, REASON)
               IF (ERRNUM.NE.0) GO TO 980
               IF (((REASON.EQ.NELSE) .OR. (REASON.EQ.NTHEN)) .AND.
     *            (K(L).EQ.NEND)) K(L) = NENDR
               CALL POP (TSTACK, NT, IT)
               IF (ERRNUM.NE.0) GO TO 980
               IF (IT.EQ.0) GO TO 215
                  K(IT-2) = -L-1
                  K(IT-1) = -LINK
                  IF (LINK.LE.0) K(IT-1) = -K(3)
                  IF (K(L).EQ.NELSE) GO TO 220
                  GO TO 215
C                                          FOR.
 230        IF (K(L).NE.NFOR) GO TO 215
               CALL PUSH (TSTACK, NT, 0)
               IF (ERRNUM.NE.0) GO TO 980
               CALL PUSH (TSTACK, NT, K(L))
               IF (ERRNUM.NE.0) GO TO 980
               GO TO 215
C                                        program chunk
 240     L = LINK
         IF (L.NE.0) GO TO 210
      POTERR = 21
      IF (NT.NE.0) GO TO 980
      IPT = '>'
      IF (MODE.NE.0) THEN
         CALL PUSH (A, AP, 1)
         IF (ERRNUM.NE.0) GO TO 980
         END IF
      POTERR = 20
      IF (LEVEL.NE.0) GO TO 980
      GO TO 999
C
C                                          Error return.
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('PROBLEM WITH ',A,' ARGUMENT OF EDIT, MODIFY, OR DELETE')
 1104 FORMAT ('ERASE LINE 1 NOT ALLOWED: DO YOU WANT SCRATCH ?')
      END

      SUBROUTINE ZFI2 (OPER, FCB, BUFF, NREC, MSGBUF, IERR)
C-----------------------------------------------------------------------
C! read/write one 256-integer record from/to a non-map disk file
C# Z2 IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Transfer one 256 local integer record between an I/O buffer and
C   disk starting at random access record "nrec" using "non-map" I/O
C   (i.e., single buffered, synchronous I/O).
C   Inputs:
C      OPER   H*4      Operation code "READ" or "WRIT"
C                      CHARACTER on VMS, HOLLERITH otherwise
C      FCB    I(*)     File control block for opened non-map disk file
C      NREC   I        Disk record number (1-relative, units of
C                      256-integer records)
C   In/out:
C      BUFF   I(256)   I/O buffer
C   Output:
C      MSGBUF H*80     extra error message (null terminated)
C                      CHARACTER on VMS, HOLLERITH otherwise
C      IERR   I        Error return code: 0 => no error
C                         2 => bad opcode
C                         3 => I/O error
C                         4 => end of file
C  Generic version - stub
C--------------------------------------------------------------------
      HOLLERITH OPER, MSGBUF(*)
      INTEGER   FCB, NREC, BUFF(256), IERR
C
      CHARACTER CMSGB*80
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CMSGB = 'ZFI2: REQUIRES LOCAL DEVELOPMENT'
      CALL CHR2H (80, CMSGB, 1, MSGBUF)
      IERR = 2
C
 999  RETURN
      END

      SUBROUTINE TABPD (OPCODE, BUFFER, IPDRNO, PDKOLS, PDNUMV, NUMIF,
     *   NUMFRQ, NUMPOL, ANT, SUBA, FREQID, REFANT, PHDIFF, DTERMS,
     *   IERR)
C-----------------------------------------------------------------------
C! Does I/O to antenna polarization spectrum (PD) table opened by PDINI
C# EXT-util UV Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 2010, 2013, 2015, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to antenna polarization spectrum (PD) extention tables.
C   Usually used after setup by PDINI.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'READ' = read entry from table.
C                        'WRIT' = write entry in table.
C                        'CLOS' = close file, flush on write
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open. Should have been returned by
C                        PDINI or TABINI.
C      IPDRNO   I        Next entry number to read or write.
C      PDKOLS   I(MAXPDC) The column pointer array in order,
C                        ANTENNA, SUBARRAY, FREQID, REFANT,
C                        P_DIFF, REAL1, IMAG1,
C                        Following used if 2 polarizations per IF
C                        REAL2, IMAG2.
C      PDNUMV   I(MAXPDC) Element count in each column.
C      NUMIF    I        Number of IF's
C      NUMFRQ   I        Number of chns
C      NUMPOL   I        Number of polarizations per IF.
C   Input/output: (written to or read from baseline file)
C      ANT     I        Antenna number.
C      SUBA    I        Subarray number.
C      FREQID  I        Freq. id number
C      REFANT  I(2)     Reference Antenna; one for each poln
C      P_DIFF  R(n,m)   R-L phase difference n channels, m IFS
C      DTERMS  C(n,m,p) Complex bandpass: n channels; m IFS; p polns
C   Output:
C      IPDRNO    I      Next solution number.
C      IERR      I      Error code, 0=>OK else TABIO error.
C                       Note: -1=> read but all polzn #1 flagged
C                             -2=> read but all polzn #2 flagged
C                             -3=> both flagged
C                             -4=> table record flagged
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXPDC, XPDRSZ
      PARAMETER (MAXPDC = 9)
      PARAMETER (XPDRSZ = 2 * MAXCIF + 4 + MAXIF)
C
      CHARACTER OPCODE*4
      INTEGER   BUFFER(*), IPDRNO, PDKOLS(MAXPDC), PDNUMV(MAXPDC),
     *   NUMIF, NUMFRQ, NUMPOL, SUBA, ANT, FREQID, REFANT(2), IERR
      REAL      PHDIFF(*), DTERMS(*)
C
      INTEGER   RECI(XPDRSZ), KOLS(MAXPDC), SUBKOL, ANTKL, FRQKOL,
     *   REF1KL, RE1KL, IM1KL, RE2KL, IM2KL, PDFKL, LOOP, NDATA,
     *   BDCNT1, BDCNT2, INDX, NNDX
      REAL      RECR(XPDRSZ)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (KOLS(1), ANTKL), (KOLS(2), SUBKOL),
     *   (KOLS(3), FRQKOL), (KOLS(4), REF1KL), (KOLS(5), PDFKL),
     *   (KOLS(6), RE1KL), (KOLS(7), IM1KL), (KOLS(8), RE2KL),
     *   (KOLS(9), IM2KL)
      SAVE RECR
      EQUIVALENCE (RECR, RECI)
C-----------------------------------------------------------------------
      BDCNT1 = 0
      BDCNT2 = 0
C                                       Close
      IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, IPDRNO, RECR, BUFFER, IERR)
         IF (IERR.GT.0) GO TO 980
         GO TO 999
         END IF
C                                       Check sizes
      NNDX = NUMPOL * NUMFRQ * NUMIF
      IF (NNDX.GT.MAXCIF) THEN
         IERR = 1
         MSGTXT = 'TABPD: RECRS TOO BIG FOR BUFFERS'
         GO TO 985
         END IF
      IF (NNDX.LE.0) THEN
         IERR = 1
         MSGTXT = 'TABPD: ZERO SIZE DATA REQUESTED'
         GO TO 985
         END IF
      IF (NUMPOL.GT.2) THEN
         IERR = 1
         MSGTXT = 'TABPD: > 2 POLARIZATIONS IN POL SPECTRUM TABLE!'
         GO TO 985
         END IF
C                                       Set pointers
      NDATA = MAXPDC
      CALL COPY (NDATA, PDKOLS, KOLS)
      NNDX = NUMFRQ * NUMIF
C                                       If write fill RECR
      IF (OPCODE.NE.'READ') THEN
         RECI(ANTKL) = ANT
         RECI(SUBKOL) = SUBA
         IF (FRQKOL.GT.0) RECI(FRQKOL) = FREQID
         RECI(REF1KL) = REFANT(1)
C                                       First polarization
         INDX = 0
         DO 20 LOOP = 1,NNDX
            INDX = INDX + 1
            RECR(RE1KL) = DTERMS(INDX)
            INDX = INDX + 1
            RECR(IM1KL) = DTERMS(INDX)
            RE1KL = RE1KL + 1
            IM1KL = IM1KL + 1
            IF (PDNUMV(5).GT.0) THEN
               RECR(PDFKL) = PHDIFF(LOOP)
               PDFKL = PDFKL + 1
               END IF
 20         CONTINUE
C                                       Second polarization
         IF (NUMPOL.GT.1) THEN
            DO 30 LOOP = 1,NNDX
               INDX = INDX + 1
               RECR(RE2KL) = DTERMS(INDX)
               INDX = INDX + 1
               RECR(IM2KL) = DTERMS(INDX)
               RE2KL = RE2KL + 1
               IM2KL = IM2KL + 1
 30            CONTINUE
            END IF
         END IF
C                                       Process record.
      CALL TABIO (OPCODE, 0, IPDRNO, RECR, BUFFER, IERR)
      IPDRNO = IPDRNO + 1
      IF (IERR.GT.0) GO TO 980
C                                       If READ pick data from RECR.
      IF (OPCODE.EQ.'READ') THEN
         IF (IERR.LT.0) IERR = -4
         ANT    = RECI(ANTKL)
         SUBA   = RECI(SUBKOL)
         IF (FRQKOL.LE.0) THEN
            FREQID = 1
         ELSE
            FREQID = RECI(FRQKOL)
            END IF
         REFANT(1) = RECI(REF1KL)
C                                       First polarization
         INDX = 0
         DO 80 LOOP = 1,NNDX
            INDX = INDX + 1
            DTERMS(INDX) = RECR(RE1KL)
            INDX = INDX + 1
            DTERMS(INDX) = RECR(IM1KL)
            IF ((RECR(RE1KL).EQ.FBLANK) .OR.
     *         (RECR(IM1KL).EQ.FBLANK)) BDCNT1 = BDCNT1 + 1
            RE1KL = RE1KL + 1
            IM1KL = IM1KL + 1
            IF (PDNUMV(5).GT.0) THEN
               PHDIFF(LOOP) = RECR(PDFKL)
               PDFKL = PDFKL + 1
               END IF
 80         CONTINUE
C                                       Second polarization
         IF (NUMPOL.GT.1) THEN
            DO 90 LOOP = 1,NNDX
               INDX = INDX + 1
               DTERMS(INDX) = RECR(RE2KL)
               INDX = INDX + 1
               DTERMS(INDX) = RECR(IM2KL)
               IF ((RECR(RE2KL).EQ.FBLANK) .OR.
     *             (RECR(IM2KL).EQ.FBLANK)) BDCNT2 = BDCNT2 + 1
               RE2KL = RE2KL + 1
               IM2KL = IM2KL + 1
 90            CONTINUE
            END IF
         END IF
      IF (IERR.GT.-4) THEN
         IF (BDCNT1.EQ.(NUMIF*NUMFRQ)) IERR = -1
         IF (BDCNT2.EQ.(NUMIF*NUMFRQ)) IERR = -2
         IF ((BDCNT1.EQ.(NUMIF*NUMFRQ)) .AND.
     *      (BDCNT2.EQ.(NUMIF*NUMFRQ))) IERR = -3
         END IF
      GO TO 999
C                                       Error
 980  WRITE (MSGTXT,1980) IERR
C
 985  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('TABPD: TABIO ERROR',I3)
      END

LOCAL INCLUDE 'SPMOD.INC'
C                                       Local include for SPMOD
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   MAXGAU
      PARAMETER (MAXGAU = 9999)
C
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, JBUFSZ, ILOCWT,
     *   NGAUSS, CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO,
     *   INCIFO, LRECO, NRPRMI, NRPRMO, OLDCNO, NEWCNO
      LOGICAL   ISCOMP, DOSPIX
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4,30), XCALC(1), XNAMOU(3),
     *   XCLAOU(2), XXSTOK(1), XINLST(12)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, INLIST*48
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XSUBA, XBIF, XEIF, XBCHAN, XECHAN, XDOCAL, XGUSE, XDOPOL,
     *   XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH(3), XDOAC, XSOUT,
     *   XDISO, FLUX, FACTOR, QUAL, DOHIST, BADD(10)
      REAL      BUFF1(UVBFSS), BUFF2(UVBFSS), DXCG(MAXGAU),
     *   DYCG(MAXGAU), DZCG(MAXGAU), ZEROSP(MAXGAU,2), GPOS(2,MAXGAU),
     *   GWID(3,MAXGAU), SCENTR(MAXGAU), SWIDTH(MAXGAU)
      INTEGER   ITYPE(MAXGAU)
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XXSTOK, XTIME, XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF, XBCHAN,
     *   XECHAN, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND,
     *   XBPVER, XSMOTH, XDOAC, XNAMOU, XCLAOU, XSOUT, XDISO, XINLST,
     *   FLUX, FACTOR, QUAL, DOHIST, BADD
      COMMON /UVMPRM/ CATOLD, SEQIN, SEQOUT, DISKIN, DISKO, ISCOMP,
     *   ILOCWT, NGAUSS, INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO,
     *   LRECO, NRPRMI, NRPRMO, OLDCNO, NEWCNO, DOSPIX
      COMMON /UVMDLS/ GPOS, GWID, DXCG, DYCG, DZCG, ZEROSP, SCENTR,
     *   SWIDTH, ITYPE
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, INLIST
LOCAL END
      PROGRAM SPMOD
C-----------------------------------------------------------------------
C! Add source model to uv data
C# UV Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 2013, 2015, 2018, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SPMOD inserts model visibilities into a data base adding noise.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      FLUX           FLUX          Noise level in Jy.
C      FACTOR         FACTOR        Multiplication factor for previous
C                                   data to be added to current.
C      QUAL           QUAL          If greater than zero then reset
C                                   weights to a value of 1.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'SPMOD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'SPMOD '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL SPMDIN (PRGM, IRET)
C                                       Call routine that sends data
C                                       to the user routine.
      IF (IRET.EQ.0) CALL SPMDUV (IRET)
C                                       History, copy tables
      IF (IRET.EQ.0) CALL SPMDHI
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE SPMDIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   SPMDIN gets input parameters for SPMOD and creates an output file
C   if necessary.
C-----------------------------------------------------------------------
      CHARACTER STAT*4, PRGN*6, UTYPE*2
      INTEGER   JERR, IROUND, NPARM, IERR, LUN, I, NFREQ, INCX
      LOGICAL   T, MATCH
      REAL      RPARM(20)
      HOLLERITH CATH(256)
      INCLUDE 'SPMOD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (CATBLK, CATH)
      DATA T /.TRUE./
      DATA LUN /20/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 191
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (4, 1, XXSTOK, STOKES)
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (48, 1, XINLST, INLIST)
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = XDOAC.GT.0.0
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Source parms
      IF (INLIST.EQ.' ') THEN
         MSGTXT = 'INPUT MODEL TEXT FILE MUST BE GIVEN'
         IERR = 10
         GO TO 990
      ELSE
         CALL READIT (IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
      DO 25 I = 1,NGAUSS
         ITYPE(I) = ITYPE(I) + 1
         IF ((ITYPE(I).LT.1) .OR. (ITYPE(I).GT.6)) ITYPE(I) = 1
         IF (ITYPE(I).EQ.5) THEN
            GWID(2,I) = GWID(1,I)
            GWID(3,I) = 0.0
            END IF
 25      CONTINUE
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      IF (ICOR0.GT.0) THEN
         IF (NCOR.EQ.1) THEN
            STOKES = 'I'
         ELSE
            IF (STOKES.NE.'HALF') STOKES = 'IV'
            END IF
      ELSE
         IF ((STOKES.NE.'I') .AND. (STOKES.NE.'IV')) STOKES = 'HALF'
         END IF
C                                       If compressed, uncompress
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NFREQ = CATBLK(KINAX+JLOCF)
      BCHAN = IROUND (XBCHAN)
      ECHAN = IROUND (XECHAN)
      IF ((BCHAN.LE.0) .OR. (BCHAN.GT.NFREQ)) BCHAN = 1
      IF ((ECHAN.LE.0) .OR. (ECHAN.GT.NFREQ)) ECHAN = NFREQ
      IF (BCHAN.GT.ECHAN) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, BUFF1, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, BUFF1, IERR)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       check that single source by now
      CALL AXEFND (6, 'SOURCE', CATBLK(KIPCN), CATH(KHPTP), I, IERR)
      IF (IERR.EQ.0) THEN
         MSGTXT = 'MORE THAN ONE SOURCE SELECTED: NOT ALLOWED'
         JERR = 10
         GO TO 990
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       read compressed => write compr.
      IF (ISCOMP) THEN
         CATBLK(KINAX) = 1
         I = CATBLK(KIPCN)
         CALL CHR2H (8, 'WEIGHT  ', 1, CATH(KHPTP+2*I))
         CALL CHR2H (8, 'SCALE   ', 1, CATH(KHPTP+2*I+2))
         CATBLK(KIPCN) = I + 2
         ILOCWT = I
         END IF
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, BUFF1, JERR)
      IF (JERR.NE.0) THEN
         IF (JERR.NE.2) THEN
            WRITE (MSGTXT,1050) JERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((CCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', BUFF1, JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1065) JERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
      NEWCNO = CCNO
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      UTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, 'READ', BUFF1, JERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       Copy any header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPMDIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('SPMDIN: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE SPMDUV (IRET)
C-----------------------------------------------------------------------
C   Routine to read data, send it to SPMODL to add a model and/or
C   noise and write the output file.
C-----------------------------------------------------------------------
      CHARACTER PHNAME*48
      INTEGER   IRET, IPTRO, LUNO, INDO, NCORO, ILENBU, KBIND, NIOUT,
     *   NIOLIM, I, IA1, IA2, BO, VO, NCOPY, NUMVIS, XCOUNT, NNCOR,
     *   CATMP(256), RNXRET
      DOUBLE PRECISION XDEC, XRA
      LOGICAL   T, F
      INCLUDE 'SPMOD.INC'
      REAL      DUM, BASEN, VIS(UVBFSS), RPARM(20), ROTATE, CATR(256)
      DOUBLE PRECISION UVSCAL
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (CATR, CATBLK)
      DATA LUNO /17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      MSGSUP = 32000
      CALL ROTFND (CATR, ROTATE, IRET)
      MSGSUP = 0
      DO 10 I = 1,NGAUSS
         CALL XYSHFT (RA, DEC, GPOS(1,I), GPOS(2,I), ROTATE, XRA, XDEC)
         IF (TYPUVD.EQ.0) THEN
            CALL SHISIN (RA, DEC, ROTATE, XRA, XDEC, DXCG(I), DYCG(I),
     *         DZCG(I))
         ELSE IF (TYPUVD.EQ.-1) THEN
            CALL SHINCP (RA, DEC, ROTATE, XRA, XDEC, DXCG(I), DYCG(I),
     *         DZCG(I))
         ELSE
            DXCG(I) = TWOPI * GPOS(1,I) * DG2RAD / 3600.0D0
            DYCG(I) = TWOPI * GPOS(2,I) * DG2RAD / 3600.0D0
            DZCG(I) = 0.0
            END IF
         GWID(1,I) = GWID(1,I) * DG2RAD / 3600.0D0
         GWID(2,I) = GWID(2,I) * DG2RAD / 3600.0D0
 10      CONTINUE

      CALL RANDIN (IRET)
C                                       Number of visibilities in input
C                                       and output files.
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       defend cat header from UVGET
      CALL COPY (256, CATBLK, CATMP)
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL COPY (256, CATMP, CATBLK)
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, NEWCNO, 1, PHNAME, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, PHNAME, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
C                                       LRECO = length of output rec.
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
      NUMVIS = 0
      XCOUNT = 0
      NNCOR = LREC - NRPARM
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
      IF ((FREQ.GT.0.0D0) .AND. (UVFREQ.GT.0.0D0)) THEN
         UVSCAL = FREQ / UVFREQ
      ELSE
         UVSCAL = 1.0D0
         END IF
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over buffer
      ELSE IF (IRET.EQ.0) THEN
         IF (ILOCB.GE.0) THEN
            BASEN = RPARM(1+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
            END IF
         NUMVIS = NUMVIS + 1
C                                       Call user routine.
         CALL SPMODL (NUMVIS, RPARM(1+ILOCU), RPARM(1+ILOCV),
     *      RPARM(1+ILOCW), VIS, IRET)
C                                       Error (fatal)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
C                                       Copy to output.
         ELSE IF (IRET.EQ.0) THEN
            XCOUNT = XCOUNT + 1
            RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
            RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
            RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
            CALL RCOPY (NRPRMI, RPARM, BUFF2(IPTRO))
C                                       update NX table
            CALL RNXUPD (RPARM, RNXRET)
C                                       Compressed
            IF (ISCOMP) THEN
               CALL ZUVPAK (NCORO, VIS, BUFF2(IPTRO+ILOCWT),
     *            BUFF2(IPTRO+NRPRMO))
            ELSE
               CALL RCOPY (NCOPY, VIS, BUFF2(IPTRO+NRPRMO))
               END IF
            IPTRO = IPTRO + LRECO
            NIOUT = NIOUT + 1
            END IF
C                                       Write vis record.
         IF (NIOUT.GE.NIOLIM) THEN
            CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1150) IRET
               GO TO 990
               END IF
            IPTRO = KBIND
            NIOUT = 0
            END IF
         GO TO 100
         END IF
C                                       Final call to SPMODL.
      NUMVIS = -1
      CALL SPMODL (NUMVIS, DUM, DUM, DUM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, NEWCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
C                                       close NX table
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPMDUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1010 FORMAT ('SPMDUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1020 FORMAT ('SPMDUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1100 FORMAT ('SPMDUV: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('SPMDUV: SPMODL ERROR',I3)
 1150 FORMAT ('SPMDUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE SPMDHI
C-----------------------------------------------------------------------
C   SPMDHI copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, CTYP(6)*4
      INTEGER   LUN1, LUN2, IERR, I, J
      LOGICAL   T
      INCLUDE 'SPMOD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUN1, LUN2 /27,28/
      DATA CTYP /'POIN', 'GAUS', 'DISK', 'RECT', 'SPHE', 'EXP '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO,
     *   CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 60
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 60
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 60
C                                       calibration history
      CALL CALHIS (LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 60
C
      IF ((NGAUSS.LE.4) .OR. (DOHIST.GT.0.0)) THEN
         DO 30 I = 1,NGAUSS
            WRITE (HILINE,1400) TSKNAM, I, CTYP(ITYPE(I))
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            MSGTXT = HILINE
            CALL MSGWRT (3)
            IF (IERR.NE.0) GO TO 60
            WRITE (HILINE,1410) TSKNAM, I, ZEROSP(I,1)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            MSGTXT = HILINE
            CALL MSGWRT (3)
            IF (IERR.NE.0) GO TO 60
            WRITE (HILINE,1411) TSKNAM, I, ZEROSP(I,2)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            MSGTXT = HILINE
            CALL MSGWRT (3)
            IF (IERR.NE.0) GO TO 60
            DO 25 J = 1,2
               WRITE (HILINE,1420) TSKNAM, J, I, GPOS(J,I)
               CALL HIADD (LUN2, HILINE, BUFF2, IERR)
               MSGTXT = HILINE
               CALL MSGWRT (3)
               IF (IERR.NE.0) GO TO 60
 25            CONTINUE
            IF (ITYPE(I).NE.1) THEN
               GWID(1,I) = GWID(1,I) * 3600. / DG2RAD
               GWID(2,I) = GWID(2,I) * 3600. / DG2RAD
               WRITE (HILINE,1430) TSKNAM, I, GWID(1,I)
               CALL HIADD (LUN2, HILINE, BUFF2, IERR)
               MSGTXT = HILINE
               CALL MSGWRT (3)
               IF (IERR.NE.0) GO TO 60
               WRITE (HILINE,1431) TSKNAM, I, GWID(2,I)
               CALL HIADD (LUN2, HILINE, BUFF2, IERR)
               MSGTXT = HILINE
               CALL MSGWRT (3)
               IF (IERR.NE.0) GO TO 60
               WRITE (HILINE,1432) TSKNAM, I, GWID(3,I)
               CALL HIADD (LUN2, HILINE, BUFF2, IERR)
               MSGTXT = HILINE
               CALL MSGWRT (3)
               IF (IERR.NE.0) GO TO 60
               END IF
            IF (DOSPIX) THEN
               WRITE (HILINE,1433) TSKNAM, I, SCENTR(I)
               CALL HIADD (LUN2, HILINE, BUFF2, IERR)
               MSGTXT = HILINE
               CALL MSGWRT (3)
               IF (IERR.NE.0) GO TO 60
               WRITE (HILINE,1434) TSKNAM, I, SWIDTH(I)
               CALL HIADD (LUN2, HILINE, BUFF2, IERR)
               MSGTXT = HILINE
               CALL MSGWRT (3)
               IF (IERR.NE.0) GO TO 60
               END IF
 30         CONTINUE
         END IF
C                                       noise
      WRITE (HILINE,1440) TSKNAM, FLUX
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (3)
      IF (IERR.NE.0) GO TO 60
C
      WRITE (HILINE,1445) TSKNAM, FACTOR
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (3)
      IF (IERR.NE.0) GO TO 60
C
      IF (QUAL.GT.0.0) THEN
         WRITE (HILINE,1450) TSKNAM
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         MSGTXT = HILINE
         CALL MSGWRT (3)
         END IF
C
 60   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                       Copy tables
      CALL COPTAB (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'SPMDHI: ERROR COPYING TABLES TO OUTPUT UV'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPMDHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1400 FORMAT (A6,'TYPE(',I4.3,') = ''',A4,'''')
 1410 FORMAT (A6,'RMAX(',I4.3,') = ',1PE12.4,' / in Jy.')
 1411 FORMAT (A6,'LMAX(',I4.3,') = ',1PE12.4,' / in Jy.')
 1420 FORMAT (A6,'GPOS(',I1,',',I4.3,') = ',1PE12.4,' / in Arcsec.')
 1430 FORMAT (A6,'BMAJ(',I4.3,') = ',1PE12.4,' / FWHM in arcsec')
 1431 FORMAT (A6,'BMIN(',I4.3,') = ',1PE12.4,' / FWHM in arcsec')
 1432 FORMAT (A6,'BPA(',I4.3,') = ',1PE12.4,' / in Deg.')
 1433 FORMAT (A6,'CENTER(',I4.3,') = ',1PE12.4,' / line center chan')
 1434 FORMAT (A6,'WIDTH(',I4.3,') = ',1PE12.4,
     *   ' / line FWHM')
 1440 FORMAT (A6,'FLUX = ',1PE12.4,' / noise added in Jy./Wgt.')
 1445 FORMAT (A6,'FACTOR = ',1PE12.4)
 1450 FORMAT (A6,24X,'/ weights reset to 1.0')
      END
      SUBROUTINE SPMODL (NUMVIS, U, V, W, VIS, IRET)
C-----------------------------------------------------------------------
C   Subroutine to add a model or noise to data.
C   Inputs:
C      NUMVIS     I    Visibility number, -1 => final call, no data
C                      passed but allows any operations to be completed.
C      U          R    U in wavelengths
C      V          R    V in wavelengths
C      W          R    W in wavelengths
C      VIS(3,*) R    Visibilities in order real, imaginary, weight
C                      (Jy, Jy, unitless).  Weight <= 0 => flagged.
C   Inputs from COMMON
C      FREQ       D    Frequency of observation (Hz)
C      CATBLK(256)I    Catalog header record. See Going Aips for
C                      details.
C
C   Output:
C      VIS        R    Visibilities
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C
C   For RR,LL,RL,LR take the following relations:
C   RR => RR + (I - V)*EXP(iCOMPHA)
C   LL => LL + (I + V)*EXP(iCOMPHA)
C   RL => RL + (Q + iU)*EXP(iCOMPHA)
C   and   LR => LR + (Q - iU)*EXP(iCOMPHA)
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IRET
      REAL      U, V, W, VIS(3,*)
C
      INCLUDE 'SPMOD.INC'
      INTEGER   I, IVIS, INDEX, LIMIT, NIF, NCHAN, NPOLN, IIF, ICHAN,
     *   LUN, BUFFER(512), IIVER, FREQID, J, IC
      REAL      TEMP, COMVIS, COMPHA, CPHI, SPHI, UU, VV, UF, VF, WF,
     *   A, LVIS(2,4), YEROSP(MAXGAU,2), YLUX, CATR(256), RR, AMPVIS,
     *   YSP(MAXGAU)
      DOUBLE PRECISION FRQFAC, R
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ISBAND(MAXIF)
      DOUBLE PRECISION  FOFF(MAXIF)
      REAL      FINC(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      SAVE YLUX, YEROSP, YSP, NCHAN, NPOLN
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (CATR, CATBLK)
      DATA LUN /25/
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.LT.0) GO TO 999
C                                       Setup: IF table
      IF (NUMVIS.EQ.1) THEN
         IIVER = 1
         FREQID = FRQSEL
         CALL CHNDAT ('READ', BUFFER, DISKIN, OLDCNO, IIVER, CATOLD,
     *      LUN, NIF, FOFF, ISBAND, FINC, BNDCOD, FREQID, IRET)
         IF (IRET.NE.0) GO TO 999
C                                        No. IFs.
         NIF = 1
         IF (JLOCIF.GT.0) NIF = CATBLK(KINAX+JLOCIF)
C                                       No. Channels
         NCHAN = 1
         IF (JLOCF.GT.0) NCHAN = CATBLK(KINAX+JLOCF)
C                                       No. polarizations.
         NPOLN = 1
         IF (JLOCS.GT.0) NPOLN = CATBLK(KINAX+JLOCS)
         CALL RCOPY (2*MAXGAU, ZEROSP, YEROSP(1,1))
         YLUX = MAX (0.0, FLUX)
         TEMP = 4.0 * LOG (2.0)
         CALL RFILL (NGAUSS, TEMP, YSP)
         DO 10 I = 1,NGAUSS
            IF (SWIDTH(I).GT.0.0) YSP(I) = YSP(I) / (SWIDTH(I)**2)
 10         CONTINUE
         END IF
C                                       Loop over IF
      A = 3.14159 / LOG (2.0)
      A = A * A
      IC = 0
      DO 600 IIF = BIF,EIF
C                                       Loop over Channels
         DO 550 ICHAN = 1,NCHAN
            IC = IC + 1
C                                       Scale U,V,W to frequency.
            FRQFAC = (UVFREQ + FOFF(IIF) + (ICHAN - CATR(KRCRP+JLOCF)) *
     *         FINC(IIF)) / UVFREQ
            UF = U * FRQFAC
            VF = V * FRQFAC
            WF = W * FRQFAC
C                                       Visibility index
            INDEX = (ICHAN-1) * INCFI + (IIF-1) * INCIFI + 1
C                                       Calculate vis
            CALL RFILL (8, 0.0, LVIS)
            DO 60 J = 1,NGAUSS
               AMPVIS = YSP(J) * ((IC - SCENTR(J)) ** 2)
               IF (AMPVIS.LE.10.0) THEN
                  AMPVIS = EXP (-AMPVIS)
                  COMPHA = UF*DXCG(J) + VF*DYCG(J) + WF*DZCG(J)
                  CPHI = 6.283185 / 360.0
                  SPHI = SIN (GWID(3,J) * CPHI)
                  CPHI = COS (GWID(3,J) * CPHI)
                  UU = GWID(1,J) * (VF*CPHI + UF*SPHI)
                  VV = GWID(2,J) * (UF*CPHI - VF*SPHI)
                  R = SQRT (UU**2+VV**2)
                  IF (ITYPE(J).EQ.2) THEN
                     COMVIS = EXP (-3.559707 * R**2)
                  ELSE IF (ITYPE(J).EQ.3) THEN
                     RR = R
                     CALL BESSEL (RR, COMVIS)
                  ELSE IF (ITYPE(J).EQ.4) THEN
                     CALL SINC (UU, TEMP)
                     CALL SINC (VV, COMVIS)
                     COMVIS = COMVIS * TEMP
                  ELSE IF (ITYPE(J).EQ.5) THEN
                     RR = R
                     CALL SPHEUV (RR, COMVIS)
                  ELSE IF (ITYPE(J).EQ.6) THEN
                     COMVIS = 1.0 / (1.0 + A*R*R) ** 1.5
                  ELSE
                     COMVIS = 1.0
                     END IF
                  COMVIS = COMVIS * AMPVIS
C                                       RR,LL,RL,LR
                  IF (ICOR0.LE.0) THEN
C                                       Do the RR and LL pairs.
                     LIMIT = 2
                     LIMIT = MIN (NPOLN, LIMIT)
                     DO 30 I = 1,LIMIT
                        LVIS(1,I) = LVIS(1,I) + COMVIS * COS (COMPHA) *
     *                     YEROSP(J,I)
                        LVIS(2,I) = LVIS(2,I) + COMVIS * SIN (COMPHA) *
     *                     YEROSP(J,I)
 30                     CONTINUE
C                                       True I,Q,U,V
                  ELSE
                     DO 50 I = 1,NPOLN
                        LVIS(1,I) = 0.5 * COMVIS * COS (COMPHA) *
     *                     (YEROSP(J,1) + YEROSP(J,2)) + LVIS(1,I)
                        LVIS(2,I) = 0.5 * COMVIS * *SIN (COMPHA) *
     *                     (YEROSP(J,1) - YEROSP(J,2)) + LVIS(2,I)
 50                     CONTINUE
                     END IF
                  END IF
 60            CONTINUE
            DO 70 I = 1,NPOLN
               IVIS = INDEX + (I-1) * INCSI
               IF (QUAL.GT.0.0) VIS(3,IVIS) = 1.0
               IF (VIS(3,IVIS).GT.0.0) THEN
                  VIS(1,IVIS) = VIS(1,IVIS)*FACTOR + LVIS(1,I)
                  VIS(2,IVIS) = VIS(2,IVIS)*FACTOR + LVIS(2,I)
C                                       Add noise to all pairs
                  IF (FLUX.GT.0.0) THEN
                     COMVIS = YLUX / SQRT (VIS(3,IVIS))
                     CALL NOISE (TEMP)
                     VIS(1,IVIS) = VIS(1,IVIS) + TEMP * COMVIS
                     CALL NOISE (TEMP)
                     VIS(2,IVIS) = VIS(2,IVIS) + TEMP * COMVIS
                     END IF
                  END IF
 70            CONTINUE
C                                       End Channel loop
 550        CONTINUE
C                                       End IF loop
 600     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SINC (X, ASINC)
C-----------------------------------------------------------------------
C   Compute ASINC = Sin (pi * X) / (Pi * X)
C    Input:  X       R    Argument
C    Output: ASINC   R    Result
C-----------------------------------------------------------------------
      REAL   X, ASINC
C-----------------------------------------------------------------------
      ASINC = 1.0
      IF (ABS(X).LE.1.0E-20) GO TO 999
         X = 3.14159 * X
         ASINC = SIN(X) / X
C
 999  RETURN
      END
      SUBROUTINE BESSEL (X, ABES)
C-----------------------------------------------------------------------
C   Compute Bessel function (J1)
C   Input:
C      X       R    Argument
C   Output:
C      ABES    R    Result
C-----------------------------------------------------------------------
      REAL      X, ABES, BESSJ1
      REAL      Y
C-----------------------------------------------------------------------
      IF (ABS(X).LE.1.0E-10) THEN
         ABES = 1.0
      ELSE
         Y = 3.141592565 * X
         ABES = 2.0 * BESSJ1 (Y) / Y
         END IF
C
 999  RETURN
      END
      SUBROUTINE SPHEUV (X, ABES)
C-----------------------------------------------------------------------
C   Compute spheroid FT
C   Input:
C      X       R    Argument
C   Output:
C      ABES    R    Result
C-----------------------------------------------------------------------
      REAL      X, ABES
      REAL      Y
C-----------------------------------------------------------------------
      Y = 3.14159 * MAX (X, 0.02)
      ABES = 3. * ((SIN(Y) / Y) - COS(Y)) / (Y * Y)
C
 999  RETURN
      END
      SUBROUTINE NOISE (ANOISE)
C-----------------------------------------------------------------------
C   Random noise generator
C    Output: ANOISE  R    Result
C-----------------------------------------------------------------------
      REAL      ANOISE, TEMP
      INTEGER   J
C-----------------------------------------------------------------------
      ANOISE = -6.0
      DO 10 J = 1,12
         CALL RANDUM (TEMP)
         ANOISE = ANOISE + TEMP
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE BESJ (X, N, BJ, D, IER)
C-----------------------------------------------------------------------
C   Compute the J Bessel function for a given argument and order
C   REPLACED BY BESSJ1 FUNCTION FOLLOWING
C   Inputs:
C      X     R    The argument of the J Bessel function desired
C      N     I    The order of the J Bessel function desired
C      D     R    Required accuracy
C      IER   I    Resultant error code where
C                   IER=0  No error
C                   IER=1  N is negative
C                   IER=2  X is negative or zero
C                   IER=3  Required accuracy not obtained
C                   IER=4  Range of N compared to X not correct
C                          (See Remarks)
C     Output:
C      BJ    R    The resultant J Bessel function
C
C   Remarks
C      N must be greater than or equal to zero, but it must be <
C         20+10*X-X** 2/3   FOR X LESS THAN OR EQUAL TO 15
C         90+X/2           FOR X GREATER THAN 15
C   Method
C      Recurrence relation technique described by H. Goldstein and
C      R.M. Thaler, 'Recurrence Techniques for the Calculation of
C      Bessel Functions', M.T.A.C., v.13, pp.102-108 and I.A. Stegun
C      and M. Abramowitz, 'Generation of Bessel Functions on High
C      Speed Computers', M.T.A.C., v.11, 1957, pp.255-257.
C-----------------------------------------------------------------------
      INTEGER   IER, N, NTEST, IN1, MA, MB, MZERO, MMAX, M, JT, M2, K,
     *   MK
      REAL   BJ, D, X, BPREV, FM1, FM, ALPHA, BMK, S
C-----------------------------------------------------------------------
C                                       Test inputs
      BJ = 0.0
      IF (N.LT.0) THEN
         IER = 1
         GO TO 999
         END IF
      IF (X.LE.0) THEN
         IER = 2
         GO TO 999
         END IF
      IF (X.LE.15.) NTEST = 20. + 10.*X - X ** 2/3
      IF (X.GT.15.) NTEST = 90. + X / 2.
      IF (N.GE.NTEST) THEN
         IER = 4
         GO TO 999
         END IF
      IER = 0
      IN1 = N + 1
      BPREV = .0
C                                       Compute starting value of M
      MA = X + 6.
      IF (X.GE.5.) MA = 1.4 * X + 60. / X
      MB = N + INT(X) / 4 + 2
      MZERO = MAX (MA, MB)
C                                       Set upper limit of M
      MMAX = NTEST
      DO 190 M = MZERO,MMAX,3
C                                       Set F(M), F(M-1)
         FM1 = 1.0E-28
         FM = 0.0
         ALPHA = 0.0
         JT = 1
         IF (M.EQ.(M/2)*2) JT = -1
         M2 = M - 2
         DO 160 K = 1,M2
            MK = M - K
            BMK = 2.0 * REAL(MK) * FM1/X - FM
            FM = FM1
            FM1 = BMK
            IF (MK.EQ.N+1) BJ = BMK
            JT = -JT
            S = 1 + JT
            ALPHA = ALPHA + BMK*S
 160        CONTINUE
         BMK = 2.0 * FM1/X - FM
         IF (N.EQ.0) BJ = BMK
         ALPHA = ALPHA + BMK
         BJ = BJ / ALPHA
         IF (ABS(BJ-BPREV).LE.ABS(D*BJ)) GO TO 999
            BPREV = BJ
 190     CONTINUE
      IER = 3
C
 999  RETURN
      END
      FUNCTION BESSJ1 (X)
C-----------------------------------------------------------------------
C   Compute the J1 Bessel function for a given argument
C   Inputs:
C      X     R    The argument of the J1 Bessel function desired
C   Output:
C            R    Returns the resultant J1 Bessel function
C   Method
C      from "Numerical Recipes" by Press et al.
C-----------------------------------------------------------------------
      REAL BESSJ1, X
C
      REAL AX, XX, Z
      DOUBLE PRECISION P1, P2, P3, P4, P5, Q1, Q2, Q3, Q4, Q5, R1, R2,
     *   R3, R4, R5, R6, S1, S2, S3, S4, S5, S6, Y
      SAVE P1, P2, P3, P4, P5, Q1, Q2, Q3, Q4, Q5, R1, R2, R3, R4, R5,
     *   R6, S1, S2, S3, S4, S5, S6
      DATA R1, R2, R3, R4, R5, R6 /72362614232.D0, -7895059235.D0,
     *   242396853.1D0, -2972611.439D0, 15704.48260D0, -30.16036606D0/
      DATA S1, S2, S3, S4, S5, S6 /144725228442.D0, 2300535178.D0,
     *   18583304.74D0, 99447.43394D0, 376.9991397D0, 1.D0/
      DATA P1, P2, P3, P4, P5 /1.D0, .183105D-2, -.3516396496D-4,
     *   .2457520174D-5, -.240337019D-6/
      DATA Q1, Q2, Q3, Q4, Q5 /.04687499995D0, -.2002690873D-3,
     *   .8449199096D-5, -.88228987D-6, .105787412D-6/
C-----------------------------------------------------------------------
      IF (ABS(X).LT.8.) THEN
         Y = X**2
         BESSJ1 = X*(R1+Y*(R2+Y*(R3+Y*(R4+Y*(R5+Y*R6))))) /
     *      (S1+Y*(S2+Y*(S3+Y*(S4+Y*(S5+Y*S6)))))
      ELSE
         AX = ABS (X)
         Z = 8. / AX
         Y = Z**2
         XX = AX - 2.356194491
         BESSJ1 = SIGN (1., X) * SQRT (.636619772/AX) *
     *      (COS(XX)*(P1+Y*(P2+Y*(P3+Y*(P4+Y*P5)))) -
     *       Z*SIN(XX)*(Q1+Y*(Q2+Y*(Q3+Y*(Q4+Y*Q5)))))
         END IF
C
 999  RETURN
      END
      SUBROUTINE READIT (IERR)
C-----------------------------------------------------------------------
C   Reads INLIST to make a list of coordinates of sources
C   Outputs:
C      IERR   I   Error code: > 0 quit
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'SPMOD.INC'
      INTEGER   TLUN, INGAUS, TIND, JTRIM, LLIM, LP
      CHARACTER LINE*132
      DOUBLE PRECISION X
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA TLUN /3/
C-----------------------------------------------------------------------
C                                       open the text file
      CALL ZTXOPN ('READ', TLUN, TIND, INLIST, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN TEXT FILE'
         GO TO 980
         END IF
C                                       defaults
      CALL RFILL (2*MAXGAU, 0.0, ZEROSP)
      CALL RFILL (2*MAXGAU, 0.0, GPOS)
      CALL RFILL (3*MAXGAU, 0.0, GWID)
      CALL RFILL (MAXGAU, 0.0, SCENTR)
      CALL RFILL (MAXGAU, 0.0, SWIDTH)
      CALL FILL (MAXGAU, 0, ITYPE)
      INGAUS = NGAUSS
      NGAUSS = 0
C                                       read until end or max
 10   CALL ZTXIO ('READ', TLUN, TIND, LINE, IERR)
      IF ((IERR.EQ.0) .AND. (NGAUSS.LT.MAXGAU)) THEN
         LLIM = JTRIM (LINE)
         IF (LLIM.LE.0) GO TO 10
         IF ((LINE(:1).EQ.'#') .OR. (LINE(:1).EQ.';')) GO TO 10
C                                       flux
         LP = 1
         CALL GETNUM (LINE, LLIM, LP, X)
         IF (X.EQ.DBLANK) GO TO 900
         NGAUSS = NGAUSS + 1
         ZEROSP(NGAUSS,1) = X
         ZEROSP(NGAUSS,2) = X
C                                       position
         IF (LP.LE.LLIM) THEN
            CALL GETNUM (LINE, LLIM, LP, X)
            IF (X.EQ.DBLANK) GO TO 900
            GPOS(1,NGAUSS) = X
            END IF
         IF (LP.LE.LLIM) THEN
            CALL GETNUM (LINE, LLIM, LP, X)
            IF (X.EQ.DBLANK) GO TO 900
            GPOS(2,NGAUSS) = X
            END IF
C                                       width
         IF (LP.LE.LLIM) THEN
            CALL GETNUM (LINE, LLIM, LP, X)
            IF (X.EQ.DBLANK) GO TO 900
            GWID(1,NGAUSS) = X
            END IF
         IF (LP.LE.LLIM) THEN
            CALL GETNUM (LINE, LLIM, LP, X)
            IF (X.EQ.DBLANK) GO TO 900
            GWID(2,NGAUSS) = X
            END IF
         IF (LP.LE.LLIM) THEN
            CALL GETNUM (LINE, LLIM, LP, X)
            IF (X.EQ.DBLANK) GO TO 900
            GWID(3,NGAUSS) = X
            END IF
C                                       type
         IF (LP.LE.LLIM) THEN
            CALL GETNUM (LINE, LLIM, LP, X)
            IF (X.EQ.DBLANK) GO TO 900
            ITYPE(NGAUSS) = X + 0.1
            END IF
C                                       line center, width
         IF (LP.LE.LLIM) THEN
            CALL GETNUM (LINE, LLIM, LP, X)
            IF (X.EQ.DBLANK) GO TO 900
            SCENTR(NGAUSS) = X
            END IF
         IF (LP.LE.LLIM) THEN
            CALL GETNUM (LINE, LLIM, LP, X)
            IF (X.EQ.DBLANK) GO TO 900
            SWIDTH(NGAUSS) = X
            END IF
C                                       LL flux
         IF (LP.LE.LLIM) THEN
            CALL GETNUM (LINE, LLIM, LP, X)
            IF (X.EQ.DBLANK) GO TO 900
            ZEROSP(NGAUSS,2) = X
            END IF
C                                       check that there is something
         IF ((ZEROSP(NGAUSS,1).EQ.0.0) .AND. (ZEROSP(NGAUSS,2).EQ.0.0))
     *      NGAUSS = NGAUSS - 1
         GO TO 10
C                                       real error
      ELSE IF ((IERR.GT.0) .AND. (IERR.NE.2)) THEN
         WRITE (MSGTXT,1000) IERR, 'READING TEXT FILE'
         GO TO 980
C                                       EOF
      ELSE
         CALL ZTXCLS (TLUN, TIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'CLOSING TEXT FILE'
            GO TO 980
            END IF
         END IF
      WRITE (MSGTXT,1010) NGAUSS
      CALL MSGWRT (2)
      IF (NGAUSS.LE.0) IERR = 8
      GO TO 999
C                                       format error
 900  WRITE (MSGTXT,1900) NGAUSS
      IERR = 10
C
 980  CALL MSGWRT (8)
      IF (TIND.GT.0) CALL ZTXCLS (TLUN, TIND, LP)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('READIT ERROR',I3,2X,A)
 1010 FORMAT ('READIT: read',I5,' model components')
 1900 FORMAT ('READIT FORMAT ERROR NEAR LINE',I5)
      END

      SUBROUTINE ZMYVER
C-----------------------------------------------------------------------
C! returns OLD, NEW, or TST based on translation of logical AIPS_VERSION
C# Service
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Determine the default AIPS version (OLD or NEW or TST).  Error
C   messages are only written to the terminal since this routine is
C   called before message handling via MSGWRT is established.
C   Output in common /DCHCOM/:
C      VERNAM   C*4   String = 'OLD:', 'NEW:' or 'TST:'
C   Generic version.
C-----------------------------------------------------------------------
      CHARACTER HOLD*4, HNEW*4, HTST*4, HCVX*4
      INTEGER   LLEN, XLEN, XLNB, IERR, DLEN
      CHARACTER LOGNAM*48, XLATED*256, XDEF*256
      INCLUDE 'INCS:DDCH.INC'
      DATA HOLD, HNEW, HTST, HCVX /'OLD:', 'NEW:', 'TST:','CVX:'/
C-----------------------------------------------------------------------
      LLEN = LEN (LOGNAM)
      XLEN = LEN (XLATED)
C                                       Translate default AIPS version.
      LOGNAM = 'AIPS_VERSION'
      CALL ZTRLOG (LLEN, LOGNAM, XLEN, XDEF, XLNB, IERR)
C                                       Trouble translating logical
      IF (IERR.NE.0) THEN
         WRITE (6,1000)
         VERNAM = HNEW
C                                       Translate 'OLD', 'NEW' and 'TST'
C                                       and look for a match.
      ELSE
         DLEN = XLNB
C                                       Translate 'TST'.
         LOGNAM = 'TST'
         CALL ZTRLOG (LLEN, LOGNAM, XLEN, XLATED, XLNB, IERR)
         IF ((IERR.EQ.0) .AND. (XLATED(1:XLNB).EQ.XDEF(1:DLEN))) THEN
            VERNAM = HTST
            GO TO 999
            END IF
C                                       Translate 'NEW'.
         LOGNAM = 'NEW'
         CALL ZTRLOG (LLEN, LOGNAM, XLEN, XLATED, XLNB, IERR)
         IF ((IERR.EQ.0) .AND. (XLATED(1:XLNB).EQ.XDEF(1:DLEN))) THEN
            VERNAM = HNEW
            GO TO 999
            END IF
C                                       Translate 'OLD'.
         LOGNAM = 'OLD'
         CALL ZTRLOG (LLEN, LOGNAM, XLEN, XLATED, XLNB, IERR)
         IF ((IERR.EQ.0) .AND. (XLATED(1:XLNB).EQ.XDEF(1:DLEN))) THEN
            VERNAM = HOLD
            GO TO 999
            END IF
C                                       Translate 'CVX'.
         LOGNAM = 'CVX'
         CALL ZTRLOG (LLEN, LOGNAM, XLEN, XLATED, XLNB, IERR)
         IF ((IERR.EQ.0) .AND. (XLATED(1:XLNB).EQ.XDEF(1:DLEN))) THEN
            VERNAM = HCVX
            GO TO 999
            END IF
C                                       No match (assume NEW).
         WRITE (6,1010) XDEF(1:DLEN)
         VERNAM = HNEW
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (' ZMYVER: INVALID AIPS_VERSION = ',A,' (USING NEW)')
 1000 FORMAT (' ZMYVER: TROUBLE TRANSLATING LOGICAL = AIPS_VERSION',
     *   ' (USING NEW)')
      END

      SUBROUTINE DRBOXS (ICH, TVAREA, CIRCLE, IL, IB, IT, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! draws boxes, circles, diagonal lines for GRBOXS
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2009, 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DRBOXS uses a graphics plane to show the user rectangular or
C   circular boxes as they are input or set with the cursor.
C   Inputs:
C      ICH      I      graphics plane to use + NGRAY
C      TVAREA   I(4)   Box must fit in this TV pixel area
C      CIRCLE   I      > 0 -> this is a circle
C      IL       I      Progress in setting: 1 first blc, 2, trc, 3 2nd
C                      blc, 0 => okay box
C                      < 0 => turn off, else turn on
C   In/Out - get fixed (IL > 0) to fit in TVAREA in TV pixels
C      IB       I(2)   Bottom left corner or (1,2) = X,Y radius
C      IT       I(2)   Top right corner or center
C   Output:
C      SCRTCH   I(*)   Scratch buffer: > X dimension (>1280)
C      IERR     I      Error code: > 0 real error
C                         -1 -> box fit partially into display
C                         -2 -> box not visible in this display
C-----------------------------------------------------------------------
      INTEGER   ICH, TVAREA(4), CIRCLE, IL, IB(2), IT(2), SCRTCH(*),
     *   IERR
C
      CHARACTER OPCODE*4
      INTEGER   IX(33), IY(33), JL, NP, I, IXX, IXN, IYX, IYN, NO, NPO,
     *   LX(2), LY(2), IROUND
      REAL      ANG, BLC(2), TRC(2), XL, YL, XU, YU, XO(2), YO(2)
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      JL = ABS (IL)
      OPCODE = 'ONNN'
      IF (IL.LT.0) OPCODE = 'OFFF'
      BLC(1) = TVAREA(1)
      BLC(2) = TVAREA(2)
      TRC(1) = TVAREA(3)
      TRC(2) = TVAREA(4)
C                                       Fix ups for partial setting
      IF (CIRCLE.GT.0) THEN
         IF (IL.EQ.1) THEN
            IT(1) = MAX (TVAREA(1)+1, MIN (TVAREA(3)-1, IT(1)))
            IT(2) = MAX (TVAREA(2)+1, MIN (TVAREA(4)-1, IT(2)))
         ELSE IF (IL.EQ.2) THEN
            I = IT(1) - IB(1) - TVAREA(1)
            IF (I.LT.0) IB(1) = IB(1) + I
            I = IT(1) + IB(1) - TVAREA(3)
            IF (I.GT.0) IB(1) = IB(1) - I
            I = IT(2) - IB(2) - TVAREA(2)
            IF (I.LT.0) IB(2) = IB(2) + I
            I = IT(2) + IB(2) - TVAREA(4)
            IF (I.GT.0) IB(2) = IB(2) - I
            IB(1) = MAX (1, IB(1))
            IB(2) = MAX (1, IB(2))
         ELSE IF (IL.EQ.3) THEN
            IT(1) = MAX (TVAREA(1)+1, MIN (TVAREA(3)-1, IT(1)))
            IT(2) = MAX (TVAREA(2)+1, MIN (TVAREA(4)-1, IT(2)))
            I = IT(1) - IB(1) - TVAREA(1)
            IF (I.LT.0) IT(1) = IT(1) + I
            I = IT(1) + IB(1) - TVAREA(3)
            IF (I.GT.0) IT(1) = IT(1) - I
            I = IT(2) - IB(2) - TVAREA(2)
            IF (I.LT.0) IT(2) = IT(2) + I
            I = IT(2) + IB(2) - TVAREA(4)
            IF (I.GT.0) IT(2) = IT(2) - I
            END IF
C                                       fix box
      ELSE IF (IL.GT.0) THEN
         IB(1) = MAX (TVAREA(1), MIN (TVAREA(3), IB(1)))
         IB(2) = MAX (TVAREA(2), MIN (TVAREA(4), IB(2)))
         IF (IL.EQ.1) THEN
            IT(1) = TVAREA(1)
            IT(2) = TVAREA(2)
         ELSE
            IT(1) = MAX (TVAREA(1), MIN (TVAREA(3), IT(1)))
            IT(2) = MAX (TVAREA(2), MIN (TVAREA(4), IT(2)))
            END IF
         END IF
C                                       Box
      IF (CIRCLE.LT.0) THEN
C                                       normal box
         IF (JL.NE.1) THEN
            IX(1) = IB(1)
            IX(2) = IT(1)
            IX(3) = IT(1)
            IX(4) = IB(1)
            IX(5) = IB(1)
            IY(1) = IB(2)
            IY(2) = IB(2)
            IY(3) = IT(2)
            IY(4) = IT(2)
            IY(5) = IB(2)
            NP = 5
C                                       initial BLC
         ELSE
            IX(1) = IB(1)
            IX(2) = IB(1)
            IX(3) = TVAREA(3)
            IY(1) = TVAREA(4)
            IY(2) = IB(2)
            IY(3) = IB(2)
            NP = 3
            END IF
C                                       circle
      ELSE
C                                       draw
         IF (JL.EQ.1) THEN
            IX(1) = IT(1)
            IX(2) = IT(1)
            IX(3) = TVAREA(1)
            IX(4) = TVAREA(3)
            IY(1) = TVAREA(4)
            IY(2) = TVAREA(2)
            IY(3) = IT(2)
            IY(4) = IT(2)
            NP = 2
            CALL IMVECT (OPCODE, ICH, NP, IX(3), IY(3), SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 999
         ELSE
            NP = 32
            DO 20 I = 1,NP
               ANG = (I-1) * DG2RAD * 360.0 / NP
               IX(I) = IT(1) + IB(1) * SIN(ANG) + 0.5
               IY(I) = IT(2) + IB(2) * COS(ANG) + 0.5
 20            CONTINUE
            NP = NP + 1
            IX(NP) = IX(1)
            IY(NP) = IY(1)
            END IF
         END IF
C                                       All on, all off, or partial
      IF (CIRCLE.GT.0) THEN
         XL = IT(1) - IB(1)
         YL = IT(2) - IB(2)
         XU = IT(1) + IB(1)
         YU = IT(2) + IB(2)
      ELSE
         XL = IB(1)
         YL = IB(2)
         XU = IT(1)
         YU = IT(2)
         END IF
      CALL INTEDG (BLC, TRC, XL, YL, XU, YU, NO, XO, YO)
C                                       so draw all inside
      IF (NO.EQ.-1) THEN
         CALL IMVECT (OPCODE, ICH, NP, IX, IY, SCRTCH, IERR)
         IF (IERR.NE.0) THEN
            IXX = IX(1)
            IXN = IX(1)
            IYN = IY(1)
            IYX = IY(1)
            DO 30 I = 2,NP
               IXX = MAX (IXX, IX(I))
               IYX = MAX (IYX, IY(I))
               IXN = MIN (IXN, IX(I))
               IYN = MIN (IYN, IY(I))
 30            CONTINUE
            WRITE (MSGTXT,1030) IERR, IXN, IYN, IXX, IYX
            CALL MSGWRT (6)
            END IF
C                                       none inside
      ELSE IF (NO.EQ.0) THEN
         IERR = -2
C                                       some inside
      ELSE
         NPO = NP
         NP = 2
         DO 50 I = 2,NPO
            XL = IX(I-1)
            YL = IY(I-1)
            XU = IX(I)
            YU = IY(I)
            CALL INTEDG (BLC, TRC, XL, YL, XU, YU, NO, XO, YO)
            IF (NO.EQ.-1) THEN
               LX(1) = IX(I-1)
               LX(2) = IX(I)
               LY(1) = IY(I-1)
               LY(2) = IY(I)
            ELSE IF (NO.EQ.2) THEN
               LX(1) = MAX (TVAREA(1), MIN (TVAREA(3), IROUND(XO(1))))
               LX(2) = MAX (TVAREA(1), MIN (TVAREA(3), IROUND(XO(2))))
               LY(1) = MAX (TVAREA(2), MIN (TVAREA(4), IROUND(YO(1))))
               LY(2) = MAX (TVAREA(2), MIN (TVAREA(4), IROUND(YO(2))))
            ELSE IF (NO.EQ.1) THEN
               IF ((XL.GE.BLC(1)) .AND. (XL.LE.TRC(1)) .AND.
     *            (YL.GE.BLC(2)) .AND. (YL.LE.TRC(2))) THEN
                  LX(1) = IX(I-1)
                  LY(1) = IY(I-1)
                  LX(2) = MAX (TVAREA(1), MIN (TVAREA(3),
     *               IROUND(XO(1))))
                  LY(2) = MAX (TVAREA(2), MIN (TVAREA(4),
     *               IROUND(YO(1))))
               ELSE
                  LX(1) = MAX (TVAREA(1), MIN (TVAREA(3),
     *               IROUND(XO(1))))
                  LY(1) = MAX (TVAREA(2), MIN (TVAREA(4),
     *               IROUND(YO(1))))
                  LX(2) = IX(I)
                  LY(2) = IY(I)
                  END IF
               END IF
            IF (NO.NE.0) THEN
               CALL IMVECT (OPCODE, ICH, NP, LX, LY, SCRTCH, IERR)
               IF (IERR.NE.0) THEN
                  IXN = MIN (LX(1), LX(2))
                  IYN = MIN (LY(1), LY(2))
                  IXX = MAX (LX(1), LX(2))
                  IYX = MAX (LY(1), LY(2))
                  WRITE (MSGTXT,1030) IERR, IXN, IYN, IXX, IYX
                  CALL MSGWRT (6)
                  GO TO 999
                  END IF
               END IF
 50         CONTINUE
         IERR = -1
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('DRBOXS IMVECT ERROR:',I4,' ON WINDOW',4I5)
      END

      SUBROUTINE TKSLAC (IBLK, YVAL, XVAL, IERR)
C-----------------------------------------------------------------------
C! activates and reads TEK cursor, converts result to image coordinates
C# Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TKSLAC will read the Tektronix cursor and convert the position to
C   units displayed on TEK 4012 plot.  Requires the image cat block in
C   common and the location common to be set up for the image and
C   requires the TK to be open.
C   Outputs:
C      IBLK    I(256)  work I/O buffer.
C      YVAL    R       y position in janskys or whatever.
C      XVAL    R       x position in arc sec or whatever..
C      IERR    I       error code:  0=ok,  1=cursor not on plot,
C                         2 = Tektronix I/O error,  3=bad position
C   Common input:
C      /MAPHDR/ CATBLK image catalog header (from IC not CB file)
C-----------------------------------------------------------------------
      INTEGER   IBLK(256), IERR
      REAL      YVAL, XVAL
C
      DOUBLE PRECISION DX, DY, DZ
      REAL      PX0, PX1, PY0, PY1, XPIX, YPIX
      INTEGER   ITX0, ITX1, ITY0, ITY1, IX, IY
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTKS.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Open, read, close Tektronix.
      CALL TKCURS (IBLK, IX, IY, IERR)
C                                       Plot corners in Tek units.
      ITX0 = CATBLK(IICOR)
      ITY0 = CATBLK(IICOR+1)
      ITX1 = CATBLK(IICOR+2)
      ITY1 = CATBLK(IICOR+3)
C                                       Corners in funny scale units.
      PX0 = CATBLK(IIWIN)
      PY0 = CATBLK(IIWIN+1)
      PX1 = CATBLK(IIWIN+2)
      PY1 = CATBLK(IIWIN+3)
C                                       Cursor position not on plot.
      IF ((IX.LT.ITX0) .OR. (IX.GT.ITX1) .OR. (IY.LT.ITY0) .OR.
     *   (IY.GT.ITY1)) THEN
         WRITE (MSGTXT,1000) IX, IY
         CALL MSGWRT (6)
         IERR = 1
C                                       Calc XVAL sec from center.
      ELSE
         XPIX = (PX1 - PX0) * REAL (IX-ITX0) / REAL (ITX1-ITX0) + PX0
         YPIX = (PY1 - PY0) * REAL (IY-ITY0) / REAL (ITY1-ITY0) + PY0
         CALL XYVAL (XPIX, YPIX, DX, DY, DZ, IERR)
         XVAL = DX
         YVAL = DY
         IF (IERR.NE.0) IERR = 3
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CURSOR POSITION (X,Y) =',2I4,' NOT ON PLOT')
      END

      SUBROUTINE ALSDEL (ALIST, KEYWRD, IERR)
C-----------------------------------------------------------------------
C! Delete Associative list (ALIST) entry
C# Utility 
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Public function.
C   Delete Keyword entry from an ALIST and recover the freed space.
C   See ALSINI for details of the package.
C   Inputs:
C      ALIST  I(*)  ALIST array
C      KEYWRD C*16  Keyword
C   Outputs:
C      IERR    I     Error code, 0=OK, 1=couldn't find
C-----------------------------------------------------------------------
      INTEGER   ALIST(*), IERR
      CHARACTER KEYWRD*(*)
C
      CHARACTER ALNAME*32
      HOLLERITH TEST(4)
      INTEGER   ADDR, NDEL, LOOP, INDEX, NEXT, LAST, ITEST(4)
      EQUIVALENCE (TEST, ITEST)
      INCLUDE 'INCS:PALIST.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Validity test
      IF (ALIST(ALSCHK).NE.ALSCVL) THEN
         MSGTXT = 'ALSDEL: DAMAGED OR UNINITIALIZED ALIST'
         IERR = 2
         GO TO 990
         END IF
C                                       Don't look if none exist.
      IF (ALIST(ALSEND).GT.1) THEN
C                                       Convert KEYWRD to HOLLERITH
         CALL CHR2H (16, KEYWRD, 1, TEST)
C                                       Find KEYWORD in ALIST, loop
C                                       until end of list.
         ADDR = ALIST(ALSBEG)
         LAST = ADDR
 50         IF ((ITEST(1).EQ.ALIST(ADDR+ALSKWD))
     *         .AND. (ITEST(2).EQ.ALIST(ADDR+ALSKWD+1)).AND.
     *         (ITEST(3).EQ.ALIST(ADDR+ALSKWD+2)).AND.
     *         (ITEST(4).EQ.ALIST(ADDR+ALSKWD+3)))  GO TO 100
C                                       Update index
            LAST = ADDR
            ADDR = ALIST(ADDR)
C                                       End of list?
            IF ((ADDR.GT.0) .AND. (ADDR.LT.ALIST(ALSIZE)) .AND.
     *         (ALIST(ADDR).GT.ADDR)) GO TO 50
C                                       If it get here then it was not
C                                       found
            IERR = 1
            GO TO 999
C                                       Found entry - compress list
C                                       Does anything follow? 
 100        IF (ALIST(ADDR).GT.0) THEN
C                                       Following links updated
               NDEL = ALIST(ADDR) - ADDR
               INDEX = ADDR
C                                       Loop over list updating links. 
 150           IF (ALIST(INDEX).GT.0) THEN
                  NEXT = ALIST(INDEX)
                  ALIST(INDEX) = ALIST(INDEX) - NDEL
                  INDEX = NEXT
                  GO TO 150
                  END IF
C                                       Shift ALIST
               INDEX = ADDR
               DO 200 LOOP = ADDR+NDEL, ALIST(ALSEND)
                  ALIST(INDEX) = ALIST(LOOP)
                  INDEX = INDEX + 1
 200              CONTINUE
C                                       Reset last word pointer
               ALIST(ALSEND) = INDEX - 1
               GO TO 999
            ELSE
C                                       No following entries, reset end
C                                       of list pointer.
               IF (LAST.GT.0) ALIST(LAST) = -1
               GO TO 999
C                                       End of ALIST compression
            END IF
C                                       End of valid entries
         END IF
C                                       Not found
      IERR = 1
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
      CALL H2CHR (32, 1, ALIST(ALSNAM), ALNAME)
      MSGTXT = 'PROBLEM DUMPING ALIST: ' // ALNAME
      CALL MSGWRT (6)
C
 999  RETURN
      END

C    EDIT uv data Class Module
C-----------------------------------------------------------------------
C! Object Oriented AIPS Fortran "EDIT" class library
C# Object-Oriented UV EDITING
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   An EDIT object is an interface to the interactive UV data editing
C   software.  It does require an open TV object to function.
C   Class public members:
C      UVMASTER  C*32  Name of parent UV object
C      UVDATA    C*32  Name of displayed uvdata
C      UVRESID   C*32  Name of displayed uvdata 2nd file matches 1st
C      FGWORK    C*32  Name of output uvdata (gets FG table..)
C      TBEDIT    C*32  Name of table object to edit
C      TVDEVICE  C*32  Name of opened TV-device object
C   Class  private data:
C      MYNAME    C*32  Name of open EDIT
C
C   Public functions:  Object management
C     EDICRE (name, ierr)
C        Creates a Edit object with name "name".
C     EDIDES (name, ierr)
C        Destroys the Edit object with name "name";
C     EDIZAP (name, ierr)
C        Destroys the Edit object with name "name";
C        (Same as EDIDES)
C     EDIOPN (name, status, ierr)
C        Opens a Edit object
C     EDICLO (name, ierr)
C        Closes a Edit object
C     EDIGET (name, keywrd, type, dim, value, valuec, ierr)
C        Return keyword value.
C     EDIPUT (name, keywrd, type, dim, value, valuec, ierr)
C        Store keyword value.
C
C
C   Private functions:
C      EDBGET (name, keywrd, type, dim, value, valuec, ierr)
C         Fetches private member.
C      EDBPUT (name, keywrd, type, dim, value, valuec, ierr)
C         Stores private member.
C-----------------------------------------------------------------------
LOCAL INCLUDE 'EDIT.INC'
C                                       Include for EDIT class.
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
      LOGICAL   ACTIVE
      COMMON /EDICCM/ ACTIVE
      CHARACTER MYNAME*32
      COMMON /EDIMCC/ MYNAME
C                                                          End EDIT.INC
LOCAL END
      SUBROUTINE EDICRE (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Creates a EDIT object with name "name"
C   Inputs:
C      NAME  C*?   The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'EDIT.INC'
      INTEGER  IDIM(7), DUMMY(1)
      CHARACTER BNAME*32
      DATA BNAME /'    '/
C-----------------------------------------------------------------------
      IERR = 0
C                                       Create AIPS object
      CALL OBCREA (NAME, 'EDIT', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Initialize - ass. obj.
      IDIM(1) = LEN (BNAME)
      IDIM(2) = 1
      IDIM(3) = 0
      CALL EDIPUT (NAME, 'UVMASTER', OOACAR, IDIM, DUMMY, BNAME, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL EDIPUT (NAME, 'UVDATA', OOACAR, IDIM, DUMMY, BNAME, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL EDIPUT (NAME, 'TBEDIT', OOACAR, IDIM, DUMMY, BNAME, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL EDIPUT (NAME, 'UVRESID', OOACAR, IDIM, DUMMY, BNAME, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL EDIPUT (NAME, 'FGWORK', OOACAR, IDIM, DUMMY, BNAME, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL EDIPUT (NAME, 'TVDEVICE', OOACAR, IDIM, DUMMY, BNAME, IERR)
C                                       Error
 990  IF (IERR.NE.0) THEN
         MSGTXT = 'EDICRE: ERROR CREATING ' // NAME
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
      END
      SUBROUTINE EDIDES (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Destroys the EDIT object with name "name";
C   Inputs:
C      NAME  C*?   The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C-----------------------------------------------------------------------
      IERR = 0
C                                       Close
      CALL EDICLO (NAME, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Delete object
      CALL OBFREE (NAME, IERR)
C
 999  RETURN
      END
      SUBROUTINE EDIZAP (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Destroys the EDIT object with name "name"; same as EDIDES.
C   Inputs:
C      NAME  C*?   The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INCLUDE 'EDIT.INC'
C-----------------------------------------------------------------------
      CALL EDIDES (NAME,IERR)
C
 999  RETURN
      END
      SUBROUTINE EDIOPN (NAME, STATUS, IERR)
C-----------------------------------------------------------------------
C   Public
C   Opens a EDIT file.  Marks EDIT common as active.
C   Inputs:
C      NAME   C*?   The name of the object.
C      STATUS C*4   Not used.
C   Output:
C      IERR  I     Error return code, 0=OK, 5=data invalid
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), STATUS*4
      INTEGER   IERR
C
      INCLUDE 'EDIT.INC'
      INCLUDE 'INCS:CLASSIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       EDIT common must be inactive
      IF (ACTIVE) THEN
         IERR = 1
         MSGTXT = 'EDIOPN: ATTEMPT TO ACTIVATE SECOND EDIT OBJECT'
         GO TO 990
         END IF
      ACTIVE = .TRUE.
C                                       Save name
      MYNAME = NAME
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
      MSGTXT = 'EDIOPN: ERROR OPENING ' // NAME
      CALL MSGWRT (8)
      ACTIVE = .FALSE.
      MYNAME = ' '
C
 999  RETURN
      END
      SUBROUTINE EDICLO (NAME, IERR)
C-----------------------------------------------------------------------
C   Public
C   Closes EDIT completing output to Edit if necessary.
C   Inputs:
C      NAME  C*?   The name of the object.
C   Output:
C      IERR  I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INCLUDE 'EDIT.INC'
      INCLUDE 'INCS:CLASSIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       No action if inactive
      IF (.NOT.ACTIVE) GO TO 999
C                                       Make sure right one
      IF (NAME.NE.MYNAME) THEN
         IERR = 2
         MSGTXT = 'ATTEMPT TO ACCESS CLOSED EDIT OBJECT'
         GO TO 990
         END IF
C                                       Mark as inactive
      MYNAME = ' '
      ACTIVE = .FALSE.
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
      MSGTXT = 'EDICLO: ERROR CLOSING ' // NAME
      CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE EDIGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Returns the dimensionality and value(s) associated with a given
C   keyword.
C   Inputs:
C      NAME     C*?   The name of the object.
C      KEYWRD   C*?   The name of the keyword in form 'MEM1.MEM2...'
C   Outputs:
C      TYPE     I     Data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM      I(*)  Dimensionality of value, an axis dimension of zero
C                     means that that dimension and higher are
C                     undefined.
C      VALUE    ?(*)  The value associated with keyword.
C      VALUEC   C*?   Associated value (character)
C      IERR     I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC(*)*(*)
      INTEGER   TYPE, DIM(*), VALUE(*), IERR
C
      INTEGER   OBJNUM
C-----------------------------------------------------------------------
C     IERR = 0
C                                       Is this a base class?
C     CALL EDBGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       IERR = 1 means not recognized.
C                                       Lookup NAME
C     IF (IERR.EQ.1) THEN
         CALL OBNAME (NAME, OBJNUM, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OBGET (OBJNUM, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
         IF (IERR.NE.0) GO TO 999
C        END IF
C
 999  RETURN
      END
      SUBROUTINE EDIPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public function
C   Stores the value (array) associated with a given keyword.
C   Inputs:
C      NAME     C*?   The name of the object.
C      KEYWRD   C*?   The name of the keyword in form 'MEM1.MEM2...'
C      TYPE     I     Data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM      I(*)  Dimensionality of value, an axis dimension of zero
C                     means that that dimension and higher are
C                     undefined.
C      VALUE    ?(*)  The value associated with keyword.
C      VALUEC   C*?   Associated value (character)
C   Outputs:
C      IERR     I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC(*)*(*)
      INTEGER   TYPE, DIM(*), VALUE(*), IERR
C
      INTEGER   OBJNUM
C-----------------------------------------------------------------------
C     IERR = 0
C                                       Is this a base class?
C     CALL EDBPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C                                       IERR = 1 means not recognized.
C                                       Lookup NAME
C     IF (IERR.EQ.1) THEN
         CALL OBNAME (NAME, OBJNUM, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OBPUT (OBJNUM, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
         IF (IERR.NE.0) GO TO 999
C        END IF
C
 999  RETURN
      END

      SUBROUTINE GLTYPE (LTYPE, BUFF, IERR)
C-----------------------------------------------------------------------
C! writes a line type command to the plot file
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GLTYPE will write a 'line type' command record to a graph file or
C   the TV (in immediate TV mode).
C   The output record description is:
C            I     opcode, 9 in this program.
C            I     line type: 1 exterior labeling, 2 contours, 3
C                     polarization vectors, 4 stars, ?
C   Inputs:
C      LTYPE   I       line type
C      BUFF    I(256)  buffer to use for I/O.
C   Output:
C      IERR   I       error code. 0 = ok.
C                        1 = disk problems.
C                        2 = TV problems
C   Common:
C      GPHPOS  incremented by 2
C      GPHRRN  incremented by 1 if a write to disk is needed.
C-----------------------------------------------------------------------
      INTEGER   LTYPE, BUFF(256), IERR
C
      INTEGER   NEED, OPCODE
      INCLUDE 'INCS:DGPH.INC'
      DATA NEED, OPCODE /255, 9/
C-----------------------------------------------------------------------
      IERR = 0
      IF (LTYPE.NE.GPHLTY) THEN
         GPHLTY = LTYPE
C                                       Plot files
         IF (.NOT.GPHDOT) THEN
C                                       See if enough room in buffer.
            IF (GPHPOS.GE.NEED) THEN
               CALL GPHWRT (BUFF, IERR)
               IF (IERR.NE.0) THEN
                  IERR = 1
                  GO TO 999
                  END IF
               END IF
C                                       Put data in buffer.
            BUFF(GPHPOS+1) = OPCODE
            BUFF(GPHPOS+2) = LTYPE
            GPHPOS = GPHPOS + 2
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE SETUP (PRGNAM, NPARMS, FIRST, IWBLK, IERR)
C-----------------------------------------------------------------------
C! does several task start up chores for non-interactive tasks
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   This routine does the initial things usually needed for an AIPS
C   task.  It initializes the device characteristics, header pointer,
C   and file commons, obtains the identification and user parameters
C   from the starting program (AIPS, AIPSB), and resumes the calling
C   program if requested.
C   NOTE: interactive tasks must not use this routine due to that
C   automatic resumption.
C   Use of this subroutine requires that (at least) the includes DDCH,
C   DMSG, DFIL, and DHDR appear also in the MAIN portion of the program.
C   Inputs:
C      PRGNAM   C*6      Name for this task.
C      NPARMS   I        Number of REAL*4 parameters comming from AIPS.
C      FIRST    R        First variable in inputs common block.
C      IWBLK    I(256)   Work buffer.
C   Output:
C      IERR     I        Error code. 0=ok
C                           1=couldn't get parms from AIPS.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      REAL      FIRST(*)
      INTEGER   NPARMS, IWBLK(256), IERR
C
      INTEGER   IERR2
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
      TSKNAM = PRGNAM
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE.)
C                                       Initialize header index values.
      CALL VHDRIN
C                                       Zero counters for DIE.
      NCFILE = 0
      NSCR = 0
      CALL FILL (10, 0, IBAD)
C                                       Get input values from AIPS.
      IERR = 0
      CALL GTPARM (PRGNAM, NPARMS, RQUICK, FIRST, IWBLK, IERR)
      IF (IERR.EQ.0) GO TO 20
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IERR = 1
 20   IF (RQUICK) CALL RELPOP (IERR, IWBLK, IERR2)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR GETTING PARAMETERS FROM AIPS. GTPARM ERR =',I5)
      END

LOCAL INCLUDE 'CCFND.INC'
      REAL      XSEQ, XDISK, XVER, XECNT, XFLUX, XFACT
      HOLLERITH XINNAM(3), XINCLS(2)
      CHARACTER INNAM*12, INCLS*6
      INTEGER   ECOUNT, DATP(128,2), BUFFER(512), INSEQ, INDISK, INVERS,
     *   CNO, IUSER, NKEY, NCOL, OUTLUN, OUTIND
C
      COMMON /INPARM/ XINNAM, XINCLS, XSEQ, XDISK, XVER, XECNT, XFLUX,
     *   XFACT
      COMMON /CHPARM / INNAM, INCLS
      COMMON /CCFNDC/ DATP, BUFFER, INSEQ, ECOUNT, INDISK, INVERS, CNO,
     *   IUSER, NKEY, NCOL, OUTLUN, OUTIND
LOCAL END
      PROGRAM CCFND
C-----------------------------------------------------------------------
C! Finds clean components satifying user request
C# EXT-util Map-util Printer
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CCFND is an AIPS task which makes two passes searching for
C   Clean Components (CC) meeting FLUX density criteria.
C   The first pass finds the CC which is just brighter than the user
C   input FLUX.  The second pass finds the CC which is FACTOR times
C   the flux of the first CC.
C   AIPS adverbs:                     Use:
C     INNAME     INNAM(3)     Image name: standard defaults, wildcards
C     INCLASS    INCLS(2)     Image class: ditto
C     INSEQ      XSEQ (INSEQ) Image sequence number: ditto
C     INDISK     XDISK (INDISK)  Image disk number: 0 -> any
C     INVERS     XVER (INVERS)   Extension version number
C     ECOUNT     XECNT (ECOUNT)  Last row number
C     FLUX       XFLUX           Flux density limit to search
C     FACTOR     XFACT (FACTOR)  Fraction of FIRST NEGATIVE
C-----------------------------------------------------------------------
      INTEGER   IRET, IERR, NTHCC1, NTHCC2, RESULT(66)
      REAL      FLUX1, FLUX2, TOTAL1, TOTAL2
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'CCFND.INC'
C-----------------------------------------------------------------------
C                                       Get parms, open things
      CALL CCFNIN (IRET)
C                                       if init was ok
      IF (IRET.EQ.0) THEN
         FLUX1 = XFLUX
C                                       Find CC just brighter than FLUX
         CALL CCFNDO (FLUX1, NTHCC1, TOTAL1, IRET)
         END IF
C                                       if not finding same CC
      IF (IRET.EQ.0 .AND. XFACT .NE. 1.0) THEN
C                                       find 2nd CC with fraction of 1st
         FLUX2 = ABS(FLUX1) * XFACT
C                                       Find CC brighter than FLUX2
         CALL CCFNDO (FLUX2, NTHCC2, TOTAL2, IRET)
         END IF
C                                       Close file opened in CCFNIN
      CALL TABIO ('CLOS', 3, 1, RESULT, BUFFER, IERR)
C                                       close down
      CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE CCFNIN (IRET)
C-----------------------------------------------------------------------
C   CCFNIN performs initialization for AIPS task CCFND.  It gets the
C   adverbs, opens the catalog file for 'READ', opens the table
C   extension
C   file, and opens the output device.
C   Output:
C      IRET    I      Error code: 0 => keep going, else quit.
C-----------------------------------------------------------------------
      CHARACTER INTYP*2, STAT*4, PRGN*6
      INTEGER   IRET, I4T, NPARM, IROUND, NREC, TABLUN, IERR,
     *   SCRBUF(256)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'CCFND.INC'
      DATA TABLUN /27/
      DATA PRGN /'CCFND '/
C-----------------------------------------------------------------------
C                                       AIPS init
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NCFILE = 0
      NSCR = 0
C                                       get adverbs
      NPARM = 3 + 2 + 1 + 1 + 1 + 1 + 1 + 1
      IRET = 0
      CALL GTPARM (PRGN, NPARM, RQUICK, XINNAM, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRBUF, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       find image file
      CALL H2CHR (12, 1, XINNAM, INNAM)
      CALL H2CHR (6, 1, XINCLS, INCLS)
      INSEQ = IROUND (XSEQ)
      INDISK = IROUND (XDISK)
      INVERS = IROUND (XVER)
      ECOUNT = IROUND (XECNT)
      IUSER = NLUSER
      IF (XFACT.EQ.0.0) XFACT = 1
      CNO = 1
      INTYP = ' '
      CALL CATDIR ('SRCH', INDISK, CNO, INNAM, INCLS, INSEQ, INTYP,
     *   IUSER, STAT, SCRBUF, IERR)
      IF (IERR.EQ.0) GO TO 20
         WRITE (MSGTXT,1010) IERR, INNAM, INCLS, INSEQ, INTYP,
     *      INDISK, IUSER
         GO TO 990
C                                       Get catblk, mark file read
 20   CALL CATIO ('READ', INDISK, CNO, CATBLK, 'READ', SCRBUF, IERR)
      IF (IERR.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) IERR
         GO TO 990
 30   NCFILE = 1
      FVOL(1) = INDISK
      FCNO(1) = CNO
      FRW(1) = 0
C                                       Open table file
      NKEY = 0
      NCOL = 0
      NREC = 0
      CALL TABINI ('READ', 'CC', INDISK, CNO, INVERS, CATBLK, TABLUN,
     *   NKEY, NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, 'CC', INVERS
         GO TO 990
         END IF
C                                       Get Max rows in table
      I4T = BUFFER(5)
C                                       Last is max, if out of limits
      IF ((ECOUNT.LE.0) .OR. (ECOUNT.GT.I4T)) ECOUNT = I4T
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' FINDING INPUT ADVERBS')
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,1X,A2,
     *   ' DISK=',I2,' USER=',I5)
 1020 FORMAT ('ERROR',I5,' READING CATBLK FROM CATALOG FILE')
 1030 FORMAT ('ERROR',I5,' OPENING ',A2,' TABLE VERS=',I6)
 1040 FORMAT ('ERROR',I5,' OPENING OUTPUT DEVICE')
      END
      SUBROUTINE CCFNDO (FLUX, FIRSTC, SUMDEL, IRET)
C-----------------------------------------------------------------------
C   CCFNDO reads a cc table and finds the Nth CC brighter than FLUX
C   In/Output:
C      FLUX   R     Flux Limit for Clean Comp./Actual Flux above limit
C   Output:
C      FIRSTC I     Number of the CC which is just above Flux limit
C      SUMDEL R     Sum of Flux of components, up to Flux Limit
C      IRET   I     Error code: 0 => OK or user terminates,
C                      2 => error writing, 3 => error reading
C-----------------------------------------------------------------------
      INTEGER   FIRSTC, IRET
      REAL      FLUX, SUMDEL
C
      INTEGER   IRNO, RESULT(66),  RTYPE, IERR, KOLS(7), I, ISCR(256),
     *   LOCS(2), VALUES(2), LRNO
      REAL      RES4(66), LASTFL
      LOGICAL   T
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'CCFND.INC'
      EQUIVALENCE (RESULT, RES4)
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       init counters, line size
      IRET = 0
C                                       Find 'FLUX' column number
      CALL FNDCOL (1, 'FLUX    ', 8, T, BUFFER, KOLS(1), IERR)
C                                       Init CC number and Fluxs
      FIRSTC = 1
      LASTFL = 0.0
      SUMDEL = 0.0
C                                       Flux in the Ith col. of a row.
      I = KOLS(1)
C                                       Read LOOP
C                                       For All Clean component Rows
      LRNO = 0
      DO 140 IRNO = 1,ECOUNT
C                                       Get cc value from the row
         CALL GETCOL (IRNO, I, DATP, LRNO, BUFFER, RTYPE, RESULT, ISCR,
     *      IERR)
C                                       retry on a flagged row
         IF (IERR.LT.0) THEN
            GO TO 140
            END IF
C                                       Exit on Error
         IF (IERR.NE.0) GO TO 960
C                                       Store sum prior to limit
         IF (RES4(1).GT.FLUX) THEN
            FIRSTC = IRNO
C                                       Record next to last flux
            LASTFL = RES4(1)
C                                       Sum flux of components
            SUMDEL = SUMDEL + LASTFL
         ELSE
C                                       Jump out, if less than min
            GO TO 150
            END IF
C
 140     CONTINUE
C                                       Jump here on cc found
 150  CONTINUE
C                                       Tell user
      WRITE (MSGTXT,1150,ERR=999) FIRSTC, LASTFL, FLUX
      CALL MSGWRT(3)
      WRITE (MSGTXT,1160,ERR=999) FIRSTC, SUMDEL
      CALL MSGWRT(3)
C                                       reset input limit to actual
      FLUX = LASTFL
C                                       Add to Map Header
C                                       set Location to first in array
      LOCS(1) = 1
C                                       copy value to buffer
      VALUES(1) = FIRSTC
C                                       Record CC Number in header
      CALL CATKEY ('WRIT', INDISK, CNO, 'NTHCC   ', 1, LOCS,
     *         VALUES, 4, CATBLK, IERR)
C                                       Record CC Flux at Limit
      CALL RCOPY( 1, FLUX, VALUES(1))
C
      CALL CATKEY ('WRIT', INDISK, CNO, 'CCFLUX  ', 1, LOCS,
     *         VALUES, 2, CATBLK, IERR)
C                                       Record Total Flux at Limit
      CALL RCOPY( 1, SUMDEL, VALUES(1))
C
      CALL CATKEY ('WRIT', INDISK, CNO, 'SUMFLUX ', 1, LOCS,
     *         VALUES, 2, CATBLK, IERR)
      GO TO 999
C                                       errors
 960  IRET = 3
      WRITE (MSGTXT,1960) IERR
      GO TO 995
C
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1150 FORMAT ('Component ',I9,' has Flux',F13.6,' > ',F13.6,' Jy.')
 1160 FORMAT ('Sum up to ',I9,' is  Flux',F13.6,' Jy.')
 1960 FORMAT ('ERROR',I5,' READING TABLE DATA')
      END

      SUBROUTINE BASAVG (NUMVIS, NUMBAS, ANTLAB, AMPVEC, DTYPE, DT,
     *   CHNSEL, DOSPEC, SCANV, TIME, NUSCAN, SCANUM, RPARM, VIS, AVTIM,
     *   AVU, AVV, AVW, IERR)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000, 2009, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Reads a uv data base and returns averages of amp, phase or the RMS
C   scatter for selected baselines.
C   Needs to be initialized by a call to UVGET.
C   The  order of the baselines returned in SCANV is defined by
C   the order in the array NATLAB.  All data specified  (channels, IFs)
C   are averaged but only one polarization is allowed.
C   UVW are scaled by FREQ/UVFREQ to be at the first IF/FREQID of the
C   data.
C   Inputs:
C     NUMVIS       I    Current visibility number
C     NUMBAS       I    Number of baselines to average.
C     ANTLAB(MXBASE,2)  I    The First (*,1) and second (*,2) antenna
C                      numbers of each baseline selected.
C     AMPVEC       L    If true do ampscalar averaging else vector.
C     DTYPE        I    Output type, 0 => amplitude, 1=> phase,
C                       2 => amplitude RMS.
C     DT           R    Averaging time in days
C     CHNSEL(3,10) I    Channel selection
C     DOSPEC       L    TRUE if spectral averaging to be done
C   Input/Output:
C     RPARM(20)    R    Random parameter array, first record of call.
C                      (1) = 'INDE' => don't use.
C                      (2) if single baseline averaged then RPARM
C                          reflects the data output.
C     VIS(3,*)     R    Visibility array, first record of call.
C   Outputs:
C     SCANV(MXBASE)R   The result for baselines in ANTLAB
C     TIME(8)      I    Time range, start, stop; days, hours, min, sec.
C                       Unless NUSCAN only first 4 values are set.
C     NUSCAN       L    True IF the first record in a new scan.
C     AVTIM        R    Average time (days) of output record
C     AVU          R    Average u of output record
C     AVV          R    Average v of output record
C     AVW          R    Average w of output record
C     IERR         I    Return code, 0 => OK, -1 => out of data,
C                       > 0 => failed.
C   Output to common in D/CSOU.INC
C     SNAME(4)     R    Source name (16 char. 4 / word.)
C     QUAL         I    Source qualifier.
C     CALCOD       R    Calibrator code 4 char.
C     FLUX(4,IF)   R    Total flux density I, Q, U, V pol, (Jy) each IF
C     FREQO(IF)    D    Frequency offset (Hz)
C   Note:   If the end of data is encountered (IERR=-1) then UVGET is
C   called with OPCODE='CLOS'.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      LOGICAL   AMPVEC, NUSCAN, DONE1, GOTDAT, DOSPEC
      INTEGER   DTYPE, TIME(8), NUMBAS, IERR, I, JA1, JA2, SUNUM, JERR,
     *   ISLUN, IBASE, IVIS, COUNT(MXBASE), KVIS, SCANUM, CNTTIM,
     *   NUMFRQ, NUMPLZ, CHNSEL(3,10), ANTLAB(MXBASE,2), NUMVIS, IDAY,
     *   IVSCNT
      REAL      RPARM(20), VIS(3,*), DT, T1, AMP, SQRT, SUMTIM,
     *   WORK(MXBASE,4), TEMP, TEMP1, TEMP2, SCANV(MXBASE),
     *   SUMU, SUMV, SUMW, AVTIM, AVU, AVV, AVW, TLAST, CT, DTUTC
      DOUBLE PRECISION X8, UVSCAL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      SAVE TLAST, DTUTC, IVSCNT
      DATA ISLUN /26/
C-----------------------------------------------------------------------
      IF (NUMVIS.EQ.0) THEN
         TLAST = -1.0
         DTUTC = DATUTC / 86400.0
         IVSCNT = 0
         END IF
C                                       See if first record read
      DONE1 = RPARM(1).NE.FBLANK
      GOTDAT = .FALSE.
      IERR = 0
C                                       Clear arrays
 10   CONTINUE
      DO 50 I = 1,NUMBAS
         COUNT(I) = 0
         WORK(I,1) = 0.0
         WORK(I,2) = 0.0
         WORK(I,3) = 0.0
         WORK(I,4) = 0.0
         SCANV(I) = FBLANK
 50      CONTINUE
      CNTTIM = 0
      SUMTIM = 0.0
      SUMU = 0.0
      SUMV = 0.0
      SUMW = 0.0
      AVTIM  = 0.0
      AVU = 0.0
      AVV = 0.0
      AVW = 0.0
C                                       Initialize time
      T1 = 1.0E10
C                                       Save scan number (0= no index)
      NUSCAN = SCANUM.NE.INXRNO
      SCANUM = INXRNO
      KVIS = (LREC-NRPARM) / 3
      NUMFRQ = CATBLK(KINAX+JLOCF)
      NUMPLZ = CATBLK(KINAX+JLOCS)
      UVSCAL = 1.0D0
      IF (UVFREQ.GT.0.0D0) UVSCAL = FREQ / UVFREQ
C                                       Loop reading data
 100     IF (.NOT.DONE1) THEN
            CALL UVGET ('READ', RPARM, VIS, IERR)
            IVSCNT = IVSCNT + 1
            END IF
         IF (IERR.GT.0) GO TO 999
         IF (IERR.EQ.-1) GO TO 500
         DONE1 = .FALSE.
C
         CT = RPARM(ILOCT+1) - DTUTC
C                                       Set up first time boundary
         IF (IVSCNT.EQ.1) THEN
            IDAY = CT
            X8 = (CT - IDAY) / DT
            TLAST = IDAY + DINT (X8) * DT + DT
            END IF
C                                       Spectral averaging
         IF ((DOSPEC) .AND. (IVSCNT.GT.0)) THEN
            CALL AVGCIF (VIS, NUMPLZ, NUMFRQ, BCHAN, ECHAN, BIF,
     *         EIF, CHNSEL, KNCS, VIS)
            END IF
C                                       Antenna numbers
         IF (ILOCB.GE.0) THEN
            JA1 = RPARM(ILOCB+1) / 256. + 0.1
            JA2 = RPARM(ILOCB+1) - JA1 * 256 + 0.1
         ELSE
            JA1 = RPARM(1+ILOCA1) + 0.1
            JA2 = RPARM(1+ILOCA2) + 0.1
            END IF
C                                       Find baseline
         DO 110 I = 1,NUMBAS
            IBASE = I
            IF ((JA1.EQ.ANTLAB(I,1) .AND. (JA2.EQ.ANTLAB(I,2))))
     *         GO TO 120
 110        CONTINUE
C                                       Not wanted
         GO TO 100
C
 120     GOTDAT = .TRUE.
C                                       Check if avg. or scan done
         IF ((INXRNO.GT.SCANUM) .OR. (IERR.LT.0) .OR.
     *      (CT.GT.TLAST)) GO TO 500
C                                       Time
         SUMTIM = SUMTIM + RPARM(ILOCT+1)
         SUMU = SUMU + RPARM(ILOCU+1) * UVSCAL
         SUMV = SUMV + RPARM(ILOCV+1) * UVSCAL
         SUMW = SUMW + RPARM(ILOCW+1) * UVSCAL
         IF (T1.GT.1.0E9) T1 = RPARM(ILOCT+1)
         CNTTIM = CNTTIM + 1
C                                       Source no.
         SUNUM = CURSOU
         IF (AMPVEC) GO TO 200
C                                       Vector average:
      INCLUDE 'INCS:ZVD.INC'
            DO 150 IVIS = 1,KVIS
               IF (VIS(3,IVIS).LE.0.0) GO TO 150
               COUNT(IBASE) = COUNT(IBASE) + 1
               WORK(IBASE,1) = WORK(IBASE,1) + VIS(1,IVIS)
               WORK(IBASE,2) = WORK(IBASE,2) + VIS(2,IVIS)
               WORK(IBASE,3) = WORK(IBASE,3) + VIS(1,IVIS) ** 2
               WORK(IBASE,4) = WORK(IBASE,4) + VIS(2,IVIS) ** 2
 150           CONTINUE
         GO TO 100
C                                       Ampscalar averaging
      INCLUDE 'INCS:ZVD.INC'
 200     DO 250 IVIS = 1,KVIS
            IF (VIS(3,IVIS).LE.0.0) GO TO 250
            AMP = SQRT (VIS(1,IVIS) * VIS(1,IVIS) +
     *         VIS(2,IVIS) * VIS(2,IVIS))
            VIS(1,IVIS) = VIS(1,IVIS) + 1.0E-20
            COUNT(IBASE) = COUNT(IBASE) + 1
            WORK(IBASE,1) = WORK(IBASE,1) + AMP
            IF (DTYPE.EQ.1) WORK(IBASE,2) = WORK(IBASE,2) +
     *         ATAN2 (VIS(2,IVIS), VIS(1,IVIS))
            WORK(IBASE,3) = WORK(IBASE,3) + AMP*AMP
 250        CONTINUE
            GO TO 100
C                                       Scan done
C                                       See if have any data.
 500  IF ((.NOT.GOTDAT) .AND. (IERR.EQ.0)) GO TO 10
      IF (.NOT.GOTDAT) GO TO 800
      IF (.NOT.AMPVEC) THEN
C                                       Vector averaging
         DO 550 I = 1,NUMBAS
C                                       Amplitude
            IF ((DTYPE.EQ.0) .AND. (COUNT(I).GT.0))
     *         SCANV(I) = SQRT (WORK(I,1)*WORK(I,1) +
     *            WORK(I,2)*WORK(I,2)) / COUNT(I)
C                                       Phase
            IF ((DTYPE.EQ.1) .AND. (COUNT(I).GT.0))
     *         SCANV(I) = ATAN2 (WORK(I,2), WORK(I,1)+1.0E-20)
C                                       RMS
            IF ((DTYPE.EQ.2) .AND. (COUNT(I).GT.2)) THEN
               TEMP1 = (COUNT(I) * WORK(I,3) - (WORK(I,1)**2))
               TEMP2 = (COUNT(I) * WORK(I,4) - (WORK(I,2)**2))
               TEMP = TEMP1 + TEMP2
               IF (TEMP.LT.0.0) TEMP = 0.0
               SCANV(I) = SQRT (TEMP) / COUNT(I)
               END IF
 550           CONTINUE
      ELSE
C                                       Else Amp scalar ave
         DO 650 I = 1,NUMBAS
C                                       Amplitude
            IF ((DTYPE.EQ.0) .AND. (COUNT(I).GT.0))
     *         SCANV(I) = WORK(I,1) / COUNT(I)
C                                       Phase
            IF ((DTYPE.EQ.1) .AND. (COUNT(I).GT.0))
     *         SCANV(I) = WORK(I,2) / COUNT(I)
C                                       RMS
            IF ((DTYPE.EQ.2) .AND. (COUNT(I).GT.2)) THEN
               TEMP = (COUNT(I) * WORK(I,3) - (WORK(I,1)**2))
               IF (TEMP.LT.0.0) TEMP = 0.0
               SCANV(I) = SQRT (TEMP) / COUNT(I)
               END IF
 650        CONTINUE
C                                       end if vector averaging
         END IF
C                                       Get source info
      IF (.NOT.NUSCAN) GO TO 800
      CALL GETSOU (SUNUM, IUDISK, IUCNO, CATUV, ISLUN, JERR)
      IF (JERR.EQ.11) THEN
C                                       Didn't find source
         WRITE (MSGTXT,1750) SUNUM
         CALL MSGWRT (8)
         JERR = 0
         END IF
      IF (JERR.LE.0) GO TO 800
         IERR = JERR
         WRITE (MSGTXT,1700) JERR
         GO TO 990
C                                       Time
 800  T1 = 0
      IF (CNTTIM.GT.0) THEN
         T1 = SUMTIM / CNTTIM
         AVTIM = T1
         AVU = SUMU / CNTTIM
         AVV = SUMV / CNTTIM
         AVW = SUMW / CNTTIM
         END IF
      CALL TODHMS (T1, TIME)
C                                       Set up new time boundary
      IDAY = CT
      X8 = (CT - IDAY) / DT
      TLAST = IDAY + DINT (X8) * DT + DT
C                                       If end of data, close UVGET
CCC      IF (IERR.LT.0) CALL UVGET ('CLOS', RPARM, VIS, JERR)
CCC      IF (JERR.NE.0) IERR = JERR
CCC      IF ((IERR.LT.0) .AND. (.NOT.GOTDAT)) IERR = -2
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1700 FORMAT ('BASAVG: ERROR',I3,' READING SOURCE TABLE')
 1750 FORMAT ('BASAVG: SOURCE ',I3,' NOT IN SU TABLE')
      END

      SUBROUTINE QGRIDA (UV, VIS, WT, L, G, CX, CY, CONI, NO2, M, LROW,
     *   CNT, TY)
C-----------------------------------------------------------------------
C! FPS AP version: Grids UV data
C# AP-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FPS AP version
C   Grids visibility data that has been loaded into the AP
C   previously.  If requested, positions are shifted and then
C   a taper is applied to the weights if requested before gridding.
C   when taper is requested and TY=2 or 3 locations VIS-2 and
C   VIS-1 are used for work space. If TY=1 locations VIS+2 and
C   VIS+3 are used.
C    Inputs:
C     UV    I  Base address of U,V vector
C     VIS   I  Base address of visibility
C     WTP   I  Base address of weights
C     L     I  Length of visibility record
C     G     I  Base address of grid
C     CX    I  Base address of row convolving fn. (Y on sky)
C     CY    I  Base address of col. convolving fn. (X on sky)
C                Convolving fns. tabulated every 1/CONI cell
C     CONI  I  Increment of conv function tabulation (assumed 100 for
C               true visibility data)
C     NO2   I  INT ( (no. cells used on a row)/2 )
C     M     I  Number of rows kept in AP (must be odd)
C     LROW  I  Length of a row (V)
C     CNT   I  Number of visibility points.
C     TY    I  Type of visibility data.
C                       1 = I maps
C                       2 = Q,U maps, or two line maps
C                       3 = V maps
C                 If TY is negative then tapering is requested.
C                 If CNT is neg, do not shift data.
C     Also expects necessary constants in following AP locations:
C           8 = -SIG(U)**2 (CELLS**2) for taper
C           9 = -SIG(V)**2 (CELLS**2) for taper
C          10 = U scaling to cells
C          11 = V scaling to cells
C          12 = W scaling to cells
C          13 = DXC = -2 * Pi * delta RA (in 1/cells)
C          14 = DYC = -2 * Pi * delta DEC
C          15 = DZC = -2 * Pi * delta Z
C-----------------------------------------------------------------------
      INTEGER UV, VIS, WT, L, G, CX, CY, CONI, NO2, M, LROW, CNT, TY
      INTEGER*2 IUV, IVIS, IWT, IL, IG, ICX, ICY, INO2, IM, ILROW,
     *   ICNT, ITY
C-----------------------------------------------------------------------
C                                        Convert inputs to unsigned I*2
      IF (UV.LT.32768) IUV = UV
      IF (UV.GE.32768) IUV = UV - 65536
      IF (VIS.LT.32768) IVIS = VIS
      IF (VIS.GE.32768) IVIS = VIS - 65536
      IF (WT.LT.32768) IWT = WT
      IF (WT.GE.32768) IWT = WT - 65536
      IF (L.LT.32768) IL = L
      IF (L.GE.32768) IL = L - 65536
      IF (G.LT.32768) IG = G
      IF (G.GE.32768) IG = G - 65536
      IF (CX.LT.32768) ICX = CX
      IF (CX.GE.32768) ICX = CX - 65536
      IF (CY.LT.32768) ICY = CY
      IF (CY.GE.32768) ICY = CY - 65536
      IF (NO2.LT.32768) INO2 = NO2
      IF (NO2.GE.32768) INO2 = NO2 - 65536
      IF (M.LT.32768) IM = M
      IF (M.GE.32768) IM = M - 65536
      IF (LROW.LT.32768) ILROW = LROW
      IF (LROW.GE.32768) ILROW = LROW - 65536
      IF (CNT.LT.32768) ICNT = CNT
      IF (CNT.GE.32768) ICNT = CNT - 65536
      ITY = TY
C                                        Call FPS routine.
      CALL GRIDAP (IUV, IVIS, IWT, IL, IG, ICX, ICY, INO2, IM, ILROW,
     *   ICNT, ITY)
C
 999  RETURN
      END

      SUBROUTINE GRBOXD (IG, NBOX, BBLC, BTRC, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! takes list of boxes and does deletion
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2006, 2009, 2021, 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GRBOXS uses a graphics plane to show the user rectangular and
C   circular boxes as they are displayed, set, and/or reset with the
C   cursor.
C   Inputs:
C      IG      I(2)     graphics planes to use - 2nd background
C   In/Out:
C      NBOX    I        in/out: number set on input/output
C      BBLC    R(7,*)   Bottom left corners
C      BTRC    R(7,*)   Top right corners
C   Output:
C      SCRTCH  I(*)     Scratch buffer: > X dimension (>1280)
C      IERR    I        Error code > 0 => a problem
C   Input in common:
C      CATBLK  I(256)   Image catalog header for image being used
C   For circular: BBLC(1,i) = -1, BBLC(2,i) = radius, BTRC(,i) center
C-----------------------------------------------------------------------
      INTEGER   IG(2), NBOX, SCRTCH(*), IERR
      REAL      BBLC(7,*), BTRC(7,*)
C
      INCLUDE 'INCS:PCLN.INC'
      INTEGER   ICH1, ICH2, IL, QUAD, IBUT, J, I, JERR, IPOS, ITEMP,
     *   SCROLX, SCROLY, INBOX, IC(2,MXNBOX), IR(2,MXNBOX), NMISS,
     *   IB(2,MXNBOX), IT(2,MXNBOX), JL, IPASS, ISONTV(MXNBOX), NOFF,
     *   CIRCLE(MXNBOX)
      REAL      RPOS(2), DLIM, IMWIND(4), TVAREA(4), RDEP(5), RADIUS,
     *   SX, SY
      LOGICAL   T, F, RESET, NXTBOX, WARN
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (IT, IC), (IB, IR)
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IERR = 0
      WARN = T
      QUAD = 0
      ICH1 = NGRAY + IG(1)
      ICH2 = NGRAY + IG(2)
C                                       Check inputs
      IERR = 2
      IF ((IG(1).LT.1) .OR. (IG(1).GT.NGRAPH)) GO TO 999
      IF ((IG(2).LT.1) .OR. (IG(2).GT.NGRAPH)) GO TO 999
      IF (NBOX.LE.0) GO TO 999
      RESET = F
      INBOX = NBOX
      IF (NBOX.GT.MXNBOX) GO TO 999
      CALL FILL (NBOX, 0, ISONTV)
      CALL LFILL (NBOX, -1, CIRCLE)
C                                       windows
      IF ((CATBLK(IIWIN+2).LE.CATBLK(IIWIN)) .OR.
     *   (CATBLK(IIWIN+3).LE.CATBLK(IIWIN+1))) GO TO 999
      IF ((CATBLK(IICOR+2).LE.CATBLK(IICOR)) .OR.
     *   (CATBLK(IICOR+3).LE.CATBLK(IICOR+1))) GO TO 999
      IMWIND(1) = CATBLK(IIWIN)
      IMWIND(2) = CATBLK(IIWIN+1)
      IMWIND(3) = CATBLK(IIWIN+2)
      IMWIND(4) = CATBLK(IIWIN+3)
      TVAREA(1) = CATBLK(IICOR)
      TVAREA(2) = CATBLK(IICOR+1)
      TVAREA(3) = CATBLK(IICOR+2)
      TVAREA(4) = CATBLK(IICOR+3)
      RDEP(1) = CATBLK(IIDEP+0)
      RDEP(2) = CATBLK(IIDEP+1)
      RDEP(3) = CATBLK(IIDEP+2)
      RDEP(4) = CATBLK(IIDEP+3)
      RDEP(5) = CATBLK(IIDEP+4)
      IL = 0
C                                       Init
      CALL YHOLD ('ONNN', IERR)
      CALL YZERO (ICH1, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL YZERO (ICH2, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       turn on graphics to be certain
      CALL YSLECT ('ONNN', ICH1, 0, SCRTCH, IERR)
      IPOS = 1
      IF (IERR.NE.0) GO TO 980
      CALL YSLECT ('ONNN', ICH2, 0, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       no scroll on graphics now
      ITEMP = 2 ** NGRAY
      SCROLX = TVSCRX(1)
      SCROLY = TVSCRY(1)
      CALL YSCROL (ITEMP, SCROLX, SCROLY, T, IERR)
      IPOS = 2
      IF (IERR.NE.0) GO TO 980
      CALL YHOLD ('OFFF', IERR)
C                                       Init values provided
      IERR = 2
      SX = (TVAREA(3) - TVAREA(1)) / (IMWIND(3) - IMWIND(1))
      SY = (TVAREA(4) - TVAREA(2)) / (IMWIND(4) - IMWIND(2))
C                                       Convert image to TV pixels
      DO 20 I = 1,INBOX
         IF ((BBLC(1,I).GT.-1.01).AND.(BBLC(1,I).LT.-0.99)) THEN
            CIRCLE(I) = 1
            IR(1,I) = NINT (BBLC(2,I) * SX)
            IR(1,I) = MAX (1, IR(1,I))
            IR(2,I) = NINT (BBLC(2,I) * SY)
            IR(2,I) = MAX (1, IR(2,I))
            IC(1,I) = NINT (TVAREA(1) + (BTRC(1,I)-IMWIND(1)) * SX)
            IC(2,I) = NINT (TVAREA(2) + (BTRC(2,I)-IMWIND(2)) * SY)
         ELSE
            IB(1,I) = NINT (TVAREA(1) + (BBLC(1,I) - IMWIND(1)) * SX)
            IT(1,I) = NINT (TVAREA(1) + (BTRC(1,I) - IMWIND(1)) * SX)
            IB(2,I) = NINT (TVAREA(2) + (BBLC(2,I) - IMWIND(2)) * SY)
            IT(2,I) = NINT (TVAREA(2) + (BTRC(2,I) - IMWIND(2)) * SY)
            END IF
 20      CONTINUE
      IERR = 0
      NXTBOX = .TRUE.
      IPASS = 0
      IF (CIRCLE(NBOX).GT.0) THEN
         RPOS(1) = IC(1,NBOX)
         RPOS(2) = IC(2,NBOX)
      ELSE
         RPOS(1) = IB(1,NBOX)
         RPOS(2) = IB(2,NBOX)
         END IF
      IPOS = 3
      CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IERR)
      IF (IERR.EQ.2) THEN
         DO 25 I = 1,NBOX
            J = NBOX - I
            IF (J.EQ.0) THEN
               RPOS(1) = MAXXTV(1) / 2
               RPOS(2) = MAXXTV(2) / 2
               CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IERR)
            ELSE
               IF (CIRCLE(J).GT.0) THEN
                  RPOS(1) = IC(1,J)
                  RPOS(2) = IC(2,J)
               ELSE
                  RPOS(1) = IB(1,J)
                  RPOS(2) = IB(2,J)
                  END IF
               CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IERR)
               END IF
            IF (IERR.EQ.0) GO TO 30
            IF (IERR.NE.2) GO TO 980
 25         CONTINUE
         END IF
 30   IF (IERR.NE.0) GO TO 980
      IBUT = 4
      IL = 2
C                                       draw all boxes
 40   IERR = 0
      CALL YHOLD ('ONNN', IERR)
      NOFF = 0
      NMISS = 0
      JL = 0
      DO 45 I = 1,NBOX
         IERR = 0
         CALL DRBOXS (ICH1, CATBLK(IICOR), CIRCLE(I), JL, IB(1,I),
     *      IT(1,I), SCRTCH, IERR)
         IPOS = 100 + I
         IF (IERR.GT.0) GO TO 980
         ISONTV(I) = IERR
         IF (IERR.EQ.-1) NOFF = NOFF + 1
         IF (IERR.EQ.-2) NMISS = NMISS + 1
 45      CONTINUE
      CALL YHOLD ('OFFF', IERR)
      IF ((WARN) .AND. (NOFF+NMISS.GT.0)) THEN
         IF (NOFF.GT.0) THEN
            WRITE (MSGTXT,1045) NOFF, NBOX
            CALL MSGWRT (6)
            MSGTXT = 'These boxes may be deleted'
            CALL MSGWRT (6)
            END IF
         IF (NMISS.GT.0) THEN
            WRITE (MSGTXT,1046) NMISS, NBOX
            CALL MSGWRT (6)
            MSGTXT = 'These boxes may NOT be deleted'
            CALL MSGWRT (6)
            END IF
         WARN = .FALSE.
         END IF
      IF ((IBUT.GT.7) .OR. (NMISS.GE.NBOX)) GO TO 800
C                                       Find a box
 50   MSGTXT = 'Select box with button A or B'
      CALL MSGWRT (1)
      MSGTXT = 'Exit with button C or D'
      CALL MSGWRT (1)
      CALL YCURSE ('READ', T, T, RPOS, QUAD, IBUT, IERR)
      IPOS = 4
      IF (IERR.NE.0) GO TO 980
      IF (IBUT.GT.3) GO TO 800
C                                       Find nearest corner
      DO 60 J = 1,3
         DLIM = J * 1.5 - 1.0
         DO 55 I = 1,NBOX
            IF (ISONTV(I).GT.-2) THEN
               IL = 2
               IF (CIRCLE(I).GT.0) THEN
                  RADIUS = SQRT (((RPOS(1)-IC(1,I))*SY/SX)**2 +
     *               (RPOS(2)-IC(2,I))**2)
                  IF (ABS(RADIUS-IR(2,I)).LE.DLIM) GO TO 70
               ELSE
                  IF ((ABS(RPOS(1)-IT(1,I)).LE.DLIM) .AND.
     *               (ABS(RPOS(2)-IT(2,I)).LE.DLIM)) GO TO 70
                  END IF
               IL = 3
               IF (CIRCLE(I).GT.0) THEN
                  IF ((ABS(RPOS(1)-IC(1,I)).LE.2*DLIM) .AND.
     *               (ABS(RPOS(2)-IC(2,I)).LE.2*DLIM)) GO TO 70
               ELSE
                  IF ((ABS(RPOS(1)-IB(1,I)).LE.DLIM) .AND.
     *               (ABS(RPOS(2)-IB(2,I)).LE.DLIM)) GO TO 70
                  END IF
               END IF
 55         CONTINUE
 60      CONTINUE
      GO TO 50
C                                       found one
 70   CALL DRBOXS (ICH1, CATBLK(IICOR), CIRCLE(I), -3, IB(1,I),
     *   IT(1,I), SCRTCH, IERR)
      CALL DRBOXS (ICH2, CATBLK(IICOR), CIRCLE(I), JL, IB(1,I),
     *   IT(1,I), SCRTCH, IERR)
      IPOS = 5
      IF (IERR.GT.0) GO TO 980
      MSGTXT = 'Hit button A to delete this box'
      CALL MSGWRT (1)
      MSGTXT = 'Hit buttons B or C to select a different box'
      CALL MSGWRT (1)
      MSGTXT = 'Hit button D to exit'
      CALL MSGWRT (1)
C                                       read for button
      CALL YCURSE ('READ', T, T, RPOS, QUAD, IBUT, IERR)
      IPOS = 6
      IF (IERR.NE.0) GO TO 980
C                                       erase highlight
      CALL DRBOXS (ICH2, CATBLK(IICOR), CIRCLE(I), -3, IB(1,I),
     *   IT(1,I), SCRTCH, IERR)
      IPOS = 7
      IF (IERR.GT.0) GO TO 980
C                                       restore if not flag
      IF (IBUT.GT.1) THEN
         CALL DRBOXS (ICH1, CATBLK(IICOR), CIRCLE(I), JL, IB(1,I),
     *      IT(1,I), SCRTCH, IERR)
         IPOS = 8
         IF (IERR.GT.0) GO TO 980
         IF (IBUT.GT.7) GO TO 800
         GO TO 50
         END IF
C                                       drop this box
      DO 80 J = I+1,NBOX
         CIRCLE(J-1) = CIRCLE(J)
         IB(1,J-1) = IB(1,J)
         IB(2,J-1) = IB(2,J)
         IT(1,J-1) = IT(1,J)
         IT(2,J-1) = IT(2,J)
         BBLC(1,J-1) = BBLC(1,J)
         BBLC(2,J-1) = BBLC(2,J)
         BTRC(1,J-1) = BTRC(1,J)
         BTRC(2,J-1) = BTRC(2,J)
 80      CONTINUE
      NBOX = NBOX - 1
      IF (NBOX.LE.0) GO TO 800
      GO TO 40
C                                       DONE: fill in real boxes
 800  NBOX = MAX (0, MIN (INBOX, NBOX))
      DO 810 I = 1,NBOX
C                                       force real BLC, TRC
         IF (CIRCLE(I).LT.0) THEN
            IF (IB(1,I).GT.IT(1,I)) THEN
               JERR = IT(1,I)
               IT(1,I) = IB(1,I)
               IB(1,I) = JERR
               END IF
            IF (IB(2,I).GT.IT(2,I)) THEN
               JERR = IT(2,I)
               IT(2,I) = IB(2,I)
               IB(2,I) = JERR
               END IF
            END IF
C                                       circle
         IF (CIRCLE(I).GT.1) THEN
            BBLC(1,I) = -1.0
            BBLC(2,I) = SQRT (IR(1,I)*IR(2,I)/SX/SY)
            BTRC(1,I) = (IC(1,I) - TVAREA(1)) / SX + IMWIND(1)
            BTRC(2,I) = (IC(2,I) - TVAREA(2)) / SY + IMWIND(2)
C                                       rectangle
         ELSE IF (CIRCLE(I).LT.-1) THEN
            BBLC(1,I) = (IB(1,I) - TVAREA(1)) / SX + IMWIND(1)
            BBLC(2,I) = (IB(2,I) - TVAREA(2)) / SY + IMWIND(2)
            BTRC(1,I) = (IT(1,I) - TVAREA(1)) / SX + IMWIND(1)
            BTRC(2,I) = (IT(2,I) - TVAREA(2)) / SY + IMWIND(2)
            END IF
         CALL RCOPY (5, RDEP, BBLC(3,I))
         CALL RCOPY (5, RDEP, BTRC(3,I))
 810     CONTINUE
      IERR = 0
C                                       Off cursor, graphics, scroll
C                                       leave graphics on
 980  CALL YCURSE ('OFFF', F, T, RPOS, QUAD, IBUT, JERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1980) IERR, IPOS
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1045 FORMAT ('Warning:',I4,' of',I4,' boxes not fully on displayed',
     *   ' image')
 1046 FORMAT ('Warning:',I4,' of',I4,' boxes fully off displayed',
     *   ' image')
 1980 FORMAT ('GRBOXD: ERROR CODE',I7,' AT',I5)
      END

      SUBROUTINE VERMAT (IVOL, PNAME, MNAME, VERSON, IVER, AVERS, IERR)
C-----------------------------------------------------------------------
C! min match handling for text file names incl sequence of directories
C# Text
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   VERMAT performs min match handling for text file names via call(s)
C   to TXTMAT.  It handles a sequence of directory names conveyed via
C   VERSON and the local default in DCHCOM.  All messages are done.
C   Inputs:
C      IVOL    I        Volume number
C      PNAME   C*48     File name: 24 packed chars
C      VERSON  C*48     Directory code: 48 packed chars
C   In/out:
C      MNAME   C*(*)    In: test member name (<= 12 chars)
C                       Out: actual name found
C   Output:
C      IVER    I        Actual version "number": 1 - 10 =>
C                          OLD, NEW, TST, CVX, OLDPSAP, NEWPSAP,
C                          TSTPSAP, CVXPSAP, LOCAL,   other = 10
C      AVERS   R(*)     Actual VERSION string where found
C      IERR    I        Error code: 0 => ok
C                           1 => none
C                           2 => more than one match found
C                           3 => IO error
C-----------------------------------------------------------------------
      CHARACTER PNAME*48, MNAME*(*), AVERS*48, VERSON*(*)
      INTEGER   IVOL, IVER, IERR
C
      INTEGER   LOLD, LNEW, VSIZE, NC, I, ITRIM
      LOGICAL   EQUAL
      CHARACTER VERVER(9)*8
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA VERVER /'OLD ', 'NEW ', 'TST ', 'CVX', 'OLDPSAP', 'NEWPSAP',
     *   'TSTPSAP', 'CVXPSAP', 'LOCAL'/
C-----------------------------------------------------------------------
C                                       Loop over requested directories
      LOLD = 1
      VSIZE = LEN (VERSON)
      DO 20 I = 1,12
         LNEW = 0
         IF (LOLD.LT.VSIZE) LNEW = INDEX (VERSON(LOLD:), '|')
         IF (LNEW.GT.0) LNEW = LNEW + LOLD - 1
         IF (LNEW.EQ.0) LNEW = VSIZE + 1
         NC = LNEW - LOLD
         AVERS = ' '
         IF (LOLD.LE.VSIZE) AVERS(1:NC) = VERSON(LOLD:LOLD+NC-1)
         LOLD = LNEW + 1
         EQUAL = AVERS.EQ.' '
         IF (EQUAL) AVERS(1:3) = VERNAM(1:3)
         IF (EQUAL) LOLD = VSIZE + 2
         CALL TXTMAT (IVOL, PNAME, MNAME, AVERS, IERR)
         IF ((IERR.NE.1) .OR. (EQUAL)) GO TO 30
 20      CONTINUE
C                                       Done trying
 30   IF (IERR.GT.1) GO TO 999
      IF (IERR.EQ.0) GO TO 40
         I = ITRIM (MNAME)
         WRITE (MSGTXT,1030) MNAME(:I)
         CALL MSGWRT (7)
         GO TO 999
C                                       Got it: message?
 40   EQUAL = VERNAM(1:3).EQ.AVERS(1:3)
      IF (EQUAL) GO TO 50
         WRITE (MSGTXT,1040) AVERS
         CALL MSGWRT (2)
C                                       Integer type
 50   IVER = 10
      DO 55 I = 1,9
         IF (AVERS(1:8).EQ.VERVER(I)) IVER = I
 55      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('TEXT FOR ',A,' UNAVAILABLE')
 1040 FORMAT ('Found in Version=',A)
      END

      SUBROUTINE FCINI (OPCODE, LUN, VOL, CNO, VER, CATBLK, FCNUM,
     *   LASTR, BUFFER, FCKOLS, FCNUMV, IERR)
C-----------------------------------------------------------------------
C! Opens/creates FC (Flag Command) tables used by OOP EDIT class
C# EXT-util UV Calibration OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1996, 1998, 2006, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   creates and/or opens for writing (and reading) a specified FC table
C   for Flag Commands from OOP EDIT class
C   Inputs:
C      OPCODE  C*4       READ or WRIT (create only if none previously)
C      LUN     I         Logical unit number to use
C      VOL     I         Disk number
C      CNO     I         Catalog number
C   In/out:
C      VER     I         Input: desired version number 0 -> highest
C                           existing or 1 if none previously
C                        Output: that used
C      CATBLK  I(256)    File catalog header block
C   Output:
C      FCNUM   I         Highest current flag command number
C      LASTR   I         Highest current record written
C      BUFFER  I(512)    Required for later calls to TABIO
C      FCKOLS  I(11)     Column pointers
C      FCNUMV  I(11)     Count by column
C      IERR    I         Error codes from TABINI or TABIO
C-----------------------------------------------------------------------
      INTEGER   NCOLS
      PARAMETER (NCOLS=15)
C
      CHARACTER OPCODE*4
      INTEGER   LUN, VOL, CNO, VER, CATBLK(256), FCNUM, LASTR,
     *   BUFFER(512), FCKOLS(NCOLS), FCNUMV(NCOLS), IERR
C
      INTEGER   IRNO, NKEY, NREC, ITITLE(8), DATP(128,2), CCODE(NCOLS),
     *   NCOL, RECORD(29), NUMBP, I, ITRIM, NC, IPOINT, JERR
      HOLLERITH HTITLE(8)
      CHARACTER TTITLE*32, CTITLE(NCOLS)*8, UNITS(NCOLS)*8, TITLE*24
      LOGICAL   T
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (ITITLE, HTITLE)
      DATA TTITLE /'AIPS UV EDITOR FLAG COMMAND TABL'/
      DATA CTITLE /'FLAGNUMB', 'FLAGOPER', 'FLAGTIME', 'FLAGANT',
     *   'FLAGSOUR', 'FLAGCHAN', 'FLAGIF  ', 'FLAGSUBA', 'FLAGFQID',
     *   'FLAGSTOK', 'DATATYPE', 'CLIPRANG', 'TIMERANG', 'ITIME',
     *   'REASON'/
      DATA UNITS /2*' ', 'DAYS', 6*' ', 'STK CODE', 2*' ', 'DAYS',
     *   2*' '/
      DATA CCODE /14, 83, 22, 24, 14, 24, 24, 14, 14, 43, 83, 22, 22,
     *   24, 243/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init parameters
      NCOL = NCOLS
      NKEY = 1
      NREC = 500
      IF (OPCODE.NE.'READ') THEN
         CALL FILL (256, 0, DATP)
         CALL COPY (NCOL, CCODE, DATP(1,2))
         END IF
C                                       Version number
      IF (VER.LE.0) CALL FNDEXT ('FC', CATBLK, VER)
C                                       create/open
      CALL TABINI (OPCODE, 'FC', VOL, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
C                                       Error
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, VER
         CALL MSGWRT (7)
C                                       pre-existing file
      ELSE IF (IERR.EQ.0) THEN
         NUMBP = DATP(1,1)
         IF (BUFFER(5).GT.0) THEN
            CALL TABIO ('READ', 0, BUFFER(5), RECORD, BUFFER, IERR)
            FCNUM = RECORD(NUMBP)
            LASTR = BUFFER(5)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1010) IERR, VER, BUFFER(5)
               CALL MSGWRT (7)
               END IF
         ELSE
            FCNUM = 0
            LASTR = 0
            END IF
C                                       New file created
      ELSE
         FCNUM = 0
         LASTR = 0
C                                       write column titles
         DO 20 IRNO = 1,NCOL
            TITLE = CTITLE(IRNO)
            CALL CHR2H (24, TITLE, 1, HTITLE)
            CALL TABIO ('WRIT', 3, IRNO, ITITLE, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'FCINI', IERR)
               GO TO 990
               END IF
 20         CONTINUE
C                                       write units
         DO 30 IRNO = 1,NCOL
            TITLE = UNITS(IRNO)
            CALL CHR2H (24, TITLE, 1, HTITLE)
            CALL TABIO ('WRIT', 4, IRNO, ITITLE, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'FCINI', IERR)
               GO TO 990
               END IF
 30         CONTINUE
C                                       table title
         CALL CHR2H (32, TTITLE, 1, HTITLE)
         CALL COPY (8, ITITLE, BUFFER(101))
         END IF
C                                      Get array indices
C                                      Cover your ass from FNDCOL -
C                                      close to flush the buffers and
C                                      then reopen.
      CALL TABIO ('CLOS', 3, IRNO, ITITLE, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'FCINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'FC', VOL, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'FCINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (NCOLS, CTITLE, 8, T, BUFFER, FCKOLS, JERR)
C                                      Get array indices and no. values
      DO 150 I = 1,NCOLS
         IPOINT = FCKOLS(I)
         IF (IPOINT.GT.0) THEN
            FCKOLS(I) = DATP(IPOINT,1)
            FCNUMV(I) = DATP(IPOINT,2) / 10
            IF (FCNUMV(I).LE.0) THEN
               NC = ITRIM (CTITLE(I))
               WRITE (MSGTXT,1100) CTITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            FCKOLS(I) = -1
            FCNUMV(I) = 0
            NC = ITRIM (CTITLE(I))
            WRITE (MSGTXT,1101) CTITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                      Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' OPENING Flag-Command TABLE VERSION',I4)
 1010 FORMAT ('ERROR',I5,' READING Flag-Command TABLE VERSION',I4,
     *   ' RECORD',I8)
 1100 FORMAT ('FCINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('FCINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('FCINI: ERROR INITIALIZING FLAG CONTROL TABLE FOR ',A4)
      END

LOCAL INCLUDE 'PCAVG.INC'
C                                                          Include DSPF
C                                       Local include for PCAVG
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2)
      CHARACTER NAMEIN*12, CLAIN*6
      REAL      XSIN, XDISIN, XINVER, SOLINT, BADD(10)
      INTEGER   DISKIN, SEQIN, CNOIN, INVER, OUTVER, BUFFER(512)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XINVER, SOLINT, BADD
      COMMON /CHRCOM/ NAMEIN, CLAIN
      COMMON /INFOLS/ DISKIN, SEQIN, CNOIN, INVER, OUTVER, BUFFER
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
C                                                          End DSPF
LOCAL END
LOCAL INCLUDE 'PCDATA.INC'
      INCLUDE 'INCS:PPCV.INC'
      DOUBLE PRECISION TIME, CABCAL, PCFREQ(2,MAXTON,MAXIF)
      INTEGER   PCNPOL, PCNIF, NUMTON, PCBUFF(512), PCNUMV(MAXPCC),
     *   PCKOLS(MAXPCC), PCROW, OUTROW
      REAL      TIMINT, STATE(2,4,MAXIF), PCREAL(2,MAXTON,MAXIF),
     *   PCIMAG(2,MAXTON,MAXIF), PCRATE(2,MAXTON,MAXIF)
      COMMON /PCDATA/ PCFREQ, TIME, CABCAL, STATE, PCREAL, PCIMAG,
     *   PCRATE, PCBUFF, TIMINT, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON,
     *   PCROW, OUTROW
LOCAL END
      PROGRAM PCAVG
C-----------------------------------------------------------------------
C! time average a PC table
C# UV Calibration EXT-appl VLBI
C-----------------------------------------------------------------------
C;  Copyright (C) 2017-2018
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task PCAVG sorts a PC table into time-antenna order and then
C   writes a new table with time averaging.
C   Inputs:
C      AIPS Adverb   Prg. Name          Description
C      INNAME         NAMEIN        File name to be imaged
C      INCLASS        CLAIN         File class to be imaged
C      INSEQ          SEQIN         File sequence number
C      INDISK         DISKIN        Disk volume on which file resides
C      INVERS         INVER         Input version
C      SOLINT         SOLINT        Averaging time
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'PCAVG.INC'
      DATA PRGM /'PCAVG '/
C-----------------------------------------------------------------------
C                                       get inputs, ...
      CALL PCAVGI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
      IF (SOLINT.GT.0.0) THEN
         CALL PCAVGR (IRET)
      ELSE
         CALL PCAVGF (IRET)
         END IF
      IF (IRET.NE.0) GO TO 990
C                                       Do history
      CALL PCAVHI
C                                       close down
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE PCAVGI (PRGM, IRET)
C-----------------------------------------------------------------------
C   PCAVGI gets the inputs for PCAVG.
C   Inputs:
C      PRGM   C*6   Task name
C   Output:
C      ONEIF  L     T => input has <= 1 IF
C      IRET   I     Error code: 0 ok, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
C
      CHARACTER STAT*4, UTYPE*2
      INTEGER   NPARM, IERR, IROUND, I
      INCLUDE 'PCAVG.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
C                                       Get input parameters.
      NPARM = 19
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMEI, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFFER, IERR)
      IRET = 5
C                                       Crunch input parameters.
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
C                                       Get CATBLK.
      CNOIN = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.5) THEN
            WRITE (MSGTXT,1015) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *         NLUSER
         ELSE
            WRITE (MSGTXT,1016) NAMEIN, CLAIN, SEQIN, DISKIN, NLUSER
            END IF
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'WRIT', BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 1
C                                       Get uv header info.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
      GO TO 999
C                                       message
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PCAVGI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1015 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I5,' DISK=',
     *   I3,' USID=',I5)
 1016 FORMAT (A12,'.',A6,'.',I5,' DISK=',I3,' USID=',I5,' NOT FOUND')
 1020 FORMAT ('PCAVGI: ERROR',I3,' READING CATBLK ')
      END
      SUBROUTINE PCAVGR (IRET)
C-----------------------------------------------------------------------
C   PCAVGR sorts the input table if needed and does the averaging to an
C   output table
C   Output:
C      IRET     I      Error code: 0 => okay, else die.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'PCAVG.INC'
      INCLUDE 'PCDATA.INC'
      INTEGER   I, ISUB, PCLUN, KEY(2,2), KEYSUB(2,2), NXVER, ANTNUM,
     *   FREQID, IROW, ISCAN, NSCAN, NUMPC, NXLUN, SOUNUM, PC2LUN,
     *   OUBUFF(512), LANT, LSOUR, NAVG, LIF, LP, LCH, NACABC, LSUB,
     *   LFREQ, NAREAL(2,MAXTON,MAXIF), NASTAT(2,4,MAXIF)
      LOGICAL   GOOD
      REAL      FKEY(2,2), AVREAL(2,MAXTON,MAXIF), AVSTAT(2,4,MAXIF),
     *   AVIMAG(2,MAXTON,MAXIF), AVRATE(2,MAXTON,MAXIF), AVTIMI,
     *   STIMES(2000)
      DOUBLE PRECISION LTIME, AVFREQ(2,MAXTON,MAXIF), AVTIME, AVCABC
      DATA FKEY /1.0,0.0,1.0,0.0/
      DATA KEYSUB, KEY /4*1, 4*0/
      DATA PCLUN, PC2LUN, NXLUN /43,44,45/
C-----------------------------------------------------------------------
C                                       open PC table
      INVER = XINVER + 0.1
      CALL FNDEXT ('PC', CATBLK, I)
      IF (INVER.LE.0) INVER = I
      IF (INVER.GT.I) INVER = I
      OUTVER = I + 1
      CALL PCINI ('READ', PCBUFF, DISKIN, CNOIN, INVER, CATBLK, PCLUN,
     *   PCROW, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT PC TABLE'
         GO TO 990
         END IF
      XINVER = INVER
C                                       sort to output PC table
      CALL TABIO ('CLOS', 0, PCROW, PCBUFF, PCBUFF, IRET)
      IF ((PCBUFF(43).NE.4) .OR. (PCBUFF(44).NE.1)) THEN
         MSGTXT = 'Sorting input table'
         CALL MSGWRT (2)
         KEY(1,1) = 4
         KEY(1,2) = 1
         CALL TABSRT (DISKIN, CNOIN, 'PC', INVER, INVER, KEY, KEYSUB,
     *      FKEY, PCBUFF, CATBLK, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SORTING PC TABLE'
            GO TO 990
            END IF
         END IF
      CALL PCINI ('READ', PCBUFF, DISKIN, CNOIN, INVER, CATBLK, PCLUN,
     *   PCROW, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'RE-OPENING INPUT PC TABLE'
         GO TO 990
         END IF
      CALL PCINI ('WRIT', OUBUFF, DISKIN, CNOIN, OUTVER, CATBLK, PC2LUN,
     *   OUTROW, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT PC TABLE'
         GO TO 990
         END IF
      OUBUFF(43) = PCBUFF(43)
      OUBUFF(44) = PCBUFF(44)
C                                       scan list
      CALL FNDEXT ('NX', CATBLK, NXVER)
      IF (NXVER.LE.0) THEN
         NSCAN = 0
         MSGTXT = 'NO INDEX TABLE SO NO SCAN BREAKS'
         CALL MSGWRT (6)
      ELSE
         ISUB = 0
         CALL GETNX (NXLUN, DISKIN, CNOIN, CATBLK, ISUB, BUFFER,
     *      NSCAN, STIMES)
         IF (NSCAN.LE.0) THEN
            MSGTXT = 'INDEX TABLE TROUBLES, SO NO SCAN BREAKS'
            CALL MSGWRT (6)
            END IF
         END IF
C                                       prepare for averaging
      MSGTXT = 'Averaging input table'
      CALL MSGWRT (2)
      NUMPC = PCBUFF(5)
      LANT = 0
      LSOUR = 0
      LTIME = -1000.
      SOLINT = SOLINT / 86400.0
      NAVG = 0
      ISCAN = 1
      DO 300 IROW = 1,NUMPC+1
         IF (IROW.LE.NUMPC) THEN
            PCROW = IROW
            CALL TABPC ('READ', PCBUFF, PCROW, PCKOLS, PCNUMV, PCNPOL,
     *         TIME, TIMINT, SOUNUM, ANTNUM, ISUB, FREQID, CABCAL,
     *         STATE, PCFREQ, PCREAL, PCIMAG, PCRATE, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING PC TABLE'
               GO TO 990
               END IF
            IF (IRET.LT.0) GO TO 300
            END IF
C                                       do an average
         IF ((SOUNUM.NE.LSOUR) .OR. (ANTNUM.NE.LANT) .OR.
     *      (IROW.GT.NUMPC) .OR. (TIME.GT.LTIME+SOLINT) .OR.
     *      (TIME.GT.STIMES(ISCAN+1))) THEN
            IF (NAVG.GT.0) THEN
               IF (TIME.GT.STIMES(ISCAN+1)) ISCAN = ISCAN + 1
               GOOD = .FALSE.
               DO 40 LIF = 1,PCNIF
                  DO 30 LP = 1,PCNPOL
                     DO 10 LCH = 1,NUMTON
                        IF (NAREAL(LP,LCH,LIF).GT.0) THEN
                           AVREAL(LP,LCH,LIF) = AVREAL(LP,LCH,LIF) /
     *                        NAREAL(LP,LCH,LIF)
                           AVIMAG(LP,LCH,LIF) = AVIMAG(LP,LCH,LIF) /
     *                        NAREAL(LP,LCH,LIF)
                           AVRATE(LP,LCH,LIF) = AVRATE(LP,LCH,LIF) /
     *                        NAREAL(LP,LCH,LIF)
                           GOOD = .TRUE.
                        ELSE
                           AVREAL(LP,LCH,LIF) = FBLANK
                           AVIMAG(LP,LCH,LIF) = FBLANK
                           AVRATE(LP,LCH,LIF) = FBLANK
                           END IF
                        AVFREQ(LP,LCH,LIF) = AVFREQ(LP,LCH,LIF) / NAVG
 10                     CONTINUE
                     DO 20 LCH = 1,4
                        IF (NASTAT(LP,LCH,LIF).GT.0) THEN
                           AVSTAT(LP,LCH,LIF) = AVSTAT(LP,LCH,LIF) /
     *                        NASTAT(LP,LCH,LIF)
                        ELSE
                           AVSTAT(LP,LCH,LIF) = FBLANK
                           END IF
 20                     CONTINUE
 30                  CONTINUE
 40               CONTINUE
               AVTIME = AVTIME / NAVG
               IF (NACABC.GT.0) THEN
                  AVCABC = AVCABC / NACABC
               ELSE
                  AVCABC = DBLANK
                  END IF
               IF (GOOD) THEN
                  CALL TABPC ('WRIT', OUBUFF, OUTROW, PCKOLS, PCNUMV,
     *               PCNPOL, AVTIME, AVTIMI, LSOUR, LANT, LSUB, LFREQ,
     *               AVCABC, AVSTAT, AVFREQ, AVREAL, AVIMAG, AVRATE,
     *               IRET)
                  IF (IRET.GT.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'WRITING PC TABLE'
                     GO TO 990
                     END IF
                  END IF
               IF (IROW.GT.NUMPC) GO TO 900
               END IF
C                                       zero summing arrays
            NAVG = 1
            LSOUR = SOUNUM
            LANT = ANTNUM
            LSUB = ISUB
            LFREQ = FREQID
            DO 140 LIF = 1,PCNIF
               DO 130 LP = 1,PCNPOL
                  DO 110 LCH = 1,NUMTON
                     IF (PCREAL(LP,LCH,LIF).NE.FBLANK) THEN
                        NAREAL(LP,LCH,LIF) = 1
                        AVREAL(LP,LCH,LIF) = PCREAL(LP,LCH,LIF)
                        AVIMAG(LP,LCH,LIF) = PCIMAG(LP,LCH,LIF)
                        AVRATE(LP,LCH,LIF) = PCRATE(LP,LCH,LIF)
                     ELSE
                        NAREAL(LP,LCH,LIF) = 0
                        AVREAL(LP,LCH,LIF) = 0.0
                        AVIMAG(LP,LCH,LIF) = 0.0
                        AVRATE(LP,LCH,LIF) = 0.0
                        END IF
                     AVFREQ(LP,LCH,LIF) = PCFREQ(LP,LCH,LIF)
 110                 CONTINUE
                  DO 120 LCH = 1,4
                     IF (STATE(LP,LCH,LIF).NE.FBLANK) THEN
                        NASTAT(LP,LCH,LIF) = 1
                        AVSTAT(LP,LCH,LIF) = STATE(LP,LCH,LIF)
                     ELSE
                        AVSTAT(LP,LCH,LIF) = 0.0
                        NASTAT(LP,LCH,LIF) = 0
                        END IF
 120                 CONTINUE
 130              CONTINUE
 140           CONTINUE
            AVTIME = TIME
            LTIME = TIME
            AVTIMI = TIMINT
            IF (CABCAL.NE.DBLANK) THEN
               AVCABC = CABCAL
               NACABC = 1
            ELSE
               NACABC = 0
               AVCABC = 0.0D0
               END IF
C                                       add in this record
         ELSE
            DO 240 LIF = 1,PCNIF
               DO 230 LP = 1,PCNPOL
                  DO 210 LCH = 1,NUMTON
                     IF (PCREAL(LP,LCH,LIF).NE.FBLANK) THEN
                        NAREAL(LP,LCH,LIF) = NAREAL(LP,LCH,LIF) + 1
                        AVREAL(LP,LCH,LIF) = AVREAL(LP,LCH,LIF) +
     *                     PCREAL(LP,LCH,LIF)
                        AVIMAG(LP,LCH,LIF) = AVIMAG(LP,LCH,LIF) +
     *                     PCIMAG(LP,LCH,LIF)
                        AVRATE(LP,LCH,LIF) = AVRATE(LP,LCH,LIF) +
     *                     PCRATE(LP,LCH,LIF)
                        END IF
                     AVFREQ(LP,LCH,LIF) = AVFREQ(LP,LCH,LIF) +
     *                  PCFREQ(LP,LCH,LIF)
 210                 CONTINUE
                  DO 220 LCH = 1,4
                     IF (STATE(LP,LCH,LIF).NE.FBLANK) THEN
                        NASTAT(LP,LCH,LIF) = NASTAT(LP,LCH,LIF) + 1
                        AVSTAT(LP,LCH,LIF) = AVSTAT(LP,LCH,LIF) +
     *                     STATE(LP,LCH,LIF)
                        END IF
 220                 CONTINUE
 230              CONTINUE
 240           CONTINUE
            NAVG = NAVG + 1
            AVTIME = AVTIME + TIME
            AVTIMI = AVTIMI + TIMINT
            IF (CABCAL.NE.DBLANK) THEN
               AVCABC = AVCABC + CABCAL
               NACABC = NACABC + 1
               END IF
            END IF
 300     CONTINUE
C                                       done - close up files
 900  CALL TABPC ('CLOS', PCBUFF, PCROW, PCKOLS, PCNUMV, PCNPOL, TIME,
     *   TIMINT, SOUNUM, ANTNUM, ISUB, FREQID, CABCAL,STATE, PCFREQ,
     *   PCREAL, PCIMAG, PCRATE, IRET)
      CALL TABPC ('CLOS', OUBUFF, OUTROW, PCKOLS, PCNUMV, PCNPOL,
     *   AVTIME, AVTIMI, LSOUR, LANT, LSUB, LFREQ, AVCABC, AVSTAT,
     *   AVFREQ, AVREAL, AVIMAG, AVRATE, IRET)
      SOLINT = SOLINT * 86400.0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PCAVGR: ERROR',I5,' ON ',A)
      END
      SUBROUTINE PCAVGF (IRET)
C-----------------------------------------------------------------------
C   PCAVGF sorts the input table if needed and does the averaging to an
C   output table using stict intervals within each scan
C   Output:
C      IRET     I      Error code: 0 => okay, else die.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'PCAVG.INC'
      INCLUDE 'PCDATA.INC'
      INTEGER   I, ISUB, PCLUN, KEY(2,2), KEYSUB(2,2), NXVER, ANTNUM,
     *   FREQID, IROW, ISCAN, NSCAN, NACABC, LSUB, LFREQ, NUMPC, NXLUN,
     *   SOUNUM, PC2LUN, OUBUFF(512), LANT, LSOUR, NAVG, LIF, LP, LCH,
     *   NAREAL(2,MAXTON,MAXIF), NASTAT(2,4,MAXIF), LSCAN, IINTR, LINTR
      LOGICAL   GOOD
      REAL      FKEY(2,2), AVREAL(2,MAXTON,MAXIF), AVSTAT(2,4,MAXIF),
     *   AVIMAG(2,MAXTON,MAXIF), AVRATE(2,MAXTON,MAXIF), AVTIMI,
     *   STIMES(2,2000), START, STOP, TINT
      DOUBLE PRECISION LTIME, AVFREQ(2,MAXTON,MAXIF), AVTIME, AVCABC
      DATA FKEY /1.0,0.0,1.0,0.0/
      DATA KEYSUB, KEY /4*1, 4*0/
      DATA PCLUN, PC2LUN, NXLUN /43,44,45/
C-----------------------------------------------------------------------
C                                       open PC table
      INVER = XINVER + 0.1
      CALL FNDEXT ('PC', CATBLK, I)
      IF (INVER.LE.0) INVER = I
      IF (INVER.GT.I) INVER = I
      OUTVER = I + 1
      CALL PCINI ('READ', PCBUFF, DISKIN, CNOIN, INVER, CATBLK, PCLUN,
     *   PCROW, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT PC TABLE'
         GO TO 990
         END IF
      XINVER = INVER
C                                       sort to output PC table
      CALL TABIO ('CLOS', 0, PCROW, PCBUFF, PCBUFF, IRET)
      IF ((PCBUFF(43).NE.4) .OR. (PCBUFF(44).NE.1)) THEN
         MSGTXT = 'Sorting input table'
         CALL MSGWRT (2)
         KEY(1,1) = 4
         KEY(1,2) = 1
         CALL TABSRT (DISKIN, CNOIN, 'PC', INVER, INVER, KEY, KEYSUB,
     *      FKEY, PCBUFF, CATBLK, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SORTING PC TABLE'
            GO TO 990
            END IF
         END IF
      CALL PCINI ('READ', PCBUFF, DISKIN, CNOIN, INVER, CATBLK, PCLUN,
     *   PCROW, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'RE-OPENING INPUT PC TABLE'
         GO TO 990
         END IF
      CALL PCINI ('WRIT', OUBUFF, DISKIN, CNOIN, OUTVER, CATBLK, PC2LUN,
     *   OUTROW, PCKOLS, PCNUMV, PCNPOL, PCNIF, NUMTON, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT PC TABLE'
         GO TO 990
         END IF
      OUBUFF(43) = PCBUFF(43)
      OUBUFF(44) = PCBUFF(44)
C                                       scan list
      CALL FNDEXT ('NX', CATBLK, NXVER)
      IF (NXVER.LE.0) THEN
         NSCAN = 0
         MSGTXT = 'NO INDEX TABLE SO NO SCAN BREAKS'
         CALL MSGWRT (6)
         NSCAN = 1
         STIMES(1,1) = 0.0
         STIMES(2,1) = 1000.
      ELSE
         ISUB = 0
         CALL GETNDX (NXLUN, DISKIN, CNOIN, CATBLK, ISUB, BUFFER,
     *      NSCAN, STIMES)
         IF (NSCAN.LE.0) THEN
            MSGTXT = 'INDEX TABLE TROUBLES, SO NO SCAN BREAKS'
            CALL MSGWRT (6)
            END IF
         END IF
C                                       prepare for averaging
      MSGTXT = 'Averaging input table'
      CALL MSGWRT (2)
      NUMPC = PCBUFF(5)
      LANT = 0
      LSOUR = 0
      LTIME = -1000.
      SOLINT = -SOLINT / 86400.0
      NAVG = 0
      LSCAN = 0
      LINTR = 0
      STOP = -1.0
      DO 400 IROW = 1,NUMPC+1
         IF (IROW.LE.NUMPC) THEN
            PCROW = IROW
            CALL TABPC ('READ', PCBUFF, PCROW, PCKOLS, PCNUMV, PCNPOL,
     *         TIME, TIMINT, SOUNUM, ANTNUM, ISUB, FREQID, CABCAL,
     *         STATE, PCFREQ, PCREAL, PCIMAG, PCRATE, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING PC TABLE'
               GO TO 990
               END IF
            IF (IRET.LT.0) GO TO 400
C                                       which scan
            DO 10 ISCAN = 1,NSCAN
               IF ((TIME.GE.STIMES(1,ISCAN)) .AND.
     *            (TIME.LE.STIMES(2,ISCAN))) GO TO 15
 10            CONTINUE
C                                       not in scan - omit
            GO TO 400
 15         IF (ISCAN.NE.LSCAN) THEN
               I = (STIMES(2,ISCAN) - STIMES(1,ISCAN)) / SOLINT + 0.5
               I = MAX (I, 1)
               TINT = (STIMES(2,ISCAN) - STIMES(1,ISCAN)) / I
               END IF
C                                       which interval - start stop
            IINTR = (TIME - STIMES(1,ISCAN)) / TINT + 1.0
            END IF
C                                       do an average
         IF ((SOUNUM.NE.LSOUR) .OR. (ANTNUM.NE.LANT) .OR.
     *      (IROW.GT.NUMPC) .OR. (ISCAN.NE.LSCAN) .OR. (IINTR.NE.LINTR)
     *      .OR. (TIME.GT.STOP)) THEN
            IF (NAVG.GT.0) THEN
               GOOD = .FALSE.
               DO 140 LIF = 1,PCNIF
                  DO 130 LP = 1,PCNPOL
                     DO 110 LCH = 1,NUMTON
                        IF (NAREAL(LP,LCH,LIF).GT.0) THEN
                           AVREAL(LP,LCH,LIF) = AVREAL(LP,LCH,LIF) /
     *                        NAREAL(LP,LCH,LIF)
                           AVIMAG(LP,LCH,LIF) = AVIMAG(LP,LCH,LIF) /
     *                        NAREAL(LP,LCH,LIF)
                           AVRATE(LP,LCH,LIF) = AVRATE(LP,LCH,LIF) /
     *                        NAREAL(LP,LCH,LIF)
                           GOOD = .TRUE.
                        ELSE
                           AVREAL(LP,LCH,LIF) = FBLANK
                           AVIMAG(LP,LCH,LIF) = FBLANK
                           AVRATE(LP,LCH,LIF) = FBLANK
                           END IF
                        AVFREQ(LP,LCH,LIF) = AVFREQ(LP,LCH,LIF) / NAVG
 110                    CONTINUE
                     DO 120 LCH = 1,4
                        IF (NASTAT(LP,LCH,LIF).GT.0) THEN
                           AVSTAT(LP,LCH,LIF) = AVSTAT(LP,LCH,LIF) /
     *                        NASTAT(LP,LCH,LIF)
                        ELSE
                           AVSTAT(LP,LCH,LIF) = FBLANK
                           END IF
 120                    CONTINUE
 130                 CONTINUE
 140              CONTINUE
               AVTIME = (START + STOP) / 2.0
               IF (NACABC.GT.0) THEN
                  AVCABC = AVCABC / NACABC
               ELSE
                  AVCABC = DBLANK
                  END IF
               IF (GOOD) THEN
                  CALL TABPC ('WRIT', OUBUFF, OUTROW, PCKOLS, PCNUMV,
     *               PCNPOL, AVTIME, AVTIMI, LSOUR, LANT, LSUB, LFREQ,
     *               AVCABC, AVSTAT, AVFREQ, AVREAL, AVIMAG, AVRATE,
     *               IRET)
                  IF (IRET.GT.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'WRITING PC TABLE'
                     GO TO 990
                     END IF
                  END IF
               IF (IROW.GT.NUMPC) GO TO 900
               END IF
C                                       zero summing arrays
            NAVG = 1
            LSOUR = SOUNUM
            LANT = ANTNUM
            LSUB = ISUB
            LFREQ = FREQID
            LSCAN = ISCAN
            LINTR = IINTR
            STOP = STIMES(1,LSCAN) + LINTR * TINT
            START = STOP - TINT
            DO 240 LIF = 1,PCNIF
               DO 230 LP = 1,PCNPOL
                  DO 210 LCH = 1,NUMTON
                     IF (PCREAL(LP,LCH,LIF).NE.FBLANK) THEN
                        NAREAL(LP,LCH,LIF) = 1
                        AVREAL(LP,LCH,LIF) = PCREAL(LP,LCH,LIF)
                        AVIMAG(LP,LCH,LIF) = PCIMAG(LP,LCH,LIF)
                        AVRATE(LP,LCH,LIF) = PCRATE(LP,LCH,LIF)
                     ELSE
                        NAREAL(LP,LCH,LIF) = 0
                        AVREAL(LP,LCH,LIF) = 0.0
                        AVIMAG(LP,LCH,LIF) = 0.0
                        AVRATE(LP,LCH,LIF) = 0.0
                        END IF
                     AVFREQ(LP,LCH,LIF) = PCFREQ(LP,LCH,LIF)
 210                 CONTINUE
                  DO 220 LCH = 1,4
                     IF (STATE(LP,LCH,LIF).NE.FBLANK) THEN
                        NASTAT(LP,LCH,LIF) = 1
                        AVSTAT(LP,LCH,LIF) = STATE(LP,LCH,LIF)
                     ELSE
                        AVSTAT(LP,LCH,LIF) = 0.0
                        NASTAT(LP,LCH,LIF) = 0
                        END IF
 220                 CONTINUE
 230              CONTINUE
 240           CONTINUE
            AVTIME = TIME
            LTIME = TIME
            AVTIMI = TIMINT
            IF (CABCAL.NE.DBLANK) THEN
               AVCABC = CABCAL
               NACABC = 1
            ELSE
               NACABC = 0
               AVCABC = 0.0D0
               END IF
C                                       add in this record
         ELSE
            DO 340 LIF = 1,PCNIF
               DO 330 LP = 1,PCNPOL
                  DO 310 LCH = 1,NUMTON
                     IF (PCREAL(LP,LCH,LIF).NE.FBLANK) THEN
                        NAREAL(LP,LCH,LIF) = NAREAL(LP,LCH,LIF) + 1
                        AVREAL(LP,LCH,LIF) = AVREAL(LP,LCH,LIF) +
     *                     PCREAL(LP,LCH,LIF)
                        AVIMAG(LP,LCH,LIF) = AVIMAG(LP,LCH,LIF) +
     *                     PCIMAG(LP,LCH,LIF)
                        AVRATE(LP,LCH,LIF) = AVRATE(LP,LCH,LIF) +
     *                     PCRATE(LP,LCH,LIF)
                        END IF
                     AVFREQ(LP,LCH,LIF) = AVFREQ(LP,LCH,LIF) +
     *                  PCFREQ(LP,LCH,LIF)
 310                 CONTINUE
                  DO 320 LCH = 1,4
                     IF (STATE(LP,LCH,LIF).NE.FBLANK) THEN
                        NASTAT(LP,LCH,LIF) = NASTAT(LP,LCH,LIF) + 1
                        AVSTAT(LP,LCH,LIF) = AVSTAT(LP,LCH,LIF) +
     *                     STATE(LP,LCH,LIF)
                        END IF
 320                 CONTINUE
 330              CONTINUE
 340           CONTINUE
            NAVG = NAVG + 1
            AVTIME = AVTIME + TIME
            AVTIMI = AVTIMI + TIMINT
            IF (CABCAL.NE.DBLANK) THEN
               AVCABC = AVCABC + CABCAL
               NACABC = NACABC + 1
               END IF
            END IF
 400     CONTINUE
C                                       done - close up files
 900  CALL TABPC ('CLOS', PCBUFF, PCROW, PCKOLS, PCNUMV, PCNPOL, TIME,
     *   TIMINT, SOUNUM, ANTNUM, ISUB, FREQID, CABCAL,STATE, PCFREQ,
     *   PCREAL, PCIMAG, PCRATE, IRET)
      CALL TABPC ('CLOS', OUBUFF, OUTROW, PCKOLS, PCNUMV, PCNPOL,
     *   AVTIME, AVTIMI, LSOUR, LANT, LSUB, LFREQ, AVCABC, AVSTAT,
     *   AVFREQ, AVREAL, AVIMAG, AVRATE, IRET)
      SOLINT = -SOLINT * 86400.0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PCAVGF: ERROR',I5,' ON ',A)
      END
      SUBROUTINE PCAVHI
C-----------------------------------------------------------------------
C   PCAVHI adds to the history file of the input UV data set info on
C   what was flagged.  It then removes that flagging info from the
C   flag command file and from the master grid, when these are kept in
C   the image catalog.
C-----------------------------------------------------------------------
C
      CHARACTER HILINE*72, CTIME(2)*12
      INTEGER   HLUNI, IERR, ITIME(3), DATE(3)
      INCLUDE 'PCAVG.INC'
      INCLUDE 'PCDATA.INC'
      INCLUDE 'INCS:DHIS.INC'
      DATA HLUNI /28/
C-----------------------------------------------------------------------
      CALL HIINIT (3)
      CALL HIOPEN (HLUNI, DISKIN, CNOIN, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (ITIME)
      CALL TIMDAT (ITIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,1000) TSKNAM, RLSNAM, CTIME
      CALL HIADD (HLUNI, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       solint
      IF (SOLINT.GT.0.0) THEN
         WRITE (HILINE,1010) TSKNAM, SOLINT
      ELSE
         WRITE (HILINE,1011) TSKNAM, -SOLINT
         END IF
      CALL HIADD (HLUNI, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       output version
      WRITE (HILINE,1015) TSKNAM, OUTVER
      CALL HIADD (HLUNI, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      MSGTXT = HILINE(7:)
      CALL MSGWRT (2)
C                                       records written
      WRITE (HILINE,1020) TSKNAM, OUTROW-1
      CALL HIADD (HLUNI, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      MSGTXT = HILINE(7:)
      CALL MSGWRT (2)
C                                       Close HI file
 100  CALL HICLOS (HLUNI, .TRUE., BUFFER, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A9,2X,A8)
 1010 FORMAT (A6,'SOLINT=',F6.1,'  / general averaging time in seconds')
 1011 FORMAT (A6,'SOLINT=',F6.1,
     *   '  / interval averaging time in seconds')
 1015 FORMAT (A6,'OUTVERS=',I5,'  / output PC table version')
 1020 FORMAT (A6,'/  wrote',I8,' records in the output PC table')
      END
      SUBROUTINE GETNDX (LUN, DISK, CNO, CATBLK, ISUB, BUFFER, NOSCAN,
     *   TSCAN)
C-----------------------------------------------------------------------
C   GETNX reads the NX table and makes a list of scan start and stop
C   Inputs:
C      LUN      I      LUN to use
C      DISK     I      Disk number
C      CNO      I      Catalog number
C      CATBLK   I(*)   Header
C      ISUB     I      Limit to subarray ISUB - 0 -> all
C   Outputs
C      BUFFER   I(*)   Scratch buffer
C      NOSCAN   I      Number of times in TSCAN
C      TSCAN    R(*)   Time of scan boundaries
C-----------------------------------------------------------------------
      INTEGER   LUN, DISK, CNO, CATBLK(256), ISUB, BUFFER(*), NOSCAN
      REAL      TSCAN(2,*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   VER, INXRNO, NXKOLS(MAXNXC), NXNUMV(MAXNXC), IERR,
     *   IDSOUR, SUBARR, VSTART, VEND, FREQID, NROW, IROW
      REAL      TIME, DTIME, TEPS
      INCLUDE 'INCS:DMSG.INC'
C                                       0.1 seconds
      DATA TEPS /1.2e-6/
C-----------------------------------------------------------------------
      VER = 1
      CALL NDXINI ('READ', BUFFER, DISK, CNO, VER, CATBLK, LUN, INXRNO,
     *   NXKOLS, NXNUMV, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING INDEX TABLE'
         GO TO 900
         END IF
      NROW = BUFFER(5)
      NOSCAN = 0
      DO 100 IROW = 1,NROW
         CALL TABNDX ('READ', BUFFER, INXRNO, NXKOLS, NXNUMV, TIME,
     *      DTIME, IDSOUR, SUBARR, VSTART, VEND, FREQID, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READING INDEX TABLE'
            GO TO 900
            END IF
         IF ((ISUB.LE.0) .OR. (SUBARR.LE.0) .OR. (ISUB.EQ.SUBARR)) THEN
            NOSCAN = NOSCAN + 1
            DTIME = DTIME / 2.0 + TEPS
            TSCAN(1,NOSCAN) = TIME - DTIME
            TSCAN(2,NOSCAN) = TIME + DTIME
            END IF
 100     CONTINUE
C
 900  IF (IERR.NE.0) THEN
         CALL MSGWRT (6)
         NOSCAN = 0
         END IF
      CALL TABNDX ('CLOS', BUFFER, INXRNO, NXKOLS, NXNUMV, TIME, DTIME,
     *   IDSOUR, SUBARR, VSTART, VEND, FREQID, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETNDX ERROR',I4,' ON ',A)
      END

      SUBROUTINE CAINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IERR)
C-----------------------------------------------------------------------
C! creates and intializes a CAlibration table.
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2000, 2006, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes antenna characteristics tables.
C   Inputs:
C      OPCODE         C*4  Operation code:
C                          'WRIT' = create/init for write or read
C                          'READ' = open for read only
C      BUFFER(512)    I    I/O buffer and related storage, also defines
C                          file if open.
C      DISK           I    Disk to use.
C      CNO            I    Catalog slot number
C      CATBLK(256)    I    Catalog header block.
C      LUN            I    Logical unit number to use
C   In/out:
C      VER            I    CA file version
C   Input/output via common (file keywords):
C      OBSCOD         C*8  Observing code.
C      NOSTKD         I    No. polzns. in data.
C      STK1           I    First Stokes' parameter in data.
C      NOBAND         I    Number of bands (=IFs) in data.
C      NOCHAN         I    Number of spectral channels in data.
C      REFFRQ         D    Freq. at reference pixel (Hz)
C      CHNBW          R    Bandwidth of single spectral channel (Hz)
C      REFPIX         R    Reference pixel
C      NOANT          I    Number of antennas for which there is info.
C      NOPOL          I    Number of polarisations (R or L) in the
C                                                               table.
C
C      TABREV         I    Table revision number.
C                          Revision 1 - table invented,
C                            BJ, Feb 19, 1991
C
C      CANUMV(MAXCAC) I    Element count in each column. On input only
C                          used if the file is created.
C   Output:
C      ICARNO         I    Next row number, start of the file if READ,
C                          the last+1 if WRITE
C      CAKOLS(MAXCAC) I    The column pointer array in order:
C                          TIME, TIME INTERVAL, SOURCE ID, ANTENNA NO.,
C                          ARRAY, FREQID,
C                            --- Polarisation 1 ---
C                          TSYS1, TANT1, SENSITIVITY1, PHASE1, RATE1,
C                          DELAY1, REAL1, IMAG1, WEIGHT1, REFANT1,
C                           + these if there are two polarisations
C                           e.g. R,L or X,Y
C                            --- Polarisation 2 ---
C                          TSYS2, TANT2, SENSITIVITY2, PHASE2, RATE2,
C                          DELAY2, REAL2, IMAG2, WEIGHT2, REFANT2,
C      IERR           I    Return error code, 0=>OK, else TABINI or
C                          TABIO error.
C----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DGLB.INC'
C                                       Input variables
      CHARACTER OPCODE*4
      INTEGER   BUFFER(*), DISK, CNO, VER, CATBLK(256), LUN, IERR
C                                       Local variables
      INTEGER   I, ITEMP(6), JERR, NTT, ITRIM, NC
      LOGICAL   T, DOREAD, NEWFIL
      HOLLERITH HOLTMP(6)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (HOLTMP, ITEMP)
      INCLUDE 'INCS:DCAV.INC'
      CHARACTER  KEYW(NKEYCA)*8, TITLE(MAXCAC)*24, UNITS(MAXCAC)*8,
     *   TTITLE*56
C                                       CA and generic data statements
      DATA NTT /18/
      DATA TTITLE /'CALIBRATION TABLE'/
C                                       Table column titles
      DATA TITLE /'TIME', 'TIME_INTERVAL', 'SOURCE_ID', 'ANTENNA_NO',
     *   'ARRAY', 'FREQID',
C                                       Polarisation 1
     *   'TSYS_1', 'TANT_1', 'SENSITIVITY_1', 'PHASE_1',
     *   'RATE_1', 'DELAY_1', 'REAL_1', 'IMAG_1', 'WEIGHT_1',
     *   'REFANT_1',
C                                       Polarisation 2
     *   'TSYS_2', 'TANT_2', 'SENSITIVITY_2', 'PHASE_2',
     *   'RATE_2', 'DELAY_2', 'REAL_2', 'IMAG_2', 'WEIGHT_2',
     *   'REFANT_2'/
C
C                                       Units of table columns
      DATA UNITS /2*'DAYS', 4*' ',
C                                       Polarisation 1
     *   2*'KELVIN', 'K/JY', 'RADIANS', 'SEC/SEC', 'SECONDS',
     *   4*' ',
C                                       Polarisation 2
     *   2*'KELVIN', 'K/JY', 'RADIANS', 'SEC/SEC', 'SECONDS',
     *   4*' '/
C
C                                       Header keywords
      DATA KEYW /'OBSCODE ', 'NO_STKD ', 'STK_1   ', 'NO_BAND ',
     *   'NO_CHAN ', 'REF_FREQ', 'CHAN_BW ', 'REF_PIXL',
     *   'NO_ANT  ', 'NO_POL  ', 'TABREV  ' /
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Set up needed variables
      NREC = 30
      NCOL = MAXCAC
      NKEY = NKEYCA
C                                       Fill in types, lengths
C                                       See Going AIPS Vol 2 p13-3.
      IF (.NOT.DOREAD) THEN
         DTYP(KTIM) = TABDBL  + 10
         DTYP(KINT) = TABFLT  + 10
         DTYP(KSID) = TABINT + 10
         DTYP(KANT) = TABINT + 10
         DTYP(KARR) = TABINT + 10
         DTYP(KFID) = TABINT + 10
         DTYP(KTA1) = TABFLT  + 10 * NOBAND
         DTYP(KTS1) = TABFLT  + 10 * NOBAND
         DTYP(KSE1) = TABFLT  + 10 * NOBAND
         DTYP(KPH1) = TABFLT  + 10 * NOBAND
         DTYP(KRT1) = TABFLT  + 10 * NOBAND
         DTYP(KDY1) = TABFLT  + 10 * NOBAND
         DTYP(KRL1) = TABFLT  + 10 * NOBAND
         DTYP(KIM1) = TABFLT  + 10 * NOBAND
         DTYP(KWT1) = TABFLT  + 10 * NOBAND
         DTYP(KRF1) = TABINT + 10 * NOBAND
         DTYP(KTA2) = TABFLT  + 10 * NOBAND
         DTYP(KTS2) = TABFLT  + 10 * NOBAND
         DTYP(KSE2) = TABFLT  + 10 * NOBAND
         DTYP(KPH2) = TABFLT  + 10 * NOBAND
         DTYP(KRT2) = TABFLT  + 10 * NOBAND
         DTYP(KDY2) = TABFLT  + 10 * NOBAND
         DTYP(KRL2) = TABFLT  + 10 * NOBAND
         DTYP(KIM2) = TABFLT  + 10 * NOBAND
         DTYP(KWT2) = TABFLT  + 10 * NOBAND
         DTYP(KRF2) = TABINT + 10 * NOBAND
         CALL COPY (NCOL, DTYP, DATP(1,2))
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'CA', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'CAINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
C                                       Get number of records
      ICARNO = BUFFER(5) + 1
      IF (DOREAD) ICARNO = 1
      NKEY = NKEYCA
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 40 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'CAINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'CAINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       Set keyword values
         CALL CAIO ('WRIT', KEYVAL, IERR)
         IF (IERR.GT.0) THEN
            CALL TABERR ('WRIT', 'CAIO', 'CAINI', IERR)
            GO TO 990
            END IF
C                                       Write if just created
         CALL TABKEY (OPCODE, KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR (OPCODE, 'TABKEY', 'CAINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'CAINI', IERR)
            GO TO 990
            END IF
C                                       Retrieve keyword values
         CALL CAIO ('READ', KEYVAL, IERR)
         IF (IERR.GT.0) THEN
            CALL TABERR ('READ', 'CAIO', 'CAINI', IERR)
            GO TO 990
            END IF
         END IF
      IERR = 0
C                                       Get array indices
C                                       Cover your ass from FNDCOL -
C                                       close to flush the buffers and
C                                       then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KEYVAL, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'CAINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'CA', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'CAINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (MAXCAC, TITLE, 24, T, BUFFER, CAKOLS, JERR)
C                                       Get array indices and no. values
      DO 150 I = 1,MAXCAC
         IPOINT = CAKOLS(I)
         IF (IPOINT.GT.0) THEN
            CAKOLS(I) = DATP(IPOINT,1)
            CANUMV(I) = DATP(IPOINT,2) / 10
            IF (CANUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            CAKOLS(I) = -1
            CANUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('CAINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('CAINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('CAINI: ERROR INITIALIZING CALIBRATION (CA) TABLE FOR ',
     *   A4)
      END

      SUBROUTINE CHR2H (NCH, ISTR, OUTPNT, OSTR)
C-----------------------------------------------------------------------
C! converts a Fortran CHARACTER variable to an AIPS HOLLERITH string
C# Character
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Convert a Fortran CHARACTER variable to an AIPS HOLLERITH string.
C   IF NCH > LEN (ISTR) then blank fill the rest.
C   Inputs:
C      NCH     I      Number of characters
C      ISTR    C*(*)  Input CHARACTER string
C      OUTPNT  I      Start position in output string
C   Output:
C      OSTR    H(*)   Output AIPS string
C-----------------------------------------------------------------------
      INTEGER   NCH, OUTPNT
      CHARACTER ISTR*(*)
      HOLLERITH OSTR(*)
C
      INTEGER   NA, I, J1, J2, IT, NLEN
C-----------------------------------------------------------------------
      NLEN = LEN (ISTR)
      IF (NCH.LE.0) GO TO 999
         NA = MAX (1, OUTPNT)
         DO 10 I = 1,NCH
            J1 = (NA-1) / 4 + 1
            J2 = MOD (NA-1, 4) + 1
            IF (I.LE.NLEN) THEN
               IT = ICHAR (ISTR(I:I))
            ELSE
               IT = ICHAR (' ')
               END IF
            CALL ZPUTCH (IT, OSTR(J1), J2)
            NA = NA + 1
 10         CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ZEXPN2 (FCB, MAP, NRECS, IERR)
C-----------------------------------------------------------------------
C! expand an open disk file
C# Z2 IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Expands an open disk file, reserving the disk space.
C   Inputs:
C      FCB     I(*)   File control block for opened disk file
C      MAP     I      Double buffer file? 1 => yes, 0 => no
C   In/out:
C      NRECS   I      In:  number of 256-integer records to expand
C                     Out: number of records expanded
C   Output:
C      IERR    I      Error return code: 0 => no error
C                        1 => error
C   Generic version - stub
C--------------------------------------------------------------------
      INTEGER   FCB(*), MAP, NRECS, IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'ZEXPN2: REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (9)
C
 999  RETURN
      END

      SUBROUTINE IENHNS (ICHAN, ICOLOR, ITYPE, RPOS, BUFFER, IERR)
C-----------------------------------------------------------------------
C! interactive linear enhancement of TV black & white LUTs
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2009, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   IENHNS performs an interactive linear enhancement of TV LUTs.
C   X cursor => intercept, Y cursor => slope, high button => quit
C   Inputs:
C      ICHAN   I          channel select bit mask
C      ICOLOR  I          color select bit mask
C   In/Out:
C      ITYPE   I          on in: 1 => do plot, A, B switch plot
C                                     C switch sign of slope
C                                2 => no plot, A, B return
C                                     C switch sign of slope
C                                3 => no plot, return any button
C                         on out - button value
C      RPOS    R(2)       Cursor position: initial -> final
C   Output:
C      BUFFER  I(>3072)   Scratch buffer
C      IERR    I          Error code of ZM70XF: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   ICHAN, ICOLOR, ITYPE, BUFFER(*), IERR
      REAL      RPOS(2)
C
      CHARACTER ON*4, OFF*4, GROP(2)*4, SUBR*6, OP*4
      INTEGER   IG, IG1, NPIXX, IX, IY, IX0, IY0, IOP, IBLK(9), JBLK(9),
     *   IBUT, IFLIP, QUAD, JERR, ITW(3), I, J, IPLSIZ, ISZX, ISZY,
     *   MAG, NPIXY
      LOGICAL   T, F, DOPLT, PLOTIT, DOIT, WASON
      REAL      PPOS(2), X, SLOPE, OFFSET, RAXINT, RVAL, XSCALE, YSCALE,
     *   TEMP, POW, F0, TMAG
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      EQUIVALENCE (ON, GROP(1)),   (OFF, GROP(2))
      DATA GROP /'ONNN','OFFF'/
      DATA T, F /.TRUE.,.FALSE./
      DATA POW /1.33/
C-----------------------------------------------------------------------
C                                        plot preparations
      PLOTIT = (ITYPE.EQ.1) .AND. (NGRAPH.GT.0)
      DOPLT = PLOTIT
      WASON = .TRUE.
      ISZX = WINDTV(3) - WINDTV(1) + 1
      ISZY = WINDTV(4) - WINDTV(2) + 1
      IF (PLOTIT) THEN
         DOPLT = F
         IG1 = MAX (2, NGRAPH) - 1
         IG = IG1 + NGRAY
         I = TVLIMG(1) / (2 ** (IG-1))
         WASON = MOD(I,2).EQ.1
         CALL YHOLD ('ONNN', IERR)
         SUBR = 'YSLECT'
         CALL YSLECT ('OFFF', IG, 0, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 900
C                                        set up plot area
         MAG = 1 + TVZOOM(1)
         IF (MXZOOM.GT.0) MAG = 2 ** TVZOOM(1)
         IPLSIZ = (MAXINT + 1) / 2
         IF (IPLSIZ.GT.ISZX/4) IPLSIZ = ISZX / 4
         IF (IPLSIZ.GT.ISZY/4) IPLSIZ = ISZY / 4
         IF (IPLSIZ.LT.ISZX/16) IPLSIZ = ISZX / 16
         IF (IPLSIZ.LT.ISZY/16) IPLSIZ = ISZY / 16
         IPLSIZ = MIN (IPLSIZ, ISZX/MAG-3*CSIZTV(1))
         IPLSIZ = MIN (IPLSIZ, ISZY/MAG-3*CSIZTV(1))
         XSCALE = REAL (IPLSIZ) / (MAXINT+1.0)
         YSCALE = REAL (IPLSIZ) / (LUTOUT+1.0)
         NPIXY = IPLSIZ + 2.5*CSIZTV(2)
         IY0 = WINDTV(4) - MAG*NPIXY + 1 - (MAG-1)/2
         IF (MAG.GT.1) IY0 = IY0 + MAG
         IY0 = (IY0 - TVZOOM(3)) / MAG + TVZOOM(3) - TVSCGY
         NPIXX = IPLSIZ + 2.5*CSIZTV(1)
         TMAG = MAG
         IX0 = WINDTV(1) - (MAG-1)/2
         IX0 = (IX0 - TVZOOM(2)) / MAG + TVZOOM(2)
         IX0 = IX0 + ISZX / MAG - NPIXX - TVSCGX
         IX0 = MOD (IX0+4*MAXXTV(1)-1, MAXXTV(1)) + 1
         IY0 = MOD (IY0+4*MAXXTV(2)-1, MAXXTV(2)) + 1
         IF (IX0+NPIXX.GT.MAXXTV(1)) IX0 = MAXXTV(1) - NPIXX
         IF (IY0+NPIXY.GT.MAXXTV(2)) IY0 = MAXXTV(2) - NPIXY
         SUBR = 'YZERO'
         CALL YZERO (IG, IERR)
         IF (IERR.NE.0) GO TO 900
C                                        label, prepare init line
         IX = IX0 + IPLSIZ/2 + 0.5*CSIZTV(1) + 0.5
         IY = IY0 + IPLSIZ/2 + 2*CSIZTV(2)
         SUBR = 'IMCHAR'
         CALL IMCHAR (IG, IX, IY0, 0, 0, 'IN', BUFFER, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL IMCHAR (IG, IX0, IY, 3, 0, 'OUT', BUFFER, IERR)
         IF (IERR.NE.0) GO TO 900
         IX0 = IX0 + 1.5*CSIZTV(1) - 1
         IY0 = IY0 + 1.5*CSIZTV(2) - 1
         IX = 1 + IX0
         IY = IPLSIZ + IX0
         IBLK(1) = IX
         IBLK(2) = IY
         IBLK(3) = IY
         IBLK(4) = IX
         IBLK(5) = IX
         IBLK(6) = IX
         IBLK(7) = IX
         IBLK(8) = IY
         IBLK(9) = IY
         IX = 1 + IY0
         IY = IPLSIZ + IY0
         JBLK(1) = IX
         JBLK(2) = IX
         JBLK(3) = IY
         JBLK(4) = IY
         JBLK(5) = IX
         JBLK(6) = IX
         JBLK(7) = IX
         JBLK(8) = IY
         JBLK(9) = IY
         SUBR = 'IMVECT'
         CALL IMVECT (ON, IG, 9, IBLK, JBLK, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL YHOLD ('OFFF', IERR)
         END IF
C                                        init values, on cursor
      F0 = (WINDTV(4) - WINDTV(2)) / 3.
      IF ((RPOS(1).GE.WINDTV(1)) .AND. (RPOS(1).LE.WINDTV(3)) .AND.
     *   (RPOS(2).GE.WINDTV(2)) .AND. (RPOS(2).LE.WINDTV(4))) GO TO 37
         RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
         RPOS(2) = F0 + WINDTV(2)
 37   PPOS(1) = 0.0
      PPOS(2) = 0.0
      IFLIP = 1
      CALL ZTIME (ITW)
      QUAD = -1
      CALL YCURSE (ON, F, F, RPOS, QUAD, IBUT, IERR)
      SUBR = 'YCURSE'
      IF (IERR.NE.0) GO TO 900
C                                        read loop
 40   CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IERR)
      SUBR = 'YCURSE'
      IF ((IBUT.GT.7) .OR. (IERR.NE.0)) GO TO 900
      IF ((ITYPE.EQ.3) .AND. (IBUT.GT.0)) GO TO 900
      IF ((ITYPE.EQ.2) .AND. ((IBUT.EQ.1) .OR. (IBUT.EQ.2))) GO TO 900
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF (.NOT.DOIT) GO TO 40
C                                       plot on/off button C
         IF ((IBUT.EQ.4) .OR. (.NOT.PLOTIT) .OR. (IBUT.EQ.0)) GO TO 50
            JERR = 0
            IBUT = IBUT - 4
            DOPLT = .NOT.DOPLT
            IOP = 2
            IF (DOPLT) IOP = 1
            SUBR = 'YSLECT'
            CALL YSLECT (GROP(IOP), IG, 0, BUFFER, IERR)
            IF ((IERR.NE.0) .OR. (JERR.NE.0)) GO TO 900
C                                        new LUT
 50      IF (IBUT.GT.0) IFLIP = -IFLIP
         J = MAXINT + 1
         RAXINT = LUTOUT
         X = ((RPOS(1)-WINDTV(1)+1.) / REAL (ISZX) - 0.5)
     *      * 2.0 * MAXINT
         SLOPE = ((RAXINT+1.)/(MAXINT+1.)) * IFLIP *
     *      (F0 / MAX (1., RPOS(2)-WINDTV(2))) ** POW
         OFFSET = ((1.0-X) * SLOPE + LUTOUT * (1-IFLIP) / 2) - 1
         DO 60 I = 1,J
            RVAL = (I-1)*SLOPE + OFFSET + 0.5
            BUFFER(I) = MAX (1.0, MIN (RAXINT, RVAL))
 60         CONTINUE
         BUFFER(1) = 0
         SUBR = 'YLUT'
         CALL YHOLD ('ONNN', IERR)
         CALL YLUT ('WRIT', ICHAN, ICOLOR, T, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 900
C                                        update line plot
         IF (DOPLT) THEN
            CALL IMVECT (OFF, IG, 9, IBLK, JBLK, BUFFER(MAXINT+2),
     *         IERR)
            SUBR = 'IMVECT'
            IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 900
            JBLK(6) = (2+BUFFER(2)) * YSCALE + IY0
            JBLK(9) = (2+BUFFER(MAXINT+1)) * YSCALE + IY0
            I = LUTOUT * (1-IFLIP) / 2
            TEMP = (I-OFFSET)/SLOPE + 1.0
            IF (TEMP.GT.MAXINT+1) TEMP = MAXINT + 1
            IX = TEMP + 0.01
            IX = MAX (2, IX)
            JBLK(7) = (2+BUFFER(IX)) * YSCALE + IY0
            IBLK(7) = (1+IX) * XSCALE + IX0
            I = LUTOUT * (1+IFLIP) / 2
            TEMP = (I-OFFSET)/SLOPE + 1.99
            IF (TEMP.GT.MAXINT+1) TEMP = MAXINT + 1
            IX = TEMP + 0.01
            IX = MAX (2, IX)
            JBLK(8) = (2+BUFFER(IX)) * YSCALE + IY0
            IBLK(8) = (1+IX) * XSCALE + IX0
            JBLK(6) = MIN (IPLSIZ+IY0, MAX (IY0 + 1, JBLK(6)))
            JBLK(7) = MIN (IPLSIZ+IY0, MAX (IY0 + 1, JBLK(7)))
            JBLK(8) = MIN (IPLSIZ+IY0, MAX (IY0 + 1, JBLK(8)))
            JBLK(9) = MIN (IPLSIZ+IY0, MAX (IY0 + 1, JBLK(9)))
            IBLK(7) = MIN (IPLSIZ+IX0, MAX (IX0 + 1, IBLK(7)))
            IBLK(8) = MIN (IPLSIZ+IX0, MAX (IX0 + 1, IBLK(8)))
            CALL IMVECT (ON, IG, 9, IBLK, JBLK, BUFFER, IERR)
            IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 900
            END IF
         CALL YHOLD ('OFFF', IERR)
         GO TO 40
C
C                                        off graphics & cursor
 900  IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1900) IERR, SUBR
         CALL MSGWRT (7)
         END IF
      ITYPE = IBUT
      CALL YCURSE (OFF, F, F, RPOS, QUAD, IBUT, JERR)
      IF (PLOTIT) THEN
         OP = 'OFFF'
C         IF (WASON) OP = 'ONNN'
         CALL YSLECT (OP, IG, 0, BUFFER, JERR)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('ERROR',I5,' GENERATED BY ',A)
      END

      SUBROUTINE ZMOUNT (MOUNT, IDRIVE, IDENS, MACHIN, RDRIVE, LMSG,
     *   SYSERR, IERR)
C-----------------------------------------------------------------------
C! mount or dismount magnetic tape device
C# Z Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Issue software mount or dismount for a given tape drive.
C   Inputs:
C      MOUNT    L       .TRUE. means mount, .FALSE. means dismount
C      IDRIVE   I       Tape drive number
C      IDENS    I       Density at which to mount tape (800, 1600, 6250)
C      MACHIN   C*(*)   Name of remote computer (iff TAPEn translates
C                       to REMOTE)
C      RDRIVE   I       Number of tape drive on remote machine (0->1)
C   Output:
C      LMSG     C*80    Message text: error or success (already
C                       reported)
C      SYSERR   I       System-level error code
C      IERR     I       Error return code: 0 => no error
C                          1 => error
C   VMS version - calls ZMOUN2 to do the real work.  It does not support
C   REMOTE tape drives.
C-----------------------------------------------------------------------
      LOGICAL   MOUNT
      INTEGER   IDRIVE, IDENS, RDRIVE, SYSERR, IERR
      CHARACTER MACHIN*(*),  LMSG*80
C
      INTEGER   IMOUNT, I, J, JTRIM
      CHARACTER HVAL*4, TAPLOG*8, XLATED*128
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
      SYSERR = 0
C                                       Valid drive?
      IF ((IDRIVE.LE.0) .OR. (IDRIVE.GT.NTAPED)) THEN
         IERR = 1
         WRITE (MSGTXT,1000) IDRIVE
         GO TO 995
         END IF
C                                       Valid density for MOUNT?
      IF (MOUNT) THEN
         IMOUNT = 1
         IF ((IDENS.NE.800) .AND. (IDENS.NE.1600) .AND. (IDENS.NE.6250))
     *      THEN
            IERR = 1
            WRITE (MSGTXT,1010) IDENS
            GO TO 995
            END IF
         CALL ZEHEX (IDRIVE, 4, HVAL)
         TAPLOG = 'TAPE' // HVAL(4:4)
         I = 5
         CALL ZTRLOG (I, TAPLOG, 128, XLATED, J, IERR)
         IF (IERR.EQ.0) THEN
            IF (XLATED.EQ.'REMOTE') THEN
               IERR = 8
               MSGTXT = 'ZMOUNT: REMOTE TAPES NOT SUPPORT IN VMS'
               GO TO 995
               END IF
            END IF
         TPNAME(IDRIVE) = 'LOCAL'
C                                        Dismounts:
      ELSE
         IMOUNT = 0
         TPNAME(IDRIVE) = ' '
         END IF
C                                        Local tape dismount/mount
      MSGTXT = ' '
      CALL ZMOUN2 (IMOUNT, IDRIVE, IDENS, NTAPED, NPOPS, NLUSER,
     *   LMSG, SYSERR, IERR)
      J = JTRIM (LMSG)
      IF ((LMSG.NE.' ') .AND. (LMSG.NE.TSKNAM)) THEN
         IF ((IERR.NE.0) .OR. (SYSERR.NE.0)) THEN
            MSGTXT = LMSG
            CALL MSGWRT (8)
         ELSE
            MSGTXT = LMSG(:J) // ' on local host'
            CALL MSGWRT (3)
            END IF
         END IF
      IF (SYSERR.NE.0) CALL ZERROR ('ZMOUN2', SYSERR, ' ', -999,
     *   .FALSE.)
      GO TO 999
C
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZMOUNT: INVALID INTAPE = ',I6)
 1010 FORMAT ('ZMOUNT: INVALID DENSITY = ',I6)
      END

      SUBROUTINE BOUNDS (A1, A2, B, IERR)
C-----------------------------------------------------------------------
C! prints message if 1 or 2 values are outside a specified range
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   This routine prints a warning message if an input value is below the
C   minimum or above a maximum value.
C   Input:  A1     R     Value to check for proper range.
C           A2     R     Value to check for proper range.
C           B(1)   R     Minimum allowed value.
C           B(2)   R     Maximum allowed value.
C   Output: IERR   I     Error: 0 ok, 1 A1 bad, 2 A2 bad, 3 both bad
C-----------------------------------------------------------------------
      REAL      A1, A2, B(2), TL, TH
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
      TL = 1.0E-5
      IF ((B(1).NE.0.0) .AND. (ABS(B(1)).LT.0.01)) TL = TL * ABS(B(1))
      TH = 1.0E-5
      IF ((B(2).NE.0.0) .AND. (ABS(B(2)).LT.0.01)) TH = TH * ABS(B(2))
C                                        A1 too small
      IF (A1-B(1).GE.-TL) GO TO 10
         IERR = 1
         WRITE (MSGTXT,1000) A1, B(1)
         IF (ABS(B(1)).LT.0.005) WRITE (MSGTXT,1001) A1, B(1)
         CALL MSGWRT (6)
         GO TO 20
C                                        A1 too big
 10   IF (A1-B(2).LT.TH) GO TO 20
         IERR = 1
         WRITE (MSGTXT,1010) A1, B(2)
         IF (ABS(B(2)).LT.0.005) WRITE (MSGTXT,1011) A1, B(2)
         CALL MSGWRT (6)
C                                        A2 too small
 20   IF (A1.EQ.A2) GO TO 999
      IF (A2-B(1).GE.-TL) GO TO 30
         IERR = 2 + IERR
         WRITE (MSGTXT,1000) A2, B(1)
         IF (ABS(B(1)).LT.0.005) WRITE (MSGTXT,1001) A2, B(1)
         CALL MSGWRT (6)
         GO TO 999
C                                        A2 too big
 30   IF (A1-B(2).LT.TH) GO TO 999
         IERR = 2 + IERR
         WRITE (MSGTXT,1010) A2, B(2)
         IF (ABS(B(2)).LT.0.005) WRITE (MSGTXT,1011) A2, B(2)
         CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('******  VALUE =',F12.4,' BELOW LIMIT',F12.4)
 1001 FORMAT ('******  VALUE =',1PE12.4,' BELOW LIMIT',1PE12.4)
 1010 FORMAT ('******  VALUE =',F12.4,' EXCEEDS LIMIT',F12.4)
 1011 FORMAT ('******  VALUE =',1PE12.4,' EXCEEDS LIMIT',1PE12.4)
      END

C   Object Manager Module
C-----------------------------------------------------------------------
C! Object Oriented AIPS Fortran Object manager library
C# Utility Object-Oriented
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1999, 2005, 2015, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This version of the Object manager uses c language routines to
C   allocate and manage the linked list and CATBLK storage for each
C   object.
C   Private data:
C     MAXCLS   PI           Number of classes defined.
C     MAXVKW   PI           Maximum number of virtual keywords.
C     VKWCLS   H*8(MAXCLS)  Class name for virtual keyword.
C     VKWNUM   I(MAXCLS)    Number of defined virtual keywords.
C     VKWTAB   I(7,MAXVKW,MAXCLS) Virtual keyword information array.
C                           The second dimension is per keyword and the
C                           third is per class.  The structure of the
C                           first dimension is:
C          Word  Type        Contents
C          ----  ----  --------------------------------------------
C           1     H     Keyword
C           3     I     Category
C           4     I     Pointer
C           5     I     Data type
C           6     I     Dim(1)
C           7     I     Dim(2)
C    Where
C    keyword:   name of the virtual keyword as HOLLERITH (2 words = 8
C               char)
C    category:  1 = in fixed portion of catalog header, pointer is
C               pointer into type dependent array.  D values must be
C               copied from R array
C               2 = in keyword/value portion of catalog header, some
C               restrictions apply (not more than 2 words of data).
C               3 = Special derived keywords read access only.  Pointer
C               specifies a class specific function.
C     pointer:  pointer to catalog header entry or function.
C     data type: 1,2,3,4,5 for D, R, C, I, L data types of associated
C               data.
C     dim       Dimensionality of value, an axis dimension of zero
C               means that that dimension and higher are undefined.  For
C               character strings the length of the string is the first
C               dimension.
C
C     VKTKEY   PI                VKWTAB col. number for keyword
C     VKTCAT   PI                VKWTAB col. number for category
C     VKTPNT   PI                VKWTAB col. number for pointer
C     VKTYPE   PI                VKWTAB col. number for data type
C     VKTDM1   PI                VKWTAB col. number for dimension 1
C     VKTDM2   PI                VKWTAB col. number for dimension 2
C
C   Shared data with Class I/O (CLASSIO.INC)
C      MAXIO   PI              Maximum number of I/O simultaneous
C                              streams
C      BUFSIZ  PI              Buffer size in words
C      OBUFFR  R(BUFSIZ,MAXIO) I/O buffers
C      BUFPNT  I(MAXIO)        Buffer pointer
C      OBJLUN  I(MAXIO)        LUNs for I/O
C      OBJFIN  I(MAXIO)        FTAB pointer for I/O
C      LUNUSE  L(100)          True if LUN=index allocated.
C
C   Public functions:
C      OBINIT (ierr)
C         Initialize Object manager.
C      OBVHKW (class, keyword, type, ierr)
C         Add a Catalog header keyword to the virtual keyword list.
C
C   Private functions:
C     INVINI (ierr)
C        Initialize virtual keywords for inputs class.
C     IMVINI (ierr)
C        Initialize virtual keywords for image class.
C     OBKEYV (objnum, keywrd, keypnt, ierr)
C        See if keyword is an object dependent, virtual keyword.
C     OBRGET (objnum, keywrd, type, dim, value, valuec, ierr)
C        Fetch the value (array) for a specified real (non-virtual)
C        keyword.
C
C   Shared functions with class modules:
C     OBCREA (name, class, ierr)
C        Associate an object slot with an object name.
C     OBFREE (name, ierr)
C        Free the object slot associated with an object.
C     OBNAME (name, objnum, ierr)
C        Look up the object slot number of object with name "name".
C     OBCLAS (obnum, clasno, name, ierr)
C        Look up the class number of object number objnum.
C     OBPUT (objnum, keywrd, type, dim, value, valuec, ierr)
C        Save an entry in an object creating it if necessary.
C     OBGET (objnum, keywrd, type, dim, value, valuec, ierr)
C        Fetch the value (array) for a specified keyword.
C     OBLUN (lun, ierr)
C        Find a free LUN.
C     OBLUFR (lun)
C        Releases an LUN
C     OBINFO (name, bufno, ierr)
C        Look up I/O stream associated with an object.
C     OBDSKC (name, disk, cno, ierr)
C        Return Disk and slot information for object.
C     OBHGET (name, cat, ierr)
C        Return catalog header record for an object.
C     OBHPUT (name, cat, ierr)
C        Store catalog header record for an object.
C     OBCOPY (namein, namout, ierr)
C        Copies one image to another.
C     OBOPEN (name, ierr)
C        Assigns a buffer.
C     OBCLOS (name, ierr)
C        Closes a buffer associated with an object.
C     OBC2H (string, dim1, dim2, holl)
C        Convert a string (possibly an array) to hollerith
C     OBH2C (holl, dim1, dim2, string)
C        Convert a hollerith (possibly an array) to a string.
C-----------------------------------------------------------------------
LOCAL INCLUDE 'OBJECT.INC'
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DMSG.INC'
LOCAL END
LOCAL INCLUDE 'VIRTKEYW.INC'
C                                       Virtual Keyword common
      INCLUDE 'INCS:OBJPARM.INC'
      INTEGER   VKWNUM(MAXCLS), VKWTAB(7,MAXVKW,MAXCLS)
      HOLLERITH VKWTAH(7,MAXVKW,MAXCLS)
      CHARACTER VKWCLS(MAXCLS)*8
      EQUIVALENCE (VKWTAB, VKWTAH)
      COMMON /VIRKEY/ VKWNUM, VKWTAB
      COMMON /VIRKEC/ VKWCLS
C                                       Column pointers in VKWTAB
      INTEGER   VKTKEY, VKTCAT, VKTPNT, VKTYPE, VKTDM1, VKTDM2
C                                       VKTKEY = KEYWORD (H)
      PARAMETER (VKTKEY = 1)
C                                       VKTCAT = category
      PARAMETER (VKTCAT = 3)
C                                       VKTPNT = pointer
      PARAMETER (VKTPNT = 4)
C                                       VKTYPE = data type
      PARAMETER (VKTYPE = 5)
C                                       VKTDM1 = dimension 1
      PARAMETER (VKTDM1 = 6)
C                                       VKTDM2 = dimension 2
      PARAMETER (VKTDM2 = 7)
LOCAL END
      SUBROUTINE OBINIT (IERR)
C-----------------------------------------------------------------------
C   Public function
C   Initialize Object manager and class I/O.
C   Outputs:
C      IERR   I  Return error code 0=>OK else failed to create class.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   LOOP
      INCLUDE 'OBJECT.INC'
      INCLUDE 'VIRTKEYW.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Initialize catalog pointers
      CALL VHDRIN
C                                       Init object information.
      CALL ZOINTD
C                                       Init I/O
      DO 100 LOOP = 1,MAXIO
C                                       Stream/buffer in use flag
         OBNUSE(LOOP) = .FALSE.
C                                       LUN
         OBJLUN(LOOP) = 0
C                                       FTAB pointer
         OBJFIN(LOOP) = 0
C                                       Buffer pointer
         BUFPNT(LOOP) = 0
C                                       Object associated with buffer
         BUFNAM(LOOP) = ' '
 100     CONTINUE
C                                       Init class information.
C                                       Virtual keywords.
      DO 150 LOOP = 1,MAXCLS
C                                       Number of keywords
         VKWNUM(LOOP) = 0
C                                       Class names
         VKWCLS(LOOP) = '        '
 150     CONTINUE
C                                       Input class (none)
      CALL INVINI (IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Image class
      CALL IMVINI (IERR)
      IF (IERR.NE.0) GO TO 999
C                                       UV data class
      CALL UVVINI (IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Internal flags if LUN used.
      DO 300 LOOP = 1,128
         LUNUSE(LOOP) = .FALSE.
 300     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE OBVHKW (CLASS, KEYWRD, TYPE, IERR)
C-----------------------------------------------------------------------
C   Public
C   Declare a task specific catalog header keyword.  This is only useful
C   for classes with underlying disk data structures.
C   Inputs:
C      CLASS   C*8   Object class
C      KEYWRD  C*8   Keyword
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C   Input/Output in common:
C      VKWCLS  H*8(MAXCLS)  Class name for virtual keyword.
C      VKWNUM  I(MAXCLS)    Number of defined virtual keywords.
C      VKWTAB  I(7,MAXVKW,MAXCLS) Virtual keyword information array.
C   Outputs:
C      IERR   I      Error code, 0=OK. 1 = table full, 2 =class not
C                    defined.
C-----------------------------------------------------------------------
      CHARACTER CLASS*8, KEYWRD*8
      INTEGER   TYPE, IERR
C
      INTEGER   CLASNO, I, J
      CHARACTER CTEMP*8
      INCLUDE 'OBJECT.INC'
      INCLUDE 'VIRTKEYW.INC'
C-----------------------------------------------------------------------
      IERR = 2
C                                       Find class number
      DO 20 I = 1,MAXCLS
         CLASNO = I
         IF (CLASS.EQ.VKWCLS(I)) GO TO 30
 20      CONTINUE
C                                       Did not find
      MSGTXT = 'OBVHKW: CLASS ' // CLASS // ' NOT DEFINED'
      CALL MSGWRT (7)
      GO TO 999
C                                       Is it already defined?
 30   J = VKWNUM(CLASNO)
      DO 40 I = 1,J
         CALL H2CHR (8, 1, VKWTAH(VKTKEY,I,CLASNO), CTEMP)
         IF (CTEMP.EQ.KEYWRD) GO TO 50
 40      CONTINUE
C                                       Is there room in table: NO
      IF (VKWNUM(CLASNO).GE.MAXVKW) THEN
         MSGTXT = 'OBVHKW: VIRTUAL KEYWORD TABLE FULL FOR CLASS ' //
     *      CLASS
         CALL MSGWRT (7)
         IERR = 1
         GO TO 999
C                                       Add entry to table
      ELSE
         VKWNUM(CLASNO) = VKWNUM(CLASNO) + 1
         I = VKWNUM(CLASNO)
         CALL CHR2H (8, KEYWRD, 1, VKWTAH(VKTKEY,I,CLASNO))
         END IF
C                                       insert new parameters
 50   VKWTAB(VKTCAT,I,CLASNO) = 2
      VKWTAB(VKTPNT,I,CLASNO) = 1
      VKWTAB(VKTYPE,I,CLASNO) = TYPE
      VKWTAB(VKTDM1,I,CLASNO) = 1
      IF (TYPE.EQ.3) VKWTAB(VKTDM1,I,CLASNO) = 8
      VKWTAB(VKTDM2,I,CLASNO) = 1
      IERR = 0
C
 999  RETURN
      END
      SUBROUTINE INVINI (IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Initialize virtual keywords for inputs class - none
C   Outputs:
C      IERR   I  Return error code 0=>OK else failed to create class.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   LOOP, CLSNUM
      INCLUDE 'OBJECT.INC'
      INCLUDE 'VIRTKEYW.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Find next class number
      DO 50 LOOP = 1,MAXCLS
         CLSNUM = LOOP
         IF (VKWCLS(LOOP).EQ.'        ') GO TO 100
 50      CONTINUE
C                                       No more classes available
      IERR = 1
      MSGTXT = 'NO MORE CLASSES CAN BE DEFINED'
      CALL MSGWRT (6)
      GO TO 999
C                                       Initialize to no virtual
C                                       keywords.
 100  VKWNUM(CLSNUM) = 0
C                                       Set class name
      VKWCLS(CLSNUM) = 'INPUTS  '
C
 999  RETURN
      END
      SUBROUTINE IMVINI (IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Initialize virtual keywords for image class.
C   Outputs:
C      IERR   I  Return error code 0=>OK else failed to create class.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER NOKW
C                                       NOKW = No. virtual keywords.
      PARAMETER (NOKW=36)
      INTEGER   LOOP, CLSNUM, NUMVKW, DATCAT(NOKW), DATYPE(NOKW),
     *   DATDM1(NOKW), DATDM2(NOKW)
      CHARACTER DATKEY(NOKW)*8
      INCLUDE 'OBJECT.INC'
      INCLUDE 'VIRTKEYW.INC'
      INCLUDE 'INCS:DHDR.INC'
C                     1           2          3          4
      DATA DATKEY /'OBJECT', 'TELESCOP', 'INSTRUME', 'OBSERVER',
C             5           6         7       8        9       10
     *   'DATE-OBS', 'DATE-MAP', 'BUNIT', 'NDIM', 'NAXIS', 'CTYPE',
C          11       12       13       14       15       16
     *   'CRVAL', 'CDELT', 'CRPIX', 'CROTA', 'EPOCH', 'DATAMAX',
C            17        18        19       20      21     22      23
     *   'DATAMIN', 'PRODUCT', 'NITER', 'BMAJ', 'BMIN', 'BPA', 'VELREF',
C            24        25         26       27          28        29
     *   'ALTRVAL', 'ALTRPIX', 'OBSRA', 'OBSDEC', 'RESTFREQ', 'XSHIFT',
C            30       31         32       33         34        35
     *   'YSHIFT', 'NAMCLSTY', 'IMSEQ', 'USERNO', 'EXTYPE', 'EXTVER',
C          36
     *   'BLANK'/
C                                       Category (1 for catalog stuff)
      DATA DATCAT /NOKW*1/
C                                       Data type 1=D, 2=R, 3=C, 4=I
C                  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18
      DATA DATYPE /3, 3, 3, 3, 3, 3, 3, 4, 4, 3, 1, 2, 2, 2, 2, 2, 2, 4,
C       19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36
     *   4, 2, 2, 2, 4, 1, 2, 1, 1, 1, 2, 2, 3, 4, 4, 3, 4, 2/
C                                       1st dimension
C                  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18
      DATA DATDM1 /8, 8, 8, 8, 8, 8, 8, 1, 7, 8, 7, 7, 7, 7, 1, 1, 1, 1,
C       19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36
     *   1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,20, 1, 1, 2,20, 1/
C                                       2nd dimension
C                  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18
      DATA DATDM2 /1, 1, 1, 1, 1, 1, 1, 1, 1, 7, 1, 1, 1, 1, 1, 1, 1, 1,
C       19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36
     *   1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,20, 1, 1/
C-----------------------------------------------------------------------
      IERR = 0
C                                       Find next class number
      DO 50 LOOP = 1,MAXCLS
         CLSNUM = LOOP
         IF (VKWCLS(LOOP).EQ.'        ') GO TO 100
 50      CONTINUE
C                                       No more classes available
      IERR = 1
      MSGTXT = 'NO MORE CLASSES CAN BE DEFINED'
      CALL MSGWRT (6)
      GO TO 999
C                                       Set class name
 100  VKWCLS(CLSNUM) = 'IMAGE   '
C                                       Initialize virtual keywords.
      NUMVKW = 0
      DO 200 LOOP = 1,NOKW
         NUMVKW = NUMVKW + 1
         CALL CHR2H (8, DATKEY(LOOP), 1, VKWTAH(VKTKEY,NUMVKW,CLSNUM))
         VKWTAB(VKTCAT,NUMVKW,CLSNUM) = DATCAT(LOOP)
         VKWTAB(VKTYPE,NUMVKW,CLSNUM) = DATYPE(LOOP)
         VKWTAB(VKTDM1,NUMVKW,CLSNUM) = DATDM1(LOOP)
         VKWTAB(VKTDM2,NUMVKW,CLSNUM) = DATDM2(LOOP)
 200     CONTINUE
      VKWNUM(CLSNUM) = NUMVKW
C                                       Pointers from include DHDR.INC
      VKWTAB(VKTPNT,1,CLSNUM) = KHOBJ
      VKWTAB(VKTPNT,2,CLSNUM) = KHTEL
      VKWTAB(VKTPNT,3,CLSNUM) = KHINS
      VKWTAB(VKTPNT,4,CLSNUM) = KHOBS
      VKWTAB(VKTPNT,5,CLSNUM) = KHDOB
      VKWTAB(VKTPNT,6,CLSNUM) = KHDMP
      VKWTAB(VKTPNT,7,CLSNUM) = KHBUN
      VKWTAB(VKTPNT,8,CLSNUM) = KIDIM
      VKWTAB(VKTPNT,9,CLSNUM) = KINAX
      VKWTAB(VKTPNT,10,CLSNUM) = KHCTP
      VKWTAB(VKTDM2,10,CLSNUM) = KICTPN
      VKWTAB(VKTPNT,11,CLSNUM) = KDCRV
      VKWTAB(VKTPNT,12,CLSNUM) = KRCIC
      VKWTAB(VKTPNT,13,CLSNUM) = KRCRP
      VKWTAB(VKTPNT,14,CLSNUM) = KRCRT
      VKWTAB(VKTPNT,15,CLSNUM) = KREPO
      VKWTAB(VKTPNT,16,CLSNUM) = KRDMX
      VKWTAB(VKTPNT,17,CLSNUM) = KRDMN
      VKWTAB(VKTPNT,18,CLSNUM) = KITYP
      VKWTAB(VKTPNT,19,CLSNUM) = KINIT
      VKWTAB(VKTPNT,20,CLSNUM) = KRBMJ
      VKWTAB(VKTPNT,21,CLSNUM) = KRBMN
      VKWTAB(VKTPNT,22,CLSNUM) = KRBPA
      VKWTAB(VKTPNT,23,CLSNUM) = KIALT
      VKWTAB(VKTPNT,24,CLSNUM) = KDARV
      VKWTAB(VKTPNT,25,CLSNUM) = KRARP
      VKWTAB(VKTPNT,26,CLSNUM) = KDORA
      VKWTAB(VKTPNT,27,CLSNUM) = KDODE
      VKWTAB(VKTPNT,28,CLSNUM) = KDRST
      VKWTAB(VKTPNT,29,CLSNUM) = KRXSH
      VKWTAB(VKTPNT,30,CLSNUM) = KRYSH
      VKWTAB(VKTPNT,31,CLSNUM) = KHIMN
      VKWTAB(VKTPNT,32,CLSNUM) = KIIMS
      VKWTAB(VKTPNT,33,CLSNUM) = KIIMU
      VKWTAB(VKTPNT,34,CLSNUM) = KHEXT
      VKWTAB(VKTDM2,34,CLSNUM) = KIEXTN
      VKWTAB(VKTPNT,35,CLSNUM) = KIVER
      VKWTAB(VKTDM1,35,CLSNUM) = KIEXTN
      VKWTAB(VKTPNT,36,CLSNUM) = KRBLK
C
 999  RETURN
      END
      SUBROUTINE UVVINI (IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Initialize virtual keywords for UVdata class.
C   Outputs:
C      IERR   I  Return error code 0=>OK else failed to create class.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER NOKW
C                                       NOKW = No. virtual keywords.
      PARAMETER (NOKW=38)
      INTEGER   LOOP, CLSNUM, NUMVKW, DATCAT(NOKW), DATYPE(NOKW),
     *   DATDM1(NOKW), DATDM2(NOKW)
      CHARACTER DATKEY(NOKW)*8
      INCLUDE 'OBJECT.INC'
      INCLUDE 'VIRTKEYW.INC'
      INCLUDE 'INCS:DHDR.INC'
C                     1           2          3          4
      DATA DATKEY /'OBJECT', 'TELESCOP', 'INSTRUME', 'OBSERVER',
C             5           6         7       8        9       10
     *   'DATE-OBS', 'DATE-MAP', 'BUNIT', 'NDIM', 'NAXIS', 'CTYPE',
C          11       12       13       14       15       16
     *   'CRVAL', 'CDELT', 'CRPIX', 'CROTA', 'EPOCH', 'GCOUNT',
C            17        18        19       20        21         22
     *   'NRPARM', 'PTYPE', 'SORTORD', 'VELREF', 'ALTRVAL', 'ALTRPIX',
C            23        24         25       26          27        28
     *   'OBSRA', 'OBSDEC', 'RESTFREQ', 'XSHIFT', 'YSHIFT', 'NAMCLSTY',
C            29       30         31       32      33      34
     *   'IMSEQ', 'USERNO', 'EXTYPE', 'EXTVER', 'LREC', 'NCORR',
C          35
     *   'TYPEUVD', 'BMAJ', 'BMIN', 'BPA'/
C                                       Category (1 for catalog stuff)
      DATA DATCAT /NOKW*1/
C                                       Data type 1=D, 2=R, 3=C, 4=I
C                  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18
      DATA DATYPE /3, 3, 3, 3, 3, 3, 3, 4, 4, 3, 1, 2, 2, 2, 2, 4, 4, 3,
C       19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35
     *   3, 4, 1, 2, 1, 1, 1, 2, 2, 3, 4, 4, 3, 4, 4, 4, 3, 2, 2, 2/
C                                       1st dimension
C                  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18
      DATA DATDM1 /8, 8, 8, 8, 8, 8, 8, 1, 7, 8, 7, 7, 7, 7, 1, 1, 1, 8,
C       19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35
     *   2, 1, 1, 1, 1, 1, 1, 1, 1,20, 1, 1, 2,20, 1, 1, 2, 1, 1, 1/
C                                       2nd dimension
C                  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17
      DATA DATDM2 /1, 1, 1, 1, 1, 1, 1, 1, 1, 7, 1, 1, 1, 1, 1, 1, 1,
C        18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35
     *   14, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/
C-----------------------------------------------------------------------
      IERR = 0
C                                       Find next class number
      DO 50 LOOP = 1,MAXCLS
         CLSNUM = LOOP
         IF (VKWCLS(LOOP).EQ.'        ') GO TO 100
 50      CONTINUE
C                                       No more classes available
      IERR = 1
      MSGTXT = 'NO MORE CLASSES CAN BE DEFINED'
      CALL MSGWRT (6)
      GO TO 999
C                                       Set class name
 100  VKWCLS(CLSNUM) = 'UVDATA   '
C                                       Derived keywords
C                                       LREC
      DATCAT(33) = 3
C                                       NCORR
      DATCAT(34) = 3
C                                       TYPEUVD
      DATCAT(35) = 3
C                                       Initialize virtual keywords.
      NUMVKW = 0
      DO 200 LOOP = 1,NOKW
         NUMVKW = NUMVKW + 1
         CALL CHR2H (8, DATKEY(LOOP), 1, VKWTAH(VKTKEY,NUMVKW,CLSNUM))
         VKWTAB(VKTCAT,NUMVKW,CLSNUM) = DATCAT(LOOP)
         VKWTAB(VKTYPE,NUMVKW,CLSNUM) = DATYPE(LOOP)
         VKWTAB(VKTDM1,NUMVKW,CLSNUM) = DATDM1(LOOP)
         VKWTAB(VKTDM2,NUMVKW,CLSNUM) = DATDM2(LOOP)
 200     CONTINUE
      VKWNUM(CLSNUM) = NUMVKW
C                                       Pointers from include DHDR.INC
      VKWTAB(VKTPNT,1,CLSNUM) = KHOBJ
      VKWTAB(VKTPNT,2,CLSNUM) = KHTEL
      VKWTAB(VKTPNT,3,CLSNUM) = KHINS
      VKWTAB(VKTPNT,4,CLSNUM) = KHOBS
      VKWTAB(VKTPNT,5,CLSNUM) = KHDOB
      VKWTAB(VKTPNT,6,CLSNUM) = KHDMP
      VKWTAB(VKTPNT,7,CLSNUM) = KHBUN
      VKWTAB(VKTPNT,8,CLSNUM) = KIDIM
      VKWTAB(VKTPNT,9,CLSNUM) = KINAX
      VKWTAB(VKTPNT,10,CLSNUM) = KHCTP
      VKWTAB(VKTDM2,10,CLSNUM) = KICTPN
      VKWTAB(VKTPNT,11,CLSNUM) = KDCRV
      VKWTAB(VKTPNT,12,CLSNUM) = KRCIC
      VKWTAB(VKTPNT,13,CLSNUM) = KRCRP
      VKWTAB(VKTPNT,14,CLSNUM) = KRCRT
      VKWTAB(VKTPNT,15,CLSNUM) = KREPO
      VKWTAB(VKTPNT,16,CLSNUM) = KIGCN
      VKWTAB(VKTPNT,17,CLSNUM) = KIPCN
      VKWTAB(VKTPNT,18,CLSNUM) = KHPTP
      VKWTAB(VKTDM2,18,CLSNUM) = KIPTPN
      VKWTAB(VKTPNT,19,CLSNUM) = KITYP
      VKWTAB(VKTPNT,20,CLSNUM) = KIALT
      VKWTAB(VKTPNT,21,CLSNUM) = KDARV
      VKWTAB(VKTPNT,22,CLSNUM) = KRARP
      VKWTAB(VKTPNT,23,CLSNUM) = KDORA
      VKWTAB(VKTPNT,24,CLSNUM) = KDODE
      VKWTAB(VKTPNT,25,CLSNUM) = KDRST
      VKWTAB(VKTPNT,26,CLSNUM) = KRXSH
      VKWTAB(VKTPNT,27,CLSNUM) = KRYSH
      VKWTAB(VKTPNT,28,CLSNUM) = KHIMN
      VKWTAB(VKTPNT,29,CLSNUM) = KIIMS
      VKWTAB(VKTPNT,30,CLSNUM) = KIIMU
      VKWTAB(VKTPNT,31,CLSNUM) = KHEXT
      VKWTAB(VKTDM2,31,CLSNUM) = KIEXTN
      VKWTAB(VKTPNT,32,CLSNUM) = KIVER
      VKWTAB(VKTDM1,32,CLSNUM) = KIEXTN
      VKWTAB(VKTPNT,36,CLSNUM) = KRBMJ
      VKWTAB(VKTPNT,37,CLSNUM) = KRBMN
      VKWTAB(VKTPNT,38,CLSNUM) = KRBPA
C
 999  RETURN
      END
      SUBROUTINE OBCREA (NAME, CLASS, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Associate an object slot with an object name
C   Inputs:
C      NAME    C*32  Name of object
C      CLASS   C*8   Object class
C   Outputs:
C      IERR    I     Error code, 0=OK, 1=None available
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), CLASS*(*)
      INTEGER   IERR
C
      INTEGER   LOOP, OBJNUM, CLSNUM
      CHARACTER TNAME*32, TCLASS*8
      HOLLERITH HNAME(8), HCLASS(2)
      INCLUDE 'OBJECT.INC'
      INCLUDE 'VIRTKEYW.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Create object storage
      TNAME = NAME
      TCLASS = CLASS
      CALL CHR2H (32, TNAME, 1, HNAME)
      CALL CHR2H (8, TCLASS, 1, HCLASS)
      CALL ZOCROB (HNAME, HCLASS, OBJNUM, IERR)
      IF (IERR.EQ.1) THEN
         MSGTXT = 'OBCREA: OBJECT TABLE FULL'
         GO TO 990
         END IF
      IF (IERR.EQ.2) THEN
         MSGTXT = 'OBCREA: MEMORY ALLOCATION FAILED'
         GO TO 990
         END IF
      IF (IERR.NE.0) THEN
         MSGTXT = 'OBCREA: OBJECT CREATION FAILED'
         GO TO 990
         END IF
C                                       Is Class already defined?
      DO 70 LOOP = 1,MAXCLS
         IF (VKWCLS(LOOP).EQ.CLASS) GO TO 999
 70      CONTINUE
C                                       No, find one to assign.
      DO 80 LOOP = 1,MAXCLS
         CLSNUM = LOOP
C                                       Set class name
         IF (VKWCLS(LOOP).EQ.' ') THEN
            VKWCLS(CLSNUM) = CLASS
            GO TO 999
            END IF
 80      CONTINUE
C                                       No more classes available
      IERR = 1
      MSGTXT = 'NO MORE CLASSES CAN BE DEFINED'
      CALL MSGWRT (6)
      MSGTXT = 'PROBLEM WITH OBJECT: ' // NAME
C                                       Error
 990  CALL MSGWRT (6)
      MSGTXT = 'OBCREA: PROBLEM CREATING: ' // NAME
      CALL MSGWRT (6)
C
 999  RETURN
      END
      SUBROUTINE OBFREE (NAME, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Frees up object slot associated with name "name" initializing the
C   arrays associated with that slot.
C   Inputs:
C      NAME   C*32  Name of object
C   Outputs:
C      IERR   I     Return error code, 0=OK.
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INTEGER   OBJNUM
      INCLUDE 'OBJECT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Find slot number
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Destroy
      CALL ZODEOB (OBJNUM)
C
 999  RETURN
      END
      SUBROUTINE OBNAME (NAME, OBJNUM, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Look up the object slot number of object with name "name".
C   Inputs:
C      NAME   C*32  Name of object
C   Outputs:
C      OBJNUM I     Object slot number
C      IERR   I     Error code, 0=OK, 1=could not find
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   OBJNUM, IERR
C
      CHARACTER TNAME*32
      HOLLERITH HNAME(8)
      INCLUDE 'OBJECT.INC'
C-----------------------------------------------------------------------
      IERR = 0
      TNAME = NAME
      CALL CHR2H (32, TNAME, 1, HNAME)
      CALL ZOFNOB (HNAME, OBJNUM)
      IF (OBJNUM.GT.0) GO TO 999
C                                       Not found
      IERR = 1
      OBJNUM = -1
      MSGTXT = 'OBJECT NAMED ' // NAME // ' IS NOT DEFINED'
      CALL MSGWRT (6)
      GO TO 999
C
 999  RETURN
      END
      SUBROUTINE OBCLAS (OBJNUM, CLASNO, CNAME, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Look up the class number of object number objnum.
C   Inputs:
C      OBJNUM I     Object slot number
C   Outputs:
C      CLASNO I     Class slot number.
C      CNAME  C*8   Class name
C      IERR   I     Error code, 0=OK, 1=could not find
C-----------------------------------------------------------------------
      INTEGER   OBJNUM, CLASNO, IERR
      CHARACTER CNAME*8
C
      INTEGER   LOOP
      HOLLERITH HNAME(8), HCLASS(2)
      CHARACTER TNAME*32
      INCLUDE 'OBJECT.INC'
      INCLUDE 'VIRTKEYW.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Get object class name
      TNAME = 'Unknown object'
      CALL ZOFENM (OBJNUM, HNAME, HCLASS, IERR)
      IF (IERR.EQ.4) THEN
         MSGTXT = 'OBCLAS: BAD OBJECT NUMBER'
         GO TO 990
         END IF
      IF (IERR.EQ.5) THEN
         MSGTXT = 'OBCLAS: OBJECT DOES NOT EXIST'
         GO TO 990
         END IF
      IF (IERR.NE.0) THEN
         MSGTXT = 'OBCLAS: ERROR FINDING CLASS'
         GO TO 990
         END IF
      CALL H2CHR (8, 1, HCLASS, CNAME)
      CALL H2CHR (32, 1, HNAME, TNAME)
C                                       Find class in VKWCLS
      DO 50 LOOP = 1,MAXCLS
         CLASNO = LOOP
         IF (VKWCLS(LOOP).EQ.CNAME) GO TO 999
 50      CONTINUE
C                                       Not found
      IERR = 1
      CLASNO = -1
      MSGTXT = 'CLASS NAMED ' // CNAME // ' IS NOT DEFINED'
C                                       Error
 990  CALL MSGWRT (6)
      MSGTXT = 'OBCLAS: PROBLEM WITH: ' // TNAME
      CALL MSGWRT (6)
      WRITE (MSGTXT,1990) OBJNUM
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1990 FORMAT ('OBCLAS: OBJECT NUMBER = ', I5)
      END
      SUBROUTINE OBKEYV (OBJNUM, KEYWRD, KEYPNT, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   See if keyword is an object dependent, virtual keyword.  Called by
C   OBVGET and OBVPUT.
C   Inputs:
C      OBJNUM  I     Object slot number
C      KEYWRD  C*8   Keyword
C   Outputs:
C      KEYPNT  I     Pointer in VKWTAB for virtual keyword.
C      IERR    I     Error code, 0=OK, 1 => not found.
C-----------------------------------------------------------------------
      CHARACTER KEYWRD*(*)
      INTEGER   OBJNUM, KEYPNT, IERR
C
      INTEGER   LOOP, CLASNO
      HOLLERITH TEST(2)
      CHARACTER CNAME*8
      INCLUDE 'OBJECT.INC'
      INCLUDE 'VIRTKEYW.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Lookup class number (CLASNO)
      CALL OBCLAS (OBJNUM, CLASNO, CNAME, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Convert KEYWRD to HOLLERITH
      CALL CHR2H (8, KEYWRD, 1, TEST)
C                                       Find KEYWORD in VKWTAH
      DO 50 LOOP = 1,VKWNUM(CLASNO)
         KEYPNT = LOOP
         IF ((TEST(1).EQ.VKWTAH(1,LOOP,CLASNO))
     *      .AND. (TEST(2).EQ.VKWTAH(2,LOOP,CLASNO))) GO TO 999
 50      CONTINUE
C                                       Not found
      IERR = 1
      GO TO 999
C
 999  RETURN
      END
      SUBROUTINE OBPUT (OBJNUM, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Save an entry in an object creating it if necessary.
C   Inputs:
C      OBJNUM  I     Object slot number
C      KEYWRD  C*8   Keyword
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of value, an axis dimension of zero
C                    means that that dimension and higher are undefined.
C      VALUE   ?     associated value (non character)
C      VALUEC  C(*)*?   associated value (character)
C   Outputs:
C      IERR    I     Error code, 0=OK.
C-----------------------------------------------------------------------
      INTEGER   OBJNUM, TYPE, DIM(*), IERR
      CHARACTER KEYWRD*(*), VALUEC(*)*(*)
      REAL      VALUE(*)
C
      INTEGER   NVAL, KEYPNT, CLASNO, DISK, CNO, CATPNT, DIM1, DIM2,
     *   NDIM, JERR
      HOLLERITH HTEMP(2), HKEY(2), HNAME(8), HCLASS(2)
      CHARACTER CNAME*8, TNAME*32
      INCLUDE 'OBJECT.INC'
      INCLUDE 'VIRTKEYW.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Size of value
      DIM1 = DIM(1)
      DIM2 = DIM(2)
      NVAL = DIM1 * DIM2
      IF (TYPE.EQ.1) NVAL = NVAL * NWDPDP
C                                       Virtual keyword?
      CALL OBKEYV (OBJNUM, KEYWRD, KEYPNT, IERR)
      IF (IERR.EQ.0) THEN
C                                       Get CATBLK
         CALL ZOFECT (OBJNUM, CATBLK, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR
            GO TO 990
            END IF
C                                       Find class number
         CALL OBCLAS (OBJNUM, CLASNO, CNAME, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Catalog header?
         IF (VKWTAB(VKTCAT,KEYPNT,CLASNO).EQ.1) THEN
C                                       Check type
            IF (TYPE.NE.VKWTAB(VKTYPE,KEYPNT,CLASNO)) THEN
               IERR = 2
               MSGTXT = 'WRONG KEYWORD DATA TYPE'
               GO TO 990
               END IF
C                                       Check dimensions
            IF ((DIM1.NE.VKWTAB(VKTDM1,KEYPNT,CLASNO)) .OR.
     *         (DIM2.NE.VKWTAB(VKTDM2,KEYPNT,CLASNO))) THEN
               IERR = 2
               MSGTXT = 'WRONG KEYWORD VALUE DIMENSIONALITY'
               GO TO 990
               END IF
C                                       Catalog header pointer
            CATPNT = VKWTAB(VKTPNT,KEYPNT,CLASNO)
C                                       Adjust for Double
            IF (TYPE.EQ.1) CATPNT = (CATPNT-1) * NWDPDP + 1
C                                       Character
            IF (TYPE.EQ.3) THEN
C                                       Check String length
               IF (LEN (VALUEC(1)) .GT. (4*HBFSZ)) THEN
                  IERR = 5
                  MSGTXT = 'OBPUT: EXCESSIVE STRING LENGTH, ARGUMENT'
     *               //  ' ERROR?'
                  GO TO 990
                  END IF
               CALL OBC2H (VALUEC, DIM1, DIM2, CATH(CATPNT))
C                                       Other
            ELSE
               CALL RCOPY (NVAL, VALUE, CATR(CATPNT))
               END IF
C                                       Store CATBLK
            CALL ZOSTCT (OBJNUM, CATBLK, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1001) IERR
               GO TO 990
               END IF
C                                       Catalog keyword?
         ELSE IF (VKWTAB(VKTCAT,KEYPNT,CLASNO).EQ.2) THEN
C                                       Limit on amount of data
            IF (TYPE.EQ.3) NVAL = NVAL / 4
            IF (NVAL.GT.2) THEN
               IERR = 2
               MSGTXT = 'ILLEGAL AMOUNT OF DATA FOR CATALOG KEYWORD.'
               GO TO 990
               END IF
C                                       Write keyword/value in header
            IF (TYPE.NE.3) THEN
C                                       Get DISK and CNO number.
               TNAME = 'Unknown object'
               CALL ZOFENM (OBJNUM, HNAME, HCLASS, JERR)
               IF (JERR.EQ.0) CALL H2CHR (32, 1, HNAME, TNAME)
               CALL OBDSKC (TNAME, DISK, CNO, IERR)
               IF (IERR.NE.0) GO TO 999
C                                       Non-character
               CALL CATKEY ('WRIT', DISK, CNO, KEYWRD, 1, 1, VALUE,
     *            TYPE, SBUFF, IERR)
               IF (IERR.GT.20) IERR = 1
               IF (IERR.NE.0) GO TO 999
            ELSE
C                                       Character
               CALL CHR2H (8, VALUEC, 1, HTEMP)
               CALL CATKEY ('WRIT', DISK, CNO, KEYWRD, 1, 1, HTEMP,
     *            TYPE, SBUFF, IERR)
               IF (IERR.GT.20) IERR = 1
               IF (IERR.NE.0) GO TO 999
               END IF
C                                       Derived keyword?
         ELSE IF (VKWTAB(VKTCAT,KEYPNT,CLASNO).EQ.3) THEN
C                                       Cannot write derived keyword
            IERR = 1
            MSGTXT = 'CANNOT WRITE A DERIVED KEYWORD'
            GO TO 990
C                                       Unknown category
         ELSE
            IERR = 1
            MSGTXT = 'UNKNOWN VIRTUAL KEYWORD CATEGORY'
            GO TO 990
            END IF
         GO TO 999
      ELSE
C                                       Real keyword
         NDIM = 2
         CALL CHR2H (8, KEYWRD, 1, HKEY)
         IF (TYPE.EQ.OOACAR) THEN
C                                       Copy characters to buffer
            IF (4*HBFSZ.LT.DIM1*DIM2) THEN
C                                       Buffer too small
               IERR = 2
               MSGTXT = 'OBPUT: HBUFF TOO SMALL'
               GO TO 990
               END IF
            CALL OBC2H (VALUEC, DIM1, DIM2, HBUFF)
            CALL ZOSTDT (OBJNUM, HKEY, TYPE, NDIM, DIM, HBUFF, IERR)
         ELSE
            CALL ZOSTDT (OBJNUM, HKEY, TYPE, NDIM, DIM, VALUE, IERR)
            END IF
         IF (IERR.EQ.1) THEN
            MSGTXT = 'OBPUT: BAD TYPE'
            GO TO 990
            END IF
         IF (IERR.EQ.2) THEN
            MSGTXT = 'OBPUT: BAD NUMBER OF DIMENSION'
            GO TO 990
            END IF
         IF (IERR.EQ.3) THEN
            MSGTXT = 'OBPUT: BAD DIMENSION ARRAY'
            GO TO 990
            END IF
         IF (IERR.EQ.4) THEN
            MSGTXT = 'OBPUT: BAD OBJECT NUMBER'
            GO TO 990
            END IF
         IF (IERR.EQ.5) THEN
            MSGTXT = 'OBPUT: OBJECT DOES NOT EXIST'
            GO TO 990
            END IF
         IF (IERR.EQ.6) THEN
            MSGTXT = 'OBPUT: ERROR ALLOCATING KEYWORD STORAGE'
            GO TO 990
            END IF
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
      MSGTXT = 'KEYWORD =' // KEYWRD
      CALL MSGWRT (6)
      TNAME = 'Unknown object'
      CALL ZOFENM (OBJNUM, HNAME, HCLASS, JERR)
      IF (JERR.EQ.0) CALL H2CHR (32, 1, HNAME, TNAME)
      MSGTXT = 'OBPUT: PROBLEM WITH OBJECT: ' // TNAME
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OBPUT: ERROR ', I5,' COPYING CATBLK')
 1001 FORMAT ('OBPUT: ERROR ', I5,' SAVING CATBLK')
      END
      SUBROUTINE OBRGET (OBJNUM, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Fetch the value (array) for a specified real (non-virtual) keyword.
C   Inputs:
C      OBJNUM  I     Object slot number
C      KEYWRD  C*8   Keyword
C   Outputs:
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of value, an axis dimension of zero
C                    means that that dimension and higher are undefined.
C      VALUE   ?     associated value (non character)
C      VALUEC  C(*)*?   associated value (character)
C      IERR    I     Error code, 0=OK.  1=> did not find.
C-----------------------------------------------------------------------
      INTEGER   OBJNUM, TYPE, DIM(*), IERR
      CHARACTER KEYWRD*(*), VALUEC(*)*(*)
      REAL      VALUE(*)
C
      INTEGER   DIM1, DIM2, OTYPE, ONDIM, ODIM(5), JERR
      CHARACTER TNAME*32
      HOLLERITH HKEY(2), HNAME(8), HCLASS(2)
      INCLUDE 'OBJECT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:CLASSIO.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Find type, check existance
      CALL CHR2H (8, KEYWRD, 1, HKEY)
      CALL ZOINLE (OBJNUM, HKEY, OTYPE, ONDIM, ODIM, IERR)
      IF (IERR.EQ.1) THEN
         MSGTXT = 'OBRGET: KEYWORD ' // KEYWRD // ' NOT FOUND'
         GO TO 990
         END IF
      IF (IERR.EQ.4) THEN
         MSGTXT = 'OBRGET: BAD OBJECT NUMBER'
         GO TO 990
         END IF
      IF (IERR.EQ.5) THEN
         MSGTXT = 'OBRGET: OBJECT DOES NOT EXIST'
         GO TO 990
         END IF
      DIM1 = MAX (1, ODIM(1))
      DIM2 = MAX (1, ODIM(2))
      IF (OTYPE.EQ.OOACAR) THEN
C                                       Copy characters to buffer
         IF (4*HBFSZ.LT.DIM1*DIM2) THEN
C                                       Buffer too small
            IERR = 2
            MSGTXT = 'OBPUT: HBUFF TOO SMALL'
            GO TO 990
            END IF
         CALL ZOFEDT (OBJNUM, HKEY, TYPE, ONDIM, DIM, HBUFF, IERR)
         CALL OBH2C (HBUFF, DIM1, DIM2, VALUEC)
      ELSE
         CALL ZOFEDT (OBJNUM, HKEY, TYPE, ONDIM, DIM, VALUE, IERR)
         END IF
C                                       Errors should have been already
C                                       caught.
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
      MSGTXT = 'KEYWORD =' // KEYWRD
      CALL MSGWRT (6)
      TNAME = 'Unknown object'
      CALL ZOFENM (OBJNUM, HNAME, HCLASS, JERR)
      IF (JERR.EQ.0) CALL H2CHR (32, 1, HNAME, TNAME)
      MSGTXT = 'OBRGET: PROBLEM WITH OBJECT: ' // TNAME
      CALL MSGWRT (6)
C
 999  RETURN
      END
      SUBROUTINE OBGET (OBJNUM, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Fetch the value (array) for a specified keyword.
C   Inputs:
C      OBJNUM  I     Object slot number
C      KEYWRD C*8   Keyword
C   Outputs:
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of value, an axis dimension of zero
C                    means that that dimension and higher are undefined.
C      VALUE   ?     associated value (non character)
C      VALUEC  C(*)*?   associated value (character)
C      IERR    I     Error code, 0=OK.  1=> did not find.
C-----------------------------------------------------------------------
      INTEGER   OBJNUM, TYPE, DIM(*), IERR
      CHARACTER KEYWRD*(*), VALUEC(*)*(*)
      REAL      VALUE(*)
C
      INTEGER   NVAL, KEYPNT, CLASNO, DISK, CNO, CATPNT, DIM1, DIM2, IT,
     *   LOOP , I1, I2, JERR, IDUM(2)
      HOLLERITH HTEMP(2), HNAME(8), HCLASS(2)
      CHARACTER CNAME*8, TNAME*32, CTYPE*4, UVTYPS(8)*2, CTYPE2*4
      REAL      RDUM(2)
      INCLUDE 'OBJECT.INC'
      INCLUDE 'VIRTKEYW.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (IDUM, RDUM)
C                                       ??, vis, Single dish, projected
C                                       celestial, galactic, ecliptic,
C                                       switched beam
      DATA UVTYPS /'??', 'UV', 'SD', 'SC', 'SG', 'SE', 'SB', 'UP'/
C-----------------------------------------------------------------------
      IERR = 0
C                                       Virtual keyword?
      CALL OBKEYV (OBJNUM, KEYWRD, KEYPNT, IERR)
      IF (IERR.EQ.0) THEN
C                                       Find class number
         CALL OBCLAS (OBJNUM, CLASNO, CNAME, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Get keyword type dimension
         TYPE = VKWTAB(VKTYPE,KEYPNT,CLASNO)
         DIM1 = VKWTAB(VKTDM1,KEYPNT,CLASNO)
         DIM2 = VKWTAB(VKTDM2,KEYPNT,CLASNO)
C                                       Size of value
         NVAL = DIM1 * DIM2
         IF (TYPE.EQ.1) NVAL = NVAL * NWDPDP
C                                       Get CATBLK
         CALL ZOFECT (OBJNUM, CATBLK, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR
            GO TO 990
            END IF
C                                       Catalog header?
         IF (VKWTAB(VKTCAT,KEYPNT,CLASNO).EQ.1) THEN
C                                       Catalog header pointer
            CATPNT = VKWTAB(VKTPNT,KEYPNT,CLASNO)
C                                       Adjust for Double
            IF (TYPE.EQ.1) CATPNT = (CATPNT-1) * NWDPDP + 1
C                                       Get data: Character
            IF (TYPE.EQ.3) THEN
C                                       Check String length
               IF (LEN (VALUEC(1)) .GT. (4*HBFSZ)) THEN
                  IERR = 5
                  MSGTXT = 'OBGET: EXCESSIVE STRING LENGTH, ARGUMENT' //
     *               ' ERROR?'
                  GO TO 990
                  END IF
               CALL OBH2C (CATH(CATPNT), DIM1, DIM2, VALUEC)
C                                       Other
            ELSE
               CALL RCOPY (NVAL, CATR(CATPNT), VALUE)
               END IF
C                                       Catalog keyword?
         ELSE IF (VKWTAB(VKTCAT,KEYPNT,CLASNO).EQ.2) THEN
C                                       Get DISK and CNO number.
            TNAME = 'Unknown object'
            CALL ZOFENM (OBJNUM, HNAME, HCLASS, JERR)
            IF (JERR.EQ.0) CALL H2CHR (32, 1, HNAME, TNAME)
            CALL OBDSKC (TNAME, DISK, CNO, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       Read keyword/value in header
            DIM1 = 1
            DIM2 = 1
            I1 = 1
            CALL CATKEY ('READ', DISK, CNO, KEYWRD, I1, I2, HTEMP,
     *         TYPE, SBUFF, IERR)
            IF (IERR.GT.20) IERR = 1
            IF (IERR.NE.0) GO TO 999
            IF (TYPE.EQ.3) THEN
C                                       Check String length
               IF (LEN (VALUEC(1)) .GT. (4*HBFSZ)) THEN
                  IERR = 5
                  MSGTXT = 'OBGET: EXCESSIVE STRING LENGTH, ARGUMENT' //
     *               ' ERROR?'
                  GO TO 990
                  END IF
C                                       Character
               DIM1 = 8
               CALL H2CHR (DIM1, 1, HTEMP, VALUEC)
            ELSE
C                                       Non-character
               NVAL = 1
C                                       Double?
               IF (TYPE.EQ.1) NVAL = NWDPDP
               CALL RCOPY (NVAL, HTEMP, VALUE)
               END IF
C                                       Derived keyword?
         ELSE IF (VKWTAB(VKTCAT,KEYPNT,CLASNO).EQ.3) THEN
            DIM(1) = 1
            DIM(2) = 1
            DIM(3) = 0
C                                       LREC (uv data)
            IF (KEYWRD.EQ.'LREC') THEN
               IT = CATBLK(KINAX)
               DO 500 LOOP = 2,CATBLK(KIDIM)
                  IF (CATBLK(KINAX+LOOP-1).GT.0)
     *               IT = IT * CATBLK(KINAX+LOOP-1)
 500              CONTINUE
               IDUM(1) = IT + CATBLK(KIPCN)
               VALUE(1) = RDUM(1)
               TYPE = 4
C                                       NCORR (uv data)
            ELSE IF (KEYWRD.EQ.'NCORR') THEN
               IT = 1
               DO 510 LOOP = 2,CATBLK(KIDIM)
                  IF (CATBLK(KINAX+LOOP-1).GT.0)
     *               IT = IT * CATBLK(KINAX+LOOP-1)
 510              CONTINUE
               IDUM(1) = IT
               VALUE(1) = RDUM(1)
               TYPE = 4
C                                       TYPEUVD (uv data)
            ELSE IF (KEYWRD.EQ.'TYPEUVD') THEN
               I1 = 1
               I2 = 1
               DIM(1) = 2
               DO 520 LOOP = 1,CATBLK(KIPCN)
                  IT = (LOOP - 1) * 2 + KHPTP
                  CALL H2CHR (4, 1, CATH(IT), CTYPE)
                  CALL H2CHR (4, 5, CATH(IT), CTYPE2)
                  IF (CTYPE.EQ.'UU-L') THEN
                     I1 = 2
                     IF (CTYPE2.EQ.'-NCP') I1 = 8
                     END IF
                  IF (CTYPE.EQ.'VV-L') THEN
                     I2 = 2
                     IF (CTYPE2.EQ.'-NCP') I2 = 8
                     END IF
                  IF (CTYPE.EQ.'RA  ') I1 = 3
                  IF (CTYPE.EQ.'DEC ') I2 = 3
                  IF (CTYPE.EQ.'RA--') I1 = 4
                  IF (CTYPE.EQ.'DEC-') I2 = 4
                  IF (CTYPE.EQ.'GLON') THEN
                     I1 = 3
                     IF (CTYPE2(:1).EQ.'-') I1 = 5
                     END IF
                  IF (CTYPE.EQ.'GLAT') THEN
                     I2 = 3
                     IF (CTYPE2(:1).EQ.'-') I2 = 5
                     END IF
                  IF (CTYPE.EQ.'ELON') THEN
                     I1 = 3
                     IF (CTYPE(:1).EQ.'-') I1 = 6
                     END IF
                  IF (CTYPE.EQ.'ELAT') THEN
                     I2 = 3
                     IF (CTYPE(:1).EQ.'-') I2 = 6
                     END IF
                  IF (CTYPE.EQ.'AZ--') I1 = 7
                  IF (CTYPE.EQ.'EL--') I2 = 7
 520              CONTINUE
               IF (I1.NE.I2) I1 = 1
               VALUEC(1) = UVTYPS(I1)
               TYPE = 3
C                                       Unknown
            ELSE
               IERR = 1
               MSGTXT = 'UNKNOWN DERIVED KEYWORD: ' // KEYWRD
               GO TO 990
               END IF
C                                       Unknown category
         ELSE
            IERR = 1
            MSGTXT = 'UNKNOWN VIRTUAL KEYWORD CATEGORY'
            GO TO 990
            END IF
C                                       Save dimensionality
         DIM(1) = DIM1
         DIM(2) = DIM2
         DIM(3) = 0
         GO TO 999
C                                       Try real keyword.
      ELSE
         CALL OBRGET (OBJNUM, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
         IF (IERR.NE.0) GO TO 995
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
 995  MSGTXT = 'KEYWORD =' // KEYWRD
      CALL MSGWRT (6)
      TNAME = 'Unknown object'
      CALL ZOFENM (OBJNUM, HNAME, HCLASS, JERR)
      IF (JERR.EQ.0) CALL H2CHR (32, 1, HNAME, TNAME)
      MSGTXT = 'OBGET: PROBLEM WITH OBJECT: ' // TNAME
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OBGET: ERROR ', I5,' COPYING CATBLK')
      END
      SUBROUTINE OBLUN (LUN, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Find a free LUN. Maintains an internal list and then checks to see
C   if it is used by AIPS.
C   Outputs:
C      LUN   I  Returned LUN to use
C      IERR  I  Error code, 0=OK.
C-----------------------------------------------------------------------
      INTEGER   LUN, IERR
C
      INTEGER  LOOP, FIND, NUMCHK, LULIST(20), JERR, JERR2, NUMTOT
      INCLUDE 'OBJECT.INC'
      INCLUDE 'INCS:DDCH.INC'
C                                       NUMCHK = no. LUNs to check
      DATA NUMCHK /20/
      DATA NUMTOT /80/
C                                       LULIST = potential LUN list
      DATA LULIST /16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 40, 41, 42,
     *   43, 44, 45, 46, 47, 48, 49/
C-----------------------------------------------------------------------
      IERR = 0
C                                       Loop over possible LUNs
      DO 20 LOOP = 1,NUMTOT
         IF (LOOP.LE.NUMCHK) THEN
            LUN = LULIST(LOOP)
         ELSE
            LUN = LOOP - NUMCHK + 60
            END IF
C                                       Check internal list
         IF ((.NOT.LUNUSE(LUN)) .AND. (DEVTAB(LUN).EQ.0)) THEN
C                                       Use LSERCH to see if LUN in use.
            CALL LSERCH ('SRCH', LUN, FIND, .TRUE., JERR)
C                                       "non map" use
            CALL LSERCH ('SRCH', LUN, FIND, .FALSE., JERR2)
C                                       Not in use?
            IF ((JERR.EQ.1) .AND. (JERR2.EQ.1)) GO TO 900
            END IF
 20      CONTINUE
C                                       No Free LUNs on list.
      MSGTXT = 'NO MORE AIPS LUNS AVAILABLE'
      CALL MSGWRT (7)
C                                       Count usage
      IERR = 0
      DO 30 LOOP = 1,NUMTOT
         IF (LOOP.LE.NUMCHK) THEN
            LUN = LULIST(LOOP)
         ELSE
            LUN = LOOP - NUMCHK + 60
            END IF
C                                       Check internal list
         IF ((LUNUSE(LUN)) .AND. (DEVTAB(LUN).EQ.0)) THEN
C                                       Use LSERCH to see if LUN in use.
            CALL LSERCH ('SRCH', LUN, FIND, .TRUE., JERR)
C                                       "non map" use
            CALL LSERCH ('SRCH', LUN, FIND, .FALSE., JERR2)
C                                       Not in use?
            IF ((JERR.EQ.1) .AND. (JERR2.EQ.1)) IERR = IERR + 1
            END IF
 30      CONTINUE
      WRITE (MSGTXT,1030) IERR, NUMTOT
      CALL MSGWRT (7)
      IERR = 1

      GO TO 999
C                                       Mark this LUN as assigned
 900  LUNUSE(LUN) = .TRUE.
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('OBLUN:',I3,' OF',I3,' POSSIBLE LUNS ACTUALLY OPEN NOW')
      END
      SUBROUTINE OBLUFR (LUN)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Free an LUN from the list of used LUNs.
C   Inputs:
C      LUN   I  Returned LUN to use
C-----------------------------------------------------------------------
      INTEGER   LUN
C
      INCLUDE 'OBJECT.INC'
C-----------------------------------------------------------------------
      LUNUSE(LUN) = .FALSE.
C
 999  RETURN
      END
      SUBROUTINE OBINFO (NAME, BUFNO, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Look up I/O stream associated with an object.
C   Inputs:
C      NAME   C*?   Name of object
C   Outputs:
C      BUFNO  I     Object buffer number
C      IERR   I     Error code, 0=OK. 1= file not open
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   BUFNO, IERR
C
      INTEGER   I
      INCLUDE 'OBJECT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Look up in active buffer table
      BUFNO = -1
      DO 100 I = 1,MAXIO
         IF (NAME.EQ.BUFNAM(I)) THEN
            BUFNO = I
            GO TO 999
            END IF
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE OBDSKC (NAME, DISK, CNO, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Return Disk and slot information for object.
C   Inputs:
C      NAME   C*32  Name of object
C   Outputs:
C      DISK   I     Disk number
C      CNO    I     Catalog slot number
C      IERR   I     Error code, 0=OK. 1= file not open
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   DISK, CNO, IERR
C
      INTEGER   OBJNUM, IT1, DIM(7), IDUM(2)
      REAL      RDUM(2)
      CHARACTER CDUMMY*1
      EQUIVALENCE (IDUM, RDUM)
      INCLUDE 'OBJECT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Find object number
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Find disk  and slot
      CALL OBRGET (OBJNUM, 'DISK', IT1, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      DISK = IDUM(1)
      CALL OBRGET (OBJNUM, 'CNO', IT1, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CNO = IDUM(1)
C
 999  RETURN
      END
      SUBROUTINE OBHGET (NAME, CAT, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Return catalog header record for an object.
C   Inputs:
C      NAME   C*32   Name of object
C   Outputs:
C      CAT    I(256) Catalog header record
C      IERR   I      Error code, 0=OK. 1= file not open
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   CAT(256), IERR
C
      INTEGER   OBJNUM
      INCLUDE 'OBJECT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Find object number
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy header
      CALL ZOFECT (OBJNUM, CAT, IERR)
C
 999  RETURN
      END
      SUBROUTINE OBHPUT (NAME, CAT, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Stores catalog header record for an object.
C   Inputs:
C      NAME   C*32   Name of object
C      CAT    I(256) Catalog header record
C   Outputs:
C      IERR   I      Error code, 0=OK. 1= file not open
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   CAT(256), IERR
C
      INTEGER   OBJNUM
      INCLUDE 'OBJECT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Find object number
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy header
      CALL ZOSTCT (OBJNUM, CAT, IERR)
C
 999  RETURN
      END
      SUBROUTINE OBCOPY (NAMEIN, NAMOUT, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Copies one onject to another.
C   Inputs:
C      NAMEIN C*32   Name of input object
C      NAMOUT C*(*)   Name of output object
C   Outputs:
C      IERR   I      Error code, 0=OK. 1= file not open
C-----------------------------------------------------------------------
      CHARACTER NAMEIN*(*), NAMOUT*(*)
      INTEGER   IERR
C
      HOLLERITH HNAMEI(8), HNAMEO(8)
      INCLUDE 'OBJECT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Copy
      CALL CHR2H (32, NAMEIN, 1, HNAMEI)
      CALL CHR2H (32, NAMOUT, 1, HNAMEO)
      CALL ZOCPOB (HNAMEI, HNAMEO, IERR)
      IF (IERR.EQ.1) THEN
         MSGTXT = 'OBCOPY: PROBLEM WITH INPUT OBJECT'
         GO TO 990
         END IF
      IF (IERR.EQ.2) THEN
         MSGTXT = 'OBCOPY: PROBLEM CREATING NEW OBJECT'
         GO TO 990
         END IF
      IF (IERR.EQ.3) THEN
         MSGTXT = 'OBCOPY: PROBLEM WITH COPYING LINKED LIST'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
      MSGTXT = 'OBCOPY: ERROR COPYING ' // NAMEIN
      CALL MSGWRT (6)
      MSGTXT = '     TO ' // NAMOUT
      CALL MSGWRT (6)
C
 999  RETURN
      END
      SUBROUTINE OBOPEN (NAME, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   Assigns a buffer
C   Inputs:
C      NAME   C*32  Name of object
C   Outputs:
C      IERR   I     Error code, 0=OK.
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INTEGER   LOOP, BUFNO
      INCLUDE 'OBJECT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Does it already have one
C                                       assigned?
      CALL OBINFO (NAME, BUFNO, IERR)
      IERR = 0
C                                       If Buffer/I/O stream not
C                                       assigned then assign one.
      IF (BUFNO.LE.0) THEN
         DO 100 LOOP = 1,MAXIO
            BUFNO = LOOP
            IF (.NOT.OBNUSE(LOOP)) GO TO 110
 100        CONTINUE
C                                       No more I/O streams = buffers
C                                       available.
         IERR = 2
         MSGTXT = 'NO MORE BUFFERS AVAILABLE: USED ONES ARE'
         CALL MSGWRT (6)
         DO 105 LOOP = 1,MAXIO
            MSGTXT = BUFNAM(LOOP)
            CALL MSGWRT (6)
 105        CONTINUE
         MSGTXT = 'FAILED ONE IS:'
         CALL MSGWRT (6)
         MSGTXT = NAME
         CALL MSGWRT (6)
         GO TO 999
C                                       Assign buffer
 110     BUFNAM(BUFNO) = NAME
         OBNUSE(BUFNO) = .TRUE.
C                                       Set buffer pointer
         BUFPNT(BUFNO) = 1
         END IF
C
 999  RETURN
      END
      SUBROUTINE OBCLOS (NAME, IERR)
C-----------------------------------------------------------------------
C   Private to Object manager and Class I/O functions
C   I/O Buffer is deassigned.
C   Inputs:
C      NAME   C*32  Name of object
C   Outputs:
C      IERR   I     Error code, 0=OK. 1= file not open
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INTEGER   BUFNO
      INCLUDE 'OBJECT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Find object number
      CALL OBINFO (NAME, BUFNO, IERR)
      IERR = 0
      IF ((BUFNO.LE.0) .OR. (BUFNO.GT.MAXIO)) GO TO 999
C                                       Deallocate buffer
      OBNUSE(BUFNO) = .FALSE.
      BUFNAM(BUFNO) = '    '
C                                       Reset buffer pointer
      BUFPNT(BUFNO) = -1
C
 999  RETURN
      END
      SUBROUTINE OBC2H (STRING, DIM1, DIM2, HOLL)
C-----------------------------------------------------------------------
C   Private to Object manager.
C   Convert a string (possibly an array) to hollerith.
C   This routine should deal with either the case that the input string
C   is declared either as C*(DIM1*DIM2) or C(DIM1)*DIM2.
C   Inputs:
C      STRING   C(*)*?  A string, possibly an array.
C      DIM1     I       First dimension of character array
C      DIM2     I       Second dimension of character array
C   Outputs:
C      HOLL     H(*)    Hollerith version of character string.
C      IERR     I       Error code, 0=OK. 1= file not open
C-----------------------------------------------------------------------
      CHARACTER STRING(*)*(*)
      INTEGER   DIM1, DIM2
      HOLLERITH HOLL(*)
C
      INTEGER   SLEN, LOOP, D1, D2, NVAL, INDEX
C-----------------------------------------------------------------------
      D1 = MAX (1, DIM1)
      D2 = MAX (1, DIM2)
C                                       Check string length
      SLEN = LEN (STRING(1))
      IF (SLEN .GE. (D1*D2)) THEN
C                                       STRING passed as one string
         NVAL = D1 * D2
         CALL CHR2H (NVAL, STRING, 1, HOLL)
      ELSE
C                                       STRING passed as array.
         INDEX = 1
         DO 100 LOOP = 1,D2
            CALL CHR2H (D1, STRING(LOOP), INDEX, HOLL)
            INDEX = INDEX + D1
 100        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE OBH2C (HOLL, DIM1, DIM2, STRING)
C-----------------------------------------------------------------------
C   Private to Object manager.
C   Convert a hollerith to a string (possibly an array).
C   This routine should deal with either the case that the output string
C   is declared either as C*(DIM1*DIM2) or C(DIM1)*DIM2.
C   Inputs:
C      HOLL     H(*)    Hollerith version of character string.
C      DIM1     I       First dimension of character array
C      DIM2     I       Second dimension of character array
C   Outputs:
C      STRING   C(*)*?  A string, possibly an array.
C      IERR     I       Error code, 0=OK. 1= file not open
C-----------------------------------------------------------------------
      CHARACTER STRING(*)*(*)
      INTEGER   DIM1, DIM2
      HOLLERITH HOLL(*)
C
      INTEGER   SLEN, LOOP, D1, D2, NVAL, INDEX
C-----------------------------------------------------------------------
      D1 = MAX (1, DIM1)
      D2 = MAX (1, DIM2)
C                                       Check string length
      SLEN = LEN (STRING(1))
      IF (SLEN .GE. (D1*D2)) THEN
C                                       STRING passed as one string
         NVAL = D1 * D2
         CALL H2CHR (NVAL, 1, HOLL, STRING)
      ELSE
C                                       STRING passed as array.
         INDEX = 1
         DO 100 LOOP = 1,D2
            CALL H2CHR (D1, INDEX, HOLL, STRING(LOOP))
            INDEX = INDEX + D1
 100        CONTINUE
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'DELZN.INC'
C                                                          Include DELZN
C                                       Local include for DELZN
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MXSOU, MT, MAXFIT, MXAN, MXANSO, MXIFSO
      PARAMETER (MXSOU = 100)
      PARAMETER (MAXFIT = 200)
      PARAMETER (MXAN = 50)
      PARAMETER (MXIFSO = MAXIF*MXSOU)
C                                       MXSASO - product # antennas
C                                       and sources
      PARAMETER (MXANSO = MXAN*MXSOU)
C                                       MSNTIM - # times in SN table
      INTEGER   MSNTIM
      LONGINT   OFFVAL, OFFTIM, OFFELE, OFFREL, OFFREF, OFFBCO, OFFBCR,
     *   OFFVSA
      INTEGER   NITER

C                                       MT - # times of an antenna
C                                       in SN table
      PARAMETER (MT = 10000)
C                                       for all antennas, IFs, pol.
      INTEGER NIDC, IDC(MXSOU), NIDS, IDS(MXSOU), NNIF, NS, NPLOTS,
     *   NCOUNT, NNNIF, SEQIN, SUBA, DISKIN, CNOIN, SNVER,
     *   CLVER, CLUSE, NANTSL, BIF, EIF, ISTOK, FREQID, XINC,
     *   CURANT, ITIME(MXANSO), NTIME(MXANSO), INDTIM, CURIND,
     *   TVCHN, GRCHN, TVCORN(4), NPARM, NSS, NUMHIS, PRTLEV, NTOTT,
     *   NTERM, NFITA, NFITAT, NFITCL, ANTRTS(MT), ANTREF(2), REFNN
      DOUBLE PRECISION RAC(MXSOU), DECC(MXSOU), RAS(MXSOU), DECS(MXSOU)
      LOGICAL    DOTV, DOHIST, DOPLOT, DOCLTM, DOCLT1
      LOGICAL    DOUTFI, DOATMA, DOCLOC, DOREF, REFEQU, DOCLAT, DOCL,
     *   DORES, DOTWO, DOMOD, DODIR, DODISP
      REAL      XSIN, XDISIN, XFQID, XBAND, XFREQ, XBIF, XEIF, XTIME(8),
     *   XANT(50), XSUBA, XSNVER, XGVER, XNCOU, XXINC,
     *   XPRTL, XDOHI, XDOTV, XBAD(10), APARM(10), XGRCHN, SELBAN,
     *   VAL(2), TIMX(2), MAPX(2), MAPRX(2), BCOEX(2), BCOERX(2),
     *   VALMX(MXAN), VALMN(MXAN),  XAXIMX, XAXIMN, XYSCL(2), VALSAV(2),
     *   XYOFF(2), GMXX, GMNX, CHOUT(4), TIMITS(MT), MAPITS(MT),
     *   MAPRIT(MT), BCOITS(MT), BCORIT(MT), VALU(MT), VALU1(MT),
     *   TIMBEG, TIMEND, TIMSTA, RNTREF(2),
     *   TIMFIN, BUFF1(2048), FLUXX(MXIFSO), NRMS
      DOUBLE PRECISION   SOL(MAXFIT), VX(MAXFIT), SSQRES, VARY, FIT,
     *   VARRES, TIMCEN, JD0
      INTEGER   LESOL
      CHARACTER  HISCRD(1000)*64, NAMEIN*12, CLAIN*6, XSOUR(30)*16,
     *   XCALIB(30)*16, XSTOK*4, OPTYPE*4, OFILE*48, DATE0*8,
     *   SOUS(MXSOU)*16, STOKK(2)*4
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XXCALB(4,30),
     *   XXSTOK(1), XOPTY(1), XOFILE(12)
      DOUBLE PRECISION FRQOFF(MAXIF), SELFRQ, LAMBDA(MAXIF)
C                                       cpecific CL data
      INTEGER   CLRECI(13+32*MAXIF), CLKOLS(MAXCLC), CLNUMV(MAXCLC),
     *   FIXCNT,
     *   TIMCL,  INTCL, SOUCL, ANTCL, SUBCL, FRQCL, IFRCL,
     *   GDLCL, DOPCL, ATMCL, DATMCL,
     *   MBD1CL, CLK1CL, DCK1CL, DIS1CL, DDS1CL,
     *   RE1CL, IM1CL, DE1CL, RA1CL, WE1CL, RF1CL,
     *   MBD2CL, CLK2CL, DCK2CL, DIS2CL, DDS2CL,
     *   RE2CL, IM2CL, DE2CL, RA2CL, WE2CL, RF2CL
      REAL     CLRECR(13+32*MAXIF)
      DOUBLE PRECISION  CLRECD(13+32*MAXIF)
C                                       Buffers and file info
      INTEGER   BUFFER(1024)
C                                       Internal storage
      INTEGER   SNRECI(10+15*MAXIF), SNKOLS(MAXSNC), SNNUMV(MAXSNC),
     *   NUMANT, NUMPOL, NUMIF, ICODE, TIMSN, INTSN, SOUSN, ANTSN,
     *   SUBSN, FRQSN, IFRSN, NODSN, RE1SN, IM1SN, DL1SN, RA1SN,
     *   WT1SN, RF1SN, RE2SN, IM2SN, DL2SN, RA2SN, WT2SN, RF2SN
      REAL      GMMOD, SNRECR(10+15*MAXIF)
      DOUBLE PRECISION COSDEC, SINDEC, SNRECD(10+15*MAXIF)
      EQUIVALENCE (ANTREF, RNTREF)
C                                       Inputs and general info
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSNVER, XGVER,
     *   APARM, XXSOUR, XXCALB, XXSTOK, XBAND, XFREQ, XFQID,
     *   XBIF, XEIF, XTIME, XANT, XSUBA, XNCOU, XXINC,
     *   XOPTY, XOFILE, XPRTL, XDOHI, XDOTV, XGRCHN, XBAD
      COMMON /OTHPRM/ OFFVAL, OFFTIM, OFFELE, OFFREL, OFFREF,
     *   OFFBCO, OFFBCR, OFFVSA,
     *   SELBAN,
     *   SEQIN, DISKIN, CNOIN, SUBA, SNVER, CLVER, CLUSE, TVCHN, NPARM,
     *   DOTV, NUMHIS, PRTLEV, DOHIST, DOPLOT, DOUTFI, DOATMA, DOCLOC,
     *   DOREF, DOCLAT, DOCL, DOCLTM, DOCLT1, DORES, DOTWO, DODISP,
     *   DOMOD, DODIR, REFEQU,
     *   NFITA, NFITAT, NFITCL
      COMMON /EL/  RAC, RAS, DECC, DECS, IDC, NIDC, IDS, NIDS, NNIF,
     *   NS, VAL, VALSAV, TIMX, MAPX, MAPRX, BCOEX, BCOERX,
     *   ANTREF, VALMX, VALMN, XAXIMX,
     *   XAXIMN, NPLOTS, XYSCL, XYOFF, NCOUNT, XINC, GMXX, GMNX, CHOUT,
     *   CURANT, ITIME, NTIME, INDTIM, CURIND, GRCHN,
     *   TVCORN, TIMITS, MAPITS, MAPRIT, BCOITS, BCORIT, VALU, VALU1,
     *   ANTRTS,  NNNIF,
     *   ICODE, NSS, FLUXX, NTOTT, MSNTIM, NITER, NRMS,
     *   REFNN
      COMMON /LEASQ/   SOL, VX, SSQRES, VARY, FIT, VARRES, TIMCEN,
     *   JD0, LESOL
      COMMON /CINFO/ FRQOFF, SELFRQ, NANTSL,  BIF, EIF, ISTOK,
     *   FREQID, TIMBEG, TIMEND, TIMSTA, TIMFIN
      COMMON /CHRCOM/ HISCRD, NAMEIN, CLAIN, XSOUR, XCALIB,
     *   XSTOK, OPTYPE, SOUS, STOKK, OFILE, DATE0
C                                       Buffers and file info
      COMMON /BUFRS/ BUFFER, BUFF1
C                                       Important constants
C                                       Internal storage
      COMMON /SNRECC/ LAMBDA, COSDEC, SINDEC, SNRECD, GMMOD,
     *   SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF,
     *   TIMSN, INTSN, SOUSN, ANTSN, SUBSN, FRQSN, IFRSN, NODSN,
     *   RE1SN, IM1SN, DL1SN, RA1SN, WT1SN, RF1SN,
     *   RE2SN, IM2SN, DL2SN, RA2SN, WT2SN, RF2SN
      COMMON /CLRECC/  CLRECD, NTERM,
     *   FIXCNT, CLKOLS, CLNUMV
      EQUIVALENCE (CLRECI, CLRECR, CLRECD)
      EQUIVALENCE (CLKOLS(CLDTIM), TIMCL), (CLKOLS(CLRTMI), INTCL),
     *   (CLKOLS(CLISID),SOUCL), (CLKOLS(CLIANT),ANTCL),
     *   (CLKOLS(CLISUB),SUBCL), (CLKOLS(CLIFQI),FRQCL),
     *   (CLKOLS(CLRIFR),IFRCL), (CLKOLS(CLDDEL),GDLCL),
     *   (CLKOLS(CLRDOP),DOPCL), (CLKOLS(CLRATM),ATMCL),
     *   (CLKOLS(CLRDAT),DATMCL)
      EQUIVALENCE (CLKOLS(CLRMD1),MBD1CL),
     *   (CLKOLS(CLRCK1),CLK1CL), (CLKOLS(CLRDC1),DCK1CL),
     *   (CLKOLS(CLRDS1),DIS1CL), (CLKOLS(CLRDD1),DDS1CL),
     *   (CLKOLS(CLRRE1),RE1CL), (CLKOLS(CLRIM1),IM1CL),
     *   (CLKOLS(CLRRA1),RA1CL), (CLKOLS(CLRDE1),DE1CL),
     *   (CLKOLS(CLRWE1),WE1CL), (CLKOLS(CLIRF1),RF1CL)
      EQUIVALENCE (CLKOLS(CLRMD2),MBD2CL),
     *   (CLKOLS(CLRCK2),CLK2CL), (CLKOLS(CLRDC2),DCK2CL),
     *   (CLKOLS(CLRDS2),DIS2CL), (CLKOLS(CLRDD2),DDS2CL),
     *   (CLKOLS(CLRRE2),RE2CL), (CLKOLS(CLRIM2),IM2CL),
     *   (CLKOLS(CLRRA2),RA2CL), (CLKOLS(CLRDE2),DE2CL),
     *   (CLKOLS(CLRWE2),WE2CL), (CLKOLS(CLIRF2),RF2CL)
Cdelete later
      EQUIVALENCE (SNRECI, SNRECR, SNRECD)
C                                                          End DELZN
LOCAL END
      PROGRAM DELZN
C-----------------------------------------------------------------------
C! Determines zenith delay observing calibrators and find corrections
C! based on the zenith delay and the source elevation.
C# UV Calibration EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2003-2008, 2012, 2015, 2017, 2020, 2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task DELZN provides estimation of the residual atmosphere zenith
C   delay and clock error based on the SN table - output of FRING
C   and corrects the CL table based on the zenith delay and the source
C   elevation.
C   Inputs:
C      INNAME.....UV file name (name).       Standard defaults.
C      INCLASS....UV file name (class).      Standard defaults.
C      INSEQ......UV file name (seq. #).     0 => highest.
C      INDISK.....Disk unit #.               0 => any.
C      SNVER......The SN table version number - source of input data
C      GAINVER....Input CL table to copy to GAINUSE and then correct
C      GAINUSE....Output Cl table
C      APARM(10)..Control parameters
C                 1: what data to plot
C                    0 => zenith atm. delay
C                    1 => clock error
C                 2: number of terms at the polynomial for zenith atm.
C      SOURCES....Source list to calibrate .
C                 ' ' = all; a "-" before a source
C                 name means all except ANY source named.
C      CALSOUR....Calibrator list to select from the SN table
C                 ' ' = all; a "-" before a calibrator
C                 name means all except ANY calibrator named.
C      STOKES.....The desired Stokes type of the data:
C                 'R' = RCP, 'L' = LCP, 'other' = all available
C      SELBAN.....Bandwidth to select (kHz)
C      SELFREQ....Frequency to select (MHz)
C      FREQID.....Freq. ID to select, 0=>all
C      BIF........Lowest IF number, 0=>all
C      EIF........Highest IF number, 0=>all
C      TIMERANG...Time range of the data to be calibrateded. In order:
C                 Start day, hour, min. sec,
C                 end day, hour, min. sec. Days relative to ref.
C                 date.
C      ANTENNAS...A list of the antennas to be callibrated. All 0 => all.
C                 If any number is negative then all antennas listed
C                 are NOT to be callibrated and all others are.
C      SUBARRAY...The subarray to callibrate. Do only one at a time.
C      NPLOTS.....Number of plots to plot per page 0=>5.
C                 -1 => Don't make plots
C      XINC.......Plot every XINC'th point
C      OPTYPE.....The SN table Data to be fitted:
C                 'MDEL'' or '    ' =>  multiband delay,
C                 'PHAS' = phas delay
C      OUTFILE....Output file name. Delays at zenith
C      DOTV.......> 0 => TV, else plot file
C      BADDISK....A list of disks on which scratch files are not to
C                 be placed.
C
C programmer: Leonia Kogan, July 2003
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'DELZN.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'DELZN '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL DELZIN (PRGM, IRET)
      MSGTXT = 'Finished init'
      call msgwrt (6)
C                                       read SN table and store
C                                       times and values; fit model
      IF (IRET.EQ.0) CALL DELUV (IRET)
C                                       plot values
C                                       and model versus time
      IF (IRET.EQ.0) CALL PLTFIT (IRET)
      IRET = MAX (0, IRET)
C                                       Apply correction to the CL table
C                                       and record output file
      IF (IRET.EQ.0 .AND. (DOCL.OR.DOUTFI)) CALL OUTCL (IRET)
      IRET = MAX (0, IRET)
C                                       Copy and update HI file.
      IF (IRET.EQ.0) CALL DELHIS
C                                       Close down files, etc.
      CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE DELZIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   DELZIN gets input parameters for DELZN.
C   Inputs:  PRGN    C*6       Program name
C   Output:  JERR    I         Error code: 0 => ok
C                                1 => Invalid request
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   JERR, NSOUR
C
      CHARACTER STAT*4, BLANK*4, UTYPE*2, CODE(5)*4
      LOGICAL   T, MATCH
      INTEGER   IERR, I, IROUND, LUN, IIVER, NCODE, SNTOT,
     *   NIDCC, IS, IEND, NUMCL, LUN2, TABUFF(512)
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'DELZN.INC'
      INTEGER   DUMMY(MAXIF)
      REAL      FINC(MAXIF), TTIME
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DOTTV.INC'
C     CODE =                 1      2      3      4      5
      DATA NCODE, CODE /5, 'MDEL','PHAS','DISP','RATE','    '/
      DATA BLANK /'    '/
      DATA T /.TRUE./
      DATA LUN, LUN2  /29, 28/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T, BUFFER)
      CALL VHDRIN
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 353
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFFER, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      SUBA = XSUBA + 0.5
      IF (SUBA.LE.0) SUBA = 1
C
      PRTLEV = IROUND (XPRTL)
      DOHIST = XDOHI.GT.0.0
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCHN + 0.01
      IF (GRCHN.EQ.0) GRCHN = 1
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
      XINC = IROUND (XXINC)
      IF (XINC.LE.0) XINC = 1
      XXINC = XINC
      DO 15 I = 1,10
         IBAD(I) = IROUND (XBAD(I))
 15      CONTINUE
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XXSTOK, XSTOK)
      CALL H2CHR (4, 1, XOPTY, OPTYPE)
      CALL H2CHR (48, 1, XOFILE, OFILE)
C                                       calculate the output file?
      DOUTFI = OFILE(1:1) .NE. ' '
C                                       OPTYPE ?
      ICODE = 1
      DO 20 I = 1,NCODE
         IF ((OPTYPE(1:3).EQ.CODE(I)(1:3)) .AND. (OPTYPE.NE.BLANK))
     *      ICODE = I
 20      CONTINUE
      OPTYPE = CODE(ICODE)
      CALL CHR2H (4, OPTYPE, 1, XOPTY)
C
      DO 30 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
         CALL H2CHR (16, 1, XXCALB(1,I), XCALIB(I))
 30      CONTINUE
C                                       Timerange
      TIMBEG = XTIME(1) + XTIME(2) / 24.0 + XTIME(3) / (24.0*60.0) +
     *   (XTIME(4) / (24.0*60.0*60.0))
      TIMEND = XTIME(5) + XTIME(6) / 24.0 + XTIME(7) / (24.0*60.0) +
     *   (XTIME(8) / (24.0*60.0*60.0))
      IF ((TIMEND.LT.TIMBEG) .OR. (TIMEND.LT.1.0E-5)) TIMEND = 1.0E20
      IF ((TIMEND.LT.TIMBEG) .OR. (TIMBEG.LT.1.0E-5)) TIMBEG = 0.0
C                                       Find file, read CATBLK
      CNOIN = 1
      STAT = 'SRCH'
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'WRIT', BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      CALL H2CHR (8, 1, CATH(KHDOB), DATE0)
      CALL JULDAY (DATE0, JD0)
C                                       what to plot?
      DOATMA = (APARM(1).LT.0.1)
      DOCLOC = (APARM(1).GT.0.5 .AND. APARM(1).LT.1.5)
      DOREF  = (APARM(1).GT.1.5 .AND. APARM(1).LT.2.5)
      DODISP = (APARM(1).GT.2.5 .AND. APARM(1).LT.3.5)
C                                       How to plot?
      DOMOD = (APARM(10).LT.0.1)
      DODIR = (APARM(10).GT.0.5 .AND. APARM(10).LT.1.5)
C                                       Number of terms at the
C                                       polynomial representation
C                                       of the zenith atmosphere
C                                       If NFITAT.EQ.0 then
C                                       nofit of atm
      NFITAT = APARM(2)
C                                       Number of terms at the
C                                       polynomial representation
C                                       of the clock errors
C                                       If NFITCL.EQ.0 then
C                                       nofit of clock error
C
C                                       Create CL table?
      NFITCL = APARM(3)
      IF (ICODE.NE.1) NFITCL = 0

      DOCL = (APARM(4).GT.0.5)
C                                       Will only atmosphere be
C                                       corrected at CL table or sum
C                                       of atmosphere and clock
      DOCLAT = (APARM(5).LT.0.1)
C                                       number of itteration in
C                                       editing the SN table
      NITER = APARM(6)
C                                       number of r.m.s in itteration
      NRMS = 3
C                                       calculate the output file for
C                                       the CL table times only if
C                                       CL table is there
      DOCLTM = APARM(8).GT.0.1
C
      IF (.NOT. DOCL .AND. DOCLTM) THEN
         DOCLTM = .FALSE.
         WRITE (MSGTXT,1048)
         CALL MSGWRT (8)
         WRITE (MSGTXT,1050)
         CALL MSGWRT (8)
         WRITE (MSGTXT,1048)
         CALL MSGWRT (8)
         END IF
C
      DOCLT1 = DOCLTM
C                                       plot data + model or
C                                       additionally plot residual
      DORES = APARM(9).GT.0.001
C
      IF (NRMS.EQ.0) NRMS=3
C                                       What the total number of fit
C                                       parameters for each antenna
      NFITA = NFITAT + NFITCL
C                                       Table version numbers
      SNVER = IROUND (XSNVER)
      CLVER = IROUND (XGVER)
C                                       Defaults for CL tables
      CALL FNDEXT ('CL', CATBLK, NUMCL)
      IF (CLVER.LE.0 .OR. CLVER.GT.NUMCL) CLVER = NUMCL
      CLUSE = NUMCL + 1
C                                       Prohibit CLUSE=1
      IF (CLUSE.EQ.1) THEN
         JERR = 5
         MSGTXT = 'ERROR: IT IS FORBIDDEN TO MODIFY CL VERSION 1'
         GO TO 990
         END IF
C                                       copy CLVER table to CLUSE table
      IF (DOCL) THEN
         CALL TABCOP ('CL', CLVER, CLUSE, LUN, LUN2, DISKIN,DISKIN,
     *      CNOIN, CNOIN, CATBLK, BUFF1, TABUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR
            GO TO 990
            END IF
         END IF
      XGVER = CLVER
C                                       determine number of SN tables
      CALL FNDEXT ('SN', CATBLK, SNTOT)
      IF (SNVER.EQ.0 .OR. SNVER.GT.SNTOT) SNVER = SNTOT
      XSNVER = SNVER
C                                       IF range
      BIF = IROUND (XBIF)
      EIF = IROUND (XEIF)
      IF (BIF.LE.0) BIF = 1
      IF ((EIF.LE.0) .AND. (JLOCIF.GT.0)) EIF = CATBLK(KINAX+JLOCIF)
      IF (EIF.LE.0) EIF = 1
      IF ((JLOCIF.GT.0) .AND. (BIF.GT.CATBLK(KINAX+JLOCIF)))
     *   BIF = CATBLK(KINAX+JLOCIF)
      IF ((JLOCIF.GT.0) .AND. (EIF.GT.CATBLK(KINAX+JLOCIF)))
     *   EIF = CATBLK(KINAX+JLOCIF)
      XBIF = BIF
      XEIF = EIF
C                                       NNIF number of selected IFs
      NNIF = EIF - BIF + 1
C                                       NNNIF number of IFs in data
      NNNIF = CATBLK(KINAX+JLOCIF)
C                                       Select sources
      NIDS = MXSOU
      NSOUR = 30
      CALL SOUSEL (XSOUR, NSOUR, DISKIN, CNOIN, CATBLK, BIF, NNIF,
     *   BUFFER, IDS, NIDS, RAS, DECS, SOUS, FLUXX, JERR)
      IF (JERR.NE.0) GO TO 999
C                                       history: sources
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2350)
      NIDCC = (NIDS-0.1) / 3
      DO 60 IS = 1, NIDCC+1
         NUMHIS = NUMHIS + 1
         IF (NIDS.GE.3*IS) THEN
            IEND = 3
         ELSE
            IEND = NIDS - 3*(IS-1)
            END IF
         WRITE (HISCRD(NUMHIS),2400) (SOUS(3*(IS-1) + I), I = 1,IEND)
 60      CONTINUE
C                                       Select calibrators
      NIDC = MXSOU
      NSOUR = 30
      CALL SOUSEL (XCALIB, NSOUR, DISKIN, CNOIN, CATBLK, BIF, NNIF,
     *   BUFFER, IDC, NIDC, RAC, DECC, SOUS, FLUXX, JERR)
      IF (JERR.NE.0) GO TO 999
C                                       history: calibrators
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2550)
      NIDCC = (NIDC-0.1) / 3
      DO 70 IS = 1, NIDCC+1
         NUMHIS = NUMHIS + 1
         IF (NIDC.GE.3*IS) THEN
            IEND = 3
         ELSE
            IEND = NIDC - 3*(IS-1)
            END IF
         WRITE (HISCRD(NUMHIS),2600) (SOUS(3*(IS-1) + I), I = 1,IEND)
 70      CONTINUE
C                                       select antennas
      NANTSL = 50
      CALL ANTSEL (XANT, NANTSL, SUBA, DISKIN, CNOIN, CATBLK,
     *   BUFFER, JERR)
      IF (NSTNS.EQ.0) THEN
         WRITE (MSGTXT,1400)
         JERR = 5
         GO TO 990
         END IF
C                                       history: antennas
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2650)
      NIDCC = (NSTNS-0.1) / 10
      DO 80 IS = 1, NIDCC+1
         NUMHIS = NUMHIS + 1
         IF (NSTNS.GE.10*IS) THEN
            IEND = 10
         ELSE
            IEND = NSTNS - 10*(IS-1)
            END IF
         WRITE (HISCRD(NUMHIS),2700) (TELNO(10*(IS-1) + I), I = 1,IEND)
 80      CONTINUE
C
      NRPARM = CATBLK(KIPCN)
C                                       Freq id
      FREQID = IROUND (XFQID)
      IF (FREQID.LE.0) FREQID = -1
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FREQID, JERR)
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1060)
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
      XFQID = SELFRQ
C                                       Stokes' type.
      STOKK(1) = 'Rpol'
      STOKK(2) = 'Lpol'
      IF ((CATBLK(KINAX+JLOCS).EQ.1) .AND. (ICOR0.EQ.-2))
     *   STOKK(1) = 'Lpol'
      NSS = MIN (2, CATBLK(KINAX+JLOCS))
      NS = 1
      ISTOK = 0
      IF (XSTOK.EQ.'R   ') ISTOK = 1
      IF (XSTOK.EQ.'L   ') ISTOK = NSS
C                                       If none selected take what you
C                                       have.
      IF (ISTOK.EQ.0) THEN
         NS = NSS
         ISTOK = 1
C                                       Is selected Stokes' available?
      ELSE
         IF ((CATBLK(KINAX+JLOCS).EQ.1) .AND.
     *      ( (ICOR0.EQ.-1) .AND. (XSTOK.EQ.'L   ') .OR.
     *       (ICOR0.EQ.-2) .AND. (XSTOK.EQ.'R   '))) THEN
            JERR = 1
            MSGTXT = 'STOKES ' // XSTOK // ' UNAVAILABLE IN DATA'
            GO TO 990
            END IF
         END IF
C                                       number of plots
      NPLOTS = NS*NNIF*NSTNS
C                                       number of plots at a page
      NCOUNT = IROUND (XNCOU)
      NCOUNT = MIN (NCOUNT, NPLOTS)
      IF (NCOUNT.EQ.0) NCOUNT = 5
      XNCOU = NCOUNT
C
      IF (DORES) THEN
         NCOUNT = 2*NCOUNT
         END IF
C
      DOPLOT = NCOUNT.GE.0
      JERR = 0
C                                       history file
      NUMHIS = NUMHIS + 1
      TTIME = 0
      DO 90 I = 1, 8
         TTIME = TTIME + XTIME(I)
 90      CONTINUE
      IF (TTIME.EQ.0.0) THEN
         WRITE (HISCRD(NUMHIS),2100)
      ELSE
         WRITE (HISCRD(NUMHIS),2200) (XTIME(I),I=1,8)
         END IF
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2300) SNVER, CLVER, CLUSE
       NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2750) BIF, EIF, FREQID, SUBA
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2800) OPTYPE
      IF (NS.EQ.2) THEN
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2900)
      ELSE
         NUMHIS = NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2950) STOKK(ISTOK)
         END IF
C
C                                       Get IF information
      IIVER = 1
      CALL CHNDAT ('READ', BUFFER, DISKIN, CNOIN, IIVER, CATBLK, LUN,
     *   NUMIF, FRQOFF, DUMMY, FINC, BNDCOD, FREQID, JERR)
      IF (JERR.NE.0) GO TO 999
C
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DELZIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1020 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1048 FORMAT ( '-----------------------------------------------------')
 1050 FORMAT ( 'force even times for OUTFI, because CL is not created')
 1060 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
 1100 FORMAT ('ERROR: COPYING INPUT CL TO OUTPUT:',I4)
 1400 FORMAT ('ANTSEL: NOONE ANTENNA SELECTED')
 2100 FORMAT ('TIMERANG = beginning to end')
 2200 FORMAT (F3.0,1X,F3.0,F3.0,F4.1,' - ',F3.0,1X,F3.0,F3.0,F4.1,
     *   '/ Time range')
 2300 FORMAT ('Input SN table =',I3, 5X, 'Input CL table =',I3,
     *   'Output CL table =',I3)
 2350 FORMAT (5X,'Selected sources')
 2400 FORMAT (3A16)
 2550 FORMAT (5X,'Selected calibrators')
 2600 FORMAT (3A16)
 2650 FORMAT (5X,'Selected antennas')
 2700 FORMAT (10I4)
 2750 FORMAT ('BIF =', I3,5X, 'EIF =', I3,5X,'FREQID =',
     *   I3,5X,'SUBARRAY =', I3)
 2800 FORMAT ('OPTYPE = ',A4)
 2900 FORMAT ('STOKES = Rpol and Lpol')
 2950 FORMAT ('STOKES = ', A4)
       END
      SUBROUTINE DELUV (IERR)
C-----------------------------------------------------------------------
C   DELUV is called from DELZN. DELUV reads through the SN table,
C   fits the polynomials,
C   stores given values for the plotting routine PLTFIT
C   Output: IERR  I    Return code, 0=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   LUN, ISNRNO, NUMREC, NUMNOD, ISN, JIF, JS, SOUN,
     *   FREQN, MODENO, IANT, KS, KIF, MAX2, LANT, SID,
     *   NTTOT, SOUANT, NFIT, IFIT, KFIT, IKFIT, IC,
     *   KC, LFIT, MFIT, RFIT, LIFIT, MIFIT, LKFIT, MKFIT, IIFSTO,
     *   REFOLD, REFNEW, RANT
      LOGICAL   ISAPL, FIRST
      REAL      RANOD(25), DECNOD(25), ELEV, ELEREF, BCO, BCOR,
     *   COSZ, MAPANT, MAPREF, TIMARG, TIMMI, TIMMA
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'DELZN.INC'
      INCLUDE 'INCS:PSNTAB.INC'
      REAL      REAL(2,MAXIF), IMAG(2,MAXIF), DELAY(2,MAXIF),
     *   RATE(2,MAXIF), WEIGHT(2,MAXIF), MBDELY(2), TIMINT, IFRM,
     *   HL, RESID, RMSD, DISP(2), DDISP(2)
      INTEGER   REFA(2,MAXIF), REFN, ITER, IFSIDE(MAXIF), IIF, NWORDS
      DOUBLE PRECISION IFFREQ(MAXIF), R(MAXFIT), MATR(MAXFIT*MAXFIT),
     *   NOBS, SUM, SSQ
      CHARACTER BNDCOD(MAXIF)*8
      REAL      IFCHW(MAXIF), IFTBW(MAXIF), VALCUR, CCANT(10), CCREF(10)
      REAL   TCOEFR, ACOEFR, BCOEFR, TCOEF, ACOEF, BCOEF,
     *   A0CLO, A1CLO, VALRAT
      DOUBLE PRECISION CTIM, SIDT, TIMMAX, TIMMIN
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUN /29/
      DATA SIDT /1.00273790935D0/
C-----------------------------------------------------------------------
      CALL GETFQ (FREQID, DISKIN, CNOIN, CATBLK, LUN, IFFREQ, IFTBW,
     *   IFCHW, IFSIDE, BNDCOD, IERR)
C
C                                       Wavelength in mm
      DO 15 IIF = 1, NUMIF
         LAMBDA(IIF) = VELITE / (SAFREQ + IFFREQ(IIF)) * 1000
 15      CONTINUE
      IF (IERR.NE.0) GO TO 900
C   --------------------------------------------------------------
C   I  Read the SN table the first time to estimate number of    I
C   I  points for each selected antenna for selected calibrators I
C   --------------------------------------------------------------
      DO 30 IANT = 1,NSTNS
         DO 20 SID = 1,NIDC
            SOUANT = SID + NIDC*(IANT-1)
            ITIME(SOUANT) = 0
 20         CONTINUE
 30      CONTINUE
C                                       Open SN table, Read for info
      CALL SNINI ('READ', BUFFER, DISKIN, CNOIN, SNVER, CATBLK, LUN,
     *   ISNRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD,
     *   GMMOD, RANOD, DECNOD, ISAPL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get number of records
      NUMREC = BUFFER(5)
      IF (NUMREC.LE.0) GO TO 999
C
      TIMMIN = 1.0E10
      TIMMAX =-1.0E10
      DO 200 ISNRNO = 1,NUMREC
C                                       read SN table
         ISN = ISNRNO
         CALL TABSN ('READ', BUFFER, ISN, SNKOLS, SNNUMV, NSS, CTIM,
     *      TIMINT, SOUN, LANT, SUBA, FREQN, IFRM, MODENO, MBDELY,
     *      DISP, DDISP, REAL, IMAG, DELAY, RATE, WEIGHT, REFA, IERR)
C                                       check if record is flagged
         IF (IERR.LT.0) GO TO 200
C                                       timerange selection
         IF ((CTIM.GT.TIMEND) .OR. (CTIM.LT.TIMBEG)) GO TO 200
C                                       FREQID selection
         IF ((FREQN.NE.0) .AND. (FREQN.NE.FREQID)) GO TO 200
C                                       antennas selection
         DO 40 IANT = 1,NSTNS
            IF (TELNO(IANT).EQ.LANT) GO TO 60
 40         CONTINUE
         GO TO 200
C                                       calibrators selection
 60      DO 80 SID = 1, NIDC
            IF (IDC(SID).EQ.SOUN) GO TO 120
 80         CONTINUE
         GO TO 200
C                                       calculate elevation of
C                                       the selected antenna for
C                                       the selected source
 120     HL = TWOPI*SIDT*CTIM + GSTIAT + STNLON(IANT) - RAC(SID)
         COSZ = DCOS(STNLAT(IANT))*DCOS(DECC(SID))*COS(HL) +
     *      DSIN(STNLAT(IANT))*DSIN(DECC(SID))
         IF (COSZ.GE.0.0) THEN
            SOUANT = SID + NIDC*(IANT-1)
            ITIME(SOUANT) = ITIME(SOUANT) + 1
            END IF
C
         TIMMIN = MIN (TIMMIN, CTIM)
         TIMMAX = MAX (TIMMAX, CTIM)
  200    CONTINUE
C                                       convert double precision to real
      TIMMI = TIMMIN
      TIMMA = TIMMAX
C                                       minimum selected time
      TIMSTA = MAX (TIMMI, TIMBEG)
C                                       maximum selected time
      TIMFIN = MIN (TIMMA, TIMEND)
C
      TIMCEN = (TIMMIN+TIMMAX) / 2
C
      WRITE (MSGTXT,1050) TIMCEN
      CALL MSGWRT (4)
C                                       Close table.
      CALL TABIO ('CLOS', 0, ISNRNO, CLRECR, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Number of points for antennas
C                                       until antenna IANT and
C                                       sources until SID
C?????????????????? SOUANT(1) refs NTIME(0) ITIME(0)  ??????????????
      NTIME(1) = 0
      DO 220 IANT = 1, NSTNS
         DO 210 SID = 1, NIDC
            SOUANT = SID + NIDC*(IANT-1)
            IF (SOUANT.GT.1) NTIME(SOUANT) = NTIME(SOUANT-1) +
     *         ITIME(SOUANT-1)
 210        CONTINUE
 220     CONTINUE
      NTTOT = NTIME(SOUANT) + ITIME(SOUANT)
      MSNTIM = NTTOT+10
C                                       dynamic memory for array of
C                                       the antenna elevation,
C                                       reference antenna elevation,
C                                       reference antenna number,
C                                       time and value
C                                       BCOEFF for antenna and for
C                                       refference antenna
      NWORDS = (MSNTIM - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, MAPX, OFFELE, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, MAPRX, OFFREL, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, TIMX, OFFTIM, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, VAL, OFFVAL, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, VALSAV, OFFVSA, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, RNTREF, OFFREF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, BCOEX, OFFBCO, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, BCOERX, OFFBCR, IERR)
      IF (IERR.NE.0) GO TO 999
C   -----------------------------------------------------------
C   I  Read the SN table the second time to store elevations  I
C   I         and delays for each selected antenna and        I
C   I             for selected calibrators                    I
C   -----------------------------------------------------------
      MAX2 = MSNTIM
      XAXIMX = 0.0
      XAXIMN = 1000.0
C                                       check later about souant lower
      DO 250 IANT = 1,NSTNS
         VALMX(IANT) = -1.0E10
         VALMN(IANT) =  1.0E10
 250     CONTINUE
      CALL SNINI ('READ', BUFFER, DISKIN, CNOIN, SNVER, CATBLK, LUN,
     *   ISNRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPL, IERR)
      IF (IERR.NE.0) GO TO 999
C
      NFIT = NFITA*NSTNS
C
      ITER = 0
C                                       New iteration in editing
 260  CONTINUE
C
      DO 280 IANT = 1,NSTNS
         DO 270 SID = 1,NIDC
            SOUANT = SID + NIDC*(IANT-1)
            ITIME(SOUANT) = 0
 270        CONTINUE
 280     CONTINUE
C                                       Force result vector R(NFIT),
C                                       matrix M(NFIT*NFIT) (in LEASQR)
C                                       to zero
      DO 310 IFIT = 1, NFIT
         R(IFIT) = 0.0
         DO 290 KFIT = 1, NFIT
            IKFIT = KFIT + (IFIT - 1)*NFIT
            MATR (IKFIT) = 0.0
 290        CONTINUE
 310     CONTINUE
      SUM = 0.0
      SSQ = 0.0
      NOBS = 0.0
C                                       Get number of records
      NUMREC = BUFFER(5)
      IF (NUMREC.LE.0) GO TO 999
      REFEQU = .TRUE.
      FIRST = .TRUE.
C                                       reading the SN table rows
      DO 500 ISNRNO = 1,NUMREC
C                                       read SN table
         ISN = ISNRNO
         CALL TABSN ('READ', BUFFER, ISN, SNKOLS, SNNUMV, NSS, CTIM,
     *      TIMINT, SOUN, LANT, SUBA, FREQN, IFRM, MODENO, MBDELY, DISP,
     *      DDISP, REAL, IMAG, DELAY, RATE, WEIGHT, REFA, IERR)
C                                       check if record is flagged
         IF (IERR.LT.0) GO TO 500
C                                       timerange selection
         IF ((CTIM.GT.TIMEND) .OR. (CTIM.LT.TIMBEG)) GO TO 500
C                                       FREQID selection
         IF ((FREQN.NE.0) .AND. (FREQN.NE.FREQID)) GO TO 500
C                                       antennas selection
         DO 320 IANT = 1,NSTNS
            IF (TELNO(IANT).EQ.LANT) GO TO 330
 320        CONTINUE
         GO TO 500
C                                       calibrators selection
 330     DO 340 SID = 1, NIDC
            IF (IDC(SID).EQ.SOUN) GO TO 350
 340        CONTINUE
         GO TO 500
C                                       Consider the reference antennas
C                                       are the same for all IFs, Stokes
C                                       but may be different for the
C                                       experiment
C
C                                       Exclude the rows IANT=REFN
C                                       Instead they considered at the
C                                       difference term
 350     REFN = REFA(1,1)
C                                       Is the REFN const for the whole
C                                       experiment?
         IF (FIRST) THEN
            REFOLD = REFN
            FIRST = .FALSE.
            END IF
         REFNEW = REFN
         REFEQU = REFEQU .AND. (REFOLD .EQ. REFNEW)
         REFOLD = REFNEW
C
         IF (TELNO(IANT).EQ.REFN) GO TO 500
C                                       calculate elevation of
C                                       the SN row antenna for
C                                       the SN row source
         HL = TWOPI*SIDT*CTIM + GSTIAT + STNLON(IANT) - RAC(SID)
         COSZ = DCOS(STNLAT(IANT))*DCOS(DECC(SID))*COS(HL) +
     *      DSIN(STNLAT(IANT))*DSIN(DECC(SID))
C                                       source is under horizon
         IF (COSZ.LT.0.0) GO TO 500
         ELEV = PI/2.0 - ACOS(COSZ)
C                                       B coefficient for IANT
         BCO = TWOPI*SIDT*
     *         DCOS(STNLAT(IANT))*DCOS(DECC(SID))*SIN(HL)
C                                       Is the reference antenna
C                                       in the selected antenna list?
         DO 360 RANT = 1,NSTNS
            IF (TELNO(RANT).EQ.REFN) GO TO 370
  360       CONTINUE
         GO TO 500
C                                       calculate elevation of the
C                                       SN row reference antenna
C                                       for the SN row source
  370    HL = TWOPI*SIDT*CTIM + GSTIAT + STNLON(RANT) - RAC(SID)
         COSZ = DCOS(STNLAT(RANT))*DCOS(DECC(SID))*COS(HL) +
     *      DSIN(STNLAT(RANT))*DSIN(DECC(SID))
C                                       source is under horizon
         IF (COSZ.LT.0.0) GO TO 500
         ELEREF = PI/2.0 - ACOS(COSZ)
C                                       B coefficient for RANT
         BCOR = TWOPI*SIDT*
     *         DCOS(STNLAT(RANT))*DCOS(DECC(SID))*SIN(HL)
C
         SOUANT = SID + NIDC*(IANT-1)
         ITIME(SOUANT) = ITIME(SOUANT) + 1
         INDTIM = ITIME(SOUANT) + NTIME(SOUANT)
         IF (INDTIM.LE.MAX2) THEN
C                                       mapping function is cosec(EL)
            IF (ELEV.GT.0.01) MAPANT = 1/SIN(ELEV)
C                                       mapping function is cosec(EL)
            IF (ELEREF.GT.0.01) MAPREF = 1/SIN(ELEREF)
C                                       store the elevations, time
            MAPX(INDTIM+OFFELE) = MAPANT
            MAPRX(INDTIM+OFFREL) = MAPREF
            TIMX(INDTIM+OFFTIM) = CTIM
C                                       store B coefficients for
C                                       OPTYPE = 'RATE'
C                                       IANT
            BCOEX(INDTIM+OFFBCO) = BCO
C                                       RANT
            BCOERX(INDTIM+OFFBCR) = BCOR
C
C                                       store the reference antennas
C                                       For each source/antenna
            ANTREF(INDTIM+OFFREF) = RANT
         ELSE
            WRITE (MSGTXT,1100) MAX2
            IERR = 1
            GO TO 990
            END IF

C                                       find MIN and MAX time
         XAXIMX = MAX(XAXIMX, TIMX(INDTIM+OFFTIM))
         XAXIMN = MIN(XAXIMN, TIMX(INDTIM+OFFTIM))
C                                       eliminate the flag points
C                                       including the flag points of
C                                       the previous edit iteration
C        IF (VAL(INDTIM+OFFVAL).EQ.FBLANK) GO TO 500
C                                       average VALs through all IFs
C                                       and stokes
         VALCUR = 0
         IIFSTO = 0
         DO 390 JIF = 1,NNIF
            KIF = BIF + JIF -1
            DO 380 JS = 1,NS
               KS = ISTOK + JS -1
C                                       chose a type of variable
C                                       mdel, phase, rate
               IF (ICODE.EQ.1) THEN
C                                       MBDELY should be identical
C                                       for all IFS. So use only
C                                       JIF=1
                  IF (JIF .GT. 1) GO TO 380
                  IF (MBDELY(KS).EQ.FBLANK) THEN
                     GO TO 380
                  ELSE
                     IIFSTO = IIFSTO + 1
C                                       delay in mm
                     VALCUR = VALCUR +
     *                  MBDELY(KS) *VELITE *1000
                     END IF
C                                       'phas'
               ELSE IF (ICODE.EQ.2) THEN
                  IF ((REAL(KS,KIF).EQ.FBLANK) .OR.
     *               (IMAG(KS,KIF).EQ.FBLANK)) THEN
                     GO TO 380
                  ELSE
                     IIFSTO = IIFSTO + 1
C                                       phase delay in mm
                     VALCUR = VALCUR +
     *                  ATAN2(IMAG(KS,KIF), REAL(KS,KIF))
     *                  / TWOPI * LAMBDA(KIF)
                     END IF
C                                       disp
               ELSE IF (ICODE.EQ.3) THEN
C                                       DISP should be identical
C                                       for all IFS. So use only
C                                       JIF=1
                  IF (JIF .GT. 1) GO TO 380
                  IF (DISP(KS).EQ.FBLANK) THEN
                     GO TO 380
                  ELSE
                     IIFSTO = IIFSTO + 1
C                                       dispersion in 1/mm
                     VALCUR = VALCUR +
     *                  DISP(KS) *VELITE *1000
                     END IF
C                                       'rate'
               ELSE IF (ICODE.EQ.4) THEN
                  IF (RATE(KS,KIF).EQ.FBLANK) THEN
                     GO TO 380
                  ELSE
C                                       the average RATE through
C                                       IFs and Stokes
                     IIFSTO = IIFSTO + 1
C                                       rate in sec/sec
C                                       VALCUR in mm/day
                     VALCUR = VALCUR + RATE(KS,KIF)*
     *                  VELITE *1D3*24.*60.*60./SIDT
                     END IF
                  END IF
C
 380           CONTINUE
 390        CONTINUE
C                                       find MAX&MIN of the value
C                                       for each ANT
C
C                                       exclude blanked points
         IF (IIFSTO.GT.0) THEN
C                                       VALUE.NE.FBLANK at least
C                                       for one IF,STOKES
            VALCUR = VALCUR / IIFSTO
C
C-----------start simulating rate having used delay at zenith----
            IF (APARM(10) .EQ. 314) THEN
               IF (ICODE .EQ. 4) THEN
                  VALRAT = VALCUR
                  TIMARG = CTIM - TIMCEN
                  TCOEFR = -25.001
                  ACOEFR = 253.323
                  BCOEFR = 2261.66
C
                  IF (IANT .EQ. 1) THEN
                     TCOEF = -119.322
                     ACOEF = -243.506
                     BCOEF = 2818.778
                     A0CLO = 0
                     A1CLO = 10
                     END IF
                  IF (IANT .EQ. 2) THEN
                     TCOEF = 50.059
                     ACOEF = 965.049
                     BCOEF = 5010.373
                     A0CLO = 0
                     A1CLO = 20
                     END IF
                  IF (IANT .EQ. 4) THEN
                     TCOEF = 12.624
                     ACOEF = 411.644
                     BCOEF = 1107.273
                     A0CLO = 0
                     A1CLO = 40
                     END IF
                  IF (IANT .EQ. 5) THEN
                     TCOEF = -554.449
                     ACOEF = 453.446
                     BCOEF = 28466.748
                     A0CLO = 0
                     A1CLO = 50
                     END IF
                  IF (IANT .EQ. 6) THEN
                     TCOEF = -19.819
                     ACOEF = -10.504
                     BCOEF = 1504.642
                     A0CLO = 0
                     A1CLO = 60
                     END IF
                  IF (IANT .EQ. 7) THEN
                     TCOEF = 11.242
                     ACOEF = 240.817
                     BCOEF = 940.816
                     A0CLO = 0
                     A1CLO = 70
                     END IF
                  IF (IANT .EQ. 8) THEN
                     TCOEF = 3.624
                     ACOEF = 352.213
                     BCOEF = 1402.638
                     A0CLO = 0
                     A1CLO = 80
                     END IF
C
                  VALCUR = TCOEF*(BCO*MAPANT**2) +
     *                  ACOEF *(MAPANT + BCO*TIMARG*MAPANT**2) +
     *                  BCOEF *(MAPANT*2*TIMARG + BCO*TIMARG**2*MAPANT
     *                  **2)- TCOEFR*(BCOR*MAPREF**2) -ACOEFR *(MAPREF +
     *                  BCOR*TIMARG*MAPREF**2) -BCOEFR *(MAPREF*2*TIMARG
     *                  + BCOR*TIMARG**2*MAPREF**2)+ A0CLO + A1CLO
                  IF (ISNRNO .LE. 300) THEN
                     WRITE (MSGTXT,3000) SID, IANT, VALRAT, VALCUR
                     CALL MSGWRT (8)
 3000                FORMAT ('SID=', I3,'  IANT=', I3, '  VALRAT=', F10
     *                  .1,'  VALCUR=', F10.1)
                     END IF

                  END IF
               END IF
C---------end simulating rate having used delay at zenith----
C
            VALMX(IANT) = MAX(VALMX(IANT), VALCUR)
            VALMN(IANT) = MIN(VALMN(IANT), VALCUR)
         ELSE
C                                       VALCUE.EQ.FBLANK for all
C                                       IF,STOKES
            VALCUR = FBLANK
            END IF
         VAL(INDTIM+OFFVAL) = VALCUR
         VALSAV(INDTIM+OFFVSA) = VALCUR
         IF (VALCUR.EQ.FBLANK) GO TO 500

         TIMARG = CTIM - TIMCEN
C
C                                       do not estimate RESID for the
C                                       first try when there is not
C                                       a solution yet
         IF (ITER.GT.0) THEN
            RESID = VALCUR
            DO 410 IC=1,NFITA
               IFIT = IC + NFITA*(IANT-1)
               RFIT = IC + NFITA*(RANT-1)
               IF (IC.LE.NFITAT) THEN
                  RESID = RESID - SOL(IFIT)*(TIMARG**(IC-1)) * MAPANT
     *               + SOL(RFIT)*(TIMARG**(IC-1)) * MAPREF
C                                       clock error of IANT
               ELSE
                  RESID = RESID - SOL(IFIT)*(TIMARG**(IC-(NFITAT+1)))
                  END IF
 410           CONTINUE
C                                       flag the point if...
C                                       and skip it
            IF (ABS(RESID).GT.NRMS*RMSD) THEN
               VAL(INDTIM+OFFVAL) = FBLANK
               GO TO 500
               END IF
            END IF
C
         NOBS = NOBS + 1
         SUM = SUM + VALCUR
         SSQ = SSQ + VALCUR*VALCUR
C                                       Prepare result vector R(NFIT)
C                                       and matrix MATR(NFIT*NFIT)
C                                       for routine LEASQR
C  --------------------------------------------------------------------
C I        Each measurement (the SN table row) is fitted as:           |
C |  SUM(I=1..NFITAT) [F(I+NFITA*(IANT-1))] * MAPANT                   |
C | +SUM(I=1..NFITCL) [F(I+NFITAT+NFITA*(IANT-1))                      |
C | -SUM(I=1..NFITAT) [F(I+NFITA*(REFA-1))] * MAPREF                   |
C  --------------------------------------------------------------------
C
         TIMARG = CTIM - TIMCEN
         DO 430 IC=1,NFITA
            IFIT = IC + NFITA*(IANT-1)
            RFIT = IC + NFITA*(RANT-1)


C
            IF (ICODE .LT. 4) THEN
C                                       OPTYPE = 'MDEL', or 'PHAS'
               IF (IC.LE.NFITAT) THEN
C                                       coefficients for zenith
C                                       atmosphere
                  CCANT(IC) = (TIMARG**(IC-1)) * MAPANT
                  CCREF(IC) = (TIMARG**(IC-1)) * (-MAPREF)
               ELSE
C                                       coefficients for clocks
                  CCANT(IC) = TIMARG**(IC-(NFITAT+1))
                  CCREF(IC) = 0
                  END IF
            ELSE
C                                       OPTYPE = 'RATE'
               IF (IC.LE.NFITAT) THEN
C                                       coefficients for zenith
C                                       atmosphere
                  CCANT(IC) =  (MAPANT*(IC-1)*TIMARG**(IC-2) +
     *               MAPANT**2 * BCO* TIMARG**(IC-1))
                  CCREF(IC) = -(MAPREF*(IC-1)*TIMARG**(IC-2) +
     *               MAPREF**2 * BCOR*TIMARG**(IC-1))
               ELSE
C                                       coefficients for clocks
                  CCANT(IC) = (IC-(NFITAT+1))*
     *               TIMARG **(IC-(NFITAT+1) -1)
                  CCREF(IC) = 0
                  END IF
               END IF
C
            R(IFIT) = R(IFIT) + VALCUR*CCANT(IC)
            R(RFIT) = R(RFIT) + VALCUR*CCREF(IC)
C
  430       CONTINUE
C                                       calculate matrix MATR
         DO 450 IC = 1, NFITA
C                                       IFIT,KFIT are column number
            IFIT = IC + NFITA*(IANT-1)
            KFIT = IC + NFITA*(RANT-1)
            DO 440 KC = 1, NFITA
C                                       LFIT,MFIT are row numbers
               LFIT = KC + NFITA*(IANT-1)
               MFIT = KC + NFITA*(RANT-1)
C                                       START OPTYPE = 'MDEL', or 'PHAS'
C
C                                       for IANT,IANT connections
               LIFIT = LFIT + (IFIT-1)*NFIT
               MATR(LIFIT) = MATR(LIFIT) + CCANT(IC)*CCANT(KC)
C                                       for REFN,IANT connections
               MIFIT = MFIT + (IFIT-1)*NFIT
               MATR(MIFIT) = MATR(MIFIT) + CCANT(IC)*CCREF(KC)
C                                       for IANT, REFN connections
               LKFIT = LFIT + (KFIT-1)*NFIT
               MATR(LKFIT) = MATR(LKFIT) + CCREF(IC)*CCANT(KC)
C                                       for REFN, REFN connections
               MKFIT = MFIT + (KFIT-1)*NFIT
               MATR(MKFIT) = MATR(MKFIT) + CCREF(IC)*CCREF(KC)
  440          CONTINUE
  450       CONTINUE
 500     CONTINUE
C                                       store the only reference antenna
      IF (REFEQU) REFNN = RANT
C                                       find the solition for each
C                                       selected antenna atm. senith
C                                       delay and clock error
C                                       All antenna differences were
C                                       used together to find solution
C                                       for all antennas
C
      CALL DLESQR (NFIT, NOBS, SUM, SSQ, R, MATR, SOL, VX, SSQRES,
     *   VARRES, VARY, FIT, LESOL)
C                                       estimate r.m.s of
C                                       the SN table data
      RMSD = SQRT(VARRES)
C                                       or
C      RMSD = SQRT(SSQRES/NOBS)

C                                       go back to next iteration
      ITER = ITER + 1
      IF (ITER.LE.NITER) GO TO 260
C                                       Close table.
      CALL TABIO ('CLOS', 0, ISNRNO, IFCHW, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 900
      GO TO 999
C                                       TABIO error
 900  WRITE (MSGTXT,1900) IERR
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('!!!!! center of the data is at ', F10.5, ' !!!!!')
 1100 FORMAT ('Product NANT*NTIME exceeds MAX = ', I6)
 1900 FORMAT ('TABIO: ERROR = ', I3)
      END
      SUBROUTINE SOUSEL (SOURCE, NSOUR, DISK, CNO, CAT, BIF, NNIF,
     *   BUFFER, ID, NID, RA, DEC, SOUS, FLUXS, IRET)
C-----------------------------------------------------------------------
C   Load all selected source identifiers from SU table.
C-----------------------------------------------------------------------
C   Inputs:
C      SOURCE  C*16(*)   List of source names.
C                        If the first character of any source names
C                        begins with a "-", all sources EXCEPT those
C                        named will be returned ( the "-" will be
C                        ignored in determining the source name).
C                        Blank source names are ignored.  Names should
C                        be left justified, blank filled
C      NSOUR     I       Number of entries in SOURCE
C      DISK      I       Disk number of the data set.
C      CNO       I       Catalog slot number of data set.
C      CAT       I(256)  Catalog header.
C      BIF       I       Beginning IF
C      NNIF      I       Number of selected IFs
C   Input/Output:
C      BUFFER    I(512)  Work buffer, used for I/O and manipulating
C                        source lists, should be at least min (512,NID)
C   Output:
C      ID        I(*)    Sources ID numbers of selected sources,
C      NID       I       Number of elements returned in ID.
C      RA        D(*)    Array of selected calibrators' RA
C      DEC       D(*)    Array of selected calibrators' declinations
C      SOUS      C*16(*) Names of selected sources
C      FLUXS     R(*)    Flux density of selected sources
C      IRET      I       Return code. 0 => OK; else failed.
C   Usage notes:
C       This routine uses AIPS LUN 27 which will be closed on normal
C       return. Version 1 of the source table is assumed.
C-----------------------------------------------------------------------
      CHARACTER SOURCE(*)*16, SOUS(*)*16, SOUST(50)*16
      INTEGER   DISK, CNO, NID, CAT(256), BUFFER(*), ID(*), KID, IID,
     *   IDT(50), BIF, NNIF, IRET
C
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4
      INTEGER   VER, LUN, IDKOL, SUKOL,IDSOU, SQUAL, MAXID,
     *   NUMIF, ISURNO, NUMREC, I4, SUFQID, NSOUR, I, J, SKIF, SIF
      LOGICAL   EQUAL, DESEL, ALLBL, GOTIT
      DOUBLE PRECISION    BANDW, RAEPO, DECEPO, EPOCH, RAAPP, DECAPP,
     *   PMRA, PMDEC, RA(*), DEC(*), PI, DEGRAD, RAT(50), DECT(50),
     *   RAOBS, DECOBS
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   SUKOLS(MAXSUC), SUNUMV(MAXSUC)
      REAL      FLUX(4,MAXIF), FREQO(MAXIF), RESTFQ(MAXIF), FLUXS(*),
     *   FLUXST(800)
      DOUBLE PRECISION LSRVEL(MAXIF)
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (IDKOL, SUKOLS(1)),   (SUKOL, SUKOLS(2))
      DATA VER, LUN /1, 27/
      DATA PI /3.14159265358979323846D0/
C-----------------------------------------------------------------------
      DEGRAD = PI/180.0D0
      MAXID = NID
      NID = 0
      IRET = 0
      DESEL = .FALSE.
      ALLBL = .TRUE.
      DO 10 I = 1,NSOUR
C                                       Check deselection
         DESEL = DESEL .OR. SOURCE(I)(1:1).EQ.'-'
C                                       Check if all blank, select
         ALLBL = ALLBL .AND. (SOURCE(I).EQ.'                ')
C
 10      CONTINUE
C                                       Initialize SOURCE table.
      CALL SOUINI ('READ', BUFFER, DISK, CNO, VER, CAT, LUN, NUMIF,
     *   VELTYP, VELDEF, SUFQID, ISURNO, SUKOLS, SUNUMV, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
         END IF
C                                       number of subrows (IFS)
C                                       Get number of entries
      NUMREC = BUFFER(5)
C                                       Loop through source records.
      DO 500 ISURNO = 1,NUMREC
C                                       Read record
         I4 = ISURNO
         CALL TABSOU ('READ', BUFFER, I4, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, SQUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA,
     *      PMDEC, IRET)
C                                       See is source record turned off
         IF (IRET.LT.0) GO TO 500
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
            END IF
C                                       Check if in list SOURCE.
         GOTIT = .FALSE.
         DO 300 J = 1,NSOUR
C                                       See if deselected.
            IF (.NOT.DESEL) THEN
C                                       Sources selected.
               EQUAL = SOURCE(J).EQ.SOUNAM
C                                       cover blank source
               EQUAL = EQUAL .OR. ALLBL
               IF (EQUAL) THEN
                  IF ((NID+1).LE.MAXID) THEN
                     NID = NID + 1
                     ID(NID) = IDSOU
                     RA(NID) = RAAPP*DEGRAD
                     DEC(NID) = DECAPP*DEGRAD
                     SOUS(NID) = SOUNAM
C                                       take IFLUX
                     DO 20 I = 1, NNIF
                        SIF = I + (NID-1)*NNIF
                        FLUXS(SIF) = FLUX(1,I +BIF -1)
                        IF (FLUXS(SIF).EQ.0.0) FLUXS(SIF) = 1.0
   20                   CONTINUE
                     GO TO 500
                  ELSE
C                                       Too many sources selected
                     WRITE (MSGTXT,1300) MAXID
                     IRET = 5
                     GO TO 990
                     END IF
                  END IF
            ELSE
C                                       Deselected
C                                       Check for leading "-"
               IF (SOURCE(J)(1:1).EQ.'-') THEN
                  EQUAL = SOURCE(J)(2:16).EQ.SOUNAM(1:15)
               ELSE
                  EQUAL = SOURCE(J).EQ.SOUNAM
                  END IF
               GOTIT = GOTIT .OR. EQUAL
               END IF
 300        CONTINUE
            IF (DESEL .AND. (.NOT.GOTIT)) THEN
C                                       Source not deselected
               IF ((NID+1).LE.MAXID) THEN
                  NID = NID + 1
                  ID(NID) = IDSOU
                  RA(NID) = RAAPP*DEGRAD
                  DEC(NID) = DECAPP*DEGRAD
                  SOUS(NID) = SOUNAM
                  DO 320 I = 1, NNIF
                     SIF = I + (NID-1)*NNIF
                     FLUXS(SIF) = FLUX(1,I +BIF -1)
 320                 CONTINUE
               ELSE
C                                       Too many sources selected
                  WRITE (MSGTXT,1300) MAXID
                  IRET = 5
                  GO TO 990
                  END IF
               END IF
 500     CONTINUE
C                                       Close Source table
      CALL TABIO ('CLOS', 0, I4, FLUX, BUFFER, IRET)

C                                       sort sources if they named
      IF ((.NOT.DESEL) .AND. (.NOT.ALLBL)) THEN
         KID = 0
         DO 580 J = 1, NSOUR
            DO 560 IID = 1, NID
               IF (SOURCE(J).EQ.SOUS(IID)) THEN
                  KID = KID + 1
                  IDT(KID) = ID(IID)
                  RAT(KID) = RA(IID)
                  DECT(KID) = DEC(IID)
                  SOUST(KID) = SOUS(IID)
                  DO 520 I = 1, NNIF
                     SKIF = I + (KID-1)*NNIF
                     SIF = I + (IID-1)*NNIF
                     FLUXST(SKIF) = FLUXS(SIF)
 520                 CONTINUE
                  END IF
 560           CONTINUE
 580        CONTINUE
         NID = KID
         DO 600 IID = 1, NID
            ID(IID) = IDT(IID)
            RA(IID) = RAT(IID)
            DEC(IID) = DECT(IID)
            SOUS(IID) = SOUST(IID)
            DO 590 I = 1, NNIF
               SIF = I + (IID-1)*NNIF
               FLUXS(SIF) = FLUXST(SIF)
 590          CONTINUE
 600        CONTINUE
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('SOUSEL: ERROR ',I3,' INITIALIZING SOURCE TABLE')
 1120 FORMAT ('SOUSEL: ERROR ',I3,' READING SOURCE TABLE')
 1300 FORMAT ('SOUSEL: MORE SOURCES SELECTED THAN MAX (',I5,')')
      END
      SUBROUTINE ANTSEL (XANT, NANTSL, SUBA, DISK, CNO, CAT,
     *   BUFFER, IRET)
C-----------------------------------------------------------------------
C   Select anntennas from AN file
C-----------------------------------------------------------------------
C   Inputs:
C      XANT      R(*)    List of antennas numbers.
C                        If any of the numbers is negative all antennas
C                        EXCEPT those named will be returned
C      NANTSL    I       Number of entries in XANT
C      DISK      I       Disk number of the data set.
C      CNO       I       Catalog slot number of data set.
C      CAT       I(256)  Catalog header.
C   Outputs sent to COMMON (DANS.INC):
C      NSTNS    I        Number of elements returned in TELNO
C      STNNAM   C(*)*8   Antenna names
C      TELNO    I(*)     Antennas numbers of selected antennas
C      STNX     D(*)     X (meters)
C      STNY     D(*)     Y (meters)
C      STNZ     D(*)     Z (meters)
C      STNLAT   D(*)     Antenna latitude (rad).
C      STNLON   D(*)     Antenna east longitude (rad).
C      STNRAD   D(*)     Antenna radius from earth center (meter)
C      STNEPL   R(2,*)   Feed real/elipticity (poln, IF)
C      STNORI   R(2,*)   Feed imag/orientation (poln, IF)
C      STNPST   C*8      Feed solution type:
C                           'APPROX  ' => linear approximation
C                           'ORI-ELP ' => orientation-ellipticity
C      TIMLAB   C*8      Time system label (e.g. 'IAT', 'UTC')
C      ANTUTC   R        UT1-UTC (time sec)
C      ANTIAT   R        Data time - UTC (sec)
C      GSTIAT   D        GST (rad) at IAT=0 on reference date.
C      ROTIAT   D        Rotation rate of the earth in IAT (Radians/day)
C      ANTUTC   R        UT1-UTC (time sec)
C      ANTIAT   R        Data time - UTC (sec)
C      FQIDAN   I        FQID for which polzn properties determined.
C   Output:
C      BUFFER    I(512)  Work buffer
C      IRET      I       Return code. 0 => OK; else failed.
C   Usage notes:
C       This routine uses AIPS LUN 27 which will be closed on normal
C       return. Version 1 of the source table is assumed.
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, IANT, CAT(256), BUFFER(*), I, J, MXAN,
     *   ANTENS(50), NANTSL, LIMIT, NEXT, SUBA, INTANT, IRET
      REAL      XANT(*)
      LOGICAL   EQUAL, DESEL, ALLANT, GOTIT
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      MXAN = NANTSL
C                                       Get antenna info
      CALL GETANT (DISK, CNO, SUBA, CAT, BUFFER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
         END IF
C                                       Antenna list
      ALLANT = .TRUE.
      DESEL = .FALSE.
      DO 10 I = 1, NANTSL
         ANTENS(I) = 0
         ALLANT = ALLANT .AND. (ABS (XANT(I)).LE.1.0E-10)
         DESEL = DESEL .OR. (XANT(I).LT.-0.5)
 10      CONTINUE
      IF (ALLANT) THEN
         NANTSL = NSTNS
         GO TO 60
         END IF
      NEXT = 1
C                                       Not all selected - make list
C                                       ANTENNAS array worriing repeating
         DO 50 I = 1,50
            IF (XANT(I).EQ.0) GO TO 50
C                                       See if already have
               INTANT = XANT(I)
               LIMIT = NEXT - 1
               IF (LIMIT.LT.1) GO TO 40
               DO 30 J = 1,LIMIT
                  IF (INTANT.EQ.ANTENS(J)) GO TO 50
 30               CONTINUE
C                                       New antenna
 40               ANTENS(NEXT) = XANT(I)
                  NEXT = NEXT + 1
 50            CONTINUE
      NANTSL = NEXT - 1
 60   CONTINUE
C                                       Setup
      IANT = 0
      IRET = 0
C                                       Loop through AN file records.
      DO 500 I = 1,NSTNS
C                                       Check if in list XANT.
         GOTIT = .FALSE.
         DO 300 J = 1, NANTSL
C                                       See if deselected.
            IF (.NOT.DESEL) THEN
C                                       Sources selected.
               EQUAL = ANTENS(J).EQ.TELNO(I)
C                                       cover blank antens
               EQUAL = EQUAL .OR. ALLANT
               IF (EQUAL) THEN
                  IF ((IANT+1).LE.MXAN) THEN
                     IANT = IANT + 1
                     STNNAM(IANT) = STNNAM(I)
                     TELNO(IANT) = TELNO(I)
                     STNX(IANT) = STNX(I)
                     STNY(IANT) = STNY(I)
                     STNZ(IANT) = STNZ(I)
                     STNLAT(IANT) = STNLAT(I)
                     STNLON(IANT) = STNLON(I)
                     STNRAD(IANT) = STNRAD(I)
                     GO TO 500
                  ELSE
C                                       Too many antenns selected
                     WRITE (MSGTXT,1300) MXAN
                     IRET = 5
                     GO TO 990
                     END IF
                  END IF
            ELSE
C                                       Deselected
               EQUAL = ABS(ANTENS(J)).EQ.TELNO(I)
               GOTIT = GOTIT .OR. EQUAL
               END IF
 300        CONTINUE
            IF (DESEL .AND. (.NOT.GOTIT)) THEN
C                                       Antens not deselected
               IF ((IANT+1).LE.MXAN) THEN
                  IANT = IANT + 1
                  STNNAM(IANT) = STNNAM(I)
                  TELNO(IANT) = TELNO(I)
                  STNX(IANT) = STNX(I)
                  STNY(IANT) = STNY(I)
                  STNZ(IANT) = STNZ(I)
                  STNLAT(IANT) = STNLAT(I)
                  STNLON(IANT) = STNLON(I)
                  STNRAD(IANT) = STNRAD(I)
                  GO TO 500
               ELSE
C                                       Too many antenns selected
                  WRITE (MSGTXT,1300) MXAN
                  IRET = 5
                  GO TO 990
                  END IF
               END IF
 500     CONTINUE
      NSTNS = IANT
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ANTSEL:',I3,' READING ANTENNA TABLE')
 1300 FORMAT ('ANTSEL: MORE ANTENS SELECTED THAN MAX (',I5,')')
      END
      SUBROUTINE PLTFIT (IRET)
C-----------------------------------------------------------------------
C   PLTFIT plots the data thru calls to PLTEL
C   Output:
C      IRET     I  Return code, 0=OK else failed
C-----------------------------------------------------------------------
      INTEGER   IRET
      INTEGER   MFITA
      PARAMETER (MFITA = 200)
      INTEGER   IPLOT, IPLT, IANT, ITIM, IT, IFIT, IIFIT,
     *   MXFIT, ITS, SOUANT, SID
      LOGICAL GOOD
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'DELZN.INC'
      REAL      FITPAR(MFITA), RMS(MFITA), FITREF(MFITA),
     *   RMSREF(MFITA), TOLER(5), TMAX, TMIN,
     *   TDIF, SIZEX, SIZEY, TEMP
      CHARACTER MEAS(3)*10, ATMCLO*6
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA TOLER /2.0, 2.0, 2.0, 0.0, 0.0/
      DATA MEAS /'mm', 'mm/day', 'mm/day/day'/
C-----------------------------------------------------------------------
      IRET = 0
      MXFIT = MAXFIT
C                                       initialize fit parameters
      CALL RFILL (MXFIT, 0.0, FITPAR)
      CALL RFILL (MXFIT, 0.0, FITREF)
C                                       Print out FITREF if there is
C                                       only one reference antenna:
C                                       REFNN
      IF (REFEQU) THEN
         DO 20 IFIT = 1, NFITA
            FITREF(IFIT) = SOL(IFIT + NFITA*(REFNN-1))
C                                       recalculate the variances of
C                                       the fit parameters to its RMS
            RMSREF(IFIT) = 0.0
            IF (VX(IFIT + NFITA*(REFNN-1)).GE.0) RMSREF(IFIT) =
     *         SQRT (VX(IFIT + NFITA*(REFNN-1)))
            IF (PRTLEV.GT.0) THEN
               IF (IFIT .LE. NFITAT) THEN
                  ATMCLO = '|ATMOS'
                  IIFIT = IFIT
               ELSE
                  ATMCLO = '|CLOCK'
                  IIFIT = IFIT - NFITAT
                  END IF
               WRITE (MSGTXT,1010) 'Ref ',TELNO(REFNN), IFIT,
     *               FITREF(IFIT), RMSREF(IFIT), MEAS(IIFIT), ATMCLO
                  CALL MSGWRT (5)
               END IF
20          CONTINUE
         END IF
C                                       Find last plot
      NPLOTS = 0
      DO 50 IANT = 1, NSTNS
         ITIM = 0
         DO 30 SID = 1, NIDC
            SOUANT = SID + NIDC*(IANT-1)
            ITIM = ITIM + ITIME(SOUANT)
 30         CONTINUE
C                                       Skip the antenna if ITIM=0
C                                       because DELUV skiped such lines
C                                       (IANT=REFN)
         IF (ITIM.GT.0) NPLOTS = NPLOTS + 1
 50      CONTINUE
C
      IF (DORES) NPLOTS = 2*NPLOTS

      IF (NPLOTS.LE.0) GO TO 980
C                                       Prepare parameters for PLTFIT
C                                       thru PLTEL
      SIZEX = 1000.0
      SIZEY = 1000.0 / NCOUNT
      IPLT = 0
C                                       Loop through plots
      DO 200 IANT = 1,NSTNS
         CURANT = IANT
         ITIM = 0
         DO 60 SID = 1, NIDC
            SOUANT = SID + NIDC*(IANT-1)
            ITIM = ITIM + ITIME(SOUANT)
 60         CONTINUE
         IF (ITIM.EQ.0) GO TO 200
C
         GMXX = -1.0E20
         GMNX = 1.0E20
C
         ITS = 0
         DO 80 SID = 1,NIDC
            SOUANT = SID + NIDC*(IANT-1)
            ITIM = ITIME(SOUANT)
            DO 70 IT = 1,ITIM
               INDTIM = IT + NTIME(SOUANT)
C                                       exclude blanked points
               TEMP = VAL(INDTIM+OFFVAL)
               IF (APARM(7).GT.0.0) TEMP = VALSAV(INDTIM+OFFVSA)
               IF (TEMP.NE.FBLANK) THEN
                  ITS = ITS + 1
C                                       store the given and reference
C                                       antenna map functions, times,
C                                       values and list of reference
C                                       antennas
                  MAPITS(ITS) = MAPX(INDTIM+OFFELE)
                  MAPRIT(ITS) = MAPRX(INDTIM+OFFREL)
                  TIMITS(ITS) = TIMX(INDTIM+OFFTIM)
                  VALU1(ITS) = TEMP
                  ANTRTS(ITS) = ANTREF(INDTIM+OFFREF)
C                                       store the B coefficients for
C                                       given and reference antennas
                  BCOITS(ITS) = BCOEX(INDTIM+OFFBCO)
                  BCORIT(ITS) = BCOERX(INDTIM+OFFBCR)
                  END IF
 70            CONTINUE
 80         CONTINUE
C                                       solution for gain's coefficients
C
         DO 82 IFIT = 1, NFITA
C                                       NFITA = 3, 4, or 5
            FITPAR(IFIT) = SOL(IFIT + NFITA*(IANT-1))
C                                       recalculate the variances of
C                                       the fit parameters to its RMS
            IF (VX(IFIT+NFITA*(IANT-1)).GE.0) RMS(IFIT) =
     *         SQRT (VX(IFIT + NFITA*(IANT-1)))
            IF (PRTLEV.GT.0) THEN
               IF (IFIT .LE. NFITAT) THEN
                  ATMCLO = '|ATMOS'
                  IIFIT = IFIT
               ELSE
                  ATMCLO = '|CLOCK'
                  IIFIT = IFIT - NFITAT
                  END IF
               WRITE (MSGTXT,1010) ' ', TELNO(IANT), IFIT, FITPAR(IFIT),
     *            RMS(IFIT), MEAS(IIFIT), ATMCLO
               CALL MSGWRT (5)
               END IF
   82       CONTINUE
         IF (DOHIST) THEN
            NUMHIS = NUMHIS + 1
            WRITE (HISCRD(NUMHIS),1140) TELNO(IANT), FITPAR(1),
     *         FITPAR(2), FITPAR(3)
            END IF
C                                       plot the values and model
C                                       versus time
         GOOD = .FALSE.
         DO 115 IFIT = 1, NFITA
            IF (FITPAR(IFIT).NE.0) GOOD = .TRUE.
  115       CONTINUE
C                                       The antenna is bad if solution
C                                       is not found
         IF (.NOT.GOOD) THEN
            NPLOTS = NPLOTS - 1
            GO TO 200
            END IF
         IPLT = IPLT + 1
         IPLOT = IPLT - 1
         IPLOT = MOD (IPLOT, NCOUNT) + 1
         IF (IPLT.EQ.NPLOTS) IPLOT = -IPLOT
C                                       TMAX, TMIN new MAX&MIN of Y
         TMAX = VALMX(IANT) + 0.1*(VALMX(IANT)-VALMN(IANT))
         TMIN = VALMN(IANT) - 0.1*(VALMX(IANT)-VALMN(IANT))
         IF (ABS (TMAX-TMIN).LT.TOLER(ICODE)) THEN
            TMAX = TMAX + TOLER(ICODE)
            TMIN = TMIN - TOLER(ICODE)
            END IF
C                                       GMXX, GMNX MAX&MIN of Y for all
C                                       plots until the current one
         GMXX = MAX (GMXX, TMAX)
         GMNX = MIN (GMNX, TMIN)
         TDIF = TMAX - TMIN
         IF (ABS (TDIF).LE.1.0E-25) TDIF = 1.0E-25
         XYOFF(2) = TMIN
         XYSCL(2) = SIZEY / TDIF
C                                       now about X-axis
         TMAX = (XAXIMX + 0.1 * (XAXIMX - XAXIMN))
         TMIN = (XAXIMN - 0.1 * (XAXIMX - XAXIMN))
         TDIF = TMAX - TMIN
         IF (ABS (TDIF).LE.0.01) TDIF = 0.01
         XYOFF(1) = TMIN
         XYSCL(1) = SIZEX / TDIF
C                                       plot VALU/TIMITS and model
         IF (DOPLOT) THEN
            DOTWO = .FALSE.
C                                       If ref. antenna is not constant
C                                       do not plot it
            IF (DOREF .AND. .NOT.REFEQU) THEN
               WRITE (MSGTXT,1300)
               CALL MSGWRT (3)
               GO TO 200
               END IF
            CALL PLTEL (IPLOT, ITS, FITPAR, FITREF, IRET)
            IF (IRET.NE.0) DOPLOT = .FALSE.
C                                       plot residuals
            IF (DORES) THEN
               DOTWO  = .TRUE.
               IPLT = IPLT + 1
               IPLOT = IPLT - 1
               IPLOT = MOD (IPLOT, NCOUNT) + 1
               IF (IPLT.EQ.NPLOTS) IPLOT = -IPLOT
               CALL PLTEL (IPLOT, ITS, FITPAR, FITREF, IRET)
               IF (IRET.NE.0) DOPLOT = .FALSE.
               END IF
            END IF
 200     CONTINUE
C                                       SQRT  of residuals variance
      IF (PRTLEV.GT.1) THEN
         WRITE (MSGTXT,1182) SQRT(VARRES)
         CALL MSGWRT (3)
         END IF
      GO TO 999
C                                       No baselines
 980  IRET = 8
      WRITE (MSGTXT,1200)
      CALL MSGWRT (2)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (A4,'ANT ',I2,': FitPar',I2,F11.3,' (',F8.3,') ',A10,1X,
     *   A6)
 1140 FORMAT ('ANT=',I2,':',1PE10.3,' +',1PE10.3,'*T +',1PE10.3,'*T**2')
 1182 FORMAT (2X, 'SQRT of variance of the residuals = ',F6.3,'mm')
 1200 FORMAT ('PLTFIT: No data for sources selected')
 1300 FORMAT ('Ref. antenna is not constant. So the plots are canceled')
      END
      SUBROUTINE PLTEL (IPLOT, ITIM, FITPAR, FITREF, IRET)
C-----------------------------------------------------------------------
C   PLTEL actually plots data and model.
C   Input:
C      IPLOT   I    Plot number on current page. If neg. then this is
C                   last plot.
C      ITIM    I     Number of points at arrays TIMITS and VALU
C      FITPAR  R(*) Array of parameters of ANT fitting function
C      FITREF  R(*) Array of parameters of REFA fitting function
C   Inputs from Common:
C      TIMITS  R(*)  Array of data arguments
C      VALU    R(*)  Array of data function
C      GMNX    R    Max. value to plot
C      GMXX    R    Min. value to plot
C      XMX     R    Max. x value to plot
C      XMN     R    Min. x value to plot
C   Output:
C      IRET    I    Return code, 0 => OK, otherwise abort.
C                     -1 => user request termination
C                      1 => failed to add to catalog
C                      2 => failed to create
C                      3 => graph file write error
C                      4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   IPLOT, IRET, NPMOD
C
      CHARACTER TEXT*132, PFILE*48, ATIME*8, ADATE*12, AUNITS(28)*8,
     *   CHTYPE(28)*16, CHTMP*18, XUNITS*20, TYPE*2
      INTEGER   ELBUFF(256), VER, IERR, ITYPE, IPSIZE, LUNPL, LTYPE,
     *   FINDPL, DEPTH(5), INCHAR, INP, IT(3), ID(3), IAXLAB, IAPLOT,
     *   I, NGOOD, NNOFIT, LABEL, ITT, IFIRST, ITIM
      INTEGER   IFIT, RANT
      REAL      BLC(2), TRC(2), XYRATO, DX, DY, TR, VALUE, TI,
     *   XY(2), XTRC(2), XBLC(2), TLC(2), PLTINC, YYOFF(2), SIZE,
     *   XMULT(2), XVARIB, YPT, DBY, FITPAR(*), FITREF(*), PREV,
     *   ARGUMT
      REAL      MAPANT, MAPREF, BCO, BCOR
      REAL      VALUMX, VALUMN, TMAX, TMIN, TDIF,
     *   SIZEY, TOLER(5)
      LOGICAL   T, F, GOOD, CATUP, CURENT, PREVOS
      SAVE LABEL, LTYPE, ELBUFF
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'DELZN.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGPH.INC'
      DATA LUNPL /26/
      DATA DEPTH /5*1/
      DATA T, F /.TRUE.,.FALSE./
C                                       meters for icode=3 'rate'
      DATA AUNITS /'mm','mm','1/mm','m', 24*' '/
      DATA CHTYPE / 'Atm zenith depth', 'Clock error',
     *              'Refa atm depth', 'Dispersion', 24*' '/
      DATA XUNITS / 'Time (days)'/
      DATA TOLER /2.0, 2.0, 2.0, 0.0, 0.0/
Ctemporal!!!! add later toler(3) rate
C-----------------------------------------------------------------------
C                                       calculate array of zenith
C                                       delays: data
C                                       minus reference antenna zenith
C                                       delay x its mapping function
C                                       minus clock error, devide MAPF

C                                       and its max/min
      VALUMX = -1.0E10
      VALUMN =  1.0E10
      DO 50 ITT = 1,ITIM
         VALU(ITT) = VALU1(ITT)
         XVARIB = TIMITS(ITT) - TIMCEN
         MAPANT = MAPITS(ITT)
         MAPREF = MAPRIT(ITT)
         BCO  = BCOITS(ITT)
         BCOR = BCORIT(ITT)
C
         RANT = ANTRTS(ITT)
C                                       Fit parameters for the
C                                       reference antenna
         DO 10 IFIT = 1, NFITA
            FITREF(IFIT) = SOL(IFIT + NFITA*(RANT-1))
 10         CONTINUE
C
         IF (DOATMA .AND. DOMOD) THEN
C                                       value of zenith delay
C
C                                       add zenith delay under
C                                       the reference antenna

            DO 20 IFIT = 1,NFITAT
C                                       'mdel' or 'phas'
               IF (ICODE.LT.4) THEN
                  VALU(ITT) = VALU(ITT) +
     *               FITREF(IFIT)*(XVARIB**(IFIT-1))*MAPREF
C                                       'rate'
               ELSE
                  VALU(ITT) = VALU(ITT) +
     *               FITREF(IFIT)*(MAPREF*(IFIT-1)*XVARIB**(IFIT-2)
     *               +MAPREF**2 * BCOR*XVARIB**(IFIT-1))
                  END IF
 20            CONTINUE
C                                       subtract the clock error
            DO 30 IFIT = NFITAT+1,NFITA
C                                       'mdel' or 'phas'
               IF (ICODE.LT.4) THEN
                  VALU(ITT) = VALU(ITT) -
     *               FITPAR(IFIT)*(XVARIB**(IFIT-NFITAT-1))
C                                       'rate'
               ELSE
                  VALU(ITT) = VALU(ITT) - FITPAR(IFIT)* (IFIT-NFITAT-1)*
     *               XVARIB **(IFIT-NFITAT -2)
                  END IF
 30            CONTINUE
C                                       'mdel' or 'phas'
            IF (ICODE.LT.4) THEN
               VALU(ITT) = VALU(ITT)/MAPANT
C                                       'rate'
            ELSE
               VALU(ITT) = VALU(ITT)/(BCO*MAPANT**2)
               DO 32 IFIT = 1, NFITAT
C                                       subtract the expression to get
C                                       polynomial presentation of the
C                                       atmosphere at zenith
                  VALU(ITT) = VALU(ITT) -
     *               FITPAR(IFIT)*(IFIT-1)*XVARIB**(IFIT-2) /
     *               (BCO*MAPANT)
 32               CONTINUE


               END IF
            END IF
C                                       value of clock error
        IF (DOCLOC .AND. DOMOD) THEN
            DO 35 IFIT = 1,NFITAT
C                                       add zenith delay over
C                                       the reference antenna
C                                       'mdel' or 'phas'
               IF (ICODE.LT.4) THEN
                  VALU(ITT) = VALU(ITT) +
     *               FITREF(IFIT)*(XVARIB**(IFIT-1))*MAPREF
C                                       'rate'
               ELSE
                  VALU(ITT) = VALU(ITT) +
     *               FITREF(IFIT)*(MAPREF*(IFIT-1)*XVARIB**(IFIT-2)
     *               +MAPREF**2 * BCOR*XVARIB**(IFIT-1))
                  END IF
C                                       subtract zenith delay over
C                                       the current antenna
C                                       'mdel' or 'phas'
               IF (ICODE.LT.4) THEN
                  VALU(ITT) = VALU(ITT) -
     *               FITPAR(IFIT)*(XVARIB**(IFIT-1))*MAPANT
C                                       'rate'
               ELSE
                  VALU(ITT) = VALU(ITT) -
     *               FITPAR(IFIT)*(MAPANT*(IFIT-1)*XVARIB**(IFIT-2)
     *               +MAPANT**2 * BCO*XVARIB**(IFIT-1))
                  END IF
 35            CONTINUE
C                                       subtract/add the expression
C                                       to get polynomial presentation
C                                       of the clock
            DO 37 IFIT = NFITAT+1, NFITA
C                                       subtract the polynomial for
C                                       rate
               IF (ICODE.GE.4) THEN
                  VALU(ITT) = VALU(ITT) -
     *               FITPAR(IFIT)* (IFIT-NFITAT-1)*
     *               XVARIB **(IFIT-NFITAT -2)
C                                       add  the polynomial for
C                                       delay
                  VALU(ITT) = VALU(ITT) +
     *               FITPAR(IFIT)* XVARIB **(IFIT-NFITAT -1)
                  END IF
 37            CONTINUE
            END IF
C                                       value of reference antenna
C                                       delay using the current
C                                       antenna fitting
         IF ((DOREF .AND. REFEQU) .AND. DOMOD) THEN
            DO 40 IFIT = 1,NFITAT
C                                       subtract zenith delay over
C                                       the current antenna
C                                       'mdel' or 'phas'
               IF (ICODE.LT.4) THEN
                  VALU(ITT) = VALU(ITT) -
     *               FITPAR(IFIT)*(XVARIB**(IFIT-1))*MAPANT
C                                       'rate'
               ELSE
                  VALU(ITT) = VALU(ITT) -
     *               FITPAR(IFIT)*(MAPANT*(IFIT-1)*XVARIB**(IFIT-2)
     *               +MAPANT**2 * BCO*XVARIB**(IFIT-1))
                  END IF
 40            CONTINUE
C                                       subtract the clock error
            DO 45 IFIT = NFITAT+1,NFITA
C                                       'mdel' or 'phas'
               IF (ICODE.LT.4) THEN
                  VALU(ITT) = VALU(ITT) -
     *               FITPAR(IFIT)*(XVARIB**(IFIT-NFITAT-1))
C                                       'rate'
               ELSE
                  VALU(ITT) = VALU(ITT) -
     *               FITPAR(IFIT)* (IFIT-NFITAT-1)*
     *               XVARIB **(IFIT-NFITAT -2)
                  END IF
 45            CONTINUE
C                                       'mdel' or 'phas'
            IF (ICODE.LT.4) THEN
               VALU(ITT) = -VALU(ITT) / MAPREF
C                                       'rate'
            ELSE
               VALU(ITT) = -VALU(ITT)/(BCOR*MAPREF**2)
               DO 47 IFIT = 1, NFITAT
C                                       subtract the expression to get
C                                       polynomial presentation of the
C                                       atmosphere at zenith
                  VALU(ITT) = VALU(ITT) -
     *               FITREF(IFIT)*(IFIT-1)*XVARIB**(IFIT-2) /
     *               (BCOR*MAPREF)
 47               CONTINUE
               END IF
            END IF
C                                       the direct data are at VALU1
         IF (DODIR) THEN
            VALU(ITT) = VALU1(ITT)
            END IF
C                                       Convert to meters if 'rate'
         IF (ICODE.EQ.4) VALU(ITT) = VALU(ITT) / 1000.0
         VALUMX = MAX(VALUMX, VALU(ITT))
         VALUMN = MIN(VALUMN, VALU(ITT))
 50      CONTINUE

C                                       TMAX, TMIN new MAX&MIN of Y
      TMAX = VALUMX + 0.1*(VALUMX - VALUMN)
      TMIN = VALUMN - 0.1*(VALUMX - VALUMN)
      IF (ABS (TMAX-TMIN).LT.TOLER(ICODE)) THEN
         TMAX = TMAX + TOLER(ICODE)
         TMIN = TMIN - TOLER(ICODE)
         END IF
C                                       GMXX, GMNX MAX&MIN of Y for
C                                       this plot
      GMXX = TMAX
      GMNX = TMIN
      TDIF = TMAX - TMIN
      IF (ABS (TDIF).LE.1.0E-25) TDIF = 1.0E-25
      XYOFF(2) = TMIN
      SIZEY = 1000.0 / NCOUNT
      XYSCL(2) = SIZEY / TDIF
      NGOOD = 0
      NNOFIT = 0
      IRET = 3
      CATUP = T
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      XYRATO = 1.0
      PLTINC = 1000. / NCOUNT
C                                       Set window for current plot.
      XBLC(1) = BLC(1)
      XBLC(2) = 1000.0 - ABS (IPLOT) * PLTINC
      XTRC(1) = TRC(1)
      XTRC(2) = XBLC(2) + PLTINC - 1.0
C
      IF (DORES) XTRC(2) =  XTRC(2) - (MOD(IABS(IPLOT),2)+0)*4
      TLC(1) = XBLC(1)
      TLC(2) = XTRC(2)
C                                       Offsets for current plot.
      YYOFF(1) = XBLC(1)
      YYOFF(2) = XBLC(2)
C                                       fool with location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
C                                       LABTYP(LOCNUM)=0 for xaxis=time
      LABTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      TR = 1.2 * (GMXX - GMNX)
      TI = TR
      CALL METSCA (TR, CPREF(2,LOCNUM), GOOD)
      XMULT(2) = TR / TI
      CPREF(1,LOCNUM) = ' '
      XMULT(1) = 1.0
      DO 60 I = 1,2
         SIZE = 1000.0
         IF (I.EQ.2) SIZE = PLTINC
         TR = SIZE / XYSCL(I)
         RPLOC(I,LOCNUM) = XBLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I) * XMULT(I)
         AXINC(I,LOCNUM) = TR * XMULT(I) / (XTRC(I) - XBLC(I))
 60      CONTINUE
      CTYP(1,LOCNUM) = XUNITS
      CTYP(2,LOCNUM) = AUNITS(ICODE)
C                                       m/day for rate and DODIR
      IF (DODIR .AND. ICODE.EQ.4) CTYP(2,LOCNUM) = 'm/day'
C                                       Create plot file
      IF (ABS (IPLOT).EQ.1) THEN
C                                       Update catalog header.
         VER = 0
         IRET = 1
         IF (.NOT.DOTV) THEN
            CALL MADDEX ('PL', DISKIN, CNOIN, CATBLK, ELBUFF, CATUP,
     *         'WRIT', VER, IERR)
            IF (IERR.NE.0) THEN
               NCFILE = NCFILE - 1
               GO TO 999
               END IF
            END IF
         CALL ZPHFIL ('PL', DISKIN, CNOIN, VER, PFILE, IERR)
         IF (IERR.NE.0) GO TO 960
         IPSIZE = 0
         ITYPE = 40
         CALL GINIT (DISKIN, CNOIN, PFILE, IPSIZE, ITYPE, NPARM,
     *      XNAMEI, DOTV, TVCHN, GRCHN, TVCORN, CATBLK, ELBUFF, LUNPL,
     *      FINDPL, IERR)
         IRET = 2
         IF (IERR.NE.0) GO TO 960
C                                       Number of characters on each
C                                       side of the plot
         CALL RFILL (4, 0.5, CHOUT)
C                                       Note that TICINC not fully
C                                       initialized as yet. -> INP being
C                                       larger than may be actually
C                                       plotted on this subplot.  This
C                                       is probably desirable.
         CALL CHNTIC (XBLC, XTRC, INP)
         INP = MAX (INP, 3)
C                                       standard labeling
         LABEL = 3
         LTYPE = 3
         CHOUT(1) = INP + 4.0
         CHOUT(2) = 3.333
         CHOUT(4) = 4.666
C                                       Init for line drawing.
         CALL GINITL (BLC, TRC, XYRATO, CHOUT, DEPTH, ELBUFF, IERR)
         IRET = 3
         IF (IERR.NE.0) GO TO 970
         IF (.NOT.DOTV) THEN
            IF (PRTLEV.GT.0) THEN
               WRITE (MSGTXT,1000) VER
               CALL MSGWRT (3)
               END IF
            END IF
         END IF
      IRET = 3
      CATUP = T
C                                       Draw border
      CALL GLTYPE (1, ELBUFF, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GPOS (XBLC(1), XTRC(2), ELBUFF, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XBLC(2), ELBUFF, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XBLC(2), ELBUFF, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XTRC(2), ELBUFF, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XTRC(2), ELBUFF, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Top labels: type & name
      IF (ABS(IPLOT).EQ.1) THEN
         DX = 0.0
         DY = 1.833
C                                       The second line of the header
         CALL GPOS (BLC(1), TRC(2), ELBUFF, IERR)
         IF (IERR.NE.0) GO TO 970
         IF (DOATMA) TEXT = CHTYPE(1)
         IF (DOCLOC) TEXT = CHTYPE(2)
         IF (DOREF)  TEXT = CHTYPE(3)
         IF (DODISP) TEXT = CHTYPE(4)
         IF (DODIR)  TEXT = 'SN table vs fits'
C                                       File name
         CALL H2CHR (18, KHIMNO, CATH(KHIMN), CHTMP)
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), CHTMP(13:18))
         IF (DORES) THEN
            TEXT(17:) = '(+ residuals) vs time for'
            CALL NAMEST (CHTMP, CATBLK(KIIMS), TEXT(45:), INCHAR)
         ELSE
            TEXT(17:) = ' vs time for '
            CALL NAMEST (CHTMP, CATBLK(KIIMS), TEXT(35:), INCHAR)
            END IF
         CALL REFRMT (TEXT, ' ', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, ELBUFF, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       the third line of header
         DY = 0.5
         CALL GPOS (BLC(1), TRC(2), ELBUFF, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Table type
         TYPE = 'SN'
         IF (DODIR) THEN
            WRITE (TEXT,1005) TYPE, SNVER, OPTYPE
         ELSE
            WRITE (TEXT,1010) TYPE, SNVER, OPTYPE
            END IF
         INP = 7
C
         IF (NSTNS.EQ.1) THEN
            WRITE (TEXT(INP:),1040) STNNAM(CURANT), TELNO(CURANT)
            END IF
C
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, ELBUFF, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Date/time/version
         DY = 0.5 + 2 * 1.333
C                                       the first line of the header
         CALL GPOS (BLC(1), TRC(2), ELBUFF, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, ATIME, ADATE)
         WRITE (TEXT,1030) VER, ADATE, ATIME
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, ELBUFF, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Set up location common
      CALL GPOS (XBLC(1), XTRC(2), ELBUFF, IERR)
      IF (IERR.NE.0) GO TO 970
      DX =  1.5
      DY = -1.8
      INCHAR = 12
      INP = 1
      IF (NSTNS.NE.1) THEN
         WRITE (TEXT(INP:),1040) STNNAM(CURANT), TELNO(CURANT)
         INP = INP + 16
         END IF
      IF ((NSTNS.NE.1) .OR. (NS.NE.1) .OR. (NNIF.NE.1)) THEN
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, ELBUFF, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Blank bottom label.
      IF ((IPLOT.GE.0) .AND. (ABS (IPLOT).NE.NCOUNT)) THEN
         CPREF(1,LOCNUM) = ' '
         CTYP(1,LOCNUM) = ' '
         END IF

      IAXLAB = NCOUNT / 2 + 1
      IAPLOT = ABS (IPLOT)
C                                       Only label Y axis once.
C                                       comment to plot vertical labels
C                                       for each plot
C      IF ((IAPLOT.NE.IAXLAB) .AND. ((IPLOT.GE.0) .OR.
C     *   (IAPLOT.GT.IAXLAB))) CPREF(2,LOCNUM) = '-1'
C                                       vertical units only for the
C                                       first plots; later for the
C                                       second ones
      IF (DOTWO) CPREF(2,LOCNUM) = '-1'
C
C                                       Put on labels and ticks
C                                       only for the first plot
      IF (.NOT.DOTWO) THEN
         CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XYRATO, F, ELBUFF, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       take data
C                                       Size of symbol.
      DX = 5.0
      DY = 5.0
      DBY = 0.5
C                                       prepare the data for plot
      CALL GLTYPE (4, ELBUFF, IERR)
      IF (IERR.NE.0) GO TO 970
C
      VALUMX = -1.0E10
      VALUMN =  1.0E10
      DO 70 ITT = 1, ITIM
         XVARIB = TIMITS(ITT)
C
         RANT = ANTRTS(ITT)
         MAPANT = MAPITS(ITT)
         MAPREF = MAPRIT(ITT)
         BCO  = BCOITS(ITT)
         BCOR = BCORIT(ITT)
C
         IF (DOTWO) THEN
C                                       calculate model for the
C                                       following subtruction

            ARGUMT = XVARIB - TIMCEN
C
            IF (DOATMA .AND. DOMOD) THEN
               VALUE = 0
               DO 61 IFIT = 1, NFITAT
                  VALUE = VALUE + FITPAR(IFIT)*ARGUMT**(IFIT-1)
 61               CONTINUE
               END IF
C
            IF (DOCLOC .AND. DOMOD) THEN
               VALUE = 0
               DO 62 IFIT = NFITAT+1, NFITA
                  VALUE = VALUE + FITPAR(IFIT)*ARGUMT**(IFIT-NFITAT-1)
 62               CONTINUE
               END IF
C
            IF ((DOREF .AND. REFEQU) .AND. DOMOD) THEN
               VALUE = 0
               DO 63 IFIT = 1, NFITAT
                  VALUE = VALUE + FITREF(IFIT)*ARGUMT**(IFIT-1)
 63               CONTINUE
               END IF
C
            IF (DODIR) THEN
C                                       direct data to plot
               IF (ICODE.LT.4) THEN
C                                       'mdel' or 'phas'
                  VALUE = 0
C                                       add the zenith atm. at ANT
                  DO 64 IFIT = 1, NFITAT
                     VALUE = VALUE + (FITPAR(IFIT)*ARGUMT**(IFIT-1)) *
     *                  MAPANT
 64                  CONTINUE
C                                       subtract the reference antenna
                  DO 65 IFIT = 1, NFITAT
                     VALUE = VALUE - (FITREF(IFIT)*ARGUMT**(IFIT-1)) *
     *                  MAPREF
 65                  CONTINUE
C                                       add the clock
                  DO 66 IFIT = NFITAT+1, NFITA
                     VALUE = VALUE + FITPAR(IFIT)*ARGUMT**(IFIT
     *                  -NFITAT-1)
 66                  CONTINUE

               ELSE
C                                       'rate'
                  VALUE = 0
C                                       add the two terms at IANT-RANT
                  DO 67 IFIT = 1, NFITAT
C                                       IANT
                     VALUE = VALUE +
     *                  FITPAR(IFIT)*(MAPANT*(IFIT-1)*ARGUMT**(IFIT-2)
     *                  +MAPANT**2 * BCO*ARGUMT**(IFIT-1))
C                                       -RANT
     *                  -FITREF(IFIT)*(MAPREF*(IFIT-1)*ARGUMT**(IFIT-2)
     *                  -MAPREF**2 * BCOR*ARGUMT**(IFIT-1))
 67                  CONTINUE
C                                       add the clock
                  DO 68 IFIT = NFITAT+1, NFITA
                     VALUE = VALUE + FITPAR(IFIT)*(IFIT-NFITAT-1)*
     *                  ARGUMT**(IFIT-NFITAT-2)
 68                  CONTINUE
                  END IF
               END IF
C                                       convert VALUE to meter if 'rate'
            IF (ICODE.EQ.4) VALUE = VALUE / 1000.0
C                                       subtract the model
            VALUE = VALU(ITT) - VALUE
C
            VALUMX = MAX(VALUMX, VALUE)
            VALUMN = MIN(VALUMN, VALUE)
         ELSE
            VALUE = VALU(ITT)
            END IF
C                                       store the VALUE at VALU()
         VALU(ITT) = VALUE
 70      CONTINUE
C                                       make the different scale for
C                                       the second plots (residuals)
      IF (DOTWO) THEN
C                                       TMAX, TMIN new MAX&MIN of Y
         TMAX = VALUMX + 0.1*(VALUMX - VALUMN)
         TMIN = VALUMN - 0.1*(VALUMX - VALUMN)
         IF (ABS (TMAX-TMIN).LT.TOLER(ICODE)) THEN
            TMAX = TMAX + TOLER(ICODE)
            TMIN = TMIN - TOLER(ICODE)
            END IF
C                                       GMXX, GMNX MAX&MIN of Y for
C                                       this plot
         GMXX = TMAX
         GMNX = TMIN
         TDIF = TMAX - TMIN
         IF (ABS (TDIF).LE.1.0E-25) TDIF = 1.0E-25
         XYOFF(2) = TMIN
         SIZEY = 1000.0 / NCOUNT
         XYSCL(2) = SIZEY / TDIF
C                                       LABTYP(LOCNUM)=0 for xaxis=time
         LABTYP(LOCNUM) = 0
         AXTYP(LOCNUM) = 0
         TR = 1.2 * (GMXX - GMNX)
         TI = TR
C
         CALL METSCA (TR, CPREF(2,LOCNUM), GOOD)
         XMULT(2) = TR / TI
         CPREF(1,LOCNUM) = ' '
         XMULT(1) = 1.0
         DO 600 I = 1,2
            SIZE = 1000.0
            IF (I.EQ.2) SIZE = PLTINC
            TR = SIZE / XYSCL(I)
            RPLOC(I,LOCNUM) = XBLC(I)
            RPVAL(I,LOCNUM) = XYOFF(I) * XMULT(I)
            AXINC(I,LOCNUM) = TR * XMULT(I) / (XTRC(I) - XBLC(I))
  600       CONTINUE
C                                       Put on labels and ticks
         CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XYRATO, F, ELBUFF, IERR)
         IF (IERR.NE.0) GO TO 970

         END IF
C                                       Loop to plot the data
      DO 75 ITT = 1, ITIM
         XVARIB = TIMITS(ITT)
         VALUE = VALU(ITT)
         IF (VALUE.NE.FBLANK) THEN
C                                       Scale X, Y
            XY(1) = XVARIB
            XY(1) = XYSCL(1) * (XY(1) - XYOFF(1)) + YYOFF(1)
            IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1))) THEN
               NNOFIT = NNOFIT + 1
               GO TO 75
               END IF
            XY(2) = VALUE
            XY(2) = XYSCL(2) * (XY(2) - XYOFF(2)) + YYOFF(2)
            IF ((XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2))) THEN
               NNOFIT = NNOFIT + 1
               GO TO 75
               END IF
            NGOOD = NGOOD + 1
C                                       Mark point
            DY = 5.0
            YPT = XY(2) + DY
            IF (YPT.GT.XTRC(2)) YPT = XTRC(2)
            CALL GPOS (XY(1), YPT, ELBUFF, IERR)
            IF (IERR.NE.0) GO TO 970
            YPT = XY(2) - DY
            IF (YPT.LT.XBLC(2)) YPT = XBLC(2)
            CALL GVEC (XY(1), YPT, ELBUFF, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
 75      CONTINUE
C-----------------------------------------------------------------------
C                                       Draw the model
C                                       NPMOD- number of points in model
C                                       draw
      NPMOD = ITIM
      IF (DOMOD .OR. DOTWO) NPMOD = 100
      IFIRST = 0
C
      DX = 5.0
      DY = 5.0
C
      DO 120 ITT = 1, NPMOD
         XVARIB = TIMITS(ITT)
         IF (DOMOD .OR. DOTWO)
     *      XVARIB = XAXIMN + (ITT-1)*((XAXIMX-XAXIMN)/(NPMOD-1.0))
         ARGUMT = XVARIB - TIMCEN
         MAPANT = MAPITS(ITT)
         MAPREF = MAPRIT(ITT)
         BCO  = BCOITS(ITT)
         BCOR = BCORIT(ITT)
C
         IF (DOATMA .AND. DOMOD) THEN
            VALUE = 0
            DO 80 IFIT = 1, NFITAT
               VALUE = VALUE + FITPAR(IFIT)*ARGUMT**(IFIT-1)
 80            CONTINUE
            END IF
C
         IF (DOCLOC .AND. DOMOD) THEN
            VALUE = 0
            DO 90 IFIT = NFITAT+1, NFITA
               VALUE = VALUE + FITPAR(IFIT)*ARGUMT**(IFIT-NFITAT-1)
 90            CONTINUE
            END IF
C
         IF ((DOREF .AND. REFEQU) .AND. DOMOD) THEN
            VALUE = 0
            DO 110 IFIT = 1, NFITAT
               VALUE = VALUE + FITREF(IFIT)*ARGUMT**(IFIT-1)
 110           CONTINUE
            END IF
C
C                                       direct data to plot
         IF (DODIR) THEN
C                                       'mdel' or 'phas'
            IF (ICODE.LT.4) THEN
               VALUE = 0
C                                       add the zenith atm. at ANT
               DO 112 IFIT = 1, NFITAT
                  VALUE = VALUE + (FITPAR(IFIT)*ARGUMT**(IFIT-1)) *
     *               MAPANT
 112              CONTINUE
C                                       subtract the reference antenna
               DO 113 IFIT = 1, NFITAT
                  VALUE = VALUE - (FITREF(IFIT)*ARGUMT**(IFIT-1)) *
     *               MAPREF
 113              CONTINUE
C                                       add the clock
               DO 114 IFIT = NFITAT+1, NFITA
                  VALUE = VALUE + FITPAR(IFIT)*ARGUMT**(IFIT-NFITAT-1)
 114              CONTINUE
C                                       'rate'
            ELSE
               VALUE = 0
C                                       add the two terms at IANT-RANT
               DO 115 IFIT = 1, NFITAT
C                                       IANT
                  VALUE = VALUE +
     *               FITPAR(IFIT)*(MAPANT*(IFIT-1)*ARGUMT**(IFIT-2)
     *               +MAPANT**2 * BCO*ARGUMT**(IFIT-1))
C                                       -RANT
     *               -FITREF(IFIT)*(MAPREF*(IFIT-1)*ARGUMT**(IFIT-2)
     *               -MAPREF**2 * BCOR*ARGUMT**(IFIT-1))
 115              CONTINUE
C                                       add the clock
               DO 116 IFIT = NFITAT+1, NFITA
                  VALUE = VALUE + FITPAR(IFIT)*(IFIT-NFITAT-1)*
     *               ARGUMT**(IFIT-NFITAT-2)
 116              CONTINUE
               END IF
            END IF
C                                       convert to meters if 'rate'
         IF (ICODE.EQ.4) VALUE = VALUE / 1000.0
C                                       Model is zero for for the
C                                       residual plot
         IF (DOTWO) VALUE = 0
C                                       Scale X, Y
         XY(1) = XVARIB
         XY(1) = XYSCL(1) * (XY(1) - XYOFF(1)) + YYOFF(1)
         IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1))) GO TO 120
         XY(2) = VALUE
         XY(2) = XYSCL(2) * (XY(2) - XYOFF(2)) + YYOFF(2)
C                                       move to the first point
         IFIRST = IFIRST + 1
C
         IF (IFIRST.EQ.1) THEN
            CALL GPOS (XY(1), XY(2), ELBUFF, IRET)
         ELSE
            CURENT = (XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2))
            PREVOS = (PREV .LT.XBLC(2)) .OR. (PREV .GT.XTRC(2))
C
            IF (CURENT .OR. PREVOS) THEN
               CALL GPOS (XY(1), XY(2), ELBUFF, IRET)
            ELSE
               IF (DOMOD .OR. DOTWO) THEN
                  CALL GVEC (XY(1), XY(2), ELBUFF, IRET)
               ELSE
C                                       model is drawn by '-'
                  CALL GPOS (XY(1)+DX, XY(2), ELBUFF, IERR)
                  IF (IERR.NE.0) GO TO 970
                  CALL GVEC (XY(1)-DX, XY(2), ELBUFF, IERR)
                  IF (IERR.NE.0) GO TO 970
                  END IF
               END IF
            END IF
         PREV = XY(2)
 120     CONTINUE
C--------------------------------------------------------------
C                                       Done: finish plot
      IF (PRTLEV.GT.0) THEN
         WRITE (MSGTXT,1200) NGOOD
         CALL MSGWRT (3)
         IF (NNOFIT.GE.1) THEN
            WRITE (MSGTXT,1201) NNOFIT
            CALL MSGWRT (3)
            END IF
      END IF
      IF ((IPLOT.GT.0) .AND. (ABS(IPLOT).LT.NCOUNT)) GO TO 210
         GPHPAG = IPLOT.GT.0
         CALL GFINIS (ELBUFF, IERR)
         IF (IERR.GT.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, ELBUFF, IERR)
            IERR = 0
            END IF
 210     IF (IERR.GT.0) GO TO 975
         IRET = MIN (IERR, 0)
         GO TO 999
C                                       ZPHFIL or GINIT failure.
 960  IF (PRTLEV.GT.0) THEN
         WRITE (MSGTXT,1960)
         CALL MSGWRT (8)
         END IF
      IF (.NOT.DOTV) THEN
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, ELBUFF,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
      GO TO 999
C                                       Try to finish partial graph
 970  IF (PRTLEV.GT.0) THEN
         WRITE (MSGTXT,1970)
         CALL MSGWRT (6)
         WRITE (MSGTXT,1200) NGOOD
         CALL MSGWRT (2)
         IF (NNOFIT.GE.1) THEN
            WRITE (MSGTXT,1201) NNOFIT
            CALL MSGWRT (2)
            END IF
         END IF
      GPHPAG = IPLOT.GT.0
      CALL GFINIS (ELBUFF, IERR)
      IF (IERR.NE.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, ELBUFF, IERR)
            IERR = 0
            END IF
         GO TO 999
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, ELBUFF,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Plot file version',I4,'  created.')
 1005 FORMAT (A2,I4, '  OPTYPE=', A4, ';', 5X, 'data(I),  model(-)')
 1010 FORMAT (A2,I4, '  OPTYPE=', A4)
 1030 FORMAT ('Plot file version',I4,'__created ',A, A)
 1040 FORMAT (A8,' (',I2,')_')
 1200 FORMAT ('PLTEL: ',I9,' points plotted')
 1201 FORMAT ('PLTEL: ',I9,' points did not fit')
 1960 FORMAT ('PLTEL: ERROR DURING GRAPH FILE CREATION')
 1970 FORMAT ('PLTEL: ERROR DURING GRAPHING. WILL TRY TO FINISH ',
     *   'PARTIAL GRAPH')
      END
      SUBROUTINE OUTCL (IERR)
C-----------------------------------------------------------------------
C   OUTCL makes the corrections of the CL table No high+1
C   Output: IERR  I    Return code, 0=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER MAXLIN
      PARAMETER (MAXLIN=100000)
      INTEGER   LUN, IRCODE, THSOU, ANT, SID, IANT,
     *   ICLRNO, NUMREC, LOOP, ILINES
      DOUBLE PRECISION   TCLT
      INTEGER   LUNPR, PFIND, NCH, ITRIM, NTIMES
      CHARACTER LINE*80, TEMOUT(MAXLIN)*80
      LOGICAL   F
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'DELZN.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN /29/
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      FIXCNT = 0
C                                       Open CL table
      NUMPOL = 1
      IF (CATBLK(KINAX+JLOCS).GT.1) NUMPOL = 2
      NUMIF = 1
      IF (JLOCIF.GT.0) NUMIF = CATBLK(KINAX+JLOCIF)
C                                       Reformat table?
      IF (DOCL) THEN
         CALL CLREFM (DISKIN, CNOIN, CLUSE, CATBLK, LUN, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL CALINI ('WRIT', BUFFER, DISKIN, CNOIN, CLUSE, CATBLK,
     *      LUN, ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF,
     *      NTERM, GMMOD, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL CALINI ('READ', BUFFER, DISKIN, CNOIN, CLVER, CATBLK,
     *      LUN, ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF,
     *      NTERM, GMMOD, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Get number of records
      NUMREC = BUFFER(5)
      IF (NUMREC.LE.0) GO TO 999
      IRCODE = 0
C                                       Update table
      NTIMES = 100
      IF (DOCL) THEN
C                                       calculate output file for
C                                       the CL times
         FIXCNT = 0
C
         DOCLTM = .TRUE.
         DO 100 LOOP = 1,NUMREC
            ICLRNO = LOOP
            CALL TABIO ('READ', IRCODE, ICLRNO, CLRECR, BUFFER, IERR)
            IF (IERR.GT.0) GO TO 900
            IF (IERR.LT.0) GO TO 100
C                                       Check data
C                                       Time:
            IF ((CLRECD(TIMCL).LT.TIMBEG) .OR.
     *         (CLRECD(TIMCL).GT.TIMEND)) GO TO 100
C                                       Subarray
            IF ((CLRECI(SUBCL).NE.SUBA) .AND. (CLRECI(SUBCL).GT.0))
     *            GO TO 100
C                                       Freq id
            IF ((CLRECI(FRQCL).NE.FREQID) .AND. (CLRECI(FRQCL).GT.0)
     *            .AND.(FREQID.GT.0)) GO TO 100
C                                       Check source
            THSOU = CLRECI(SOUCL)
            DO 30 SID = 1, NIDS
               IF (THSOU.EQ.IDS(SID)) GO TO 40
 30            CONTINUE
            GO TO 100
 40         RA = RAS(SID)
            DEC = DECS(SID)
C                                       Check antenna
            ANT = CLRECI(ANTCL)
            DO 50 IANT = 1,NSTNS
               IF (TELNO(IANT).EQ.ANT) GO TO 60
 50          CONTINUE
            GO TO 100
C                                       count
 60         FIXCNT = FIXCNT + 1
            IF (FIXCNT.GT.MAXLIN) THEN
               WRITE (MSGTXT,1240) MAXLIN
               CALL MSGWRT (8)
               WRITE (MSGTXT,1250)
               IERR = 1
               GO TO 990
               END IF
C                                       Correct record.
C                                       Correction of the CL row
C                                       based on the vertical atmosphere
C                                       delay, clock error and elevation
C                                       of the source
C
C                                       time at the CL table line,
C                                       in days
            TCLT = CLRECD(TIMCL) - TIMCEN
            IF (ICODE.NE.3) THEN
               CALL ATMOV (TCLT, IANT, TEMOUT, IERR)
            ELSE
               CALL DISPV (TCLT, IANT, TEMOUT, IERR)
               END IF
            IF (IERR.NE.0) GO TO 100
C
            CALL TABIO ('WRIT', IRCODE, ICLRNO, CLRECR, BUFFER, IERR)
            IF (IERR.GT.0) GO TO 900
 100        CONTINUE
C                                       calculate output file for
C                                       even distributed NTIMES
         DOCLTM = DOCLT1
         IF (.NOT.DOCLTM) THEN
            FIXCNT = 0
            DO 120 IANT = 1,NSTNS
               DO 110 LOOP = 1,NTIMES+1
                  TCLT = TIMSTA + (LOOP-1) * (TIMFIN-TIMSTA)/NTIMES
     *               - TIMCEN
C                                       Correct record.
                  FIXCNT = FIXCNT + 1
C                                       calculation of the output file
                  IF (ICODE.NE.3) THEN
                     CALL ATMOV (TCLT, IANT, TEMOUT, IERR)
                  ELSE
                     CALL DISPV (TCLT, IANT, TEMOUT, IERR)
                     END IF
 110              CONTINUE
 120           CONTINUE
            END IF
C                                       .NOT.DOCL
      ELSE
C                                       calculate output file for
C                                       even distributed NTIMES
C
C                                       At the beginning:
C                                       IF(.NOT.DOCL) DOCLTM = .FALSE.
         FIXCNT = 0
         DO 140 IANT = 1,NSTNS
            DO 130  LOOP = 1,NTIMES+1
               TCLT = TIMSTA + (LOOP-1) * (TIMFIN-TIMSTA)/NTIMES
     *            - TIMCEN
C                                       Correct record.
               FIXCNT = FIXCNT + 1
C                                       calculation of the output file
               IF (ICODE.NE.3) THEN
                  CALL ATMOV (TCLT, IANT, TEMOUT, IERR)
               ELSE
                  CALL DISPV (TCLT, IANT, TEMOUT, IERR)
                  END IF
 130           CONTINUE
 140        CONTINUE
         END IF
C                                       record in the OUTFILE:
C                                       number of lines-FIXCNT
C                                       and following FIXCNT lines
C
C                                       open the OUTFILE
      IF (DOUTFI) THEN
         LUNPR = 3
         CALL ZTXOPN ('WRIT', LUNPR, PFIND, OFILE, .TRUE., IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPENING OUTPUT TEXT FILE'
            CALL MSGWRT (8)
            IERR = 0
            GO TO 160
            END IF
         WRITE (LINE,1270) FIXCNT, DATE0, JD0
         NCH = ITRIM (LINE)
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT TEXT FILE'
            CALL MSGWRT (8)
            IERR = 0
            GO TO 155
            END IF
         DO 150 ILINES = 1, FIXCNT
            LINE = TEMOUT(ILINES)
            NCH = ITRIM(LINE)
            CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH),
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT TEXT FILE'
               CALL MSGWRT (8)
               IERR = 0
               GO TO 155
               END IF
 150        CONTINUE
C                                       close the OUTFILE
 155     CALL ZTXCLS (LUNPR, PFIND, IERR)
         END IF
C
 160  IF (DOCL) THEN
         NUMHIS= NUMHIS + 1
         WRITE (HISCRD(NUMHIS),2900) FIXCNT
         WRITE (MSGTXT,2901) FIXCNT, CLUSE
         CALL MSGWRT (6)
         END IF
C                                       Close table.
      CALL TABIO ('CLOS', IRCODE, LOOP, CLRECR, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 900
      GO TO 999
C                                       TABIO error
 900  WRITE (MSGTXT,1900) IERR
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OUTCL: ERROR',I5,' ON ',A)
 1900 FORMAT ('TABIO ERROR',I3,' CORRECTING CL TABLE')
 2900 FORMAT (' / ',I6,' Records modified')
 2901 FORMAT (I6,' Records of the CL table ', I2, ' modified')
 1240 FORMAT ('Number of lines in OUTFILE exceeds MAX = ', I6)
 1250 FORMAT ('So use even times for OUTFILE: APARM(8)=1 .OR. ask LK')
 1270 FORMAT (I5,5X,'DATE ''',A8,'''  JD=',F14.1)
      END
      SUBROUTINE ATMOV (TCLT, IANT, TEMOUT, IERR)
C-----------------------------------------------------------------------
C   Routine to apply atmospheric and clock error corrections to the
C   given CL table row on the basis of the fitted polynomials and
C   the source elevation
C   Input:
C      TCLT     D      Time
C      IANT     I      antenna number as it selected
C   Control info from common:
C      ISTOK    I      Polarization to correct, 1=first, 2=second,
C                      0 = both
C   Output:
C      TEMOUT   C(*)   File of zenith delays for each selected antennas
C                      and times
C      IERR     I      Return error code , 0=OK else failed.
C-----------------------------------------------------------------------
      INTEGER   IANT, IERR
      DOUBLE PRECISION TCLT
      CHARACTER TEMOUT(*)*80
C
      INTEGER   I, ITEMP, IFIT, POLFAC, TIME(3)
      REAL      XT, YT, PDLYAT, PDLYCL, PDLY, DPDLAT, DPDLCL, DPDLY,
     *   DPDATZ, CFAC, SFAC, FQFAC, HA, DELDT, COSZ, ELERAD, MAPF,
     *   SECNDS, CTIMR
      CHARACTER TSIGN*1
      DOUBLE PRECISION FREQS, COSLAT, SINLAT, SIDT, DELZAV,
     *   CLOCAV
C                                       speed of light (meters/sec)
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'DELZN.INC'
      REAL      FITPAR(MAXFIT)
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA SIDT /1.00273790935D0/
C-----------------------------------------------------------------------
      IERR = 0
C                                       time at the CL table line,
C                                       or even distributed time
C                                       in days
C      TCLT = CLRECD(TIMCL) - TIMCEN
C      CTIMR = CLRECD(TIMCL)
      CTIMR = TCLT + TIMCEN
C
      DO 10 IFIT = 1, NFITA
         FITPAR(IFIT) = SOL(IFIT + NFITA*(IANT-1))
 10      CONTINUE
C                                       estimate the atmzen delay, mm
      DELZAV = 0
      DO 20 IFIT = 1, NFITAT
         DELZAV = DELZAV + FITPAR(IFIT)*TCLT**(IFIT-1)
 20      CONTINUE
C                                       estimate the clock error, mm
      CLOCAV = 0
      DO 30 IFIT = NFITAT+1, NFITA
         CLOCAV = CLOCAV + FITPAR(IFIT)*TCLT**(IFIT-NFITAT-1)
 30      CONTINUE
C
C                                       derivative of atmosphere
C                                       at zenith in sec/sec
      DPDATZ = 0
      DO 40 IFIT = 2,NFITAT
         DPDATZ = DPDATZ + (IFIT-1)*FITPAR(IFIT)*TCLT**(IFIT-2)
 40      CONTINUE
      DPDATZ = DPDATZ/24./60./60./1000./VELITE
C                                       derivative (drift) of clocks
C                                       in sec/sec
      DPDLCL = 0
      POLFAC = 1
      DO 50 IFIT = NFITAT+2, NFITA
         POLFAC = POLFAC*(IFIT-NFITAT-1)
         DPDLCL = DPDLCL + POLFAC*FITPAR(IFIT)*TCLT**(IFIT-NFITAT-2)
 50      CONTINUE
      DPDLCL = DPDLCL/24./60./60./1000./VELITE
C                                       record in the  temp FILE:
C                                       TELNO(IANT), CTIM
C                                       and DELZAV (in cm)
C                                       and CLOCAV (in cm)
C                                       derivative of the zenith
C                                       atmosphere *E14
C                                       clock drift *E14
      IF (DOUTFI) THEN
         CALL TFDHMS (CTIMR, 1, TSIGN, TIME, SECNDS)
         WRITE (TEMOUT(FIXCNT), 1250) STNNAM(IANT)(1:3), TSIGN,
     *      TIME, SECNDS, DELZAV/10, CLOCAV/10, DPDATZ*1.0E14,
     *      DPDLCL*1.0E14
         END IF
      IF (.NOT. DOCL) GO TO 999
C
      IF (.NOT.DOCLTM) GO TO 999
C                                       antenna number at the CL table
C                                       line
      COSLAT = COS (STNLAT(IANT))
      SINLAT = SIN (STNLAT(IANT))
C                                       calculate elevation of the
C                                       antenna for the given source
      HA = TWOPI*SIDT*CTIMR + GSTIAT + STNLON(IANT) - RA
      COSZ = DCOS(STNLAT(IANT))*DCOS(DEC)*COS(HA) +
     *   DSIN(STNLAT(IANT))*DSIN(DEC)
C                                       source is under horizon
      IF (COSZ.LT.0.0) THEN
         IERR = 1
         GO TO 999
      ELSE
         ELERAD = PI / 2.0 - ACOS (COSZ)
         END IF
      FREQS = FREQ + FREQO(BIF)
      SINDEC = SIN (DEC)
      COSDEC = COS (DEC)

C                                       recalculate the  zenith delay
C                                       to the given elevation
C                                       using 1/SIN(EL) as a mapping
C                                       function and add the clock error
      IF (ELERAD.GT.0.01) THEN
         MAPF = 1 / SIN(ELERAD)
C                                       delays in second
         PDLYAT = DELZAV * MAPF/ 1000 / VELITE
         PDLYCL = CLOCAV / 1000 / VELITE
C                                       Correct only atmosphere?
         IF (DOCLAT) THEN
            PDLY = PDLYAT
         ELSE
            PDLY = PDLYAT + PDLYCL
            END IF
      ELSE
         PDLY = 0
         END IF
C                                       DELDT is derivative of ELV
C                                       (by time) multiplied by
C                                       COS(ELV)
      DELDT = -7.29211E-5 * SIN (HA) * COSLAT * COSDEC
C
C                                       derivative of atmosphere
C                                       in sec/sec
      DPDLAT = -PDLYAT * DELDT
      IF (ELERAD.GT.0.01) THEN
         DPDLAT = (DPDLAT + DPDATZ) / SIN(ELERAD)
      ELSE
         DPDLAT = 0
         END IF
C
C                                       Correct only atmosphere?
      IF (DOCLAT) THEN
         DPDLY = DPDLAT
      ELSE
         DPDLY = DPDLAT + DPDLCL
         END IF
C                                       Atmospheric group delay
      IF (CLRECR(ATMCL).NE.FBLANK) CLRECR(ATMCL) = CLRECR(ATMCL)
     *      - PDLYAT
C                                       Atmospheric group delay rate
      IF (CLRECR(DATMCL).NE.FBLANK) CLRECR(DATMCL) = CLRECR(DATMCL) -
     *   DPDLAT
C                                       clock shift
      IF (.NOT.DOCLAT .AND. CLRECR(CLK1CL).NE.FBLANK)
     *   CLRECR(CLK1CL) = CLRECR(CLK1CL) - PDLYCL
C                                       clock drift
      IF (.NOT.DOCLAT .AND. CLRECR(DCK1CL).NE.FBLANK)
     *   CLRECR(DCK1CL) = CLRECR(DCK1CL) - DPDLCL
C                                       multiband delay
      IF (CLRECR(MBD1CL).NE.FBLANK) CLRECR(MBD1CL) = CLRECR(MBD1CL)
     *      + PDLY
C                                       first Stokes
      IF (ISTOK.NE.2) THEN
         DO 100 I = BIF,EIF
            FQFAC = (FREQS+FRQOFF(I)) * PDLY
            ITEMP = FQFAC
            FQFAC = TWOPI * (FQFAC - ITEMP)
            CFAC = COS (FQFAC)
            SFAC = SIN (FQFAC)
C                                       Phase
            XT = CLRECR(RE1CL+I-1)
            YT = CLRECR(IM1CL+I-1)
            IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
               CLRECR(RE1CL+I-1) = XT * CFAC - YT * SFAC
               CLRECR(IM1CL+I-1) = XT * SFAC + YT * CFAC
               END IF
C                                       Delay
            IF (CLRECR(DE1CL+I-1).NE.FBLANK)
     *         CLRECR(DE1CL+I-1) = CLRECR(DE1CL+I-1) + PDLY
C                                       Phase rate
            IF (CLRECR(RA1CL+I-1).NE.FBLANK)
     *         CLRECR(RA1CL+I-1) = CLRECR(RA1CL+I-1) + DPDLY
 100        CONTINUE
         END IF
C                                       second Stokes
      IF ((ISTOK.NE.1) .OR. (NS.NE.1)) THEN
C                                       clock shift
         IF (CLRECR(CLK2CL).NE.FBLANK) CLRECR(CLK2CL) = CLRECR(CLK2CL)
     *         - PDLYCL
C                                       clock drift
         IF (CLRECR(DCK2CL).NE.FBLANK) CLRECR(DCK2CL) = CLRECR(DCK2CL) -
     *      DPDLCL
C                                       multi delay
         IF (CLRECR(MBD2CL).NE.FBLANK) CLRECR(MBD2CL) = CLRECR(MBD2CL)
     *      - PDLY
         DO 120 I = BIF,EIF
C                                       PDLY => correct both atm.
C                                       delay and clock shift
            FQFAC = (FREQS+FRQOFF(I)) * PDLY
            ITEMP = FQFAC
            FQFAC = TWOPI * (FQFAC - ITEMP)
            CFAC = COS (FQFAC)
            SFAC = SIN (FQFAC)
C                                       Phase
            XT = CLRECR(RE2CL+I-1)
            YT = CLRECR(IM2CL+I-1)
            IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK)) THEN
               CLRECR(RE2CL+I-1) = XT * CFAC - YT * SFAC
               CLRECR(IM2CL+I-1) = XT * SFAC + YT * CFAC
               END IF
C                                       Delay
           IF (CLRECR(DE2CL+I-1).NE.FBLANK)
     *         CLRECR(DE2CL+I-1) = CLRECR(DE2CL+I-1) + PDLY
C                                       Phase rate
            IF (CLRECR(RA2CL+I-1).NE.FBLANK)
     *         CLRECR(RA2CL+I-1) = CLRECR(RA2CL+I-1) + DPDLY
 120        CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1250 FORMAT (A3,A1,3I3,F5.1,F9.4,2X,F9.4,2X,F10.5,2X,F10.5)
      END
      SUBROUTINE DISPV (TCLT, IANT, TEMOUT, IERR)
C-----------------------------------------------------------------------
C   Routine to apply dispersion corrections to the given CL table row on
C   the basis of the fitted polynomials and the source elevation
C   Input:
C      TCLT     D      Time
C      IANT     I      antenna number as it selected
C   Control info from common:
C      ISTOK    I      Polarization to correct, 1=first, 2=second,
C                      0 = both
C   Output:
C      TEMOUT   C(*)   File of zenith delays for each selected antennas
C                      and times
C      IERR     I      Return error code , 0=OK else failed.
C-----------------------------------------------------------------------
      INTEGER   IANT, IERR
      DOUBLE PRECISION TCLT
      CHARACTER TEMOUT(*)*80
C
      INTEGER   IFIT, TIME(3)
      REAL      PDLYAT, PDLY, DPDLAT, DPDLY, DPDATZ, HA, DELDT, COSZ,
     *   ELERAD, MAPF, SECNDS, CTIMR
      CHARACTER TSIGN*1
      DOUBLE PRECISION FREQS, COSLAT, SINLAT, SIDT, DISPAV
C                                       speed of light (meters/sec)
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'DELZN.INC'
      REAL      FITPAR(MAXFIT)
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA SIDT /1.00273790935D0/
C-----------------------------------------------------------------------
      IERR = 0
C                                       time at the CL table line,
C                                       or even distributed time
C                                       in days
      CTIMR = TCLT + TIMCEN
C
      DO 10 IFIT = 1, NFITA
         FITPAR(IFIT) = SOL(IFIT + NFITA*(IANT-1))
 10      CONTINUE
C                                       estimate the atmzen delay, mm
      DISPAV = 0
      DO 20 IFIT = 1, NFITAT
         DISPAV = DISPAV + FITPAR(IFIT)*TCLT**(IFIT-1)
 20      CONTINUE
C                                       derivative of atmosphere
C                                       at zenith in sec/sec
      DPDATZ = 0
      DO 40 IFIT = 2, NFITAT
         DPDATZ = DPDATZ + (IFIT-1)*FITPAR(IFIT)*TCLT**(IFIT-2)
 40      CONTINUE
      DPDATZ = DPDATZ/24./60./60./1000./VELITE
C                                       record in the  temp FILE:
C                                       TELNO(IANT), CTIM
C                                       and DISPAV (in cm)
C                                       derivative of the zenith
C                                       atmosphere *E14
      IF (DOUTFI) THEN
         CALL TFDHMS (CTIMR, 1, TSIGN, TIME, SECNDS)
         WRITE (TEMOUT(FIXCNT), 1250) STNNAM(IANT)(1:3), TSIGN,
     *      TIME, SECNDS, DISPAV/10, DPDATZ*1.0E14
         END IF
      IF (.NOT.DOCL) GO TO 999
C
      IF (.NOT.DOCLTM) GO TO 999
C                                       antenna number at the CL table
C                                       line
      COSLAT = COS (STNLAT(IANT))
      SINLAT = SIN (STNLAT(IANT))
C                                       calculate elevation of the
C                                       antenna for the given source
      HA = TWOPI*SIDT*CTIMR + GSTIAT + STNLON(IANT) - RA
      COSZ = DCOS(STNLAT(IANT))*DCOS(DEC)*COS(HA) +
     *   DSIN(STNLAT(IANT))*DSIN(DEC)
C                                       source is under horizon
      IF (COSZ.LT.0.0) THEN
         IERR = 1
         GO TO 999
      ELSE
         ELERAD = PI / 2.0 - ACOS (COSZ)
         END IF
      FREQS = FREQ + FREQO(BIF)
      SINDEC = SIN (DEC)
      COSDEC = COS (DEC)

C                                       recalculate the  zenith delay
C                                       to the given elevation
C                                       using 1/SIN(EL) as a mapping
C                                       function and add the clock error
      IF (ELERAD.GT.0.01) THEN
         MAPF = 1 / SIN(ELERAD)
C                                       delays in second
         PDLYAT = DISPAV * MAPF/ 1000 / VELITE
C                                       Correct only atmosphere?
         PDLY = PDLYAT
      ELSE
         PDLY = 0
         END IF
C                                       DELDT is derivative of ELV
C                                       (by time) multiplied by
C                                       COS(ELV)
      DELDT = -7.29211E-5 * SIN (HA) * COSLAT * COSDEC
C
C                                       derivative of atmosphere
C                                       in sec/sec
      DPDLAT = -PDLYAT * DELDT
      IF (ELERAD.GT.0.01) THEN
         DPDLAT = (DPDLAT + DPDATZ) / SIN(ELERAD)
      ELSE
         DPDLAT = 0
         END IF
      DPDLY = DPDLAT
C                                       dispersion
      IF (CLRECR(DIS1CL).NE.FBLANK) CLRECR(DIS1CL) = CLRECR(DIS1CL)
     *      + PDLY
      IF (CLRECR(DDS1CL).NE.FBLANK) CLRECR(DDS1CL) = CLRECR(DDS1CL)
     *      + DPDLY
C                                       second Stokes
      IF ((ISTOK.NE.1) .OR. (NS.NE.1)) THEN
C                                       dispersion
         IF (CLRECR(DIS2CL).NE.FBLANK) CLRECR(DIS2CL) = CLRECR(DIS2CL)
     *      + PDLY
         IF (CLRECR(DDS2CL).NE.FBLANK) CLRECR(DDS2CL) = CLRECR(DDS2CL)
     *      + DPDLY
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1250 FORMAT (A3,A1,3I3,F5.1,F10.4,F12.4)
      END
      SUBROUTINE DELHIS
C-----------------------------------------------------------------------
C   DELHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER CTIME(2)*12,  HILINE*72, LABEL*8
      INTEGER   LUN, IERR, TIM(3), DATE(3), I
      LOGICAL   T
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'DELZN.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN, DISKIN, FCNO(NCFILE), BUFFER, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIM)
      CALL TIMDAT (TIM, DATE, CTIME(2)(1:8), CTIME)
      WRITE (HILINE,1010) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any other history.
      WRITE (LABEL,1020) TSKNAM
      DO 50 I = 1,NUMHIS
         HILINE = LABEL // HISCRD(I)
         CALL HIADD (LUN, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 200
 50      CONTINUE
C                                       Close HI file
 200  CALL HICLOS (LUN, T, BUFFER, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DELHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6, 'RELEASE =''',A7,' ''  /********* Start ',
     *   A12, 2X, A8)
 1020 FORMAT (A6)
      END

      PROGRAM RDFITS
C-----------------------------------------------------------------------
C! RDFITS performs various operations on a FITS-like tape.
C# FITS Utility Service Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   RDFITS is a service routine to play with FITS-like tapes.  It
C   performs operations to move tapes:
C       Rewind
C       Advance record and file
C       Back record and file
C       Read
C       Index (list first card image of each file, count records)
C-----------------------------------------------------------------------
      CHARACTER FITS*80, PHNAME*48, PRGNAM*6, TEMP*4, MSGBUF*80
      INTEGER   NREC, TLUN, TIND, TVOL, IPNT, I, J, TTYLUN, TTYIND,
     *   IERR, PRTLUN, PRTIND, NBL, IXJ, KREC, NFILE, IFIL, MBYTE,
     *   LBYTE, LBL, JBL, TTY(2)
      REAL      TAPBUF(7200)
      LOGICAL   T, F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (TTY(1), TTYLUN),  (TTY(2), TTYIND)
      DATA PRGNAM /'RDFITS'/
      DATA TTYLUN, PRTLUN /5, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      CALL AIPINI (TTY, PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 980
      PRTIND = 0
      TIND = 0
C                                       Tape volume #, open
 10   WRITE (MSGBUF,1000)
      CALL INQINT (TTY, MSGBUF, 1, TVOL, IERR)
      IF (IERR.LT.0) GO TO 10
      IF (IERR.GT.0) GO TO 980
      TLUN = 129 - TVOL
      CALL ZPHFIL ('MT', TVOL, 0, 0, PHNAME, IERR)
      CALL ZTPOPN (TLUN, TIND, TVOL, PHNAME, 'READ', IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1002) IERR
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       Open printer
      WRITE (MSGBUF,1015)
      CALL INQSTR (TTY, MSGBUF, 48, PHNAME, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL CHLTOU (48, PHNAME)
      IF (PHNAME.EQ.'TEMP') PHNAME = ' '
      CALL ZOPEN (PRTLUN, PRTIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       OP LOOP
C                                       get operation
 20   WRITE (MSGBUF,1020)
      CALL INQSTR (TTY, MSGBUF, 4, TEMP, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL CHLTOU (4, TEMP)
      IF (TEMP.EQ.'REWI') GO TO 100
      IF (TEMP.EQ.'QUIT') GO TO 990
      IF (TEMP.EQ.'ADVF') GO TO 30
      IF (TEMP.EQ.'INDX') GO TO 30
      IF (TEMP.EQ.'KEYI') GO TO 30
C                                       get number of records
 25      WRITE (MSGBUF,1025)
         CALL INQINT (TTY, MSGBUF, 1, NREC, IERR)
         IF (IERR.LT.0) GO TO 25
         IF (IERR.GT.0) GO TO 980
C                                       get number of files
 30   IF (TEMP.EQ.'ADVR') GO TO 300
         WRITE (MSGBUF,1030)
         CALL INQINT (TTY, MSGBUF, 1, NFILE, IERR)
         IF (IERR.LT.0) GO TO 30
         IF (IERR.GT.0) GO TO 980
      IF (TEMP.EQ.'ADVF') GO TO 200
      IF (TEMP.EQ.'READ') GO TO 400
      IF (TEMP.EQ.'INDX') GO TO 500
      IF (TEMP.EQ.'KEYI') GO TO 600
      GO TO 20
C-----------------------------------------------------------------------
C                                       Rewind
 100  J = 1
      CALL ZTAPE ('REWI', TLUN, TIND, J, IERR)
 110  IF (IERR.EQ.0) GO TO 20
         WRITE (MSGTXT,1110) IERR
         CALL MSGWRT (7)
         GO TO 20
C-----------------------------------------------------------------------
C                                       Advance file
 200  IF (NFILE.LE.0) GO TO 210
         CALL ZTAPE ('ADVF', TLUN, TIND, NFILE, IERR)
         GO TO 110
 210  CONTINUE
         NFILE = 1 - NFILE
         CALL ZTAPE ('BAKF', TLUN, TIND, NFILE, IERR)
         GO TO 110
C-----------------------------------------------------------------------
C                                       Advance record
 300  IF (NREC.LE.0) GO TO 310
         CALL ZTAPE ('ADVR', TLUN, TIND, NREC, IERR)
         GO TO 110
 310  CONTINUE
         NREC = 1 - NREC
         CALL ZTAPE ('BAKR', TLUN, TIND, NREC, IERR)
         GO TO 110
C-----------------------------------------------------------------------
C                                       Read and print ASCII
 400  IF (NFILE.LE.0) NFILE = 10000
      IF (NREC.LE.0) NREC = 10000
      MBYTE = 28800
      DO 430 IFIL = 1,NFILE
         IPNT = -79
         CALL ZTPMIO ('READ', TLUN, TIND, MBYTE, TAPBUF, 1, IERR)
         IF (IERR.EQ.0) CALL ZTPWAT (TLUN, TIND, 1, LBYTE, IERR)
         IF (IERR.EQ.4) GO TO 425
         IF (IERR.NE.0) GO TO 110
         LBL = LBYTE / 2880
         NBL = MAX (1, LBL)
         DO 420 I = 1,NREC,NBL
            IF (I.EQ.1) GO TO 405
               IPNT = -79
               CALL ZTPMIO ('READ', TLUN, TIND, MBYTE, TAPBUF, 1, IERR)
               IF (IERR.EQ.0) CALL ZTPWAT (TLUN, TIND, 1, LBYTE, IERR)
               IF (IERR.EQ.4) GO TO 425
               IF (IERR.NE.0) GO TO 110
               LBL = LBYTE / 2880
 405        WRITE (1,1405) I, LBL
            LBL = LBL + I - 1
            IF (LBL.GT.NREC) LBL = NREC
            DO 410 JBL = I,LBL
               DO 409 J = 1,36
                  IPNT = IPNT + 80
                  CALL ZC8CL (80, IPNT, TAPBUF, FITS)
                  WRITE (1,1410) FITS
                  IF (FITS(1:8).EQ.'END     ') GO TO 425
 409              CONTINUE
 410           CONTINUE
 420        CONTINUE
 425     WRITE (MSGTXT,1571) IFIL
         IF ((IERR.EQ.4) .AND. (I.EQ.1)) CALL MSGWRT (2)
         IF ((IERR.EQ.4) .AND. (I.EQ.1)) GO TO 110
         IF (IERR.EQ.4) GO TO 430
            J = 1
            CALL ZTAPE ('ADVF', TLUN, TIND, J, IERR)
 430     CONTINUE
      GO TO 110
C-----------------------------------------------------------------------
C                                       Index
 500  IF (NFILE.LE.0) NFILE = 10000
      MBYTE = 28800
      DO 550 IXJ = 1,NFILE
         KREC = 0
         CALL ZTPMIO ('READ', TLUN, TIND, MBYTE, TAPBUF, 1, IERR)
         IF (IERR.EQ.0) CALL ZTPWAT (TLUN, TIND, 1, LBYTE, IERR)
         IF (IERR.NE.0) GO TO 560
         CALL ZC8CL (80, 1, TAPBUF, FITS)
         KREC = LBYTE / 2880
         DO 510 I = 1,10000
            CALL ZTPMIO ('READ', TLUN, TIND, MBYTE, TAPBUF, 1, IERR)
            IF (IERR.EQ.0) CALL ZTPWAT (TLUN, TIND, 1, LBYTE, IERR)
            IF (IERR.EQ.4) GO TO 520
            IF (IERR.NE.0) GO TO 560
            KREC = KREC + LBYTE / 2880
 510        CONTINUE
 520     WRITE (1,1520) IXJ, KREC, FITS
 550     CONTINUE
      GO TO 20
 560  IF (IERR.EQ.4) GO TO 570
         WRITE (1,1560) IERR, KREC, IXJ
         GO TO 110
 570  IXJ = IXJ - 1
      IF (IERR.EQ.4) WRITE (1,1570) IXJ
      WRITE (MSGTXT,1571) IXJ
      CALL MSGWRT (2)
      GO TO 20
C-----------------------------------------------------------------------
C                                       Read and print ASCII keywords
 600  IF (NFILE.LE.0) NFILE = 10000
      NREC = 10000
      MBYTE = 28800
      DO 630 IFIL = 1,NFILE
         WRITE (1,1600) IFIL
         IPNT = -79
         CALL ZTPMIO ('READ', TLUN, TIND, MBYTE, TAPBUF, 1, IERR)
         IF (IERR.EQ.0) CALL ZTPWAT (TLUN, TIND, 1, LBYTE, IERR)
         IF (IERR.EQ.4) GO TO 625
         IF (IERR.NE.0) GO TO 110
         LBL = LBYTE / 2880
         NBL = MAX (1, LBL)
         DO 620 I = 1,NREC,NBL
            IF (I.EQ.1) GO TO 605
               IPNT = -79
               CALL ZTPMIO ('READ', TLUN, TIND, MBYTE, TAPBUF, 1, IERR)
               IF (IERR.EQ.0) CALL ZTPWAT (TLUN, TIND, 1, LBYTE, IERR)
               IF (IERR.EQ.4) GO TO 625
               IF (IERR.NE.0) GO TO 110
               LBL = LBYTE / 2880
 605        LBL = LBL + I - 1
            IF (LBL.GT.NREC) LBL = NREC
            DO 610 JBL = I,LBL
               DO 609 J = 1,36
                  IPNT = IPNT + 80
                  CALL ZC8CL (80, IPNT, TAPBUF, FITS)
                  IF (FITS(1:8).NE.'        ') THEN
                     WRITE (1,1410) FITS
                     IF (FITS(1:8).EQ.'END     ') GO TO 625
                     END IF
 609              CONTINUE
 610           CONTINUE
 620        CONTINUE
 625     WRITE (MSGTXT,1571) IFIL
         IF ((IERR.EQ.4) .AND. (I.EQ.1)) CALL MSGWRT (2)
         IF ((IERR.EQ.4) .AND. (I.EQ.1)) GO TO 110
         IF (IERR.EQ.4) GO TO 630
            J = 1
            CALL ZTAPE ('ADVF', TLUN, TIND, J, IERR)
 630     CONTINUE
      GO TO 110
C-----------------------------------------------------------------------
C                                       Terminal error
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (8)
C                                       Close files
 990  IF (TIND.GT.0) CALL ZTPCLS (TLUN, TIND, IERR)
      IF (TTYIND.GT.0) CALL ZCLOSE (TTYLUN, TTYIND, IERR)
      IF (PRTIND.GT.0) CALL ZCLOSE (PRTLUN, PRTIND, IERR)
      CALL ACOUNT (2)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('Which tape drive (I)')
 1002 FORMAT ('TAPE OPEN ERROR ',I8)
 1015 FORMAT ('Printer output file name (''TEMP'' => scratch)')
 1020 FORMAT ('Op: Rewi, Advr, Advf, Read, Indx, Keyi, Quit (A4)')
 1025 FORMAT ('How many recs +- (I) <= 0 -> 10000 for read')
 1030 FORMAT ('How many files +- (I) <= 0 -> 10000 for read, indx')
 1110 FORMAT ('IERR = ',I9)
 1405 FORMAT ('1   Rec = ',I6,'  Blocking factor =',I3//)
 1410 FORMAT ('   ',A80)
 1520 FORMAT (' Rel file #',I5,' # Recs',I6,' First line ',A80)
 1560 FORMAT (' ERROR',I8,' AT REC ',I5,' FILE',I5)
 1570 FORMAT ('0End of tape after',I6,' files')
 1571 FORMAT ('End of tape after',I6,' files')
 1600 FORMAT ('1   File = ',I6//)
 1980 FORMAT ('ERROR',I7,' IN TERMINAL IO')
      END

LOCAL INCLUDE 'UVADD.INC'
C                                       Local include for UVADD
      INCLUDE 'INCS:ZPBUFSZ.INC'
      CHARACTER NAME*12, CLASS*6, NAME2*12, CLASS2*6, OUTNAM*12,
     *   OUTCLS*6, OPCODE*4
      HOLLERITH XNAME(3), XCLASS(2), XNAME2(3), XCLAS2(2), XONAME(3),
     *   XOCLAS(2), XOPCOD(1), CAT2H(256)
      REAL      XSEQ, XDISK, XSEQ2, XDISK2, XOSEQ, XODISK
      REAL      BUFF1(UVBFSS), BUFF2(UVBFSS), BUFFO(UVBFSS), CAT2R(256),
     *   XMAX
      DOUBLE PRECISION CAT2D(128), NSUM, SUM, SUMS
      LOGICAL   ISCMP1, ISCMP2, SINGLE
      INTEGER   LUN, FIND, CNO, SEQ, DISK, USERID, LUN2, FIND2,
     *   CNO2, SEQ2, DISK2, CAT2I(256), KLOCWT, LLOCWT, NRP1, NRP2,
     *   LREC2, LUNO, FINDO, CNOO, SEQO, DISKO, CATOLD(256),
     *   I1LOCB, I1LOCT, I1LOSA, I1LOA1, I1LOA2, I2LOCB, I2LOCT,
     *   I2LOSA, I2LOA1, I2LOA2, VISINC, VISMSG
C                                       Local include for UVADD
      COMMON /INPARM/ XNAME, XCLASS, XSEQ, XDISK, XNAME2, XCLAS2, XSEQ2,
     *   XDISK2, XONAME, XOCLAS, XOSEQ, XODISK, XOPCOD
      COMMON /CHPARM/ NAME, CLASS, NAME2, CLASS2, OUTNAM, OUTCLS, OPCODE
      COMMON /FNDUVC/ BUFF1, BUFF2, CATOLD, BUFFO, NSUM, SUM, SUMS,
     *   ISCMP1, ISCMP2, LUN, FIND, LUN2,FIND2, CNO, CNO2, SEQ, DISK,
     *   SEQ2, DISK2, USERID, KLOCWT, LLOCWT, NRP1, NRP2, LREC2, XMAX,
     *   I1LOCB, I1LOCT, I1LOSA, I1LOA1, I1LOA2, I2LOCB, I2LOCT, I2LOSA,
     *   I2LOA1, I2LOA2, SEQO, DISKO, CNOO, LUNO, FINDO, VISINC, VISMSG,
     *   SINGLE
      COMMON /MAP2HD/ CAT2I
      EQUIVALENCE (CAT2I, CAT2R, CAT2H, CAT2D)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
LOCAL END
LOCAL INCLUDE 'BUFFS.INC'
      INCLUDE 'ZPBUFSZ.INC'
      REAL      LBUFF(UVBFSS), KBUFF(UVBFSS), KBUFF2(UVBFSS),
     *   LBUFF2(UVBFSS)
      COMMON /UVDUFS/ LBUFF, KBUFF, LBUFF2, KBUFF2
LOCAL END
      PROGRAM UVADD
C-----------------------------------------------------------------------
C! UVADD combines 2 data matching sets
C# UV UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2019, 2021-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVADD is an AIPS system task to locate questionable data in a
C   catalogd UV data base and to print them.  Compares 2 data sets.
C   Inputs:
C     USERID    R         User number
C     INNAME    R(3)      File name: 12 chars
C     INCLASS   R(2)      File class: 6 chars
C     INSEQ     R         File seq #
C     INDISK    R         Disk volume on which file resides
C     IN2NAME   R(3)      File name: 12 chars
C     IN2CLASS  R(2)      File class: 6 chars
C     IN2SEQ    R         File seq #
C     IN2DISK   R         Disk volume on which file resides
C     CHANNEL   R         Spectral channel number
C     BIF       R         IF to test.
C     NITER     R         Limit on number of lines to print
C     UVRANGE   R(2)      Range of wavelengths to check in 1000s
C     OPCODE    R         Opcode: 4 chars ADD, SUBT, MULT, DIV
C-----------------------------------------------------------------------
      INTEGER   IRET
      INCLUDE 'UVADD.INC'
C-----------------------------------------------------------------------
C                                       Init, open file
      CALL UVADIN (IRET)
C                                       Do it
      IF (IRET.EQ.0) THEN
         IF (OPCODE.EQ.'DIV') THEN
            CALL UVADIV (IRET)
         ELSE IF (OPCODE.EQ.'MULT') THEN
            CALL UVADMU (IRET)
         ELSE IF (OPCODE.EQ.'ADD') THEN
            CALL UVADDD (IRET)
         ELSE
            CALL UVADSU (IRET)
            END IF
         END IF
C                                       history
      CALL UVADHI
C                                       Close up shop
      IRET = MAX (0, IRET)
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE UVADIN (IRET)
C-----------------------------------------------------------------------
C   UVADIN inits the task UVADV and opens the UV file and printer.
C   Outputs:
C      RQUICK   L    T => AIPS has been restarted
C      IRET     I    error code: 0 => keep going, else quit
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER PRGM*6, ITYPE*2, CTEMP1*8, CTEMP2*8, UTYPE*2, BLANK*6
      LOGICAL   F, EQUAL
      INTEGER   NPARM,I, J, IERR, INC, NT, IROUND
      DOUBLE PRECISION   DEPS
      INCLUDE 'UVADD.INC'
      DATA F /.FALSE./
      DATA PRGM /'UVADD '/
      DATA BLANK /' '/
C-----------------------------------------------------------------------
C                                       Init I/O
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 22
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAME, BUFF1, IRET)
      IF (IRET.EQ.0) GO TO 10
         RQUICK = .TRUE.
         IF (IRET.EQ.1) GO TO 999
C                                       Restart AIPS.
 10   IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 8
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XNAME, NAME)
      CALL H2CHR (6, 1, XCLASS, CLASS)
      CALL H2CHR (12, 1, XNAME2, NAME2)
      CALL H2CHR (6, 1, XCLAS2, CLASS2)
      CALL H2CHR (12, 1, XONAME, OUTNAM)
      CALL H2CHR (6, 1, XOCLAS, OUTCLS)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
C                                       Decode input.
      USERID = NLUSER
      SEQ = IROUND (XSEQ)
      DISK = IROUND (XDISK)
      SEQ2 = IROUND (XSEQ2)
      DISK2 = IROUND (XDISK2)
      SEQO = IROUND (XOSEQ)
      DISKO = IROUND (XODISK)
C                                       Open file 2 and get CAT2.
      LUN2 = 17
      ITYPE = ' '
      CALL MAPOPN ('READ', DISK2, NAME2, CLASS2, SEQ2, ITYPE, USERID,
     *   LUN2, FIND2, CNO2, CAT2I, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING 2ND INPUT UV FILE'
         CALL MSGWRT (8)
         GO TO 940
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK2
      FCNO(NCFILE) = CNO2
      FRW(NCFILE) = 0
      ISCMP2 = CAT2I(KINAX).EQ.1
      NRP2 = CAT2I(KIPCN)
      CALL COPY (256, CAT2I, CATBLK)
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 950
      LREC2 = LREC
      I2LOCB = ILOCB
      I2LOCT = ILOCT
      I2LOSA = ILOCSA
      I2LOA1 = ILOCA1
      I2LOA2 = ILOCA2
C                                       Open file and get CATBLK.
      LUN = 16
      UTYPE = 'UV'
      CALL MAPOPN ('READ', DISK, NAME, CLASS, SEQ, UTYPE, USERID, LUN,
     *   FIND, CNO, CATBLK, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING 1ST INPUT UV FILE'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 0
C                                       Get info from CATBLK.
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 950
      I1LOCB = ILOCB
      I1LOCT = ILOCT
      I1LOSA = ILOCSA
      I1LOA1 = ILOCA1
      I1LOA2 = ILOCA2
      CALL COPY (256, CATBLK, CATOLD)
      VISINC = CATBLK(KIGCN) / 20
      VISMSG = CATBLK(KIGCN) / 10
      VISINC = MAX (20000, MIN (200000,VISINC))
      VISMSG = (VISMSG / VISINC) * VISINC
      IF (VISMSG.LT.VISINC) VISMSG = 100 * VISINC
C                                       Compressed?
      ISCMP1 = CATBLK(KINAX).EQ.1
      NRP1 = CATBLK(KIPCN)
C                                       Compare headers
      EQUAL = ITYPE.EQ.'SC'
      SINGLE = .FALSE.
      IF (ITYPE.NE.'SC') THEN
         IF (ABS(CATBLK(KIGCN)-CAT2I(KIGCN)).NE.0) GO TO 49
         IF (CATBLK(KIDIM).NE.CAT2I(KIDIM)) GO TO 49
         INC = 2
         NT = CATBLK(KIDIM)
         IF (NT.GT.4) NT = 4
         DO 45 I = 2,NT
            J = KHCTP + (I-1) * INC
            CALL H2CHR (8, 1, CATH(J), CTEMP1)
            CALL H2CHR (8, 1, CAT2H(J), CTEMP2)
            IF (CTEMP1.NE.CTEMP2) GO TO 49
            J = I - 1
            DEPS = 0.01 * ABS(CATR(KRCIC+J))
            IF (DEPS.LE.0.0D0) DEPS = 1.0D-4
            IF (CATBLK(KINAX+J).NE.CAT2I(KINAX+J)) THEN
               IF ((CAT2I(KINAX+J).NE.1) .OR. (CTEMP1.NE.'FREQ'))
     *            GO TO 49
               SINGLE= .TRUE.
               END IF
            IF (ABS(CATR(KRCRP+J)-CAT2R(KRCRP+J)).GT.DEPS) GO TO 49
            IF (ABS(CATD(KDCRV+J)-CAT2D(KDCRV+J)).GT.DEPS) GO TO 49
            IF (ABS(CATR(KRCIC+J)-CAT2R(KRCIC+J)).GT.DEPS) GO TO 49
 45         CONTINUE
         GO TO 50
C                                       no match
 49      CONTINUE
            WRITE (MSGTXT,1049)
            CALL MSGWRT (8)
            GO TO 940
         END IF
C                                       now create output file
 50   CALL MAKOUT (NAME, CLASS, SEQ, BLANK,  OUTNAM, OUTCLS, SEQO)
      CALL CHR2H (12, OUTNAM, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, OUTCLS, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQO
      CALL UVCREA (DISKO, CNOO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'FAILS TO CREATE UV OUTPUT FILE'
         CALL MSGWRT (8)
         GO TO 940
         END IF
      LUNO = 18
      CALL MAPOPN ('INIT', DISKO, OUTNAM, OUTCLS, SEQO, ITYPE, USERID,
     *   LUNO, FINDO, CNOO, CATBLK, BUFFO, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING OUTPUT UV FILE'
         CALL MSGWRT (8)
         GO TO 940
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CNOO
      FRW(NCFILE) = 2
      IRET = 0
      GO TO 999
C                                       Close map on error
 940  CALL MAPCLS ('READ', DISK2, CNO2, LUN2, FIND2, CAT2I, F, BUFF2,
     *    IERR)
      IF (IERR.EQ.0) GO TO 950
         WRITE (MSGTXT,1000) IERR, 'CLOSING 2ND INPUT UV FILE'
         CALL MSGWRT (6)
 950  CALL MAPCLS ('READ', DISK, CNO, LUN, FIND, CATBLK, F, BUFF1, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1000) IERR, 'CLOSING 1ST INPUT UV FILE'
         CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVADIN ERROR',I4,' ON ',A)
 1049 FORMAT ('HEADERS DO NOT MATCH')
      END
      SUBROUTINE UVADSU (IRET)
C-----------------------------------------------------------------------
C   UVADPR reads the UV files and subtracts the vis
C   Output:
C      IRET   I   Return code: 0 success or user requests end, else bad
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'UVADD.INC'
      LOGICAL   F, T
      INTEGER   DPTR, BINDO, CMAX, JIF, JF, JS, JIMAX, JFMAX, JSMAX,
     *   NIOLIM, NUMST, NUMCH, NUMIF, OPINT, BO, BIND, BIND2, VO, COUNT,
     *   BUFSZ, INDEX, NIOUT, IERR, IPINT, IPIN2, J, LRECA, LRECF,
     *   NCORR, NIO, NIO2, XCOUNT, LENBU, JERR, RNXRET, INDEX2
      REAL      XR, XI, XA
      INCLUDE 'BUFFS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PUVD.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA LENBU, BO, VO /0, 1, 0/
C-----------------------------------------------------------------------
      IRET = 8
      XMAX = -1.0
      NSUM = 0.0D0
      SUM = 0.0D0
      SUMS = 0.0D0
C                                       Set up for compressed data.
      NCORR = (LREC - NRPARM) / CATBLK(KINAX)
      LRECF = 3 * NCORR
      DPTR = 1 + MAX (NRP1, NRP2)
      LRECA = LRECF + DPTR - 1
      CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), KLOCWT,
     *   JERR)
      IF (ISCMP1 .AND. ((JERR.NE.0) .OR. (KLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL AXEFND (8, 'WEIGHT  ', CAT2I(KIPCN), CAT2H(KHPTP), LLOCWT,
     *   JERR)
      IF (ISCMP2 .AND. ((JERR.NE.0) .OR. (LLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Initialize difference statistics
      NUMCH = CATBLK(KINAX+JLOCF)
      NUMIF = CATBLK(KINAX+JLOCIF)
      NUMST = CATBLK(KINAX+JLOCS)
C                                       Initialize reading VIS. file.
      LENBU = 0
      BUFSZ = UVBFSS * 2
      CALL UVINIT ('READ', LUN, FIND, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFF1, BO, BIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING 1ST INPUT UV FILE'
         GO TO 900
         END IF
      CALL UVINIT ('READ', LUN2, FIND2, NVIS, VO, LREC2, LENBU, BUFSZ,
     *   BUFF2, BO, BIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING 2ND INPUT UV FILE'
         GO TO 900
         END IF
      CALL UVINIT ('WRIT', LUNO, FINDO, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFFO, BO, BINDO, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING 1ST INPUT UV FILE'
         GO TO 900
         END IF
      NIOLIM = LENBU
      COUNT = 0
      NIOUT = 0
C                                       make an index table
      CALL RNXGET (DISK, CNO, CATOLD)
      CALL RNXINI (DISKO, CNOO, CATBLK, RNXRET)
C                                       Start looping thru data.
 100  CONTINUE
C                                       Read buffer.
         COUNT = COUNT + 1
         CALL UVDISK ('READ', LUN, FIND, BUFF1, NIO, BIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1001) IERR, COUNT, 'READING 1ST UV FILE'
            GO TO 900
            END IF
         CALL UVDISK ('READ', LUN2, FIND2, BUFF2, NIO2, BIND2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1001) IERR, COUNT, 'READING 2ND UV FILE'
            GO TO 900
            END IF
         IPINT = BIND - LREC
         IPIN2 = BIND2 - LREC2
         OPINT = BINDO
         NIO = MIN (NIO2, NIO)
         IF (NIO.LE.0) GO TO 200
C                                       Loop thru buffer.
         DO 175 J = 1,NIO
C                                       Update counters
            XCOUNT = XCOUNT + 1
            IPINT = IPINT + LREC
            IPIN2 = IPIN2 + LREC2
            IF (MOD(XCOUNT-1,VISMSG).EQ.0) THEN
               WRITE (MSGTXT,1105) XCOUNT
               CALL MSGWRT (2)
            ELSE IF (MOD(XCOUNT-1,VISINC).EQ.0) THEN
               WRITE (MSGTXT,1105) XCOUNT
               CALL MSGWRT (1)
               END IF
C                                       matching?
            IF (I1LOCB.GE.0) THEN
               IF (BUFF1(IPINT+I1LOCB).NE.BUFF2(IPIN2+I2LOCB)) GO TO 890
            ELSE
               IF (BUFF1(IPINT+I1LOSA).NE.BUFF2(IPIN2+I2LOSA)) GO TO 890
               IF (BUFF1(IPINT+I1LOA1).NE.BUFF2(IPIN2+I2LOA1)) GO TO 890
               IF (BUFF1(IPINT+I1LOA2).NE.BUFF2(IPIN2+I2LOA2)) GO TO 890
               END IF
            IF (ABS(BUFF1(IPINT+I1LOCT)-BUFF2(IPIN2+I2LOCT)).GT.1.E-7)
     *         GO TO 890
C                                       Compressed?
            CALL RCOPY (NRP1, BUFF1(IPINT), KBUFF)
            IF (ISCMP1) THEN
               CALL ZUVXPN (NCORR, BUFF1(IPINT+NRP1),
     *            BUFF1(IPINT+KLOCWT), KBUFF(DPTR))
            ELSE
               CALL RCOPY (LRECF, BUFF1(IPINT+NRP1), KBUFF(DPTR))
               END IF
            CALL RCOPY (NRP2, BUFF2(IPIN2), KBUFF2)
            IF (ISCMP2) THEN
               CALL ZUVXPN (NCORR, BUFF2(IPIN2+NRP2),
     *            BUFF2(IPIN2+LLOCWT), KBUFF2(DPTR))
            ELSE
               CALL RCOPY (LRECF, BUFF2(IPIN2+NRP2), KBUFF2(DPTR))
               END IF
C                                       prepare output
            CALL RCOPY (NRP1, BUFF1(IPINT),  BUFFO(OPINT))
C                                       update NX table
            CALL RNXUPD (BUFF1(IPINT), RNXRET)
            DO 130 JIF = 1,NUMIF
               DO 120 JS = 1,NUMST
                  INDEX2 = (JIF-1) * INCIF/NUMCH + (JS-1) * INCS
                  DO 110 JF = 1,NUMCH
                     INDEX = (JIF-1) * INCIF + (JF-1) * INCF +
     *                  (JS-1) * INCS
                     IF (.NOT.SINGLE) INDEX2 = INDEX
                     XR = KBUFF(DPTR+INDEX) - KBUFF2(DPTR+INDEX2)
                     XI = KBUFF(DPTR+INDEX+1) - KBUFF2(DPTR+INDEX2+1)
                     KBUFF(DPTR+INDEX) = XR
                     KBUFF(DPTR+INDEX+1) = XI
                     XA = SQRT (XR*XR + XI*XI)
                     IF (XA.GT.XMAX) THEN
                        XMAX = XA
                        JIMAX = JIF
                        JFMAX = JF
                        JSMAX = JS
                        CMAX = XCOUNT
                        END IF
                     NSUM = NSUM + 1.0D0
                     SUM = SUM + XA
                     SUMS = SUMS + XA * XA
 110                 CONTINUE
 120              CONTINUE
 130           CONTINUE
            IF (ISCMP1) THEN
               CALL ZUVPAK (NCORR, KBUFF(DPTR), BUFFO(OPINT+KLOCWT),
     *            BUFFO(OPINT+NRP1))
            ELSE
               CALL RCOPY (LRECF, KBUFF(DPTR), BUFFO(OPINT+NRP1))
               END IF
            OPINT = OPINT + LREC
            NIOUT = NIOUT + 1
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, FINDO, BUFFO, NIOLIM, BINDO,
     *            IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITING OUTPUT UV DATA'
                  GO TO 900
                  END IF
               OPINT = BINDO
               NIOUT = 0
               END IF
 175        CONTINUE
         GO TO 100
C                                       Finish write
 200  NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, FINDO, BUFFO, NIOUT, BINDO, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FLUSHING OUTPUT UV DATA'
         GO TO 900
         END IF
      IRET = 0
      GO TO 900
C                                       mismatch
 890  WRITE (MSGTXT,1890) COUNT
      IERR = 10
C                                       first input file
 900  IF (IERR.NE.0) CALL MSGWRT (8)
C
      WRITE (MSGTXT,1900) XMAX, CMAX, JSMAX, JFMAX, JIMAX
      CALL MSGWRT (5)
      IF (NSUM.GE.1.0D0) THEN
         SUM = SUM / NSUM
         SUMS = SUMS/NSUM - SUM * SUM
         SUMS = SQRT (MAX (0.0D0, SUMS))
         WRITE (MSGTXT,1901) SUM, SUMS, NSUM
         CALL MSGWRT (5)
         END IF
      CALL MAPCLS ('READ', DISK, CNO, LUN, FIND, CATOLD, F, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING INPUT FILE 1'
         CALL MSGWRT (6)
         END IF
      CALL MAPCLS ('READ', DISK2, CNO2, LUN2, FIND2, CAT2I, F, BUFF1,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING INPUT FILE 2'
         CALL MSGWRT (6)
         END IF
      CALL MAPCLS ('WRIT', DISKO, CNOO, LUNO, FINDO, CATBLK, T, BUFF1,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING OUTPUT FILE'
         CALL MSGWRT (6)
         END IF
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVADSU ERROR',I4,' ON ',A)
 1001 FORMAT ('UVADSU ERROR',I4,' COUNT',I10,' ON ',A)
 1105 FORMAT ('UVADSU: at visibility record',I10)
 1890 FORMAT ('UVADSU MISMATCH AT COUNT',I10)
 1900 FORMAT ('UVADSU Max',1PE11.3,'  Count,st,fr,if',I10,I2,I7,I3)
 1901 FORMAT ('UVADSU Mean, rms',2(1PE11.3),' from',F13.0,' samples')
      END
      SUBROUTINE UVADDD (IRET)
C-----------------------------------------------------------------------
C   UVADPR reads the UV files and adds the vis
C   Output:
C      IRET   I   Return code: 0 success or user requests end, else bad
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'UVADD.INC'
      LOGICAL   F, T
      INTEGER   DPTR, BINDO, CMAX, JIF, JF, JS, JIMAX, JFMAX, JSMAX,
     *   NIOLIM, NUMST, NUMCH, NUMIF, OPINT, BO, BIND, BIND2, VO, COUNT,
     *   BUFSZ, INDEX, NIOUT, IERR, IPINT, IPIN2, J, LRECA, LRECF,
     *   NCORR, NIO, NIO2, XCOUNT, LENBU, JERR, RNXRET, INDEX2
      REAL      XR, XI, XA
      INCLUDE 'BUFFS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PUVD.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA LENBU, BO, VO /0, 1, 0/
C-----------------------------------------------------------------------
      IRET = 8
      XMAX = -1.0
      NSUM = 0.0D0
      SUM = 0.0D0
      SUMS = 0.0D0
C                                       Set up for compressed data.
      NCORR = (LREC - NRPARM) / CATBLK(KINAX)
      LRECF = 3 * NCORR
      DPTR = 1 + MAX (NRP1, NRP2)
      LRECA = LRECF + DPTR - 1
      CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), KLOCWT,
     *   JERR)
      IF (ISCMP1 .AND. ((JERR.NE.0) .OR. (KLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL AXEFND (8, 'WEIGHT  ', CAT2I(KIPCN), CAT2H(KHPTP), LLOCWT,
     *   JERR)
      IF (ISCMP2 .AND. ((JERR.NE.0) .OR. (LLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Initialize difference statistics
      NUMCH = CATBLK(KINAX+JLOCF)
      NUMIF = CATBLK(KINAX+JLOCIF)
      NUMST = CATBLK(KINAX+JLOCS)
C                                       Initialize reading VIS. file.
      LENBU = 0
      BUFSZ = UVBFSS * 2
      CALL UVINIT ('READ', LUN, FIND, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFF1, BO, BIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING 1ST INPUT UV FILE'
         GO TO 900
         END IF
      CALL UVINIT ('READ', LUN2, FIND2, NVIS, VO, LREC2, LENBU, BUFSZ,
     *   BUFF2, BO, BIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING 2ND INPUT UV FILE'
         GO TO 900
         END IF
      CALL UVINIT ('WRIT', LUNO, FINDO, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFFO, BO, BINDO, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING 1ST INPUT UV FILE'
         GO TO 900
         END IF
      NIOLIM = LENBU
      COUNT = 0
      NIOUT = 0
C                                       make an index table
      CALL RNXGET (DISK, CNO, CATOLD)
      CALL RNXINI (DISKO, CNOO, CATBLK, RNXRET)
C                                       Start looping thru data.
 100  CONTINUE
C                                       Read buffer.
         COUNT = COUNT + 1
         CALL UVDISK ('READ', LUN, FIND, BUFF1, NIO, BIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1001) IERR, COUNT, 'READING 1ST UV FILE'
            GO TO 900
            END IF
         CALL UVDISK ('READ', LUN2, FIND2, BUFF2, NIO2, BIND2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1001) IERR, COUNT, 'READING 2ND UV FILE'
            GO TO 900
            END IF
         IPINT = BIND - LREC
         IPIN2 = BIND2 - LREC2
         OPINT = BINDO
         NIO = MIN (NIO2, NIO)
         IF (NIO.LE.0) GO TO 200
C                                       Loop thru buffer.
         DO 175 J = 1,NIO
C                                       Update counters
            XCOUNT = XCOUNT + 1
            IPINT = IPINT + LREC
            IPIN2 = IPIN2 + LREC2
            IF (MOD(XCOUNT-1,VISMSG).EQ.0) THEN
               WRITE (MSGTXT,1105) XCOUNT
               CALL MSGWRT (2)
            ELSE IF (MOD(XCOUNT-1,VISINC).EQ.0) THEN
               WRITE (MSGTXT,1105) XCOUNT
               CALL MSGWRT (1)
               END IF
C                                       matching?
            IF (I1LOCB.GE.0) THEN
               IF (BUFF1(IPINT+I1LOCB).NE.BUFF2(IPIN2+I2LOCB)) GO TO 890
            ELSE
               IF (BUFF1(IPINT+I1LOSA).NE.BUFF2(IPIN2+I2LOSA)) GO TO 890
               IF (BUFF1(IPINT+I1LOA1).NE.BUFF2(IPIN2+I2LOA1)) GO TO 890
               IF (BUFF1(IPINT+I1LOA2).NE.BUFF2(IPIN2+I2LOA2)) GO TO 890
               END IF
            IF (ABS(BUFF1(IPINT+I1LOCT)-BUFF2(IPIN2+I2LOCT)).GT.1.E-7)
     *         GO TO 890
C                                       Compressed?
            CALL RCOPY (NRP1, BUFF1(IPINT), KBUFF)
            IF (ISCMP1) THEN
               CALL ZUVXPN (NCORR, BUFF1(IPINT+NRP1),
     *            BUFF1(IPINT+KLOCWT), KBUFF(DPTR))
            ELSE
               CALL RCOPY (LRECF, BUFF1(IPINT+NRP1), KBUFF(DPTR))
               END IF
            CALL RCOPY (NRP2, BUFF2(IPIN2), KBUFF2)
            IF (ISCMP2) THEN
               CALL ZUVXPN (NCORR, BUFF2(IPIN2+NRP2),
     *            BUFF2(IPIN2+LLOCWT), KBUFF2(DPTR))
            ELSE
               CALL RCOPY (LRECF, BUFF2(IPIN2+NRP2), KBUFF2(DPTR))
               END IF
C                                       prepare output
            CALL RCOPY (NRP1, BUFF1(IPINT),  BUFFO(OPINT))
C                                       update NX table
            CALL RNXUPD (BUFF1(IPINT), RNXRET)
            DO 130 JIF = 1,NUMIF
               DO 120 JS = 1,NUMST
                  INDEX2 = (JIF-1) * INCIF/NUMCH + (JS-1) * INCS
                  DO 110 JF = 1,NUMCH
                     INDEX = (JIF-1) * INCIF + (JF-1) * INCF +
     *                  (JS-1) * INCS
                     IF (.NOT.SINGLE) INDEX2 = INDEX
                     XR = KBUFF(DPTR+INDEX) + KBUFF2(DPTR+INDEX2)
                     XI = KBUFF(DPTR+INDEX+1) + KBUFF2(DPTR+INDEX2+1)
                     KBUFF(DPTR+INDEX) = XR
                     KBUFF(DPTR+INDEX+1) = XI
                     XA = SQRT (XR*XR + XI*XI)
                     IF (XA.GT.XMAX) THEN
                        XMAX = XA
                        JIMAX = JIF
                        JFMAX = JF
                        JSMAX = JS
                        CMAX = XCOUNT
                        END IF
                     NSUM = NSUM + 1.0D0
                     SUM = SUM + XA
                     SUMS = SUMS + XA * XA
 110                 CONTINUE
 120              CONTINUE
 130           CONTINUE
            IF (ISCMP1) THEN
               CALL ZUVPAK (NCORR, KBUFF(DPTR), BUFFO(OPINT+KLOCWT),
     *            BUFFO(OPINT+NRP1))
            ELSE
               CALL RCOPY (LRECF, KBUFF(DPTR), BUFFO(OPINT+NRP1))
               END IF
            OPINT = OPINT + LREC
            NIOUT = NIOUT + 1
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, FINDO, BUFFO, NIOLIM, BINDO,
     *            IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITING OUTPUT UV DATA'
                  GO TO 900
                  END IF
               OPINT = BINDO
               NIOUT = 0
               END IF
 175        CONTINUE
         GO TO 100
C                                       Finish write
 200  NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, FINDO, BUFFO, NIOUT, BINDO, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FLUSHING OUTPUT UV DATA'
         GO TO 900
         END IF
      IRET = 0
      GO TO 900
C                                       mismatch
 890  WRITE (MSGTXT,1890) COUNT
      IERR = 10
C                                       first input file
 900  IF (IERR.NE.0) CALL MSGWRT (8)
C
      WRITE (MSGTXT,1900) XMAX, CMAX, JSMAX, JFMAX, JIMAX
      CALL MSGWRT (5)
      IF (NSUM.GE.1.0D0) THEN
         SUM = SUM / NSUM
         SUMS = SUMS/NSUM - SUM * SUM
         SUMS = SQRT (MAX (0.0D0, SUMS))
         WRITE (MSGTXT,1901) SUM, SUMS, NSUM
         CALL MSGWRT (5)
         END IF
      CALL MAPCLS ('READ', DISK, CNO, LUN, FIND, CATOLD, F, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING INPUT FILE 1'
         CALL MSGWRT (6)
         END IF
      CALL MAPCLS ('READ', DISK2, CNO2, LUN2, FIND2, CAT2I, F, BUFF1,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING INPUT FILE 2'
         CALL MSGWRT (6)
         END IF
      CALL MAPCLS ('WRIT', DISKO, CNOO, LUNO, FINDO, CATBLK, T, BUFF1,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING OUTPUT FILE'
         CALL MSGWRT (6)
         END IF
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVADDD ERROR',I4,' ON ',A)
 1001 FORMAT ('UVADDD ERROR',I4,' COUNT',I10,' ON ',A)
 1105 FORMAT ('UVADDD: at visibility record',I10)
 1890 FORMAT ('UVADDD MISMATCH AT COUNT',I10)
 1900 FORMAT ('UVADDD Max',1PE11.3,'  Count,st,fr,if',I10,I2,I7,I3)
 1901 FORMAT ('UVADDD Mean, rms',2(1PE11.3),' from',F13.0,' samples')
      END
      SUBROUTINE UVADMU (IRET)
C-----------------------------------------------------------------------
C   UVADPR reads the UV files and multiplies the vis
C   Output:
C      IRET   I   Return code: 0 success or user requests end, else bad
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'UVADD.INC'
      LOGICAL   F, T
      INTEGER   DPTR, BINDO, CMAX, JIF, JF, JS, JIMAX, JFMAX, JSMAX,
     *   NIOLIM, NUMST, NUMCH, NUMIF, OPINT, BO, BIND, BIND2, VO, COUNT,
     *   BUFSZ, INDEX, NIOUT, IERR, IPINT, IPIN2, J, LRECA, LRECF,
     *   NCORR, NIO, NIO2, XCOUNT, LENBU, JERR, RNXRET, INDEX2
      REAL      XR, XI, XA
      INCLUDE 'BUFFS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PUVD.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA LENBU, BO, VO /0, 1, 0/
C-----------------------------------------------------------------------
      IRET = 8
      XMAX = -1.0
      NSUM = 0.0D0
      SUM = 0.0D0
      SUMS = 0.0D0
C                                       Set up for compressed data.
      NCORR = (LREC - NRPARM) / CATBLK(KINAX)
      LRECF = 3 * NCORR
      DPTR = 1 + MAX (NRP1, NRP2)
      LRECA = LRECF + DPTR - 1
      CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), KLOCWT,
     *   JERR)
      IF (ISCMP1 .AND. ((JERR.NE.0) .OR. (KLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL AXEFND (8, 'WEIGHT  ', CAT2I(KIPCN), CAT2H(KHPTP), LLOCWT,
     *   JERR)
      IF (ISCMP2 .AND. ((JERR.NE.0) .OR. (LLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Initialize difference statistics
      NUMCH = CATBLK(KINAX+JLOCF)
      NUMIF = CATBLK(KINAX+JLOCIF)
      NUMST = CATBLK(KINAX+JLOCS)
C                                       Initialize reading VIS. file.
      LENBU = 0
      BUFSZ = UVBFSS * 2
      CALL UVINIT ('READ', LUN, FIND, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFF1, BO, BIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING 1ST INPUT UV FILE'
         GO TO 900
         END IF
      CALL UVINIT ('READ', LUN2, FIND2, NVIS, VO, LREC2, LENBU, BUFSZ,
     *   BUFF2, BO, BIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING 2ND INPUT UV FILE'
         GO TO 900
         END IF
      CALL UVINIT ('WRIT', LUNO, FINDO, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFFO, BO, BINDO, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING 1ST INPUT UV FILE'
         GO TO 900
         END IF
      NIOLIM = LENBU
      COUNT = 0
      NIOUT = 0
C                                       make an index table
      CALL RNXGET (DISK, CNO, CATOLD)
      CALL RNXINI (DISKO, CNOO, CATBLK, RNXRET)
C                                       Start looping thru data.
 100  CONTINUE
C                                       Read buffer.
         COUNT = COUNT + 1
         CALL UVDISK ('READ', LUN, FIND, BUFF1, NIO, BIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1001) IERR, COUNT, 'READING 1ST UV FILE'
            GO TO 900
            END IF
         CALL UVDISK ('READ', LUN2, FIND2, BUFF2, NIO2, BIND2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1001) IERR, COUNT, 'READING 2ND UV FILE'
            GO TO 900
            END IF
         IPINT = BIND - LREC
         IPIN2 = BIND2 - LREC2
         OPINT = BINDO
         NIO = MIN (NIO2, NIO)
         IF (NIO.LE.0) GO TO 200
C                                       Loop thru buffer.
         DO 175 J = 1,NIO
C                                       Update counters
            XCOUNT = XCOUNT + 1
            IPINT = IPINT + LREC
            IPIN2 = IPIN2 + LREC2
            IF (MOD(XCOUNT-1,VISMSG).EQ.0) THEN
               WRITE (MSGTXT,1105) XCOUNT
               CALL MSGWRT (2)
            ELSE IF (MOD(XCOUNT-1,VISINC).EQ.0) THEN
               WRITE (MSGTXT,1105) XCOUNT
               CALL MSGWRT (1)
               END IF
C                                       matching?
            IF (I1LOCB.GE.0) THEN
               IF (BUFF1(IPINT+I1LOCB).NE.BUFF2(IPIN2+I2LOCB)) GO TO 890
            ELSE
               IF (BUFF1(IPINT+I1LOSA).NE.BUFF2(IPIN2+I2LOSA)) GO TO 890
               IF (BUFF1(IPINT+I1LOA1).NE.BUFF2(IPIN2+I2LOA1)) GO TO 890
               IF (BUFF1(IPINT+I1LOA2).NE.BUFF2(IPIN2+I2LOA2)) GO TO 890
               END IF
            IF (ABS(BUFF1(IPINT+I1LOCT)-BUFF2(IPIN2+I2LOCT)).GT.1.E-7)
     *         GO TO 890
C                                       Compressed?
            CALL RCOPY (NRP1, BUFF1(IPINT), KBUFF)
            IF (ISCMP1) THEN
               CALL ZUVXPN (NCORR, BUFF1(IPINT+NRP1),
     *            BUFF1(IPINT+KLOCWT), KBUFF(DPTR))
            ELSE
               CALL RCOPY (LRECF, BUFF1(IPINT+NRP1), KBUFF(DPTR))
               END IF
            CALL RCOPY (NRP2, BUFF2(IPIN2), KBUFF2)
            IF (ISCMP2) THEN
               CALL ZUVXPN (NCORR, BUFF2(IPIN2+NRP2),
     *            BUFF2(IPIN2+LLOCWT), KBUFF2(DPTR))
            ELSE
               CALL RCOPY (LRECF, BUFF2(IPIN2+NRP2), KBUFF2(DPTR))
               END IF
C                                       prepare output
            CALL RCOPY (NRP1, BUFF1(IPINT),  BUFFO(OPINT))
C                                       update NX table
            CALL RNXUPD (BUFF1(IPINT), RNXRET)
            DO 130 JIF = 1,NUMIF
               DO 120 JS = 1,NUMST
                  INDEX2 = (JIF-1) * INCIF/NUMCH + (JS-1) * INCS
                  DO 110 JF = 1,NUMCH
                     INDEX = (JIF-1) * INCIF + (JF-1) * INCF +
     *                  (JS-1) * INCS
                     XR = KBUFF(DPTR+INDEX) * KBUFF2(DPTR+INDEX2) -
     *                  KBUFF(DPTR+INDEX+1) * KBUFF2(DPTR+INDEX2+1)
                     XI = KBUFF(DPTR+INDEX) * KBUFF2(DPTR+INDEX2+1) +
     *                  KBUFF(DPTR+INDEX+1) + KBUFF2(DPTR+INDEX2)
                     KBUFF(DPTR+INDEX) = XR
                     KBUFF(DPTR+INDEX+1) = XI
                     XA = SQRT (XR*XR + XI*XI)
                     IF (XA.GT.XMAX) THEN
                        XMAX = XA
                        JIMAX = JIF
                        JFMAX = JF
                        JSMAX = JS
                        CMAX = XCOUNT
                        END IF
                     NSUM = NSUM + 1.0D0
                     SUM = SUM + XA
                     SUMS = SUMS + XA * XA
 110                 CONTINUE
 120              CONTINUE
 130           CONTINUE
            IF (ISCMP1) THEN
               CALL ZUVPAK (NCORR, KBUFF(DPTR), BUFFO(OPINT+KLOCWT),
     *            BUFFO(OPINT+NRP1))
            ELSE
               CALL RCOPY (LRECF, KBUFF(DPTR), BUFFO(OPINT+NRP1))
               END IF
            OPINT = OPINT + LREC
            NIOUT = NIOUT + 1
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, FINDO, BUFFO, NIOLIM, BINDO,
     *            IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITING OUTPUT UV DATA'
                  GO TO 900
                  END IF
               OPINT = BINDO
               NIOUT = 0
               END IF
 175        CONTINUE
         GO TO 100
C                                       Finish write
 200  NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, FINDO, BUFFO, NIOUT, BINDO, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FLUSHING OUTPUT UV DATA'
         GO TO 900
         END IF
      IRET = 0
      GO TO 900
C                                       mismatch
 890  WRITE (MSGTXT,1890) COUNT
      IERR = 10
C                                       first input file
 900  IF (IERR.NE.0) CALL MSGWRT (8)
C
      WRITE (MSGTXT,1900) XMAX, CMAX, JSMAX, JFMAX, JIMAX
      CALL MSGWRT (5)
      IF (NSUM.GE.1.0D0) THEN
         SUM = SUM / NSUM
         SUMS = SUMS/NSUM - SUM * SUM
         SUMS = SQRT (MAX (0.0D0, SUMS))
         WRITE (MSGTXT,1901) SUM, SUMS, NSUM
         CALL MSGWRT (5)
         END IF
      CALL MAPCLS ('READ', DISK, CNO, LUN, FIND, CATOLD, F, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING INPUT FILE 1'
         CALL MSGWRT (6)
         END IF
      CALL MAPCLS ('READ', DISK2, CNO2, LUN2, FIND2, CAT2I, F, BUFF1,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING INPUT FILE 2'
         CALL MSGWRT (6)
         END IF
      CALL MAPCLS ('WRIT', DISKO, CNOO, LUNO, FINDO, CATBLK, T, BUFF1,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING OUTPUT FILE'
         CALL MSGWRT (6)
         END IF
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVADMU ERROR',I4,' ON ',A)
 1001 FORMAT ('UVADMU ERROR',I4,' COUNT',I10,' ON ',A)
 1105 FORMAT ('UVADMU: at visibility record',I10)
 1890 FORMAT ('UVADMU MISMATCH AT COUNT',I10)
 1900 FORMAT ('UVADMU Max',1PE11.3,'  Count,st,fr,if',I10,I2,I7,I3)
 1901 FORMAT ('UVADMU Mean, rms',2(1PE11.3),' from',F13.0,' samples')
      END
      SUBROUTINE UVADIV (IRET)
C-----------------------------------------------------------------------
C   UVADPR reads the UV files and divides the vis
C   Output:
C      IRET   I   Return code: 0 success or user requests end, else bad
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'UVADD.INC'
      LOGICAL   F, T
      INTEGER   DPTR, BINDO, CMAX, JIF, JF, JS, JIMAX, JFMAX, JSMAX,
     *   NIOLIM, NUMST, NUMCH, NUMIF, OPINT, BO, BIND, BIND2, VO, COUNT,
     *   BUFSZ, INDEX, NIOUT, IERR, IPINT, IPIN2, J, LRECA, LRECF,
     *   NCORR, NIO, NIO2, XCOUNT, LENBU, JERR, RNXRET, INDEX2
      REAL      XR, XI, XA
      INCLUDE 'BUFFS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PUVD.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA LENBU, BO, VO /0, 1, 0/
C-----------------------------------------------------------------------
      IRET = 8
      XMAX = -1.0
      NSUM = 0.0D0
      SUM = 0.0D0
      SUMS = 0.0D0
C                                       Set up for compressed data.
      NCORR = (LREC - NRPARM) / CATBLK(KINAX)
      LRECF = 3 * NCORR
      DPTR = 1 + MAX (NRP1, NRP2)
      LRECA = LRECF + DPTR - 1
      CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), KLOCWT,
     *   JERR)
      IF (ISCMP1 .AND. ((JERR.NE.0) .OR. (KLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL AXEFND (8, 'WEIGHT  ', CAT2I(KIPCN), CAT2H(KHPTP), LLOCWT,
     *   JERR)
      IF (ISCMP2 .AND. ((JERR.NE.0) .OR. (LLOCWT.LT.0))) THEN
         IRET = 5
         MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED DATA'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Initialize difference statistics
      NUMCH = CATBLK(KINAX+JLOCF)
      NUMIF = CATBLK(KINAX+JLOCIF)
      NUMST = CATBLK(KINAX+JLOCS)
C                                       Initialize reading VIS. file.
      LENBU = 0
      BUFSZ = UVBFSS * 2
      CALL UVINIT ('READ', LUN, FIND, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFF1, BO, BIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING 1ST INPUT UV FILE'
         GO TO 900
         END IF
      CALL UVINIT ('READ', LUN2, FIND2, NVIS, VO, LREC2, LENBU, BUFSZ,
     *   BUFF2, BO, BIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING 2ND INPUT UV FILE'
         GO TO 900
         END IF
      CALL UVINIT ('WRIT', LUNO, FINDO, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFFO, BO, BINDO, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING 1ST INPUT UV FILE'
         GO TO 900
         END IF
      NIOLIM = LENBU
      COUNT = 0
      NIOUT = 0
C                                       make an index table
      CALL RNXGET (DISK, CNO, CATOLD)
      CALL RNXINI (DISKO, CNOO, CATBLK, RNXRET)
C                                       Start looping thru data.
 100  CONTINUE
C                                       Read buffer.
         COUNT = COUNT + 1
         CALL UVDISK ('READ', LUN, FIND, BUFF1, NIO, BIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1001) IERR, COUNT, 'READING 1ST UV FILE'
            GO TO 900
            END IF
         CALL UVDISK ('READ', LUN2, FIND2, BUFF2, NIO2, BIND2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1001) IERR, COUNT, 'READING 2ND UV FILE'
            GO TO 900
            END IF
         IPINT = BIND - LREC
         IPIN2 = BIND2 - LREC2
         OPINT = BINDO
         NIO = MIN (NIO2, NIO)
         IF (NIO.LE.0) GO TO 200
C                                       Loop thru buffer.
         DO 175 J = 1,NIO
C                                       Update counters
            XCOUNT = XCOUNT + 1
            IPINT = IPINT + LREC
            IPIN2 = IPIN2 + LREC2
            IF (MOD(XCOUNT-1,VISMSG).EQ.0) THEN
               WRITE (MSGTXT,1105) XCOUNT
               CALL MSGWRT (2)
            ELSE IF (MOD(XCOUNT-1,VISINC).EQ.0) THEN
               WRITE (MSGTXT,1105) XCOUNT
               CALL MSGWRT (1)
               END IF
C                                       matching?
            IF (I1LOCB.GE.0) THEN
               IF (BUFF1(IPINT+I1LOCB).NE.BUFF2(IPIN2+I2LOCB)) GO TO 890
            ELSE
               IF (BUFF1(IPINT+I1LOSA).NE.BUFF2(IPIN2+I2LOSA)) GO TO 890
               IF (BUFF1(IPINT+I1LOA1).NE.BUFF2(IPIN2+I2LOA1)) GO TO 890
               IF (BUFF1(IPINT+I1LOA2).NE.BUFF2(IPIN2+I2LOA2)) GO TO 890
               END IF
            IF (ABS(BUFF1(IPINT+I1LOCT)-BUFF2(IPIN2+I2LOCT)).GT.1.E-7)
     *         GO TO 890
C                                       Compressed?
            CALL RCOPY (NRP1, BUFF1(IPINT), KBUFF)
            IF (ISCMP1) THEN
               CALL ZUVXPN (NCORR, BUFF1(IPINT+NRP1),
     *            BUFF1(IPINT+KLOCWT), KBUFF(DPTR))
            ELSE
               CALL RCOPY (LRECF, BUFF1(IPINT+NRP1), KBUFF(DPTR))
               END IF
            CALL RCOPY (NRP2, BUFF2(IPIN2), KBUFF2)
            IF (ISCMP2) THEN
               CALL ZUVXPN (NCORR, BUFF2(IPIN2+NRP2),
     *            BUFF2(IPIN2+LLOCWT), KBUFF2(DPTR))
            ELSE
               CALL RCOPY (LRECF, BUFF2(IPIN2+NRP2), KBUFF2(DPTR))
               END IF
C                                       prepare output
            CALL RCOPY (NRP1, BUFF1(IPINT),  BUFFO(OPINT))
C                                       update NX table
            CALL RNXUPD (BUFF1(IPINT), RNXRET)
            DO 130 JIF = 1,NUMIF
               DO 120 JS = 1,NUMST
                  INDEX2 = (JIF-1) * INCIF/NUMCH + (JS-1) * INCS
                  DO 110 JF = 1,NUMCH
                     INDEX = (JIF-1) * INCIF + (JF-1) * INCF +
     *                  (JS-1) * INCS
                     XA = KBUFF2(DPTR+INDEX)**2+KBUFF2(DPTR+INDEX2+1)**2
                     XR = (KBUFF(DPTR+INDEX) * KBUFF2(DPTR+INDEX2) +
     *                  KBUFF(DPTR+INDEX+1) * KBUFF2(DPTR+INDEX2+1))/ XA
                     XI = (KBUFF(DPTR+INDEX+1) * KBUFF2(DPTR+INDEX2) -
     *                  KBUFF(DPTR+INDEX) * KBUFF2(DPTR+INDEX2+1)) / XA
                     KBUFF(DPTR+INDEX) = XR
                     KBUFF(DPTR+INDEX+1) = XI
                     XA = SQRT (XR*XR + XI*XI)
                     IF (XA.GT.XMAX) THEN
                        XMAX = XA
                        JIMAX = JIF
                        JFMAX = JF
                        JSMAX = JS
                        CMAX = XCOUNT
                        END IF
                     NSUM = NSUM + 1.0D0
                     SUM = SUM + XA
                     SUMS = SUMS + XA * XA
 110                 CONTINUE
 120              CONTINUE
 130           CONTINUE
            IF (ISCMP1) THEN
               CALL ZUVPAK (NCORR, KBUFF(DPTR), BUFFO(OPINT+KLOCWT),
     *            BUFFO(OPINT+NRP1))
            ELSE
               CALL RCOPY (LRECF, KBUFF(DPTR), BUFFO(OPINT+NRP1))
               END IF
            OPINT = OPINT + LREC
            NIOUT = NIOUT + 1
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, FINDO, BUFFO, NIOLIM, BINDO,
     *            IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITING OUTPUT UV DATA'
                  GO TO 900
                  END IF
               OPINT = BINDO
               NIOUT = 0
               END IF
 175        CONTINUE
         GO TO 100
C                                       Finish write
 200  NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, FINDO, BUFFO, NIOUT, BINDO, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FLUSHING OUTPUT UV DATA'
         GO TO 900
         END IF
      IRET = 0
      GO TO 900
C                                       mismatch
 890  WRITE (MSGTXT,1890) COUNT
      IERR = 10
C                                       first input file
 900  IF (IERR.NE.0) CALL MSGWRT (8)
C
      WRITE (MSGTXT,1900) XMAX, CMAX, JSMAX, JFMAX, JIMAX
      CALL MSGWRT (5)
      IF (NSUM.GE.1.0D0) THEN
         SUM = SUM / NSUM
         SUMS = SUMS/NSUM - SUM * SUM
         SUMS = SQRT (MAX (0.0D0, SUMS))
         WRITE (MSGTXT,1901) SUM, SUMS, NSUM
         CALL MSGWRT (5)
         END IF
      CALL MAPCLS ('READ', DISK, CNO, LUN, FIND, CATOLD, F, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING INPUT FILE 1'
         CALL MSGWRT (6)
         END IF
      CALL MAPCLS ('READ', DISK2, CNO2, LUN2, FIND2, CAT2I, F, BUFF1,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING INPUT FILE 2'
         CALL MSGWRT (6)
         END IF
      CALL MAPCLS ('WRIT', DISKO, CNOO, LUNO, FINDO, CATBLK, T, BUFF1,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING OUTPUT FILE'
         CALL MSGWRT (6)
         END IF
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVADIV ERROR',I4,' ON ',A)
 1001 FORMAT ('UVADIV ERROR',I4,' COUNT',I10,' ON ',A)
 1105 FORMAT ('UVADIV: at visibility record',I10)
 1890 FORMAT ('UVADIV MISMATCH AT COUNT',I10)
 1900 FORMAT ('UVADIV Max',1PE11.3,'  Count,st,fr,if',I10,I2,I7,I3)
 1901 FORMAT ('UVADIV Mean, rms',2(1PE11.3),' from',F13.0,' samples')
      END
      SUBROUTINE UVADHI
C-----------------------------------------------------------------------
C   Copies old HI to new file and adds
C-----------------------------------------------------------------------
      INTEGER   HLUN1, HLUN2, IERR, NONOT
      CHARACTER HILINE*72, NOTTYP(25)*2
      INCLUDE 'UVADD.INC'
      INCLUDE 'INCS:DHIS.INC'
      DATA HLUN1, HLUN2 /27,28/
C                                       allow SU, AN, FQ, PO
      DATA NONOT, NOTTYP /25, 'BP', 'CL', 'CD', 'CP', 'CQ', 'FG', 'GC',
     *   'IM', 'MC', 'PC', 'PD', 'SN', 'SY', 'TY', 'WX', 'BL', 'PP',
     *   'BD', 'NX', 'CC', 'CH', 'AT', 'VT', 'HF', 'TE'/
C-----------------------------------------------------------------------
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (HLUN1, HLUN2, DISK, DISKO, CNO, CNOO, CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAME, CLASS, SEQ, DISK, HLUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCO2 (TSKNAM, NAME2, CLASS2, SEQ2, DISK2, HLUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCOO (TSKNAM, OUTNAM, OUTCLS, SEQO, DISKO, HLUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,2000) TSKNAM, OPCODE
      CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      IF (SINGLE) THEN
         HILINE = TSKNAM // '/ 2nd data set single spectral channel'
         CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
         END IF
      WRITE (HILINE,2001) TSKNAM, XMAX
      CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,2002) TSKNAM, SUM
      CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,2003) TSKNAM, SUMS
      CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Close HI file
 100  CALL HICLOS (HLUN2, .TRUE., BUFF2, IERR)
C                                       Copy a few tables
      CALL ALLTAB (NONOT, NOTTYP, HLUN1, HLUN2, DISK, DISKO, CNO, CNOO,
     *   CATBLK, BUFF1, BUFF2, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVADHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 2000 FORMAT (A6,'OPCODE = ''',A,'''   / operation performed')
 2001 FORMAT (A6,'/ peak amplitude out',1PE11.3)
 2002 FORMAT (A6,'/ mean amplitude out',1PE11.3)
 2003 FORMAT (A6,'/ rms amplitude out',1PE11.3)
      END

      SUBROUTINE STATCH (OLDST, NEWST, IVOL, ISLOT, FTYPE, BUFFER, IERR)
C-----------------------------------------------------------------------
C! Changes state of a file
C# Utility Catalog
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2005
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to clear a file of one state and change it to another state.
C   Inputs:
C      OLDST    C*4    State to clear from the file ('READ', 'WRIT',
C                      else no clear)
C      NEWST    C*4    New state into which file should be placed
C                      ('READ', 'WRIT', else no new state)
C      IVOL     I      Volume number on which file resides
C      ISLOT    I      Catalogue number of file
C      FTYPE    C*2    Type of file, 'UV' or 'MA'
C      BUFFER   I(*)   Work buffer
C   Outputs:
C      IERR     I      Error code, 0 => OK, else from CATDIR with
C                      warnings reset to 0.
C-----------------------------------------------------------------------
      CHARACTER OLDST*4, NEWST*4, FTYPE*2
      INTEGER   IVOL, ISLOT, BUFFER(*), IERR
C
      CHARACTER CTEMP*12, CLRST*4
      INTEGER   IDUM
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       clear
      IF (OLDST.EQ.'READ') THEN
         CLRST = 'CLRD'
      ELSE IF (OLDST.EQ.'WRIT') THEN
         CLRST = 'CLWR'
      ELSE
         CLRST = ' '
         END IF
      IF (CLRST.NE.' ') THEN
         CALL CATDIR ('CSTA', IVOL, ISLOT, CTEMP, CTEMP, IDUM, FTYPE,
     *      IDUM, CLRST, BUFFER, IERR)
         IF (IERR.EQ.10) IERR = 0
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'BY', CLRST
            CALL MSGWRT (8)
            GO TO 999
            END IF
         END IF
      IF ((NEWST.EQ.'READ') .OR. (NEWST.EQ.'WRIT')) THEN
         CALL CATDIR ('CSTA', IVOL, ISLOT, CTEMP, CTEMP, IDUM, FTYPE,
     *      IDUM, NEWST, BUFFER, IERR)
         IF (IERR.EQ.9) IERR = 0
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'TO', NEWST
            CALL MSGWRT (8)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('STATCH: ERROR ',I3,' CHANGING STATUS ',A,1X,A4)
      END

      SUBROUTINE ZPHFIL (TYPE, IVOL, NSEQ, IVER, PNAM, IERR)
C-----------------------------------------------------------------------
C! construct a physical file or device name from AIPS logical parameters
C# Z IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Construct a physical file name in PNAM from TYPE, IVOL, NSEQ, and
C   IVER - either for public data files or user-specific files.
C   Inputs:
C      TYPE    C*2   Type of file: e.g. 'MA' for map file
C      IVOL    I     Number of the disk volume to be used (1-15)
C      NSEQ    I     Sequence number (000-4095)
C      IVER    I     Version number (00-255)
C   Outputs:
C      PNAM    C*48  physical file name, left justified
C      IERR    I     Error return code: 0 = good return.   1 = error.
C
C   Example: If TYPE='MA', IVOL=7, AIPSVER=C, NSEQ=321, IVER=99,
C            NLUSER=762 then
C               PNAME='DA07:MAC14163;1'      for public data or
C               PNAME='DA07:MAC14163.2FA;1'  for private data
C            where 321 = 141 base 16, 99 = 63 base 16, 762 = 2FA base 16
C
C   TYPE = 'MT' leads to special name for tapes
C   TYPE = 'TK' leads to special name for TEK4012 plotter CRT
C   TYPE = 'TV' leads to special name for TV device
C   TYPE = 'ME' leads to special logical for POPS memory files
C
C   Generic version - the ZOPEN, ZTRLOG, etc. routines interpret the
C   resulting VMS-like names.
C   VMS VERSION RETAINS ;1.
C-----------------------------------------------------------------------
      CHARACTER TYPE*2, PNAM*48
      INTEGER   IVOL, NSEQ, IVER, IERR
C
      INTEGER   IVOL2, NUNAME, UNAME, VERLIM, VOLLIM, CATLIM
      CHARACTER JUNK*4, UNAMES(15)*2, VERDAT*1, VERSYS*1
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA NUNAME, UNAMES /15, 'AC','BA','BQ','HE','IC','ID','IN','ME',
     *   'SP','TP','TD','GR','PW','MT','TC'/
C                                       Current AIPS data version level
      DATA VERDAT, VERSYS /'D','D'/
C-----------------------------------------------------------------------
      IERR = 1
      PNAM = 'DA00:MAAFFFFFF.;1'
      PNAM(8:8) = VERDAT
      IF (TYPE.EQ.'MT') PNAM(1:2) = 'MT'
C                                       Special code for TEK 4012
      IF (TYPE.EQ.'TK') THEN
         IF (NTKDEV.LE.0) GO TO 999
         PNAM = 'TKDEV  :'
         CALL ZEHEX (NTKDEV, 2, PNAM(6:7))
C                                       TV device
      ELSE IF (TYPE.EQ.'TV') THEN
         IF (NTVDEV.LE.0) GO TO 999
         PNAM = 'TVDEV  :'
         CALL ZEHEX (NTVDEV, 2, PNAM(6:7))
C                                       Special POPS memory files
      ELSE IF ((TYPE.EQ.'ME') .AND. (IVER.EQ.0)) THEN
         PNAM = VERNAM(1:3) // 'MEM:ME100000;1'
         PNAM(10:10) = VERSYS
C                                       other devices (disk files)
      ELSE
C                                       Check input parameters.
         VERLIM = 36 * 36 * 36 - 1
         CATLIM = VERLIM
         VOLLIM = 35
         IF ((IVOL.LT.1) .OR. (IVOL.GT.VOLLIM)) GO TO 999
         IF ((NSEQ.LT.0) .OR. (NSEQ.GT.CATLIM)) GO TO 999
         IF ((IVER.LT.0) .OR. (IVER.GT.VERLIM)) GO TO 999
C                                       User private?
            UNAME = 0
            IF (NUNAME.LE.0) GO TO 45
               DO 40 UNAME = 1,NUNAME
                  IF (TYPE.EQ.UNAMES(UNAME)) GO TO 45
 40               CONTINUE
               UNAME = 0
C                                       Adjust for 1 relative input
 45         IVOL2 = IVOL - 1
            IF (UNAME.LE.0) IVOL2 = IVOL
            CALL ZEHEX (IVOL2, 4, JUNK)
            PNAM(4:4) = JUNK(4:4)
            PNAM(6:7) = TYPE
            IF (UNAME.LE.0) THEN
               PNAM(8:8) = VERDAT
            ELSE
               PNAM(8:8) = VERSYS
               END IF
            CALL ZEHEX (NSEQ, 4, JUNK)
            PNAM(9:11) = JUNK(2:4)
            CALL ZEHEX (IVER, 4, JUNK)
            PNAM(12:14) = JUNK(2:4)
C                                       User private additions
            IF ((UNAME.LE.0) .AND. (UCTSIZ.GT.0)) THEN
               CALL ZEHEX (NLUSER, 4, JUNK)
               PNAM(15:) = '.' // JUNK(2:4) // ';1'
               END IF
         END IF
C                                       No error
      IERR = 0
C
 999  RETURN
      END

      PROGRAM GRSORT
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C     Program to sort a gripe file. GETGRI checks format, sequencing,
C     etc. GRSORT suppresses identical redundant copies of gripes.
C     Optionally, it also suppresses non-identical copies.
C     DCW, 01Oct84
C-----------------------------------------------------------------------
      IMPLICIT    NONE
      INTEGER     MGRIPE, LGRIPE
      PARAMETER   (MGRIPE=500, LGRIPE=5000)
      INTEGER     NGRIPE, L5, L6, LIN, LOUT, K, J, IGRIPE,
     *            JGRIPS(MGRIPE), NOUT, ILAST
      INTEGER     N10
      LOGICAL     LCRUSH
      CHARACTER   GRIPES(MGRIPE)*(LGRIPE), GRIPE*(LGRIPE), NEWLIN*3,
     *            INFILE*30, OUTFIL*30, GRARGS(9)*(LGRIPE)
      DATA        LIN, LOUT, L5, L6, N10 /1, 2, 5, 6, 10/
      DATA        NEWLIN /'|||'/
C-----------------------------------------------------------------------
C                                       initialize:
      NGRIPE = 0
 10   CONTINUE
         WRITE (L6, 1010) 'INFILE'
         READ (L5, 1012, ERR=10) INFILE
         IF (INFILE.EQ.' ') GO TO 15
            CALL PADTEX (L6, INFILE)
            OPEN (UNIT=LIN, FILE=INFILE, STATUS='OLD', ERR=10)
            GO TO 20
 15      CONTINUE
            OPEN (UNIT=LIN, FILE='GRINFIL', STATUS='OLD', ERR=10)
 20   CONTINUE
         WRITE (L6, 1010 ) 'OUTFIL'
         READ (L5, 1012, ERR=20) OUTFIL
         IF (OUTFIL.EQ.' ') GO TO 25
            CALL PADTEX (L6, OUTFIL)
            OPEN (UNIT=LOUT, FILE=OUTFIL, STATUS='NEW',
     *            CARRIAGECONTROL='LIST', ERR=20)
            GO TO 30
 25      CONTINUE
            OPEN (UNIT=LOUT, FILE='GROUTFIL', STATUS='NEW',
     *            CARRIAGECONTROL='LIST', ERR=20)
 30   CONTINUE
         WRITE (L6, 1030)
         READ (L5, 1035, ERR=30) LCRUSH
C                                       read and sort:
 50   CONTINUE
         CALL GETGRI (L6, LIN, NEWLIN, IGRIPE, GRIPE, GRARGS)
         IF (GRIPE.EQ.' ') GO TO 900
         IF (NGRIPE.GT.0) GO TO 60
C                                       insert the first gripe:
            J = 1
            GO TO 90
 60      CONTINUE
         IF (IGRIPE.LT.JGRIPS(NGRIPE)) GO TO 70
C                                       new gripe goes at end:
            J = NGRIPE + 1
            GO TO 90
 70      CONTINUE
C                                       else, find interpolation spot:
         J = NGRIPE + 1
 80      CONTINUE
            J = J - 1
            IF (J.LE.0) STOP 'GRSORT: J.LE.0 !!'
            GRIPES(J+1) = GRIPES(J)
            JGRIPS(J+1) = JGRIPS(J)
            IF (J.LE.1) GO TO 90
            IF (IGRIPE.LT.JGRIPS(J-1)) GO TO 80
C                                       store the gripe:
 90      CONTINUE
         GRIPES(J) = GRIPE
         JGRIPS(J) = IGRIPE
         NGRIPE = NGRIPE + 1
         IF (NGRIPE.GE.MGRIPE) STOP 'GRSORT: NGRIPE.GE.MGRIPE!'
         IF (MOD (NGRIPE, N10).EQ.1) WRITE (L6, 1090) NGRIPE, IGRIPE, J
         GO TO 50
C                                       write out the sorted gripes:
 900  CONTINUE
      IF (MOD (NGRIPE, N10).NE.1) WRITE (L6, 1090) NGRIPE, IGRIPE, J
      CLOSE (UNIT=LIN)
      WRITE (L6, 1900) NGRIPE
      NOUT = 0
      WRITE (LOUT, 1903)
      DO 930 J = 1, NGRIPE
         IF (J.EQ.1) GO TO 920
         IF (JGRIPS(J).NE.JGRIPS(J-1)) GO TO 920
            IF (.NOT.LCRUSH.AND.(GRIPES(J).NE.GRIPES(J-1))) GO TO 910
               WRITE (L6, 1907) JGRIPS(J)
               GO TO 930
 910        CONTINUE
               WRITE (L6, 1910) JGRIPS(J)
 920     CONTINUE
         CALL WRIGRI (L6, LOUT, NEWLIN, GRIPES(J))
         NOUT = NOUT + 1
         ILAST = JGRIPS(J)
 930     CONTINUE
      WRITE (LOUT, 1930)
      CLOSE (UNIT=LOUT)
      WRITE (L6, 1935) NOUT, JGRIPS(1), ILAST
C-----------------------------------------------------------------------
 1010 FORMAT (' GRSORT: enter name for file ', A6, ': ', $)
 1012 FORMAT (A30)
 1030 FORMAT (' GRSORT: Be careful! This option can destroy data:', /,
     *        '         suppress ALL redundant gripes? enter T or F:',
     *                                                               $)
 1035 FORMAT (L1)
 1090 FORMAT (' GRSORT: NGRIPE=', I5, ', IGRIPE=', I5, ', J=', I5)
 1900 FORMAT (' GRSORT:', I5, ' gripes read.')
 1903 FORMAT ('\input aipsgrip:gripemac5.tex', /,
     *        '\def\finalrun{F}', /)
 1907 FORMAT (' GRSORT: duplicate copy of gripe', I5, ' suppressed.')
 1910 FORMAT (' GRSORT: another version of gripe', I5, ' copied.')
 1930 FORMAT ('\end')
 1935 FORMAT (' GRSORT:', I5, ' gripes written. first=', I5,
     *                                                   ', last=', I5)
      END

      PROGRAM CCMOD
C-----------------------------------------------------------------------
C! Adds components to a CC table to model a Gaussian or disk.
C# Modeling EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2020-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CCMOD inserts a group of clean components into an existing CC
C   extension file to model a source as an elliptical uniformly bright
C   disk or Gaussian.
C   VERSION FOR CC TABLES FILES
C   Inputs:
C       INNAME(3)   R     Image name (name)
C       INCLASS(2)  R     Image name (class)
C       INSEQ       R     Image name (seq #)
C       INDISK      R     Input disk unit #
C       INVER       I     CC file ver. #
C       OPCODE      C*4   Model type; 'DISK' = '    ', or 'GAUS'
C     'DISG' = Gaussian * disk
C       FLUX        R     Source flux
C                         (map units*square pixel)
C       BMAJ        R     Source major axis (pixels)
C       BMIN        R     Source minor axis (pixels)
C       BPA         R     Source position angle of major axis
C       GWIDTH      R(*)  Bmaj, Bmin, BPA of Gaussian in 'DISG'
C       MAPXY       R     Source center position (pixels)
C       BITER       R     If >0 start replacing components after
C                         this component
C-----------------------------------------------------------------------
      CHARACTER NAMEIN*12, CLASIN*6, MTYPE*2, STAT*4, PNAM*6,
     *   TYPNAM(5)*4, TYPE*4
      INTEGER   CATBLK(256), NPARMS, PORK(768), IRET, IERR, VER, CATNO,
     *   IROUND, IDISK, LUN, SEQIN, NREC, X1, X2, Y1, Y2, IX, IY, ITYP,
     *   NEW, NEXT, NCOMP
      REAL      A, B, C, S, CO, DX, DY, RFAC(3), XM, BRIGHT, XS, YS,
     *   C4(256), PIG(512), SFACT, SUM, RADIUS, ADD, GMAJ, GMIN, GPA,
     *   AG, BG, CG
      LOGICAL   RQUICK, F, T
      HOLLERITH XNAMEI(3), XCLASI(2), XTYPE(1)
      REAL      SEQ, DISKIN, XVER, FLUX, BMAJ, BMIN, BPA, GWIDTH(3,4),
     *   MAPX, MAPY, MAPZ(5), CLSTRT
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INTEGER   CCKOLS(MAXCCC), CCNUMV(MAXCCC), CCRNO, CCNCOL, CCTYPE,
     *   CCBUFF(512)
      REAL      XX, YY, ZZ, FLX, PARMS(3)
      COMMON /INPARM/ XNAMEI, XCLASI, SEQ, DISKIN, XVER, XTYPE, FLUX,
     *   BMAJ, BMIN, BPA, GWIDTH, MAPX, MAPY, MAPZ, CLSTRT
      EQUIVALENCE (PIG, PORK)
      EQUIVALENCE (C4, CATBLK)
      DATA NPARMS, PNAM /33, 'CCMOD '/
      DATA F, T /.FALSE.,.TRUE./
      DATA TYPNAM /'DISK','GAUS','DISG', 'POIN', '    '/
      DATA RFAC /0.5, 1.6, 0.5/
C-----------------------------------------------------------------------
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NEW = 0
      CALL GTPARM (PNAM, NPARMS, RQUICK, XNAMEI, PORK, IERR)
      IF (IERR.EQ.0) GO TO 10
         IRET = 1
         RQUICK = F
         IF (IERR.EQ.1) GO TO 900
         WRITE (MSGTXT,1000)
         GO TO 990
 10   IRET = 0
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLASI, CLASIN)
      CALL H2CHR (4, 1, XTYPE, TYPE)
      IF (RQUICK) CALL RELPOP (IRET, PORK, IERR)
      SEQIN = IROUND (SEQ)
      IDISK = IROUND (DISKIN)
      VER = IROUND (XVER)
      DO 40 ITYP = 1,5
         IF (TYPE.EQ.TYPNAM(ITYP)) GO TO 50
 40      CONTINUE
 50   IF (ITYP.GT.4) ITYP = 1
      NEXT = IROUND (CLSTRT)
C                                       Locate map in directory.
      CATNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', IDISK, CATNO, NAMEIN, CLASIN, SEQIN, MTYPE,
     *   NLUSER, STAT, PORK, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'REQUESTED MAP NOT FOUND IN CATALOG DIRECTORY'
         GO TO 990
         END IF
      WRITE (MSGTXT,1020) NAMEIN, CLASIN, SEQIN, IDISK, CATNO
      CALL MSGWRT (3)
C                                       Read catalog block, get # comps
      CALL CATIO ('READ', IDISK, CATNO, CATBLK, 'WRIT', PORK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1005) IERR
         GO TO 990
         END IF
C                            Calculate center positions
      XS = C4(KRCRP)
      YS = C4(KRCRP+1)
C                                       Open clean comp. file
      NREC = 1000
      LUN = 27
C                                       default 0 => high current
      IF (VER.EQ.0) CALL FNDEXT ('CC', CATBLK, VER)
      VER = MAX (0, VER)
      CCNCOL = 3
      CALL CCMINI ('WRIT', CCBUFF, IDISK, CATNO, VER, CATBLK, LUN,
     *   CCRNO, CCKOLS, CCNUMV, CCNCOL, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1006) IERR
         GO TO 980
         END IF
      NCOMP = CCBUFF(5)
      IF ((NEXT.GT.NCOMP) .OR. (NEXT.EQ.0)) NEXT = NCOMP
      IF (NEXT.LT.0) NEXT = 0
      CCTYPE = 0
      PARMS(1) = 0.0
      PARMS(2) = 0.0
      PARMS(3) = 0.0
      ZZ = 0.0
C                                       compute model scaling
C                                       calculate some elliptical nos.
      IF (ITYP.NE.4) THEN
         BMAJ = BMAJ * RFAC(ITYP)
         BMIN = BMIN * RFAC(ITYP)
         S    = SIN (BPA*DG2RAD)
         CO   = COS (BPA*DG2RAD)
         A = (CO/BMAJ)**2 + (S/BMIN)**2
         B = (S/BMAJ)**2 + (CO/BMIN)**2
         C = 2. * CO * S * ((1./BMIN)**2 - (1./BMAJ)**2)
C                                       DISG
         IF (ITYP.EQ.3) THEN
            GMAJ = GWIDTH(1,1) * RFAC(2)
            GMIN = GWIDTH(2,1) * RFAC(2)
            GPA = GWIDTH(3,1)
            S    = SIN (GPA*DG2RAD)
            CO   = COS (GPA*DG2RAD)
            AG = (CO/GMAJ)**2 + (S/GMIN)**2
            BG = (S/GMAJ)**2 + (CO/GMIN)**2
            CG = 2. * CO * S * ((1./GMIN)**2 - (1./GMAJ)**2)
            END IF
C                                       maximum extent in Y
         DY = SQRT ((S*BMIN)**2 + (CO*BMAJ)**2)
         Y1 = 0.5 + MAPY - DY
         Y2 = MAPY + DY + 0.5
         SUM = 0.0
C                                       loop over all points within elli
         DO 100 IY = Y1,Y2
            DY = IY - MAPY
            DX = A + (C*C - A*B) * DY**2
            IF (DX.GE.0.0) THEN
               XM = -C * DY/A
               DX = SQRT(DX) / A
               X1 = 0.5 + XM + MAPX - DX
               X2 = XM + MAPX + DX + 0.5
               DO 90 IX = X1,X2
                  XX = (IX-XS) * C4(KRCIC)
                  YY = (IY-YS) * C4(KRCIC+1)
                  DX = IX - MAPX
                  RADIUS = A * DY ** 2 + B * DX ** 2 + C * DY * DX
                  ADD = SFACT (ITYP, RADIUS)
                  IF (ITYP.EQ.3) THEN
                     RADIUS = AG * DY ** 2 + BG * DX ** 2 + CG * DY * DX
                     ADD = ADD * SFACT (2, RADIUS)
                     END IF
                  SUM = SUM + ADD
 90               CONTINUE
               END IF
 100        CONTINUE
C                                       loop over all points within elli
         BRIGHT = FLUX / SUM
         WRITE (MSGTXT,1100) SUM, FLUX
         CALL MSGWRT (4)
         SUM = 0.0
         DO 300 IY = Y1,Y2
            DY = IY - MAPY
            DX = A + (C*C - A*B) * DY**2
            IF (DX.GE.0.0) THEN
               XM = -C * DY/A
               DX = SQRT(DX) / A
               X1 = 0.5 + XM + MAPX - DX
               X2 = XM + MAPX + DX + 0.5
               DO 200 IX = X1,X2
                  XX = (IX-XS) * C4(KRCIC)
                  YY = (IY-YS) * C4(KRCIC+1)
                  DX = IX - MAPX
                  RADIUS = A * DY ** 2 + B * DX ** 2 + C * DY * DX
                  ADD = BRIGHT * SFACT (ITYP, RADIUS)
                  IF (ITYP.EQ.3) THEN
                     RADIUS = AG * DY ** 2 + BG * DX ** 2 + CG * DY * DX
                     ADD = ADD * SFACT (2, RADIUS)
                     END IF
                  IF (ADD.NE.0.0) THEN
                     FLX = ADD
                     SUM = SUM + ADD
                     NEXT = NEXT + 1
                     NEW = NEW + 1
                     CCRNO = NEXT
                     CALL TABCCM ('WRIT', CCBUFF, CCRNO, CCKOLS, CCNUMV,
     *                  CCNCOL, XX, YY, ZZ, FLX, CCTYPE, PARMS, IERR)
                     IF (IERR.NE.0) GO TO 975
                     END IF
 200              CONTINUE
               END IF
 300        CONTINUE
C                                       Point source
      ELSE
         FLX = FLUX
         XX = (MAPX-XS) * C4(KRCIC)
         YY = (MAPY-YS) * C4(KRCIC+1)
         NEXT = NEXT + 1
         NEW = NEW + 1
         SUM = SUM + FLUX
         CCRNO = NEXT
         CALL TABCCM ('WRIT', CCBUFF, CCRNO, CCKOLS, CCNUMV, CCNCOL, XX,
     *      YY, ZZ, FLX, CCTYPE, PARMS, IERR)
         IF (IERR.NE.0) GO TO 975
         END IF
C                                       Close it up
      CALL TABCCM ('CLOS', CCBUFF, CCRNO, CCKOLS, CCNUMV, CCNCOL, XX,
     *   YY, ZZ, FLX, CCTYPE, PARMS, IERR)
      IF (IERR.NE.0) GO TO 975
      CATBLK(KINIT) = NEXT
      WRITE (MSGTXT,1200) NEW, SUM
      CALL MSGWRT (4)
      CALL CATIO ('UPDT', IDISK, CATNO, CATBLK, 'CLWR', PORK, IERR)
      GO TO 995
C                                       error messages
 900  WRITE (MSGTXT,1001)
      CALL MSGWRT (1)
      GO TO 999
C
 975  WRITE (MSGTXT,1008) IERR
 980  CALL MSGWRT (8)
      CALL CATIO ('UPDT', IDISK, CATNO, CATBLK, 'CLWR', PORK, IERR)
      GO TO 995
C
 990  CALL MSGWRT (8)
C                                   Close files and go to bed.
 995  CALL DIETSK (IRET, RQUICK, PORK)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('DISK PROBLEMS, GTPARM')
 1001 FORMAT ('CAN''T FIND INITIATOR, GTPARM')
 1005 FORMAT ('CATIO ERROR NO',I5)
 1006 FORMAT ('CAN''T OPEN CCFILE,  ERRNO',I5)
 1008 FORMAT ('ERROR NO',I5,' IN WRITING CCFILE WITH TABIO')
 1020 FORMAT ('Found ',A12,A6,' Seq',I4,' Disk:',I3,' in slot no',I5)
 1100 FORMAT ('Model sum',1PE12.4,' scaled to produce FLUX',1PE12.4)
 1200 FORMAT ('Added ',I6,' comps to file: flux=',1PE12.3)
      END
      REAL FUNCTION SFACT (ITYPE, R)
C-----------------------------------------------------------------------
C   Determine the intensity of a point component at a given normalized
C   distance from source center so that the sum of the point components
C   is 1.0; this for various model types.
C   Inputs:
C      ITYPE    I      Model type: 1 => disk; 2 => gaussian
C      R        R      Normalized radius.  For disks this
C                      is the radius; for gauss 1.6 * FWHP dize
C-----------------------------------------------------------------------
      INTEGER   ITYPE
      REAL      R, C1, C2
C                              (3.2**2) * Ln (2.0), Ln (2.0)
      DATA C1/7.097827 /, C2 /.6931472  /
C-----------------------------------------------------------------------
      IF (ITYPE.NE.2) THEN
         SFACT = 1.0
         IF (R.GT.1.0) SFACT = 0.0
      ELSE
         SFACT = C2 * EXP (-C1 * R)
         END IF
C
 999  RETURN
      END

      SUBROUTINE UVPGET (IERR)
C-----------------------------------------------------------------------
C! determines pointers to UV data from the header
C# UV-util Header
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999, 2004-2005, 2015-2016, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVPGET determines pointers and other information from a UV CATBLK.
C   The address relative to the start of a vis record for the real part
C   for a given spectral channel (CHAN) and stokes parameter (ICOR)
C   is given by :
C      NRPARM+(CHAN-1)*INCF+IABS(ICOR-ICOR0)*INCS+(IF-1)*INCIF
C   Single dish data, i.e. randomly sampled data in the image plane, is
C   also recognized and ILOCU and ILOCV point to the longitude like and
C   latitude like random parameters.  Also a "BEAM" random parameter
C   may be substitued for the "BASELINE" random parameter.  The data
C   type present may be determined from the common variable TYPUVD.
C      The types of single dish data are recognized:
C   TYPUVD=1 => unprojected RA and Dec and
C   TYPUVD=2 => projected RA and Dec (obsolete was for SELSD/GRIDR)
C   TYPUVD=3 => unprojected relative Az-El to center Ra-Dec
C      The types of UV data are
C   TYPUVD=0 => -SIN projected u,v,w's
C   TYPUVD=-1 => -NCP projected u,v's (w === 0) East-West arrays
C   Inputs: From common /MAPHDR/
C      CATBLK   I(256)   Catalog block
C      CATH     H(256)   same as CATBLK
C      CATR     R(256)   same as CATBLK
C      CATD     D(128)   same as CATBLK
C   Output: In common /UVHDR/
C      SOURCE   C*8      Source name.
C      ILOCU    I        Offset from beginning of vis record of U
C                        or longitude for single dish format data.
C      ILOCV    I        Offset from beginning of vis record of V
C                        or longitude for single dish format data.
C      ILOCW    I        Offset from beginning of vis record of W.
C      ILOCT    I                      "                        Time
C      ILOCB    I                      "                      Baseline
C                                                             (or beam)
C      ILOCSU   I                      "                    Source id.
C      ILOCFQ   I                      "                    Freq id.
C      ILOCIT   I                      "                Integration time
C      ILOCID   I                      "                Correlation id.
C      JLOCC    I        0-rel. order in data of complex values
C      JLOCS    I        Order in data of Stokes' parameters.
C      JLOCF    I        Order in data of Frequency.
C      JLOCR    I        Order in data of RA
C      JLOCD    I        Order in data of dec.
C      JLOCIF   I        Order in data of IF.
C      INCS     I        Increment in data for stokes (see above)
C      INCF     I        Increment in data for freq. (see above)
C      INCIF    I        Increment in data for IF.
C      ICOR0    I        Stokes value of first value.
C      NRPARM   I        Number of random parameters
C      LREC     I        Length in values of a vis record.
C      NVIS     I        Number of visibilities
C      FREQ     D        Frequency (Hz)
C      RA       D        Right ascension (1950) deg.
C      DEC      D        Declination (1950) deg.
C      NCOR     I        Number of correlators (Stokes' parm.)
C      ISORT    C*2      Sort order 1st 2 char meaningful.
C      TYPUVD   I        UV data type, 0=interferometer,
C                           1=single dish unprojected,
C                           2=single dish projected RA and Dec.
C      IERR     I        Return error code: 0=>OK,
C                           1, 2, 5, 7 : not all normal rand parms
C                           2, 3, 6, 7 : not all normal axes
C                           4, 5, 6, 7 : wrong bytes/value
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      CHARACTER RTYP(12)*8, ICOOR(6)*8, PCOOR(2)*5, BEM*8, CTEST*5,
     *   CTEMP*8, XCOOR(2,3)*5
      INTEGER   ILOC(12), JLOC(6), I, J, NPRM, INDEX, NAXIS, II, NCOMP,
     *   LIMIT
      LOGICAL   EQUAL, ISSD
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (ILOC(1), ILOCU)
      EQUIVALENCE (JLOC(1), JLOCC)
      DATA RTYP /'UU-L   ', 'VV-L    ', 'WW-L    ',
     *   'TIME1   ', 'BASELINE', 'SOURCE  ','FREQSEL ','INTTIM  ',
     *   'CORR-ID ', 'SUBARRAY', 'ANTENNA1', 'ANTENNA2'/
C                                       axis types - 1st set for UV
      DATA ICOOR /'COMPLEX ', 'STOKES ', 'FREQ ', 'RA ', 'DEC ', 'IF '/
C                                       any for single dish
      DATA XCOOR /'RA','DEC','GLON','GLAT','ELON','ELAT'/
C                                       single-dish relative az,el
      DATA PCOOR /'AZ---','EL---'/
      DATA BEM /'BEAM    '/
C-----------------------------------------------------------------------
      IERR = 0
      NVIS = CATBLK(KIGCN)
      CALL H2CHR (8, 1, CATH(KHOBJ), SOURCE)
C                                       ISSD = true for single dish data
      ISSD = .FALSE.
      TYPUVD = 0
C                                       Determine rand parm. locations.
      CALL FILL (12, -1, ILOC)
      NRPARM = CATBLK(KIPCN)
      NPRM = MIN (NRPARM, KIPTPN)
      DO 30 I = 1,NPRM
         INDEX = KHPTP + 2 * (I-1)
         CALL H2CHR (8, 1, CATH(INDEX), CTEMP)
         DO 29 J = 1,12
            NCOMP = 8
            IF (J.LE.3) NCOMP = 4
            EQUAL = RTYP(J)(1:NCOMP).EQ.CTEMP(1:NCOMP)
            IF (EQUAL) THEN
               ILOC(J) = I - 1
               IF ((J.LE.2) .AND. (CTEMP(5:8).EQ.'-NCP')) TYPUVD = -1
               END IF
C                                       For SD, sub. BEAM for
C                                       BASELINE.
            IF ((J.EQ.5) .AND. (ILOC(J).LT.0)) THEN
               EQUAL = BEM.EQ.CTEMP
               IF (EQUAL) ILOC(J) = I - 1
               END IF
C                                       Single dish data trap, projected
            IF ((J.LE.2) .AND. (.NOT.EQUAL)) THEN
               CTEST = CTEMP(:5)
C                                       Single dish un projected.
               EQUAL = XCOOR(J,1)(1:4).EQ.CTEST
               IF (.NOT.EQUAL) EQUAL = XCOOR(J,2).EQ.CTEST
               IF (.NOT.EQUAL) EQUAL = XCOOR(J,3).EQ.CTEST
               IF (EQUAL) THEN
                  ILOC(J) = I - 1
                  ISSD = .TRUE.
                  TYPUVD = 1
C                                       relative az-el
               ELSE
                  EQUAL = CTEST.EQ.PCOOR(J)
                  IF (EQUAL) THEN
                     ILOC(J) = I - 1
                     ISSD = .TRUE.
                     TYPUVD = 3
                     END IF
                  END IF
               END IF
 29         CONTINUE
 30      CONTINUE
C                                       For single dish data set ILOCW
      IF (ISSD) ILOC(3) = 0
C                                       All there?
C                                       Check required types
      LIMIT = 4
      IF (ISSD) LIMIT = 4
      DO 35 I = 1,LIMIT
         IF (ILOC(I).LE.-1) THEN
            WRITE (MSGTXT,1030) ILOC
            CALL MSGWRT (6)
            IERR = IERR + 1
            GO TO 40
            END IF
 35      CONTINUE
      IF (.NOT.ISSD) THEN
         IF ((ILOC(5).LT.0) .AND. ((ILOC(10).LT.0) .OR. (ILOC(11).LT.0)
     *      .OR. (ILOC(12).LT.0))) THEN
            WRITE (MSGTXT,1030) ILOC
            CALL MSGWRT (6)
            IERR = IERR + 1
            END IF
         END IF
C                                       Determine order of data.
 40   CALL FILL (6, -1, JLOC)
      NAXIS = CATBLK(KIDIM)
      DO 50 I = 1,NAXIS
         INDEX = KHCTP + 2 * (I-1)
         CALL H2CHR (8, 1, CATH(INDEX), CTEMP)
         DO 45 J = 1,6
            EQUAL = ICOOR(J).EQ.CTEMP
            IF ((.NOT.EQUAL) .AND. (J.GE.4) .AND. (J.LE.5)) THEN
C                                       really should not br RA---
               EQUAL = XCOOR(J-3,1).EQ.CTEMP(:5)
C                                       single-dish forgiving
               IF (ISSD) THEN
                  IF (.NOT.EQUAL) EQUAL = XCOOR(J-3,2).EQ.CTEMP(:5)
                  IF (.NOT.EQUAL) EQUAL = XCOOR(J-3,3).EQ.CTEMP(:5)
                  END IF
               END IF
            IF (EQUAL) THEN
               JLOC(J) = I - 1
               GO TO 50
               END IF
 45         CONTINUE
 50      CONTINUE
C                                       All there?
C                                       Don't check IF.
      DO 55 I = 1,5
         IF (JLOC(I).GT.-1) GO TO 55
            WRITE (MSGTXT,1050) ICOOR(I)
            CALL MSGWRT (6)
            IERR = IERR + 2
            GO TO 60
 55      CONTINUE
C                                       Logical record length
 60   LREC = 1
      DO 65 I = 1,NAXIS
         LREC = LREC * CATBLK(KINAX+I-1)
 65      CONTINUE
      LREC = LREC + NRPARM
C                                       Other parameters
      NCOR = CATBLK(KINAX+JLOCS)
      FREQ = CATD(KDCRV+JLOCF)
      IF (FREQ.LE.0.0D0) THEN
         FREQ = 1.0D0
         MSGTXT = 'CHANGED FREQ = 0 TO 1 HZ TO AVOID BIGGER HURTS'
         CALL MSGWRT (7)
         END IF
      RA = CATD(KDCRV+JLOCR)
      DEC = CATD(KDCRV+JLOCD)
      DEQUIN = CATR(KREPO)
      CALL H2CHR (2, 1, CATH(KITYP), ISORT)
      IF (CATR(KRCIC+JLOCS).EQ.0.0) CATR(KRCIC+JLOCS) = SIGN (1.0D0,
     *   CATD(KDCRV+JLOCS))
      ICOR0 = CATD(KDCRV+JLOCS) + (1.0-CATR(KRCRP+JLOCS))*
     *   CATR(KRCIC+JLOCS)
C                                        Determine increments in data.
      INCS = 1
      IF (JLOCS.LE.0) GO TO 75
         DO 70 II = 1,JLOCS
            INCS = INCS * CATBLK(KINAX+II-1)
 70         CONTINUE
 75   INCF = 1
      IF (JLOCF.LE.0) GO TO 85
         DO 80 II = 1,JLOCF
            INCF = INCF * CATBLK(KINAX+II-1)
 80         CONTINUE
 85   INCIF = 0
      IF (JLOCIF.LE.0) GO TO 999
         INCIF = 1
         DO 90 II = 1,JLOCIF
            INCIF = INCIF * CATBLK(KINAX+II-1)
 90         CONTINUE
C                                       Trap 1 freq, multiple IF
         IF ((CATBLK(KINAX+JLOCF).LE.1) .AND. (INCIF.GT.0)) INCF = INCIF
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('UVPGET RANDOM PARMS MISSING:',12I3)
 1050 FORMAT ('UVPGET: Missing ',A8,' axis')
      END

      SUBROUTINE ZTQSP2 (DOALL, MSLEV, NPROC)
C-----------------------------------------------------------------------
C! display AIPS account or all processes running on the system
C# Z2 System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Displays information on the user's terminal regarding AIPS account
C   originated processes or all processes running on the system.
C   Inputs:
C      DOALL   R   > 0.0 => display all processes
C      MSLEV   I   Message level to use in calling MSGWRT.
C   VMS version.  This one doesn't use the info in NPROC to filter
C   down the process list.  If we ever revive the VMS port, it should.
C-----------------------------------------------------------------------
      REAL      DOALL
      INTEGER   MSLEV, NPROC
C
      INTEGER   I, IL, LISTI(28), PIDADR, JERR, AIPGRP, HOURS, MINS,
     *   JTRIM, STATE, STATUS, DIRIO, PRIORI, CPU, GROUP, MEMB, BUFIO,
     *   SYS$GETJPIW
      INTEGER*2 LIST2(56)
      REAL      RCPU, SECS
      CHARACTER UNAME*15, WCH*1, CSTATE(14)*5
      LOGICAL   DOIT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE '($JPIDEF)'
      INCLUDE '($SSDEF)'
      EQUIVALENCE (LISTI, LIST2)
      DATA CSTATE /'CPW  ', 'MWAIT', 'CEF  ', 'PFW  ', 'LEF  ',
     *   'LEFO ', 'HIB  ', 'HIBO ', 'SUSP ', 'SUSPO', 'FPW  ',
     *   'COM  ', 'COMO ', 'CUR  '/
C-----------------------------------------------------------------------
C                                       table entry lengths
      CALL FILL (28, 0, LISTI)
      LIST2(1) = 4
      LIST2(7) = 4
      LIST2(13) = 4
      LIST2(19) = 4
      LIST2(25) = 4
      LIST2(31) = 4
      LIST2(37) = 4
      LIST2(43) = 15
      LIST2(49) = 4
      LIST2(55) = 4
C                                       Operation codes in table
      LIST2(2) = JPI$_STATE
      LIST2(8) = JPI$_STS
      LIST2(14) = JPI$_DIRIO
      LIST2(20) = JPI$_PRI
      LIST2(26) = JPI$_CPUTIM
      LIST2(32) = JPI$_GRP
      LIST2(38) = JPI$_MEM
      LIST2(44) = JPI$_PRCNAM
      LIST2(50) = JPI$_BUFIO
      LIST2(56) = 0
C                                       Addresses in table
      LISTI(2) = %LOC (STATE)
      LISTI(5) = %LOC (STATUS)
      LISTI(8) = %LOC (DIRIO)
      LISTI(11) = %LOC (PRIORI)
      LISTI(14) = %LOC (CPU)
      LISTI(17) = %LOC (GROUP)
      LISTI(20) = %LOC (MEMB)
      LISTI(23) = %LOC (UNAME)
      LISTI(26) = %LOC (BUFIO)
C                                       Header
      WRITE (MSGTXT,1000)
      CALL MSGWRT (MSLEV)
C                                       Find out what my group is.
      PIDADR = 0
      JERR = SYS$GETJPIW ( , PIDADR, , LISTI, , , )
      AIPGRP = GROUP
C                                       Loop for all processes
C                                       PIDADR -1 implies this
      PIDADR = -1
10    JERR = SYS$GETJPIW ( , PIDADR, , LISTI, , , )
C                                       there are more processes
      IF (JERR.NE.SS$_NOMOREPROC) THEN
C                                       error
         IF (JERR.NE.SS$_NORMAL) THEN
            IF (JERR.NE.SS$_NOPRIV) THEN
               WRITE (MSGTXT,1010) JERR
               CALL MSGWRT (MSLEV)
               END IF
C                                       list one?
         ELSE IF ((GROUP.EQ.AIPGRP) .OR. (DOALL.GT.0.0)) THEN
            IL = JTRIM (UNAME)
            DOIT = .TRUE.
C                                       Is it really an AIPS name?
            IF (DOALL.LE.0.0) THEN
               DOIT = IL.LE.6
               DO 20 I = 1,IL
                  WCH = UNAME(I:I)
                  IF ((WCH.LT.'0') .OR. (WCH.GT.'Z')) DOIT = .FALSE.
                  IF ((WCH.GT.'9') .AND. (WCH.LT.'A')) DOIT = .FALSE.
 20               CONTINUE
               WCH = UNAME(IL:IL)
C                                       I have a feeling this isn't
C                                       quite right...
               IF (NPROC.LT.10) THEN
                  CLAST = CHAR(ICHAR('0') + NPROC)
               ELSE
                  CLAST = CHAR(ICHAR('A') + NPROC - 10)
                  END IF
               CLAST =
               IF (WCH.GT.CLAST) DOIT = .FALSE.
               END IF
C                                       list it
            IF (DOIT) THEN
               RCPU = CPU / 360000.
               HOURS = RCPU
               RCPU = (RCPU - HOURS) * 60.
               MINS = RCPU
               SECS = (RCPU - MINS) * 60.
               DIRIO = DIRIO + BUFIO
               WRITE (MSGTXT,1020) UNAME(1:13), HOURS, MINS, SECS,
     *            CSTATE(STATE), PRIORI, DIRIO
               IF (MSGTXT(21:21).EQ.' ') MSGTXT(21:21) = '0'
               CALL MSGWRT (MSLEV)
               END IF
            END IF
         GO TO 10
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('  Name          CPU-time    State  Priority  I/O count')
 1010 FORMAT ('ZTQSP2: GETJPI RETURNS ERROR CODE',I10)
 1020 FORMAT (A13,1X,I2.2,':',I2.2,':',F5.2,4X,A5,I6,3X,I10)
      END

LOCAL INCLUDE 'WSLOD.INC'
C                                                          Include DWIN
      INTEGER   MAXCH
      PARAMETER (MAXCH = 128)
C
      DOUBLE PRECISION BSC, BZE, RA1, DEC1, RA0, DEC0, BASLM(14),
     *          BFREQ(MAXCH)
      HOLLERITH XNAMEI(3), XNAMEO(3), XCLAOU(2), XUVWTF
      CHARACTER NAMEIN*12, NAMOUT*12, CLAOUT*6
      REAL      TAPE, XFILES,
     *          DISO, XVSMAX, PSCAL(91,4,MAXCH), BASNO(91),
     *          XBBAND, XEBAND, XIBAND,
     *          BASLIN(91), SHA(91), DHA(91), BANDW, WVSMAX,
     *          DAYFR, PHIROT, NAMPAK(3), CLSPAK(2), STAT, XBAND
      REAL      BUFF1(4610),BUFF2(4610)
      CHARACTER*6 CLAOUT1, CLAOUT2
      CHARACTER*2 UVWTFN
      REAL      DONOTST
      INTEGER   NVIS
      INTEGER   NVISFL(2)
      LOGICAL   NDOEOF, ISBLNK, LCMPLX, LSTOKE, RQUICK, DOLIST
      INTEGER   LUN1, LUN2, IND1, IND2, DISOUT1, DISOUT2, CCNO1, CCNO2
      INTEGER   BUFF0(256), HW(3840), CW(1920)
      INTEGER   DOGBLK1(20), DOGBLK2(20)
      INTEGER   LREC, NFILES, DISOUT, TAPEIN, GROUP,
     *          ICEND, IBLANK(2), TABLES, IBPP, NPARMS, ITAB(20),
     *          JADR(4), NSTACT, STRTRC(91,4,MAXCH),
     *          IINT(91), LUNDS, DINDS,
     *          NDATP(91), POFF(91,4,MAXCH), NRINT,
     *          WDATE(6), CCNO, POLC,
     *          ICNO, SNO, WS, NRPOL, NSTOKES, IVOL, IVER, BBAND,
     *          EBAND, IBAND, FDVEC(50)
      COMMON /BUFRS / BUFF2, BUFF1, BUFF0, HW, CW
      COMMON /INPARM/ XNAMEI, XBBAND, XEBAND, XIBAND,
     *                TAPE, XFILES, XNAMEO,
     *                XCLAOU, DISO, XUVWTF, DONOTST, XVSMAX
      COMMON /SCRINF/ NVIS, NDOEOF, RQUICK, DOLIST,
     *                NFILES, DISOUT, TAPEIN,
     *                LREC, LUNDS, DINDS,
     *                BBAND, EBAND, IBAND, FDVEC
      COMMON /FITINF/ BSC, BZE, ISBLNK, LCMPLX, LSTOKE, ICEND,
     *                IBLANK, TABLES, IBPP, NPARMS, ITAB, JADR, NSTACT
      COMMON /SRTDAT/ RA0, DEC0, RA1, DEC1, BASLM,  PSCAL, BASNO,
     *                BASLIN, SHA, DHA, BFREQ, BANDW, WVSMAX, DAYFR,
     *                NDATP, POFF, PHIROT, STRTRC, IINT, NRINT, WDATE,
     *                CCNO, POLC, NRPOL, NSTOKES
      COMMON /FILES/  NAMPAK, CLSPAK, STAT, ICNO, SNO, WS, IVOL, IVER
      COMMON /FINFO/  LUN1, LUN2, IND1, IND2,
     *                DISOUT1, DISOUT2, CCNO1, CCNO2, NVISFL,
     *                DOGBLK1, DOGBLK2
      COMMON /CHACOM/ NAMEIN, NAMOUT, CLAOUT, CLAOUT1, CLAOUT2
LOCAL END
      PROGRAM WSLOD
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C----------------------------------------------------------------------
C   WSLOD copies a uv data base from a WSRT DR tape to a catalogued
C   disk file.  If the input name is set to 'INDEX' it will read
C   the entire input tape, and write out relevant information on
C   each file.
C  Inputs:
C  Adverb  Pgm. name         Comments.
C    NAMEIN    NAMEIN     NAMEIN name; if = 'INDEX' index the tape
C    BCHAN     BBAND      1st WSRT band number (0 => continuum)
C    ECHAN     EBAND      last WSRT band number
C    CHINC     IBAND      delta WSRT band number
C              sequence number of output file := channel number
C
C    INTAPE    TAPEIN     Input tape drive number
C    NFILES    NFILES     Label on tape to read in
C                         < 0 => quit when one full sour/vis set read
C    OUTNAME   NAMOUT     Output file name (default = NAMEIN)
C    OUTCLASS  CLAOUT     Output file class (default = 'UVDATA' if
C                                           donotst <> 3, else 'UVRDUN')
C    OUTDISK   DISOUT     Output disk volume
C    UVWTFN    UVWTFN     Reweight WSRT data to near uniform
C    DOALL     DONOTST    If 1 include the non standard WSRT baselines,
C                         if 2 save original IF pairs,
C                         if 3 write redundant and non-redundant data
C                              to different files. Note that the meaning
C                              of 'redundant' is slightly different from
C                              the meaning of 'standard'.
C
C
C
C  Programmer WaWa, Oct. 1982
C  Modified April 1984 by R.J.Hanisch to handle WSRT tape format 6.
C  Latest modifications to handle redundant baselines by:
C    J. M. van der Hulst; September 1985, Dwingeloo, the Netherlands.
C    Bert van Oortmarssen; Augustus 1987, Leiden, the Netherlands.
C         < DUMPAN corrected (to new AN-file format) >
C         < check for duplicate baselines corrected  >
C         < ignore IH-blocks 92..96 (dummy blocks)   > 27-04-88
C         < range of band numbers                    > 19-05-88
C  Mark Wieringa; Nov. 1988, Leiden, The Netherlands :
C  added system 52 format : integration times now calculated from HA-step.
C  WaWa again March 1989 to integrate charlottesville tapeio with
C  Leiden/Dwingeloo changes in format, and rationalize multiple channel
C  numbers.
C  WaWa   Feb. 1990, conform to new NRAO code revisions
C----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER IERR, IRET
      INTEGER   FTAB(160), INDEST
      INCLUDE 'WSLOD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:IDCH.INC'
      DATA PRGM /'WSLOD '/
C----------------------------------------------------------------------
C                                       Get input parameters
      CALL UVPARM (PRGM, IERR)
      IRET = 16
      IF (IERR.NE.0) GO TO 990
C                                       Read vis tape, copy to
C                                       catalogued file.
         CALL VISIN (IERR)
C                                       Need to destroy output file
         IF (IERR.GT.10) GO TO 950
C                                       Leave output alone
         IF (IERR.NE.0)  GO TO 990
C                                       Finished
         IRET = 0
         GO TO 990
  950  CONTINUE
C                                   Clear status, then destroy
      CALL FILEINFO(1)
      CALL PTBLK (1, 'WRIT')
      CALL CATIO ('READ', DISOUT, CCNO, CATBLK, 'CLWR', BUFF0, IERR)
      CALL MDESTR (DISOUT, CCNO, CATBLK, BUFF0, INDEST, IERR)
      IF (DONOTST.EQ.3.0) THEN
C                        Clear and destroy 2nd file
         CALL FILEINFO(2)
         CALL PTBLK (2, 'WRIT')
         CALL CATIO ('READ', DISOUT, CCNO, CATBLK, 'CLWR', BUFF0, IERR)
         CALL MDESTR (DISOUT, CCNO, CATBLK, BUFF0, INDEST, IERR)
      END IF
C
  990 CONTINUE
      IF (.NOT.DOLIST) THEN
         CALL FILEINFO(1)
C                        not necessary, but does not harm
         CALL PTBLK (1, 'WRIT')
         CALL UNSCR
      ENDIF
C
      CALL DIETSK (IRET, RQUICK, BUFF0)
C
      STOP
      END
C
C
C
      SUBROUTINE UVPARM (PRGM, JERR)
C----------------------------------------------------------------------
C   UVPARM reads input parameters for Task UVLOD.  See header comments
C   in PROGRAM UVLOD for more details.
C   Inputs: PRGM   C*6      Program name
C           IERR   I        Error code: 0 => ok, else quit
C   Common: /MAPHDR/ initial cat block header (heavily filled in if
C                    FITS is false)
C   Programmer: W. D. Cotton, Jan. 1981.
C----------------------------------------------------------------------
      CHARACTER*(*) PRGM
      INTEGER JERR
      LOGICAL   EQUAL
      INTEGER IRET, IERR
      INTEGER   NAXIS, NRAN, INC, IFIL, I, INDEX
      CHARACTER*8 IRAN(5), ICOOR(5)
      REAL   TEMP(2), EPS
      INCLUDE 'WSLOD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
C                               I*4 Buffer Size
      INTEGER  FDVEC3_4
      EQUIVALENCE (FDVEC3_4, FDVEC(3))
C
      DATA IRAN /'UU-L    ','VV-L    ','WW-L    ',
     *           'BASELINE','TIME1   '/
      DATA ICOOR /'COMPLEX ','STOKES  ','FREQ    ',
     *           'RA---NCP','DEC--NCP'/
      DATA NAXIS, NRAN /5, 5/
C----------------------------------------------------------------------
C                                       Initilize I/O
      CALL ZDCHIN (.TRUE.)
      CALL HIINIT (3)
      CALL VHDRIN
      JERR = 0
C                                       Get input parameters.
      NPARMS = 16
      CALL GTPARM (PRGM, NPARMS, RQUICK, XNAMEI, BUFF0, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT, 1000) IERR
         CALL MSGWRT (8)
         IRET = 8
         GO TO 20
 10   CALL FILL (256, 0, CATBLK)
      CALL FILL (50,  0, FDVEC)
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (12, 1, XNAMEO, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (2, 1, XUVWTF, UVWTFN)
      DOLIST = NAMEIN(1:5) .EQ. 'INDEX'
      EPS = 0.1
C                                       Get TAPEIN
      TAPEIN = TAPE + EPS
C                                       Get NFILES
C            Account for header and trailer labels
      NFILES = 3.0 * XFILES - 2.0 + EPS
      IF (DOLIST) THEN
         MSGTXT = 'I will try to list an entire WSRT tape'
         CALL MSGWRT(2)
      ENDIF
C                                       Get DISOUT( ), DISOUT is used
C                                       only when DONOTST=3
      DISOUT  = DISO + EPS
      DISOUT1 = DISOUT
      DISOUT2 = DISOUT
C                                       Get band info.
      BBAND = XBBAND + EPS
      EBAND = XEBAND + EPS
      IBAND = XIBAND + EPS
C                                       rationalize
      BBAND = MAX (BBAND, 0)
      IBAND = MAX (IBAND, 1)
      EBAND = MAX (EBAND, BBAND)
      EBAND = MIN (EBAND, BBAND + IBAND * (MAXCH-1))
C                                       Get max. no. visibilities.
C                                       Set user id in CATBLK
      CATBLK(KIIMU) = NLUSER
C                                       If RQUICK, restart AIPS
      IRET = 0
C                                       Test legality
      IF (NTAPED.EQ.1 .OR. TAPEIN.LT.1) TAPEIN = 1
      IF ((TAPEIN.GE.1) .AND. (TAPEIN.LE.NTAPED)) GO TO 15
         WRITE (MSGTXT, 1010) TAPEIN
         CALL MSGWRT (8)
         IRET = 8
         GO TO 20
 15   IF ((NPOPS.LE.NINTRN) .AND. (ISBTCH.NE.32000)) GO TO 20
         WRITE (MSGTXT, 1015)
         CALL MSGWRT (8)
         IRET = 8
 20   JERR = IRET
      IF (RQUICK) CALL RELPOP (IRET, BUFF0, IERR)
      IF (JERR.NE.0) GO TO 999
C                                       Open tape
      FDVEC(1)  = TAPEIN + 30
      FDVEC(2)  = 3840
      FDVEC3_4  = 7680
      FDVEC(5)  = TAPEIN
      FDVEC(31) = 0
C
      CALL TAPIO ('OPRD', FDVEC(1), HW, FDVEC(40), IERR)
      IF (IERR.LE.1) GO TO 25
         WRITE (MSGTXT, 1020) IERR
         CALL MSGWRT (8)
         JERR = 8
         GO TO 999
C                                       Skip to correct file.
 25   IF (NFILES.GT.0) THEN
           WRITE (MSGTXT, 1022) NFILES
           CALL MSGWRT(2)
           CALL ZTAPE ('ADVF', FDVEC(1), FDVEC(40), NFILES, IERR)
      ENDIF
      IFIL = 1-NFILES
      IF (NFILES.LE.0)
     *          CALL ZTAPE ('BAKF', FDVEC(1), FDVEC(40), IFIL, IERR)
      IF (IERR.EQ.0) GO TO 30
         WRITE (MSGTXT, 1025) IERR
         CALL MSGWRT (8)
         JERR = 8
         GO TO 999
 30   MSGSUP = 32000
C                                        enable level 6 & 7 messages.
         MSGSUP = 0
      IF (DOLIST) GO TO 999
C
C                                       Get CLAOUT in CATBLK
         IF (DONOTST.NE.3.0) THEN
C                                       Check if not 'UVNORD', 'UVRDUN'
            IF ((CLAOUT .EQ. 'UVNORD') .OR. (CLAOUT .EQ. 'UVRDUN'))
     *          THEN
               WRITE (MSGTXT, 1012) CLAOUT1, DONOTST
               CALL MSGWRT (6)
               CLAOUT1 = 'UVDATA'
               WRITE (MSGTXT, 1013) CLAOUT1
               CALL MSGWRT (6)
            ELSE IF (CLAOUT .EQ. ' ') THEN
               CLAOUT1 = 'UVDATA'
            ENDIF
            CALL CHR2H (6, CLAOUT1, KHIMCO, CATH(KHIMC))
         ELSE
            CLAOUT1 = 'UVRDUN'
            CLAOUT2 = 'UVNORD'
            CALL CHR2H (6, CLAOUT1, KHIMCO, CATH(KHIMC))
C                                       CAT4(K4IMC) has to be filled
C                                       with CLAOUT2 after the first
C                                       file is created.
         END IF
         MSGSUP = 32000
C                                       Fill CATBLK.
C                                       Set units.
         CALL CHR2H (8, 'JY      ', 1, CATH(KHBUN))
C                                       Random para. types.
         DO 60 I = 1,NRAN
            INDEX = KHPTP + (I-1)*2
            CALL CHR2H (8, IRAN(I), 1, CATH(INDEX))
 60         CONTINUE
         CATBLK(KIPCN) = NRAN
C                                       Rotations.
         CALL RFILL (NAXIS, 0.0, CATR(KRCRT))
C                                       Increments.
         CALL RFILL (NAXIS, 0.0, CATR(KRCIC))
         CALL RFILL (NAXIS, 1.0, CATR(KRCRP))
         CATR(KRCIC)   = 1.0
         CATR(KRCIC+1) = 1.0
         CATD(KDCRV)   = 1.0D0
         CATD(KDCRV+1) = 1.0D0
C       IF THE NON STANDARD BASELINES ARE INCLUDED WE MUST
C       SET THE STOKES AXIS VALUES TO 'XX', 'YY', 'XY', 'YX'
         IF (DONOTST.GT.0.0) THEN
            CATR(KRCIC+1) = -1.0
            CATD(KDCRV+1) = -5.0D0
         END IF
C                                       Epoch.
         CATR(KREPO) = 1950.0
C                                       Axis types.
         DO 70 I = 1,NAXIS
            INDEX = KHCTP + (I-1)*2
            CALL CHR2H (8, ICOOR(I), 1, CATR(INDEX))
 70         CONTINUE
         CATBLK(KIDIM) = NAXIS
C                                       Axis dimensions.
         CATBLK(KINAX) = 3
         CATBLK(KINAX+1) = 4
         CATBLK(KINAX+2) = 1
         CATBLK(KINAX+3) = 1
         CATBLK(KINAX+4) = 1
C                                       Blank telescope,instrument,
C                                       observer.
         CALL CHR2H (8, 'WSRT    ', 1, CATH(KHTEL))
         CALL CHR2H (8, '        ', 1, CATH(KHINS))
         CALL CHR2H (8, '        ', 1, CATH(KHOBS))
c                                        enable level 6 & 7 messages.
         MSGSUP = 0
C                                       Set file type to 'UV'
         CALL CHR2H (2, 'UV', KHPTYO, CATH(KHPTY))
C
 999  RETURN
C----------------------------------------------------------------------
 1000 FORMAT ('UVPARM: ERROR',I3,' OBTAINING INPUT PARAMETERS ')
 1010 FORMAT ('UVPARM: INTAPE =',I7,' ILLEGAL')
 1012 FORMAT ('CLASSNAME: ',2A4,' NOT ALLOWED FOR DOALL = ',F3.1)
 1013 FORMAT ('CLASSNAME RENAMED TO: ',2A4)
 1015 FORMAT ('TAPE JOBS ARE NOT ALLOWED IN BATCH')
 1020 FORMAT ('ERROR',I7,' OPENING TAPE')
 1022 FORMAT (' About to skip ', I3, ' tape files, including labels')
 1025 FORMAT ('ERROR',I7,' POSITIONING TAPE')
      END
C
C
C
      SUBROUTINE VISIN (JERR)
C----------------------------------------------------------------------
C  VISIN call SRT2SC to read a Dwingeloo format UV tape into
C  a scratch file.  It then reads the information back, sorting
C  out polarizations and bands and writes it back into an
C  AIPS catalogued file.
C
C  Inputs (via COMMON /SRCINF/):
C  NAMEIN(2)        C*4  Source name
C  TAPEIN           I*2  Tape drive number
C  NFILES           I*2  Label on tape to read
C  BBAND            I*2  Which bands to read
C  EBAND            I*2
C  IBAND            I*2
C
C  from /BUFRS/
C  BUFF0(256)      I*2  Work buffer
C  BUFF1(4610)      R*4  Work buffer
C  BUFF2(4610)      R*4  Work buffer (for 2nd file if DONOTST=3)
C
C  Output:
C  JERR             I*2  Return error code.
C                        0 = OK
C                        5 = Did not find requested data.
C                        8 = I/O error.
C                       11 = OPEN I/O error.
C
C  Programmer: WaWa et al.
C  Last revision March 1989 for tapio
C----------------------------------------------------------------------
      INTEGER JERR
      INTEGER ERROR, IERR
      INTEGER   MJAD(2), LENBU, NUMANT,
     *   SZBUFF,  IFIL, NRPARM, KPOL, NOFF,
     *   BLKOFF, IB, HI, SBUFF(256,4,128), DELETE
      INTEGER   DUPWGT(91), F1OR2
      CHARACTER NATWT*2
      INTEGER   INDEX, INDX(2), KIND(2), IOCNT(2), NIOUT(2)
      INTEGER   BASDUP(91), NTEL, ITEL, JTEL, I
      INTEGER   IBASNO, NWTEL, NOTEL, NBAND, JBAND, CBAND
      INTEGER   IPT, NPT, NPOL, ICOR, ICOFF, IOFF, NCOR, IPOL
      INTEGER   V1, V2, BLKOF
C
C  new common TOHIST (in CWIN.INC / DWIN.inc)
C  I*4: NVISFL(2); R*4: CLAOUT1(2),CLAOUT2(2);
C  I*2: LUN1,LUN2,IND1,IND2,CCNO1,CCNO2,DISOUT1,DISOUT2
C
      LOGICAL   EQUAL, REWT, BADDAT
      CHARACTER*48 PNAME1, PNAME2
      REAL   BAS, COSHA, SINHA, HA, COSDEC, SINDEC, WT,
     *       COSPHI, SINPHI, U, V, W, DAYRAT, FREQ
      REAL   POLM(4,4,5), QUVR(4), QUVI(4),XCNT(2),YREC(2)
      DOUBLE PRECISION XMJAD, TIMFAC, XDAT, STFAC,
     *       GST0, IATDAY , TWOPI
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'WSLOD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DANT.INC'
      DATA V1, V2 / 0, 0/, NRPARM/5/, DELETE /-32768/
      DATA LUN1, LENBU, BLKOF /16, 128, 1/
      DATA LUN2 /17/
      DATA POLM /1.,1.,1.,1.,  -1.,-1.,1.,1.,
     *           1.,-1.,1.,-1., -1.,1.,1.,-1.,
     *           2.,0.,0.,2.,   -2.,0.,0.,2.,
     *           0.,-2.,-2.,0.,  0.,2.,-2.,0.,
     *           1.,0.,0.,0.,    0.,1.,0.,0.,
     *           0.,0.,1.,0.,    0.,0.,0.,1.,
     *           2.,2.,0.,0.,   -2.,2.,0.,0.,
     *           0.,0.,0.,0.,    0.,0.,0.,0.,
     *           1.,0.,0.,0.,    0.,0.,0.,1.,
     *           0.,1.,0.,0.,    0.,0.,1.,0./
C        ADDED DIAGONAL MATRIX TO COPE WITH WSRT IQUV LINOBS
C        TAPES. USE POLC = 11 TO IDENTIFY THEM
C        ADDED MATRIX TO CONVERT WSRT XX, XY, YX, YY TO
C        VLA RR, LL, RL, LR PSEUDO FORMAT.  19 SEP 85 / JMH
      DATA NTEL /14/
c                               init. value of dupwgt is 1 (not 0 )
      DATA BASDUP /91*1/, DUPWGT /91*1/
      DATA CCNO1,CCNO2 / 0, 0/
      DATA IATDAY / 0.99726956637D0 /, TWOPI / 6.283185308/
C----------------------------------------------------------------------
      TIMFAC = 1.0D0 / 65536.0D0
      JERR = 0
      REWT = UVWTFN(1:2) .EQ. 'NA'
      JERR = 5
      CALL SRT2SC ( ERROR)
      IF (ERROR.NE.0 .OR. DOLIST) GO TO 999
      CATBLK(KIGCN) = WVSMAX
      CALL CHR2H (4, 'WSRT', 1, CATH(KHTEL))
      CATD(KDBSC) = 1.0D0
      CATD(KDBZE) = 0.0D0
C                                       IAT days/LST radians
C         DAYRAT = .99726956637D0 / TWOPI
      DAYRAT = IATDAY / TWOPI
C                                       Get sort order.
      CALL CHR2H (2, 'BT', 1, CATBLK(KITYP))
C                                       Get RA
      CATD(KDCRV+3) =  RA1
C                                       Get Declination.
      CATD(KDCRV+4) = DEC1
      NBAND = 1 + (EBAND - BBAND)/IBAND
      CATBLK(KINAX+2) = NBAND
C                                       Get bandwidth (Hz)
      IF (NBAND .EQ. 1) THEN
         CATR(KRCIC+2) = BANDW
      ELSE
         CATR(KRCIC+2) = BFREQ(2) - BFREQ(1)
      ENDIF
      CATD(KDCRV+2) = BFREQ(1)
C
      SINDEC = SIN(TWOPI*DEC0/360.)
      COSDEC = COS(TWOPI*DEC0/360.)
      SINPHI = SIN(PHIROT)
      COSPHI = COS(PHIROT)
C                                       Check for duplicate baselines
      DO 120 ITEL = 1, NRINT-1
         DO 110 JTEL = ITEL+1, NRINT
            IF (10..LT.ABS(ABS(BASLIN(JTEL))-ABS(BASLIN(ITEL))))
     *         GO TO 110
            BASDUP(ITEL) = BASDUP(ITEL) + 1
            BASDUP(JTEL) = BASDUP(JTEL) + 1
 110     CONTINUE
         IF (.NOT. REWT .OR. DONOTST.GT.0.0) GO TO 120
            DUPWGT(ITEL) = BASDUP(ITEL)
 120     CONTINUE
C
C ITEL is in the range [1..NRINT-1] so ...
        IF (.NOT. REWT .OR. DONOTST.GT.0.0) GO TO 130
            DUPWGT(NRINT) = BASDUP(NRINT)
 130   CONTINUE
       FREQ = CATD(KDCRV+2) * 1.0D-9
C                                       Write message to user who is
C                                       waiting breathlessly to see if
C                                       reset epoch
      CATR(KREPO) = 1900. + WDATE(1)
C                                       Get number of polarizations.
      NCOR = NRPOL
      CATBLK(KINAX+1) = NCOR
      NVISFL(1)  = 0
      IOCNT(1) = 0
      CATBLK(KIIMS) = 0
      CALL UVCREA (DISOUT1, CCNO1, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1050) IERR
         CALL MSGWRT (8)
         JERR = 8
         GO TO 999
         END IF
C                                        Construct output file name.
      CALL ZPHFIL ('UV', DISOUT1, CCNO1, 1, PNAME1, IERR)
C                                       Initilize vis. count.
      XCNT(1) = 0.0
C
C                                       Do the same for the 2nd output
C                                       output file (class: 'UVNORD')
      IF (DONOTST.EQ.3.0) THEN
         IOCNT(2) = 0
         NVISFL(2) = 0
         CATBLK(KIGCN) = WVSMAX
         CALL CHR2H (6, CLAOUT2, KHIMCO, CATH(KHIMC))
         CALL UVCREA (DISOUT2, CCNO2, BUFF2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT, 1050) IERR
            CALL MSGWRT (8)
            JERR = 8
            GO TO 999
         END IF
C                                        Construct output file name.
         CALL ZPHFIL ('UV', DISOUT2, CCNO2, 1, PNAME2, IERR)
         XCNT(2) = 0.0
C                                        reset out class
         CALL CHR2H (6,  CLAOUT1, KHIMCO, CATH(KHIMC))
      END IF

C Init DOGBLK1 and DOGBLK2, these are only used when DONOTST=3.
C It's not reallly necessary to use test on DONOTST, because that is
C also done in the routine PTBLK, but it emphasizes the fact that
C DOGBLK and the routine PTBLK are only needed when 2 output files
C are sharing CATBLK
C
      IF (DONOTST.EQ.3) THEN
         CALL PTBLK (1, 'READ')
         CALL PTBLK (2, 'READ')
      END IF
C                                       Set up ANTENNA file
      CALL PTBLK (1, 'WRIT')
      CALL FILEINFO(1)
      CALL DUMPAN (NTEL, JERR)
C                                        CATBLK(K2EXT) altered by DUMPAN
      CALL PTBLK (1, 'READ')
      IF (DONOTST.GE.3) THEN
         CALL PTBLK (2, 'WRIT')
         CALL FILEINFO(2)
         CALL DUMPAN (NTEL, JERR)
         CALL PTBLK (2, 'READ')
      END IF
C                                       Set output rec length R*4 words
      LREC = NRPARM+CATBLK(KINAX)*CATBLK(KINAX+1)*CATBLK(KINAX+2)*
     *   CATBLK(KINAX+3)*MAX0 (1, CATBLK(KINAX+4))
C                                       Open output file.
      CALL ZOPEN (LUN1, IND1, DISOUT1, PNAME1,
     *          .TRUE.,.TRUE.,.TRUE., IERR)
      IF (IERR.EQ.0) GO TO 420
         WRITE (MSGTXT, 1410) IERR,PNAME1
         CALL MSGWRT (8)
         JERR = 11
         GO TO 999
C                                       Initilize output file.
 420  NVIS = 32760 ** 2
      SZBUFF = 9220
         do while (lenbu * lrec .ge. (szbuff/2))
            lenbu = lenbu/2
         enddo
      NIOUT(1) = LENBU
      CALL UVINIT ('WRIT', LUN1, IND1, NVIS, V1, LREC, NIOUT(1),
     *      SZBUFF, BUFF1, BLKOF, KIND(1), IERR)
      IF (IERR.EQ.0) GO TO 430
         WRITE (MSGTXT, 1420) IERR,PNAME1
         CALL MSGWRT (8)
         JERR = 11
         GO TO 999
 430  YREC(1) = 0.0
C                                       If DONOTST=3 then open the
C                                       second output file.
      IF (DONOTST.EQ.3.0) THEN
         CALL ZOPEN (LUN2, IND2, DISOUT2, PNAME2,
     *          .TRUE.,.TRUE.,.TRUE., IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT, 1410) IERR,PNAME2
            CALL MSGWRT (8)
            JERR = 11
            GO TO 999
         END IF
C                                Initilize output file.
         NVIS = 32760 ** 2
         NIOUT(2) = LENBU
         SZBUFF = 9220
         CALL UVINIT ('WRIT', LUN2, IND2, NVIS, V2, LREC, NIOUT(2),
     *           SZBUFF, BUFF2, BLKOF, KIND(2), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT, 1420) IERR,PNAME2
            CALL MSGWRT (8)
            JERR = 11
            GO TO 999
         END IF
         YREC(2) = 0.0
      END IF
      JERR = 8
C
C                                       VIS records.
C                                       Set up polariz. matrix
      IF ((POLC.EQ.9) .OR. (POLC.EQ.10)) GO TO 440
         WRITE (MSGTXT, 1440) POLC
         CALL MSGWRT (8)
         JERR = 20
         GO TO 999
 440  CONTINUE
      KPOL = POLC - 8
C
C       SET THE SCALING FACTORS AND POL MATRIX PARAMETERS
C
      SC = 0.25
      NOFF = 1
      IF (DONOTST.GT.0.0) GOTO 442
      IF (NRPOL.EQ.4) GOTO 445
      IF (NRPOL.EQ.2) THEN
         KPOL = 4
C                               OFFSET FOR INDEXING IN STRTRC IN LOOP 510
         NOFF = 3
         GOTO 450
      END IF
      IF (NRPOL.EQ.1) THEN
         SC = 1.0 / FLOAT (KPOL)
         GOTO 450
      END IF
442   IF (DONOTST.EQ.3. .OR.  DONOTST.EQ.1. .OR.
     *      DONOTST.EQ.2. .AND. NRPOL.EQ.2) THEN
         KPOL = 3
         NOFF = 3
         SC = 1.0
         GOTO 450
      END IF
      IF (DONOTST.EQ.2.0) THEN
         KPOL = 5
         SC = 1.0
         GOTO 450
      END IF
445   IF (NSTOKES.EQ.1) THEN
         KPOL = 3
         SC = 1.0
      END IF
450   CONTINUE
C
C
C        BEGIN LOOPING THROUGH DATA TO CONSTRUCT OUTPUT VISIBILITIES
C
      DO 600 ITEL = 1, NRINT
C                                  is this a redundant baseline ?
C                                  YES, write to file 1 ['UVRDUN']
C                                  NO,  write to file 2 ['UVNORD']
C                                  if DONOTST<>3 always to file 1
         IF (BASDUP(ITEL).GT.1 .OR. DONOTST.LT.3.0) THEN
            F1OR2 = 1
            CLAOUT(1:6) = CLAOUT1
         ELSE
            F1OR2 = 2
            CLAOUT(1:6) = CLAOUT2
         END IF
C
C        get the telesc.nrs from ITEL, these only use of these ## is
C        to write a message to the user about the tel. configuration.
C
         IBASNO = BASNO(ITEL) + 0.1
         NWTEL  = IBASNO/256
         NOTEL  = IBASNO - NWTEL*256
C
         BLKOFF = 0
         NPT    = NDATP(ITEL)
         HI     = 257
         WT     = IINT(ITEL)
C                       baseline in lambdas, not seconds, for 1st freq. only
         BAS = BASLIN(ITEL) * BFREQ(1)

C                                  Pseudo uniform weight
C         IF (REWT) WT =  WT * BAS / (BASLIN(1) * DUPWGT(ITEL))
C        Changed: average redundant baselines always (not only if DOALL<0)
C        (if doall<0 only 0A & 9C, 0B & 9D are equal). MHW 881111
         IF (REWT) WT =  WT * BAS / (BASLIN(1) * BASDUP(ITEL))
         DO 580 IPT = 1, NPT
            IF (HI.LT.257) GO TO 515
               DO 511 JBAND = 1, NBAND
                  DO 510 IPOL = 1, NRPOL
                     NPOL = 1 + NOFF * (IPOL - 1)
C                               Find initial block number for data
C                               given interf. no., polariz., freq.
                     IB = BLKOFF + STRTRC(ITEL,NPOL,JBAND)
                     CALL ZFIO ('READ', LUNDS, DINDS, IB,
     *                  SBUFF(1,IPOL,JBAND), IERR)
                      IF (IERR.EQ.0) GO TO 510
                         WRITE (MSGTXT, 1520) IERR, IB
                         CALL MSGWRT (8)
                         JERR = 20
                         GO TO 999
 510              CONTINUE
 511           CONTINUE
               BLKOFF = BLKOFF + 1
               HI = 1
 515        CONTINUE
C                                  Check for fully flagged record
            BADDAT = .FALSE.
            DO 521 JBAND = 1, NBAND
               DO 520 IPOL = 1, NRPOL
                  BADDAT = BADDAT .OR.
     *                  (SBUFF(HI,IPOL,JBAND).NE.DELETE)
     *                  .OR. (SBUFF(HI+1,IPOL,JBAND).NE.DELETE)
               IF (BADDAT) GO TO 522
 520           CONTINUE
 521        CONTINUE
            GO TO 580
 522        CONTINUE
C                                       Update vis. count and check
            XCNT(F1OR2) = XCNT(F1OR2) + 1.0
            IF (XCNT(F1OR2).GT.WVSMAX) GO TO 900
C                                       Where to put data in output buffer
            INDX(F1OR2)  = KIND(F1OR2) + IOCNT(F1OR2)*LREC
            IOCNT(F1OR2) = IOCNT(F1OR2) + 1
            INDEX        = INDX(F1OR2)
C
            HA    = SHA(ITEL) + (IPT - 1) * DHA(ITEL)
            SINHA = SIN(HA)
            COSHA = COS(HA)
C                                       Random parameters - U,V,W
            U = -BAS * COSHA
            V = -BAS * SINHA * SINDEC
            W =  BAS * SINHA * COSDEC
C
            IF (F1OR2.EQ.1) THEN
C                                       Precess U&V with PHIROT
               BUFF1(INDEX)   = U + V * SINPHI
               BUFF1(INDEX+1) =-U * SINPHI + V
               BUFF1(INDEX+2) = W
C                                       Baseline
               BUFF1(INDEX+3) = BASNO(ITEL)
C                                        Time
               BUFF1(INDEX+4) = DAYFR + DAYRAT * (HA - SHA(ITEL))
            ELSE
               BUFF2(INDEX)   = U + V * SINPHI
               BUFF2(INDEX+1) =-U * SINPHI + V
               BUFF2(INDEX+2) = W
               BUFF2(INDEX+3) = BASNO(ITEL)
               BUFF2(INDEX+4) = DAYFR + DAYRAT * (HA - SHA(ITEL))
            END IF
C                                       Set further random parameters
C                                       here. NRPARM = # ran. parm.
C                                       Visibilities.
c                                       Loop over freq.
            DO 560 JBAND = 1, NBAND
C                                       Scramble polarization
C                                       default weight
            WTD = WT
C                                       Scramble polarization
            DO 550 IPOL = 1, NCOR
               QUVR(IPOL) = 0.
               QUVI(IPOL) = 0.
               DO 530 ICOR = 1, NCOR
C                                       check for bad point, this freq only
                  IF ((SBUFF(HI,ICOR,JBAND) .EQ. DELETE) .OR.
     *                (SBUFF(HI+1,ICOR,JBAND) .EQ. DELETE)) WTD =-WT
                  ICOFF = 1 + NOFF * (ICOR - 1)
                  QUVR(IPOL) = QUVR(IPOL) + POLM(ICOR,IPOL,KPOL)*SC*
     *               (PSCAL(ITEL,ICOFF,JBAND)*SBUFF(HI,ICOR,JBAND)
     *               +POFF(ITEL,ICOFF,JBAND))
                  QUVI(IPOL) = QUVI(IPOL) + POLM(ICOR,IPOL,KPOL)*SC*
     *               (PSCAL(ITEL,ICOFF,JBAND)*SBUFF(HI+1,ICOR,JBAND)
     *               +POFF(ITEL,ICOFF,JBAND))
 530           CONTINUE
               IOFF = NRPARM+ CATBLK(KINAX)*(IPOL-1 + NCOR*(JBAND-1))
               IF (F1OR2.EQ.1) THEN
                  BUFF1(INDEX+IOFF)   = QUVR(IPOL)
                  BUFF1(INDEX+IOFF+1) = QUVI(IPOL)
                  BUFF1(INDEX+IOFF+2) = WTD
               ELSE
                  BUFF2(INDEX+IOFF)   = QUVR(IPOL)
                  BUFF2(INDEX+IOFF+1) = QUVI(IPOL)
                  BUFF2(INDEX+IOFF+2) = WTD
               END IF
 550        CONTINUE
 560        CONTINUE
C                                       See if output buffer is full.
            IF (IOCNT(F1OR2).LT.NIOUT(F1OR2)) GO TO 580
C                                       Write output buffer(F1ORF2).
               NIOUT(F1OR2) = IOCNT(F1OR2)
               IOCNT(F1OR2) = 0
               YREC(F1OR2)  = YREC(F1OR2) + 1.0
               IF (F1OR2.EQ.1) THEN
                  CALL UVDISK
     *              ('WRIT',LUN1,IND1,BUFF1,NIOUT(1),KIND(1),IERR)
               ELSE
                  CALL UVDISK
     *              ('WRIT',LUN2,IND2,BUFF2,NIOUT(2),KIND(2),IERR)
               END IF
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT, 1510) IERR, F1OR2, YREC(F1OR2)
                  CALL MSGWRT (8)
                  JERR = 11
                  GO TO 999
               END IF
C                                       Update vis. count.
               NVISFL(F1OR2) = NVISFL(F1OR2) + LENBU
C
C                                       Loop back for next record.
 580        HI = HI + 2
 600     CONTINUE
C                                       Finished; cleanup and go home.
C                                       Finish vis. count.
 900     NVISFL(1) = NVISFL(1) + IOCNT(1)
C                                       Check if no data.
         IF (NVISFL(1).NE.0) GO TO 905
            JERR = 15
            GO TO 999
C                                       Finish write and close files.
 905     YREC(1)  = YREC(1) + 1.0
         NIOUT(1) = -IOCNT(1)
         CALL UVDISK
     *       ('FLSH', LUN1, IND1, BUFF1, NIOUT(1), KIND(1), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT, 1510) IERR, 1, YREC(1)
            CALL MSGWRT (8)
         END IF
C                                       Cleanup 2nd file if DONOTST=3
         IF (DONOTST.EQ.3.0) THEN
            NVISFL(2) = NVISFL(2) + IOCNT(2)
            YREC(2)  = YREC(2) + 1.0
C                                        Finish write and close files.
            NIOUT(2) = -IOCNT(2)
            CALL UVDISK
     *           ('FLSH', LUN2, IND2, BUFF2, NIOUT(2), KIND(2), IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT, 1510) IERR, 2, YREC(2)
               CALL MSGWRT (8)
            END IF
         END IF
C                                       Shrink 1st file if necessary
C                                       Put vis count in CATBLK
C
         CATBLK(KIGCN) = NVISFL(1)
C                                        Write message about how many vis.
         WRITE (MSGTXT, 1920) 1, NVISFL(1)
         CALL MSGWRT (5)
C                                       Close output file.
         CALL ZCLOSE (LUN1, IND1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT, 1921) IERR
            CALL MSGWRT (6)
         ELSE
            JERR = 0
         END IF
C                                       If 2nd file is used, shrink and
C                                       and close this one too.
C The catalogue is not updated by ZCLOSE so it's no use to put
C information in CATBLK that is not saved. The correct number of
C visib. and the class name is put in CATBLK by a call to subr.
C FILEINFO and/or subr. PTBLK ...........
C and then C the catalogue is updated by a call to UVHIS
C or CATIO.
C                                init for UVHIS or CATIO
         CALL FILEINFO(1)
         CALL PTBLK (1, 'WRIT')
         CALL UVHIS
C                                CATBLK(K2EXT) altered by UVHIS
         CALL PTBLK (1, 'READ')
         IF (DONOTST.EQ.3.0) THEN
            CALL FILEINFO(2)
            CALL PTBLK (2, 'WRIT')
            CALL UVHIS
            CALL PTBLK (2, 'READ')
         END IF
C
         IF (DONOTST.EQ.3) THEN
C                                Write message about how many vis.
            WRITE (MSGTXT, 1920) 2, NVISFL(2)
            CALL MSGWRT (5)
            CALL ZCLOSE (LUN2, IND2, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT, 1921) IERR
               CALL MSGWRT (6)
            ELSE
               JERR = 0
            END IF
         END IF
  999 CONTINUE
C       close scratch set
      CALL ZCLOSE (LUNDS, DINDS, IERR)
C
C close tape after last band or in case of any error in visin
C
      CALL TAPIO('CLOS', FDVEC, HW, IHND, IERR)
      RETURN
C----------------------------------------------------------------------
 1050 FORMAT ('VISIN: ERROR',I3,' CREATING CATALOGUED OUTPUT FILE')
 1410 FORMAT ('VISIN: ERROR',I3,' OPENING OUTPUT FILE: ',6A4)
 1420 FORMAT ('VISIN: ERROR',I3,' INIT OUTPUT FILE: ',6A4)
 1440 FORMAT ('VISIN: CANT HANDLE DIPOLE AXIS CODE',I6)
 1510 FORMAT ('VISIN: WRITE ERROR',I4,' OUT. FILE:',I4,' BLOCK:',F10.0)
 1520 FORMAT ('VISIN: ZFIO READ ERROR',I7,' BLOCK ',I6)
 1920 FORMAT ('VISIN: Copied (to file:',I2,') ', I10,' vis. records')
 1921 FORMAT ('VISIN: ERROR',I7,' CLOSING CATALOGUED UV FILE')
      END
C
C
C
      SUBROUTINE UVHIS
C----------------------------------------------------------------------
C  UVHIS writes the history file for a uv data base.
C  NAMEIN      R*4(2)  Source name.
C  NVIS      P I*4     Number of visibility points.
C  NAME
C  NAMOUT      C*4(3)  Output file name
C  CLAOUT      C*4(2)  Output file class.
C  SEQOUT      I*2     Output file sequence no.
C
C  Programmer: W. D. Cotton, April 1981.
C----------------------------------------------------------------------
      INTEGER LUN, IERR
      INTEGER   TIME(3), DATE(3)
      INCLUDE 'WSLOD.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN /28/
C----------------------------------------------------------------------
C                                       Create/open hist. file.
      CALL HICREA (LUN, DISOUT, CCNO, CATBLK, BUFF0, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT, 1000) IERR
         CALL MSGWRT (6)
         GO TO 995
C                                       Get current date/time.
 10   CALL ZDATE (DATE)
      DATE(1) = DATE(1)-1900
      CALL ZTIME (TIME)
C                                       Write first record.
      WRITE (MSGTXT, 1010) TSKNAM, NLUSER, DATE, TIME
      CALL HIADD (LUN, MSGTXT, BUFF0, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Write file name,class,seq.
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, CATBLK(KIIMS), DISOUT,
     *   LUN, BUFF0, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Source name/qualifier/band.
      WRITE (MSGTXT, 1011) TSKNAM, NAMEIN
      CALL HIADD (LUN, MSGTXT, BUFF0, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Number of vis.
      WRITE (MSGTXT, 1012) TSKNAM, NVIS
      CALL HIADD (LUN, MSGTXT, BUFF0, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Close file
      CALL HICLOS (LUN, .TRUE., BUFF0, IERR)
      GO TO 995
C                                       An error occured.
 980  WRITE (MSGTXT, 1980) IERR
      CALL MSGWRT (5)
 995  CALL CATIO ('UPDT', DISOUT, CCNO, CATBLK, 'CLWR', BUFF0, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT, 1900) IERR
         CALL MSGWRT (6)
C
 999  RETURN
C----------------------------------------------------------------------
 1000 FORMAT ('UVHIS: ERROR',I3,' CREATING HISTORY FILE')
 1010 FORMAT (A,'/ DATA BASE CREATED BY USER ',I3,I4,'/',I2,'/',I2,
     *   3X,I2,':',I2,':',I2)
 1011 FORMAT (A,' SOURCE=''',A)
 1012 FORMAT (A,' /NUMBER OF VIS. POINTS = ',I9)
 1900 FORMAT ('ERROR',I7,' UPDATING CATALOG HEADER')
 1980 FORMAT ('UVHIS: ERROR',I3,' WRITING HISTORY FILE')
      END
C
      SUBROUTINE FILEINFO(FILENUMBER)
C----------------------------------------------------------------------
C  this routine fills DISOUT,CCNO,NVIS with DISOUT<i>,
C  CCNO<i> ....   where <i> stands for the file number 1 or 2.
C  argument:
C          FILENUMBER  I*2     File number 1 or 2 (2 only if DONOTST=3).
C----------------------------------------------------------------------
      INTEGER FILENUMBER
      INCLUDE   'WSLOD.INC'
      INCLUDE   'INCS:DCAT.INC'
      INCLUDE   'INCS:DHDR.INC'
C                                   The information is passed
C                                   through the common block FINFO
C----------------------------------------------------------------------
C                                       File 1 or 2 ?
      IF (FILENUMBER.EQ.1) THEN
         CCNO = CCNO1
         DISOUT = DISOUT1
C              put real number of vis. and the correct class in CATBLK.
         NVIS = NVISFL(1)
         CATBLK(KIGCN) = NVIS
         CALL CHR2H (6,  CLAOUT1, KHIMCO, CATH(KHIMC))
      ELSE
         CCNO = CCNO2
         NVIS = NVISFL(2)
         CATBLK(KIGCN) = NVIS
         DISOUT = DISOUT2
         CALL CHR2H (6,  CLAOUT2, KHIMCO, CATH(KHIMC))
      END IF
      RETURN
      END
C---------------------------------------------------------------------
C
      SUBROUTINE PTBLK (FILENUMBER, OPCODE)
C----------------------------------------------------------------------
C performs a similar task as the subroutine fileinfo, but only for
C CATBLK (KIEXT):CATBLK (KIEXT+KIEXTN). This pt. of the catalogue block
C must be unique for the two files, so this routine is only necessary
C if DONOTST EQ 3.0.
C arguments:
C              FILENUMBER  I*2     filenumber 1 or 2
C              OPCODE      R*4     'READ' : CATBLK(KIEXT) --> DOGBLK<i>
C                                  'WRIT' : DOGBLK<i> --> CATBLK(KIEXT)
C                                           where <i> is FILENUMBER.
C----------------------------------------------------------------------
      INTEGER FILENUMBER
      CHARACTER*4    OPCODE
      INCLUDE   'WSLOD.INC'
      INCLUDE   'INCS:DCAT.INC'
      INCLUDE   'INCS:DHDR.INC'
C----------------------------------------------------------------------
C                                        this routine is only necessary
C                                        if DONOTST = 3.
      IF (DONOTST.LE.2.0) GOTO 999
C
      IF (FILENUMBER .EQ. 2) THEN
         IF (OPCODE .EQ. 'READ') CALL ICOPY(20, K2EXT,CATBLK,1,DOGBLK2)
         IF (OPCODE .EQ. 'WRIT') CALL ICOPY(20,1,DOGBLK2,K2EXT,CATBLK)
      ELSE
         IF (OPCODE .EQ. 'READ') CALL ICOPY(20,K2EXT,CATBLK,1,DOGBLK1)
         IF (OPCODE .EQ. 'WRIT') CALL ICOPY(20,1,DOGBLK1,K2EXT,CATBLK)
      END IF
C
  999 RETURN
      END
C---------------------------------------------------------------------
C
      SUBROUTINE ICOPY (NTOCPY, SPOS1, IBUFF1, SPOS2, IBUFF2)
C---------------------------------------------------------------------
C   copies NTOCPY INTEGER   values from IBUFF1, starting at SPOS1 to
C   IBUFF2, starting at SPOS2.
C---------------------------------------------------------------------
      INTEGER I, NTOCPY, SPOS1, SPOS2
      INTEGER   IBUFF1(1), IBUFF2(1)
C---------------------------------------------------------------------
      DO 100 I=1, NTOCPY
         IBUFF2 (SPOS2 + I - 1) = IBUFF1 (SPOS1 + I - 1)
  100 CONTINUE
      RETURN
      END
C---------------------------------------------------------------------
C
C
      SUBROUTINE SRT2SC ( ERROR)
C---------------------------------------------------------------------
C     Read in a Dwingeloo visibility tape and store the data
C     internally
C---------------------------------------------------------------------
      INTEGER ERROR
      INTEGER    I, II, ITEL, ISET, IPOL, ITER, IBLK, N
      INTEGER    NWTEL, NOTEL, IRTYPE
      INTEGER    NREC, HI, FI, NBYTES, LX, LY
      INTEGER    IFND, IHND
      INTEGER    MSH, NTEL, PTS, TPTS, MDB, FWVAR, XNREC
      INTEGER    NDB, NDBPS, SCRLEN
      REAL       XFREQ, EPVAR, SCAL, EXP
      INTEGER    BLKCNT, JERR
      DOUBLE PRECISION     JTIME,JTIM0,JUDAY,DPJTIM, HAST, HAEND, HAFTIM, DAYRAT
      DOUBLE PRECISION     DPVAR, TWOM16
      DOUBLE PRECISION     PREC(9), NUTA(9), ABER(3), VNPA(3), DVNPA(3)
      REAL       WLAT, WLON,  TWOPI, SPDLIT, DFREQ
      INTEGER    POST(14), TDATE(6), UDAY, UTIME
      INTEGER    NRSTS, LOH, LSC, LRCRD, PHBLL, NFREQ, NTOT, PROJN
      INTEGER    SFREQ, PBAND
      INTEGER    ITAPVR, NOBAND, NGSET(4), NITER, NBAND, JBAND, CBAND
      LOGICAL    DOALL, NOTIBM, l1, l2, l3
      LOGICAL    INTOK, READSH,SYS52
      CHARACTER*2 CHTEMP, DATYP, TTYPE(5), CPOL(4)
      CHARACTER*1 CSTOK(4)
      CHARACTER*12 SOURSE
      CHARACTER*8 CDATE
      CHARACTER*4 BACK
      CHARACTER*6 VOLUME
      CHARACTER*3 TAPTYP(2)
      INCLUDE 'WSLOD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /TAPCOM/ NREC, HI, FI, IHND, NBYTE
      DATA CPOL /'XX','XY','YX','YY'/, TTYPE /'FD','OH','SC','SH',
     *   'IH'/
      DATA CSTOK /'I','Q','U','V'/
      DATA TAPTYP /'IBM', 'VAX'/
      DATA NTEL /14/
      DATA SPDLIT /2.997925E+8/, JTIM0 /2440000.D0/
C-----------------------------------------------------------------------
      TWOPI  = 2.*3.1415926
      TWOM16 = 2.D0**(-16)
C                                     ratio iat day to sideral day
      DAYRAT = .99726956637D0
C                                     Read File Description Record
      NBYTES = 3840
      LX = 1920
      LY = 9999
      LUNDS = 27
      SPDLIT = 1./SPDLIT
C                                     Loop back here on index function
 20   CALL TAPIO ('READ', FDVEC, HW, IFND, JERR)
      IF (JERR.NE.0) GO TO 960
      IRTYPE = 1
      CALL ZC8CL (2, 3, HW(IFND), CHTEMP)
      NOTIBM = (CHTEMP .EQ. TTYPE(IRTYPE))
C If not ok then maybe the tape isn't in ASCII format, try to
C read it in EBCDIC format ...
         IF (.NOT. NOTIBM) THEN
            CALL ZCHEBC(2, CHTEMP, CHTEMP)
            IF (CHTEMP .NE. TTYPE(IRTYPE)) THEN
               GOTO 950
            ENDIF
         END IF
C
C If tape is in IBM/EBCDIC format, swap the order of bytes in HW
C attention: not the whole buffer, only the part that will be used !!
C all I*2 numbers are now correct ...
C
C                                          Get volume and label #
      IF (DOLIST) THEN
         CALL ZC8CL (6, 105, HW(IFND), VOLUME)
         IF (.NOT. NOTIBM) CALL ZCHEBC(6, VOLUME, VOLUME)
         NFILES = XFILES + .01
         I = 1
         IF (NOTIBM) I = 2
         WRITE (MSGTXT , 1068) NFILES, VOLUME, TAPTYP(I)
         CALL MSGWRT(5)
      ENDIF
C
      CALL TI16IL(48, HW(IFND), CW, NOTIBM)
      CALL TI32IL(1, HW(17+IFND), MSH ,NOTIBM)
      ITAPVR = CW(13)
      IF (.NOT.DOLIST.AND.ITAPVR.LT.6 .AND. DONOTST.GT.0.0) THEN
          WRITE (MSGTXT, 1073) ITAPVR
          CALL MSGWRT (5)
      END IF
      LRCRD  = CW(14)
      PHBLL  = CW(15)
C                   Total # data blocks; # data blocks per set
c   just changed 24+ifind to 25+ifnd?
      CALL TI32IL (1, HW(25+IFND), MDB, NOTIBM)
C                       Replace MSH with 4 ?
c      CALL TI32IL (32, HW, HW, NOTIBM)
      NDBPS  = 1 + (MDB - 1)/MSH
C                                       Create scratch file
      NBAND  = 1 + (EBAND - BBAND)/IBAND
C                                            Read first OH block
      CALL TAPIO ('READ', FDVEC, HW, IFND, JERR)
         IF (JERR.NE.0) GO TO 960
      CALL TI16IL(335, HW(IFND), CW, NOTIBM)
      CALL ZC8CL (2, 3, HW(IFND), CHTEMP)
      IF (.NOT.NOTIBM)  THEN
         CALL ZCHEBC(2, CHTEMP, CHTEMP)
      ENDIF
      IRTYPE = 2
      IF (CHTEMP .NE. TTYPE(IRTYPE)) GO TO 950
      CALL TI32IL (1, HW(2+IFND), LOH, NOTIBM)
      SYS52 = (CW(33) .EQ. 52)
      ERROR = 5
C                               Source name on tape
      CALL ZC8CL (12, 1, HW(IFND+7), SOURSE)
      IF (.NOT.NOTIBM)  THEN
         CALL ZCHEBC(12, SOURSE, SOURSE)
      ENDIF
      IF (NAMEIN(1:4) .EQ. '    '.OR. DOLIST) NAMEIN = SOURSE
C                                          sourse name correct ?
      IF (NAMEIN .NE. SOURSE) THEN
         WRITE (MSGTXT, 1050) SOURSE, NAMEIN
         GO TO 980
      END IF
      CALL CHR2H (8, NAMEIN, 1, CATH(KHOBJ))
C                                       Default NAMOUT=NAMEIN.IQUAL
C                                       (If IQUAL.le.0 NAMOUT=NAMEIN)
      IF (NAMOUT .EQ. ' ') NAMOUT = NAMEIN
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
C                                       Let project number be observer
      PROJN = CW(14)
      WRITE (CDATE, 1065) PROJN
      CALL CHR2H (8, CDATE, 1, CATH(KHOBS))
C                                       Let backend be instrument
      CALL ZC8CL (4, 173, HW(IFND), BACK)
      IF (.NOT.NOTIBM)  THEN
         CALL ZCHEBC(4, BACK, BACK)
      ENDIF
      CALL CHR2H (8, BACK//'    ', 1, CATH(KHINS))
C
      DO 70 I = 1, 6
 70      TDATE(I) = CW(I+24)
C                                       These are (1) Epoch - 1900
C                                                 (2) Obs. Year - 1900
C                                                 (3) Obs. Month
C                                                 (4--6) Obs Day Hour Min (MET)
C                                       UT day# and time in 10s
      UDAY  = CW(9)
      UTIME = CW(10)
C                                       Convert start of year + hh/mm/ss to JD
      WDATE(1) = TDATE(2)
      WDATE(4) = UTIME/360.
      UTIME    = UTIME - WDATE(4)*360.
      WDATE(5) = UTIME/6.
C                                       Seconds, make approx. correction
C                                       for IAT - UT.
      WDATE(6) = 24. + 0.65 * (WDATE(1) - WDATE(1)) +
     &          10. * (UTIME - 6. * WDATE(5)) + 0.5
      WDATE(2) = 1
      WDATE(3) = 0
      CALL DAT2JD (WDATE, JTIME)
C                                       Add UT day number
      JTIME = JTIME + UDAY
C                                       Convert back to civil system
      CALL GREG (JTIME, CDATE)
      DAYFR = (WDATE(6) + 60. * WDATE(5) + 3600. * WDATE(4))/86400.
C                                       TOTAL number of channels
      NTOT = CW(77)
C                                       Number of frequencies observed
      NFREQ = CW(78)
C                                       Channel separation
      CALL ZINR32 (CW(75), BANDW, NOTIBM)
C                                       FREQ in in kHz
      DFREQ = 1.e3 * BANDW/NFREQ
C       DFREQ = 0.1 * CW(79)  ! works for DLB, not for DCB
C               One tape block (MDB) is 3840 true bytes, is 1920 integers
C               which take 3840 AIPS bytes to store is 3840/256 disk blocks
C               The number of tape blocks in NDBPS * number of sets needed
C               Fudge upward by 2 because short 32 point WSRT tape records
C               don't pack well into aips 64 point blocks.
C                                       Actual # freq on tape
      NFREQ = CW(335)
      SCRLEN = 2. * NBAND * (1./FLOAT(NFREQ)) * MDB * (3840./256.)
      IF (.NOT. DOLIST) THEN
         CALL SCRFIL (SCRLEN, JERR)
            IF (JERR.EQ.0) GO TO 75
               ERROR = 2
               GO TO 999
      ENDIF
c
 75   CALL ZINR64(CW(101), HAST, NOTIBM)
      CALL ZINR64(CW(105), HAEND, NOTIBM)
      HAST = HAST * 360.D0
      HAEND = HAEND * 360.D0
      CALL CHR2H (8, CDATE, 1, CATH(KHDOB))
      CALL ZINR64 (CW(65), DPVAR, NOTIBM)
         RA1 = 360.D0 * DPVAR
      CALL ZINR64 (CW(69), DPVAR, NOTIBM)
         DEC1= 360.D0 * DPVAR
         IF (RA1 .LT. 0.D0) RA1 = 360.D0+RA1
      CALL ZINR64 (CW(93), DPVAR, NOTIBM)
         DEC0 = 360.D0 * DPVAR
      CALL ZINR64 (CW(89), DPVAR, NOTIBM)
         RA0  = 360.D0 * DPVAR
         IF (RA0.LT.0.D0) RA0 = 360.D0+RA0
      NRPOL = CW(80)
C
C     Set NRPOL to 2 if we want redundant baselines because we
C     will eventually skip the XY and YX data.
C
      IF ((DONOTST.EQ.3.0 .OR. DONOTST.EQ.1.0).AND. NRPOL.EQ.4)
     *     NRPOL = 2
C                                       THIS IS THE # STANDARD BASELINES
C                                       SO DO NOT USE
C                                       nrint is multiple of 16, so
C                                       will be 96 i.s.o. 91 (DBX-type,
C                                       tape version 6)
      NRINT = CW(81)
      CALL ZINR32 (CW(75), BANDW, NOTIBM)
      BANDW = BANDW * 1.E+6
      POLC  = CW(74)
C                                       IF 1 THEN IQUV ARE ON TAPE
      NSTOKES = CW(185)
      NRSTS   = CW(334)
C
      IF (DONOTST.GT.3.0) GOTO 985
      IF (.NOT.DOLIST.AND.DONOTST.GT.0.0) THEN
            WRITE (MSGTXT, 1072) DONOTST
            CALL MSGWRT (5)
      END IF
      IF (POLC.NE.10 .AND. DONOTST.GT.0.0) THEN
         WRITE (MSGTXT, 1075)
         CALL MSGWRT (5)
      END IF
C                              Telescope positions in meters, find minimum
         CALL TI32IL (NTEL, HW(75+IFND), POST, NOTIBM)
      DO 80 ITEL = 1, NTEL
         BASLM(ITEL) = POST(ITEL) * TWOM16
 80   CONTINUE
      IF (.NOT.DOLIST) THEN
         DPVAR = BASLM(11) - BASLM(10)
         WRITE (MSGTXT, 1600) SOURSE, HAST, HAEND, DPVAR
         CALL MSGWRT(5)
         WRITE (MSGTXT, 1005) BBAND, EBAND, IBAND
         CALL MSGWRT(5)
      ENDIF
C                             Read 2nd OH rec
      CALL TAPIO ('READ', FDVEC, HW, IFND, JERR)
         IF (JERR.NE.0) GO TO 960
C
C                              Read System Calibration Rec
      CALL TAPIO ('READ', FDVEC, HW, IFND, JERR)
         IF (JERR.NE.0) GO TO 960
      CALL ZC8CL (2, 3, HW(IFND), CHTEMP)
      IF (.NOT.NOTIBM)  THEN
         CALL ZCHEBC(2, CHTEMP, CHTEMP)
      ENDIF
      IRTYPE = 3
      IF (CHTEMP .NE. TTYPE(IRTYPE)) GO TO 950
      CALL TI16IL(224, HW(IFND), CW, NOTIBM)
      CALL TI32IL (1, HW(2+IFND), LSC, NOTIBM)
C                                            Latitute and Longitude
      CALL ZINR32(CW(217), WLAT, NOTIBM)
      CALL ZINR32 (CW(219), WLON, NOTIBM)
C                                          Precesion rotation angle
      CALL ZINR32 (CW(223), PHIROT, NOTIBM)
      IF (.NOT.DOLIST.AND.PHIROT .EQ. 0.0) THEN
         MSGTXT = 'SRT2SC:THERE IS NO PRECESION ROTATION ON THIS TAPE'
         CALL MSGWRT(5)
         ENDIF
      PHIROT = PHIROT * TWOPI
C                                          Read 2nd SC record
      CALL TAPIO ('READ', FDVEC, HW, IFND, JERR)
         IF (JERR.NE.0) GO TO 960
C                                       Read 3rd & 4th SC records
C                                       for tape version 6
      IF (ITAPVR.GE.6) THEN
         CALL TAPIO ('READ', FDVEC, HW, IFND, JERR)
         IF (JERR.NE.0) GOTO 960
         CALL TAPIO ('READ', FDVEC, HW, IFND, JERR)
         IF (JERR.NE.0) GOTO 960
      END IF
C                                          Loop through sets
      BLKCNT = 1
      READSH = .FALSE.
C                                          1st desired band
      CBAND  = BBAND
      JBAND  = 1
C                                       NRSTS replaces MSH
      DO 500 ISET = 1, NRSTS
C                                          Find next set header
         CHTEMP = '  '
         IRTYPE = 4
         DO WHILE (CHTEMP .NE. TTYPE(IRTYPE))
            CALL TAPIO ('READ', FDVEC, HW, IFND, JERR)
               IF (JERR.NE.0) GO TO 960
            CALL ZC8CL (2, 3, HW(IFND), CHTEMP)
            IF (.NOT.NOTIBM)  THEN
               CALL ZCHEBC(2, CHTEMP, CHTEMP)
            ENDIF
         ENDDO
         CALL TI16IL(20, HW(IFND), CW, NOTIBM)
C
C                       Find which polarization (or is it an IF set?)
         CALL ZC8CL (2, 31, HW(IFND),  DATYP)
         IF (.NOT.NOTIBM)  THEN
            CALL ZCHEBC(2, DATYP, DATYP)
         ENDIF
         POLC = CW(17)
         DOALL = (DONOTST.EQ.3.0 .OR. DONOTST.EQ.1.0)

C
C          If we want the non standard baselines we should read the
C          number of interferometers from the set header to include
C          them in the count
C
         IF (DOALL) NRINT = CW(18)
C                                       Do we want this set?
         IF (DATYP.EQ.'IF') GOTO 500
C                               For LIST, get PTS and FREQ and quit
         IF (DOLIST) THEN
            CALL TI32IL (1, HW(9+IFND),  PTS, NOTIBM)
            CALL TI32IL (1,HW(6+IFND), FWVAR, NOTIBM)
            BFREQ(1) = FWVAR * TWOM16
            GO TO 600
         ENDIF
C
C      If we want redundant baselines we should skip XY and YX
C
         IF (((DATYP.EQ.'XY') .OR. (DATYP.EQ.'YX'))
     *          .AND. DOALL) GOTO 500
         IF (ITAPVR .LE. 5) THEN
c                                Tape version 5
            DO 111 N=1,NRPOL
 111           NGSET(N) = NRPOL*NBAND + N
            DO 112 N=1,NRPOL
               IF (ISET.EQ.NGSET(N)) GOTO 115
 112           CONTINUE
C                               Skip rest of tape
               IF (ISET.GT.NGSET(NRPOL)) GOTO 510
            GOTO 500
            END IF
         IF (ITAPVR .GE. 6) THEN
C                                                Tape version 6
            NOBAND = CW(11)
            IF (NOBAND.LT.CBAND) THEN
C                                                Read some more tape
               GOTO 500
            ELSE IF (NOBAND.EQ.CBAND) THEN
C                                               process this set
               GOTO 115
            ELSE IF (NOBAND.GT.EBAND) THEN
C                                               skip rest of tape
               GOTO 510
            ELSE
C                                               NOBAND>CBAND
               CBAND = CBAND + IBAND
               JBAND = JBAND + 1
               IF (CBAND .EQ. NOBAND) GOTO 115
               GOTO 500
            ENDIF
         END IF
 115     CONTINUE
         DO 118 IPOL = 1, 4
            IF (DATYP.EQ.CPOL(IPOL)) GO TO 120
 118     CONTINUE
            WRITE (MSGTXT, 1250) DATYP
            GO TO 980
C                                              poltype ok
 120     CONTINUE
         CALL TI32IL (1, HW(2+IFND), XNREC, NOTIBM)
         CALL TI32IL (1, HW(9+IFND),   PTS, NOTIBM)
         IF (PTS.EQ.0) PTS=57600
C
C   Shall we print something?
         PBAND = MOD (JBAND, 5)
         IF ((PBAND .EQ. 0) .OR. (CBAND+IBAND .GT. EBAND)) THEN
            IF (PBAND .EQ. 0) PBAND = 5
            PBAND = 1 - PBAND
            WRITE (MSGTXT, 1071) DATYP, (CBAND+I*IBAND, I=PBAND,0)
            CALL MSGWRT (5)
         ENDIF
C
C                                        Freq in Hz
         CALL TI32IL (1,HW(6+IFND), FWVAR, NOTIBM)
         BFREQ(JBAND) = FWVAR * (1.D6) * TWOM16
         XFREQ = 1.E-9 * BFREQ(JBAND)
C    what is at HW(15+IHND) ??? this cannot be the BANDW
C    so it's better to take the old value of BANDW
C    (that was computed some 140 lines ago)
C         CALL TI32IL (1, HW(7+IFND), FWVAR, NOTIBM)
C         FWVAR = CW(15)
C         BANDW = FLOAT (FWVAR) * 100.0
         TPTS = PTS
         WVSMAX = 1.5 * PTS
C                                         Loop through interforms
         NITER = 0
         NREC = XNREC
         DO 400 ITER = 1, NRINT
C                                       IH record starts new block in
C                                       format 6 tapes.
C
C set NREC >> 30 to force GTREC to make a call to TAPIO
            IF (ITER.EQ.1 .AND. ITAPVR.GE.6)  nrec=32000
C                                         IH Record (not registered
C                                          in block for format <=5)
            CALL GTREC (NOTIBM, JERR)
            IF (JERR.NE.0) GOTO 960
            IRTYPE = 5
            CALL ZC8CL (2, 3, HW(FI), CHTEMP)
            IF (.NOT.NOTIBM)  THEN
               CALL ZCHEBC(2, CHTEMP, CHTEMP)
            ENDIF
            IF (CHTEMP .NE. TTYPE(IRTYPE)) THEN
               WRITE (MSGTXT, 1140) CHTEMP
               ERROR = 1
               GO TO 980
            END IF
            NWTEL = CW(HI+12)
            NOTEL = CW(HI+13)
C do all interferometers or only standard interferometers ...
            IF (DOALL) THEN
               INTOK = .TRUE.
            ELSE
               CALL INTCHK (NWTEL, NOTEL, INTOK)
            END IF
C
C                                   ignore IH-blocks 92..96 and
C                                   telescp. numbers >= 15
            NWTEL = NWTEL + 1
            NOTEL = NOTEL + 1
            INTOK = (INTOK) .AND. (MAX(NWTEL,NOTEL) .LE. 14)
            IF (INTOK) THEN
               NITER = NITER + 1
C                               Only calculate baselines etc. for 1st band
               IF (JBAND .EQ. 1) THEN
                  BASNO(NITER) = NOTEL + 256. * NWTEL
                  BASLIN(NITER) = POST(NOTEL) - POST(NWTEL)
C                                    Baseline in light seconds
                  BASLIN(NITER) = BASLIN(NITER)*TWOM16*SPDLIT
C                                   Start hour angle
                  CALL ZINR32 (CW(HI+18), EPVAR, NOTIBM)
                  SHA(NITER) = EPVAR * TWOPI
C                                   Delta hour angle
                  CALL ZINR32 (CW(HI+22), EPVAR, NOTIBM)
                  DHA(NITER) = EPVAR * TWOPI
C                                   Calc integration time from HA-step
                  IF (SYS52) IINT(NITER)=NINT(EPVAR*360*240*DAYRAT)
C                                   Number of data points
                  NDATP(NITER) = CW(HI+25)
C                                   The rest for each band
               ENDIF
C
C                                  Scaling factor 0.005 to get from w.u.
C                                  to Jy.
C                                  Appropriate factors for polarization
C                                  are taken care of in VISIN
               SCAL = FLOAT( CW(HI+28) ) * 0.005
               EXP  = 2.0**CW(HI+27)
               PSCAL(NITER,IPOL,JBAND) = SCAL*EXP
               POFF (NITER,IPOL,JBAND) = FLOAT( CW(HI+29))
C                                  Integration time in sec
               IF (.NOT.SYS52) IINT(NITER) = CW(HI+54)
               STRTRC(NITER, IPOL,JBAND) = BLKCNT
C                                  Got parameters for wanted baselines
            END IF
C                                               find # data blocks
            NDB = CW(HI+24)
            DO 300 IBLK = 1, NDB
               CALL GTREC (NOTIBM, JERR)
               IF (JERR.NE.0) GO TO 960
C                                               Don't write red.ifm's
                  IF (INTOK) THEN
                     CALL PUTBLK (IBLK, NDB, BLKCNT, CW, HI, JERR)
                     IF (JERR.NE.0) THEN
                        ERROR = 3
                        GO TO 999
                     END IF
                  END IF
 300        CONTINUE
 400     CONTINUE
C
C       UPDATE THE NUMBER OF INTERFEROMETERS IN CASE THE REDUNDANT
C       BASELINES WERE SKIPPED, or if nrint contains some dummy
C       ih-blocks (92..96)
C
        NRINT = NITER
C                                        do NEXT SET
 500  CONTINUE
C
 510  ERROR = 0
C                                       write info about tapeversion,
C                                       # of set, # of intfm's .. e.a.
         NRINT = NITER
         WRITE (MSGTXT, 1200) SOURSE, XFREQ, TPTS
         CALL MSGWRT (5)
      GO TO 999
C                                       Skip three files for listimg
 600  CONTINUE
      DPVAR = BASLM(11) - BASLM(10)
      WDATE(1) = WDATE(1) + 1900
      WRITE (MSGTXT, 1600) SOURSE, HAST, HAEND, DPVAR
      CALL MSGWRT(5)
      WRITE (MSGTXT, 1601) BFREQ(1), RA1, DEC1, WDATE(1)
      CALL MSGWRT(5)
      WRITE (MSGTXT, 1602) WDATE(4), WDATE(3), WDATE(2),
     *          WDATE(5), WDATE(6)
      CALL MSGWRT(5)
      WRITE(MSGTXT, 1603) NFREQ, DFREQ, NRPOL, BACK
      CALL MSGWRT(5)
      NFILES = 3
      CALL TAPIO ('CLOS', FDVEC(1), HW, IFND, IERR)
      CALL TAPIO ('OPRD', FDVEC(1), HW, IFND, IERR)
      CALL ZTAPE ('ADVF', FDVEC(1), FDVEC(40), NFILES, IERR)
      XFILES = XFILES + 1.
      IF (IERR .EQ. 0) GO TO 20
      ERROR = 0
      GOTO 999
 950  CONTINUE
      ERROR = 1
      WRITE (MSGTXT, 1950) CHTEMP, TTYPE(IRTYPE)
      GO TO 980
 960  ERROR = 1
      IF (JERR.EQ.8) THEN
         GOTO 999
      ELSE IF (JERR .EQ. 4 .AND. DOLIST) THEN
         MSGTXT = '    End of Tape '
         ERROR = 0
      ELSE
         WRITE (MSGTXT, 1960) JERR
      ENDIF
      GO TO 980
 985  WRITE (MSGTXT, 1076) DONOTST
      ERROR = 1
      GOTO 980
 980  CALL MSGWRT (8)
      GO TO 999
 999  CONTINUE
      RETURN
C-----------------------------------------------------------------------
 1005 FORMAT ('1st Band#: ',I3,', Last Band#: ',I3,', Band Inc: ',I3)
 1050 FORMAT('SRT2SC:FOUND ',A,' INSTEAD OF ',A)
 1065 FORMAT('W',I7)
 1068 FORMAT ('  Label ',I4, ' Volume ',A,'  ',A,' Format Tape')
 1071 FORMAT('For Polarization ', A, ' Found Bands ', 5(I3,','))
 1072 FORMAT('SRT2SC: DOALL =',F3.0,'! SEE EXPLAIN WSLOD ',
     *        'FOR INFO ON HOW TO GET I, Q, U AND V !')
 1073 FORMAT('SRT2SC: TAPE VERSION',I5,' HAS NO REDUNDANT',
     * ' BASELINES!')
 1074 FORMAT(I2,'/',I2,'/',I2)
 1075 FORMAT('SRT2SC: NO PARALLEL DIPOLES! REDUNDANT BASELINE',
     *        ' INFORMATION NOT USEFUL!')
 1076 FORMAT('SRT2SC: INVALID VALUE FOR DOALL: ',F3.0)
 1140 FORMAT('SRT2SC: CANT FIND IH BLOCK ',A)
 1200 FORMAT('For ',A, ' at ',F9.6,' Ghz found',
     :  I9,' vis pts')
 1250 FORMAT('SRT2SC: WHAT IS POLTYPE ',A)
 1600 FORMAT(A,' HA=', F6.2,' ->',F6.2, ' Baseline 9A=',F5.1, ' meters')
 1601 FORMAT('  Chan 0=', F9.3, ' MHz, RA=', F9.5,
     *   '  Dec=', F9.5, ' (' , I4, ')' )
 1602 FORMAT('  Obsdate ',I2,'/',I2,'/',I2,' Obstime ',I2,':',I2)
 1603 FORMAT(I5,' Freq. Chans. at ',F7.1,' kHz  '
     *,I2,' Pol. Channels ', ' Backend ',A)
 1950 FORMAT('SRT2SC:FOUND RECORD ',A,' INSTEAD OF ',A)
 1960 FORMAT('SRT2SC: TAPE READ ERROR ',I6)
C
      END
C
C
C
      SUBROUTINE GTREC (NOTIBM, IERR)
C-----------------------------------------------------------------------
C     While reading IH and DB records, decide if we
C     need a new block, and get it if necessary.  In
C     any case, set some pointers.
C     If NOTIBM is true, the bytes on the tape are in VAX order
C     (small byte first), otherwise IBM order (bigendian)
C     IERR                   0 : ok
C                         1..6 : error in TAPIO
C                            8 : error in counting # of records
C-----------------------------------------------------------------------
      INTEGER IERR
      INTEGER   NREC, HI, FI, NBYTES, DI, IHND
      LOGICAL   NOTIBM
      INCLUDE 'WSLOD.INC'
      INCLUDE   'INCS:DMSG.INC'
      COMMON    /TAPCOM/ NREC, HI, FI, IHND, NBYTES
C-----------------------------------------------------------------------
C If NREC < 0 then there is something wrong.
C
      IF (NREC .LE. 0) THEN
         WRITE (MSGTXT, 1100) NREC
         CALL MSGWRT (8)
         IERR = 8
         GOTO 999
      END IF
C
      IF (NREC.LT.30) GO TO 100
         CALL TAPIO ('READ', FDVEC, HW, IHND, JERR)
         IF (IERR.NE.0) GO TO 999
         CALL TI16IL (1920, HW(IHND), CW, NOTIBM)
         NREC = 0
         FI = IHND - 32
 100     NREC = NREC + 1
C                       HI is pointer to first integer in record in CW
c                       FI is pointer to unflipped data in HW
      HI = 64 * (NREC - 1) + 1
      FI = FI + 32
 999  CONTINUE
      RETURN
C-----------------------------------------------------------------------
 1100 FORMAT('GETRC: LOST COUNT OF # OF RECORDS, NREC: ',I7)
      END
C
C
C
      SUBROUTINE SCRFIL ( MDB, IERR)
C-----------------------------------------------------------------------
C      Create a scratch file to hold native WSRT visibilities
C      MDB should be the number of 256 "AIPS BYTE" records we need
C-----------------------------------------------------------------------
      INTEGER MDB, IERR
      INTEGER   ISEQ
      INTEGER   WBUFF(256), ERRCNT
      INTEGER MDB4, ASIZE
      CHARACTER*48 PNAM
      LOGICAL   NOMAP, NOWAIT, EXCL
      INCLUDE 'WSLOD.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (WBUFF, BUFF1)
C
      DATA ISEQ /0/, IVER /1/
      DATA NOMAP, NOWAIT, EXCL /.FALSE.,.FALSE.,.TRUE./
C-----------------------------------------------------------------------
C               91 is a margin of safety, probably not needed
      MDB4 = 91 + MDB
C               convert to AIPS bytes
      MDB4 = 256 * MDB
      IVOL = 0
      ICNO = 1
      SNO  = 1
      CALL CATDIR ('OPEN', IVOL, ICNO, 'WSLOD       ',
     *          'SCRACH', SNO, 'SC',
     *   NLUSER, STAT, WBUFF, IERR)
      IF (IERR.EQ.0) GO TO 110
         WRITE (MSGTXT, 1110) IERR
         CALL MSGWRT (8)
         GO TO 999
 110  CONTINUE
      CALL ZPHFIL ('SC', IVOL, ICNO, IVER, PNAM, IERR)
C                                       Error count
      ERRCNT = 0
 112  CALL ZCREAT (IVOL, PNAM, MDB4, NOMAP, ASIZE, IERR)
         IF (IERR.EQ.0) GO TO 120
C         If no space on disk 1 try on disk 2
      IF (IERR.NE.3) GOTO 114
      IF (IVOL .GE. 2) GOTO 115
      CALL UNSCR
      ERRCNT = ERRCNT + 1
      IVOL = 2
      CALL ZPHFIL ('SC', IVOL, ICNO, IVER, PNAM, IERR)
      GOTO 112
C                                      Problem with dup name?
  114 CONTINUE
         IF ((IERR.NE.1) .OR. (ERRCNT.GT.0)) GO TO 115
            CALL UNSCR
            ERRCNT = ERRCNT + 1
            GO TO 112
 115        WRITE (MSGTXT, 1100) IERR
            CALL MSGWRT (8)
            GO TO 999
 120  CONTINUE
      CALL CATDIR ('CSTA', IVOL, ICNO, NAMPAK, CLSPAK, SNO, 'SC',
     *   NLUSER, 'CLWR', WBUFF, IERR)
      CALL ZOPEN (LUNDS, DINDS, IVOL,PNAM,NOMAP,EXCL,NOWAIT,  IERR)
         IF (IERR.EQ.0) GO TO 999
           WRITE (MSGTXT, 1200) IERR
           CALL MSGWRT (8)
 999  CONTINUE
      RETURN
C----------------------------------------------------------------------
 1100 FORMAT(' ZCREAT ERROR FOR SCRATCH ',I6)
 1110 FORMAT(' SCRATCH CATDIR ERROR ',I6)
 1200 FORMAT(' ZOPEN ERROR FOR SCRATCH ',I6)
      END
C
C
C
      SUBROUTINE PUTBLK (IBLK, NBLK, BLKCNT, BUFF, OFFS, IERR)
C-----------------------------------------------------------------------
C     Write out the Westerbork Data records, with blocking
C        into scratch file
C-----------------------------------------------------------------------
      INTEGER   IBLK, BLKCNT, BUFF(*), OFFS, IERR, IB
      INTEGER   NBLK
      INTEGER   HOLD(256)
      INCLUDE 'WSLOD.INC'
      INCLUDE 'INCS:DMSG.INC'
C
C-----------------------------------------------------------------------
      IB = MOD (IBLK, 4)
      IF (IB.EQ.0) IB = 4
      CALL COPY(64, BUFF(OFFS), HOLD(1+64*(IB-1)))
      IF ((IB.NE.4) .AND. (IBLK.NE.NBLK)) GO TO 999
         CALL ZFIO ('WRIT', LUNDS, DINDS, BLKCNT, HOLD, IERR)
         IF (IERR.EQ.0) GO TO 800
            WRITE (MSGTXT, 1000) IERR
            CALL MSGWRT (8)
            GO TO 999
 800     CONTINUE
      BLKCNT = BLKCNT + 1
 999  CONTINUE
      RETURN
C---------------------------------------------------------------------
 1000 FORMAT(' ZFIO ERROR IN PUTBLK ',I6)
      END
C
C
C
      SUBROUTINE UNSCR
C---------------------------------------------------------------------
C      Get rid of scratch files
C---------------------------------------------------------------------
      INTEGER   ISEQ, IERR
      INTEGER   WBUFF(256)
      CHARACTER*48 PNAM
      INCLUDE 'WSLOD.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (WBUFF, BUFF1)
C     DATA IVER /1/, ISEQ /1/
C---------------------------------------------------------------------
C     IVOL = 1
   10 CALL ZPHFIL ('SC', IVOL, ICNO, IVER, PNAM, IERR)
      CALL CATDIR ('CLOS', IVOL, ICNO, 'WSLOD       ',
     *  'SCRACH', 1,
     * 'SC', NLUSER, WBUFF, WBUFF, IERR)
      CALL ZDESTR (IVOL, PNAM, IERR)
        IF (IERR.EQ.0) GO TO 900
        IF (IVOL.LT.2) THEN
                IVOL = IVOL + 1
                GO TO 10
        END IF
        IF (IERR.EQ.1) THEN
                WRITE (MSGTXT, 1000)
                CALL MSGWRT (8)
                GO TO 900
        END IF
        IF (IERR.EQ.2) THEN
                WRITE (MSGTXT, 1001)
                CALL MSGWRT (8)
                GO TO 900
        END IF
        IF (IERR .GE. 3) THEN
                WRITE (MSGTXT, 1002)
                CALL MSGWRT (8)
        END IF
900     CONTINUE
        RETURN
C----------------------------------------------------------------------
 1000 FORMAT('UNSCR: COULD NOT FIND SCRATCH FILES FOR DESTROY')
 1001 FORMAT('UNSCR: COULD NOT DESTROY SCRATCH FILES')
 1002 FORMAT('UNSCR: ERROR',I3,' FROM ZDESTR')
C
      END
C
      SUBROUTINE DUMPAN (IMAXANT, IERR)
C-----------------------------------------------------------------------
C   DUMPAN creates an AN file and writes the AN common data to it.
C   Inputs: IMAXANT I*2   # antennas
C   Output: IERR    I*2   error code of TABINI/TABAN
C-----------------------------------------------------------------------
      INTEGER IMAXANT, IERR
      INTEGER   IABUF(512), NUMV(12)
      INTEGER   ANVER, FINDA, I, JERR, LUNA
      REAL      ABUF(256)
      CHARACTER*4 NAMSTA(14)
      DOUBLE PRECISION    A8BUF(128)
      DOUBLE PRECISION    DEG2RD, FREQ, JD
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'WSLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
C
      EQUIVALENCE (IABUF, ABUF, A8BUF)
C
      DATA ANVER, LUNA / 2, 30/
      DATA NUMV /8,3,0,1,1,1,1,1,3,1,1,3/
      DATA NAMSTA /'0   ','1   ','2   ','3   ','4   ','5   ','6   ',
     *             '7   ','8   ','9   ','A   ','B   ','C   ','D   '/
C-----------------------------------------------------------------------
      IERR  = 0
      DEG2RD= 3.141592653589793D0 / 180.0D0
C                                       Setup for AN table initization
      NUMORB = 0
      NOPCAL = 3
C                                       Position of the earth's pole
      POLRXY(1) = 0.0
      POLRXY(2) = 0.0
C                                       UT1UTC, IATUTC not used
      UT1UTC = 0.0
      IATUTC = 0.0
C                                       Array name
      ANAME = 'WSRT'
C                                       Array center (rel to center of
C                                       earth), not used.
      ARRAYC(1) = 3828440.6D0
      ARRAYC(2) = -445226.0D0
      ARRAYC(3) = 5064923.1D0
C                                       GST0 is not used ...
      CALL H2CHR (8, 1, CATH(KHDOB), RDATE)
      CALL JULDAY (RDATE, JD)
C     CALL GSTROT (JD, GSTIA0, GASTM, DEGPDY)
      GSTIA0   = 0.0D0
      DEGPDY   = 0.0D0
      FREQ     = CATD(KDCRV+2)
      ANFQID   = -1
C                                       Number of values in each column
C                                       in the AN table.
      CALL COPY (12, NUMV, ANNUMV)
C                                       Create/init file
      CALL ANTINI ('WRIT', IABUF, DISOUT, CCNO, ANVER, CATBLK, LUNA,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, FREQ,
     *   RDATE, POLRXY, UT1UTC, IATUTC, ANAME, NUMORB, NOPCAL, ANFQID,
     *   IERR)
      IF (IERR.NE.0) GO TO 990
C                                       init basic AN record
      ANNAME = 'WSRT'
      STAXOF    = 0.0
      STAXYZ(1) = 0.0D0
      STAXYZ(2) = 0.0D0
      STAXYZ(3) = 0.0D0
      ORBPRM(1) = 0.0D0
      NOSTA  = 0
      MNTSTA = 1
      POLAA  = 0.0
      POLAB  = 90.0
      CALL RFILL (3, 0.0, POLCA)
      CALL RFILL (3, 0.0, POLCB)
      POLTYA = 'X'
      POLTYB = 'Y'
      IF (IMAXANT.LE.0) GO TO 30
C                                       AN records
         DO 10 I = 1,IMAXANT
            STAXYZ(1) = -0.1155160D0 * BASLM(I)
            STAXYZ(2) = -0.9933060D0 * BASLM(I)
            STAXYZ(3) = 0.0D0
            ANNAME(5:8) = NAMSTA(I)
            NOSTA  = I
            IANRNO = I
            CALL TABAN ('WRIT', IABUF, IANRNO, ANKOLS, ANNUMV,
     *             ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF,
     *             POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
            IF (IERR.NE.0) GO TO 990
 10      CONTINUE
C                                       Close/update AN file.
 30   CALL TABIO ('CLOS', 1, IANRNO, ANNAME, IABUF, IERR)
      GO TO 999
C                                       Error
 990  CALL ZCLOSE (LUNA, FINDA, JERR)
C
 999  RETURN
      END
C
C
C
      SUBROUTINE INTCHK (NFIX,NMOV,IOK)
C----------------------------------------------------------------------
C     This routine checks whether INFNR is a WSRT standard inter-
C     ferometer or not.  If so, IOK is .TRUE., if not IOK is .FALSE.
C----------------------------------------------------------------------
      INTEGER   NFIX,NMOV
      LOGICAL   IOK
C
C
      IOK = .FALSE.
      IF (NFIX.LT.0 .OR. NFIX.GT.13) RETURN
      IF (NMOV.LT.0 .OR. NMOV.GT.13) RETURN
      IF (NFIX.LE.9 .AND. NMOV.GE.10) IOK = .TRUE.
      RETURN
      END
C
      SUBROUTINE TI16IL(NW, INBUF, OUTBUF, NOTIBM)
C----------------------------------------------------------------------
C Convert tape format I*2 integers to local integers.  Possible
C tape formats are IBM (2-s complement, big byte first) and VAX
C (2-s complement, small byte first)
c
C  INPUTS:
C               NW      I       Number of words to convert
C               INBUF   I*2(*)  Input array of tape integers
C               NOTIBM  L       .true. -> VAX format tape
C                               .false.-> IBM format
C  OUTPUT:      OUTBUF  I       Local Integers.  Should not be same
C                               as INBUF
C------------------------------------------------------------------------
      INTEGER   NW, INBUF(*), OUTBUF(*)
      LOGICAL   NOTIBM
      INTEGER   TEMBYT
      INCLUDE 'INCS:DDCH.INC'
C                                       Store BYTFLP
      TEMBYT  = BYTFLP
C                                       Fool ZI16IL about whether
C                                       We need to flip
      IF ((NOTIBM .AND. (BYTFLP .GT. 0))
     &    .OR. (.NOT.NOTIBM .AND. (BYTFLP .EQ. 0))) THEN
         BYTFLP = 0
      ELSE
         BYTFLP = 3
      ENDIF
C                               With BYTFLP temporarily changed, flip
C                               as necessary
      CALL ZI16IL (NW, 1, INBUF, OUTBUF)
C                               Restore
      BYTFLP = TEMBYT
C
      RETURN
      END
      SUBROUTINE TI32IL(NW, INBUF, OUTBUF, NOTIBM)
C----------------------------------------------------------------------
C Convert tape format I*4 integers to local integers.  Possible
C tape formats are IBM (2-s complement, big byte first) and VAX
C (2-s complement, small byte first)
c
C  INPUTS:
C               NW      I       Number of words to convert
C               INBUF   I*4(*)  Input array of tape integers
C               NOTIBM  L       .true. -> VAX format tape
C                               .false.-> IBM format
C  OUTPUT:      OUTBUF  I       Local Integers.  Can be same as INBUF
C  This version will work if BYTFLP = 0 (no flipping) or =3 (word and
C  byte swap as in VAXes).  It probably won't work for BYTFLP =1 or 2.
C------------------------------------------------------------------------
      INTEGER   NW, INBUF(*), OUTBUF(*)
      LOGICAL   NOTIBM
      INTEGER   TEMBYT
      INCLUDE 'INCS:DDCH.INC'
C                                       Store BYTFLP
      TEMBYT  = BYTFLP
C                                       Fool ZI16IL about whether
C                                       We need to flip
      IF ((NOTIBM .AND. (BYTFLP .GT. 0))
     &    .OR. (.NOT.NOTIBM .AND. (BYTFLP .EQ. 0))) THEN
         BYTFLP = 0
      ELSE
         BYTFLP = 3
      ENDIF
C                               With BYTFLP temporarily changed, flip
C                               as necessary
      CALL ZI32IL (NW, 1, INBUF, OUTBUF)
C                               Restore
      BYTFLP = TEMBYT
C
      RETURN
      END
C
      SUBROUTINE ZINR32 (TINT, LOCAL, FRMVAX)
C----------------------------------------------------------------------
C       Convert a tape single precision floating point number, stored
C       as the least sig. 2 bytes in two local integers.  These
C       are assumed already flipped etc. as necessary by TI16IL.
C----------------------------------------------------------------------
      INTEGER NREAL
      LOGICAL FRMVAX
      INTEGER TINT(2)
      REAL LOCAL
C
      INTEGER SMASK, EXPMSK(2), MNTMSK(2), SIGN, EXPM, M2
      INTEGER MANT, TWO16
      INTEGER RTYPE, ZAND
      REAL TEMP
C
      DATA SMASK /32768/,
     *          EXPMSK /32640, 32512/,
     *          MNTMSK /127, 255/
C      DATA SMASK /Z8000/, EXPMSK /Z7F80/, MNTMSK /Z007F/
      DATA TWO16 /65536/
C      DATA TWO16 /Z00010000/
C
      IF (FRMVAX) THEN
         RTYPE = 1
      ELSE
         RTYPE = 2
      ENDIF
C
      SIGN = ZAND(TINT(1), SMASK)
      EXPM = ZAND(TINT(1), EXPMSK(RTYPE))
      M2   = ZAND(TINT(1), MNTMSK(RTYPE))
      IF (FRMVAX) THEN
C                       7 BIT, 128 BIASED EXPONENT
         EXPM = (EXPM/128) - 128
C                       BINARY POINT IS 8 PLACES TO RIGHT
         EXPM = EXPM - 8
C                       VIRTUAL BIT
          M2 = M2 + 128
       ELSE
C               rIGHT SHIFT EIGHT BITS, SUBTRACT BIAS OF 64, MULTIPLY
C               BY 4 (ibm EXP IS HEXADECIMAL) AND SUBTRACT 8 (BECAUSE
C               MANTISSA M2 IS ALREADY LEFT SHIFTED 8 BITS WRT
C               THE HEXADECIMAL POINT
         EXPM = (EXPM/64) - 264
      ENDIF
      LOCAL = M2 * 2.**EXPM
      MANT = TINT(2)
      IF (MANT .LT. 0)  MANT = MANT + TWO16
      EXPM = EXPM - 16
      LOCAL = LOCAL + MANT*2.**EXPM
      IF (SIGN .NE. 0) LOCAL = -LOCAL
C
      RETURN
      END
C
      SUBROUTINE ZINR64 (TINT, LOCAL, FRMVAX)
C----------------------------------------------------------------------
C       Convert a tape double precision float (VAX or IBM) into local
C       Double precision.  Assume that input is in the least significant
C       two bytes of 4 consecutive local integers, already flipped.
C----------------------------------------------------------------------
C
      LOGICAL FRMVAX
      INTEGER TINT(4)
      DOUBLE PRECISION LOCAL
      INTEGER NREAL
C
      INTEGER SMASK, EXPMSK(2), MNTMSK(2), SIGN, EXPM, M2
      INTEGER MANT, TWO16
      DOUBLE PRECISION TEMP
      INTEGER RTYPE

C
      DATA SMASK /32768/,
     *          EXPMSK /32640,32512/,
     *          MNTMSK /127, 255/
C      DATA SMASK /Z8000/, EXPMSK /Z7F80/, MNTMSK /Z007F/
      DATA TWO16 /65536/
C      DATA TWO16 /Z00010000/
C
      IF ( FRMVAX) THEN
         RTYPE = 1
      ELSE
         RTYPE = 2
      ENDIF
C
      SIGN = ZAND(TINT(1), SMASK)
      EXPM = ZAND(TINT(1), EXPMSK(RTYPE))
      M2   = ZAND(TINT(1), MNTMSK(RTYPE))
      IF (FRMVAX) THEN
         M2 = M2 + 128
         EXPM = (EXPM/128) - 128
         EXPM = EXPM - 8
      ELSE
         EXPM = (EXPM/64) - 264
      ENDIF
      LOCAL = M2 * 2.D0 ** EXPM
      DO I = 2, 4
         MANT = TINT(I)
         IF (MANT .LT. 0) MANT = MANT + TWO16
         EXPM = EXPM - 16
         LOCAL = LOCAL + MANT * 2.**EXPM
      ENDDO
      IF (SIGN .NE. 0) LOCAL = -LOCAL
C
      RETURN
      END
C
      SUBROUTINE ZCHEBC (NR_CH_IN_STRING, CH_IN, CH_OUT)
C-----------------------------------------------------------------------
C
C     Translates a character string from ascii to ebcdic
C
C-----------------------------------------------------------------------
      CHARACTER        CH_IN(*), CH_OUT(*)
      INTEGER          TABLE(0:255), J, NR_CH_IN_STRING, I
      DATA    (TABLE(J) , J=0,63) /
     *     0,    1,    2,    3,   92,    9,   92,  127,
     *   92,   92,   92,   11,   12,   13,   14,   15,
     *   16,   17,   18,   19,   92,   92,    8,   92,
     *   24,   25,   92,   92,   28,   29,   30,   31,
     *   92,   92,   92,   92,   92,   10,   23,   27,
     *   92,   92,   92,   92,   92,    5,    6,    7,
     *   92,   92,   22,   92,   92,   92,   92,    4,
     *   92,   92,   92,   92,   20,   21,   92,   26/
      DATA    (TABLE(J) , J=64,127) /
     *    32,   92,   92,   92,   92,   92,   92,   92,
     *    92,   92,   91,   46,   60,   40,   43,   33,
     *    38,   92,   92,   92,   92,   92,   92,   92,
     *   92,   92,   93,   36,   42,   41,   59,   94,
     *   45,   47,   92,   92,   92,   92,   92,   92,
     *   92,   92,  124,   44,   37,   95,   62,   63,
     *   92,   92,   92,   92,   92,   92,   92,   92,
     *   92,   96,   58,   35,   64,   39,   61,   34/
      DATA    (TABLE(J) , J=128,191) /
     *   92,   97,   98,   99,  100,  101,  102,  103,
     *  104,  105,   92,   92,   92,   92,   92,   92,
     *   92,  106,  107,  108,  109,  110,  111,  112,
     *  113,  114,   92,   92,   92,   92,   92,   92,
     *   92,  126,  115,  116,  117,  118,  119,  120,
     *  121,  122,   92,   92,   92,   92,   92,   92,
     *   92,   92,   92,   92,   92,   92,   92,   92,
     *   92,   92,   92,   92,   92,   92,   92,   92/
      DATA    (TABLE(J) , J=192,255) /
     *  123,   65,   66,   67,   68,   69,   70,   71,
     *   72,   73,   92,   92,   92,   92,   92,   92,
     *  125,   74,   75,   76,   77,   78,   79,   80,
     *   81,   82,   92,   92,   92,   92,   92,   92,
     *   92,   92,   83,   84,   85,   86,   87,   88,
     *   89,   90,   92,   92,   92,   92,   92,   92,
     *   48,   49,   50,   51,   52,   53,   54,   55,
     *   56,   57,   92,   92,   92,   92,   92,  255/
C=======================================================================
       DO I=1,NR_CH_IN_STRING
         CH_OUT(I) = CHAR (TABLE(ICHAR(CH_IN(I))))
      END DO
C
      RETURN
      END

      SUBROUTINE AMERGE (KEY1, KEY2, NREC, LREC, NSORT, NBUFF, LUN, VOL,
     *   FILCNO, LENBU, INBUF, OUTBUF, JERR)
C-----------------------------------------------------------------------
C! sorts by merging previously sorted blocks of records
C# Sort UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Merge orders records of REAL values by merging previously sorted
C   blocks of records.  Sorts on values offset by KEY1 and KEY2 from
C   the first word in each record.  KEY2 advances fastest.  Ordering is
C   into decreasing values of the keys.  Data is expected and is
C   returned in the first file defined by VOL and FILCNO.  Two cataloged
C   SC files are required.  Buffers should be 2*sector length greater
C   than the minimum size sufficient for single buffered operation.
C   Input:
C      KEY1,KEY2   I    Offsets in I   words from first word of sort key
C      NREC        I    Number of records to be merged.
C      LREC        I    Number of I   words in a record.
C      NSORT       I    Number of records in a block previously sorted
C                       (Should be a multiple of LENBU))
C      NBUFF       I    Number of input streams to be used in the merge
C                       (adj. array dim.; max. 20).
C      LUN(NBUFF,2)I    LUNs for work files, each is opened NBUFF times.
C      LENBU       I    The number of records per buffer.
C   In/out (order may be switched on output):
C      VOL(2)      I    Volumne numbers of the work disks.
C      FILCNO(2)   I    Catalog numbers of the work files. (type 'SC')
C   Output:
C      INBUF(LREC,LENBU,NBUFF)  R    Work buffer.
C      OUTBUF(LREC,LENBU)       R    Work buffer.
C      JERR        I    Return error code: 0 = OK.
C                       2 => open error
C                       3 => I/O error
C   Programmer: W. D. Cotton, Jan. 1981.
C-----------------------------------------------------------------------
      INTEGER   NBUFF, KEY1, KEY2, NREC, LREC, NSORT, LUN(NBUFF,2),
     *   VOL(2), FILCNO(2), LENBU, JERR
      REAL      INBUF(*), OUTBUF(*)
C
      LOGICAL   T, F, EOI, EMPTY(20)
      INTEGER   OBO, IBO, ISECSZ, IROFF, OROFF, IBIND(20), OBIND, IN,
     *   OUT, BUFSZ, OCNT, OPOINT, IFIRST, FIND(20,2), INIO(20),
     *   IPOINT(20), JIN(20), I, IERR, IFILE, IND1, IND2, IPASS, KIN,
     *   NEXT, NIOUT, NPASS, X2READ, XLEFT
      DOUBLE PRECISION XNREC, SECSZ
      CHARACTER FILE(2)*48
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA OROFF, IBO /0, 1/
C-----------------------------------------------------------------------
      CALL ZPHFIL ('SC', VOL(1), FILCNO(1), 1, FILE(1), IERR)
      CALL ZPHFIL ('SC', VOL(2), FILCNO(2), 1, FILE(2), IERR)
C                                       Get D   record count.
      XNREC = NREC
C                                       Determine number of merge passes
      NPASS = LOG (XNREC/NSORT) / LOG(1.0D0*NBUFF) + 1.0D0
      NPASS = MAX (NPASS, 1)
C                                       Open each file NBUFF times.
      JERR = 0
      DO 20 I = 1,NBUFF
         IFILE = 1
         CALL ZOPEN (LUN(I,1), FIND(I,1), VOL(1), FILE(1), T, F, T,
     *      IERR)
         IF (IERR.LE.0) GO TO 10
            WRITE (MSGTXT,1000) IERR, IFILE, I
            CALL MSGWRT (8)
            JERR = 2
            GO TO 999
 10      IFILE = 2
         CALL ZOPEN (LUN(I,2), FIND(I,2), VOL(2), FILE(2), T, F, T,
     *      IERR)
         IF (IERR.LE.0) GO TO 20
            WRITE (MSGTXT,1000) IERR, IFILE, I
            CALL MSGWRT (8)
            JERR = 2
            GO TO 999
 20      CONTINUE
      IN = 1
      OUT = 2
      BUFSZ = 2 * (LREC * LENBU + NBPS)
C                                       Begin pass loop
      DO 300 IPASS = 1,NPASS
C                                       Determine input section size.
         SECSZ = NSORT
         SECSZ = SECSZ * (REAL(NBUFF)**(IPASS-1))
C                                       If section size .GE. data base
C                                       exit
         IF (SECSZ.GE.NREC) GO TO 900
         NIOUT = LENBU
         OBO = 1
C                                       Initialize output
         CALL UVINIT ('WRIT', LUN(1,OUT), FIND(1,OUT), NREC, OROFF,
     *      LREC, NIOUT, BUFSZ, OUTBUF, OBO, OBIND, IERR)
         IF (IERR.EQ.0) GO TO 110
            WRITE (MSGTXT,1020) IERR,IPASS
            CALL MSGWRT (8)
            JERR = 3
            GO TO 999
 110     OPOINT = OBIND
         OCNT = 0
C                                       Set initial rec. offset
         IROFF = 0
         EOI = F
C                                       Begin section loop.
 120     CONTINUE
C                                       Initialize inputs
            DO 140 I = 1,NBUFF
C                                       Set # rec per call
               INIO(I) = LENBU
C                                       Set stream empty marker.
               EMPTY(I) = EOI
C                                       Check if this stream necessary.
               IF (EOI) GO TO 140
C                                       See how many rec. left.
               XLEFT = NREC - IROFF
               X2READ = XLEFT
               IF (XLEFT.GT.SECSZ) X2READ = SECSZ
               ISECSZ = X2READ
C                                       See if end-of-data this sec.
               IF (XLEFT.LE.SECSZ) EOI = T
               KIN = (I-1) * (BUFSZ/2) + 1
               JIN(I) = KIN
               CALL UVINIT ('READ', LUN(I,IN), FIND(I,IN), ISECSZ,
     *            IROFF, LREC, INIO(I), BUFSZ, INBUF(KIN), IBO,
     *            IBIND(I), IERR)
               IF (IERR.EQ.0) GO TO 130
                  WRITE (MSGTXT,1120) IERR, I, IPASS
                  CALL MSGWRT (8)
                  JERR = 3
                  GO TO 999
C                                       Update record offset.
 130           IROFF = ISECSZ + IROFF
C                                       First read
               CALL UVDISK ('READ', LUN(I,IN), FIND(I,IN), INBUF(KIN),
     *            INIO(I), IBIND(I), IERR)
               IPOINT(I) = IBIND(I) + KIN - 1
               IF (IERR.EQ.0) GO TO 140
                  WRITE (MSGTXT,1130) IERR, I, IPASS
                  CALL MSGWRT (8)
                  JERR = 3
                  GO TO 999
 140           CONTINUE
C                                       Begin loop merging sections.
 150        CONTINUE
C                                       Check that there is data left an
C                                       find first stream with data left
            DO 160 I = 1,NBUFF
               IF (EMPTY(I)) GO TO 160
                  IFIRST = I + 1
                  NEXT = I
                  GO TO 200
 160           CONTINUE
C                                       If you got here then you're out
C                                       data.  Unless an EOI was encoun
C                                       go back and initialize the
C                                       of sections.
            IF (.NOT.EOI) GO TO 120
C                                       Finished this pass.
         GO TO 290
C                                       Find next largest record.
 200     IF (IFIRST.GT.NBUFF) GO TO 230
            DO 220 I = IFIRST,NBUFF
               IF (.NOT.EMPTY(I)) THEN
                  IND1 = IPOINT(I) - 1
                  IND2 = IPOINT(NEXT) - 1
                  IF ((INBUF(IND1+KEY1).GT.INBUF(IND2+KEY1)) .OR.
     *               ((INBUF(IND1+KEY1).EQ.INBUF(IND2+KEY1)) .AND.
     *               (INBUF(IND1+KEY2).GT.INBUF(IND2+KEY2)))) THEN
                     NEXT = I
                     END IF
                  END IF
 220           CONTINUE
C                                       Copy to output buffer
 230     CALL RCOPY (LREC, INBUF(IPOINT(NEXT)), OUTBUF(OPOINT))
C                                       Update pointers and counters.
         IPOINT(NEXT) = IPOINT(NEXT) + LREC
         OPOINT = OPOINT + LREC
         INIO(NEXT) = INIO(NEXT) - 1
         NIOUT = NIOUT - 1
         OCNT = OCNT + 1
C                                       Check if time to write output
         IF (NIOUT.GT.0) GO TO 240
            NIOUT = OCNT
            OCNT = 0
            CALL UVDISK ('WRIT', LUN(1,OUT), FIND(1,OUT), OUTBUF, NIOUT,
     *         OBIND, IERR)
            OPOINT = OBIND
            IF (IERR.EQ.0) GO TO 240
               WRITE (MSGTXT,1230) IERR, IPASS
               CALL MSGWRT (8)
               JERR = 3
               GO TO 999
C                                       Update pointer.
C                                       Check if time to read input.
 240     IF (INIO(NEXT).GT.0) GO TO 150
            KIN = JIN(NEXT)
            CALL UVDISK ('READ', LUN(NEXT,IN), FIND(NEXT,IN),
     *         INBUF(KIN), INIO(NEXT), IBIND(NEXT), IERR)
            IF (IERR.EQ.0) GO TO 250
               WRITE (MSGTXT,1130) IERR, NEXT, IPASS
               CALL MSGWRT (8)
               JERR = 3
               GO TO 999
C                                       Update pointers and counter.
 250        IPOINT(NEXT) = IBIND(NEXT) + KIN - 1
C                                       Check for end of input.
            IF (INIO(NEXT).LE.0) EMPTY(NEXT) = T
C                                       Loop back for next record.
            GO TO 150
C                                       Finish write.
 290     NIOUT = -OCNT
         CALL UVDISK ('FLSH', LUN(1,OUT), FIND(1,OUT), OUTBUF, NIOUT,
     *      OBIND, IERR)
         IF (IERR.EQ.0) GO TO 295
            WRITE (MSGTXT,1230) IERR, IPASS
            CALL MSGWRT (8)
            JERR = 3
            GO TO 999
C                                       Switch input and output.
 295     IN = 3 - IN
         OUT = 3 - OUT
 300     CONTINUE
C                                       Close files.
 900  DO 910 I = 1,NBUFF
         CALL ZCLOSE (LUN(I,1), FIND(I,1), IERR)
         CALL ZCLOSE (LUN(I,2), FIND(I,2), IERR)
 910     CONTINUE
C                                       If output currently on file 2
C                                       switch names etc.
      IF (IN.EQ.2) CALL FSWTCH (FILE(1), FILE(2), VOL(1), VOL(2),
     *   FILCNO(1), FILCNO(2), IBO, OBO)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AMERGE: ERROR',I7,' OPENING FILE ',I3,' NUMBER ',I3)
 1020 FORMAT ('AMERGE: ERROR',I7,' INIT OUTPUT PASS',I4)
 1120 FORMAT ('AMERGE: ERROR',I7,' INIT INPUT FILE',I3,' PASS ',I2)
 1130 FORMAT ('AMERGE: READ ERROR',I7,' FILE ',I3,' PASS ',I3)
 1230 FORMAT ('AMERGE: WRITE ERROR',I7,' PASS ',I4)
      END

      SUBROUTINE TBDATA (OPER, IVOL, ISLOT, IERR)
C-----------------------------------------------------------------------
C! verbs to put/get table values
C# POPS-appl Ext-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2006-2007, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This routine reads and writes values from/to an AIPS table.
C   Inputs:
C      OPER    C*4  'READ' or 'WRIT' operation desired.
C      IVOL    I    Disk number
C      ISLOT   I    Catalog slot number
C   Common: (though adverbs in common)
C      INEXT     H*2  Table type (e.g. AN, SU)
C      INVER     R    the version number of the table.
C      KEYWORD  H*8   FITS keyword corresponding to a header value
C      KEYVALUE R(2)  Numeric value out/in
C      KEYSTRNG H*16  String value out/in
C      PIXXY    R(7)  Location in table:
C                     (1) = Row number
C                     (2) = Column number
C                     (3) = subscript or start character
C   Output:
C      IERR     I     Error code, 0=> OK else failed
C-----------------------------------------------------------------------
      CHARACTER OPER*4
      INTEGER   IVOL, ISLOT, IERR
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER PRGNAM*8, STVALU*16, TABTYP*2, NEWSTR*16, OLDSTR*16,
     *   HILINE*72, HILIN2*72, CDUM*1
      INTEGER   POTERR, IROUND, VER, IBUFF(512), TLUN, IKEY, NREC, NCOL,
     *   DATP(128,2), DATVI(XBPRSZ), ITYPE, NROW, ILEN, I, JERR, IROW,
     *   ICOL, ISUB, NCOPY, I1, I2, BITS(64), IHLUN, IERH, OLDVI, ITEMP,
     *   IDUM(2), LROW
      HOLLERITH DATVH(XBPRSZ), OLDVH(4)
      REAL      DATVR(XBPRSZ), OLDVR, SCRTCH(XBPRSZ), RDUM(2), DOHI
      DOUBLE PRECISION D, TEMPD, DATVD(XBPRSZ/2), OLDVD
      LOGICAL   DATVL(XBPRSZ), OLDVL, ISBLNK
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (DATVI, DATVR, DATVH, DATVD, DATVL)
      EQUIVALENCE (OLDVI, OLDVR, OLDVH, OLDVD, OLDVL)
      COMMON /AIPSCR/ DATVR, SCRTCH
      DATA TLUN, IHLUN /28,27/
      DATA PRGNAM /'TBDATA'/
C-----------------------------------------------------------------------
      POTERR = 0
C                                       Read CATBLK
      CALL CATIO ('READ', IVOL, ISLOT, CATBLK, 'REST', IBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         IF (IERR.EQ.5) MSGTXT = 'FILE IS BUSY'
         POTERR = 33
         GO TO 970
         END IF
C                                       Open table
      IKEY = 1
      NREC = 10
      NCOL = 0
      CALL ADVERB ('INEXT', 'C', 1, 2, IDUM, RDUM, TABTYP)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INVERS', 'I', 1, 0, IDUM, RDUM, CDUM)
      VER = IDUM(1)
      IF (ERRNUM.NE.0) GO TO 980
C                                       Find highest if no version given
      IF (VER.LE.0) CALL FNDEXT (TABTYP, CATBLK, VER)
C                                       Open table
      CALL TABINI (OPER, TABTYP, IVOL, ISLOT, VER, CATBLK, TLUN,
     *   IKEY, NREC, NCOL, DATP, IBUFF, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1100) IERR, OPER, TABTYP, VER
         POTERR = 61
         GO TO 970
         END IF
      NROW = IBUFF(5)
C                                       Set row, col, etc.
      CALL ADVERB ('PIXXY', 'I', 7, 0, BITS, RDUM, CDUM)
      IROW = MAX (BITS(1), 1)
      ICOL = MAX (BITS(2), 1)
      ISUB = MAX (BITS(3), 1)
C                                       Check values: row number
      IF (IROW.GT.NROW) THEN
         WRITE (MSGTXT,1120) IROW, NROW
         CALL MSGWRT (7)
         IERR = 2
         POTERR = 32
         GO TO 800
         END IF
C                                       Column number
      IF (ICOL.GT.NCOL) THEN
         WRITE (MSGTXT,1130) ICOL, NCOL
         CALL MSGWRT (7)
         IERR = 2
         POTERR = 32
         GO TO 800
         END IF
C                                       Subscript
      ILEN = DATP(ICOL,2) / 10
      IF (ISUB.GT.ILEN) THEN
         WRITE (MSGTXT,1140) ISUB, ILEN
         CALL MSGWRT (7)
         IERR = 2
         POTERR = 32
         GO TO 800
         END IF
C                                       Check array size
      IF (ILEN.GT.MAXCIF) THEN
         WRITE (MSGTXT,1150) ILEN, MAXCIF
         CALL MSGWRT (7)
         IERR = 2
         POTERR = 32
         GO TO 800
         END IF
      ITYPE = MOD (DATP(ICOL,2), 10)
      LROW = 0
C                                       TABPUT
      IF (OPER.EQ.'WRIT') THEN
C                                       Get current entry
         CALL GETCOL (IROW, ICOL, DATP, LROW, IBUFF, ITYPE, DATVI,
     *      SCRTCH, IERR)
         ITYPE = MOD (ITYPE, 10)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1500) IERR, OPER
            CALL MSGWRT (7)
            POTERR = 61
            GO TO 800
            END IF
C                                       Blank?
         CALL ADVERB ('KEYSTRNG', 'C', 1, 16, IDUM, RDUM, STVALU)
         IF (ERRNUM.NE.0) GO TO 800
         ISBLNK = STVALU(:7) .EQ. 'BLANKED'
C                                       Enter data in VALUE via
C                                       EQUIVALENCE
         CALL ADVERB ('KEYVALUE', 'R', 2, 0, IDUM, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 800
         CALL POPSRD ('R2D', RDUM, TEMPD)
C                                       Double precision
         IF (ITYPE.EQ.1) THEN
            OLDVD = DATVD(ISUB)
            DATVD(ISUB) = TEMPD
            IF (ISBLNK) DATVD(ISUB) = DBLANK
C                                       Single precision
         ELSE IF (ITYPE.EQ.2) THEN
            OLDVR = DATVR(ISUB)
            DATVR(ISUB) = RDUM(1)
            IF (ISBLNK) DATVR(ISUB) = FBLANK
C                                       Character strings
         ELSE IF (ITYPE.EQ.3) THEN
            NCOPY = ILEN - ISUB + 1
            NCOPY = MIN (NCOPY, 16)
            CALL CHCOPY (NCOPY, ISUB, DATVH, 1, OLDVH)
            CALL CHR2H (NCOPY, STVALU, ISUB, DATVH)
C                                       Integers
         ELSE IF (ITYPE.EQ.4) THEN
            OLDVI = DATVI(ISUB)
            DATVI(ISUB) = IROUND (RDUM(1))
C                                       Logicals
         ELSE IF (ITYPE.EQ.5) THEN
            OLDVL = DATVL(ISUB)
            DATVL(ISUB) = STVALU(:1).EQ.'T'
C                                       Bit arrays
         ELSE IF (ITYPE.EQ.7) THEN
            I1 = ((ISUB-1) / NBITWD) + 1
            I2 = (ISUB-1)
            I2 = MOD (I2, NBITWD) + 1
            CALL ZGTBIT (NBITWD, DATVI(I1), BITS)
            OLDVL = BITS(I2).EQ.1
            BITS(I2) = 0
            IF (STVALU(:1).EQ.'T') BITS(I2) = 1
            CALL ZPTBIT (NBITWD, DATVI(I1), BITS)
            END IF
C                                       Write value
         CALL PUTCOL (IROW, ICOL, DATP, LROW, IBUFF, DATVI, SCRTCH,
     *      IERR)
C                                       Force it to disk
         IF (IERR.EQ.0) CALL PUTCOL (0, ICOL, DATP, LROW, IBUFF, DATVI,
     *      SCRTCH, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1500) IERR, OPER
            CALL MSGWRT (7)
            POTERR = 61
            GO TO 800
            END IF
C                                       TABGET
      ELSE IF (OPER.EQ.'READ') THEN
C                                       Read value
         CALL GETCOL (IROW, ICOL, DATP, LROW, IBUFF, ITYPE, DATVI,
     *      SCRTCH, IERR)
         ITYPE = MOD (ITYPE, 10)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1500) IERR, OPER
            CALL MSGWRT (7)
            POTERR = 61
            GO TO 800
            END IF
C                                       Initialize results
         RDUM(1) = 0.0
         RDUM(2) = 0.0
         STVALU = ' '
C                                       Put value back into adverbs
C                                       Double precision
         IF (ITYPE.EQ.1) THEN
            CALL RCOPY (NWDPDP, DATVD(ISUB), D)
            ISBLNK = D.EQ.DBLANK
            IF (ISBLNK) THEN
               STVALU = 'BLANKED'
            ELSE
               CALL POPSRD ('D2R', RDUM, D)
               END IF
C                                       Real
         ELSE IF (ITYPE.EQ.2) THEN
            ISBLNK = DATVR(ISUB).EQ.FBLANK
            IF (ISBLNK) THEN
               STVALU = 'BLANKED'
            ELSE
               RDUM(1) = DATVR(ISUB)
               END IF
C                                       Character
         ELSE IF (ITYPE.EQ.3) THEN
            NCOPY = ILEN - ISUB + 1
            NCOPY = MIN (NCOPY, 16)
            CALL H2CHR (NCOPY, ISUB, DATVH, STVALU)
C                                       Integer
         ELSE IF (ITYPE.EQ.4) THEN
            RDUM(1) = DATVI(ISUB)
C                                       Logical
         ELSE IF (ITYPE.EQ.5) THEN
            IF (DATVL(ISUB)) THEN
               STVALU = 'T'
            ELSE
               STVALU = 'F'
               END IF
C                                       Bit arrays
         ELSE IF (ITYPE.EQ.7) THEN
            I1 = ((ISUB-1) / NBITWD) + 1
            I2 = (ISUB-1)
            I2 = MOD (I2, NBITWD) + 1
            CALL ZGTBIT (NBITWD, DATVI(I1), BITS)
            IF (BITS(I2).EQ.1) THEN
               STVALU = 'T'
            ELSE
               STVALU = 'F'
               END IF
            END IF
         CALL ADVRBS ('KEYVALUE', 'R', 2, 0, IDUM, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 800
         CALL ADVRBS ('KEYSTRNG', 'C', 1, 16, IDUM, RDUM, STVALU)
         IF (ERRNUM.NE.0) GO TO 800
         END IF
C                                       Close table
 800  CALL TABIO ('CLOS', 1, I, SCRTCH, IBUFF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1800) JERR, TABTYP, VER
         IF (POTERR.EQ.0) POTERR = 61
         IF (IERR.EQ.0) IERR = JERR
         GO TO 970
         END IF
C                                       Any history
      CALL ADVERB ('DOHIST', 'R', 1, 0, IDUM, RDUM, CDUM)
      DOHI = RDUM(1)
      IF (ERRNUM.NE.0) GO TO 980
      IF ((OPER.EQ.'WRIT') .AND. (DOHI.GT.-1.5)) THEN
C                                       Open history file
         CALL HIOPEN (IHLUN, IVOL, ISLOT, IBUFF, IERH)
         IF (IERH.NE.0) GO TO 980
C                                       Which table?
         WRITE (HILINE,2800) TSKNAM, 'TABPUT', TABTYP, VER
         CALL HIADD (IHLUN, HILINE, IBUFF, IERH)
C                                       Add entries by type
C                                       Double precision
         IF (ITYPE.EQ.1) THEN
            WRITE (HILINE,2801) TSKNAM, 'TABPUT',IROW, ICOL, ISUB, TEMPD
            WRITE (HILIN2,3801) TSKNAM, 'TABPUT', OLDVD
C                                       Either blanked?
            IF (ISBLNK) WRITE (HILINE,4801) TSKNAM, 'TABPUT', IROW,
     *         ICOL, ISUB
            IF (OLDVD.EQ.DBLANK) WRITE (HILIN2,5801) TSKNAM, 'TABPUT'
C                                       Real
         ELSE IF (ITYPE.EQ.2) THEN
            WRITE (HILINE,2802) TSKNAM, 'TABPUT',IROW, ICOL, ISUB,
     *         RDUM(1)
            WRITE (HILIN2,3802) TSKNAM, 'TABPUT', OLDVR
C                                       Either blanked?
            IF (ISBLNK) WRITE (HILINE,4802) TSKNAM, 'TABPUT', IROW,
     *         ICOL, ISUB
            IF (OLDVR.EQ.FBLANK) WRITE (HILIN2,5802) TSKNAM, 'TABPUT'
C                                       Character
         ELSE IF (ITYPE.EQ.3) THEN
            NEWSTR = STVALU
            CALL H2CHR (16, 1, OLDVH, OLDSTR)
            WRITE (HILINE,2803) TSKNAM, 'TABPUT',IROW, ICOL, ISUB,
     *         NEWSTR
            WRITE (HILIN2,3803) TSKNAM, 'TABPUT', OLDSTR
C                                       Integer
         ELSE IF (ITYPE.EQ.4) THEN
            ITEMP = IROUND(RDUM(1))
            WRITE (HILINE,2804) TSKNAM, 'TABPUT',IROW, ICOL, ISUB, ITEMP
            WRITE (HILIN2,3804) TSKNAM, 'TABPUT', OLDVI
C                                       Logical
         ELSE IF (ITYPE.EQ.5) THEN
            NEWSTR = STVALU
            CALL H2CHR (1, 1, OLDVH, OLDSTR)
            WRITE (HILINE,2805) TSKNAM, 'TABPUT',IROW, ICOL, ISUB,
     *         NEWSTR(1:1)
            WRITE (HILIN2,3805) TSKNAM, 'TABPUT', OLDSTR(1:1)
C                                       Logical
         ELSE IF (ITYPE.EQ.7) THEN
            NEWSTR = STVALU
            IF (OLDVL) THEN
               OLDSTR = 'T'
            ELSE
               OLDSTR = 'F'
               END IF
            WRITE (HILINE,2807) TSKNAM, 'TABPUT',IROW, ICOL, ISUB,
     *         NEWSTR(1:1)
            WRITE (HILIN2,3807) TSKNAM, 'TABPUT', OLDSTR(1:1)
            END IF
C                                       Add history entries
         IF (IERH.EQ.0) CALL HIADD (IHLUN, HILINE, IBUFF, IERH)
         IF (IERH.EQ.0) CALL HIADD (IHLUN, HILIN2, IBUFF, IERH)
         CALL HICLOS (IHLUN, .TRUE., IBUFF, IERH)
         END IF
      GO TO 980
C-----------------------------------------------------------------------
C                                       Print error.
 970  CALL MSGWRT (8)
C                                       AIPS error management.
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.EQ.0) GO TO 999
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CATALOG READ ERROR',I5)
 1100 FORMAT ('TABINI ERROR ',I3,' OPEN FOR ',A4,1X,A2,', TABLE ',
     *   ' VER=',I3)
 1120 FORMAT ('ROW ',I6,' OUT OF RANGE (1:',I6,')')
 1130 FORMAT ('COLUMN ',I6,' OUT OF RANGE (1:',I6,')')
 1140 FORMAT ('SUBSCRIPT ',I6,' OUT OF RANGE (1:',I6,')')
 1150 FORMAT ('TABLE ENTRY SIZE ',I5,' TOO BIG FOR ARRAY ',I5)
 1500 FORMAT ('TABKEY ERROR',I3,1X,A,'ING TABLE VALUE')
 1800 FORMAT ('TABIO ERROR ',I3,' CLOSING ',A2,' TABLE VER=',I3)
 2800 FORMAT (A,':',A,': INEXT=''',A,''', INVERS=',I3,' /Table edited')
 2801 FORMAT (A,':',A,': PIXXY=',I8,2I5,',KEYVALUE=', 1PD20.12)
 3801 FORMAT (A,':',A,': / Old value =',1PD20.12)
 4801 FORMAT (A,':',A,': PIXXY=',I8,2I5,', KEYSTRNG=''BLANKED''')
 5801 FORMAT (A,':',A,': / Old value =''INDE''')
 2802 FORMAT (A,':',A,': PIXXY=',I8,2I5,',KEYVALUE(1)=',1PE15.5)
 3802 FORMAT (A,':',A,': / Old value =',1PE12.5)
 4802 FORMAT (A,':',A,': PIXXY=',I8,2I5,', KEYSTRNG=''BLANKED''')
 5802 FORMAT (A,':',A,': / Old value =''INDE''')
 2803 FORMAT (A,':',A,': PIXXY=',I8,2I5,',KEYSTRNG=''',A,'''')
 3803 FORMAT (A,':',A,': / Old value =''',A,'''')
 2804 FORMAT (A,':',A,': PIXXY=',I8,2I5,', KEYVALUE(1)=',I10)
 3804 FORMAT (A,':',A,': / Old value = ',I10)
 2805 FORMAT (A,':',A,': PIXXY=',I8,2I5,', KEYSTRNG=''',A,'''')
 3805 FORMAT (A,':',A,': / Old value =''',A,'''')
 2807 FORMAT (A,':',A,': PIXXY=',I8,2I5,', KEYSTRNG=''',A,'''')
 3807 FORMAT (A,':',A,': / Old value =''',A,'''')
      END

      SUBROUTINE ZMOUNR (MOUNT, IDRIVE, RDRIVE, IDENS, LPOPS, NUSER,
     *   MSG, SYSERR, IERR)
C-----------------------------------------------------------------------
C! mount or dismount remote magnetic tape device
C# Z2 Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004, 2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Issue software mount or dismount for a given tape drive - the lowest
C   level Z routine called by ZMOUNT.
C   Inputs:
C      MOUNT    I      Operation: 1 => mount, 0 => dismount
C      IDRIVE   I      Drive number - pseudo number used on local
C                      machine
C      RDRIVE   I      Drive number (on remote machine)
C      IDENS    I      Density
C      LPOPS    I      Pops number
C      NUSER    I      User AIPS number
C   Output:
C      MSG      C*80   Error message buffer - DO NOT USE MSGTXT
C      SYSERR   I      System error code (for ZERROR call)
C      IERR     I      Error return code: 0 => no error
C                         1 => error
C   Generic version - opens a virtual tape connection, sends the mount
C   or dismount command and closes the connection.
C-----------------------------------------------------------------------
      INTEGER   MOUNT, IDRIVE, RDRIVE, IDENS, LPOPS, SYSERR, IERR, NUSER
      CHARACTER MSG*80
C
      INTEGER   LUN, FIND, IBUF(26), JERR, I, JTRIM, ITRIM, J, NBACK,
     *   NBACKE, LRDRIV
      CHARACTER PNAME*48, XLATED*132, ICHR*1
      HOLLERITH HBUF(26), HLATED(32)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
      EQUIVALENCE (IBUF, HBUF)
      DATA NBACKE /21/
C-----------------------------------------------------------------------
      MSG = ' '
      SYSERR = 0
C                                       open the tape
      LUN = 129 - IDRIVE
C                                       Allocate area in FTAB for LUN.
      CALL LSERCH ('OPEN', LUN, FIND, .TRUE., JERR)
      IF (JERR.NE.0) THEN
C                                       LUN already in use.
         IF (JERR.EQ.2) THEN
            IERR = 1
            WRITE (MSGTXT,1001) LUN
C                                       No room in FTAB for LUN.
         ELSE IF (JERR.EQ.3) THEN
            IERR = 5
            WRITE (MSGTXT,1002) LUN
         ELSE
            IERR = 6
            WRITE (MSGTXT,1000) JERR, 'OPEN', LUN
            END IF
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Real tape
      PNAME = 'AMT0x:'
      CALL ZEHEX (IDRIVE, 1, PNAME(5:5))
      I = ITRIM (PNAME)
      CALL ZTRLOG (I, PNAME, 128, XLATED, J, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'ZMOUNR: UNABLE TO TRANSLATE LOGICAL NAME ='
         CALL MSGWRT (7)
         MSGTXT = '''' // PNAME(:I) // ''''
         CALL MSGWRT (7)
         MSGTXT = 'ZMOUNR: ZMOUNT/ZCRLOG MUST HAVE FAILED'
         CALL MSGWRT (7)
         GO TO 990
      ELSE IF (XLATED(:10).EQ.'DISMOUNTED') THEN
         IERR = 2
         MSGTXT =  'ZMOUNR: TAPE WAS NOT MOUNTED'
         CALL MSGWRT (7)
         GO TO 990
         END IF
C                                       remote drive number
      IF (MOUNT.GT.0) THEN
         LRDRIV = RDRIVE
      ELSE
         ICHR = XLATED(7:7)
         J = 0
         CALL ZHEX10 (ICHR, J, IERR)
         IF ((J.LE.0) .OR. (IERR.NE.0)) THEN
            IERR = 2
            MSGTXT = 'UNABLE TO DETERMINE REMOTE TAPE DRIVE NUMBER'
     *         // ' FROM LOGICAL NAME:'
            CALL MSGWRT (7)
            MSGTXT= XLATED
            CALL MSGWRT (7)
            GO TO 990
            END IF
         LRDRIV = J
         END IF
C                                       call ZVTPO2: open socket
      I = JTRIM (XLATED)
      CALL CHR2H (132, XLATED, 1, HLATED)
      CALL ZVTPO2 (FTAB(FIND+MOFF), I, HLATED, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (7)
         GO TO 990
         END IF
C                                       pack buffer: header
      CALL ZCLC8 (8, 'ZMOUNT  ', 1, HBUF)
      CALL ZILI32 (1, 5, 3, IBUF)
      CALL ZILI32 (1, 21, 4, IBUF)
      CALL ZILI32 (1, 0, 5, IBUF)
C                                       pack buffer: data
      CALL ZILI32 (1, MOUNT, 6, IBUF)
      CALL ZILI32 (1, LRDRIV, 7, IBUF)
      CALL ZILI32 (1, IDENS, 8, IBUF)
      CALL ZILI32 (1, LPOPS, 9, IBUF)
      CALL ZILI32 (1, NUSER, 10, IBUF)
C
      NBACK = NBACKE
      CALL ZVTPX2 (FTAB(FIND+MOFF), 5, NBACK, IBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (7)
      ELSE
         CALL ZI32IL (1, 5, IBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1025) IERR
            CALL MSGWRT (7)
            END IF
         END IF
      IF ((IERR.EQ.0) .AND. (NBACK.NE.NBACKE)) THEN
         WRITE (MSGTXT,1026) NBACK, NBACKE
         CALL MSGWRT (7)
         END IF
C                                       outputs
      CALL ZI32IL (1, 6, IBUF, SYSERR)
      CALL ZC8CL (80, 25, HBUF, MSG)
C                                       close
      CALL ZVTPC2 (FTAB(FIND+MOFF), JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1030) JERR
         CALL MSGWRT (7)
         IF (IERR.EQ.0) IERR = JERR
         END IF
C
 990  CALL LSERCH ('CLOS', LUN, FIND, .TRUE., JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZMOUNR: LSERCH ERROR ',I1,' FOR ',A4,' ON LUN = ',I3)
 1001 FORMAT ('ZMOUNR: LUN = ',I3,' ALREADY OPEN IN FTAB')
 1002 FORMAT ('ZMOUNR: NO ROOM IN FTAB FOR LUN = ',I3)
 1010 FORMAT ('ZMOUNR: UNABLE TO OPEN SOCKET TO REMOTE MACHINE, ERROR',
     *   I5)
 1020 FORMAT ('ZMOUNR: UNABLE TO TALK TO REMOTE TAPE DEVICE, ERROR',I5)
 1025 FORMAT ('ZMOUNR: UNABLE TO MOUNT REMOTE TAPE DEVICE, ERROR',I5)
 1026 FORMAT ('ZMOUNR: WARNING - GOT BACK',I3,' WORDS, EXPECTED',I3)
 1030 FORMAT ('ZMOUNR: UNABLE TO CLOSE SOCKET TO REMOTE MACHINE, ERROR',
     *   I5)
      END

      SUBROUTINE DMAP (DAT, DEQ, DELDAT, DEQRA, DEQDEC, DAPRA, DAPDEC,
     *   NR)
C-----------------------------------------------------------------------
C! Compute apparent position from mean position
C# Math Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Given are the mean equinox, mean position, and any Julian date.
C   Calculated is the apparent position for that Julian date.
C   Inputs: DAT    D    Julian date of the apparent place wanted
C           DEQ    D    mean equinox of given mean place
C           DELDAT D    interpolation interval (days)
C           DEQRA  D    given mean RA
C           DEQDEC D    given mean DEC
C   Output: DAPRA  D    apparent RA
C           DAPDEC D    apparent DEC
C-----------------------------------------------------------------------
      DOUBLE PRECISION    DAT, DEQ, DELDAT, DEQRA, DEQDEC, DAPRA, DAPDEC
      LOGICAL   NR
      INTEGER   IY, IM, ID, IWD, K
      DOUBLE PRECISION DS(4), DPRMAT(3,3), BDNS1(5), BDNS2(5),
     *   BDNDEL(5),
     *   SCRA(4), SCDEC(4), D1OLD, D2OLD, DEQOLD, DYQOLD, PI, TWOPI,
     *   PI2, DYQ, YQ, DYQRA, DYQDEC, PSIDEL, SPSI, SEPS, DELTIM, FACSC,
     *   APD, APMD, BPMC, SINRA, COSRA, TANDEC, DJ, DJP, X
      DATA D1OLD, D2OLD, DEQOLD, DYQOLD /4*0.D0/
C-----------------------------------------------------------------------
      PI = 4.D0 * ATAN(1.D0)
      TWOPI = PI + PI
      PI2 = .5D0 * PI
      CALL CLD (DAT, IY, IM, ID, IWD)
      DYQ = IY
      IF (IM.GE.7) DYQ = IY + 1
      YQ = DYQ
      IF ((DYQ.EQ.DYQOLD) .AND. (DEQ.EQ.DEQOLD)) GO TO 20
         DYQOLD = DYQ
         DEQOLD = DEQ
         IF (DYQ.NE.DEQ) CALL DPRE (DEQ, DYQ, DPRMAT)
 20   IF (DYQ.NE.DEQ) GO TO 30
         DYQRA = DEQRA
         DYQDEC = DEQDEC
         GO TO 40
 30   CONTINUE
         CALL DTRC (DPRMAT, DEQRA, DEQDEC, DYQRA, DYQDEC)
 40   IF ((DAT.GE.D1OLD) .AND. (DAT.LE.D2OLD)) GO TO 50
         D1OLD = DAT
         D2OLD = DAT + DELDAT
         CALL BDN (D1OLD, YQ, BDNS1, PSIDEL, SPSI, SEPS, NR)
         CALL BDN (D2OLD, YQ, BDNS2, PSIDEL, SPSI, SEPS, NR)
         DO 45 K = 1,5
            BDNDEL(K) = BDNS2(K) - BDNS1(K)
 45         CONTINUE
 50   CALL BSC (DAT, YQ, DYQRA, DYQDEC, SCRA, SCDEC)
      DELTIM = (DAT- D1OLD) / DELDAT
      DAPRA = DYQRA + BDNS1(5) + DELTIM * BDNDEL(5)
      DAPDEC = DYQDEC
      DO 60 K = 1,4
         FACSC = BDNS1(K) + DELTIM * BDNDEL(K)
         DS(K) = FACSC
         DAPRA = DAPRA + FACSC * SCRA(K)
         DAPDEC = DAPDEC + FACSC * SCDEC(K)
 60      CONTINUE
      APD = DS(1) + DS(4)
      IF (DYQDEC.LT.0D0) GO TO 70
         APMD = APD
         BPMC = DS(2) + DS(3)
         GO TO 80
 70   CONTINUE
         APMD = DS(1) - DS(4)
         BPMC = DS(2) - DS(3)
 80   SINRA = SIN (DYQRA)
      COSRA = COS (DYQRA)
      TANDEC = TAN (DYQDEC)
      DJ = (APD*SINRA + BPMC*COSRA) * (APMD*COSRA - BPMC*SINRA)
      DJP = -.5D0 * (APMD*SINRA + BPMC*COSRA) ** 2
      DAPRA = DAPRA + DJ * TANDEC ** 2
      DAPDEC = DAPDEC + DJP * TANDEC
      IF (ABS(DAPDEC).GT.PI2) DAPRA = DAPRA + PI
      DAPDEC = MOD (DAPDEC, TWOPI)
      IF (DAPDEC.GT.PI) DAPDEC = DAPDEC - TWOPI
      X = ABS(DAPDEC)
      IF (X.GT.PI2) X = PI - X
      DAPDEC = X * DAPDEC / ABS(DAPDEC)
      DAPRA = MOD (DAPRA, TWOPI)
C
 999  RETURN
      END

LOCAL INCLUDE 'PRTCC.INC'
      INCLUDE 'INCS:PUVD.INC'
      REAL      XSEQ, XDISK, XVER, XBCNT, XECNT, XINC, DOCRT, DOCELL
      HOLLERITH XINNAM(3), XINCLS(2), XLPNAM(12)
      CHARACTER INNAM*12, INCLS*6, LPNAME*48
      INTEGER   BCOUNT, ECOUNT, ICOUNT, DATP(128,2), BUFFER(512),
     *   INSEQ, INDISK, INVERS, CNO, IUSER, NKEY, NCOL, OUTLUN, OUTIND,
     *   NACROS, CCNUMV(MAXCCC), CCKOLS(MAXCCC), CCRNO, CCNCOL
      LOGICAL   ISUV, ISCX
C
      COMMON /INPARM/ XINNAM, XINCLS, XSEQ, XDISK, XVER, XBCNT, XECNT,
     *   XINC, DOCRT, XLPNAM, DOCELL
      COMMON /CHPARM / INNAM, INCLS, LPNAME
      COMMON /PRTCCC/ BCOUNT, ECOUNT, ICOUNT, DATP, BUFFER, INSEQ,
     *   INDISK, INVERS, CNO, IUSER, NKEY, NCOL, OUTLUN, OUTIND, NACROS,
     *   ISUV, CCNUMV, CCKOLS, CCRNO, CCNCOL, ISCX
LOCAL END
      PROGRAM PRTCC
C-----------------------------------------------------------------------
C! Prints clean component files on printer or terminal
C# EXT-util Map-util Printer
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1999, 2004, 2007-2009, 2016, 2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PRTCC is an AIPS task to print the contents of clean components
C   (tables format) extension files on the line printer or the CRT
C   terminal.
C   AIPS adverbs:                     Use:
C     INNAME     INNAM(3)     Image name: standard defaults, wildcards
C     INCLASS    INCLS(2)     Image class: ditto
C     INSEQ      XSEQ (INSEQ) Image sequence number: ditto
C     INDISK     XDISK (INDISK)  Image disk number: 0 -> any
C     INVERS     XVER (INVERS)   Extension version number
C     BCOUNT     XBCNT (BCOUNT)  First row number
C     ECOUNT     XECNT (ECOUNT)  Last row number
C     XINC       XINC (ICOUNT)   Increment between printed rows
C     DOCRT      DOCRT           > 0. => CRT, else line printer
C     OUTPRINT   LPNAME          File name to keep printer output in
C     DOCELL     DOCELL          > 0. => x,y in cells
C-----------------------------------------------------------------------
      INTEGER   IRET
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'PRTCC.INC'
C-----------------------------------------------------------------------
C                                       Get parms, open things
      CALL PRCCIN (IRET)
C                                       do printing
      IF (IRET.EQ.0) THEN
         CALL PRCCHK (IRET)
         IF (IRET.EQ.0) THEN
            IF (ISCX) THEN
               CALL PRCXDO (IRET)
            ELSE
               CALL PRCCDO (IRET)
               END IF
            END IF
         IRET = MAX (0, IRET)
         END IF
C                                       close down
      CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE PRCCIN (IRET)
C-----------------------------------------------------------------------
C   PRCCIN performs initialization for AIPS task PRTCC.  It gets the
C   adverbs, opens the catalog file for 'READ', opens the table
C   extension
C   file, and opens the output device.
C   Output:
C      IRET    I      Error code: 0 => keep going, else quit.
C-----------------------------------------------------------------------
      CHARACTER INTYP*2, STAT*4, PRGN*6
      INTEGER   IRET, I4T, NPARM, IROUND, TABLUN, IERR, SCRBUF(256),
     *   MVERS, NREC
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'PRTCC.INC'
      DATA TABLUN /27/
      DATA PRGN /'PRTCC '/
C-----------------------------------------------------------------------
C                                       AIPS init
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NCFILE = 0
      NSCR = 0
C                                       get adverbs
      NPARM = 25
      IRET = 0
      CALL GTPARM (PRGN, NPARM, RQUICK, XINNAM, SCRBUF, IERR)
      IF (IERR.EQ.0) GO TO 10
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
C                                       restart AIPS
 10   IF ((IRET.NE.0) .OR. (NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   DOCRT = MIN (-1.0, DOCRT)
      CALL H2CHR (48, 1, XLPNAM, LPNAME)
      IF (DOCRT.GT.0.0) RQUICK = .FALSE.
      IF (RQUICK) RQUICK = LPNAME.NE.' '
      IF (RQUICK) CALL RELPOP (IRET, SCRBUF, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       find image file
      CALL H2CHR (12, 1, XINNAM, INNAM)
      CALL H2CHR (6, 1, XINCLS, INCLS)
      INSEQ = IROUND (XSEQ)
      INDISK = IROUND (XDISK)
      INVERS = IROUND (XVER)
      ICOUNT = IROUND (XINC)
      BCOUNT = IROUND (XBCNT)
      ECOUNT = IROUND (XECNT)
      IF (ICOUNT.LE.0) ICOUNT = 1
      IF (BCOUNT.LE.0) BCOUNT = 1
      IUSER = NLUSER
      CNO = 1
      INTYP = ' '
      CALL CATDIR ('SRCH', INDISK, CNO, INNAM, INCLS, INSEQ, INTYP,
     *   IUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, INNAM, INCLS, INSEQ, INTYP,
     *      INDISK, IUSER
         GO TO 990
         END IF
C                                       Get catblk, mark file read
      CALL CATIO ('READ', INDISK, CNO, CATBLK, 'READ', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
      NCFILE = 1
      FVOL(1) = INDISK
      FCNO(1) = CNO
      FRW(1) = 0
      ISUV = INTYP.NE.'MA'
      CALL FNDEXT ('CC', CATBLK, MVERS)
      ISCX = MVERS.LE.0
      IF (ISCX) THEN
         CALL FNDEXT ('CX', CATBLK, MVERS)
         ISCX = MVERS.GT.0
         END IF
C                                       Open table file
      IF (ISCX) THEN
         CALL TABINI ('READ', 'CX', INDISK, CNO, INVERS, CATBLK, TABLUN,
     *      NKEY, NREC, NCOL, DATP, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR, 'CX', INVERS
            GO TO 990
            END IF
         CCNCOL = 4
      ELSE
         CALL CCMINI ('READ', BUFFER, INDISK, CNO, INVERS, CATBLK,
     *      TABLUN, CCRNO, CCKOLS, CCNUMV, CCNCOL, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR, 'CC', INVERS
            GO TO 990
            END IF
         END IF
      I4T = BUFFER(5)
      IF (BCOUNT.GT.I4T) BCOUNT = 1
      IF ((ECOUNT.LT.BCOUNT) .OR. (ECOUNT.GT.I4T)) ECOUNT = I4T
C                                       Open output device
      IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
      CALL LPOPEN (LPNAME, DOCRT, OUTLUN, OUTIND, NACROS, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' FINDING INPUT ADVERBS')
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,1X,A2,
     *   ' DISK=',I2,' USER=',I5)
 1020 FORMAT ('ERROR',I5,' READING CATBLK FROM CATALOG FILE')
 1030 FORMAT ('ERROR',I5,' OPENING ',A2,' TABLE VERS=',I6)
 1040 FORMAT ('ERROR',I5,' OPENING OUTPUT DEVICE')
      END
      SUBROUTINE PRCCHK (IRET)
C-----------------------------------------------------------------------
C   PRCCDO reads and counts lines to be printed for the CC table
C   Output:
C      IRET   I     Error code: 0 => OK or user terminates,
C                      2 => error writing, 3 => error reading
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER CCTITL(7)*8, SCRTCH*132, LONGS(4)*4, STR*4
      INTEGER   IRNO, MRNO, RESULT(66), IERR, OTYPE, IPAGE, I, N, NLINE,
     *   NCOUNT, TTY(2)
      LOGICAL   T
      REAL      RES4(66), BUFF4(512)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'PRTCC.INC'
      EQUIVALENCE (BUFFER, BUFF4)
      EQUIVALENCE (RESULT, RES4)
      DATA T /.TRUE./
      DATA LONGS /'GLON','GLAT','ELON','ELAT'/
      DATA CCTITL /'DELTAX  ', 'DELTAY  ', 'MAJOR AX', 'MINOR AX',
     *   'POSANGLE', 'TYPE OBJ', 'FLUX    '/
C-----------------------------------------------------------------------
C                                       init counters, line size
      IRET = 0
      IF ((LPNAME.NE.' ') .OR. (DOCRT.GT.0.0)) GO TO 999
      MSGTXT = 'Checking count of lines for direct output to printer'
      CALL MSGWRT (2)
C                                       Find format
      OTYPE = 5
      IF (NACROS.GE.80) OTYPE = OTYPE - 1
      IF (NACROS.GE.100) OTYPE = OTYPE - 1
      IF (NACROS.GE.120) OTYPE = OTYPE - 1
      IF (CCNCOL.LE.4) OTYPE = 1
C                                       Primary page: heading info
      IPAGE = 0
      NLINE = 899
      MRNO = BUFFER(5)
      NCOUNT = 0
      IF (ISUV) DOCELL = -1.0
      I = 100 + 1
      N = I + 13
C                                         First page
      IF (DOCRT.LE.-2.5) THEN
         NCOUNT = NCOUNT + 1
      ELSE
         NCOUNT = NCOUNT + 3
C                                       selection strings
         IF (BUFFER(61).GT.0) THEN
            N = BUFFER(61)
            NCOUNT = NCOUNT + 1 + N
            END IF
         END IF
C                                       Output the titles
      IF (DOCRT.GT.-2.5) NCOUNT = NCOUNT + 1
      NCOUNT = NCOUNT + 2
      IF ((DOCRT.GT.-2.5) .AND. (DOCRT.LE.0.0)) NCOUNT = NCOUNT + 1
C                                       Output loop
      DO 140 IRNO = 1,ECOUNT
         IF (MOD(IRNO-BCOUNT,ICOUNT).EQ.0) NCOUNT =  NCOUNT + 1
 140     CONTINUE
      NCOUNT = NCOUNT + 2
C                                       ask if needed
      IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) THEN
         IF (NCOUNT.GT.1000) THEN
            NLINE = -1
            CALL LPCLOS (OUTLUN, OUTIND, NLINE, IERR)
            IRET = -1
            END IF
      ELSE IF (NCOUNT.GT.500) THEN
         TTY(1) = 5
         CALL ZOPEN (TTY(1), TTY(2), 1, SCRTCH, .FALSE., .FALSE.,
     *      .TRUE., IRET)
         MSGTXT = 'PROBLEM OPENING TERMINAL'
         IF (IRET.GT.0) GO TO 990
         WRITE (SCRTCH,1150) NCOUNT
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, IRET)
         MSGTXT = 'PROBLEM DOING IO TO TERMINAL'
         IF (IRET.GT.0) GO TO 990
         SCRTCH = 'Do you really want to print this much??' //
     *      ' Enter Y or y if so'
         CALL INQSTR (TTY, SCRTCH, 1, STR, IRET)
         IF (IRET.GT.0) GO TO 990
         IF ((STR(:1).NE.'y') .AND. (STR(:1).NE.'Y')) THEN
            NLINE = -1
            CALL LPCLOS (OUTLUN, OUTIND, NLINE, IERR)
            IRET = -1
            SCRTCH = 'Good choice - save trees'
         ELSE
            SCRTCH = 'OKAY, printing anyway'
            END IF
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, I)
         CALL ZCLOSE (TTY(1), TTY(2), I)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1150 FORMAT ('Requested print job is',I10,' lines long!')
      END
      SUBROUTINE PRCCDO (IRET)
C-----------------------------------------------------------------------
C   PRCCDO reads, formats, and prints a table extension file
C   Output:
C      IRET   I     Error code: 0 => OK or user terminates,
C                      2 => error writing, 3 => error reading
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER CCTITL(8)*8, LABEL*5, TITL1*132, TITL2*132, LINE*132,
     *   SCRTCH*132, ATIME*8, ADATE*12, BTIME*8, BDATE*12, CCTYPE*4,
     *   SORTOR(5)*8, LONGS(4)*4, CHTMP*132, CHTM12*12, CCCHAR*1,
     *   SORTS(4)*8, MODTYP(5)*5
      INTEGER   IRNO, MRNO, FIRSTC, LRNO, RESULT(66), II, M1, IERR,
     *   INC, OTYPE, IPAGE, I, J, M, N, NLINE, JJ, M2, ITYPE
      LOGICAL   PFLAG, EQUAL, T, UPSUM, DOZZ
      REAL      RES4(66), BUFF4(512), SCALEX, SCALET, CCMAX,
     *   SCALES(8), OFFS(8), SUMDEL, XX, YY, ZZ, FLUX, PARMS(3), TFLUX
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'PRTCC.INC'
      EQUIVALENCE (BUFFER, BUFF4)
      EQUIVALENCE (RESULT, RES4)
      DATA T /.TRUE./
      DATA SORTOR /'ASCEND ','ASCEAB ','DESCND ','DESCAB ',' '/
      DATA LONGS /'GLON','GLAT','ELON','ELAT'/
      DATA CCTITL /'DELTAX', 'DELTAY', 'DELTAZ', 'MAJOR AX', 'MINOR AX',
     *   'POSANGLE', 'TYPE OBJ', 'FLUX    '/
      DATA MODTYP /'Point','Gauss','CGaus','Spher','?????'/
C-----------------------------------------------------------------------
C                                       init counters, line size
      IRET = 0
C                                       Find columns
      OTYPE = 5
      IF (NACROS.GE.80) OTYPE = OTYPE - 1
      IF (NACROS.GE.100) OTYPE = OTYPE - 1
      IF (NACROS.GE.120) OTYPE = OTYPE - 1
      IF (CCNCOL.LE.4) OTYPE = 1
      DOZZ = (CCNCOL.EQ.4) .OR. (CCNCOL.EQ.8)
C                                       Primary page: heading info
      IPAGE = 0
      NLINE = 899
      MRNO = BUFFER(5)
      SORTS(1) = ' '
      SORTS(2) = ' '
      SORTS(3) = ' '
      SORTS(4) = ' '
      II = 5
      JJ = 5
      IF (BUFFER(43).GT.0) II = 1
      IF (BUFFER(44).GT.0) JJ = 1
      IF (BUFFER(43).LT.0) II = 3
      IF (BUFFER(44).LT.0) JJ = 3
      IF (BUFFER(43).GT.256) II = 2
      IF (BUFFER(44).GT.256) JJ = 2
      IF (BUFFER(43).LT.-256) II = 4
      IF (BUFFER(44).LT.-256) JJ = 4
      SORTS(2) = SORTOR(II)
      SORTS(4) = SORTOR(JJ)
      I = ABS(BUFFER(43))
      IF (I.GT.256) I = I - 256
      J = ABS(BUFFER(44))
      IF (J.GT.256) J = J - 256
      N = 2
      IF (I.NE.0) THEN
         I = 257 + (BUFFER(128+I) - 1) * 6
         CALL H2CHR (8, 1, BUFF4(I), SORTS(1))
         END IF
      IF (J.NE.0) THEN
         J = 257 + (BUFFER(128+J) - 1) * 6
         CALL H2CHR (8, 1, BUFF4(J), SORTS(2))
         END IF
      CALL TIMDAT (BUFFER(14), BUFFER(11), ATIME, ADATE)
      CALL TIMDAT (BUFFER(36), BUFFER(33), BTIME, BDATE)
C                                       CC scaling - uv data
      IF (ISUV) THEN
         M1 = MIN (CCNCOL-1, 4)
         LRNO = 0
         CCMAX = 0.0
         DO 220 IRNO = 1,ECOUNT
            J = IRNO
            CALL TABCCM ('READ', BUFFER, J, CCKOLS, CCNUMV, CCNCOL, XX,
     *         YY, ZZ, FLUX, ITYPE, PARMS, IERR)
            IF (IERR.EQ.0) THEN
               CCMAX = MAX (CCMAX, ABS(XX))
               CCMAX = MAX (CCMAX, ABS(YY))
               END IF
 220        CONTINUE
         SCALET = CCMAX / 100.0 * 3600.0
         SCALEX = SCALET + 1.E-25
         CALL METSCA (SCALET, LABEL, PFLAG)
         SCALEX = 3600.0 * SCALET / SCALEX
C                                       find real RA/DEC axis : MA file
      ELSE
         INC = 2
         N = CATBLK(KIDIM)
         M1 = 0
         M2 = 0
         DO 30 I = 1,N
            J = KHCTP + (I-1) * INC
            CALL H2CHR (2, 1, CATH(J), CHTM12)
            IF (CHTM12(:2).EQ.'RA') M1 = I
            CALL H2CHR (3, 1, CATH(J), CHTM12)
            IF (CHTM12(1:3).EQ.'DEC') M2 = I
            DO 29 M = 1,4
               CALL H2CHR (4, 1, CATH(J), CHTM12)
               EQUAL = LONGS(M)(1:4).EQ. CHTM12(1:4)
               IF ((EQUAL) .AND. ((M.EQ.1) .OR. (M.EQ.3))) M1 = I
               IF ((EQUAL) .AND. ((M.EQ.2) .OR. (M.EQ.4))) M2 = I
 29            CONTINUE
            IF ((M1.GT.0) .AND. (M2.GT.0)) GO TO 35
 30         CONTINUE
         M1 = 1
 35      M = MAX (M1, M2) - 1
         SCALET = ABS(CATR(KRCIC+M)) * 3600.0
         SCALEX = SCALET + 1.E-25
         CALL METSCA (SCALET, LABEL, PFLAG)
         SCALEX = 3600.0 * SCALET / SCALEX
         END IF
      OFFS(1) = 0.0
      OFFS(2) = 0.0
      OFFS(3) = 0.0
      OFFS(4) = 0.0
      OFFS(5) = 0.0
      SCALES(1) = SCALEX
      SCALES(2) = SCALEX
      SCALES(3) = SCALEX
      SCALES(4) = SCALEX
      SCALES(5) = SCALEX
      SCALES(6) = 1.0
      IF (ISUV) DOCELL = -1.0
      IF ((DOCELL.GT.0.0) .AND. (M1.GT.0) .AND.
     *   (CATR(KRCIC+M1-1).NE.0.0)) THEN
         SCALES(1) = 1.0/CATR(KRCIC+M1-1)
         OFFS(1) = CATR(KRCRP+M1-1)
         END IF
      IF ((DOCELL.GT.0.0) .AND. (M2.GT.0) .AND.
     *   (CATR(KRCIC+M2-1).NE.0.0)) THEN
         SCALES(2) = 1.0/CATR(KRCIC+M2-1)
         OFFS(2) = CATR(KRCRP+M2-1)
         END IF
      I = 100 + 1
      N = I + 13
C                                         First page
      WRITE (TITL1,1040) INNAM, INCLS, INSEQ, INDISK, 'CC', INVERS
      CALL H2CHR (56, 1, BUFF4(I), CHTMP)
      WRITE (TITL2,1041) CHTMP
      IF (DOCRT.LE.-2.5) THEN
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *      TITL1, NLINE, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 970
      ELSE
         CALL H2CHR (5, 1, BUFF4(29), CHTMP)
         WRITE (LINE,1042) CHTMP, ADATE, ATIME
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, NLINE, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL H2CHR (5, 1, BUFF4(39), CHTMP)
         WRITE (LINE,1043) CHTMP, BDATE, BTIME
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, NLINE, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 970
         IF ((SORTS(3).EQ.' ') .AND. (SORTS(4).EQ.' ')) THEN
            WRITE (LINE,1044) MRNO, SORTS(1), SORTS(2)
         ELSE
            WRITE (LINE,1045) MRNO, SORTS
            END IF
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, NLINE, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       selection strings
         IF (BUFFER(61).GT.0) THEN
            WRITE (LINE,1050)
            CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *         LINE, NLINE, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 970
            N = BUFFER(61)
            DO 55 I = 1,N
               IRNO = I
               CALL TABIO ('READ', 2, IRNO, RESULT, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 960
               M = BUFFER(63+I) - BUFFER(62+I)
               IF (I.EQ.N) M = BUFFER(62) - BUFFER(62+I)
               M = MIN (M, 28)
               IF (16+4*M.GT.NACROS) M = (NACROS - 16) / 4
               M = M * 4
               CALL H2CHR (M, 1, RES4(1), CHTMP)
               WRITE (LINE,1051) CHTMP(:M)
               CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *            LINE, NLINE, IPAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 970
 55            CONTINUE
            END IF
         END IF
C                                       Prepare titles
      IF (.NOT.DOZZ) THEN
         IF (OTYPE.EQ.1) WRITE (TITL1,1081)
         IF (OTYPE.EQ.2) WRITE (TITL1,1082)
         IF (OTYPE.EQ.3) WRITE (TITL1,1083)
         IF (OTYPE.EQ.4) WRITE (TITL1,1084)
         IF (OTYPE.EQ.5) WRITE (TITL1,1085)
         IF (DOCELL.LE.0.0) THEN
            IF (OTYPE.EQ.1) WRITE (TITL2,1086) LABEL, LABEL
            IF (OTYPE.EQ.2) WRITE (TITL2,1087) LABEL, LABEL, LABEL,
     *         LABEL
            IF (OTYPE.EQ.3) WRITE (TITL2,1088) LABEL, LABEL, LABEL,
     *         LABEL
            IF (OTYPE.EQ.4) WRITE (TITL2,1089) LABEL, LABEL, LABEL,
     *         LABEL
            IF (OTYPE.EQ.5) WRITE (TITL2,1090) LABEL, LABEL, LABEL,
     *         LABEL
         ELSE
            IF (OTYPE.EQ.1) WRITE (TITL2,1091)
            IF (OTYPE.EQ.2) WRITE (TITL2,1092) LABEL, LABEL
            IF (OTYPE.EQ.3) WRITE (TITL2,1093) LABEL, LABEL
            IF (OTYPE.EQ.4) WRITE (TITL2,1094) LABEL, LABEL
            IF (OTYPE.EQ.5) WRITE (TITL2,1095) LABEL, LABEL
            END IF
      ELSE
         IF (OTYPE.EQ.1) WRITE (TITL1,2081)
         IF (OTYPE.EQ.2) WRITE (TITL1,2082)
         IF (OTYPE.EQ.3) WRITE (TITL1,2083)
         IF (OTYPE.EQ.4) WRITE (TITL1,2084)
         IF (OTYPE.EQ.5) WRITE (TITL1,2085)
         IF (DOCELL.LE.0.0) THEN
            IF (OTYPE.EQ.1) WRITE (TITL2,2086) LABEL, LABEL, LABEL
            IF (OTYPE.EQ.2) WRITE (TITL2,2087) LABEL, LABEL, LABEL,
     *         LABEL, LABEL
            IF (OTYPE.EQ.3) WRITE (TITL2,2088) LABEL, LABEL, LABEL,
     *         LABEL, LABEL
            IF (OTYPE.EQ.4) WRITE (TITL2,2089) LABEL, LABEL, LABEL,
     *         LABEL, LABEL
            IF (OTYPE.EQ.5) WRITE (TITL2,2090) LABEL, LABEL, LABEL,
     *         LABEL, LABEL
         ELSE
            IF (OTYPE.EQ.1) WRITE (TITL2,2091) LABEL
            IF (OTYPE.EQ.2) WRITE (TITL2,2092) LABEL, LABEL, LABEL
            IF (OTYPE.EQ.3) WRITE (TITL2,2093) LABEL, LABEL, LABEL
            IF (OTYPE.EQ.4) WRITE (TITL2,2094) LABEL, LABEL, LABEL
            IF (OTYPE.EQ.5) WRITE (TITL2,2095) LABEL, LABEL, LABEL
            END IF
         END IF
C                                       Output the titles
      IF (DOCRT.GT.-2.5) THEN
         LINE = ' '
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, NLINE, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
      CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *   TITL1, NLINE, IPAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *   TITL2, NLINE, IPAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 970
      IF ((DOCRT.GT.-2.5) .AND. (DOCRT.LE.0.0)) THEN
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, NLINE, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Output loop
      TFLUX = 0.0
      FIRSTC = 0
      SUMDEL = 0.0
      UPSUM = .TRUE.
      CCCHAR = ' '
      LRNO = 0
      DO 140 IRNO = 1,ECOUNT
         CALL TABCCM ('READ', BUFFER, CCRNO, CCKOLS, CCNUMV, CCNCOL, XX,
     *      YY, ZZ, FLUX, ITYPE, PARMS, IERR)
         IF (IERR.LT.0) THEN
            CCCHAR = '*'
            GO TO 140
            END IF
         IF (IERR.NE.0) GO TO 960
C                                      Store sum prior to last negative.
         IF ((UPSUM) .AND. (FLUX.LT.0.0)) THEN
            SUMDEL = TFLUX
            UPSUM = .FALSE.
            END IF
C
         TFLUX = TFLUX + FLUX
         IF ((FIRSTC.LE.0) .AND. (FLUX.LT.0.0)) FIRSTC = IRNO
         IF (IRNO.LT.BCOUNT) GO TO 140
         IF (MOD(IRNO-BCOUNT,ICOUNT).NE.0) GO TO 140
            XX = XX * SCALES(1) + OFFS(1)
            YY = YY * SCALES(2) + OFFS(2)
            ZZ = ZZ * SCALES(3) + OFFS(3)
            PARMS(1) = PARMS(1) * SCALES(4) + OFFS(4)
            PARMS(2) = PARMS(2) * SCALES(5) + OFFS(5)
            I = ITYPE + 1
            IF ((I.LT.1) .OR. (I.GT.4)) I = 5
            CCTYPE = MODTYP(I)
C                                       encode it now
            IF (.NOT.DOZZ) THEN
               IF (OTYPE.EQ.1) WRITE (LINE,1131,ERR=135) IRNO, XX, YY,
     *            FLUX, TFLUX
               IF (OTYPE.EQ.2) WRITE (LINE,1132,ERR=135) IRNO, XX, YY,
     *            PARMS, CCTYPE, FLUX, TFLUX, CCCHAR
               IF (OTYPE.EQ.3) WRITE (LINE,1133,ERR=135) IRNO, XX, YY,
     *            PARMS, CCTYPE, FLUX, TFLUX, CCCHAR
               IF (OTYPE.EQ.4) WRITE (LINE,1134,ERR=135) IRNO, XX, YY,
     *            PARMS, CCTYPE, FLUX, TFLUX, CCCHAR
               IF (OTYPE.EQ.5) WRITE (LINE,1135,ERR=135) IRNO, XX, YY,
     *            PARMS, CCTYPE, FLUX, TFLUX, CCCHAR
            ELSE
               IF (OTYPE.EQ.1) WRITE (LINE,2131,ERR=135) IRNO, XX, YY,
     *            ZZ, FLUX, TFLUX
               IF (OTYPE.EQ.2) WRITE (LINE,2132,ERR=135) IRNO, XX, YY,
     *            ZZ, PARMS, CCTYPE, FLUX, TFLUX, CCCHAR
               IF (OTYPE.EQ.3) WRITE (LINE,2133,ERR=135) IRNO, XX, YY,
     *            ZZ, PARMS, CCTYPE, FLUX, TFLUX, CCCHAR
               IF (OTYPE.EQ.4) WRITE (LINE,2134,ERR=135) IRNO, XX, YY,
     *            ZZ, PARMS, CCTYPE, FLUX, TFLUX, CCCHAR
               IF (OTYPE.EQ.5) WRITE (LINE,2135,ERR=135) IRNO, XX, YY,
     *            ZZ, PARMS, CCTYPE, FLUX, TFLUX, CCCHAR
               END IF
C                                       do output finally
 135        CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *         LINE, NLINE, IPAGE, SCRTCH, IERR)
            IF (IERR.GT.0) GO TO 970
            IF (IERR.NE.0) GO TO 150
 140     CONTINUE
 150  IF (FIRSTC.GT.0) THEN
         IF (IERR.LT.0) NLINE = 5
         WRITE (LINE,1150) FIRSTC
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, NLINE, IPAGE, SCRTCH, IERR)
         WRITE (LINE,1160) SUMDEL
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, NLINE, IPAGE, SCRTCH, IERR)
         END IF
C                                       Close down
      CALL TABCCM ('CLOS', BUFFER, CCRNO, CCKOLS, CCNUMV, CCNCOL, XX,
     *   YY, ZZ, FLUX, ITYPE, PARMS, IERR)
      CALL LPCLOS (OUTLUN, OUTIND, NLINE, IERR)
      GO TO 999
C                                       errors
 960  IRET = 3
      WRITE (MSGTXT,1960) IERR
      GO TO 995
 970  IRET = 0
      IF (IERR.LT.0) GO TO 150
         IRET = 2
         WRITE (MSGTXT,1970) IERR
C
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT (A12,'.',A6,'.',I4,'  Disk=',I2,4X,A2,' table version',
     *   I4)
 1041 FORMAT ('Title: ',A56)
 1042 FORMAT ('Created by      ',A5,' on ',A12,A8)
 1043 FORMAT ('Last written by ',A5,' on ',A12,A8)
 1044 FORMAT ('Ncomps',I8,4X,'sort on:',1X,A8,1X,'(',A6,')')
 1045 FORMAT ('Ncomps',I8,4X,'sort on:',2(1X,A8,1X,'(',A6,')'))
 1050 FORMAT (3X,'* After total => does not include flagged',
     *   ' components')
 1051 FORMAT (3X,'Selected on: ',A112)
 1081 FORMAT (4X,'Comp',8X,'Delta X',8X,'Delta Y',7X,'Flux',12X,
     *   'Total')
 1082 FORMAT (4X,'Comp',8X,'Delta X',8X,'Delta Y',7X,'Major ax',7X,
     *   'Minor ax',8X,'Pa',6X,'Type',7X,'Flux',12X,'Total')
 1083 FORMAT (4X,'Comp',8X,'Delta X',8X,'Delta Y',7X,'Major ax',7X,
     *   'Minor ax',5X,'Pa',3X,'Type',4X,'Flux',9X,'Total')
 1084 FORMAT (4X,'Comp',4X,'Deltax',4X,'Deltay',3X,'Majax',3X,'Minax',
     *   4X,'Pa',2X,'Type',3X,'Flux',8X,'Total')
 1085 FORMAT (3X,'Comp',3X,'Deltax',3X,'Deltay',2X,'Majax',2X,'Minax',
     *   4X,'Pa',2X,'Type',2X,'Flux',7X,'Total')
 1086 FORMAT (7X,'#',2(6X,A5,'asec'),8X,'Jy',15X,'Jy')
 1087 FORMAT (7X,'#',4(6X,A5,'asec'),7X,'Degr',17X,'Jy',14X,'Jy')
 1088 FORMAT (7X,'#',4(6X,A5,'asec'),4X,'Degr',11X,'Jy',11X,'Jy')
 1089 FORMAT (7X,'#',2(4X,A5,'S'),2(2X,A5,'S'),3X,'Degr',9X,'Jy',
     *   10X,'Jy')
 1090 FORMAT (6X,'#',2(3X,A5,'S'),2(2X,A5),3X,'Degr',8X,'Jy',9X,
     *   'Jy')
 1091 FORMAT (7X,'#',2(10X,'Cells'),8X,'Jy',15X,'Jy')
 1092 FORMAT (7X,'#',2(10X,'Cells'),2(6X,A5,'asec'),7X,'Degr',17X,
     *   'Jy',14X,'Jy')
 1093 FORMAT (7X,'#',2(10X,'Cells'),2(6X,A5,'asec'),4X,'Degr',11X,
     *   'Jy',11X,'Jy')
 1094 FORMAT (7X,'#',2(5X,'Cells'),2(2X,A5,'S'),3X,'Degr',9X,'Jy',
     *   10X,'Jy')
 1095 FORMAT (6X,'#',2(4X,'Cells'),2(2X,A5),3X,'Degr',8X,'Jy',9X,
     *   'Jy')
 1131 FORMAT (I8,2F15.2,4X,F12.7,4X,F13.7,A1)
 1132 FORMAT (I8,4F15.2,5X,F6.1,5X,A5,4X,F10.6,5X,F11.6,A1)
 1133 FORMAT (I8,4F15.2,2X,F6.1,2X,A5,1X,F10.6,2X,F11.6,A1)
 1134 FORMAT (I8,2F10.2,2F8.2,F7.1,1X,A5,F10.6,F12.6,A1)
 1135 FORMAT (I7,2F9.2,2F7.2,F7.1,1X,A5,F9.6,F10.5,A1)
 1150 FORMAT ('First negative component is number',I9)
 1160 FORMAT ('Sum of components prior to first negative = ',F12.5,
     *   ' Jy.')
 1960 FORMAT ('ERROR',I5,' READING TABLE DATA')
 1970 FORMAT ('ERROR',I5,' WRITING OUTPUT')
 2081 FORMAT (4X,'Comp',6X,'Delta X',6X,'Delta Y',6X,'Delta Z',6X,
     *   'Flux',10X,'Total')
 2082 FORMAT (4X,'Comp',6X,'Delta X',6X,'Delta Y',6x,'Delta Z',5X,
     *   'Major ax',5X,'Minor ax',6X,'Pa',6X,'Type',4X,'Flux',11X,
     *   'Total')
 2083 FORMAT (4X,'Comp',5X,'Delta X',5X,'Delta Y',4X,'Delta Z',3X,
     *   'Major ax',3X,'Minor ax',5X,'Pa',2X,'Type',3X,'Flux',5X,
     *   'Total')
 2084 FORMAT (4X,'Comp',3X,'DeltaX',3X,'DeltaY',2X,'DeltaZ',3X,
     *   'Majax',3X,'Minax',4X,'Pa',2X,'Type',2X,'Flux',5X,'Total')
 2085 FORMAT (3X,'Comp',2X,'DeltaX',2X,'DeltaY',2X,'DeltaZ',2X,
     *   'Majax',2X,'Minax',4X,'Pa',2X,'Type',2X,'Flux',3X,'Total')
 2086 FORMAT (7X,'#',3(4X,A5,'asec'),8X,'Jy',13X,'Jy')
 2087 FORMAT (7X,'#',5(4X,A5,'asec'),5X,'Degr',14X,'Jy',13X,'Jy')
 2088 FORMAT (7X,'#',2(3X,A5,'asec'),3(2X,A5,'asec'),3X,'Degr',10X,
     *   'Jy',8X,'Jy')
 2089 FORMAT (7X,'#',2(3X,A5,'S'),3(2X,A5,'S'),3X,'Degr',7X,'Jy',
     *   8X,'Jy')
 2090 FORMAT (6X,'#',3(2X,A5,'S'),2(2X,A5),2X,'Degr',8X,'Jy',6X,
     *   'Jy')
 2091 FORMAT (7X,'#',2(8X,'Cells'),(4X,A5,'asec'),8X,'Jy',13X,'Jy')
 2092 FORMAT (7X,'#',2(8X,'Cells'),3(4X,A5,'asec'),5X,'Degr',14X,
     *   'Jy',13X,'Jy')
 2093 FORMAT (7X,'#',2(7X,'Cells'),3(2X,A5,'asec'),3X,'Degr',10X,
     *   'Jy',8X,'Jy')
 2094 FORMAT (7X,'#',2(4X,'Cells'),3(2X,A5,'S'),3X,'Degr',7X,'Jy',
     *   8X,'Jy')
 2095 FORMAT (6X,'#',2(3X,'Cells'),1x,3(2X,A5),3X,'Degr',8X,'Jy',6X,
     *   'Jy')
 2131 FORMAT (I8,3F13.2,3X,F12.7,2X,F13.7,A1)
 2132 FORMAT (I8,5F13.2,3X,F6.1,4X,A5,F13.6,F15.6,A1)
 2133 FORMAT (I8,2F12.2,3F11.2,F7.1,1X,A5,F10.5,F11.5,A1)
 2134 FORMAT (I8,2F9.2,3F8.2,F7.1,1X,A4,F8.4,F10.4,A1)
 2135 FORMAT (I7,3F8.1,2F7.1,F7.1,1X,A4,F7.3,F8.3,A1)
      END
      SUBROUTINE PRCXDO (IRET)
C-----------------------------------------------------------------------
C   PRCXDO reads, formats, and prints a CX table extension file
C   Output:
C      IRET   I     Error code: 0 => OK or user terminates,
C                      2 => error writing, 3 => error reading
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER LABEL*5, TITL1*132, TITL2*132, LINE*132, SCRTCH*132,
     *   ATIME*8, ADATE*12, BTIME*8, BDATE*12, CHTMP*132, CHTM12*12,
     *   CCCHAR*1, LONGS(4)*4
      INTEGER   IRNO, MRNO, LRNO, M1, IERR, INC, IPAGE, I, J, M, N,
     *   NLINE, M2, ITYPE
      LOGICAL   PFLAG, EQUAL, T
      REAL      BUFF4(512), SCALEX, SCALET, QFLUX, UFLUX, SCALES(2),
     *   OFFS(2), XX, YY, FLUX, TFLUX, ROWB(10)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'PRTCC.INC'
      EQUIVALENCE (BUFFER, BUFF4)
      DATA LONGS /'GLON','GLAT','ELON','ELAT'/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       init counters, line size
      IRET = 0
C                                       Primary page: heading info
      IPAGE = 0
      NLINE = 899
      MRNO = BUFFER(5)
      CALL TIMDAT (BUFFER(14), BUFFER(11), ATIME, ADATE)
      CALL TIMDAT (BUFFER(36), BUFFER(33), BTIME, BDATE)
C                                       find real RA/DEC axis : MA file
      INC = 2
      N = CATBLK(KIDIM)
      M1 = 0
      M2 = 0
      DO 30 I = 1,N
         J = KHCTP + (I-1) * INC
         CALL H2CHR (2, 1, CATH(J), CHTM12)
         IF (CHTM12(:2).EQ.'RA') M1 = I
         CALL H2CHR (3, 1, CATH(J), CHTM12)
         IF (CHTM12(1:3).EQ.'DEC') M2 = I
         DO 29 M = 1,4
            CALL H2CHR (4, 1, CATH(J), CHTM12)
            EQUAL = LONGS(M)(1:4).EQ. CHTM12(1:4)
            IF ((EQUAL) .AND. ((M.EQ.1) .OR. (M.EQ.3))) M1 = I
            IF ((EQUAL) .AND. ((M.EQ.2) .OR. (M.EQ.4))) M2 = I
 29         CONTINUE
         IF ((M1.GT.0) .AND. (M2.GT.0)) GO TO 35
 30      CONTINUE
      M1 = 1
 35   M = MAX (M1, M2) - 1
      SCALET = ABS(CATR(KRCIC+M)) * 3600.0
      SCALEX = SCALET + 1.E-25
      CALL METSCA (SCALET, LABEL, PFLAG)
      SCALEX = 3600.0 * SCALET / SCALEX
      OFFS(1) = 0.0
      OFFS(2) = 0.0
      SCALES(1) = SCALEX
      SCALES(2) = SCALEX
      IF ((DOCELL.GT.0.0) .AND. (M1.GT.0) .AND.
     *   (CATR(KRCIC+M1-1).NE.0.0)) THEN
         SCALES(1) = 1.0/CATR(KRCIC+M1-1)
         OFFS(1) = CATR(KRCRP+M1-1)
         END IF
      IF ((DOCELL.GT.0.0) .AND. (M2.GT.0) .AND.
     *   (CATR(KRCIC+M2-1).NE.0.0)) THEN
         SCALES(2) = 1.0/CATR(KRCIC+M2-1)
         OFFS(2) = CATR(KRCRP+M2-1)
         END IF
      I = 100 + 1
      N = I + 13
C                                         First page
      WRITE (TITL1,1040) INNAM, INCLS, INSEQ, INDISK, 'CX', INVERS
      CALL H2CHR (56, 1, BUFF4(I), CHTMP)
      WRITE (TITL2,1041) CHTMP
      IF (DOCRT.LE.-2.5) THEN
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *      TITL1, NLINE, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 970
      ELSE
         CALL H2CHR (5, 1, BUFF4(29), CHTMP)
         WRITE (LINE,1042) CHTMP, ADATE, ATIME
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, NLINE, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL H2CHR (5, 1, BUFF4(39), CHTMP)
         WRITE (LINE,1043) CHTMP, BDATE, BTIME
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, NLINE, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 970
         WRITE (LINE,1044) MRNO
         IF (CHTMP.EQ.'CCMRG') WRITE (LINE,1045) MRNO
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, NLINE, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 970
         WRITE (LINE,1050)
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, NLINE, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Prepare titles
      WRITE (TITL1,1081)
      IF (DOCELL.LE.0.0) THEN
         WRITE (TITL2,1086) LABEL, LABEL
      ELSE
         WRITE (TITL2,1091)
         END IF
C                                       Output the titles
      IF (DOCRT.GT.-2.5) THEN
         LINE = ' '
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, NLINE, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
      CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *   TITL1, NLINE, IPAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *   TITL2, NLINE, IPAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 970
      IF ((DOCRT.GT.-2.5) .AND. (DOCRT.LE.0.0)) THEN
         CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, NLINE, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Output loop
      TFLUX = 0.0
      CCCHAR = ' '
      LRNO = 0
      DO 140 IRNO = 1,ECOUNT
         CALL GETCOL (IRNO, 1, DATP, LRNO, BUFFER, ITYPE, XX, ROWB,
     *      IERR)
         IF (IERR.LE.0) CALL GETCOL (IRNO, 2, DATP, LRNO, BUFFER, ITYPE,
     *      YY, ROWB, IERR)
         IF (IERR.LE.0) CALL GETCOL (IRNO, 3, DATP, LRNO, BUFFER, ITYPE,
     *      QFLUX, ROWB, IERR)
         IF (IERR.LE.0) CALL GETCOL (IRNO, 4, DATP, LRNO, BUFFER, ITYPE,
     *      UFLUX, ROWB, IERR)
         IF (IERR.LT.0) THEN
            CCCHAR = '*'
            GO TO 140
            END IF
         IF (IERR.NE.0) GO TO 960
C                                      Store sum prior to last negative.
         FLUX = SQRT (QFLUX*QFLUX + UFLUX*UFLUX)
         TFLUX = TFLUX + FLUX
         IF ((IRNO.GE.BCOUNT) .AND. (MOD(IRNO-BCOUNT,ICOUNT).EQ.0)) THEN
            XX = XX * SCALES(1) + OFFS(1)
            YY = YY * SCALES(2) + OFFS(2)
C                                       encode it now
            IF (DOCELL.LE.0.0) THEN
               WRITE (LINE,1131,ERR=135) IRNO, XX, YY, QFLUX, UFLUX,
     *            FLUX, TFLUX, CCCHAR
            ELSE
               WRITE (LINE,1132,ERR=135) IRNO, XX, YY, QFLUX, UFLUX,
     *            FLUX, TFLUX, CCCHAR
               END IF
C                                       do output finally
 135        CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NACROS, TITL1, TITL2,
     *         LINE, NLINE, IPAGE, SCRTCH, IERR)
            IF (IERR.GT.0) GO TO 970
            IF (IERR.NE.0) GO TO 150
            END IF
 140     CONTINUE
C                                       Close down
 150  CALL TABIO ('CLOS', 0, IRNO, BUFFER, BUFFER, IERR)
      CALL LPCLOS (OUTLUN, OUTIND, NLINE, IERR)
      GO TO 999
C                                       errors
 960  IRET = 3
      WRITE (MSGTXT,1960) IERR
      GO TO 995
 970  IRET = 0
      IF (IERR.LT.0) GO TO 150
         IRET = 2
         WRITE (MSGTXT,1970) IERR
C
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT (A12,'.',A6,'.',I4,'  Disk=',I2,4X,A2,' table version',
     *   I4)
 1041 FORMAT ('Title: ',A56)
 1042 FORMAT ('Created by      ',A5,' on ',A12,A8)
 1043 FORMAT ('Last written by ',A5,' on ',A12,A8)
 1044 FORMAT ('Ncomps',I8,4X,'sort on: descending component amplitude')
 1045 FORMAT ('Ncomps',I8,4X,'sort on: descending abs(REAL) component')
 1050 FORMAT (3X,'* After total => does not include flagged',
     *   ' components')
 1081 FORMAT (4X,'Comp',3X,'Delta X',3X,'Delta Y',2X,'Real',4X,2X,
     *   'Imag',4X,4X,'Flux',10X,'Total')
 1086 FORMAT (7X,'#',2(1X,A5,'asec'),2(3X,'Jy',5X),4X,'Jy',12X,'Jy')
 1091 FORMAT (7X,'#',2(5X,'Cells'),2(3X,'Jy',5X),5X,'Jy',12X,'Jy')
 1131 FORMAT (I8,2F10.2,2F10.5,F11.5,3X,F9.3,A1)
 1132 FORMAT (I8,2F10.1,2F10.5,F11.5,3X,F9.3,A1)
 1960 FORMAT ('ERROR',I5,' READING TABLE DATA')
 1970 FORMAT ('ERROR',I5,' WRITING OUTPUT')
      END

      SUBROUTINE MAKCVM (APCORE, IN, OUT, IERR)
C-----------------------------------------------------------------------
C! Tim Cornwell routine: Make image with residuals added.
C# IO-util Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C Make image with residuals added
C   Programmer =  R. Braun      November 1987
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER    IN, OUT, IFIELD
      REAL       VAL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IERR = 0
      DO 100 IFIELD = 1,NFIELD
         IF (FRES(IFIELD).GT.0.0) THEN
            VAL = 1/FRES(IFIELD)**2
         ELSE
            VAL = 1.0
            END IF
C                                        Focal or aperture plane data ?
         IF (BEAMTP(IFIELD).GT.0) THEN
C                                        Primary beam correction ?
            IF (BMSIZE(IFIELD).GT.0) THEN
               CALL APPLPB (IFIELD, IN, PRS, IERR)
               IF (IERR.NE.0) GO TO 990
               CALL CONV (APCORE, F, PRS, 1.0, WT(IFIELD), PRS, IERR)
               IF (IERR.NE.0) GO TO 990
               CALL SUBMAP (DAT(IFIELD), PRS, PRS, 0.0, IERR)
               IF (IERR.NE.0) GO TO 990
               IF (IFIELD.EQ.1) THEN
                  CALL APLPBI (IFIELD, PRS, VAL, OUT, RES, IERR)
                  IF (IERR.NE.0) GO TO 990
               ELSE
                  VMSZ(1,WK1) = HNX
                  VMSZ(2,WK1) = HNY
                  VMSZ(1,WK2) = HNX
                  VMSZ(2,WK2) = HNY
                  CALL APLPBI (IFIELD, PRS, VAL, WK1, WK2, IERR)
                  IF (IERR.NE.0) GO TO 990
                  CALL ADDMAP (WK1, OUT, OUT, FBLANK, RESMAX, RESMIN,
     *               IERR)
                  IF (IERR.NE.0) GO TO 990
                  CALL ADDMAP (WK2, RES, RES, FBLANK, RESMAX, RESMIN,
     *               IERR)
                  IF (IERR.NE.0) GO TO 990
                  VMSZ(1,WK1) = NX
                  VMSZ(2,WK1) = NY
                  VMSZ(1,WK2) = NX
                  VMSZ(2,WK2) = NY
                  END IF
            ELSE
               CALL CONV (APCORE, F, IN, 1.0, WT(IFIELD), PRS, IERR)
               IF (IERR.NE.0) GO TO 990
               CALL SUBMAP (DAT(IFIELD), PRS, PRS, 0.0, IERR)
               IF (IERR.NE.0) GO TO 990
               IF (IFIELD.EQ.1) THEN
                  CALL MLTMAP (PRS, VAL, OUT, 0.0, IERR)
                  IF (IERR.NE.0) GO TO 990
                  CALL FLAT (VAL, RES, IERR)
                  IF (IERR.NE.0) GO TO 990
               ELSE
                  VMSZ(1,WK1) = HNX
                  VMSZ(2,WK1) = HNY
                  VMSZ(1,WK2) = HNX
                  VMSZ(2,WK2) = HNY
                  CALL MLTMAP (PRS, VAL, WK1, 0.0, IERR)
                  IF (IERR.NE.0) GO TO 990
                  CALL FLAT (VAL, WK2, IERR)
                  IF (IERR.NE.0) GO TO 990
                  CALL ADDMAP (WK1, OUT, OUT, 0.0, RESMAX, RESMIN, IERR)
                  IF (IERR.NE.0) GO TO 990
                  CALL ADDMAP (WK2, RES, RES, 0.0, RESMAX, RESMIN, IERR)
                  IF (IERR.NE.0) GO TO 990
                  VMSZ(1,WK1) = NX
                  VMSZ(2,WK1) = NY
                  VMSZ(1,WK2) = NX
                  VMSZ(2,WK2) = NY
                  END IF
               END IF
         ELSE
C                                                Focal plane data
            CALL CONV (APCORE, T, IN, 1.0, WT(IFIELD), PRS, IERR)
            IF (IERR.NE.0) GO TO 990
            CALL SUBMAP (DAT(IFIELD), PRS, PRS, 0.0, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (IFIELD.EQ.1) THEN
               CALL MLTMAP (PRS, VAL, OUT, 0.0, IERR)
               IF (IERR.NE.0) GO TO 990
               CALL FLAT (VAL, RES, IERR)
               IF (IERR.NE.0) GO TO 990
            ELSE
               VMSZ(1,WK1) = HNX
               VMSZ(2,WK1) = HNY
               VMSZ(1,WK2) = HNX
               VMSZ(2,WK2) = HNY
               CALL MLTMAP (PRS, VAL, WK1, 0.0, IERR)
               IF (IERR.NE.0) GO TO 990
               CALL ADDMAP (WK1, OUT, OUT, FBLANK, RESMAX, RESMIN, IERR)
               IF (IERR.NE.0) GO TO 990
               CALL FLAT (VAL, WK2, IERR)
               IF (IERR.NE.0) GO TO 990
               CALL ADDMAP (WK2, RES, RES, FBLANK, RESMAX, RESMIN, IERR)
               IF (IERR.NE.0) GO TO 990
               VMSZ(1,WK1) = NX
               VMSZ(2,WK1) = NY
               VMSZ(1,WK2) = NX
               VMSZ(2,WK2) = NY
               END IF
            END IF
  100    CONTINUE
C                                       Now divide by (primary beam)**2
      IF (BLANKD) THEN
         CALL DIVMAP (OUT, RES, RES, FBLANK, RESMAX, RESMIN, IERR)
         IF (IERR.NE.0) GO TO 990
      ELSE
         CALL DIVMAP (OUT, RES, RES, 0.0, RESMAX, RESMIN, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       Now make Convolving function
C                                       and convolve with it.
      IFIELD = 1
      CALL MAKGAU (WT(IFIELD), IERR)
      IF (IERR.NE.0) GO TO 990
      CALL CONV (APCORE, F, IN, 1.0, WT(IFIELD), OUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Add residuals after linear
C                                       correction for primary beam.
      IF (BLANKD) THEN
         CALL ADDMAP (OUT, RES, OUT, FBLANK, RESMAX, RESMIN, IERR)
         IF (IERR.NE.0) GO TO 990
      ELSE
         CALL ADDMAP (OUT, RES, OUT, 0.0, RESMAX, RESMIN, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C
 990  WRITE (MSGTXT,1000)
      CALL MSGWRT (8)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MAKCVM')
      END

      SUBROUTINE PRTERR (IERR, ILUN)
C-----------------------------------------------------------------------
C! Prints standard WaWa error message and namestring of file.
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   PRTERR will print a standard WAWA error message plus the name string
C   if the LUN can be found in FILTAB.
C   Inputs:
C     IERR       I   WAWA error number.
C     ILUN       I   the LUN of the file.
C-----------------------------------------------------------------------
      CHARACTER NAMSTR*36
      INTEGER   IERR, ILUN, IERR2
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF ((IERR.LT.1) .OR. (IERR.GT.26)) GO TO 330
         GO TO (110,120,130,140,150,160,170,180,190,200,210,220,230,
     *      240,330,250,260,330,330,330,270,280,290,300,310,320), IERR
 110        WRITE (MSGTXT,1110)
            GO TO 500
 120        WRITE (MSGTXT,1200)
            GO TO 500
 130        WRITE (MSGTXT,1130)
            GO TO 500
 140        WRITE (MSGTXT,1140)
            GO TO 500
 150        WRITE (MSGTXT,1150)
            GO TO 500
 160        WRITE (MSGTXT,1160)
            GO TO 500
 170        WRITE (MSGTXT,1170)
            GO TO 500
 180        WRITE (MSGTXT,1180)
            GO TO 500
 190        WRITE (MSGTXT,1190)
            GO TO 500
 200        WRITE (MSGTXT,1200)
            GO TO 500
 210        WRITE (MSGTXT,1210)
            GO TO 500
 220        WRITE (MSGTXT,1220)
            GO TO 500
 230        WRITE (MSGTXT,1230)
            GO TO 500
 240        WRITE (MSGTXT,1240)
            GO TO 500
 250        WRITE (MSGTXT,1250)
            GO TO 500
 260        WRITE (MSGTXT,1260)
            GO TO 500
 270        WRITE (MSGTXT,1270)
            GO TO 500
 280        WRITE (MSGTXT,1280)
            GO TO 500
 290        WRITE (MSGTXT,1290)
            GO TO 500
 300        WRITE (MSGTXT,1300)
            GO TO 500
 310        WRITE (MSGTXT,1310)
            GO TO 500
 320        WRITE (MSGTXT,1320)
            GO TO 500
 330        WRITE (MSGTXT,1330) IERR
            GO TO 500
 500  CONTINUE
      CALL MSGWRT (7)
      IF (ILUN.EQ.0) GO TO 999
         CALL GTNAME (ILUN, NAMSTR, IERR2)
C                                       Print file name or LUN.
         IF (IERR2.EQ.0) CALL PRTNAM (NAMSTR, 7)
         IF (IERR2.EQ.0) GO TO 999
            WRITE (MSGTXT,1500) ILUN
            CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1110 FORMAT ('FILE NOT OPEN')
 1120 FORMAT ('INPUT PARAMETER ERROR')
 1130 FORMAT ('IO ERROR ("OTHER")')
 1140 FORMAT ('END OF FILE')
 1150 FORMAT ('BEGINNING OF MEDIUM')
 1160 FORMAT ('END OF MEDIUM')
 1170 FORMAT ('BUFFER TOO SMALL')
 1180 FORMAT ('ILLEGAL DATA TYPE')
 1190 FORMAT ('LOGICAL END OF FILE')
 1200 FORMAT ('CATALOG OPERATION ERROR')
 1210 FORMAT ('CATALOG STATUS ERROR')
 1220 FORMAT ('MAP NOT IN CATALOG')
 1230 FORMAT ('EXT FILE NOT IN CATALOG')
 1240 FORMAT ('NO ROOM IN HEADER/CATALOG')
 1250 FORMAT ('ILLEGAL WINDOW SPECIFICATION')
 1260 FORMAT ('ILLEGAL WINDOW SPECIFICATION FOR WRITING')
 1270 FORMAT ('CREATE: FILE ALREADY EXITS')
 1280 FORMAT ('CREATE: VOLUME UNAVAILABLE')
 1290 FORMAT ('CREATE: SPACE UNAVAILABEL')
 1300 FORMAT ('CREATE: "OTHER"')
 1310 FORMAT ('DESTROY: "OTHER"')
 1320 FORMAT ('OPEN: "OTHER"')
 1330 FORMAT ('IO ERROR:',I5)
 1500 FORMAT ('LUN =',I6)
      END

      SUBROUTINE TABCQ (OPCODE, BUFFER, ICQRNO, CQKOLS, CQNUMV, NOIFCQ,
     *   IFQDCQ, ISUBCQ, NFFTCQ, NCHCQ, NSAVCQ, DFRQCQ, DCBWCQ, LTAPCQ,
     *   NOVSCQ, NZPDCQ, IFLTCQ, TAVGCQ, NBITCQ, IOVLCQ, IRET)
C----------------------------------------------------------------------
C! I/O to correlator parameter frequency (CQ) tables
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2007, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to CQ tables, after setup by CQINI
C   Inputs:
C      OPCODE      C*4        Operation code:
C                             'READ' = read entry from table
C                             'WRIT' = write entry in table
C                             'CLOS' = close file, flush on write
C      BUFFER      I(512)     I/O buffer and related storage, also
C                             defines file if open. Should have been
C                             returned by CQINI.
C      ICQRNO      I          Next scan no. to read or write
C      CQKOLS      I(MAXCQC)  The column pointer array in order:
C                             FQ_ID, SUBARRAY, FFT_SIZE, NO_CHAN,
C                             SPEC_AVG, EDGE_FREQ, CHAN_BW, TAPER_FN,
C                             OVER_SAMPL, ZERO_PAD, TIME_FILT, TIME_AVG,
C                             NO_BITS, FFT_OVLP
C      CQNUMV      I(MAXCQC)  Element count in each column.
C      NOIFCQ      I          No of IFs in CQ table.
C   Input/output: (written to or read from CQ table)
C      IFQDCQ      I          Freq_id
C      ISUBCQ      I          Subarray number
C   Following fields are all indexed on IF number:
C      NFFTCQ      I(*)       FFT_size
C      NCHCQ       I(*)       No. of channels
C      NSAVCQ      I(*)       Spectral averaging factor
C      DFRQCQ      D(*)       Edge frequency (Hz)
C      DCBWCQ      D(*)       Channel bandwidth (Hz)
C      LTAPCQ      C*8(*)     Taper function
C      NOVSCQ      I(*)       Oversampling factor
C      NZPDCQ      I(*)       Zero-padding factor
C      IFLTCQ      I(*)       Filter type
C      TAVGCQ      R(*)       Time averaging interval (s)
C      NBITCQ      I(*)       Quantization (no. of bits)
C      IOVLCQ      I(*)       FFT overlap factor
C   Output:
C      IRET        I          Return error code, 0=>ok, else
C                             TABIO error
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCQV.INC'
      INTEGER NOIFCQ
      CHARACTER OPCODE*4, LTAPCQ(NOIFCQ)*8
      DOUBLE PRECISION DFRQCQ(NOIFCQ), DCBWCQ(NOIFCQ)
      REAL TAVGCQ(NOIFCQ)
      INTEGER BUFFER(512), ICQRNO, CQKOLS(MAXCQC), CQNUMV(MAXCQC),
     *   IFQDCQ, ISUBCQ, NFFTCQ(NOIFCQ), NCHCQ(NOIFCQ), NSAVCQ(NOIFCQ),
     *   NOVSCQ(NOIFCQ), NZPDCQ(NOIFCQ), IFLTCQ(NOIFCQ), NBITCQ(NOIFCQ),
     *   IOVLCQ(NOIFCQ), IRET
C
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      HOLLERITH HOLTMP(2)
      LOGICAL DOREAD, DOCLOS
      DOUBLE PRECISION RECD(MXSPCQ)
      REAL RECORD(MXSPCQ)
      INTEGER RECI(MXSPCQ), ITEMP(2), NUMIF, JIF
      EQUIVALENCE (RECORD, RECI, RECD), (HOLTMP, ITEMP)
C-----------------------------------------------------------------------
      NUMIF = CQNUMV(CQIFFT)
C                                       Check OPCODE
      DOREAD = (OPCODE.EQ.'READ')
      DOCLOS = (OPCODE.EQ.'CLOS')
C                                       Branch for CLOS
      IF (DOCLOS) GO TO 800
C                                       If WRIT fill record
      IF (.NOT.DOREAD) THEN
C                                       FQ_ID
         RECI(CQKOLS(CQIFQD)) = IFQDCQ
C                                       Subarray
         RECI(CQKOLS(CQISUB)) = ISUBCQ
C                                       Loop over IF
         DO 100 JIF = 1, NUMIF
C                                       FFT size
            RECI(CQKOLS(CQIFFT)+JIF-1) = NFFTCQ(JIF)
C                                       No. channels
            RECI(CQKOLS(CQINCH)+JIF-1) = NCHCQ(JIF)
C                                       Spectral averaging
            RECI(CQKOLS(CQISAV)+JIF-1) = NSAVCQ(JIF)
C                                       Edge frequency
            CALL RCOPY (NWDPDP, DFRQCQ(JIF),
     *         RECD(CQKOLS(CQDFRQ)+JIF-1))
C                                       Channel bandwidth
            CALL RCOPY (NWDPDP, DCBWCQ(JIF),
     *         RECD(CQKOLS(CQDCBW)+JIF-1))
C                                       Weighting function
            CALL CHR2H (8, LTAPCQ(JIF), 1, HOLTMP)
            CALL COPY (2, ITEMP, RECI(CQKOLS(CQHTAP)+2*(JIF-1)))
C                                       Oversampling factor
            RECI(CQKOLS(CQIOVS)+JIF-1) = NOVSCQ(JIF)
C                                       Zero padding factor
            RECI(CQKOLS(CQIZPD)+JIF-1) = NZPDCQ(JIF)
C                                       Filter type
            RECI(CQKOLS(CQIFLT)+JIF-1) = IFLTCQ(JIF)
C                                       Time averaging interval
            RECORD(CQKOLS(CQRTAV)+JIF-1) = TAVGCQ(JIF)
C                                       Quantization
            RECI(CQKOLS(CQIBIT)+JIF-1) = NBITCQ(JIF)
C                                       FFT overlap factor
            RECI(CQKOLS(CQIOVL)+JIF-1) = IOVLCQ(JIF)
100         CONTINUE
         END IF
C                                       Process record
220   CALL TABIO (OPCODE, 0, ICQRNO, RECORD, BUFFER, IRET)
      ICQRNO = ICQRNO + 1
      IF (IRET.GT.0) THEN
         CALL TABERR (OPCODE, 'TABIO', 'TABCQ', IRET)
         GO TO 999
         END IF
C                                       If READ pick data from
C                                       record.
      IF (DOREAD) THEN
C                                       FQ_id
         IFQDCQ = RECI(CQKOLS(CQIFQD))
C                                       Subarray
         ISUBCQ = RECI(CQKOLS(CQISUB))
C
         DO 300 JIF = 1, NUMIF
C                                       FFT size
            NFFTCQ(JIF) = RECI(CQKOLS(CQIFFT)+JIF-1)
C                                       No. channels
            NCHCQ(JIF) = RECI(CQKOLS(CQINCH)+JIF-1)
C                                       Spectral averaging factor
            NSAVCQ(JIF) = RECI(CQKOLS(CQISAV)+JIF-1)
C                                       Edge frequency
            CALL RCOPY (NWDPDP, RECD(CQKOLS(CQDFRQ)+JIF-1),
     *         DFRQCQ(JIF))
C                                       Channel bandwidth
            CALL RCOPY (NWDPDP, RECD(CQKOLS(CQDCBW)+JIF-1),
     *         DCBWCQ(JIF))
C                                       Weighting function
            CALL COPY (2, RECI(CQKOLS(CQHTAP)+2*(JIF-1)), ITEMP)
            CALL H2CHR (8, 1, HOLTMP, LTAPCQ(JIF))
C                                       Oversampling factor
            NOVSCQ(JIF) = RECI(CQKOLS(CQIOVS)+JIF-1)
C                                       Zero padding factor
            NZPDCQ(JIF) = RECI(CQKOLS(CQIZPD)+JIF-1)
C                                       Filter type
            IFLTCQ(JIF) = RECI(CQKOLS(CQIFLT)+JIF-1)
C                                       Time averaging interval
            TAVGCQ(JIF) = RECORD(CQKOLS(CQRTAV)+JIF-1)
C                                       Quantization
            NBITCQ(JIF) = RECI(CQKOLS(CQIBIT)+JIF-1)
C                                       FFT overlap factor
            IOVLCQ(JIF) = RECI(CQKOLS(CQIOVL)+JIF-1)
300         CONTINUE
         END IF
         GO TO 999
C                                       Close
800   CALL TABIO ('CLOS', 0, ICQRNO, RECORD, BUFFER, IRET)
      IF (IRET.NE.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'TABCQ', IRET)
         GO TO 999
         END IF
      GO TO 999
C                                       Exit
999   RETURN
      END

      SUBROUTINE FQFTAB (DISK, CNO, LUN, CATR, MAXFQI, NUMBIF, NUMBFQ,
     *   FQOFF, FQCHSP, BUFFER, IRET)
C-----------------------------------------------------------------------
C! Return FQ id/IF table of frequency offsets and channel increments
C# Header Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Returns the number of IF and FQ ids from the Fq or CH table and
C   tables of the frequency offsets and the channel separations.
C   Input:
C      DISK     I        Disk number. If .le. 0 /CFILES/ scratch file
C                        number CNO will be used.
C      CNO      I        Catalog slot number
C      LUN      I        AIPS LUN to use for CHNDAT.
C      CATR     R(*)     Catalog header
C      MAXFQI   I        Maximum number of FQ ids.
C   Output:
C      NUMBIF   I        The number of IFs in the data set.
C      NUMBFQ   I        The maximum FQ if number in the data set or
C                        MAXFQI if this is smaller.
C      FQOFF    R(MAXIF,MAXFQI)  Frequency offset table from the
C                        reference frequency (Hz) by IF and FQ id.
C      FQCHSP   R(MAXIF,MAXFQI)  Channel separation table (Hz) by IF and
C                        FQ id.
C      BUFFER   I(512)   I/O work buffer.
C      IRET     I        Return error code, 0=>OK,
C                           1 => exceeded table size
C                           other = table I/O error
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   DISK, CNO, LUN, MAXFQI, NUMBIF, NUMBFQ, BUFFER(*), IRET
      REAL      CATR(256), FQOFF(MAXIF,MAXFQI), FQCHSP(MAXIF,MAXFQI)
C
      INTEGER   IVER, IERR, IFQRNO, FQKOLS(MAXFQC), FQNUMV(MAXFQC),
     *   NUMROW, LOOP, FQID, IFSIDE(MAXIF), LOOPIF
      LOGICAL   TABLE, EXIST, FITASC, ISFQ, ISCH
      REAL      IFCHW(MAXIF), IFTBW(MAXIF)
      DOUBLE PRECISION IFFREQ(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Initialize output
      NUMBIF = 1
      NUMBFQ = 1
      DO 20 LOOPIF = 1,MAXIF
         DO 10 LOOP = 1,MAXFQI
            FQOFF(LOOPIF,LOOP) = 0.0
            FQCHSP(LOOPIF,LOOP) = 0.0
 10         CONTINUE
 20      CONTINUE
C                                       There are three different
C                                       possibilities here, either an FQ
C                                       table, a CH table or neither.
      IVER = 1
      CALL ISTAB ('FQ', DISK, CNO, IVER, LUN, BUFFER, TABLE, EXIST,
     *   FITASC, IERR)
      ISFQ = EXIST .AND. TABLE .AND. (IERR.EQ.0)
      ISCH = .FALSE.
      IF (.NOT.ISFQ) THEN
         CALL ISTAB ('CH', DISK, CNO, IVER, LUN, BUFFER, TABLE, EXIST,
     *      FITASC, IERR)
         ISCH = EXIST .AND. TABLE .AND. (IERR.EQ.0)
         END IF
C                                       FQ Table branch
      IF (ISFQ) THEN
C                                       Init FQ table
         CALL FQINI ('READ', BUFFER, DISK, CNO, IVER, CATR, LUN,
     *      IFQRNO, FQKOLS, FQNUMV, NUMBIF, IRET)
         IF (IRET.NE.0) GO TO 999
         NUMROW = BUFFER(5)
C                                       Read table
         DO 100 LOOP = 1,NUMROW
            IFQRNO = LOOP
            CALL TABFQ ('READ', BUFFER, IFQRNO, FQKOLS, FQNUMV, NUMBIF,
     *         FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IRET)
            IF (IRET.GT.0) GO TO 999
C                                       In case entries are flagged.
            IF (IRET.EQ.0) THEN
               NUMBFQ = MAX (NUMBFQ, FQID)
               IF (NUMBFQ.LE.MAXFQI) THEN
C                                       Save values
                  DO 50 LOOPIF = 1,NUMBIF
                     FQOFF(LOOPIF,FQID) = IFFREQ(LOOPIF)
                     FQCHSP(LOOPIF,FQID) = IFCHW(LOOPIF)
 50                  CONTINUE
               ELSE
C                                       Too many FQ ids.
                  NUMBFQ = MAXFQI
                  WRITE (MSGTXT,1050) FQID, MAXFQI
                  CALL MSGWRT (7)
                  END IF
               END IF
 100        CONTINUE
C                                       Close table
         CALL TABFQ ('CLOS', BUFFER, IFQRNO, FQKOLS, FQNUMV, NUMBIF,
     *      FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       CH Table branch
      ELSE IF (ISCH) THEN
C                                       Only 1 FQ id in CH tables
         FQID = 1
         CALL CHNDAT ('READ', BUFFER, DISK, CNO, IVER, CATR, LUN,
     *      NUMBIF, IFFREQ, IFSIDE, FQCHSP, BNDCOD, FQID, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
C                                       Copy double precision to
C                                       output single precision
         ELSE
            DO 125 LOOPIF = 1, NUMBIF
               FQOFF(LOOPIF,FQID) = IFFREQ(LOOPIF)
 125           CONTINUE
            END IF
         END IF
C
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
      MSGTXT = 'THE ERROR OCCURED IN FQFTAB'
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('FQFTAB: THERE ARE MORE FQ IDS (',I3,') THAN MAX.=',I3)
 1100 FORMAT ('FQFTAB: CHNDAT ERROR ',I3)
      END

LOCAL INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:PMAD.INC'
      INCLUDE 'INCS:PUVD.INC'
C                                       Local include for APCLN
      INTEGER   LBUFSZ, HBUFSZ, BMHSIZ
C                                       IO buffers: power of 2
      PARAMETER (LBUFSZ = MABFSL)
C                                       Histogram, <= 2 x LBUFSZ
      PARAMETER (HBUFSZ = 16384)
C                                       Histogram of beam size
      PARAMETER (BMHSIZ = 512)
C
      REAL   GAIN, FMIN, FLUX, RESMAX, MAPLIM, GAUSA, GAUSB, GAUSC,
     *   GAUSAA, GAUSBB, GAUSCC, PHAT, XSPACE, YSPACE, MAPROT,
     *   SPEXP, TVFMAX, TVFMIN, TVREMX, TVREMN,
     *   BUFF1(LBUFSZ), BUFF2(LBUFSZ), BUFF3(LBUFSZ)
      CHARACTER BEMFIL*48, RESFIL*48, WTFIL*48, GRDFIL*48, DRTFIL*48,
     *   WRKFIL*48, CLNFIL*48
      LOGICAL   NOFIT
      INTEGER   PRECLN, CLNLST, CLNSTR, CLNLIM, PTRJ, PTRK, MAXPIX,
     *   BMHIS(BMHSIZ+2), RESHIS(HBUFSZ), NX, NY, PATCH, MAXPCH, MINPCH,
     *   NUMBIN, BPS, LUNBEM, WINB(4), WINM(4,50), NBOXS, LUNRES,
     *   LUNRS1, LUNWT, LUNGD1, LUNGD2, LUNDRT, LUNWRK, LUNCL1, LUNCL2,
     *   BEMVOL, RESVOL, WTVOL, GRDVOL, DRTVOL, WRKVOL, CLNVOL, ICENX,
     *   ICENY, CLNVER, BOBEM, BORES, BOWT, BOGRD, BODRT, BOWRK, CNORES,
     *   CNOWT, CNOGRD, CNOWRK, BLC(7), APSIZ, BUFSZ1, BUFSZ2, BUFSZ3,
     *   BMOFFS
      INTEGER   CCBUFF(512), CCKOLS(MAXCCC), CCNUMV(MAXCCC), CCRNO,
     *   CCNCOL, CCTYPE, IDUM(24)
      REAL      XX, YY, ZZ, CCFLUX, PARMS(3), RDUM(24)
      EQUIVALENCE (IDUM, RDUM)
      COMMON /CCFILE/ CCBUFF, CCKOLS, CCNUMV, CCRNO, CCNCOL, CCTYPE, XX,
     *   YY, ZZ, CCFLUX, PARMS, RDUM
      COMMON /CLNCHR/ BEMFIL, RESFIL, WTFIL, GRDFIL, DRTFIL, WRKFIL,
     *   CLNFIL
      COMMON /CLNCOM/ BUFF1, BUFF2, BUFF3, GAIN, FMIN, FLUX, PHAT,
     *   RESMAX, MAPLIM, GAUSA, GAUSB, GAUSC, GAUSAA, GAUSBB, GAUSCC,
     *   APSIZ, XSPACE, YSPACE, MAPROT, SPEXP, TVFMAX, TVFMIN, TVREMX,
     *   TVREMN, PRECLN, CLNLST, CLNSTR, CLNLIM, PTRJ, PTRK, BMHIS,
     *   RESHIS, NOFIT, ICENX, ICENY, NX, NY, PATCH, MAXPCH, MINPCH,
     *   NUMBIN, WINB, WINM, NBOXS, BPS, LUNBEM, LUNRES, LUNRS1, LUNWT,
     *   LUNGD1, LUNGD2, LUNDRT, LUNWRK, LUNCL1, LUNCL2, BEMVOL, RESVOL,
     *   WTVOL, GRDVOL, DRTVOL, WRKVOL, CLNVOL, BOBEM, BORES, BOWT,
     *   BOGRD, BODRT, BOWRK, CNORES, CNOWT, CNOGRD, CNOWRK, CLNVER,
     *   BLC, BUFSZ1, BUFSZ2, BUFSZ3, MAXPIX, BMOFFS
C                                                          End APCLN
LOCAL END
      PROGRAM APCLN
C-----------------------------------------------------------------------
C! Barry Clark CLEAN deconvolution
C# Map AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1999-2000, 2003, 2006-2008, 2010, 2015,
C;  Copyright (C) 2019-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   APCLN does a map CLEAN of the type designed by B. Clark
C   * => support TELL change of parameter:
C   INPUTS    ALIAS   DIM(R)                COMMENTS
C   INNAME    NAME(1,1) 3           Dirty map name
C   INCLASS   CLASS(1,1)2           Dirty map class
C   INSEQ     SEQ(1)    1           Dirty map sequence number
C   INDISK    VOL(1)    1           Dirty map volumn
C   BLC       BLC       7           Specifies the plane to CLEAN
C   IN2NAME   NAME(1,2) 3           Beam map name
C   IN2CLASS  CLASS(1,2)2           Beam map class
C   IN2SEQ    SEQ(2)    1           Beam map sequence number
C   IN2DISK   VOL(2)    1           Beam map volumn
C   OUTNAME   NAME(1,3) 3           Clean map name
C   OUTCLASS  CLASS(1,3)2           CLEAN map class
C   OUTSEQ    SEQ(3)    1           CLEAN map sequence number
C   OUTDISK   VOL(3)    1           CLEAN map volumn
C   OUTVER    CLNVER                CLEAN comp. file version #.
C   GAIN  *             1           CLEAN loop gain
C   FLUX  *   FMIN      1           Minimum CLEAN component(Jy)
C   PHAT      PHAT                  Prussian hat size.
C   NITER *   CLNLIM    1           Maximum number of CLEAN components
C                                   If neg. stop at first neg. comp.
C   BITER     CLNSTR    1           Restart using first CLSTART comps.
C   BMAJ  *   GAUSA     1           Major axis of CLEAN restoring beam
C                                   sigma of Gaussian in cells.
C   BMIN  *   GAUSB     1           Minor axis size of CLEAN beam.
C   BPA   *   GAUSC     1           Position angle (deg) of BMAJ
C   NBOXES    NBOXS     1           Number of boxes for CLEAN
C   CLBOX(4,50) WINM    200         Windows for the CLEAN boxes.
C   FACTOR*   SPEXP     1           Speed up factor
C   MAXPIXEL* MAXPIX    1           Maximum number of pixels searched in
C                                   major cycle.
C   DOTV  *   ITV       1           1 = request TV display of residual
C                                   maps and ask user if continue,
C                                   < 0 => no display or question
C   BADDISK   IBAD     10           Bad disk list.
C   Programmer = W. D. Cotton 1980
C-----------------------------------------------------------------------
      INTEGER   TVPASS, IDIR, IERR, IRET, USID, VOL(3), SEQ(3), ITV,
     *    CATBLK(256), KAP, NEED, I
      LOGICAL   FINISH, NEW, OLD, T, F, NOSUB, WFIRST, WASCLN, NORES,
     *   DOBEAM, NONEG, ONEPLN
      REAL      CATR(256), HISMAX, TEMP, PLNMAX, PLNMIN, PLNAMX
      CHARACTER HILINE*72, NAME(3)*12, CLASS(3)*6, REST*4
      DOUBLE PRECISION APCORE(2)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DAPM.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATR(1), CATBLK(1))
      DATA T, F /.TRUE.,.FALSE./
      DATA REST /'REST'/
C-----------------------------------------------------------------------
C                                       Free AP memory
      CALL QRLSE
      NCFILE = 0
      NSCR = 0
      TVPASS = 1
      FINISH = .FALSE.
      WASCLN = .FALSE.
      WFIRST = .TRUE.
C                                       Get input values.
      CALL GETIN (USID, NAME, VOL, CLASS, SEQ, ITV, IRET)
C                                       Check for restart of AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 990
C                                       Set NOSUB flag.
      NOSUB = F
      IF (CLNSTR.LT.0) NOSUB = T
      IF (CLNSTR.LT.0) CLNSTR = -CLNSTR
      IF (NOSUB) CLNLST = CLNSTR
      NORES = GAUSA.LT.0.0
      GAUSA = MAX (0.0, GAUSA)
C                                       Set NONEG flag.
      NONEG = CLNLIM.LT.0
      IF (NONEG) CLNLIM = - CLNLIM
C                                       Get map files and create
C                                       output files if required.
      CALL FILES (USID, NAME, VOL, CLASS, SEQ, OLD, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Decide if more than one plane
C                                       in image.
      ONEPLN = .NOT. ((CATBLK(KINAX+2).GT.1) .OR. (CATBLK(KINAX+3).GT.1)
     *   .OR. (CATBLK(KINAX+4).GT.1) .OR. (CATBLK(KINAX+5).GT.1)
     *   .OR. (CATBLK(KINAX+6).GT.1))
C                                       Get BEAM if not input.
      IF (GAUSA.NE.0.0) GO TO 10
      IF (CATR(KRBMJ).GE.0.0) THEN
         GAUSA = CATR(KRBMJ) * 3600.
         GAUSB = CATR(KRBMN) * 3600.
         GAUSC = CATR(KRBPA)
         END IF
C                                       If GAUSA=0 fit dirty beam.
 10   DOBEAM = GAUSA.EQ.0.0
      CALL BMSHP (DOBEAM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Write inputs to history and
C                                       log files.
      OLD = (OLD) .AND. (CLNSTR.GT.0)
C                                       OLD if higher plane no. or CC
C                                       file no.
      OLD = OLD .OR. (CLNVER.GT.1)
      CALL CLNHIS (NAME, VOL, CLASS, SEQ, OLD)
C                                       Make WEIGHT file.
      IDIR = 1
      NEED = 2 * NX * NY + NX + NY
      KAP = 8 * NY + 106 + 5 * 10000
      NEED = MAX (NEED, KAP)
      NEED = NEED / 1024
      CALL QINIT (APCORE, NEED, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
         NEED = 8 * NY + 106 + 5 * 10000 + 4 * NX
         NEED = NEED / 1024
         NEED = MIN (32 * 1024, NEED) + 2
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            IRET = 8
            MSGTXT = 'UNABLE TO GET DESIRED MEMORY'
            CALL MSGWRT (8)
            GO TO 990
            END IF
         END IF
      CALL QCLNSZ (APCORE, APSIZ)
      MAXPCH = SQRT ((APSIZ-1026.)/2.) - 1
      MAXPCH = MIN (BMHSIZ, MAXPCH) - 1
      I = (APSIZ - BMOFFS - (BMHSIZ+1) * (2*BMHSIZ + 1)) / 3 - 10
      MAXPIX = MIN (MAXPIX, I)
      CALL APDFFT (APCORE, IDIR, IRET)
      IF (IRET.NE.0) GO TO 990
      CALL QRLSE
C                                       See if restore only requested.
      IF (CLNSTR.GE.CLNLIM) THEN
         FINISH = .TRUE.
         GO TO 200
         END IF
      WASCLN = .TRUE.
C                                       Compute BEAM histogram.
      CALL HISTOB (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       If restarting sub. clean comp.
      NEW = .TRUE.
      IF ((CLNSTR.LE.0) .OR. (NOSUB)) GO TO 50
         WRITE (MSGTXT,1025) CLNSTR
         CALL MSGWRT (4)
         NEW = .FALSE.
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            IRET = 8
            MSGTXT = 'UNABLE TO GET DESIRED MEMORY (2)'
            CALL MSGWRT (8)
            GO TO 990
            END IF
         CALL GRIDER (APCORE, WFIRST, IRET)
         IF (IRET.NE.0) GO TO 990
         WFIRST = F
         IDIR = -1
         CALL APDFFT (APCORE, IDIR, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Release and reaquire AP
         CALL QRLSE
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            IRET = 8
            MSGTXT = 'UNABLE TO GET DESIRED MEMORY (3)'
            CALL MSGWRT (8)
            GO TO 990
            END IF
C                                       Make pass through ADDMAP to get
C                                       maximum
         CALL ADDMAP (APCORE, NEW, PLNMAX, PLNMIN, IRET)
         IF (IRET.NE.0) GO TO 990
         CALL QRLSE
C                                       Determine new RESMAX.
         RESMAX = MAX (ABS(TVREMX), ABS(TVREMN))
C                                       Initialize RESIDUAL map.
 50   NOSUB = F
      CALL QINIT (APCORE, NEED, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
         IRET = 8
         MSGTXT = 'UNABLE TO GET DESIRED MEMORY (4)'
         CALL MSGWRT (8)
         GO TO 990
         END IF
 60   CALL ADDMAP (APCORE, NEW, PLNMAX, PLNMIN, IRET)
      IF (IRET.NE.0) GO TO 990
      TEMP = MAX (ABS(TVREMX), ABS(TVREMN))
C                                       Check if histogram max. OK.
      IF ((.NOT.NEW) .OR. (TEMP.GT.(0.9*ABS (RESMAX)))) GO TO 70
C                                       Redo ADDMAP for better
C                                       histogram.
         WRITE (MSGTXT,1060) TEMP, RESMAX
C                                       Warn only if really a problem
         PLNAMX = MAX (ABS (PLNMAX), ABS (PLNMIN))
         IF (TEMP.LT.(0.9*PLNAMX)) CALL MSGWRT (8)
         RESMAX = TEMP
         GO TO 60
C                                       Display current residual map.
 70   IF (ITV.EQ.1) CALL DISPTV (TVPASS)
      IF (ITV.NE.1) CALL QRLSE
      IF (ITV.EQ.1) TVPASS = 2
C                                       Begin CLEANing.
 100  CONTINUE
         CALL TOUCH
         CALL APCTEL (FINISH, NORES, NONEG, ITV, IRET)
         IF (IRET.NE.0) GO TO 990
         IF (ITV.NE.1) TVPASS = 1
         IF (.NOT.FINISH) GO TO 110
            CALL QINIT (APCORE, NEED, 0, KAP)
            IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
               IRET = 8
               MSGTXT = 'UNABLE TO GET DESIRED MEMORY (5)'
               CALL MSGWRT (8)
               GO TO 990
               END IF
            GO TO 210
 110     CALL DECIDE
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            IRET = 8
            MSGTXT = 'UNABLE TO GET DESIRED MEMORY (6)'
            CALL MSGWRT (8)
            GO TO 990
            END IF
         CALL MAPPAK (APCORE, IRET)
         IF (IRET.NE.0) GO TO 990
         CALL BMSHOV (APCORE, IRET)
         IF (IRET.NE.0) GO TO 990
         CALL ACLN (APCORE, NONEG, FINISH, IRET)
         IF (IRET.NE.0) GO TO 990
         HISMAX = RESMAX
         CALL QRLSE
C                                       Create grid file
 200  CONTINUE
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            IRET = 8
            MSGTXT = 'UNABLE TO GET DESIRED MEMORY (7)'
            CALL MSGWRT (8)
            GO TO 990
            END IF
         CALL GRIDER (APCORE, WFIRST, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       WFIRST = .TRUE. iff first write
C                                       onto grid file.
         WFIRST = F
C                                       Restore if finished.
 210     CALL APCTEL (FINISH, NORES, NONEG, ITV, IRET)
         IF (IRET.NE.0) GO TO 990
         IF (ITV.NE.1) TVPASS = 1
         IF ((FINISH) .AND. (.NOT.NORES)) CALL RESTOR (APCORE, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       FFT to map plane.
         IDIR = -1
         CALL APDFFT (APCORE, IDIR, IRET)
         CALL QRLSE
         IF (IRET.NE.0) GO TO 990
C                                       Reaquire AP
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            IRET = 8
            MSGTXT = 'UNABLE TO GET DESIRED MEMORY (8)'
            CALL MSGWRT (8)
            GO TO 990
            END IF
C                                       Subtract from dirty map.
         CALL ADDMAP (APCORE, F, PLNMAX, PLNMIN, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Determine RESMAX if finished.
         IF (FINISH) THEN
            RESMAX = MAX (ABS (PLNMAX), ABS (PLNMIN))
C                                       Display current residual map.
            IF (TVPASS.GE.2) TVPASS = 3
            IF (TVPASS.EQ.1) TVPASS = 0
            TVREMX = PLNMAX
            TVREMN = PLNMIN
            TVFMAX = TVREMX
            TVFMIN = TVREMN
            END IF
         IF (ITV.EQ.1) CALL DISPTV (TVPASS)
         IF (ITV.NE.1) CALL QRLSE
         IF (TVPASS.EQ.32700) THEN
            FINISH = .TRUE.
            CALL QINIT (APCORE, NEED, 0, KAP)
            IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
               IRET = 8
               MSGTXT = 'UNABLE TO GET DESIRED MEMORY (9)'
               CALL MSGWRT (8)
               GO TO 990
               END IF
            GO TO 210
            END IF
         IF (ITV.EQ.1) TVPASS = 2
C                                       Update CLEAN catalog header
         CATBLK(KINIT) = CLNSTR
         CATR(KRBMJ) = GAUSA / 3600.
         CATR(KRBMN) = GAUSB / 3600.
         CATR(KRBPA) = GAUSC
         CATBLK(KITYP) = 1
         CATR(KRDMX) = MAX (CATR(KRDMX), PLNMAX)
         CATR(KRDMN) = MIN (CATR(KRDMN), PLNMIN)
         IF (ONEPLN) CATR(KRDMX) = PLNMAX
         IF (ONEPLN) CATR(KRDMN) = PLNMIN
         IF (NORES) CATBLK(KITYP) = 3
         IF ((GAUSA.GT.0.0) .AND. (GAUSA.LT.1.E-5)) CATBLK(KITYP) = 4
         CALL CATIO ('UPDT', VOL(3), CCNO, CATBLK, REST, BUFF3, IERR)
         IF ((IERR.EQ.0) .OR. (IERR.GE.5)) GO TO 250
            WRITE (MSGTXT,1200) IERR
            CALL MSGWRT (8)
C                                       If more cleaning required,
C                                       loop.
 250     IF (.NOT.FINISH) GO TO 100
C                                       Clear  map files
      IRET = IERR
      IF ((IERR.NE.0) .AND. (IERR.LT.9)) GO TO 990
C                                       History
      CALL HIOPEN (LUNCL1, VOL(3), CCNO, BUFF1, IERR)
C                                       Plane number
      WRITE (HILINE,1254) TSKNAM, BLC(3)
      IF (BLC(3).GT.1) CALL HIADD (LUNCL1, HILINE, BUFF1, IERR)
C                                        Write total CLEANed flux
      WRITE (HILINE,1250) TSKNAM, FLUX
      CALL HIADD (LUNCL1, HILINE, BUFF1, IERR)
C                                       Tell if comps. NOT restored
      WRITE (HILINE,1253) TSKNAM
      IF (NORES) CALL HIADD (LUNCL1, HILINE, BUFF1, IERR)
C                                       Write number of iterations
C                                       actually done.
      WRITE (HILINE,1251) TSKNAM, CLNSTR
      CALL HIADD (LUNCL1, HILINE, BUFF1, IERR)
      IF (WASCLN) THEN
         WRITE (HILINE,1252) TSKNAM, HISMAX
         CALL HIADD (LUNCL1, HILINE, BUFF1, IERR)
         END IF
      CALL HICLOS (LUNCL1, T, BUFF1, IERR)
C                                        Finished.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
C-----------------------------------------------------------------------
 1025 FORMAT ('Restart CLEAN at comp ',I8)
 1060 FORMAT ('*** WARNING: ABS(WINDOW) MAX =',F9.5,' ABS(MAP) MAX =',
     *   F9.5)
 1200 FORMAT ('ERROR',I3,' UPDATING CLEAN HEADER ')
 1250 FORMAT (A6,' /Total CLEANed flux density = ',1PE12.4,' Jy')
 1251 FORMAT (A6,' /Number of iterations done =',I8)
 1252 FORMAT (A6,' /Peak residual =',1PE12.4,' Jy/beam')
 1253 FORMAT (A6,' / Components not restored to image')
 1254 FORMAT (A6,' / Clean of plane ',I4)
      END
      SUBROUTINE ACLN (APCORE, NONEG, FINISH, IERR)
C-----------------------------------------------------------------------
C   ACLN does a limited clean of the Barry Clark variety using the
C   highest map points and limited beam stored in the AP.
C   INPUT:
C     NONEG  L     IF .TRUE. then stop at first negative component.
C     LUNCL1 I   = Logical unit number for reading the clean components.
C     LUNCL2 I   = Logical unit number for writing the clean components.
C     CLNFIL I   = File name array for the clean component file.
C     GAIN   R   = Clean loop gain.
C     PTRK   I   = Number of map points in the AP.
C     PTRJ   I   = first location in the AP of the beam.
C     CLNSTR I   = First clean component to do. (0 for first clean).
C     CLNLIM I   = Maximum number of clean components desired.
C
C     OUTPUT:
C     CLNSTR I   = Current clean component number.
C     FINISH L   = .TRUE. If minimum clean component flux density
C                  or maximum iteration encountered, otherwise
C                  = .FALSE.
C     RESMAX R   = Maximum abs. residual (Jy).
C     A list of the clean components on file CLNFIL.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      LOGICAL   NONEG, FINISH
      INTEGER   IERR
C
      CHARACTER KEYS(4)*8, PREFIX*5
      LOGICAL   LERR, FA
      INTEGER   ITER, JPTR, NCOMPC, LENCBU, APFDV, COMP, IBUFF(512),
     *   NREC, CATBLK(256), IRET, I, NCBUFF, IPOINT
      REAL      ATLIM, XFAC, XFLUX, XPROD,
     *   CATR(256), XCENTR, YCENTR
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK(1), CATR(1))
      EQUIVALENCE (BUFF1(1), IBUFF(1))
C                                       LENCBU, NCOMPC control the
C                                       no. CC per AP call.
      DATA LENCBU, NCOMPC /137, 32/
      DATA FA /.FALSE. /
      DATA KEYS /'DELTAX  ', 'DELTAY  ', 'FLUX    ',
     *   'TYPE OBJ'/
      DATA APFDV, COMP /2, 9/
C-----------------------------------------------------------------------
C                                       setup values in AP
C                                       beam patch size
      BUFF2(1) = PATCH
      BUFF2(2) = PATCH
C                                       Field descriptor vector
      BUFF2(3) = 1.0
      BUFF2(4) = BMOFFS
      BUFF2(5) = PTRK
      BUFF2(6) = 0.0
      BUFF2(7) = 0.0
      BUFF2(8) = 0.0
      BUFF2(9) = GAIN
C                                       Components vector
      BUFF2(10) = 0.0
      BUFF2(11) = 0.0
      BUFF2(12) = 0.0
      BUFF2(13) = 0.0
      CALL QPUT (APCORE, BUFF2, 0, 13, 2)
C                                       put address as integer
      I = BMOFFS
      IDUM(1) = I
      CALL QPUT (APCORE, RDUM, 3, 1, 1)
C                                       Open CLNFIL for reading
      NREC = 5000
      IF (CLNLIM-CLNSTR.LT.4990)  NREC = CLNLIM - CLNSTR + 10
      CCNCOL = 3
      CALL CCMINI ('WRIT', CCBUFF, CLNVOL, FCNO(3), CLNVER, CATBLK,
     *   LUNCL2, CCRNO, CCKOLS, CCNUMV, CCNCOL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CLNSTR = CLNSTR + 1
      XCENTR = CATR(KRCRP)
      YCENTR = CATR(KRCRP+1)
C                                       Prepare to CLEAN
      JPTR = PTRJ
      CALL QWD
C                                       Start CLEANing.
      CALL QMULCL (APCORE, COMP, APFDV, JPTR, 0, NCOMPC)
      ITER = CLNSTR
C                                       Speed up clean.
      XFAC = MAPLIM / RESMAX
      IF (XFAC.LT.0.0) XFAC = -XFAC
      XPROD = XFAC**SPEXP
      XFAC = XPROD
      ATLIM = 0.0
      CALL QWR
      NCBUFF = NCOMPC
C                                       Begin loop.
 30   NCBUFF = NCBUFF + 1
C                                       See if time to get more from
C                                       the AP.
         IF (NCBUFF.GT.NCOMPC) THEN
            CALL QWR
C                                       Check AP roller.
            CALL QROLL (APCORE, APSIZ, BUFF3, BUFSZ3, IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Get next load of components.
            CALL QGET (APCORE, BUFF2, 0, LENCBU, 2)
C                                       Load last comp. for CLEAN.
            CALL QWD
C                                       Start CLEANing again.
            CALL QMULCL (APCORE, COMP, APFDV, JPTR, 0, NCOMPC)
            NCBUFF = 1
            END IF
C                                       Process a Component.
         IPOINT = 10 + (NCBUFF-1) * 4
C                                       Get component
         CCTYPE = 0
         XX = (BUFF2(IPOINT+1) - XCENTR) * XSPACE
         YY = (BUFF2(IPOINT+2) - YCENTR) * YSPACE
         FLUX = FLUX + BUFF2(IPOINT) * GAIN
C                                       Stored RA and Dec refer to
C                                       the catalogd CLEAN map.
         CCFLUX = BUFF2(IPOINT) * GAIN
         CCRNO = ITER
         CALL TABCCM ('WRIT', CCBUFF, CCRNO, CCKOLS, CCNUMV, CCNCOL, XX,
     *      YY, ZZ, CCFLUX, CCTYPE, PARMS, IERR)
         IF (IERR.EQ.4) THEN
            WRITE (MSGTXT,1030) ITER
            CALL MSGWRT (8)
            END IF
         IF (IERR.NE.0) GO TO 999
         XFLUX = BUFF2(IPOINT)
C                                       Check for iteration limit.
         IF (ITER.GE.CLNLIM) THEN
            CALL METSCA (XFLUX, PREFIX, LERR)
            WRITE (MSGTXT,1110) ITER, XFLUX, PREFIX
            CALL MSGWRT (4)
C                                       Check for minimum CLEAN flux
C                                       Check for negative comp.
         ELSE IF ((ABS(BUFF2(IPOINT)).LT.FMIN) .OR.
     *      ((NONEG) .AND. (BUFF2(IPOINT).LT.0.0))) THEN
C                                       Finished minor CLEAN loop.
            CALL METSCA (XFLUX, PREFIX, LERR)
            WRITE (MSGTXT,1090) XFLUX, PREFIX, ITER
            CALL MSGWRT (4)
C                                       Check minimum algorithm flux
C                                       Do not stop in last 5%
         ELSE IF ((ABS(BUFF2(IPOINT)).LT.MAPLIM*(1.0+ATLIM)) .AND.
     *      (ITER.LT.0.95*CLNLIM)) THEN
            CALL METSCA (XFLUX, PREFIX, LERR)
            WRITE (MSGTXT,1100) XFLUX, PREFIX, ITER
            CALL MSGWRT (4)
C                                       Loop back for next clean.
         ELSE
            ITER = ITER + 1
C                                       Include no. comps. sub from
C                                       the dirty map.
            ATLIM = ATLIM + XFAC / (ITER + PRECLN)
            GO TO 30
            END IF
C                                       Save maximum residual
      RESMAX = ABS (BUFF2(IPOINT))
C                                       See if finished.
      FINISH = .FALSE.
      IF (ITER.GE.CLNLIM) FINISH = .TRUE.
      IF (RESMAX.LE.FMIN) FINISH = .TRUE.
      IF (NONEG.AND.(BUFF2(IPOINT).LT.0.0)) FINISH = .TRUE.
C                                       Write total flux density
      XFLUX = FLUX
      CALL METSCA (XFLUX, PREFIX, LERR)
      WRITE (MSGTXT,1120) XFLUX, PREFIX
      CALL MSGWRT (4)
C                                       Output last buffer and close.
      CALL TABCCM ('CLOS', CCBUFF, CCRNO, CCKOLS, CCNUMV, CCNCOL, XX,
     *   YY, ZZ, CCFLUX, CCTYPE, PARMS, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1015) IERR
         CALL MSGWRT (8)
         END IF
C                                       Set CLNSTR to the current clean
C                                       counter (NCOMP - 1 ).
      CLNSTR = ITER
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ACLN: ERROR',I3,' OPENING FILE ')
 1015 FORMAT ('ACLN: ERROR',I3,' CLOSING FILE ')
 1030 FORMAT ('ACLN: ITER. ',I8,' CC FILE LIMIT EXCEEDED')
 1090 FORMAT ('Reached min. clean flux density=',F8.3,1X,A5,'Jy',
     *   ' iter=',I8)
 1100 FORMAT ('Reached min. algorithm flux =',F8.3,1X,A5,'Jy',
     *   ' iter =',I8)
 1110 FORMAT ('Reached iteration limit',I8,' max. res=',F8.3,1X,A5,
     *   'Jy')
 1120 FORMAT ('Total CLEANed flux density =',F8.3,1X,A5,'Jy')
      END
      SUBROUTINE ADDMAP (APCORE, FIRST, RMAX, RMIN, IERR)
C-----------------------------------------------------------------------
C   ADDMAP adds the transformed GRID map to the Dirty map producing
C   the residual map or the CLEAN  map depending on whether or not
C   RESTOR was run. If FIRST is TRUE then the dirty map is copied
C   to the residual map file.
C   The transformed grid file is assumed to be in the WRK file.
C   Also computes the histogram of residual map values.
C   INPUT:
C     FIRST  L     If TRUE the dirty map is copied to the residual map.
C   OUTPUT:
C     RMAX    R   Maximum in residual/restored map.
C     RMIN    R   Minimum in residual/restored map.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   FIND1, FIND2, FIND3, BIND1, BIND2, BIND3, WIN(4),
     *   I, IBOX, IERR, J, LIMIT
      INTEGER   IAPSCL, IAPMAX, IAPMIN, IAPRES, PNUMIN,
     *   IAPHIS, IAPHMX, IAPHMN, ISTART, SIZE, IAPSUM, MX, ONENX
      LOGICAL   FIRST, MAP, EXCL, WAIT
      REAL      RMAX, RMIN, TMAX, TMIN, XTEMP(8), YTEMP(3), TEMP
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (TMAX, YTEMP(1)),      (TMIN, YTEMP(3))
      DATA MAP, EXCL, WAIT /.TRUE., 2*.TRUE./
      DATA IAPSCL, IAPMAX, IAPMIN, IAPHMX, IAPHMN, IAPRES
     *   /    0,      2,      4,      6,      7,      10/
C-----------------------------------------------------------------------
C                                       Initialize extrema.
      RMAX = -1.0E20
      RMIN =  1.0E20
      TVREMX = RMAX
      TVREMN = RMIN
C                                       Setup AP locations.
C                                         0 =
C                                         1 =
C                                         2 = MAX    (IAPMAX)
C                                         4 = MIN    (IAPMIN)
C                                         6 = Hist. max. (IAPHMX)
C                                         7 = Hist. min. (IAPHMN)
C                                        10 = Residual map (IAPRES)
C                                        IAPRES+NX+1 Dirty & Sum(IAPSUM)
C                                        IAPSUM+NX+1 Histogram (IAPHIS)
      ONENX = NX
      PNUMIN = NUMBIN + 1
      SIZE = ONENX + 1
      IAPSUM = IAPRES + SIZE
      IAPHIS = IAPSUM + SIZE
C                                       Clear AP area for Residual map.
      CALL QVCLR (APCORE, IAPRES, 1, ONENX)
C                                       Clear Histogram.
      CALL QVCLR (APCORE, IAPHIS, 1, PNUMIN)
C                                       Open and INIT files.
      CALL ZOPEN (LUNDRT, FIND1, DRTVOL, DRTFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
      CALL ZOPEN (LUNWRK, FIND2, WRKVOL, WRKFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
      CALL ZOPEN (LUNRES, FIND3, RESVOL, RESFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1030) IERR
         GO TO 990
         END IF
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NX
      WIN(4) = NY
      CALL MINIT ('READ', LUNDRT, FIND1, NX, NY, WIN, BUFF1, BUFSZ1,
     *   BODRT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      CALL MINIT ('READ', LUNWRK, FIND2, NX, NY, WIN, BUFF2, BUFSZ2,
     *   BOWRK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
      CALL MINIT ('WRIT', LUNRES, FIND3, NX, NY, WIN, BUFF3, BUFSZ3,
     *   BORES, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
C                                       Load His maxmin
      XTEMP(1) = 1.0
      XTEMP(2) = 0.0
      XTEMP(7) = RESMAX
      XTEMP(8) = 0.0
      CALL QPUT (APCORE, XTEMP, IAPSCL, 8, 2)
C                                       Loop thru map.
      DO 150 I = 1,NY
C                                       Read dirty map.
         CALL MDISK ('READ', LUNDRT, FIND1, BUFF1, BIND1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1070) IERR, I
            GO TO 990
            END IF
C                                       Write output.
         CALL MDISK ('WRIT', LUNRES, FIND3, BUFF3, BIND3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR, I
            GO TO 990
            END IF
C                                       If FIRST = .FALSE. read residual
         IF (.NOT.FIRST) THEN
            CALL MDISK ('READ', LUNWRK, FIND2, BUFF2, BIND2, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1105) IERR,I
               GO TO 990
               END IF
            END IF
C                                       Load dirty map (if nec.)
         CALL QWR
         CALL QPUT (APCORE, BUFF1(BIND1), IAPSUM, ONENX, 2)
         CALL QWD
C                                       Load residual row (FIRST=false)
         IF (.NOT.FIRST) THEN
            CALL QWR
            CALL QPUT (APCORE, BUFF2(BIND2), IAPRES, ONENX, 2)
            CALL QWD
C                                       Add rows.
            CALL QVADD (APCORE, IAPSUM, 1, IAPRES, 1, IAPSUM, 1, ONENX)
            END IF
C                                       Find max and min in row.
         CALL QMAXV (APCORE, IAPSUM, 1, IAPMAX, ONENX)
         CALL QMINV (APCORE, IAPSUM, 1, IAPMIN, ONENX)
C                                       Read results.
         CALL QWR
         CALL QGET (APCORE, BUFF3(BIND3), IAPSUM, ONENX, 2)
         CALL QGET (APCORE, YTEMP, IAPMAX, 3, 2)
         CALL QWD
C                                       Note use of EQUIVALENCE.
C                                       Save max and min.
         RMAX = MAX (RMAX, TMAX)
         RMIN = MIN (RMIN, TMIN)
C                                       Compute histogram of residuals.
         DO 120 IBOX = 1,NBOXS
            IF ((I.GE.WINM(2,IBOX)) .AND. (I.LE.WINM(4,IBOX))) THEN
               ISTART = IAPSUM + WINM(1,IBOX) - 1
               MX = (WINM(3,IBOX) - WINM(1,IBOX)) + 1
               IF (MX.LT.0) MX = - MX + 2
               CALL QMAXV (APCORE, ISTART, 1, IAPMAX, MX)
               CALL QMINV (APCORE, ISTART, 1, IAPMIN, MX)
               CALL QWR
               CALL QGET (APCORE, YTEMP, IAPMAX, 3, 2)
               CALL QWD
               TVREMN = MIN (TVREMN, TMIN)
               TVREMX = MAX (TVREMX, TMAX)
               CALL QVABS (APCORE, ISTART, 1, ISTART, 1, MX)
               CALL QHIST (APCORE, ISTART, 1, IAPHIS, MX, PNUMIN,
     *            IAPHMX, IAPHMN)
               END IF
 120        CONTINUE
 150     CONTINUE
C                                       Finish write.
      CALL MDISK ('FINI', LUNRES, FIND3, BUFF3, BIND3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1150) IERR
         GO TO 990
         END IF
C                                       Close files.
      CALL ZCLOSE (LUNDRT, FIND1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1160) IERR
         CALL MSGWRT (8)
         END IF
      CALL ZCLOSE (LUNWRK, FIND2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1170) IERR
         CALL MSGWRT (8)
         END IF
      CALL ZCLOSE (LUNRES, FIND3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1180) IERR
         CALL MSGWRT (8)
         END IF
C                                       Get histogram from AP.
      CALL QWR
      CALL QGET (APCORE, BUFF2, IAPHIS, PNUMIN, 2)
      CALL QWD
C                                       Integrate histogram.
      BUFF2(NUMBIN) = BUFF2(NUMBIN) + BUFF2(NUMBIN+1)
      RESHIS(NUMBIN) = BUFF2(NUMBIN)
      LIMIT = NUMBIN - 1
      DO 200 I = 1,LIMIT
         J = NUMBIN - I + 1
         TEMP = RESHIS(J)
         TEMP = TEMP + BUFF2(J-1)
         RESHIS(J-1) = TEMP + 0.5
 200     CONTINUE
      RESHIS(NUMBIN+1) = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ADDMAP: CANNOT OPEN DIRTY FILE, ERROR ',I3)
 1020 FORMAT ('ADDMAP: CANNOT OPEN FOR READ RESIDUAL MAP, ERROR ',I3)
 1030 FORMAT ('ADDMAP: CANNOT OPEN FOR WRITE RESIDUAL MAP, ERROR ',I3)
 1040 FORMAT ('ADDMAP: CANNOT INIT DIRTY MAP, ERROR ',I3)
 1050 FORMAT ('ADDMAP: CANNOT INIT READ RESIDUAL MAP, ERROR ',I3)
 1060 FORMAT ('ADDMAP: CANNOT INIT WRITE RESIDUAL MAP, ERROR ',I3)
 1070 FORMAT ('ADDMAP: READ ERROR ',I3,' DIRTY FILE ROW ',I6)
 1105 FORMAT ('ADDMAP: READ ERROR ',I3,' RESIDUAL MAP ROW ',I6)
 1100 FORMAT ('ADDMAP: WRITE ERROR ',I3,' RESIDUAL ROW ',I6)
 1150 FORMAT ('ADDMAP: FINISH ERROR ',I3,' RESIDUAL FILE')
 1160 FORMAT ('ADDMAP: CLOSE ERROR ',I3,' DIRTY MAP ')
 1170 FORMAT ('ADDMAP: CLOSE ERROR ',I3,' READ RESIDUAL FILE')
 1180 FORMAT ('ADDMAP: CLOSE ERROR ',I3,' WRITE RESIDUAL FILE ')
      END
      SUBROUTINE APDFFT (APCORE, IDIR, IERR)
C-----------------------------------------------------------------------
C   APDFFT calls AP FFT routines PASS1 and PASS2.  If the transform
C   can be done all in the AP this is done; if not then a transpose
C   of the type designed by F. Schwab is done.
C   For the forward transform the Beam map is tranformed to the
C   weight file and on the reverse transform the GRID file is
C   transformed to the WORK file. The contents of the GRID file are
C   destroyed.
C   The beam is assumed in file GRD.
C   Input:
C     IDIR       I    1 for forward transform, -1 for reverse,
C     BOGRD      I    Block offset of beam map.
C     GRDVOL     I    Volume for beam map.
C     GRDFIL     C    Physical name of  Beam map.
C     LUNGD1     I    LUN for Beam map.
C     BOGRD      I    Block offset of GRID file.
C     GRDVOL     I    Volume for GRID file.
C     GRDFIL     C    Physical name of GRID file.
C     LUNGD1     I    LUN for GRID file.
C     BOWT       I    Block offset of weight file.
C     WTVOL      I    Volume for weight file.
C     WTFIL      C    Physical name of weight file.
C     LUNWT      I    LUN for weight file.
C     BORES      I    Block offset for residual map.
C     RESVOL     I    Volume for residual map.
C     RESFIL     C    Physical name of residual map.
C     LUNRES     I    LUN for residual map.
C     BOWRK      I    Block offset for WORK file.
C     WRKVOL     I    Volume for work file.
C     WRKFIL     C    Physical name of WORK file.
C     LUNWRK     I    LUN for WORK file.
C     BUFF1(),BUFF2()  I    Work buffers for I/O.
C     BUFSZ1,BUFSZ2    I    Size in bytes of BUFF1 and BUFF2.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   IERR, JDIR
      INTEGER   IDIR, LUN(3), BO(3), VOL(3)
      LOGICAL   FULL
      REAL      SMAX, SMIN
      CHARACTER FIL(3)*48
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA FULL /.FALSE./
C-----------------------------------------------------------------------
C                                       REAL TO COMPLEX
C                                       Set file information.
C                                       1 = Beam, 2 = Work, 3 = Weight
      IF (IDIR.GE.0) THEN
         BO(1) = BOGRD
         BO(2) = BOWRK
         BO(3) = BOWT
         VOL(1) = GRDVOL
         VOL(2) = WRKVOL
         VOL(3) = WTVOL
         LUN(1) = LUNGD1
         LUN(2) = LUNWRK
         LUN(3) = LUNWT
         FIL(1) = GRDFIL
         FIL(2) = WRKFIL
         FIL(3) = WTFIL
C                                       Do disk based FFT.
         JDIR = 3
         CALL PASS1 (APCORE, JDIR, FULL, LUN, VOL, FIL, BO, BUFF1,
     *      BUFSZ1, BUFF2, BUFSZ2, NX, NY, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL PASS2 (APCORE, JDIR, FULL, LUN, VOL, FIL, BO, BUFF1,
     *      BUFSZ1, BUFF2, BUFSZ2, NX, NY, SMAX, SMIN, IERR)
C                                       COMPLEX TO REAL
C                                       Set file information.
C                                       1 = Grid, 2 = Resid, 3 = Work
      ELSE
         BO(1) = BOGRD
         BO(2) = BORES
         BO(3) = BOWRK
         VOL(1) = GRDVOL
         VOL(2) = RESVOL
         VOL(3) = WRKVOL
         LUN(1) = LUNGD1
         LUN(2) = LUNWRK
         LUN(3) = LUNRES
         FIL(1) = GRDFIL
         FIL(2) = RESFIL
         FIL(3) = WRKFIL
C                                       Do disk based FFT.
         CALL PASS1 (APCORE, IDIR, FULL, LUN, VOL, FIL, BO, BUFF1,
     *      BUFSZ1, BUFF2, BUFSZ2, NX, NY, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL PASS2 (APCORE, IDIR, FULL, LUN, VOL, FIL, BO, BUFF1,
     *      BUFSZ1, BUFF2, BUFSZ2, NX, NY, SMAX, SMIN, IERR)
         END IF
C
 999  RETURN
      END
      SUBROUTINE BMSHOV (APCORE, IERR)
C-----------------------------------------------------------------------
C   BMSHOV loads the beam patch into the array processor.
C   Beam assumed catalogd
C   Input :
C      LUNBEM I   = Logical unit number for the beam map file.
C      BEMFIL I   = Name of the beam map file.
C      PATCH  I   = Beam patch half size (cells).
C      BPBEM  I   = Bytes / pixel for beam map.
C      BOBEM  I   = Blok offset for the beam map.
C      APSIZ  I   = Size of array processor in words.
C      PTRJ   I   = AP location of beginning of beam.
C      ICENX  I   = Offset of center of beam map in X from NX/2+1
C      ICENY  I   = Offset of center of beam map in Y from NY/2+1
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   FIND, BIND, IERR, I, MSIZE
      INTEGER   IPTR, PPATCH, TWOPAT, CORE
      LOGICAL   MAP, EXCL, WAIT
      REAL      RTEMP
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA MAP, EXCL, WAIT /3*.TRUE./
C-----------------------------------------------------------------------
C                                      Set window for beam patch.
      WINB(1) = NX / 2 + 1 + ICENX
      WINB(2) = NY / 2 - PATCH + 2 + ICENY
      WINB(3) = NX / 2 + PATCH + ICENX
      WINB(4) = NY / 2 + PATCH + ICENY
      PPATCH = PATCH
      TWOPAT = 2 * PATCH - 1
C                                      Check to make sure the beam
C                                      patch will fit in the AP.
      CORE = PTRJ + PPATCH * (2 * PPATCH - 1)
      IF (CORE.GE.APSIZ) THEN
         WRITE (MSGTXT,1000) CORE
         GO TO 990
         END IF
C                                      Open beam file.
      CALL ZOPEN (LUNBEM, FIND, BEMVOL, BEMFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1005) IERR
         GO TO 990
         END IF
C                                      Initialize beam map.
      CALL MINIT ('READ', LUNBEM, FIND, NX, NY, WINB, BUFF1, BUFSZ1,
     *   BOBEM, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         GO TO 990
         END IF
C                                       Loop thru beam & shove into AP
      IPTR = PTRJ
      MSIZE = 2 * PATCH - 1
      DO 30 I = 1,MSIZE
C                                      Read row of the map.
         CALL MDISK ('READ', LUNBEM, FIND, BUFF1, BIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1015) IERR, I
            GO TO 990
            END IF
C                                      Load row into AP.
         CALL QWR
         CALL QPUT (APCORE, BUFF1(BIND), 2, PPATCH, 2)
         CALL QWD
         CALL QVMOV (APCORE, 2, 1, IPTR, TWOPAT, PPATCH)
C                                       Add offset to center of beam
         IF ((I.EQ.PATCH).AND.(PHAT.GT.1.0E-10)) THEN
            CALL QWR
            CALL QGET (APCORE, RDUM, IPTR, 1, 2)
            RTEMP = RDUM(1)
            WRITE (MSGTXT,1025) RTEMP
            CALL MSGWRT (4)
            RTEMP = 1.0 + PHAT
            RDUM(1) = RTEMP
            CALL QPUT (APCORE, RDUM, IPTR, 1, 2)
            CALL QGET (APCORE, RDUM, IPTR, 1, 2)
            RTEMP = RDUM(1)
            CALL QWD
            WRITE (MSGTXT,1026) RTEMP
            CALL MSGWRT (4)
            END IF
         IPTR = IPTR + 1
 30      CONTINUE
C                                      Close beam file.
      CALL ZCLOSE (LUNBEM, FIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (8)
         END IF
C                                       Roll AP if necessary.
C                                       Save all of AP memory.
      CALL QROLL (APCORE, APSIZ, BUFF1, BUFSZ1, IERR)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BMSHOV: YOU NEED ',I8,' WORDS OF AP CORE ')
 1005 FORMAT ('BMSHOV: ERROR',I3,' OPENING FILE ')
 1010 FORMAT ('BMSHOV: ERROR',I3,' INIT FILE ')
 1015 FORMAT ('BMSHOV: READ ERROR',I3,' ROW ',I5)
 1025 FORMAT ('BMSHOV: Old beam peak = ',1PE12.4)
 1026 FORMAT ('BMSHOV: New beam peak = ',1PE12.4)
 1030 FORMAT ('BMSHOV: ERROR',I3,' CLOSING FILE ')
      END
      SUBROUTINE BMSHP (DOBEAM, IERR)
C-----------------------------------------------------------------------
C   BMSHP fits an eliptical Gaussian to the dirty beam (DOBEAM true)
C   and checks that the peak of the beam is 1.0.  If peak of beam is
C   too narrow to fit a default circular Gaussian is used.
C   A grid of up to 5 X 11 points is used for the fit; only points
C   within the half power points are used.  To avoid degenerate
C   cases some of the allowed points are ignored.
C   Solution is by least squares to a linearized gaussian.
C   Beam R   map assumed in GRD file.
C    Input:  The beam map centered at (NX/2+1,NY/2+1)
C     XSPACE    R   Grid spacing in RA (deg)
C     YSPACE    R   Grid spacing in Dec (deg.)
C     MAPROT    R   Coordinate rotation.
C    Output:
C     GAUSA     R    Major axis size (FWHP in sec).
C     GAUSB     R    Minor axis size (FWHP in sec).
C     GAUSC     R    Position angle of major axis (degrees).
C-----------------------------------------------------------------------
      LOGICAL   MAP, EXCL, WAIT, DOBEAM, FA
      INTEGER   FIND, BIND, WIN(4), IERR, TRY, I, IFLIP, IJK, ILAST,
     *   IROW, J, K, L, SIZE
      REAL      X(3,3), Y(3), P(3), BMAP(1), DX, DY, XFACT,
     *   BABS, BDIF, BASE
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (BMAP(1), BUFF1(1))
      DATA MAP, EXCL, WAIT / .TRUE., 2*.TRUE./
      DATA FA /.FALSE./
C-----------------------------------------------------------------------
      NOFIT = FA
      TRY = 0
      IFLIP = 1
      XFACT = ABS (XSPACE) * 3600.
C                                       window size
      SIZE = 5
C                                       fit cut-off
      BASE = 0.35
C                                       Open beam file.
      CALL ZOPEN (LUNGD1, FIND, GRDVOL, GRDFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Zero work arrays.
      DO 20 I = 1,3
         Y(I) = 0.0
         DO 10 J = 1,3
            X(I,J) = 0.0
 10         CONTINUE
 20      CONTINUE
C                                       Set window,only need half map
      WIN(1) = NX / 2 - SIZE + 1
      WIN(2) = NY / 2 + 1
      WIN(3) = NX / 2 + SIZE + 1
      WIN(4) = NY / 2 + SIZE + 1
      CALL MINIT ('READ', LUNGD1, FIND, NX, NY, WIN, BMAP, BUFSZ1,
     *   BOGRD, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Loop through rows.
      DO 70 I = 1,SIZE + 1
C                                       Read row.
         CALL MDISK ('READ', LUNGD1, FIND, BMAP, BIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR, I
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       Make sure center is 1.0
         IF (I.EQ.1) THEN
            BDIF = BMAP(BIND+SIZE) - 1.0
            BABS = ABS (BDIF)
            IF (BABS.GT.0.01) GO TO 980
            END IF
C                                       Loop down row doing alternate
C                                       halves. go only to first
C                                       descending BASE from center.
         DO 65 IJK = 1,2
            IFLIP = - IFLIP
            ILAST = BIND + SIZE - IFLIP
            DO 60 J = IJK,SIZE + 1
               IROW = BIND + SIZE + (J-1) * IFLIP
               IF ((BMAP(IROW).LT.BASE) .AND. (BMAP(IROW).LT.
     *            BMAP(ILAST))) GO TO 65
               IF (BMAP(IROW).GE.BASE) THEN
                  ILAST = IROW
C                                       Compute displacements from
C                                       center.
                  DX = IFLIP * (J-1.0) * XSPACE * 3600. / XFACT
                  DY = (1.0-I) * YSPACE * 3600. / XFACT
C                                       Compute partials WRT C1,C2,C3
                  P(1) = DX * DX
                  P(2) = DY * DY
                  P(3) = DX * DY
C                                       Sum partials into X matrix and
C                                       Y vector.
                  DO 50 K = 1,3
                     Y(K) = Y(K) - LOG (BMAP(IROW)) * P(K)
                     DO 45 L = 1,3
                        X(K,L) = X(K,L) + P(K) * P(L)
 45                     CONTINUE
 50                  CONTINUE
                  END IF
 60            CONTINUE
 65         CONTINUE
 70      CONTINUE
C                                       Fit beam
      IF (DOBEAM) THEN
         CALL FITBM (0, X, Y, XFACT, MAPROT, GAUSA, GAUSB, GAUSC)
         NOFIT = .FALSE.
         END IF
C                                       Close
      CALL ZCLOSE (LUNGD1, FIND, IERR)
      GO TO 999
C                                       Beam center not 1.000.
 980  WRITE (MSGTXT,1980) BMAP(BIND+5)
      CALL MSGWRT (8)
      CALL ZCLOSE (LUNGD1, FIND, IERR)
      IERR = 8
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BMSHP: ERROR ',I3,' OPENING FILE ')
 1020 FORMAT ('BMSHP: ERROR ',I3,' INIT FILE ')
 1030 FORMAT ('BMSHP: READ ERROR ',I3,' ROW ',I5)
 1980 FORMAT ('BMSHP ERROR: CENTER OF BEAM = ',E12.5)
      END
      SUBROUTINE CLNHIS (NAME, VOL, CLASS, SEQ, OLD)
C-----------------------------------------------------------------------
C   CLNHIS copies the dirty map history if the CLEAN map does not
C   already have a history file.  Then the inputs to APCLN with
C   the default values are added to the history file.
C   INPUTS:
C     NAME(3)    C*12 Names of maps
C                      1 = Dirty map
C                      2 = Beam map
C                      3 = Clean map
C     VOL(3)      I    Vol. numbers of the maps.
C     CLASS(3)    C*6  Classes of the map.
C     SEQ(3)      I    Sequence numbers of the maps.
C     OLD         L    T => Clean map pre-exists & restart > 0
C   From common /MAPHDR/
C     CATBLK(256) I    Catalog header block for the CLEAN map.
C   From COMMON /CLN/
C     NX          I    Number of cell in the map in RA.
C     NY          I    Number of cells in the map in dec.
C     BLC(7)      I    Specifies plane.
C     CLNLIM      I    Max number of iterations.(NITER)
C     CLNSTR      I    Numb. of previous CLEAN comp. to use.
C     GAIN        R    CLEAN loop gain.
C     FMIN        R    Min. CLEAN residual.
C     GAUSA       R    Major axis (FWHM) of CLEAN restoring beam
C     GAUSB       R    Minor axis (FWHM) of CLEAN restoring beam
C     GAUSC       R    Position angle of CLEAN restoring beam.
C     NBOXS       I    Number of boxes for CLEAN.
C     WINM(4,50)  I    Windows of the CLEAN boxes.
C     BUFF1(*)    R    Work buffer
C     BUFF2(*)    R    Work buffer
C     LUNCL1      I    LUN for CLEAN history file
C     LUNDRT      I    LUN for dirty history file
C     CLNVER      I    CLEAN comp. file version number.
C   From COMMON /CFILES/
C     FCNO(10)    I    Catalog slot numbers of catalogd maps.
C                      2 = Dirty map
C                      3 = Clean map
C   OUTPUT:
C     The input parameters are written on the history file and the
C     log file.
C-----------------------------------------------------------------------
      CHARACTER NAME(3)*12, CLASS(3)*6, XCLS*8, XNAM*12, HILINE*72
      INTEGER   VOL(3), SEQ(3), CATBLK(256), IERR, I, J
      LOGICAL   T, OLD, LOLD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      COMMON /MAPHDR/ CATBLK
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Open old file: no copy old HI
      IF (.NOT.OLD) GO TO 20
         CALL HIOPEN (LUNCL1, VOL(3), CCNO, BUFF2, IERR)
         IF (IERR.EQ.5) GO TO 20
         IF (IERR.NE.0) GO TO 10
            CALL ZDATE (BUFF1(1))
            CALL ZTIME (BUFF1(4))
            CALL TIMDAT (BUFF1(4), BUFF1(1), XCLS, XNAM)
            WRITE (HILINE,1000) TSKNAM, RLSNAM, XNAM, XCLS
            CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 50
            LOLD = .TRUE.
            GO TO 30
 10      CONTINUE
            WRITE (MSGTXT,1010) IERR
            CALL MSGWRT (6)
            GO TO 60
C                                       Copy/open history files.
 20   CONTINUE
         LOLD = .FALSE.
         CALL HISCOP (LUNDRT, LUNCL1, VOL(1), VOL(3), FCNO(2), CCNO,
     *      CATBLK, BUFF1, BUFF2, IERR)
C                                       Check if old file does not exist
         IF (IERR.LE.2) GO TO 30
            IF (IERR.EQ.3) GO TO 50
            WRITE (MSGTXT,1020) IERR
            CALL MSGWRT (6)
            GO TO 60
C                                       Add to history file.
C                                       Dirty map name.
 30   WRITE (MSGTXT,2000) NAME(1), CLASS(1), SEQ(1), VOL(1)
      CALL MSGWRT (3)
      CALL HENCO1 (TSKNAM, NAME(1), CLASS(1), SEQ(1), VOL(1),
     *   LUNCL1, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       Dirty beam name.
      WRITE (MSGTXT,2001) NAME(2), CLASS(2), SEQ(2), VOL(2)
      CALL MSGWRT (3)
      CALL HENCO2 (TSKNAM, NAME(2), CLASS(2), SEQ(2), VOL(2),
     *   LUNCL1, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       Clean map name.
      WRITE (MSGTXT,2002) NAME(3), CLASS(3), SEQ(3), VOL(3)
      CALL MSGWRT (1)
      CALL HENCOO (TSKNAM, NAME(3), CLASS(3), SEQ(3), VOL(3),
     *   LUNCL1, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       BLC
      WRITE (HILINE,2015) TSKNAM, BLC
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE(7:)
      CALL MSGWRT (1)
      IF (IERR.NE.0) GO TO 50
C                                       CC file version number.
      WRITE (HILINE,2012) TSKNAM, CLNVER
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE(7:)
      CALL MSGWRT (1)
      IF (IERR.NE.0) GO TO 50
C                                       Maximum number of components.
      WRITE (HILINE,2003) TSKNAM, CLNLIM
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE(7:)
      CALL MSGWRT (1)
      IF (IERR.NE.0) GO TO 50
C                                       Start component.
      WRITE (HILINE,2004) TSKNAM, CLNSTR
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE(7:)
      CALL MSGWRT (1)
      IF (IERR.NE.0) GO TO 50
C                                       Loop gain.
      WRITE (HILINE,2005) TSKNAM, GAIN
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE(7:)
      CALL MSGWRT (1)
      IF (IERR.NE.0) GO TO 50
C                                       Speed up factor
      WRITE (HILINE,2006) TSKNAM, SPEXP
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE(7:)
      CALL MSGWRT (1)
      IF (IERR.NE.0) GO TO 50
C                                       Flux minimum.
      WRITE (HILINE,2007) TSKNAM, FMIN
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE(7:)
      CALL MSGWRT (1)
      IF (IERR.NE.0) GO TO 50
C                                       Prussian hat size
      WRITE (HILINE,2013) TSKNAM, PHAT
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE(7:)
      CALL MSGWRT (1)
      IF (IERR.NE.0) GO TO 50
C                                       CLEAN restoring beam
      WRITE (HILINE,2008) TSKNAM, GAUSA, GAUSB, GAUSC
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE(7:)
      CALL MSGWRT (1)
      IF (IERR.NE.0) GO TO 50
      WRITE (HILINE,2014) TSKNAM
      IF (NOFIT) CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       Number of boxes.
      WRITE (HILINE,2009) TSKNAM, NBOXS
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE(7:)
      CALL MSGWRT (1)
      IF (IERR.NE.0) GO TO 50
C                                       Windows.
      DO 40 I = 1,NBOXS
         WRITE (HILINE,2010) TSKNAM, I, (WINM(J,I), J = 1,4)
         CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
         MSGTXT = HILINE(7:)
         CALL MSGWRT (1)
         IF (IERR.NE.0) GO TO 50
 40      CONTINUE
C                                       Min beam patch
      I = MINPCH + 1
      WRITE (HILINE,2011) TSKNAM, I
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE(7:)
      CALL MSGWRT (1)
      IF (IERR.NE.0) GO TO 50
C                                       Max pixels searched
      WRITE (HILINE,2016) TSKNAM, MAXPIX
      CALL HIADD (LUNCL1, HILINE, BUFF2, IERR)
      MSGTXT = HILINE(7:)
      CALL MSGWRT (1)
      IF (IERR.NE.0) GO TO 50
C
      GO TO 60
C                                       Error has occured.
 50   WRITE (MSGTXT,1050) IERR
      CALL MSGWRT (6)
C                                       Close history files.
 60   CALL HICLOS (LUNCL1, T, BUFF2, IERR)
C                                       copy tables
      IF (.NOT.LOLD) THEN
         CALL ALLTAB (1, 'CC', LUNDRT, LUNCL1, VOL(1), VOL(3), FCNO(2),
     *      CCNO, CATBLK, BUFF1, BUFF2, IERR)
         IF (IERR.GT.2) THEN
            MSGTXT = 'ERROR COPYING TABLE FILES'
            CALL MSGWRT (6)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* RESTART ',
     *   A12,2X,A8)
 1010 FORMAT ('UNABLE TO OPEN OLD CLEAN-MAP HISTORY FILE')
 1020 FORMAT ('CLNHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1050 FORMAT ('CLNHIS: ERROR',I3,' WRITING HISTORY FILE')
 2000 FORMAT ('DIRTY MAP =''',A12,''' . ''',A6,''' . ',2I4)
 2001 FORMAT ('BEAM MAP = ''',A12,''' . ''',A6,''' . ',2I4)
 2002 FORMAT ('CLEAN MAP =''',A12,''' . ''',A6,''' . ',2I4)
 2003 FORMAT (A6,'NITER = ',I8,' /Max. no. CLEAN iterations')
 2004 FORMAT (A6,'BITER = ',I8,' /No. of previous CLEAN comp.')
 2005 FORMAT (A6,'GAIN = ',F7.4,' /CLEAN loop gain factor')
 2006 FORMAT (A6,'FACTOR =',F5.2,' /Speed-up factor')
 2007 FORMAT (A6,'FLUX = ',E12.5,' /Min. CLEAN comp. (Jy)')
 2008 FORMAT (A6,'BMAJS=',F11.6,' BMINS=',F11.6,' BPAD=',F8.3,
     *   ' /Clean beam')
 2009 FORMAT (A6,'NBOXES = ',I3,' /No. CLEAN windows')
 2010 FORMAT (A6,'BOX(',I2,') = ',I5,', ',I5,', ',I5,', ',I5,
     *   ' /Clean window')
 2011 FORMAT (A6,'MINPATCH = ',I4,' /Min allowed beam patch radius')
 2012 FORMAT (A6,'OUTVER = ',I4,' /CLEAN comp. file version no.')
 2013 FORMAT (A6,'PHAT = ',E12.5,' /Prussian hat size')
 2014 FORMAT (A6,'/ BEAM FIT FAILED')
 2015 FORMAT (A6,'BLC =',7I5,' / Plane CLEANed')
 2016 FORMAT (A6,'MAXPIXEL=',I10,' / Max pixels searched in cycle')
      END
      SUBROUTINE DECIDE
C-----------------------------------------------------------------------
C   DECIDE determines a beam patch and limiting map value (PATCH and
C   MAPLIM) which will optimize the use of the array processor.
C   INPUTS:
C       BMHIS  I   = max. fractional abs. of sidelobes external to
C                    beam patch I + 1.  See HISTOB for details.
C       RESHIS I   = Histogram of abs residual map values.
C                    See HISTOR for details.
C       NUMBIN I   = Number of levels for fraction of the peak.
C       MAXRES I   = Max. abs. residual map value .
C       MAXPCH I   = Maximum beam patch size allowed.
C       MINPCH I   = Minimum beam patch size allowed.
C       ICENX  I   = Offset in X of beam from NX/2+1
C       ICENY  I   = Offset in Y of beam from NY/2+2
C   OUTPUT:
C       PATCH  I   = Beam patch size (max. distance from the center)
C       MAPLIM R   = Minimum abs. map level to be considered. (scaled
C                    I)   Only values GREATER than MAPLIM should be
C                    used.
C-----------------------------------------------------------------------
      CHARACTER PREFIX*5
      REAL      XFLUX
      INTEGER   I, IPMAP, JLEV, K, KPAT, MLOOP, IT1, IT2, I2TMP, CORE,
     *   I4TMP, MAXRES, LMXPCH
      LOGICAL   LERR
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA MAXRES /20050/
C-----------------------------------------------------------------------
C                                       Determine max PATCH for NBOXS=1
      IPMAP = WINM(3,1) - WINM(1,1) + 1
      IF (IPMAP.LT.(WINM(4,1)-WINM(2,1)+1)) IPMAP = WINM(4,1)-
     *   WINM(2,1) + 1
      IF (IPMAP.LT.0) IPMAP = -IPMAP + 2
C                                       Loop thru beam patch sizes to fi
C                                       the largest which, with necessar
C                                       map points will fit in the AP.
      IT1 = NX / 2 - ABS (ICENX)
      IT2 = NY / 2 - ABS (ICENY)
      LMXPCH = MIN (MAXPCH, BMHSIZ, IT1, IT2) - 1
C                                       set maximum # pixels searched
      IF ((MAXPIX.LT.1000) .OR. (MAXPIX.GT.500000)) MAXPIX = MAXRES
      IT1 = (APSIZ - BMOFFS - (LMXPCH+1) * (2*LMXPCH + 1)) / 3 - 10
      MAXPIX = MIN (MAXPIX, IT1)
C                                       Minimum MINPCH is 3.
      IT1 = NX / 2
      IT2 = NY / 2
      MINPCH = MIN (MINPCH, IT1, IT2)
      IT1 = LMXPCH - 5
      MINPCH = MIN (MINPCH, IT1)
      MINPCH = MAX (MINPCH, 3)
      MLOOP = LMXPCH - MINPCH + 1
      DO 50 I = 1,MLOOP
         KPAT = LMXPCH - I + 1
C                                       Ignore beam patches with no info
         IF (BMHIS(KPAT).GT.0) THEN
C                                       Compute amount of AP core for be
            CORE = KPAT + 1
            CORE = CORE * (2 * CORE - 1)
C                                       Use value in BMHIS as an index
C                                       for RESHIS.
            JLEV = BMHIS(KPAT)
            IF (JLEV.GE.2) THEN
C                                       Make sure some data to be loaded
               I2TMP = JLEV
               DO 30 K = 2,I2TMP
                  IF (RESHIS(JLEV).GT.0) GO TO 35
                     JLEV = JLEV - 1
 30               CONTINUE
               END IF
C                                       Compute total AP core for this
C                                       PATCH - MAPLIM combination.
 35         I4TMP = RESHIS(JLEV)
            CORE = CORE + 3 * I4TMP
C                                       See if this will fit and if so
C                                       jump out of the loop.
            IF ((CORE.LT.APSIZ-BMOFFS) .AND.
     *         (RESHIS(JLEV).LE.MAXPIX)) GO TO 60
            END IF
 50      CONTINUE
C                                       If the program gets here, no bea
C                                       patch - map limit would fit.
C                                       Use minimum beam patch  and
C                                       determine which map limit will f
      CORE = APSIZ - (MINPCH+1) * (2*MINPCH + 1) - BMOFFS
      DO 55 I = 1,NUMBIN
         IF (RESHIS(I).LE.MAXPIX) THEN
            IF ((CORE - 3 * RESHIS(I)).GT.0) THEN
               JLEV = I
               CORE = APSIZ - 3*RESHIS(I) - BMOFFS - 20
               KPAT = (SQRT (8.0*CORE+1.0) + 1.0) / 4.0
               KPAT = MAX (MINPCH, MIN (KPAT, LMXPCH))
               KPAT = MINPCH
               GO TO 60
               END IF
            END IF
 55      CONTINUE
C                                      If program gets here there is a
C                                      serious problem. e.g. residual ma
C                                      has a constant (or nearly) value
      WRITE (MSGTXT,1055)
      CALL MSGWRT (8)
C                                      Use JLEV =NUMBIN -1/2 and hope fo
C                                      best.
      MAPLIM = RESMAX * (NUMBIN-0.5) / NUMBIN
      PATCH = MINPCH
      GO TO 990
C                                      An acceptable solution was found.
 60   MAPLIM = (RESMAX * (JLEV - 0.5)) / (NUMBIN - 1.0)
      PATCH = KPAT + 1
C                                       See if everything will fit.
      CORE = BMOFFS + 3 * RESHIS(1) + PATCH * (2*PATCH-1)
      IF ((NBOXS.EQ.1) .AND. (PATCH.GE.IPMAP) .AND. (CORE.LE.APSIZ)
     *   .AND. (RESHIS(1).LE.MAXPIX)) MAPLIM = -1.0E-10 * RESMAX
C                                       Display the results.
 990  XFLUX = MAPLIM
      CALL METSCA (XFLUX, PREFIX, LERR)
      WRITE (MSGTXT,1990) XFLUX, PREFIX
      CALL MSGWRT (2)
      WRITE (MSGTXT,1991) PATCH
      CALL MSGWRT (2)
C
 999  RETURN
C-----------------------------------------------------------------------
 1055 FORMAT ('DECIDE: CANNOT OBTAIN BEAM PATCH - MAP LIMIT PROPERLY')
 1990 FORMAT ('In-AP CLEAN uses residual points brighter than',F10.3,
     *   1X,A5,'Jy')
 1991 FORMAT ('and a beam half-width of',I5,' cells')
      END
      SUBROUTINE DISPTV (TVPASS)
C-----------------------------------------------------------------------
C   DISPTV displays the current residual map on the TV, showing inner
C   portion only if that is all that will fit.
C   Inputs:  TVPASS  I     code: 0,1 => clear screen, else don't
C                                0,3 => don't question the user about
C                                       quitting
C   Output:  TVPASS  I     code: 32700 => user wants to quit cleaning
C-----------------------------------------------------------------------
      CHARACTER PREFIX*5
      INTEGER   TVPASS, JROW(1024), WIN(4), FIND, IERR, ICH, INC(2),
     *   CATBLK(256), S2H(256), IQ, IB, I, IWIN(4)
      REAL      XBUFF(1), TD, RPOS(2), CATR(256)
      REAL      XFLUX, TVLMAX, TVLMIN, ARG
      LOGICAL   MAP, EXCL, WAIT, LERR, F
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVD.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATR, CATBLK)
      EQUIVALENCE (JROW(1), BUFF2(1)),    (BUFF1(1), XBUFF(1))
      DATA MAP, EXCL, WAIT / .TRUE., 2*.TRUE./
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      ICH = 1
      CALL TVOPEN (BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 999
         END IF
      IF (TVPASS.LE.1) THEN
         CALL TVSET (ICH, BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            CALL MSGWRT (6)
            GO TO 998
            END IF
         END IF
      IF (TVFMAX.LE.TVFMIN) THEN
         TVFMAX = TVREMX
         TVFMIN = TVREMN
         END IF
      IF (TVREMX.GT.TVFMAX) TVFMAX = TVREMX
      IF (TVREMN.LT.TVFMIN) TVFMIN = TVREMN
      TVLMAX = TVFMAX - TVFMIN
      IF (0.1*TVLMAX.GT.TVREMX-TVREMN) THEN
         ARG = 0.1 * TVFMIN
         TVFMIN = MIN (ARG, TVREMN)
         ARG = TVFMIN + 0.1 * TVLMAX
         TVFMAX = MAX (ARG, TVREMX)
         TVLMAX = TVFMAX - TVFMIN
         END IF
C                                       Write scaling factor
      XFLUX = TVLMAX
      CALL METSCA (XFLUX, PREFIX, LERR)
      TVLMIN = TVFMIN * XFLUX / TVLMAX
      TVLMAX = TVFMAX * XFLUX / TVLMAX
      WRITE (MSGTXT,1020) TVLMIN, TVLMAX, PREFIX
      CALL MSGWRT (1)
      CALL COPY (256, CATBLK, S2H)
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NX
      WIN(4) = NY
      INC(1) = NX / MAXXTV(1) + 1
      INC(2) = NY / MAXXTV(2) + 1
      INC(1) = MAX (INC(1), INC(2))
      INC(2) = MAX (INC(1), INC(2))
      DO 70 I = 1,2
         WIN(I+2) = WIN(I+2) - MOD (WIN(I+2)-WIN(I), INC(I))
         IWIN(I) = (MAXXTV(I) - (WIN(I+2)- WIN(I))/INC(I) + 1)/2
         IF (IWIN(I).LT.1) THEN
            IWIN(I) = 1
            WIN(I)  = (WIN(I+2) + WIN(I) - MAXXTV(I)*INC(I) + 1)/2
            IWIN(I+2) = MAXXTV(I)
            WIN(I+2) = WIN(I) + (IWIN(I+2) - IWIN(I)) * INC(I)
         ELSE
            IWIN(I+2) = IWIN(I) + (WIN(I+2) - WIN(I)) / INC(I)
            IF (IWIN(I+2).GT.MAXXTV(I)) THEN
               IWIN(I+2) = MAXXTV(I)
               WIN(I+2) = WIN(I) + (IWIN(I+2) - IWIN(I)) * INC(I)
               END IF
            END IF
 70      CONTINUE
      WRITE (MSGTXT,1070) TVFMIN, TVFMAX, INC(1)
      CALL MSGWRT (2)
C                                       Prepare to read map.
      CALL ZOPEN (LUNRES, FIND, RESVOL, RESFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) GO TO 998
      CALL FILL (5, 1, CATBLK(IIDEP))
      CATR(IRRAN) = TVFMIN
      CATR(IRRAN+1) = TVFMAX
C                                       tvload standard
      CALL TVLOAD (LUNRES, FIND, ICH, INC, IWIN, WIN, BUFSZ1, XBUFF,
     *   IERR)
      CALL COPY (256, S2H, CATBLK)
      CALL ZCLOSE (LUNRES, FIND, I)
      IERR = MAX (I, IERR)
      IF (IERR.NE.0) GO TO 998
C                                       Ask user to quit?
      IF ((TVPASS.NE.1) .AND. (TVPASS.NE.2)) GO TO 998
         MSGTXT = 'Hit button D within 15 seconds to stop cleaning now'
         CALL MSGWRT (1)
         MSGTXT = 'Hit buttons A, B, or C to continue sooner'
         CALL MSGWRT (1)
         RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2.0
         RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2.0
         TD = 0.4
         CALL YCURSE ('ONNN', F, F, RPOS, IQ, IB, IERR)
         IF (IERR.NE.0) GO TO 998
         DO 130 I = 1,75
            CALL ZDELAY (TD, IERR)
            CALL YCURSE ('READ', F, F, RPOS, IQ, IB, IERR)
            IF (IB.GT.7) GO TO 140
            IF (IB.GT.0) GO TO 135
            IF (IERR.NE.0) GO TO 135
 130        CONTINUE
 135     MSGTXT = 'Continuing'
         CALL MSGWRT (1)
         GO TO 150
C                                       Wants to quit
 140     TVPASS = 32700
         MSGTXT = 'TV Button D hit: have done enough I guess'
         CALL MSGWRT (3)
C                                       Off cursor
 150     CALL YCURSE ('OFFF', F, F, RPOS, IQ, IB, IERR)
 998  CALL TVCLOS (BUFF1, I)
      IF (IERR.EQ.0) IERR = I
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CAN''T OPEN TV IER=',I6)
 1010 FORMAT ('IMCLEAR ERROR =',I6)
 1020 FORMAT ('TVDISP: Display range =',2F8.3,1X,A5,'Jy')
 1070 FORMAT ('Loading TV from',1PE11.3,' to',1PE10.3,' every',I2,
     *   ' pixel')
      END
      SUBROUTINE FILES (USID, NAME, VOL, CLASS, SEQ, OLD, IERR)
C-----------------------------------------------------------------------
C   FILES reads and floats the  beam and creates the
C   clean map and components files. The R   beam is placed in the
C   GRD file and the location of the R   catalogd files are
C   left in the DRT and BEM files.
C   BEAM and Dirty maps in catalog are marked READ and Clean map
C   is marked WRITE.
C   Input:
C     USID     I    User number.
C     NAME(3)  C*12 Names of maps
C                     1 = Dirty map
C                     2 = Beam map
C                     3 = CLEAN map
C     CLASS(3)  C*6   Classes of the maps
C     VOL(3)     I    Volumns of the maps.
C   Output:
C     ICENX    I    Offset in X of BEAM center from NX/2+1
C     ICENY    I    Offset in Y of BEAM center from NY/2+1
C     OLD      L    TRUE if old map file being replaced.
C     WINM(4,NBOXS)  I    Adjusted dirty map window.
C     NBOXS    I    Number of boxes in the map to CLEAN.
C   Commons:
C     CATBLK(256) in /MAPHDR/ a preliminary header for the clean map
C        is returned.
C-----------------------------------------------------------------------
      CHARACTER NAME(3)*12, CLASS(3)*6, STAT*4, REST*4, TYPTMP*2
      INTEGER   ISIZE, LSIZE, IEQUIV
      INTEGER   USID, CATBLK(256), CNO, VOL(3), SEQ(3),
     *   OLDIM, OLDNAX(7), I, IBOX, IER, IERR, IDEP(5), IROUND,
     *   CORN(7), JWIN(4), NOSCR, NBP, NPIX(2), IX, IY
      LOGICAL   OLD
      DOUBLE PRECISION CATD(128), OLDCRV(7)
      REAL      CATR(256), XMAX, XMIN, REQUIV, XCEN, YCEN
      HOLLERITH CATH(256)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK, CATR, CATD, CATH)
      EQUIVALENCE (IEQUIV, REQUIV)
      DATA CORN, JWIN /7*1, 4*0/
      DATA REST /'REST'/
C-----------------------------------------------------------------------
      NCFILE = 0
C                                       Read dirty beam.
C                                       Get catalog slot for BEAM.
      CNO = 1
      TYPTMP = 'MA'
      CALL CATDIR ('SRCH', VOL(2), CNO, NAME(2), CLASS(2), SEQ(2),
     *   TYPTMP, USID, STAT, BUFF3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, NAME(1), CLASS(1), SEQ(2), VOL(2),
     *      USID
         GO TO 990
         END IF
C                                       Copy CATBLK and mark beam READ
      CALL CATIO ('READ', VOL(2), CNO, CATBLK, 'READ', BUFF3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = VOL(2)
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 0
C                                       Determine NX and NY
      NX = CATBLK(KINAX)
      NY = CATBLK(KINAX+1)
      CALL POWER2 (NX, IX)
      CALL POWER2 (NY, IY)
C                                       Invalid (NX,NY)
      IF ((NX.NE.IX) .OR. (NX.LT.32) .OR. (NX.GT.MAXIMG) .OR.
     *   (NY.NE.IY) .OR. (NY.LT.32) .OR. (NY.GT.MAXIMG)) GO TO 980
C                                       Determine beam center pixel
      CALL COPY (5, BLC(3), IDEP)
C                                       See if beam cube
      IF (CATBLK(KINAX+2).EQ.1) IDEP(1) = 1
      CALL PEAKFN (LUNGD1, VOL(2), CNO, IDEP, CATBLK, BUFF1, BUFSZ1,
     *   XCEN, YCEN, IERR)
      IF (IERR.NE.0) GO TO 999
      XCEN = XCEN - NX/2 - 1
      YCEN = YCEN - NY/2 - 1
      ICENX = IROUND (XCEN)
      ICENY = IROUND (YCEN)
C                                       Create scratch files.
C                                       Use output as residual file
C                                       Grid file
      NSCR = 0
      NBP = 2
      NPIX(1) = NY
      NPIX(2) = NX + 1
      CALL MAPSIZ (2, NPIX, ISIZE)
      NPIX(1) = 2 * NPIX(1)
      NPIX(2) = NX/2 + 1
      CALL MAPSIZ (2, NPIX, LSIZE)
      IF (LSIZE.GT.ISIZE) ISIZE = LSIZE
      CALL SCREAT (ISIZE, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       Update from COMMON /FILES/
      GRDVOL = SCRVOL(NSCR)
      CNOGRD = SCRCNO(NSCR)
      CALL ZPHFIL ('SC', GRDVOL, CNOGRD, 1, GRDFIL, IERR)
      NOSCR = NSCR
C                                       Work file
      CALL SCREAT (ISIZE, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1025) IERR
         GO TO 990
         END IF
C                                       Update from COMMON /FILES/
      WRKVOL = SCRVOL(NSCR)
      CNOWRK = SCRCNO(NSCR)
      CALL ZPHFIL ('SC', WRKVOL, CNOWRK, 1, WRKFIL, IERR)
C                                       Weight file
      CALL SCREAT (ISIZE, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         GO TO 990
         END IF
C                                       Update from COMMON /FILES/
      WTVOL = SCRVOL(NSCR)
      CNOWT = SCRCNO(NSCR)
      CALL ZPHFIL ('SC', WTVOL, CNOWT, 1, WTFIL, IERR)
C                                       Read beam map to GRID
      CALL COPY (5, IDEP, CORN(3))
      CALL PLNGET (VOL(2), CNO, CORN, JWIN, ICENX, ICENY, NOSCR, NX,
     *   NY, BUFF1, BUFF2, BUFSZ1, BUFSZ2, LUNGD1, LUNDRT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1035) IERR
         GO TO 990
         END IF
C                                       Get and store info on BEAM.
C                                       Store information on BEAM file
C                                       Use GRD file for temp R   BEAM.
      CALL ZPHFIL ('MA', VOL(2), CNO, 1, BEMFIL, IER)
      BEMVOL = VOL(2)
      SEQ(2) = CATBLK(KIIMS)
C                                       Set BLKOF for plane.
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEP, BOBEM, IERR)
      BOBEM = BOBEM + 1
C                                       Loop through the boxes.
      DO 70 IBOX = 1,NBOXS
C                                       Make sure window no larger
C                                       than map size.
         IF (WINM(3,IBOX).GT.NX) WINM(3,IBOX) = NX
         IF (WINM(4,IBOX).GT.NY) WINM(4,IBOX) = NY
C                                       If default use center 1/4 of map
         IF (WINM(1,IBOX).LE.0) WINM(1,IBOX) = NX / 4 + 1
         IF (WINM(2,IBOX).LE.0) WINM(2,IBOX) = NY / 4 + 1
         IF (WINM(3,IBOX).LE.0) WINM(3,IBOX) = 3*NX/4 - 1
         IF (WINM(4,IBOX).LE.0) WINM(4,IBOX) = 3*NY/4 - 1
 70      CONTINUE
C                                       Get catalog slot number for
C                                       the dirty map and its CATBLK.
      CNO = 1
      TYPTMP = 'MA'
      CALL CATDIR ('SRCH', VOL(1), CNO, NAME(1), CLASS(1), SEQ(1),
     *   TYPTMP, USID, STAT, BUFF3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, NAME(1), CLASS(1), SEQ(1), VOL(1),
     *      USID
         GO TO 990
         END IF
C                                       Get CATBLK for dirty map.
C                                       Leave file marked READ.
      CALL CATIO ('READ', VOL(1), CNO, CATBLK, 'READ', BUFF3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1090) IERR
         GO TO 990
         END IF
C                                       Mark map READ in /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = VOL(1)
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 0
C                                       Warn if "Clean"
      IF (CATBLK(KINIT).GT.0) THEN
         WRITE (MSGTXT,1100)
         CALL MSGWRT (6)
         END IF
C                                       Get dirty scale,offset,max,min.
C                                       Set info into COMMON.
      XMAX = CATR(KRDMX)
      XMIN = CATR(KRDMN)
      RESMAX = MAX (ABS(XMAX) , ABS(XMIN))
      CALL ZPHFIL ('MA', VOL(1), CNO, 1, DRTFIL, IER)
      DRTVOL = VOL(1)
C                                       Set BLKOF for plane.
      IDEP(1) = BLC(3)
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEP, BODRT, IERR)
      BODRT = BODRT + 1
C                                        RA spacing.
      XSPACE = CATR(KRCIC)
C                                        Dec spacing.
      YSPACE = CATR(KRCIC+1)
C                                        Map rotation.
      CALL ROTFND (CATR, MAPROT, IER)
C                                       Make sure NX,NY same as
C                                       for the beam.
      IF ((NX.NE.CATBLK(KINAX)) .OR. (NY.NE.CATBLK(KINAX+1))) THEN
         IERR = 1
         WRITE (MSGTXT,1105)
         CALL MSGWRT (8)
         WRITE (MSGTXT,1106) NX,NY,CATBLK(KINAX),CATBLK(KINAX+1)
         GO TO 990
         END IF
C                                       Put NAME in CATBLK
      CALL CHR2H (12, NAME(3), KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLASS(3), KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQ(3)
C                                       Create output CLEAN map file.
      CALL MCREAT (VOL(3), CNO, BUFF1, IERR)
      OLD = .FALSE.
      IF (IERR.EQ.0) GO TO 300
         OLD = .TRUE.
         IF (IERR.EQ.2) GO TO 200
            WRITE (MSGTXT,1190) IERR
            GO TO 990
C                                       Existing file: check it out
 200     CONTINUE
            OLDIM = CATBLK(KIDIM)
            DO 205 I = 1,7
               OLDNAX(I) = CATBLK(KINAX+I-1)
               OLDCRV(I) = CATD(KDCRV+I-1)
 205           CONTINUE
            CALL CATIO ('READ', VOL(3), CNO, CATBLK, REST, BUFF3, IERR)
            IF (OLDIM.NE.CATBLK(KIDIM)) GO TO 215
            DO 210 I = 1,OLDIM
               IF (OLDNAX(I).NE.CATBLK(KINAX+I-1)) GO TO 215
               IF (ABS (OLDCRV(I)-CATD(KDCRV+I-1)) .GT. 0.05 *
     *            ABS (CATR(KRCIC+I-1))) GO TO 215
 210           CONTINUE
C                                       It matches, mark WRITE
            CALL CATIO ('WRIT', VOL(3), CNO, CATBLK, 'WRIT', BUFF3,
     *         IERR)
            IF (IERR.EQ.0) GO TO 300
               WRITE (MSGTXT,1210) IERR
               GO TO 990
C                                       Not same file !!!
 215        CONTINUE
               IERR = 8
               WRITE (MSGTXT,1215)
               GO TO 990
C                                       Actual seq #
 300  SEQ(3) = CATBLK(KIIMS)
C                                       Add to /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = VOL(3)
      CLNVOL = VOL(3)
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 2
      IF (OLD) FRW(NCFILE) = 1
      CCNO = CNO
      CCNCOL = 3
C                                       copy keywords
      IF (.NOT.OLD) CALL KEYPCP (FVOL(2), FCNO(2), VOL(3), CNO, 0,
     *   ' ', IERR)
C                                       Use output file as resid. file
      RESVOL = VOL(3)
      CNORES = CNO
      CALL ZPHFIL ('MA', RESVOL, CNORES, 1, RESFIL, IERR)
      BORES = BODRT
C                                       If cube, override CLNVER w/
C                                       plane number.
      IF (CATBLK(KINAX+2).GT.1) CLNVER = BLC(3)
C                                       Check limit of 46655
      IF (CLNVER.GT.46655) THEN
         IERR = 5
         WRITE (MSGTXT,1301) CLNVER
         GO TO 990
         END IF
C                                       Create/get ver # for CC file.
      IF (CLNVER.EQ.0) CALL FNDEXT ('CC', CATBLK, CLNVER)
      CALL CCMINI ('WRIT', CCBUFF, CLNVOL, FCNO(3), CLNVER, CATBLK,
     *   LUNCL2, CCRNO, CCKOLS, CCNUMV, CCNCOL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1300) IERR
         GO TO 990
         END IF
C                                       Check no. CC comps.
      CLNSTR = MIN (CLNSTR, CCBUFF(5))
      CCBUFF(5) = CLNSTR
C                                       Close.
      CALL TABCCM ('CLOS', CCBUFF, CCRNO, CCKOLS, CCNUMV, CCNCOL, XX,
     *   YY, ZZ, CCFLUX, CCTYPE, PARMS, IERR)
      GO TO 999
 980  WRITE (MSGTXT,1980) NX, NY
      IERR = 8
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FILES: ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,
     *   ' DISK=',I3,' USID=',I4)
 1010 FORMAT ('FILES: CANNOT COPY BEAM CATBLK, ERROR',I3)
 1020 FORMAT ('FILES: ERROR',I3,' CREATING GRID SCRATCH FILE')
 1025 FORMAT ('FILES: ERROR',I3,' CREATING WORK SCRATCH FILE')
 1030 FORMAT ('FILES: ERROR',I3,' CREATING WEIGHT SCRATCH FILE')
 1035 FORMAT ('FILES: CANNOT COPY DIRTY BEAM, ERROR ',I3)
 1090 FORMAT ('FILES: CANNOT COPY MAP CATBLK, ERROR',I3)
 1100 FORMAT ('WARNING: MAY BE CLEANING A CLEAN MAP')
 1105 FORMAT ('FILES: UNEQUAL DIMENSIONS IN DIRTY AND BEAM MAPS')
 1106 FORMAT ('       BEAM =',2I5,' DIRTY =',2I5)
 1190 FORMAT ('FILES: COULD NOT CREATE CLEAN MAP FILE, ERROR ',I3)
 1210 FORMAT ('FILES: CANNOT UPDATE CLEAN CATBLK, ERROR',I3)
 1215 FORMAT ('OLD CLEAN MAP NOT COMPATIBLE WITH DIRTY MAP')
 1300 FORMAT ('FILES: UNABLE TO CREATE CLEAN COMP. FILE, ERROR',I3)
 1301 FORMAT ('COMPONENT FILE NO. TOO LARGE ',I3,' >46655')
 1980 FORMAT ('MAP DIMENSIONS:',2I5,' NOT INTEGER POWERS OF 2')
      END
      SUBROUTINE GETIN (USID, NAME, VOL, CLASS, SEQ, ITV, IERR)
C-----------------------------------------------------------------------
C   GETIN gets the input parameters for the program from AIPS
C  See Prologue for APCLN for more details.
C-----------------------------------------------------------------------
      CHARACTER TYPTMP*2
      CHARACTER PRGNAM*6, NAME(3)*12, CLASS(3)*6, DEFCLS*6
      HOLLERITH XNAM1(3), XCLAS1(2), XNAM2(3), XCLAS2(2), XNAM3(3),
     *   XCLAS3(2)
      INTEGER   USID, SEQ(3), VOL(3), ITV, NPARMS, IERR, CATBLK(256),
     *   IND, CNO, I, IK, IL, J, IROUND, IT1, ITEMP
      REAL   XSEQ1, XSEQ2, XSEQ3, XVOL1, XVOL2, XVOL3, XBLC(7), XG, XF,
     *   XNI, XBI, XBMJ, XBMN, XBPA, XNB, XBOX(4,50), XDOTV, XMAXPX,
     *   XFCTR, XBAD(10), XVER, XINC, XPHAT
      LOGICAL   T, F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      COMMON /MAPHDR/ CATBLK
      COMMON /INPARM/ XNAM1, XCLAS1, XSEQ1, XVOL1, XBLC, XNAM2, XCLAS2,
     *   XSEQ2, XVOL2, XNAM3, XCLAS3, XSEQ3, XVOL3, XVER, XG, XF,
     *   XPHAT, XNI, XBI, XBMJ, XBMN, XBPA, XNB, XBOX, XFCTR, XINC,
     *   XMAXPX, XDOTV, XBAD
      DATA PRGNAM /'APCLN '/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                        Initialize common parameters.
C                                        global areas
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL HIINIT (3)
C                                        non-standard messages
C                                        APCLN common areas
      BMOFFS = 2 * BMHSIZ + 4
      BOBEM = 1
      BORES = 1
      BOWT = 1
      BOGRD = 1
      BODRT = 1
      BOWRK = 1
      LUNBEM = 16
      LUNRES = 17
      LUNRS1 = 19
      LUNWT  = 20
      LUNGD1 = 19
      LUNGD2 = 21
      LUNDRT = 22
      LUNWRK = 23
      LUNCL1 = 26
      LUNCL2 = 27
      CLNLIM = 200
      CLNSTR = 0
      CLNLST = 0
      FLUX = 0.0
      FMIN = 0.001
      MINPCH = 127
      GAIN = 0.10
      NUMBIN = HBUFSZ - 10
      ITEMP = 2  * LBUFSZ
      BUFSZ1 = ITEMP
      BUFSZ2 = ITEMP
      BUFSZ3 = ITEMP
      BPS = NBPS
      TVFMAX = 0.0
      TVFMIN = 0.0
C                                       Get AIPS adverbs.
      NPARMS = 252
      CALL GTPARM (PRGNAM, NPARMS, RQUICK, XNAM1, BUFF1, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         RQUICK = .FALSE.
         GO TO 999
C                                       Convert names
 10   CALL H2CHR (12, 1, XNAM1, NAME(1))
      CALL H2CHR (6, 1, XCLAS1, CLASS(1))
      CALL H2CHR (12, 1, XNAM2, NAME(2))
      CALL H2CHR (6, 1, XCLAS2, CLASS(2))
      CALL H2CHR (12, 1, XNAM3, NAME(3))
      CALL H2CHR (6, 1, XCLAS3, CLASS(3))
C                                       Find desired plane no.
      BLC(1) = 1
      BLC(2) = 1
      DO 20 I = 3,7
         BLC(I) = MAX (1.0, XBLC(I)) + 0.5
 20      CONTINUE
C                                       get actual dirty map name
      VOL(1) = IROUND (XVOL1)
      SEQ(1) = IROUND (XSEQ1)
      USID = NLUSER
      CNO = 1
      TYPTMP = 'MA'
      CALL MAPOPN ('READ', VOL, NAME(1), CLASS(1), SEQ, TYPTMP, USID,
     *   LUNBEM, IND, CNO, CATBLK, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL MAPCLS ('READ', VOL, CNO, LUNBEM, IND, CATBLK, F, BUFF1,
     *   IERR)
C                                       Default name for Beam and CLEAN
C                                       maps is Dirty map name.
      IF (NAME(1).EQ.' ') NAME(2) = NAME(1)
C                                       Copy CLASSes or default.
      IF (CLASS(2).EQ.' ') THEN
         CLASS(2) = 'IBM001'
         IF (CLASS(1)(1:1).EQ.'R') CLASS(2)(1:1) = 'R'
         IF (CLASS(1)(1:1).EQ.'L') CLASS(2)(1:1) = 'L'
         END IF
C                                       Use appropriate default for
C                                       polarization type.
      DEFCLS = 'ICL001'
      IF (CLASS(1)(1:1).EQ.'Q') DEFCLS(1:1) = 'Q'
      IF (CLASS(1)(1:1).EQ.'U') DEFCLS(1:1) = 'U'
      IF (CLASS(1)(1:1).EQ.'V') DEFCLS(1:1) = 'V'
      IF (CLASS(1)(1:1).EQ.'R') DEFCLS(1:1) = 'R'
      IF (CLASS(1)(1:1).EQ.'L') DEFCLS(1:1) = 'L'
C                                       Get volumn numbers
      VOL(2) = IROUND (XVOL2)
      VOL(3) = IROUND (XVOL3)
C                                       Get sequence numbers
      SEQ(2) = IROUND (XSEQ2)
      SEQ(3) = IROUND (XSEQ3)
      IF (SEQ(2).LE.0) SEQ(2) = SEQ(1)
      CALL MAKOUT (NAME, CLASS, SEQ, DEFCLS, NAME(3), CLASS(3),
     *   SEQ(3))
C                                       Get CC file version no.
      CLNVER = IROUND (XVER)
C                                       Get CLEANing information
      IF (XG.GT.0.0) GAIN = XG
      FMIN = XF
      PHAT = XPHAT
      IF (XNI.GT.0.5) CLNLIM = XNI + 0.5
      IF (XNI.LT.-0.5) CLNLIM = XNI - 0.5
      CLNSTR = XBI + 0.5
      GAUSA = XBMJ
      GAUSB = XBMN
      GAUSC = XBPA
C                                       set maximum # pixels searched
      MAXPIX = XMAXPX + 0.5
      IF ((MAXPIX.LT.1000) .OR. (MAXPIX.GT.500000)) MAXPIX = 20050
C                                       Check number of comps
C                                       subtracted from dirty map.
      PRECLN = 0
      IF (CATBLK(KINIT).GT.0) PRECLN = CATBLK(KINIT)
      NBOXS = IROUND (XNB)
      NBOXS = MIN (NBOXS, 50)
      CALL FILL (200, 0, WINM)
      IF (NBOXS.GT.0) THEN
         IL = 1
         DO 60 I = 1,NBOXS
            IK = 0
            DO 50 J = 1,4
               WINM(J,IL) = IROUND (XBOX(J,I))
               IF (WINM(J,IL).GT.0) IK = IK + 1
 50            CONTINUE
            IF ((I.EQ.1) .OR. (IK.GT.0)) IL = IL + 1
 60         CONTINUE
         IT1 = IL - 1
         NBOXS = MIN (IT1, NBOXS)
         END IF
      NBOXS = MAX (NBOXS, 1)
      SPEXP  = XFCTR
      IF (XINC.GT.3.0) MINPCH = XINC - 0.9
      ITV = 0
      IF (XDOTV.GT.0.0) ITV = 1
C                                       Get bad disks.
      DO 70 I = 1,10
         IBAD(I) = IROUND (XBAD(I))
 70      CONTINUE
C                                       Check if TV allowed
      IF (NTVDEV.LE.0) ITV = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
      END
      SUBROUTINE GRIDER (APCORE, WFIRST, IERR)
C-----------------------------------------------------------------------
C   GRIDER Fourier transforms the CLEAN components and multiplies
C   times the negative of the  weighting function so that when
C   retransformed and added to the Dirty map the current residual map
C   results.  Results are accumulated in a file GRID so that only
C   new components need be transformed.
C   Output is to file WRK and then the names and addresses of the GRID
C   and WRK files are switched.
C    Input:
C     CLNSTR I   = highest number component to transform
C     CLNLST I   = first CLEAN component to transform.
C     WFIRST L   = .TRUE. iff this is first write on grid file.
C     CLEAN components from file CLNFIL.
C   Output:
C     Transform of additional CLEAN components times the weighting fn
C     added to the file GRDFIL.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   FIND1, FIND2, FIND3, IERR, IRET,  WIN(4), BIND1, BIND2,
     *   BIND3, NLOAD, I, JLIM
      INTEGER   NUMCLN, FIRST, MAXCMP, JNUM, NAPGRD, IAPSIZ,
     *   NAPWTS, NAPCMP, NAPCMS, APBUF, NUMBER, TWONY, ONENY,
     *   WRK1, WRK2
      LOGICAL   MAP, EXCL, WAIT, WFIRST, F, DOSUM
      REAL      WBUFF(1), GBUFF(1), OBUFF(1)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
c      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      EQUIVALENCE (WBUFF(1), BUFF1(1)),      (GBUFF(1), BUFF2(1))
      EQUIVALENCE (OBUFF(1), BUFF3(1))
      DATA MAP, EXCL, WAIT /.TRUE.,2*.TRUE./
      DATA F /.FALSE./
      DATA APBUF /1/
C-----------------------------------------------------------------------
      IAPSIZ = 1024 * PSAPNW
      DOSUM = WFIRST
      IF (DOSUM) FLUX = 0.0
C                                       Determine Area assignments in AP
      ONENY = NY
      TWONY = 2 * NY
      NAPGRD = 100
      NAPWTS = NAPGRD + TWONY + 1
      NAPCMP = NAPWTS + TWONY + 1
      NAPCMS = NAPCMP + TWONY + 1
C                                       Determine AP buffer size.
      NLOAD = NAPCMS - 3
C                                       Determine maximum number of comp
C                                       per pass.
      MAXCMP = (IAPSIZ - NAPCMS) / 5.0
C                                       Determine number of components
C                                       to be CLEANed.
      NUMCLN = CLNSTR - CLNLST
C                                       Begin component loop.
 10   CONTINUE
         FIRST = CLNLST + 1
         NUMBER = MAXCMP
         IF (NUMCLN.LT.NUMBER) NUMBER = NUMCLN
C                                       Load NUMBER components this pass
         JNUM = NUMBER
         CALL CMPCRM (APCORE, NAPCMS, APBUF, FIRST, NUMBER, NLOAD,
     *      DOSUM, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Open weights file and init.
         CALL ZOPEN (LUNWT, FIND1, WTVOL, WTFIL, MAP, EXCL, WAIT, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
         WIN(1) = 1
         WIN(2) = 1
         WIN(3) = NY * 2
         WIN(4) = NX / 2 + 1
         CALL MINIT ('READ', LUNWT, FIND1, WIN(3), WIN(4), WIN, WBUFF,
     *      BUFSZ1, BOWT, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR
            GO TO 990
            END IF
C                                       Open and INIT GRID file for read
        CALL ZOPEN (LUNGD1, FIND2, GRDVOL, GRDFIL, MAP, EXCL, WAIT,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR
            GO TO 990
            END IF
         WIN(3) = NY * 2
         WIN(4) = NX / 2 + 1
         CALL MINIT ('READ', LUNGD1, FIND2, WIN(3), WIN(4), WIN, GBUFF,
     *      BUFSZ2, BOGRD, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Open and INIT WRK file for writi
         CALL ZOPEN (LUNWRK, FIND3, WRKVOL, WRKFIL, MAP, EXCL, WAIT,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR
            GO TO 990
            END IF
         CALL MINIT ('WRIT', LUNWRK, FIND3, WIN(3), WIN(4), WIN, OBUFF,
     *      BUFSZ3, BOWRK, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Clear NAPGRD.
         CALL QVCLR (APCORE, NAPGRD, 1, TWONY)
C                                       Begin loop thru map.
         JLIM = NX / 2 + 1
         DO 150 I = 1,JLIM
C                                       Do direct transform in X.
            CALL QVCLR (APCORE, NAPCMP, 1, TWONY)
            CALL QDIRAD (APCORE, NAPCMS, 5, NAPCMP, NUMBER)
C                                       Read weights.
            CALL MDISK ('READ', LUNWT, FIND1, WBUFF, BIND1, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1080) IERR,I
               GO TO 990
               END IF
C                                       Do FFT in Y.
            CALL QWR
            CALL QCFFT (APCORE, NAPCMP, ONENY, 1)
C                                       Read row from GRID file.
C                                       except on first pass
            IF (.NOT.WFIRST) THEN
               CALL MDISK ('READ', LUNGD1, FIND2, GBUFF, BIND2, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1100) IERR,I
                  GO TO 990
                  END IF
               END IF
C                                       Load weights into AP.
            CALL QWR
            CALL QPUT (APCORE, WBUFF(BIND1), NAPWTS, TWONY, 2)
            CALL QWD
C                                       Load row from GRID file if nec.
            IF (.NOT.WFIRST) CALL QPUT (APCORE, GBUFF(BIND2), NAPGRD,
     *         TWONY, 2)
            CALL QWD
C                                       Multiply by weights.
            CALL QCVMUL (APCORE, NAPCMP, 2, NAPWTS, 2, NAPCMP, 2, ONENY,
     *         1)
            CALL QWR
C                                       Subtract from previous GRID file
            CALL QVSUB (APCORE, NAPCMP, 1, NAPGRD, 1, NAPCMP, 1, TWONY)
C                                       Write file back to disk.
            CALL MDISK ('WRIT', LUNWRK, FIND3, OBUFF, BIND3, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1090) IERR, I
               GO TO 990
               END IF
C                                       Read results back out.
            CALL QWR
            CALL QGET (APCORE, OBUFF(BIND3), NAPCMP, TWONY, 2)
            CALL QWD
C                                       Rotate DFT for next pass.
            WRK1 = NAPCMS + 1
            WRK2 = NAPCMS + 3
            CALL QCVMUL (APCORE, WRK1, 5, WRK2, 5, WRK1, 5, NUMBER, 1)
            CALL QWR
 150        CONTINUE
C                                       End of this pass, close files.
         CALL ZCLOSE (LUNWT, FIND1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1150) IERR
            CALL MSGWRT (8)
            END IF
         CALL ZCLOSE (LUNGD1, FIND2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1160) IERR
            CALL MSGWRT (8)
            END IF
C                                       Finish writing GRID file.
         CALL MDISK ('FINI', LUNWRK, FIND3, OBUFF, BIND3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1170) IERR
            GO TO 990
            END IF
         CALL ZCLOSE (LUNWRK, FIND3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1160) IERR
            CALL MSGWRT (8)
            END IF
         CLNLST = CLNLST + JNUM
         NUMCLN = NUMCLN - JNUM
C                                       Switch WRK and GRID files.
         CALL FSWTCH (GRDFIL, WRKFIL, GRDVOL, WRKVOL, CNOGRD, CNOWRK,
     *      BOGRD, BOWRK)
C                                       Check for more CLEAN components.
         WFIRST = F
C                                       Call AP roller before next pass
         IF (CLNLST.LT.CLNSTR) CALL QROLL (APCORE, 0, BUFF1, BUFSZ1,
     *      IRET)
         IF (CLNLST.LT.CLNSTR) GO TO 10
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('GRIDER: ERROR ',I3,' OPENING FILE ')
 1020 FORMAT ('GRIDER: ERROR ',I3,' INIT WEIGHT FILE')
 1030 FORMAT ('GRIDER: ERROR ',I3,' OPENING GRID FILE ')
 1050 FORMAT ('GRIDER: ERROR ',I3,' INIT GRID FILE')
 1090 FORMAT ('GRIDER: WRITE ERROR ',I3,' GRID ROW ',I6)
 1080 FORMAT ('GRIDER: ERROR ',I3,' READ WEIGHT ROW ',I6)
 1100 FORMAT ('GRIDER: ERROR ',I3,' READ GRID ROW ',I6)
 1150 FORMAT ('GRIDER: ERROR ',I3,' CLOSING WEIGHT FILE')
 1160 FORMAT ('GRIDER: ERROR ',I3,' CLOSING GRID FILE')
 1170 FORMAT ('GRIDER: FINISH ERROR ',I3,' WRITING GRID FILE ')
      END
      SUBROUTINE HISTOB (IERR)
C-----------------------------------------------------------------------
C   HISTOB determines the largest exterior sidelobe as a function of
C   the beam patch size. Beam assumed in GRD file.
C    Input:
C        LUMGRD I   = Logical unit number for the beam file.
C        GRDFIL I   = the name of the beam map file.
C        MAXPCH I   = maximum beam patch size to be considered.
C        NX,NY  I   = X and Y dimensions of the full beam map.(cells).
C        NUMBIN I   = Number of levels considered for the fraction
C                     of the peak.
C        BOGRD I   = Blok offset for beam map.
C    Output:
C        BMHIS  I   = An array whose elements have values between 1
C                     and NUMBIN + 1 indicating the maximum abs.
C                     exterior sidelobe for a beam patch whose size
C                     corresponds to the array index.
C                     e.g. for a beam patch of half size I the maximum
C                     fractional absolute sidelobe level exterior to the
C                     beam patch is BMHIS(I) / NUMBIN  .
C-----------------------------------------------------------------------
      INTEGER   FIND, BIND, IERR, IPCH, IY, I, ITEMP, J, JJ, LIMIT,
     *   MAXMUM, NXHAF, NYHAF, IT1, IT2, LMXPCH
      LOGICAL   MAP, EXCL, WAIT
      REAL      XBUFF(1), BMBUF(1)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (XBUFF(1), BUFF1(1)),      (BMBUF(1), BUFF3(1))
      DATA MAP, EXCL, WAIT /3*.TRUE./
C-----------------------------------------------------------------------
C                                       Search entire beam map.
C                                       Center is at (NX/2+1,NY/2+1).
      NYHAF = NY / 2 + 1
      NXHAF = NX / 2 + 1
      MAXMUM = MAX (NYHAF, NXHAF)
C                                      Open beam file.
      CALL ZOPEN (LUNGD1, FIND, GRDVOL, GRDFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
C                                       Check to be sure MAXPCH is permi
      IT1 = NX / 2 - 1
      IT2 = NY / 2 - 1
      LMXPCH = MIN (MAXPCH, IT1, IT2, BMHSIZ)
C                                       Set window for histogram.
      WINB(1) = 1
      WINB(2) = 1
      WINB(3) = NX
      WINB(4) = NYHAF
C                                      Initialize beam map.
       CALL MINIT ('READ', LUNGD1, FIND, NX, NY, WINB, XBUFF, BUFSZ1,
     *    BOGRD, IERR)
       IF (IERR.NE.0) THEN
          WRITE (MSGTXT,1010) IERR
          GO TO 990
          END IF
C                                      Initialize BMHIS to zero.
       DO 20 I = 1,MAXMUM
         BMBUF(I) = 0
 20      CONTINUE
C                                      Loop thru map looking for max.
C                                      abs. sidelobe level on each beam
C                                      patch boundary.
      DO 40 I = 1,NYHAF
C                                      Read row of the map.
         CALL MDISK ('READ', LUNGD1, FIND, XBUFF, BIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR,I
            GO TO 990
            END IF
         IY = NYHAF - I - 1
C                                      Loop down the row.
         DO 30 J = 1,NX
            JJ = BIND + J - 1
C                                      Compute min. beam patch including
C                                      this pixel. Adjust the index so t
C                                      order in array gives the largest
C                                      EXTERIOR sidelobe.
            ITEMP = J - NXHAF
            ITEMP = ABS (ITEMP) - 1
            IPCH = MAX (IY, ITEMP, 1)
C                                      Replace current value of
C                                      BMBUF(IPCH) if abs. value of
C                                      this pixel is larger.
            BMBUF(IPCH) = MAX (BMBUF(IPCH), ABS(XBUFF(JJ)))
 30         CONTINUE
 40      CONTINUE
C                                      Close beam file.
      CALL ZCLOSE (LUNGD1, FIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         CALL MSGWRT (8)
         END IF
C                                      Make sure BMBUF for each beam
C                                      patch is.GE.that for larger
C                                      beam patches.
      LIMIT = MAXMUM - 1
      DO 50 I = 1,LIMIT
         J = MAXMUM - I + 1
         IF (BMBUF(J-1).LT.BMBUF(J)) BMBUF(J-1) = BMBUF(J)
C                                      Check that value. le. 1.0
         IF (ABS (BMBUF(J-1)).GT.1.05) THEN
            WRITE (MSGTXT,1045) BMBUF(J-1)
            IERR = 6
            GO TO 990
            END IF
 50      CONTINUE
C                                      Scale BMHIS to range (1,NUMBIN+1)
      DO 60 I = 1,LMXPCH
         BMHIS(I) = BMBUF(I) * NUMBIN + 1.5
 60      CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('HISTOB: ERROR',I3,' OPENING FILE ')
 1010 FORMAT ('HISTOB: ERROR',I3,' INIT FILE ')
 1020 FORMAT ('HISTOB: READ ERROR',I3,' ROW ',I5)
 1040 FORMAT ('HISTOB: ERROR',I3,' CLOSING FILE ')
 1045 FORMAT ('HISTOB: BAD BEAM VALUE =',1PE10.3)
      END
      SUBROUTINE MAPPAK (APCORE, IERR)
C-----------------------------------------------------------------------
C   MAPPAK takes points from the residual map greater than MAPLIM
C   and places them with their addresses into the array processor.
C    Input :
C      LUNRES I   = Logical unit number for the residual map file.
C      RESFIL I   = Name of the residual map file.
C      MAPLIM R   = Limiting map value .
C      BORES  I   = Blok offset for the residual map.
C      WINM   I   = Windows for the map.
C      NBOXS  I   = Number of boxes in CLEAN map
C      APSIZ  R   = Size of the Array Processor in words.
C   Output:
C     Residual map points greater than MAPLIM and their addresses
C     are placed in the array processor.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   FIND, BIND, IERR, I, IBOX, IPTR, J, JJ, MY,
     *   WIN(4), LOX, HIX, LOY, HIY, MINY, MAXY, JPTR, JPTRP1, LPTR
      LOGICAL   MAP, EXCL, WAIT
      REAL      V(1), X(1), Y(1), XBUFF(1)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (XBUFF(1), BUFF1(1)),      (X(1), BUFF2(1)),
     *   (Y(1), BUFF2(4097)),        (V(1), BUFF3(1))
      DATA MAP, EXCL, WAIT /3*.TRUE./
C-----------------------------------------------------------------------
C                                      Open residual file.
      CALL ZOPEN (LUNRES, FIND, RESVOL, RESFIL, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
      IPTR = 0
      PTRJ = BMOFFS
C                                       Find max,min Y
      MAXY = -30000
      MINY = 30000
      DO 20 IBOX = 1,NBOXS
         MAXY = MAX (MAXY, WINM(2,IBOX), WINM(4,IBOX))
         MINY = MIN (MINY, WINM(2,IBOX), WINM(4,IBOX))
 20      CONTINUE
      IF (MINY.LE.0) MINY = 1
      IF (MAXY.LE.0) MAXY = NY
      WIN(1) = 1
      WIN(2) = MINY
      WIN(3) = NX
      WIN(4) = MAXY
      MY = HIY - LOY + 1
C                                      Initialize residual map.
      CALL MINIT ('READ', LUNRES, FIND, NX, NY, WIN, XBUFF, BUFSZ1,
     *   BORES, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       Loop thru map looking for points
C                                       greater than MAPLIM.
      IPTR = 0
      DO 80 I = MINY,MAXY
C                                      Read row of the map.
         CALL MDISK ('READ', LUNRES, FIND, XBUFF, BIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR, I
            GO TO 990
            END IF
C                                       Loop over boxes
         DO 70 IBOX = 1,NBOXS
            LOY = MIN (WINM(2,IBOX), WINM(4,IBOX))
            HIY = MAX (WINM(2,IBOX), WINM(4,IBOX))
            IF (HIY.LE.0) HIY = NY
            IF ((I.LT.LOY) .OR. (I.GT.HIY)) GO TO 70
            LOX = MIN (WINM(1,IBOX), WINM(3,IBOX))
            HIX = MAX (WINM(1,IBOX), WINM(3,IBOX))
C                                      Loop down the row.
            DO 60 J = LOX, HIX
               JJ = BIND + J - 1
               IF (ABS (XBUFF(JJ)).GT.MAPLIM) THEN
                  IPTR = IPTR + 1
                  V(IPTR) = XBUFF(JJ)
                  X(IPTR) = J
                  Y(IPTR) = I
C                                      Check to see if buffer full.
                  IF (IPTR.GE.256) THEN
C                                       Check if AP full.
                     IF (PTRJ+IPTR*3.GE.APSIZ) GO TO 90
                     JPTR = PTRJ
                     JPTRP1 = JPTR + 2
                     CALL QWR
                     CALL QPUT (APCORE, V, 2, 256, 2)
                     CALL QWD
                     CALL QVMOV (APCORE, 2, 1, JPTRP1, 3, 256)
                     CALL QWR
                     CALL QPUT (APCORE, Y, 2, 256, 2)
                     JPTRP1 = JPTR + 1
                     CALL QWD
                     CALL QVMOV (APCORE, 2, 1, JPTRP1, 3, 256)
                     CALL QWR
                     CALL QPUT (APCORE, X, 2, 256, 2)
                     CALL QWD
                     CALL QVMOV (APCORE, 2, 1, JPTR, 3, 256)
                     IPTR = 0
                     PTRJ = PTRJ + 3 * 256
                     END IF
                  END IF
 60            CONTINUE
 70         CONTINUE
 80      CONTINUE
      GO TO 100
C                                      If program gets here AP filled.
 90   WRITE (MSGTXT,1090)
      CALL MSGWRT (8)
C                                      Write last buffer into the AP.
C                                      Check if AP full.
 100  IF ((IPTR.GT.0) .AND. (PTRJ+IPTR*3.LT.APSIZ)) THEN
         LPTR = IPTR
         JPTR = PTRJ
         JPTRP1 = PTRJ + 2
         CALL QWR
         CALL QPUT (APCORE, V, 2, LPTR, 2)
         CALL QWD
         CALL QVMOV (APCORE, 2, 1, JPTRP1, 3, LPTR)
         CALL QWR
         CALL QPUT (APCORE, Y, 2, LPTR, 2)
         JPTRP1 = JPTR + 1
         CALL QWD
         CALL QVMOV (APCORE, 2, 1, JPTRP1, 3, LPTR)
         CALL QWR
         CALL QPUT (APCORE, X, 2, LPTR, 2)
         CALL QWD
         CALL QVMOV (APCORE, 2, 1, JPTR, 3, LPTR)
         PTRJ = PTRJ + 3 * IPTR
         END IF
C                                      Close residual file.
      CALL ZCLOSE (LUNRES, FIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) IERR
         CALL MSGWRT (8)
         END IF
C                                       Set and print number of points.
      PTRK = (PTRJ - BMOFFS) / 3
      WRITE (MSGTXT,1120) PTRK
      CALL MSGWRT (2)
C                                       Call AP roller
      JPTR = PTRJ
      CALL QROLL (APCORE, JPTR, BUFF1, BUFSZ1, IERR)
C                                       Check that some data loaded
      IF (PTRK.GT.0) GO TO 999
         IERR = 1
         WRITE (MSGTXT,1121)
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MAPPAK: ERROR',I3,' OPENING FILE ')
 1020 FORMAT ('MAPPAK: ERROR',I3,' INIT FILE ')
 1030 FORMAT ('MAPPAK: READ ERROR',I3,' ROW ',I5)
 1090 FORMAT ('MAPPAK: NOT ENOUGH ROOM FOR ALL MAP POINTS ')
 1110 FORMAT ('MAPPAK: ERROR',I3,' CLOSING FILE ')
 1120 FORMAT ('MAPPAK:',I8,' Residual map points loaded into AP')
 1121 FORMAT ('NO RESIDUAL POINTS LOADED INTO AP, I QUIT')
      END
      SUBROUTINE RESTOR (APCORE, IERR)
C-----------------------------------------------------------------------
C   RESTOR restores CLEAN components to GRID file.  This is done by
C   transforming the CLEAN components, multiplying by the appropriate
C   Gaussian function and adding to the GRID file.
C   Output is to file WRK and then the names and addresses of the WRK
C   and GRID files are switched.
C   Input:
C     CLNSTR I   = highest number component to transform
C     CLEAN components from file CLNFIL.
C   Output:
C     Transform of additional CLEAN components times the restoring fn
C     added to the file GRDFIL.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   FIND1, FIND2, BIND2, BIND3, IERR, WIN(4), NLOAD, I, JLIM
      INTEGER   FIRST, NUMCLN, MAXCMP, JNUM, IAPSIZ,
     *   WRK1, WRK2, NAPGAU, NAPEX1, NAPEXP, NAPRES, NAPGRD,
     *   NAPCMP, NAPCMS, NUMBER, APBUF, ONENY, TWONY
      LOGICAL   MAP, EXCL, WAIT, F
      REAL      TEMP, GBUFF(1), OBUFF(1)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
C      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      EQUIVALENCE (OBUFF(1), BUFF1(1)),      (GBUFF(1), BUFF2(1))
      DATA APBUF / 1 /
      DATA EXCL, WAIT, MAP, F /3*.TRUE., .FALSE./
C-----------------------------------------------------------------------
C                                       Determine Area assignments in AP
      ONENY = NY
      TWONY = 2 * NY
      NAPRES = 100
      WRK1 = ONENY + 1
      WRK2 = TWONY + 1
      NAPEXP = NAPRES + WRK1
      NAPGRD = NAPEXP + WRK1
      NAPCMP = NAPGRD + WRK2
      NAPGAU = NAPCMP + WRK2
      NAPEX1 = NAPGAU + WRK1
      NAPCMS = NAPEX1 + WRK1
C                                       Determine maximum number of comp
C                                       per pass.
      IAPSIZ = 1024 * PSAPNW
      MAXCMP = (IAPSIZ - NAPCMS) / 5.0
      NUMCLN = CLNSTR
      CLNLST = 1
      APBUF = 2
C                                       Determine size of AP buffer for
      NLOAD = NAPGAU - 3
C                                       Prepare work arrays in AP.
      CALL INGAUS (APCORE)
C                                       Roll AP if necessary
      CALL QROLL (APCORE, NAPCMS, BUFF3, BUFSZ3, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Begin component loop.
 10   CONTINUE
         NUMBER = MAXCMP
         IF (NUMCLN.LT.MAXCMP) NUMBER = NUMCLN
C                                       Load CLEAN components this pass.
         FIRST = CLNLST
         JNUM = NUMBER
         CALL CMPCRM (APCORE, NAPCMS, APBUF, FIRST, NUMBER, NLOAD, F,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         WIN(1) = 1
         WIN(2) = 1
         WIN(3) = NY * 2
         WIN(4) = NX / 2 + 1
C                                       Open and INIT GRID file for read
         CALL ZOPEN (LUNGD1, FIND2, GRDVOL, GRDFIL, MAP, EXCL, WAIT,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
         CALL MINIT ('READ', LUNGD1, FIND2, WIN(3), WIN(4), WIN, GBUFF,
     *      BUFSZ2, BOGRD, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Open and INIT GRID file for writ
         CALL ZOPEN (LUNWRK, FIND1, WRKVOL, WRKFIL, MAP, EXCL, WAIT,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
         CALL MINIT ('WRIT', LUNWRK, FIND1, WIN(3), WIN(4), WIN, OBUFF,
     *      BUFSZ1, BOWRK, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Prepare NAPEXP using weight left
C                                       in AP loc 0 by INGAUS.
         CALL QVCLR (APCORE, NAPEXP, 1, ONENY)
         CALL QVSADD (APCORE, NAPEXP, 1, 0, NAPEXP, 1, ONENY)
         CALL QWR
C                                       Begin loop thru map.
         JLIM = NX / 2 + 1
         DO 150 I = 1,JLIM
C                                        Generate restoring factors.
            TEMP = (-0.5 * GAUSCC * (I - 1.0) ** 2 )
            RDUM(1) = TEMP
            CALL QPUT (APCORE, RDUM , 1, 1, 2)
            CALL QWAIT
            CALL QVSADD (APCORE, NAPGAU, 1, 1, NAPRES, 1, ONENY)
            CALL QVADD (APCORE, NAPRES, 1, NAPEXP, 1, NAPRES, 1, ONENY)
            CALL QVEXP (APCORE, NAPRES, 1, NAPRES, 1, ONENY)
C                                       Read row from GRID file.
            CALL MDISK ('READ', LUNGD1, FIND2, GBUFF, BIND2, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1080) IERR,I
               GO TO 990
               END IF
C                                       Write file back to disk.
            CALL MDISK ('WRIT', LUNWRK, FIND1, OBUFF, BIND3, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1090) IERR, I
               GO TO 990
               END IF
C                                       Prepare NAPEXP for next pass.
            CALL QVADD (APCORE, NAPEXP, 1, NAPEX1, 1, NAPEXP, 1, ONENY)
            CALL QWR
C                                       Clear NAPCMP.
            CALL QVCLR (APCORE, NAPCMP, 1, TWONY)
C                                       Do direct transform in X.
            CALL QDIRAD (APCORE, NAPCMS, 5, NAPCMP, NUMBER)
            CALL QWR
C                                       Do FFT in Y.
            CALL QCFFT (APCORE, NAPCMP, ONENY, 1)
            CALL QWR
C                                       Load row from GRID file.
            CALL QPUT (APCORE, GBUFF(BIND2), NAPGRD, TWONY, 2)
            CALL QWD
C                                       Multiply by restoring function.
            CALL QCRVMU (APCORE, NAPCMP, 2, NAPRES, 1, NAPCMP, 2, ONENY)
            CALL QWR
C                                       Add to GRID file.
            CALL QVADD (APCORE, NAPCMP, 1, NAPGRD, 1, NAPCMP, 1, TWONY)
C                                       Read results back out.
            CALL QWR
            CALL QGET (APCORE, OBUFF(BIND3), NAPCMP, TWONY, 2)
            CALL QWD
C                                       Rotate DFT for next pass.
            WRK1 = NAPCMS + 1
            WRK2 = NAPCMS + 3
            CALL QCVMUL (APCORE, WRK1, 5, WRK2, 5, WRK1, 5, NUMBER, 1)
            CALL QWR
 150        CONTINUE
C                                       Finish writing GRID file.
         CALL MDISK ('FINI', LUNWRK, FIND1, OBUFF, BIND3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1090) IERR,JLIM
            GO TO 990
            END IF
C                                       End of this pass, close files.
         CALL ZCLOSE (LUNGD1, FIND2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1160) IERR
            CALL MSGWRT (8)
            END IF
         CALL ZCLOSE (LUNWRK, FIND1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1160) IERR
            CALL MSGWRT (8)
            END IF
         CLNLST = CLNLST + JNUM
         NUMCLN = NUMCLN - JNUM
C                                       Switch WRK and GRID files.
         CALL FSWTCH (GRDFIL, WRKFIL, GRDVOL, WRKVOL, CNOGRD, CNOWRK,
     *      BOGRD, BOWRK)
C                                       Roll AP if necessary
         IF (CLNLST.LE.CLNSTR) CALL QROLL (APCORE, NAPCMS, BUFF3,
     *      BUFSZ3, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       Check for more CLEAN components.
         IF (CLNLST.LE.CLNSTR) GO TO 10
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('RESTOR: ERROR ',I3,' OPENING GRID FILE ')
 1050 FORMAT ('RESTOR: ERROR ',I3,' INIT GRID FILE')
 1090 FORMAT ('RESTOR: WRITE ERROR ',I3,' GRID ROW ',I6)
 1080 FORMAT ('RESTOR: ERROR ',I3,' READ GRID ROW ',I6)
 1160 FORMAT ('RESTOR: ERROR ',I3,' CLOSING GRID FILE')
      END
      SUBROUTINE CMPCRM (APCORE, APLO, APBUF, FIRST, NUMBER, NLOAD,
     *   LFIRST, IERR)
C-----------------------------------------------------------------------
C   CMPCRM loads CLEAN components into the Array Processor
C   in preparation for transformation to the data plane.
C   If CMPCRM starts from the first component, the flux density
C   of the CLEAN components is summed.
C   The signs of the cell offsets are adjusted for flips made to
C   the map.
C    Input:
C     APLO   I   = AP start location for the component array.
C     APBUF  I   = AP start location for the buffer.
C     FIRST  I   = First CLEAN component to be loaded.
C     NUMBER I   = Number of CLEAN components to be loaded.
C     NLOAD  I   = AP buffer size.
C     LFIRST L   = .TRUE. iff CLEAN components are to be summed.
C    Output:
C     NUMBER  I     Number of clean components loaded.
C     CLEAN components loaded into the AP in blocks of 5 words
C     arrainged as follows:
C         0 = Y (integer form)
C         1 = FLUX * cos(UX)
C         2 = FLUX * sin(UX)
C         3,4 = cos, sin(X)
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   APLO, APBUF, FIRST, NUMBER, NLOAD, IERR
      LOGICAL   LFIRST
C
      INTEGER   IBUFF(512), CATBLK(256), LIMIT, NCOUNT, I, APLOC,
     *   APLOC1, APLOC2, APLOC3, APLOC4, NNCNT, JJCNT, IPOINT,
     *   ICOUNT, JCOUNT
      REAL      CFLUX(1), TEMP(6), TWOPIX, RAC(1), DECC(1), CATR(256),
     *   XCEN, YCEN
      LOGICAL   FA
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (BUFF1(1), IBUFF(1))
      EQUIVALENCE (BUFF2(1), CFLUX(1)),      (BUFF3(1), RAC(1)),
     *   (BUFF3(LBUFSZ/2+1), DECC(1)),  (CATBLK, CATR)
      DATA FA /.FALSE./
C-----------------------------------------------------------------------
C                                       Determine beam center.
      XCEN = CATR (KRCRP)
      YCEN = CATR (KRCRP+1)
      XCEN = (XCEN - NX/2 - 1) * XSPACE
      YCEN = (YCEN - NY/2 - 1) * YSPACE
C                                       Open CLEAN component file.
      JCOUNT = 0
      CALL CCMINI ('READ', CCBUFF, CLNVOL, FCNO(3), CLNVER, CATBLK,
     *   LUNCL2, CCRNO, CCKOLS, CCNUMV, CCNCOL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
      APLOC = APLO
      ICOUNT = 0
      IPOINT = FIRST
C                                       Begin loading into computer buff
C                                       Make sure to load in small
C                                       enough pieces.
      LIMIT = BUFSZ1 / 8
      IF (LIMIT.GT.NUMBER) LIMIT = NUMBER
      LIMIT = MIN (LIMIT, NLOAD)
C                                       Jump to here if more passes nece
 30   CONTINUE
         NCOUNT = 0
         DO 50 I = 1,LIMIT
            CCRNO = IPOINT
            CALL TABCCM ('READ', CCBUFF, CCRNO, CCKOLS, CCNUMV, CCNCOL,
     *         XX, YY, ZZ, CCFLUX, CCTYPE, PARMS, IERR)
            IF (IERR.GT.0) THEN
               WRITE (MSGTXT,1030) IERR, IPOINT
               GO TO 990
               END IF
            IF (((CCNCOL.LE.3) .OR. (CCTYPE.EQ.0)) .AND. (IERR.EQ.0))
     *         THEN
               NCOUNT = NCOUNT + 1
               CFLUX(NCOUNT) = CCFLUX
               RAC(NCOUNT) = XX + XCEN
               DECC(NCOUNT) = YY + YCEN
               END IF
            IPOINT = IPOINT + 1
 50         CONTINUE
         IF (NCOUNT.LE.0) GO TO 55
         NNCNT = NCOUNT
C                                       Form AP indexes.
         APLOC1 = APLOC + 1
         APLOC2 = APLOC + 2
         APLOC3 = APLOC + 3
         APLOC4 = APLOC + 4
C                                       Load data into AP buffer APBUF.
C                                       Load flux density (FLUX*cos(ux))
         CALL QPUT (APCORE, CFLUX, APBUF, NNCNT, 2)
         CALL QWD
         CALL QVMOV (APCORE, APBUF, 1, APLOC1, 5, NNCNT)
C                                        Load and fix dec cell numbers.
         CALL QWR
         CALL QPUT (APCORE, DECC, APBUF, NNCNT, 2)
         CALL QWD
C                                       Move values before fixing.
         CALL QVMOV (APCORE, APBUF, 1, APLOC, 5, NNCNT)
         CALL QWR
C                                       Set constants in AP.
         TEMP(1) = (-NY/2.) * YSPACE
         TEMP(2) = (NY/2.0-1.0) * YSPACE
         TEMP(3) = NY * YSPACE
         TEMP(4) = 2.0 / YSPACE
         TEMP(5) = 0.0
         TEMP(6) = -0.5 * YSPACE
         CALL QPUT (APCORE, TEMP, 1, 6, 2)
         CALL QWD
C                                       Put declinations in the range
C                                       (0,NY-1) and multiply by 2,fix.
C                                       Use APLOC2 for temporary use.
         CALL QVFILL (APCORE, 6, APLOC2, 5, NNCNT)
         CALL QVCLIP (APCORE, APLOC, 5, 1, 2, APLOC, 5, NNCNT)
         CALL QLVGT (APCORE, APLOC2, 5, APLOC, 5, APLOC2, 5, NNCNT)
         CALL QVSMUL (APCORE, APLOC2, 5, 3, APLOC2, 5, NNCNT)
         CALL QVADD (APCORE, APLOC2, 5, APLOC, 5, APLOC, 5, NNCNT)
         CALL QVSMAF (APCORE, APLOC, 5, 4, 5, APLOC, 5, NNCNT)
C                                       Load and float RA cell numbers.
         CALL QWR
         CALL QPUT (APCORE, RAC, APBUF, NNCNT, 2)
         CALL QWD
         CALL QVMOV (APCORE, APBUF, 1, APLOC3, 5, NNCNT)
C                                       Store -2*PI/NX/XSPACE
         TWOPIX = (-6.283185/NX) / XSPACE
         CALL QWR
         RDUM(1) = TWOPIX
         CALL QPUT (APCORE, RDUM, 1, 1, 2)
         CALL QWD
C                                       Scale RAs by -2*PI/NX/XSPACE
         CALL QVSMUL (APCORE, APLOC3, 5, 1, APLOC3, 5, NNCNT)
C                                       Clear APLOC+2 (FLUX*sin(ux) ).
         CALL QVCLR (APCORE, APLOC2, 5, NNCNT)
C                                       Take sine and cosine of
C                                       RA to 3 and 4.
         CALL QVSIN (APCORE, APLOC3, 5, APLOC4, 5, NNCNT)
         CALL QVCOS (APCORE, APLOC3, 5, APLOC3, 5, NNCNT)
 55      ICOUNT = ICOUNT + LIMIT
         JCOUNT = JCOUNT + NCOUNT
C                                       If load complete close CLNFIL
C                                       and return.
         IF (ICOUNT.LT.NUMBER) THEN
C                                       Update APLOC.
            APLOC = APLOC + NNCNT * 5
            IF (NUMBER-ICOUNT.LT.LIMIT) LIMIT = NUMBER - ICOUNT
C                                       Return for another load.
            GO TO 30
            END IF
C                                       IF (LFIRST) sum fluxes.
      IF (LFIRST) THEN
         APLOC1 = APLO + 1
         JJCNT = JCOUNT
         CALL QSVE (APCORE, APLOC1, 5, 1, JJCNT)
         CALL QWR
         CALL QGET (APCORE, RDUM, 1, 1, 2)
         TEMP = RDUM(1)
         CALL QWD
         FLUX = FLUX + TEMP(1)
         END IF
C                                     Make sure CC loaded.
      IF (JCOUNT.LE.0) THEN
         WRITE (MSGTXT,1065)
         IERR = 1
         GO TO 990
         END IF
      NUMBER = JCOUNT
C                                       Close CLNFIL.
      CALL TABCCM ('CLOS', CCBUFF, CCRNO, CCKOLS, CCNUMV, CCNCOL,
     *   XX, YY, ZZ, CCFLUX, CCTYPE, PARMS, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1070) IERR
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CMPCRM: ERROR',I3,' OPENING FILE ')
 1030 FORMAT ('CMPCRM: READ ERROR',I3,' RECORD ',I5)
 1065 FORMAT ('CMPCRM: NO POINT CLEAN COMPONENTS FOUND')
 1070 FORMAT ('CMPCRM: ERROR',I3,' CLOSING FILE ')
      END
      SUBROUTINE INGAUS (APCORE)
C-----------------------------------------------------------------------
C   INGAUS creates the arrays in the AP necessary for restoring with
C   an eliptical gaussian.
C    Input:
C     NX,NY     I    Number of map grid cells in X and Y.
C     GAUSA     R    Major Axis (FWHP in cells)
C     GAUSB     R    Minor axis size (FWHP in cells).
C     GAUSB     R    Position angle of restoring beam (deg ).
C     XSPACE    R    RA grid spacing (deg).
C     YSPACE    R    Dec grid spacing (deg).
C     MAPROT    R    Coordinate rotation (deg).
C    Output:
C     GAUSAA     R    Coefficient of u**2
C     GAUSBB     R    Coefficient of u*v
C     GAUSCC     R    Coefficient of v**2
C     Normalization constant for the restoring Gaussian left in
C                  AP location 0.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      REAL      COMP(1), WT, WT1, XNX2, XNY2, XNXNY, TEMP,
     *   AK, AM, AN, TA, TB, ARG
      INTEGER   I, JLIM, K
      INTEGER   NAPRES, NAPGAU, NAPEXP, NAPEX1, NAPGRD, NAPCMP, NAPCMS,
     *   NAPRS1, ONENY, TWONY, WRK1, WRK2
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (BUFF1(1), COMP(1))
C-----------------------------------------------------------------------
C                                       Set AP assignments.
      ONENY = NY
      TWONY = 2 * NY
      NAPRES = 100
      WRK1 = ONENY + 1
      WRK2 = TWONY + 1
      NAPEXP = NAPRES + WRK1
      NAPGRD = NAPEXP + WRK1
      NAPCMP = NAPGRD + WRK2
      NAPGAU = NAPCMP + WRK2
      NAPEX1 = NAPGAU + WRK1
      NAPCMS = NAPEX1 + WRK1
C                                       Do a little arithmetic to put
C                                       the beam parameters into useable
C                                       form. Convert to sigma, then to
C                                       coeficients of U**2, U*V, and
C                                       V**2 the last of which is return
C                                       for later use.
      TA = GAUSA * 3.1415927 / 1.1774
      TB = GAUSB * 3.1415927 / 1.1774
      AM = COS ((GAUSC + MAPROT) * 3.1415927 / 180.)
      AN = SIN ((GAUSC + MAPROT) * 3.1415927 / 180.)
      XNX2 = NX * XSPACE * 3600.
      XNY2 = NY * YSPACE * 3600.
      XNXNY = ABS (XNX2 * XNY2)
      XNX2 = XNX2 ** 2
      XNY2 = XNY2 ** 2
      GAUSAA = (TA*TA*AM*AM + TB*TB*AN*AN) / (XNY2)
      GAUSCC = (TA*TA*AN*AN + TB*TB*AM*AM) / (XNX2)
      GAUSBB = ((TB*TB-TA*TA) * AN*AM) / (XNXNY )
C                                       Create array NAPEX1.
      DO 10 I = 1,NY
         K = I - 1
         IF (I.GT.NY/2) K = K - NY
         COMP(I) = (-GAUSBB * K)
 10      CONTINUE
C                                       Load NAPEX1 into AP.
      CALL QPUT (APCORE, COMP, NAPEX1, ONENY, 2)
      CALL QWD
C                                       Create array NAPGAU.
      DO 20 I = 1,NY
         K = I - 1
         IF (I.GT.NY/2) K = K - NY
         AK = K
         COMP(I) = -0.5 * GAUSAA * AK * AK
 20      CONTINUE
C                                       Load NAPGAU into AP.
      CALL QPUT (APCORE, COMP, NAPGAU, ONENY, 2)
C                                       Initialize array NAPEXP.
      RDUM(1) = 0.0
      CALL QPUT (APCORE, RDUM, 0, 1, 2)
      CALL QWD
      CALL QVCLR (APCORE, NAPEXP, 1, ONENY)
      CALL QVSADD (APCORE, NAPEXP, 1, 0, NAPEXP, 1, ONENY)
C                                       Initialize NAPRES for summing
C                                       weights
      NAPRS1 = NAPRES - 1
      WRK1 = ONENY + 1
      CALL QVCLR (APCORE, NAPRS1, 1, WRK1)
      CALL QWR
C                                       Calculate sum of the weights.
      JLIM = NX / 2
      DO 40 I = 1,JLIM
         TEMP = -0.5 * GAUSCC * (I - 1.0) ** 2
         RDUM(1) = TEMP
         CALL QPUT (APCORE, RDUM, 1, 1, 2)
         CALL QWD
         CALL QVSADD (APCORE, NAPGAU, 1, 1, NAPRES, 1, ONENY)
         CALL QVADD (APCORE, NAPRES, 1, NAPEXP, 1, NAPRES, 1, ONENY)
         CALL QVEXP (APCORE, NAPRES, 1, NAPRES, 1, ONENY)
         CALL QSVE (APCORE, NAPRS1, 1, NAPRS1, WRK1)
C                                       Prepare NAPEXP for next pass.
         CALL QVADD (APCORE, NAPEXP, 1, NAPEX1, 1, NAPEXP, 1, ONENY)
         CALL QWR
C                                       Get intermediate sum.
         IF (I.EQ.1) THEN
            CALL QGET (APCORE, RDUM, NAPRS1, 1, 2)
            WT1 = RDUM(1)
            END IF
 40      CONTINUE
C                                       Get sum of the weights.
      CALL QGET (APCORE, RDUM, NAPRS1, 1, 2)
      WT = RDUM(1)
      CALL QWD
C                                       Compute weight over whole plane.
      WT = 2.0 * WT - WT1
      ARG = 1.0 / WT
      WT = LOG (ARG)
C                                       Store WT in AP loc 0.
      RDUM(1) = WT
      CALL QPUT (APCORE, RDUM, 0, 1, 2)
      CALL QWD
C
 999  RETURN
      END
      SUBROUTINE APCTEL (FINISH, NORES, NONEG, ITV, IRET)
C-----------------------------------------------------------------------
C   APCTEL checks the TELL file to see if anything is waiting for APCLN.
C   If so, it picks up the parms (via GTTELL), interprets them, and
C   sends them back to the rest of the task to handle.
C   In/out:   FINISH  L     Time to quit normally
C             NORES   L     Do not restore the components
C             NONEG   L     Quit on negative
C             ITV     I     =1 => do TV display
C   Output:   IRET    I     0 => okay, 99 => abort now
C-----------------------------------------------------------------------
      CHARACTER OPTELL*4
      LOGICAL   FINISH, NORES, NONEG
      INTEGER   ITV, IRET
      INTEGER   NPARMS, SCRTCH(256), IERR
      REAL      XGN, XFLUX, XNITER, XBMAJ, XBMIN, XBPA, XFCTR, XMINPT,
     *   XMAXPX, XDOTV
      INCLUDE 'APCLN.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /APCTLL/ XGN, XFLUX, XNITER, XBMAJ, XBMIN, XBPA, XFCTR,
     *   XMINPT, XMAXPX, XDOTV
C-----------------------------------------------------------------------
C                                       Check TELL file
      IRET = 0
      NPARMS = 10
      CALL GTTELL (NPARMS, OPTELL, XGN, SCRTCH, IERR)
      WRITE (MSGTXT,1000) OPTELL
      IF (IERR.NE.0) CALL MSGWRT (4)
      IF (IERR.EQ.2) FINISH = .TRUE.
      IF (IERR.EQ.3) IRET = 99
      IF (IERR.NE.1) GO TO 999
C                                       install parms
      FMIN = XFLUX
      IF (RESMAX.LE.FMIN) FINISH = .TRUE.
C                                       number iterations, quit
      IF (XGN.GT.0.0) GAIN = XGN
      IF (XNITER.LE.-1.0) NONEG = .TRUE.
      IF (ABS (XNITER).GE.1.0) CLNLIM = ABS (XNITER) + 0.01
      IF (CLNSTR.GT.CLNLIM) FINISH = .TRUE.
C                                       beam, no restore
      IF ((XBMAJ.NE.0.) .AND. (XBMIN.NE.0.0)) THEN
         IF (XBMAJ.LT.0.0) NORES = .TRUE.
         IF (XBMAJ.GT.0.0) THEN
            GAUSA = XBMAJ
            GAUSB = XBMIN
            GAUSC = XBPA
            END IF
         END IF
      SPEXP  = XFCTR
      IF (XMINPT.GT.3) MINPCH = XMINPT - 0.9
      MAXPIX = XMAXPX + 0.5
      ITV = 0
      IF (XDOTV.GT.0.0) ITV = 1
      IF (NTVDEV.LE.0) ITV = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RECEIVED ',A4,' OPERATION FROM TELL')
      END

      SUBROUTINE PTIME (TIME, RADS, IT, SEC)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  Routine to translate the time to a form that can be printed.
C  Inputs:
C    PTIME       R        Time in days (or radians)
C    RADS        L        .True. if in radians
C  Outputs:
C    IT          I(3)     Array with days, hours, mins
C    SEC         R        Seconds
C-----------------------------------------------------------------------
      REAL      TIME, SEC
      INTEGER   IT(3)
      LOGICAL   RADS
C
      REAL      DTIME, TIMEX
      DOUBLE PRECISION TPI
C-----------------------------------------------------------------------
      TPI = 2.0 * 3.14159265358979323846D0
      IF (RADS) THEN
         DTIME = TIME / TPI
      ELSE
         DTIME = TIME
         END IF
      IT(1) = DTIME
      TIMEX = (DTIME-IT(1)) * 24.
      IT(2) = TIMEX
      TIMEX = (TIMEX-IT(2)) * 60.
      IT(3) = TIMEX
      TIMEX = (TIMEX-IT(3)) * 60.
      SEC = TIMEX
      IF (SEC.EQ.60.0) THEN
         SEC = 0.0
         IT(3) = IT(3) + 1
         END IF
      IF (IT(3).EQ.60) THEN
         IT(3) = 0
         IT(2) = IT(2) + 1
         END IF
      IF (IT(2).EQ.24) THEN
         IT(2) = 0
         IT(1) = IT(1) + 1
         END IF
C
 999  RETURN
      END

      SUBROUTINE YCONST (OP, RCONST, GCONST, BCONST, VRTRTC, IERR)
C-----------------------------------------------------------------------
C! controls the constant registers added to the TV picture - not used
C# Y2 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YCONST reads/writes the constants which are added to the 3 sum
C   channels on the TV.
C   Inputs:
C      OP      C*4   'READ' from TV, 'WRIT' to TV
C   In/out:
C      RCONST  I     constant for red channel
C      GCONST  I     constant for green channel
C      BCONST  I     constant for blue channel
C      VRTRTC  L     Vertical retrace - do only on ?
C   Output:
C      IERR    I     error code of Z...XF : 0 => ok
C   Version for IIS M75
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   RCONST, GCONST, BCONST, IERR
      LOGICAL   VRTRTC
C
      INTEGER   UNIT, HEADER(8), BUFFER(3), BUFSIZ, NB, ZRBG
      LOGICAL   COMAND
      DATA UNIT, COMAND, BUFSIZ /8,.TRUE.,3/
C                                       Color select (M75)
      DATA ZRBG /7/
C-----------------------------------------------------------------------
C                                       WRIT: fill buffer
      IF (OP.EQ.'WRIT') THEN
         BUFFER(1) = BCONST
         BUFFER(2) = GCONST
         BUFFER(3) = RCONST
         END IF
C                                       Header & IO
      CALL YMKHDR (OP, UNIT, COMAND, BUFSIZ, 8, 0, ZRBG, 0, VRTRTC,
     *   HEADER)
      NB = 2 * BUFSIZ
      CALL ZM70XF (OP, NB, HEADER, BUFFER, IERR)
C                                       Return answers
      IF ((IERR.EQ.0) .AND. (OP.NE.'WRIT')) THEN
         BCONST = BUFFER(1)
         GCONST = BUFFER(2)
         RCONST = BUFFER(3)
         END IF
C
 999  RETURN
      END

      SUBROUTINE TVSLPL (OP, ISLUN, ISFIND, RANGE2, BLC, TRC, IFMOD,
     *   IMOD, GM, GP, GW, IERR)
C-----------------------------------------------------------------------
C! plot a slice on graphics device
C# Slice Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 2000, 2007, 2016
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Given an open slice file and an open TEK device, TVSLPL will draw
C   the slice.
C   Inputs:
C      OP      A*4      'SLIC', "RESI', 'MODL', 'GUES'
C      ISLUN   I        logical unit no. of open slice file.
C      ISFIND  I        FTAB index for slice file.
C      RANGE2  R(2)     min and max pixel value allowed for plot.
C      BLC     R(7)     bottom left corner of the plot.
C      TRC     R(7)     top right corner of plot; value 1 - 4000
C      IFMOD   I        First block of slice model data
C      IMOD    I        Model number, # gaussians on GUES
C      GM      R(4)     Peak values
C      GP      R(2,4)   GP(1,*) positions
C      GW      R(3,4)   GW(1,*) fwhm of Gaussian guesses
C   Output:
C      IERR    I        error code: 0 = none.
C                         1 = error reading slice
C                         2 = error writing TV
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   ISLUN, ISFIND, IFMOD, IMOD, IERR
      REAL      RANGE2(2), BLC(7), TRC(7), GM(4), GP(2,4), GW(3,4)
C
      DOUBLE PRECISION XVAL, YVAL
      REAL      X, Y, SCALEF, OFFSET, PARM(12), YSLICE, SCALE2, OFF2,
     *   BASLIN(3), XCEN
      INTEGER   ISTART, IEND, IRRN, INP, ISL, NRPBLK, J, NGAUSS, INDEX,
     *   IC, I
      LOGICAL   BLAST
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DTVS.INC'
C-----------------------------------------------------------------------
C                                       Draw plot.
      NRPBLK = 256
      SCALEF = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      OFFSET = 40000.0 - SCALEF * CATR(IRRAN+1)
      ISTART = BLC(1) + .5
      IEND = TRC(1) + .5
C                                       Read model data.
      IF ((OP.EQ.'RESI') .OR. (OP.EQ.'MODL') .OR. (OP.EQ.'COMP')) THEN
         IRRN = IFMOD + IMOD - 1
         CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, ISBLK, IERR)
         IF (IERR.NE.0) GO TO 930
         NGAUSS = ISBLK(25+2)
         CALL RCOPY (12, RSBLK, PARM)
         CALL RCOPY (3, RSBLK(83), BASLIN)
         XCEN = (ISTART + IEND) / 2.0
      ELSE IF (OP.EQ.'GUES') THEN
         NGAUSS = IMOD
C                                       Scale parms to go from 1 to
C                                       4000 units to header max min.
         SCALE2 = (CATR(IRRAN+1) - CATR(IRRAN)) / 39999.0
         OFF2 = CATR(IRRAN) - SCALE2
C                                       Convert user units to internal
C                                       units.
         J = 1
         DO 20 I = 1,NGAUSS
C                                       Position & maximum.
            XVAL = GP(1,I)
            YVAL = GM(I)
            CALL XYPIX (XVAL, YVAL, X, Y, IERR)
            IF (IERR.EQ.0) THEN
               PARM(J) = SCALE2 * Y  +  OFF2
               PARM(J+1) = X
C                                       Half width.
               XVAL = GP(1,I) - (GW(1,I) / 2.0 )
               CALL XYPIX (XVAL, YVAL, X, Y, IERR)
               IF (IERR.EQ.0) THEN
                  PARM(J+2) = 2.0 * ABS (PARM(J+1) - X)
                  IF (PARM(J+2).LE.0.0) GO TO 960
                  END IF
               END IF
            J = J + 3
            IF (IERR.NE.0) GO TO 960
 20         CONTINUE
         END IF
C                                       plot with data
      IF (OP.NE.'COMP') THEN
C                                       Read 1st block of slice pts.
         IRRN = 3 + (ISTART - 1) / NRPBLK
         CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, ISBLK, IERR)
         IF (IERR.NE.0) GO TO 930
         INDEX = ISTART - ((IRRN - 3) * NRPBLK)
         BLAST = .TRUE.
C                                       Plot residual data points.
         DO 50 ISL = ISTART,IEND
C                                       Read another block of data.
            IF (INDEX.GT.NRPBLK) THEN
               IRRN = IRRN + 1
               CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, ISBLK, IERR)
               IF (IERR.NE.0) GO TO 930
               INDEX = 1
               END IF
            YSLICE = RSBLK(INDEX)
            INDEX = INDEX + 1
C                                       Blanked pixel found. Dont show
            IF (YSLICE.EQ.FBLANK) THEN
               BLAST = .TRUE.
C                                       Plot this one
            ELSE
C                                       Find model value
               X = ISL
               IF ((OP.EQ.'MODL') .OR. (OP.EQ.'RESI') .OR.
     *            (OP.EQ.'GUES')) THEN
C                                       Add up all components
                  Y = 0.0
                  DO 40 IC = 1,NGAUSS
                     J = 3 * IC - 2
                     Y = Y + PARM(J) * EXP (-2.772 * (PARM(J+1) - X)**2
     *                  / (PARM(J+2) * PARM(J+2)))
 40                  CONTINUE
                  Y = Y + BASLIN(1) + (X - XCEN) * BASLIN(2) +
     *               (X - XCEN) * (X - XCEN) * BASLIN(3)
                  IF (OP.EQ.'RESI') Y = YSLICE - Y
               ELSE
                  Y = YSLICE
                  END IF
C                                       scale
               Y = SCALEF * Y + OFFSET
               Y = MIN (Y, RANGE2(2))
               Y = MAX (Y, RANGE2(1))
               INP = 2
               IF (BLAST) INP = 1
               CALL TVVEC (X, Y, INP, IERR)
               IF (IERR.NE.0) GO TO 950
               BLAST = .FALSE.
               END IF
 50         CONTINUE
C                                       components only (ignore data)
      ELSE
         DO 80 IC = 1,NGAUSS
            J = 3 * IC - 2
            BLAST = .TRUE.
            DO 70 ISL = ISTART,IEND
               X = ISL
               Y  = 2.772 * (PARM(J+1) - X)**2 / (PARM(J+2) * PARM(J+2))
               IF (Y.GT.12) THEN
                  BLAST = .TRUE.
               ELSE
                  Y = PARM(J) * EXP (-Y)
C                                       scale
                  Y = SCALEF * Y + OFFSET
                  Y = MIN (Y, RANGE2(2))
                  Y = MAX (Y, RANGE2(1))
                  INP = 2
                  IF (BLAST) INP = 1
                  CALL TVVEC (X, Y, INP, IERR)
                  IF (IERR.NE.0) GO TO 950
                  BLAST = .FALSE.
                  END IF
 70            CONTINUE
 80         CONTINUE
         BLAST = .TRUE.
         IF ((BASLIN(1).NE.0.0) .OR. (BASLIN(2).NE.0.0) .OR.
     *      (BASLIN(3).NE.0.0)) THEN
            DO 90 ISL = ISTART,IEND
               X = ISL
               Y = X - XCEN
               Y = BASLIN(1) + Y * BASLIN(2) + Y * y * BASLIN(3)
C                                       scale
               Y = SCALEF * Y + OFFSET
               Y = MIN (Y, RANGE2(2))
               Y = MAX (Y, RANGE2(1))
               INP = 2
               IF (BLAST) INP = 1
               CALL TVVEC (X, Y, INP, IERR)
               IF (IERR.NE.0) GO TO 950
               BLAST = .FALSE.
 90            CONTINUE
            END IF
         END IF
      GO TO 999
C                                       Slice read error.
 930  WRITE (MSGTXT,1930) IERR
      CALL MSGWRT (6)
      IERR = 1
      GO TO 999
C                                       TV write error.
 950  WRITE (MSGTXT,1950) IERR
      CALL MSGWRT (7)
      IERR = 2
      GO TO 999
C                                       Parameter error
 960  WRITE (MSGTXT,1960) I, IERR
      IF (IERR.EQ.0) WRITE (MSGTXT,1961) I
      CALL MSGWRT (7)
      IERR = 3
C
 999  RETURN
C-----------------------------------------------------------------------
 1930 FORMAT ('SLICE FILE READ ERROR',I5)
 1950 FORMAT ('TV WRITE ERROR',I5)
 1960 FORMAT ('ERROR',I3,' CONVERTING COMPONENT',I3,' TO PIXEL COORDS')
 1961 FORMAT ('ZERO HALF WIDTH IN COMPONENT ',I2,'. STOPPING.')
      END

      SUBROUTINE ZTPMIO (OPER, LUN, FIND, NBYTES, BUFF, IBUFF, IERR)
C-----------------------------------------------------------------------
C! read/write tape devices with quick return IO methods
C# Z Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2001, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Low level sequential access, large record, double buffered tape
C   device I/O.
C   Inputs:
C      OPER     C*4    Operation code 'READ' or 'WRIT'
C      LUN      I      Logical unit number == 129 - DriveNumber
C                         if real tapes, other if disk
C      FIND     I      Index in FTAB to file control block for LUN
C      NBYTES   I      Number of 8-bit bytes to transfer
C      BUFF     I(*)   I/O buffer
C      IBUFF    I      Buffer number to use (1 or 2)
C   Output:
C      IERR     I      Error return code: 0 => no error
C                         1 => file not open
C                         2 => input error
C                         3 => I/O error
C                         4 => end of file (no messages)
C   Generic UNIX version - different call seq to ZTPMID
C-----------------------------------------------------------------------
      CHARACTER OPER*4
      INTEGER   LUN, FIND, NBYTES, BUFF(*), IBUFF, IERR
C
      INTEGER   FCBOFF, IEREOF
      LOGICAL   TAPE, T
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA T /.TRUE./
      DATA IEREOF /4/
C-----------------------------------------------------------------------
C                                       Check inputs.
      TAPE = (LUN.LT.129) .AND. (LUN.GE.129-NTAPED)
      IERR = 2
C                                       Valid opcode?
      IF ((OPER.EQ.'READ') .OR. (OPER.EQ.'WRIT')) GO TO 10
         WRITE (MSGTXT,1000) OPER
         GO TO 995
C                                       Valid # bytes requested?
 10   IF ((NBYTES.GE.0) .AND. (NBYTES.LT.32768)) GO TO 30
         WRITE (MSGTXT,1020) NBYTES
         GO TO 995
C                                       Proper device type?
 30   IF ((TAPE) .AND. (DEVTAB(LUN).EQ.2)) GO TO 40
      IF ((.NOT.TAPE) .AND. (DEVTAB(LUN).EQ.0)) GO TO 40
         WRITE (MSGTXT,1030) LUN, DEVTAB(LUN)
         GO TO 995
C                                       Proper buffer # specified?
 40   IF ((IBUFF.EQ.1) .OR. (IBUFF.EQ.2)) GO TO 50
         WRITE (MSGTXT,1040) IBUFF
         GO TO 995
C                                       File open in FTAB?
 50   IF (FTAB(FIND).EQ.LUN) GO TO 60
         IERR = 1
         WRITE (MSGTXT,1050) LUN
         GO TO 995
C                                       Calculate FTAB offset to file
C                                       control block for buffer #.
 60   FCBOFF = FIND + MOFF + (IBUFF - 1) * MFCB
C                                       Real tape devices
      IF (TAPE) THEN
C                                       Remote tapes
         IF (TPNAME(129-LUN).NE.'LOCAL') THEN
            CALL ZTPMIR (OPER, LUN, FIND, NBYTES, BUFF, IBUFF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1060) OPER, LUN, IERR, 'REMOTE'
               CALL MSGWRT (7)
               END IF
C                                       Local tapes
         ELSE
            CALL ZTPMI2 (OPER, FTAB(FCBOFF), BUFF, NBYTES, IERR)
C                                       Check for good start of I/O.
            IF ((IERR.NE.0) .AND. (IERR.NE.IEREOF)) THEN
               WRITE (MSGTXT,1060) OPER, LUN, NBYTES, 'TAPE'
               CALL MSGWRT (7)
               CALL ZERROR ('ZTPMI2', FTAB(FCBOFF+FCBERR), ' ',
     *            FTAB(FCBOFF), T)
               END IF
            END IF
C                                       Pseudo-tape disk files
      ELSE
C                                       Remote
         IF (TPDNAM.NE.'LOCAL') THEN
            CALL ZTPMIR (OPER, LUN, FIND, NBYTES, BUFF, IBUFF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1060) OPER, LUN, IERR, 'REMOTE'
               CALL MSGWRT (7)
               END IF
C                                       Local
         ELSE
C                                       FTAB(FIND+5) = blkno
            CALL ZTPMID (OPER, FTAB(FIND+5), FTAB(FCBOFF), BUFF, NBYTES,
     *         IERR)
C                                       Check for good start of I/O.
            IF ((IERR.NE.0) .AND. (IERR.NE.IEREOF)) THEN
               WRITE (MSGTXT,1060) OPER, LUN, NBYTES, 'DISK'
               CALL MSGWRT (7)
               CALL ZERROR ('ZTPMID', FTAB(FCBOFF+FCBERR), ' ',
     *            FTAB(FCBOFF), T)
               END IF
            END IF
         END IF
      IF (IERR.EQ.3) THEN
         MSGTXT = 'This usually means PARITY ERROR'
      ELSE IF (IERR.EQ.5) THEN
         MSGTXT = 'This usually means unexpected BEGINNING-OF-TAPE'
      ELSE IF (IERR.EQ.6) THEN
         MSGTXT = 'This usually means you''re at END-OF-TAPE'
      ELSE
         GO TO 999
         END IF
C                                       Error
 995  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZTPMIO: INVALID OPERATION = ',A4)
 1020 FORMAT ('ZTPMIO: INVALID BYTE REQUEST = ',I6)
 1030 FORMAT ('ZTPMIO: IMPROPER DEVICE TYPE DEVTAB(',I3,') = ',I1,
     *   'FOR TAPE I/O')
 1040 FORMAT ('ZTPMIO: INVALID BUFFER NUMBER = ',I2)
 1050 FORMAT ('ZTPMIO: LUN = ',I3,' NOT OPEN IN FTAB')
 1060 FORMAT ('ZTPMIO: OPER = ',A4,' LUN = ',I3,' NBYTES = ',I6,' TO ',
     *   A)
      END

      PROGRAM ADDIF
C-----------------------------------------------------------------------
C! Task to add an IF axis to the header of a uv-file.
C# Catalogue Header UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ADDIF modifies the catalog header of a uv-data base by adding
C   an IF axis, this can be missing from 'old' data and is needed
C   when DBCONing such data to 'new' or AIPS calibrated data.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  SEQIN, DISKIN, JBUFSZ, IRET
      HOLLERITH XNAMEI(3), XCLAIN(2)
      CHARACTER NAMEIN*12, CLAIN*6
      REAL      XSIN, XDISIN, BUFF1(1600)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /BUFRS/ BUFF1, JBUFSZ
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN,
     *   SEQIN, DISKIN
      COMMON /CHPARM/ NAMEIN, CLAIN
C
      DATA PRGM /'ADDIF '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       insert IF in header
      CALL ADIFIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE ADIFIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   ADIFIN gets input parameters for ADDIF.
C   Inputs:  PRGN    C*6)      Program name (2 chars/word)
C   Output:  JERR    I         Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C
C-----------------------------------------------------------------------
      CHARACTER  NAMEIN*12, CLAIN*6, STAT*4, PRGN*6, UTYPE*2
      HOLLERITH  XNAMEI(3), XCLAIN(2)
      INTEGER  JERR
      INTEGER   OLDCNO, SEQIN, DISKIN, JBUFSZ, IROUND, NPARM, IERR
      REAL      XSIN, XDISIN, BUFF1(1600)
      LOGICAL   T, F
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /BUFRS/ BUFF1, JBUFSZ
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, SEQIN, DISKIN
      COMMON /CHPARM/ NAMEIN, CLAIN
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      TSKNAM = ' '
      CALL ZDCHIN (.TRUE., BUFF1)
      CALL VHDRIN
      JBUFSZ = 3200
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 7
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.EQ.0) GO TO 10
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
C                                       Restart AIPS
 10   IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
 20   SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
C                                       Get CATBLK from old file.
 30   OLDCNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.EQ.0) GO TO 40
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
 40   CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.EQ.0) GO TO 50
         WRITE (MSGTXT,1040) IERR
         GO TO 990
C                                       Get uv header info.
 50   CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Add IF axis to catblk
      CALL CADDIF (CATBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        Put input file in WRIT
      UTYPE = 'UV'
      STAT = 'WRIT'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKIN, FCNO(NCFILE), CATBLK, 'REST', BUFF1,
     *   IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ADIFIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('ADIFIN: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE CADDIF (IDUM, IERR)
C-----------------------------------------------------------------------
C Routine to add an IF axis to the catblk header
C-----------------------------------------------------------------------
      CHARACTER TYPES(7)*8
      INTEGER   I, INDEX, INC, IERR, NAXIS, IDUM(1)
      LOGICAL   EXIST
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      CALL COPY (256, IDUM, CATBLK)
      EXIST = .FALSE.
      IERR = 0
      NAXIS = CATBLK(KIDIM)
C                                       Obtain random axes names
C                                       & check if IF already there
      INC = 2
      DO 10 I = 1, NAXIS
         INDEX = KHCTP + (I-1) * INC
         CALL H2CHR (8, 1, CATH(INDEX), TYPES(I))
         IF (TYPES(I).EQ.'IF      ') EXIST = .TRUE.
 10      CONTINUE
C                                       Does it exist?
      IF (EXIST) THEN
         WRITE (MSGTXT,1000)
         IERR = 1
         GO TO 990
         END IF
C                                       Create IF axis
      I = NAXIS + 1
      CATBLK (KINAX+I-1) = 1
      CATR(KRCIC+I-1) = 1.0
      CATR(KRCRT+I-1) = 0.0
      CATR(KRCRP+I-1) = 1.0
      CATD(KDCRV+I-1) = 1.0D0
      INDEX = KHCTP + (I-1) * INC
      CALL CHR2H (8, 'IF      ', 1, CATH(INDEX))
      CATBLK(KIDIM) = NAXIS + 1
      CALL COPY (256, CATBLK, IDUM)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('IF AXIS ALREADY EXISTS - THIS OPERATION IS POINTLESS')
C-----------------------------------------------------------------------
      END

      SUBROUTINE TABCG (OPCODE, CGBUFF, ICGRNO, CGKOLS, CGNUMV, FREQ,
     *   BMAJ, BMIN, BPA, IERR)
C----------------------------------------------------------------------
C! I/O to Clean beam info table (following init. by CGINI)
C# EXT-appl
C----------------------------------------------------------------------
C;  Copyright (C) 2010, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C----------------------------------------------------------------------
C   Does I/O to a Clean beam table.  Used after setup by CGINI.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                           'READ' = read entry from table
C                           'WRIT' = write entry in table
C                           'CLOS' = close file, flush on write
C      CGBUFF   I(512)   I/O buffer and related storage, also defines
C                        file if open. Returned by CGINI.
C   Input/Output:
C      ICGRNO   I        Next row to read or write
C      CGKOLS   I(4)     The column pointer array in order:
C                           FREQ, BMAJ, BMIN, BPA
C      CGNUMV   I(4)     Element count in each column.
C      FREQ     D        Frequency (Hz)
C      BMAJ     R        Clean beam major axis (deg)
C      BMIN     R        Clean beam minor axis (deg)
C      BPA      R        Clean beam position angle (deg)
C   Output:
C      IERR     I        Return code (0=>ok; else error)
C                           Note: -1 => read okay but row flagged
C----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   CGBUFF(512), ICGRNO, CGKOLS(4), CGNUMV(4), IERR
      DOUBLE PRECISION FREQ
      REAL      BMAJ, BMIN, BPA
C
      DOUBLE PRECISION RECD(3)
      REAL      RECR(5)
      INTEGER   RECI(5)

      EQUIVALENCE (RECD, RECR, RECI)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C----------------------------------------------------------------------
C                                       Initialization
      IERR = 0
C                                       Close
      IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, ICGRNO, RECI, CGBUFF, IERR)
         IF (IERR.GT.0) CALL TABERR ('CLOS', 'TABIO', 'TABCG', IERR)
C                                       Do I/O
      ELSE
C                                       If write fill RECORD
         IF (OPCODE.NE.'READ') THEN
C                                       Frequency
            IF ((CGKOLS(1).GT.0) .AND. (CGNUMV(1).GT.0))
     *         RECD(CGKOLS(1)) = FREQ
C                                       Major axis
            IF ((CGKOLS(2).GT.0) .AND. (CGNUMV(2).GT.0))
     *         RECR(CGKOLS(2)) = BMAJ
C                                       Minor axis
            IF ((CGKOLS(3).GT.0) .AND. (CGNUMV(3).GT.0))
     *         RECR(CGKOLS(3)) = BMIN
C                                       Position angle
            IF ((CGKOLS(4).GT.0) .AND. (CGNUMV(4).GT.0))
     *         RECR(CGKOLS(4)) = BPA
            END IF
C                                       Process record
         CALL TABIO (OPCODE, 0, ICGRNO, RECI, CGBUFF, IERR)
         ICGRNO = ICGRNO + 1
         IF (IERR.GT.0) THEN
            CALL TABERR (OPCODE, 'TABIO', 'TABCG', IERR)
            GO TO 999
C                                       If READ pick data from record
         ELSE IF (OPCODE.EQ.'READ') THEN
C                                       Time
            FREQ = 0.0D0
            IF ((CGKOLS(1).GT.0) .AND. (CGNUMV(1).GT.0)) THEN
               FREQ = RECD(CGKOLS(1))
            ELSE
               FREQ = DBLANK
               END IF
C                                       Major axis
            IF ((CGKOLS(2).GT.0) .AND. (CGNUMV(2).GT.0)) THEN
               BMAJ = RECR(CGKOLS(2))
            ELSE
               BMAJ = FBLANK
               END IF
C                                       Minor axis
            IF ((CGKOLS(3).GT.0) .AND. (CGNUMV(3).GT.0)) THEN
               BMIN = RECR(CGKOLS(3))
            ELSE
               BMIN = FBLANK
               END IF
C                                       Position angle
            IF ((CGKOLS(4).GT.0) .AND. (CGNUMV(4).GT.0)) THEN
               BPA = RECR(CGKOLS(4))
            ELSE
               BPA = FBLANK
               END IF
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE UVTIME (IVOL, ISLOT, CATBLK, TSTART, TSTOP, IERR)
C-----------------------------------------------------------------------
C! Find the start and stop times of a TB-sorted uv data set.
C# UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2003, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Input:
C      IVOL     I        Volume number on which data resides
C      ISLOT    I        Catalogue number of data
C      CATBLK   I(256)   Catalogue header
C   Output:
C      TSTART   R        Start time (days)
C      TSTOP    R        Stop time in days
C      IERR     I        Return code, 0=>OK, otherwise INDEX file
C                        exists but cannot be read.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      REAL      TSTART, TSTOP
      INTEGER   IVOL, ISLOT, CATBLK(256), IERR
      LOGICAL   NXEXST
C
      INTEGER   JERR, NXIDSO, NXSUBA, NIO, IUBIND, NXSTA, IULUN,
     *   NXEND, NREAD, BO, FRSRED, FREQID, INXRNO, FSTVIS, LSTVIS,
     *   IXLUN, NXBUFF(1024), NXKOLS(MAXNXC), NXNUMV(MAXNXC), NINDEX,
     *   UBUFSZ, IUFIND, LRECIN, CATTMP(256)
      LOGICAL   T, F, TABLE, EXIST, FITASC
      REAL      NXTIME, NXDTIM, UBUFF(UVBFSS)
      CHARACTER UFILE*48, CSORT*2
      HOLLERITH CATH(256)
      SAVE UBUFF
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATTMP, CATH)
      DATA T, F /.TRUE.,.FALSE./
      DATA BO /1/
C-----------------------------------------------------------------------
      NXEXST = F
      UBUFSZ = UVBFSS * 2
      CALL COPY (256, CATBLK, CATTMP)
C                                       Initialize output
      INXRNO = -1
      FSTVIS = 1
      LSTVIS = CATBLK(KIGCN)
      IXLUN = 30
C                                       See if NX file exists.
      CALL ISTAB ('NX', IVOL, ISLOT, 1, IXLUN, NXBUFF, TABLE, EXIST,
     *   FITASC, JERR)
      IF ((JERR.NE.0) .OR. (.NOT.TABLE) .OR. (.NOT.EXIST)) GO TO 300
C                                       Open NX table
      CALL NDXINI ('READ', NXBUFF, IVOL, ISLOT, 1, CATBLK, IXLUN,
     *   INXRNO, NXKOLS, NXNUMV, JERR)
      IF (JERR.GT.0) THEN
         IERR = 1
         WRITE (MSGTXT,1000) JERR
         GO TO 990
         END IF
C                                       Get number of scans
      NINDEX = NXBUFF(5)
C                                       Check if empty
      IF (NINDEX.LE.0) GO TO 300
C                                       Locate first selected scan.
      NXEXST = T
      INXRNO = 1
      IERR = 1
      CALL TABNDX ('READ', NXBUFF, INXRNO, NXKOLS, NXNUMV,
     *   NXTIME, NXDTIM, NXIDSO, NXSUBA, NXSTA, NXEND, FREQID,
     *   IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
      IERR = 0
C                                       Return start time
      TSTART = NXTIME - 0.5 * NXDTIM
C                                       Get last included one
      INXRNO = NINDEX
      IERR = 1
      CALL TABNDX ('READ', NXBUFF, INXRNO, NXKOLS, NXNUMV,
     *   NXTIME, NXDTIM, NXIDSO, NXSUBA, NXSTA, NXEND, FREQID,
     *   IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
      IERR = 0
C
      TSTOP = NXTIME + 0.5 * NXDTIM
      CALL TABIO ('CLOS', 0, INXRNO, UBUFF, NXBUFF, IERR)
      GO TO 999
C                                       No INDEX file
C                                       Check sort order
 300  CALL H2CHR (2, 1, CATH(KITYP), CSORT)
      IF (CSORT(1:1).NE.'T') THEN
         IERR = 1
         WRITE (MSGTXT,1080)
         GO TO 990
         END IF
C                                       Open uv file
      IULUN = 45
      CALL ZPHFIL ('UV', IVOL, ISLOT, 1, UFILE, IERR)
      CALL ZOPEN (IULUN, IUFIND, IVOL, UFILE, T, F, T, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1800) 'OPEN', IERR
         GO TO 990
         END IF
C                                       Init I/O to uvfile
      NREAD = 1
      LRECIN = LREC
C                                       Read first vis.
      FRSRED = FSTVIS - 1
      CALL UVINIT ('READ', IULUN, IUFIND, NREAD, FRSRED, LRECIN, 1,
     *   UBUFSZ, UBUFF, BO, IUBIND, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1810) 'INIT FIRST', IERR
         GO TO 990
         END IF
      CALL UVDISK ('READ', IULUN, IUFIND, UBUFF, NIO, IUBIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1810) 'READ FIRST', IERR
         GO TO 990
         END IF
      TSTART = UBUFF(IUBIND+ILOCT)
C                                       Read last vis.
      FRSRED = LSTVIS - 1
      CALL UVINIT ('READ', IULUN, IUFIND, NREAD, FRSRED, LRECIN, 1,
     *   UBUFSZ, UBUFF, BO, IUBIND, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1810) 'INIT LAST', IERR
         GO TO 990
         END IF
      CALL UVDISK ('READ', IULUN, IUFIND, UBUFF, NIO, IUBIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1810) 'READ LAST', IERR
         GO TO 990
         END IF
      TSTOP = UBUFF(IUBIND+ILOCT)
      CALL ZCLOSE (IULUN, IUFIND, JERR)
      GO TO 999
C                                       Errors
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVTIME: ERROR',I3,' OPENING INDEX TABLE')
 1020 FORMAT ('UVTIME: ERROR',I3,' READING INDEX TABLE')
 1080 FORMAT ('The data are not TB sorted. Use UVSRT to sort data')
 1800 FORMAT ('UVTIME: UNABLE TO ',A,' INPUT UV FILE, ERROR',I5)
 1810 FORMAT ('UVTIME: UNABLE TO ',A,' INPUT VISIBILITY RECORD, ERROR',
     *   I5)
      END

      SUBROUTINE YCRCTL (OP, ON, X, Y, LINKX, LINKY, RBLINK, BUTTON,
     *   VRTRTC, IERR)
C-----------------------------------------------------------------------
C! controls the TV cursor visibility, position; reads trackball buttons
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YCRCTL reads/writes the cursor/trackball control register of TV
C   Inputs:
C      OP      C*4   'READ' from TV or 'WRIT' to TV
C      VRTRTC  L     T => do on vertical retrace only
C   In/out:
C      ON      L     T => cursor visible, F => off
C      X       I     X position cursor center (1-512, 1 => LHS)
C      Y       I     Y position cursor center (1-512, 1 => bot)
C      LINKX   L     T => trackball moves cursor in X
C      LINKY   L     T => trackball moves cursor in Y
C      RBLINK  I     rate of cursor blink: 0-3 no-fast blink
C   Output:
C      BUTTON  I     button value (0 - 15)
C      IERR    I     error code of Z...XF : 0 => ok
C                                           2 => input error
C   Version for IIS Model 70
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   X, Y, RBLINK, BUTTON, IERR
      LOGICAL   ON, LINKX, LINKY, VRTRTC
C
      INTEGER   BUFFER(3), HEADER(8), UNIT, BUFSIZ, BITS(16), NB, I
      LOGICAL   COMAND
      INCLUDE 'INCS:DTVC.INC'
      DATA UNIT, COMAND, BUFSIZ /10,.TRUE.,3/
C-----------------------------------------------------------------------
C                                        write: build control word
      IF (OP.EQ.'WRIT') THEN
         IERR = 2
         IF ((X.LT.1) .OR. (X.GT.MAXXTV(1))) GO TO 999
         IF ((Y.LT.1) .OR. (Y.GT.MAXXTV(2))) GO TO 999
         BUFFER(2) = X - 33
         BUFFER(3) = MAXXTV(2) - 32 - Y
         CALL FILL (16, 0, BITS)
         IF (ON    ) BITS(1) = 1
         IF (LINKX ) BITS(2) = 1
         IF (LINKY ) BITS(3) = 1
         I = MAX (0, MIN (3, RBLINK))
         IF (I.NE.0) I = 4 - I
         CALL ZGTBIT (2, I, BITS(4))
         CALL ZPTBIT (16, BUFFER(1), BITS)
         END IF
C                                        header & IO
 10   CALL YMKHDR (OP, UNIT, COMAND, BUFSIZ, 0, 0, 0, 0, VRTRTC, HEADER)
      NB = 2 * BUFSIZ
      CALL ZM70XF (OP, NB, HEADER, BUFFER, IERR)
C                                        return answers
      IF ((IERR.EQ.0) .AND. (OP.NE.'WRIT')) THEN
         CALL ZGTBIT (16, BUFFER(1), BITS)
         ON     = BITS(1).EQ.1
         LINKX  = BITS(2).EQ.1
         LINKY  = BITS(3).EQ.1
         CALL ZPTBIT (4, BUTTON, BITS(9))
         CALL ZPTBIT (2, RBLINK, BITS(4))
         IF (RBLINK.NE.0) RBLINK = 4 - RBLINK
C                                        use button pushed bit to
C                                        prevent double hits
         IF (BITS(15).NE.1) BUTTON = 0
C         IF (BUFFER(2).GE.2048) BUFFER(2) = BUFFER(2) - 4096
         IF (BUFFER(3).GE.2048) BUFFER(3) = BUFFER(3) - 4096
         BUFFER(2) = MOD (BUFFER(2), 512)
         BUFFER(3) = MOD (BUFFER(3), 512)
         X = BUFFER(2) + 32
         X = MOD (X, MAXXTV(1)) + 1
         Y = 3*MAXXTV(2) - BUFFER(3) - 33
         Y = MOD (Y, MAXXTV(2)) + 1
         END IF
C
 999  RETURN
      END

      SUBROUTINE ALSPUT (ALIST, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C! Store value to Associative list (ALIST)
C# Utility 
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Public
C   Save an entry in an object creating it if necessary.
C   Recognizes special keyword 'LISTNAME' as the name of the ALIST.
C   See ALSINI for details of the package.
C   Note the AIPS datatypes are defined as parameters in the INCLUDE
C   'INCS:PAOOF.INC': OOADP = double precision, OOARE = real, 
C   OOACAR = character, OOAINT = integer, and OOALOG = logical.
C   Inputs:
C      ALIST  I(*)  ALIST array
C      KEYWRD  C*16  Keyword
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of value, an axis dimension of zero
C                    means that that dimension and higher are undefined.
C      VALUE   ?     Associated value (non character)
C      VALUEC  C(*)*? Associated value (character)
C   Outputs:
C      IERR    I     Error code, 0=OK.
C-----------------------------------------------------------------------
      INTEGER   ALIST(*), TYPE, DIM(*), VALUE(*), IERR
      CHARACTER KEYWRD*(*), VALUEC(*)*(*)
C
      INTEGER   NVAL, KEYPNT, IDIM(100), NDIM, DATOFF, LHEAD, I
      CHARACTER ALNAME*32
      INCLUDE 'INCS:PALIST.INC'
C-----------------------------------------------------------------------
      IERR = 0
      NDIM = ALIST(ALSNDM)
      DATOFF = ALIST(ALSDAT)
      LHEAD = ALIST(ALSHED)
C                                       Validity test
      IF (ALIST(ALSCHK).NE.ALSCVL) THEN
         MSGTXT = 'ALSPUT: DAMAGED OR UNINITIALIZED ALIST'
         IERR = 6
         GO TO 990
         END IF
C                                       Special trap for ALIST name
      IF (KEYWRD(1:8).EQ.'LISTNAME') THEN
         CALL CHR2H (32, VALUEC, 1, ALIST(ALSNAM))
         GO TO 999
         END IF
C                                       Size of value
      NVAL = 1
      DO 20 I = 1,NDIM
         IDIM(I) = MAX (1, DIM(I))
         NVAL = NVAL * IDIM(I)
 20      CONTINUE
C                                       DP may be longer
      IF (TYPE.EQ.1) NVAL = NVAL * NWDPDP
C                                       See if it's there?
      CALL ALSKEY (ALIST, KEYWRD, KEYPNT, IERR)
C                                       Does it currently exist?
      IF (IERR.EQ.0) THEN
C                                       Update existing entry.
C                                       Check type
         IF (TYPE.NE.ALIST(KEYPNT+ALSTYP)) THEN
            IERR = 1
            MSGTXT = 'WRONG KEYWORD DATA TYPE'
            GO TO 990
            END IF
C                                       Check dimensions
         DO 40 I = 1,NDIM
            IF (IDIM(I).NE.ALIST(KEYPNT+ALSDIM+I-1)) THEN
               IERR = 1
               MSGTXT = 'WRONG KEYWORD VALUE DIMENSIONALITY'
               GO TO 990
               END IF
 40         CONTINUE
C                                       Character
         IF (TYPE.EQ.3) THEN
            CALL ALSC2H (VALUEC, NDIM, IDIM, ALIST(KEYPNT+DATOFF))
C                                       Other
         ELSE
            CALL COPY (NVAL, VALUE, ALIST(KEYPNT+DATOFF))
            END IF
      ELSE
         IERR = 0
C                                       Add new keyword.
C                                       Check if there's room
         IF ((ALIST(ALSEND)+NVAL+LHEAD) .GT. ALIST(ALSIZE)) THEN
            IERR = 3
            MSGTXT = 'ALIST TOO SMALL TO ALLOCATE NEW KEYWORD'
            GO TO 990
            END IF
C                                       Pointer to next free word
         KEYPNT = ALIST(ALSEND)
         ALIST(ALSEND) = KEYPNT + LHEAD + NVAL
C                                       New list termination
         ALIST(ALIST(ALSEND)) = -1
C                                       Add Keyword
         CALL CHR2H (16, KEYWRD, 1, ALIST(KEYPNT+ALSKWD))
C                                       Pointer to next cell
         ALIST(KEYPNT+ALSNXT) = ALIST(ALSEND)
C                                       Type
         ALIST(KEYPNT+ALSTYP) = TYPE
C                                       Dimensions
         CALL COPY (NDIM, IDIM, ALIST(KEYPNT+ALSDIM))
C                                       Character
         IF (TYPE.EQ.3) THEN
            CALL ALSC2H (VALUEC, NDIM, IDIM, ALIST(KEYPNT+DATOFF))
C                                       Other
         ELSE
            CALL COPY (NVAL, VALUE, ALIST(KEYPNT+DATOFF))
            END IF
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
      MSGTXT = 'KEYWORD =' // KEYWRD
      CALL MSGWRT (6)
      CALL H2CHR (32, 1, ALIST(ALSNAM), ALNAME)
      MSGTXT = 'PROBLEM WITH ALIST: ' // ALNAME
      CALL MSGWRT (6)
C
 999  RETURN
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER NPARMS
      PARAMETER (NPARMS=18)
      INTEGER AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
      INCLUDE 'INCS:PAOOF.INC'
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
     *   'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK',
     *   'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK',
     *   'BLC', 'TRC', 'IMSIZE', 'REWEIGHT', 'AXREF', 'APARM'/
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT,
     *   OOACAR, OOACAR, OOAINT, OOAINT,
     *   OOACAR, OOACAR, OOAINT, OOAINT,
     *   OOAINT, OOAINT, OOAINT, OOARE, OOARE, OOARE/
      DATA AVDIM /12,1, 6,1, 1,1, 1,1,
     *   12,1, 6,1, 1,1, 1,1,
     *   12,1, 6,1, 1,1, 1,1,
     *   7,1, 7,1, 2,1, 2,1, 2,1, 10,1/
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(14)
      LOGICAL   LDUM(14)
      REAL      RDUM(14)
      DOUBLE PRECISION DDUM(7)
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
      COMMON /OHGEOG/ DDUM
LOCAL END
      PROGRAM OHGEO
C-----------------------------------------------------------------------
C! Geometric interpolation with correction for 3-D effects
C# Task MAP-UTIL OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2000, 2010, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, IN*32, OUT*32
      INTEGER  IRET, BUFF1(256), HWIDTH, NAXIS(7)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'OHGEO '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL OHGEIN (PRGM, IN, OUT, HWIDTH, NAXIS, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Interpolate
      CALL IMGHGE (IN, HWIDTH, 1, NAXIS(1), OUT, IRET)
      IF (IRET.NE.0) GO TO 990
      CALL BEMCOP (IN, OUT, IRET)
      IRET = 0
C                                       History
      CALL OHGEHI (IN, OUT)
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE OHGEIN (PRGN, IN, OUT, HWIDTH, NAXIS, IRET)
C-----------------------------------------------------------------------
C   OHGEIN gets input parameters for OHGEO and creates the output.
C   Inputs:
C      PRGN     C*6    Program name
C   Output:
C      IN       C*?    Input object
C      OUT      C*?    Output object
C      HWIDTH   I      Interpolation kernel half width.
C      NAXIS    I(7)   Output image size
C      IRET     I      Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   HWIDTH, NAXIS(7), IRET
      CHARACTER PRGN*6, IN*(*), OUT*(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NKEY1, NKEY2
C                                       NKEY1=no. adverbs for inname
      PARAMETER (NKEY1=6)
C                                       NKEY2 = no. adverb for in2name
      PARAMETER (NKEY2=4)
      INTEGER   DIM(7), TYPE, DISK, SEQ, BLC(7), TRC(7), IMSIZE(2),
     *   MSGSAV, NAXIS2(7), IROUND, IDISK, ODISK, ICNO, OCNO, ICX, ICY
      LOGICAL   DO3D, SECOND
      REAL      APARM(10), PA, ZA, CRPIX(7), CRPIX2(7), C123(4),
     *   REWT(2), CROTA(7), CROTA2(7), CDELT(7), CDELT2(7), AXREF(2),
     *   PIX(7), PIX2(7)
      DOUBLE PRECISION OBSRA, OBSDEC, CRVAL(7), CRVAL2(7)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32, IN2*32, NAME*12, CLASS*6, INAME*12,
     *   CNAME*8, KEYW*8, CDUMMY*1, CTYPE(7)*8, CTYPE2(7)*8
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
      INCLUDE 'GFORT'
C                                       Adverbs for IN
C                    1          2        3        4        5      6
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'BLC', 'TRC'/
C                                       Rename
C                    1       2       3        4       5      6
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'BLC', 'TRC'/
C                                       Adverbs for in2name
C                    1          2          3          4
      DATA INK2 /'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK'/
C                                       Rename
C                   1       2         3       4
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Declare 'PARANGLE' a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'PARANGLE'
      CALL OBVHKW (CNAME, KEYW, OOARE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Declare 'ZENANGLE' a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'ZENANGLE'
      CALL OBVHKW (CNAME, KEYW, OOARE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create IN
      IN = 'Input image object'
      CALL CREATE (IN, 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, IN, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Open and close to check
      CALL OOPEN (IN, 'READ', IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OCLOSE (IN, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Control parameters
      CALL OGET ('Input', 'APARM', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, APARM)
      CALL OGET ('Input', 'REWEIGHT', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, REWT)
C                                       Interpolation kernel half width.
      HWIDTH = IROUND (REWT(1))
      HWIDTH = MIN (4, MAX (1, HWIDTH))
      REWT(1) = HWIDTH
      IF ((REWT(2).LE.0.0) .OR. (REWT(2).GE.1.0)) REWT(2) = 0.3334
      CALL RCOPY (DIM(1), REWT, RDUM)
      CALL OPUT ('Input', 'REWEIGHT', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 1
      DIM(2) = 1
      RDUM(1) = REWT(2)
      CALL OPUT (IN, 'RELIABLE', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       3-D corrections?
      DO3D = APARM(1).GT.0.0
      IF (DO3D) THEN
         DIM(1) = 1
         DIM(2) = 1
         LDUM(1) = DO3D
         CALL OPUT (IN, 'DO3DCOR', OOALOG, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         MSGSAV = MSGSUP
C                                       Parallactic angle
         MSGSUP = 32000
         CALL OGET (IN, 'PARANGLE', TYPE, DIM, IDUM, CDUMMY, IRET)
         PA = RDUM(1)
         MSGSUP = MSGSAV
C                                       Use input
         IF (IRET.NE.0) THEN
            RDUM(1) = APARM(2)
            CALL OPUT (IN, 'PARANGLE', OOARE, DIM, IDUM, CDUMMY,
     *         IRET)
            END IF
         IF (IRET.NE.0) GO TO 999
C                                       Zenith angle
         MSGSUP = 32000
         CALL OGET (IN, 'ZENANGLE', TYPE, DIM, IDUM, CDUMMY, IRET)
         ZA = RDUM(1)
         MSGSUP = MSGSAV
C                                       Use input
         IF (IRET.EQ.1) THEN
            RDUM(1) = APARM(3)
            CALL OPUT (IN, 'ZENANGLE', OOARE, DIM, IDUM, CDUMMY,
     *         IRET)
            END IF
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Radial scaling
      DIM(1) = 1
      DIM(2) = 1
      RDUM(1) = APARM(4)
      CALL OPUT (IN, 'PBFWHM', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Linear scaling
      IF (APARM(9).LE.0.0) APARM(9) = 1.0
      C123(1) = APARM(9)
C                                       Radial scaling?
      IF (APARM(4).GT.0.0) THEN
         CALL RCOPY (3, APARM(6), C123(2))
      ELSE
         CALL RFILL (3, 0.0, C123(2))
         APARM(5) = 0.0
         CALL RFILL (3, 0.0, APARM(6))
         END IF
      DIM(1) = 1
      RDUM(1) = APARM(5) * APARM(5)
      CALL OPUT (IN, 'FBWSQ', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 4
      CALL RCOPY (4, C123, RDUM)
      CALL OPUT (IN, 'C123', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Save APARM for history
      DIM(1) = 10
      CALL RCOPY (10, APARM, RDUM)
      CALL OPUT ('Input', 'APARM', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       IN2
      IN2 = 'Image to emulate'
      CALL CREATE (IN2, 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, IN2, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Open and close to check
      CALL OOPEN (IN2, 'READ', IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OCLOSE (IN2, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Clone output from IN2
      OUT = 'Output interpolated image'
      CALL CREATE (OUT, 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy array descriptors
C                                       ERROR ?
      CALL ARDCOP (IN, OUT, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Set names
      CALL OGET (IN, 'NAME', TYPE, DIM, IDUM, INAME, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'OUTNAME', TYPE, DIM, IDUM, NAME, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'OUTCLASS', TYPE, DIM, IDUM, CLASS, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'OUTSEQ', TYPE, DIM, IDUM, CDUMMY, IRET)
      SEQ = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'OUTDISK', TYPE, DIM, IDUM, CDUMMY, IRET)
      DISK = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      IF (NAME.EQ.'    ') NAME = INAME
      IF (CLASS.EQ.'    ') CLASS = PRGN
      DIM(1) = LEN (NAME)
      CALL OPUT (OUT, 'NAME', OOACAR, DIM, IDUM, NAME, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = LEN (CLASS)
      CALL OPUT (OUT, 'CLASS', OOACAR, DIM, IDUM, CLASS, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 1
      IDUM(1) = SEQ
      CALL OPUT (OUT, 'IMSEQ', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = DISK
      CALL OPUT (OUT, 'DISK', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Size
      CALL OGET ('Input', 'IMSIZE', TYPE, DIM, IMSIZE, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'AXREF', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, AXREF)
      SECOND = (IMSIZE(1).EQ.0) .AND. (IMSIZE(2).EQ.0) .AND.
     *   (AXREF(1).EQ.0) .AND. (AXREF(2).EQ.0)
C                                       Input subimage dimension
      CALL ARRWIN (IN, BLC, TRC, NAXIS, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Reference image size
      CALL OGET (IN2, 'ARRAY.ARRAY_DESC.NAXIS', TYPE, DIM, NAXIS2,
     *   CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Output image size
      IF (IMSIZE(1).LE.0) IMSIZE(1) = NAXIS2(1)
      IF (IMSIZE(2).LE.0) IMSIZE(2) = NAXIS2(2)
      NAXIS(1) = IMSIZE(1)
      NAXIS(2) = IMSIZE(2)
      DIM(1) = 7
      CALL OPUT (OUT, 'ARRAY.ARRAY_DESC.NAXIS', OOAINT, DIM, NAXIS,
     *   CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Reference pixel
      CALL OGET (IN, 'IMAGE_DESC.CRPIX', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, CRPIX)
      CALL OGET (IN2, 'IMAGE_DESC.CRPIX', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, CRPIX2)
      IF (SECOND) THEN
         AXREF(1) = CRPIX2(1)
         AXREF(2) = CRPIX2(2)
         END IF
C                                       Reference value
      CALL OGET (IN, 'IMAGE_DESC.CRVAL', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL DPCOPY (DIM(1), DDUM, CRVAL)
      CALL OGET (IN2, 'IMAGE_DESC.CRVAL', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL DPCOPY (DIM(1), DDUM, CRVAL2)
C                                       Rotation
      CALL OGET (IN, 'IMAGE_DESC.CROTA', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, CROTA)
      CALL OGET (IN2, 'IMAGE_DESC.CROTA', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, CROTA2)
C                                       Increment
      CALL OGET (IN, 'IMAGE_DESC.CDELT', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, CDELT)
      CALL OGET (IN2, 'IMAGE_DESC.CDELT', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, CDELT2)
C                                       Type
      CALL OGET (IN, 'IMAGE_DESC.CTYPE', TYPE, DIM, IDUM, CTYPE, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET (IN2, 'IMAGE_DESC.CTYPE', TYPE, DIM, IDUM, CTYPE2, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Correct other axes for
C                                       subimaging.
      CRPIX(3) = CRPIX(3) - BLC(3) + 1.0
      CRPIX(4) = CRPIX(4) - BLC(4) + 1.0
      CRPIX(5) = CRPIX(5) - BLC(5) + 1.0
      CRPIX(6) = CRPIX(6) - BLC(6) + 1.0
      CRPIX(7) = CRPIX(7) - BLC(7) + 1.0
C                                       Image 2 in first 2 axes
      CTYPE(1) = CTYPE2(1)
      CTYPE(2) = CTYPE2(2)
      CDELT(1) = CDELT2(1)
      CDELT(2) = CDELT2(2)
      CROTA(1) = CROTA2(1)
      CROTA(2) = CROTA2(2)
      CRVAL(1) = CRVAL2(1)
      CRVAL(2) = CRVAL2(2)
C                                       Ref pixel
C                                       Center of subimage
      IF ((AXREF(1).EQ.0.0) .AND. (AXREF(2).EQ.0.0)) THEN
         PIX(1) = (TRC(1) - BLC(1) + 1) / 2 + BLC(1) - 1
         PIX(2) = (TRC(2) - BLC(2) + 1) / 2 + BLC(2)
         PIX(3) = BLC(3)
         PIX(4) = BLC(4)
         PIX(5) = BLC(5)
         PIX(6) = BLC(6)
         PIX(7) = BLC(7)
C                                       Find corresponding pixel in IN2
         CALL PSNCVT (IN, PIX, IN2, PIX2, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Center of image
         ICX = NAXIS(1) / 2
         ICY = NAXIS(2) / 2 + 1
C                                       Shift reference pixel.
         CRPIX(1) = CRPIX2(1) + (ICX - PIX2(1)) - BLC(1) + 1
         CRPIX(2) = CRPIX2(2) + (ICY - PIX2(2)) - BLC(2) + 1
      ELSE
         CRPIX(1) = AXREF(1)
         CRPIX(2) = AXREF(2)
         END IF
C                                       Force full instantiation
      CALL OOPEN (OUT, 'WRIT', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy image descriptors
      CALL IMDCOP (IN, OUT, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy Convolving beam
      CALL BEMCOP (IN, OUT, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy Observing position
      CALL PSNGET (IN, 'OBSRA', TYPE, DIM, IDUM, CDUMMY, IRET)
      OBSRA = DDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL PSNPUT (OUT, 'OBSRA', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL PSNGET (IN, 'OBSDEC', TYPE, DIM, IDUM, CDUMMY, IRET)
      OBSDEC = DDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL PSNPUT (OUT, 'OBSDEC', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Save reference pixel.
      DIM(1) = 7
      CALL DPCOPY (7, CRVAL, DDUM)
      CALL OPUT (OUT, 'IMAGE_DESC.CRVAL', OOADP, DIM, IDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (7, CRPIX, RDUM)
      CALL OPUT (OUT, 'IMAGE_DESC.CRPIX', OOARE, DIM, IDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (7, CDELT, RDUM)
      CALL OPUT (OUT, 'IMAGE_DESC.CDELT', OOARE, DIM, IDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (7, CROTA, RDUM)
      CALL OPUT (OUT, 'IMAGE_DESC.CROTA', OOARE, DIM, IDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 8
      DIM(2) = 7
      CALL OPUT (OUT, 'IMAGE_DESC.CTYPE', OOACAR, DIM, IDUM, CTYPE,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OCLOSE (OUT, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy catalog header keywords.
      CALL OBDSKC (IN, IDISK, ICNO, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OBDSKC (OUT, ODISK, OCNO, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL KEYCOP (IDISK, ICNO, ODISK, OCNO, IRET)
      IF (IRET.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE OHGEHI (IN, OUT)
C-----------------------------------------------------------------------
C   Routine to write history file to output.
C   Inputs:
C      IN      C*?  Input object
C      OUT     C*?  Output object
C-----------------------------------------------------------------------
      CHARACTER IN*(*), OUT*(*)
C
      INTEGER   NADV
      PARAMETER (NADV=13)
      CHARACTER LIST(NADV)*8
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
     *   'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK', 'BLC', 'TRC',
     *   'IMSIZE', 'REWEIGHT', 'APARM'/
C-----------------------------------------------------------------------
C                                        Copy old history
      CALL OHCOPY (IN, OUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                        New additions - copy adverb
C                                        values.
      CALL OHLIST ('Input', LIST, NADV, OUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       copy tables
      CALL IMCALT (IN, OUT, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'ERROR COPYING TABLES'
         CALL MSGWRT (6)
         END IF
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // OUT
      CALL MSGWRT (6)
 999  RETURN
      END

      SUBROUTINE LCOPY (N, LFROM, LTO)
C-----------------------------------------------------------------------
C! copies logical values from one array to another
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   LCOPY transfers N logical values from LFROM to LTO
C   Inputs:
C      N       I      number of words to be copied
C      LFROM   L(N)   input array
C   Outputs:
C      LTO     L(N)   output array
C-----------------------------------------------------------------------
      INTEGER   N
      LOGICAL   LFROM(*), LTO(*)
C
      INTEGER   I
C-----------------------------------------------------------------------
      IF (N.GT.0) THEN
         DO 10 I = 1,N
            LTO(I) = LFROM(I)
 10         CONTINUE
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'TAPLT.INC'
C                                       Include for TAPLT.
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMIN(3), XCLAIN(2), XINEXT(1), XKEYST(4)
      REAL      USERID, XSIN, XDISIN, XVER, BCOUNT, ECOUNT, XINC,
     *   DOHIST, FACTOR, APARM(10), BPARM(10), CPARM(10), XARR(30),
     *   DOINV, XLABEL, XDOTV, XGRCH
      CHARACTER NAMEIN*12, CLAIN*6, INEXT*2, CTVAL*16
      DOUBLE PRECISION  RSUM(2), DEG2R
      REAL      XYSCL(2), XYOFF(2), SUM(400), SUM2(400), RTVAL(7),
     *   ETVAL(7)
      INTEGER   SBUF(256), TABUF(512), NKEY, NCOL, NREC,
     *   RECI(XBPRSZ), IBCNT, IECNT, INC, BINCNT(400), SEQIN, DISKIN,
     *   TALUN, TYPEAX(2,2), EVER, PVER, TESTEM(2), CNO, NPARM, TAIND,
     *   DTYPAX(2,2), ISUBAX(2,2), OPTYPE(2), GRCHN, TVCHN, GR2CHN,
     *   TVCORN(4), LABEL, LROW, NBIN, NTVAL, ITVAL(4,7), DATP(128,2)
      LOGICAL   SCALEM(2), SUMEM(2), TWOOF(2), ABSEM(2,2), DOTV
      COMMON /INPARM/ USERID, XNAMIN, XCLAIN, XSIN, XDISIN, XINEXT,
     *   XVER, BCOUNT, ECOUNT, XINC, DOHIST, FACTOR, APARM, BPARM,
     *   CPARM, XARR, XKEYST, DOINV, XLABEL, XDOTV, XGRCH
      COMMON /CHPARM/ NAMEIN, CLAIN, INEXT, CTVAL
      COMMON /BUFRS/ RSUM, DEG2R, RECI, SBUF, DATP, TABUF, NKEY,
     *   NCOL, NREC, XYSCL, XYOFF, SUM, SUM2, IBCNT, IECNT, INC, BINCNT,
     *   SCALEM, SUMEM, TWOOF, ABSEM, SEQIN, DISKIN, TALUN, TYPEAX,
     *   EVER, PVER, TESTEM, CNO, NPARM, DTYPAX, ISUBAX, TAIND, OPTYPE,
     *   GRCHN, GR2CHN,  TVCHN, TVCORN, DOTV, LABEL, LROW, NBIN, RTVAL,
     *   ETVAL, NTVAL, ITVAL
LOCAL END
       PROGRAM TAPLT
C-----------------------------------------------------------------------
C!  Task plots table extension data.
C#  EXT-util EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2002, 2005, 2007, 2009, 2012, 2014-2015,
C;  Copyright (C) 2019-2020, 2022, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TAPLT plots table extension data . A 'PL' extension file is made
C   which can be displayed in the usual ways.
C   Inputs:
C     USERID                       file owner # ignored
C     INNAME         NAMEIN        Name of main input file
C     INCLASS        CLAIN         Class of main input file
C     INSEQ          SEQIN         Seq. of main input file
C     INDISK         DISKIN        Disk number of main input file.
C     CHANNEL        NCH           Channel #: 0 or 1 ok for cont.
C     INEXT......Type of input table extension.  '  ' = 'CC'
C     INVERS.....Version number of table extension.  0 => highest.
C     BCOUNT.....Beginning row number to be included in plot. 0 = 1.
C     ECOUNT.....Ending row number included in plot.  0 = highest.
C     XINC.......Increment in row number between rows included in
C                plot.    0 => 1.
C     DOHIST.....> 0 => plot as histogram in the X-axis parameter.
C                <= 0 plot two columns against each other.
C     APARM......Column selection parameters:
C        1 = X-axis logical column number A:  0 => row number.
C            < 0 => use absolute value of col. abs(APARM(1))
C        2 = The subscript of the X-axis column A data to use if the
C            column is an array.  0 => 1.
C        3 = X-axis logical column number B:  0 => row number.
C            < 0 => use absolute value of col. abs(APARM(1))
C        4 = The subscript of the X-axis column B data to use if the
C            column is an array.  0 => 1.
C        5 = X-axis function number: Various functions may be
C            performed on column A only or on a pair of columns A
C            and B before plotting.  Functions which use column A
C            only are 0 = no function, 1 = sum, 2 = asin, 3 = Log10,
C            4 = ln, 5 = exp, 6 = sin, 7 = cos, 8 = tan, 9 = atan.
C            In these cases, APARM(3) and (4) are ignored.
C            Functions which use both columns are 10 = +, 11 = -,
C            12 = *, 13 = /, 14 = **, 15 = mod, 16 = Modulus,
C            17 = atan2, 18 = max, 19 = min.
C        6 = Y-axis logical column number A:  as for X-axis.
C        7 = The subscript of the Y-axis column A data to use if the
C            column is an array.  0 => 1.
C        8 = Y-axis logical column number B:  as for X-axis.
C        9 = The subscript of the Y-axis column B data to use if the
C            column is an array.  0 => 1.
C        10 = Y-axis function number: as for X-axis.
C     BPARM......Plot control parameters:
C        1 = If DOHIST > 0, the number of bins in the histogram
C            (0 => 50).  If DOHIST <= 0 and BPARM(1) > 0, the plot
C            will be of bin averages in X of the specified quantity.
C            There will be BPARM(1) number of bins in the plot.  For
C            bins with more than 2 samples the vertical height of
C            the symbol represents the standard deviation of the
C            mean of the distribution in the bin.  In this case, 0
C            means to plot all points rather than the binned
C            average.
C        2 = If DOHIST <= 0 and BPARM(1) > 0 and BPARM(2) > 0, the
C            bin averages will be printed in the message file at
C            message level 4.
C        3 = If greater than zero, use BPARM(4) - BPARM(7) as
C            the ranges of the axes.  If less than zero, use the
C            BPARMs to limit the range of the axes, but self-
C            scale the axes within that range.  If 0.0, fully
C            self-scaling.
C        4 = Minimum of X-axis.
C        5 = Maximum of X-axis (if = BPARM(4) do self-scale in X).
C        6 = Minimum of Y-axis.
C        7 = Maximum of Y-axis (if = BPARM(6) do self-scale in Y).
C        9 = The exponent to which to take the X-axis result value
C            before plotting.   0 => 1.
C        10 = The exponent to which to take the Y-axis result value
C            before plotting.   0 => 1.
C     CPARM......After the value or absolute value of a column is
C             found, it may be scaled and offset before other
C             functions are applied to it.
C        1 = X-axis logical column number A scale factor: 0 -> 1.
C        2 = X-axis logical column number A offset.
C        3 = X-axis logical column number B scale factor: 0 -> 1.
C        4 = X-axis logical column number B offset.
C        5 = Y-axis logical column number A scale factor: 0 -> 1.
C        6 = Y-axis logical column number A offset.
C        7 = Y-axis logical column number B scale factor: 0 -> 1.
C        8 = Y-axis logical column number B offset.
C     LTYPE.......Labeling type
C     DOTV........> 0 => plot directly on the TV device, otherwise
C                 make a plot file for later display on one or
C                 more devices (including the TV if desired).
C     GRCHAN......Graphics channel (1 - 3) to use for line drawing.
C                 0 => 1.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IERR, IRET
      INCLUDE 'TAPLT.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'TAPLT '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL TAPIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       determine scaling
      IF ((SCALEM(1)) .OR. ((SCALEM(2)) .AND. (NBIN.EQ.0))) THEN
         CALL TASCAL (IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
C                                       do histogram
      IF (DOHIST.GT.0.0) THEN
         CALL TAHIST (IRET)
         IF (IRET.NE.0) GO TO 990
      ELSE IF ((NBIN.NE.0) .AND. (SCALEM(2))) THEN
         CALL TABSCL (IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
C                                       Do plot
      CALL PLOTAB (IRET)
C                                       Clear catlg on error
 990  IF ((IRET.EQ.0) .OR. (NCFILE.LT.1) .OR. (FRW(1).GT.0) .OR.
     *   (DOTV)) GO TO 995
         CALL DELEXT ('PL', FVOL(1), FCNO(1), 'READ', CATBLK, SBUF,
     *      PVER, IERR)
         NCFILE = NCFILE - 1
C                                       Close down
 995  CALL DIE (IRET, SBUF)
C
 999  STOP
      END
      SUBROUTINE TAPIN (PRGM, JERR)
C-----------------------------------------------------------------------
C   TAPIN gets input parameters for TAPLT .
C   Inputs:  PRGM   C*6)      Program name
C   Output:  JERR   I         Error code: 0 => ok, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   JERR
C
      CHARACTER INTYPE*2, STAT*4, CHAX(2)*2
      INTEGER   IUSER, I, IERR, IROUND, IO, ID1, ID2, J, K, JTRIM, I4T,
     *   LTYPE
      LOGICAL   T
      INCLUDE 'TAPLT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T, CHAX /.TRUE., 'X-','Y-'/
C-----------------------------------------------------------------------
C                                       Init IO et al.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      DEG2R = ATAN(1.0D0) / 45.0D0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
      PVER = 10000
C                                       Get input parameters.
      NPARM = 83
      CALL GTPARM (PRGM, NPARM, RQUICK, USERID, SBUF, IERR)
      IF (IERR.EQ.0) GO TO 10
         JERR = 8
         RQUICK = .TRUE.
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
C                                       Restart AIPS
 10   IF (RQUICK) CALL RELPOP (JERR, SBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 0
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMIN, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (2, 1, XINEXT, INEXT)
C                                       Crunch input parameters.
      IF (ABS(FACTOR).LT.0.1) THEN
         IF (FACTOR.GE.0.0) THEN
            FACTOR = 1.0
         ELSE
            FACTOR = -1.0
            END IF
         END IF
      USERID = NLUSER
      IUSER = NLUSER
      IF (XINC.LT.1.0) XINC = 1.0
      INC = IROUND (XINC)
      IF (INC.LE.0) INC = 1
      XINC = INC
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      GR2CHN = GRCHN / 10
      GRCHN = MOD (GRCHN, 10)
      IF (GR2CHN.EQ.0) GR2CHN = MAX (1, GRCHN)
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
      LABEL = IROUND (XLABEL)
      LTYPE = MOD (ABS(LABEL), 100)
      IF ((LTYPE.EQ.0) .OR. (LTYPE.GT.10)) LTYPE = 3
      IF (LTYPE.GT.7) LTYPE = 7
      IF ((LTYPE.GE.4) .AND. (LTYPE.LE.6)) LTYPE = 3
      IF (LABEL.GE.0) THEN
         LABEL = (LABEL/100)*100 + LTYPE
      ELSE
         LABEL = (LABEL/100)*100 - LTYPE
         END IF
C                                       Get CATBLK from file.
      CNO = 1
      INTYPE = ' '
      CALL CATDIR ('SRCH', DISKIN, CNO, NAMEIN, CLAIN, SEQIN, INTYPE,
     *   IUSER, STAT, SBUF, IERR)
      IF (IERR.EQ.0) GO TO 20
         WRITE (MSGTXT,1010) IERR, NAMEIN, CLAIN, SEQIN, DISKIN, IUSER
         GO TO 990
 20   STAT = 'WRIT'
      IF (DOTV) STAT = 'READ'
      CALL CATIO ('READ', DISKIN, CNO, CATBLK, STAT, SBUF, IERR)
      IF (IERR.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) IERR
         GO TO 990
 30   NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 1
      XSIN = SEQIN
      XDISIN = DISKIN
C                                       Find extension file
      IF (INEXT.EQ.'  ') INEXT = 'CC'
      EVER = IROUND (XVER)
      IF (INEXT.EQ.INTYPE) EVER = 1
      TALUN = 28
      NKEY = 0
      NCOL = 0
      NREC = 0
      LROW = 0
      CALL TABINI ('READ', INEXT, DISKIN, CNO, EVER, CATBLK, TALUN,
     *   NKEY, NREC, NCOL, DATP, TABUF, IERR)
      IF (IERR.EQ.0) GO TO 40
         WRITE (MSGTXT,1030) IERR, INEXT, EVER
         GO TO 990
C                                       Set/check parms
 40   IECNT = TABUF(5)
      TAIND = TABUF(82)
      IF ((ECOUNT.GE.1.0) .AND. (ECOUNT.LT.IECNT)) IECNT = ECOUNT + 0.1
      IBCNT = BCOUNT + 0.1
      IF (IBCNT.LE.0) IBCNT = 1
      ECOUNT = IECNT
      BCOUNT = IBCNT
      XVER = EVER
      IF (IBCNT+INC.LE.IECNT) GO TO 45
         WRITE (MSGTXT,1040) IBCNT, IECNT, INC
         GO TO 990
 45   SUMEM(2) = .FALSE.
      DO 60 I = 1,2
         IO = (I-1)*5
         OPTYPE(I) = IROUND (APARM(IO+5))
         IF (OPTYPE(I).LT.0) OPTYPE(I) = 0
         IF ((I.EQ.2) .AND. (DOHIST.GT.0.0)) GO TO 60
         TWOOF(I) = OPTYPE(I).GT.9
         TYPEAX(1,I) = IROUND (APARM(IO+1))
         TYPEAX(2,I) = 0
         IF (TWOOF(I)) TYPEAX(2,I) = IROUND (APARM(IO+3))
         IF ((TYPEAX(1,I).GE.-NCOL) .AND. (TYPEAX(1,I).LE.NCOL) .AND.
     *      (TYPEAX(2,I).GE.-NCOL) .AND. (TYPEAX(2,I).LE.NCOL)) GO TO 50
            WRITE (MSGTXT,1045) CHAX(I), TYPEAX(1,I), TYPEAX(2,I)
            GO TO 990
 50      SUMEM(I) = OPTYPE(I).EQ.1
         ABSEM(1,I) = TYPEAX(1,I).LT.0
         ABSEM(2,I) = TYPEAX(2,I).LT.0
         TYPEAX(1,I) = ABS(TYPEAX(1,I))
         TYPEAX(2,I) = ABS(TYPEAX(2,I))
         DTYPAX(1,I) = 0
         DTYPAX(2,I) = 0
         ISUBAX(1,I) = APARM(IO+2) + 0.1
         ISUBAX(2,I) = 1
         IF (TWOOF(I)) ISUBAX(2,I) = APARM(IO+4) + 0.1
         IF (TYPEAX(1,I).GT.0) DTYPAX(1,I) = DATP(TYPEAX(1,I),2)
         IF (TYPEAX(2,I).GT.0) DTYPAX(2,I) = DATP(TYPEAX(2,I),2)
         ID1 = DTYPAX(1,I) / 10
         ID2 = DTYPAX(2,I) / 10
         IF (ID1.LT.1) ID1 = 1
         IF (ID2.LT.1) ID2 = 1
         DTYPAX(1,I) = MOD (DTYPAX(1,I), 10)
         DTYPAX(2,I) = MOD (DTYPAX(2,I), 10)
         IF ((ISUBAX(1,I).LE.0) .OR. (ID1.EQ.1)) ISUBAX(1,I) = 1
         IF ((ISUBAX(2,I).LE.0) .OR. (ID2.EQ.1)) ISUBAX(2,I) = 1
         IF ((DTYPAX(1,I).NE.3) .AND. (DTYPAX(1,I).NE.5) .AND.
     *      (DTYPAX(1,I).NE.7) .AND. (DTYPAX(2,I).NE.3) .AND.
     *      (DTYPAX(2,I).NE.5) .AND. (DTYPAX(2,I).NE.7)) GO TO 55
            WRITE (MSGTXT,1050) CHAX(I)
            GO TO 990
 55      IF ((ISUBAX(1,I).LE.ID1) .AND. (ISUBAX(2,I).LE.ID2)) GO TO 60
            WRITE (MSGTXT,1055) CHAX(I), ISUBAX(1,I), ISUBAX(2,I),
     *         ID1, ID2
            GO TO 990
 60      CONTINUE
      IF (DOHIST.GT.0.) ABSEM(1,2) = .FALSE.
      IF (DOHIST.GT.0.) ABSEM(2,2) = .FALSE.
      IF ((DOHIST.GT.0.) .AND. ((OPTYPE(2).GT.4) .OR. (OPTYPE(2).LE.2)))
     *   OPTYPE(2) = 0
      IF (OPTYPE(1).GT.19) OPTYPE(1) = 0
      IF (OPTYPE(2).GT.19) OPTYPE(2) = 0
      APARM(5) = OPTYPE(1)
      APARM(10) = OPTYPE(2)
      IF (BPARM(9).EQ.0.0) BPARM(9) = 1.0
      IF (BPARM(10).EQ.0.0) BPARM(10) = 1.0
      IF (CPARM(1).EQ.0.0) CPARM(1) = 1.0
      IF (CPARM(3).EQ.0.0) CPARM(3) = 1.0
      IF (CPARM(5).EQ.0.0) CPARM(5) = 1.0
      IF (CPARM(7).EQ.0.0) CPARM(7) = 1.0
      IF (CPARM(9).EQ.0.0) CPARM(9) = 1.0
C                                       Update catalog header for PL
      FRW(NCFILE) = 0
      PVER = 0
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', DISKIN, FCNO(1), CATBLK, SBUF, T, 'READ',
     *      PVER, IERR)
         IF (IERR.NE.0) THEN
            NCFILE = NCFILE - 1
            WRITE (MSGTXT,1060) IERR
            GO TO 990
            END IF
         END IF
C                                       parms
      XYSCL(1) = -1.0E10
      XYSCL(2) = XYSCL(1)
      XYOFF(1) = 1.E10
      XYOFF(2) = XYOFF(1)
      APARM(2) = ISUBAX(1,1)
      APARM(4) = ISUBAX(2,1)
      APARM(7) = ISUBAX(1,2)
      APARM(9) = ISUBAX(2,2)
C                                       Prepare for possible binning of
C                                       data
      NBIN = IROUND (BPARM(1))
      IF (DOHIST.GT.0.0) NBIN = ABS (NBIN)
      IF ((DOHIST.GT.0.0) .AND. (NBIN.LE.1)) NBIN = 50
      NBIN = MAX (-400, MIN (400, NBIN))
      BPARM(1) = NBIN
C                                       Autoscale ?
      SCALEM(1) = (BPARM(3).LE.0.0) .OR. (BPARM(4).EQ.BPARM(5))
      SCALEM(2) = (BPARM(3).LE.0.0) .OR. (BPARM(6).EQ.BPARM(7))
      TESTEM(1) = 1
      IF (BPARM(4).GT.BPARM(5)) TESTEM(1) = -1
      IF ((BPARM(3).EQ.0.0) .OR. (BPARM(4).EQ.BPARM(5))) TESTEM(1) = 0
      TESTEM(2) = 1
      IF (BPARM(6).GT.BPARM(7)) TESTEM(2) = -1
      IF ((BPARM(3).EQ.0.0) .OR. (BPARM(6).EQ.BPARM(7))) TESTEM(2) = 0
      IF (DOHIST.GT.0.0) THEN
         TESTEM(2) = 0
         SCALEM(2) = .TRUE.
         END IF
      DO 75 I = 1,400
         SUM(I) = 0.0
         SUM2(I) = 0.0
         BINCNT(I) = 0
 75      CONTINUE
C                                       testing on a column value
      J = 1
      NTVAL = 0
      DO 90 K = 1,7
         ITVAL(1,K) = IROUND (XARR(J))
         IF ((ITVAL(1,K).GT.0) .AND. (ITVAL(1,K).LE.NCOL)) THEN
            NTVAL = K
            ITVAL(2,K) = IROUND (XARR(J+1))
            I = MOD (DATP(ITVAL(1,K),2), 10)
            I4T = DATP(ITVAL(1,K),2) / 10
            ITVAL(2,K) = MAX (1, MIN (I4T, ITVAL(2,K)))
            IF ((I.EQ.1) .OR. (I.EQ.2)) THEN
               RTVAL(K) = XARR(J+2)
               IF (XARR(J+3).LE.0.0) XARR(J+3) = 1.0E-2
               ETVAL(K) = XARR(J+3)
            ELSE IF (I.EQ.4) THEN
               ITVAL(4,K) = IROUND (XARR(J+2))
               IF (XARR(J+3).LE.0.0) XARR(J+3) = 1.0E-2
               ETVAL(K) = XARR(J+3)
            ELSE
               CALL H2CHR (16, 1, XKEYST, CTVAL)
               ETVAL(K) = MIN (I4T, JTRIM (CTVAL))
               END IF
            ITVAL(3,K) = I
            J = J + 4
         ELSE
            GO TO 999
            END IF
 90      CONTINUE
      GO TO 999
C                                       Error message
 990  CALL MSGWRT (8)
      JERR = 5
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TAPIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('ERROR',I4,' FINDING ',A12,'.',A6,'.',I4,' DISK',I2,
     *   ' USER',I5)
 1020 FORMAT ('ERROR',I4,' READING CATALOG HEADER')
 1030 FORMAT ('ERROR',I4,' OPENING EXT. ',A2,' VERS',I6)
 1040 FORMAT ('ERROR IN BCOUNT, ECOUNT INC:',3I8)
 1045 FORMAT (A2,'AXIS COLUMN NUMBERS',2I5,' OUT OF RANGE')
 1050 FORMAT ('I PLOT ONLY FLOATING OR INTEGER COLUMNS: PROBLEM IN ',A2,
     *   'AXIS')
 1055 FORMAT (A2,'AXIS SUBSCRIPTS',2I6,' EXCEED LIMITS',2I6)
 1060 FORMAT ('ERROR',I5,' ADDING PL FILE TO HEADER')
      END
      SUBROUTINE TASCAL (IRET)
C-----------------------------------------------------------------------
C   TASCAL read the table file to determine the scaling.
C   IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET, IROW, ICNT, JCNT, LINC, LBCNT
      DOUBLE PRECISION    XY(2)
      LOGICAL   PSC
      INCLUDE 'TAPLT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      ICNT = 0
      JCNT = 0
      RSUM(1) = 0.0D0
      RSUM(2) = 0.0D0
      PSC = SCALEM(2)
C                                       Loop
      IF ((SUMEM(1)) .OR. (SUMEM(2))) THEN
         LINC = 1
         LBCNT = 1
      ELSE
         LINC = INC
         LBCNT = IBCNT
         END IF
      IF (NBIN.GT.0) SCALEM(2) = .FALSE.
      DO 100 IROW = LBCNT,IECNT,LINC
         CALL FNDTXY (IROW, XY, IRET)
         IF ((IRET.LT.0).OR.(XY(1).EQ.DBLANK).OR.(XY(2).EQ.DBLANK))
     *      GO TO 100
         IF (IRET.GT.0) GO TO 999
C                                       Find scales
         IF ((IROW.GE.IBCNT) .AND. (MOD(IROW-IBCNT,INC).EQ.0)) THEN
            ICNT = ICNT + 1
            CALL XYSCAT (ICNT, XY, IRET)
            IF (IRET.EQ.0) JCNT = JCNT + 1
            END IF
 100     CONTINUE
C                                       Any valid points
      IF (JCNT.GT.1) GO TO 110
         IRET = 4
         WRITE (MSGTXT,1100) JCNT
         GO TO 990
C                                       Final call to XYSCL.
 110  ICNT = -1
      CALL XYSCAT (ICNT, XY, IRET)
      IF (IRET.LE.0) GO TO 120
         WRITE (MSGTXT,1110) IRET
         GO TO 990
 120  IRET = 0
      SCALEM(2) = PSC
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('FOUND',I5,' POINTS: NOT ENOUGH TO SELF-SCALE')
 1110 FORMAT ('TASCAL: XYSCAT ERROR',I3)
      END
      SUBROUTINE TABSCL (IRET)
C-----------------------------------------------------------------------
C   TABSCL reads the table file to determine the binned Y scale
C   Output
C      IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   I, IP, NP, IROW, ICNT, JCNT, LINC, LBCNT
      REAL      TEMP, STD
      DOUBLE PRECISION    XY(2), XMIN, XMAX, DX
      INCLUDE 'TAPLT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      ICNT = 0
      JCNT = 0
      IF (SCALEM(1)) THEN
         XMIN = XYOFF(1)
         XMAX = 1000.0 / XYSCL(1) + XYOFF(1)
      ELSE
         XMIN = BPARM(4)
         XMAX = BPARM(5)
         END IF
      NP = ABS (NBIN)
      DX = (XMAX - XMIN) / NP
      IF (SUMEM(1)) THEN
         LINC = 1
         LBCNT = 1
      ELSE
         LINC = INC
         LBCNT = IBCNT
         END IF
      RSUM(1) = 0.0D0
      RSUM(2) = 0.0D0
C                                       Loop
      DO 100 IROW = LBCNT,IECNT,LINC
         CALL FNDTXY (IROW, XY, IRET)
         IF (IRET.GT.0) GO TO 999
C                                       Find scales
         IF ((IRET.EQ.0) .AND. (IROW.GE.IBCNT) .AND.
     *      (MOD(IROW-IBCNT,INC).EQ.0) .AND. (XY(1).NE.DBLANK) .AND.
     *      (XY(2).NE.DBLANK)) THEN
            IF (XY(1).EQ.XMAX) XY(1) = XMAX - DX/100.
            IP = (XY(1) - XMIN) / DX + 1.0D0
            IF ((IP.LT.1) .OR. (IP.GT.NP)) THEN
               JCNT = JCNT + 1
            ELSE
               ICNT = ICNT + 1
               BINCNT(IP) = BINCNT(IP) + 1
               SUM(IP) = SUM(IP) + XY(2)
               SUM2(IP) = SUM2(IP) + XY(2)*XY(2)
               END IF
            END IF
 100     CONTINUE
C                                       Any valid points
      IF (ICNT.LE.1) THEN
         IRET = 4
         WRITE (MSGTXT,1100) ICNT
         GO TO 990
         END IF
C                                       Any missing points
      IF (JCNT.GT.0) THEN
         WRITE (MSGTXT,1110) JCNT
         CALL MSGWRT (4)
         END IF
      IRET = 0
      WRITE (MSGTXT,1120) ICNT
      CALL MSGWRT (4)
      XMAX = -1.0D9
      XMIN = 1.D9
      DO 130 I = 1,NP
         STD = 0.0
C                                       include only filled bins
         IF ((NBIN.GT.0) .AND. (BINCNT(I).GT.0)) THEN
            SUM(I) = SUM(I) / BINCNT(I)
            IF (BINCNT(I).GE.2) STD = SQRT (ABS ((SUM2(I)/BINCNT(I)) -
     *         SUM(I)*SUM(I)) / (BINCNT(I) - 1.0))
            SUM2(I) = STD
            IF (XMAX.LT.SUM(I)+STD) XMAX = SUM(I)+STD
            IF (XMIN.GT.SUM(I)-STD) XMIN = SUM(I)-STD
            END IF
 130     CONTINUE
      XYOFF(2) = XMIN
      XYSCL(2) = XMAX
      TEMP = 0.025 * (XYSCL(2) - XYOFF(2))
      XYSCL(2) = XYSCL(2) + TEMP
      XYOFF(2) = XYOFF(2) - TEMP
      XYSCL(2) = 1000.0 / (XYSCL(2) - XYOFF(2))
      DO 140 I = 1,NP
         BINCNT(I) = 0
         SUM(I) = 0.0
         SUM2(I) = 0.0
 140     CONTINUE
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('FOUND',I5,' POINTS: NOT ENOUGH TO SET A SCALE')
 1110 FORMAT ('Found',I8,' points outside x range while binning')
 1120 FORMAT ('Found',I8,' points to include in bins')
      END
      SUBROUTINE TAHIST (IRET)
C-----------------------------------------------------------------------
C   TAHIST reads the table file to determine the histogram.
C   IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET, I, IP, NP, IROW, ICNT, JCNT, LINC, LBCNT
      REAL      TEMP
      DOUBLE PRECISION    XY(2), XMIN, XMAX, DX
      INCLUDE 'TAPLT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      ICNT = 0
      JCNT = 0
      IF (SCALEM(1)) THEN
         XMIN = XYOFF(1)
         XMAX = 1000.0 / XYSCL(1) + XYOFF(1)
      ELSE
         XMIN = BPARM(4)
         XMAX = BPARM(5)
         END IF
      NP = BPARM(1) + 0.01
      DX = (XMAX - XMIN) / NP
      IF (SUMEM(1)) THEN
         LINC = 1
         LBCNT = 1
      ELSE
         LINC = INC
         LBCNT = IBCNT
         END IF
      RSUM(1) = 0.0D0
      RSUM(2) = 0.0D0
C                                       Loop
      DO 100 IROW = LBCNT,IECNT,LINC
         CALL FNDTXY (IROW, XY, IRET)
         IF (IRET.GT.0) GO TO 999
C                                       Find scales
         IF ((IRET.EQ.0) .AND. (IROW.GE.IBCNT) .AND.
     *      (MOD(IROW-IBCNT,INC).EQ.0) .AND. (XY(1).NE.DBLANK) .AND.
     *      (XY(2).NE.DBLANK)) THEN
            IF (XY(1).EQ.XMAX) XY(1) = XMAX - DX/100.
            IP = (XY(1) - XMIN) / DX + 1.0D0
            IF ((IP.LT.1) .OR. (IP.GT.NP)) THEN
               JCNT = JCNT + 1
            ELSE
               ICNT = ICNT + 1
               BINCNT(IP) = BINCNT(IP) + 1
               END IF
            END IF
 100     CONTINUE
C                                       Any valid points
      IF (ICNT.GT.1) GO TO 110
         IRET = 4
         WRITE (MSGTXT,1100) ICNT
         GO TO 990
C                                       Any missing points
 110  IF (JCNT.LE.0) GO TO 120
         WRITE (MSGTXT,1110) JCNT
         CALL MSGWRT (4)
 120  IRET = 0
      WRITE (MSGTXT,1120) ICNT
      CALL MSGWRT (4)
      XMAX = -1.D10
      XMIN = -XMAX
      DO 130 I = 1,NP
         SUM(I) = BINCNT(I)
         IF ((OPTYPE(2).GE.3) .AND. (SUM(I).LT.1.0)) SUM(I) = -0.3
         IF ((OPTYPE(2).EQ.3) .AND. (SUM(I).GE.1.0))
     *      SUM(I) = LOG10 (SUM(I))
         IF ((OPTYPE(2).GE.4) .AND. (SUM(I).GE.1.0))
     *      SUM(I) = LOG (SUM(I))
         IF (SUM(I).GT.0.0) SUM(I) = SUM(I) ** BPARM(10)
         IF (SUM(I).GT.XMAX) XMAX = SUM(I)
         IF (SUM(I).LT.XMIN) XMIN = SUM(I)
 130     CONTINUE
      XYOFF(2) = XMIN
      XYSCL(2) = XMAX
      TEMP = 0.025 * (XYSCL(2) - XYOFF(2))
      XYSCL(2) = XYSCL(2) + TEMP
      XYOFF(2) = XYOFF(2) - TEMP
      XYSCL(2) = 1000.0 / (XYSCL(2) - XYOFF(2))
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('FOUND',I5,' POINTS: NOT ENOUGH TO HISTOGRAM')
 1110 FORMAT ('Found',I8,' points outside x range while histogramming')
 1120 FORMAT ('Found',I8,' points to include in histogram')
      END
      SUBROUTINE PLOTAB (IRET)
C-----------------------------------------------------------------------
C   PLOTAB actually plots table data.
C   Output:
C      IRET   I   Return code, 0 => OK, otherwise abort.
C                       1 => failed to add to catalog
C                       2 => failed to create
C                       3 => graph file write error
C                       4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER TEXT*1024, PFILE*48, COLTYP(2,2)*24, TIME*8, DATE*12,
     *   CHAX(2)*2, CTEMP*18
      INTEGER   BUFFER(256), IERR, ITYPE, IPSIZE, I, LUNPL, FINDPL,
     *   IAPARM(8), INCHAR, INP, J, IBIN, IP, IT(3), ID(3), II, JJ,
     *   LTYPE
      REAL      BLC(2), TRC(2), CHOUT(4), XYRATO, DX, DY, TR, TI, XY(2),
     *   AVERG, STDEV, RESULT(6), TEMP, SCLR(2)
      DOUBLE PRECISION    XZY(2)
      INTEGER   NGOOD, NNOFIT, LINC, IROW, IRNO, LBCNT, NCOUNT, NB
      LOGICAL   GOOD, NOCHK, DOGRID, PTOFF
      INCLUDE 'TAPLT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA LUNPL /26/
      DATA CHAX /'X-','Y-'/
C-----------------------------------------------------------------------
      NGOOD = 0
      NCOUNT = 0
      NNOFIT = 0
      IRET = 1
      RSUM(1) = 0.0D0
      RSUM(2) = 0.0D0
      NB = ABS (NBIN)
C                                       See if data range check
      NOCHK = (NB.GT.0)
C                                       User sets the scales
      DO 10 I = 1,2
         IF (.NOT.SCALEM(I)) THEN
            XYSCL(I) = BPARM(3+2*I)
            XYOFF(I) = BPARM(2+2*I)
            TEMP = 0.015 * (XYSCL(I) - XYOFF(I))
            XYSCL(I) = XYSCL(I) + TEMP
            XYOFF(I) = XYOFF(I) - TEMP
            IF (XYSCL(I).EQ.XYOFF(I)) GO TO 999
            XYSCL(I) = 1000. / (XYSCL(I)-XYOFF(I))
            END IF
 10      CONTINUE
C                                       Fill in last of actual parms
      BPARM(5) = 1000.0/XYSCL(1) + XYOFF(1)
      BPARM(7) = 1000.0/XYSCL(2) + XYOFF(2)
      BPARM(4) = XYOFF(1)
      BPARM(6) = XYOFF(2)
C                                       Create plot file
      CALL ZPHFIL ('PL', DISKIN, FCNO(1), PVER, PFILE, IERR)
      IF (IERR.NE.0) GO TO 999
      IPSIZE = 0
      ITYPE = 15
      CALL GINIT (DISKIN, FCNO(1), PFILE, IPSIZE, ITYPE, NPARM, USERID,
     *   DOTV, TVCHN, GRCHN, TVCORN, CATBLK, BUFFER, LUNPL, FINDPL,
     *   IERR)
      IRET = 2
      IF (IERR.NE.0) GO TO 999
      IF (GR2CHN.GT.0) GPHTVG(1) = GR2CHN + NGRAY
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      XYRATO = 1.0
      IRET = 3
      CALL FILL (5, 1, IAPARM)
C                                       Set up location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      DO 30 I = 1,2
         TR = 1000.0 / XYSCL(I)
         TI = TR
         RPLOC(I,LOCNUM) = BLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I)
         AXINC(I,LOCNUM) = TR / (TRC(I) - BLC(I))
         CALL METSCL (LABEL, TR, CPREF(I,LOCNUM), GOOD)
         RPVAL(I,LOCNUM) = RPVAL(I,LOCNUM) * TR / TI
         AXINC(I,LOCNUM) = AXINC(I,LOCNUM) * TR / TI
C                                       get col. units
         DO 20 J = 1,2
            IF ((J.NE.2) .OR. (TWOOF(I))) THEN
               IF ((I.EQ.2) .AND. (DOHIST.GT.0.0)) THEN
                  IF (J.EQ.1) CTYP(I,LOCNUM) = 'COUNT'
                  COLTYP(J,I) = 'HISTOGRAM'
               ELSE IF (TYPEAX(J,I).EQ.0) THEN
                  IF (J.EQ.1) CTYP(I,LOCNUM) = 'ROW NUMBER'
                  COLTYP(J,I) = 'ROW NUMBER'
               ELSE
                  IRNO = TYPEAX(J,I)
                  IF (J.EQ.1) CALL TABIO ('READ', 4, IRNO, RESULT,
     *               TABUF, IERR)
                  IF (IERR.NE.0) GO TO 970
                  IF (J.EQ.1) CALL H2CHR (8, 1, RESULT, CTYP(I,LOCNUM))
                  CALL TABIO ('READ', 3, IRNO, RESULT, TABUF, IERR)
                  IF (IERR.NE.0) GO TO 970
                  CALL H2CHR (24, 1, RESULT, COLTYP(J,I))
                  IF (CTYP(I,LOCNUM).EQ.' ') CTYP(I,LOCNUM) =
     *               COLTYP(J,I)(:20)
                  END IF
               END IF
 20         CONTINUE
         IF ((OPTYPE(I).EQ.9) .OR. (OPTYPE(I).EQ.17)) CTYP(I,LOCNUM) =
     *      'DEGREES'
 30      CONTINUE
C                                       Count characters around
      CALL RFILL (4, 0.5, CHOUT)
      CALL CHNTIC (BLC, TRC, INP)
      LTYPE = MOD (ABS (LABEL), 100)
      IF (LTYPE.EQ.2) CHOUT(1) = 2.5
      IF ((LTYPE.GT.2) .AND. (INP.GT.0)) CHOUT(1) = 4.0 + INP
      IF (LTYPE.GT.1) CHOUT(2) = 2.0
      IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = 4.666
      IF ((LABEL.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = CHOUT(4) + 1.333
C                                       Init for line drawing.
      CALL GINITL (BLC, TRC, XYRATO, CHOUT, IAPARM, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 975
      CALL GLTYPE (1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Draw border
      CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (BLC(1), BLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (TRC(1), BLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (TRC(1), TRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (BLC(1), TRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Top labels: type & name
      DX = 0.0
      IF ((LABEL.GT.1) .AND. (LTYPE.LT.7)) THEN
         DY = 0.5 + 3 * 1.333
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, TIME, DATE)
         WRITE (TEXT,1030) PVER, DATE, TIME
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Top labels: type & name
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DY = 0.5 + 2 * 1.333
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         INP = 21
         WRITE (TEXT,1031) INEXT, EVER
         TEXT(INP-1:INP-1) = '_'
         CALL H2CHR (18, 1, CATH(KHIMN), CTEMP)
         CALL NAMEST (CTEMP, SEQIN, TEXT(INP:), INCHAR)
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Top label: col. labels
         DO 45 I = 1,2
            DY = DY - 1.333
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            TEXT = ' '
            WRITE (TEXT,1032) CHAX(I)
            IP = 9
            IF (I.EQ.1) THEN
               IF (NBIN.NE.0) THEN
                  TEXT(9:) = 'BINNED'
                  IP = 16
                  END IF
            ELSE IF (DOHIST.LE.0.0) THEN
               IF (NBIN.LT.0) THEN
                  TEXT(9:) = 'BINNED SUM'
                  IP = 20
               ELSE IF (NBIN.GT.0) THEN
                  TEXT(9:) = 'BINNED AVG'
                  IP = 20
                  END IF
               END IF
C                                       first column(s)
            II = 4*I - 3
            JJ = 8 + I
            IF (I.EQ.1) THEN
               SCLR(1) = CPARM(9)
               SCLR(2) = CPARM(10)
            ELSE
               SCLR(1) = 1.0
               SCLR(2) = 0.0
               END IF
            CALL SELSTR (IP, OPTYPE(I), TWOOF(I), ABSEM(1,I),
     *         TYPEAX(1,I), ISUBAX(1,I), CPARM(II), SCLR, BPARM(JJ),
     *         COLTYP(1,I), IP, TEXT)
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
 45         CONTINUE
         END IF
C                                       Put on labels and ticks
      DOGRID = .FALSE.
      CALL CLAB1 (BLC, TRC, CHOUT, LABEL, XYRATO, DOGRID, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Read table file:
      DX = 5.0 * ABS(FACTOR)
      DY = 5.0 * ABS(FACTOR)
      CALL GLTYPE (2, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Plot histogram
      IF (DOHIST.GT.0.0) THEN
         PTOFF = .TRUE.
         DO 50 IBIN = 1,NBIN
            XY(1) = (IBIN * 1000. - 500.) / NBIN
            XY(2) = XYSCL(2) * (SUM(IBIN) - XYOFF(2))
            IF ((XY(2).LT.BLC(2)) .OR. (XY(2).GT.TRC(2))) THEN
               NNOFIT = NNOFIT + 1
            ELSE
               CALL GPOS (XY(1)+DX, XY(2), BUFFER, IRET)
               IF (IRET.NE.0) GO TO 970
               CALL GVEC (XY(1)-DX, XY(2), BUFFER, IRET)
               IF (IRET.NE.0) GO TO 970
               CALL GPOS (XY(1), XY(2)+DY, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 970
               CALL GVEC (XY(1), XY(2)-DY, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 970
               NGOOD = NGOOD + 1
               END IF
 50         CONTINUE
         IF (FACTOR.LT.0.0) THEN
            CALL GLTYPE (4, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            DO 55 IBIN = 1,NBIN
               XY(1) = (IBIN * 1000. - 500.) / NBIN
               XY(2) = XYSCL(2) * (SUM(IBIN) - XYOFF(2))
               IF ((XY(2).GE.BLC(2)) .AND. (XY(2).LE.TRC(2))) THEN
                  IF (PTOFF) THEN
                     CALL GPOS (XY(1), XY(2), BUFFER, IRET)
                  ELSE
                     CALL GVEC (XY(1), XY(2), BUFFER, IRET)
                     END IF
                  IF (IRET.NE.0) GO TO 970
                  PTOFF = .FALSE.
               ELSE
                  PTOFF = .TRUE.
                  END IF
 55            CONTINUE
            CALL GLTYPE (2, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
C                                       Loop
      ELSE
         IF ((SUMEM(1)) .OR. (SUMEM(2))) THEN
            LINC = 1
            LBCNT = 1
         ELSE
            LINC = INC
            LBCNT = IBCNT
            END IF
         DO 80 IROW = LBCNT,IECNT,LINC
            CALL FNDTXY (IROW, XZY, IRET)
            IF (IRET.GT.0) GO TO 999
            IF ((IRET.EQ.0) .AND. (IROW.GE.IBCNT) .AND.
     *         (MOD(IROW-IBCNT,INC).EQ.0) .AND. (XZY(1).NE.DBLANK) .AND.
     *         (XZY(2).NE.DBLANK)) THEN
               DO 70 J = 1,2
                  XY(J) = XYSCL(J) * (XZY(J) - XYOFF(J))
                  IF (((XY(J).GE.BLC(J)) .AND. (XY(J).LE.TRC(J))) .OR.
     *               ((NOCHK) .AND. (J.EQ.2))) GO TO 70
                     NNOFIT = NNOFIT + 1
                     GO TO 80
 70               CONTINUE
               NGOOD = NGOOD + 1
C                                       If binning - accumulate
               IF (NB.GT.0) THEN
                  IBIN = 1 + NB * XY(1) / 1000.
                  IF (IBIN.LT.1) IBIN = 1
                  IF (IBIN.GT.NB) IBIN = NB
                  SUM(IBIN) = SUM(IBIN) + XY(2)
                  SUM2(IBIN) = SUM2(IBIN) + XY(2)*XY(2)
                  BINCNT(IBIN) = BINCNT(IBIN) + 1
C                                       Mark the point
               ELSE
                  CALL GPOS (XY(1)+DX, XY(2), BUFFER, IRET)
                  IF (IRET.NE.0) GO TO 970
                  CALL GVEC (XY(1)-DX, XY(2), BUFFER, IRET)
                  IF (IRET.NE.0) GO TO 970
                  CALL GPOS (XY(1), XY(2)+DY, BUFFER, IRET)
                  IF (IRET.NE.0) GO TO 970
                  CALL GVEC (XY(1), XY(2)-DY, BUFFER, IRET)
                  IF (IRET.NE.0) GO TO 970
                  END IF
               END IF
 80         CONTINUE
C                                       Done: finish plot
         IF (NBIN.GT.0) THEN
C                                       Plot binned data.
            NCOUNT = NGOOD
            NGOOD = 0
            NNOFIT = 0
            PTOFF = .TRUE.
            DO 90 IBIN = 1,NB
               STDEV = 0.0
C                                       sum plot
               IF (BINCNT(IBIN).LE.0) THEN
                  PTOFF = .TRUE.
                  NNOFIT = NNOFIT + 1
C                                       average w plus/minus
               ELSE
                  AVERG = SUM(IBIN) / BINCNT(IBIN)
                  IF (BINCNT(IBIN).GE.2) STDEV =
     *               SQRT (ABS ((SUM2(IBIN)/BINCNT(IBIN)) -
     *               AVERG*AVERG)/(BINCNT(IBIN) - 1.0))
                  DY = STDEV
                  IF (BINCNT(IBIN).GE.2.0) DY = MAX (DX, DY)
                  XY(1) = (IBIN * 1000. - 500.) / NB
                  XY(2) = AVERG
                  IF ((XY(2).LT.BLC(2)) .OR. (XY(2).GT.TRC(2))) THEN
                     NNOFIT = NNOFIT + 1
                  ELSE
                     CALL GPOS (XY(1)+DX, XY(2), BUFFER, IRET)
                     IF (IRET.NE.0) GO TO 970
                     CALL GVEC (XY(1)-DX, XY(2), BUFFER, IRET)
                     IF (IRET.NE.0) GO TO 970
                     CALL GPOS (XY(1), XY(2)+DY, BUFFER, IRET)
                     IF (IRET.NE.0) GO TO 970
                     CALL GVEC (XY(1), XY(2)-DY, BUFFER, IRET)
                     IF (IRET.NE.0) GO TO 970
                     NGOOD = NGOOD + 1
                     END IF
                  END IF
               IF (BPARM(2).GT.0.0) THEN
                  XY(1) = XY(1) / XYSCL(1) + XYOFF(1)
                  XY(2) = XY(2) / XYSCL(2) + XYOFF(2)
                  STDEV = STDEV / XYSCL(2)
                  WRITE (MSGTXT,1110) XY(1), XY(2), STDEV
                  CALL MSGWRT (4)
                  END IF
 90            CONTINUE
            IF (FACTOR.LT.0.0) THEN
               CALL GLTYPE (4, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               DO 95 IBIN = 1,NB
                  STDEV = 0.0
C                                       sum plot
                  IF (BINCNT(IBIN).LE.0) THEN
                     PTOFF = .TRUE.
C                                       average w plus/minus
                  ELSE
                     AVERG = SUM(IBIN) / BINCNT(IBIN)
                     IF (BINCNT(IBIN).GE.2) STDEV =
     *                  SQRT (ABS ((SUM2(IBIN)/BINCNT(IBIN)) -
     *                  AVERG*AVERG)/(BINCNT(IBIN) - 1.0))
                     DY = STDEV
                     IF (BINCNT(IBIN).GE.2.0) DY = MAX (DX, DY)
                     XY(1) = (IBIN * 1000. - 500.) / NB
                     XY(2) = AVERG
                     IF ((XY(2).LT.BLC(2)) .OR. (XY(2).GT.TRC(2))) THEN
                        PTOFF = .TRUE.
                     ELSE
                        IF (PTOFF) THEN
                           CALL GPOS (XY(1), XY(2), BUFFER, IRET)
                        ELSE
                           CALL GVEC (XY(1), XY(2), BUFFER, IRET)
                           END IF
                        IF (IRET.NE.0) GO TO 970
                        PTOFF = .FALSE.
                        END IF
                     END IF
 95               CONTINUE
               CALL GLTYPE (2, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               END IF
            END IF
         END IF
C                                       finish plot
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.EQ.0) THEN
         IRET = 0
         GO TO 990
         END IF
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 990
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         END IF
      GO TO 999
C                                       No catalog update
C                                       Messages
 990  WRITE (MSGTXT,1990) NGOOD
      CALL MSGWRT (2)
      WRITE (MSGTXT,1991) NNOFIT
      IF (NNOFIT.GE.1.0D0) CALL MSGWRT (2)
      WRITE (MSGTXT,1992) NCOUNT
      IF (NCOUNT.GE.1.0D0) CALL MSGWRT (2)
      WRITE (MSGTXT,1993) PVER
      CALL MSGWRT (2)
      CALL ZCLOSE (TALUN, TAIND, IERR)
      IF (.NOT.DOTV) CALL HIPLOT (DISKIN, FCNO(1), PVER, BUFFER, IERR)
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('Plot file version',I4,'__created ',A12,A8)
 1031 FORMAT ('Ext ',A2,'__Vers',I4)
 1032 FORMAT (A2,'Axis: ')
 1110 FORMAT ('X=',1PE12.5,', Y=',E12.5,', SIG=',E12.5)
 1970 FORMAT ('PLOTAB: Error during graphing. will try to finish',
     *   ' partial graph')
 1990 FORMAT ('PLOTAB: ',I10,' points plotted')
 1991 FORMAT ('PLOTAB: ',I10,' points did not fit')
 1992 FORMAT ('PLOTAB: ',I10,' points entered into bins')
 1993 FORMAT ('PLOTAB: Plot file version',I5,'  created.')
      END
      SUBROUTINE XYSCAT (ICNT, XY, IRET)
C-----------------------------------------------------------------------
C   XYSCAT finds the scaling parameters needed to fit X and Y
C   into a 1000*1000 plotting area .
C   Inputs:
C      NUMVIS     I    Data number, -1 => final call, no data
C                      passed -> change to scaling factor from max/min
C      XY         D    plotted parameters .
C   Outputs:
C      XYOFF      R    when added to XY changes minimum to zero .
C      XYSCL      R    scale XY so that maximum is 1000.
C      IRET       I    Error return code , non-zero if error .
C-----------------------------------------------------------------------
      DOUBLE PRECISION    XY(2), TEMP
      INTEGER   IRET, I, JJ, ICNT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'TAPLT.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Are they in requested range
      IF (ICNT.GE.0) THEN
         IRET = -1
         DO 10 I = 1,2
            IF (TESTEM(I).NE.0) THEN
               JJ = 2*I + 2
               IF ((BPARM(JJ).LT.BPARM(JJ+1)) .AND. ((XY(I).LT.
     *            BPARM(JJ)) .OR. (XY(I).GT.BPARM(JJ+1)))) GO TO 999
               IF ((BPARM(JJ).GT.BPARM(JJ+1)) .AND. ((XY(I).GT.
     *            BPARM(JJ)) .OR. (XY(I).LT.BPARM(JJ+1)))) GO TO 999
               END IF
 10         CONTINUE
         IRET = 0
C                                       Find max, min from data
         DO 30 I = 1,2
            IF (SCALEM(I)) THEN
               IF (XY(I).LT.XYOFF(I)) XYOFF(I) = XY(I)
               IF (XY(I).GT.XYSCL(I)) XYSCL(I) = XY(I)
               END IF
 30         CONTINUE
C                                       Convert to scaling factors
C                                       provide room at edges too.
      ELSE
         DO 120 I = 1,2
            IF (SCALEM(I)) THEN
               IF (XYSCL(I).LE.XYOFF(I)) THEN
                  IRET = 1
                  WRITE (MSGTXT,1980) I
                  CALL MSGWRT (8)
               ELSE
                  TEMP = 0.025 * (XYSCL(I) - XYOFF(I))
                  XYSCL(I) = XYSCL(I) + TEMP
                  XYOFF(I) = XYOFF(I) - TEMP
                  IF ((XYOFF(I).GT.0.0) .AND.
     *               (XYOFF(I).LT.0.15*XYSCL(I))) XYOFF(I) = 0.0
                  XYSCL(I) = 1000.0 / (XYSCL(I) - XYOFF(I))
                  END IF
               END IF
 120        CONTINUE
         END IF
      GO TO 999
C
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('XYSCAT: AXIS',I2,' DEGENERATE')
      END
      SUBROUTINE FNDTXY (IROW, XY, IRET)
C-----------------------------------------------------------------------
C   FNDTXY extracts the desired X and Y values from the table file.
C   Inputs:  IROW   I        Table row number
C   Outputs: XY     D(2)     X, Y values
C            IRET   I        Error code: <0 -> skip row, > 0 bad error
C-----------------------------------------------------------------------
      INTEGER   IROW, IRET
      DOUBLE PRECISION XY(2)
C
      INCLUDE 'TAPLT.INC'
      DOUBLE PRECISION  DADATA(XBPRSZ/2), XZY(2)
      REAL      D4DATA(XBPRSZ)
      INTEGER   D3DATA(XBPRSZ), I, D2DATA(XBPRSZ), J, JT, IO, JTRIM, M
      LOGICAL   DOIT
      HOLLERITH DHDATA(XBPRSZ)
      CHARACTER SCRTCH*132
      EQUIVALENCE (DADATA, D4DATA, D3DATA, D2DATA, DHDATA)
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       do we want this row
      DOIT = .TRUE.
      IRET = -1
      DO 110 I = 1,NTVAL
         J = ITVAL(1,I)
         CALL GETCOL (IROW, J, DATP, LROW, TABUF, JT, DADATA,
     *      RECI, IRET)
         IF (IRET.NE.0) GO TO 999
         JT = ITVAL(3,I)
         IF (JT.EQ.1) THEN
            IF (ABS(DADATA(ITVAL(2,I))-RTVAL(I)).GT.ETVAL(I))
     *         DOIT = .FALSE.
         ELSE IF (JT.EQ.2) THEN
            IF (ABS(D4DATA(ITVAL(2,I))-RTVAL(I)).GT.ETVAL(I))
     *         DOIT = .FALSE.
         ELSE IF (JT.EQ.4) THEN
            IF (ABS(D3DATA(ITVAL(2,I))-ITVAL(4,I)).GT.ETVAL(I))
     *         DOIT = .FALSE.
         ELSE
            M = ETVAL(I) + 0.1
            CALL H2CHR (M, 1, DHDATA, SCRTCH)
            JT = JTRIM (SCRTCH(:M))
            IF (SCRTCH(:M).NE.CTVAL(:M)) DOIT = .FALSE.
            END IF
 110     CONTINUE
      IF ((DOINV.GT.0.0) .AND. (NTVAL.GT.0)) DOIT = .NOT.DOIT
      IF (.NOT.DOIT) THEN
         IRET = -1
         GO TO 999
         END IF
C                                       Loop over axes
      DO 100 I = 1,2
         IF ((I.EQ.2) .AND. (DOHIST.GT.0.0)) GO TO 100
C                                       Get values
         DO 10 J = 1,2
            IF ((J.EQ.1) .OR. (TWOOF(I))) THEN
               XZY(J) = IROW
               IF (TYPEAX(J,I).NE.0) THEN
                  CALL GETCOL (IROW, TYPEAX(J,I), DATP, LROW, TABUF, JT,
     *               DADATA, RECI, IRET)
                  IF (IRET.NE.0) GO TO 999
                  JT = MOD (JT, 10)
                  IF (JT.EQ.1) THEN
                     IF (DADATA(ISUBAX(J,I)).EQ.DBLANK) IRET = -1
                     XZY(J) = DADATA(ISUBAX(J,I))
                  ELSE IF (JT.EQ.2) THEN
                     IF (D4DATA(ISUBAX(J,I)).EQ.FBLANK) IRET = -1
                     XZY(J) = D4DATA(ISUBAX(J,I))
                  ELSE IF (JT.EQ.4) THEN
                     XZY(J) = D3DATA(ISUBAX(J,I))
                  ELSE IF (JT.EQ.6) THEN
                     XZY(J) = D2DATA(ISUBAX(J,I))
                     END IF
                  IF (IRET.NE.0) GO TO 999
                  IF (ABSEM(J,I)) XZY(J) = ABS(XZY(J))
                  END IF
               IO = 4 * I + 2 * J - 5
               XZY(J) = XZY(J) * CPARM(IO) + CPARM(IO+1)
               END IF
 10         CONTINUE
C                                       perform function
         IRET = -2
         J = OPTYPE(I) + 1
         GO TO (20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33,
     *      34, 35, 36, 37, 38, 39), J
C                                       straight through
 20      XY(I) = XZY(1)
         GO TO 95
C                                       Sum
 21      RSUM(I) = RSUM(I) + XZY(1)
         XY(I) = RSUM(I)
         GO TO 95
C                                       ASIN
 22      IF (ABS(XZY(1)).GT.1.0D0) GO TO 999
         XY(I) = ASIN (XZY(1)) / DEG2R
         GO TO 95
C                                       LOG10
 23      IF (XZY(1).LE.0.0D0) GO TO 999
         XY(I) = LOG10 (XZY(1))
         GO TO 95
C                                       LN
 24      IF (XZY(1).LE.0.0D0) GO TO 999
         XY(I) = LOG (XZY(1))
         GO TO 95
C                                       EXP
 25      XY(I) = EXP (XZY(1))
         GO TO 95
C                                       SIN
 26      XY(I) = SIN (DEG2R * XZY(1))
         GO TO 95
C                                       COS
 27      XY(I) = COS (DEG2R * XZY(1))
         GO TO 95
C                                       TAN
 28      XY(I) = TAN (DEG2R * XZY(1))
         GO TO 95
C                                       ARC TAN
 29      XY(I) = RAD2DG * ATAN (XZY(1)) / DEG2R
         GO TO 95
C                                       +
 30      XY(I) = XZY(1) + XZY(2)
         GO TO 95
C                                       -
 31      XY(I) = XZY(1) - XZY(2)
         GO TO 95
C                                       *
 32      XY(I) = XZY(1) * XZY(2)
         GO TO 95
C                                       /
 33      IF (XZY(2).EQ.0.D0) GO TO 999
         XY(I) = XZY(1) / XZY(2)
         GO TO 95
C                                       **
 34      IF (XZY(1).LT.0.D0) GO TO 999
         XY(I) = XZY(1) ** XZY(2)
         GO TO 95
C                                       MOD
 35      IF (XZY(2).EQ.0.D0) GO TO 999
         XY(I) = MOD (XZY(1), XZY(2))
         GO TO 95
C                                       Modulus
 36      XY(I) = SQRT (XZY(1)*XZY(1) + XZY(2)*XZY(2))
         GO TO 95
C                                       ATAN2
 37      IF ((XZY(1).EQ.0.D0) .AND. (XZY(2).EQ.0.D0)) GO TO 999
         XY(I) = RAD2DG * ATAN2 (XZY(1), XZY(2))
         GO TO 95
C                                       Max
 38      XY(I) = XZY(1)
         IF (XZY(2).GT.XZY(1)) XY(I) = XZY(2)
         GO TO 95
C                                       Min
 39      XY(I) = XZY(1)
         IF (XZY(2).LT.XZY(1)) XY(I) = XZY(2)
C                                       Okay!: scale
 95      IO = 8 + I
         IF ((BPARM(IO).NE.1.0) .AND. (BPARM(IO).NE.0.0) .AND.
     *      (XY(I).NE.0.0)) THEN
            JT = BPARM(IO)
            IF (JT.NE.BPARM(IO)) THEN
               IF (XY(I).GT.0.0D0) XY(I) = XY(I) ** BPARM(IO)
            ELSE
               XY(I) = XY(I) ** JT
               END IF
            END IF
C                                       Added X scale
         IF (I.EQ.1) XY(I) = XY(I) * CPARM(9) + CPARM(10)
 100     CONTINUE
      IRET = 0
C
 999  RETURN
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER   NPARMS
C                                       NPARMS=no. adverbs passed.
      PARAMETER (NPARMS=10)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                                       NOTE: Uses values in PAOOF.INC
C                                       Adverb names
C                     1         2          3        4         5
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INEXT',
C         6         7           8         9         10
     * 'INVERS', 'ANTENNAS', 'BCOUNT' ,'ECOUNT', 'OUTFILE'/
C                                       Adverb data types (PAOOF.INC)
C                    1       2       3       4       5
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOACAR,
C          6       7       8       9       10
     *   OOAINT, OOAINT, OOAINT, OOAINT, OOACAR/
C                                       Adverb dimensions (as 2D)
C                   1    2    3    4    5
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 2,1,
C         6     7    8    9    10
     *   1,1, 50,1, 1,1, 1,1, 48,1/
LOCAL END
      PROGRAM HF2SV
C-----------------------------------------------------------------------
C! Convert HF table to binary table for Mark III geodetic program DBEDIT
C# Calibration VLBI OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2001-2002, 2009, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Paraform AIPS OOP task processing a table.  This version HF2SV
C   converts the HF table into a binary table for input into the
C   geodetic package Solve.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, INTAB*36, FNAME*256
      INTEGER  IRET, BUFF1(256), NCH
      DATA PRGM /'HF2SV '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL TABTIN (PRGM, INTAB, FNAME, NCH, IRET)
C                                       Process table
      IF (IRET.EQ.0) CALL TABTAB (INTAB, FNAME, NCH, IRET)
C                                       Close down files, etc.
C  For use in Batch jobs: If error, close down but continue
      IRET=0
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE TABTIN (PRGN, INTAB, FNAME, NCH, IRET)
C-----------------------------------------------------------------------
C   TABTIN gets input parameters for HF2SV and creates the input object.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      FNAME   C*256  Directory name
C      NCH     I    Character is director name (plus /)
C      IRET    I    Error code: 0 => ok
C                               1=>  FRING.LIST alread there
C                               2=>  Error writing/reading FRING.LIST
C                               4 => user routine detected error
C                               5 => catalog troubles
C                               8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6, INTAB*36, FNAME*(*)
C
      INTEGER   NKEY1
C                                       NKEY1=no. adverbs to copy to
C                                       INTAB
      PARAMETER (NKEY1=10)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32
C                                       for reading to EOF, index file
      CHARACTER CDUMMY*1
      INTEGER   DIM(3), FDUM(2), TYPE, NCH, JTRIM
      CHARACTER LFILE*48, FILNAM*256
      LOGICAL EXISTS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to INTAB
C                   1         2          3        4         5
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INEXT',
C           6         7           8         9         10
     *   'INVERS', 'ANTENNAS', 'BCOUNT', 'ECOUNT', 'OUTFILE'/
C                                       May rename adverbs to INTAB
C                    1       2        3        4       5
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'TBLTYPE',
C           6      7         8         9         10
     *   'VER', 'REFANT', 'BCOUNT', 'ECOUNT', 'FILE'/
C-----------------------------------------------------------------------
C                                       Startup,  returns "Input" object
C                                       containing POPS adverbs
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create input object
      INTAB = 'Input table'
      CALL CREATE (INTAB, 'TABLE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, INTAB, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Get file name
      CALL OGET (INTAB, 'FILE', TYPE, DIM, FDUM, LFILE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Crack name
      CALL ZFULLN(LFILE, ' ', '     ', FNAME, IRET)
      IF (IRET.NE.0) GO TO 999
      NCH = JTRIM (FNAME) + 1
      FNAME(NCH:) = '/'
      WRITE (MSGTXT, 1010) FNAME(1:NCH)
 1010 FORMAT ('Directory: ',A)
      CALL MSGWRT(4)
C                                       See if Fring index file exists
      FILNAM = FNAME(1:NCH) // 'FRING.LIST'
      INQUIRE (FILE=FILNAM, EXIST=EXISTS)
      IF (EXISTS) THEN
C                                       Yes, so open, read to end
         OPEN (UNIT=23, FILE=FILNAM, STATUS='OLD')
 100     READ (23, 1110,END=120) CDUMMY
         GO TO 100
 120     WRITE (MSGTXT, 1120)
         CALL MSGWRT(4)
        ELSE
         OPEN (UNIT=23, FILE=FILNAM, STATUS='NEW')
         WRITE (MSGTXT, 1121)
         CALL MSGWRT(4)
         ENDIF
C
 999  RETURN
C-----------------------------------------------------------------------
 1110 FORMAT (A1)
 1120 FORMAT ('Existing FRING.LIST file found, appending to it.')
 1121 FORMAT ('Created FRING.LIST')
      END
      SUBROUTINE TABTAB (INTAB, FNAME, NCH, IERR)
C-----------------------------------------------------------------------
C   Convert table.
C   Inputs:
C      INTAB   C*   Name of input table object.
C      FNAME   C*   Directory name
C      NCH     I    # characters in directory name
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*), FNAME*(*)
      INTEGER   IERR, NCH
C                                       MAXSIZ = max table entry size as
C                                       reals or characters
      INTEGER   MAXSIZ
      PARAMETER (MAXSIZ = 5000)
      INTEGER   IROW, OROW, NROW, ICOL, NCOL, BC, EC, TYPE, DIM(3)
      REAL      RVALS(MAXSIZ)
      CHARACTER CVALS*(MAXSIZ*4), CDUMMY*1
      CHARACTER*8 ANNAME(50), S1, S2
      INTEGER   IVALS(MAXSIZ)
      DOUBLE PRECISION DVALS(MAXSIZ/2)
      COMMON /HFTST/ RVALS
      COMMON /HFTSTC/ CVALS
      EQUIVALENCE  (RVALS(1), DVALS(1), IVALS(1))
      INTEGER   REFANT(50), NREF, NNREF, SUBARR
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Open input table
      CALL OOPEN (INTAB, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get number of entries
      CALL OGET (INTAB, 'NROW', TYPE, DIM, IVALS, CDUMMY, IERR)
      NROW = IVALS(1)
      IF (IERR.NE.0) GO TO 999
C                                       Number of columns
      CALL OGET (INTAB, 'NCOL', TYPE, DIM, IVALS, CDUMMY, IERR)
      NCOL = IVALS(1)
      IF (IERR.NE.0) GO TO 999
C                                       Get range of rows.
      CALL OGET (INTAB, 'BCOUNT', TYPE, DIM, IVALS, CDUMMY, IERR)
      BC = IVALS(1)
      IF (IERR.NE.0) GO TO 999
      BC = MIN (MAX (BC, 1), NROW)
      CALL OGET (INTAB, 'ECOUNT', TYPE, DIM, IVALS, CDUMMY, IERR)
      EC = IVALS(1)
      IF (IERR.NE.0) GO TO 999
      IF (EC.LE.0) EC = NROW
C                                       Get antenna names
      SUBARR = 1
      CALL ANTIFO (INTAB, SUBARR, ANNAME, IERR)
C                                       Reference antennas
      CALL OGET (INTAB, 'REFANT', TYPE, DIM, REFANT, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (REFANT(1) .EQ. 0) THEN
         NREF = 0
         GO TO 20
         ENDIF
         DO 10 IROW = 2, 50
            IF (REFANT(IROW) .NE. 0 .AND.
     *          REFANT(IROW) .NE. REFANT(IROW-1)) GO TO 10
            NREF = IROW - 1
            GO TO 20
 10         CONTINUE
C                                       Loop over selected rows.
 20   IF (NREF .EQ. 0) THEN
         WRITE (MSGTXT, 1020)
 1020    FORMAT ('All baselines written out')
         CALL MSGWRT(4)
         ELSE
         NNREF = MIN (5,NREF)
         WRITE (MSGTXT, 1021) (ANNAME(REFANT(IROW)),IROW=1,NNREF)
         CALL MSGWRT(4)
 1021    FORMAT ('Using reference antennas ', 5(A8,1X))
         ENDIF
C                                       HF table loop
      OROW = 0
      DO 100 IROW = BC,EC
C                                       Check refant
         IF (NREF .EQ. 0) GO TO 40
         CALL TABDGT (INTAB, IROW, 26, TYPE, DIM, RVALS, CVALS, IERR)
         IF (IERR.NE.0) GO TO 999
         S1 = CVALS(1:8)
         CALL TABDGT (INTAB, IROW, 27, TYPE, DIM, RVALS, CVALS, IERR)
         IF (IERR.NE.0) GO TO 999
         S2 = CVALS(1:8)
         DO 30 ICOL = 1, NREF
            IF (ANNAME(REFANT(ICOL)) .EQ. S1 .OR.
     *          ANNAME(REFANT(ICOL)) .EQ. S2) GO TO 40
 30         CONTINUE
         GO TO 100
C                                       HF table information
 40      OROW = OROW + 1
         DO 50 ICOL = 1,NCOL
            CALL TABDGT (INTAB, IROW, ICOL, TYPE, DIM, RVALS, CVALS,
     *         IERR)
            IF (IERR.NE.0) GO TO 999
C                                       Conversion Routine
            CALL CNSLV (IROW, NCOL, ICOL, DIM(1), FNAME, NCH, IERR)
            IF (IERR.NE.0) GO TO 999
 50         CONTINUE
         IF (MOD(OROW,500) .EQ. 1) THEN
            WRITE (MSGTXT, 1050) IROW, OROW
 1050       FORMAT ('Converting HF row ', I5,' into File ', I5)
            CALL MSGWRT(1)
            ENDIF
 100     CONTINUE
C                                       Close tables
      CALL OCLOSE (INTAB, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE CNSLV (IROW, NCOL, ICOL, INUM, FNAME, NCH, IERR)
C-----------------------------------------------------------------------
C   This subroutine converts the HF data files into a binary form for
C   for input into the Mark III geodetic DBEDIT program. Most of the
C   conversion is done with EQUIVALENCE statments.
C-----------------------------------------------------------------------
C                                       General specifications
      INTEGER  IROW, NCOL, ICOL, INUM, IERR, I, ILENG,
     *   ITRIM, ISEC, JDATE(6), II, CH10, IOST, NTRY
      CHARACTER BLANK*1, CC*1, CF*1, CDOT*1, CLINE*1, N1CHAR*3,
     *   FPART*4, N2CHAR*4, LPART*6, DNAME*8, SDIR*10, SDIRBK*10,
     *   OUTFIL*86, COMAND*128
      LOGICAL   EXISTS
      CHARACTER FNAME*(*)
      INTEGER   NCH
C                                       Data arrays
      INTEGER   MAXSIZ
      PARAMETER (MAXSIZ = 5000)
      INTEGER   IVALS(MAXSIZ)
      REAL      RVALS(MAXSIZ)
      DOUBLE PRECISION DVALS(MAXSIZ/2)
      CHARACTER CVALS*(MAXSIZ*4)
      COMMON /HFTST/ RVALS
      COMMON /HFTSTC/ CVALS
      EQUIVALENCE (RVALS(1), DVALS(1), IVALS(1))
      INCLUDE 'INCS:DMSG.INC'
C                                       Record 0 conversions
      INTEGER*2 H0(128), H1(128), H2(128), H3(128), H4(128), H5(128)
      INTEGER*2 JUNK(128)
      CHARACTER C1*2
      INTEGER*2 I2(6), I3(6), I4(4), I9(28), I10(56), I12(6)
      INTEGER*2 I5, I6, I7, I8, I11, I13, I14, I15, I16, I17
C
      EQUIVALENCE (H0(3),  C1),     (H0(7),  I2(1)),  (H0(13), I3(1)),
     *            (H0(19), I4(1)),  (H0(23), I5),     (H0(24), I6),
     *            (H0(25), I7),     (H0(26), I8),     (H0(27), I9(1)),
     *            (H0(55), I10(1)), (H0(111),I11),    (H0(112),I12(1)),
     *            (H0(118),I13),    (H0(119),I14),    (H0(120),I15),
     *            (H0(121),I16),    (H0(122),I17)
C                                       Record 1,2,3 Conversion
      CHARACTER*2  C33, C34
      CHARACTER*6  C28, C31, C35, C36
      CHARACTER*8  C25, C26, C27, C29, C30, C32, C37, C38
C
      INTEGER*2  I18(28), I19(84)
      INTEGER*2  I20(28), I21(56), I22(28), I23, I24
C
      EQUIVALENCE (H1(7),  I18(1)), (H1(35), I19(1))
      EQUIVALENCE (H2(7),  I20(1)), (H2(35), I21(1)), (H2(91), I22(1)),
     1            (H2(119),I23),    (H2(120),I24)
      EQUIVALENCE (H3(7),  C25),    (H3(11), C26),    (H3(15), C27),
     1            (H3(19), C28),    (H3(22), C29),    (H3(26), C30),
     2            (H3(30), C31),    (H3(33), C32),    (H3(37), C33),
     3            (H3(38), C34),    (H3(39), C35),    (H3(42), C36),
     4            (H3(49), C37),    (H3(53), C38)
C                                       Record 4 Conversion
      DOUBLE PRECISION D39(14), D40, D41, D42, D43, D44, D45, D46,
     1       D47, D48, D49, D50
      EQUIVALENCE (H4(5),  D39(1)), (H4(61), D40),    (H4(65), D41),
     1            (H4(69), D42),    (H4(73), D43),    (H4(77), D44),
     2            (H4(81), D45),    (H4(85), D46),    (H4(89), D47),
     3            (H4(93), D48),    (H4(97), D49),    (H4(101),D50)
C                                       Record 5 Conversion
      REAL  R51(28), R52(2), R53, R54, R55, R56, R57, R58, R59(2),
     1      R60(2), R61, R62(2), R63(6), R64, R65, R66, R67, R68,
     2      R69, R70, R71, R72, R73, R74, R75, R76, R77
      EQUIVALENCE (H5(3),  R51(1)), (H5(59), R52(1)), (H5(63), R53),
     1            (H5(65), R54),    (H5(67), R55),    (H5(69), R56),
     2            (H5(71), R57),    (H5(73), R58),    (H5(75), R59(1)),
     3            (H5(79), R60(1)), (H5(83), R61),    (H5(85), R62(1)),
     4            (H5(89), R63(1)), (H5(101),R64),    (H5(103),R65),
     5            (H5(105),R66),    (H5(107),R67),    (H5(109),R68),
     6            (H5(111),R69),    (H5(113),R70),    (H5(115),R71),
     7            (H5(117),R72),    (H5(119),R73),    (H5(121),R74),
     8            (H5(123),R75),    (H5(125),R76),    (H5(127),R77)
C
      DATA  CH10 / 10 /
      DATA  CDOT, CLINE /'.', '_'/
      DATA  BLANK /' '/
      DATA  SDIRBK /'          '/
      DATA  JUNK / 128*0/
C-----------------------------------------------------------------------
C                                       Convert HF entries
      IF (ICOL.EQ.1) C1 = CVALS
      IF (ICOL.EQ.2) CALL IMANY (IVALS, INUM, I2)
      IF (ICOL.EQ.3) CALL IMANY (IVALS, INUM, I3)
      IF (ICOL.EQ.4) CALL IMANY (IVALS, INUM, I4)
      IF (ICOL.EQ.5) I5 = IVALS(1)
      IF (ICOL.EQ.6) I6 = IVALS(1)
      IF (ICOL.EQ.7) I7 = IVALS(1)
      IF (ICOL.EQ.8) I8 = IVALS(1)
      IF (ICOL.EQ.9) CALL IMANY (IVALS, INUM, I9)
      IF (ICOL.EQ.10) CALL IMANY (IVALS, INUM, I10)
      IF (ICOL.EQ.11) I11 = IVALS(1)
      IF (ICOL.EQ.12) CALL IMANY (IVALS, INUM, I12)
      IF (ICOL.EQ.13) I13 = IVALS(1)
      IF (ICOL.EQ.14) I14 = IVALS(1)
      IF (ICOL.EQ.15) I15 = IVALS(1)
      IF (ICOL.EQ.16) I16 = IVALS(1)
      IF (ICOL.EQ.17) I17 = IVALS(1)
      IF (ICOL.EQ.18) CALL IMANY (IVALS, INUM, I18)
      IF (ICOL.EQ.19) CALL IMANY (IVALS, INUM, I19)
      IF (ICOL.EQ.20) CALL IMANY (IVALS, INUM, I20)
      IF (ICOL.EQ.21) CALL IMANY (IVALS, INUM, I21)
      IF (ICOL.EQ.22) CALL IMANY (IVALS, INUM, I22)
      IF (ICOL.EQ.23) I23 = IVALS(1)
      IF (ICOL.EQ.24) I24 = IVALS(1)
      IF (ICOL.EQ.25) C25 = CVALS
      IF (ICOL.EQ.26) C26 = CVALS
      IF (ICOL.EQ.27) C27 = CVALS
      IF (ICOL.EQ.28) C28 = CVALS
      IF (ICOL.EQ.29) C29 = CVALS
      IF (ICOL.EQ.30) C30 = CVALS
      IF (ICOL.EQ.31) C31 = CVALS
      IF (ICOL.EQ.32) C32 = CVALS
      IF (ICOL.EQ.33) C33 = CVALS
      IF (ICOL.EQ.34) C34 = CVALS
      IF (ICOL.EQ.35) C35 = CVALS
      IF (ICOL.EQ.36) C36 = CVALS
      IF (ICOL.EQ.37) C37 = CVALS
      IF (ICOL.EQ.38) C38 = CVALS
      IF (ICOL.EQ.39) CALL DMANY(DVALS, INUM, D39)
      IF (ICOL.EQ.40) D40 = DVALS(1)
      IF (ICOL.EQ.41) D41 = DVALS(1)
      IF (ICOL.EQ.42) D42 = DVALS(1)
      IF (ICOL.EQ.43) D43 = DVALS(1)
      IF (ICOL.EQ.44) D44 = DVALS(1)
      IF (ICOL.EQ.45) D45 = DVALS(1)
      IF (ICOL.EQ.46) D46 = DVALS(1)
      IF (ICOL.EQ.47) D47 = DVALS(1)
      IF (ICOL.EQ.48) D48 = DVALS(1)
      IF (ICOL.EQ.49) D49 = DVALS(1)
      IF (ICOL.EQ.50) D50 = DVALS(1)
      IF (ICOL.EQ.51) CALL RMANY(RVALS, INUM, R51)
      IF (ICOL.EQ.52) CALL RMANY(RVALS, INUM, R52)
      IF (ICOL.EQ.53) R53 = RVALS(1)
      IF (ICOL.EQ.54) R54 = RVALS(1)
      IF (ICOL.EQ.55) R55 = RVALS(1)
      IF (ICOL.EQ.56) R56 = RVALS(1)
      IF (ICOL.EQ.57) R57 = RVALS(1)
      IF (ICOL.EQ.58) R58 = RVALS(1)
      IF (ICOL.EQ.59) CALL RMANY(RVALS, INUM, R59)
      IF (ICOL.EQ.60) CALL RMANY(RVALS, INUM, R60)
      IF (ICOL.EQ.61) R61 = RVALS(1)
      IF (ICOL.EQ.62) CALL RMANY(RVALS, INUM, R62)
      IF (ICOL.EQ.63) CALL RMANY(RVALS, INUM, R63)
      IF (ICOL.EQ.64) R64 = RVALS(1)
      IF (ICOL.EQ.65) R65 = RVALS(1)
      IF (ICOL.EQ.66) R66 = RVALS(1)
      IF (ICOL.EQ.67) R67 = RVALS(1)
      IF (ICOL.EQ.68) R68 = RVALS(1)
      IF (ICOL.EQ.69) R69 = RVALS(1)
      IF (ICOL.EQ.70) R70 = RVALS(1)
      IF (ICOL.EQ.71) R71 = RVALS(1)
      IF (ICOL.EQ.72) R72 = RVALS(1)
      IF (ICOL.EQ.73) R73 = RVALS(1)
C     IF (ICOL.EQ.73) print *, 'R73 ', R73
      IF (ICOL.EQ.74) R74 = RVALS(1)
      IF (ICOL.EQ.75) R75 = RVALS(1)
      IF (ICOL.EQ.76) R76 = RVALS(1)
      IF (ICOL.EQ.77) R77 = RVALS(1)
C
C                                       Print out (debug)
C       WRITE (*, 3050) IROW, ICOL, TYPE, INUM
C 3050 FORMAT (' ROW ', I4, '  COL ', I4, ' TYPE ', I2, '  # ', I4)
C       IF (TYPE.EQ.1) WRITE (*, 3051) (DVALS(I), I=1,INUM)
C       IF (TYPE.EQ.2) WRITE (*, 3052) (RVALS(I), I=1,INUM)
C       IF (TYPE.EQ.3) WRITE (*, 3053) CVALS
C       IF (TYPE.EQ.4) WRITE (*, 3054) (IVALS(I), I=1,INUM)
C 3051 FORMAT (1X, 5D22.15)
C 3052 FORMAT (1X, 5E22.15)
C 3053 FORMAT (1X, A8)
C 3054 FORMAT (1X, 15I7)
C
      IF (ICOL .LT. NCOL) RETURN
C                                       All columns done
C                                       Fix some things
C                                        Add in codes
      H0(1) = 4000
      H1(1) = 4100
      H2(1) = 4200
      H3(1) = 4300
      H4(1) = 4400
      H5(1) = 4500
C                                        Fix times
      IF (I2(6) .EQ. 60) THEN
         I2(6) = 0
         I2(5) = I2(5) + 1
         ENDIF
      IF (I3(6) .EQ. 60) THEN
         I3(6) = 0
         I3(5) = I3(5) + 1
         ENDIF
      IF (I12(6) .EQ. 60) THEN
         I12(6) = 0
         I12(5) = I12(5) + 1
         ENDIF
C                                        Fix years
      H0(7) = H0(7) - 1900
      H0(112) = H0(112) - 1900
C                                        Fix QuaL code 'X ' TO ' X'
      CC = C33
      C33 = BLANK // CC
C                                        Corlvr = 772
      H0(111) = 772
C                                        Subdirectory name
C                                        DDD-HHMMSS
      NTRY = 0
C
C      ISEC = MOD (IFIX(R70+0.5), 60)
CC  Fix for start time and obs time different hours
C       IF (ISEC .LT. 0) ISEC = ISEC + 60
CC
C 304  IF (ISEC .GT. 9) THEN
C         WRITE (SSEC, 3070) ISEC
C 3070    FORMAT (I2)
C         ELSE
C         WRITE (SSEC, 3071) ISEC
C 3071    FORMAT ('0',I1)
C         ENDIF
C      SDIR = C32 // SSEC
C
  304  CONTINUE
       WRITE (SDIR, 3072) C32(1:4), I2(4), I2(5), I2(6)
 3072  FORMAT (A4,3I2)
C   Beware of blanks in file name!
       DO 3073 I=1,10
        IF (SDIR(I:I) .EQ. ' ') SDIR(I:I) = '0'
 3073  CONTINUE
C      print *, ' SDIR, SDIRBK  ', SDIR, SDIRBK
C
      NTRY = NTRY+1
C                                        Create new subdirectory?
      IF (SDIR .EQ. SDIRBK) GO TO 500
C        CALL ZCRDIR (CH10, SDIR, IERR)
         COMAND = 'mkdir ' //FNAME(1:NCH)//SDIR
         CALL SYSTEM (COMAND)
         IERR = 0
         IF (IERR.NE.0) THEN
            COMAND = FNAME
            WRITE (MSGTXT,3080) COMAND(1:NCH)//SDIR
 3080       FORMAT (' could not make subdirectory ', A60)
            CALL MSGWRT (8)
            IERR = 1
            GO TO 999
           ELSE
            SDIRBK = SDIR
            ENDIF
C                                        Start time 6-char code
      JDATE(1) = I12(1)
      JDATE(2) = I12(2)
      JDATE(3) = I12(3)
      READ (C32, 3083) JDATE(4), JDATE(5)
 3083 FORMAT (4X, I2, I2)
      JDATE(6) = ISEC
      CALL JTIME (JDATE, LPART)
C                                        Make root filed
      DNAME = C25
      ILENG = ITRIM (DNAME)
C                                        Get rid of '.' in name
      DO 480  II = 1,ILENG
         IF (DNAME(II:II) .NE. CDOT) GO TO 480
            DNAME(II:II) = CLINE
 480     CONTINUE
      OUTFIL = FNAME(1:NCH) // SDIR // '/' // DNAME(1:ILENG)
     *         // '.' // LPART
C                                        Does file exist?
      INQUIRE (FILE=OUTFIL, EXIST=EXISTS)
      IF (.NOT. EXISTS) THEN
         OPEN (UNIT=22, STATUS='NEW', FORM='UNFORMATTED',
     *      ACCESS='DIRECT', RECL=256, FILE=OUTFIL,
     *      ERR=490, IOSTAT=IOST)
         GO TO 495
C                                        Problem?  Remake directory
 490     IF (NTRY .GT. 10) THEN
            IERR = 1
            WRITE (MSGTXT, 1490) OUTFIL, NTRY
 1490       FORMAT ('Cannot make ', A26, ' after ', I3, ' tries')
            CALL MSGWRT(4)
            WRITE (MSGTXT, 1491) IROW
 1491       FORMAT ('Restart HF2SV with BCOUNT ', I5)
            CALL MSGWRT(4)
            GO TO 999
            ENDIF
C                                        Remove bad dir, redo
        PRINT *, ' Removing directory ?? '
         CALL SYSTEM ('rmdir ' // SDIR // '?')
         SDIR = '          '
         SDIRBK = '          '
C                                        Try again
         GO TO 304
C                                        Sub dir,root file written
 495     WRITE (22,REC=1) JUNK
         CLOSE(22)
         WRITE (23, 5098)  OUTFIL
 5098    FORMAT (11X, 'Rootfile made in file ', A86)
         IF (NTRY .GT. 1) THEN
            WRITE (MSGTXT, 5097) OUTFIL, NTRY
 5097       FORMAT (A26, '  Root file created after ',I3,' tries')
            ENDIF
         ENDIF
C                                        Get fringe file name
 500  CONTINUE
      CF = C34
      FPART = C1 // '.' // CF
      DO 510 I = 1,99
         IF (I .LT. 10) THEN
            WRITE (N1CHAR, 5101) I
 5101       FORMAT ('.',I1,'.')
            OUTFIL = FNAME(1:NCH) // SDIR // '/' // FPART
     *               // N1CHAR // LPART
            ELSE
            WRITE (N2CHAR, 5102) I
 5102       FORMAT ('.',I2,'.')
            OUTFIL = FNAME(1:NCH) // SDIR // '/' // FPART
     *              // N2CHAR // LPART
            ENDIF
         INQUIRE (FILE=OUTFIL, EXIST=EXISTS)
         IF (.NOT. EXISTS) THEN
C                                        Successful open
            OPEN(UNIT=22, STATUS='NEW', FORM='UNFORMATTED',
     *         ACCESS='DIRECT', RECL=256, FILE=OUTFIL)
            WRITE (23, 5100) IROW, C25, C33, OUTFIL
 5100       FORMAT (I6, 2X, A8, '  QC= ',A2, ' in file ', A86)
            GO TO 520
            ELSE
C   File exists, make small change and try again
              IF(I.LE.8) GO TO 510
            WRITE(MSGTXT,5117) OUTFIL
            WRITE(6,5117) OUTFIL
 5117        FORMAT('HF2SV: File ',A86,' already exists!!!')
             CALL MSGWRT(4)
C             IF(I.LE.98) GO TO 510
            IERR = 1
            GO TO 999
            ENDIF
 510     CONTINUE
C                                        Too many duplicate files
      WRITE (MSGTXT,5110) OUTFIL, I
 5110 FORMAT (' could not open file ', A26, ' after ', I3, ' tries')
      CALL MSGWRT (8)
      IERR = 1
      GO TO 999
C                                        File opened.  Now write
 520  CONTINUE
      WRITE (22, REC=1) H0
      WRITE (22, REC=2) H1
      WRITE (22, REC=3) H2
      WRITE (22, REC=4) H3
      WRITE (22, REC=5) H4
      WRITE (22, REC=6) H5
      CLOSE (22)
      IERR = 0
C
 999  CONTINUE
      RETURN
      END
      SUBROUTINE IMANY (IVALS, INUM, IVAL)
C-----------------------------------------------------------------------
C   Variation on COPY.  Note conversion from I*4 to I*2
C-----------------------------------------------------------------------
      INTEGER   INUM, IVALS(*)
      INTEGER*2 IVAL(*)
C
      INTEGER   I
C-----------------------------------------------------------------------
      DO 10 I = 1,INUM
         IVAL(I) = IVALS(I)
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE DMANY (DVALS, INUM, DVAL)
C-----------------------------------------------------------------------
C   Variation on RCOPY for double precision
C-----------------------------------------------------------------------
      INTEGER   INUM
      DOUBLE PRECISION DVALS(*), DVAL(*)
C
      INTEGER   I
C-----------------------------------------------------------------------
      DO 10 I = 1,INUM
         DVAL(I) = DVALS(I)
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE RMANY (RVALS, INUM, RVAL)
C-----------------------------------------------------------------------
C   Variation on RCOPY
C-----------------------------------------------------------------------
      INTEGER   INUM
      REAL      RVALS(*), RVAL(*)
C
      INTEGER   I
C-----------------------------------------------------------------------
      DO 10 I = 1,INUM
         RVAL(I) = RVALS(I)
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE JTIME (JDATE, LPART)
C-----------------------------------------------------------------------
C   Determines the duration time between Jan 1, 1979 and JDATE in the
C   form (YY,MM,DD,HH,MM,SS).  The difference is converted into units of
C   4 seconds and further converted into base 26 number with a=0, b=1,
C   c=2, ..., y=24, z=25.  This conversion is done in subroutine ALSTR.
C-----------------------------------------------------------------------
      INTEGER   JDATE(6)
      CHARACTER LPART*6
C
      INTEGER   ZDATE(6)
      DOUBLE PRECISION JDAY1, JDAY2, JDIFF
      DATA  ZDATE / 79, 1, 1, 0, 0, 0 /
C-----------------------------------------------------------------------
      CALL DAT2JD (ZDATE, JDAY1)
      CALL DAT2JD (JDATE, JDAY2)
      JDIFF = (JDAY2 - JDAY1) * 21600.0D0
C
      CALL ALSTR (JDIFF, LPART)
C
 999  RETURN
      END
      SUBROUTINE ALSTR (JDAY, TSTR)
C-----------------------------------------------------------------------
C   This subroutine converts JDAY into a six digit number to the base
C   26.
C-----------------------------------------------------------------------
      DOUBLE PRECISION JDAY
      CHARACTER TSTR*6
C
      DOUBLE PRECISION TDAY, F26(6)
      INTEGER   I, ITEMP
      CHARACTER FLET*26
      DATA FLET /'abcdefghijklmnopqrstuvwxyz'/
C-----------------------------------------------------------------------
      DO 100 I = 1,6
         F26(7-I) = 26.0 ** (I-1)
 100     CONTINUE
      TDAY = JDAY
      DO 200 I = 1,6
         ITEMP = TDAY / F26(I)
         TSTR(I:I) = FLET(ITEMP+1:ITEMP+1)
         TDAY = TDAY - ITEMP * F26(I)
 200     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE ANTIFO (INTAB, SUBARR, ANAME, IERR)
C-----------------------------------------------------------------------
C   Returns the names of the antennas in a given subarray with
C   associated table INTAB.
C   subarray at a given time.
C   Inputs:
C      INTAB   C*?  Input table object (assumed to have associated AN
C                   and SU tables)
C      SUBARR  I    Subarray number 0=> 1
C   Output:
C      ANAME   C(*)*8 Antenna names
C      IERR    I    Return code, O=OK, else failed.
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*), ANAME(*)*8
      INTEGER SUBARR, IERR
C
      CHARACTER ANTAB*36, COLLAB(2)*24, CDUMMY*1
      INTEGER   NROW, ANTNO, I, COLS(2), TYPE, DIM(3), IDUM(2)
      REAL      RDUM(2)
      EQUIVALENCE (RDUM, IDUM)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
      DATA COLLAB /'NOSTA', 'ANNAME'/
C-----------------------------------------------------------------------
      IERR = 0
C                                        Make AN table object
      ANTAB = 'AN table'
      CALL OCOPY (INTAB, ANTAB, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Table type
      DIM(1) = 2
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (ANTAB, 'TBLTYPE', OOACAR, DIM, IDUM, 'AN', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Version
      DIM(1) = 1
      IDUM(1) = SUBARR
      CALL OPUT (ANTAB, 'VER', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open AN table
      CALL OOPEN (ANTAB, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
C                                        Find column numbers
      CALL TABCOL (ANTAB, 2, COLLAB, COLS, IERR)
      IF ((IERR.GE.1) .AND. (IERR.LE.10)) GO TO 999
C                                        Make sure all columns found
      DO 10 I = 1,2
         IF (COLS(I).LE.0) THEN
            MSGTXT = 'AN TABLE MISSING COLUMN ' // COLLAB(I)
            CALL MSGWRT (9)
            IERR = 7
            END IF
 10      CONTINUE
      IF (IERR.NE.0) GO TO 999
C                                       Get number of entries
      CALL OGET (ANTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IERR)
      NROW = IDUM(1)
      IF (IERR.NE.0) GO TO 999
C                                       Loop over table
      DO 100 I = 1,NROW
C                                       Read data for this row
         CALL TABDGT (ANTAB, I, COLS(1), TYPE, DIM, RDUM, CDUMMY, IERR)
         ANTNO = IDUM(1)
         IF (IERR.NE.0) GO TO 999
         ANAME(ANTNO) = ' '
         CALL TABDGT (ANTAB, I, COLS(2), TYPE, DIM, RDUM, ANAME(ANTNO),
     *      IERR)
         IF (IERR.NE.0) GO TO 999
 100     CONTINUE
C                                       Close AN table
         CALL OCLOSE (ANTAB, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Delete AN object
         CALL DESTRY (ANTAB, IERR)
         IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END

      SUBROUTINE ZBYTFL (NWORDS, INBUF, OUTBUF)
C-----------------------------------------------------------------------
C! interchange bytes in buffer if needed to go between local & standard
C# Z Binary Tape FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Interchange the low order and high order bytes for all words in the
C   input buffer and put the results in output buffer (which may be the
C   same as the input buffer).  For machines that are not byte flipped,
C   the output buffer is identical to the input buffer (see BYTFLP in
C   ZDCHIN).  Any required byte swapping is performed via a call to
C   ZBYTF2.  NOTE a byte is 8 bits here.
C   Inputs:
C      NWORDS   I           Number of 16-BIT words to byte swap
C      INBUF    I*2(*)      Input buffer
C   Output:
C      OUTBUF   I*2(*)      Output buffer containing the byte swapped
C                           words
C   Generic version - uses ZBYTF2 and ZADDR, works for 16, 32, 48, and
C   64-bit machines only
C-----------------------------------------------------------------------
      INTEGER   NWORDS
      INTEGER*2 INBUF(*), OUTBUF(*)
C
      INTEGER   IERR, I, J
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Only swap bytes/words if this is
C                                       a byte/word-swapped machine
C                                       (e.g., a VAX).
      IF (BYTFLP.GT.0) THEN
         CALL ZBYTF2 (NWORDS, BYTFLP, NBITWD, INBUF, OUTBUF)
C                                       Non-byte/word-swapped machine,
C                                       but is INBUF the same as OUTBUF?
      ELSE
         CALL ZADDR (INBUF, OUTBUF, IERR)
C                                       If not, copy buffers
         IF (IERR.NE.0) THEN
            J = NBITWD / 16
            IF (J*16.EQ.NBITWD) THEN
               DO 20 I = 1,NWORDS
                  OUTBUF(I) = INBUF(I)
 20               CONTINUE
            ELSE
               WRITE (MSGTXT,1000) NBITWD
               CALL MSGWRT (9)
               STOP 'ZBYTFL missing'
               END IF
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZBYTFL: REQUIRES LOCAL DEVELOPMENT FOR NBITWD =',I6)
      END

      SUBROUTINE YMNMAX (RMIN, RMAX, GMIN, GMAX, BMIN, BMAX, VRTRTC,
     *   IERR)
C-----------------------------------------------------------------------
C! read 3 min/max values from TV data paths (IIS only, not used)
C# Y2 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YMNMAX reads the min & max values put out by the 3 summers (before
C   application of constants, shifts and OFM) from the TV
C   Inputs:
C      VRTRTC  L    do it on vertical retrace only
C   Output:
C      RMIN    I    red minimum
C      RMAX    I    red maximum
C      GMIN    I    green minimum
C      GMAX    I    green maximum
C      BMIN    I    blue minimum
C      BMAX    I    blue maximum
C      IERR    I    error code of Z...XF : 0 => ok, 2 => input error
C   Virtual TV (by communication) version.
C-----------------------------------------------------------------------
      INTEGER   RMIN, RMAX, GMIN, GMAX, BMIN, BMAX, IERR
      LOGICAL   VRTRTC
C
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      BUFFER(1) = 0
      IF (VRTRTC) BUFFER(1) = 1
      BUFSW = 1
      BUFSR = 7
      CALL MKYBUF ('READ', 'YMNMAX', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
      IF (IERR.EQ.0) THEN
         CALL UNYBUF (BUFSR, BUFFER, HEADER)
         RMIN = BUFFER(2)
         RMAX = BUFFER(3)
         GMIN = BUFFER(4)
         GMAX = BUFFER(5)
         BMIN = BUFFER(6)
         BMAX = BUFFER(7)
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'FITTP.INC'
C                                                          Include FITTP
C                                       Local include for FITTP
      DOUBLE PRECISION HSCAL(2,20), HZERO(2,20), CATSCL, CATOFF
      HOLLERITH XNAME(3), XCLASS(2), XTYPE, XOUTFI(12)
      CHARACTER NAME*12, CLASS*6, TYPE*2, OUTFIL*48, HNAME(20)*8,

     *   LINE*2880
      REAL      DOALL, SEQ4, KVOL4, NTAPE4, DOEOT, TAMROF, BLOCKD,
     *   CNO(2), DOPLOT
      INTEGER   IBVOL, IEVOL, ISEQ, FDVEC(50), TBIND, DLUN, DIND, USER,
     *   ICARD, FITBLK(2880), TABLES, ANTFIL, IFLAG(20), IBLKF, IFMTYP,
     *   KLOCWT, NUMCOR, CATSAV(256), ICNO(2)
      LOGICAL   DODISK, ISCMP, DOBASL
      COMMON /INPARM/ DOALL, XNAME, XCLASS, SEQ4, KVOL4, XTYPE, NTAPE4,
     *   XOUTFI, DOEOT, TAMROF, BLOCKD, CNO, DOPLOT
      COMMON /MORPRM/ HSCAL, HZERO, CATSCL, CATOFF, FITBLK, DODISK,
     *   ISCMP, IBVOL, IEVOL, ISEQ, FDVEC, TBIND, DLUN, DIND, USER,
     *   ICARD, TABLES, ANTFIL, IFLAG, IBLKF, IFMTYP, KLOCWT, NUMCOR,
     *   CATSAV, ICNO, DOBASL
      COMMON /FTPCHR/ NAME, CLASS, TYPE, OUTFIL, HNAME, LINE
C                                                          End FITTP.
LOCAL END
LOCAL INCLUDE 'FITTP2.INC'
C                                       Local include for buffers
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   TAPBUF(29184), IBUFSZ
      REAL      BUFF(UVBFSS), TBUFF(UVBFSS)
      COMMON /BUFRS/ TAPBUF, BUFF, TBUFF, IBUFSZ
LOCAL END
      PROGRAM FITTP
C-----------------------------------------------------------------------
C! Translate AIPS data file to a FITS format file
C# Tape Map UV EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2000, 2002-2005, 2007-2008, 2010-2013, 2015-2016,
C;  Copyright (C) 2022, 2024-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This program will write a series of maps or UV data bases
C   using the FITS format.  The antenna file or clean components file
C   will be written as a table of one type or another.
C   Inputs:
C     DOALL      R      True (.GT.0) means do every data base that
C                       matches the inputs.  False (.LE.0) means do
C                       the first data base that matches.
C     INNAME     R(3)   Name of input file.
C     INCLASS    R(2)   Class of file.
C     INSEQ      R      sequence number of file.
C     INDISK     R      disk volume no. of file.
C     INTYPE     R      file type (UV or MA or blank).
C     OUTTAPE    R      tape number for output.
C     OUTFILE(12)R      Disk file name
C     OUTDISK    R      Output disk number
C     DOEOT      R      >= 0 -> advance to end-of-tape before writing
C     FORMAT     R      format types
C                           1 = 16-bit I, 2 32-bit I, 3 = 32-bit IEEE
C     BLOCKING   R      blocking factor 1 - 10
C     CATNO      R(2)   range of catalog numbers
C-----------------------------------------------------------------------
      CHARACTER  CHTM*2
      INTEGER   ISCR(256), IMAX, IERR, IVOL, INDEX, JERR, LSEQ, IRET, I,
     *   JCNO
      LOGICAL   FIND1, T, F, EOF
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (ISCR, BUFF)
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Set No. of files & no. of
C                                       scratch files to zero
      NCFILE = 0
      NSCR = 0
C                                       Get input parameters. Fill in
C                                       defaults.
      CALL FITINI (RQUICK, ISCR, IERR)
      IRET = IERR
      IF (IERR.NE.0) GO TO 990
C                                       Loop for all disks.
      FIND1 = F
      IMAX = 1000000
      IF (DOALL.LE.0.0) IMAX = 1
      IF (ISEQ.LE.0) ISEQ = 0
      LSEQ = ISEQ
      IF ((ISEQ.LE.0) .AND. (DOALL.LE.0.0)) LSEQ = -1
      ICNO(1) = CNO(1) + 0.01
      ICNO(2) = CNO(2) + 0.01
      IF (ICNO(1).LE.0) ICNO(1) = 1
      IF (ICNO(2).LT.ICNO(1)) ICNO(2) = 1000000
      DO 100 IVOL = IBVOL,IEVOL
C                                       Loop for all files on disk.
         JCNO = ICNO(1) - 1
         DO 80 INDEX = 1,IMAX
            JCNO = JCNO + 1
C                                       Find next data base.
            CALL NXTMAP ('READ', IVOL, NAME, CLASS, LSEQ, TYPE, USER,
     *         DLUN, DIND, JCNO, CATBLK, ISCR, EOF, IERR)
            CALL COPY (256, CATBLK, CATSAV)
            CATSCL = 1.0D0
            CATOFF = 0.0D0
            IF (IERR.NE.0) GO TO 900
            IF (EOF) GO TO 90
            IF (JCNO.LE.ICNO(2)) THEN
               FIND1 = T
C                                       Set DIE values for this file.
               NCFILE = 1
               FVOL(1) = IVOL
               FCNO(1) = JCNO
               FRW(1) = 0
C                                       Determine if UV or Map.
               CALL H2CHR (2, KHPTYO, CATH(KHPTY), CHTM)
               IF (CHTM.EQ.'UV') THEN
                  CALL FITSUV (JCNO, IVOL, IERR)
               ELSE
                  CALL FITSMP (JCNO, IVOL, IERR)
                  END IF
               END IF
            CALL MAPCLS ('READ', IVOL, JCNO, DLUN, DIND, CATBLK, F,
     *         ISCR, JERR)
            IF (IERR.NE.0) GO TO 990
            NCFILE = 0
            IF (JCNO.GE.ICNO(2)) GO TO 90
 80         CONTINUE
 90      IF ((IMAX.EQ.1) .AND. (FIND1)) GO TO 900
 100     CONTINUE
 900  IRET = IERR
C                                       Close output
      IF (FIND1) THEN
         I = 1
C                                       BAKF tape to where it already is
C                                       to encourage the OS to not write
C                                       an extra EOF on the tape
         IF (.NOT.DODISK) CALL ZTAPE ('BAKF', FDVEC(1), FDVEC(40), I,
     *      IERR)
C                                       Then close it
         CALL TAPIO ('CLOS', FDVEC, TAPBUF, TBIND, IERR)
         IF (IRET.EQ.0) IRET = IERR
C                                       Could not find file of type ...
      ELSE
         IF ((ICNO(1).EQ.1) .AND. (ICNO(2).GE.1000000)) THEN
            MSGTXT = 'CANNOT FIND THE INPUT DATA TO WRITE OUT'
         ELSE
            WRITE (MSGTXT,1900) ICNO
            END IF
         CALL MSGWRT (7)
         WRITE (MSGTXT,1901) USER, NAME, CLASS, ISEQ, IBVOL, IEVOL
         CALL MSGWRT (7)
         IF (IRET.EQ.0) IRET = 1
         CALL ZTPCLS (FDVEC(1), FDVEC(40), IERR)
         END IF
C
 990  CALL DIE (IRET, ISCR)
C
 999  STOP
C-----------------------------------------------------------------------
 1900 FORMAT ('INPUT DATA NOT FOUND IN CATALOG NUMBER RANGE',2I6)
 1901 FORMAT ('LOOKED FOR USER:',I5,1X,A12,'.',A6,'.',I4,' VOLS:',I2,
     *   ' -',I2)
      END
      SUBROUTINE FITINI (RQUICK, ISCR, IRET)
C-----------------------------------------------------------------------
C   FITINI does the most basic inits for FITTP.  Get the parameters,
C   restart AIPS if required, fill in defaults, init the tape I/O.
C   Outputs: RQUICK  L         T -> AIPS already restarted
C            ISCR    I(256)    Scratch buffer
C            IRET    I         Return code : 0 => ok
C                                       else quit
C            COMMON /INPARM/
C            COMMON /MORPRM/
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6, FILUPK*48
      INTEGER   IRET, ISCR(256)
      INTEGER   NPARM, ANP, NP, IERR, NTAPE
      LOGICAL   RQUICK, T, EQUAL
      HOLLERITH HFDVEC(50)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (HFDVEC, FDVEC)
      DATA PRGNAM, NPARM /'FITTP ', 28/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
      CALL ZDCHIN (T)
      CALL VHDRIN
C                                       Zero fill FDVEC
      CALL FILL (50, 0, FDVEC)
C                                       Init the FITS I/O
      TBIND = 1
C                                       Initialize for AIPS
      CALL GTPARM (PRGNAM, NPARM, RQUICK, DOALL, ISCR, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (8)
C                                       Only interactive tasks
C                                       Check if disk file output
      ELSE
         CALL H2CHR (48, 1, XOUTFI, FILUPK)
         EQUAL = FILUPK(1:20).EQ.'                    '
         DODISK = .NOT.EQUAL
         IF (((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) .AND.
     *      (.NOT.DODISK)) THEN
            WRITE (MSGTXT,1010)
            CALL MSGWRT (8)
            IRET = 4
            END IF
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, ISCR, IERR)
      IF (IRET.NE.0) GO TO 999
C                                       Convert characters
      CALL H2CHR (12, 1, XNAME, NAME)
      CALL H2CHR (6, 1, XCLASS, CLASS)
      CALL H2CHR (2, 1, XTYPE, TYPE)
      CALL H2CHR (48, 1, XOUTFI, OUTFIL)
C                                       Disk output.
      IF (DODISK) THEN
         WRITE (MSGTXT,1019) FILUPK
         CALL MSGWRT (4)
C                                       Don't do DOALL
         DOALL = -1.0
         CALL CHR2H (48, OUTFIL, 1, HFDVEC(7))
         FDVEC(1) = 25
         NTAPE = 1
C                                       Tape output
      ELSE
         NTAPE = NTAPE4 + 0.5
         IF (NTAPE.EQ.0) NTAPE = 1
         WRITE (MSGTXT,1030) NTAPE
         CALL MSGWRT (4)
         FDVEC(1) = 129 - NTAPE
         END IF
C                                       Open output file
      FDVEC(5) = NTAPE
      FDVEC(2) = 2880
      FDVEC(3) = (29184 * NBITWD) / 8
      IFMTYP = ABS(TAMROF) + 0.5
C                                        Default to IEEE
      IF ((IFMTYP.LT.1) .OR. (IFMTYP.GT.4)) IFMTYP = 3
      IBLKF = ABS(BLOCKD) + 0.1
      IF (IBLKF.LT.1) IBLKF = 10
      IF (IBLKF.GT.10) IBLKF = 10
      FDVEC(6) = IBLKF
      CALL TAPIO ('OPWT', FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
C                                       Advance to end-of-tape?
      IF (.NOT.DODISK) THEN
         IF (DOEOT.GT.0.0) THEN
            MSGTXT = 'Advancing tape to end-of-information'
            CALL MSGWRT (3)
            NP = 0
            CALL ZTAPE ('AEOI', FDVEC(1), FDVEC(40), NP, IERR)
            IF (IERR.NE.0) GO TO 975
            ANP = ABS (NP) - 1
            IF (NP.GT.0) WRITE (MSGTXT,1060) ANP
            IF (NP.LT.0) WRITE (MSGTXT,1061) ANP
            IF (NP.NE.0) CALL MSGWRT (3)
C                                       Make EOFs and correct position
         ELSE
            MSGTXT = 'Writing at current tape position'
            CALL MSGWRT (3)
            MSGTXT = 'Writing beginning-of-write EOFs'
            CALL MSGWRT (2)
            NP = 1
            CALL ZTAPE ('BEGW', FDVEC(1), FDVEC(40), NP, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1065) IERR
               GO TO 970
               END IF
            END IF
         END IF
C                                       Set some default values,
C                                       and global parameters.
      USER = NLUSER
      DLUN = 16
      ISEQ = SEQ4 + .5
      IBVOL = KVOL4 + .5
      IEVOL = IBVOL
      IF (IBVOL.EQ.0) THEN
         IBVOL = 1
         IEVOL = NVOL
         END IF
      GO TO 999
C
 970  CALL MSGWRT (8)
 975  CALL ZTPCLS (FDVEC(1), FDVEC(40), IERR)
      GO TO 995
C
 990  CALL MSGWRT (8)
 995  IRET = 16
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('COULD NOT GET PARMS.  IER=',I3)
 1010 FORMAT ('TAPES NOT AVAILABLE TO BATCH AIPS  ')
 1019 FORMAT ('Writing to disk file: ',A)
 1030 FORMAT ('Writing to tape drive number ',I3)
 1050 FORMAT ('COULD NOT OPEN OUTPUT FILE.  IER=',I4)
 1060 FORMAT ('Advanced to end-of-information after file',I5)
 1061 FORMAT ('Advanced to end-of-information after skipping',I6,
     *   ' files')
 1065 FORMAT ('ERROR',I6,' BEGINNING WRITES WITH EOFS')
      END
      SUBROUTINE FITSMP (ISLOT, KVOL, IERR)
C-----------------------------------------------------------------------
C   FITSMP calls the specific routines for translating an AIPS MAp
C   image to FITS format.
C   INPUTS:
C      ISLOT        I       Catalog slot number of map.
C      KVOL         I       Disk volume number.
C   COMMON /CFTP/
C      DOALL        R       < 0 (False) do first match, >= 0 (True)
C                           do every match.
C      NAME         C*12    Image designation (Name)
C      CLASS        C*6     Image designation (Class)
C      INSEQ        R       Image designation (Seq #)
C      INDISK       R       Inputs disk unit #
C      OUTTAPE      R       Output tape unit #
C   OUTPUT:
C      IERR         I       0=ok, 1=not ok.
C-----------------------------------------------------------------------
      INTEGER   KVOL, ISLOT, IERR
C
      INTEGER   I
      CHARACTER CHTMP*18
      REAL      NBLC(7), NTRC(7)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IFMTYP = ABS(TAMROF) + 0.5
      IF ((IFMTYP.LT.1) .OR. (IFMTYP.GT.4)) IFMTYP = 3
C                                       Tell user
      WRITE (MSGTXT,1000) USER, KVOL
      CALL H2CHR (18, 1, CATH(KHIMN), CHTMP)
      CALL NAMEST (CHTMP, CATBLK(KIIMS), MSGTXT(40:80), I)
      CALL MSGWRT (3)
      DO 5 I = 1,7
         NBLC(I) = 0.
         NTRC(I) = 0.
 5       CONTINUE
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), NBLC, NTRC, IERR)
C                                       Convert standard header to FITS
      CALL FITHCN (IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) 'BASIC FITS HEADER', IERR
         GO TO 960
         END IF
C                                       Copy header extra keywords
      CALL FITKEY (ISLOT, KVOL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) 'HEADER KEYWORDS', IERR
         GO TO 960
         END IF
C                                       Copy HI file, add AIPS HI
      CALL FTMAHI (ISLOT, KVOL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) 'HISTORY', IERR
         GO TO 960
         END IF
C                                       Write mapdata onto tape
      CALL FITDCN (NBLC, NTRC, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) 'BINARY IMAGE DATA', IERR
         GO TO 960
         END IF
C                                       Write ext files to tape
      CALL FITEXT (KVOL, ISLOT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) 'EXTENSION FILES', IERR
         CALL MSGWRT (6)
         END IF
C                                       Close Tape EOF
      MSGTXT = 'Writing end-of-file marks'
      CALL MSGWRT (2)
      CALL TAPIO ('FLSH', FDVEC, TAPBUF, TBIND, IERR)
      GO TO 999
C
C                                       Error return
 960  CALL MSGWRT (8)
      I = 1
      IF (.NOT.DODISK) CALL ZTAPE ('BAKF', FDVEC(1), FDVEC(40), I, IERR)
      CALL ZTPCLS (FDVEC(1), FDVEC(40), IERR)
      FDVEC(40) = 0
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Writing image: User',I5,'  Disk',I2,'  Name')
 1010 FORMAT ('ERROR WRITING ',A,':',I7)
      END
      SUBROUTINE FITHCN (IERR)
C-----------------------------------------------------------------------
C   FITHCN converts the standard map header into the FITS format and
C   writes this header on tape.
C   Outputs:
C      IERR   I          Error return: 0--> okay
C                        else  from IO routines
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      CHARACTER CHEXTN*8, TCOM*32, CHBLOK*8, BLKCOM*32, BCOM*32
      INTEGER   I, NWORDS, LBPX
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DKEY.INC'
      INCLUDE 'INCS:VKEY.INC'
      DATA CHEXTN /'EXTEND  '/
      DATA TCOM /'Tables following main image     '/
      DATA CHBLOK, BLKCOM /'BLOCKED ', 'Tape may be blocked      '/
C-----------------------------------------------------------------------
C                                       Initialize
      ICARD = 0
      BCOM = '          '
C                                       Save old header, insert new
      CATSCL = 1.0D0
      CATOFF = 0.0D0
      IF (IFMTYP.LT.3) THEN
         CATSCL = (CATR(KRDMX) - CATR(KRDMN)) / 65520.0D0
         CATOFF = (CATR(KRDMX) + CATR(KRDMN)) / 2.0D0
         IF (IFMTYP.EQ.2) CATSCL = CATSCL / 65520.0D0
      ELSE IF (IFMTYP.EQ.4) THEN
         CATSCL = (CATR(KRDMX) - CATR(KRDMN)) / 255.D0
         CATOFF = CATR(KRDMN)
         END IF
C                                       Required keywords
      CALL KEYWRD (RWORD(1), RTYPE(1), RPOINT(1), BCOM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       header no longer has bits/pix
      LBPX = 16 * IFMTYP
      IF (IFMTYP.EQ.3) LBPX = -32
      IF (IFMTYP.EQ.4) LBPX = 8
      CALL KEYWRD (RWORD(2), 10, LBPX, BCOM, IERR)
      IF (IERR.NE.0) GO TO 999
      NWORDS = 3 + CATBLK(KIDIM)
      DO 45 I = 3,NWORDS
         CALL KEYWRD (RWORD(I), RTYPE(I), RPOINT(I), BCOM, IERR)
         IF (IERR.NE.0) GO TO 999
 45      CONTINUE
C                                       New FITS extension/table file.
      CALL KEYWRD (CHEXTN, 1, 1, TCOM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       New FITS BLOCKED = T
      CALL KEYWRD (CHBLOK, 1, 1, BLKCOM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Normal keywords
      DO 50 I = 1,NNT
         CALL KEYWRD (NWORD(I), NTYPE(I), NPOINT(I), NCOM(I), IERR)
         IF (IERR.NE.0) GO TO 999
 50      CONTINUE
C                                       Axis keywords
      NWORDS = 5 * CATBLK(KIDIM)
      DO 65 I = 1,NWORDS
         CALL KEYWRD (AWORD(I), ATYPE(I), APOINT(I), BCOM, IERR)
         IF (IERR.NE.0) GO TO 999
 65      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE FITKEY (ISLOT, IVOL, IERR)
C-----------------------------------------------------------------------
C   FITKEY writes history records into FITS headers containing all of
C   the special keywords from the catalog header.  So that readers will
C   recognize them they go out in the form:
C   HISTORY AIPS HEADERi keyword = value / comment
C   where i is the keyword type code (1-5 => double precision, single
C   precision, character*8, integer, logical).
C   Inputs:
C      ISLOT   I      Map slot number
C      IVOL    I      Map disk number
C   Output:
C      IERR    I      Error code from IO routines.
C-----------------------------------------------------------------------
      INTEGER   IVOL, ISLOT, IERR
C
      INTEGER   MXKEYS
      PARAMETER (MXKEYS=500)
      INTEGER   LOCS(MXKEYS), KEYTS(MXKEYS), ITEMP, IKEY, IC, NUMKEY, I,
     *   ITRIM
      CHARACTER KEYWOR(MXKEYS)*8, HCOM*27, CARD*80, HKEY*19, LOGKEY*1,
     *   DATEST*12
      LOGICAL   LTEMP
      REAL      VALUES(MXKEYS), RTEMP(2)
      DOUBLE PRECISION DTEMP
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (DTEMP, RTEMP, LTEMP, ITEMP)
      DATA HCOM /'AIPS Catalog Header Keyword'/
      DATA HKEY /'HISTORY AIPS HEADER'/
C-----------------------------------------------------------------------
C                                       read all header keywords
      NUMKEY = MXKEYS
      CALL CATKEY ('ALL ', IVOL, ISLOT, KEYWOR, NUMKEY, LOCS,
     *   VALUES, KEYTS, BUFF, IERR)
C                                       If any keywords read
      IF (NUMKEY.GT.0) THEN
         DO 20 IKEY = 1,NUMKEY
C                                       Double precsion keyword
            IF (KEYTS(IKEY).EQ.1) THEN
               CALL RCOPY (NWDPDP, VALUES(LOCS(IKEY)), RTEMP)
               WRITE (CARD,1010) HKEY, KEYTS(IKEY), KEYWOR(IKEY), DTEMP,
     *            HCOM
C                                       Single precsion keyword
            ELSE IF (KEYTS(IKEY).EQ.2) THEN
               WRITE (CARD,1011) HKEY, KEYTS(IKEY), KEYWOR(IKEY),
     *            VALUES(LOCS(IKEY)), HCOM
C                                       Character keyword
            ELSE IF (KEYTS(IKEY).EQ.3) THEN
               CALL H2CHR (8, 1, VALUES(LOCS(IKEY)), DATEST)
               IF (INDEX(KEYWOR(IKEY), 'DATE').GT.0)
     *            CALL DATFST ('L2F', DATEST)
               I = MAX (8, ITRIM (DATEST))
               WRITE (CARD,1030) HKEY, KEYTS(IKEY), KEYWOR(IKEY),
     *            DATEST(:I), HCOM
C                                       Integer keyword
            ELSE IF (KEYTS(IKEY).EQ.4) THEN
               CALL RCOPY (1, VALUES(LOCS(IKEY)), RTEMP)
               WRITE (CARD,1040) HKEY, KEYTS(IKEY), KEYWOR(IKEY), ITEMP,
     *            HCOM
C                                       Logical keyword
            ELSE IF (KEYTS(IKEY).EQ.5) THEN
               CALL RCOPY (1, VALUES(LOCS(IKEY)), RTEMP)
               LOGKEY = 'F'
               IF (LTEMP) LOGKEY = 'T'
               WRITE (CARD,1050) HKEY, KEYTS(IKEY), KEYWOR(IKEY),
     *            LOGKEY, HCOM
C                                       shouldn't get here
            ELSE
               WRITE (MSGTXT,1000) IKEY, KEYTS(IKEY)
               CALL MSGWRT (6)
               GO TO 20
               END IF
C                                       Put card into buffer.
            IF (ICARD.GE.36) THEN
               CALL WRCTAP (IERR)
               IF (IERR.NE.0) GO TO 999
               END IF
            ICARD = ICARD + 1
C                                       Put card in buffer.
            IC = 80 * (ICARD - 1)  +  1
            CALL FITCHM (CARD, IC, FITBLK)
 20         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FITKEY: KEYWORD',I3,' STRANGE TYPE =',I5)
C1010 FORMAT (A,I1,2X,A8,' =',1PD19.11,' /',A)
 1010 FORMAT (A,I1,2X,A8,' =',1PE19.11,' /',A)
 1011 FORMAT (A,I1,2X,A8,' =',1PE17.9,' /',A)
 1030 FORMAT (A,I1,2X,A8,' = ''',A,'''',6X,' /',A)
 1040 FORMAT (A,I1,2X,A8,' =',I12,5X,' /',A)
 1050 FORMAT (A,I1,2X,A8,' = ',A1,15X,' /',A)
      END
      SUBROUTINE FTMAHI (ISLOT, IVOL, IERR)
C-----------------------------------------------------------------------
C   FTMAHI writes history records on map FITS headers by calling FITHIS
C   to copy the HI file and by adding special records re Clean.
C   Inputs:
C      ISLOT   I      Map slot number
C      IVOL    I      Map disk number
C   Output:
C      IERR    I      Error code from IO routines.
C-----------------------------------------------------------------------
      INTEGER   IVOL, ISLOT, IERR
C
      CHARACTER PRODS(5)*12
      INTEGER   I, J, IC, IL
      REAL      X, Y, Z
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA PRODS /'NORMAL      ', 'COMPONENTS  ',
     *   'RESIDUAL    ', 'POINTS      ', 'DIRTY MAP   '/
C-----------------------------------------------------------------------
C                                       Copy HI file + general AIPS
      CALL FITHIS (ISLOT, IVOL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Write MAp specific 'AIPS' HI
C                                       Clean parameters
C                                       Convert parameters
      X = CATR(KRBMJ)
      Y = CATR(KRBMN)
      Z = CATR(KRBPA)
      IF ((CATBLK(KINIT).GT.0) .OR. (X.GT.0.) .OR. (Y.GT.0.) .OR.
     *   (Z.NE.0.)) THEN
C                                       Clean beam
         IF (ICARD.GE.36) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 999
         ICARD = ICARD + 1
         IC = 80 * ICARD - 79
         WRITE (MSGTXT,1020) X, Y, Z
         CALL FITCHM (MSGTXT, IC, FITBLK)
C                                       Iterations, product
         IF (ICARD.GE.36) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 999
         ICARD = ICARD + 1
         IC = 80 * ICARD - 79
         I = MAX (1, MIN (4, CATBLK(KITYP)))
         J = I
         IF (CATBLK(KINIT).LE.0) I = 5
         IF (CATBLK(KINIT).LE.0) J = 0
         WRITE (MSGTXT,1025) CATBLK(KINIT), J, PRODS(I)
         CALL FITCHM (MSGTXT, IC, FITBLK)
         END IF
C                                       imaging type, xpoff, ypoff
      I = CATBLK(KIITY)
      IF ((I.EQ.1) .OR. (I.EQ.2)) THEN
         IF (ICARD.GE.36) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 999
         ICARD = ICARD + 1
         IC = 80 * ICARD - 79
         WRITE (MSGTXT,1030) I, CATR(KRXPO), CATR(KRYPO)
         CALL FITCHM (MSGTXT, IC, FITBLK)
         END IF
C                                       END card
      IF (ICARD.GE.36) CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 999
      IC = ICARD * 80 + 1
      MSGTXT = 'END     '
      CALL FITCHM (MSGTXT, IC, FITBLK)
C                                       Fill and Write record
      IL = 2880 - IC + 1
      IF (IL.GT.0) THEN
         LINE (IC:2880) = '                  '
         CALL ZCLC8 (IL, LINE(IC:2880), IC, FITBLK)
         END IF
      IL = 2880 / (NBITWD / 8)
      CALL COPY (IL, FITBLK, TAPBUF(TBIND))
      CALL TAPIO ('WRIT', FDVEC, TAPBUF, TBIND, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('HISTORY AIPS   CLEAN BMAJ=',1PE12.4,' BMIN=',1PE12.4,
     *   ' BPA=',0PF7.2)
 1025 FORMAT ('HISTORY AIPS   CLEAN NITER=',I9,' PRODUCT=',I1,3X,
     *   '/ ',A)
 1030 FORMAT ('HISTORY AIPS   IMAGE ITYPE=',I1,' XPOFF=',1PE16.8,
     *   ' YPOFF=',1PE16.8)
      END
      SUBROUTINE FITDCN (NBLC, NTRC, IER)
C-----------------------------------------------------------------------
C   FITDCN reads the standard map image data and writes the image on
C   tape in the 16-bit, binary FITS format.
C   Inputs:
C      NBLC     R(7)    Bottom left corner
C      NTRC     R(7)    Top right corner
C   Outputs:
C      IER   I     Error return
C                     0--> okay
C                     1--> error condition
C-----------------------------------------------------------------------
      INTEGER   IER
      REAL      NBLC(7), NTRC(7)
C
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   IERR, IWIN(4), NBKOF1, IOFF, NX, NY, IDEPTH(5), NBYB, I,
     *   INX, INY, IBL, NVAL, ININD, NXX, NXY, I3, I3A, I3B, I4, I4A,
     *   I4B, I5, I5A, I5B, I6, I6A, I6B, I7, I7A, I7B
      INTEGER   BUFFII(MAXIMG), FITBII(2880)
      REAL      BUFFRR(MAXIMG), FITBRR(2880)
      DOUBLE PRECISION BSC, BZE, NONZER, NZERO
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (BUFFII(1), BUFFRR(1))
      EQUIVALENCE (FITBLK(1), FITBII(1), FITBRR(1))
C-----------------------------------------------------------------------
C                                       Initialize
      NONZER = 0.0D0
      NZERO = 0.0D0
      IER = 0
      NBYB = UVBFSS * 2
      BSC = 1.0D0
      BZE = 0.0D0
      IF (CATSCL.GT.1.0E-30) THEN
         BSC = 1.0D0 / CATSCL
         BZE =  -CATOFF / CATSCL
         END IF
      NVAL = 720
      IF (IFMTYP.EQ.1) NVAL = 1440
      IF (IFMTYP.EQ.4) NVAL = 2880
      CALL FILL (2880, 0, FITBLK)
      MSGTXT = 'Now writing the image'
      CALL MSGWRT (3)
C                                       Set window parms
      I3A = NBLC(3) + 0.01
      I4A = NBLC(4) + 0.01
      I5A = NBLC(5) + 0.01
      I6A = NBLC(6) + 0.01
      I7A = NBLC(7) + 0.01
      I3B = NTRC(3) + 0.01
      I4B = NTRC(4) + 0.01
      I5B = NTRC(5) + 0.01
      I6B = NTRC(6) + 0.01
      I7B = NTRC(7) + 0.01
      IWIN(1) = NBLC(1) + 0.01
      IWIN(2) = NBLC(2) + 0.01
      IWIN(3) = NTRC(1) + 0.01
      IWIN(4) = NTRC(2) + 0.01
      NY = IWIN(4) - IWIN(2) + 1
      NX = IWIN(3) - IWIN(1) + 1
      INX = CATBLK(KINAX)
      INY = CATBLK(KINAX+1)
      IBL = 0
      DO 100 I7 = I7A,I7B
      DO 99  I6 = I6A,I6B
      DO 98  I5 = I5A,I5B
      DO 97  I4 = I4A,I4B
      DO 96  I3 = I3A,I3B
C                                       Initialize disk
         IDEPTH(1) = I3
         IDEPTH(2) = I4
         IDEPTH(3) = I5
         IDEPTH(4) = I6
         IDEPTH(5) = I7
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH, NBKOF1,
     *      IERR)
         IF (IERR.NE.0) GO TO 990
         NBKOF1 = NBKOF1 + 1
         CALL MINIT ('READ', DLUN, DIND, INX, INY, IWIN, BUFF, NBYB,
     *      NBKOF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR
            GO TO 980
            END IF
C                                       Begin read/write loop
         DO 90 I = 1,NY
C                                       Read a map line
            CALL MDISK ('READ', DLUN, DIND, BUFF, ININD, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1040) IERR,I
               GO TO 980
               END IF
            CALL FITSNC (NX, IFMTYP, BSC, BZE, BUFF(ININD), BUFFII,
     *         BUFFRR, NONZER, NZERO)
            NXY = NX
            IOFF = 1
 55         NXX = MIN (NXY, NVAL-IBL)
C                                       Need new buffer
            IF (NXX.LE.0) THEN
               CALL WRTAPE (IBL, IERR)
               IBL = 0
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1055) IERR
                  GO TO 980
               ELSE
                  GO TO 55
                  END IF
               END IF
C                                       Do copy
            IF (IFMTYP.NE.3) THEN
               CALL COPY (NXX, BUFFII(IOFF), FITBLK(1+IBL))
            ELSE
               CALL RCOPY (NXX, BUFFRR(IOFF), FITBRR(1+IBL))
               END IF
            IBL = IBL + NXX
            IOFF = IOFF + NXX
            NXY = NXY - NXX
            IF (NXY.GT.0) GO TO 55
 90         CONTINUE
 96      CONTINUE
 97      CONTINUE
 98      CONTINUE
 99      CONTINUE
 100     CONTINUE
C                                       Warning:
      IF (NZERO.GT.0.5D0) THEN
         NZERO = 100.0D0 * NZERO / (NZERO + NONZER)
         WRITE (MSGTXT,1100) NZERO
         IF (NZERO.GT.0.1D0) CALL MSGWRT (6)
         END IF
C                                       Write last record on tape
      IF (IBL.LE.0) GO TO 999
         CALL WRTAPE (IBL, IERR)
         IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1055) IERR
C
 980  CALL MSGWRT (8)
 990  IER = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('FITDCN: COULD NOT INITIALIZE MAP.  IER=',I4)
 1040 FORMAT ('FITDCN: COULD NOT READ MAP.  IER=',I3,' LINE=',I4)
 1055 FORMAT ('FITDCN: COULD NOT WRITE FITS RECORD.  IER=',I4)
 1100 FORMAT ('WARNING: ',F8.4,' per cent of pixels written as 0')
      END
      SUBROUTINE FITSNC (N, OTYPE, BSC, BZE, RIB, II, RR, NONZER,
     *   NZERO)
C-----------------------------------------------------------------------
C   FITSNC applies any scaling and offsets reqested.
C   Inputs:
C      N        I      Number of pixels
C      OTYPE    I      Type output buffer (I,   I,   R   1-3)
C      BSC      D      Multiply buffer by this
C      BZE      D      Then add this
C      RIB      R(N)   Floating in buffer
C   In/out:
C      NONZER   D      Count of non-zero outputs
C      NZERO    D      Count of 0 outputs
C   Out:
C      II       I(N)   Integer*2 buffer out (OTYPE=1)
C      RR       R(N)   Real*4 buffer out (OTYPE=3)
C-----------------------------------------------------------------------
      INTEGER   N, OTYPE, II(*)
      DOUBLE PRECISION BSC, BZE, NONZER, NZERO
      REAL      RIB(*), RR(*)
C
      DOUBLE PRECISION DTEMP
      INTEGER   MAGIC4, MAGIC1, I, MAGIC, IROUND
      REAL      TEMP
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
      MAGIC1 = 0
      MAGIC = -32768
      MAGIC4 = -2147483647 - 1
C                                       16 bit integer out
      IF (OTYPE.EQ.1) THEN
         DO 10 I = 1,N
            IF (RIB(I).NE.FBLANK) THEN
               TEMP = RIB(I) * BSC + BZE
               II(I) = IROUND (TEMP)
               IF (II(I).EQ.0) THEN
                  NZERO = NZERO + 1.0D0
               ELSE
                  NONZER = NONZER + 1.0D0
                  END IF
            ELSE
               II(I) = MAGIC
               END IF
 10         CONTINUE
C                                       32 bit integer out
      ELSE IF (OTYPE.EQ.2) THEN
         DO 20 I = 1,N
            IF (RIB(I).NE.FBLANK) THEN
               DTEMP = RIB(I) * BSC + BZE
               IF (DTEMP.GE.0.0D0) II(I) = DTEMP + 0.5D0
               IF (DTEMP.LT.0.0D0) II(I) = DTEMP - 0.5D0
               IF (II(I).EQ.0) THEN
                  NZERO = NZERO + 1.0D0
               ELSE
                  NONZER = NONZER + 1.0D0
                  END IF
            ELSE
               II(I) = MAGIC4
               END IF
 20         CONTINUE
C                                       Floating output
      ELSE IF (OTYPE.EQ.3) THEN
         DO 30 I = 1,N
            RR(I) = RIB(I)
 30         CONTINUE
C                                       32 bit integer out
      ELSE IF (OTYPE.EQ.4) THEN
         DO 40 I = 1,N
            IF (RIB(I).NE.FBLANK) THEN
               DTEMP = RIB(I) * BSC + BZE
               IF (DTEMP.GE.0.0D0) II(I) = DTEMP + 0.5D0
               IF (DTEMP.LT.0.0D0) II(I) = DTEMP - 0.5D0
               II(I) = MAX (0, MIN (255, II(I)))
               IF (II(I).EQ.0) THEN
                  NZERO = NZERO + 1.0D0
               ELSE
                  NONZER = NONZER + 1.0D0
                  END IF
            ELSE
               II(I) = MAGIC1
               END IF
 40         CONTINUE
         END IF
      GO TO 999
C
 999  RETURN
      END
      SUBROUTINE FITSUV (ISLOT, IVOL, IERR)
C-----------------------------------------------------------------------
C   This program will write a given UV data base to tape using the
C   FITS format.
C   Inputs:
C      ISLOT  I   Catalog slot number of UV data base.
C      IVOL   I   Disk volume no. of UV data base.
C      COMMON /INPARMS/
C   Outputs:
C      IERR    I   0=ok, 1=fatal error.
C-----------------------------------------------------------------------
      CHARACTER CHTMP*18
      INTEGER   ISLOT, IVOL, IERR, I, JERR
      DOUBLE PRECISION    SCVIS, SCRP(2,20), SCTIM1, SCTIM2, SCWT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      IBUFSZ = 2 * UVBFSS
      IFMTYP = ABS(TAMROF) + 0.5
      IF ((IFMTYP.LT.1) .OR. (IFMTYP.GT.4)) IFMTYP = 3
      IF (IFMTYP.NE.3) THEN
         IFMTYP = 3
         MSGTXT = 'FORMAT CHANGED TO IEEE - INTEGER INAPPROPRIATE FOR'
     *      // ' UV DATA'
         CALL MSGWRT (7)
         END IF
C                                       Tell user which map
      WRITE (MSGTXT,1000) USER, IVOL
      CALL H2CHR (18, 1, CATH(KHIMN), CHTMP)
      CALL NAMEST (CHTMP, CATBLK(KIIMS), MSGTXT(41:80), I)
      I = I + 40
      CALL MSGWRT (3)
C                                       Calculate scaling factors.
      CALL CALCSC (ISLOT, IVOL, SCTIM1, SCTIM2, SCRP, SCVIS, SCWT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Write header to tape.
      CALL FTUVHE (IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1021) IERR
         GO TO 980
         END IF
C                                       Writer extra header keywords
      CALL FITKEY (ISLOT, IVOL, IERR)
C                                       Write history to tape.
      CALL FTUVHI (ISLOT, IVOL, SCWT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         GO TO 980
         END IF
C                                       Write data to tape.
      MSGTXT = 'Now writing the uv data'
      CALL MSGWRT (3)
C                                       Compressed data
      IF (ISCMP) THEN
         CALL FTUVDC (SCRP, SCVIS, SCWT, IERR)
C                                       Normal data.
      ELSE
         CALL FTUVDA (SCRP, SCVIS, SCWT, IERR)
         END IF
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 980
         END IF
C                                       Write extension tables
      CALL FITEXT (IVOL, ISLOT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         CALL MSGWRT (8)
         END IF
C                                       End tape file
      MSGTXT = 'Writing end-of-file marks'
      CALL MSGWRT (2)
      CALL TAPIO ('FLSH', FDVEC, TAPBUF, TBIND, IERR)
      GO TO 999
C                                       Error after starting Tape write
 980  CALL MSGWRT (8)
      I = 1
      IF (.NOT.DODISK) CALL ZTAPE ('BAKF', FDVEC(1), FDVEC(40), I, JERR)
      IF (IERR.EQ.0) IERR = JERR
      CALL ZTPCLS (FDVEC(1), FDVEC(40), JERR)
      IF (IERR.EQ.0) IERR = JERR
      FDVEC(40) = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Writing UV data: User',I5,' Disk',I2,'  Name')
 1010 FORMAT ('ERROR FINDING UV SCALING:',I7)
 1021 FORMAT ('ERROR WRITING BASIC UV FITS HEADER:',I7)
 1030 FORMAT ('ERROR WRITING UV HISTORY TO FITS HEADER:',I7)
 1040 FORMAT ('ERROR WRITING UV BINARY DATA TO TAPE:',I7)
 1050 FORMAT ('ERROR WRITING ANTENNA TABLES ON TAPE:',I7)
      END
      SUBROUTINE CALCSC (ISLOT, IVOL, SCTIM1, SCTIM2, SCRP, SCVIS, SCWT,
     *   IERR)
C-----------------------------------------------------------------------
C   CALCSC will calculate the scaling factors to use when converting
C   uv data from the internal format to FITS tape format.
C   Inputs:
C      ISLOT   I     catalog number
C      IVOL    I     disk number
C      COMMON /INPARM/
C   Outputs:
C      SCTIM1  D     1st scaling factor to use for DATE.
C      SCTIM2  D     2nd scaling factor to use for DATE.
C      SCRP    D(2,20)   scaling factor random parameters.  The
C                      second index is for representing a random
C                      parameter as a double integer on tape.
C      OFFSCP  D(2,20)   Offset for random parameters.
C      SCVIS   D       scaling factor array values.
C      SCWT    D       scaling factor for complex-weights.
C      IERR    I   error code. 0=ok, 1=bad.
C      COMMON /MAPHDR/
C         CATBLK(KIPCN) add 1 if TIME1 changed to DATE
C         CATR(KRCIC+JLOCS) STOKES axis inc, change from -1 to 1.
C         CATD(KDCRV+JLOCS) STOKES value at ref pix. Change from -1 to 1
C      COMMON /MORPRM/
C         HSCAL  scaling factors for RP in tape header section.  These
C                are different than the ones we use to convert from our
C                internal format to tape values.
C         HZERO  offsets for RP on tape.
C         HNAME  names of RP on tape.
C         NUMCOR The number of correlator values to write to tape.
C-----------------------------------------------------------------------
      INTEGER   ISLOT, IVOL, IERR
      DOUBLE PRECISION SCTIM1, SCTIM2, SCRP(2,20), SCVIS, SCWT
C
      CHARACTER CHTM8*8
      DOUBLE PRECISION JDAY
      REAL      XMAXRP(20), XMAXVS, XMAXWT
      INTEGER   I, IPTR, ICTR, INO, INDEX, NANT, NVER
      LOGICAL   LBLK
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANS.INC'
C-----------------------------------------------------------------------
C                                       Find any "WEIGHT" axis
      ISCMP = CATBLK(KINAX).EQ.1
      CALL AXEFND (8, 'WEIGHT   ', CATBLK(KIPCN), CATH(KHPTP), KLOCWT,
     *   IERR)
C                                       Find location of parameters in
C                                       header.
      CALL UVPGET (IERR)
C                                       baseline conversion?
      CALL FNDEXT ('AN', CATBLK, NVER)
      DOBASL = (ILOCB.LT.0) .AND. (NVER.LT.90)
      IF ((DOBASL) .AND. (MAXANT.GT.255)) THEN
         NANT = 0
         CALL FNDEXT ('AN', CATBLK, NVER)
         DO 10 I = 1,NVER
            CALL GETANT (IVOL, ISLOT, I, CATBLK, BUFF, IERR)
            IF (IERR.EQ.0) NANT = MAX (NSTNS, NANT)
 10         CONTINUE
         IF (NANT.GT.255) DOBASL = .FALSE.
         END IF
C                                       Complex-3 has to be first axis
C                                       or else things get too
C                                       complicated.
      IF ((IERR.NE.0) .OR. (JLOCC.NE.0) .OR.
     *   (CATBLK(KINAX).GT.3) .OR. (CATBLK(KINAX).LT.1)) THEN
         WRITE (MSGTXT,1000)
         CALL MSGWRT (7)
         IERR = 10
         GO TO 999
         END IF
C                                       Init values
      CALL FNDEXT ('AN', CATBLK, ANTFIL)
      XMAXWT = 1.0
      XMAXVS = 1.0
      DO 15 I = 1,20
         XMAXRP(I) = 0.0
         IF (I.LE.NRPARM) XMAXRP(I) = 1.0
 15      CONTINUE
C                                       Blanking
      CATR(KRBLK) = 0.
      IF (LBLK) CATR(KRBLK) = FBLANK
C                                       Compressed data?
      IF (ISCMP) THEN
         CATBLK(KINAX)= 3
         NUMCOR = LREC - NRPARM
C                                       Remove excess random parms.
         IF ((KLOCWT+2).EQ.CATBLK(KIPCN)) THEN
            CATBLK(KIPCN) = KLOCWT
            NRPARM = CATBLK(KIPCN)
            END IF
         INDEX = KHPTP + 2 * KLOCWT
         CALL CHR2H (8, '        ', 1, CATH(INDEX))
         INDEX = INDEX + 2
         CALL CHR2H (8, '        ', 1, CATH(INDEX))
      ELSE
C                                       Regular data
         NUMCOR = (LREC - NRPARM) / CATBLK(KINAX)
         END IF
C                                       Set scaling factors.
      SCWT = 1.0D0
      SCVIS = 1.0D0
      CATSCL = 1.0D0 / SCVIS
C                                       Calculate scaling factor for
C                                       writing to tape and for header
C                                       values.
      DO 35 I = 1,20
         SCRP(1,I) = 1.0D0
         SCRP(2,I) = 0.D0
         HSCAL(1,I) = 1.0D0 / SCRP(1,I)
         HSCAL(2,I) = 0.0D0
         HZERO(1,I) = 0.0D0
         HZERO(2,I) = 0.0D0
         IFLAG(I) = 1
         HNAME(I) = ' '
 35      CONTINUE
      DO 36 I = 1,KIPTPN
         CALL H2CHR (8, 1, CATH(KHPTP+(I-1)*2), HNAME(I))
 36      CONTINUE
C                                       Set special scaling factors
C                                       that allow for conversion from
C                                       internal format to FITS format.
      IF ((ILOCU.GE.0).AND.(TYPUVD.LE.0)) THEN
         IPTR = ILOCU  +  1
         HSCAL(1,IPTR) = HSCAL(1,IPTR) / FREQ
         HSCAL(2,IPTR) = HSCAL(2,IPTR) / FREQ
         HNAME(IPTR)(3:4) = '--'
         END IF
      IF ((ILOCV.GE.0).AND.(TYPUVD.LE.0)) THEN
         IPTR = ILOCV + 1
         HSCAL(1,IPTR) = HSCAL(1,IPTR) / FREQ
         HSCAL(2,IPTR) = HSCAL(2,IPTR) / FREQ
         HNAME(IPTR)(3:4) = '--'
         END IF
      IF ((ILOCW.GE.0).AND.(TYPUVD.LE.0)) THEN
         IPTR = ILOCW  +  1
         HSCAL(1,IPTR) = HSCAL(1,IPTR) / FREQ
         HSCAL(2,IPTR) = HSCAL(2,IPTR) / FREQ
         HNAME(IPTR)(3:4) = '--'
         END IF
      IF (ILOCB.GE.0) THEN
         IPTR = ILOCB + 1
         HSCAL(1,IPTR) = 1.0D0
         SCRP(1,IPTR) = 1.0D0
         IFLAG(IPTR) = 1
      ELSE IF (ILOCSA.GE.0) THEN
         IPTR = ILOCSA + 1
         HSCAL(1,IPTR) = 1.0D0
         SCRP(1,IPTR) = 1.0D0
         IFLAG(IPTR) = 1
         IF (DOBASL) THEN
            HNAME(IPTR) = 'BASELINE'
            IPTR = ILOCA1 + 1
            IFLAG(IPTR) = 0
            IPTR = ILOCA2 + 1
            IFLAG(IPTR) = 0
            END IF
         END IF
C                                       Convert TIME1 to two value DATE
      IF (ILOCT.EQ.-1) GO TO 999
         IPTR = ILOCT  +  1
         SCTIM1 = 1.0D0
         SCTIM2 = 1.0D0
         IFLAG(IPTR) = 2
         HNAME(IPTR) = 'DATE'
         HSCAL(1,IPTR) = SCTIM1
         CALL H2CHR (8, 1, CATH(KHDOB), CHTM8)
         CALL JULDAY (CHTM8, JDAY)
         HZERO(1,IPTR) = JDAY
         HSCAL(2,IPTR) = SCTIM2
         HZERO(2,IPTR) = 0.0D0
         SCRP(1,IPTR) = 1.0D0 / SCTIM1
         SCRP(2,IPTR) = 1.0D0 / SCTIM2
C                                       Count up number of RP we have.
         ICTR = 0
         INO = CATBLK(KIPCN)
         DO 600 I = 1,INO
            ICTR = ICTR + IFLAG(I)
 600        CONTINUE
         CATBLK(KIPCN) = ICTR
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DATA SET NOT STANDARD ENOUGH FOR ME')
      END
      SUBROUTINE FTUVHE (IERR)
C-----------------------------------------------------------------------
C   FTUVHE causes standard UV FITS header records to be written on tape.
C   Inputs:
C      COMMON /INPARMS/
C      COMMON /MORPRM/
C   Outputs:  (first 4 in Common)
C      ICARD   I   Card number in current tape buffer (FITBLK).
C      FITBLK  I(2880)   FITS header block work area
C      TAPBUF  I(*)      TAPIO buffers
C      TBIND   I   TAPBUF(TBIND) is the start of the current tape
C                  buffer containing the next block of data to be
C                  written to tape.
C      IERR    I   error code. 0=ok, 1=error.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      CHARACTER CTABLS(2)*2, TCOM*32, ZCOM*32, CHEXTN*8, CHBLOK*8,
     *   BLKCOM*32, COMARR(15)*32, CHTM12*12, BCOM*32, TEMP*8, XWORD*8,
     *   TSTLBL(13)*8
      INTEGER   I, NWORDS, NTABLS, J, XXTYPE(3), XPOINT(3), K, II, INO,
     *   IIII, III, IOFF, IPNT, LBPX, NUMCOM, COMPNT(13), COMNDX,
     *   COMLOP, INDEX
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DKEY.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:VKEY.INC'
      DATA NTABLS, CTABLS /2, 'AN','CH'/
      DATA XXTYPE /8, 6, 7/, XPOINT /8000, 4000, 4000/
      DATA TCOM /'This is the antenna file        '/
      DATA ZCOM /'No standard image just group    '/
      DATA CHEXTN /'EXTEND  '/
      DATA CHBLOK, BLKCOM /'BLOCKED ', 'Tape may be blocked        '/
      DATA NUMCOM /13/
      DATA TSTLBL /
     *   'COMPLEX ', 'STOKES  ', 'FREQ    ',
     *   'IF      ', 'RA      ', 'DEC     ',
     *   'UU-L    ', 'VV-L    ', 'WW-L    ',
     *   'TIME1   ', 'BASELINE', 'SOURCE  ',
     *   'FRQSEL  '/
      DATA COMPNT /2,3,5,6,7,8,9,10,11,12,13,14,15/
      DATA COMARR /'                                ',
     *   '1=real,2=imag,3=weight          ',
     *   '1=I, 2=Q, 3=U, 4=V              ',
     *   '-1=RR, -2=LL, -3=RL, -4=LR      ',
     *   'Frequency in Hz.                ',
     *   'Freq. group no. in CH table     ',
     *   'Right Ascension in deg.         ',
     *   'Declination in deg.             ',
     *   'U baseline component in sec.    ',
     *   'V baseline component in sec.    ',
     *   'W baseline component in sec.    ',
     *   'Time of vis. as Julian date     ',
     *   '256*ant1+ant2+(array#-1)/100    ',
     *   'Source id. in SU table          ',
     *   'Frequency id. in FQ table       ' /
C-----------------------------------------------------------------------
      ICARD = 0
      BCOM = ' '
C                                       Encode required keywords.
      CALL KEYWRD (RWORD(1), RTYPE(1), RPOINT(1), BCOM, IERR)
      IF (IERR.NE.0) GO TO 999
      LBPX = -32
      CALL KEYWRD (RWORD(2), 10, LBPX, BCOM, IERR)
      IF (IERR.NE.0) GO TO 999
      NWORDS = 1 + CATBLK(KIDIM)
      CALL KEYWRD (RWORD(3), 10, NWORDS, BCOM, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL KEYWRD (RWORD(4), 10, 0, ZCOM, IERR)
      IF (IERR.NE.0) GO TO 999
      NWORDS = 3 + CATBLK(KIDIM)
      DO 10 I = 4,NWORDS
         CALL KEYWRD (RWORD(I+1), RTYPE(I), RPOINT(I), BCOM, IERR)
         IF (IERR.NE.0) GO TO 999
 10      CONTINUE
C                                       Determine if ANtenna ext file
C                                       exists.
      TABLES = 0
      IF (NTABLS.GT.0) THEN
         DO 15 I = 1,NTABLS
            CALL FNDEXT (CTABLS(I), CATBLK, J)
            TABLES = TABLES + J
 15         CONTINUE
         END IF
C                                       Always write AN files if extant
      CALL KEYWRD (CHEXTN, 1, 1, TCOM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       New FITS BLOCKED = T
      CALL KEYWRD (CHBLOK, 1, 1, BLKCOM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Encode normal keywords.
      NWORDS = NNT - 2
      DO 20 I = 1,NWORDS
         CALL KEYWRD (NWORD(I), NTYPE(I), NPOINT(I), NCOM(I), IERR)
         IF (IERR.NE.0) GO TO 999
 20      CONTINUE
C                                       Encode axis keywords.
      NWORDS = 5 * CATBLK(KIDIM)
      DO 50 I = 1,NWORDS
C                                       Find comment for label
         INDEX = ((I-1) / 5) * 2 + KHCTP
         COMNDX = 1
         IF (MOD(I, 5) .EQ. 1) THEN
            DO 45 COMLOP = 1,6
               CALL H2CHR (8, 1, CATH(INDEX), CHTM12)
               IF (TSTLBL(COMLOP)(1:8).EQ. CHTM12(1:8))
     *            COMNDX = COMPNT(COMLOP)
 45            CONTINUE
C                                       Correct Stokes' label if nec.
            IF ((COMNDX.EQ.3) .AND. (ICOR0.LT.0)) COMNDX = 4
            END IF
         CALL KEYWRD (AWORD(I+5), ATYPE(I), APOINT(I),
     *      COMARR(COMNDX), IERR)
         IF (IERR.NE.0) GO TO 999
 50      CONTINUE
C                                       Encode GROUP, GCOUNT, PCOUNT.
      DO 60 I = 1,3
         CALL KEYWRD (GWORD(I), GTYPE(I), GPOINT(I), BCOM, IERR)
 60      CONTINUE
C                                       Encode random parameter keywrd.
      I = 0
      K = 0
C                                       Loop for all random parms.
      DO 90 II = 1,NRPARM
C                                       Find comment for label
         INDEX = (II - 1) * 2 + KHPTP
         COMNDX = 1
         CALL H2CHR (8, 1, CATH(INDEX), CHTM12)
         DO 62 COMLOP = 7,NUMCOM
            IF (TSTLBL(COMLOP)(1:4).EQ.CHTM12(1:4)) COMNDX =
     *         COMPNT(COMLOP)
 62         CONTINUE
C                                       Projected RA, Dec
         IF (TSTLBL(5)(1:2).EQ.CHTM12(1:2)) COMNDX = COMPNT(5)
         IF (TSTLBL(6)(1:3).EQ.CHTM12(1:3)) COMNDX = COMPNT(6)
C                                       Sometimes we loop twice for
C                                       double integer or not at all
C                                       for ANTENNA1/2
         INO = IFLAG(II)
C                                       count RP even if omitted
         K = K + 1
         DO 80 IIII = 1,INO
            IOFF = 100 * IIII
            I = I + 1
C                                       Loop for NAME, SCALE, OFFSET
            DO 70 III = 1,3
               IPNT = XPOINT(III) + IOFF + K
               IF (I.LT.10) THEN
                  IF (III.EQ.1) WRITE (TEMP,1060) I
                  IF (III.EQ.2) WRITE (TEMP,1062) I
                  IF (III.EQ.3) WRITE (TEMP,1064) I
               ELSE
                  IF (III.EQ.1) WRITE (TEMP,1065) I
                  IF (III.EQ.2) WRITE (TEMP,1066) I
                  IF (III.EQ.3) WRITE (TEMP,1068) I
                  END IF
               XWORD(1:8) = TEMP(1:8)
               CALL KEYWRD (XWORD, XXTYPE(III), IPNT, COMARR(COMNDX),
     *            IERR)
               COMNDX = 1
 70            CONTINUE
 80         CONTINUE
         IF (IERR.NE.0) GO TO 999
 90      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1060 FORMAT ('PTYPE',I1)
 1062 FORMAT ('PSCAL',I1)
 1064 FORMAT ('PZERO',I1)
 1065 FORMAT ('PTYPE',I2)
 1066 FORMAT ('PSCAL',I2)
 1068 FORMAT ('PZERO',I2)
      END
      SUBROUTINE KEYWRD (WORD, ITYPE, POINT, COMENT, IERR)
C-----------------------------------------------------------------------
C   This routine will encode a given keyword and the corresponding
C   value in the header into the FITS card format and put that card
C   into the tape output buffer.  If that buffer is full, the output
C   buffer will be written to tape.
C   INPUTS:
C      WORD    C*8     FITS keyword (characters).
C      ITYPE   I        data type of header value.
C                           1=Logical variable
C                           2=Number
C                           3=String on real boundary
C                           4=String on integer boundary
C                           5=image scaling parms
C                           6=Rand parm scalling factors.
C                           7=Rand parm offsets.
C                           8=Rand parm names.
C                           9=blanking value.
C                          10=value = pointer.
C                          11=NUMERIC, omit if zero.
C      POINT   I        'pointer code' of the header value, i.e. 1000 *
C                       length in bytes + 100 * offset into the header +
C                       position of pointer in common HDRVAL.
C      COMENT  C*32     comment for this card.
C      COMMON /MAPHDR/
C      COMMON /HDRVAL/
C      COMMON /MORPRM/
C   IN/OUT: (In common)
C      ICARD   I         last card in the buffer FITBLK (0-36).
C      TBIND   I         Starting word of current buffer in FITBLK.
C      FITBLK  I(2880)   output work buffer.
C      TAPBUF  I(*)      TAPIO buffers
C   OUTPUT:
C      IERR    I         error code. 0=ok, 1=bad.
C-----------------------------------------------------------------------
      CHARACTER WORD*8, COMENT*32, CARD*80, STR*12
      INTEGER   ITYPE, POINT, IERR
      INTEGER   KPNTR(58), PNTR, POFF, NBYT, ISTART, IC, ITEND, ITRIM
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (KPNTR, KHOBJ)
C-----------------------------------------------------------------------
C                                       Decode POINT.
      IERR = 0
      IF ((ITYPE.LT.1) .OR. (ITYPE.GT.11)) GO TO 999
      PNTR = MOD (POINT, 1000)
      POFF = PNTR / 100
      PNTR = MOD (PNTR, 100)
      IF (PNTR.GT.0) PNTR = KPNTR(PNTR)
      NBYT = POINT / 1000
C                                       Go to appropiate data type.
C                                       Special cases start at label
C                                       600.
      GO TO (100, 200, 300, 400, 500, 600, 610, 620, 630, 640,
     *   200), ITYPE
C                                       Logical (always true so far)
 100     WRITE (CARD,1100) WORD, COMENT
         GO TO 800
C                                       Numeric.
C                                       Integer.
 200     IF (NBYT.NE.2) GO TO 210
            IF ((ITYPE.EQ.11) .AND. (CATBLK(PNTR+POFF).EQ.0)) GO TO 999
            WRITE (CARD,1200) WORD, CATBLK(PNTR+POFF), COMENT
            GO TO 800
C                                       Real
 210     IF (NBYT.NE.4) GO TO 220
            IF ((ITYPE.EQ.11) .AND. (CATR(PNTR+POFF).EQ.0.0)) GO TO 999
            WRITE (CARD,1210) WORD, CATR(PNTR+POFF), COMENT
            GO TO 800
C                                       Double precision
 220        IF ((ITYPE.EQ.11) .AND. (CATD(PNTR+POFF).EQ.0.0D0))
     *         GO TO 999
            WRITE (CARD,1220) WORD, CATD(PNTR+POFF), COMENT
            GO TO 800
C                                       Character on real boundary.
 300        WRITE (CARD,1300) WORD, COMENT
C                                       Dates are special
            IF (WORD(:4).EQ.'DATE') THEN
               ISTART = NBYT * POFF  +  1
               STR  = ' '
               CALL H2CHR (NBYT, ISTART, CATH(PNTR), STR)
               CALL DATFST ('L2F', STR)
               NBYT = ITRIM (STR)
               CARD(12:11+NBYT) = STR(:NBYT)
            ELSE
               ISTART = NBYT * POFF  +  1
               CALL H2CHR (NBYT, ISTART, CATH(PNTR), CARD(12:11+NBYT))
               END IF
            ITEND = NBYT + 12
            CARD(ITEND:ITEND) = ''''
            GO TO 800
C                                       Character on integer boundary.
 400        WRITE (CARD,1300) WORD, COMENT
            ITEND = NBYT + 12
            ISTART = NBYT * POFF  +  1
            CALL H2CHR (NBYT, ISTART, CATH(PNTR), CARD(12:11+NBYT))
            CARD(ITEND:) = ''''
            GO TO 800
C                                       Image scaling parameter.
 500        IF (WORD.EQ.'BSCALE') WRITE (CARD,1220) WORD, CATSCL, COMENT
            IF (WORD.EQ.'BZERO') WRITE (CARD,1220) WORD, CATOFF, COMENT
            GO TO 800
C                                       Get scaling factors from
C                                       common MORPRM.
 600        PNTR = MOD (POINT, 100)
            WRITE (CARD,1220) WORD, HSCAL(POFF,PNTR), COMENT
            GO TO 800
C                                       Get offsets from MORPRM.
 610        PNTR = MOD (POINT, 100)
            WRITE (CARD,1220) WORD, HZERO(POFF,PNTR), COMENT
            GO TO 800
C                                       Get RP type from MORPRM
 620        PNTR = MOD (POINT, 100)
            WRITE (CARD,1300) WORD, COMENT
            ITEND = NBYT + 12
            CARD(12:11+NBYT) = HNAME(PNTR)(1:NBYT)
            CARD(ITEND:) = ''' '
            GO TO 800
C                                       Blanking
 630        IF (CATR(PNTR+POFF).EQ.0) GO TO 999
C                                       do not write BLANK for f.p.
            IF (IFMTYP.EQ.1) WRITE (CARD,1630) WORD
            IF (IFMTYP.EQ.2) WRITE (CARD,1631) WORD
            IF (IFMTYP.EQ.3) WRITE (CARD,1632)
            GO TO 800
C                                       Value given by POINT.
 640        WRITE (CARD,1200) WORD, POINT, COMENT
C                                       Put card into buffer.
 800  IF (ICARD.GE.36) CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 999
      ICARD = ICARD + 1
C                                       Put card in buffer.
      IC = 80 * (ICARD - 1)  +  1
      CALL FITCHM (CARD, IC, FITBLK)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT (A8,'= ',19X,'T /',A)
 1200 FORMAT (A8,'= ',I20,' /',A)
 1210 FORMAT (A8,'= ',1PE20.9,' /',A)
 1220 FORMAT (A8,'= ',1PE20.11,' /',A)
 1300 FORMAT (A8,'= ''',19X,' /',A)
 1630 FORMAT (A8,'= ',14X,'-32768 / Blanked pixel tape value')
 1631 FORMAT (A8,'= ',9X,'-2147483648 / Blanked pixel tape value')
 1632 FORMAT ('COMMENT / IEEE not-a-number used for blanked',
     *   ' f.p. pixels')
      END
      SUBROUTINE FTUVHI (ISLOT, IVOL, SCWT, IERR)
C-----------------------------------------------------------------------
C   This routine will write the non UV data base specific history by
C   calling FITHIS.  Then the UV data history and the END card are
C   written to the FITS header.
C   INPUTS:
C      ISLOT   I         catalog slot number of the UV file.
C   In/out: (in common)
C      ICARD   I         The last card written in FITBLK  (1:36)
C      TBIND   I         the start of the current I/O buffer.
C      TAPBUF  I(*)      The TAPIO buffers
C      FITBLK  I(*)      The FITS header work buffer
C   Output:
C      IERR    I         error code. 0=ok, 1 = bad
C-----------------------------------------------------------------------
      CHARACTER SRTYPS(3)*4, EXPL(11)*12, CHTM2*2
      DOUBLE PRECISION    SCWT, WTSCAL
      INTEGER   ISLOT, IVOL, IERR
      INTEGER   IC, IL, I, J1, J2, J, NTYPS
      REAL      X, Y, Z
      LOGICAL   EQUAL
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA NTYPS, SRTYPS /11, 'BTUV','WRPX','YZM '/
      DATA EXPL /'BASELINE NUM', 'TIME (IAT)  ',
     *           'U VIS. COORD', 'V VIS. COORD',
     *           'W VIS. COORD', 'BASELINE LEN',
     *           'BASELINE PA ', 'DESC ABS(U) ',
     *           'DESC ABS(V) ', 'ASCE ABS(U) ',
     *           'ASCE ABS(V) '/
C-----------------------------------------------------------------------
C                                       Beam parameters
      X = CATR(KRBMJ)
      Y = CATR(KRBMN)
      Z = CATR(KRBPA)
      IF ((X.GT.0.) .OR. (Y.GT.0.) .OR. (Z.NE.0.)) THEN
         IF (ICARD.GE.36) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 999
         ICARD = ICARD + 1
         IC = 80 * ICARD - 79
         WRITE (MSGTXT,1000) X, Y, Z
         CALL FITCHM (MSGTXT, IC, FITBLK)
         END IF
C                                       Explain baseline number
      IF (ICARD.GE.36) CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 999
      ICARD = ICARD + 1
      IC = 80 * ICARD - 79
      WRITE (MSGTXT,1010)
      CALL FITCHM (MSGTXT, IC, FITBLK)
C                                       Write general history info.
      CALL FITHIS (ISLOT, IVOL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Write UV specific stuff.
C                                       Sort order:
      IF (ICARD.GE.36) CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 999
      ICARD = ICARD + 1
      IC = 80 * ICARD  -  79
      WRITE (MSGTXT,1011) CATBLK(KITYP)
      CALL FITCHM (MSGTXT, IC, FITBLK)
C                                       Explain this mess
      CALL H2CHR (2, 1, CATH(KITYP), CHTM2)
      DO 30 I = 1,2
         DO 10 J = 1,NTYPS
            J1 = MOD (J-1, 4) + 1
            J2 = (J-1) / 4 + 1
            EQUAL = CHTM2(I:I) .EQ. SRTYPS(J2)(J1:J1)
            IF (EQUAL) GO TO 20
 10         CONTINUE
         GO TO 30
 20      IF (ICARD.GE.36) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 999
         ICARD = ICARD + 1
         IC = ICARD * 80 - 79
         WRITE (MSGTXT,1020) CHTM2(I:I), EXPL(J)
         CALL FITCHM (MSGTXT, IC, FITBLK)
 30      CONTINUE
C                                       Scale factor for weights
         IF (ICARD.GE.36) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 999
         ICARD = ICARD + 1
         IC = ICARD * 80 - 79
         WTSCAL = 1.0D0 / SCWT
         WRITE (MSGTXT,1030) WTSCAL
         CALL FITCHM (MSGTXT, IC, FITBLK)
C                                       Put END card in buffer.
      IF (ICARD.GE.36) CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 999
      IC = 80 * ICARD + 1
      MSGTXT = 'END     '
      CALL FITCHM (MSGTXT, IC, FITBLK)
      IL = 2880 - IC + 1
      IF (IL.GT.0) THEN
         LINE (IC:2880) = '                  '
         CALL ZCLC8 (IL, LINE(IC:2880), IC, FITBLK)
         END IF
      IL = 2880 / (NBITWD / 8)
      CALL COPY (IL, FITBLK, TAPBUF(TBIND))
      CALL TAPIO ('WRIT', FDVEC, TAPBUF, TBIND, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('HISTORY AIPS   BMAJ=',1PE12.4,' BMIN=',1PE12.4,
     *   ' BPA=',0PF7.2)
 1010 FORMAT (9X,'/ Where baseline = 256*ant1 + ant2 + (array#-1)/100')
 1011 FORMAT ('HISTORY AIPS   SORT ORDER = ''',A2,'''')
 1020 FORMAT (14X,'/ Where ',A1,' means ',A)
C1030 FORMAT ('HISTORY AIPS WTSCAL = ', 1PD18.11, 1X,
 1030 FORMAT ('HISTORY AIPS WTSCAL = ', 1PE18.11, 1X,
     *   '/ CMPLX WTS=WTSCAL*(TAPE*BSCALE+BZERO)')
      END
      SUBROUTINE FTUVDA (SCRP, SCVIS, SCWT, IERR)
C-----------------------------------------------------------------------
C  Writes FITS format uv data to the output file.
C   Inputs:
C     SCRP    D(2,20)   scaling factors for random parameters.
C     SCVIS   D   scaling factor array values.
C     SCWT    D   scaling factor for complex.weight.  If this is minus,
C                 it is a secret code indicating that the complex
C                 values are complex 2 not complex 3 (ie no weight).
C   In/out: (in common)
C      FITBLK  I(2880)    Header work buffer
C      TAPBUF  I(*)       TAPIO work buffers
C   Output:
C      IERR    I          Error code, 0 => OK
C                             8 => I/O error.
C-----------------------------------------------------------------------
      INTEGER   IERR
      DOUBLE PRECISION SCRP(2,20), SCVIS, SCWT, TAPVR8
      REAL      TAPVAL, RXCNT, FITBR4(1440)
      INTEGER   VO, BO, BIND, LENBU, NIO, I, J, K, IOFF, IPTR, ITMAX,
     *   ITPOS, NCHAN, NVALS, JJ, NCMPLX
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (FITBLK, FITBR4)
      DATA VO, BO /0, 1/
C-----------------------------------------------------------------------
      NCMPLX = 3
      IF (SCWT.LT.0.0D0) NCMPLX = 2
      NCHAN = CATBLK(KINAX+JLOCF)
      NVALS = NUMCOR
C                                       Initialize buffer pointers
      ITPOS = 0
      ITMAX = 720
      RXCNT = 0.0
C                                       Init disk IO.
      LENBU = 0
      CALL UVINIT ('READ', DLUN, DIND, NVIS, VO, LREC, LENBU, IBUFSZ,
     *   BUFF, BO, BIND, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Loop thru disk file.
 10      RXCNT = RXCNT + 1.0
         CALL UVDISK ('READ', DLUN, DIND, BUFF, NIO, BIND, IERR)
         IF (IERR.NE.0) GO TO 999
         IPTR = BIND
C                                       Check if data finished.
         IF (NIO.LE.0) GO TO 300
            DO 290 J = 1,NIO
C                                       Real*4 output
C                                       Loop through random parms.
               DO 230 I = 1,NRPARM
                  IF (IFLAG(I).GT.0) THEN
                     K = I - 1
                     IF ((DOBASL) .AND. (K.EQ.ILOCSA)) THEN
                        TAPVR8 = 256.0*BUFF(IPTR+ILOCA1) +
     *                     BUFF(IPTR+ILOCA2) + (BUFF(IPTR+ILOCSA)-1.)
     *                     /100.
                     ELSE
                        TAPVR8 = SCRP(1,I) * BUFF(IPTR+K)
                        END IF
                     ITPOS = ITPOS + 1
C                                       Write buffer to tape.
                     IF (ITPOS.GT.ITMAX) THEN
                        CALL WRTAUV (ITMAX, IERR)
                        ITPOS = 1
                        IF (IERR.NE.0) GO TO 999
                        END IF
                     IF (IFLAG(I).EQ.2) THEN
                        FITBR4(ITPOS) = TAPVR8
                        TAPVR8 = BUFF(IPTR+K) - (FITBR4(ITPOS) /
     *                     SCRP(1,I))
                        TAPVR8 =  TAPVR8 * SCRP(2,I)
                        ITPOS = ITPOS + 1
                        IF (ITPOS.GT.ITMAX) THEN
                           CALL WRTAUV (ITMAX, IERR)
                           ITPOS = 1
                           IF (IERR.NE.0) GO TO 999
                           END IF
                        END IF
                     FITBR4(ITPOS) = TAPVR8
                     END IF
 230              CONTINUE
C                                       Group array values.
               IOFF = IPTR + NRPARM - 1
C                                       No conversion
               DO 250 I = 1,NVALS
                  DO 245 JJ = 1,NCMPLX
                     IOFF = IOFF + 1
                     TAPVAL = SCVIS * BUFF(IOFF)
                     ITPOS = ITPOS + 1
                     IF (ITPOS.GT.ITMAX) THEN
                        CALL WRTAUV (ITMAX, IERR)
                        ITPOS = 1
                        IF (IERR.NE.0) GO TO 999
                        END IF
                     FITBR4(ITPOS) = TAPVAL
 245                 CONTINUE
 250              CONTINUE
C                                       Incr address, loop
               IPTR = IPTR + LREC
 290           CONTINUE
            GO TO 10
C                                       Write last buffer.
 300  CALL WRTAUV (ITPOS, IERR)
C
 999  RETURN
      END
      SUBROUTINE FTUVDC (SCRP, SCVIS, SCWT, IERR)
C-----------------------------------------------------------------------
C  Writes FITS format uv data to the output file from compressed data.
C   Inputs:
C     SCRP    D(2,20)   scaling factors for random parameters.
C     SCVIS   D   scaling factor array values.
C     SCWT    D   scaling factor for complex.weight.  If this is minus,
C                 it is a secret code indicating that the complex
C                 values are complex 2 not complex 3 (ie no weight).
C   In/out: (in common)
C      FITBLK  I(2880)    Header work buffer
C      TAPBUF  I(*)       TAPIO work buffers
C   Output:
C      IERR    I          Error code, 0 => OK
C                             8 => I/O error.
C-----------------------------------------------------------------------
      INTEGER   IERR
      DOUBLE PRECISION SCRP(2,20), SCVIS, SCWT, TAPVR8
      REAL      TAPVAL, SCLDAT(3), RXCNT, FITBR4(1440), MAGICR
      INTEGER   VO, BO, BIND, LENBU, NIO, I, J, K, IOFF, IPTR, ITMAX,
     *   ITPOS, NCHAN, NVALS, JJ, KINCS
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (FITBLK, FITBR4)
      DATA VO, BO /0, 1/
C-----------------------------------------------------------------------
C                                       Compiler bug workaround
      MAGICR = FBLANK
      NCHAN = CATBLK(KINAX+JLOCF)
      NVALS = NUMCOR
      KINCS = INCS * 3
C                                       Initialize buffer pointers
      ITPOS = 0
      ITMAX = 720
      RXCNT = 0.0
C                                       Init disk IO.
      LENBU = 0
      SCLDAT(1) = SCVIS
      SCLDAT(2) = SCVIS
      SCLDAT(3) = SCVIS * SCWT
      CALL UVINIT ('READ', DLUN, DIND, NVIS, VO, LREC, LENBU, IBUFSZ,
     *   BUFF, BO, BIND, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Loop thru disk file.
 10      RXCNT = RXCNT + 1.0
         CALL UVDISK ('READ', DLUN, DIND, BUFF, NIO, BIND, IERR)
         IF (IERR.NE.0) GO TO 999
         IPTR = BIND
C                                       Check if data finished.
         IF (NIO.LE.0) GO TO 300
            DO 290 J = 1,NIO
C                                       Decompress data.
C                                       If NRPARM=KLOCWT then there are
C                                       WEIGHT and SCALE parameters at
C                                       the end of the random parameter
C                                       list which are not included in
C                                       NRPARM.
               IF (NRPARM.EQ.KLOCWT) THEN
                  CALL ZUVXPN (NVALS, BUFF(IPTR+NRPARM+2),
     *               BUFF(IPTR+KLOCWT), TBUFF)
               ELSE
                  CALL ZUVXPN (NVALS, BUFF(IPTR+NRPARM),
     *               BUFF(IPTR+KLOCWT), TBUFF)
                  END IF
C                                       Real*4 output
C                                       Loop through random parms.
               DO 230 I = 1,NRPARM
                  IF (IFLAG(I).GT.0) THEN
                     K = I - 1
                     IF ((DOBASL) .AND. (K.EQ.ILOCSA)) THEN
                        TAPVR8 = 256.0*BUFF(IPTR+ILOCA1) +
     *                     BUFF(IPTR+ILOCA2) +
     *                     (BUFF(IPTR+ILOCSA)-1.)/100.
                     ELSE
                        TAPVR8 = SCRP(1,I) * BUFF(IPTR+K)
                        END IF
                     ITPOS = ITPOS + 1
C                                       Write buffer to tape.
                     IF (ITPOS.GT.ITMAX) THEN
                        CALL WRTAUV (ITMAX, IERR)
                        ITPOS = 1
                        IF (IERR.NE.0) GO TO 999
                        END IF
                     IF (IFLAG(I).EQ.2) THEN
                        FITBR4(ITPOS) = TAPVR8
                        TAPVR8 = BUFF(IPTR+K) - (FITBR4(ITPOS) /
     *                     SCRP(1,I))
                        TAPVR8 =  TAPVR8 * SCRP(2,I)
                        ITPOS = ITPOS + 1
                        IF (ITPOS.GT.ITMAX) THEN
                           CALL WRTAUV (ITMAX, IERR)
                           ITPOS = 1
                           IF (IERR.NE.0) GO TO 999
                           END IF
                        END IF
                     FITBR4(ITPOS) = TAPVR8
                     END IF
 230              CONTINUE
C                                       Group array values.
               IOFF = 0
C                                       No conversion
               DO 250 I = 1,NVALS
                  DO 245 JJ = 1,3
                     IOFF = IOFF + 1
                     TAPVAL = TBUFF(IOFF) * SCLDAT(JJ)
                     ITPOS = ITPOS + 1
                     IF (ITPOS.GT.ITMAX) THEN
                        CALL WRTAUV (ITMAX, IERR)
                        ITPOS = 1
                        IF (IERR.NE.0) GO TO 999
                        END IF
                     FITBR4(ITPOS) = TAPVAL
 245                 CONTINUE
 250              CONTINUE
C                                       Incr address, loop
               IPTR = IPTR + LREC
 290           CONTINUE
            GO TO 10
C                                       Write last buffer.
 300  CALL WRTAUV (ITPOS, IERR)
C
 999  RETURN
      END
      SUBROUTINE FITHIS (ISLOT, IVOL, IERR)
C-----------------------------------------------------------------------
C   This routine will write the general history information to tape.
C   An END card is NOT written.
C   Inputs:
C      ISLOT   I         Catalog slot number of the cataloged file.
C      IVOL    I         Disk number.
C   IN/OUT:  (in common)
C      ICARD   I         The last card written in FITBLK  (1:36)
C      TBIND    I        TAPBUF(TBIND) is the start of the current I/O
C                        buffer.
C      FITBLK  I(1440)   header buffer
C      TAPBUF  I(*)      TAPIO buffers
C   Output:
C      IERR    I         error code. 0=ok, 1=bad>
C-----------------------------------------------------------------------
      CHARACTER HISTRY*8, CHTMP*72, HILINE*80, COFITS(2)*72
      HOLLERITH IBUFF(256)
      INTEGER   ISLOT, IVOL, IERR
      INTEGER   I, IHLUN, LOC, KT, KD, HPTR, IC, IL, J, ID(3), IER,
     *   ITRIM
      LOGICAL   F
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (IBUFF, BUFF)
      DATA F /.FALSE./
      DATA IHLUN /29/
      DATA HISTRY /'HISTORY '/
C-----------------------------------------------------------------------
      IERR = 0
      COFITS(1) = '  FITS (Flexible Image Transport System) format is'
     *   // ' defined in ''Astronomy'
      COFITS(2) = '  and Astrophysics'', volume 376, page 359;' //
     *   ' bibcode: 2001A&A...376..359H'
C                                       Is there a history file?
      CALL FNDEXT ('HI', CATBLK, I)
      IF (I.LE.0) THEN
         WRITE (MSGTXT,1010)
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       Open HI file
      CALL HIINIT (1)
C                                       add a line
      CALL HIOPEN (IHLUN, IVOL, ISLOT, IBUFF, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1015) IER
         CALL MSGWRT (8)
         GO TO 100
         END IF
      IF (OUTFIL.NE.' ') THEN
         I = ITRIM (OUTFIL)
         IF (I.LE.30) THEN
            WRITE (HILINE,1000) TSKNAM, OUTFIL(:I)
         ELSE
            WRITE (HILINE,1001) TSKNAM, OUTFIL(:I)
            END IF
      ELSE
         WRITE (HILINE,1002) TSKNAM, FDVEC(5)
         END IF
      CALL HIADD (IHLUN, HILINE, IBUFF, IER)
      CALL HICLOS (IHLUN, .TRUE., IBUFF, IER)
C                                       Add HI file into FITS tape
      CALL HIOPEN (IHLUN, IVOL, ISLOT, IBUFF, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1015) IER
         CALL MSGWRT (8)
         GO TO 100
         END IF
C                                       Initialize HI parameters
C                                       LOC = HI Physical record
C                                       KT = Total # of Logical rec.
C                                       KD = HI logical record
      LOC = 0
      HPTR = 1
      KT = HITAB(HPTR+2)
C                                       Let user know.
      WRITE (MSGTXT, 1200)
      CALL MSGWRT (3)
C                                       Begin HI record loop
      DO 60 KD = 1,KT
         I = MOD (KD-1, NHILPR) + 1
C                                       Read next HI physical record
         IF (I.EQ.1) THEN
            LOC = LOC + 1
            CALL HIIO ('READ', HPTR, LOC, IBUFF, IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,1020) IER, LOC
               GO TO 90
               END IF
            END IF
         IL = 5 + NHIWPL * MOD (KD-1, NHILPR)
         CALL SPFIL (IBUFF(IL), 72, J)
         CALL H2CHR (72, 1, IBUFF(IL), CHTMP)
C                                       Not AIPS / FITS history
         IF ((CHTMP.NE.COFITS(1)) .AND. (CHTMP.NE.COFITS(2)) .AND.
     *      (CHTMP(1:5).NE.'AIPS ')) THEN
C                                       Increment output card cnt
C                                       Write TAPBUF to tape.
            IF (ICARD.GE.36) CALL WRCTAP (IERR)
            IF (IERR.NE.0) GO TO 999
            ICARD = ICARD + 1
            IC = 80 * ICARD - 79
C                                       Copy HI data into buffer
            HILINE(1:8) = HISTRY
C                                       See if this card already starts
C                                       with word history.
            IF (CHTMP(1:8).EQ.HISTRY) THEN
C                                       "HISTORY" in card
               HILINE(9:72) = CHTMP(9:72)
               HILINE(73:80) = ' '
            ELSE
               HILINE(9:80) = CHTMP
               END IF
C                                       Card to FITBLK
            CALL ZCLC8 (80, HILINE, IC, FITBLK)
            END IF
 60      CONTINUE
C                                       Close HI file
 90   CALL HICLOS (IHLUN, F, IBUFF, IER)
C                                       extra parameters
C                                       ORIGIN keyword
 100  IF (ICARD.GE.36) CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 999
      ICARD = ICARD + 1
      IC = 80 * ICARD - 79
      WRITE (MSGTXT,1100) HSTNAM, SYSNAM, RLSNAM
      CALL FITCHM (MSGTXT, IC, FITBLK)
C                                       DATE keyword
      IF (ICARD.GE.36) CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 999
      ICARD = ICARD + 1
      IC = 80 * ICARD - 79
      CALL ZGDATE (ID)
      WRITE (CHTMP,1110) ID
      CALL DATFST ('L2F', CHTMP)
      I = ITRIM (CHTMP)
C                                       year 2000 set by DATFST only
      IF (I.LE.8) THEN
         WRITE (MSGTXT,1111) CHTMP(:I)
      ELSE
         WRITE (MSGTXT,1112) CHTMP(:I)
         END IF
      CALL FITCHM (MSGTXT, IC, FITBLK)
C                                       history: names
      IF (ICARD.GE.36) CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 999
      ICARD = ICARD + 1
      IC = 80 * ICARD - 79
      WRITE (MSGTXT,1120) CATBLK(KIIMS)
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), MSGTXT(24:35))
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), MSGTXT(47:52))
      CALL FITCHM (MSGTXT, IC, FITBLK)
C                                       history: user number
      IF (ICARD.GE.36) CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 999
      ICARD = ICARD + 1
      IC = 80 * ICARD - 79
      WRITE (MSGTXT,1130) CATBLK(KIIMU)
      CALL FITCHM (MSGTXT, IC, FITBLK)
C                                       history: FITS ref 1
      IF (ICARD.GE.36) CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 999
      ICARD = ICARD + 1
      IC = 80 * ICARD - 79
      MSGTXT = 'COMMENT ' // COFITS(1)
      CALL FITCHM (MSGTXT, IC, FITBLK)
C                                       history: FITS ref 2
      IF (ICARD.GE.36) CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 999
      ICARD = ICARD + 1
      IC = 80 * ICARD - 79
      MSGTXT = 'COMMENT ' // COFITS(2)
      CALL FITCHM (MSGTXT, IC, FITBLK)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'DATAOUT = ''',A,''' / data written to disk file')
 1001 FORMAT (A6,'DATAOUT = ''',A,''' / disk file')
 1002 FORMAT (A6,'OUTTAPE = ',I2,'   / data written to tape')
 1010 FORMAT ('Warning: No history file to put on FITS output')
 1015 FORMAT ('FITHCN: COULD NOT OPEN HI FILE.  IER=',I4)
 1020 FORMAT ('FITHCN: COULD NOT READ HI FILE.  IER=',I4,
     *   '  RECORD #=',I5)
 1100 FORMAT ('ORIGIN  = ''AIPS',A12,1X,A20,1X,A7,'''',4X,'/ ')
 1110 FORMAT (I4.4,2I2.2)
 1111 FORMAT ('DATE    = ''',A,'''',5X,'/ File written on dd/mm/yy')
 1112 FORMAT ('DATE    = ''',A,'''',3X,
     *   '/ File written on Greenwich yyyy-mm-dd')
 1120 FORMAT ('HISTORY AIPS   IMNAME=''',12X,''' IMCLASS=''',6X,
     *   ''' IMSEQ=',I4,5X,'/ ')
 1130 FORMAT ('HISTORY AIPS   USERNO=',I5,12X,'/ ')
 1200 FORMAT ('Writing HI file')
      END
      SUBROUTINE WRTAPE (ITFULL, IERR)
C-----------------------------------------------------------------------
C   Writes TAPBUF to tape and resets counters.
C   INPUTS:
C      ITFULL  I        Number values filled in buffer (will zero fill)
C   Inputs via common:
C      FDVEC   I(40)    File descriptor vector for TAPIO output
C      FITBLK  I(*)     header buffer
C      TAPBUF  I(*)     TAPIO buffers
C      IFMTYP  I        Desired format in FITBLK
C   In/Out via common:
C      TBIND   I      starting index of current buffer in TAPBUF.
C   Outputs:
C      IERR    I      IO error code.
C-----------------------------------------------------------------------
      INTEGER   ITFULL, IERR
C
      INTEGER   ITMAX, ITZ
      REAL      FITBR4(1440)
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (FITBLK, FITBR4)
C-----------------------------------------------------------------------
C                                       Write this buffer to tape.
      ITMAX = 720
      IF (IFMTYP.EQ.1) ITMAX = 1440
      IF (IFMTYP.EQ.4) ITMAX = 2880
      ITZ = ITMAX - ITFULL
      IF (ITZ.GT.0) THEN
         IF (IFMTYP.EQ.3) THEN
            CALL RFILL (ITZ, 0.0, FITBR4(1+ITFULL))
         ELSE
            CALL FILL (ITZ, 0, FITBLK(1+ITFULL))
            END IF
         END IF
C                                       translate
      IF (IFMTYP.EQ.1) CALL ZILI16 (ITMAX, FITBLK, 1, TAPBUF(TBIND))
      IF (IFMTYP.EQ.2) CALL ZILI32 (ITMAX, FITBLK, 1, TAPBUF(TBIND))
      IF (IFMTYP.EQ.3) CALL ZRLR32 (ITMAX, 1, FITBLK, TAPBUF(TBIND))
      IF (IFMTYP.EQ.4) CALL ZILI8 (ITMAX, FITBLK, 1, TAPBUF(TBIND))
C                                       write
      CALL TAPIO ('WRIT', FDVEC, TAPBUF, TBIND, IERR)
C
 999  RETURN
      END
      SUBROUTINE WRTAUV (ITFULL, IERR)
C-----------------------------------------------------------------------
C   Writes TAPBUF to tape and resets counters.
C   for UV data with no magic blanks
C   INPUTS:
C      ITFULL  I        Number values filled in buffer (will zero fill)
C   Inputs via common:
C      FDVEC   I(40)    File descriptor vector for TAPIO output
C      FITBLK  I(*)     header buffer
C      TAPBUF  I(*)     TAPIO buffers
C      IFMTYP  I        Desired format in FITBLK
C   In/Out via common:
C      TBIND   I      starting index of current buffer in TAPBUF.
C   Outputs:
C      IERR    I      IO error code.
C-----------------------------------------------------------------------
      INTEGER   ITFULL, IERR
C
      INTEGER   ITMAX, ITZ
      REAL      FITBR4(1440)
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (FITBLK, FITBR4)
C-----------------------------------------------------------------------
C                                       Write this buffer to tape.
      ITMAX = 720
      IF (IFMTYP.EQ.1) ITMAX = 1440
      IF (IFMTYP.EQ.4) ITMAX = 2880
      ITZ = ITMAX - ITFULL
      IF (ITZ.GT.0) THEN
         IF (IFMTYP.EQ.3) THEN
            CALL RFILL (ITZ, 0.0, FITBR4(1+ITFULL))
         ELSE
            CALL FILL (ITZ, 0, FITBLK(1+ITFULL))
            END IF
         END IF
C                                       translate
      IF (IFMTYP.EQ.1) CALL ZILI16 (ITMAX, FITBLK, 1, TAPBUF(TBIND))
      IF (IFMTYP.EQ.2) CALL ZILI32 (ITMAX, FITBLK, 1, TAPBUF(TBIND))
      IF (IFMTYP.EQ.3) CALL ZRLRUV (ITMAX, 1, FITBLK, TAPBUF(TBIND))
      IF (IFMTYP.EQ.4) CALL ZILI8 (ITMAX, FITBLK, 1, TAPBUF(TBIND))
C                                       write
      CALL TAPIO ('WRIT', FDVEC, TAPBUF, TBIND, IERR)
C
 999  RETURN
      END
      SUBROUTINE FITCHM (TEXT, IC, BUFFER)
C-----------------------------------------------------------------------
C   FITCHM moves TEXT to BUFFER 80-charcter strings converting to
C   real world characters.
C   Inputs/outputs:
C      TEXT    C*80      text line:
C      IC      I          pointer to char loc for text
C      BUFFER  I(*)       buffer to hold n lines
C-----------------------------------------------------------------------
      CHARACTER TEXT*80
      INTEGER   IC, BUFFER(*)
C-----------------------------------------------------------------------
      CALL ZCLC8 (80, TEXT, IC, BUFFER)
      IC = IC + 80
C
 999  RETURN
      END
      SUBROUTINE FT2CHM (TEXT, ICARD, BUFFER)
C-----------------------------------------------------------------------
C   FT2CHM moves TEXT to BUFFER converting to real world characters.
C   Inputs/outputs:
C      TEXT     C*80   text line:
C      ICARD    I      pointer to char loc for text
C      BUFFER   I(*)   buffer to hold n lines
C-----------------------------------------------------------------------
      CHARACTER TEXT*80
      INTEGER   ICARD, BUFFER(*)
C
      INTEGER   IC
C-----------------------------------------------------------------------
      ICARD = ICARD + 1
      IC = 80 * ICARD - 79
      CALL ZCLC8 (80, TEXT, IC, BUFFER)
C
 999  RETURN
      END
      SUBROUTINE WRCTAP (IERR)
C-----------------------------------------------------------------------
C   WRCTAP writes a tape record of FITS character data.
C   The data in FITBLK must already have been converted into real world
C   characters.
C   Output:  IERR   I     Error code of IO routines.
C-----------------------------------------------------------------------
      INTEGER   IERR, IL
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Copy to buffer
      IL = 2880 / (NBITWD/8)
      CALL COPY (IL, FITBLK, TAPBUF(TBIND))
      CALL TAPIO ('WRIT', FDVEC, TAPBUF, TBIND, IERR)
      ICARD = 0
C
 999  RETURN
      END
      SUBROUTINE FITEXT (KVOL, ISLOT, IER)
C-----------------------------------------------------------------------
C   FITEXT copies AIPS tables files to the FITS output file.  All
C   tables will be written as 3-D tables unless DOASC=.TRUE.; in this
C   case, all files which can be written as ASCII tables will be
C   written thus and others will be written as 3-D tables.
C   Inputs:  KVOL   I     Disk number
C            ISLOT  I     Catalog slot number of map file.
C   Output:  IER    I     Error number: 0 => none
C                           else count of errors or tape IO error #
C-----------------------------------------------------------------------
      INTEGER   KVOL, ISLOT, IER
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER TTYPE*2
      INTEGER   NEXTF, ITABLE, I20, MAXVER, IVER
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       Loop for all extension files.
      CALL FXHDEX (CATBLK)
      NEXTF = KHEXT + KIEXTN - 1
      DO 800 ITABLE = KHEXT, NEXTF
C                                       Get max # Table versions
         I20 = KIVER + ITABLE - KHEXT
         MAXVER = CATBLK(I20)
         IF (MAXVER.GT.0) THEN
            CALL H2CHR (2, 1, CATH(ITABLE), TTYPE)
C                                       Loop over versions
            DO 780 IVER = 1,MAXVER
C                                       Do table
               CALL EXTWRT (TTYPE, IVER, KVOL, ISLOT, IER)
               IF (IER.NE.0) GO TO 999
 780           CONTINUE
            END IF
 800     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE EXTWRT (TTYPE, IVER, KVOL, ISLOT, IER)
C-----------------------------------------------------------------------
C   EXTWRT copies a single, specified AIPS table file to the FITS
C   output file.  Table will be written as 3-D tables unless
C   DOASC=.TRUE.; in this case, a file which can be written as an ASCII
C   table will be  written thus else it will be written as a 3-D table.
C   Inputs:  TTYPE  C*2   Extension table type, 2 char.
C            IVER   I     Version number.
C            KVOL   I     Disk number
C            ISLOT  I     Catalog slot number of map file.
C   Output:  IER    I     Error number: 0 => none
C                           else count of errors or tape IO error #
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
C                                       XBPRSZ is maximum size of an
C                                       array in a table record in real
C                                       words, worst case is bandpass
C                                       table.
      CHARACTER COLHDR(128)*24, UNITS(128)*8, KWNAME*8, TTYPE*2,
     *   FORM3D*8, FORMXX*8, FORCOD(7)*1, FORM(7)*8, TYPTAB(2)*8,
     *   FRMOUT*8, STARS*32, CHTMP*10
      HOLLERITH RECH(XBPRSZ), HVALUE(2)
      INTEGER   KVOL, ISLOT, IER
      DOUBLE PRECISION RECORD(XBPRSZ/2), DVALUE, RECRD(XBPRSZ/2),
     *   DLINE(XBPRSZ/2)
      REAL      RLINE(XBPRSZ), RECRR(XBPRSZ), RVALUE
      INTEGER   NREC, RECI(XBPRSZ), IRNO, JVALUE, ILINE(XBPRSZ),
     *   IPAIR, SUMBYT, MXTEST, MAXL, CH1, CHEND
      LOGICAL   EXIST, TABLE, RECL(XBPRSZ), FITASC, IS3D
      INTEGER   IVER, LUN, IFORMT(128), BUFFER(512), IC, I, II, ITRIM,
     *   IERR, IFLEN(128), ITLEN(7), ITYPE, NKEY, NCOL, DATP(128,2),
     *   ICRDL, INCRD, IL, IRCODE, IDUM,ILEN, IBCOL(128), MINLEN, IOFF,
     *   ILEN0, JJ, SRTORD, TBTYP, NUMFOR, NUMBYT(7),
     *   NCOPY, NEXT, TCOUNT(128), TPTYPE(128), TOFF(128),
     *   ITNCOL, FLAGD, RECOUT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'FITTP.INC'
      INCLUDE 'FITTP2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (BUFF, BUFFER)
      EQUIVALENCE (DVALUE, HVALUE)
      EQUIVALENCE (DLINE, RLINE, ILINE)
      EQUIVALENCE (RECORD, RECRD, RECRR, RECI, RECL, RECH)
      DATA FORCOD /'D','E','A','J','L','I','X'/
      DATA STARS /'********************************'/
      DATA NUMBYT / 8, 4,  1,  4,  1,  2,  1/
      DATA MAXL /XBPRSZ/
      DATA LUN /28/
      DATA FORM /'D24.15  ','E15.6   ','        ',
     *   'I12     ','A1      ', 'I6      ','        '/
      DATA ITLEN /24, 15, 0, 12, 0, 6, 0/
      DATA TYPTAB /'A3DTABLE',  'BINTABLE'/
C-----------------------------------------------------------------------
      IER = 0
      ILEN0 = 160
      IS3D = .TRUE.
C                                       See if we have a table.
      CALL ISTAB (TTYPE, KVOL, ISLOT, IVER, LUN, BUFFER,
     *   TABLE, EXIST, FITASC, IERR)
      IF (.NOT.EXIST) GO TO 999
      IF (.NOT.TABLE) THEN
         IF ((DOPLOT.GE.0.0) .AND. ((TTYPE.EQ.'PL') .OR.
     *      (TTYPE.EQ.'SL'))) CALL FITPL (TTYPE, KVOL, ISLOT, IVER,
     *      IERR)
         GO TO 999
         END IF
      CALL TABINI ('READ', TTYPE, KVOL, ISLOT, IVER, CATBLK, LUN, NKEY,
     *   IDUM, NCOL, DATP, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 999
      NREC = BUFFER(5)
C                                       Count the unflagged records.
C                                         This will have to be revised.
      FLAGD = 0
      DO 10 IRNO = 1,NREC
         CALL TABIO ('READ', IRCODE, IRNO, RECI, BUFFER, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.-1)) GO TO 999
C                                       IERR=-1 is flagged row.
         IF (IERR.EQ.-1) FLAGD = FLAGD + 1
         IERR = 0
 10      CONTINUE
C                                       Let the user know.
C
      RECOUT = NREC - FLAGD
      IF (FLAGD.GT.0) THEN
         WRITE (MSGTXT,1010) RECOUT
         CALL MSGWRT (4)
         WRITE (MSGTXT,1011) NREC, TTYPE, IVER
         CALL MSGWRT (4)
         ENDIF
C                                       Everything you need to know
C                                       about the columns.
      CALL GETHUT (NCOL, DATP, BUFFER, COLHDR, UNITS,
     *   IFORMT, IFLEN, IERR)
C                                       Determine col start positions
C                                       and number of bytes for 3-D
      II = IFORMT(1)
      SUMBYT = IFLEN(1) * NUMBYT(II)
      IF (II.EQ.7) SUMBYT = 1 + (IFLEN(1)-1) / NBITWD
      IBCOL(1) = 1
      DO 40 I = 2,NCOL
         II = IFORMT(I-1)
         IBCOL(I) = IBCOL(I-1) + ITLEN(II) + IFLEN(I-1) + 1
         II = IFORMT(I)
         IF (II.NE.7) SUMBYT = SUMBYT + IFLEN(I) * NUMBYT(II)
         IF (II.EQ.7) SUMBYT = SUMBYT + 1 + (IFLEN(I)-1)/NBITWD
 40      CONTINUE
      II = IFORMT(NCOL)
      IF (II.EQ.7) MINLEN = IBCOL(NCOL) +
     *   (IFLEN(I-1) - 1) / 4 + 1
      IF (II.NE.7) MINLEN = IBCOL(NCOL) + ITLEN(II) + IFLEN(II)
C                                       Make card length a multiple of
C                                       60 to make things simple.
      ICRDL = 60 * (MINLEN / 60  +  1)
      INCRD = 2880 / ICRDL
C                                       We did not reserve enuf buffer
C                                       size in array LINE or RLINE
      MXTEST = (MAXL * 2)
      IF (SUMBYT.GT.MXTEST) THEN
         WRITE (MSGTXT,1040) ICRDL
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Table header
      ICARD = 0
C                                       Table type
      TBTYP = 2
C                                       Tell user table and type
      WRITE (MSGTXT,1015) TTYPE
      CALL MSGWRT (3)
      WRITE (MSGTXT,1050) TYPTAB(TBTYP)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1051)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1052)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1053) SUMBYT
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1054) RECOUT
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1055)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1056)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1057) NCOL
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1058) TTYPE
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1059) IVER
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      DO 80 I = 1,NCOL
         IF (I.LT.10) WRITE (MSGTXT,1060) I, IBCOL(I)
         IF (I.GE.10) WRITE (MSGTXT,1061) I, IBCOL(I)
C         IF (.NOT.IS3D) CALL FT2CHM (MSGTXT, ICARD, FITBLK)
         IF (ICARD.GT.35) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 900
         II = IFORMT(I)
C                                       Try to get character format
C                                       into the right form.
         IF (II.EQ.3) THEN
            WRITE (MSGTXT,1062) IFLEN(I)
            CALL CHTRIM (MSGTXT, 8, MSGTXT, ILEN)
            FORM(3) = 'A' // MSGTXT(1:ILEN)
            END IF
C                                       Get correct format for file type
         FRMOUT = FORM(II)
C                                       3-D tables
         WRITE (FORM3D,1076) IFLEN(I), FORCOD(II)
         FORMXX = '        '
         CALL CHTRIM (FORM3D, 8, FORMXX, NUMFOR)
         FRMOUT = FORMXX
         IF (I.LT.10) WRITE (MSGTXT,1070) I, FRMOUT, I
         IF (I.GE.10) WRITE (MSGTXT,1071) I, FRMOUT, I
         CALL FT2CHM (MSGTXT, ICARD, FITBLK)
         IF (ICARD.GT.35) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 900
         IF (I.LT.10) WRITE (MSGTXT,1072) I, COLHDR(I)(1:16), I
         IF (I.GE.10) WRITE (MSGTXT,1073) I, COLHDR(I)(1:16), I
         CALL FT2CHM (MSGTXT, ICARD, FITBLK)
         IF (ICARD.GT.35) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 900
         IF (I.LT.10) WRITE (MSGTXT,1074) I, UNITS(I), I
         IF (I.GE.10) WRITE (MSGTXT,1075) I, UNITS(I), I
         CALL FT2CHM (MSGTXT, ICARD, FITBLK)
         IF (ICARD.GT.35) CALL WRCTAP (IERR)
         IF (IERR.NE.0) GO TO 900
 80      CONTINUE
C                                       Do all KeyWord value pairs.
      NKEY = BUFFER(53)
      IF (NKEY.GE.1) THEN
         DO 240 IPAIR = 1,NKEY
            CALL GTPAIR (IPAIR, BUFFER, KWNAME, DVALUE, ITYPE)
            IF (ITYPE.EQ.0) GO TO 240
C                                       Double Precision.
            IF (ITYPE.EQ.1) THEN
               WRITE (MSGTXT,1120) KWNAME, DVALUE
C                                       Real.
            ELSE IF (ITYPE.EQ.2) THEN
               RVALUE = DVALUE
               WRITE (MSGTXT,1140) KWNAME, RVALUE
C                                       Character.
            ELSE IF (ITYPE.EQ.3) THEN
               CALL H2CHR (8, 1, HVALUE, CHTMP)
               IF (INDEX(KWNAME,'DATE').GT.0) CALL DATFST ('L2F', CHTMP)
               I = MAX (8, ITRIM (CHTMP))
               WRITE (MSGTXT,1160) KWNAME, CHTMP(:I)
C                                       Integer.
            ELSE IF (ITYPE.EQ.4) THEN
               IF (DVALUE.LT.0.0D0) JVALUE = DVALUE - 0.01D0
               IF (DVALUE.GE.0.0D0) JVALUE = DVALUE + 0.01D0
               WRITE (MSGTXT,1180) KWNAME, JVALUE
C                                       Logical.
            ELSE IF (ITYPE.EQ.5) THEN
               IF (DVALUE.GT.0.0D0) WRITE (MSGTXT,1200) KWNAME
               IF (DVALUE.LE.0.0D0) WRITE (MSGTXT,1202) KWNAME
C                                       Integer (short no longer valid)
C           ELSE IF (ITYPE.EQ.6) THEN
C              IER = 5
C              MSGTXT = 'SHORT INTEGERS NO LONGER VALID'
C              CALL MSGWRT (8)
C              GO TO 999
               END IF
C
            CALL FT2CHM (MSGTXT, ICARD, FITBLK)
            IF (ICARD.GT.35) CALL WRCTAP (IERR)
 240        CONTINUE
         END IF
C                                       Sort order.
      SRTORD = BUFFER(43)
      IF (SRTORD.NE.0) THEN
         WRITE (MSGTXT,1230) SRTORD
         CALL FT2CHM (MSGTXT, ICARD, FITBLK)
         IF (ICARD.GT.35) CALL WRCTAP (IERR)
         END IF
C                                       END card.
      WRITE (MSGTXT,1240)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
C                                       Blank fill rest of block.
      IC = 80 * ICARD  + 1
      IL = 2881 - IC
      IF (IL.GT.0) THEN
         LINE (IC:2880) = '                  '
         CALL ZCLC8 (IL, LINE(IC:2880), IC, FITBLK)
         END IF
      CALL WRCTAP (IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Decide file type
      IF (IS3D) GO TO 500
C                                       ASCII format table
C                                       Table data
      IRCODE = 0
      DO 340 IRNO = 1,NREC
         CALL TABIO ('READ', IRCODE, IRNO, RECI, BUFFER, IERR)
         IF (IERR.EQ.-1) GO TO 340
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1245) IERR
               CALL MSGWRT (6)
               DO 260 II = 1, NCOL
                  ITYPE = IFORMT(II)
                  ILEN = ITLEN(ITYPE) + IFLEN(II)
                  LINE(IBCOL(II):IBCOL(II)+ILEN-1) = STARS(1:ILEN)
 260              CONTINUE
               GO TO 320
               END IF
            IF (ICARD.GE.INCRD) CALL WRCTAP (IERR)
            IF (IERR.NE.0) GO TO 900
            IC = ICRDL * ICARD + 1
            ICARD = ICARD + 1
            LINE(1:ICRDL) = '     '
C                                       Put each column value in the
C                                       card line.
            DO 300 II = 1,NCOL
               ITYPE = IFORMT(II)
               ILEN = ITLEN(ITYPE) + IFLEN(II)
               IOFF = DATP(II,1)
               CH1 = IBCOL(II)
               CHEND = CH1 + ILEN - 1
C                                       Double precision.
               IF (ITYPE.EQ.1) THEN
                  WRITE (LINE(CH1:CHEND),1281) RECRD(IOFF)
C                                       Real.
               ELSE IF (ITYPE.EQ.2) THEN
                  WRITE (LINE(CH1:CHEND),1282) RECRR(IOFF)
C                                       Character
               ELSE IF (ITYPE.EQ.3) THEN
                  CALL H2CHR (ILEN, 1, RECH(IOFF), LINE(CH1:CHEND))
C                                       Integer.
               ELSE IF (ITYPE.EQ.4) THEN
                  WRITE (LINE(CH1:CHEND),1284) RECI(IOFF)
C                                       Logical
               ELSE IF (ITYPE.EQ.5) THEN
                  IF (RECL(IOFF)) THEN
                     WRITE (LINE(CH1:CHEND),1285)
                  ELSE
                     WRITE (LINE(CH1:CHEND),1286)
                     END IF
C                                       Integer (short no longer valid)
               ELSE
                  IER = 5
                  MSGTXT = 'SHORT INTEGERS NO LONGER VALID'
                  CALL MSGWRT (8)
                  GO TO 999
                  END IF
 300           CONTINUE
 320        CALL ZCLC8 (ICRDL, LINE, IC, FITBLK)
 340     CONTINUE
C                                       Last record flush
      IC = ICRDL * ICARD + 1
      IL = 2881 - IC
      IF (IL.LT.2880) THEN
         IF (IL.GT.0) THEN
            LINE (IC:2880) = '                  '
            CALL ZCLC8 (IL, LINE(IC:2880), IC, FITBLK)
            END IF
         IL = 2880 / (NBITWD/8)
         CALL COPY (IL, FITBLK, TAPBUF(TBIND))
         CALL TAPIO ('WRIT', FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      CALL TABIO ('CLOS', IRCODE, IRNO, RECI, BUFFER, IERR)
      GO TO 999
C                                       3-D table
 500  IRCODE = 0
C                                       Table control info
      DO 510 II = 1,NCOL
         TPTYPE(II) = IFORMT(II)
         TCOUNT(II) = IFLEN(II)
         TOFF(II) = DATP(II,1)
 510     CONTINUE
C                                       Compress table if possible
      ITNCOL = NCOL
      NEXT = 1
      CALL FILL (720, 0, TAPBUF(TBIND))
C
      DO 740 IRNO = 1,NREC
         CALL TABIO ('READ', IRCODE, IRNO, RECI, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 740
C                                       Use RLINE for scratch output
            DO 700 II = 1,ITNCOL
               ITYPE = TPTYPE(II)
               ILEN = TCOUNT(II)
               IOFF = TOFF(II)
C                                       Double precision.
               IF (ITYPE.EQ.1) THEN
                  CALL ZRLR64 (ILEN, 1, RECRD(IOFF), DLINE)
C                                       Real.
               ELSE IF (ITYPE.EQ.2) THEN
                  CALL ZRLR32 (ILEN, 1, RECI(IOFF), ILINE)
C                                       Character
               ELSE IF (ITYPE.EQ.3) THEN
                  CALL H2CHR (ILEN, 1, RECH(IOFF), LINE)
                  CALL ZCLC8 (ILEN, LINE, 1, ILINE)
C                                       Integer.
               ELSE IF (ITYPE.EQ.4) THEN
                  CALL ZILI32 (ILEN, RECI(IOFF), 1, ILINE)
C                                       Logical
               ELSE IF (ITYPE.EQ.5) THEN
                  DO 650 JJ = 1,ILEN
                     IF (RECL(IOFF+JJ-1)) LINE(JJ:JJ) = 'T'
                     IF (.NOT.RECL(IOFF+JJ-1)) LINE(JJ:JJ) = 'F'
 650                 CONTINUE
                  CALL ZCLC8 (ILEN, LINE, 1, ILINE)
C                                       Bit array
               ELSE IF (ITYPE.EQ.7) THEN
                  CALL ZXLX8 (ILEN, RECI(IOFF), RLINE)
C                                       Integer (short no longer valid)
               ELSE
                  IER = 5
                  MSGTXT = 'SHORT INTEGERS NO LONGER VALID'
                  CALL MSGWRT (8)
                  GO TO 999
                  END IF
C                                       Copy to output
               NCOPY = NUMBYT(ITYPE) * ILEN
               IF (ITYPE.EQ.7) NCOPY = 1 + (ILEN-1) / (NBITWD/2)
               CALL PTF3D (FDVEC, TBIND, NEXT, RLINE, TAPBUF, NCOPY,
     *            IERR)
               IF (IERR.NE.0) GO TO 900
 700           CONTINUE
 740     CONTINUE
C                                       Last record flush
      IF (NEXT.GT.1) THEN
         CALL TAPIO ('WRIT', FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      CALL TABIO ('CLOS', IRCODE, IRNO, RECI, BUFFER, IERR)
      GO TO 999
C                                       Error on I/O
 900  WRITE (MSGTXT,1900) IERR
      CALL MSGWRT (8)
      IER = IERR
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('EXTWRT: WRITING ',I6,' UNFLAGGED ROWS OUT OF ')
 1011 FORMAT (8X,I6,' TOTAL FOR TABLE ',A2,' VERSION ',I3)
 1015 FORMAT ('Writing binary table of type ',A2)
 1040 FORMAT ('BUFFER NOT BIG ENOUGH FOR NEEDED CARD SIZE. BYTES=',I8)
 1050 FORMAT ('XTENSION= ',1H',A8,1H',11X,'/ Extension type')
 1051 FORMAT ('BITPIX  =',20X,'8',1X,'/ Binary data')
 1052 FORMAT ('NAXIS   =',20X,'2',1X,'/ Table is a matrix')
 1053 FORMAT ('NAXIS1  =',13X,I8,1X,'/ Width of table in bytes')
 1054 FORMAT ('NAXIS2  =',13X,I8,1X,'/ Number of entries in table')
 1055 FORMAT ('PCOUNT  =',20X,'0',1X,'/ Random parameter count')
 1056 FORMAT ('GCOUNT  =',20X,'1',1X,'/ Group count')
 1057 FORMAT ('TFIELDS =',19X,I2,1X,'/ Number of fields in each row')
 1058 FORMAT ('EXTNAME = ''AIPS ',A2,1X,'''',11X,'/ AIPS table file')
 1059 FORMAT ('EXTVER  = ',15X,I5,1X,'/ Version number of table')
 1060 FORMAT ('TBCOL',I1,'  = ',15X,I5,1X,'/ Starting Char. pos. of',
     *   ' field',I3)
 1061 FORMAT ('TBCOL',I2 ,' = ',15X,I5,1X,'/ Starting char. pos. of',
     *   ' field',I3)
 1062 FORMAT (I6)
 1070 FORMAT ('TFORM',I1,'  = ''',A8,'''',11X,'/ FORTRAN format',
     *   ' of field',I3)
 1071 FORMAT ('TFORM',I2 ,' = ''',A8,'''',11X,'/ FORTRAN format',
     *   ' of field',I3)
 1072 FORMAT ('TTYPE',I1,'  = ''',A16,'''',3X,'/ Type (heading)',
     *   ' of field',I3)
 1073 FORMAT ('TTYPE',I2,' = ''',A16,'''',3X,'/ Type (heading)',
     *   ' of field',I3)
 1074 FORMAT ('TUNIT',I1,'  = ''',A8,'''',11X,'/ Physical units',
     *   ' of field',I3)
 1075 FORMAT ('TUNIT',I2 ,' = ''',A8,'''',11X,'/ physical units',
     *   ' of field',I3)
 1076 FORMAT (I7,1A1)
 1120 FORMAT (A8,'= ',D25.17)
 1140 FORMAT (A8,'= ',E15.7)
 1160 FORMAT (A8,'= ''',A,'''')
 1180 FORMAT (A8,'= ',I12)
 1200 FORMAT (A8,'=',20X,'T')
 1202 FORMAT (A8,'=',20X,'F')
 1230 FORMAT ('ISORTORD=',I20)
 1240 FORMAT ('END')
 1245 FORMAT ('TABIO RETURNS ERROR',I7,' PROCEED WITH NULL DATA')
 1281 FORMAT (D24.15)
 1282 FORMAT (E15.6)
 1284 FORMAT (I12)
 1285 FORMAT ('T')
 1286 FORMAT ('F')
 1900 FORMAT ('EXTWRT: FITS WRITE ERROR',I7)
      END
      SUBROUTINE FITPL (TTYPE, KVOL, ISLOT, IVER, IRET)
C-----------------------------------------------------------------------
C   FITPL writes a PL or SL file as a FITS table (entrely in the "heap")
C   Inputs:
C      TTYPE   C*2   PL or SL
C      KVOL    I     disk
C      ISLOT   I     slot number
C      IVER    I     version number
C   Outouts:
c      IRET    I     Error code
C-----------------------------------------------------------------------
      CHARACTER TTYPE*2
      INTEGER   KVOL, ISLOT, IVER, IRET
C
      INTEGER   IBUFF(256), LUN, FIND, ISIZE, IC, IL, IREC, IPOS
      CHARACTER PHNAME*48
      INCLUDE 'FITTP.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LUN /89/
C-----------------------------------------------------------------------
      CALL ZPHFIL (TTYPE, KVOL, ISLOT, IVER, PHNAME, IRET)
      CALL ZEXIST (KVOL, PHNAME, ISIZE, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IVER
         CALL MSGWRT (7)
         IRET = 0
         GO TO 999
         END IF
      CALL ZOPEN (LUN, FIND, KVOL, PHNAME, .FALSE., .FALSE., .TRUE.,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, IVER, 'OPEN PLOT FILE'
         GO TO 980
         END IF
C                                       Table header
      ICARD = 0
C                                       Tell user table and type
      WRITE (MSGTXT,1015) TTYPE, IVER
      CALL MSGWRT (3)
      WRITE (MSGTXT,1050)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1051)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1052)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1053)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1054) ISIZE
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1055)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1056)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1057)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1058) TTYPE
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1059) IVER
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1060)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      WRITE (MSGTXT,1061)
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      MSGTXT = 'COMMENT  This file is not really a table'
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      MSGTXT = 'COMMENT  It is a literal copy of an AIPS ' //
     *   TTYPE // ' file'
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      MSGTXT = 'COMMENT  and is only useful if read back into AIPS'
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
      MSGTXT = 'END'
      CALL FT2CHM (MSGTXT, ICARD, FITBLK)
C                                       Blank fill rest of block.
      IC = 80 * ICARD  + 1
      IL = 2881 - IC
      IF (IL.GT.0) THEN
         LINE (IC:2880) = ' '
         CALL ZCLC8 (IL, LINE(IC:2880), IC, FITBLK)
         END IF
      CALL WRCTAP (IRET)
      IF (IRET.NE.0) GO TO 900
C                                       copy pl file
      IPOS = 1
      DO 100 IREC = 1,ISIZE
         CALL ZFIO ('READ', LUN, FIND, IREC, IBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, IVER, 'READING PLOT FILE'
            GO TO 980
            END IF
         IF (IPOS+255.LE.720) THEN
            CALL COPY (256, IBUFF, FITBLK(IPOS))
            IPOS = IPOS + 256
         ELSE
            IL = 721-IPOS
            CALL COPY (IL, IBUFF, FITBLK(IPOS))
            CALL ZILI32 (720, FITBLK, 1, FITBLK)
            CALL WRCTAP (IRET)
            IF (IRET.NE.0) GO TO 900
            IC = 256 - IL
            CALL COPY (IC, IBUFF(IL+1), FITBLK(1))
            IPOS = 1 + IC
         END IF
 100  CONTINUE
      IF (IPOS.GT.1) THEN
         IL = 721 - IPOS
         CALL FILL (IL, 0, FITBLK(IPOS))
         CALL ZILI32 (720, FITBLK, 1, FITBLK)
         CALL WRCTAP (IRET)
         IF (IRET.NE.0) GO TO 900
      END IF
      CALL ZCLOSE (LUN, FIND, IC)
      GO TO 999
C
 900  WRITE (MSGTXT,1000) IRET, IVER, 'WRITING FITS FILE'
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FITPL ERROR',I4,' PL VERS',I4,' ON ',A)
 1010 FORMAT ('FITPL: PL VERSION',I5,' DOES NOT EXIST')
 1015 FORMAT ('Writing ',A,' file as binary table version',I5)
 1050 FORMAT ('XTENSION= ''BINTABLE''',11X,'/ Extension type')
 1051 FORMAT ('BITPIX  =',20X,'8',1X,'/ Binary data')
 1052 FORMAT ('NAXIS   =',20X,'2',1X,'/ Table is a matrix')
 1053 FORMAT ('NAXIS1  =',17X,'1024 / Width of table in bytes')
 1054 FORMAT ('NAXIS2  =',13X,I8,1X,'/ Number of entries in table')
 1055 FORMAT ('PCOUNT  =',20X,'0',1X,'/ Random parameter count')
 1056 FORMAT ('GCOUNT  =',20X,'1',1X,'/ Group count')
 1057 FORMAT ('TFIELDS =',19X,' 1 / Number of fields in each row')
 1058 FORMAT ('EXTNAME = ''AIPS ',A2,'''',11X,'/ AIPS PL or SL file')
 1059 FORMAT ('EXTVER  = ',15X,I5,1X,'/ Version number of plot')
 1060 FORMAT ('TFORM001= ''256J''',15X,'/ Version number of plot')
 1061 FORMAT ('TTYPE001= ''Plot data''')
      END
      SUBROUTINE FQ2CH (DISK, CNO, DOFQCH, FQTRN, IERR)
C-----------------------------------------------------------------------
C  Routine to determine if an FQ table is present, if it is and it
C  has only one row then it will be translated to a CH table. An
C  exception is if the one row has an FQ ID > 1, in which case the
C  translation must not occur.
C  Input:
C    DISK             I       Vol. number on which FQ table exists
C    CNO              I       Catalogue number
C    DOFQCH           L       If TRUE will try to translate FQ -> CH
C                             if possible
C  Output:
C    FQTRN            L       True if FQ translated to CH
C    IERR             I       Error code, 0=> OK
C-----------------------------------------------------------------------
      INTEGER IERR
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER CTEMP*12, UTYPE*2, STAT*4, BNDCOD(MAXIF)*8
      INTEGER DISK, CNO, VER, LUN, BUFFER(512), JERR, IFQRNO,
     *   FQKOLS(MAXFQC), FQNUMV(MAXFQC), NIF, NUMFQE, FQID, FQVER,
     *   FQSID(MAXIF), ISBAND(MAXIF), IDUM, I
      LOGICAL TABLE, FQEXIS, FITASC, CHSTAT, FQTRN, DOFQCH
      REAL    FQCHB(MAXIF), FQTBW(MAXIF)
      DOUBLE PRECISION FQFRQ(MAXIF), FOFF(MAXIF)
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LUN /30/
C-----------------------------------------------------------------------
      IERR = 0
      FQTRN = .FALSE.
      IF (.NOT.DOFQCH) GO TO 999
C                                       Does FQ table exist
      VER = 1
      CALL ISTAB ('FQ', DISK, CNO, VER, LUN, BUFFER, TABLE, FQEXIS,
     *   FITASC, JERR)
      IF (.NOT. FQEXIS) GO TO 999
C                                       Read it and check number
C                                       of rows
      CALL FQINI ('READ', BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IFQRNO, FQKOLS, FQNUMV, NIF, IERR)
      IF (IERR.NE.0) GO TO 999
      NUMFQE = BUFFER(5)
      FQVER = VER
      IF (NUMFQE.GT.1) THEN
         CALL TABIO ('CLOS', 0, IFQRNO, BUFFER, BUFFER, JERR)
         GO TO 999
         END IF
C                                       Otherwise read and store
      IFQRNO = 1
      CALL TABFQ ('READ', BUFFER, IFQRNO, FQKOLS, FQNUMV, NIF, FQID,
     *   FQFRQ, FQCHB, FQTBW, FQSID, BNDCOD, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (FQID.NE.1) THEN
         CALL TABIO ('CLOS', 0, IFQRNO, BUFFER, BUFFER, JERR)
         GO TO 999
         END IF
      DO 100 I = 1, NIF
         FOFF(I) = FQFRQ(I)
         ISBAND(I) = FQSID(I)
 100     CONTINUE
      CALL TABIO ('CLOS', 0, IFQRNO, BUFFER, BUFFER, JERR)
C                                       Create CH table
C                                       Determine status of file
      UTYPE = 'UV'
      CHSTAT = .FALSE.
      CALL CATDIR ('INFO', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE, IDUM,
     *   STAT, BUFFER, IERR)
      IF (STAT.EQ.'READ') THEN
C                                       Change status
         STAT = 'CLRD'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, 'CLRD'
            GO TO 990
            END IF
         STAT = 'WRIT'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, 'WRIT'
            GO TO 990
            END IF
         CHSTAT = .TRUE.
         END IF
C                                       # rows in old table
      VER = 1
      CALL OLDCHN ('WRIT', BUFFER, DISK, CNO, VER, CATBLK, LUN, NIF,
     *   FOFF, ISBAND, IERR)
      FQTRN = .TRUE.
      IF (IERR.NE.0) GO TO 999
C                                       Check if changed status
      IF (CHSTAT) THEN
         STAT = 'CLWR'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, 'CLWR'
            GO TO 990
            END IF
         STAT = 'READ'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, 'READ'
            GO TO 990
            END IF
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('FQ2CH: ERROR ',I3,' CHANGING ',A4,' STATUS')
      END
      SUBROUTINE OLDCHN (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   NIF, FOFF, ISBAND, IERR)
C-----------------------------------------------------------------------
C   Creates and fills or reads CH (IF descriptor) extension tables.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'WRIT' = create/init for write or read
C                        'READ' = open for read only
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      CATBLK   I(256)   Catalog header block.
C      LUN      I        Logical unit number to use
C   Input/Output:
C      VER      I        CH file version
C      NIF      I        Number of IFs.
C      FOFF     D(*)     Frequency offset in Hz from ref. freq.
C                           True = reference + offset.
C      ISBAND   I(*  )   Sideband of each IF.
C                        -1 => 0 video freq. is high freq. end
C                         1 => 0 video freq. is low freq. end
C   Output:
C      IERR     I        Return error code, 0=>OK, else TABINI or TABIO
C                        error.
C-----------------------------------------------------------------------
      CHARACTER CHIF*8, OPCODE*4, TTITLE*56, TITLE(3)*24, UNITS(3)*8
      HOLLERITH HOLTMP(14)
      INTEGER   BUFFER(512), DISK, CNO, VER, LUN, IERR, CATBLK(256),
     *   NKEY, NREC, DATP(128,2), NCOL, CHKOLS(3), NTT, DTYP(3), NDATA,
     *   ISBAND(*), RECI(8), JERR, IFOFF, NOKOL, OFFKOL, SBKOL, NIF,
     *   INTTMP(14)
      LOGICAL   DOREAD
      INTEGER   ICHRNO, NUMCH, I, J
      DOUBLE PRECISION  FOFF(*), RECD(4)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (INTTMP, HOLTMP)
      EQUIVALENCE (CHKOLS(1), NOKOL), (CHKOLS(2), OFFKOL),
     *   (CHKOLS(3), SBKOL),     (RECI, RECD)
      DATA NTT /56/
      DATA CHIF /'IF      '/
      DATA TTITLE /'AIPS UV DATA FILE IF DESCRIPTOR TABLE           '/
      DATA NDATA /3/
      DATA DTYP /14,11,14/
      DATA TITLE /'IF NO.                  ',
     *   'FREQUENCY OFFSET        ', 'SIDEBAND                '/
      DATA UNITS /'        ', 'HZ      ', '        '/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       See if CH table should be there
      CALL COPY (14, CATBLK(KHCTP), INTTMP)
      CALL AXEFND (4, CHIF, CATBLK(KIDIM), HOLTMP, IFOFF, JERR)
      IF ((JERR.NE.0) .OR. (IFOFF.LT.0)) GO TO 500
C                                       Open file
      NREC = 20
      NCOL = NDATA
      NKEY = 0
C                                       Fill in types
      CALL COPY (NDATA, DTYP, DATP(1,2))
C                                       Create/open file
      CALL TABINI (OPCODE, 'CH', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) GO TO 999
C                                       See if file exists.
      IF (IERR.NE.0) THEN
C                                       File created, initialize
         DO 40 I = 1,NDATA
C                                       Col. labels.
            CALL CHR2H (24, TITLE(I), 1, HOLTMP)
            CALL TABIO ('WRIT', 3, I, INTTMP, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, HOLTMP)
            CALL TABIO ('WRIT', 4, I, INTTMP, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 999
 40         CONTINUE
         END IF
C                                       Get number of Channels
      NUMCH = BUFFER(5)
C                                       Set NIF
      IF (DOREAD) NIF = NUMCH
C                                       Fill in Table title
      IF (.NOT.DOREAD) THEN
         CALL CHR2H (NTT, TTITLE, 1, HOLTMP)
         CALL COPY (14, INTTMP, BUFFER(101))
         END IF
C                                       Get array indices
      DO 150 I = 1,NDATA
         CHKOLS(I) = DATP(I,1)
 150     CONTINUE
C                                       Read/write table entries
      DO 200 I = 1,NIF
         ICHRNO = I
C                                       If write fill RECORD
         IF (.NOT.DOREAD) THEN
            RECI(NOKOL) = I
            RECI(SBKOL) = ISBAND(I)
            RECD(OFFKOL) = FOFF(I)
            END IF
C                                       Process record.
         CALL TABIO (OPCODE, 0, ICHRNO, RECI, BUFFER, IERR)
         IF (IERR.GT.0) GO TO 999
         IF (IERR.LT.0) GO TO 200
C                                       If READ pick data from RECORD.
         IF (DOREAD) THEN
            J = RECI(NOKOL)
            FOFF(J) = RECD(OFFKOL)
            ISBAND(J) = RECI(SBKOL)
            END IF
 200     CONTINUE
C                                       Close
      CALL TABIO ('CLOS', 0, ICHRNO, RECI, BUFFER, IERR)
      GO TO 999
C                                       Case of no or 1 IF axis.
C                                       If write just return
 500  IF (DOREAD) THEN
         NIF = 1
         FOFF(1) = 0.0D0
         ISBAND(1) = 0
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'FGCNT.INC'
C                                       Local include for FGCNT
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4,30), XCALC(1), XXSTOK(1),
     *   XOPTYP(1), XOUTFI(12)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XANT(50), XBASE(50), XSUBA, XBIF, XEIF, XBCHAN, XECHAN,
     *   XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XFLAG2, XDOBND,
     *   XBPVER, XSMOTH(3), XDOAC, PRTLEV, XIF, XCHAN, XREF, BADD(10),
     *   SCRBUF(256), BUFF2(UVBFSS)
      INTEGER   SEQIN, DISKIN, JBUFSZ, CATOLD(256), INCSI, INCFI,
     *   INCIFI, INCSO, INCFO, INCIFO, LRECO, OLDCNO, IXANT(50),
     *   IXBAS(50), NXANT, NXBAS, INSNUM, POLTYP, SPIF, SPCHAN, SPANT
      LOGICAL   DESEL, ONLY1, NOCAL, DOSPEC
      CHARACTER NAMEIN*12, CLAIN*6, OPTYPE*4, OUTFIL*48
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XXSTOK, XTIME, XBAND, XFREQ, XFQID, XANT, XBASE, XSUBA, XBIF,
     *   XEIF, XBCHAN, XECHAN, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER,
     *   XFLAG, XFLAG2, XDOBND, XBPVER, XSMOTH, XDOAC, XOPTYP, PRTLEV,
     *   XIF, XCHAN, XREF, XOUTFI, BADD
      COMMON /FGCNTP/ CATOLD, SEQIN, DISKIN, INCSI, INCFI, INCIFI,
     *   INCSO, INCFO, INCIFO, LRECO, OLDCNO, IXANT, IXBAS, NXANT,
     *   NXBAS, DESEL, INSNUM, POLTYP, ONLY1, NOCAL, DOSPEC, SPIF,
     *   SPCHAN, SPANT
      COMMON /CHARPM/ NAMEIN, CLAIN, OPTYPE, OUTFIL
      COMMON /BUFRS/ SCRBUF, BUFF2, JBUFSZ
C                                       End local include for FGCNT
LOCAL END
LOCAL INCLUDE 'FGCNTSOU.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER NUMSOU, SUNUMS(1000), SUMAX(1000,2), LP1, LP2, LF1, LF2,
     *   WANT(MAXANT), NUMCH, NUMIFS, PRTL
      CHARACTER SUNAMS(1000)*16
      COMMON /SUCOMM/ NUMSOU, SUNUMS, SUMAX, WANT, LP1, LP2, LF1, LF2,
     *   NUMCH, NUMIFS, PRTL
      COMMON /SUCOMC/ SUNAMS
LOCAL END
      PROGRAM FGCNT
C-----------------------------------------------------------------------
C! counts samples with different sampling
C# Utility UV editing
C-----------------------------------------------------------------------
C;  Copyright (C) 2016, 2018, 2020, 2022, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FGCNT counts sampling with flag versions FLAGVER and optionally
C   IN2VERS
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, VISCNT(2), ANTCNT(2), NWORDS, NC
      LONGINT   VISPTR, ANTPTR
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'FGCNT.INC'
      INCLUDE 'FGCNTSOU.INC'
      DATA PRGM /'FGCNT'/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL FGCNTI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       counting memories
      NC = NUMIFS
      IF (ONLY1) NC = NC * NUMCH
      NWORDS = (4 * NC * NUMSOU * 2 - 1) / 1024 + 4
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, VISCNT, VISPTR, IRET)
      IF ((IRET.EQ.0) .AND. (OPTYPE(:2).EQ.'AN')) THEN
         NWORDS = (4 * NC * MAXANT * NUMSOU * 2 - 1) / 1024 + 4
         CALL ZMEMRY ('GET ', TSKNAM, NWORDS, ANTCNT, ANTPTR, IRET)
         END IF
      IF (IRET.NE.0) THEN
         MSGTXT = 'FAILED TO GET DYNAMIC MEMORY NEEDED'
         CALL MSGWRT (8)
         GO TO 990
         END IF
      SPIF = SPIF - BIF + 1
      SPCHAN = SPCHAN - BCHAN + 1
C                                       Count the flagged data
      IF (NOCAL) THEN
         CALL FGCNTN (NC, MAXANT, NUMSOU, VISCNT(1+VISPTR),
     *      ANTCNT(1+ANTPTR), IRET)
      ELSE
         CALL FGCNTU (NC, MAXANT, NUMSOU, VISCNT(1+VISPTR),
     *      ANTCNT(1+ANTPTR), IRET)
         END IF
         IF (IRET.NE.0) GO TO 990

      IF (DOSPEC) CALL PRTSPC (0, 0, 0, 10000.0, BUFF2)
C                                       print the results
      CALL FGCNTH (OPTYPE, ONLY1, NC, MAXANT, NUMSOU, VISCNT(1+VISPTR),
     *   ANTCNT(1+ANTPTR), POLTYP)
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE FGCNTI (PRGN, JERR)
C-----------------------------------------------------------------------
C   FGCNTI gets input parameters for FGCNT and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, NFREQ, LUN, J
      LOGICAL   MATCH
      REAL      CATR(256), RPARM(20)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'FGCNT.INC'
      INCLUDE 'FGCNTSOU.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      DATA BLANK  /' '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 286
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (4, 1, XXSTOK, STOKES)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      CALL H2CHR (48, 1, XOUTFI, OUTFIL)
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      PRTL = IROUND (PRTLEV)
      SPIF = XIF + 0.1
      SPCHAN = XCHAN + 0.1
      SPANT = XREF + 0.1
      DOSPEC = (SPIF.GT.0) .AND. (SPCHAN.GT.0) .AND. (OUTFIL.NE.' ')
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = XDOAC.GT.0.0
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      IF (FGVER.LE.0) FGVER = -1
      IF (OPTYPE.EQ.'ANCH') XFLAG2 = 0.0
      ONLY1 = XFLAG2.LT.0.5
      NOCAL = ONLY1 .AND. (XFLAG.LT.0.) .AND. (XDOBND.LT.0.) .AND.
     *   (XDOCAL.LT.0.)
      IF (ONLY1) STOKES = ' '
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING HEADR'
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NUMIFS = EIF - BIF + 1
      NFREQ = CATBLK(KINAX+JLOCF)
      LF1 = IROUND (XBCHAN)
      LF2 = IROUND (XECHAN)
      IF ((LF1.LE.0) .OR. (LF1.GT.NFREQ)) LF1 = 1
      IF ((LF2.LE.0) .OR. (LF2.GT.NFREQ)) LF2 = NFREQ
      IF (LF1.GT.LF2) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
      IF (NOCAL) THEN
         BCHAN = 1
         ECHAN = NFREQ
      ELSE
         BCHAN = LF1
         ECHAN = LF2
         END IF
      NUMCH = ECHAN - BCHAN + 1
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       Find baselines to copy
      CALL SETANT (50, XANT, XBASE, NXANT, NXBAS, IXANT, IXBAS, DESEL)
C                                       print desires
      IF (ONLY1) THEN
         IF (DESEL) THEN
            J = 0
            CALL FILL (MAXANT, 1, WANT)
         ELSE
            J = 1
            CALL FILL (MAXANT, 0, WANT)
            END IF
         DO 20 I = 1,NXANT
            WANT(IXANT(I)) = J
 20         CONTINUE
         CALL H2CHR (4, 1, XXSTOK, STAT)
         LP1 = 1
         LP2 = 4
         IF ((STAT.EQ.'HALF') .OR. (STAT.EQ.'RRLL') .OR.
     *      (STAT.EQ.'VVHH')) THEN
            LP2 = 2
         ELSE IF ((STAT.EQ.'CROS') .OR. (STAT.EQ.'RLLR') .OR.
     *      (STAT.EQ.'VHHV')) THEN
            LP1 = 3
            LP2 = 4
         ELSE IF ((STAT.EQ.'RR') .OR. (STAT.EQ.'VV')) THEN
            LP2 = 1
         ELSE IF ((STAT.EQ.'LL') .OR. (STAT.EQ.'HH')) THEN
            LP1 = 2
            LP2 = 2
         ELSE IF ((STAT.EQ.'RL') .OR. (STAT.EQ.'VH')) THEN
            LP1 = 3
            LP2 = 3
         ELSE IF ((STAT.EQ.'LR') .OR. (STAT.EQ.'HV')) THEN
            LP1 = 4
            LP2 = 4
            END IF
         END IF
C                                       now using cal system -
C                                       UVGET makes header
      IF (.NOT.NOCAL) THEN
         CALL UVGET ('INIT', RPARM, SCRBUF, JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1035) JERR
            GO TO 990
            END IF
         CALL UVGET ('CLOS', RPARM, SCRBUF, IERR)
         END IF
      INSNUM = 1
      IF ((NSOUWD.EQ.1) .AND. (DOSWNT)) INSNUM = SOUWAN(1)
      POLTYP = 4
      IF (ICOR0.EQ.-1) THEN
         IF (CATR(KRCIC+JLOCS).EQ.-1.0) POLTYP = 1
      ELSE IF (ICOR0.EQ.-5) THEN
         IF (CATR(KRCIC+JLOCS).EQ.-1.0) POLTYP = 2
      ELSE IF (ICOR0.EQ.1) THEN
         IF (CATR(KRCIC+JLOCS).EQ.1.0) POLTYP = 3
         END IF
C                                       Save input file info
      INCX = CATBLK(KINAX)
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', SCRBUF, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       set up source and count common
      CALL SOUSET (DISKIN, OLDCNO, CATOLD, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1000) JERR, 'READING SOURCE TABLE'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FGCNTI: ERROR',I3,1X,A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
      END
      SUBROUTINE SOUSET (DISK, CNO, CATBLK, IRET)
C-----------------------------------------------------------------------
C   reads source numbers and names from source file
C   Inputs:
C      DISK     I      Disk number
C      CNO      I      Catalog number
C      CATBLK   I(*)   input header
C   Output:
C      IRET     I      error code
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, CATBLK(256), IRET
C
      INTEGER   NREC, IREC, VER, LUN, NKEY, NCOL, DATP(128,2), I,
     *   BUFFER(512), KOLS(2), SUNUM, LRNO, SCRTCH(1024), ITYPE,
     *   INAME(4)
      CHARACTER KOLTYP(2)*24
      HOLLERITH HNAME(4)
      EQUIVALENCE (INAME, HNAME)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'FGCNTSOU.INC'
      DATA KOLTYP /'ID. NO.', 'SOURCE'/
C-----------------------------------------------------------------------
C                                       single source?
      CALL FNDEXT ('SU', CATBLK, I)
      IF (I.LE.0) THEN
         NUMSOU = 1
         SUNAMS(1) = ' '
         CALL COPY (2, CATBLK(KHOBJ), INAME)
         CALL H2CHR (8, 1, HNAME, SUNAMS(1))
         GO TO 999
         END IF
C                                       open source table
      VER = 1
      LUN = 86
      CALL TABINI ('READ', 'SU', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN SOURCE TABLE'
         GO TO 980
         END IF
C                                       locate columns
      CALL FNDCOL (2, KOLTYP, 24, .TRUE., BUFFER, KOLS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FIND SOURCE NAME AND NUMBER COLS'
         GO TO 980
         END IF
C                                       read it
      NREC = BUFFER(5)
      LRNO = 0
      DO 100 IREC = 1,NREC
         CALL GETCOL (IREC, KOLS(1), DATP, LRNO, BUFFER, ITYPE, HNAME,
     *      SCRTCH, IRET)
         SUNUM = INAME(1)
         IF (IRET.EQ.0) CALL GETCOL (IREC, KOLS(2), DATP, LRNO, BUFFER,
     *      ITYPE, HNAME, SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ SU TABLE ROW'
            GO TO 980
            END IF
         CALL H2CHR (16, 1, HNAME, SUNAMS(IREC))
         SUNUMS(IREC) = SUNUM
 100     CONTINUE
      NUMSOU = NREC
      CALL TABIO ('CLOS', 0, IREC, BUFFER, BUFFER, IRET)
      GO TO 999
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SOUSET ERROR',I4,' ON ',A)
      END
      SUBROUTINE FGCNTU (NI, NA, NS, VISCNT, ANTCNT, IRET)
C-----------------------------------------------------------------------
C   FGCNTU reads with flag table 1 calling counter subroutine, then
C   if desired reads with flag table 2 calling counter routine
C   Inputs:
C      NI       I      Number channels
C      NA       I      Number antennas
C      NS       I      Number sources
C   Outputs:
C      VISCNT   I(*)   Counts (pol,chan,source,2)
C      ANTCNT   I(*)   Counts (pol,chan,antenna,source,2)
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NI, NA, NS, VISCNT(4,NI,NS,2), ANTCNT(4,NI,NA,NS,2),
     *   IRET
C
      INCLUDE 'FGCNT.INC'
      INTEGER   IA1, IA2, NUMVS1, NUMVS2, CATMP(256), I, ITYP
      LOGICAL   REQBAS
      REAL      BASEN, VIS(UVBFSS), RPARM(20)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
C                                       defend cat header from UVGET
      CALL COPY (256, CATBLK, CATMP)
      WRITE (MSGTXT,1010) FGVER
      CALL MSGWRT (2)
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL COPY (256, CATMP, CATBLK)
      CALL UVPGET (IRET)
      NUMVS1 = 0
      NUMVS2 = 0
      I = 4 * NI * NS * 2
      CALL FILL (I, 0, VISCNT)
      I = I * NA
      IF (OPTYPE(:2).EQ.'AN') CALL FILL (I, 0, ANTCNT)
      ITYP = 1
      IF (ONLY1) ITYP = 0
C                                       Loop for before
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over buffer
      ELSE IF (IRET.EQ.0) THEN
         IF (ILOCB.GE.0) THEN
            BASEN = RPARM(1+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
         END IF
         IF (.NOT.ONLY1) THEN
            IF (.NOT.REQBAS (IA1, IA2, DESEL, IXANT, NXANT, IXBAS,
     *         NXBAS)) GO TO 100
            END IF
         NUMVS1 = NUMVS1 + 1
C                                       call counting routine
         CALL FGCNTC (ITYP, VIS, RPARM, IA1, IA2, NI, NA, NS, VISCNT,
     *      ANTCNT)
C                                       read next
         GO TO 100
         END IF
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      IF (ONLY1) GO TO 999
C                                       now after
      FGVER = XFLAG2 + 0.1
      WRITE (MSGTXT,1010) FGVER
      CALL MSGWRT (2)
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL COPY (256, CATMP, CATBLK)
      CALL UVPGET (IRET)
C                                       Loop for after
C                                       Read vis. record.
 200  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over buffer
      ELSE IF (IRET.EQ.0) THEN
         IF (ILOCB.GE.0) THEN
            BASEN = RPARM(1+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
            END IF
         IF (.NOT.REQBAS (IA1, IA2, DESEL, IXANT, NXANT, IXBAS, NXBAS))
     *      GO TO 200
         NUMVS2 = NUMVS2 + 1
C                                       call counting routine
         CALL FGCNTC (2, VIS, RPARM, IA1, IA2, NI, NA, NS, VISCNT,
     *      ANTCNT)
C                                       read next
         GO TO 200
         END IF
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FGCNTU: ERROR',I3,' OPEN/INIT INPUT VIS FILE')
 1010 FORMAT ('Start reading with flag table version',I5)
 1100 FORMAT ('FGCNTU: ERROR',I3,' READING VIS FILE')
      END
      SUBROUTINE FGCNTN (NI, NA, NS, VISCNT, ANTCNT, IRET)
C-----------------------------------------------------------------------
C   FGCNTN reads with no flagging or other calibration
C   Inputs:
C      NI       I      Number channels
C      NA       I      Number antennas
C      NS       I      Number sources
C   Outputs:
C      VISCNT   I(*)   Counts (pol,chan,source,2)
C      ANTCNT   I(*)   Counts (pol,chan,antenna,source,2)
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NI, NA, NS, VISCNT(4,NI,NS,2), ANTCNT(4,NI,NA,NS,2),
     *   IRET
C
      INCLUDE 'FGCNT.INC'
      CHARACTER IFILE*48
      INTEGER   IA1, IA2, NCORI, LUNI, INDI, VO, ILENBU, I, BO, IBIND,
     *   IPTRI, NUMVIS, INIO, ILOCWT
      REAL      BASEN, CBUFF(UVBFSS)
      LOGICAL   T, F, ISCOMP
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI /16/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            IRET = 9
            GO TO 990
            END IF
         END IF
C                                       Number of visibilities in input
C                                       and output files.
      NCORI = (LREC - NRPARM) / CATBLK(KINAX)
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF2, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      I = 4 * NI * NS * 2
      CALL FILL (I, 0, VISCNT)
      I = I * NA
      IF (OPTYPE(:2).EQ.'AN') CALL FILL (I, 0, ANTCNT)
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF2, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Out of data?
         IF (INIO.LE.0) GO TO 200
C                                       Loop over buffer
         DO 190 I = 1,INIO
            IF (ILOCB.GE.0) THEN
               BASEN = BUFF2(IPTRI+ILOCB)
               IA1 = BASEN / 256. + 0.1
               IA2 = BASEN - IA1*256. + 0.1
            ELSE
               IA1 = BUFF2(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF2(IPTRI+ILOCA2) + 0.1
               END IF
            NUMVIS = NUMVIS + 1
C                                      Call user routine.
            IF (ISCOMP) THEN
C                                       Compressed data.
               CALL ZUVXPN (NCORI, BUFF2(IPTRI+NRPARM),
     *            BUFF2(IPTRI+ILOCWT), CBUFF)
C                                       call counting routine
               CALL FGCNTC (0, CBUFF, BUFF2(IPTRI), IA1, IA2, NI, NA,
     *            NS, VISCNT, ANTCNT)
            ELSE
C                                       Un compressed data
C                                       call counting routine
               CALL FGCNTC (0, BUFF2(IPTRI+NRPARM), BUFF2(IPTRI), IA1,
     *            IA2, NI, NA, NS, VISCNT, ANTCNT)
               END IF
C                                       OK, but no output please
            IPTRI = IPTRI + LREC
 190        CONTINUE
C                                       Read next buffer.
         GO TO 100
C                                       Close files
 200  CALL ZCLOSE (LUNI, INDI, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FGCNTN: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1030 FORMAT ('FGCNTN: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('FGCNTN: ERROR',I3,' READING VIS FILE')
      END
      SUBROUTINE FGCNTH (OPTYPE, ONLY1, NI, NA, NS, VISCNT, ANTCNT,
     *   POLTYP)
C-----------------------------------------------------------------------
C   FGCNTH prints the results
C-----------------------------------------------------------------------
      CHARACTER OPTYPE*4
      LOGICAL   ONLY1
      INTEGER   NI, NA, NS, VISCNT(4,NI,NS,2), ANTCNT(4,NI,NA,NS,2),
     *   POLTYP
C
      INTEGER   LP, LS, LI, JI, LA, N1, N2, N3, J, JTRIM, LF, JJ, JF
      REAL      FRAC
      LOGICAL   FIRST
      CHARACTER POLLAB(4,4)*2
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'FGCNTSOU.INC'
      DATA POLLAB /'RR','LL','RL','LR', 'HH','VV','VH','HV',
     *   'I','Q','U','V', '1','2','3','4'/
C-----------------------------------------------------------------------
C                                       Find maximum
      DO 840 LS = 1,NUMSOU
         SUMAX(LS,1) = 0
         SUMAX(LS,2) = 0
         DO 830 LP = 1,4
            DO 820 LI = 1,NI
               SUMAX(LS,1) = MAX (SUMAX(LS,1), VISCNT(LP,LI,LS,1))
               IF (OPTYPE(:2).EQ.'AN') THEN
                  DO 810 LA = 1,NA
                     SUMAX(LS,2) = MAX (SUMAX(LS,2),
     *                  ANTCNT(LP,LI,LA,LS,1))
 810                 CONTINUE
                  END IF
 820           CONTINUE
 830        CONTINUE
 840     CONTINUE
C                                       sum over antennas
      IF (.NOT.ONLY1) THEN
         IF (OPTYPE(:2).NE.'AN') THEN
            WRITE (MSGTXT,1000)
            CALL MSGWRT (5)
            DO 40 LS = 1,NUMSOU
               J = JTRIM (SUNAMS(LS))
               DO 30 LP = 1,4
                  FIRST = .TRUE.
                  DO 20 LI = BIF,EIF
                     JI = LI - BIF + 1
                     IF ((VISCNT(LP,JI,LS,1).GT.0) .OR.
     *                  (VISCNT(LP,JI,LS,2).GT.0)) THEN
                        FRAC = (VISCNT(LP,JI,LS,1) - VISCNT(LP,JI,LS,2))
                        FRAC = (100.0 * FRAC) / VISCNT(LP,JI,LS,1)
                        IF (FIRST) THEN
                           WRITE (MSGTXT,1010) SUNUMS(LS),
     *                        SUNAMS(LS)(:J),POLLAB(LP,POLTYP)
                           CALL MSGWRT (5)
                           FIRST = .FALSE.
                           END IF
                        WRITE (MSGTXT,1020) LI, VISCNT(LP,JI,LS,1),
     *                     VISCNT(LP,JI,LS,2), FRAC
                        CALL MSGWRT (5)
                        END IF
 20                  CONTINUE
 30               CONTINUE
 40           CONTINUE
C                                       sum over IFS
         ELSE IF (OPTYPE.EQ.'ANTE') THEN
            WRITE (MSGTXT,1100)
            CALL MSGWRT (5)
            DO 140 LS = 1,NUMSOU
               J = JTRIM (SUNAMS(LS))
               DO 130 LA = 1,NA
                  FIRST = .TRUE.
                  DO 120 LP = 1,4
                     N1 = 0
                     N2 = 0
                     DO 110 JI = 1,NI
                        N1 = N1 + ANTCNT(LP,JI,LA,LS,1)
                        N2 = N2 + ANTCNT(LP,JI,LA,LS,2)
 110                    CONTINUE
                     IF (N1.GT.0) THEN
                        FRAC = (100.0 * (N1 - N2)) / N1
                        IF (FIRST) THEN
                           WRITE (MSGTXT,1110) SUNUMS(LS),
     *                        SUNAMS(LS)(:J), LA, BIF, EIF
                           CALL MSGWRT (5)
                           FIRST = .FALSE.
                           END IF
                        WRITE (MSGTXT,1120) POLLAB(LP,POLTYP), N1, N2,
     *                     FRAC
                        CALL MSGWRT (5)
                        END IF
 120                 CONTINUE
 130              CONTINUE
 140          CONTINUE
         ELSE IF (OPTYPE.EQ.'ANIF') THEN
            WRITE (MSGTXT,1000)
            CALL MSGWRT (5)
            DO 250 LS = 1,NUMSOU
               J = JTRIM (SUNAMS(LS))
               DO 240 LA = 1,NA
                  DO 230 LP = 1,4
                     FIRST = .TRUE.
                     DO 220 LI = BIF,EIF
                        JI = LI - BIF + 1
                        IF (ANTCNT(LP,JI,LA,LS,1).GT.0) THEN
                           FRAC = ANTCNT(LP,JI,LA,LS,1) -
     *                        ANTCNT(LP,JI,LA,LS,2)
                           FRAC = (100.0 * FRAC) / ANTCNT(LP,JI,LA,LS,1)
                           IF (FIRST) THEN
                              WRITE (MSGTXT,1210) SUNUMS(LS),
     *                           SUNAMS(LS)(:J), LA, POLLAB(LP,POLTYP)
                              CALL MSGWRT (5)
                              FIRST = .FALSE.
                              END IF
                           WRITE (MSGTXT,1020) LI,
     *                        ANTCNT(LP,JI,LA,LS,1),
     *                        ANTCNT(LP,JI,LA,LS,2), FRAC
                           CALL MSGWRT (5)
                           END IF
 220                    CONTINUE
 230                 CONTINUE
 240              CONTINUE
 250           CONTINUE
            END IF
C                                       Have by spectral channel
      ELSE
C                                       sum over antennas
         IF (OPTYPE(:2).NE.'AN') THEN
            WRITE (MSGTXT,1300)
            CALL MSGWRT (5)
            DO 340 LS = 1,NUMSOU
               J = JTRIM (SUNAMS(LS))
               DO 330 LP = LP1,LP2
                  FIRST = .TRUE.
                  JJ = 0
                  DO 320 LI = BIF,EIF
                     JI = LI - BIF + 1
                     DO 310 LF = BCHAN,ECHAN
                        JF = LF - BCHAN + 1
                        JJ = JJ + 1
                        IF ((LF.LT.LF1) .OR. (LF.GT.LF2)) GO TO 310
                        N1 = VISCNT(LP,JJ,LS,1)
                        N2 = SUMAX(LS,1)-VISCNT(LP,JJ,LS,1)
                        N3 = VISCNT(LP,JJ,LS,2)
                        IF (N1.GT.0) THEN
                           IF (FIRST) THEN
                              WRITE (MSGTXT,1310) SUNUMS(LS),
     *                           SUNAMS(LS)(:J)
                              CALL MSGWRT (5)
                              FIRST = .FALSE.
                              END IF
                           WRITE (MSGTXT,1320) POLLAB(LP,POLTYP), LI,
     *                           LF, N1, N2, N3
                           IF ((PRTL.GT.0) .OR. (N2.GT.0) .OR.
     *                        (N3.GT.0)) CALL MSGWRT (5)
                           END IF
 310                    CONTINUE
 320                 CONTINUE
 330              CONTINUE
 340           CONTINUE
C                                       sum over IFS
         ELSE IF (OPTYPE.EQ.'ANTE') THEN
            WRITE (MSGTXT,1400)
            CALL MSGWRT (5)
            DO 440 LS = 1,NUMSOU
               J = JTRIM (SUNAMS(LS))
               DO 430 LA = 1,NA
                  FIRST = .TRUE.
                  IF (WANT(LA).EQ.0) GO TO 430
                  DO 420 LP = LP1,LP2
                     N1 = 0
                     N2 = 0
                     N3 = 0
                     JI = 0
                     DO 410 LI = BIF,EIF
                        DO 409 JF = BCHAN,ECHAN
                           JI = JI + 1
                           IF ((JF.LT.LF1) .OR. (JF.GT.LF2)) GO TO 409
                           N1 = N1 + ANTCNT(LP,JI,LA,LS,1)
                           N2 = N2 + SUMAX(ls,2)-ANTCNT(LP,JI,LA,LS,1)
                           N3 = N3 + ANTCNT(LP,JI,LA,LS,2)
 409                       CONTINUE
 410                    CONTINUE
                     IF (N1.GT.0) THEN
                        IF (FIRST) THEN
                           WRITE (MSGTXT,1410) SUNUMS(LS),
     *                        SUNAMS(LS)(:J), BIF, EIF, BCHAN, ECHAN
                           CALL MSGWRT (5)
                           FIRST = .FALSE.
                           END IF
                        WRITE (MSGTXT,1420) LA, POLLAB(LP,POLTYP),
     *                     N1, N2, N3
                        CALL MSGWRT (5)
                        END IF
 420                 CONTINUE
 430              CONTINUE
 440          CONTINUE
         ELSE IF (OPTYPE.EQ.'ANIF') THEN
            WRITE (MSGTXT,1500)
            CALL MSGWRT (5)
            DO 550 LS = 1,NUMSOU
               J = JTRIM (SUNAMS(LS))
               DO 540 LA = 1,NA
                  IF (WANT(LA).EQ.0) GO TO 540
                  DO 530 LP = LP1,LP2
                     FIRST = .TRUE.
                     JJ = 0
                     DO 520 LI = BIF,EIF
                        JI = LI - BIF + 1
                        N1 = 0
                        N2 = 0
                        N3 = 0
                        DO 510 LF = BCHAN,ECHAN
                           JJ = JJ + 1
                           IF ((LF.LT.LF1) .OR. (LF.GT.LF2)) GO TO 510
                           N1 = N1 + ANTCNT(LP,JJ,LA,LS,1)
                           N2 = N2 + SUMAX(LS,2)-ANTCNT(LP,JJ,LA,LS,1)
                           N3 = N3 + ANTCNT(LP,JJ,LA,LS,2)
 510                       CONTINUE
                        IF (N1.GT.0) THEN
                           IF (FIRST) THEN
                              WRITE (MSGTXT,1510) SUNUMS(LS),
     *                           SUNAMS(LS)(:J),
     *                           BCHAN, ECHAN
                              CALL MSGWRT (5)
                              FIRST = .FALSE.
                              END IF
                           WRITE (MSGTXT,1520) LA, POLLAB(LP,POLTYP),
     *                        JI, N1, N2, N3
                           CALL MSGWRT (5)
                           END IF
 520                    CONTINUE
 530                 CONTINUE
 540              CONTINUE
 550           CONTINUE
         ELSE IF (OPTYPE.EQ.'ANCH') THEN
            WRITE (MSGTXT,1300)
            CALL MSGWRT (5)
            DO 650 LS = 1,NUMSOU
               J = JTRIM (SUNAMS(LS))
               DO 640 LA = 1,NA
                  IF (WANT(LA).EQ.0) GO TO 640
                  DO 630 LP = LP1,LP2
                     FIRST = .TRUE.
                     JJ = 0
                     DO 620 LI = BIF,EIF
                        JI = LI - BIF + 1
                        DO 610 LF = BCHAN,ECHAN
                           JF = LF - BCHAN + 1
                           JJ = JJ + 1
                           IF ((LF.LT.LF1) .OR. (LF.GT.LF2)) GO TO 610
                           N1 = ANTCNT(LP,JJ,LA,LS,1)
                           N2 = SUMAX(LS,2)-ANTCNT(LP,JJ,LA,LS,1)
                           N3 = ANTCNT(LP,JJ,LA,LS,2)
                           IF (N1.GT.0) THEN
                              IF (FIRST) THEN
                                 WRITE (MSGTXT,1305) SUNUMS(LS),
     *                              SUNAMS(LS)(:J), LA
                                 CALL MSGWRT (5)
                                 FIRST = .FALSE.
                                 END IF
                              WRITE (MSGTXT,1320) POLLAB(LP,POLTYP), LI,
     *                           LF, N1, N2, N3
                              IF ((PRTL.GT.0) .OR. (N2.GT.0) .OR.
     *                           (N3.GT.0)) CALL MSGWRT (5)
                              END IF
 610                       CONTINUE
 620                    CONTINUE
 630                 CONTINUE
 640              CONTINUE
 650           CONTINUE
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (11X,'IF   Samp before    Samp after  Percent')
 1010 FORMAT ('Source',I4,'  ''',A,'''  polarization ',A2)
 1020 FORMAT (10X,I3,2I14,F9.2)
 1100 FORMAT (11X,'Pol   Samp before    Samp after  Percent')
 1110 FORMAT ('Source',I4,'  ''',A,'''  antenna',I3,'  IFs',I3,' -',I3)
 1120 FORMAT (11X,A2,2I14,F9.2)
 1210 FORMAT ('Source',I4,'  ''',A,'''  antenna',I3,'  polarization ',
     *   A2)
 1300 FORMAT (6X,'Pol  IF Channel     # samples     # flagged',
     *  '     # flagged')
 1305 FORMAT ('Source',I4,'  ''',A,'''  antenna',I3)
 1310 FORMAT ('Source',I4,'  ''',A)
 1320 FORMAT (7X,A2,I4,I8,3I14)
 1400 FORMAT (6X,'Ant  Pol     # samples     # flagged     # flagged')
 1410 FORMAT ('Source',I4,'  ''',A,'''  IFs',I3,' -',I3,'  Chans',I4,
     *   ' -',I6)
 1420 FORMAT (6X,I3,3X,A2,3I14)
 1500 FORMAT (6X,'Ant  Pol   IF   # samples       # flagged    ',
     *   ' # flagged')
 1510 FORMAT ('Source',I4,'  ''',A,'''  Chans',I4,' -',I6)
 1520 FORMAT (6X,I3,3X,A2,3X,I2,3I14)
      END
      SUBROUTINE FGCNTC (ITYP, VIS, RPARM, IA1, IA2, NI, NA, NS, VISCNT,
     *   ANTCNT)
C-----------------------------------------------------------------------
C   counts visibilities by source, IF, polarization
C     Inputs:
C      ITYPE   I       1 -> first FG, 2 -> 2nd FG, 0 -> one only
C      RPARM   R(*) Random parameter array which includes U,V,W etc
C                   but also any other random parameters.
C      VIS     R(3,*)  Visibilities in order real, imaginary, weight
C                      (Jy, Jy, unitless).  Weight <= 0 => flagged.
C      NI      I       Number IFs or Number IFs * Number channels
C   Inputs from COMMON:
C      CATBLK     I(256)  Catalog header record. See Going Aips for
C                         details.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
C   Output:
C      counting common update
C-----------------------------------------------------------------------
      INTEGER   ITYP, IA1, IA2, NI, NA, NS, VISCNT(4,NI,NS,2),
     *   ANTCNT(4,NI,NA,NS,2)
      REAL      VIS(3,*), RPARM(*)
C
      INTEGER   JIF, JF, JS, NIF, NF, NST, I, JSRC, INDEXI, JJ, LTYP
      LOGICAL   DOTWO
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FGCNT.INC'
      INCLUDE 'FGCNTSOU.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      LTYP = MAX (1, ITYP)
      DOTWO = ITYP.LE.0
C                                       which source
      JSRC = INSNUM
      IF (ILOCSU.GE.0) THEN
         JS = RPARM(1+ILOCSU) + 0.01
         DO 10 I = 1,NUMSOU
            IF (JS.EQ.SUNUMS(I)) JSRC = I
 10         CONTINUE
         END IF
C                                       pointers to traverse the data
      NST = 1
      NIF = 1
      NF = 1
      IF (JLOCS.GE.0) NST = CATBLK(KINAX+JLOCS)
      IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
      IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
      JJ = 0
      DO 40 JIF = 1,NIF
         IF (.NOT.ONLY1) JJ = JJ + 1
         DO 30 JF = 1,NF
            IF (ONLY1) JJ = JJ + 1
            IF ((DOSPEC) .AND. (JIF.EQ.SPIF) .AND. (JF.EQ.SPCHAN)) THEN
               IF ((IA1.EQ.SPANT) .OR. (IA2.EQ.SPANT) .OR. (SPANT.LE.0))
     *            THEN
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI + 1
                  CALL PRTSPC (NST, IA1, IA2, RPARM(1+ILOCT),
     *               VIS(1,INDEXI))
                  END IF
               END IF
            DO 20 JS = 1,NST
               INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *            (JS-1) * INCSI + 1
               IF (VIS(3,INDEXI).GT.0.0) THEN
                  VISCNT(JS,JJ,JSRC,LTYP) = VISCNT(JS,JJ,JSRC,LTYP)+1
                  IF (OPTYPE(:2).EQ.'AN') THEN
                     ANTCNT(JS,JJ,IA1,JSRC,LTYP) =
     *                  ANTCNT(JS,JJ,IA1,JSRC,LTYP) + 1
                     IF (IA1.NE.IA2) ANTCNT(JS,JJ,IA2,JSRC,LTYP) =
     *                  ANTCNT(JS,JJ,IA2,JSRC,LTYP) + 1
                     END IF
               ELSE IF (DOTWO) THEN
                  VISCNT(JS,JJ,JSRC,2) = VISCNT(JS,JJ,JSRC,2)+1
                  IF (OPTYPE(:2).EQ.'AN') THEN
                     ANTCNT(JS,JJ,IA1,JSRC,2) =
     *                  ANTCNT(JS,JJ,IA1,JSRC,2) + 1
                     IF (IA1.NE.IA2) ANTCNT(JS,JJ,IA2,JSRC,2) =
     *                  ANTCNT(JS,JJ,IA2,JSRC,2) + 1
                     END IF
                  END IF
 20            CONTINUE
 30         CONTINUE
 40      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE PRTSPC (NS, IA1, IA2, TIME, VIS)
C-----------------------------------------------------------------------
C   special text output
C   Inputs
C      NS     I        Number Stokes
C      TIME   R        time, > 1000 => close the file
C      VIS    R(3,*)   desired single channel
C   Output
C      IRET   I        error
C-----------------------------------------------------------------------
      INTEGER   NS, IA1, IA2
      REAL      TIME, VIS(3,4)
C
      INCLUDE 'INCS:FGCNT.INC'
      INTEGER   TXLUN, TXIND, NUMVIS, LUNTMP, I, J, JTRIM, ITIM(3), IRET
      CHARACTER OUTLIN*256, TSIGN*1
      REAL      AMP(4), PHASE(4), WT(4) , TSEC
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DSEL.INC'
      SAVE TXLUN, TXIND, NUMVIS
      DATA NUMVIS /0/
C-----------------------------------------------------------------------
      IF (TIME.GT.1000.) THEN
         CALL ZTXCLS (TXLUN, TXIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING SPECIAL TEXT FILE'
            GO TO 990
            END IF
      ELSE
C                                       open text file
         IF (NUMVIS.EQ.0) THEN
            TXLUN = LUNTMP (2)
            CALL ZTXOPN ('WRIT', TXLUN, TXIND, OUTFIL, .TRUE., IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'OPENING SPECIAL TEXT FILE'
               GO TO 990
               END IF
            WRITE (OUTLIN,2000) NAMEIN, CLAIN, SEQIN, DISKIN,
     *         SPIF+BIF-1, SPCHAN+BCHAN-1
            J = JTRIM (OUTLIN)
            CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITING SPECIAL TEXT FILE'
               GO TO 990
               END IF
            END IF
         NUMVIS = NUMVIS + 1
         CALL TFDHMS (TIME, 2, TSIGN, ITIM, TSEC)
         DO 20 I = 1,NS
            AMP(I) = SQRT (VIS(1,I)**2 + VIS(2,I)**2)
            PHASE(I) = 0.0
            IF (AMP(I).GT.0.) PHASE(I) = ATAN2 (VIS(2,I), VIS(1,I)) *
     *         RAD2DG
            WT(I) = VIS(3,I)
 20         CONTINUE
         WRITE (OUTLIN,2010) NUMVIS, IA1, IA2, ITIM, TSEC, (AMP(I),
     *      PHASE(I), WT(I), I = 1,NS)
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING SPECIAL TEXT FILE'
            GO TO 990
            END IF
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
      CALL ZTXCLS (TXLUN, TXIND, IRET)
      DOSPEC = .FALSE.
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PRTSPC ERROR',I4,' ON ',A)
 2000 FORMAT (A12,'.',A6,'.',I4,'.',I3,'   IF',I3,' CHANNEL',I6)
 2010 FORMAT (I8,3I4,'/',2(I2.2,':'),F5.2,4(2X,F8.4,F8.2,F8.4))
      END

      SUBROUTINE ZTOPEN (LUN, FIND, IVOL, PNAME, MNAME, VERSON, WAIT,
     *   IERR)
C-----------------------------------------------------------------------
C! open text file - logical area, version, member name as arguments
C# Z Text
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999, 2002, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Open a text file - logical area, version, member name as arguments
C   Inputs:
C      LUN      I      Logical unit number
C      IVOL     I      Disk volume containing file, (not used)
C      PNAME    C*48   Physical file name, only used to determine file
C                      type or logical area
C      MNAME    C*(*)  Text file name  (<= 12 chars)
C      VERSON   C*48   Logical name for directory or version of
C                      directory to search (for file-specific
C                      directories)
C      WAIT     L      T => wait until file is available (not used)
C   Outputs:
C      FIND     I      Index in FTAB for LUN
C      IERR     I      Error return code: 0 => no error
C                         1 => LUN already in use
C                         2 => file not found
C                         3 => volume not found
C                         4 => file locked
C                         5 => no room for LUN in FTAB
C                         6 => other open errors
C   Generic version - uses ZDIR, ZFULLN, and Fortran functions INQUIRE
C   and then calls ZTOPE2.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IVOL, IERR
      CHARACTER VERSON*48, PNAME*48, MNAME*(*)
      LOGICAL   WAIT
C
      INTEGER   I, J, JERR, IOSVAL, ITRIM, LN, LF
      LOGICAL   MAP, EXISTS
      CHARACTER FILTYP*2, FILSPC*256, XLATED*256
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA MAP /.FALSE./
C-----------------------------------------------------------------------
C                                       Check inputs.
      IERR = 6
C                                       Valid LUN?
      IF ((LUN.LE.0) .OR. (LUN.GT.99)) THEN
         WRITE (MSGTXT,1000) LUN
         GO TO 995
         END IF
C                                       Valid device type?
      IF (DEVTAB(LUN).NE.3) THEN
         WRITE (MSGTXT,1010) LUN, DEVTAB(LUN)
         GO TO 995
         END IF
C                                       Allocate area in FTAB for LUN.
      CALL LSERCH ('OPEN', LUN, FIND, MAP, JERR)
      IF (JERR.NE.0) THEN
C                                       LUN already in use.
         IF (JERR.EQ.2) THEN
            IERR = 1
            WRITE (MSGTXT,1022) LUN
C                                       No room in FTAB for LUN.
         ELSE IF (JERR.EQ.3) THEN
            IERR = 5
            WRITE (MSGTXT,1023) LUN
         ELSE
            WRITE (MSGTXT,1020) JERR, 'OPEN', LUN
            END IF
         GO TO 995
         END IF
C                                       Get file type ('HE','RU', etc.).
      I = INDEX(PNAME,':')
      FILTYP = PNAME(I+1:I+2)
C                                       Create complete file
C                                       specification (ZDIR will append
C                                       proper extension, if any).
      IERR = 0
      CALL ZDIR (FILTYP, VERSON, MNAME, FILSPC, IERR)
C                                       Check for existence and open.
      IF (IERR.NE.0) GO TO 990
      LF = ITRIM (FILSPC)
      LN = ITRIM (MNAME)
      INQUIRE (FILE=FILSPC(1:LF), EXIST=EXISTS)
C                                       Not found
      IF (.NOT.EXISTS) THEN
C                                       Check system RUN file directory
         IF (FILTYP.EQ.'RU') THEN
            IF ((VERSON.EQ.'CVX') .OR. (VERSON.EQ.'TST') .OR.
     *         (VERSON.EQ.'NEW') .OR. (VERSON.EQ.'OLD') .OR.
     *         (VERSON.EQ.' ')) THEN
               XLATED = 'RUNSYS:' // MNAME(1:LN) // '.001'
            ELSE
               XLATED = VERSON(:ITRIM(VERSON)) // ':' // MNAME(1:LN) //
     *            '.001'
               END IF
            CALL ZFULLN (XLATED, ' ', ' ', FILSPC, JERR)
            IF (JERR.NE.0) THEN
               WRITE (MSGTXT,1032) 'RUNSYS'
               CALL MSGWRT (6)
C                                       Does this version exist?
            ELSE
               LF = ITRIM (FILSPC)
               INQUIRE (FILE=FILSPC(1:LF), EXIST=EXISTS)
               END IF
            END IF
C                                       Can't find it.
         IF (.NOT.EXISTS) THEN
            IERR = 2
            WRITE (MSGTXT,1050) FILTYP, MNAME(:LN)
            GO TO 985
            END IF
         END IF
C                                       Found it, now open it.
      CALL ZTOPE2 (LUN, FILSPC, WAIT, IOSVAL, IERR)
C                                       OPEN error?
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IOSVAL
         CALL MSGWRT (6)
         DO 70 J = 1,I,56
            WRITE (MSGTXT,1061) FILSPC(J:J+55)
            CALL MSGWRT (6)
 70         CONTINUE
         CALL ZERROR ('ZTOPE2', IOSVAL, ' ', -999, .FALSE.)
         GO TO 990
         END IF
C                                       Rewind.
      REWIND (LUN)
C                                       store file name
      CALL FSERCH (FIND, I, J, JERR)
      IF (JERR.EQ.0) THEN
         IF (I.EQ.1) DEVNAM(J) = FILSPC(1:48)
         IF (I.EQ.2) NONNAM(J) = FILSPC(1:48)
         IF (I.EQ.3) MAPNAM(J) = FILSPC(1:48)
         END IF
      GO TO 999
C
 985  CALL MSGWRT (6)
C                                       Error.  Remove FTAB entry.
 990  CALL LSERCH ('CLOS', LUN, FIND, MAP, JERR)
      IF (JERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1020) JERR, 'CLOS', LUN
C
 995  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZTOPEN: INVALID LUN = ',I2)
 1010 FORMAT ('ZTOPEN: INVALID DEVTAB(',I2,') = ',I1)
 1020 FORMAT ('ZTOPEN: LSERCH ERROR ',I2,' ON ',A4,' LUN = ',I2)
 1022 FORMAT ('ZTOPEN: LUN = ',I2,' ALREADY OPENED IN FTAB')
 1023 FORMAT ('ZTOPEN: NO ROOM IN FTAB FOR LUN = ',I2)
 1032 FORMAT ('ZTOPEN: TROUBLE TRANSLATING LOGICAL = ',A)
 1050 FORMAT ('ZTOPEN: CAN''T FIND ',A,' FILE =''',A,'''')
 1060 FORMAT ('ZTOPEN: FORTRAN OPEN ERROR = ',I6,' FOR FILE =')
 1061 FORMAT ('ZTOPEN: ',A)
      END

      SUBROUTINE FUNBSM (FUNTYP, CUT, WIDTH, X, Y, S, BLANK, N, YS)
C-----------------------------------------------------------------------
C! smoothing with wt function of irregularly spaced array with blanking
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does a weight-function smoothing of irregularly spaced points,
C   replacing blanked and good values with the smoothed values.  Only
C   returns blanked values if no valid data found within +-WIDTH/2
C   and/or sum of function weights < CUT.  Does not smooth different
C   source numbers together.  Therefore, make S(*) constant if you wish
C   to smooth all samples.
C   Inputs:
C      FUNTYP   C*4    Function type: 'GAUS', 'EXP ', 'LINE'
C      CUT      R      Sum of function < CUT => output blanked
C      WIDTH    R(2)   (1) Full width of window in same units as X
C                      (2) FWHM of function in same units as X
C      X        R(N)   Absissae of points to be smoothed - monotonically
C                      increasing
C      Y        R(N)   Values to be smoothed.
C      S        I(N)   Source numbers - do not smooth across numbers
C                      If S(1) < 0, then S(I) is not otherwise examined
C      BLANK    R      Value used for blanking.
C      N        I      Number of points to smooth.
C    Output:
C      YS       R(N)   Smoothed values.
C-----------------------------------------------------------------------
      CHARACTER FUNTYP*(*)
      INTEGER   N, S(N)
      REAL      CUT, WIDTH(2), X(N), Y(N), YS(N), BLANK
C
      INTEGER   I, J, J1, J2
      REAL      HWIDTH, FWIDTH, WT, WTS, V
      LOGICAL   NOSORC
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       copy if width <= 0
      CALL RCOPY (N, Y, YS)
      IF ((FUNTYP(:4).NE.'LINE') .AND. (FUNTYP(:4).NE.'GAUS') .AND.
     *   (FUNTYP(:4).NE.'EXP ')) THEN
         WRITE (MSGTXT,1000) FUNTYP, WIDTH
         CALL MSGWRT (6)
      ELSE IF ((WIDTH(1).GT.0.0) .AND. (WIDTH(2).GT.0.0)) THEN
         NOSORC = S(1).LT.0
         CUT = MAX (CUT, 1.E-6)
         HWIDTH = WIDTH(1) / 2.0
         FWIDTH = WIDTH(2) / 2.0
         IF (FUNTYP(:4).EQ.'LINE') FWIDTH = 2.0 * FWIDTH
         IF (FUNTYP(:4).EQ.'EXP ') FWIDTH = FWIDTH / LOG (2.0)
         IF (FUNTYP(:4).EQ.'GAUS') FWIDTH = FWIDTH / SQRT (LOG (2.0))
         J2 = 1
         DO 100 I = 1,N
            J1 = J2
            J2 = N + 1
            WTS = 0.0
            V   = 0.0
C                                       source not examined
            IF (NOSORC) THEN
               DO 10 J = J1,N
                  IF (X(J)-X(I).GT.HWIDTH) GO TO 90
                  IF (ABS(X(I)-X(J)).LE.HWIDTH) THEN
                     J2 = MIN (J2, J)
                     IF (Y(J).NE.BLANK) THEN
                        WT = ABS (X(I)-X(J)) / FWIDTH
                        IF (FUNTYP(:4).EQ.'GAUS') THEN
                           WT = EXP (-(WT**2))
                        ELSE IF (FUNTYP(:4).EQ.'EXP ') THEN
                           WT = EXP (-WT)
                        ELSE
                           WT = 1.0 - WT
                           END IF
                        WT = MAX (0.0, WT)
                        WTS = WTS + WT
                        V = V + Y(J) * WT
                        END IF
                     END IF
 10               CONTINUE
C                                       source examined
            ELSE
               DO 20 J = J1,N
                  IF (X(J)-X(I).GT.HWIDTH) GO TO 90
                  IF (ABS(X(I)-X(J)).LE.HWIDTH) THEN
                     J2 = MIN (J2, J)
                     IF ((Y(J).NE.BLANK) .AND. (S(I).EQ.S(J))) THEN
                        WT = ABS (X(I)-X(J)) / FWIDTH
                        IF (FUNTYP(:4).EQ.'GAUS') THEN
                           WT = EXP (-(WT**2))
                        ELSE IF (FUNTYP(:4).EQ.'EXP ') THEN
                           WT = EXP (-WT)
                        ELSE
                           WT = 1.0 - WT
                           END IF
                        WT = MAX (0.0, WT)
                        WTS = WTS + WT
                        V = V + Y(J) * WT
                        END IF
                     END IF
 20               CONTINUE
               END IF
 90         IF (WTS.GT.CUT) THEN
               YS(I) = V / WTS
            ELSE
               YS(I) = BLANK
               END IF
 100        CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FUNBSM: FUNCTION ',A,' TIMES',2(1PE11.3),' ERROR')
      END

      SUBROUTINE NATCEL (PHI, THETA, PHIP, ALPHAP, DELTAP, ALPHA, DELTA)
C-----------------------------------------------------------------------
C! Celeestial coordinate rotation from native to celestial
C# Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   NATCEL does a coordinate rotation in the notation of WCS Paper II
C   from native coordinates to celestial coordinates
C   Inputs:
C      PHI      D   Native longitude
C      THETA    D   Native latitude
C      PHIP     D   Native longitude of North pole
C      ALPHAP   D   Celestial longitude of the native pole
C      DELTAP   D   Celestial latitude of the native pole
C   Outputs:
C      ALPHA    D   Celestial longitude
C      DELTA    D   Celestial latitude
C   ALL COORDINATES ARE IN RADIANS
C-----------------------------------------------------------------------
      DOUBLE PRECISION PHI, THETA, PHIP, ALPHAP, DELTAP, ALPHA, DELTA
C
C-----------------------------------------------------------------------
      ALPHA = ALPHAP + ATAN2 (-COS(THETA) * SIN(PHI-PHIP),
     *   SIN(THETA)*COS(DELTAP) - COS(THETA) * SIN(DELTAP) *
     *   COS(PHI-PHIP))
      DELTA = ASIN (SIN(THETA) * SIN(DELTAP) + COS(THETA) * COS(DELTAP)
     *   * COS(PHI-PHIP))
C
 999  RETURN
      END

LOCAL INCLUDE 'UVFIL.INC'
C                                       Local include UVFIL
      INCLUDE 'INCS:ZPBUFSZ.INC'
C                                       Global variables and commons
C                                       are defined here.
      INTEGER   SEQOUT, DISKO, NUMHIS, JBUFSZ, NANT
      HOLLERITH XINFIL(12), XIN2FI(12), XNAMOU(3), XCLAOU(2)
      CHARACTER INFILE*48, IN2FIL*48, NAMOUT*12, CLAOUT*6,
     *   HISCRD(10)*64, ANTNAM(30)*8
      REAL      XSOUT, XDISO, APARM(10), BPARM(10), BUFFER(UVBFSS),
     *   XIAT, XUT1
      DOUBLE PRECISION ANTLOC(3,30), GST0
C                                       Antenna information (ex char.)
      COMMON /ANTS/ ANTLOC, GST0, XIAT, XUT1, NANT
C                                       I/O buffer
      COMMON /BUFRS/ BUFFER, JBUFSZ
C                                       AIPS adverbs passed
      COMMON /INPARM/ XINFIL, XIN2FI, XNAMOU, XCLAOU, XSOUT, XDISO,
     *   APARM, BPARM, SEQOUT, DISKO, NUMHIS
C                                       Various CHARACTER variables
      COMMON /CHRCOM/ INFILE, IN2FIL, NAMOUT, CLAOUT, HISCRD, ANTNAM
LOCAL END
      PROGRAM UVFIL
C-----------------------------------------------------------------------
C! User redefinable task to create an uv data file from external data.
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2000, 2009, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVFIL creates an AIPS uv data base and fills the data base thru
C   calls to a user provided routine.  See the UVFIL EXPLAIN file
C   or Going AIPS  for better descriptions of the UV data
C   file and catalog header structure and the contents and structure
C   of the antenna (AN) table.  There are sufficient comments in
C   NEWHED and FIDDLE to describe simple cases.
C       The current version of UVFIL has a sample version of
C   statments to read control information and data from
C   text files as a guide for other implementations.  These sections
C   are marked 'SAMPLE CODE' and delimited by a row of '*''s
C
C   IMPORTANT NOTE: to avoid confusion this task should be renamed.
C   To rename (max. 5 char) and install the new task :
C     1) copy the source code to a new file with the name newname.
C        then add desired code to subroutines FIDDLE and NEWHED
C     2) using the source editor change all references to UVFIL to
C        newname.  It is especially important to change the string
C        DATAed into array PRGM in the main routine to the new name.
C     3) copy .HLP file for UVFIL to .HLP file for newname.
C     4) compile and link edit with the APL and NOTST subroutine
C        libraries from AIPS.
C
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INFILE         INFILE        Input file name.
C      IN2FILE        IN2FIL        Name of aux. input file.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is source name
C      OUTCLASS       CLAOUT        Class of the output uv file.
C                                   Default 'UVDATA'
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      APARM(10)      APARM         User specified array.
C      BPARM(10)      BPARM         User specified array.
C-----------------------------------------------------------------------
      INTEGER  IRET
      CHARACTER PRGM*6
      INCLUDE 'UVFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
C
C                 Change this DATA stmt. if changing the PROGRAM name.
C
      DATA PRGM /'UVFIL '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL UVFILN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL GETUV (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL FILHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE UVFILN (PRGN, JERR)
C-----------------------------------------------------------------------
C   UVFILN gets input parameters for UVFIL and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                               4 => error creating output file.
C                               8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in UVFIL for more details.
C
C   To change the adverb list sent to this task change:
C   1)  the inputs file (task_name.HLP).
C   2)  the contents of COMMON /INPARM/.  Remember all adverbs are sent
C       as reals; character data is sent as HOLLERITH variables and
C       needs to be converted to CHARACTER using H2CHR.
C       Values will be filled into COMMON /INPARM/ in the order
C       specified in the inputs file.
C   3)  If the first adverb is not XINFIL then replace
C       XINFIL in the call to GTPARM with the name of the first
C       adverb.
C   4)  Change the value of NPARM sent to GTPARM to the number of
C       words desired.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER OLDNAM*12, BLANK*6, DEFNAM*12
      INTEGER   IERR, NPARM, IROUND
      INCLUDE 'UVFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK /'      '/
      DATA DEFNAM /'UV DATA FILE'/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 51
      CALL GTPARM (PRGN, NPARM, RQUICK, XINFIL, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFFER, IERR)
      IF (JERR.NE.0) GO TO 999
C                                       Crunch input parameters.
      SEQOUT = IROUND (XSOUT)
      DISKO = IROUND (XDISO)
C                                       Convert AIPS character adverbs
C                                       from HOLLERITH to CHARACTER.
      CALL H2CHR (48, 1, XINFIL, INFILE)
      CALL H2CHR (48, 1, XIN2FI, IN2FIL)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       Create new header.
      CALL NEWHED (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Get uv header info and
C                                       verify header structure.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Put new values in CATBLK.
C                                       Get naming defaults
      OLDNAM = DEFNAM
      CALL MAKOUT (OLDNAM, BLANK, 0, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
C                                       File type ='UV'
      CALL CHR2H (2, 'UV', KHPTYO, CATH(KHPTY))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      CCNO = 1
      CALL UVCREA (DISKO, CCNO, BUFFER, IERR)
      IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR
            JERR = 4
            GO TO 990
            END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = 2
C                                       Get SEQ. no. used.
      SEQOUT = CATBLK(KIIMS)
      JERR = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVFILN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE GETUV (IRET)
C-----------------------------------------------------------------------
C   GETUV reads uv data one point at a time from the user supplied
C   routine FIDDLE and then writes the data.
C   Output:
C      IRET   I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48
      INTEGER   IPTRO, LUNO, LENBU, IA1, IA2, NIOUT, INDO, LRECO, KBIND,
     *   VO, BO, NUMVIS, XCOUNT
      REAL      DUM
      LOGICAL   T, F
      INCLUDE 'UVFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNO /16/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
C                                       LRECO = length of output rec.
      LRECO = LREC
      LENBU = 1
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, LENBU, JBUFSZ,
     *   BUFFER, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NUMVIS = 0
      XCOUNT = 0
C                                       ant numbers should be set by
C                                       FIDDLE but just in case:
      IA1 = 1
      IA2 = 2
C                                       Loop
 100  CONTINUE
         NUMVIS = NUMVIS + 1
C                                      Call user routine.
         CALL FIDDLE (NUMVIS, BUFFER(IPTRO+ILOCU),
     *      BUFFER(IPTRO+ILOCV), BUFFER(IPTRO+ILOCW),
     *      BUFFER(IPTRO+ILOCT), IA1, IA2, BUFFER(IPTRO+NRPARM),
     *      BUFFER(IPTRO), IRET)
C                                       Fill in baseline.
         IF (ILOCB.GE.0) THEN
            BUFFER(IPTRO+ILOCB) = IA1 * 256 + IA2
         ELSE
            BUFFER(IPTRO+ILOCA1) = IA1
            BUFFER(IPTRO+ILOCA2) = IA2
            BUFFER(IPTRO+ILOCSA) = 1.0
            END IF
C                                       Error (fatal)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
C                                       Got datum
         ELSE IF (IRET.EQ.0) THEN
            XCOUNT = XCOUNT + 1
            IPTRO = IPTRO + LRECO
            NIOUT = NIOUT + 1
C                                       Write vis record.
            CALL UVDISK ('WRIT', LUNO, INDO, BUFFER, NIOUT, KBIND, IRET)
C                                       Check for end.
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1150) IRET
               GO TO 990
               END IF
            IPTRO = KBIND
            NIOUT = 0
C                                       Next vis.
            GO TO 100
            END IF
C                                       Final call to FIDDLE.
      NUMVIS = -1
      CALL FIDDLE (NUMVIS, DUM, DUM, DUM, DUM, IA1, IA2, BUFFER,
     *   BUFFER, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFFER, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close file
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('GETUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1120 FORMAT ('GETUV: FIDDLE ERROR',I3)
 1150 FORMAT ('GETUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE FILHIS
C-----------------------------------------------------------------------
C   FILHIS creates and fills a history file.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, LABEL*8, ATIME*8, ADATE*12, TELE*8, OBSR*8
      INTEGER   LUN, I, IERR, TIME(3), DATE(3)
      LOGICAL   T
      INCLUDE 'UVFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      DATA LUN /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Create/open hist. file.
      CALL HICREA (LUN, DISKO, CCNO, CATBLK, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Get current date/time.
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
C                                       Write first record.
      WRITE (HILINE,1010) TSKNAM, NLUSER, ADATE, ATIME
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       New history
      WRITE (HILINE,1011) TSKNAM, INFILE
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,1012) TSKNAM, IN2FIL
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN,
     *   BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       SOURCE
      WRITE (HILINE,2000) TSKNAM, SOURCE
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Number of visibilities
      WRITE (HILINE,2001) TSKNAM, CATBLK(KIGCN)
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Telescope, observer name.
      CALL H2CHR (8, 1, CATH(KHTEL), TELE)
      CALL H2CHR (8, 1, CATH(KHOBS), OBSR)
      WRITE (HILINE,2002) TSKNAM, TELE, OBSR
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       AIPS release
      WRITE (HILINE,2003) TSKNAM, RLSNAM
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any user supplied history.
      IF (NUMHIS.GT.0) THEN
         WRITE (LABEL,1050) TSKNAM
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
         END IF
C                                       Close HI file
 200   CALL HICLOS (LUN, T, BUFFER, IERR)
C                                       Write ANtenna file.
      CALL ANTFIL
C                                       Update CATBLK.
      CALL CATIO ('UPDT', DISKO, CCNO, CATBLK, 'REST', BUFFER, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FILHIS: ERROR',I3,' CREATE/OPEN HISTORY FILE')
 1010 FORMAT (A6,'/ Image created by user',I5,' at ',A12,2X,A8)
 1011 FORMAT (A6,'INFILE =''',A,'''')
 1012 FORMAT (A6,'IN2FILE=''',A,'''')
 1050 FORMAT (A6,' /')
 2000 FORMAT (A6,' SOURCE = ''',A,'''')
 2001 FORMAT (A6,' / Number of visibilities copied=',I9)
 2002 FORMAT (A6,' / Telescope = ',A8,' Observer = ',A8)
 2003 FORMAT (A6,' Release = ''',A7,' ''')
      END
      SUBROUTINE ANTFIL
C-----------------------------------------------------------------------
C   ANTFIL creates and fills the antenna file.
C-----------------------------------------------------------------------
      INTEGER   IERR, VER, IABUF(1), LUN, I
      DOUBLE PRECISION JD, GMSTM, GASTM, RATE
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'UVFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (BUFFER, IABUF)
      DATA LUN /27/
C-----------------------------------------------------------------------
C                                       Make sure there is antenna info
      IF (NANT.LE.0) GO TO 999
C                                       Setup for AN table initization
         NUMORB = 0
         NOPCAL = 2
C                                       Position of the earth's pole
         POLRXY(1) = 0.0
         POLRXY(2) = 0.0
         UT1UTC = XUT1
         DATUTC = XIAT
C                                       Array name
         ANAME = '        '
C                                       Array center (rel to center of
C                                       earth)
         ARRAYC(1) = 0.0D0
         ARRAYC(2) =  0.0D0
         ARRAYC(3) =  0.0D0
C                                       Get GST0 and Earth rotation rate
         CALL H2CHR (8, 1, CATH(KHDOB), RDATE)
         IF (ABS (GST0).LT.1.0E-20) CALL JULDAY (RDATE, JD)
         IF (ABS (GST0).LT.1.0E-20)
     *      CALL GSTROT (JD, GMSTM, GASTM, RATE)
         GSTIA0 = GST0
         IF (ABS (GST0).LT.1.0E-20) GSTIA0 = GMSTM
         DEGPDY = RATE
         SAFREQ = FREQ
         ANFQID = -1
         TIMSYS = 'UTC'
         VER = 1
         XYZHAN = ' '
         TFRAME = ' '
         ANTNIF = 1
C                                       Create/init file
         CALL ANTINI ('WRIT', BUFFER, DISKO, CCNO, VER, CATBLK, LUN,
     *      IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *      RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *      TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       init basic AN record
         ANNAME = ' '
         STAXOF = 0.0
         STAXYZ(1) = 0.0D0
         STAXYZ(2) = 0.0D0
         STAXYZ(3) = 0.0D0
         ORBPRM(1) = 0.0D0
         NOSTA = 0
         MNTSTA = 0
         POLAA = 0.0
         POLAB = 0.0
         CALL RFILL (3, 0.0, POLCA)
         CALL RFILL (3, 0.0, POLCB)
         POLTYA = 'R'
         POLTYB = 'L'
         DIAMAN = 0.0
         FWHMAN(1) = 0.0
C                                       AN records
         DO 20 I = 1,NANT
            STAXYZ(1) = ANTLOC(1,I)
            STAXYZ(2) = ANTLOC(2,I)
            STAXYZ(3) = ANTLOC(3,I)
            NOSTA = I
            ANNAME = ANTNAM(I)
            IANRNO = I
            CALL TABAN ('WRIT', BUFFER, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
            IF (IERR.NE.0) GO TO 990
 20         CONTINUE
C                                       Fill in header and close
         CALL TABIO ('CLOS', 1, IANRNO, ANNAME, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 990
         GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1020) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('ERROR ',I3,' OCCURED WRITING ANTENNA FILE')
      END
      SUBROUTINE NEWHED (IRET)
C-----------------------------------------------------------------------
C   NEWHED is a routine in which the catalog header is constructed.
C   Necessary values can be read in in the areas markes "USER CODE
C   GOES HERE".
C
C   NOTE: the AIPS convention for the coordinate reference value
C   for the STOKES axis is that 1,2,3,4 represent I, Q, U, V
C   stokes' parameters and -1,-2,-3,-4 represent RR, LL, RL and
C   LR correlator values.  Currently set for R and L polarization
C   ie Ref. value = -1 and increment = -1.
C
C   The MINIMUM information required here is that
C   required to define the size of the output file; ie.
C      CATBLK(KIGCN)   = I   number of visibility records
C      CATBLK(KIPCN) = Number of random parameters.
C      CATBLK(KIDIM)= the number of axes,
C      CATBLK(KINAX+i) = the dimension of each axis.
C   Other changes can be made either here or in FIDDLE; the
C   catalog block will be updated when the history file is
C   written.
C      The antenna information can also be entered in this
C   routine.  It is possible to put much more information in the
C   ANtenna file, see Going AIPS for details.
C
C    Input:
C     CATBLK(256)    I     Output catalog header, also CATR, CATH, CATD
C                          The OUTNAME, OUTCLASS, OUTSEQ are entered
C                          elsewhere.
C    Output:
C     CATBLK(256)    I     Modified output catalog header.
C     IRET           I     Return error code, 0=>OK, otherwise abort.
C    Also the antenna informtion can be filled into a common.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER RTYPES(9)*8, TYPES(7)*8, UNITS*8, TELE*8, OBSR*8,
     *   INSTR*8, OBSDAT*8
C     CHARACTER LINE*80
      INTEGER   I, NAXIS, NRAN, NCHAN, NPOLN, NDIM(7), INDEX, XCOUNT,
     *   LUN, FIND
      LOGICAL   APPEND
      REAL      CRINC(7), CRPIX(7), EPOCH, BANDW
      DOUBLE PRECISION CRVAL(7)
      INCLUDE 'UVFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
C                                       User definable values
C                                       Random parameters.
C                                       No. random parameters.
      DATA NRAN /7/
C                                       Rand. parm. names.
C                                       with encoded baseline
C     DATA RTYPES /'UU-L-SIN','VV-L-SIN','WW-L-SIN','TIME1',
c    *   'BASELINE', 2*' '/
C                                       with separate antennas, subarray
      DATA RTYPES /'UU-L-SIN', 'VV-L-SIN', 'WW-L-SIN', 'TIME1',
     *   'SUBARRAY', 'ANTENNA1', 'ANTENNA2', 2*' '/
C                                       Uniform axes.
C                                         No. axes.
      DATA NAXIS /5/
C                                         Axes names.
      DATA TYPES /'COMPLEX ','STOKES  ','FREQ    ',
     *   'RA      ','DEC     ',2*'        '/
C                                         Axis dimensions
      DATA NDIM /3,1,1,1,1,0,0/
C                                         Reference values
      DATA CRVAL /1.0D0, -1.0D0, 5*0.0D0/
C                                         Reference pixel.
      DATA CRPIX /7*1.0/
C                                         Coordinate increment.
      DATA CRINC /1.0, -1.0, 0.0, 0.0, 0.0, 2*0.0/
C                                       Epoch of position.
      DATA EPOCH /1950.0/
C                                       Units
      DATA UNITS /'JY      '/
C-----------------------------------------------------------------------
      NANT = 0
      GST0 = 0.0D0
      XIAT = 0.0
      XUT1 = 0.0
C                                       Zero fill CATBLK
      CALL CATINI (CATBLK)
C                                       Fill axis arrays.
C                                       Random axis names
      DO 10 I = 1,NRAN
         INDEX = KHPTP + (I-1) * 2
         CALL CHR2H (8, RTYPES(I), 1, CATH(INDEX))
 10      CONTINUE
C                                       Uniform axes
      DO 30 I = 1,KICTPN
C                                       Init dimension
         CATBLK(KINAX+I-1) = NDIM(I)
C                                       Init. increment.
         CATR(KRCIC+I-1) = CRINC(I)
C                                       Init. rotation.
         CATR(KRCRT+I-1) = 0.0
C                                       Init. ref pixel.
         CATR(KRCRP+I-1) = CRPIX(I)
C                                       Init. ref value.
         CATD(KDCRV+I-1) = CRVAL(I)
C                                       Fill axis type from
C                                       TYPES
         INDEX = KHCTP + (I-1) * 2
         CALL CHR2H (8, TYPES(I), 1, CATH(INDEX))
 30      CONTINUE
C                                       Fill in values.
C                                       Fill other character strings.
C                                       Source name
      SOURCE = '        '
C                                       Observation date. 'DD/MM/YY'
      OBSDAT = '        '
C                                       Telescope.
      TELE = '        '
C                                       Receiver
      INSTR = '        '
C                                       Observer's name.
      OBSR = '        '
C                                       Set number of axes.
      CATBLK(KIDIM) = NAXIS
      CATBLK(KIPCN) = NRAN
C                                       Miscellaneous items.
C                                       Epoch.
      CATR(KREPO) = EPOCH
C                                       Sort order ('**'=>unsorted)
      CALL CHR2H (2, '**', 1, CATH(KITYP))
C                                       Units
      CALL CHR2H (8, UNITS, 1, CATH(KHBUN))
C-----------------------------------------------------------------------
C                                       Enter values for data:
C                                       XCOUNT = number of vis. record.
C                                       RA = Right ascension (1950)
C                                          in degrees.
C                                       DEC = Declination in degrees.
C                                       FREQ = frequency of obs in Hz.
C                                       BANDW = bandwidth or channel
C                                           separation.
C                                       NCHAN = Number of freq chan.
C                                       NPOLN = number of polarization
C                                            correlators.
C                                       OBSDAT = Reference date of time
C                                          tags for data as "yyyymmdd"
C                                       SOURCE = source name (8 char)
C                                       TELE = telescope name (8 char)
C                                       INSTR = Receiver name (8char)
C                                       OBSR = Observers name (8 char)
C                                       Just in case you forget.
      XCOUNT = 1
      RA = 0.0D0
      DEC = 0.0D0
      FREQ = 1.0D0
      BANDW = 0.0
      NCHAN = 1
      NPOLN = 1
C                                       Open INFILE on lun 10
      LUN = 10
      APPEND = .FALSE.
      CALL ZTXOPN ('READ', LUN, FIND, INFILE, APPEND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
C
C
C      USER CODE GOES HERE
C
C***********************************************************************
C   SAMPLE CODE
C
C      CALL ZTXIO ('READ', LUN, FIND, LINE, IRET)
C      IF (IRET.NE.0) THEN
C         WRITE (MSGTXT,1031) IRET
C         GO TO 990
C         END IF
C      READ (LINE,2001) XCOUNT, RA, DEC, FREQ, OBSDAT, BANDW
C 2001 FORMAT (I10,3E12.3,4X,A8,E12.3)
C      CALL ZTXIO ('READ', LUN, FIND, LINE, IRET)
C      IF (IRET.NE.0) THEN
C         WRITE (MSGTXT,1031) IRET
C         GO TO 990
C         END IF
C      READ (LINE,2002) NCHAN, NPOLN, SOURCE, TELE, INSTR, OBSR
C 2002 FORMAT (2I5, 4(2X,A8))
C***********************************************************************
C                                       Insert values in header.
C                                       Number of vis.
      CATBLK(KIGCN) = XCOUNT
C                                       Position.
      CATD(KDCRV+3) = RA
      CATD(KDCRV+4) = DEC
C                                       Frequency
      CATD(KDCRV+2) = FREQ
C                                       Bandwidth.
      CATR(KRCIC+2) = BANDW
C                                       Number of frequencies.
      CATBLK(KINAX+2) = NCHAN
C                                       Number of polarizations.
      CATBLK(KINAX+1) = NPOLN
C                                       Observing date.
      CALL CHR2H (8, OBSDAT, 1, CATH(KHDOB))
C                                       Object.
      CALL CHR2H (8, SOURCE, 1, CATH(KHOBJ))
C                                       Telescope.
      CALL CHR2H (8, TELE, 1, CATH(KHTEL))
C                                       Receiver
      CALL CHR2H (8, INSTR, 1, CATH(KHINS))
C                                       Observer's name.
      CALL CHR2H (8, OBSR, 1, CATH(KHOBS))
C-----------------------------------------------------------------------
C                                       Enter antenna / time info
C                                       GST0 = Greenwich sidereal time
C                                         (in degrees) at midnight
C                                         on the reference date
C                                         (OBSDAT)
C                                       XIAT = 0 (time in UTC)
C                                       XUT1 = The UT1-UTC time
C                                          correction for ref. date.
C                                       NANT = number of antennas.
C                                       ANTLOC(i,n) is the position of
C                                          antenna n in meters from
C                                          the array reference center.
C                                          i=1=X, i=2=Y, I=3=Z.
C                                          (see AIPS manual Vol 2)
C                                       ANTNAM(n) is the antenna
C                                          name, up to 8 char.
C
C
C
C     USER CODE GOES HERE
C***********************************************************************
C   SAMPLE CODE
C
C      CALL ZTXIO ('READ', LUN, FIND, LINE, IRET)
C      IF (IRET.NE.0) THEN
C         WRITE (MSGTXT,1031) IRET
C         GO TO 990
C         END IF
C      READ (LINE,2003) NANT, GST0, XIAT, XUT1
C 2003 FORMAT (I5,3F15.5)
C      DO 3000 I = 1,NANT
C         CALL ZTXIO ('READ', LUN, FIND, LINE, IRET)
C         IF (IRET.NE.0) THEN
C            WRITE (MSGTXT,1031) IRET
C            GO TO 990
C            END IF
C         READ (LINE,2004) ANTNAM(I),
C     *      ANTLOC(1,I), ANTLOC(2,I), ANTLOC(3,I)
C 3000    CONTINUE
C 2004 FORMAT (A8,3E15.5)
C***********************************************************************
C                                       Close INFILE
      CALL ZTXCLS (LUN, FIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1032) IRET
         GO TO 990
         END IF
C
C                                       Finished.
      IRET = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('NEWHED: ERROR',I3,' OPENING INPUT FILE')
C1031 FORMAT ('NEWHED: ERROR',I3,' READING INPUT FILE')
 1032 FORMAT ('NEWHED: ERROR',I3,' CLOSING INPUT FILE')
      END
      SUBROUTINE FIDDLE (NUMVIS, U, V, W, T, IA1, IA2, VIS, RPARM, IRET)
C-----------------------------------------------------------------------
C  This is a skeleton version of subroutine FIDDLE which allows the
C  user to create a UV data base.  Visibilities are returned one at
C  a time and are written on the output file.
C
C       Up to 10 history entries can be written by using WRITE to
C  record up to 64 characters per entry into array HISCRD. Ex:
C     WRITE (HISCRD(entry #),format #) list
C  The history is written after the last call to FIDDLE.
C
C       Messages can be written to the monitor/logfile by writing
C  the message (up to 80 char) into array MSGTXT in COMMON /MSGCOM/
C  and then issuing a call:
C     CALL MSGWRT (priority #)
C
C       Unit 1 is the line printer
C
C       If IRET .GT. 0 then the output file will be destroyed.
C       A value of IRET .lt. 0 indicates the end of the data.
C
C
C       See the precursor comments for UVPGET for a description
C  of the contents of COMMON /UVHDR/ which allows easy access to
C  much of the information from the catalog header (CATBLK) and
C  which describes the order in which the data is being written.
C
C       After all data has been processed a final call will be made to
C  FIDDLE with NUMVIS = -1.  This is to allow for the completion of
C  pending operations, i.e. preparation of HIstory cards.
C
C     AIPS I/O  LUN 16 is open and not available to FIDDLE.
C  FORTRAN unit numbers greater than 50 will probably not get the
C  AIPS routines confused.  (Any unit numbers other that 1 and 5
C  will probably also work.)
C
C       The current contents of CATBLK will be written back to the
C  catalog after the last call to FIDDLE.
C
C  Inputs:
C     NUMVIS     I    Visibility number, -1 => final call, no data
C                     passed but allows any operations to be completed.
C
C  Inputs from COMMON:
C     IN2FIL  C*48  Name of the aux. file
C     APARM   R(10) User array.
C     BPARM   R(10) User array.
C     RA         D  Right ascension (1950) of phase center. (deg)
C     DEC        D  Declination (1950) of phase center. (deg)
C     FREQ       D  Frequency of observation (Hz)
C     NRPARM     I  # random parameters.
C     NCOR       I  # correlators
C     CATBLK(256)I  Catalog header record. See [DOC]HEADER for details
C
C  Output:
C     U       R       U in wavelengths at the reference frequency.
C     V       R       V in wavelengths
C     W       R       W in wavelengths
C     T       R       Time in days since the midnight at the start of
C                     the reference date.
C     IA1     I       Antenna number of the first antenna.
C     IA2     I       Antenna number of the second antenna.
C                     NOTE: IA2 MUST be greater that IA1
C     RPARM   R       Modified random parameter array. NB U,V,W,
C                     time and baseline should not be modified in RPARM
C     VIS     R(3,*)  Visibilities.  The first dimension is the COMPLEX
C                     axis in the order Real part, Imaginary part,
C                     weight. The order of the following visibilities is
C                     defined by variables in COMMOM /UVHDR/ (originally
C                     specified in NEWHDR).  The order number for Stokes
C                     parameters is JLOCS and the order number for
C                     frequency is given by JLOCF.  The lower order
C                     number  increases faster in the array.
C                     See precursor comments in UVPGET for more details.
C     IRET    I       Return code  -1 => End of data.
C                             0 => OK
C                            >0 => error, terminate.
C
C  Output in COMMON:
C     NUMHIS   I          # history entries (max. 10)
C     HISCRD   C(NUMHIS)  History records
C     CATBLK   I          Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IA1, IA2, IRET
      REAL      U, V, W, T, VIS(3,*), RPARM(*)
C
C      CHARACTER LINE*80
C      INTEGER   LUN, FIND
C      LOGICAL   APPEND
      INCLUDE 'UVFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
C***********************************************************************
C   SAMPLE CODE
C
C      CHARACTER ANTSYM*20
C      INTEGER   IDAY0, IDAY, IYR, IYR0, IUT, IHR, IMN, IS1, IS2,
C     *   I, IT
C      REAL      AMP, PHASE
C      SAVE LUN, FIND
C      DATA ANTSYM /'ABCDEFGHIJKLNMOPQRST'/
C***********************************************************************
C-----------------------------------------------------------------------
      IRET = 0
C
C    USER CODE GOES HERE
C
C
C
C
C
C
C***********************************************************************
C   SAMPLE CODE
C
C                                       Check NUMVIS
C      IF (NUMVIS-1) 500, 10, 100
C                                       Initialize I/O etc.
C                                       Open IN2FIL on lun 10
C 10   LUN = 10
C      APPEND = .FALSE.
C      CALL ZTXOPN ('READ', LUN, FIND, INFILE, APPEND, IRET)
C      IF (IRET.NE.0) THEN
C         WRITE (MSGTXT,1030) IRET
C         GO TO 990
C         END IF
C      CALL ZTXIO ('READ', LUN, FIND, LINE, IRET)
C      IF (IRET.NE.0) THEN
C         WRITE (MSGTXT,1031) IRET
C         GO TO 990
C         END IF
C         READ (LINE,2000) IYR0,IDAY0
C                                       Read and crunch data.
C 100  CALL ZTXIO ('READ', LUN, FIND, LINE, IRET)
C      IF (IRET.NE.0) THEN
C         WRITE (MSGTXT,1031) IRET
C         GO TO 990
C         END IF
C      READ (LINE,2001,END=600) IYR,IDAY,IUT,IS1,IS2,U,V,AMP,PHASE
C      IHR = IUT / 100
C      IMN = IUT - IHR * 100
C      T = (IDAY - IDAY0) + IHR/24. + IMN/1440. + XIAT
C                                       Find antenna numbers.
C      IA1 = NANT
C      IA2 = NANT+1
C      DO 110 I = 1,NANT
C         IF (IS1.EQ.ANTSYM(I:I)) IA1 = I
C         IF (IS2.EQ.ANTSYM(I:I)) IA2 = I
C 110     CONTINUE
C      U = U * 1.0E6
C      V = V * 1.0E6
C      W = 0.0
C      PHASE = PHASE * 1.74533E-2
C      VIS(1,1) = AMP * COS (PHASE)
C      VIS(2,1) = AMP * SIN (PHASE)
C      VIS(3,1) = 1.0
C                                       Check if need to reverse bl.
C      IF (IA2.GT.IA1) GO TO 999
C                                       Flip baseline.
C         IT = IA1
C         IA1 = IA2
C         IA2 = IT
C         U = -U
C         V = -V
C         VIS(2,1) = - VIS(2,1)
C         GO TO 999
C                                       Last call, do history.
C 500  CONTINUE
C      NUMHIS = 1
C      WRITE (HISCRD(NUMHIS),1500) NANT
C      GO TO 600
C                                       End of data.
C 600  IRET = -1
C                                       Close IN2FIL
C      CALL ZTXCLS (LUN, FIND, IRET)
C      IF (IRET.NE.0) THEN
C         WRITE (MSGTXT,1032) IRET
C         GO TO 990
C         END IF
C      GO TO 999
C
C
 999  RETURN
C-----------------------------------------------------------------------
C   FORMAT STATEMENTS GO HERE
C 1030 FORMAT ('FIDDLE: ERROR',I3,' OPENING INPUT FILE')
C 1031 FORMAT ('FIDDLE: ERROR',I3,' READING INPUT FILE')
C 1032 FORMAT ('FIDDLE: ERROR',I3,' CLOSING INPUT FILE')
C 2000 FORMAT (3X,I3,I3)
C 2001 FORMAT (3X,I3,I3,I5,7X,2A1,1X,2F8.2,13X,F6.3,7X,F5.0)
C 1500 FORMAT (' Number of antennas =',I5)
      END

      SUBROUTINE PLTVEC (VPCORN, VBLC, VTRC, VASEC, LABEL, IWBUFF, IERR)
C-----------------------------------------------------------------------
C! Draw polarization vector in a box
C# Map Plot
C-----------------------------------------------------------------------
C;  Copyright (C) 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PLTVEC  plots the polarization vector
C   Inputs:
C      VPCORN   I        Code indicating where to put the plot
C                           0 or 5: in the middle of the pane
C                                   10    darker
C                           1: lower left-hand corner  6 darker
C                           2: lower right-hand corner 7 darker
C                           3: upper left-hand corner  8 darker
C                           4: upper right-hand corner 9 darker
C      VBLC     I(2)     BLC of pol box
C      VTRC     I(2)     TRC of pol box
C      VASEC    R        Length of vector in ASEC
C      LABEL    C*(*)    Label
C   In/out:
C      IWBUFF   I(256)   I/O block for graph file.
C   Output:
C      IERR     I        Error code. 0: success, > 0 from plot routines
C                            -1: HPBW not defined
C                            -2: plot too big
C-----------------------------------------------------------------------
      INTEGER   VPCORN, VBLC(2), VTRC(2), IERR, IWBUFF(256)
      REAL      VASEC
      CHARACTER LABEL*(*)
C
      INTEGER   INTYPE, J, JTRIM
      REAL      X, Y, DX, DY
      CHARACTER TXTMSG*80
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DGPH.INC'
C-----------------------------------------------------------------------
      IERR = 0
      INTYPE = GPHLTY
      IF (AXTYP(LOCNUM).NE.1) GO TO 999
      IF ((LABTYP(LOCNUM).NE.56) .AND. (LABTYP(LOCNUM).NE.65)) GO TO 999
      IF ((VBLC(1).GE.VTRC(1)) .OR. (VBLC(2).GE.VTRC(2))) GO TO 999
C                                       state our intentions
      TXTMSG = 'Draw polarization vector inside box'
      CALL GCOMNT (-1, TXTMSG, IWBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Draw a box around the beam
      IF (VPCORN.NE.0) THEN
         IF (GPHLTY.NE.1) THEN
            CALL GLTYPE (1, IWBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         X = VBLC(1)
         Y = VBLC(2)
         CALL GPOS (X, Y, IWBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         X = VTRC(1)
         CALL GVEC (X, Y, IWBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         Y = VTRC(2)
         CALL GVEC (X, Y, IWBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         X = VBLC(1)
         CALL GVEC (X, Y, IWBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         Y = VBLC(2)
         CALL GVEC (X, Y, IWBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       pol vec
         X = VBLC(1) + 0.25 * (VTRC(1) - VBLC(1))
         Y = (VBLC(2) + VTRC(2)) / 2.0
         CALL GPOS (X, Y, IWBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         X = X + (VTRC(1) - VBLC(1)) / 2.0
         CALL GVEC (X, Y, IWBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       characters
         J = JTRIM (LABEL)
         IF (J.GT.0) THEN
            CALL REFRMT (LABEL, ' ', J)
            X = (VTRC(1) + VBLC(1)) / 2.0
            DX = -J / 2.0
            DY = 0.5
            IF (GPHDOT) DY = 1.0
            CALL GPOS (X, Y, IWBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GCHAR (J, 0, DX, DY, LABEL(:J), IWBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         END IF
      IF (GPHLTY.NE.INTYPE) THEN
         CALL GLTYPE (INTYPE, IWBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
      WRITE (MSGTXT,1000) VASEC
      CALL MSGWRT (3)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PLTVEC drawing boxed pol. vector of length',F8.3,' asec')
      END

      SUBROUTINE ZCMPRS (IVOL, PNAME, LUN, LSIZE, IERR)
C-----------------------------------------------------------------------
C! release space from the end of an open disk file
C# Z IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZCMPRS releases unused disk space from the end of an open disk file.
C   "Byte" defined as 1/2 of a small integer.
C   Inputs:
C      IVOL    I        volume number
C      PNAME   C*48     physical file name
C      LUN     I        logical unit number under which file is open.
C   In/Out:
C      LSIZE   I        (In) desired final size in AIPS blocks
C                       (Out) actual final size in AIPS blocks
C   Outputs:
C      IERR    I        error code: 0 => ok
C                                   1 => input data error
C                                   2 => compress error
C   UNICOS version - uses ZCMPR2.
C-----------------------------------------------------------------------
      CHARACTER PNAME*48
      INTEGER   IVOL, LUN, LSIZE, IERR
C
      INTEGER   TOFF, FIND, SYSERR, IMAP, BSIZE
      LOGICAL   MAP
      HOLLERITH ANAME(12)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
C-----------------------------------------------------------------------
C                                       build file descriptor
C                                       Find the FTAB entry.
      TOFF = NMOFF
      MAP = .FALSE.
      IMAP = 0
      CALL LSERCH ('SRCH', LUN, FIND, MAP, IERR)
      IF (IERR.EQ.0) GO TO 10
         MAP = .TRUE.
         TOFF = MOFF
         IMAP = 1
         CALL LSERCH ('SRCH', LUN, FIND, MAP, IERR)
         IF (IERR.EQ.0) GO TO 10
            WRITE (MSGTXT,1000) LUN
            CALL MSGWRT (7)
            GO TO 999
C                                       Truncate file
 10   BSIZE = LSIZE
C      CALL CHR2H (48, PNAME, 1, ANAME)
      CALL ZCMPR2 (FTAB(FIND+TOFF), PNAME, BSIZE, IMAP, SYSERR, IERR)
      IF (IERR.EQ.0) THEN
         LSIZE = BSIZE
      ELSE IF (IERR.EQ.1) THEN
         WRITE (MSGTXT,1010) PNAME
         CALL MSGWRT (7)
      ELSE
         CALL ZERROR ('ZCMPR2', SYSERR, PNAME, -999, MAP)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZCMPRS: LUN NOT OPEN ',I6)
 1010 FORMAT ('ZCMPRS: CAN''T TRANSLATE NAME =',A)
      END

      SUBROUTINE TYSEL (DISKI, CNOI, DISKO, CNOO, VER, CATIN, CATOUT,
     *   LUNI, LUNO, BPOL, EPOL, BIF, EIF, IFQID, TB, TE, AN, NA, ISUB,
     *   JSUB, BUFFER, OBUFF, IRET)
C-----------------------------------------------------------------------
C! Copies a subset of IFs in a TY table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1998, 2007, 2011
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Copies a subset of IFs in a TY table, can also modify the FQ ID
C   Inputs:
C      DISKI    I        Input volume number
C      CNOI     I        Input catalog number
C      DISKO    I        Output volume number
C      CNOO     I        Output catalog number
C      VER      I        Version to check/modify
C      CATIN    I(256)   Input catalog header
C      LUNI     I        LUN to use
C      LUNO     I        LUN to use
C      BPOL     I        First polarization to copy
C      EPOL     I        Last polarization to copy
C      BIF      I        Start IF number
C      EIF      I        End IF number
C      IFQID    I        FQ ID to select (output value is 1)
C                        if <= 0 then output value unchanged.
C      TB       D        Beginning time in days
C      TE       D        Ending time in days
C      AN       I(*)     Array of selected antennas
C      NA       I        Number of selected antennas
C      ISUB     I        Selected subarray (= 0 any)
C      JSUB     I        Output subarray number (< 0 => NO CHANGE)
C   Input/Output:
C      CATOUT   I(256)   Output catalog header
C      BUFFER   I(*)     Work buffer
C      OBUFF    I(*)     Work buffer
C   Output:
C      IRET     I        Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER DISKI, CNOI, DISKO, CNOO, VER, CATIN(256), CATOUT(256),
     *   LUNI, LUNO, BPOL, EPOL, BIF, EIF, IFQID, AN(8), NA, ISUB, JSUB,
     *   BUFFER(*), OBUFF(*), IRET
      DOUBLE PRECISION TB, TE
C
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ITYRNO, TYKOLS(MAXTYC), TYNUMV(MAXTYC), NUMPOL, NUMIF,
     *   OKOLS(MAXTYC), ONUMV(MAXTYC), NTYROW, I, OVER, SOURID, ANTNO,
     *   SUBA, FREQID, OTYRNO, NEWNIF, IIF, JIF, IPOL, K, LBIF, LBPOL,
     *   NEWPOL
      LOGICAL   REFMT, GOTIT
      REAL      TIME, TIMEI, TSYS(2,MAXIF), TANT(2,MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       Open TY file
      CALL TYINI ('READ', BUFFER, DISKI, CNOI, VER, CATIN, LUNI, ITYRNO,
     *   TYKOLS, TYNUMV, NUMPOL, NUMIF, IRET)
      IF (IRET.EQ.2) THEN
         IRET = 0
         GO TO 999
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       New no. of IFs
      LBIF = MAX (1, BIF)
      NEWNIF = MIN (NUMIF, EIF) - LBIF + 1
      IF (NEWNIF.LE.0) THEN
         NEWNIF = NUMIF
         LBIF = 1
         END IF
      LBPOL = MAX (1, BPOL)
      NEWPOL = MIN (2, MIN (NUMPOL, EPOL)) - LBPOL + 1
      IF (NEWPOL.LE.0) THEN
         NEWPOL = NUMPOL
         LBPOL = 1
         END IF
      REFMT = (NEWNIF.NE.NUMIF) .OR. (NEWPOL.NE.NUMPOL)
C                                       # rows in old table
      NTYROW = BUFFER(5)
C                                       Open up new TY table
      OVER = VER
      CALL TYINI ('WRIT', OBUFF, DISKO, CNOO, OVER, CATOUT, LUNO,
     *   OTYRNO, OKOLS, ONUMV, NEWPOL, NEWNIF, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 100 I = 1,NTYROW
         CALL TABTY ('READ', BUFFER, ITYRNO, TYKOLS, TYNUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, TSYS, TANT,
     *      IRET)
C                                       Error reading table
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1020) IRET
            GO TO 990
C                                       check subarray, time
         ELSE IF (IRET.EQ.0) THEN
            IF ((SUBA.GT.0) .AND. (ISUB.GT.0) .AND. (ISUB.NE.SUBA))
     *         IRET = -1
            IF ((TIME.LT.TB) .OR. (TIME.GT.TE)) IRET = -1
            IF ((IFQID.GT.0) .AND. (FREQID.GT.0) .AND.
     *         (IFQID.NE.FREQID)) IRET = -1
C                                       antenna
            IF ((NA.GT.0) .AND. (ANTNO.GT.0)) THEN
               GOTIT = .FALSE.
               DO 30 K = 1,NA
                  GOTIT = GOTIT .OR. (ANTNO.EQ.AN(K))
 30               CONTINUE
               IF (.NOT.GOTIT) IRET = -1
               END IF
            END IF
C                                       Is this record selected ?
         IF (IRET.LT.0) THEN
            REFMT = .TRUE.
C                                       Select IFs
         ELSE
            DO 90 JIF = 1,NEWNIF
               IIF = JIF + BIF - 1
               DO 80 IPOL = 1,NEWPOL
                  K = IPOL + LBPOL - 1
                  TSYS(IPOL,JIF) = TSYS(K,IIF)
                  TANT(IPOL,JIF) = TANT(K,IIF)
 80               CONTINUE
 90            CONTINUE
C                                       Write new one
            IF (IFQID.GT.0) FREQID = 1
            IF (JSUB.GE.0) SUBA = JSUB
            CALL TABTY ('WRIT', OBUFF, OTYRNO, OKOLS, ONUMV, NEWPOL,
     *         NEWNIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, TSYS,
     *         TANT, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1020) IRET
               GO TO 990
               END IF
            END IF
 100     CONTINUE
      IRET = 0
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ITYRNO, BUFFER, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OTYRNO, OBUFF, OBUFF, IRET)
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         IF (REFMT) THEN
            WRITE (MSGTXT,1100) 'Reformatted TY', DISKI, CNOI, VER,
     *         DISKO, CNOO, OVER
         ELSE
            WRITE (MSGTXT,1100) 'Copied TY', DISKI, CNOI, VER, DISKO,
     *         CNOO, OVER
            END IF
         CALL MSGWRT (3)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('TYSEL: ERROR ',I3,' RETURNED FROM TYINI')
 1020 FORMAT ('TYSEL: ERROR ',I3,' RETURNED FROM TABTY')
 1100 FORMAT (A,' file from vol/cno/vers',I3,I5,I4,' to',I3,I5,I4)
      END

      SUBROUTINE ZCRLOG (LLEN, LOGNAM, TLEN, TLOG, IERR)
C-----------------------------------------------------------------------
C! (re)define a logical name
C# Z2 System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Defines a new logical name (i.e., environment variable) or redefines
C   an old one.
C   Inputs:
C      LLEN     I       Length of lognam (< 65)
C      LOGNAM   H(*)    Logical name
C      TLEN     I       Length of tlen (< 257)
C      TLOG     H(*)    New translated logical name
C   Outputs:
C      IERR     I       Error return code: 0 okay
C                          1 => error
C   Generic version - stubbed
C-----------------------------------------------------------------------
      INTEGER   LLEN, TLEN, IERR
      HOLLERITH LOGNAM(*), TLOG(*)
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'ZCRLOG REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (8)
C
 999  RETURN
      END

      SUBROUTINE YTVOPN (BUF, IERR)
C-----------------------------------------------------------------------
C! open the TV device and the TV disk control/parameter file.
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   YTVOPN opens the TV including TV lock/parameter file and reads the
C   parameters, placing them in commons.
C   Outputs:
C      BUF   I(256)   Scratch buffer
C      IERR  I        Error return from YTVOP2
C                        = 10 TV unavailable to this version
C   Generic version - uses YDTVC to get TV device common
C-----------------------------------------------------------------------
      INTEGER   BUF(256), IERR
C
      INTEGER   IER
      LOGICAL   F
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      IERR = 10
      IF (NTVDEV.LE.0) GO TO 999
      TVLUN = 9
      TVIND = 0
      TVMAP = F
      TVLUN2 = 8
      TVIND2 = 0
C                                       Is TV available?
      CALL YDTVC ('OPEN', BUF, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.4) THEN
            WRITE (MSGTXT,1010) IERR
         ELSE
            WRITE (MSGTXT,1011) NTVDEV
            END IF
         GO TO 990
         END IF
C                                       Open actual TV device
 20   CALL YTVOP2 (TVLUN, TVIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         TVIND = 0
         GO TO 990
         END IF
C                                       get current status
 40   CALL YTVMC
      CALL YDTVC ('GET ', BUF, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1040) IERR
C                                       error
 990  CALL MSGWRT (7)
      IF (TVIND.GT.0) CALL YTVCL2 (TVLUN, TVIND, IER)
      TVIND = 0
      IF (TVIND2.GT.0) CALL YDTVC ('CLOS', BUF, IER)
      TVIND2 = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('YTVOPN: TV LOCK OPEN ERROR',I7)
 1011 FORMAT ('TV DEVICE',I3,' CURRENTLY BEING USED BY SOMEONE ELSE')
 1030 FORMAT ('YTVOPN: TV OPEN ERROR',I7)
 1040 FORMAT ('YTVOPN: YDTVC RETURNS ERROR',I7)
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QVRVRS (C, K, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Reverse the elements of a vector.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Reverse the elements in a vector:
C       C(mK) = C((N-m)K)  for m = 0, N-1
C   Inputs:
C      C  I  Vector base address
C      K  I  C address increment
C      N  I  Element count
C-----------------------------------------------------------------------
      INTEGER   C, K, N, JA, JC, NO2, LOOP
      REAL      TEMP
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Addresses 1-rel
      JC = C + 1
      JA = JC + (N - 1) * K
      NO2 = N / 2
C                                       Loop
C@DIR IGNORE RECRDEPS(APCORE)
      DO 100 LOOP = 1,NO2
         TEMP = APCORE(JC)
         APCORE(JC) = APCORE(JA)
         APCORE(JA) = TEMP
         JA = JA - K
         JC = JC + K
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE YCNECT (X1, Y1, X2, Y2, IC, BUFFER, IERR)
C-----------------------------------------------------------------------
C! write line segment between 2 points on TV
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YCNECT writes a line segment on the TV.  This version will work on
C   all TVs.  It is called a Y routine to allow the use of hardware
C   vector generators on those TVs equiped with them.
C   Inputs:
C      X1      I      start X position
C      Y1      I      start Y position
C      X2      I      end X position
C      Y2      I      end Y position
C      IC      I      Channel (1 to NGRAY+NGRAPH)
C      BUFFER  I(*)   Buffer contains desired intensity (size > max
C                     horizontal or vertical line, e.g., 1280)
C   Output:
C      IERR    I      error code : 0 => ok
C   Version for no TV at all - stubbed.
C-----------------------------------------------------------------------
      INTEGER    X1, Y1, X2, Y2, IC, BUFFER(*), IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'YCNECT: THERE IS NO TV CONFIGURED'
      CALL MSGWRT (8)
C
 999  RETURN
      END

LOCAL INCLUDE 'BSTST.INC'
C                                                          Include BSTST
C                                       Local include for BSTST
      REAL      XSIZE(2), XBCH, XECH, XGAUSS, GMAX(4), GPOSN(2,4),
     *   GWIDTH(3,4), DPARM(10), FLUX, FACTOR, APARM(10), XNIT, GAIN,
     *   PRTLEV, XSEQ, XDISK, XYR, XDOTV, XCHAN
      HOLLERITH XNAME(3), XCLASS(2)
      COMMON /INPARM/ XSIZE, XBCH, XECH, XGAUSS, GMAX, GPOSN, GWIDTH,
     *   DPARM, FLUX, FACTOR, APARM, XNIT, GAIN, PRTLEV, XNAME, XCLASS,
     *   XSEQ, XDISK, XYR, XDOTV, XCHAN
C
      INTEGER   NCHAN, NGAUSS, SCRTCH(256), DISK, SEQ, CNO, PLUN, PFIND,
     *   NPARM, IUSER, BCHAN, ECHAN, NITER
      REAL      YS(3), Y0(2)
      CHARACTER NAME*12, CLASS*6
      COMMON /BSTSCO/  SCRTCH, NCHAN, NGAUSS, DISK, SEQ, CNO, PLUN,
     *   PFIND, NPARM, IUSER, YS, Y0, BCHAN, ECHAN, NITER
      COMMON /BSTSCH/ NAME, CLASS
C                                                          End BSTST.
LOCAL END
      PROGRAM BSTST
C-----------------------------------------------------------------------
C! Tests frequency-switch correction
C# Map singledish
C-----------------------------------------------------------------------
C;  Copyright (C) 1996-1999, 2002, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BSTST correctes two beam-switch images (each total power) producing
C   a best estimate of the combination
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C   Programmer Eric W. Greisen:  August 1996
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'BSTST.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'BSTST '/
C-----------------------------------------------------------------------
C                                       Get input parameters create
C                                       output file
      CALL BSTSIN (PRGM, IRET)
C                                       correction/output routine
      IF (IRET.EQ.0) CALL BSTSDO (IRET)
C
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE BSTSIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   BSTSIN gets input parameters for BSTST and creates an output file.
C   Inputs:
C      PRGN   C*6   Program name
C   Output:
C      IRET   I     Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   IRET
C
      INTEGER   IERR
      CHARACTER FTYPE*2, STAT*4
      INCLUDE 'BSTST.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      IRET = 0
      FTYPE = ' '
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      CALL FILL (10, 0, IBAD)
C                                       Get input parameters.
      NPARM = 64
      CALL GTPARM (PRGN, NPARM, RQUICK, XSIZE, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) THEN
            GO TO 999
         ELSE
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
            END IF
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      NCHAN = XSIZE(1) + 0.5
      IF (NCHAN.LE.16) NCHAN = 1024
      NCHAN = MIN (8192, NCHAN)
      BCHAN = XBCH + 0.1
      IF (BCHAN.LE.0) BCHAN = 1
      ECHAN = XECH + 0.1
      IF (ECHAN.LE.BCHAN+10) ECHAN = NCHAN
      NGAUSS = XGAUSS + 0.5
      IF (NGAUSS.LE.0) NGAUSS = 1
      IF (APARM(1).LE.0.1) APARM(1) = 1.0
      IF (APARM(2).LE.0.1) APARM(2) = 1.0
      IF (APARM(3).LE.0.1) APARM(3) = 1.0
      IF ((GAIN.LE.0.0) .OR. (GAIN.GT.1.0)) GAIN = 0.1
      NITER = XNIT + 0.1
C                                       plot
      IF (PRTLEV.LT.0.0) THEN
         CALL H2CHR (12, 1, XNAME, NAME)
         CALL H2CHR (6, 1, XCLASS, CLASS)
         SEQ = XSEQ + 0.1
         DISK = XDISK + 0.1
         IUSER = NLUSER
         CNO = 1
         CALL CATDIR ('SRCH', DISK, CNO, NAME, CLASS, SEQ, FTYPE,
     *      IUSER, STAT, SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, NAME, CLASS, SEQ, FTYPE,
     *         DISK, IUSER
            GO TO 990
            END IF
C                                       Get catblk, mark file write
         IF (XDOTV.LE.0.0) THEN
            CALL CATIO ('READ', DISK, CNO, CATBLK, 'WRIT', SCRTCH, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ CATALOG HEADER'
               GO TO 990
               END IF
            NCFILE = 1
            FVOL(1) = DISK
            FCNO(1) = CNO
            FRW(1) = 1
            END IF
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BSTSIN: ERROR',I5,' DOING ',A)
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,1X,A2,
     *   'DISK=',I2,' USER=',I5)
      END
      SUBROUTINE BSTSDO (IRET)
C-----------------------------------------------------------------------
C   BSTSDO does all the work
C   Output:
C      PIMAG   R(*)   memory for plus image
C      MIMAG   R(*)   memory for minus image
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   I, J, N, IC, NSUM, JJ, TVCHN, GRCHN, TVCORN(2), IVER,
     *   PBUFF(256), IROUND, FSUM, CH1, CH2, CH3, CH4, NAC
      REAL      BUFFP(8192), BUFFR(8192), BUFFD(8192), THROWP, THROWM,
     *   CONV(16500), A(4), BSUM, X, XSUMS, XMAX, RMAX, RMIN, DX, DY, Y,
     *   PMAX, PMIN, THRAWP, THRAWM, WP, WM, DP, DM, MMAX, RSUMS, RMAXS,
     *   FSUMS, FMAX, BUFFC(8192), BUFFW(8192), CSUMS, CMAXS, CMAXA,
     *   CAVG, XAVG
      LOGICAL   DOTV, PENUP, WASUP
      CHARACTER PFILE*48, STRNG1*80, STRNG2*80
      INCLUDE 'BSTST.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DGPH.INC'
C-----------------------------------------------------------------------
      DOTV = XDOTV.GT.0.0
      NAC = ECHAN - BCHAN + 1
      TVCHN = 0
      TVCORN(1) = 0
      TVCORN(2) = 0
      GRCHN = IROUND (XCHAN)
      IF (GRCHN.LE.0) GRCHN = 1
      PLUN = 26
      IF (FLUX.GT.0.0) CALL RANDIN (I)
      DO 10 N = 1,NGAUSS
         IF (GWIDTH(1,N).LE.0.01) GWIDTH(1,N) = 3.0
         A(N) = 4.0 * LOG (2.0) / (GWIDTH(1,N) * GWIDTH(1,N))
 10      CONTINUE
C                                       Reference spectrum
      MMAX = 0.0
      DO 20 I = 1,NCHAN
         BUFFD(I) = 0.0
         DO 15 N = 1,NGAUSS
            BUFFD(I) = BUFFD(I) + GMAX(N) * EXP (-A(N) *
     *         (I - GPOSN(1,N)) * (I - GPOSN(1,N)))
 15         CONTINUE
         MMAX = MAX (MMAX, BUFFD(I))
 20      CONTINUE
      MMAX = MMAX / 100.0
      CH1 = APARM(4) + 0.1
      CH2 = APARM(5) + 0.1
      IF (CH1.LE.0) THEN
         DO 21 I = BCHAN,ECHAN
            IF (BUFFD(I).GT.MMAX) THEN
               CH1 = MAX (1,I -1)
               GO TO 22
               END IF
 21         CONTINUE
         END IF
 22   IF (CH2.LE.0) THEN
         DO 23 I = BCHAN,ECHAN
            IF (BUFFD(NCHAN+1-I).GT.MMAX) THEN
               CH2 = MIN (NCHAN,NCHAN+2-I)
               GO TO 24
               END IF
 23         CONTINUE
         END IF
C                                       loop over throws
 24   IF (FACTOR.LE.0.1) FACTOR = 1.0
      DO 100 J = 1,10
         IF (DPARM(J).NE.0.0) THEN
            THROWP = - DPARM(J) / 2.0
            THROWM = DPARM(J) / 2.0
            CH4 = THROWM + 0.5
            CH3 = MAX (BCHAN, CH1-CH4)
            CH4 = MIN (ECHAN, CH2+CH4)
            THRAWP = THROWP * FACTOR * SQRT (APARM(1))
            THRAWM = THROWM * FACTOR / SQRT (APARM(1))
            WP = 1.0 / APARM(3)
            WM = 1.0 / WP
            DP = SQRT (APARM(2))
            DM = 1.0 / DP
            DO 30 I = BCHAN,ECHAN
               BUFFP(I) = 0.0
               DO 25 N = 1,NGAUSS
                  BUFFP(I) = BUFFP(I) + GMAX(N) *
     *               (DP * EXP (-WP*A(N)*((I+THRAWP-GPOSN(1,N))**2)) -
     *               DM * EXP (-WM*A(N)*((I+THRAWM-GPOSN(1,N))**2)))
 25               CONTINUE
               IF (FLUX.GT.0) THEN
                  CALL NOISE (X)
                  BUFFP(I) = BUFFP(I) + FLUX * X
                  END IF
 30            CONTINUE
C                                       Convolving function
            CALL BSCONV (NAC, THROWP, THROWM, 1.0, IC, CONV)
C                                       Do it
            DO 40 N = 1,NAC
               BSUM = 0.0
               NSUM = 0.0
               DO 35 I = 1,NAC
                  JJ = I - N + IC
                  IF ((JJ.GT.0) .AND. (JJ.LE.2*NCHAN) .AND.
     *               (CONV(JJ).NE.0.0)) THEN
                     NSUM = NSUM + 1
                     BSUM = BSUM + BUFFP(I+BCHAN-1) * CONV(JJ)
                     END IF
 35               CONTINUE
               IF (NSUM.GT.0) THEN
                  BUFFR(N+BCHAN-1) = BSUM
               ELSE
                  BUFFR(N+BCHAN-1) = FBLANK
                  END IF
 40            CONTINUE
C                                       Do Clean too
            IF (NITER.GT.0) THEN
               CALL RFILL (8192, FBLANK, BUFFC)
               CALL RCOPY (NAC, BUFFP(BCHAN), BUFFW)
               CALL BSCLEN (NAC, THROWP, THROWM, NITER, GAIN, BUFFW,
     *            BUFFC(BCHAN))
               END IF
C                                       Find plot extrema
            XSUMS = 0.0
            XMAX = 0.0
            RSUMS = 0.0
            RMAXS = 0.0
            FSUMS = 0.0
            CMAXS = 0.0
            CMAXA = 0.0
            XAVG = 0.0
            CAVG = 0.0
            CSUMS = 0.0
            FMAX = 0.0
            NSUM = 0
            FSUM = 0
            RMIN = 0.0
            RMAX = 0.0
            PMIN = 0.0
            PMAX = 0.0
            DO 50 I = BCHAN,ECHAN
               X = BUFFD(I) - BUFFR(I)
               XSUMS = XSUMS + X * X
               XMAX = MAX (XMAX, ABS(X))
               XAVG = XAVG + X
               IF (NITER.GT.0) THEN
                  Y = BUFFD(I) - BUFFC(I)
                  CAVG = CAVG + Y
                  CMAXA = MAX (CMAXA, ABS(Y))
                  END IF
               IF ((I.LE.CH1) .OR. (I.GE.CH2)) THEN
                  NSUM = NSUM + 1
                  RSUMS = RSUMS + X * X
                  RMAXS = MAX (RMAXS, ABS(X))
                  IF (NITER.GT.0) THEN
                     CSUMS = CSUMS + Y * Y
                     CMAXS = MAX (CMAXS, ABS(Y))
                     END IF
                  END IF
               IF ((I.LE.CH3) .OR. (I.GE.CH4)) THEN
                  FSUM = FSUM + 1
                  FSUMS = FSUMS + BUFFP(I) ** 2
                  FMAX = MAX (FMAX, ABS(BUFFP(I)))
                  END IF
               IF (PRTLEV.LT.0.0) THEN
                  RMAX = MAX (RMAX, BUFFD(I))
                  RMAX = MAX (RMAX, BUFFR(I))
                  RMIN = MIN (RMIN, BUFFD(I))
                  RMIN = MIN (RMIN, BUFFR(I))
                  PMIN = MIN (PMIN, BUFFP(I))
                  PMAX = MAX (PMAX, BUFFP(I))
                  IF (NITER.GT.0) THEN
                     RMAX = MAX (RMAX, BUFFC(I))
                     RMIN = MIN (RMIN, BUFFC(I))
                     END IF
                  END IF
 50            CONTINUE
            IF (APARM(6).GT.0.0) THEN
               IF (APARM(8).GT.APARM(7)) RMIN = APARM(7)
               IF (APARM(8).GT.APARM(7)) RMAX = APARM(8)
               IF (APARM(10).GT.APARM(9)) PMIN = APARM(9)
               IF (APARM(10).GT.APARM(9)) PMAX = APARM(10)
               END IF
            X = (PMAX - PMIN) * 0.025
            RMAX = RMAX + X
            RMIN = RMIN - X
            PMAX = PMAX + X
            PMIN = PMIN - X
            XSUMS = SQRT (XSUMS / NAC)
            XAVG = XAVG / NAC
            IF (NSUM.GT.0) RSUMS = SQRT (RSUMS / NSUM)
            IF (FSUM.GT.0) FSUMS = SQRT (FSUMS / FSUM)
            WRITE (MSGTXT,1050) J, THROWP, THROWM, XMAX, XSUMS
            CALL MSGWRT (5)
            WRITE (MSGTXT,1052) CH1, CH2, RMAXS, RSUMS
            CALL MSGWRT (5)
            IF (NITER.GT.0) THEN
               IF (NSUM.GT.0) CSUMS = SQRT (CSUMS / NSUM)
               CAVG = CAVG / NAC
               WRITE (MSGTXT,1053) CH1, CH2, CMAXS, CSUMS
               CALL MSGWRT (5)
               END IF
            WRITE (MSGTXT,1054) CH3, CH4, FMAX, FSUMS
            CALL MSGWRT (5)
C                                       print
            IF (PRTLEV.GE.0.0) THEN
               DO 55 I = BCHAN,ECHAN
                  X = BUFFD(I) - BUFFR(I)
                  IF (ABS(X).GT.PRTLEV) THEN
                     WRITE (MSGTXT,1051) I, BUFFD(I), BUFFR(I), X
                     CALL MSGWRT (4)
                     END IF
 55               CONTINUE
C                                       plot
            ELSE
               IVER = 0
               IF (.NOT.DOTV) THEN
                  CALL MADDEX ('PL', DISK, CNO, CATBLK, PBUFF, .TRUE.,
     *               'WRIT', IVER, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'CREATE PLOT FILE'
                     GO TO 990
                     END IF
                  END IF
               CALL ZPHFIL ('PL', DISK, CNO, IVER, PFILE, IRET)
               CALL GINIT (DISK, CNO, PFILE, 0, 1, NPARM, IUSER, DOTV,
     *            TVCHN, GRCHN, TVCORN, CATBLK, PBUFF, PLUN, PFIND,
     *            IRET)
               IF (IRET.NE.0) GO TO 999

               WRITE (STRNG1,1055) THROWP, THROWM, XMAX, XSUMS
               CALL REFRMT (STRNG1, '_', I)
               IF ((FACTOR.NE.1.0) .OR. (APARM(1).NE.1.0) .OR.
     *            (APARM(2).NE.1.0) .OR. (APARM(3).NE.1.0)) THEN
                  WRITE (STRNG2,1056) FACTOR, APARM(1), APARM(2),
     *               APARM(3)
                  CALL REFRMT (STRNG2, '_', I)
               ELSE
                  STRNG2 = ' '
                  END IF
               CALL BSTLAB (NCHAN, NITER, IVER, RMIN, RMAX, PMIN, PMAX,
     *            STRNG1, STRNG2, YS, Y0, XYR, PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
C                                       label panels: EKH
               X = 0.0
               Y = (RMAX - RMIN) * YS(1) + Y0(1)
               DX = 3.0
               DY = -2.5
               CALL GPOS (X, Y, PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
               WRITE (STRNG1,1057) 'max err', XMAX
               CALL REFRMT (STRNG1, '_', I)
               CALL GICHAR (1, I, 0, DX, DY, STRNG1, PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
               WRITE (STRNG1,1057) 'rms err', RSUMS
               DY = DY - 1.333
               CALL GPOS (X, Y, PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
               CALL REFRMT (STRNG1, '_', I)
               CALL GICHAR (1, I, 0, DX, DY, STRNG1, PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
               WRITE (STRNG1,1057) 'avg err', XAVG
               DY = DY - 1.333
               CALL GPOS (X, Y, PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
               CALL REFRMT (STRNG1, '_', I)
               CALL GICHAR (1, I, 0, DX, DY, STRNG1, PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
               X = 1000.0
               DX = -6.0
               DY = -2.5
               CALL GPOS (X, Y, PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
               CALL GCHAR (3, 0, DX, DY, 'EKH', PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
C                                       label Clean
               IF (NITER.GT.0) THEN
                  X = 0.0
                  Y = (RMAX - RMIN) * YS(2) + Y0(2)
                  DX = 3.0
                  DY = -2.5
                  CALL GPOS (X, Y, PBUFF, IRET)
                  IF (IRET.NE.0) GO TO 999
                  WRITE (STRNG1,1057) 'max err', CMAXA
                  CALL REFRMT (STRNG1, '_', I)
                  CALL GICHAR (1, I, 0, DX, DY, STRNG1, PBUFF, IRET)
                  IF (IRET.NE.0) GO TO 999
                  WRITE (STRNG1,1057) 'rms err', CSUMS
                  DY = DY - 1.333
                  CALL GPOS (X, Y, PBUFF, IRET)
                  IF (IRET.NE.0) GO TO 999
                  CALL REFRMT (STRNG1, '_', I)
                  CALL GICHAR (1, I, 0, DX, DY, STRNG1, PBUFF, IRET)
                  IF (IRET.NE.0) GO TO 999
                  WRITE (STRNG1,1057) 'avg err', CAVG
                  DY = DY - 1.333
                  CALL GPOS (X, Y, PBUFF, IRET)
                  IF (IRET.NE.0) GO TO 999
                  CALL REFRMT (STRNG1, '_', I)
                  CALL GICHAR (1, I, 0, DX, DY, STRNG1, PBUFF, IRET)
                  IF (IRET.NE.0) GO TO 999
                  X = 1000.0
                  DX = -8.0
                  DY = -2.5
                  CALL GPOS (X, Y, PBUFF, IRET)
                  IF (IRET.NE.0) GO TO 999
                  CALL GICHAR (1, 5, 0, DX, DY, 'Clean', PBUFF, IRET)
                  IF (IRET.NE.0) GO TO 999
                  END IF
C                                       label difference
               X = 0.0
               Y = (PMAX - PMIN) * YS(3)
               DX = 3.0
               DY = -2.5
               CALL GPOS (X, Y, PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
               WRITE (STRNG1,1057) 'max',FMAX
               CALL REFRMT (STRNG1, '_', I)
               CALL GICHAR (1, I, 0, DX, DY, STRNG1, PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
               WRITE (STRNG1,1057) 'rms',FSUMS
               DY = DY - 1.333
               CALL GPOS (X, Y, PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
               CALL REFRMT (STRNG1, '_', I)
               CALL GICHAR (1, I, 0, DX, DY, STRNG1, PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
               X = 1000.0
               DX = -13.0
               DY = -2.5
               CALL GPOS (X, Y, PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
               CALL GICHAR (1, 10, 0, DX, DY, 'Difference', PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
C                                       plot model
               CALL GLTYPE (2, PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
               DX = NCHAN + 2
               DX = 1000.0 / DX
               X = DX / 2.0 - DX
               PENUP = .TRUE.
               DO 60 I = 1,NCHAN
                  X = X + DX
                  Y = (BUFFD(I) - RMIN) * YS(1) + Y0(1)
                  WASUP = PENUP
                  PENUP = (BUFFD(I).GT.RMAX) .OR. (BUFFD(I).LT.RMIN)
                  IF (.NOT.PENUP) THEN
                     IF (WASUP) THEN
                        CALL GPOS (X, Y, PBUFF, IRET)
                     ELSE
                        CALL GVEC (X, Y, PBUFF, IRET)
                        END IF
                     IF (IRET.NE.0) GO TO 999
                     END IF
 60               CONTINUE
C                                       plot model on Clean
               IF (NITER.GT.0) THEN
                  X = DX / 2.0 - DX
                  PENUP = .TRUE.
                  DO 65 I = 1,NCHAN
                     X = X + DX
                     Y = (BUFFD(I) - RMIN) * YS(2) + Y0(2)
                     WASUP = PENUP
                     PENUP = (BUFFD(I).GT.RMAX) .OR. (BUFFD(I).LT.RMIN)
                     IF (.NOT.PENUP) THEN
                        IF (WASUP) THEN
                           CALL GPOS (X, Y, PBUFF, IRET)
                        ELSE
                           CALL GVEC (X, Y, PBUFF, IRET)
                           END IF
                        IF (IRET.NE.0) GO TO 999
                        END IF
 65                  CONTINUE
                  END IF
C                                       plot difference spectrum
               X = DX / 2.0 + (BCHAN-2) * DX
               PENUP = .TRUE.
               DO 70 I = BCHAN,ECHAN
                  X = X + DX
                  Y = (BUFFP(I) - PMIN) * YS(3)
                  WASUP = PENUP
                  PENUP = (BUFFP(I).GT.PMAX) .OR. (BUFFP(I).LT.PMIN)
                  IF (.NOT.PENUP) THEN
                     IF (WASUP) THEN
                        CALL GPOS (X, Y, PBUFF, IRET)
                     ELSE
                        CALL GVEC (X, Y, PBUFF, IRET)
                        END IF
                     IF (IRET.NE.0) GO TO 999
                     END IF
 70               CONTINUE
C                                       plot result: EKH
               X = DX / 2.0 + (BCHAN-2) * DX
               PENUP = .TRUE.
               DO 75 I = BCHAN,ECHAN
                  X = X + DX
                  Y = (BUFFR(I) - RMIN) * YS(1) + Y0(1)
                  WASUP = PENUP
                  PENUP = (BUFFR(I).GT.RMAX) .OR. (BUFFR(I).LT.RMIN)
                  IF (.NOT.PENUP) THEN
                     IF (WASUP) THEN
                        CALL GPOS (X, Y, PBUFF, IRET)
                     ELSE
                        CALL GVEC (X, Y, PBUFF, IRET)
                        END IF
                     IF (IRET.NE.0) GO TO 999
                     END IF
 75               CONTINUE
C                                       plot result: Clean
               IF (NITER.GT.0) THEN
                  X = DX / 2.0 + (BCHAN-2) * DX
                  PENUP = .TRUE.
                  DO 80 I = BCHAN,ECHAN
                     X = X + DX
                     Y = (BUFFC(I) - RMIN) * YS(2) + Y0(2)
                     WASUP = PENUP
                     PENUP = (BUFFC(I).GT.RMAX) .OR. (BUFFC(I).LT.RMIN)
                     IF (.NOT.PENUP) THEN
                        IF (WASUP) THEN
                           CALL GPOS (X, Y, PBUFF, IRET)
                        ELSE
                           CALL GVEC (X, Y, PBUFF, IRET)
                           END IF
                        IF (IRET.NE.0) GO TO 999
                        END IF
 80                  CONTINUE
                  END IF
C                                       finish plot and continue?
               GPHPAG = (DOTV) .AND. (J.LT.10) .AND. (DPARM(J+1).NE.0.0)
               WRITE (MSGTXT,1070) IVER
               IF (.NOT.DOTV) CALL MSGWRT (2)
               CALL GFINIS (PBUFF, IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
            END IF
 100     CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BSTSDO: ERROR',I5,' DOING ',A)
 1050 FORMAT (I2,': THROWS',2F8.2,'  MAX,RMS',2(1PE13.4))
 1051 FORMAT ('CHAN, MODEL, RESULT',I5,2(0PF10.4),1PE13.4)
 1052 FORMAT ('Non-signal regions EKH ',I4,I5,' MAX,RMS',2F9.4)
 1053 FORMAT ('Non-signal regions Cln ',I4,I5,' MAX,RMS',2F9.4)
 1054 FORMAT ('Non-signal diff regions',I4,I5,' MAX,RMS',2F9.4)
 1055 FORMAT ('Throws',2F8.2,'__max',1PE13.4,'__rms',1PE13.4)
 1056 FORMAT ('Factor',F7.4,'__Ratio throw',F7.4,' Peak',F7.4,' Width',
     *   F7.4)
 1057 FORMAT (A,'_',F8.3)
 1070 FORMAT ('Successful plot file version',I5,'  created.')
      END
      SUBROUTINE NOISE (ANOISE)
C-----------------------------------------------------------------------
C   Random noise generator
C    Output: ANOISE  R    Result
C-----------------------------------------------------------------------
      REAL      ANOISE, TEMP
      INTEGER   J
C-----------------------------------------------------------------------
      ANOISE = -6.0
      DO 10 J = 1,12
         CALL RANDUM (TEMP)
         ANOISE = ANOISE + TEMP
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE BSTLAB (NCHAN, NITER, IVER, RMIN, RMAX, PMIN, PMAX,
     *   STRNG1, STRNG2, YS, Y0, XYR, PBUFF, IERR)
C-----------------------------------------------------------------------
C   Do the init for line drawing, ...
C   Inputs:
C      NCHAN   I      Number channels
C      NITER   I      Number Clean iterations (0 none)
C      IVER    I      File version number
C      RMIN    R      Min value to plot
C      RMAX    R      Max value to plot
C   Output:
C      IERR   I   Error code
C-----------------------------------------------------------------------
      REAL      RMIN, RMAX, PMIN, PMAX, YS(3), Y0(2), XYR
      INTEGER   NCHAN, NITER, IVER, PBUFF(*), IERR
      CHARACTER STRNG1*(*), STRNG2*(*)
C
      REAL      BLC(7), CH(4), TRC(7), X, XYRATO, DX, DY, DCX, DCY, YB,
     *   YINTER(9), YINT, PIXR(2), DU, DL, DEG
      INTEGER   IDEPTH(5), I, LTYPE, IIP, IIF, XINTER(10), XINT,
     *   XLO, XHI, ID(3), IT(3), ITRIM
      CHARACTER STRING*80, CTIME*8, CDATE*12
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA XINTER /2,5,10,20,50,100,200,500,1000,2000/
      DATA YINTER /0.1, 0.2, 0.5, 1., 2., 5., 10., 20., 50./
C-----------------------------------------------------------------------

C                                       number characters around
      CALL RFILL (4, 0.5, CH)
      LTYPE = 3
      PIXR(1) = RMIN
      PIXR(2) = RMAX
      CALL GTICNT (LTYPE, PIXR, I)
      IF (LTYPE.EQ.2) CH(1) = 2.5
      IF (LTYPE.GT.2) CH(1) = I + 4.0
      IF (LTYPE.GT.1) CH(2) = 2.0
      IF (LTYPE.GT.2) THEN
         CH(2) = CH(2) + 2 * 1.333
         IF (STRNG2.NE.' ') CH(2) = CH(2) + 1.333
         END IF
      IF (LTYPE.EQ.2) CH(3) = 2.5
      IF (LTYPE.GT.1) CH(4) = CH(4) + 1.5
      IF (LTYPE.GT.2) CH(4) = CH(4) + 1.333
      CH(4) = CH(4) + 1.333
C                                       Set BLC, TRC, XYRATO.
      CALL RFILL (5, 1.0, BLC(3))
      CALL RFILL (5, 1.0, TRC(3))
      CALL FILL (5, 1, IDEPTH)
      BLC(2) = 0.0
      BLC(1) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1500.0
      IF (NITER.LE.0) TRC(2) = 1000.0
      XYRATO = XYR
      IF ((XYRATO.LT.0.1) .OR. (XYRATO.GT.10.0)) XYRATO = 1.0
      YS(1) = 500.0 / (RMAX - RMIN)
      YS(2) = YS(1)
      YS(3) = 500.0 / (PMAX - PMIN)
      Y0(2) = 500.
      Y0(1) = 1000.
      IF (NITER.LE.0) Y0(1) = 500.
C                                       Initialize plot file line drw.
      CALL GINITL (BLC, TRC, XYRATO, CH, IDEPTH, PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GLTYPE (1, PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Draw borders.
      CALL GPOS (BLC(1), BLC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (TRC(1), BLC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (TRC(1), TRC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (BLC(1), TRC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (BLC(1), BLC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GPOS (BLC(1), Y0(1), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (TRC(1), Y0(1), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (NITER.GT.0) THEN
         CALL GPOS (BLC(1), Y0(2), PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (TRC(1), Y0(2), PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       draw zeros
      YB = -RMIN * YS(1) + Y0(1)
      IF (YB.GT.1.0) THEN
         CALL GPOS (BLC(1), YB, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (TRC(1), YB, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
      IF (NITER.GT.0) THEN
         YB = -RMIN * YS(2) + Y0(2)
         IF (YB.GT.1.0) THEN
            CALL GPOS (BLC(1), YB, PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GVEC (TRC(1), YB, PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         END IF
      YB = -PMIN * YS(3)
      IF (YB.GT.1.0) THEN
         CALL GPOS (BLC(1), YB, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (TRC(1), YB, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Horizontal ticks
      IIP = 9
      DO 10 I = 1,10
         IIF = NCHAN / XINTER(I)
         IF (IIF.LE.IIP) GO TO 15
 10      CONTINUE
      GO TO 25
C                                       horizontal tick drawing
 15   XINT = XINTER(I)
      XLO = (1 / XINT) * XINT
      IF (XLO.LT.1) XLO = XLO + XINT
      XHI = (NCHAN / XINT) * XINT
      DX = 1000.0 / (NCHAN+2)
      DY = 25.
      DCY = -1.5
      DO 20 I = XLO,XHI,XINT
         X = DX * (1.0 + I)
         WRITE (STRING,1015) I
         CALL CHTRIM (STRING, 4, STRING, IIF)
         DCX = -IIF + 0.5
         CALL GPOS (X, TRC(2), PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (X, TRC(2)-DY, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GPOS (X, Y0(1)+DY, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (X, Y0(1)-DY, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         IF (NITER.GT.0) THEN
            CALL GPOS (X, Y0(2)+DY, PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GVEC (X, Y0(2)-DY, PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         CALL GPOS (X, DY, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (X, 0.0, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GCHAR (IIF, 0, DCX, DCY, STRING(:IIF), PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
 20      CONTINUE
C                                       Vertical ticks
 25   IIP = 7
      DO 30 I = 1,9
         DEG = YINTER(I)
         DU = AINT (RMAX/DEG) * DEG
         IF (DU.GT.RMAX) DU = DU - DEG
         DL = AINT (RMIN/DEG) * DEG
         IF (DL.LT.RMIN) DL = DL + DEG
         IIF = (DU - DL) / DEG + 1.001
         IF (IIF.LE.IIP) GO TO 35
 30      CONTINUE
      GO TO 45
C                                       vertical tick drawing
 35   YINT = YINTER(I)
      XLO = RMIN / YINT
      IF (XLO*YINT.LT.RMIN) XLO = XLO + 1
      XHI = RMAX / YINT
      DX = 25.
      DCY = -0.5
      YB = 0.
      DO 40 I = XLO,XHI
         X = I * YINT
         WRITE (STRING,1035) X
         IF (YINT.GT.0.9) STRING(5:6) = ' '
         CALL CHTRIM (STRING, 6, STRING, IIF)
         DCX = -IIF - 1.0
         YB = MIN (YB, DCX)
         X = (X - RMIN) * YS(1) + Y0(1)
         CALL GPOS (1000.0, X, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (1000.0-DX, X, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GPOS (DX, X, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (0.0, X, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GCHAR (IIF, 0, DCX, DCY, STRING(:IIF), PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         IF (NITER.GT.0) THEN
            X = I * YINT
            X = (X - RMIN) * YS(2) + Y0(2)
            CALL GPOS (1000.0, X, PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GVEC (1000.0-DX, X, PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GPOS (DX, X, PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GVEC (0.0, X, PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GCHAR (IIF, 0, DCX, DCY, STRING(:IIF), PBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 40      CONTINUE
C                                       lower plot
 45   IIP = 7
      DO 50 I = 1,9
         IIF = (PMAX - PMIN) / YINTER(I)
         IF (IIF.LE.IIP) GO TO 55
 50      CONTINUE
      GO TO 70
C                                       vertical tick drawing
 55   YINT = YINTER(I)
      XLO = PMIN / YINT
      IF (XLO*YINT.LT.PMIN) XLO = XLO + 1
      XHI = PMAX / YINT
      DX = 25.
      DCY = -0.5
      DO 60 I = XLO,XHI
         X = I * YINT
         WRITE (STRING,1035) X
         IF (YINT.GT.0.9) STRING(5:6) = ' '
         CALL CHTRIM (STRING, 6, STRING, IIF)
         DCX = -IIF - 1.0
         YB = MIN (YB, DCX)
         X = (X - PMIN) * YS(3)
         CALL GPOS (1000.0, X, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (1000.0-DX, X, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GPOS (DX, X, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (0.0, X, PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GCHAR (IIF, 0, DCX, DCY, STRING(:IIF), PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
 60      CONTINUE
C                                       horizontal axis label
 70   DCY = -1.5 - 1.333
      CALL GPOS (500., 0., PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      DCX = -8.5
      CALL GCHAR (17, 0, DCX, DCY, 'Spectral channels', PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       extra text
      DCY = DCY - 1.333
      CALL GPOS (500., 0., PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      I = ITRIM (STRNG1)
      DCX = -I / 2.0
      CALL GCHAR (I, 0, DCX, DCY, STRNG1(:I), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (STRNG2.NE.' ') THEN
         DCY = DCY - 1.333
         CALL GPOS (500., 0., PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         I = ITRIM (STRNG2)
         DCX = -I / 2.0
         CALL GCHAR (I, 0, DCX, DCY, STRNG2(:I), PBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       vertical axis label
      CALL GPOS (0.0, TRC(2)/2.0, PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      DCX = YB - 2.0
      CALL GCHAR (10, 1, DCX, 4.0, 'Brightness', PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       more labels
      CALL GPOS (BLC(1), TRC(2), PBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, CTIME, CDATE)
      WRITE (STRING,1130) IVER, CDATE, CTIME
      CALL REFRMT (STRING, '_', IIF)
      DCY = 0.6
      DCX = 0.0
      CALL GCHAR (IIF, 0, DCX, DCY, STRING, PBUFF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1015 FORMAT (I4)
 1035 FORMAT (F6.1)
 1130 FORMAT ('Plot file version',I4,'__created ',A,A)
      END
      SUBROUTINE BSCLEN (NCH, THROWP, THROWM, NITER, GAIN, BUFFW, BUFFC)
C-----------------------------------------------------------------------
C   Does a Clean on the 1-D switched spectrum
C   Inputs:
C      NCH      I      Number channels
C      THROWP   R      Plus spectrum throw (channels)
C      THROWM   R      Minus spectrum throw (channels)
C      NITER    I      Number Clean iterations
C      GAIN     R      Clean loop gain
C   In/out:
C      BUFFW    R(*)   Difference spectrum: in = full, out = residual
C   Output
C      BUFFC    R(*)   Cleaned spectrum
C-----------------------------------------------------------------------
      INTEGER   NCH, NITER
      REAL      THROWP, THROWM, GAIN, BUFFW(*), BUFFC(*)
C
      INTEGER   N, I, I1, I2, IP, IM, IROUND, IX, IN
      REAL      T, TX, TN, TH
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL RFILL (NCH, 0.0, BUFFC)
      IF (NITER.LE.0) GO TO 999
      IP = IROUND (THROWP)
      IM = IROUND (THROWM)
      IF (IP.LT.0) THEN
         I1 = 1 + IM
         I2 = NCH + IP
      ELSE
         I1 = 1 + IP
         I2 = NCH + IM
         END IF
      DO 50 N = 1,NITER
         TX = 0.0
         TN = 0.0
         DO 20 I = I1,I2
            T = BUFFW(I-IP) - BUFFW(I-IM)
            IF (T.GT.TX) THEN
               TX = T
               IX = I
               END IF
            IF (T.LT.TN) THEN
               TN = T
               IN = I
               END IF
 20         CONTINUE
          IF (-TN.GT.TX) THEN
            TX = TN
            IX = IN
            END IF
         TX = GAIN * TX * 0.5
         BUFFC(IX) = BUFFC(IX) + TX
         BUFFW(IX-IP) = BUFFW(IX-IP) - TX
         BUFFW(IX-IM) = BUFFW(IX-IM) + TX
 50      CONTINUE
C                                       max resid
         TH = 0.0
         DO 60 I = 1,NCH
            IF (ABS(BUFFW(I)).GT.TH) TH = ABS (BUFFW(I))
            BUFFC(I) = BUFFC(I) + BUFFW(I)
 60         CONTINUE
         WRITE (MSGTXT,1060) TH
         CALL MSGWRT (3)
C
 999  RETURN
C-----------------------------------------------------------------------
 1060 FORMAT ('BSCLEN: peak residual',1PE12.5)
      END

      SUBROUTINE FILOPN (LUN, NAMS, ASSOC, TYPE, VER, ERROR)
C-----------------------------------------------------------------------
C! open image, associated, or scratch file (WaWa system)
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   WaWa IO system: Open the file specified by NAMS and associate
C   it with Logical Unit number LUN.
C   Inputs:
C      LUN       I     Logical Unit Number
C      ASSOC     L     File is an associated file,i.e. not catalogd
C                      ASSOC will be taken as FALSE if NAMS(8)='SCxx'
C      TYPE      C*2   Associated file type; ignored if ASSOC is false
C      VER       I     Associated file version; ignored if ASSOC is fal
C   In/Out:
C      NAMS      C*36  NAMESTRING specifying catalog block to which
C                      file is associated: NAME,CLASS,CATTYPE,SEQ,VOL,
C                      USID.  NAME,CLASS,USID ignored for scratch files.
C   Outputs:
C      ERROR     I     Error code:  0 => o.k.
C                           2 => input error: bad or in use LUN
C                          10 => catalog error
C                          12 => map not found
C                          13 => extension file not in catalog
C                          14 => no room in FILTAB
C                          22 => volume not available
C                          26 => open error
C   Written by WaWa (4/21/81)
C-----------------------------------------------------------------------
      CHARACTER NAMS*36, TYPE*2
      INTEGER   LUN, VER, ERROR
      LOGICAL   ASSOC
C
      CHARACTER DNAMS*36, STAT*4, PNAM*48, DTYPE*2, DNAME*12, DCLASS*6,
     *   DPTYPE*2
      INTEGER   DVER, IVER, SEQ, USID, BFIL, DFIL, I, J, BADLUN, DVOL,
     *   NOROOM, NOFIND, EFIND, CATER, OPNER, WARN, EXTER, IERR, IFIL
      LOGICAL   MAIN, NDISK, MAP, LSCR, F, T
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA EFIND, OPNER, BADLUN, NOROOM, CATER, EXTER, WARN, NOFIND
     *   /12, 26, 2, 14, 10, 13, 6, 5/
      DATA F, T /.FALSE.,.TRUE./
C-----------------------------------------------------------------------
C                                       Check if LUN in range
      ERROR = BADLUN
      IF ((LUN.LT.8) .OR. (LUN.GT.30)) GO TO 999
C                                       Get device type
      NDISK = DEVTAB(LUN).NE.0
C                                       Map or "file" i/o
      MAP = (LUN.GE.16) .AND. (LUN.LE.25)
      MAIN = .NOT.ASSOC
C                                       Search LUN table
      BFIL = 1
      DFIL = 5
      IF (.NOT.MAP) GO TO 20
         BFIL = 6
         DFIL = EFIL
C                                       Is LUN in use?
 20   DO 25 IFIL = BFIL,DFIL
         IF (FILTAB(POLUN,IFIL).EQ.LUN) GO TO 999
 25      CONTINUE
C                                       Is there room in table
      DO 30 IFIL = BFIL,DFIL
         IF (FILTAB(POLUN,IFIL).EQ.0) GO TO 40
 30      CONTINUE
      ERROR = NOROOM
      GO TO 999
C                                       Fill in some values
 40   FILTAB(POLUN,IFIL) = LUN
      FILTAB(POCAT,IFIL) = 1
      FILTAB(POIOP,IFIL) = 3
      FILTAB(POASS,IFIL) = 1
      IF (MAIN) FILTAB(POASS,IFIL) = 0
C                                       Disks: find in catalog
      IF (NDISK) GO TO 300
C                                       Copy NAMS into temporary area
         CALL PRENAM (NAMS, DNAMS, LSCR)
         IF (.NOT.LSCR) GO TO 100
            MAIN = T
            FILTAB(POASS,IFIL) = 0
C                                       Make Namestr intelligble
 100     CALL WAWA2A (DNAMS, DNAME, DCLASS, SEQ, DPTYPE, DVOL, USID)
C                                       find file in catalog
         CALL CATDIR ('SRCH', DVOL, FILTAB(POCAT,IFIL), DNAME, DCLASS,
     *      SEQ, DPTYPE, USID, STAT, WBUFF, IERR)
         CALL A2WAWA (DNAME, DCLASS, SEQ, DPTYPE, DVOL, USID, DNAMS)
         FILTAB(POVOL,IFIL) = DVOL
         IF (IERR.EQ.0) GO TO 120
            IF (IERR.EQ.NOFIND) GO TO 110
               ERROR = CATER
               WRITE (MSGTXT,1100) DVOL, IERR
               GO TO 980
 110        CONTINUE
               ERROR = EFIND
               WRITE (MSGTXT,1110) DVOL
               GO TO 980
C                                       Get Catalog block
 120     CALL CATIO ('READ', DVOL, FILTAB(POCAT,IFIL), CATBLK, 'REST',
     *      WBUFF, IERR)
         IF ((IERR.EQ.0) .OR. (IERR.EQ.WARN)) GO TO 140
            ERROR = CATER
            WRITE (MSGTXT,1100) DVOL, IERR
            GO TO 980
C                                       Check file type
 140     DVER = 1
         IVER = VER
         DTYPE = DPTYPE
C                                       Find extension file
         IF (MAIN) GO TO 200
            ERROR = EFIND
            CALL FNDEXT (TYPE, CATBLK, I)
            IF ((I.LE.0) .OR. (IVER.GT.I)) THEN
               WRITE (MSGTXT,1170) DVOL, TYPE, IVER
               ERROR = EXTER
               GO TO 980
               END IF
 180       DVER = IVER
           IF (IVER.LE.0) DVER = I
C                                       for maps set full window
 200  NAMS = DNAMS
      IF (.NOT.MAP) GO TO 300
         FILTAB(POBPX,IFIL) = 2
         FILTAB(PODIM,IFIL) = CATBLK(KIDIM)
         DO 210 I = 1,7
            J = I - 1
            FILTAB(PONAX+J,IFIL) = CATBLK(KINAX+J)
            FILTAB(POBLC+J,IFIL) = 1
            FILTAB(POTRC+J,IFIL) = CATBLK(KINAX+J)
            IF (I.GT.CATBLK(KIDIM)) FILTAB(POTRC+J,IFIL) = 1
            FILTAB(PODEP+J,IFIL) = 1
 210        CONTINUE
         FILTAB(POBL,IFIL) = 1
         FILTAB(POBL+1,IFIL) = 0
         FILTAB(PODEP+6,IFIL) = 0
C                                       Generate file name & open file
 300  CALL ZPHFIL (DTYPE, FILTAB(POVOL,IFIL), FILTAB(POCAT,IFIL),
     *   DVER, PNAM, IERR)
      CALL ZOPEN (LUN, FILTAB(POFIN,IFIL), FILTAB(POVOL,IFIL), PNAM,
     *   MAP, F, T, IERR)
      ERROR = 0
      IF (IERR.EQ.0) GO TO 999
         ERROR = OPNER
         IF (IERR.LE.3) ERROR = 10 * IERR - 8
         IF (IERR.EQ.5) ERROR = NOROOM
         WRITE (MSGTXT,1300) IERR, FILTAB(POVOL,IFIL), DTYPE, DVER
C                                       Errors
 980  FILTAB (POLUN,IFIL) = 0
      CALL MSGWRT (8)
      CALL PRTNAM (DNAMS, 8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('FILOPN: CATALOG I/O ERROR ON VOL',I6,' ERROR',I6)
 1110 FORMAT ('FILOPN: CATBLOCK NOT FOUND ON VOL ',I2)
 1120 FORMAT ('FILOPN: BAD STATUS CAN''T OPEN FOR WRITE ON VOL ',I2)
 1170 FORMAT ('FILOPN: CAN''T FIND EXT FILE ON VOL ',I2,' EXTYP ',A2,
     *   ' VER ',I4)
 1300 FORMAT ('FILOPN: OPEN ERROR',I6,' ON VOL ',I2,' EXTYP ',A2,
     *   ' VER ',I4)
      END

LOCAL INCLUDE 'XG2XG.INC'
      HOLLERITH XINAM1(3), XINCL1(2), XINEXT(1)
      REAL      XINSEQ, XINDSK, XINVER, XNGAUS
      COMMON /INPARM/ XINAM1, XINCL1, XINSEQ, XINDSK, XINVER, XNGAUS,
     *   XINEXT
      INTEGER   INSEQ, INDISK, INCNO, INVER, NGAUSS, OUVER, MGAUSS,
     *   SCRTCH(256)
      CHARACTER INAME*12, INCLS*6, INEXT*2
      COMMON /XGPRMS/ SCRTCH, INSEQ, INDISK, INCNO, INVER, NGAUSS,
     *   MGAUSS, OUVER
      COMMON /CHPRMS/ INAME, INCLS, INEXT
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
LOCAL END
LOCAL INCLUDE 'XGTABLE.INC'
      INTEGER   MAXGAU, MAXP
      PARAMETER (MAXGAU=32)
      PARAMETER (MAXP=2+3*MAXGAU)
C
      INTEGER   XGBUFI(512), XGBUFO(512), XGKOLS(12), XGNUMV(12),
     *   XGKOLO(12), XGNUMO(12)
      REAL      RESULI(2*MAXP), RESULO(2*MAXP)
      COMMON /XGTABP/ XGBUFI, XGBUFO, XGKOLS, XGNUMV, XGKOLO, XGNUMO,
     *   RESULI, RESULO
LOCAL END
      PROGRAM XG2XG
C-----------------------------------------------------------------------
C! Task to copy one XG table to a new one with changed NGAUSS
C# Plot-util EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   XG2XG copy data to new VG file
C   Inputs:   (from AIPS)
C      INNAME     H(3)   name of primary file.Ipol
C      INCLASS    H(2)   class of primary file.Ipol
C      INSEQ      R      sequence number of primary file. Ipol
C      INDISK     R      disk volume number. 0 means try all.Ipol
C      INVERS     R      version number of XG file, 0 means latest
C      NGAUSS     R      Number Gaussians in output file
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGNAM*6
      INCLUDE 'XG2XG.INC'
      INCLUDE 'XGTABLE.INC'
      DATA PRGNAM /'XG2XG'/
C-----------------------------------------------------------------------
C                                       Init
      CALL XG2XGI (PRGNAM, IRET)
C                                       Do the copy
      IF (IRET.EQ.0) THEN
         IF (INEXT.EQ.'ZE') THEN
            CALL XG2XGZ (IRET)
         ELSE
            CALL XG2XGX (IRET)
            END IF
         END IF
C                                       history
      IF (IRET.EQ.0) CALL XG2XGH
C
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE XG2XGI (PRGNAM, IRET)
C-----------------------------------------------------------------------
C   Inits this task
C   Input:
C      PRGNAM   C*6   Task name
C   Outputs:
C      IRET     I     Error code: 0 okay
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*(*)
      INTEGER   IRET
C
      INTEGER   I, IROUND, NPARMS
      CHARACTER MTYPE*2, STAT*4
      INCLUDE 'XG2XG.INC'
      INCLUDE 'XGTABLE.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NSCR = 0
      NCFILE = 0
C                                       Get input values from AIPS.
      NPARMS = 10
      CALL GTPARM (PRGNAM, NPARMS, RQUICK, XINAM1, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (8)
         END IF
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, I)
      IF (IRET.NE.0) GO TO 999
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XINAM1, INAME)
      CALL H2CHR (6, 1, XINCL1, INCLS)
      CALL H2CHR (2, 1, XINEXT, INEXT)
      INSEQ = IROUND (XINSEQ)
      INDISK = IROUND (XINDSK)
      INVER = IROUND (XINVER)
      NGAUSS = XNGAUS
C                                       IPOL
      INCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', INDISK, INCNO, INAME, INCLS, INSEQ,
     *   MTYPE, NLUSER, STAT, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET, INAME, INCLS, INSEQ, INDISK,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      STAT = 'WRIT'
      CALL CATIO ('READ', INDiSK, INCNO, CATBLK, STAT, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING IPOL HEADER'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = INDiSK
      FCNO(NCFILE) = INCNO
      FRW(NCFILE) = 1
C                                       Find table version
      IF (INEXT.NE.'ZE') INEXT = 'XG'
      CALL FNDEXT (INEXT, CATBLK, I)
      IF ((INVER.LE.0) .OR. (INVER.GT.I)) INVER = I
      OUVER = I + 1
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XG2XGI ERROR',I4,' ON ',A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I2,' USID=',I5)
      END
      SUBROUTINE XG2XGX (IRET)
C-----------------------------------------------------------------------
C   Copies XG to new XG
C   Outputs
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'XG2XG.INC'
      INCLUDE 'XGTABLE.INC'
      INTEGER   IROW, NVI, NVO, LUNI, LUNTMP, LUNO, IXGRNO, IYINC, CMAX,
     *   IZINC, IBLC(2), ITRC(2), ABSORB, NC, NROW, YZPIX(2), NGA, I, K,
     *   PDONE, NP
      REAL      VCLIP, REFINC, REFPIX, VPEAK, XGRMS
      LOGICAL   CHECK
      DOUBLE PRECISION REFVAL, VOFF
      CHARACTER REFTYP*8
C-----------------------------------------------------------------------
      LUNI = LUNTMP (1)
      CALL XGINI ('READ', XGBUFI, INDISK, INCNO, INVER, CATBLK, LUNI,
     *   IXGRNO, XGKOLS, XGNUMV, MGAUSS, IBLC, ITRC, IYINC, IZINC,
     *   VCLIP, VOFF, PDONE, REFVAL, REFPIX, REFINC, REFTYP, ABSORB,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING REQUESTED XG TABLE'
         GO TO 990
         END IF
      LUNO = LUNTMP (1)
      NGAUSS = MAX (1, MIN (MAXGAU, NGAUSS))
      CALL XGINI ('WRIT', XGBUFO, INDISK, INCNO, OUVER, CATBLK, LUNO,
     *   IXGRNO, XGKOLO, XGNUMO, NGAUSS, IBLC, ITRC, IYINC, IZINC,
     *   VCLIP, VOFF, PDONE, REFVAL, REFPIX, REFINC, REFTYP, ABSORB,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT XG TABLE'
         GO TO 990
         END IF
      WRITE (MSGTXT,1010) INVER, MGAUSS
      CALL MSGWRT (2)
      WRITE (MSGTXT,1011) OUVER, NGAUSS
      CALL MSGWRT (2)
      CHECK = NGAUSS.LT.MGAUSS
      NP = 0
      NVI = 2 + 3*MGAUSS + 1
      NVO = 2 + 3*NGAUSS + 1
      NC = MIN (NVI, NVO) - 1
      NROW = XGBUFI(5)
      CALL FILL (2*MAXP, FBLANK, RESULO)
      DO 100 IROW = 1,NROW
         IXGRNO = IROW
         CALL TABXG ('READ', XGBUFI, IXGRNO, XGKOLS, XGNUMV, YZPIX, NGA,
     *      VPEAK, XGRMS, RESULI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT XG TABLE'
            GO TO 990
            END IF
         IF (CHECK) THEN
            CMAX = 0
            K = 2 + 3*MGAUSS
            DO 50 I = 1,K
               IF ((RESULI(I).NE.0.0) .AND. (RESULI(I).NE.FBLANK))
     *            CMAX = I
               IF ((RESULI(I+K).NE.0.0) .AND. (RESULI(I+K).NE.FBLANK))
     *            CMAX = I
 50         CONTINUE
            CMAX = CMAX / 3
            IF (CMAX.GT.NGAUSS) THEN
               WRITE (MSGTXT,1050) YZPIX, CMAX-NGAUSS
               IF (NP.LT.30) CALL MSGWRT (6)
               NP = NP + 1
               END IF
            END IF
C                                       copy fit results
         CALL RCOPY (NC, RESULI(1), RESULO(1))
C                                       copy errors
         CALL RCOPY (NC, RESULI(NVI), RESULO(NVO))
C                                       write output
         IXGRNO = IROW
         CALL TABXG ('WRIT', XGBUFO, IXGRNO, XGKOLO, XGNUMO, YZPIX, NGA,
     *      VPEAK, XGRMS, RESULO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT XG TABLE'
            GO TO 990
            END IF
 100     CONTINUE
C                                       close down
      CALL TABXG ('CLOS', XGBUFO, IXGRNO, XGKOLO, XGNUMO, YZPIX, NGA,
     *   VPEAK, XGRMS, RESULO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OUTPUT XG TABLE'
         GO TO 990
         END IF
      CALL TABXG ('CLOS', XGBUFI, IXGRNO, XGKOLS, XGNUMV, YZPIX, NGA,
     *   VPEAK, XGRMS, RESULI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING INPUT XG TABLE'
         GO TO 990
         END IF
      IF (NP.GT.30) THEN
         WRITE (MSGTXT,1100) NP-30
         CALL MSGWRT (6)
         END IF
      GO TO 999
C
 990  CALL MSGWRT(8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XG2XGX ERROR',I4,' ON ',A)
 1010 FORMAT ('Reading XG table version',I4,' with',I3,' Gaussians')
 1011 FORMAT ('Writing XG table version',I4,' with',I3,' Gaussians')
 1050 FORMAT ('Image pixel',2I6,' loses',I3,' components')
 1100 FORMAT ('And',I7,' more messages about loss')
      END
      SUBROUTINE XG2XGZ (IRET)
C-----------------------------------------------------------------------
C   Copies ZE to new ZE
C   Outputs
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'XG2XG.INC'
      INCLUDE 'XGTABLE.INC'
      INTEGER   IROW, NVI, NVO, LUNI, LUNTMP, LUNO, IXGRNO, IBLC(2), I,
     *   ITRC(2), ABSORB, NC, NROW, YZPIX(2), NGA, PDONE, NGI, NGO, NG,
     *   CMAX, K, NP
      REAL      VCLIP, REFINC, REFPIX, VPEAK, XGRMS, XGAUSI(3*MAXGAU),
     *   XGAUSO(3*MAXGAU), XGAUSB(2)
      DOUBLE PRECISION REFVAL
      CHARACTER REFTYP*8
      LOGICAL   CHECK
C-----------------------------------------------------------------------
      LUNI = LUNTMP (1)
      CALL ZEINI ('READ', XGBUFI, INDISK, INCNO, INVER, CATBLK, LUNI,
     *   IXGRNO, XGKOLS, XGNUMV, IBLC, ITRC, MGAUSS, VCLIP, PDONE,
     *   REFVAL, REFPIX, REFINC, REFTYP, ABSORB, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING REQUESTED ZE TABLE'
         GO TO 990
         END IF
      LUNO = LUNTMP (1)
      NGAUSS = MAX (1, MIN (MAXGAU, NGAUSS))
      CALL ZEINI ('WRIT', XGBUFO, INDISK, INCNO, OUVER, CATBLK, LUNO,
     *   IXGRNO, XGKOLO, XGNUMO, IBLC, ITRC, NGAUSS, VCLIP, PDONE,
     *   REFVAL, REFPIX, REFINC, REFTYP, ABSORB, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT XG TABLE'
         GO TO 990
         END IF
      WRITE (MSGTXT,1010) INVER, MGAUSS
      CALL MSGWRT (2)
      WRITE (MSGTXT,1011) OUVER, NGAUSS
      CALL MSGWRT (2)
      CHECK = NGAUSS.LT.MGAUSS
      NP = 0
      NVI = 1 + MGAUSS + 1
      NVO = 1 + NGAUSS + 1
      NC = MIN (NVI, NVO) - 1
      NGI = 3 * MGAUSS
      NGO = 3 * NGAUSS
      NG = MIN (NGO, NGI)
      NROW = XGBUFI(5)
      CALL FILL (2*MAXP, FBLANK, RESULO)
      CALL FILL (3*MAXGAU, FBLANK, XGAUSO)
      DO 100 IROW = 1,NROW
         IXGRNO = IROW
         CALL TABZE ('READ', XGBUFI, IXGRNO, XGKOLS, XGNUMV, YZPIX,
     *      VPEAK, XGRMS, RESULI, NGA, XGAUSI, XGAUSB, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT ZE TABLE'
            GO TO 990
            END IF
         IF (CHECK) THEN
            CMAX = 0
            K = 1 + MGAUSS
            DO 50 I = 1,K
               IF ((RESULI(I).NE.0.0) .AND. (RESULI(I).NE.FBLANK))
     *            CMAX = I
               IF ((RESULI(I+K).NE.0.0) .AND. (RESULI(I+K).NE.FBLANK))
     *            CMAX = I
 50            CONTINUE
            CMAX = CMAX - 1
            IF (CMAX.GT.NGAUSS) THEN
               WRITE (MSGTXT,1050) YZPIX, CMAX-NGAUSS
               IF (NP.LT.30) CALL MSGWRT (6)
               NP = NP + 1
               END IF
            END IF
C                                       copy fit results
         CALL RCOPY (NC, RESULI(1), RESULO(1))
C                                       copy errors
         CALL RCOPY (NC, RESULI(NVI), RESULO(NVO))
C                                       copy Gaussian model
         CALL RCOPY (NG, XGAUSI, XGAUSO)
C                                       write output
         IXGRNO = IROW
         CALL TABZE ('WRIT', XGBUFO, IXGRNO, XGKOLO, XGNUMO, YZPIX,
     *      VPEAK, XGRMS, RESULO, NGA, XGAUSO, XGAUSB, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT ZE TABLE'
            GO TO 990
            END IF
 100     CONTINUE
C                                       close down
      CALL TABZE ('CLOS', XGBUFO, IXGRNO, XGKOLO, XGNUMO, YZPIX,
     *   VPEAK, XGRMS, RESULO, NGA, XGAUSO, XGAUSB, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OUTPUT ZE TABLE'
         GO TO 990
         END IF
      CALL TABZE ('CLOS', XGBUFI, IXGRNO, XGKOLS, XGNUMV, YZPIX,
     *   VPEAK, XGRMS, RESULI, NGA, XGAUSI, XGAUSB, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING INPUT ZE TABLE'
         GO TO 990
         END IF
      IF (NP.GT.30) THEN
         WRITE (MSGTXT,1100) NP-30
         CALL MSGWRT (6)
         END IF
      GO TO 999
C
 990  CALL MSGWRT(8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XG2XGZ ERROR',I4,' ON ',A)
 1010 FORMAT ('Reading ZE table version',I4,' with',I3,' Gaussians')
 1011 FORMAT ('Writing ZE table version',I4,' with',I3,' Gaussians')
 1050 FORMAT ('Image pixel',2I6,' loses',I3,' components')
 1100 FORMAT ('And',I7,' more messages about loss')
      END
      SUBROUTINE XG2XGH
C-----------------------------------------------------------------------
C   Adds a few lines to the history
C-----------------------------------------------------------------------
C
      INCLUDE 'XG2XG.INC'
      INTEGER   HLUN, DATE(3), TIME(3), IERR
      CHARACTER HILINE*72, TTIME(2)*12
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      DATA HLUN /28/
C-----------------------------------------------------------------------
      CALL HIINIT (3)
      CALL HIOPEN (HLUN, INDISK, INCNO, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 100
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, TTIME(2), TTIME)
      WRITE (HILINE,1000) TSKNAM, RLSNAM, TTIME
      CALL HIADD (HLUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1010) TSKNAM, INVER, INEXT
      CALL HIADD (HLUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1011) TSKNAM, MGAUSS, INEXT
      CALL HIADD (HLUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1012) TSKNAM, OUVER, INEXT
      CALL HIADD (HLUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1013) TSKNAM, NGAUSS, INEXT
      CALL HIADD (HLUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1014) TSKNAM, INEXT, INEXT
      CALL HIADD (HLUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 100
C
 100  IF (IERR.NE.0) THEN
         MSGTXT = 'ERROR WRITING NISTORY FILE'
         CALL MSGWRT (6)
         END IF
      CALL HICLOS (HLUN, .TRUE., SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,'''   /****** Start ',
     *   A12,2X,A8)
 1010 FORMAT (A6,'INVERS  =',I5,'   / input ',A,' table version')
 1011 FORMAT (A6,'INGAUSS =',I5,'   / input ',A,' table # Gaussians')
 1012 FORMAT (A6,'OUTVERS =',I5,'   / output ',A,' table version')
 1013 FORMAT (A6,'NGAUSS  =',I5,'   / output ',A,' table # Gaussians')
 1014 FORMAT (A6,'INEXT   =''',A,'''    / output ',A,
     *   ' table # Gaussians')
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCLN.INC'
      INTEGER   NPARMS
      PARAMETER (NPARMS=11)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                      1        2         3          4
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           5          6           7          8         9       10
     *   'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK', 'SORT', 'ROTATE',
C           11
     *   'BADDISK'/
C                    1       2       3       4
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT,
C          5       6       7       8        9       10     11
     *   OOACAR, OOACAR, OOAINT, OOAINT,  OOACAR, OOARE, OOAINT/
C                   1     2     3     4
      DATA AVDIM /12,1,  6,1,  1,1,  1,1,
C          5     6     7     8     9     10     11
     *   12,1,  6,1,  1,1,  1,1,  2,1,  1,1,  10,1/
LOCAL END
      PROGRAM OOSRT
C-----------------------------------------------------------------------
C! Sort a UV data set with rotation
C# Task AP UV OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 2000, 2007, 2015, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, UVSORT*32, UVDATA*32
      INTEGER  IRET, BUFF1(256)
      DOUBLE PRECISION APCORE(2)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'OOSRT'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL OSRTIN (PRGM, UVDATA, UVSORT, IRET)
C                                       Sort them
      IF (IRET.EQ.0) CALL OUVSRT (APCORE, UVDATA, UVSORT, IRET)
C                                       History
      IF (IRET.EQ.0) CALL OSRTHI (UVDATA, UVSORT)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE OSRTIN (PRGN, UVDATA, UVSORT, IRET)
C-----------------------------------------------------------------------
C   OSRTIN gets input parameters for OOSRT and creates the UVSORT
C   object.
C   Inputs:
C      PRGN     C*6    Program name
C   Output:
C      UVDATA   C*32   Name of input uv data.
C      UVSORT   C*32   Nme of output sorted UV object
C      IRET     I      Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6, UVSORT*(*), UVDATA*(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NKEY1, NKEY2
C                                       NKEY1=no. adverbs to copy to
C                                       UVDATA object
      PARAMETER (NKEY1=10)
C                                       NKEY2 = no. adverb for UVSORT
      PARAMETER (NKEY2=4)
      INCLUDE 'INPUT.INC'
      INTEGER   DIM(7), TYPE, IDUM(5)
      LOGICAL   DOCOMP, LDUM(5)
      EQUIVALENCE (IDUM, LDUM)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32, SORT*2, CDUMMY*1, TINAME*12, TONAME*12
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs for UVDATA object
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'ROTATE',
     *   'SORT', 'OUTNAME', 'OUTCLASS', 'OUTDISK', 'OUTSEQ'/
C                                       Rename
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'ROTATE', 'SORT',
     *   'OUTNAME', 'OUTCLASS', 'OUTDISK', 'OUTSEQ'/
C                                       Adverbs for UVSORT object
C                    1          2          3         4
      DATA INK2 /'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK'/
C                                       Rename
C                    1       2       3         4
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK'/
C-----------------------------------------------------------------------
C                                       Startup - as interactive
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) THEN
         RQUICK = .FALSE.
         GO TO 999
         END IF
C                                       Default sort = 'XY'
      CALL OGET ('Input', 'SORT', TYPE, DIM, IDUM, SORT, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (SORT.EQ.' ') THEN
         SORT = 'XY'
         CALL OPUT ('Input', 'SORT', TYPE, DIM, IDUM, SORT, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       BADDISK
      CALL OGET ('Input', 'BADDISK', TYPE, DIM, IBAD, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Default output Name = input
      CALL OGET ('Input', 'INNAME', TYPE, DIM, IDUM, TINAME, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'OUTNAME', TYPE, DIM, IDUM, TONAME, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (TONAME.EQ.' ') THEN
         TONAME = TINAME
         CALL OPUT ('Input', 'OUTNAME', TYPE, DIM, IDUM, TONAME, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Create UVDATA object
      UVDATA = 'Input UVdata to be sorted'
      CALL CREATE (UVDATA, 'UVDATA', IRET)
      IF (IRET.NE.0) GO TO 999
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, UVDATA, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Open UVDATA to be sure OK.
      CALL OOPEN (UVDATA, 'READ', IRET)
      IF (IRET.NE.0) GO TO 999
      CALL UVDGET (UVDATA, 'ISCOMP', TYPE, DIM, IDUM, CDUMMY, IRET)
      DOCOMP = LDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OUVPUT (UVDATA, 'DOUVCOMP', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OCLOSE (UVDATA, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create output objects
      UVSORT = 'Output sorted UVdata'
      CALL CREATE (UVSORT, 'UVDATA', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, UVSORT, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Make output object
      CALL OUVCLN (UVDATA, UVSORT, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OUVOPN (UVSORT, 'WRIT', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy UVDESC
      CALL UVDSCP (UVDATA, UVSORT, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OCLOSE (UVSORT, IRET)
      IF (IRET.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE OSRTHI (UVDATA, UVSORT)
C-----------------------------------------------------------------------
C   Routine to write history file to output UVSORT image object.
C   Inputs:
C      UVDATA   C*?  Input UV data object name
C      UVSORT   C*?  Sorted UV data object name
C-----------------------------------------------------------------------
      CHARACTER UVSORT*(*), UVDATA*32
C
      INTEGER   NADV
      PARAMETER (NADV=8)
      CHARACTER LIST(NADV)*8, NOTYPE(3)*2
      INTEGER   IERR, DIM(7), DUMMY(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'OUTNAME', 'OUTCLASS',
     *   'OUTSEQ', 'SORT', 'ROTATE'/
      DATA NOTYPE /'AN', 'FQ', 'SU'/
C-----------------------------------------------------------------------
C                                       Copy old history
      CALL OHCOPY (UVDATA, UVSORT, IERR)
C                                       Copy base adverb values.
      IF (IERR.EQ.0) CALL OHLIST ('Input', LIST, NADV, UVSORT, IERR)
C                                       Error
      IF (IERR.NE.0) THEN
         MSGTXT = 'ERROR WRITING HISTORY FOR ' // UVSORT
         CALL MSGWRT (6)
         END IF
C                                       copy all other tables
      DIM(1) = 2
      DIM(2) = 3
      DIM(3) = 1
      DIM(4) = 0
      CALL OPUT (UVDATA, 'DROPTABS', OOACAR, DIM, DUMMY, NOTYPE, IERR)
      CALL UVCALT (UVDATA, UVSORT, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'PROBLEM COPYING TABLES TO OUTPUT'
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
      END

      SUBROUTINE MAPMAX (LUN, XMAX, XMIN, ERROR)
C-----------------------------------------------------------------------
C! determine extrema of image opened by FILOPN and update header
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   WaWa IO system: Determine max and min of an map opened by FILOPN
C   and update CAT block accordingly
C   Inputs:
C      LUN     I   Logical Unit No. of map
C   Outputs:
C      XMAX    R   Maximum in map
C      XMIN    R   Minimum
C      ERROR   I   Error codes: 0 => ok
C                               1 => file not open
C                               2 => input parms error
C                             3-6 => IO errors
C                               8 => data type illegal (only
C                                    floating scalars & complex ok)
C                              10 => catalog read/... error
C   Written by WaWa (4/21/81)
C-----------------------------------------------------------------------
      INTEGER   LUN, ERROR
      REAL      XMAX, XMIN
C
      CHARACTER CHTM12*12, CHTM6*6, CHTM2*2, OPER*4
      INTEGER   NX, NY, NPLANE, IPLANE, BLK, DB, TYPCOD,
     *   FIND, NDIM, NSUB, DEP(5), BUFSZ, BIND, DUM,
     *   RDINT, I, IERR, IFIL, IND1, J, BADTYP, NOTOPN, WARN1, WARN2,
     *   CATER
      REAL      X1, X2, X3
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA DEP /2,1,1,1,1/
      DATA NOTOPN, CATER, WARN1, WARN2, BADTYP /1, 10, 6, 7, 8/
C-----------------------------------------------------------------------
C                                       Is file open?
      ERROR = NOTOPN
      DO 10 IFIL = 6,EFIL
         IF (LUN.EQ.FILTAB(POLUN,IFIL)) GO TO 20
 10      CONTINUE
      GO TO 999
C                                       Read only floating point
 20   TYPCOD = FILTAB(POBPX,IFIL)
      ERROR = BADTYP
      IF (TYPCOD.NE.2) GO TO 999
C                                       Parms from table
      FIND = FILTAB(POFIN,IFIL)
      NX = FILTAB(PONAX,IFIL)
      NY = FILTAB(PONAX+1,IFIL)
      RDINT = LREAL * (IFIL - 6)
      BUFSZ = LREAL * 2
C                                       Get cat block, mark it read
      OPER = 'READ'
      NSUB = 2
      ERROR = CATER
      CALL CATIO ('READ', FILTAB(POVOL,IFIL), FILTAB(POCAT,IFIL),
     *   CATBLK, 'READ', WBUFF, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.WARN1) .AND. (IERR.NE.WARN2))
     *   GO TO 980
C                                       Number planes, block offset
      NDIM = CATBLK(KIDIM)
      NPLANE = 1
      DB = 0
      IF (NDIM.LE.2) GO TO 50
         DO 40 I = 3,NDIM
            NPLANE = NPLANE * CATBLK(KINAX+I-1)
 40         CONTINUE
         CALL COMOFF (NDIM, CATBLK(KINAX), DEP, DB, IERR)
C                                       Init block off, max/min
 50   BLK = 1
      X2 = 1.0E20
      X1 = -X2
C                                       Read loop over planes
      DO 100 IPLANE = 1,NPLANE
         NSUB = 3
         CALL MINIT ('READ', LUN, FIND, NX, NY, 0, RBUF(RDINT+1), BUFSZ,
     *      BLK, ERROR)
         IF (ERROR.NE.0) GO TO 970
         NSUB = 4
         DO 70 I = 1,NY
            CALL MDISK ('READ', LUN, FIND, RBUF(RDINT+1), BIND, ERROR)
            IF (ERROR.NE.0) GO TO 970
            IND1 = BIND + RDINT - 1
            DO 60 J = 1,NX
               X3 = RBUF(IND1+J)
               IF (X3.EQ.INDEF) GO TO 60
                  X1 = MAX (X1, X3)
                  X2 = MIN (X2, X3)
 60            CONTINUE
 70         CONTINUE
         BLK = DB + BLK
 100     CONTINUE
C                                       Clear read, then update
C                                       cat block on disk
      CALL CATDIR ('CSTA', FILTAB(POVOL,IFIL), FILTAB(POCAT,IFIL),
     *   CHTM12, CHTM6, DUM, CHTM2, DUM, 'CLRD', WBUFF, IERR)
      CATR(KRDMX) = X1
      CATR(KRDMN) = X2
      XMAX = X1
      XMIN = X2
      NSUB = 2
      ERROR = CATER
      OPER = 'UPDT'
      CALL CATIO ('UPDT', FILTAB(POVOL,IFIL), FILTAB(POCAT,IFIL),
     *   CATBLK, 'REST', WBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      ERROR = 0
      GO TO 999
C                                       Errors
 970  IERR = ERROR
C
 980  WRITE (MSGTXT,1980) SUBNAM(NSUB), OPER, IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('MAPMAX: ',A6,2X,A4,' ERROR',I7)
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER NPARMS
      PARAMETER (NPARMS=24)
      INTEGER AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
      INCLUDE 'INCS:PAOOF.INC'
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'NFIELD',
     *   'NMAPS', 'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK', 'IMSIZE',
     *   'COORDINA', 'COOTYPE', 'COOINC', 'COOREF', 'ROTATE',
     *   'REWEIGHT', 'DOWEIGHT', 'EDGSKP', 'OPTYPE', 'APARM', 'PBPARM',
     *   'NOISE', 'BADDISK'/
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOAINT,
     *   OOAINT, OOACAR, OOACAR, OOAINT, OOAINT, OOAINT,
     *   OOARE, OOACAR, OOARE, OOARE, OOARE,
     *   OOARE, OOARE, OOAINT, OOACAR, OOARE, OOARE,
     *   OOARE, OOAINT/
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 1,1,
     *   1,1, 12,1, 6,1, 1,1, 1,1, 2,1,
     *   6,1, 4,1, 2,1, 2,1, 1,1,
     *   2,1, 1,1, 1,1, 4,1, 10,1, 7,1,
     *   64,1, 10,1/
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(66)
      LOGICAL   LDUM(66)
      REAL      RDUM(66)
      DOUBLE PRECISION DDUM(33)
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
      COMMON /FLATNG/ DDUM
LOCAL END
      PROGRAM FLATN
C-----------------------------------------------------------------------
C! Geometric interpolation of multiple facets/pointings to one image
C# Task IMAGING OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1997-2000, 2002-2003, 2006-2007, 2009-2013, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NMMAX
      PARAMETER (NMMAX = MAXFLD * MAXFLD / 16)
      CHARACTER PRGM*6, IN(NMMAX)*32, OUT*32, SCF(2)*32, ARRAY*8
      INTEGER   NIMAGE, IRET, BUFF1(256), HWIDTH, I
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'FLATN '/
C-----------------------------------------------------------------------
C                                       Startup
      I = NMMAX
      CALL FLTNIN (PRGM, I, IN, NIMAGE, OUT, SCF, HWIDTH, ARRAY, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Interpolate
      CALL FLATEN (ARRAY, IN, NIMAGE, HWIDTH, SCF, OUT, IRET)
      IF (IRET.NE.0) GO TO 990
      CALL BEMCOP (IN, OUT, IRET)
      IRET = 0
C                                       History
      CALL FLTNHI (IN, OUT)
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE FLTNIN (PRGN, NMMAX, IN, NIMAGE, OUT, SCF, HWIDTH,
     *   ARRAY, IRET)
C-----------------------------------------------------------------------
C   FLTNIN gets input parameters for FLATN and creates the output.
C   Inputs:
C      PRGN     C*6      Program name
C      NMMAX    I        Max dimension of IN
C   Output:
C      IN       C(*)*?   Input object
C      NIMAGE   I        Number of images in IN
C      OUT      C*?      Output object
C      SCF      C(2)*?   Scratch image objects
C      HWIDTH   I        Interpolation kernel half width.
C      ARRAY    C*8      Array name
C      IRET     I        Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   NMMAX, NIMAGE, HWIDTH, IRET
      CHARACTER PRGN*6, IN(*)*(*), OUT*(*), SCF(2)*(*), ARRAY*8
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NKEY1
C                                       NKEY1=no. adverbs for inname
      PARAMETER (NKEY1=4)
      INTEGER   DIM(7), TYPE, DISK, SEQ, BLC(7), TRC(7), IMSIZE(2),
     *   NAXIS(7), NAXIS2(7), IROUND, IDISK, ODISK, ICNO, OCNO,
     *   INAXIS(7), BLC2(7), TRC2(7), ROTAX, I, NFIELD, LFIELD, NITOT,
     *   NITER, MSGSAV, EDGSKP, NDIM, J0, NMAPS, IMSEQ0, IMSEQ, LMAP,
     *   LLM, NNOISE, IPROJ
      REAL      CRPIX(7), CRPIX2(7), REWT(2), CDELT(7), CDELT2(7),
     *   CROTA(7), CROTA2(7), COORDS(6), XSHIFT, YSHIFT, APARM(10),
     *   C123(4), PA, ZA, NOISES(65), PBPARM(7), COOINC(2), COOREF(2),
     *   ROTATE, ACTN
      DOUBLE PRECISION OBSRA, OBSDEC, CRVAL(7), CRVAL2(7), OUTRA, OUTDEC
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, NAME*12, CLASS*6,
     *   INAME*12, CDUMMY*1, CFIELD*11, CNAME*8, KEYW*8, CRTYPE(7)*8,
     *   TEST*32, COOTYP*4, PROJ*4, LPROJ(11)*4, ICLASS*6, OPTYPE*4,
     *   CUNITS*8, NOTTAB*2
      LOGICAL   ISNEG, DO3D, OLDNAM, DOPBEM
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs for IN
C                    1          2        3           4
      DATA INK1 /'INNAME', 'INDISK', 'DOWEIGHT', 'PBPARM'/
C                                       Rename
C                    1       2        3           4
      DATA OUTK1 /'NAME', 'DISK', 'DOWEIGHT', 'PBPARM'/
      DATA LPROJ /'-TAN','-SIN', '-ARC', 'NCP', '-STG', '-AIT',
     *   '-GLS', '-MER','-CAR','-MOL','-PAR'/
C-----------------------------------------------------------------------
      NIMAGE = 0
C                                       Startup
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Declare 'PARANGLE' a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'PARANGLE'
      CALL OBVHKW (CNAME, KEYW, OOARE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Declare 'ZENANGLE' a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'ZENANGLE'
      CALL OBVHKW (CNAME, KEYW, OOARE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Declare 'ACTNOISE' a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'ACTNOISE'
      CALL OBVHKW (CNAME, KEYW, OOARE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       other inputs
      CALL OGET ('Input', 'BADDISK', TYPE, DIM, IBAD, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'NFIELD', TYPE, DIM, IDUM, CDUMMY, IRET)
      NFIELD = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      NFIELD = MAX (1, MIN (MAXFLD, NFIELD))
      CALL OGET ('Input', 'PBPARM', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, PBPARM)
      CALL OGET ('Input', 'NMAPS', TYPE, DIM, IDUM, CDUMMY, IRET)
      NMAPS = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      NMAPS = MAX (1, NMAPS)
      DOPBEM = NMAPS.GT.1
      IF ((PBPARM(1).GT.0.0) .AND. (PBPARM(2).GT.0.0) .AND.
     *   (PBPARM(3).EQ.0.0) .AND. (PBPARM(4).EQ.0.0) .AND.
     *   (PBPARM(5).EQ.0.0) .AND. (PBPARM(6).EQ.0.0) .AND.
     *   (PBPARM(7).EQ.0.0)) DOPBEM = .FALSE.
      CALL OGET ('Input', 'OPTYPE', TYPE, DIM, IDUM, OPTYPE, IRET)
      IF (IRET.NE.0) GO TO 999
      IF ((OPTYPE.NE.'NOIS') .AND. (OPTYPE.NE.'WEIG')) OPTYPE = ' '
      IF (.NOT.DOPBEM) OPTYPE = ' '
      CALL OGET ('Input', 'INCLASS', TYPE, DIM, IDUM, CLASS, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'EDGSKP', TYPE, DIM, IDUM, CDUMMY, IRET)
      EDGSKP = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      IF (EDGSKP.LT.0) EDGSKP = -EDGSKP - 1
      EDGSKP = MIN (1024, EDGSKP)
      CALL OGET ('Input', 'NOISE', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, NOISES)
      CALL OGET ('Input', 'INSEQ', TYPE, DIM, IDUM, CDUMMY, IRET)
      IMSEQ0 = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      IMSEQ0 = MAX (1, IMSEQ0)
C                                       Image coordinates
      CALL OGET ('Input', 'COOTYPE', TYPE, DIM, IDUM, COOTYP, IRET)
      IF (IRET.NE.0) GO TO 999
      PROJ = ' '
      IPROJ = 0
      DO 15 I = 1,11
         IF (COOTYP.EQ.LPROJ(I)) THEN
            PROJ = LPROJ(I)
            IPROJ = I
            END IF
 15      CONTINUE
      CALL OGET ('Input', 'ROTATE', TYPE, DIM, IDUM, CDUMMY, IRET)
      ROTATE = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'COOINC', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, COOINC)
      CALL OGET ('Input', 'COOREF', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, COOREF)
      CALL OGET ('Input', 'COORDINA', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, COORDS)
      ISNEG = (COORDS(1).LT.0.0) .OR. (COORDS(2).LT.0.0) .OR.
     *   (COORDS(3).LT.0.0)
      OUTRA = ABS (COORDS(1)) + ABS (COORDS(2))/60.0D0 + ABS
     *   (COORDS(3))/3600.0D0
      IF (ISNEG) OUTRA = -OUTRA
      OUTRA = OUTRA * 15.0D0
      ISNEG = (COORDS(4).LT.0.0) .OR. (COORDS(5).LT.0.0) .OR.
     *   (COORDS(6).LT.0.0)
      OUTDEC = ABS(COORDS(4)) + ABS(COORDS(5))/60.0D0 +
     *   ABS(COORDS(6))/3600.0D0
      IF (ISNEG) OUTDEC = -OUTDEC
      IF ((IPROJ.GT.5) .AND. (OUTDEC.NE.0.0D0)) THEN
         MSGTXT = 'You have requested an oblique coordinate system'
         CALL MSGWRT (6)
         MSGTXT = 'I hope that is what you wanted!'
         CALL MSGWRT (6)
         END IF
      CALL OGET ('Input', 'APARM', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, APARM)
C                                       Interpolation kernel half width.
      CALL OGET ('Input', 'REWEIGHT', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, REWT)
      HWIDTH = IROUND (REWT(1))
      HWIDTH = MIN (4, MAX (1, HWIDTH))
      REWT(1) = HWIDTH
      IF ((REWT(2).LE.0.0) .OR. (REWT(2).GE.1.0)) REWT(2) = 0.3334
      CALL RCOPY (DIM(1), REWT, RDUM)
      CALL OPUT ('Input', 'REWEIGHT', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create IN
      NITOT = 0
      DO3D = APARM(1).GT.0.0
C                                       Linear scaling
      IF (APARM(9).LE.0.0) APARM(9) = 1.0
      C123(1) = APARM(9)
C                                       Radial scaling?
      IF (APARM(4).GT.0.0) THEN
         CALL RCOPY (3, APARM(6), C123(2))
      ELSE
         CALL RFILL (3, 0.0, C123(2))
         APARM(5) = 0.0
         CALL RFILL (3, 0.0, APARM(6))
         END IF
      IF (CLASS.EQ.' ') CLASS = 'ICL001'
      OLDNAM = (CLASS(4:4).LT.'0') .OR. (CLASS(4:4).GT.'9') .OR.
     *   (CLASS(5:5).LT.'0') .OR. (CLASS(5:5).GT.'9') .OR.
     *   (CLASS(6:6).LT.'0') .OR. (CLASS(6:6).GT.'9')
      J0 = 1
      IF (.NOT.OLDNAM) READ (CLASS(4:6),1001) J0
      NOISES(65) = 0.0
      NNOISE = 0
      DO 30 LMAP = 1,NMAPS
         IMSEQ = IMSEQ0 - 1 + LMAP
         ICLASS = CLASS
         LLM = MIN (LMAP, 65)
         ACTN = 0.0
         IF (LMAP.EQ.65) THEN
            NNOISE = MAX (1, NNOISE)
            NOISES(65) = NOISES(65) / NNOISE
         ELSE IF (LMAP.LT.65) THEN
            ACTN = NOISES(LMAP)
            END IF
         DO 20 LFIELD = 1,NFIELD
            WRITE (CFIELD,1000) LFIELD - 1 + J0, IMSEQ
            TEST = 'Input image object ' // CFIELD
            CALL CREATE (TEST, 'IMAGE', IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
            CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, TEST, IRET)
            IF (IRET.NE.0) GO TO 999
            DIM(1) = 6
            DIM(2) = 1
            IF (OLDNAM) THEN
               CALL ZEHEX (LFIELD-1, 2, CFIELD(:2))
               IF (LFIELD.GT.1) ICLASS(5:6) = CFIELD(:2)
            ELSE IF (LFIELD.LT.1000) THEN
               ICLASS(4:6) = CFIELD(2:4)
            ELSE
               ICLASS(3:6) = CFIELD(1:4)
               END IF
            CALL OPUT (TEST, 'CLASS', OOACAR, DIM, IDUM, ICLASS, IRET)
            IF (IRET.NE.0) GO TO 999
            DIM(1) = 1
            IDUM(1) = IMSEQ
            CALL OPUT (TEST, 'IMSEQ', OOAINT, DIM, IDUM, CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Open and close to check
            MSGSAV = MSGSUP
            MSGSUP = 32000
            CALL OOPEN (TEST, 'READ', IRET)
            MSGSUP = MSGSAV
C                                       skip missing ones
            IF (IRET.NE.0) THEN
               IRET = 0
C                                       got it - continue
            ELSE
               IF (NIMAGE.EQ.NMMAX) THEN
                  MSGTXT = 'TOO MANY FIELDS*POINTINGS !!!!'
                  CALL MSGWRT (8)
                  IRET = 8
                  GO TO 999
                  END IF
               NIMAGE = NIMAGE + 1
               IN(NIMAGE) = TEST
C                                       get noise
               IF (ACTN.LE.0.0) THEN
                  MSGSUP = 32000
                  CALL IMGET (TEST, 'ACTNOISE', TYPE, DIM, IDUM, CDUMMY,
     *               IRET)
                  ACTN = RDUM(1)
                  MSGSUP = MSGSAV
                  IF ((IRET.NE.0) .OR. (ACTN.LE.0.0)) THEN
                     ACTN = 1.0
                     IF (LMAP.GE.65) ACTN = NOISES(65)
                     IRET = 0
                     END IF
                  IF ((LMAP.LT.65) .AND. (LFIELD.NE.1)) THEN
                     NOISES(65) = NOISES(65) + ACTN
                     NNOISE = NNOISE + 1
                     END IF
                  IF (LMAP.LT.65) NOISES(LMAP) = ACTN
                  END IF
               IF ((LMAP.LT.65) .AND. (LFIELD.EQ.1)) THEN
                  NOISES(65) = NOISES(65) + ACTN
                  NNOISE = NNOISE + 1
                  END IF
C                                       other input parms -> class
               DIM(1) = 4
               DIM(2) = 1
               CALL OPUT (TEST, 'OPTYPE', OOACAR, DIM, IDUM, OPTYPE,
     *            IRET)
               IF (IRET.NE.0) GO TO 999
               DIM(1) = 1
               DIM(2) = 1
               LDUM(1) = DOPBEM
               CALL OPUT (TEST, 'DOPBEAM', OOALOG, DIM, IDUM, CDUMMY,
     *            IRET)
               IF (IRET.NE.0) GO TO 999
               RDUM(1) = ACTN
               CALL OPUT (TEST, 'NOISE', OOARE, DIM, IDUM, CDUMMY, IRET)
               IF (IRET.NE.0) GO TO 999
C                                       sum clean iterations
               CALL BEMGET (TEST, 'NITER', TYPE, DIM, IDUM, CDUMMY,
     *            IRET)
               NITER = IDUM(1)
               IF (IRET.NE.0) GO TO 999
               NITOT = NITOT + MAX (0, NITER)
C                                       Input subimage dimension
               CALL ARRWIN (TEST, BLC, TRC, NAXIS, IRET)
               IF (IRET.NE.0) GO TO 999
               BLC(1) = 1 + EDGSKP
               BLC(2) = 1 + EDGSKP
               TRC(1) = TRC(1) - EDGSKP
               TRC(2) = TRC(2) - EDGSKP
               DIM(1) = 7
               DIM(2) = 1
               CALL OPUT (TEST, 'BLC', OOAINT, DIM, BLC, CDUMMY, IRET)
               IF (IRET.NE.0) GO TO 999
               CALL OPUT (TEST, 'TRC', OOAINT, DIM, TRC, CDUMMY, IRET)
               IF (IRET.NE.0) GO TO 999
               CALL OCLOSE (TEST, IRET)
               IF (IRET.NE.0) GO TO 999
               DIM(1) = 1
               DIM(2) = 1
               RDUM(1) = REWT(2)
               CALL OPUT (TEST, 'RELIABLE', OOARE, DIM, IDUM, CDUMMY,
     *            IRET)
               IF (IRET.NE.0) GO TO 999
C                                       3-D corrections?
               IF (DO3D) THEN
                  MSGTXT = '*** WARNING: DOING 3-D CORRECTIONS. ***'
                  CALL MSGWRT (7)
                  MSGTXT = '*** I HOPE YOU KNOW WHAT YOU ARE DOING ***'
                  CALL MSGWRT (7)
                  DIM(1) = 1
                  DIM(2) = 1
                  LDUM(1) = DO3D
                  CALL OPUT (TEST, 'DO3DCOR', OOALOG, DIM, IDUM, CDUMMY,
     *               IRET)
                  IF (IRET.NE.0) GO TO 999
                  MSGSAV = MSGSUP
C                                       Parallactic angle
                  MSGSUP = 32000
                  CALL OGET (TEST, 'PARANGLE', TYPE, DIM, IDUM, CDUMMY,
     *               IRET)
                  PA = RDUM(1)
                  MSGSUP = MSGSAV
C                                       Use input
                  IF (IRET.NE.0) THEN
                     RDUM(1) = APARM(2)
                     CALL OPUT (TEST, 'PARANGLE', OOARE, DIM, IDUM,
     *                  CDUMMY, IRET)
                     END IF
                  IF (IRET.NE.0) GO TO 999
C                                       Zenith angle
                  MSGSUP = 32000
                  CALL OGET (TEST, 'ZENANGLE', TYPE, DIM, IDUM, CDUMMY,
     *               IRET)
                  ZA = RDUM(1)
                  MSGSUP = MSGSAV
C                                       Use input
                  IF (IRET.EQ.1) THEN
                     RDUM = APARM(3)
                     CALL OPUT (TEST, 'ZENANGLE', OOARE, DIM, IDUM,
     *                  CDUMMY, IRET)
                     END IF
                  IF (IRET.NE.0) GO TO 999
                  END IF
C                                       Radial scaling
               DIM(1) = 1
               DIM(2) = 1
               RDUM(1) = APARM(4)
               CALL OPUT (TEST, 'PBFWHM', OOARE, DIM, IDUM, CDUMMY,
     *            IRET)
               IF (IRET.NE.0) GO TO 999
               DIM(1) = 1
               RDUM(1) = APARM(5) * APARM(5)
               CALL OPUT (TEST, 'FBWSQ', OOARE, DIM, IDUM, CDUMMY, IRET)
               IF (IRET.NE.0) GO TO 999
               DIM(1) = 4
               CALL RCOPY (4, C123, RDUM)
               CALL OPUT (TEST, 'C123', OOARE, DIM, IDUM, CDUMMY, IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
 20         CONTINUE
 30      CONTINUE
C                                       Save APARM, NOISE for history
      DIM(1) = 10
      CALL RCOPY (10, APARM, RDUM)
      CALL OPUT ('Input', 'APARM', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 64
      CALL RCOPY (64, NOISES, RDUM)
      CALL OPUT ('Input', 'NOISE', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Control parameters
C                                       Clone output from IN2
      OUT = 'Output interpolated image'
      CALL CREATE (OUT, 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy array descriptors
      CALL ARDCOP (IN, OUT, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Set names
      CALL ARDGET (IN(1), 'NDIM', TYPE, DIM, IDUM, CDUMMY, IRET)
      NDIM = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET (IN(1), 'NAME', TYPE, DIM, IDUM, INAME, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'OUTNAME', TYPE, DIM, IDUM, NAME, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'OUTCLASS', TYPE, DIM, IDUM, CLASS, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'OUTSEQ', TYPE, DIM, IDUM, CDUMMY, IRET)
      SEQ = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'OUTDISK', TYPE, DIM, IDUM, CDUMMY, IRET)
      DISK = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      IF (NAME.EQ.' ') NAME = INAME
      IF (CLASS.EQ.' ') CLASS = PRGN
      DIM(1) = LEN (NAME)
      CALL OPUT (OUT, 'NAME', OOACAR, DIM, IDUM, NAME, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = LEN (CLASS)
      CALL OPUT (OUT, 'CLASS', OOACAR, DIM, IDUM, CLASS, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 1
      IDUM(1) = SEQ
      CALL OPUT (OUT, 'IMSEQ', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = DISK
      CALL OPUT (OUT, 'DISK', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Size
      CALL OGET ('Input', 'IMSIZE', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL COPY (DIM(1), IDUM, IMSIZE)
C                                       Input subimage dimension
      CALL ARRWIN (IN(1), BLC, TRC, NAXIS, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Check coordinate type
      CALL OBHGET (IN(1), CATBLK, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL H2CHR (8, 1, CATH(KHTEL), ARRAY)
      LOCNUM = 1
      CALL SETLOC (BLC(3), .FALSE.)
      ROTAX = 0
      IF (AXTYP(LOCNUM).EQ.1) THEN
         ROTAX = 2
         IF (CORTYP(LOCNUM).EQ.2) ROTAX = 1
         END IF
C                                       Output image size
      CALL COPY (7, NAXIS, NAXIS2)
      IF (IMSIZE(1).GT.0) NAXIS2(1) = IMSIZE(1)
      IF (IMSIZE(2).GT.0) NAXIS2(2) = IMSIZE(2)
      DIM(1) = 7
      CALL OPUT (OUT, 'ARRAY.ARRAY_DESC.NAXIS', OOAINT, DIM, NAXIS2,
     *   CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IMSIZE(1) = NAXIS2(1)
      IMSIZE(2) = NAXIS2(2)
C                                       Reference pixel, increment
      CALL OGET (IN(1), 'ARRAY.ARRAY_DESC.NAXIS', TYPE, DIM, INAXIS,
     *   CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL COPY (DIM(1), IDUM, INAXIS)
      CALL OGET (IN(1), 'IMAGE_DESC.CRPIX', TYPE, DIM, IDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, CRPIX)
      CALL OGET (IN(1), 'IMAGE_DESC.CRVAL', TYPE, DIM, IDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL DPCOPY (DIM(1), DDUM, CRVAL)
      CALL OGET (IN(1), 'IMAGE_DESC.CDELT', TYPE, DIM, IDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, CDELT)
      CALL OGET (IN(1), 'IMAGE_DESC.CROTA', TYPE, DIM, IDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, CROTA)
      CALL OGET (IN(1), 'IMAGE_DESC.CTYPE', TYPE, DIM, IDUM, CRTYPE,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Correct for subimaging.
      CRPIX2(1) = NAXIS2(1) / 2
      CRPIX2(2) = NAXIS2(2) / 2 + 1
      CRPIX2(3) = CRPIX(3) - BLC(3) + 1.0
      CRPIX2(4) = CRPIX(4) - BLC(4) + 1.0
      CRPIX2(5) = CRPIX(5) - BLC(5) + 1.0
      CRPIX2(6) = CRPIX(6) - BLC(6) + 1.0
      CRPIX2(7) = CRPIX(7) - BLC(7) + 1.0
      CALL RCOPY (7, CDELT, CDELT2)
      CALL RCOPY (7, CROTA, CROTA2)
      CALL DPCOPY (7, CRVAL, CRVAL2)
      DO 35 I = NDIM+1,KICTPN
         CRPIX2(I) = 0.0
         CDELT2(I) = 0.0
         CRVAL2(I) = 0.0D0
         CROTA2(I) = 0.0
         CRTYPE(I) = ' '
 35      CONTINUE
C                                       Force full instantiation
      CALL OOPEN (OUT, 'WRIT', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy image descriptors
C                                       includes obsra, obsdec, beam
      CALL IMDCOP (IN(1), OUT, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       do not copy CC tables
      DIM(1) = 2
      DIM(2) = 1
      NOTTAB = 'CC'
      CALL OPUT (IN(1), 'DROPTABS', OOACAR, DIM, IDUM, NOTTAB, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       set total niter
      DIM(1) = 1
      DIM(2) = 1
      IDUM(1) = NITOT
      CALL OPUT (OUT, 'BEAM.NITER', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Get Observing position
      CALL PSNGET (IN(1), 'OBSRA', TYPE, DIM, IDUM, CDUMMY, IRET)
      OBSRA = DDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL PSNGET (IN(1), 'OBSDEC', TYPE, DIM, IDUM, CDUMMY, IRET)
      OBSDEC = DDUM(1)
      IF (IRET.NE.0) GO TO 999
      IF ((OUTRA.EQ.0.0D0) .AND. (OUTDEC.EQ.0.0D0)) THEN
         OUTRA = OBSRA
         OUTDEC = OBSDEC
         END IF
      IF ((OUTRA.NE.0.0) .OR. (OUTDEC.NE.0.0)) THEN
         CRVAL2(1) = OUTRA
         CRVAL2(2) = OUTDEC
      ELSE IF (IPROJ.GT.5) THEN
         CRVAL2(2) = 0.0D0
         END IF
      IF (PROJ.NE.' ') THEN
         CRTYPE(1)(5:) = PROJ
         CRTYPE(2)(5:) = PROJ
         END IF
      IF ((COOREF(1).NE.0.0) .OR. (COOREF(2).NE.0.0)) THEN
         CRPIX2(1) = COOREF(1)
         CRPIX2(2) = COOREF(2)
         END IF
      IF ((COOINC(1).NE.0.0) .AND. (COOINC(2).NE.0.0)) THEN
         CDELT2(1) = COOINC(1) / 3600.0
         CDELT2(2) = COOINC(2) / 3600.0
         END IF
      DO 40 I = 1,2
         IF (CRTYPE(I)(:4).EQ.'DEC-') CROTA2(I) = ROTATE
         IF (CRTYPE(I)(2:4).EQ.'LAT') CROTA2(I) = ROTATE
 40      CONTINUE
C                                       zero the shift parameter
      CALL PSNGET (IN(1), 'XSHIFT', TYPE, DIM, IDUM, CDUMMY, IRET)
      XSHIFT = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      XSHIFT = 0.0
      RDUM(1) = XSHIFT
      CALL PSNPUT (OUT, 'XSHIFT', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL PSNGET (IN(1), 'YSHIFT', TYPE, DIM, IDUM, CDUMMY, IRET)
      YSHIFT = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      YSHIFT = 0.0
      RDUM(1) = 0.0
      CALL PSNPUT (OUT, 'YSHIFT', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Save reference pixel.
      DIM(1) = 7
      CALL RCOPY (7, CRPIX2, RDUM)
      CALL OPUT (OUT, 'IMAGE_DESC.CRPIX', OOARE, DIM, IDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (7, CDELT2, RDUM)
      CALL OPUT (OUT, 'IMAGE_DESC.CDELT', OOARE, DIM, IDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (7, CROTA2, RDUM)
      CALL OPUT (OUT, 'IMAGE_DESC.CROTA', OOARE, DIM, IDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL DPCOPY (7, CRVAL2, DDUM)
      CALL OPUT (OUT, 'IMAGE_DESC.CRVAL', OOADP, DIM, IDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL FILL (7, 0, BLC2)
      CALL FILL (7, 0, TRC2)
      CALL OPUT (OUT, 'BLC', OOAINT, DIM, BLC2, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (OUT, 'TRC', OOAINT, DIM, TRC2, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 8
      DIM(2) = 7
      CALL OPUT (OUT, 'IMAGE_DESC.CTYPE', OOACAR, DIM, IDUM, CRTYPE,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      IF (OPTYPE.EQ.'WEIG') THEN
         CUNITS = '(B/JY)^2'
         DIM(2) = 1
         CALL OPUT (OUT, 'IMAGE_DESC.BUNIT', OOACAR, DIM, IDUM, CUNITS,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      CALL OCLOSE (OUT, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy catalog header keywords.
      CALL OBDSKC (IN(1), IDISK, ICNO, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OBDSKC (OUT, ODISK, OCNO, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL KEYCOP (IDISK, ICNO, ODISK, OCNO, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Save parms for history
      DIM(1) = 2
      DIM(2) = 1
      CALL OPUT ('Input', 'IMSIZE', OOAINT, DIM, IMSIZE, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       create scratch files
      SCF(1) = 'Scratch image'
      SCF(2) = 'Weight summing image'
      DO 50 I = 1,2
         CALL IMGSCR (SCF(I), NAXIS2, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OOPEN (SCF(I), 'WRIT', IRET)
         IF (IRET.NE.0) GO TO 999
         DIM(1) = 8
         DIM(2) = 7
         CALL OPUT (OUT, 'IMAGE_DESC.CTYPE', OOACAR, DIM, IDUM, CRTYPE,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         DIM(1) = 7
         DIM(2) = 1
         CALL RCOPY (7, CRPIX2, RDUM)
         CALL OPUT (SCF(I), 'CRPIX', OOARE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL RCOPY (7, CDELT2, RDUM)
         CALL OPUT (SCF(I), 'CDELT', OOARE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL RCOPY (7, CROTA2, RDUM)
         CALL OPUT (SCF(I), 'CROTA', OOARE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL DPCOPY (7, CRVAL2, DDUM)
         CALL OPUT (SCF(I), 'CRVAL', OOADP, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT (SCF(I), 'BLC', OOAINT, DIM, BLC2, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT (SCF(I), 'TRC', OOAINT, DIM, TRC2, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         DIM(1) = 1
         IDUM(1) = NDIM
         CALL ARDPUT (SCF(I), 'NDIM', OOAINT, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OCLOSE (SCF(I), IRET)
         IF (IRET.NE.0) GO TO 999
 50      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I4.4,1X,I6.5)
 1001 FORMAT (I3)
      END
      SUBROUTINE FLATEN (ARRAY, IN, NIMAGE, HWIDTH, SCF, OUT, IRET)
C-----------------------------------------------------------------------
C   Loops over input fields: re-grids each to SCF(1) then adds into OUT
C   with weight sum in SCF(2).  At end, divides SCF(2) into OUT.
C   Inputs:
C      IN       C(*)*?   Input image(s)
C      NIMAGE   I        Number images in IN
C      HWIDTH   I        Convolution half width
C      SCF      C(2)*?   Scratch files
C      OUT      C*?      Output file
C   Output:
C      IRET     I        Error code: 0 okay
C-----------------------------------------------------------------------
      CHARACTER ARRAY*8, IN(*)*(*), SCF(2)*(*), OUT*(*)
      INTEGER   NIMAGE, HWIDTH, IRET
C
      INTEGER   NAX2(7), I1, I2, I3, I4, I5, I6, I7, LFIELD, NFIELD,
     *   TYPE, DIM(7), NY, BLC(7), TRC(7), XB, XE, LOCF, EDGSKP,
     *   NAX1(7), INBLC(7), INTRC(7)
      LOGICAL   DOPBEM, DORADI, SWITCH, OUTSID, DOELLI
      CHARACTER CDUMMY*1, WWT*32, WOUT*32, STATUS*4, CTYPE(7)*8,
     *   OPTYPE*4
      DOUBLE PRECISION RAPT, DECPT, RAREF, DECREF, XREF, YREF, ZREF,
     *   CRVAL(7), FREQ, LAMBDA, ANGLEP, ANGLER, DEPS
      INCLUDE 'INCS:PMAD.INC'
      REAL      ROWI(MABFSS), ROWO(MABFSS), ROWW(MABFSS), FMIN, FMAX,
     *   NOISE, WT, RFACT, CRPIX(7), CDELT(7), PBPARM(7), XPIX, YPIX,
     *   BMFACT, R, X, Y, XC, YC
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
C-----------------------------------------------------------------------
C                                       number of fields to do
      CALL OGET ('Input', 'NMAPS', TYPE, DIM, IDUM, CDUMMY, IRET)
      NFIELD = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'EDGSKP', TYPE, DIM, IDUM, CDUMMY, IRET)
      EDGSKP = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      DOELLI = EDGSKP.GE.0
      IF (EDGSKP.LE.0) EDGSKP = 5
      NFIELD = MAX (1, MIN (MAXFLD, NFIELD))
      DEPS = 1.D-4
C                                       size of output
      CALL OGET (OUT, 'ARRAY.ARRAY_DESC.NAXIS', TYPE, DIM, IDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL COPY (DIM(1), IDUM, NAX2)
C                                       Do first one
      IF (NIMAGE.EQ.1) THEN
         MSGTXT = 'Start field   1'
         CALL MSGWRT (2)
         XB = 1
         XE = NAX2(1)
         CALL IMGHGE (IN(1), HWIDTH, XB, XE, OUT, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Multi-field initialize
      ELSE
         CALL COPY (7, NAX2, TRC)
         CALL FILL (7, 1, BLC)
         CALL OOPEN (OUT, 'WRIT', IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OOPEN (SCF(2), 'WRIT', IRET)
         IF (IRET.NE.0) GO TO 999
         DIM(1) = 8
         DIM(2) = 1
         CALL OPUT (OUT, 'ARRAY.ARRAY_PNT.ACCESS', OOACAR, DIM, IDUM,
     *      'ROW', IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT (SCF(2), 'ARRAY.ARRAY_PNT.ACCESS', OOACAR, DIM, IDUM,
     *      'ROW', IRET)
         IF (IRET.NE.0) GO TO 999
         CALL RFILL (NAX2(1), FBLANK, ROWI)
         DO 30 I7 = 1,NAX2(7)
            DO 29 I6 = 1,NAX2(6)
               DO 28 I5 = 1,NAX2(5)
                  DO 27 I4 = 1,NAX2(4)
                     DO 26 I3 = 1,NAX2(3)
                        DO 20 I2 = 1,NAX2(2)
                           CALL ARRWRI (OUT, DIM, ROWI, IRET)
                           IF (IRET.NE.0) GO TO 999
                           CALL ARRWRI (SCF(2), DIM, ROWI, IRET)
                           IF (IRET.NE.0) GO TO 999
 20                        CONTINUE
 26                     CONTINUE
 27                  CONTINUE
 28               CONTINUE
 29            CONTINUE
 30         CONTINUE
         CALL ARRCLO (OUT, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL ARRCLO (SCF(2), IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OCLOSE (OUT, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OCLOSE (SCF(2), IRET)
         IF (IRET.NE.0) GO TO 999
         STATUS = ' '
         CALL IMCDES (OUT, STATUS, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       dummy for read/write
         WWT = 'Shallow weight out'
         WOUT = 'Shallow image out'
         CALL OCOPY (OUT, WOUT, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OCOPY (SCF(2), WWT, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       what operation
         CALL OGET (IN(1), 'OPTYPE', TYPE, DIM, IDUM, OPTYPE, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       loop over fields 1 -> N
         DO 200 LFIELD = 1,NIMAGE
            CALL OGET (IN(LFIELD), 'ARRAY.ARRAY_DESC.NAXIS', TYPE, DIM,
     *         IDUM, CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL COPY (DIM(1), IDUM, NAX1)
            XC = NAX1(1) / 2
            YC = NAX1(2) / 2 + 1
            R = (NAX1(1) - 2*EDGSKP) * (NAX1(2) - 2*EDGSKP) / 2.0
            R = R * R
C                                       switch to new file
            CALL OOPEN (IN(LFIELD), 'READ', IRET)
            IF (IRET.NE.0) GO TO 999
            CALL ARSGET (IN(LFIELD), 'DATAMIN', TYPE, DIM, IDUM, CDUMMY,
     *         IRET)
            FMIN = RDUM(1)
            CALL ARSGET (IN(LFIELD), 'DATAMAX', TYPE, DIM, IDUM, CDUMMY,
     *         IRET)
            FMAX = RDUM(1)
            CALL OCLOSE (IN(LFIELD), IRET)
            IF (IRET.NE.0) GO TO 999
            IF ((FMIN.GT.FMAX) .OR. ((FMIN.EQ.0.0) .AND. (FMAX.EQ.0.0)))
     *         THEN
               MSGTXT = 'Image all 0 or blank - skipping interpolation'
               CALL MSGWRT (6)
               GO TO 200
               END IF
C                                       get weighting parameters
            CALL OGET (IN(LFIELD), 'DOWEIGHT', TYPE, DIM, IDUM, CDUMMY,
     *         IRET)
            RFACT = RDUM(1)
            IF (IRET.NE.0) GO TO 999
            DORADI = RFACT.GT.0.0
            RFACT = RFACT * 3600.0
            CALL OGET (IN(LFIELD), 'DOPBEAM', TYPE, DIM, IDUM, CDUMMY,
     *         IRET)
            DOPBEM = LDUM(1)
            IF (IRET.NE.0) GO TO 999
            IF ((DOPBEM) .OR. (DORADI)) THEN
               CALL OGET (IN(LFIELD), 'CRPIX', TYPE, DIM, IDUM, CDUMMY,
     *            IRET)
               IF (IRET.NE.0) GO TO 999
               CALL RCOPY (DIM(1), RDUM, CRPIX)
               CALL PSNVAL (IN(LFIELD), XC, YC, XREF, YREF, ZREF, IRET)
               IF (IRET.NE.0) GO TO 999
C                                       test image coord type
               IF ((AXTYP(LOCNUM).NE.1) .OR. (CORTYP(LOCNUM).LT.1)
     *            .OR. (CORTYP(LOCNUM).GT.2)) THEN
                  MSGTXT = 'PRIMARY BEAM AND DEFOCUSING WORK ONLY ON'
     *               // ' RA-DEC IMAGES'
                  CALL MSGWRT (8)
                  IRET = 8
                  GO TO 999
                  END IF
               SWITCH = CORTYP(LOCNUM).EQ.2
               IF (SWITCH) THEN
                  RAREF = YREF * DG2RAD
                  DECREF = XREF * DG2RAD
               ELSE
                  RAREF = XREF * DG2RAD
                  DECREF = YREF * DG2RAD
                  END IF
               IF (DOPBEM) THEN
                  CALL OGET (IN(LFIELD), 'CRVAL', TYPE, DIM, IDUM,
     *               CDUMMY, IRET)
                  IF (IRET.NE.0) GO TO 999
                  CALL DPCOPY (DIM(1), DDUM, CRVAL)
                  CALL OGET (IN(LFIELD), 'CDELT', TYPE, DIM, IDUM,
     *               CDUMMY, IRET)
                  IF (IRET.NE.0) GO TO 999
                  CALL RCOPY (DIM(1), RDUM, CDELT)
                  CALL OGET (IN(LFIELD), 'CTYPE', TYPE, DIM, IDUM,
     *               CTYPE, IRET)
                  IF (IRET.NE.0) GO TO 999
                  CALL OGET (IN(LFIELD), 'NOISE', TYPE, DIM, IDUM,
     *               CDUMMY, IRET)
                  NOISE = RDUM(1)
                  IF (IRET.NE.0) GO TO 999
                  CALL OGET (IN(LFIELD), 'PBPARM', TYPE, DIM, IDUM,
     *               CDUMMY, IRET)
                  IF (IRET.NE.0) GO TO 999
                  CALL RCOPY (DIM(1), RDUM, PBPARM)
                  IF (PBPARM(1).LE.0.0) PBPARM(1) = 0.1
                  CALL PSNGET (IN(LFIELD), 'OBSRA', TYPE, DIM, IDUM,
     *               CDUMMY, IRET)
                  RAPT = DDUM(1)
                  IF (IRET.NE.0) GO TO 999
                  CALL PSNGET (IN(LFIELD), 'OBSDEC', TYPE, DIM, IDUM,
     *               CDUMMY, IRET)
                  DECPT = DDUM(1)
                  IF (IRET.NE.0) GO TO 999
                  IF ((RAPT.EQ.0.0D0) .AND. (DECPT.EQ.0.0D0)) THEN
                     RAPT = CRVAL(1)
                     DECPT = CRVAL(2)
                     MSGTXT = 'POINTING POSITION 0 - SET TO' //
     *                  ' REFERENCE POSITION'
                     CALL MSGWRT (7)
                     END IF
                  RAPT = RAPT * DG2RAD
                  DECPT = DECPT * DG2RAD
C                                       find freq axis
                  LOCF = 0
                  DO 50 I1 = 1,7
                     IF (CTYPE(I1)(1:4).EQ.'FREQ') LOCF = I1
 50                  CONTINUE
                  IF (LOCF.LE.0) THEN
                     MSGTXT = 'THERE MUST BE A FREQ AXIS FOR PRIMARY'
     *                  // ' BEAM CORRECTION'
                     CALL MSGWRT (8)
                     IRET = 8
                     GO TO 999
                     END IF
                  END IF
               END IF
C                                       set window into output
            CALL INTWIN (IN(LFIELD), HWIDTH, SCF(1), BLC, TRC, INBLC,
     *         INTRC, IRET)
            IF (IRET.GT.0) GO TO 999
            IF (IRET.LT.0) THEN
               IF (IRET.EQ.-1) THEN
                  WRITE (MSGTXT,1030) LFIELD
               ELSE
                  WRITE (MSGTXT,1031) LFIELD
                  END IF
               CALL MSGWRT (6)
               GO TO 200
            ELSE
               WRITE (MSGTXT,1032) LFIELD, BLC(1), BLC(2), TRC(1),
     *            TRC(2)
               CALL MSGWRT (4)
               END IF
            XB = BLC(1)
            XE = TRC(1)
C                                       shift center match out's IX,IY
            XC = XC + XB - INBLC(1)
            YC = YC + 1 - INBLC(2)
            BLC(1) = 1
            TRC(1) = NAX2(1)
            DIM(1) = 7
            DIM(2) = 1
            CALL OPUT (SCF(1), 'BLC', OOAINT, DIM, BLC, CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OPUT (SCF(1), 'TRC', OOAINT, DIM, TRC, CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OPUT (SCF(2), 'BLC', OOAINT, DIM, BLC, CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OPUT (SCF(2), 'TRC', OOAINT, DIM, TRC, CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OPUT (OUT, 'BLC', OOAINT, DIM, BLC, CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OPUT (OUT, 'TRC', OOAINT, DIM, TRC, CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OPUT (WOUT, 'BLC', OOAINT, DIM, BLC, CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OPUT (WOUT, 'TRC', OOAINT, DIM, TRC, CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OPUT (WWT, 'BLC', OOAINT, DIM, BLC, CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OPUT (WWT, 'TRC', OOAINT, DIM, TRC, CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
            NY = TRC(2) - BLC(2) + 1
C                                       interp field LFIELD
            CALL IMGHGE (IN(LFIELD), HWIDTH, XB, XE, SCF(1), IRET)
            IF (IRET.NE.0) GO TO 999
C                                       open for weighting
            CALL OOPEN (OUT, 'READ', IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OOPEN (SCF(1), 'READ', IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OOPEN (SCF(2), 'READ', IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OOPEN (WOUT, 'WRIT', IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OOPEN (WWT, 'WRIT', IRET)
            IF (IRET.NE.0) GO TO 999
            DO 130 I7 = 1,NAX2(7)
            DO 129 I6 = 1,NAX2(6)
            DO 128 I5 = 1,NAX2(5)
            DO 127 I4 = 1,NAX2(4)
            DO 126 I3 = 1,NAX2(3)
               IF (DOPBEM) THEN
                  FREQ = CRVAL(LOCF) + (I3 - CRPIX(LOCF)) * CDELT(LOCF)
                  LAMBDA = VELITE / FREQ
                  END IF
               DO 120 I2 = 1,NY
                  YPIX = I2 + BLC(2) - 1.0
                  CALL ARREAD (OUT, DIM, ROWO, IRET)
                  IF (IRET.NE.0) GO TO 999
                  CALL ARREAD (SCF(1), DIM, ROWI, IRET)
                  IF (IRET.NE.0) GO TO 999
                  CALL ARREAD (SCF(2), DIM, ROWW, IRET)
                  IF (IRET.NE.0) GO TO 999
                  Y = (I2 - YC) * NAX1(1)
                  Y = Y * Y
                  DO 110 I1 = XB,XE
                     IF (ROWI(I1).NE.FBLANK) THEN
C                                       Primary beam weighting
C                                       Defocusing weighting
                        WT = 1.0
                        IF ((DOPBEM) .OR. (DORADI)) THEN
                           XPIX = I1
                           CALL PSNVAL (OUT, XPIX, YPIX, XREF, YREF,
     *                        ZREF, IRET)
                           IF (IRET.NE.0) WT = 0.0
                           IF (SWITCH) THEN
                              ZREF = XREF
                              XREF = YREF
                              YREF = ZREF
                              END IF
                           XREF = XREF * DG2RAD
                           YREF = YREF * DG2RAD
                           END IF
C                                       inscribed ellipse
                        IF (DOELLI) THEN
                           X = (I1 - XC) * NAX1(2)
                           X = X * X
                           IF (X+Y.GT.R) WT = 0.0001
                           END IF
C                                       primary beam
                        IF ((DOPBEM) .AND. (WT.GT.0.0)) THEN
                           ZREF = SIN (YREF) * SIN (DECPT) + COS (YREF)
     *                        * COS (DECPT) * COS (XREF - RAPT)
                           ANGLEP = ACOS (ZREF) * RAD2DG
                           CALL PBCALC (ANGLEP, LAMBDA, ARRAY,
     *                        PBPARM(2), BMFACT, OUTSID)
                           IF (BMFACT.LT.PBPARM(1)) THEN
                              WT = 0.0
                           ELSE
                              WT = WT * BMFACT * BMFACT / NOISE / NOISE
                              ROWI(I1) = ROWI(I1) / BMFACT
                              END IF
                           END IF
C                                       radial downweight
                        IF ((DORADI) .AND. (WT.GT.0.0)) THEN
                           ZREF = SIN (YREF) * SIN (DECREF) + COS (YREF)
     *                        * COS (DECREF) * COS (XREF - RAREF)
                           ANGLER = ACOS (ZREF) * RAD2DG
                           WT = WT * MAX (0.0001D0, 1.0D0-ANGLER*RFACT)
                           END IF
C                                       add it in finally
                        IF (ROWO(I1).NE.FBLANK) THEN
                           ROWO(I1) = ROWO(I1) + ROWI(I1) * WT
                           ROWW(I1) = ROWW(I1) + WT
                        ELSE
                           ROWO(I1) = ROWI(I1) * WT
                           ROWW(I1) = WT
                           END IF
                        END IF
 110                 CONTINUE
                  CALL ARRWRI (WWT, DIM, ROWW, IRET)
                  IF (IRET.NE.0) GO TO 999
                  CALL ARRWRI (WOUT, DIM, ROWO, IRET)
                  IF (IRET.NE.0) GO TO 999
 120              CONTINUE
 126           CONTINUE
 127           CONTINUE
 128           CONTINUE
 129           CONTINUE
 130           CONTINUE
            CALL ARRCLO (OUT, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OCLOSE (OUT, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL ARRCLO (WOUT, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OCLOSE (WOUT, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL ARRCLO (SCF(1), IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OCLOSE (SCF(1), IRET)
            IF (IRET.NE.0) GO TO 999
            CALL ARRCLO (SCF(2), IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OCLOSE (SCF(2), IRET)
            IF (IRET.NE.0) GO TO 999
            CALL ARRCLO (WWT, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OCLOSE (WWT, IRET)
            IF (IRET.NE.0) GO TO 999
 200        CONTINUE
C                                       divide by weights
         IF (OPTYPE.EQ.'NOIS') THEN
            MSGTXT = 'Now output noise image = 1 / ' //
     *         'SQRT (sum of the weights)'
         ELSE IF (OPTYPE.EQ.'WEIG') THEN
            MSGTXT = 'Now output weight image = (sum of the weights)'
         ELSE
            MSGTXT = 'Now output average image'
            END IF
         CALL MSGWRT (2)
         CALL COPY (7, NAX2, TRC)
         CALL FILL (7, 1, BLC)
         DIM(1) = 7
         DIM(2) = 1
         CALL OPUT (SCF(2), 'BLC', OOAINT, DIM, BLC, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT (SCF(2), 'TRC', OOAINT, DIM, TRC, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT (OUT, 'BLC', OOAINT, DIM, BLC, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT (OUT, 'TRC', OOAINT, DIM, TRC, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT (WOUT, 'BLC', OOAINT, DIM, BLC, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT (WOUT, 'TRC', OOAINT, DIM, TRC, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OOPEN (OUT, 'READ', IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OOPEN (SCF(2), 'READ', IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OOPEN (WOUT, 'WRIT', IRET)
         IF (IRET.NE.0) GO TO 999
         DO 230 I7 = 1,NAX2(7)
            DO 229 I6 = 1,NAX2(6)
               DO 228 I5 = 1,NAX2(5)
                  DO 227 I4 = 1,NAX2(4)
                     DO 226 I3 = 1,NAX2(3)
                        DO 220 I2 = 1,NAX2(2)
                           CALL ARREAD (OUT, DIM, ROWO, IRET)
                           IF (IRET.NE.0) GO TO 999
                           CALL ARREAD (SCF(2), DIM, ROWW, IRET)
                           IF (IRET.NE.0) GO TO 999
                           DO 210 I1 = 1,NAX2(1)
                              IF (ROWW(I1).LE.0.0) THEN
                                 ROWO(I1) = FBLANK
                              ELSE IF (ROWO(I1).NE.FBLANK) THEN
                                 IF (OPTYPE.EQ.'NOIS') THEN
                                    ROWO(I1) = 1.0 / SQRT (ROWW(I1))
                                 ELSE IF (OPTYPE.EQ.'WEIG') THEN
                                    ROWO(I1) = ROWW(I1)
                                 ELSE
                                    ROWO(I1) = ROWO(I1) / ROWW(I1)
                                    END IF
                                 END IF
 210                          CONTINUE
                           CALL ARRWRI (WOUT, DIM, ROWO, IRET)
                           IF (IRET.NE.0) GO TO 999
 220                       CONTINUE
 226                    CONTINUE
 227                 CONTINUE
 228              CONTINUE
 229           CONTINUE
 230        CONTINUE
         CALL ARRCLO (OUT, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OCLOSE (OUT, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL ARRCLO (SCF(2), IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OCLOSE (SCF(2), IRET)
         IF (IRET.NE.0) GO TO 999
         CALL ARRCLO (WOUT, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OCLOSE (WOUT, IRET)
         IF (IRET.NE.0) GO TO 999
C
         CALL DESTRY (WWT, IRET)
         CALL DESTRY (WOUT, IRET)
         END IF
C                                       delete scratch
      CALL IMGZAP (SCF(1), IRET)
      CALL IMGZAP (SCF(2), IRET)
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('Field',I6,' not included in output - outside image')
 1031 FORMAT ('Field',I6,' not included in output - geometry failure')
 1032 FORMAT ('Field',I6,' included blc,trc',4I6)
      END
      SUBROUTINE FLTNHI (IN, OUT)
C-----------------------------------------------------------------------
C   Routine to write history file to output.
C   Inputs:
C      IN    C(*)*?   Input object
C      OUT   C*?      Output object
C-----------------------------------------------------------------------
      CHARACTER IN(*)*(*), OUT*(*)
C
      INTEGER   NADV
      PARAMETER (NADV=12)
      CHARACTER LIST(NADV)*8
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'NFIELD',
     *   'NMAPS', 'IMSIZE', 'REWEIGHT', 'DOWEIGHT', 'APARM', 'PBPARM',
     *   'NOISE'/
C-----------------------------------------------------------------------
C                                        Copy old history
      CALL OHCOPY (IN(1), OUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                        New additions - copy adverb
C                                        values.
      CALL OHLIST ('Input', LIST, NADV, OUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       copy tables
      CALL IMCALT (IN, OUT, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'ERROR COPYING TABLES'
         CALL MSGWRT (6)
         END IF
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // OUT
      CALL MSGWRT (6)
C
 999  RETURN
      END

LOCAL INCLUDE 'SHADW.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO,
     *   CATOLD(256), NUMHIS, JBUFSZ, ICODE
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOT(2)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, OPCODE*4,
     *   HISCRD(10)*64
      REAL      XSEQIN, XDISKI, XSEQO, XDISKO, BLC(7), TRC(7),
     *   CPARM(10), BUFF1(MABFSS), BUFF2(MABFSS)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XNAMOU, XCLAOT,
     *   XSEQO, XDISKO, BLC, TRC, CPARM
      COMMON /CHPARM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, OPCODE, HISCRD
      COMMON /PARMS/ CATOLD, SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO,
     *   OLDCNO, JBUFSZ, ICODE, NUMHIS
      COMMON /BUFRS/ BUFF1, BUFF2
LOCAL END
      PROGRAM SHADW
C-----------------------------------------------------------------------
C! Generate a "shadowed" map from a standard AIPS map.
C# Map-util Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2008, 2010, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SHADW generates a "shadowed" map from a standard AIPS map.
C   It was cloned from TAFFY.
C
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLAOUT        Class of the output image.
C                                   Default is input class.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      CPARM(10)      CPARM         User specified array.
C                                    1: sun's azimuth (deg)
C                                    2: sun's elevation (deg)
C                                    3: surface height scale factor
C                                    4: relative shade brightness
C
C     Author:
C          Mark Calabretta, Australia Telescope.
C          Origin; 1990/Sep/20. Code last modified; 1990/Sep/20
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'SHADW.INC'
      INCLUDE 'INCS:DCAT.INC'
C
      DATA PRGM /'SHADW '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL SHADIN (PRGM, IRET)
C                                       Call routine that sends data
C                                       to the user routine.
      IF (IRET.EQ.0) CALL SENDMA (IRET)
C                                       History
      IF (IRET.EQ.0) CALL SHADHI
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE SHADIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   SHADIN gets input parameters for SHADW and creates an output file.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      CHARACTER  STAT*4, MTYPE*2
      INTEGER   IERR, NPARM, IROUND
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'SHADW.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
C                                       Fixed PPM 1996.09.30: was 35
      NPARM = 38
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOT, CLAOUT)
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO = IROUND (XDISKO)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, 'READ', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Copy old CATBLK to new.
      CALL COPY (256, CATOLD, CATBLK)
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATOLD(KIDIM), CATOLD(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get user modification to CATBLK
C                                       Create output file.
      NEWCNO = 1
      IRET = 4
      CALL MCREAT (DISKO, NEWCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SHADIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1060 FORMAT ('SHADIN: ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE SENDMA (IRET)
C-----------------------------------------------------------------------
C   SENDMA sends image one row at a time to the user supplied
C   routine and then writes the modified data.
C   Output:
C      IRET   I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER IFILE*48
      INTEGER   IROUND, LUNI, LUNO, NYI, NXI, WINI(4), NXO, NYO,
     *   WINO(4), BOI, BOO, LIM2, LIM3, LIM4, LIM5, LIM6, LIM7, I1, I2,
     *   I3, I4, I5, I6, I7, IPOS(7), CORN(7), BOTEMP, KOFF, LIMO,
     *   LIMIT, IBIND, OBIND, INDI, INDO, LIM1, DIDRET, OUTCNT
      REAL      OUTMAX, OUTMIN
      LOGICAL   T, F, BLNKD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'SHADW.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI, LUNO /16,17/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.GT.1) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Setup for I/O
      NXI = CATOLD(KINAX)
      NYI = CATOLD(KINAX+1)
      NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      OUTMAX = -1.0E20
      OUTMIN = 1.0E20
      BLNKD = F
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
      KOFF = 0
      CORN(7) = 1
      LIMO = CATBLK(KINAX) - 1
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         CORN(7+KOFF) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            CORN(6+KOFF) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               CORN(5+KOFF) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  CORN(4+KOFF) = I4
                  DO 300 I3 = 1,LIM3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     CORN(3+KOFF) = I3
C                                       Init. files, first input.
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1099) IRET
            GO TO 990
            END IF
         BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'READ', IRET
            GO TO 990
            END IF
C                                       Init output file.
         IF (I3.LE.1) THEN
            CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORN(3), BOTEMP,
     *         IRET)
            BOO = BOTEMP + 1
            CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO, BUFF2,
     *         JBUFSZ, BOO, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1100) 'WRIT', IRET
               GO TO 990
               END IF
            END IF
         DIDRET = 0
         OUTCNT = NYO
         DO 220 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
C                                       Read.
            CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'READ', IRET
               GO TO 990
               END IF
C                                       Check for deferred output.
            IF (DIDRET.GE.0) THEN
               CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IRET)
               OBIND = OBIND - 1
               OUTCNT = OUTCNT - 1
               IF (OUTCNT.LT.0) THEN
                  WRITE (MSGTXT,1113)
                  GO TO 990
                  END IF
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1120) 'WRIT', IRET
                  GO TO 990
                  END IF
               END IF
C                                       Call DIDDLE
            IF (DIDRET.GE.0) OBIND = OBIND + 1
            CALL DIDDLE (IPOS, BUFF1(IBIND), BUFF2(OBIND), IRET)
            DIDRET = IRET
C                                       error
            IF (DIDRET.GT.0) THEN
               WRITE (MSGTXT,1180) IRET
               GO TO 990
C                                       Check max, min, blanking.
C                                       Check if output deferred.
            ELSE IF (DIDRET.EQ.0) THEN
               LIMIT = OBIND + LIMO
               DO 200 I1 = OBIND,LIMIT
                  IF (BUFF2(I1).NE.FBLANK) THEN
                     OUTMAX = MAX (OUTMAX, BUFF2(I1))
                     OUTMIN = MIN (OUTMIN, BUFF2(I1))
                  ELSE
                     BLNKD = .TRUE.
                     END IF
 200              CONTINUE
               END IF
 220        CONTINUE
C                                       Read out any remaining rows
C                                       from DIDDLE.
         DO 260 I2 = 1,OUTCNT
            IPOS(1) = -1
C                                       Check if write requested.
            CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IRET)
            OBIND = OBIND - 1
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'WRIT', IRET
               GO TO 990
               END IF
C                                       Call DIDDLE
            OBIND = OBIND + 1
            CALL DIDDLE (IPOS, BUFF1(IBIND), BUFF2(OBIND), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1180) IRET
               GO TO 990
               END IF
C                                       Check max, min, blanking.
            LIMIT = OBIND + LIMO
            DO 250 I1 = OBIND,LIMIT
               IF (BUFF2(I1).EQ.FBLANK) then
                  BLNKD = .TRUE.
               ELSE
                  OUTMAX = MAX (OUTMAX, BUFF2(I1))
                  OUTMIN = MIN (OUTMIN, BUFF2(I1))
                  END IF
 250           CONTINUE
 260        CONTINUE
C                                       Flush buffer.
         CALL MDISK ('FINI', LUNO, INDO, BUFF2, OBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1120) 'FINI', IRET
            GO TO 990
            END IF
C                                       Update CATBLK.
         CATR(KRDMX) = OUTMAX
         CATR(KRDMN) = OUTMIN
         CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', BUFF1,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1260) IRET
            GO TO 990
            END IF
 300     CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Mark blanking in CATBLK.
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
C                                       Close input map.
      CALL ZCLOSE (LUNI, INDI, IRET)
C                                       Final call to functions
      IPOS(1) = -2
      CALL DIDDLE (IPOS, BUFF1, BUFF2, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1180) IRET
         GO TO 990
         END IF
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SENDMA: ERROR',I3,' OPENING INPUT FILE')
 1020 FORMAT ('SENDMA: ERROR',I5,' OPENING OUTPUT FILE')
 1099 FORMAT ('SENDMA: COMOFF ERROR',I3)
 1100 FORMAT ('SENDMA: INIT-FOR-',A4,' ERROR',I3)
 1113 FORMAT ('SENDMA: OUTCNT.LT.0! Too many output rows returned.')
 1120 FORMAT ('SENDMA: ',A,' ERROR',I3)
 1180 FORMAT ('SENDMA: DIDDLE ERROR',I3)
 1260 FORMAT ('SENDMA: CATIO ERROR',I3,' UPDATING CATBLK')
      END
      SUBROUTINE SHADHI
C-----------------------------------------------------------------------
C   SHADHI copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER LABEL*8, LINE*80, NOTTYP*2
      INTEGER   LUN1, LUN2, IERR, I
      LOGICAL   T
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'SHADW.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NOTTYP /'CC'/
C-----------------------------------------------------------------------
C                                       copy some keywords
      CALL KEYPCP (DISKIN, OLDCNO, DISKO, NEWCNO, 0, ' ', IERR)
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       BLC
      WRITE (MSGTXT,2000) TSKNAM, BLC
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       TRC
      WRITE (MSGTXT,2001) TSKNAM, TRC
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any user supplied history.
      IF (NUMHIS.LE.0) GO TO 200
         WRITE (LABEL,1010) TSKNAM
         LINE(1:8) = LABEL(1:8)
         DO 50 I = 1,NUMHIS
            LINE(9:64) = HISCRD(I)(1:64)
            CALL HIADD (LUN2, LINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (1, NOTTYP, LUN1, LUN2, DISKIN, DISKO, OLDCNO,
     *   NEWCNO, CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SHADHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,' /')
 2000 FORMAT (A6,' BLC =',6(F6.0,','),F6.0)
 2001 FORMAT (A6,' TRC =',6(F6.0,','),F6.0)
      END
      SUBROUTINE DIDDLE (IPOS, DATA, RESULT, IRET)
C-----------------------------------------------------------------------
C   Inputs:
C      IPOS   I(7)    BLC (input image) of first value in DATA
C                     IPOS(1) = -1 => no input data this call.
C                     IPOS(2) = -2 => last call (no input data).
C      DATA   R(*)    Input row, magic value blanked.
C   Values from commons:
C      ICODE   I      Opcode number from list in NEWHED.
C      FBLANK  R      Value of blanked pixel.
C      CPARM   R(10)  Input adverb array.
C      CATBLK  I      Output catalog header (also CATR, CATD)
C      CATOLD  I      Input catalog header
C   Output:
C      RESULT  R(*)   Output row.
C      IRET    I      Return code   0 => OK
C                                  >0 => error, terminate.
C   Output in COMMON:
C     NUMHIS  I          # history entries (max. 10)
C     HISCRD  C(NUMHIS)  History records
C     CATBLK  I          Catalog header block
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), IRET
      REAL      DATA(*), RESULT(*)
C
      LOGICAL   DOIT
      INTEGER   NDX, NX, NY
      REAL      MAP(1048575)
      SAVE NX, NY, NDX, DOIT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'SHADW.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (IPOS(1).LE.-2) THEN
C        Last call (no input data).
      ELSE IF (IPOS(1).EQ.-1) THEN
C        Send back the results a row at a time.
         IF (DOIT) THEN
C           First time through, do the shadowing.
            CALL SHADOW (NX, NY, MAP)
            NDX = 1
            DOIT = .FALSE.
            END IF
C
         CALL RCOPY (NX, MAP(NDX), RESULT)
         NDX = NDX + NX
      ELSE
         IF (IPOS(2).EQ.1) THEN
C           First call for this plane, set length of a row.
            NX = CATBLK(KINAX)
            NY = CATBLK(KINAX+1)
            NDX  = 1
            DOIT = .TRUE.
            END IF
C                                       Accumulate rows of the input map
         CALL RCOPY (NX, DATA, MAP(NDX))
         NDX = NDX + NX
         IRET = -1
         END IF
C
      RETURN
      END
      SUBROUTINE SHADOW (NX, NY, MAP)
C-----------------------------------------------------------------------
C     SHADOW interprets the input map as a three dimensional surface
C     upon which the sun shines, casting shadows.
C
C     Given:
C          NX,NY       I     Map dimensions.
C
C     Given via common INPARM:
C          CPARM(1)    R     Input adverb array.
C                              1) sun's azimuth (deg)
C                              2) sun's elevation (deg)
C                              3) surface height scale factor
C                              4) relative shade brightness
C
C     Given via common MAPHDR:
C          CATR(256)   R     Input map header.
C
C     Given and returned:
C          MAP(NX,NY)  R     The input map.  On return contains the
C                            shadowed representation of the map.
C
C     Called:
C          SHADW: {ILLUM}
C
C     Algorithm:
C          MAP(X,Y) is dissected and loaded into an array BAND(U,V)
C          with rotation by an integral multiple of 90 degrees so that
C          that the sun shines from within 45 degrees of the +V
C          direction.
C
C     Notes:
C       1) Can handle an input map of up to MAXIMG pixels on a side.
C
C     Author:
C          Mark Calabretta, Australia Telescope.
C          Origin; 1990/Sep/20. Code last modified; 1990/Sep/20
C
C-----------------------------------------------------------------------
      INCLUDE 'SHADW.INC'
      INTEGER  IQUAD, IV, IX, IY, NV, NX, NY
      REAL     BAND(-1:1,0:4097), D2R, DARK, DV, DW, SCL, MAP(NX,NY),
     *   SCLFCT, SHDW(MAXIMG), SOLAZ, SOLEL, SS(MAXIMG), US, VS, WS
C
      PARAMETER (D2R = 3.14159265358/180.0)
C
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       Get input parameters
      SOLAZ  = CPARM(1)
      SOLEL  = CPARM(2)
      SCLFCT = CPARM(3)
      DARK   = CPARM(4)
      SOLAZ = MOD (SOLAZ, 360.0)
      IF (SOLAZ.LT.0.0)  SOLAZ  = SOLAZ + 360.0
      IF (SOLEL.LE.0.0)  SOLEL  = 45.0
      IF (SOLEL.GT.90.0) SOLEL  = 90.0
      IF (SCLFCT.EQ.0.0) SCLFCT = 100.0
      IF (DARK.EQ.0.0)   DARK   = 0.75
C                                       Replace blanks with zeroes and
C                                       scale the pixel heights
      SCL = SCLFCT/CATR(KRDMX)
      DO 20 IY = 1, NY
         DO 10 IX = 1, NX
            IF (MAP(IX,IY).EQ.FBLANK) MAP(IX,IY) = 0.0
            MAP(IX,IY) = SCL*MAP(IX,IY)
 10         CONTINUE
 20      CONTINUE
C                                       Determine the solar quadrant
      IQUAD = INT((SOLAZ+45.0)/90.0)
      IQUAD = MOD(IQUAD,4) + 1
      IF (SOLAZ.EQ.45.0)  IQUAD = 1
      IF (SOLAZ.EQ.225.0) IQUAD = 3
      SOLAZ = SOLAZ - (IQUAD-1)*90.0
C                                       Number of pixels on the side
C                                       facing the sun
      IF (IQUAD.EQ.1) NV = NX
      IF (IQUAD.EQ.2) NV = NY
      IF (IQUAD.EQ.3) NV = NX
      IF (IQUAD.EQ.4) NV = NY
C                                       Components of the unit vector in
C                                       the direction of the sun
      US = COS(SOLAZ*D2R)*COS(SOLEL*D2R)
      VS = SIN(SOLAZ*D2R)*COS(SOLEL*D2R)
      WS = SIN(SOLEL*D2R)
C                                       Shadow decrement between image
C                                       rows (DU = -1.0)
      DV = TAN(SOLAZ*D2R)
      DW = TAN(SOLEL*D2R)/SCL
C                                       Initial shadow line
      DO 30 IV = 1, NV
         SHDW(IV) = -1.0E30
 30      CONTINUE
C                                       Do it for the particular
C                                       quadrant
      IF (IQUAD.EQ.1) THEN
C                                       Sunshine from the bottom quarter
         DO 150 IY = 1, NY
            IX = 0
            IF (IY.EQ.1) THEN
               DO 110 IV = 1, NV
                  IX = IX + 1
                  BAND(1,IV)  = 2.0*MAP(IX,1) - MAP(IX,2)
                  BAND(0,IV)  = MAP(IX,1)
                  BAND(-1,IV) = MAP(IX,2)
 110              CONTINUE
            ELSE IF (IY.EQ.NY) THEN
               DO 120 IV = 1, NV
                  IX = IX + 1
                  BAND(1,IV)  = BAND(0,IV)
                  BAND(0,IV)  = BAND(-1,IV)
                  BAND(-1,IV) = 2.0*MAP(IX,NY) - MAP(IX,NY-1)
 120              CONTINUE
            ELSE
               DO 130 IV = 1, NV
                  IX = IX + 1
                  BAND(1,IV)  = BAND(0,IV)
                  BAND(0,IV)  = BAND(-1,IV)
                  BAND(-1,IV) = MAP(IX,IY+1)
 130              CONTINUE
               END IF
C
            CALL ILLUM (DARK, US, VS, WS, DV, DW, NV, BAND, SHDW, SS)
C
            IX = 0
            DO 140 IV = 1, NV
               IX = IX + 1
               MAP(IX,IY) = SS(IV)
 140           CONTINUE
 150        CONTINUE
C
      ELSE IF (IQUAD.EQ.2) THEN
C                                       Sunshine from the right quarter
         DO 250 IX = NX, 1, -1
            IY = 0
            IF (IX.EQ.NX) THEN
               DO 210 IV = 1, NV
                  IY = IY + 1
                  BAND(1,IV)  = 2.0*MAP(NX,IY) - MAP(NX-1,NY)
                  BAND(0,IV)  = MAP(NX,IY)
                  BAND(-1,IV) = MAP(NX-1,IY)
 210              CONTINUE
            ELSE IF (IX.EQ.1) THEN
               DO 220 IV = 1, NV
                  IY = IY + 1
                  BAND(1,IV)  = BAND(0,IV)
                  BAND(0,IV)  = BAND(-1,IV)
                  BAND(-1,IV) = 2.0*MAP(1,IY) - MAP(2,IY)
 220              CONTINUE
            ELSE
               DO 230 IV = 1, NV
                  IY = IY + 1
                  BAND(1,IV)  = BAND(0,IV)
                  BAND(0,IV)  = BAND(-1,IV)
                  BAND(-1,IV) = MAP(IX-1,IY)
 230              CONTINUE
               END IF
C
            CALL ILLUM (DARK, US, VS, WS, DV, DW, NV, BAND, SHDW, SS)
C
            IY = 0
            DO 240 IV = 1, NV
               IY = IY + 1
               MAP(IX,IY) = SS(IV)
 240           CONTINUE
 250        CONTINUE
C
      ELSE IF (IQUAD.EQ.3) THEN
C                                       Sunshine from the top quarter
         DO 350 IY = NY, 1, -1
            IX = NX + 1
            IF (IY.EQ.NY) THEN
               DO 310 IV = 1, NV
                  IX = IX - 1
                  BAND(1,IV)  = 2.0*MAP(IX,NY) - MAP(IX,NY-1)
                  BAND(0,IV)  = MAP(IX,NY)
                  BAND(-1,IV) = MAP(IX,NY-1)
 310              CONTINUE
            ELSE IF (IY.EQ.1) THEN
               DO 320 IV = 1, NV
                  IX = IX - 1
                  BAND(1,IV)  = BAND(0,IV)
                  BAND(0,IV)  = BAND(-1,IV)
                  BAND(-1,IV) = 2.0*MAP(IX,1) - MAP(IX,2)
 320              CONTINUE
            ELSE
               DO 330 IV = 1, NV
                  IX = IX - 1
                  BAND(1,IV)  = BAND(0,IV)
                  BAND(0,IV)  = BAND(-1,IV)
                  BAND(-1,IV) = MAP(IX,IY-1)
 330              CONTINUE
               END IF
C
            CALL ILLUM (DARK, US, VS, WS, DV, DW, NV, BAND, SHDW, SS)
C
            IX = NX + 1
            DO 340 IV = 1, NV
               IX = IX - 1
               MAP(IX,IY) = SS(IV)
 340           CONTINUE
 350        CONTINUE
C
      ELSE IF (IQUAD.EQ.4) THEN
C                                       Sunshine from the left quarter
         DO 450 IX = 1, NX
            IY = NY + 1
            IF (IX.EQ.1) THEN
               DO 410 IV = 1, NV
                  IY = IY - 1
                  BAND(1,IV)  = 2.0*MAP(1,IY) - MAP(2,IY)
                  BAND(0,IV)  = MAP(1,IY)
                  BAND(-1,IV) = MAP(2,IY)
 410              CONTINUE
            ELSE IF (IX.EQ.NX) THEN
               DO 420 IV = 1, NV
                  IY = IY - 1
                  BAND(1,IV)  = BAND(0,IV)
                  BAND(0,IV)  = BAND(-1,IV)
                  BAND(-1,IV) = 2.0*MAP(NX,IY) - MAP(NX-1,IY)
 420              CONTINUE
            ELSE
               DO 430 IV = 1, NV
                  IY = IY - 1
                  BAND(1,IV)  = BAND(0,IV)
                  BAND(0,IV)  = BAND(-1,IV)
                  BAND(-1,IV) = MAP(IX+1,IY)
 430              CONTINUE
               END IF
C
            CALL ILLUM (DARK, US, VS, WS, DV, DW, NV, BAND, SHDW, SS)
C
            IY = NY + 1
            DO 440 IV = 1, NV
               IY = IY - 1
               MAP(IX,IY) = SS(IV)
 440           CONTINUE
 450        CONTINUE
         END IF
C
      RETURN
      END
      SUBROUTINE ILLUM (DARK, US, VS, WS, DV, DW, NV, BAND, SHDW, SS)
C-----------------------------------------------------------------------
C     ILLUM applies the illumination / shadowing algorithm.
C
C     Given:
C          DARK        R     Factor by which to reduce the brightness in
C                            shadowed areas.
C                              = 0.0 gives pitch black shadows
C                              = 1.0 gives no shadows
C          US,VS,WS    R     Components of the unit vector towards the
C                            sun in the (U,V,W) coordinate system.
C          DV,DW       R     Shadow falloff in V and W for DU = -1.0
C          NV          R     Number of pixels in the V-direction.
C
C     Given and returned:
C          BAND(,)     R     Input band of pixels dimensioned as
C                            BAND(-1:1,0:NV+1).  The locations at
C                            IV=0, and IV=NV+1 are for extrapolation
C                            and will be modified.
C          SHDW(NV)    R     Array containing the shadow height.
C
C     Returned:
C          SS(NV)      R     The surface brightness.
C
C     Called:
C          none
C
C     Algorithm:
C          Coordinates are expressed in terms of (U,V,W) and the sun is
C          assumed to lie within 45 degrees of the +V direction.
C          The dot product of the unit vector in the direction of the
C          sun and the unit vector normal to the surface is calculated
C          at each pixel.  The result is normalized to lie in the range
C          0 (black), to 1 (white), and then squared to simulate a
C          cosine reflectivity law.
C
C     Notes:
C       1)
C
C     Author:
C          Mark Calabretta, Australia Telescope.
C          Origin; 1990/Sep/20. Code last modified; 1990/Sep/20
C
C-----------------------------------------------------------------------
      INTEGER  IU, IV, NV
      REAL     BU, BV, DARK, DV, DW, NS, S, SHDW(NV), SS(NV), UN, US,
     :         BAND(-1:1,0:NV+1), VN, VS, WN, WS
C-----------------------------------------------------------------------
C                                       Extrapolate
      DO 10 IU = -1, 1
         BAND(IU,0)    = 2.0*BAND(IU,1)  - BAND(IU,2)
         BAND(IU,NV+1) = 2.0*BAND(IU,NV) - BAND(IU,NV-1)
 10      CONTINUE
C
      DO 20 IV = 1, NV
C                                       Compute derivatives in U and V
C                                       at the pixel, quadratic fit
         BU = (BAND(1,IV)   - BAND(-1,IV))/2.0
         BV = (BAND(0,IV+1) - BAND(0,IV-1))/2.0
C                                       Unit vector normal to the
C                                       surface
         S  = SQRT(BU*BU + BV*BV + 1.0)
         UN = -BU/S
         VN = -BV/S
         WN = 1.0/S
C                                       Compute the vector dot product
         NS = UN*US + VN*VS + WN*WS
C                                       Compute the light value
         SS(IV) = ((NS + 1.0)/2.0)**2
 20      CONTINUE
C
      DO 30 IV = 1, NV
         IF (BAND(0,IV).GE.SHDW(IV)) THEN
C                                       Sunlight
            SHDW(IV) = BAND(0,IV)
         ELSE
C                                       Shadow
            SS(IV) = DARK*SS(IV)
            END IF
 30      CONTINUE
C                                       Decrement the shadow line
      DO 40 IV = 1, NV
         SHDW(IV) = SHDW(IV) - DW
 40      CONTINUE
C                                       Shift the shadow line in V
      IF (DV.LT.0.0) THEN
         DO 50 IV = NV, 2, -1
            SHDW(IV) = (1.0 + DV)*SHDW(IV) - DV*SHDW(IV-1)
 50         CONTINUE
         SHDW(1) = 0.0
C
      ELSE IF (DV.GT.0.0) THEN
         DO 60 IV = 1, NV-1
            SHDW(IV) = (1.0 - DV)*SHDW(IV) + DV*SHDW(IV+1)
 60         CONTINUE
         SHDW(NV) = 0.0
         END IF
C
      RETURN
      END

      SUBROUTINE POLINO(ARG, FUNC, NFIT, NEQUAT, FITPAR, VARRES, IRET)
C-----------------------------------------------------------------------
C! Fit a polinom to the given data
C# math
C-----------------------------------------------------------------------
C;  Copyright (C) 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to fit a polinomial to the data by Least Square method
C   Input:
C      ARG     R(*)  Array of data arguments
C      FUNC    R(*)  Array of data function
C      NFIT    I     Number of parameters to fit, equaled the polinom
C                    degree + 1
C      NEQUAT  I     Number of points at arrays ARG, FUNC
C   Output:
C      FITPAR  R(*)  Array of found fitting polinom's coefficients
C      VARRES  R     SQRT of residuals
C      IRET    I     Error; 0 => OK
C-----------------------------------------------------------------------
      INTEGER NFIT, NEQUAT, IRET
      REAL    ARG(*), FUNC(*), VARRES, FITPAR(*)
      INTEGER   I, IFIT, KFIT, IKFIT
      REAL      R(20), MATR(400), NOBS, SUM, SSQ,
     *   VX(20), SSQRES, VARY, FIT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (NFIT .GT. 20) THEN
         IRET = 1
         WRITE (MSGTXT,1000) NFIT
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Force result vector R(NFIT),
C                                       matrix M(NFIT*NFIT) to zero
      DO 20 IFIT = 1, NFIT
         R(IFIT) = 0.0
         DO 10 KFIT = 1, NFIT
            IKFIT = IFIT + (KFIT - 1)*NFIT
            MATR (IKFIT) = 0.0
 10         CONTINUE
 20      CONTINUE
      SUM = 0.0
      SSQ = 0.0
      NOBS = 0.0
C                                       Prepare result vector R(NFIT)
C                                       and matrix MATR(NFIT*NFIT)
C                                       for routine LEASQR
      DO 80 I = 1, NEQUAT
         NOBS = NOBS + 1
         SUM = SUM + FUNC(I)
         SSQ = SSQ + FUNC(I)*FUNC(I)
C
         DO 60 IFIT = 1, NFIT
            R(IFIT) = R(IFIT) + FUNC(I) * (ARG(I) ** (IFIT - 1))
C                                       calculate upper/right
C                                       triangle of MATR
            DO 40 KFIT = IFIT, NFIT
               IKFIT = IFIT + (KFIT-1)*NFIT
               MATR(IKFIT) = MATR(IKFIT) +
     *            (ARG(I) ** (IFIT - 1)) * (ARG(I) ** (KFIT - 1))
   40          CONTINUE
   60       CONTINUE
 80      CONTINUE
C
      CALL LEASQR (NFIT, NOBS, SUM, SSQ, R, MATR, FITPAR, VX, SSQRES,
     *   VARRES, VARY, FIT, IRET)
      VARRES = SQRT(VARRES)
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('POLINO: The number of fitting parameters ', I4,
     *   ' exceeds 20')
      END

      SUBROUTINE YOFM (OP, COLOR, VRTRTC, OFM, IERR)
C-----------------------------------------------------------------------
C! read/write all-channel look-up-table ("output function memory")
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YOFM reads/writes full OFM look up tables to TV.
C   Inputs:
C      OP      C*4    'READ' from TV, 'WRIT' to TV
C      COLOR   I      color select bit mask (RGB <-> 421)
C      VRTRTC  L      T => do it only during vertical retrace
C   In/Out:
C      OFM     R(*)   look up table (dimension = OFMINP+1, values 0
C                     through 1 are used, others clipped)
C   Output:
C      IERR    I      error code of Z...XF : 0 => ok, 2 => input error
C   Modified NOV-83 for DeAnza by W. Jaffe; corrected EWG 12/85.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   COLOR, IERR
      REAL      OFM(*)
      LOGICAL   VRTRTC
C
      INTEGER   CA, NB, I, AG1, VOCN, VOCLUT, LUTADR, ICOL, MOD, LCOL,
     *   LOFM(512)
      REAL      TEMP, GAMINV
      LOGICAL   ON, T
      INCLUDE 'INCS:DTVC.INC'
      DATA T /.TRUE./
C                                Output LUT is byte array group # 1
C                                We only use VOC number 0
C                                VOC LUT address in VOC register #3
      DATA NB, AG1, VOCN, VOCLUT, LUTADR /1024, 1, 0, 3, 0/
C-----------------------------------------------------------------------
C                                       Update all 3 colors
      IF (OP.EQ.'WRIT') THEN
         GAMINV = 1.0
         IF (TVGAMA.GT.0.0001) GAMINV = 1.0 / TVGAMA
         DO 10 I = 1,256
             TEMP = MAX (0.0, MIN (1.0, OFM(I)))
             LOFM(I) = (TEMP ** GAMINV) * 255.0 + 0.025
 10          CONTINUE
C                                       Zero 2nd LUT section
         CALL FILL (256, 0, LOFM(257))
         LCOL = COLOR
         DO 15 ICOL = 1,3
            ON = (MOD(LCOL, 2).NE.0)
            LCOL = LCOL / 2
            IF (ON) THEN
C                                       Zero LUT address in VOC
               CALL ZDEAXF ('LVR ', LUTADR, 2, VOCN, VOCLUT, T, IERR)
               IF (IERR.NE.0) GO TO 999
C                                       Set channel address to
C                                       match color
               CA = 3 - ICOL
               CALL ZDEAXF ('LPA ', LOFM, NB, CA, AG1, T, IERR)
               IF (IERR.NE.0) GO TO 999
               END IF
 15         CONTINUE
C                                       Read opcode
      ELSE IF (OP.EQ.'READ') THEN
         LCOL = COLOR
C                                       Can only read 1 color, 1st on
         DO 20 ICOL = 1,3
            ON = (MOD(LCOL, 2).NE.0)
            LCOL = LCOL / 2
            IF (ON) THEN
C                                       Set LUT address
               CALL ZDEAXF ('LVR ', LUTADR, 2, VOCN, VOCLUT, T, IERR)
               IF (IERR.NE.0) GO TO 999
               CA = 3 - ICOL
               CALL ZDEAXF ('RPA ', LOFM, NB, CA, AG1, T, IERR)
               IF (IERR.NE.0) GO TO 999
               GO TO 30
               END IF
 20         CONTINUE
C                                       Move to output buffer
 30      DO 40 I = 1,256
           TEMP = (LOFM(I) / 255.0) ** TVGAMA
           OFM(I) = MAX (0.0, MIN (1.0, TEMP))
 40        CONTINUE
      ELSE
         IERR = 2
         END IF
C
 999  RETURN
      END

      SUBROUTINE EVTHDR (LOPCOD, LEVENT, VERS, IBUF, NBUF, NBYTES,
     *   IRET)
C-----------------------------------------------------------------------
C! Encode/decode an AIPS XDR event header containing name and vers. no.
C# IO-remote
C-----------------------------------------------------------------------
C;  Copyright (C) 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Encode/decode an XDR AIPS event header containing event name
C   and version number.
C   Inputs:
C      LOPCOD     C*6     Opcode ('ENCODE' or 'DECODE')
C   Input/output:
C      LEVENT     C*8     Event name
C      VERS       R       Event version number.
C      IBUF       I(*)    XDR buffer
C      NBUF       I       Dimension of IBUF
C   Output:
C      NBYTES     I       Current XDR byte offset in IBUF
C      IRET       I       Return code (0=> ok; else error)
C-----------------------------------------------------------------------
      CHARACTER LOPCOD*6, LEVENT*8
      REAL      VERS
      INTEGER   NBUF, NBYTES, IRET
      INTEGER   IBUF(NBUF)
C
      CHARACTER LOPT(2)*6
      INTEGER   IERR, IOPT, NLEN, JTRIM
      INCLUDE 'INCS:DMSG.INC'
      DATA LOPT /'ENCODE', 'DECODE'/
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C                                       Encode or decode ?
      IF (LOPCOD.EQ.'ENCODE') THEN
         IOPT = 1
      ELSE
         IOPT = 2
         END IF
C                                       Encode or decode event name
      NBYTES = 0
      IF (IOPT.EQ.1) NLEN = JTRIM (LEVENT)
      IF (IOPT.EQ.2) NLEN = 8
      CALL ZXDRST (LOPT(IOPT), LEVENT, NLEN, IBUF, NBUF, NBYTES, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1050) IERR, LOPT(IOPT)
         GO TO 990
         END IF
C                                       Encode or decode version number
      NLEN = 1
      CALL ZXDRFP (LOPT(IOPT), VERS, NLEN, IBUF, NBUF, NBYTES, IERR)
      IF (IERR.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1100) IERR, LOPT(IOPT)
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C                                       Exit
 999  RETURN
C----------------------------------------------------------------------
1050  FORMAT ('EVTHDR: ERROR',I4,' IN EVENT NAME ',A6)
1100  FORMAT ('EVTHDR: ERROR',I4,' IN VERSION NO. ',A6)
      END

      SUBROUTINE REFCNT (ISUB, NUMIF, NUMANT, SUBKOL, WT1KOL, WT2KOL,
     *   RF1KOL, RF2KOL, BUFFER, ANTUSE, IERR)
C-----------------------------------------------------------------------
C! Counts reference antenna usage in an SN table.
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to determine antenna usage as the reference antenna in an
C   open SN table.  All IFs are examined.
C   All valid entries are included.
C   Inputs:
C      ISUB     I  Subarray number, 0=>1
C      NUMIF    I  Number of IFs
C      NUMANT   I  Maximum antenna number.
C      SUBKOL   I  Subarray column pointer.
C      WT1KOL   I  Weight 1 column pointer.
C      WT2KOL   I  Weight 2 column pointer <1 => not present
C      RF1KOL   I  Reference antenna 1 pointer
C      RF2KOL   I  Reference antenna 2 pointer <1 => not present
C   Input/Output:
C      BUFFER   I(*) Table I/O buffer
C   Output:
C      ANTUSE   I(*) Count per antenna of uses as reference antenna.
C      IERR     I  Error code, 0=OK else failed.
C-----------------------------------------------------------------------
      INTEGER   ISUB, NUMIF, NUMANT, SUBKOL, WT1KOL, WT2KOL, RF1KOL,
     *   RF2KOL, BUFFER(*), ANTUSE(NUMANT), IERR
C
      INTEGER   LOOPR, IRCODE, IIF, IREF, NUMREC, SUB, SA
      INTEGER   RECORD(1024)
      REAL      RECR(1024)
      DOUBLE PRECISION RECD(512)
      EQUIVALENCE (RECORD, RECR, RECD)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA IRCODE /0/
C-----------------------------------------------------------------------
      CALL FILL (NUMANT, 0, ANTUSE)
      NUMREC = BUFFER(5)
      SUB = MAX (1, ISUB)
      DO 20 LOOPR = 1,NUMREC
         CALL TABIO ('READ', IRCODE, LOOPR, RECORD, BUFFER, IERR)
         IF (IERR.LT.0) GO TO 20
         IF (IERR.NE.0) GO TO 900
C                                       Right subarray?
         SA = RECORD(SUBKOL)
         IF ((SA.NE.SUB) .AND. (SA.GT.0)) GO TO 20
C                                       Loop over IFs
            DO 10 IIF = 1,NUMIF
               IF (RECR(WT1KOL+IIF-1).GT.0.0) THEN
                  IREF = RECORD(RF1KOL+IIF-1)
                  IF ((IREF.GT.0) .AND. (IREF.LE.NUMANT))
     *               ANTUSE(IREF) = ANTUSE(IREF) + 1
                  END IF
               IF ((WT2KOL.GT.0) .AND. (RECR(WT2KOL+IIF-1).GT.0.0))
     *            THEN
                  IREF = RECORD(RF2KOL+IIF-1)
                  IF ((IREF.GT.0) .AND. (IREF.LE.NUMANT))
     *               ANTUSE(IREF) = ANTUSE(IREF) + 1
                  END IF
 10            CONTINUE
 20         CONTINUE
      IERR = 0
      GO TO 999
C                                       TABIO error
 900  WRITE (MSGTXT,1900) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('REFCNT: TABIO ERROR',I3,' COUNTING REFERENCE ANTENNAS')
      END

      SUBROUTINE UVDPAD (DISK, CNOSCR, ISCR2, JBUFSZ, BUFF1, BUFF2,
     *   IRET)
C-----------------------------------------------------------------------
C! Reformat UV data record, doubling size and zero extra words.
C# UV Modeling IO-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   UVDPAD reformats the uv data in the input file by doubling the
C   visibility portion with zero fill of the upper half.  Model values
C   can then be computed and subsequently divided into the observed
C   values by UVDOUT.  The values in /UVHDR/ common (filled by UVPGET)
C   are assumed valid for the input file.  If disk .LE. 0 then CNOSCR
C   is assumed to be the /CFILES/ scratch file number.  Uses LUNs 24
C   and 25 which must not already be in use.
C      If the scratch file ISCR2 does not exist (denoted by ISCR2 .LE.
C   0) then it will be created and entered into /CFILES/ so that it can
C   be destroyed by DIE.
C   Inputs:
C      DISK     I      Disk number for catalogd input file. If .LE. 0
C                      then the input file is a /CFILES/ scratch file.
C      CNOSCR   I      Catalog slot number for if catalogd file;
C                      /CFILES/ scratch file number if a scratch file,
C      ISCR2    I      /CFILES/ number of scratch file for output,
C                      If .LE. 0 then the file will be created.
C      JBUFSZ   I      The size of BUFF1 and BUFF2 in bytes.
C   Inputs from common /UVHDR/:
C      LREC     I      Length of visibility record in R   words.
C      NRPARM   I      Number of random parameters (R   words)
C      NVIS     I      Number of visibilities
C   Output:
C      BUFF1    R(*)   Work buffers
C      BUFF2    R(*)   Work buffers
C      ISCR2    I      /CFILES/ number of output scratch file.
C      IRET     I      Return code, 0 => OK, otherwise failed.
C-----------------------------------------------------------------------
      INTEGER   DISK, CNOSCR, ISCR2, JBUFSZ, IRET
      REAL      BUFF1(*), BUFF2(*)
C
      CHARACTER NAME*48
      INTEGER   VOL, LUNI, LUNO, FINDI, FINDO, BINDI, BINDO, LENBI,
     *   LENBO, INIO, ONIO, LRECO, OCNT, ILOOP, NZERO, BO, VO, ISIZE,
     *   LRECUN, UNPARM, ILOCWT
      LOGICAL   T, F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSCD.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA LUNI, LUNO, BO, VO /24,25, 1,0/
C-----------------------------------------------------------------------
      IRET = 0
C                                       Set input file name.
      IF (DISK.LE.0) THEN
         VOL = SCRVOL(CNOSCR)
         CALL ZPHFIL ('SC', VOL, SCRCNO(CNOSCR), 1, NAME, IRET)
      ELSE
         VOL = DISK
         CALL ZPHFIL ('UV', VOL, CNOSCR, 1, NAME, IRET)
         END IF
C                                       Open input file.
      CALL ZOPEN (LUNI, FINDI, VOL, NAME, T, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) 'READ', IRET
         GO TO 990
         END IF
C                                       Setup to init I/O, determine
C                                       size.
      LENBI = 0
      CALL UVINIT ('READ', LUNI, FINDI, NVIS, VO, LREC, LENBI, JBUFSZ,
     *   BUFF1, BO, BINDI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) 'READ', IRET
         GO TO 990
         END IF
C                                       If compressed, what would
C                                       uncompressed size be?
      LRECUN = LREC
      UNPARM = NRPARM
      IF (COMPDT) THEN
         CALL AXEFND (8, 'WEIGHT  ', SCRCAT(KIPCN), SCRHOL(KHPTP),
     *      ILOCWT, IRET)
         IF ((IRET.NE.0) .OR. (ILOCWT.LT.0)) THEN
            IRET = 1
            MSGTXT = 'UVDPAD: CANNOT FIND WEIGHT/SCALE FOR COMPRESSED'
     *         // ' DATA'
            GO TO 990
            END IF
         LRECUN = LREC - NRPARM
         LRECUN = LRECUN * 3
         LRECUN = LRECUN + NRPARM - 2
         UNPARM = NRPARM - 2
C                                       Update SCRHDR data
         SCLREC = 2 * LRECUN - UNPARM
         SCRPRM = LRECUN
         SCRCAT(KINAX) = SCRCAT(KINAX) * 3
         END IF
C                                       Check if scratch file exists,
C                                       if not create it.
      IF (ISCR2.LE.0) THEN
C                                       Create scratch file.
C                                       Must be uncompressed
         CALL UVSIZE ((LRECUN*2 - UNPARM), NVIS, ISIZE)
         CALL SCREAT (ISIZE, BUFF2, IRET)
         ISCR2 = NSCR
         IF (IRET.NE.0) THEN
            IF (IRET.EQ.1) WRITE (MSGTXT,1020)
            IF (IRET.GT.1) WRITE (MSGTXT,1021) IRET
            GO TO 990
            END IF
         END IF
C                                       Open output file.
      CALL ZPHFIL ('SC', SCRVOL(ISCR2), SCRCNO(ISCR2), 1, NAME, IRET)
      CALL ZOPEN (LUNO, FINDO, SCRVOL(ISCR2), NAME, T, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) 'WRIT', IRET
         GO TO 990
         END IF
C                                       Setup for init.
      LRECO = 2 * LRECUN - UNPARM
      LENBO = 0
      CALL UVINIT ('WRIT', LUNO, FINDO, NVIS, VO, LRECO, LENBO, JBUFSZ,
     *   BUFF2, BO, BINDO, IRET)
      OCNT = 0
      ONIO = LENBO
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) 'WRIT', IRET
         GO TO 990
         END IF
C                                       Set up for reformatting.
      NZERO = LRECUN - UNPARM
C                                       Begin loop
 100     CALL UVDISK ('READ', LUNI, FINDI, BUFF1, INIO, BINDI, IRET)
         IF (INIO.LE.0) GO TO 250
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'READ', IRET
            GO TO 990
            END IF
C                                       Loop copying to output, zero
C                                       padding.
         DO 200 ILOOP = 1,INIO
            IF (COMPDT) THEN
               CALL RCOPY (UNPARM, BUFF1(BINDI), BUFF2(BINDO))
               CALL ZUVXPN ((LREC-NRPARM), BUFF1(BINDI+NRPARM),
     *            BUFF1(BINDI+ILOCWT), BUFF2(BINDO+UNPARM))
            ELSE
               CALL RCOPY (LREC, BUFF1(BINDI), BUFF2(BINDO))
               END IF
C                                       Zero fill upper portion.
            CALL RFILL (NZERO, 0.0, BUFF2(BINDO+LRECUN))
C                                       Update pointers.
            BINDI = BINDI + LREC
            BINDO = BINDO + LRECO
C                                       Check if time for output.
            OCNT = OCNT + 1
C                                       Write
            IF (OCNT.GE.ONIO) THEN
               ONIO = OCNT
               CALL UVDISK ('WRIT', LUNO, FINDO, BUFF2, ONIO, BINDO,
     *            IRET)
               OCNT = 0
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1100) 'WRIT', IRET
                  GO TO 990
                  END IF
               END IF
 200        CONTINUE
C                                       Loop back for more.
         GO TO 100
C                                       Done - flush output buffer.
 250  ONIO = -OCNT
      CALL UVDISK ('FLSH', LUNO, FINDO, BUFF2, ONIO, BINDO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) 'FLSH', IRET
         GO TO 990
         END IF
C                                       Close files.
      CALL ZCLOSE (LUNI, FINDI, IRET)
      CALL ZCLOSE (LUNO, FINDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVDPAD: OPEN FOR ',A4,' ERROR ',I5)
 1010 FORMAT ('UVDPAD: INIT FOR ',A4,' ERROR ',I5)
 1020 FORMAT ('UVDPAD: TOO LITTLE DISK SPACE FOR SCRATCH FILE')
 1021 FORMAT ('UVDPAD: ERROR ',I5,' CREATING SCRATCH FILE')
 1100 FORMAT ('UVDPAD: ',A4,' ERROR ',I5)
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QBOXSU (A, I, NB, C, J, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Boxcar sum of a vector.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo AP version.
C   QBOXSU does a boxcar sum of a vector, returns constant values in
C   first and last half boxcar width.
C   Inputs:
C      A   I  input vector base address
C      I   I  input vector increment
C      NB  I  boxcar width
C      C   I  output vector base address; output vector should not
C             overlap input.
C      J   I  output increment
C      N   I  element count
C-----------------------------------------------------------------------
      INTEGER   A, I, II, IJ, IODD, NB, C, J, N, JA, JC, ITEMP
      REAL      SUM
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                       Convert to 1-rel. addresses
      JA = A + 1
      JC = C + 1
C                                       Sum first section.
      IODD = MOD (NB, 2)
      SUM = 0.0
C@DIR IGNORE RECRDEPS(APCORE)
      DO 10 II = 1,NB
         SUM = SUM + APCORE(JA)
         JA = JA + I
 10      CONTINUE
C                                       Set output for first section.
      ITEMP = NB / 2
      IJ = MAX (1, ITEMP)
      DO 20 II = 1,IJ
         APCORE(JC) = SUM
         JC = JC + J
 20      CONTINUE
C                                       Loop through middle.
      IJ = N - NB
      DO 30 II = 1, IJ
         SUM = SUM + APCORE(JA) - APCORE(JA-NB*I)
         APCORE(JC) = SUM
         JA = JA + I
         JC = JC + J
 30      CONTINUE
C                                       Save constant value for last
C                                       section.
      IF (NB .LE. 1) GO TO 999
      IJ = IODD + NB/2
      DO 40 II = 1,IJ
         APCORE(JC) = SUM
         JC = JC + J
 40      CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'TXPL.INC'
C                                       Local include for TXPL
      CHARACTER NAMIN*12, CLSIN*6, LPNAME*48
      HOLLERITH XNAMIN(3), XCLSIN(2), XLNAME(12)
      REAL      DSKIN, SEQIN, VERSN, DOCRT
C                                          common for screen parms
      CHARACTER SCREEN(60)*132
      INTEGER   BITSCR(400,200), IDOCRT, LASTX, LASTY, MINX, MAXX,
     *   MINY, MAXY, CHARSI, MAXC
      LOGICAL   DOPRNT
      COMMON /INPARM/ XNAMIN, XCLSIN, SEQIN, DSKIN, VERSN, DOCRT, XLNAME
      COMMON /CHRCOM/ NAMIN, CLSIN, LPNAME
      COMMON /SCRN/ BITSCR, CHARSI, LASTX, LASTY, MINX, MAXX, MINY,
     *   MAXY, MAXC, IDOCRT, DOPRNT
      COMMON /SCRCHR/ SCREEN
LOCAL END
      PROGRAM TXPL
C-----------------------------------------------------------------------
C! Displays a plot (PL) file on a terminal or line printer
C# Plot-appl Terminal Printer
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1999, 2002-2004, 2006-2007, 2009, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TXPL is a program for the graphics package.  First a cataloged
C   file is found using data passed from AIPS.  The list of
C   associated files is searched for a PLot file corresponding
C   to the version number.  The graphics commands in this file
C   are executed for a dump line printing CRT or Lineprinter.
C   INPUTS:  (from AIPS)
C      INNAME  R(3)   Name of primary file.
C      INCLASS R(2)   Class of primary file.
C      INSEQ   R      Sequence number of primary file.
C      INDISK  R      Disk volume number. 0 means try all.
C      INTYPE  R      Primary file type.
C      INVERS  R      Extension file version number. 0 means.
C                     use the highest version number.
C      DOCRT   R      > 0 means CRT, else LINEPRINTER
C                        2 = write to history file
C                        3 = msgfil, no wait
C   Glen Langston MPIFR and MIT, November 1987
C-----------------------------------------------------------------------
      CHARACTER TYPIN*2, STATUS*4, PRGM*6, GFILE*48
      INTEGER   BUFFER(256), CATERR, LUN, FIND, IERR, NPARMS, RETCOD,
     *   CNO, IVER, I, IVOL, ISEQ, IERR2, USER, IROUND
      LOGICAL   NOMAP, QUICK, NOEXCL, WAIT
      INCLUDE 'TXPL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DTKS.INC'
      DATA PRGM /'TXPL  '/
      DATA NOMAP, NOEXCL, WAIT /.FALSE.,.FALSE.,.TRUE./
      DATA LUN /26/
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Get input values from AIPS.
      NPARMS = 21
      CALL GTPARM (PRGM, NPARMS, QUICK, XNAMIN, BUFFER, IERR)
      RETCOD = IERR
      IF ((IERR.NE.0) .OR. (NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   DOCRT = MIN (-1.0, DOCRT)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
C                                       If not CRT Release POPs
 10   I = IROUND (DOCRT)
      IF ((DOCRT.GT.0.0001) .AND. (I.EQ.0)) I = 1
      IDOCRT = MIN (I, 132)
      QUICK = QUICK .AND. ((I.LE.0) .OR. (I.EQ.2) .OR. (I.EQ.3))
      IF (QUICK) CALL RELPOP (RETCOD, BUFFER, IERR2)
      IF (RETCOD.NE.0) GO TO 995
      DOPRNT = (IDOCRT.LE.1) .OR. (IDOCRT.GE.4)
      DOCRT = IDOCRT
C                                       Get map header.
      ISEQ = IROUND (SEQIN)
      IVOL = IROUND (DSKIN)
      USER = NLUSER
      IVER = IROUND (VERSN)
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
      CNO = 1
      TYPIN = '  '
      CALL CATDIR ('SRCH', IVOL, CNO, NAMIN, CLSIN, ISEQ, TYPIN, USER,
     *   STATUS, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 40
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (8)
         GO TO 995
C                                       Read catalog header.
 40   CALL CATIO ('READ', IVOL, CNO, CATBLK, 'REST', BUFFER, CATERR)
      IF (CATERR.EQ.0) GO TO 50
         WRITE (MSGTXT,1040) IERR
         CALL MSGWRT (8)
         GO TO 995
C                                       Find version to plot
 50   IF (IVER.LE.0) CALL FNDEXT ('PL', CATBLK, IVER)
C                                       PLot file not found.
      IF (IVER.LE.0) THEN
         MSGTXT = 'PLOT FILE NOT IN CATALOG'
         CALL MSGWRT (8)
         GO TO 995
         END IF
C                                       Build file name.
      CALL ZPHFIL ('PL', IVOL, CNO, IVER, GFILE, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Open graphics file.
      CALL ZOPEN (LUN, FIND, IVOL, GFILE, NOMAP, NOEXCL, WAIT, IERR)
      IF (IERR.EQ.0) GO TO 80
         WRITE (MSGTXT,1070)
         CALL MSGWRT (8)
         GO TO 995
 80   CALL H2CHR (48, 1, XLNAME, LPNAME)
C                                       Write to terminal or Printer.
      CALL TEXDRW (LUN, FIND, IVOL, CNO,  IERR)
      IF (IERR.EQ.0) GO TO 90
         WRITE (MSGTXT,1080)
         CALL MSGWRT (8)
         GO TO 990
C                                        update image catalog
 90   CONTINUE
C                                       Close graph file.
 990  CALL ZCLOSE (LUN, FIND, IERR)
 995  CALL DIETSK (RETCOD, QUICK, BUFFER)
C
      STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('COULD NOT GET INPUTS FROM AIPS. GTPARM ERR =',I5)
 1020 FORMAT ('CATALOG ENTRY NOT FOUND. CATDIR ERR =',I5)
 1040 FORMAT ('ERROR READING CATALOG HEADER. CATIO ERR =',I5)
 1070 FORMAT ('PLOT FILE NOT FOUND')
 1080 FORMAT ('ERROR WRITING TO TEXT DEVICE')
      END
      SUBROUTINE TEXDRW (LUN, FIND, IVOL, CNO, IERR)
C-----------------------------------------------------------------------
C   This routine will execute the commands in a graph file for the
C   TEXT oriented dumb terminal or printer
C   Inputs:  LUN     I   logical unit number of an open graph file.
C            FIND    I   pointer to the FTAB info of the graph file.
C            IVOL    I   DISK containing MAP
C            CNO     I   Catalog number of file
C   Output:
C            IOBUF   I(256)   buffer to use for I/O.
C            IERR    I   error code. 0 = ok.
C-----------------------------------------------------------------------
      REAL   DX, DY, SCALEF, X, XYRATO, RX1, RX2, RY1, RY2, AX, AY,
     *   ASPMM, XPXSEP, YPXSEP, YTKDMM, UASPMM, XYDIFF, YASPMM, DELTA,
     *   Y, GDX, GDY
      LOGICAL   T
      INTEGER   ITYPE, IOBUF(256), FIND, GRYERR, LOOP, LOOP2, IANGL,
     *   ICHB, ICHL, ICHR, ICHT, IERR, IERR2, INCRRN, IOPOS, IORRN, IT,
     *   IX1, IY1, LUN, NXA, NYA, OPCODE, I, IERRC, IERRLM, IX2, IY2,
     *   NCHAR, IARG, INO, CNO, IVOL, NPIXL, IGLO, IGHI, IGDX, IGDY,
     *   NCOL
      HOLLERITH HOBUF(256)
      INCLUDE 'TXPL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DTKS.INC'
      EQUIVALENCE (IOBUF, HOBUF)
      DATA T /.TRUE./
      DATA IGLO, IGHI/0,0/
C-----------------------------------------------------------------------
C                                       Initialize all values.
C                                       Assume symetric device for now.
      YTKDMM = XTKDMM
      IERR = 0
      IERRLM = 20
      IERRC = 0
      GRYERR = 0
      IOPOS = 9999
      TKPOS = 0
      DO 10 LOOP = 1,60
         SCREEN(LOOP) = '          '
 10      CONTINUE
C                                       initialize screen parameters,
C                                       set character size to 1 by 1
      CHARSI = 3
      CSIZTK(1) = CHARSI
      CSIZTK(2) = CHARSI
      MINX = 1
      MINY = 1
C                                       If writing on dumb crt,
      IF (IDOCRT.GT.0) THEN
C                                       if plot written to history
         IF ((IDOCRT.EQ.2) .OR. (IDOCRT.EQ.3)) THEN
            MAXC = 64
            MAXY = 26 * CHARSI
C                                       else plot to terminal
         ELSE
            CALL ZWINC (NCOL)
            IF ((IDOCRT.LE.72) .OR. (IDOCRT.GT.NCOL)) IDOCRT = NCOL
            MAXC = IDOCRT
            DOCRT = IDOCRT
C                                       CRTMAX characters high
            MAXY = MAX((ABS(CRTMAX)-1),22) * CHARSI
            END IF
C                                       else plotting on printer
      ELSE
         MAXC = NCHPRT - 1
         MAXY = (PRTMAX-5) * CHARSI
         END IF
      MAXX = MAXC * CHARSI
C                                       zero bit array
      DO 20 LOOP = 1,MAXY
         DO 19 LOOP2 = 1,MAXX
            BITSCR(LOOP2,LOOP) = 0
 19         CONTINUE
 20      CONTINUE
C                                       Set plot region to number of
C                                       chars times CHARSI
      MAXXTK(1) = MAXX
      MAXXTK(2) = MAXY
      CALL RFILL (TKSIZE, 0.0, TKBUFF)
C                                       determine where plot starts
      CALL ZFIO ('READ', LUN, FIND, 1, IOBUF, IERR)
      IF (IERR.NE.0) GO TO 980
      IORRN = (IOBUF(10) + 9) / 256 + 1
      IF (IOBUF(3).GT.0) IORRN = IORRN + 1
C                                       next plot command
C                                       Read record.
 50   IF (IOPOS.LE.256) GO TO 60
 55      IORRN = IORRN + 1
         CALL ZFIO ('READ', LUN, FIND, IORRN, IOBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         IOPOS = 1
C                                       Transfer based on opcode.
 60   OPCODE = IOBUF(IOPOS)
      IF ((OPCODE.GT.0) .AND. (OPCODE.LE.18)) GO TO (100, 200,
     *   300, 400, 500, 600, 700, 800, 150, 500, 750, 300, 300, 600,
     *   600, 160, 500, 810), OPCODE
      IF (OPCODE.EQ.0) GO TO 55
C                                       End of file.
      IF (OPCODE.NE.32767) GO TO 970
         GO TO 990
C                                       Opcode 1, initialize.
 100  ITYPE = IOBUF(IOPOS+5)
      IOPOS = IOPOS + 6
      GO TO 50
C                                       Opcode 9, line type (ignored)
 150  IOPOS = IOPOS + 2
      GO TO 50
C                                       Opcode 16, 3-color color
C                                       (ignored)
 160  IOPOS = IOPOS + 4
      GO TO 50
C                                       Opcode 2, line drawing init.
 200  XYRATO = IOBUF(IOPOS+1) / 100.0
      SCALEF = IOBUF(IOPOS+2)
      IX1    = IOBUF(IOPOS+3)
      IY1    = IOBUF(IOPOS+4)
      IX2    = IOBUF(IOPOS+5)
      IY2    = IOBUF(IOPOS+6)
      RX1    = IOBUF(IOPOS+7)/1000.0
      RY1    = IOBUF(IOPOS+8)/1000.0
      RX2    = IOBUF(IOPOS+9)/1000.0
      RY2    = IOBUF(IOPOS+10)/1000.0
      ICHL   = (IOBUF(IOPOS+11)/10.0) * CSIZTK(1)  + 0.5
      ICHB   = (IOBUF(IOPOS+12)/10.0) * CSIZTK(2)  + 0.5
      ICHR   = (IOBUF(IOPOS+13)/10.0) * CSIZTK(1)  + 0.5
      ICHT   = (IOBUF(IOPOS+14)/10.0) * CSIZTK(2)  + 0.5
      IOPOS = IOPOS + 15
C                                      Expand scale to use all space
      XYRATO = XYRATO * REAL (MAXX) / REAL (MAXY)
C                                       Find no. pIXels inside border.
      NYA = MAXXTK(2) - ICHT - ICHB
      NXA = MAXXTK(1) - ICHL - ICHR
      IF ((NXA.LE.0) .OR. (NYA.LE.0)) THEN
         WRITE (MSGTXT,1200) NXA, NYA
         CALL MSGWRT (7)
         GO TO 990
         END IF
C                                       Compute scaling: sizes
      AX = ABS (IX2 - IX1) * XYRATO
      AY = ABS (IY2 - IY1)
      X = ABS (IX2+RX2-IX1-RX1) * XYRATO
      Y = ABS (IY2+RY2-IY1-RY1)
      IF ((X.LE.0) .OR. (Y.LE.0)) THEN
         WRITE (MSGTXT,1210) X, Y
         CALL MSGWRT (7)
         GO TO 990
         END IF
C                                       Factors
      IF ((X/Y).LE.FLOAT(NXA)/FLOAT(NYA)) THEN
         SCALEY = NYA/SCALEF * AY/Y
         SCALEX = SCALEY * AX/AY
      ELSE
         SCALEX = NXA/SCALEF * AX/X
         SCALEY = SCALEX * AY/AX
         END IF
C                                       Mm / arc sec scaling
      LOCNUM = 1
      IF ((ITYPE.EQ.2) .OR. (ITYPE.EQ.3) .OR. (ITYPE.EQ.6) .OR.
     *   (ITYPE.EQ.18) .OR. (ITYPE.EQ.27) .OR. (ITYPE.EQ.28) .OR.
     *   (ITYPE.EQ.29)) THEN
         CALL SETLOC (IOBUF(IOPOS), T)
         IF (AXTYP(LOCNUM).EQ.1) THEN
            XPXSEP = AXINC(1,LOCNUM) * 3600.0 / XYRATO
            YPXSEP = XPXSEP
            UASPMM = ASPMM
            CALL SCALMM (AX, AY, XPXSEP, YPXSEP, SCALEF, XTKDMM,
     *         YTKDMM, ASPMM, SCALEX, SCALEY)
            YASPMM = ABS (AY * AXINC(2,LOCNUM) * 3600.0 * YTKDMM)
     *         / (SCALEY * SCALEF)
            XYDIFF = ABS (ASPMM - YASPMM)
            DELTA = .05 * ASPMM
            END IF
         END IF
C                                        Center
      NXA = SCALEX*SCALEF*X/AX + ICHL + ICHR
      IARG = MAXXTK(1) - NXA
      RX0 = ICHL + MAX (0, IARG)/2 + 1
      NYA = SCALEY*SCALEF*Y/AY + ICHB + ICHT
      IARG = MAXXTK(2) - NYA
      RY0 = ICHB + MAX (0, IARG)/2 + 1
      IOPOS = IOPOS + 5
      RX0 = RX0 - RX1 * XYRATO * SCALEX * SCALEF / AX
      RY0 = RY0 - RY1 * SCALEY * SCALEF / AY
C                                       ScaleX*ScaleF is the x size
C                                       inside the plot border in
C                                       device pixels
      GO TO 50
C                                       Opcode 3, grey scale init.
C                                       Max and Min Grey values
 300  IGLO = IOBUF(IOPOS+1) / 8
      IGHI = IOBUF(IOPOS+2) / 8
C                                       Size of a Grey scale unit
      IGDX = IOBUF(IOPOS+3)
      IGDY = IOBUF(IOPOS+4)
      GDX = 1
      GDY = 1
      IF (IGDX.NE.0) GDX  = SCALEX * SCALEF / IGDX
      IF (IGDY.NE.0) GDY  = SCALEY * SCALEF / IGDY
      IF ((GDX.LT..01) .OR. (GDX.GT.30)) GDX = 0.4
      IOPOS = IOPOS + 5
      IF (OPCODE.EQ.13) IOPOS = IOPOS + 3
      IF (OPCODE.EQ.12) IOPOS = IOPOS + 7
      GO TO 50
C                                       Opcode 4, position cursor.
 400  X = IOBUF(IOPOS+1)
      Y = IOBUF(IOPOS+2)
      IOPOS = IOPOS+3
      CALL TEXVEC (X, Y, 1,  IERR)
      IF (IERR.EQ.0) GO TO 50
      IF (IERR.NE.2) GO TO 960
         IERRC = IERRC + 1
         GO TO 50
C                                       Opcode 5, draw vector.
C                                       Opcode 10, dark vector
C                                       Opcode 17, color vector
 500  X = IOBUF(IOPOS+1)
      Y = IOBUF(IOPOS+2)
      IOPOS = IOPOS+3
      CALL TEXVEC (X, Y, 2, IERR)
      IF (IERR.EQ.0) GO TO 50
      IF (IERR.NE.2) GO TO 960
         IERRC = IERRC + 1
         GO TO 50
C                                       Opcode 6, write characters.
 600  NCHAR = IOBUF(IOPOS+1)
      IANGL = IOBUF(IOPOS+2)
      DX    = IOBUF(IOPOS+3)/100.0
      DY    = IOBUF(IOPOS+4)/100.0
      CALL TXCHAR (NCHAR, IANGL, DX, DY, HOBUF(IOPOS+5), IERR)
      IF (IERR.NE.0) GO TO 960
      IOPOS = IOPOS + 5 + ((NCHAR + 3) / 4)
      GO TO 50
C                                       Do not process past end of buf
 700  IARG = 256 - IOPOS - 2
      NPIXL = MIN (IARG, IOBUF(IOPOS+1))
      IANGL = IOBUF(IOPOS+2)
C                                       PROCESS NPIXLs at once
      CALL TXGREY (NPIXL, IANGL, IGLO, IGHI, GDX, GDY,
     *   IOBUF(IOPOS+3), IERR)
      IF (IERR.NE.0) GO TO 960
      IOPOS = IOPOS + 3 + IOBUF(IOPOS+1)
C                                       Update IO position. Read
C                                       proper RRN if necessary.
      IF (IOPOS.LE.256) GO TO 60
C                                       Grey scale spans a buffer
C                                       determine number of blocks left
         INCRRN = (IOPOS-1)/256
C                                       process each block
         DO 720 I = 1, INCRRN
           IORRN = IORRN + 1
C                                       Get the rest
           CALL ZFIO ('READ', LUN, FIND, IORRN, IOBUF, IERR)
           IF (IERR.NE.0) GO TO 960
C                                       if not last block process all
           IF (I.LT.INCRRN) NPIXL = 256
           IF (I.EQ.INCRRN) NPIXL = IOPOS - 256*INCRRN - 1
C                                       process the block
           CALL TXGREY (NPIXL, IANGL, IGLO, IGHI, GDX, GDY, IOBUF(1),
     *        IERR)
           IF (IERR.NE.0) GO TO 960
 720       CONTINUE
C                                       point to next opcode
         IOPOS = IOPOS - 256*INCRRN
         GO TO 60
C                                       Opcode 11, write color scale
 750  GRYERR = GRYERR + 1
      IOPOS = IOPOS + 3 + 3*IOBUF(IOPOS+1)
      IF (IOPOS.GT.256) THEN
         INCRRN = (IOPOS-1)/256
         IORRN = IORRN + INCRRN
         IOPOS = IOPOS - 256*INCRRN
         CALL ZFIO ('READ', LUN, FIND, IORRN, IOBUF, IERR)
         IF (IERR.NE.0) GO TO 960
         END IF
      GO TO 60
C                                       Opcode 8, put misc info in
C                                       image catalog.
 800  INO = IOBUF(IOPOS+1)
      IOPOS = IOPOS + INO + 2
      GO TO 50
C                                       Opcode 18, comment
 810  INO = IOBUF(IOPOS+1)
      IOPOS = IOPOS + (INO+3)/4 + 2
      GO TO 50
C                                       Write error.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      GO TO 990
C                                       Invalid opcode.
 970  WRITE (MSGTXT,1970) OPCODE
      CALL MSGWRT (8)
      GO TO 990
C                                       Disk error.
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (8)
C                                       Close files.
C                                       force alpha
 990  IT = 31
C                                       Write out screen of data to
C                                       the terminal
      CALL TEXFLS (IVOL, CNO, IGLO, IGHI, IERR2)
      IF (IERRC.GT.0) THEN
         WRITE (MSGTXT,1990) IERRC
         CALL MSGWRT (3)
         END IF
      IF (GRYERR.GT.0) THEN
         WRITE (MSGTXT,1995) GRYERR
         CALL MSGWRT (3)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1200 FORMAT ('TEXDRW: ERR FROM GINITL ARGS. NXA, NYA=',2I6)
 1210 FORMAT ('TEXDRW: ERR FROM GINITL ARGS. X,Y=',2E10.3)
 1960 FORMAT ('TEXDRW: TEXTRONIX WRITE ERROR')
 1970 FORMAT ('TEXDRW: INVALID OPCODE',I5,' IN GRAPH FILE')
 1980 FORMAT ('TEXDRW: DISK IO RELATED ERROR',I3)
 1990 FORMAT (I8,' VECTORS TRUNCATED AT EDGES')
 1995 FORMAT (I8,' COLOR COMMANDS IGNORED')
      END
      SUBROUTINE TXCHAR (INCHAR, IANGL, DCX, DCY, TEXT, IERR)
C-----------------------------------------------------------------------
C  TXCHAR will write characters to a Dumb Terminal
C  Inputs:
C     INCHAR  I      number of characters.
C     IANGL   I      0=horizontal, other = vertical.
C     DCX     R      X distance in characters from current position.
C     DCY     R      Y distance in characters from current position.
C     TEXT    H(*)   Hollerith characters.
C  Outputs:
C     IERR    I      error indicator. 0 = ok.
C-----------------------------------------------------------------------
      REAL      DCX, DCY, X, Y
      HOLLERITH TEXT(*)
      CHARACTER CTEXT*512
      INTEGER   IANGL, IERR, IERRC, IERRL, INCHAR, I
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTKS.INC'
      DATA IERRL /50/
C-----------------------------------------------------------------------
      IERR = 0
      IF (INCHAR.LE.0) GO TO 999
      IERRC = 0
C                                       Convert to character
      CALL H2CHR (INCHAR, 1, TEXT, CTEXT)
C                                       Calc starting position, CSIZTK
C                                       is the character size
      X = RXL + DCX * CSIZTK(1)
      Y = RYL + DCY * CSIZTK(2)
C                                       Move to the starting position
C                                       for the string
      CALL TEXVEC (X, Y, 3, IERR)
      IERRC = IERRC + IERR
      IF (IERRC.GT.IERRL) GO TO 980
C                                       Alpha mode.
      IF (IERR.NE.0) GO TO 980
C                                       Loop for each character.
      DO 10 I = 1,INCHAR
C                                       Put the character at the screen
C                                       coordinate
         CALL TEXPUT (CTEXT(I:I))
C                                       Vertical, reposition.
         IF (IANGL.EQ.0) GO TO 10
            X = RXL
            Y = RYL - CSIZTK(2)
            CALL TEXVEC (X, Y, 3, IERR)
            IERRC = IERRC + IERR
            IF (IERRC.GT.IERRL) GO TO 980
 10      CONTINUE
      IERR = 0
      GO TO 999
C                                       Error limit exceeded.
 980  WRITE (MSGTXT,1980)
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('TXCHAR: ERROR LIMIT EXCEEDED.')
      END
      SUBROUTINE TXGREY (NPIXL, IANGL, IGLO, IGHI, GDX, GDY, THEGRE,
     *   IERR)
C-----------------------------------------------------------------------
C  TXGREY will write GREY Scales to a Dumb Terminal
C  Inputs:
C     NPIXL   I      number of greyscale values.
C     IANGL   I      0=horizontal, other = vertical.
C     IGLO    I      Minimum Grey scale value in counts
C     IGHI    I      Maximum Grey scale value in counts
C     GDX     R      X size of a grey scale unit in pIXels
C     GDY     R      Y size of a grey scale unit in pIXels
C     THEGRE  I(*)   greyscales.
C In/Out COMMON
C      RXL,RYL R   Last X and Y coordinates
C Output:
C      IERR   I      Error code, IERR=0 is good
C-----------------------------------------------------------------------
      INTEGER   NPIXL, IANGL, IGLO, IGHI, THEGRE(*)
      REAL      GDX, GDY
      INTEGER   IERR, I, PIXL, IX, IY
      INCLUDE 'TXPL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTKS.INC'
C-----------------------------------------------------------------------
      IERR = 0
      IF ((NPIXL.LE.0) .OR. (NPIXL.GT.256)) GO TO 999
      I = IGHI
C                                       Loop for every other grey scale
      DO 100 I = 1,NPIXL,2
C                                       Convert Grey to negative range
         PIXL = IGLO - (THEGRE(I)/8)
C                                       if screen does not have a line
C                                       here and new pixel is brighter
C                                       than old, put grey at the
C                                       screen coordinate.
         IF ((BITSCR(LASTX,LASTY).LE.0) .AND. (BITSCR(LASTX,LASTY).GT.
     *      PIXL)) BITSCR(LASTX,LASTY) = PIXL
C                                       Move to next grey start
         IF (IANGL.EQ.0) THEN
C                                       Horizontal, move two units
            RXL = RXL + GDX + GDX
         ELSE
C                                       Vertical, reposition.
            RYL = RYL - GDY - GDY
            ENDIF
C                                       Do actual move
         IX = RXL
         IY = RYL
C                                       Side effect:changes LASTX,LASTY
         CALL TXDVEC (1, IX, IY, IERR)
 100  CONTINUE
C
 999  RETURN
      END
      SUBROUTINE TEXVEC (XX, YY, IN, IERR)
C-----------------------------------------------------------------------
C   This routine will put lines and move to X and Y coordinates
C   into the TEXT output buffer.
C   Inputs:
C      XX     R   X coordinate value.
C      YY     R   Y coordinate value.
C      IN     I   control value:
C                 1 = Scale XX and YY and preceed coordinates
C                     by 'write dark vector' control charactr
C                 2 = Scale XX and YY, put in buffer.
C                 3 = XX and YY are not scaled, 'write dark vector'
C                     control character is put into
C                     the buffer.
C                 4 = no scale, write vector
C   Output:
C      IERR   I   error code, 0=ok, 1=write error.
C   COMMON:
C      TKBUFF
C      TKPOS
C      RXL, RYL
C-----------------------------------------------------------------------
      REAL      XX, YY
      INTEGER   IN, IERR
C
      INTEGER   X, Y
      LOGICAL   ISERR
      REAL      ALPHA, BETA, RZ(2), RXN, RYN
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTKS.INC'
C-----------------------------------------------------------------------
      ISERR = .FALSE.
C                                       Set last X and Y.
      RXN = XX
      RYN = YY
      RZ(1) = MAXXTK(1)
      RZ(2) = MAXXTK(2)
C                                       If IN = 1 or 2 do scaling.
      IF (IN.LE.2) THEN
         RXN = XX*SCALEX + RX0
         RYN = YY*SCALEY + RY0
         END IF
C                                       If IN = 1 or 3 'dark vector'.
      IF ((IN.NE.1) .AND. (IN.NE.3)) GO TO 20
         X = MAX (1.0, MIN (RZ(1), RXN)) + 0.5
         Y = MAX (1.0, MIN (RZ(2), RYN)) + 0.5
         CALL TXDVEC (1, X, Y, IERR)
         GO TO 90
C                                       Bright vector
 20   CONTINUE
C                                       Check start point
         IF ((RXL.GT.0.5) .AND. (RXL.LE.RZ(1)) .AND. (RYL.GT.0.5)
     *      .AND. (RYL.LE.RZ(2))) GO TO 30
            X = MAX (1.0, MIN (RZ(1), RXL)) + 0.5
            Y = MAX (1.0, MIN (RZ(2), RYL)) + 0.5
            ALPHA = 1.0
            IF (RXN.NE.RXL) ALPHA = (X - RXN) / (RXL - RXN)
            BETA = 1.0
            IF (RYN.NE.RYL) BETA = (Y - RYN) / (RYL - RYN)
            ALPHA = MIN (ALPHA, BETA)
            X = RXN + ALPHA * (RXL-RXN) + 0.5
            Y = RYN + ALPHA * (RYL-RYN) + 0.5
            CALL TXDVEC (1, X, Y, IERR)
            IF (IERR.NE.0) GO TO 90
C                                       Check end point
 30      X = MAX (1.0, MIN (RZ(1), RXN)) + 0.5
         Y = MAX (1.0, MIN (RZ(2), RYN)) + 0.5
         IF ((RXN.GT.0.5) .AND. (RYN.GT.0.5) .AND. (RXN.LE.RZ(1))
     *      .AND. (RYN.LE.RZ(2))) GO TO 40
            ISERR = .TRUE.
            ALPHA = 1.0
            IF (RXN.NE.RXL) ALPHA = (X - RXL) / (RXN - RXL)
            BETA = 1.0
            IF (RYN.NE.RYL) BETA = (Y - RYL) / (RYN - RYL)
            ALPHA = MIN (ALPHA, BETA)
            X = RXL + ALPHA * (RXN-RXL) + 0.5
            Y = RYL + ALPHA * (RYN-RYL) + 0.5
 40      CONTINUE
         CALL TXDVEC (2, X, Y, IERR)
C                                         Save new pos
 90   RXL = RXN
      RYL = RYN
      IF ((IERR.EQ.0) .AND. (ISERR)) IERR = 2
C
      RETURN
      END
      SUBROUTINE TXDVEC (IOP, X, Y, IERR)
C-----------------------------------------------------------------------
C   TXDVEC draws a line in the array of characters to be displayed on a
C   dumb terminal.
C   Input:
C      IOP    I   OPcode, 1=Move, 2=Draw
C      X      I   Screen coordinate in characters
C      Y      I   Screen coordinate in characters
C Output:
C      IERR   I   Error code, 0=good
C-----------------------------------------------------------------------
      INTEGER   IOP, X, Y, IERR
C
      INTEGER   BITCOU, DELTAX, DELTAY, IX, IY, I, J
      REAL      DX, DY
      INCLUDE 'TXPL.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       do not draw if not a draw
C                                       command.
      IF (IOP.NE.2) GO TO 900
C                                       calculate the absolute movement
C                                       in x and y
      DX = X - LASTX
      DY = Y - LASTY
      DELTAX = ABS (DX)
      DELTAY = ABS (DY)
C                                       turn on as many pixels as the
C                                       max movement
      BITCOU = DELTAX
      IF (DELTAY.GT.BITCOU) BITCOU = DELTAY
C                                       convert pixel increment to line
C                                       increment .
      IF (BITCOU.GT.0) THEN
         DX = DX / BITCOU
         DY = DY / BITCOU
         END IF
C                                       fill in the bits.
      J = BITCOU + 1
      DO 100 I = 1,J
        IX = (I-1)*DX + LASTX
        IY = (I-1)*DY + LASTY
C                                       limit values to within the
C                                       screen.
        IX = MIN (MAXX, MAX (MINX, IX))
        IY = MIN (MAXY, MAX (MINY, IY))
        BITSCR(IX,IY) = 1
 100    CONTINUE
C                               store the last coordinate filled
 900  LASTX = MIN (MAXX, MAX (MINX, X))
      LASTY = MIN (MAXY, MAX (MINY, Y))
C
 999  RETURN
      END
      SUBROUTINE TEXPUT (THECHS)
C-----------------------------------------------------------------------
C   TEXPUT puts one character at the current screen location on the
C   terminal.
C   Input:
C      THECHS  C*1   Input character
C-----------------------------------------------------------------------
      CHARACTER   THECHS*1
C
      INTEGER   IX,IY, IARG
      INCLUDE 'TXPL.INC'
C-----------------------------------------------------------------------
C                                       convert bit coord to Character
C                                       coord.
      IX = (LASTX + CHARSI - 1) / CHARSI
      IARG = LASTY / CHARSI
      IY =  MAX (1,IARG)
      SCREEN(IY)(IX:IX) = THECHS
C                                       Move current position to next
C                                       character
      LASTX = LASTX + CHARSI
      IF (LASTX.GT.MAXX) LASTX = MAXX
C
 999  RETURN
      END
      SUBROUTINE TEXFLS (IVOL, CNO, IGLO, IGHI, IERR)
C-----------------------------------------------------------------------
C   TEXFLS flushes the tex screen to printer or user teminal
C   Input:
C      IVOL    I     Disk containing map
C      CNO     I     Catalog number of file
C      IGLO    I     Low gray scale value
C      IGHI    I     High gray scale value
C   Output:
C      IERR    I     Error code, 0=good
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, WORK*160, OUTCHA*1, TITL1*160, TITL2*160,
     *   WORK2*160
      REAL      GREYVA
      INTEGER   IERR, IVOL, CNO, IGLO, IGHI, OUTLUN, OUTIND, NC, I, J,
     *   K, NLINE, PIXEL(3,3), IX, IY, CRTX, CRTY, NUMGRE, HLUN, II,
     *   IBUF(256), IPAGE
      LOGICAL   T
      INCLUDE 'TXPL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA HLUN /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
      IERR = 0
      IPAGE = 0
      NLINE = 999
C                                       Calculate max CRT X and Y
      CRTX = MAXX/CHARSI
      CRTY = MAXY/CHARSI
      NC   = CRTX
C                                       Open output device
C                                       if not writing to msg file.
      IF (DOPRNT) THEN
         IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
         CALL LPOPEN (LPNAME, DOCRT, OUTLUN, OUTIND, II, IBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1040) IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       Initialize titles for print
         TITL1 = ' '
         TITL2 = ' '
         END IF
C                                       write out one line at a time,
      II = CRTY - 1
      DO 400 I = 1,II
C                                       getting y axis positive
         IY = CRTY - I
C                                       copy Screen line to scratch
         WORK(1:NC) = SCREEN(IY)(1:NC)
C                                       convert PIXEL(3*3) into one
C                                       character.
         DO 300 IX = 1,CRTX
C                                       init count of greyscales values
            NUMGRE = 0
            GREYVA = 0
C                                       transfer the bits to a work
C                                       array
            DO 200 J = 1,3
               DO 100 K = 1,3
                  PIXEL(J,K) = BITSCR((IX-1)*CHARSI+J,IY*CHARSI+K)
C                                       greyscale values are negative
                  IF (PIXEL(J,K).LT.0) THEN
C                                       count number of greyscale value
                     NUMGRE = NUMGRE + 1
C                                       let darkest grey represent pixel
                     IF (GREYVA.LT.-PIXEL(J,K)) GREYVA = -PIXEL(J,K)
                     END IF
 100              CONTINUE
 200           CONTINUE
C                                       convert the 3*3 PIXEL to 1 char
            CALL BIT2CH (PIXEL, OUTCHA)
C                                       does screen have a blank here?
            IF (WORK(IX:IX).EQ.' ') WORK(IX:IX) = OUTCHA
C                                       now insert greyscale value if
C                                       any, and is grey scale correctly
C                                       initialized?
            IF ((NUMGRE.GT.0) .AND. (IGHI-IGLO.GT.0)) THEN
C                                       grey scale ranges from 0 to 9
               GREYVA = 10. * GREYVA / (IGHI-IGLO)
C                                       values of 0. to .999 map to 0,
C                                       etc 9. to 9.999 maps to 9, 10
C                                       is special.
               NUMGRE   = GREYVA
C                                       convert intensity to char
               CALL SETDCH (NUMGRE, OUTCHA)
C                                       does screen have a blank here?
               IF (WORK(IX:IX).EQ.' ') WORK(IX:IX) = OUTCHA
               END IF
 300        CONTINUE
C                                       copy scratch back to screen
         SCREEN(IY) = WORK(:NC)
C                                       CRT (no header), Printer
         IF (DOPRNT) THEN
            IF (IDOCRT.GT.0) NLINE = 1
            CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NC, TITL1, TITL2,
     *         WORK, NLINE, IPAGE, WORK2, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1900,ERR=999) IERR
               CALL MSGWRT (8)
               GO TO 999
               END IF
C                                       Message Write prints 72 chars
C                                       per line and adds a 8 char label
C                                       leaving only 64 chars of info.
         ELSE IF (IDOCRT.EQ.3) THEN
            MSGTXT = SCREEN(IY)(1:MIN(NC,64))
            CALL MSGWRT (4)
            END IF
 400     CONTINUE
C                                       Close down output
C                                       CRT: wait for user input
      IF (DOPRNT) THEN
         IF (IDOCRT.GT.0) THEN
            NLINE = 1001
            IPAGE = 1
            CALL PRTLIN (OUTLUN, OUTIND, DOCRT, NC, TITL1, TITL2,
     *         WORK, NLINE, IPAGE, WORK2, IERR)
            END IF
         CALL LPCLOS (OUTLUN, OUTIND, NLINE, IERR)
         END IF
C                                       If plot added to history
      IF (IDOCRT.EQ.2) THEN
C                                       Prepare history
         CALL HIINIT (3)
         CALL HIOPEN (HLUN, IVOL, CNO, IBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR
            CALL MSGWRT (6)
            GO TO 999
            END IF
C                                       Write out one line at a time,
C                                       getting y axis positive
         II = CRTY - 1
         DO 900 I = 1,II
            IY = CRTY - I
            WRITE (HILINE,1400,ERR=900) TSKNAM(1:5), SCREEN(IY)(1:64)
            CALL HIADD (HLUN, HILINE, IBUF, IERR)
 900        CONTINUE
         CALL HICLOS (HLUN, T, IBUF , IERR)
         END IF
C
 999  RETURN
C----------------------------------------------------------------------
 1040 FORMAT ('ERROR',I5,' OPENING OUTPUT DEVICE')
 1100 FORMAT ('ERROR:',I7,' OPENING HISTORY FILE')
 1400 FORMAT (A5,1X,A)
 1900 FORMAT ('PRTLIN ERROR:',I7)
      END
      SUBROUTINE BIT2CH (PIXEL, OUTCHA)
C-----------------------------------------------------------------------
C   Convert the 3*3 pixel to one character
C   Input:
C      PIXEL  I(3,3)   Array of bits to be converted to a character
C                      organized as follows
C                                  COL
C                     (COL,ROW)
C                        1,3    2,3   3,3
C               ROW      1,2    2,2   3,2
C                        1,1    2,1   3,1
C              SO "T" IS (1,3) (2,3) (3,3) (2,2) AND (2,1)
C   Output:
C      OUTCHA  C*1     One character representing the pixel
C-----------------------------------------------------------------------
      INTEGER   PIXEL(3,3)
      CHARACTER OUTCHA*1
C
      CHARACTER TICK*1, MINUS*1, QUOTE*1, PIPE*1, SLASH*1, BACKSL*2,
     *   PLUS*1, EQUAL*1, XX*1, HH*1, II*1, OO*1, UU*1
      INTEGER   I, J, NUMON, ROWON(3), COLON(3)
      DATA TICK, MINUS, QUOTE, PIPE
     *   / '`',   '-',   '"',   '|'/
      DATA SLASH, BACKSL, PLUS, EQUAL
     *   / '/',    '\\',   '+',  '='/
      DATA XX, HH,  II,  OO,  UU
     *   /'X', 'H', 'I', 'O', 'U'/
C-----------------------------------------------------------------------
C                                       INIT COUNTS OF NUMB ON IN
C                                       ROWS
      NUMON = 0
      DO 10 I = 1,3
         ROWON(I) = 0
         COLON(I) = 0
 10      CONTINUE
C                                       Count the number of bits on
C                                       will range from 0 to 9
C                                       I = col, J = row
      DO 30 I = 1, 3
         DO 20 J = 1, 3
            IF (PIXEL(I,J).GE.1) THEN
               NUMON = NUMON + 1
               ROWON(J) = ROWON(J) + 1
               COLON(I) = COLON(I) + 1
               END IF
 20         CONTINUE
 30      CONTINUE
C                                       If none on, blank, etc...
C                                       set default for all cases
      CALL SETDCH (NUMON, OUTCHA)
C                                       Now correct for special cases
      IF ((NUMON.EQ.1) .AND. (ROWON(3).EQ.1)) OUTCHA = TICK
C                                       Special processing for 2,3 on
      IF (NUMON.LE.3) THEN
C                                       Use mostly vertical or horiz
         IF ((ROWON(1).GE.2) .OR. (ROWON(2).GE.2) .OR. (ROWON(3).GE.2))
     *      OUTCHA = MINUS
         IF ((PIXEL(2,3).EQ.0) .AND. (ROWON(3).EQ.2)) OUTCHA = QUOTE
         IF ((COLON(1).GE.2) .OR. (COLON(2).GE.2) .OR. (COLON(3).GE.2))
     *      OUTCHA = PIPE
C                                       One and Two finished.
         IF (NUMON.LT.3) GO TO 999
C
         IF ((ROWON(1).NE.3) .AND. (ROWON(2).NE.3) .AND.
     *      (ROWON(3).NE.3) .AND. (COLON(1).NE.3) .AND.
     *      (COLON(2).NE.3) .AND. (COLON(3).NE.3)) OUTCHA = PLUS
         END IF
C                                       Take care of diagonal cases,
C                                       if center on
      IF ((NUMON.LE.5) .AND. (PIXEL(2,2).NE.0)) THEN
         IF ((PIXEL(1,1).GE.1) .AND. (PIXEL(3,3).GE.1)) OUTCHA = SLASH
         IF ((PIXEL(3,1).GE.1) .AND. (PIXEL(1,3).GE.1))
     *      OUTCHA = BACKSL(1:1)
         IF ((PIXEL(3,1).GE.1) .AND. (PIXEL(1,3).GE.1) .AND.
     *      (PIXEL(1,1).GE.1) .AND. (PIXEL(3,3).GE.1)) OUTCHA = XX
         END IF
C                                       To simplify follow tests,
C                                       exit if only a few pixels
C                                       are on or almost all on.
      IF ((NUMON.LE.3) .OR. (NUMON.GE.8)) GO TO 900
C                                       Try to make lines work
      IF ((COLON(2).EQ.3) .OR. (COLON(3).EQ.3) .OR. (ROWON(1).EQ.3) .OR.
     *   (ROWON(2).EQ.3) .OR. (ROWON(3).EQ.3)) OUTCHA = PLUS
C                                        Cases for which there are
C                                        special characters
      IF ((COLON(1).EQ.3) .AND. (ROWON(1).EQ.3) .AND. (COLON(3).EQ.3))
     *   OUTCHA = UU
      IF ((COLON(2).EQ.3) .AND. (ROWON(1).EQ.3) .AND. (ROWON(3).EQ.3))
     *   OUTCHA = II
      IF ((ROWON(2).EQ.3) .AND. (COLON(1).EQ.3) .AND. (COLON(3).EQ.3))
     *   OUTCHA = HH
      IF ((COLON(1).EQ.2) .AND. (COLON(2).EQ.2) .AND. (COLON(3).EQ.2))
     *   OUTCHA = EQUAL
C                                    IS ALL BUT CENTER ON ?
 900  IF ((NUMON.EQ.8) .AND. (PIXEL(2,2).LE.0)) OUTCHA = OO
C
 999  RETURN
      END
      SUBROUTINE SETDCH (INTENS, OUTCHA)
C-----------------------------------------------------------------------
C   SETDCH sets the character which corresponds to the input intensity
C   Input:
C      INTENS  I    Value to be turned into a character, allowed range
C                   0 to 9, values outside this range are set to blank
C   Output:
C      OUTCHA  C*1  Character representation of the INTENS
C-----------------------------------------------------------------------
      CHARACTER OUTCHA*1
      INTEGER   INTENS
C
      CHARACTER DEFCHA(11)*1
      INTEGER   INRANG
      DATA DEFCHA/' ','.',':','~','+','*','&','%','#','@','M'/
C-----------------------------------------------------------------------
      INRANG = MIN (10, MAX (0, INTENS))
      OUTCHA = DEFCHA(INRANG+1)
C
 999  RETURN
      END

      SUBROUTINE RWTAB (FDVEC, TBIND, DPTR, NAXIS, IBLK, TAPBUF, IERR)
C-----------------------------------------------------------------------
C! Read FITS ASCII table data and write AIPS table file.
C# FITS EXT-util Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2008, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  This routine will read the data section of a FITS extension file
C  of type TABLE and decode this information using data obtained from
C  the header section of the extension file, and write the AIPS version
C  of a table file.  Limited to tables lines <= 2880 characters.
C  Inputs:
C     FDVEC    I(50)      File descriptor vector for TAPIO input
C     DPTR     I(128,2)   Data Pointers, used in table file control.
C     NAXIS    I(2)       Length of columns (in char), number of rows.
C  In/Out:
C     TBIND    I          Buffer pointer in TAPBUF
C     IBLK     I(>=512)     Disk Table file I/O buffer.
C     TAPBUF   I(*)       Tape I/O buffer.
C  Outputs:
C     IERR     I          Error code. 0=ok.
C-----------------------------------------------------------------------
      CHARACTER TLINE*2880
      HOLLERITH RECH(1)
      INTEGER   NAXIS(2), FDVEC(50), TBIND, DPTR(128,2), IBLK(*),
     *   TAPBUF(*), IERR
      DOUBLE PRECISION X, RECRD(1)
      REAL      RECRR(512)
      INTEGER   NAXIS2, LCTR, RECII(1), IT(256), ILEN(256), NCNTR,
     *   I, NAXIS1, IOFF, IT0, JT, JTRIM
      LOGICAL   NULL, RECLL(1)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTHD.INC'
      EQUIVALENCE (RECII, RECLL, RECRD, RECRR, RECH)
C-----------------------------------------------------------------------
      NCNTR = 2881
C                                       Calculate end & type
C                                       of Column values.
C                                       Use TFCODE to determine types
C                                       because DPTR holds output info.
      DO 10 I = 1,ITNCOL
         IT(I) = MOD (TFCODE(I),10)
C                                       Length of Character types in
C                                       reals.
         IF (IT(I).EQ.3) ILEN(I) = ((DPTR(I,2) / 10) + 3) / 4
 10      CONTINUE
C                                       Loop for all lines in table.
      NAXIS1 = NAXIS(1)
      NAXIS2 = NAXIS(2)
      DO 800 LCTR = 1,NAXIS2
C                                       Read a FITS table data line.
         CALL TABLIN (NAXIS1, FDVEC, TBIND, NCNTR, TAPBUF, TLINE, IERR)
         IF (IERR.NE.0) GO TO 999
         DO 200 I = 1,ITNCOL
C                                       Decode the data fields in this
C                                       row.  Look for null values.
            NULL = TLINE(TBCOL(I):TBCOL(I)+TWIDTH(I)-1) .EQ.
     *         TNULL(I)(1:TWIDTH(I))
C                                       Go to correct type
            IOFF = DPTR(I,1)
            IT0 = IT(I)
C                                       Double precision
            IF (IT0.LE.1) THEN
               IF (.NOT.NULL) THEN
                  CALL DCODEF (TBCOL(I), TWIDTH(I), TFRAC(I), TLINE,
     *               X, IERR)
                  RECRD(IOFF) = X
               ELSE
                  RECRD(IOFF) = DBLANK
                  END IF
C                                       Single precision
            ELSE IF (IT0.EQ.2) THEN
               IF (.NOT.NULL) THEN
                  CALL DCODEF (TBCOL(I), TWIDTH(I), TFRAC(I), TLINE,
     *               X, IERR)
                  RECRR(IOFF) = X
               ELSE
                  RECRR(IOFF) = FBLANK
                  END IF
C                                       Character.
            ELSE IF (IT0.EQ.3) THEN
               IF (.NOT.NULL) THEN
                  JT = JTRIM (TLINE(TBCOL(I):TBCOL(I)+TWIDTH(I)-1))
                  CALL CHR2H (TWIDTH(I), TLINE(TBCOL(I):), 1,
     *               RECH(IOFF))
               ELSE
                  CALL CHFILL (TWIDTH(I), HBLANK, RECH(IOFF))
                  END IF
C                                       Integer
            ELSE IF ((IT0.EQ.4) .OR. (IT0.EQ.6)) THEN
               IF (.NOT.NULL) THEN
                  CALL DCODEF (TBCOL(I), TWIDTH(I), TFRAC(I), TLINE,
     *               X, IERR)
                  IF (X.GT.0.0D0) THEN
                     RECII(IOFF) = X + 0.5
                  ELSE
                     RECII(IOFF) = X - 0.5
                     END IF
               ELSE
                  RECII(IOFF) = BLANKV
                  END IF
               GO TO 200
C                                       Logical
            ELSE IF (IT0.EQ.5) THEN
               RECLL(IOFF) = TLINE(TBCOL(I):TBCOL(I)).EQ.'T'
               GO TO 200
C                                       Hexbit
C                                       Not supported.
            ELSE
               END IF
C
 200        CONTINUE
C                                       Write this table row.
         CALL TABIO ('WRIT', 0, LCTR, RECRR, IBLK, IERR)
 800     CONTINUE
      CALL TABIO ('CLOS', 0, LCTR, RECRR, IBLK, IERR)
C
 999  RETURN
      END

      SUBROUTINE ZTXOP2 (OPCODE, LUN, FIND, OUTFIL, APPEND, IERR)
C-----------------------------------------------------------------------
C! translate the file name and open a text file
C# Z2 Text
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Translate file name and do actual text file open.
C   Inputs:
C      OPCODE   C*4    Operation code 'READ' or 'WRIT'
C      LUN      I      Logical unit number
C      FIND     I      Index in FTAB for LUN
C      OUTFIL   C*48   Physical file name
C      APPEND   L      If true append new text to end of old file.
C                         (OPCODE='WRIT' only).
C   Outputs:
C      IERR     I      Error return code: 0 => no error
C                         4 => trouble translating logical
C                         5 => file doesn't exist
C                         6 => open error
C   VMS version.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, OUTFIL*48
      INTEGER   LUN, FIND, IERR
      LOGICAL   APPEND
C
      INTEGER   I, FLEN, IOSVAL, ITRIM
      LOGICAL   EXISTS
      CHARACTER FILNAM*128, LSTAT*3
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Translate logical device name.
      CALL ZFULLN (OUTFIL, ' ', ' ', FILNAM, IERR)
      IF (IERR.NE.0) THEN
         IERR = 4
         GO TO 999
         END IF
      FLEN = ITRIM (FILNAM)
      WRITE (MSGTXT,1000)
      CALL MSGWRT (2)
      WRITE (MSGTXT,1001) FILNAM(1:MIN (56, FLEN))
      CALL MSGWRT (2)
      IF (FLEN.GT.56) THEN
         WRITE (MSGTXT,1001) FILNAM(57:FLEN)
         CALL MSGWRT (2)
         END IF
C                                       See if file exists
      INQUIRE (FILE=FILNAM, EXIST=EXISTS)
      LSTAT = 'NEW'
      IF (EXISTS) LSTAT = 'OLD'
C                                       File should exist (READ)
      IF ((OPCODE.EQ.'READ') .AND. (.NOT.EXISTS)) THEN
         IERR = 5
         WRITE (MSGTXT,1010)
C                                       File should not exist (WRIT)
      ELSE IF ((OPCODE.EQ.'WRIT') .AND. (EXISTS) .AND. (.NOT.APPEND))
     *   THEN
         IERR = 5
         WRITE (MSGTXT,1011)
      ELSE
C                                       To read (only)
         IF (OPCODE.EQ.'READ') THEN
            OPEN (UNIT=LUN, FILE=FILNAM(1:FLEN), STATUS='OLD',
     *         IOSTAT=IOSVAL, READONLY)
            IF (IOSVAL.EQ.0) REWIND (LUN)
C                                       To write at end
         ELSE IF ((EXISTS) .AND. (APPEND)) THEN
            OPEN (UNIT=LUN, FILE=FILNAM(1:FLEN), STATUS=LSTAT,
     *         CARRIAGECONTROL='LIST', IOSTAT=IOSVAL, ACCESS='APPEND')
C                                       To write from beginning
         ELSE
            OPEN (UNIT=LUN, FILE=FILNAM(1:FLEN), STATUS=LSTAT,
     *         CARRIAGECONTROL='LIST', IOSTAT=IOSVAL)
            IF (IOSVAL.EQ.0) REWIND (LUN)
            END IF
         IF (IOSVAL.NE.0) THEN
            IERR = 6
            WRITE (MSGTXT,1020) IOSVAL
            END IF
         END IF
C                                       Error
      IF (IERR.NE.0) CALL MSGWRT (6)
      IF (IERR.EQ.6) THEN
         I = FIND + NMOFF
         FTAB(I+FCBERR) = IOSVAL
         CALL ZERROR ('ZTXOP2', IOSVAL, FILNAM, -999, .FALSE.)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZTXOP2: using translated file name =')
 1001 FORMAT ('ZTXOP2: ',A)
 1010 FORMAT ('ZTXOP2: FILE TO BE READ DOES NOT EXIST')
 1011 FORMAT ('ZTXOP2: FILE TO BE WRITTEN ALREADY EXISTS')
 1020 FORMAT ('ZTXOP2: FORTRAN OPEN ERROR = ',I6)
      END

      PROGRAM ASORT
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C     Utility to sort and re-format \a, \c and \h# fields of ADR files.
C     Only does contiguous groups of lines of same type.
C     DCW, NRAO-CV, 24Apr88,27Apr88.
C-----------------------------------------------------------------------
C                                       Constants:
      INTEGER     ILDIM, NLSMAX, CMAX, L1, L2, L5, L6, FILDIM, OLMAX,
     *            BARLEN
      PARAMETER   (ILDIM=80, NLSMAX=100, CMAX=3, L1=1, L2=2, L5=5, L6=6,
     *            FILDIM=40, OLMAX=72, BARLEN=(OLMAX-3))
      CHARACTER   CS*3, DIGITS*10
      PARAMETER   (CS = 'ahc', DIGITS = '0123456789')
C                                       Local variables:
      INTEGER     I, J, ITRIM, NLS, NS, KI, KO
      CHARACTER   IL*(ILDIM), TIL*(ILDIM), C*3, LC*3,
     *            S((ILDIM/2))*(ILDIM), LS(NLSMAX)*(OLMAX), T*(ILDIM),
     *            INP*(FILDIM), F1*(FILDIM), F2*(FILDIM), LASTN*(ILDIM)
      LOGICAL     NOTBAR
C
C-----------------------------------------------------------------------
C                                       get input file:
  10  CONTINUE
      WRITE (L6, 1010)
      INP = ' '
      READ (L5, 1015, ERR=10) INP
      IF (INP.EQ.' ') INP = 'AIPSWHO:WHOGETS'
      F1 = INP(:ITRIM(INP)) // '.ADR'
      OPEN (UNIT=L1, FILE=F1, STATUS='OLD', ERR=17, READONLY)
         WRITE (L6, 1016) 1, F1
         GO TO 20
  17  CONTINUE
         WRITE (L6, 1017) F1
         GO TO 10
  20  CONTINUE
C                                       get output file:
  30  CONTINUE
      WRITE (L6, 1030)
      READ (L5, 1015, ERR=30) INP
      IF (INP.EQ.' ') THEN
         INP = F1
         I = INDEX (INP, ':')
         IF (I.GT.0) THEN
            T = INP(I+1:)
            INP = T
         ENDIF
         I = INDEX (INP, ']')
         IF (I.GT.0) THEN
            T = INP(I+1:)
            INP = T
         ENDIF
         I = INDEX (INP, '.ADR')
         T = INP(:I-1)
         INP = T
      ENDIF
      F2 = INP(:ITRIM(INP)) // '.ADR'
      OPEN (UNIT=L2, FILE=F2, STATUS='NEW', ERR=37,
     *      CARRIAGECONTROL='LIST')
         WRITE (L6, 1016) 2, F2
         GO TO 40
  37  CONTINUE
         WRITE (L6, 1017) F2
         GO TO 30
  40  CONTINUE
C
      LC = ' '
      NLS = 0
      KI = 0
      KO = 0
      LASTN = ' '
C                                       main scan loop:
 110  READ (L1, '(A)', END=910) IL
         KI = KI + 1
         IF (IL(OLMAX+1:).NE.' ')
     *      WRITE (L6, *) '[', LASTN(:ITRIM(LASTN)),
     *         '] Long-line: [', IL(:ITRIM(IL)), ']', ITRIM (IL)
         IF (IL(1:1).NE.'\') GO TO 310
C                                       parse line into strings:
         T = IL(2:)
         TIL = T
         NS = 0
 120     CONTINUE
            IF (TIL.EQ.' ') GO TO 150
 130        IF (TIL(1:1).NE.' ') GO TO 140
               T = TIL(2:)
               TIL = T
               GO TO 130
 140        I = INDEX (TIL, ' ')
            NS = NS + 1
            S(NS) = TIL(:I-1)
            IF (S(NS)(OLMAX+1:).NE.' ') WRITE (L6, *) '[',
     *         LASTN(:ITRIM(LASTN)), '] Long S(NS): [',
     *         S(NS)(:ITRIM(S(NS))), ']', ITRIM (S(NS))
            T = TIL(I+1:)
            TIL = T
            GO TO 120
 150     CONTINUE
C                                       is C in sort-set?
         C = S(1)
         IF (INDEX (CS, C(1:1)).EQ.0) GO TO 310
C
C                                       we will sort the line:
         IF (C(1:1).EQ.'h') THEN
            IF (C(2:2).EQ.' ') C(2:2) = '1'
            IF ((INDEX (DIGITS, C(2:2)).EQ.0).OR.(C(3:3).NE.' '))
     *         WRITE (L6,*) ' Encountered [\', C, '] !?!'
         ELSE
            IF (C(2:2).NE.' ')
     *            WRITE (L6,*) ' Encountered [\', C, '] !?!'
         ENDIF
C                                       move list down:
         NS = NS - 1
         IF (NS.GT.0) THEN
            DO 160 I = 1, NS
               S(I) = S(I+1)
 160           CONTINUE
         ENDIF
C                                       append S to LS:
C                                       comment-lines *not* appended:
         IF ((C.NE.LC).OR.(LC.EQ.'c'))
     *      CALL FLUSH (L2, L6, OLMAX, LASTN, LC, NLS, LS, KO)
         LC = C
         DO 170 I = 1, NS
            NLS = NLS + 1
            LS(NLS) = S(I)
 170        CONTINUE
C                                       \c case is special:
         IF (LC.EQ.'c') THEN
C                                       objective is to
C                                       normalize comment bars:
            IF ((NLS.EQ.1).AND.(LS(1)(1:1).EQ.'-')) THEN
               NOTBAR = .FALSE.
               DO 180 I = 1, OLMAX
                  NOTBAR = NOTBAR .OR.
     *               ((LS(1)(I:I).NE.'-') .AND. (LS(1)(I:).NE.' '))
 180              CONTINUE
               IF (.NOT.NOTBAR) THEN
C                                       make bar extend to margin:
                  LS(1)(BARLEN+1:) = ' '
                  J = INDEX (LS(1), ' ')
                  IF (J.LT.BARLEN) THEN
                     DO 190 I = J, BARLEN
                        LS(1)(I:I) = '-'
 190                    CONTINUE
                  ENDIF
               ELSE
                  WRITE (L6, *) 'Peculiar bar: [', LS(1)(:ITRIM(LS(1))),
     *               ']'
               ENDIF
            ENDIF
         ENDIF
C
         GO TO 110
C                                       IL not in CS:
 310     CALL FLUSH (L2, L6, OLMAX, LASTN, LC, NLS, LS, KO)
C                                       update LASTN (after FLUSH!):
         IF ((LASTN.NE.' ').AND.(IL.EQ.' ')) LASTN = ' '
         IF ((LASTN.EQ.' ').AND.(IL.NE.' ')) LASTN = IL
C                                       write IL:
         WRITE (L2, '(A)') IL(:ITRIM(IL))
         KO = KO + 1
         IF (MOD (KO, 2000).EQ.0) WRITE (L6, *) 'KO =', KO
         GO TO 110
C                                       That's all folks:
 910  CONTINUE
      CLOSE (UNIT=L1)
      WRITE (L6, *) 'final KI = ', KI
      CALL FLUSH (L2, L6, OLMAX, LASTN, LC, NLS, LS, KO)
      WRITE (L6, *) 'final KO = ', KO
      CLOSE (UNIT=L2)
C-----------------------------------------------------------------------
 1010 FORMAT (' Enter input WHOGETS-file  (w/o .ADR):', $)
 1015 FORMAT (A72)
 1016 FORMAT (' L',I1,'=', A)
 1017 FORMAT (' Cannot open file ', A)
 1030 FORMAT (' Enter output WHOGETS-file (w/o .ADR):', $)
      END
      SUBROUTINE FLUSH (L2, L6, OLMAX, LASTN, LC, NLS, LS, KO)
C-----------------------------------------------------------------------
C     Sort LS() and write it out.
C-----------------------------------------------------------------------
      INTEGER     L2, L6, OLMAX, NLS, KO
      CHARACTER   LASTN*(*), LC*(*), LS(*)*(*)
C
      INTEGER     I, J, ITRIM, OLDIM, NOL1
      PARAMETER   (OLDIM=84)
      CHARACTER   OL*(OLDIM), OL1*4, T*(OLDIM)
      LOGICAL     SWAP
C-----------------------------------------------------------------------
      IF (OLDIM.LT.OLMAX) STOP 'FLUSH: OLDIM.LT.OLMAX !'
      IF (LC.EQ.' ') GO TO 910
C                                       \c-lines not sorted:
      IF (LC.EQ.'c') GO TO 135
C                                       sort fields in LS():
      IF (NLS.GT.1) THEN
         J = 0
 110     SWAP = .FALSE.
            DO 130 I = 2, NLS
               IF (LS(I-1).GT.LS(I)) THEN
                  T = LS(I-1)
                  LS(I-1) = LS(I)
                  LS(I) = T
                  SWAP = .TRUE.
               END IF
 130           CONTINUE
         J = J + 1
         IF (J.GT.NLS) STOP 'FLUSH: J.GT.NLS !'
         IF (SWAP) GO TO 110
      END IF
C                                       check for equal fields:
      IF (NLS.GT.1) THEN
         DO 132 I = 2, NLS
            J = INDEX (LS(I), '=')
            IF (J.GT.0) THEN
               IF (LS(I-1)(:J).EQ.LS(I)(:J))
     *         WRITE (L6,*) '[', LASTN(:ITRIM(LASTN)), '] Duplicate: [',
     *            LS(I)(:ITRIM(LS(I))), ']'
            ENDIF
 132        CONTINUE
      ENDIF
C                                       write output lines:
 135  CONTINUE
      OL1 = '\' // LC
      NOL1 = ITRIM (OL1)
      OL = ' '
      IF (NLS.EQ.0) THEN
         WRITE (L2, '(A)') OL1(:NOL1)
         KO = KO + 1
C        WRITE (L6, *) OL1(:NOL1)
      ENDIF
      DO 140 I = 1, NLS
         J = ITRIM (OL)
         IF (J.GT.0) J = J + 1
         IF ((NOL1+J+(1+ITRIM(LS(I)))).GT.OLMAX) THEN
            WRITE (L2, '(A)') OL1(:NOL1) // OL(:ITRIM(OL))
            KO = KO + 1
            OL = ' '
         ENDIF
         OL(ITRIM (OL)+2:) = LS(I)
 140     CONTINUE
      IF (OL.NE.' ') THEN
         WRITE (L2, '(A)') OL1(:NOL1) // OL(:ITRIM(OL))
         KO = KO + 1
      ENDIF
C                                       clear LS():
      NLS = 0
      LC = ' '
C
 910  CONTINUE
      RETURN
      END
      INTEGER FUNCTION ITRIM (STRING)
C-----------------------------------------------------------------------
C   Function to determine length of a string. I.e., it trims trailing
C   blanks. Use with calls like:
C         TRIMMED = GROSS(1:ITRIM(GROSS))
C   DCW, NRAO-CV, 30Nov82.
C-----------------------------------------------------------------------
      CHARACTER STRING*(*)
C
      ITRIM = LEN (STRING) + 1
 10   CONTINUE
         ITRIM = ITRIM - 1
         IF (ITRIM.LT.1) GO TO 999
         IF (STRING(ITRIM:ITRIM).EQ.' ') GO TO 10
 999  RETURN
      END

      SUBROUTINE BLTLIS (LPOLY, LLV, NPOLY, NVERT, XV, YV, IY, LNX,
     *   IXL, IXU)
C-----------------------------------------------------------------------
C! lists any segments of current row which fall inside blotch regions
C# Map-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BLTLIS makes a list of line segments included inside a blotch area
C   Inputs:
C      LPOLY   I        beginning polygon number
C      LLV     I        beginning vertex number
C      NPOLY   I        Number of polygons
C      NVERT   I(*)     Number of vertices in each polygon
C      XV      I(*)     X position of vertices
C      YV      I(*)     Y position of vertices
C      IY      I        Row number
C   Output:
C      LNX     I        Number of segments
C      IXL     I(*)     low x index of segments
C      IXU     I(*)     high x index of segments
C-----------------------------------------------------------------------
      INTEGER   LPOLY, LLV, NPOLY, NVERT(*), XV(*), YV(*), IY, LNX,
     *   IXL(*), IXU(*)
C
      INTEGER   LP, IP, LV, NXE, Y1, Y2, IROUND, I, J, IX
      LOGICAL   SORTED
      REAL      RX, RY, ANG, ANGSUM, XSE(200)
C-----------------------------------------------------------------------
      LNX = 0
      LP = LLV
      RY = IY
      DO 80 IP = LPOLY,NPOLY
         LV = NVERT(IP) + LP - 2
C                                       find intersections
         NXE = 0
         DO 10 I = LP,LV
            Y1 = YV(I)
            Y2 = YV(I+1)
            IF ((IY.GE.MIN(Y1,Y2)) .AND. (IY.LE.MAX(Y1,Y2))) THEN
               NXE = NXE + 1
               IF (Y2.NE.Y1) THEN
                  XSE(NXE) = REAL(XV(I+1)-XV(I)) * REAL(IY-Y1)
     *               / REAL (Y2-Y1) + XV(I)
               ELSE
                  XSE(NXE) = XV(I)
                  END IF
               END IF
 10         CONTINUE
C                                       found some
         IF (NXE.GT.1) THEN
C                                       sort list
 20         SORTED = .TRUE.
            DO 30 I = 2,NXE
               IF (XSE(I-1).GT.XSE(I)) THEN
                  RX = XSE(I-1)
                  XSE(I-1) = XSE(I)
                  XSE(I) = RX
                  SORTED = .FALSE.
                  END IF
 30            CONTINUE
            IF (.NOT.SORTED) GO TO 20
C                                       which are interior
            DO 60 I = 2,NXE
               RX = (XSE(I-1) + XSE(I)) / 2.0
               IX = IROUND (RX)
C                                       test for on an edge
               DO 40 J = LP,LV
                  IF (IY.EQ.YV(J)) THEN
                     IF (IX.EQ.XV(J)) GO TO 55
                     IF ((IX.GE.XV(J)) .AND. (IX.LE.XV(J+1)) .AND.
     *                  (IY.EQ.YV(J+1))) GO TO 55
                     IF ((IX.LE.XV(J)) .AND. (IX.GE.XV(J+1)) .AND.
     *                  (IY.EQ.YV(J+1))) GO TO 55
                     END IF
 35               IF (IX.EQ.XV(J)) THEN
                     IF ((IY.GE.YV(J)) .AND. (IY.LE.YV(J+1)) .AND.
     *                  (IX.EQ.XV(J+1))) GO TO 55
                     IF ((IY.LE.YV(J)) .AND. (IY.GE.YV(J+1)) .AND.
     *                  (IX.EQ.XV(J+1))) GO TO 55
                     END IF
 40               CONTINUE
               ANGSUM = 0.0
               DO 50 J = LP,LV
                  CALL BLTGLE (RX, RY, XV(J), YV(J), XV(J+1),
     *               YV(J+1), ANG)
                  ANGSUM = ANGSUM + ANG
 50               CONTINUE
               IF (ABS(ANGSUM).LT.180.) GO TO 60
 55               LNX = LNX + 1
                  IXL(LNX) = IROUND (XSE(I-1))
                  IXU(LNX) = IROUND (XSE(I))
 60            CONTINUE
            END IF
         LP = LV + 2
 80      CONTINUE
      IF (LNX.LE.0) GO TO 999
C                                       compress list
      I = 1
 85   IF (I.LT.LNX) THEN
         I = I + 1
 90      IF (IXU(I-1).NE.IXL(I)) THEN
            GO TO 85
         ELSE
            J = LNX - I
            IXU(I-1) = IXU(I)
            LNX = LNX - 1
            IF (J.GT.0) THEN
               CALL COPY (J, IXL(I+1), IXL(I))
               CALL COPY (J, IXU(I+1), IXU(I))
               GO TO 90
               END IF
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE IMHCOR (IFIELD, CHINC)
C-----------------------------------------------------------------------
C! Corrects catalog header for imaging parameters.
C# Map Header
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999, 2005
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Corrects catalog header for imaging parameters.
C   Most input and output in common.
C   Input:
C      IFIELD   I        Field number, <0 => beam # -IFIELD
C      CHINC    I        Channel increment
C   Input from commons: (Includes DGDS, DMPR, DUVH, DSEL)
C      SCRBLK   I(256)   UV data catalog header.
C      NCHAVG   I        Number of channels to grid together.
C      BCHAN    I        First input channel number
C      ECHAN    I        Highest input channel number
C      FLDSZ    I(2,*)   Dimension of map in RA, Dec (cells)
C      NXBEM    I        X-Dimension (cells) of beam.
C      NYBEM    I        Y-Dimension (cells) of beam.
C      CELLSG   R(2)     The cell spacing in X and Y in arcseconds.
C      XSHIFT   R(16)    Shift in X (after rotation) in asec.
C                        in projected coordinates. 1 per field.
C      YSHIFT   R(16)    Shift in Y (after rotation) in asec.
C                        in projected coordinates. 1 per field.
C      STOKES   C*4      Stokes types wanted. 'I','Q','U','V','R','L'
C      FREQ     D        Average Frequency of output (Hz).
C   In/out from commons: (Includes DGDS, DMPR, DUVH, DSEL)
C      ICNTRX   I(*)     The center pixel in X for each field.  Optional
C                        but must be at least initialized to 0.  Set if
C                        input <= 0.
C      ICNTRY   I(*)     The center pixel in Y for each field.  Optional
C                        but must be at least initialized to 0.  Set if
C                        input <= 0.
C      CATBLK   I(256)   Image catalog header
C      UVROT    R        Set to rotation in UV header
C      MAPROT   R        Set to rotation in UV header
C-----------------------------------------------------------------------
      INTEGER   IFIELD, CHINC
C
      HOLLERITH CATH(256)
      INTEGER   II, IMODE, JERR, LFIELD
      REAL      CATR(256), CATSCR(256), MAPRR, XXP, YYP
      DOUBLE PRECISION CATD(128), CATSCD(64), STOK(7), XRA, XDEC
      CHARACTER ISTOK(6)*1, LL*8, MM*8, CFREQ*8, STOKE*8, JYBM*8, LLN*8,
     *   MMN*8
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMPR.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (CATBLK, CATH, CATR, CATD)
      EQUIVALENCE (SCRBLK, CATSCR, CATSCD)
      DATA ISTOK /'I','Q','U','V','R','L'/
      DATA    LL,         MM,       CFREQ,     STOKE,        JYBM
     *   /'RA---SIN', 'DEC--SIN', 'FREQ    ', 'STOKES  ',  'JY/BEAM '/
      DATA LLN, MMN /'RA---NCP','DEC--NCP'/
      DATA STOK /0.0D0,1.0D0,2.0D0,3.0D0,4.0D0,-1.0D0,-2.0D0/
C-----------------------------------------------------------------------
C                                       Get uv data rotation.
      CALL ROTFND (SCRBLK, UVROT, JERR)
      MAPROT = UVROT
      MAPRR = MAPROT * DG2RAD
C                                       Set for shift
      LFIELD = MAX (1, ABS(IFIELD))
      CALL XYSHFT (RA, DEC, XSHIFT(LFIELD), YSHIFT(LFIELD), MAPROT, XRA,
     *   XDEC)
      CALL SHFCRP (TYPUVD, RA, DEC, MAPROT, XRA, XDEC, XXP, YYP)
C                                       Beam.
      IF (IFIELD.LT.1) THEN
         CATR(KRCRP) = NXBEM(LFIELD) / 2
         CATR(KRCRP+1) = NYBEM(LFIELD) / 2 + 1
         IF (DO3DIM) THEN
            CATR(KRXSH) = XRA - RA
            CATR(KRYSH) = XDEC - DEC
            CATD(KDCRV) = XRA
            CATD(KDCRV+1) = XDEC
         ELSE
            CATR(KRXSH) = 0.0
            CATR(KRYSH) = 0.0
            CATD(KDCRV) = RA
            CATD(KDCRV+1) = DEC
            END IF
C                                       Map.
      ELSE
C                                       Set center pixel if necessary.
         IF (ICNTRX(LFIELD).LE.0) ICNTRX(LFIELD) = FLDSZ(1,LFIELD)
     *      / 2
         IF (ICNTRY(LFIELD).LE.0) ICNTRY(LFIELD) = FLDSZ(2,LFIELD)
     *      / 2 + 1
         CATR(KRXSH) = XRA - RA
         CATR(KRYSH) = XDEC - DEC
C                                       3D imaging
         IF (DO3DIM) THEN
            CATR(KRCRP) = ICNTRX(LFIELD)
            CATR(KRCRP+1) = ICNTRY(LFIELD)
            CATD(KDCRV) = XRA
            CATD(KDCRV+1) = XDEC
C                                       Bits of single tangent plane
         ELSE
            CATR(KRCRP) = ICNTRX(LFIELD) + XXP / ABS (CELLSG(1))
            CATR(KRCRP+1) = FLDSZ(2,LFIELD) - ICNTRY(LFIELD) + 2 -
     *         YYP / ABS (CELLSG(2))
            CATD(KDCRV) = RA
            CATD(KDCRV+1) = DEC
            END IF
         END IF
      CALL CHR2H (8, JYBM, 1, CATH(KHBUN))
      IF (TYPUVD.GE.0) THEN
         CALL CHR2H (8, LL, 1, CATH(KHCTP))
         CALL CHR2H (8, MM, 1, CATH(KHCTP+2))
      ELSE
         CALL CHR2H (8, LLN, 1, CATH(KHCTP))
         CALL CHR2H (8, MMN, 1, CATH(KHCTP+2))
         END IF
      CALL CHR2H (8, CFREQ, 1, CATH(KHCTP+2*2))
      CALL CHR2H (8, STOKE, 1, CATH(KHCTP+3*2))
      IMODE = 1
      DO 30 II = 1,6
         IF (STOKES(1:1).EQ.ISTOK(II)) IMODE = II
 30      CONTINUE
      CATD(KDCRV+3) = STOK(IMODE+1)
      IF (IFIELD.LE.0) CATD(KDCRV+3) = STOK(1)
      CATR(KRCIC) =  -ABS (CELLSG(1)) / 3.6D3
      CATR(KRCIC+1) = CELLSG(2) / 3.6D3
      IF (CATBLK(KINAX+2).LE.1) THEN
         CATR(KRCIC+2) = CATSCR(KRCIC+JLOCF) * MAX (1, NCHAVG)
      ELSE
         CATR(KRCIC+2) = CATSCR(KRCIC+JLOCF) * MAX (1, CHINC)
         END IF
      CATR(KRCIC+3) = 1.0
      CATR(KRCRP+3) = 1.
      CATR(KRCRT+1) = MAPROT
      CATR(KRCRT+0) = 0.0
      CATR(KRCRT+2) = 0.
      CATR(KRCRT+3) = 0.
      CATR(KRBLK) = 0.
C                                       imaging parameters
      IF (DO3DIM) THEN
         CATBLK(KIITY) = 2
         CATR(KRXPO) = 0.0
         CATR(KRYPO) = 0.0
      ELSE
         CATBLK(KIITY) = 1
         IF (IFIELD.LT.1) THEN
            CATR(KRXPO) = 0.0
            CATR(KRXPO) = 0.0
         ELSE
            CATR(KRXPO) = (CATR(KRCRP) - ICNTRX(IFIELD)) * CATR(KRCIC)
            CATR(KRYPO) = (CATR(KRCRP+1) - ICNTRY(IFIELD)) *
     *         CATR(KRCIC+1)
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE EXTIO (OPCODE, LUN, IND, IRNO, RECORD, BUFFER, IERR)
C-----------------------------------------------------------------------
C! does random access IO to extension files of the EXTINI/EXTIO type
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   EXTIO does random access I/O to an extension files.  Mixed reads
C   and writes are allowed if EXTINI was called 'WRIT'
C   Inputs:
C      OPCODE         C*4  Opcode 'READ','WRIT','CLOS'
C      LUN            I    Logical unit number
C      IND            I    FTAB pointer
C      IRNO           I    Logical record no. 0=> next.
C      RECORD( )      I    Array containing record to be written
C      BUFFER( )      I    Work buffer = 512 bytes + enough 512 byte
C                          blocks for at least one full logical record.
C   Output:
C      RECORD( )      I    Array containing record read.
C      BUFFER( )      I    buffer.
C      IERR           I    Return error code 0 => OK
C                                1 => file not open
C                                2 => input error
C                                3 => I/O error
C                                4 => attempt to read past end of data
C                                     or write past log. or phys.
C                                     record 32766.
C   IMPORTANT NOTE:  the contents of BUFFER should not be changed
C   except by EXTIO between the time EXTINI is called until the file
C   is closed.  The exception is that the user portion of the header
C   record is available.
C   Programmer: W. D. Cotton, Sept. 1981
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   LUN, IND, IRNO, RECORD(*), BUFFER(*), IERR
C
      INTEGER   LRNO, I, IER, INDEX, IOP, LIMIT, LROFF, NADD, NEXP,
     *   NPB, JBUF
      CHARACTER PNAME*48
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Determine logical rec. no.
      IERR = 2
      LRNO = IRNO
      IF (LRNO.LE.0) LRNO = BUFFER(56) + 1
C                                       Determine opcode.
      IOP = 0
      IF (OPCODE.EQ.'READ') IOP = 1
      IF (OPCODE.EQ.'WRIT') IOP = 2
      IF (OPCODE.EQ.'CLOS') GO TO 200
C                                       Unknown opcode.
      IF (IOP.GT.0) GO TO 20
         WRITE (MSGTXT,1000) OPCODE
         GO TO 990
C                                       Check record no.
 20   IERR = 4
      IF ((IOP.EQ.1) .AND. (LRNO.GT.BUFFER(4))) GO TO 999
C                                       Determine phys. block
      NPB = 1
      IF (BUFFER(7).LT.0) NPB = (1 - LRNO) * BUFFER(7) + 1
      IF (BUFFER(7).GT.0) NPB = (LRNO-1)/BUFFER(7) + 1
C                                       Determine off of log.
      LROFF = 257
      IF (BUFFER(7).GT.0) LROFF = (LRNO - (NPB-1)*BUFFER(7) - 1) *
     *   BUFFER(53) + 257
C                                       New record required
      IF (BUFFER(55).EQ.NPB) GO TO 55
C                                       If write-enable check if going
C                                       to new phys. rec - if so write
         LIMIT = -BUFFER(7)
         LIMIT = MAX (1, LIMIT)
C                                       Write OLD block
C                                       Don't write on first access
         IF (BUFFER(54).NE.2) GO TO 35
            IF (BUFFER(55).LE.0) GO TO 35
            JBUF = BUFFER(55)+1
            DO 30 I = 1,LIMIT
               INDEX = I * 256 + 1
               CALL ZFIO ('WRIT', LUN, IND, JBUF, BUFFER(INDEX), IER)
               JBUF = JBUF + 1
               IF (IER.EQ.0) GO TO 30
                  WRITE (MSGTXT,1020) 'WRITE', IER
                  GO TO 990
 30            CONTINUE
C                                       Extend if necessary
 35      IF ((NPB+LIMIT.LE.BUFFER(1)) .AND. (LRNO.LE.BUFFER(3)))
     *      GO TO 45
            NADD = 0.1 * BUFFER(3) + 1.5
            NADD = MIN (BUFFER(2), NADD)
            IF (BUFFER(7).LE.0) NEXP = NADD * ABS(BUFFER(7))
            IF (BUFFER(7).GT.0) NEXP = NADD / BUFFER(7) + 1
            IERR = 3
            CALL H2CHR (48, 1, BUFFER(17), PNAME)
            CALL ZEXPND (LUN, BUFFER(29), PNAME, NEXP, IER)
            IF (IER.EQ.0) GO TO 40
               WRITE (MSGTXT,1035) IER
               GO TO 990
C                                       Update info
 40         BUFFER(1) = BUFFER(1) + NEXP
            NADD = NEXP * BUFFER(7)
            IF (BUFFER(7).LT.0) NADD = NEXP / ABS (BUFFER(7))
            BUFFER(3) = BUFFER(3) + NADD
C                                       New record read.
 45      IF ((LRNO.GT.BUFFER(4)) .AND. (BUFFER(55).GT.0)) GO TO 55
            JBUF = NPB + 1
            DO 50 I = 1,LIMIT
               INDEX = 256 * I + 1
               CALL ZFIO ('READ', LUN, IND, JBUF, BUFFER(INDEX), IER)
               JBUF = JBUF + 1
               IF (IER.EQ.0) GO TO 50
                  WRITE (MSGTXT,1020) 'READ', IER
                  GO TO 990
 50            CONTINUE
 55      BUFFER(55) = NPB
C                                       Do data transfer
      BUFFER(56) = LRNO
      IERR = 0
      LIMIT = BUFFER(53)
      IF (IOP.EQ.1) CALL COPY (LIMIT, BUFFER(LROFF), RECORD)
      IF (IOP.EQ.1) GO TO 999
         CALL COPY (LIMIT, RECORD, BUFFER(LROFF))
         BUFFER(4) = MAX (BUFFER(4), LRNO)
         GO TO 999
C                                       Close file
C                                       If write-enabled write.
 200  IF (BUFFER(54).EQ.1) GO TO 220
C                                       Write header
         CALL ZFIO ('WRIT', LUN, IND, 1, BUFFER, IER)
         IF (IER.EQ.0) GO TO 205
            IERR = 3
            WRITE (MSGTXT,1020) 'WRITE', IER
            GO TO 990
C                                       Write data
 205     IF (BUFFER(55).LE.0) GO TO 220
            LIMIT = - BUFFER(7)
            LIMIT = MAX (1, LIMIT)
            JBUF = BUFFER(55) + 1
            DO 210 I = 1,LIMIT
               INDEX = 256 * I + 1
               CALL ZFIO ('WRIT', LUN, IND, JBUF, BUFFER(INDEX), IER)
               JBUF = JBUF + 1
               IF (IER.EQ.0) GO TO 210
                  IERR = 3
                  WRITE (MSGTXT,1020) 'WRITE', IER
                  GO TO 990
 210           CONTINUE
C                                       Close.
 220  CALL ZCLOSE (LUN, IND, IER)
      IERR = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('EXTIO: UNKNOWN OPCODE: ',A4)
 1020 FORMAT ('EXTIO: ',A,' ERROR ',I3)
 1035 FORMAT ('EXTIO: ZEXPND ERROR',I3,' EXPANDING FILE')
      END

      SUBROUTINE CMPARM (BIF, EIF, BCHAN, ECHAN, BCHANS, ECHANS,
     *   NDECMP, DECMP)
C-----------------------------------------------------------------------
C! Determines blocks of data in a vis. record to decompress
C# Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Determines the number of blocks of data in a compressed visibility
C   record to decompress and the length and offsets of these blocks.
C   It is assumed that UVPGET has been called with the relevant CATBLK
C   and the values in DUVH.INC are correct.
C   Inputs:
C      BIF      I       First IF number
C      EIF      I       Highest IF number
C      BCHAN    I       First channel number
C      ECHAN    I       Highest channel number
C      BCHANS   I       First channel number if smoothing
C      ECHANS   I       Last channel number if smoothing
C   Inputs from common DCAT.INC:
C      CATBLK   I(256)  Catalogue header record of compressed file
C   Output:
C      NDECMP   I        Number of entries in DECMP
C      DECMP    I(2,*)   (1,*) = number of packed correlator values
C                        (2,*) = 0-rel offset in vis data.
C                        (from beginning of vis data NOT ran. parms.)
C-----------------------------------------------------------------------
      INTEGER   BIF, EIF, BCHAN, ECHAN, NDECMP, DECMP(2,*), BCHANS,
     *   ECHANS
C
      INTEGER   I, J, LIMS, NIF, NCHAN, IBCHAN, IECHAN
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       Packed data?
      IF (CATBLK(KINAX).GT.1) GO TO 999
C                                       Smoothed = use wider range
C                                       of channels
      IF ((BCHANS.GT.0) .AND. (ECHANS.GT.0)) THEN
         IBCHAN = BCHANS
         IECHAN = ECHANS
      ELSE
         IBCHAN = BCHAN
         IECHAN = ECHAN
         END IF
C                                       Check if all requested.
      NIF = 1
      IF (JLOCIF.GT.0) NIF = CATBLK(KINAX+JLOCIF)
      NCHAN = CATBLK(KINAX+JLOCF)
      IF (((BIF.EQ.1) .AND. (EIF.EQ.NIF)) .AND.
     *   ((IBCHAN.EQ.1) .AND. (IECHAN.EQ.NCHAN))) THEN
         NDECMP = 1
         DECMP(1,1) = LREC - NRPARM
         DECMP(2,1) = 0
         GO TO 999
         END IF
C                                       Continuum
      IF (NCHAN.LE.1) THEN
         NDECMP = 1
         DECMP(1,NDECMP) = (EIF-BIF+1) * CATBLK(KINAX+JLOCS)
         DECMP(2,NDECMP) = (BIF-1) * INCIF
         GO TO 999
         END IF
C                                       Line
      IF ((JLOCS.LT.JLOCF) .AND. ((JLOCIF.GE.3) .OR. (JLOCIF.LE.0)))
     *   THEN
C                                       Stokes most rapid var.
         NDECMP = 0
         DO 200 I = BIF,EIF
            NDECMP = NDECMP + 1
            DECMP(1,NDECMP) = (IECHAN-IBCHAN+1) * CATBLK(KINAX+JLOCS)
            DECMP(2,NDECMP) = (IBCHAN-1) * INCF + (I-1) * INCIF
 200        CONTINUE
         GO TO 999
         END IF
      IF ((JLOCF.LT.JLOCS) .AND. ((JLOCIF.GE.3) .OR. (JLOCIF.LE.0)))
     *   THEN
C                                       Frequency most rapid var.
         LIMS = CATBLK(KINAX+JLOCS)
         NDECMP = 0
         DO 300 I = BIF,EIF
            DO 290 J = 1,LIMS
               NDECMP = NDECMP + 1
               DECMP(1,NDECMP) = IECHAN - IBCHAN + 1
               DECMP(2,NDECMP) = (IBCHAN-1) * INCF + (I-1) * INCIF +
     *            (J-1) * INCS
 290           CONTINUE
 300        CONTINUE
         GO TO 999
         END IF
C                                       Anything else - do all

      NDECMP = 1
      DECMP(1,1) = LREC - NRPARM
      DECMP(2,1) = 0
C
 999  RETURN
      END

      SUBROUTINE XYVAL (XPIX, YPIX, X, Y, Z, IERR)
C-----------------------------------------------------------------------
C! returns coordinate values corresponding to specified pixel position
C# Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2013, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   XYVAL determines the coordinate value (X,Y,Z) corresponding to the
C   pixel location (XPIX,YPIX).  The pixel values need not be integers.
C   The necessary map header data is passed via common /LOCATI/
C   requiring a previous call to SETLOC. This program is the inverse of
C   XYPIX.
C   Inputs:
C      XPIX    R    Pixel location, x-coordinate
C      YPIX    R    Pixel location, y-coordinate
C   Outputs:
C      X       D    X-coordinate value at pixel location
C      Y       D    Y-coordinate value at pixel location
C      Z       D    Z-coordinate value (if part of a position
C                   pair with either X or Y)
C                   03 March 2025 - also any other 3rd axis value
C      IERR    I    0 ok, 1 out of range, 2 bad type, 3 undefined
C   Common inputs:
C      /LOCATI/ position parms deduced from the map header by
C               subroutine SETLOC
C   UNITS ARE AS IN THE MAPHEADER: degrees for position coords
C-----------------------------------------------------------------------
      DOUBLE PRECISION X, Y, Z
      REAL      XPIX, YPIX
C
      REAL      COSR, SINR
      DOUBLE PRECISION A, B, C, DX, DY, DZ, TEMP
      INTEGER   IERR, I
      INCLUDE 'INCS:DLOC.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Offset from ref pixel
      DX = (XPIX-RPLOC(1,LOCNUM)) * AXINC(1,LOCNUM)
      DY = (YPIX-RPLOC(2,LOCNUM)) * AXINC(2,LOCNUM)
      IF ((AXTYP(LOCNUM).EQ.2) .OR. (AXTYP(LOCNUM).EQ.3)) DZ =
     *   (ZDEPTH(ZAXIS(LOCNUM)-2,LOCNUM) - RPLOC(3,LOCNUM)) *
     *   AXINC(3,LOCNUM)
C                                       Take out rotation
      IF ((ROT(LOCNUM).NE.0.0) .AND. (AXTYP(LOCNUM).GT.0) .AND.
     *   (AXTYP(LOCNUM).LT.4)) THEN
         COSR = COS(ROT(LOCNUM)*COND2R)
         SINR = SGNROT(LOCNUM) * SIN(ROT(LOCNUM)*COND2R)
         IF (AXTYP(LOCNUM).EQ.1) THEN
            TEMP = DX * COSR - DY * SINR
            DY = DY * COSR + DX * SINR
            DX = TEMP
         ELSE IF (AXTYP(LOCNUM).EQ.2) THEN
            TEMP = DX * COSR - DZ * SINR
            DZ = DZ * COSR + DX * SINR
            DX = TEMP
         ELSE IF (AXTYP(LOCNUM).EQ.3) THEN
            TEMP = DY * COSR - DZ * SINR
            DZ = DZ * COSR + DY * SINR
            DY = TEMP
            END IF
         END IF
C                                       Linear transformation
      Z = 0.0
      I = AXFUNC(KLOCL(LOCNUM)+1,LOCNUM)
      IF ((CORTYP(LOCNUM).LE.0) .OR. (AXTYP(LOCNUM).EQ.4) .OR.
     *   (I.LE.1)) THEN
         IF ((AXTYP(LOCNUM).GT.1) .AND. (AXTYP(LOCNUM).LT.4)) Z =
     *      RPVAL(3,LOCNUM) + DZ
         X = RPVAL(1,LOCNUM) + DX
         Y = RPVAL(2,LOCNUM) + DY
         Z = CURNTV(1)
C                                       Partly non-linear
      ELSE
         A = RPVAL(1,LOCNUM) * COND2R
         B = RPVAL(2,LOCNUM) * COND2R
         C = RPVAL(3,LOCNUM) * COND2R
         DX = DX * COND2R
         DY = DY * COND2R
         DZ = DZ * COND2R
C                                       x, y => L,M
         IF (CORTYP(LOCNUM).EQ.1) THEN
            CALL NEWPOS (I, A, B, DX, DY, X, Y, IERR)
C                                       x, y => M, L
         ELSE IF (CORTYP(LOCNUM).EQ.2) THEN
            CALL NEWPOS (I, B, A, DY, DX, Y, X, IERR)
C                                       x, z => L, M
         ELSE IF (CORTYP(LOCNUM).EQ.3) THEN
            CALL NEWPOS (I, A, C, DX, DZ, X, Z, IERR)
            Y = B + DY
C                                       x, z => M, L
         ELSE IF (CORTYP(LOCNUM).EQ.4) THEN
            CALL NEWPOS (I, C, A, DZ, DX, Z, X, IERR)
            Y = B + DY
C                                       y, z => L, M
         ELSE IF (CORTYP(LOCNUM).EQ.5) THEN
            CALL NEWPOS (I, B, C, DY, DZ, Y, Z, IERR)
            X = A + DX
C                                       y, z => M, L
         ELSE IF (CORTYP(LOCNUM).EQ.6) THEN
            CALL NEWPOS (I, C, B, DZ, DY, Z, Y, IERR)
            X = A + DX
            END IF
C                                       correct units back
         X  = X  / COND2R
         Y  = Y  / COND2R
         Z  = Z  / COND2R
         DX = DX / COND2R
         DY = DY / COND2R
         IF (CORTYP(LOCNUM).LE.2) Z = CURNTV(1)
         END IF
C                                       Felocity
      IF ((KLOCF(LOCNUM).EQ.0) .AND. (AXFUNC(1,LOCNUM).EQ.1)) X =
     *   RPVAL(1,LOCNUM) + DX / (1.0D0 + AXDENU(LOCNUM) *
     *   (XPIX-RPLOC(1,LOCNUM)))
      IF ((KLOCF(LOCNUM).EQ.1) .AND. (AXFUNC(2,LOCNUM).EQ.1)) Y =
     *   RPVAL(2,LOCNUM) + DY / (1.0D0 + AXDENU(LOCNUM) *
     *   (YPIX-RPLOC(2,LOCNUM)))
C
 999  RETURN
      END

      SUBROUTINE SVANDT (N, X, Y)
C-----------------------------------------------------------------------
C! Solve a Vandermonde system of equations for polynomial interpolation
C# Util
C-----------------------------------------------------------------------
C;  Copyright (C) 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Solve the Vandermonde system of equations Va = y where V is the
C   transposed Vandermonde matrix
C
C        +-                                    -+
C        |   1  X(1)   X(1)**2   ... X(1)**N    |
C        |   1  X(2)   X(2)**2   ... X(2)**N    |
C        |   ...          ...    ...   ...      |
C        |   1  X(N+1) X(N+1)**2 ... X(N+1)**N  |
C        +-                                    -+
C
C   This usually occurs when trying to interpolate tabulated values
C   of a function (y) with an N-th order polynomial in which case
C   the solution vector, a, contains the polynomial coeeficients.
C
C   This routine uses Algorithm 4.6.1 from Matrix Computations (second
C   edition) by Gene H. Glob and Charles F. van Loan, John Hopkins
C   University Press, 1989.  This requires 5 * N**2 / 2 FLOPS.
C
C   Inputs:
C      N        I        The order of the polynomial
C      X        R(N+1)   Sample points of the  function to be
C                        interpolated
C
C   Input/Output
C      Y        R(N+1)   The sampled function values on input,
C                        overwritten by the polynomial coefficients.
C-----------------------------------------------------------------------
      INTEGER   N
      REAL      X(N+1), Y(N+1)
C
      INTEGER   I, K
C-----------------------------------------------------------------------
C                                       Calculate the Newton
C                                       representation of the
C                                       interpolating polynomial.
      DO 20 K = 0, N - 1
         DO 10 I = N + 1, K + 2, -1
            Y(I) = (Y(I) - Y(I - 1)) / (X(I) - X(I - K - 1))
   10    CONTINUE
   20 CONTINUE
C                                       Calculate polynomial
C                                       coefficients.
      DO 40 K = N, 1, -1
         DO 30 I = K, N
            Y(I) = Y(I) - Y(I + 1) * X(K)
   30    CONTINUE
   40 CONTINUE
C
      END

      SUBROUTINE YFDBCK (COLOR, CHANNL, BITPL, PIXOFF, BYPIFM, EXTERN,
     *   ZERO, ACCUM, ADDWRT, IERR)
C-----------------------------------------------------------------------
C! causes a feedback operation in the TV
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YFDBCK sends a feedback command to the TV
C   Inputs:
C      COLOR   I    bit map of color to be fedback (RGB = 4,2,1)
C      CHANNL  I    bit map of channels to receive feedback
C      BITPL   I    bit map of bit planes to receive feedback
C      PIXOFF  I    offset fedback image to left by 0 - 1 pixels
C      BYPIFM  L    F => image goes thru IFM lookup before store
C      EXTERN  L    T => image from external input (iedigitizer)
C      ZERO    L    T => feed back all zeros
C      ACCUM   L    T => use 16-bit accumulator mode then CHANNL must
C                        give even-odd pair lsbyte goes to even (lower)
C                        # channel
C      ADDWRT  L    T => additive write  F => replace old data
C   Outputs:
C      IERR    I    error code of Z...XF: 0 -> ok
C                                         2 -> input error
C   IIS Model 70 version
C-----------------------------------------------------------------------
      INTEGER   COLOR, CHANNL, BITPL, PIXOFF, IERR
      LOGICAL   BYPIFM, EXTERN, ZERO, ACCUM, ADDWRT
C
      INTEGER   NB, UNIT, HEADER(8), BUFFER, BUFSIZ, BITS(16)
      LOGICAL   COMAND, VRTRTC
      DATA UNIT, COMAND, VRTRTC /5,.FALSE.,.FALSE./
      DATA BUFSIZ /1/
C-----------------------------------------------------------------------
C                                        check error if not ZERO
      IF (ZERO) GO TO 10
         IERR = 2
         IF ((PIXOFF.LT.0) .OR. (PIXOFF.GT.1)) GO TO 999
         IF ((.NOT.EXTERN) .AND. (COLOR.NE.1) .AND. (COLOR.NE.2) .AND.
     *      (COLOR.NE.4)) GO TO 999
C                                        Standard header
 10   CALL YMKHDR ('WRIT', UNIT, COMAND, BUFSIZ, 0, 0, CHANNL, BITPL,
     *   VRTRTC, HEADER)
C                                        header controls
      CALL ZGTBIT (16, HEADER(1), BITS)
      IF (BYPIFM) BITS(14) = 1
      IF (ADDWRT) BITS(12) = 1
      IF (ACCUM)  BITS(11) = 1
      BITS(13) = 1
      BITS(10) = 1
      CALL ZPTBIT (16, HEADER(1), BITS)
C                                        data word
      CALL FILL (16, 0, BITS)
      CALL ZGTBIT (3, COLOR, BITS(1))
      CALL ZGTBIT (1, PIXOFF, BITS(9))
      IF (EXTERN) BITS(15) = 1
      IF (ZERO  ) BITS(16) = 1
      CALL ZPTBIT (16, BUFFER, BITS)
C                                        IO
      NB = 2 * BUFSIZ
      CALL ZM70XF ('WRIT', NB, HEADER, BUFFER, IERR)
C
 999  RETURN
      END

      SUBROUTINE CAIO (OPCODE, KEYARR, IERR)
C-----------------------------------------------------------------------
C! does IO to an CA table
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  Routine to set up, or read, the arrays containing the keyword values
C  from CA tables.
C  Only called from CAINI.
C  Input:
C     OPCODE        C*4      If 'WRIT' then write keywords into KEYVAL
C                            array, if 'READ', then read them from it.
C  Input/output:
C     KEYARR(*)     I        The KEYVAL array, name different because
C                            of equivalence.
C  Input/output via common:
C     KLOCS(*)      I        Array defining location of keywords within
C                            the KEYVAL array.
C     KEYTYP(*)     I        Array defining type of keyword in KEYVAL
C                            array.
C     OBSCODE       C*8      Observing code
C     NOSTKD        I        # polzns in the data
C     STK1          I        First Stokes parameter in the data
C     NOBAND        I        # bands (IF's) in the data.
C     NOCHAN        I        # spectral channels in the data.
C     REFFRQ        D        Freq. at reference pixel (Hz)
C     CHNBW         R        Bandwidth of single spectral channel (Hz)
C     REFPIX        R        Reference pixel
C     NOANT         I        # antennas for which there is info.
C     NOPOL         I        # polarisations for which there is info.
C     TABREV        I        Table revision number.
C  Output:
C     IERR          I        error code: 0 => OK
C                                        1 => pointer > max size array
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DGLB.INC'
      INTEGER   KEYARR(*), IERR, IPT
      CHARACTER OPCODE*4
      DOUBLE PRECISION KEYVAD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAV.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       write keyword values into the
C                                       KEYVAL array to be transferred
C                                       to disc
      IF (OPCODE.EQ.'WRIT') THEN
         IPOINT = 1
         IPT = 1
C                                       Observing code
         KLOCS(IPT) = IPOINT
         KEYTYP(IPT) = TABHOL
         CALL CHR2H (8, OBSCOD, 1, KEYVAH(IPOINT))
         IPOINT = IPOINT + 2
         IF (IPOINT.GT.MAXWCA) GO TO 900
         IPT = IPT + 1
C                                       # Stokes in data
         KLOCS(IPT) = IPOINT
         KEYTYP(IPT) = TABINT
         KEYVAL(IPOINT) = NOSTKD
         IPOINT = IPOINT + 1
         IF (IPOINT.GT.MAXWCA) GO TO 900
         IPT = IPT + 1
C                                       1st Stokes in data
         KLOCS(IPT) = IPOINT
         KEYTYP(IPT) = TABINT
         KEYVAL(IPOINT) = STK1
         IPOINT = IPOINT + 1
         IF (IPOINT.GT.MAXWCA) GO TO 900
         IPT = IPT + 1
C                                       # bands (IF's) in data
         KLOCS(IPT) = IPOINT
         KEYTYP(IPT) = TABINT
         KEYVAL(IPOINT) = NOBAND
         IPOINT = IPOINT + 1
         IF (IPOINT.GT.MAXWCA) GO TO 900
         IPT = IPT + 1
C                                       # spectral channels in data
         KLOCS(IPT) = IPOINT
         KEYTYP(IPT) = TABINT
         KEYVAL(IPOINT) = NOCHAN
         IPOINT = IPOINT + 1
         IF (IPOINT.GT.MAXWCA) GO TO 900
         IPT = IPT + 1
C                                       Ref freq
         KLOCS(IPT) = IPOINT
         KEYTYP(IPT) = TABDBL
         CALL RCOPY (NWDPDP, REFFRQ, KEYVAR(IPOINT))
         IPOINT = IPOINT + NWDPDP
         IF (IPOINT.GT.MAXWCA) GO TO 900
         IPT = IPT + 1
C                                       Chn bw
         KLOCS(IPT) = IPOINT
         KEYTYP(IPT) = TABDBL
         KEYVAD = CHNBW
         CALL RCOPY (NWDPDP, KEYVAD, KEYVAR(IPOINT))
         IPOINT = IPOINT + NWDPDP
         IF (IPOINT.GT.MAXWCA) GO TO 900
         IPT = IPT + 1
C                                       Ref. pixel
         KLOCS(IPT) = IPOINT
         KEYTYP(IPT) = TABDBL
         KEYVAD = REFPIX
         CALL RCOPY (NWDPDP, KEYVAD, KEYVAR(IPOINT))
         IPOINT = IPOINT + NWDPDP
         IF (IPOINT.GT.MAXWCA) GO TO 900
         IPT = IPT + 1
C                                       # antennas with info
         KLOCS(IPT) = IPOINT
         KEYTYP(IPT) = TABINT
         KEYVAL(IPOINT) = NOANT
         IPOINT = IPOINT + 1
         IF (IPOINT.GT.MAXWCA) GO TO 900
         IPT = IPT + 1
C                                       # polarisations with info
         KLOCS(IPT) = IPOINT
         KEYTYP(IPT) = TABINT
         KEYVAL(IPOINT) = NOPOL
         IPOINT = IPOINT + 1
         IF (IPOINT.GT.MAXWCA) GO TO 900
         IPT = IPT + 1
C                                       Table revision number
         KLOCS(IPT) = IPOINT
         KEYTYP(IPT) = TABINT
         KEYVAL(IPOINT) = TABREV
         IPOINT = IPOINT + 1
C                                       fill in array to be passed
C                                       back
         CALL COPY (MAXWCA, KEYVAL, KEYARR)
C                                       read keyword values from
C                                       KEYVAL array
      ELSE IF (OPCODE.EQ.'READ') THEN
         CALL COPY (MAXWCA, KEYARR, KEYVAL)
         IPT = 1
C                                       Observing code
         IPOINT = KLOCS(IPT)
         CALL H2CHR (8, 1, KEYVAH(IPOINT), OBSCOD)
         IPT = IPT + 1
C                                       # Stokes in data
         IPOINT = KLOCS(IPT)
         NOSTKD = KEYVAL(IPOINT)
         IPT = IPT + 1
C                                       1st Stokes in data
         IPOINT = KLOCS(IPT)
         STK1 = KEYVAL(IPOINT)
         IPT = IPT + 1
C                                       # band's (IF's) in data
         IPOINT = KLOCS(IPT)
         NOBAND = KEYVAL(IPOINT)
         IPT = IPT + 1
C                                       # spectral channels in data
         IPOINT = KLOCS(IPT)
         NOCHAN = KEYVAL(IPOINT)
         IPT = IPT + 1
C                                       Ref frq
         IPOINT = KLOCS(IPT)
         IF (KEYTYP(IPT).EQ.TABDBL) THEN
            CALL DBCOPY (1, KEYVAR(IPOINT), REFFRQ)
         ELSE
            REFFRQ = KEYVAR(IPOINT)
            END IF
         IPT = IPT + 1
C                                       Chn. bw
         IPOINT = KLOCS(IPT)
         IF (KEYTYP(IPT).EQ.TABDBL) THEN
            CALL DPCOPY (1, KEYVAR(IPOINT), KEYVAD)
            CHNBW = KEYVAD
         ELSE
            CHNBW = KEYVAR(IPOINT)
            END IF
         IPT = IPT + 1
C                                       Ref. pixel
         IPOINT = KLOCS(IPT)
         IF (KEYTYP(IPT).EQ.TABDBL) THEN
            CALL DPCOPY (1, KEYVAR(IPOINT), KEYVAD)
            REFPIX = KEYVAD
         ELSE
            REFPIX = KEYVAR(IPOINT)
            END IF
         IPT = IPT + 1
C                                       # antennas with info
         IPOINT = KLOCS(IPT)
         NOANT = KEYVAL(IPOINT)
         IPT = IPT + 1
C                                       # polarisations with info
         IPOINT = KLOCS(IPT)
         NOPOL = KEYVAL(IPOINT)
         IPT = IPT + 1
C                                       Table revision number
         IPOINT = KLOCS(IPT)
         TABREV = KEYVAL(IPOINT)
         END IF
      GO TO 999
C                                       MAXWCA error
 900  WRITE (MSGTXT,1000) IPOINT, MAXWCA
      CALL MSGWRT (6)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CAIO: POINTER VALUE: ',I4,' > MAXIMUM: ',I4)
      END

      SUBROUTINE ZSHCM2 (LCOM, COMMND, LTASK, OUTDEV, IERR)
C-----------------------------------------------------------------------
C! execute a job-control level command string
C# Z3 System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Execute a "shell" (DCL or sh) command string below present task.
C   Inputs:
C      LCOM     I       Length of commnd
C      COMMND   C*(*)   The command line string
C      LTASK    I       Length of taskout
C      OUTDEV   C*(*)   File/device for standard output/error
C   Output:
C      IERR     I       Error return: 0 means okay
C                          1 input command too long
C                          2 some system error occurred
C   VMS version - true CHARACTER inputs.
C-----------------------------------------------------------------------
      INTEGER   LCOM, LTASK, IERR
      CHARACTER COMMND*(*), OUTDEV*(*)
C
      INTEGER   STATUS, LIB$SPAWN, PRCERR, I, ITRIM, JERR, ZAND
      CHARACTER PRCNAM*11, CTEMP*1, ZTEMP*8
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL ZEHEX (NPOPS, 1, CTEMP)
      I = ITRIM (TSKNAM)
      PRCNAM = TSKNAM(:I) // CTEMP // '_SUB'
      I = I + 5
      STATUS = LIB$SPAWN (COMMND, , OUTDEV, , PRCNAM(:I), , PRCERR, , ,
     *   , , )
      IERR = 0
      IF (STATUS.NE.1) THEN
         CALL ZHEX (STATUS, 8, ZTEMP)
         WRITE (MSGTXT,1010) ZTEMP
         CALL MSGWRT (8)
         IERR = 64
         END IF
      JERR = ZAND (PRCERR, 1)
      IF (JERR.NE.1) THEN
         CALL ZHEX (PRCERR, 8, ZTEMP)
         WRITE (MSGTXT,1020) ZTEMP
         CALL MSGWRT (8)
         IERR = IERR + 32
         CALL ZERROR ('ZSHCMD', PRCERR, ' ', -999, .FALSE.)
         END IF
C
 990  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('FAILURE: SPAWN STATUS=',A)
 1020 FORMAT ('SPAWNED PROCESS STATUS RETURNED=',A,' (NORMAL=1)')
      END

      SUBROUTINE CONV2 (APCORE, LUN, VOL, FIL, BO, XBUFF1, BUFSZ1,
     *   XBUFF2, BUFSZ2, XBUFF3, BUFSZ3, NX, NY, FACTOR, IERR)
C-----------------------------------------------------------------------
C! Second of four routines to convolve two real images.
C# AP-FFT Math Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CONV2 = second of four routines to convolve two real images.
C   This routine reads data from the appropriate locations in the work
C   file (or the AP memory if sufficient) and completes the transpose.
C   Then the second transforms are done, the data is multiplied by
C   the convolving function and written to the output file.
C   If the map will all fit in the AP CONV1 will have left it
C   fully transposed in the AP and the WORK file will not be read.
C   If the data is left in memory, rows 1 and NX/2+1 are already
C   processed.
C   Input:
C      LUN      I(5)     LUNs for files
C      VOL      I(5)     Volume numbers for the files.
C      FIL      C(5)*48  Physical names for the files.
C      BO       I(5)     Block offsets for the files.
C      XBUFF1   R        Work buffers for I/O
C      XBUFF2   R        Work buffers for I/O
C      XBUFF3   R        Work buffers for I/O
C      NX       I        Number of grid cells in X of maps.
C      NY       I        Number of grid cells in Y of maps.
C      FACTOR   R        Normalization factor for convolving function;
C                        i.e. is multiplied by the transform of the
C                        convolving fn.
C   Output:
C      BUFSZ1   I        Size in bytes for XBUFF1
C      BUFSZ2   I        Size in bytes for XBUFF2
C      BUFSZ3   I        Size in bytes for XBUFF3
C      IERR     I        Return error code, 0 = >OK,  otherwise failed.
C                           3 => Size less than 4 in one dimension.
C   The Transformed Map/File will be left in File 3.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      CHARACTER FIL(5)*48
      INTEGER   LUN(5), VOL(5), BO(5), BUFSZ1, BUFSZ2, BUFSZ3, NX, NY,
     *   IERR
      REAL      XBUFF1(*), XBUFF2(*), XBUFF3(*), FACTOR
C
      CHARACTER BADOP*4
      INTEGER   JAPWRD,  NSKIP, IWIN(4), IFIRST, NOROW, BLCNT, NX2, NY2,
     *   KOFF, JDIR, LNDEX, KNDEX, NWORD, HALFNX, ONENX, TWONX, ONENY,
     *   TWONY, ONECOL, TWOCOL, ONEROW, TWOROW, NSHOV, OMPASS, NUM,
     *   JNDEX, INDEX, I4TEMP, LOOP, FIND1, FIND2, FIND3, BIND1, BIND2,
     *   BIND3, BADFIL, WIN(4), FIND5, BIND5, APSIZ, NBUF, MPASS,
     *   IFIN, IER, I, IC, J, LROW, JSTART, NCOL, NROW
      REAL      XR, XI
      LOGICAL   MAP, WAIT, EXCL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DAPM.INC'
      DATA MAP, WAIT, EXCL /2*.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IERR = 0
C                                       Determine power of 2 AP size.
      JAPWRD = PSAPNW
      CALL AP2SIZ (JAPWRD, APSIZ)
      NWORD = APSIZ
C                                       Make sure min. dim .ge. 4
      IF ((NX.LT.4) .OR. (NY.LT.4)) THEN
           WRITE (MSGTXT,1000) NX,NY
           CALL MSGWRT (8)
           IERR = 3
           GO TO 999
           END IF
C                                       Set a few parameters.
      NX2 = NX * 2
      NY2 = NY * 2
      NCOL = APSIZ / (NY2 * 2.0)
      NCOL = MIN (NCOL, NX)
      NROW = APSIZ / NX2
      NROW = MIN (NROW, NY2)
      MPASS = NY2 / NROW
      MPASS = MAX (MPASS, 1)
      HALFNX = NX
      ONENX = NX2
      TWONX = 2 * NX2
      ONENY = NY2
      TWONY = 2 * NY2
      OMPASS = MPASS
      ONECOL = NCOL
      TWOCOL = 2 * NCOL
      ONEROW = NROW
      TWOROW = 2 * NROW
C                                       Open files
      BADOP = 'OPEN'
      BADFIL = 2
C                                       I/O only for multiple AP loads
      IF (MPASS.GT.1) THEN
         CALL ZOPEN (LUN(2), FIND2, VOL(2), FIL(2), MAP, EXCL, WAIT,
     *      IERR)
         IF (IERR.NE.0) GO TO 900
         CALL ZOPEN (LUN(3), FIND3, VOL(3), FIL(3), MAP, EXCL, WAIT,
     *      IERR)
         BADFIL = 3
         IF (IERR.NE.0) GO TO 900
         END IF
C                                       Convolving fn.
      CALL ZOPEN (LUN(5), FIND5, VOL(5), FIL(5), MAP, EXCL, WAIT, IERR)
      BADFIL = 5
      IF (IERR.NE.0) GO TO 900
      BADOP = 'INIT'
C                                       Determine length of read
      LROW = NROW * 2 * NCOL
C                                       Setup for correct output mode.
      NUM = NY2 * 2
      JDIR = 1
C                                       Initialize output.
      WIN(1) = 1
      WIN(2) = 2
      WIN(3) = NUM
      WIN(4) = NX
C                                       Output
      BIND3 = 1
      IF (MPASS.GT.1) CALL MINIT ('WRIT', LUN(3), FIND3, WIN(3),
     *   WIN(4), WIN, XBUFF2, BUFSZ2, BO(3), IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Convolving image
      CALL MINIT ('READ', LUN(5), FIND5, WIN(3), WIN(4), WIN, XBUFF3,
     *   BUFSZ3, BO(5), IERR)
      BADFIL = 5
      IF (IERR.NE.0) GO TO 900
C                                       Trap for row NX/2+1
      JSTART = 2
      DO 300 I = 1,MPASS
C                                       Initialize read with skip.
C                                       Read only for multiple AP loads
         IF (MPASS.GT.1) THEN
C                                       Read only values not
C                                       corresponding to zeroed rows.
C                                       Since they were not written
C                                       just skip.
            NBUF = 1
            NOROW = MPASS * MPASS
            NSKIP = MPASS
            IFIRST = I
            CALL MINSK (LUN(2), FIND2, LROW, NOROW, IFIRST, NSKIP,
     *         XBUFF1, BUFSZ1, BO(2), NBUF, IERR)
            BADFIL = 2
            BADOP = 'INIT'
            IF (IERR.NE.0) GO TO 900
C                                       Determine number of words per re
            NSHOV = LROW / NBUF
            BLCNT = 0
C                                       Load NCOL columns into AP,
C                                       complete transpose.
            DO 60 J = 1,MPASS
               KOFF = J - MPASS/2
               IF (KOFF.LE.0) KOFF = KOFF + MPASS
               IF (((KOFF.LE.(MPASS/4)) .OR. (KOFF.GT.(3*MPASS/4)))
     *            .AND. (MPASS.GE.4)) THEN
C                                       Zero
                  INDEX = (J-1) * LROW
                  I4TEMP = ((1.0 * APSIZ) / MPASS) + 0.1
                  CALL QVCLR (APCORE, INDEX, 1, I4TEMP)
                  GO TO 60
                  END IF
               IC = -1
C                                       Return to here if multiple
C                                       buffering used.
 50               CALL MSKIP (LUN(2), FIND2, XBUFF1, BIND2, IFIN, IERR)
                  IC = IC + 1
                  IF (IERR.NE.0) THEN
                     BADOP = 'READ'
                     GO TO 900
                     END IF
C                                       Load in proper place in AP.
                  INDEX = (J-1) * LROW + NSHOV * IC
                  CALL QPUT (APCORE, XBUFF1(BIND2), INDEX, NSHOV, 2)
C                                       If read not finished loop.
                  IF (IFIN.NE.0) GO TO 50
 60               CONTINUE
C                                       Finish Transpose.
               CALL QWD
               CALL QVTRAN (APCORE, OMPASS, ONECOL, 0, TWOROW)
            END IF
 65         CALL QWAIT
C                                       Do col transform, dump to disk
            DO 100 J = JSTART,NCOL
               INDEX = (J-1) * 2 * NY2
               JNDEX = INDEX
C                                       FFT
               CALL QCFFT (APCORE, INDEX, ONENY, JDIR)
C                                       Scale.
 75            CALL QVIDIV (APCORE, INDEX, 1, TWONX, ONENY, INDEX, 1,
     *            NUM)
               CALL QWR
C                                       Write output
               IF (MPASS.GT.1) CALL MDISK ('WRIT', LUN(3), FIND3,
     *            XBUFF2, BIND3, IERR)
               IF (IERR.NE.0) THEN
                     BADOP = 'WRIT'
                     BADFIL = 3
                     GO TO 900
                     END IF
C                                       Dump to disk.
               CALL QGET (APCORE, XBUFF2(BIND3), JNDEX, NUM, 2)
C                                       Read convolving fn
               CALL MDISK ('READ', LUN(5), FIND5, XBUFF3, BIND5, IERR)
               IF (IERR.NE.0) THEN
                  BADOP = 'READ'
                  BADFIL = 5
                  GO TO 900
                  END IF
               CALL QWD
C                                       Multiply
               DO 90 LOOP = 1,NUM,2
                  XR = FACTOR * XBUFF2(BIND3+LOOP-1)
                  XI = FACTOR * XBUFF2(BIND3+LOOP)
                  XBUFF2(BIND3+LOOP-1) = XR * XBUFF3(BIND5+LOOP-1) -
     *               XI * XBUFF3(BIND5+LOOP)
                  XBUFF2(BIND3+LOOP) = XR * XBUFF3(BIND5+LOOP) +
     *               XI * XBUFF3(BIND5+LOOP-1)
 90               CONTINUE
C                                       Put back if MPASS=1
               IF (MPASS.EQ.1) CALL QPUT (APCORE, XBUFF2(BIND3), JNDEX,
     *            NUM, 2)
               IF (MPASS.EQ.1) CALL QWD
               JNDEX = JNDEX + NUM
 100           CONTINUE
C                                       Row NX/2 + 1
C                                       Deal with first and last rows.
C                                       Already packed into AP memory at
C                                       start loc. 0.
            IF (JSTART.EQ.1) GO TO 290
            JSTART = 1
C                                       Unpack
            IF (MPASS.EQ.1) GO TO 200
C                                       Disk based section:
C                                       Copy real of NX/2+1
            LNDEX = 1
            KNDEX = TWONY
            CALL QVMOV (APCORE, LNDEX, 2, KNDEX, 2, ONENY)
C                                       Clear imag. of 1
            LNDEX = 1
            CALL QVCLR (APCORE, LNDEX, 2, ONENY)
C                                       Clear imag. of NX/2+1
            LNDEX = KNDEX + 1
            CALL QVCLR (APCORE, LNDEX, 2, ONENY)
C                                       FFTs
            LNDEX = 0
            CALL QCFFT (APCORE, LNDEX, ONENY, JDIR)
            CALL QCFFT (APCORE, KNDEX, ONENY, JDIR)
            CALL QWR
C                                       Scale
            CALL QVIDIV (APCORE, LNDEX, 1, TWONX, ONENY, LNDEX, 1, NUM)
            CALL QVIDIV (APCORE, KNDEX, 1, TWONX, ONENY, KNDEX, 1, NUM)
            CALL QWR

C                                       Flush, reinit other output
C                                       buffer.
            CALL MDISK ('FINI', LUN(3), FIND3, XBUFF2, BIND3, IERR)
            IF (IERR.NE.0) THEN
               BADOP = 'FINI'
               BADFIL = 3
               GO TO 900
               END IF
            IWIN(1) = WIN(1)
            IWIN(2) = NCOL + 1
            IWIN(3) = WIN(3)
            IWIN(4) = WIN(4)
            CALL MINIT ('WRIT', LUN(3), FIND3, IWIN(3), IWIN(4),
     *         IWIN, XBUFF2, BUFSZ2, BO(3), IERR)
            IF (IERR.NE.0) THEN
               BADOP = 'INIT'
               BADFIL = 3
               GO TO 900
               END IF
C                                       Setup to write row 1
            IWIN(1) = 1
            IWIN(2) = 1
            IWIN(3) = NUM
            IWIN(4) = 1
C                                       Open output file.
            BADOP = 'OPEN'
            CALL ZOPEN (LUN(1), FIND1, VOL(3), FIL(3), MAP,
     *         EXCL, WAIT, IERR)
            BADFIL = 3
            IF (IERR.NE.0) GO TO 900
C                                       Write these two rows.
            DO 160 J = 1,2
C                                       Init (Use input buffer)
               CALL MINIT ('WRIT', LUN(1), FIND1, IWIN(3),
     *            IWIN(4), IWIN, XBUFF1, BUFSZ1, BO(3), IERR)
               IF (IERR.NE.0) THEN
                  BADOP = 'INIT'
                  BADFIL = 3
                  GO TO 900
                  END IF
C                                       Convolving function
               CALL MINIT ('READ', LUN(5), FIND5, IWIN(3),
     *               IWIN(4), IWIN, XBUFF3, BUFSZ3, BO(5), IERR)
               IF (IERR.NE.0) THEN
                  BADOP = 'INIT'
                  BADFIL = 5
                  GO TO 900
                  END IF
               INDEX = (J-1) * 2 * NY2
               JNDEX = INDEX
C                                       Copy to disk
               CALL MDISK ('WRIT', LUN(1), FIND1, XBUFF1, BIND1, IERR)
               IF (IERR.NE.0) THEN
                  BADOP = 'WRIT'
                  BADFIL = 3
                  GO TO 900
                  END IF
               CALL QGET (APCORE, XBUFF1(BIND1), JNDEX, NUM, 2)
C                                       Read convolving fn
               CALL MDISK ('READ', LUN(5), FIND5, XBUFF3, BIND5, IERR)
               IF (IERR.NE.0) THEN
                  BADOP = 'READ'
                  BADFIL = 5
                  GO TO 900
                  END IF
               CALL QWD
C                                       Multiply
               DO 140 LOOP = 1,NUM,2
                  XR = FACTOR * XBUFF1(BIND1+LOOP-1)
                  XI = FACTOR * XBUFF1(BIND1+LOOP)
                  XBUFF1(BIND1+LOOP-1) =
     *               XR * XBUFF3(BIND5+LOOP-1) -
     *               XI * XBUFF3(BIND5+LOOP)
                  XBUFF1(BIND1+LOOP) =
     *               XR * XBUFF3(BIND5+LOOP) +
     *               XI * XBUFF3(BIND5+LOOP-1)
 140              CONTINUE
               JNDEX = JNDEX + NUM
 145           CONTINUE
C                                       Flush I/O
               IF (MPASS.GT.1) CALL MDISK ('FINI', LUN(1), FIND1,
     *            XBUFF1, BIND1, IERR)
               IF (IERR.NE.0) THEN
                  BADOP = 'FINI'
                  BADFIL = 3
                  GO TO 900
                  END IF
C                                       Set up for row NX/2+1
               IF (J.LE.1) THEN
                  IWIN(2) = NX + 1
                  IWIN(4) = NX + 1
                  END IF
 160           CONTINUE
C                                       Close file
            CALL ZCLOSE (LUN(1), FIND1, IER)
C                                       Reinit Convolving fn.
            WIN(2) = NCOL + 1
            CALL MINIT ('READ', LUN(5), FIND5, WIN(3), WIN(4),
     *         WIN, XBUFF3, BUFSZ3, BO(5), IERR)
            IF (IERR.NE.0) THEN
               BADOP = 'INIT'
               BADFIL = 5
               GO TO 900
               END IF
            GO TO 290
C                                       Row NX/2+1 AP based:
C                                       Get packed row; use buffers
C                                       for storage.
 200        LNDEX = 0
            CALL QGET (APCORE, XBUFF2, LNDEX, NUM, 2)
            CALL QWD
C                                       Clear imag. of 1
            LNDEX = 1
            CALL QVCLR (APCORE, LNDEX, 2, ONENY)
C                                       FFT row 1
            LNDEX = 0
            JDIR = 1
            CALL QCFFT (APCORE, LNDEX, ONENY, JDIR)
C                                       Scale
            CALL QVIDIV (APCORE, LNDEX, 1, TWONX, ONENY, LNDEX, 1, NUM)
            CALL QWR
C                                       Get row 1
            CALL QGET (APCORE, XBUFF1, LNDEX, NUM, 2)
            CALL QWD
C                                       Setup to multiply row 1
            IWIN(1) = 1
            IWIN(2) = 1
            IWIN(3) = NUM
            IWIN(4) = 1
C                                       Convolving function
            CALL MINIT ('READ', LUN(5), FIND5, IWIN(3), IWIN(4),
     *         IWIN, XBUFF3, BUFSZ3, BO(5), IERR)
            IF (IERR.NE.0) THEN
               BADOP = 'INIT'
               BADFIL = 5
               GO TO 900
               END IF
            INDEX = 1
C                                       Read convolving fn
            CALL MDISK ('READ', LUN(5), FIND5, XBUFF3, BIND5, IERR)
            IF (IERR.NE.0) THEN
               BADOP = 'READ'
               BADFIL = 5
               GO TO 900
               END IF
C                                       Multiply
            DO 220 LOOP = 1,NUM,2
               XR = FACTOR * XBUFF1(INDEX)
               XI = FACTOR * XBUFF1(INDEX+1)
               XBUFF1(INDEX) =
     *            XR * XBUFF3(BIND5+LOOP-1) -
     *            XI * XBUFF3(BIND5+LOOP)
               XBUFF1(INDEX+1) =
     *            XR * XBUFF3(BIND5+LOOP) +
     *            XI * XBUFF3(BIND5+LOOP-1)
               INDEX = INDEX + 2
 220           CONTINUE
C                                       Row NX/2+1
            LNDEX = 0
            CALL QPUT (APCORE, XBUFF2(2), LNDEX, NUM, 2)
            CALL QWD
C                                       Clear imag. of NX/2+1
            LNDEX = 1
            CALL QVCLR (APCORE, LNDEX, 2, ONENY)
C                                       FFT row NX/2+1
            LNDEX = 0
            JDIR = 1
            CALL QCFFT (APCORE, LNDEX, ONENY, JDIR)
C                                       Scale
            CALL QVIDIV (APCORE, LNDEX, 1, TWONX, ONENY, LNDEX, 1, NUM)
            CALL QWR
C                                       Get row NX/2+1
            CALL QGET (APCORE, XBUFF2, LNDEX, NUM, 2)
            CALL QWD
C                                       Setup to multiply row NX/2+1
            IWIN(1) = 1
            IWIN(2) = NX + 1
            IWIN(3) = NUM
            IWIN(4) = NX + 1
C                                       Convolving function
            CALL MINIT ('READ', LUN(5), FIND5, IWIN(3), IWIN(4),
     *         IWIN, XBUFF3, BUFSZ3, BO(5), IERR)
            IF (IERR.NE.0) THEN
               BADOP = 'INIT'
               BADFIL = 5
               GO TO 900
               END IF
            INDEX = 1
C                                       Read convolving fn
            CALL MDISK ('READ', LUN(5), FIND5, XBUFF3, BIND5, IERR)
            IF (IERR.NE.0) THEN
               BADOP = 'READ'
               BADFIL = 5
               GO TO 900
               END IF
C                                       Multiply
            DO 250 LOOP = 1,NUM,2
               XR = FACTOR * XBUFF2(INDEX)
               XI = FACTOR * XBUFF2(INDEX+1)
               XBUFF2(INDEX) =
     *            XR * XBUFF3(BIND5+LOOP-1) -
     *            XI * XBUFF3(BIND5+LOOP)
               XBUFF2(INDEX+1) =
     *            XR * XBUFF3(BIND5+LOOP) +
     *            XI * XBUFF3(BIND5+LOOP-1)
               INDEX = INDEX + 2
 250           CONTINUE
C                                       FFT rows 1 and NX/2+1
            LNDEX = 0
            CALL QPUT (APCORE, XBUFF1, LNDEX, NUM, 2)
            JDIR = -1
            CALL QWD
            CALL QCFFT (APCORE, LNDEX, ONENY, JDIR)
            CALL QWR
            CALL QGET (APCORE, XBUFF1, LNDEX, NUM, 2)
            CALL QWD
C                                       Row NX/2+1
            CALL QPUT (APCORE, XBUFF2, LNDEX, NUM, 2)
            CALL QWD
            CALL QCFFT (APCORE, LNDEX, ONENY, JDIR)
            CALL QWR
            CALL QGET (APCORE, XBUFF2, LNDEX, NUM, 2)
            JDIR = 1
            CALL QWD
C                                       Pack
            DO 270 LOOP = 1,NUM,2
               XBUFF1(LOOP+1) = XBUFF2(LOOP)
 270           CONTINUE
C                                       Leave in AP
            CALL QPUT (APCORE, XBUFF1, LNDEX, NUM, 2)
            CALL QWAIT
C                                       Roll AP if necessary.
 290        IF (MPASS.GT.1) NWORD = 0
            CALL QROLL (APCORE, NWORD, XBUFF1, BUFSZ1, IERR)
            NWORD = APSIZ
            IF (IERR.NE.0) GO TO 999
 300        CONTINUE
         IF (MPASS.EQ.1) GO TO 990
C                                       Finish write.
         BADOP = '    '
         CALL MDISK ('FINI', LUN(3), FIND3, XBUFF2, BIND3, IERR)
         IF (IERR.NE.0) THEN
            BADOP = 'FINI'
            BADFIL = 3
            GO TO 900
            END IF
         GO TO 990
C                                       Error report
 900  WRITE (MSGTXT,1900) BADOP, IERR, FIL(BADFIL)
      IF ((BADOP.EQ.'READ') .OR. (BADOP.EQ.'WRIT')) THEN
         WRITE (MSGTXT,1901) BADOP, IERR, I, J
         CALL MSGWRT (8)
         WRITE (MSGTXT,1902) FIL(BADFIL)
         END IF
      CALL MSGWRT (8)
C                                       Close files
 990  IF ((MPASS.GT.1) .AND. ((BADOP.NE.'OPEN') .OR. (BADFIL.NE.2)))
     *   CALL ZCLOSE (LUN(2), FIND2, IER)
      IF ((MPASS.GT.1) .AND. ((BADOP.NE.'OPEN') .OR. (BADFIL.NE.3)))
     *   CALL ZCLOSE (LUN(3), FIND3, IER)
      IF ((BADOP.NE.'OPEN') .OR. (BADFIL.NE.2))
     *   CALL ZCLOSE (LUN(5), FIND5, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CONV2: NX OR NY (',I5,',',I5,') LESS THAN 4')
 1900 FORMAT ('CONV2: ',A4,' ERROR',I7,' FILE ',A)
 1901 FORMAT ('CONV2: ',A4,' ERROR',I7,' I,J=',I3,I5)
 1902 FORMAT ('      FILE ',A)
      END

      SUBROUTINE TFDHMS (TIMEIN, NDIG, TSIGN, TIME, SECNDS)
C-----------------------------------------------------------------------
C! Converts time to print format of greater accuracy than integer sec
C# Utility coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Convert from Time to Sign Days Hours Minutes Seconds format
C   Input:
C      TIMEIN   R      Time in days
C      NDIG     I      Number of digits after decimal in Seconds display
C   Output:
C      TSIGN    C*1    Sign of time
C      TIME     I(3)   Time in Days Hours Minutes
C      SECNDS   R      Time in seconds
C-----------------------------------------------------------------------
      REAL      TIMEIN, SECNDS
      CHARACTER TSIGN
      INTEGER   NDIG, TIME(3)
C
      INTEGER  I
      REAL     T, X
C-----------------------------------------------------------------------
      T = TIMEIN
      IF (TIMEIN.LT.0.0) T = -T
C
      TIME(1) = T
      T = (T - TIME(1)) * 24.0
      TIME(2) = T
      T = (T - TIME(2)) * 60.0
      TIME(3) = T
      T = (T - TIME(3)) * 60.0
      IF ((NDIG.GT.0) .AND. (NDIG.LE.6)) THEN
         X = 10.0 ** NDIG
      ELSE
         X = 1.0
         END IF
      I = T * X + 0.5
      SECNDS = I / X
C                                       Now Remove 60 seconds
      IF (SECNDS.GE.59.999) THEN
         SECNDS = SECNDS - 60.
         TIME(3) = TIME(3) + 1
         END IF
C                                       Now Remove 60 minutes
      IF (TIME(3).GE.60) THEN
         TIME(3) = TIME(3) - 60
         TIME(2) = TIME(2) + 1
         END IF
C                                       Now Remove 24 hours
      IF (TIME(2).GE.24) THEN
         TIME(2) = TIME(2) - 24
         TIME(1) = TIME(1) + 1
         END IF
C                                       Sign
      IF (TIMEIN.LT.0.0) THEN
         TSIGN = '-'
      ELSE
         TSIGN = ' '
         END IF
C
 999  RETURN
      END

      SUBROUTINE WXINI (OPCODE, WXBUFF, DISK, CNO, VER, CATBLK, LUNWX,
     *   IWXRNO, WXKOLS, WXNUMV, OBSCOD, OBSDAT, TABVER, IERR)
C-----------------------------------------------------------------------
C! creates and intializes a weather data (WX) table.
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2001-2003, 2006, 2010, 2015-2016, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes weather data tables.
C   Inputs:
C      OPCODE         C*4  Operation code:
C                          'WRIT' = create/init for write or read
C                          'READ' = open for read only
C      WXBUFF(512)    I    I/O buffer and related storage, also defines
C                          file if open.
C      DISK           I    Disk to use.
C      CNO            I    Catalog slot number
C      VER            I    WX file version
C      CATBLK(256)    I    Catalog header block.
C      LUNWX          I    Logical unit number to use
C   Input (create) / output (pre-existing) (file keywords):
C      OBSCOD         C*8  Observing code.
C      OBSDAT         C*8  Observing date.
C      TABVER         I    Table revision number.
C      WXNUMV(MAXWXC) I    Element count in each column. On input only
C                          used if the file is created.
C   Output:
C      IWXRNO         I    Next row number, start of the file if READ,
C                          the last+1 if WRITE
C      WXKOLS(MAXWXC) I    The column pointer array in order:
C                          TIME, DTIM, ANT, TEMP, PRESS, DEWPT,
C                          WVEL, WDIR, H2OCOL, IONCOL
C   Output:
C      IERR           I    Return error code, 0=>OK, else TABINI or
C                          TABIO error.
C----------------------------------------------------------------------
      INCLUDE 'INCS:DWXV.INC'
      CHARACTER OPCODE*4, OBSCOD*8, OBSDAT*8
      INTEGER   WXBUFF(512), DISK, CNO, VER, CATBLK(256), LUNWX, IWXRNO,
     *   WXKOLS(MAXWXC), WXNUMV(MAXWXC), TABVER, IERR
C
      INCLUDE 'INCS:DMSG.INC'
      LOGICAL T, DOREAD, NEWFIL
      CHARACTER TTITLE*56, TITLE(MAXWXC)*24, TITLE2(MAXWXC)*24,
     *   UNITS(MAXWXC)*8, KEYWRD(NKEYWX)*8, TITLEC(MAXWXC)*24
      INTEGER   I, JERR, ITEMP(6), NTTWX, NKEY, NREC, NCOL, IPOINT,
     *   NC, ITRIM, NDATA, DATP(128,2), KLOCS(NKEYWX), KEYTYP(NKEYWX),
     *   KEYI(NKYWWX), DTYP(MAXWXC), WXKOL2(MAXWXC), WXKOLC(MAXWXC)
      REAL      KEYR(NKYWWX)
      DOUBLE PRECISION KEYD(NKYWW2)
      HOLLERITH KEYH(NKYWWX), HOLTMP(6)
      EQUIVALENCE (KEYI, KEYR, KEYD, KEYH)
      EQUIVALENCE (HOLTMP, ITEMP)
      DATA TTITLE / 'WEATHER DATA TABLE' /
      DATA TITLE /'TIME', 'TIME_INTERVAL', 'ANTENNA_NO', 'SUBARRAY',
     *   'TEMPERATURE', 'PRESSURE', 'DEWPOINT', 'WIND_VELOCITY',
     *   'WIND_DIRECTION', 'WIND_GUST', 'PRECIPITATION', 'WVR_H2O',
     *   'IONOS_ELECTRON' /
C                                       casa
      DATA TITLEC /'TIME', 'TIME_INTERVAL', 'ANTENNA NO.', 'SUBARRAY',
     *   'TEMPERATURE', 'PRESSURE', 'DEWPOINT', 'WIND_VELOCITY',
     *   'WIND_DIRECTION', 'WIND_GUST', 'PRECIPITATION', 'WVR_H2O',
     *   'IONOS_ELECTRON' /
      DATA TITLE2 / 'TIME', 'TIME INTERVAL', 'ANTENNA NUMBER',
     *   'SUBARRAY', 'TEMPERATURE', 'PRESSURE', 'DEWPOINT',
     *   'WIND VELOCITY', 'WIND DIRECTION', 'WIND GUST',
     *   'PRECIPITATION', 'H2O COLUMN', 'ELECTRON COLUMN' /
      DATA UNITS / 2*'DAYS', 2*' ', 'CENTIGRA', 'MILLIBAR',
     *   'CENTIGRA', 'M/SEC', 'DEGREES', 'M/SEC', 'CM', 2*'/M/M' /
      DATA KEYWRD / 'OBSCODE', 'RDATE', 'TABREV' /
      DATA NTTWX / 56 /
      DATA T / .TRUE. /
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Set up needed variables
      NREC = 1000
      NCOL = MAXWXC
      IF (DOREAD) NCOL = 0
      NKEY = NKEYWX
      NDATA = MAXWXC
      CALL FILL (NDATA, 0, WXKOLS)
      CALL FILL (NDATA, 0, WXNUMV)
C                                       Fill in types, lengths
C                                       See Going AIPS Vol 2 p13-3.
      IF (.NOT.DOREAD) THEN
         DTYP(WXDTIM) = TABDBL + 10
         DTYP(WXRINT) = TABFLT + 10
         DTYP(WXIANT) = TABINT + 10
         DTYP(WXSUBA) = TABINT + 10
         DTYP(WXRTMP) = TABFLT + 10
         DTYP(WXRPRS) = TABFLT + 10
         DTYP(WXRDWP) = TABFLT + 10
         DTYP(WXRVEL) = TABFLT + 10
         DTYP(WXRDIR) = TABFLT + 10
         DTYP(WXRGUS) = TABFLT + 10
         DTYP(WXRPRE) = TABFLT + 10
         DTYP(WXRH2O) = TABFLT + 10
         DTYP(WXRION) = TABFLT + 10
         CALL COPY (NCOL, DTYP, DATP(1,2))
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'WX', DISK, CNO, VER, CATBLK, LUNWX, NKEY,
     *   NREC, NCOL, DATP, WXBUFF, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'WXINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
C                                       Get number of records
      IWXRNO = WXBUFF(5) + 1
      IF (DOREAD) IWXRNO = 1
      NKEY = NKEYWX
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 40 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, WXBUFF, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'WXINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, WXBUFF, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'WXINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTTWX, TTITLE, 1, WXBUFF(101))
C                                       Set keyword values
C                                       Observing code
         KLOCS(1) = 1
         KEYTYP(1) = TABHOL
         CALL CHR2H (8, OBSCOD, 1, KEYI(KLOCS(1)))
C                                       Observing date
         KLOCS(2) = 3
         KEYTYP(2) = TABHOL
         CALL CHR2H (8, OBSDAT, 1, KEYI(KLOCS(2)))
C                                       Table revision number
         KLOCS(3) = 5
         KEYTYP(3) = TABINT
         KEYI(KLOCS(3)) = IWXREV
C                                       Write to the WX table
         CALL TABKEY ('WRIT', KEYWRD, NKEYWX, WXBUFF, KLOCS, KEYI,
     *      KEYTYP, IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'WXINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         CALL TABKEY ('READ', KEYWRD, NKEYWX, WXBUFF, KLOCS, KEYI,
     *      KEYTYP, IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'WXINI', IERR)
            GO TO 990
            END IF
C                                       Observing code
         CALL H2CHR (8, 1, KEYH(KLOCS(1)), OBSCOD)
C                                       Observing date
         CALL H2CHR (8, 1, KEYH(KLOCS(2)), OBSDAT)
C                                       Table revision number
         TABVER = KEYI(KLOCS(3))
         END IF
C                                       Get array indices
C                                       Cover your ass from FNDCOL -
C                                       close to flush the buffers and
C                                       then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KEYI, WXBUFF, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'WXINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'WX', DISK, CNO, VER, CATBLK, LUNWX, NKEY,
     *   NREC, NCOL, DATP, WXBUFF, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'WXINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (MAXWXC, TITLE, 24, T, WXBUFF, WXKOLS, JERR)
      CALL FNDCOL (MAXWXC, TITLE2, 24, T, WXBUFF, WXKOL2, JERR)
      CALL FNDCOL (MAXWXC, TITLEC, 24, T, WXBUFF, WXKOLC, JERR)
C                                       Get array indices and no. values
      DO 150 I = 1,MAXWXC
         IPOINT = WXKOLS(I)
         IF (IPOINT.EQ.0) IPOINT = WXKOL2(I)
         IF (IPOINT.EQ.0) IPOINT = WXKOLC(I)
         IF (IPOINT.GT.0) THEN
            WXKOLS(I) = DATP(IPOINT,1)
            WXNUMV(I) = DATP(IPOINT,2) / 10
            IF (WXNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               IF (I.LE.9) CALL MSGWRT (6)
               END IF
         ELSE
            WXKOLS(I) = -1
            WXNUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            IF (I.LE.9) CALL MSGWRT (6)
            END IF
 150     CONTINUE
C                                       check format of time (CASA)
      IPOINT = WXKOLS(1)
      I = MOD (DATP(IPOINT,2), 10)
      IF (I.EQ.2) WXNUMV(1) = -WXNUMV(1)
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('WXINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('WXINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('WXINI: ERROR INITIALIZING WEATHER INFO TABLE FOR ', A4)
      END

      SUBROUTINE DTCALS (JSOU, JANT, JSUBA, JFQ, JIF, JNDXCE, TIME,
     *   DELAY, DPHASE, DRATE, DACCEL, DFEED, DGAIN, DTSYS, DAMPL,
     *   DGERR)
C-----------------------------------------------------------------------
C! Compute simulated calibration errors at a given time
C# UV Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2007, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Compute simulated calibration errors at a given time
C   Input:
C      JSOU    I        Source index
C      JANT    I        Antenna index
C      JSUBA   I        Subarray index
C      JFQ     I        Freqid. index
C      JIF     I        IF number.
C      JNDXCE  I        Cal. error index
C      TIME    R        Time (in days wrt ref. date)
C   Output:
C      DELAY   D(2)     Group delay (RCP, LCP) (seconds)
C      DPHASE  D(2)     Phase delay (RCP, LCP) (radians)
C      DRATE   D(2)     Phase rate (RCP, LCP) rad/s.
C      DACCEL  D(2)     Phase acceleration (RCP, LCP) rad/s/s.
C      DFEED   D(2,2)   Feed D-terms (Re,Im; RCP,LCP)
C      DGAIN   D(2)     Point source sensitivity (RCP, LCP) (K/Jy)
C      DTSYS   D(2)     System temperature (RCP, LCP) (K)
C      DAMPL   D(2)     Square root (DGAIN * DTSYS)
C      DGERR   D(2)     Multiplicative gain error factor (RCP,LCP)
C----------------------------------------------------------------------
      DOUBLE PRECISION DELAY(2), DPHASE(2), DRATE(2), DACCEL(2),
     *   DFEED(2,2), DGAIN(2), DTSYS(2), DAMPL(2), DGERR(2)
      REAL      TIME
      INTEGER   JSOU, JANT, JSUBA, JFQ, JIF, JNDXCE
C
      INTEGER   MXCHEB
      PARAMETER (MXCHEB = 100)
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DTPM.INC'
      DOUBLE PRECISION DCHEB(MXCHEB), DCHEBD(MXCHEB,2), DK(6), DA, DB,
     *   DX, DAF, DPF, DTIME, DJUNK, DRA, DDEC, DC
      REAL      PARM(MAXERP)
      INTEGER   ITYPE, J, N, IRET, K, IROUND
C----------------------------------------------------------------------
C                                       Initialization
      DTIME = TIME
      CALL DFILL (2, 0.0D0, DELAY)
      CALL DFILL (2, 0.0D0, DPHASE)
      CALL DFILL (2, 0.0D0, DRATE)
      CALL DFILL (2, 0.0D0, DACCEL)
      CALL DFILL (4, 0.0D0, DFEED)
      CALL DFILL (2, 1.0D0, DGAIN)
      CALL DFILL (2, 0.0D0, DTSYS)
      CALL DFILL (2, 0.0D0, DAMPL)
      CALL DFILL (2, 1.0D0, DGERR)
C                                       general defaults
      IF (JNDXCE.LE.0) THEN
         IF (DEFGAN(JIF).GT.0.0) THEN
            DGAIN(1) = DEFGAN(JIF)
            DGAIN(2) = DEFGAN(JIF)
            END IF
         IF (DEFSYS(JIF).GT.0.0) THEN
            DTSYS(1) = DEFSYS(JIF)
            DTSYS(2) = DEFSYS(JIF)
            END IF
         DAMPL(1) = SQRT (DTSYS(1) * DGAIN(1))
         DAMPL(2) = SQRT (DTSYS(2) * DGAIN(2))
      ELSE
C                                       Loop over Stokes
         DO 900 J = 1, 2
C======================================================================
C                                       Delay
            CALL RCOPY (MAXERP, RDTDEL(1,JIF,J,JNDXCE), PARM)
            ITYPE = IROUND (PARM(1))
C                                       Case delay_type of:
C                                       1: Chebyshev polynomial
            IF (ITYPE.EQ.1) THEN
C                                       Order, period.
               N = IROUND (PARM(2))
               DA = 0.0D0
               DB = PARM(3)
               DX = MOD (TIME, PARM(3))
C                                       Compute polynomial value.
               CALL CHEBY (DA, DB, DX, DCHEB, N, IRET)
               IF (IRET.NE.0)  GO TO 900
C                                       Scale and add offset,
C                                       convert to sec
               DELAY(J) = (DCHEB(N+1) * PARM(4) + PARM(5)) * 1.0D-9
C                                       2: Perturbed orbit error
            ELSE IF (ITYPE.EQ.2) THEN
               CALL DCOPY (6, DTORB(1,JANT,JSUBA), 1, DK, 1)
C                                       Convert to radians
               DRA = DTSRA(JSOU) * DG2RAD
               DDEC = DTSDEC(JSOU) * DG2RAD
               DO 100 K = 3,6
                  DK(K) = DK(K) * DG2RAD
100               CONTINUE
C
               CALL ORBERR (DK(1), DK(2), DK(3), DK(4), DK(5), DK(6),
     *            DTIME, DTFREQ(JIF,JFQ), DDEC, DRA, PARM(2), PARM(3),
     *            PARM(4), PARM(5), DELAY(J), DJUNK)
               END IF
C======================================================================
C                                       Phase, rate and acceleration
            CALL RCOPY (MAXERP, RDTPHS(1,JIF,J,JNDXCE), PARM)
            ITYPE = IROUND (PARM(1))
C                                       Case phase_type of:
C                                       1: Chebyshev polynomial
            IF (ITYPE.EQ.1) THEN
C                                       Order, period.
               N = IROUND (PARM(2))
               DA = 0.0
               DB = PARM(3)
               DX = MOD (TIME, PARM(3))
C                                       Compute polynomial value.
               CALL CHEBY (DA, DB, DX, DCHEB, N, IRET)
               IF (IRET.NE.0) GO TO 900
C                                       Scale and add offset,
C                                       covert to rad.
               DPHASE(J) = (DCHEB(N+1) * PARM(4) + PARM(5)) * DG2RAD
C                                       Compute rate and acceleration
               CALL CHEBYD (DA, DB, DX, DCHEBD, MXCHEB, N, IRET)
               IF (IRET.NE.0) GO TO 900
C                                       Rate rad/s
               DC = 2.0D0 / (PARM(3) * 86400.0)
               DRATE(J) = DC * DCHEBD(N+1,1) * PARM(4) * DG2RAD
C                                       Acceleration rad/s/s
               DACCEL(J) = DC * DC * DCHEBD(N+1,2) * PARM(4) * DG2RAD
C                                       2: Perturbed orbit error
C                                       Rate, acceleration: NYI
            ELSE IF (ITYPE.EQ.2) THEN
               CALL DCOPY (6, DTORB(1,JANT,JSUBA), 1, DK, 1)
C                                       Convert to radians
               DRA = DTSRA(JSOU) * DG2RAD
               DDEC = DTSDEC(JSOU) * DG2RAD
               DO 200 K = 3,6
                  DK(K) = DK(K) * DG2RAD
200               CONTINUE
C
               CALL ORBERR (DK(1), DK(2), DK(3), DK(4), DK(5), DK(6),
     *            DTIME, DTFREQ(JIF,JFQ), DDEC, DRA, PARM(2), PARM(3),
     *            PARM(4), PARM(5), DJUNK, DPHASE(J))
               END IF
C=====================================================================
C                                       Feed D-terms
            CALL RCOPY (MAXERP, RDTFED(1,JIF,J,JNDXCE), PARM)
            ITYPE = IROUND (PARM(1))
C                                       Case feed_type of:
C                                       1: Const. D-terms
            IF (ITYPE.EQ.1) THEN
C                                       Amplitude, phase of D-term
               DAF = PARM(2)
               DPF = PARM(3) * DG2RAD
C                                       Convert to (Re,Im)
               DFEED(1,J) = DAF * COS (DPF)
               DFEED(2,J) = DAF * SIN (DPF)
               END IF
C======================================================================
C                                       Point source sensitivity
C                                       (gain in K/Jy)
            CALL RCOPY (MAXERP, RDTGAN(1,JIF,J,JNDXCE), PARM)
            ITYPE = IROUND (PARM(1))
C                                       Case gain_type of:
C                                       1: Constant value.
            IF (ITYPE.EQ.1) THEN
               DGAIN(J) = PARM(2)
            ELSE IF (DEFGAN(JIF).GT.0.0) THEN
               DGAIN(J) = DEFGAN(JIF)
               END IF
C======================================================================
C                                       Tsys
            CALL RCOPY (MAXERP, RDTTSY(1,JIF,J,JNDXCE), PARM)
            ITYPE = IROUND (PARM(1))
C                                       Case Tsys_type of:
C                                       1: Chebyshev polynomial
C                                          (absolute value)
            IF (ITYPE.EQ.1) THEN
C                                       Order, period.
               N = IROUND (PARM(2))
               DA = 0.0
               DB = PARM(3)
               DX = MOD (TIME, PARM(3))
C                                       Compute polynomial value.
               CALL CHEBY (DA, DB, DX, DCHEB, N, IRET)
               IF (IRET.NE.0) GO TO 900
C                                       Scale and add offset
               DTSYS(J) = ABS (DCHEB(N+1)) * PARM(4) + PARM(5)
C                                       default
            ELSE IF (DEFSYS(JIF).GT.0.0) THEN
               DTSYS(J) = DEFSYS(JIF)
               END IF
C======================================================================
C                                       Gain error factor
            CALL RCOPY (MAXERP, RDTGER(1,JIF,J,JNDXCE), PARM)
            ITYPE = IROUND (PARM(1))
C                                       Case gain_err_type of:
C                                       1: Chebyshev polynomial
            IF (ITYPE.EQ.1) THEN
C                                       Order, period
               N = IROUND (PARM(2))
               DA = 0.0
               DB = PARM(3)
               DX = MOD (TIME, PARM(3))
C                                       Compute polynomial value
               CALL CHEBY (DA, DB, DX, DCHEB, N, IRET)
               IF (IRET.NE.0) GO TO 900
C                                       Scale and add offset
               DGERR(J) = DCHEB(N+1) * PARM(4) + PARM(5)
C                                       Enforce positivity
               DGERR(J) = MAX (DGERR(J), 0.0D0)
               END IF
C======================================================================
C                                       Set amplitude gain factor
            DAMPL(J) = SQRT (DTSYS(J) * DGAIN(J))
900         CONTINUE
         END IF
C                                       Exit
999   RETURN
      END

LOCAL INCLUDE 'PCNTR.INC'
      INCLUDE 'INCS:PMAD.INC'
      INCLUDE 'INCS:PTVC.INC'
C                                       Input parms
      REAL      CONTUR, POLVEC, GRYSCL, PRUSER, SEQIN, DSKIN, SEQIN2,
     *   DSKIN2, SEQIN3, DSKIN3, SEQIN4, DSKIN4, XBLC(7), XTRC(7),
     *   X3COL, XYRATO, TLABEL, PLEV, CLEV, LEVS(30), FACTOR, PAROT,
     *   XINC, YINC, PCUT, ICUT, DOFRAC, P3COL, DOALIN, DOCIRC,
     *   RANGE(2), DOWDGE, INCOLR, XINVER, STMULT, XHPBP, XPVCRN, XDOTV,
     *   XGRCH, XTVCH, DODARK, XDKLIN, RGBLEV(3,30), DRKLEV(3,30),
     *   XTVCRN(2)
      HOLLERITH XNAMIN(3), XCLSIN(2), XNAM2(3), XCLS2(2), XNAM3(3),
     *   XCLS3(2), XNAM4(3), XCLS4(2), XFUN(1), XOMFIL(12)
      CHARACTER NAMIN(5)*12, CLSIN(5)*6, IGFILE*48, OFMFIL*48
      INTEGER   PLBUF(256), IWBLK(256), IGFIND, IGLUN, IFIND(5),
     *   ILUN(5), ISLOT(5), ILABEL, ISEQ(5), IVER, IVOL(5), INVER,
     *   GRCHN, TVCHN, TVCORN(2), INPRMS, BMCORN, IXWDGE, IYWDGE,
     *   ILPVAL, IHPVAL, ZINC, ZMIN, ZMAX, RGBLAB, NOFM, PVCORN
      REAL      BLC(7,5), TRC(7,5), CHOUT(4), NBLC(2), NTRC(2), ABLC(2),
     *   ATRC(2), ROFM(TVMLOU), GOFM(TVMLOU), BOFM(TVMLOU), WRANGE(2),
     *   VASEC, SUBMIN, SUBMAX
      LOGICAL   CATUP, QUICK, DOCON, DOPOL, WASOPN(5), DOTV, DOCONV,
     *   DOOFM, DOCOLR, SPCOLR, BMBLNK, FORCEC
      DOUBLE PRECISION    GFAC, GOFF
      COMMON /INPARM/ CONTUR, POLVEC, GRYSCL, PRUSER, XNAMIN, XCLSIN,
     *   SEQIN, DSKIN, XNAM2, XCLS2, SEQIN2, DSKIN2, XNAM3, XCLS3,
     *   SEQIN3, DSKIN3, XNAM4, XCLS4, SEQIN4, DSKIN4, XBLC, XTRC,
     *   X3COL, XYRATO, TLABEL, PLEV, CLEV, LEVS, FACTOR, PAROT, XINC,
     *   YINC, PCUT, ICUT, DOFRAC, P3COL, DOALIN, DOCIRC, RANGE, XFUN,
     *   DOWDGE, XOMFIL, INCOLR, XINVER, STMULT, XHPBP, XPVCRN, XDOTV,
     *   XGRCH, XTVCH, DODARK, XDKLIN, RGBLEV, DRKLEV, XTVCRN
      COMMON /TSTUF/ GFAC, GOFF, PLBUF, IWBLK, IGFIND, IGLUN, IFIND,
     *   ILUN, ISLOT, ILABEL, ISEQ, IVER, IVOL, INVER, GRCHN, TVCHN,
     *   TVCORN, INPRMS, CATUP, QUICK, DOCON, DOPOL, WASOPN, DOTV, BLC,
     *   TRC, CHOUT, DOCONV, BMCORN, NBLC, NTRC, ABLC, ATRC, IXWDGE,
     *   IYWDGE, DOOFM, DOCOLR, ILPVAL, IHPVAL, ROFM, GOFM, BOFM,
     *   WRANGE, ZINC, ZMIN, ZMAX, SPCOLR, BMBLNK, FORCEC, RGBLAB, NOFM,
     *   PVCORN, VASEC, SUBMIN, SUBMAX
      COMMON /CHPARM/ NAMIN, CLSIN, IGFILE, OFMFIL
C                                       Header blocks etc
      INTEGER   PCATI(256,5)
      REAL      PCATR(256,5)
      HOLLERITH PCATH(256,5)
      DOUBLE PRECISION PCATD(128,5)
      REAL      RBLK(MABFSS,4)
      INTEGER   IBLK(MABFSS,4)
      COMMON /MAPHDR/ PCATI
      INCLUDE 'INCS:DCNT.INC'
      EQUIVALENCE (PCATI, PCATR, PCATH, PCATD)
      EQUIVALENCE (IBLK, RBLK, IBUFF)
LOCAL END
      PROGRAM PCNTR
C-----------------------------------------------------------------------
C! Task to generate an image plot with polarization vectors.
C# Map Map-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2002-2004, 2006-2009, 2011-2012, 2014-2017,
C;  Copyright (C) 2019, 2021-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PCNTR will write commands to a plot file for the execution
C   of a contour plot for a cataloged image file and/or a vector
C   polarization vector plot for the associated polarization
C   intensity and position angle maps.
C   First a cataloged map file is found.  Then the list of
C   associated files is searched for PLot files to find the highest
C   version number.  Then a PLot file is created for this map and the
C   catalog header is updated.  Next the graphics commands are
C   written to the plot file.
C    INPUTS:   (from AIPS)
C              DOCONT   R   true (1) means do contour plot.
C              DOVECT   R   true (1) means do polarization vectors.
C              USERID   R   user number, 0 means use logon user
C                       number, 32000 means any user can be accessed.
C              INNAME   R(3)   name of I map.
C              INCLASS  R(2)   class of I map.
C              INSEQ    R   sequence number of I map.
C              INDISK   R   disk volume number of I map.
C              IN2NAME  R(3)   name of P map.
C              IN2CLASS R(2)   class of P map.
C              IN2SEQ   R   sequence number of P map.
C              IN2DISK  R   disk volume number of P map.
C              IN3NAME  R(3)   name of Q map.
C              IN3CLASS R(2)   sequence number of Q map.
C              IN3SEQ   R   sequence number of Q map.
C              IN3DISK  R   the disk volume number of the Q map.
C              BLC      R(7)   the coordinate in the input file to
C                       become the left hand coordinate (1,1) of the
C                       contour plot.  BLC(1) is the X coordinate and
C                       BLC(2) is the Y coordinate.  The first
C                       coordinate in the input image is (1,1).
C              TRC      R(7)   the coordinate in the input file to
C                       become the top right hand corner of the
C                       contour plot. The conventions for BLC hold.
C              XYRATIO  R   the ratio between the scale factor to use
C                       for the X axis and the scale factor to use
C                       for the Y axis.
C              LTYPE    R   the type of axis labeling to use for this
C                          1 = no labels. Make map as big as possible.
C                          2 = no ticks, no tick labels, but rest
C                          3 = RA - DEC coordinates & labels
C                          4 = Center of field relative
C                          5 = Center of sub-image relative
C              PLEV     R   the percentage of the peak value to use as
C                       the multiplier for the contour levels.  If
C                       zero use CLEV below.
C              CLEV     R   The absolute value of the multiplier used
C                       for the contour levels.  This value is used
C                       only if PLEV is zero.
C              LEVS     R(30)   the contour levels.  An out of sequence
C                       level indicates 'end of levels'.  The real
C                       value of a particular level is the LEV value
C                       times CLEV or the value determined by PLEV.
C              FACTOR   R   the number pixels for a vector of
C                       length 1 P units.
C              XINC     R   X spacing in pixels between vectors.
C              YINC     R   Y spacing in pixels between vectors.
C              PCUT     R   do not print vector with lengths .LT.
C                       PCUT in P map units. 0 => 0.1 * Pmax.
C              ICUT     Do not draw vectors when pixel value of I
C                       map < ICUT in I map units. 0 => 0.1*Imax.
C              DOALIGN  R    >= 0. => require axes to line up
C              DOCIRCLE R    > 0 Plot coord grid rather than just ticks
C              INVERS   R    ST file version number.
C              STFACTOR R    scale star sizes in file for plotting:
C                              0 => no plot of stars.
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C      TVCORN   R(2)   TV pixel to use (both > 0 => pixel scale)
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGNAM*6
      INCLUDE 'PCNTR.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA PRGNAM /'PCNTR '/
C-----------------------------------------------------------------------
C                                       init the inputs
      CALL PCNTRI (PRGNAM, IRET)
C                                       do plot
      CALL PCNTRP (IRET)
C
      CALL DIETSK (IRET, QUICK, IWBLK)
C
 999  STOP
      END
      SUBROUTINE PCNTRI (PRGNAM, IRET)
C-----------------------------------------------------------------------
C   Startup routine.  Get parameters and check values and defaults, open
C   image and init PL file.
C   Inputs:
C      PRGNAM    C*6  Task name
C   Output:
C      IRET      I    Return code, 0=> OK else failed
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   IRET
C
      CHARACTER TYPIN*2, CTEMP1*8, CTEMP2*8, OPCODE*4, STOKES*8, RGB*8
      DOUBLE PRECISION DAXV
      REAL   AXV, EPS, PEAK, X, XMULT, RANGE2(2), WRANG2(2), TEMP
      INTEGER  ICPNT, I, IUSER, INC, J, IROUND, IDEPTH(5), IERR, MLOCS,
     *   LLOCS, K, KK, IC, IG, LTYPE
      LOGICAL   T, F, REDUCE, ONEMAP
      INCLUDE 'PCNTR.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA TYPIN /'  '/
      DATA T, F /.TRUE.,.FALSE./
      DATA EPS /0.2/
      DATA STOKES, RGB /'STOKES', 'RGB'/
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      ILUN(1) = 16
      ILUN(2) = 17
      ILUN(3) = 18
      ILUN(4) = 19
      ILUN(5) = 20
      IGLUN = 26
      WASOPN(1) = .FALSE.
      WASOPN(2) = .FALSE.
      WASOPN(3) = .FALSE.
      WASOPN(4) = .FALSE.
      WASOPN(5) = .FALSE.
      IXWDGE = 0
      IYWDGE = 0
C                                       get adverbs
      INPRMS = 209
      IRET = 0
      CALL GTPARM (PRGNAM, INPRMS, QUICK, CONTUR, IWBLK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRET = 1
         END IF
      IF (QUICK) CALL RELPOP (IRET, IWBLK, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 8
      CATUP = F
C                                       Hollerith -> Char
      CALL H2CHR (12, 1, XNAMIN, NAMIN(1))
      CALL H2CHR (6, 1, XCLSIN, CLSIN(1))
      CALL H2CHR (12, 1, XNAM2, NAMIN(2))
      CALL H2CHR (6, 1, XCLS2, CLSIN(2))
      CALL H2CHR (12, 1, XNAM3, NAMIN(3))
      CALL H2CHR (6, 1, XCLS3, CLSIN(3))
      CALL H2CHR (12, 1, XNAM4, NAMIN(4))
      CALL H2CHR (6, 1, XCLS4, CLSIN(4))
      CALL H2CHR (48, 1, XOMFIL, OFMFIL)
      IF ((XDKLIN.LE.0.0) .OR. (XDKLIN.GT.1.0)) XDKLIN = 0.33
C
      ISEQ(1) = IROUND (SEQIN)
      IVOL(1) = IROUND (DSKIN)
      ISEQ(2) = IROUND (SEQIN2)
      IVOL(2) = IROUND (DSKIN2)
      ISEQ(3) = IROUND (SEQIN3)
      IVOL(3) = IROUND (DSKIN3)
      ISEQ(4) = IROUND (SEQIN4)
      IVOL(4) = IROUND (DSKIN4)
      INVER = IROUND (XINVER)
      ZINC = IROUND (X3COL)
      IF (X3COL.GT.0.0) THEN
         ZINC = MAX (1, ZINC)
      ELSE
         ZINC = 1
         END IF
C                                       which is which?
      IC = IROUND (CONTUR)
      IF (CONTUR.GT.0.0) THEN
         IC = MAX (IC, 1)
         NAMIN(5) = NAMIN(IC)
         CLSIN(5) = CLSIN(IC)
         ISEQ(5) = ISEQ(IC)
         IVOL(5) = IVOL(IC)
         END IF
      IG = IROUND (GRYSCL)
      IF ((GRYSCL.GT.0.0) .AND. (IG.NE.4)) THEN
         IG = MAX (IG, 1)
         NAMIN(4) = NAMIN(IG)
         CLSIN(4) = CLSIN(IG)
         ISEQ(4) = ISEQ(IG)
         IVOL(4) = IVOL(IG)
         END IF
      DOCON = CONTUR.GT.0.0
      SPCOLR = (.NOT.DOCON) .AND. (X3COL.GT.0.0)
      DOPOL = POLVEC.GT.0.0
      RGBLAB = IROUND (ABS(TLABEL))
      IF (MOD(RGBLAB,100).LE.0) RGBLAB = 3
      RGBLAB = (RGBLAB-1) / 10
      ILABEL = IROUND (TLABEL)
      LTYPE = MOD (ABS(ILABEL), 100)
      IF (LTYPE.LE.0) LTYPE = 3
      LTYPE = MOD (LTYPE-1,10) + 1
      IF (ILABEL.GT.0) THEN
         ILABEL = (ILABEL/100)*100 + LTYPE
      ELSE
         ILABEL = (ILABEL/100)*100 - LTYPE
         END IF
      PRUSER = NLUSER
      IUSER = NLUSER
      PVCORN = IROUND (XPVCRN)
      IF (.NOT.DOPOL) PVCORN = 0
      BMCORN = IROUND (XHPBP)
      BMBLNK = BMCORN.LT.0.0
      BMCORN = ABS (BMCORN)
      IF (BMCORN.GT.20) BMCORN = 1
      IF (MOD(BMCORN,5).EQ.0) BMCORN = BMCORN - 4
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = XTVCH + 0.01
      TVCORN(1) = IROUND (XTVCRN(1))
      TVCORN(2) = IROUND (XTVCRN(2))
C                                       Set some default values.
      IF (FACTOR.LE.0.000001) FACTOR = 1.0
      IF (XINC.LT.1.0) XINC = 1.0
      IF (YINC.LT.1.0) YINC = 1.0
C                                       Open I map file & get header.
      OPCODE = 'HDWR'
      IF (DOTV) OPCODE = 'READ'
      CALL MAPOPN (OPCODE, IVOL(1), NAMIN(1), CLSIN(1), ISEQ(1), TYPIN,
     *   IUSER, ILUN(1), IFIND(1), ISLOT(1), PCATI(1,1), IWBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      WASOPN(1) = .TRUE.
      SEQIN = ISEQ(1)
      DSKIN = IVOL(1)
      CALL CHR2H (12, NAMIN(1), 1, XNAMIN)
      CALL CHR2H (6, CLSIN(1), 1, XCLSIN)
      IF ((PCATR(KRBMJ,1).LE.1.E-9) .OR. (PCATR(KRBMN,1).LE.1.E-9))
     *   BMCORN = 0
C                                       Add extension file to header.
      IVER = 0
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', IVOL, ISLOT, PCATI, IWBLK, T, 'READ',
     *      IVER, IERR)
         IF (IERR.NE.0) GO TO 975
         END IF
      CALL WINDOW (PCATI(KIDIM,1), PCATI(KINAX,1), XBLC, XTRC, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       check ST plot parms
      I = 0
      IF (XINVER.LT.0.0) STMULT = 0.0
      IF (STMULT.NE.0.0) CALL FNDEXT ('ST', PCATI, I)
      IF (I.GT.0) THEN
         J = XINVER + 0.1
         IF (J.LE.0) J = I
         XINVER = J
      ELSE
         XINVER = 0.0
         STMULT = 0.0
         END IF
      INVER = IROUND (XINVER)
C                                       Default XYRATO: ratio of
C                                       incr if related.
      DO 15 I = 1,5
         IDEPTH(I) = XBLC(I+2) + 0.01
 15      CONTINUE
      LOCNUM = 1
      CALL SETLOC (IDEPTH, T)
      IF ((XYRATO.LE.0.01) .OR. (XYRATO.GT.320.0)) THEN
         IF ((AXTYP(LOCNUM).EQ.1) .AND. (AXINC(2,LOCNUM).NE.0.0)) XYRATO
     *      = ABS (AXINC(1,LOCNUM) / AXINC(2,LOCNUM))
         IF (((XYRATO.LE.0.04) .OR. (XYRATO.GT.25.)) .AND.
     *      (XTRC(1).NE.XBLC(1))) XYRATO = (XTRC(2)-XBLC(2)) /
     *      (XTRC(1)-XBLC(1))
         IF ((XYRATO.LE.0.04) .OR. (XYRATO.GT.25.)) XYRATO = 1.0
         END IF
C                                       Build file name.
      CALL ZPHFIL ('PL', IVOL, ISLOT, IVER, IGFILE, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (7)
         GO TO 970
         END IF
C                                       fill in defaults in PARMS
      IF (X3COL.GT.0.0) THEN
         ZMAX = IROUND (XTRC(3))
      ELSE
         ZMAX = IROUND (XBLC(3))
         END IF
      CALL RCOPY (5, XBLC(3), XTRC(3))
      IF (NAMIN(2).EQ.' ') NAMIN(2) = NAMIN(1)
      IF (NAMIN(3).EQ.' ') NAMIN(3) = NAMIN(1)
      IF (NAMIN(4).EQ.' ') NAMIN(4) = NAMIN(1)
      IF (NAMIN(5).EQ.' ') NAMIN(5) = NAMIN(1)
      IF (CLSIN(2).EQ.' ') CLSIN(2) = 'PPOL  '
      IF (CLSIN(3).EQ.' ') CLSIN(3) = 'PANG  '
      CALL RCOPY (7, XBLC, BLC(1,1))
      CALL RCOPY (7, XTRC, TRC(1,1))
C                                       Check for pol maps = #1
      REDUCE = .FALSE.
      ONEMAP = .FALSE.
      IF (DOPOL) THEN
         POLVEC = 1.0
C                                       Do we have only one image?
         CALL AXEFND (8, STOKES, PCATI(KIDIM,1), PCATH(KHCTP,1), MLOCS,
     *      IERR)
         IF (IERR.EQ.0) THEN
            AXV = PCATD(KDCRV+MLOCS,1) + PCATR(KRCIC+MLOCS,1) *
     *         (1.0 - PCATR(KRCRP+MLOCS,1))
            PEAK = PCATD(KDCRV+MLOCS,1) +  PCATR(KRCIC+MLOCS,1) *
     *         (PCATI(KINAX+MLOCS,1) - PCATR(KRCRP+MLOCS,1))
            ONEMAP = ((AXV.LE.1.0) .AND. (PEAK.GE.3.0)) .OR.
     *         ((AXV.GE.3.0) .AND. (PEAK.LE.1.0))
            END IF
         IF (ONEMAP) THEN
            NAMIN(2) = NAMIN(1)
            CLSIN(2) = CLSIN(1)
            ISEQ(2) = ISEQ(1)
            IVOL(2) = IVOL(1)
            NAMIN(3) = NAMIN(1)
            CLSIN(3) = CLSIN(1)
            ISEQ(3) = ISEQ(1)
            IVOL(3) = IVOL(1)
            END IF
         END IF
C                                       open and check images
      DOCONV = ONEMAP
      DO 50 K = 2,5
         IF (((K.LT.4) .AND. (DOPOL)) .OR.
     *      ((K.EQ.4) .AND. (GRYSCL.GT.0.0)) .OR.
     *      ((K.EQ.5) .AND. (CONTUR.GT.0.0))) THEN
            CALL MAPOPN ('READ', IVOL(K), NAMIN(K), CLSIN(K), ISEQ(K),
     *         TYPIN, IUSER, ILUN(K), IFIND(K), ISLOT(K), PCATI(1,K),
     *         IWBLK, IERR)
            IF (IERR.GT.1) GO TO 970
            WASOPN(K) = .TRUE.
            IF ((K.EQ.2) .OR. ((K.EQ.4) .AND. (IG.EQ.2)) .OR.
     *         ((K.EQ.5) .AND. (IC.EQ.2))) THEN
               SEQIN2 = ISEQ(K)
               DSKIN2 = IVOL(K)
               CALL CHR2H (12, NAMIN(K), 1, XNAM2)
               CALL CHR2H (6, CLSIN(K), 1, XCLS2)
            ELSE IF ((K.EQ.3) .OR. ((K.EQ.4) .AND. (IG.EQ.3)) .OR.
     *         ((K.EQ.5) .AND. (IC.EQ.3))) THEN
               SEQIN3 = ISEQ(K)
               DSKIN3 = IVOL(K)
               CALL CHR2H (12, NAMIN(K), 1, XNAM3)
               CALL CHR2H (6, CLSIN(K), 1, XCLS3)
            ELSE IF ((K.EQ.4) .OR. ((K.EQ.5) .AND. (IC.EQ.4))) THEN
               SEQIN4 = ISEQ(K)
               DSKIN4 = IVOL(K)
               CALL CHR2H (12, NAMIN(K), 1, XNAM4)
               CALL CHR2H (6, CLSIN(K), 1, XCLS4)
               END IF
            DO 20 I = 3,7
               J = KINAX + I - 1
               BLC(I,K) = BLC(I,1)
               IF (PCATI(J,K).LE.1) BLC(I,K) = 1
               TRC(I,K) = BLC(I,K)
 20            CONTINUE
            DO 35 I = 1,2
               J = KRCRP + I - 1
               BLC(I,K) = PCATR(J,K) - PCATR(J,1) + BLC(I,1)
               TRC(I,K) = PCATR(J,K) - PCATR(J,1) + TRC(I,1)
               IF (DOALIN.LT.-1.5) THEN
                  BLC(I,K) = BLC(I,1)
                  TRC(I,K) = TRC(I,1)
                  END IF
               J = I - 1
               IF (DOALIN.GT.-0.10) THEN
                  DAXV = PCATD(KDCRV+J,1) + (BLC(I,1) -
     *               PCATR(KRCRP+J,1)) * PCATR(KRCIC+J,1)
                  IF (PCATR(KRCIC+J,K).EQ.0.0) GO TO 900
                  X = (DAXV - PCATD(KDCRV+J,K)) / PCATR(KRCIC+J,K) +
     *               PCATR(KRCRP+J,K)
                  BLC(I,K) = IROUND (X)
                  IF ((DOALIN.GE.0.1) .AND. (ABS(X-BLC(I,K)).GT.EPS))
     *               GO TO 900
                  TRC(I,K) = BLC(I,K) + TRC(I,1) - BLC(I,1)
                  END IF
C                                       smaller subimage needed?
               IF (BLC(I,K).LT.1.0) THEN
                  DO 25 KK = 1,K
                     BLC(I,KK) = BLC(I,KK) + 1.0 - BLC(I,K)
 25                  CONTINUE
                  REDUCE = .TRUE.
                  END IF
               IF (TRC(I,K).GT.PCATI(KINAX+J,K)) THEN
                  DO 30 KK = 1,K
                     TRC(I,KK) = TRC(I,KK) + PCATI(KINAX+J,K) - TRC(I,K)
 30                  CONTINUE
                  REDUCE = .TRUE.
                  END IF
               IF (BLC(I,K).GE.TRC(I,K)) GO TO 900
 35            CONTINUE
C                                       Check alignment
            IF (DOALIN.GE.0.1) THEN
               INC = 2
               DO 40 I = 1,2
                  J = I - 1
                  X = ABS (PCATR(KRCIC+J,1)) * EPS * EPS
                  ICPNT = KHCTP + J*INC
                  CALL H2CHR (8, 1, PCATH(ICPNT,1), CTEMP1)
                  CALL H2CHR (8, 1, PCATH(ICPNT,K), CTEMP2)
                  IF (CTEMP1.NE.CTEMP2) GO TO 900
                  IF (ABS(PCATR(KRCIC+J,1)-PCATR(KRCIC+J,K)).GT.X)
     *               GO TO 900
                  IF (ABS(PCATR(KRCRT+J,1)-PCATR(KRCRT+J,K)).GT.1.)
     *               GO TO 900
 40               CONTINUE
               END IF
            END IF
 50      CONTINUE
C                                       Levels defaults
      IF (CONTUR.GT.0.0) THEN
         PEAK = MAX (ABS(PCATR(KRDMX,5)), ABS(PCATR(KRDMN,5)))
         IF ((CLEV.EQ.0.0) .AND. (PLEV.EQ.0.0)) PLEV = 10.0
         XMULT = CLEV
         IF (PLEV.NE.0.0) XMULT = PEAK * PLEV / 100.0
         CLEV = XMULT
         PLEV = 0.0
         IF ((LEVS(1).EQ.0.0) .AND. (LEVS(2).LE.LEVS(1))) THEN
            DO 60 I = 1,10
               LEVS(I) = I - 11.
               LEVS(I+10) = I
               LEVS(I+20) = 0.0
 60            CONTINUE
            END IF
         END IF
C                                       INCOLOR ??
      MLOCS = -1
      IF ((GRYSCL.GT.0.0) .AND. (INCOLR.GT.0.0)) THEN
         CALL AXEFND (8, RGB, PCATI(KIDIM,4), PCATH(KHCTP,4), MLOCS,
     *      IERR)
         IF ((IERR.EQ.0) .AND. ((MLOCS.NE.2) .OR.
     *      (PCATI(KINAX+2,4).LT.3))) THEN
            MSGTXT = 'DOCOLR REQUESTED, BUT RGB AXIS NOT 3RD AXIS'
            CALL MSGWRT (7)
            MLOCS = 99
            END IF
         END IF
      IF (MLOCS.NE.2) INCOLR = -1.0
      IF (INCOLR.GT.0.0) THEN
         BLC(3,4) = 1.0
         TRC(3,4) = 1.0
         END IF
C                                       check conversion
      IF (DOPOL) THEN
         CALL AXEFND (8, STOKES, PCATI(KIDIM,3), PCATH(KHCTP,3), MLOCS,
     *      IERR)
         IF (IERR.NE.0) MLOCS = -1
         CALL AXEFND (8, STOKES, PCATI(KIDIM,2), PCATH(KHCTP,2), LLOCS,
     *      IERR)
         IF (IERR.NE.0) LLOCS = -1
         IF ((MLOCS.GE.0) .AND. (LLOCS.GE.0)) THEN
            TEMP = PCATD(KDCRV+MLOCS,3) +  PCATR(KRCIC+MLOCS,3) *
     *         (BLC(1+MLOCS,3) - PCATR(KRCRP+MLOCS,3))
            J = IROUND (TEMP)
            TEMP = PCATD(KDCRV+LLOCS,2) +  PCATR(KRCIC+LLOCS,3) *
     *         (BLC(1+LLOCS,2) - PCATR(KRCRP+LLOCS,2))
            I = IROUND (TEMP)
            DOCONV = (J.EQ.3) .AND. (I.EQ.2)
            END IF
         END IF
      IF (REDUCE) THEN
         MSGTXT = 'Input maps aligned on reduced subimage only'
         CALL MSGWRT (3)
         END IF
      IF (DOCONV) THEN
         IF (ONEMAP) THEN
            POLVEC = 3.0
            MSGTXT = 'First image IQU converted to I-P-angle'
         ELSE
            POLVEC = 2.0
            MSGTXT = 'Second image is Stokes Q and third image is U'
            END IF
         CALL MSGWRT (3)
         END IF
      IRET = 0
C                                       set gray scale range
      IF (GRYSCL.GT.0.0) THEN
         WRANGE(1) = 0.0
         WRANGE(2) = 0.0
         CALL RNGSET (WRANGE, PCATR(KRDMX,4), PCATR(KRDMN,4), WRANG2)
         CALL RNGSET (RANGE, PCATR(KRDMX,4), PCATR(KRDMN,4), RANGE2)
         GFAC = 2.0D0 ** MIN (30, NBITWD)  -  4.0D0
         IF (DOWDGE.LT.2.5) CALL RCOPY (2, RANGE2, WRANG2)
         GFAC = (WRANG2(2)-WRANG2(1)) / GFAC
         GOFF = (WRANG2(2)+WRANG2(1)) / 2.0D0
         RANGE2(2) = (RANGE2(2) - GOFF) / GFAC
         RANGE2(1) = (RANGE2(1) - GOFF) / GFAC
         IHPVAL = IROUND (RANGE2(2))
         ILPVAL = IROUND (RANGE2(1))
         RANGE(1) = (ILPVAL * GFAC + GOFF)
         RANGE(2) = (IHPVAL * GFAC + GOFF)
         WRANG2(2) = (WRANG2(2) - GOFF) / GFAC
         WRANG2(1) = (WRANG2(1) - GOFF) / GFAC
         I = IROUND (WRANG2(2))
         J = IROUND (WRANG2(1))
         WRANGE(1) = (J * GFAC + GOFF)
         WRANGE(2) = (I * GFAC + GOFF)
         IF (DOWDGE.GT.0.0) THEN
            IF ((DOWDGE.LT.1.5) .OR. ((DOWDGE.GE.2.5) .AND.
     *         (DOWDGE.LT.3.5))) THEN
               IYWDGE = MAX (1.0, (TRC(2,4)-BLC(2,4))/20.0) + 2.5
            ELSE
               IXWDGE = MAX (1.0, (TRC(1,4)-BLC(1,4))/20.) + 2.5
               END IF
            IF (INCOLR.GT.0.0) THEN
               IXWDGE = ((IXWDGE+2)/3) * 3
               IYWDGE = ((IYWDGE+2)/3) * 3
               END IF
            END IF
         END IF
      GO TO 999
C                                       Not aligned adequately
 900  MSGTXT = 'INPUT IMAGES NOT SUFFICIENTLY ALIGNED'
      CALL MSGWRT (8)
C
 970  IF (.NOT.DOTV) CALL DELEXT ('PL', IVOL, ISLOT, 'READ', PCATI,
     *   IWBLK, IVER, IERR)
 975  CALL ZCLOSE (ILUN(1), IFIND(1), IERR)
C                                       Close map file.
      DO 980 K = 1,5
         IF (WASOPN(K)) CALL MAPCLS ('READ', IVOL(K), ISLOT(K), ILUN(K),
     *      IFIND(K), PCATI(1,K), F, IWBLK, IERR)
 980     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR GETTING PARAMETERS FROM AIPS. GTPARM ERR =',I5)
 1030 FORMAT ('COULD NOT BUILD GRAPH FILE NAME, IERR=',I5)
      END
      SUBROUTINE PCNTRP (IRET)
C-----------------------------------------------------------------------
C   Plots image as requested.
C   Inputs:
C   Outputs:
C      IRET   I    Return code, 0=OK.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      REAL      YGAP, VMUL, X, Y, TEMP, JBLC(7), JTRC(7), KBLC(7),
     *   KTRC(7), COL(3), AX, AY, RTEMP(2)
      CHARACTER PHNAME*48, SPRTXT*8, LEVTXT*200, TXTMSG*80, PVSTRN*8
      INTEGER   IGSIZE, ITYPE, IDEPTH(5), IERR, K, KK, IBLCX, IBLCY,
     *   ITRCX, ITRCY, INPIXS, INPIXT, IROUND, ICOL, IROW, IANGLE, IPOS,
     *   JPOS, KPOS, JLUN, KLUN, JIND, KIND, IC(3), J, TLUN,
     *   PZMAX, PZMIN, BBLC(2), BTRC(2), BXOFF, BXSIZ, DO3C, LTYPE,
     *   VBLC(2), VTRC(2), VXOFF, VXSIZ
      LOGICAL   T, F, DOGRID, RED2B, ISRGBL
      INCLUDE 'PCNTR.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IF (IRET.NE.0) GO TO 999
      LTYPE = MOD (ABS(ILABEL), 100)
      IANGLE = 0
      IRET = 8
C                                       Init graph file.
      IGSIZE = 1
      ITYPE = 28
      DOGRID = DOCIRC.GT.0.0
      IF (GRYSCL.GT.0.0) THEN
         CALL H2CHR (2, 1, XFUN, GPHFUN)
         IF ((GPHFUN.NE.'LG') .AND. (GPHFUN.NE.'NG') .AND.
     *      (GPHFUN.NE.'SQ') .AND. (GPHFUN.NE.'NQ') .AND.
     *      (GPHFUN.NE.'NE') .AND. (GPHFUN.NE.'L2') .AND.
     *      (GPHFUN.NE.'N2')) GPHFUN = 'LN'
         CALL CHR2H (2, GPHFUN, 1, XFUN)
         END IF
      CALL GINIT (IVOL(1), ISLOT(1), IGFILE, IGSIZE, ITYPE, INPRMS,
     *   CONTUR, DOTV, TVCHN, GRCHN, TVCORN, PCATI, PLBUF, IGLUN,
     *   IGFIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (7)
         GO TO 970
         END IF
      GPHCUT = XDKLIN
      IF (DODARK.LE.0.0) GPHCUT = 100.0
      IF (INCOLR.GT.0.0) OFMFIL = ' '
      IF (GRYSCL.GT.0.0) THEN
         IF (DOTV) GPHDOD = (DODARK.GT.0.0)
         CALL GETOFM (OFMFIL, GPHDOT, GPHTVC, DOOFM, DOCOLR, ROFM, GOFM,
     *      BOFM, NOFM, IERR)
         IF (IERR.NE.0) THEN
            DOOFM = .FALSE.
            IERR = 0
            END IF
         IF (.NOT.DOOFM) DOCOLR = .FALSE.
      ELSE
         INCOLR = -1.0
         GPHDOD = .FALSE.
         DOOFM = .FALSE.
         DOCOLR = .FALSE.
         END IF
      IF (INCOLR.GT.0.0) DOCOLR = .TRUE.
      IF (.NOT.DOOFM) OFMFIL = ' '
      CALL CHR2H (48, OFMFIL, 1, XOMFIL)
C                                       color forced
      ISRGBL = .FALSE.
      DO 20 K = 1,30
         DO 10 J = 1,3
            IF (RGBLEV(J,K).GT.0.0) ISRGBL = .TRUE.
 10         CONTINUE
 20      CONTINUE
      ZMIN = BLC(3,5)
      IF (ZMAX.GT.ZMIN) ISRGBL = .FALSE.
      FORCEC = ISRGBL .OR. (P3COL.GT.0.0) .OR. (X3COL.GT.0.0)
      IF (DOCOLR) FORCEC = .FALSE.
C                                       Character borders
      CALL RFILL (4, 0.0, CHOUT)
      IF (.NOT.DOPOL) PAROT = 0.0
      K = 0
      IF ((LTYPE.GT.1) .AND. (LTYPE.LE.6)) THEN
         IF (DOPOL) THEN
            K = 1
            IF (PAROT.NE.0.0) K = 2
            END IF
         IF (GRYSCL.GT.0.0) K = K + 1
         END IF
      CHOUT(2) = K * 1.333
C                                       Write init commands, external
C                                       labels
      CALL PLTVSZ (PVCORN, BLC, TRC, PCATR, VBLC, VTRC, VASEC)
      IF (RGBLAB.GE.2) ISRGBL = .FALSE.
      CALL PGLAB (YGAP, ISRGBL, LEVTXT, IERR)
      IF (IERR.NE.0) GO TO 950
      IF (BMBLNK) THEN
         CALL PLTBSZ (BMCORN, BLC, TRC, PCATR, BBLC, BTRC)
      ELSE
         BBLC(1) = 0
         BBLC(2) = 0
         BTRC(1) = 0
         BTRC(2) = 0
         END IF
C                                       Grey scale before axis labeling
      IF (GRYSCL.GT.0.0) THEN
         TXTMSG = 'Do grey scale:'
         CALL GCOMNT (2, TXTMSG, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
C                                       open other planes
         IF (INCOLR.GT.0.0) THEN
            JLUN = ILUN(5) + 1
            KLUN = ILUN(5) + 2
            CALL ZPHFIL ('MA', IVOL(4), ISLOT(4), 1, PHNAME, IERR)
            CALL ZOPEN (JLUN, JIND, IVOL(4), PHNAME, T, T, T, IERR)
            IF (IERR.EQ.0) CALL ZOPEN (KLUN, KIND, IVOL(4), PHNAME, T,
     *         T, T, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1040) 'OPEN EXTRA PLANES', IERR
               CALL MSGWRT (8)
               GO TO 950
               END IF
            CALL RCOPY (7, BLC(1,4), JBLC)
            CALL RCOPY (7, BLC(1,4), KBLC)
            CALL RCOPY (7, TRC(1,4), JTRC)
            CALL RCOPY (7, TRC(1,4), KTRC)
            BLC(3,4) = (1.0D0 - PCATD(KDCRV+2,4)) / PCATR(KRCIC+2,4)
     *         + PCATR(KRCRP+2,4)
            JBLC(3) = (2.0D0 - PCATD(KDCRV+2,4)) / PCATR(KRCIC+2,4)
     *         + PCATR(KRCRP+2,4)
            KBLC(3) = (3.0D0 - PCATD(KDCRV+2,4)) / PCATR(KRCIC+2,4)
     *         + PCATR(KRCRP+2,4)
            TRC(3,4) = BLC(3,4)
            JTRC(3) = JBLC(3)
            KTRC(3) = KBLC(3)
            END IF
         IBLCX = IROUND (BLC(1,1))
         IBLCY = IROUND (BLC(2,1))
         ITRCX = IROUND (TRC(1,1))
         ITRCY = IROUND (TRC(2,1))
         INPIXS = ITRCX - IBLCX + 1
         INPIXT = INPIXS + IXWDGE
         BXOFF = BBLC(1) - IBLCX
         BXSIZ = BTRC(1) - BBLC(1) + 1
         VXOFF = VBLC(1) - IBLCX
         VXSIZ = VTRC(1) - VBLC(1) + 1
C                                       Top step wedge
         IF (IYWDGE.GT.0) THEN
            VMUL = (WRANGE(2) - WRANGE(1)) / (TRC(1,4) - BLC(1,4))
            DO 30 ICOL = 1,INPIXS
               RLROW(ICOL) = (ICOL - 1.) * VMUL + WRANGE(1)
 30            CONTINUE
            CALL GSCALE (GPHFUN, RANGE, INPIXS, 1, RLROW, ILROW)
            IF (INCOLR.GT.0.0) THEN
               CALL FILL (INPIXT, GPHTLO, IBBUFF)
               CALL FILL (INPIXT, GPHTLO, IBLROW)
            ELSE IF (DOOFM) THEN
               CALL G3SCAL (INPIXT, ILROW, NOFM, ROFM, GOFM, BOFM,
     *            ILROW, IBBUFF, IBLROW)
            ELSE IF (FORCEC) THEN
               CALL COPY (INPIXT, ILROW, IBBUFF)
               CALL COPY (INPIXT, ILROW, IBLROW)
               END IF
            DO 40 IROW = 1,IYWDGE
               X = IBLCX
               Y = ITRCY + IROW
               CALL GPOS (X, Y, PLBUF, IERR)
               IF (IERR.NE.0) GO TO 950
               IF (INCOLR.GT.0.0) THEN
                  IF (IROW.LE.IYWDGE/3) THEN
                     CALL G3COLR (INPIXT, IANGLE, ILROW, IBBUFF, IBLROW,
     *                  PLBUF, IERR)
                  ELSE IF (IROW.LE.(2*IYWDGE)/3) THEN
                     CALL G3COLR (INPIXT, IANGLE, IBBUFF, ILROW, IBLROW,
     *                  PLBUF, IERR)
                  ELSE
                     CALL G3COLR (INPIXT, IANGLE, IBBUFF, IBLROW, ILROW,
     *                  PLBUF, IERR)
                     END IF
               ELSE IF ((DOCOLR) .OR. (FORCEC)) THEN
                  CALL G3COLR (INPIXT, IANGLE, ILROW, IBBUFF, IBLROW,
     *               PLBUF, IERR)
               ELSE
                  CALL GRAYPX (INPIXT, IANGLE, ILROW, PLBUF, IERR)
                  END IF
               IF (IERR.NE.0) GO TO 950
 40            CONTINUE
            END IF
C                                       Loop over all rows.
         CALL DBINIT (ILUN(4), IFIND(4), PCATI(1,4), BLC(1,4), TRC(1,4),
     *      JBUFSZ, BUFF, IERR)
         IF ((INCOLR.GT.0.0) .AND. (IERR.EQ.0)) THEN
            CALL DBINIT (JLUN, JIND, PCATI(1,4), JBLC, JTRC, JBUFSZ,
     *         BBUFF, IERR)
            IF (IERR.EQ.0) CALL DBINIT (KLUN, KIND, PCATI(1,4), KBLC,
     *         KTRC, JBUFSZ, RLROW, IERR)
            END IF
         IF (IERR.NE.0) GO TO 950
         DO 50 IROW = IBLCY,ITRCY
C                                       Read proper row.
            CALL MDISK ('READ', ILUN(4), IFIND(4), BUFF, IPOS, IERR)
            IF ((IERR.EQ.0) .AND. (INCOLR.GT.0.0)) THEN
               CALL MDISK ('READ', JLUN, JIND, BBUFF, JPOS, IERR)
               IF (IERR.EQ.0) CALL MDISK ('READ', KLUN, KIND, RLROW,
     *            KPOS, IERR)
               END IF
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1040) 'READ', IERR
               CALL MSGWRT (7)
               GO TO 950
               END IF
C                                       Position.
            X = IBLCX
            Y = IROW
            CALL GPOS (X, Y, PLBUF, IERR)
            IF (IERR.NE.0) GO TO 950
            IF ((IROW.GE.BBLC(2)) .AND. (IROW.LE.BTRC(2))) THEN
               CALL RFILL (BXSIZ, FBLANK, BUFF(IPOS+BXOFF))
               IF ((INCOLR.GT.0.0) .OR. (FORCEC)) THEN
                  CALL RFILL (BXSIZ, FBLANK, BBUFF(JPOS+BXOFF))
                  CALL RFILL (BXSIZ, FBLANK, RLROW(KPOS+BXOFF))
                  END IF
               END IF
            IF ((IROW.GE.VBLC(2)) .AND. (IROW.LE.VTRC(2))) THEN
               CALL RFILL (VXSIZ, FBLANK, BUFF(IPOS+VXOFF))
               IF ((INCOLR.GT.0.0) .OR. (FORCEC)) THEN
                  CALL RFILL (VXSIZ, FBLANK, BBUFF(JPOS+VXOFF))
                  CALL RFILL (VXSIZ, FBLANK, RLROW(KPOS+VXOFF))
                  END IF
               END IF
            CALL GSCALE (GPHFUN, RANGE, INPIXS, 1, BUFF(IPOS),
     *         IBUFF(IPOS))
            IF (INCOLR.GT.0.0) THEN
               CALL GSCALE (GPHFUN, RANGE, INPIXS, 1, BBUFF(JPOS),
     *            IBBUFF(JPOS))
               CALL GSCALE (GPHFUN, RANGE, INPIXS, 1, RLROW(KPOS),
     *            ILROW(KPOS))
            ELSE IF (DOOFM) THEN
               JPOS = IPOS
               KPOS = IPOS
               CALL G3SCAL (INPIXS, IBUFF(IPOS), NOFM, ROFM, GOFM, BOFM,
     *            IBUFF(IPOS), IBBUFF(JPOS), ILROW(KPOS))
            ELSE IF (FORCEC) THEN
               JPOS = IPOS
               KPOS = IPOS
               CALL COPY (INPIXS, IBUFF(IPOS), IBBUFF(JPOS))
               CALL COPY (INPIXS, IBUFF(IPOS), ILROW(KPOS))
               END IF
            IF ((DOCOLR) .OR. (FORCEC)) THEN
               CALL G3COLR (INPIXS, 0, IBUFF(IPOS), IBBUFF(JPOS),
     *            ILROW(KPOS), PLBUF, IERR)
            ELSE
               CALL GRAYPX (INPIXS, 0, IBUFF(IPOS), PLBUF, IERR)
               END IF
            IF (IERR.NE.0) GO TO 950
 50         CONTINUE
C                                       add wedge to right
         IF (IXWDGE.GT.0) THEN
            VMUL = (WRANGE(2) - WRANGE(1)) / (TRC(2,4) - BLC(2,4))
            J = IXWDGE / 3
            CALL FILL (IXWDGE, GPHTLO, IBUFF)
            CALL FILL (IXWDGE, GPHTLO, IBBUFF)
            CALL FILL (IXWDGE, GPHTLO, IBLROW)
            DO 60 IROW = IBLCY,ITRCY
               X = IBLCX + INPIXS
               Y = IROW
               CALL GPOS (X, Y, PLBUF, IERR)
               IF (IERR.NE.0) GO TO 950
               RTEMP(1) = (IROW - IBLCY) * VMUL + WRANGE(1)
               CALL GSCALE (GPHFUN, RANGE, 1, 1, RTEMP, IC(1))
               IF (DOOFM) CALL G3SCAL (1, IC(1), NOFM, ROFM, GOFM, BOFM,
     *            IC(1), IC(2), IC(3))
               IF (INCOLR.GT.0.0) THEN
                  CALL FILL (J, IC(1), IBUFF(1))
                  CALL FILL (J, IC(1), IBBUFF(1+J))
                  CALL FILL (J, IC(1), IBLROW(1+J+J))
                  CALL G3COLR (IXWDGE, IANGLE, IBUFF, IBBUFF, IBLROW,
     *               PLBUF, IERR)
               ELSE IF (FORCEC) THEN
                  CALL FILL (IXWDGE, IC(1), IBUFF)
                  CALL FILL (IXWDGE, IC(1), IBBUFF)
                  CALL FILL (IXWDGE, IC(1), IBLROW)
                  CALL G3COLR (IXWDGE, IANGLE, IBUFF, IBBUFF, IBLROW,
     *               PLBUF, IERR)
               ELSE IF (DOCOLR) THEN
                  CALL FILL (IXWDGE, IC(1), IBUFF)
                  CALL FILL (IXWDGE, IC(2), IBBUFF)
                  CALL FILL (IXWDGE, IC(3), IBLROW)
                  CALL G3COLR (IXWDGE, IANGLE, IBUFF, IBBUFF, IBLROW,
     *               PLBUF, IERR)
               ELSE
                  CALL FILL (IXWDGE, IC(1), IBUFF)
                  CALL GRAYPX (IXWDGE, IANGLE, IBUFF, PLBUF, IERR)
                  END IF
               IF (IERR.NE.0) GO TO 950
 60            CONTINUE
            END IF
         END IF
C                                       Draw borders.
      TXTMSG = 'Draw labels'
      CALL GCOMNT (-1, TXTMSG, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950

      CALL GLTYPE (1, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GPOS (NBLC(1), NBLC(2), PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GVEC (NTRC(1), NBLC(2), PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GVEC (NTRC(1), NTRC(2), PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GVEC (NBLC(1), NTRC(2), PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GVEC (NBLC(1), NBLC(2), PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
C                                       Line off the wedge.
      IF (IXWDGE.NE.0) THEN
         TEMP = NTRC(1) - IXWDGE - 0.2
         CALL GPOS (TEMP, NBLC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GVEC (TEMP, NTRC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
      IF (IYWDGE.NE.0) THEN
         TEMP = NTRC(2) - IYWDGE - 0.2
         CALL GPOS (NBLC(1), TEMP, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GVEC (NTRC(1), TEMP, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
      CALL CLAB1 (ABLC, ATRC, CHOUT, ILABEL, XYRATO, DOGRID, PLBUF,
     *   IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GTIC (ILABEL, BLC(1,1), TRC(1,1), NTRC, ATRC, WRANGE, PLBUF,
     *   IERR)
      IF (IERR.NE.0) GO TO 950
C                                       Recover true LOCATI info
C                                       Draw stars
      CALL GLTYPE (4, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL SETLOC (IDEPTH, T)
      IF (GRYSCL.LE.0.0) IFIND(4) = 0
      CALL STARPL (STMULT, IVOL, ISLOT, INVER, ABLC, ATRC, ILUN(4),
     *   IFIND(4), PCATI, BLC, 1, PLBUF, IERR)
      IF (IERR.GE.3) GO TO 950
      IF ((LTYPE.GT.1) .AND. (LTYPE.LE.6) .AND. (DOPOL))
     *   THEN
         CALL GLTYPE (1, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL PLNLAB (YGAP, PVSTRN, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
C                                       Write contour plot.
      IF (DOCON) THEN
         CALL GLTYPE (2, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         TXTMSG = 'Start contouring'
         CALL GCOMNT (2, TXTMSG, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         ZMIN = BLC(3,5)
C                                       color=velocity contours
         IF (ZMAX.GT.ZMIN) THEN
            DO3C = 1
            CALL H2CHR (8, 1, PCATH(KHCTP+4,5), SPRTXT)
            IF (SPRTXT(:4).EQ.'FREQ') THEN
               RED2B = PCATR(KRCIC+2,5).GT.0.0
            ELSE IF (SPRTXT(:4).EQ.'VELO') THEN
               RED2B = PCATR(KRCIC+2,5).LT.0.0
            ELSE IF (SPRTXT(:4).EQ.'FELO') THEN
               RED2B = PCATR(KRCIC+2,5).LT.0.0
               END IF
C                                       other color contours or ?
         ELSE
            DO3C = 0
            DO 80 K = 1,30
               IF ((K.EQ.1) .OR. (LEVS(K).GT.LEVS(K-1))) THEN
                  DO 75 J = 1,3
                     IF (RGBLEV(J,K).GT.0.0) DO3C = 2
 75                  CONTINUE
                  END IF
 80            CONTINUE
            END IF
         IF ((DODARK.GT.0.0) .AND. (DO3C.GT.0)) THEN
            MSGTXT = 'DODARK is not used on color contours'
            CALL MSGWRT (2)
            END IF
         DO 90 K = ZMIN,ZMAX,ZINC
C                                       color contour
            IF (DO3C.EQ.1) THEN
               X = K - ZMIN
               X = X / (ZMAX - ZMIN)
               IF (.NOT.RED2B) X = 1.0 - X
               CALL COLOR3 (X, .FALSE., COL)
               CALL G3VCOL (COL(1), COL(2), COL(3), PLBUF, IERR)
               IF (IERR.NE.0) GO TO 950
               END IF
            BLC(3,5) = K
            TRC(3,5) = K
C                                       Init contour map for double buff
C                                       CONDRW uses buffers 1 and 2
            CALL DBINIT (ILUN(5), IFIND(5), PCATI(1,5), BLC(1,5),
     *         TRC(1,5), JBUFSZ, RBLK(1,1), IERR)
            IF (IERR.NE.0) GO TO 950
            IF ((GRYSCL.GT.0.0) .AND. (DODARK.GT.0.0) .AND. (DO3C.LE.0))
     *         THEN
               CALL DBINIT (ILUN(4), IFIND(4), PCATI(1,4), BLC(1,4),
     *            TRC(1,4), JBUFSZ, RBLK(1,2), IERR)
               IF (IERR.NE.0) GO TO 950
               TLUN = ILUN(4)
            ELSE
               TLUN = -1
               END IF
            CALL CONDRW (ILUN(5), IFIND(5), TLUN, IFIND(4), CLEV,
     *         BLC(1,5), TRC(1,5), LEVS, DO3C, BBLC, BTRC, VBLC, VTRC,
     *         RGBLEV, PLBUF, IERR)
            IF (IERR.GT.9) GO TO 960
            IF (IERR.NE.0) GO TO 200
 90         CONTINUE
         BLC(3,5) = ZMIN
         TRC(3,5) = ZMIN
         END IF
C                                       Write polarization vector plot.
      IF (DOPOL) THEN
         KK = 3
         IF ((GRYSCL.GT.0.0) .AND. (DODARK.GT.0.0)) KK = 4
C                                        Draw polarization vectors.
         TXTMSG = 'Start polarization lines'
         CALL GCOMNT (2, TXTMSG, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GLTYPE (3, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         PZMIN = BLC(3,1)
         IF (SPCOLR) THEN
            PZMAX = ZMAX
         ELSE
            PZMAX = PZMIN
            END IF
         IF (PZMAX.GT.PZMIN) THEN
            DO3C = 1
            P3COL = -1.0
            CALL H2CHR (8, 1, PCATH(KHCTP+4,1), SPRTXT)
            IF (SPRTXT(:4).EQ.'FREQ') THEN
               RED2B = PCATR(KRCIC+2,1).GT.0.0
            ELSE IF (SPRTXT(:4).EQ.'VELO') THEN
               RED2B = PCATR(KRCIC+2,1).LT.0.0
            ELSE IF (SPRTXT(:4).EQ.'FELO') THEN
               RED2B = PCATR(KRCIC+2,1).LT.0.0
               END IF
         ELSE
            DO3C = 0
            END IF
         DO 110 K = PZMIN,PZMAX,ZINC
C                                       color contour
            IF (DO3C.EQ.1) THEN
               X = K - ZMIN
               X = X / (ZMAX - ZMIN)
               IF (.NOT.RED2B) X = 1.0 - X
               CALL COLOR3 (X, .FALSE., COL)
               CALL G3VCOL (COL(1), COL(2), COL(3), PLBUF, IERR)
               IF (IERR.NE.0) GO TO 950
               END IF
            BLC(3,1) = K
            TRC(3,1) = K
            BLC(3,2) = K
            TRC(3,2) = K
            BLC(3,3) = K
            TRC(3,3) = K

            DO 105 J = 1,KK
               CALL DBINIT (ILUN(J), IFIND(J), PCATI(1,J), BLC(1,J),
     *            TRC(1,J), JBUFSZ, RBLK(1,J), IERR)
               IF (IERR.NE.0) GO TO 200
 105           CONTINUE
            CALL POLDRW (BBLC, BTRC, VBLC, VTRC, IERR)
            IF (IERR.GT.9) GO TO 960
 110        CONTINUE
         END IF
C                                       beam
      IF (BMCORN.GT.0) THEN
         CALL GLTYPE (1, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL PLTBEM (BMCORN, BLC, TRC, PCATR, PLBUF, IERR)
         IF (IERR.GT.0) GO TO 960
         END IF
      IF (PVCORN.GT.0) THEN
         CALL GLTYPE (1, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL PLTVEC (PVCORN, VBLC, VTRC, VASEC, PVSTRN, PLBUF, IERR)
         IF (IERR.GT.0) GO TO 960
         END IF
C                                       rgblev display
      IF ((DO3C.EQ.2) .AND. (RGBLAB.LE.1) .AND. (DOCON)) THEN
         X = 4
         IF (RGBLAB.LE.0) THEN
            AX = NBLC(1)
            AY = NBLC(2)
            Y = 2.5
         ELSE
            AX = NBLC(1)
            AY = NTRC(2)
            Y = -4.
            END IF
         TXTMSG = 'Draw LEVS values in RGB colors'
         CALL GCOMNT (2, TXTMSG, PLBUF, IRET)
         IF (IRET.NE.0) GO TO 950
         CALL TXRGBL (X, Y, AX, AY, LEVTXT, RGBLEV, PLBUF, IERR)
         END IF
C                                       Write sucessful finish message.
 200  IF (IERR.NE.0) GO TO 950
         CALL GFINIS (PLBUF, IERR)
         IF (IERR.NE.0) GO TO 960
            IF (.NOT.DOTV) THEN
               CALL HIPLOT (IVOL, ISLOT, IVER, IWBLK, IERR)
               CATUP = T
               WRITE (MSGTXT,1200) IVER
               CALL MSGWRT (2)
               END IF
            IRET = 0
            GO TO 980
C-----------------------------------------------------------------------
C                                       Graph writing error.
 950  WRITE (MSGTXT,1950)
      CALL MSGWRT (8)
C                                       Try to do finish.
      CALL GFINIS (PLBUF, IERR)
      IF (IERR.NE.0) GO TO 960
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (IVOL, ISLOT, IVER, IWBLK, IERR)
            CATUP = T
            END IF
         IRET = 0
         GO TO 980
C                                       Finish not sucessful. Destroy.
 960  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (IGLUN, IGFIND, IERR)
         CALL ZDESTR (IVOL, IGFILE, IERR)
         END IF
 970  IF (.NOT.DOTV) CALL DELEXT ('PL', IVOL, ISLOT, 'READ', PCATI,
     *   IWBLK, IVER, IERR)
      CALL ZCLOSE (ILUN(1), IFIND(1), IERR)
C                                       Close map file.
 980  DO 985 K = 1,5
         IF (WASOPN(K)) CALL MAPCLS ('READ', IVOL(K), ISLOT(K), ILUN(K),
     *      IFIND(K), PCATI(1,K), F, IWBLK, IERR)
 985     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GRAPH FILE INIT ERROR. GINIT ERR =',I5)
 1040 FORMAT (A,' GREY-SCALE IMAGE ERROR =',I5)
 1200 FORMAT ('Successful plot file version',I5,'  created.')
 1950 FORMAT ('Error during graphing will try to finish partial graph')
      END
      SUBROUTINE PLNLAB (YGAP, PVSTRN, IERR)
C-----------------------------------------------------------------------
C  Write character command to graph file that says 'Pol line : 1 pixel
C  = ...'
C   Inputs
C      YGAP    R    place to write pol. vector plot line
C   Output:
C      IERR    I    error code from GCHAR.
C-----------------------------------------------------------------------
      REAL      YGAP
      INTEGER   IERR
      CHARACTER PVSTRN*(*)
C
      CHARACTER BJUNK*8, SPRTXT*80
      INTEGER   IANGL, INCHAR, ITRIM
      REAL      DCX, DCY, VECTOR, TEMP
      INCLUDE 'PCNTR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      PVSTRN = ' '
C                                       'Pol line : 1 pixel = ...'
      DCX = 0.0
      DCY = -YGAP
      YGAP = YGAP + 1.333
      IANGL = 0
      CALL GPOS (NBLC(1), NBLC(2), PLBUF, IERR)
      IF (IERR.NE.0) GO TO 999
      VECTOR = 0.5 / FACTOR
      CALL H2CHR (8, 1, PCATH(KHBUN,2), BJUNK)
      IF (DOFRAC.GT.0.0) BJUNK = 'Frac pol'
      WRITE (SPRTXT,1000) VECTOR, BJUNK
C                                       Arc seconds instead
      IF ((AXTYP(LOCNUM).EQ.1) .AND. (PCATR(KRCIC,2).NE.0.0) .AND.
     *   (PCATR(KRCIC+1,2).NE.0.0)) THEN
         TEMP = MAX (ABS(PCATR(KRCIC,2)), ABS (PCATR(KRCIC+1,2))) *
     *      3600.
         VECTOR = VECTOR * VASEC / TEMP
         IF (TEMP.GT.0.01) THEN
            WRITE (SPRTXT,1001) VASEC, VECTOR, BJUNK
         ELSE
            WRITE (SPRTXT,1002) VASEC * 1000, VECTOR, BJUNK
            END IF
         END IF
      INCHAR = ITRIM (SPRTXT)
      CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPRTXT, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (DOFRAC.GT.0.0) THEN
         WRITE (PVSTRN,1020) VECTOR*100.0
      ELSE
         WRITE (PVSTRN,1021) VECTOR
         END IF
C                                       Add info on ROTATE
      IF (PAROT.NE.0.0) THEN
         CALL GPOS (NBLC(1), NBLC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 999
         WRITE (SPRTXT,1010) PAROT
         DCY = -YGAP
         YGAP = YGAP + 1.333
         CALL REFRMT (SPRTXT, ' ', INCHAR)
         CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPRTXT, PLBUF, IERR)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Pol line: 1 pixel =',1PE12.4,1X,A8)
 1001 FORMAT ('Pol line',F8.3,' arcsec =',1PE12.4,1X,A8)
 1002 FORMAT ('Pol line',F8.3,' milli arcsec =',1PE12.4,1X,A8)
 1010 FORMAT ('Rotated by',F7.1,' degrees')
 1020 FORMAT (F6.1,' %')
 1021 FORMAT (F8.3)
      END
      SUBROUTINE POLDRW (BBLC, BTRC, VBLC, VTRC, IERR)
C-----------------------------------------------------------------------
C   POLDRW will read the I, P, and A maps and add the polarization
C   vectors to the graph file.
C   Output:
C      IERR    I   the error code. 0 = ok.
C                      9 => QUIT op received from TELL
C                     10 => ABOR op received from TELL
C-----------------------------------------------------------------------
      INTEGER   BBLC(2), BTRC(2), VBLC(2), VTRC(2), IERR
C
      REAL      CON, P, Q, X, X0, Y, Y0, IICUT, Z1, Z2, Z3, PLEN, PA,
     *   TEMP, COL(3), FACT
      INTEGER   I, IPOS(4), IM, INCOLS, INROWS, IXINC, IYINC, K, J, MJ,
     *   BCUT, BVAL, LCORN, IBLCY, ITRCY, IROUND, ITRCX, IBLCX, BXOFF,
     *   BXSIZ, VXOFF, VXSIZ
      DOUBLE PRECISION RRA, DDE, DZ
      LOGICAL   DOBACK, PERLEY
      INCLUDE 'PCNTR.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      DOBACK = (GRYSCL.GT.0.0) .AND. (DODARK.GT.0.0)
      IF (DOBACK) BCUT = GPHCUT * GPHTHI + (1.0-GPHCUT) * GPHTLO
      MJ = 3
      IF (DOBACK) MJ = 4
      IBLCX = IROUND (BLC(1,1))
      IBLCY = IROUND (BLC(2,1))
      ITRCX = IROUND (TRC(1,1))
      ITRCY = IROUND (TRC(2,1))
      INCOLS = ITRCX - IBLCX + 1
      INROWS = ITRCY - IBLCY + 1
      BXOFF = BBLC(1) - IBLCX
      BXSIZ = BTRC(1) - BBLC(1) + 1
      VXOFF = VBLC(1) - IBLCX
      VXSIZ = VTRC(1) - VBLC(1) + 1
      IBLCY = BLC(2,1)
      ITRCY = TRC(2,1) + 0.5
      INROWS = TRC(2,1) - BLC(2,1) + 1.5
      INCOLS = TRC(1,1) - BLC(1,1) + 1.5
      IXINC = XINC + .5
      IYINC = YINC + .5
      CON = 3.14159 / 180.0
      PERLEY = .FALSE.
      IF (AXTYP(LOCNUM).NE.1) THEN
         MSGTXT = 'AXES NOT COORDINATE PAIR: angles may be meaningless'
         CALL MSGWRT (8)
C         IERR = 2
C         GO TO 999
         PERLEY = (CTYP(1,LOCNUM).EQ.'L') .AND. (AXINC(1,LOCNUM).GT.0.0)
     *      .AND. (CTYP(2,LOCNUM).EQ.'M')
         END IF
C                                       Find pixel value cut off.
      IICUT = ICUT
      FACT = FACTOR * MAX (ABS(PCATR(KRCIC,1)), ABS(PCATR(KRCIC+1,1)))
C                                        Loop for all rows.
      DO 100 I = IBLCY,ITRCY
         DO 25 J = 1,MJ
            CALL MDISK ('READ', ILUN(J), IFIND(J), RBLK(1,J), IPOS(J),
     *         IERR)
            IF (IERR.NE.0) GO TO 999
            IF ((I.GE.BBLC(2)) .AND. (I.LE.BTRC(2))) THEN
               CALL RFILL (BXSIZ, FBLANK, RBLK(IPOS(J)+BXOFF,J))
               END IF
            IF ((I.GE.VBLC(2)) .AND. (I.LE.VTRC(2))) THEN
               CALL RFILL (VXSIZ, FBLANK, RBLK(IPOS(J)+VXOFF,J))
               END IF
 25         CONTINUE
         IF ((MOD(I-IBLCY,IYINC).EQ.0) .OR. (IYINC.EQ.1)) THEN
            IF (DOBACK) CALL GSCALE (GPHFUN, GPHRNG, INCOLS, 1,
     *         RBLK(IPOS(4),4), IBLK(IPOS(4),4))
C                                        Yes. Do for all pixels.
            IM = -1
            DO 90 K = IBLCX,ITRCX,IXINC
               IM = K - IBLCX
C                                       Check for blanked pixels.
               Z1 = RBLK(IPOS(1)+IM,1)
               Z2 = RBLK(IPOS(2)+IM,2)
               Z3 = RBLK(IPOS(3)+IM,3)
               IF (DOBACK) BVAL = IBLK(IPOS(4)+IM,4)
               IF (Z1.EQ.FBLANK) GO TO 90
               IF (Z2.EQ.FBLANK) GO TO 90
               IF (Z3.EQ.FBLANK) GO TO 90
C                                       Check user supplied cut off.
               IF (DOCONV) THEN
                  P = SQRT (Z2*Z2 + Z3*Z3)
                  PA = 28.64789 * ATAN2 (Z3, Z2+1.0E-20) + PAROT
               ELSE
                  P = Z2
                  PA = Z3 + PAROT
                  END IF
C                                       Use these pixels.
               IF ((Z1.GE.IICUT) .AND. (P.GE.PCUT)) THEN
                  X0 = K
                  Y0 = I
                  Q = CON * PA
                  IF (CORTYP (LOCNUM).EQ.1) THEN
                     CALL XYVAL (X0, Y0, RRA, DDE, DZ, IERR)
                  ELSE
                     CALL XYVAL (X0, Y0, DDE, RRA, DZ, IERR)
                     END IF
                  IF (IERR.NE.0) GO TO 980
C                                       fractional pol
                  IF (DOFRAC.GT.0.0) P = P / Z1
                  PLEN = FACT * P
                  IF (AXTYP(LOCNUM).NE.1) THEN
                     X = X0 + PLEN * SIN (Q) / AXINC(1,LOCNUM)
                     Y = Y0 + PLEN * COS (Q) / AXINC(2,LOCNUM)
                     IF (PERLEY) X = 2 * X0 - X
                  ELSE
                     RRA = RRA + PLEN * SIN (Q) / COS (DDE * CON)
                     DDE = DDE + PLEN * COS (Q)
                     IF (CORTYP(LOCNUM).EQ.1) THEN
                        CALL XYPIX (RRA, DDE, X, Y, IERR)
                     ELSE
                        CALL XYPIX (DDE, RRA, X, Y, IERR)
                        END IF
                     IF (IERR.NE.0) GO TO 980
                     END IF
                  CALL GPOS (X, Y, PLBUF, IERR)
                  IF (IERR.NE.0) GO TO 990
                  X = 2 * X0 - X
                  Y = 2 * Y0  - Y
                  IF ((DOBACK) .AND. (BVAL.GT.BCUT)) THEN
                     CALL GDVEC (X, Y, PLBUF, IERR)
                  ELSE IF (P3COL.GT.0.0) THEN
                     TEMP = PA - P3COL
                     TEMP = MOD (TEMP+3600.0, 180.0)
                     TEMP = TEMP / 180.0
                     CALL COLOR3 (TEMP, .TRUE., COL)
                     CALL G3VCOL (COL(1), COL(2), COL(3), PLBUF, IERR)
                     IF (IERR.NE.0) GO TO 990
                     CALL G3VEC (X, Y, PLBUF, IERR)
                  ELSE IF (SPCOLR) THEN
                     CALL G3VEC (X, Y, PLBUF, IERR)
                  ELSE
                     CALL GVEC (X, Y, PLBUF, IERR)
                     END IF
                  IF (IERR.NE.0) GO TO 990
                  END IF
 90            CONTINUE
            END IF
 100     CONTINUE
C                                       POL color wheel
      IF (P3COL.GT.0.0) THEN
         LCORN = MOD (BMCORN, 5)
         K = MAX (1, INROWS / 15)
         J = MAX (1, INCOLS / 15)
         P = K*K + J*J
         P = SQRT (P)
         IF (LCORN.LE.1) THEN
            Y0 = BLC(2,1) + INROWS - 3*K
            X0 = BLC(1,1) + INCOLS - 2*J
         ELSE IF (LCORN.EQ.2) THEN
            Y0 = BLC(2,1) + INROWS - 3*K
            X0 = BLC(1,1) + 2*J
         ELSE IF (LCORN.EQ.3) THEN
            P = -P
            Y0 = BLC(2,1) + 3*K
            X0 = BLC(1,1) + 2*J
         ELSE IF (LCORN.EQ.4) THEN
            P = -P
            Y0 = BLC(2,1) + 3*K
            X0 = BLC(1,1) + INCOLS - 2*J
            END IF
         DO 140 I = 1,180,2
            PA = (I - 90) * DG2RAD
            TEMP = I - 90 - P3COL
            TEMP = MOD (TEMP+3600.0, 180.0)
            TEMP = TEMP / 180.0
            CALL COLOR3 (TEMP, .TRUE., COL)
            CALL G3VCOL (COL(1), COL(2), COL(3), PLBUF, IERR)
            IF (IERR.NE.0) GO TO 990
            X = X0 - P * SIN (PA) / 3.0
            Y = Y0 + P * COS (PA) / 3.0
            CALL GPOS (X, Y, PLBUF, IERR)
            IF (IERR.NE.0) GO TO 990
            X = X0 - P * SIN (PA)
            Y = Y0 + P * COS (PA)
            CALL G3VEC (X, Y, PLBUF, IERR)
            IF (IERR.NE.0) GO TO 990
 140        CONTINUE
         END IF
      GO TO 999
C                                       coordinate error
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (6)
      GO TO 999
C                                       plot error
 990  WRITE (MSGTXT,1990) IERR
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('POLDRW: COORDINATE ERROR',I3,' FACTOR TOO LARGE??')
 1990 FORMAT ('POLDRW: PLOT ROUTINE ERROR',I3,' QUITTING')
      END
      SUBROUTINE PGLAB (YGAP, ISRGBL, LEVTXT, IERR)
C-----------------------------------------------------------------------
C   PGLAB is an axis labelling routine for use with grey scale plots.
C   Optional contour labels.
C   Output:
C      YGAP    R        Current used lines below
C      IERR    I        error indicator:  0 = No error.
C   Inputs COMMON:
C      BLC     R(7)     bottom left hand corner of contour map.
C      BTRC    R(7)     top right hand corner of contour map.
C   In/out COMMON:
C      CHOUT   R(4)     character spacing around plot.
C      NBLC    R(2)     BLC including wedge, extra space
C      NTRC    R(2)     TRC including wedge, extra space
C      ABLC    R(2)     BLC including edge of pixels
C      ATRC    R(2)     TRC including edge of pixels
C      PLBUF   I(256)   the updated graphics output buffer.
C-----------------------------------------------------------------------
      REAL      YGAP
      LOGICAL   ISRGBL
      CHARACTER LEVTXT*(*)
      INTEGER   IERR
C
      CHARACTER SPRTXT*100, ATIME*8, ADATE*12, CHTMP*8, NAMSTR*18,
     *   PREFIX*5, CORTXT(2)*80, LTEXT(5)*80, CHTEMP*20
      DOUBLE PRECISION    ZV(3)
      REAL      DCX, DCY, BJUNK(2), TEMP, RANGES(2,3)
      INTEGER   IDEPTH(5), NTEXT, I, IANGL, INCHAR, IT(3), ID(3), ITEMP,
     *   CATEMP(256), NL, IXL, IROUND, I1, I2, IS, LEVLEN, LTYPE, JTRIM
      LOGICAL   SLICE, T, LFLAG, CSAME
      INCLUDE 'PCNTR.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DGPH.INC'
      DATA SLICE, T /.FALSE., .TRUE./
C-----------------------------------------------------------------------
      CSAME = (IVOL(5).EQ.IVOL(4)) .AND. (ISLOT(5).EQ.ISLOT(4)) .AND.
     *   (DOCON) .AND. (GRYSCL.GT.0.0)
      NBLC(1) = BLC(1,1) - 0.7
      NBLC(2) = BLC(2,1) - 0.7
      NTRC(1) = TRC(1,1) + 0.7 + IXWDGE
      NTRC(2) = TRC(2,1) + 0.7 + IYWDGE
      ABLC(1) = NBLC(1)
      ABLC(2) = NBLC(2)
      ATRC(1) = TRC(1,1) + 0.7
      ATRC(2) = TRC(2,1) + 0.7
C
      IDEPTH(1) = BLC(3,1) + .01
      IDEPTH(2) = BLC(4,1) + .01
      IDEPTH(3) = BLC(5,1) + .01
      IDEPTH(4) = BLC(6,1) + .01
      IDEPTH(5) = BLC(7,1) + .01
      LTYPE = MOD (ABS(ILABEL), 100)
C                                       Init for line drawing.
      LOCNUM = 1
      IF ((GRYSCL.GT.0.0) .AND. (.NOT.CSAME) .AND. (DOCON)) CHOUT(4) =
     *   CHOUT(4) + 1.333
      CALL LABINI (BLC, TRC, IDEPTH, CHOUT, ILABEL, SLICE, YGAP, CORTXT,
     *   NTEXT)
C                                       wedge labeling
      IF (LTYPE.GE.3) THEN
         IF (IXWDGE.GT.0) THEN
            CALL GTICNT (ILABEL, WRANGE, I)
            IF (I.GT.0) CHOUT(3) = CHOUT(3) + I + 0.5
            END IF
         IF (IYWDGE.GT.0) CHOUT(4) = CHOUT(4) + 1.333
         END IF
C                                       Prepare LEVS lines
      NL = 0
      LEVTXT = ' '
      LEVLEN = 0
      IF ((LTYPE.LT.7) .AND. (DOCON)) THEN
         I = 2 * MABFSS
         CALL FXLEVS (ILUN(5), IFIND(5), PCATI(1,5), BLC(1,5), TRC(1,5),
     *      ZMIN, ZMAX, ZINC, CLEV, LEVS, SUBMIN, SUBMAX, RBLK, I, IERR)
         IF (IERR.NE.0) GO TO 999
         NL = NL + 1
         IF ((CLEV.GT.999.) .OR. (CLEV.LT.0.01)) THEN
            WRITE (LTEXT(NL),1120) CLEV
            WRITE (LEVTXT,1120) CLEV
         ELSE
            WRITE (CHTEMP,1122) CLEV
            IF (CHTEMP(9:10).EQ. ' -') CHTEMP(9:10) = '-0'
            IF (CHTEMP(9:10).EQ. '  ') CHTEMP(9:10) = ' 0'
            I2 = 15
            IF ((I2.GT.11) .AND. (CHTEMP(I2:I2).EQ.'0')) I2 = I2 - 1
            IF ((I2.GT.11) .AND. (CHTEMP(I2:I2).EQ.'0')) I2 = I2 - 1
            IF ((I2.GT.11) .AND. (CHTEMP(I2:I2).EQ.'0')) I2 = I2 - 1
            IF ((I2.GT.11) .AND. (CHTEMP(I2:I2).EQ.'0')) I2 = I2 - 1
            IF (I2.EQ.11) I2 = 10
            CHTEMP(I2+1:) = ' '
            CALL CHTRIM (CHTEMP, 20, CHTEMP, IXL)
            LTEXT(NL)(:IXL+7) = 'Levs = ' // CHTEMP(:IXL)
            LEVTXT(:IXL+7) = 'Levs = ' // CHTEMP(:IXL)
            END IF
         I = JTRIM (LTEXT(NL))
         LTEXT(NL)(I+1:) = ' * ('
         INCHAR = I + 5
         I = JTRIM (LEVTXT)
         LEVTXT(I+1:) =  ' * ('
         LEVLEN = I + 5
         DO 10 I = 1,30
            I2 = 12
            IXL = IROUND (LEVS(I))
            IF (ABS(IXL-LEVS(I)).GT.0.0001) THEN
               IF ((LEVS(I).GE.-99.90) .AND. (LEVS(I).LE.999.90))
     *            I2 = 13
               IF ((LEVS(I).GE.-9.990) .AND. (LEVS(I).LE.99.990))
     *            I2 = 14
               IF ((LEVS(I).GE.-0.9990) .AND. (LEVS(I).LE.9.9990))
     *            I2 = 15
               DCX = 10.0 ** (I2-12)
               IXL = IROUND (LEVS(I) * DCX)
               TEMP = IXL / DCX
            ELSE
               TEMP = IXL
               END IF
            WRITE (CHTEMP,1123,ERR=5) TEMP
 5          IF (CHTEMP(10:11).EQ. ' -') CHTEMP(10:11) = '-0'
            IF (CHTEMP(10:11).EQ. '  ') CHTEMP(10:11) = ' 0'
            IF ((I2.GT.12) .AND. (CHTEMP(I2:I2).EQ.'0')) I2 = I2 - 1
            IF ((I2.GT.12) .AND. (CHTEMP(I2:I2).EQ.'0')) I2 = I2 - 1
            IF ((I2.GT.12) .AND. (CHTEMP(I2:I2).EQ.'0')) I2 = I2 - 1
            IF (I2.EQ.12) I2 = 11
            CHTEMP(I2+1:) = ' '
            CALL CHTRIM (CHTEMP, 20, CHTEMP, IXL)
            LTEXT(NL)(INCHAR:) = CHTEMP(:IXL) // ', '
            INCHAR = INCHAR + 2 + IXL
            LEVTXT(LEVLEN:) = CHTEMP(:IXL)
            LEVLEN = LEVLEN + IXL + 2
C                                       Print out this line.
            IF (I.EQ.30) GO TO 15
            IF (LEVS(I+1).LE.LEVS(I)) GO TO 15
            IF (INCHAR.GE.70) THEN
               INCHAR = 1
               NL = NL + 1
               END IF
 10         CONTINUE
 15      INCHAR = INCHAR - 2
         LTEXT(NL)(INCHAR:INCHAR) = ')'
         LEVLEN = LEVLEN - 2
         LEVTXT(LEVLEN:LEVLEN) = ')'
         IF (ISRGBL) NL = 0
         CHOUT(2) = CHOUT(2) + (NL + 1) * 1.333
         END IF
C                                       Init for plotting
      CALL GINITL (NBLC, NTRC, XYRATO, CHOUT, IDEPTH, PLBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Init for grey scale.
      IF (GRYSCL.GT.0.0) THEN
         CALL H2CHR (2, 1, XFUN, GPHFUN)
         IF ((GPHFUN.NE.'LG') .AND. (GPHFUN.NE.'NG') .AND.
     *      (GPHFUN.NE.'SQ') .AND. (GPHFUN.NE.'NQ') .AND.
     *      (GPHFUN.NE.'NE') .AND. (GPHFUN.NE.'L2') .AND.
     *      (GPHFUN.NE.'N2')) GPHFUN = 'LN'
         CALL CHR2H (2, GPHFUN, 1, XFUN)
         IF ((DOCOLR) .OR. (FORCEC)) THEN
            RANGES(1,1) = RANGE(1)
            RANGES(2,1) = RANGE(2)
            RANGES(1,2) = RANGE(1)
            RANGES(2,2) = RANGE(2)
            RANGES(1,3) = RANGE(1)
            RANGES(2,3) = RANGE(2)
            CALL GINITC (ILPVAL, IHPVAL, RANGES, PLBUF, IERR)
         ELSE
            CALL GINITG (ILPVAL, IHPVAL, RANGE, PLBUF, IERR)
            END IF
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            CALL MSGWRT (7)
            GO TO 999
            END IF
         END IF
C                                       Extra lines (center rels)
      CALL GLTYPE (1, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 980
      IF (LTYPE.EQ.1) GO TO 999
      IF ((NTEXT.GT.0) .AND. (LTYPE.LT.7)) THEN
         DCX = 0.0
         IANGL = 0
         DO 25 I = 1,NTEXT
            CALL GPOS (NBLC(1), NBLC(2), PLBUF, IERR)
            IF (IERR.NE.0) GO TO 980
            DCY = -YGAP
            CALL CHTRIM (CORTXT(I), 80, CORTXT(I), INCHAR)
            CALL GCHAR (INCHAR, IANGL, DCX, DCY, CORTXT(I), PLBUF,
     *         IERR)
            IF (IERR.NE.0) GO TO 980
            YGAP = YGAP + 1.333
 25         CONTINUE
         END IF
C                                       Source name, stokes, freq.
C                                       for grey scale image
      IF (LTYPE.LT.7) THEN
         IANGL = 0
         DCX = 0.0
         DCY = 0.5
         IF ((LTYPE.GE.3) .AND. (IYWDGE.GT.0)) DCY = 1.833
         IF ((GRYSCL.LE.0.0) .OR. (CSAME) .OR. (DOCON)) THEN
            CALL GPOS (NBLC(1), NTRC(2), PLBUF, IERR)
            IF (IERR.NE.0) GO TO 980
            SPRTXT = ' '
            INCHAR = 1
            IS = 1
            IF ((DOCON) .AND. (GRYSCL.GT.0.0) .AND. (.NOT.CSAME)) THEN
               INCHAR = 7
               SPRTXT(1:5) = 'CONT:'
               IS = 5
               END IF
            CALL H2CHR (8, 1, PCATH(KHOBJ,IS), CHTMP)
            IF (CHTMP.NE.' ') THEN
               SPRTXT(INCHAR:INCHAR+7) = CHTMP(1:8)
               INCHAR = INCHAR + 10
               END IF
            IF (NCHLAB(1,LOCNUM).GT.0) THEN
               IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
               SPRTXT(INCHAR:) = SAXLAB(1,LOCNUM)(:NCHLAB(1,LOCNUM))
               INCHAR = INCHAR + 3 + NCHLAB(1,LOCNUM)
               END IF
            IF (NCHLAB(2,LOCNUM).GT.0) THEN
               IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
               SPRTXT(INCHAR:) = SAXLAB(2,LOCNUM)(:NCHLAB(2,LOCNUM))
               INCHAR = INCHAR + 3 + NCHLAB(2,LOCNUM)
               END IF
C                                       image name
            IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
            CALL H2CHR (12, KHIMNO, PCATH(KHIMN,IS), NAMSTR(1:12))
            CALL H2CHR (6, KHIMCO, PCATH(KHIMC,IS), NAMSTR(13:18))
            CALL NAMEST (NAMSTR, PCATI(KIIMS,IS), SPRTXT(INCHAR:),
     *         ITEMP)
            CALL REFRMT (SPRTXT, '_', INCHAR)
            CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPRTXT, PLBUF, IERR)
            IF (IERR.NE.0) GO TO 980
            END IF
C                                       Date/time version
         IF (ILABEL.GE.0) THEN
            CALL GPOS (NBLC(1), NTRC(2), PLBUF, IERR)
            IF (IERR.NE.0) GO TO 980
            DCY = DCY + 1.333
            IF ((GRYSCL.GT.0.0) .AND. (.NOT.CSAME) .AND. (DOCON) .AND.
     *         (LTYPE.LT.7)) DCY = DCY + 1.333
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (SPRTXT,1030) IVER, ADATE, ATIME
            CALL REFRMT (SPRTXT, '_', INCHAR)
            CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPRTXT, PLBUF, IERR)
            IF (IERR.NE.0) GO TO 980
            END IF
C                                       Peak flux for grey scale
         IF (GRYSCL.GT.0.0) THEN
            DCX = 0.0
            DCY = -YGAP
            YGAP = YGAP + 1.333
            IANGL = 0
            CALL GPOS (NBLC(1), NBLC(2), PLBUF, IERR)
            IF (IERR.NE.0) GO TO 980
            CALL H2CHR (8, 1, PCATH(KHBUN,4), CHTMP)
            TEMP = RANGE(2) - RANGE(1)
            CALL METSCL (ILABEL, TEMP, PREFIX, LFLAG)
            IF (LFLAG) THEN
               INCHAR = 55
               WRITE (SPRTXT,1040) RANGE, CHTMP
            ELSE
               BJUNK(1) = TEMP * RANGE(1) / (RANGE(2) - RANGE(1))
               BJUNK(2) = TEMP * RANGE(2) / (RANGE(2) - RANGE(1))
               TEMP = MAX (ABS(BJUNK(1)), ABS(BJUNK(2)))
               IF (TEMP.LT.9.99) THEN
                  WRITE (SPRTXT,1041) BJUNK, PREFIX, CHTMP
                  I1 = 25
                  I2 = 33
               ELSE IF (TEMP.LT.99.9) THEN
                  WRITE (SPRTXT,1042) BJUNK, PREFIX, CHTMP
                  I1 = 26
                  I2 = 34
               ELSE IF (TEMP.LT.9999.) THEN
                  WRITE (SPRTXT,1043) BJUNK, PREFIX, CHTMP
                  I1 = 27
                  I2 = 35
               ELSE IF (TEMP.LT.9999999.) THEN
                  WRITE (SPRTXT,1044) BJUNK, PREFIX, CHTMP
                  I1 = 30
                  I2 = 40
               ELSE
                  WRITE (SPRTXT,1040) RANGE, CHTMP
                  I1 = -1
                  END IF
               IF (I1.GT.0) THEN
                  IF (SPRTXT(I1:I1+1).EQ. ' -') SPRTXT(I1:I1+1) = '-0'
                  IF (SPRTXT(I1:I1+1).EQ. '  ') SPRTXT(I1:I1+1) = ' 0'
                  IF (SPRTXT(I2:I2+1).EQ. ' -') SPRTXT(I2:I2+1) = '-0'
                  IF (SPRTXT(I2:I2+1).EQ. '  ') SPRTXT(I2:I2+1) = ' 0'
                  END IF
               END IF
            CALL REFRMT (SPRTXT, '_', INCHAR)
            CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPRTXT, PLBUF, IERR)
            IF (IERR.NE.0) GO TO 980
            END IF
         END IF
C                                       With Grey scale
      IF (GRYSCL.GT.0.0) THEN
         IF (.NOT.CSAME) THEN
            CALL COPY (256, PCATI(1,1), CATEMP)
            CALL COPY (256, PCATI(1,4), PCATI(1,1))
            IDEPTH(1) = BLC(3,4) + .01
            IDEPTH(2) = BLC(4,4) + .01
            IDEPTH(3) = BLC(5,4) + .01
            IDEPTH(4) = BLC(6,4) + .01
            IDEPTH(5) = BLC(7,4) + .01
            LOCNUM = 2
            CALL SETLOC (IDEPTH, T)
            IF ((AXTYP(LOCNUM).EQ.2) .OR. (AXTYP(LOCNUM).EQ.3)) THEN
               DCX = (BLC(1,4) + TRC(1,4)) / 2.0
               DCY = (BLC(2,4) + TRC(2,4)) / 2.0
               CALL XYVAL (DCX, DCY, ZV(1), ZV(2), ZV(3), IERR)
               CALL AXSTRN (CTYP(3,LOCNUM), ZV(3), KLOCA(LOCNUM),
     *            NCHLAB(1,LOCNUM), SAXLAB(1,LOCNUM))
               END IF
C                                       Source name, stokes, freq.
C                                       for grey image
             IF (LTYPE.LT.7) THEN
               CALL GPOS (NBLC(1), NTRC(2), PLBUF, IERR)
               IF (IERR.NE.0) GO TO 980
               DCX = 0.0
               DCY = 0.5
               IF ((LTYPE.GE.2) .AND. (IYWDGE.GT.0)) DCY = 1.833
               IF (DOCON) DCY = DCY + 1.333
               IANGL = 0
               SPRTXT = 'GREY: '
               INCHAR = 7
               CALL H2CHR (8, 1, PCATH(KHOBJ,4), CHTMP)
               IF (CHTMP.NE.' ') THEN
                  SPRTXT(INCHAR:) = CHTMP(1:8)
                  INCHAR = INCHAR + 10
                  END IF
               IF (NCHLAB(1,LOCNUM).GT.0) THEN
                  IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
                  SPRTXT(INCHAR:) = SAXLAB(1,LOCNUM)(:NCHLAB(1,LOCNUM))
                  INCHAR = INCHAR + 3 + NCHLAB(1,LOCNUM)
                  END IF
               IF (NCHLAB(2,LOCNUM).GT.0) THEN
                  IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
                  SPRTXT(INCHAR:) = SAXLAB(2,LOCNUM)(:NCHLAB(2,LOCNUM))
                  INCHAR = INCHAR + 3 + NCHLAB(2,LOCNUM)
                  END IF
C                                       image name
               IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
               CALL H2CHR (12, KHIMNO, PCATH(KHIMN,4), NAMSTR(1:12))
               CALL H2CHR (6, KHIMCO, PCATH(KHIMC,4), NAMSTR(13:18))
               CALL NAMEST (NAMSTR, PCATI(KIIMS,4), SPRTXT(INCHAR:),
     *            ITEMP)
               CALL REFRMT (SPRTXT, '_', INCHAR)
               CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPRTXT, PLBUF,
     *            IERR)
               IF (IERR.NE.0) GO TO 980
               END IF
            CALL COPY (256, CATEMP, PCATI(1,1))
            LOCNUM = 1
            END IF
         END IF
C                                        Peak contour flux
      IF ((DOCON) .AND. (LTYPE.LT.7)) THEN
         DCX = 0.0
         DCY = -YGAP
         YGAP = YGAP + 1.333
         IANGL = 0
         CALL GPOS (NBLC(1), NBLC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         TEMP = PCATR(KRDMX,1)
         IF (ABS(TEMP).LT.ABS(PCATR(KRDMN,1))) TEMP = PCATR(KRDMN,1)
         CALL H2CHR (8, 1, PCATH(KHBUN,1), CHTMP)
         WRITE (SPRTXT,1110) SUBMIN, SUBMAX, CHTMP
         CALL REFRMT (SPRTXT, '_', INCHAR)
         CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPRTXT, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Write levels.
         DCX = 0.0
         IANGL = 0
         DO 130 I = 1,NL
            DCY = -YGAP
            YGAP = YGAP + 1.333
            CALL GPOS (NBLC(1), NBLC(2), PLBUF, IERR)
            IF (IERR.NE.0) GO TO 980
            CALL REFRMT (LTEXT(I), ' ', INCHAR)
            CALL GCHAR (INCHAR, IANGL, DCX, DCY, LTEXT(I), PLBUF, IERR)
            IF (IERR.NE.0) GO TO 980
 130        CONTINUE
         END IF
      GO TO 999
C                                       Graph drawing error.
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GRAPH FILE INITIALIZATION ERROR. GINITL ERR =',I5)
 1010 FORMAT ('GREY SCALE INITIALIZATION ERROR. GINITG ERR =',I5)
 1030 FORMAT ('Plot file version',I4,'__created ',A12,A8)
 1040 FORMAT ('Grey scale brightness range=',2(1PE12.4),1X,A8)
 1041 FORMAT ('Grey scale brightness range=',2F8.3,1X,A5,A8)
 1042 FORMAT ('Grey scale brightness range=',2F8.2,1X,A5,A8)
 1043 FORMAT ('Grey scale brightness range=',2F8.1,1X,A5,A8)
 1044 FORMAT ('Grey scale brightness range=',2F10.0,1X,A5,A8)
 1110 FORMAT ('Contour brightness extrema =',2(1PE12.4),1X,A8)
 1120 FORMAT ('Levs = ',1PE10.3)
 1122 FORMAT (F15.4)
 1123 FORMAT (F15.3)
 1980 FORMAT ('GRAPH LABEL WRITING ERROR. IERR =',I5)
      END
      SUBROUTINE CONDRW (IMLUN, IMFIND, IBLUN, IBFIND, XMULT, BLC, TRC,
     *   LEVS, DOCOLR, BBLC, BTRC, VBLC, VTRC, RGBLEV, IGBLK, IERR)
C-----------------------------------------------------------------------
C   CONDRW will write commands to a plot file for the execution of
C   a contour plot. 2 BLANKING WINDOWS
C   Inputs:
C      IMLUN    I         logical unit number for the contour map file
C      IMFIND   I         FTAB index for open contour map file.
C      IBLUN    I         logical unit number of background gray image
C      IBFIND   I         FTAB index of open background gray image
C      IGBLK    I(256)    I/O block for graph file.
C      XMULT    R         Contour interval (image units)
C      BLC      R(7)      Bottom left corner
C      TRC      R(7)      Top right corner
C      LEVS     R(30)     Selected contour intervals in increasing order
C                         (any decrease terminates the list)
C      DOCOLR   I         0 no color, 1, use existing color, 2 use
C                         RGBLEV
C      BBLC     I(2)      BLC of blanked area
C      BTRC     I(2)      TRC of blanked area
C      VBLC     I(2)      BLC of blanked area
C      VTRC     I(2)      TRC of blanked area
C      RGBLEV   R(3,30)   RGB colors when level i not blacked
C   Common:
C      CATBLK   I(256)  map header.
C      CNTRBU   R(8192) buffers
C   Output:
C      IERR     I   error code. 0 = ok.
C-----------------------------------------------------------------------
      INTEGER   IMLUN, IMFIND, IBLUN, IBFIND, IGBLK(256), DOCOLR,
     *   BBLC(2), BTRC(2), VBLC(2), VTRC(2), IERR
      REAL      XMULT, BLC(7), TRC(7), LEVS(*), RGBLEV(3,*)
C
      REAL      VAL(3), XPOS(3), YPOS(3), TEMP, VC, VL, VM, VS, XA, XB,
     *   XL, XLAST, XM, XS, YA, YB, YL, YLAST, YM, YS, DELTAX, DELTAY,
     *   TLEV, XLEV, ALEVS(30)
      INTEGER   IPERM(3,6), IBLCX, IBLCY, IBLCY1, ICOL, II, INDEX,
     *   INLEVS, INPIXS, IPLUS, IPOS, IROW, ISKIP, ITRCX, ITRCXM,
     *   ITRCY, ITRI, I, MININT, LOCINT, IROUND, BPOS, ISLEV, JJ, BCUT,
     *   BVAL, BXOFF, BXSIZ, LASTC, VXOFF, VXSIZ
      LOGICAL   DOBACK
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DCNT.INC'
      INCLUDE 'INCS:DGPH.INC'
      DATA IPERM /1,3,2, 3,2,1, 3,1,2, 2,1,3, 1,2,3, 2,3,1/
C-----------------------------------------------------------------------
      DOBACK = (IBLUN.GT.0) .AND. (IBFIND.GT.0) .AND. (DOCOLR.LE.0)
      IF (DOBACK) BCUT = 3.0 * (GPHCUT * GPHTHI + (1.0-GPHCUT) * GPHTLO)
      ISKIP = 2
      XLAST = -1000.
      YLAST = -1000.
      TEMP = MAX (TRC(1)-BLC(1), TRC(2)-BLC(2))
      TEMP = 10 - 3 * LOG10 (TEMP)
      LOCINT = IROUND (TEMP)
      IF (LOCINT.LT.2) LOCINT = 2
      IBLCY = BLC(2) + .5
      ITRCY = TRC(2) + .5
      ITRCX = TRC(1) + .5
      IBLCX = BLC(1) + .5
      INPIXS = ITRCX - IBLCX + 1
      BXSIZ = BTRC(1) - BBLC(1) + 1
      BXOFF = BBLC(1) - IBLCX
      VXSIZ = VTRC(1) - VBLC(1) + 1
      VXOFF = VBLC(1) - IBLCX
      LASTC = 0
C                                       magic parms for dashed lines
      XLEV = 256.0 / INPIXS
      TLEV = 256.0 / (ITRCY - IBLCY + 1.0)
      ISLEV = SQRT (1.0 / (XLEV * TLEV)) + 0.1
      IF (ISLEV.LT.1) ISLEV = 1
      IF (XLEV.LT.1.0) XLEV = (SQRT (XLEV) + 3.0*XLEV) / 4.0
C                                       Determine number of levels.
C                                       and convert to absolute levels.
      TEMP = LEVS(1)
      ALEVS(1) = XMULT * LEVS(1)
      DO 45 INLEVS = 2,30
         IF (TEMP.GE.LEVS(INLEVS)) GO TO 50
         TEMP = LEVS(INLEVS)
         ALEVS(INLEVS) = XMULT * LEVS(INLEVS)
 45      CONTINUE
 50   INLEVS = INLEVS - 1
C                                       Read and save first row.
      CALL MDISK ('READ', IMLUN, IMFIND, BUFF, IPOS, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) 'Contour', IERR
         GO TO 990
         END IF
      IF ((IBLCY.GE.BBLC(2)) .AND. (IBLCY.LE.BTRC(2)))
     *   CALL RFILL (BXSIZ, FBLANK, BUFF(IPOS+BXOFF))
      IF ((IBLCY.GE.VBLC(2)) .AND. (IBLCY.LE.VTRC(2)))
     *   CALL RFILL (VXSIZ, FBLANK, BUFF(IPOS+VXOFF))
      CALL RCOPY (INPIXS, BUFF(IPOS), RLROW)
      IF (DOBACK) THEN
         CALL MDISK ('READ', IBLUN, IBFIND, BBUFF, BPOS, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) 'Background', IERR
            GO TO 990
            END IF
         CALL GSCALE (GPHFUN, GPHRNG, INPIXS, 1, BBUFF(BPOS),
     *      IBBUFF(BPOS))
         CALL COPY (INPIXS, IBBUFF(BPOS), IBLROW)
         END IF
C                                       Loop over all rows.
      IBLCY1 = IBLCY + 1
      DO 300 IROW = IBLCY1,ITRCY
C                                       Read proper row.
         CALL MDISK ('READ', IMLUN, IMFIND, BUFF, IPOS, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) 'Contour', IERR
            GO TO 990
            END IF
         IF ((IROW.GE.BBLC(2)) .AND. (IROW.LE.BTRC(2))) THEN
            CALL RFILL (BXSIZ, FBLANK, BUFF(IPOS+BXOFF))
            END IF
         IF ((IROW.GE.VBLC(2)) .AND. (IROW.LE.VTRC(2))) THEN
            CALL RFILL (VXSIZ, FBLANK, BUFF(IPOS+VXOFF))
            END IF
         IF (DOBACK) THEN
            CALL MDISK ('READ', IBLUN, IBFIND, BBUFF, BPOS, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) 'Background', IERR
               GO TO 990
               END IF
            CALL GSCALE (GPHFUN, GPHRNG, INPIXS, 1, BBUFF(BPOS),
     *         IBBUFF(BPOS))
            END IF
C                                       Loop over all pixels in row.
         IPLUS = 0
         ITRCXM = ITRCX - 1
         DO 250 ICOL = IBLCX,ITRCXM
            IPLUS = IPLUS + 1
C                                       Init values
            VAL(1) = BUFF(IPOS+IPLUS-1)
            VAL(2) = BUFF(IPOS+IPLUS)
            VAL(3) = RLROW(IPLUS)
            IF (DOBACK) BVAL = IBBUFF(BPOS+IPLUS-1) + IBBUFF(BPOS+IPLUS)
     *         + IBLROW(IPLUS)
C                                       Init positions.
            XPOS(1) = ICOL
            XPOS(2) = ICOL + 1
            XPOS(3) = ICOL
            YPOS(1) = IROW
            YPOS(2) = IROW
            YPOS(3) = IROW - 1
C                                       Loop for both triangles.
            DO 200 ITRI = 1,2
C                                       Changes for 2nd triangle.
               IF (ITRI.EQ.2) THEN
                  VAL(1) = RLROW(IPLUS+1)
                  IF (DOBACK) BVAL = BVAL - IBBUFF(BPOS+IPLUS-1) +
     *               IBLROW(IPLUS+1)
                  XPOS(1) = ICOL + 1
                  YPOS(1) = IROW - 1
                  END IF
C                                       Order points in triangle.
               DO 130 II = 1,3
                  IF (VAL(II).EQ.FBLANK) GO TO 200
 130              CONTINUE
               INDEX = 0
               IF (VAL(1).GT.VAL(2)) INDEX = 1
               IF (VAL(3).GE.VAL(1)) INDEX = INDEX + 2
               IF (VAL(2).GE.VAL(3)) INDEX = INDEX + 4
C                                       find large, med, small
C                                       values and X,Y positions.
               II = IPERM(1,INDEX)
               VL = VAL(II)
               XL = XPOS(II)
               YL = YPOS(II)
C
               II = IPERM(2,INDEX)
               VM = VAL(II)
               XM = XPOS(II)
               YM = YPOS(II)
C
               II = IPERM(3,INDEX)
               VS = VAL(II)
               XS = XPOS(II)
               YS = YPOS(II)
C                                       Loop for all levels.
               DO 190 II = 1,INLEVS
                  VC = ALEVS(II)
C                                       Cut down negatives
                  IF (VC.GE.0.0) GO TO 140
                     IF ((XLEV.LT.2.85) .AND. (ITRI.EQ.2)) GO TO 190
                     IF (XLEV.GE.1.0) GO TO 140
                        JJ = IROW + ICOL + II
                        IF (MOD(JJ, ISLEV).NE.0) GO TO 190
 140              IF ((VC.GT.VL) .OR. ((VL-VS).LE.0.0)) GO TO 200
C                                       If level not right, next lev.
                  IF (VC.LE.VS) GO TO 190
C                                       Interpolate btwn max two corns.
                  TEMP = (VC-VS) / (VL-VS)
                  XA = TEMP * (XL-XS) + XS
                  YA = TEMP * (YL-YS) + YS
C                                       See which corners 2nd pt. btwn.
                  IF (VC.GT.VM) GO TO 150
                  IF (VM.EQ.VS) GO TO 150
C                                       Level btwn med & small corners.
                     TEMP = (VC-VS) / (VM-VS)
                     XB = TEMP * (XM-XS) + XS
                     YB = TEMP * (YM-YS) + YS
                     GO TO 160
C                                       Level btwn large & med corners.
 150                 TEMP = (VC-VM) / (VL-VM)
                     XB = TEMP * (XL-XM) + XM
                     YB = TEMP * (YL-YM) + YM
C                                       Issue position & write commands
C                                       We can avoid position command
C                                       if we switch A and B.
 160              IF ((XLAST.EQ.XB) .AND. (YLAST.EQ.YB)) THEN
                     TEMP = XA
                     XA = XB
                     XB = TEMP
                     TEMP = YA
                     YA = YB
                     YB = TEMP
C                                       See if we need to position.
                  ELSE IF ((XLAST.NE.XA) .OR. (YLAST.NE.YA)) THEN
                     CALL GPOS (XA, YA, IGBLK, IERR)
                     IF (IERR.NE.0) GO TO 999
                     END IF
C                                       Draw vector.
                  IF (VC.GE.0.0) THEN
                     IF ((DOBACK) .AND. (BVAL.GT.BCUT)) THEN
                        CALL GDVEC (XB, YB, IGBLK, IERR)
                     ELSE IF (DOCOLR.GT.0) THEN
                        IF ((DOCOLR.EQ.2) .AND. (LASTC.NE.II)) THEN
                           CALL G3VCOL (RGBLEV(1,II), RGBLEV(2,II),
     *                        RGBLEV(3,II), IGBLK, IERR)
                           IF (IERR.NE.0) GO TO 999
                           LASTC = II
                           END IF
                        CALL G3VEC (XB, YB, IGBLK, IERR)
                     ELSE
                        CALL GVEC (XB, YB, IGBLK, IERR)
                        END IF
                     IF (IERR.NE.0) GO TO 999
                     XLAST = XB
                     YLAST = YB
                     GO TO 190
C                                       Negative contours broken
                  ELSE
                     TEMP = LOCINT * SQRT (((XB-XA)**2 + (YB-YA)**2)
     *                  / 2.0)
                     MININT = IROUND (TEMP)
                     IF (MININT.LT.2) MININT = 2
                     DELTAX = (XB - XA) / MININT
                     DELTAY = (YB - YA) / MININT
                     DO 185 I = 1,MININT,2
                        XB = XA + DELTAX
                        YB = YA + DELTAY
                        IF ((DOBACK) .AND. (BVAL.GT.BCUT)) THEN
                           CALL GDVEC (XB, YB, IGBLK, IERR)
                        ELSE IF (DOCOLR.GT.0) THEN
                           IF ((DOCOLR.EQ.2) .AND. (LASTC.NE.II)) THEN
                              CALL G3VCOL (RGBLEV(1,II), RGBLEV(2,II),
     *                           RGBLEV(3,II), IGBLK, IERR)
                              IF (IERR.NE.0) GO TO 999
                              LASTC = II
                              END IF
                           CALL G3VEC (XB, YB, IGBLK, IERR)
                        ELSE
                           CALL GVEC (XB, YB, IGBLK, IERR)
                           END IF
                        IF (IERR.NE.0) GO TO 999
                        IF (I.LT.MININT-1) THEN
                           XA = XB + DELTAX
                           YA = YB + DELTAY
                           CALL GPOS (XA, YA, IGBLK, IERR)
                           IF (IERR.NE.0) GO TO 999
                           END IF
 185                    CONTINUE
                     XLAST = XB
                     YLAST = YB
                     END IF
 190              CONTINUE
 200           CONTINUE
 250        CONTINUE
         CALL RCOPY (INPIXS, BUFF(IPOS), RLROW)
         IF (DOBACK) CALL COPY (INPIXS, IBBUFF(BPOS), IBLROW)
 300     CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ON ',A,' IMAGE, MDISK ERROR',I6)
      END

      SUBROUTINE ISPRIM (N, PRIME, NXTTWO)
C-----------------------------------------------------------------------
C! Is a number a prime number?
C# General
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  Routine to determine if a number is a prime number and if
C  so what is the next higher power of two.
C-----------------------------------------------------------------------
      INTEGER   IFACT(32), N, IF, NPART, ID, IDIV, IQUOT,
     *   NFACT, NXTTWO, GAMMA
      LOGICAL   PRIME
C-----------------------------------------------------------------------
      PRIME = .FALSE.
      NXTTWO = 0
C                                       factor n into its prime
C                                       factors, nfact in number.
C                                       for example, for n = 1960,
C                                       nfact = 6 and ifact(if) = 2,
C                                       2, 2, 5, 7 and 7.
      IF = 0
      NPART = N
      DO 50 ID = 1, N, 2
         IDIV = ID
         IF (ID-1.LE.0) IDIV = 2
 20      IQUOT = NPART / IDIV
         IF (NPART - IDIV * IQUOT.EQ.0) THEN
            IF = IF + 1
            IFACT(IF) = IDIV
            NPART = IQUOT
            GO TO 20
            END IF
         IF (IQUOT-IDIV.LE.0) GO TO 60
 50      CONTINUE
 60   IF (NPART-1.GT.0) THEN
         IF = IF + 1
         IFACT(IF) = NPART
         END IF
      NFACT = IF
C                                       Prime?
      IF (NFACT .LE.1) THEN
         PRIME = .TRUE.
C                                       Find next power of two
         DO 100 GAMMA = 1, 15
            NXTTWO = 2**GAMMA
            IF (NXTTWO.GT.N) GO TO 999
 100        CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE BSINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   BSRNO, BSCOLS, BSNUMV, MODE, NUMIF, IERR)
C-----------------------------------------------------------------------
C! Open a baseline solution (BS) file and initialize I/O structures.
C# Ext-util Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2006, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Open a baseline solution (BS) table and initialize its I/O
C   structures.  If OPCODE is 'READ' and VER is less than or equal to
C   zero then the BS table with the highest version number will be
C   opened.  If OPCODE is 'WRIT' and VER is less than or equal to zero
C   then a new table will be created.
C
C   If there are NROW rows in the table BSRNO will be 1 if OPCODE is
C   'READ' or NROW+1 if OPCODE is 'WRIT'.
C   Inputs:
C      OPCODE   C*4               Operation code:
C                                    'READ' - open in read-only mode;
C                                    'WRIT' - open for reading and
C                                             writing.
C      DISK     I                 AIPS disk number of primary file.
C      CNO      I                 AIPS catalogue number of primary
C                                  file.
C      LUN      I                 AIPS logical unit number for BS table.
C
C   Input/output:
C      BUFFER   I(512)   TABINI/TABIO workspace. Do not modify.
C      VER      I        On input: requested BS table version number.
C                        On output: actual  BS table version number.
C      CATBLK   I(256)   Header block of primary file.
C      BSCOLS   I(*)     Column addresses.  Do not modify.
C      BSNUMV   I(*)     Column dimensions.  Do not modify.
C      MODE     C*4      Solution mode used to derive the values in the
C                        table
C                        'INDE' - independent delays for each IF
C                        'VLBA' - one delay for all IFs
C                        'MK3 ' - multiband and single-band delays
C                        'RATE' - rate only
C      NUMIF    I         Number of IFs for which narrow-band delays are
C                         present.
C   Outputs:
C      BSRNO    I         Row number of next row to read or write.
C      IERR     I         Status code: 0 - no errors
C                            1 - could not initialize table
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, MODE*4
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, BSRNO,
     *   BSCOLS(*), BSNUMV(*), NUMIF, IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
C                                        NUMKEY = number of keywords
      INTEGER   NUMKEY
      PARAMETER (NUMKEY = 3)
C                                        KEYWRD = keyword list
C                                        KEYTYP = keyword types
C                                        KEYLOC = keyword indices
C                                        IKVAL = integer keyword values
C                                        LKVAL = logical keyword values
      CHARACTER KEYWRD(NUMKEY)*8
      INTEGER   KEYTYP(NUMKEY), KEYLOC(NUMKEY), IKVAL(NUMKEY+1)
C                                       Need an extra work in IKVAL
C                                       since MODE requires 2 words.
C
C                                        BSVER = BS table version
      INTEGER   BSVER
      PARAMETER (BSVER = 4)
C                                        CTITLE = Column titles.
      CHARACTER CTITLE(MAXBSC)*24
C                                        CUNITS = Column units
      CHARACTER CUNITS(MAXBSC)*8
C                                        CTYPE = Column type code
      INTEGER   CTYPE(MAXBSC)
C                                        CDIMEN = Column dimension
      INTEGER   CDIMEN(MAXBSC)
C                                        TTITLE = table title
      CHARACTER TTITLE*56
      PARAMETER (TTITLE = 'AIPS BASELINE FRINGE SOLUTION TABLE')
C                                       Mode padded to 8 characters
      CHARACTER PMODE*8
C
      INTEGER   I, NKEY, NCOL, DATP(128,2), NC, ITRIM, IPOINT, NREC,
     *   ITEMP(6)
      HOLLERITH HOLTMP(6)
      EQUIVALENCE (HOLTMP, ITEMP)
C
      DATA KEYWRD /'VERSION ', 'NO_IF   ', 'MODE    '/
      DATA CTITLE
     *   /'TIME                    ', 'TIME INTERVAL           ',
     *    'BASELINE                ', 'SUBARRAY                ',
     *    'STOKES                  ', 'SOURCE                  ',
     *    'VECTOR AMPLITUDE        ', 'SCALAR AMPLITUDE        ',
     *    'RESIDUAL MB DELAY       ', 'MB DELAY ERROR          ',
     *    'MB DELAY AMBIGUITY      ',
     *    'RESIDUAL SB DELAY       ', 'SB DELAY ERROR          ',
     *    'SB DELAY AMBIGUITY      ',
     *    'RESIDUAL FRINGE RATE    ', 'FRINGE RATE ERROR       ',
     *    'FRINGE RATE AMBIGUITY   ',
     *    'RESIDUAL ACCELERATION   ', 'ACCELERATION ERROR      ',
     *    'RESIDUAL PHASE          ', 'PHASE ERROR             '/
      DATA CUNITS /'DAYS    ', 'DAYS    ', '        ', '        ',
     *             '        ', '        ', 'JANSKYS ', 'JANSKYS ',
     *             'SECONDS ', 'SECONDS ', 'SECONDS ', 'SECONDS ',
     *             'SECONDS ', 'SECONDS ', 'HZ      ', 'HZ      ',
     *             'HZ      ', 'HZ/SEC  ', 'HZ/SEC  ', 'DEGREES ',
     *             'DEGREES '/
      DATA CTYPE /TABDBL, TABFLT, TABINT, TABINT, TABINT, TABINT,
     *            TABFLT, TABFLT, TABFLT, TABFLT, TABFLT, TABFLT,
     *            TABFLT, TABFLT, TABFLT, TABFLT, TABFLT, TABFLT,
     *            TABFLT, TABFLT, TABFLT/
      DATA CDIMEN /1, 1, 2, 1, 1, 1, 0, 0, 1, 1,
     *             1, 0, 0, 1, 0, 0, 1, 0, 0, 0,
     *             0/
C-----------------------------------------------------------------------
C                                       Set the number of IFs to unity
C                                       for 'VLBA', 'MK3 ' and 'RATE'
C                                       modes to minimize wasted space
C                                       in the table.
      IF ((OPCODE.EQ.'WRIT') .AND. ((MODE.EQ.'VLBA') .OR.
     *   (MODE.EQ.'RATE') .OR.(MODE.EQ.'MK3 '))) NUMIF = 1
C                                       Initialize BS table:
      NKEY = NUMKEY
      NCOL = MAXBSC
      PMODE = MODE
C                                       Dimension fields by the number
C                                       of IFs where appropriate:
      IF (OPCODE.NE.'READ') THEN
         DO 10 I = 1,MAXBSC
            IF (CDIMEN(I).GT.0) THEN
               DATP(I, 2) = 10 * CDIMEN(I) + CTYPE(I)
            ELSE
               DATP(I, 2) = 10 * NUMIF + CTYPE(I)
               END IF
 10         CONTINUE
         END IF
      NREC = 128
      CALL TABINI (OPCODE, 'BS', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'BSINI', IERR)
         GO TO 990
C                                       new file
      ELSE IF (IERR.EQ.-1) THEN
         DO 20 I = 1,MAXBSC
C                                        Write column label to table:
            CALL CHR2H (24, CTITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', TIOTTL, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'BSINI', IERR)
               GO TO 990
               END IF
C                                        Write column units to table:
            CALL CHR2H (8, CUNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', TIOUNT, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'BSINI', IERR)
               GO TO 990
               END IF
 20         CONTINUE
C                                        Write table title:
         CALL CHR2H (56, TTITLE, 1, BUFFER(101))
C                                        Write keywords to table:
         KEYLOC(1) = 1
         KEYTYP(1) = TABINT
         IKVAL(1)  = BSVER
         KEYLOC(2) = 2
         KEYTYP(2) = TABINT
         IKVAL(2)  = NUMIF
         KEYLOC(3) = 3
         KEYTYP(3) = TABHOL
         CALL CHR2H (8, PMODE, 1, IKVAL(3))
         NKEY = NUMKEY
         CALL TABKEY ('WRIT', KEYWRD, NKEY, BUFFER, KEYLOC, IKVAL,
     *      KEYTYP, IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'BSINI', IERR)
            GO TO 990
            END IF
C                                        Read keyword/value pairs:
      ELSE
         NKEY = NUMKEY
         CALL TABKEY ('READ', KEYWRD, NKEY, BUFFER, KEYLOC, IKVAL,
     *      KEYTYP, IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'BSINI', IERR)
            GO TO 990
            END IF
C                                        Check BS table version no.:
         IF (KEYLOC(1).NE.-1) THEN
C                                        Must be from a later version
C                                        of AIPS.
            IF (IKVAL(KEYLOC(1)).GT.BSVER) THEN
               IERR = 1
               WRITE (MSGTXT,1020) IKVAL(KEYLOC(1))
               CALL MSGWRT (7)
               GO TO 990
               END IF
C                                       Can not cope with old versions
C                                       of the table format:
            IF (IKVAL(KEYLOC(1)).LT.BSVER) THEN
               IERR = 1
               WRITE (MSGTXT, 1021) 1
               CALL MSGWRT (7)
               GO TO 990
               END IF
         ELSE
            IERR = 1
            MSGTXT = 'BSINI: CORRUPT BS TABLE - NO REVISION NUMBER'
            CALL MSGWRT (7)
            GO TO 990
            END IF
C                                        Read number of IFs:
         IF (KEYLOC(2).NE.-1) THEN
            NUMIF = IKVAL(KEYLOC(2))
         ELSE
            IERR = 1
            MSGTXT = 'BSINI: CORRUPT BS TABLE - NO NO_IF KEYWORD'
            CALL MSGWRT (7)
            GO TO 990
            END IF
C                                        Read MODE keyword:
         IF (KEYLOC(3).NE.-1) THEN
            CALL H2CHR (8, 1, IKVAL(3), PMODE)
            MODE = PMODE(1:4)
         ELSE
            IERR = 1
            MSGTXT = 'BSINI: CORRUPT BS TABLE - NO MODE KEYWORD'
            CALL MSGWRT (7)
            GO TO 990
            END IF
C                                        Check keyword consistency:
         IF (((MODE.EQ.'VLBA') .OR. (MODE.EQ.'RATE') .OR.
     *      (MODE.EQ.'MK3 ')) .AND. (NUMIF.NE.1)) THEN
            IERR = 1
            WRITE (MSGTXT,1025) NUMIF, MODE
            CALL MSGWRT (7)
            GO TO 990
            END IF
         END IF
C                                        Set BSRNO:
      IF (OPCODE.EQ.'READ') THEN
         BSRNO = 1
      ELSE
         BSRNO = BUFFER(5) + 1
         END IF
C                                        Get array indices:
C                                      Get array indices
C                                      Cover your ass from FNDCOL -
C                                      close to flush the buffers and
C                                      then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, IKVAL, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'BSINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'BS', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'BSINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (MAXBSC, CTITLE, 24, .TRUE., BUFFER, BSCOLS, I)
C                                      Get array indices and no. values
      DO 150 I = 1,MAXBSC
         IPOINT = BSCOLS(I)
         IF (IPOINT.GT.0) THEN
            BSCOLS(I) = DATP(IPOINT,1)
            BSNUMV(I) = DATP(IPOINT,2) / 10
            IF (BSNUMV(I).LE.0) THEN
               NC = ITRIM (CTITLE(I))
               WRITE (MSGTXT,1100) CTITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            BSCOLS(I) = -1
            BSNUMV(I) = 0
            NC = ITRIM (CTITLE(I))
            WRITE (MSGTXT,1101) CTITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      IERR = 0
      GO TO 999
C
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
  999 RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('BSINI: CANNOT HANDLE BS TABLE REVISION ', I2)
 1021 FORMAT ('BSINI: OBSOLETE BS TABLE REVISION - RERUN BLING')
 1025 FORMAT ('BSINI: ', I2, ' IFS INCONSISTENT WITH MODE ''', A4, '''')
 1100 FORMAT ('BSINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('BSINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('BSINI: ERROR INITIALIZING BASELINE SOLUTION TABLE FOR ',
     *   A4)
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NPARMS
      PARAMETER (NPARMS=36)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'SOURCES',
     *   'QUAL', 'CALCODE', 'TIMERANG', 'SELBAND', 'SELFREQ', 'FREQID',
     *   'BIF', 'EIF', 'BCHAN', 'ECHAN', 'SUBARRAY', 'DOCALIB',
     *   'GAINUSE', 'DOPOL', 'PDVER', 'BLVER', 'FLAGVER', 'DOBAND',
     *   'BPVER', 'SMOOTH', 'UVRANGE', 'SOLINT', 'SCANLENG', 'REFANT',
     *   'OPTYPE', 'DOROBUST', 'DOCAT', 'DOCRT', 'OUTPRINT', 'PRTLEV',
     *    'BADDISK'/
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOACAR,
     *   OOAINT, OOACAR, OOARE, OOARE, OOARE, OOAINT,
     *   OOAINT, OOAINT, OOAINT, OOAINT, OOAINT, OOARE,
     *   OOAINT, OOAINT, OOAINT, OOAINT, OOAINT, OOAINT,
     *   OOAINT, OOARE, OOARE, OOARE, OOARE, OOAINT,
     *   OOACAR, OOALOG, OOALOG, OOAINT, OOACAR, OOAINT,
     *   OOAINT/
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 16,30,
     *   1,1, 4,1, 8,1, 1,1, 1,1, 1,1,
     *   1,1, 1,1, 1,1, 1,1, 1,1, 1,1,
     *   1,1, 1,1, 1,1, 1,1, 1,1, 1,1,
     *   1,1, 3,1, 2,1, 1,1, 1,1, 1,1,
     *   4,1, 1,1, 1,1, 1,1, 48,1, 1,1,
     *   10,1/
LOCAL END
LOCAL INCLUDE 'OUTPUT.INC'
C                                       Declarations for inputs
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NPARMO
      PARAMETER (NPARMO=1)
      CHARACTER AVONAM(NPARMO)*8
LOCAL END
LOCAL INCLUDE 'OUTPUTDATA.INC'
      DATA AVONAM /'ARRAY2'/
LOCAL END
LOCAL INCLUDE 'XXTAB.INC'
C                                       Column indices
C                                         (1) time1
C                                         (2) time2
C                                         (3) Source
C                                         (4) NSAMP Vector amplitudes
C                                         (5) NSAMP vector sigmas
C                                         (6) NSAMP Scalar amplitudes
C                                         (7) NSAMP vector sigmas
C                                         (8) NSAMP weights
C                                         (9) NSAMP closure failures
C                                       NSAMP = Cant * Cif * Cpol
C                                       Table label, column labels
      INTEGER   NCOL
      PARAMETER (NCOL = 9)
C
      INTEGER   COLIDX(NCOL), NSAMP, NCORS, XXTYPE
C
      COMMON /TABXX/ COLIDX, NSAMP, NCORS, XXTYPE
LOCAL END
LOCAL INCLUDE 'GFORT'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IDUM(40)
      LOGICAL   LDUM(40)
      REAL      RDUM(40)
      DOUBLE PRECISION DDUM(20)
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
      COMMON /FINDRG/ DDUM
LOCAL END
      PROGRAM FINDR
C-----------------------------------------------------------------------
C! Find normal values to guide FLAGR
C# Task OOP calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2004-2007, 2009-2011, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Determines normal data amplitudes and rms's.
C   This task takes the rms in the Real part and the rms in the
C   Imaginary part as two samples of the Amplitude rms.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, UVIN*32, PRINT*32, INPUT*32, OUTPUT*32
      INTEGER   IRET, IERR
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'OUTPUTDATA.INC'
      DATA PRGM /'FINDR '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL FINDRI (PRGM, INPUT, UVIN, PRINT, OUTPUT, IRET)
C                                       Check interference
      IF (IRET.LE.0) CALL FINDRO (INPUT, UVIN, PRINT, OUTPUT, IRET)
C                                       Return adverbs if RQUICK
      CALL OUTQAV (IRET, NPARMO, AVONAM, OUTPUT, IERR)
C                                       Return adverbs if .NOT.RQUICK
C                                       Close down files, etc.
      CALL OUT2AV (IRET, NPARMO, AVONAM, OUTPUT, IERR)
C
 999  STOP
      END
      SUBROUTINE FINDRI (PRGN, INPUT, UVIN, PRINT, OUTPUT, IERR)
C-----------------------------------------------------------------------
C   FINDRI gets input parameters for FINDR and creates the input uvdata
C   object.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      INPUT   C*?   Task inputs object
C      UVIN    C*?   Input multisource uv data object.
C      PRINT   C*?   Print object
C      OUTPUT  C*?   Output adverb object
C      IERR    I     Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER PRGN*(*), INPUT*(*), UVIN*(*), PRINT*(*), OUTPUT*(*)
      INTEGER   IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INTEGER   NKEY, NKEY2
C                                       NKEY=no. adverbs to copy to
C                                       UVIN
      PARAMETER (NKEY=30)
C                                       NKEY2=no. adverbs for PRINT
      PARAMETER (NKEY2=2)
      INTEGER   DIM(7), TYPE, FGVER, DISKI, CNOI, FGV, DOCRT, AVODIM(7)
      REAL      SOLINT, XDOCAL, ZERO(40)
      CHARACTER INK(NKEY)*8, OUTK(NKEY)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32, STOKES*4, CDUMMY*1, FGIN*32
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INPUT.INC'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'OUTPUTDATA.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs for UVIN
      DATA INK /'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
     *   'GAINUSE', 'DOPOL', 'BLVER', 'DOBAND', 'BPVER', 'SMOOTH',
     *   'FLAGVER',  'TIMERANG', 'UVRANGE', 'SOURCES', 'QUAL',
     *   'SELBAND', 'SELFREQ', 'FREQID', 'CALCODE', 'SUBARRAY',
     *   'BIF', 'EIF', 'BCHAN', 'ECHAN', 'PRTLEV', 'DOCAT',
     *   'SCANLENG', 'REFANT', 'PDVER', 'DOROBUST'/
      DATA OUTK /'NAME', 'CLASS', 'IMSEQ', 'DISK',
     *   'CALEDIT.CLUSE', 'CALEDIT.DOPOL', 'CALEDIT.BLVER',
     *   'CALEDIT.DOBAND', 'CALEDIT.BPVER', 'CALEDIT.SMOOTH',
     *   'CALEDIT.FGVER', 'CALEDIT.TIMRNG', 'CALEDIT.UVRNG',
     *   'CALEDIT.SOURCS', 'CALEDIT.SELQUA', 'CALEDIT.SELBAN',
     *   'CALEDIT.SELFRQ', 'CALEDIT.FRQSEL', 'CALEDIT.SELCOD',
     *   'CALEDIT.SUBARR', 'CALEDIT.BIF', 'CALEDIT.EIF',
     *   'CALEDIT.BCHAN', 'CALEDIT.ECHAN', 'PRTLEV', 'DOCAT',
     *   'SCANLENG', 'REFANT', 'CALEDIT.PDVER', 'DOROBUST'/
C                                       Adverbs for PRINT
      DATA INK2  /'DOCRT', 'OUTPRINT'/
      DATA OUTK2 /'DOCRT', 'LPFILE'/
      DATA ZERO /40 * 0.0/
C-----------------------------------------------------------------------
C                                       Startup - not resume AIPS
      INPUT = 'Input'
      CALL AV2INT (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, INPUT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       BADDISK
      CALL OGET (INPUT, 'BADDISK', TYPE, DIM, IBAD, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INPUT, 'DOCRT', TYPE, DIM, IDUM, CDUMMY, IERR)
      DOCRT = IDUM(1)
      IF (IERR.NE.0) GO TO 999
C                                       Create UVIN
      UVIN = 'Input UVdata'
      CALL CREATE (UVIN, 'UVDATA', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ (INPUT, NKEY, INK, OUTK, UVIN, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       DOCALIB
      CALL OGET ('Input', 'DOCALIB', TYPE, DIM, IDUM, CDUMMY, IERR)
      XDOCAL = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      DIM(1) = 1
      DIM(2) = 1
      LDUM(1) = XDOCAL.GT.0.0
      CALL OPUT (UVIN, 'CALEDIT.DOCAL', OOALOG, DIM, IDUM, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
      LDUM(1) = (XDOCAL.GT.0.0) .AND. (XDOCAL.LE.99.0)
      CALL OPUT (UVIN, 'CALEDIT.DOWTCL', OOALOG, DIM, IDUM, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Select all Stokes'
      STOKES = ' '
      DIM(1) = LEN (STOKES)
      DIM(2) = 1
      CALL OPUT (UVIN, 'CALEDIT.STOKES', OOACAR, DIM, IDUM, STOKES,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open UVIN to be sure it's OK.
      CALL OOPEN (UVIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBDSKC (UVIN, DISKI, CNOI, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OCLOSE (UVIN, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Default FLAGVER
      CALL OGET (INPUT, 'FLAGVER', TYPE, DIM, IDUM, CDUMMY, IERR)
      FGVER = IDUM(1)
      IF (IERR.NE.0) GO TO 999
C                                       Find highest FG table.
      FGIN = 'Temporary FG table for FINDRI'
      FGV = 1
      CALL UV2TAB (UVIN, FGIN, 'FG', FGV, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TBLHIV (FGIN, FGV, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       use highest for in
      IF (FGVER.EQ.0) FGVER = FGV
      IF (FGVER.GT.FGV) FGVER = FGV
      IDUM(1) = FGVER
      CALL OPUT (INPUT, 'FLAGVER', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OPUT (UVIN, 'CALEDIT.FGVER', OOAINT, DIM, IDUM, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Default SOLINT (60 sec)
      CALL OGET (INPUT, 'SOLINT', TYPE, DIM, IDUM, CDUMMY, IERR)
      SOLINT = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      IF (SOLINT.LE.0.0) SOLINT = 60.0
      RDUM(1) = SOLINT
      CALL OPUT (INPUT, 'SOLINT', OOARE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OPUT (UVIN, 'TIMEAVG', OOARE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TABDES (FGIN, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Printer object
      IF (DOCRT.NE.0) THEN
         PRINT = 'Printer object'
         CALL PRTCRE (PRINT, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
         CALL IN2OBJ (INPUT, NKEY2, INK2, OUTK2, PRINT, IERR)
         IF (IERR.NE.0) GO TO 999
         DIM(1) = LEN (UVIN)
         DIM(2) = 1
         CALL PRTPUT (PRINT, 'PRINTOBJ', OOACAR, DIM, IDUM, UVIN, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         PRINT = ' '
         END IF
C                                       Output object
      OUTPUT = 'Output adverbs'
      CALL OBCREA (OUTPUT, 'INPUTS', IERR)
      IF (IERR.NE.0) GO TO 999
      AVODIM(1) = 20
      AVODIM(2) = 2
      AVODIM(3) = 1
      CALL RCOPY (40, ZERO, RDUM)
      CALL OPUT (OUTPUT, AVONAM(1), OOARE, AVODIM, IDUM, CDUMMY, IERR)
C
 999  RETURN
      END
      SUBROUTINE FINDRO (INPUT, UVIN, PRINT, OUTPUT, IERR)
C-----------------------------------------------------------------------
C   Process data: allocates memory, calls various operations
C   Inputs:
C      INPUT   C*?   Task input object.
C      UVIN    C*?   Input multisource uv object
C      PRINT   C*?   Print object
C      OUTPUT  C*?   output object
C   Output:
C      IERR    I     Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER INPUT*(*), UVIN*(*), PRINT*(*), OUTPUT*(*)
      INTEGER   IERR
C
      INTEGER   TDIM
      PARAMETER (TDIM = 100)
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   TYPE, DIM(7), CCHAN, CIF, CPOL, NAXIS(7), INDEX, CANT,
     *   IS1, IS2, ANVER, MXA, COUNT(MAXANT,MAXANT,MAXIF,2), NTIME, NV,
     *   COUNTA(MAXANT,MAXANT,MAXIF,2), THEIUF(28*MAXANT*MAXANT*MAXIF),
     *   II
      LOGICAL   EXISTS
      CHARACTER OPTYPE*4, CDUMMY*1, TABLE*32
      DOUBLE PRECISION SUMV(MAXANT,MAXANT,MAXIF,2),
     *   SUMVS(MAXANT,MAXANT,MAXIF,2), SUMS(MAXANT,MAXANT,MAXIF,2),
     *   SUMSS(MAXANT,MAXANT,MAXIF,2), SUMWT(MAXANT,MAXANT,MAXIF,2),
     *   SUMWTA(MAXANT,MAXANT,MAXIF,2)
      REAL      ANTD(MAXANT,MAXIF,2,6), THEBUF(28*MAXANT*MAXANT*MAXIF),
     *   RUMV(MAXANT,MAXANT,MAXIF,4), RUMVS(MAXANT,MAXANT,MAXIF,4),
     *   RUMS(MAXANT,MAXANT,MAXIF,4), RUMSS(MAXANT,MAXANT,MAXIF,4),
     *   RUMWT(MAXANT,MAXANT,MAXIF,4), RUMWTA(MAXANT,MAXANT,MAXIF,4)
      EQUIVALENCE (THEBUF, THEIUF, SUMV, RUMV), (SUMVS, RUMVS),
     *   (SUMS, RUMS), (SUMSS, RUMSS), (SUMWT, RUMWT), (SUMWTA, RUMWTA)
      COMMON /SUMBUF/ SUMV, SUMVS, SUMS, SUMSS, SUMWT, SUMWTA, COUNT,
     *   COUNTA
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'GFORT'
      INCLUDE 'XXTAB.INC'
C-----------------------------------------------------------------------
C                                       opcode
      CALL OGET (INPUT, 'OPTYPE', TYPE, DIM, IDUM, OPTYPE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       data parameters
      CALL UVDGET (UVIN, 'NAXIS', TYPE, DIM, NAXIS, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL UVDFND (UVIN, 2, 'STOKES', INDEX, IERR)
      IF (IERR.NE.0) GO TO 999
      CPOL = NAXIS(INDEX)
      CPOL = MIN (2, CPOL)
      CALL UVDFND (UVIN, 2, 'FREQ', INDEX, IERR)
      IF (IERR.NE.0) GO TO 999
      CCHAN = NAXIS(INDEX)
      CALL UVDFND (UVIN, 2, 'IF', INDEX, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.1)) GO TO 999
      CIF = 1
      IF (IERR.EQ.0) CIF = NAXIS(INDEX)
C                                       find maximum antenna number
      TABLE = 'Temporary AN table for FINDR'
      CANT = 0
      CALL OUVGET (UVIN, 'CALEDIT.SUBARR', TYPE, DIM, IDUM, CDUMMY,
     *   IERR)
      ANVER = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      IF (ANVER.GT.0) THEN
         IS1 = ANVER
         IS2 = ANVER
      ELSE
         IS1 = 1
         IS2 = 99
         END IF
      DO 20 ANVER = 1,99
         CALL UV2TAB (UVIN, TABLE, 'AN', ANVER, IERR)
         EXISTS = .FALSE.
         IF (IERR.EQ.0) CALL TABEXI (TABLE, EXISTS, IERR)
         MXA = 0
         IF ((IERR.EQ.0) .AND. (EXISTS)) CALL ANTNO (TABLE, ANVER, MXA,
     *      IERR)
         CALL TABDES (TABLE, II)
         IF ((IERR.EQ.0) .AND. (EXISTS)) THEN
            CANT = MAX (CANT, MXA)
         ELSE
            GO TO 30
            END IF
 20      CONTINUE
 30   IF (CANT.LE.0) CANT = MAXANT
C
      NSAMP = CANT * CIF * CPOL
      NCORS = CIF * CPOL
C                                       Vector diff - antenna
      IF (OPTYPE.EQ.'VDIF') THEN
         XXTYPE = 2
         NTIME = (14 * 2 * MAXIF * MAXANT * MAXANT) / (5*NSAMP + NCORS)
         NV = NSAMP * NTIME
         CALL AMVDIF (UVIN, PRINT, OUTPUT, CANT, CIF, CPOL, CCHAN,
     *      NTIME, RUMV, RUMWT, COUNT, RUMS, ANTD, THEBUF(1),
     *      THEBUF(NV+1), THEBUF(2*NV+1), THEIUF(5*NV+1),
     *      THEBUF(4*NV+1), THEBUF(3*NV+1), IERR)
C                                       Vector diff - baseline
      ELSE IF (OPTYPE.EQ.'VRFI') THEN
         NSAMP = CANT * NSAMP
         NTIME = (14 * 2 * MAXIF * MAXANT * MAXANT - NSAMP) / (3*NSAMP)
         NV = NSAMP * NTIME
         CALL AMVRFI (UVIN, PRINT, OUTPUT, CANT, CIF, CPOL, CCHAN,
     *      NTIME, THEBUF(1), THEBUF(NV+1), THEBUF(2*NV+1),
     *      THEBUF, THEBUF(3*NV+1), IERR)
C                                       the rest
      ELSE
         XXTYPE = 1
         NTIME = (14 * 2 * MAXIF * MAXANT * MAXANT) / (6 * NSAMP)
         CALL ANTIME (UVIN, PRINT, OUTPUT, CANT, CIF, CPOL, CCHAN,
     *      NTIME, OPTYPE, SUMV, SUMVS, SUMS, SUMSS, SUMWT, COUNT,
     *      SUMWTA, COUNTA, ANTD, THEBUF, IERR)
         END IF
C                                       Error
      IF (IERR.NE.0) THEN
         MSGTXT = 'ERROR FINDING RMS IN ' // UVIN
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
      END
      SUBROUTINE ANTIME (UVIN, PRINT, OUTPUT, CANT, CIF, CPOL, CCHAN,
     *   CTIME, OPTYPE, SUMV, SUMVS, SUMS, SUMSS, SUMWT, COUNT, SUMWTA,
     *   COUNTA, ANTD, TD, IERR)
C-----------------------------------------------------------------------
C   Look for interference based on a high real or imaginary rms in time
C   interval TIMEAVG.
C   Inputs:
C      UVIN      C*?   Name of input uvdata object.
C      PRINT     C*?   Print object
C      OUTPUT    C*?   Output object
C      CANT      I     Maximum antenna number
C      CPOL      I     Number of polarizations
C      CIF       I     Number of IFs
C      CCHAN     I     Number of spactral channels
C      CTIME     I     Limit on number of times
C      OPTYPE    C*4   'GAIN' convert all amps to gains and do all
C                      sources together
C   Scratch variables
C      SUM, SUMSQ, SUMWT, COUNT, AMPS, RMSS
C      Note AMPS cannot be used when SUMV, SUMVS, SUMS, SUMSS, SUMWT,
C      COUNT are being used
C   Inputs attached to UVIN:
C      MAXRMS    R(*)  Maximum RMS allowed, constant plus amplitude
C                      coefficient.
C      MAXBAD    R(2)  Maximum allowed fraction of bad baselines.
C      TIMEAVG   R     Time in seconds for clipping interval
C      DOIFS     L     Flag all IFs if one bad
C      DOSTOKES  L     Flas all Stokes if 1 bad
C      KILLONES  L     Kill 1-sample integrations
C      PRTLEV    I     Print level for debugging
C   Output:
C      IERR      I     Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER UVIN*(*), PRINT*(*), OUTPUT*(*), OPTYPE*4
      INTEGER   CANT, CIF, CPOL, CCHAN, CTIME, IERR
      INTEGER   COUNT(CANT,CANT,CIF,CPOL), COUNTA(CANT,CANT,CIF,CPOL)
      DOUBLE PRECISION SUMV(CANT,CANT,CIF,CPOL),
     *   SUMVS(CANT,CANT,CIF,CPOL), SUMS(CANT,CANT,CIF,CPOL),
     *   SUMSS(CANT,CANT,CIF,CPOL), SUMWT(CANT,CANT,CIF,CPOL),
     *   SUMWTA(CANT,CANT,CIF,CPOL)
      REAL      ANTD(CANT,CIF,CPOL,6), TD(CANT,CIF,CPOL,6,*)
C
      REAL      TCLIP
      LOGICAL   DOCAT
      INTEGER   PRTLEV
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NSORC, NTIME, LMAX
      PARAMETER (NSORC = 5000, NTIME = 15001)
      PARAMETER (LMAX = ((MAXANT) * (MAXANT)))
C
      INTEGER   TYPE, DIM(7), ANT1, ANT2, ENDVIS, VISNO, CURSOU,
     *   THISOU, TBVER, DOCRT, I, J, LS, XS, NACROS, ILOCU, ILOCV, IT,
     *   ILOCW, ILOCT, ILOCB, K,ILOCSU, ILOCFQ, ILOCA1, ILOCA2, ILOCSA,
     *   JLOCC, JLOCS, JLOCF, JLOCR, JLOCD, JLOCIF, LA,INCS, INCF,
     *   INCIF, LP, LIF, IP, NPRINT, THISUB, THIFRQ, CURSUB, CURFRQ,
     *   NZERO, XXROW, LT, II, SCNT(NSORC), SNUMS(NTIME), MTIME,
     *   SINUM(NSORC), SCOUNT, BADANT(MAXANT), QUAL(NSORC), NOFIVE(5),
     *   NOFTEN(5), ITRIM, AVODIM(3), JJ, KK, NPP(2)
      LOGICAL   DONE, DOSOU, QUIT, DOCAL, DOROBU
      CHARACTER SUTAB*32, SUNAME(NSORC)*16, LINE*132, CDUMMY*1,
     *   XXFILE*32, DTYPE(5)*10
      REAL      AMP, RMS,  RP(50), TEPS, W, CURTIM, LSTIME, ENDTIM,
     *   BEGTIM, VIS(3,MAXCIF), SASUM(NSORC), SRSUM(NSORC), DV(5),
     *   SAASUM(NSORC), SRRSUM(NSORC), TIMR(2,NTIME), RV(5),
     *   PP(2,MAXIF,MAXANT,5), PR(2,MAXIF,MAXANT,5), NOVER(12),
     *   ARRAY2(20,2), LIST(2*MAXANT*MAXIF), FRAC(MAXANT,MAXIF,2),
     *   FRACNT(12), FRATOT, TDUMMY(NTIME,4), LSUMV(LMAX), LSUMVS(LMAX),
     *   LSUMS(LMAX), LSUMSS(LMAX), LSUMWT(LMAX), WP(2), SP(2), SPP(2)
      EQUIVALENCE (ARRAY2(1,1), DV),  (ARRAY2(6,1), RV),
     *   (ARRAY2(1,2), NOVER)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      COMMON /TBUFS/ TIMR, SNUMS, TDUMMY
      INCLUDE 'GFORT'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'OUTPUTDATA.INC'
      DATA DTYPE /'Vector amp', 'Vector rms', 'Scalar amp',
     *   'Scalar rms', 'Weight'/
C-----------------------------------------------------------------------
      XXFILE = ' '
      TEPS = 0.02 / (3600.0 * 24.0)
      CALL FILL (NSORC, 0, SCNT)
      CALL RFILL (NSORC, 0.0, SASUM)
      CALL RFILL (NSORC, 0.0, SRSUM)
      CALL RFILL (NSORC, 0.0, SAASUM)
      CALL RFILL (NSORC, 0.0, SRRSUM)
      CALL RFILL (40, 0.0, ARRAY2)
      SCOUNT = 0
C                                       Open printer
      NPRINT = 0
      IF (PRINT.NE.' ') THEN
         CALL OOPEN (PRINT, 'WRIT', IERR)
         IF (IERR.NE.0) GO TO 990
         CALL OGET (PRINT, 'DOCRT', TYPE, DIM, IDUM, CDUMMY, IERR)
         DOCRT = IDUM(1)
         IF (IERR.NE.0) GO TO 990
         CALL OGET (PRINT, 'NACROS', TYPE, DIM, IDUM, CDUMMY, IERR)
         NACROS = IDUM(1)
         IF (IERR.NE.0) GO TO 990
      ELSE
         DOCRT = 0
         END IF
      THISOU = 0
      THISUB = 0
      THIFRQ = 0
      CURSUB = 0
      CURFRQ = 0
C                                       Create and open a scratch table:
      XXFILE = 'Temporary results table'
      CALL UV2TAB (UVIN, XXFILE, 'XX', 1, IERR)
      IF (IERR.NE.0) THEN
         XXFILE = ' '
         GO TO 990
         END IF
      CALL OXXINI (XXFILE, 'WRIT', XXROW, IERR)
      IF (IERR.NE.0) THEN
         XXFILE = ' '
         GO TO 990
         END IF
C                                       Retrieve pointers into the data:
C                                       pointers into the data:
      CALL UVDPNT (UVIN, ILOCU, ILOCV, ILOCW, ILOCT, ILOCB, ILOCSU,
     *   ILOCFQ, ILOCA1, ILOCA2, ILOCSA, JLOCC, JLOCS, JLOCF, JLOCR,
     *   JLOCD, JLOCIF, INCS, INCF, INCIF, IERR)
      IF (IERR.NE.0) GO TO 999
      INCS = INCS / 3
      INCF = INCF / 3
      INCIF = INCIF / 3
C                                       Open input.
      CALL OUVOPN (UVIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Get parameters=
      CALL OUVGET (UVIN, 'DOROBUST', TYPE, DIM, IDUM, CDUMMY, IERR)
      DOROBU = LDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OUVGET (UVIN, 'DOCAT', TYPE, DIM, IDUM, CDUMMY, IERR)
      DOCAT = LDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OUVGET (UVIN, 'PRTLEV', TYPE, DIM, IDUM, CDUMMY, IERR)
      PRTLEV = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OUVGET (UVIN, 'TIMEAVG', TYPE, DIM, IDUM, CDUMMY, IERR)
      TCLIP = RDUM(1)
      IF (IERR.NE.0) GO TO 990
      TCLIP = TCLIP / 86400.0
C                                       Processing info
      CALL OUVGET (UVIN, 'CALEDIT.DOCAL', TYPE, DIM, IDUM, CDUMMY,
     *   IERR)
      DOCAL = LDUM(1)
      IF (IERR.NE.0) GO TO 990
      DOSOU = (ILOCSU.GT.0)
      IERR = 0
C                                       Source table/name
      IF (DOSOU) THEN
         SUTAB = 'SoUrce table for ANTIME'
         TBVER = 1
         CALL UV2TAB (UVIN, SUTAB, 'SU', TBVER, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       For single source use 'OBJECT'
      ELSE
         CALL UVDGET (UVIN, 'OBJECT', TYPE, DIM, IDUM, SUNAME, IERR)
         IF (IERR.NE.0) GO TO 990
         QUAL(1) = 0
         END IF
C                                       Clear accumulators:
C                                       (1,*) =  count
C                                       (2,*) =  sum r then max rms**2
C                                       (3,*) =  sum**2 r then rms**2
C                                       (4,*) =  sum imaginary
C                                       (5,*) =  sum**2 imaginary
C                                       (6,*) =  sum amplitude
      NZERO = CANT * CANT * CIF * CPOL
      CALL DFILL (NZERO, 0.0D0, SUMV)
      CALL DFILL (NZERO, 0.0D0, SUMVS)
      CALL DFILL (NZERO, 0.0D0, SUMS)
      CALL DFILL (NZERO, 0.0D0, SUMSS)
      CALL DFILL (NZERO, 0.0D0, SUMWT)
      CALL DFILL (NZERO, 0.0D0, SUMWTA)
      CALL FILL (NZERO, 0, COUNT)
      CALL FILL (NZERO, 0, COUNTA)
C                                       Initialize visibility count
      DONE = .FALSE.
      VISNO = 0
C                                       Swallow input collecting
C                                       statistics.
C                                       Loop thru data
 100     CALL UVREAD (UVIN, RP, VIS, IERR)
         IF (IERR.LT.0) THEN
            DONE = .TRUE.
            IERR = 0
            END IF
         IF (IERR.GT.0) GO TO 990
         VISNO = VISNO + 1
 110     CURTIM = RP(ILOCT)
         IF (DOSOU) THEN
            CURSOU = RP(ILOCSU) + 0.5
         ELSE
            CURSOU = 0
            END IF
         IF (ILOCFQ.GT.0) CURFRQ = RP(ILOCFQ) + 0.5
C                                       Get antenna numbers
         IF (ILOCB.GT.0) THEN
            ANT1 = (RP(ILOCB) / 256.0) + 0.001
            ANT2 = (RP(ILOCB) - ANT1 * 256) + 0.001
            CURSUB = (RP(ILOCB) - 256 * ANT1 - ANT2) * 100.0 + 1.1
         ELSE
            ANT1 = RP(ILOCA1) + 0.001
            ANT2 = RP(ILOCA2) + 0.001
            CURSUB = RP(ILOCSA) + 0.001
            END IF
C                                       Initial selection.
         IF (VISNO.EQ.1) THEN
            THIFRQ = CURFRQ
            THISUB = CURSUB
            THISOU = CURSOU
            BEGTIM = CURTIM
            ENDTIM = CURTIM + TCLIP
            END IF
C                                       Finished with data or interval?
         IF (DONE .OR. (CURTIM.GT.ENDTIM) .OR. (CURSOU.NE.THISOU)
     *      .OR. (CURSUB.NE.THISUB)) GO TO 150
C                                       Set last vis of interval
         ENDVIS = VISNO
C                                       Set last time
         LSTIME = CURTIM
C                                       Baseline index
         DO 130 LP = 1,CPOL
            DO 125 LIF = 1,CIF
               IP = (LP-1) * INCS + (LIF-1) * INCIF + 1
C                                       amplitude
               CALL AVERAG (CCHAN, VIS(1,IP), INCF, ANT1, ANT2, .TRUE.,
     *            DOROBU, NPP, WP, SP, SPP)
               COUNTA(ANT1,ANT2,LIF,LP) = COUNTA(ANT1,ANT2,LIF,LP) +
     *            NPP(1)
               SUMWTA(ANT1,ANT2,LIF,LP) = SUMWTA(ANT1,ANT2,LIF,LP) +
     *            WP(1)
               SUMS(ANT1,ANT2,LIF,LP) = SUMS(ANT1,ANT2,LIF,LP) +
     *            SP(1)
               SUMSS(ANT1,ANT2,LIF,LP) = SUMSS(ANT1,ANT2,LIF,LP) +
     *            SPP(1)
C                                       real & imaginary
               CALL AVERAG (CCHAN, VIS(1,IP), INCF, ANT1, ANT2, .FALSE.,
     *            DOROBU, NPP, WP, SP, SPP)
               COUNT(ANT1,ANT2,LIF,LP) = COUNT(ANT1,ANT2,LIF,LP) +
     *            NPP(1)
               SUMWT(ANT1,ANT2,LIF,LP) = SUMWT(ANT1,ANT2,LIF,LP) +
     *            WP(1)
               SUMV(ANT1,ANT2,LIF,LP) = SUMV(ANT1,ANT2,LIF,LP) +
     *            SP(1)
               SUMVS(ANT1,ANT2,LIF,LP) = SUMVS(ANT1,ANT2,LIF,LP) +
     *            SPP(1)
               COUNT(ANT2,ANT1,LIF,LP) = COUNT(ANT2,ANT1,LIF,LP) +
     *            NPP(2)
               SUMWT(ANT2,ANT1,LIF,LP) = SUMWT(ANT2,ANT1,LIF,LP) +
     *            WP(2)
               SUMV(ANT2,ANT1,LIF,LP) = SUMV(ANT2,ANT1,LIF,LP) +
     *            SP(2)
               SUMVS(ANT2,ANT1,LIF,LP) = SUMVS(ANT2,ANT1,LIF,LP) +
     *            SPP(2)
 125           CONTINUE
 130        CONTINUE
C                                       Next vis until done
         IF (.NOT.DONE) GO TO 100
 150     IERR = 0
C                                       Get statistics
       DO 170 LIF = 1,CIF
          DO 165 LP = 1,CPOL
             CALL FILL (CANT, 0, BADANT)
             KK = 0
             DO 160 ANT2 = 1,CANT
               DO 155 ANT1 = 1,CANT
                  KK = KK + 1
                  IF (SUMWT(ANT1,ANT2,LIF,LP).GT.0.0) THEN
                     SUMV(ANT1,ANT2,LIF,LP) = (SUMV(ANT1,ANT2,LIF,LP)
     *                  / SUMWT(ANT1,ANT2,LIF,LP)) ** 2
                     SUMVS(ANT1,ANT2,LIF,LP) = SUMVS(ANT1,ANT2,LIF,LP)
     *                  / SUMWT(ANT1,ANT2,LIF,LP)
                     END IF
                  IF (SUMWTA(ANT1,ANT2,LIF,LP).GT.0.0) THEN
                     SUMS(ANT1,ANT2,LIF,LP) = (SUMS(ANT1,ANT2,LIF,LP)
     *                  / SUMWTA(ANT1,ANT2,LIF,LP)) ** 2
                     SUMSS(ANT1,ANT2,LIF,LP) = SUMSS(ANT1,ANT2,LIF,LP)
     *                  / SUMWTA(ANT1,ANT2,LIF,LP)
                     END IF
                  IF (COUNT(ANT1,ANT2,LIF,LP).GT.1) THEN
                     RMS = SUMVS(ANT1,ANT2,LIF,LP) -
     *                  SUMV(ANT1,ANT2,LIF,LP)
                     RMS = (RMS * COUNT(ANT1,ANT2,LIF,LP)) /
     *                  (COUNT(ANT1,ANT2,LIF,LP) - 1.0)
                     RMS = ABS (RMS)
                     LSUMV(KK) = SUMV(ANT1,ANT2,LIF,LP)
                     LSUMVS(KK) = RMS
                     LSUMWT(KK) = (SUMWT(ANT1,ANT2,LIF,LP)
     *                  / COUNT(ANT1,ANT2,LIF,LP)) ** 2
                  ELSE
                     LSUMVS(KK) = FBLANK
                     LSUMV(KK) = FBLANK
                     LSUMWT(KK) = FBLANK
                     END IF
                  IF (COUNTA(ANT1,ANT2,LIF,LP).GT.1) THEN
                     IF (ANT1.LE.ANT2) THEN
                        RMS = SUMSS(ANT1,ANT2,LIF,LP) -
     *                     SUMS(ANT1,ANT2,LIF,LP)
                        RMS = (RMS * COUNTA(ANT1,ANT2,LIF,LP)) /
     *                     (COUNTA(ANT1,ANT2,LIF,LP) - 1.0)
                        RMS = ABS (RMS)
                        LSUMS(KK) = SUMS(ANT1,ANT2,LIF,LP)
                        LSUMSS(KK) = RMS
                     ELSE
                        LSUMSS(KK) = FBLANK
                        LSUMS(KK) = FBLANK
                        END IF
                  ELSE
                     LSUMSS(KK) = FBLANK
                     LSUMS(KK) = FBLANK
                     END IF
                  BADANT(ANT1) = MAX (BADANT(ANT1),
     *               COUNT(ANT1,ANT2,LIF,LP))
                  BADANT(ANT2) = MAX (BADANT(ANT2),
     *               COUNT(ANT1,ANT2,LIF,LP))
 155              CONTINUE
 160           CONTINUE
C                                       solve for antenna amplitude
            CALL ASOLVE (PRTLEV, 'amp', BEGTIM, LSTIME, CANT, 3.0,
     *         LSUMV, ANTD(1,LIF,LP,1), ANTD(1,LIF,LP,6))
            CALL ASOLVE (PRTLEV, 'amp', BEGTIM, LSTIME, CANT, 3.0,
     *         LSUMS, ANTD(1,LIF,LP,3), FRAC)
C                                       solve for antenna RMS
            CALL ASOLVE (PRTLEV, 'rms', BEGTIM, LSTIME, CANT, 3.0,
     *         LSUMVS, ANTD(1,LIF,LP,2), FRAC)
            CALL ASOLVE (PRTLEV, 'rms', BEGTIM, LSTIME, CANT, 3.0,
     *         LSUMSS, ANTD(1,LIF,LP,4), FRAC)
C                                       solve for antenna weight
            CALL ASOLVE (PRTLEV, 'rms', BEGTIM, LSTIME, CANT, 3.0,
     *         LSUMWT, ANTD(1,LIF,LP,5), FRAC)
C                                       mark all 1-sample
            DO 162 ANT1 = 1,CANT
               IF (BADANT(ANT1).EQ.1) ANTD(ANT1,LIF,LP,1) = -1.E6
 162           CONTINUE
 165        CONTINUE
 170     CONTINUE
C                                       local source number
      J = 0
      DO 175 I = 1,SCOUNT
         IF (THISOU.EQ.SINUM(I)) J = I
 175     CONTINUE
      IF (J.EQ.0) THEN
         SCOUNT = SCOUNT + 1
         J = SCOUNT
         SINUM(J) = THISOU
         END IF
C                                       Stuff into array
      DO 195 LA = 1,CANT
         DO 190 LIF = 1,CIF
            DO 185 LP = 1,CPOL
               IF ((ANTD(LA,LIF,LP,2).NE.FBLANK) .AND.
     *            (ANTD(LA,LIF,LP,2).GT.0.0) .AND.
     *            (ANTD(LA,LIF,LP,1).NE.FBLANK) .AND.
     *            (ANTD(LA,LIF,LP,1).GT.0.0)) THEN
                  SCNT(J) = SCNT(J) + 1
                  SRSUM(J) = SRSUM(J) + ANTD(LA,LIF,LP,2)
                  SASUM(J) = SASUM(J) + ANTD(LA,LIF,LP,1)
                  SRRSUM(J) = SRRSUM(J) + ANTD(LA,LIF,LP,2) ** 2
                  SAASUM(J) = SAASUM(J) + ANTD(LA,LIF,LP,1) ** 2
                  END IF
 185           CONTINUE
 190        CONTINUE
 195     CONTINUE
C                                       write to scratch table
      CALL OTABXX (XXFILE, 'WRIT', XXROW, BEGTIM, LSTIME, J,
     *   ANTD(1,1,1,1), ANTD(1,1,1,2), ANTD(1,1,1,3), ANTD(1,1,1,4),
     *   ANTD(1,1,1,5), ANTD(1,1,1,6), COUNT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Clear accumulators:
      CALL DFILL (NZERO, 0.0D0, SUMV)
      CALL DFILL (NZERO, 0.0D0, SUMVS)
      CALL DFILL (NZERO, 0.0D0, SUMS)
      CALL DFILL (NZERO, 0.0D0, SUMSS)
      CALL DFILL (NZERO, 0.0D0, SUMWT)
      CALL DFILL (NZERO, 0.0D0, SUMWTA)
      CALL FILL (NZERO, 0, COUNT)
      CALL FILL (NZERO, 0, COUNTA)
C                                       Another clipping interval?
      IF (.NOT.DONE) THEN
         THISOU = CURSOU
         BEGTIM = CURTIM
         ENDTIM = CURTIM + TCLIP
         THIFRQ = CURFRQ
         THISUB = CURSUB
         GO TO 110
         END IF
C-----------------------------------------------------------------------
C                                       Okay - close table and re-read
C                                       to fill memory
      CALL TABCLO (XXFILE, IERR)
      IF (IERR.NE.0) GO TO 990
      MTIME = XXROW - 1
      IF ((MTIME.GT.CTIME) .OR. (MTIME.GT.NTIME)) THEN
         LP = MIN (NTIME, CTIME)
         WRITE (MSGTXT,1200) MTIME, LP
         CALL MSGWRT (7)
         MTIME = LP
         END IF
      CALL OXXINI (XXFILE, 'READ', XXROW, IERR)
      IF (IERR.NE.0) GO TO 999
      DO 215 IP = 1,MTIME
         CALL OTABXX (XXFILE, 'READ', XXROW, TIMR(1,IP), TIMR(2,IP),
     *      SNUMS(IP), TD(1,1,1,1,IP), TD(1,1,1,2,IP), TD(1,1,1,3,IP),
     *      TD(1,1,1,4,IP), TD(1,1,1,5,IP), TD(1,1,1,6,IP), COUNT, IERR)
         IF (IERR.NE.0) GO TO 990
 215     CONTINUE
      CALL TABCLO (XXFILE, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL RFILL (12, 0.0, FRACNT)
      FRATOT = 0.0
C                                       average source sums
      DO 220 LS = 1,SCOUNT
         IF (SCNT(LS).GT.0) THEN
            SRSUM(LS) = SRSUM(LS) / SCNT(LS)
            SASUM(LS) = SASUM(LS) / SCNT(LS)
            SRRSUM(LS) = SRRSUM(LS) / SCNT(LS)
            SAASUM(LS) = SAASUM(LS) / SCNT(LS)
            END IF
 220     CONTINUE
C                                       get source info, scale clips
      DO 230 LS = 1,SCOUNT
C                                       Get source name, qualifier
         THISOU = SINUM(LS)
         IF (DOSOU) THEN
            CALL SOUNFO (SUTAB, THISOU, 'SOURCE', TYPE, DIM, II,
     *         SUNAME(LS), IERR)
            IF (IERR.NE.0) GO TO 990
            CALL SOUNFO (SUTAB, THISOU, 'QUAL', TYPE, DIM, QUAL(LS),
     *         CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
C                                       tell user
         IF ((OPTYPE.EQ.'GAIN') .AND. (SASUM(LS).GT.0.0)) THEN
            WRITE (MSGTXT,1220) SUNAME(LS), QUAL(LS), SASUM(LS)
            LINE = MSGTXT
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (IERR.NE.0) GO TO 990
               IF (QUIT) DOCRT = 0
               END IF
            IF (DOCRT.LE.0) CALL MSGWRT (4)
            END IF
 230     CONTINUE
C                                       scale to gains
      IF (OPTYPE.EQ.'GAIN') THEN
         DO 270 IP = 1,MTIME
            LS = SNUMS(IP)
            DO 260 LA = 1,CANT
               DO 250 LIF = 1,CIF
                  DO 240 LP = 1,CPOL
                     IF ((TD(LA,LIF,LP,1,IP).NE.FBLANK) .AND.
     *                  (TD(LA,LIF,LP,1,IP).GT.0.0)) TD(LA,LIF,LP,1,IP)
     *                  = TD(LA,LIF,LP,1,IP) / SASUM(LS)
                     IF ((TD(LA,LIF,LP,3,IP).NE.FBLANK) .AND.
     *                  (TD(LA,LIF,LP,3,IP).GT.0.0)) TD(LA,LIF,LP,3,IP)
     *                  = TD(LA,LIF,LP,3,IP) / SASUM(LS)
 240                 CONTINUE
 250              CONTINUE
 260           CONTINUE
 270        CONTINUE
         SCOUNT = 1
         END IF
C                                       outer loops: antenna, source
      DO 500 XS = 1,SCOUNT
         LS = XS
C                                       find correct amp, rms
         IF ((PRTLEV.GE.2) .AND. (DOCRT.NE.0)) THEN
            LINE = ' '
            CALL PRTWRI (PRINT, LINE, QUIT, IERR)
            IF (QUIT) DOCRT = 0
            IF (IERR.NE.0) GO TO 990
            LINE = 'List all data values'
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
C                                       Page labels
            LINE = 'Antenna-based amplitudes, rmses, weights'
            I = ITRIM (LINE)
            IF (OPTYPE.EQ.'GAIN') THEN
               LINE(I+1:) = ' for all sources'
            ELSE
               LINE(I+1:) = ' for ' // SUNAME(LS)
               END IF
            DIM(1) = LEN (LINE)
            DIM(2) = 1
            CALL OPUT (PRINT, 'TITLE1', OOACAR, DIM, IDUM, LINE, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
            LINE = 'An IF P Time    V amp    V rms      '
     *         // 'S amp    S rms    Weight'
            CALL OPUT (PRINT, 'TITLE2', OOACAR, DIM, IDUM, LINE, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
            END IF
         DO 350 LA = 1,CANT
            DO 340 LIF = 1,CIF
               DO 330 LP = 1,CPOL
                  DO 325 IT = 1,5
                     II = 0
                     DO 320 IP = 1,MTIME
                        IF (OPTYPE.EQ.'GAIN') LS = SNUMS(IP)
                        IF (SNUMS(IP).EQ.LS) THEN
                           IF ((PRTLEV.GE.2) .AND. (IT.EQ.1) .AND.
     *                        (TD(LA,LIF,LP,1,IP).NE.FBLANK) .AND.
     *                        (TD(LA,LIF,LP,1,IP).GT.0.0) .AND.
     *                        (DOCRT.NE.0)) THEN
                              WRITE (LINE,1310) LA, LIF, LP, IP,
     *                           (TD(LA,LIF,LP,LT,IP), LT = 1,6)
                              CALL PRTWRI (PRINT, LINE, QUIT, IERR)
                              IF (IERR.NE.0) GO TO 990
                              IF (QUIT) DOCRT = 0
                              END IF
                           IF ((TD(LA,LIF,LP,IT,IP).NE.FBLANK) .AND.
     *                        (TD(LA,LIF,LP,IT,IP).GE.0.0)) THEN
                              II = II + 1
                              LIST(II) = TD(LA,LIF,LP,IT,IP)
C                                       closure error statistics
                              IF ((IT.EQ.1) .AND.
     *                           (TD(LA,LIF,LP,6,IP).NE.FBLANK)) THEN
                                 IF (TD(LA,LIF,LP,6,IP).LE.0.0) THEN
                                    JJ = 1
                                 ELSE
                                    JJ = TD(LA,LIF,LP,6,IP) / 0.1 + 2
                                    JJ = MIN (JJ, 12)
                                    END IF
                                 FRATOT = FRATOT + 1.0
                                 FRACNT(JJ) = FRACNT(JJ) + 1.0
                                 END IF
                              END IF
                           END IF
 320                    CONTINUE
                     IF (II.GT.0) THEN
                        CALL ROBUST (LIST, II, DV(IT), RV(IT))
                        PP(LP,LIF,LA,IT) = DV(IT)
                        PR(LP,LIF,LA,IT) = RV(IT)
                     ELSE
                        PP(LP,LIF,LA,IT) = 0.0
                        PR(LP,LIF,LA,IT) = 1.E12
                        END IF
 325                 CONTINUE
 330              CONTINUE
 340           CONTINUE
 350        CONTINUE
C                                       get global averages reliably
         DO 390 IT = 1,5
            II = 0
            DO 380 LA = 1,CANT
               DO 370 LIF = 1,CIF
                  DO 360 LP = 1,CPOL
                     IF ((PR(LP,LIF,LA,IT).LT.1.E9)) THEN
                        II = II + 1
                        LIST(II) = PP(LP,LIF,LA,IT)
                        END IF
 360                 CONTINUE
 370              CONTINUE
 380           CONTINUE
            IF (II.GT.0) THEN
               CALL ROBUST (LIST, II, DV(IT), RV(IT))
            ELSE
               DV(IT)= 0.0
               RV(IT) = 0.0
               END IF
 390        CONTINUE
C                                       Report overall numbers
C                                       Page labels
         IF (DOCRT.NE.0) THEN
            LINE = ' '
            DIM(1) = LEN (LINE)
            DIM(2) = 1
            CALL OPUT (PRINT, 'TITLE1', OOACAR, DIM, IDUM, LINE, IERR)
            IF (IERR.NE.0) GO TO 990
            CALL PRTWRI (PRINT, LINE, QUIT, IERR)
            IF (QUIT) DOCRT = 0
            IF (IERR.NE.0) GO TO 990
            LINE = 'Robust average over all IFs and polarizations of' //
     *         ' the robust averages over time'
            CALL OPUT (PRINT, 'TITLE2', OOACAR, DIM, IDUM, LINE, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
            END IF
         DO 395 IT = 1,5
            IF (DOCRT.LE.0) THEN
               IF (OPTYPE.EQ.'GAIN') THEN
                  WRITE (MSGTXT,1390) DTYPE(IT), DV(IT), RV(IT),
     *               'All sources', ' '
               ELSE
                  WRITE (MSGTXT,1390) DTYPE(IT), DV(IT), RV(IT),
     *               'source=', SUNAME(LS)
                  END IF
               CALL MSGWRT (4)
               END IF
            IF (DOCRT.NE.0) THEN
               IF (OPTYPE.EQ.'GAIN') THEN
                  WRITE (LINE,1391) DTYPE(IT), DV(IT), RV(IT),
     *               'All sources', ' '
               ELSE
                  WRITE (LINE,1391) DTYPE(IT), DV(IT), RV(IT),
     *               'source=', SUNAME(LS)
                  END IF
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (IERR.NE.0) GO TO 990
               IF (QUIT) DOCRT = 0
               END IF
 395        CONTINUE
C                                       report particular numbers
         IF ((PRTLEV.GE.1) .AND. (PRINT.NE.' ') .AND. (DOCRT.NE.0)) THEN
            LINE = ' '
            CALL PRTWRI (PRINT, LINE, QUIT, IERR)
            IF (QUIT) DOCRT = 0
            IF (IERR.NE.0) GO TO 990
            LINE = 'List all robust averages with their uncertainties'
            I = ITRIM (LINE)
            IF (OPTYPE.EQ.'GAIN') THEN
               LINE(I+1:) = ' for all sources'
            ELSE
               LINE(I+1:) = ' for ' // SUNAME(LS)
               END IF
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
C                                       Page labels
            LINE = 'IF P An  Vector amp    Vector rms  '
     *         // '  Scalar amp    Scalar rms         Weight'
            DIM(1) = LEN (LINE)
            DIM(2) = 1
            CALL OPUT (PRINT, 'TITLE1', OOACAR, DIM, IDUM, LINE, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
            IF (OPTYPE.EQ.'GAIN') THEN
               LINE = 'All sources'
            ELSE
               LINE = SUNAME(LS)
               END IF
            LINE(16:) = '+-'
            LINE(30:) = '+-'
            LINE(44:) = '+-'
            LINE(58:) = '+-'
            LINE(76:) = '+-'
            CALL OPUT (PRINT, 'TITLE2', OOACAR, DIM, IDUM, LINE, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
C                                       loop over data
            DO 420 LIF = 1,CIF
               DO 410 LP = 1,CPOL
                  DO 400 LA = 1,CANT
                     IF ((PR(LP,LIF,LA,3).LT.1.E9) .OR.
     *                  (PR(LP,LIF,LA,1).LT.1.E7) .OR.
     *                  (PR(LP,LIF,LA,2).LT.1.E7)) THEN
                        WRITE (LINE,1400) LIF, LP, LA,
     *                     (PP(LP,LIF,LA,IT), PR(LP,LIF,LA,IT),
     *                     IT = 1,5)
                        CALL PRTWRI (PRINT, LINE, QUIT, IERR)
                        IF (IERR.NE.0) GO TO 990
                        IF (QUIT) THEN
                           DOCRT = 0
                           GO TO 425
                           END IF
                        END IF
 400                 CONTINUE
 410              CONTINUE
 420           CONTINUE
            END IF
C                                       page titles
 425     IF ((PRTLEV.GE.1) .AND. (PRINT.NE.' ') .AND. (DOCRT.NE.0)) THEN
            LINE = ' '
            CALL PRTWRI (PRINT, LINE, QUIT, IERR)
            IF (QUIT) DOCRT = 0
            IF (IERR.NE.0) GO TO 990
            LINE = 'Number samples more than 5 and 10 sigma from mean'
     *         // ' by type and orphan samples'
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
            LINE = 'IF P An Total  Vector amp  Vector rms '
     *         // ' Scalar amp  Scalar rms      Weight  Orphans'
            DIM(1) = LEN (LINE)
            DIM(2) = 1
            CALL OPUT (PRINT, 'TITLE1', OOACAR, DIM, IDUM, LINE, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
            IF (OPTYPE.EQ.'GAIN') THEN
               LINE = 'All sources'
            ELSE
               LINE = SUNAME(LS)
               END IF
            LINE(21:) = '5  10'
            LINE(33:) = '5  10'
            LINE(45:) = '5  10'
            LINE(57:) = '5  10'
            LINE(69:) = '5  10'
            CALL OPUT (PRINT, 'TITLE2', OOACAR, DIM, IDUM, LINE, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
            END IF
         DO 460 LIF = 1,CIF
            DO 450 LP = 1,CPOL
               DO 440 LA = 1,CANT
                  CALL FILL (5, 0, NOFIVE)
                  CALL FILL (5, 0, NOFTEN)
                  K = 0
                  J = 0
                  DO 430 IP = 1,MTIME
                     IF (OPTYPE.EQ.'GAIN') LS = SNUMS(IP)
                     IF (SNUMS(IP).EQ.LS) THEN
                        IF (TD(LA,LIF,LP,1,IP).NE.FBLANK) THEN
                           K = K + 1
                           IF (TD(LA,LIF,LP,1,IP).LE.0.0) THEN
                              J = J + 1
                           ELSE
                              DO 428 IT = 1,5
                                 IF (PR(LP,LIF,LA,IT).GT.0.0) THEN
                                    W = ABS (TD(LA,LIF,LP,IT,IP) -
     *                                 PP(LP,LIF,LA,IT)) /
     *                                 PR(LP,LIF,LA,IT)
                                    IF (W.GT.5.0) NOFIVE(IT) =
     *                                 NOFIVE(IT) + 1
                                    IF (W.GT.10.) NOFTEN(IT) =
     *                                 NOFTEN(IT) + 1
                                    END IF
 428                             CONTINUE
                              END IF
                           END IF
                        END IF
 430                 CONTINUE
                  IF ((PRTLEV.GE.1) .AND. (PRINT.NE.' ') .AND.
     *               (DOCRT.NE.0)) THEN
                     I = NOFIVE(1) + NOFIVE(2) + NOFIVE(3) + NOFIVE(4) +
     *                  NOFIVE(5) + J
                     IF (I.GT.0) THEN
                        WRITE (LINE,1430) LIF, LP, LA, K, (NOFIVE(I),
     *                     NOFTEN(I), I = 1,5), J
                        CALL PRTWRI (PRINT, LINE, QUIT, IERR)
                        IF (IERR.NE.0) GO TO 990
                        IF (QUIT) DOCRT = 0
                        END IF
                     END IF
 440              CONTINUE
 450           CONTINUE
 460        CONTINUE
         CALL RFILL (12, 0.0, NOVER)
C                                       page titles
         IF ((PRTLEV.GE.1) .AND. (PRINT.NE.' ') .AND. (DOCRT.NE.0)) THEN
            LINE = ' '
            CALL PRTWRI (PRINT, LINE, QUIT, IERR)
            IF (QUIT) DOCRT = 0
            IF (IERR.NE.0) GO TO 990
            LINE = 'Number samples more than 10 and 20 sigma from '
     *         // 'overall mean by type and orphan samples'
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
            LINE = 'IF P An Total  Vector amp  Vector rms '
     *         // ' Scalar amp  Scalar rms      Weight  Orphans'
            DIM(1) = LEN (LINE)
            DIM(2) = 1
            CALL OPUT (PRINT, 'TITLE1', OOACAR, DIM, IDUM, LINE, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
            IF (OPTYPE.EQ.'GAIN') THEN
               LINE = 'All sources'
            ELSE
               LINE = SUNAME(LS)
               END IF
            LINE(20:) = '10  20'
            LINE(32:) = '10  20'
            LINE(44:) = '10  20'
            LINE(56:) = '10  20'
            LINE(68:) = '10  20'
            CALL OPUT (PRINT, 'TITLE2', OOACAR, DIM, IDUM, LINE, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
            END IF
         DO 490 LIF = 1,CIF
            DO 485 LP = 1,CPOL
               DO 480 LA = 1,CANT
                  CALL FILL (5, 0, NOFIVE)
                  CALL FILL (5, 0, NOFTEN)
                  K = 0
                  J = 0
                  DO 475 IP = 1,MTIME
                     IF (OPTYPE.EQ.'GAIN') LS = SNUMS(IP)
                     IF (SNUMS(IP).EQ.LS) THEN
                        IF (TD(LA,LIF,LP,1,IP).NE.FBLANK) THEN
                           K = K + 1
                           IF (TD(LA,LIF,LP,1,IP).LE.0.0) THEN
                              J = J + 1
                           ELSE
                              DO 470 IT = 1,5
                                 IF (RV(IT).GT.0.0) THEN
                                    W = ABS (TD(LA,LIF,LP,IT,IP)-DV(IT))
     *                                 / RV(IT)
                                    IF (W.GT.10.0) NOFIVE(IT) =
     *                                 NOFIVE(IT) + 1
                                    IF (W.GT.20.) NOFTEN(IT) =
     *                                 NOFTEN(IT) + 1
                                    END IF
 470                             CONTINUE
                              END IF
                           END IF
                        END IF
 475                 CONTINUE
C                                       sum for final return
                  NOVER(1) = NOVER(1) + NOFIVE(1)
                  NOVER(2) = NOVER(2) + NOFIVE(2)
                  NOVER(3) = NOVER(3) + NOFIVE(3)
                  NOVER(4) = NOVER(4) + NOFIVE(4)
                  NOVER(5) = NOVER(5) + NOFIVE(5)
                  NOVER(6) = NOVER(6) + NOFTEN(1)
                  NOVER(7) = NOVER(7) + NOFTEN(2)
                  NOVER(8) = NOVER(8) + NOFTEN(3)
                  NOVER(9) = NOVER(9) + NOFTEN(4)
                  NOVER(10) = NOVER(10) + NOFTEN(5)
                  NOVER(11) = NOVER(11) + J
                  NOVER(12) = NOVER(12) + K
C                                       print
                  IF ((PRTLEV.GE.1) .AND. (PRINT.NE.' ') .AND.
     *               (DOCRT.NE.0)) THEN
                     I = NOFIVE(1) + NOFIVE(2) + NOFIVE(3) + NOFIVE(4) +
     *                  NOFIVE(5) + J
                     IF (I.GT.0) THEN
                        WRITE (LINE,1430) LIF, LP, LA, K, (NOFIVE(I),
     *                     NOFTEN(I), I = 1,5), J
                        CALL PRTWRI (PRINT, LINE, QUIT, IERR)
                        IF (IERR.NE.0) GO TO 990
                        IF (QUIT) DOCRT = 0
                        END IF
                     END IF
 480              CONTINUE
 485           CONTINUE
 490        CONTINUE
C                                       print
         IF ((PRTLEV.GE.1) .AND. (PRINT.NE.' ') .AND. (DOCRT.NE.0)) THEN
            J = NOVER(11) + 0.01
            K = NOVER(12) + 0.01
            NOFIVE(1) = NOVER(1) + 0.01
            NOFIVE(2) = NOVER(2) + 0.01
            NOFIVE(3) = NOVER(3) + 0.01
            NOFIVE(4) = NOVER(4) + 0.01
            NOFIVE(5) = NOVER(5) + 0.01
            NOFTEN(1) = NOVER(6) + 0.01
            NOFTEN(2) = NOVER(7) + 0.01
            NOFTEN(3) = NOVER(8) + 0.01
            NOFTEN(4) = NOVER(9) + 0.01
            NOFTEN(5) = NOVER(10) + 0.01
            WRITE (LINE,1430) LIF, LP, LA, K, (NOFIVE(I), NOFTEN(I),
     *         I = 1,5), J
            LINE(1:7) = 'Totals '
            CALL PRTWRI (PRINT, LINE, QUIT, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (QUIT) DOCRT = 0
            END IF
C                                       print closure info
         IF (FRATOT.LE.0.0) FRATOT = 1.0
         DO 494 J = 1,12
            FRACNT(J) = FRACNT(J) / FRATOT
            IF ((J.GE.2) .AND. (J.LE.11)) ARRAY2(9+J,1) = FRACNT(J)
 494        CONTINUE

         IF ((PRTLEV.GE.1) .AND. (PRINT.NE.' ') .AND. (DOCRT.NE.0)) THEN
            LINE = ' '
            CALL PRTWRI (PRINT, LINE, QUIT, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (QUIT) DOCRT = 0
            IF (DOCRT.NE.0) THEN
               LINE = 'Fraction of closure error in range:'
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (IERR.NE.0) GO TO 990
               IF (QUIT) DOCRT = 0
               END IF
            IF (DOCRT.NE.0) THEN
               WRITE (LINE,1494) 0.0, FRACNT(1)
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (IERR.NE.0) GO TO 990
               IF (QUIT) DOCRT = 0
               END IF
            DO 495 J = 2,11
               IF (DOCRT.NE.0) THEN
                  AMP = 0.1 * (J-2)
                  RMS = AMP + 0.1
                  WRITE (LINE,1495) AMP, RMS, FRACNT(J)
                  CALL PRTWRI (PRINT, LINE, QUIT, IERR)
                  IF (IERR.NE.0) GO TO 990
                  IF (QUIT) DOCRT = 0
                  END IF
 495           CONTINUE
            IF (DOCRT.NE.0) THEN
               WRITE (LINE,1494) 1.0, FRACNT(12)
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (IERR.NE.0) GO TO 990
               IF (QUIT) DOCRT = 0
               END IF
            END IF
C                                       store away the answers for AIPS
         IF (XS.EQ.1) THEN
            AVODIM(1) = 20
            AVODIM(2) = 2
            AVODIM(3) = 1
            CALL RCOPY (40, ARRAY2, RDUM)
            CALL OPUT (OUTPUT, AVONAM(1), OOARE, AVODIM, IDUM, CDUMMY,
     *         IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
 500     CONTINUE
C-----------------------------------------------------------------------
C                                       Close file
      CALL OUVCLO (UVIN, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (.NOT.DOCAT) THEN
         CALL TABZAP (XXFILE, IERR)
         XXFILE = ' '
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       Close printer
      IF (PRINT.NE.' ') THEN
         CALL OCLOSE (PRINT, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       Delete temporary table
      IF (DOSOU) THEN
         CALL DESTRY (SUTAB, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  MSGTXT = 'ANTIME: ERROR IN DATA VALUE FINDING FOR ' // UVIN
      CALL MSGWRT (7)
      IF ((.NOT.DOCAT) .AND. (XXFILE.NE.' ')) CALL TABZAP (XXFILE, I)
C
 999  RETURN
C-----------------------------------------------------------------------
 1200 FORMAT ('READ',I6,' TIMES, WILL DO ONLY',I5)
 1220 FORMAT ('Scale ',A,':',I5.5,' by rel flux',F10.5)
 1310 FORMAT (I2,I3,I2,I5,F11.5,F9.5,F11.5,F9.5,1PE11.3,0PF7.4)
 1390 FORMAT ('Overall av ',A,'=',1PE10.3,' +-',1PE10.3,1X,A,1X,A)
 1391 FORMAT (A,' =',1PE12.3,'  +-',1PE11.3,4X,A,1X,A)
 1400 FORMAT (I2,I2,I3,F7.3,3F7.4,F7.3,3F7.4,1X,2(1PE10.3))
 1430 FORMAT (I2,I2,I3,I6,5(2X,I6,I4),I9)
 1494 FORMAT ('Equal ',F4.1,F9.6)
 1495 FORMAT (F4.1,' -',F4.1,F9.6)
      END
      SUBROUTINE AVERAG (NC, VIS, INCF, ANT1, ANT2, AONLY, DOROBU,
     *   NP, WP, SP, SSP)
C-----------------------------------------------------------------------
C   AVERAG does normal or robust average of a spectrum
C   Inputs:
C      NC       I        Number channels
C      VIS      R(3,*)   Visibilities
C      INCF     I        Increment between frequencies in vis
C      ANT1     I        Antenna 1 number
C      ANT2     I        Antenna 2 number
C      AONLY    L        Do amplitude only
C      DOROBU   L        Do robust average
C   Outputs:
C      NP       I(2)     Count of included samples
C      WP       R(2)     Sum of weights
C      SP       R(2)     weighted sum (amp or Re/Im)
C      SSP      R(2)     weighted sum square (of amp or of Re/Im)
C-----------------------------------------------------------------------
      INTEGER   NC, INCF, ANT1, ANT2, NP(2)
      REAL      VIS(3,*), WP(2), SP(2), SSP(2)
      LOGICAL   AONLY, DOROBU
C
      INTEGER   I, J, ITER, NITER, NR, NI
      REAL      W, FACT(7)
      DOUBLE PRECISION SUMR, SUMI, SUMRS, SUMIS, WR, WI, AVR, AVI, RMR,
     *   RMI, AMP
      DATA FACT /6.0, 5.0, 4.0, 3.5, 3.1, 2.7, 3.0/
C-----------------------------------------------------------------------
      NITER = 1
      IF (DOROBU) NITER = 7
C                                       iterate
      AVR = 0.0D0
      AVI = 0.0D0
      RMR = 1.0D10
      RMI = 1.0D10
      IF ((AONLY) .OR. (ANT1.EQ.ANT2)) THEN
         DO 20 ITER = 1,NITER
            NR = 0
            SUMR = 0.0D0
            SUMRS = 0.0D0
            WR = 0.0D0
            J = 1 - INCF
            DO 10 I = 1,NC
               J = J + INCF
               W = VIS(3,J)
               IF (W.GT.0) THEN
                  IF (AONLY) THEN
                     AMP = SQRT (VIS(1,J)*VIS(1,J) + VIS(2,J)*VIS(2,J))
                  ELSE
                     AMP = VIS(1,J)
                     END IF
                  IF (ABS(AMP-AVR).LT.RMR) THEN
                     NR = NR + 1
                     WR = WR + W
                     SUMR = SUMR + W * AMP
                     SUMRS = SUMRS + W * AMP * AMP
                     END IF
                  END IF
 10            CONTINUE
            IF (NR.GT.0) THEN
               AVR = SUMR / WR
               RMR = SUMRS / WR - AVR * AVR
               RMR = SQRT (MAX (0.0D0, RMR)) * FACT(ITER)
               END IF
            IF ((NR.LT.3) .OR. (RMR.LE.0.0D0)) GO TO 25
 20         CONTINUE
 25      NP(1) = NR
         NP(2) = 0
         WP(1) = WR
         WP(2) = 0.
         SP(1) = SUMR
         SP(2) = 0.
         SSP(1) = SUMRS
         SSP(2) = 0.
      ELSE
         DO 40 ITER = 1,NITER
            NR = 0
            NI = 0
            SUMR = 0.0D0
            SUMI = 0.0D0
            SUMRS = 0.0D0
            SUMIS = 0.0D0
            WR = 0.0D0
            WI = 0.0D0
            J = 1 - INCF
            DO 30 I = 1,NC
               J = J + INCF
               W = VIS(3,J)
               IF (W.GT.0) THEN
                  IF (ABS(VIS(1,J)-AVR).LT.RMR) THEN
                     NR = NR + 1
                     WR = WR + W
                     SUMR = SUMR + W * VIS(1,J)
                     SUMRS = SUMRS + W * VIS(1,J) * VIS(1,J)
                     END IF
                  IF (ABS(VIS(2,J)-AVI).LT.RMI) THEN
                     NI = NI + 1
                     WI = WI + W
                     SUMI = SUMI + W * VIS(2,J)
                     SUMIS = SUMIS + W * VIS(2,J) * VIS(2,J)
                     END IF
                  END IF
 30            CONTINUE
            IF ((NR.GT.0) .AND. (NI.GT.0)) THEN
               AVR = SUMR / WR
               RMR = SUMRS / WR - AVR * AVR
               RMR = SQRT (MAX (0.0D0, RMR)) * FACT(ITER)
               AVI = SUMI / WI
               RMI = SUMIS / WI - AVI * AVI
               RMI = SQRT (MAX (0.0D0, RMI)) * FACT(ITER)
               END IF
            IF ((NR.LT.3) .OR. (RMR.LE.0.0D0)) GO TO 45
            IF ((NI.LT.3) .OR. (RMI.LE.0.0D0)) GO TO 45
 40         CONTINUE
 45      NP(1) = NR
         NP(2) = NI
         WP(1) = WR
         WP(2) = WI
         SP(1) = SUMR
         SP(2) = SUMI
         SSP(1) = SUMRS
         SSP(2) = SUMIS
         END IF
C
 999  RETURN
      END
      SUBROUTINE AMVDIF (UVIN, PRINT, OUTPUT, CANT, CIF, CPOL, CCHAN,
     *   CTIME, SUM, SUMWT, COUNT, WORK, ANTD, AMPS, DIFS, WTS, REFAS,
     *   FRAS, WORKS, IERR)
C-----------------------------------------------------------------------
C   Look for bad data via amplitude of the vector difference of the
C   current sample from a running mean of the samples
C   Inputs:
C      UVIN      C*?   Name of input uvdata object.
C      PRINT     C*?   Print object
C      OUTPUT    C*?   Output parameter object
C      CANT      I     Maximum antenna number
C      CPOL      I     Number of polarizations
C      CIF       I     Number of IFs
C      CCHAN     I     Number of spactral channels
C      CTIME     I     Limit on number of times
C   Scratch variables
C      SUM, SUMSQ, SUMWT, COUNT, AMPS, DIFS
C      Note AMPS, DIFS, WTS cannot be used when
C           SUM, WORK, SUMWT, COUNT are being used
C   Inputs attached to UVIN:
C      MAXRMS    R(*)  Maximum RMS allowed, constant plus amplitude
C                      coefficient.
C      MAXBAD    R(2)  Maximum allowed fraction of bad baselines.
C      TIMEAVG   R     Time in seconds for clipping interval
C      DOIFS     L     Flag all IFs if one bad
C      DOSTOKES  L     Flas all Stokes if 1 bad
C      AMPONLY   L     Use amplitude not Real/Imag
C      KILLONES  L     Kill 1-sample integrations
C      PRTLEV    I     Print level for debugging
C   Output:
C      IERR      I     Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER UVIN*(*), PRINT*(*), OUTPUT*(*)
      INTEGER   CANT, CIF, CPOL, CCHAN, CTIME, IERR
      INTEGER   COUNT(CANT,CANT,CIF,CPOL), REFAS(CIF,CPOL,*)
      REAL      SUM(CANT,CANT,CIF,CPOL), WORK(CANT,CANT,CIF,CPOL),
     *   SUMWT(CANT,CANT,CIF,CPOL), ANTD(CANT,CIF,CPOL,6),
     *   AMPS(CANT,CIF,CPOL,*), DIFS(CANT,CIF,CPOL,*),
     *   WTS(CANT,CIF,CPOL,*), FRAS(CANT,CIF,CPOL,*), WORKS(*)
C
      REAL      TCLIP, SCNTIM
      LOGICAL   DOCAT
      INTEGER   PRTLEV, REFANT
C
      INTEGER   NSORC, NTIME
      PARAMETER (NSORC = 5000, NTIME = 15001)
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   TYPE, DIM(7), ANT1, ANT2, ENDVIS, VISNO, CURSOU, THISOU,
     *   TBVER,DOCRT, I, J, LS, NACROS, ILOCU, ILOCV, ILOCW, ILOCT,
     *   ILOCB, ILOCSU, ILOCFQ, ILOCA1, ILOCA2, ILOCSA, JLOCC, JLOCS,
     *   JLOCF, JLOCR, JLOCD, JLOCIF, LA, INCS, INCF, INCIF, LP, LIF,
     *   IP, THISUB, THIFRQ, CURSUB, CURFRQ, NZERO, XXROW, NP, KP, K,
     *   JJ, SNUMS(NTIME), MTIME, SINUM(NSORC), SCOUNT, QUAL, MINNO,
     *   BADANT(MAXANT), NREF(MAXIF*2), MODE, NREFS(MAXANT), KP1, KP2,
     *   LIST(NTIME), AVODIM(3), NOTEN(3), NOTWEN(3), NPP(2)
      LOGICAL   DONE, DOSOU, QUIT, DOROBU
      CHARACTER SUTAB*32, SUNAME*16, LINE*132, CDUMMY*1, XXFILE*32,
     *   DTYPE(5)*10
      REAL      RP(50), TEPS, CURTIM, LSTIME, ENDTIM, BEGTIM,
     *   VIS(3,MAXCIF), TIMR(2,NTIME), RE(NTIME), IM(NTIME), TI(NTIME),
     *   MERE, MEIM, MEDIUM, SCNT2, ARRAY2(20,2), FRAC(MAXANT,MAXIF,2),
     *   FRACNT(12), FRATOT, MEDIAN, WP(2), SP(2), SPP(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      COMMON /TBUFS/ TIMR, RE, IM, TI, SNUMS, LIST
      INCLUDE 'GFORT'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'OUTPUTDATA.INC'
      DATA DTYPE /'Amplitude', 'Vector dif', ' ', ' ', 'Weight'/
C-----------------------------------------------------------------------
      XXFILE = ' '
      TEPS = 0.02 / (3600.0 * 24.0)
      SCOUNT = 0
      MINNO = 3
      MODE = 10
C                                       Open printer
      IF (PRINT.NE.' ') THEN
         CALL OOPEN (PRINT, 'WRIT', IERR)
         IF (IERR.NE.0) GO TO 990
         CALL OGET (PRINT, 'DOCRT', TYPE, DIM, IDUM, CDUMMY, IERR)
         DOCRT = IDUM(1)
         IF (IERR.NE.0) GO TO 990
         CALL OGET (PRINT, 'NACROS', TYPE, DIM, IDUM, CDUMMY, IERR)
         NACROS = IDUM(1)
         IF (IERR.NE.0) GO TO 990
      ELSE
         DOCRT = 0
         END IF
      THISOU = 0
      THISUB = 0
      THIFRQ = 0
      CURSUB = 0
      CURFRQ = 0
C                                       Create and open a scratch table:
      XXFILE = 'Temporary results table'
      CALL UV2TAB (UVIN, XXFILE, 'XX', 1, IERR)
      IF (IERR.NE.0) THEN
         XXFILE = ' '
         GO TO 990
         END IF
      CALL OXXINI (XXFILE, 'WRIT', XXROW, IERR)
      IF (IERR.NE.0) THEN
         XXFILE = ' '
         GO TO 990
         END IF
C                                       Retrieve pointers into the data:
      CALL UVDPNT (UVIN, ILOCU, ILOCV, ILOCW, ILOCT, ILOCB, ILOCSU,
     *   ILOCFQ, ILOCA1, ILOCA2, ILOCSA, JLOCC, JLOCS, JLOCF, JLOCR,
     *   JLOCD, JLOCIF, INCS, INCF, INCIF, IERR)
      IF (IERR.NE.0) GO TO 999
      INCS = INCS / 3
      INCF = INCF / 3
      INCIF = INCIF / 3
C                                       Open input.
      CALL OUVOPN (UVIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Get parameters
      CALL OUVGET (UVIN, 'DOROBUST', TYPE, DIM, IDUM, CDUMMY, IERR)
      DOROBU = LDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OUVGET (UVIN, 'REFANT', TYPE, DIM, IDUM, CDUMMY, IERR)
      REFANT = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      IF (REFANT.LE.0) REFANT = 1
      CALL OUVGET (UVIN, 'DOCAT', TYPE, DIM, IDUM, CDUMMY, IERR)
      DOCAT = LDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OUVGET (UVIN, 'PRTLEV', TYPE, DIM, IDUM, CDUMMY, IERR)
      PRTLEV = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OUVGET (UVIN, 'SCANLENG', TYPE, DIM, IDUM, CDUMMY, IERR)
      SCNTIM = RDUM(1)
      IF (IERR.NE.0) GO TO 990
      SCNTIM = SCNTIM / 86400.0
      SCNT2 = SCNTIM / 2.0
      CALL OUVGET (UVIN, 'TIMEAVG', TYPE, DIM, IDUM, CDUMMY, IERR)
      TCLIP = RDUM(1)
      IF (IERR.NE.0) GO TO 990
      TCLIP = TCLIP / 86400.0
C                                       Processing info
      DOSOU = (ILOCSU.GT.0)
C                                       Source table/name
      IF (DOSOU) THEN
         SUTAB = 'SoUrce table for ANTIME'
         TBVER = 1
         CALL UV2TAB (UVIN, SUTAB, 'SU', TBVER, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       For single source use 'OBJECT'
      ELSE
         CALL UVDGET (UVIN, 'OBJECT', TYPE, DIM, IDUM, SUNAME, IERR)
         IF (IERR.NE.0) GO TO 990
         QUAL = 0
         END IF
C                                       Clear accumulators:
      NZERO = CANT * CANT * CIF * CPOL
      CALL RFILL (NZERO, 0.0, SUM)
      CALL RFILL (NZERO, 0.0, SUMWT)
      CALL FILL (NZERO, 0, COUNT)
C                                       Initialize visibility count
      DONE = .FALSE.
      VISNO = 0
C                                       Swallow input collecting
C                                       statistics.
C                                       Loop thru data
 100     CALL UVREAD (UVIN, RP, VIS, IERR)
         IF (IERR.LT.0) THEN
            DONE = .TRUE.
            IERR = 0
            END IF
         IF (IERR.GT.0) GO TO 990
         VISNO = VISNO + 1
 110     CURTIM = RP(ILOCT)
         IF (DOSOU) THEN
            CURSOU = RP(ILOCSU) + 0.5
         ELSE
            CURSOU = 0
            END IF
         IF (ILOCFQ.GT.0) CURFRQ = RP(ILOCFQ) + 0.5
C                                       Get antenna numbers
         IF (ILOCB.GT.0) THEN
            ANT1 = (RP(ILOCB) / 256.0) + 0.001
            ANT2 = (RP(ILOCB) - ANT1 * 256) + 0.001
            CURSUB = (RP(ILOCB) - 256 * ANT1 - ANT2) * 100.0 + 1.1
         ELSE
            ANT1 = RP(ILOCA1) + 0.001
            ANT2 = RP(ILOCA2) + 0.001
            CURSUB = RP(ILOCSA) + 0.001
            END IF
C                                       Initial selection.
         IF (VISNO.EQ.1) THEN
            THIFRQ = CURFRQ
            THISUB = CURSUB
            THISOU = CURSOU
            BEGTIM = CURTIM
            ENDTIM = CURTIM + TCLIP
            END IF
C                                       Finished with data or interval?
         IF (DONE .OR. (CURTIM.GT.ENDTIM) .OR. (CURSOU.NE.THISOU)
     *      .OR. (CURSUB.NE.THISUB)) GO TO 150
C                                       Set last vis of interval
         ENDVIS = VISNO
C                                       Set last time
         LSTIME = CURTIM
C                                       Baseline index
         DO 130 LP = 1,CPOL
            DO 125 LIF = 1,CIF
               IP = (LP-1) * INCS + (LIF-1) * INCIF + 1
               CALL AVERAG (CCHAN, VIS(1,IP), INCF, ANT1, ANT2, .FALSE.,
     *            DOROBU, NPP, WP, SP, SPP)
               COUNT(ANT1,ANT2,LIF,LP) = COUNT(ANT1,ANT2,LIF,LP) +
     *            NPP(1)
               SUMWT(ANT1,ANT2,LIF,LP) = SUMWT(ANT1,ANT2,LIF,LP) +
     *            WP(1)
               SUM(ANT1,ANT2,LIF,LP) = SUM(ANT1,ANT2,LIF,LP) + SP(1)
               COUNT(ANT2,ANT1,LIF,LP) = COUNT(ANT2,ANT1,LIF,LP) +
     *            NPP(2)
               SUMWT(ANT2,ANT1,LIF,LP) = SUMWT(ANT2,ANT1,LIF,LP) +
     *            WP(2)
               SUM(ANT2,ANT1,LIF,LP) = SUM(ANT2,ANT1,LIF,LP) + SP(2)
 125           CONTINUE
 130        CONTINUE
C                                       Next vis until done
         IF (.NOT.DONE) GO TO 100
 150     IERR = 0
C                                       Average and square
       DO 170 LIF = 1,CIF
          DO 165 LP = 1,CPOL
             CALL FILL (CANT, 0, BADANT)
             DO 160 ANT2 = 1,CANT
               DO 155 ANT1 = 1,CANT
                  IF (SUMWT(ANT1,ANT2,LIF,LP).GT.0.0) THEN
                     SUM(ANT1,ANT2,LIF,LP) = SUM(ANT1,ANT2,LIF,LP)
     *                  / SUMWT(ANT1,ANT2,LIF,LP)
                     SUMWT(ANT1,ANT2,LIF,LP) = (SUMWT(ANT1,ANT2,LIF,LP)
     *                  / COUNT(ANT1,ANT2,LIF,LP)) ** 2
                  ELSE
                     SUMWT(ANT1,ANT2,LIF,LP) = FBLANK
                     SUM(ANT1,ANT2,LIF,LP) = FBLANK
                     END IF
 155              CONTINUE
 160           CONTINUE
C                                       solve for antenna weight**2
            CALL ASOLVE (PRTLEV, 'rms', BEGTIM, LSTIME, CANT, 3.0,
     *         SUMWT(1,1,LIF,LP), ANTD(1,LIF,LP,3), FRAC)
C                                       solve for antenna real/imag
            KP = (LP - 1) * CIF + LIF
            CALL VSOLVE (SUM(1,1,LIF,LP), SUMWT(1,1,LIF,LP), CANT,
     *         REFANT, MODE, MINNO, 2.5, ANTD(1,LIF,LP,1),
     *         ANTD(1,LIF,LP,2), NREF(KP), ANTD(1,LIF,LP,6), WORK,
     *         PRTLEV, IERR)
 165        CONTINUE
 170     CONTINUE
C                                       local source number
      J = 0
      DO 175 I = 1,SCOUNT
         IF (THISOU.EQ.SINUM(I)) J = I
 175     CONTINUE
      IF (J.EQ.0) THEN
         SCOUNT = SCOUNT + 1
         J = SCOUNT
         SINUM(J) = THISOU
         END IF
C                                       write to scratch table
C                                       ???????
      CALL OTABXX (XXFILE, 'WRIT', XXROW, BEGTIM, LSTIME, J,
     *   ANTD(1,1,1,1), ANTD(1,1,1,2), ANTD(1,1,1,3), ANTD(1,1,1,4),
     *   WORKS, ANTD(1,1,1,6), NREF, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Clear accumulators:
      CALL RFILL (NZERO, 0.0, SUM)
      CALL RFILL (NZERO, 0.0, SUMWT)
      CALL FILL (NZERO, 0, COUNT)
C                                       Another clipping interval?
      IF (.NOT.DONE) THEN
         THISOU = CURSOU
         BEGTIM = CURTIM
         ENDTIM = CURTIM + TCLIP
         THIFRQ = CURFRQ
         THISUB = CURSUB
         GO TO 110
         END IF
C-----------------------------------------------------------------------
C                                       Okay - close table and re-read
C                                       to fill memory
      CALL TABCLO (XXFILE, IERR)
      IF (IERR.NE.0) GO TO 990
      MTIME = XXROW - 1
      IF ((MTIME.GT.CTIME) .OR. (MTIME.GT.NTIME)) THEN
         LP = MIN (NTIME, CTIME)
         WRITE (MSGTXT,1200) MTIME, LP
         CALL MSGWRT (7)
         MTIME = LP
         END IF
      CALL OXXINI (XXFILE, 'READ', XXROW, IERR)
      IF (IERR.NE.0) GO TO 999
      DO 200 IP = 1,MTIME
C                                       ?????????????????
         CALL OTABXX (XXFILE, 'READ', XXROW, TIMR(1,IP), TIMR(2,IP),
     *      SNUMS(IP), AMPS(1,1,1,IP), DIFS(1,1,1,IP), WTS(1,1,1,IP),
     *      WORKS, WORKS, FRAS(1,1,1,IP), REFAS(1,1,IP), IERR)
         IF (IERR.NE.0) GO TO 990
 200     CONTINUE
      CALL TABCLO (XXFILE, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL RFILL (12, 0.0, FRACNT)
      FRATOT = 0.0
C                                       outer loops: antenna, source
      DO 500 LS = 1,SCOUNT
C                                       Get source name, qualifier
         THISOU = SINUM(LS)
         IF (DOSOU) THEN
            CALL SOUNFO (SUTAB, THISOU, 'SOURCE', TYPE, DIM, JJ,
     *         SUNAME, IERR)
            IF (IERR.NE.0) GO TO 990
            CALL SOUNFO (SUTAB, THISOU, 'QUAL', TYPE, DIM, QUAL,
     *         CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
C                                       Compute amp vect diff in DIFS
C                                       Compute amp in AMPS
         DO 280 LIF = 1,CIF
            DO 270 LP = 1,CPOL
C                                       See about re-referencing
               CALL FILL (CANT, 0, NREFS)
               DO 210 IP = 1,MTIME
                  IF (SNUMS(IP).EQ.LS) THEN
                     LA = REFAS(LIF,LP,IP)
                     IF ((LA.GT.0) .AND. (LA.LE.CANT)) NREFS(LA) =
     *                  NREFS(LA) + 1
                     END IF
 210              CONTINUE
               REFANT = 0
               I = 0
               J = 0
               DO 220 LA = 1,CANT
                  IF (NREFS(LA).GT.I) THEN
                     REFANT = LA
                     I = NREFS(LA)
                     END IF
                  IF (NREFS(LA).GT.0) J = J + 1
 220              CONTINUE
C                                       re-referencing required
               IF ((REFANT.GT.0) .AND. (J.GT.1)) THEN
                  DO 230 LA = 1,CANT
                     IF ((NREFS(LA).GT.0) .AND. (LA.NE.REFANT))
     *                  CALL REREF (CANT, CIF, CPOL, MTIME, LIF, LP, LS,
     *                  REFANT, LA, SNUMS, TIMR, AMPS, DIFS, REFAS)
 230                 CONTINUE
                  END IF
C                                       do vect difference
               DO 260 LA = 1,CANT
C                                       list points
                  NP = 0
                  DO 240 IP = 1,MTIME
                     IF (SNUMS(IP).EQ.LS) THEN
                        IF ((AMPS(LA,LIF,LP,IP).NE.FBLANK) .AND.
     *                     (DIFS(LA,LIF,LP,IP).NE.FBLANK)) THEN
                           NP = NP + 1
                           TI(NP) = (TIMR(1,IP) + TIMR(2,IP)) / 2.0
                           RE(NP) = AMPS(LA,LIF,LP,IP)
                           IM(NP) = DIFS(LA,LIF,LP,IP)
                           LIST(NP) = IP
                           END IF
                        END IF
 240                 CONTINUE
C                                       finally do it
                  DO 250 KP = 1,NP
C                                       find range of points
                     KP1 = KP
                     KP2 = KP
 245                 IF ((KP1.GT.1) .AND. (TI(KP)-TI(KP1-1).LE.SCNT2))
     *                  THEN
                        KP1 = KP1 - 1
                        GO TO 245
                        END IF
 246                 IF ((KP2.LT.NP) .AND.
     *                  (TI(KP2+1)-TI(KP1).LE.SCNTIM)) THEN
                        KP2 = KP2 + 1
                        GO TO 246
                        END IF
                     I = KP2 - KP1 + 1
C                                       vector diff and amp
                     MERE = MEDIUM (RE(KP1), IM(KP1), I)
                     MEIM = MEDIUM (IM(KP1), RE(KP1), I)
                     IP = LIST(KP)
                     DIFS(LA,LIF,LP,IP) = SQRT ((RE(KP)-MERE)**2 +
     *                  (IM(KP)-MEIM)**2)
                     AMPS(LA,LIF,LP,IP) = SQRT (RE(KP)**2 + IM(KP)**2)
 250                 CONTINUE
 260              CONTINUE
 270           CONTINUE
 280        CONTINUE
C                                       use robust to get average amp
         CALL RFILL (40, 0.0, ARRAY2)
         KP = 0
         DO 320 IP = 1,MTIME
            IF (SNUMS(IP).EQ.LS) THEN
               DO 315 LP = 1,CPOL
                  DO 310 LIF = 1,CIF
                     DO 305 LA = 1,CANT
                        IF (AMPS(LA,LIF,LP,IP).NE.FBLANK) THEN
                           KP = KP + 1
                           WORKS(KP) = AMPS(LA,LIF,LP,IP)
C                                       closure ststs
                           IF (FRAS(LA,LIF,LP,IP).NE.FBLANK) THEN
                              IF (FRAS(LA,LIF,LP,IP).LE.0.0) THEN
                                 JJ = 1
                              ELSE
                                 JJ = FRAS(LA,LIF,LP,IP) / 0.1 + 2
                                 JJ = MIN (JJ, 12)
                                 END IF
                              FRATOT = FRATOT + 1.0
                              FRACNT(JJ) = FRACNT(JJ) + 1.0
                              END IF
                           END IF
 305                    CONTINUE
 310                 CONTINUE
 315              CONTINUE
               END IF
 320        CONTINUE
         MERE = MEDIUM (WORKS, WORKS, KP)
         ARRAY2(1,2) = MERE
         CALL ROBUST (WORKS, KP, ARRAY2(1,1), ARRAY2(6,1))
C                                       rms
         DO 325 IP = 1,KP
            IF (WORKS(IP).NE.0.0) WORKS(IP) = ABS (WORKS(IP) - MERE)
 325        CONTINUE
         MEIM = MEDIAN (KP, WORKS)
         ARRAY2(6,2) = 1.5 * SQRT (2.0) * MEIM
C                                       use median to get average dif
         KP = 0
         DO 350 IP = 1,MTIME
            IF (SNUMS(IP).EQ.LS) THEN
               DO 345 LP = 1,CPOL
                  DO 340 LIF = 1,CIF
                     DO 335 LA = 1,CANT
                        IF (DIFS(LA,LIF,LP,IP).NE.FBLANK) THEN
                           KP = KP + 1
                           WORKS(KP) = DIFS(LA,LIF,LP,IP)
                           END IF
 335                    CONTINUE
 340                 CONTINUE
 345              CONTINUE
               END IF
 350        CONTINUE
         MERE = MEDIAN (KP, WORKS)
         ARRAY2(2,2) = MERE
         CALL ROBUST (WORKS, KP, ARRAY2(2,1), ARRAY2(7,1))
C                                       rms
         DO 355 IP = 1,KP
            WORKS(IP) = ABS (WORKS(IP) - MERE)
 355        CONTINUE
         MEIM = MEDIAN (KP, WORKS)
         ARRAY2(7,2) = 1.5 * SQRT (2.0) * MEIM
C                                       use median to get average wt
         KP = 0
         DO 380 IP = 1,MTIME
            IF (SNUMS(IP).EQ.LS) THEN
               DO 375 LP = 1,CPOL
                  DO 370 LIF = 1,CIF
                     DO 365 LA = 1,CANT
                        IF ((WTS(LA,LIF,LP,IP).NE.FBLANK) .AND.
     *                     (WTS(LA,LIF,LP,IP).GT.0.0)) THEN
                           KP = KP + 1
                           WORKS(KP) = WTS(LA,LIF,LP,IP)
                           END IF
 365                    CONTINUE
 370                 CONTINUE
 375              CONTINUE
               END IF
 380        CONTINUE
         MERE = MEDIUM (WORKS, WORKS, KP)
         ARRAY2(5,2) = MERE
         CALL ROBUST (WORKS, KP, ARRAY2(5,1), ARRAY2(10,1))
C                                       rms
         DO 385 IP = 1,KP
            IF (WORKS(IP).NE.0.0) WORKS(IP) = ABS (WORKS(IP) - MERE)
 385        CONTINUE
         MEIM = MEDIAN (KP, WORKS)
         ARRAY2(10,2) = 1.5 * SQRT (2.0) * MEIM
C                                       Median estimates discarded
C                                       print summary
         IF (PRINT.NE.' ') THEN
            LINE = ' '
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
            LINE = 'Overall robust-estimated averages for ' //
     *         SUNAME
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
            DO 360 I = 1,5
               WRITE (LINE,1385) DTYPE(I), ARRAY2(I,1), ARRAY2(I+5,1)
               IF ((ARRAY2(I,1).GT.0.0) .AND. (DOCRT.NE.0)) THEN
                  CALL PRTWRI (PRINT, LINE, QUIT, IERR)
                  IF (QUIT) DOCRT = 0
                  IF (IERR.NE.0) GO TO 990
                  END IF
 360           CONTINUE
            END IF
C                                       page titles
         CALL RFILL (20, 0.0, ARRAY2(1,2))
         IF ((PRTLEV.GE.1) .AND. (PRINT.NE.' ') .AND. (DOCRT.NE.0)) THEN
            LINE = ' '
            CALL PRTWRI (PRINT, LINE, QUIT, IERR)
            IF (QUIT) DOCRT = 0
            IF (IERR.NE.0) GO TO 990
            LINE = 'Number samples more than 10 and 20 sigma from '
     *         // 'overall mean by type'
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
            LINE = 'IF P An   Total    Vector amp    Vector dif '
     *         // '       Weight'
            DIM(1) = LEN (LINE)
            DIM(2) = 1
            CALL OPUT (PRINT, 'TITLE1', OOACAR, DIM, IDUM, LINE, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
            LINE = SUNAME
            LINE(20:) = 'X 10  X 20'
            LINE(34:) = 'X 10  X 20'
            LINE(48:) = 'X 10  X 20'
            CALL OPUT (PRINT, 'TITLE2', OOACAR, DIM, IDUM, LINE, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (DOCRT.NE.0) THEN
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (QUIT) DOCRT = 0
               IF (IERR.NE.0) GO TO 990
               END IF
            END IF
C                                       number 10, 20 * rms
         DO 420 LP = 1,CPOL
            DO 415 LIF = 1,CIF
               DO 410 LA = 1,CANT
                  K = 0
                  J = 0
                  CALL FILL (3, 0, NOTEN)
                  CALL FILL (3, 0, NOTWEN)
                  DO 405 IP = 1,MTIME
                     IF (SNUMS(IP).EQ.LS) THEN
                        IF (AMPS(LA,LIF,LP,IP).NE.FBLANK) THEN
                           K = K + 1
                           IF (ABS(AMPS(LA,LIF,LP,IP)-ARRAY2(1,1))
     *                        .GT.10.0*ARRAY2(6,1)) THEN
                              NOTEN(1) = NOTEN(1) + 1
                              IF (ABS(AMPS(LA,LIF,LP,IP)-ARRAY2(1,1))
     *                           .GT.20.0*ARRAY2(6,1))
     *                           NOTWEN(1) = NOTWEN(1) + 1
                              END IF
                           END IF
                        IF (DIFS(LA,LIF,LP,IP).NE.FBLANK) THEN
                           IF (ABS(DIFS(LA,LIF,LP,IP)-ARRAY2(2,1))
     *                        .GT.10.0*ARRAY2(7,1)) THEN
                              NOTEN(2) = NOTEN(2) + 1
                              IF (ABS(DIFS(LA,LIF,LP,IP)-ARRAY2(2,1))
     *                           .GT.20.0*ARRAY2(7,1))
     *                           NOTWEN(2) = NOTWEN(2) + 1
                              END IF
                           END IF
                        IF ((WTS(LA,LIF,LP,IP).NE.FBLANK) .AND.
     *                     (WTS(LA,LIF,LP,IP).GT.0.0)) THEN
                           IF (ABS(WTS(LA,LIF,LP,IP)-ARRAY2(5,1))
     *                        .GT.10.0*ARRAY2(10,1)) THEN
                              NOTEN(3) = NOTEN(3) + 1
                              IF (ABS(WTS(LA,LIF,LP,IP)-ARRAY2(5,1))
     *                           .GT.20.0*ARRAY2(10,1))
     *                           NOTWEN(3) = NOTWEN(3) + 1
                              END IF
                           END IF
                        END IF
 405                 CONTINUE
                  ARRAY2(1,2) = ARRAY2(1,2) + NOTEN(1)
                  ARRAY2(2,2) = ARRAY2(2,2) + NOTEN(2)
                  ARRAY2(5,2) = ARRAY2(5,2) + NOTEN(3)
                  ARRAY2(6,2) = ARRAY2(6,2) + NOTWEN(1)
                  ARRAY2(7,2) = ARRAY2(7,2) + NOTWEN(2)
                  ARRAY2(10,2) = ARRAY2(10,2) + NOTWEN(3)
                  ARRAY2(12,2) = ARRAY2(12,2) + K
C                                       print
                  IF ((PRTLEV.GE.1) .AND. (PRINT.NE.' ') .AND.
     *               (DOCRT.NE.0)) THEN
                     I = NOTEN(1) + NOTEN(2) + NOTEN(3)
                     IF (I.GT.0) THEN
                        WRITE (LINE,1400) LIF, LP, LA, K, (NOTEN(I),
     *                     NOTWEN(I), I = 1,3)
                        CALL PRTWRI (PRINT, LINE, QUIT, IERR)
                        IF (IERR.NE.0) GO TO 990
                        IF (QUIT) DOCRT = 0
                        END IF
                     END IF
 410              CONTINUE
 415           CONTINUE
 420        CONTINUE
C                                       print
         IF ((PRTLEV.GE.1) .AND. (PRINT.NE.' ') .AND. (DOCRT.NE.0)) THEN
            K = ARRAY2(12,2) + 0.01
            NOTEN(1) = ARRAY2(1,2) + 0.01
            NOTEN(2) = ARRAY2(2,2) + 0.01
            NOTEN(3) = ARRAY2(5,2) + 0.01
            NOTWEN(1) = ARRAY2(6,2) + 0.01
            NOTWEN(2) = ARRAY2(7,2) + 0.01
            NOTWEN(3) = ARRAY2(10,2) + 0.01
            WRITE (LINE,1400) LIF, LP, LA, K, (NOTEN(I), NOTWEN(I),
     *         I = 1,3)
            LINE(1:7) = 'Totals '
            CALL PRTWRI (PRINT, LINE, QUIT, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (QUIT) DOCRT = 0
            END IF
C                                       print closure info
         IF (FRATOT.LE.0.0) FRATOT = 1.0
         DO 440 J = 1,12
            FRACNT(J) = FRACNT(J) / FRATOT
            IF ((J.GE.2) .AND. (J.LE.11)) ARRAY2(9+J,1) = FRACNT(J)
 440        CONTINUE

         IF ((PRTLEV.GE.1) .AND. (PRINT.NE.' ') .AND. (DOCRT.NE.0)) THEN
            LINE = ' '
            CALL PRTWRI (PRINT, LINE, QUIT, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (QUIT) DOCRT = 0
            IF (DOCRT.NE.0) THEN
               LINE = 'Fraction of closure error in range:'
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (IERR.NE.0) GO TO 990
               IF (QUIT) DOCRT = 0
               END IF
            IF (DOCRT.NE.0) THEN
               WRITE (LINE,1440) 0.0, FRACNT(1)
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (IERR.NE.0) GO TO 990
               IF (QUIT) DOCRT = 0
               END IF
            DO 445 J = 2,11
               IF (DOCRT.NE.0) THEN
                  MERE = 0.1 * (J-2)
                  MEIM = MERE + 0.1
                  WRITE (LINE,1445) MERE, MEIM, FRACNT(J)
                  CALL PRTWRI (PRINT, LINE, QUIT, IERR)
                  IF (IERR.NE.0) GO TO 990
                  IF (QUIT) DOCRT = 0
                  END IF
 445           CONTINUE
            IF (DOCRT.NE.0) THEN
               WRITE (LINE,1440) 1.0, FRACNT(12)
               CALL PRTWRI (PRINT, LINE, QUIT, IERR)
               IF (IERR.NE.0) GO TO 990
               IF (QUIT) DOCRT = 0
               END IF
            END IF
C                                       store away the answers for AIPS
         IF (LS.EQ.1) THEN
            AVODIM(1) = 20
            AVODIM(2) = 2
            AVODIM(3) = 1
            CALL RCOPY (40, ARRAY2, RDUM)
            CALL OPUT (OUTPUT, AVONAM(1), OOARE, AVODIM, IDUM, CDUMMY,
     *         IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
 500     CONTINUE
C-----------------------------------------------------------------------
C                                       Close file
      CALL OUVCLO (UVIN, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (.NOT.DOCAT) THEN
         CALL TABZAP (XXFILE, IERR)
         XXFILE = ' '
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       Delete temporary table
      IF (DOSOU) THEN
         CALL DESTRY (SUTAB, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       Close printer
      IF (PRINT.NE.' ') THEN
         CALL OCLOSE (PRINT, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  MSGTXT = 'AMVDIF: ERROR IN DATA VALUE FINDING FOR ' // UVIN
      CALL MSGWRT (7)
      IF ((.NOT.DOCAT) .AND. (XXFILE.NE.' ')) CALL TABZAP (XXFILE, I)
C
 999  RETURN
C-----------------------------------------------------------------------
 1200 FORMAT ('READ',I6,' TIMES, WILL DO ONLY',I5)
 1385 FORMAT ('Antenna ',A,2(2X,1PE13.5,'  +-',1PE13.5))
 1400 FORMAT (I2,I2,I3,I8,3(I8,I6))
 1440 FORMAT ('Equal ',F4.1,F9.6)
 1445 FORMAT (F4.1,' -',F4.1,F9.6)
      END
      SUBROUTINE AMVRFI (UVIN, PRINT, OUTPUT, CANT, CIF, CPOL, CCHAN,
     *   CTIME, SUM, SUMWT, VALS, LIST, COUNT, IERR)
C-----------------------------------------------------------------------
C   Look for bad data via amplitude of the vector difference of the
C   current sample from a running mean of the samples - baseline based
C   Inputs:
C      UVIN      C*?   Name of input uvdata object.
C      PRINT     C*?   Print object
C      OUTPUT    C*?   Output adverb object
C      CANT      I     Maximum antenna number
C      CPOL      I     Number of polarizations
C      CIF       I     Number of IFs
C      CCHAN     I     Number of spactral channels
C      CTIME     I     Limit on number of times
C   Scratch variables
C      SUM, SUMWT, VALS, COUNT.
C      LIST and SUM overlap
C   Inputs attached to UVIN:
C      MAXRMS    R(*)  Maximum RMS allowed, constant plus amplitude
C                      coefficient.
C      MAXBAD    R(2)  Maximum allowed fraction of bad baselines.
C      TIMEAVG   R     Time in seconds for clipping interval
C      DOIFS     L     Flag all IFs if one bad
C      DOSTOKES  L     Flas all Stokes if 1 bad
C      PRTLEV    I     Print level for debugging
C   Output:
C      IERR      I     Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER UVIN*(*), PRINT*(*), OUTPUT*(*)
      INTEGER   CANT, CIF, CPOL, CCHAN, CTIME, IERR
      REAL      SUM(CANT,CANT,CIF,CPOL,*), SUMWT(CANT,CANT,CIF,CPOL,*),
     *   COUNT(CANT,CANT,CIF,CPOL), VALS(CANT,CANT,CIF,CPOL,*), LIST(*)
C
      REAL      TCLIP, SCNTIM
      INTEGER   PRTLEV
C
      INTEGER   NTIME
      PARAMETER (NTIME = 15001)
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   TYPE, DIM(7), ANT1, ANT2, ENDVIS, VISNO, CURSOU, THISOU,
     *   TBVER, DOCRT, BEGT(4), ENDT(4), NACROS, ILOCU, ILOCV, ILOCW,
     *   ILOCT, ILOCB, ILOCSU, ILOCFQ, ILOCA1, ILOCA2, ILOCSA, JLOCC,
     *   JLOCS, JLOCF, JLOCR, JLOCD, JLOCIF, INCS, INCF, INCIF, LP, LIF,
     *   IP, THISUB, THIFRQ, CURSUB, CURFRQ, NZERO, QUAL, NP, KP, KP1,
     *   KP2, IP1, IP2, IPMAX, II, NLIST, NOTEN(3), NOTWEN(3), NARR,
     *   ITER, AVODIM(3), NPP(2)
      LOGICAL   DONE, DOSOU, QUIT, DOROBU
      CHARACTER SUTAB*32, SUNAME*16, CDUMMY*1, DTYPE(3)*10
      REAL      RP(50), TEPS, CURTIM, LSTIME, ENDTIM, BEGTIM, TEMP,
     *   VIS(3,MAXCIF), TIMR(2,NTIME), RE(NTIME), IM(NTIME), MERE, MEIM,
     *   MEDIAN, SCNT2, T2, ARRAY2(20,2), AVG, RMS, PARMA(3), PARMR(3),
     *   TDUMMY(NTIME,3), WP(2), SP(2), SPP(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      COMMON /TBUFS/ TIMR, RE, IM, TDUMMY
      INCLUDE 'GFORT'
      INCLUDE 'OUTPUT.INC'
      INCLUDE 'OUTPUTDATA.INC'
      DATA DTYPE /'Amplitude', 'Vector dif', 'Weight'/
C-----------------------------------------------------------------------
      TEPS = 0.02 / (3600.0 * 24.0)
      CALL RFILL (40, 0.0, ARRAY2)
      NARR = 0
C                                       Open printer
      IF (PRINT.NE.' ') THEN
         CALL OOPEN (PRINT, 'WRIT', IERR)
         IF (IERR.NE.0) GO TO 990
         CALL OGET (PRINT, 'DOCRT', TYPE, DIM, IDUM, CDUMMY, IERR)
         DOCRT = IDUM(1)
         IF (IERR.NE.0) GO TO 990
         CALL OGET (PRINT, 'NACROS', TYPE, DIM, IDUM, CDUMMY, IERR)
         NACROS = IDUM(1)
         IF (IERR.NE.0) GO TO 990
      ELSE
         DOCRT = 0
         END IF
      THISOU = 0
      THISUB = 0
      THIFRQ = 0
      CURSUB = 0
      CURFRQ = 0
C                                       Retrieve pointers into the data:
      CALL UVDPNT (UVIN, ILOCU, ILOCV, ILOCW, ILOCT, ILOCB, ILOCSU,
     *   ILOCFQ, ILOCA1, ILOCA2, ILOCSA, JLOCC, JLOCS, JLOCF, JLOCR,
     *   JLOCD, JLOCIF, INCS, INCF, INCIF, IERR)
      IF (IERR.NE.0) GO TO 999
      INCS = INCS / 3
      INCF = INCF / 3
      INCIF = INCIF / 3
C                                       Open input.
      CALL OUVOPN (UVIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Get parameters
      CALL OUVGET (UVIN, 'DOROBUST', TYPE, DIM, IDUM, CDUMMY, IERR)
      DOROBU = LDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OUVGET (UVIN, 'PRTLEV', TYPE, DIM, IDUM, CDUMMY, IERR)
      PRTLEV = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OUVGET (UVIN, 'SCANLENG', TYPE, DIM, IDUM, CDUMMY, IERR)
      SCNTIM = RDUM(1)
      IF (IERR.NE.0) GO TO 990
      SCNTIM = SCNTIM / 86400.0
      SCNT2 = SCNTIM / 2.0
      CALL OUVGET (UVIN, 'TIMEAVG', TYPE, DIM, IDUM, CDUMMY, IERR)
      TCLIP = RDUM(1)
      IF (IERR.NE.0) GO TO 990
      TCLIP = TCLIP / 86400.0
C                                       Processing info
      DOSOU = (ILOCSU.GT.0)
C                                       Source table/name
      IF (DOSOU) THEN
         SUTAB = 'SoUrce table for ANTIME'
         TBVER = 1
         CALL UV2TAB (UVIN, SUTAB, 'SU', TBVER, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       For single source use 'OBJECT'
      ELSE
         CALL UVDGET (UVIN, 'OBJECT', TYPE, DIM, IDUM, SUNAME, IERR)
         IF (IERR.NE.0) GO TO 990
         QUAL = 0
         END IF
C                                       Clear accumulators:
C                                       (1,*) =  count
C                                       (2,*) =  sum r then max rms**2
C                                       (3,*) =  sum**2 r then rms**2
C                                       (4,*) =  sum imaginary
C                                       (5,*) =  sum**2 imaginary
C                                       (6,*) =  sum amplitude
      IP1 = 1
      IP2 = 1
      IP = 1
      NZERO = CANT * CANT * CIF * CPOL
      CALL RFILL (NZERO, 0.0, SUM(1,1,1,1,IP))
      CALL RFILL (NZERO, 0.0, SUMWT(1,1,1,1,IP))
      CALL RFILL (NZERO, 0.0, COUNT)
C                                       Initialize visibility count
      DONE = .FALSE.
      VISNO = 0
C                                       page title
      MSGTXT = '        time range        type        value'
     *   // '     +- rms        X 10  X 20'
      IF (DOCRT.NE.0) THEN
         DIM(1) = LEN (MSGTXT)
         DIM(2) = 1
         CALL OPUT (PRINT, 'TITLE1', OOACAR, DIM, IDUM, MSGTXT, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL PRTWRI (PRINT, MSGTXT, QUIT, IERR)
         IF (QUIT) DOCRT = 0
         IF (IERR.NE.0) GO TO 990
      ELSE
         CALL MSGWRT (5)
         END IF
C                                       Swallow input collecting
C                                       statistics.
C                                       Loop thru data
 100     CALL UVREAD (UVIN, RP, VIS, IERR)
         IF (IERR.LT.0) THEN
            DONE = .TRUE.
            IERR = 0
            END IF
         IF (IERR.GT.0) GO TO 990
         VISNO = VISNO + 1
 110     CURTIM = RP(ILOCT)
         IF (DOSOU) THEN
            CURSOU = RP(ILOCSU) + 0.5
         ELSE
            CURSOU = 0
            END IF
         IF (ILOCFQ.GT.0) CURFRQ = RP(ILOCFQ) + 0.5
C                                       Get antenna numbers
         IF (ILOCB.GT.0) THEN
            ANT1 = (RP(ILOCB) / 256.0) + 0.001
            ANT2 = (RP(ILOCB) - ANT1 * 256) + 0.001
            CURSUB = (RP(ILOCB) - 256 * ANT1 - ANT2) * 100.0 + 1.1
         ELSE
            ANT1 = RP(ILOCA1) + 0.001
            ANT2 = RP(ILOCA2) + 0.001
            CURSUB = RP(ILOCSA) + 0.001
            END IF
C                                       Initial selection.
         IF (VISNO.EQ.1) THEN
            THIFRQ = CURFRQ
            THISUB = CURSUB
            THISOU = CURSOU
            BEGTIM = CURTIM
            ENDTIM = CURTIM + TCLIP
            END IF
C                                       Finished with data or interval?
         IF (DONE .OR. (CURTIM.GT.ENDTIM) .OR. (CURSOU.NE.THISOU)
     *      .OR. (CURSUB.NE.THISUB)) GO TO 150
C                                       Set last vis of interval
         ENDVIS = VISNO
C                                       Set last time
         LSTIME = CURTIM
C                                       Baseline index
         DO 130 LP = 1,CPOL
            DO 125 LIF = 1,CIF
               II = (LP-1) * INCS + (LIF-1) * INCIF + 1
               CALL AVERAG (CCHAN, VIS(1,II), INCF, ANT1, ANT2, .FALSE.,
     *            DOROBU, NPP, WP, SP, SPP)
               COUNT(ANT1,ANT2,LIF,LP) = COUNT(ANT1,ANT2,LIF,LP) +
     *            NPP(1)
               SUMWT(ANT1,ANT2,LIF,LP,IP) = SUMWT(ANT1,ANT2,LIF,LP,IP) +
     *            WP(1)
               SUM(ANT1,ANT2,LIF,LP,IP) = SUM(ANT1,ANT2,LIF,LP,IP) +
     *            SP(1)
               COUNT(ANT2,ANT1,LIF,LP) = COUNT(ANT2,ANT1,LIF,LP) +
     *            NPP(2)
               SUMWT(ANT2,ANT1,LIF,LP,IP) = SUMWT(ANT2,ANT1,LIF,LP,IP) +
     *            WP(2)
               SUM(ANT2,ANT1,LIF,LP,IP) = SUM(ANT2,ANT1,LIF,LP,IP) +
     *            SP(2)
 125           CONTINUE
 130        CONTINUE
C                                       Next vis until done
         IF (.NOT.DONE) GO TO 100
C                                       save times at end of interval
 150   TIMR(1,IP) = BEGTIM
       TIMR(2,IP) = LSTIME
C                                       Average
       DO 170 LIF = 1,CIF
          DO 165 LP = 1,CPOL
             DO 160 ANT2 = 1,CANT
               DO 155 ANT1 = 1,CANT
                  IF (SUMWT(ANT1,ANT2,LIF,LP,IP).GT.0.0) THEN
                     SUM(ANT1,ANT2,LIF,LP,IP) = SUM(ANT1,ANT2,LIF,LP,IP)
     *                  / SUMWT(ANT1,ANT2,LIF,LP,IP)
                     SUMWT(ANT1,ANT2,LIF,LP,IP) =
     *                  SUMWT(ANT1,ANT2,LIF,LP,IP) /
     *                  COUNT(ANT1,ANT2,LIF,LP)
                     END IF
 155              CONTINUE
 160           CONTINUE
 165        CONTINUE
 170     CONTINUE
C                                       process what we have
      IF ((DONE) .OR. (CURSOU.NE.THISOU) .OR. (IP.GE.CTIME) .OR.
     *   (IP.GT.NTIME) .OR. (CURSUB.NE.THISUB)) THEN
         IPMAX = IP
C                                       do to end
         IF ((DONE) .OR. (CURSOU.NE.THISOU) .OR. (CURSUB.NE.THISUB))
     *      THEN
            IP2 = IPMAX
C                                       will need to find the max to do
         ELSE
            TEMP = (TIMR(1,IPMAX) + TIMR(2,IPMAX)) / 2.0
            DO 175 IP = IP1,IPMAX
               IF ((TEMP-(TIMR(1,IP)+TIMR(2,IP))/2.0).GT.SCNT2) IP2 = IP
 175           CONTINUE
            END IF
         IF (DOSOU) THEN
            CALL SOUNFO (SUTAB, THISOU, 'SOURCE', TYPE, DIM, II,
     *         SUNAME, IERR)
            IF (IERR.NE.0) GO TO 990
            CALL SOUNFO (SUTAB, THISOU, 'QUAL', TYPE, DIM, QUAL,
     *         CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
C                                       loop over times of interest
         DO 240 IP = IP1,IP2
            CALL RFILL (NZERO, FBLANK, VALS(1,1,1,1,IP))
C                                       time range to cover here
            TEMP = (TIMR(1,IP) + TIMR(2,IP)) / 2.0
            KP1 = IP
            KP2 = IP
 180        IF (KP1.GT.1) THEN
               T2 = (TIMR(1,KP1-1) + TIMR(2,KP1-1)) / 2.0
               IF (TEMP-T2.LE.SCNT2) THEN
                  KP1 = KP1 - 1
                  GO TO 180
                  END IF
               END IF
 185        TEMP = (TIMR(1,KP1) + TIMR(2,KP1)) / 2.0
            IF (KP2.LT.IPMAX) THEN
               T2 = (TIMR(1,KP2+1) + TIMR(2,KP2+1)) / 2.0
               IF (T2-TEMP.LE.SCNTIM) THEN
                  KP2 = KP2 + 1
                  GO TO 185
                  END IF
            ELSE
               TEMP = (TIMR(1,KP2) + TIMR(2,KP2)) / 2.0
 186           IF (KP1.GT.1) THEN
                  T2 = (TIMR(1,KP1-1) + TIMR(2,KP1-1)) / 2.0
                  IF (TEMP-T2.LE.SCNTIM) THEN
                     KP1 = KP1 - 1
                     GO TO 186
                     END IF
                  END IF
               END IF
C                                       find all correlators Vdif
            DO 230 ANT1 = 1,CANT-1
               DO 225 ANT2 = ANT1+1,CANT
                  DO 220 LIF = 1,CIF
                     DO 215 LP = 1,CPOL
                        IF (SUMWT(ANT1,ANT2,LIF,LP,IP).GT.0.0) THEN
                           NP = 0
                           DO 210 KP = KP1,KP2
                              IF (SUMWT(ANT1,ANT2,LIF,LP,KP).GT.0.0)
     *                           THEN
                                 NP = NP + 1
                                 RE(NP) = SUM(ANT1,ANT2,LIF,LP,KP)
                                 IM(NP) = SUM(ANT2,ANT1,LIF,LP,KP)
                                 END IF
 210                          CONTINUE
                           MERE = MEDIAN (NP, RE)
                           MEIM = MEDIAN (NP, IM)
                           VALS(ANT1,ANT2,LIF,LP,IP) = SQRT
     *                        ((SUM(ANT1,ANT2,LIF,LP,IP)-MERE)**2 +
     *                        (SUM(ANT2,ANT1,LIF,LP,IP)-MEIM)**2)
                           VALS(ANT2,ANT1,LIF,LP,IP) = SQRT
     *                        (SUM(ANT1,ANT2,LIF,LP,IP)**2 +
     *                        SUM(ANT2,ANT1,LIF,LP,IP)**2)
                           END IF
 215                    CONTINUE
 220                 CONTINUE
 225              CONTINUE
 230           CONTINUE
 240        CONTINUE
         CALL FILL (3, 0, NOTEN)
         CALL FILL (3, 0, NOTWEN)
         DO 280 ITER = 0,3
            NLIST = 0
            DO 270 IP = IP1,IP2
               DO 260 ANT1 = 1,CANT-1
                  DO 255 ANT2 = ANT1+1,CANT
                     DO 250 LIF = 1,CIF
                        DO 245 LP = 1,CPOL
                           IF (SUMWT(ANT1,ANT2,LIF,LP,IP).GT.0.0) THEN
                              NLIST = NLIST + 1
                              IF (ITER.EQ.0) THEN
                                 LIST(NLIST) = VALS(ANT2,ANT1,LIF,LP,IP)
                              ELSE IF (ITER.EQ.1) THEN
                                 TEMP = ABS (LIST(NLIST)-AVG)
                                 IF (TEMP.GT.10.*RMS) NOTEN(ITER) =
     *                              NOTEN(ITER) + 1
                                 IF (TEMP.GT.20.*RMS) NOTWEN(ITER) =
     *                              NOTWEN(ITER) + 1
                                 LIST(NLIST) = VALS(ANT1,ANT2,LIF,LP,IP)
                              ELSE IF (ITER.EQ.2) THEN
                                 TEMP = ABS (LIST(NLIST)-AVG)
                                 IF (TEMP.GT.10.*RMS) NOTEN(ITER) =
     *                              NOTEN(ITER) + 1
                                 IF (TEMP.GT.20.*RMS) NOTWEN(ITER) =
     *                              NOTWEN(ITER) + 1
                                 LIST(NLIST) =
     *                              SUMWT(ANT1,ANT2,LIF,LP,IP)
                              ELSE
                                 TEMP = ABS (LIST(NLIST)-AVG)
                                 IF (TEMP.GT.10.*RMS) NOTEN(ITER) =
     *                              NOTEN(ITER) + 1
                                 IF (TEMP.GT.20.*RMS) NOTWEN(ITER) =
     *                              NOTWEN(ITER) + 1
                                 END IF
                              END IF
 245                       CONTINUE
 250                    CONTINUE
 255                 CONTINUE
 260              CONTINUE
 270           CONTINUE
            IF (ITER.LT.3) THEN
               CALL ROBUST (LIST, NLIST, AVG, RMS)
               PARMA(ITER+1) = AVG
               PARMR(ITER+1) = RMS
               END IF
 280        CONTINUE
         NARR = NARR + 1
         ARRAY2(1,1) = ARRAY2(1,1) + PARMA(1)
         ARRAY2(2,1) = ARRAY2(2,1) + PARMA(2)
         ARRAY2(5,1) = ARRAY2(5,1) + PARMA(3)
         ARRAY2(6,1) = ARRAY2(6,1) + PARMR(1)
         ARRAY2(7,1) = ARRAY2(7,1) + PARMR(2)
         ARRAY2(10,1) = ARRAY2(10,1) + PARMR(3)
         ARRAY2(1,2) = ARRAY2(1,2) + NOTEN(1)
         ARRAY2(2,2) = ARRAY2(2,2) + NOTEN(2)
         ARRAY2(5,2) = ARRAY2(5,2) + NOTEN(3)
         ARRAY2(6,2) = ARRAY2(6,2) + NOTWEN(1)
         ARRAY2(7,2) = ARRAY2(7,2) + NOTWEN(2)
         ARRAY2(10,2) = ARRAY2(10,2) + NOTWEN(3)
         CALL TODHMS (TIMR(1,IP1), BEGT)
         CALL TODHMS (TIMR(2,IP2), ENDT)
C                                       report
         DO 290 ITER = 1,3
            WRITE (MSGTXT,1280) BEGT, ENDT, DTYPE(ITER), PARMA(ITER),
     *         PARMR(ITER), NOTEN(ITER), NOTWEN(ITER)
            IF (DOCRT.EQ.0) THEN
               CALL MSGWRT (5)
            ELSE
               CALL PRTWRI (PRINT, MSGTXT, QUIT, IERR)
               IF (IERR.NE.0) GO TO 990
               IF (QUIT) DOCRT = 0
               END IF
 290        CONTINUE
C                                       shift buffers down
         IF (IP2.LT.IPMAX) THEN
            KP1 = IP2 + 1
            TEMP = (TIMR(1,KP1) + TIMR(2,KP1)) / 2.0
 335        IF (KP1.GT.1) THEN
               T2 = (TIMR(1,KP1-1) + TIMR(2,KP1-1)) / 2.0
               IF (TEMP-T2.LE.SCNT2) THEN
                  KP1 = KP1 - 1
                  GO TO 335
                  END IF
               END IF
C                                       shift down
            IP1 = IP2 - KP1 + 2
            NP = 0
            DO 340 IP = KP1,IPMAX
               NP = NP + 1
               CALL RCOPY (NZERO, SUM(1,1,1,1,IP), SUM(1,1,1,1,NP))
               CALL RCOPY (NZERO, SUMWT(1,1,1,1,IP), SUMWT(1,1,1,1,NP))
               CALL RCOPY (2, TIMR(1,IP), TIMR(1,NP))
 340           CONTINUE
            IP = NP
         ELSE
            IP = 0
            IP1 = 1
            END IF
         END IF
C                                       advance for next buffer
      IF (.NOT.DONE) THEN
         IP = IP + 1
         CALL RFILL (NZERO, 0.0, SUM(1,1,1,1,IP))
         CALL RFILL (NZERO, 0.0, SUMWT(1,1,1,1,IP))
         CALL RFILL (NZERO, 0.0, COUNT)
         THISOU = CURSOU
         BEGTIM = CURTIM
         ENDTIM = CURTIM + TCLIP
         THIFRQ = CURFRQ
         THISUB = CURSUB
         GO TO 110
         END IF
C-----------------------------------------------------------------------
C                                       send back data
      NARR = MAX (1, NARR)
      ARRAY2(1,1) = ARRAY2(1,1) / NARR
      ARRAY2(2,1) = ARRAY2(2,1) / NARR
      ARRAY2(5,1) = ARRAY2(5,1) / NARR
      ARRAY2(6,1) = ARRAY2(6,1) / NARR
      ARRAY2(7,1) = ARRAY2(7,1) / NARR
      ARRAY2(10,1) = ARRAY2(10,1) / NARR
      AVODIM(1) = 20
      AVODIM(2) = 2
      AVODIM(3) = 1
      CALL RCOPY (40, ARRAY2, RDUM)
      CALL OPUT (OUTPUT, AVONAM(1), OOARE, AVODIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Close file
      CALL OUVCLO (UVIN, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Delete temporary table
      IF (DOSOU) THEN
         CALL DESTRY (SUTAB, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       Close printer
      IF (PRINT.NE.' ') THEN
         CALL OCLOSE (PRINT, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  MSGTXT = 'AMVRFI: ERROR IN DATA VALUE FINDING FOR ' // UVIN
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1280 FORMAT (I2,'/',2(I2.2,':'),I2.2,' -',I2,'/',2(I2.2,':'),I2.2,2X,
     *   A,1PE11.3,' +-',1PE10.3,I6,I6)
      END
      SUBROUTINE OXXINI (TABLE, OPCODE, XXROW, IERR)
C-----------------------------------------------------------------------
C   Initialize a weights scratch table (type XX) for reading or writing,
C   creating it if necessary.
C   Inputs:
C      TABLE  C*(*)     Name of table object:  NAME, CLASS, IMSEQ, DISK
C                       and VER should be set.
C      OPCODE C*4       Operation code
C                         'READ' - open for reading
C                         'WRIT' - open for writing (create if
C                                  necessary)
C
C   Outputs:
C      XXROW  I         Next row to read or write
C      IERR   I         Return code: 0 => successful
C-----------------------------------------------------------------------
      CHARACTER TABLE*(*), OPCODE*4
      INTEGER   XXROW, IERR
C
      INCLUDE 'XXTAB.INC'
      CHARACTER LABEL*56, COLLAB(NCOL,2)*24, COLUNT(NCOL,2)*8
      INTEGER   COLTYP(NCOL,2), COLDIM(NCOL), LCOL
      INTEGER   TYPE, DIM(3)
      CHARACTER CDUMMY*4
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      DATA LABEL / 'AMP/RMS/WT SCRATCH TABLE'/
      DATA COLLAB / 'TIME1', 'TIME2', 'SOURCE', 'VECTOR AMP',
     *   'VECTOR RMS', 'SCALAR AMP', 'SCALAR RMS', 'WEIGHT', 'CLOSURE',
     *   'TIME1', 'TIME2', 'SOURCE', 'REAL', 'IMAG', 'WEIGHT',
     *   'CLOSURE', 'REF ANT', ' ' /
      DATA COLUNT / 'DAYS', 'DAYS', ' ', 4*'Jy', '1/Jy**2', ' ',
     *    'DAYS', 'DAYS', ' ', 2*'Jy', '1/Jy**2', ' ', ' ', ' ' /
      DATA COLTYP / OOARE, OOARE, OOAINT, 6*OOARE,
     *     OOARE, OOARE, OOAINT, 4*OOARE, 2*OOAINT /
      DATA COLDIM / NCOL*1 /
C-----------------------------------------------------------------------
      LCOL = NCOL + 1 - XXTYPE
C                                       Fill in table type:
      TYPE = OOACAR
      DIM(1) = 2
      DIM(2) = 1
      DIM(3) = 0
      CALL TABPUT (TABLE, 'TBLTYPE', TYPE, DIM, IDUM, 'XX', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Initialize table data if
C                                       writing:
      IF (OPCODE.EQ.'WRIT') THEN
         TYPE = OOACAR
         DIM(1) = 56
         DIM(2) = 1
         DIM(3) = 0
         CALL TABPUT (TABLE, 'LABEL', TYPE, DIM, IDUM, LABEL, IERR)
         IF (IERR.NE.0) GO TO 999
         TYPE = OOAINT
         DIM(1) = 1
         IDUM(1) = LCOL
         CALL TABPUT (TABLE, 'NCOL', TYPE, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
         IDUM(1) = 0
         CALL TABPUT (TABLE, 'VER', TYPE, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
         TYPE = OOACAR
         DIM(1) = 24
         DIM(2) = LCOL
         CALL TABPUT (TABLE, 'COLABEL', TYPE, DIM, IDUM,
     *      COLLAB(1,XXTYPE), IERR)
         IF (IERR.NE.0) GO TO 999
         DIM(1) = 8
         CALL TABPUT (TABLE, 'COLUNIT', TYPE, DIM, IDUM,
     *      COLUNT(1,XXTYPE), IERR)
         IF (IERR.NE.0) GO TO 999
         TYPE = OOAINT
         DIM(1) = LCOL
         DIM(2) = 1
         CALL TABPUT (TABLE, 'COLTYPE', TYPE, DIM, COLTYP(1,XXTYPE),
     *      CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
         COLDIM(4) = NSAMP
         COLDIM(5) = NSAMP
         COLDIM(6) = NSAMP
         COLDIM(7) = NSAMP
         COLDIM(8) = NSAMP
         COLDIM(9) = NSAMP
         IF (XXTYPE.EQ.2) COLDIM(8) = NCORS
         CALL TABPUT (TABLE, 'COLDIM', TYPE, DIM, COLDIM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Initialize table:
      CALL TABOPN (TABLE, OPCODE, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'CANNOT OPEN WEIGHTS SCRATCH (XX) TABLE'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Get column indices
      CALL TABCOL (TABLE, LCOL, COLLAB(1,XXTYPE), COLIDX, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get next row:
      IF (OPCODE.EQ.'READ') THEN
         XXROW = 1
      ELSE
         CALL TABGET (TABLE, 'NROW', TYPE, DIM, IDUM, CDUMMY, IERR)
         XXROW = IDUM(1)
         IF (IERR.NE.0) GO TO 999
         XXROW = XXROW + 1
         END IF
C
 999  RETURN
      END
      SUBROUTINE OTABXX (TABLE, OPCODE, XXROW, TB, TE, SU, VAMP, VRMS,
     *   SAMP, SRMS, WT, CLOS, REFA, IERR)
C-----------------------------------------------------------------------
C   Read or write a record to a amp/rms scratch table.
C   Inputs:
C      TABLE   C*(*)   Name of table object
C      OPCODE  C*4     Operation code: 'READ' or 'WRIT'
C   Input/output:
C      XXROW   I       Row number to read or write (incremented on exit)
C      TB      R       Start time
C      TE      R       End time
C      SU      I       source number
C      VAMP    R(*)    Amplitude values (Nant, Nif, Npol)
C      VRMS    R(*)    RMS values (Nant, Nif, Npol)
C      SAMP    R(*)    Amplitude values (Nant, Nif, Npol)
C      SRMS    R(*)    RMS values (Nant, Nif, Npol) (XTYPE = 1 only)
C      WT      R(*)    Weight values (Nant, Nif, Npol) (XTYPE = 1 only)
C      REFA    i(*)    Refant (Nif, Npol) (XTYPE = 2 only)
C   Output:
C      IERR    I       Return code: 0 => successful
C-----------------------------------------------------------------------
      CHARACTER TABLE*(*), OPCODE*4
      INTEGER   XXROW, SU, REFA(*), IERR
      REAL      TB, TE, VAMP(*), VRMS(*), SAMP(*), SRMS(*), WT(*),
     *   CLOS(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   TYPE, DIM(3), IDUM(2*MAXIF)
      REAL      RDUM(2*MAXIF)
      CHARACTER CDUMMY*4
      EQUIVALENCE (RDUM, IDUM)
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'XXTAB.INC'
C-----------------------------------------------------------------------
      IF (OPCODE.EQ.'WRIT') THEN
         TYPE = OOAINT
         DIM(1) = 1
         DIM(2) = 1
         DIM(3) = 0
         IDUM(1) = SU
         CALL TABDPT (TABLE, XXROW, COLIDX(3), TYPE, DIM, RDUM, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         TYPE = OOARE
         RDUM(1) = TB
         CALL TABDPT (TABLE, XXROW, COLIDX(1), TYPE, DIM, RDUM, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         RDUM(1) = TE
         CALL TABDPT (TABLE, XXROW, COLIDX(2), TYPE, DIM, RDUM, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         DIM(1) = NSAMP
         CALL TABDPT (TABLE, XXROW, COLIDX(4), TYPE, DIM, VAMP, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         CALL TABDPT (TABLE, XXROW, COLIDX(5), TYPE, DIM, VRMS, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         CALL TABDPT (TABLE, XXROW, COLIDX(6), TYPE, DIM, SAMP, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         IF (XXTYPE.EQ.1) THEN
            CALL TABDPT (TABLE, XXROW, COLIDX(7), TYPE, DIM, SRMS,
     *         CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TABDPT (TABLE, XXROW, COLIDX(8), TYPE, DIM, WT,
     *         CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TABDPT (TABLE, XXROW, COLIDX(9), TYPE, DIM, CLOS,
     *         CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 999
         ELSE
            CALL TABDPT (TABLE, XXROW, COLIDX(7), TYPE, DIM, CLOS,
     *         CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 999
            TYPE = OOAINT
            DIM(1) = NCORS
            CALL COPY (NCORS, REFA, IDUM)
            CALL TABDPT (TABLE, XXROW, COLIDX(8), TYPE, DIM, RDUM,
     *         CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
      ELSE
         CALL TABDGT (TABLE, XXROW, COLIDX(1), TYPE, DIM, RDUM, CDUMMY,
     *      IERR)
         TB = RDUM(1)
         IF (IERR.NE.0) GO TO 999
         CALL TABDGT (TABLE, XXROW, COLIDX(2), TYPE, DIM, RDUM, CDUMMY,
     *      IERR)
         TE = RDUM(1)
         IF (IERR.NE.0) GO TO 999
         CALL TABDGT (TABLE, XXROW, COLIDX(3), TYPE, DIM, RDUM, CDUMMY,
     *      IERR)
         SU = IDUM(1)
         IF (IERR.NE.0) GO TO 999
         CALL TABDGT (TABLE, XXROW, COLIDX(4), TYPE, DIM, VAMP, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         CALL TABDGT (TABLE, XXROW, COLIDX(5), TYPE, DIM, VRMS, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         CALL TABDGT (TABLE, XXROW, COLIDX(6), TYPE, DIM, SAMP, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         IF (XXTYPE.EQ.1) THEN
            CALL TABDGT (TABLE, XXROW, COLIDX(7), TYPE, DIM, SRMS,
     *         CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TABDGT (TABLE, XXROW, COLIDX(8), TYPE, DIM, WT, CDUMMY,
     *         IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TABDGT (TABLE, XXROW, COLIDX(9), TYPE, DIM, CLOS,
     *         CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 999
         ELSE
            CALL TABDGT (TABLE, XXROW, COLIDX(7), TYPE, DIM, CLOS,
     *         CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TABDGT (TABLE, XXROW, COLIDX(8), TYPE, DIM, RDUM,
     *         CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL COPY (DIM(1)*DIM(2), IDUM, REFA)
            END IF
         END IF
C
      XXROW = XXROW + 1
C
 999  RETURN
      END
      SUBROUTINE REREF (CANT, CIF, CPOL, MTIME, LIF, LP, LS, REFANT,
     *   ANT, SNUMS, TIMR, CREAL, CIMAG, REFAS)
C-----------------------------------------------------------------------
C   Re-references from ANT to REFANT
C   Inputs:
C      CANT      I     Maximum antenna number
C      CIF       I     Number of IFs
C      CPOL      I     Number of polarizations
C      MTIME     I     Number of times
C      LIF       I     Current IF
C      LP        I     Current polarization
C      LS        I     Current source
C      REFANT    I     Desired reference antenna
C      ANT       I     Reference antenna to be undone
C      SNUMS     I(*)  Source numbers vs time
C      TIMR      R(*)  Time range (start/stop, time)
C   In/out:
C      CREAL     R(*)  Real (ant,if,pol,time)
C      CIMAG     R(*)  Imag (ant,if,pol,time)
C      REFAS     I(*)  Refants (if,pol,time)
C-----------------------------------------------------------------------
      INTEGER   CANT, CIF, CPOL, MTIME, LIF, LP, LS, REFANT, ANT,
     *   SNUMS(*), REFAS(CIF,CPOL,*)
      REAL      TIMR(2,*), CREAL(CANT,CIF,CPOL,*),
     *   CIMAG(CANT,CIF,CPOL,*)
C
      INTEGER   IP, NP, LIST(1001), IP1, IP2, KP1, KP2, LA
      REAL      RE1, RE2, IM1, IM2, TI1, TI2, W1, W2, TI, RE, IM, AMP,
     *   TRE, TIM
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       make a list of matching times
      NP = 0
      DO 10 IP = 1,MTIME
         IF (SNUMS(IP).EQ.LS) THEN
            IF ((REFAS(LIF,LP,IP).EQ.REFANT) .AND.
     *         (CREAL(ANT,LIF,LP,IP).NE.FBLANK) .AND.
     *         ((CREAL(ANT,LIF,LP,IP).NE.0.0) .OR.
     *         (CIMAG(ANT,LIF,LP,IP).NE.0.0))) THEN
               NP = NP + 1
               LIST(NP) = IP
            ELSE IF ((REFAS(LIF,LP,IP).EQ.ANT) .AND.
     *         (CREAL(REFANT,LIF,LP,IP).NE.FBLANK) .AND.
     *         ((CREAL(REFANT,LIF,LP,IP).NE.0.0) .OR.
     *         (CIMAG(REFANT,LIF,LP,IP).NE.0.0))) THEN
               NP = NP + 1
               LIST(NP) = IP
               END IF
            END IF
 10      CONTINUE
C                                       no connection
      IF (NP.LE.0) THEN
         WRITE (MSGTXT,1010) ANT, REFANT, LIF, LP
         CALL MSGWRT (6)
C                                       re-reference
      ELSE
C                                       initial interp values
         IP1 = 1
         IP2 = MIN (2, NP)
         KP1 = LIST(IP1)
         KP2 = LIST(IP2)
         IF (REFAS(LIF,LP,KP1).EQ.REFANT) THEN
            RE1 = CREAL(REFANT,LIF,LP,KP1)
            IM1 = CIMAG(REFANT,LIF,LP,KP1)
         ELSE
            RE1 = CREAL(ANT,LIF,LP,KP1)
            IM1 = -CIMAG(ANT,LIF,LP,KP1)
            END IF
         IF (REFAS(LIF,LP,KP2).EQ.REFANT) THEN
            RE2 = CREAL(REFANT,LIF,LP,KP2)
            IM2 = CIMAG(REFANT,LIF,LP,KP2)
         ELSE
            RE2 = CREAL(ANT,LIF,LP,KP2)
            IM2 = -CIMAG(ANT,LIF,LP,KP2)
            END IF
         TI1 = (TIMR(1,KP1) + TIMR(2,KP1)) / 2.0
         TI2 = (TIMR(1,KP2) + TIMR(2,KP2)) / 2.0
C                                       loop through data
         DO 50 IP = 1,MTIME
            IF (SNUMS(IP).EQ.LS) THEN
               IF (REFAS(LIF,LP,IP).EQ.ANT) THEN
                  TI = (TIMR(1,IP) + TIMR(2,IP)) / 2.0
 20               IF ((TI.GE.TI1) .AND. (TI.LE.TI2)) THEN
                     IF (TI2.GT.TI1) THEN
                        W1 = (TI2 - TI) / (TI2 - TI1)
                     ELSE
                        W1 = 1.0
                        END IF
                  ELSE IF (TI.LT.TI1) THEN
                     W1 = 1.0
                  ELSE IF (IP2.GE.NP) THEN
                     W1 = 0.0
                  ELSE
                     RE1 = RE2
                     IM1 = IM2
                     TI1 = TI2
                     KP1 = KP2
                     IP1 = IP1 + 1
                     IP2 = MIN (IP2+1, NP)
                     KP2 = LIST(IP2)
                     IF (REFAS(LIF,LP,KP2).EQ.REFANT) THEN
                        RE2 = CREAL(REFANT,LIF,LP,KP2)
                        IM2 = CIMAG(REFANT,LIF,LP,KP2)
                     ELSE
                        RE2 = CREAL(ANT,LIF,LP,KP2)
                        IM2 = -CIMAG(ANT,LIF,LP,KP2)
                        END IF
                     TI2 = (TIMR(1,KP2) + TIMR(2,KP2)) / 2.0
                     GO TO 20
                     END IF
C                                       interpolate
                  W2 = 1.0 - W1
                  RE = W1 * RE1 + W2 * RE2
                  IM = W1 * IM1 + W2 * RE2
                  AMP = SQRT (RE * RE + IM * IM)
                  RE = RE / AMP
                  IM = IM / AMP
                  DO 30 LA = 1,CANT
                     IF ((CREAL(LA,LIF,LP,IP).NE.FBLANK) .AND.
     *                  (CIMAG(LA,LIF,LP,IP).NE.FBLANK) .AND.
     *                  ((CREAL(LA,LIF,LP,IP).NE.0.0) .OR.
     *                  (CIMAG(LA,LIF,LP,IP).NE.0.0))) THEN
                        TRE = CREAL(LA,LIF,LP,IP)
                        TIM = CIMAG(LA,LIF,LP,IP)
                        CREAL(LA,LIF,LP,IP) = TRE * RE - TIM * IM
                        CIMAG(LA,LIF,LP,IP) = TRE * IM + TIM * RE
                        END IF
 30                  CONTINUE
                  REFAS(LIF,LP,IP) = REFANT
                  END IF
               END IF
 50         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('CANNOT REFERENCE ANT',I3,' TO',I3,' AT IF/POL',I3,I2)
      END
      REAL FUNCTION MEDIUM (A, B, LEN)
C-----------------------------------------------------------------------
C   The median of the first LEN numbers in A.  LEN should be an odd
C   number.
C
C   Input:
C      LEN       I         Length of array
C      A         R(*)      Data array
C      B         R(*)      Second array
C                             ignore points that have A(I)=B(I)=0.0
C   Usage example for remembrance
C
C      MEDRE = MEDIUM (RE, FILWID)
C                                       rms
C      DO 60 I = 1, FILWID
C         ADIFF(I) = ABS(RE(I) - MEDRE)
C 60      CONTINUE
C      SIGMA = ROOT2 * 1.5 * MEDIUM(ADIFF, FILWID)
C
C-----------------------------------------------------------------------
      REAL      A(*), B(*)
      INTEGER   LEN
C
      INTEGER   I, L
      REAL      X(50001), MEDIAN
C-----------------------------------------------------------------------
C                                       select
      L = 0
      DO 10 I = 1,LEN
         IF ((A(I).NE.0.0) .OR. (B(I).NE.0.0)) THEN
            L = L + 1
            X(L) = A(I)
            END IF
 10      CONTINUE
C                                       sort
      IF (L.GT.0) THEN
         MEDIUM = MEDIAN (L, X)
      ELSE
         MEDIUM = 0.0
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'DTCHK.INC'
C                                       Local include for DTCHK
      INCLUDE 'INCS:ZPBUFSZ.INC'
      LOGICAL WANTSL
      HOLLERITH XNAMEI(3), XCLAIN(2), XINFIL(12), XINEXT(1), XOPCOD(1),
     *   XOPTYP(1), XCOMNT(16), XOUTFL(12)
      REAL XANT(50), XTIMER(8), APARM(10), XSIN, XDISIN, XINVER,
     *   XPRTLV, TSELCT(2), DPARMS(70)
      INTEGER SEQIN, DISKIN, IANTSL(50), NANTSL, INVER, IPRTLV, JNCIF,
     *   JNCF, JNCS
      CHARACTER NAMEIN*12, CLAIN*6, LINFIL*48, LEXT*4, LOPCOD*4,
     *   LOPTYP*4, LCOMNT*64, LOUTFL*48
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XINFIL, XANT,
     *   XTIMER, XINEXT, XINVER, XOPCOD, XOPTYP, APARM, XCOMNT,
     *   XOUTFL, XPRTLV, DPARMS, TSELCT, SEQIN, DISKIN, INVER, IANTSL,
     *   NANTSL, IPRTLV, WANTSL, JNCIF, JNCF, JNCS
      COMMON /CHRCOM/ NAMEIN, CLAIN, LINFIL, LEXT, LOPCOD, LOPTYP,
     *   LCOMNT, LOUTFL
C                                       General
      LOGICAL ISCOMP, WOUTFL
      INTEGER ICNO, ILOCWT, ILUNF, IFINDF
      COMMON /GENPAR/ ICNO, ILOCWT, ILUNF, IFINDF, ISCOMP, WOUTFL
C                                       Test statistics:
      INTEGER MXSTAT
      PARAMETER (MXSTAT = 10000)
C                                       (Amp, phase, delay, rate)
      LOGICAL WTEST(5)
      DOUBLE PRECISION DERRMS(5), DERMAX(5), DERSUM(5), DERSQ(5),
     *   DERAVG(5), DERPVR(5), DSBUFF(MXSTAT,5)
      INTEGER NERCNT, NXSTAT
      COMMON /DTSTAT/ DERRMS, DERMAX, DERSUM, DERSQ, DERAVG,
     *   DERPVR, DSBUFF, NERCNT, NXSTAT, WTEST
C                                       Buffers
      INTEGER JBUFSZ
      PARAMETER (JBUFSZ = UVBFSS)
      REAL BUFF1(UVBFSS), BUFF2(UVBFSS)
      INTEGER JBUFF(UVBFSS)
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFF
C                                       End local include for DTCHK
LOCAL END
      PROGRAM DTCHK
C-----------------------------------------------------------------------
C! Checks results obtained using simulated test data.
C# UV VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999-2000, 2007, 2012, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DTCHK checks results obtained using simulated test data.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      INFILE         LINFIL        Simulation parameter file.
C      ANTENNAS       IANTSL        Antennas to select
C      TIMERANG       TSELCT        Time range to select
C      INEXT          LEXT          Cal. table type (CL or SN)
C      INVERS         INVERS        Cal. table version.
C      OPCODE         LOPCOD        Test type.
C      OPTYPE         LOPTYP        Test sub-type.
C      PRTLEV         IPRTLV        Print level.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'DTCHK.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'DTCHK '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       perform initialization.
      CALL DTCKIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Read in simulation parameters
C                                       used by DTSIM if required.
      IF ((LOPCOD.EQ.'TABC').OR.(LOPCOD.EQ.'BSTB')) THEN
         CALL DTPARM (LINFIL, ILUNF, IPRTLV, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
C                                       Compile test statistics
      CALL DTMAIN (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Print test results
      CALL DTPRNT (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE DTCKIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   DTCKIN gets input parameters for DTCHK and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, PTYPE*2
      INTEGER   IROUND, NPARM, NN, J, IERR
      LOGICAL   T, F
      INCLUDE 'DTCHK.INC'
      INCLUDE 'INCS:DTPM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
C                                       LUN for text files
      ILUNF = 10
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 190
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (48, 1, XINFIL, LINFIL)
      CALL H2CHR (4, 1, XINEXT, LEXT)
      CALL H2CHR (4, 1, XOPCOD, LOPCOD)
      CALL H2CHR (4, 1, XOPTYP, LOPTYP)
      CALL H2CHR (64, 1, XCOMNT, LCOMNT)
      CALL H2CHR (48, 1, XOUTFL, LOUTFL)
C                                       Antennas
      WANTSL = T
      NANTSL = 0
      DO 100 J = 1, 50
         IF (XANT(J).NE.0) THEN
            NANTSL = NANTSL + 1
            IANTSL(NANTSL) = IROUND (ABS (XANT(J)))
            IF (XANT(J).LT.0) WANTSL = F
            END IF
100      CONTINUE
C                                       Time range
      TSELCT(1) = XTIMER(1) + XTIMER(2) / 24.0D0 +
     *   XTIMER(3) / 1440.0D0 + XTIMER(4) / 86400.0D0
      TSELCT(2) = XTIMER(5) + XTIMER(6) / 24.0D0 +
     *   XTIMER(7) / 1440.0D0 + XTIMER(8) / 86400.0D0
      IF (TSELCT(2).LE.TSELCT(1)) THEN
         TSELCT(1) = -999.0
         TSELCT(2) = 999.0
         END IF
C                                       Outfile specified ?
      CALL CHBLNK (48, 1, LOUTFL, NN)
      WOUTFL = (NN.GT.0)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      INVER = IROUND (XINVER)
      IPRTLV = IROUND (XPRTLV)
C                                       Get CATBLK from input file.
      ICNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, ICNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, ICNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      JNCS = INCS / CATBLK(KINAX)
      JNCF = INCF / CATBLK(KINAX)
      JNCIF = INCIF / CATBLK(KINAX)
C                                       Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, ICNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = ICNO
      FRW(NCFILE) = 0
      JERR = 0
C                                       defaults to DTPM.INC
      DYEAR  = DPARMS(1) + 0.1
      DMONTH = DPARMS(2) + 0.1
      DDAY   = DPARMS(3) + 0.1
      CALL RFILL (MAXIF, DPARMS(40), DEFGAN)
      CALL RCOPY (30, DPARMS(11), DEFGAN)
      CALL RFILL (MAXIF, DPARMS(70), DEFSYS)
      CALL RCOPY (30, DPARMS(41), DEFSYS)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DTCKIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE DTMAIN (IRET)
C----------------------------------------------------------------------
C   Main routine for checking test results.
C   Output:
C      IRET      I       Return code (0 => ok)
C----------------------------------------------------------------------
      INTEGER IRET
C
      LOGICAL WT, WF
      INTEGER I, NFILL
      INCLUDE 'DTCHK.INC'
      DATA WT /.TRUE./, WF /.FALSE./
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
      DO 20 I = 1, 5
         WTEST(I) = WF
20       CONTINUE
C                                       Initialize test statistics
      CALL DFILL (5, 0.0D0, DERSUM)
      CALL DFILL (5, 0.0D0, DERSQ)
      CALL DFILL (5, 0.0D0, DERRMS)
      CALL DFILL (5, 0.0D0, DERAVG)
      CALL DFILL (5, 0.0D0, DERPVR)
      NFILL = 5 * MXSTAT
      CALL DFILL (NFILL, 0.0D0, DSBUFF)
      NXSTAT = 0
      NERCNT = 0
C                                       Case sub_type of:
C                                       a) 'AMP' - check amplitude.
      IF (LOPTYP.EQ.'AMP') WTEST(1) = WT
C                                       b) 'PHAS' - check phase.
      IF (LOPTYP.EQ.'PHAS') WTEST(2) = WT
C                                       c) 'DELA' - check delay.
      IF (LOPTYP.EQ.'DELA') WTEST(3) = WT
C                                       d) 'RATE' - check rate.
      IF (LOPTYP.EQ.'RATE') WTEST(4) = WT
C                                       e) 'ACCL' - check acceleration
      IF (LOPTYP.EQ.'ACCL') WTEST(5) = WT
C                                       Endcase.
C
C                                       Case test type of:
C                                       1: 'TABC' - generic CL/SN check
      IF (LOPCOD.NE.'TABC') GO TO 150
         CALL CALCHK (IRET)
         GO TO 890
C                                       2: 'UV' - check uvdata directly
C                                          for unit ampl., zero phase
150   IF (LOPCOD.NE.'UVUN') GO TO 250
         CALL UVCHK (IRET)
         GO TO 890
C                                       3: 'BSTB' - check calibration
C                                          information in BS table
250   IF (LOPCOD.NE.'BSTB') GO TO 350
         CALL BSCHK (IRET)
         GO TO 890
C                                       Other: ignore
350   CONTINUE
C                                       Endcase
890   CONTINUE
      GO TO 999
C                                       Exit
999   RETURN
      END
      SUBROUTINE CALCHK (IRET)
C----------------------------------------------------------------------
C   Compile test statistics for calibration (CL/SN) tables.
C   Output:
C      IRET      I       Return code (0 => ok)
C----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      LOGICAL WAPPL, WGOOD, WSELCT
      CHARACTER LDUMMY*16, BNDCOD(MAXIF)*8
      DOUBLE PRECISION DTIME, DTIMEI, DGEO(1024), DELAY(2), DPHASE(2),
     *   DRATE(2), DFEED(2,2), DGAIN(2), DTSYS(2), DAMPL(2), DIFF(4),
     *   DELAYR(2), DPHASR(2), DRATR(2), DFEEDR(2,2), DGAINR(2),
     *   DTSYSR(2), DAMPLR(2), DGERR(2), DGERRF(2), DACCEL(2),
     *   DACCLR(2), DAMP, DPHS, DFOFF(MAXIF), DMHZ, DTMHZ
      REAL GMMOD, RANOD(25), DECNOD(25), FARAD, OFFDOP(MAXIF), ATMOS,
     *   ATMOSD, XMBDEL, CLOCK(2), CLOCKD(2), XDISP(2), XDISPD(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), CDELA(2,MAXIF),
     *   CRATE(2,MAXIF), CWGT(2,MAXIF), FINC(MAXIF), RTIME
      INTEGER ILUNTB, IRNO, CLKOLS(MAXCLC), CLNUMV(MAXCLC), NUMANT,
     *   NUMPOL, NUMIF, NTERM, IERR, SNKOLS(MAXSNC), SNNUMV(MAXSNC),
     *   NUMNOD, NREC, JREC, ISOU, NODENO, ISUBA, IREFA(2,MAXIF),
     *   IANT, IFQID, ISUBAN, IFQ, IAN, IANR, INDX, INDXR, JIF,
     *   JSTOK, KSTOK, J, ISUB, JSOU, JAN, JANR, JSUB, JFQ, ILUNFQ,
     *   IFQCUR, IFQVER, NIF, IFQD, ISBAND(MAXIF)
      INCLUDE 'DTCHK.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LDUMMY /' '/
      DATA ILUNTB /28/, ILUNFQ /29/
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
      ISUBAN = 0
      IFQCUR = 0
C                                       Open CL or SN table
      IF (LEXT.EQ.'CL') THEN
         CALL CALINI ('READ', JBUFF, DISKIN, ICNO, INVER, CATBLK,
     *      ILUNTB, IRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF,
     *      NTERM, GMMOD, IERR)
      ELSE
         CALL SNINI ('READ', JBUFF, DISKIN, ICNO, INVER, CATBLK,
     *      ILUNTB, IRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF,
     *      NUMNOD, GMMOD, RANOD, DECNOD, WAPPL, IERR)
         END IF
C
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1020) IERR, LEXT, INVER
         GO TO 990
         END IF
C                                       Loop over each record
C                                       in table.
      NREC = JBUFF(5)
      DO 500 JREC = 1, NREC
C                                       Read CL or SN record
         IRNO = JREC
         IF (LEXT.EQ.'CL') THEN
            CALL TABCAL ('READ', JBUFF, IRNO, CLKOLS, CLNUMV, NUMPOL,
     *         NUMIF, DTIME, DTIMEI, ISOU, IANT, ISUBA, IFQID, FARAD,
     *         DGEO, OFFDOP, ATMOS, ATMOSD, XMBDEL, CLOCK, CLOCKD,
     *         XDISP, XDISPD, CREAL, CIMAG, CDELA, CRATE, CWGT, IREFA,
     *         IERR)
         ELSE
            CALL TABSN ('READ', JBUFF, IRNO, SNKOLS, SNNUMV, NUMPOL,
     *         DTIME, DTIMEI, ISOU, IANT, ISUBA, IFQID, FARAD, NODENO,
     *         XMBDEL, XDISP, XDISPD, CREAL, CIMAG, CDELA, CRATE,
     *         CWGT, IREFA, IERR)
            END IF
C
      IF (IERR.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1100) IERR, LEXT, INVER
         GO TO 990
         END IF
C                                       Antenna selection
      CALL AMATCH (IANT, IANTSL, NANTSL, WANTSL, WSELCT)
      IF (.NOT.WSELCT) GO TO 500
C                                       Time range selection
      IF ((DTIME.LT.TSELCT(1)).OR.(DTIME.GT.TSELCT(2))) GO TO 500
C                                       Get antenna information for
C                                       this subarray if not already
C                                       loaded.
      ISUB = MAX (ISUBA, 1)
      IF (ISUBAN.NE.ISUB) THEN
         ISUBAN = ISUB
         CALL GETANT (DISKIN, ICNO, ISUBAN, CATBLK, BUFF2, IERR)
         IF (IERR.NE.0) THEN
            IRET = 3
            WRITE (MSGTXT,1200) IERR, ISUBAN
            GO TO 990
            END IF
         END IF
C                                       Get FQ information for this
C                                       FQ_ID if not already loaded
      IFQD = MAX (IFQID, 1)
      IF (IFQD.NE.IFQCUR) THEN
         IFQVER = 1
         CALL CHNDAT ('READ', BUFF1, DISKIN, ICNO, IFQVER, CATBLK,
     *      ILUNFQ, NIF, DFOFF, ISBAND, FINC, BNDCOD, IFQD, IERR)
         IF (IERR.NE.0) THEN
            IRET = 4
            WRITE (MSGTXT,1250) IERR, IFQ
            GO TO 990
            END IF
         IFQCUR = IFQD
         END IF
C                                       Loop over IF
      DO 350 JIF = 1, NUMIF
C                                       Match anten. name and
C                                       FQ_ID in cal. error arrays.
         IAN = MAX (IANT, 1)
         IFQ = MAX (IFQID, 1)
         CALL DTINDX (STNNAM(IAN), IFQ, INDX)
C                                       Look up indices in simulated
C                                       data common blocks
         CALL DTMATC (LDUMMY, IAN, ISUB, IFQ, JSOU, JAN, JSUB, JFQ)
C                                       Cal. errors.
         RTIME = DTIME
         CALL DTCALS (JSOU, JAN, JSUB, JFQ, JIF, INDX, RTIME, DELAY,
     *      DPHASE, DRATE, DACCEL, DFEED, DGAIN, DTSYS, DAMPL, DGERR)
C                                       Loop over polzn.
         DO 300 JSTOK = 1, NUMPOL
            WGOOD = .FALSE.
C                                       Reference antenna.
            IANR = MAX (IREFA(JSTOK,JIF), 1)
            CALL DTINDX (STNNAM(IANR), IFQ, INDXR)
C                                       Look up indices in simulated
C                                       data common blocks
            CALL DTMATC (LDUMMY, IANR, ISUB, IFQ, JSOU, JANR, JSUB,
     *         JFQ)
            CALL DTCALS (JSOU, JANR, JSUB, JFQ, JIF, INDXR, RTIME,
     *         DELAYR, DPHASR, DRATR, DACCLR, DFEEDR, DGAINR, DTSYSR,
     *         DAMPLR, DGERRF)
C                                       Stokes index
            KSTOK = JSTOK
            IF ((NUMPOL.EQ.1).AND.(ICOR0.LT.-1)) KSTOK = 2
C                                       Difference in (amp, phase,
C                                       delay and rate).
            IF ((WTEST(1).OR.WTEST(2)).AND.
     *         ((CREAL(JSTOK,JIF).NE.FBLANK).AND.
     *         (CIMAG(JSTOK,JIF).NE.FBLANK))) THEN
               DAMP = SQRT (CREAL(JSTOK,JIF)**2 + CIMAG(JSTOK,JIF)**2)
               IF (DAMP.NE.0.0D0) DAMP = 1.0 / (DAMP * GMMOD)
               DPHS = ATAN2 (CIMAG(JSTOK,JIF), CREAL(JSTOK,JIF))
C                                       Amplitude
               DIFF(1) = DGERR(KSTOK) - DAMP
C                                       Phase
               DIFF(2) = (DPHASE(KSTOK) - DPHASR(KSTOK)) - DPHS
               DIFF(2) = DIFF(2) * RAD2DG
               DIFF(2) = MOD (DIFF(2), 360.0D0)
               IF (DIFF(2).GT.180.0) DIFF(2) = DIFF(2) - 360.0D0
               IF (DIFF(2).LT.-180.0) DIFF(2) = DIFF(2) + 360.0D0
               WGOOD = .TRUE.
               END IF
C                                       Delay
            IF (WTEST(3).AND.(CDELA(JSTOK,JIF).NE.FBLANK)) THEN
               DIFF(3) = (DELAY(KSTOK) - DELAYR(KSTOK)) -
     *            CDELA(JSTOK,JIF)
C                                       Convert to ns.
               DIFF(3) = DIFF(3) * 1.0D9
               WGOOD = .TRUE.
               END IF
C                                       Rate
            IF (WTEST(4).AND.(CRATE(JSTOK,JIF).NE.FBLANK)) THEN
C                                       Convert to mHz
               DTMHZ = (DRATE(KSTOK) - DRATR(KSTOK)) / TWOPI * 1.0D3
               DMHZ = CRATE(JSTOK,JIF) * (FREQ + DFOFF(JIF)) * 1.0D3
               DIFF(4) = DTMHZ - DMHZ
               WGOOD = .TRUE.
               END IF
C                                       Accumulate statistics
            IF (WGOOD) THEN
               DERAVG(1) = DERAVG(1) + DAMP
               DERAVG(2) = DERAVG(2) + DPHS * RAD2DG
               DERAVG(3) = DERAVG(3) + CDELA(JSTOK,JIF)
               DERAVG(4) = DERAVG(4) + CRATE(JSTOK,JIF)
C
               NXSTAT = MIN (NXSTAT+1, MXSTAT)
               DO 280 J = 1, 4
                  DERSUM(J) = DERSUM(J) + DIFF(J)
                  DERSQ(J) = DERSQ(J) + DIFF(J) ** 2
                  DSBUFF(NXSTAT,J) = DIFF(J)
280               CONTINUE
               NERCNT = NERCNT + 1
               END IF
C
300         CONTINUE
350      CONTINUE
500   CONTINUE
C                                       Calculate final statistics
      CALL ERSTAT (IERR)
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Exit
999   RETURN
C----------------------------------------------------------------------
1020  FORMAT ('CALCHK: ERROR',I4,' OPENING',A3,' TABLE',I3)
1100  FORMAT ('CALCHK: ERROR',I4,' READING',A3,' TABLE',I3)
1200  FORMAT ('CALCHK: ERROR',I4,' READING AN TABLE',I3)
1250  FORMAT ('CALCHK: ERROR',I4,' READING FQ TABLE; FQID=',I3)
      END
      SUBROUTINE BSCHK (IRET)
C----------------------------------------------------------------------
C   Compile test statistics for calibration information in BS tables
C   Output:
C      IRET    I  Return code (0 => ok; else error)
C----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      LOGICAL WGOOD, WSEL1, WSEL2
      CHARACTER LMODE*4, LDUMMY*16, BNDCOD(MAXIF)*8
      DOUBLE PRECISION DTIME, DELAY(2), DPHASE(2), DRATE(2), DACCL(2),
     *   DFEED(2,2), DGAIN(2), DTSYS(2), DAMPL(2), DGERR(2),
     *   DELAY2(2), DPHAS2(2), DRATE2(2), DACCL2(2), DFEED2(2,2),
     *   DGAIN2(2), DTSYS2(2), DAMPL2(2), DGERR2(2), DIFF(5),
     *   DFOFF(MAXIF), DMHZ, DTMHZ
      REAL TIMINT, VAMP(MAXIF), SAMP(MAXIF), RMBD, RMBERR, AMBMBD,
     *   RSBD(MAXIF), SBDERR(MAXIF), SBDAMB, RRATE(MAXIF),
     *   RTERR(MAXIF), RTAMB, RACCEL(MAXIF), ACCERR(MAXIF),
     *   RPHASE(MAXIF), PHSERR(MAXIF), FINC(MAXIF), RTIME
      INTEGER ISUBAN, ILUNTB, IRNO, BSCOLS(MAXBSC), BSNUMV(MAXBSC),
     *   NUMIF, IERR, NREC, JREC, IBASL(2), ISUBA, ISTK, ISOU, ISUB,
     *   JIF, IAN, IFQ, INDX, JSOU, JAN, JSUB, JFQ, J, K1, K2, IFQCUR,
     *   ILUNFQ, IFQVER, NIF, IFQD, ISBAND(MAXIF)
      INCLUDE 'DTCHK.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA ILUNTB /28/, ILUNFQ /29/
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
      ISUBAN = 0
      IFQCUR = 0
C                                       Open BS table
      LMODE = '    '
      CALL BSINI ('READ', JBUFF, DISKIN, ICNO, INVER, CATBLK, ILUNTB,
     *   IRNO, BSCOLS, BSNUMV, LMODE, NUMIF, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1020) IERR, INVER
         GO TO 990
         END IF
C                                       Loop over each record in table
      NREC = JBUFF(5)
      DO 500 JREC = 1, NREC
C                                       Read BS record
         IRNO = JREC
         CALL TABBS ('READ', JBUFF, IRNO, BSCOLS, BSNUMV, NUMIF, DTIME,
     *      TIMINT, IBASL, ISUBA, ISTK, ISOU, VAMP, SAMP, RMBD, RMBERR,
     *      AMBMBD, RSBD, SBDERR, SBDAMB, RRATE, RTERR, RTAMB, RACCEL,
     *      ACCERR, RPHASE, PHSERR, IERR)
         IF (IERR.NE.0) THEN
            IRET = 2
            WRITE (MSGTXT,1100) IERR, INVER
            GO TO 990
            END IF
C                                       Antenna selection
         CALL AMATCH (IBASL(1), IANTSL, NANTSL, WANTSL, WSEL1)
         CALL AMATCH (IBASL(2), IANTSL, NANTSL, WANTSL, WSEL2)
         IF (.NOT.(WSEL1.OR.WSEL2)) GO TO 500
C                                       Time range selection
         IF ((DTIME.LT.TSELCT(1)).OR.(DTIME.GT.TSELCT(2))) GO TO 500
C                                       Get antenna information for
C                                       this subarray if not already
C                                       loaded
         ISUB = MAX (ISUBA, 1)
         IF (ISUBAN.NE.ISUB) THEN
            ISUBAN = ISUB
            CALL GETANT (DISKIN, ICNO, ISUBAN, CATBLK, BUFF2, IERR)
            IF (IERR.NE.0) THEN
               IRET = 3
               WRITE (MSGTXT,1200) IERR, ISUBAN
               GO TO 990
               END IF
            END IF
C                                       Get FQ information if not
C                                       already loaded (Note: BS
C                                       table has no fq_id col.)
         IFQD = 1
         IF (IFQD.NE.IFQCUR) THEN
            IFQVER = 1
            CALL CHNDAT ('READ', BUFF1, DISKIN, ICNO, IFQVER, CATBLK,
     *         ILUNFQ, NIF, DFOFF, ISBAND, FINC, BNDCOD, IFQD, IERR)
            IF (IERR.NE.0) THEN
               IRET = 4
               WRITE (MSGTXT,1250) IERR, IFQ
               GO TO 990
               END IF
            IFQCUR = IFQD
            END IF
C                                       Loop over IF
         DO 350 JIF = 1, NUMIF
            WGOOD = .FALSE.
C                                       Match antenna name and FQ_ID
C                                       in the calibration error arrays
C                                       Antenna_1:
            IAN = MAX (IBASL(1), 1)
            IFQ = 1
            CALL DTINDX (STNNAM(IAN), IFQ, INDX)
C                                       Look up indices in simulated
C                                       data common blocks
            CALL DTMATC (LDUMMY, IAN, ISUB, IFQ, JSOU, JAN, JSUB, JFQ)
C                                       Compute expected cal. errors
            RTIME = DTIME
            CALL DTCALS (JSOU, JAN, JSUB, JFQ, JIF, INDX, RTIME, DELAY,
     *         DPHASE, DRATE, DACCL, DFEED, DGAIN, DTSYS, DAMPL,
     *         DGERR)
C                                       Antenna_2:
            IAN = MAX (IBASL(2), 1)
            CALL DTINDX (STNNAM(IAN), IFQ, INDX)
C                                       Look up indices
            CALL DTMATC (LDUMMY, IAN, ISUBA, IFQ, JSOU, JAN, JSUB, JFQ)
C                                       Compute calibration errors
            CALL DTCALS (JSOU, JAN, JSUB, JFQ, JIF, INDX, RTIME,
     *         DELAY2, DPHAS2, DRATE2, DACCL2, DFEED2, DGAIN2, DTSYS2,
     *         DAMPL2, DGERR2)
C                                       Stokes index
C                                       RR:
            IF (ISTK.EQ.-1) THEN
               K1 = 1
               K2 = 1
               END IF
C                                       LL:
            IF (ISTK.EQ.-2) THEN
               K1 = 2
               K2 = 2
               END IF
C                                       RL:
            IF (ISTK.EQ.-3) THEN
               K1 = 1
               K2 = 2
               END IF
C                                       LR:
            IF (ISTK.EQ.-4) THEN
               K1 = 2
               K2 = 1
               END IF
C                                       Check for invalid Stokes
            IF ((ISTK.GT.0).OR.(ISTK.LT.-4)) THEN
               IRET = 4
               WRITE (MSGTXT,1350) ISTK
               GO TO 990
               END IF
C                                       Difference in (amp, phase
C                                       delay, rate and acceleration)
C                                       Amplitude:
            IF (WTEST(1).AND.(VAMP(JIF).NE.FBLANK)) THEN
               DIFF(1) = DGERR(K1) * DGERR2(K2) - VAMP(JIF)
               WGOOD = .TRUE.
               END IF
C                                       Phase
            IF (WTEST(2).AND.(RPHASE(JIF).NE.FBLANK)) THEN
               DIFF(2) = (DPHASE(K1) - DPHAS2(K2)) * RAD2DG -
     *            RPHASE(JIF)
               DIFF(2) = MOD (DIFF(2), 360.0D0)
               IF (DIFF(2).GT.180.0) DIFF(2) = DIFF(2) - 360.0D0
               IF (DIFF(2).LT.-180.0) DIFF(2) = DIFF(2) + 360.0D0
               WGOOD = .TRUE.
               END IF
C                                       Delay
            IF (WTEST(3).AND.(RSBD(JIF).NE.FBLANK)) THEN
               DIFF(3) = (DELAY(K1) - DELAY2(K2)) - RSBD(JIF)
C                                       Convert to ns
               DIFF(3) = DIFF(3) * 1.0D9
               WGOOD = .TRUE.
               END IF
C                                       Rate
            IF (WTEST(4).AND.(RRATE(JIF).NE.FBLANK)) THEN
C                                       Convert to mHz
               DTMHZ = (DRATE(K1) - DRATE2(K2)) / TWOPI * 1.0D3
               DMHZ = RRATE(JIF) * 1.0D3
               DIFF(4) = DTMHZ - DMHZ
               WGOOD = .TRUE.
               END IF
C                                       Acceleration
            IF (WTEST(5).AND.(RACCEL(JIF).NE.FBLANK)) THEN
C                                       Convert to (mHz)**2
               DTMHZ = (DACCL(K1) - DACCL2(K2)) / TWOPI * 1.0D6
               DMHZ = RACCEL(JIF) * 1.0D6
               DIFF(5) = DTMHZ - DMHZ
               WGOOD = .TRUE.
               END IF
C                                       Accumulate statistics
            IF (WGOOD) THEN
               DERAVG(1) = DERAVG(1) + VAMP(JIF)
               DERAVG(2) = DERAVG(2) + RPHASE(JIF)
               DERAVG(3) = DERAVG(3) + RSBD(JIF)
               DERAVG(4) = DERAVG(4) + RRATE(JIF)
               NXSTAT = MIN (NXSTAT+1, MXSTAT)
               DO 300 J = 1, 5
                  DERSUM(J) = DERSUM(J) + DIFF(J)
                  DERSQ(J) = DERSQ(J) + DIFF(J) ** 2
                  DSBUFF(NXSTAT,J) = DIFF(J)
300               CONTINUE
               NERCNT = NERCNT + 1
               END IF
350         CONTINUE
500      CONTINUE
C                                       Calculate final statistics
      CALL ERSTAT (IERR)
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Exit
999   RETURN
C----------------------------------------------------------------------
1020  FORMAT ('BSCHK: ERROR',I4,' OPENING BS TABLE',I3)
1100  FORMAT ('BSCHK: ERROR',I4,' READING BS TABLE',I3)
1200  FORMAT ('BSCHK: ERROR',I4,' READING AN TANLE',I3)
1250  FORMAT ('BSCHK: ERROR',I4,' READING FQ TABLE; FQID=',I3)
1350  FORMAT ('BSCHK: UNSUPPORTED STOKES TYPE',I3)
      END
      SUBROUTINE DTPRNT (IRET)
C----------------------------------------------------------------------
C   Print test results
C   Output:
C      IRET    I  Return code (0 => ok; else error)
C----------------------------------------------------------------------
      INTEGER IRET
C
      CHARACTER LTYPE(5)*6, LUNIT(5)*4, LTEST*4
      DOUBLE PRECISION DSNR
      INTEGER J, K, IERR, ITIME(8)
      INTEGER IROUND
      INCLUDE 'DTCHK.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LTYPE /'AMPL', 'PHASE', 'DELAY', 'RATE', 'ACCL'/
      DATA LUNIT /'Jy', 'deg', 'ns', 'mHz', 'mHz2'/
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C                                       Open output text file
      IF (WOUTFL) THEN
         CALL ZTXOPN ('WRIT', ILUNF, IFINDF, LOUTFL, .TRUE., IERR)
         IF (IERR.NE.0) THEN
            IRET = 1
            WRITE (MSGTXT,1000) IERR
            GO TO 990
            END IF
         END IF
C                                       Header
      WRITE (MSGTXT,1010)
      CALL MSGWRT (5)
      IF (WOUTFL) CALL ZTXIO ('WRIT', ILUNF, IFINDF, MSGTXT, IERR)
C                                       Input comment line
      MSGTXT = LCOMNT
      CALL MSGWRT (5)
      IF (WOUTFL) CALL ZTXIO ('WRIT', ILUNF, IFINDF, MSGTXT, IERR)
C                                       Antenna selection
      IF (WANTSL) THEN
         WRITE (MSGTXT,1020) (IANTSL(K), K=1,NANTSL)
      ELSE
         WRITE (MSGTXT,1025) (IANTSL(K), K=1,NANTSL)
         END IF
      CALL MSGWRT (5)
      IF (WOUTFL) CALL ZTXIO ('WRIT', ILUNF, IFINDF, MSGTXT, IERR)
C                                       Time range selection
      DO 30 J = 1, 8
         ITIME(J) = IROUND (XTIMER(J))
30       CONTINUE
      WRITE (MSGTXT,1030) ITIME
      CALL MSGWRT (5)
      IF (WOUTFL) CALL ZTXIO ('WRIT', ILUNF, IFINDF, MSGTXT, IERR)
C                                       Test type and sub_type
      WRITE (MSGTXT,1100) LOPCOD, LOPTYP, NERCNT
      CALL MSGWRT (5)
      IF (WOUTFL) CALL ZTXIO ('WRIT', ILUNF, IFINDF, MSGTXT, IERR)
C                                       Results:
C                                       (Amp, phase, delay, rate)
      DO 500 J = 1, 5
         IF (WTEST(J)) THEN
C                                       Compute SNR
            IF (DERRMS(J).GT.0) THEN
               DSNR = ABS (DERAVG(J)) / DERRMS(J)
            ELSE
               DSNR = 999.9
               END IF
C                                       Check limits on mean
C                                       and rms deviation
            K = 2 * (J - 1) + 1
            IF ((ABS(DERSUM(J)).LT.APARM(K)).AND.
     *         (DERRMS(J).LT.APARM(K+1))) THEN
               LTEST = 'PASS'
            ELSE
               LTEST = 'FAIL'
               END IF
C                                       Write limits
            WRITE (MSGTXT,1180) LTYPE(J), APARM(K), APARM(K+1)
            CALL MSGWRT (5)
            IF (WOUTFL) CALL ZTXIO ('WRIT', ILUNF, IFINDF, MSGTXT,
     *         IERR)
C                                       Write test results
            WRITE (MSGTXT,1200) DERSUM(J), DERRMS(J)
            CALL MSGWRT (5)
            IF (WOUTFL) CALL ZTXIO ('WRIT', ILUNF, IFINDF, MSGTXT,
     *         IERR)
            WRITE (MSGTXT,1220) LUNIT(J), DERPVR(J), DSNR, LTEST
            CALL MSGWRT (5)
            IF (WOUTFL) CALL ZTXIO ('WRIT', ILUNF, IFINDF, MSGTXT,
     *         IERR)
            END IF
500      CONTINUE
C                                       Trailer
      WRITE (MSGTXT,1010)
      CALL MSGWRT (5)
      IF (WOUTFL) CALL ZTXIO ('WRIT', ILUNF, IFINDF, MSGTXT, IERR)
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Exit
C                                       Close output text file
999   IF (WOUTFL) CALL ZTXCLS (ILUNF, IFINDF, IERR)
      RETURN
C---------------------------------------------------------------------
1000  FORMAT ('DTPRNT: ERR',I4,' OPENING OUTPUT FILE')
1010  FORMAT (64('='))
1020  FORMAT ('Ant(T):',18I4)
1025  FORMAT ('Ant(F):',18I4)
1030  FORMAT ('Time range: ',2(I3,'/',I2.2,':',I2.2,':',I2.2,5X))
1100  FORMAT ('Test type: ',A4,'  Sub_type: ',A4,'  Npoints:',I8)
1180  FORMAT (A6,' Limits:  ',E13.6,5X,E13.6)
1200  FORMAT (6X,' Mean dev=',E13.6,' RMS=',E13.6)
1220  FORMAT ('(',A4,') Fp-sigma=',E13.6,' SNR=',F13.2,' **',A4)
      END
      SUBROUTINE UVCHK (IRET)
C----------------------------------------------------------------------
C   Reads uv-data one point at a time and compiles test statistics.
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise error.
C----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER IFILE*48
      INTEGER   INIO, IPTRI, LUNI, INDI, ILENBU, IBIND, I, IA1, IA2,
     *   INCX, BO, VO, NUMVIS, XCOUNT, NCORI
      LOGICAL   T, F, WSEL1, WSEL2
      INCLUDE 'DTCHK.INC'
      REAL      BASEN, CBUFF(UVBFSS), TIME
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI /16/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
      IF (ISCOMP) INCX = 3
C                                       Number of visibilities in input
C                                       and output files.
      NCORI = (LREC - NRPARM) / CATBLK(KINAX)
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Out of data?
         IF (INIO.LE.0) GO TO 200
C                                       Loop over buffer
         DO 190 I = 1,INIO
            IF (ILOCB.GE.0) THEN
               BASEN = BUFF1(IPTRI+ILOCB)
               IA1 = BASEN / 256. + 0.1
               IA2 = BASEN - IA1*256. + 0.1
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               END IF
C                                       Antenna selection
            CALL AMATCH (IA1, IANTSL, NANTSL, WANTSL, WSEL1)
            CALL AMATCH (IA2, IANTSL, NANTSL, WANTSL, WSEL2)
            IF (.NOT.(WSEL1.OR.WSEL2)) GO TO 190
C                                       Time range selection
            TIME = BUFF1(IPTRI+ILOCT)
            IF ((TIME.LT.TSELCT(1)).OR.(TIME.GT.TSELCT(2))) GO TO 190
C
            NUMVIS = NUMVIS + 1
C                                      Call user routine.
            IF (ISCOMP) THEN
C                                       Compressed data.
               CALL ZUVXPN (NCORI, BUFF1(IPTRI+NRPARM),
     *            BUFF1(IPTRI+ILOCWT), CBUFF)
               CALL UVSTAT (NUMVIS, CBUFF, INCX, IRET)
            ELSE
C                                       Un compressed data
               CALL UVSTAT (NUMVIS, BUFF1(IPTRI+NRPARM), INCX, IRET)
               END IF
C                                       Branch on his return
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
               END IF
            IPTRI = IPTRI + LREC
 190        CONTINUE
C                                       Read next buffer.
         GO TO 100
C                                       Final call to UVSTAT.
 200     NUMVIS = -1
         CALL UVSTAT (NUMVIS, BUFF1, INCX, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
            END IF
C                                       Close input file
      CALL ZCLOSE (LUNI, INDI, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVCHK: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1030 FORMAT ('UVCHK: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('UVCHK: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('UVSTAT: UVSTAT ERROR',I3)
      END
      SUBROUTINE UVSTAT (NUMVIS, VIS, INCX, IRET)
C-----------------------------------------------------------------------
C   Compile test statistics for each uv-record.
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      INCX    I    Increment in visibility array.
C      VIS     R(*) Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C   Output:
C      IRET       I    Return code  0 => ok; else error.
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, INCX, IRET
      REAL      VIS(INCX,*)
C
      INCLUDE 'INCS:PSTD.INC'
      DOUBLE PRECISION DAMP, DPHAS, DIFF(2)
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXI, J
      INCLUDE 'DTCHK.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.GT.0) THEN
C                                       Compare with (1,0)
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
         DO 40 JIF = 1,NIF
            DO 30 JF = 1,NF
               DO 20 JS = 1,NS
                  INDEXI = (JIF-1) * JNCIF + (JF-1) * JNCF +
     *               (JS-1) * JNCS + 1
C                                       Skip blanked data
                  IF ((VIS(1,INDEXI).EQ.FBLANK) .OR.
     *               (VIS(2,INDEXI).EQ.FBLANK) .OR.
     *               (VIS(3,INDEXI).LE.0.0)) GO TO 20
C                                       Accumulate test statistics
                  DAMP = SQRT (VIS(1,INDEXI) ** 2 +
     *               VIS(2,INDEXI) ** 2)
C                                       Trap case of zero amplitude
                  IF (DAMP.GT.0.0D0) THEN
                     DPHAS = ATAN2 (VIS(2,INDEXI), VIS(1,INDEXI))
                     DPHAS = DPHAS * RAD2DG
                  ELSE
                     DPHAS = 0.0D0
                     END IF
C                                       Amp. and phase only
                  DIFF(1) = DAMP - 1.0D0
                  DIFF(2) = DPHAS
                  DERAVG(1) = DERAVG(1) + DAMP
                  DERAVG(2) = DERAVG(2) + DPHAS
                  NXSTAT = MIN (NXSTAT+1, MXSTAT)
                  DO 15 J = 1, 2
                     DERSUM(J) = DERSUM(J) + DIFF(J)
                     DERSQ(J) = DERSQ(J) + DIFF(J) ** 2
                     DSBUFF(NXSTAT,J) = DIFF(J)
 15                  CONTINUE
                  NERCNT = NERCNT + 1
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
C                                       Last call: compute statistics
      ELSE
         CALL ERSTAT (IRET)
         END IF
C
 999  RETURN
C----------------------------------------------------------------------
      END
      SUBROUTINE ERSTAT (IRET)
C----------------------------------------------------------------------
C   Compute error statistics
C   Output:
C      IRET     I      Return code (0=> ok; else error)
C----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'DTCHK.INC'
      DOUBLE PRECISION DQA, DQB
      INTEGER J, N4A, N4B, MEDIAN, NADJ
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C                                       Loop over (amp,phas,delay,rate
C                                        and acceleration)
      DO 100 J = 1, 5
         IF (NERCNT.GT.0) THEN
            DERAVG(J) = DERAVG(J) / NERCNT
            DERSUM(J) = DERSUM(J) / NERCNT
            DERSQ(J) = DERSQ(J) / NERCNT
            DERRMS(J) = SQRT (DERSQ(J) - DERSUM(J) ** 2)
            END IF
C                                       Non-parametric variance
C                                       (F-pseudovariance)
C                                       First sort in descending order
         IF (NXSTAT.EQ.0) THEN
            DERPVR(J) = 0.0
         ELSE
            CALL DSORT (NXSTAT, DSBUFF(1,J))
            MEDIAN = (NXSTAT + 1) / 2
C                                       Depth of fourths
            N4B = (MEDIAN + 1) / 2
            N4A = NXSTAT - N4B + 1
            IF (MOD (MEDIAN,2).EQ.0) THEN
               NADJ = MIN (N4B+1, NXSTAT)
               DQB = (DSBUFF(N4B,J) + DSBUFF(NADJ,J)) / 2.0D0
               NADJ = MAX (N4A-1, 1)
               DQA = (DSBUFF(N4A,J) + DSBUFF(NADJ,J)) / 2.0D0
            ELSE
               DQB = DSBUFF(N4B,J)
               DQA = DSBUFF(N4A,J)
               END IF
C                                       F-pseudovariance
            DERPVR(J) = (DQB - DQA) / 1.349
            END IF
C
100      CONTINUE
C                                       Exit
      RETURN
      END
      SUBROUTINE AMATCH (IANT, IANTSL, NANTSL, WANTSL, WMATCH)
C----------------------------------------------------------------------
C   Antenna selection
C   Inputs:
C      IANT      I      Antenna number to match
C      IANTSL    I(*)   List of selected antennas
C      NANTSL    I      Element count in IANTSL
C      WANTSL    L      True if the listed antennas are selected;
C                       else anything but the listed antennas.
C   Output:
C      WMATCH    L      True if IANT is selected
C----------------------------------------------------------------------
      LOGICAL WANTSL, WMATCH
      INTEGER NANTSL
      INTEGER IANT, IANTSL(NANTSL)
C
      INTEGER J
C----------------------------------------------------------------------
C                                       Initialization
      WMATCH = (NANTSL.LE.0)
C                                       Loop over selected antennas
      DO 50 J = 1, NANTSL
         IF (IANTSL(J).EQ.IANT) WMATCH = .TRUE.
50       CONTINUE
C
      IF (.NOT.WANTSL) WMATCH = (.NOT.WMATCH)
C                                       Exit
999   RETURN
      END

LOCAL INCLUDE 'AHIST.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO,
     *   CATOLD(256), NUMHIS, JBUFSZ, XWIN, YWIN, IBLC(2), DBPTR
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOT(2)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6,
     *   HISCRD(10)*64
      REAL      XSEQIN, XDISKI, XSEQO, XDISKO, BLC(7), TRC(7), XXWIN,
     *   XYWIN, PIXRNG(2), BUFF1(MABFSS), BUFF2(MABFSS), DB(MAXIMG,29),
     *   OLDR(256)
      EQUIVALENCE (CATOLD, OLDR)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XNAMOU, XCLAOT,
     *   XSEQO, XDISKO, BLC, TRC, XXWIN, XYWIN, PIXRNG
      COMMON /CHPARM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, HISCRD
      COMMON /PARMS/ CATOLD, SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO,
     *   OLDCNO, JBUFSZ, NUMHIS, XWIN, YWIN, IBLC, DBPTR
      COMMON /BUFRS/ BUFF1, BUFF2, DB
LOCAL END
      PROGRAM AHIST
C-----------------------------------------------------------------------
C! Task to alter image intensities by windowed histogram equalization
C# Map-util Analysis
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000, 2008, 2010, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AHIST does a histogram equalization of pixel intensities using only
C   those pixels within a 2-dimensional window surrounding the pixel.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLAOUT        Class of the output image.
C                                   Default is input class.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      XINC           XWIN          X window size in pixels
C      YINC           YWIN          X window size in pixels
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'AHIST.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'AHIST '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL AHEIN (PRGM, IRET)
C                                       Call routine that sends data
C                                       to the user routine.
      IF (IRET.EQ.0) CALL AHEDO (IRET)
C                                       History
      IF (IRET.EQ.0) CALL AHEHIS
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE AHEIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   AHEIN gets input parameters for AHIST and creates an output file.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, MTYPE*2
      INTEGER   IERR, NPARM, IROUND
      REAL      RTEMP(2)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'AHIST.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 32
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOT, CLAOUT)
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO = IROUND (XDISKO)
      XWIN = IROUND (XXWIN)
      IF (XWIN.LE.1) XWIN = 11
      XWIN = MAX (5, MIN (29, XWIN))
      XWIN = (XWIN / 2) * 2 + 1
      YWIN = IROUND (XYWIN)
      IF (YWIN.LE.1) YWIN = 11
      YWIN = MAX (5, MIN (29, YWIN))
      YWIN = (YWIN / 2) * 2 + 1
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, 'READ', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       set input range
      RTEMP(1) = PIXRNG(1)
      RTEMP(2) = PIXRNG(2)
      CALL RNGSET (RTEMP, OLDR(KRDMX), OLDR(KRDMN), PIXRNG)
C                                       Copy old CATBLK to new.
      CALL COPY (256, CATOLD, CATBLK)
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATOLD(KIDIM), CATOLD(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Set output units.
      CALL CHR2H (8, 'HISTEQAL', 1, CATH(KHBUN))
C                                       Set axes in output CATBLK.
      CALL SUBHDR (BLC, TRC, 1, 1)
C                                       Create output file.
      NEWCNO = 1
      IRET = 4
      CALL MCREAT (DISKO, NEWCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy most keywords
      CALL KEYPCP (DISKIN, OLDCNO, DISKO, NEWCNO, 0, ' ', IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AHEIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1060 FORMAT ('AHEIN: ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE AHEDO (IRET)
C-----------------------------------------------------------------------
C   AHEDO sends image one row at a time to the user supplied
C   routine and then writes the modified data.
C   Output:
C      IRET   I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER IFILE*48
      INTEGER   IROUND, LUNI, LUNO, NYI, NXI, WINI(4), NXO, NYO,
     *   WINO(4), BOI, BOO, LIM2, LIM3, LIM4, LIM5, LIM6, LIM7, I1, I2,
     *   I3, I4, I5, I6, I7, IPOS(7), CORN(7), BOTEMP, KOFF, LIMO,
     *   LIMIT, IBIND, OBIND, INDI, INDO, LIM1, DIDRET, OUTCNT
      REAL      OUTMAX, OUTMIN
      LOGICAL   T, F, BLNKD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'AHIST.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI, LUNO /16,17/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open the data files
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Setup for I/O
      NXI = CATOLD(KINAX)
      NYI = CATOLD(KINAX+1)
      NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      OUTMAX = -1.0E20
      OUTMIN = 1.0E20
      BLNKD = F
      IBLC(1) = BLC(1) + 0.1
      IBLC(2) = BLC(1) + 0.1
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
      KOFF = 0
      CORN(7) = 1
      LIMO = CATBLK(KINAX) - 1
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         CORN(7+KOFF) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            CORN(6+KOFF) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               CORN(5+KOFF) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  CORN(4+KOFF) = I4
                  DO 300 I3 = 1,LIM3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     CORN(3+KOFF) = I3
                     WRITE (MSGTXT,1090) IPOS(3)
                     CALL MSGWRT (1)
C                                       Init. files, first input.
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1099) IRET
            GO TO 990
            END IF
         BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'READ', IRET
            GO TO 990
            END IF
C                                       Init output file.
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORN(3), BOTEMP,
     *      IRET)
         BOO = BOTEMP + 1
         CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO, BUFF2,
     *      JBUFSZ, BOO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'WRIT', IRET
            GO TO 990
            END IF
         DIDRET = 0
         OUTCNT = NYO
         DO 220 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
C                                       Read.
            CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'READ', IRET
               GO TO 990
               END IF
C                                       Check for deferred output.
            IF (DIDRET.GE.0) THEN
               CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IRET)
               OBIND = OBIND - 1
               OUTCNT = OUTCNT - 1
               IF (OUTCNT.LT.0) THEN
                  WRITE (MSGTXT,1113)
                  GO TO 990
                  END IF
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1120) 'WRIT', IRET
                  GO TO 990
                  END IF
               END IF
C                                       Call ADHIST
            IF (DIDRET.GE.0) OBIND = OBIND + 1
            CALL ADHIST (IPOS, BUFF1(IBIND), BUFF2(OBIND), IRET)
            DIDRET = IRET
C                                       Error
            IF (DIDRET.GT.0) THEN
               WRITE (MSGTXT,1180) IRET
               GO TO 990
C                                       output is now desired
            ELSE IF (DIDRET.EQ.0) THEN
C                                       Check max, min, blanking.
               LIMIT = OBIND + LIMO
               DO 200 I1 = OBIND,LIMIT
                  IF (BUFF2(I1).NE.FBLANK) THEN
                     OUTMAX = MAX (OUTMAX, BUFF2(I1))
                     OUTMIN = MIN (OUTMIN, BUFF2(I1))
                  ELSE
                     BLNKD = .TRUE.
                     END IF
 200              CONTINUE
               END IF
 220        CONTINUE
C                                       Read out any remaining rows
C                                       from ADHIST.
            IF (OUTCNT.GT.0) THEN
               DO 260 I2 = 1,OUTCNT
                  IPOS(1) = -1
C                                       Check if write requested.
                  CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1120) 'WRIT', IRET
                     GO TO 990
                     END IF
C                                       Call ADHIST
                  CALL ADHIST (IPOS, BUFF1(IBIND), BUFF2(OBIND), IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1180) IRET
                     GO TO 990
                     END IF
C                                       Check max, min, blanking.
                  LIMIT = OBIND + LIMO
                  DO 250 I1 = OBIND,LIMIT
                     IF (BUFF2(I1).NE.FBLANK) THEN
                        OUTMAX = MAX (OUTMAX, BUFF2(I1))
                        OUTMIN = MIN (OUTMIN, BUFF2(I1))
                     ELSE
                        BLNKD = .TRUE.
                        END IF
 250                 CONTINUE
 260              CONTINUE
               END IF
C                                       Flush buffer.
            CALL MDISK ('FINI', LUNO, INDO, BUFF2, OBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'FINI', IRET
               GO TO 990
               END IF
C                                       Update CATBLK.
            CATR(KRDMX) = OUTMAX
            CATR(KRDMN) = OUTMIN
            CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', BUFF1,
     *         IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1260) IRET
               GO TO 990
               END IF
 300     CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Mark blanking in CATBLK.
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
C                                       Close input map.
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AHEDO: ERROR',I3,' OPENING INPUT FILE')
 1020 FORMAT ('AHEDO: ERROR',I5,' OPENING OUTPUT FILE')
 1090 FORMAT ('Beginning plane',I4)
 1099 FORMAT ('AHEDO: COMOFF ERROR',I3)
 1100 FORMAT ('AHEDO: INIT-FOR-',A4,' ERROR',I3)
 1113 FORMAT ('AHEDO: OUTCNT.LT.0! Too many output rows returned.')
 1120 FORMAT ('AHEDO: ',A,' ERROR',I3)
 1180 FORMAT ('AHEDO: ADHIST ERROR',I3)
 1260 FORMAT ('AHEDO: CATIO ERROR',I3,' UPDATING CATBLK')
      END
      SUBROUTINE AHEHIS
C-----------------------------------------------------------------------
C   AHEHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER LINE*80, NOTTYP*2
      INTEGER   LUN1, LUN2, IERR
      LOGICAL   T
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'AHIST.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NOTTYP /'CC'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       BLC
      WRITE (LINE,2000) TSKNAM, BLC
      CALL HIADD (LUN2, LINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       TRC
      WRITE (LINE,2001) TSKNAM, TRC
      CALL HIADD (LUN2, LINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       X window
      WRITE (LINE,2002) TSKNAM, 'X', XWIN, 'columns'
      CALL HIADD (LUN2, LINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Y window
      WRITE (LINE,2002) TSKNAM, 'Y', YWIN, 'rows'
      CALL HIADD (LUN2, LINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Pixel range
      WRITE (LINE,2003) TSKNAM, PIXRNG
      CALL HIADD (LUN2, LINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (1, NOTTYP, LUN1, LUN2, DISKIN, DISKO, OLDCNO,
     *   NEWCNO, CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AHEHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 2000 FORMAT (A6,'BLC =',6(F6.0,','),F6.0)
 2001 FORMAT (A6,'TRC =',6(F6.0,','),F6.0)
 2002 FORMAT (A6,A1,'WIN = ',I3,10X,' / ',A,' in histogram window')
 2003 FORMAT (A6,'PIXRANGE =',1PE11.3,' ,',1PE11.3,4X,
     *   '/ pixel range limit')
      END
      SUBROUTINE ADHIST (IPOS, DATA, RESULT, IRET)
C-----------------------------------------------------------------------
C   Inputs:
C      IPOS   I(7)    BLC (input image) of first value in DATA
C                     IPOS(1) = -1 => no input data this call.
C      DATA   R(*)    Input row, magic value blanked.
C   Values from commons:
C      FBLANK  R      Value of blanked pixel.
C      CATBLK  I      Output catalog header (also CATR, CATD)
C      CATOLD  I      Input catalog header
C   Output:
C      RESULT  R(*)   Output row.
C      IRET    I      Return code   0 => OK
C                                  >0 => error, terminate.
C   Output in COMMON:
C      NUMHIS  I          # history entries (max. 10)
C      HISCRD  C(NUMHIS)  History records
C      CATBLK  I          Catalog header block
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), IRET
      REAL      DATA(*), RESULT(*)
C
      REAL      R
      DOUBLE PRECISION  X, Y, Z, VALS(512), SUM, RL
      INTEGER   LCOL, LY, IY, NHISTO, NVALS, HISTOG(10000), IX, LX,
     *   NHIST, HALFX, JY, I, J, L
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'AHIST.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Data call
      IF (IPOS(1).GT.0) THEN
         LY = IPOS(2) - IBLC(2) + 1
         JY = MOD (LY - 1, YWIN) + 1
         LCOL = CATBLK(KINAX)
         CALL RCOPY (LCOL, DATA, DB(1,JY))
C                                       Defer YWIN/2
         IF (LY.LE.YWIN/2) THEN
            IRET = -1
C                                       Blank YWIN/2
         ELSE IF (LY.LT.YWIN) THEN
            CALL RFILL (LCOL, FBLANK, RESULT)
C                                       Actually do something
         ELSE
            NHISTO = 10000
            NVALS = MIN (500, XWIN*YWIN)
            Y = NHISTO / (PIXRNG(2) - PIXRNG(1))
            CALL FILL (NHISTO, 0, HISTOG)
            NHIST = 0
            HALFX = XWIN / 2
            CALL RFILL (HALFX, FBLANK, RESULT(1))
            CALL RFILL (HALFX, FBLANK, RESULT(LCOL+1-HALFX))
            DO 100 IX = 1,LCOL
C                                       subtract lost column
               LX = IX - XWIN
               IF (LX.GT.0) THEN
                  DO 10 IY = 1,YWIN
                     R = DB(LX,IY)
                     IF ((R.NE.FBLANK) .AND. (R.GE.PIXRNG(1)) .AND.
     *                  (R.LE.PIXRNG(2))) THEN
                        R = Y * (R - PIXRNG(1)) + 1.00001
                        IF ((R.GE.1.) .AND. (R.LE.NHISTO)) THEN
                           J = R
                           HISTOG(J) = HISTOG(J) - 1
                           NHIST = NHIST - 1
                           END IF
                        END IF
 10                  CONTINUE
                  END IF
C                                       add next column
               DO 20 IY = 1,YWIN
                  R = DB(IX,IY)
                  IF ((R.NE.FBLANK) .AND. (R.GE.PIXRNG(1)) .AND.
     *               (R.LE.PIXRNG(2))) THEN
                     R = Y * (R - PIXRNG(1)) + 1.00001
                     IF ((R.GE.1.) .AND. (R.LE.NHISTO)) THEN
                        J = R
                        HISTOG(J) = HISTOG(J) + 1
                        NHIST = NHIST + 1
                        END IF
                     END IF
 20               CONTINUE
C                                       Do we need to equalize?
               IF (IX.GE.XWIN) THEN
                  LX = IX - HALFX
                  IF (NHIST.EQ.0) THEN
                     RESULT(LX) = FBLANK
                  ELSE IF (DATA(LX).LT.PIXRNG(1)) THEN
                     RESULT(LX) = - 0.5 / NVALS
                  ELSE IF (DATA(LX).GT.PIXRNG(2)) THEN
                     RESULT(LX) = 1.0 + 0.5 / NVALS
C                                       Find by equalization
                  ELSE
                     VALS(1) = PIXRNG(1)
                     X = REAL (NHIST) / REAL (NVALS)
                     Z = 0.0
                     L = 1
                     RL = 0.0
                     SUM = 0.0
                     DO 50 I = 1,NVALS
                        DO 30 J = L,NHISTO
                           SUM = SUM + HISTOG(J)
                           IF (SUM.GE.X) GO TO 40
                           L = L + 1
 30                        CONTINUE
                        VALS(I+1) = (VALS(I) + PIXRNG(2)) / 2.0
                        GO TO 50
C                                       get value
 40                     Z = SUM - X
                        RL = L - (Z / HISTOG(L)) * (L - RL)
                        VALS(I+1) = PIXRNG(1) + RL / Y
                        IF (DATA(LX).LT.VALS(I+1)) GO TO 60
                        SUM = Z - HISTOG(L)
 50                     CONTINUE
                     I = NVALS + 1
                     VALS(NVALS+2) = PIXRNG(2)
                     VALS(NVALS+3) = PIXRNG(2) + 1.E9
 60                  IF (VALS(I+1).GT.VALS(I)) THEN
                        RESULT(LX) = (I - 1.0 + (DATA(LX) - VALS(I)) /
     *                     (VALS(I+1) - VALS(I))) / (NVALS + 1.0)
                     ELSE
                        RESULT(LX) = FBLANK
                        END IF
                     IF ((RESULT(LX).GT.1.01) .OR.
     *                  (RESULT(LX).LT.-0.01)) THEN
                        WRITE (MSGTXT,1060) LX, LY
                        CALL MSGWRT (6)
                        WRITE (MSGTXT,1061) I, VALS(I+1), VALS(I),
     *                     DATA(LX)
                        CALL MSGWRT (6)
                        END IF
                     END IF
                  END IF
 100           CONTINUE
            END IF
C                                       No data in, return blanked
      ELSE IF (IPOS(1).EQ.-1) THEN
         LCOL = CATBLK(KINAX)
         CALL RFILL (LCOL, FBLANK, RESULT)
C                                       Error
      ELSE
         IRET = 99
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1060 FORMAT ('Warning: odd result at x,y',2I6)
 1061 FORMAT ('I vals(i+1) vals(i) data(lx)',I5,3F10.4)
      END

      SUBROUTINE ZTKOPN (IERR)
C-----------------------------------------------------------------------
C! open a TK device
C# Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2004, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Open a Tektronix device (calls ZTKOP2 to perform the actual open).
C   Output:
C      IERR   I   Error return code: 0 => no error
C                    1 => LUN already in use
C                    2 => no such logical device
C                    3 => device not found
C                    4 => exclusive use denied
C                    5 => no room for LUN in FTAB
C                    6 => other open errors
C   Also sets up DTKS.INC common
C   Generic version.   VMS COMMENTED OUT
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      CHARACTER PNAME*48
      HOLLERITH HNAME(12)
      INTEGER   FCBOFF, DELMAX, DLMAX2, DELCNT, DLCNT2, MAXTRY, IDELAY,
     *   WAITED, JERR, I, J
      LOGICAL   F
      REAL      TDELAY
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTKS.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA F /.FALSE./
      DATA IDELAY, DELMAX, DLMAX2 /2, 15, 10/
C-----------------------------------------------------------------------
      TKLUN = 7
      IERR = 0
      DELCNT = 0
      DLCNT2 = 0
      WAITED = 0
C                                       Allocate area in FTAB for LUN.
      CALL LSERCH ('OPEN', TKLUN, TKFIND, F, JERR)
      IF (JERR.EQ.0) GO TO 30
C                                       LUN already in use.
         IF (JERR.NE.2) GO TO 20
            IERR = 1
            WRITE (MSGTXT,1010) TKLUN
            GO TO 995
C                                       No room in FTAB for LUN.
 20      IF (JERR.NE.3) GO TO 30
            IERR = 5
            WRITE (MSGTXT,1020) TKLUN
            GO TO 995
C                                       Build physical file name for
C                                       Tektronix device.
 30   CALL ZPHFIL ('TK', 1, 0, 0, PNAME, IERR)
      IF (IERR.EQ.0) GO TO 50
         IERR = 6
         WRITE (MSGTXT,1030)
         GO TO 900
C                                       Open Tektronix device.
 50   FCBOFF = TKFIND + NMOFF
C     IF (SYSTYP.EQ.'VMS') THEN
C        CALL ZTKOP2 (FTAB(FCBOFF), PNAME, TKTYPE, IERR)
C     ELSE
         CALL CHR2H (48, PNAME, 1, HNAME)
         CALL ZTKOP2 (FTAB(FCBOFF), HNAME, TKTYPE, IERR)
C        END IF
C                                       store file name
      IF (IERR.EQ.0) THEN
         CALL FSERCH (TKFIND, I, J, JERR)
         IF (JERR.EQ.0) THEN
            IF (I.EQ.1) DEVNAM(J) = PNAME
            IF (I.EQ.2) NONNAM(J) = PNAME
            IF (I.EQ.3) MAPNAM(J) = PNAME
            END IF
         TKPOS = 0
         CALL RFILL (TKSIZE, 0.0, TKBUFF)
         GO TO 999
      ELSE
C                                       Device busy.  Wait and try again
C                                       once with no message, then every
C                                       IDELAY secs up to DELMAX*DLMAX2
C                                       times.  Issue a message every
C                                       DELMAX*IDELAY secs.
         IF (IERR.EQ.4) THEN
            IF (WAITED.NE.IDELAY) GO TO 52
               WRITE (MSGTXT,1050)
               CALL MSGWRT (2)
               MAXTRY = DELMAX * DLMAX2
               WRITE (MSGTXT,1051) MAXTRY, IDELAY
               CALL MSGWRT (2)
 52         DELCNT = DELCNT + 1
            IF (DELCNT.GT.DELMAX) GO TO 55
               TDELAY = IDELAY * 1.0
               CALL ZDELAY (TDELAY, IERR)
               WAITED = WAITED + IDELAY
               GO TO 50
 55         DLCNT2 = DLCNT2 + 1
C                                       Device still busy message.
            IF (DLCNT2.LT.DLMAX2) THEN
               WRITE (MSGTXT,1055) WAITED
               CALL MSGWRT (2)
               DELCNT = 0
               GO TO 50
C                                       Device unavailable.
            ELSE
               WRITE (MSGTXT,1060)
               END IF
C                                       No such logical device.
         ELSE IF (IERR.EQ.2) THEN
            WRITE (MSGTXT,1070) PNAME(1:24)
C                                       No such device
         ELSE IF (IERR.EQ.3) THEN
            WRITE (MSGTXT,1080) PNAME(1:24)
C                                       Other open error.
         ELSE
            CALL ZERROR ('ZTKOP2', FTAB(FCBOFF+FCBERR), PNAME,
     *         FTAB(FCBOFF), F)
            GO TO 910
            END IF
         END IF
C                                       Error
 900  CALL MSGWRT (6)
C                                       Remove FTAB entry for LUN.
 910  CALL LSERCH ('CLOS', TKLUN, TKFIND, F, JERR)
      TKFIND = 0
      IF (JERR.EQ.0) GO TO 999
         IERR = IERR + 2
         WRITE (MSGTXT,1900) JERR, 'CLOS', TKLUN
C
 995  CALL MSGWRT (6)
      TKFIND = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ZTKOPN: LUN = ',I2,' ALREADY OPENED IN FTAB')
 1020 FORMAT ('ZTKOPN: NO ROOM IN FTAB FOR LUN = ',I2)
 1030 FORMAT ('ZTKOPN: ZPHFIL ERROR FOR TYPE = TK VOL = 1',
     *   ' SEQ = 0 VER = 0')
 1050 FORMAT ('ZTKOPN: TEKTRONIX DEVICE IS BUSY')
 1051 FORMAT ('ZTKOPN: WILL KEEP TRYING UP TO ',I3,' TIMES AT ',I1,
     *   ' SECOND INTERVALS')
 1055 FORMAT ('ZTKOPN: STILL WAITING FOR TEKTRONIX DEVICE AFTER ',I3,
     *   ' SECONDS')
 1060 FORMAT ('ZTKOPN: TEKTRONIX DEVICE NOT AVAILABLE.')
 1070 FORMAT ('ZTKOPN: NO SUCH LOGICAL DEVICE = ',A24)
 1080 FORMAT ('ZTKOPN: TEKTRONIX DEVICE ',A24,' NOT FOUND')
 1900 FORMAT ('ZTKOPN: LSERCH ERROR = ',I1,' ON ',A4,' FOR LUN = ',I2)
      END

LOCAL INCLUDE 'PANELP'
      INTEGER   MXX
      PARAMETER (MXX=256)
LOCAL END
LOCAL INCLUDE 'PANEL.INC'
      INCLUDE 'INCS:PMAD.INC'
      HOLLERITH XNAME1(3), XCLAS1(2), XNAME2(3), XCLAS2(2), XOUTF(12),
     *   XINLST(12)
      REAL      XSEQ1, XDISK1, XSEQ2, XDISK2, BLC(7), TRC(7), XINC,
     *   YINC, XDOPLT, APARM(10), XDOTV, XCHAN, XGRCH
      COMMON /INPARM/ XNAME1, XCLAS1, XSEQ1, XDISK1, XNAME2, XCLAS2,
     *   XSEQ2, XDISK2, BLC, TRC, XINC, YINC, XOUTF, XDOPLT, APARM,
     *   XINLST, XDOTV, XCHAN, XGRCH
      INTEGER   SEQ1, CNO1, DISK1, SEQ2, CNO2, DISK2, SCRTCH(256),
     *   JBUFSZ, TXLUN, TXIND, IDOPLT, NPARMS, CATOLD(256,2)
      CHARACTER NAME1*12, CLASS1*6, NAME2*12, CLASS2*6, OUTFIL*48,
     *   OPTSTR*32, INLIST*48
      REAL      BUFF1(MABFSS)
      HOLLERITH CATOH(256,2)
      EQUIVALENCE (CATOLD, CATOH)
      COMMON /PARMS/ CATOLD, BUFF1, SCRTCH, SEQ1, CNO1, DISK1, SEQ2,
     *   CNO2, DISK2, JBUFSZ, TXLUN, TXIND, IDOPLT, NPARMS
      COMMON /CPARMS/ NAME1, CLASS1, NAME2, CLASS2, OUTFIL, OPTSTR,
     *   INLIST
LOCAL END
LOCAL INCLUDE 'PANELDATA'
      REAL      MAPSZ, CELLSZ, FOCUS, RESN, RAD(2,10), TR(6), C(21),
     *   NODX(4,100,10), NODY(4,100,10), RMS, PAR(4,100,10), EDGE
      INTEGER   NR, NP(10), OPT, NC
      LOGICAL   PLTOFF
      COMMON /PDATA/ MAPSZ, CELLSZ, FOCUS, RESN, RAD, TR, C, NODX, NODY,
     *   RMS, PAR, NP, NR, OPT, NC, PLTOFF, EDGE
LOCAL END
LOCAL INCLUDE 'PANELPLOT'
      INTEGER   CATSAV(256), PLBUF(256), GLUN, GFIND, TVCHN, GRCHN
      REAL      CH(4)
      COMMON /PLDATA/ CATSAV, PLBUF, CH, GLUN, GFIND, TVCHN, GRCHN
LOCAL END
      PROGRAM PANEL
C-----------------------------------------------------------------------
C! Process holography images from HOLOG/HOLGR to panel adjustments
C# UV ANALYSIS VLA
C-----------------------------------------------------------------------
C;  Copyright (C) 2015, 2017-2018, 2020-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Determine the panel adjustments given a surface deviation map
C   Variables list
C      VDEV     Array of panel deviations, in meters or degrees
C      VMAP     Array of shadowed parts of antenna
C      HIT      Array used in locating panel points
C      RESN     resolution of p.s. function
C      MAPSZ    Physical size of antenna image (m)
C      FOCUS    Antenna focal length
C      MGAIN    Antenna gain with input deviation map
C      MXGN     Antenna gain with no surface errors
C      CELLSZ   Cellsize in meters
C      GAIN     Array of estimated gains
C   Discarded
C      LEGW     Width of antenna feed leg (m)
C      LEGR     Radial distance of feed leg base from axis
C      VTXHT    Height of vertex from bottom of antenna
C   Now in APARM
C      NPT      Number of observed offsets in one row
C      PHSMAP   Is .TRUE. if input map is in phase, otherwise .false.
C      FREQ     Frequency in GHz
C   The panel layout data is in DATA statements in the init routine
C      NR          Number of rings of panels
C      NP(I)       Number of panels in ring 'I'
C      RAD(1,J)    Inner radius (m) of ring 'J'
C      RAD(2,J)    Outer radius (m) of ring 'J'
C-----------------------------------------------------------------------
      INCLUDE 'PANEL.INC'
      INCLUDE 'PANELDATA'
      INCLUDE 'PANELP'
C
      CHARACTER PRGNAM*6
      INTEGER   IRET, MX, VMAP(MXX,MXX)
      REAL      RMS0, LAMBDA, MGAIN, MXGN, GAIN(3,5), VDEV(MXX,MXX),
     *   NDEV(MXX,MXX)
      LOGICAL   HIT(MXX,MXX)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
C
      DATA PRGNAM /'PANEL'/
C-----------------------------------------------------------------------
      MX = MXX
      CALL PANELI (PRGNAM, MX, VDEV, VMAP, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       initial rms
      CALL GETRMS (MX, VDEV, VMAP, RMS)
      WRITE (MSGTXT,1010) 'Initial', RMS
      CALL MSGWRT (4)
      RMS0 = RMS
C                                       Compute the current and maximum
C                                       power gains
      LAMBDA = 35.
      CALL ANTGN (MX, VDEV, VMAP, LAMBDA, MGAIN, MXGN)
      GAIN(1,1) = MGAIN
      GAIN(3,1) = MXGN
      LAMBDA = 20.
      CALL ANTGN (MX, VDEV, VMAP, LAMBDA, MGAIN, MXGN)
      GAIN(1,2) = MGAIN
      GAIN(3,2) = MXGN
      LAMBDA = 13.
      CALL ANTGN (MX, VDEV, VMAP, LAMBDA, MGAIN, MXGN)
      GAIN(1,3) = MGAIN
      GAIN(3,3) = MXGN
      LAMBDA = 7.
      CALL ANTGN (MX, VDEV, VMAP, LAMBDA, MGAIN, MXGN)
      GAIN(1,4) = MGAIN
      GAIN(3,4) = MXGN
      LAMBDA = 3.4
      CALL ANTGN (MX, VDEV, VMAP, LAMBDA, MGAIN, MXGN)
      GAIN(1,5) = MGAIN
      GAIN(3,5) = MXGN
C                                       show the raw data ?
      CALL DOPLOT (1, MX, VDEV, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       do the work
      CALL PANELD (MX, VDEV, VMAP, NDEV, HIT, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Plot adjustment map
      CALL DOPLOT (2, MX, NDEV, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Final rms
      CALL GETRMS (MX, VDEV, VMAP, RMS)
      WRITE (MSGTXT,1010) 'Final', RMS
      CALL MSGWRT (4)
C                                       Compute the expected gain after
C                                       panel adjustment
      LAMBDA = 35.
      CALL ANTGN (MX, VDEV, VMAP, LAMBDA, MGAIN, MXGN)
      GAIN(2,1) = MGAIN
      LAMBDA = 20.
      CALL ANTGN (MX, VDEV, VMAP, LAMBDA, MGAIN, MXGN)
      GAIN(2,2) = MGAIN
      LAMBDA = 13.
      CALL ANTGN (MX, VDEV, VMAP, LAMBDA, MGAIN, MXGN)
      GAIN(2,3) = MGAIN
      LAMBDA = 7.
      CALL ANTGN (MX, VDEV, VMAP, LAMBDA, MGAIN, MXGN)
      GAIN(2,4) = MGAIN
      LAMBDA = 3.4
      CALL ANTGN (MX, VDEV, VMAP, LAMBDA, MGAIN, MXGN)
      GAIN(2,5) = MGAIN
C                                       Plot the residual map
      CALL DOPLOT (3, MX, VDEV, IRET)
      IF (IRET.NE.0) GO TO 995
      CALL DOPLOT (4, MX, NDEV, IRET)
      IF (IRET.NE.0) GO TO 995
      CALL REPORT (RMS0, GAIN)
      GO TO 995
C
 990  CALL MSGWRT (8)
C
 995  IF (TXIND.GT.0) CALL ZTXCLS (TXLUN, TXIND, MX)
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
C-----------------------------------------------------------------------
 1010 FORMAT (A,' rms',F8.2,' mm')
      END
      SUBROUTINE PANELI (PRGNAM, MX, VDEV, VMAP, IRET)
C-----------------------------------------------------------------------
C   PANELI gets the input adverbs and reads in the image
C   Inputs:
C      PRGNAM   C*6    program name
C   Outputs:
C      MX       I      dimension of images
C      VDEV     R(*)   input image
C      VMAP     I(*)   blanking image
C      IRET     I      > 0 => error -> quit
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*(*)
      INTEGER   MX, VMAP(*), IRET
      REAL      VDEV(*)
C
      INCLUDE 'PANEL.INC'
      INCLUDE 'PANELDATA'
C
      INTEGER   IERR, MLUN, MIND, DX, DY, IY, IX, NY, NX, IWIN(4),
     *   IDEPTH(5), I, J, IDATE(3), ITIME(3), JTRIM, IBLKOF, IBIND,
     *   IROUND, LOCS, KEYTYP, MSGSAV, LL, KK
      CHARACTER MTYPE*2, LINE*64, ATIME*8, ADATE*12, STROPT(3)*32,
     *   CUNITS*8, KEYWRD*8, TELESC*8, DATOBS*8
      REAL      CONST, X, Y, RF, SEC
      DOUBLE PRECISION FREQ
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
C                               rigid panel, displaced normal to surface
C                               rigid panel, lifted and tilted
C                               flexible panel.
      DATA STROPT /'Rigid panel, shift only',
     *             'Rigid panel, tilt+shift',
     *             'Flexible panel'/
C-----------------------------------------------------------------------
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NCFILE = 0
      NSCR = 0
C                                       Get input values from AIPS.
      NPARMS = 68
      CALL GTPARM (PRGNAM, NPARMS, RQUICK, XNAME1, SCRTCH, IERR)
      IRET = IERR
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (7)
         END IF
      RQUICK = .FALSE.
C
      IF (IRET.NE.0) GO TO 999
      IRET = 8
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XNAME1, NAME1)
      CALL H2CHR (6, 1, XCLAS1, CLASS1)
      SEQ1 = XSEQ1 + 0.01
      DISK1 = XDISK1 + 0.01
      CALL H2CHR (12, 1, XNAME2, NAME2)
      CALL H2CHR (6, 1, XCLAS2, CLASS2)
      SEQ2 = XSEQ2 + 0.01
      DISK2 = XDISK2 + 0.01
      CALL H2CHR (48, 1, XOUTF, OUTFIL)
      IF (OUTFIL.EQ.' ') OUTFIL = 'HOME:panel.adj'
      CALL H2CHR (48, 1, XINLST, INLIST)
      IF (XDOPLT.EQ.0.0) XDOPLT = 7.0
      IDOPLT = IROUND (XDOPLT)
C                                       get the mask data
      MLUN = 21
      MTYPE = 'MA'
      CALL MAPOPN ('READ', DISK2, NAME2, CLASS2, SEQ2, MTYPE, NLUSER,
     *   MLUN, MIND, CNO2, CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING MASK IMAGE'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK2
      FCNO(NCFILE) = CNO2
      FRW(NCFILE) = 0
      CALL COPY (256, CATBLK, CATOLD(1,2))
C                                       Set default values BLC, TRC.
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'SETTING WINDOW INTO MASK IMAGE'
         GO TO 990
         END IF
      DO 10 I = 1,5
         IDEPTH(I) = BLC(I+2) + 0.1
 10      CONTINUE
      IWIN(1) = BLC(1) + 0.1
      IWIN(2) = BLC(2) + 0.1
      IWIN(3) = TRC(1) + 0.1
      IWIN(4) = TRC(2) + 0.1
      DX = XINC + 0.1
      DX = MAX (1, DX)
      XINC = DX
      DY = YINC + 0.1
      DY = MAX (1, DY)
      YINC = DY
      IX = (IWIN(3) - IWIN(1)) / DX + 1
      IY = (IWIN(4) - IWIN(2)) / DY + 1
      IF ((IX.NE.IY) .OR. ((IX.NE.128) .AND. (IX.NE.256))) THEN
         WRITE (MSGTXT,1010) IX, IY
         GO TO 990
         END IF
      MX = IX
      NX = IWIN(3) - IWIN(1) + 1
      NY = IWIN(4) - IWIN(2) + 1
      JBUFSZ = 2 * MABFSS
C                                       Initialize for double buffering
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH, IBLKOF, IERR)
      IBLKOF = IBLKOF + 1
      CALL MINIT ('READ', MLUN, MIND, CATBLK(KINAX), CATBLK(KINAX+1),
     *   IWIN, BUFF1, JBUFSZ, IBLKOF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INIT I/O FOR MASK'
         GO TO 990
         END IF
C                                       read in mask image
      LL = 0
      DO 30 IY = IWIN(2),IWIN(4)
         CALL MDISK ('READ', MLUN, MIND, BUFF1, IBIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READING MASK IMAGE'
            GO TO 990
            END IF
         IF (MOD(IY-IWIN(2),DY).EQ.0) THEN
            DO 20 IX = IWIN(1),IWIN(3),DX
               LL = LL + 1
               VDEV(LL) = BUFF1(IBIND+IX-IWIN(1))
 20            CONTINUE
            END IF
 30      CONTINUE
C                                       close
      CALL MAPCLS ('READ', DISK2, CNO2, MLUN, MIND, CATBLK, .FALSE.,
     *   SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING MASK IMAGE'
         GO TO 990
         END IF
      NCFILE = NCFILE - 1
C                                       make mask
      LL = 0
      DO 40 J = 1,MX
         DO 35 I = 1,MX
            LL = LL + 1
            IF (VDEV(LL).EQ.FBLANK) THEN
               VMAP(LL) = 0
            ELSE IF (VDEV(LL).LE.APARM(2)) THEN
               VMAP(LL) = 0
            ELSE
               VMAP(LL) = 1
               END IF
 35         CONTINUE
 40      CONTINUE
C                                       get the image data
      CALL MAPOPN ('READ', DISK1, NAME1, CLASS1, SEQ1, MTYPE, NLUSER,
     *   MLUN, MIND, CNO1, CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING MASK IMAGE'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK1
      FCNO(NCFILE) = CNO1
      FRW(NCFILE) = 0
      CALL COPY (256, CATBLK, CATOLD(1,1))
C                                       INIT i/o
      CALL MINIT ('READ', MLUN, MIND, CATBLK(KINAX), CATBLK(KINAX+1),
     *   IWIN, BUFF1, JBUFSZ, IBLKOF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INIT I/O FOR IMAGE DATA'
         GO TO 990
         END IF
C                                       read in data image
      ll = 0
      DO 60 IY = IWIN(2),IWIN(4)
         CALL MDISK ('READ', MLUN, MIND, BUFF1, IBIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READING IMAGE DATA'
            GO TO 990
            END IF
         IF (MOD(IY-IWIN(2),DY).EQ.0) THEN
            DO 50 IX = IWIN(1),IWIN(3),DX
               LL = LL + 1
               VDEV(LL) = BUFF1(IBIND+IX-IWIN(1))
               IF (VDEV(LL).EQ.FBLANK) VMAP(LL) = 0
               IF (VMAP(LL).LE.0) VDEV(LL) = 0.0
C                                       convert to mm
               VDEV(LL) = VDEV(LL) * 1000.0
 50            CONTINUE
            END IF
 60      CONTINUE
      CALL H2CHR (8, 1, CATH(KHDOB), DATOBS)
      CALL H2CHR (8, 1, CATH(KHTEL), TELESC)
C                                       close
      CALL MAPCLS ('READ', DISK1, CNO1, MLUN, MIND, CATBLK, .FALSE.,
     *   SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING IMAGE DATA FILE'
         GO TO 990
         END IF
      NCFILE = NCFILE - 1
C                                       panel parameters
      CALL GETPAN (INLIST, NR, NP, RAD, FOCUS)
      CALL SETNOD (NR, NP, RAD, NODX, NODY)
C                                       Convert to meters
      MAPSZ = 0.0
      CALL AXEFND (4, 'X   ', CATBLK(KIDIM), CATH(KHCTP), I, IERR)
      IF (IERR.EQ.0) THEN
         MAPSZ = CATBLK(KINAX+I) * ABS (CATR(KRCIC+I))
         APARM(3) = MAPSZ
      ELSE
         MSGTXT = 'X axis not found, using APARM(3)'
         CALL MSGWRT (6)
         MAPSZ = APARM(3)
         END IF
      IF (MAPSZ.LE.0.0) THEN
         MSGTXT = 'MAPSIZE IN METERS IS REQUIRED'
         GO TO 990
         END IF
C                                       number samples
      KEYWRD = 'VisUsed'
      I = 1
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL CATKEY ('READ', DISK1, CNO1, KEYWRD, I, LOCS, IX, KEYTYP,
     *   SCRTCH, IERR)
      MSGSUP = MSGSAV
      IF (IERR.EQ.0) THEN
         APARM(5) = IX
         APARM(5) = SQRT (APARM(5))
      ELSE
         MSGTXT = 'APARM(5) is being used since VisUsed not present'
         CALL MSGWRT (7)
         END IF
      APARM(5) = MAX (1.0, APARM(5))
      RESN = MAPSZ / APARM(5)
      CELLSZ = MAPSZ / MX
      EDGE = APARM(6)
      EDGE = MAX (0.0, MIN (0.2, EDGE))
      CALL H2CHR (8, 1, CATH(KHBUN), CUNITS)
      CALL CHLTOU (8, CUNITS)
      IF (CUNITS(:6).EQ.'DEGREE') THEN
         FREQ = 0.0D0
         CALL AXEFND (4, 'FREQ', CATBLK(KIDIM), CATH(KHCTP), I, IERR)
         IF (IERR.EQ.0) THEN
            FREQ = CATD(KDCRV+I)
            APARM(4) = FREQ
         ELSE
            MSGTXT = 'FREQ axis not found, using APARM(4)'
            CALL MSGWRT (6)
            FREQ = APARM(4)
            END IF
         IF (FREQ.LE.0.0D0) THEN
            MSGTXT = 'FREQUENCY IS REQUIRED FOR PHASE IMAGES'
            GO TO 990
            END IF
         CONST = 0.3 / 720.0 / FREQ
         LL = 0
         KK = MX / 2 + 1
         DO 70 J = 1,MX
            Y = KK - J
            DO 65 I = 1,MX
               LL = LL + 1
               X = KK - I
               RF = CELLSZ * SQRT (X**2+Y**2) / (2.*FOCUS)
               SEC = SQRT (1.+RF*RF)
               VDEV(LL) = VDEV(LL) * CONST * SEC
 65            CONTINUE
 70         CONTINUE
         END IF
C                                       open the output file
      TXLUN = 11
      CALL ZTXOPN ('WRIT', TXLUN, TXIND, OUTFIL, .TRUE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING OUTPUT TEXT FILE'
         TXIND = 0
         GO TO 990
         END IF
C                                       telescope, date-obs
      LINE = ' Antenna = ' // TELESC(:4) // '   Date-obs = ' // DATOBS
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'WRITE TEXT FILE HEADER'
         GO TO 990
         END IF
      CALL ZDATE (IDATE)
      CALL ZTIME (ITIME)
      CALL TIMDAT (ITIME, IDATE, ATIME, ADATE)
      LINE = ' Processed : ' // ADATE // ATIME
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'WRITE TEXT FILE HEADER'
         GO TO 990
         END IF
      OPT = APARM(1) + 0.1
      IF ((OPT.LE.0) .OR. (OPT.GT.3)) OPT = 1
      APARM(1) = OPT
      OPTSTR = STROPT(OPT)
      LINE = ' Panel fitting option : ' // OPTSTR
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'WRITE TEXT FILE HEADER'
         GO TO 990
         END IF
      X = (1.0 - 2.*EDGE) ** 2
      WRITE (LINE,1020) EDGE, X
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'WRITE TEXT FILE HEADER'
         GO TO 990
         END IF
C                                       plot parameters
      PLTOFF = .TRUE.
C                                       the array-space mapping
      TR(2) = MAPSZ/MX
      TR(6) = TR(2)
      TR(1) = -MAPSZ/2. - TR(2)
      TR(4) = TR(1)
      TR(3) = 0.
      TR(5) = 0.
C                                       the contour levels (in mm)
C                                       (Contours every 0.5 mm)
      NC = 21
      DO 80 I = 1,NC
         C(I) = (I-11)/2. - 0.25
 80      CONTINUE
C
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PANELI ERROR',I4,' ON ',A)
 1010 FORMAT ('PANELI REQUESTED IMAGE SIZE',2I5,
     *   ' NOT SQUARE 128 OR 256')
 1020 FORMAT (' Edge fraction omitted',F5.2,'  Panel fraction used',
     *   F6.3)
      END
      SUBROUTINE GETPAN (INLIST, NR, NP, RAD, FOCUS)
C-----------------------------------------------------------------------
C   Inputs:
C      INLIST   C*(*)    Input text file
C   Outputs:
C      NR       I        Number rings
C      NP       I(*)     Number panels in each ring
C      RAD      R(2,*)   Inner and outer radius each ring
C      FOCUS    R        Focal length
C-----------------------------------------------------------------------
      CHARACTER INLIST*(*)
      INTEGER   NR, NP(*)
      REAL      RAD(2,*), FOCUS
C
      INTEGER   NRADS
      PARAMETER (NRADS=6)
C
      INTEGER   LUN, IND, NPL(NRADS,2), IRET, KBPLIM, KBP, JTRIM, I
      CHARACTER LINE*132, ANT(2)*4
      DOUBLE PRECISION X
      REAL      RPL(2,NRADS,2), FOC(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA NPL /12,16,24,40,40,40, 20,20,40,40,40,40/
      DATA RPL /1.983,3.683, 3.683,5.563, 5.563,7.391, 7.391,9.144,
     *   9.144,10.87, 10.87,12.5,
     *   1.676,3.518, 3.518,5.423, 5.423,7.277, 7.277,9.081,
     *   9.081,10.808, 10.808,12.500/
      DATA FOC /8.8, 8.75/
      DATA ANT /'VLA ','VLBA'/
C-----------------------------------------------------------------------
      IRET = -1
      FOCUS = -1.0
      NR = 0
      IF ((INLIST.NE.' ') .AND. (INLIST.NE.'VLA') .AND.
     *   (INLIST.NE.'VLBA')) THEN
         LUN = 11
         CALL ZTXOPN ('READ', LUN, IND, INLIST, .FALSE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN', INLIST
            GO TO 90
            END IF
C                                       Read focus
 10      CALL ZTXIO ('READ', LUN, IND, LINE, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ', INLIST
            GO TO 80
         ELSE
            IF ((LINE.NE.' ') .AND. (LINE(:1).NE.'#') .AND.
     *         (LINE(:1).NE.';')) THEN
               KBP = 1
               KBPLIM = JTRIM (LINE)
               CALL GETNUM (LINE, KBPLIM, KBP, X)
               IF (X.NE.DBLANK) FOCUS = X
               END IF
            IF (FOCUS.LE.0.0) GO TO 10
            END IF
C                                       Read panel data
 20      CALL ZTXIO ('READ', LUN, IND, LINE, IRET)
         IF (IRET.EQ.2) THEN
            IRET = 0
            GO TO 80
         ELSE IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ', INLIST
            GO TO 80
         ELSE
            IF ((LINE.NE.' ') .AND. (LINE(:1).NE.'#') .AND.
     *         (LINE(:1).NE.';')) THEN
               NR = NR + 1
               KBP = 1
               KBPLIM = JTRIM (LINE)
               CALL GETNUM (LINE, KBPLIM, KBP, X)
               IF (X.NE.DBLANK) THEN
                  NP(NR) = X + 0.1
                  CALL GETNUM (LINE, KBPLIM, KBP, X)
                  IF (X.NE.DBLANK) THEN
                     RAD(1,NR) = X
                     CALL GETNUM (LINE, KBPLIM, KBP, X)
                     IF (X.NE.DBLANK) RAD(2,NR) = X
                     END IF
                  END IF
               IF (X.EQ.DBLANK) NR = NR - 1
               GO TO 20
               END IF
            END IF
C                                       close text file
 80      CALL ZTXCLS (LUN, IND, KBP)
C
 90      IF (IRET.NE.0) CALL MSGWRT (8)
         END IF
C                                       use VLA on ' ' and error
      IF ((IRET.NE.0) .OR. (FOCUS.LE.0.0) .OR. (NR.LE.0)) THEN
         I = 1
         IF (INLIST.EQ.'VLBA') I = 2
         NR = NRADS
         CALL COPY (NR, NPL(1,I), NP)
         CALL RCOPY (2*NR, RPL(1,1,I), RAD)
         FOCUS = FOC(I)
         MSGTXT = 'GETPAN: using ' // ANT(I) //
     *      ' panel structure and focus'
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETPAN ERROR',I3,' ON ',A,' ',A)
      END
      SUBROUTINE PANELD (MX, VDEV, VMAP, NDEV, HIT, IRET)
C-----------------------------------------------------------------------
C   does main body of computation
C   examine each panel
C      To simplify matters, and yet keep track of the fact that a
C      rectangular grid sits uncomfortably with a circular antenna, we
C      proceed in 4 steps:
C      a. set up a regular (fine) grid on a reference panel oriented
C         along the y-axis
C      b. transform ah point on the grid to the actual panel
C      c. locate the nearest actual sample point
C      d.  transform back to the reference panel.
C   Inputs
C      MX     I      X/Y dimension of arrays
C      VDEV   R(*)   Data array
C      VMAP   I(*)   Mask arrays
C   Outputs
C      NDEV   R(*)   Count of samples hitting pixel
C      HIT    L(*)   work area to mark points used
C-----------------------------------------------------------------------
      INTEGER   MX, VMAP(MX,*), IRET
      REAL      VDEV(MX,*), NDEV(MX,*)
      LOGICAL   HIT(MX,*)
C
      INCLUDE 'PANEL.INC'
      INCLUDE 'PANELDATA'
      INTEGER   I, J, NV, IT, JT, IP, IR, NVT
      REAL      X, Y, TH1, TH2, FI, X1, X2, Y1, Y2, INC, ZETA, XX, FIT,
     *   V(3,500), XI, YI, FI1, XT, YT, RT, MN, DE, NVS, NVSS, NVN
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       set fine enough to locate
C                                       all the points
      INC = 15.0 / MX
      DO 15 I = 1,MX
         DO 10 J = 1,MX
            HIT(J,I) = VMAP(J,I).GT.0
 10         CONTINUE
 15      CONTINUE
C                                       loop over rings
      NVT = 0
      NVS = 0.
      NVSS = 0.
      NVN = 0.
      DO 50 IR = 1,NR
         FI = TWOPI / NP(IR)
         X1 = RAD(1,IR) * SIN (FI/2.0)
         X2 = RAD(2,IR) * SIN (FI/2.0)
         Y1 = RAD(1,IR) * COS (FI/2.0)
         Y2 = RAD(2,IR) * COS (FI/2.0)
         DE = (X2 - X1) * EDGE
         X1 = X1 + DE
         X2 = X2 - DE
         DE =(Y2 - Y1) * EDGE
         Y1 = Y1 + DE
         Y2 = Y2 - DE
C                                       loop over panels
         DO 40 IP = 1,NP(IR)
            IF (IP.EQ.61) THEN
                I = 99
                END IF
            TH1 = (IP-1) * TWOPI / NP(IR)
            TH2 = IP * TWOPI / NP(IR)
            ZETA = (IP-0.5) * FI
            NV = 0
            Y = Y1
 20         IF (Y.LE.Y2) THEN
               XX = X1 + (X2-X1) * (Y-Y1) / (Y2-Y1)
               X = -XX
 30            IF (X.LE.XX) THEN
                  FI1 = ATAN2 (X, Y)
                  FIT = FI1 + ZETA
                  RT = SQRT (X**2 + Y**2)
                  XT = RT * SIN (FIT)
                  YT = RT * COS (FIT)
                  JT = NINT ((XT - TR(1))/TR(2))
                  IT = NINT ((YT - TR(4))/TR(6))
C                                       checks :
C                                       a. is this point truly
C                                          within the panel?
                  XT = TR(1) + TR(2) * JT
                  YT = TR(4) + TR(6) * IT
                  RT = SQRT (XT**2 + YT**2)
                  FIT = ATAN2 (XT, YT)
                  IF (FIT.LT.0.) FIT = FIT + TWOPI
C                                       b.  have we used this point
                  IF ((HIT(JT,IT)) .AND. (FIT.GE.TH1) .AND. (FIT.LE.TH2)
     *               .AND.  (RT.GE.RAD(1,IR)) .AND. (RT.LE.RAD(2,IR)))
     *               THEN
                     NV = NV + 1
C                                       set up the parameters for the
C                                       panel solution -- locate each
C                                       point on the reference panel
                     FI1 = FIT - ZETA
                     V(1,NV) = RT * SIN (FI1)
                     V(2,NV) = RT * COS (FI1) - Y1
                     V(3,NV) = VDEV(JT,IT)
                     HIT(JT,IT) = .FALSE.
C                                       ignore if blanked
                     IF ((VMAP(JT,IT).LE.0) .OR. (VDEV(JT,IT).EQ.0.0))
     *                  NV = NV - 1
                     END IF
                  X = X + INC
                  GO TO 30
                  END IF
               Y = Y + INC
               GO TO 20
               END IF
            NVS = NVS + NV
            NVSS = NVSS + NV * NV
            NVN = NVN + 1.0
            NVT = NVT + NV
C                                       work out panel adjustment
            IF (NV.GT.0) THEN
               CALL SOLVEP (OPT, IR, IP, NV, V, PAR, X1, X2, Y2, IRET)
               IF (IRET.NE.0) THEN
                  I = 1
                  GO TO 999
                  END IF
            ELSE
               CALL RFILL (4, 0.0, PAR(1,IP,IR))
               END IF
 40         CONTINUE
 50     CONTINUE
      IF (NVN.GT.0.0) THEN
         NVS = NVS / NVN
         NVSS = NVSS / NVN - NVS * NVS
         NVSS = SQRT (MAX (0.0, NVSS))
         END IF
      WRITE (MSGTXT,1050) NVT, NVS, NVSS
      CALL MSGWRT (5)

C                                       generate the new surface map

      DO 115 I = 1,MX
         DO 110 J = 1,MX
            HIT(J,I) = VMAP(J,I).GT.0
 110        CONTINUE
 115     CONTINUE
C                                       loop over rings
      DO 150 IR = 1,NR
         FI = TWOPI / NP(IR)
         X1 = RAD(1,IR) * SIN (FI/2.0)
         X2 = RAD(2,IR) * SIN (FI/2.0)
         Y1 = RAD(1,IR) * COS (FI/2.0)
         Y2 = RAD(2,IR) * COS (FI/2.0)
C                                       loop over panels
         DO 140 IP = 1,NP(IR)
            TH1 = (IP-1) * TWOPI / NP(IR)
            TH2 = IP * TWOPI / NP(IR)
            ZETA = (IP-0.5) * FI
            Y = Y1
 120        IF (Y.LE.Y2) THEN
               XX = X1 + (X2-X1)*(Y-Y1)/(Y2-Y1)
               X = -XX
 130           IF (X.LE.XX) THEN
                  FI1 = ATAN2 (X,Y)
                  FIT = FI1 + ZETA
                  RT = SQRT (X**2 + Y**2)
                  XT = RT * SIN (FIT)
                  YT = RT * COS (FIT)
                  JT = NINT ((XT - TR(1))/TR(2))
                  IT = NINT ((YT - TR(4))/TR(6))
C                                       checks :
C                                       a.point  within the panel?
                  XT = TR(1) + TR(2) * JT
                  YT = TR(4) + TR(6) * IT
                  RT = SQRT (XT**2 + YT**2)
                  FIT = ATAN2 (XT, YT)
                  IF (FIT.LT.0.) FIT = FIT + TWOPI
C                                       b. have we used this point ?
                  IF ((HIT(JT,IT)) .AND. (FIT.GE.TH1) .AND. (FIT.LE.TH2)
     *               .AND. (RT.GE.RAD(1,IR)) .AND. (RT.LE.RAD(2,IR)))
     *               THEN
                     FI1 = FIT - ZETA
                     XI = RT * SIN (FI1)
                     YI = RT * COS (FI1) - Y1
                     CALL APPLYP (OPT, PAR, IR, IP, XI, YI, X1, X2,
     *                  Y2, MN)
                     NDEV(JT,IT) = MN
                     VDEV(JT,IT) = VDEV(JT,IT) - NDEV(JT,IT)
                     HIT(JT,IT) = .FALSE.
                     END IF
                  X = X + INC
                  GO TO 130
                  END IF
               Y = Y + INC
               GO TO 120
               END IF
 140        CONTINUE
 150     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('Total image samples used',I8,' average/panel',
     *   F7.1,' rms',F5.1)
      END
      SUBROUTINE GETRMS (MX, V, VMAP, RMS)
C-----------------------------------------------------------------------
C   GETRMS computes the image rms
C   Inputs
C      MX     I      Dimension of arrays
C      V      R(*)   Image
C      VMAP   I(*)   Mask
C   Outputs:
C      RMS    R      Image rms
C-----------------------------------------------------------------------
      INTEGER   MX, VMAP(MX,*)
      REAL      V(MX,*), RMS
C
      INTEGER   I, J
      REAL      CN
C-----------------------------------------------------------------------
      CN =  0.0
      RMS = 0.0
      DO 20 J = 1,MX
        DO 10 I = 1,MX
           IF (VMAP(I,J).GT.0) THEN
              CN  = CN + 1.0
              RMS = RMS + V(I,J)**2
              END IF
 10        CONTINUE
 20     CONTINUE
C
      IF (CN.GT.0.0) RMS = SQRT (RMS/CN)
C
 999  RETURN
      END
      SUBROUTINE SETNOD (NR, NP, RAD, NODX, NODY)
C-----------------------------------------------------------------------
C   compute node points from panel info
C   Inputs:
C      NR     I      Number rings
C      NP     I(*)   Number panels in ring i
C      RAD    R(*)   Radius (m) of inside/outside of ring
C   Outputs:
C      NODX   R(*)   X coordinates of corners
C      NODY   R(*)   Y coordinates of corners
C-----------------------------------------------------------------------
      INTEGER   NR, NP(*)
      REAL      RAD(2,*), NODX(4,100,*), NODY(4,100,*)
C
      INTEGER   I, J
      REAL      TH1, TH2
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       Loop over rings
      DO 20 I = 1,NR
C                                       Loop over panels IN each ring
         DO 10 J = 1,NP(I)
            TH1 = (J-1) * TWOPI / NP(I)
            TH2 = J * TWOPI / NP(I)
C                                       Set coords bottom left corner
C                                       of Jth panel in Ring I.
            NODX(1,J,I) =  RAD(1,I) * SIN(TH1)
            NODY(1,J,I) =  RAD(1,I) * COS(TH1)
C                                       Coords of bottom right corner
            NODX(2,J,I) =  RAD(1,I) * SIN(TH2)
            NODY(2,J,I) =  RAD(1,I) * COS(TH2)
C                                       Coords of top right corner
            NODX(3,J,I) =  RAD(2,I) * SIN(TH2)
            NODY(3,J,I) =  RAD(2,I) * COS(TH2)
C                                       Coords of top left corner
            NODX(4,J,I) =  RAD(2,I) * SIN(TH1)
            NODY(4,J,I) =  RAD(2,I) * COS(TH1)
 10         CONTINUE
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE ANTGN (MX, VDEV, VMAP, LAMBDA, MGAIN, MXGN)
C-----------------------------------------------------------------------
C   This routine calculates the actual and theoretical power gain.
C   It assumes uniform illumination.
C   Inputs:
C      LAMBDA   R   Wavelength
C   Outputs:
C      MGAIN    R   max gain  this roughness
C      MXGN     R   theoretical max gain
C-----------------------------------------------------------------------
      INTEGER   MX, VMAP(MX,*)
      REAL      VDEV(MX,*), LAMBDA, MGAIN, MXGN
C
      INCLUDE 'PANELDATA'
      INTEGER   I, J
      REAL      R, X, Y, VPHS, INTR, INTI, INT2, FACT, Q, AMAX
      DOUBLE PRECISION FORPI
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      FORPI = 4.0D0 * PI
      INTR = 0.0
      INTI = 0.0
      INT2 = 0.
      FACT = 1000. * RESN / LAMBDA
C                                       Convert surface error to phase
C                                       and compute gain loss
      DO 20 J = 1,MX
         Y = TR(4) + J*TR(6)
         DO 10 I = 1,MX
            IF (VMAP(I,J).GT.0) THEN
               X = TR(4) + J*TR(6)
               R = SQRT (X*X + Y*Y)
               Q = R / (2.*FOCUS)
               VPHS = VDEV(I,J) * FORPI / (SQRT(1.+Q*Q) * LAMBDA)
               INTR = INTR + COS (VPHS)
               INTI = INTI + SIN (VPHS)
               INT2 = INT2 + 1.0
               END IF
 10         CONTINUE
 20      CONTINUE
C
      AMAX = SQRT (INTR*INTR + INTI*INTI) / INT2
      AMAX = AMAX * FACT * FACT
      MGAIN = AMAX * FORPI
      MGAIN = 10. * LOG10 (MGAIN)
      MXGN = FACT * FACT * FORPI
      MXGN = 10. * LOG10 (MXGN)
C
 999  RETURN
      END
      SUBROUTINE SOLVEP (OPT, IR, IP, NV, V, PAR, X1, X2, Y2, IRET)
C-----------------------------------------------------------------------
C   Does a solution for 1 panel
C   Inputs:
C      OPT    I      model:
C                    1  rigid panel, displaced normal to surface
C                    2  rigid panel, lifted and tilted
C                    3  flexible panel.
C      IR     I      Ring number
C      IP     I      Panel number
C      NV     I
C      V      R(*)
C      X2     R
C      Y1     R
C      Y2     R
C   Outputs:
C      PAR    R(*)
C      IRET   I
C-----------------------------------------------------------------------
      INTEGER   OPT, IP, IR, NV, IRET
      REAL      V(3,*), PAR(4,100,*), X1, X2, Y2
C
      INTEGER   I, J, NCOUNT
      REAL      MN, X, Y, F, A1, A2, A3, A4
      DOUBLE PRECISION M(4,4), R(4), W(4,4), DBG(4,4)
C-----------------------------------------------------------------------
      IRET = 0
C                                       initialise the arrays:
      DO 10 I = 1,4
         DO 5 J = 1,4
            M(J,I) = 0.
 5          CONTINUE
         R(I) = 0.
 10      CONTINUE
C                                       rigid, shift only
      IF (OPT.EQ.1) THEN
         MN = 0.
         NCOUNT = 0
         DO 20 I = 1,NV
            IF (V(3,I).NE.0.) THEN
               MN = MN + V(3,I)
               NCOUNT = NCOUNT + 1
               END IF
 20         CONTINUE
         MN = MN / NCOUNT
         PAR(1,IP,IR) = MN
C                                       rigid, shift+tilt
      ELSE IF (OPT.EQ.2) then
         DO 30 I = 1,NV
            IF (V(3,I).NE.0.) THEN
               M(1,1) = M(1,1) + V(1,I)*V(1,I)
               M(1,2) = M(1,2) + V(1,I)*V(2,I)
               M(1,3) = M(1,3) + V(1,I)
               M(2,1) = M(1,2)
               M(2,2) = M(2,2) + V(2,I)*V(2,I)
               M(2,3) = M(2,3) + V(2,I)
               M(3,1) = M(1,3)
               M(3,2) = M(2,3)
               M(3,3) = M(3,3) + 1.0
               R(1)   = R(1) + V(3,I)*V(1,I)
               R(2)   = R(2) + V(3,I)*V(2,I)
               R(3)   = R(3) + V(3,I)
               END IF
 30         CONTINUE
         CALL DPCOPY (16, M, DBG)
         CALL GAUSSJ (M, 3, 4, W, 3, 4, IRET)
         IF (IRET.NE.0) GO TO 999
         DO 40 I = 1,3
            MN = 0.
            DO 35 J = 1,3
               MN = MN + M(J,I) * R(J)
 35            CONTINUE
            PAR(I,IP,IR) = MN
 40         CONTINUE
C                                       flexible
      ELSE IF (OPT.EQ.3) then
         DO 50 I = 1,NV
            IF (V(3,I).NE.0.) THEN
               X = V(1,I)
               Y = V(2,I)
               F = X1 + Y*(X2-X1)/Y2
               A1 = (Y2-Y) * (1.-X/F) / (2.0*Y2)
               A2 =     Y  * (1.-X/F) / (2.0*Y2)
               A3 = (Y2-Y) * (1.+X/F) / (2.0*Y2)
               A4 =     Y  * (1.+X/F) / (2.0*Y2)
               M(1,1) = M(1,1) + A1*A1
               M(1,2) = M(1,2) + A1*A2
               M(1,3) = M(1,3) + A1*A3
               M(1,4) = M(1,4) + A1*A4
               M(2,1) = M(1,2)
               M(2,2) = M(2,2) + A2*A2
               M(2,3) = M(2,3) + A2*A3
               M(2,4) = M(2,4) + A2*A4
               M(3,1) = M(1,3)
               M(3,2) = M(2,3)
               M(3,3) = M(3,3) + A3*A3
               M(3,4) = M(3,4) + A3*A4
               M(4,1) = M(1,4)
               M(4,2) = M(2,4)
               M(4,3) = M(3,4)
               M(4,4) = M(4,4) + A4*A4
               R(1)   = R(1) + V(3,i)*A1
               R(2)   = R(2) + V(3,i)*A2
               R(3)   = R(3) + V(3,i)*A3
               R(4)   = R(4) + V(3,i)*A4
               END IF
 50         CONTINUE
         CALL GAUSSJ (M, 4, 4, W, 4, 4, IRET)
         IF (IRET.NE.0) GO TO 999
c        call ludcmp (m,4,4, indx, w)
c        call lubksb (m,4,4, indx, r)
         DO 60 I = 1,4
            MN = 0.
            DO 55 J = 1,4
               MN = MN + M(J,I) * R(J)
 55            CONTINUE
            PAR(I,IP,IR) = MN
 60         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE APPLYP (OPT, PAR, IR, IP, XI, YI, X1, X2, Y2, MN)
C-----------------------------------------------------------------------
C   applies the model to determine the correction
C   Inputs:
C      OPT   I      model:
C                   1  rigid panel, displaced normal to surface
C                   2  rigid panel, lifted and tilted
C                   3  flexible panel.
C      IR    I      Ring number
C      IP    I      Panel number
C      NV    I
C      V     R(*)
C      X1    R
C      X2    R
C      Y2    R
C   Outputs:
C      MN    R      nodel fit value
C-----------------------------------------------------------------------
      INTEGER   OPT, IR, IP
      REAL      PAR(4,100,*), XI, YI, X1, X2, Y2, MN
C
      INTEGER   K
      REAL      F, A(4)
C-----------------------------------------------------------------------
C                                       rigid, lift only
      IF (OPT.EQ.1) THEN
         MN = PAR(1,IP,IR)
C                                       rigid, lift and tilt
      ELSE IF (OPT.EQ.2) then
         MN = XI * PAR(1,IP,IR) + YI * PAR(2,IP,IR) + PAR(3,IP,IR)
C                                       flexible
      ELSE IF (OPT.EQ.3) then
         F = X1 + YI * (X2-X1) / Y2
         A(1) = (Y2-YI) * (1.-XI/F) / (2.0*Y2)
         A(2) =     YI  * (1.-XI/F) / (2.0*Y2)
         A(3) = (Y2-YI) * (1.+XI/F) / (2.0*Y2)
         A(4) =     YI  * (1.+XI/F) / (2.0*Y2)
         MN = 0.
         DO 30 K = 1,4
            MN = MN + A(K) * PAR(K,IP,IR)
 30         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE REPORT (RMS0, GAIN)
C-----------------------------------------------------------------------
C   generate the report to the message terminal and text file
C   Inputs:
C      RMS0   R      initial rms
C      GAIN   R(*)   initial, final, theoretical gains at 5 freq
C-----------------------------------------------------------------------
      REAL      RMS0, GAIN(3,5)
C
      INCLUDE 'PANEL.INC'
      INCLUDE 'PANELDATA'
      INTEGER   IP, IR, K, I, J, JTRIM, IRET
      REAL      X1, X2, Y1, Y2, A(4), Z(4), FI, X(4), Y(4), XI, YI, MN,
     *   F
      CHARACTER LINE *132
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
*-------------------------------------------------------
      WRITE (LINE,1000) 'before', RMS0
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      WRITE (LINE,1000) 'after ', RMS
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Write gain computations
      MSGTXT = 'Estimated Gain Performance -- Uniform Illumination'
      CALL MSGWRT (4)
      LINE = MSGTXT
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      WRITE (MSGTXT,1101)
      CALL MSGWRT (4)
      LINE = MSGTXT
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      MSGTXT =  '---------------------------------------------------'
     :   // '-------'
      CALL MSGWRT (4)
      LINE = MSGTXT
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      WRITE (MSGTXT,1102) ' Uncorrected  |', (GAIN(1,J), J = 1,5)
      CALL MSGWRT (4)
      LINE = MSGTXT
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      WRITE (MSGTXT,1102) '   Corrected  |', (GAIN(2,J), J = 1,5)
      CALL MSGWRT (4)
      LINE = MSGTXT
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      WRITE (MSGTXT,1102) ' Theoretical  |', (GAIN(3,J), J = 1,5)
      CALL MSGWRT (4)
      LINE = MSGTXT
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = ' '
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:1), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = 'Conventions in the following are'
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = '   Units are (INCH/1000).'
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = '   Rings are numbered from inner to outer'
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = '      thus center to rim of dish'
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = '   Panels are numbered clockwise, starting from'
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = '     the highest point as seen from the front'
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = '     looking into the dish'
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = '   Lower means away from subreflector'
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = '   Raise means toward the subreflector'
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = '   LOWER the panel if the number is POSITIVE'
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = '   RAISE the panel if the number is NEGATIVE'
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = ' '
      J = 1
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = 'ring  panel      Inner edge              Outer edge'
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = '                 left     right          left    right'
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
      LINE = '                   A         B             C         D'
      J = JTRIM (LINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       print results
C                                       loop rings
      DO 60 IR = 1,NR
         FI = TWOPI / NP(IR)
         X1 = RAD(1,IR) * SIN(FI/2.0)
         X2 = RAD(2,IR) * SIN (FI/2.0)
         Y1 = RAD(1,IR) * COS (FI/2.0)
         Y2 = RAD(2,IR) * COS (FI/2.0)
         X(1) = -X1
         X(2) =  X1
         X(3) = -X2
         X(4) =  X2
         Y(1) = 0.
         Y(2) = 0.
         Y(3) = Y2 - Y1
         Y(4) = Y2 - Y1
C                                       loop panels
         DO 50 IP = 1,NP(IR)
C                                       rigid, shift only
            IF (OPT.EQ.1) THEN
               DO 10 K = 1,4
                  Z(K) = PAR(1,IP,IR) * 39.37
 10               CONTINUE
C                                       rigid, tilt+shift
            ELSE IF (OPT.EQ.2) THEN
               DO 20 K = 1,4
                  Z(K) = (X(K) * PAR(1,IP,IR)
     *                + Y(K) * PAR(2,IP,IR)
     *                + PAR(3,IP,IR)) * 39.37
 20               CONTINUE
C                                       flexible
            ELSE IF (OPT.EQ.3) then
               DO 40 I = 1,4
                  XI = X(I)
                  YI = Y(I)
                  F = X1 + YI * (X2-X1) / Y2
                  A(1) = (Y2-YI) * (1.-XI/F) / (2.0*Y2)
                  A(2) =     YI  * (1.-XI/F) / (2.0*Y2)
                  A(3) = (Y2-YI) * (1.+XI/F) / (2.0*Y2)
                  A(4) =     YI  * (1.+XI/F) / (2.0*Y2)
                  mn = 0.
                  DO 30 K = 1,4
                     MN = MN + A(K) * PAR(K,IP,IR)
 30                  continue
C                                       convert to INCH/1000.
                  Z(I) = MN * 1000.0 / 25.4
 40               CONTINUE
               END IF
            WRITE (LINE,1140) IR, IP, Z
            J = JTRIM (LINE)
            CALL ZTXIO ('WRIT', TXLUN, TXIND, LINE(:J), IRET)
            IF (IRET.NE.0) GO TO 990
 50         CONTINUE
 60      CONTINUE
      GO TO 995
C
 990  MSGTXT = 'REPORT: ERROR WRITING OUTPUT TEXT FILE'
      CALL MSGWRT (8)
C
 995  CALL ZTXCLS (TXLUN, TXIND, I)
      TXIND = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('rms ',A6,' adjustment :',F9.2,' mm')
 1101 FORMAT (18X,'3.5cm   2.0cm   1.3cm   0.7cm  0.34cm')
 1102 FORMAT (A,5F8.2)
 1140 FORMAT (I3,2X,I3,3X,2F10.0,4X,2F10.0)
      END
      SUBROUTINE GAUSSJ (A, N, NP, B, M, MP, IRET)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      INTEGER   NMAX
      PARAMETER (NMAX = 50)
C
      INTEGER   N, NP, M, MP, IRET
      DOUBLE PRECISION A(NP,NP), B(NP,MP)
C
      INTEGER   IPIV(NMAX), INDXR(NMAX), INDXC(NMAX), I, J, K, IROW,
     *   ICOL, L, LL
      DOUBLE PRECISION BIG, DUM, PIVINV
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      DO 20 J = 1,N
        IPIV(J) = 0
 20     CONTINUE
      IRET = 0
      DO 70 I = 1,N
         BIG = 0.
         DO 30 J = 1,N
            IF (IPIV(J).NE.1) THEN
               DO 25 K = 1,N
                  IF (IPIV(K).EQ.0) THEN
                     IF (ABS(A(J,K)).GE.BIG) THEN
                        BIG = ABS (A(J,K))
                        IROW = J
                        ICOL = K
                        END IF
                  ELSE IF (IPIV(K).GT.1) THEN
                     GO TO 900
                     END IF
 25               CONTINUE
               END IF
 30         CONTINUE

        IPIV(ICOL) = IPIV(ICOL) + 1
        IF (IROW.NE.ICOL) THEN
           DO 35 L = 1,N
              DUM = A(IROW,L)
              A(IROW,L) = A(ICOL,L)
              A(ICOL,L) = DUM
 35           CONTINUE
           DO 40 L = 1,M
              DUM = B(IROW,L)
              B(IROW,L) = B(ICOL,L)
              B(ICOL,L) = DUM
 40           CONTINUE
           END IF

        INDXR(I) = IROW
        INDXC(I) = ICOL
        IF (A(ICOL,ICOL).EQ.0.) THEN
           GO TO 900
           END IF
        PIVINV = 1.0 / A(ICOL,ICOL)
        A(ICOL,ICOL) = 1.
        DO 45 L = 1,N
           A(ICOL,L) = A(ICOL,L) * PIVINV
 45        CONTINUE
        DO 50 L = 1,M
           B(ICOL,L) = B(ICOL,L) * PIVINV
 50        CONTINUE
        DO 65 LL = 1,N
           IF (LL.NE.ICOL) THEN
              DUM = A(LL,ICOL)
              A(LL,ICOL) = 0.
              DO 55 L = 1,N
                 A(LL,L) = A(LL,L) - A(ICOL,L) * DUM
 55              CONTINUE
              DO 60 L = 1,M
                 B(LL,L)=B(LL,L)-B(ICOL,L)*DUM
 60              CONTINUE
               END IF
 65         CONTINUE
 70      CONTINUE

      DO 80 L = N,1,-1
         IF (INDXR(L).NE.INDXC(L)) THEN
            DO 75 K = 1,N
               DUM = A(K,INDXR(L))
               A(K,INDXR(L)) = A(K,INDXC(L))
               A(K,INDXC(L)) = DUM
 75            CONTINUE
            END IF
 80      CONTINUE
      GO TO 999
C
 900  MSGTXT = 'GAUSSJ: MATRIX IS SINGULAR'
      CALL MSGWRT (8)
      IRET = 1
C
 999  RETURN
      END
      SUBROUTINE DOPLOT (TYPE, MX, V, IRET)
C-----------------------------------------------------------------------
C   Generates the full pgplot gray-scale, contour, layout, label
C   Inputs:
C      TYPE   I   1, 2, 3 for stage opf operation
C-----------------------------------------------------------------------
      INTEGER   TYPE, MX, IRET
      REAL      V(MX,*)
C
      INCLUDE 'PANEL.INC'
      INCLUDE 'PANELDATA'
      INTEGER   NBITS, LBITS(6)
C     CHARACTER XL*70, YL*70
      CHARACTER GL*70
      LOGICAL   LAST
C     DATA XL /'X (parallel to EL axis) (m)'/
C     DATA YL /'(m)'/
C-----------------------------------------------------------------------
      NBITS = 6
      CALL ZGTBIT (NBITS, IDOPLT, LBITS)
      IRET = 0
C                                       label
      IF (TYPE.EQ.1) THEN
         WRITE (GL,1001) RMS
      ELSE IF (TYPE.EQ.2) THEN
         WRITE (GL,1002) OPTSTR
      ELSE IF (TYPE.EQ.3) THEN
         WRITE (GL,1003) RMS, OPTSTR
      ELSE IF (TYPE.EQ.4) THEN
         GL = 'Yellow A x, B circle, Green C star, D plus'
         END IF
C                                       aips style plot
      LAST = (TYPE.EQ.4) .OR. ((TYPE.EQ.3) .AND. (LBITS(4).LE.0))
     *   .OR. ((TYPE.EQ.2) .AND. (LBITS(3)+LBITS(4).LE.0))
     *   .OR. ((TYPE.EQ.1) .AND. (LBITS(2)+LBITS(3)+LBITS(4).LE.0))
c      LAST = (TYPE.EQ.3) .OR. ((TYPE.EQ.2) .AND. (LBITS(3).LE.0))
c     *   .OR. ((TYPE.EQ.1) .AND. (LBITS(2)+LBITS(3).LE.0))
      IF (LBITS(TYPE).EQ.1) CALL AIPLOT (LAST, TYPE, GL, MX, V, IRET)
C
 999  RETURN
C-----------------------------------------------------------------------
 1001 FORMAT ('Raw data - rms',F8.2,' mm')
 1002 FORMAT ('Adjustment map - Fit ',A)
 1003 FORMAT ('Residuals - rms',F8.2,' mm   Fit ',A)
      END
      SUBROUTINE AIPLOT (LAST, TYPE, GL, N, V, IRET)
C-----------------------------------------------------------------------
C   generates a full plot in AIPS style
C   Inputs:
C      LAST   L       Last plot?
C      TYPE   I       1, 2, 3
C      GL     C*(*)   Plot title
C      M      I       Dimension of square array V
C      V      R(*)    data array
C   Outputs:
C      IRET   I       error code
C-----------------------------------------------------------------------
      LOGICAL   LAST
      INTEGER   TYPE, N, IRET
      CHARACTER GL*(*)
      REAL      V(N,N)
C
      INCLUDE 'PANEL.INC'
      INCLUDE 'PANELDATA'
      INCLUDE 'PANELPLOT'
      INTEGER   I, J, K, L, M, DD, IVER, IGSIZE, TVCORN(2), ITYPE,
     *   IDEPTH(5), ILABEL, NTEXT, IROUND, IROW(768), JTRIM, IHPVAL,
     *   ILPVAL
      REAL      BIGA(768,768), DIFF, YGAP, LBLC(7), LTRC(7), NBLC(2),
     *   NTRC(2), LXINC, LYINC, RANGE(2), GFAC, GOFF, F, XYRATO, VV, X,
     *   Y, XP(5), YP(5), DX, AX(5), AY(5)
      CHARACTER IGFILE*48, TXTMSG(2)*80, NAMSTR*18, NUMSTR*2
      LOGICAL   SLICE, DOTV
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA TVCORN /2*0/
      DATA SLICE /.FALSE./
C                                       gray 0 -> 4 mm
      DATA F/4.0/
C-----------------------------------------------------------------------
C                                       compute interpolated array
C                                       column interpolation
      DD = 768 / N
      IF (TYPE.EQ.4) THEN
         I = 768 * 768
         CALL RFILL (I, 0.0, BIGA)
         GO TO 65
         END IF
      DO 30 J = 1,N
         L = (J - 1) * DD + 1
         DO 20 I = 1,N-1
            K = (I - 1) * DD + 1
            BIGA(K,L) = V(I,J)
            IF ((V(I,J).NE.FBLANK) .AND. (V(I+1,J).NE.FBLANK)) THEN
               DIFF = (V(I+1,J) - V(I,J)) / DD
               DO 10 M = 1,DD-1
                  BIGA(K+M,L) = BIGA(K,L) + M * DIFF
 10               CONTINUE
            ELSE IF (DD.EQ.3) THEN
               BIGA(K+1,L) = V(I,J)
               BIGA(K+2,L) = V(I+1,J)
            ELSE
               BIGA(K+1,L) = V(I,J)
               BIGA(K+2,L) = V(I,J)
               BIGA(K+3,L) = FBLANK
               BIGA(K+4,L) = V(I+1,J)
               BIGA(K+5,L) = V(I+1,J)
               END IF
 20         CONTINUE
         K = (N - 1) * DD + 1
         BIGA(K,L) = V(N,J)
 30      CONTINUE
C                                       row interpolation
      DO 60 J = 1,N-1
         L = (J - 1) * DD + 1
         IF (DD.EQ.3) THEN
            DO 40 K = 1,3*N-2
               IF ((BIGA(K,L).EQ.FBLANK) .OR. (BIGA(K,L+DD).EQ.FBLANK))
     *            THEN
                  BIGA(K,L+1) = BIGA(K,L)
                  BIGA(K,L+2) = BIGA(K,L+DD)
               ELSE
                  DIFF = (BIGA(K,L+DD) - BIGA(K,L)) / DD
                  BIGA(K,L+1) = BIGA(K,L) + DIFF
                  BIGA(K,L+2) = BIGA(K,L+3) - DIFF
                  END IF
 40            CONTINUE
         ELSE
            DO 50 K = 1,6*N-5
               IF ((BIGA(K,L).NE.FBLANK) .AND. (BIGA(K,L+DD).NE.FBLANK))
     *            THEN
                  DIFF = (BIGA(K,L+DD) - BIGA(K,L)) / DD
                  DO 45 M = 1,DD-1
                     BIGA(K,L+M) = BIGA(K,L) + M * DIFF
 45                  CONTINUE
               ELSE
                  BIGA(K,L+1) = BIGA(K,L)
                  BIGA(K,L+2) = BIGA(K,L)
                  BIGA(K,L+3) = FBLANK
                  BIGA(K,L+4) = BIGA(K,L+DD)
                  BIGA(K,L+5) = BIGA(K,L+DD)
                  END IF
 50            CONTINUE
            END IF
 60      CONTINUE
C                                       add PL file to catalog
 65   IVER = 0
      IF (XDOTV.LE.0.0) THEN
         CALL MADDEX ('PL', DISK1, CNO1, CATBLK, PLBUF, .TRUE., 'UPDT',
     *      IVER, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'ADD PL FILE TO CATALOG HEADER'
            GO TO 995
            END IF
         END IF
C                                       header
      CALL COPY (256, CATBLK, CATSAV)
      CALL SUBHDR (BLC, TRC, XINC, YINC)
      CALL RFILL (7, 1.0, LBLC)
      CALL RFILL (5, 1.0, LTRC(3))
      LTRC(1) = N
      LTRC(2) = LTRC(1)
      LXINC = 1.0 / DD
      LYINC = LXINC
      CALL SUBHDR (LBLC, LTRC, LXINC, LYINC)
      LTRC(1) = (N - 1) * DD + 1
      LTRC(2) = LTRC(1)
C                                       plot init
      LOCNUM = 1
      CALL FILL (5, 1, IDEPTH)
      CALL SETLOC (IDEPTH, .TRUE.)
      CALL ZPHFIL ('PL', DISK1, CNO1, IVER, IGFILE, IRET)
      ITYPE = 65
      IGSIZE = 2
      GLUN = 26
      TVCHN = XCHAN + 0.1
      TVCHN = MAX (1, MIN (NGRAY, TVCHN))
      GRCHN = XGRCH + 0.1
      DOTV = XDOTV.GT.0.0
      XDOPLT = TYPE
      CALL GINIT (DISK1, CNO1, IGFILE, IGSIZE, ITYPE, NPARMS, XNAME1,
     *   DOTV, TVCHN, GRCHN, TVCORN, CATBLK, PLBUF, GLUN, GFIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INITIALIZE PLOT FILE'
         GO TO 990
         END IF
      IF (DOTV) GPHDOD = .TRUE.
C                                       init labeling
      ILABEL = -7
      CALL LABINI (LBLC, LTRC, IDEPTH, CH, ILABEL, SLICE, YGAP, TXTMSG,
     *   NTEXT)
      CH(1) = 5.5
      CH(2) = 3.5
      CH(3) = 0.5
      CH(4) = 4.0
      XYRATO = 1.0
C                                       Init for plotting
      NBLC(1) = LBLC(1) - 0.7
      NBLC(2) = LBLC(2) - 0.7
      NTRC(1) = LTRC(1) + 0.7
      NTRC(2) = LTRC(2) + 0.7
      CALL GINITL (NBLC, NTRC, XYRATO, CH, IDEPTH, PLBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT LINE DRAWING'
         GO TO 990
         END IF
      IF (TYPE.EQ.4) THEN
         RANGE(1) = -0.03
         RANGE(2) = 5.0
      ELSE
         RANGE(1) = 0.0
         RANGE(2) = F / 1000.0
         END IF
      GFAC = 2.0D0 ** MIN (30, NBITWD)  -  4.0D0
      GFAC = (RANGE(2)-RANGE(1)) / GFAC
      GOFF = (RANGE(2)+RANGE(1)) / 2.0D0
      RANGE(2) = (RANGE(2) - GOFF) / GFAC
      RANGE(1) = (RANGE(1) - GOFF) / GFAC
      IHPVAL = IROUND (RANGE(2))
      ILPVAL = IROUND (RANGE(1))
      RANGE(1) = (ILPVAL * GFAC + GOFF)
      RANGE(2) = (IHPVAL * GFAC + GOFF)
      CALL GINITG (ILPVAL, IHPVAL, RANGE, PLBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT GRAY SCALE'
         GO TO 990
         END IF
      CALL GLTYPE (1, PLBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'SET LINE TYPE = 1'
         GO TO 990
         END IF
      M = CATBLK(KINAX)
      IF ((APARM(8).LE.0.0) .AND. (TYPE.LT.4)) THEN
         TXTMSG(1) = 'Start grey scale'
         CALL GCOMNT (2, TXTMSG, PLBUF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'ADD COMMENT'
            GO TO 990
            END IF
         DO 90 J = 1,M
            DO 80 I = 1,M
               IF (BIGA(I,J).NE.FBLANK) THEN
                  VV = (ABS(BIGA(I,J)/1000.0) - GOFF) / GFAC
                  IROW(I) = IROUND (VV)
               ELSE
                  IROW(I) = ILPVAL
                  END IF
 80            CONTINUE
           X = BLC(1)
           Y = J
           CALL GPOS (X, Y, PLBUF, IRET)
           IF (IRET.NE.0) THEN
              WRITE (MSGTXT,1000) IRET, 'GPOS CALL FOR GRAYPX'
              GO TO 990
              END IF
           CALL GRAYPX (M, 0, IROW, PLBUF, IRET)
           IF (IRET.NE.0) THEN
              WRITE (MSGTXT,1000) IRET, 'WRITE LINE OF GRAY SCALE'
              GO TO 990
              END IF
 90        CONTINUE
        END IF
C                                       Now do labels
      TXTMSG(1) = 'Start labeling'
      CALL GCOMNT (-1, TXTMSG, PLBUF, IRET)
      IF (IRET.EQ.0) CALL GLTYPE (1, PLBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'COMMENT AND LINE TYPE'
         GO TO 990
         END IF
      CALL GPOS (NBLC(1), NBLC(2), PLBUF, IRET)
      IF (IRET.EQ.0) CALL GVEC (NTRC(1), NBLC(2), PLBUF, IRET)
      IF (IRET.EQ.0) CALL GVEC (NTRC(1), NTRC(2), PLBUF, IRET)
      IF (IRET.EQ.0) CALL GVEC (NBLC(1), NTRC(2), PLBUF, IRET)
      IF (IRET.EQ.0) CALL GVEC (NBLC(1), NBLC(2), PLBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITING BORDER LINES'
         GO TO 990
         END IF
      CALL CLAB1 (NBLC, NTRC, CH, ILABEL, XYRATO, .FALSE., PLBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITING AXIS LABELS'
         GO TO 990
         END IF
      CALL GPOS (NBLC(1), NTRC(2), PLBUF, IRET)
      J = JTRIM (GL)
      IF (IRET.EQ.0) CALL GCHAR (J, 0, 0.0, 1.0, GL(:J), PLBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE PLOT TITLE'
         GO TO 990
         END IF
      CALL GPOS (NBLC(1), NTRC(2), PLBUF, IRET)
      IF (IRET.EQ.0) THEN
         IF (TYPE.LE.3) THEN
            TXTMSG(1) = 'IMAGE = '
            I = 9
            CALL H2CHR (12, KHIMNO, CATOH(KHIMN,1), NAMSTR(1:12))
            CALL H2CHR (6, KHIMCO, CATOH(KHIMC,1), NAMSTR(13:18))
            CALL NAMEST (NAMSTR, CATOLD(KIIMS,1), TXTMSG(1)(I:), J)
            I = I + J + 4
            TXTMSG(1)(I:) = 'MASK = '
            I = I + 7
            CALL H2CHR (12, KHIMNO, CATOH(KHIMN,2), NAMSTR(1:12))
            CALL H2CHR (6, KHIMCO, CATOH(KHIMC,2), NAMSTR(13:18))
            CALL NAMEST (NAMSTR, CATOLD(KIIMS,2), TXTMSG(1)(I:), J)
         ELSE
            TXTMSG(1) = 'Panel and corner identifier: pink for' //
     *         ' panel outline and numbers'
            end if
         J = JTRIM (TXTMSG(1))
         CALL GCHAR (J, 0, 0.0, 2.5, TXTMSG(1)(:J), PLBUF, IRET)
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE PLOT TITLE'
         GO TO 990
         END IF
C                                       contouring
      IF ((APARM(9).LE.0.0) .AND. (TYPE.LT.4)) THEN
         TXTMSG(1) = 'Do contours'
         CALL GCOMNT (-1, TXTMSG, PLBUF, IRET)
         IF (IRET.EQ.0) CALL GLTYPE (2, PLBUF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'COMMENT AND LINE TYPE'
            GO TO 990
            END IF
         CALL DRWCON (M, 768, BIGA, PLBUF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'DRAWING CONTOURS'
            GO TO 990
            END IF
         END IF
C                                       do panel layout
      IF ((APARM(10).LE.0.0) .OR. (TYPE.EQ.4)) THEN
         TXTMSG(1) = 'Do panel layout'
         CALL GCOMNT (-1, TXTMSG, PLBUF, IRET)
         IF (IRET.EQ.0) CALL GLTYPE (3, PLBUF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'COMMENT AND LINE TYPE'
            GO TO 990
            END IF
         DO 130 I = 1,NR
            DO 120 J = 1,NP(I)
               DO 110 K = 1,4
                  XP(K) = NODX(K,J,I)
                  YP(K) = NODY(K,J,I)
                  XP(K) = CATR(KRCRP) + XP(K) / ABS(CATR(KRCIC))
                  YP(K) = CATR(KRCRP+1) + YP(K) / ABS(CATR(KRCIC+1))
 110              CONTINUE
               XP(5) = XP(1)
               YP(5) = YP(1)
               CALL GPOS (XP(1), YP(1), PLBUF, IRET)
               IF (IRET.EQ.0) CALL GVEC (XP(2), YP(2), PLBUF, IRET)
               IF (IRET.EQ.0) CALL GVEC (XP(3), YP(3), PLBUF, IRET)
               IF (IRET.EQ.0) CALL GVEC (XP(4), YP(4), PLBUF, IRET)
               IF (IRET.EQ.0) CALL GVEC (XP(5), YP(5), PLBUF, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'DRAWING PANEL OUTLINE'
                  GO TO 990
                  END IF
               IF (TYPE.EQ.4) THEN
                  AX(1) = (0.9*(XP(1) + XP(2)) + 1.1*(XP(3) + XP(4)))
     *               / 4.0 - 2.5
                  AY(1) = (0.9*(YP(1) + YP(2)) + 1.1*(YP(3) + YP(4)))
     *               / 4.0 - 2.5
                  WRITE (NUMSTR,1010) J
                  K = 2
                  IF (J.GT.9) THEN
                     K = 1
                     AX(1) = AX(1) - 5.
                     END IF
                  CALL GCHDRW (AX(1), AY(1), 5.0, NUMSTR(K:2), 0, PLBUF,
     *               IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'DRAWING PANEL NUMBERS'
                     GO TO 990
                     END IF
                  END IF
 120           CONTINUE
 130        CONTINUE
         IF (TYPE.EQ.4) THEN
            DX = 2.7
            TXTMSG(1) = 'Mark corners A and B'
            CALL GCOMNT (-1, TXTMSG, PLBUF, IRET)
            IF (IRET.EQ.0) CALL GLTYPE (1, PLBUF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'COMMENT AND LINE TYPE'
               GO TO 990
               END IF
            DO 160 I = 1,NR
               DO 150 J = 1,NP(I)
                  DO 140 K = 1,4
                     XP(K) = NODX(K,J,I)
                     YP(K) = NODY(K,J,I)
                     XP(K) = CATR(KRCRP) + XP(K) / ABS(CATR(KRCIC))
                     YP(K) = CATR(KRCRP+1) + YP(K) / ABS(CATR(KRCIC+1))
 140                 CONTINUE
                  XP(5) = XP(1) + 0.20 * (XP(3) - XP(1))
                  YP(5) = YP(1) + 0.20 * (YP(3) - YP(1))
                  CALL GPOS (XP(5)-DX, YP(5)-DX, PLBUF, IRET)
                  IF (IRET.EQ.0) CALL GVEC (XP(5)+DX, YP(5)+DX, PLBUF,
     *               IRET)
                  IF (IRET.EQ.0) CALL GPOS (XP(5)-DX, YP(5)+DX, PLBUF,
     *               IRET)
                  IF (IRET.EQ.0) CALL GVEC (XP(5)+DX, YP(5)-DX, PLBUF,
     *               IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'DRAWING PANEL SPOT A'
                     GO TO 990
                     END IF
                  AX(1) = XP(2) + 0.20 * (XP(4) - XP(2))
                  AY(1) = YP(2) + 0.20 * (YP(4) - YP(2))
                  AX(2) = AX(1) - DX
                  AX(3) = AX(1) + DX
                  AX(4) = AX(1)
                  AX(5) = AX(1)
                  AY(2) = AY(1)
                  AY(3) = AY(1)
                  AY(4) = AY(1) - DX
                  AY(5) = AY(1) + DX
                  CALL PNTPLT (3, AX, AY, LBLC, LTRC, .FALSE., .FALSE.,
     *               PLBUF, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'DRAWING PANEL SPOT B'
                     GO TO 990
                     END IF
 150              CONTINUE
 160           CONTINUE
            TXTMSG(1) = 'Mark corners C and D'
            CALL GCOMNT (-1, TXTMSG, PLBUF, IRET)
            IF (IRET.EQ.0) CALL GLTYPE (2, PLBUF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'COMMENT AND LINE TYPE'
               GO TO 990
               END IF
            DX = DX * 1.4
            DO 190 I = 1,NR
               DO 180 J = 1,NP(I)
                  DO 170 K = 1,4
                     XP(K) = NODX(K,J,I)
                     YP(K) = NODY(K,J,I)
                     XP(K) = CATR(KRCRP) + XP(K) / ABS(CATR(KRCIC))
                     YP(K) = CATR(KRCRP+1) + YP(K) / ABS(CATR(KRCIC+1))
 170                 CONTINUE
                  XP(5) = XP(3) - 0.20 * (XP(3) - XP(1))
                  YP(5) = YP(3) - 0.20 * (YP(3) - YP(1))
                  CALL GPOS (XP(5)-DX, YP(5), PLBUF, IRET)
                  IF (IRET.EQ.0) CALL GVEC (XP(5)+DX, YP(5), PLBUF,
     *               IRET)
                  IF (IRET.EQ.0) CALL GPOS (XP(5), YP(5)+DX, PLBUF,
     *               IRET)
                  IF (IRET.EQ.0) CALL GVEC (XP(5), YP(5)-DX, PLBUF,
     *               IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'DRAWING PANEL SPOT D'
                     GO TO 990
                     END IF
                  AX(1) = XP(4) - 0.20 * (XP(4) - XP(2))
                  AY(1) = YP(4) - 0.20 * (YP(4) - YP(2))
                  AX(2) = AX(1) - DX
                  AX(3) = AX(1) + DX
                  AX(4) = AX(1)
                  AX(5) = AX(1)
                  AY(2) = AY(1)
                  AY(3) = AY(1)
                  AY(4) = AY(1) - DX
                  AY(5) = AY(1) + DX
                  CALL PNTPLT (17, AX, AY, LBLC, LTRC, .FALSE., .FALSE.,
     *               PLBUF, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'DRAWING PANEL SPOT B'
                     GO TO 990
                     END IF
 180              CONTINUE
 190           CONTINUE
            END IF
         END IF
C                                       Finish up plot file
      GPHPAG = .NOT.LAST
      CALL GFINIS (PLBUF, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINISH THE PLOT'
         GO TO 995
      ELSE IF (IRET.LT.0) THEN
         IDOPLT = 0
         IRET = 0
         END IF
C                                       Write sucessful finish message.
      CALL COPY (256, CATSAV, CATBLK)
      IF (.NOT.DOTV) THEN
         CALL HIPLOT (DISK1, CNO1, IVER, PLBUF, IRET)
         WRITE (MSGTXT,1130) IVER
         CALL MSGWRT (2)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
      CALL COPY (256, CATSAV, CATBLK)
      IF (.NOT.DOTV) THEN
         CALL ZCLOSE (GLUN, GFIND, IRET)
         CALL ZDESTR (DISK1, IGFILE, IRET)
         IF (IVER.GT.0) CALL DELEXT ('PL', DISK1, CNO1, 'READ',
     *      CATBLK, PLBUF, IVER, IRET)
         END IF
      GO TO 999
C
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AIPLOT ERROR',I5,' ON ',A)
 1010 FORMAT (I2)
 1130 FORMAT ('AIPLOT: wrote plot file version',I4)
      END
      SUBROUTINE DRWCON (M, N, V, PLBUF, IRET)
C-----------------------------------------------------------------------
C   DRWCON will write commands to a plot file for the execution of
C   a contour plot.  CONDRW reads from disk, DRWCON uses image in core.
C   Inputs:
C      M       I      Number pixels to use in image
C      N       I      Dimension in X of V
C      V       R(*)   Image
C   In/out:
C      PLBUF   I(*)   Plot buffer
C      IRET    I      Error code
C-----------------------------------------------------------------------
      INTEGER   M, N, PLBUF(*), IRET
      REAL      V(N,*)
C
      INCLUDE 'PANELDATA'
      REAL      VAL(3), XPOS(3), YPOS(3), TEMP, VC, VL, VM, VS, XA, XB,
     *   XL, XLAST, XM, XS, YA, YB, YL, YLAST, YM, YS, DELTAX, DELTAY,
     *   TLEV, XLEV
      INTEGER   IPERM(3,6), IBLCX, IBLCY, IBLCY1, ICOL, II, INDEX, I,
     *   INPIXS, IPLUS, IROW, ISKIP, ITRCX, ITRCXM, ITRCY, ITRI, MININT,
     *   LOCINT, IROUND, ISLEV, JJ, LASTC
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DCNT.INC'
      INCLUDE 'INCS:DGPH.INC'
      DATA IPERM /1,3,2, 3,2,1, 3,1,2, 2,1,3, 1,2,3, 2,3,1/
C-----------------------------------------------------------------------
      ISKIP = 2
      XLAST = -1000.
      YLAST = -1000.
      TEMP = M - 1
      TEMP = 10 - 3 * LOG10 (TEMP)
      LOCINT = IROUND (TEMP)
      IF (LOCINT.LT.2) LOCINT = 2
      IBLCY = 1
      ITRCY = M
      ITRCX = M
      IBLCX = 1
      INPIXS = ITRCX - IBLCX + 1
      LASTC = 0
C                                       magic parms for dashed lines
      XLEV = 256.0 / INPIXS
      TLEV = 256.0 / (ITRCY - IBLCY + 1.0)
      ISLEV = SQRT (1.0 / (XLEV * TLEV)) + 0.1
      IF (ISLEV.LT.1) ISLEV = 1
      IF (XLEV.LT.1.0) XLEV = (SQRT (XLEV) + 3.0*XLEV) / 4.0
C                                       save first row.
      CALL RCOPY (M, V(1,1), RLROW)
C                                       Loop over all rows.
      IBLCY1 = IBLCY + 1
      DO 300 IROW = IBLCY1,ITRCY
C                                       Loop over all pixels in row.
         IPLUS = 0
         ITRCXM = ITRCX - 1
         DO 250 ICOL = IBLCX,ITRCXM
            IPLUS = IPLUS + 1
C                                       Init values
            VAL(1) = V(IPLUS,IROW)
            VAL(2) = V(IPLUS+1,IROW)
            VAL(3) = RLROW(IPLUS)
C                                       Init positions.
            XPOS(1) = ICOL
            XPOS(2) = ICOL + 1
            XPOS(3) = ICOL
            YPOS(1) = IROW
            YPOS(2) = IROW
            YPOS(3) = IROW - 1
C                                       Loop for both triangles.
            DO 200 ITRI = 1,2
C                                       Changes for 2nd triangle.
               IF (ITRI.EQ.2) THEN
                  VAL(1) = RLROW(IPLUS+1)
                  XPOS(1) = ICOL + 1
                  YPOS(1) = IROW - 1
                  END IF
C                                       Order points in triangle.
               DO 130 II = 1,3
                  IF (VAL(II).EQ.FBLANK) GO TO 200
 130              CONTINUE
               INDEX = 0
               IF (VAL(1).GT.VAL(2)) INDEX = 1
               IF (VAL(3).GE.VAL(1)) INDEX = INDEX + 2
               IF (VAL(2).GE.VAL(3)) INDEX = INDEX + 4
C                                       find large, med, small
C                                       values and X,Y positions.
               II = IPERM(1,INDEX)
               VL = VAL(II)
               XL = XPOS(II)
               YL = YPOS(II)
C
               II = IPERM(2,INDEX)
               VM = VAL(II)
               XM = XPOS(II)
               YM = YPOS(II)
C
               II = IPERM(3,INDEX)
               VS = VAL(II)
               XS = XPOS(II)
               YS = YPOS(II)
C                                       Loop for all levels.
               DO 190 II = 1,NC
                  VC = C(II)
C                                       Cut down negatives
                  IF (VC.LT.0.0) THEN
                     IF ((XLEV.LT.2.85) .AND. (ITRI.EQ.2)) THEN
                        GO TO 190
                     ELSE IF (XLEV.LT.1.0) THEN
                        JJ = IROW + ICOL + II
                        IF (MOD(JJ, ISLEV).NE.0) GO TO 190
                        END IF
                     END IF
                  IF ((VC.GT.VL) .OR. ((VL-VS).LE.0.0)) GO TO 200
C                                       If level not right, next lev.
                  IF (VC.LE.VS) GO TO 190
C                                       Interpolate btwn max two corns.
                  TEMP = (VC-VS) / (VL-VS)
                  XA = TEMP * (XL-XS) + XS
                  YA = TEMP * (YL-YS) + YS
C                                       See which corners 2nd pt. btwn.
C                                       Level btwn med & small corners.
                  IF ((VC.LT.VM) .AND. (VM.NE.VS)) THEN
                     TEMP = (VC-VS) / (VM-VS)
                     XB = TEMP * (XM-XS) + XS
                     YB = TEMP * (YM-YS) + YS
C                                       Level btwn large & med corners.
                  ELSE
                     TEMP = (VC-VM) / (VL-VM)
                     XB = TEMP * (XL-XM) + XM
                     YB = TEMP * (YL-YM) + YM
                     END IF
C                                       Issue position & write commands
C                                       We can avoid position command
C                                       if we switch A and B.
                  IF ((XLAST.EQ.XB) .AND. (YLAST.EQ.YB)) THEN
                     TEMP = XA
                     XA = XB
                     XB = TEMP
                     TEMP = YA
                     YA = YB
                     YB = TEMP
C                                       See if we need to position.
                  ELSE IF ((XLAST.NE.XA) .OR. (YLAST.NE.YA)) THEN
                     CALL GPOS (XA, YA, PLBUF, IRET)
                     IF (IRET.NE.0) GO TO 999
                     END IF
C                                       Draw vector.
                  IF (VC.GE.0.0) THEN
                     CALL GVEC (XB, YB, PLBUF, IRET)
                     IF (IRET.NE.0) GO TO 999
                     XLAST = XB
                     YLAST = YB
                     GO TO 190
C                                       Negative contours broken
                  ELSE
                     TEMP = LOCINT * SQRT (((XB-XA)**2 + (YB-YA)**2)
     *                  / 2.0)
                     MININT = IROUND (TEMP)
                     IF (MININT.LT.2) MININT = 2
                     DELTAX = (XB - XA) / MININT
                     DELTAY = (YB - YA) / MININT
                     DO 185 I = 1,MININT,2
                        XB = XA + DELTAX
                        YB = YA + DELTAY
                        CALL GVEC (XB, YB, PLBUF, IRET)
                        IF (IRET.NE.0) GO TO 999
                        IF (I.LT.MININT-1) THEN
                           XA = XB + DELTAX
                           YA = YB + DELTAY
                           CALL GPOS (XA, YA, PLBUF, IRET)
                           IF (IRET.NE.0) GO TO 999
                           END IF
 185                    CONTINUE
                     XLAST = XB
                     YLAST = YB
                     END IF
 190              CONTINUE
 200           CONTINUE
 250        CONTINUE
         CALL RCOPY (INPIXS, V(1,IROW), RLROW)
 300     CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'TBOUT.INC'
C                                       Local include for TBOUT
      HOLLERITH XINNAM(3), XINCLS(2), XINEXT(1), XEXTFI(12)
      CHARACTER INNAM*12, INCLS*6, INEXT*2, EXTFIL*48
      REAL      XSEQ, XDISK, XVER, DOCRT, XBCOUN, XECOUN
      INTEGER   DATP(128,2), BUFFER(512), INSEQ, INDISK, INVERS, CNO,
     *   IUSER, NCOL, IBCOL(1000), BCOUNT, ECOUNT
      COMMON /INPARM/ XINNAM, XINCLS, XSEQ, XDISK, XINEXT, XVER, XEXTFI,
     *   DOCRT, XBCOUN, XECOUN
      COMMON /TBLCHR/ INNAM, INCLS, INEXT, EXTFIL
      COMMON /TBOUTC/ DATP, BUFFER, INSEQ, INDISK, INVERS, CNO, IUSER,
     *   NCOL, IBCOL, BCOUNT, ECOUNT
LOCAL END
C                                       Common for card I/O
LOCAL INCLUDE 'CARDIO.INC'
      INTEGER   EXTLUN, EXTIND
      COMMON /CARDIO/ EXTLUN, EXTIND
LOCAL END
      PROGRAM TBOUT
C-----------------------------------------------------------------------
C! Translates between AIPS tables and external files
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2000, 2004, 2007, 2009, 2012, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TBOUT converts between external text files and AIPS tables.
C   AIPS adverbs:                     Use:
C     INNAME     INNAM(3)     Image name: standard defaults, wildcards
C     INCLASS    INCLS(2)     Image class: ditto
C     INSEQ      XSEQ (INSEQ) Image sequence number: ditto
C     INDISK     XDISK (INDISK)  Image disk number: 0 -> any
C     INEXT      INEXT           Extension type: '  ' => 'TA'
C     INVERS     XVER (INVERS)   Extension version number
C     OUTFILE    EXTFIL          External text file.
C     DOCRT      DOCRT           Width of output
C     BCOUNT     BCOUNT          First Row to be stored
C     ECOUNT     ECOUNT          Last Row to be stored
C-----------------------------------------------------------------------
      INTEGER   IERR, NACROS, NCH(128), FCH(128), RESULT(16), IPASS,
     *   NOPASS, NREC, NKEY, TABLUN, JCOL1(128), JCOL2(128),
     *   MAXDIM(128)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'TBOUT.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA TABLUN, NREC /27, 0/
C-----------------------------------------------------------------------
C                                       Get parms, open things
      CALL TBLIIN (IERR)
      IF (IERR.NE.0) THEN
         WRITE(MSGTXT,1900)
         GO TO 990
         END IF
C                                       Open table file
      CALL TABINI ('READ', INEXT, INDISK, CNO, INVERS, CATBLK, TABLUN,
     *   NKEY, NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, INEXT, INVERS
         GO TO 990
         END IF
C                                        init counters, line size
      NREC = BUFFER(5)
      NACROS = DOCRT + 0.1
C                                        start and stop row limits
      BCOUNT = MIN(BCOUNT,NREC)
      ECOUNT = MIN(ECOUNT,NREC)
      IF (ECOUNT.LT.1) ECOUNT = NREC
C                                       Calc text output positions.
      CALL CALPOS (NACROS, NOPASS, JCOL1, JCOL2, MAXDIM, FCH, NCH)
C                                       Open external text file
      CALL OPCARD ('WRIT', EXTFIL, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Write header information.
      CALL EXWTHD (NACROS, NOPASS, MAXDIM, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Loop: all columns for each pass
      DO 100 IPASS = 1, NOPASS
C                                       Label columns for this pass
         CALL LABPAS (JCOL1(IPASS), JCOL2(IPASS), FCH, NCH, RESULT,
     *      IERR)
         IF (IERR.NE.0) GO TO 950
C                                       Output loop
         CALL PUTPAS (MAXDIM(IPASS), JCOL1(IPASS), JCOL2(IPASS), FCH,
     *      NCH, IERR)
         IF (IERR.NE.0) GO TO 950
 100     CONTINUE
C                                       Close down
      CALL TABIO ('CLOS', 3, NREC, RESULT, BUFFER, IERR)
      CALL CLCARD (IERR)
      GO TO 995
C                                       write error
 950  IF (IERR.EQ.3) THEN
         WRITE (MSGTXT,1960) IERR
      ELSE
         WRITE (MSGTXT,1970) IERR
         END IF
C
 990  CALL MSGWRT (8)
C                                       close down
 995  CALL DIE (IERR, BUFFER)
 999  STOP
C-----------------------------------------------------------------------
 1030 FORMAT ('ERROR',I5,' OPENING ',A2,' TABLE VERS=',I6)
 1900 FORMAT ('ERROR',I5,' DURING TBLIIN')
 1960 FORMAT ('ERROR',I5,' READING TABLE DATA')
 1970 FORMAT ('ERROR',I5,' WRITING OUTPUT')
      END
      SUBROUTINE TBLIIN (IERR)
C-----------------------------------------------------------------------
C   TBLIIN performs initialization for AIPS task TBOUT.  It gets the
C   adverbs, opens the catalog file and opens the external file.
C   Output: IERR    I      Error code: 0 => keep going, else quit.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      CHARACTER INTYP*2, STAT*4, PRGN*6
      INTEGER   NPARM, IROUND, IRET
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'TBOUT.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGN /'TBOUT '/
C-----------------------------------------------------------------------
C                                       AIPS init
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NCFILE = 0
      NSCR = 0
C                                       get adverbs
      NPARM = 24
      IERR = 0
      CALL GTPARM (PRGN, NPARM, RQUICK, XINNAM, DATP, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       restart AIPS
      IRET = IERR
      IF (RQUICK) CALL RELPOP (IRET, DATP, IERR)
      IF (IERR.NE.0) GO TO 999
      IERR = 5
C                                       Convert characters
      CALL H2CHR (12, 1, XINNAM, INNAM)
      CALL H2CHR (6, 1, XINCLS, INCLS)
      CALL H2CHR (2, 1, XINEXT, INEXT)
      CALL H2CHR (48, 1, XEXTFI, EXTFIL)
C                                       find file
      INSEQ  = IROUND (XSEQ)
      INDISK = IROUND (XDISK)
      INVERS = IROUND (XVER)
      BCOUNT = IROUND (XBCOUN)
      BCOUNT = MAX(1,BCOUNT)
      ECOUNT = IROUND (XECOUN)
      IF (INEXT.EQ.'  ') INEXT = 'TA'
      IUSER = NLUSER
      IF (DOCRT.LE.40) DOCRT = 80
      IF (DOCRT.GT.1000) DOCRT = 1000
      CNO = 1
      INTYP = '  '
      CALL CATDIR ('SRCH', INDISK, CNO, INNAM, INCLS, INSEQ, INTYP,
     *   IUSER, STAT, DATP, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, INNAM, INCLS, INSEQ, INTYP,
     *      INDISK, IUSER
         GO TO 990
         END IF
C                                       Get catblk, mark file
      CALL CATIO ('READ', INDISK, CNO, CATBLK, 'READ', DATP, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
      NCFILE = 1
      FVOL(1) = INDISK
      FCNO(1) = CNO
C                                       Mark table as read only
      FRW(1) = 0
C     FRW(1) = 1                        Mark as table write
      GO TO 999
C
 990  CALL MSGWRT (8)
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' FINDING INPUT ADVERBS')
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,1X,A2,
     *   'DISK=',I2,' USER=',I5)
 1020 FORMAT ('ERROR',I5,' READING CATBLK FROM CATALOG FILE')
      END
      SUBROUTINE CALPOS (NACROS, NOPASS, JCOL1, JCOL2, MAXDIM, FCH, NCH)
C-----------------------------------------------------------------------
C   CALPOS CALculates the POSition of variables output to a text file
C   Input:  NACROS    I     Number of columns of text file
C   Common: NCOL      I     Number of columns (variables) in table
C   Common: DATP(*,2) I     Array containing variable specification
C   Output: NOPASS    I     Number of passes to output all variables
C           JCOL1(*)  I     Start column output in pass
C           JCOL2(*)  I     End column output in pass
C           MAXDIM(*) I     Maximum dimension of table variables each
C                           pass
C           FCH(*)    I     Array of starting character positions for
C                           columns
C           NCH(*)    I     Array of string lengths for columns
C   Common: IBCOL(*)  I     Array describing var. location in output
C-----------------------------------------------------------------------
      INTEGER   NACROS, NOPASS, JCOL1(*), JCOL2(*), MAXDIM(*),
     *   FCH(*), NCH(*)
C                                       STRTCL=Start col of data print
C                                       Define character and bit types
      INTEGER   STRTCL, CHARTY, BITTYP
      PARAMETER (STRTCL=9,CHARTY=3,BITTYP=7)
      INTEGER   VTYPE, VARLEN, J, BCOL
      INCLUDE 'TBOUT.INC'
C-----------------------------------------------------------------------
C                                        Force new pass on first
C                                        variable
      BCOL = NACROS + 2
      NOPASS = 0
C                                        For all columns in table
      DO 100 J = 1,NCOL
C                                        Length of datum
         NCH(J) = VARLEN(J)
C                                        Another pass if more than
C                                        NACROS?
         IF ((BCOL+NCH(J)).GE.NACROS) THEN
C                                        Begin at start column
            BCOL = STRTCL
            NOPASS = NOPASS + 1
C                                        Init Max array dimension each
C                                        pass
            MAXDIM(NOPASS) = 1
C                                        Start Column for each pass
            JCOL1(NOPASS) = J
            END IF
C                                        Set first columns.
         FCH(J) = BCOL
C                                        Save var location for header
C                                        write
         IBCOL(J) = BCOL + (NOPASS-1) * 1000
C                                        Update next start col
         BCOL = BCOL + NCH(J)
C                                        Assume current col is last in
C                                        pass
         JCOL2(NOPASS) = J
C                                        Variable type is in 1's digit
         VTYPE = MOD( DATP(J,2), 10)
C                                        If not bit or char
         IF ((VTYPE.NE.CHARTY) .AND. (VTYPE.NE.BITTYP)) THEN
C                                        get table array dimension
            MAXDIM(NOPASS) = MAX (MAXDIM(NOPASS), (DATP(J,2)/10))
            END IF
 100     CONTINUE
      RETURN
      END
      SUBROUTINE LABPAS (JBEGIN, JEND, FCH, NCH, RESULT, IERR)
C-----------------------------------------------------------------------
C   LABPAS LABels one PASs of a write of an AIPS table to an
C          external text table.
C   Input:  JBEGIN I     Start column output in pass
C           JEND   I     End column output in pass
C           FCH(*) I     Array of starting character positions for
C                        columns
C           NCH(*) I     Array of string lengths for columns
C           RESULT(*) I  Array for receiving TABIO results.
C   Common: DATP, BUFFER
C   Output: IERR   I     Error code: 0 => OK,
C                        2 => error writing, 3 => error reading
C-----------------------------------------------------------------------
      INTEGER   JBEGIN, JEND, FCH(*), NCH(*), RESULT(*), IERR
C
      CHARACTER LINE*1024, CTEMP*8
      HOLLERITH HTEMP(2)
      INTEGER   I, J, IP, NCP, JJ, JTRIM, ITEMP(2)
      EQUIVALENCE (HTEMP, ITEMP)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'TBOUT.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       No. characters per line.
      NCP = FCH(JEND) + NCH(JEND)
C                                       Column numbers
      LINE = 'COL. NO.  '
      DO 100 J = JBEGIN,JEND
         WRITE (LINE(FCH(J)+2:FCH(J)+6),1090) J
 100     CONTINUE
      CALL WRCARD ( LINE, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Prepare page titles
      LINE = '     ROW  '
      DO 110 J = JBEGIN,JEND
C                                       Column label
         CALL TABIO ('READ', 3, J, RESULT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 960
         CALL COPY (2, RESULT, ITEMP)
         I = 8
         IP = FCH(J) + 3
         CALL H2CHR (I, 1, HTEMP, CTEMP)
         JJ = JTRIM (CTEMP)
         LINE(IP:IP+7) = CTEMP
 110     CONTINUE
      CALL WRCARD ( LINE, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Units
      LINE = '  NUMBER  '
      DO 120 J = JBEGIN,JEND
         CALL TABIO ('READ', 4, J, RESULT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 960
         CALL COPY (2, RESULT, ITEMP)
         IP = FCH(J) + 3
         CALL H2CHR (8, 1, HTEMP, CTEMP)
         JJ = JTRIM (CTEMP)
         LINE(IP:IP+7) = CTEMP
 120     CONTINUE
      CALL WRCARD( LINE, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Mark Begin Pass
      LINE = '***BEGIN*PASS***'
      CALL WRCARD( LINE, IERR)
      IF (IERR.NE.0) GO TO 970
      GO TO 999
C                                       read error
 960  IERR = 3
      GO TO 995
C                                       write error
 970  IERR = 2
C
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1090 FORMAT (I5)
      END
      SUBROUTINE PUTPAS (MAXDIM, JBEGIN, JEND, FCH, NCH, IERR)
C-----------------------------------------------------------------------
C  PUTPAS writes one pass of an AIPS table to an external text table.
C   Input:  MAXDIM I     Maximum dimension of table arrays
C           JBEGIN I     Start column output in pass
C           JEND   I     End column output in pass
C           FCH(*) I     Array of starting character positions for
C                        columns
C           NCH(*) I     Array of string lengths for columns
C   Common: DATP, BUFFER, BCOUNT, ECOUNT
C   Output: IERR   I     Error code: 0 => OK,
C                        2 => error writing, 3 => error reading
C-----------------------------------------------------------------------
      INTEGER MAXDIM, JBEGIN, JEND, FCH(*), NCH(*), IERR
C
      CHARACTER LINE*1024, CTEMP*80, STRING*1024
      INTEGER   CHARTY, BITTYP, JTRIM, JJ
C                                       Define character and bit types
      INCLUDE 'INCS:PUVD.INC'
      PARAMETER (CHARTY=3,BITTYP=7)
      INTEGER   IRNO, RESLI(XBPRSZ), RESULT(XBPRSZ), I, J, K, L, M, N,
     *   ROWB(XBPRSZ), BITS(64), RTYPE, IROW, IEL, NCP, JTYPE, JDIMEN,
     *   LRNO
      LOGICAL   RESLO(XBPRSZ), ROWFLG
      REAL      RES4(XBPRSZ)
      HOLLERITH RESH(XBPRSZ)
      DOUBLE PRECISION RES8(XBPRSZ/2)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'TBOUT.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (RESULT, RES8, RES4, RESLI, RESLO, RESH)
C-----------------------------------------------------------------------
      IERR = 0
C                                       Max num chars = last col + len
      NCP = FCH(JEND) + NCH(JEND)
      IROW = 0
C                                       Output loop
      LRNO = 0
      DO 60 IRNO = BCOUNT,ECOUNT
C                                       Keep track of actual row written
         IROW = IROW + 1
C                                       Clear output
         LINE = ' '
C                                       Loop over element in arrays.
         DO 59 IEL = 1,MAXDIM
            DO 50 J = JBEGIN,JEND
C                                       get data.
               CALL GETCOL (IRNO, J, DATP, LRNO, BUFFER, RTYPE, RESULT,
     *            ROWB, IERR)
C                                       if row is flagged
               ROWFLG = (IERR.LT.0)
               IF (ROWFLG) IERR = 0
               IF (IERR.NE.0) GO TO 960
C                                       Get variable type
               JTYPE = MOD (RTYPE, 10)
C                                       See which have data, get
C                                       dimension
               JDIMEN = RTYPE/10
C                                       for arrays with 0 elements or
C                                       arrays with smaller than IEL
C                                       elements
               IF ((JDIMEN.LT.IEL) .OR. ((IEL .GT. 1) .AND.
     *             ((JTYPE.EQ.CHARTY).OR.(JTYPE.EQ.BITTYP))))  THEN
                  L = FCH(J)
C                                       init with blanks
                  LINE(L:L+NCH(J)-1) = ' '
                  LINE(L+NCH(J)-2:L+NCH(J)-2) = ''''
                  LINE(L+NCH(J)-1:L+NCH(J)-1) = ''''
               ELSE
C                                       array has >= IEL elements
C                                       if bit or char type
                  IF ((JTYPE.EQ.CHARTY).OR.(JTYPE.EQ.BITTYP)) THEN
C                                       work to right justify
                     L = FCH(J)+NCH(J)-JDIMEN-2
C                                       First quote
                     LINE(L:L) = ''''
C                                       jump for character or bit data
                     IF (JTYPE.EQ.CHARTY) THEN
                        CALL H2CHR (JDIMEN, 1, RESH, STRING)
                        JJ = JTRIM (STRING(:JDIMEN))
                        LINE(L+1:L+JDIMEN) = STRING(:JDIMEN)
                     ELSE
C                                       else bit type
C                                       calc number of words with NBITWD
C                                       bits
                        N = ((JDIMEN - 1) / NBITWD) + 1
                        DO 40 I = 1,N
                           M = NBITWD
C                                       last word has only a few bits
                           IF (I.EQ.N) M = JDIMEN - ((N-1)*NBITWD)
C                                       if fewer bits than fill a word
                           M = MIN (M, JDIMEN)
C                                       unpack word into an array
                           CALL ZGTBIT (M, RESULT(I),
     *                        BITS(((I-1)*NBITWD)+1))
  40                       CONTINUE
                        WRITE (LINE(L+1:L+JDIMEN),1230)
     *                             (BITS(K), K = 1,JDIMEN)
C                                       end if char type else bit
                        END IF
C                                       Final quote
                     LINE(L+JDIMEN+1:L+JDIMEN+1) = ''''
                  ELSE
C                                       else numeric, is var dimension
C                                       ok
                     IF (JDIMEN.GE.IEL) THEN
C                                       check floats for indefinite values
                        IF (JTYPE.EQ.1) THEN
                           IF (RES8(IEL).EQ.DBLANK) THEN
                              WRITE (CTEMP,1201)
                           ELSE
                              WRITE (CTEMP,1101) RES8(IEL)
                              END IF
                        ELSE IF (JTYPE.EQ.2) THEN
                           IF (RES4(IEL).EQ.FBLANK) THEN
                              WRITE (CTEMP,1201)
                           ELSE
                              WRITE (CTEMP,1102) RES4(IEL)
                              END IF
                        ELSE IF (JTYPE.EQ.4) THEN
                           WRITE (CTEMP,1103) RESLI(IEL)
                        ELSE IF (JTYPE.EQ.5) THEN
                           WRITE (CTEMP,1104) RESLO(IEL)
                        ELSE IF (JTYPE.EQ.6) THEN
                           WRITE (CTEMP,1105) RESULT(IEL)
                           END IF
C
                        LINE(FCH(J):FCH(J)+NCH(J)-1) = CTEMP(1:NCH(J))
C                                       end if var dimension < IEL
                        END IF
C                                       end if char or bit
                     END IF
C                                       if has elements
                  END IF
C                                       end for all columns loop
 50            CONTINUE
C                                       row number, minus if flaged
            IF (ROWFLG) THEN
               WRITE (LINE(1:8),1100) -IROW
            ELSE
               WRITE (LINE(1:8),1100) IROW
               END IF
C                                       do output finally
            CALL WRCARD ( LINE(1:NCP), IERR)
            IF (IERR.NE.0) THEN
               WRITE(MSGTXT, 1900) LINE(1:40)
               CALL MSGWRT(8)
               GO TO 970
               END IF
 59         CONTINUE
  60     CONTINUE
C                                       Mark End Pass
      LINE = '***END*PASS***'
      CALL WRCARD( LINE, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       loop for more columns
      GO TO 999
 960  IERR = 3
      GO TO 999
 970  IERR = 4
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT (I8)
 1101 FORMAT (1PD24.15)
 1102 FORMAT (1PE15.6)
 1103 FORMAT (I11,4X)
 1104 FORMAT (4X,L1,4X)
 1105 FORMAT (I6,4X)
 1201 FORMAT (' ''INDE''      ')
 1230 FORMAT (64I1)
 1900 FORMAT ('WRITE ERROR; LINE(1:40)=',A40)
      END
      INTEGER FUNCTION VARLEN (VARNUM)
C-----------------------------------------------------------------------
C Calculate the length in characters of the different data types
C Input  VARNUM  I  Index to Variable
C Output LENGTH  I  Integer length of variable in number of characters
C
C-----------------------------------------------------------------------
      INTEGER VARNUM
C
      INTEGER LENGTH, VTYPE, LCH(6), CHARTY, BITTYP
C                                       Define character and bit types
      PARAMETER (CHARTY=3,BITTYP=7)
      INCLUDE 'TBOUT.INC'
C                                       Length of types in characters
C                                       for:
C                                       R*8, R*4, C*8, I*4, L*2, I*2
      DATA LCH /24, 15, 8, 11, 8, 8/
C-----------------------------------------------------------------------
      VTYPE = MOD(DATP(VARNUM,2), 10)
C                                       If char or bit type
      IF ((VTYPE.EQ.CHARTY) .OR. (VTYPE.EQ.BITTYP)) THEN
C                                       length is hidden in tens digits
         LENGTH = (DATP(VARNUM,2) / 10) + 3
      ELSE
C                                       length is defined by formats
         LENGTH = LCH(VTYPE)
         END IF
C                                       never less than 9 chars
      VARLEN = MAX (LENGTH, 9)
      RETURN
      END
      SUBROUTINE EXWTHD (NACROS, NOPASS, MAXDIM, IERR)
C-----------------------------------------------------------------------
C   EXWTHD writes header information for a specified AIPS table
C   to an external text file.
C   Input:
C     NACROS     I    Number of characters per line of output text
C     NOPASS     I    Number of passes to output all columns of table
C     MAXDIM    I(*)  Maximum dimension of Array in each pass
C   Inputs from common:
C     BUFFER(*)  I    Table I/O buffer (table opened and closed
C                     outside of this routine).
C     TYPE       I    Table type (2 char)
C     VER        I    Table version number
C     IBCOL      I    First col no. + (no. pass - 1) * 1000
C   Output:
C     IER        I    Error number: 0 => none, else count of errors #
C-----------------------------------------------------------------------
      INTEGER   NACROS, NOPASS, MAXDIM(*), IERR
C
      CHARACTER KWNAME*8, PAD*16, FORM(7)*8, TYPTAB(2)*8, LINE*80,
     *   FRMOUT*8, ITOCHR*2, ATIME*8, ADATE*12
      DOUBLE PRECISION DVALUE
      REAL   RVALUE
      INTEGER   IPAIR, I, II, IVALUE, SRTORD, KTYPE, NNKEY, ILEN,
     *   TBMAXD, TABTYP,IPASS, ID(3), IT(3)
      INCLUDE 'TBOUT.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DEHD.INC'
      INCLUDE 'INCS:DTHD.INC'
      DATA FORM /'D24.15', 'E15.6', 'A', 'I11', 'A1', 'I6', ' '/
      DATA TYPTAB /'TABLE   ', 'BINTABLE'/, PAD /' '/
C-----------------------------------------------------------------------
      IERR = 0
C                                       Find max dimension of the table
      TBMAXD = 0
      DO 50 IPASS = 1, NOPASS
         TBMAXD = MAX (TBMAXD, MAXDIM(IPASS))
 50      CONTINUE
C                                       Assume 3d table, unless max dim
C                                       1
      TABTYP = 2
      IF (TBMAXD.EQ.1) TABTYP = 1
C                                       Everything you need to know
C                                       about the columns.
      CALL GETHUT (NCOL, DATP, BUFFER, TTYPE, TUNIT, TFCODE, TWIDTH,
     *   IERR)
C                                       Tell user table and type
      WRITE (MSGTXT,1005) INEXT
      CALL MSGWRT (5)
      WRITE (LINE,1050) TYPTAB(TABTYP)
      CALL WRCARD (LINE, IERR)
      WRITE (LINE,1051)
      CALL WRCARD (LINE, IERR)
      WRITE (LINE,1052)
      CALL WRCARD (LINE, IERR)
      WRITE (LINE,1053) NACROS
      CALL WRCARD (LINE, IERR)
      WRITE (LINE,1054) ECOUNT-BCOUNT+1
      CALL WRCARD (LINE, IERR)
      WRITE (LINE,1055)
      CALL WRCARD (LINE, IERR)
      WRITE (LINE,1056)
      CALL WRCARD (LINE, IERR)
C                                       Number of passes
      WRITE (LINE,2056) NOPASS
      CALL WRCARD (LINE, IERR)
      WRITE (LINE,1057) NCOL
      CALL WRCARD (LINE, IERR)
      WRITE (LINE,1058) INEXT
      CALL WRCARD (LINE, IERR)
      WRITE (LINE,1059) INVERS
      CALL WRCARD (LINE, IERR)
      DO 80 I = 1,NCOL
C                                       Turn I into a 2 character string
         IF (I.LT.10) THEN
            WRITE (ITOCHR,1060) I
         ELSE
            WRITE (ITOCHR,1061) I
            END IF
         WRITE (LINE,1062) ITOCHR, IBCOL(I)
         CALL WRCARD (LINE, IERR)
         IF (IERR.NE.0) GO TO 900
         II = TFCODE(I)
C                                       Get char or bit format
C                                       into the right form.
         IF ((II.EQ.3) .OR. (II .EQ. 7)) THEN
            WRITE (FRMOUT,1064) TWIDTH(I)
            CALL CHTRIM (FRMOUT, 8, FRMOUT, ILEN)
C                                       Char format
            IF (II.EQ.3) FORM(3) = 'A' // FRMOUT(1:ILEN)
C                                       Bit format
            IF (II.EQ.7) FORM(7) = 'X' // FRMOUT(1:ILEN)
            END IF
C                                       Get correct format for file type
         FRMOUT = FORM(II)
         WRITE (LINE,1068) ITOCHR, FRMOUT, I
         CALL WRCARD (LINE, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       Get dimension of field
         ILEN = DATP(I,2) / 10
         WRITE (LINE,1070) ITOCHR, ILEN, I
         CALL WRCARD (LINE, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       Pad 1 to 11 blanks
         ILEN = MAX(1,MIN(11,19-LEN(TTYPE(I))))
         WRITE (LINE,1072) ITOCHR, TTYPE(I), PAD(1:ILEN), I
         CALL WRCARD (LINE, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1074) ITOCHR, TUNIT(I), I
         CALL WRCARD (LINE, IERR)
         IF (IERR.NE.0) GO TO 900
 80      CONTINUE
C                                       Do all KeyWord value pairs.
      NNKEY = BUFFER(53)
      IF (NNKEY.GE.1) THEN
         DO 240 IPAIR = 1,NNKEY
            CALL GTPAIR (IPAIR, BUFFER, KWNAME, DVALUE, KTYPE)
            IF (KTYPE.EQ.0) GO TO 240
C                                       Double Precision.
            IF (KTYPE.EQ.1) THEN
               WRITE (LINE,1120) KWNAME, DVALUE
C                                       Real.
            ELSE IF (KTYPE.EQ.2) THEN
               RVALUE = DVALUE
               WRITE (LINE,1140) KWNAME, RVALUE
C                                       Character.
            ELSE IF (KTYPE.EQ.3) THEN
               WRITE (LINE,1160) KWNAME, DVALUE
C                                       Long Integer.
            ELSE IF (KTYPE.EQ.4) THEN
               IF (DVALUE.LT.0.0D0) THEN
                  IVALUE = DVALUE - 0.01D0
               ELSE
                  IVALUE = DVALUE + 0.01D0
                  END IF
               WRITE (LINE,1180) KWNAME, IVALUE
C                                       Logical.
            ELSE IF (KTYPE.EQ.5) THEN
               IF (DVALUE.GT.0.0D0) THEN
                  WRITE (LINE,1200) KWNAME
               ELSE
                  WRITE (LINE,1202) KWNAME
                  END IF
C                                       Integer.
            ELSE IF (KTYPE.EQ.6) THEN
               IF (DVALUE.LT.0.0D0) THEN
                  IVALUE = DVALUE - 0.01D0
               ELSE
                  IVALUE = DVALUE + 0.01D0
                  END IF
               WRITE (LINE,1220) KWNAME, IVALUE
               END IF
            CALL WRCARD ( LINE, IERR)
 240        CONTINUE
         END IF
C                                       Sort order.
      SRTORD = BUFFER(43)
      IF (SRTORD.NE.0) THEN
         WRITE (LINE,1230) SRTORD
         CALL WRCARD (LINE, IERR)
         END IF
C                                       HISTORY Card with File name
      WRITE (LINE,1300) INEXT, INVERS, INNAM, INCLS, INSEQ
      CALL WRCARD (LINE, IERR)
C
      WRITE (LINE,1400) EXTFIL(1:30)
      CALL WRCARD (LINE, IERR)
C                                       Date and time
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, ATIME, ADATE)
      WRITE (LINE,1500) ADATE, ATIME
      CALL WRCARD (LINE, IERR)
C                                       END card.
      CALL WRCARD ('END ',IERR)
      GO TO 999
C                                       Error on I/O
 900  WRITE (MSGTXT,1900) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1005 FORMAT ('Writing ASCII table of type ',A2)
 1050 FORMAT ('XTENSION= ''',A8,'''',11X,'/ extension type')
 1051 FORMAT ('BITPIX  =',20X,'8',1X,'/ printable ASCII codes')
 1052 FORMAT ('NAXIS   =',20X,'2',1X,'/ Table is a matrix')
 1053 FORMAT ('NAXIS1  =',15X,I6,1X,'/ Max. no. of characters/pass')
 1054 FORMAT ('NAXIS2  =',13X,I8,1X,'/ Number of entries in table')
 1055 FORMAT ('PCOUNT  =',20X,'0',1X,'/ Random parameter count')
 1056 FORMAT ('GCOUNT  =',20X,'1',1X,'/ Group count')
 2056 FORMAT ('NOPASS  =',18X,I3,1X,'/ Number of passes thru table')
 1057 FORMAT ('TFIELDS =',19X,I2,1X,'/ Number of fields in each row')
 1058 FORMAT ('EXTNAME = ''AIPS ',A2,1X,'''',11X,'/ AIPS table file')
 1059 FORMAT ('EXTVER  = ',15X,I5,1X,'/ Version Number of table')
 1060 FORMAT (I1,' ')
 1061 FORMAT (I2)
 1062 FORMAT ('TBCOL',A2,' = ',15X,I5,1X,'/ Starting char. pos. of',
     *   ' field',I3)
 1064 FORMAT (I6)
 1068 FORMAT ('TFORM',A2,' = ''',A8,'''',11X,'/ Fortran format',
     *   ' of field',I3)
 1070 FORMAT ('TFDIM',A2,' = ',15X,I5,1X,'/ Dimension of field',I3)
 1072 FORMAT ('TTYPE',A2,' = ''',A24,'''',A11,'/ type (heading)',
     *   ' of field',I3)
 1074 FORMAT ('TUNIT',A2,' = ''',A8,'''',11X,'/ physical units',
     *   ' of field',I3)
 1120 FORMAT (A8,'= ',1PD25.17)
 1140 FORMAT (A8,'= ',1PE15.7)
 1160 FORMAT (A8,'= ''',A8,'''')
 1180 FORMAT (A8,'= ',I12)
 1200 FORMAT (A8,'=',20X,'T')
 1202 FORMAT (A8,'=',20X,'F')
 1220 FORMAT (A8,'= ',I6)
 1230 FORMAT ('ISORTORD =',I20)
 1300 FORMAT ('HISTORY TBOUT  /', A2, ' table version', I3,
     *   ' of INNAME=''',A12,'.',A6,'.',I4,'''')
 1400 FORMAT ('HISTORY TBOUT  / copied to the text file ', A)
 1500 FORMAT ('HISTORY TBOUT  / ',A,A)
 1900 FORMAT ('EXWTHD: WRITE ERROR',I7)
      END
      SUBROUTINE WRCARD (LINE, IERR)
C-----------------------------------------------------------------------
C WRCARD WRites a fits CARD.
C Input:  LINE C*(*) Output fits card
C Output: IERR I     Error code, 0 => ok
C-----------------------------------------------------------------------
      CHARACTER LINE*(*)
      INTEGER IERR
C
      INTEGER   JTRIM
      INCLUDE 'CARDIO.INC'
C-----------------------------------------------------------------------
      CALL ZTXIO ('WRIT', EXTLUN, EXTIND, LINE(1:JTRIM(LINE)), IERR)
      RETURN
      END
      SUBROUTINE OPCARD (OPCODE, EXTFIL, IERR)
C-----------------------------------------------------------------------
C OPens file for reading or writing FITS Text Cards.
C Input:  OPCODE C*4   Opcode, 'READ' or 'WRIT'
C         EXTFIL C*(*) External File Name
C Output: IERR I       Error code, 0 => ok
C-----------------------------------------------------------------------
      CHARACTER OPCODE, EXTFIL*(*)
      INTEGER IERR
C
      LOGICAL F
      INCLUDE 'CARDIO.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA F/.FALSE./
C-----------------------------------------------------------------------
      EXTLUN = 10
      CALL ZTXOPN (OPCODE, EXTLUN, EXTIND, EXTFIL, F, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT(8)
         END IF
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' OPENING EXTERNAL FILE')
      END
      SUBROUTINE CLCARD (IERR)
C-----------------------------------------------------------------------
C CLoses a file for reading or writing FITS Text Cards.
C Output: IERR I     Error code, 0 => ok
C-----------------------------------------------------------------------
      INTEGER IERR
C
      INCLUDE 'CARDIO.INC'
C-----------------------------------------------------------------------
      CALL ZTXCLS (EXTLUN, EXTIND, IERR)
      RETURN
      END

      SUBROUTINE VISPCK (NRPARM, TBUFF, BUFF)
C-----------------------------------------------------------------------
C! Compresses a visibility record.
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Routine to compress a visibility record. A utility routine
C   to make life a little easier.
C   Inputs:
C     NRPARM      I      # random parameters
C     TBUFF(*)    R      Uncompressed visibility
C   Inputs from common /CMPPRM/
C     MLOCWT      I      Location of weight in random parameter array
C     NDECMP      I      Number of entries in DECMP
C     DECMP       I(2,*) (1,*) = number of compressed correlator values
C                        (2,*) = 0-rel offset in vis data.
C                        (from beginning of vis data NOT ran. parms.)
C
C   Outputs:
C     BUFF(*)     R      Compressed visibility
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER NRPARM
      REAL    TBUFF(*), BUFF(*)
C
      INCLUDE 'INCS:DCMP.INC'
      INTEGER I
C-----------------------------------------------------------------------
      CALL RCOPY (NRPARM, TBUFF, BUFF)
      DO 100 I = 1, NDECMP
         CALL ZUVPAK (DECMP(1,I), TBUFF(1+NRPARM), BUFF(1+MLOCWT),
     *      BUFF(1+NRPARM))
 100     CONTINUE
      RETURN
      END

      SUBROUTINE ZDICOP (LUN, SYSTEM, USERNO, FLMSIZ, FLMTYP, COPIES,
     *                   BPPIX, WIDTH, HEIGHT, COMMNT, IRET)
C-----------------------------------------------------------------------
C! Open a Dicomed image file and fill in the header
C# Z
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Open a Dicomed image file and fill in the file header.
C
C   Inputs:
C      LUN         I          Logical unit number for file.
C      SYSTEM      C*(*)      The name of the computer system.
C      USERNO      I          AIPS user number.
C      FLMSIZ      I          Film size (assumed to be valid)
C                               0 -> 35mm
C                               1 -> 2"x2"
C                               2 -> 4"x5"
C      FLMTYP      I          Film type (assumed to be valid)
C                               0 -> colour positive
C                               1 -> colour negative
C                               2 -> B/W negative
C      COPIES      I          Number of copies to make (assumed to be
C                               greater than zero)
C      BPPIX       I          Number of bits per pixel (assumed to be
C                               8 or 24
C      WIDTH       I          Width of image in pixels (assumed to be
C                               greater than zero)
C      HEIGHT      I          Height of image in pixels (assumed to be
C                               greater than zero)
C      COMMNT      C*(*)      User's comments
C
C   Output:
C      IRET        I          Return status:
C                               0 -> success
C                               1 -> could not open file
C                               2 -> could not write header
C
C Generic version: stubbed.
C-----------------------------------------------------------------------
      CHARACTER SYSTEM*(*), COMMNT*(*)
      INTEGER   LUN, USERNO, FLMSIZ, FLMTYP, COPIES, BPPIX, WIDTH,
     *          HEIGHT, IRET
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IRET = 1
      WRITE (MSGTXT, 1000)
      CALL MSGWRT (8)
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZDICOP REQUIRES LOCAL DEVELOPMENT')
      END

      SUBROUTINE QCFFT (C, N, F)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Complex 1-D FFT.
C# AP-FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Full complex 1-D FFT.
C   Inputs:
C      C  I  Base address (0-rel) of complex array to transform
C      N  I  Number of points in array (must be power of two).
C      F  I  Transform direction; 1 -> Forward
C                                -1 -> Backward
C   IBM 3090 version
C-----------------------------------------------------------------------
      INTEGER   C, N, F, IFF, FFTSIZ, PAD4
      DOUBLE PRECISION AUX1(40000), AUX2(40000)
      REAL      WORK(4096)
      INCLUDE 'INCS:DAPC.INC'
      COMMON /SCFTCM/ FFTSIZ, FFTDIR, AUX1, AUX2
C-----------------------------------------------------------------------
      IFF = F
      IF ((MOD (C, 2)) .EQ. 0) THEN
         IF (FFTSIZ.NE.N .OR. FFTDIR.NE.IFF) THEN
            CALL SCFT (1, APCORE(C+1), 1, 1, APCORE(C+1), 1, 1, N, 1,
     *         IFF, 1.0, AUX1, 20000, AUX2, 20000)
            FFTSIZ = N
            FFRDIR = IFF
            END IF
         CALL SCFT (0, APCORE(C+1), 1, 1, APCORE(C+1), 1, 1, N, 1,
     *      IFF, 1.0, AUX1, 20000, AUX2, 20000)
      ELSE
         CALL QXFOUR (APCORE(C+1), N, IFF, WORK)
         END IF
C
      RETURN
      END

      SUBROUTINE CHBLNK (NT, NS, CH, NP)
C-----------------------------------------------------------------------
C! returns position of first non-blank character in portion of string
C# Character
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   CHBLNK searches a string to find the first non-blank character
C   Inputs: NT   I       Total length of string
C           NS   I       Start position in string for search
C           CH   C*(*)   String
C   Output: NP   I       first non-blank character position (from start
C                        of string)
C-----------------------------------------------------------------------
      CHARACTER CH*(*)
      INTEGER   NT, NS, NP
C
      INTEGER   IS
C-----------------------------------------------------------------------
      NP = 0
      IF (NT.LE.0) GO TO 999
      IS = NS
      IF (IS.LE.0) IS = 1
      IF (IS.GT.NT) GO TO 999
      DO 10 NP = IS,NT
         IF (CH(NP:NP).NE.' ') GO TO 999
 10      CONTINUE
      NP = 0
C
 999  RETURN
      END

      SUBROUTINE YZERO (CHAN, IERR)
C-----------------------------------------------------------------------
C! fill a TV memory plane with zeros
C# Y1 TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YZERO fills an TV TV memory plane with zeros the fast way.
C   Inputs:
C      CHAN   I     channel # ( 1 - NGRAY+NGRAPH), 0 => all
C   Outputs:
C      IERR   I     error code of Z...XF: 0 - ok, 2 - input error
C   Virtual TV version
C-----------------------------------------------------------------------
      INTEGER   CHAN, IERR
C
      INTEGER   IC
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((CHAN.LT.0) .OR. (CHAN.GT.NGRAY+NGRAPH)) GO TO 999
C                                       fix common
      IF (CHAN.LE.NGRAY) THEN
         IC = CHAN - 1
         IF (IC.GE.0) IC = 2**IC
         CALL MOVIST ('OFFF', IC, 0, 0, 0, IERR)
         END IF
C                                       set up comm buffer
      BUFSW = 1
      BUFSR = 0
      CALL MKYBUF ('WRIT', 'YZERO', BUFSW, BUFSR, CHAN, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
C
 999  RETURN
      END

LOCAL INCLUDE 'XYMOD.INC'
C                                       Local include for XYMOD
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4), XCALC(1), XNAMOU(3),
     *   XCLAOU(2), XOPCOD(1)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XANT(50), XBASE(50),  XSUBA, XBIF, XEIF, XBCHAN, XECHAN,
     *   XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER,
     *   XSMOTH(3), XDOAC, XSOUT, XDISO, XCENT, BADD(10), ROTATE,
     *   SCRBUF(256), BUFF2(UVBFSS), DIFPIX, IFLUX(MAXIF), QFLUX(MAXIF),
     *   UFLUX(MAXIF), QSPEC(MAXCIF), USPEC(MAXCIF)
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS, JBUFSZ, ILOCWT,
     *   CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO,
     *   LRECO, NRPRMI, NRPRMO, OLDCNO, NEWCNO, IXANT(50), IXBAS(50),
     *   NXANT, NXBAS
      LOGICAL   ISCOMP, DESEL
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, HISCRD(10)*64,
     *   OPCODE
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XTIME, XBAND, XFREQ, XFQID, XANT, XBASE, XSUBA, XBIF, XEIF,
     *   XBCHAN, XECHAN, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG,
     *   XDOBND, XBPVER, XSMOTH, XDOAC, XNAMOU, XCLAOU, XSOUT, XDISO,
     *   XCENT, BADD, XOPCOD, ROTATE
      COMMON /XYMODP/ CATOLD, SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS,
     *   ILOCWT, INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECO,
     *   NRPRMI, NRPRMO, ISCOMP, OLDCNO, NEWCNO, DIFPIX, IXANT, IXBAS,
     *   NXANT, NXBAS, DESEL, IFLUX, QFLUX, UFLUX, QSPEC, USPEC
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, HISCRD, OPCODE
      COMMON /BUFRS/ SCRBUF, BUFF2, JBUFSZ
C                                       End local include for XYMOD
LOCAL END
      PROGRAM XYMOD
C-----------------------------------------------------------------------
C! Computes linear polarization model
C# UV VLA Calibration Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 2019-2020, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   XYMOD computes a linear polarization point source model and the
C   replaces the data or subtracts from the data or divides into the
C   data
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C   full set of calibration adverbs
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      OPCODE         OPCODE        What to do w model
C      ROTATE         ROTATE        Rotation measure
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'XYMOD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'XYMOD '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL XYMODI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL XYMODD (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL XYMODH
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE XYMODI (PRGN, JERR)
C-----------------------------------------------------------------------
C   XYMODI gets input parameters for XYMOD and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, NFREQ, LUN
      LOGICAL   MATCH
      REAL      CATR(256), RPARM(20)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'XYMOD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      DATA BLANK  /' '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 162
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      STOKES = 'XXYY'
      DO 5 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 5       CONTINUE
      CALL H2CHR (16, 1, XSOUR, SOURCS(1))
      SELQUA = IROUND (XQUAL)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = XDOAC.GT.0.0
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      IF (ICOR0.EQ.-5) THEN
         MSGTXT = 'I ONLY WORK ON LINEAR POLARIZATION'
         CALL MSGWRT (8)
         JERR = 10
         GO TO 999
         END IF
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NFREQ = CATBLK(KINAX+JLOCF)
      BCHAN = IROUND (XBCHAN)
      ECHAN = IROUND (XECHAN)
      IF ((BCHAN.LE.0) .OR. (BCHAN.GT.NFREQ)) BCHAN = 1
      IF ((ECHAN.LE.0) .OR. (ECHAN.GT.NFREQ)) ECHAN = NFREQ
      IF (BCHAN.GT.ECHAN) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       Find baselines to copy
      CALL SETANT (50, XANT, XBASE, NXANT, NXBAS, IXANT, IXBAS, DESEL)
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, SCRBUF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, SCRBUF, IERR)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       center frequency axis
      IF (JLOCF.LT.0) XCENT = -1.
      IF (XCENT.GT.0.0) THEN
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
      ELSE
         DIFPIX = 0.0
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       read compressed => write compr.
      IF (ISCOMP) THEN
         CATBLK(KINAX) = 1
         I = CATBLK(KIPCN)
         CALL CHR2H (8, 'WEIGHT  ', 1, CATH(KHPTP+2*I))
         CALL CHR2H (8, 'SCALE   ', 1, CATH(KHPTP+2*I+2))
         CATBLK(KIPCN) = I + 2
         ILOCWT = I
         END IF
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         WRITE (MSGTXT,1060)
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
      NEWCNO = CCNO
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', SCRBUF, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       Copy any header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XYMODI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY NOT OVERWRITE ANY FILE.  QUITTING')
      END
      SUBROUTINE XYMODS (IRET)
C-----------------------------------------------------------------------
C   XYMODS sets up the flux and spectrum portions of the parameters
C   Output
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'XYMOD.INC'
      INTEGER   BUFFER(512), I, VER, IIF, ICH, LUN, NNIF
      DOUBLE PRECISION CFREQ, CLAMB, AFREQ, CATUVD(128)
      REAL      CATUVR(256), AREF, ARG
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DCHND.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      EQUIVALENCE (CATUV, CATUVD, CATUVR)
      DATA LUN /29/
C-----------------------------------------------------------------------
C                                       get antenna info for parang
      CALL GETANT (DISKIN, OLDCNO, SUBARR, CATUV, BUFFER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'GETTING ANTENNA INFO'
         GO TO 990
         END IF
C                                       get source fluxes
      CALL GETSOU (SOUWAN(1), DISKIN, OLDCNO, CATUV, LUN, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING SOURCE FLUXES'
         GO TO 990
         END IF
      DO 10 IIF = 1,MAXIF
         IFLUX(IIF) = FLUX(1,IIF)
         QFLUX(IIF) = FLUX(2,IIF)
         UFLUX(IIF) = FLUX(3,IIF)
         IF ((IFLUX(IIF).LE.0.0) .OR. ((QFLUX(IIF).EQ.0.0) .AND.
     *      (UFLUX(IIF).EQ.0.0))) THEN
            IRET = 10
            MSGTXT = 'YOU MUST SPECIFY I, Q, U FLUXES'
            GO TO 990
            END IF
 10      CONTINUE
C                                       no rotation measure
      IF (ROTATE.EQ.0) THEN
         I = 0
         DO 15 IIF = BIF,EIF
            DO 14 ICH = BCHAN,ECHAN
               I = I + 1
               QSPEC(I) = QFLUX(IIF)
               USPEC(I) = UFLUX(IIF)
 14            CONTINUE
 15         CONTINUE
C                                       rotation measure spectrum
      ELSE
         VER = 1
         CALL CHNDAT ('READ', BUFFER, DISKIN, OLDCNO, VER, CATUV, LUN,
     *      NNIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING FQ TABLE'
            GO TO 990
            END IF
         AFREQ = CATUVD(KDCRV+JLOCF)
         AREF = CATUVR(KRCRP+JLOCF)
         I = 0
         DO 30 IIF = BIF,EIF
            DO 20 ICH = BCHAN,ECHAN
               I = I + 1
               CFREQ = AFREQ + FOFF(IIF) + (ICH-AREF)*FINC(IIF)
               CLAMB = VELITE / CFREQ
               ARG = 2.0 * ROTATE * CLAMB * CLAMB
               QSPEC(I) = QFLUX(IIF) * COS(ARG) - UFLUX(IIF) * SIN(ARG)
               USPEC(I) = QFLUX(IIF) * SIN(ARG) + UFLUX(IIF) * COS(ARG)
 20            CONTINUE
 30         CONTINUE
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' ON ',A)
      END
      SUBROUTINE XYMODD (IRET)
C-----------------------------------------------------------------------
C   XYMODD sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48
      INTEGER   IPTRO, LUNO, INDO, ILENBU, KBIND, NIOUT, NIOLIM, IA1,
     *   IA2, BO, VO, NUMVIS, XCOUNT, NCORO, NCOPY, CATMP(256), RNXRET
      LOGICAL   T, F, REQBAS
      INCLUDE 'XYMOD.INC'
      REAL      DUM, BASEN, VIS(UVBFSS), RESULT(UVBFSS), RPARM(20)
      DOUBLE PRECISION UVSCAL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA LUNO /17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Number of visibilities in input
C                                       and output files.
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       defend cat header from UVGET
      CALL COPY (256, CATBLK, CATMP)
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL COPY (256, CATMP, CATBLK)
      CALL UVPGET (IRET)
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
      NUMVIS = 0
      XCOUNT = 0
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
      IF ((FREQ.GT.0.0D0) .AND. (UVFREQ.GT.0.0D0)) THEN
         UVSCAL = FREQ / UVFREQ
      ELSE
         UVSCAL = 1.0D0
         END IF
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over buffer
      ELSE IF (IRET.EQ.0) THEN
         IF (ILOCB.GE.0) THEN
            BASEN = RPARM(1+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
            END IF
         IF (.NOT.REQBAS (IA1, IA2, DESEL, IXANT, NXANT, IXBAS, NXBAS))
     *      GO TO 100
         NUMVIS = NUMVIS + 1
         RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
         RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
         RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
C                                       call user routine
         CALL DIDDLE (NUMVIS, BIF, EIF, RPARM(1+ILOCT), IA1, IA2, VIS,
     *      RESULT, IRET)
C                                       Error (fatal)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
C                                       Copy to output.
         ELSE IF (IRET.EQ.0) THEN
            XCOUNT = XCOUNT + 1.0D0
            CALL RCOPY (NRPRMI, RPARM, BUFF2(IPTRO))
C                                       update NX table
            CALL RNXUPD (RPARM, RNXRET)
C                                       Compressed
            IF (ISCOMP) THEN
               CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *            BUFF2(IPTRO+NRPRMO))
            ELSE
               CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
               END IF
            IPTRO = IPTRO + LRECO
            NIOUT = NIOUT + 1
            END IF
C                                       Write vis record.
         IF (NIOUT.GE.NIOLIM) THEN
            CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1150) IRET
               GO TO 990
               END IF
            IPTRO = KBIND
            NIOUT = 0
            END IF
C                                       Read next buffer.
         GO TO 100
         END IF
C                                       Final call to DIDDLE.
      NUMVIS = -1
      CALL DIDDLE (NUMVIS, BIF, EIF, DUM, IA1, IA2, SCRBUF, RESULT,
     *   IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
C                                       close NX table
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XYMODD: ERROR',I3,' OPEN/INIT INPUT VIS FILE')
 1010 FORMAT ('XYMODD: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('XYMODD: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1100 FORMAT ('XYMODD: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('XYMODD: DIDDLE ERROR',I3)
 1150 FORMAT ('XYMODD: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE XYMODH
C-----------------------------------------------------------------------
C   XYMODH copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, LABEL*8
      INTEGER   LUN1, LUN2, IERR, I
      INCLUDE 'XYMOD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1, LUN2 /27,28/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   SCRBUF, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
C                                       calibration history
      CALL CALHIS (LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Add any other history.
      IF (NUMHIS.GT.0) THEN
         LABEL = TSKNAM // '/'
         DO 10 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 100
 10         CONTINUE
         END IF
C                                       Close HI file
 100  CALL HICLOS (LUN2, .TRUE., BUFF2, IERR)
C                                       Copy tables
      CALL COPTAB (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'XYMODH: ERROR COPYING TABLES TO OUTPUT UV'
         CALL MSGWRT (6)
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (DISKO, NEWCNO, DIFPIX, BUFF2(1025), BUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'CENTHI: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                       Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRBUF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XYMODH: ERROR',I3,' COPY/OPEN HISTORY FILE')
      END
      SUBROUTINE DIDDLE (NUMVIS, BIF, EIF, T, IA1, IA2, VIS, RESULT,
     *   IRET)
C-----------------------------------------------------------------------
C   DIDDLE computes the model and applies it to the data
C   The history is written after the last call to DIDDLE.
C   After all data has been processed a final call will be made to
C   DIDDLE with NUMVIS = -1.  This is to allow for the completion of
C   pending operations, i.e. preparation of HIstory cards.
C   LUN's 16 and 17 are open and not available to DIDDLE.
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      BIF     I    first IF
C      EIF     I    last IF
C      T       R    Time in days since 0 IAT on the first day for
C                   which there is data, the julian day corresponding
C                   to this day can be obtained in D   form by:
C                   CALL JULDAY (CATH(KHDOB),XDAY) where XDAY will
C                   be the Julian day number.
C      IA1     I    First antenna number
C      IA2     I    Second antenna number
C      VIS     R(3,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C   Inputs from COMMON:
C      RA         D       Right ascension (1950) of phase center. (deg)
C      DEC        D       Declination (1950) of phase center. (deg)
C      FREQ       D       Frequency of observation (Hz)
C      NRPARM     I       # random parameters.
C      NCOR       I       # correlators
C      CATBLK     I(256)  Catalog header record. See Going Aips for
C                         details.
C      NRPRMI     I    Input number of random parameters.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
C      LRECO      I    Output file record length
C      NRPRMO     I    Output number of random parameters.
C      INCSO      I    Output Stokes' increment in vis.
C      INCFO      I    Output frequency increment in vis.
C      INCIFO     I    Output IF increment in vis.
C   Output:
C      RESULT     R(3,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C
C   Output in COMMON:
C      NUMHIS    I         # history entries (max. 10)
C      HISCRD    C(NUMHIS) History records
C      CATBLK    I         Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, BIF, EIF, IA1, IA2, IRET
      REAL      T, VIS(3,*), RESULT(3,*)
C
      INCLUDE 'XYMOD.INC'
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXO, INDEXI, I
      REAL      TLAST, PANGLE(MAXANT), P, CP, SP, VXXYY(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      SAVE TLAST, PANGLE
      DATA TLAST /-10.0/
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.GT.0) THEN
C                                       parallactic angles
         IF (ABS(T-TLAST).GT.1.1E-5) THEN
            CALL PARANG (T, PANGLE)
            TLAST = T
            END IF
         P = PANGLE(IA1) + PANGLE(IA2)
         SP = SIN (P)
         CP = COS (P)
C                                       pointers to traverse the data
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
C                                       model
         IF (OPCODE.EQ.'MODL') THEN
            I = 0
            DO 40 JIF = 1,NIF
               DO 30 JF = 1,NF
                  I = I + 1
                  VXXYY(1) = IFLUX(JIF) + QSPEC(I)*CP + USPEC(I)*SP
                  VXXYY(2) = IFLUX(JIF) - QSPEC(I)*CP - USPEC(I)*SP
                  DO 20 JS = 1,NS
                     INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *                  (JS-1) * INCSI + 1
                     INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *                  (JS-1) * INCSO + 1
C                                       Example does scaling
                     RESULT(1,INDEXO) = VXXYY(JS)
                     RESULT(2,INDEXO) = 0.0
                     RESULT(3,INDEXO) = VIS(3,INDEXI)
 20                  CONTINUE
 30               CONTINUE
 40            CONTINUE
         ELSE IF (OPCODE.EQ.'SUBT') THEN
            I = 0
            DO 140 JIF = 1,NIF
               DO 130 JF = 1,NF
                  I = I + 1
                  VXXYY(1) = IFLUX(JIF) + QSPEC(I)*CP + USPEC(I)*SP
                  VXXYY(2) = IFLUX(JIF) - QSPEC(I)*CP - USPEC(I)*SP
                  DO 120 JS = 1,NS
                     INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *                  (JS-1) * INCSI + 1
                     INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *                  (JS-1) * INCSO + 1
C                                       Example does scaling
                     RESULT(1,INDEXO) = VIS(1,INDEXI) - VXXYY(JS)
                     RESULT(2,INDEXO) = VIS(2,INDEXI)
                     RESULT(3,INDEXO) = VIS(3,INDEXI)
 120                 CONTINUE
 130              CONTINUE
 140           CONTINUE
         ELSE
            I = 0
            DO 240 JIF = 1,NIF
               DO 230 JF = 1,NF
                  I = I + 1
                  VXXYY(1) = IFLUX(JIF) + QSPEC(I)*CP + USPEC(I)*SP
                  VXXYY(2) = IFLUX(JIF) - QSPEC(I)*CP - USPEC(I)*SP
                  DO 220 JS = 1,NS
                     INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *                  (JS-1) * INCSI + 1
                     INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *                  (JS-1) * INCSO + 1
C                                       Example does scaling
                     RESULT(1,INDEXO) = VIS(1,INDEXI) / VXXYY(JS)
                     RESULT(2,INDEXO) = VIS(2,INDEXI) / VXXYY(JS)
                     RESULT(3,INDEXO) = VIS(3,INDEXI)
 220                 CONTINUE
 230              CONTINUE
 240           CONTINUE
            END IF
C                                       end of example (vis)
C                                       last call - no vis
      ELSE
         NUMHIS = 5
         WRITE (HISCRD(1),1100) ROTATE
         WRITE (HISCRD(2),1102) OPCODE
         WRITE (HISCRD(3),1103) IFLUX(BIF)
         WRITE (HISCRD(4),1104) QFLUX(BIF)
         WRITE (HISCRD(5),1105) UFLUX(BIF)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ROTATE=',F9.2,'  / rotation measure')
 1102 FORMAT ('OPCODE=''',A,'''  / operation code')
 1103 FORMAT ('IFLUX(BIF) =',F9.4,'  / Stokes I model flux')
 1104 FORMAT ('QFLUX(BIF) =',F9.4,'  / Stokes Q model flux')
 1105 FORMAT ('UFLUX(BIF) =',F9.4,'  / Stokes U model flux')
      END

      SUBROUTINE YFILL (CHAN, IX0, IY0, IXT, IYT, IVAL, IBLK, IERR)
C-----------------------------------------------------------------------
C! fill rectangle of TV memory with a constant value
C# Y0 TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YFILL will write a constant in a given rectangle in a given graphics
C   or image plane.  It will use fast methods if full screen requested
C   with IVAL 0.
C   Inputs:
C      CHAN     I   Channel (1 to NGRAY+NGRAPH)
C      IX0      I   lower left X pixel (1 relative) of rectangle
C      IY0      I   lower left Y pixel of rectangle.
C      IXT      I   top right X pixel of rectangle.
C      IYT      I   top right Y pixel of rectangle.
C      IVAL     I   desired value: for graphics = 0 or 1
C                                  for grey scale = 0 - MAXINT
C   In/out:
C      IBLK     I(IXT-IX0+1)   work buffer.
C   Output:
C      IERR     I   error code of Z...XF: 0 ok, 2 input error
C   Generic version: will work on all TVs (except IVAS where there is a
C   firmware bug in version 1.1).
C-----------------------------------------------------------------------
      INTEGER   CHAN, IX0, IY0, IXT, IYT, IVAL, IBLK(*), IERR
C
      INTEGER   IANGLE, IY, INUM, LNUM, X0, Y0, XINC, YINC, IV
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
C                                       partial planes
      IF ((IX0.GT.1) .OR. (IY0.GT.1) .OR. (IXT.LT.MAXXTV(1)) .OR.
     *   (IYT.LT.MAXXTV(2)) .OR. (IVAL.NE.0)) THEN
         IERR = 2
         IF ((IXT.LT.IX0) .OR. (IYT.LT.IY0)) GO TO 999
         IF ((IX0.LT.1) .OR. (IY0.LT.1)) GO TO 999
         IF ((IXT.GT.MAXXTV(1)) .OR. (IYT.GT.MAXXTV(2))) GO TO 999
         INUM = IXT - IX0 + 1
         LNUM = IYT - IY0 + 1
         X0 = IX0
         Y0 = IY0
         XINC = 0
         YINC = 1
         IANGLE = 0
         IF (TVXMOD.EQ.2) THEN
            IANGLE = 2
            X0 = IXT
            END IF
         IF (TVXMOD.LE.0) THEN
            IY = INUM
            INUM = LNUM
            LNUM = IY
            XINC = 1
            YINC = 0
            IANGLE = 1
            IF (TVYMOD.EQ.2) THEN
               IANGLE = 3
               Y0 = IYT
               END IF
            END IF
 25      IV = IVAL
         IF ((CHAN.GT.NGRAY) .AND. (IVAL.GE.1)) IV = -1
         CALL FILL (INUM, IV, IBLK)
C                                       Loop for all lines.
         DO 30 IY = 1,LNUM
            CALL YIMGIO ('WRIT', CHAN, X0, Y0, IANGLE, INUM, IBLK, IERR)
            IF (IERR.NE.0) GO TO 999
            X0 = X0 + XINC
            Y0 = Y0 + YINC
 30         CONTINUE
C                                       full planes
      ELSE
         CALL YZERO (CHAN, IERR)
         END IF
C
 999  RETURN
      END

      SUBROUTINE TABOF (OPCODE, OFBUFF, IOFRNO, OFKOLS, OFNUMV, TIME,
     *   SOURCE, IANT, SUBID, FREQID, ANFLAG, STATUS, IERR)
C----------------------------------------------------------------------
C! I/O to Online Flags table (following init. by OFINI)
C# EXT-appl
C----------------------------------------------------------------------
C;  Copyright (C) 2003, 2008, 2013, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C----------------------------------------------------------------------
C   Does I/O to a Online Flags table.  Used after setup by OFINI.
C   Inputs:
C      OPCODE       C*4         Operation code:
C                               'READ' = read entry from table
C                               'WRIT' = write entry in table
C                               'CLOS' = close file, flush on write
C      OFBUFF       I(*)        I/O buffer and related storage, also
C                               defines file if open. Should have
C                               been returned by OFINI.
C   Input/Output:
C      IOFRNO       I           Next row to read or write
C      OFKOLS       I(MAXOFC)   The column pointer array in order:
C                               TIME, DTIME, SRCID, IANT, SUBID,
C                               FREQID, FLAG
C      OFNUMV       I(MAXOFC)   Element count in each column.
C      TIME         R           Time (days wrt reference day)
C      SOURCE       I           source ID
C      IANT         I           antenna number
C      SUBID        I           subarray ID
C      FREQID       I           frequency ID
C      ANFLAG       I           Antenna-based flag bit pattern
C      STATUS       I(2,*)      Status level (pol, IF)
C   Output:
C      IERR         I           Return code (0=>ok; else error)
C                               Note: -1 => read by not selected
C----------------------------------------------------------------------
      INCLUDE 'INCS:DOFV.INC'
      CHARACTER OPCODE*4
      INTEGER   OFBUFF(512), IOFRNO, OFKOLS(MAXOFC), OFNUMV(MAXOFC),
     *   SOURCE, IANT, SUBID, FREQID, ANFLAG, STATUS(2,*), IERR
      REAL      TIME
C
      REAL      RECR(MXSPOF)
      INTEGER   RECI(MXSPOF), I, J
      EQUIVALENCE (RECR, RECI)
      INCLUDE 'INCS:DMSG.INC'
C----------------------------------------------------------------------
C                                       Initialization
      IERR = 0
C                                       Close
      IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, IOFRNO, RECR, OFBUFF, IERR)
         IF (IERR.GT.0) CALL TABERR ('CLOS', 'TABIO', 'TABOF', IERR)
C                                       Do I/O
      ELSE
C                                       If write fill RECORD
         IF (OPCODE.NE.'READ') THEN
C                                       Time
            RECR(OFKOLS(OFRTIM)) = TIME
C                                       source ID
            RECI(OFKOLS(OFISID)) = SOURCE
C                                       antenna number
            RECI(OFKOLS(OFIANT)) = IANT
C                                       subarray ID
            RECI(OFKOLS(OFISUB)) = SUBID
C                                       frequency ID
            RECI(OFKOLS(OFIFQI)) = FREQID
C                                       flag values
            RECI(OFKOLS(OFIANF)) = ANFLAG
C                                       pol 1
            J = OFKOLS(OFIST1) - 1
            DO 10 I = 1,OFNUMV(OFIST1)
               J = J + 1
               RECI(J) = STATUS(1,I)
 10            CONTINUE
C                                       pol 2
            DO 20 I = 1,OFNUMV(OFIST2)
               J = J + 1
               RECI(J) = STATUS(2,I)
 20            CONTINUE
            END IF
C                                       Process record
         CALL TABIO (OPCODE, 0, IOFRNO, RECR, OFBUFF, IERR)
         IOFRNO = IOFRNO + 1
         IF (IERR.GT.0) THEN
            CALL TABERR (OPCODE, 'TABIO', 'TABOF', IERR)
            GO TO 999
C                                       If READ pick data from record
         ELSE IF (OPCODE.EQ.'READ') THEN
C                                       Time
            TIME = RECR(OFKOLS(OFRTIM))
C                                       source ID
            SOURCE = RECI(OFKOLS(OFISID))
C                                       antenna number
            IANT = RECI(OFKOLS(OFIANT))
C                                       subarray ID
            SUBID = RECI(OFKOLS(OFISUB))
C                                       frequency ID
            FREQID = RECI(OFKOLS(OFIFQI))
C                                       flag values
            ANFLAG = RECI(OFKOLS(OFIANF))
C                                       pol 1
            J = OFKOLS(OFIST1) - 1
            DO 110 I = 1,OFNUMV(OFIST1)
               J = J + 1
               STATUS(1,I) = RECI(J)
 110           CONTINUE
C                                       pol 2
            DO 120 I = 1,OFNUMV(OFIST2)
               J = J + 1
               STATUS(2,I) = RECI(J)
 120           CONTINUE
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE DATEST (FDATE, ID)
C-----------------------------------------------------------------------
C! converts 'DD/MM/YY' or 'YYYYMMDD' to date numbers
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 2018
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Convert ALPHA forms of date to integers
C   Inputs:
C      FDATE  C*8    FITS packed string: 'DD/MM/YY' or 'YYYYMMDD'
C   Output:
C      ID     I(3)   ID(1)   year since 0.
C                    ID(2)   month (1-12).
C                    ID(3)   day   (1-31).
C-----------------------------------------------------------------------
      CHARACTER FDATE*(*)
      INTEGER   ID(3)
C
      INTEGER   IDATE(3)
C-----------------------------------------------------------------------
C                                       Get date: old format
      IF (FDATE(3:3).EQ.'/') THEN
         READ (FDATE,1000,ERR=10) IDATE
         ID(1) = IDATE(3)
         ID(2) = IDATE(2)
         ID(3) = IDATE(1)
         IF (ID(1).LE.50) ID(1) = ID(1) + 100
         ID(1) = ID(1) + 1900
C                                       get date new format
      ELSE
         READ (FDATE,1010,ERR=10) ID
         END IF
      GO TO 999
C                                       bad string
 10   CALL FILL (3, -1, ID)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I2,1X,I2,1X,I2)
 1010 FORMAT (I4,I2,I2)
      END

      SUBROUTINE CHUNT (K, LL, NT, ISTART, KHUNT)
C-----------------------------------------------------------------------
C! searches symbol table for character string accepting min match
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   CHUNT searches a linked list usually the symbol table
C   It goes by characters and will take min match if MODE not 69
C   Inputs:
C      K       I(*)  contains linked tables
C      NT      I     number of characters to match
C      ISTART  I     offset within each table entry for matching
C      KHUNT   H(*)  string to match
C   In/Outputs:
C      LL      I     in : start address in K for tables
C                    out: pointer to entry found (0 if none)
C-----------------------------------------------------------------------
      INTEGER   K(*), LL, NT, ISTART
      HOLLERITH KHUNT(*)
C
      CHARACTER PRMSG*28
      INTEGER   IMSP, IMSTK(20), LENGTH, J, I
      LOGICAL   EQUAL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DPOP.INC'
      DATA PRMSG /'SYMBOL NOT UNIQUE COULD BE  '/
C-----------------------------------------------------------------------
      IMSP = 0
      IF (NT.LE.0) LL = 0
C                                        zero link -> none
 10   IF (LL.EQ.0) GO TO 900
C                                        compare
         LENGTH = K(LL+1)/16
         IF (LENGTH.LT.NT) GO TO 30
            J = LL + ISTART
            CALL CHCOMP (NT, 1, K(J), 1, KHUNT, EQUAL)
C                                       got something
            IF (.NOT.EQUAL) GO TO 30
C                                       min match applies
               IF (LENGTH.EQ.NT) GO TO 999
                  IF (IMSP.GE.20) GO TO 30
                     IMSP = IMSP + 1
                     IMSTK(IMSP) = LL
C                                       keep looking
 30      LL = K(LL)
         GO TO 10
C                                       what now: any match?
 900  IF ((IMSP.LE.0) .OR. (MODE.EQ.69)) GO TO 999
C                                       unique min match
      IF (IMSP.GT.1) GO TO 910
         LL = IMSTK(1)
         GO TO 999
C                                       not unique: error messages
 910  DO 920 I = 1,IMSP
         J = IMSTK(I)
         LENGTH = K(J+1)/16
         MSGTXT = PRMSG
         J = J + ISTART
         CALL H2CHR (LENGTH, 1, K(J), MSGTXT(29:))
         CALL MSGWRT (1)
 920     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE YTCOMP (OLD, NEW, UPDATE)
C-----------------------------------------------------------------------
C! decide if a parameter has changed
C# Y0 TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Check whether a value in a soft register has to be changed.  If so,
C   change it and set a flag indicating that the hard register must be
C   updated too.
C   Inputs:
C      OLD      I   Current value in soft register
C      NEW      I   New value
C   Output:
C      OLD      I   Put new value here too if necessary
C      UPDATE   L   Set true if update is needed, else leave alone
C   Generic - used only in DeAnza, not really a Y at all.
C-----------------------------------------------------------------------
      INTEGER   OLD, NEW
      LOGICAL   UPDATE
C-----------------------------------------------------------------------
      IF (OLD.NE.NEW) THEN
         OLD = NEW
         UPDATE = .TRUE.
         END IF
C
 999  RETURN
      END

      SUBROUTINE CALREF (OLDREF, NEWREF, SUB, ROWIDX, IFFREQ, SMOTIM,
     *   MAXTIM, TBLBUF, WRKTIM, WORK1, WORK2, WORK3, WORK4, IRET)
C-----------------------------------------------------------------------
C! Adjusts the reference antenna in an SN table.
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1999, 2003, 2011
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Change the reference antenna for a single IF and polarization in an
C   SN table from antenna number OLDREF to antenna number NEWREF in
C   subarray number SUB, interpolating between or extrapolating from
C   tabulated values of the phase, delay, and rate corrections for
C   OLDREF relative to NEWREF that have been extracted from the table
C   and smoothed using boxcar functions with widths given by SMOTIM. Use
C   the smoothed rate corrections to provide time derivatives for the
C   phase and delay corrections during interpolation/extrapolation.
C
C   The SN table may be assumed to be open and in time order.
C   Inputs:
C      OLDREF  I          Old reference antenna number
C      NEWREF  I          New reference antenna number
C      SUB     I          Subarray number
C      ROWIDX  I(9)       Indices into an SN table row for
C                          1 - antenna number
C                          2 - reference antenna for current IF and
C                              polarization
C                          3 - subarray number
C                          4 - weight for corrections for current IF and
C                              polarization
C                          5 - time
C                          6 - real gain correction for current IF and
C                              polarization
C                          7 - imaginary gain correction for current IF
C                              and polarization
C                          8 - delay correction for current IF and
C                              polarization
C                          9 - rate correction for current IF and
C                              polarization
C                          All assumed to be valid indices into an SN
C                          table row buffer.
C      IFFREQ  D           IF reference frequency in Hz (i.e. data
C                           reference frequency plus IF offset)
C      SMOTIM  R(3)        Boxcar smoothing times for phase (1),
C                           delay (2), and rate (3) in days. Zero or
C                           negative values imply no smoothing before
C                           interpolation
C      MAXTIM  I           Maximum number of time slots in interpolation
C                          workspace. Assumed to be positive.
C   Input/Output:
C      TBLBUF  I(*)        Table I/O buffer for SN table. Assumed to
C                           have been initialized by TABOPN. Updated
C                           on exit
C      WRKTIM  R(MAXTIM)   Interpolation workspace. Trashed on exit.
C      WORK1   R(MAXTIM)   Interpolation workspace. Trashed on exit.
C      WORK2   R(MAXTIM)   Interpolation workspace. Trashed on exit.
C      WORK3   R(MAXTIM)   Interpolation workspace. Trashed on exit.
C      WORK4   R(MAXTIM)   Interpolation workspace. Trashed on exit.
C   Output:
C      IRET    I           Return status
C                            0 - table updated
C                            1 - can not reference OLDREF to NEWREF;
C                                table is unchanged and an error
C                                message has been issued
C                            2 - insufficient interpolation workspace;
C                                table is unchanged and an error
C                                message has been issued
C                            3 - error detected while filling workspace;
C                                table is unchanged and an error
C                                message has been issued
C                            4 - error detected while updating table;
C                                table may be partly updated and an
C                                error message has been issued
C-----------------------------------------------------------------------
      INTEGER   OLDREF, NEWREF, SUB, ROWIDX(9)
      DOUBLE PRECISION IFFREQ
      REAL      SMOTIM(3)
      INTEGER   MAXTIM, TBLBUF(*)
      REAL      WRKTIM(MAXTIM), WORK1(MAXTIM), WORK2(MAXTIM)
      REAL      WORK3(MAXTIM), WORK4(MAXTIM)
      INTEGER   IRET
C
C     Local variables
C
C     NUMROW    Number of rows in SN table
C     NUMTIM    Number of tabulated phase, delay, and rate corrections
C                for OLDREF relative to NEWREF
C     SMALL     Small number threshold
C     ROW       TABIO code for row I/O
C     SECPDY    Number of seconds in a day
C     FTLERR    Message priority for fatal error messages
C
C     TIMIDX    Time index in SN table row
C     ANTIDX    Antenna number index in SN table row
C     SUBIDX    Subarray number index in SN table row
C     REFIDX    Reference antenna number index in SN table row
C     GRIDX     Real gain index in SN table row
C     GIIDX     Imaginary gain index in SN table row
C     DELIDX    Delay index in SN table row
C     RATIDX    Rate index in SN table row
C     WTIDX     Weight index in SN table row
C
C     SNROW     SN table row number
C     SNROWR    SN row buffer as array of REAL
C     SNROWI    SN row buffer as array of INTEGER
C     SNROWD    SN row buffer as array of DOUBLE PRECISION
C
C     BEFORE    Index of latest time before current record in
C               interpolation table or 1 if there are no times
C               prior to the current record in the interpolation
C               table
C     AFTER     Index of the earliest time after the current record
C               in the interpolation or NUMTIM if there are no
C               times after the current record in the interpolation
C               table
C
C     WT1       Weight of interpolation point 1
C     WT2       Weight of interpolation point 2
C     Y1        Value at interpolation point 1
C     Y2        Value at interpolation point 2
C
C     GR        Real part of gain
C     GI        Imaginary part of gain
C
C     PHASE     Interpolated phase
C
      INTEGER   NUMROW
      INTEGER   NUMTIM
      REAL      SMALL
      INTEGER   ROW
      PARAMETER (ROW = 0)
      DOUBLE PRECISION SECPDY
      PARAMETER (SECPDY = 24.0D0 * 60.0D0 * 60.0D0)
      INTEGER   FTLERR
      PARAMETER (FTLERR = 8)
C
      INTEGER   TIMIDX, ANTIDX, SUBIDX, REFIDX, GRIDX, GIIDX, DELIDX
      INTEGER   RATIDX, WTIDX
C
      INTEGER   SNROW
      REAL      SNROWR(1024)
      INTEGER   SNROWI(1024)
      DOUBLE PRECISION SNROWD(512)
      EQUIVALENCE (SNROWR, SNROWI, SNROWD)
C
      INTEGER   BEFORE, AFTER, TABC, SORC, NUMOLD
      REAL      WT1, WT2, Y1, Y2, GR, GI, PHASE
      CHARACTER TABIOC(2)*4
      LOGICAL   WASPHS
C
C     REAL      SLAMCH
C     EXTERNAL  SLAMCH
C
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA TABIOC /'FLAG','WRIT'/
C-----------------------------------------------------------------------
      SORC = -1
C                                       Number of rows in table
      NUMROW = TBLBUF(5)
      WASPHS = .FALSE.
C                                       No change is needed.
      IF ((NUMROW.EQ.0) .OR. (NEWREF.EQ.OLDREF)) THEN
         IRET = 0
C                                       Update the table:
      ELSE
         NUMOLD = 0
C
C        Update the table rows with refence antenna OLDREF in subarray
C        SUB using phase, delay, and rate information for OLDREF
C        relative to NEWREF extracted from the table and set IRET to
C        zero otherwise issue a fatal error message and set IRET to
C        a positive number:
C                                       Threshold value small numbers
C        SMALL = SQRT (SLAMCH ('safe minimum'))
         SMALL = 1.E-10
C                                       Mnemonic pointers into table
         ANTIDX = ROWIDX(1)
         REFIDX = ROWIDX(2)
         SUBIDX = ROWIDX(3)
         WTIDX  = ROWIDX(4)
         TIMIDX = ROWIDX(5)
         GRIDX  = ROWIDX(6)
         GIIDX  = ROWIDX(7)
         DELIDX = ROWIDX(8)
         RATIDX = ROWIDX(9)
C
C        Find unflagged SN table rows that directly relate OLDREF to
C        NEWREF in subarray SUB and the have unblanked values for the
C        gain, delay and rate corrections with a positive weight and
C        non-negligable gain amplitude. Store the number of such
C        records as NUMTIM, their times in WRKTIM and the phase, rate
C        and delay corrections for OLDREF relative to NEWREF in WORK2,
C        WORK3, and WORK4. Issue a fatal error message and set IRET
C        to 3 if there is an error reading the table; issue a fatal
C        error message and set IRET to 2 if NUMTIM would exceed MAXTIM;
C        otherwise set IRET to 0.
C
         IRET  = 0
         SNROW = 0
         NUMTIM = 0
 10      IF ((SNROW.NE.NUMROW) .AND. (IRET.EQ.0)) THEN
            SNROW = SNROW + 1
            CALL TABIO ('READ', ROW, SNROW, SNROWR, TBLBUF, IRET)
C                                       Ignore flagged row:
            IF (IRET.LT.0) THEN
               IRET = 0
            ELSE IF (IRET.EQ.0) THEN
               IF (ABS(SNROWR(GIIDX)).GT.SMALL) WASPHS = .TRUE.
               IF (((SNROWI(SUBIDX).EQ.SUB) .OR. (SNROWI(SUBIDX).LE.0))
     *             .AND. (SNROWI(REFIDX).EQ.OLDREF) .AND.
     *             (SNROWR(WTIDX).GT.0.0)) NUMOLD = NUMOLD + 1
               IF (((SNROWI(SUBIDX).EQ.SUB) .OR. (SNROWI(SUBIDX).LE.0))
     *             .AND. (((SNROWI(ANTIDX).EQ.OLDREF) .AND.
     *             (SNROWI(REFIDX).EQ.NEWREF)) .OR.
     *             ((SNROWI(REFIDX).EQ.OLDREF) .AND.
     *             (SNROWI(ANTIDX).EQ.NEWREF)))
     *             .AND. (SNROWR(WTIDX).GT.0.0)) THEN
C
C                 The current row relates OLDREF to NEWREF with positive
C                 weight. If the gain, delay and rate corrections are
C                 not blanked and the gain correction has a non-
C                 negligable amplitude then store store the phase,
C                 delay, and rate corrections for OLDREF relative to
C                 NEWREF if NUMTIM is less than MAXTIM or issue a fatal
C                 error message and set IRET to 2 if NUMTIM equals
C                 MAXTIM:
C
                  IF ((SNROWR(GRIDX).NE.FBLANK)
     *                .AND. (SNROWR(GIIDX).NE.FBLANK)
     *                .AND. (SNROWR(DELIDX).NE.FBLANK)
     *                .AND. (SNROWR(RATIDX).NE.FBLANK)) THEN
C
C                    If the gain amplitude is non-negligable then store
C                    the phase, delay and rate corrections for OLDREF
C                    relative to NEWREF if NUMTIM is less than MAXTIM
C                    or issue a fatal error message and set IRET to 2
C                    if NUMTIM equals MAXTIM:
C
                     IF ((ABS (SNROWR(GRIDX)).GE.SMALL)
     *                   .OR. (ABS (SNROWR(GIIDX)).GE.SMALL)) THEN
C
C                       Store the phase, delay and rate corrections for
C                       OLDREF relative to NEWREF if NUMTIM is less than
C                       MAXTIM or issue a fatal error message and set
C                       IRET to 2 if NUMTIM equals MAXTIM:
C
                        IF (NUMTIM.NE.MAXTIM) THEN
C
C                          Store the phase, delay and rate corrections
C                          for OLDREF relative to NEWREF and increment
C                          NUMTIM:
C
                           NUMTIM = NUMTIM + 1
                           WRKTIM(NUMTIM) = REAL (SNROWD(TIMIDX))
C
C                             Record gives corrections for OLDREF
C                             relative to NEWREF.
                           IF (SNROWI(ANTIDX).EQ.OLDREF) THEN
C                                       +- 90 degrees
                              IF (ABS (SNROWR(GRIDX)).LT.SMALL) THEN
                                 IF (SNROWR(GIIDX).GT.0.0) THEN
                                    WORK2(NUMTIM) = REAL (PI / 2.0D0)
                                 ELSE
                                    WORK2(NUMTIM) = -REAL (PI / 2.0D0)
                                    END IF
                              ELSE
                                 WORK2(NUMTIM) = ATAN2 (SNROWR(GIIDX),
     *                                                  SNROWR(GRIDX))
                                 END IF
                              WORK3(NUMTIM) = SNROWR(DELIDX)
                              WORK4(NUMTIM) = SNROWR(RATIDX)
C
C                             Record gives corrections for NEWREF
C                             relative to OLDREF. Flip signs to get
C                             corrections for OLDREF realtive to
C                             NEWREF:
                           ELSE
C                                       +- 90 degrees
                              IF (ABS (SNROWR(GRIDX)).LT.SMALL) THEN
                                 IF (SNROWR(GIIDX).GT.0.0) THEN
                                    WORK2(NUMTIM) = -REAL (PI / 2.0D0)
                                 ELSE
                                    WORK2(NUMTIM) = REAL (PI / 2.0D0)
                                    END IF
                              ELSE
                                 WORK2(NUMTIM) = -ATAN2 (SNROWR(GIIDX),
     *                                                   SNROWR(GRIDX))
                                 END IF
                              WORK3(NUMTIM) = -SNROWR(DELIDX)
                              WORK4(NUMTIM) = -SNROWR(RATIDX)
                              END IF
C
C                          No room left in interpolation table. Issue
C                          a fatal error message and set IRET to 2
                        ELSE
                           WRITE (MSGTXT,9010) MAXTIM
                           CALL MSGWRT (FTLERR)
                           IRET = 2
                           END IF
                        END IF
                     END IF
                  END IF
C                                       Read error. Issue a fatal error
C                                       message and set IRET to 3:
            ELSE
               WRITE (MSGTXT, 9011) IRET
               CALL MSGWRT (FTLERR)
               IRET = 2
               END IF
C                                       loop for more
            GO TO 10
            END IF
C
C        If no error conditions were detected while reading the
C        interpolation data then update the table using this data
C        or issue a fatal error message and set IRET to 1 if no
C        data were accumulated.  Issue a fatal error message and
C        set IRET to 4 if an error is detected while updating the
C        table.
C
         IF (IRET.EQ.0) THEN
C                                       No data relates OLDREF to
C                                       NEWREF. Issue a fatal error.
C
            IF (NUMTIM.EQ.0) THEN
               WRITE (MSGTXT,9012) OLDREF, NEWREF, SUB
               IF ((WASPHS) .AND. (NUMOLD.GT.0)) CALL MSGWRT (FTLERR)
               IF (NUMOLD.GT.0) IRET = 1
C                                       Smooth phases to WORK1, delays
C                                       to WORK2, and rates to WORK3:
            ELSE
               IF (SMOTIM(1).GE.1.1E-6) THEN
                  CALL BOXBSM (SMOTIM(1), WRKTIM, WORK2, SORC, FBLANK,
     *               NUMTIM, WORK1)
               ELSE
                  CALL RCOPY (NUMTIM, WORK2, WORK1)
                  END IF
               IF (SMOTIM(2).GE.1.1E-6) THEN
                  CALL BOXBSM (SMOTIM(2), WRKTIM, WORK3, SORC, FBLANK,
     *               NUMTIM, WORK2)
               ELSE
                  CALL RCOPY (NUMTIM, WORK3, WORK2)
                  END IF
               IF (SMOTIM(3).GE.1.1E-6) THEN
                  CALL BOXBSM (SMOTIM(3), WRKTIM, WORK4, SORC, FBLANK,
     *               NUMTIM, WORK3)
               ELSE
                  CALL RCOPY (NUMTIM, WORK4, WORK3)
                  END IF
C
C              Update reference antenna in SN table using data
C              interpolated or extrapolated from WORK1, WORK2 and WORK3.
C              Issue a fatal error message and set IRET to 4 if a read
C              or write error is detected.
C
C                                       Initialize pointers
               BEFORE = 1
               AFTER  = MIN (2, NUMTIM)
C                                       Update table rows with reference
C                                       antenna OLDREF in subarray SUB:
               SNROW = 0
 20            IF ((SNROW.NE.NUMROW) .AND. (IRET.EQ.0)) THEN
                  SNROW = SNROW + 1
                  CALL TABIO ('READ', ROW, SNROW, SNROWR, TBLBUF, IRET)
C                                       Flagged rows should be adjusted
C                                       as well as unflagged rows.
                  IF (IRET.LE.0) THEN
                     TABC = MAX (1, IRET+2)
                     IF ((SNROWI(REFIDX).EQ.OLDREF) .AND.
     *                  ((SNROWI(SUBIDX).EQ.SUB) .OR.
     *                  (SNROWI(SUBIDX).EQ.0))) THEN
C
C                       Increment the interpolation table pointers
C                       until AFTER is either equal to NUMTIM or
C                       points to a time equal to or later than the
C                       SN row time:
C
 30                     IF ((AFTER.NE.NUMTIM) .AND. (REAL
     *                     (SNROWD(TIMIDX)).GT.WRKTIM(AFTER))) THEN
                           BEFORE = BEFORE + 1
                           AFTER = AFTER + 1
                           GO TO 30
                           END IF
C
C                       There are 4 cases to consider
C                       1 - If WRKTIM(AFTER) < SNROWD(TIMIDX) then
C                           the row time is after the last entry in
C                           the table and the corrections must be
C                           extrapolated.
C                       2 - If WRKTIM(BEFORE) > SNROWD(TIMIDX) then
C                           the row time is before the first entry in
C                           the table and the corrections must be
C                           extrapolated
C                       3 - If WRKTIM(BEFORE) = SNROWD(TIMIDX)
C                           = WRKTIM(AFTER) then there may be two
C                           tabulated corrections for the row and
C                           they may be averaged. Interpolation
C                           would cause a divide by zero fault.
C                       4 - Otherwise the table entries may be
C                           interpolated.
C
C                       Set interpolation weights:
C
                        IF (WRKTIM(AFTER)
     *                     .LT.REAL (SNROWD(TIMIDX))) THEN
                           WT1 = 1.0
                           WT2 = 0.0
                        ELSE IF (WRKTIM(BEFORE)
     *                          .GT.REAL (SNROWD(TIMIDX))) THEN
                           WT1 = 0.0
                           WT2 = 1.0
                        ELSE IF ((WRKTIM(BEFORE)
     *                           .EQ.REAL (SNROWD(TIMIDX)))
     *                           .AND. (WRKTIM(BEFORE)
     *                                 .EQ.WRKTIM(AFTER))) THEN
                           WT1 = 0.5
                           WT2 = 0.5
                        ELSE
                           WT1 = (WRKTIM(AFTER)
     *                            - REAL (SNROWD(TIMIDX)))
     *                           / (WRKTIM(AFTER) - WRKTIM(BEFORE))
                           WT2 = 1.0 - WT1
                           END IF
C
C                       Update phase correction if gain correction
C                       is not blank using the tabulated rate
C                       rate to calculate time derivatives:
C
                        IF ((SNROWR(GRIDX).NE.FBLANK)
     *                      .AND. (SNROWR(GIIDX).NE.FBLANK)) THEN
                           IF (WRKTIM(AFTER)
     *                        .LT.REAL (SNROWD(TIMIDX))) THEN
                              Y1 = WORK1(AFTER)
     *                             + TWOPI * SECPDY * WORK3(AFTER)
     *                             * (REAL (SNROWD(TIMIDX))
     *                                - WRKTIM(AFTER)) * IFFREQ
                              Y2 = 0.0
                           ELSE IF (WRKTIM(BEFORE)
     *                             .GT.REAL (SNROWD(TIMIDX))) THEN
                              Y1 = 0.0
                              Y2 = WORK1(BEFORE)
     *                             + TWOPI * SECPDY * WORK3(BEFORE)
     *                             * (REAL (SNROWD(TIMIDX))
     *                                - WRKTIM(BEFORE)) * IFFREQ
                           ELSE IF ((WRKTIM(BEFORE)
     *                              .EQ.REAL (SNROWD(TIMIDX)))
     *                              .AND. (WRKTIM(BEFORE)
     *                                    .EQ.WRKTIM(AFTER))) THEN
                              Y1 = WORK1(BEFORE)
                              Y2 = WORK1(AFTER)
                           ELSE
                              Y1 = WORK1(BEFORE)
     *                             + TWOPI * SECPDY * WORK3(BEFORE)
     *                             * (REAL (SNROWD(TIMIDX))
     *                                - WRKTIM(BEFORE)) * IFFREQ
                              Y2 = WORK1(AFTER)
     *                             + TWOPI * SECPDY * WORK3(AFTER)
     *                             * (REAL (SNROWD(TIMIDX))
     *                                - WRKTIM(AFTER)) * IFFREQ
                              END IF
                           PHASE = WT1 * Y1 + WT2 * Y2
                           GR = SNROWR(GRIDX)
                           GI = SNROWR(GIIDX)
                           SNROWR(GRIDX) = GR * COS(PHASE)
     *                                     - GI * SIN(PHASE)
                           SNROWR(GIIDX) = GR * SIN(PHASE)
     *                                     + GI * COS(PHASE)
                           END IF
C
C                       Update delay correction if it is not blank:
C
                        IF (SNROWR(DELIDX).NE.FBLANK) THEN
                           IF (WRKTIM(AFTER)
     *                        .LT.REAL (SNROWD(TIMIDX))) THEN
                              Y1 = WORK2(AFTER)
     *                             + WORK3(AFTER) * SECPDY
     *                             * (REAL (SNROWD(TIMIDX))
     *                                - WRKTIM(AFTER))
                              Y2 = 0.0
                           ELSE IF (WRKTIM(BEFORE)
     *                             .GT.REAL (SNROWD(TIMIDX))) THEN
                              Y1 = 0.0
                              Y2 = WORK2(BEFORE)
     *                             + WORK3(BEFORE) * SECPDY
     *                             * (REAL (SNROWD(TIMIDX))
     *                                - WRKTIM(BEFORE))
                           ELSE IF ((WRKTIM(BEFORE)
     *                              .EQ.REAL (SNROWD(TIMIDX)))
     *                              .AND. (WRKTIM(BEFORE)
     *                                    .EQ.WRKTIM(AFTER))) THEN
                              Y1 = WORK2(BEFORE)
                              Y2 = WORK2(AFTER)
                           ELSE
                              Y1 = WORK2(BEFORE)
     *                             + WORK3(BEFORE) * SECPDY
     *                             * (REAL (SNROWD(TIMIDX))
     *                                - WRKTIM(BEFORE))
                              Y2 = WORK2(AFTER)
     *                             + WORK3(AFTER) * SECPDY
     *                             * (REAL (SNROWD(TIMIDX))
     *                                - WRKTIM(AFTER))
                              END IF
                           SNROWR(DELIDX) = SNROWR(DELIDX)
     *                                      + WT1 * Y1 + WT2 * Y2
                           END IF
C
C                       Adjust rate correction if it is not blanked:
C
                        IF (SNROWR(RATIDX).NE.FBLANK) THEN
                           IF (WRKTIM(AFTER)
     *                        .LT.REAL (SNROWD(TIMIDX))) THEN
                              Y1 = WORK3(AFTER)
                              Y2 = 0.0
                           ELSE IF (WRKTIM(BEFORE)
     *                             .GT.REAL (SNROWD(TIMIDX))) THEN
                              Y1 = 0.0
                              Y2 = WORK3(BEFORE)
                           ELSE
                              Y1 = WORK3(BEFORE)
                              Y2 = WORK3(AFTER)
                              END IF
                           SNROWR(RATIDX) = SNROWR(RATIDX)
     *                                         + WT1 * Y1 + WT2 * Y2
                           END IF
                        SNROWI(REFIDX) = NEWREF
C                                       Write updated record to table
                        CALL TABIO (TABIOC(TABC), ROW, SNROW, SNROWR,
     *                     TBLBUF, IRET)
C                                       Write error. Set IRET to 4:
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,9030) IRET
                           CALL MSGWRT (FTLERR)
                           IRET = 4
                           END IF
                        END IF
C                                       Table read error. set IRET to 4
                  ELSE
                     WRITE (MSGTXT,9030) IRET
                     CALL MSGWRT (FTLERR)
                     IRET = 4
                     END IF
C                                       loop for more
                  GO TO 20
                  END IF
               END IF
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 9010 FORMAT ('CALREF: INTERPOLATION TABLE SPACE (', I6, ' ENTRIES) ',
     *        'EXHAUSTED')
 9011 FORMAT ('CALREF: TABIO ERROR ', I4,
     *        ' BUILDING INTERPOLATION TABLES')
 9012 FORMAT ('CALREF: CANNOT RELATE ANTENNA ', I2, ' TO ', I2,
     *        ' IN SUBARRAY ', I2)
 9030 FORMAT ('CALREF: TABIO ERROR ', I4, ' UPDATING SN TABLE')
      END

      SUBROUTINE YCHRW (CHAN, X, Y, STRING, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! writes characters into image and graphics planes
C# Y0 TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YCHRW  writes characters into image planes of the TV.  The format is
C   5 by 7 with one blank all around: net 7 in X by 9 in Y. This version
C   will work on all TVs which allow horizontal writing to the right. It
C   is a Y routine to allow for hardware character generators on the TV.
C   Inputs:
C      CHAN    I       channel select  (1 to NGRAY + NGRAPH)
C      X       I       X position lower left corner first char.
C      Y       I       Y position lower left corner first char.
C      STRING  C*(*)   character string - length passed from Fortran
C   Output:
C      SCRTCH  I(>)    scratch buffer (dim = 14*count+8 < 1031)
C      IERR    I       error code of Z...XF:0 - ok
C                                           2 - input error
C   Virtual TV version is for TV by communication.
C-----------------------------------------------------------------------
      CHARACTER STRING*(*)
      INTEGER   CHAN, X, Y, SCRTCH(*), IERR
C
      REAL      XT(50)
      INTEGER   COUNT, IXT(50), I, LX, LY
      INCLUDE 'INCS:DVTV.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      EQUIVALENCE (XT, IXT)
C-----------------------------------------------------------------------
C                                        check input
      IERR = 2
      COUNT = LEN (STRING)
      LX = X + COUNT*CSIZTV(1) - 1
      LY = Y + CSIZTV(2) - 1
      IF ((Y.LT.1) .OR. (LY.GT.MAXXTV(2))) GO TO 900
      IF ((X.LT.1) .OR. (LX.GT.MAXXTV(1))) GO TO 900
      IF (COUNT.LE.0) GO TO 900
C                                       set up parms
      BUFFER(1) = CHAN
      BUFFER(2) = X
      BUFFER(3) = Y
      BUFFER(4) = COUNT
C                                       do string
      CALL ZCLC8 (COUNT, STRING, 1, XT)
      I = (COUNT - 1) / 2 + 1
      CALL ZI16IL (I, 1, IXT, BUFFER(5))
      BUFSW = 4 + I
      BUFSR = 0
      CALL MKYBUF ('WRIT', 'YCHRW ', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
      GO TO 999
C
 900  WRITE (MSGTXT,1900) X, LX, Y, LY, COUNT
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('YCHRW: BAD X,LX, Y,LY, COUNT =',5I7)
      END

LOCAL INCLUDE 'AMKAT.INC'
C                                       Local include for AMKAT
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      REAL      XSIN, XDISIN, XSOUT, XDISO
      REAL      BUFF1(UVBFSS), BUFF2(UVBFSS)
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, JBUFSZ, ILOCWT,
     *   CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI,
     *   LRECO, NRPRMI, NRPRMO, OLDCNO, NEWCNO, OUTANT(MAXANT,10), NSUB,
     *   MXANT(10), MISANT(MAXANT,10), IBUFF1(UVBFSS), IBUFF2(UVBFSS)
      LOGICAL   ISCOMP
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      EQUIVALENCE (BUFF1, IBUFF1), (BUFF2, IBUFF2)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XCLAOU,
     *   XSOUT, XDISO
      COMMON /TPARMS/ CATOLD, SEQIN, SEQOUT, DISKIN, DISKO, ILOCWT,
     *   INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI, LRECO,
     *   NRPRMI, NRPRMO, ISCOMP, OLDCNO, NEWCNO, OUTANT, NSUB, MXANT,
     *   MISANT
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
C                                       End local include for AMKAT
LOCAL END
      PROGRAM AMKAT
C-----------------------------------------------------------------------
C! Renumbers MeerKAT antennas to match station IDs
C# Utility UV UV-util VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AMKAT renumbers MeerKAT antennas to match station IDs
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'AMKAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'AMKAT '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL AMKATI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL AMKATU (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL AMKATH
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE AMKATI (PRGN, JERR)
C-----------------------------------------------------------------------
C   AMKATI gets input parameters for AMKAT and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in AMKAT for more details.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX
      LOGICAL   T, F
      INCLUDE 'AMKAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK  /'      '/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 14
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING HEADER'
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       Read AN files - do we do this?
      JERR = 1
      CALL AMKATR (IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING ANTENNA FILES'
         GO TO 990
      ELSE IF (IERR.LT.0) THEN
         MSGTXT = 'THERE IS NOTHING TO DO: QUITTING'
         GO TO 990
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      NEWCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, NEWCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1000) IERR, 'CREATING OUTPUT DATA SET'
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((NEWCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, NEWCNO, CATBLK, 'WRIT', BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'UPDATING NEW CATBLK'
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AMKATI: ERROR',I3,' ON ',A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
      END
      SUBROUTINE AMKATR (IRET)
C-----------------------------------------------------------------------
C   AMKATR reads the antenna files and makes a list of output antenna
C   numbers
C   Output:
C      IRET   I   Error code: 0 ok, > 0 real error, < 0 nothing to do
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'AMKAT.INC'
      INTEGER   ISUB, BUFF(512), I, J, K, KK, NDIFF
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
C-----------------------------------------------------------------------
      IRET = -1
      CALL FNDEXT ('AN', CATOLD, NSUB)
      IF (NSUB.LE.0) THEN
         MSGTXT = 'NO ANTENNA FILES FOUND'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      NDIFF = 0
      CALL FILL (10*MAXANT, 0, OUTANT)
      CALL FILL (10*MAXANT, 0, MISANT)
      CALL FILL (10, 0, MXANT)
C                                       loop subarrays
      DO 100 ISUB = 1,NSUB
         CALL GETANT (DISKIN, OLDCNO, ISUB, CATOLD, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, ISUB
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       loop antennas
         DO 10 I = 1,NSTNS
            J = TELNO(I)
            READ (STNNAM(I),1000,ERR=900) K
            K = K + 1
            OUTANT(J,ISUB) = K
            MXANT(ISUB) = MAX (MXANT(ISUB), K)
            IF (J.NE.K) NDIFF = NDIFF + 1
 10         CONTINUE
C                                       Missing antennas
         I = 0
         DO 30 K = 1,64
            DO 20 KK = 1,NSTNS
               IF (OUTANT(KK,ISUB).EQ.K) GO TO 30
 20            CONTINUE
            I = I + 1
            MISANT(I,ISUB) = K
 30         CONTINUE
 100     CONTINUE
      IRET = -1
      IF (NDIFF.GT.0) IRET = 0
      WRITE (MSGTXT,1100) NDIFF
      IF (NDIFF.GT.0) CALL MSGWRT (4)
      GO TO 999
C                                       format issue
 900  WRITE (MSGTXT,1900) I, ISUB, STNNAM(I)
      CALL MSGWRT (8)
      IRET = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (1X,I3)
 1010 FORMAT ('GETANT ERROR',I4,' SUBARRAY',I3)
 1100 FORMAT ('AMKATR found',I5,' antennas to correct')
 1900 FORMAT ('AMKATR FORMAT ISSUE ANT, SUB, STN',I4,I3,' ''',A,'''')
      END
      SUBROUTINE AMKATU (IRET)
C-----------------------------------------------------------------------
C   AMKATU changes the antenna numbers
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48, IFILE*48
      INTEGER   INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, ILENBU,
     *   KBIND, NIOUT, NIOLIM, IBIND, I, IA1, IA2, INCX, BO, VO, ISUB,
     *   NUMVIS, XCOUNT, NCORI, NCORO, NCOPY, RNXRET, VISINC, VISMSG
      LOGICAL   T, F
      INCLUDE 'AMKAT.INC'
      REAL      BASEN, CBUFF(UVBFSS), RESULT(UVBFSS)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI, LUNO /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
      IF (ISCOMP) INCX = 3
      VISINC = CATBLK(KIGCN) / 20
      VISMSG = CATBLK(KIGCN) / 10
      VISINC = MAX (20000, MIN (200000,VISINC))
      VISMSG = (VISMSG / VISINC) * VISINC
      IF (VISMSG.LT.VISINC) VISMSG = 100 * VISINC
C                                       Number of visibilities in input
C                                       and output files.
      NCORI = (LRECI - NRPRMI) / CATOLD(KINAX)
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, NEWCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Out of data?
         IF (INIO.LE.0) GO TO 200
C                                       Loop over buffer
         DO 190 I = 1,INIO
            IF (ILOCB.GE.0) THEN
               BASEN = BUFF1(IPTRI+ILOCB)
               IA1 = BASEN / 256. + 0.1
               IA2 = BASEN - IA1*256. + 0.1
               ISUB = (BASEN - 256*IA1 - IA2) * 100.0 + 1.5
               IA1 = OUTANT(IA1,ISUB)
               IA2 = OUTANT(IA2,ISUB)
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               ISUB = BUFF1(IPTRI+ILOCSA) + 0.1
               IA1 = OUTANT(IA1,ISUB)
               IA2 = OUTANT(IA2,ISUB)
               END IF
            NUMVIS = NUMVIS + 1
            IF (MOD(NUMVIS-1,VISMSG).EQ.0) THEN
               WRITE (MSGTXT,1105) NUMVIS
               CALL MSGWRT (2)
            ELSE IF (MOD(NUMVIS-1,VISINC).EQ.0) THEN
               WRITE (MSGTXT,1105) NUMVIS
               CALL MSGWRT (1)
               END IF
C                                      Call user routine.
            IF (ISCOMP) THEN
C                                       Compressed data.
               CALL ZUVXPN (NCORI, BUFF1(IPTRI+NRPRMI),
     *            BUFF1(IPTRI+ILOCWT), CBUFF)
               CALL AMKATD (NUMVIS, IA1, IA2, ISUB, CBUFF, BUFF1(IPTRI),
     *            INCX, RESULT, IRET)
            ELSE
C                                       Un compressed data
               CALL AMKATD (NUMVIS, IA1, IA2, ISUB, BUFF1(IPTRI+NRPRMI),
     *            BUFF1(IPTRI), INCX, RESULT, IRET)
               END IF
C                                       Branch on his return
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
C                                       Copy to output.
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1.0D0
               CALL RCOPY (NRPRMO, BUFF1(IPTRI), BUFF2(IPTRO))
C                                       update NX table
               CALL RNXUPD (BUFF1(IPTRI), RNXRET)
C                                       Compressed
               IF (ISCOMP) THEN
                  CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *               BUFF2(IPTRO+NRPRMO))
               ELSE
                  CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
                  END IF
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               END IF
C                                       OK, but no output please
            IPTRI = IPTRI + LRECI
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
C                                       Read next buffer.
         GO TO 100
C                                       Finish write
 200  NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, NEWCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AMKATU: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1010 FORMAT ('AMKATU: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('AMKATU: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('AMKATU: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('AMKATU: ERROR',I3,' READING VIS FILE')
 1105 FORMAT ('AMKATU: at visibility record',I10)
 1120 FORMAT ('AMKATU: AMKATD ERROR',I3)
 1150 FORMAT ('AMKATU: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE AMKATD (NUMVIS, JA1, JA2, ISUB, VIS, RPARM, INCX,
     *   RESULT, IRET)
C-----------------------------------------------------------------------
C   Copies data to RESULT with phase reversal if IA1 > IA2
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      JA1     I    First new antenna number
C      JA2     I    Second new antenna number
C      ISUB    I    subarray
C      RPARM   R(*) Random parameter array which includes U,V,W etc
C                   but also any other random parameters.
C      VIS     R(INCX,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                   NOTE: INCX may be any value .GE. 2
C   Inputs from COMMON:
C      NRPARM     I       # random parameters.
C      NCOR       I       # correlators
C      LRECI      I    Input file record length
C      NRPRMI     I    Input number of random parameters.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
C      LRECO      I    Output file record length
C      NRPRMO     I    Output number of random parameters.
C      INCSO      I    Output Stokes' increment in vis.
C      INCFO      I    Output frequency increment in vis.
C      INCIFO     I    Output IF increment in vis.
C   Output:
C      RPARM      R    Modified random parameter array. (baseline or
C                      antenna changed)
C      RESULT  R(INCX,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, JA1, JA2, ISUB, INCX, IRET
      REAL      VIS(INCX,*), RPARM(*), RESULT(INCX,*)
C
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXO, INDEXI, I, JJS, JJ(4)
      INCLUDE 'AMKAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA JJ /1,2,4,3/
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.GT.0) THEN
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
C                                       copy data only
         IF (JA1.LE.JA2) THEN
            IF (ILOCB.GE.0) THEN
               RPARM(1+ILOCB) = 256 * JA1 + JA2 + (ISUB-1)/100.0
            ELSE
               RPARM(1+ILOCA1) = JA1
               RPARM(1+ILOCA2) = JA2
               RPARM(1+ILOCSA) = ISUB
               END IF
            DO 40 JIF = 1,NIF
               DO 30 JF = 1,NF
                  DO 20 JS = 1,NS
                     INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *                  (JS-1) * INCSI + 1
                     INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *                  (JS-1) * INCSO + 1
                     DO 10 I = 1,INCX
                        RESULT(I,INDEXO) = VIS(I,INDEXI)
 10                     CONTINUE
 20                  CONTINUE
 30               CONTINUE
 40            CONTINUE
C                                       reverse things
         ELSE
            RPARM(1+ILOCU) = -RPARM(1+ILOCU)
            RPARM(1+ILOCV) = -RPARM(1+ILOCV)
            RPARM(1+ILOCW) = -RPARM(1+ILOCW)
            IF (ILOCB.GE.0) THEN
               RPARM(1+ILOCB) = 256 * JA2 + JA1 + (ISUB-1)/100.0
            ELSE
               RPARM(1+ILOCA1) = JA2
               RPARM(1+ILOCA2) = JA1
               RPARM(1+ILOCSA) = ISUB
               END IF
            DO 80 JIF = 1,NIF
               DO 70 JF = 1,NF
                  DO 60 JS = 1,NS
                     JJS = JJ(JS)
                     INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *                  (JS-1) * INCSI + 1
                     INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *                  (JJS-1) * INCSO + 1
                     RESULT(1,INDEXO) = VIS(1,INDEXI)
                     RESULT(2,INDEXO) = -VIS(2,INDEXI)
                     RESULT(3,INDEXO) = VIS(3,INDEXI)
 60                  CONTINUE
 70               CONTINUE
 80            CONTINUE
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE AMKATH
C-----------------------------------------------------------------------
C   AMKATH copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP(2)*2, HILINE*72
      INTEGER   LUN1, LUN2, IERR, I, NONOT, J
      LOGICAL   T, F
      INCLUDE 'AMKAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T, F /.TRUE.,.FALSE./
      DATA NONOT, NOTTYP /2, 'NX', 'AN'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      DO 100 I = 1,10
         DO 90 J = 1,MXANT(I)
            IF (OUTANT(J,I).NE.J) THEN
               WRITE (HILINE,1010) TSKNAM, I, J, OUTANT(I,J)
               CALL HIADD (LUN2, HILINE, BUFF2, IERR)
               IF (IERR.NE.0) GO TO 200
               END IF
 90         CONTINUE
 100     CONTINUE

C                                       Close HI file
 200  CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ADJANT (LUN1, LUN2, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1200) IERR
         CALL MSGWRT (6)
         END IF
C                                        Copy tables
      CALL ADJTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO, FCNO(2),
     *   FCNO(1), OUTANT,  CATBLK, BUFF1, IBUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1201)
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST',
     *   BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AMKATH: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,' / SUBARRAY=',I2,' ANTENNA',I4,' NOW',I4)
 1200 FORMAT ('AMKATH: ERROR',I4,' COPYING ANTENNA TABLES')
 1201 FORMAT ('AMKATH: ERROR COPYING TABLES')
      END
      SUBROUTINE ADJANT (LUNOLD, LUNNEW, IRET)
C-----------------------------------------------------------------------
C   ADJANT copies all antenna Table extension file(s).  The output
C   antenna file will have 64 antennas, some OUT.
C   Inputs:
C      LUNOLD  I       LUN for old file
C      LUNNEW  I       LUN for new file
C   Output:
C      IRET    I       Return error code  0 => ok,
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   LUNOLD, LUNNEW, IRET
C
      INCLUDE 'AMKAT.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INTEGER   NREC, ISUB, BUFFA(512), IER, IVERI, IVERO, I, IREC
      LOGICAL   TABLE, EXIST, FITASC
C-----------------------------------------------------------------------
C                                       loop over subarrays
      DO 100 ISUB = 1,NSUB
C                                       See if files exist and are
C                                       wanted.
         CALL ISTAB ('AN', DISKIN, OLDCNO, ISUB, LUNOLD, BUFF1, TABLE,
     *      EXIST, FITASC, IER)
         IF (TABLE .AND. EXIST .AND. (IER.EQ.0)) THEN
            IVERI = ISUB
            IVERO = ISUB
C                                       Copy
            CALL TABCOP ('AN', IVERI, IVERO, LUNOLD, LUNNEW, DISKIN,
     *         DISKO, OLDCNO, NEWCNO, CATBLK, IBUFF1, IBUFF2, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, ISUB, 'COPYING AN FILE'
               GO TO 990
               END IF
C                                       update
            CALL ANTINI ('WRIT', BUFFA, DISKO, NEWCNO, IVERO, CATBLK,
     *         LUNNEW, IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY,
     *         SAFREQ, RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME,
     *         XYZHAN, TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, ISUB, 'OPENING NEW AN FILE'
               GO TO 990
               END IF
            NREC = BUFFA(5)
            DO 20 IREC = 1,NREC
               IANRNO = IREC
               CALL TABAN ('READ', BUFFA, IANRNO, ANKOLS, ANNUMV,
     *            ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN,
     *            FWHMAN, POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, ISUB, 'READING AN FILE'
                  GO TO 990
                  END IF
               IF (OUTANT(NOSTA,ISUB).NE.NOSTA) THEN
                  NOSTA = OUTANT(NOSTA,ISUB)
                  IANRNO = IREC
                  CALL TABAN ('WRIT', BUFFA, IANRNO, ANKOLS, ANNUMV,
     *               ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF,
     *               DIAMAN, FWHMAN, POLTYA, POLAA, POLCA, POLTYB,
     *               POLAB, POLCB, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, ISUB, 'WRITING AN FILE'
                     GO TO 990
                     END IF
                  END IF
 20            CONTINUE
            ANNAME = 'OUT'
            STAXYZ(1) = 0.0d0
            STAXYZ(2) = 0.0d0
            STAXYZ(3) = 0.0d0
            DO 30 I = 1,MAXANT
               IF (MISANT(I,ISUB).GT.0) THEN
                  IANRNO = NREC + I
                  NOSTA = MISANT(I,ISUB)
                  CALL TABAN ('WRIT', BUFFA, IANRNO, ANKOLS, ANNUMV,
     *               ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF,
     *               DIAMAN, FWHMAN, POLTYA, POLAA, POLCA, POLTYB,
     *               POLAB, POLCB, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, ISUB,
     *                  'WRITING AN FILE OUT ANTENNAS'
                     GO TO 990
                     END IF
               ELSE
                  GO TO 40
                  END IF
 30            CONTINUE
C                                       close an file
 40         CALL TABAN ('CLOS', BUFFA, IANRNO, ANKOLS, ANNUMV,
     *         ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN,
     *         FWHMAN, POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB,
     *         IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, ISUB, 'CLOSING AN FILE'
               GO TO 990
               END IF
            END IF
 100     CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AFJANT ERROR',I4,' SUBARRAY',I3,' ON ',A)
      END
      SUBROUTINE ADJTAB (NONOT, NOTTYP, LUNOLD, LUNNEW, VOLOLD, VOLNEW,
     *   CNOOLD, CNONEW, ANTS, CATNEW, BUFF1, BUFF2, IRET)
C-----------------------------------------------------------------------
C   ADJTAB copies all Table extension file(s).  The output files must
C   be new - old ones cannot be rewritten.  The output file must be
C   opened WRIT in the catalog and will have its CATBLK updated on disk.
C   Source, FQ, and antenna numbers are renumbered.
C   Inputs:
C      NONOT   I       Number of "Forbidden" types to copy.
C      NOTTYP  C*2(*)  Table types to ignore.
C      LUNOLD  I       LUN for old file
C      LUNNEW  I       LUN for new file
C      VOLOLD  I       Disk number for old file.
C      VOLNEW  I       Disk number for new file.
C      CNOOLD  I       Catalog slot number for old file
C      CNONEW  I       Catalog slot number for new file
C      ANTS    I(*,*)  New antenna numbers
C   In/out:
C      CATNEW  I(256)  Catalog header for new file.
C   Output:
C      BUFF1   I(1024) Work buffer
C      BUFF2   I(1024) Work buffer
C      IRET    I       Return error code  0 => ok, otherwise TABCOP
C                                             or 10*CATIO error.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER NOTTYP(*)*2
      INTEGER   NONOT, LUNOLD, LUNNEW, VOLOLD, VOLNEW, CNOOLD, CNONEW,
     *   BUFF2(*), ANTS(MAXANT,*), CATNEW(256), IRET
      REAL      BUFF1(*)
C
      INCLUDE 'INCS:PHDR.INC'
      INTEGER   NKOLS
      PARAMETER (NKOLS=4)
      INTEGER   IVERI, IVERO, IER, NONON, IEXT, JEXT, OLDNUM(NIEXTN),
     *   NKEY, NCOL, DATP(128,2), NREC, KOLS(NKOLS), LKEY(NKOLS), RTYPE,
     *   VALUE(MAXIF), ISUB, LRNO, IREC, K, IANT, J, JJ,
     *   ROWB(XBPRSZ), IDUM(2), SUBKOL, IBUFF2(1024), IBUFF1(1024)
      HOLLERITH HDUM(2)
      EQUIVALENCE (IDUM, HDUM)
      LOGICAL   TABLE, EXIST, FITASC, DOPUT, DIDSOM, DIDONE
      CHARACTER OLDTYP(NIEXTN)*2, NONTAB(20)*2, KEYS(NKOLS)*8
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C                                       Non table extension files
      DATA NONON /3/
      DATA NONTAB /'HI','PL','SL',17*'  '/
      DATA KEYS /'ANTENNA', 'REFANT 1', 'REFANT 2', 'ANTS'/
      DATA LKEY /7, 8, 8, 8/
C-----------------------------------------------------------------------
C                                       Get old CATBLK in BUFF2.
      CALL CATIO ('READ', VOLOLD, CNOOLD, BUFF2, 'REST', BUFF1, IRET)
      IF ((IRET.GE.1) .AND. (IRET.LE.4)) THEN
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (6)
         IRET = 10 * IRET
         GO TO 999
         END IF
C                                       header ext format
      CALL FXHDEX (BUFF2)
C                                       Get extension file info
      DO 20 IEXT = 1,KIEXTN
         OLDTYP(IEXT) = ' '
         IDUM(1) = BUFF2(KHEXT+IEXT-1)
         CALL H2CHR (2, 1, HDUM, OLDTYP(IEXT))
         OLDNUM(IEXT) = BUFF2(KIVER+IEXT-1)
C                                       Check if on non table list
         DO 10 JEXT = 1,NONON
            IF (OLDTYP(IEXT).EQ.NONTAB(JEXT)) OLDNUM(IEXT) = 0
 10         CONTINUE
C                                       Check "forbidden" types
         IF (NONOT.GT.0) THEN
            DO 15 JEXT = 1,NONOT
               IF (OLDTYP(IEXT).EQ.NOTTYP(JEXT)) OLDNUM(IEXT) = 0
 15            CONTINUE
            END IF
 20      CONTINUE
C                                       Loop, copying tables.
      DO 100 IEXT = 1,KIEXTN
         IF (OLDNUM(IEXT).LE.0) GO TO 100
C                                       Copy each table independently
         DO 90 JEXT = 1,OLDNUM(IEXT)
C                                       See if files exist and are
C                                       wanted.
            CALL ISTAB (OLDTYP(IEXT), VOLOLD, CNOOLD, JEXT, LUNOLD,
     *         BUFF1, TABLE, EXIST, FITASC, IER)
            IF (TABLE .AND. EXIST .AND. (IER.EQ.0)) THEN
               IVERI = JEXT
               IVERO = JEXT
C                                       Copy
               CALL TABCOP (OLDTYP(IEXT), IVERI, IVERO, LUNOLD, LUNNEW,
     *            VOLOLD, VOLNEW, CNOOLD, CNONEW, CATNEW, IBUFF1,
     *            IBUFF2, IER)
               IRET = MAX (IER, IRET)
               IF (IER.NE.0) GO TO 90
C                                       Re-open output to update #s
               DIDSOM = .FALSE.
               NKEY = 0
               NCOL = 0
               CALL TABINI ('WRIT', OLDTYP(IEXT), VOLNEW, CNONEW, IVERO,
     *            CATNEW, LUNNEW, NKEY, NREC, NCOL, DATP, BUFF2, IER)
               IRET = MAX (IER, IRET)
               IF (IER.NE.0) GO TO 90
               NREC = BUFF2(5)
               CALL FILL (NKOLS, 0, KOLS)
               K = 0
               CALL FNDCOL (1, KEYS(1), LKEY(1), .TRUE., BUFF2, KOLS(1),
     *            IER)
               IF ((IER.GT.0) .AND. (IER.LE.10)) GO TO 85
               IF (IER.GT.10) K = K + IER - 10
               CALL FNDCOL (NKOLS-1, KEYS(2), LKEY(2), .TRUE., BUFF2,
     *            KOLS(2), IER)
               IF ((IER.GT.0) .AND. (IER.LE.10)) GO TO 85
               IER = IER + K
               IF (IER.GE.10+NKOLS) THEN
                  IER = 0
                  GO TO 85
                  END IF
C                                       subarray too
               SUBKOL = 0
               IF ((KOLS(1).GT.0) .OR. (KOLS(2).GT.0) .OR.
     *            (KOLS(3).GT.0) .OR. (KOLS(4).GT.0)) THEN
                  CALL FNDCOL (1, 'SUBARRAY', 7, .TRUE., BUFF2,
     *               SUBKOL, IER)
                  IF ((IER.GT.0) .AND. (IER.LE.10)) GO TO 85
                  END IF
               DO 80 IREC = 1,NREC
                  LRNO = 0
                  DIDONE = .FALSE.
C                                       subarray number
                  IF (SUBKOL.GT.0) THEN
                     CALL GETCOL (IREC, SUBKOL, DATP, LRNO, BUFF2,
     *                  RTYPE, IDUM, ROWB, IER)
                     ISUB = IDUM(1)
                     IF (IER.NE.0) GO TO 85
                     ISUB = MAX (1, ISUB)
                  ELSE
                     ISUB = 1
                     END IF
C                                       antenna number(s)
                  IANT = 0
                  DO 30 K = 1,4
                     IF (KOLS(K).GT.0) THEN
                        CALL GETCOL (IREC, KOLS(K), DATP, LRNO, BUFF2,
     *                     RTYPE, VALUE, ROWB, IER)
                        IF (IER.NE.0) GO TO 85
                        JJ = RTYPE / 10
                        JJ = MAX (1, JJ)
                        DOPUT = .FALSE.
                        DO 25 J = 1,JJ
                           IF ((VALUE(J).GT.0) .AND.
     *                        (ANTS(VALUE(1),ISUB).GT.0) .AND.
     *                        (ANTS(VALUE(J),ISUB).NE.VALUE(J))) THEN
                              VALUE(J) = ANTS(VALUE(J),ISUB)
                              DOPUT = .TRUE.
                              END IF
 25                        CONTINUE
                        IF (DOPUT) THEN
                           CALL PUTCOL (IREC, KOLS(K), DATP, LRNO,
     *                        BUFF2, VALUE, ROWB, IER)
                           IF (IER.NE.0) GO TO 85
                           DIDSOM = .TRUE.
                           DIDONE = .TRUE.
                           END IF
                        IF (K.EQ.2) IANT = VALUE(1)
                        END IF
 30                  CONTINUE
C                                       force write to disk
                  IF (DIDONE) THEN
                     CALL PUTCOL (0, KOLS, DATP, LRNO, BUFF2, VALUE,
     *                  ROWB, IER)
                     IF (IER.NE.0) GO TO 85
                     END IF
 80               CONTINUE
C                                       close table
 85            IRET = MAX (IRET, IER)
               CALL TABIO ('CLOS', 0, NREC, ROWB, BUFF2, IER)
               IRET = MAX (IRET, IER)
               IF (DIDSOM) THEN
                  WRITE (MSGTXT,1085) OLDTYP(IEXT), IVERO
                  CALL MSGWRT (2)
                  END IF
               END IF
 90         CONTINUE
 100     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ADJTAB: ERROR',I5,' READING OLD CATBLK')
 1085 FORMAT ('Source, FQ, and/or antenna #s adjusted in ',A,
     *   ' table version',I5)
      END

      SUBROUTINE UVAPAS(NCHAVG, MAXU, MDELTA, FREQG, FREQUV,
     *   INPASS, NPASS, LOCHAN, NCHAN, FREQLO, FREQHI, FRQTAB)
C-----------------------------------------------------------------------
C! Deterines number of passes needed for bandwidth synthesis
C# AP-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C UVAPAS calculates the number of channels to average in a gridding
C or interpolation pass for bandwidth synthesis
C handels two functions, deterimining the number of passes
C and returning the number of channels to average in a given pass.
C INPUTS:
C  NCHAVG   I    Number of channels to average
C  MAXU     I    Maximum baseline in cells
C  MDELTA   I    Number of cells in AP
C  FREQG    R(*) Frequencies to average
C  FREQUV   R    Frequency of observation
C  INPASS   I    Pass number to determine LOCHAN and NCHAN for.
C OUTPUT :
C  NPASS    I    Number of passes, set only if IPASS=0
C  LOCHAN   I    Index of first channel to average
C  NCHAN    I    Number of channels to average (includes LOCHAN)
C  FREQLO   R    Lowest frequency to average
C  FREQHI   R    Highest frequency to average
C  FRQTAB   R(*) Frequency scaling table
C-----------------------------------------------------------------------
      INTEGER NCHAVG, MAXU, MDELTA, INPASS, NPASS, LOCHAN, NCHAN
      REAL FRQTAB(255)
      DOUBLE PRECISION FREQG(255), FREQUV, FREQLO, FREQHI
C-----------------------------------------------------------------------
      INTEGER ICHAN, ISTART, IPASS
      DOUBLE PRECISION FREQI, FREQS, FREQT, BWMAX
C-----------------------------------------------------------------------
C                                       init counts of chans and passes
      ISTART = 1
      NCHAN  = 0
      IPASS  = 1
         IF ((MAXU-MDELTA) .GT. 0) THEN
            BWMAX = FREQUV/(MAXU-MDELTA)
         ELSE
            BWMAX = FREQUV
            END IF
         BWMAX = ABS(BWMAX)
C                                       For all chanels to average
      DO 100 ICHAN = 1, NCHAVG
C                                       set freq of cur. and start chan
         FREQI  = FREQG(ICHAN)
         FREQS  = FREQG(ISTART)
C                                       get min freq in current range
         FREQT  = MIN (FREQS, FREQI)
C                                       Bandwidth MAX is set by freq.
C                                       shift U or V by 1 row
C        1 = (MAXU-MDELTA)*(FREQS+BWMAX)/FREQS
C        FREQS+BWMAX = FREQT/(MAXU-MDELTA)
C         BWMAX = FREQT * MDELTA / (MAXU * (FREQT/FREQUV))
C                                       if bandwidth exceeded
         IF (ABS (FREQS-FREQI).GT.BWMAX) THEN
C                                       must start new averaging pass
            IPASS = IPASS + 1
C                                       record start of pass
            ISTART = ICHAN
            END IF
C                                       if in pass of interest
         IF (IPASS .EQ. INPASS) THEN
C                                       count number of channels
            NCHAN = NCHAN + 1
C                                       if first channel
            IF (NCHAN.EQ.1) THEN
C                                       then keep Low Channel
               LOCHAN = ICHAN
C                                       init search for hi and lo freq
               FREQLO = FREQI
               FREQHI = FREQLO
            ELSE
C                                       find hi and lo freq in pass
               FREQLO = MIN(FREQI, FREQLO)
               FREQHI = MAX(FREQI, FREQHI)
               FRQTAB(ICHAN-LOCHAN) = 0
               IF (FREQG(ICHAN-1) .NE. 0)
     *            FRQTAB(ICHAN-LOCHAN) = (FREQI/FREQG(ICHAN-1)) - 1.0D0
               END IF
            END IF
C                                       end all channels to average
 100        CONTINUE
C                                       if counting passes
      IF (INPASS .EQ. 0) NPASS = IPASS
      RETURN
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QMCALC (NGS, NPT, NV)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Compute model visibility from point model.
C# AP-appl UV Obselete
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   MCALC computes model visibilities from CLEAN components.
C   Input:
C      NGS  I  Number of Gaussian components (Gaussian components
C              are not supported at present, so only NGS=0 will
C              work properly)
C      NPT  I  Number of point components
C      NV   I  Number of visibilities to compute
C   AP storage allocation:
C      first 7*NGS locations -- parameters of Gaussian compo-
C         nents
C      next 4*NPT locations -- parameters of point components.
C         The component parameter vectors (flux,x,y,z) are
C         assumed to have been stored one after another.  Fluxes
C         are to be in units of Janskys, and the position off-
C         sets from the visibility phase reference position are
C         to be in units of radians multiplied by 2 pi.
C      next location  --  number of visibility observations,
C         NOBS
C      next NOBS locations -- spatial frequency u-coordinates,
C         in units of wavelengths
C      next NOBS locations -- v-coordinates in wavelengths
C      next NOBS locations -- w-coordinates in wavelengths
C      next 2*NOBS locations -- MCALC stores its result, the
C         model visibilities, here
C      next 2*NOBS locations -- a work area
C-----------------------------------------------------------------------
      INTEGER   NGS, NPT, NV, INGS, INPT, INOBS,
     *   IU, IV, IW, IGS, IPT, IWK, I, IVMOD,
     *   M1, M2, M3, M4, M5
      DATA IGS /2/
C-----------------------------------------------------------------------
      IF (NV.LE.0) GO TO 999
C                                       Set up pointers, etc.
      IPT = IGS + (NGS * 7)
      INGS = IPT + (NPT * 4)
      INPT = INGS + 1
      INOBS = INPT + 1
      IU = INOBS + 1
      IV = IU + NV
      IW = IV + NV
      IVMOD = IW + NV
      IWK = IVMOD + 2 * NV
      M1 = IPT + 1
      M2 = M1 + 1
      M3 = M2 + 1
      M4 = IWK + 1
C                                       Loop
      DO 10 I = 1,NV
         CALL QVSMUL (M1, 4, IU, IWK, 2, NPT)
         CALL QVSMA (M2, 4, IV, IWK, 2, IWK, 2, NPT)
         CALL QVSMA (M3, 4, IW, IWK, 2, IWK, 2, NPT)
         CALL QCVEXP (IWK, 2, IWK, 2, NPT)
         CALL QCRVMU (IWK, 2, IPT, 4, IWK, 2, NPT)
         CALL QSVE (IWK, 2, IVMOD, NPT)
         M5 = IVMOD + 1
         CALL QSVE (M4, 2, M5, NPT)
C                                       Update pointers
         IU = IU + 1
         IV = IV + 1
         IW = IW + 1
         IVMOD = IVMOD + 2
 10      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE GEODLL (X, Y, Z, LAT, LONG)
C-----------------------------------------------------------------------
C! Calculate geodetic lat and long.
C# General
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  Routine to calculate the geodetic latitude and logitude of a
C  point on the earth's surface from its geocentric coordinates.
C
C  Inputs:
C      X,Y,Z      D         Coordinates of point (metres)
C
C  Outputs:
C      LAT        D         Geodetic latitude (rads)
C      LONG       D         Geodetic longitude (rads)
C-----------------------------------------------------------------------
      DOUBLE PRECISION  X, Y, Z, LONG, GCLAT, DLAT, LAT, C1, C2, C3
      DATA C1 / -3.358513D-3 /,
     *     C2 /  5.6398D-6 /,
     *     C3 / -0.01261D-6 /
C-----------------------------------------------------------------------
      LONG = ATAN2 (Y, X)
      GCLAT = ASIN ( Z / SQRT (X*X + Y*Y + Z*Z) )
      DLAT =  C1 * SIN ( 2.D0 * GCLAT )
     *      + C2 * SIN ( 4.D0 * GCLAT )
     *      + C3 * SIN ( 6.D0 * GCLAT )
      LAT = GCLAT - DLAT
      RETURN
      END

      SUBROUTINE SRTOUT (DISKI, CNOSCI, DISKO, CNOSCO, LUN, JBUFSZ,
     *   BUFF1, BUFF2, IERR)
C-----------------------------------------------------------------------
C! Strips sort keys and writes output sorted data file.
C# Sort UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Sort routine called by UVSORT.
C   Strips sort keys and writes output sorted data file.
C   Input:
C      DISKI    I        Input SC file disk number
C      CNOSCI   I        Input SC file catalog slot number.
C      DISKO    I        Output file disk number for cataloged files,
C                        .LE. 0 => /CFILES/ scratch file.
C      CNOSCO   I        Output file catalog slot number or /CFILES/
C                        scratch file number.
C      LUN      I(2)     LUNs for I/O
C   Input from DUVH.INC common:
C      LREC     I        Length of input vis rec.
C      NVIS     I        Number of visibilities
C   Input/Output:
C      JBUFSZ   I        I/O buffer size in bytes
C      BUFF1    R(*)     I/O buffer
C      BUFF2    R(*)     I/O buffer
C   Output:
C      IERR     I        Return code, 0=OK else failed.
C-----------------------------------------------------------------------
      INTEGER   DISKI, CNOSCI, DISKO, CNOSCO, LUN(2), JBUFSZ, IERR
      REAL      BUFF1(*), BUFF2(*)
C
      INTEGER   FINDI, FINDO, DISK, JERR, VO, BO, LENBU, IBIND,
     *   OBIND, NIOUT, LREC2, LOOP, INIO, I
      CHARACTER FILE*48, ERRTXT*80
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C                                       Open input
      ERRTXT = 'ERROR OPENING UV DATA FILE'
C                                       Scratch file
      CALL ZPHFIL ('SC', DISKI, CNOSCI, 1, FILE, JERR)
      CALL ZOPEN (LUN(1), FINDI, DISKI, FILE, .TRUE., .TRUE., .FALSE.,
     *   IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Open Output
      IF (DISKO.LE.0) THEN
C                                       Scratch file
         DISK = SCRVOL(CNOSCO)
         CALL ZPHFIL ('SC', DISK, SCRCNO(CNOSCO), 1, FILE, JERR)
      ELSE
C                                       UV data file
         DISK = DISKO
         CALL ZPHFIL ('UV', DISK, CNOSCO, 1, FILE, JERR)
         END IF
      CALL ZOPEN (LUN(2), FINDO, DISK, FILE, .TRUE., .TRUE., .FALSE.,
     *   IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Init I/O
      LENBU = 1
      VO = 0
      BO = 1
      LREC2 = LREC + 2
      ERRTXT = 'ERROR INITIALIZING I/O'
      CALL UVINIT ('READ', LUN(1), FINDI, NVIS, VO, LREC2, LENBU,
     *   JBUFSZ, BUFF1, BO, IBIND, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Output
      LENBU = 1
      CALL UVINIT ('WRIT', LUN(2), FINDO, NVIS, VO, LREC, LENBU,
     *   JBUFSZ, BUFF2, BO, OBIND, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Loop thru file by NSORT
      ERRTXT = 'ERROR DOING I/O'
      DO 500 LOOP = 1,NVIS
C                                       Read
         CALL UVDISK ('READ', LUN(1), FINDI, BUFF1, INIO, IBIND, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Copy stripping sort keys
         DO 200 I = 1,LREC
            BUFF2(OBIND+I-1) = BUFF1(IBIND+I+1)
 200        CONTINUE
         NIOUT = 1
         CALL UVDISK ('WRIT', LUN(2), FINDO, BUFF2, NIOUT, OBIND,
     *      IERR)
         IF (IERR.NE.0) GO TO 990
 500     CONTINUE
C                                       Flush output buffer
      NIOUT = 0
      ERRTXT = 'FLUSHING VIS FILE'
      CALL UVDISK ('FLSH', LUN(2), FINDO, BUFF2, NIOUT, OBIND, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Close files
      CALL ZCLOSE (LUN(1), FINDI, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL ZCLOSE (LUN(2), FINDO, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = ERRTXT
      CALL MSGWRT (7)
      MSGTXT = 'SRTOUT: ERROR SORTING UV DATA'
 995  CALL MSGWRT (7)
C
 999  RETURN
      END

      SUBROUTINE PLTSET (XMIN, XMAX, YMIN, YMAX, XYSCL, XYOFF, YYOFF,
     *   IERR)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Sets up the common area /CPLOTU/ for PLOTDA.  This subroutine must
C   have been called before any calls are made to PLOTDA and it must
C   be segmented at a higher level than PLOTDA.
C   Inputs: XMIN,XMAX      R    min and max of X-axis in user
C                                 coordinates
C           YMIN,YMAX      R    same for Y-axis
C           XYSCL(2)       R    Scaling in X and Y
C           XYOFF(2)       R    X and Y offset in current plot.
C           YYOFF(2)       R    X and Y offset of current plot.
C   Programmer: L.B.Baath  Onsala Space Observatory  29 october 1982
C-----------------------------------------------------------------------
      INTEGER   IERR
      REAL      XMIN, XMAX, YMIN, YMAX, XYSCL(2), XYOFF(2), YYOFF(2),
     *    X(10)
      COMMON /CPLOTU/ X
C-----------------------------------------------------------------------
      X(1) = XYSCL(1)
      X(2) = XYSCL(2)
      X(3) = XYOFF(1)
      X(4) = XYOFF(2)
      X(5) = XMIN
      X(6) = XMAX
      X(7) = YMIN
      X(8) = YMAX
      X(9) = YYOFF(1)
      X(10) = YYOFF(2)
      IERR = 0
C
 999  RETURN
      END

      SUBROUTINE ALSH2C (HOLL, NDIM, DIM, STRING)
C-----------------------------------------------------------------------
C! Convert hollerith to character with possible multiple dimensionality
C# Utility 
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Convert a hollerith to a string (possibly an array).
C   This routine should deal with either the case that the output string
C   is declared either as C*(DIM1*DIM2) or C(DIM1)*DIM2.
C   Inputs:
C      HOLL     H(*)    Hollerith version of character string.
C      NDIM     I       Number of dimensions
C      DIM      I(*)    Dimensionality array
C   Outputs:
C      STRING   C(*)*?  A string, possibly an array.
C      IERR     I       Error code, 0=OK. 1= file not open
C-----------------------------------------------------------------------
      CHARACTER STRING(*)*(*)
      INTEGER   NDIM, DIM(*)
      HOLLERITH HOLL(*)
C
      INTEGER   SLEN, LOOP, NVAL, INDEX
C-----------------------------------------------------------------------
C                                       Total length
      NVAL = 1
      DO 10 LOOP = 1,NDIM
         NVAL = NVAL * MAX (1, DIM(LOOP))
 10      CONTINUE
C                                       Check string length
      SLEN = LEN (STRING(1))
      IF (SLEN .GE. NVAL) THEN
C                                       STRING passed as one string
         CALL H2CHR (NVAL, 1, HOLL, STRING)
      ELSE
C                                       STRING passed as array.
         NVAL = NVAL / MAX (1, DIM(1))
         INDEX = 1
         DO 100 LOOP = 1,NVAL
            CALL H2CHR (SLEN, INDEX, HOLL, STRING(LOOP))
            INDEX = INDEX + SLEN
 100        CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZR32RL (NVAL, NP, INB, OUTB)
C-----------------------------------------------------------------------
C! convert 32-bit IEEE floating buffer to local REAL values
C# Binary
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Converts from 32 bit IEEE floating format to local single precision.
C
C   The IEEE format is:
C
C                1         2         3
C      01234567890123456789012345678901
C      seeeeeeeemmmmmmmmmmmmmmmmmmmmmmm
C
C   where sign = -1 _*_* s, exponent = eee..., mantissa = 1.mmmmm...
C
C   The value is given by:
C
C      value = sign _* 2 _*_*(exp-127) _* mantissa
C
C   Note: these values have a "hidden" bit and must always be normalized
C   The IEEE nan (not a number) values are used to indicate an invalid
C   number; a value with all bits set is recognized as a "nan".
C
C   The AIPS internal format for an invalid number is the value which
C   has the same bit pattern as 'INDE'.
C
C   The IEEE special values (-0., +/- Infty) are not recognized.
C
C   A multiplication by a factor of 4.0 converts between VAX F and IEEE
C   32 bit formats.
C
C   Inputs:
C      NVAL   I      Number of values to convert
C      NP     I      First value in INB to convert
C      INB    R(*)   32-bit IEEE format values
C   Output:
C      OUTB   R(*)   Local format values ("nan" values are replaced
C                    with AIPS' indefinite value = 'INDE')
C   Generic version - does IEEE and VAX F formats for 32-bit machines,
C   is stubbed with STOP for all others.
C-----------------------------------------------------------------------
      INTEGER   NVAL, NP
      REAL      INB(*), OUTB(*)
C
      INTEGER   LOOP, I4NAN, J, I4TEST, ZAND, I, L4NAN, I4NANV
      REAL      R4TEST
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (I4TEST, R4TEST)
C                                       = 7F800000 mask for exponent
      DATA I4NAN /2139095040/
C                                       = 00007F80 mask for exponent VMS
      DATA I4NANV /32640/
C-----------------------------------------------------------------------
      IF (NVAL.LE.0) GO TO 999
C                                       only works for 32-bit words
      IF (NBITWD.NE.32) THEN
         WRITE (MSGTXT,1000) NBITWD
         CALL MSGWRT (10)
         STOP
      ELSE
         IF (BYTFLP.GT.1) THEN
            L4NAN = I4NANV
         ELSE
            L4NAN = I4NAN
            END IF
C                                       IEEE floating-point - copy
         IF (SPFRMT.EQ.1) THEN
            LOOP = 2 * NVAL
            CALL ZBYTFL (LOOP, INB(NP), INB(NP))
            DO 10 LOOP = 1,NVAL
               J = LOOP + NP - 1
               R4TEST = INB(J)
               I = ZAND (L4NAN, I4TEST)
               IF (I.EQ.0) THEN
                  OUTB(LOOP) = 0.0
               ELSE IF (I.EQ.L4NAN) THEN
                  OUTB(LOOP) = FBLANK
               ELSE
                  OUTB(LOOP) = INB(J)
                  END IF
 10            CONTINUE
C                                       VAX F - multiply by 4
         ELSE IF (SPFRMT.EQ.2) THEN
            LOOP = 2 * NVAL
            CALL ZBYTFL (LOOP, INB(NP), INB(NP))
            DO 20 LOOP = 1,NVAL
               J = LOOP + NP - 1
               R4TEST = INB(J)
               I = ZAND (L4NAN, I4TEST)
               IF (I.EQ.0) THEN
                  OUTB(LOOP) = 0.0
               ELSE IF (I.EQ.L4NAN) THEN
                  OUTB(LOOP) = FBLANK
               ELSE
                  OUTB(LOOP) = INB(J) * 4.0
                  END IF
 20            CONTINUE
C                                       IBM - yeah, right
         ELSE IF(SPFRMT.EQ.4) THEN
            CALL S2IBM(NVAL,INB(NP),OUTB(1))
C                                       VAX G not easy
         ELSE
            WRITE (MSGTXT,1020) SPFRMT
            CALL MSGWRT (10)
            STOP
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZR32RL: REQUIRES LOCAL DEVELOPMENT FOR NBITWD =',I7)
 1020 FORMAT ('ZR32RL: REQUIRES LOCAL DEVELOPMENT FOR SPFRMT =',I7)
      END

      SUBROUTINE YLUT (OP, CHANNL, COLOR, VRTRTC, LUT, IERR)
C-----------------------------------------------------------------------
C! read/write channel-based look-up-table
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YLUT reads/writes full channel look up tables to TV.
C   Inputs:
C      OP      C*4    'READ' from TV, 'WRIT' to TV
C      CHANNL  I      channel select bit mask
C      COLOR   I      color select bit mask (RGB <-> 421)
C      VRTRTC  L      T => do it only during vertical retrace
C   In/Out:
C      LUT     I(*)   look up table (dimension = MAXINT+1, values to
C                     LUTOUT are used)
C   Out:
C      IERR    I      error code of Z...XF : 0 => ok, 2 => input error
C                        returns 2 on WRIT 12-bit colored table
C   Version for IIS Model IVAS - in 12-bit mode: uses 11 bits, 12th
C      determines channel inside the IVAS;
C      In 8-bit mode: there is no LUT: uses OFM
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   CHANNL, COLOR, LUT(*), IERR
      LOGICAL   VRTRTC
C
      INTEGER   I, ZAND, JERR, JB
      REAL      GAMINV, TEMP
      INTEGER   FIVASVPLUT, FIVASVPOFM
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Vertical retrace
      CALL YVRTR (VRTRTC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       12-bit mode
      IF (NGRAY.LE.2) THEN
C                                       write to TV
         IF (OP.EQ.'WRIT') THEN
            IF ((COLOR.NE.0) .AND. (COLOR.NE.7)) THEN
               IERR = 2
               MSGTXT = 'IVAS CANNOT PUT COLORS INTO THE 12-BIT LUT'
               CALL MSGWRT (7)
               GO TO 999
               END IF
            LUT(1) = 0
            LUT(2048) = 0
            IF (ZAND(CHANNL,1).NE.0) THEN
               JERR = FIVASVPLUT (LUT, 0, 2048, 1, 3)
               IF (JERR.NE.0) GO TO 900
               END IF
            IF (ZAND(CHANNL,2).NE.0) THEN
               JERR = FIVASVPLUT (LUT, 2048, 2048, 1, 3)
               IF (JERR.NE.0) GO TO 900
               END IF
C                                       Read (12 bit)
         ELSE
            IF (CHANNL.NE.2) THEN
               JERR = FIVASVPLUT (LUT, 0, 2048, 2, 1)
            ELSE
               JERR = FIVASVPLUT (LUT, 2048, 2048, 2, 1)
               END IF
            IF (JERR.NE.0) GO TO 900
            DO 10 I = 1,2048
               LUT(I) = MOD (LUT(I), 256)
 10            CONTINUE
            END IF
C                                       8-bit mode: no LUT!
      ELSE
C                                       write
         IF (OP.EQ.'WRIT') THEN
            JB = 0
            IF (ZAND(COLOR, 1).NE.0) JB = JB + 48
            IF (ZAND(COLOR, 2).NE.0) JB = JB + 12
            IF (ZAND(COLOR, 4).NE.0) JB = JB + 3
            GAMINV = 1.0
            IF (TVGAMA.GT.0.0001) GAMINV = 1.0 / TVGAMA
            DO 20 I = 1,256
               TEMP = MAX (0.0, MIN (1.0, LUT(I)/255.0))
               LUT(I) = (TEMP ** GAMINV) * 255.0 + 0.025
 20            CONTINUE
            JERR = FIVASVPOFM (LUT, 0, 256, 1, JB)
            IF (JERR.NE.0) GO TO 900
C                                       read
         ELSE
            JB = 1
            IF (ZAND(COLOR, 1).NE.0) JB = 16
            IF (ZAND(COLOR, 2).NE.0) JB = 4
            IF (ZAND(COLOR, 4).NE.0) JB = 1
            JERR = FIVASVPOFM (LUT, 0, 256, 2, JB)
            IF (JERR.NE.0) GO TO 900
            IF (TVGAMA.LT.0.001) TVGAMA = 1.0
            DO 160 I = 1,256
               LUT(I) = MOD (LUT(I), 256)
               IF (LUT(I).LT.0) LUT(I) = LUT(I) + 256
               TEMP = MAX (0.0, MIN (1.0, LUT(I)/255.0)) ** TVGAMA
               LUT(I) = TEMP * 255.0 + 0.001
 160           CONTINUE
            END IF
         END IF
      GO TO 999
C                                       Error
 900  CALL YDOERR ('YLUT', JERR, IERR)
C
 999  RETURN
      END

      SUBROUTINE ZTPWA2 (FCB, IERR)
C-----------------------------------------------------------------------
C! wait for read/write from/to a tape device
C# Z2 IO-basic Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Wait for the completion of an asynchronous tape I/O operation and
C   returns its completion status and 8-bit byte count.
C   Inputs:
C      FCB    I(*)   File I/O control block
C   Output:
C      IERR   I      Error return  0 => ok
C                       3 => IO error
C                       4 => end of file
C                       5 => beginning of tape
C                       6 => end of tape
C                       7 => wait service error
C   MAC version - stub
C-----------------------------------------------------------------------
      INTEGER   FCB(*), IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'ZTPWA2 STUBBED FOR LATER DEVELOPMENT'
      CALL MSGWRT (9)
C
 999  RETURN
      END

LOCAL INCLUDE 'RESEQ.INC'
C                                       Local include for RESEQ
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      REAL      XSIN, XDISIN, XSOUT, XDISO, XSUB, XANT(50), XBAS(50),
     *   BUFF1(UVBFSS), BUFF2(UVBFSS)
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, MANT, IANT(50), IBAS(50),
     *   JBUFSZ, ILOCWT, CATOLD(256), INCSI, INCFI, INCIFI, INCSO,
     *   INCFO, INCIFO, LRECI, LRECO, NRPRMI, NRPRMO, THESUB,
     *   IBUFF1(UVBFSS), OLDCNO, NEWCNO
      LOGICAL   ISCOMP
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      EQUIVALENCE (IBUFF1, BUFF1)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XCLAOU,
     *   XSOUT, XDISO, XSUB, XANT, XBAS
      COMMON /PARMS/ CATOLD, SEQIN, SEQOUT, DISKIN, DISKO, ILOCWT,
     *   INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI, LRECO,
     *   NRPRMI, NRPRMO, ISCOMP, IANT, IBAS, MANT, THESUB, OLDCNO,
     *   NEWCNO
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
C                                       End local include for RESEQ
LOCAL END
      PROGRAM RESEQ
C-----------------------------------------------------------------------
C! Allows user to provide subroutine to operate on UV data base
C# Utility UV UV-util VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-2001, 2005, 2007-2008, 2015, 2021-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   RESEQ renumbers antennas
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      SUBARRAY       XSUB          Subarray to be done
C      ANTENNAS       XANT(50)      List of new numbers
C      BASELINE       XBAS(50)      List of old numbers
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'RESEQ.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'RESEQ '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL RESEQI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Read/write uv data, process
      CALL RESEQU (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Write HI, tables
      CALL RESEQH
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE RESEQI (PRGN, JERR)
C-----------------------------------------------------------------------
C   RESEQI gets input parameters for RESEQ and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C            /PARMS/ converted input parameters
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, II, JJ
      INCLUDE 'RESEQ.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK  /'      '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 115
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
      THESUB = XSUB + 0.1
      IF (THESUB.LE.0) THESUB = 1
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      NEWCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, NEWCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((NEWCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, NEWCNO, CATBLK, 'WRIT', BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       antenna list
      MANT = 0
      DO 20 I = 1,50
         II = IROUND (XANT(I))
         JJ = IROUND (XBAS(I))
         IF (JJ.GT.0) THEN
            MANT = MANT + 1
            IANT(MANT) = II
            IBAS(MANT) = JJ
            IF (IANT(MANT).LE.0) IANT(MANT) = IANT(1)
            END IF
 20      CONTINUE
      IF ((MANT.LE.0) .OR. (IANT(1).LE.0)) THEN
         MSGTXT = 'NO ANTENNA NUMBERS WERE SPECIFIED: QUITTING'
         JERR = 5
         GO TO 990
         END IF
C                                       copy keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RESEQI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('RESEQI: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE RESEQU (IRET)
C-----------------------------------------------------------------------
C   RESEQU sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48, IFILE*48
      INTEGER   INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, ILENBU,
     *   KBIND, NIOUT, NIOLIM, IBIND, I, IA1, IA2, INCX, BO, VO,
     *   NUMVIS, XCOUNT, NCORI, NCORO, NCOPY, ISUBA, RNXRET
      LOGICAL   T, F
      INCLUDE 'RESEQ.INC'
      REAL      BASEN, CBUFF(UVBFSS), RESULT(UVBFSS)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI, LUNO /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
      IF (ISCOMP) INCX = 3
C                                       Number of visibilities in input
C                                       and output files.
      NCORI = (LRECI - NRPRMI) / CATOLD(KINAX)
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, NEWCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Out of data?
         IF (INIO.LE.0) GO TO 200
C                                       Loop over buffer
         DO 190 I = 1,INIO
            IF (ILOCB.GE.0) THEN
               BASEN = BUFF1(IPTRI+ILOCB)
               IA1 = BASEN / 256. + 0.1
               IA2 = BASEN - IA1*256. + 0.1
               BASEN = BASEN - 256 * IA1 - IA2
               ISUBA = 1.5 + 100.0 * BASEN
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               ISUBA = BUFF1(IPTRI+ILOCSA) + 0.1
               END IF
            NUMVIS = NUMVIS + 1
C                                      Call user routine.
C                                       Compressed data.
            IF (ISCOMP) THEN
               CALL ZUVXPN (NCORI, BUFF1(IPTRI+NRPRMI),
     *            BUFF1(IPTRI+ILOCWT), CBUFF)
               CALL RESEQD (NUMVIS, IA1, IA2, ISUBA, CBUFF,
     *            BUFF1(IPTRI), INCX, RESULT, IRET)
C                                       Un compressed data
            ELSE
               CALL RESEQD (NUMVIS, IA1, IA2, ISUBA,
     *            BUFF1(IPTRI+NRPRMI), BUFF1(IPTRI), INCX, RESULT, IRET)
               END IF
            IF (IRET.GT.0) GO TO 999
C                                       Copy to output.
            XCOUNT = XCOUNT + 1.0D0
            CALL RCOPY (NRPRMO, BUFF1(IPTRI), BUFF2(IPTRO))
C                                       update NX table
            CALL RNXUPD (BUFF1(IPTRI), RNXRET)
C                                       Compressed
            IF (ISCOMP) THEN
               CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *            BUFF2(IPTRO+NRPRMO))
            ELSE
               CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
               END IF
            IPTRO = IPTRO + LRECO
            NIOUT = NIOUT + 1
            IPTRI = IPTRI + LRECI
C                                       Write vis record.
         IF (NIOUT.GE.NIOLIM) THEN
            CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1150) IRET
               GO TO 990
               END IF
            IPTRO = KBIND
            NIOUT = 0
            END IF
 190     CONTINUE
C                                       Read next buffer.
         GO TO 100
C                                       Final call to RESEQD.
 200  NUMVIS = -1
      CALL RESEQD (NUMVIS, IA1, IA2, ISUBA, BUFF1, BUFF1, INCX, RESULT,
     *   IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, NEWCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RESEQU: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1010 FORMAT ('RESEQU: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('RESEQU: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('RESEQU: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('RESEQU: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('RESEQU: RESEQD ERROR',I3)
 1150 FORMAT ('RESEQU: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE RESEQH
C-----------------------------------------------------------------------
C   RESEQH copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP*2, HILINE*72
      INTEGER   LUN1, LUN2, IERR, I, NONOT
      LOGICAL   T
      INCLUDE 'RESEQ.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NONOT, NOTTYP /0, '  '/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1001) TSKNAM, THESUB
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      DO 10 I = 1,MANT
         WRITE (HILINE,1002) TSKNAM, IBAS(I), IANT(I)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
 10      CONTINUE
C                                       Close HI file
 100  CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO, FCNO(2),
     *   FCNO(1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1200)
         CALL MSGWRT (6)
         END IF
C                                       convert copied tables
         CALL SUBTAB (DISKO, FCNO(NCFILE-1), LUN1, THESUB, MANT, IBAS,
     *      IANT, IBUFF1, IERR)
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST',
     *   BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RESEQH: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1001 FORMAT (A6,'SUBARRAY=',I4,5X,'/ renumber this subarray only')
 1002 FORMAT (A6,'/ antenna',I3,' renumbered as antenna',I3)
 1200 FORMAT ('RESEQH: ERROR COPYING TABLES')
      END
      SUBROUTINE RESEQD (NUMVIS, IA1, IA2, ISUBA, VIS, RPARM, INCX,
     *   RESULT, IRET)
C-----------------------------------------------------------------------
C   Renumbers antennas if appropriate
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      IA1     I    First antenna number
C      IA2     I    Second antenna number
C      ISUBA   I    Subarray
C      RPARM   R(*) Random parameter array which includes U,V,W etc
C                   but also any other random parameters.
C      VIS     R(INCX,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                   NOTE: INCX may be any value .GE. 2
C   Output:
C      RPARM      R    Modified random parameter array.
C      RESULT  R(INCX,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IA1, IA2, ISUBA, INCX, IRET
      REAL      VIS(INCX,*), RPARM(*), RESULT(INCX,*)
C
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXO, INDEXI, I, SWPOL,
     *   IROUND
      REAL      RPOL, TMPVIS
      LOGICAL   REVERS
      INCLUDE 'RESEQ.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      SAVE SWPOL, NS, NIF, NF
C-----------------------------------------------------------------------
      IRET = 0
C                                       data record
      IF (NUMVIS.GT.0) THEN
C                                       first call
         IF (NUMVIS.EQ.1) THEN
            NS = 1
            NIF = 1
            NF = 1
            IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
            IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
            IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
            DO 10 JS = 1,NS
               RPOL = CATD(KDCRV+JLOCS) + (JS - CATR(KRCRP+JLOCS)) *
     *            CATR(KRCIC+JLOCS)
               I = IROUND (RPOL)
               IF ((I.EQ.-3) .OR. (I.EQ.-7)) THEN
                  IF ((NINT(CATR(KRCIC+JLOCS)).EQ.-1) .AND. (JS.LT.NS))
     *               THEN
                     SWPOL = JS
                  ELSE IF ((NINT(CATR(KRCIC+JLOCS)).EQ.+1) .AND.
     *               (JS.GT.1)) THEN
                     SWPOL = JS - 1
                  ELSE
                     MSGTXT = 'POLARIZATION STRUCTURE DOES NOT PERMIT'
     *                  // ' ANTENNA RENUMBERING'
                     CALL MSGWRT (8)
                     IRET = 8
                     GO TO 999
                     END IF
                  END IF
 10            CONTINUE
            END IF
C                                       desired subarray, check antennas
         REVERS = .FALSE.
         IF (THESUB.EQ.ISUBA) THEN
            DO 15 I = 1,MANT
               IF (IBAS(I).EQ.IA1) THEN
                  IA1 = IANT(I)
                  GO TO 20
                  END IF
 15            CONTINUE
 20         DO 25 I = 1,MANT
               IF (IBAS(I).EQ.IA2) THEN
                  IA2 = IANT(I)
                  GO TO 30
                  END IF
 25            CONTINUE
 30         IF (IA2.LT.IA1) THEN
               REVERS = .TRUE.
               I = IA2
               IA2 = IA1
               IA1 = I
               RPARM(1+ILOCU) = -RPARM(1+ILOCU)
               RPARM(1+ILOCV) = -RPARM(1+ILOCV)
               RPARM(1+ILOCW) = -RPARM(1+ILOCW)
               END IF
            IF (ILOCB.GE.0) THEN
               RPARM(1+ILOCB) = 256 * IA1 + IA2 + 0.01 * (ISUBA-1)
            ELSE
               RPARM(1+ILOCA1) = IA1
               RPARM(1+ILOCA2) = IA2
               RPARM(1+ILOCSA) = ISUBA
               END IF
            END IF
C                                       copy data
         DO 70 JIF = 1,NIF
            DO 60 JF = 1,NF
               DO 50 JS = 1,NS
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *               (JS-1) * INCSO + 1
C                                       swap crosshand at swpol
                  IF ((REVERS) .AND. (JS.EQ.SWPOL)) THEN
                     DO 35 I = 1,INCX
                        TMPVIS = VIS(I,INDEXI)
                        VIS(I,INDEXI) = VIS(I,INDEXI+INCSI)
                        VIS(I,INDEXI+INCSI) = TMPVIS
 35                     CONTINUE
                     END IF
C                                       copy to output
                  DO 40 I = 1,INCX
                     RESULT(I,INDEXO) = VIS(I,INDEXI)
 40                  CONTINUE
                  IF (REVERS) RESULT(2,INDEXO) = -RESULT(2,INDEXO)
 50               CONTINUE
 60            CONTINUE
 70         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE SUBTAB (IDISK, ICNO, JLUN, SUBA, MANT, INANT, OUTANT,
     *   JBUFF, IRET)
C----------------------------------------------------------------------
C   Update antenna numbers in generic tables attached to uv-data file
C   Input:
C      IDISK    I      Disk volume number
C      ICNO     I      Catalog slot number
C      JLUN     I      LUN for table I/O
C      SUBA     I      subarray to change
C      MANT     I      Number of antennas to change
C      INANT    I(*)   Input antenna numbers
C      OUTANT   I(*)   Output antenna numbers
C   Output:
C      JBUFF    I(512) Buffer for table I/O
C      IRET     I      Return code (0=> ok; else error)
C----------------------------------------------------------------------
      INTEGER   IDISK, ICNO, JLUN, SUBA, MANT, INANT(*), OUTANT(*),
     *   JBUFF(*), IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NCOLMX, NSUBID, NANTID
      PARAMETER (NSUBID = 2, NANTID = 7)
      PARAMETER (NCOLMX = 7)
C
      LOGICAL   WTABLE, WEXIST, WFITS, T
      CHARACTER LTYPE*2, LSUBID(NSUBID)*24, LANTID(NANTID)*24
      DOUBLE PRECISION DREC(XBPRSZ/2)
      REAL      RECR(XBPRSZ)
      INTEGER   ITAB, NKEY, NREC, NCOL, IVER, NVER, DATP(128,2), I,
     *   IERR, IKOLS(NCOLMX), J, IANT, JANT, NROW, IROW, IRNO,
     *   IREC(XBPRSZ), ISUBA, JSUBA
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (DREC, RECR, IREC)
      DATA LSUBID /'ARRAY', 'SUBARRAY'/
      DATA LANTID /'ANTENNA_NO', 'ANTENNA_NOS', 'ANTENNA',
     *   'ANTENNA NO.', 'ANTS', 'ANTENNA NO','NOSTA'/
      DATA T /.TRUE./
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C                                       Loop over all table types
      DO 100 ITAB = 1,KIEXTN
C                                       Extract type, version.
         CALL H2CHR (2, 1, CATH(KHEXT+ITAB-1), LTYPE)
         NVER = CATBLK(KIVER+ITAB-1)
C                                       Loop over all table versions
         DO 90 IVER = 1,NVER
C                                       valid, existing table ?
            CALL ISTAB (LTYPE, IDISK, ICNO, IVER, JLUN, JBUFF,
     *         WTABLE, WEXIST, WFITS, IERR)
C                                       Skip if invalid
            IF ((IERR.NE.0) .OR. (.NOT.WEXIST) .OR. (.NOT.WTABLE))
     *         GO TO 90
C                                       If its an AN table, but its the
C                                       wrong one, skip table
            IF ((LTYPE.EQ.'AN') .AND. (IVER.NE.SUBA)) GO TO 90
C
C                                       Open table
            CALL TABINI ('READ', LTYPE, IDISK, ICNO, IVER, CATBLK,
     *         JLUN, NKEY, NREC, NCOL, DATP, JBUFF, IERR)
            IF (IERR.NE.0) THEN
               IRET = 1
               WRITE (MSGTXT,1000) IERR, LTYPE, IVER
               GO TO 990
               END IF
C                                       Search for antennas column
            CALL FNDCOL (NANTID, LANTID, 24, T, JBUFF, IKOLS, IERR)
            IF ((IERR.GE.1) .AND. (IERR.LE.10)) THEN
               IRET = 2
               WRITE (MSGTXT,1010) IERR, LTYPE, IVER
               GO TO 990
               END IF
C                                       Match found ?
            JANT = 0
            DO 10 J = 1, NANTID
               IF ((IKOLS(J).GT.0) .AND. (JANT.EQ.0)) JANT = IKOLS(J)
 10            CONTINUE
            IF (JANT.EQ.0) GO TO 80
C                                       If this is an AN table,
C                                       then dont look for subarray column
            IF (LTYPE.EQ.'AN') THEN
               JSUBA = 0
C                                       find subarray column
            ELSE
               CALL FNDCOL (NSUBID, LSUBID, 24, T, JBUFF, IKOLS, IERR)
               IF ((IERR.GE.1) .AND. (IERR.LE.10)) THEN
                  IRET = 2
                  WRITE (MSGTXT,1010) IERR, LTYPE, IVER
                  GO TO 990
                  END IF
C                                       Match found ?
               JSUBA = 0
               DO 20 J = 1,NSUBID
                  IF ((IKOLS(J).GT.0).AND.(JSUBA.EQ.0)) JSUBA = IKOLS(J)
 20               CONTINUE
               END IF
C                                       Message about table update
            WRITE (MSGTXT,1020) LTYPE, IVER
            CALL MSGWRT (4)
C                                       Close table; open for
C                                       re-write
            CALL TABIO ('CLOS', 0, 0, RECR, JBUFF, IERR)
            CALL TABINI ('WRIT', LTYPE, IDISK, ICNO, IVER, CATBLK,
     *         JLUN, NKEY, NREC, NCOL, DATP, JBUFF, IERR)
            IF (IERR.NE.0) THEN
               IRET = 1
               WRITE (MSGTXT,1000) IERR, LTYPE, IVER
               GO TO 990
               END IF
C                                       Loop through table
            NROW = JBUFF(5)
            DO 50 IROW = 1,NROW
C                                       Read record
               IRNO = IROW
               CALL TABIO ('READ', 0, IRNO, RECR, JBUFF, IERR)
               IF (IERR.NE.0) THEN
                  IRET = 3
                  WRITE (MSGTXT,1010) IERR, LTYPE, IVER
                  GO TO 990
                  END IF
C                                       Extract antenna number
               IANT = IREC(DATP(JANT,1))
C                                       if this table has a subarray
C                                       column
               IF (JSUBA.GT.0) THEN
                  ISUBA = IREC(DATP(JSUBA,1))
                  IF (ISUBA.NE.SUBA) GO TO 50
                  END IF
C                                       is it special?
               DO 30 I = 1,MANT
                  IF (IANT.EQ.INANT(I)) THEN
                     IANT = OUTANT(I)
                     GO TO 40
                     END IF
 30               CONTINUE
C                                       change to new number
 40            IREC(DATP(JANT,1)) = IANT
C                                       Re-write record
               IRNO = IROW
               CALL TABIO ('WRIT', 0, IRNO, RECR, JBUFF, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1030) IERR, LTYPE, IVER
                  GO TO 990
                  END IF
 50            CONTINUE
C                                       Mark table as unsorted
            JBUFF(43) = 0
            JBUFF(44) = 0

C                                       Close table
 80         CALL TABIO ('CLOS', 0, 0, RECR, JBUFF, IERR)
 90         CONTINUE
 100     CONTINUE
C
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Exit
999   RETURN
C----------------------------------------------------------------------
1000  FORMAT ('SUBTAB: ERR',I3,' OPENING ',A2,' TABLE',I4)
1010  FORMAT ('SUBTAB: ERR',I3,' READING ',A2,' TABLE',I4)
1020  FORMAT ('Updating ',A2,' table; version', I4)
1030  FORMAT ('SUBTAB: ERR',I3,' WRITING ',A2,' TABLE',I4)
      END

      SUBROUTINE DIRRA (TYPE, DX, DEC, RA0, DEC0, ROTA, DY, RA, IERR)
C-----------------------------------------------------------------------
C! finds latitude pixel and longitude given longitude pixel and latitude
C# Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2013-2014
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DIRRA will find the longitude and the latitude pixel position of a
C   point given the latitude and the longitude pixel of the point.
C   For use with four projective geometries.
C   ALL ANGLES ARE IN RADIANS.
C   Inputs:
C      TYPE  I      2 => SIN, 3 => TAN, 4 => Arc, 5 => WSRT geometry
C                   6 Global sinusoidal, 7 Mercator, 8 Aitoff
C      DX    D      X pixel value from ref pixel
C      DEC   D      declination/ latitude
C      RA0   D      RA / longitude of ref pixel
C      DEC0  D      DEC / latitude of ref pixel
C      ROTA   D      Rotation of coordinates
C   Output:
C      DY    D      Y pixel position
C      RA    D      right ascension/ longitude
C      IERR  D      0 ok, 1 out of range, 2 bad type, 3 undefined answer
C-----------------------------------------------------------------------
      INTEGER   IERR, TYPE
      DOUBLE PRECISION    DX, DEC, RA0, DEC0, ROTA, DY, RA
C
      INTEGER   NC, NCLIM, I
      DOUBLE PRECISION COSR, SINR, DA, DB, DC, COS0, SIN0, COSD, SIND,
     *   DEPS, DT, ALPHA, DELTA, M, XMIN, XMAX, DM, MVAL, DDIST
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA DEPS /1.0D-5/
C-----------------------------------------------------------------------
      NCLIM = 1000
      DY = 0.0D0
      RA = 0.0D0
      IERR = 2
      IF ((TYPE.LT.2) .OR. (TYPE.GT.12)) GO TO 999
      IERR = 0
      COSR = COS(ROTA)
      SINR = SIN(ROTA)
      COSD = COS(DEC)
      SIND = SIN(DEC)
      COS0 = COS(DEC0)
      SIN0 = SIN(DEC0)
      NC = 0
      IF (ABS(COSD).LT.DEPS) THEN
         IERR = 3
C                                       SIN projection
      ELSE IF (TYPE.EQ.2) THEN
         DA = COSR
         DB = SINR * SIN0
         DT = SQRT (DA*DA + DB*DB)
         IF (DT.LT.DEPS) THEN
            IERR = 3
         ELSE
            DT = (DX - SINR*SIND*COS0) / DT / COSD
            IF (ABS(DT).GT.1.0D0) THEN
               IERR = 3
            ELSE
               RA = ASIN (DT) +  ATAN2 (DB, DA)  +  RA0
               DY = SIND * COS0 * COSR  -  COSD * (COSR * SIN0 *
     *            COS(RA-RA0) + SIN(RA-RA0) * SINR)
               END IF
            END IF
C                                       TAN projection
      ELSE IF (TYPE.EQ.3) THEN
         DA = COSR
         DB = SINR * SIN0 + DX * COS0
         DT = SQRT (DA*DA + DB*DB)
         IF (DT.LT.DEPS) THEN
            IERR = 3
         ELSE
            DT = (DX*SIN0 - COS0*SINR) / DT * SIND / COSD
            IF (ABS(DT).GT.1.0D0) THEN
               IERR = 3
            ELSE
               RA = ASIN (DT)  + ATAN2 (DB, DA) + RA0
               DT = SIND * SIN0 + COSD * COS0 * COS(RA-RA0)
               IF (ABS(DT).LT.DEPS) THEN
                  IERR = 3
               ELSE
                  DY = (SIND*COS0*COSR - COSD*SIN0*COS(RA-RA0)*COSR -
     *               COSD*SINR*SIN(RA-RA0)) / DT
                  END IF
               END IF
            END IF
C                                       Arc projection
      ELSE IF (TYPE.EQ.4) THEN
         IF (ABS(COSR).LT.DEPS) THEN
            IERR = 3
         ELSE
            IF (ABS(COS0).LE.DEPS) THEN
               IF (ABS(SIN0).LT.DEPS) THEN
                  IERR = 3
               ELSE
                  DY = ACOS (SIND / SIN0)
                  DY = DY*DY - DX*DX
                  IF (DY.LT.0.0D0) THEN
                     IERR = 3
                  ELSE
                     DY = -SQRT (DY)
                     DA = SQRT (DX*DX + DY*DY)
                     DB = 1.0D0
                     IF (DA.NE.0.0D0) DB = SIN(DA) / DA
                     END IF
                  END IF
            ELSE
               DY = 0.0D0
               NC = 0
 45            IF (NC.LE.NCLIM) THEN
                  DA = SQRT (DX*DX + DY*DY)
                  NC = NC + 1
                  DC = DY
                  DB = 1.0D0
                  IF (DA.NE.0.0D0) DB = SIN(DA) / DA
                  DA = COS(DA)
                  DY = (SIND - SIN0*DA - DX*SINR*COS0*DB) / (COSR * COS0
     *               * DB)
                  DA = ABS (DY - DC)
                  IF ((NC.GT.10) .AND. (NC.LE.NCLIM)) DY = (DY+DC)/2.0D0
                  IF (DA.GE.1.0D-9) GO TO 45
                  END IF
               END IF
            END IF
         IF (IERR.EQ.0) THEN
            DT = DB * (DX*COSR - DY*SINR) / COSD
            IF (ABS(DT).GT.1.0D0) THEN
               IERR = 3
            ELSE
               RA = RA0 + ASIN (DT)
               END IF
            END IF
C                                       WSRT projection
      ELSE IF (TYPE.EQ.5) THEN
         IF (ABS(SIN0).LT.DEPS) THEN
            IERR = 3
         ELSE
            DA = COSR
            DB = SINR / SIN0
            DT = (DX - COS0*DB) / SQRT (DA*DA + DB*DB) / COSD
            IF (ABS(DT).GT.1.0D0) THEN
               IERR = 3
            ELSE
               RA = ASIN (DT) + ATAN2 (DB, DA) + RA0
               DY = (COS0 - COSD*COS(RA-RA0)) * COSR / SIN0  -
     *            COSD * SINR * SIN(RA-RA0)
               END IF
            END IF
C                                       Stereographic
      ELSE IF (TYPE.EQ.6) THEN
         DA = 2.0D0 * COSD * COSR
         DB = 2.0D0 * COSD * SIN0 * SINR + DX * COSD * COS0
         DT = SQRT (DA*DA + DB*DB)
         IF (DT.LT.DEPS) THEN
            IERR = 3
         ELSE
            DT = (DX + DX*SIND*SIN0 - 2.0D0*SIND*COS0*SINR) / DT
            IF (ABS(DT).GT.1.0D0) THEN
               IERR = 3
            ELSE
               RA = ASIN (DT) + ATAN2 (DB, DA)
               DY = 1.0D0 + SIND*SIN0 + COSD*COS0*COS(RA)
               IF (ABS(DY).LE.DEPS) THEN
                  IERR = 3
               ELSE
                  DY = 2.0D0 * ((SIND*COS0 - COSD*SIN0*COS(RA)) * COSR -
     *               COSD*SIN(RA) * SINR) / DY
                  RA = RA + RA0
                  END IF
               END IF
            END IF
         GO TO 900
C                                       modern WCS-II globals
      ELSE
         XMIN = MMIN(LOCNUM)
         XMAX = MMAX(LOCNUM)
         DM = (XMAX - XMIN) / 10.0D0
         XMIN = XMIN - DM
         XMAX = XMAX + DM
         NC = 0
         NCLIM = 25
 60      IF (NC.LT.NCLIM) THEN
            NC = NC + 1
            DM = (XMAX - XMIN) / 99.0D0
            DDIST = 1.E10
            M = XMIN
            DO 65 I = 1,100
               CALL NEWPOS (TYPE, RA0, DEC0, DX, M, ALPHA, DELTA, IERR)
               IF ((IERR.EQ.0) .AND. (ABS(DEC-DELTA).LT.DDIST)) THEN
                  DDIST = ABS (DEC-DELTA)
                  MVAL = M
                  DY = M
                  RA = ALPHA
                  END IF
               M = M + DM
 65            CONTINUE
            IF ((DDIST.LT.10.0D0) .AND. (DDIST.GT.1.D-5)) THEN
               XMIN = MVAL - DM * 5.0D0
               XMAX = MVAL + DM * 5.0D0
               GO TO 60
               END IF
            END IF
         IF (DDIST.GE.1.0D-3) IERR = 3
         END IF
C                                       RA in range:
 900  IF (IERR.EQ.0) THEN
         IF (RA-RA0.LT.-TWOPI/2.0D0) RA = RA + TWOPI
         IF (RA-RA0.GT.TWOPI/2.0D0) RA = RA - TWOPI
         IF (NC.GT.NCLIM/2) THEN
            WRITE (MSGTXT,1900) NC
            IF (NC.GT.NCLIM) WRITE (MSGTXT,1901) NC
            CALL MSGWRT (6)
            IF (NC.GT.NCLIM) IERR = 3
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('DIRRA: ITERATIONS REQUIRED = ',I5)
 1901 FORMAT ('DIRRA: FAILED TO CONVERGE AFTER',I5,' ITERATIONS')
      END

      SUBROUTINE ASSGN
C-----------------------------------------------------------------------
C! performs the assignment functions of scalar/vector = scalar/vector
C# POPS-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2007, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ASSGN performs the assignment functions: scalar = constant,
C   vector = constant, and vector = vector.
C   Output in commons:
C      K array
C      SP in /POPS/
C      SYTYPE and TAG in /SMSTUF/
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   POTERR, ICSIZE, ISIZE, IOFF, ITAG, ITYPE, J, M, NCSIZE,
     *   NSIZE, IACT, NOFF, NACT, IXPT, LXPT, NCWORD, ICWORD
      CHARACTER CTEMP*256
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DSMS.INC'
      DATA PRGNAM /'ASSGN '/
C-----------------------------------------------------------------------
C                                       find type of assignment
      POTERR = 7
      IF (SP.LT.2) GO TO 980
      M = STACK(SP)
      IF (M.EQ.2) GO TO 30
      M = STACK(SP-1)
C                                       scalar = constant
      IF (M.EQ.2) GO TO 10
         POTERR = 25
         IF (M.LE.K(KXORG+7-1)) GO TO 980
         C(M) = V(SP)
         SP = SP - 2
         GO TO 999
C                                       Vector = Constant.
 10   IF (SP.LT.5) GO TO 980
      SYTYPE = STACK(SP-4)
      POTERR = 23
      IF (SYTYPE.NE.2) GO TO 980
         TAG = STACK(SP-2)
         POTERR = 25
         IF (TAG.LE.K(KXORG+7-1)) GO TO 980
         NSIZE = STACK(SP-3)
         NSIZE = K(NSIZE)
         M = TAG + NSIZE - 1
         DO 15  J = TAG,M
            C(J) = V(SP)
 15         CONTINUE
         SP = SP - 5
         GO TO 999
C                                       vector = vector
 30   IF (SP.LT.8) GO TO 980
      ITAG = STACK(SP-1)
      ISIZE = STACK(SP-2)
      ITYPE = STACK(SP-3)
      TAG = STACK(SP-5)
      NSIZE = STACK(SP-6)
      SYTYPE = STACK(SP-7)
      POTERR = 8
      IF (STACK(SP-4).NE.2) GO TO 980
      IF ((SYTYPE.EQ.2) .AND. (ITYPE.NE.2) .AND. (ITYPE.NE.12))
     *   GO TO 980
      IF ((SYTYPE.NE.2) .AND. (ITYPE.EQ.2)) GO TO 980
      IF ((SYTYPE.NE.2) .AND. (ITYPE.EQ.12)) GO TO 980
      IF (SYTYPE.EQ.12) GO TO 980
      IF (SYTYPE.EQ.14) GO TO 980
      POTERR = 25
      IF (TAG.LE.K(KXORG+7-1)) GO TO 980
      SP = SP - 8
C                                       Real vector = vector
      IF (SYTYPE.NE.2) GO TO 40
         IF (ITYPE.EQ.2) ISIZE = K(ISIZE)
         NSIZE = K(NSIZE)
         POTERR = 13
         IF (ISIZE.GT.NSIZE) GO TO 980
         CALL RCOPY (ISIZE, C(ITAG), C(TAG))
         NSIZE = NSIZE - ISIZE
         IF (NSIZE.GT.0) CALL RFILL (NSIZE, 0.0, C(TAG+ISIZE))
         GO TO 999
C                                       char element/subst = chars
 40   IF (SYTYPE.EQ.7) GO TO 50
         ICSIZE = ISIZE
         IF (ITYPE.EQ.7) ICSIZE = K(ISIZE+3)
         IF (ITYPE.EQ.9) ICSIZE = MOD (ISIZE, 1024)
         IOFF = 1
         IF (ITYPE.EQ.9) IOFF = ISIZE / 1024
         NOFF = 1
         IF (SYTYPE.EQ.9) NOFF = NSIZE / 1024
         IF (SYTYPE.EQ.9) NSIZE = MOD (NSIZE, 1024)
C                                       # actual chars on RHS
         CALL SPFIL (CH(ITAG), ICSIZE, IACT)
         POTERR = 13
         IF (NSIZE-NOFF.LT.IACT-IOFF) GO TO 980
         IF ((ITYPE.EQ.7) .AND. (K(ISIZE+1).NE.1)) GO TO 980
C                                       Do copy, then fill
         NACT = NSIZE - NOFF + 1
         IACT = IACT - IOFF + 1
         IF (IACT.GT.0) THEN
            CALL H2CHR (IACT, IOFF, CH(ITAG), CTEMP)
            CALL CHR2H (IACT, CTEMP, NOFF, CH(TAG))
            NOFF = NOFF + IACT
            NACT = NACT - IACT
            END IF
         IF (NACT.GT.0) CALL CHFILL (NACT, HBLANK, NOFF, CH(TAG))
         GO TO 999
C                                        char vector = const/substr
 50   IF (ITYPE.EQ.7) GO TO 70
         NCSIZE = K(NSIZE+3)
         IF (NCSIZE.LE.0) GO TO 980
         ICSIZE = ISIZE
         IF (ITYPE.EQ.9) ICSIZE = MOD (ISIZE, 1024)
         IOFF = 1
         IF (ITYPE.EQ.9) IOFF = ISIZE / 1024
         IF ((ICSIZE.LE.0) .OR. (IOFF.LE.0)) GO TO 980
         NCWORD = (NCSIZE + 3) / 4
         NSIZE = K(NSIZE) / NCWORD
C                                       Actual # chars on RHS
 55      POTERR = 13
         CALL SPFIL (CH(ITAG), ICSIZE, IACT)
         IF (NCSIZE.LT.IACT-IOFF+1) GO TO 980
         IACT = IACT - IOFF + 1
         IACT = MAX (IACT, 0)
         IXPT = 1 + IACT
         LXPT = NCSIZE - IACT
         IF (IACT.GT.0) CALL H2CHR (IACT, IOFF, CH(ITAG), CTEMP)
         DO 60 J = 1,NSIZE
            IF (IACT.GT.0) CALL CHR2H (IACT, CTEMP, 1, CH(TAG))
            IF (LXPT.GT.0) CALL CHFILL (LXPT, HBLANK, IXPT, CH(TAG))
            TAG = TAG + NCWORD
 60         CONTINUE
          GO TO 999
C                                        char vector = char vector
 70   CONTINUE
         IOFF = 1
         NCSIZE = K(NSIZE+3)
         ICSIZE = K(ISIZE+3)
         IF ((NCSIZE.LE.0) .OR. (ICSIZE.LE.0)) GO TO 980
         NCWORD = (NCSIZE + 3) / 4
         ICWORD = (ICSIZE + 3) / 4
         NSIZE = K(NSIZE) / NCWORD
         ISIZE = K(ISIZE) / ICWORD
         POTERR = 13
         IF (ISIZE.GT.NSIZE) GO TO 980
         IF (ISIZE.EQ.1) GO TO 55
         DO 80 J = 1,NSIZE
            IF (J.GT.ISIZE) CALL CHFILL (NCSIZE, HBLANK, 1, CH(TAG))
            IF (J.GT.ISIZE) GO TO 75
               CALL SPFIL (C(ITAG), ICSIZE, IACT)
               IF (IACT.GT.NCSIZE) GO TO 980
               IXPT = (IACT + 3) / 4
               CALL RCOPY (IXPT, CH(ITAG), CH(TAG))
               IXPT = 1 + IACT
               LXPT = NCSIZE - IACT
               IF (LXPT.GT.0) CALL CHFILL (LXPT, HBLANK, IXPT, CH(TAG))
               ITAG = ITAG + ICWORD
 75         TAG  =  TAG + NCWORD
 80         CONTINUE
         GO TO 999
C                                        error return
 980  ERRNUM = POTERR
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
      END

      SUBROUTINE SOUINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   NUMIF, VELTYP, VELDEF, FREQID, ISURNO, SUKOLS, SUNUMV, IERR)
C-----------------------------------------------------------------------
C! Create/initialize/open source (SU) table
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2000, 2006, 2012, 2014-2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes SOURCE extension tables or opens them for
C   reading.  SOUINI now translates the files if needed and then uses
C   SUINI to do the actual opening.  All tasks should call this
C   routine not SUINI.
C   Inputs:
C     OPCODE       C*4 Operation code:
C                      'WRIT' = create/init for write or read
C                      'READ' = open for read only
C     BUFFER(512)  I   I/O buffer and related storage, also defines file
C                      if open.
C     DISK         I   Disk to use.
C     CNO          I   Catalog slot number
C     VER          I   SU file version
C     CATBLK(256)  I   Catalog header block.
C     LUN          I   Logical unit number to use
C   Input (create) / Output (pre-existing) :
C     NUMIF        I   Table keyword, gives the number of IFs
C     VELTYP       C*8 Velocity type,
C     VELDEF       C*8 Velocity defination 'RADIO','OPTICAL',
C     FREQID       I   Table keyword, denotes the FQ ID for which
C                      the SU parms have been modified. On O/P if
C                      FREQID = -999 it is not in the table, if
C                      FREQID = -1 the virgin values still exist, or
C                      the data have no FREQID random parameter.
C   Output:
C     ISURNO       I   Next scan number, start of the file if 'READ',
C                      the last+1 if WRITE
C     SUKOLS(MAXSUC)I   The column pointer array in order, ID. NO.,
C                      SOURCE, QUAL, CALCODE, IFLUX, QFLUX, UFLUX,
C                      VFLUX, FREQO, BANDWIDTH, RAEPO, DECEPO, EPOCH,
C                      RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF,
C                      PMRA, PMDEC
C     SUNUMV(MAXSUC)I   Element count in each column.
C     IERR         I   Return error code, 0=>OK, else TABINI or TABIO
C                      error.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, VELTYP*8, VELDEF*8
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, NUMIF,
     *   FREQID, ISURNO, SUKOLS(*), SUNUMV(*), IERR
C
      INTEGER   IVER, MVER
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL FNDEXT ('SU', CATBLK, MVER)
      IVER = VER
      IF (VER.LE.0) THEN
         IVER = MVER
         IF (OPCODE.EQ.'WRIT') IVER = MVER + 1
         END IF
C                                       check format of file if read
C                                       or existing
      IF ((OPCODE.EQ.'READ') .OR. (IVER.LE.MVER)) THEN
         CALL SUREFM (DISK, CNO, IVER, CATBLK, LUN, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
            END IF
         END IF
C                                       now do proper thing
      CALL SUINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN, NUMIF,
     *   VELTYP, VELDEF, FREQID, ISURNO, SUKOLS, SUNUMV, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SOUINI: ERROR',I3,' CORRECTING SU FORMAT, CONTINUING')
      END

LOCAL INCLUDE 'SQASH.INC'
      INCLUDE 'INCS:PMAD.INC'
      HOLLERITH XNAMIN(3), XCLSIN(2), XNMOUT(3), XCLOUT(2), XINTXT(12)
      REAL      XSEQI, XDISKI, XSEQO, XDISKO, XBLC(7), XTRC(7), XBDROP,
     *   DPARM(10)
      COMMON /INPARM/ XNAMIN, XCLSIN, XSEQI, XDISKI, XNMOUT, XCLOUT,
     *   XSEQO, XDISKO, XBLC, XTRC, XBDROP, DPARM, XINTXT
      CHARACTER NAMIN*12, CLSIN*6, NAMOUT*12, CLSOUT*6, INTEXT*48
      COMMON /CHPARM/ NAMIN, CLSIN, NAMOUT, CLSOUT, INTEXT
      INTEGER   CATIN(256), SCRTCH(256), DISKIN, DISKOU, CNOIN, CNOUT,
     *   SEQIN, SEQOU, LUNIN, INDIN, LUNOU, INDOU, IBDROP, IFUNC
      LOGICAL   SUM(7)
      COMMON /OTPARM/ CATIN, SCRTCH, DISKIN, DISKOU, CNOIN, CNOUT,
     *   SEQIN, SEQOU, LUNIN, INDIN, LUNOU, INDOU, IBDROP, SUM, IFUNC
      REAL      BUFF1(MABFSS), BUFF2(MABFSS)
      COMMON /BUPARM/ BUFF1, BUFF2
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
LOCAL END
      PROGRAM SQASH
C-----------------------------------------------------------------------
C! Task to sum or average planes along axes, writing to new file
C# Map-util Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2008-2009, 2011-2012, 2015, 2017,
C;  Copyright (C) 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SQASH will copy a subarray of a cataloged file to a new file
C   summing or averaging the planes along one or more axes.
C   Inputs:  (from AIPS)
C      INNAME     R(3)   the entry name for the source file.  If
C                 blank the first match consistent with the other
C                 parameters is used.
C      INCLASS    R(2)   the class of the source file.  If blank
C                 the first match consistent with the other
C                 parameters is used.
C      INSEQ      R   the sequence number of the source file.  If
C                 zero the first match consistent with the other
C                 parameters is used.
C      INDISK     R   the disk volume number of the source file.
C                 If zero all disks are searched and the first
C                 match found is used.
C      OUTNAME    R(3)   the name of the new subimage file.  If
C                 blank the value in INNAME will be used.
C      OUTCLASS   R(2)   the class of the new subimage file.  If
C                 blank the value in INCLASS will be used.
C      OUTSEQ     R   the sequence number for the new subimage
C                 file.  If zero the first sequence number that
C                 will produce a unique file specification is
C                 used.
C      OUTDISK    R   the disk volume number for the new subimage
C                 file.  If zero the new file will be created
C                 on the same disk as the old file.
C      BLC        R(7)   the coordinate in the source file to
C                 become the bottom left hand coordinate (1,1)
C                 of the subimage.  BLC(1) is the X value and
C                 BLC(2) is the Y value.  The first coordinate
C                 IN the source map is (1,1). Any BLC(I) equal
C                 to zero defaults to 1.
C      TRC        R(7)   the coordinate in the source file to
C                 become the top right hand corner of the
C                 subimage.  The conventions used for BLC hold.
C      BDROP      The axis number over which the planes are summed or
C                 averaged.  > 0 just that axis, < 0 all axes >=
C                 -BDROP.
C      DPARM(10)  (1) = 0 average, = 1 sum, = 2 maximum
C                 (2) > 0 ignore blanked pixels, <= 0 enforce them.
C-----------------------------------------------------------------------
      INTEGER   IRET, NWORDS, NX, NY, I, J
      LONGINT   PWT, PWORK, PASUM, PACNT, PASQS
      REAL      WT(2), WORK(2), ASUM(2), ASQS(2), RCNT(2)
      INTEGER   ACNT(2)
      CHARACTER PRGNAM*6
      EQUIVALENCE (ACNT, RCNT)
      INCLUDE 'SQASH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGNAM /'SQASH'/
C-----------------------------------------------------------------------
C                                       get inputs, create output
      CALL SQASHI (PRGNAM, NX, NY, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       get dynamic memory for weights
      PWORK = 0
      PWT = 0
      IF (IFUNC.LE.2) THEN
         NWORDS = 1
         DO 10 I = 3,7
            J = XTRC(I) - XBLC(I) + 1.5
            NWORDS = NWORDS * J
 10         CONTINUE
         I = NWORDS
         NWORDS = (NWORDS - 1) / 1024 + 3
         CALL ZMEMRY ('GET ', TSKNAM, NWORDS, WT, PWT, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'CANNOT GET DYNAMIC MEMORY NEEDED'
            CALL MSGWRT (8)
            GO TO 990
            END IF
C                                       text file
         IF ((DPARM(3).GT.0.0) .AND. (INTEXT.NE.' ')) THEN
            CALL SQASHT (I, WT(1+PWT), IRET)
            IF (IRET.NE.0) GO TO 990
C                                       read each plane and compute
         ELSE
            NWORDS = (NX * NY - 1) / 1024 + 3
            CALL ZMEMRY ('GET ', TSKNAM, NWORDS, WORK, PWORK, IRET)
            IF (IRET.NE.0) THEN
               MSGTXT = 'CANNOT GET DYNAMIC MEMORY NEEDED'
               CALL MSGWRT (8)
               GO TO 990
               END IF
            CALL SQASHR (WT(1+PWT), NX, WORK(1+PWORK), IRET)
            IF (IRET.NE.0) GO TO 990
            END IF
         END IF
C                                       do computation
C     IF (IBDROP.EQ.3) THEN
      NWORDS = (NX * NY - 1) / 1024 + 3
      IF (PWORK.EQ.0) THEN
         CALL ZMEMRY ('GET ', TSKNAM, NWORDS, WORK, PWORK, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'CANNOT GET DYNAMIC MEMORY NEEDED'
            CALL MSGWRT (8)
            GO TO 990
            END IF
         END IF
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, ASUM, PASUM, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'CANNOT GET DYNAMIC MEMORY NEEDED'
         CALL MSGWRT (8)
         GO TO 990
         END IF
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, ASQS, PASQS, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'CANNOT GET DYNAMIC MEMORY NEEDED'
         CALL MSGWRT (8)
         GO TO 990
         END IF
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, RCNT, PACNT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'CANNOT GET DYNAMIC MEMORY NEEDED'
         CALL MSGWRT (8)
         GO TO 990
         END IF
      IF (IBDROP.GT.2) THEN
         CALL SQASH3 (WT(1+PWT), NX, WORK(1+PWORK), ASUM(1+PASUM),
     *      ASQS(1+PASQS), ACNT(1+PACNT), IRET)
      ELSE
         CALL SQASH2 (WT(1+PWT), NX, WORK(1+PWORK), ASUM(1+PASUM),
     *      ASQS(1+PASQS), ACNT(1+PACNT), IRET)
         END IF
C     ELSE
c         CALL SQASHD (WT(1+PWT), IRET)
c         END IF
      IF (IRET.NE.0) GO TO 990
C                                       history
      CALL SQASHH
C
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE SQASHI (PRGNAM, NX, NY, IRET)
C-----------------------------------------------------------------------
C   Inputs:
C      PRGNAM   C*6   Program name
C   Outputs:
C      NX       I     Number X pixels in output
C      NY       I     Number Y pixels in output
C      IRET     I     error code
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   NX, NY, IRET
C
      INTEGER   NPARMS, IERR, IUSER, INODIM, IROUND, I, JTRIM
      CHARACTER MTYPE*2, CFUNC(7)*16
      INCLUDE 'SQASH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA CFUNC /'Weighted mean', 'Weighted rms', 'Mean', 'Rms', 'Sum',
     *   'Maximum', 'Minimum'/
C-----------------------------------------------------------------------
C                                       Initialize the I/O parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NSCR = 0
      NCFILE = 0
      LUNIN = 17
      LUNOU = 18
C                                       Get input values from AIPS.
      NPARMS = 51
      CALL GTPARM (PRGNAM, NPARMS, RQUICK, XNAMIN, SCRTCH, IERR)
      IRET = IERR
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (7)
C
 10   IF (RQUICK) CALL RELPOP (IRET, CATBLK, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 8
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
      CALL H2CHR (12, 1, XNMOUT, NAMOUT)
      CALL H2CHR (6, 1, XCLOUT, CLSOUT)
      CALL H2CHR (48, 1, XINTXT, INTEXT)
      SEQIN = IROUND (XSEQI)
      SEQOU = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKOU = IROUND (XDISKO)
C                                       Open source file.
      MTYPE = 'MA'
      IUSER = NLUSER
      CALL MAPOPN ('READ', DISKIN, NAMIN, CLSIN, SEQIN, MTYPE, IUSER,
     *   LUNIN, INDIN, CNOIN, CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 0
      CALL COPY (256, CATBLK, CATIN)
C                                       Set default values BLC, TRC.
      INODIM = CATBLK(KIDIM)
      CALL WINDOW (INODIM, CATBLK(KINAX), XBLC, XTRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       check BDROP
      IBDROP = IROUND (XBDROP)
      IBDROP = ABS(IBDROP)
      IF ((IBDROP.GT.INODIM) .OR. (IBDROP.LT.2)) THEN
         WRITE (MSGTXT,1015) IBDROP, INODIM
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       function
      IFUNC = IROUND (DPARM(1)) + 1
      IF ((IFUNC.LT.1) .OR. (IFUNC.GT.7)) IFUNC = 1
      I = JTRIM (CFUNC(IFUNC))
      IF (XBDROP.LT.-0.49) THEN
         WRITE (MSGTXT,1025) CFUNC(IFUNC)(:I), IBDROP, INODIM
      ELSE
         WRITE (MSGTXT,1026) CFUNC(IFUNC)(:I), IBDROP
         END IF
      CALL MSGWRT (3)
C                                       output header
C                                       Build new file cat name.
      CALL MAKOUT (NAMIN, CLSIN, SEQIN, '      ', NAMOUT, CLSOUT,
     *   SEQOU)
      CALL SUBHDR (XBLC, XTRC, 1.0, 1.0)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLSOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOU
C                                       counters
      NX = CATIN(KINAX)
      NY = CATIN(KINAX+1)
      DO 20 I = 1,7
         SUM(I) = .FALSE.
         IF (I.EQ.IBDROP) SUM(I) = .TRUE.
         IF ((I.GT.IBDROP) .AND. (XBDROP.LT.-0.49)) SUM(I) = .TRUE.
 20      CONTINUE
      DO 25 I = 1,7
         IF (SUM(I)) CATBLK(KINAX+I-1) = 1
         IF (CATBLK(KINAX+I-1).LE.0) CATBLK(KINAX+I-1) = 1
 25      CONTINUE
C                                       Create new cataloged file.
      CALL MCREAT (DISKOU, CNOUT, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKOU
      FCNO(NCFILE) = CNOUT
      FRW(NCFILE) = 2
      SEQOU = CATBLK(KIIMS)
C                                       copy most keywords
      CALL KEYPCP (DISKIN, CNOIN, DISKOU, CNOUT, 0, ' ', IERR)
C                                       Open new file.
      MTYPE = 'MA'
      CALL MAPOPN ('INIT', DISKOU, NAMOUT, CLSOUT, SEQOU, MTYPE, IUSER,
     *   LUNOU, INDOU, CNOUT, CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR GETTING PARAMETERS FROM AIPS. ERR=',I5)
 1015 FORMAT ('BAD VALUE OF BDROP =',I2,' NOT IN RANGE 2 -',I2)
 1025 FORMAT('*** determines ',A,' along axes ',I1,' thru ',I1,' ***')
 1026 FORMAT('*** determines ',A,' along axis ',I1,' ***')
      END
      SUBROUTINE SQASHH
C-----------------------------------------------------------------------
C   writes HI and tables
C-----------------------------------------------------------------------
C
      INTEGER   IERR, IC(7), I, INODIM, HLUN1, HLUN2, JTRIM
      CHARACTER HILINE*72, CFUNC(7)*16, NOTTYP(1)*2
      INCLUDE 'SQASH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA HLUN1, HLUN2 /27, 28/
      DATA CFUNC /'Weighted mean', 'Weighted rms', 'Mean', 'Rms', 'Sum',
     *   'Maximum', 'Minimum'/
      DATA NOTTYP /'CC'/
C-----------------------------------------------------------------------
      CALL HIINIT (3)
C                                       Create and copy history file.
      CALL HISCOP (HLUN1, HLUN2, DISKIN, DISKOU, CNOIN, CNOUT, CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.3) GO TO 110
      CALL HENCO1 (TSKNAM, NAMIN, CLSIN, SEQIN, DISKIN, HLUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCOO (TSKNAM, NAMOUT, CLSOUT, SEQOU, DISKOU, HLUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       corners
      INODIM = CATIN(KIDIM)
      DO 10 I = 1,INODIM
         IC(I) = XBLC(I) + 0.5
 10      CONTINUE
      WRITE (HILINE,1010) TSKNAM, 'BLC', (IC(I), I = 1,INODIM)
      I = JTRIM (HILINE)
      IF (HILINE(I:I).EQ.',') HILINE(I:I) = ' '
      CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      DO 15 I = 1,INODIM
         IC(I) = XTRC(I) + 0.5
 15      CONTINUE
      WRITE (HILINE,1010) TSKNAM, 'TRC', (IC(I), I = 1,INODIM)
      I = JTRIM (HILINE)
      IF (HILINE(I:I).EQ.',') HILINE(I:I) = ' '
      CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       function
      WRITE (HILINE,1015) TSKNAM, IFUNC-1, CFUNC(IFUNC)
      CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      IF (IFUNC.LE.2) THEN
         IF (DPARM(3).GT.0.0) THEN
            I = JTRIM (INTEXT)
            WRITE (HILINE,1016) TSKNAM, INTEXT(:I)
         ELSE
            WRITE (HILINE,1017) TSKNAM
            END IF
         CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
         END IF
      IF (XBDROP.LE.-0.49) THEN
         WRITE (HILINE,1020) TSKNAM, IBDROP, IBDROP, INODIM
      ELSE
         WRITE (HILINE,1021) TSKNAM, IBDROP, IBDROP
         END IF
      CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       update header
 100  CALL HICLOS (HLUN2, .TRUE., BUFF2, IERR)
C                                       copy tables, not CC
 110  CALL ALLTAB (1, NOTTYP, HLUN1, HLUN2, DISKIN, DISKOU, CNOIN,
     *   CNOUT, CATBLK, BUFF1, BUFF2, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (A,A,' =',2(I6,','),4(I5,','),I5)
 1015 FORMAT (A,'DPARM(1) =',I2,'    / compute ',A)
 1016 FORMAT (A,'INTEXT =''',A,'''  / weight file')
 1017 FORMAT (A,'  / weight from data')
 1020 FORMAT (A,'BDROP = -',I1,'  / summed over axes',I2,' thru',I2)
 1021 FORMAT (A,'BDROP = ',I2,'  / summed over axis',I2)
      END
      SUBROUTINE SQASHT (N, WT, IRET)
C-----------------------------------------------------------------------
C   SQASHT reads the text file of weights
C   Inputs:
C      N      I      Number wts expected
C   Outputs:
C      WT     R(*)   Weight array
C      IRET   I      Error code
C-----------------------------------------------------------------------
      INTEGER   N, IRET
      REAL      WT(*)
C
      INTEGER   I, KBP, LUN, LUNTMP, J, JTRIM, K, FIND
      DOUBLE PRECISION X
      CHARACTER LINE*132
      INCLUDE 'SQASH.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       open text file
      LUN = LUNTMP (2)
      CALL ZTXOPN ('READ', LUN, FIND, INTEXT, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING THE TEXT FILE'
         GO TO 990
         END IF
C                                       read loop
      I = 0
      K = 0
 20   K = K + 1
      CALL ZTXIO ('READ', LUN, FIND, LINE, IRET)
      IF (IRET.EQ.0) THEN
         J = JTRIM (LINE)
         CALL CHLTOU (J, LINE)
         IF ((J.LE.0) .OR. (LINE(:1).EQ.'#') .OR. ((LINE(:1).GE.'A')
     *      .AND. (LINE(:1).LE.'Z'))) GO TO 20
         KBP = 1
         CALL GETNUM (LINE, J, KBP, X)
         IF (X.EQ.DBLANK) THEN
            WRITE (MSGTXT,1020) K
            CALL MSGWRT (7)
         ELSE
            I = I + 1
            IF (I.LE.N) WT(I) = X
            END IF
         GO TO 20
      ELSE IF (IRET.NE.2) THEN
         WRITE (MSGTXT,1000) IRET, 'READING TEXT FILE'
         GO TO 990
         END IF
      IRET = 0
      K = K - 1
      CALL ZTXCLS (LUN, FIND, KBP)
      IF (I.EQ.N) THEN
         WRITE (MSGTXT,1100) I, K
         CALL MSGWRT (3)
      ELSE
         WRITE (MSGTXT,1101) I, N, K
         CALL MSGWRT (7)
         IF (I.LT.N) IRET = 10
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SQASHT: ERROR',I4,' ON ',A)
 1020 FORMAT ('SQASHT: TEXT FILE NUMBER ERROR LINE',I5)
 1100 FORMAT ('SQASHT: read',I6,' weights in',I6,' text file lines')
 1101 FORMAT ('SQASHT: READ',I6,' WEIGHTS, EXPECTED',I6,' IN',I6,
     *   ' LINES')
      END
      SUBROUTINE SQASHR (WT, NX, WORK, IRET)
C-----------------------------------------------------------------------
C   SQASHR reads the image a plane at a time and fits a robust rms to
C   each plane returning WT = 1 / (rms**2).
C   Inputs:
C      NX     I      Number X points per row
C   Outputs:
C      WT     R(*)   Weights for each plane
C      WORK   R(*)   work area for each plane
C      IRET   I      error code
C-----------------------------------------------------------------------
      INTEGER   NX, IRET
      REAL      WT(*), WORK(NX,*)
C
      INTEGER   IROUND, IX3L, IX3U, IX4L, IX4U, IX5L, IX5U, IX6L, IX6U,
     *   IX7L, IX7U, I3, I4, I5, I6, I7, IDEPTH(5), IWIN(4), N, NY, NBY,
     *   IX, IY, IBIND, IPASS, IBLKOF
      REAL      RSC(9)
      DOUBLE PRECISION SS, SQ, SN, RSP, RSM, RM, RS, T
      INCLUDE 'SQASH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA RSC /6.0, 5.0, 4.0, 3.5, 3.0, 2.8, 2.6, 3.2, 3.2/
C-----------------------------------------------------------------------
      NBY = 2 * MABFSS
      IX3L = IROUND (XBLC(3))
      IX3U = IROUND (XTRC(3))
      IX4L = IROUND (XBLC(4))
      IX4U = IROUND (XTRC(4))
      IX5L = IROUND (XBLC(5))
      IX5U = IROUND (XTRC(5))
      IX6L = IROUND (XBLC(6))
      IX6U = IROUND (XTRC(6))
      IX7L = IROUND (XBLC(7))
      IX7U = IROUND (XTRC(7))
      IWIN(1) = 1
      IWIN(2) = 1
      IWIN(3) = CATIN(KINAX)
      IWIN(4) = CATIN(KINAX+1)
      NY = CATIN(KINAX+1)
      N = 0
      DO 200 I7 = IX7L,IX7U
         DO 190 I6 = IX6L,IX6U
            DO 180 I5 = IX5L,IX5U
               DO 170 I4 = IX4L,IX4U
                  DO 160 I3 = IX3L,IX3U
                     IDEPTH(1) = I3
                     IDEPTH(2) = I4
                     IDEPTH(3) = I5
                     IDEPTH(4) = I6
                     IDEPTH(5) = I7
                     CALL COMOFF (CATIN(KIDIM), CATIN(KINAX), IDEPTH,
     *                  IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'COMOFF CALL'
                        GO TO 990
                        END IF
                     IBLKOF = IBLKOF + 1
C                                       init I/O this plane
                     CALL MINIT ('READ', LUNIN, INDIN, NX, NY, IWIN,
     *                  BUFF1, NBY, IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'INIT I/O TO INPUT'
                        GO TO 990
                        END IF
C                                       fill plane
                     DO 20 IY = 1,NY
                        CALL MDISK ('READ', LUNIN, INDIN, BUFF1, IBIND,
     *                     IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET,
     *                        'READING INPUT IMAGE'
                           GO TO 990
                           END IF
                        CALL RCOPY (NX, BUFF1(IBIND), WORK(1,IY))
 20                     CONTINUE
C                                       find rms
                     RSP = 1.E10
                     RSM = -1.E10
                     RM = 0.0D0
                     RS = 1.D6
                     DO 50 IPASS = 1,9
                        SS = 0.0D0
                        SQ = 0.0D0
                        SN = 0.0D0
                        DO 40 IY = 1,NY
                           DO 30 IX = 1,NX
                              IF (WORK(IX,IY).NE.FBLANK) THEN
                                 T = WORK(IX,IY)
                                 IF ((T.GE.RSM) .AND. (T.LE.RSP)) THEN
                                    SS = SS + T
                                    SQ = SQ + T * T
                                    SN = SN + 1.0D0
                                    END IF
                                 END IF
 30                           CONTINUE
 40                        CONTINUE
                        IF (SN.LE.0.0D0) THEN
                           RSP = RSP + 3.0D0 * RS
                           RSM = RSM - 3.0D0 * RS
                        ELSE
                           RM = SS / SN
                           RS = SQ / SN - RM * RM
                           RS = SQRT (MAX (0.0D0, RS))
                           IF (RS.EQ.0.0D0) RS = RM/3.0D0
                           RSP = RM + RSC(IPASS) * RS
                           RSM = RM - RSC(IPASS) * RS
                           END IF
 50                     CONTINUE
C                                       squirrel away a weight
                     N = N + 1
                     IF (RS.GT.0.0) THEN
                        WT(N) = 1.0D0 / (RS * RS)
                     ELSE
                        WT(N) = 0.0
                        END IF
                     WRITE (MSGTXT,1050) WT(N), I3, I4, I5, I6, I7
                     CALL MSGWRT (3)
 160                 CONTINUE
 170              CONTINUE
 180           CONTINUE
 190        CONTINUE
 200     CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SQASHR: ERROR',I4,' ON ',A)
 1050 FORMAT ('SQASHR weight',F14.3,' plane',I7,I5,3I4)
      END
      SUBROUTINE PLANE (IDEPTH, XBLC, XTRC, JPL)
C-----------------------------------------------------------------------
C   PLANE finds the plane number currently
C   Inputs:
C      IDEPTH   I(5)   Current input file depth
C      XBLC     R(7)   bottom left corner of input
C      XTRC     R(7)   top right corner of input
C   Output:
C      JPL      I      Plane number
C-----------------------------------------------------------------------
      INTEGER   IDEPTH(5), JPL
      REAL      XBLC(7), XTRC(7)
C
      INTEGER   IBLC, NPIX, NTOT(6), I
C-----------------------------------------------------------------------
      NTOT(1) = 1
      JPL = 1
      DO 10 I = 1,5
         IBLC = XBLC(I+2) + 0.1
         NPIX = XTRC(I+2) + 1.1 - IBLC
         NTOT(I+1) = NTOT(I) * NPIX
         JPL = JPL + (IDEPTH(I)-IBLC) * NTOT(I)
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SQASH3 (WT, NX, WORK, ASUM, ASQS, ACNT, IRET)
C-----------------------------------------------------------------------
C   SQASHR does the squash operation
C   Inputs:
C      WT     R(*)   Weights for each plane
C      NX     I      Row size
C   Outputs:
C      WORK   R(*)   work buffer
C      ASUM   R(*)   work buffer
C      ICNT   I(*)   work buffer
C      IRET   I      error code
C-----------------------------------------------------------------------
      INTEGER   NX, ACNT(NX,*), IRET
      REAL      WT(*), WORK(NX,*), ASQS(NX,*), ASUM(NX,*)
C
      INCLUDE 'SQASH.INC'
      INTEGER   IROUND, IX3L, IX3U, IX4L, IX4U, IX5L, IX5U, IX6L, IX6U,
     *   IX7L, IX7U, I3, I4, I5, I6, I7, IDEPTH(5), IWIN(4), NY, NBY,
     *   IX, IY, IBIND, IBLKOF, K3, K4, K5, K6, K7, K3U, K4U, K5U, K6U,
     *   K7U, OWIN(4), OBIND, NCNTMX, JPL, INY, INX
      REAL      RMAX, RMIN, W, T
      LOGICAL   WASBLK
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      NBY = 2 * MABFSS
      IX3L = IROUND (XBLC(3))
      IX3U = IROUND (XTRC(3))
      IX4L = IROUND (XBLC(4))
      IX4U = IROUND (XTRC(4))
      IX5L = IROUND (XBLC(5))
      IX5U = IROUND (XTRC(5))
      IX6L = IROUND (XBLC(6))
      IX6U = IROUND (XTRC(6))
      IX7L = IROUND (XBLC(7))
      IX7U = IROUND (XTRC(7))
      K3U = CATBLK(KINAX+2)
      K4U = CATBLK(KINAX+3)
      K5U = CATBLK(KINAX+4)
      K6U = CATBLK(KINAX+5)
      K7U = CATBLK(KINAX+6)
      NY = CATIN(KINAX+1)
      IWIN(1) = IROUND (XBLC(1))
      IWIN(2) = IROUND (XBLC(2))
      IWIN(3) = IROUND (XTRC(1))
      IWIN(4) = IROUND (XTRC(2))
      INX = IWIN(3) - IWIN(1) + 1
      INY = IWIN(4) - IWIN(2) + 1
      OWIN(1) = 1
      OWIN(2) = 1
      OWIN(3) = INX
      OWIN(4) = INY
      RMAX = -1.E10
      RMIN = -RMAX
      WASBLK = .FALSE.
      DO 200 K7 = 1,K7U
         DO 190 K6 = 1,K6U
            DO 180 K5 = 1,K5U
               DO 170 K4 = 1,K4U
                  DO 160 K3 = 1,K3U
                     IDEPTH(1) = K3
                     IDEPTH(2) = K4
                     IDEPTH(3) = K5
                     IDEPTH(4) = K6
                     IDEPTH(5) = K7
                     CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH,
     *                  IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'COMOFF FOR WRITE'
                        GO TO 990
                        END IF
                     IBLKOF = IBLKOF + 1
C
                     CALL MINIT ('WRIT', LUNOU, INDOU, INX, INY, OWIN,
     *                  BUFF2, NBY, IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'INIT WRITE I/O'
                        GO TO 990
                        END IF
C                                       Which planes contribute
                     IF (.NOT.SUM(7)) THEN
                        IX7L = K7 + XBLC(7) - 0.999
                        IX7U = IX7L
                        END IF
                     IF (.NOT.SUM(6)) THEN
                        IX6L = K6 + XBLC(6) - 0.999
                        IX6U = IX6L
                        END IF
                     IF (.NOT.SUM(5)) THEN
                        IX5L = K5 + XBLC(5) - 0.999
                        IX5U = IX5L
                        END IF
                     IF (.NOT.SUM(4)) THEN
                        IX4L = K4 + XBLC(4) - 0.999
                        IX4U = IX4L
                        END IF
                     IF (.NOT.SUM(3)) THEN
                        IX3L = K3 + XBLC(3) - 0.999
                        IX3U = IX3L
                        END IF
C                                       init the buffer
                     IY = INX * INY
                     IF (IFUNC.EQ.7) THEN
                        CALL RFILL (IY, 1.E10, WORK)
                     ELSE IF (IFUNC.EQ.6) THEN
                        CALL RFILL (IY, -1.E10, WORK)
                     ELSE
                        CALL RFILL (IY, 0.0, WORK)
                        CALL RFILL (IY, 0.0, ASUM)
                        CALL RFILL (IY, 0.0, ASQS)
                        END IF
                     CALL FILL (IY, 0, ACNT)
                     NCNTMX = 0
                     DO 130 I7 = IX7L,IX7U
                        DO 120 I6 = IX6L,IX6U
                           DO 110 I5 = IX5L,IX5U
                              DO 100 I4 = IX4L,IX4U
                                 DO 90 I3 = IX3L,IX3U
                                    IDEPTH(1) = I3
                                    IDEPTH(2) = I4
                                    IDEPTH(3) = I5
                                    IDEPTH(4) = I6
                                    IDEPTH(5) = I7
                                    CALL PLANE (IDEPTH, XBLC, XTRC, JPL)
                                    CALL COMOFF (CATIN(KIDIM),
     *                                 CATIN(KINAX), IDEPTH, IBLKOF,
     *                                 IRET)
                                    IF (IRET.NE.0) THEN
                                       WRITE (MSGTXT,1000) IRET,
     *                                    'COMOFF CALL'
                                       GO TO 990
                                       END IF
                                    IBLKOF = IBLKOF + 1
                                    CALL MINIT ('READ', LUNIN, INDIN,
     *                                 NX, NY, IWIN, BUFF1, NBY, IBLKOF,
     *                                 IRET)
                                    IF (IRET.NE.0) THEN
                                       WRITE (MSGTXT,1000) IRET,
     *                                    'INIT I/O TO INPUT'
                                       GO TO 990
                                       END IF
                                    NCNTMX = NCNTMX + 1
                                    DO 80 IY = 1,INY
                                       CALL MDISK ('READ', LUNIN, INDIN,
     *                                    BUFF1, IBIND, IRET)
                                       IF (IRET.NE.0) THEN
                                          WRITE (MSGTXT,1000) IRET,
     *                                       'READING INPUT IMAGE'
                                          GO TO 990
                                          END IF
                                       W = 1.0
                                       IF (IFUNC.LE.2) W = WT(JPL)
                                       DO 70 IX = 1,INX
                                          T = BUFF1(IX+IBIND-1)
                                          IF (T.NE.FBLANK) THEN
                                             IF (IFUNC.EQ.7) THEN
                                                WORK(IX,IY) = MIN (T,
     *                                             WORK(IX,IY))
                                             ELSE IF (IFUNC.EQ.6) THEN
                                                WORK(IX,IY) = MAX (T,
     *                                             WORK(IX,IY))
                                             ELSE
                                                WORK(IX,IY) = W * T
     *                                             + WORK(IX,IY)
                                                ASQS(IX,IY) = W * T * T
     *                                             + ASQS(IX,IY)
                                                END IF
                                             ASUM(IX,IY) = ASUM(IX,IY)+W
                                             ACNT(IX,IY) = ACNT(IX,IY)+1
                                             END IF
 70                                       CONTINUE
 80                                    CONTINUE
 90                                 CONTINUE
 100                             CONTINUE
 110                          CONTINUE
 120                       CONTINUE
 130                    CONTINUE
C                                       test and average
                     DO 150 IY = 1,INY
                        CALL MDISK ('WRIT', LUNOU, INDOU, BUFF2, OBIND,
     *                     IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET, 'WRITE A ROW'
                           GO TO 990
                           END IF
                        DO 140 IX = 1,INX
                           T = WORK(IX,IY)
                           IF ((ACNT(IX,IY).LE.0) .OR.
     *                        (ASUM(IX,IY).LE.0.0)) THEN
                              T = FBLANK
                           ELSE IF ((DPARM(2).GT.0.0) .AND.
     *                        (ACNT(IX,IY).LT.NCNTMX)) THEN
                              T = FBLANK
                           ELSE
                              IF (IFUNC.LE.4) T = T / ASUM(IX,IY)
                              IF ((IFUNC.EQ.2) .OR. (IFUNC.EQ.4)) THEN
                                 T = ASQS(IX,IY) / ASUM(IX,IY) - T * T
                                 T = SQRT (MAX (0.0, T))
                                 END IF
                              RMAX = MAX (RMAX, T)
                              RMIN = MIN (RMIN, T)
                              END IF
                           BUFF2(OBIND+IX-1) = T
                           IF (T.EQ.FBLANK) WASBLK = .TRUE.
 140                       CONTINUE
 150                    CONTINUE
C                                       write last buffer
                     CALL MDISK ('FINI', LUNOU, INDOU, BUFF2, OBIND,
     *                  IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'WRITE A ROW'
                        GO TO 990
                        END IF
 160                 CONTINUE
 170              CONTINUE
 180           CONTINUE
 190        CONTINUE
 200     CONTINUE
C                                       anything?
      IF (RMAX.LT.RMIN) THEN
         MSGTXT = 'NO VALID PIXELS FOUND'
         IRET = 10
         GO TO 990
         END IF
      CATR(KRDMN) = RMIN
      CATR(KRDMX) = RMAX
      CATR(KRBLK) = 0.0
      IF (WASBLK) CATR(KRBLK) = FBLANK
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SQASH3: ERROR',I4,' ON ',A)
      END
      SUBROUTINE SQASH2 (WT, NX, WORK, ASUM, ASQS, ACNT, IRET)
C-----------------------------------------------------------------------
C   SQASHR does the squash operation when axis 2 is included
C   Inputs:
C      WT     R(*)   Weights for each plane
C      NX     I      Row size
C   Outputs:
C      WORK   R(*)   work buffer
C      ASUM   R(*)   work buffer
C      ICNT   I(*)   work buffer
C      IRET   I      error code
C-----------------------------------------------------------------------
      INTEGER   NX, ACNT(NX,*), IRET
      REAL      WT(*), WORK(NX,*), ASQS(NX,*), ASUM(NX,*)
C
      INCLUDE 'SQASH.INC'
      INTEGER   IROUND, IX3L, IX3U, IX4L, IX4U, IX5L, IX5U, IX6L, IX6U,
     *   IX7L, IX7U, I3, I4, I5, I6, I7, IDEPTH(5), IWIN(4), NY, NBY,
     *   IX, IY, IBIND, IBLKOF, K3, K4, K5, K6, K7, K3U, K4U, K5U, K6U,
     *   K7U, OWIN(4), OBIND, NCNTMX, JPL, INY, INX
      REAL      RMAX, RMIN, W, T
      LOGICAL   WASBLK
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      NBY = 2 * MABFSS
      IX3L = IROUND (XBLC(3))
      IX3U = IROUND (XTRC(3))
      IX4L = IROUND (XBLC(4))
      IX4U = IROUND (XTRC(4))
      IX5L = IROUND (XBLC(5))
      IX5U = IROUND (XTRC(5))
      IX6L = IROUND (XBLC(6))
      IX6U = IROUND (XTRC(6))
      IX7L = IROUND (XBLC(7))
      IX7U = IROUND (XTRC(7))
      K3U = CATBLK(KINAX+2)
      K4U = CATBLK(KINAX+3)
      K5U = CATBLK(KINAX+4)
      K6U = CATBLK(KINAX+5)
      K7U = CATBLK(KINAX+6)
      NY = CATIN(KINAX+1)
      IWIN(1) = IROUND (XBLC(1))
      IWIN(2) = IROUND (XBLC(2))
      IWIN(3) = IROUND (XTRC(1))
      IWIN(4) = IROUND (XTRC(2))
      INX = IWIN(3) - IWIN(1) + 1
      INY = IWIN(4) - IWIN(2) + 1
      OWIN(1) = 1
      OWIN(2) = 1
      OWIN(3) = INX
      OWIN(4) = INY
      RMAX = -1.E10
      RMIN = -RMAX
      WASBLK = .FALSE.
      DO 200 K7 = 1,K7U
         DO 190 K6 = 1,K6U
            DO 180 K5 = 1,K5U
               DO 170 K4 = 1,K4U
                  DO 160 K3 = 1,K3U
                     IDEPTH(1) = K3
                     IDEPTH(2) = K4
                     IDEPTH(3) = K5
                     IDEPTH(4) = K6
                     IDEPTH(5) = K7
                     CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH,
     *                  IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'COMOFF FOR WRITE'
                        GO TO 990
                        END IF
                     IBLKOF = IBLKOF + 1
C
                     CALL MINIT ('WRIT', LUNOU, INDOU, INX, INY, OWIN,
     *                  BUFF2, NBY, IBLKOF, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'INIT WRITE I/O'
                        GO TO 990
                        END IF
C                                       Which planes contribute
                     IF (.NOT.SUM(7)) THEN
                        IX7L = K7 + XBLC(7) - 0.999
                        IX7U = IX7L
                        END IF
                     IF (.NOT.SUM(6)) THEN
                        IX6L = K6 + XBLC(6) - 0.999
                        IX6U = IX6L
                        END IF
                     IF (.NOT.SUM(5)) THEN
                        IX5L = K5 + XBLC(5) - 0.999
                        IX5U = IX5L
                        END IF
                     IF (.NOT.SUM(4)) THEN
                        IX4L = K4 + XBLC(4) - 0.999
                        IX4U = IX4L
                        END IF
                     IF (.NOT.SUM(3)) THEN
                        IX3L = K3 + XBLC(3) - 0.999
                        IX3U = IX3L
                        END IF
C                                       init the buffer
                     IY = INX * INY
                     IF (IFUNC.EQ.7) THEN
                        CALL RFILL (IY, 1.E10, WORK)
                     ELSE IF (IFUNC.EQ.6) THEN
                        CALL RFILL (IY, -1.E10, WORK)
                     ELSE
                        CALL RFILL (IY, 0.0, WORK)
                        CALL RFILL (IY, 0.0, ASUM)
                        CALL RFILL (IY, 0.0, ASQS)
                        END IF
                     CALL FILL (IY, 0, ACNT)
                     NCNTMX = 0
                     DO 130 I7 = IX7L,IX7U
                        DO 120 I6 = IX6L,IX6U
                           DO 110 I5 = IX5L,IX5U
                              DO 100 I4 = IX4L,IX4U
                                 DO 90 I3 = IX3L,IX3U
                                    IDEPTH(1) = I3
                                    IDEPTH(2) = I4
                                    IDEPTH(3) = I5
                                    IDEPTH(4) = I6
                                    IDEPTH(5) = I7
                                    CALL PLANE (IDEPTH, XBLC, XTRC, JPL)
                                    CALL COMOFF (CATIN(KIDIM),
     *                                 CATIN(KINAX), IDEPTH, IBLKOF,
     *                                 IRET)
                                    IF (IRET.NE.0) THEN
                                       WRITE (MSGTXT,1000) IRET,
     *                                    'COMOFF CALL'
                                       GO TO 990
                                       END IF
                                    IBLKOF = IBLKOF + 1
                                    CALL MINIT ('READ', LUNIN, INDIN,
     *                                 NX, INY, IWIN, BUFF1, NBY,
     *                                 IBLKOF, IRET)
                                    IF (IRET.NE.0) THEN
                                       WRITE (MSGTXT,1000) IRET,
     *                                    'INIT I/O TO INPUT'
                                       GO TO 990
                                       END IF
                                    NCNTMX = NCNTMX + 1
                                    DO 80 IY = 1,INY
                                       CALL MDISK ('READ', LUNIN, INDIN,
     *                                    BUFF1, IBIND, IRET)
                                       IF (IRET.NE.0) THEN
                                          WRITE (MSGTXT,1000) IRET,
     *                                       'READING INPUT IMAGE'
                                          GO TO 990
                                          END IF
                                       W = 1.0
                                       IF (IFUNC.LE.2) W = WT(JPL)
                                       DO 70 IX = 1,INX
                                          T = BUFF1(IX+IBIND-1)
                                          IF (T.NE.FBLANK) THEN
                                             IF (IFUNC.EQ.7) THEN
                                                WORK(IX,1) = MIN (T,
     *                                             WORK(IX,1))
                                             ELSE IF (IFUNC.EQ.6) THEN
                                                WORK(IX,1) = MAX (T,
     *                                             WORK(IX,1))
                                             ELSE
                                                WORK(IX,1) = W * T
     *                                             + WORK(IX,1)
                                                ASQS(IX,1) = W * T * T
     *                                             + ASQS(IX,1)
                                                END IF
                                             ASUM(IX,1) = ASUM(IX,1)+W
                                             ACNT(IX,1) = ACNT(IX,1)+1
                                             END IF
 70                                       CONTINUE
 80                                    CONTINUE
 90                                 CONTINUE
 100                             CONTINUE
 110                          CONTINUE
 120                       CONTINUE
 130                    CONTINUE
C                                       test and average
                     DO 150 IY = 1,INY
                        CALL MDISK ('WRIT', LUNOU, INDOU, BUFF2, OBIND,
     *                     IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET, 'WRITE A ROW'
                           GO TO 990
                           END IF
                        DO 140 IX = 1,INX
                           T = WORK(IX,IY)
                           IF ((ACNT(IX,IY).LE.0) .OR.
     *                        (ASUM(IX,IY).LE.0.0)) THEN
                              T = FBLANK
                           ELSE IF ((DPARM(2).GT.0.0) .AND.
     *                        (ACNT(IX,IY).LT.NCNTMX)) THEN
                              T = FBLANK
                           ELSE
                              IF (IFUNC.LE.4) T = T / ASUM(IX,IY)
                              IF ((IFUNC.EQ.2) .OR. (IFUNC.EQ.4)) THEN
                                 T = ASQS(IX,IY) / ASUM(IX,IY) - T * T
                                 T = SQRT (MAX (0.0, T))
                                 END IF
                              RMAX = MAX (RMAX, T)
                              RMIN = MIN (RMIN, T)
                              END IF
                           BUFF2(OBIND+IX-1) = T
                           IF (T.EQ.FBLANK) WASBLK = .TRUE.
 140                       CONTINUE
 150                    CONTINUE
C                                       write last buffer
                     CALL MDISK ('FINI', LUNOU, INDOU, BUFF2, OBIND,
     *                  IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'WRITE A ROW'
                        GO TO 990
                        END IF
 160                 CONTINUE
 170              CONTINUE
 180           CONTINUE
 190        CONTINUE
 200     CONTINUE
C                                       anything?
      IF (RMAX.LT.RMIN) THEN
         MSGTXT = 'NO VALID PIXELS FOUND'
         IRET = 10
         GO TO 990
         END IF
      CATR(KRDMN) = RMIN
      CATR(KRDMX) = RMAX
      CATR(KRBLK) = 0.0
      IF (WASBLK) CATR(KRBLK) = FBLANK
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SQASH2: ERROR',I4,' ON ',A)
      END

      SUBROUTINE CHEBY (DA, DB, DX, DCHEB, N, IRET)
C----------------------------------------------------------------------
C! Evaluate Chebyshev polynomials
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Evaluate a sequence of Chebyshev polynomials.
C   Inputs:
C      DA      D       Lower limit x-ordinate range
C      DB      D       Upper limit x-ordinate range
C      DX      D       x-ordinate value
C      N       I       Order of maximum Chebyshev polynomial
C   Output:
C      DCHEB   D(N+1)  Polynomial values
C      IRET    I       Return code (0 => ok; else error)
C---------------------------------------------------------------------
      INTEGER N, IRET
      DOUBLE PRECISION DCHEB(N+1), DA, DB, DX
C
      DOUBLE PRECISION D2X, DXX
      INTEGER I
C---------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C                                       Check for valid input
C                                       parameters
      IF (((DB-DA).EQ.0.0D0).OR.(N.LT.0).OR.(DX.LT.DA).OR.
     *   (DX.GT.DB)) IRET = 1
      IF (IRET.NE.0) GO TO 999
C                                       Transform to range [A,B]
      DXX = (2.0D0 * DX - DA - DB) / (DB - DA)
      D2X = 2.0D0 * DXX
C                                       N = 0
      DCHEB(1) = 1.0D0
      IF (N.EQ.0) GO TO 999
C                                       N = 1
      DCHEB(2) = DXX
      IF (N.EQ.1) GO TO 999
C                                       Recurrence relation (N > 1)
      I = 2
 100  DCHEB(I+1) = D2X * DCHEB(I) - DCHEB(I-1)
      IF (I.EQ.N) GO TO 999
         I = I + 1
         GO TO 100
C                                       Exit
 999  RETURN
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER   NPARMS
C                                       NPARMS=no. adverbs passed.
      PARAMETER (NPARMS=10)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
      INCLUDE 'INCS:PAOOF.INC'
C                                       Adverb names
C                     1         2          3        4         5
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INVERS',
C           6           7         8         9         10
     *   'OUTVERS',  'BCOUNT' ,'ECOUNT', 'RADIUS', 'CUTOFF'/
C                                       Adverb data types (PAOOF.INC)
C                    1       2       3       4       5       6
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOAINT,
C          6       7       8       9      10
     *   OOAINT, OOAINT, OOAINT, OOARE, OOARE/
C                                       Adverb dimensions (as 2D)
C                   1    2    3    4    5
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 1,1,
C         6    7    8    9    10
     *   1,1, 1,1, 1,1, 1,1, 1,1/
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(4)
      LOGICAL   LDUM(4)
      REAL      RDUM(4)
      DOUBLE PRECISION DDUM(2)
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
      COMMON /CCSELG/ DDUM
LOCAL END
      PROGRAM CCSEL
C-----------------------------------------------------------------------
C! Select signifigant CC components.
C# Utility OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2009-2010, 2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Paraform AIPS OOP task processing a table.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, INTAB*32, OUTTAB*32
      INTEGER   IRET, BUFF1(256)
      DATA PRGM /'CCSEL '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL CSELIN (PRGM, INTAB, OUTTAB, IRET)
C                                       Process table
      IF (IRET.EQ.0) CALL CSELAB (INTAB, OUTTAB, IRET)
C                                       History
      IF (IRET.EQ.0) CALL CSELHI (OUTTAB)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE CSELIN (PRGN, INTAB, OUTTAB, IRET)
C-----------------------------------------------------------------------
C   CSELIN gets input parameters for CCSEL and creates the input and
C   output objects
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS file
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6, INTAB*32, OUTTAB*32
C
      INTEGER   NKEY1, NKEY2
C                                       NKEY1=no. adverbs to copy to
C                                       INTAB
      PARAMETER (NKEY1=9)
C                                       NKEY2=no. adverbs to copy to
C                                       OUTTAB
      PARAMETER (NKEY2=5)
      INTEGER   DIM(3)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to INTAB
C                   1         2          3        4         5
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INVERS',
C           6         7         8         9
     *   'BCOUNT', 'ECOUNT', 'RADIUS', 'CUTOFF'/
C                                       May rename adverbs to INTAB
C                    1       2        3        4       5
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'VER',
C           6         7         8         9
     *   'BCOUNT', 'ECOUNT', 'RADIUS', 'CUTOFF'/
C                                       Adverbs to copy to OUTTAB
C                   1         2          3        4         5
      DATA INK2 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'OUTVERS'/
C                                       May rename adverbs to OUTTAB
C                    1       2        3        4       5
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'VER'/
C-----------------------------------------------------------------------
C                                       Startup,  returns "Input" object
C                                       containing POPS adverbs
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create input object
      INTAB = 'Input table'
      CALL CREATE (INTAB, 'TABLE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, INTAB, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Table type
      DIM(1) = 2
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (INTAB, 'TBLTYPE', OOACAR, DIM, IDUM, 'CC', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create Output Object
      OUTTAB = 'Output table'
      CALL CREATE (OUTTAB, 'TABLE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, OUTTAB, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Table type
      CALL OPUT (OUTTAB, 'TBLTYPE', OOACAR, DIM, IDUM, 'CC', IRET)
      IF (IRET.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE CSELAB (INTAB, OUTTAB, IERR)
C-----------------------------------------------------------------------
C   Sum and select components.
C   Inputs:
C      INTAB   C*   Name of input table object.
C      OUTTAB  C*   Name of output table object.
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*), OUTTAB*(*)
      INTEGER   IERR
C
C
      INTEGER   MAXCC
C                                       MAXCC = max. no. CC entries.
      PARAMETER (MAXCC = 1000000)
      INTEGER   IROW, OROW, NROW, BC, EC, TYPE, DIM(3), NCC, I, J,
     *   CCROW, CCNCOL, CCTYPE(MAXCC), OVER
      REAL      XPOS(MAXCC), YPOS(MAXCC), ZPOS(MAXCC), FLUX(MAXCC),
     *   SFLUX(MAXCC), PARMS(3,MAXCC), RADIUS, CUTOFF, MXDIS, SUM, DIS,
     *   SUMI, SUMO
      LOGICAL   DOMAGN
      CHARACTER CDUMMY*1
      INCLUDE 'GFORT'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Create output table
C                                       This copies header stuff
C                                       including any keywords.
      CALL COPHED (INTAB, OUTTAB, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open input table
      CALL OCCINI (INTAB, 'READ', CCROW, CCNCOL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get number of entries
      CALL OGET (INTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IERR)
      NROW = IDUM(1)
      IF (IERR.NE.0) GO TO 999
C                                       Get range of rows.
      CALL OGET (INTAB, 'BCOUNT', TYPE, DIM, IDUM, CDUMMY, IERR)
      BC = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      BC = MIN (MAX (BC, 1), NROW)
      CALL OGET (INTAB, 'ECOUNT', TYPE, DIM, IDUM, CDUMMY, IERR)
      EC = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      IF (EC.LE.0) EC = NROW
C                                       Check array sizes
      IF ((EC-BC+1) .GT. MAXCC) THEN
         WRITE (MSGTXT,1000) EC-BC+1, MAXCC
         CALL MSGWRT (8)
         IERR = 5
         GO TO 999
         END IF
C                                       Filtering parameters
      CALL OGET (INTAB, 'RADIUS', TYPE, DIM, IDUM, CDUMMY, IERR)
      RADIUS = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'CUTOFF', TYPE, DIM, IDUM, CDUMMY, IERR)
      CUTOFF = RDUM(1)
      IF (IERR.NE.0) GO TO 999
C                                       Filter by magnitude?
      DOMAGN = CUTOFF.LT.0.0
      CUTOFF = ABS (CUTOFF)
C                                       Read table to internal arrays.
      NCC = 0
      SUMI = 0.0
      DO 100 IROW = BC,EC
         NCC = NCC + 1
         CALL CCTGET (INTAB, IROW, CCNCOL, XPOS(NCC), YPOS(NCC),
     *      ZPOS(NCC), FLUX(NCC), CCTYPE(NCC), PARMS(1,NCC), IERR)
         IF (IERR.GT.0) GO TO 999
C                                       Flagged?
         IF (IERR.LT.0) NCC = NCC - 1
         IF (IERR.EQ.0) SUMI = SUMI + FLUX(NCC)
 100     CONTINUE
C                                       Close Input
      CALL OCLOSE (INTAB, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Sum fluxes within RADIUS
      MXDIS = (RADIUS / 3600.0) ** 2
      DO 400 I = 1,NCC
         SUM = 0.0
         DO 300 J = 1,NCC
            DIS = (XPOS(I)-XPOS(J)) ** 2 + (YPOS(I)-YPOS(J)) ** 2
            IF (DIS.LE.MXDIS) SUM = SUM + FLUX(J)
 300        CONTINUE
         IF (DOMAGN) SUM = ABS (SUM)
         SFLUX(I) = SUM
 400     CONTINUE
C                                       Open output table
      CALL OCCINI (OUTTAB, 'WRIT', CCROW, CCNCOL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Write selected components
      OROW = 0
      SUMO = 0.0
      DO 500 IROW = 1,NCC
         IF (SFLUX(IROW).GT.CUTOFF) THEN
            OROW = OROW + 1
            CALL CCTPUT (OUTTAB, OROW, CCNCOL, XPOS(IROW), YPOS(IROW),
     *         ZPOS(IROW), FLUX(IROW), CCTYPE(IROW), PARMS(1,IROW),
     *         IERR)
            IF (IERR.GT.0) GO TO 999
            SUMO = SUMO + FLUX(IROW)
            END IF
 500     CONTINUE
C                                       Update number of rows
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      IDUM(1) = OROW
      CALL OPUT (OUTTAB, 'NROW', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (OUTTAB, 'VER', TYPE, DIM, IDUM, CDUMMY, IERR)
      OVER = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      WRITE (MSGTXT,1500) NCC, OROW, OVER
      CALL MSGWRT (4)
      WRITE (MSGTXT,1505) SUMI, SUMO
      CALL MSGWRT (4)
C                                       Close output
      CALL OCLOSE (OUTTAB, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TOO MANY COMPONENTS FOR INTERNAL ARRAYS:',I8,'>',I8)
 1500 FORMAT ('Read',I10,' comps, wrote',I10,' to version',I5)
 1505 FORMAT ('Read',F11.5,' Jy, wrote',F11.5)
      END
      SUBROUTINE CSELHI (OUTTAB)
C-----------------------------------------------------------------------
C   Routine to write history file to output table object.  This assumes
C   that a previous history exists and merely adds the information from
C   the current task.
C   Inputs:
C      OUTTAB  C*?  Output table object
C-----------------------------------------------------------------------
      CHARACTER OUTTAB*(*)
C
      INTEGER   NADV
      PARAMETER (NADV=9)
      CHARACTER LIST(NADV)*8
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'INVERS',
     *   'OUTVERS',  'BCOUNT' ,'ECOUNT', 'RADIUS', 'CUTOFF'/
C-----------------------------------------------------------------------
C                                       Add task label to history
      CALL OHTIME (OUTTAB, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy adverb values.
      CALL OHLIST ('Input', LIST, NADV, OUTTAB, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // OUTTAB
      CALL MSGWRT (4)
 999  RETURN
      END
      SUBROUTINE CCTGET (NAME, ROW, NC, X, Y, Z, FLUX, CCTYPE, PARMS,
     *   IERR)
C-----------------------------------------------------------------------
C   Get row from CC (CLEAN component) table object.
C   This assumes the structure of the CC table
C   Inputs:
C      NAME    C*?  CC table object name.
C      ROW     I    Row number
C   Output:
C      X       R    X coordinate
C      Y       R    Y coordinate
C      FLUX    R    Component flux density.
C      IERR    I    Return error code, 0=>OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   ROW, NC, CCTYPE, IERR
      REAL      X, Y, Z, FLUX, PARMS(3)
C
      INTEGER   CCRNO
C-----------------------------------------------------------------------
C                                       Read
      CCRNO = ROW
      CALL OTABCC (NAME, 'READ', CCRNO, NC, X, Y, Z, FLUX, CCTYPE,
     *   PARMS, IERR)
C
 999  RETURN
      END
      SUBROUTINE CCTPUT (NAME, ROW, NC, X, Y, Z, FLUX, CCTYPE, PARMS,
     *   IERR)
C-----------------------------------------------------------------------
C   Write row to CC (CLEAN component) table object.
C   This assumes the structure of the CC table
C   Inputs:
C      NAME    C*?  CC table object name.
C      ROW     I    Row number
C      X       R    X coordinate
C      Y       R    Y coordinate
C   Output:
C      IERR    I    Return error code, 0=>OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   ROW, NC, CCTYPE, IERR
      REAL      X, Y, Z, FLUX, PARMS(3)
C
      INTEGER   CCRNO
C-----------------------------------------------------------------------
C                                       Write
      CCRNO = ROW
      CALL OTABCC (NAME, 'WRIT', CCRNO, NC, X, Y, Z, FLUX, CCTYPE,
     *   PARMS, IERR)
C
 999  RETURN
      END

      SUBROUTINE QPUT (HOST, AP, N, TYPE)
C-----------------------------------------------------------------------
C! VMS Pseudo AP routine: Copy data from "host" to "AP" memory.
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   VMS version.
C   Transfer data from "Host" core into pseudo-AP  core, i.e. APCORE
C   Inputs:
C      HOST  R/I(*)  Data array in "host"
C      AP    I       Target area in AP; 0 - relative
C      N     I       Number of elements
C      TYPE  I       Data type:
C                    0   data is I   in host
C                    1   data is I   in host
C                    2   data is R   in host
C-----------------------------------------------------------------------
      REAL      HOST(*)
      INTEGER   AP, N, TYPE, I, JA, JC, LENGTH, LEN, NPASS, NLEFT, LOOP
      INTEGER*2 ILEN
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                       Check that type valid.
      IF (TYPE.GT.2) GO TO 999
C                                       Check for no data.
      IF (N.LE.0) GO TO 999
C                                       Deterimine data type
      IF (TYPE.EQ.1) THEN
C                                       Integer Values
         CALL QPUT2 (HOST, AP, N)
      ELSE
C                                       Real Values, Init block transfer
         LENGTH = 8191
         NLEFT = N
C                                       Send what is left if less than max
         LEN = MIN (NLEFT, LENGTH)
C                                       Calc Num. block transfers + a few.
         NPASS = (REAL(N) / REAL(LENGTH)) + 2.0
C                                       Start at the beginning of the blocks
         JA = 1
         JC = AP + 1
         DO 50 LOOP = 1,NPASS
C                                       Byte count is 4 times real value count
            ILEN = LEN * 4
            CALL LIB$MOVC3 (ILEN, HOST(JA), APCORE(JC))
            NLEFT = NLEFT - LEN
C                                       Exit if none left
            IF (NLEFT .LE. 0) GO TO 999
            JA = JA + LEN
            JC = JC + LEN
            LEN = MIN (NLEFT, LENGTH)
 50      CONTINUE
      ENDIF
C
 999  RETURN
      END

LOCAL INCLUDE 'STACK.INC'
      INCLUDE 'INCS:PMAD.INC'
      HOLLERITH XNAMIN(3), XCLSIN(2), XNMOUT(3), XCLOUT(2),
     *   XOPCOD(1), XINFIL(12)
      REAL      SEQIN, DSKIN, SEQ2IN, SEQOUT, DSKOUT, BLC(7), TRC(7)
      CHARACTER NAMIN*12, CLSIN*6, NAMOUT*12, CLSOUT*6, OPCODE*4,
     *   INFILE*48
      INTEGER   CATOLD(256), SEQ1, SEQ2, IVOL, ICNO, SEQO, OVOL, OCNO,
     *   LUN, IND, SCRTCH(256), IWIN(4), IVOL0, ICNO0
      REAL      RMAX, RMIN, RBUFF(MABFSS), WTS(32768)
      LOGICAL   WASBLK
C
      COMMON /INPARM/ XNAMIN, XCLSIN, SEQIN, DSKIN, SEQ2IN, XNMOUT,
     *   XCLOUT, SEQOUT, DSKOUT, BLC, TRC, XOPCOD, XINFIL
      COMMON /PSTACK/ SCRTCH, CATOLD, SEQ1, SEQ2, IVOL, ICNO, SEQO,
     *   OVOL, OCNO, LUN, IND, IWIN, IVOL0, ICNO0, RMAX, RMIN, WASBLK
      COMMON /BSTACK/ RBUFF, WTS
      COMMON /CSTACK/ NAMIN, CLSIN, NAMOUT, CLSOUT, OPCODE, INFILE
LOCAL END
      PROGRAM STACK
C-----------------------------------------------------------------------
C! Task to stack image planes
C# Map-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   STACK will do a weighted average of a number of images or planes of
C   one image cube.
C   Inputs:  (from AIPS)
C      INNAME    C*12   The file name for all input images
C      INCLASS   C*6    The file class of all input images
C      INSEQ     I      The sequence number of the first input image
C      INDISK    I      The disk volume number of the input images
C                       If zero all disks are searched for each sequence
C                       number
C      OUTNAME   C*12   The name of the output image file
C      OUTCLASS  C*6    The class of the output image file
C      OUTSEQ    I      The sequence number for the output image file
C      OUTDISK   I      The disk volume number for the output image
C      BLC       I(7)   The bottom left corner pixel coordinate
C      TRC       I(7)   The top right pixel coordinate
C      OPCODE    C*4    '    ' average INSEQ through IN2SEQ
C                       'CUBE' average planes BLC(3) through TRC(3)
C-----------------------------------------------------------------------
      INCLUDE 'STACK.INC'
      INTEGER   IRET, NX, NY, NZ, NWORDS, IERR
      CHARACTER PRGNAM*6
      LONGINT   PIMAGE, PWEIGH, PINPU
      REAL      IMAGE(2), WEIGHT(2), INPU(2)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA PRGNAM /'STACK'/
C-----------------------------------------------------------------------
C                                       init and create output file
      CALL STACKI (PRGNAM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       get memory
      NX = IWIN(3) - IWIN(1) + 1
      NY = IWIN(4) - IWIN(2) + 1
      IF (OPCODE.EQ.'MEDC') THEN
         NZ = TRC(3) - BLC(3) + 1.5
      ELSE IF (OPCODE.EQ.'MEDI') THEN
         NZ = SEQ2 - SEQ1 + 1
      ELSE
         NZ = 1
         ENDIF
      NWORDS = (NX * NY * NZ - 1) / 1024 + 3
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, IMAGE, PIMAGE, IRET)
      IF ((IRET.EQ.0) .AND. (NZ.EQ.1)) THEN
         CALL ZMEMRY ('GET ', TSKNAM, NWORDS, WEIGHT, PWEIGH, IRET)
         IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, INPU,
     *      PINPU, IRET)
         END IF
      IF (IRET.NE.0) THEN
         MSGTXT = 'FAILED TO GET NEEDED DYNAMIC MEMORY'
         CALL MSGWRT (8)
      ELSE IF (OPCODE.EQ.'MEDC') THEN
         CALL STACKM (NX, NY, NZ, IMAGE(1+PIMAGE), IRET)
      ELSE IF (OPCODE.EQ.'MEDI') THEN
         CALL STACKN (NX, NY, NZ, IMAGE(1+PIMAGE), IRET)
      ELSE IF (OPCODE.EQ.'CUBE') THEN
         CALL STACKC (NX, NY, INPU(1+PINPU), IMAGE(1+PIMAGE),
     *      WEIGHT(1+PWEIGH), IRET)
      ELSE
         CALL STACKS (NX, NY, INPU(1+PINPU), IMAGE(1+PIMAGE),
     *      WEIGHT(1+PWEIGH), IRET)
         END IF
C                                       history
      IF (IRET.EQ.0) CALL STACKH (NX, NY, NZ, IMAGE(1+PIMAGE),
     *   WEIGHT(1+PWEIGH), IRET)
C                                       Release AIPS if wait state.
 990  CALL ZMEMRY ('FRAL', TSKNAM, NWORDS, IMAGE, PIMAGE, IERR)
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE STACKI (PRGNAM, IRET)
C-----------------------------------------------------------------------
C   Init the task and crete the output image
C   Inputs:
C      PRGNAM   C*6   Task name
C   Outputs:
C      IRET     I     Error code: > 0 => quit
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*(*)
      INTEGER   IRET
C
      INCLUDE 'STACK.INC'
      INTEGER   INPRMS, IERR, IROUND, IUSER, I, J, JTRIM, TXLUN, TXIND,
     *   KBP
      CHARACTER MTYPE*2, CBLANK*6, LINE*72
      DOUBLE PRECISION X
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA CBLANK /' '/
C-----------------------------------------------------------------------
C                                       Initialize the I/O parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NCFILE = 0
      NSCR = 0
C                                       Get input values from AIPS.
      INPRMS = 42
      CALL GTPARM (PRGNAM, INPRMS, RQUICK, XNAMIN, SCRTCH, IERR)
      IRET = IERR
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'GETTING ADVERBS FROM AIPS'
         CALL MSGWRT (7)
         END IF
C
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 8
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
      CALL H2CHR (12, 1, XNMOUT, NAMOUT)
      CALL H2CHR (6, 1, XCLOUT, CLSOUT)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      CALL H2CHR (48, 1, XINFIL, INFILE)
C                                       Set initial values.
      SEQ1 = IROUND (SEQIN)
      SEQ2 = IROUND (SEQ2IN)
      IVOL = IROUND (DSKIN)
      SEQO = IROUND (SEQOUT)
      OVOL = IROUND (DSKOUT)
      IUSER = NLUSER
      LUN = 17
C                                       Open source file.
      MTYPE = 'MA'
      CALL MAPOPN ('READ', IVOL, NAMIN, CLSIN, SEQ1, MTYPE, IUSER,
     *   LUN, IND, ICNO, CATOLD, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING FIRST INPUT FILE'
         GO TO 990
         END IF
      NCFILE = 2
      FVOL(NCFILE) = IVOL
      FCNO(NCFILE) = ICNO
      FRW(NCFILE) = 0
      IVOL0 = IVOL
      ICNO0 = ICNO
C                                       Copy to output header
      CALL COPY (256, CATOLD, CATBLK)
C                                       Set default values BLC, TRC.
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'SETTING INPUT IMAGE WINDOW'
         GO TO 990
         END IF
      IF ((OPCODE.EQ.'CUBE')  .OR. (OPCODE.EQ.'MEDC')) THEN
         SEQ2 = IROUND (TRC(3))
         CALL RCOPY (4, BLC(4), TRC(4))
      ELSE
         CALL RCOPY (5, BLC(3), TRC(3))
         END IF
      I = SEQ2 - SEQ1 + 1
      IF (I.LT.2) THEN
         MSGTXT = 'YOU HAVE NOT ASKED TO AVERAGE ANYTHING'
         GO TO 990
         END IF
      CALL RFILL (I, 0.0, WTS)
C                                       Build new file cat name.
      CALL MAKOUT (NAMIN, CLSIN, SEQ1, CBLANK, NAMOUT, CLSOUT, SEQO)
C                                       Set header values needed
C                                       by MCREAT.
      CALL SUBHDR (BLC, TRC, 1.0, 1.0)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLSOUT, KHIMCO, CATH(KHIMC))
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
      CATBLK(KIIMS) = SEQO
C                                       Create new cataloged file.
      CALL MCREAT (OVOL, OCNO, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CREATING OUTPUT FILE'
         GO TO 990
         END IF
      SEQO = CATBLK(KIIMS)
      FVOL(1) = OVOL
      FCNO(1) = OCNO
      FRW(1) = 2
C                                       do not Copy header keywords
      IWIN(1) = IROUND (BLC(1))
      IWIN(2) = IROUND (BLC(2))
      IWIN(3) = IROUND (TRC(1))
      IWIN(4) = IROUND (TRC(2))
      RMAX = -1.E12
      RMIN = 1.E12
      WASBLK = .FALSE.
C                                       image weights
      IF (INFILE.NE.' ') THEN
         TXLUN = 3
         CALL ZTXOPN ('READ', TXLUN, TXIND, INFILE, .FALSE., IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPENING TEXT FILE'
            GO TO 990
            END IF
         I = 0
 20      CALL ZTXIO ('READ', TXLUN, TXIND, LINE, IERR)
         IF (IERR.EQ.0) THEN
            J = JTRIM (LINE)
            IF ((J.GT.0) .AND. (LINE(:1).NE.'#')) THEN
               KBP = 1
               CALL GETNUM (LINE, J, KBP, X)
               IF (X.NE.DBLANK) THEN
                  I = I + 1
                  WTS(I) = X
                  END IF
               END IF
            GO TO 20
         ELSE IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1000) IERR, 'READING TEXT FILE'
            GO TO 990
            END IF
         CALL ZTXCLS (TXLUN, TXIND, IERR)
         END IF
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('STACKI ERROR',I4,' ON A',A)
      END
      SUBROUTINE STACKC (NX, NY, IMAGE, SUM, WEIGHT, IRET)
C-----------------------------------------------------------------------
C   Stacks over BLC(3) to TRC(3)
C   Inputs:
C      NX       I      Number X pixels in usable image plane
C      NY       I      Number Y pixels in usable image plane
C   Outputs:
C      IMAGE    R(*)   Work memory for input images
C      SUM      R(*)   Output mean image
C      WEIGHT   R(*)   Work memory for sum weights
C      IRET     I      > 0 => failure
C-----------------------------------------------------------------------
      INTEGER   NX, NY, IRET
      REAL      IMAGE(NX,NY), SUM(NX,NY), WEIGHT(NX,NY)
C
      INCLUDE 'STACK.INC'
C
      REAL      VALUE, GVALUE
      INTEGER   IBLKOF, IDEPTH(5), I, IBIND, NBY, NPTS, NUMKEY, KEYTYP,
     *   LOCS, MSGSAV, IROUND, IUSER, IX, IY, IP, IP1, IP2
      CHARACTER KEYWRD*8
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
      MSGSAV = MSGSUP
      NBY = 2 * MABFSS
      IUSER = NLUSER
C                                       header value?
      NUMKEY = 1
      KEYWRD = 'ACTNOISE'
      MSGSUP = 32000
      CALL CATKEY ('READ', IVOL, ICNO, KEYWRD, NUMKEY, LOCS, GVALUE,
     *   KEYTYP, SCRTCH, IRET)
      MSGSUP = MSGSAV
      IF (IRET.NE.0) GVALUE = 0.0
C                                       Init values for loop.
      NPTS = NX * NY
      CALL RFILL (NPTS, 0.0, SUM)
      CALL RFILL (NPTS, 0.0, WEIGHT)
      IP1 = IROUND (BLC(3))
      IP2 = IROUND (TRC(3))
      IDEPTH(1) = IROUND (BLC(3))
      IDEPTH(2) = IROUND (BLC(4))
      IDEPTH(3) = IROUND (BLC(5))
      IDEPTH(4) = IROUND (BLC(6))
      IDEPTH(5) = IROUND (BLC(7))
C                                       Loop for all possible planes.
      DO 100 IP = IP1,IP2
         IDEPTH(1) = IP
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IDEPTH, IBLKOF,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         IBLKOF = IBLKOF + 1
C
         CALL MINIT ('READ', LUN, IND, CATOLD(KINAX), CATOLD(KINAX+1),
     *      IWIN, RBUFF, NBY, IBLKOF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT I/O FOR INPUT PLANE', IP
            CALL MSGWRT (7)
            GO TO 999
            END IF
C                                       read input plane
         DO 20 IY = 1,NY
            CALL MDISK ('READ', LUN, IND, RBUFF, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING INPUT PLANE', IP
               GO TO 990
               END IF
            CALL RCOPY (NX, RBUFF(IBIND), IMAGE(1,IY))
 20         CONTINUE
C                                       find a weight
         I = IP - IP1 + 1
         IF (WTS(I).LE.0.0) THEN
            CALL GETRMS (NX, NY, IMAGE, VALUE)
            IF (VALUE.LE.0.0) VALUE = GVALUE
            IF (VALUE.LE.0.0) THEN
               WRITE (MSGTXT,1020) IP
               CALL MSGWRT (7)
               GO TO 100
               END IF
            WTS(I) = 1.0 / (VALUE * VALUE)
            END IF
C                                       sum into SUM and WEIGHT
         DO 50 IY = 1,NY
            DO 40 IX = 1,NX
               IF (IMAGE(IX,IY).NE.FBLANK) THEN
                  SUM(IX,IY) = SUM(IX,IY) + WTS(I) * IMAGE(IX,IY)
                  WEIGHT(IX,IY) = WEIGHT(IX,IY) + WTS(I)
                  END IF
 40            CONTINUE
 50         CONTINUE
 100     CONTINUE
C                                       close inout file
      CALL MAPCLS ('READ', IVOL, ICNO, LUN, IND, CATOLD, .FALSE.,
     *   SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSE INPUT IMAGE'
         GO TO 990
         END IF
      NCFILE = NCFILE - 1
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('STACKC ERROR:',I5,' ON ',A,I6)
 1020 FORMAT ('STACKC PLANE=',I6,' NO WEIGHT FOUND')
      END
      SUBROUTINE STACKS (NX, NY, IMAGE, SUM, WEIGHT, IRET)
C-----------------------------------------------------------------------
C   Stacks over INSEQ to IN2SEQ
C   Inputs:
C      NX       I      Number X pixels in usable image plane
C      NY       I      Number Y pixels in usable image plane
C   Outputs:
C      IMAGE    R(*)   Work memory for input images
C      SUM      R(*)   Output mean image
C      WEIGHT   R(*)   Work memory for sum weights
C      IRET     I      > 0 => failure
C-----------------------------------------------------------------------
      INTEGER   NX, NY, IRET
      REAL      IMAGE(NX,NY), SUM(NX,NY), WEIGHT(NX,NY)
C
      INCLUDE 'STACK.INC'
C
      REAL      VALUE
      INTEGER   IBLKOF, IDEPTH(5), I, IBIND, NBY, NPTS, NUMKEY, KEYTYP,
     *   LOCS, MSGSAV, IROUND, IUSER, IX, IY, ISEQ
      CHARACTER KEYWRD*8, MTYPE*2
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
      MSGSAV = MSGSUP
      NBY = 2 * MABFSS
      IUSER = NLUSER
C
      NPTS = NX * NY
C                                       Init values for loop.
      CALL RFILL (NPTS, 0.0, SUM)
      CALL RFILL (NPTS, 0.0, WEIGHT)
      IDEPTH(1) = IROUND (BLC(3))
      IDEPTH(2) = IROUND (BLC(4))
      IDEPTH(3) = IROUND (BLC(5))
      IDEPTH(4) = IROUND (BLC(6))
      IDEPTH(5) = IROUND (BLC(7))
C                                       Loop for all possible planes.
      DO 100 ISEQ = SEQ1,SEQ2
         IF (ISEQ.NE.SEQ1) THEN
            MTYPE = 'MA'
            IVOL = DSKIN
            CALL MAPOPN ('READ', IVOL, NAMIN, CLSIN, ISEQ, MTYPE, IUSER,
     *         LUN, IND, ICNO, CATOLD, SCRTCH, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'OPENING INPUT FILE', ISEQ
               IF (IRET.NE.3) GO TO 990
               WRITE (MSGTXT,1010) ISEQ
               CALL MSGWRT (7)
               IRET = 0
               GO TO 100
               END IF
            NCFILE = NCFILE + 1
            FVOL(NCFILE) = IVOL
            FCNO(NCFILE) = ICNO
            FRW(NCFILE) = 0
            END IF
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IDEPTH, IBLKOF,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         IBLKOF = IBLKOF + 1
C
         CALL MINIT ('READ', LUN, IND, CATOLD(KINAX), CATOLD(KINAX+1),
     *      IWIN, RBUFF, NBY, IBLKOF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT I/O FOR INPUT FILE', ISEQ
            CALL MSGWRT (7)
            GO TO 999
            END IF
C                                       read input plane
         DO 20 IY = 1,NY
            CALL MDISK ('READ', LUN, IND, RBUFF, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING INPUT IMAGE', ISEQ
               GO TO 990
               END IF
            CALL RCOPY (NX, RBUFF(IBIND), IMAGE(1,IY))
 20         CONTINUE
C                                       find a weight
         I = ISEQ - SEQ1 + 1
         IF (WTS(I).LE.0.0) THEN
C                                       header value?
            NUMKEY = 1
            KEYWRD = 'ACTNOISE'
            MSGSUP = 32000
            CALL CATKEY ('READ', IVOL, ICNO, KEYWRD, NUMKEY, LOCS,
     *         VALUE, KEYTYP, SCRTCH, IRET)
            MSGSUP = MSGSAV
            IF ((IRET.NE.0) .OR. (VALUE.LE.0.0)) CALL GETRMS (NX, NY,
     *         IMAGE, VALUE)
            IF (VALUE.LE.0.0) THEN
               WRITE (MSGTXT,1020) ISEQ
               CALL MSGWRT (7)
               GO TO 90
               END IF
            WTS(I) = 1.0 / (VALUE * VALUE)
            END IF
C                                       sum into SUM and WEIGHT
         DO 50 IY = 1,NY
            DO 40 IX = 1,NX
               IF (IMAGE(IX,IY).NE.FBLANK) THEN
                  SUM(IX,IY) = SUM(IX,IY) + WTS(I) * IMAGE(IX,IY)
                  WEIGHT(IX,IY) = WEIGHT(IX,IY) + WTS(I)
                  END IF
 40            CONTINUE
 50         CONTINUE
C                                       close inout file
 90      CALL MAPCLS ('READ', IVOL, ICNO, LUN, IND, CATOLD, .FALSE.,
     *      SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSE INPUT IMAGE', ISEQ
            GO TO 990
            END IF
         NCFILE = NCFILE - 1
 100     CONTINUE
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('STACKS ERROR:',I5,' ON ',A,I6)
 1010 FORMAT ('STACKS INSEQ=',I6,' NOT FOUND')
 1020 FORMAT ('STACKS INSEQ=',I6,' NO WEIGHT FOUND')
      END
      SUBROUTINE GETRMS (NX, NY, IMAGE, RMS)
C-----------------------------------------------------------------------
C   Robust RMS determination on an image plane
C   Inputs:
C      NX      I      Number X pixels in IMAGE
C      NY      I      Number Y pixels in IMAGE
C      IMAGE   R(*)   Image values
C   Outputs:
C      RMS     R      Image true RMS (0 -> failed)
C-----------------------------------------------------------------------
      INTEGER   NX, NY
      REAL      IMAGE(*), RMS
C
      INTEGER   NITER
      PARAMETER (NITER=8)
C
      INTEGER   NP, IT, IP
      REAL      WS(NITER), VP, VM
      DOUBLE PRECISION SV, SSV, NV
      INCLUDE 'INCS:DDCH.INC'
      DATA WS /5.0, 4.0, 3.5, 3.0, 2.7, 2.6, 2.5, 3.5/
C-----------------------------------------------------------------------
C                                       ROBUST mean, rms
      NP = NX * NY
      VP = 1.E5
      VM = -VP
      DO 120 IT = 1,NITER
         SV = 0.0D0
         SSV = 0.0D0
         NV = 0.0D0
         DO 110 IP = 1,NP
            IF ((IMAGE(IP).NE.FBLANK) .AND. (IMAGE(IP).NE.0.0)) THEN
               IF ((IMAGE(IP).GT.VM) .AND. (IMAGE(IP).LT.VP)) THEN
                  SV = SV + IMAGE(IP)
                  SSV = SSV + IMAGE(IP) * IMAGE(IP)
                  NV = NV + 1.0D0
                  END IF
               END IF
 110        CONTINUE
         IF (NV.GT.0.0D0) THEN
            SV = SV / NV
            SSV = SSV / NV - SV * SV
            SSV = SQRT (MAX (0.0D0, SSV))
            IF (IT.LT.NITER) THEN
               VP = SV + WS(IT+1) * SSV
               VM = SV - WS(IT+1) * SSV
               END IF
         ELSE
            VP = 1.E4
            VM = -1.E4
            END IF
 120     CONTINUE
      RMS = SSV
C
 999  RETURN
      END
      SUBROUTINE STACKN (NX, NY, NZ, IMAGE, IRET)
C-----------------------------------------------------------------------
C   Stacks over INSEQ to IN2SEQ
C   Inputs:
C      NX       I      Number X pixels in usable image plane
C      NY       I      Number Y pixels in usable image plane
C      NZ       I      Number Z pixels in usable image cube
C   Outputs:
C      IMAGE    R(*)   Work memory for input images
C                      first planeis output image
C      IRET     I      > 0 => failure
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, IRET
      REAL      IMAGE(NX,NY,*)
C
      INCLUDE 'STACK.INC'
C
      REAL      MEDIAN
      INTEGER   IBLKOF, IDEPTH(5), I, IBIND, NBY, NPTS, MSGSAV, IROUND,
     *   IUSER, IX, IY, IZ, ISEQ, IS
      CHARACTER MTYPE*2
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
      MSGSAV = MSGSUP
      NBY = 2 * MABFSS
      IUSER = NLUSER
C
      NPTS = NX * NY * NZ
      CALL RFILL (NPTS, FBLANK, IMAGE)
C                                       Init values for loop.
      IDEPTH(1) = IROUND (BLC(3))
      IDEPTH(2) = IROUND (BLC(4))
      IDEPTH(3) = IROUND (BLC(5))
      IDEPTH(4) = IROUND (BLC(6))
      IDEPTH(5) = IROUND (BLC(7))
C                                       Loop for all possible planes.
      DO 30 ISEQ = SEQ1,SEQ2
         IF (ISEQ.NE.SEQ1) THEN
            MTYPE = 'MA'
            IVOL = DSKIN
            CALL MAPOPN ('READ', IVOL, NAMIN, CLSIN, ISEQ, MTYPE, IUSER,
     *         LUN, IND, ICNO, CATOLD, SCRTCH, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'OPENING INPUT FILE', ISEQ
               IF (IRET.NE.3) GO TO 990
               WRITE (MSGTXT,1010) ISEQ
               CALL MSGWRT (7)
               IRET = 0
               GO TO 30
               END IF
            NCFILE = NCFILE + 1
            FVOL(NCFILE) = IVOL
            FCNO(NCFILE) = ICNO
            FRW(NCFILE) = 0
            END IF
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IDEPTH, IBLKOF,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         IBLKOF = IBLKOF + 1
C
         CALL MINIT ('READ', LUN, IND, CATOLD(KINAX), CATOLD(KINAX+1),
     *      IWIN, RBUFF, NBY, IBLKOF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT I/O FOR INPUT FILE', ISEQ
            CALL MSGWRT (7)
            GO TO 999
            END IF
C                                       read input plane
         IS = ISEQ - SEQ1 + 1
         DO 20 IY = 1,NY
            CALL MDISK ('READ', LUN, IND, RBUFF, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING INPUT IMAGE', ISEQ
               GO TO 990
               END IF
            CALL RCOPY (NX, RBUFF(IBIND), IMAGE(1,IY,IS))
 20         CONTINUE
C                                       close inout file
         CALL MAPCLS ('READ', IVOL, ICNO, LUN, IND, CATOLD, .FALSE.,
     *      SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSE INPUT IMAGE', ISEQ
            GO TO 990
            END IF
         NCFILE = NCFILE - 1
 30      CONTINUE
C                                       do medians
      DO 100 IY = 1,NY
         DO 90 IX = 1,NX
            I = 0
            DO 80 IZ = 1,NZ
               IF (IMAGE(IX,IY,IZ).NE.FBLANK) THEN
                  I = I + 1
                  RBUFF(I) = IMAGE(IX,IY,IZ)
                  END IF
 80            CONTINUE
            IF (I.LE.0) THEN
               IMAGE(IX,IY,1) = FBLANK
            ELSE
               IMAGE(IX,IY,1) = MEDIAN (I, RBUFF)
               END IF
 90         CONTINUE
 100     CONTINUE
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('STACKN ERROR:',I5,' ON ',A,I6)
 1010 FORMAT ('STACKN INSEQ=',I6,' NOT FOUND')
      END
      SUBROUTINE STACKM (NX, NY, NZ, IMAGE, IRET)
C-----------------------------------------------------------------------
C   Stacks over BLC(3) to TRC(3) to find median
C   Inputs:
C      NX       I      Number X pixels in usable image plane
C      NY       I      Number Y pixels in usable image plane
C      NZ       I      Number of planes to be read and used
C   Outputs:
C      IMAGE    R(*)   Work memory for input images: first plane is
C                      output median
C      IRET     I      > 0 => failure
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, IRET
      REAL      IMAGE(NX,NY,NZ)
C
      INCLUDE 'STACK.INC'
C
      INTEGER   IBLKOF, IDEPTH(5), I, IBIND, NBY, NPTS, MSGSAV, IROUND,
     *   IUSER, IX, IY, IZ, IP, IP1, IP2, IPL
      REAL      MEDIAN
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
      MSGSAV = MSGSUP
      NBY = 2 * MABFSS
      IUSER = NLUSER
C                                       Init values for loop.
      NPTS = NX * NY * NZ
      CALL RFILL (NPTS, FBLANK, IMAGE)
      IP1 = IROUND (BLC(3))
      IP2 = IROUND (TRC(3))
      IDEPTH(1) = IROUND (BLC(3))
      IDEPTH(2) = IROUND (BLC(4))
      IDEPTH(3) = IROUND (BLC(5))
      IDEPTH(4) = IROUND (BLC(6))
      IDEPTH(5) = IROUND (BLC(7))
C                                       Loop for all possible planes.
      DO 30 IP = IP1,IP2
         IPL = IP - IP1 +1
         IDEPTH(1) = IP
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IDEPTH, IBLKOF,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         IBLKOF = IBLKOF + 1
C
         CALL MINIT ('READ', LUN, IND, CATOLD(KINAX), CATOLD(KINAX+1),
     *      IWIN, RBUFF, NBY, IBLKOF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT I/O FOR INPUT PLANE', IP
            CALL MSGWRT (7)
            GO TO 999
            END IF
C                                       read input plane
         DO 20 IY = 1,NY
            CALL MDISK ('READ', LUN, IND, RBUFF, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING INPUT PLANE', IP
               GO TO 990
               END IF
            CALL RCOPY (NX, RBUFF(IBIND), IMAGE(1,IY,IPL))
 20         CONTINUE
 30      CONTINUE
C                                       close inout file
      CALL MAPCLS ('READ', IVOL, ICNO, LUN, IND, CATOLD, .FALSE.,
     *   SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSE INPUT IMAGE'
         GO TO 990
         END IF
      NCFILE = NCFILE - 1
C                                       do medians
      DO 100 IY = 1,NY
         DO 90 IX = 1,NX
            I = 0
            DO 80 IZ = 1,NZ
               IF (IMAGE(IX,IY,IZ).NE.FBLANK) THEN
                  I = I + 1
                  RBUFF(I) = IMAGE(IX,IY,IZ)
                  END IF
 80            CONTINUE
            IF (I.LE.0) THEN
               IMAGE(IX,IY,1) = FBLANK
            ELSE
               IMAGE(IX,IY,1) = MEDIAN (I, RBUFF)
               END IF
 90         CONTINUE
 100     CONTINUE
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('STACKM ERROR:',I5,' ON ',A,I6)
      END
      SUBROUTINE STACKH (NX, NY, NZ, IMAGE, WEIGHT, IRET)
C-----------------------------------------------------------------------
C   normalizes image and outputs it, copies tables, writes history
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, IRET
      REAL      IMAGE(NX,*), WEIGHT(NX,*)
C
      INCLUDE 'STACK.INC'
C
      INTEGER   IH1LUN, IH2LUN, NFILES, IERR, LUNTMP, IX, IY, IBIND,
     *   JBUFSZ, IBLC(7), ITRC(7), IWTS(32768), I, I1, I2
      CHARACTER HILINE*72, PHNAME*48
      LOGICAL   T
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (WTS, IWTS)
      DATA IH1LUN, IH2LUN /27, 28/
      DATA NFILES /2/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       normalize the image
      IF (NZ.LE.1) THEN
         DO 20 IY = 1,NY
            DO 10 IX = 1,NX
               IF (WEIGHT(IX,IY).LE.0.0) THEN
                  WASBLK = .TRUE.
                  IMAGE(IX,IY) = FBLANK
               ELSE
                  IMAGE(IX,IY) = IMAGE(IX,IY) / WEIGHT(IX,IY)
                  RMIN = MIN (RMIN, IMAGE(IX,IY))
                  RMAX = MAX (RMAX, IMAGE(IX,IY))
                  END IF
 10            CONTINUE
 20         CONTINUE
      ELSE
         DO 40 IY = 1,NY
            DO 30 IX = 1,NX
               IF (IMAGE(IX,IY).EQ.FBLANK) THEN
                  WASBLK = .TRUE.
               ELSE
                  RMIN = MIN (RMIN, IMAGE(IX,IY))
                  RMAX = MAX (RMAX, IMAGE(IX,IY))
                  END IF
 30            CONTINUE
 40         CONTINUE
         END IF
C                                       check and update header
      IRET = 10
      IF (RMAX.EQ.RMIN) THEN
         WRITE (MSGTXT,1020) RMAX
         GO TO 990
      ELSE IF (RMAX.LT.RMIN) THEN
         MSGTXT = 'NO VALID PIXELS FOUND'
         GO TO 990
         END IF
      CATR(KRDMN) = RMIN
      CATR(KRDMX) = RMAX
      CATR(KRBLK) = 0.0
      IF (WASBLK) CATR(KRBLK) = FBLANK
C                                       open the IO
      JBUFSZ = 2 * MABFSS
      CALL ZPHFIL ('MA', OVOL, OCNO, 1, PHNAME, IRET)
      LUN = LUNTMP (0)
      CALL ZOPEN (LUN, IND, OVOL, PHNAME, T, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT IMAGE FILE'
         GO TO 990
         END IF
      IWIN(1) = 1
      IWIN(2) = 1
      IWIN(3) = NX
      IWIN(4) = NY
      CALL MINIT ('WRIT', LUN, IND, NX, NY, IWIN, RBUFF, JBUFSZ, 1,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT I/O TO OUTPUT IMAGE'
         GO TO 990
         END IF
      DO 50 IY = 1,NY
         CALL MDISK ('WRIT', LUN, IND, RBUFF, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE ROW OF OUTPUT IMAGE'
            GO TO 990
            END IF
         CALL RCOPY (NX, IMAGE(1,IY), RBUFF(IBIND))
 50      CONTINUE
      CALL MDISK ('FINI', LUN, IND, RBUFF, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE LAST ROW OF OUTPUT IMAGE'
         GO TO 990
         END IF
      CALL ZCLOSE (LUN, IND, IRET)
      FRW(1) = 1
C                                       Initialize HITAB
      CALL HIINIT (NFILES)
C                                       Create and copy history file.
      CALL HISCOP (IH1LUN, IH2LUN, IVOL0, OVOL, ICNO0, OCNO, CATBLK,
     *   SCRTCH, RBUFF, IERR)
      IF (IERR.GT.3) GO TO 300
      IF (IERR.EQ.3) GO TO 290
C                                       Add STACK history.
      CALL HENCO1 (TSKNAM, NAMIN, CLSIN, SEQ1, IVOL0, IH2LUN, RBUFF,
     *   IERR)
      IF (IERR.NE.0) GO TO 290
      CALL HENCOO (TSKNAM, NAMOUT, CLSOUT, SEQO, OVOL, IH2LUN, RBUFF,
     *   IERR)
      IF (IERR.NE.0) GO TO 290
      DO 200 I = 1,7
         IBLC(I) = BLC(I) + 0.1
         ITRC(I) = TRC(I) + 0.1
 200     CONTINUE
      WRITE (HILINE,1211) IBLC
      CALL HIADD (IH2LUN, HILINE, RBUFF, IERR)
      IF (IERR.NE.0) GO TO 290
      WRITE (HILINE,1212) ITRC
      CALL HIADD (IH2LUN, HILINE, RBUFF, IERR)
      IF (IERR.NE.0) GO TO 290
      IF (OPCODE.EQ.'CUBE') THEN
         WRITE (HILINE,1213) OPCODE
         IX = ITRC(3) - IBLC(3) + 1
      ELSE
         WRITE (HILINE,1214) SEQ2
         IX = SEQ2 - SEQ1 + 1
         END IF
      CALL HIADD (IH2LUN, HILINE, RBUFF, IERR)
      IF (IERR.NE.0) GO TO 290
C                                       normalize weights
      IF (NZ.LE.1) THEN
         RMAX = 0.0
         DO 210 I = 1,IX
            RMAX = MAX (RMAX, WTS(I))
 210        CONTINUE
         RMAX = 9999.0 / RMAX
         DO 220 I = 1,IX
            IWTS(I) = WTS(I) * RMAX + 0.5
 220        CONTINUE
         I2 = 0
 230     I1 = I2 + 1
         I2 = I1 + 8
         I2 = MIN (I2, IX)
         IF (I2.GE.I1) THEN
            WRITE (HILINE,1230) I1, I2, (IWTS(I), I = I1,I2)
            CALL HIADD (IH2LUN, HILINE, RBUFF, IERR)
            IF (IERR.NE.0) GO TO 290
            GO TO 230
            END IF
         END IF
C
 290  CALL HICLOS (IH2LUN, .TRUE., RBUFF, IERR)
C                                       Copy no files
 300  IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('STACKH ERROR',I5,' AT ',A)
 1020 FORMAT ('STACKH IMAGE CONSTANT AT',1PE12.4)
 1211 FORMAT ('STACK BLC    =',2(I5,','),4(I5,','),I5)
 1212 FORMAT ('STACK TRC    =',2(I5,','),4(I5,','),I5)
 1213 FORMAT ('STACK OPCODE = ''',A,'''')
 1214 FORMAT ('STACK IN2SEQ =',I6)
 1230 FORMAT ('STACK WTS(',I5,',',I5,') =',9I5)
      END

      SUBROUTINE IOBSRC (IA1, IA2, GOT)
C-----------------------------------------------------------------------
C! Search for antennas in the current bandpass buffer.
C# UV Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2005
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to search an index array set up by BPGET for the
C   presence of antennae in an I/O buffer
C   Inputs:
C      IA1      I        Antenna 1
C      IA2      I        Antenna 2
C   Outputs:
C      GOT      L(2,3)   If true antenna is present, if (*,2) true,
C                        antenna is present twice.
C   From common
C      ANTNX    LI(3,*)  Index array contains 1 or 2 pointers for each
C                        antenna, if pointer = 0 antenna not present 1
C                        or 2 times.  Pointer is to time (vis 2 later).
C   To common
C      ANTPNT   LI(2,3)  Final index array to vis array skipping time
C                        and antenna elements.
C      BPGOT    I(2,3)   Antenna numbers
C-----------------------------------------------------------------------
      INTEGER   IA1, IA2
      LOGICAL   GOT(2,*)
C
      INTEGER   I, J
      LOGICAL   T, F
      INCLUDE 'INCS:DBPC.INC'
      DATA T, F /.TRUE., .FALSE./
C-----------------------------------------------------------------------
C                                       init all pointers
      DO 20 J = 1,3
         DO 10 I = 1,2
            BPGOT(I,J) = 0
            ANTPNT(I,J) = 0
            GOT(I,J) = F
 10         CONTINUE
 20      CONTINUE
C                                       set them if there are data
      DO 40 I = 1,NANTBP
         IF ((I.EQ.IA1) .OR. (I.EQ.IA2)) THEN
            DO 30 J = 1,3
               IF (ANTNX(J,I).NE.0) THEN
                  IF (I.EQ.IA1) THEN
                     GOT(1,J) = T
                     BPGOT(1,J) = IA1
                     ANTPNT(1,J) = ANTNX(J,I) + 2
                     END IF
                  IF (I.EQ.IA2) THEN
                     GOT(2,J) = T
                     BPGOT(2,J) = IA2
                     ANTPNT(2,J) = ANTNX(J,I) + 2
                     END IF
                  END IF
 30            CONTINUE
            END IF
 40      CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'PUVGIT.INC'
C                                       Local include for UVGIT
      INTEGER   XMXVIS, XMXPRM, XMXCMP
C                                       XMXVIS = max. no. vis records.
      PARAMETER (XMXVIS=2500000)
C                                       XMXCMP = max. no sources
      PARAMETER (XMXCMP=60)
C                                       XMXPRM = max. no parameters.
      PARAMETER (XMXPRM=6*XMXCMP+30)
LOCAL END
LOCAL INCLUDE 'UVGIT.INC'
C                                       Local include for UVGIT
      INCLUDE 'PUVGIT.INC'
C
      INTEGER   SEQIN, DISKIN, NGAUSS, NITER, CCVER, CHAN, NPR,
     *   CNO
      LOGICAL   DOAMP, DOREAL
      INTEGER   NUMVIS, MAXVIS, NANT, SCRTCH(512)
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4), XXSOLM(1),
     *   XOPCOD(1), XXSTOK(1), XINLIS(12), XFITOU(12)
      CHARACTER NAMEIN*12, CLAIN*6, XSOUR*16, XSOLMO*4, OPCODE*4,
     *   XSTOK*4, INLIST*48, FITOUT*48, COMNTS(XMXCMP)*256
      REAL      XSIN, XDISIN, XBCHAN, XECHAN, XBIF, XEIF, XBAND, XFREQ,
     *   XFQID, XANTS(50), XSUBA, XTIME(8), XDOCAL, XGUSE, XDOPOL,
     *   XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH(3), XUVRA(2),
     *   XNGAU, DMAX(4), DPOS(2,4), DWIDTH(3,4), GAINE(30), XNIT, EDROP,
     *   DDMAX(4), DDPOS(2,4), DDWID(3,4), SIZE(2), PRTL, DOCAT, XNVER,
     *   TLOW, THIGH, BADD(10)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN,
     *   XBCHAN, XECHAN, XBIF, XEIF, XXSTOK, XBAND, XFREQ, XFQID,
     *   XXSOUR, XANTS, XSUBA, XTIME, XDOCAL, XGUSE, XDOPOL, XPDVER,
     *   XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH, XUVRA, XXSOLM, XOPCOD,
     *   XNGAU, DMAX, DPOS, DWIDTH, GAINE, XNIT, EDROP, DDMAX, DDPOS,
     *   DDWID, XINLIS, SIZE, PRTL, DOCAT, XNVER, XFITOU, BADD
      COMMON /INFO/ SCRTCH, NUMVIS, MAXVIS, NANT, DOAMP, DOREAL, SEQIN,
     *   DISKIN, NGAUSS, NITER, CCVER, CHAN, CNO, NPR, TLOW, THIGH
      COMMON /CHRCOM/ NAMEIN, CLAIN, XSOUR, XSOLMO, OPCODE, XSTOK,
     *   INLIST, FITOUT, COMNTS
LOCAL END
LOCAL INCLUDE 'DUVGIT.INC'
      INCLUDE 'PUVGIT.INC'
      DOUBLE PRECISION LPARMS(XMXPRM), CHISQ, RMSRES
      INTEGER   NVAR, MODPNT(6,XMXCMP), GAPNT(30), IANT1(XMXVIS),
     *   IANT2(XMXVIS), IVAR(XMXPRM), JVAR(XMXPRM), ITTER, NUMDAT, MINC
      REAL      GAIN(30), U(XMXVIS), V(XMXVIS), W(XMXVIS), RE(XMXVIS),
     *   IM(XMXVIS), WT(XMXVIS), GPARMS(6,XMXCMP), DOCOMP(6,XMXCMP)
      COMMON /UVDATA/ LPARMS, CHISQ, RMSRES, GAIN, U, V, W, RE, IM, WT,
     *   GPARMS, DOCOMP, MODPNT, GAPNT, IANT1, IANT2, IVAR, JVAR, NVAR,
     *   ITTER, NUMDAT, MINC
LOCAL END
      PROGRAM UVGIT
C-----------------------------------------------------------------------
C! Fits source models to uv data.
C# UV Modeling Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2016, 2018, 2020, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVGIT fits a model consisting of a collection of elliptical
C   gaussians or uniform optical spheres to uv data.
C   The results can optionally be written as a CLEAN components file.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input UV data.
C      BCHAN          BCHAN         1st channel number
C      ECHAN          ECHAN         Highest channel number
C      BIF            BIF           1st IF number
C      EIF            EIF           Highest IF number
C      SOURCES        SOURCS        Source name.
C      ANTENNAS       ANTENS        Antenna list
C      SUBARRAY       SUBA          Subarray.
C      TIMERANG       TIMER         Timerange
C      DOCALIB        DOCAL         Apply calibration?
C      GAINUSE        CLUSE         CL table to apply
C      FLAGVER        FLGVER        FG table to apply
C      DOBAND                       Apply bandpass calibration?
C      BPVER                        BP table to apply
C      SMOOTH                       Smoothing function
C      UVRANGE(2)     UVRA          Range of baseline lengths to
C                                   use (kilowavelengths).
C      SOLMODE        SOLMOD(?)     Amp. or  Amp and phase, or real.
C      OPCODE         OPCODE        'GAUS','SPHE' => model
C      NGAUSS         NGAUSS        Number of comp. to fit
C      GMAX(4)        GMAX          Peak intensity
C      GPOS(2,4)      GPOS          (X,Y) Position in arcsec.
C      GPARMS(6,4)    GWIDTH        (BMAJ,BMIN,BPA) in asec, asec,
C                                     degrees
C      GAINERR        GAIN          Antenna gain (<0 => fix to abs,
C                                   0 => 1
C      NITER          NITER         Number of loop iterations
C      EDROP          EDROP         Goodness of fit cutoff
C      DOMAX(4)       DOMAX         Peak intensity variability
C      DOPOS(2,4)     DOPOS         (X,Y) Position variability
C      DOWIDTH(3,4)   DOWID         (BMAJ,BMIN,BPA) variability
C      IMSIZE(2)      SIZE          Minimum and maximum component
C                                   size in asec.
C      PRTLEV         NPR           Print level from fitting
C      DOCAT          DOCAT         0=>Don't write CC.
C                                   1=>Deconvolved components
C                                   2=>Fit components
C      INVER          CCVER         Output CC file ver no.
C                                    0=>create new.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'UVGIT.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'UVGIT '/
C-----------------------------------------------------------------------
C                                       Get input parameters.
      CALL UVFTIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Read data
      CALL UVFDAT (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Fit model.
      CALL FITMOD (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE UVFTIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   UVFTIN gets input parameters for UVGIT and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6   Program name
C   Output:
C      JERR    I     Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER STAT*4, PRGN*6, UTYPE*2
      INTEGER   JERR, IROUND, NPARM, IERR, LOOP, LUN, I, JTRIM
      REAL      CATR(256)
      LOGICAL   T, F, TABLE, EXIST, FITASC, OK, MATCH
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'UVGIT.INC'
      INCLUDE 'DUVGIT.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANS.INC'
      EQUIVALENCE (CATR, CATBLK)
      DATA T, F /.TRUE.,.FALSE./
      DATA LUN /25/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL SELINI
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
      TLOW = 1.E10
      THIGH = -1.E10
C                                       Set max. number vis.
      MAXVIS = XMXVIS
C                                       Get input parameters.
      NPARM = 183
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRTCH, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      NGAUSS = IROUND (XNGAU)
      NITER = IROUND (XNIT)
      CCVER = IROUND (XNVER)
      NPR = IROUND (PRTL)
C                                       Characters
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XXSOLM, XSOLMO)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      CALL H2CHR (4, 1, XXSTOK, XSTOK)
      CALL H2CHR (48, 1, XINLIS, INLIST)
      CALL H2CHR (48, 1, XFITOU, FITOUT)
      I = JTRIM (INLIST)
      I = JTRIM (FITOUT)
      CALL H2CHR (16, 1, XXSOUR, XSOUR)
C                                       Find input file.
      CNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, SCRTCH, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1030) JERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Set status (WRIT => CC)
      STAT = 'REST'
      CALL CATIO ('READ', DISKIN, CNO, CATBLK, STAT, SCRTCH, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1040) JERR
         GO TO 990
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       See if multisource table
      CALL ISTAB ('SU', DISKIN, CNO, 1, LUN, SCRTCH, TABLE, EXIST,
     *   FITASC, IERR)
C                                       Must name a source for
C                                       multisource file.
      IF (EXIST .AND. (IERR.EQ.0) .AND. (XSOUR.EQ.' ')) THEN
         WRITE (MSGTXT,1050)
         JERR = 6
         GO TO 990
         END IF
C                                       Give source name for multi
      IF (EXIST .AND. (IERR.EQ.0)) THEN
         WRITE (MSGTXT,1051) XSOUR
         CALL MSGWRT (6)
         END IF
C                                       Setup for UVGET
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
C                                       Only 1 source allowed.
      SOURCS(1) = XSOUR
      CALL RCOPY (8, XTIME, TIMRNG)
      UVRNG(1) = XUVRA(1)
      UVRNG(2) = XUVRA(2)
      IF (XSTOK.EQ.'    ') XSTOK = 'I   '
      STOKES = XSTOK
      BCHAN = IROUND (XBCHAN)
      BCHAN = MAX (1, MIN (BCHAN, CATBLK(KINAX+JLOCF)))
      ECHAN = IROUND (XECHAN)
      IF (ECHAN.LT.BCHAN) ECHAN = CATBLK(KINAX+JLOCF)
      ECHAN = MAX (1, MIN (ECHAN, CATBLK(KINAX+JLOCF)))
      XBCHAN = BCHAN
C                                       get initial guess
      CALL INIDAT (BCHAN, JERR)
      IF (JERR.NE.0) THEN
         MSGTXT = 'FAILED TO SET UP INITIAL GUESSES'
         GO TO 990
         END IF
C                                       Check defaults, limits
      IF (NITER.LE.0) NITER = 100 * NGAUSS
      IF (EDROP.LE.0) EDROP = 1.0E-10
C                                       IFs
      IF (JLOCIF.GE.0) THEN
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, CATBLK(KINAX+JLOCIF)))
         EIF = IROUND (XEIF)
         IF (BIF.GT.EIF) EIF = CATBLK(KINAX+JLOCIF)
         EIF = MAX (1, MIN (EIF, CATBLK(KINAX+JLOCIF)))
      ELSE
         BIF = 1
         EIF = 1
         END IF
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOPOL = IROUND (XDOPOL)
      IF ((DOPOL.EQ.0) .AND. (XDOPOL.GT.0.0)) DOPOL = 1
      PDVER = IROUND (XPDVER)
      BLVER = IROUND (XBLVER)
      DO 100 LOOP = 1,50
         ANTENS(LOOP) = IROUND (XANTS(LOOP))
 100     CONTINUE
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LE.0) SUBARR = 1
      FGVER = IROUND (XFLAG)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      BLVER = -1
      DXTIME = 0.0
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, CNO, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1070)
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       Get # antennas
      CALL GETANT (DISKIN, CNO, SUBARR, CATBLK, SCRTCH, JERR)
      IF (JERR.GT.0) GO TO 999
      NANT = NSTNS
C
      DOAMP = XSOLMO.EQ.'A   '
      DOREAL = XSOLMO.EQ.'RE  '
      IF (DOAMP .OR. DOREAL) THEN
C                                       Make sure one posn. fixed
         OK = F
         DO 150 LOOP = 1,NGAUSS
            OK = OK .OR. ((DOCOMP(2,LOOP).LE.0.0) .AND.
     *         (DOCOMP(3,LOOP).LE.0.0))
 150        CONTINUE
C                                       Must fix one posn.
         IF (.NOT.OK) THEN
            JERR = 7
            IF (DOAMP) WRITE (MSGTXT,1150)
            IF (DOREAL) WRITE (MSGTXT,1160)
            GO TO 990
            END IF
         END IF
C                                       Tell Stokes' type
      MSGTXT = 'Processing Stokes type ' // XSTOK
      CALL MSGWRT (4)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVFTIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR: You MUST specify a SOURCE for multisource files')
 1051 FORMAT ('Fitting to source = ',4A4)
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
 1150 FORMAT ('ERROR: You MUST fix at least one posn. for amp. only ',
     *   'fitting')
 1160 FORMAT ('ERROR: You MUST fix at least one posn. for real only ',
     *   'fitting')
      END
      SUBROUTINE INIDAT (BCHAN, IRET)
C-----------------------------------------------------------------------
C   INIDAT reads the text file input if any or copies the user adverbs
C   to the fitting parameters
C   Inputs:
C      BCHAN   I   Desired spectral channel
C   Outputs:
C      IRET    I   Error code
C-----------------------------------------------------------------------
      INTEGER   BCHAN, IRET
C
      INCLUDE 'UVGIT.INC'
      INTEGER   TLUN, TIND, LUNTMP, I, JTRIM, J, NC, KBP
      DOUBLE PRECISION X
      CHARACTER INLINE*512
      INCLUDE 'DUVGIT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       adverb input
      IF (INLIST.EQ.' ') THEN
         NGAUSS = MAX (1, MIN (4, NGAUSS))
         DO 10 I = 1,NGAUSS
            GPARMS(1,I) = DMAX(I)
            IF (GPARMS(1,I).EQ.0.0) GPARMS(1,I) = 1.0
            GPARMS(2,I) = DPOS(1,I)
            GPARMS(3,I) = DPOS(2,I)
            GPARMS(4,I) = DWIDTH(1,I)
            GPARMS(5,I) = DWIDTH(2,I)
            GPARMS(6,I) = DWIDTH(3,I)
            DOCOMP(1,I) = DDMAX(I)
            DOCOMP(2,I) = DDPOS(1,I)
            DOCOMP(3,I) = DDPOS(2,I)
            DOCOMP(4,I) = DDWID(1,I)
            DOCOMP(5,I) = DDWID(2,I)
            DOCOMP(6,I) = DDWID(3,I)
 10         CONTINUE
         IRET = 0
C                                       text file input
      ELSE
         NGAUSS = 0
         TLUN = LUNTMP (2)
         CALL ZTXOPN ('READ', TLUN, TIND, INLIST, .FALSE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING TEXT FILE'
            GO TO 990
            END IF
 100     CALL ZTXIO ('READ', TLUN, TIND, INLINE, IRET)
         IF ((IRET.GT.0) .AND. (IRET.NE.2)) THEN
            WRITE (MSGTXT,1000) IRET, 'READING TEXT FILE'
            GO TO 990
         ELSE IF (IRET.EQ.0) THEN
            NC = JTRIM (INLINE)
            IF (NC.LE.0) GO TO 100
            IF (INLINE(:1).EQ.'#') GO TO 100
            KBP = 1
            CALL GETNUM (INLINE, NC, KBP, X)
            IF (X.EQ.DBLANK) GO TO 100
            I = X + 0.5D0
            IF ((I.NE.BCHAN) .AND. (I.NE.0)) GO TO 100
            J = NGAUSS + 1
            IF (J.GT.XMXCMP) THEN
               WRITE (MSGTXT,1100) XMXCMP
               CALL MSGWRT (7)
               GO TO 110
               END IF
            DOCOMP(1,J) = -1
            DOCOMP(2,J) = -1
            DOCOMP(3,J) = -1
            DOCOMP(4,J) = -1
            DOCOMP(5,J) = -1
            DOCOMP(6,J) = -1
C                                       flux
            CALL GETNUM (INLINE, NC, KBP, X)
            IF (X.EQ.DBLANK) GO TO 100
            GPARMS(1,J) = X
C                                       position
            CALL GETNUM (INLINE, NC, KBP, X)
            IF (X.EQ.DBLANK) GO TO 100
            GPARMS(2,J) = X
C                                       position
            CALL GETNUM (INLINE, NC, KBP, X)
            IF (X.EQ.DBLANK) GO TO 100
            GPARMS(3,J) = X
C                                       width
            CALL GETNUM (INLINE, NC, KBP, X)
            IF (X.EQ.DBLANK) GO TO 100
            GPARMS(4,J) = X
C                                       width
            CALL GETNUM (INLINE, NC, KBP, X)
            IF (X.EQ.DBLANK) GO TO 100
            GPARMS(5,J) = X
C                                       width
            CALL GETNUM (INLINE, NC, KBP, X)
            IF (X.EQ.DBLANK) GO TO 100
            GPARMS(6,J) = X
C                                       count it
            NGAUSS = J
C                                       are we fitting?
C                                       flux
            CALL GETNUM (INLINE, NC, KBP, X)
            IF (X.EQ.DBLANK) GO TO 100
            DOCOMP(1,J) = X
C                                       position
            CALL GETNUM (INLINE, NC, KBP, X)
            IF (X.EQ.DBLANK) GO TO 100
            DOCOMP(2,J) = X
C                                       position
            CALL GETNUM (INLINE, NC, KBP, X)
            IF (X.EQ.DBLANK) GO TO 100
            DOCOMP(3,J) = X
C                                       width
            CALL GETNUM (INLINE, NC, KBP, X)
            IF (X.EQ.DBLANK) GO TO 100
            DOCOMP(4,J) = X
C                                       width
            CALL GETNUM (INLINE, NC, KBP, X)
            IF (X.EQ.DBLANK) GO TO 100
            DOCOMP(5,J) = X
C                                       width
            CALL GETNUM (INLINE, NC, KBP, X)
            IF (X.EQ.DBLANK) GO TO 100
            DOCOMP(6,J) = X
C                                       comment?
            COMNTS(J) = ' '
            IF (KBP.LT.NC) THEN
               COMNTS(J) = INLINE(KBP:NC)
               NC = JTRIM (COMNTS(J))
               CALL CHTRIM (COMNTS(J), NC, COMNTS(J), I)
               END IF
            GO TO 100
            END IF
C                                       close file
 110     CALL ZTXCLS (TLUN, TIND, I)
         END IF
      IRET = 0
C                                       Error if none
      IF (NGAUSS.LE.0) THEN
         MSGTXT = 'NO GAUSSIANS FOUND'
         IRET = 10
         END IF
C
 990  IF (IRET.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('INIDAT: ERROR',I4,' ON ',A)
 1100 FORMAT ('INIDAT: USING ONLY FIRST',I3,' COMPONENTS FOUND')
      END
      SUBROUTINE UVFDAT (IRET)
C-----------------------------------------------------------------------
C   UVFDAT reads the uv data and converts to the form expected in the
C   rest of the program. Will read up to MAXVIS visibility records.
C   Input from common:
C      CHAN        I    Channel number
C      CATBLK(256) I    Catalog header
C      MAXVIS      I    Maximum number of visibilities.
C   Output:
C      IRET        I    Return error code: 0=>OK, otherwise error.
C   Output in common:
C      NUMVIS      I    Number of visibilities read.
C      U(*)        R    U coordinates in wavelengths
C      V(*)        R    V coordinates in wavelengths
C      RE(*)       R    Real part (Jy) (Amplitude if DOAMP)
C      IM(*)       R    Imaginary part (Jy)
C      WT(*)       R    weight
C      IANT1(*)    I    first antenna number
C      IANT2(*)    I    second antenna number
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   IPOINT, IERR, KVIS, LUN, NIF, LOOP, VISCNT, KOOP, IIVER
      REAL      BUFFER(2048), CATR(256), SUMRE, SUMIM, SUMWT, XRE, XIM,
     *   GCOR
      DOUBLE PRECISION CATD(128), SUM, TFREQ, COUNT
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ISBAND(MAXIF), IA2
      DOUBLE PRECISION FOFF(MAXIF)
      REAL      FINC(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'UVGIT.INC'
      INCLUDE 'DUVGIT.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE  (CATBLK, CATR, CATD)
      DATA LUN /29/
C-----------------------------------------------------------------------
      VISCNT = 0
C                                       Frequency correction factor
C                                       Get IF table:
      IIVER = 1
      CALL CHNDAT ('READ', BUFFER, DISKIN, CNO, IIVER, CATBLK, LUN, NIF,
     *   FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IERR)
C                                       Find average frequency
      SUM = 0.0D0
      COUNT = 0.0D0
      DO 30 LOOP = BIF,EIF
C                                       Use FINC(LOOP) here rather
C                                       than the header incr.  Would
C                                       FINC(BIF) be safer in case the
C                                       increment chnages ? Probably
C                                       better to get rubbish answers
         TFREQ = FREQ + FOFF(LOOP) + (((BCHAN+ECHAN)/2.0) -
     *      CATR(KRCRP+JLOCF)) * FINC(LOOP)
         SUM = SUM + TFREQ
         COUNT = COUNT + 1.0D0
 30      CONTINUE
      IF (COUNT.GT.1.0D0) SUM = SUM / COUNT
      GCOR = SUM / FREQ
C                                       Open file
      CALL UVGET ('INIT', BUFFER, BUFFER(1+NRPARM), IRET)
      IF (IRET.NE.0) GO TO 999
      KVIS = (LREC - NRPARM) / 3
C                                       Begin loop reading
      IF (NVIS.GT.MAXVIS) THEN
         WRITE (MSGTXT,1030) MAXVIS, NVIS
         CALL MSGWRT (7)
         END IF
      NUMVIS = MIN (NVIS, MAXVIS)
      DO 200 LOOP = 1,NUMVIS
C                                       Read datum
         CALL UVGET ('READ', BUFFER, BUFFER(1+NRPARM), IRET)
         IF (IRET.GT.0) GO TO 999
         IF (IRET.LE.-1) GO TO 210
         VISCNT = VISCNT + 1
C                                       Correct u,v,w
         U(VISCNT) = BUFFER(1+ILOCU) * GCOR
         V(VISCNT) = BUFFER(1+ILOCV) * GCOR
         W(VISCNT) = BUFFER(1+ILOCW) * GCOR
         TLOW = MIN (TLOW, BUFFER(1+ILOCT))
         THIGH = MAX (THIGH, BUFFER(1+ILOCT))
C                                       Antenna numbers
         IF (ILOCB.GE.0) THEN
            IA2 = BUFFER(1+ILOCB) + 0.1
            IANT1(VISCNT) = IA2 / 256
            IANT2(VISCNT) = IA2 - IANT1(VISCNT) * 256
         ELSE
            IANT1(VISCNT) = BUFFER(1+ILOCA1) + 0.1
            IANT2(VISCNT) = BUFFER(1+ILOCA2) + 0.1
            END IF
C                                       Average visibility
         SUMRE = 0.0
         SUMIM = 0.0
         SUMWT = 0.0
         COUNT = 0.0D0
         IPOINT = NRPARM + 1
         DO 150 KOOP = 1,KVIS
            XRE = BUFFER(IPOINT)
            XIM = BUFFER(IPOINT+1)
C                                       Just pass reals
            IF (DOREAL) THEN
               XIM = 0.0
               END IF
C                                       Convert to amplitude.
            IF (DOAMP) THEN
               XRE = SQRT (XRE*XRE + XIM*XIM)
               XIM = 0.0
               END IF
C                                       Sum
            IF (BUFFER(IPOINT+2).GT.0.0) THEN
               SUMRE = SUMRE + XRE
               SUMIM = SUMIM + XIM
               SUMWT = SUMWT + BUFFER(IPOINT+2)
               COUNT = COUNT + 1.0D0
               END IF
            IPOINT = IPOINT + 3
 150        CONTINUE
         IF (COUNT.LE.0.5D0) COUNT = 1.0D0
         RE(VISCNT) = SUMRE / COUNT
         IM(VISCNT) = SUMIM / COUNT
         WT(VISCNT) = SUMWT / COUNT
 200     CONTINUE
C                                       Close file
 210  CALL UVGET ('CLOS', BUFFER, BUFFER(NRPARM), IRET)
      IRET = 0
C                                       Check that some data given
      NUMVIS = VISCNT
      IF (NUMVIS.LE.1) THEN
         IRET = 8
         WRITE (MSGTXT,1220)
         GO TO 980
C                                       Tell how many vis. used.
      ELSE
         WRITE (MSGTXT,1230) NUMVIS
         END IF
C                                       Error
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('UVFDAT: READING ONLY',I8,' OF',I12,' VIS RECORDS')
 1220 FORMAT ('UVFDAT: NO VALID DATA FOUND')
 1230 FORMAT ('UVFDAT: Using',I8,' visibilities')
      END
      SUBROUTINE FITMOD (IRET)
C-----------------------------------------------------------------------
C   Routine to fit a model to uv data.  May write results to a CC file.
C   Inputs from common:
C     NUMVIS         I    Number of visibilities.
C     U(*)           R    U coordinates in wavelengths
C     V(*)           R    V coordinates in wavelengths
C     RE(*)          R    Real part (Jy) (Amplitude if DOAMP)
C     IM(*)          R    Imaginary part (Jy)
C     WT(*)          R    weight
C     DOAMP          L    IF true fit only amplitudes.
C     DOREAL         L    If true fit only reals
C     OPCODE         C*4  Model type, 'GAUS', 'SPHE'
C                         Anything but 'SPHE' is 'GAUS'.
C     NGAUSS         I    Number of gaussians to fit (up to 4)
C     GMAX(4)        R    Estimated peak of gaussian.
C     GPOS(2,4)      R    Estimated position of gaussian, x and y
C                         offsets in arcsec from phase center.
C     GWIDTH(3,4)    R    Estimated size of gaussian.
C                          1 = Major axis (FWHM in asec)
C                          2 = Minor axis (FWHM in asec)
C                          3 = Position angle ( degrees ).
C     GAIN(*)        R    Antenna gain corrections.
C     NITER          I    Maximum number of iterations to run
C     EDROP          R    Chi squared cutoff.
C     DOMAX(4)       R    Flags to fit maximum :
C                         > 0. => vary,  <= 0. => fix.
C     DOPOS(2,4)     R    Flags to fit position.
C     DOWID(3,4)     R    Flags to fit size parameters.
C                         If DOCOMP(5,n) is .le. -1.9 then
C                         a circular gaussian is desired.
C     SIZE(2)        R    Minimum and maximum size for components.
C     DOCAT          R    > 0. => write results in CC file.
C     CCVER          I    CC table version number.
C   Output in Common:
C     GMAX(4)        R    Fitted peak of gaussian.
C     GPOS(2,4)      R    Fitted position of gaussian, x and y
C                         offsets in arcsec from phase center.
C     GWIDTH(3,4)    R    Fitted size of gaussian.
C                          1 = Major axis (FWHM in asec)
C                          2 = Minor axis (FWHM in asec)
C                          3 = Position angle ( degrees ).
C     GAIN(*)        R    Antenna gain corrections.
C     MODPNT(6,*)    I    Array of pointers in P for values varies,
C                         0 => parameter fixed.  One per model parm.
C                         MODPNT(5,n) = -1 => circular gaussian.
C     GAPNT(*)       I    Array of pointers in P for antenna gains
C                         0 => parameter fixed.  One per antenna.
C     IRET           I    Return code, 0=> OK otherwise failed.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      EXTERNAL  GAUFUN, SPHFUN
C
      CHARACTER PREPOS*5, PRESIZ*5, KEYWRD*8, MODTYP(3)*8, OUTLIN*512
      INTEGER   I, J, K, LUN, IERR, IP, IMODTY, JERR, LUN2, MXPRM, TLUN,
     *   TIND, LUNTMP, JTRIM
      REAL      SCLPOS, SCLSIZ, POSMAX, SIZMAX, POS1, POS2, SIZ1, SIZ2,
     *   EPOS1, EPOS2, ESIZ1, ESIZ2
      HOLLERITH HSOUR(2)
      LOGICAL   LERR
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'UVGIT.INC'
      INCLUDE 'DUVGIT.INC'
      INTEGER   CCBUFF(512), CCKOLS(MAXCCC), CCNUMV(MAXCCC), CCRNO,
     *   CCNCOL, CCTYPE
      REAL      ERROR(6,XMXCMP), XX, YY, ZZ, CCFLUX, PARMS(3)
      DOUBLE PRECISION EPS, VALUE(XMXPRM), ERR(XMXPRM), FVEC(2*XMXVIS),
     *   TOL, FJAC(XMXPRM,XMXPRM), SFJAC(XMXPRM,XMXPRM), FNORM, ENORM,
     *   WORK(XMXPRM)
      INTEGER   IPVT(XMXPRM), INFO, LDFJAC
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSOU.INC'
      DATA LUN, LUN2 /27,25/
      DATA MODTYP /'Gaussian','        ','Sphere  '/
      DATA KEYWRD /'SOURCE  '/
      DATA MXPRM /XMXPRM/
      DATA LDFJAC /XMXPRM/
      DATA TOL /1.D-7/
C-----------------------------------------------------------------------
C                                       Set tolerance
      EDROP = ABS (EDROP)
      IF (EDROP.LE.1.0E-6) EDROP = 1.0
      EPS = 1.0D-12 * EDROP
C                                       Find model type
C                                       1=GAUSSIAN, 2=SPHERE
      IMODTY = 1
      IF (OPCODE.EQ.'SPHE') IMODTY = 3
C                                       Tell model type
      WRITE (MSGTXT,1000) MODTYP(IMODTY)
      CALL MSGWRT (2)
C                                       Amplitude only message
      IF (DOAMP) THEN
         MSGTXT = 'Using amplitudes of visibility data ONLY.'
         CALL MSGWRT (2)
         END IF
C                                       Real only message
      IF (DOREAL) THEN
         MSGTXT = 'Using REAL part of visibility data ONLY'
         CALL MSGWRT (2)
         END IF
C                                       complex or real
      MINC = 2
      IF ((DOAMP) .OR. (DOREAL)) MINC = 1
      NUMDAT = MINC * NUMVIS
C                                       Setup for model fitting
      NVAR = 0
      ITTER = 0
      K = 0
      DO 10 I = 1,NGAUSS
C                                       Set pointers
         CALL FILL (6, 0, MODPNT(1,I))
C                                       Make sure .NE. major axis
         IF (ABS (GPARMS(5,I)-GPARMS(4,I)).LT.(0.01*GPARMS(4,I)))
     *      GPARMS(5,I) = 0.99 * GPARMS(4,I)
C                                       Trap for circular gaussian
         IF (DOCOMP(5,I).LE.-1.9) MODPNT(5,I) = -1
C                                       Don't solve for PA on circular
         IF (MODPNT(5,I).LE.-1) DOCOMP(6,I) = -1.0
C                                       all comps
         DO 5 J = 1,6
            K = K + 1
            LPARMS(K) = GPARMS(J,I)
            IF (DOCOMP(J,I).GT.0.01) THEN
               NVAR = NVAR + 1
               VALUE(NVAR) = GPARMS(J,I)
               MODPNT(J,I) = NVAR
               IVAR(NVAR) = I
               JVAR(NVAR) = J
               END IF
 5          CONTINUE
 10      CONTINUE
C                                       Gain parameters
      DO 20 I = 1,NANT
          GAPNT(I) = 0
          K = K + 1
          GAIN(I) = GAINE(I)
          LPARMS(K) = GAIN(I)
          IF (GAIN(I).GT.0.001) THEN
             NVAR = NVAR + 1
             VALUE(NVAR) = GAIN(I)
             GAPNT(I) = NVAR
             IVAR(NVAR) = I
             JVAR(NVAR) = 7
             END IF
          IF (ABS (GAIN(I)).LE.0.001) GAIN(I) = 1.0
          IF (GAIN(I).LT.-0.001) GAIN(I) = ABS (GAIN(I))
 20       CONTINUE
C                                       Check NVAR
      IF (NVAR.GT.MXPRM) THEN
         IRET = 5
         WRITE (MSGTXT,1020) NVAR, MXPRM
         GO TO 990
         END IF
C                                       Get Chi squares
      IF (IMODTY.EQ.1) CALL GAUFUN (NUMDAT, NVAR, VALUE, FVEC, FJAC, 1)
      IF (IMODTY.EQ.3) CALL SPHFUN (NUMDAT, NVAR, VALUE, FVEC, FJAC, 1)
      WRITE (MSGTXT,1030) CHISQ, RMSRES
      CALL MSGWRT (4)
C                                       Fit model
      IF (IMODTY.EQ.1) CALL XGALMS (GAUFUN, NUMDAT, NVAR, VALUE, FVEC,
     *   FJAC, LDFJAC, TOL, INFO, IPVT)
      IF (IMODTY.EQ.3) CALL XGALMS (SPHFUN, NUMDAT, NVAR, VALUE, FVEC,
     *   FJAC, LDFJAC, TOL, INFO, IPVT)
      IF (INFO.EQ.-1) THEN
         MSGTXT = 'NUMBER OF ITERATIONS EXCEEDED WHEN TRYING TO FIT'
      ELSE IF ((INFO.EQ.0) .OR. (INFO.EQ.4)) THEN
         MSGTXT = 'LMSTR1 DOES NOT LIKE INPUT PARAMETERS'
         IF (INFO.EQ.4) MSGTXT = 'MATRIX ORTHOGONAL TO JACOBIAN'
         CALL MSGWRT (8)
         IRET = 10
         GO TO 999
      ELSE IF (INFO.GT.4) THEN
         WRITE (MSGTXT,1100) INFO
      ELSE
         WRITE (MSGTXT,1101) INFO
         END IF
      CALL MSGWRT (6)
C                                       Get errors
      FNORM = ENORM (NUMDAT, FVEC)
      I = XMXPRM * XMXPRM
      CALL DPCOPY (I, FJAC, SFJAC)
      CALL GETERR (NGAUSS, NVAR, NUMDAT, XMXPRM, IPVT, SFJAC, ERR,
     *   FNORM, WORK, TOL, IVAR, JVAR)
C                                       Put results into output arrays.
C                                       Also get min size and position.
      POSMAX = -1.0E20
      SIZMAX = -1.0E20
      DO 220 I = 1,NGAUSS
C                                       Peak
         IP = MODPNT(1,I)
         IF (IP.GT.0) GPARMS(1,I) = VALUE(IP)
         ERROR(1,I) = -1.0
         IF (IP.GT.0) ERROR(1,I) = ERR(IP)
C                                       Position
         IP = MODPNT(2,I)
         IF (IP.GT.0) GPARMS(2,I) = VALUE(IP)
         IF (ABS (GPARMS(2,I)).GT.POSMAX) POSMAX = ABS (GPARMS(2,I))
         ERROR(2,I) = -1.0
         IF (IP.GT.0) ERROR(2,I) = ERR(IP)
         IP = MODPNT(3,I)
         IF (IP.GT.0) GPARMS(3,I) = VALUE(IP)
         IF (ABS (GPARMS(3,I)).GT.POSMAX) POSMAX = ABS (GPARMS(3,I))
         ERROR(3,I) = -1.0
         IF (IP.GT.0) ERROR(3,I) = ERR(IP)
C                                       Size
         IP = MODPNT(4,I)
         IF (IP.GT.0) GPARMS(4,I) = VALUE(IP)
         IF (GPARMS(4,I).GT.SIZMAX) SIZMAX = GPARMS(4,I)
         ERROR(4,I) = -1.0
         IF (IP.GT.0) ERROR(4,I) = ERR(IP)
         IP = MODPNT(5,I)
         IF (IP.GT.0) GPARMS(5,I) = VALUE(IP)
         IF ((GPARMS(5,I).GT.SIZMAX) .AND. (IMODTY.EQ.1))
     *      SIZMAX = GPARMS(5,I)
         ERROR(5,I) = -1.0
         IF (IP.GT.0) ERROR(5,I) = ERR(IP)
         IP = MODPNT(6,I)
         IF (IP.GT.0) THEN
            GPARMS(6,I) = VALUE(IP)
            IF (GPARMS(6,I).GT.180.0) GPARMS(6,I) = GPARMS(6,I) - 360.0
            IF (GPARMS(6,I).GT.180.0) GPARMS(6,I) = GPARMS(6,I) - 360.0
            IF (GPARMS(6,I).GT.180.0) GPARMS(6,I) = GPARMS(6,I) - 360.0
            IF (GPARMS(6,I).LT.-180.0) GPARMS(6,I) = GPARMS(6,I) + 360.0
            IF (GPARMS(6,I).LT.-180.0) GPARMS(6,I) = GPARMS(6,I) + 360.0
            IF (GPARMS(6,I).LT.-180.0) GPARMS(6,I) = GPARMS(6,I) + 360.0
            END IF
         ERROR(6,I) = -1.0
         IF (IP.GT.0) ERROR(6,I) = ERR(IP)
 220     CONTINUE
C                                       Get size and position scaling
      SCLPOS = POSMAX
      CALL METSCA (POSMAX, PREPOS, LERR)
      IF (ABS (SCLPOS).GT.1.0E-10) SCLPOS = POSMAX / SCLPOS
      IF (ABS (SCLPOS).LE.1.0E-10) SCLPOS = 1.0
      SCLSIZ = SIZMAX
      CALL METSCA (SIZMAX, PRESIZ, LERR)
      IF (ABS (SCLSIZ).GT.1.0E-10) SCLSIZ = SIZMAX / SCLSIZ
      IF (ABS (SCLSIZ).LE.1.0E-10) SCLSIZ = 1.0
C                                       Get Chi squares
      IF (IMODTY.EQ.1) CALL GAUFUN (NUMDAT, NVAR, VALUE, FVEC, FJAC, 1)
      IF (IMODTY.EQ.3) CALL SPHFUN (NUMDAT, NVAR, VALUE, FVEC, FJAC, 1)
      WRITE (MSGTXT,1218) CHISQ, RMSRES
      CALL MSGWRT (4)
C                                       Write results and
C                                       write CC table if requested
      IF (DOCAT.GT.0.0001) THEN
         CALL CCMINI ('WRIT', CCBUFF, DISKIN, CNO, CCVER, CATUV, LUN,
     *      CCRNO, CCKOLS, CCNUMV, CCNCOL, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1210) IRET
            GO TO 990
            END IF
         END IF
C                                       Write source name as KEYWORD
C                                       (only first 8 characters used).
C                                       Assume CURSOU valid.
      CCRNO = 1
      IF (DOCAT.GT.0.001) THEN
         CALL GETSOU (CURSOU, DISKIN, CNO, CATUV, LUN2, JERR)
         IF (JERR.EQ.0) THEN
            CALL CHR2H (8, SNAME, 1, HSOUR)
            CALL TABKEY ('WRIT', KEYWRD, 1, U, 1, HSOUR, 3, JERR)
            END IF
         END IF
C                                       text file too?
      IF (FITOUT.NE.' ') THEN
         TLUN = LUNTMP (2)
         CALL ZTXOPN ('WRIT', TLUN, TIND, FITOUT, .TRUE., JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR OPENING TEXT FILE'
            CALL MSGWRT (6)
            FITOUT = ' '
         ELSE
            WRITE (OUTLIN,1300) PREPOS, PRESIZ
            J = JTRIM (OUTLIN)
            CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), JERR)
            IF (JERR.NE.0) THEN
               MSGTXT = 'ERROR WRITING TEXT FILE'
               CALL MSGWRT (6)
               FITOUT = ' '
               END IF
            END IF
         END IF
C                                       Write results
      J = 1
      CHAN = XBCHAN + 0.1
      DO 290 I = 1,NGAUSS
C                                       Scale position and size
         POS1 = GPARMS(2,I) * SCLPOS
         POS2 = GPARMS(3,I) * SCLPOS
         SIZ1 = GPARMS(4,I) * SCLSIZ
         SIZ2 = GPARMS(5,I) * SCLSIZ
C                                       ERROR=-1 if not fitted
         EPOS1 = -1.0
         EPOS2 = -1.0
         ESIZ1 = -1.0
         ESIZ2 = -1.0
         IF (MODPNT(2,I).GT.0) EPOS1 = ERROR(2,I) * SCLPOS
         IF (MODPNT(3,I).GT.0) EPOS2 = ERROR(3,I) * SCLPOS
         IF (MODPNT(4,I).GT.0) ESIZ1 = ERROR(4,I) * SCLSIZ
         IF (MODPNT(5,I).GT.0) ESIZ2 = ERROR(5,I) * SCLSIZ
         WRITE (MSGTXT,1220,ERR=235) I, GPARMS(1,I), POS1, POS2, PREPOS
 235     CALL MSGWRT (4)
         WRITE (MSGTXT,1222,ERR=240) ERROR(1,I), EPOS1, EPOS2
 240     CALL MSGWRT (4)
         WRITE (MSGTXT,1221,ERR=245) SIZ1, SIZ2, PRESIZ, GPARMS(6,I)
 245     CALL MSGWRT (4)
         WRITE (MSGTXT,1223,ERR=250) ESIZ1, ESIZ2, ERROR(6,I)
 250     CALL MSGWRT (4)
         J = J + 6
C                                       write text file
         IF (FITOUT.NE.' ') THEN
            WRITE (OUTLIN,1310) CHAN, I, POS1, EPOS1, POS2, EPOS2,
     *         GPARMS(1,I), ERROR(1,I), SIZ1, ESIZ1, SIZ2, ESIZ2,
     *         GPARMS(6,I), ERROR(6,I), RMSRES, CHISQ, TLOW, THIGH
            J = JTRIM (OUTLIN)
            OUTLIN(J+2:) = COMNTS(I)
            J = JTRIM (OUTLIN)
            CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), JERR)
            IF (JERR.NE.0) THEN
               MSGTXT = 'ERROR WRITING TEXT FILE'
               CALL MSGWRT (6)
               FITOUT = ' '
               END IF
            END IF
C                                       Write CC table.
         IF (DOCAT.GT.0.0001) THEN
            CCFLUX = GPARMS(1,I)
            XX = GPARMS(2,I) / 3600.0
            YY  = GPARMS(3,I) / 3600.0
            ZZ = 0.0
            PARMS(1) = GPARMS(4,I) / 3600.0
            IF (IMODTY.EQ.1) THEN
               PARMS(2) = GPARMS(5,I) / 3600.0
               PARMS(3) = GPARMS(6,I)
            ELSE
               PARMS(2) = 0.0
               PARMS(3) = 0.0
               END IF
            CCTYPE = IMODTY
            CALL TABCCM ('WRIT', CCBUFF, CCRNO, CCKOLS, CCNUMV, CCNCOL,
     *        XX, YY, ZZ, CCFLUX, CCTYPE, PARMS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1280) IRET
               GO TO 990
               END IF
            END IF
 290     CONTINUE
C                                       Write antenna gains varied
      DO 300 I = 1,30
         IF (GAPNT(I).GT.0) THEN
            IP = GAPNT(I)
            WRITE (MSGTXT,1290) I, VALUE(IP), ERR(IP)
            CALL MSGWRT (4)
            END IF
 300     CONTINUE
C                                       Close CC file
      IF (DOCAT.GT.0.001) CALL TABCCM ('CLOS', CCBUFF, CCRNO, CCKOLS,
     *   CCNUMV, CCNCOL,XX, YY, ZZ, CCFLUX, CCTYPE, PARMS, IRET)
      IF (FITOUT.NE.' ') CALL ZTXCLS (TLUN, TIND, IERR)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Fitting model of type ',A8)
 1020 FORMAT ('TOO MANY PARAMETERS TO FIT,',I3,' > ',I4)
 1030 FORMAT ('Prefit CHI squared =',1PE12.5,' Jy^2  RMS =',1PE12.5,
     *   ' Jy')
 1100 FORMAT ('MODFIT: INFO',I3,' FULL CONVERGENCE NOT ACHIEVED')
 1101 FORMAT ('MODFIT: info',I3,' fit converged')
 1210 FORMAT ('MODFIT: CCINI ERROR',I3,' INIT THE CC FILE')
 1218 FORMAT ('Postfit Chi squared =',1PE12.5,' Jy^2  RMS =',1PE12.5,
     *   ' Jy')
 1220 FORMAT ('Comp',I3,' Max=',1PE11.4,' Jy, pos=',0PF11.6,
     *   F11.6,1X,A5,'sec')
 1221 FORMAT (7X,' Size =',2F12.6,1X,A5,'sec PA =',F8.2,' deg')
 1222 FORMAT (12X,1PE11.4,9X,0PF11.6,F11.6)
 1223 FORMAT (14X,2F12.6,14X,0PF8.2)
 1280 FORMAT ('MODFIT: ERROR',I3,' WRITING CC TABLE')
 1290 FORMAT (' Gain for antenna ',I4,' = ',F8.4,' +/-',F8.4)
 1300 FORMAT ('   ch  #',3X,'Dra',1X,A5,'asec',4X,'Ddec',4X,'+-',3X,
     *   4X,'Flux Jy  +-',2X,3X,'Bmaj',1X,A,'asec',3X,'Bmin',4X,'+-',
     *   3X,4X,'PA   +- ',4X,'RMS   Chi_sq Tstart    Tend')
 1310 FORMAT (I5,I3, F10.4,F7.3, F10.4,F7.3, F9.3,F8.3, F9.4,F7.3,
     *   F9.4,F7.3, F7.1,F5.1, F8.2, F8.2, 2F10.7)
      END
      SUBROUTINE GETERR (NGAUSS, MP, NDATA, MD, IPVT, FJAC, PARERR,
     *   FNORM, WA, TOL, IVAR, JVAR)
C-----------------------------------------------------------------------
C   This subroutine calculates the errors on the fitted parameters.
C   Inputs:
C      NGAUSS  I       Totatl number Gaussians
C      IPVT    I(MP)   Defines a permutation matrix P such that
C                      JAC*P = Q*R, where JAC is the final calculated
C                      Jacobian, Q is orthogonal (not stored), and R is
C                      upper triangular with diagonal elements of
C                      nonincreasing magnitude column J of P is column
C                      IPVT(J) of the identity matrix. (See FJAC below)
C      FJAC    D(MD,MP)   The upper MP by MP submatrix of FJAC contains
C                      an upper triangular matrix R with diagonal
C                      elements of nonincreasing magnitude such that
C                           T     T           T
C                          P *(JAC *JAC)*P = R *R,
C                      where P is a permutation matrix and JAC is the
C                      final calculated Jacobian. Column J of P is
C                      column IPVT(J) (see above) of the identity
C                      matrix.
C      MP      I       Number of parameters in fitted function.
C      NDATA   I       Number of data points fitted.
C      MD      I       Maximum no. of data points allowed for in FJAC
C      FNORM   D       Euclidian norm of solution vector.
C      WA      D(MP)   work array.
C  Output:
C      FJAC    D       modified by COVAR
C      PARERR  D(*)    error in all parameters.
C      TOL     D       tolerance used in call to LMDER1.
C-----------------------------------------------------------------------
      INTEGER   NGAUSS, MD, MP, IPVT(*), NDATA, IVAR(*), JVAR(*)
      DOUBLE PRECISION FJAC(MD,*), PARERR(*), FNORM, WA(*), TOL
C
      DOUBLE PRECISION EPSILN
      INTEGER   J, JC
C-----------------------------------------------------------------------
C                                       Calculate error following
C                                       Argonne write up
      J = NGAUSS * 6 + 30
      CALL DFILL (J, 0.0D0, PARERR)
      EPSILN = FNORM / SQRT (REAL(NDATA-MP))
      CALL COVAR (MP, FJAC, MD, IPVT, TOL, WA)
      DO 100 J = 1,MP
         IF (JVAR(J).LE.6) THEN
            JC = 6 * (IVAR(J) - 1) + JVAR(J)
         ELSE
            JC = 6 + NGAUSS + IVAR(J)
            END IF
         PARERR(J) = EPSILN * SQRT (FJAC(J,J))
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE GAUFUN (M, N, VALVAR, FVEC, FJROW, IFLAG)
C-----------------------------------------------------------------------
C   This routine is called by the Argonne package to calculate the
C   difference between the current fit and the actual data OR the
C   Jacobian for this difference.
C   Inputs:
C        M        I      Number of data points in slice (adj array dim)
C        N        I      No. of parameters (adj. array dim.;
C                        NGAUSS * 3)
C        VALVAR   D(N)   parameters of gaussian components,
C                        GMAX(1), GPOS(1), GWIDTH(1), GMAX(2), ...
C        IFLAG    I      1=calculate difference for current guess.
C                        2=calculate jacobian for current guess.
C    COMMON GDATA
C        RE       R(M)   real part of vis
C        IM       R(M)   imaginary part of vis
C        ITTER    I      number of calls to evaluate FVEC.
C    Outputs:
C        FVEC     D(M)   Slice data points minus data points
C                           evaluated for current guess.
C        FJROW    D(N)   Row (IFLAG - 1) of Jacobian.
C-----------------------------------------------------------------------
      INTEGER   N, M, IFLAG
      DOUBLE PRECISION VALVAR(N), FVEC(M), FJROW(N)
C
      INCLUDE 'UVGIT.INC'
      INCLUDE 'DUVGIT.INC'
      INTEGER   IDA, IDATA, I, J, K, IP, IP1, IP2, ITYP, COUNT
      REAL      GN(30), W1(XMXCMP), W2(XMXCMP), ST(XMXCMP), CT(XMXCMP),
     *   TH, C1, C2, ANTFAC, TT, T1, T2, ALF, TC, IMMOD, REMOD
      DOUBLE PRECISION PHI, DRA, DECC, DEC0, SUMRE, SUMIM, TEMP, EFACT
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      SAVE GN, W1, W2, ST, CT, REMOD, IMMOD
      DATA C1 /8.3668894E-11/
      DATA C2 /1.7453292E-2/
C-----------------------------------------------------------------------
C                                       Determine difference between
C                                       data and current fit.
      DEC0 = DEC * DG2RAD
      IF (IFLAG.LE.1) THEN
         ITTER = ITTER + 1
         IF (ITTER.GT.NITER) THEN
            IFLAG = -1
            GO TO 999
            END IF
C                                       get full parms array
C                                       must be set in COMMON
C                                       defend against blanks
         DO 5 I = 1,XMXPRM
            IF (LPARMS(I).EQ.FBLANK) LPARMS(I) = 0.0D0
 5          CONTINUE
C                                       transfer varying values
         DO 10 I = 1,N
            IF (JVAR(I).EQ.7) THEN
               K = GAPNT(IVAR(I))
            ELSE
               K = 6 * (IVAR(I) - 1) + JVAR(I)
               END IF
            IF (K.GT.0) LPARMS(K) = VALVAR(I)
 10         CONTINUE
C                                       get constants
         DO 20 I = 1,NGAUSS
            K = (I - 1) * 6 + 1
            W1(I) = C1 * LPARMS(K+3) * LPARMS(K+3)
            W2(I) = C1 * LPARMS(K+4) * LPARMS(K+4)
            TH = C2 * LPARMS(K+5)
            ST(I) = SIN (TH)
            CT(I) = COS (TH)
 20         CONTINUE
         DO 25 I = 1,NANT
            GN(I) = 1.0 / GAIN(I)
            IP = GAPNT(I)
            IF (IP.GT.0) THEN
               VALVAR(IP) = ABS (VALVAR(IP))
               GN(I) = 1.0 / VALVAR(IP)
               END IF
 25         CONTINUE
         CHISQ = 0.0D0
         RMSRES = 0.0D0
         COUNT = 0
         DO 50 IDA = 1,M,MINC
            IDATA = (IDA - 1) / MINC + 1
            SUMRE = RE(IDATA)
            SUMIM = IM(IDATA)
            IP1 = IANT1(IDATA)
            IP2 = IANT2(IDATA)
            ANTFAC = GN(IP1) * GN(IP2)
            TT = U(IDATA) * U(IDATA) + V(IDATA) * V(IDATA)
            K = -5
            DO 40 I = 1,NGAUSS
               K = K + 6
               T1 = U(IDATA)*ST(I) + V(IDATA)*CT(I)
               T2 = U(IDATA)*CT(I) - V(IDATA)*ST(I)
               ALF = W1(I)*T1*T1 + W2(I)*T2*T2
               DRA = AS2RAD * LPARMS(K+1) / COS (DEC0)
               DECC = AS2RAD * LPARMS(K+2) + DEC0
               PHI = TWOPI * ((SIN(DRA)*COS(DECC))*U(IDATA) + V(IDATA)*
     *            (COS(DEC0)*SIN(DECC) - SIN(DEC0)*COS(DECC)*COS(DRA)) +
     *            (SIN(DEC0)*SIN(DECC) + COS(DEC0)*COS(DECC)*COS(DRA)
     *            -1.D0) * W(IDATA))
               TC = EXP (-ALF) * ANTFAC * LPARMS(K)
               IMMOD = TC * SIN (PHI)
               REMOD = TC * COS (PHI)
               SUMRE = SUMRE - REMOD
               SUMIM = SUMIM - IMMOD
 40            CONTINUE
            TEMP = SUMRE * SUMRE + SUMIM * SUMIM
            COUNT = COUNT + 1
            IF (DOAMP) THEN
               FVEC(IDA) = SQRT (TEMP)
               CHISQ = CHISQ + WT(IDATA) * TEMP
               RMSRES = RMSRES + TEMP
            ELSE IF (DOREAL) THEN
               FVEC(IDA) = SUMRE
               CHISQ = CHISQ + WT(IDATA) * SUMRE * SUMRE
               RMSRES = RMSRES + SUMRE * SUMRE
            ELSE
               FVEC(IDA) = SUMRE
               FVEC(IDA+1) = SUMIM
               CHISQ = CHISQ + WT(IDATA) * TEMP
               RMSRES = RMSRES + TEMP
               END IF
 50         CONTINUE
         RMSRES = SQRT (RMSRES / MAX (COUNT, 1))
C                                       calculate Jacobean
      ELSE
         IDA = IFLAG - 1
         IDATA = (IDA - 1) / MINC + 1
         ITYP = MOD (IDA-1, MINC)
         DO 100 I = 1,N
C                                       Gains
            IF (JVAR(I).GT.6) THEN
               IP1 = IVAR(I)
               IF (ITYP.EQ.0) THEN
                  FJROW(I) = -REMOD / GN(IP1)
               ELSE
                  FJROW(I) = -IMMOD / GN(IP1)
                  END IF
C                                       Gaussians
            ELSE
               J = IVAR(I)
               K = 6 * (J - 1) + 1
               SUMRE = RE(IDATA)
               SUMIM = IM(IDATA)
               IP1 = IANT1(IDATA)
               IP2 = IANT2(IDATA)
               ANTFAC = GN(IP1) * GN(IP2)
               TT = U(IDATA) * U(IDATA) + V(IDATA) * V(IDATA)
               T1 = U(IDATA)*ST(J) + V(IDATA)*CT(J)
               T2 = U(IDATA)*CT(J) - V(IDATA)*ST(J)
               ALF = W1(I)*T1*T1 + W2(I)*T2*T2
               DRA = AS2RAD * LPARMS(K+1) / COS (DEC0)
               DECC = AS2RAD * LPARMS(K+2) + DEC0
               PHI = TWOPI * ((SIN(DRA)*COS(DECC))*U(IDATA) + V(IDATA)*
     *            (COS(DEC0)*SIN(DECC) - SIN(DEC0)*COS(DECC)*COS(DRA)) +
     *            (SIN(DEC0)*SIN(DECC) + COS(DEC0)*COS(DECC)*COS(DRA)
     *            -1.D0) * W(IDATA))
               EFACT = -EXP (-ALF) * ANTFAC
               TC = EXP (-ALF) * ANTFAC * LPARMS(K)
C                                       wrt amplitude
               IF (JVAR(I).EQ.1) THEN
                  IF (ITYP.EQ.0) THEN
                     FJROW(I) = EFACT * COS (PHI)
                  ELSE
                     FJROW(I) = EFACT * SIN (PHI)
                     END IF
C                                       east=west
               ELSE IF (JVAR(I).EQ.2) THEN
                  TEMP = (AS2RAD * TWOPI * COS(DEC)/COS(DEC0)) *
     *               (COS(DRA)*U(IDATA) + SIN(DEC0)*SIN(DRA)*V(IDATA) -
     *               COS(DEC0)*SIN(DRA)*W(IDATA))
                  IF (ITYP.EQ.0) THEN
                     FJROW(I) = -EFACT * SIN (PHI) * TEMP
                  ELSE
                     FJROW(I) = EFACT * COS (PHI) * TEMP
                     END IF
C                                       north south
               ELSE IF (JVAR(I).EQ.3) THEN
                  TEMP = AS2RAD * TWOPI * (-SIN(DRA)*SIN(DECC)*U(IDATA)+
     *               (COS(DEC0)*COS(DEC)+SIN(DEC0)*SIN(DECC)*COS(DRA))*
     *               V(IDATA) + W(IDATA) * (COS(DECC)*SIN(DEC0) -
     *               COS(DEC0)*SIN(DECC)*COS(DRA)))
                  IF (ITYP.EQ.0) THEN
                     FJROW(I) = -EFACT * SIN (PHI) * TEMP
                  ELSE
                     FJROW(I) = EFACT * COS (PHI) * TEMP
                     END IF
C                                       major axis
               ELSE IF (JVAR(I).EQ.4) THEN
                  TEMP = T1 * T1
C                                       Trap for circular gaussian
                  IF (MODPNT(5,J).LE.-1) TEMP = TT
                  TEMP = 2.0 * C1 * LPARMS(K+3) * TEMP
                  IF (ITYP.EQ.0) THEN
                     FJROW(I) = -EFACT * COS (PHI) * TEMP
                  ELSE
                     FJROW(I) = -EFACT * SIN (PHI) * TEMP
                     END IF
C                                       minor axis
               ELSE IF (JVAR(I).EQ.5) THEN
                  TEMP = 2.0 * C1 * LPARMS(K+4) * T2 * T2
                  IF (ITYP.EQ.0) THEN
                     FJROW(I) = -EFACT * COS (PHI) * TEMP
                  ELSE
                     FJROW(I) = -EFACT * SIN (PHI) * TEMP
                     END IF
C                                       position angle
               ELSE IF (JVAR(I).EQ.6) THEN
                  TEMP = 2.0 * C2 * T1 * T2 * (W1(J) - W2(J))
                  IF (ITYP.EQ.0) THEN
                     FJROW(I) = -EFACT * COS (PHI) * TEMP
                  ELSE
                     FJROW(I) = -EFACT * SIN (PHI) * TEMP
                     END IF
                  END IF
               END IF
 100        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE SPHFUN (M, N, VALVAR, FVEC, FJROW, IFLAG)
C-----------------------------------------------------------------------
C   This routine is called by the Argonne package to calculate the
C   difference between the current fit and the actual data OR the
C   Jacobian for this difference.  Spherical model
C   Inputs:
C        M        I      Number of data points in slice (adj array dim)
C        N        I      No. of parameters (adj. array dim.;
C                        NGAUSS * 3)
C        VALVAR   D(N)   parameters of gaussian components,
C                        GMAX(1), GPOS(1), GWIDTH(1), GMAX(2), ...
C        IFLAG    I      1=calculate difference for current guess.
C                        2=calculate jacobian for current guess.
C    COMMON GDATA
C        RE       R(M)   real part of vis
C        IM       R(M)   imaginary part of vis
C        ITTER    I      number of calls to evaluate FVEC.
C    Outputs:
C        FVEC     D(M)   Slice data points minus data points
C                           evaluated for current guess.
C        FJROW    D(N)   Row (IFLAG - 1) of Jacobian.
C-----------------------------------------------------------------------
      INTEGER   N, M, IFLAG
      DOUBLE PRECISION VALVAR(N), FVEC(M), FJROW(N)
C
      INCLUDE 'UVGIT.INC'
      INCLUDE 'DUVGIT.INC'
      INTEGER   IDA, IDATA, I, J, K, IP, IP1, IP2, ITYP, COUNT
      REAL      GN(30), W1(XMXCMP), C1, ANTFAC, TT, TC, IMMOD, REMOD
      DOUBLE PRECISION PHI, DRA, DECC, DEC0, SUMRE, SUMIM, TEMP, AA, CA,
     *   SA
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      SAVE GN, W1, REMOD, IMMOD
      DATA C1 /8.3668894E-11/
C-----------------------------------------------------------------------
C                                       Determine difference between
C                                       data and current fit.
      DEC0 = DEC * DG2RAD
      IF (IFLAG.LE.1) THEN
         ITTER = ITTER + 1
         IF (ITTER.GT.NITER) THEN
            IFLAG = -1
            GO TO 999
            END IF
C                                       get full parms array
C                                       must be set in COMMON
C                                       defend against blanks
         DO 5 I = 1,XMXPRM
            IF (LPARMS(I).EQ.FBLANK) LPARMS(I) = 0.0D0
 5          CONTINUE
C                                       transfer varying values
         DO 10 I = 1,N
            IF (JVAR(I).EQ.7) THEN
               K = GAPNT(IVAR(I))
            ELSE
               K = 6 * (IVAR(I) - 1) + JVAR(I)
               END IF
            IF (K.GT.0) LPARMS(K) = VALVAR(I)
 10         CONTINUE
C                                       get constants
         DO 20 I = 1,NGAUSS
            K = (I - 1) * 6 + 1
            W1(I) = C1 * LPARMS(K+4)
 20         CONTINUE
         DO 25 I = 1,NANT
            GN(I) = 1.0 / GAIN(I)
            IP = GAPNT(I)
            IF (IP.GT.0) THEN
               VALVAR(IP) = ABS (VALVAR(IP))
               GN(I) = 1.0 / VALVAR(IP)
               END IF
 25         CONTINUE
         CHISQ = 0.0D0
         RMSRES = 0.0D0
         COUNT = 0
         DO 50 IDA = 1,M,MINC
            IDATA = (IDA - 1) / MINC + 1
            SUMRE = RE(IDATA)
            SUMIM = IM(IDATA)
            IP1 = IANT1(IDATA)
            IP2 = IANT2(IDATA)
            ANTFAC = GN(IP1) * GN(IP2)
            TT = U(IDATA) * U(IDATA) + V(IDATA) * V(IDATA)
            K = -5
            DO 40 I = 1,NGAUSS
               K = K + 6
               AA = W1(I) * TT
C                                       Trap very unresolved.
C                                       This needed to prevent
C                                       serious precision loss.
               IF (AA.LT.6.28D-2) AA = 6.28D-2
               CA = COS (AA)
               SA = SIN (AA)
               DRA = AS2RAD * LPARMS(K+1) / COS (DEC0)
               DECC = AS2RAD * LPARMS(K+2) + DEC0
               PHI = TWOPI * ((SIN(DRA)*COS(DECC))*U(IDATA) + V(IDATA)*
     *            (COS(DEC0)*SIN(DECC) - SIN(DEC0)*COS(DECC)*COS(DRA)) +
     *            (SIN(DEC0)*SIN(DECC) + COS(DEC0)*COS(DECC)*COS(DRA)
     *            -1.D0) * W(IDATA))
               TC = 3.0 * ANTFAC * LPARMS(K) * ((SA/(AA*AA*AA)) -
     *            (CA/(AA*AA)))
               IMMOD = TC * SIN (PHI)
               REMOD = TC * COS (PHI)
               SUMRE = SUMRE - REMOD
               SUMIM = SUMIM - IMMOD
 40            CONTINUE
            TEMP = SUMRE * SUMRE + SUMIM * SUMIM
            COUNT = COUNT + 1
            IF (DOAMP) THEN
               FVEC(IDA) = SQRT (TEMP)
               CHISQ = CHISQ + WT(IDATA) * TEMP
               RMSRES = RMSRES + TEMP
            ELSE IF (DOREAL) THEN
               FVEC(IDA) = SUMRE
               CHISQ = CHISQ + WT(IDATA) * SUMRE * SUMRE
               RMSRES = RMSRES + SUMRE * SUMRE
            ELSE
               FVEC(IDA) = SUMRE
               FVEC(IDA+1) = SUMIM
               CHISQ = CHISQ + WT(IDATA) * TEMP
               RMSRES = RMSRES + TEMP
               END IF
 50         CONTINUE
         RMSRES = SQRT (RMSRES / MAX (COUNT, 1))
C                                       calculate Jacobean
      ELSE
         IDA = IFLAG - 1
         IDATA = (IDA - 1) / MINC + 1
         ITYP = MOD (IDA-1, MINC)
         TT = U(IDATA) * U(IDATA) + V(IDATA) * V(IDATA)
         DO 100 I = 1,N
C                                       Gains
            IF (JVAR(I).GT.6) THEN
               IP1 = IVAR(I)
               IF (ITYP.EQ.0) THEN
                  FJROW(I) = -REMOD / GN(IP1)
               ELSE
                  FJROW(I) = -IMMOD / GN(IP1)
                  END IF
C                                       Spheres
            ELSE
               J = IVAR(I)
               K = 6 * (J - 1) + 1
               IP1 = IANT1(IDATA)
               IP2 = IANT2(IDATA)
               ANTFAC = GN(IP1) * GN(IP2)
               AA = W1(J) * TT
C                                       Trap very unresolved.
C                                       This needed to prevent
C                                       serious precision loss.
               IF (AA.LT.6.28D-2) AA = 6.28D-2
               CA = COS (AA)
               SA = SIN (AA)
               DRA = AS2RAD * LPARMS(K+1) / COS (DEC0)
               DECC = AS2RAD * LPARMS(K+2) + DEC0
               PHI = TWOPI * ((SIN(DRA)*COS(DECC))*U(IDATA) + V(IDATA)*
     *            (COS(DEC0)*SIN(DECC) - SIN(DEC0)*COS(DECC)*COS(DRA)) +
     *            (SIN(DEC0)*SIN(DECC) + COS(DEC0)*COS(DECC)*COS(DRA)
     *            -1.D0) * W(IDATA))
               TC = 3.0 * ANTFAC * LPARMS(K) * ((SA/(AA*AA*AA)) -
     *            (CA/(AA*AA)))
               IMMOD = TC * SIN (PHI)
               REMOD = TC * COS (PHI)
C                                       wrt amplitude
               IF (JVAR(I).EQ.1) THEN
                  IF (ITYP.EQ.0) THEN
                     FJROW(I) = -REMOD / (LPARMS(K) + 1.E-20)
                  ELSE
                     FJROW(I) = -IMMOD / (LPARMS(K) + 1.E-20)
                     END IF
C                                       east=west
               ELSE IF (JVAR(I).EQ.2) THEN
                  TEMP = (AS2RAD * TWOPI * COS(DEC)/COS(DEC0)) *
     *               (COS(DRA)*U(IDATA) + SIN(DEC0)*SIN(DRA)*V(IDATA) -
     *               COS(DEC0)*SIN(DRA)*W(IDATA))
                  IF (ITYP.EQ.0) THEN
                     FJROW(I) = IMMOD * TEMP
                  ELSE
                     FJROW(I) = -REMOD * TEMP
                     END IF
C                                       north south
               ELSE IF (JVAR(I).EQ.3) THEN
                  TEMP = AS2RAD * TWOPI * (-SIN(DRA)*SIN(DECC)*U(IDATA)+
     *               (COS(DEC0)*COS(DEC)+SIN(DEC0)*SIN(DECC)*COS(DRA))*
     *               V(IDATA) + W(IDATA) * (COS(DECC)*SIN(DEC0) -
     *               COS(DEC0)*SIN(DECC)*COS(DRA)))
                  IF (ITYP.EQ.0) THEN
                     FJROW(I) = IMMOD * TEMP
                  ELSE
                     FJROW(I) = -REMOD * TEMP
                     END IF
C                                       size
               ELSE IF (JVAR(I).EQ.4) THEN
                  TEMP = 3.0 * LPARMS(K) * C1 * TT / (AA*AA*AA*AA) *
     *               ANTFAC
                  TEMP = TEMP * ( SA * (AA*AA - 3.0) + 3.0 * AA * CA)
                  IF (ITYP.EQ.0) THEN
                     FJROW(I) = -COS (PHI) * TEMP
                  ELSE
                     FJROW(I) = -SIN (PHI) * TEMP
                     END IF

                  END IF
               END IF
 100        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE XGALMS (FCN, M, N, X, FVEC, FJAC, LDFJAC, TOL, INFO,
     *   IPVT)
C-----------------------------------------------------------------------
C   XGALMS provides an extra interface to the math routine LMSTR1
C   and holds the WORK array (for overlay purposes)
C   Inputs:
C      FCN      EXT      Function to evaluate the model
C      M        I        Number data points (adj. array dim.)
C      N        I        Number of unknowns (adj. array dim.)
C      LDFJAC   I        Number points on first axis of FJAC (adj.
C                           array dim.)
C      TOL      D        Tolerance desired
C   In/out:
C      X        D(N)     Initial guess/ answer
C      FVEC     D(M)     Function (Data - model) evaluation
C      FJAC     D(N,N)   Work matrix
C      INFO     I        Error code: 1 - 3 good, 0 bad input,
C                           4 orthogonal, 5 - 7 poor fit
C      IPVT     D(N)     Permutation matrix
C   See precursor remarks to LMSTR1 or LMSTR for details.
C-----------------------------------------------------------------------
      EXTERNAL  FCN
      INTEGER   M, N, LDFJAC, INFO, IPVT(N)
      DOUBLE PRECISION X(N), FVEC(M), FJAC(LDFJAC,N), TOL
C
      INTEGER   LWA
      DOUBLE PRECISION WA(100000)
      DATA LWA /100000/
C-----------------------------------------------------------------------
C                                       It's just a dummy routine
      CALL LMSTR1 (FCN, M, N, X, FVEC, FJAC, LDFJAC, TOL, INFO, IPVT,
     *   WA, LWA)
C
 999  RETURN
      END

      SUBROUTINE DAYNUM (YEAR, DAY, MONTH, DNUM)
C-----------------------------------------------------------------------
C! Determine day number of given date.
C# General
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2012, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  Routine to determine the daynumber of a particular calendar date.
C
C  Inputs:
C     YEAR       I       Year
C     DAY        I       Day of the month
C     MONTH      I       Month of the year
C
C  Output:
C     DNUM       I       Day number
C-----------------------------------------------------------------------
      INTEGER   YEAR, DAY, MONTH, DNUM
C
      INTEGER   J, MONT, IMONT, DAYMTH(12,2), I
      DATA DAYMTH /31,28,31,30,31,30,31,31,30,31,30,31,
     *             31,29,31,30,31,30,31,31,30,31,30,31/
C-----------------------------------------------------------------------
      IF (MOD(YEAR,400).EQ.0) THEN
         I = 2
      ELSE IF (MOD(YEAR,100).EQ.0) THEN
         I = 1
      ELSE IF (MOD(YEAR,4).EQ.0) THEN
         I = 2
      ELSE
         I = 1
         END IF
C
      MONT = 0
      IMONT = MONTH - 1
      DO 100 J = 1,IMONT
         MONT = MONT + DAYMTH(J,I)
 100     CONTINUE
      DNUM = MONT + DAY
C
 999  RETURN
      END

      SUBROUTINE ZDOPR3 (IVOL, IBMLUN, NCOPY, FILNAM, ISIZE, INBLK,
     *   IERR)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZDOPR3 will read a bit map such as produced by PRTPL and plot it
C   on the VERSATEC printer-plotter.  This subroutine can be used
C   to replace ZDOPRT in PRTPL when output to the VERSATEC is not
C   spooled.  This routine expects the device name of the VERSATEC
C   to be LPA0:.  Edit the DATA statement in this routine if you have
C   a different device name.
C     INPUTS:
C        IVOL      volume no. of bit map disk (1 rel) I
C        IBMLUN    bit map logical unit number. I
C        NCOPY     NOT IMPLIMENTED
C        FILNAM    physical file name of bit map. I(12)
C        ISIZE     I    size of INBLK in words
C      IN/Out:
C        INBLK     I(*)    scratch buffer
C     OUTPUTS:
C        IERR      error return code.
C                    0 - good.
C                   >0 - an error occurred.
C   VAX VERSION
C-----------------------------------------------------------------------
      REAL       READ
      INTEGER    INBLK(1), IOBLK(132), SP(12), ISIZE, N1, FILNAM(12)
      INTEGER    LP(12), IFCA(6), IFCB(6), LPA0(12)
      INTEGER    IOSB(4), IBMIND, IERR, IRESET, N0, IFORM, ICLEAR
      INTEGER    N7, N132, N264, IEOT, NCOPY
      INTEGER    ILEN, INPOS, IOPOS, IBMLUN, IVOL, IPLOT
      INTEGER    IRRN(2), IMLINE, ILINE, NBYTES
      LOGICAL    EXCL, NOMAP, WAIT, MAP
      DOUBLE PRECISION
     *       RBYTES
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (EXCL, WAIT, MAP)
      DATA IPLOT /0/, IRESET /2/, ICLEAR /4/, IEOT /8/, IFORM /16/
      DATA N0, N1, N7, N132, N264 / 0, 1, 7, 132, 264/
      DATA LPA0 /'LP','A0',': ',9*'  '/
      DATA READ /'READ'/
      DATA EXCL /.TRUE./,     NOMAP /.FALSE./
C-----------------------------------------------------------------------
C                                       Open the bit map file.
      CALL ZOPEN (IBMLUN, IBMIND, IVOL, FILNAM, MAP, EXCL, WAIT, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT(N7)
         GO TO 999
C                                       Assign chan to plotter, init.
 10   CONTINUE
      CALL ZQASSN (IFCB, LPA0, NOMAP, IERR)
      IF (IERR.NE.0) GO TO 15
      CALL ZQIOV (IRESET, IFCB, IOBLK, N0, IOSB, IERR)
      IF (IERR.NE.0) GO TO 15
      CALL ZQIOV (IFORM, IFCB, IOBLK, N0, IOSB, IERR)
      IF (IERR.NE.0) GO TO 15
      CALL ZQIOV (ICLEAR, IFCB, IOBLK, N0, IOSB, IERR)
      IF (IERR.EQ.0) GO TO 20
15       CONTINUE
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (N7)
         GO TO 990
C                                       Initial buffer counters.
 20   CONTINUE
      INPOS = 257
      IOPOS = 1
      IRRN(1) = 1
      IRRN(2) = 0
      NBYTES = 2 * ISIZE
      ILINE = 0
      CALL ZMI3 (READ, IBMLUN, IBMIND, IRRN, NBYTES, INBLK, N1, IERR)
      IF (IERR.EQ.0) CALL ZWAIT (IBMLUN, IBMIND, N1, IERR)
      IF (IERR.NE.0) GO TO 920
      IRRN(1) = IRRN(1) + NBYTES/NBPS
      IMLINE = INBLK(1)
      RBYTES = 512.0D0 + 264.0D0 * IMLINE - NBYTES
C                                       See if we need to read new buff
 100  CONTINUE
         IF (INPOS.LE.ISIZE) GO TO 110
            IF (RBYTES.LT.NBYTES) NBYTES = RBYTES + 0.1
            CALL ZMI3 (READ, IBMLUN, IBMIND, IRRN, NBYTES, INBLK, N1,
     *         IERR)
            IF (IERR.EQ.0) CALL ZWAIT (IBMLUN, IBMIND, N1, IERR)
            IF (IERR.NE.0) GO TO 920
            RBYTES = RBYTES - NBYTES
            IRRN(1) = IRRN(1) + NBYTES/NBPS
            INPOS = 1
C                                       Determine length to copy.
 110     ILEN = MIN (ISIZE+1-INPOS, 133-IOPOS)
         CALL ZBYTFL (ILEN, INBLK(INPOS), IOBLK(IOPOS))
         IOPOS = IOPOS + ILEN
         INPOS = INPOS + ILEN
C                                       Write to VERSATEC spool file.
         IF (IOPOS.LE.132) GO TO 100
            CALL ZQIOV (IPLOT, IFCB, IOBLK, N264, IOSB, IERR)
            ILINE = ILINE + 1
            IOPOS = 1
            IF (ILINE.LT.IMLINE) GO TO 100
C                                       print 1000 lines of blank
C                                       to move page at correct rate
            CALL FILL (N132, N0, IOBLK)
            DO 130 I = 1,1000
               CALL ZQIOV (IPLOT, IFCB, IOBLK, N264, IOSB, IERR)
               IF (IERR.NE.0) GO TO 940
 130           CONTINUE
            GOTO 990
C                                       Error handling.
 920  WRITE (MSGTXT,1920) IERR
      CALL MSGWRT (N7)
      GO TO 990
 940  WRITE (MSGTXT,1940)
      CALL MSGWRT (N7)
C                                       Issue final form feed and
C                                       close files.
 990  CALL ZQIOV (IFORM, IFCB, IOBLK, N0, IOSB, IERR)
      CALL ZQIOV (IRESET, IFCB, IOBLK, N0, IOSB, IERR)
      CALL ZQIOV (IEOT, IFCB, IOBLK, N0, IOSB, IERR)
      CALL ZQDASS (IFCB, NOMAP, IERR)
      CALL ZQCLOS (IFCA, NOMAP, IERR)
      CALL ZCLOSE (IBMLUN,IBMIND,IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZDOPRT: UNABLE TO OPEN BIT MAP FILE. IERR=',I4)
 1010 FORMAT ('ZDOPRT: UNABLE TO OPEN THE PLOTTER. IERR=', I4)
 1020 FORMAT (A2)
 1110 FORMAT (66A2)
 1920 FORMAT ('ZDOPRT: ZFI3 READ ERROR. IERR=',I4)
 1940 FORMAT ('ZDOPRT: FORTRAN WRITE ERROR TO PLOTTER')
      END

      SUBROUTINE TVVEC (XX, YY, IN, IERR)
C-----------------------------------------------------------------------
C! write bright or dark, scaled or unscaled vector to TV graphics device
C# Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 2000, 2005, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This routine will plot lines on the TV.
C   Inputs:
C      XX    I   X coordinate value.
C      YY    I   Y coordinate value.
C      IN    I   control value:
C                1 = Scale XX and YY and save value
C                2 = Scale XX and YY, draw bright vector
C                3 = Scale XX and YY, draw dark vector
C                11 = XX and YY are not scaled, save value
C                12 = no scale, write bright vector
C                13 = no scale, write dark vector
C   Output:
C      IERR  I   error code, 0=ok, 1=write error.
C-----------------------------------------------------------------------
      REAL      XX, YY
      INTEGER   IN, IERR
C
      INTEGER   JERR, IX(2), IY(2)
      REAL      BLC(2), TRC(2), AX(2), AY(2)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVS.INC'
C-----------------------------------------------------------------------
C                                       Set last X and Y.
      IERR = 0
      BLC(1) = WINDTV(1)
      BLC(2) = WINDTV(2)
      TRC(1) = WINDTV(3)
      TRC(2) = WINDTV(4)
      AX(1) = RXL
      AY(1) = RYL
C                                       If IN = 1 or 2 do scaling.
      IF (IN.LE.3) THEN
         AX(2) = XX*SCALEX + RX0
         AY(2) = YY*SCALEY + RY0
      ELSE
         AX(2) = XX
         AY(2) = YY
         END IF
C                                       Save requested
      RXL = AX(2)
      RYL = AY(2)
C                                       Only bright vectors
      IF ((IN.EQ.2) .OR. (IN.EQ.12)) THEN
C                                       Interpolate at edges
         CALL LINLIM (BLC, TRC, AX, AY, JERR)
         IF (JERR.EQ.0) THEN
            IX(1) = AX(1) + 0.5
            IX(2) = AX(2) + 0.5
            IY(1) = AY(1) + 0.5
            IY(2) = AY(2) + 0.5
            CALL IMVECT ('ONNN', IGR, 2, IX, IY, INBUF, IERR)
            END IF
         END IF
C                                       Only dark vectors
      IF ((IN.EQ.3) .OR. (IN.EQ.13)) THEN
C                                       Interpolate at edges
         CALL LINLIM (BLC, TRC, AX, AY, JERR)
         IF (JERR.EQ.0) THEN
            IX(1) = AX(1) + 0.5
            IX(2) = AX(2) + 0.5
            IY(1) = AY(1) + 0.5
            IY(2) = AY(2) + 0.5
            CALL IMVECT ('OFFF', IGR, 2, IX, IY, INBUF, IERR)
            END IF
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'BPPLT.INC'
      INTEGER   NCODE
      PARAMETER (NCODE=4)
C                                       Local include for BPPLT
      INCLUDE 'INCS:PUVD.INC'
C                                       Input parameters
      REAL      XSIN, XDISIN, XNVER, XQUAL, XTIME(8), XBAND, XFREQ,
     *   XFQID, XSUBA, XBIF, XEIF, XBCHAN, XECHAN, XANT(50), PIXR(2),
     *   XNCOU, XXINC, XDO3C, ABSICA, XSYM, FACTOR, XDOBL, CUTOFF,
     *   XSCAN, XLABEL, XDOTV, XGRCH, XYRATO
      HOLLERITH XNAMEI(3), XCLAIN(2), XTYPE(1), XXSOUR(4,30), XXSTOK(1),
     *   XOPTY(1), XOPCOD(1)
      CHARACTER NAMEIN*12, CLAIN*6, TYPE*2, XSOUR(30)*16, XSTOK*4,
     *   OPTYPE*4, OPCODE*4
C                                       Program info
C
      INTEGER   MXSCAN
      PARAMETER (MXSCAN=5000)
C
      REAL      TSTART, TSTOP, TINT, XYSCL(2), XYOFF(2), YYMX(10),
     *   YYMN(10), XMX, XMN, XMXW, XMNW, GMMOD, RATFAC(MAXIF), SELBAN,
     *   XSTART, XSTOP, CHOUT(4), XXMIN(MAXANT), XXMAX(MAXANT),
     *   YYMIN(2,MAXIF,MAXANT,10), TSCAN(MXSCAN), PPMAX(2,MAXIF,MAXANT),
     *   YYMAX(2,MAXIF,MAXANT,10), PPMIN(2,MAXIF,MAXANT), PRAN(2,2),
     *   DO3COL, TCAL(4,MAXIF,MAXANT), CSMIN, CSMAX, BPARM(2), CPARM(2)
      INTEGER   SEQIN, DISKIN, CNOIN, IVER, BIF, ANTS(50), NCOUNT,
     *   ICODES(10), NCODES, NPARMS, NID, SID(500), NANTSL, NPLOTS,
     *   SUMSTK, ISTOK, FRQSEL, XINC, GRCHN, TVCHN, TVCORN(4), XVAR,
     *   ISOU, OSOU, IANT, EIF, ITPLOT, ITVER, PCNUM, LABEL, SUBARR,
     *   MUMPAR, MUMPOL, MUMIF, MUMANT, NTONE, NUMPTS(MAXANT), ISYM,
     *   BSYM, NANREC(MAXANT), FANREC(MAXANT), NOSCAN, STRANS(MXSCAN),
     *   BCHAN, ECHAN
      LOGICAL   DOAWNT, DOTV, NNODAT, DOLINE, SWAP
      DOUBLE PRECISION SELFRQ, JD0
C                                       SN/CL table info
      INTEGER NUMANT, NUMPOL, NUMIF, NUMFRQ
C                                       Constants
      DOUBLE PRECISION SIDER, CLIGHT
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XTYPE, XNVER,
     *   XXSOUR, XQUAL, XTIME, XXSTOK, XBAND, XFREQ, XFQID, XSUBA, XBIF,
     *   XEIF, XBCHAN, XECHAN, XANT, PIXR, XNCOU, XXINC, XOPTY, XOPCOD,
     *   XDO3C, ABSICA, XSYM, FACTOR, XDOBL, CUTOFF, XSCAN, XLABEL,
     *   XDOTV, XGRCH, XYRATO
      COMMON /VPARM/ SEQIN, DISKIN, CNOIN, IVER, BIF, EIF, ANTS, NCOUNT,
     *   ICODES, NCODES, NPARMS, GRCHN, TVCHN, TVCORN, XVAR, ISOU, OSOU,
     *   IANT, ITPLOT, ITVER, PCNUM, DOTV, NNODAT, LABEL, CHOUT, DO3COL,
     *   DOLINE, NOSCAN, TSCAN, STRANS, SWAP, BCHAN, ECHAN, BPARM, CPARM
      COMMON /VGNCOM/ SELFRQ, JD0,
     *   TSTART, TSTOP, TINT, XYSCL, XYOFF, SELBAN, XMX, XMN, XMXW,
     *   XMNW, XSTART, XSTOP, GMMOD, RATFAC, NID, SID, NANTSL, PRAN,
     *   NPLOTS, DOAWNT, ISTOK, SUMSTK, FRQSEL, XINC,
     *   SUBARR, MUMPAR, MUMPOL, MUMIF, MUMANT, NUMPTS, NTONE,
     *   XXMIN, XXMAX, YYMIN, YYMAX, PPMIN, PPMAX, YYMX, YYMN, ISYM,
     *   BSYM, TCAL, NANREC, FANREC, CSMIN, CSMAX
      COMMON /VGNCHR/ NAMEIN, CLAIN, TYPE, XSOUR, XSTOK, OPTYPE,
     *   OPCODE
      COMMON /TABCOM/ NUMANT, NUMPOL, NUMIF, NUMFRQ
      COMMON /CONST/ SIDER, CLIGHT
C                                                          End BPPLT
LOCAL END
LOCAL INCLUDE 'BPASS.INC'
      INTEGER   BPBUFF(512), NBPINR, IBPRNO, BPKOLS(MAXBPC),
     *   BPNUMV(MAXBPC), IBPLUN, REFANT(2), SOURID, SUBA, ANT, FREQID
      REAL      WEIGHT(MAXIF,2), BNDPAS(2,MAXCIF), INTERV, BANDW
      DOUBLE PRECISION TIME, CHSHFT(MAXIF)
      COMMON /BPCOMM/ BPBUFF, TIME, CHSHFT, WEIGHT, BNDPAS, INTERV,
     *   BANDW, NBPINR, IBPRNO, BPKOLS, BPNUMV, IBPLUN, REFANT, SOURID,
     *   SUBA, ANT, FREQID
LOCAL END
      PROGRAM BPPLT
C-----------------------------------------------------------------------
C! Plots data from a BP table
C# UV Plot EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BPPLT plots BP extension files. A 'PL' extension file is made
C   which can be displayed in the usual ways .
C   Inputs:
C      INNAME.....UV file name (name).       Standard defaults.
C      INCLASS....UV file name (class).      Standard defaults.
C      INSEQ......UV file name (seq. #).     0 => highest.
C      INDISK.....Disk unit #.               0 => any.
C      INEXT......'SN','TY','PC' or 'CL' table to be plotted
C      INVERS.....Version number of table to plot, 0=>highest no.
C      SOURCES....Source list.  '*' = all; a "-" before a source
C                 name means all except ANY source named.
C      TIMERANG...Time range of the data to be plotted. In order:
C                 Start day, hour, min. sec,
C                 end day, hour, min. sec. Days relative to ref.
C                 date.
C      STOKES.....The desired Stokes type of the output data:
C                 'R' = RCP, 'L' = LCP, 'DIFF' = difference
C      BIF........IF to plot
C      ANTENNAS...A list of the antennas to be plotted. All 0 => all.
C                 If any number is negative then all antennas listed
C                 are NOT to be plotted and all others are.
C      PIXRANGE...Limit the plot to values between PIXR(1) and
C                 PIXR(2).  The plots will not exceed the min/max in
C                 the actual gains.  Basically, if PIXR(1) < PIXR(2),
C                 all plots will be on the same scale and be limited
C                 to max (datamin, PIXR(1)) through min (datamax,
C                 PIXR(2)).  If PIXR(1) >= PIXR(2), each plot will be
C                 self-scaled individually.
C      NCOUNT.....Number of antennas to plot per page (try 5).
C      OPTYPE.....Data to be plotted: 'PHAS' = phase, 'AMP '=  ampl.,
C                 'DELA' = delay, 'RATE' = rate, 'TSYS' = sys. temp.
C                 'SUM ' = summary, 'DOPL' = doppler offset, 'SNR' =
C                 signal to noise ratio, 'CCAL' = cable-cal,
C                 'DDLY' = dispersive delay  'IFR' Faraday rotation
C                 '    ' => 'PHAS'
C      OPCODE.....'IFDF' = IF difference, 'PLIF' = all IF's for
C                 specified antennas, ' ' = just OPTYPE
C      XTYPE......Variable data to be plotted against,
C                 1 = IAT time; 2 = elevation; 3 = HA, 4 = LST
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C-----------------------------------------------------------------------
C
      CHARACTER PRGN*6
      REAL      PLTPTS(2)
      LONGINT   PPLTPT
      INTEGER   IRET, MVAL, NWORDS, NROWS
      INCLUDE 'BPPLT.INC'
      INCLUDE 'BPASS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGN /'BPPLT '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL BPPIN (PRGN, NROWS, IRET)
      MUMANT = MAX (1, MUMANT)
      MVAL = 3 + MUMPAR*MUMPOL*MUMIF*NCODES
      NWORDS = (MVAL * NROWS - 1) / 1024  + 21
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, PLTPTS, PPLTPT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         END IF
C                                       read data to figure out
C                                       distribution
      NWORDS = NWORDS * 1024
      IF (IRET.EQ.0) CALL BPPCNT (NWORDS, IRET)
C                                       Fetch data, determine scaling
      IF (IRET.EQ.0) CALL BPPMAX (MVAL, PLTPTS(1+PPLTPT), IRET)
C                                       Do plots
      IF (IRET.EQ.0) CALL BPPLOT (MVAL, MUMANT, PLTPTS(1+PPLTPT), IRET)
      IF (IRET.LT.0) IRET = 0
C                                       Close down
      CALL DIE (IRET, BPBUFF)
C
 999  STOP
      END
      SUBROUTINE BPPIN (PRGN, NROWS, IERR)
C-----------------------------------------------------------------------
C   Gets the inputs parameters for BPPLT.
C   Inputs:
C      PRGN    C*6  Program name
C   Output in common:
C      SUMSTK  I    Selected Stokes 0=both, 1=R, 2=L, 4=difference
C   Output:
C      IERR    I    Error code: 0 => ok
C      ISTOK   I    1 = R, 2 = L
C      ICODE   I    1='PHAS', 2='AMP ', 3='REAL', 4='IMAG', 5='A&P',
C                   6='R&I'
C-----------------------------------------------------------------------
      INTEGER   NROWS, IERR
      CHARACTER PRGN*6
C
      INTEGER   NTPLT
      PARAMETER (NTPLT=5)
C
      INCLUDE 'BPPLT.INC'
      CHARACTER STAT*4, CODE(NCODE)*4, TYPTMP*2, TPLOT(NTPLT)*4
      INTEGER   IRET, BUFF(256), I, J, K, JERR, QUAL(30), NSOUR, LTYPE,
     *   BUFFER(512), IROUND, LUN, NSTOK, ICODE
      LOGICAL T, F, MATCH
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA CODE /'AMP', 'PHAS', 'REAL', 'IMAG'/
      DATA TPLOT /'ALIF', 'ALST', 'ALSI', 'IFDF', 'IFRA'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      OSOU = -1
      NPARMS = 214
C                                        Get input parameters.
      CALL SETUP (PRGN, NPARMS, XNAMEI, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRET = 8
         RQUICK = .FALSE.
         GO TO 990
         END IF
C                                       Decode inputs.
C                                       characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      TYPE = 'BP'
      CALL H2CHR (4, 1, XXSTOK, XSTOK)
      CALL H2CHR (4, 1, XOPTY, OPTYPE)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      ISYM = IROUND (XSYM)
      IF ((ISYM.LE.0) .OR. (ISYM.GT.24)) ISYM = 1
      BSYM = IROUND (XDOBL)
      IF ((BSYM.GT.0) .AND. (BSYM.EQ.ISYM)) BSYM = MOD (ISYM, 24) + 1
C
      DO3COL = XDO3C
      IF (XDO3C.GT.1.5) DO3COL = -1.
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
         QUAL(I) = IROUND (XQUAL)
 20      CONTINUE
      CUTOFF = MAX (0.0, CUTOFF)
      CALL FILL (MAXANT, 0, NUMPTS)
      XTYPE = HBLANK
      CALL CHR2H (2, TYPE, 1, XTYPE)
C                                       Integers
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      IVER = IROUND (XNVER)
      NCOUNT = IROUND (XNCOU)
      IF (NCOUNT.LE.0) NCOUNT = 5
      XNCOU = NCOUNT
      XINC = IROUND (XXINC)
      IF (XINC.LE.0) XINC = 1
      XXINC = XINC
      XVAR = IROUND (ABSICA)
      DOLINE = FACTOR.LT.0.0
      FACTOR = ABS (FACTOR)
      IF ((.NOT.DOLINE) .AND. (FACTOR.LT.0.1)) FACTOR = 1.0
      IF (FACTOR.GT.10.0) FACTOR = 1.0
      IF ((XVAR.LE.0) .OR. (XVAR.GT.6)) XVAR = 1
      ABSICA = XVAR
      BPARM(1) = PIXR(1)
      BPARM(2) = PIXR(1)
      CPARM(1) = PIXR(2)
      CPARM(2) = PIXR(2)
      IF (OPTYPE.EQ.'A&P') THEN
         NCODES = 2
         ICODES(1) = 1
         ICODES(2) = 2
         CPARM(2) = BPARM(2)
      ELSE IF (OPTYPE.EQ.'R&I') THEN
         NCODES = 2
         ICODES(1) = 3
         ICODES(2) = 4
      ELSE
         ICODE = 1
         DO 30 I = 1,NCODE
            IF (OPTYPE.EQ.CODE(I)) ICODE = I
 30         CONTINUE
         CALL CHR2H (4, CODE(ICODE), 1, XOPTY)
         NCODES = 1
         ICODES(1) = ICODE
         END IF
      MUMPAR = 1
      ITPLOT = 0
      DO 35 I = 1,NTPLT
         IF (OPCODE.EQ.TPLOT(I)) ITPLOT = I
 35      CONTINUE
      IF (ITPLOT.GT.0) CALL CHR2H (4, TPLOT(ITPLOT), 1, XOPCOD)
      IF ((ITPLOT.LE.0) .OR. (ITPLOT.GT.3)) DO3COL = -1.0
C                                       Time range
      TSTART = XTIME(1) + (XTIME(2) / 24.0) + (XTIME(3) / (24.0*60.0)) +
     *   (XTIME(4) / (24.0*3600.0))
      TSTOP = XTIME(5) + (XTIME(6) / 24.0) + (XTIME(7) / (24.0*60.0)) +
     *   (XTIME(8) / (24.0*3600.0))
      IF (TSTART.GE.TSTOP) THEN
         TSTART = 0.0
         TSTOP = 999.0
         END IF
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
      LABEL = IROUND (XLABEL)
      LTYPE = MOD (ABS(LABEL), 100)
      IF ((LTYPE.EQ.0) .OR. (LTYPE.GT.10)) LTYPE = 3
      IF (LTYPE.GT.7) LTYPE = 7
      IF ((LTYPE.GE.4) .AND. (LTYPE.LE.6)) LTYPE = 3
      IF (LABEL.LT.0) THEN
         LABEL = (LABEL/100)*100 - LTYPE
      ELSE
         LABEL = (LABEL/100)*100 + LTYPE
         END IF
C                                       Find input catalog
      CNOIN = 1
      TYPTMP = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, TYPTMP,
     *   NLUSER, STAT, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      'UV', NLUSER
         GO TO 990
         END IF
C                                       Save name class etc.
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
      XDISIN = DISKIN
      XSIN = SEQIN
C                                       Read catalog header
      STAT = 'WRIT'
      IF (DOTV) STAT = 'READ'
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, STAT, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FCNO(NCFILE) = CNOIN
      FVOL(NCFILE) = DISKIN
      FRW(NCFILE) = 1
      IF (DOTV) FRW(NCFILE) = 0
      XDISIN = DISKIN
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 990
      SEQIN = CATBLK(KIIMS)
      XSIN = SEQIN
C                                       Subarray
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.EQ.0) SUBARR = 1
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.GE.0) THEN
         LUN = 25
         CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *      FRQSEL, IERR)
         IF (.NOT.MATCH) THEN
            WRITE (MSGTXT,1070)
            IERR = 1
            GO TO 990
            END IF
         IF (IERR.GT.0) GO TO 999
         END IF
C                                       Channels
      BCHAN = IROUND (XBCHAN)
      IF (BCHAN.LE.0) BCHAN = 1
      IF (BCHAN.GT.CATBLK(KINAX+JLOCF)) BCHAN = 1
      ECHAN = IROUND (XECHAN)
      IF (ECHAN.LT.BCHAN) ECHAN = CATBLK(KINAX+JLOCF)
      IF (ECHAN.GT.CATBLK(KINAX+JLOCF)) BCHAN = CATBLK(KINAX+JLOCF)
      XBCHAN = BCHAN
      XECHAN = ECHAN
C                                       IF'S
      IF (JLOCIF.GE.0) THEN
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, CATBLK(KINAX+JLOCIF)))
         EIF = IROUND (XEIF)
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         IF (EIF.GT.CATBLK(KINAX+JLOCIF)) EIF = CATBLK(KINAX+JLOCIF)
      ELSE
         BIF = 1
         EIF = 1
         END IF
      IF ((ITPLOT.GE.4) .AND. (EIF.LE.BIF)) THEN
         MSGTXT = 'OPCODE IFDF/IFRA REQUESTED WITH 1 IF - CONTINUING'
         CALL MSGWRT (6)
         ITPLOT = 0
         OPCODE = ' '
         END IF
C                                       Look up sources
      NID = 500
      NSOUR = 30
      MSGSUP = 32000
      CALL SOURNU (XSOUR, QUAL, NSOUR, DISKIN, CNOIN, NID, BUFFER, SID,
     *   JERR)
      MSGSUP = 0
      IF (JERR.LT.0) THEN
         MSGTXT = 'SPECIFIED SOURCE(S) NOT FOUND - CONTINUING'
         CALL MSGWRT (6)
         END IF
      IF (JERR.NE.0) NID = 0
C                                       Check antennas desired.
      NANTSL = 0
      DOAWNT = T
      DO 70 J = 1,50
         ANTS(J) = IROUND (XANT(J))
         IF (ANTS(J).LT.0) DOAWNT = F
C                                       Make positive
         ANTS(J) = ABS (ANTS(J))
         IF (NANTSL.LT.1) GO TO 60
            DO 50 K = 1,NANTSL
               IF (ANTS(J).EQ.ANTS(K)) ANTS(J) = 0
 50            CONTINUE
C                                       Check for multiple entries
 60      IF (ABS (ANTS(J)).GE.1) NANTSL = J
 70      CONTINUE
C                                       Make sure not too many
      IF (NANTSL.GT.MAXANT) NANTSL = MAXANT
C                                       Get antenna names
      CALL GETANT (DISKIN, CNOIN, MAX (1, SUBARR), CATBLK, BUFFER, JERR)
      MUMANT = NSTNS
      IF (MUMANT.LE.1) THEN
         MUMANT = MAXANT
         TIMLAB = 'IAT'
         END IF
      CALL JULDAY (RDATE, JD0)
C                                       Rate scaling to Hz
C                                       Check Stokes' (R or IPOL)
C                                       Set stokes request
      NSTOK = CATBLK(KINAX+JLOCS)
      MUMPOL = 1
      IF ((ICOR0.EQ.1) .OR. (ICOR0.EQ.-2) .OR. (ICOR0.EQ.-6) .OR.
     *   (((ICOR0.EQ.-1) .OR. (ICOR0.EQ.-5)) .AND. (NSTOK.EQ.1))) THEN
         ISTOK = ABS (ICOR0)
         SUMSTK = 1
         XSTOK = 'I'
         IF (ICOR0.EQ.-2) XSTOK='L'
         IF (ICOR0.EQ.-1) XSTOK='R'
      ELSE IF (XSTOK.EQ.'DIFF') THEN
         ISTOK = 1
         SUMSTK = 3
      ELSE IF (XSTOK.EQ.'RATO') THEN
         ISTOK = 1
         SUMSTK = 4
      ELSE IF (ICOR0.EQ.-1) THEN
         IF ((XSTOK.EQ.'R') .OR. (XSTOK.EQ.'RR')) THEN
            ISTOK = 1
            SUMSTK = 1
            XSTOK = 'R'
         ELSE IF ((XSTOK.EQ.'L') .OR. (XSTOK.EQ.'LL')) THEN
            ISTOK = 2
            SUMSTK = 2
            XSTOK = 'L'
         ELSE
            ISTOK = 1
            SUMSTK = 0
            XSTOK = 'R&L'
            IF (ICODES(1).NE.6) MUMPOL = 2
            END IF
      ELSE IF (ICOR0.EQ.-5) THEN
         IF ((XSTOK.EQ.'V') .OR. (XSTOK.EQ.'VV')) THEN
            ISTOK = 1
            SUMSTK = 1
            XSTOK = 'V'
         ELSE IF ((XSTOK.EQ.'H') .OR. (XSTOK.EQ.'HH')) THEN
            ISTOK = 2
            SUMSTK = 2
            XSTOK = 'H'
         ELSE
            ISTOK = 1
            SUMSTK = 0
            XSTOK = 'V&H'
            IF (ICODES(1).NE.6) MUMPOL = 2
            END IF
         END IF
      CALL CHR2H (4, XSTOK, 1, XXSTOK)
      IF ((SUMSTK.GE.3) .AND. (ITPLOT.GE.4)) THEN
         MSGTXT = 'CANNOT DIFFERENCE POLARIZATIONS AND IFS TOGETHER'
         CALL MSGWRT (6)
         ITPLOT = 0
         END IF
C                                       Open table to check
      CALL BPPOPN (NROWS, IERR)
      IF (IERR.NE.0) GO TO 999
      XNVER = IVER
      MUMIF = EIF - BIF + 1
      IF (ITPLOT.GE.4) MUMIF = 1
      XBIF = BIF
      XEIF = EIF
      CSMAX = -100000
      CSMIN = 1000000
      CALL RFILL (MAXANT, 1.E5, XXMIN)
      CALL RFILL (MAXANT, -1.E5, XXMAX)
      I = 2 * MAXIF * MAXANT
      CALL RFILL (I, 1.E8, PPMIN)
      CALL RFILL (I, -1.E8, PPMAX)
      I = I * 10
      CALL RFILL (I, 1.E8, YYMIN)
      CALL RFILL (I, -1.E8, YYMAX)
      CALL RFILL (10, -1.E8, YYMX)
      CALL RFILL (10,  1.E8, YYMN)
      IF ((XVAR.EQ.1) .AND. (TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         CALL RFILL (MAXANT, TSTART, XXMIN)
         CALL RFILL (MAXANT, TSTOP, XXMAX)
         END IF
      IF ((XSCAN.GT.0.0) .AND. (XVAR.EQ.1)) THEN
         LUN = 25
         CALL GETNX (LUN, DISKIN, CNOIN, CATBLK, SUBARR, BUFFER, NOSCAN,
     *      TSCAN)
      ELSE
         NOSCAN = 0
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR;',I7,'GETTING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',I3,
     *   ' TYPE=',A2,' USER=',I4)
 1040 FORMAT ('ERROR',I3,' COPYING CATALOG HEADER')
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
      END
      SUBROUTINE BPPOPN (NROWS, IERR)
C-----------------------------------------------------------------------
C   Routine to open BP table and get necessary information
C   Input from Common:
C      TYPE     C*2  'BP'
C      DISKIN   I     Disk number
C      CNOIN    I     Catalog slot number
C      CATBLK   I(*)  Catalog header
C      SUMSTK   I     Stokes type requested 0=both, 1=R, 2=L,
C                     3=difference, 4=ratio
C   Output:
C      IERR     I     Error code, 0=OK else failed.
C   Output in common:
C      IBPRNO       I    Current cal record number
C      NBPINR       I    Number of gain records in file.
C      NUMANT       I    Number of antennas
C      NUMPOL       I    Number of polarizations
C      NUMIF        I    Number of IFs.
C      ITVER        I    Version number opened.
C      KOLS         I(*) Column pointers
C      KOLTYP       I(*) Column data types
C      KOLDIM       I(*) Column dimension
C-----------------------------------------------------------------------
      INTEGER   NROWS, IERR
C
      INCLUDE 'BPPLT.INC'
      INCLUDE 'BPASS.INC'
      CHARACTER LBPTYP*8
      INTEGER   NUMSHF, IBCHAN
      LOGICAL   T
      REAL      LOWSHF, DELSHF
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Open table
      IBPLUN = 28
      IBPRNO = 1
      CALL BPINI ('READ', BPBUFF, DISKIN, CNOIN, IVER, CATBLK, IBPLUN,
     *   IBPRNO, BPKOLS, BPNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ, IBCHAN,
     *   NUMSHF, LOWSHF, DELSHF, LBPTYP, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1100) IERR, TYPE, IVER
         GO TO 980
         END IF
      ITVER = IVER
C                                       Get number of scans
      NBPINR = BPBUFF(5)
      NROWS = NBPINR
C                                       Check if empty
      IF (NBPINR.LE.0) THEN
         IERR = 6
         MSGTXT = 'ERROR: SELECTED TABLE IS EMPTY'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Error
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ERROR ',I3,' OPENING ',A,' TABLE NO. ',I3)
      END
      LOGICAL FUNCTION ISTYPE (FTYPE)
C-----------------------------------------------------------------------
C   ISTYPE inquires if type in list of requested types
C   Inputs:
C      FTYPE    I   Test type
C   Output:
C      ISTYPE   L   T => TYPE in ICODES
C-----------------------------------------------------------------------
      INTEGER   FTYPE
C
      INTEGER   I
      INCLUDE 'BPPLT.INC'
C-----------------------------------------------------------------------
      ISTYPE = .FALSE.
      DO 10 I = 1,NCODES
         IF (ICODES(I).EQ.FTYPE) ISTYPE = .TRUE.
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE BPPCNT (NWORDS, IERR)
C-----------------------------------------------------------------------
C   BPPCNT reads the SN or CL table to find the number of samples for
C   each antenna
C   Input:
C      NWORDS   I      Size of work array
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NWORDS, IERR
C
      INCLUDE 'BPPLT.INC'
      INCLUDE 'BPASS.INC'
      LOGICAL   NODATA, OKAY
      INTEGER   I, NP, SCNT(MXSCAN), IRNO
      REAL      XVARIB, CSOU
      REAL      VALUE(2*MAXIF,10)
      DOUBLE PRECISION TB, TE
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      CALL FILL (MAXANT, 0, NANREC)
      CALL FILL (MXSCAN, 0, SCNT)
      NODATA = .TRUE.
      TB = 1.0E5
      TE = -1.0E5
      IF ((XVAR.EQ.1) .AND. (TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TB = TSTART
         TE = TSTOP
         END IF
      XMX = TE
      XMN = TB
      XMXW = TE
      XMNW = TB
C                                       Loop thru data
      DO 100 IRNO = 1,NBPINR,XINC
         IBPRNO = IRNO
         CALL TABBP ('READ', BPBUFF, IBPRNO, BPKOLS, BPNUMV, NUMIF,
     *      NUMFRQ, NUMPOL, TIME, INTERV, SOURID, SUBA, ANT, BANDW,
     *      CHSHFT, FREQID, REFANT, WEIGHT, BNDPAS, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
C                                       Record within specified
C                                       time range ?
         IF ((TIME.LT.TSTART) .OR. (TIME.GT.TSTOP)) GO TO 100
C                                       Freq id
         IF ((FREQID.GT.0) .AND. (FREQID.NE.FRQSEL) .AND. (FRQSEL.GT.0))
     *      GO TO 100
C                                       Subarray
         IF ((SUBA.GT.0) .AND. (SUBARR.GT.0) .AND. (SUBA.NE.SUBARR))
     *      GO TO 100
C                                       Antenna?
         IANT = ANT
         IF (NANTSL.GT.0) THEN
            DO 50 I = 1,NANTSL
               IF ((IANT.EQ.ANTS(I)).AND.DOAWNT) GO TO 60
               IF ((IANT.EQ.ANTS(I)).AND.(.NOT.DOAWNT)) GO TO 100
 50            CONTINUE
            IF (DOAWNT) GO TO 100
            END IF
C                                       Check source
 60      IF (NID.GT.0) THEN
            ISOU = SOURID
            DO 70 I = 1,NID
               IF (ISOU.EQ.SID(I)) GO TO 80
 70            CONTINUE
            GO TO 100
            END IF
C                                      Get start, stop times
 80      TB = MIN (TB, TIME)
         TE = MAX (TE, TIME)
C                                       Get value
         CALL BPPDAT (VALUE, XVARIB, CSOU, OKAY)
C                                       Max. - Min
         IF (((OKAY) .OR. (BSYM.GT.0)) .AND. (XVARIB.NE.FBLANK)) THEN
            IF (OKAY) NODATA = .FALSE.
            NANREC(IANT) = NANREC(IANT) + 1
            I = CSOU + 0.1
            IF ((I.GT.0) .AND. (I.LE.MXSCAN)) SCNT(I) = SCNT(I) + 1
            END IF
 100     CONTINUE
      IERR = MAX (0, IERR)
      FANREC(1) = 1
      DO 120 I = 2,MAXANT
         FANREC(I) = FANREC(I-1) + NANREC(I-1)
 120     CONTINUE
      IF (NWORDS.LT.FANREC(MAXANT)+NANREC(MAXANT)) THEN
         MSGTXT = 'MEMORY TOO SMALL'
         IERR = 10
         END IF
C                                       source number translation
      NP = 0
      CALL FILL (MXSCAN, 0, STRANS)
      DO 130 I = 1,MXSCAN
         IF (SCNT(I).GT.0) THEN
            NP = NP + 1
            STRANS(I) = NP
            END IF
 130     CONTINUE
C
 990  IF (IERR.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('BPPCNT: ERROR =',I3,' FROM TABIO')
      END
      SUBROUTINE BPPMAX (NV, PLTPTS, IERR)
C-----------------------------------------------------------------------
C   BPPMAX reads the BP table to find the max and min values for each
c   station or IF prior to plotting.
C   Input:
C      NV       I      Number values per time (source, T, X, n*Y)
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      PLTPTS   R(*)   Data to be plotted (NV, *)
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NV, IERR
      REAL      PLTPTS(NV,*)
C
      LOGICAL   NODATA, OKAY
      INTEGER   I, NP, NN, IP, IIF, IIS, IS, KK, IRNO
      REAL      TMAX, TMIN, XVARIB, CSOU, TEMP
      DOUBLE PRECISION TB, TE
      INCLUDE 'BPPLT.INC'
      INCLUDE 'BPASS.INC'
      REAL      VALUE(2*MAXIF,10)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      NODATA = .TRUE.
      TB = 1.0E5
      TE = -1.0E5
      IF ((XVAR.EQ.1) .AND. (TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TB = TSTART
         TE = TSTOP
         END IF
      XMX = TE
      XMN = TB
      XMXW = TE
      XMNW = TB
C                                       Loop thru data
      NP = MUMPOL * MUMIF
      DO 100 IRNO = 1,NBPINR,XINC
         IBPRNO = IRNO
         CALL TABBP ('READ', BPBUFF, IBPRNO, BPKOLS, BPNUMV, NUMIF,
     *      NUMFRQ, NUMPOL, TIME, INTERV, SOURID, SUBA, ANT, BANDW,
     *      CHSHFT, FREQID, REFANT, WEIGHT, BNDPAS, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
C                                       Record within specified
C                                       time range ?
         IF ((TIME.LT.TSTART) .OR. (TIME.GT.TSTOP)) GO TO 100
C                                       Freq id
         IF ((FREQID.GT.0) .AND. (FREQID.NE.FRQSEL) .AND. (FRQSEL.GT.0))
     *      GO TO 100
C                                       Subarray
         IF ((SUBA.GT.0) .AND. (SUBARR.GT.0) .AND. (SUBA.NE.SUBARR))
     *      GO TO 100
C                                       Antenna?
         IANT = ANT
         IF (NANTSL.GT.0) THEN
            DO 50 I = 1,NANTSL
               IF ((IANT.EQ.ANTS(I)).AND.DOAWNT) GO TO 60
               IF ((IANT.EQ.ANTS(I)).AND.(.NOT.DOAWNT)) GO TO 100
 50            CONTINUE
            IF (DOAWNT) GO TO 100
            END IF
C                                       Check source
 60      IF (NID.GT.0) THEN
            ISOU = SOURID
            DO 70 I = 1,NID
               IF (ISOU.EQ.SID(I)) GO TO 80
 70            CONTINUE
            GO TO 100
            END IF
C                                      Get start, stop times
 80      TB = MIN (TB, TIME)
         TE = MAX (TE, TIME)
C                                       Get value
         CALL BPPDAT (VALUE, XVARIB, CSOU, OKAY)
C                                       Max. - Min
         IF (((OKAY) .OR. (BSYM.GT.0)) .AND. (XVARIB.NE.FBLANK)) THEN
            IF (OKAY) NODATA = .FALSE.
C                                       Put in array
            NUMPTS(IANT) = NUMPTS(IANT) + 1
            NN = FANREC(IANT) + NUMPTS(IANT) - 1
            IS = CSOU + 0.1
            IF ((IS.GT.0) .AND. (IS.LE.MXSCAN)) CSOU = STRANS(IS)
            PLTPTS(1,NN) = CSOU
            PLTPTS(2,NN) = TIME
            PLTPTS(3,NN) = XVARIB
            KK = 4
            DO 81 I = 1,NCODES
               CALL RCOPY (NP, VALUE(1,I), PLTPTS(KK,NN))
               KK = KK + NP
 81            CONTINUE
            IF (ICODES(1).EQ.6) CALL RCOPY (NP, VALUE(1,2),
     *         PLTPTS(KK,NN))
            IF (XVAR.NE.6) THEN
               XMX = MAX (XMX, XVARIB)
               XMN = MIN (XMN, XVARIB)
            ELSE
               TEMP = XVARIB
               IF (TEMP.LT.0.0) TEMP = TEMP + 360.
               XMX = MAX (XMX, TEMP)
               XMN = MIN (XMN, TEMP)
               IF (TEMP.GT.180.0) TEMP = TEMP - 360
               XMXW = MAX (XMXW, TEMP)
               XMNW = MIN (XMNW, TEMP)
               END IF
            XXMAX(IANT) = MAX (XXMAX(IANT), XVARIB)
            XXMIN(IANT) = MIN (XXMIN(IANT), XVARIB)
            CSMIN = MIN (CSMIN, CSOU)
            CSMAX = MAX (CSMAX, CSOU)
C                                       If not a summary plot
            DO 95 KK = 1,NCODES
               IP = 0
               DO 90 IIF = 1,MUMIF
                  DO 85 IIS = 1,MUMPOL
                     IP = IP + 1
                     IF (VALUE(IP,KK).NE.FBLANK) THEN
                        YYMX(KK) = MAX (YYMX(KK), VALUE(IP,KK))
                        YYMN(KK) = MIN (YYMN(KK), VALUE(IP,KK))
                        IF (ICODES(KK).EQ.1) THEN
                           IF (VALUE(IP,KK).LE.-180.0) THEN
                              VALUE(IP,KK) = VALUE(IP,KK) + 360.
                           ELSE IF (VALUE(IP,KK).GT.180.) THEN
                              VALUE(IP,KK) = VALUE(IP,KK) - 360.
                              END IF
                           YYMIN(IIS,IIF,IANT,KK) = MIN (VALUE(IP,KK),
     *                        YYMIN(IIS,IIF,IANT,KK))
                           YYMAX(IIS,IIF,IANT,KK) = MAX (VALUE(IP,KK),
     *                        YYMAX(IIS,IIF,IANT,KK))
                           IF (VALUE(IP,KK).LT.0.0) VALUE(IP,KK) =
     *                        VALUE(IP,KK) + 360.0
                           PPMIN(IIS,IIF,IANT) = MIN (VALUE(IP,KK),
     *                        PPMIN(IIS,IIF,IANT))
                           PPMAX(IIS,IIF,IANT) = MAX (VALUE(IP,KK),
     *                        PPMAX(IIS,IIF,IANT))
                        ELSE IF (ICODES(KK).EQ.6) THEN
                           YYMIN(1,1,1,KK) = MIN (VALUE(IP,KK),
     *                        YYMIN(1,1,1,KK))
                           YYMAX(1,1,1,KK) = MAX (VALUE(IP,KK),
     *                        YYMAX(1,1,1,KK))
                           IF (VALUE(IP,2).LE.-180.0) THEN
                              VALUE(IP,2) = VALUE(IP,2) + 360.
                           ELSE IF (VALUE(IP,2).GT.180.) THEN
                              VALUE(IP,2) = VALUE(IP,2) - 360.
                              END IF
                           YYMIN(2,1,1,KK) = MIN (VALUE(IP,2),
     *                        YYMIN(2,1,1,KK))
                           YYMAX(2,1,1,KK) = MAX (VALUE(IP,2),
     *                        YYMAX(2,1,1,KK))
                           IF (VALUE(IP,2).LT.0.0) VALUE(IP,2) =
     *                        VALUE(IP,2) + 360.
                           PPMIN(1,1,1) = MIN (VALUE(IP,2),
     *                        PPMIN(1,1,1))
                           PPMAX(1,1,1) = MAX (VALUE(IP,2),
     *                        PPMAX(1,1,1))
                        ELSE
                           YYMIN(IIS,IIF,IANT,KK) = MIN (VALUE(IP,KK),
     *                        YYMIN(IIS,IIF,IANT,KK))
                           YYMAX(IIS,IIF,IANT,KK) = MAX (VALUE(IP,KK),
     *                        YYMAX(IIS,IIF,IANT,KK))
                           END IF
                        END IF
 85                  CONTINUE
 90               CONTINUE
 95            CONTINUE
            END IF
 100     CONTINUE
      IERR = MAX (0, IERR)
C                                       reset max min on fixed scale
      DO 125 KK = 1,NCODES
         IF (BPARM(KK).LT.CPARM(KK)) THEN
            YYMX(KK) = CPARM(KK)
            YYMN(KK) = BPARM(KK)
            DO 120 IANT = 1,MUMANT
               DO 115 IIF = 1,MUMIF
                  DO 110 IIS = 1,MUMPOL
                     IF (YYMAX(IIS,IIF,IANT,KK).GE.
     *                  YYMIN(IIS,IIF,IANT,KK)) THEN
                        YYMAX(IIS,IIF,IANT,KK) = CPARM(KK)
                        YYMIN(IIS,IIF,IANT,KK) = BPARM(KK)
                        IF (ICODES(KK).EQ.1) THEN
                           PPMAX(IIS,IIF,IANT) = CPARM(KK)
                           PPMIN(IIS,IIF,IANT) = BPARM(KK)
                           END IF
                        END IF
 110                 CONTINUE
 115              CONTINUE
 120           CONTINUE
            END IF
         IF (ICODES(KK).EQ.6) THEN
            IF (YYMAX(2,1,1,KK)-YYMIN(2,1,1,KK).GT.
     *         PPMAX(1,1,1)-PPMIN(1,1,1)) THEN
               YYMAX(2,1,1,KK) = PPMAX(1,1,1)
               YYMIN(2,1,1,KK) = PPMIN(1,1,1)
               END IF
            END IF
 125     CONTINUE
C                                       Set actual X range
      SWAP = .FALSE.
      IF (XVAR.EQ.1) THEN
         XSTART = TB
         XSTOP = TE
      ELSE IF (XVAR.EQ.6) THEN
         IF (XMX-XMN.LE.XMXW-XMNW) THEN
            XSTART = XMN
            XSTOP  = XMX
         ELSE
            XSTART = XMNW
            XSTOP  = XMXW
            SWAP = .TRUE.
            END IF
      ELSE
         XSTART = XMN
         XSTOP  = XMX
         END IF
C                                       Check for no data
      IF (NODATA) THEN
         IERR = 6
         MSGTXT = 'NO DATA SELECTED'
         GO TO 990
         END IF
C                                       check and set scaling
      IF ((XVAR.EQ.1) .AND. (TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TMAX = (XSTOP + 0.03 * (XSTOP - XSTART)) * 360.0
         TMIN = (XSTART- 0.03 * (XSTOP - XSTART)) * 360.0
      ELSE IF ((XVAR.EQ.1) .OR. (XVAR.EQ.3) .OR. (XVAR.EQ.4)) THEN
         TMAX = (XSTOP + 0.1 * (XSTOP - XSTART)) * 360.0
         TMIN = (XSTART- 0.1 * (XSTOP - XSTART)) * 360.0
      ELSE
         TMAX = (XSTOP + 0.1 * (XSTOP - XSTART))
         TMIN = (XSTART- 0.1 * (XSTOP - XSTART))
         END IF
C                                       If start time is stop time,
      IF (ABS (TMAX-TMIN) .LT. 0.01) THEN
         TMIN = MAX( TMIN-0.005, 0.0)
         TMAX = TMIN + 0.01
         END IF
      TSTART = TB
      TSTOP = TE
      XYOFF(1) = TMIN
      XYSCL(1) = 1000.0 / (TMAX - TMIN)
      PRAN(1,1) = TMIN
      PRAN(2,1) = TMAX
C                                       Send back time range
      XTIME(1) = TSTART
      XTIME(2) = 0.0
      XTIME(3) = 0.0
      XTIME(4) = 0.0
      XTIME(5) = TSTOP
      XTIME(6) = 0.0
      XTIME(7) = 0.0
      XTIME(8) = 0.0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('BPPMAX: ERROR =',I3,' FROM TABIO')
      END
      SUBROUTINE GETSCL (KK, LST1, LST2, LIF1, LIF2, LANT, DOIT)
C-----------------------------------------------------------------------
C   GETSCL converts a number of max/min's to a scale
C   Inputs:
C      KK      I   parameter number
C      LST1    I   1st Stokes
C      LST2    I   Upper Stokes
C      LIF1    I   1st IF number
C      LIF2    I   1st IF number
C      LANT    I   Antenna number
C   Output:
C      DOIT    L      There were valid values
C   Output in common
C      XYSCL   R(2)   Scaling - only 2nd one changed
C      XYOFF   R(2)   Offset  - only second one changed
C-----------------------------------------------------------------------
      INTEGER   KK, LST1, LST2, LIF1, LIF2, LANT
      LOGICAL   DOIT
C
      INCLUDE 'BPPLT.INC'
      INTEGER   IST, IIF
      REAL      YMX, YMN, PMX, PMN, TMAX, TMIN, TDIF, TOLER(30), SIZEY
C                                       Minimum value range for each
C                                       ICODE
C                  phs    amp    delay    rate    Tsys Summary doppler
      DATA TOLER /0.001, 0.001, 1.0E-12, 1.0E-8, 0.001,  0.01,  0.001,
C                  snr  MB delay   Tant    Atm dly  geo dly  ccal
     *            0.001, 1.0E-12, 0.000001, 1.0E-12, 1.0E-12, 1.0E-14,
C                  ddely   real   imag  Faraday Pdif   Psum   Pgn
     *            1.0E-12, 0.001, 0.001, 0.005, 0.001, 0.001, 1.E-5,
C                 Pon   Poff  Psys   PDgain PSgain
     *            0.01, 0.01, 0.01,  0.001, 0.001, 5*0.0/
C-----------------------------------------------------------------------
      DOIT = .FALSE.
      YMX = -1.E8
      YMN = -YMX
      PMX = YMX
      PMN = YMN
      DO 30 IIF = LIF1,LIF2
         DO 20 IST = LST1,LST2
            IF (YYMAX(IST,IIF,LANT,KK).GE.YYMIN(IST,IIF,LANT,KK)) THEN
               DOIT = .TRUE.
               YMX = MAX (YMX, YYMAX(IST,IIF,LANT,KK))
               YMN = MIN (YMN, YYMIN(IST,IIF,LANT,KK))
               IF (ICODES(KK).EQ.1) THEN
                  PMX = MAX (PMX, PPMAX(IST,IIF,LANT))
                  PMN = MIN (PMN, PPMIN(IST,IIF,LANT))
                  END IF
               END IF
 20         CONTINUE
 30      CONTINUE
      IF ((ICODES(KK).EQ.1) .AND. (PMX-PMN.LT.YMX-YMN)) THEN
         YMX = PMX
         YMN = PMN
         END IF
      SIZEY = 1000.0 / NCOUNT
      TMAX = YMX + 0.1 * (YMX - YMN)
      TMIN = YMN - 0.1 * (YMX - YMN)
      IF (ABS (TMAX-TMIN) .LT. TOLER(ICODES(KK))) THEN
         TMAX = TMAX + TOLER(ICODES(KK))
         TMIN = TMIN - TOLER(ICODES(KK))
         END IF
      TDIF = TMAX - TMIN
      IF (ABS (TDIF).LE.1.0E-25) TDIF = 1.0E-25
      XYOFF(2) = TMIN
      XYSCL(2) = 1000.0 / TDIF / NCOUNT
      PRAN(1,2) = TMIN
      PRAN(2,2) = TMAX
C
 999  RETURN
      END
      SUBROUTINE BPPDAT (VALUE, XVARIB, CSOU, OKAY)
C-----------------------------------------------------------------------
C   Routine to get the specified value from a SN/CL/TY table entry
C   Input from common:
C      ICODE    I     Plot code
C      SUMSTK   I     Selected Stokes 0=both, 1=R, 2=L, 3=Difference
C   Also uses pointers etc. set in BPPOPN
C   Output:
C      VALUE    R(*)   Table value, magic value blanked (amp on ICODE 6)
C      XVARIB   R      Value of associated x-axis variable
C      CSOU     R      source number
C      OKAY     L      Some values are good
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      REAL      VALUE(2*MAXIF,*), XVARIB, CSOU
      LOGICAL   OKAY
C
      INCLUDE 'BPPLT.INC'
      INTEGER   IS, IIF, LP, KK, ICODE
      REAL      V2, VALS(2,2,MAXIF)
      LOGICAL   T, DORATO, DODIFF
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       In case the data is bad
      LP = MUMPOL * MUMIF
      CALL XCALC (XVARIB, CSOU)
      CALL VCALC (VALS)
      DO 900 KK = 1,NCODES
         ICODE = ICODES(KK)
         CALL RFILL (LP, FBLANK, VALUE(1,KK))
         DODIFF = (ITPLOT.EQ.4) .OR. (SUMSTK.EQ.3)
         DORATO = (ITPLOT.EQ.5) .OR. (SUMSTK.EQ.4)
C                                       Select data type
C                                       Phase (deg)
         IF (ICODE.EQ.2) THEN
            DO 110 IS = 1,MUMPOL
               LP = IS - MUMPOL
               DO 105 IIF = 1,MUMIF
                  LP = LP + MUMPOL
                  IF ((VALS(2,IS,IIF).NE.FBLANK) .AND.
     *               (VALS(1,IS,IIF).NE.FBLANK)) THEN
                     IF (DODIFF) THEN
                        IF ((VALS(1,2,IIF).NE.FBLANK) .AND.
     *                     (VALS(2,2,IIF).NE.FBLANK)) THEN
                           VALUE(LP,KK) = 57.296 *
     *                        (ATAN2 (VALS(2,1,IIF), VALS(1,1,IIF) +
     *                        1.0E-20)
     *                        -ATAN2 (VALS(2,2,IIF), VALS(1,2,IIF) +
     *                        1.0E-20))
                           IF (VALUE(LP,KK).LE.-180.0) VALUE(LP,KK) =
     *                        VALUE(LP,KK) + 360.0
                           IF (VALUE(LP,KK).GT.+180.0) VALUE(LP,KK) =
     *                        VALUE(LP,KK) - 360.0
                           END IF
                     ELSE
                        VALUE(LP,KK) = 57.296 *
     *                     ATAN2 (VALS(2,IS,IIF), VALS(1,IS,IIF) +
     *                     1.0E-20)
                        END IF
                     END IF
 105              CONTINUE
 110           CONTINUE
C                                       Amplitude
         ELSE IF (ICODE.EQ.1) THEN
            DO 130 IS = 1,MUMPOL
               LP = IS - MUMPOL
               DO 125 IIF = 1,MUMIF
                  LP = LP + MUMPOL
                  IF ((VALS(1,IS,IIF).NE.FBLANK) .AND.
     *               (VALS(2,IS,IIF).NE.FBLANK)) THEN
                     IF (DORATO) THEN
                        V2 = 0.0
                        IF ((VALS(1,2,IIF).NE.FBLANK) .AND.
     *                     (VALS(2,2,IIF).NE.FBLANK)) V2 =
     *                     SQRT (VALS(1,2,IIF)**2+VALS(2,2,IIF)**2)
                        IF (V2.NE.0.0) VALUE(LP,KK) =
     *                     SQRT ((VALS(1,1,IIF)**2 +
     *                     VALS(2,1,IIF)**2)) / V2
                     ELSE IF (DODIFF) THEN
                        IF ((VALS(1,2,IIF).NE.FBLANK) .AND.
     *                     (VALS(2,2,IIF).NE.FBLANK)) VALUE(LP,KK) =
     *                     SQRT ((VALS(1,1,IIF)-VALS(1,2,IIF))**2  +
     *                     (VALS(2,1,IIF)-VALS(2,2,IIF))**2)
                     ELSE
                        VALUE(LP,KK) = SQRT ((VALS(1,IS,IIF)**2) +
     *                     (VALS(1,IS,IIF)**2))
                        END IF
                     END IF
 125              CONTINUE
 130           CONTINUE
C                                       Real
         ELSE IF (ICODE.EQ.3) THEN
            DO 150 IS = 1,MUMPOL
               LP = IS - MUMPOL
               DO 145 IIF = 1,MUMIF
                  LP = LP + MUMPOL
                  IF (VALS(1,IS,IIF).NE.FBLANK) THEN
                     IF (DODIFF) THEN
                        IF (VALS(1,2,IIF).NE.FBLANK)
     *                     VALUE(LP,KK) = VALS(1,2,IIF) -
     *                     VALS(1,2,IIF)
                     ELSE
                        VALUE(LP,KK) = VALS(1,IS,IIF)
                        END IF
                     END IF
 145              CONTINUE
 150           CONTINUE
C                                       IMAG
         ELSE IF (ICODE.EQ.4) THEN
            DO 170 IS = 1,MUMPOL
               LP = IS - MUMPOL
               DO 165 IIF = 1,MUMIF
                  LP = LP + MUMPOL
                  IF (VALS(1,IS,IIF).NE.FBLANK) THEN
                     IF (DODIFF) THEN
                        IF (VALS(1,2,IIF).NE.FBLANK)
     *                     VALUE(LP,KK) = VALS(2,2,IIF) -
     *                     VALS(2,2,IIF)
                     ELSE
                        VALUE(LP,KK) = VALS(2,IS,IIF)
                        END IF
                     END IF
 165              CONTINUE
 170           CONTINUE
            END IF
 900     CONTINUE
C
      OKAY = .TRUE.
      LP = MUMPOL * MUMIF
      DO 910 IS = 1,LP
         IF (VALUE(IS,KK).NE.FBLANK) GO TO 999
 910     CONTINUE
      OKAY = .FALSE.
C
 999  RETURN
      END
      SUBROUTINE VCALC (VALS)
C-----------------------------------------------------------------------
C   VCALC averages channels in bandpass
C   Output:
C      VALS   R(2,2,*)   Real, imaginary for RR, LL for BIF to EIF
C-----------------------------------------------------------------------
      REAL      VALS(2,2,*)
C
      INCLUDE 'BPPLT.INC'
      INCLUDE 'BPASS.INC'
      INTEGER   IIF, IP, I, I1
      REAL      SRE, SIM, WT
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      DO 100 IP = 1,2
         DO 90 IIF = BIF,EIF
            SRE = 0.0
            SIM = 0.0
            WT = 0.0
            I1 = BCHAN - 1 + (IIF-1) * NUMFRQ + (IP-1) * NUMIF * NUMFRQ
            DO 80 I = BCHAN,ECHAN
               I1 = I1 + 1
               IF (BNDPAS(1,I1).NE.FBLANK) THEN
                  SRE = SRE + BNDPAS(1,I1)
                  SIM = SIM + BNDPAS(2,I1)
                  WT = WT + 1.0
                  END IF
 80            CONTINUE
            IF (WT.GT.0.0) THEN
               VALS(1,IP,IIF-BIF+1) = SRE / WT
               VALS(2,IP,IIF-BIF+1) = SIM / WT
            ELSE
               VALS(1,IP,IIF-BIF+1) = FBLANK
               VALS(2,IP,IIF-BIF+1) = FBLANK
               END IF
 90         CONTINUE
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE BPPLOT (NV, NA, PLTPTS, IRET)
C-----------------------------------------------------------------------
C   BPPLOT plots the data thru calls to PLTSN.
C   Input:
C      NV       I      Number values per antenna (source, T, X, Y data)
C      NA       I      Number antennas in data array
C      PLTPTS   R(*)   Data (NV,*)
C   Output:
C      IRET     I      Return code, 0=OK else failed
C-----------------------------------------------------------------------
      INTEGER   NV, NA, IRET
      REAL      PLTPTS(NV,*)
C
      INTEGER   IPLOT, JPLT, IPLT, NPLT, DIFF, LUMIF, LIF1, LIF2, KK,
     *   LUMST, LST1, LST2, IIF, IIS
      LOGICAL   ONEIF, ONEST, DOIT
      INCLUDE 'BPPLT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IPLOT = 0
      DIFF = MAX (1, SUMSTK-1)
      IF ((DIFF.EQ.1) .AND. (ITPLOT.GE.4)) DIFF = ITPLOT - 2
C                                       Summary plot?
      IF (OPTYPE.EQ.'SUM ') THEN
         CALL SUMPLT (DIFF, NV, NA, PLTPTS, IRET)
C                                       Loop thru stations to plot
      ELSE
         ONEST = (OPCODE.EQ.'ALST') .OR. (OPCODE.EQ.'ALSI')
         ONEIF = (OPCODE.EQ.'ALIF') .OR. (OPCODE.EQ.'ALSI')
         IF (ONEIF) THEN
            LUMIF = 1
            LIF1 = 1
            LIF2 = MUMIF
         ELSE
            LUMIF = MUMIF
            END IF
         IF (ONEST) THEN
            LUMST = 1
            LST1 = 1
            LST2 = MUMPOL
         ELSE
            LUMST = MUMPOL
            END IF
C                                       count the plots
         NPLOTS = 0
         DO 40 IPLT = 1,MUMANT
            DO 35 IIF = 1,LUMIF
               IF (.NOT.ONEIF) THEN
                  LIF1 = IIF
                  LIF2 = IIF
                  END IF
               DO 30 IIS = 1,LUMST
                  IF (.NOT.ONEST) THEN
                     LST1 = IIS
                     LST2 = IIS
                     END IF
                  DO 25 KK = 1,NCODES
                     CALL GETSCL (KK, LST1, LST2, LIF1, LIF2, IPLT,
     *                  DOIT)
                     IF (DOIT) NPLOTS = NPLOTS + 1
 25                  CONTINUE
 30               CONTINUE
 35            CONTINUE
 40         CONTINUE
C                                       Now plot
         NPLT = 0
         DO 100 IPLT = 1,MUMANT
            DO 90 IIF = 1,LUMIF
               IF (.NOT.ONEIF) THEN
                  LIF1 = IIF
                  LIF2 = IIF
                  END IF
               DO 80 IIS = 1,LUMST
                  IF (.NOT.ONEST) THEN
                     LST1 = IIS
                     LST2 = IIS
                     END IF
                  DO 70 KK = 1,NCODES
                     CALL GETSCL (KK, LST1, LST2, LIF1, LIF2, IPLT,
     *                  DOIT)
                     IF (DOIT) THEN
                        NPLT = NPLT + 1
                        JPLT = NPLT
                        IPLOT = MOD (NPLT-1, NCOUNT) + 1
                        IF (NPLT.EQ.NPLOTS) IPLOT = -IPLOT
                        CALL PLTSN (IPLOT, KK, LST1, LST2, LIF1, LIF2,
     *                     IPLT, DIFF, NV, PLTPTS, IRET)
                        IF (IRET.NE.0) GO TO 999
                        END IF
 70                  CONTINUE
 80               CONTINUE
 90            CONTINUE
 100        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE PLTSN (IPLOT, KK, LST1, LST2, LIF1, LIF2, ANTNO, DIFF,
     *   NV, PLTPTS, IRET)
C-----------------------------------------------------------------------
C   PLTSN actually plots data.
C   Input:
C      IPLOT    I      Plot number on current page. If neg. then this is
C                      last plot.
C      KK       I      Parameter number
C      LST1     I      1st Stokes this plot
C      LST2     I      last Stokes this plot
C      LIF1     I      1st IF this plot
C      LIF2     I      last IF this plot
C      ANTNO    I      Antenna number
C      DIFF     I      3/2 if plotting ratio/difference between Stokes
C                      parameters , 1 otherwise
C      NV       I      Number values
C      PLTPTS   R(*)   Data to plot (NV,*)
C   Output:
C      IRET     I      Return code, 0 => OK, otherwise abort.
C                       -1 => user request termination
C                        1 => failed to add to catalog
C                        2 => failed to create
C                        3 => graph file write error
C                        4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   IPLOT, kk, LST1, LST2, LIF1, LIF2, ANTNO, DIFF, NV,
     *   IRET
      REAL      PLTPTS(NV,*)
C
      INCLUDE 'BPPLT.INC'
C
      CHARACTER TEXT*132, PFILE*48, ATIME*8, ADATE*12, CHTMP*18,
     *   AUNITS(NCODE,3)*8, CHTYPE(NCODE,3)*16, XUNITS(6)*20, TXTMSG*80,
     *   CSAVE*5
      INTEGER   BUFFER(256), VER, IERR, ITYPE, IPSIZE, LUNPL, LTYPE,
     *   FINDPL, DEPTH(5), INCHAR, INP, IT(3), ID(3), IAXLAB, IAPLOT,
     *   I, NGOOD, NNOFIT, JCODE, NN, IP, IST, IIF, LDIFF, ILITY, NNN
      REAL      BLC(2), TRC(2), DX, DY, TR, VALUE, TI, XY(2),
     *   XTRC(2), XBLC(2), TLC(2), PLTINC, YYOFF(2), SIZE, XMULT(2),
     *   DBY, COLV, COL(3), COLR, AX(5), AY(5), OLDSRC
      LOGICAL   T, F, GOOD, CATUP, DONEG, DO3C, BLNKD, SCOLOR, DOCOLR
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      SAVE XMULT, CSAVE, LTYPE, BUFFER
      DATA LUNPL /26/
      DATA DEPTH /5*1/
      DATA T, F /.TRUE.,.FALSE./
      DATA AUNITS /'Gain','Degrees','Gain','Gain',
     *   'Gain','Degrees','Gain','Gain',
     *   'Gain','Degrees','Gain','Gain'/
      DATA CHTYPE /'Gain amp', 'Gain phs', 'Gain real','Gain imag',
     *   'Gain amp diff', 'Gain phs diff', 'Gain real diff',
     *   'Gain imag diff', 'Gain amp ratio', ' ', 'Gain real ratio',
     *   'Gain imag ratio'/
      DATA XUNITS /'IAT (hr)', 'Elevation (degrees)',
     *   'Hour Angle (hr)', 'LST (hr)', 'Parallactic angle',
     *   'Azimuth (degrees)' /
C-----------------------------------------------------------------------
C                                       Time system from AN table
      SCOLOR = (XDO3C.GT.1.5) .AND. (CSMAX-CSMIN.GT.0.99)
      OLDSRC = -1000.0
      XUNITS(1)(1:3) = TIMLAB(1:3)
      NGOOD = 0
      NNOFIT = 0
      IRET = 3
      CATUP = T
C
      JCODE = ICODES(KK)
      IF (TYPE.EQ.'PC') THEN
         IF (JCODE.EQ.1) JCODE = NCODE+1
         IF (JCODE.EQ.2) JCODE = NCODE+2
         END IF
C                                       Create plot file
      IF (ABS (IPLOT).EQ.1) THEN
C                                       Update catalog header.
         VER = 0
         IRET = 1
         IF (.NOT.DOTV) THEN
            CALL MADDEX ('PL', DISKIN, CNOIN, CATBLK, BUFFER, CATUP,
     *         'WRIT', VER, IERR)
            IF (IERR.NE.0) THEN
               NCFILE = NCFILE - 1
               GO TO 999
               END IF
            END IF
         CALL ZPHFIL ('PL', DISKIN, CNOIN, VER, PFILE, IERR)
         IF (IERR.NE.0) GO TO 960
         IPSIZE = 0
         ITYPE = 78
         CALL GINIT (DISKIN, CNOIN, PFILE, IPSIZE, ITYPE, NPARMS,
     *      XNAMEI, DOTV, TVCHN, GRCHN, TVCORN, CATBLK, BUFFER, LUNPL,
     *      FINDPL, IERR)
         IRET = 2
         IF (IERR.NE.0) GO TO 960
         END IF
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      IF (DOTV) THEN
         TRC(1) = WINDTV(3) - WINDTV(1)
         TRC(2) = WINDTV(4) - WINDTV(2)
         IF (DO3COL.LE.0.0) THEN
            CALL GCINIT (GPHTVG(4), 0, IERR)
            IF (IERR.NE.0) GO TO 960
            CALL GCINIT (GPHTVG(3), 0, IERR)
            IF (IERR.NE.0) GO TO 960
            END IF
         END IF
      PLTINC = TRC(2) / NCOUNT
      IF (XYRATO.LT.0.01) XYRATO = 1.0
C                                       Set window for current plot.
      XBLC(1) = BLC(1)
      XBLC(2) = TRC(2) - ABS (IPLOT) * PLTINC
      XTRC(1) = TRC(1)
      XTRC(2) = XBLC(2) + PLTINC - 1.0
      TLC(1) = XBLC(1)
      TLC(2) = XTRC(2)
C                                       Offsets for current plot.
      YYOFF(1) = XBLC(1)
      YYOFF(2) = XBLC(2)
C                                       fool with location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 7
      IF (XVAR.EQ.2) LABTYP(LOCNUM) = 0
      IF (XVAR.EQ.6) LABTYP(LOCNUM) = 0
      IF (XVAR.EQ.3) LABTYP(LOCNUM) = 8
      IF (XVAR.EQ.4) LABTYP(LOCNUM) = 9
      IF (XVAR.EQ.5) LABTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      TR = 1.1 * (PRAN(2,2)-PRAN(1,2))
      IF (TR.LE.0.0) TR = 1.0
      IF ((ABS(IPLOT).EQ.1) .OR. (NCODES.GT.1)) THEN
         TI = TR
         CALL METSCL (LABEL, TR, CPREF(2,LOCNUM), GOOD)
         XMULT(2) = TR / TI
         CSAVE = CPREF(2,LOCNUM)
         END IF
      CPREF(1,LOCNUM) = ' '
      XMULT(1) = 1.0
      DO 50 I = 1,2
         SIZE = XTRC(I) - XBLC(I) + 1
         TR = PRAN(2,I) - PRAN(1,I)
         XYSCL(I) = (XTRC(I) - XBLC(I)) / TR
         RPLOC(I,LOCNUM) = XBLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I) * XMULT(I)
         AXINC(I,LOCNUM) = TR * XMULT(I) / (XTRC(I) - XBLC(I))
 50      CONTINUE
      CTYP(1,LOCNUM) = XUNITS(XVAR)
      CTYP(2,LOCNUM) = AUNITS(JCODE, DIFF)
      LDIFF = DIFF
      IF (ITPLOT.GE.4) LDIFF = 1
C                                       Init plot calls again
C                                       Number of characters on each
C                                       side of the plot
      IF (ABS (IPLOT).EQ.1) THEN
         CALL RFILL (4, 0.5, CHOUT)
C                                       Not fully initialized, may make
C                                       INP too large which is okay.
         CALL CHNTIC (XBLC, XTRC, INP)
         INP = MAX (INP, 3)
         IF (NCODES.GT.1) INP = MAX (INP, 7)
         LTYPE = MOD (ABS (LABEL), 100)
         IF (LTYPE.EQ.2) CHOUT(1) = 2.5
         IF (LTYPE.GT.2) CHOUT(1) = INP + 4
         IF (LTYPE.GT.1) CHOUT(2) = 2.0
         IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
         IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = 3.333
         IF ((LABEL.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7))
     *      CHOUT(4) = CHOUT(4) + 1.333
C                                       Init for line drawing.
         CALL GINITL (BLC, TRC, XYRATO, CHOUT, DEPTH, BUFFER, IERR)
         IRET = 3
         IF (IERR.NE.0) GO TO 970
         IF (.NOT.DOTV) THEN
            WRITE (MSGTXT,1000) VER
            CALL MSGWRT (2)
            END IF
         END IF
      IRET = 3
      CATUP = T
C                                       Draw border
      CALL GLTYPE (1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Top labels: type & name
      IF ((ABS(IPLOT).EQ.1) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DX = 0.0
         DY = 1.833
C                                       The second line of the header
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         INCHAR = 16
         INP = 1
         TEXT = CHTYPE(JCODE,LDIFF)
         IF (NCODES.GT.1) TEXT = 'Multiple'
         IF (ICOR0.LT.-4) THEN
            IF (TEXT(1:3).EQ.'R-L') THEN
               TEXT(1:3) = 'V-H'
            ELSE IF (TEXT(:3).EQ.'R/L') THEN
               TEXT(1:3) = 'V/H'
               END IF
            END IF
         CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
         IF (ITPLOT.GE.4) THEN
            TEXT(INP+1:) = ' IF diff'
            IF (ITPLOT.EQ.5) TEXT(INP+1:) = ' IF ratio'
            INCHAR = 132
            CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
            END IF
         INP = INP + 1
         IF (XVAR.EQ.1) THEN
            TEXT(INP:INP+16) = ' vs '// TIMLAB(1:3) // ' time for '
            INP = INP + 17
         ELSE IF (XVAR.EQ.2) THEN
            TEXT(INP:INP+17) = ' vs elevation for '
            INP = INP + 18
         ELSE IF (XVAR.EQ.3) THEN
            TEXT(INP:INP+10) = ' vs HA for '
            INP = INP + 11
         ELSE IF (XVAR.EQ.4) THEN
            TEXT(INP:INP+16) = ' vs LST time for '
            INP = INP + 17
         ELSE IF (XVAR.EQ.5) THEN
            TEXT(INP:INP+17) = ' vs parallactic angle for '
            INP = INP + 26
         ELSE IF (XVAR.EQ.6) THEN
            TEXT(INP:INP+17) = ' vs azimuth for '
            INP = INP + 16
            END IF
C                                       File name
         CALL H2CHR (18, KHIMNO, CATH(KHIMN), CHTMP)
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), CHTMP(13:18))
         CALL NAMEST (CHTMP, CATBLK(KIIMS), TEXT(INP:), INCHAR)
         CALL REFRMT (TEXT, ' ', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       the third line of header
         DY = 0.5
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         INP = 1
C
         WRITE (TEXT(INP:),1010) TYPE, ITVER
         INP = INP + 8
         IF (TYPE .EQ. 'PC') THEN
            WRITE (TEXT(INP:),1015) PCNUM
            INP = INP + 9
            END IF
C                                       Stokes and IF
         IF (LDIFF.EQ.1) THEN
            IF (SUMSTK.GT.0) THEN
               TEXT(INP:) = XSTOK(:1) // 'pol_'
               INP = INP + 7
            ELSE
               TEXT(INP:) = 'Rpol & Lpol_'
               IF (ICOR0.LT.-4) TEXT(INP:) = 'Vpol & Hpol_'
               INP = INP + 14
               END IF
            END IF
         IF (ITPLOT.GE.4) THEN
            WRITE (TEXT(INP:),1020) BIF, EIF
            INP = INP + 12
         ELSE IF (BIF.EQ.EIF) THEN
            WRITE (TEXT(INP:),1021) BIF
            INP = INP + 6
         ELSE
            WRITE (TEXT(INP:),1022) BIF, EIF
            INP = INP + 11
            END IF
C                                       Phase-cal tone
         IF ((TYPE.EQ.'PC') .AND. ((JCODE.EQ.NCODE+1) .OR.
     *         (JCODE.EQ.NCODE+2))) THEN
            WRITE (TEXT(INP:),1060) PCNUM
            END IF
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Date/time/version
         IF ((LABEL.GT.0) .AND. (LTYPE.GT.1)) THEN
            DY = 0.5 + 2 * 1.333
C                                       the first line of the header
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (TEXT,1030) VER, ADATE, ATIME
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
         END IF
C                                       station ID
      CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      DX =  1.5
      DY = -1.8
      WRITE (TEXT,1040) ANTNO
      INP = 4
      IF (MUMPOL.LE.1) THEN
         TEXT(INP:) = XSTOK(:1)
         INP = INP + 1
      ELSE IF ((MUMIF.LE.1) .OR. (LIF1.NE.LIF2)) THEN
         IF (ICOR0.LT.-4) THEN
            TEXT(INP:) = 'V'
            IF (LST1.EQ.2) TEXT(INP:) = 'H'
         ELSE
            TEXT(INP:) = 'R'
            IF (LST1.EQ.2) TEXT(INP:) = 'L'
            END IF
         INP = INP + 1
         END IF
      TEXT(INP+1:) = STNNAM(ANTNO)
      CALL CHTRIM (TEXT, 132, TEXT, INCHAR)
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Stokes, IF
      IF ((MUMIF.GT.1) .AND. (LIF1.EQ.LIF2)) THEN
         INP = 1
C         WRITE (TEXT(INP:),1021) LIF1
C
         WRITE (TEXT(INP:),1021) LIF1 + BIF - 1
         INP = INP + 5
         IF ((MUMPOL.GT.1) .AND. (LST1.EQ.LST2)) THEN
            IF (ICOR0.LT.-4) THEN
               TEXT(INP:) = 'V'
               IF (LST1.EQ.2) TEXT(INP:) = 'H'
            ELSE
               TEXT(INP:) = 'R'
               IF (LST1.EQ.2) TEXT(INP:) = 'L'
               END IF
            INP = INP + 1
            END IF
         CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         DX =  1.5
         DY = -3.133
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       type of plot
      IF (NCODES.GT.1) THEN
         TEXT = CHTYPE(JCODE,LDIFF)
         CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
         CALL GPOS (XTRC(1), XTRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         DX = -INP - 3.0
         DY = -2.8
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Set up location common
C                                       Blank bottom label.
      IF ((IPLOT.GE.0) .AND. (ABS (IPLOT).NE.NCOUNT)) THEN
         CPREF(1,LOCNUM) = ' '
         CTYP(1,LOCNUM) = ' '
         END IF
C                                       Only label Y axis once.
      IAXLAB = NCOUNT / 2 + 1
      IAPLOT = ABS (IPLOT)
      IF (NCODES.LE.1) THEN
         CPREF(2,LOCNUM) = CSAVE
         IF ((IAPLOT.NE.IAXLAB) .AND. ((IPLOT.GE.0) .OR.
     *      (IAPLOT.GT.IAXLAB))) CPREF(2,LOCNUM) = '-1'
         END IF
C                                       Put on labels and ticks
      CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XYRATO, F, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Size of symbol.
      DBY = 0.5 * FACTOR
C                                       Loop
      ILITY = 4
      CALL GLTYPE (ILITY, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      COLR = (LIF2 - LIF1 + 1.0) * (LST2 - LST1 + 1.0) - 1.0
      DO3C = (DO3COL.GT.0.0) .AND. (COLR.GE.0.9)
      DOCOLR = DO3C .OR. SCOLOR
C                                       Outer loop: IF, stokes
      COLV = 0.0
      DO 200 IIF = LIF1,LIF2
         DO 190 IST = LST1,LST2
            IF (DO3COL.GT.0.0) THEN
               IF (DO3C) THEN
                  CALL COLOR3 (COLV, .FALSE., COL)
                  CALL G3VCOL (COL(1), COL(2), COL(3), BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  COLV = COLV + 0.97 / COLR
               ELSE IF (2+IST.NE.ILITY) THEN
                  ILITY = 2 + IST
                  CALL GLTYPE (ILITY, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  END IF
               END IF
            IP = (IIF-1) * MUMPOL + IST + 3 + (KK-1) * MUMPOL * MUMIF
C                                       Point plot
            DO 120 NN = 1,NUMPTS(ANTNO)
               DONEG = (JCODE.EQ.1) .OR. (JCODE.EQ.NCODE+1)
C                                       Scale X
               NNN = NN - 1 + FANREC(ANTNO)
               XY(1) = PLTPTS(3,NNN)
               IF ((SWAP) .AND. (XY(1).GT.180.0)) XY(1) = XY(1) - 360.0
               IF ((XVAR.EQ.1) .OR. (XVAR.EQ.3) .OR. (XVAR.EQ.4))
     *            XY(1) = XY(1) * 360.0
               XY(1) = XYSCL(1) * (XY(1) - XYOFF(1)) + YYOFF(1)
               IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1))) THEN
                  NNOFIT = NNOFIT + (LST2-LST1+1)*(LIF2-LIF1+1)
                  GO TO 120
                  END IF
C                                       source color
               IF ((SCOLOR) .AND. (ABS(PLTPTS(1,NNN)-OLDSRC).GT.0.1))
     *            THEN
                  COLV = 0.97 * (PLTPTS(1,NNN)-CSMIN) / (CSMAX-CSMIN)
                  CALL COLOR3 (COLV, .FALSE., COL)
                  CALL G3VCOL (COL(1), COL(2), COL(3), BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  OLDSRC = PLTPTS(1,NNN)
                  END IF
C                                       loop for points
               VALUE = PLTPTS(IP,NNN)
C                                       ?????????????????
               IF (VALUE.NE.FBLANK) THEN
 110              XY(2) = VALUE
                  XY(2) = XYSCL(2) * (XY(2) - XYOFF(2)) + YYOFF(2)
                  IF ((XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2))) THEN
                     IF (DONEG) THEN
                        IF (VALUE.LT.0.) THEN
                           VALUE = VALUE + 360.
                        ELSE
                           VALUE = VALUE - 360.
                           END IF
                        DONEG = .FALSE.
                        GO TO 110
                     ELSE
                        NNOFIT = NNOFIT + 1
                        END IF
                  ELSE
                     NGOOD = NGOOD + 1
C                                       Mark point
                     DY = 5.0 * FACTOR
                     DX = 5.0 * FACTOR
                     IF (XYRATO.GT.1.0) THEN
                        DY = DY * XYRATO
                     ELSE
                        DX = DX / XYRATO
                        END IF
                     AX(1) = XY(1)
                     AY(1) = XY(2)
                     AX(2) = AX(1)
                     AX(3) = AX(1)
                     AX(4) = AX(1) - DX
                     AX(5) = AX(1) + DX
                     AY(2) = AY(1) + DY
                     AY(3) = AY(1) - DY
                     AY(4) = AY(1)
                     AY(5) = AY(1)
                     IF ((DO3COL.LE.0) .AND. (ILITY.NE.4)) THEN
                        ILITY = 4
                        CALL GLTYPE (ILITY, BUFFER, IERR)
                        IF (IERR.NE.0) GO TO 970
                        END IF
                     CALL PNTPLT (ISYM, AX, AY, XBLC, XTRC, .FALSE.,
     *                  DOCOLR, BUFFER, IERR)
                     IF (IERR.NE.0) GO TO 970
                     END IF
               ELSE IF (BSYM.GT.0) THEN
                  DY = 5.0 * FACTOR
                  DX = 5.0 * FACTOR
                  IF (XYRATO.GT.1.0) THEN
                     DY = DY * XYRATO
                  ELSE
                     DX = DX / XYRATO
                     END IF
                  XY(2) = XBLC(2) + DY
                  AX(1) = XY(1)
                  AY(1) = XY(2)
                  AX(2) = AX(1)
                  AX(3) = AX(1)
                  AX(4) = AX(1) - DX
                  AX(5) = AX(1) + DX
                  AY(2) = AY(1) + DY
                  AY(3) = AY(1) - DY
                  AY(4) = AY(1)
                  AY(5) = AY(1)
                  IF ((DO3COL.LE.0) .AND. (ILITY.NE.3)) THEN
                     ILITY = 3
                     CALL GLTYPE (ILITY, BUFFER, IERR)
                     IF (IERR.NE.0) GO TO 970
                     END IF
                  CALL PNTPLT (BSYM, AX, AY, XBLC, XTRC, .FALSE.,
     *               DOCOLR, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  END IF
 120           CONTINUE
C                                       Line plot
            IF (DOLINE) THEN
               BLNKD = .TRUE.
               DO 140 NN = 1,NUMPTS(ANTNO)
                  DONEG = (JCODE.EQ.1) .OR. (JCODE.EQ.NCODE+1)
C                                       Scale X
                  NNN = NN - 1 + FANREC(ANTNO)
                  XY(1) = PLTPTS(3,NNN)
                  IF ((XVAR.NE.2) .AND. (XVAR.NE.5) .AND. (XVAR.NE.6))
     *               XY(1) = XY(1) * 360.0
                  XY(1) = XYSCL(1) * (XY(1) - XYOFF(1)) + YYOFF(1)
                  IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1)))
     *               GO TO 140
C                                       loop for points
                  VALUE = PLTPTS(IP,NNN)
                  IF (VALUE.EQ.FBLANK) THEN
                     BLNKD = .TRUE.
                  ELSE
 130                 XY(2) = VALUE
                     XY(2) = XYSCL(2) * (XY(2) - XYOFF(2)) + YYOFF(2)
                     IF ((XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2)))
     *                  THEN
                        IF (DONEG) THEN
                           IF (VALUE.LT.0.) THEN
                              VALUE = VALUE + 360.
                           ELSE
                              VALUE = VALUE - 360.
                              END IF
                           DONEG = .FALSE.
                           GO TO 130
                           END IF
                     ELSE
                        NGOOD = NGOOD + 1
C                                       Mark point
                        IF (BLNKD) THEN
                           CALL GPOS (XY(1), XY(2), BUFFER, IERR)
                           BLNKD = .FALSE.
                        ELSE IF (DOCOLR) THEN
                           CALL G3VEC (XY(1), XY(2), BUFFER, IERR)
                        ELSE
                           CALL GVEC (XY(1), XY(2), BUFFER, IERR)
                           END IF
                        IF (IERR.NE.0) GO TO 970
                        END IF
                     END IF
 140              CONTINUE
               END IF
C                                       plot scan boundaries
            IF ((XSCAN.GT.0.0) .AND. (NOSCAN.GT.0)) THEN
               WRITE (TXTMSG,1150) NOSCAN
               CALL GCOMNT (-1, TXTMSG, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               I = 3
               CALL GLTYPE (I, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               AY(1) = XYSCL(2) * (PRAN(1,2)-XYOFF(2)) + YYOFF(2)
               AY(2) = XYSCL(2) * (PRAN(2,2)-XYOFF(2)) + YYOFF(2)
               IF (XSCAN.GE.1.5) AY(2) = AY(1) + 0.1*(AY(2)-AY(1))
               DO 160 I = 1,NOSCAN
                  AX(1) = XYSCL(1) * (TSCAN(I)*360.-XYOFF(1)) + YYOFF(1)
                  IF ((AX(1).GE.XBLC(1)) .AND. (AX(1).LE.XTRC(1))) THEN
                     CALL GPOS (AX(1), AY(1), BUFFER, IERR)
                     IF (IERR.NE.0) GO TO 970
                     CALL GVEC (AX(1), AY(2), BUFFER, IERR)
                     IF (IERR.NE.0) GO TO 970
                     END IF
 160              CONTINUE
               END IF
 190        CONTINUE
 200     CONTINUE
C                                       Done: finish plot
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      IF ((IPLOT.GT.0) .AND. (ABS(IPLOT).LT.NCOUNT)) GO TO 210
         GPHPAG = IPLOT.GT.0
         CALL GFINIS (BUFFER, IERR)
         IF (IERR.GT.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
            IERR = 0
            END IF
 210  IF (IERR.GT.0) GO TO 975
         IRET = MIN (IERR, 0)
         GO TO 999
C                                       ZPHFIL or GINIT failure.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      IF (.NOT.DOTV) THEN
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
      GO TO 999
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      GPHPAG = IPLOT.GT.0
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.NE.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
            IERR = 0
            END IF
         GO TO 999
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Plot file version',I4,'  created.')
 1010 FORMAT (A2,I4,'_')
 1015 FORMAT ('NTONE ',I2)
 1020 FORMAT ('IF ',I2,' vs',I3)
 1021 FORMAT ('IF ',I2)
 1022 FORMAT ('IF ',I2,' - ',I2)
 1030 FORMAT ('Plot file version',I4,'__created ',A, A)
 1040 FORMAT (I3)
 1060 FORMAT ('_Phase tone ',I2)
 1150 FORMAT ('Plotting',I4,' scan breaks')
 1200 FORMAT ('PLTSN:',I9,' points plotted')
 1202 FORMAT ('PLTSN:',I9,' points did not fit')
 1960 FORMAT ('PLTSN: ERROR DURING GRAPH FILE CREATION')
 1970 FORMAT ('PLTSN: ERROR DURING GRAPHING. WILL TRY TO FINISH ',
     *   'PARTIAL GRAPH')
      END
      SUBROUTINE SUMPLT (DIFF, NV, NA, PLTPTS, IRET)
C-----------------------------------------------------------------------
C   Plots all amplitudes and all phases selected in 2 plots on a single
C   page.
C   Input:
C      DIFF   I    2 if plotting difference between R and L,
C                  1 otherwise
C      NV     I    Number values per antenna (source, T, X, Y data)
C      NA     I    Number antennas
C   Inputs from Common:
C      GMN    R    Max. value to plot
C      GMX    R    Min. value to plot
C   Output:
C      IRET   I    Return code, 0 => OK, otherwise abort.
C                     1 => failed to add to catalog
C                     2 => failed to create
C                     3 => graph file write error
C                     4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   DIFF, NV, NA, IRET
      REAL      PLTPTS(NV,*)
C
      CHARACTER TEXT*132, PFILE*48, ATIME*8, ADATE*12, AUNITS(2,3)*8,
     *   CHTYPE(2,3)*12, CHTMP*18, XUNITS(6)*20
      INTEGER   BUFFER(256), VER, IERR, ITYPE, IPSIZE, LUNPL, FINDPL,
     *   DEPTH(5), INCHAR, INP, IT(3), ID(3), LTYPE, NNOFIT, I, NGOOD,
     *   IPLOT, NN, ANTNO, NNN
      REAL      BLC(2), TRC(2), DX, DY, TR, VALUE, XY(2), XTRC(2),
     *   XBLC(2), TLC(2), PLTINC, YYOFF(2), SIZE, XMULT(2),
     *   XVARIB, TMAX, TMIN, COLV, COL(3), COLR, OLDSRC, AX(5), AY(5)
      LOGICAL   T, F, CATUP, SCOLOR, DOCOLR
      INCLUDE 'BPPLT.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA LUNPL /26/
      DATA DEPTH /5*1/
      DATA T, F /.TRUE.,.FALSE./
      DATA AUNITS /'Gain','Degrees', 'Gain','Degrees',
     *   'Ratio','Degrees'/
      DATA CHTYPE /'Gain amp','Gain phs', 'Diff amp','Phase diff',
     *   'Amp ratio','Phase diff' /
      DATA XUNITS /'IAT (hr)', 'Elevation (degrees)',
     *   'Hour Angle (hr)', 'LST (hr)', 'Parallactic angle',
     *   'Azimuth (degrees)'/
C-----------------------------------------------------------------------
      IRET = 1
      CATUP = T
      XUNITS(1)(1:3) = TIMLAB(1:3)
      DO3COL = XDO3C
      SCOLOR = XDO3C.GT.1.5
      IF (SCOLOR) DO3COL = -1.0
      IF (NA.LE.1) DO3COL = -1.0
      OLDSRC = -1
      IF (CSMAX-CSMIN.LE.0.9) SCOLOR = .FALSE.
      DOCOLR = SCOLOR .OR. (DO3COL.GT.0)
C                                       Loopover amplitude and phase
      DO 500 IPLOT = 1,2
C                                       Number of characters on each
C                                       side of the plot
         IF (IPLOT.EQ.1) THEN
C                                       Create plot file
C                                       Update catalog header.
            VER = 0
            IF (.NOT.DOTV) THEN
               CALL MADDEX ('PL', DISKIN, CNOIN, CATBLK, BUFFER, CATUP,
     *            'WRIT', VER, IERR)
               IF (IERR.NE.0) THEN
                  NCFILE = NCFILE - 1
                  GO TO 999
                  END IF
               END IF
            CALL ZPHFIL ('PL', DISKIN, CNOIN, VER, PFILE, IERR)
            IF (IERR.NE.0) GO TO 960
            IPSIZE = 0
            ITYPE = 17
            CALL GINIT (DISKIN, CNOIN, PFILE, IPSIZE, ITYPE, NPARMS,
     *         XNAMEI, DOTV, TVCHN, GRCHN, TVCORN, CATBLK, BUFFER,
     *         LUNPL, FINDPL, IERR)
            IRET = 2
            IF (IERR.NE.0) GO TO 960
            END IF
C                                       Graph drawing parameters.
         BLC(1) = 0.0
         BLC(2) = 0.0
         TRC(1) = 1000.0
         TRC(2) = 1000.0
         IF (DOTV) THEN
            TRC(1) = WINDTV(3) - WINDTV(1)
            TRC(2) = WINDTV(4) - WINDTV(2)
            END IF
         NCOUNT = 2
         PLTINC = TRC(2) / NCOUNT
         IF (XYRATO.LT.0.01) XYRATO = 1.0
         TMAX = YYMAX(IPLOT,1,1,1) + 0.1 * (YYMAX(IPLOT,1,1,1) -
     *      YYMIN(IPLOT,1,1,1))
         TMIN = YYMIN(IPLOT,1,1,1) - 0.1 * (YYMAX(IPLOT,1,1,1) -
     *      YYMIN(IPLOT,1,1,1))
         IF (TMAX-TMIN.LT.0.1) THEN
            TMAX = TMAX + 0.1
            TMIN = TMIN - 0.1
            END IF
         XYOFF(2) = TMIN
         XYSCL(2) = (TRC(2) - BLC(2)) / (TMAX - TMIN) / 2.0
         XYOFF(1) = PRAN(1,1)
         XYSCL(1) = (TRC(1) - BLC(1)) / (PRAN(2,1) - PRAN(1,1))
C                                       Set window for current plot.
         XBLC(1) = BLC(1)
         XBLC(2) = TRC(2) - IPLOT * PLTINC
         XTRC(1) = TRC(1)
         XTRC(2) = XBLC(2) + PLTINC - 1.0
         TLC(1) = XBLC(1)
         TLC(2) = XTRC(2)
C                                       Offsets for current plot.
         YYOFF(1) = XBLC(1)
         YYOFF(2) = XBLC(2)
C                                       play with location common
         LOCNUM = 1
         ROT(LOCNUM) = 0.0
         CORTYP(LOCNUM) = 0
         LABTYP(LOCNUM) = 7
         IF (XVAR.EQ.2) LABTYP(LOCNUM) = 0
         IF (XVAR.EQ.3) LABTYP(LOCNUM) = 8
         IF (XVAR.EQ.4) LABTYP(LOCNUM) = 9
         IF (XVAR.EQ.5) LABTYP(LOCNUM) = 0
         IF (XVAR.EQ.6) LABTYP(LOCNUM) = 0
         AXTYP(LOCNUM) = 0
         CPREF(1,LOCNUM) = '     '
         CPREF(2,LOCNUM) = '     '
         XMULT(1) = 1.0
         XMULT(2) = 1.0
         DO 50 I = 1,2
            SIZE = XTRC(I) - XBLC(I)
            IF (I.EQ.2) SIZE = PLTINC
            TR = SIZE / XYSCL(I)
            RPLOC(I,LOCNUM) = XBLC(I)
            RPVAL(I,LOCNUM) = XYOFF(I) * XMULT(I)
            AXINC(I,LOCNUM) = TR * XMULT(I) / (XTRC(I) - XBLC(I))
 50         CONTINUE
         CTYP(1,LOCNUM) = XUNITS(XVAR)
         CTYP(2,LOCNUM) = AUNITS(IPLOT, DIFF)
C                                       Init for line drawing.
         IF (IPLOT.EQ.1) THEN
            CALL RFILL (4, 0.5, CHOUT)
C                                       Note that TICINC not fully
C                                       initialized as yet. -> INP being
C                                       larger than may be actually
C                                       plotted on this subplot.  This
C                                       is probably desirable.
            CALL CHNTIC (XBLC, XTRC, INP)
            INP = MAX (INP, 3)
            LTYPE = MOD (ABS (LABEL), 100)
            IF (LTYPE.EQ.2) CHOUT(1) = 2.5
            IF (LTYPE.GT.2) CHOUT(1) = INP + 4
            IF (LTYPE.GT.1) CHOUT(2) = 2.0
            IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
            IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = 3.333
            IF ((LABEL.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7))
     *         CHOUT(4) = CHOUT(4) + 1.333
            CALL GINITL (BLC, TRC, XYRATO, CHOUT, DEPTH, BUFFER, IERR)
            IRET = 3
            IF (IERR.NE.0) GO TO 970
            IF (.NOT.DOTV) THEN
               WRITE (MSGTXT,1000) VER
               CALL MSGWRT (2)
               END IF
            IRET = 3
            CATUP = T
            END IF
C                                       Set amp/phase flag
         NGOOD = 0
         NNOFIT = 0
C                                       Draw border
         CALL GLTYPE (1, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL GVEC (XBLC(1), XBLC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL GVEC (XTRC(1), XBLC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL GVEC (XTRC(1), XTRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL GVEC (XBLC(1), XTRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Top labels: type & name
         IF ((IPLOT.EQ.1) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
            DX = 0.0
            DY = 1.833
C                                       The second line of the header
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            TEXT = 'Vis data vs ' // TIMLAB(1:3) // ' time for '
C                                       File name
            CALL H2CHR (18, KHIMNO, CATH(KHIMN), CHTMP)
            CALL H2CHR (6, KHIMCO, CATH(KHIMC), CHTMP(13:18))
            CALL NAMEST (CHTMP, CATBLK(KIIMS), TEXT(25:), INCHAR)
            CALL REFRMT (TEXT, ' ', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
C                                       the third line of header
            DY = 0.5
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
C                                       Table type
            TEXT = TYPE // '_'
            INP = 5
C                                       Stokes and IF
            IF (ICOR0.LT.-4) THEN
               IF ((SUMSTK.EQ.1) .AND. (ICOR0.EQ.-1)) THEN
                  TEXT(INP:) = 'Vpol_'
               ELSE IF (SUMSTK.EQ.2) THEN
                  TEXT(INP:) = 'Npol_'
               ELSE IF (DIFF.EQ.2) THEN
                  TEXT(INP:) = 'V-H_'
               ELSE IF (DIFF.EQ.3) THEN
                  TEXT(INP:) = 'V/H_'
               ELSE
                  TEXT(INP:) = 'Vpol & Hpol_'
                  END IF
            ELSE
               IF ((SUMSTK.EQ.1) .AND. (ICOR0.EQ.-1)) THEN
                  TEXT(INP:) = 'Rpol_'
               ELSE IF (SUMSTK.EQ.2) THEN
                  TEXT(INP:) = 'Lpol_'
               ELSE IF (DIFF.EQ.2) THEN
                  TEXT(INP:) = 'R-L_'
               ELSE IF (DIFF.EQ.3) THEN
                  TEXT(INP:) = 'R/L_'
               ELSE
                  TEXT(INP:) = 'Rpol & Lpol_'
                  END IF
               END IF
            INP = INP + 13
            WRITE (TEXT(INP:),1020) BIF, EIF
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
C                                       Date/time/version
            IF ((LABEL.GT.0) .AND. (LTYPE.GT.1)) THEN
               DY = 0.5 + 2 * 1.333
               CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               CALL ZDATE (ID)
               CALL ZTIME (IT)
               CALL TIMDAT (IT, ID, ATIME, ADATE)
               WRITE (TEXT,1030) VER, ADATE, ATIME
               CALL REFRMT (TEXT, '_', INCHAR)
               CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               END IF
            END IF
C                                       Set up location common
         CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         DX =  1.5
         DY = -1.8
         INCHAR = 8
         INP = 1
C                                       Blank bottom label for ampl.
         IF (IPLOT.EQ.1) THEN
            CPREF(1,LOCNUM) = ' '
            CTYP(1,LOCNUM) = ' '
            END IF
C                                       Put on labels and ticks
         CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XYRATO, F, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Loop
         CALL GLTYPE (4, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         IF (DO3COL.GT.0.0) THEN
            COLR = -1.0
            DO 195 ANTNO = 1,NA
               IF (NUMPTS(ANTNO).GT.0) COLR = COLR + 1.0
 195           CONTINUE
            IF (COLR.LE.0.0) DO3COL = -1.0
            END IF
         COLV = 0.0
         DO 200 ANTNO = 1,NA
            IF ((DO3COL.GT.0.0) .AND. (NUMPTS(ANTNO).GT.0)) THEN
               CALL COLOR3 (COLV, .FALSE., COL)
               CALL G3VCOL (COL(1), COL(2), COL(3), BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               COLV = COLV + 1.0 / COLR
               END IF
            DO 190 NN = 1,NUMPTS(ANTNO)
               NNN = NN - 1 + FANREC(ANTNO)
               VALUE = PLTPTS(3+IPLOT,NNN)
               XVARIB = PLTPTS(3,NNN)
               IF ((SWAP) .AND. (XVARIB.GT.180.0)) XVARIB = XVARIB-360.0
C                                       source color
               IF ((SCOLOR) .AND. (ABS(PLTPTS(1,NNN)-OLDSRC).GT.0.1))
     *            THEN
                  COLV = 0.95 * (PLTPTS(1,NNN)-CSMIN) / (CSMAX-CSMIN)
                  CALL COLOR3 (COLV, .FALSE., COL)
                  CALL G3VCOL (COL(1), COL(2), COL(3), BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  OLDSRC = PLTPTS(1,NNN)
                  END IF
               IF ((VALUE.NE.FBLANK) .AND. (XVARIB.NE.FBLANK)) THEN
                  IF (IPLOT.EQ.2) THEN
                     IF (VALUE.LT.YYMIN(2,1,1,1)) VALUE = VALUE + 360.
                     IF (VALUE.GT.YYMAX(2,1,1,1)) VALUE = VALUE - 360.
                     END IF
C                                       Scale X, Y
                  IF ((XVAR.EQ.1) .OR. (XVAR.EQ.3) .OR. (XVAR.EQ.4))
     *               THEN
                     XY(1) = XVARIB * 360.0
                  ELSE
                     XY(1) = XVARIB
                     END IF
                  XY(2) = VALUE
                  XY(1) = XYSCL(1) * (XY(1) - XYOFF(1)) + YYOFF(1)
                  XY(2) = XYSCL(2) * (XY(2) - XYOFF(2)) + YYOFF(2)
                  IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1)) .OR.
     *               (XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2))) THEN
                     NNOFIT = NNOFIT + 1
                  ELSE
                     NGOOD = NGOOD + 1
C                                       Mark point
                     DY = 5.0 * FACTOR
                     DX = 5.0 * FACTOR
                     IF (XYRATO.GT.1.0) THEN
                        DY = DY * XYRATO
                     ELSE
                        DX = DX / XYRATO
                        END IF
                     AX(1) = XY(1)
                     AY(1) = XY(2)
                     AX(2) = AX(1)
                     AX(3) = AX(1)
                     AX(4) = AX(1) - DX
                     AX(5) = AX(1) + DX
                     AY(2) = AY(1) + DY
                     AY(3) = AY(1) - DY
                     AY(4) = AY(1)
                     AY(5) = AY(1)
                     CALL PNTPLT (ISYM, AX, AY, XBLC, XTRC, .FALSE.,
     *                  DOCOLR, BUFFER, IERR)
                     IF (IERR.NE.0) GO TO 970
                     END IF
                  END IF
 190           CONTINUE
 200        CONTINUE
C                                       Done: finish plot
         WRITE (MSGTXT,1200) NGOOD, CHTYPE(IPLOT, DIFF)
         CALL MSGWRT (2)
         IF (NNOFIT.GT.0) THEN
            WRITE (MSGTXT,1201) NNOFIT
            CALL MSGWRT (2)
            END IF
 500     CONTINUE
C                                       Close down plot
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.NE.0) GO TO 975
      IF (.NOT.DOTV) CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
      IRET = 0
      GO TO 999
C                                       ZPHFIL or GINIT failure.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      IF (.NOT.DOTV) THEN
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
      GO TO 999
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      WRITE (MSGTXT,1971) NGOOD
      CALL MSGWRT (2)
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.NE.0) GO TO 975
         IF (.NOT.DOTV) CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
         IERR = 0
         GO TO 999
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Plot file version',I4,'  created.')
 1020 FORMAT ('IF ',I2,' - ',I2)
 1030 FORMAT ('Plot file version',I4,'__created ',A, A)
 1200 FORMAT ('SUMPLT: ',I9,1X,A,' points plotted')
 1201 FORMAT ('SUMPLT: ',I9,' points did not fit on plot')
 1960 FORMAT ('SUMPLT: ERROR DURING GRAPH FILE CREATION')
 1970 FORMAT ('SUMPLT: ERROR DURING GRAPHING. WILL TRY TO FINISH ',
     *   'PARTIAL GRAPH')
 1971 FORMAT ('SUMPLT: ',I9,' points plotted')
      END
      SUBROUTINE XCALC (XVARIB, XSOU)
C-----------------------------------------------------------------------
C  Routine to use the source and antenna geometry information in order
C  to return the requested value of the x-variable against which the
C  data is to be plotted.
C  Inputs (in common):
C    XVAR        I       Type of variable to calculate:
C                        1 = time (easy)
C                        2 = source elevation
C                        3 = HA
C                        4 = LST
C                        5 = Parallactic angle
C                        6 = Azimuth
C  Output:
C    XVARIB      R       Value of requested variable
C                        Time, LST (days)
C                        Elevation, HA (degrees)
C    XSOU        I       source number
C----------------------------------------------------------------------
      REAL    XVARIB, XSOU
C
      REAL    HA, EL, PA, AZ, TT
      INTEGER IERR, ISLUN, CSOU, I
      DOUBLE PRECISION LST, LTIME, DRA, DDEC
      LOGICAL PLANET
      INCLUDE 'BPPLT.INC'
      INCLUDE 'BPASS.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      SAVE LTIME, DRA, DDEC
      DATA ISLUN /25/
      DATA LTIME /-1.D0/
C-----------------------------------------------------------------------
      CSOU = SOURID
      XSOU = CSOU
C                                      Time
      IF (XVAR.EQ.1) THEN
         XVARIB = TIME
         GO TO 999
         END IF
C
C                                      Get source parameters
      IF ((OSOU.EQ.-1) .OR. (CSOU.NE.OSOU) .OR.
     *   (ABS(TIME-LTIME).GT.1.E-6)) THEN
         I = MSGSUP
         MSGSUP = 32000
         TT = TIME
         CALL FNDCOO (0, JD0, CSOU, DISKIN, CNOIN, CATBLK, ISLUN, TT,
     *      DRA, DDEC, PLANET, IERR)
         MSGSUP = I
         OSOU = CSOU
         LTIME = TIME
         END IF
C                                      Geometry parameters
      CALL ANTGEO (IANT, TIME, DRA, DDEC, HA, EL, LST, PA, AZ)
      IF (XVAR.EQ.2) THEN
         XVARIB = EL * RAD2DG
      ELSE IF (XVAR.EQ.3) THEN
         XVARIB = HA / TWOPI
      ELSE IF (XVAR.EQ.4) THEN
         XVARIB = LST / TWOPI
      ELSE IF (XVAR.EQ.5) THEN
         XVARIB = PA * RAD2DG
      ELSE IF (XVAR.EQ.6) THEN
         XVARIB = AZ * RAD2DG
         IF (XVARIB.LT.0.0) XVARIB = XVARIB + 360.0
         END IF
      IF (EL.LT.0.0) XVARIB = FBLANK
C
 999  RETURN
      END
      SUBROUTINE ANTGEO (ANTNO, TIME, DRA, DDEC, HA, EL, ANTLST, PA, AZ)
C-----------------------------------------------------------------------
C   Subroutine to compute the apparent source elevations based on source
C   and antenna coordinates in common.  The routines GETANT and GETSOU
C   should be called before this routine to put the correct values in
C   the relevant commons.
C   Inputs:
C      ANTNO      I    Antenna number
C      TIME       D    Current data time (days).
C      DRA        D    Apparent RA of source
C      DDEC       D    Apparent Declination of source.
C   Input from common:
C      STNLAT     D(*) Antenna latitude (rad).
C      STNLON     D(*) Antenna east longitudes (rad).
C      GSTIAT     D    GST at IAT=0 of reference day (rad).
C      ROTIAT     D    Rotation of the earth rate in IAT.
C   Output:
C      HA         R    Source hour angle (rad)
C      EL         R    Source elevation (rad)
C      ANTLST     D    Antenna LST (rad)
C      PA         R    Parallactic angle (rad)
C      AZ         R    Azimuth (rad)
C-----------------------------------------------------------------------
      INTEGER   ANTNO
      DOUBLE PRECISION TIME, ANTLST, DRA, DDEC
      REAL      HA, EL, PA, AZ
C
      LOGICAL   ISVLA
      DOUBLE PRECISION HRANG, ARLONG, ARLAT, DARG, DARG2, DAZ
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANS.INC'
C-----------------------------------------------------------------------
C                                       Antenna LST
      ANTLST = GSTIAT + STNLON(ANTNO) + TIME * ROTIAT
C                                       Hour angle
      HRANG = ANTLST - DRA
      HRANG = DMOD (HRANG, TWOPI)
      IF (HRANG.GT.PI) HRANG = HRANG - TWOPI
      IF (HRANG.LT.-PI) HRANG = HRANG + TWOPI
      HA = HRANG
C                                       Elevation angle
      DARG = SIN (STNLAT(ANTNO)) * SIN (DDEC) + COS (STNLAT(ANTNO))
     *   * COS (DDEC) * COS (HRANG)
      EL = (PI/2.0D0 - ACOS (DARG))
C                                       AZ = ATAN2(SD*CL - CD*SL*CH,
C                                       CD*SH)
      DARG = SIN (DDEC) * COS (STNLAT(ANTNO)) -
     *       COS (DDEC) * SIN (STNLAT(ANTNO)) * COS(HRANG)
      DARG2 = COS (DDEC) * SIN (HRANG)
      DAZ = ATAN2 (DARG, DARG2)
      DAZ = MOD (DAZ - PI/2.0D0, TWOPI)
      IF (DAZ.LT.0.0D0) DAZ = DAZ + TWOPI
      AZ = DAZ
C                                       Is this the VLA?
      ISVLA = (ABS (CNTRX + 1.601162D6) .LE. 10.0D0) .AND.
     *   (ABS (CNTRY + 5.042003D6) .LE. 10.0D0) .AND.
     *   (ABS (CNTRZ - 3.554915D6) .LE. 10.0D0)
C                                       All VLA antennas have the same
C                                       parallactic angle.
      PA = 0.0
      IF (ISVLA) THEN
         ARLONG = ATAN2 (CNTRY, CNTRX)
         ARLAT = ASIN (CNTRZ / SQRT (CNTRX*CNTRX + CNTRY*CNTRY +
     *      CNTRZ*CNTRZ))
      ELSE
         ARLONG = STNLON(ANTNO)
         ARLAT = STNLAT(ANTNO)
         END IF
C                                       Dont compute Equatorial or space
      IF ((MNTYP(ANTNO).NE.1) .AND. (MNTYP(ANTNO).NE.2)) THEN
C                                       Antenna LST
         HRANG = GSTIAT + ARLONG + TIME * ROTIAT
C                                       Hour angle
         HRANG = HRANG - DRA
C                                       Parallactic angle
         PA = ATAN2 (COS (ARLAT) * SIN (HRANG),
     *     (SIN (ARLAT) * COS (DDEC) -
     *     COS (ARLAT) * SIN (DDEC) * COS(HRANG)))
C                                       EW-mount
         IF (MNTYP(ANTNO).EQ.3) THEN
            PA =  ATAN2 (COS(HRANG), SIN(HRANG)*SIN(DDEC))
C                                       Right  Nasmyth
         ELSE IF (MNTYP(ANTNO).EQ.4) THEN
            PA = PA + EL
C                                       Left Nasmyth
         ELSE IF (MNTYP(ANTNO).EQ.5) THEN
            PA = PA -EL
C                                       Right BWG
         ELSE IF (MNTYP(ANTNO).EQ.6) THEN
            PA = PA -AZ+EL
C                                       Left BWG
         ELSE IF (MNTYP(ANTNO).EQ.7) THEN
            PA = PA -EL+AZ
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE DVDMIN (FX, XI, ERR, N, EPS, ITMAX, FOPT, GNOPT,
     *   NPR, IER)
C-----------------------------------------------------------------------
C! Davidon's optimally conditioned method for function minimization.
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2011, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C    This is a Fortran implementation of Davidon's optimally conditioned
C  variable metric (quasi-Newton) method for function minimization.  It
C  is based on the algorithm given in W. C. Davidon:  Optimally condi-
C  tioned optimization algorithms without line searches, Mathematical
C  Programming, vol. 9 (1975) pp. 1-30.  One should refer to that re-
C  ference for the algorithmic details.  Here, the steps of the
C  algorithm which are delineated by COMMENT lines correspond to the
C  numbered steps in Davidon's paper.  The user must supply a subroutine
C  FX to calculate the objective function and its gradient at a given
C  point.  The objective function F is assumed to be a real-valued
C  function of N real variables.  Here, 0 is assumed to be a lower
C  bound for F.  If F can assume negative values, Step 2 must be modi-
C  fied in one of two different ways, depending on whether a lower
C  bound is known (see Davidon for details).
C  Inputs:
C    FX      ENTRY     A user-supplied subroutine of the form
C                      FX (X, F, G, K) which is used to calculate the
C                      value of the objective function F at X and, op-
C                      tionally, the gradient G of F at X.  When K=1, FX
C                      need only compute F.  When K=2, both F and G are
C                      required.
C    XI(N)   D         An initial estimate for the location of a mini-
C                      mum.
C    ERR(N)  D         An initial estimate of the square roots of the
C                      diagonal elements of the inverse of the Hessian
C                      matrix of the objective function evaluated at XI.
C                      When no estimates are known, it should suffice to
C                      set ERR(I)=1.0D0, for all I.
C    N       I         The number of unknowns.
C    EPS     D         A small positive number used in tests to set a
C                      lower bound on the squared Euclidean norm of
C                      vectors considered significantly different from
C                      0.  EPS is used in the convergence test.  Usually
C                      setting EPS in the range 10**(-12) to 10**(-8) is
C                      reasonable.  Very close to a minimum, the algo-
C                      rithm generally exhibits a quadratic rate of con-
C                      vergence, so setting EPS a few orders of magni-
C                      tude too small usually is not too costly.
C    ITMAX   I         The maximum number of iterations.  On average, a
C                      few evaluations of F and slightly more than one
C                      evaluation of G are required at each iteration.
C    NPR     I         A print flag.  When NPR=0, there is no printout;
C                      for NPR=1, the value of F and the Euclidean norm
C                      of G, both evaluated at the location of the best
C                      minimum found so far, are printed at each itera-
C                      tion; for NPR=2, the latter information, together
C                      with the location of the best minimum, is print-
C                      ed at each iteration.
C  Outputs:
C    XI(N)   I         The user-supplied initial guess is replaced by
C                      the location of the best minimum found by the al-
C                      gorithm.
C    ERR(N)  D         The initial estimate supplied by the user is re-
C                      placed by an estimate of the square roots of the
C                      diagonal elements of the Hessian matrix evaluated
C                      at the best minimum found.  In least-squares ap-
C                      plications, assuming that F is the sum of squared
C                      residuals, estimates of the standard errors of
C                      the unknowns can be obtained by multiplying ERR
C                      by the r.m.s. residual.
C    FOPT     D        The value of F evaluated at the location of the
C                      best minimum that was found.
C    GNOPT    D        The Euclidean norm of the gradient of the objec-
C                      tive function, evaluated at the location of the
C                      best minimum that was found.
C    IER      I        An error flag.  When IER=0, convergence was
C                      achieved in ITMAX or fewer iterations; other-
C                      wise not.
C  Remarks:
C  1) This algorithm can be used for under-determined problems.
C  2) It maintains an approximation, in factored form J*transpose(J),
C     to the inverse Hessian of F.  At each iteration, a rank two update
C     is added to this approximation.  This approximation remains posi-
C     tive definite throughout the iteration.  In cases where an un-
C     known, say the Ith unknown, is ill-determined, ERR(I) will be
C     finite on exit from this routine. So, in least-squares applica-
C     tions, the error estimates for ill-determined parameters are like-
C     ly to be too small.
C  2.5) In the case of an under-determined problem (i.e., when the
C     Hessian matrix is singular) J*transpose(J) is a non-singular
C     matrix whose inverse is close to the Hessian matrix.
C  3) Furthermore, in cases where an excellent initial guess is supplied
C     by the user, DVDMIN is likely to converge before it has iterated
C     long enough to get a good approximation to the inverse Hessian.
C     (Understand that it is trying to estimate this second-order in-
C     formation only from the first-order information that is supplied
C     by FX.)  So, in least-squares applications, when convergence oc-
C     curs in just a couple of iterations, the derived error estimates
C     may be inaccurate.
C  4) Another Fortran implementation is given in the technical report
C     by W. C. Davidon and L. Nazareth:  DRVOCR - A Fortran implementa-
C     tion of Davidon's optimally conditioned method, Argonne National
C     Lab., Applied Math. Div. Technical Memo. No. 306, August 1977.
C  5) Comparisons of Davidon's algorithm with other quasi-Newton mini-
C     mization algorithms are given in  J. N. Lyness:  A bench mark
C     experiment for minimization algorithms, Math. of Computation,
C     vol. 33 (1979) pp. 249-264.  This algorithm compares quite favor-
C     ably with others, including the routine QNMDER of Gill et al.,
C     and the Harwell Library routine VA13AD.
C  6) Argonne Lab.'s MINPACK routines (non-proprietary) or NAG Library
C     routines (proprietary) could be used in place of DVDMIN.  They
C     would provide somewhat more flexibility.  They're a bit more con-
C     servative (and therefore more robust, but perhaps less efficient).
C-----------------------------------------------------------------------
      INTEGER MAXUNK
C                                       MAXUNK = max. no unknowns.
      PARAMETER (MAXUNK=64)
      INTEGER   N, ITMAX, NPR, IER, NF, NG, IT, I, J, L, I1, II
      DOUBLE PRECISION XI(*), ERR(*), EPS, FOPT, GNOPT, LAMBDA, F0,
     *   MSQ, MU, NSQ, NU, XJ(MAXUNK,MAXUNK), X0(MAXUNK), X(MAXUNK),
     *   K0(MAXUNK), K(MAXUNK), S(MAXUNK), G(MAXUNK), M(MAXUNK),
     *   P(MAXUNK), Q(MAXUNK), WUN(MAXUNK), AX(MAXUNK),
     *   XDDOT, XDMACH, TINYC, F, GN, F0P, XX, UTU, FP,
     *   UTS, A, B, C, ALF, GAMMA, DELTA, T1, T2, T3, T4, T5, T6,
     *   QTK0, B0
C                                       This for STUPID SUNS
C                                       Well, not so dumb anymore
C     INTEGER FX
      EXTERNAL FX
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Trap excessive parameters
      IF (N.GT.MAXUNK) THEN
         MSGTXT = 'DVDMIN: PROGRAMMER ERROR --- TOO MANY PARAMETERS'
         CALL MSGWRT (8)
         MSGTXT = 'DVDMIN: IF THE TASK CLAIMS TO END SUCCESSFULLY, THE'
         CALL MSGWRT (8)
         MSGTXT = 'DVDMIN: RESULTS ARE UBRELIABLE AND SHOULD BE'
         CALL MSGWRT (8)
         MSGTXT = 'DVDMIN: DISREGARDED'
         END IF
C                                       Initialization:
      CALL DMACH (2, XDMACH)
      TINYC = 1.0D-3*SQRT (XDMACH)
      NF = 1
      NG = 1
      IT = -1
      DO 20 I = 1,N
         X(I) = XI(I)
         X0(I) = XI(I)
         DO 10 J = 1,N
            XJ(I,J) = 0.0D0
 10         CONTINUE
         XJ(I,I) = ERR(I)
 20      CONTINUE
      CALL FX (X, F, G, 2)
      F0 = F
      DO 40 I = 1,N
         DO 30 J = 1,N
            AX(J) = XJ(J,I)
 30         CONTINUE
         CALL DDOT (N, AX, 1, G, 1, WUN(I))
         K0(I) = WUN(I)
 40      CONTINUE
C                                       Step 1:
 100  IT = IT+1
      CALL DNRM2 (N, G, 1, GN)
      IF (NPR.GE.1) THEN
         WRITE (MSGTXT,1010) IT, F0, GN
         CALL MSGWRT (3)
         END IF
      IF (NPR.GT.1) THEN
         WRITE (MSGTXT,1020)
         DO 105 I = 1,N,5
            I1 = I + 4
            I1 = MIN (I1, N)
            WRITE (MSGTXT,1021) (X0(II), II = I,I1)
            CALL MSGWRT (3)
 105        CONTINUE
         END IF
      IF (IT.LT.ITMAX) GO TO 110
         IER = 1
         GO TO 900
 110  DO 120 I = 1, N
         S(I) = -K0(I)
 120     CONTINUE
      CALL DDOT (N, K0, 1, S, 1, F0P)
      LAMBDA = 2.0D0
      IF (4.0D0*F0.GE.-F0P) GO TO 200
         XX = -4.0D0*F0/F0P
         DO 130 I = 1, N
            S(I) = XX*S(I)
 130        CONTINUE
         F0P = -4.0D0*F0
C                                       Step 2:
 200  DO 220 I = 1,N
         DO 210 J = 1,N
            AX(J) = XJ(I,J)
 210        CONTINUE
         CALL DDOT (N, AX, 1, S, 1, XDDOT)
         X(I) = X0(I) + XDDOT
 220     CONTINUE
      IF (-F0P.GE.EPS) GO TO 230
         IER = 0
         GO TO 900
 230  CALL FX (X, F, G, 1)
      NF = NF+1
      IF (F.LT.F0) GO TO  300
         DO 240 I = 1,N
            S(I) = 0.5D0*S(I)
 240        CONTINUE
         F0P = 0.5D0*F0P
         LAMBDA = 0.5D0
         GO TO 200
C                                       Step 3:
 300  CALL FX (X, F, G, 2)
      NF = NF+1
      NG = NG+1
      DO 320 I = 1,N
         DO 310 J = 1,N
            AX(J) = XJ(J,I)
 310        CONTINUE
         CALL DDOT (N, AX, 1, G, 1, K(I))
         M(I) = S(I)+K0(I)-K(I)
         K0(I) = K(I)
         X0(I) = X(I)
 320     CONTINUE
      CALL DDOT (N, K, 1, S, 1, FP)
      B0 = FP-F0P
      F0 = F
      F0P = FP
      IF (B0.GE.EPS) GO TO 400
         DO 330 I = 1,N
            S(I) = LAMBDA*S(I)
 330        CONTINUE
         F0P = LAMBDA*F0P
         GO TO 200
C                                       Step 4:
 400  CALL DNRM2 (N, M, 1, MSQ)
      MSQ = MSQ * MSQ
      IF (MSQ.LT.EPS) GO TO 100
         CALL DDOT (N, M, 1, S, 1, NU)
         MU = NU-MSQ
         CALL DDOT (N, M, 1, WUN, 1, XX)
         XX = XX / MSQ
         DO 410 I = 1,N
            WUN(I) = WUN(I)-XX*M(I)
 410        CONTINUE
         CALL DNRM2 (N, WUN, 1, UTU)
         UTU = UTU * UTU
C                                       Trap trouble
         UTU = MAX (UTU, EPS)
         CALL DDOT (N, M, 1, WUN, 1, XX)
         IF (XX.LT.TINYC .OR. ((1D3*XX)**2.LT.MSQ*UTU)) GO TO 450
            DO 420 I = 1,N
               WUN(I) = 0.0D0
 420           CONTINUE
            NSQ = 0.0D0
            GO TO 500
C                                       Step 4A:
 450     CALL DDOT (N, WUN, 1, S, 1, UTS)
         XX = UTS / UTU
         DO 460 I = 1,N
            WUN(I) = XX * WUN(I)
 460        CONTINUE
         NSQ = UTS * XX
C                                       Step 5:
 500  XX = NU / MSQ
      B = NSQ + MU*XX
      IF (B.GE.EPS) GO TO 600
         DO 510 I = 1,N
            WUN(I) = S(I) - XX*M(I)
 510        CONTINUE
         NSQ = B0 - MU*XX
         B = B0
C                                       Step 6:
 600  IF (MU*NU.LT.MSQ*NSQ) GO TO 650
         GAMMA = 0.0D0
         DELTA = SQRT (NU/MU)
         GO TO 700
C                                       Step 6A:
 650  A = B-MU
      C = B+NU
      GAMMA = SQRT ((1.0D0 - MU*NU/(MSQ*NSQ))/(A*B))
      DELTA = SQRT (C / A)
      IF (C.LT.A) GAMMA = -GAMMA
C                                       Step 7:
 700  XX = NSQ * GAMMA
      ALF = NU + MU*DELTA + MSQ*XX
      T1 = DELTA - XX
      T2 = GAMMA * NU
      T3 = (1.0D0+XX) / ALF
      T4 = -GAMMA * MU / ALF
      XX = MU * NU / ALF
      T5 = NSQ * (1.0D0 + GAMMA*XX)
      T6 = -(1.0D0 + DELTA) * XX
      DO 710 I = 1,N
         P(I) = T1*M(I) + T2*WUN(I)
         Q(I) = T3*M(I) + T4*WUN(I)
         WUN(I) = T5*M(I) + T6*WUN(I)
 710     CONTINUE
      CALL DDOT (N, Q, 1, K0, 1, QTK0)
      DO 730 I = 1,N
         K0(I) = K0(I) + QTK0*P(I)
         DO 720 L = 1,N
            AX(L) = XJ(I,L)
 720        CONTINUE
         CALL DDOT (N, AX, 1, Q, 1, XX)
         DO 729 J = 1,N
            XJ(I,J) = XJ(I,J) + XX*P(J)
 729        CONTINUE
 730     CONTINUE
      IF (NSQ.GT.0.0D0) GO TO 100
         DO 740 I = 1,N
            WUN(I) = K0(I)
 740        CONTINUE
         GO TO 100
C                                       Exit:
 900  DO 920 I = 1,N
         XI(I) = X0(I)
         DO 910 J = 1,N
            AX(J) = XJ(I,J)
 910        CONTINUE
         CALL DNRM2 (N, AX, 1, ERR(I))
 920     CONTINUE
      FOPT = F0
      GNOPT = GN
      IF (NPR.LE.0) GO TO 999
         IF (IER.EQ.0) THEN
            WRITE (MSGTXT,1030)
            CALL MSGWRT (3)
         ELSE IF (IER.EQ.1) THEN
            WRITE (MSGTXT,1040)
            CALL MSGWRT (3)
            END IF
         WRITE (MSGTXT,1050) NF,NG
         CALL MSGWRT (3)
         WRITE (MSGTXT,1060)
         CALL MSGWRT (3)
         DO 930 I = 1,N,5
            I1 = I + 4
            I1 = MIN (I1, N)
            WRITE (MSGTXT,1061) (XI(II), II = I,I1)
            CALL MSGWRT (3)
 930        CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('Iteration #',I4,4X,'F=',1PD16.8,' Gradient=',1PD16.8)
 1020 FORMAT ('Parameters:')
 1021 FORMAT (1P5D12.4)
 1030 FORMAT ('***  Convergence achieved.')
 1040 FORMAT ('***  Maximum number of iterations reached.')
 1050 FORMAT (I4,' Function evaluations and ',I4,
     *   ' Gradient evaluations.')
 1060 FORMAT ('Solution parameters:')
 1061 FORMAT (1P5D12.4)
      END

      SUBROUTINE SHFCRP (TYPUVD, RA, DEC, ROTATE, XRA, XDEC, XSHIFT,
     *   YSHIFT)
C-----------------------------------------------------------------------
C! Returns shifts of coordinates in ref pixel shift
C# Map Header coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1999
C;  Associated Universities, Inc. Washington DC, USA.
C;  Eric W. Greisen
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Finds coordinate shift from RA,DEC to XRA,XDEC
C   Input:
C      TYPUVD   I   -1 => NCP, else -SIN
C      RA       D   Initial RA in degrees: reference point
C      DEC      D   Initial Declination in degrees: reference point
C      ROTATE   R   Image rotation in degrees
C      XRA      D   RA of shifted point in degrees
C      XDEC     D   Declination of shifted point in degrees
C   Output
C      XSHIFT   R   Shift in "X" ref pixel in arc sec
C      YSHIFT   R   Shift in "Y" ref pixel in arc sec
C   For -SIN projection and -NCP.
C-----------------------------------------------------------------------
      INTEGER   TYPUVD
      DOUBLE PRECISION RA, DEC, XRA, XDEC
      REAL      XSHIFT, YSHIFT, ROTATE
C
      REAL      MAPRR
      DOUBLE PRECISION XXSHFT, YYSHFT
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      MAPRR = ROTATE * DG2RAD
C                                       L: SIN, NCP projection
      XXSHFT = COS (DG2RAD*XDEC) * SIN (DG2RAD*(XRA-RA))
C                                       M: NCP PROJECTION
      IF (TYPUVD.EQ.-1) THEN
         YYSHFT = (COS (DG2RAD*DEC) - COS (DG2RAD*XDEC) *
     *      COS (DG2RAD*(XRA-RA))) / SIN (DG2RAD*DEC)
C                                       M: SIN PROJECTION
      ELSE
         YYSHFT = SIN (DG2RAD*XDEC) * COS (DG2RAD*DEC) - COS
     *      (DG2RAD*XDEC) * SIN (DG2RAD*DEC) * COS (DG2RAD*(XRA-RA))
         END IF
C                                       now do simple "linear" terms
C     XXSHFT = COS (DG2RAD*DEC) * (XRA - RA)
C     YYSHFT = XDEC - DEC
C                                       Undo rotation
      XSHIFT = (COS (MAPRR) * XXSHFT + SIN (MAPRR) * YYSHFT) * 3600.0 /
     *   DG2RAD
      YSHIFT = (-SIN (MAPRR) * XXSHFT + COS (MAPRR) * YYSHFT) * 3600.0 /
     *   DG2RAD
C
 999  RETURN
      END

      SUBROUTINE PEAKFN (LUN, VOL, CNO, IDEPTH, CATBLK, BUFFER, JBUFSZ,
     *   PEAKX, PEAKY, IRET)
C-----------------------------------------------------------------------
C! returns location of maximum within 5 pixels of image plane center
C# Map-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   PEAKFN searches a region around the center of an image to locate the
C   pixel location of the maximum.  Will handle data cubes.
C   Inputs:
C      LUN      I        Logical unit number to use.
C      VOL      I        Disk on which image resides.
C      CNO      I        Catalog slot number of image.
C      IDEPTH   I(5)     Depth in image of desired plane.
C      CATBLK   I(256)   Catalog header block for image.
C      JBUFSZ   I        Size of the BUFFER in bytes
C   Output:
C      BUFFER   R(*)     Real work buffer
C      PEAKX    R        X coordinate of peak pixel location.
C      PEAKY    R        Y coordinate of peak pixel location.
C      IRET     I        Return code, 0=> OK, otherwise error.
C   Programmer: W. D. Cotton, Jan. 1983.
C-----------------------------------------------------------------------
      INTEGER   LUN, VOL, CNO, CATBLK(256), IDEPTH(5), IRET, JBUFSZ
      REAL      BUFFER(*), PEAKX, PEAKY
C
      INTEGER   NX, NY, BO, FIND, BIND, WIN(4), NS, IXMAX, IYMAX, I, J,
     *   IERR
      LOGICAL   T, F
      REAL      MAXVAL
      CHARACTER FILE*48
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA NS /5/
C-----------------------------------------------------------------------
      IRET = 1
C                                       Get NX, NY
      NX = CATBLK(KINAX)
      NY = CATBLK(KINAX+1)
C                                       Set window - search NS x NS.
      WIN(1) = NX / 2 + 1 - (NS / 2)
      WIN(2) = NY / 2 + 1 - (NS / 2)
      WIN(3) = WIN(1) + NS - 1
      WIN(4) = WIN(2) + NS - 1
C                                       Initialize maximum.
      MAXVAL = -1.0E20
      IXMAX = NX / 2 + 1
      IYMAX = NY / 2 + 1
C                                       Set block offset.
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH, BO, IERR)
      BO = BO + 1
C                                       Open image.
      CALL ZPHFIL ('MA', VOL, CNO, 1, FILE, IRET)
      CALL ZOPEN (LUN, FIND, VOL, FILE, T, F, T, IRET)
      IF (IRET.EQ.0) GO TO 50
         WRITE (MSGTXT,1000) IRET, VOL, CNO
         GO TO 990
C                                       Init. I/O
 50   CALL MINIT ('READ', LUN, FIND, NX, NY, WIN, BUFFER, JBUFSZ, BO,
     *   IRET)
      IF (IRET.EQ.0) GO TO 60
         WRITE (MSGTXT,1050) IRET, VOL, CNO
         GO TO 990
C                                       Find maximum: loop Y
 60   DO 200 I = 1,NS
C                                       Read row.
         CALL MDISK ('READ', LUN, FIND, BUFFER, BIND, IRET)
         IF (IRET.EQ.0) GO TO 100
            WRITE (MSGTXT,1060) IRET, VOL, CNO
            GO TO 990
C                                       Find max: loop X
 100     DO 140 J = 1,NS
C                                       New max.
            IF (MAXVAL.LT.BUFFER(BIND+J-1)) THEN
               MAXVAL = BUFFER(BIND+J-1)
               IXMAX = WIN(1) + J - 1
               IYMAX = WIN(2) + I - 1
               END IF
 140        CONTINUE
 200     CONTINUE
C                                       Close
      CALL ZCLOSE (LUN, FIND, IERR)
C                                       Set peak location.
      PEAKX = IXMAX
      PEAKY = IYMAX
      IRET = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PEAKFN: ERROR',I3,' OPENING MAP VOL=',I3,' SLOT=',I4)
 1050 FORMAT ('PEAKFN: ERROR',I3,' INITING MAP VOL=',I3,' SLOT=',I4)
 1060 FORMAT ('PEAKFN: ERROR',I3,' READING MAP VOL=',I3,' SLOT=',I4)
      END

      SUBROUTINE FFTMEM (APCORE, GRID, NX, NY, NROWFT, IRET)
C-----------------------------------------------------------------------
C! In memory 2-D FFT
C# AP-util FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does an inplace 2-D half plane complex to real FFT in AP memory.
C   The outer NX/2+1-NROWFT "Y" FFTs may be omitted if these are all
C   zeroes.
C   Input is a uv grid as produced by GRDMEM and output is an image as
C   expected by GDCMEM.
C   This routine expects the center pixel to be NX/2, NY/2+1
C   Input:
C      GRID   I "AP" base address of grid
C      NX     I Number of rows in output image
C      NY     I Number of columns in output image
C      NROWFT I Number of "Y" FFTs.  0=> NX/2+1
C   Output:
C      IRET   I Return code. 0=>OK else transpose error.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER GRID, NX, NY, NROWFT, IRET
C
      INTEGER NFT, LOOP, IAP, LROW, FIRST, LAST, IAP2, HAFNX, HIGH, LOW
C-----------------------------------------------------------------------
C                                       How many Y rows to transform
      NFT = NROWFT
      IF (NFT.LE.0) NFT = NX/2 + 1
C                                       Y transforms.
      IAP = GRID
      LROW = 2 * NY
      DO 100 LOOP = 1,NFT
         CALL QCFFT (APCORE, IAP, NY, -1)
         IAP = IAP + LROW
 100    CONTINUE
C                                       Pack first row real and last row
C                                       imaginary.
      FIRST = GRID + 1
      LAST = FIRST + (NX/2) * NY * 2
      CALL QVMOV (APCORE, LAST, 2, FIRST, 2, NY/2)
C                                       Transpose
      CALL APXPOS (APCORE, NX/2, NY, GRID, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       X transforms.
      IAP = GRID
      LROW = NX
      DO 200 LOOP = 1,NY
         CALL QRFFT (APCORE, IAP, NX, -1)
         IAP = IAP + LROW
 200     CONTINUE
C                                       Put center at center
C                                       Swap columns
      IAP = GRID
      LROW = NX
      HAFNX = NX/2
      IAP2 = IAP + HAFNX
      DO 300 LOOP = 1,NY
         CALL QVSWAP (APCORE, IAP, 1, IAP2, 1, HAFNX)
         IAP = IAP + LROW
         IAP2 = IAP2 + LROW
 300     CONTINUE
C                                       Swap top and bottom
      LROW = NX
      LOW = GRID
      HIGH = LOW + (NY/2) * LROW
      DO 400 LOOP = 1,NY/2
         CALL QVSWAP (APCORE, LOW, 1, HIGH, 1, LROW)
         LOW = LOW + LROW
         HIGH = HIGH + LROW
 400     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE STORES (BRANCH)
C-----------------------------------------------------------------------
C! stores proc code; pseudoverbs: SAVE, GET, RESTORE, STORE, LIST, ...
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1999, 2001-2003, 2013, 2019, 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   STORES stores either the procedure source code, procedure object
C   code, or handles the source code.  Note BRANCH 1 is an internal
C   operator that stores the source and object code for procedures.
C   Inputs: BRANCH  operation code number
C                   1 : Store Proc source & object code
C                   2 : STORE <n> save K array + LISTF
C                   3 : SAVE <ln> save K & LISTF in user area
C                   4 : LIST <proc> source code  on terminal
C                   5 : CORE used/avail report
C                   6 : RESTORE <n> recover STOREd K & LISTF
C                   7 : GET <ln> recover user area to K & LISTF
C                   8 : SCRATCH <proc> delete proc object code
C                   9 : COMPRESS is stubbed now
C                  10 : MODIFY a line of a procedure
C   LISTF is the storage location for PROC source code and is now
C   kept in common.
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      CHARACTER PHNAME*48, IOPRAT*4, TEMP*80, PRGNAM*6, SPACE*1,
     *   DELETE*1, INSERT*1, ICHAR*1, SCNAME*24
      INTEGER   BPR(100), A(100), B(100), ITEMP, POTERR, FINDME, LBYTES,
     *   LUN, FIND, LUNSG, IT, IVER, MSGIND, LISTL, LL, IERR, I, J, IER,
     *   II, IOP, IX, JJ, KBP, KP, KX3, KX5, MSGLUN,  LUNME, NMEM, INP,
     *   KOP, LLOCAT, IL, LLL, NWORDS, MSGLIN, ISCR(256), ILINK, ISIZE,
     *   IDPI, LUNDE, LBRNCH, SAVEU, LUNTMP
      LOGICAL   T, F, WASFIL, DOINS, FIXIT, EXCL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DSMS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DIO.INC'
      INCLUDE 'INCS:DRUN.INC'
      EQUIVALENCE (BPR(1), V(1))
      EQUIVALENCE (STACK(1), A(1)),   (CSTACK(1), B(1))
      DATA T, F /.TRUE.,.FALSE./
      DATA LUNME, LUNDE /14,10/
      DATA MSGLUN, LUNSG /6, 27/
      DATA PRGNAM /'STORES'/
      DATA SPACE, DELETE, INSERT /'@','$','_'/
C-----------------------------------------------------------------------
      FIXIT = .FALSE.
      LBRNCH = BRANCH
      POTERR = 76
      IF ((LBRNCH.LT.1) .OR. (LBRNCH.GT.11)) GO TO 980
      POTERR = 71
      IF ((MODE.EQ.1) .AND. (LBRNCH.GE.2) .AND. (LBRNCH.LE.9))
     *   GO TO 980
      IF ((MODE.EQ.1) .AND. (LBRNCH.GE.11)) GO TO 980
      WASFIL = .TRUE.
C                                       branch to operation
      GO TO (100, 200, 210, 220, 240, 300, 320, 400, 450, 500, 600),
     *   LBRNCH
C-----------------------------------------------------------------------
C                                  Store PROC source and object code.
C-----------------------------------------------------------------------
C                                       Store object code.
 100  ITEMP = AP + 2
      L = LLOCAT (ITEMP, K, LPGM)
      IF (ERRNUM.NE.0) GO TO 970
      LPGM = L
      L = L + 1
      LISTL = 1
      II = (NBYTES+3) / 4 + 1
      K(L) = LLOCAT (II, LISTF, LISTL)
      IF (ERRNUM.NE.0) GO TO 970
      L = L + 1
      CALL COPY (AP, A, K(L))
C                                       Store source code.
      LISTF(LISTL) = NBYTES
      LISTL = LISTL + 1
      KBP = 1
      KP = 1
      CALL CHR2H (NBYTES, KARBUF, 1,  LISTF(LISTL))
      LISTL = LISTL + II - 1
      GO TO 950
C-----------------------------------------------------------------------
C                                       STORE - all memory.
C-----------------------------------------------------------------------
 200  IOP = 2
      IOPRAT = 'WRIT'
      STORE1 = 1
      STORE2 = 1
      GO TO 310
C-----------------------------------------------------------------------
C                                       SAVE
C                                       to user store area
C-----------------------------------------------------------------------
 210  IOP = 2
      IOPRAT = 'WRIT'
      GO TO 330
C-----------------------------------------------------------------------
C                                       LIST a Procedure.
C-----------------------------------------------------------------------
 220  CALL GETFLD
      IF (ERRNUM.NE.0) GO TO 970
C                                       Error check.
      POTERR = 11
      IF (SYTYPE.NE.3) GO TO 970
      IX = 1
      ILINK = TAG
 230  L = ILINK
         ILINK = K(L)
         IT = K(L+1)
         IF (IT.EQ.0) GO TO 230
            LL = IT + 1
            LLL = (LISTF(IT)+3) / 4
            WRITE (MSGTXT,1230) IX
            CALL H2CHR (LISTF(IT), 1, LISTF(LL), MSGTXT(4:))
            CALL MSGWRT (3)
            IX = IX + 1
            IF (ILINK.NE.0) GO TO 230
      GO TO 950
C-----------------------------------------------------------------------
C                                       Report CORE utilization.
C-----------------------------------------------------------------------
 240  KX5 = K(8) + 10
      KX3 = K(KXORG+3-1) - KX5
      KX5 = K(KXORG+5-1) - KX5
      WRITE (MSGTXT,1240)
      CALL MSGWRT (4)
      WRITE (MSGTXT,1241)
      CALL MSGWRT (4)
      WRITE (MSGTXT,1242) K(3), K(5), KX3, KX5, LISTF(3), LISTF(5)
      CALL MSGWRT (4)
      GO TO 950
C-----------------------------------------------------------------------
C                                       RESTORE - all memory.
C-----------------------------------------------------------------------
 300  IOP = 1
      IOPRAT = 'READ'
C                                       STORE and RESTORE
C                                       get region number
 310  CALL GETFLD
      IF (ERRNUM.NE.0) GO TO 970
C                                       Error check.
      POTERR = 12
      IF (SYTYPE.NE.11) GO TO 970
      POTERR = 32
      NMEM = X(1)
      IF ((NMEM.LT.IOP-1) .OR. (NMEM.GT.1)) GO TO 970
      IF ((NMEM.EQ.1) .AND. (IOP.EQ.1)) THEN
         IF (STORE1.NE.1) THEN
            POTERR = 101
            MSGTXT = 'NO STORE 1 HAS BEEN DONE DURING THIS JOB'
            CALL MSGWRT (8)
            GO TO 980
            END IF
         IF (STORE2.NE.1) THEN
            STORE2 = 1
            MSGTXT= 'Warning: RESTORE 1 area was STOREd by another user'
            CALL MSGWRT (6)
            END IF
         END IF
      IDPI = 1
C                                       Open ME file
 315  I = NPOPS * NMEM
      CALL ZPHFIL ('ME', 1, 0, I, PHNAME, IERR)
C                                       file big enough?
      IF ((IOP.EQ.2) .AND. (I.GT.0)) THEN
         CALL ZEXIST (1, PHNAME, ISIZE, IERR)
         IF ((IERR.NE.0) .OR. (ISIZE.LT.MPAGE)) THEN
            IF (IERR.EQ.0) CALL ZDESTR (1, PHNAME, IERR)
            CALL ZCREAT (1, PHNAME, MPAGE, .FALSE., ISIZE, IERR)
            IF (IERR.NE.0) THEN
               MSGTXT = 'FAILED TO CREATE NEEDED MEMORY FILE'
               CALL MSGWRT (8)
               ERRNUM = 100
               GO TO 980
               END IF
            END IF
         END IF
      EXCL = T
      IF (I.EQ.0) EXCL = F
      CALL ZOPEN (LUNME, FINDME, 1, PHNAME, F, EXCL, T, IERR)
      POTERR = 101
      IF (IERR.NE.0) GO TO 980
      LUN = LUNME
      FIND = FINDME
      IDPI = 1
      GO TO 340
C-----------------------------------------------------------------------
C                                       GET
C                                       from user store area
C-----------------------------------------------------------------------
 320  IOP = 1
      IOPRAT = 'READ'
C                                       SAVE and GET
C                                       parse area name: char,#
 330  CALL SGLOCA (IOP, IVER, FIXIT)
      IF ((FIXIT) .AND. (IOPRAT.EQ.'READ') .AND. (ERRNUM.EQ.30))
     *   ERRNUM = 0
      IF (ERRNUM.NE.0) GO TO 970
      CALL ZPHFIL ('SG', 1, NLUSER, IVER, PHNAME, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       create file if needed
      IF (IOPRAT.NE.'READ') THEN
         ISIZE = MPAGE + 1
         CALL ZEXIST (1, PHNAME, IDPI, IERR)
         IF (IERR.EQ.0) CALL ZDESTR (1, PHNAME, IERR)
         WASFIL = IERR.NE.1
C                                       create it now
         IF ((IERR.EQ.0) .OR. (IERR.EQ.1)) CALL ZCREAT (1, PHNAME,
     *      ISIZE, F, IDPI, IERR)
         IF ((IERR.LT.0) .OR. (IERR.GT.1)) THEN
            POTERR = 50
            GO TO 970
            END IF
C                                       message overwrite
         IF (WASFIL) THEN
            MSGTXT = 'OVERWRITING EXISTING FILE'
            CALL MSGWRT (6)
            WASFIL = .FALSE.
            END IF
         END IF
C                                       open SG file
      CALL ZOPEN (LUNSG, FIND, 1, PHNAME, F, T, T, IERR)
      POTERR = 101
      IF (IERR.NE.0) GO TO 965
      IDPI = 2
      LUN = LUNSG
C                                       STORE, RESTORE, SAVE, GET
C                                       move K array
 340  JJ = MPAGE - LPAGE
      POTERR = 61
      J = 1
      DO 345 I = 1,JJ
         CALL ZFIO (IOPRAT, LUN, FIND, IDPI, K(J), IERROR(1))
         IF (IERROR(1).NE.0) GO TO 960
         IDPI = IDPI + 1
         J = J + 256
 345     CONTINUE
C                                       move LISTF
      J = 1
      DO 350 I = 1,LPAGE
         CALL ZFIO (IOPRAT, LUN, FIND, IDPI, LISTF(J), IERROR(1))
         IF (IERROR(1).NE.0) GO TO 960
         IDPI = IDPI + 1
         J = J + 256
 350     CONTINUE
C                                       SAVE SG files: write time
      IF (LBRNCH.EQ.3) THEN
         CALL FILL (256, 0, ISCR)
         CALL ZDATE (ISCR(1))
         CALL ZTIME (ISCR(4))
         IDPI = 1
         CALL ZFIO ('WRIT', LUNSG, FIND, IDPI, ISCR, IERR)
         END IF
      IF ((FIXIT) .AND. (LBRNCH.EQ.7)) THEN
         FIXIT = .FALSE.
         LBRNCH = 9
         CALL ZCLOSE (LUNSG, FIND, IERR)
         MSGTXT = 'GET file being modernized via COMPRESS.' //
     *      '  You should SAVE it.'
         CALL MSGWRT (6)
C                                       reset file size
         LPAGE = LBLOCK
         MPAGE = KBLOCK + LPAGE
         GO TO 450
         END IF
      GO TO 950
C-----------------------------------------------------------------------
C                                       Scratch a Procedure.
C-----------------------------------------------------------------------
 400  CALL GETFLD
      IF (ERRNUM.NE.0) GO TO 980
      POTERR = 11
      IF (SYTYPE.NE.3) GO TO 980
C                                        protect VLAGEN'd procs
      POTERR = 25
      IF (L.LT.K(7)) GO TO 980
C                                       Search for the Procedure.
      L = 1
 410  LAST = L
         L = K(L)
         IF (TAG.NE.K(L+2)) GO TO 410
C                                       Delete PROC from symbol table.
      IF (IDEBUG.GT.0) THEN
         WRITE (MSGTXT,1410) LAST, L, K(L)
         CALL MSGWRT (4)
         END IF
C                                          Last symbol entry.
      IF (K(L).EQ.0) THEN
         K(9) = LAST
         K(LAST) = 0
C                                          Middle symbol entry.
      ELSE
         K(LAST) = K(L)
         END IF
      GO TO 999
C-----------------------------------------------------------------------
C                                       Compress PROCEDURES.
C-----------------------------------------------------------------------
C                                       save the procs and adverb values
 450  SCNAME = 'RUNFIL:COMPRESS.N.UUU'
      SCNAME(12:15) = HSTNAM(:4)
      CALL ZEHEX (NPOPS, 1, SCNAME(17:17))
      CALL ZEHEX (NLUSER, 3, SCNAME(19:21))
C                                       get an LUN
      IF (NUMRUN.GE.MAXRUN) THEN
         MSGTXT = 'MORE THAN 20 DEEP IN RUN FILES'
         CALL MSGWRT (8)
         ERRNUM = 101
         GO TO 980
         END IF
      NUMRUN = NUMRUN + 1
      IF (NUMRUN.EQ.1) THEN
         LUN = LUNDE
      ELSE IF ((LUNRUN(NUMRUN).GT.0) .AND. (LUNRUN(NUMRUN).LE.99)) THEN
         LUN = LUNRUN(NUMRUN)
      ELSE
         LUN = LUNTMP (2)
         END IF
      LUNRUN(NUMRUN) = LUN
      CALL K2TEXT (LUN, .TRUE., SCNAME)
      IF (ERRNUM.NE.0) GO TO 980
C                                       set to type 5 input
      IUNIT = 5
C                                       do a RESTORE 0
      IOP = 1
      IOPRAT = 'READ'
      NMEM = 0
      GO TO 315
C-----------------------------------------------------------------------
C                                       MODIFY a line of a proc
C-----------------------------------------------------------------------
C                                       Find source code line
 500  LINK = NAMEP
      POTERR = 53
      IF (IUNIT.EQ.3) POTERR = 60
      IF (IUNIT.NE.1) GO TO 970
      IX = 0
      IL = XX
      POTERR = 11
      IF (IL.LT.2) GO TO 970
 510  L = LINK
         IF (L.EQ.0) GO TO 970
         LINK = K(L)
         IT = K(L+1)
         IF (IT.EQ.0) GO TO 510
            IX = IX + 1
            IF (IX.LT.IL) GO TO 510
               LL = IT + 1
               LBYTES = LISTF(IT)
               NWORDS = (LBYTES+3) / 4
C                                       Echo old line
      TEMP = '?'
      CALL H2CHR (LBYTES, 1, LISTF(LL), TEMP(2:))
      I = LBYTES + 1
      CALL ZMSGOP (MSGLUN, MSGIND, 1, PHNAME, IERR)
      CALL ZTTYIO ('WRIT', MSGLUN, MSGIND, I, TEMP, IERR)
      CALL ZMSGCL (MSGLUN, MSGIND, IERR)
C                                       Read new line
      IPT = '?'
      CALL PREAD (KARBUF)
      IPT = '>'
      IF (ERRNUM.NE.0) GO TO 970
      IF (NBYTES.LE.0) GO TO 550
C                                       Merge old and new lines
      INP = 1
      KOP = 1
      DOINS = .FALSE.
      DO 520 I = 1,1000
         ICHAR = KARBUF(I:I)
C                                       Insert mode
         IF (DOINS) THEN
            IF ((ICHAR.EQ.INSERT) .OR. (I.GT.NBYTES)) THEN
               DOINS = .FALSE.
            ELSE
               KARBUF(KOP:KOP) = ICHAR
               IF (ICHAR.EQ.SPACE) KARBUF(KOP:KOP) = ' '
               IF (ICHAR.NE.DELETE) KOP = KOP + 1
               END IF
C                                       Substitute mode
         ELSE IF ((I.LE.NBYTES) .OR. (INP.LE.LBYTES)) THEN
C                                       Pure copy at end
            IF (I.GT.NBYTES) THEN
               CALL H2CHR (1, INP, LISTF(LL), KARBUF(KOP:KOP))
               KOP = KOP + 1
               INP = INP + 1
C                                       Start insert
            ELSE IF (ICHAR.EQ.INSERT) THEN
               DOINS = .TRUE.
C                                       Delete a character
            ELSE IF (ICHAR.EQ.DELETE) THEN
               INP = INP + 1
C                                       Change to blank
            ELSE IF (ICHAR.EQ.SPACE) THEN
               KARBUF(KOP:KOP) = ' '
               KOP = KOP + 1
               INP = INP + 1
C                                       Keep old character
            ELSE IF (ICHAR.EQ.' ') THEN
               KARBUF(KOP:KOP) = ' '
               IF (INP.LE.LBYTES) CALL H2CHR (1, INP, LISTF(LL),
     *            KARBUF(KOP:KOP))
               INP = INP + 1
               KOP = KOP + 1
C                                       New character
            ELSE
               KARBUF(KOP:KOP) = ICHAR
               IF ((ICHAR.EQ.SPACE) .OR. (ICHAR.EQ.INSERT) .OR.
     *            (ICHAR.EQ.DELETE)) KARBUF(KOP:KOP) = ' '
               KOP = KOP + 1
               INP = INP + 1
               END IF
         ELSE
            GO TO 530
            END IF
 520     CONTINUE
C                                       Count real characters
 530  NBYTES = NCHLIN
      INP = NCHLIN - KOP + 1
      IF (INP.GT.0) KARBUF(KOP:NCHLIN) = ' '
      DO 535 I = 1,NCHLIN
         ICHAR = KARBUF(NBYTES:NBYTES)
         IF ((ICHAR.NE.' ') .AND. (ICHAR.NE.SPACE) .AND.
     *      (ICHAR.NE.DELETE)) GO TO 540
            KARBUF(NBYTES:NBYTES) = ' '
            NBYTES = NBYTES - 1
 535     CONTINUE
C                                       Set GETFLD pointer to start line
 540  KBPTR = 1
C                                       Echo new line
      TEMP = ' ' // KARBUF(1:NBYTES)
      I = NBYTES + 1
      CALL ZMSGOP (MSGLUN, MSGIND, 1, PHNAME, IERR)
      CALL ZTTYIO ('WRIT', MSGLUN, MSGIND, I, TEMP, IERR)
      CALL ZMSGCL (MSGLUN, MSGLIN, IERR)
C                                       New line blank or changed?
      IF (NBYTES.LE.LBYTES) GO TO 950
      CALL H2CHR (NBYTES, 1, LISTF(LL), MSGTXT)
      IF (MSGTXT.NE.TEMP(2:)) GO TO 950
C                                       No: user changed mind
 550  MODE = 0
      AP = 0
      GO TO 950
C-----------------------------------------------------------------------
C                                       USAVE - save to another user
C-----------------------------------------------------------------------
C                                       get user number
 600  CALL GETFLD
      IF (ERRNUM.NE.0) GO TO 970
C                                       Error check.
      POTERR = 12
      IF (SYTYPE.NE.11) GO TO 970
      POTERR = 32
      NMEM = X(1)
      IF ((NMEM.LT.1) .OR. (NMEM.GT.46655)) GO TO 970
      SAVEU = NLUSER
      IOP = 2
      IOPRAT = 'WRIT'
      NLUSER = NMEM
      CALL SGLOCA (IOP, IVER, FIXIT)
      NLUSER = SAVEU
      IF (ERRNUM.NE.0) GO TO 970
      NLUSER = NMEM
      CALL ZPHFIL ('SG', 1, NLUSER, IVER, PHNAME, IERR)
      NLUSER = SAVEU
      IF (IERR.NE.0) GO TO 970
C                                       create file
      ISIZE = MPAGE + 1
      CALL ZEXIST (1, PHNAME, IDPI, IERR)
      IF (IERR.EQ.0) CALL ZDESTR (1, PHNAME, IERR)
      WASFIL = IERR.NE.1
C                                       create it now
      IF ((IERR.EQ.0) .OR. (IERR.EQ.1)) CALL ZCREAT (1, PHNAME,
     *   ISIZE, F, IDPI, IERR)
      IF ((IERR.LT.0) .OR. (IERR.GT.1)) THEN
         POTERR = 50
         GO TO 970
         END IF
C                                       message overwrite
      IF (WASFIL) THEN
         MSGTXT = 'OVERWRITING EXISTING FILE'
         CALL MSGWRT (6)
         WASFIL = .FALSE.
         END IF
C                                       open SG file
      CALL ZOPEN (LUNSG, FIND, 1, PHNAME, F, T, T, IERR)
      POTERR = 101
      IF (IERR.NE.0) GO TO 965
      IDPI = 2
      LUN = LUNSG
C                                       move K array
      JJ = MPAGE - LPAGE
      POTERR = 61
      J = 1
      DO 610 I = 1,JJ
         CALL ZFIO (IOPRAT, LUN, FIND, IDPI, K(J), IERROR(1))
         IF (IERROR(1).NE.0) GO TO 960
         IDPI = IDPI + 1
         J = J + 256
 610     CONTINUE
C                                       move LISTF
      J = 1
      DO 620 I = 1,LPAGE
         CALL ZFIO (IOPRAT, LUN, FIND, IDPI, LISTF(J), IERROR(1))
         IF (IERROR(1).NE.0) GO TO 960
         IDPI = IDPI + 1
         J = J + 256
 620     CONTINUE
C                                       SAVE SG files: write time
      CALL FILL (256, 0, ISCR)
      CALL ZDATE (ISCR(1))
      CALL ZTIME (ISCR(4))
      IDPI = 1
      CALL ZFIO ('WRIT', LUNSG, FIND, IDPI, ISCR, IERR)
      GO TO 950
C-----------------------------------------------------------------------
C                                       Close down: normal
 950  POTERR = 0
      WASFIL = .TRUE.
C                                       close SG
 960  IF ((LBRNCH.NE.3) .AND. (LBRNCH.NE.7) .AND. (LBRNCH.NE.11))
     *   GO TO 970
         CALL ZCLOSE (LUNSG, FIND, IERR)
C                                       destroy new SG on err
 965     IF (.NOT.WASFIL) CALL ZDESTR (1, PHNAME, IERR)
C                                       close file ME
 970  IF ((LBRNCH.EQ.2) .OR. (LBRNCH.EQ.6) .OR. (LBRNCH.EQ.9))
     *   CALL ZCLOSE (LUNME, FINDME, IER)
C
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1230 FORMAT (I2)
 1240 FORMAT (16X,'Space used / total for')
 1241 FORMAT (7X,'Program',9X,'Variables',9X,'Source')
 1242 FORMAT (3X,3(I6,' /',I6,3X))
 1410 FORMAT ('PROC found: LAST,L,K(L)',3I6)
      END

      SUBROUTINE T2DHMS (TIMEIN, TSIGN, TIME)
C-----------------------------------------------------------------------
C! Converts times in days to signed sexagesimal
C# Util Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Convert from Time to Sign Days Hours Minutes Seconds format
C   Input:
C      TIMEIN   R      Input:  Time
C   Output:
C      TSIGN    C*1    Sign of time
C      TIME     I(4)   Output Time in Days Hours Minutes Seconds
C-----------------------------------------------------------------------
      REAL      TIMEIN
      CHARACTER TSIGN
      INTEGER   TIME(4)
C
      REAL     T
C-----------------------------------------------------------------------
      T = TIMEIN
      IF (TIMEIN.LT.0.0) T = -T
C
      TIME(1) = T
      T = (T - TIME(1)) * 24.0
      TIME(2) = T
      T = (T - TIME(2)) * 60.0
      TIME(3) = T
      T = (T - TIME(3)) * 60.0
      TIME(4) = T + 0.5
C                                       Now Remove 60 seconds
      IF (TIME(4).GE.60) THEN
         TIME(4) = TIME(4) - 60
         TIME(3) = TIME(3) + 1
         END IF
C                                       Now Remove 60 minutes
      IF (TIME(3).GE.60) THEN
         TIME(3) = TIME(3) - 60
         TIME(2) = TIME(2) + 1
         END IF
C                                       Now Remove 24 hours
      IF (TIME(2).GE.24) THEN
         TIME(2) = TIME(2) - 24
         TIME(1) = TIME(1) + 1
         END IF
C                                       Sign
      IF (TIMEIN.LT.0.0) THEN
         TSIGN = '-'
      ELSE
         TSIGN = ' '
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'SLPRT.INC'
      HOLLERITH XNAMIN(3), XCLSIN(2), XOUTPR(12)
      REAL      XDOMOD, XSEQ, XDISK, XINV, XINV2, XDOCRT
      COMMON /INPARM/ XDOMOD, XNAMIN, XCLSIN, XSEQ, XDISK, XINV, XINV2,
     *   XDOCRT, XOUTPR
      INTEGER   INSEQ, INDISK, INVER, INVER2, INCNO, SCRTCH(256), SLUN,
     *   SIND, PLUN, PIND, NACROS, PAGE, IPCNT
      LOGICAL   CHANGE(3)
      CHARACTER NAMEIN*12, CLSIN*6, OUTPRT*48, OPTYPE*4, TITL1*132,
     *   TITL2*132, SCRSTR*132, LINE*132
      COMMON /PRTPRM/ SCRTCH, INSEQ, INDISK, INVER, INVER2, INCNO, SLUN,
     *   SIND, PLUN, PIND, NACROS, CHANGE, PAGE, IPCNT
      COMMON /PRTCHR/ NAMEIN, CLSIN, OUTPRT, OPTYPE, TITL1, TITL2,
     *   SCRSTR, LINE
      INTEGER   ISLHDR(256), INOSL, NGAUSS
      REAL      XBLC(7), XTRC(7), YMIN, YMAX, FQFINC, SLICE(16384),
     *   GPARM(12), MODEL(16384)
      DOUBLE PRECISION FQFREQ
      COMMON /PRTSLI/ FQFREQ, ISLHDR, SLICE, MODEL, XBLC, XTRC, YMIN,
     *   YMAX, FQFINC, INOSL, NGAUSS, GPARM
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
LOCAL END
      PROGRAM SLPRT
C-----------------------------------------------------------------------
C! Task to print contents of a SLice file
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2016
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SLPRT will create a printer file representation of a SLice file.
C   Inputs:   (from AIPS)
C      DOMODEL   R      > 0 means print model(s).
C      INNAME    H(3)   name of primary file.
C      INCLASS   H(2)   class of primary file.
C      INSEQ     R      sequence number of primary file.
C      INDISK    R      disk volume number. 0 means try all.
C      INVERS    R      version number of slice file, 0 means try
C                       latest version.
C      IN2VERS   R      version number of gaussian model if
C                       DOSLICE or DOMODEL is true.
C      DOCRT     R      > 0 -> user terminal, else print file/printer
C      OUTPRINT  H(12)  Printer file - ' ' -> line printer
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   IRET, SIMPLE
      INCLUDE 'SLPRT.INC'
      DATA PRGNAM /'SLPRT '/
C-----------------------------------------------------------------------
      CALL SLPRTI (PRGNAM, SIMPLE, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       print spectra
      IF (SIMPLE.GT.0) THEN
         CALL SLPRTS (SIMPLE, IRET)
C                                       position coord
      ELSE
         CALL SLPRTP (IRET)
         END IF
C                                       close down
 990  IRET = MAX (0, IRET)
      CALL DIETSK (IRET, RQUICK, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE SLPRTI (PRGNAM, SIMPLE, IRET)
C-----------------------------------------------------------------------
C   SLPRTI does start up tasks for SLPRT
C   Inputs:
C      PRGNAM   C*6   Task name
C   Outputs:
C      SIMPLE   I     slice along SIMPLE axis which is not a position
C                     coordinate
C      IRET     I     > 0 -> quit now
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*(*)
      INTEGER   SIMPLE, IRET
C
      CHARACTER TYPIN*2, PFILE*48, STR*8, STATUS*4
      INTEGER   ISBLK(256), IROUND, DEPTH(5), I, J, IC, IERR, INPRMS,
     *   IPOS, IRRN, NCOUNT, TTY(2)
      REAL      RSBLK(256), X, XCEN, BASLIN(3)
      DOUBLE PRECISION DSBLK(128)
      INCLUDE 'SLPRT.INC'
      EQUIVALENCE (ISBLK, RSBLK, DSBLK)
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NCFILE = 0
      NSCR = 0
C                                       Get input values from AIPS.
      INPRMS = 23
      CALL GTPARM (PRGNAM, INPRMS, RQUICK, XDOMOD, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'GETTING PARAMETERS FROM AIPS'
         CALL MSGWRT (8)
         END IF
      CALL H2CHR (48, 1, XOUTPR, OUTPRT)
      IF ((IRET.NE.0) .OR. (NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   XDOCRT = MIN (-1.0, XDOCRT)
      RQUICK = (RQUICK) .AND. (XDOCRT.LE.0.0)
      IF (RQUICK) RQUICK = OUTPRT.NE.' '
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMIN, NAMEIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
      INSEQ = IROUND (XSEQ)
      INDISK = IROUND (XDISK)
      INVER = IROUND (XINV)
      INVER2 = IROUND (XINV2)
C                                       Open map file & get header.
      INCNO = 1
      TYPIN = 'MA'
      CALL CATDIR ('SRCH', INDISK, INCNO, NAMEIN, CLSIN, INSEQ, TYPIN,
     *   NLUSER, STATUS, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINDING IMAGE IN CATALOG'
         GO TO 990
         END IF
C                                       Read catalog header.
      CALL CATIO ('READ', INDISK, INCNO, CATBLK, 'REST', SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING IMAGE HEADER'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = INDISK
      FCNO(NCFILE) = INCNO
      FRW(NCFILE) = 0
C                                       open SL file
      CALL FNDEXT ('SL', CATBLK, I)
      IF ((INVER.LE.0) .OR. (INVER.GT.I)) INVER = I
      IF (INVER.LE.0) THEN
         MSGTXT = 'NO SL FILES FOUND'
         GO TO 990
         END IF
      SLUN = 25
      CALL ZPHFIL ('SL', INDISK, INCNO, INVER, PFILE, IRET)
      CALL ZOPEN (SLUN, SIND, INDISK, PFILE, .FALSE., .FALSE., .TRUE.,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING SL FILE'
         GO TO 990
         END IF
C                                       read SL header
      CALL ZFIO ('READ', SLUN, SIND, 1, ISLHDR, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ SLICE HEADER RECORD'
         GO TO 990
         END IF
C                                       get input adverbs
      CALL ZFIO ('READ', SLUN, SIND, 2, ISBLK, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ SLICE ADVERBS RECORD'
         GO TO 990
         END IF
      CALL RCOPY (7, RSBLK(19), XBLC)
      CALL RCOPY (7, RSBLK(26), XTRC)
      YMIN = RSBLK(34)
      YMAX = RSBLK(35)
      CALL H2CHR (4, 1, RSBLK(33), OPTYPE)
C                                       new format
      IF ((OPTYPE.EQ.'AVER') .OR. (OPTYPE.EQ.'FLUX') .OR.
     *   (OPTYPE.EQ.'LGFL') .OR. (OPTYPE.EQ.'LNFL') .OR.
     *   (OPTYPE.EQ.'ADER') .OR. (OPTYPE.EQ.'FDER') .OR.
     *   (OPTYPE.EQ.'LGAV') .OR. (OPTYPE.EQ.'LNAV')) THEN
         FQFINC = RSBLK(36)
         FQFREQ = DSBLK(19)
C                                       old format
      ELSE
         FQFINC = 0.0
         FQFREQ = 0.0D0
         END IF
C                                       special units
      IF (OPTYPE.EQ.'FLUX') CALL CHR2H (8, 'Jy      ', 1, CATH(KHBUN))
      IF (OPTYPE.EQ.'LGFL') CALL CHR2H (8, 'LOG10 JY', 1, CATH(KHBUN))
      IF (OPTYPE.EQ.'LNFL') CALL CHR2H (8, 'LN (JY) ', 1, CATH(KHBUN))
      IF (OPTYPE.EQ.'FDER') CALL CHR2H (8, 'dJY / dx', 1, CATH(KHBUN))
C                                       model
      IF (XDOMOD.GT.0.0) THEN
         IF ((INVER2.LE.0) .OR. (INVER2.GT.ISLHDR(58))) INVER2 =
     *      ISLHDR(58)
         IF (INVER2.LE.0) THEN
            MSGTXT = 'NO MODELS AVAILABLE'
            CALL MSGWRT (6)
            XDOMOD = -1.0
            END IF
         END IF
C                                       number slice values
      INOSL = ISLHDR(57)
C                                       number of lines of print
      IF ((XDOCRT.LE.0.0) .AND. (OUTPRT.EQ.' ')) THEN
         NCOUNT = INOSL + 8
         IRET = 0
         IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) THEN
            IF (NCOUNT.GT.1000) IRET = -1
         ELSE IF (NCOUNT.GT.500) THEN
            TTY(1) = 5
            CALL ZOPEN (TTY(1), TTY(2), 1, SCRSTR, .FALSE., .FALSE.,
     *         .TRUE., IRET)
            MSGTXT = 'PROBLEM OPENING TERMINAL'
            IF (IRET.GT.0) GO TO 990
            WRITE (SCRSTR,1010) NCOUNT
            CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRSTR, IRET)
            MSGTXT = 'PROBLEM DOING IO TO TERMINAL'
            IF (IRET.GT.0) GO TO 990
            SCRSTR = 'Do you really want to print this much??' //
     *         ' Enter Y or y if so'
            CALL INQSTR (TTY, SCRSTR, 1, STR, IRET)
            IF (IRET.GT.0) GO TO 990
            IF ((STR(:1).NE.'y') .AND. (STR(:1).NE.'Y')) THEN
               IRET = -1
               SCRSTR = 'Good choice - save trees'
            ELSE
               SCRSTR = 'OKAY, printing anyway'
               END IF
            CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRSTR, I)
            CALL ZCLOSE (TTY(1), TTY(2), I)
            IF (IRET.NE.0) GO TO 999
            END IF
         END IF
C                                       read slice values
      IPOS = 1
      IRRN = 2
 30   IF (IPOS.LE.INOSL) THEN
         IRRN = IRRN + 1
         CALL ZFIO ('READ', SLUN, SIND, IRRN, ISBLK, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ SLICE DATA'
            GO TO 990
            END IF
         CALL RCOPY (256, RSBLK, SLICE(IPOS))
         IPOS = IPOS + 256
         GO TO 30
         END IF
C                                       read model
      NGAUSS = 0
      IF (XDOMOD.GT.0.0) THEN
         IRRN = ISLHDR(59) + INVER2 - 1
         CALL ZFIO ('READ', SLUN, SIND, IRRN, ISBLK, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ MODEL DATA'
            GO TO 990
            END IF
         NGAUSS = ISBLK(27)
         CALL RCOPY (12, RSBLK, GPARM)
         CALL RCOPY (3, RSBLK(83), BASLIN)
         XCEN = (ISBLK(25) + 1 + INOSL - ISBLK(26)) / 2.0
C                                       compute model
         CALL RFILL (INOSL, 0.0, MODEL)
         DO 50 I = 1,INOSL
            X = I
            DO 40 IC = 1,NGAUSS
               J = 3 * IC - 2
               MODEL(I) = MODEL(I) + GPARM(J) *
     *            EXP (- 2.772 * (GPARM(J+1) - X) ** 2 /
     *            (GPARM(J+2) * GPARM(J+2)))
 40            CONTINUE
            X = X - XCEN
            MODEL(I) = MODEL(I) + BASLIN(1) + X*BASLIN(2) +
     *         X*X*BASLIN(3)
 50         CONTINUE
         END IF
C                                       close slice
      CALL ZCLOSE (SLUN, SIND, IRET)
C                                       open printer
      IF (OUTPRT.EQ.' ') XDOCRT = MAX (-1.0, XDOCRT)
      CALL LPOPEN (OUTPRT, XDOCRT, PLUN, PIND, NACROS, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING THE PRINTER'
         GO TO 990
         END IF
C                                       coordinates
      DO 60 I = 1,5
         DEPTH(I) = XBLC(I+2) + 0.01
 60      CONTINUE
      LOCNUM = 1
      CALL SETLOC (DEPTH, .FALSE.)
      J = 0
      IC = 0
      DO 65 I = 1,3
         CHANGE(I) = ABS(XTRC(I)-XBLC(I)).GT.0.01
         IF (CHANGE(I)) THEN
            J = J + 1
            IC = I
            END IF
 65      CONTINUE
      SIMPLE = 0
      IF (J.EQ.1) THEN
         CALL H2CHR (8, 1, CATH(KHCTP+2*(IC-1)), STR)
         IF (STR(:4).EQ.'FREQ') SIMPLE = IC
         IF (STR(:4).EQ.'VELO') SIMPLE = IC
         IF (STR(:4).EQ.'FELO') SIMPLE = IC
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I4,' ON ',A)
 1010 FORMAT ('Requested print job is',I10,' lines long!')
      END
      SUBROUTINE SLPRTS (SIMPLE, IRET)
C-----------------------------------------------------------------------
C   print "simple" slices - all on 1 axis which is frequency,
C   velocity, or felocity
C   Inputs:
C      SIMPLE   I   axis number of "simple" axis
C   Outputs:
C      IRET     I   not 0 => failure of some sort
C-----------------------------------------------------------------------
      INTEGER   SIMPLE, IRET
C
      INCLUDE 'SLPRT.INC'
      INTEGER   HM(2), DM(2), I, JTRIM
      REAL      XPIX, YPIX, ZPIX, RSEC, DSEC, REFP, REFI, VDIV, RMS,
     *   NRMS
      CHARACTER CHSIG1*1, CHSIG2*1, LLCH*4, MMCH*4, AXIS*8, UNITS*8,
     *   AUNIT*8, CTEMP*8
      DOUBLE PRECISION XX, YY, ZZ, RR, DD, VV, REFV
C-----------------------------------------------------------------------
      CALL H2CHR (8, 1, CATH(KHBUN), CTEMP)
      I = JTRIM (CTEMP)
      UNITS = ' '
      UNITS(9-I:) = CTEMP(:I)
      CALL H2CHR (8, 1, CATH(KHCTP+2*SIMPLE-2), CTEMP)
      VDIV = 1.0
      AUNIT = ' '
      IF (CTEMP(:4).EQ.'FREQ') THEN
         VDIV = 1.E6
         AUNIT = '     MHz'
      ELSE IF (CTEMP(:4).EQ.'VELO') THEN
         VDIV = 1.E3
         AUNIT = '    km/s'
      ELSE IF (CTEMP(:4).EQ.'FELO') THEN
         VDIV = 1.E3
         AUNIT = '    km/s'
         END IF
      I = JTRIM (CTEMP)
      AXIS = ' '
      AXIS(9-I:) = CTEMP(:I)
C                                       base coordinate
      XPIX = XBLC(1)
      YPIX = XBLC(2)
      ZPIX = XBLC(3)
      CALL XYVAL (XPIX, YPIX, XX, YY, ZZ, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INITIAL COORDINATE COMPUTATION'
         CALL MSGWRT (6)
         END IF
      IF (CORTYP(LOCNUM).EQ.1) THEN
         RR = XX
         DD = YY
      ELSE IF (CORTYP(LOCNUM).EQ.2) THEN
         RR = YY
         DD = XX
      ELSE IF (CORTYP(LOCNUM).EQ.3) THEN
         RR = XX
         DD = ZZ
      ELSE IF (CORTYP(LOCNUM).EQ.4) THEN
         RR = ZZ
         DD = XX
      ELSE IF (CORTYP(LOCNUM).EQ.5) THEN
         RR = YY
         DD = ZZ
      ELSE IF (CORTYP(LOCNUM).EQ.6) THEN
         RR = ZZ
         DD = YY
         END IF
      CALL H2CHR (4, 1, CATH(KHCTP+KLOCL(LOCNUM)*2), LLCH)
      CALL H2CHR (4, 1, CATH(KHCTP+KLOCM(LOCNUM)*2), MMCH)
      IF (RR.LT.0.0D0) RR = RR + 360.0D0
      IF (RR.LT.0.0D0) RR = RR + 360.0D0
      IF (RR.LT.0.0D0) RR = RR + 360.0D0
      IF (LLCH(:2).EQ.'RA') THEN
         CALL COORDD (1, RR, CHSIG1, HM, RSEC)
      ELSE
         CALL COORDD (2, RR, CHSIG1, HM, RSEC)
         END IF
      CALL COORDD (2, DD, CHSIG2, DM, DSEC)
C                                       Page header
      PAGE = 0
      IPCNT = 998
      TITL1 = ' '
      TITL2 = ' '
      IF (XDOCRT.GT.-2.5) THEN
C                                       file
         WRITE (LINE,1010) NAMEIN, CLSIN, INSEQ, INDISK, NLUSER
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         IF (IRET.NE.0) GO TO 950
C                                       SLice file
         WRITE (LINE,1015) INVER, INVER2
         IF (XDOMOD.LE.0.0) LINE(26:) = ' '
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         IF (IRET.NE.0) GO TO 950
C                                       slice ends
         WRITE (LINE,1020) XBLC(1), XBLC(2), XBLC(3), XTRC(1), XTRC(2),
     *      XTRC(3)
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         IF (IRET.NE.0) GO TO 950
C                                       main coordinate
         WRITE (LINE,1025) LLCH, HM, RSEC, MMCH, CHSIG2, DM, DSEC
         IF (LINE(15:15).EQ.' ') LINE(15:15) = '0'
         IF (LINE(38:38).EQ.' ') LINE(38:38) = '0'
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         IF (IRET.NE.0) GO TO 950
         LINE = ' '
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         IF (IRET.NE.0) GO TO 950
         END IF
C                                       page titles
      WRITE (TITL1,1030) AXIS
      IF (XDOMOD.LE.0.0) TITL1(32:) = ' '
      WRITE (TITL2,1031) AUNIT, UNITS, UNITS, UNITS
      IF (XDOMOD.LE.0.0) TITL2(32:) = ' '
      IF (XDOCRT.GT.-2.5) THEN
         LINE = TITL1
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         IF (IRET.NE.0) GO TO 950
         LINE = TITL2
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         IF (IRET.NE.0) GO TO 950
         END IF
      REFV = CATD(KDCRV+SIMPLE-1) / VDIV
      REFP = CATR(KRCRP+SIMPLE-1)
      REFI = CATR(KRCIC+SIMPLE-1) / VDIV
      RMS = 0.0
      NRMS = 0.0
      DO 100 I = 1,INOSL
         XX = XBLC(SIMPLE) + (I-1.0) / (INOSL-1.0) *
     *      (XTRC(SIMPLE) - XBLC(SIMPLE))
         IF (AXFUNC(SIMPLE,LOCNUM).EQ.0) THEN
            VV = REFV + (XX - REFP) * REFI
C                                       felocity
         ELSE
             VV = REFV + (XX - REFP) * REFI /
     *         (1.0D0 + AXDENU(LOCNUM) * (XX-REFP))
            END IF
         IF (SLICE(I).NE.FBLANK) THEN
            WRITE (LINE,1050) I, VV, SLICE(I)
            IF (XDOMOD.GT.0.0) THEN
               WRITE(LINE(32:),1055) MODEL(I), SLICE(I)-MODEL(I)
               RMS = RMS + (SLICE(I)-MODEL(I))**2
               NRMS = NRMS + 1.0
               END IF
         ELSE
            WRITE (LINE,1051) I, VV
            END IF
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         IF (IRET.NE.0) GO TO 950
 100     CONTINUE
      IF ((XDOMOD.GT.0.0) .AND. (NRMS.GT.0.0)) THEN
         RMS = SQRT (RMS/NRMS)
         WRITE (LINE,1100) RMS
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         END IF
C
 950  IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'PRINT LINE ERROR'
         CALL MSGWRT (8)
         END IF
      IRET = MAX (0, IRET)
      CALL LPCLOS (PLUN, PIND, IPCNT, I)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SLPRTS ERROR',I4,' ON ',A)
 1010 FORMAT ('File = ',A12,'.',A6,'.',I4,'   Vol =',I2,4X,'Userid =',
     *   I5)
 1015 FORMAT ('SLice file version =',I5,'   model version =',I2)
 1020 FORMAT ('SLice  Blc=',3F8.1,'    Trc=',3F8.1)
 1025 FORMAT (A4,' = ',I3.2,':',I2.2,':',F5.2,4X,A4,' = ',A1,I2.2,':',
     *   I2.2,':',F4.1)
 1030 FORMAT (' Pixel',4X,A8,'  Slice value  Model value     Residual')
 1031 FORMAT (10X,A8,5X,A8,5X,A8,5X,A8)
 1050 FORMAT (I6,F12.3,F13.5)
 1051 FORMAT (I6,F12.3,6X,'Blanked')
 1055 FORMAT (F13.5,F13.6)
 1100 FORMAT ('Data-model RMS =',F13.6)
      END
      SUBROUTINE SLPRTP (IRET)
C-----------------------------------------------------------------------
C   print not so "simple" slices
C   Outputs:
C      IRET     I   not 0 => failure of some sort
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'SLPRT.INC'
      INTEGER   HM(2), I, NAXES, ICH, J, K, JTRIM
      REAL      PIXEL(3), RSEC, VDIV(3), RMS, NRMS
      CHARACTER CHSIG1*1, AXIS(3)*8, UNITS*8, AUNIT(3)*8, ASTRNG(3)*13,
     *   CTEMP*8
      DOUBLE PRECISION VV(3)
C-----------------------------------------------------------------------
      NAXES = 3
      IF (CATBLK(KINAX+2).LE.1) NAXES = 2
C                                       right shift units
      CALL H2CHR (8, 1, CATH(KHBUN), CTEMP)
      J = JTRIM (CTEMP)
      UNITS = ' '
      UNITS(9-J:) = CTEMP(1:J)
      DO 10 I = 1,NAXES
         CALL H2CHR (8, 1, CATH(KHCTP+2*I-2), CTEMP)
         IF (CTEMP(:4).EQ.'FREQ') THEN
            VDIV(I) = 1.0E6
            AUNIT(I) = '     MHz'
         ELSE IF (CTEMP(2:4).EQ.'ELO') THEN
            VDIV(I) = 1.0E3
            AUNIT(I) = '    km/s'
         ELSE
            VDIV(I) = 1.0
            AUNIT(I) = ' '
            END IF
         J = JTRIM (CTEMP)
         AXIS(I) = ' '
         AXIS(I)(9-J:) = CTEMP(1:J)
 10      CONTINUE
C                                       Page header
      PAGE = 0
      IPCNT = 998
      TITL1 = ' '
      TITL2 = ' '
      IF (XDOCRT.GT.-2.5) THEN
C                                       file
         WRITE (LINE,1010) NAMEIN, CLSIN, INSEQ, INDISK, NLUSER
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         IF (IRET.NE.0) GO TO 950
C                                       SLice file
         WRITE (LINE,1015) INVER, INVER2
         IF (XDOMOD.LE.0.0) LINE(26:) = ' '
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         IF (IRET.NE.0) GO TO 950
C                                       slice ends
         WRITE (LINE,1020) XBLC(1), XBLC(2), XBLC(3), XTRC(1), XTRC(2),
     *      XTRC(3)
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         IF (IRET.NE.0) GO TO 950
         LINE = ' '
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         IF (IRET.NE.0) GO TO 950
         END IF
C                                       page titles
      WRITE (TITL1,1030) (AXIS(I), I = 1,NAXES)
      ICH = 7 + 14*NAXES
      IF (XDOMOD.GT.0.0) THEN
         TITL1(ICH:) = '  Slice value  Model value    Residual'
      ELSE
         TITL1(ICH:) = '  Slice value'
         END IF
      WRITE (TITL2,1031) (AUNIT(I), I = 1,NAXES)
      IF (XDOMOD.GT.0.0) THEN
         TITL2(ICH:) = '     ' //  UNITS // '     ' // UNITS // '    '
     *      // UNITS
      ELSE
         TITL2(ICH:) = '     ' //  UNITS
         END IF
      IF (XDOCRT.GT.-2.5) THEN
         LINE = TITL1
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         IF (IRET.NE.0) GO TO 950
         LINE = TITL2
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         IF (IRET.NE.0) GO TO 950
         END IF
      PIXEL(3) = 1.0
      RMS = 0.0
      NRMS = 0.0
      DO 100 I = 1,INOSL
         DO 20 J = 1,NAXES
            PIXEL(J) = (I-1.0)/(INOSL-1.0) * (XTRC(J) - XBLC(J)) +
     *         XBLC(J)
 20         CONTINUE
         IF (NAXES.GT.2) ZDEPTH(ZAXIS(LOCNUM)-2,LOCNUM) = PIXEL(3)
         CALL XYVAL (PIXEL(1), PIXEL(2), VV(1), VV(2), VV(3), IRET)
         DO 30 J = 1,NAXES
            IF (AXFUNC(J,LOCNUM).EQ.0) THEN
               VV(J) = CATD(KDCRV+J-1) + (PIXEL(J) - CATR(KRCRP+J-1)) *
     *            CATR(KRCIC+J-1)
               WRITE (ASTRNG(J),1040) VV(J)/VDIV(J)
C                                       felocity
            ELSE IF (AXFUNC(J,LOCNUM).EQ.1) THEN
                VV(J) = CATD(KDCRV+J-1) + (PIXEL(J) - CATR(KRCRP+J-1)) *
     *            CATR(KRCIC+J-1) /
     *            (1.0D0 + AXDENU(LOCNUM) * (PIXEL(J)-CATR(KRCRP+J-1)))
               WRITE (ASTRNG(J),1040) VV(J)/VDIV(J)
            ELSE
              IF (AXIS(J)(:2).EQ.'RA') THEN
                 IF (VV(J).LT.0.0D0) VV(J) = VV(J) + 360.0D0
                 CALL COORDD (1, VV(J), CHSIG1, HM, RSEC)
                 WRITE (ASTRNG(J),1041) HM, RSEC
                 IF (ASTRNG(J)(8:8).EQ.' ') ASTRNG(J)(8:8) = '0'
              ELSE IF (AXIS(J)(2:4).EQ.'LON') THEN
                 IF (VV(J).LT.0.0D0) VV(J) = VV(J) + 360.0D0
                 CALL COORDD (2, VV(J), CHSIG1, HM, RSEC)
                 WRITE (ASTRNG(J),1042) HM, RSEC
                 IF (ASTRNG(J)(9:9).EQ.' ') ASTRNG(J)(9:9) = '0'
              ELSE
                 CALL COORDD (2, VV(J), CHSIG1, HM, RSEC)
                 WRITE (ASTRNG(J),1043) CHSIG1, HM, RSEC
                 IF (ASTRNG(J)(9:9).EQ.' ') ASTRNG(J)(9:9) = '0'
                 END IF
               END IF
 30         CONTINUE
         WRITE (LINE,1050) I, (ASTRNG(K), K = 1,NAXES)
         IF (SLICE(I).EQ.FBLANK) THEN
            LINE(ICH:) = '      Blanked'
         ELSE IF (XDOMOD.GT.0) THEN
            WRITE (LINE(ICH:),1051) SLICE(I), MODEL(I),
     *         SLICE(I)-MODEL(I)
            RMS = RMS + (SLICE(I)-MODEL(I))**2
            NRMS = NRMS + 1.0
         ELSE
            WRITE (LINE(ICH:),1051) SLICE(I)
            END IF
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         IF (IRET.NE.0) GO TO 950
 100     CONTINUE
      IF ((XDOMOD.GT.0.0) .AND. (NRMS.GT.0.0)) THEN
         RMS = SQRT (RMS/NRMS)
         WRITE (LINE,1100) RMS
         CALL PRTLIN (PLUN, PIND, XDOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRSTR, IRET)
         END IF
C
 950  IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'PRINT LINE ERROR'
         CALL MSGWRT (8)
         END IF
      IRET = MAX (0, IRET)
      CALL LPCLOS (PLUN, PIND, IPCNT, I)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SLPRTS ERROR',I4,' ON ',A)
 1010 FORMAT ('File = ',A12,'.',A6,'.',I4,'   Vol =',I2,4X,'Userid =',
     *   I5)
 1015 FORMAT ('SLice file version =',I5,'   model version =',I2)
 1020 FORMAT ('SLice  Blc=',3F8.1,'    Trc=',3F8.1)
 1030 FORMAT (' Pixel',3(6X,A8))
 1031 FORMAT (6X,3(6X,A8))
 1040 FORMAT (F13.3)
 1041 FORMAT (1X,I2.2,':',I2.2,':',F6.3)
 1042 FORMAT (1X,I3.2,':',I2.2,':',F5.2)
 1043 FORMAT (1X,A1,I2.2,':',I2.2,':',F5.2)
 1050 FORMAT (I6,3(1X,A13))
 1051 FORMAT (2F13.5,F12.6)
 1100 FORMAT ('Data-model RMS =',F13.6)
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NPARMS
      PARAMETER (NPARMS=44)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                      1         2          3        4         5
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'SOURCES',
C            6       7          8           9          10         11
     *   'QUAL', 'CALCODE', 'TIMERANG', 'SELBAND', 'SELFREQ', 'FREQID',
C            12          13         14         15       16       17
     *   'SUBARRAY', 'DOCALIB', 'GAINUSE', 'DOPOL', 'PDVER', 'BLVER',
C            18        19          20        21       22        23
     *   'FLAGVER', 'OUTFGVER', 'DOBAND', 'BPVER', 'SMOOTH', 'STOKES',
C            24       25      26     27      28         29
     *   'BCHAN', 'ECHAN', 'BIF', 'EIF', 'UVRANGE', 'ANTENNAS',
C            30         31          32        33         34        35
     *   'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK', 'DOHIST', 'SOLINT',
C            36        37         38        39         40        41
     *   'DETIME', 'DOWEIGHT', 'DOTWO', 'EXPERT', 'CROWDED', 'DO3COL',
C            42        43        44
     *   'REASON', 'ANTUSE', 'BADDISK'/
C                    1       2       3       4       5
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOACAR,
C          6       7       8      9      10     11
     *   OOAINT, OOACAR, OOARE, OOARE, OOARE, OOAINT,
C          12      13      14      15      16      17
     *   OOAINT, OOARE,  OOAINT, OOAINT, OOAINT, OOAINT,
C          18      19      20      21      22     23
     *   OOAINT, OOAINT, OOAINT, OOAINT, OOARE, OOACAR,
C          24      25      26      27     28      29
     *   OOAINT, OOAINT, OOAINT, OOAINT, OOARE, OOAINT,
C          30      31      32      33      34     35
     *   OOACAR, OOACAR, OOAINT, OOAINT, OOARE, OOARE,
C          36     37     38      39      40      41
     *   OOARE, OOARE, OOALOG, OOALOG, OOAINT, OOARE,
C          42      43      44
     *   OOACAR, OOAINT, OOAINT/
C                   1     2     3     4     5
      DATA AVDIM /12,1,  6,1,  1,1,  1,1, 16,30,
C         6     7     8     9     10    11
     *   1,1,  4,1,  8,1,  1,1,  1,1,  1,1,
C         12    13    14    15    16    17
     *   1,1,  1,1,  1,1,  1,1,  1,1,  1,1,
C         18    19    20    21    22    23
     *   1,1,  1,1,  1,1,  1,1,  3,1,  4,1,
C         24    25    26    27    28    29
     *   1,1,  1,1,  1,1,  1,1,  2,1, 50,1,
C         30    31    32    33    34    35
     *   12,1, 6,1,  1,1,  1,1,  1,1,  1,1,
C         36    37    38    39    40    41
     *   1,1,  1,1,  1,1,  1,1,  1,1,  1,1,
C         42    43    44
     *   24,1, 50,1, 10,1/
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(20)
      LOGICAL   LDUM(20)
      REAL      RDUM(20)
      DOUBLE PRECISION DDUM(10)
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
      COMMON /EDITRG/ DDUM
LOCAL END
      PROGRAM EDITR
C-----------------------------------------------------------------------
C! UV data editing with the TV in baseline-based manner
C# Task AP OOP UV EDITING TV-APPL
C-----------------------------------------------------------------------
C;  Copyright (C) 1996-2000, 2003, 2006-2007, 2010, 2015, 2019-2020,
C;  Copyright (C) 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UV data editing
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, UVDATA*32, UVDAT2*32
      INTEGER  IRET, BUFF1(256)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'EDITR'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL EDITIN (PRGM, UVDATA, UVDAT2, IRET)
C                                       CLEAN
      IF (IRET.EQ.0) CALL EDITIT (UVDATA, UVDAT2, IRET)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE EDITIN (PRGN, UVDATA, UVDAT2, IERR)
C-----------------------------------------------------------------------
C   EDITIN gets input parameters for EDITR and sets UV data adverbs
C   Inputs:
C      PRGN     C*6    Program name
C   Output:
C      UVDATA   C*32   Name of input uv data. - as master
C      UVDAT2   C*32   Name of 2nd input uv file to display
C      IERR     I      Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER PRGN*6, UVDATA*(*), UVDAT2*(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NKEY1, NKEY2
C                                       NKEY1 = # adverbs FOR UVDATA
      PARAMETER (NKEY1=36)
C                                       NKEY2 = # adverbs for UVDAT2
      PARAMETER (NKEY2=12)
C
      INTEGER   DIM(7), TYPE, BCHAN, ECHAN, I, BIF, EIF, NIF, NAXIS(7),
     *   FQINDX, IFINDX, NCHN, BCHAN2, ECHAN2, BIF2, EIF2, STINDX,
     *   NCHN2, NIF2, FGVERI, FGVERO, FGV, FGVERC
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32, CDUMMY*1, TINAME*12, TICLAS*6, STOKES*4,
     *   FGNAME(4)*32, FGIN*32
      DOUBLE PRECISION CRVAL(7)
      REAL      XDOCAL
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to UVDATA object
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
     *   'BCHAN', 'ECHAN', 'BIF', 'EIF',
     *   'STOKES', 'GAINUSE',
     *   'TIMERANG', 'UVRANGE', 'ANTENNAS',
     *   'SOURCES', 'QUAL', 'SELBAND',
     *   'SELFREQ', 'FREQID', 'CALCODE',
     *   'SUBARRAY', 'DOPOL', 'BLVER',
     *   'DOBAND', 'BPVER', 'SMOOTH',
     *   'SOLINT', 'DETIME', 'DOHIST', 'DOWEIGHT', 'DOTWO',
     *   'EXPERT', 'ANTUSE', 'REASON', 'CROWDED', 'DO3COL',
     *   'PDVER'/
C                                       Rename
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK',
     *   'CALEDIT.BCHAN', 'CALEDIT.ECHAN', 'CALEDIT.BIF', 'CALEDIT.EIF',
     *   'CALEDIT.STOKES', 'CALEDIT.CLUSE',
     *   'CALEDIT.TIMRNG', 'CALEDIT.UVRNG', 'CALEDIT.ANTENNS',
     *   'CALEDIT.SOURCS', 'CALEDIT.SELQUA', 'CALEDIT.SELBAN',
     *   'CALEDIT.SELFRQ', 'CALEDIT.FRQSEL', 'CALEDIT.SELCOD',
     *   'CALEDIT.SUBARR', 'CALEDIT.DOPOL', 'CALEDIT.BLVER',
     *   'CALEDIT.DOBAND', 'CALEDIT.BPVER', 'CALEDIT.SMOOTH',
     *   'EQU_TIME', 'GAP_TIME', 'DOHIST', 'REWEIGHT', 'COMPARE',
     *   'DOEXPERT', 'ANTS2USE', 'REASON', 'CROWDED', 'DO3COLOR',
     *   'CALEDIT.PDVER'/
C                                       Adverbs for UVDAT2 object
      DATA INK2 /'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK', 'TIMERANG',
     *   'UVRANGE', 'BCHAN', 'ECHAN', 'BIF', 'EIF', 'STOKES',
     *   'ANTENNAS'/
C                                       Rename
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'CALEDIT.TIMRNG',
     *   'CALEDIT.UVRNG', 'CALEDIT.BCHAN', 'CALEDIT.ECHAN',
     *   'CALEDIT.BIF', 'CALEDIT.EIF', 'CALEDIT.STOKES',
     *   'CALEDIT.ANTENNS'/
      DATA FGNAME /'CALEDIT.FGVER', 'IN_FGVER', 'OUT_FGVER',
     *   'COP_FGVER'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL AV2INT (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IERR)
      IF (IERR.NE.0) GO TO 999
      RQUICK = .FALSE.
C                                       BADDISK
      CALL OGET ('Input', 'BADDISK', TYPE, DIM, IBAD, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Create UV master object
      UVDATA = 'UVDATA master input object'
      CALL CREATE (UVDATA, 'UVDATA', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, UVDATA, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       DOCALIB
      CALL OGET ('Input', 'DOCALIB', TYPE, DIM, IDUM, CDUMMY, IERR)
      XDOCAL = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      LDUM(1) = XDOCAL.GT.0.0
      CALL OPUT (UVDATA, 'CALEDIT.DOCAL', OOALOG, DIM, IDUM, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
      LDUM(1) = (XDOCAL.GT.0.0) .AND. (XDOCAL.LE.99.0)
      CALL OPUT (UVDATA, 'CALEDIT.DOWTCL', OOALOG, DIM, IDUM, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get IF channel selection
      CALL SECSLT (UVDATA, BIF, EIF, BCHAN, ECHAN, STOKES, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       All Stokes', IF, channels
      CALL SECSAV (UVDATA, 1, 0, 1, 0, '    ', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open UVDATA to be sure it's OK
      CALL OOPEN (UVDATA, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OCLOSE (UVDATA, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Find highest FG table.
      FGIN = 'Temporary FG table for EDITR'
      FGV = 1
      CALL UV2TAB (UVDATA, FGIN, 'FG', FGV, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TBLHIV (FGIN, FGV, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TABDES (FGIN, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Set FLAGVER
      CALL OGET ('Input', 'FLAGVER', TYPE, DIM, IDUM, CDUMMY, IERR)
      FGVERI = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET ('Input', 'OUTFGVER', TYPE, DIM, IDUM, CDUMMY, IERR)
      FGVERO = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      FGVERI = MIN (FGVERI, FGV)
      IF (FGVERI.EQ.0) FGVERI = FGV
      IF ((FGVERO.LE.0) .OR. (FGVERO.GT.FGV)) FGVERO = FGV + 1
      FGVERC = FGVERI
      IF (FGVERO.LE.FGV) FGVERC = - ABS (FGVERI)
      IDUM(1) = FGVERI
      CALL OPUT (UVDATA, FGNAME(1), TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OPUT (UVDATA, FGNAME(2), TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IDUM(1) = FGVERO
      CALL OPUT (UVDATA, FGNAME(3), TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IDUM(1) = FGVERC
      CALL OPUT (UVDATA, FGNAME(4), TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Find size of axes
      CALL UVDFND (UVDATA, 2, 'FREQ', FQINDX, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL UVDFND (UVDATA, 2, 'STOKES', STINDX, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL UVDFND (UVDATA, 2, 'IF  ', IFINDX, IERR)
      IERR = 0
      CALL OGET (UVDATA, 'UV_DESC.NAXIS', TYPE, DIM, NAXIS, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (UVDATA, 'UV_DESC.CRVAL', TYPE, DIM, IDUM, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
      CALL DPCOPY (DIM(1), DDUM, CRVAL)
C                                       channel defaults
      NCHN = NAXIS(FQINDX)
      BCHAN = MAX (BCHAN, 1)
      BCHAN = MIN (BCHAN, NCHN)
      IF (ECHAN.LT.BCHAN) ECHAN = NCHN
      ECHAN = MIN (ECHAN, NCHN)
C                                       IF defaults
      IF (IFINDX.GT.0) THEN
         NIF = NAXIS(IFINDX)
         BIF = MAX (1, BIF)
         BIF = MIN (BIF, NIF)
         IF (EIF.LT.BIF) EIF = NIF
         EIF = MIN (EIF, NIF)
      ELSE
         BIF = 1
         EIF = 1
         NIF = 1
         END IF
C                                       Stokes
      IF ((STOKES.NE.'I') .AND. (CRVAL(STINDX).LT.0.0D0) .AND.
     *   (NAXIS(STINDX).GT.1)) THEN
         STOKES = 'HALF'
      ELSE
         STOKES = 'I'
         END IF
C                                       Do 2nd image?
      CALL OGET ('Input', 'IN2NAME', TYPE, DIM, IDUM, TINAME, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET ('Input', 'IN2CLASS', TYPE, DIM, IDUM, TICLAS, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET ('Input', 'IN2DISK', TYPE, DIM, IDUM, CDUMMY, IERR)
      I = IDUM(1)
      IF (IERR.NE.0) GO TO 999
C                                       Create UVDAT2 object
      IF ((TINAME.EQ.' ') .OR. (TICLAS.EQ.' ') .OR. (I.LE.0)) THEN
         UVDAT2 = ' '
      ELSE
         UVDAT2 = 'Input UVdata to be edited'
         CALL CREATE (UVDAT2, 'UVDATA', IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
         CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, UVDAT2, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Get IF channel selection
         CALL SECSLT (UVDAT2, BIF2, EIF2, BCHAN2, ECHAN2, STOKES, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       All Stokes, IF, channels
         CALL SECSAV (UVDAT2, 1, 0, 1, 0, '    ', IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Open UVDAT2 to be sure OK.
         CALL OOPEN (UVDAT2, 'READ', IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OCLOSE (UVDAT2, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       check parameters
C                                       Find size of axes
         CALL UVDFND (UVDAT2, 2, 'FREQ', FQINDX, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL UVDFND (UVDAT2, 2, 'STOKES', STINDX, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL UVDFND (UVDAT2, 2, 'IF  ', IFINDX, IERR)
         IERR = 0
         CALL OGET (UVDAT2, 'UV_DESC.NAXIS', TYPE, DIM, NAXIS, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OGET (UVDAT2, 'UV_DESC.CRVAL', TYPE, DIM, IDUM, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         CALL DPCOPY (DIM(1), DDUM, CRVAL)
C                                       channel defaults
         NCHN2 = NAXIS(FQINDX)
         IF (NCHN2.GE.NCHN) THEN
            BCHAN2 = BCHAN
            ECHAN2 = ECHAN
         ELSE
            BCHAN2 = 1
            ECHAN2 = ECHAN - BCHAN + 1
            ECHAN2 = MIN (ECHAN2, NCHN2)
            END IF
C                                       IF defaults
         IF (IFINDX.GT.0) THEN
            NIF2 = NAXIS(IFINDX)
         ELSE
            NIF2 = 1
            END IF
         IF (NIF2.GE.NIF) THEN
            BIF2 = BIF
            EIF2 = EIF
         ELSE
            BIF2 = 1
            EIF2 = EIF - BIF + 1
            IF (EIF2.GT.NIF2) THEN
               MSGTXT = 'IF AXES DO NOT MATCH AS SELECTED'
               IERR = 8
               CALL MSGWRT (8)
               GO TO 999
               END IF
            END IF
C                                       Stokes
         IF ((STOKES.NE.'I') .AND. (CRVAL(STINDX).LT.0.0D0) .AND.
     *         (NAXIS(STINDX).GT.1)) THEN
            STOKES = 'HALF'
         ELSE
            STOKES = 'I'
            END IF
C                                       Reset Selection
         CALL SECSAV (UVDAT2, BIF2, EIF2, BCHAN2, ECHAN2, STOKES, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Reset Selection
      CALL SECSAV (UVDATA, BIF, EIF, BCHAN, ECHAN, STOKES, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Save in Inputs for history
      DIM(1) = 4
      CALL OPUT ('Input', 'STOKES', OOACAR, DIM, IDUM, STOKES, IERR)
      IF (IERR.NE.0) GO TO 999
      DIM(1) = 1
      IDUM(1) = BCHAN
      CALL OPUT ('Input', 'BCHAN', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IDUM(1) = ECHAN
      CALL OPUT ('Input', 'ECHAN', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IDUM(1) = BIF
      CALL OPUT ('Input', 'BIF', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IDUM(1) = EIF
      CALL OPUT ('Input', 'EIF', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE EDITIT (UVDATA, UVDAT2, IERR)
C-----------------------------------------------------------------------
C   Does the editing
C   Inputs:
C      UVDATA   C*32   Name of input uv data. - as master
C      UVDAT2   C*32   Name of input uv work file also to edit
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER UVDATA*(*), UVDAT2*(*)
C
      DOUBLE PRECISION APCORE(2)
      CHARACTER UVEDIT*32, STATUS*4, TVDEVC*32, CDUMMY*1
      INTEGER   JERR, DIM(7)
      LOGICAL   DOFLAG
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      DATA DOFLAG /.TRUE./
C-----------------------------------------------------------------------
C                                       open TV object
      TVDEVC = 'EDITR task TV object'
      CALL TVDCRE (TVDEVC, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL TVDOPN (TVDEVC, STATUS, IERR)
      IF (IERR.NE.0) GO TO 985
C                                       open edit object
      UVEDIT = 'EDITR task EDIT object'
      CALL EDICRE (UVEDIT, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL EDIOPN (UVEDIT, STATUS, IERR)
      IF (IERR.NE.0) GO TO 975
C                                       Insert object info
      DIM(1) = LEN(UVDATA)
      DIM(2) = 1
      CALL EDIPUT (UVEDIT, 'UVMASTER', OOACAR, DIM, IDUM, UVDATA, IERR)
      IF (IERR.NE.0) GO TO 980
      DIM(1) = LEN(UVDAT2)
      CALL EDIPUT (UVEDIT, 'UVSECOND', OOACAR, DIM, IDUM, UVDAT2, IERR)
      IF (IERR.NE.0) GO TO 980
      DIM(1) = LEN(TVDEVC)
      CALL EDIPUT (UVEDIT, 'TVDEVICE', OOACAR, DIM, IDUM, TVDEVC, IERR)
      IF (IERR.NE.0) GO TO 980
      DIM(1) = 1
      LDUM(1) = DOFLAG
      CALL EDIPUT (UVEDIT, 'DOUVFLAG', OOALOG, DIM, IDUM, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 980
C                                       do it
      CALL EDITUV (APCORE, 'INIT', UVEDIT, IERR)
C                                       Clean up - no apply
      IF (IERR.NE.0) THEN
         IF (IERR.LT.0) THEN
            CALL EDITUV (APCORE, 'ABOR', UVEDIT, JERR)
            IERR = 0
         ELSE
            CALL EDITUV (APCORE, 'KILL', UVEDIT, JERR)
            END IF
C                                       apply FG and clean up
      ELSE
         CALL EDITUV (APCORE, 'APPL', UVEDIT, IERR)
         END IF
      IF (UVDAT2.NE.' ') CALL OUVDES (UVDAT2, JERR)
      CALL OUVDES (UVDATA, IERR)
C                                       Delete object
      CALL EDICLO (UVEDIT, JERR)
 975  CALL EDIDES (UVEDIT, JERR)
C                                       close and delete TV device
 980  CALL TVDCLO (TVDEVC, JERR)
 985  CALL TVDDES (TVDEVC, JERR)
C                                       error message
 990  IF (IERR.NE.0) THEN
         MSGTXT = 'ERROR EDITING ' // UVDATA
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
      END

      SUBROUTINE QMENT (APCORE, APBASE, DOGRDS, IMG, DEF, RES, STP,
     *   NELEM)
C-----------------------------------------------------------------------
C! Pseudo AP routine: MEM routine
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Q-Routine for Maximum entropy programs. Calculates gradients
C   and their dot products.
C   Input :
C      APBASE   I  Base address in PS-AP, all others relative
C      DOGRDS   I  Do gradients ? If > 0 then yes else no.
C      IMG      I  Pointer in PS-AP to MEM image line
C      DEF      I  Pointer in PS-AP to default image line
C      RES      I  Pointer in PS-AP to residual image line
C      STP      I  Pointer in PS-AP to step image line
C      NELEM    I  Number of elements in a line
C   Input via AP :
C    Location        Variable
C      0            - ALPHA
C      1            - BETA
C      2              GGC
C      3              1.0
C  Input/Output via AP :
C   Location        Variable
C      4             GRDHSQ
C      5             GRDESQ
C      6             GRDFSQ
C      7             GRDHE
C      8             GRDHF
C      9             GRDEF
C     10             FLUX
C     11              RJ1
C    STP        step in mem image
C    All locations are relative to APBASE. Location 12 is used for
C scratch. Locations 13-16 are free for future use.
C Programmer : T.J. Cornwell                   January 1986
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   APBASE, DOGRDS, IMG, DEF, RES, STP, NELEM
c
      INTEGER   ALP, BET, GGC, RH, WRK, RJ1, RONE, GHS, GES, GFS, GHE,
     *   GHF, GEF, FLX, TMP
C-----------------------------------------------------------------------
C                                      Pointers for variables
      ALP = APBASE
      BET = ALP + 1
      GGC = ALP + 2
      RONE = ALP + 3
C                                      Storage for gradients, etc
      GHS = ALP + 4
      GES = ALP + 5
      GFS = ALP + 6
      GHE = ALP + 7
      GHF = ALP + 8
      GEF = ALP + 9
      FLX = ALP + 10
      RJ1 = ALP + 11
      TMP = ALP + 12
C                                      Storage for work areas
      RH  = STP + NELEM
      WRK = RH  + NELEM
C
C            FLUX = FLUX + IMG
C
      CALL QSVE (APCORE, IMG, 1, TMP, NELEM)
      CALL QVADD (APCORE, TMP, 1, FLX, 1, FLX, 1, 1)
C
C               RH = IMG / (1.0 + GGC*IMG)
C
      CALL QVSMSA (APCORE, IMG, 1, GGC, RONE, RH, 1, NELEM)
      CALL QVDIV  (APCORE, RH, 1, IMG, 1, RH, 1, NELEM)
C
C               GRADH = -LOG (IMG/DEF)
C
      CALL QVDIV (APCORE, IMG, 1, DEF, 1, IMG, 1, NELEM)
      CALL QVLN  (APCORE, IMG, 1, IMG, 1, NELEM)
C
C            GRADJ = GRADH - ALPHA*RES - BETA
C
      CALL QVSMA (APCORE, RES, 1, ALP, IMG, 1, WRK, 1, NELEM)
      CALL QVSADD (APCORE, WRK, 1, BET, WRK, 1, NELEM)
C
C            RJ1 = RJ1 + STP*GRADJ
C
      CALL QVMUL (APCORE, STP, 1, WRK, 1, STP, 1, NELEM)
      CALL QSVE (APCORE, STP, 1, TMP, NELEM)
      CALL QVADD (APCORE, TMP, 1, RJ1, 1, RJ1, 1, 1)
      IF (DOGRDS.GE.0) THEN
         CALL QVMOV (APCORE, WRK, 1, STP, 1, NELEM)
C
C            STP = GRADJ*RH
C
         CALL QVMUL (APCORE, STP, 1, RH, 1, STP, 1, NELEM)
C
C               GFS = GFS + RH
C
         CALL QSVE (APCORE, RH, 1, TMP, NELEM)
         CALL QVADD (APCORE, TMP, 1, GFS, 1, GFS, 1, 1)
C
C               GHS = GHS + RH * GRADH**2
C
         CALL QVSQ (APCORE, IMG, 1, WRK, 1, NELEM)
         CALL QVMUL (APCORE, WRK, 1, RH, 1, WRK, 1, NELEM)
         CALL QSVE (APCORE, WRK, 1, TMP, NELEM)
         CALL QVADD (APCORE, TMP, 1, GHS, 1, GHS, 1, 1)
C
C               GES = GES + RH * GRADER**2
C
         CALL QVSQ (APCORE, RES, 1, WRK, 1, NELEM)
         CALL QVMUL (APCORE, WRK, 1, RH, 1, WRK, 1, NELEM)
         CALL QSVE (APCORE, WRK, 1, TMP, NELEM)
         CALL QVADD (APCORE, TMP, 1, GES, 1, GES, 1, 1)
C
C            GHE = GHE + RH * GRADER * GRADH
C
         CALL QVMUL (APCORE, RES, 1, IMG, 1, WRK, 1, NELEM)
         CALL QVMUL (APCORE, WRK, 1, RH, 1, WRK, 1, NELEM)
         CALL QSVE (APCORE, WRK, 1, TMP, NELEM)
         CALL QVADD (APCORE, TMP, 1, GHE, 1, GHE, 1, 1)
C
C            GEF = GEF + RH * GRADER
C
         CALL QVMUL (APCORE, RES, 1, RH, 1, WRK, 1, NELEM)
         CALL QSVE (APCORE, WRK, 1, TMP, NELEM)
         CALL QVADD (APCORE, TMP, 1, GEF, 1, GEF, 1, 1)
C
C            GHF = GHF + RH * GRADH
C
         CALL QVMUL (APCORE, IMG, 1, RH, 1, WRK, 1, NELEM)
         CALL QSVE (APCORE, WRK, 1, TMP, NELEM)
         CALL QVADD (APCORE, TMP, 1, GHF, 1, GHF, 1, 1)
         END IF
C
  999 RETURN
      END

LOCAL INCLUDE 'OBPLT.INC'
      INTEGER BUFFER(256)
      COMMON /FBUFF/ BUFFER
C                                       POPS variable names
      INTEGER NPARM
      PARAMETER (NPARM = 22)
      HOLLERITH      XINNAM(3), XINCLA(2)
      REAL           XINSEQ, XINDIS, XINVER
      HOLLERITH      XOPCOD(1), XOPTYP(1)
      REAL           XAPARM(10), XLTYPE, XDOTV
      COMMON /INPARM/ XINNAM, XINCLA,
     *                XINSEQ, XINDIS, XINVER,
     *                XOPCOD, XOPTYP,
     *                XAPARM, XLTYPE, XDOTV
C                                       internal variable names
      CHARACTER       INNAME*12, INCLAS*6, OPCODE*4, OPTYPE*4
      COMMON /CHRCOM/ INNAME,    INCLAS,   OPCODE,   OPTYPE
      INTEGER         INDISK, INCAT, INSEQ, INVERS, LTYPE
      LOGICAL         DOTV
      REAL            APARM(10)
      COMMON /NUMCOM/ INDISK, INCAT, INSEQ, INVERS, DOTV, APARM, LTYPE
C
C                                       table info is stored here
      INCLUDE 'INCS:POBV.INC'
      INTEGER TABBUF(512)
      INTEGER N
      INTEGER OBKOLS(MAXOBC), OBNUMB(MAXOBC)
      COMMON /TBUF/ TABBUF, N, OBKOLS, OBNUMB

LOCAL END
      PROGRAM OBPLT
C-----------------------------------------------------------------------
C! Plots one column of an OB table against another
C# TASK VLBI PLOT UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2003, 2005, 2007, 2012, 2014, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   OBPLT plots any two columns of an OB table against each other
C   Inputs:
C   AIPS adverb  Prg. name.          Description.
C   INNAME         INNAME        Name of the file to be sorted
C   INCLASS        INCLAS        Class of the file to be sorted.
C   INSEQ          INSEQ         Seq. number of file to be sorted.
C   INDISK         INDISK        Disk number of file to be sorted.
C   INVERS         INVERS        Vers. number of OB table to be plotted.
C   OPCODE         OPCODE        X-Column to plot.
C   OPTYPE         OPTYPE        Y-Column to plot.
C   APARM          APARM         APARM(1-2) can be used to specify
C                                explicitly the limits on the X-axis
C                                instead of self-scaling
C                                APARM(3-4) can be used to specify
C                                explicitly the limits on the X-axis
C                                instead of self-scaling
C   LTYPE          LTYPE         Used to specify how axes are labelled.
C                                As per standard AIPS conventions
C                                [see HELP LTYPE]
C   DOTV           DOTV          If DOTV=1, plot appears on TV,
C                                if DOTV=0, plot goes to PL file.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, IERR
      INCLUDE 'OBPLT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA PRGM /'OBPLT '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      IRET = 18
      CALL OBPLIN (PRGM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Read OB table and extract
C                                       wanted columns
      IRET = 17
      CALL PREPOB (IERR)
      IF (IERR.NE.0) GO TO 990
      IRET = 0
C                                       Close down files
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE OBPLIN (PRGM, JERR)
C-----------------------------------------------------------------------
C   OBPLIN gets input parameters for OBPLT
C   Inputs: PRGM   C*6       Task name
C   Output: JERR   I         Error code: 0 => ok, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, STAT*4, UTYPE*2
      INTEGER  JERR, TABLUN, IROUND, IERR
      LOGICAL   T
      INCLUDE 'OBPLT.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA TABLUN /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init IO characteristics
      CALL ZDCHIN (T)
      CALL VHDRIN
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      CALL GTPARM (PRGM, NPARM, RQUICK, XINNAM, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         JERR = 8
         RQUICK = .FALSE.
         GO TO 999
         END IF
C                                       Crunch input parameters.
      INSEQ  = IROUND (XINSEQ)
      INDISK = IROUND (XINDIS)
      INVERS = IROUND (XINVER)
C                                       Characters
      CALL H2CHR (12, 1, XINNAM, INNAME)
      CALL H2CHR (6, 1, XINCLA, INCLAS)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
C                                       Reals
C                                       axis labelling handle, see
C                                       LTYPE adverb inside AIPS
      LTYPE = IROUND (XLTYPE)
      IF (MOD(ABS(LTYPE), 100).EQ.0) THEN
         IF (LTYPE.LT.0) THEN
            LTYPE = (LTYPE/100)*100 - 3
         ELSE
            LTYPE = (LTYPE/100)*100 + 3
            END IF
         END IF
      XLTYPE = LTYPE
C                                       manually set limits on X and
C                                       Y axes using APARM(1-2) and
C                                       APARM(3-4) respectively
      APARM(1) = XAPARM(1)
      APARM(2) = XAPARM(2)
      APARM(3) = XAPARM(3)
      APARM(4) = XAPARM(4)
C                                       Logicals
      DOTV = XDOTV.GT.0.0
C                                       Restart AIPS.
      IF (RQUICK) CALL RELPOP (JERR, BUFFER, IERR)
C                                       Get CATBLK.
      INCAT = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', INDISK, INCAT, INNAME, INCLAS, INSEQ, UTYPE,
     *   NLUSER, STAT, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, INNAME, INCLAS, INSEQ, INDISK, NLUSER
         CALL MSGWRT (8)
         JERR = 5
         GO TO 999
         END IF
      CALL CATIO ('READ', INDISK, INCAT, CATBLK, 'REST', BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (8)
         JERR = 5
         GO TO 999
         END IF
      NCFILE = 1
      FVOL(1) = INDISK
      FCNO(1) = INCAT
      FRW(1) = 0
C                                       max number of points to plot from
C                                       table
C
C                                       Init table
      CALL OBINI ('READ', TABBUF, INDISK, INCAT, INVERS, CATBLK, TABLUN,
     *   N, OBKOLS, OBNUMB, JERR)
      IF (JERR.NE.0) GO TO 999
C                                       count number of rows
      N = TABBUF(5)
C                                       done!
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OBPLIN: ERROR',I7,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('OBPLIN: ERROR',I7,' FINDING ',A12,'.',A6,'.',I4,
     *               ' DISK=',I3,' USID=',I5)
 1020 FORMAT ('OBPLIN: ERROR',I7,' COPYING CATBLK ')
      END
      SUBROUTINE PREPOB (IRET)
C-----------------------------------------------------------------------
C   PREPOB allocates enough dynamic memory to plot all possible rows of
C   the OB table; additionally, PREPOB loads the data arrays and invokes
C   the plotting routine PLOTOB.  These must be invoked here since the
C   data arrays are created here.
C   Inputs through local include OBPLT.INC
C      N        I        Number of rows in OB table
C   Outputs
C      IRET     I        Error code: 0 => ok
C                           not 0 => not ok
C-----------------------------------------------------------------------
      INTEGER    IRET
C
      INCLUDE 'OBPLT.INC'
      LONGINT    OX, OY
      REAL       X(2), Y(2)
      INTEGER    NMEM, IERR
C-----------------------------------------------------------------------
C                                       be optimistic
      IRET = 0
C                                       get memory for X array
      NMEM = N
      IF (NMEM.GT.2) THEN
         NMEM = ( ( NMEM - 1 )/256 + 1 ) * 256
         NMEM = (NMEM - 1) / 1024 + 1
         CALL ZMEMRY ('GET', 'PREPOB', NMEM, X, OX, IRET)
         IF (IRET.NE.0) GO TO 100
      ELSE
         OX = 0
         END IF
C                                       get memory for X array
      NMEM = N
      IF (NMEM.GT.2) THEN
         NMEM = ( ( NMEM - 1 )/256 + 1 ) * 256
         NMEM = (NMEM - 1) / 1024 + 1
         CALL ZMEMRY ('GET', 'PREPOB', NMEM, Y, OY, IRET)
         IF (IRET.NE.0) GO TO 100
      ELSE
         OY = 0
         END IF
C                                       load arrays
      CALL LOADOB (X(1+OX), Y(1+OY), IRET)
C                                       plot arrays
      IF (IRET.EQ.0) CALL PLOTOB (X(1+OX), Y(1+OY), IRET)
C                                       free memory
 100  CALL ZMEMRY ('FRAL', 'PREPOB', NMEM, X, OX, IERR)
C
 999  RETURN
      END
      SUBROUTINE LOADOB (X, Y, IRET)
C-----------------------------------------------------------------------
C   LOADOB gets data arrays from OB table
C   Inputs:
C      N           I      (via common) total number of rows in OB table
C   Output:
C      X(N)        I      X axis data array
C      Y(N)        I      Y axis data array
C      N           I      (via common) actual # of data points loaded
C      IRET        I      Error code: 0 => ok, else quit
C-----------------------------------------------------------------------
      INTEGER IRET
      INCLUDE 'OBPLT.INC'
C                                       get FBLANK value
      INCLUDE 'INCS:DDCH.INC'
      REAL X(N), Y(N)
      INTEGER OBROW, OBANT, OBSUB, M
      REAL OBANGL(3), OBECL(4), OBORI, XTEMP, YTEMP
      DOUBLE PRECISION OBTIME, OBPOS(3), OBVEL(3)
C-----------------------------------------------------------------------
C                                       start at row 1
      OBROW = 1
C                                       initialize #points loaded
      M = 0
C                                       loop over rows of OB table
 300  CONTINUE
         IF (OBROW.GT.N) GO TO 390
         CALL TABOB ('READ', TABBUF, OBROW, OBKOLS, OBNUMB,
     *      OBANT, OBSUB, OBTIME, OBPOS, OBVEL, OBANGL, OBECL, OBORI,
     *      IRET)
         IF (IRET.EQ.4) GO TO 390
C                                       find x point here
         CALL GETOBV (OPCODE, OBANT, OBSUB, OBTIME,
     *      OBPOS, OBVEL, OBANGL, OBECL, OBORI, XTEMP)
C                                       find y point here
         CALL GETOBV (OPTYPE, OBANT, OBSUB, OBTIME,
     *      OBPOS, OBVEL, OBANGL, OBECL, OBORI, YTEMP)
C                                       load arrays here
         IF ((XTEMP.NE.FBLANK).AND.(YTEMP.NE.FBLANK)) THEN
            M = M + 1
            X(M) = XTEMP
            Y(M) = YTEMP
            END IF
         GO TO 300
 390     CONTINUE
C                                       reset counter to #points loaded
      N = M
C                                       done!
 999  RETURN
      END
      SUBROUTINE GETOBV (AXTYPE, OBANT, OBSUB, OBTIME,
     *   OBPOS, OBVEL, OBANGL, OBECL, OBORI, AXVAL)
C-----------------------------------------------------------------------
C   GETOBV extracts the requested data value for an OB table record
C   Inputs:
C      AXTYPE    C*4    Axis type label - user supplied
C             These quantities are as returned by TABOB
C      OBANT     I      Antenna number for this OB record
C      OBSUB     I      Subarray number for this OB record
C      OBTIME    R
C      OBPOS(3)  D(3)
C      OBVEL(3)  D(3)
C      OBANGL(3) R(3)
C      OBECL(4)  R(4)
C      OBORI     R      Parallactic angle
C   Outputs:
C      AXVAL     R     Value for the axis type requested
C-----------------------------------------------------------------------
      CHARACTER AXTYPE*4
      INTEGER OBANT, OBSUB
      REAL OBANGL(3), OBECL(4), OBORI
      DOUBLE PRECISION OBTIME, OBPOS(3), OBVEL(3)
      REAL AXVAL
C-----------------------------------------------------------------------
      IF (AXTYPE.EQ.'ANT ') AXVAL = OBANT
      IF (AXTYPE.EQ.'SUB ') AXVAL = OBSUB
      IF (AXTYPE.EQ.'TIME') AXVAL = OBTIME * 24.0
      IF (AXTYPE.EQ.'XPOS') AXVAL = OBPOS(1)
      IF (AXTYPE.EQ.'YPOS') AXVAL = OBPOS(2)
      IF (AXTYPE.EQ.'ZPOS') AXVAL = OBPOS(3)
      IF (AXTYPE.EQ.'XVEL') AXVAL = OBVEL(1)
      IF (AXTYPE.EQ.'YVEL') AXVAL = OBVEL(2)
      IF (AXTYPE.EQ.'ZVEL') AXVAL = OBVEL(3)
      IF (AXTYPE.EQ.'ANG1') AXVAL = OBANGL(1)
      IF (AXTYPE.EQ.'ANG2') AXVAL = OBANGL(2)
      IF (AXTYPE.EQ.'ANG3') AXVAL = OBANGL(3)
      IF (AXTYPE.EQ.'ECL1') AXVAL = OBECL(1)
      IF (AXTYPE.EQ.'ECL2') AXVAL = OBECL(2)
      IF (AXTYPE.EQ.'ECL3') AXVAL = OBECL(3)
      IF (AXTYPE.EQ.'ECL4') AXVAL = OBECL(4)
      IF (AXTYPE.EQ.'ORIE') AXVAL = OBORI
      IF (AXTYPE.EQ.'DIST') THEN
         AXVAL = OBPOS(1)**2 + OBPOS(2)**2 + OBPOS(3)**2
         AXVAL = SQRT(AXVAL)
         END IF
      IF (AXTYPE.EQ.'VEL') THEN
         AXVAL = OBVEL(1)**2 + OBVEL(2)**2 + OBVEL(3)**2
         AXVAL = SQRT(AXVAL)
         END IF
      IF (AXTYPE.EQ.'BECL') AXVAL = OBECL(1) * 24.0
      IF (AXTYPE.EQ.'EECL') AXVAL = OBECL(2) * 24.0
      RETURN
      END
      SUBROUTINE GETOBU (AXTYPE, AXUNIT)
C-----------------------------------------------------------------------
C   GETOBU extracts the units of the requested data value for an OB
C      table record
C   Inputs:
C      AXTYPE    C*4    Axis type label - user supplied
C             These quantities are as returned by TABOB
C   Outputs:
C      AXUNIT   C*20   Units for the axis type requested
C-----------------------------------------------------------------------
      CHARACTER AXUNIT*20, AXTYPE*4
C-----------------------------------------------------------------------
      IF (AXTYPE.EQ.'ANT ') AXUNIT = 'STAT'
      IF (AXTYPE.EQ.'SUB ') AXUNIT = 'SUBA'
      IF (AXTYPE.EQ.'TIME') AXUNIT = 'Hours'
      IF (AXTYPE.EQ.'XPOS') AXUNIT = 'Meters'
      IF (AXTYPE.EQ.'YPOS') AXUNIT = 'Meters'
      IF (AXTYPE.EQ.'ZPOS') AXUNIT = 'Meters'
      IF (AXTYPE.EQ.'XVEL') AXUNIT = 'Meters/Second'
      IF (AXTYPE.EQ.'YVEL') AXUNIT = 'Meters/Second'
      IF (AXTYPE.EQ.'ZVEL') AXUNIT = 'Meters/Second'
      IF (AXTYPE.EQ.'ANG1') AXUNIT = 'Sun Angle'
      IF (AXTYPE.EQ.'ANG2') AXUNIT = 'Sun Angle'
      IF (AXTYPE.EQ.'ANG3') AXUNIT = 'Sun Angle'
      IF (AXTYPE.EQ.'ECL1') AXUNIT = 'Begin Eclipse'
      IF (AXTYPE.EQ.'ECL2') AXUNIT = 'End Eclipse'
      IF (AXTYPE.EQ.'ECL3') AXUNIT = ' '
      IF (AXTYPE.EQ.'ECL4') AXUNIT = ' '
      IF (AXTYPE.EQ.'ORIE') AXUNIT = 'Degrees'
      IF (AXTYPE.EQ.'DIST') AXUNIT = 'Meters'
      IF (AXTYPE.EQ.'VEL')  AXUNIT = 'Meters/Second'
      IF (AXTYPE.EQ.'BECL') AXUNIT = 'Hours'
      IF (AXTYPE.EQ.'EECL') AXUNIT = 'Hours'
      RETURN
      END
      SUBROUTINE PLOTOB (X, Y, IRET)
C-----------------------------------------------------------------------
C   This routine will plot the data in YARRAY versus the data in XARRAY
C   Input:
C      X       R(N)     Array of X-values
C      Y       R(N)     Array of Y-values
C   Output:
C      IRET    I        Termination code (0 => ok)
C   Input from common:
C      DOTV    L        If true then plot to TV dev., else PL file.
C-----------------------------------------------------------------------
      INTEGER IRET
C                                       the dimension of X and Y are
C                                       carried in OBPLT.INC
      INCLUDE 'OBPLT.INC'
      REAL X(N), Y(N)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DPLD.INC'
      INCLUDE 'INCS:DMSG.INC'
      CHARACTER LABOVE(5)*80, LBELOW(5)*80, LXUNIT*20, LYUNIT*20
      REAL BLC(2), TRC(2), XDIV, YDIV, XWIDTH, YWIDTH
      REAL PGBLC(2), PGTRC(2), XMIN, XMAX, YMIN, YMAX, XPFRAC, YPFRAC
      INTEGER NX, NY, IGTYPE, ITVORG(2), IGRCHN, ITVCHN, IERR, NABOVE,
     *   NBELOW
      INTEGER PLTBUF(256)
C----------------------------------------------------------------------
C                                       Initialisation
      IRET = 0
      CALL FILL (2, 0, ITVORG)
      IGRCHN = 1
      ITVCHN = 1
C                                       New page
      IGTYPE = 1
      CALL PLINIT (IGTYPE, INDISK, INCAT, CATBLK, NPARM, XINNAM,
     *   DOTV, IGRCHN, ITVCHN, ITVORG, PLTBUF, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       Define plotting page in pixels
      PGBLC(1) = 0.0
      PGBLC(2) = 0.0
      PGTRC(1) = 1000.0
      PGTRC(2) = 1000.0
C                                       required first line
      NABOVE = 2
      WRITE (LABOVE(1), 1030) INNAME, INCLAS, INSEQ, INDISK
      WRITE (LABOVE(2), 1031) INVERS, OPTYPE, OPCODE
      NBELOW = 0
C                                       get X-axis units
      CALL GETOBU (OPCODE, LXUNIT)
C                                       get Y-axis units
      CALL GETOBU (OPTYPE, LYUNIT)
      NX = 1
      NY = 1
C                                       these numbers need tweaking.
      XPFRAC = 0.35
C                                       this used to be 0.9
      YPFRAC = 0.35
      XDIV = NX + (NX + 0.5) * XPFRAC
      YDIV = NY + (NY + 1.0) * YPFRAC
      XWIDTH = (PGTRC(1) - PGBLC(1)) / XDIV
      YWIDTH = (PGTRC(2) - PGBLC(2)) / YDIV
C                                       define lower left of plot
      BLC(1) = PGBLC(1) + XWIDTH * XPFRAC
      BLC(2) = PGBLC(2) + YWIDTH * YPFRAC
C                                       define upper right of plot
      TRC(1) = BLC(1) + XWIDTH
      TRC(2) = BLC(2) + YWIDTH
C                                       Determine axis range
C                                       did user set limits manually?
      IF (APARM(1).LT.APARM(2)) THEN
         XMIN = APARM(1)
         XMAX = APARM(2)
      ELSE
         CALL PLRANG (X, N, 1.05, 0.0, XMIN, XMAX)
         END IF
      IF (APARM(3).LT.APARM(4)) THEN
         YMIN = APARM(3)
         YMAX = APARM(4)
      ELSE
         CALL PLRANG (Y, N, 1.05, 0.0, YMIN, YMAX)
         END IF
C                                       write header and plot axes
      CALL PLAXES (BLC, TRC, XMIN, XMAX, YMIN, YMAX, LTYPE, LXUNIT,
     *   LYUNIT, NABOVE, NBELOW, LABOVE, LBELOW, 5, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1040) IERR
         GO TO 990
      END IF

C                                       Plot points
      CALL PLPNT (X, Y, N, 1, 0.03, IERR)
      IF (IERR.NE.0) THEN
         IRET = 3
         WRITE (MSGTXT,1220) IERR
         GO TO 990
         END IF
C                                       End page
      CALL PLCLOS (INDISK, INCAT, CATBLK, PLTBUF, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
      CALL PLCLOS (INDISK, INCAT, CATBLK, PLTBUF, IRET)
C                                       Exit
 999  RETURN
C----------------------------------------------------------------------
 1020 FORMAT ('PLOTOB: ERROR',I5,' RETURNED BY PLINIT')
 1030 FORMAT ('OB table plot for ',A12,'.',A6,'.',I4,'.',I4)
 1031 FORMAT ('OB # ',I4,' : ',A4,' vs ',A4)
 1040 FORMAT ('PLOTOB: ERROR',I5,' RETURNED BY PLAXES')
 1220 FORMAT ('PLOTOB: ERROR',I5,' RETURNED BY PLPNT')
      END

      SUBROUTINE ZBYMOV (NMOVE, INP, INB, OUTP, OUTB)
C-----------------------------------------------------------------------
C! move 8-bit bytes from in-buffer to out-buffer
C# Z Binary
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Moves a string of bytes from INB to OUTB. Byte = 8 bits (NOT an AIPS
C   half-integer byte).  This is used with tape input and output only.
C   Inputs:
C      NMOVE   I      Number of 8-bit bytes bytes
C      INP     I      First value in INB to move (8-bit byte offset)
C      INB     I(*)   Input buffer.
C      OUTP    I      Location in OUTB to put first 8-bit byte  (8-bit
C                     byte offset)
C   Output:
C      OUTB    I(*)   Output buffer.
C   VAX version
C-----------------------------------------------------------------------
      INTEGER   NMOVE, INP, OUTP
      BYTE      INB(*), OUTB(*)
C
      INTEGER   LOOP
C-----------------------------------------------------------------------
      IF (NMOVE.GT.0) THEN
         DO 10 LOOP = 1,NMOVE
            OUTB(OUTP+LOOP-1) = INB(INP+LOOP-1)
 10         CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE CGINI (OPCODE, CGBUFF, DISK, CNO, VER, CATBLK, LUNCG,
     *   ICGRNO, CGKOLS, CGNUMV, TABVER, IERR)
C-----------------------------------------------------------------------
C! creates and intializes a Clean beam (CG) table.
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2010, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes Clean beam tables.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                          'WRIT' = create/init for write or read
C                          'READ' = open for read only
C      CGBUFF   I(512)   I/O buffer and related storage, also defines
C                         file if open.
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      VER      I        CG file version
C      CATBLK   I(256)   Catalog header block.
C      LUNCG    I        Logical unit number to use
C   Output:
C      ICGRNO   I        Next row number, start of the file if READ,
C                          the last+1 if WRITE
C      CGNUMV   I(4)     All 1
C      CGKOLS   I(4)     The column pointer array in order:
C                          Frequency, Bmaj, Bmin, Bpa
C   Output:
C      IERR     I        Return error code, 0=>OK, else TABINI or
C                        TABIO error.
C----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   CGBUFF(512), DISK, CNO, VER, CATBLK(256), LUNCG, ICGRNO,
     *   CGKOLS(4), CGNUMV(4), TABVER, IERR
C
      INTEGER   NKEYCG, NCOLCG
      PARAMETER (NKEYCG=1)
      PARAMETER (NCOLCG=4)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PTAB.INC'
      LOGICAL   T, DOREAD, NEWFIL
      CHARACTER TTITLE*56, TITLE(NCOLCG)*24, UNITS(NCOLCG)*8,
     *   KEYWRD(NKEYCG)*8
      INTEGER   I, JERR, ITEMP(6), NTTCG, NKEY, NREC, NCOL, IPOINT,
     *   NC, ITRIM, NDATA, DATP(128,2), KLOCS(NKEYCG), KEYTYP(NKEYCG),
     *   KEYI(NKEYCG), DTYP(NCOLCG), ICGREV
      HOLLERITH HOLTMP(6)
      EQUIVALENCE (HOLTMP, ITEMP)
      DATA TTITLE / 'CLEAN BEAM TABLE' /
      DATA TITLE /'FREQUENCY', 'BMAJ', 'BMIN', 'BPA'/
      DATA UNITS / 'HZ', 3*'DEGREES'/
      DATA KEYWRD /'TABREV' /
      DATA NTTCG / 56 /
      DATA T / .TRUE. /
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
      ICGREV = 1
C                                       Set up needed variables
      NREC = 1000
      NCOL = NCOLCG
      IF (DOREAD) NCOL = 0
      NKEY = NKEYCG
      NDATA = NCOLCG
      CALL FILL (NDATA, 0, CGKOLS)
      CALL FILL (NDATA, 0, CGNUMV)
C                                       Fill in types, lengths
C                                       See Going AIPS Vol 2 p13-3.
      IF (.NOT.DOREAD) THEN
         DTYP(1) = TABDBL + 10
         DTYP(2) = TABFLT + 10
         DTYP(3) = TABFLT + 10
         DTYP(4) = TABFLT + 10
         CALL COPY (NCOL, DTYP, DATP(1,2))
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'CG', DISK, CNO, VER, CATBLK, LUNCG, NKEY,
     *   NREC, NCOL, DATP, CGBUFF, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'CGINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
C                                       Get number of records
      ICGRNO = CGBUFF(5) + 1
      IF (DOREAD) ICGRNO = 1
      NKEY = NKEYCG
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 40 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, CGBUFF, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'CGINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, CGBUFF, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'CGINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTTCG, TTITLE, 1, CGBUFF(101))
C                                       Set keyword values
C                                       Table revision number
         KLOCS(1) = 5
         KEYTYP(1) = TABINT
         KEYI(KLOCS(1)) = ICGREV
C                                       Write to the CG table
         CALL TABKEY ('WRIT', KEYWRD, NKEYCG, CGBUFF, KLOCS, KEYI,
     *      KEYTYP, IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'CGINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         CALL TABKEY ('READ', KEYWRD, NKEYCG, CGBUFF, KLOCS, KEYI,
     *      KEYTYP, IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'CGINI', IERR)
            GO TO 990
            END IF
C                                       Table revision number
         TABVER = KEYI(KLOCS(1))
         END IF
C                                       Get array indices
C                                       Cover your ass from FNDCOL -
C                                       close to flush the buffers and
C                                       then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KEYI, CGBUFF, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'CGINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'CG', DISK, CNO, VER, CATBLK, LUNCG, NKEY,
     *   NREC, NCOL, DATP, CGBUFF, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'CGINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (4, TITLE, 24, T, CGBUFF, CGKOLS, JERR)
C                                       Get array indices and no. values
      DO 150 I = 1,4
         IPOINT = CGKOLS(I)
         IF (IPOINT.GT.0) THEN
            CGKOLS(I) = DATP(IPOINT,1)
            CGNUMV(I) = DATP(IPOINT,2) / 10
            IF (CGNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            CGKOLS(I) = -1
            CGNUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('CGINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('CGINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('CGINI: ERROR INITIALIZING WEATHER INFO TABLE FOR ', A4)
      END

      SUBROUTINE QMULCL (COMP, FLDECS, ABEAM, BBEAM, NCOMP)
C-----------------------------------------------------------------------
C! Convex Pseudo AP routine: High level Clark CLEAN routine.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Vector compiler version CONVEX (similar to CRAY)
C   Calls B. Clark's QCLNSU routine multiple times to
C   accumulate a number of CLEAN components in one AP call.
C   This version copies the residuals and the beam into work arrays
C   in order to vectorize the CLEANing.
C   Inputs:
C      COMP   I  Base address of component vector 4 words per comp.:
C                1 = component intensity.
C                2 = x location (cells)
C                3 = y location (cells)
C                4 = field number
C                NOTE: this vector is the output of this routine.
C      FLDECS I  Field descriptor vector base address.
C                0 = Number of fields (REAL value)
C                 for each field:
C                0 = Start address of residuals (INTEGER value) (AMAP)
C                   (location,intensity), intensity=2**14*x + y
C                   NOTE THE INTEGER FORMAT, THIS WORD ONLY!
C                1 = Number of points in the map. (REAL value) (LMAP)
C                2 = Current max. flux density (loc = FCOMP)
C                3 = X position of current max.
C                4 = Y position of current max.
C                5 = CLEAN gain
C      ABEAM  I  Base address of the square (folded) beam patch.
C                The Y direction is most rapid variable:-BY<Y<BY,
C                X varies less rapidly, -1<X<BX
C      BBEAM  I  Beam description vector (BX,BY).
C                In the current QCLNSU BX must equal BY.
C      NCOMP  I  Number of components to CLEAN.
C   Useage notes:
C   The following common work vectors are used:
C      IWVEC1   = KYF   => array of first residual in beam patch
C      IWVEC2   = KYL   => array of last residual in beam patch
C      IWVEC3   = IX    => X pixel location of residuals
C      IWVEC4   = IY    => Y pixel location of residuals
C      WKVEC5   = FLUX  => Residual flux density
C      WKVEC6,7 = BEAM  => BEAM patch.
C-----------------------------------------------------------------------
      INTEGER   MAXFLD
      PARAMETER (MAXFLD=16)
C
      INTEGER   COMP, FLDECS, ABEAM, BBEAM, NCOMP, NFIELD, JFDV, ILOOP,
     *   JLMAP, JCOMP, I, IFIELD, JFDVT, JLOOP, JFIELD, ADDR, ITEMP,
     *   LENT, APOFF, NP(MAXFLD), LF(MAXFLD), INDRES(MAXFLD), IBX, IBY,
     *   JA, JB, JX, JY, MAXY, ISAMAX, LOOP, IBY21, LIMIT, LIMIT1,
     *   LIMIT2, IXMXMN, MAX, INDEX, JNDEX
      REAL      AXMAX
      INCLUDE 'INCS:DAPC.INC'
      INTEGER   KYF(APSIZE/2+1), KYL(APSIZE/2+1), IX(APSIZE/2+1),
     *   IY(APSIZE/2+1)
      REAL      FLUX(APSIZE/2+1), BEAM(APSIZE/2+1)
      EQUIVALENCE (KYF, WKVEC1), (KYL, WKVEC2), (IX, WKVEC3),
     *   (IY, WKVEC4), (FLUX, WKVEC5), (BEAM, WKVEC6)
       DATA LENT /3/
C-----------------------------------------------------------------------
C                                       Get Beam Patch size
      IBX = APCORE(BBEAM+1)
      IBY = APCORE(BBEAM+2)
      IBY21 = IBY * 2 - 1
C                                       Addresses to 1-rel etc.
      JFDV = FLDECS + 1
      JCOMP = COMP + 1
      NFIELD = APCORE(JFDV) + 0.3
C                                       Loop over fields rewriting
      DO 100 IFIELD = 1,NFIELD
         JNDEX = JFDV + (IFIELD-1)*6 + 1
         APOFF = APCORI(JNDEX)
         NP(IFIELD) = 1
         IF(IFIELD.GT.1) NP(IFIELD) = NP(IFIELD-1) + LF(IFIELD-1)
         LF(IFIELD) = APCORE(JNDEX+1) + 0.3
         JLMAP = LF(IFIELD)
C                                       Get X, Y, FLUX
         JY = APOFF + LENT
         JX = APOFF + 1
         JA = NP(IFIELD) - 1
      INCLUDE 'INCS:ZVND.INC'
         DO 10 ILOOP = 1,JLMAP
            IX(JA+ILOOP) = APCORE(JX) + 0.3
            IY(JA+ILOOP) = APCORE(JX+1) + 0.3
            FLUX(JA+ILOOP) = APCORE(JY)
            JX = JX + LENT
            JY = JY + LENT
 10         CONTINUE
C                                       Get max. Y
         INDEX = NP(IFIELD) + JLMAP - 1
         MAXY = IY(INDEX)
C                                        Clear IWVEC6
         DO 20 ILOOP = 1,MAXY
            IWVEC6(ILOOP) = 0
 20         CONTINUE
C                                        Fill next IBY entries
C                                        with JLMAP+1
         LIMIT1 = MAXY
         LIMIT2 = LIMIT1 + IBY + 1
         DO 30 ILOOP = LIMIT1,LIMIT2
            IWVEC6(ILOOP) = JLMAP + 1
 30         CONTINUE
C                                        Find first occurence of Y
C                                        Use SCATTER
         JY = JLMAP
         DO 40 ILOOP = 1,JLMAP
            ADDR = IY(JY+JA)
            IWVEC6(ADDR) = JY
            JY = JY - 1
 40         CONTINUE
C                                        Fill zero entries in IWVEC6.
C                                        Contains recursion - DON'T
C                                        Vectorize!!
         JY = MAXY - 1
         DO 50 ILOOP = 2,MAXY
            IF (IWVEC6(JY).EQ.0) IWVEC6(JY) = IWVEC6(JY+1)
            JY = JY - 1
 50         CONTINUE
C                                        Set first resid in window and
C                                        set last resid in Beam patch
C                                        (Find first occurance of next)
         JA = NP(IFIELD) - 1
      INCLUDE 'INCS:ZVND.INC'
         DO 60 ILOOP = 1,JLMAP
            ITEMP = IY(JA+ILOOP) - IBY + 1
            IXMXMN = MAX (1, ITEMP)
            KYF(JA+ILOOP) = IWVEC6(IXMXMN)
            ITEMP = IY(JA+ILOOP) + IBY
            KYL(JA+ILOOP) = IWVEC6(ITEMP) - 1
            KYL(JA+ILOOP) = MIN (KYL(JA+ILOOP), JLMAP)
 60         CONTINUE
 100     CONTINUE
C                                        Form full beam, X .GE. 0
      JA = (IBX-1) * IBY21
      JB = ABEAM
      LIMIT = IBX * IBY21
      INCLUDE 'INCS:ZVND.INC'
      DO 110 ILOOP = 1,LIMIT
         BEAM(JA+ILOOP) = APCORE(JB+ILOOP)
 110     CONTINUE
C                                        X .LT. half of beam
      LIMIT1 = (IBX-1) * IBY21
      JA = ABEAM + IBX * IBY21
      INCLUDE 'INCS:ZVND.INC'
      DO 120 LOOP = 1,LIMIT1
         BEAM(LOOP) = APCORE(JA)
         JA = JA - 1
 120     CONTINUE
C                                       Find maxima in fields
      DO 300 IFIELD = 1,NFIELD
C                                        Use ISAMAX to find max. abs.
C                                        FLUX.
         JNDEX = JFDV + (IFIELD-1) * 6 + 1
         JLMAP = LF(IFIELD)
         JFDVT = JNDEX + 2
         INDEX = NP(IFIELD)
         INDRES(IFIELD) = ISAMAX (JLMAP, FLUX(INDEX), 1)
C                                        Save location
         ITEMP = INDRES(IFIELD) + INDEX - 1
         APCORE(JFDVT) = FLUX(ITEMP)
         APCORE(JFDVT+1) = IX(ITEMP)
         APCORE(JFDVT+2) = IY(ITEMP)
 300     CONTINUE
C                                       Loop
      DO 600 JLOOP = 1,NCOMP
C                                       Find field with max.
         AXMAX = -10.0
         IFIELD = 1
         JFDVT = JFDV + 3
         JFIELD = JFDVT
         DO 420 I = 1,NFIELD
            IF (ABS (APCORE(JFDVT)).LE.AXMAX) GO TO 410
C                                       New max
               AXMAX = ABS (APCORE(JFDVT))
               IFIELD = I
               JFIELD = JFDVT
 410           CONTINUE
            JFDVT = JFDVT + 6
 420        CONTINUE
C                                       Copy result to output vector
         APCORE(JCOMP) = APCORE(JFIELD)
         APCORE(JCOMP+1) = APCORE(JFIELD+1)
         APCORE(JCOMP+2) = APCORE(JFIELD+2)
         APCORE(JCOMP+3) = IFIELD
C                                       Prepare to call QCLNSU
         JNDEX = NP(IFIELD) - 1
         INDEX = INDRES(IFIELD) + JNDEX
C                                       Subtract / find max.
         CALL QCLNSU (APCORE(JFIELD), LF(IFIELD), KYF(INDEX),
     *      KYL(INDEX), IBX, IBY, JNDEX, INDRES(IFIELD))
C                                       Update JCOMP
         JCOMP = JCOMP + 4
 600     CONTINUE
C                                       Restore residuals to APCORE
C                                       Get total no. residuals.
      LIMIT = 0
      DO 700 ILOOP = 1,NFIELD
         LIMIT = LIMIT + LF(ILOOP)
 700     CONTINUE
      JA = APCORI(JFDV+1) + LENT
      INCLUDE 'INCS:ZVND.INC'
      DO 750 ILOOP = 1,LIMIT
         APCORE(JA) = FLUX(ILOOP)
         JA = JA + LENT
 750     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ZSLISN (SOCK, QLEN, IRET)
C-----------------------------------------------------------------------
C! Place a socket into "listen" mode
C# Z IO Network
C-----------------------------------------------------------------------
C;  Copyright (C) 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Set a socket into "listen" mode so that client programs may
C   connect to it (use ZSACPT to accept incoming connections after
C   setting the socket mode).
C
C   Inputs:
C
C      SOCK     I      An integer designating the socket to use, as
C                       returned by ZSCREA.
C                       Precondition: SOCK .NE. 0
C      QLEN     I      The number of pending connections to be queued
C                       for servicing.
C                       Precondition: QLEN .GE. 0
C   Outputs:
C
C      IRET     I      Return code: 0 indicates that the socket is in
C                                     listen mode
C                                   1 indicates an invalid argument
C                                     value
C                                   2 indicates that a system error
C                                     occurred
C                                  99 indicates that the network
C                                     interface is not implemented
C
C   Usage notes:
C
C   - The caller should interpret IRET and issue any error messages
C
C   Generic version: no network interface
C-----------------------------------------------------------------------
      INTEGER   SOCK, QLEN, IRET
C-----------------------------------------------------------------------
      IRET = 99
C
 999  RETURN
      END

      SUBROUTINE QWTCNT (APCORE, A, I, WT, J, C, N, NB)
C-----------------------------------------------------------------------
C! Sums positive values into an array
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Sums positive values into an array.
C   Inputs:
C      A     I  Vector of array indices as integers (1-rel)
C      I     I  A address increment.
C      WT    I  Vector of values; values < 0 replaced by 0.
C      J     I  Increment of WT
C      C     I  Summing array
C               Array must be cleared before first call.
C      N     I  Element count for A, WT
C      NB    I  Number of cells in C
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   A, I, WT, J, C, N, NB
C
      LONGINT   JA, JC, JWT, LOOP, LEND, INDEX, LTEMP
      INTEGER   ELEM
      DOUBLE PRECISION DTEMP
      EQUIVALENCE (LTEMP, DTEMP)
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                       Addresses to 1-rel
      JA = A + PSAPOF
      JC = C + PSAPOF - 1
      JWT = WT + PSAPOF
C                                        SUM
      LEND = JA + (N-1) * I
      DO 100 LOOP = JA,LEND,I
         DTEMP = APCORE(LOOP)
         ELEM = LTEMP
         INDEX = MAX (MIN (ELEM, NB), 1) + JC
         APCORE(INDEX) = APCORE(INDEX) + MAX (0.0D0, APCORE(JWT))
         JWT = JWT + J
 100     CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER   NPARMS
      PARAMETER (NPARMS=19)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
      INCLUDE 'INCS:PAOOF.INC'
C                      1        2         3          4        5
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'PIXXY',
C           6          7          8          9          10
     *   'OPCODE', 'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK',
C          11     12      13        14        15
     *   'BLC', 'TRC', 'PIX2XY', 'FACTOR', 'OFFSET',
C            16          17        18         19
     *   'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK'/
C                     1       2      3       4       5       6
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOAINT, OOACAR,
C           7       8      9       10      11      12      13
     *   OOACAR, OOACAR, OOAINT, OOAINT, OOAINT, OOAINT, OOAINT,
C          14     15      16       17      18      19
     *   OOARE,  OOARE, OOACAR, OOACAR, OOAINT, OOAINT/
C                   1    2    3    4    5    6    7     8    9
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 7,1, 4,1, 12,1, 6,1, 1,1,
C         10   11   12   13   14   15    16   17   18   19
     *   1,1, 7,1, 7,1, 7,1, 1,1, 1,1, 12,1, 6,1, 1,1, 1,1/
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(10)
      LOGICAL   LDUM(10)
      REAL      RDUM(10)
      DOUBLE PRECISION DDUM(5)
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
      COMMON /PASTEG/ DDUM
LOCAL END
      PROGRAM PASTE
C-----------------------------------------------------------------------
C! Pastes a selected subimage of one image into another.
C# Map-util Utility Object-Oriented OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998-1999, 2010, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pastes a selected subimage of one image into another.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, SUBIM*32, IMIN*32, IMOUT*32
      INTEGER  IRET, BUFF1(256)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'PASTE '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL PASTIN (PRGM, SUBIM, IMIN, IMOUT, IRET)
C                                       Paste
      IF (IRET.EQ.0) CALL PASTIT (SUBIM, IMIN, IMOUT, IRET)
C                                       History
      IF (IRET.EQ.0) CALL PASTHI (IMIN, IMOUT)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE PASTIN (PRGN, SUBIM, IMIN, IMOUT, IRET)
C-----------------------------------------------------------------------
C   PASTIN gets input parameters for PASTE and creates the relevant
C   objects.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      SUBIM   C*32 Name of subimage object.
C      IMIN    C*32 Name of input image
C      IMOUT   C*32 Output image (same underlying files as IMIN)
C      IRET    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6, SUBIM*(*), IMIN*(*), IMOUT*(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NKEY1, NKEY2
C                                       NKEY1=no. adverbs to copy to
C                                       Subimage
      PARAMETER (NKEY1=9)
C                                       NKEY2 = no. adverb for IMIN
      PARAMETER (NKEY2=10)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to subimage
C                                       object
C                    1          1           2         4
      DATA INK1 /'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK',
C          5      6       7         8        9
     *   'BLC', 'TRC', 'PIX2XY', 'FACTOR', 'OFFSET'/
C                                       Rename
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK',
C          5      6       7         8        9
     *   'BLC', 'TRC', 'PIX2XY', 'FACTOR', 'OFFSET'/
C                                       Adverbs for IMIN image object
C                    1         2         3         4        5
      DATA INK2 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'PIXXY',
C           6          7          8           9        10
     *   'OPCODE', 'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK'/
C                    1         2       3       4        5         6
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'PIXXY', 'OPCODE',
C            7          8          9         10
     *   'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create Subimage object
      SUBIM = 'Subimage to paste'
      CALL CREATE (SUBIM, 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, SUBIM, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create input image object
      IMIN = 'Input image'
      CALL CREATE (IMIN, 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, IMIN, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Clone output image object
      IMOUT = 'Output image'
      CALL OCLONE (IMIN, IMOUT, IRET)
      IF (IRET.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE PASTIT (SUBIM, IMIN, IMOUT, IERR)
C-----------------------------------------------------------------------
C   Paste subimage.
C   Inputs:
C      SUBIM   C*?   Subimage object
C      IMIN    C*?   Image into which SUBIM is to be inserted
C      IMOUT   C*?   Output image
C   Output:
C      IERR    I     Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER SUBIM*(*), IMIN*(*), IMOUT*(*)
      INTEGER   IERR
C
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   I1, I2, I3, I4, I5, I6, I7, PIXSUB(7), PIXIM(7), TYPE,
     *   DIM(7), BLC(7), TRC(7), NDIM(7), BLCIM(7), TRCIM(7), NDIMIM(7),
     *   IDIM, SUBPNT, IMPNT, IROUND, LIM1, NDIMI
      LOGICAL   DO2, DO3, DO4, DO5, DO6, DO7
      REAL      ROWSUB(MAXIMG), ROWIM(MAXIMG), FACTOR, OFFSET, REFPS(7),
     *   REFPI(7)
      CHARACTER OPCODE*4, CDUMMY*1
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Get control parameters.
      CALL ARDGET (IMIN, 'NDIM', TYPE, DIM, IDUM, CDUMMY, IERR)
      NDIMI = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (IMIN, 'OPCODE', TYPE, DIM, IDUM, OPCODE, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (IMIN, 'PIXXY', TYPE, DIM, PIXIM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (SUBIM, 'PIX2XY', TYPE, DIM, PIXSUB, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (SUBIM, 'FACTOR', TYPE, DIM, IDUM, CDUMMY, IERR)
      FACTOR = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (SUBIM, 'OFFSET', TYPE, DIM, IDUM, CDUMMY, IERR)
      OFFSET = RDUM(1)
      IF (IERR.NE.0) GO TO 999
C                                       Open objects
      CALL IMGOPN (SUBIM, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL IMGOPN (IMOUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL IMGOPN (IMIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ARRWIN (SUBIM, BLC, TRC, NDIM, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ARRWIN (IMIN, BLCIM, TRCIM, NDIMIM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Default FACTOR
      IF (ABS (FACTOR).LE.1.0E-20) FACTOR = 1.0
C                                       Update Input for history
      DIM(1) = 1
      DIM(2) = 1
      RDUM(1) = FACTOR
      CALL OPUT ('Input', 'FACTOR', OOARE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Defaults on alignment pixels
C                                       Get reference pixels
      CALL IMDGET (IMIN, 'CRPIX', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, REFPI)
      CALL IMDGET (SUBIM, 'CRPIX', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, REFPS)
      IF (NDIMI.LT.7) THEN
         IDIM = 7 - NDIMI
         CALL FILL (IDIM, 1, PIXSUB(NDIMI+1))
         CALL FILL (IDIM, 1, PIXIM(NDIMI+1))
         END IF
      DO 20 IDIM = 1,7
         IF (PIXSUB(IDIM).LE.0) PIXSUB(IDIM) = IROUND (REFPS(IDIM))
         IF (PIXIM(IDIM).LE.0) PIXIM(IDIM) = IROUND (REFPI(IDIM))
 20      CONTINUE
C                                       Update Input for history
      DIM(1) = 7
      DIM(2) = 1
      CALL OPUT ('Input', 'PIXXY', OOAINT, DIM, PIXSUB, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OPUT ('Input', 'PIX2XY', OOAINT, DIM, PIXIM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Set window in image, must read
C                                       entire planes from IMIN to
C                                       IMOUT.
      BLCIM(1) = 1
      TRCIM(1) = NDIMIM(1)
      BLCIM(2) = 1
      TRCIM(2) = NDIMIM(2)
      DO 50 IDIM = 3,7
         BLCIM(IDIM) = (PIXIM(IDIM) - PIXSUB(IDIM)) + BLC(IDIM)
         TRCIM(IDIM) = (PIXIM(IDIM) - PIXSUB(IDIM)) + TRC(IDIM)
 50      CONTINUE
C                                       Check array compatability
      IF (((PIXIM(1) - (PIXSUB(1) - BLC(1))).LT.1) .OR.
     *   ((PIXIM(1) - (PIXSUB(1) - TRC(1))).GT.NDIMIM(1)) .OR.
     *   ((PIXIM(2) - (PIXSUB(2) - BLC(2))).LT.1) .OR.
     *   ((PIXIM(2) - (PIXSUB(2) - TRC(2))).GT.NDIMIM(2))) THEN
C                                       Have to trim BLC, TRC
         MSGTXT = 'Warning: trimming BLC,TRC to fit output'
         CALL MSGWRT (5)
         IF ((PIXIM(1) - (PIXSUB(1) - BLC(1))) .LT. 1)
     *      BLC(1) = PIXSUB(1) - PIXIM(1) + 1
         IF ((PIXIM(2) - (PIXSUB(2) - BLC(2))) .LT. 1)
     *      BLC(2) = PIXSUB(2) - PIXIM(2) + 1
         IF ((PIXIM(1) - (PIXSUB(1) - TRC(1))).GT.NDIMIM(1))
     *      TRC(1) = PIXSUB(1) - PIXIM(1) + NDIMIM(1)
         IF ((PIXIM(2) - (PIXSUB(2) - TRC(2))).GT.NDIMIM(2))
     *      TRC(2) = PIXSUB(2) - PIXIM(2) + NDIMIM(2)
C                                       Reset BLC, TRC
         DIM(1) = 7
         DIM(2) = 1
         CALL OPUT (SUBIM, 'BLC', OOAINT, DIM, BLC, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OPUT (SUBIM, 'TRC', OOAINT, DIM, TRC, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
      DO 70 IDIM = 2,7
         IF ((BLCIM(IDIM).LT.1) .OR. (BLCIM(IDIM).GT.NDIMIM(IDIM)) .OR.
     *      (TRCIM(IDIM).LT.1) .OR. (TRCIM(IDIM).GT.NDIMIM(IDIM))) THEN
            IERR = 5
            WRITE (MSGTXT,1050) IDIM
            CALL MSGWRT (8)
            IF (IDIM.LE.NDIMI) GO TO 999
            END IF
 70      CONTINUE
C                                       Save BLC, TRC for history
      DIM(1) = 7
      DIM(2) = 1
      CALL OPUT ('Input', 'BLC', OOAINT, DIM, BLC, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OPUT ('Input', 'TRC', OOAINT, DIM, TRC, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       subimage copying limit
      LIM1 = TRC(1) - BLC(1) + 1
C                                       Loop over image
      DO 700 I7 = 1,NDIMIM(7)
         DO7 = ((I7.GE.BLCIM(7)) .AND. (I7.LE.TRCIM(7)))
         DO 600 I6 = 1,NDIMIM(6)
            DO6 = ((I6.GE.BLCIM(6)) .AND. (I6.LE.TRCIM(6)))
            DO 500 I5 = 1,NDIMIM(5)
               DO5 = ((I5.GE.BLCIM(5)) .AND. (I5.LE.TRCIM(5)))
               DO 400 I4 = 1,NDIMIM(4)
                  DO4 = ((I4.GE.BLCIM(4)) .AND. (I4.LE.TRCIM(4)))
                  DO 300 I3 = 1,NDIMIM(3)
                     DO3 = ((I3.GE.BLCIM(3)) .AND. (I3.LE.TRCIM(3)))
                     DO 200 I2 = 1,NDIMIM(2)
C                                       Read inputs
      CALL ARREAD (IMIN, DIM, ROWIM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Modify this row?
      DO2 = (I2.GE.(PIXIM(2) - (PIXSUB(2) - BLC(2)))) .AND.
     *   (I2.LE.(PIXIM(2) - (PIXSUB(2) - TRC(2))))
      IF (.NOT.(DO2 .AND. DO3 .AND. DO4 .AND. DO5 .AND. DO6 .AND. DO7))
     *   GO TO 290
C                                       Something to do.
      CALL ARREAD (SUBIM, DIM, ROWSUB, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Scaling of subimage
         DO 100 I1 = 1,LIM1
            IF (ROWSUB(I1).NE.FBLANK) THEN
               ROWSUB(I1) = ROWSUB(I1) * FACTOR + OFFSET
               END IF
 100        CONTINUE
C                                       Update by OPCODE
      SUBPNT = 1
      IMPNT = PIXIM(1) - (PIXSUB(1) - BLC(1))
C                                       Sum
      IF (OPCODE.EQ.'ADD ') THEN
         DO 110 I1 = 1,LIM1
            IF ((ROWSUB(SUBPNT).NE.FBLANK) .AND.
     *         (ROWIM(IMPNT).NE.FBLANK)) THEN
               ROWIM(IMPNT) = ROWIM(IMPNT) + ROWSUB(SUBPNT)
            ELSE IF (ROWSUB(SUBPNT).NE.FBLANK) THEN
               ROWIM(IMPNT) = ROWSUB(SUBPNT)
               END IF
            SUBPNT = SUBPNT + 1
            IMPNT = IMPNT + 1
 110        CONTINUE
C                                       Replace
      ELSE
         DO 120 I1 = 1,LIM1
            IF (ROWSUB(SUBPNT).NE.FBLANK) THEN
               ROWIM(IMPNT) = ROWSUB(SUBPNT)
               END IF
            SUBPNT = SUBPNT + 1
            IMPNT = IMPNT + 1
 120        CONTINUE
         END IF
 290  CALL ARRWRI (IMOUT, DIM, ROWIM, IERR)
      IF (IERR.NE.0) GO TO 999
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close Array objects
      CALL ARRCLO (SUBIM, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ARRCLO (IMIN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ARRCLO (IMOUT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Close Image objects
      CALL IMGCLO (SUBIM, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL IMGCLO (IMIN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL IMGCLO (IMOUT, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('IMAGE AND SUBIMAGE ARE INCOMPATIBLE ON AXIS ',I3)
      END
      SUBROUTINE PASTHI (IMIN, IMOUT)
C-----------------------------------------------------------------------
C   Routine to write history file to output CLEAN image object.
C   Inputs:
C      IMIN    C*32 Output image.
C      IMOUT   C*32 Output image.
C-----------------------------------------------------------------------
      CHARACTER IMIN*(*), IMOUT*(*)
C
      INTEGER   NADV
      PARAMETER (NADV=11)
      CHARACTER LIST(NADV)*8, NOTTYP*2
      INTEGER   IERR, DIM(7)
      INCLUDE 'GFORT'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK', 'BLC',
     *   'TRC',  'PIXXY', 'FACTOR', 'OFFSET', 'PIX2XY', 'OPCODE'/
C-----------------------------------------------------------------------
C                                       Copy history
      CALL OHCOPY (IMIN, IMOUT, IERR)
C                                       Add task label to history
      CALL OHTIME (IMOUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                        New additions - copy adverb
C                                        values.
      CALL OHLIST ('Input', LIST, NADV, IMOUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       copy rest tables
      DIM(1) = 2
      DIM(2) = 1
      NOTTYP = 'CC'
      CALL IMPUT (IMIN, 'DROPTABS', OOACAR, DIM, IDUM, NOTTYP, IERR)
      IF (IERR.EQ.0) CALL IMCALT (IMIN, IMOUT, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE COPYING OTHER TABLES'
         CALL MSGWRT (6)
         END IF
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // IMOUT
      CALL MSGWRT (4)
C
 999  RETURN
      END

LOCAL INCLUDE 'UJOIN.INC'
C                                       Local include for UJOIN
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2), XOPCOD(1)
      REAL      XSIN, XDISIN, XSOUT, XDISO, XCHSEL(3,10), DOWT,
     *   BUFF1(UVBFSS), BUFF2(UVBFSS)
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, JBUFSZ, ILOCWT,
     *   CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI,
     *   LRECO, NRPRMI, NRPRMO, CHNSEL(3,10)
      LOGICAL   ISCOMP
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, OPCODE*4
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XCLAOU,
     *   XSOUT, XDISO, XCHSEL, XOPCOD, DOWT,
     *   SEQIN, SEQOUT, DISKIN, DISKO, ILOCWT, CATOLD, INCSI,
     *   INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI, LRECO, NRPRMI,
     *   NRPRMO, ISCOMP, CHNSEL
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, OPCODE
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
C                                       End local include for UJOIN
LOCAL END
      PROGRAM UJOIN
C-----------------------------------------------------------------------
C! Joins 2 IFs into one spectrum
C# Utility UV UV-util VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1996, 1999-2000, 2004, 2007-2013, 2017, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UJOIN joines 2 IFs into 1 spectrum
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      CHANSEL        CHNSEL        1st, last input, 1st output channel
C                                   for each IF
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'UJOIN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'UJOIN '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file
      CALL UJOINI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL UJOINU (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL UJOINH
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE UJOINI (PRGN, IRET)
C-----------------------------------------------------------------------
C   UJOINI gets input parameters for UJOIN and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      CHARACTER  STAT*4, BLANK*6, PTYPE*2
      INTEGER   OLDCNO, IROUND, NPARM, IERR, INCX
      LOGICAL   T
      INCLUDE 'UJOIN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK  /'      '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
C                                       Get input parameters.
      NPARM = 46
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Find weight and scale.
      IF (ISCOMP) THEN
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            IRET = 9
            GO TO 990
            END IF
         END IF
C                                       Get uv header info.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Plan overlap, modify header
      CALL FIXHDR (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      IRET = 4
      CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                       Save output file info
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UJOINI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE FIXHDR (IERR)
C-----------------------------------------------------------------------
C   Gets frequencies, plans overlap, alters CATBLK for output
C   Output:
C      IERR   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   NCH, NIF, NOUT, I, IROUND, NP, IP, J, L, JIF
      CHARACTER STRING*12
      INCLUDE 'INCS:PUVD.INC'
      REAL      FINC(MAXIF), REFP, ERROR1, ERROR2
      INTEGER   ISBAND(MAXIF), VER, FRQSEL, LUN1
      CHARACTER BNDCOD(MAXIF)*8
      DOUBLE PRECISION FOFF(MAXIF), UVFREQ, FIN, FOUT
      INCLUDE 'UJOIN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA LUN1 /27/
C-----------------------------------------------------------------------
      IERR = 4
      IF (JLOCIF.LT.0) THEN
         MSGTXT = 'NO IF AXIS - I CANNOT DO MY THING'
         GO TO 980
         END IF
      IF (JLOCF.LT.0) THEN
         MSGTXT = 'NO FREQ AXIS - I CANNOT DO MY THING'
         GO TO 980
         END IF
      NCH = CATBLK(KINAX+JLOCF)
      REFP = CATR(KRCRP+JLOCF)
      UVFREQ = CATD(KDCRV+JLOCF)
      NIF = CATBLK(KINAX+JLOCIF)
      IF (NIF.LT.2) THEN
         MSGTXT = 'ONLY 1 IF - I CANNOT DO MY THING'
         GO TO 980
         END IF
      IF (NCH.LE.2) THEN
         MSGTXT = 'FEW SPECTRAL CHANNELS - WHY DO MY THING'
         GO TO 980
         END IF
      NOUT = 0
      NCH = NCH
      DO 10 I = 1,NIF
         CHNSEL(1,I) = IROUND (XCHSEL(1,I))
         IF (CHNSEL(1,I).LT.1) CHNSEL(1,I) = 1
         CHNSEL(2,I) = IROUND (XCHSEL(2,I))
         IF (CHNSEL(2,I).LT.CHNSEL(1,I)) CHNSEL(2,I) = NCH
         CHNSEL(3,I) = IROUND (XCHSEL(3,I))
         IF (CHNSEL(3,I).LT.1) CHNSEL(3,I) = 1
         IF ((CHNSEL(1,I).GT.NCH) .OR. (CHNSEL(2,I).GT.NCH)) THEN
            MSGTXT = 'INCORRECT CHANNEL SPECIFICATIONS'
            GO TO 980
            END IF
         NOUT = MAX (NOUT, CHNSEL(3,I)+CHNSEL(2,I)-CHNSEL(1,I))
 10      CONTINUE
      CATBLK(KINAX+JLOCF) = NOUT
      CATBLK(KINAX+JLOCIF) = 1
      CATR(KRCRP+JLOCF) = CATR(KRCRP+JLOCF) + CHNSEL(3,1) - CHNSEL(1,1)
      CATR(KRARP) = CATR(KRARP) + CHNSEL(3,1) - CHNSEL(1,1)
      IERR = 0
C                                       tell user channel selection
      DO 50 I = 1,NOUT
         WRITE (MSGTXT,1010) I
         NP = 34
         DO 40 JIF = 1,NIF
            J = I - CHNSEL(3,JIF) + CHNSEL(1,JIF)
C                                       this IF involved
            IF ((J.GE.CHNSEL(1,JIF)) .AND. (J.LE.CHNSEL(2,JIF))) THEN
               WRITE (STRING,1015) JIF, J
               IP = 0
C                                       squeeze all blanks
               DO 30 L = 1,9
                  IF (STRING(L:L).NE.' ') THEN
                     IP = IP + 1
                     STRING(IP:IP) = STRING(L:L)
                     END IF
 30               CONTINUE
               IF (NP+IP-1.LE.80) MSGTXT(NP:) = STRING(:IP)
               NP = NP + IP + 1
               END IF
 40         CONTINUE
         CALL MSGWRT (2)
 50      CONTINUE
C                                       get FQ info
      VER = 1
      FRQSEL = 1
      CALL CHNDAT ('READ', BUFF1, DISKIN, FCNO(1), VER, CATOLD, LUN1,
     *   NIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Test frequencies
      DO 60 JIF = 1,NIF
         FOUT = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) * (CHNSEL(3,JIF) -
     *      CATR(KRCRP+JLOCF))
         FIN = UVFREQ + FOFF(JIF) + FINC(JIF) * (CHNSEL(1,JIF) - REFP)
         ERROR1 = (FOUT - FIN) / CATR(KRCIC+JLOCF)
         FOUT = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) * (CHNSEL(3,JIF) -
     *      CATR(KRCRP+JLOCF) + CHNSEL(2,JIF) - CHNSEL(1,JIF))
         FIN = UVFREQ + FOFF(JIF) + FINC(JIF) * (CHNSEL(2,JIF) - REFP)
         ERROR2 = (FOUT - FIN) / CATR(KRCIC+JLOCF)
         IF ((ABS(ERROR1).GT.0.1) .OR. (ABS(ERROR2).GT.0.1)) THEN
            WRITE (MSGTXT,1050) JIF, ERROR1, ERROR2
            CALL MSGWRT (6)
            END IF
 60      CONTINUE
      GO TO 999
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('Output channel',I5,' input IF(ch)')
 1015 FORMAT (I2,'(',I5,')')
 1050 FORMAT ('WARNING: IF',I3,' END FREQS DIFFER BY',2F9.2,' CHANNELS')
      END
      SUBROUTINE UJOINU (IRET)
C-----------------------------------------------------------------------
C   UJOINU sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48, IFILE*48
      INTEGER   INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, ILENBU,
     *   KBIND, NIOUT, NIOLIM, IBIND, I, INCX, BO, VO,
     *   NUMVIS, XCOUNT, NCORI, NCORO, NCOPY
      LOGICAL   T, F
      INCLUDE 'UJOIN.INC'
      REAL      CBUFF(UVBFSS), RESULT(UVBFSS)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI, LUNO /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
      IF (ISCOMP) INCX = 3
C                                       Number of visibilities in input
C                                       and output files.
      NCORI = (LRECI - NRPRMI) / CATOLD(KINAX)
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(1), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Out of data?
         IF (INIO.LE.0) GO TO 200
C                                       Loop over buffer
         DO 190 I = 1,INIO
            NUMVIS = NUMVIS + 1
C                                      Call user routine.
C                                      Compressed data.
            IF (ISCOMP) THEN
               CALL ZUVXPN (NCORI, BUFF1(IPTRI+NRPRMI),
     *            BUFF1(IPTRI+ILOCWT), CBUFF)
               CALL JOINUV (NUMVIS, CBUFF, INCX, RESULT, IRET)
C                                       Un compressed data
            ELSE
               CALL JOINUV (NUMVIS, BUFF1(IPTRI+NRPRMI), INCX, RESULT,
     *            IRET)
               END IF
C                                       Branch on his return
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
C                                       Copy to output.
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1.0D0
               CALL RCOPY (NRPRMO, BUFF1(IPTRI), BUFF2(IPTRO))
C                                       Compressed
               IF (ISCOMP) THEN
                  CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *               BUFF2(IPTRO+NRPRMO))
               ELSE
                  CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
                  END IF
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               END IF
C                                       OK, but no output please
            IPTRI = IPTRI + LRECI
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
C                                       Read next buffer.
         GO TO 100
C                                       Final call to JOINUV.
 200  NUMVIS = -1
      CALL JOINUV (NUMVIS, BUFF1, INCX, RESULT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UJOINU: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1010 FORMAT ('UJOINU: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('UJOINU: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('UJOINU: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('UJOINU: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('UJOINU: JOINUV ERROR',I3)
 1150 FORMAT ('UJOINU: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE UJOINH
C-----------------------------------------------------------------------
C   UJOINH copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP(21)*2, HILINE*72
      INTEGER   LUN1, LUN2, IERR, I, NONOT, NIF, J
      LOGICAL   T
      INCLUDE 'INCS:PUVD.INC'
      REAL      FINC(MAXIF)
      INTEGER   ISBAND(MAXIF), VER, FRQSEL, FREQID
      CHARACTER BNDCOD(MAXIF)*8
      DOUBLE PRECISION FOFF(MAXIF)
      INCLUDE 'UJOIN.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NONOT, NOTTYP /20, 'FQ','CH','CL','SN','SU','FG','BP',
     *   'IM', 'CQ', 'PC', 'TY', 'GC', 'MC', 'WX', 'BL', 'AN', 'CP',
     *   'PD', 'CD', 'SY', 'PP'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(1), FCNO(2), CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any other history.
      NIF = CATOLD(KINAX+JLOCIF)
      WRITE (HILINE,1010) TSKNAM, NIF
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      DO 20 I = 1,NIF
         WRITE (HILINE,1011) TSKNAM, I, (CHNSEL(J,I), J = 1,3)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
 20      CONTINUE
      IF (OPCODE.EQ.'DIFF') THEN
         HILINE = TSKNAM // '/ IFs weighted by (-1)**(IFnumber-1)'
      ELSE
         HILINE = TSKNAM // '/ IFs weighted by data weights'
         END IF
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       flagging
      IF (ABS(DOWT).LT.0.5) THEN
         HILINE = TSKNAM // '/ Spectrum flagged if any input flagged'
      ELSE IF (DOWT.GT.0.0) THEN
         HILINE = TSKNAM // '/ Channel flagged if any input channel ' //
     *      'flagged'
      ELSE
         HILINE = TSKNAM // '/ Data flagged only if all inputs flagged'
         END IF
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables except FQ
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO, FCNO(1),
     *   FCNO(2), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1200)
         CALL MSGWRT (6)
         END IF
C                                       copy FQ info
      VER = 1
      FRQSEL = 1
      CALL CHNDAT ('READ', BUFF1, DISKIN, FCNO(1), VER, CATOLD, LUN1,
     *   NIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Fixup
      NIF = 1
C                                       Rewrite new
      VER = 1
      FREQID = 1
      CALL CHNDAT ('WRIT', BUFF1, DISKO, FCNO(2), VER, CATBLK, LUN1,
     *   NIF, FOFF, ISBAND, FINC, BNDCOD, FREQID, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       copy tables with IFs
      CALL COPTAB (IERR)
C                                       Update CATBLK.
 990  CALL CATIO ('UPDT', DISKO, FCNO(2), CATBLK, 'REST', BUFF1,
     *   IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UJOINH: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,'NIF =',I5,19X,'/ Input IFs -> 1')
 1011 FORMAT (A6,'CHANSEL(',I2.2,')=',3I5,'  / IF ',I2.2,
     *   '1st last input, 1st output chan')
 1200 FORMAT ('UJOINH: ERROR COPYING TABLES')
      END
      SUBROUTINE JOINUV (NUMVIS, VIS, INCX, RESULT, IRET)
C-----------------------------------------------------------------------
C   Actually joins up the IFs to make one spectrum
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      VIS     R(INCX,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                   NOTE: INCX may be any value .GE. 2
C   Inputs from COMMON:
C      RA         D       Right ascension (1950) of phase center. (deg)
C      DEC        D       Declination (1950) of phase center. (deg)
C      FREQ       D       Frequency of observation (Hz)
C      NRPARM     I       # random parameters.
C      NCOR       I       # correlators
C      CATBLK     I(256)  Catalog header record. See Going Aips for
C                         details.
C      LRECI      I    Input file record length
C      NRPRMI     I    Input number of random parameters.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
C      LRECO      I    Output file record length
C      NRPRMO     I    Output number of random parameters.
C      INCSO      I    Output Stokes' increment in vis.
C      INCFO      I    Output frequency increment in vis.
C      INCIFO     I    Output IF increment in vis.
C   Output:
C      RESULT  R(INCX,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C
C   Output in COMMON:
C      NUMHIS    I         # history entries (max. 10)
C      HISCRD    C(NUMHIS) History records
C      CATBLK    I         Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, INCX, IRET
      REAL      VIS(INCX,*), RESULT(INCX,*)
C
      INTEGER   JIF, JF, KF, JS, NIF, NS, INDEXO, INDEXI, WTS, JF1, JF2,
     *   WASF(4)
      REAL      WT
      INCLUDE 'UJOIN.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.GT.0) THEN
         NS = CATOLD(KINAX+JLOCS)
         NIF = CATOLD(KINAX+JLOCIF)
         CALL FILL (4, 0, WASF)
         KF = INCX * CATBLK(KINAX+JLOCF) * NS
         CALL RFILL (KF, 0.0, RESULT)
         DO 40 JIF = 1,NIF
            WTS = (-1) ** (JIF - 1)
            JF1 = CHNSEL(1,JIF)
            JF2 = CHNSEL(2,JIF)
            DO 30 JS = 1,NS
               DO 20 JF = JF1,JF2
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  KF = CHNSEL(3,JIF) + JF - JF1
                  INDEXO = (KF-1) * INCFO + (JS-1) * INCSO + 1
                  WT = VIS(3,INDEXI)
                  IF (WT.GT.0.0) THEN
                     IF (OPCODE.EQ.'DIFF') WT = WTS
                     RESULT(1,INDEXO) = RESULT(1,INDEXO) + WT *
     *                  VIS(1,INDEXI)
                     RESULT(2,INDEXO) = RESULT(2,INDEXO) + WT *
     *                  VIS(2,INDEXI)
                     RESULT(3,INDEXO) = RESULT(3,INDEXO) + VIS(3,INDEXI)
                  ELSE IF (DOWT.GT.-0.5) THEN
                     RESULT(3,INDEXO) = -1.0E10
                     WASF(JS) = WASF(JS) + 1
                     END IF
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
         IF ((OPCODE.NE.'DIFF') .AND. (ABS(DOWT).GE.0.5)) THEN
            KF = CATBLK(KINAX+JLOCF) * NS
            DO 50 JF = 1,KF
               WT = RESULT(3,JF)
               IF (WT.GT.0.0) THEN
                  RESULT(1,JF) = RESULT(1,JF) / WT
                  RESULT(2,JF) = RESULT(2,JF) / WT
                  END IF
 50            CONTINUE
         ELSE IF (ABS(DOWT).LT.0.5) THEN
            KF = CATBLK(KINAX+JLOCF)
            DO 80 JS = 1,NS
               IF (WASF(JS).GT.0) THEN
                  DO 60 JF = 1,KF
                     INDEXO = (JF-1) * INCFO + (JS-1) * INCSO + 1
                     RESULT(3,INDEXO) = -ABS (RESULT(3,INDEXO))
 60                  CONTINUE
               ELSE IF (OPCODE.NE.'DIFF') THEN
                  DO 70 JF = 1,KF
                     INDEXO = (JF-1) * INCFO + (JS-1) * INCSO + 1
                     WT = RESULT(3,INDEXO)
                     IF (WT.GT.0.0) THEN
                        RESULT(1,INDEXO) = RESULT(1,INDEXO) / WT
                        RESULT(2,INDEXO) = RESULT(2,INDEXO) / WT
                        END IF
 70                  CONTINUE
                  END IF
 80            CONTINUE
            END IF
C                                       last call - no vis
      ELSE
         END IF
C
 999  RETURN
      END
      SUBROUTINE COPTAB (IRET)
C-----------------------------------------------------------------------
C   Updates tables for selection by IF
C   Output:
C      IRET  I  Return code, 0=>OK
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   IERR, LUN1, LUN2, VER, NVER, OFQID, ISUB, JSUB, AN(50),
     *   NA, BIF, EIF, SOUWAN, NSOUWD, BCHAN, ECHAN, DOPOL, BPOL, EPOL
      LOGICAL   TABLE, EXIST, FITASC
      DOUBLE PRECISION TIME1, TIME2, FQOFF
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'UJOIN.INC'
      DATA LUN1, LUN2 /28,29/
C-----------------------------------------------------------------------
      MSGTXT = 'Updating tables for IF selection'
      CALL MSGWRT (4)
      ISUB = 0
      JSUB = -1
      BIF = 1
      EIF = 1
      NA = 0
      CALL FILL (50, 0, AN)
      TIME1 = -1.D9
      TIME2 = 1.D9
      SOUWAN = 0
      NSOUWD = 0
      BCHAN = 1
      ECHAN = MAXCHA
      FQOFF = 0.0D0
      DOPOL = 0
C                                       no STOKES selection so okay
      BPOL = 1
      EPOL = 2
C                                       Reference frequency in AN table
C                                       IF selection
      CALL FNDEXT ('AN', CATOLD, NVER)
      DO 100 VER = 1,NVER
         CALL ISTAB ('AN', DISKIN, FCNO(1), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF ((EXIST) .AND. (IERR.EQ.0)) CALL ANSEL (DISKIN, FCNO(1),
     *      DISKO, FCNO(2), VER, VER, CATOLD, CATBLK, LUN1, LUN2, BIF,
     *      EIF, FQOFF, DOPOL, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 100     CONTINUE
C                                       Revise tables: note depends on
C                                       doing loops 0 times if none
      OFQID = 0
C                                       BP tables
      CALL FNDEXT ('BP', CATOLD, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'BANDPASS TABLES ARE DISCARDED'
         CALL MSGWRT (7)
         END IF
C                                       CL tables
      CALL FNDEXT ('CL', CATOLD, NVER)
      DO 140 VER = 1,NVER
         CALL ISTAB ('CL', DISKIN, FCNO(1), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
C                                       do NOT select on sources
         IF (EXIST .AND. (IERR.EQ.0)) CALL CLSEL (DISKIN, FCNO(1),
     *      DISKO, FCNO(2), VER, CATOLD, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BIF, EIF, OFQID, TIME1, TIME2, 0, SOUWAN, AN, NA, ISUB,
     *      JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 140     CONTINUE
C                                       CD tables
      CALL FNDEXT ('CD', CATOLD, NVER)
      DO 145 VER = 1,NVER
         CALL ISTAB ('CD', DISKIN, FCNO(1), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
C                                       do not select on antenna
         IF (EXIST .AND. (IERR.EQ.0)) CALL CDSEL (DISKIN, FCNO(1),
     *      DISKO, FCNO(2), VER, CATOLD, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BIF, EIF, OFQID, AN, 0, ISUB, JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 145     CONTINUE
C                                       CP tables
      CALL FNDEXT ('CP', CATOLD, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'CAL SOURCE POLARIZATION TABLES ARE DISCARDED'
         CALL MSGWRT (7)
         END IF
C                                       CQ tables
      CALL FNDEXT ('CQ', CATOLD, NVER)
      DO 160 VER = 1, NVER
         CALL ISTAB ('CQ', DISKIN, FCNO(1), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST.AND.(IERR.EQ.0)) CALL CQSEL (DISKIN, FCNO(1), DISKO,
     *      FCNO(2), VER, CATOLD, CATBLK, LUN1, LUN2, BIF, EIF, OFQID,
     *      ISUB, JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 160     CONTINUE
C                                       FG tables
      CALL FNDEXT ('FG', CATOLD, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'WARNING: FG TABLES MAY CONTAIN BAD IF/CHANNEL' //
     *      ' REFERENCES'
         CALL MSGWRT (6)
         END IF
      DO 180 VER = 1,NVER
         CALL ISTAB ('FG', DISKIN, FCNO(1), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL FGSEL (DISKIN, FCNO(1),
     *      DISKO, FCNO(2), VER, CATOLD, CATBLK, LUN1, LUN2, BIF, EIF,
     *      BCHAN, ECHAN,  TIME1, TIME2, OFQID, ISUB, JSUB, BUFF1,
     *      BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 180     CONTINUE
C                                       GC tables
      CALL FNDEXT ('GC', CATOLD, NVER)
      DO 200 VER = 1,NVER
         CALL ISTAB ('GC', DISKIN, FCNO(1), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL GCSEL (DISKIN, FCNO(1),
     *      DISKO, FCNO(2), VER, CATOLD, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BCHAN, ECHAN, BIF, EIF, OFQID, AN, NA, ISUB, JSUB, BUFF1,
     *      BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 200     CONTINUE
C                                       IM tables
      CALL FNDEXT ('IM', CATOLD, NVER)
      DO 220 VER = 1,NVER
         CALL ISTAB ('IM', DISKIN, FCNO(1), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL IMSEL (DISKIN, FCNO(1),
     *      DISKO, FCNO(2), VER, CATOLD, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BIF, EIF, OFQID, TIME1, TIME2, NSOUWD, SOUWAN, AN, NA, ISUB,
     *      JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 220     CONTINUE
C                                       MC tables
      CALL FNDEXT ('MC', CATOLD, NVER)
      DO 240 VER = 1,NVER
         CALL ISTAB ('MC', DISKIN, FCNO(1), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL MCSEL (DISKIN, FCNO(1),
     *      DISKO, FCNO(2), VER, CATOLD, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BIF, EIF, OFQID, TIME1, TIME2, NSOUWD, SOUWAN, AN, NA, ISUB,
     *      JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 240     CONTINUE
C                                       PC tables
      CALL FNDEXT ('PC', CATOLD, NVER)
      DO 260 VER = 1,NVER
         CALL ISTAB ('PC', DISKIN, FCNO(1), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL PCSEL (DISKIN, FCNO(1),
     *      DISKO, FCNO(2), VER, CATOLD, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BIF, EIF, OFQID, TIME1, TIME2, NSOUWD, SOUWAN, AN, NA, ISUB,
     *      JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 260     CONTINUE
C                                       PD tables
      CALL FNDEXT ('PD', CATOLD, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'ANTENNA SPECTRAL POLARIZATION TABLES ARE DISCARDED'
         CALL MSGWRT (7)
         END IF
C                                       PP tables
      CALL FNDEXT ('PP', CATOLD, NVER)
      IF (NVER.GT.0) THEN
         MSGTXT = 'RIGHT MINUS LEFT PHASE TABLES ARE DISCARDED'
         CALL MSGWRT (7)
         END IF
C                                       SN tables
      CALL FNDEXT ('SN', CATOLD, NVER)
      DO 280 VER = 1,NVER
         CALL ISTAB ('SN', DISKIN, FCNO(1), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL SNSEL (DISKIN, FCNO(1),
     *      DISKO, FCNO(2), VER, CATOLD, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BIF, EIF, OFQID, TIME1, TIME2, ISUB, JSUB, BUFF1, BUFF2,
     *      IRET)
         IF (IRET.GT.0) GO TO 999
 280     CONTINUE
C                                       SY tables
      CALL FNDEXT ('SY', CATOLD, NVER)
      DO 290 VER = 1,NVER
         CALL ISTAB ('SY', DISKIN, FCNO(1), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL SYSEL (DISKIN, FCNO(1),
     *      DISKO, FCNO(2), VER, CATOLD, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BIF, EIF, OFQID, TIME1, TIME2, NSOUWD, SOUWAN, AN, NA, ISUB,
     *      JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 290     CONTINUE
C                                       SU tables
      IF (ILOCSU.GE.0) THEN
         CALL FNDEXT ('SU', CATOLD, NVER)
         DO 300 VER = 1,NVER
            CALL ISTAB ('SU', DISKIN, FCNO(1), VER, LUN1, BUFF1, TABLE,
     *         EXIST, FITASC, IERR)
            IF (EXIST .AND. (IERR.EQ.0)) CALL SUSEL (DISKIN, FCNO(1),
     *         DISKO, FCNO(2), VER, CATOLD, CATBLK, LUN1, LUN2, BIF,
     *         EIF, OFQID, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 300        CONTINUE
         END IF
C                                       TY tables
      CALL FNDEXT ('TY', CATOLD, NVER)
      DO 320 VER = 1,NVER
         CALL ISTAB ('TY', DISKIN, FCNO(1), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL TYSEL (DISKIN, FCNO(1),
     *      DISKO, FCNO(2), VER, CATOLD, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BIF, EIF, OFQID, TIME1, TIME2, AN, NA, ISUB, JSUB, BUFF1,
     *      BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 320     CONTINUE
C                                       WX tables
      CALL FNDEXT ('WX', CATOLD, NVER)
      DO 340 VER = 1,NVER
         CALL ISTAB ('WX', DISKIN, FCNO(2), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL WXSEL (DISKIN, FCNO(2),
     *      DISKO, FCNO(1), VER, CATOLD, CATBLK, LUN1, LUN2, TIME1,
     *      TIME2, AN, NA, ISUB, JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 340     CONTINUE
C                                       BL tables
      CALL FNDEXT ('BL', CATOLD, NVER)
      DO 350 VER = 1,NVER
         CALL ISTAB ('BL', DISKIN, FCNO(2), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL BLSEL (DISKIN, FCNO(2),
     *      DISKO, FCNO(1), VER, CATOLD, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      AN, NA, ISUB, JSUB, BIF, EIF, OFQID, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 350     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE APFNSH (APCORE, USTRT, USTOP, UZERO, FRSTU, MO2,
     *   ROWSIZ, LROW, LOGRID, APSIZE, THETA)
C-----------------------------------------------------------------------
C! AP routine: Phase rotates rows of GRIDDED UV data in the AP
C# AP-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C AP FiNiSH: Finishes UV data Gridding Process, phase rotates image
C to center of GRID after FFT
C   Inputs:
C      USTRT   I    Start U row to process
C      USTOP   I    Stop  U row to process
C      UZERO   I    Row number of minimum row in AP to be processed
C                   (Often Location of row U=0 in AP)
C      FRSTU   I    U cell containing max U baseline
C      MO2     I    Interpolation half width (Must be Odd)
C      ROWSIZ  I    Length of a Row in AP, number of REALs
C      LROW    I    Number of Cells in a Row (real and imaginary pairs)
C      LOGRID  I    Index of start of rows in AP (0 relative)
C      APSIZE  I    Size of AP in REALs
C      THETA   DP   Angle to rotate U=1 cell to center
C   Outputs:
C      AP memory modified
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   USTRT, USTOP, UZERO, FRSTU, MO2, ROWSIZ, LROW, LOGRID,
     *   APSIZE
      DOUBLE PRECISION THETA
C
      DOUBLE PRECISION DTHETA
      REAL      TRIG(2)
      INTEGER   IU, U, EROW
C-----------------------------------------------------------------------
C                                       wait for ap to finish
      CALL QWAIT
C                                       for rows to write from AP
      DO 100 IU = USTRT,USTOP
C                                       convert to decreasing U
         U = USTOP - IU + USTRT
C                                       if below Max U
         IF ((U.LT.(FRSTU+MO2)) .AND. (U.GE.UZERO)) THEN
C                                       Do final operations on grid
            EROW = LOGRID + ((U-UZERO)*ROWSIZ)
C                                       rows above top of AP are zero
            IF (EROW+ROWSIZ.GE.APSIZE) EROW = APSIZE-ROWSIZ-1
C                                       calc phase to rotate U=0 to edge
            DTHETA =  U * THETA
C                                       get trig functions of angle
            TRIG(1) = DCOS (DTHETA)
            TRIG(2) = DSIN (DTHETA)
C                                       put phase in ap
            CALL QPUT (APCORE, TRIG, 0, 2, 2)
            CALL QWAIT
C                                       phase rotate and flip UV grid
            CALL Q1FIN (APCORE, U, EROW, MO2, LROW)
            CALL QWAIT
C                                       end if below top of grid used
            END IF
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ZRMTAP (MACHIN, NT, TAPES, IERR)
C-----------------------------------------------------------------------
C! read tape list of remote machine
C# Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1999-2000, 2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Open a link to TPMON1 on a remote machine, ask it for the list of
C   tapes supported on that machine, and close the link.
C   Inputs:
C      MACHIN   C*(*)      tape disk physical file name
C   Output:
C      NT       I          Number of non-blank strings
C      TAPES    C(36)*80   List of tape strings
C      IERR     I          Error return code: 0 => no error
C                            1 => LUN already in use
C                            2 => file not found
C                            3 => volume not found
C                            4 => exclusive use denied
C                            5 => no room for LUN in FTAB
C                            6 => other open errors
C   Generic version.
C-----------------------------------------------------------------------
      INTEGER   NT, IERR
      CHARACTER MACHIN*(*), TAPES(36)*80
C
      INTEGER   JERR, I, J, JTRIM, LUN, FIND, IBUF(725), IP, NBACK
      HOLLERITH HBUF(725), HLATED(64)
      LOGICAL   T
      CHARACTER XLATED*256, LNAME*48
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      EQUIVALENCE (IBUF, HBUF)
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Check inputs.
      NT = 0
      IERR = 6
      LUN = 30
C                                       Allocate area in FTAB for LUN.
      CALL LSERCH ('OPEN', LUN, FIND, T, JERR)
      IF (JERR.NE.0) THEN
C                                       LUN already in use.
         IF (JERR.EQ.2) THEN
            IERR = 1
            WRITE (MSGTXT,1001) LUN
C                                       No room in FTAB for LUN.
         ELSE IF (JERR.EQ.3) THEN
            IERR = 5
            WRITE (MSGTXT,1002) LUN
         ELSE
            WRITE (MSGTXT,1000) JERR, 'OPEN', LUN
            END IF
         GO TO 990
         END IF
C                                       Finally, open the tape drive.
      IERR = 0
      LNAME = MACHIN
      CALL CHUTOL (48, LNAME)
      XLATED = 'aipsmt0:' // LNAME
      LNAME = 'NET0:TPDEVS.LIST'
      I = JTRIM (XLATED)
      CALL CHR2H (256, XLATED, 1, HLATED)
      CALL ZVTPO2 (FTAB(FIND+MOFF), I, HLATED, IERR)
      IF (IERR.NE.0) THEN
          WRITE (MSGTXT,1005) IERR
          GO TO 990
          END IF
C                                       Open tape device
C                                       pack buffer: header
      NBACK = 720
      CALL ZCLC8 (8, 'ZTPOPN  ', 1, HBUF)
      CALL ZILI32 (1, 15, 3, IBUF)
      CALL ZILI32 (1, NBACK, 4, IBUF)
      CALL ZILI32 (1, 0, 5, IBUF)
C                                       pack buffer: data
      CALL ZILI32 (1, LUN, 6, IBUF)
      CALL ZILI32 (1, 1, 7, IBUF)
      CALL ZCLC8 (4, 'READ', 29, HBUF)
      CALL ZCLC8 (48, LNAME, 33, HBUF)
      CALL ZVTPX2 (FTAB(FIND+MOFF), 15, NBACK, IBUF, IERR)
C                                       interpret return
      IF (IERR.EQ.4) THEN
         WRITE (MSGTXT,1010)
         CALL MSGWRT (7)
      ELSE IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1011) IERR
         CALL MSGWRT (7)
      ELSE
         CALL ZI32IL (1, 5, IBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1012) IERR
            CALL MSGWRT (7)
         ELSE IF (NBACK.NE.720) THEN
            WRITE (MSGTXT,1015) NBACK, 720
            CALL MSGWRT (6)
C                                       OKAY! return answers
         ELSE
            NT = 0
            IP = 21
            DO 20 I = 1,36
               CALL ZC8CL (80, IP, HBUF, TAPES(NT+1))
               IP = IP + 80
               J = JTRIM (TAPES(NT+1))
               IF (J.GT.0) NT = NT + 1
 20            CONTINUE
            END IF
         END IF
C                                       Close
      CALL ZVTPC2 (FTAB(FIND+MOFF), I)
      IF (I.EQ.0) GO TO 995
      WRITE (MSGTXT,1020) I
C
 990  CALL MSGWRT (6)
C
 995  CALL LSERCH ('CLOS', LUN, FIND, T, JERR)
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZRMTAP: LSERCH ERROR ',I1,' FOR ',A4,' ON LUN = ',I2)
 1001 FORMAT ('ZRMTAP: LUN = ',I2,' ALREADY OPEN IN FTAB')
 1002 FORMAT ('ZRMTAP: NO ROOM IN FTAB FOR LUN = ',I2)
 1005 FORMAT ('ZRMTAP: ZVTPO2 RETURNS ERROR CODE',I7)
 1010 FORMAT ('ZRMTAP: AIPS TPHOSTS PERMISSION DENIED ON REMOTE HOST')
 1011 FORMAT ('ZRMTAP: ZVTPX2 RETURNS ERROR CODE',I7)
 1012 FORMAT ('ZRMTAP: REMOTE TAPE SYSTEM RETURNS ERROR CODE',I7)
 1015 FORMAT ('ZRMTAP: WARNING - GOT BACK',I3,' WORDS, EXPECTED',I3)
 1020 FORMAT ('ZRMTAP: ERROR',I5,' CLOSING THE SOCKET')
      END

      PROGRAM SETPAR
C-----------------------------------------------------------------------
C! stand-alone program to set system parameters in SP file
C# Service
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2000-2006, 2008, 2011, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This program initializes or changes the system parameters kept in
C   the System Parameter (SP) file.  It is read by ZDCHIN to initialize
C   the values in common CDCH.
C-----------------------------------------------------------------------
      CHARACTER INAME*48, MSGBUF*80, PRGNAM*6
      REAL      ROBLK(256)
      INTEGER   IOBLK(256), ILUN, TTYIND, TTYLUN, I, I0, I1, I2, I3,
     *   I4, IERR, JERR, IND, IOPT, ISTDEV, J1, J2, J3, J4, IDUM(2),
     *   SCRTCH(256), INIPRM(256)
      LOGICAL   PASPER, PASCHG, NOMAP, EXCL, WAIT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (EXCL, WAIT),   (IOBLK, ROBLK)
      COMMON /TTYCOM/ TTYLUN, TTYIND
      DATA ISTDEV /14/
      DATA PRGNAM /'SETPAR'/
      DATA ILUN /27/
      DATA NOMAP, EXCL /.FALSE.,.TRUE./
C-----------------------------------------------------------------------
      TTYLUN = 5
C                                       Password not entered
      PASPER = .FALSE.
C                                       Parameters not modified
      PASCHG = .FALSE.
C                                       Setup
      CALL AIPINI (TTYLUN, PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Open parameter file
      CALL ZPHFIL ('SP', 1, 0, 0, INAME, IERR)
      CALL ZOPEN (ILUN, IND, 1, INAME, NOMAP, EXCL, WAIT, JERR)
      IF (IERR.NE.0 .OR. JERR.NE.0) THEN
         WRITE (MSGTXT, 1050) IERR, JERR
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       Read initial parameters
      CALL ZFIO ('READ', ILUN, IND, 1, INIPRM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Determine init, change, quit
 100  WRITE (MSGBUF,1100)
      CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
      IOPT = IDUM(1)
      IF (IERR.LT.0) GO TO 100
      IF (IERR.GT.0) GO TO 980
      IF ((IOPT.GE.1) .AND. (IOPT.LE.4)) GO TO (200, 300, 400, 990),
     *   IOPT
C                                       Invalid entry.
      CONTINUE
         WRITE (MSGTXT,1110)
         CALL MSGWRT (6)
         GO TO 100
C                                       1 - Start Over
 200  CONTINUE
         CALL COPY (256, INIPRM, IOBLK)
         PASCHG = .TRUE.
         GO TO 350
C                                       2 - Change Parameters
 300  CONTINUE
         CALL ZFIO ('READ', ILUN, IND, 1, IOBLK, IERR)
         IF (IERR.NE.0) GO TO 990
         PASCHG = .FALSE.
C
 350  CALL QUEST (0, IOBLK, ROBLK, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Enter option number
 360  WRITE (MSGBUF,1360)
      CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
      IOPT = IDUM(1)
      IF (IERR.LT.0) GO TO 360
      IF (IERR.GT.0) GO TO 980
         IF (IOPT.EQ.-1) GO TO 900
         IF (IOPT.EQ.0) GO TO 350
         PASCHG = .TRUE.
         CALL QUEST (IOPT, IOBLK, ROBLK, IERR)
         IF (IERR.NE.0) GO TO 980
         GO TO 360
C                                       3 - Change DEVTAB values
 400  CONTINUE
         CALL ZFIO ('READ', ILUN, IND, 1, IOBLK, IERR)
         PASCHG = .FALSE.
         IF (IERR.NE.0) GO TO 990
C                                       Print DEVTAB values.
 410  DO 420 I = 1,10
         I0 = I + ISTDEV - 1
         I1 = I + ISTDEV + 9
         I2 = I + ISTDEV + 19
         I3 = I + ISTDEV + 29
         I4 = I + ISTDEV + 39
         J1 = I + 10
         J2 = I + 20
         J3 = I + 30
         J4 = I + 40
         WRITE (MSGBUF,1410) I, IOBLK(I0), J1, IOBLK(I1), J2,
     *      IOBLK(I2), J3, IOBLK(I3), J4, IOBLK(I4)
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 980
 420     CONTINUE
C                                       Enter no for change, 0=p ...
 430  WRITE (MSGBUF,1360)
      CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
      IOPT = IDUM(1)
      IF (IERR.LT.0) GO TO 430
      IF (IERR.GT.0) GO TO 980
         IF (IOPT.EQ.-1) GO TO 900
         IF (IOPT.EQ.0) GO TO 410
C                                       Invalid entry.
         IF ((IOPT.GT.0) .AND. (IOPT.LE.50)) GO TO 450
            WRITE (MSGTXT,1110)
            CALL MSGWRT (7)
            GO TO 430
C                                       Read new DEVTAB value
 450     WRITE (MSGBUF,1450) IOPT
         CALL INQINT (TTYLUN, MSGBUF, 1, IOBLK(IOPT+ISTDEV-1), IERR)
         IF (IERR.LT.0) GO TO 450
         IF (IERR.GT.0) GO TO 980
         PASCHG = .TRUE.
         GO TO 430
C                                       Save record.
 900  IF (.NOT.PASCHG) GO TO 100
C                                       Require password
         IF (PASPER) GO TO 910
            CALL PASWRD (SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 990
            PASPER = .TRUE.
C                                       write it
 910  CALL ZFIO ('WRIT', ILUN, IND, 1, IOBLK, IERR)
      GO TO 100
C                                       Terminal I/O error
 980  WRITE (MSGTXT,1980) IERR
      CALL  MSGWRT (8)
C                                       4 - Quit; close parm file
 990  IF (IND.NE.0) CALL ZCLOSE (ILUN, IND, IERR)
      CALL ACOUNT (2)
C
 999  STOP
C-----------------------------------------------------------------------
 1050 FORMAT ('ERROR!  System Parameter file open error:',2I7)
 1100 FORMAT ('Enter:  1=Start Over, 2=Change parameters,',
     *        ' 3=Change DEVTAB, 4=Quit')
 1110 FORMAT ('INVALID ENTRY.  TRY AGAIN.')
 1360 FORMAT ('Enter number to change or  0 = Print, -1 = Return')
 1410 FORMAT (I3,'.',I5,4(I7,'.',I5))
 1450 FORMAT ('Enter DEVTAB(',I2,')  using I format')
 1980 FORMAT ('ERROR',I7,' in terminal I/O')
      END
      SUBROUTINE QUEST (IOPT, IOBLK, ROBLK, IERR)
C-----------------------------------------------------------------------
C   Ask questions.
C   Input:
C      IOPT   I        question to ask. 0 = all. -1 = print.
C   In/Out:
C      IOBLK  I(256)   Block of parameter values: integers
C      ROBLK  R(256)   Block of parameter values: reals
C   Output:
C      IERR   I        Error code from terminal IO.
C   Note that ROBLK and IOBLK are expected to be equivalenced in the
C   calling routine.
C-----------------------------------------------------------------------
      INTEGER   IOPT, IOBLK(256), IERR
      REAL      ROBLK(256)
C
      INTEGER   TTYLUN, TTYIND, I, J1, J2, I1, I2, IMDISK(15), IVOL, J,
     *   K, KK(9), ADDRSZ, KMAX, IDUM(2)
      CHARACTER  MSGBUF*80, ANAME*20
      DOUBLE PRECISION DK(4)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMMON /TTYCOM/ TTYLUN, TTYIND
C-----------------------------------------------------------------------
 10   IERR = 0
      IF (IOPT.EQ.0) GO TO 100
      IF ((IOPT.GE.1) .AND. (IOPT.LE.35)) GO TO (100, 110, 120, 130,
     *   140, 150, 160, 170, 180, 190, 200, 210, 220, 230, 240, 250,
     *   260, 270, 280, 290, 300, 310, 320, 330, 340, 350, 360, 370,
     *   380, 390, 400, 410, 420, 430, 440), IOPT
C                                       Invalid option.
         WRITE (MSGTXT,1000)
         CALL MSGWRT (8)
         GO TO 999
C                                       # of large disks.
 100  WRITE (MSGBUF,1100) IOBLK(1)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.1) .OR. (K.GT.35)) GO TO 10
            IOBLK(1) = K
            END IF
         GO TO 999
         END IF
C                                       # of tape drives
 110  WRITE (MSGBUF,1110) IOBLK(2)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.1) .OR. (K.GT.35)) GO TO 10
            IOBLK(2) = K
            END IF
         GO TO 999
         END IF
C                                       # lines per CRT page.
 120  WRITE (MSGBUF,1120) IOBLK(3)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IOBLK(3) = K
            END IF
         GO TO 999
         END IF
C                                       # lines per print page.
 130  WRITE (MSGBUF,1130) IOBLK(4)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.10) .OR. (K.GT.300)) GO TO 10
            IOBLK(4) = K
            END IF
         GO TO 999
         END IF
C                                       # of batch queues
 140  WRITE (MSGBUF,1140) IOBLK(5)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.0) .OR. (K.GT.34-MAX(1,IOBLK(10)))) GO TO 10
            IOBLK(5) = K
            END IF
         GO TO 999
         END IF
C                                       Printer plotter.
C                                       X dots per page.
 150  WRITE (MSGBUF,1150) IOBLK(6)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.10) .OR. (K.GT.200000)) GO TO 10
            IOBLK(6) = K
            END IF
         GO TO 999
         END IF
C                                       Y dots per page.
 160  WRITE (MSGBUF,1160) IOBLK(7)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.10) .OR. (K.GT.200000)) GO TO 10
            IOBLK(7) = K
            END IF
         GO TO 999
         END IF
C                                       X dots per character.
 170  WRITE (MSGBUF,1170) IOBLK(8)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.3) .OR. (K.GT.200)) GO TO 10
            IOBLK(8) = K
            END IF
         GO TO 999
         END IF
C                                       Y dots per character.
 180  WRITE (MSGBUF,1180) IOBLK(9)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.3) .OR. (K.GT.200)) GO TO 10
            IOBLK(9) = K
            END IF
         GO TO 999
         END IF
C                                       # of interactive AIPSs
 190  WRITE (MSGBUF,1190) IOBLK(10)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.1) .OR. (K.GT.35)) GO TO 10
            IOBLK(10) = K
            IF ((IOBLK(10)+IOBLK(5).GT.34) .AND. (IOBLK(5).GT.0)) THEN
               K = 34 - IOBLK(10)
               WRITE (MSGBUF,1195) IOBLK(5), K
               CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
               END IF
            END IF
         GO TO 999
         END IF
C                                       # words in AP (in 1024's)
 200  WRITE (MSGBUF,1200) IOBLK(11)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            CALL ZADRSZ (ADDRSZ)
            KMAX = 3 * 128 * 1024
            IF (ADDRSZ.EQ.8) KMAX = 6 * 256 * 1024
            IF ((K.LT.0) .OR. (K.GT.KMAX)) GO TO 10
            IOBLK(11) = K
            END IF
         GO TO 999
         END IF
C                                       # of TV devices available.
 210  WRITE (MSGBUF,1210) IOBLK(12)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.0) .OR. (K.GT.1295)) GO TO 10
            IOBLK(12) = K
            END IF
         GO TO 999
         END IF
C                                       # of graphics devices
 220  WRITE (MSGBUF,1220) IOBLK(13)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.0) .OR. (K.GT.1295)) GO TO 10
            IOBLK(13) = K
            END IF
         GO TO 999
         END IF
C                                       # X dots per mm on printer.
 230  WRITE (MSGBUF,1230) ROBLK(71)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQFLT (TTYLUN, MSGBUF, 1, DK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((DK(1).LT.0.1) .OR. (DK(1).GT.100.)) GO TO 10
            ROBLK(71) = DK(1)
            END IF
         GO TO 999
         END IF
C                                       # X lines per mm on tek.
 240  WRITE (MSGBUF,1240) ROBLK(72)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQFLT (TTYLUN, MSGBUF, 1, DK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((DK(1).LT.0.1) .OR. (DK(1).GT.100.)) GO TO 10
            ROBLK(72) = DK(1)
            END IF
         GO TO 999
         END IF
C                                       # POPS allowed TV access
 250  WRITE (MSGBUF,1250) IOBLK(64)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.1) .OR. (K.GT.35)) GO TO 10
            IOBLK(64) = K
            END IF
         GO TO 999
         END IF
C                                       # POPS allowed TK access
 260  WRITE (MSGBUF,1260) IOBLK(65)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.1) .OR. (K.GT.35)) GO TO 10
            IOBLK(65) = K
            END IF
         GO TO 999
         END IF
C                                       # entries in private catlgs
 270  WRITE (MSGBUF,1270) IOBLK(66)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.1) .OR. (K.GT.46655)) GO TO 10
            IOBLK(66) = K
            END IF
         GO TO 999
         END IF
C                                       System name/Registration
 280  CALL H2CHR (20, 1, ROBLK(73), ANAME)
      WRITE (MSGBUF,1280) ANAME
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQSTR (TTYLUN, MSGBUF, 20, ANAME, IERR)
         IF (IERR.EQ.0) THEN
            IF (ANAME.EQ.' ') GO TO 10
            CALL CHR2H (20, ANAME, 1, ROBLK(73))
            END IF
         GO TO 999
         END IF
C                                       Maximum user number
 290  WRITE (MSGBUF,1290) IOBLK(67)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.10) .OR. (K.GT.46655)) GO TO 10
            IOBLK(67) = K
            END IF
         GO TO 999
         END IF
C                                       Disk data set TIMDEST limits
 300  J2 = 0
 301  J1 = J2 + 1
         J2 = J1 + 2
         IF (J2.GT.IOBLK(1)) J2 = IOBLK(1)
         I1 = J1 + 77
         I2 = J2 + 77
 302     WRITE (MSGBUF,1300) J1, J2, (ROBLK(I), I = I1,I2)
         IF (IOPT.EQ.0) THEN
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
            IF (IERR.NE.0) GO TO 999
         ELSE
            K = I2 - I1 + 1
            CALL INQFLT (TTYLUN, MSGBUF, K, DK, IERR)
            IF (IERR.LT.0) GO TO 10
            IF (IERR.NE.0) GO TO 999
            DO 305 I = 1,K
               IF ((DK(I).LE.0.25) .OR. (DK(I).GT.365.)) GO TO 302
 305           CONTINUE
            DO 306 I = 1,K
               ROBLK(I1+I-1) = DK(I)
 306           CONTINUE
            END IF
         IF (J2.LT.IOBLK(1)) GO TO 301
         IF (IOPT.NE.0) GO TO 999
C                                       TIMDEST limit: SAVE/GET
 310  WRITE (MSGBUF,1310) ROBLK(93)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQFLT (TTYLUN, MSGBUF, 1, DK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((DK(1).LE.3.0) .OR. (DK(1).GT.365.0)) GO TO 10
            ROBLK(93) = DK(1)
            END IF
         GO TO 999
         END IF
C                                       TIMDEST/EXIT limit messages
 320  WRITE (MSGBUF,1320) ROBLK(94)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQFLT (TTYLUN, MSGBUF, 1, DK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((DK(1).LE.1.0) .OR. (DK(1).GT.365.0)) GO TO 10
            ROBLK(94) = DK(1)
            END IF
         GO TO 999
         END IF
C                                       TIMDEST limit scratch
 330  WRITE (MSGBUF,1330) ROBLK(95)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQFLT (TTYLUN, MSGBUF, 1, DK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((DK(1).LE.1.0) .OR. (DK(1).GT.35.0)) GO TO 10
            ROBLK(95) = DK(1)
            END IF
         GO TO 999
         END IF
C                                       TIMDEST limit: empty CA files
 340  WRITE (MSGBUF,1340) ROBLK(96)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQFLT (TTYLUN, MSGBUF, 1, DK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((DK(1).LE.0.1) .OR. (DK(1).GT.5.0)) GO TO 10
            ROBLK(96) = DK(1)
            END IF
         GO TO 999
         END IF
C                                       No AP batch starts ranges
 350  WRITE (MSGBUF,1350) ROBLK(97), ROBLK(98)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQFLT (TTYLUN, MSGBUF, 2, DK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((DK(1).LT.0.) .OR. (DK(1).GT.24.)) GO TO 350
            IF ((DK(2).LT.0.) .OR. (DK(2).GT.24.)) GO TO 350
            IF (DK(2).LT.DK(1)) GO TO 350
            ROBLK(97) = DK(1)
            ROBLK(98) = DK(2)
         ELSE
            GO TO 999
            END IF
         END IF
 355  WRITE (MSGBUF,1355) ROBLK(99), ROBLK(100)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQFLT (TTYLUN, MSGBUF, 2, DK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((DK(1).LT.0.) .OR. (DK(1).GT.24.)) GO TO 355
            IF ((DK(2).LT.0.) .OR. (DK(2).GT.24.)) GO TO 355
            IF (DK(2).LT.DK(1)) GO TO 355
            ROBLK(99) = DK(1)
            ROBLK(100) = DK(2)
            END IF
         GO TO 999
         END IF
C                                       AP: roll time, delay formula
 360  WRITE (MSGBUF,1360) ROBLK(101)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQFLT (TTYLUN, MSGBUF, 1, DK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (DK(1).LE.1.) GO TO 360
            ROBLK(101) = DK(1)
         ELSE
            GO TO 999
            END IF
         END IF
 365  WRITE (MSGBUF,1365) ROBLK(102), ROBLK(103)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQFLT (TTYLUN, MSGBUF, 2, DK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF (DK(1).LE.0.1) GO TO 365
            ROBLK(102) = DK(1)
            ROBLK(103) = DK(2)
            END IF
         GO TO 999
         END IF
C                                       Maximum line printer width
 370  WRITE (MSGBUF,1370) IOBLK(68)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.72) .OR. (K.GT.132)) GO TO 10
            IOBLK(68) = K
            END IF
         GO TO 999
         END IF
C                                       Secondary AP space
 380  IF (IOPT.NE.0) THEN
         GO TO 999
         END IF
C                                       Max length short vector
 390  WRITE (MSGBUF,1390) IOBLK(70)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((K.LT.3) .OR. (K.GT.2000)) GO TO 10
            IOBLK(70) = K
            END IF
         GO TO 999
         END IF
C                                       TK device screen size
 400  WRITE (MSGBUF,1400) IOBLK(224), IOBLK(225)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 2, KK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((KK(1).LT.300) .OR. (KK(1).GT.16384)) GO TO 10
            IF ((KK(2).LT.300) .OR. (KK(2).GT.16384)) GO TO 10
            CALL COPY (2, KK, IOBLK(224))
            END IF
         GO TO 999
         END IF
C                                       TK device char size
 410  WRITE (MSGBUF,1410) IOBLK(226), IOBLK(227)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 2, KK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            IF ((KK(1).LT.5) .OR. (KK(1).GT.100)) GO TO 10
            IF ((KK(1).LT.5) .OR. (KK(1).GT.100)) GO TO 10
            CALL COPY (2, KK, IOBLK(226))
            END IF
         GO TO 999
         END IF
C                                       Disk assignments
 420  CALL FILL (15, 0, IMDISK)
      IVOL = IOBLK(1)
      IVOL = MIN (IVOL, 15)
      IF ((IVOL.LE.0) .AND. (IOPT.NE.0)) GO TO 999
      IF (IVOL.LE.0) GO TO 430
      DO 422 I = 1,IVOL
         J1 = 103 + 8 * (I-1)
         DO 421 J = 1,8
            IF (IOBLK(J+J1).EQ.0) GO TO 422
            IF ((IOBLK(J+J1).LT.0) .AND. (J.GT.1)) GO TO 422
            IMDISK(I) = J
 421        CONTINUE
 422     CONTINUE
      WRITE (MSGBUF,1420)
      CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
      IF (IERR.NE.0) GO TO 999
      DO 423 I = 1,IVOL
         J2 = MAX (1, IMDISK(I))
         J1 = 104 + 8 * (I-1)
         J2 = J1 + J2 - 1
         WRITE (MSGBUF,1421) I, (IOBLK(J), J = J1,J2)
         IF ((IOPT.EQ.0) .OR. (I.LT.IVOL)) THEN
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 423     CONTINUE
      IF (IOPT.EQ.0) GO TO 430
         CALL INQINT (TTYLUN, MSGBUF, 9, KK, IERR)
         IF (IERR.LT.0) GO TO 10
         IF (IERR.EQ.0) THEN
            I = KK(1)
            IF ((I.LT.2) .OR. (I.GT.IVOL)) GO TO 420
            IF (KK(2).LT.-1) GO TO 420
            J1 = 104 + 8 * (I-1)
            CALL COPY (8, KK(2), IOBLK(J1))
            END IF
         GO TO 999
C                                       printer delete time
 430  WRITE (MSGBUF,1430) IOBLK(228)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQINT (TTYLUN, MSGBUF, 1, IDUM, IERR)
         K = IDUM(1)
         IF (IERR.LT.0) GO TO 430
         IF (IERR.EQ.0) THEN
            IF ((K.LT.10) .OR. (K.GT.36000)) GO TO 430
            IOBLK(228) = K
            END IF
         GO TO 999
         END IF
C                                       Computer's speed (AIPSmark)
 440  WRITE (MSGBUF,1440) ROBLK(238)
      IF (IOPT.EQ.0) THEN
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
         CALL INQFLT (TTYLUN, MSGBUF, 1, DK, IERR)
         IF (IERR.LT.0) GO TO 430
         IF (IERR.EQ.0) THEN
            IF ((DK(1).LT.0.01) .OR. (DK(1).GT.2000.)) GO TO 440
            ROBLK(238) = DK(1)
            END IF
         GO TO 999
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('INVALID OPTION. RE-ENTER')
 1100 FORMAT ('  1  No. of AIPS data areas ("disks")   ',I6)
 1110 FORMAT ('  2  No. of tape drives                 ',I6)
 1120 FORMAT ('  3  No. of lines per CRT page          ',I6)
 1130 FORMAT ('  4  No. of lines per print page        ',I6)
 1140 FORMAT ('  5  No. of batch queues                ',I6)
 1150 FORMAT ('  6  Plotter no. of X dots per page     ',I6)
 1160 FORMAT ('  7  Plotter no. of Y dots per page     ',I6)
 1170 FORMAT ('  8  Plotter no. of X dots per character',I6)
 1180 FORMAT ('  9  Plotter no. of Y dots per character',I6)
 1190 FORMAT (' 10  No. of interactive AIPS            ',I6)
 1200 FORMAT (' 11  Max words in pseudo AP (in 1024s) ',I7)
 1210 FORMAT (' 12  No. of TV devices available        ',I6)
 1220 FORMAT (' 13  No. of graphics devices available  ',I6)
 1230 FORMAT (' 14  No. of X dots per mm on printer    ',F6.3)
 1240 FORMAT (' 15  No. of X dots per mm on tektronix  ',F6.3)
 1250 FORMAT (' 16  No. of POPS allowed access to TVs  ',I6)
 1260 FORMAT (' 17  No. of POPS allowed access to TKs  ',I6)
 1270 FORMAT (' 18  No. entries in private catalogs    ',I6)
 1280 FORMAT (' 19  Site name (A20)                    ',A20)
 1290 FORMAT (' 20  Maximum user number (<= 46655)     ',I6)
 1300 FORMAT (' 21  TIMDEST minima disks',I3,' -',I3,' days ',3F5.0)
 1310 FORMAT (' 22  TIMDEST limit: SAVE/GET files      ',F5.0)
 1320 FORMAT (' 23  TIMDEST/EXIT limit: messages       ',F5.0)
 1330 FORMAT (' 24  TIMDEST limit: scratch files       ',F5.0)
 1340 FORMAT (' 25  TIMDEST limit: empty CA files      ',F6.3)
 1350 FORMAT (' 26  No AP batch starts: weekend hours  ',2F6.3)
 1355 FORMAT ('     No AP batch starts: weekday hours  ',2F6.3)
 1360 FORMAT (' 27  AP roll interval minutes           ',F6.3)
 1365 FORMAT ('     AP patience: (1)*N+(2)*N*N minutes ',2F6.3)
 1370 FORMAT (' 28  Line printer width (72 - 132)      ',I6)
 1390 FORMAT (' 30  Max length of "short" vector       ',I6)
 1400 FORMAT (' 31  Graphics (TK) screen size: x, y    ',2I6)
 1410 FORMAT (' 32  Graphics (TK) character size: x, y ',2I6)
 1420 FORMAT (' 33  Disk & reserved users or -1 scratch (9 I)')
 1421 FORMAT ('     Disk',I3,' Users',8I5)
 1430 FORMAT (' 34  Delay time print file delete (secs)',I6)
 1440 FORMAT (' 35  Computer speed rating (AIPSmarks)  ',F6.1)
 1195 FORMAT (' *** REDUCE NUMBER BATCH QUEUES FROM',I3,' TO <=',I3)
      END

      SUBROUTINE YCONST (OP, RCONST, GCONST, BCONST, VRTRTC, IERR)
C-----------------------------------------------------------------------
C! controls the constant registers added to the TV picture - not used
C# Y2 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YCONST reads/writes the constants which are added to the 3 sum
C   channels on the TV.
C   Inputs:
C      OP      C*4   'READ' from TV, 'WRIT' to TV
C   In/out:
C      RCONST  I     constant for red channel
C      GCONST  I     constant for green channel
C      BCONST  I     constant for blue channel
C      VRTRTC  L     (could be Vertical retrace)
C   Output:
C      IERR    I     error code of Z...XF : 0 => ok
C   Virtual TV version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   RCONST, GCONST, BCONST, IERR
      LOGICAL   VRTRTC
C
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      BUFFER(1) = 0
      IF (VRTRTC) BUFFER(1) = 1
      BUFFER(2) = RCONST
      BUFFER(3) = GCONST
      BUFFER(4) = BCONST
      IF (OP.NE.'WRIT') THEN
         BUFSW = 1
         BUFSR = 4
      ELSE
         BUFSW = 4
         BUFSR = 0
         END IF
C                                        header & IO
      CALL MKYBUF (OP, 'YCONST', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
C                                        read: return control parms
      IF ((IERR.EQ.0) .AND. (OP.NE.'WRIT')) THEN
         CALL UNYBUF (BUFSR, BUFFER, HEADER)
         RCONST = BUFFER(2)
         GCONST = BUFFER(3)
         BCONST = BUFFER(4)
         END IF
C
 999  RETURN
      END

      SUBROUTINE TABTS (OPCODE, BUFFER, TSROW, TSCOLS, TSNUMV, NUMPOL,
     *   TIME, TIMINT, SOURCE, ANTNUM, SUBARR, FREQID, TSYS, TANT, IRET)
C-----------------------------------------------------------------------
C! Read a record from a FITS interchange phase-cal table
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1998, 2013, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Read a single record from a FITS interferometry data interchange
C   phase cal (PH) table that has been opened using PHINI or close a PH
C   table that was opened using PHINI.
C
C   Inputs:
C      OPCODE   C*4          Operation to perform:
C                              'READ' - read a record
C                              'CLOS' - close table
C      TSCOLS   I(MAXTSC)    Column index array from TSINI (ignored
C                              if OPCODE = 'CLOS')
C      TSNUMV   I(MAXTSC)    Column dimensions array from TSINI
C                              (ignored if OPCODE = 'CLOS')
C      NUMPOL    I           Number of polarizations from TSINI (ignored
C                              if OPCODE = 'CLOS').
C
C   Input/output:
C      BUFFER   I(512)       Table I/O control block and buffers
C                              (will be modified)
C      TSROW    I            Table row to be read if OPCODE = 'READ';
C                              incremented by 1 on exit if the record
C                              was read successfully. Ignored if
C                              OPCODE = 'CLOS'.
C
C   Output:
C      TIME     D            Centre time of record in days
C      TIMINT   R            Interval covered by record in days
C      ANTNUM   I            Antenna number if OPCODE = 'READ'
C      SUBARR   I            Subarray number if OPCODE = 'READ'
C      FREQID   I            Frequency ID if OPCODE = 'READ'
C      TSYS     R(2, MAXIF)  System temperature for each IF and
C                            polarization in kelvin
C      TANT     R(2, MAXIF)  Antenna temperature for each IF and
C                            polarization in kelvin
C      IRET     I            Return code:
C                              0 - record read (OPCODE = 'READ') or
C                                  table closed (OPCODE = 'CLOS)
C                              1 - TSROW beyond end of table
C                                  (OPCODE = 'WRIT')
C                              2 - I/O error detected
C                            999 - Invalid call to TABTS
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PTAB.INC'
      INCLUDE 'INCS:PTSV.INC'
C
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), TSROW, TSCOLS(MAXTSC), TSNUMV(MAXTSC),
     *   NUMPOL, SOURCE, ANTNUM, SUBARR, FREQID, IRET
      DOUBLE PRECISION TIME
      REAL      TIMINT, TSYS(2, MAXIF), TANT(2, MAXIF)
C                                       Local Variables
C     IREC       Integer valued buffer
C     RREC       Single-precision floating-point buffer
C     DREC       Double-precision floating-point buffer
C     NUMIF      Number of IFs in table
C     I          Loop index
C     J          Loop index
C
      INTEGER   IREC(TSRSIZ)
      REAL      RREC(TSRSIZ)
      DOUBLE PRECISION DREC(TSRSIZ / 2)
      INTEGER   NUMIF, I, J
      EQUIVALENCE (IREC, RREC, DREC)
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (OPCODE.EQ.'READ') THEN
         CALL TABIO (OPCODE, TIOROW, TSROW, IREC, BUFFER, IRET)
         IF (IRET.LE.0) THEN
            TSROW  = TSROW + 1
            NUMIF  = TSNUMV(7)
C
            TIME   = DREC(TSCOLS(1))
            TIMINT = RREC(TSCOLS(2))
            SOURCE = IREC(TSCOLS(3))
            ANTNUM = IREC(TSCOLS(4))
            SUBARR = IREC(TSCOLS(5))
            FREQID = IREC(TSCOLS(6))
            DO 20 I = 1,NUMPOL
               DO 10 J = 1,NUMIF
                  TSYS(I,J) = RREC(TSCOLS(7 + 2 * (I - 1)) + (J - 1))
                  TANT(I,J) = RREC(TSCOLS(8 + 2 * (I - 1)) + (J - 1))
 10               CONTINUE
 20            CONTINUE
         ELSE IF (IRET.EQ.4) THEN
            WRITE (MSGTXT, 9020) TSROW, BUFFER(5)
            CALL MSGWRT (6)
            IRET = 1
         ELSE
            CALL TABERR (OPCODE, 'TABIO ', 'TABTS ', IRET)
            IRET = 2
            END IF
      ELSE IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO (OPCODE, 0, TSROW, IREC, BUFFER, IRET)
         IF (IRET.NE.0) THEN
            CALL TABERR (OPCODE, 'TABIO ', 'TABTS ', IRET)
            IRET = 2
            END IF
      ELSE
         WRITE (MSGTXT, 9021) OPCODE
         CALL MSGWRT (8)
         IRET = 999
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 9020 FORMAT ('TABTS: ROW ', I6, ' BEYOND END OF TABLE AT ', I6,
     *        ' ROWS')
 9021 FORMAT ('TABTS: UNRECOGNIZED OPCODE ''', A, '''')
      END

      SUBROUTINE QMTYP (NFIELD, NCC, NVIS, NCHAN, NX, NY,
     *   TIMDFT, TIMFFT)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Version FPS AP120B on a VAX 11/780
C   QMTYP computes the times to do a DFT and interpolated GRID model
C   computation.  The algorithm is a crude, parameterized model which
C   allows a decision about which method is faster; high accuracy is not
C   needed.  The comparison is between VISDFT which does a DFT model
C   computation and GRDSUB which does the gridded interpolation.
C   It is simple to compute the cost of VISDFT since it is a constant
C   times NVIS * SUM(NCC) * NCHAN.  GRDSUB depends on the number of
C   fields (one pass per field per channel is required), the size of
C   each field, NCC(field), and NVIS.  Three scaling factors
C   TPVGRD, TFFT, TPCGRD are used to parameterize the dependence of
C   NVIS, (NX(field)*NY(field)) and NCC(field).
C      The algorithm may be adjusted to the accounting scheme of the
C   local system.  VISDFT will generally be CPU bound and GRDSUB will
C   be I/O bound.
C   Input:
C      NFIELD      I  Number of fields
C      NCC(*)      I  Number of components per field.
C      NVIS        I  Number of visibility records.
C      NCHAN       I  Number of frequency channels to subtract.
C      NX(*),NY(*) I  Size of each field
C   Output:
C      TIMDFT      R Estimate of time for DFT in sec.
C      TIMFFT      R Estimate of time for FFT/grid. interpolation.
C-----------------------------------------------------------------------
      INTEGER NFIELD
      INTEGER NCC(NFIELD), NX(NFIELD), NY(NFIELD), NVIS, NCHAN
      REAL    TIMDFT, TIMFFT
      INTEGER SUMCC, I
      REAL    TPVGRD, TFFT, TPCGRD, TPVPC
C                                       Time/vis to interpolate
C                                       (ALGSUB)
      DATA TPVGRD /0.4E-3/
C                                       Time/NX/NY for GRID (CCSGRD)
C                                       Dependency on grid size.
      DATA TFFT /4.0E-2/
C                                       Time/comp to grid (CCSGRD)
C                                       dependency on no. comp.
      DATA TPCGRD /1.0E-3/
C                                       Time/vis/comp DFT (VISDFT)
      DATA TPVPC /6.0E-6/
C-----------------------------------------------------------------------
C                                       Compute Grid-interpolation
C                                       Loop over fields
      TIMFFT = 0.0
      SUMCC = 0
      DO 50 I = 1,NFIELD
C                                       Sum number of components
         SUMCC = SUMCC + NCC(I)
         IF (NCC(I).GT.0)
     *         TIMFFT = TIMFFT + (NVIS * TPVGRD +
     *         SQRT (4.0 * NX(I) * NY(I)) * TFFT +
     *         NCC(I) * TPCGRD) * NCHAN
 50         CONTINUE
C                                       Compute DFT time
      TIMDFT = TPVPC * NVIS * SUMCC * NCHAN
C
 999  RETURN
      END

      SUBROUTINE TABPH (OPCODE, BUFFER, PHROW, PHCOLS, PHNUMV, NUMPOL,
     *   TIME, TIMINT, SOURCE, ANTNUM, SUBARR, FREQID, CABCAL, STATE,
     *   PCFREQ, PCREAL, PCIMAG, PCRATE, IRET)
C-----------------------------------------------------------------------
C! Read a record from a FITS interchange phase-cal table
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1998, 2013, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Read a single record from a FITS interferometry data interchange
C   phase cal (PH) table that has been opened using PHINI or close a PH
C   table that was opened using PHINI.
C
C   Inputs:
C      OPCODE   C*4          Operation to perform:
C                              'READ' - read a record
C                              'CLOS' - close table
C      PHCOLS   I(MAXPHC)    Column index array from PHINI (ignored
C                              if OPCODE = 'CLOS')
C      PHNUMV   I(MAXPHC)    Column dimensions array from PHINI
C                              (ignored if OPCODE = 'CLOS')
C      NUMPOL   I            Number of polarizations from PHINI (ignored
C                              if OPCODE = 'CLOS').
C   Input/output:
C      BUFFER   I(512)       Table I/O control block and buffers
C                              (will be modified)
C      PHROW    I            Table row to be read if OPCODE = 'READ';
C                              incremented by 1 on exit if the record
C                              was read successfully. Ignored if
C                              OPCODE = 'CLOS'.
C
C   Output:
C      TIME     D            Centre time of record in days
C      TIMINT   R            Interval covered by record in days
C      ANTNUM   I            Antenna number if OPCODE = 'READ'
C      SUBARR   I            Subarray number if OPCODE = 'READ'
C      FREQID   I            Frequency ID if OPCODE = 'READ'
C      CABCAL   D            Cable cal delay measurement in seconds
C      STATE    R(2, 4, MAXIF)
C                            Percentage of time the digitizer spent
C                               in the lowest (1), medium-low (2),
C                               medium-high (3) and highest (4) states
C                               for each IF and polarization
C      PCFREQ   D(2, MAXTON, MAXIF)
C                            Phase tone frequencies for each IF and
C                               polarization
C      PCREAL   R(2, MAXTON, MAXIF)
C                            The real part of each phase cal
C                               measurement in each IF and polarization
C      PCIMAG   R(2, MAXTON, MAXIF)
C                            The imaginary part of each phase cal
C                               measurement in each IF and polarization
C      PCRATE   R(2, MAXTON, MAXIF)
C                            The rate of change of the phase cal phase
C                               in Hz divided by the phase cal
C                               frequency for each tone in each IF
C                               and polarization
C      IRET     I            Return code:
C                              0 - record read (OPCODE = 'READ') or
C                                  table closed (OPCODE = 'CLOS)
C                              1 - PHROW beyond end of table
C                                  (OPCODE = 'WRIT')
C                              2 - I/O error detected
C                            999 - Invalid call to TABPH
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PTAB.INC'
      INCLUDE 'INCS:PPHV.INC'
C
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), PHROW, PHCOLS(MAXPHC), PHNUMV(MAXPHC),
     *   NUMPOL, SOURCE, ANTNUM, SUBARR, FREQID, IRET
      DOUBLE PRECISION TIME, CABCAL, PCFREQ(2, MAXTON, MAXIF)
      REAL      TIMINT, STATE(2, 4, MAXIF), PCREAL(2, MAXTON, MAXIF),
     *   PCIMAG(2, MAXTON, MAXIF), PCRATE(2, MAXTON, MAXIF)
C                                       Local Variables
C     IREC       Integer valued buffer
C     RREC       Real valued buffer
C     NUMIF      Number of IFs in table
C     NUMTON     Number of tabulated vales in table
C     I          Loop index
C     J          Loop index
C
      INTEGER   IREC(PHRSIZ)
      REAL      RREC(PHRSIZ)
      DOUBLE PRECISION DREC(PHRSIZ / 2)
      INTEGER   NUMIF, NUMTON, I, J, K
      EQUIVALENCE (IREC, RREC, DREC)
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (OPCODE .EQ. 'READ') THEN
         CALL TABIO (OPCODE, TIOROW, PHROW, IREC, BUFFER, IRET)
         IF (IRET.LE.0) THEN
            PHROW  = PHROW + 1
            NUMIF  = PHNUMV(8) / 4
            NUMTON = PHNUMV(9) / NUMIF
C
            TIME   = DREC(PHCOLS(1))
            TIMINT = RREC(PHCOLS(2))
            SOURCE = IREC(PHCOLS(3))
            ANTNUM = IREC(PHCOLS(4))
            SUBARR = IREC(PHCOLS(5))
            FREQID = IREC(PHCOLS(6))
            CABCAL = DREC(PHCOLS(7))
            DO 40 I = 1,NUMPOL
               DO 30 K = 1,NUMIF
                  DO 10 J = 1,4
                     STATE(I,J,K) = RREC(PHCOLS(8 + 5 * (I - 1))
     *                  + 4 * (K - 1) + (J - 1))
 10                  CONTINUE
                  DO 20 J = 1,NUMTON
                     PCFREQ(I,J,K) = DREC(PHCOLS(9 + 5 * (I - 1))
     *                  + NUMTON * (K - 1) + (J - 1))
                     PCREAL(I,J,K) = RREC(PHCOLS(10 + 5 * (I - 1))
     *                  + NUMTON * (K - 1) + (J - 1))
                     PCIMAG(I,J,K) = RREC(PHCOLS(11 + 5 * (I - 1))
     *                  + NUMTON * (K - 1) + (J - 1))
                     PCRATE(I,J,K) = RREC(PHCOLS(12 + 5 * (I - 1))
     *                  + NUMTON * (K - 1) + (J - 1))
 20                  CONTINUE
 30               CONTINUE
 40            CONTINUE
         ELSE IF (IRET.EQ.4) THEN
            WRITE (MSGTXT, 9040) PHROW, BUFFER(5)
            CALL MSGWRT (6)
            IRET = 1
         ELSE
            CALL TABERR (OPCODE, 'TABIO ', 'TABPH ', IRET)
            IRET = 2
            END IF
      ELSE IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO (OPCODE, 0, PHROW, IREC, BUFFER, IRET)
         IF (IRET .NE. 0) THEN
            CALL TABERR (OPCODE, 'TABIO ', 'TABPH ', IRET)
            IRET = 2
            END IF
      ELSE
         WRITE (MSGTXT,9041) OPCODE
         CALL MSGWRT (8)
         IRET = 999
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 9040 FORMAT ('TABPH: ROW ', I6, ' BEYOND END OF TABLE AT ', I6,
     *        ' ROWS')
 9041 FORMAT ('TABPH: UNRECOGNIZED OPCODE ''', A, '''')
      END

      SUBROUTINE BEMFIT (IFIELD, JBUFSZ, BUFFR, BEAM, IERR)
C-----------------------------------------------------------------------
C! Fits elliptical Gaussian to beam image
C# Modeling Map
C-----------------------------------------------------------------------
C;  Copyright (C) 2008
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BMSHP fits an eliptical Gaussian to the dirty beam and checks that
C   the peak of the beam is 1.0.  If peak of beam is too narrow to fit a
C   default circular Gaussian is used.  A grid of up to 5 X 11 points is
C   used for the fit; only points within the half power points are used.
C   To avoid degenerate cases some of the allowed points are ignored.
C   Solution is by least squares to a linearized gaussian.
C   Input:
C      IFIELD   I      Field number
C      JBUFSZ   I      Size of BUFFR in AIPS bytes
C   Output:
C      BUFFR    R(*)   Scratch buffer
C      BEAM     R(3)   Major, minor, PA
C      IERR     I      Error code (disk IO troubles)
C   Uses COMMONs DMPR, DGDS to define cell size, beam size and disk
C   location
C-----------------------------------------------------------------------
      INTEGER   IFIELD, JBUFSZ, IERR
      REAL      BUFFR(*), BEAM(3)
C
      CHARACTER PHNAME*48
      INTEGER   IFLIP, ICENX, ICENY, LUN, FIND, LFIELD, WIN(4), NX, NY,
     *   I, J, BIND, IJK, IROW, ILAST, K, L
      REAL      X(3,3), Y(3), P(3), DX, DY, XFACT, CELLS(2)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DMPR.INC'
      INCLUDE 'INCS:DGDS.INC'
C-----------------------------------------------------------------------
      LFIELD = MAX (1, ABS(IFIELD))
      XFACT = ABS (CELLSG(1))
      CELLS(1) = - XFACT
      CELLS(2) = CELLSG(2)
      IFLIP = 1
      NX = NXBEM(LFIELD)
      NY = NYBEM(LFIELD)
      ICENX = NX / 2
      ICENY = NY / 2 + 1
      LUN = 18
C                                       Open beam file.
      CALL ZPHFIL ('MA', BEMVOL(LFIELD), CNOBEM(LFIELD), 1, PHNAME,
     *   IERR)
      CALL ZOPEN (LUN, FIND, BEMVOL(LFIELD), PHNAME, .TRUE., .FALSE.,
     *   .TRUE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Zero work arrays.
      DO 20 I = 1,3
         Y(I) = 0.0
         DO 10 J = 1,3
            X(I,J) = 0.0
 10         CONTINUE
 20      CONTINUE
C                                       Set window,only need half map
      WIN(1) = NX / 2 - 5
      WIN(2) = NY / 2 + 1
      WIN(3) = NX / 2 + 5
      WIN(4) = NY / 2 + 5 + 1
      CALL MINIT ('READ', LUN, FIND, NX, NY, WIN, BUFFR, JBUFSZ,
     *   BOBEM(LFIELD), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INIT'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Loop through rows.
      DO 70 I = 1,6
C                                       Read row.
         CALL MDISK ('READ', LUN, FIND, BUFFR, BIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR, (I + WIN(1) - 1)
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       Loop down row doing alternate
C                                       halves. go only to first
C                                       decending 0.35 from center.
         DO 65 IJK = 1,2
            IFLIP = - IFLIP
            ILAST = BIND + 5 - IFLIP
            DO 60 J = IJK,6
               IROW = BIND + 5 + (J-1) * IFLIP
               IF ((BUFFR(IROW).LT.0.35) .AND. (BUFFR(IROW).LT.
     *            BUFFR(ILAST))) GO TO 65
               IF (BUFFR(IROW).GE.0.35) THEN
                  ILAST = IROW
C                                       Compute displacements from
C                                       center.
                  DX = IFLIP * (J-1.0) * CELLS(1) / XFACT
                  DY = (1.0-I) * CELLS(2) / XFACT
C                                       Compute partials WRT C1,C2,C3
                  P(1) = DX * DX
                  P(2) = DY * DY
                  P(3) = DX * DY
C                                       Sum partials into X matrix and
C                                       Y vector.
                  DO 40 K = 1,3
                     Y(K) = Y(K) - LOG (BUFFR(IROW)) * P(K)
                     DO 30 L = 1,3
                        X(K,L) = X(K,L) + P(K) * P(L)
 30                     CONTINUE
 40                  CONTINUE
                  END IF
 60            CONTINUE
 65         CONTINUE
 70      CONTINUE
C                                       Fit beam
      CALL FITBM (0, X, Y, CELLS, MAPROT, BEAM(1), BEAM(2), BEAM(3))
C                                       Close beam file
      CALL ZCLOSE (LUN, FIND, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BEMFIT: ERROR ',I3,1X,A,'ING FILE ')
 1020 FORMAT ('BEMFIT: READ ERROR ',I3,' ROW ',I5)
      END

      SUBROUTINE DATGET (RPARM, VIS, TIMLST, IERR)
C-----------------------------------------------------------------------
C! Reads, selects, calibrates and edits data.
C# Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2001, 2004, 2007, 2009, 2015, 2017-2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Reads next selected data record. Applies calibration and editing.
C   Inputs from common /SELCAL/:
C      INXRNO       I    Current INDEX file record number.
C                        If .LT. 0 then there is no index file.
C      NINDEX       I    Number of entries in the index table
C      NXKOLS(7)    I    Pointer array for index records.
C      ANTENS(50)   I    List of antennas selected, 0=>all,
C                        any negative => all except those specified
C      NANTSL       I    Number of antennas selected/excluded in ANTENS
C                        0 = All included.
C      DOAWNT       L    If .TRUE. then antennas in ANTENS included.
C                        If .FALSE. then excluded.
C      SUBARR       I    Subarray number desired, 0=>any.
C      NSOUWD       I    Number of sources specified.
C      DOSWNT       L    If true sources specified are included
C                        else excluded.
C      SOUWAN(30)   I    List or source numbers from source file.
C      DOACOR       L    If true, pass autocorrelations.
C      DOXCOR       L    If true, pass crosscorrelations.
C      TRANSL       L    If true, translate data to requested stokes.
C      JADR(2,4)    I    Table to translate input data to output vis.
C      TSTART       R    Start time in days.
C      TEND         R    End time in days.
C      UVRA(2)      R    UV range (wavelength squared)
C      NPRMIN       I    No. random parameters in the input data
C      NRPARM       I    No. random parameters in output data.
C      LRECIN       I    Length of input record in words.
C      KLOCSU       I    Source number pointer in input data.
C      KLOCWT       I    Weight pointer for compressed data.
C      NDECMP       I    Number of entries in DECMP
C      DECMP    I(2,*)   (1,*) = number of packed correlator values
C                        (2,*) = 0-rel offset in vis data.
C                        (from beginning of vis data NOT ran. parms.)
C      DOFQSL       L    If true, FREQSEL random parameter is present
C      FRQSEL       I    FQ entry to pass.
C   Input/output:
C      TIMLST       R    Time of last record
C   Output:
C      RPARM(*)   R    Random parameter array
C      VIS(3,*)   R    Visibility array
C      IERR       I    Return code, 0=OK, else UVDISK error number.
C   Output to common /SELCAL/:
C      FSTVS3       I    Actual vis record number
C      FSTVIS       I    First word pointer of current buffer.
C      LSTVIS       I    Last word pointer of current buffer.
C      CURSOU       I    Current source number.
C     MRC 89/Sep/19: Ensure IERR is reset to 0.
C-----------------------------------------------------------------------
      INTEGER   IERR
      REAL      RPARM(*), VIS(3,*), TIMLST
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NUMAX, NIO, BIND, IBUFF(1024), IA1, IA2, IRET, TIMKOL,
     *   INTKOL, SOUKOL, SUBKOL, FRSKOL, LSTKOL, FRQKOL, RECI(MAXNXC),
     *   IUBIND, CURSUB, THSOUR, CMPNT, CMPNT2, FREQRP, NREAD, BO, I,
     *   LIMT, J, ISUBA, JJ, ICORID
      LOGICAL   DROP, T, F, MATCH, MAT1, MAT2, BADTIM
      REAL      RECORD(MAXNXC), TIME, TMINT
      INTEGER   TBUFSZ
      PARAMETER (TBUFSZ = MAXCIF * 3)
      REAL      TBUFF(TBUFSZ)
      SAVE      TBUFF, RECORD
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      INCLUDE 'INCS:DPDC.INC'
      EQUIVALENCE (RECORD, RECI)
      EQUIVALENCE (IBUFF, NXBUFF)
      EQUIVALENCE (NXKOLS, TIMKOL), (NXKOLS(2), INTKOL),
     *   (NXKOLS(3), SOUKOL), (NXKOLS(4), SUBKOL), (NXKOLS(5), FRSKOL),
     *   (NXKOLS(6), LSTKOL), (NXKOLS(7), FRQKOL)
      SAVE BADTIM
      DATA BADTIM /.FALSE./
      DATA T, F /.TRUE.,.FALSE./
      DATA BO /1/
C-----------------------------------------------------------------------
      IERR = 0
      TIME = -1.0E10
      IF (TYPUVD.GT.0) DOACOR = .TRUE.
 10   FSTVIS = FSTVIS + LRECIN
      RECNO3 = RECNO3 + 1
      IF (FSTVIS.GT.LSTVIS) THEN
C                                       Check expansion buffer size
         IF ((LRECIN.GT.TBUFSZ) .AND. ISCMP) THEN
            MSGTXT = 'DATGET: DATA EXPANSION BUFFER IS TOO SMALL'
            IERR = 5
            GO TO 990
            END IF
C                                       Read next buffer load.
         CALL UVDISK ('READ', IULUN, IUFIND, UBUFF, NIO, BIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR
            GO TO 990
            END IF
C                                       Check for end of scan
         IF (NIO.LE.0) GO TO 200
            FSTVIS = BIND
            LSTVIS = FSTVIS + (NIO-1) * LRECIN
C                                       See which records selected;
C                                       UBUFF(BIND)='INDE' => not wanted
C                                       Check freq random parm
            IF (DOFQSL .AND. (FRQSEL.GT.0)) THEN
               BIND = FSTVIS
      INCLUDE 'INCS:ZVND.INC'
               DO 15 I = 1,NIO
                  FREQRP = UBUFF(BIND+KLOCFQ)
                  IF (FREQRP.NE.FRQSEL) UBUFF(BIND) = FBLANK
                  BIND = BIND + LRECIN
 15               CONTINUE
               END IF
C                                       Check timerange
            BIND = FSTVIS
      INCLUDE 'INCS:ZVND.INC'
            DO 20 I = 1,NIO
               TIME = UBUFF(BIND+ILOCT)
               IF ((TIME.LT.TSTART) .OR. (TIME.GT.TEND))
     *            UBUFF(BIND) = FBLANK
               BIND = BIND + LRECIN
 20            CONTINUE
C                                       Check subarray
            BIND = FSTVIS
            IF (SUBARR.GT.0) THEN
      INCLUDE 'INCS:ZVND.INC'
               DO 40 I = 1,NIO
                  IF (ILOCB.GE.0) THEN
                     IA1 = UBUFF(BIND+ILOCB) + 0.1
                     CURSUB = 1.5 + 100.0 * (UBUFF(BIND+ILOCB) - IA1)
                  ELSE
                     CURSUB = UBUFF(BIND+ILOCSA) + 0.1
                     END IF
                  IF (CURSUB.NE.SUBARR) UBUFF(BIND) = FBLANK
                  BIND = BIND + LRECIN
 40               CONTINUE
               END IF
C                                       Check autocorrelations or
C                                       crosscorrelations
            BIND = FSTVIS
            IF ((.NOT.DOACOR) .OR. (.NOT.DOXCOR)) THEN
               DO 45 I = 1,NIO
                  IF (ILOCB.GE.0) THEN
                     IA1 = UBUFF(BIND+ILOCB) / 256.0 + 0.1
                     IA2 = UBUFF(BIND+ILOCB) - 256 * IA1 + 0.1
                  ELSE
                     IA1 = UBUFF(BIND+ILOCA1) + 0.1
                     IA2 = UBUFF(BIND+ILOCA2) + 0.1
                     END IF
                  IF ((.NOT.DOACOR) .AND. (IA1.EQ.IA2))
     *               UBUFF(BIND) = FBLANK
                  IF ((.NOT.DOXCOR) .AND. (IA1.NE.IA2))
     *               UBUFF(BIND) = FBLANK
                  BIND = BIND + LRECIN
 45               CONTINUE
               END IF
C                                       Check antennas
            BIND = FSTVIS
            IF (NANTSL.GT.0) THEN
               DO 60 I = 1,NIO
                  IF (ILOCB.GE.0) THEN
                     IA1 = UBUFF(BIND+ILOCB) / 256.0 + 0.1
                     IA2 = UBUFF(BIND+ILOCB) - 256 * IA1 + 0.1
                  ELSE
                     IA1 = UBUFF(BIND+ILOCA1) + 0.1
                     IA2 = UBUFF(BIND+ILOCA2) + 0.1
                     END IF
                  MAT1 = F
                  MAT2 = F
                  DO 50  J = 1,NANTSL
                     MAT1 = MAT1 .OR. (IA1.EQ.ABS(ANTENS(J)))
                     MAT2 = MAT2 .OR. (IA2.EQ.ABS(ANTENS(J)))
 50                  CONTINUE
C                                       Check for match selected.
                  IF (DOAWNT .AND. (MAT1.AND.MAT2)) GO TO 55
C                                       Check for match excluded
                  IF (.NOT.DOAWNT .AND. (MAT1.OR.MAT2))
     *               UBUFF(BIND) = FBLANK
C                                       If inclusion flag
                  IF (DOAWNT) UBUFF(BIND) = FBLANK
 55               BIND = BIND + LRECIN
 60               CONTINUE
               END IF
C                                       Check source
            BIND = FSTVIS
            IF ((NSOUWD.GT.0) .AND. (KLOCSU.GE.0)) THEN
               DO 100 I = 1,NIO
                  THSOUR = UBUFF(BIND+KLOCSU) + 0.5
                  IF ((THSOUR.EQ.CURSOU) .OR. (CURSOU.EQ.0)) GO TO 90
                  IF ((NSOUWD.EQ.1) .AND. (THSOUR.NE.CURSOU)) THEN
                     UBUFF(BIND) = FBLANK
                     GO TO 90
                     END IF
C                                       loop thru list
                  DO 70 J = 1,NSOUWD
                     IF (THSOUR.EQ.SOUWAN(J)) GO TO 80
 70                  CONTINUE
C                                       Not in list
                  IF (.NOT.DOSWNT) GO TO 90
                     UBUFF(BIND) = FBLANK
                     GO TO 90
C                                       In list
 80               IF (DOSWNT) GO TO 90
                     UBUFF(BIND) = FBLANK
 90               BIND = BIND + LRECIN
 100              CONTINUE
               END IF
         END IF
C                                       Check if wanted
      FSTVS3 = FSTVS3 + 1
      IF (UBUFF(FSTVIS).EQ.FBLANK) GO TO 10
      BIND = FSTVIS
      TIME = UBUFF(BIND+ILOCT)
      IF (ILOCB.GE.0) THEN
         IA1 = UBUFF(BIND+ILOCB) / 256.0 + 0.1
         IA2 = UBUFF(BIND+ILOCB) - 256 * IA1 + 0.1
         JJ = UBUFF(BIND+ILOCB) + 0.01
         ISUBA = 1.1 + 100.0 * (UBUFF(BIND+ILOCB) - JJ)
      ELSE
         IA1 = UBUFF(BIND+ILOCA1) + 0.1
         IA2 = UBUFF(BIND+ILOCA2) + 0.1
         ISUBA = UBUFF(BIND+ILOCSA) + 0.1
         END IF
C                                       Correlation id.
      IF (ILOCID.GE.0) THEN
         ICORID = UBUFF(BIND+ILOCID) + 0.1
      ELSE
         ICORID = 1
         END IF
C                                       Set integration time for
C                                       rate smearing correction:
C                                       default of 1 sec.
      IF (DXTIME.LE.0.0) THEN
         IF (ILOCIT.GE.0) THEN
            TMINT = UBUFF(BIND+ILOCIT) / 86400.0
         ELSE
            TMINT = 1.0 / 86400.0
            END IF
      ELSE
         TMINT = DXTIME
         END IF
      DORSM = (DXTIME.GE.0.0)
C                                       See if time order important
      IF (((DOCAL) .OR. (DOBL) .OR. (DOBAND.GT.1) .OR. (DOFLAG)) .AND.
     *   (TIMORD)) THEN
C                                       Trap aginst going backwards in
C                                       time.
         IF (TIME.LT.TIMLST) THEN
            MSGTXT = 'WARNING: TIMES OUT OF ORDER, DATA LOST'
            IF (.NOT.BADTIM) CALL MSGWRT (8)
            BADTIM = .TRUE.
            GO TO 10
            END IF
         IF (TIME.GT.TEND) GO TO 200
         TIMLST = TIME
         END IF
C                                       Copy to output
      DO 110 I = 1,NRPARM
         RPARM(I) = UBUFF(BIND+I-1)
 110     CONTINUE
      IF (ISCMP) THEN
C                                       Compressed data - decompress
         DO 120 I = 1,NDECMP
            CMPNT = BIND + NPRMIN + DECMP(2,I)
            CMPNT2 = 1 + DECMP(2,I) * 3
            CALL ZUVXPN (DECMP(1,I), UBUFF(CMPNT), UBUFF(BIND+KLOCWT),
     *         TBUFF(CMPNT2))
 120         CONTINUE
C                                       Do flagging
         DROP = F
         IF (DOUVRA) THEN
            CALL DATUVR (RPARM, TBUFF, DROP, IERR)
            IF (IERR.NE.0) GO TO 999
            IF (DROP) GO TO 10
            END IF
         IF (DOFLAG) THEN
            CALL DATFLG (RPARM, TBUFF, DROP, IERR)
            IF (IERR.NE.0) GO TO 999
            IF (DROP) GO TO 10
            END IF
C                                       Calibrate
         IF (DOCAL .OR. DOBL) THEN
            CALL DATCAL (IA1, IA2, ISUBA, ICORID, TIME, TMINT, TBUFF,
     *         DROP, IERR)
            IF (IERR.NE.0) GO TO 999
            IF (DROP) GO TO 10
            END IF
C                                       Convolve with smoothing function
         IF (DOSMTH.EQ.1) THEN
            CALL SMOSP (TBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
C                                       Bandpass correction
         IF (DOBAND.GT.0) THEN
            CALL DATBND (TIME, IA1, IA2, TBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
C                                       Polarization correction
         IF (DOPOL.GT.0) THEN
            CALL DATPOL (IA1, IA2, TIME, TBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
         ELSE IF (TRXYQU.GT.0) THEN
            CALL DATPAR (TIME, ISUBA, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
C                                       Convolve with smoothing function
         IF (DOSMTH.EQ.2) THEN
            CALL SMOSP (TBUFF, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         NUMAX = 3
C                                       Get data in correct Stokes form.
         IF (TRXYQU.GT.0) THEN
            CALL DVHGET (TBUFF, NUMAX, IA1, IA2, VIS, DROP)
         ELSE
            CALL DGGET (TBUFF, NUMAX, TRANSL, MVIS, JADR, SELFAC, ALLWT,
     *         VIS, DROP)
            END IF
         IF (DROP) GO TO 10
C                                       Uncompressed data
      ELSE
C                                       Do flagging
         DROP = F
         IF (DOUVRA) THEN
            CALL DATUVR (RPARM, UBUFF(BIND+NPRMIN), DROP, IERR)
            IF (IERR.NE.0) GO TO 999
            IF (DROP) GO TO 10
            END IF
         IF (DOFLAG) THEN
            CALL DATFLG (RPARM, UBUFF(BIND+NPRMIN), DROP, IERR)
            IF (IERR.NE.0) GO TO 999
            IF (DROP) GO TO 10
            END IF
C                                       Calibrate
         IF (DOCAL .OR. DOBL) THEN
            CALL DATCAL (IA1, IA2, ISUBA, ICORID, TIME, TMINT,
     *         UBUFF(BIND+NPRMIN), DROP, IERR)
            IF (IERR.NE.0) GO TO 999
            IF (DROP) GO TO 10
            END IF
C                                       Convolve with smoothing function
         IF (DOSMTH.EQ.1) THEN
            CALL SMOSP (UBUFF(BIND+NPRMIN), IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
C                                       Bandpass correction
         IF (DOBAND.GT.0) THEN
            CALL DATBND (TIME, IA1, IA2, UBUFF(BIND+NPRMIN), IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
C                                       Polarization correction
         IF (DOPOL.GT.0) THEN
            CALL DATPOL (IA1, IA2, TIME, UBUFF(BIND+NPRMIN), IERR)
            IF (IERR.NE.0) GO TO 999
         ELSE IF (TRXYQU.GT.0) THEN
            CALL DATPAR (TIME, ISUBA, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
C                                       Convolve with smoothing function
         IF (DOSMTH.EQ.2) THEN
            CALL SMOSP (UBUFF(BIND+NPRMIN), IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         NUMAX = CATUV(KINAX)
C                                       Get data in correct Stokes form.
         IF (TRXYQU.GT.0) THEN
            CALL DVHGET (UBUFF(BIND+NPRMIN), NUMAX, IA1, IA2, VIS, DROP)
         ELSE
            CALL DGGET (UBUFF(BIND+NPRMIN), NUMAX, TRANSL, MVIS, JADR,
     *         SELFAC, ALLWT, VIS, DROP)
            END IF
         IF (DROP) GO TO 10
         END IF
      GO TO 999
C                                       New scan.
C                                       Find next in INDEX file.
 200  IERR = 4
C                                       Check if INDEX file used.
      IF (INXRNO.LE.0) GO TO 999
      IF (INXRNO.GT.NINDEX) GO TO 999
C                                       See if time range exhausted.
      IF (TIME.GT.TEND) GO TO 999
C                                       Loop through records
      LIMT = INXRNO
      DO 260 I = LIMT,NINDEX
         INXRNO = I
         IERR = 1
C                                       Read record.
         CALL TABIO ('READ', 0, INXRNO, RECORD, IBUFF, IRET)
C                                       Check if flagged
         IF (IRET.LT.0) GO TO 260
C                                       Check error
         IF (IRET.GT.0) GO TO 999
         IERR = 0
C                                       Check time range.
         IF (TSTART.GT.(RECORD(TIMKOL)+RECORD(INTKOL))) GO TO 260
C                                       Check subarray
         IF ((SUBARR.GT.0) .AND. (RECI(SUBKOL).NE.SUBARR) .AND.
     *      (RECI(SUBKOL).GT.0)) GO TO 260
C                                       Check freq id
         IF ((FRQSEL.GT.0) .AND. (RECI(FRQKOL).NE.FRQSEL) .AND.
     *      (RECI(FRQKOL).GT.0)) GO TO 260
C                                       Set values
         FSTVIS = RECI(FRSKOL)
         LSTVIS = RECI(LSTKOL)
         IF (LSTVIS.LT.FSTVIS) GO TO 260
         CURSOU = RECI(SOUKOL)
C                                       See if all sources selected.
         IF (NSOUWD.LE.0) GO TO 300
C                                       Search source lists
         DO 240 J = 1,NSOUWD
            MATCH = RECI(SOUKOL) .EQ. SOUWAN(J)
            IF (MATCH) GO TO 250
 240        CONTINUE
C                                       See if found match
 250     IF ((MATCH.AND.DOSWNT) .OR. ((.NOT.MATCH).AND.(.NOT.DOSWNT)))
     *    GO TO 300
 260     CONTINUE
C                                       No more data selected.
      IERR = 4
      GO TO 999
C                                       Init I/O to uvfile
 300  INXRNO = INXRNO + 1
      NREAD = LSTVIS - FSTVIS + 1
      FSTRED = FSTVIS - 1
      RECNO3 = FSTRED
      NREAD3 = NREAD
      FSTRD3 = FSTRED
      FSTVS3 = FSTVIS - 1
      LSTVS3 = LSTVIS
      FSTVIS = 0
      LSTVIS = 0
      BIND = 0
      DOUVIN = T
      CALL UVINIT ('READ', IULUN, IUFIND, NREAD, FSTRED, LRECIN, BIND,
     *   UBUFSZ, UBUFF, BO, IUBIND, IERR)
      LENBU3 = BIND
      IF (IERR.LE.0) GO TO 10
         WRITE (MSGTXT,1300) IERR
         GO TO 990
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('DATGET: ERROR',I3,' READING UV DATA')
 1300 FORMAT ('DATGET: ERROR',I3,' INITIALIZING I/O TO UV DATA')
      END

      SUBROUTINE ZTFILL (FIND, MAP)
C-----------------------------------------------------------------------
C! zero-fill, initialize a file IO table (FTAB) entry
C# IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZTFILL fills in initial values in the FTAB file control block.
C   Inputs:
C      FIND   I   Index in FTAB to file control block
C      MAP    L   Map file indicator
C   Common: via DDCH.INC
C      FTAB   I(*)   input:  FTAB(FIND) = LUN
C                    output: FTAB(FIND+1...) = ? whatever is needed
C   Generic version - zeros the table.
C-----------------------------------------------------------------------
      INTEGER   FIND
      LOGICAL   MAP
C
      INTEGER   IFTAB, NFTAB
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       FCB size.
      NFTAB = NBTB2 / 2
      IF (MAP) NFTAB = NBTB3 / 2
      NFTAB = NFTAB - 1
C                                       init FCB.
      DO 10 IFTAB = 1,NFTAB
         FTAB(FIND+IFTAB) = 0
 10      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ZACTV8 (NAME, INPOPS, RVERSN, PID, IERR)
C-----------------------------------------------------------------------
C! activate the requested program, returning process ID information
C# Z System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Activate the specified program and return the activated process
C   identification information.
C   Inputs:
C      NAME     C*6    Program name
C      INPOPS   I      POPS # for the task to use
C      RVERSN   C*(*)  Logical name or fully qualified name of the
C                      directory from which to get the required
C                      executable module
C   In/Out:
C      PID      I(4)   Process identification information used directly
C                      by subsequent calls to ZTACTQ where
C                      In:  PID(1)   = user number for systems that use
C                                      it (= 0 otherwise and on all
C                                      AIPSB invocations)
C                      Out: PID(2-4) = process ID number(s) as needed
C   Output:
C      IERR     I      Error return code: 0 => no error
C                         1 => program name too long
C                         2 => activation error
C   Common: DMSG.INC
C      DBGAIP   I      > 10 => start tasks in DEBUG mode if possible
C   Generic UNIX version (since VERSION is converted to uppercase by
C   AIPS, RVERSN can only be a literal directory name if it is all
C   uppercase).  Relatively generic over all, but uses "/" everywhere to
C   build file and path names.
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), RVERSN*(*)
      INTEGER   INPOPS, PID(4), IERR
C
      INTEGER   ALTX, ELEN, FLEN, I, IALT(3), IDBG, ITRIM, J, LARCHX,
     *   NALT, PLEN, SYSERR, TVALT, VLEN, XLEN, XLNB, JT, JTRIM
      LOGICAL   EXIST
      CHARACTER CARCHX*40, CVERSN*256, EXENAM*9, FULNAM*256, PNAME*6,
     *   XLATED*256
      HOLLERITH HPNAME(2), HFULNM(64)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Build process name = task name
C                                       with POPS # suffix.
      CALL BLDTNM (NAME, INPOPS, PNAME, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) NAME
         GO TO 995
         END IF
C                                       Get logical name ARCH for
C                                       architecture (SUN4, DEC, etc)
      CALL ZTRLOG (4, 'ARCH', 40, CARCHX, LARCHX, IERR)
      IF (IERR.NE.0) THEN
         IERR = 2
         WRITE (MSGTXT,1990)
         CALL MSGWRT (8)
         WRITE (MSGTXT,1991) 'ARCH'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Translate TVALT.
      XLEN = LEN (XLATED)
      CALL ZTRLOG (5, 'TVALT', XLEN, XLATED, XLNB, IERR)
      IF (IERR.NE.0) THEN
         IERR = 2
         WRITE (MSGTXT,1990)
         CALL MSGWRT (6)
         WRITE (MSGTXT,1991) 'TVALT'
         CALL MSGWRT (6)
         WRITE (MSGTXT,1010)
         CALL MSGWRT (6)
         TVALT = 0
      ELSE IF ((XLATED(1:5).NE.'TVALT') .OR. (XLNB.NE.7)) THEN
         JT = JTRIM (XLATED(:XLNB))
         WRITE (MSGTXT,1020) XLATED(:JT)
         CALL MSGWRT (7)
         WRITE (MSGTXT,1010)
         CALL MSGWRT (7)
         TVALT = 0
      ELSE
         READ (XLATED(6:6), 1030, IOSTAT=SYSERR) TVALT
         IF (SYSERR.NE.0 .OR. MOD(TVALT,2).EQ.1) THEN
            JT = JTRIM (XLATED(:XLNB))
            WRITE (MSGTXT,1020) XLATED(:JT)
            CALL MSGWRT (7)
            WRITE (MSGTXT,1010)
            CALL MSGWRT (7)
            TVALT = 0
            END IF
         END IF
C                                       Determine full name of .EXE
      ELEN = ITRIM (NAME)
      EXENAM = NAME(1:ELEN) // '.EXE'
C                                       If blank, use VERNAM.
      CVERSN = RVERSN
C     IF (CVERSN.EQ.' ' .OR. CVERSN.EQ.'LOCAL') CVERSN = VERNAM
      IF (CVERSN.EQ.' ') CVERSN = VERNAM
      VLEN = ITRIM (CVERSN)
C                                       Version name: VMSism
      IF (CVERSN(VLEN:VLEN).EQ.':') THEN
         CVERSN(VLEN:VLEN) = ' '
         VLEN = VLEN - 1
         END IF
C                                       Determine fully qualified name
C                                       of executable module.
C                                       Standard logicals
      IF ((CVERSN(1:4).EQ.'TST ') .OR. (CVERSN(1:4).EQ.'NEW ') .OR.
     *   (CVERSN(1:4).EQ.'OLD ') .OR. (CVERSN(1:4).EQ.'CVX ') .OR.
     *   (CVERSN(1:6).EQ.'LOCAL ')) THEN
         IF (TVALT.EQ.0) THEN
            NALT = 1
            IALT(1) = 0
         ELSE
            NALT = 2
            IALT(1) = TVALT
            IALT(2) = 0
            END IF
         CALL ZTRLOG (VLEN, CVERSN, XLEN, XLATED, XLNB, IERR)
         IF (IERR.NE.0) GO TO 990
         FULNAM = XLATED(1:XLNB) // '/' // CARCHX(1:LARCHX) //
     *      '/LOAD/ALTx/' // EXENAM
         ALTX = INDEX (FULNAM, 'ALTx') + 3
C                                       pseudo AP tasks
      ELSE IF ((CVERSN(1:8).EQ.'TSTPSAP ') .OR. (CVERSN(1:8).EQ.
     *   'NEWPSAP ') .OR. (CVERSN(1:8).EQ.'OLDPSAP ') .OR.
     *   (CVERSN(1:8).EQ.'CVXPSAP ')) THEN
         IF (TVALT.EQ.0) THEN
            NALT = 2
            IALT(1) = 1
            IALT(1) = 0
         ELSE
            NALT = 3
            IALT(1) = TVALT + 1
            IALT(2) = TVALT
            IALT(3) = 0
            END IF
         CVERSN(4:) = ' '
         VLEN = 3
         CALL ZTRLOG (VLEN, CVERSN, XLEN, XLATED, XLNB, IERR)
         IF (IERR.NE.0) GO TO 990
         FULNAM = XLATED(1:XLNB) // '/' // CARCHX(1:LARCHX) //
     *      '/LOAD/ALTx/' // EXENAM
         ALTX = INDEX (FULNAM, 'ALTx') + 3
C                                       Some other logical.
      ELSE IF (INDEX (CVERSN, '/').EQ.0) THEN
         NALT = 1
         IALT(1) = 0
         ALTX = 0
         CALL ZTRLOG (VLEN, CVERSN, XLEN, XLATED, XLNB, IERR)
         IF (IERR.NE.0) GO TO 990
         FULNAM = XLATED(1:XLNB) // '/' // EXENAM
C                                       Literal path name.
      ELSE
         NALT = 1
         IALT(1) = 0
         ALTX = 0
         I = INDEX (CVERSN, ' ') - 1
         IF (I.LE.0) I = LEN (CVERSN)
         FULNAM = CVERSN(1:I) // '/' // EXENAM
         END IF
C                                       Cycle through standard areas
C                                       looking for executable module.
      DO 40 I = 1, NALT
         J = IALT(I)
C                                       Fill in 'x' in ALTx or eliminate
C                                       ALTx based on J
         IF (ALTX.GT.0) THEN
            IF (J.GT.0) CALL ZEHEX (J, 1, FULNAM(ALTX:ALTX))
            IF (J.EQ.0) FULNAM = XLATED(1:XLNB) // '/' //
     *         CARCHX(1:LARCHX) // '/LOAD/' // EXENAM
            END IF
         INQUIRE (FILE=FULNAM, EXIST=EXIST)
         IF (EXIST) GO TO 50
 40      CONTINUE
C                                       Could not find executable
      IERR = 1
      WRITE (MSGTXT,1040) NAME
      CALL MSGWRT (7)
      WRITE (MSGTXT,1041) CVERSN(1:VLEN)
      GO TO 995
C                                       Activate the program.
 50   FLEN = ITRIM (FULNAM)
      PLEN = ITRIM (PNAME)
      IF (DBGAIP.LE.10) THEN
         IDBG = 0
      ELSE
         IDBG = 1
         END IF
C                                       call C here
      CALL CHR2H (FLEN, FULNAM, 1, HFULNM)
      CALL CHR2H (PLEN, PNAME, 1, HPNAME)
      CALL ZACTV9 (FLEN, HFULNM, PLEN, HPNAME, IDBG, PID, SYSERR, IERR)
      IF (IERR.EQ.0) THEN
         IF ((J/2)*2.NE.J) THEN
            WRITE (MSGTXT,1050)
            CALL MSGWRT (2)
            END IF
C                                       ZACTV9 now does zerror messages
      ELSE
CCC         CALL ZERROR ('ZACTV9', SYSERR, ' ', -999, F)
         IERR = 2
         END IF
      GO TO 999
C                                       version not found
 990  IERR = 2
      WRITE (MSGTXT,1990)
      CALL MSGWRT (7)
      WRITE (MSGTXT,1991) CVERSN
C
 995  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZACTV8: TASK NAME',A6,' TOO LONG')
 1010 FORMAT ('ZACTV8: Assuming ALT0.')
 1020 FORMAT ('ZACTV8: Invalid TVALT: ',A)
 1030 FORMAT (I1)
 1040 FORMAT ('ZACTV8: TASK ',A6,' DOES NOT EXIST IN')
 1041 FORMAT ('ZACTV8: VERSION = ',A)
 1050 FORMAT ('Starting up pseudo-AP version')
 1990 FORMAT ('ZACTV8: COULD NOT TRANSLATE LOGICAL =')
 1991 FORMAT ('ZACTV8: ',A)
      END

LOCAL INCLUDE 'VHDIF.INC'
      INTEGER   MAXSOU, MAXCAL
      PARAMETER (MAXSOU = 100)
      PARAMETER (MAXCAL = 30)
      INCLUDE 'INCS:PUVD.INC'
C
      CHARACTER NAMEIN*12, CLAIN*6, XSOUR(30)*16, XCALCO*4, LPNAME*48,
     *   LINE*132, TITL1*132,TITL2*132, SCRTCH*132, CSNAME(MAXCAL)*16
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOURC(4,30), XXCALC(1),
     *   XLPNAM(12)
      DOUBLE PRECISION  FREQSO(MAXIF,MAXCAL), CALFRQ(MAXCHA,4)
      REAL      XSIN, XDISIN, XTIME(8), XBAND, XFREQ, XFQID, XBIF, XEIF,
     *   XBCHAN, XECHAN, XANT(50), XUVRA(2), XSUBA, XDOCAL, XGUSE,
     *   XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH(3),
     *   DOINV, SOLINT, DOKEEP, XCHNS(4,20), DOAPLY, DOLINE, XINTP(3),
     *   DOCRT, XBADD(10), RPARM(20), VIS(3,MAXCIF), FRQCRP,
     *   FINC(MAXIF), CALQU(2,MAXCHA,4)
      LOGICAL   ISNXT, SINGLE
      INTEGER   DISKIN, SEQIN, CNOIN, BUFFER(512), LUNP, FINDP, NACROS,
     *   IPCNT, PAGE, IDOCRT, VSOUID(MAXSOU), VCALID(MAXCAL), NVCAL,
     *   VCALKK(MAXCAL), LBCHAN, LECHAN, NCAL(4), OPDVER, PPVER, OBPVER,
     *   SNVER, OCLVER
C
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOURC, XXCALC,
     *   XTIME, XBAND, XFREQ, XFQID, XBIF, XEIF, XBCHAN, XECHAN, XANT,
     *   XUVRA, XSUBA, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG,
     *   XDOBND, XBPVER, XSMOTH, DOINV, SOLINT, DOKEEP, XCHNS, DOAPLY,
     *   DOLINE, XINTP, DOCRT, XLPNAM, XBADD
      COMMON /CHPARM/ NAMEIN, CLAIN, XSOUR, XCALCO, LPNAME, LINE, TITL1,
     *   TITL2, SCRTCH, CSNAME
      COMMON /INFOLS/ FREQSO, CALFRQ, RPARM, VIS, ISNXT, DISKIN, SEQIN,
     *   CNOIN, BUFFER, NACROS, IPCNT, PAGE, LUNP, FINDP, IDOCRT, NVCAL,
     *   SINGLE, VSOUID, VCALID, VCALKK, FRQCRP, FINC, LBCHAN, LECHAN,
     *   CALQU, NCAL, OPDVER, PPVER, OBPVER, SNVER, OCLVER
LOCAL END
      PROGRAM VHDIF
C-----------------------------------------------------------------------
C! VHDIF returns the V - H linear polarization phase difference
C# Calibration UV VLA VLB polarization
C-----------------------------------------------------------------------
C;  Copyright (C) 2018-2019, 2021-2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task VHDIF prints data from uv data files in a variety of forms.
C   Inputs:
C      AIPS Adverb   Prg. Name          Description
C      INNAME         NAME          File name to be listed.
C      INCLASS        CLASS         File class to be listed.
C      INSEQ          SEQ           File sequence number.
C      INDISK         DISK          Disk volumn on which file resides.
C      SOURCES        XSOUR(4,30)   Sources selected
C      CALCODE        XCALCO        Calibrator source code
C      TIMERANG       XTIME(8)      Timerange
C      BIF            BIF           IF number
C      BCHAN          BCHAN         Channel number
C      ANTENNAS       XANT(50)      Antenna numbers
C      UVRANGE        UVRANG        Range of UV in 1000's wavelengths
C      SUBARRAY       SUBARR        Subarray
C      DOCALIB        DOCAL         Calibrate?
C      GAINUSE        GAUSE         CL version to apply.
C      FLAGVER        FGVER         Flag table version
C      DOBAND                       Bandpass calibrate?
C      BPVER                        BP table to apply
C      SMOOTH                       Smoothing function
C      DOCRT          DOCRT         > 0 => use CRT, else line printer
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER PRGM*6
      INTEGER   IRET, IERR, IB, IE, NIF, NWORDS, NCH, NGOOD
      REAL      PDIF, CLCORP(20), PERR, PDCOR(2), PCLCOR(3*MAXIF)
      DOUBLE PRECISION DPDCOR(2)
      LONGINT   PPDCOR, PDPDC
      LOGICAL   NOW
      EQUIVALENCE (DPDCOR, PDCOR)
      INCLUDE 'VHDIF.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA PRGM /'VHDIF '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL XHDIN (PRGM, IRET)
      IF (IRET.NE.0) THEN
         RQUICK = .FALSE.
         GO TO 990
         END IF
C                                       return quickly?
      CALL RFILL (20, 0.0, CLCORP)
      NOW = (DOAPLY.GT.0.0) .OR. (DOLINE.GT.0.0) .OR. (NVCAL.GT.1)
      NOW = NOW .AND. RQUICK
      IF (NOW) THEN
         CALL PTPARM (20, CLCORP, BUFFER, IERR)
         CALL RELPOP (IRET, BUFFER, IERR)
         END IF
      NGOOD = 0
C                                       List data - continuum method
C                                       can do > 1 cal source
      IF (DOLINE.LE.0.0) THEN
         NIF = EIF - BIF + 1
         IB = BIF
         IE = EIF
         CALL RFILL (3*MAXIF, 0.0, PCLCOR)
         DO 10 BIF = IB,IE
            WRITE (MSGTXT,1000) BIF
            CALL MSGWRT (2)
            CALL MATXUV (PDIF, PERR, IRET)
C            IF (IRET.NE.0) GO TO 990
            IF (IRET.EQ.0) THEN
               CLCORP(BIF-IB+1) = PDIF
               PCLCOR(BIF-IB+1) = PDIF
               PCLCOR(BIF-IB+1+NIF) = PERR
               PCLCOR(BIF-IB+1+2*NIF) = PERR
               NGOOD = NGOOD + 1
               END IF
 10         CONTINUE
         IF (NGOOD.GT.0) THEN
            DO 20 BIF = IB,IE
               WRITE (MSGTXT,1010) BIF, CLCORP(BIF-IB+1),
     *            PCLCOR(BIF-IB+1+NIF)
               CALL MSGWRT (5)
 20            CONTINUE
         ELSE
            MSGTXT = 'NO DATA FOUND FOR ALL IFS'
            CALL MSGWRT (8)
            IRET = 1
            END IF
C                                       Close printer
         IF (IDOCRT.NE.0) CALL LPCLOS (LUNP, FINDP, IPCNT, IERR)
C                                       apply
         IF ((DOAPLY.GT.0.0) .AND. (NGOOD.GT.0)) THEN
            FRQCRP = 1.0
            CALL CLAPPL (DISKIN, CNOIN, IB, IE, CLVER, SUBARR, PCLCOR,
     *         OCLVER, CATUV, IRET)
            CALL RFILL (20, 0.0, CLCORP)
         ELSE
            RQUICK = .FALSE.
            END IF
C                                       spectral line
      ELSE
         NIF = EIF - BIF + 1
         NCH = ECHAN - BCHAN + 1
         NWORDS = (11 * NIF * NCH * 2 + 4095) / 1024 + 1
         CALL ZMEMRY ('GET ', 'VHDIFL', NWORDS, PDCOR, PPDCOR, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'FAILED TO GET DYNAMIC MEMORY'
            CALL MSGWRT (8)
            GO TO 990
            END IF
         PDPDC = PPDCOR / 2
         CALL XHDLIN (NCH, NIF, DPDCOR(1+PDPDC), IRET)
         IF (IRET.NE.0) GO TO 990
         IF (DOCRT.GT.0.0) CALL XHDPRT (NCH, NIF, CSNAME, BIF, LBCHAN,
     *      LECHAN, CATUV, DOCRT, LPNAME, DPDCOR(1+PDPDC))
         CALL XHDSMT (NCH, NIF, LBCHAN, LECHAN, CATUV, XINTP, DOINV,
     *      DPDCOR(1+PDPDC))
         IF (DOCRT.LT.0.0) CALL XHDPRT (NCH, NIF, CSNAME, BIF, LBCHAN,
     *      LECHAN, CATUV, DOCRT, LPNAME, DPDCOR(1+PDPDC))
         IF (DOLINE.GT.0.0) CALL PPFILE (DISKIN, CNOIN, PPVER, BCHAN,
     *      BIF, SUBARR, FRQSEL, NCH, NIF, NUMIF, SNVER, XCHNS,
     *      DPDCOR(1+PDPDC), CATUV, IRET)
         IF (DOAPLY.GT.0.0) THEN
            CALL BPAPPL (DISKIN, CNOIN, BCHAN, BIF, BPVER, PDVER,
     *         SUBARR, FRQSEL, NCH, NIF, OPDVER, OBPVER,
     *         DPDCOR(1+PDPDC), CATUV, IRET)
            END IF
         CALL RFILL (20, 0.0, CLCORP)
         END IF
C                                       return adverbs
      IF (.NOT.RQUICK) CALL PTPARM (20, CLCORP, BUFFER, IERR)
C                                       History file ??
      IF (IRET.EQ.0) CALL XHDHI (NCH, NIF, BIF, EIF, CLCORP, PCLCOR)
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('Doing IF',I3)
 1010 FORMAT ('IF',I3,' avg XY phase',F8.3,' +-',F8.3)
      END
      SUBROUTINE XHDIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   XHDIN gets input parameters for VHDIF
C   Inputs:
C      PRGN    C*6       Program name (2 chars/word)
C   Output:
C      IRET    I         Error code: 0 => ok
C                           5 => catalog troubles
C                           8 => can't start
C   Commons:
C      /INPARM/ all input adverbs in order given by INPUTS file
C      /MAPHDR/ output file catalog header
C   See prologue comments in VHDIF for more details.
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   IRET
C
      CHARACTER STAT*4, STATUS*4, UTYPE*2
      INTEGER   IROUND, NPARM, IERR, I, LUN, NIF, IIVER, J, IDUM(2)
      HOLLERITH HDUM(2)
      REAL      CATR(256), DUM(2)
      LOGICAL   F, TABLE, EXIST, FITASC, MATCH
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ISBAND(MAXIF)
      DOUBLE PRECISION FOFF(MAXIF), BFREQ
      CHARACTER BNDCOD(MAXIF)*8
      EQUIVALENCE (IDUM, HDUM)
      INCLUDE 'VHDIF.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATR, CATBLK)
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      PPVER = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
C                                       Get input parameters.
      NPARM = 319
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFFER, IERR)
      IF ((IERR.NE.0) .OR. (NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   DOCRT = MIN (-1.0, DOCRT)
      RQUICK = RQUICK .AND. (DOCRT.LE.0.0)
      IF (IERR.NE.0) THEN
         RQUICK = .FALSE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (IRET.NE.0) GO TO 999
      IRET = 5
      IF (DOINV.GT.0.0) THEN
         DOINV = 180.0
      ELSE
         DOINV = 0.0
         END IF
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XXCALC, XCALCO)
      CALL H2CHR (48, 1, XLPNAM, LPNAME)
C                                       Calcode abreviations
      IF (XCALCO(1:2).EQ.'CA') XCALCO = '*   '
      IF (XCALCO(1:1).EQ.'-')  XCALCO = '-CAL'
      SELCOD = XCALCO
      DO 25 I = 1,30
         CALL H2CHR (16, 1, XSOURC(1,I), XSOUR(I))
 25      CONTINUE
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      IDOCRT = IROUND (DOCRT)
      IF (DOCRT.GT.0.0) IDOCRT = MAX (1, IDOCRT)
C                                       Get CATBLK.
      CNOIN = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       READ or WRIT cause trouble
      STATUS = 'REST'
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, STATUS, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Mark in CFILES
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 0
C                                       Get uv header info.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
      BFREQ = FREQ
      FRQCRP = CATR(KRCRP+JLOCF)
      SINGLE = ILOCSU.LT.0
C                                       Check sort order
      IF (ISORT(1:1).NE.'T') THEN
         MSGTXT = 'YOUR DATA ARE NOT IN T* ORDER, USE UVSRT'
         IRET = 1
         GO TO 990
         END IF
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DO 70 I = 1,30
         SOURCS(I) = XSOUR(I)
 70      CONTINUE
      CALL RCOPY (8, XTIME, TIMRNG)
      UVRNG(1) = XUVRA(1)
      UVRNG(2) = XUVRA(2)
      BCHAN = IROUND (XBCHAN)
      BCHAN = MAX (1, MIN (BCHAN, CATBLK(KINAX+JLOCF)))
      ECHAN = IROUND (XECHAN)
      IF (ECHAN.LT.BCHAN) ECHAN = CATBLK(KINAX+JLOCF)
      ECHAN = MAX (1, MIN (ECHAN, CATBLK(KINAX+JLOCF)))
      IF (DOLINE.GT.0.0) THEN
         LBCHAN = BCHAN
         LECHAN = ECHAN
         BCHAN = 1
         ECHAN = CATBLK(KINAX+JLOCF)
         END IF
      IF (JLOCIF.GE.0) THEN
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, CATBLK(KINAX+JLOCIF)))
         EIF = IROUND (XEIF)
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         EIF = MAX (1, MIN (EIF, CATBLK(KINAX+JLOCIF)))
         IF ((EIF-BIF.GT.19) .AND. (DOAPLY.LE.0.0) .AND.
     *      (DOLINE.LE.0.0)) THEN
            MSGTXT = 'EIF LIMITED TO BIF+19 BY CLCORPRM'
            CALL MSGWRT (7)
            EIF = BIF+19
            END IF
      ELSE
         BIF = 1
         EIF = 1
         END IF
C                                       Antennas
      DO 60 I = 1,50
         ANTENS(I) = IROUND (XANT(I))
 60      CONTINUE
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOPOL = IROUND (XDOPOL)
      IF ((DOPOL.EQ.0) .AND. (XDOPOL.GT.0.0)) DOPOL = 1
      IF (DOPOL.LE.0) THEN
         MSGTXT = '**************************************************'
         CALL MSGWRT (7)
         MSGTXT = '*** WARNING DOPOL FALSE - NOT THE NORMAL VALUE ***'
         CALL MSGWRT (7)
         MSGTXT = '**************************************************'
         CALL MSGWRT (7)
         END IF
      PDVER = IROUND (XPDVER)
      DOAPPL = F
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LE.0) SUBARR = 1
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
      DO 80 I = 1,10
         IBAD(I) = IROUND (XBADD(I))
 80      CONTINUE
      IRET = 0
C                                       List U, V
      STOKES = 'IQUV'
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      LUN = 28
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, IRET)
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1070)
         IRET = 1
         GO TO 990
         END IF
      IF (IRET.GT.0) GO TO 999
C                                       Get IF freq offset.
      LUN = 28
      IIVER = 1
      CALL CHNDAT ('READ', BUFFER, DISKIN, CNOIN, IIVER, CATBLK, LUN,
     *   NIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IERR)
      IF (IERR.GT.0) GO TO 999
C                                       See if index table
      CALL ISTAB ('NX', DISKIN, CNOIN, 1, LUN, BUFFER, TABLE, EXIST,
     *   FITASC, IERR)
      ISNXT = (.NOT.EXIST) .OR. (IERR.NE.0)
C                                       check UV data set exists,
C                                       set variables for PCLSOU
      CALL UVGET ('INIT', DUM, DUM, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL UVGET ('CLOS', DUM, DUM, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL FILL (MAXSOU, -1, VSOUID)
      IF (SINGLE) THEN
         NVCAL = 1
         VCALID(1) = 1
         VSOUID(1) = 1
         CALL COPY (2, CATUV(KHOBJ), IDUM)
         CALL H2CHR (8, 1, HDUM, CSNAME(1))
         CALL DFILL (NIF, 0.0D0, FREQSO)
      ELSE
         CALL XHDSOU (IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      DO 90 I = 1,NVCAL
         DO 85 J = 1,NUMIF
            FREQSO(J,I) = FREQSO(J,I) + BFREQ + FOFF(J)
 85         CONTINUE
 90      CONTINUE
      IF (NVCAL.LE.0) THEN
         MSGTXT = 'YOU MUST REQUEST SOME SOURCE!'
         IRET = 10
         GO TO 990
         END IF
      IF ((NVCAL.GT.1) .AND. (DOLINE.LE.0.0) .AND. (DOAPLY.LE.0.0)) THEN
         MSGTXT = 'CLCORPRM METHOD REQUIRES THERE TO BE ONLY 1 SOURCE'
         IRET = 10
         GO TO 990
         END IF
      IF (DOAPLY.LE.0.0) IRET = 0
      IF (IRET.NE.0) GO TO 999
C                                       Init printer
      PAGE = 0
      IPCNT = 980
      TITL1 = ' '
      TITL2 = ' '
      LINE = ' '
C                                       Open output device
      IF ((IDOCRT.NE.0) .AND. (DOLINE.LE.0.0)) THEN
         IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
         CALL LPOPEN (LPNAME, DOCRT, LUNP, FINDP, NACROS, BUFFER, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET
            IRET = 1
            GO TO 990
            END IF
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XHDIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
 1080 FORMAT ('XHDIN: ERROR ',I3,' OPENING OUTPUT ''PRINT'' DEVICE')
      END
      SUBROUTINE XHDSOU (IRET)
C-----------------------------------------------------------------------
C   Gets source info
C   Outputs:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'VHDIF.INC'
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4
      INTEGER   I, SUKOLS(MAXSUC), SUNUMV(MAXSUC), IDSOU, QUAL, SULUN,
     *   ISURNO, NUMSOU, LOOP, SUFQID
      DOUBLE PRECISION BANDW, RAEPO, DECEPO, EPOCH, RAAPP, DECAPP,
     *   PMRA, PMDEC, LSRVEL(MAXIF), FREQO(MAXIF), RESTFQ(MAXIF), RAOBS,
     *   DECOBS
      REAL     FLUX(4,MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA SULUN /27/
C-----------------------------------------------------------------------
      NVCAL = 0
C                                       Open source (SU) table
      CALL SOUINI ('READ', NXBUFF, DISKIN, CNOIN, 1, CATUV, SULUN,
     *   NUMIF, VELTYP, VELDEF, SUFQID, ISURNO, SUKOLS, SUNUMV, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Check FREQID compatibility.
      IF ((SUFQID.GT.0) .AND. (FRQSEL.GT.0) .AND. (SUFQID.NE.FRQSEL))
     *   THEN
         MSGTXT = 'WARNING - POTENTIALLY FATAL ERROR'
         CALL MSGWRT (6)
         WRITE (MSGTXT,1040) SUFQID
         CALL MSGWRT (6)
         WRITE (MSGTXT,1050) FRQSEL
         CALL MSGWRT (6)
         MSGTXT = '   Suggest you rerun SETJY with the correct FREQID'
         CALL MSGWRT (6)
         IRET = 5
         GO TO 999
         END IF
C                                       Get number of sources
      NUMSOU = NXBUFF(5)
C                                       Read flux array
      DO 50 LOOP = 1,NUMSOU
         ISURNO = LOOP
         CALL TABSOU ('READ', NXBUFF, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA,
     *      PMDEC, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET
            GO TO 990
            END IF
C                                       Save calibrator fluxes
C                                       See if wanted
         IF (NSOUWD.GT.0) THEN
            DO 20 I = 1,NSOUWD
               IF (IDSOU.EQ.SOUWAN(I)) GO TO 30
 20            CONTINUE
C                                       Not wanted
            GO TO 50
            END IF
C                                       Wanted
 30      IF (NVCAL.LT.MAXCAL) THEN
            NVCAL = NVCAL + 1
            VCALID(NVCAL) = IDSOU
            CSNAME(NVCAL) = SOUNAM
            VSOUID(IDSOU) = NVCAL
            DO 35 I = 1,NUMIF
               FREQSO(I,NVCAL) = FREQO(I)
 35            CONTINUE
C                                       Too many calibrators
         ELSE
            IRET = 10
            WRITE (MSGTXT,1035) MAXCAL
            GO TO 990
            END IF
 50      CONTINUE
C                                       Close table
      CALL TABIO ('CLOS', 0, ISURNO, NXBUFF, NXBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1070) IRET
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XHDSOU: ERROR',I3,' OPENING SOURCE TABLE')
 1010 FORMAT ('XHDSOU: ERROR',I3,' READING SOURCE TABLE')
 1040 FORMAT ('   Your calibrators have their fluxes set for FQID ',I3)
 1050 FORMAT ('   You are using them to calibrate FQID ',I3)
 1035 FORMAT ('XHDSOU: ERROR: TOO MANY CALIBRATORS, >',I4)
 1070 FORMAT ('XHDSOU: ERROR',I3,' CLOSING SOURCE TABLE')
      END
      SUBROUTINE MATXUV (PDIF, PERR, IRET)
C-----------------------------------------------------------------------
C   Gives matrix listings of scan averaged uv data.
C   Info for UVGET is set in XHDIN.
C   Output:
C      PDIF   R   R-L phase difference
C      PERR   R   Uncertainty
C      IRET   I   Return code, 0=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   IRET
      REAL      PDIF, PERR
C
      CHARACTER ENTRY*20, FRMAT(10)*5, FORM*5, CHLINE*132, CCODE*1,
     *   POLA1*3, POLA2*3, PART(2)*5
      INTEGER   TIME(8), NANT, NPASS, IPASS, IANTHI, IANTLO,
     *   NANTPP, IROW, ICOL, NCOLPV, COLPNT, IATY, IANT, MANT, I, J,
     *   IERR, I4TEMP, KQUAL, KANT, ISCAN, JSCAN
      LOGICAL   DONE
      REAL      CATR(256), SFACT, DT, AVGS(2,2), SCNAVG(200),
     *   SCNSIG(200)
      DOUBLE PRECISION    CATD(128), SFREQ, XV(2), SA(2), SW, W, SS(2),
     *   AVG, SIG(2)
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ANTLAB(MAXANT), IROUND
      REAL      SCANV(MAXANT,MAXANT), SCNMIN
      INCLUDE 'VHDIF.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (CATBLK, CATR, CATD)
      DATA FRMAT /'(I1)','(I2)','(I3)','(I4)','(I5)','(I6)','(I7)',
     *   '(I8)','(I9)','(I10)'/
      DATA PART /'upper','lower'/
C-----------------------------------------------------------------------
C                                       Setup
      SCNMIN = 1.E10
      EIF = BIF
      IATY = 2
      ISCAN = 0
      IF (IPCNT.NE.980) IPCNT = 990
C                                       Single source default = 10 min.
      IF (ISNXT) THEN
         DT = 10.0 / 1440.0
C                                       Multisource DT default = scan
      ELSE
         DT = 1.0E10
         END IF
      IF (SOLINT.GT.0.0) DT = SOLINT / 1440.0
C                                       Number of char per col.
      NCOLPV = 4
      FORM = FRMAT(NCOLPV)
C                                       Init. vis record
      DO 10 I = 1,20
         RPARM(I) = 0.0
 10      CONTINUE
      RPARM(1) = FBLANK
C                                       Open uv data etc.
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.EQ.0) GO TO 20
         WRITE (MSGTXT,1010) IRET
         GO TO 990
C                                       Antenna list
 20   IANT = 1
      MANT = 1
      IF ((NANTSL.GT.0) .AND. (.NOT.DOAWNT)) MANT = NANTSL
      DO 30 I = 1,MAXANT
C                                       Search list of deselected
C                                       antennas.
         DO 25 J = 1,MANT
            IF ((.NOT.DOAWNT) .AND. (ABS(ANTENS(J)).EQ.I)) GO TO 30
 25         CONTINUE
         ANTLAB(IANT) = I
         IANT = IANT + 1
 30      CONTINUE
      IF ((NANTSL.GT.0) .AND. DOAWNT) CALL COPY (NANTSL, ANTENS, ANTLAB)
      FREQ = FREQ * 1.0D-9
C                                       first page titles
      IF ((IDOCRT.NE.0) .AND. (DOCRT.GT.-2.5)) THEN
         IF (NACROS.GE.90) THEN
            WRITE (LINE,1040) NAMEIN, CLAIN, SEQIN, DISKIN, NLUSER,
     *         BCHAN, BIF
         ELSE
            WRITE (LINE,1041) NAMEIN, CLAIN, SEQIN, DISKIN, NLUSER,
     *         BCHAN, BIF
            END IF
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         WRITE (LINE,1042) FREQ, NCOR, NVIS
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         WRITE (LINE,1043) STOKES, SUBARR
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         IF (DOCAL) THEN
            WRITE (LINE,1050) CLUSE
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         LINE, IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 950
            END IF
         IF (DOPOL.GT.0) THEN
            LINE = 'Applying polarization corrections'
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         LINE, IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 950
            END IF
         IF (DOBL) THEN
            WRITE (LINE,1051) BLVER
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         LINE, IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 950
            END IF
         IF (DOFLAG) THEN
            WRITE (LINE,1052) FGVER
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         LINE, IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 950
            END IF
         IF (DOBAND.GT.0) THEN
            WRITE (LINE,1053) BPVER
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         LINE, IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 950
            END IF
         LINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
C                                       While data, Loop thru scans
 100  CALL SCANAV (DT, SCANV, TIME, NANT, RPARM, VIS, AVGS, IRET)
         DONE = IRET.LT.0
         IF (IRET.GT.0) GO TO 999
C                                       If calc code OK
         CCODE = CALCOD(1:1)
         IF ((XCALCO(:1).EQ.' ') .OR. (CCODE.EQ.XCALCO(:1)) .OR.
     *      ((XCALCO(:1).EQ.'*') .AND. (CCODE.NE.' ')) .OR.
     *      ((XCALCO(:1).EQ.'-') .AND. (CCODE.EQ.' ') .AND.
     *      (NANT.GT.0))) THEN
C                                       Determine number of passes
            NPASS = ((1.0 * NCOLPV * NANT) / (NACROS - NCOLPV)) + 0.999
            NANTPP = (NACROS - 5) / NCOLPV
C                                       Find max value
            CALL SCNMAX (SCANV, NANT, SFACT, AVG, SIG)
            AVG = AVG + DOINV
            IF (ISCAN.LT.200) THEN
               ISCAN = ISCAN + 1
               SCNAVG(ISCAN) = AVG
               SCNSIG(ISCAN) = SIG(1)
               SCNMIN = MIN (SCNMIN, SCNSIG(ISCAN))
               END IF
C                                       Header for scan (2 blank lines
C                                       first - first pass only)
            IF (IDOCRT.NE.0) THEN
               LINE = ' '
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            LINE, IPCNT, PAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 950
               KQUAL = QUAL
               WRITE (LINE,1100) TIME, SNAME, KQUAL
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *            TITL2, LINE, IPCNT, PAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 950
C                                       Source info
               I = VSOUID(IDSOUR)
               SFREQ = FREQSO(BIF,I) * 1.0D-9
               IF (DOCRT.GT.-2.5) THEN
                  WRITE (LINE,1101) FLUX(1,BIF), CALCOD, SFREQ, BIF
                  CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *               TITL2, LINE, IPCNT, PAGE, SCRTCH, IERR)
                  IF (IERR.NE.0) GO TO 950
                  END IF
C                                       Type of data listed
               WRITE (LINE,1111) SFACT, 1000.0/SFACT
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            LINE, IPCNT, PAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 950
C                                       Polarizations
               WRITE (LINE,1112) BIF
               POLA1 = 'V'
               POLA2 = 'U'
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            LINE, IPCNT, PAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 950
               DO 600 IPASS = 1,NPASS
                  IANTLO = (IPASS - 1) * NANTPP + 1
                  IANTHI = IANTLO + NANTPP - 1
                  IANTHI = MIN (IANTHI, NANT)
C                                       Section label
                  LINE = ' '
                  CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *               TITL2, LINE, IPCNT, PAGE, SCRTCH, IERR)
                  IF (IERR.NE.0) GO TO 950
                  KQUAL = QUAL
                  WRITE (TITL1,1100) TIME, SNAME, KQUAL
                  TITL2 = 'Ant'
                  COLPNT = 5
                  DO 150 ICOL = IANTLO,IANTHI
                     WRITE (ENTRY,1120) ANTLAB(ICOL)
                     TITL2(COLPNT:COLPNT+NCOLPV-1) = ENTRY(:NCOLPV)
                     COLPNT = COLPNT + NCOLPV
 150                 CONTINUE
                  IF (((IPCNT.GT.3) .AND. (IPCNT.LT.(PRTMAX-1))) .OR.
     *               (DOCRT.LE.-2.5)) THEN
                     CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *                  TITL2, TITL2, IPCNT, PAGE,SCRTCH, IERR)
                     IF (IERR.NE.0) GO TO 950
                     END IF
                  KANT = NANT
                  DO 400 IROW = 1,KANT
                     IF (IROW.LE.NANT) THEN
                        WRITE (LINE,1150) ANTLAB(IROW)
                     ELSE
                        IF (IROW.EQ.NANT+1) THEN
                           WRITE (LINE,1160) POLA1
                        ELSE
                           WRITE (LINE,1170) POLA2
                           END IF
                        END IF
                     COLPNT = 5
                     DO 200 ICOL = IANTLO,IANTHI
                        IF (IROW .LE. NANT) THEN
                           IF (SCANV(IROW,ICOL).NE.FBLANK) THEN
                              I4TEMP = IROUND (SFACT * SCANV(IROW,ICOL))
                              WRITE (CHLINE,FORM) I4TEMP
                              LINE(COLPNT:COLPNT+NCOLPV-1) =
     *                           CHLINE(:NCOLPV)
                              END IF
                           END IF
                        COLPNT = COLPNT + NCOLPV
 200                    CONTINUE
C                                       Write row
                     CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *                  TITL2, LINE, IPCNT, PAGE, SCRTCH, IERR)
                     IF (IERR.NE.0) GO TO 950
 400                 CONTINUE
C                                       Blank titles
                  TITL1 = ' '
                  TITL2 = ' '
 600              CONTINUE
C                                       Give matrix avg, sigma
               WRITE (LINE,1600) AVG, SIG(1)
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            LINE, IPCNT, PAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 950
               DO 610 I = 1,2
                  WRITE (LINE,1601) PART(I), AVGS(1,I)*SFACT,
     *               AVGS(2,I)*SFACT
                  CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *               TITL2, LINE, IPCNT, PAGE, SCRTCH, IERR)
                  IF (IERR.NE.0) GO TO 950
 610              CONTINUE
C                                       End If ok to print
               END IF
            END IF
C                                       end while more data - loop
         IF (.NOT.DONE) GO TO 100
C                                       get average phase difference
      IF (ISCAN.LE.0) THEN
         MSGTXT = 'No phase difference returned'
         CALL MSGWRT (6)
         PDIF = 0.0
         PERR = 0.0
      ELSE IF (ISCAN.EQ.1) THEN
         PDIF = SCNAVG(1)
         PERR = SCNSIG(1)
      ELSE
         JSCAN = 0
         SCNMIN = 3.0 * MAX (SCNMIN, 0.1)
         AVG = 0.0
         SIG(1) = 1.E8
C                                       first average
 700     SW = 0.0D0
         SA(1) = 0.0D0
         SS(1) = 0.0D0
         SA(2) = 0.0D0
         SS(2) = 0.0D0
         J = 0
         DO 720 I = 1,ISCAN
            IF ((JSCAN.EQ.0) .OR. (ABS(SCNAVG(I)-AVG).LT.SIG(1))) THEN
               W = 1.0D0
               IF (SCNSIG(I).NE.0.0) W = 1.0D0 / SCNSIG(I)**2
               J = J + 1
               SW = SW + W
               XV(1) = COS (SCNAVG(I)/RAD2DG)
               XV(2) = SIN (SCNAVG(I)/RAD2DG)
               SA(1) = SA(1) + W * XV(1)
               SA(2) = SA(2) + W * XV(2)
               SS(1) = SS(1) + W * XV(1) * XV(1)
               SS(2) = SS(2) + W * XV(2) * XV(2)
               END IF
 720        CONTINUE
         IF (SW.GT.0) THEN
            XV(1) = SA(1) / SW
            XV(2) = SA(2) / SW
C            AVG = ATAN2 (XV(2), (XV(1)+1.E-20)) * RAD2DG
            AVG = ATAN (XV(2)/(XV(1)+1.E-20)) * RAD2DG + DOINV
            SS(1) = SS(1) / SW
            SS(2) = SS(2) / SW
            SS(1) = SS(1) - XV(1)*XV(1)
            SS(2) = SS(2) - XV(2)*XV(2)
            SS(1) = MAX (0.0D0, SS(1))
            SS(2) = MAX (0.0D0, SS(2))
            SIG(1) = MAX (SS(1), SS(2))
            SIG(1) = 3.0 * SQRT (SIG(1)) * RAD2DG
            IF (J.NE.JSCAN) THEN
               IF (SIG(1).LT.SCNMIN) SIG(1) = SCNMIN
               JSCAN = J
               GO TO 700
               END IF
            SIG(1) = SIG(1) / 3.0
            IF (SIG(1).LT.SCNMIN/3.0) SIG(1) = SCNMIN/3.0
            PDIF = AVG
            PERR = SIG(1) / SQRT (SW)
         ELSE
            MSGTXT = 'ERROR IN SELF-CONSISTENT AVERAGING'
            CALL MSGWRT (6)
            MSGTXT = 'No phase difference returned'
            CALL MSGWRT (6)
            PDIF = 0.0
            PERR = 0.0
            END IF
         END IF
C                                       CRT error
 950  IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1950) IERR
         CALL MSGWRT (8)
         IRET = 1
      ELSE
         IRET = 0
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('MATXUV: ERROR',I4,' DETERMINING UV-FILE PARAMETERS')
 1040 FORMAT ('File = ',A12,'.',A6,'.',I4,'   Vol =',I2,'    Userid =',
     *   I5,5X,'Channel =',I5,' IF =',I5)
 1041 FORMAT (A12,'.',A6,'.',I4,'  Vol=',I2,'  User=',I5,'  Channel=',
     *   I4,'  IF=',I4)
 1042 FORMAT ('Freq=',F13.9,' GHz   Ncor=',I3,'   No. vis=',I10)
 1043 FORMAT ('Stokes = ',A4,' Subarray = ',I3)
 1050 FORMAT ('Applying calibration table ',I3)
 1051 FORMAT ('Applying baseline table ',I3)
 1052 FORMAT ('Applying flag table ',I3)
 1053 FORMAT ('Applying bandpass table ',I3)
 1100 FORMAT ('Time =',I4,'/',2(I2.2,':'),I2.2,' to',I4,'/',2(I2.2,':'),
     *   I2.2,'   Source = ',A16,':',I5.4)
 1101 FORMAT ('Flux =',F8.4,' Jy, Calcode = ',A4,', Freq =',F13.9,
     *   ' GHz, IF =',I3)
 1111 FORMAT ('Real parts scaled by',1PE8.1,' -> 1000 =',0PF10.4,' Jy')
 1112 FORMAT ('IF=',I3,4X,'V in upper right, U in lower left')
 1120 FORMAT ('--',I2,'------')
 1150 FORMAT (I3,'|',128X)
 1160 FORMAT (A3,'|',128X)
 1170 FORMAT (A3,'|',128X)
 1600 FORMAT ('Average phase corr of matrix  = ',F8.2,'(',F7.3,
     *   ')')
 1601 FORMAT ('Average of ',A,' data = ',F8.2,9X,' sigma =',F7.3)
 1950 FORMAT ('MATXUV: ERROR',I5,' DOING I/O TO TERMINAL')
      END
      SUBROUTINE SCANAV (DT, SCANV, TIME, NANT, RPARM, VIS, AVGS, IERR)
C-----------------------------------------------------------------------
C   Reads an indexed uv data base and returns scan averages of amp,
C   phase or the RMS scatter.  Needs to be initialized by a call to
C   UVGET.  The  order of the antennas returned in SCANV is defined by
C   the order in the common array ANTENS unless all antennas were
C   specified, (NANTSL = 0).
C      IF 2 polarizations were specified to UVGET then they will be
C   returned in the two halves of SCANV.
C   Inputs:
C     DT         R    Maximum length integration in days.
C   Input/Output:
C     RPARM(20)  R    Random parameter array, first record of call.
C                     (1) = 'INDE' => don't use.
C     VIS(*)     R    Visibility array, first record of call.
C   Outputs:
C     SCANV(maxant,maxant) R   The result for antennas I<J,
C                     (I,J,*) = first polarization U
C                     (J,I,*) = second polarization V
C                     Undefined values will contain 'INDE'.
C                     Note: maxant is defined in the parameter include
C                     INCS:PUVD.INC.  Third dimension used for first and
C                     second data types (e.g. amp. + rms).
C     TIME(8)    I    Time range, start, stop; days, hours, min, sec.
C     NANT       I    Highest antenna number encountered.
C                     Actually highest index in SCANV
C     AVGS(2,2)  R    Average & rms for the type done in the AMPVEC
C                     style
C     IERR       I    Return code, 0 => OK, -1 => out of data,
C                     > 0 => failed.
C   Output to common in D/CSOU.INC
C     SNAME      C    Source name (16 char)
C     QUAL       I    Source qualifier.
C     CALCOD     R    Calibrator code 4 char.
C     FLUX(4,IF) R    Total flux density I, Q, U, V pol, (Jy) each IF
C     FREQO(IF)  D    Frequency offset (Hz)
C   Related values in common:
C     NANTSL     I    Number of antennas selected, 0 > all.
C     ANTENS(*)  I    Antenna numbers in order used in SCANV.
C   Notes:  The values of MVIS, EIF and ECHAN may be changed in the
C   UVGET commons to insure that only a single visibility is returned.
C      If the end of data is encountered (IERR=-1) then UVGET is called
C   with OPCODE='CLOS'.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      REAL     DT, SCANV(MAXANT,MAXANT), RPARM(*), VIS(3,*),
     *   AVGS(2,2)
      INTEGER   TIME(8), NANT, IERR
C
      REAL      T1, T2, SQRT, CATUV4(128), PFACT, TEMP, CATR(256)
      DOUBLE PRECISION CATD(128)
      INTEGER   MXANT, I, J, IA1, IA2, JA1, JA2, KA1, KA2, SUNUM, LIMIT,
     *   LIMIT1, JERR, NNANT, ISLUN, IANT, IPOFF, SCANUM, IVIS, KVIS,
     *   NPOL, INX
      LOGICAL   ORDER, DONE1, GOTDAT
      INTEGER   ENSANT(MAXANT), NC(2)
      DOUBLE PRECISION WORK(MAXANT,MAXANT,6), COUNT(MAXANT,MAXANT,4), W,
     *   SR(2), SI(2), SW(2), SSR(2), RP, RP2, W2, WT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSOU.INC'
      EQUIVALENCE (CATBLK, CATR, CATD)
      EQUIVALENCE (CATUV, CATUV4)
      DATA ISLUN /26/
      DATA MXANT /MAXANT/
C-----------------------------------------------------------------------
C                                       getting both CROS and AUTO
      DOACOR = .TRUE.
      DOXCOR = .TRUE.
C                                       See if first record read
      DONE1 = RPARM(1).NE.FBLANK
      GOTDAT = .FALSE.
C                                       Polarization
      NPOL = CATBLK(KINAX+JLOCS)
      IPOFF = 3
      PFACT = -1.0
      KVIS = (LREC-NRPARM) / 3
      KVIS = KVIS / NPOL
C                                       Clear arrays
 10   ORDER = NANTSL.GT.0
      NANT = NANTSL
      IF ((NANT.LE.0) .OR. (.NOT.DOAWNT)) NANT = MXANT
      NNANT = NANTSL
      DO 50 I = 1,NANT
         DO 49 J = 1,NANT
            COUNT(I,J,1) = 0.0D0
            COUNT(I,J,2) = 0.0D0
            COUNT(I,J,3) = 0.0D0
            COUNT(I,J,4) = 0.0D0
            WORK(I,J,1) = 0.0D0
            WORK(I,J,2) = 0.0D0
            WORK(I,J,3) = 0.0D0
            WORK(I,J,4) = 0.0D0
            WORK(I,J,5) = 0.0D0
            WORK(I,J,6) = 0.0D0
            SCANV(I,J) = FBLANK
 49         CONTINUE
 50      CONTINUE
C                                       Get address array for antennas
      CALL FILL (MXANT, 1, ENSANT)
      NC(1) = 0
      NC(2) = 0
C                                       Antennas selected
      DO 60 I = 1,NANT
         J = ABS(ANTENS(I))
         IF (J.GT.0) ENSANT(J) = I
 60      CONTINUE
      IF (DOAWNT .OR. (NANTSL.LE.0)) GO TO 90
C                                       Antennas deselected
      IANT = 1
      DO 80 I = 1,NANT
         DO 70 J = 1,NANTSL
            IF (ABS(ANTENS(J)).EQ.I) GO TO 80
 70         CONTINUE
C                                       Add antenna I to list.
         ENSANT(I) = IANT
         IANT = IANT + 1
 80      CONTINUE
C                                       Do one IF at a time
 90   EIF = BIF
C                                       Initialize time
      T1 = 1.0E10
      T2 = 1.0E10
C                                       Save scan number (0= no index)
      SCANUM = INXRNO
C                                       Loop reading data
 100     IF (.NOT.DONE1) CALL UVGET ('READ', RPARM, VIS, IERR)
         IF (IERR.GT.0) GO TO 999
         DONE1 = .FALSE.
C                                       Check if scan done
         IF ((INXRNO.GT.SCANUM) .OR. (IERR.LT.0) .OR.
     *      (RPARM(1+ILOCT).GT.(T1+DT))) GO TO 500
C                                       Antenna numbers
         IF (ILOCB.GE.0) THEN
            JA1 = RPARM(ILOCB+1) / 256. + 0.1
            JA2 = RPARM(ILOCB+1) - JA1 * 256 + 0.1
         ELSE
            JA1 = RPARM(ILOCA1+1) + 0.1
            JA2 = RPARM(ILOCA2+1) + 0.1
            END IF
         KA1 = JA1
         KA2 = JA2
         IF (ORDER) KA1 = ENSANT(JA1)
         IF (ORDER) KA2 = ENSANT(JA2)
         IA1 = MIN (KA1, KA2)
         IA2 = MAX (KA1, KA2)
         NNANT = MAX (NNANT, IA2)
         GOTDAT = .TRUE.
C                                       Time
         T2 = RPARM(ILOCT+1)
         IF (T1.GT.1.0E5) T1 = T2
C                                       Source no.
         SUNUM = CURSOU
C                                       Vector average:
C                                       Accumulate 1 st. poln.
         INX = IPOFF
         RP = 0.0D0
         W = 0.0D0
         RP2 = 0.0D0
         W2 = 0.0D0
         DO 120 IVIS = 1,KVIS
            WT = VIS(3,INX)
            IF (WT.GT.0.0D0) THEN
               RP = RP + VIS(1,INX) * WT
               W = W + WT
               END IF
C                                       Accumulate 2 nd. poln.
            WT = VIS(3,INX+1)
            IF (WT.GT.0.0D0) THEN
               RP2 = RP2 + VIS(1,INX+1) * WT
               W2 = W2 + WT
               END IF
            INX = INX + NPOL
 120        CONTINUE
         IF ((W.GT.0.0D0) .AND. (IA1.NE.IA2)) THEN
            RP = RP / W
            COUNT(IA1,IA2,1) = COUNT(IA1,IA2,1) + W
            COUNT(IA1,IA2,3) = COUNT(IA1,IA2,3) + W**2
            WORK(IA1,IA2,1) = WORK(IA1,IA2,1) + W * RP
            WORK(IA1,IA2,2) = WORK(IA1,IA2,2) + W * RP * RP
            END IF
C                                       Accumulate 2 nd. poln.
         IF ((W2.GT.0.0D0) .AND. (IA1.NE.IA2)) THEN
            RP = RP2 / W2
            W = W2
            COUNT(IA1,IA2,2) = COUNT(IA1,IA2,2) + W
            COUNT(IA1,IA2,4) = COUNT(IA1,IA2,4) + W**2
            WORK(IA1,IA2,3) = WORK(IA1,IA2,3) + W * RP
            WORK(IA1,IA2,4) = WORK(IA1,IA2,4) + W * RP * RP
            END IF
         GO TO 100
C                                       Scan done
C                                       See if have any data.
 500  IF ((.NOT.GOTDAT) .AND. (IERR.EQ.0)) GO TO 10
      IF (.NOT.GOTDAT) GO TO 800
      NANT = NNANT
      SR(1) = 0.0D0
      SR(2) = 0.0D0
      SW(1) = 0.0D0
      SW(2) = 0.0D0
      SSR(1) = 0.0D0
      SSR(2) = 0.0D0
C                                       Vector averaging
      LIMIT = NANT - 1
      DO 560 I = 1,LIMIT
         LIMIT1 = I + 1
         DO 550 J = LIMIT1,NANT
C                                       real part - upper right
            IF (COUNT(I,J,1).GT.0.0D0) THEN
               SCANV(I,J) = WORK(I,J,1) / COUNT(I,J,1)
               SR(1) = SR(1) + WORK(I,J,1)
               SSR(1) = SSR(1) + WORK(I,J,2)
               SW(1) = SW(1) + COUNT(I,J,1)
               NC(1) = NC(1) + 1
               END IF
C                                       real part - lower left
            IF (COUNT(I,J,2).GT.0.0D0) THEN
               SCANV(J,I) = WORK(I,J,3) / COUNT(I,J,2)
               SR(2) = SR(2) + WORK(I,J,3)
               SSR(2) = SSR(2) + WORK(I,J,4)
               SW(2) = SW(2) + COUNT(I,J,2)
               NC(2) = NC(2) + 1
               END IF
 550        CONTINUE
 560     CONTINUE
C                                       average matrix averages
      CALL RFILL (4, 0.0, AVGS)
      DO 570 I = 1,2
         IF (SW(I).GT.0.0D0) THEN
            SR(I) = SR(I) / SW(I)
            SSR(I) = SSR(I) / SW(I)
            AVGS(1,I) = SR(I)
            SSR(I) = SSR(I) - SR(I)*SR(I)
            TEMP = (SR(I)*SR(I) + SI(I)*SI(I)) ** 2
            IF (SR(I).NE.0.0D0) THEN
               AVGS(2,I) = SQRT (MAX (0.0D0, SSR(I)))
               IF (NC(I).GT.1) AVGS(2,I) = AVGS(2,I) / SQRT (NC(I)-1.0)
            ELSE
               AVGS(2,I) = 999.0
               END IF
            END IF
 570     CONTINUE
C                                       average matrix averages
C                                       Get source info
      CALL GETSOU (SUNUM, IUDISK, IUCNO, CATUV, ISLUN, JERR)
C                                       Didn't find source
      IF (JERR.EQ.11) THEN
         WRITE (MSGTXT,1750) SUNUM
         CALL MSGWRT (8)
         JERR = 0
      ELSE IF (JERR.GT.0) THEN
         IERR = JERR
         WRITE (MSGTXT,1700) JERR
         GO TO 990
         END IF
C                                       Time to Days Hours Mins Secs
 800  IF (T1.LT.1000.) THEN
         CALL TODHMS (T1, TIME(1))
         CALL TODHMS (T2, TIME(5))
         END IF
C                                       If end of data, close UVGET
      IF (IERR.LT.0) CALL UVGET ('CLOS', RPARM, VIS, JERR)
      IF (JERR.NE.0) IERR = JERR
      IF ((IERR.LT.0) .AND. (.NOT.GOTDAT)) THEN
         IERR = 1
         MSGTXT = 'NO DATA FOUND'
         CALL MSGWRT (8)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1700 FORMAT ('SCANAV: ERROR',I3,' READING SOURCE TABLE')
 1750 FORMAT ('SCANAV: SOURCE ',I3,' NOT IN SU TABLE')
      END
      SUBROUTINE SCNMAX (SCANV, NANT, SFACT, AVG, SIG)
C-----------------------------------------------------------------------
C   Routine to find the maximum, non blank value in an array and
C   determine the proper scaling factor for printing.
C   Inputs:
C      SCANV(maxant,maxant)  R    Scan values.
C      NANT                  I    Max. antenns number in scan.
C   Output:
C      SFACT                 R    Scaling factor to print values.
C      AVG                   R    Matrix average ATAN(V,U)
C      SIG(2)                R    Sigma of average, of matrix
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      REAL      SCANV(MAXANT,MAXANT), SFACT
      INTEGER   NANT
      DOUBLE PRECISION AVG, SIG(2)
C
      INTEGER   I, J, ICNT
      REAL      SQRT, TEMP, XV(2), XAVG, SMAX, SMIN
      DOUBLE PRECISION XS1(2), XS2(2)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       Find maximum non blank and do
C                                       sums for average, sigma
      ICNT = 0
      AVG = 0.0D0
      XAVG = 0.0
      SIG(1) = 0.0D0
      SIG(2) = 0.0D0
      XV(1) = 0.0
      XV(2) = 0.0
      XS1(1) = 0.0D0
      XS1(2) = 0.0D0
      XS2(1) = 0.0D0
      XS2(2) = 0.0D0
      SFACT = 1.0
      IF (NANT.LE.0) GO TO 999
      SMAX = -1.E10
      SMIN = 1.E10
      DO 100 I = 1,NANT-1
         DO 90 J = I+1,NANT
            IF ((SCANV(I,J).NE.FBLANK) .AND. (SCANV(J,I).NE.FBLANK))
     *         THEN
               ICNT = ICNT + 1
               XV(1) = SCANV(I,J)
               XV(2) = SCANV(J,I)
               SMAX = MAX (SMAX, SCANV(I,J))
               SMAX = MAX (SMAX, SCANV(J,I))
               SMIN = MIN (SMIN, SCANV(I,J))
               SMIN = MIN (SMIN, SCANV(J,I))
               XS1(1) = XS1(1) + XV(1)
               XS1(2) = XS1(2) + XV(2)
               XS2(1) = XS2(1) + XV(1) * XV(1)
               XS2(2) = XS2(2) + XV(2) * XV(2)
               END IF
 90         CONTINUE
 100     CONTINUE
      IF (ICNT.LE.0) GO TO 999
      SMAX = MAX (SMAX, -10.0*SMIN)
      I = 4 - LOG10 (SMAX)
      SFACT = 10.0 ** I
C                                       Average and sigma
      IF (ICNT.GT.0) THEN
         XV(1) = XS1(1) / ICNT
         XV(2) = XS1(2) / ICNT
C                                       NOT ATAN2
C         AVG = ATAN2 (-XV(2), (XV(1)+1.0E-20))
         AVG = ATAN (-XV(2)/(XV(1)+1.0E-20))
         XAVG = XS1(2) / ICNT
         END IF
      IF (ICNT.GT.3) THEN
         XS2(1) = (XS2(1)/ICNT) - XV(1)*XV(1)
         XS2(2) = (XS2(2)/ICNT) - XV(2)*XV(2)
         TEMP = ((XV(1)/(XV(1)*XV(1)+XV(2)*XV(2))) ** 2) * XS2(2) +
     *      ((XV(2)/(XV(1)*XV(1)+XV(2)*XV(2))) ** 2) * XS2(1)
         IF (TEMP.LT.0.0) TEMP = 0.0
         SIG(1) = SQRT (TEMP / (ICNT - 1))
         IF (SIG(1).LE.1.0) THEN
            SIG(1) = ASIN(SIG(1))
         ELSE
            SIG(1) = 3.14159
            END IF
         SIG(2) = SQRT (TEMP)
         IF (SIG(2).LE.1.0) THEN
            SIG(2) = ASIN(SIG(2))
         ELSE
            SIG(2) = 3.14159
            END IF
         END IF
      AVG = AVG * RAD2DG
      SIG(1) = SIG(1) * RAD2DG
      SIG(2) = SIG(2) * RAD2DG
C
 999  RETURN
      END
      SUBROUTINE CLAPPL (DISK, CNO, BIF, EIF, CLVER, ANVER, CLCORP,
     *   OCLVER, CATBLK, IRET)
C-----------------------------------------------------------------------
C   CLAPPL applies the corrections by IF to the CL and AN tables
C   Inputs:
C      DISK     I      Disk number
C      CNO      I      Catalog number
C      BIF      I      begin IF
C      EIF      I      end IF
C      CLVER    I      Input CL table version
C      CLCORP   R(*)   corrections for BIF through EIF
C   In/out:
C      CATBLK   I(*)   Data file header
C   Outputs:
C      OCLVER   I
C      IRET     I      Error code in handling the tables
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, BIF, EIF, CLVER, ANVER, OCLVER, CATBLK(256),
     *   IRET
      REAL      CLCORP(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NUMCL, LUN1, LUN2, TABUF1(512), TABUF2(512), VER, LI,
     *   NUMANT, NUMPOL, NUMIF, NTERM, CLKOLS(MAXCLC), CLNUMV(MAXCLC),
     *   IDSOU, ANTNO, SUBA, FREQID, REFA(2,MAXIF), ICLRNO, NREC, IREC,
     *   IANRNO, ANKOLS(MAXANC), ANNUMV(MAXANC), NUMORB, NOPCAL, ANTNIF,
     *   ANFQID, ISTYPE, LOCS, KEYTYP, INDEX, NOSTA, MNTSTA, I
      REAL      GMMOD, DTIMEI, IFR, DOPOFF(MAXIF), ATMOS, DATMOS,
     *   MBDELY(2), CLOCK(2), DCLOCK(2), DISP(2), DDISP(2), XT, YT,
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF),
     *   WEIGHT(2,MAXIF), CF(MAXIF), SF(MAXIF), POLRXY(2), UT1UTC,
     *   DATUTC, STAXOF, DIAMAN, FWHMAN(MAXIF), POLAA, POLCA(2*MAXIF),
     *   POLAB, POLCB(2*MAXIF)
      DOUBLE PRECISION TIME, GEODLY, ARRAYC(3), GSTIA0, DEGPDY, SAFREQ,
     *   STAXYZ(3), ORBPRM(6)
      CHARACTER RDATE*8, TIMSYS*8, ANAME*8, XYZHAN*8, TFRAME*8,
     *   SOLTYP*8, CHSOL(4)*8, ANNAME*8, POLTYA*2, POLTYB*2
      HOLLERITH XSOLTY(2)
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1, LUN2 /79, 78/
      DATA CHSOL /'ORI-ELP ', 'APPROX  ', 'X-Y LIN', 'VLBI'/
C-----------------------------------------------------------------------
      CALL FNDEXT ('CL', CATBLK, NUMCL)
      IF (NUMCL.LE.0) THEN
         MSGTXT = 'CANNOT APPLY TO CL TABLE IF NONE PRESENT'
         IRET = 10
         GO TO 990
         END IF
      MSGTXT = 'Updating the CL table to a new one'
      CALL MSGWRT (5)
      DO 10 LI = BIF,EIF
         IF (CLCORP(LI-BIF+1).NE.FBLANK) THEN
            CF(LI) = COS (CLCORP(LI-BIF+1) * DG2RAD)
            SF(LI) = SIN (CLCORP(LI-BIF+1) * DG2RAD)
         ELSE
            CF(LI) = 1.0
            SF(LI) = 0.0
            END IF
 10      CONTINUE
      VER = NUMCL + 1
      IF (CLVER.LE.0) CLVER = NUMCL
      CALL CALINI ('READ', TABUF1, DISK, CNO, CLVER, CATBLK, LUN1,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT CL TABLE'
         GO TO 990
         END IF
      CALL CALINI ('WRIT', TABUF2, DISK, CNO, VER, CATBLK, LUN2, ICLRNO,
     *   CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT CL TABLE'
         GO TO 990
         END IF
      OCLVER = VER
      NREC = TABUF1(5)
      DO 50 IREC = 1,NREC
         ICLRNO = IREC
         CALL TABCAL ('READ', TABUF1, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *      NUMIF, TIME, DTIMEI, IDSOU, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ INPUT CL TABLE'
            GO TO 990
            END IF
         DO 20 LI = BIF,EIF
            XT = CREAL(2,LI)
            YT = CIMAG(2,LI)
            CREAL(2,LI) = XT * CF(LI) - YT * SF(LI)
            CIMAG(2,LI) = XT * SF(LI) + YT * CF(LI)
 20         CONTINUE
         ICLRNO = IREC
         CALL TABCAL ('WRIT', TABUF2, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *      NUMIF, TIME, DTIMEI, IDSOU, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT CL TABLE'
            GO TO 990
            END IF
 50      CONTINUE
      CALL TABIO ('CLOS', 0, ICLRNO, TABUF1, TABUF1, IRET)
      IF (IRET.EQ.0) CALL TABIO ('CLOS', 0, ICLRNO, TABUF2, TABUF2,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING CL TABLES'
         GO TO 990
         END IF
C                                       now the AN table
      MSGTXT = 'Updating the AN table in place'
      CALL MSGWRT (5)
      CALL ANTINI ('READ', TABUF1, DISK, CNO, ANVER, CATBLK, LUN1,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN AN FILE FOR READ'
         GO TO 990
         END IF
C                                       find solution type
      ISTYPE = 0
      MSGSUP = 32000
      CALL TABKEY ('READ', 'POLTYPE ', 1, TABUF1, LOCS, XSOLTY, KEYTYP,
     *   IRET)
      MSGSUP = 0
      IF (IRET.GT.20) THEN
         MSGTXT = 'NO PCAL SOLUTION FOUND IN AN TABLE: NONE CORRECTED'
         CALL MSGWRT (6)
      ELSE IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ SOLUTION TYPE'
         GO TO 990
      ELSE IF (IRET.EQ.0) THEN
         CALL H2CHR (8, 1, XSOLTY, SOLTYP)
         DO 110 I = 1,4
            IF (SOLTYP.EQ.CHSOL(I)) ISTYPE = I
 110        CONTINUE
         IF (ISTYPE.EQ.0) THEN
            MSGTXT = 'PCAL SOLUTION TYPE NOT RECOGNIZED: NONE CORRECTED'
            CALL MSGWRT (6)
            IRET = 21
            END IF
         END IF
      CALL TABIO ('CLOS', 0, IANRNO, TABUF1, TABUF1, I)
      IF (IRET.GT.20) THEN
         IRET = 0
         GO TO 999
         END IF
C                                       ORI-ELP modify phase differences
      IF (SOLTYP.EQ.'ORI-ELP') THEN
C                                       Fetch old phase differences
         CALL PDRGET (DISK, CNO, ANVER, LUN1, CATBLK, ANTNIF, REFA, SF,
     *      TABUF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'GETTING OLD PHASE DIFFERENCES'
            GO TO 990
            END IF
C                                       Update values (radians)
         INDEX = 1
         DO 120 LI = BIF,EIF
            IF (CLCORP(INDEX).NE.FBLANK) SF(LI) = SF(LI) +
     *         CLCORP(INDEX) * DG2RAD
            INDEX = INDEX + 1
 120        CONTINUE
C                                       Save results
         CALL PDRSET (DISK, CNO, ANVER, LUN1, CATBLK, ANTNIF, REFA, SF,
     *      TABUF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'RE-SETTING PHASE DIFFERENCES'
            GO TO 990
            END IF
C                                       others require AN table
      ELSE
         CALL ANTINI ('WRIT', TABUF1, DISK, CNO, ANVER, CATBLK, LUN1,
     *      IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *      RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *      TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN AN FILE FOR WRITE'
            GO TO 990
            END IF
         NREC = TABUF1(5)
         DO 150 IREC = 1,NREC
            IANRNO = IREC
            CALL TABAN ('READ', TABUF1, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ OLD AN TABLE'
               GO TO 990
               END IF
            INDEX = 1 + (BIF - 1) * 2
            DO 130 LI = BIF,EIF
C                                       Right hand (or X) parameters
               XT = POLCA(INDEX)
               YT = POLCA(INDEX+1)
               POLCA(INDEX) = XT * CF(LI) - YT * SF(LI)
               POLCA(INDEX+1) = YT * CF(LI) + XT * SF(LI)
C                                       Left hand (or Y) parameters
               XT = POLCB(INDEX)
               YT = POLCB(INDEX+1)
               POLCB(INDEX) = XT * CF(LI) + YT * SF(LI)
               POLCB(INDEX+1) = YT * CF(LI) - XT * SF(LI)
               INDEX = INDEX + 2
 130           CONTINUE
            IANRNO = IREC
            CALL TABAN ('WRIT', TABUF1, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'UPDATE AN TABLE'
               GO TO 990
               END IF
 150        CONTINUE
         END IF
      CALL TABIO ('CLOS', 0, IANRNO, TABUF1, TABUF1, I)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLAPPL: ERROR',I4,' ON ',A)
      END
      SUBROUTINE XHDLIN (NC, NI, PDCOR, IRET)
C-----------------------------------------------------------------------
C   XHDLIN averages the U and V Stokes data in each scan and then
C   averages the atan2(v,u) over the scans.
C   Inputs:
C      NC      I      Number spectral channels
C      NI      I      Number IFs
C      NS      I      Number sources
C   Outputs:
C      PDCOR   R(*)   Average phase (NC,NI, 1-6 averaging in scans
C                        7-11 averaging over scans)
C      IRET    I      Error code
C-----------------------------------------------------------------------
      INTEGER   NC, NI, IRET
      DOUBLE PRECISION PDCOR(NC,NI,*)
C
      INCLUDE 'VHDIF.INC'
      INTEGER   LC, LI, I, JNCF, JNCIF, JNCS, INX, SCANUM, PPLUN,
     *   PPBUFF(512), PPKOLS(5), PPNUMV(5), IPPRNO, NUMVIS, VISINC,
     *   VISMSG, NGOOD, IERR, PPOL
      DOUBLE PRECISION X, Y, W, XX, YY, TEMP, WT, SU, SV, UU, VV
      DOUBLE PRECISION DBGU(128,4), DBGV(128,4), DBGA(128,4)
      REAL      DT, T1, T2
      CHARACTER MARK*1, PPNAME*48
      LOGICAL   FIRST
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      FIRST = .TRUE.
      I = NC * NI * 11
      CALL DFILL (I, 0.0D0, PDCOR)
C                                       create PP table
      IF (DOKEEP.GT.0.0) THEN
         PPVER = 0
         PPLUN = 59
         PPOL = 2
         CALL PPINI ('WRIT', PPBUFF, DISKIN, CNOIN, PPVER, CATUV, PPLUN,
     *      IPPRNO, PPKOLS, PPNUMV, NI, NC, BIF, BCHAN, PPOL, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATE PHASE DIFF TABLE'
            GO TO 990
            END IF
C                                       write dummy average record
         CALL TABPP ('WRIT', PPBUFF, IPPRNO, PPKOLS, PPNUMV, 0.0,
     *      SUBARR, FRQSEL, PDCOR(1,1,1), PDCOR(1,1,2), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET,
     *         'WRITING DUMMTY RECORD IN PP TABLE'
            GO TO 990
            END IF
         END IF
C                                       Single source default = 10 min.
      IF (ISNXT) THEN
         DT = 10.0 / 1440.0
C                                       Multisource DT default = scan
      ELSE
         DT = 1.0E10
         END IF
      IF (SOLINT.GT.0.0) DT = SOLINT / 1440.0
      T1 = 1.E10
      T2 = 1.E10
C                                       open uv data set
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN UV DATA SET'
         GO TO 990
         END IF
      JNCIF = INCIF / 3
      JNCS = INCS / 3
      JNCF = INCF / 3
      SCANUM = INXRNO
      VISINC = MAX (40000, NVIS/20)
      VISINC = ((VISINC+500) / 1000) * 1000
      VISMSG = 3 * VISINC
      NUMVIS = 0
C                                       read loop point
 20   CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ UV DATA SET'
         GO TO 990
      ELSE IF (IRET.LE.0) THEN
C                                       Check if scan done
         IF ((INXRNO.GT.SCANUM) .OR. (IRET.LT.0) .OR.
     *      (RPARM(1+ILOCT).GT.(T1+DT))) THEN
           NGOOD = 0
           DO 40 LI = 1,NI
               DO 30 LC = 1,NC
                  IF ((PDCOR(LC,LI,2).GT.0.0D0) .AND.
     *               (PDCOR(LC,LI,5).GT.0.0D0)) THEN
                     UU = PDCOR(LC,LI,1) / PDCOR(LC,LI,2)
                     VV = PDCOR(LC,LI,4) / PDCOR(LC,LI,5)
                     SU = PDCOR(LC,LI,3) / PDCOR(LC,LI,2) - UU*UU
                     SV = PDCOR(LC,LI,6) / PDCOR(LC,LI,5) - VV*VV
                     TEMP = (UU*UU + VV*VV) ** 2
                     IF (TEMP.NE.0.0) TEMP = (UU*UU*SV+VV*VV*SU) / TEMP
                     PDCOR(LC,LI,1) = FBLANK
                     PDCOR(LC,LI,2) = FBLANK
                     IF (TEMP.GT.0.0) THEN
                        WT = 1.0D0 / TEMP
                        NGOOD = NGOOD + 1
C                                       NOT ATAN2
C                        X = ATAN2 (-VV, UU)
                        X = ATAN (-VV/UU)
                        XX = COS (X)
                        YY = SIN (X)
                        DBGU(LC,LI) = UU
                        DBGV(LC,LI) = VV
                        DBGA(LC,LI) = X * RAD2DG
                        PDCOR(LC,LI,7) = PDCOR(LC,LI,7) + XX * WT
                        PDCOR(LC,LI,8) = PDCOR(LC,LI,8) + YY * WT
                        PDCOR(LC,LI,9) = PDCOR(LC,LI,9) + WT
                        PDCOR(LC,LI,10) = PDCOR(LC,LI,10) + XX * XX * WT
                        PDCOR(LC,LI,11) = PDCOR(LC,LI,11) + YY * YY * WT
                        PDCOR(LC,LI,1) = RAD2DG * ATAN (YY/XX) + DOINV
                        PDCOR(LC,LI,2) = RAD2DG * SQRT (MAX(0.0D0,TEMP))
                        END IF
                  ELSE
                     PDCOR(LC,LI,1) = FBLANK
                     PDCOR(LC,LI,2) = FBLANK
                     END IF
 30               CONTINUE
 40            CONTINUE
C                                       save the time record
            IF ((DOKEEP.GT.0.0) .AND. (NGOOD.GT.0)) THEN
               T1 = (T1 + T2) / 2.0
               CALL TABPP ('WRIT', PPBUFF, IPPRNO, PPKOLS, PPNUMV, T1,
     *            SUBARR, FRQSEL, PDCOR(1,1,1), PDCOR(1,1,2), I)
               IF (I.NE.0) THEN
                  IRET = I
                  WRITE (MSGTXT,1000) IRET,
     *               'WRITING PP TABLE TIME RECORD'
                  GO TO 990
                  END IF
               END IF
C                                       end of data?
            IF (IRET.LT.0) GO TO 100
C                                       re-zero
            T1 = RPARM(1+ILOCT)
            SCANUM = INXRNO
C                                       leave 7 8 9 10 11 alone
            I = NC * NI * 6
            CALL DFILL (I, 0.0D0, PDCOR)
            END IF
C                                       sum for line work
         IF (FIRST) THEN
            T1 = RPARM(1+ILOCT)
            FIRST = .FALSE.
            END IF
         T2 = RPARM(1+ILOCT)
         NUMVIS = NUMVIS + 1
         IF (MOD(NUMVIS-1,VISMSG).EQ.0) THEN
            WRITE (MSGTXT,1040) NUMVIS
            CALL MSGWRT (2)
         ELSE IF (MOD(NUMVIS-1,VISINC).EQ.0) THEN
            WRITE (MSGTXT,1040) NUMVIS
            CALL MSGWRT (1)
            END IF
         DO 60 LI = 1,NI
            INX = (LI - 1) * JNCIF + 2 * JNCS + 1
            DO 50 LC = 1,NC
               WT = VIS(3,INX)
               IF (WT.GT.0.0D0) THEN
                  PDCOR(LC,LI,1) = PDCOR(LC,LI,1) +
     *               VIS(1,INX) * WT
                  PDCOR(LC,LI,2) = PDCOR(LC,LI,2) +
     *               WT
                  PDCOR(LC,LI,3) = PDCOR(LC,LI,3) +
     *               (VIS(1,INX) ** 2) * WT
                  END IF
               INX = INX + JNCS
               WT = VIS(3,INX)
               IF (WT.GT.0.0D0) THEN
                  PDCOR(LC,LI,4) = PDCOR(LC,LI,4) +
     *               VIS(1,INX) * WT
                  PDCOR(LC,LI,5) = PDCOR(LC,LI,5) +
     *               WT
                  PDCOR(LC,LI,6) = PDCOR(LC,LI,6) +
     *               (VIS(1,INX) ** 2) * WT
                  END IF
               INX = INX - JNCS + JNCF
 50            CONTINUE
 60         CONTINUE
         GO TO 20
         END IF
C                                       we are done
 100  CALL UVGET ('CLOS', RPARM, VIS, IRET)
      IF (DOKEEP.GT.0.0) THEN
         CALL TABPP ('CLOS', PPBUFF, IPPRNO, PPKOLS, PPNUMV, 0.0,
     *      SUBARR, FRQSEL, PDCOR, PDCOR, IRET)
         END IF
      IRET = 0
      NGOOD = 0
C                                       average and rms
      DO 120 LI = 1,NI
         DO 110 LC = 1,NC
            W = PDCOR(LC,LI,9)
            IF (W.GT.0.0) THEN
               NGOOD = NGOOD + 1
               X = PDCOR(LC,LI,7) / W
               Y = PDCOR(LC,LI,8) / W
               XX = PDCOR(LC,LI,10) / W
               YY = PDCOR(LC,LI,11) / W
C                                       NOT ATAN2 ?
C               PDCOR(LC,LI,1) = RAD2DG * ATAN2 (Y, X)
               PDCOR(LC,LI,1) = RAD2DG * ATAN (Y/X) + DOINV
               XX = XX - X * X
               YY = YY - Y * Y
               TEMP = (X * X + Y * Y) ** 2
               IF (TEMP.GT.0.0D0) TEMP = (X*X*YY + Y*Y*XX) / TEMP
               IF (TEMP.GE.0.0D0) THEN
                  TEMP = RAD2DG * SQRT (TEMP)
               ELSE
                  TEMP = 0.0D0
                  END IF
               PDCOR(LC,LI,2) = TEMP
C               PDCOR(LC,LI,2) = TEMP / SQRT (W)
               MARK = ' '
               IF ((LC.LT.LBCHAN) .OR. (LC.GT.LECHAN)) MARK = '*'
               WRITE (MSGTXT,1110) LI+BIF-1, LC, PDCOR(LC,LI,1), TEMP,
     *            MARK
               CALL MSGWRT (5)
            ELSE
               PDCOR(LC,LI,1) = DBLANK
               PDCOR(LC,LI,2) = 0.0
               END IF
 110        CONTINUE
 120     CONTINUE
      IF (NGOOD.LE.0) THEN
         MSGTXT = 'NO VALID DATA FOUND'
         CALL MSGWRT (8)
         IRET = 1
         IF (DOKEEP.GT.0) THEN
            WRITE (MSGTXT,1120) PPVER
            CALL MSGWRT (8)
            CALL ZPHFIL ('PP', DISKIN, CNOIN, PPVER, PPNAME, IERR)
            CALL ZDESTR (DISKIN, PPNAME, IERR)
            CALL DELEXT ('PP', DISKIN, CNOIN, 'WRWR', PPBUFF, BUFFER,
     *         PPVER, IERR)
            END IF
      ELSE IF ((LBCHAN.GT.1) .OR. (LECHAN.LT.NC)) THEN
         MSGTXT = '* following values => will not be applied to data'
         CALL MSGWRT (5)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XHDLIN: ERROR',I4,' ON ',A)
 1040 FORMAT ('XHDLIN at visibility record',I10)
 1110 FORMAT ('IF',I3,' ch',I6,2X,F8.2,' +-',F8.2,2X,A)
 1120 FORMAT ('XHDLIN DELETING PP TABLE VERSION',I4)
      END
      SUBROUTINE BPAPPL (DISK, CNO, BCHAN, BIF, BPVER, PDVER, SUBARR,
     *   FRQSEL, NCH, NIF, OPDVER, OBPVER, PDCOR, CATBLK, IRET)
C-----------------------------------------------------------------------
C   BPAPPL writes a new BP table based on the one used and updates the
c   PD table with the corrections contained in PDCOR
C   Inputs
C      DISK     I      Disk number
C      CNO      I      Catalog number
C      BCHAN    I      Begin channel
C      BIF      I      Begin IF
C      BPVER    I      BP version in
C      SUBARR   I      Subarray
C      FRQSEL   I      Freq ID
C      NCH      I      Number channels
C      NIF      I      Number IFs
C      PDCOR    D(*)   Phase change in degrees (Nch,Nif)
C   In/Out:
C      CATBLK   I(*)   UV file header
C   Output:
C      IRET
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, BCHAN, BIF, BPVER, PDVER, SUBARR, FRQSEL,
     *   NCH, NIF, OPDVER, OBPVER, CATBLK(*), IRET
      DOUBLE PRECISION PDCOR(NCH,NIF)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NUMTA, LUN1, LUN2, TABUF1(512), TABUF2(512), IBPRNO,
     *   BPKOLS(MAXBPC), BPNUMV(MAXBPC), NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *   LCHAN, NUMSHF, NREC, IREC, SOURID, SUBA, ANT, FREQID, LI, LC,
     *   REFANT(2), I, JNX, VER, IPDRNO, PDKOLS(9), PDNUMV(9),
     *   PDKOLO(9), PDNUMO(9)
      DOUBLE PRECISION TIME, CHSHFT(MAXIF)
      REAL      CF, SF, LOWSHF, DELSHF, INTERV, BANDW, WEIGHT(2*MAXIF),
     *   BNDPAS(2,MAXCIF), XT, YT, VFLUX(4,MAXCIF), PHDIFF(MAXCIF)
      CHARACTER LBPTYP*8, POLTYP*8
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (BNDPAS, VFLUX)
      DATA LUN1, LUN2 /79, 78/
C-----------------------------------------------------------------------
      CALL FNDEXT ('BP', CATBLK, NUMTA)
      IF (BPVER.LE.0) BPVER = NUMTA
      VER = NUMTA + 1
C                                       modify existing BP table
      IF (BPVER.GT.0) THEN
         MSGTXT = 'Updating existing BP table, writing new one'
         CALL MSGWRT (5)
         CALL BPINI ('READ', TABUF2, DISK, CNO, BPVER, CATBLK, LUN2,
     *      IBPRNO, BPKOLS, BPNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *      LCHAN, NUMSHF, LOWSHF, DELSHF, LBPTYP, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OLD BP TABLE'
            GO TO 990
            END IF
         CALL BPINI ('WRIT', TABUF1, DISK, CNO, VER, CATBLK, LUN1,
     *      IBPRNO, BPKOLS, BPNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *      LCHAN, NUMSHF, LOWSHF, DELSHF, LBPTYP, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OLD BP TABLE'
            GO TO 990
            END IF
         OBPVER = VER
         NREC = TABUF2(5)
         DO 50 IREC = 1,NREC
            IBPRNO = IREC
            CALL TABBP ('READ', TABUF2, IBPRNO, BPKOLS, BPNUMV, NUMIF,
     *         NUMFRQ, NUMPOL, TIME, INTERV, SOURID, SUBA, ANT, BANDW,
     *         CHSHFT, FREQID, REFANT, WEIGHT, BNDPAS, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ OLD BP TABLE'
               GO TO 990
               END IF
            IF (((SUBA.LE.0) .OR. (SUBARR.LE.0) .OR. (SUBA.EQ.SUBARR))
     *         .AND. ((FREQID.LE.0) .OR. (FRQSEL.LE.0) .OR.
     *         (FREQID.EQ.FRQSEL)) .AND. (IRET.GT.-2)) THEN
               DO 30 LI = 1,NIF
                  JNX = (LI + BIF - 2) * NUMFRQ + BCHAN + NUMFRQ*NUMIF
                  DO 20 LC = 1,NCH
                     XT = BNDPAS(1,JNX)
                     YT = BNDPAS(2,JNX)
                     IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK) .AND.
     *                  (PDCOR(LC,LI).NE.DBLANK)) THEN
                        CF = COS (PDCOR(LC,LI)*DG2RAD)
                        SF = SIN (PDCOR(LC,LI)*DG2RAD)
                        BNDPAS(1,JNX) = XT*CF - YT*SF
                        BNDPAS(2,JNX) = XT*SF + YT*CF
                        END IF
                     JNX = JNX + 1
 20                  CONTINUE
 30               CONTINUE
               END IF
            IBPRNO = IREC
            CALL TABBP ('WRIT', TABUF1, IBPRNO, BPKOLS, BPNUMV, NUMIF,
     *         NUMFRQ, NUMPOL, TIME, INTERV, SOURID, SUBA, ANT, BANDW,
     *         CHSHFT, FREQID, REFANT, WEIGHT, BNDPAS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITE NEW BP TABLE'
               GO TO 990
               END IF
 50         CONTINUE
         CALL TABIO ('CLOS', 0, IBPRNO, TABUF2, TABUF2, LI)
C                                       create one from scratch
      ELSE
         MSGTXT = 'Writing new BP table from scratch'
         CALL MSGWRT (5)
         CALL GETANT (DISK, CNO, SUBARR, CATBLK, TABUF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ AN FILE WITH GETANT'
            GO TO 990
            END IF
         NUMANT = NSTNS
         NUMPOL = 2
         NUMIF = 1
         IF (JLOCIF.GE.0) NUMIF = CATBLK(KINAX+JLOCIF)
         NUMFRQ = CATBLK(KINAX+JLOCF)
         LCHAN = 1
         NUMSHF = 3
         LOWSHF = 0.0
         DELSHF = 0.0
         LBPTYP = ' '
         CALL BPINI ('WRIT', TABUF1, DISK, CNO, VER, CATBLK, LUN1,
     *      IBPRNO, BPKOLS, BPNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *      LCHAN, NUMSHF, LOWSHF, DELSHF, LBPTYP, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OLD BP TABLE'
            GO TO 990
            END IF
         OBPVER = VER
         TIME = 0.0D0
         INTERV = 0.0
         SOURID = 0
         SUBA = SUBARR
         FREQID = FRQSEL
         REFANT(1) = 1
         REFANT(2) = 1
         LI = NUMIF * NUMPOL * NUMFRQ
         CALL RFILL (2*MAXIF, 1.0, WEIGHT)
         DO 110 I = 1,LI
            BNDPAS(1,I) = 1.0
            BNDPAS(2,I) = 0.0
 110        CONTINUE
         DO 130 LI = 1,NIF
            JNX = (LI + BIF - 2) * NUMFRQ + BCHAN + NUMFRQ*NUMIF
            DO 120 LC = 1,NCH
               IF (PDCOR(LC,LI).NE.DBLANK) THEN
                  BNDPAS(1,JNX) = COS (PDCOR(LC,LI)*DG2RAD)
                  BNDPAS(2,JNX) = SIN (PDCOR(LC,LI)*DG2RAD)
               ELSE
                  BNDPAS(1,JNX) = FBLANK
                  BNDPAS(2,JNX) = FBLANK
                  END IF
               JNX = JNX + 1
 120           CONTINUE
 130        CONTINUE
         DO 150 ANT = 1,NSTNS
            IBPRNO = ANT
            CALL TABBP ('WRIT', TABUF1, IBPRNO, BPKOLS, BPNUMV, NUMIF,
     *         NUMFRQ, NUMPOL, TIME, INTERV, SOURID, SUBA, ANT, BANDW,
     *         CHSHFT, FREQID, REFANT, WEIGHT, BNDPAS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITE NEW BP TABLE'
               GO TO 990
               END IF
 150        CONTINUE
         END IF
      CALL TABIO ('CLOS', 0, IBPRNO, TABUF1, TABUF1, LI)
C                                       PD update
      CALL FNDEXT ('PD', CATBLK, NUMTA)
      IF (NUMTA.LE.0) THEN
         MSGTXT = 'NO PD TABLE - HOW CAN THIS BE?'
         GO TO 990
         END IF
      MSGTXT = 'Updating existing PD table, writing new one'
      CALL MSGWRT (5)
      VER = PDVER
      CALL PDINI ('READ', TABUF2, DISK, CNO, VER, CATBLK, LUN2,
     *   IPDRNO, PDKOLS, PDNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *   POLTYP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OLD PD TABLE FOR READ'
         GO TO 990
         END IF
      VER = NUMTA + 1
      CALL PDINI ('WRIT', TABUF1, DISK, CNO, VER, CATBLK, LUN1,
     *   IPDRNO, PDKOLO, PDNUMO, NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *   POLTYP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'RE-OPEN OLD PD TABLE FOR WRITE'
         GO TO 990
         END IF
      OPDVER = VER
      NREC = TABUF2(5)
      DO 360 IREC = 1,NREC
         IPDRNO = IREC
         CALL TABPD ('READ', TABUF2, IPDRNO, PDKOLS, PDNUMV, NUMIF,
     *      NUMFRQ, NUMPOL, ANT, SUBA, FREQID, REFANT, PHDIFF, BNDPAS,
     *      IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ PD TABLE'
            GO TO 990
            END IF
         IF (((SUBA.LE.0) .OR. (SUBARR.LE.0) .OR. (SUBA.EQ.SUBARR))
     *      .AND. (IRET.GT.-3)) THEN
C                                       Just add to phase difference
            IF (POLTYP.EQ.'ORI-ELP') THEN
               DO 320 LI = 1,NIF
                  JNX = (LI + BIF - 2) * NUMFRQ + BCHAN
                  DO 310 LC = 1,NCH
                     IF (PDCOR(LC,LI).NE.DBLANK) PHDIFF(JNX) =
     *                  PHDIFF(JNX) + PDCOR(LC,LI) * DG2RAD
                     JNX = JNX + 1
 310                 CONTINUE
 320              CONTINUE
C                                       correct D terms
            ELSE
               DO 350 LI = 1,NIF
                  JNX = (LI + BIF - 2) * NUMFRQ + BCHAN
                  DO 330 LC = 1,NCH
                     XT = BNDPAS(1,JNX)
                     YT = BNDPAS(2,JNX)
                     IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK) .AND.
     *                  (PDCOR(LC,LI).NE.DBLANK)) THEN
                        CF = COS (PDCOR(LC,LI)*DG2RAD)
                        SF = SIN (PDCOR(LC,LI)*DG2RAD)
                        BNDPAS(1,JNX) = XT*CF - YT*SF
                        BNDPAS(2,JNX) = XT*SF + YT*CF
                        END IF
                     JNX = JNX + 1
 330                 CONTINUE
C                                       2nd polarization opposite
                  JNX = (LI + BIF - 2) * NUMFRQ + BCHAN +
     *               NUMFRQ * NUMIF
                  DO 340 LC = 1,NCH
                     XT = BNDPAS(1,JNX)
                     YT = BNDPAS(2,JNX)
                     IF ((XT.NE.FBLANK) .AND. (YT.NE.FBLANK) .AND.
     *                  (PDCOR(LC,LI).NE.DBLANK)) THEN
                        CF = COS (PDCOR(LC,LI)*DG2RAD)
                        SF = SIN (PDCOR(LC,LI)*DG2RAD)
                        BNDPAS(1,JNX) = XT*CF + YT*SF
                        BNDPAS(2,JNX) = YT*CF - XT*SF
                        END IF
                     JNX = JNX + 1
 340                 CONTINUE
 350              CONTINUE
               END IF
            END IF
         IPDRNO = IREC
         CALL TABPD ('WRIT', TABUF1, IPDRNO, PDKOLO, PDNUMO, NUMIF,
     *      NUMFRQ, NUMPOL, ANT, SUBA, FREQID, REFANT, PHDIFF, BNDPAS,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'RE-WRITE PD TABLE'
            GO TO 990
            END IF
 360     CONTINUE
      CALL TABIO ('CLOS', 0, IPDRNO, TABUF1, TABUF1, LI)
      CALL TABIO ('CLOS', 0, IPDRNO, TABUF2, TABUF2, LI)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPAPPL: ERROR',I4,' ON ',A)
      END
      SUBROUTINE XHDPRT (NC, NI, CSNAME, BIF, LBCHAN, LECHAN, CATBLK,
     *   DOCRT, LPNAME, PDCOR)
C-----------------------------------------------------------------------
C   XHDPRT writes a PLOTR text file if requested
C   Inputs:
C      NC       I       Number spectral channels
C      NI       I       Number IFs
C      CSNAME   C*(*)   Source names
C      DOCRT    R       not 0 => okay to write
C      LPNAME   C*(*)   not blank => write this file name
C      PDCOR    D(*)    Average phase (NC,NI,NS, ph/err/cnt/wrk1/wrk2)
C-----------------------------------------------------------------------
      INTEGER   NC, NI, BIF, LBCHAN, LECHAN, CATBLK(*)
      REAL      DOCRT
      DOUBLE PRECISION PDCOR(NC,NI,*)
      CHARACTER CSNAME(*)*(*), LPNAME*(*)
C
      INTEGER   LC, LI, JTRIM, TLUN, TIND, IERR, LUNTMP, INX, I, JJ, IC,
     *   LS, IDUM(5)
      HOLLERITH HDUM(5)
      CHARACTER LINE*80, CNAME*12, CCLAS*6, CNUMB*6
      EQUIVALENCE (IDUM, HDUM)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IF ((DOCRT.NE.0.0) .AND. (LPNAME.NE.' ')) THEN
         TLUN = LUNTMP (2)
         CALL ZTXOPN ('WRIT', TLUN, TIND, LPNAME, .TRUE., IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPEN OUTPUT TEXT FILE'
            CALL MSGWRT (8)
            GO TO 999
            END IF
         CALL COPY (5, CATBLK(KHIMN), IDUM)
         CALL H2CHR (12, KHIMNO, HDUM, CNAME)
         CALL H2CHR (6, KHIMCO, HDUM, CCLAS)
         JJ = JTRIM (CNAME)
         I = JTRIM (CCLAS)
         WRITE (CNUMB,1005) CATBLK(KIIMS)
         CALL CHTRIM (CNUMB, 6, CNUMB, LS)
         WRITE (LINE,1010) CNAME(:JJ), CCLAS(:I), CNUMB(:LS)
         INX = JTRIM (LINE)
         CALL ZTXIO ('WRIT', TLUN, TIND, LINE(:INX), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT TEXT FILE'
            GO TO 990
            END IF
         INX = 1
         LINE = ' '
         CALL ZTXIO ('WRIT', TLUN, TIND, LINE(:INX), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT TEXT FILE'
            GO TO 990
            END IF
         CALL ZTXIO ('WRIT', TLUN, TIND, LINE(:INX), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT TEXT FILE'
            GO TO 990
            END IF
         LINE = 'Channels'
         INX = JTRIM (LINE)
         CALL ZTXIO ('WRIT', TLUN, TIND, LINE(:INX), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT TEXT FILE'
            GO TO 990
            END IF
         LINE = 'XY Phase'
         INX = JTRIM (LINE)
         CALL ZTXIO ('WRIT', TLUN, TIND, LINE(:INX), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT TEXT FILE'
            GO TO 990
            END IF
         WRITE (LINE,1015) -1, 'Phase'
         INX = JTRIM (LINE)
         CALL ZTXIO ('WRIT', TLUN, TIND, LINE(:INX), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT TEXT FILE'
            GO TO 990
            END IF
         WRITE (LINE,1015) -2, 'Error'
         INX = JTRIM (LINE)
         CALL ZTXIO ('WRIT', TLUN, TIND, LINE(:INX), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'WRITE OUTPUT TEXT FILE'
            GO TO 990
            END IF
         INX = 22
         DO 30 LI = 1,NI
            IC = (LI+BIF-2) * NC + LBCHAN - 1
            DO 20 LC = LBCHAN,LECHAN
               IC = IC + 1
               IF (PDCOR(LC,LI,1).NE.DBLANK) THEN
                  WRITE (LINE,1020) IC, PDCOR(LC,LI,1), 1
                  INX = JTRIM (LINE)
                  CALL ZTXIO ('WRIT', TLUN, TIND, LINE(:INX), IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1000) IERR,
     *                  'WRITE OUTPUT TEXT FILE'
                     GO TO 990
                     END IF
                  END IF
 20            CONTINUE
 30         CONTINUE
         DO 50 LI = 1,NI
            IC = (LI+BIF-2) * NC + LBCHAN - 1
            DO 40 LC = LBCHAN,LECHAN
               IC = IC + 1
               IF (PDCOR(LC,LI,1).NE.DBLANK) THEN
                  WRITE (LINE,1020) IC, PDCOR(LC,LI,2), 2
                  INX = JTRIM (LINE)
                  CALL ZTXIO ('WRIT', TLUN, TIND, LINE(:INX), IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1000) IERR,
     *                  'WRITE OUTPUT TEXT FILE'
                     GO TO 990
                     END IF
                  END IF
 40            CONTINUE
 50         CONTINUE
         CALL ZTXCLS (TLUN, TIND, IERR)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XHDPRT: ERROR:',I4,' ON ',A)
 1005 FORMAT (I6)
 1010 FORMAT ('Phase corrections for ',A,'.',A,'.',A)
 1015 FORMAT ('SL',I4,2X,A,1X,A)
 1020 FORMAT (I7,F11.3,I4)
      END
      SUBROUTINE XHDSMT (NC, NI, LBCHAN, LECHAN, CATBLK, XINTP, DOINV,
     *   PDCOR)
C-----------------------------------------------------------------------
C   XHDSMT smooths the phases which are about to be applied
C   Inputs:
C      NC       I       Number spectral channels
C      NI       I       Number IFs
C      LBCHAN   I       Ignore solutions from channels < LBCHAN
C      LECHAN   I       Ignore colutions from channels > LECHAN
C      DOINV    R       180 to add
C   In/out:
C      XINTP    R(3)    Smoothing parameters
C      PDCOR    D(*)    Average phase (NC,NI,NS, ph/err/cnt/wrk1/wrk2)
C-----------------------------------------------------------------------
      INTEGER   NC, NI, LBCHAN, LECHAN, CATBLK(*)
      REAL      XINTP(3), DOINV
      DOUBLE PRECISION PDCOR(NC,NI,*)
C
      INTEGER   IT, I, N, LC, LI, PSMRAD, J1, J2, J, K
      DOUBLE PRECISION FX, X, W, WIDTHS(4), SUPS(4), PSMTAB(1024), CS,
     *   SS, WS
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA WIDTHS /4.0, 2.0, 2.0, 3.0/
      DATA SUPS /1.0, 3.0, 1.0, 4.0/
C-----------------------------------------------------------------------
C                                       type and defaults
      IT = XINTP(1) + 0.1
      IT = MAX (0, IT)
      IF (IT.GT.0) IT = MOD (IT-1,4) + 1
      XINTP(1) = IT
C                                       no smoothing, do extrapolation
      IF (IT.EQ.0) THEN
         XINTP(2) = 0.0
         XINTP(3) = 0.0
         DO 30 LI = 1,NI
            DO 10 LC = 1,LBCHAN-1
               PDCOR(LC,LI,1) = PDCOR(LBCHAN,LI,1)
               PDCOR(LC,LI,2) = PDCOR(LBCHAN,LI,2)
 10            CONTINUE
            DO 20 LC = LECHAN+1,NC
               PDCOR(LC,LI,1) = PDCOR(LECHAN,LI,1)
               PDCOR(LC,LI,2) = PDCOR(LECHAN,LI,2)
 20            CONTINUE
 30         CONTINUE
C                                       smoothing
      ELSE
         N = CATBLK(KINAX+JLOCF)
         IF ((XINTP(2).LT.0.5) .OR. (XINTP(2).GT.N/3.0)) XINTP(2) =
     *      WIDTHS(IT)
         IF ((XINTP(3).GT.4.0*SUPS(IT)*XINTP(2)) .OR.
     *      (XINTP(3).LT.XINTP(2))) XINTP(3) = XINTP(2) * SUPS(IT)
         PSMRAD = XINTP(3) / 2.0 + 0.1
         IF (PSMRAD.GT.510) THEN
            PSMRAD = 509
            XINTP(3) = 2.0* PSMRAD
            XINTP(2) = XINTP(3) / SUPS(IT)
            END IF
         N = PSMRAD + 1
         FX = 2.0 / XINTP(2)
         W = 1.0
         PSMTAB(1) = 1.0
C                                       Hanning smooth
         IF (IT.EQ.1) THEN
            DO 40 I = 2,N
               X = I - 1.0
               PSMTAB(I) = MAX (0.0D0, 1.0-FX*X)
               W = W + 2 * PSMTAB(I)
 40            CONTINUE
C                                       Gaussian smooth
         ELSE IF (IT.EQ.2) THEN
            FX = -LOG(2.0) * FX * FX
            DO 45 I = 2,N
               X = I - 1.0
               PSMTAB(I) = EXP (FX * X * X)
               W = W + 2 * PSMTAB(I)
 45            CONTINUE
C                                       Boxcar smooth
         ELSE IF (IT.EQ.3) THEN
            FX = 1.0 / FX
            DO 50 I = 2,N
               X = I - 1.0
               IF (X.LE.FX) PSMTAB(I) = 1.0
               W = W + 2 * PSMTAB(I)
 50            CONTINUE
C                                      Sinc smooth
         ELSE IF (IT.EQ.4) THEN
            FX = 3.14159 * FX
            DO 55 I = 2,N
               X = (I - 1.0) * FX
               PSMTAB(I) = SIN(X) / X
               W = W + 2 * PSMTAB(I)
 55            CONTINUE
            END IF
C                                       Normalize integral
         IF (W.LE.0.0) W = 1.0
         DO 60 I = 1,N
            PSMTAB(I) = PSMTAB(I) / W
 60         CONTINUE
C                                       Now smooth
         DO 100 LI = 1,NI
            DO 80 LC = 1,NC
               CS = 0.0D0
               SS = 0.0D0
               WS = 0.0D0
               J1 = MAX (LBCHAN, LC-PSMRAD)
               J2 = MIN (LECHAN, LC+PSMRAD)
               DO 70 J = J1,J2
                  K = ABS (J-LC) + 1
                  IF ((PDCOR(J,LI,1).NE.DBLANK) .AND.
     *               (PDCOR(J,LI,2).GT.0.0)) THEN
                     W = PSMTAB(K) / (PDCOR(J,LI,2) ** 2)
                     CS = CS + W * COS (PDCOR(J,LI,1)*DG2RAD)
                     SS = SS + W * SIN (PDCOR(J,LI,1)*DG2RAD)
                     WS = WS + W
                     END IF
 70               CONTINUE
               IF (WS.GT.0.0) THEN
C                  PDCOR(LC,LI,5) = ATAN2 (SS, CS) * RAD2DG
                  PDCOR(LC,LI,5) = ATAN (SS/CS) * RAD2DG + DOINV
                  PDCOR(LC,LI,4) = SQRT (1.0 / WS)
               ELSE
                  PDCOR(LC,LI,5) = DBLANK
                  PDCOR(LC,LI,4) = DBLANK
                  END IF
 80            CONTINUE
            J1 = NC + 1
            J2 = 0
            DO 85 LC = 1,NC
               PDCOR(LC,LI,1) = PDCOR(LC,LI,5)
               PDCOR(LC,LI,2) = PDCOR(LC,LI,4)
               IF (PDCOR(LC,LI,1).NE.DBLANK) THEN
                  J1 = MIN (J1, LC)
                  J2 = MAX (J2, LC)
                  END IF
 85            CONTINUE
            DO 90 LC = 1,J1-1
               PDCOR(LC,LI,1) = PDCOR(J1,LI,1)
               PDCOR(LC,LI,2) = PDCOR(J1,LI,2)
 90            CONTINUE
            DO 95 LC = J2+1,NC
               PDCOR(LC,LI,1) = PDCOR(J2,LI,1)
               PDCOR(LC,LI,2) = PDCOR(J2,LI,2)
 95            CONTINUE
 100        CONTINUE
         END IF
C                                       interpolate remaining blanks
      DO 200 LI = 1,NI
         DO 190 LC = 1,NC
            IF (PDCOR(LC,LI,1).EQ.DBLANK) THEN
               J1 = -999999
               DO 110 I = LC-1,1,-1
                  IF (PDCOR(I,LI,1).NE.DBLANK) J1 = MAX (J1, I)
 110              CONTINUE
               J2 = 999999
               DO 120 I = LC+1,NC
                  IF (PDCOR(I,LI,1).NE.DBLANK) J2 = MIN (J2, I)
 120              CONTINUE
               IF ((J1.GT.0) .AND. (J2.LE.NC)) THEN
                  DO 130 I = J1+1,J2-1
                     PDCOR(I,LI,1) = ((I-J1) * PDCOR(J1,LI,1) +
     *                  (J2-I) * PDCOR(J2,LI,1)) / (J2-J1)
                     PDCOR(I,LI,2) = ((I-J1) * PDCOR(J1,LI,2) +
     *                  (J2-I) * PDCOR(J2,LI,2)) / (J2-J1)
 130                 CONTINUE
               ELSE IF (J1.GT.0) THEN
                  DO 140 I = J1+1,NC
                     PDCOR(I,LI,1) = PDCOR(J1,LI,1)
                     PDCOR(I,LI,2) = PDCOR(J1,LI,2)
 140                 CONTINUE
               ELSE IF (J2.LE.NC) THEN
                  DO 150 I = 1,J2-1
                     PDCOR(I,LI,1) = PDCOR(J2,LI,1)
                     PDCOR(I,LI,2) = PDCOR(J2,LI,2)
 150                 CONTINUE
C                                       all blanked
               ELSE
                  GO TO 200
                  END IF
               END IF
 190        CONTINUE
 200     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE XHDHI (NCH, NIF, IB, IE, CLCORP, PCLCOR)
C-----------------------------------------------------------------------
C   writes HI records when solution is appled to data
C-----------------------------------------------------------------------
      INTEGER   NCH, NIF, IB, IE
      REAL      CLCORP(*), PCLCOR(*)
C
      INCLUDE 'VHDIF.INC'
      INTEGER   LUN, LUNTMP, TIME(3), DATE(3), IERR, BUFF2(256), I
      CHARACTER CTIME(2)*12, HILINE*72
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       skip if values are going away
      IF ((DOLINE.GT.0.0) .AND. (DOAPLY.LE.0.0)) GO TO 999
C                                       Write History.
      LUN = LUNTMP (1)
      CALL HIINIT (3)
C                                       Open old history
      CALL HIOPEN (LUN, DISKIN, CNOIN, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,1000) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       calibration et al.
      CALL CALHIS (LUN, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       SPECTRAL, INTPARM
      IF (DOLINE.LE.0.0) THEN
         HILINE = TSKNAM // 'SPECTRAL = -1   / continuum mode used'
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         DO 20 I = IB,IE
            WRITE (HILINE,1015) TSKNAM, I, CLCORP(I-IB+1),
     *         PCLCOR(I-IB+1+NIF)
            CALL HIADD (LUN, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
 20         CONTINUE
      ELSE
         HILINE = TSKNAM // 'SPECTRAL = +1   / spectral mode used'
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         IF (XINTP(1).EQ.0.0) THEN
            HILINE = TSKNAM // 'INTPARM = 0  / no spectral smoothing'
         ELSE
            WRITE (HILINE,1020) TSKNAM, XINTP
            END IF
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         IF ((LBCHAN.GT.1) .OR. (LECHAN.LT.NCH)) THEN
            WRITE (HILINE,1025) LBCHAN, LECHAN
            CALL HIADD (LUN, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
            END IF
         END IF
      IF (DOAPLY.GT.0.0) THEN
         HILINE = TSKNAM // 'DOAPPLY = 1   / corrections applied'
     *      // ' by ' // TSKNAM
      ELSE
         HILINE = TSKNAM // 'DOAPPLY = -1   / corrections NOT applied'
     *      // ' by ' // TSKNAM
         END IF
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
      IF (DOAPLY.GT.0.0) THEN
         IF (DOLINE.GT.0.0) THEN
            WRITE (HILINE,1030) TSKNAM, 'PD', PDVER
            CALL HIADD (LUN, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
            WRITE (HILINE,1035) TSKNAM, 'PD', OPDVER
            CALL HIADD (LUN, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
            IF (BPVER.GT.0) THEN
               WRITE (HILINE,1030) TSKNAM, 'BP', BPVER
               CALL HIADD (LUN, HILINE, BUFF2, IERR)
               IF (IERR.NE.0) GO TO 200
               WRITE (HILINE,1035) TSKNAM, 'BP', OBPVER
               CALL HIADD (LUN, HILINE, BUFF2, IERR)
               IF (IERR.NE.0) GO TO 200
            ELSE
               WRITE (HILINE,1045) TSKNAM, 'BP', OBPVER
               CALL HIADD (LUN, HILINE, BUFF2, IERR)
               IF (IERR.NE.0) GO TO 200
               END IF
         ELSE
            WRITE (HILINE,1030) TSKNAM, 'CL', CLVER
            CALL HIADD (LUN, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
            WRITE (HILINE,1035) TSKNAM, 'CL', OCLVER
            CALL HIADD (LUN, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
            WRITE (HILINE,1040) TSKNAM, 'AN', SUBARR
            CALL HIADD (LUN, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
            END IF
         END IF
      IF (DOLINE.GT.0.0) THEN
         WRITE (HILINE,1045) TSKNAM, 'PP', PPVER
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         IF (SNVER.GT.0) THEN
            WRITE (HILINE,1046) TSKNAM, 'SN', SNVER
            CALL HIADD (LUN, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
            END IF
         END IF
      WRITE (HILINE,1050) TSKNAM, DOINV
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Close HI file
 200  CALL HICLOS (LUN, .TRUE., BUFF2, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 1015 FORMAT (A6,'/ IF',I3,' avg XY phase',F8.3,' +-',F8.3)
 1020 FORMAT (A6,'INTPARM=',F3.0,2(',',F5.1),3X,'/ smoothing parms')
 1025 FORMAT (A6,'BCHAN=',I5,' ECHAN=',I5,' / extrapolate solutions',
     *   ' outside')
 1030 FORMAT (A6,'/ input  ',A,' table version =',I4)
 1035 FORMAT (A6,'/ output ',A,' table version =',I4)
 1040 FORMAT (A6,'/ input  ',A,' table version =',I4,' updated')
 1045 FORMAT (A6,'/ output ',A,' table version =',I4,' created')
 1046 FORMAT (A6,'/ output ',A,' table version =',I4,
     *   ' with time dependence')
 1050 FORMAT (A6,'DOINVERS =',F6.1,'   / Phase added to answer')
      END
      SUBROUTINE DVHROT (VISIN, PA1, PA2, VISOUT)
C-----------------------------------------------------------------------
C   SPECIAL VERSION - DOES NOT DO THE ROTATION
C   Gets requested data from XY Stokes visibility record, reformatting as
C   needed.  REQUIRES setup by DGINIT to set values in common DSEL.INC.
C   Inputs:
C      VISIN    R(3)   Input visibility array (1 channel real, imag, wt)
C                      Data order VV HH VH HV
C      PA1      R      Parallactic angle zntenna 1 - lambda^2 * IFR(1)
C      PA2      R      Parallactic angle zntenna 2 - lambda^2 * IFR(2)
c                      radians
C   Input from DSEL.INC
C   Output:
C      VISOUT   R(3)   Output visibility record - may be VISIN
C                      Data order VV HH VH HV
C-----------------------------------------------------------------------
      REAL      VISIN(3,4), PA1, PA2, VISOUT(3,4)
C
C      INTEGER   I, J, K
C      REAL      C1, C2, S1, S2, ARR(4,4), VISI(3,4), VISO(3,4)
C-----------------------------------------------------------------------
      CALL RCOPY (12, VISIN, VISOUT)
C
 999  RETURN
      END
      SUBROUTINE PPFILE (DISK, CNO, PPVER, BCHAN, BIF, SUBARR, FRQSEL,
     *   NCH, NIF, NUMIF, SNVER, XCHNS, PDCOR, CATBLK, IRET)
C-----------------------------------------------------------------------
C   PPFILE writes out a PP table containing the R-L phase difference
C   spectrum
C   Inputs
C      DISK     I      Disk number
C      CNO      I      Catalog number
C      BCHAN    I      Begin channel
C      BIF      I      Begin IF
C      SUBARR   I      Subarray
C      FRQSEL   I      Freq ID
C      NCH      I      Number channels
C      NIF      I      Number IFs in PP
C      NUMIF    I      Number IFs in data set
C      PDCOR    D(*)   Phase change in degrees (Nch,Nif)
C   In/Out:
C      CATBLK   I(*)   UV file header
C   Output:
C      SNVER    I      SN table version
C      IRET     I      error code
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, PPVER, BCHAN, BIF, SUBARR, FRQSEL, NCH, NIF,
     *   NUMIF, SNVER, CATBLK(*), IRET
      REAL      XCHNS(4,20)
      DOUBLE PRECISION PDCOR(NCH,NIF,*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   LUN, LUNTMP, PPBUFF(512), IPPRNO, PPKOLS(5), I,
     *   PPNUMV(5), NW(MAXIF), J, K, K1, K2, CHNSEL(3,20,MAXIF), IROUND,
     *   IREC, NREC, SNLUN, SNKOLS(MAXSNC), SNNUMV(MAXSNC), ISNRNO, IIF,
     *   NUMPOL, NUMNOD, SNBUFF(512), ANTNO, NODENO, SOURID,
     *   REFA(2,MAXIF), PPOL
      REAL      REFPHS(MAXIF), PHS(MAXIF), GNMOD, RANOD(25), DECNOD(25),
     *   TIME, TIMEI, IFR, MBDELY(2), DISP(2), DDISP(2), CREAL(2,MAXIF),
     *   CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF), WEIGHT(2,MAXIF)
      DOUBLE PRECISION DTIME
      LOGICAL   ISAPPL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      LUN = LUNTMP(1)
      PPOL = 2
      CALL PPINI ('WRIT', PPBUFF, DISK, CNO, PPVER, CATBLK, LUN, IPPRNO,
     *   PPKOLS, PPNUMV, NIF, NCH, BIF, BCHAN, PPOL, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATE PHASE DIFF TABLE'
         GO TO 990
         END IF
      IPPRNO = 1
      CALL TABPP ('WRIT', PPBUFF, IPPRNO, PPKOLS, PPNUMV, 0.0, SUBARR,
     *   FRQSEL, PDCOR(1,1,1), PDCOR(1,1,2), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITING PHASE DIFFERENCE TABLE'
         GO TO 990
         END IF
      SNVER = 0
C                                       SN table output
      IF (PPBUFF(5).GT.2) THEN
         NREC = PPBUFF(5)
C                                       Channel selection
         I = 60 * MAXIF
         CALL FILL (I, 0, CHNSEL)
         CALL FILL (MAXIF, 0, NW)
         DO 20 J = 1,20
            K = IROUND (XCHNS(2,J))
            IF (K.GT.0) THEN
               K = IROUND (XCHNS(4,J))
               IF ((K.LE.0) .OR. (K.GT.MAXIF)) THEN
                  K1 = 1
                  K2 = MAXIF
               ELSE
                  K1 = K
                  K2 = K
                  END IF
               DO 15 K = K1,K2
                  NW(K) = NW(K) + 1
                  DO 10 I = 1,3
                     CHNSEL(I,NW(K),K) = IROUND (XCHNS(I,J))
                     IF (CHNSEL(I,NW(K),K).LT.0) CHNSEL(I,NW(K),K) = 0
 10                  CONTINUE
                  IF (CHNSEL(3,NW(K),K).EQ.0) CHNSEL(3,NW(K),K) = 1
 15               CONTINUE
               END IF
 20         CONTINUE
C                                       If no channel selection
C                                       use VLA definition of
C                                       channel 0
         DO 30 K = 1,MAXIF
            IF (NW(K).LE.0) THEN
               NW(K) = 1
               CHNSEL(1,1,K) = (NCH+1)/8 + 1
               CHNSEL(2,1,K) = NCH - ((NCH+1)/8)
               CHNSEL(3,1,K) = 1
               END IF
            DO 25 I = 1,NW(K)
               CHNSEL(1,I,K) = MAX (1, MIN (CHNSEL(1,I,K), NCH))
               IF (CHNSEL(2,I,K).LT.CHNSEL(1,I,K))
     *            CHNSEL(2,I,K) = NCH
               CHNSEL(2,I,K) = MAX (1, MIN (CHNSEL(2,I,K), NCH))
 25            CONTINUE
 30         CONTINUE
C                                       get averages of average solution
         CALL AVERIT (NCH, NIF, CHNSEL, PDCOR(1,1,1), REFPHS)
C                                       init SN table
         SNVER = 0
         NUMNOD = 0
         ISAPPL = .FALSE.
         SNLUN = LUNTMP(1)
         NUMPOL = 2
         CALL SNINI ('WRIT', SNBUFF, DISK, CNO, SNVER, CATBLK, SNLUN,
     *      ISNRNO, SNKOLS, SNNUMV, NSTNS, NUMPOL, NUMIF, NUMNOD, GNMOD,
     *      RANOD, DECNOD, ISAPPL, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATING OUTPUT SN TABLE'
            GO TO 990
            END IF
         IFR = 0.
         CALL RFILL (2, 0.0, MBDELY)
         CALL RFILL (2, 0.0, DISP)
         CALL RFILL (2, 0.0, DDISP)
         I = 2 * NUMIF
         CALL RFILL (I, 1.0, CREAL)
         CALL RFILL (I, 0.0, CIMAG)
         CALL RFILL (I, 0.0, DELAY)
         CALL RFILL (I, 0.0, RATE)
         CALL RFILL (I, 1.0, WEIGHT)
         CALL FILL (I, 1, REFA)
C                                       loop over PP table
         DO 100 IREC = 2,NREC
            IPPRNO = IREC
            CALL TABPP ('READ', PPBUFF, IPPRNO, PPKOLS, PPNUMV, TIME,
     *         SUBARR, FRQSEL, PDCOR(1,1,3), PDCOR(1,1,4), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET,
     *            'RE-READING PHASE DIFFERENCE TABLE'
               GO TO 990
               END IF
            CALL AVERIT (NCH, NIF, CHNSEL, PDCOR(1,1,3), PHS)
            DO 40 IIF = 1,NIF
               IF ((PHS(IIF).NE.FBLANK) .AND. (REFPHS(IIF).NE.FBLANK))
     *            THEN
                  PHS(IIF) = PHS(IIF) - REFPHS(IIF)
                  CREAL(2,IIF+BIF-1) = COS (PHS(IIF) * DG2RAD)
                  CIMAG(2,IIF+BIF-1) = SIN (PHS(IIF) * DG2RAD)
               ELSE
                  CREAL(2,IIF+BIF-1) = FBLANK
                  CIMAG(2,IIF+BIF-1) = FBLANK
                  END IF
 40            CONTINUE
            DTIME = TIME
            TIMEI = 10. / 1440.
            SOURID = 0
            DO 50 ANTNO = 1,NSTNS
               CALL TABSN ('WRIT', SNBUFF, ISNRNO, SNKOLS, SNNUMV,
     *            NUMPOL, DTIME, TIMEI, SOURID, ANTNO, SUBARR, FRQSEL,
     *            IFR, NODENO, MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY,
     *            RATE, WEIGHT, REFA, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITING SN TABLE'
                  GO TO 990
                  END IF
 50            CONTINUE
 100        CONTINUE
         CALL TABSN ('CLOS', SNBUFF, ISNRNO, SNKOLS, SNNUMV, NUMPOL,
     *      DTIME, TIMEI, SOURID, ANTNO, SUBARR, FRQSEL, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
         WRITE (MSGTXT,1100) SNVER
         CALL MSGWRT (3)
         END IF
C                                       close the PP table
      CALL TABPP ('CLOS', PPBUFF, IPPRNO, PPKOLS, PPNUMV, 0.0, SUBARR,
     *   FRQSEL, PDCOR, PDCOR, IRET)
      IRET = 0
      WRITE (MSGTXT,1110) PPVER
      CALL MSGWRT (3)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PPFILE: ERROR',I4,' ON ',A)
 1100 FORMAT ('Wrote phase adjustments as time function in SN table',
     *   ' version',I4)
 1110 FORMAT ('Wrote phase corrections into PP table version',I4)
      END
      SUBROUTINE AVERIT (NCH, NIF, CHNSEL, PDCOR, PHS)
C-----------------------------------------------------------------------
C   Average the phases in a solution record
C   Inputs:
C      NCH      I      Number spectral channels
C      NIF      I      Number IFs
C      CHNSEL   I(*)   Channels to use
C      PDCOR    D(*)   solution record (nch, nif, 2)
C   Output
C      PHS      R(*)   average phase per IF
C-----------------------------------------------------------------------
      INTEGER   NCH, NIF, CHNSEL(3,20,*)
      DOUBLE PRECISION PDCOR(NCH,NIF,2)
      REAL      PHS(*)
C
      INTEGER   I, J, K
      DOUBLE PRECISION CSUM, SSUM, WSUM, WT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                        loop over IF
      DO 50 K = 1,NIF
         WSUM = 0.0D0
         CSUM = 0.0D0
         SSUM = 0.0D0
         DO 20 J = 1,20
            IF ((CHNSEL(1,J,K).GT.0) .AND. (CHNSEL(3,J,K).GT.0) .AND.
     *         (CHNSEL(2,J,K).GE.CHNSEL(1,J,K))) THEN
               DO 10 I = CHNSEL(1,J,K),CHNSEL(2,J,K),CHNSEL(3,J,K)
                  IF ((PDCOR(I,K,1).NE.DBLANK) .AND.
     *               (PDCOR(I,K,2).NE.DBLANK)) THEN
                     WT = PDCOR(I,K,2) * RAD2DG
                     IF (WT.NE.0.0D0) WT = 1.0D0 / (WT * WT)
                     WSUM = WSUM + WT
                     CSUM = CSUM + WT * COS (PDCOR(I,K,1) * DG2RAD)
                     SSUM = SSUM + WT * SIN (PDCOR(I,K,1) * DG2RAD)
                     END IF
 10               CONTINUE
               END IF
 20         CONTINUE
         IF (WSUM.GT.0.0) THEN
            PHS(K) = RAD2DG * ATAN2 (SSUM, CSUM)
         ELSE
            PHS(K) = FBLANK
            END IF
 50      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE DSICO (A, LDA, N, KPVT, RCOND, Z)
C-----------------------------------------------------------------------
C! Factors a symmetric matrix.
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C     DSICO FACTORS A DOUBLE PRECISION SYMMETRIC MATRIX BY ELIMINATION
C     WITH SYMMETRIC PIVOTING AND ESTIMATES THE CONDITION OF THE
C     MATRIX.
C
C     IF  RCOND  IS NOT NEEDED, DSIFA IS SLIGHTLY FASTER.
C     TO SOLVE  A*X = B , FOLLOW DSICO BY DSISL.
C     TO COMPUTE  INVERSE(A)*C , FOLLOW DSICO BY DSISL.
C     TO COMPUTE  INVERSE(A) , FOLLOW DSICO BY DSIDI.
C     TO COMPUTE  DETERMINANT(A) , FOLLOW DSICO BY DSIDI.
C     TO COMPUTE  INERTIA(A), FOLLOW DSICO BY DSIDI.
C
C     ON ENTRY
C
C        A       DOUBLE PRECISION(LDA, N)
C                THE SYMMETRIC MATRIX TO BE FACTORED.
C                ONLY THE DIAGONAL AND UPPER TRIANGLE ARE USED.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  A .
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX  A .
C
C     OUTPUT
C
C        A       A BLOCK DIAGONAL MATRIX AND THE MULTIPLIERS WHICH
C                WERE USED TO OBTAIN IT.
C                THE FACTORIZATION CAN BE WRITTEN  A = U*D*TRANS(U)
C                WHERE  U  IS A PRODUCT OF PERMUTATION AND UNIT
C                UPPER TRIANGULAR MATRICES , TRANS(U) IS THE
C                TRANSPOSE OF  U , AND  D  IS BLOCK DIAGONAL
C                WITH 1 BY 1 AND 2 BY 2 BLOCKS.
C
C        KPVT    INTEGER(N)
C                AN INTEGER VECTOR OF PIVOT INDICES.
C
C        RCOND   DOUBLE PRECISION
C                AN ESTIMATE OF THE RECIPROCAL CONDITION OF  A .
C                FOR THE SYSTEM  A*X = B , RELATIVE PERTURBATIONS
C                IN  A  AND  B  OF SIZE  EPSILON  MAY CAUSE
C                RELATIVE PERTURBATIONS IN  X  OF SIZE  EPSILON/RCOND .
C                IF  RCOND  IS SO SMALL THAT THE LOGICAL EXPRESSION
C                           1.0 + RCOND.EQ.1.0
C                IS TRUE, THEN  A  MAY BE SINGULAR TO WORKING
C                PRECISION.  IN PARTICULAR,  RCOND  IS ZERO  IF
C                EXACT SINGULARITY IS DETECTED OR THE ESTIMATE
C                UNDERFLOWS.
C
C        Z       DOUBLE PRECISION(N)
C                A WORK VECTOR WHOSE CONTENTS ARE USUALLY UNIMPORTANT.
C                IF  A  IS CLOSE TO A SINGULAR MATRIX, THEN  Z  IS
C                AN APPROXIMATE NULL VECTOR IN THE SENSE THAT
C                NORM(A*Z) = RCOND*NORM(A)*NORM(Z) .
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     LINPACK DSIFA
C     BLAS DAXPY,DFDOT,DSCAL,DASUM
C     FORTRAN DABS,DMAX1,IABS,DSIGN
C-----------------------------------------------------------------------
      INTEGER LDA, N
      INTEGER   KPVT(*)
      DOUBLE PRECISION A(LDA,*), Z(*)
      DOUBLE PRECISION RCOND
C
C     INTERNAL VARIABLES
C
      DOUBLE PRECISION AK, AKM1, BK, BKM1, DFDOT, DENOM, EK, T
      DOUBLE PRECISION ANORM, S, DASUM, YNORM
      INTEGER   I, INFO, J, JM1, K, KP, KPS, KS
      INTEGER   IT1
C-----------------------------------------------------------------------
C     FIND NORM OF A USING ONLY UPPER HALF
C
      DO 30 J = 1, N
         Z(J) = DASUM (J, A(1,J), 1)
         JM1 = J - 1
         IF (JM1.LT.1) GO TO 20
         DO 10 I = 1, JM1
            Z(I) = Z(I) + ABS (A(I,J))
   10    CONTINUE
   20    CONTINUE
   30 CONTINUE
      ANORM = 0.0D0
      DO 40 J = 1, N
         ANORM = MAX (ANORM,Z(J))
   40 CONTINUE
C
C     FACTOR
C
      CALL DSIFA (A, LDA, N, KPVT, INFO)
C
C     RCOND = 1/(NORM(A)*(ESTIMATE OF NORM(INVERSE(A)))) .
C     ESTIMATE = NORM(Z)/NORM(Y) WHERE  A*Z = Y  AND  A*Y = E .
C     THE COMPONENTS OF  E  ARE CHOSEN TO CAUSE MAXIMUM LOCAL
C     GROWTH IN THE ELEMENTS OF W  WHERE  U*D*W = E .
C     THE VECTORS ARE FREQUENTLY RESCALED TO AVOID OVERFLOW.
C
C     SOLVE U*D*W = E
C
      EK = 1.0D0
      DO 50 J = 1, N
         Z(J) = 0.0D0
   50 CONTINUE
      K = N
   60 IF (K.EQ.0) GO TO 120
         KS = 1
         IF (KPVT(K).LT.0) KS = 2
         KP = ABS (KPVT(K))
         KPS = K + 1 - KS
         IF (KP.EQ.KPS) GO TO 70
            T = Z(KPS)
            Z(KPS) = Z(KP)
            Z(KP) = T
   70    CONTINUE
         IF (Z(K) .NE. 0.0D0) EK = SIGN(EK, Z(K))
         Z(K) = Z(K) + EK
         IT1 = K-KS
         CALL DAXPY (IT1, Z(K), A(1,K), 1, Z(1), 1)
         IF (KS.EQ.1) GO TO 80
            IF (Z(K-1) .NE. 0.0D0) EK = SIGN(EK,Z(K-1))
            Z(K-1) = Z(K-1) + EK
            IT1 = K-KS
            CALL DAXPY (IT1, Z(K-1), A(1,K-1), 1, Z(1), 1)
   80    CONTINUE
         IF (KS.EQ.2) GO TO 100
            IF (ABS (Z(K)).LE.ABS (A(K,K))) GO TO 90
               S = ABS (A(K,K)) / ABS (Z(K))
               CALL DSCAL (N, S, Z, 1)
               EK = S*EK
   90       CONTINUE
            IF (A(K,K) .NE. 0.0D0) Z(K) = Z(K)/A(K,K)
            IF (A(K,K).EQ.0.0D0) Z(K) = 1.0D0
         GO TO 110
  100    CONTINUE
            AK = A(K,K)/A(K-1,K)
            AKM1 = A(K-1,K-1)/A(K-1,K)
            BK = Z(K)/A(K-1,K)
            BKM1 = Z(K-1)/A(K-1,K)
            DENOM = AK*AKM1 - 1.0D0
            Z(K) = (AKM1*BK - BKM1)/DENOM
            Z(K-1) = (AK*BKM1 - BK)/DENOM
  110    CONTINUE
         K = K - KS
      GO TO 60
  120 CONTINUE
      S = 1.0D0/DASUM (N, Z, 1)
      CALL DSCAL (N, S, Z, 1)
C
C     SOLVE TRANS(U)*Y = W
C
      K = 1
  130 IF (K.GT.N) GO TO 160
         KS = 1
         IF (KPVT(K).LT.0) KS = 2
         IF (K.EQ.1) GO TO 150
            IT1 = K-1
            Z(K) = Z(K) + DFDOT (IT1, A(1,K), 1, Z(1), 1)
            IF (KS.EQ.2)
     *         Z(K+1) = Z(K+1) + DFDOT (IT1, A(1,K+1), 1, Z(1), 1)
            KP = ABS (KPVT(K))
            IF (KP.EQ.K) GO TO 140
               T = Z(K)
               Z(K) = Z(KP)
               Z(KP) = T
  140       CONTINUE
  150    CONTINUE
         K = K + KS
      GO TO 130
  160 CONTINUE
      S = 1.0D0 / DASUM (N, Z, 1)
      CALL DSCAL (N, S, Z, 1)
C
      YNORM = 1.0D0
C
C     SOLVE U*D*V = Y
C
      K = N
  170 IF (K.EQ.0) GO TO 230
         KS = 1
         IF (KPVT(K).LT.0) KS = 2
         IF (K.EQ.KS) GO TO 190
            KP = ABS (KPVT(K))
            KPS = K + 1 - KS
            IF (KP.EQ.KPS) GO TO 180
               T = Z(KPS)
               Z(KPS) = Z(KP)
               Z(KP) = T
  180       CONTINUE
            IT1 = K-KS
            CALL DAXPY (IT1, Z(K), A(1,K), 1, Z(1), 1)
            IF (KS.EQ.2)
     *         CALL DAXPY (IT1, Z(K-1), A(1,K-1), 1, Z(1), 1)
  190    CONTINUE
         IF (KS.EQ.2) GO TO 210
            IF (ABS (Z(K)).LE.ABS (A(K,K))) GO TO 200
               S = ABS (A(K,K))/ABS (Z(K))
               CALL DSCAL (N, S, Z, 1)
               YNORM = S*YNORM
  200       CONTINUE
            IF (A(K,K) .NE. 0.0D0) Z(K) = Z(K)/A(K,K)
            IF (A(K,K).EQ.0.0D0) Z(K) = 1.0D0
         GO TO 220
  210    CONTINUE
            AK = A(K,K)/A(K-1,K)
            AKM1 = A(K-1,K-1)/A(K-1,K)
            BK = Z(K)/A(K-1,K)
            BKM1 = Z(K-1)/A(K-1,K)
            DENOM = AK*AKM1 - 1.0D0
            Z(K) = (AKM1*BK - BKM1)/DENOM
            Z(K-1) = (AK*BKM1 - BK)/DENOM
  220    CONTINUE
         K = K - KS
      GO TO 170
  230 CONTINUE
      S = 1.0D0 / DASUM (N, Z, 1)
      CALL DSCAL (N, S, Z, 1)
      YNORM = S*YNORM
C
C     SOLVE TRANS(U)*Z = V
C
      K = 1
  240 IF (K.GT.N) GO TO 270
         KS = 1
         IF (KPVT(K).LT.0) KS = 2
         IF (K.EQ.1) GO TO 260
            IT1 = K-1
            Z(K) = Z(K) + DFDOT (IT1, A(1,K), 1, Z(1), 1)
            IF (KS.EQ.2)
     *         Z(K+1) = Z(K+1) + DFDOT (IT1, A(1,K+1), 1, Z(1), 1)
            KP = ABS (KPVT(K))
            IF (KP.EQ.K) GO TO 250
               T = Z(K)
               Z(K) = Z(KP)
               Z(KP) = T
  250       CONTINUE
  260    CONTINUE
         K = K + KS
      GO TO 240
  270 CONTINUE
C     MAKE ZNORM = 1.0
      S = 1.0D0  / DASUM (N, Z, 1)
      CALL DSCAL (N, S, Z, 1)
      YNORM = S*YNORM
C
      IF (ANORM .NE. 0.0D0) RCOND = YNORM/ANORM
      IF (ANORM.EQ.0.0D0) RCOND = 0.0D0
C
 999  RETURN
      END

LOCAL INCLUDE 'NNLSQ.INC'
C                                       Local include for NNLSQ
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO,
     *   CATOLD(256), JBUFSZ, ICODE, SCRTCH(512)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2), OLDH(256)
      REAL      XSEQIN, XDISKI, XSEQO, XDISKO, BLC(7), TRC(7),
     *   CPARM(10), BUFF1(MABFSS), BUFF2(MABFSS), OLDR(256)
      DOUBLE PRECISION OLDD(128)
      EQUIVALENCE (CATOLD, OLDR, OLDH, OLDD)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XNAMOU, XCLAOU,
     *   XSEQO, XDISKO, BLC, TRC, CPARM
      COMMON /PARMS/ CATOLD, SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO,
     *   OLDCNO, JBUFSZ, ICODE
      COMMON /CHRPRM/ NAMEIN, CLAIN, NAMOUT, CLAOUT
      COMMON /BUFRS/ BUFF1, BUFF2, SCRTCH
      INCLUDE 'INCS:DCAT.INC'
LOCAL END
      PROGRAM NNLSQ
C-----------------------------------------------------------------------
C! Fit spectral components in an image
C# Map Math Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This program solves for the set of positive (non-negative)
C   components which when convolved with a specified Gaussian make
C   a least squares fit to the dirty spectrum. For best results
C   (minimum broadening of the profiles combined with best S/N) the
C   sigma of the Gaussian should be similar to that of the
C   instrumental profile (1-1.5 is probably good).
C   This program used TAFFY as a template.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLAOUT        Class of the output image.
C                                   Default is input class.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      CPARM(10)      CPARM         User specified array.
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGM*6
      INCLUDE 'NNLSQ.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'NNLSQ '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL NLSQIN (PRGM, IRET)
C                                       Fit image.
      IF (IRET.EQ.0) CALL NLSQMA (IRET)
C                                       History
      IF (IRET.EQ.0) CALL NLSQHI
C                                       Close down files, etc.
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE NLSQIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   NLSQIN gets input parameters for NNLSQ and creates an output file.
C   Inputs:  PRGN    C*6       Program name
C   Output:  IRET    I         Error code: 0 => ok
C                                4 => user routine detected error.
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in TAFFY for more details.
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER STAT*4, PRGN*6, BLANK*6, MTYPE*2
      INTEGER   IERR, NPARM, IROUND
      INCLUDE 'NNLSQ.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA BLANK /'      '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 38
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO = IROUND (XDISKO)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, 'READ', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Copy old CATBLK to new.
      CALL COPY (256, CATOLD, CATBLK)
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATOLD(KIDIM), CATOLD(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get modification to CATBLK
      IRET = 4
      CALL NLSQHD (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create output file.
      NEWCNO = 1
      IRET = 4
      CALL MCREAT (DISKO, NEWCNO, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      SEQOUT = CATBLK(KIIMS)
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('NLSQIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('NLSQIN: ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE NLSQMA (IRET)
C-----------------------------------------------------------------------
C   NLSQMA sends image one row at a time to the fitting
C   routine and then writes the modified data.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER IFILE*48
      INTEGER   IRET, IROUND, LUNI, LUNO,
     *   NYI, NXI, WINI(4), NXO, NYO, WINO(4), BOI,
     *   BOO, LIM2, LIM3, LIM4, LIM5, LIM6, LIM7, I1, I2,
     *   I3, I4, I5, I6, I7, IPOS(7), CORN(7), BOTEMP, KOFF,
     *   LIMO, LIMIT, IBIND, OBIND, INDI, INDO, LIM1
      LOGICAL   T, F, BLNKD
      INCLUDE 'NNLSQ.INC'
      REAL      OUTMAX, OUTMIN, RDATA(MAXIMG)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNI, LUNO /16,17/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Setup for I/O
      NXI = CATOLD(KINAX)
      NYI = CATOLD(KINAX+1)
      NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      OUTMAX = -1.0E20
      OUTMIN = 1.0E20
      BLNKD = F
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
      KOFF = 0
      CORN(7) = 1
      LIMO = CATBLK(KINAX) - 1
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         CORN(7+KOFF) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            CORN(6+KOFF) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               CORN(5+KOFF) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  CORN(4+KOFF) = I4
                  DO 300 I3 = 1,LIM3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     CORN(3+KOFF) = I3
C                                       Init. files, first input.
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1099) IRET
            GO TO 990
            END IF
         BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'READ', IRET
            GO TO 990
            END IF
C                                       Init output file.
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORN(3), BOTEMP,
     *      IRET)
         BOO = BOTEMP + 1
         CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO, BUFF2, JBUFSZ,
     *      BOO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'WRIT', IRET
            GO TO 990
            END IF
         DO 250 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
C                                       Read.
            CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'READ', IRET
               GO TO 990
               END IF
            DO 165 I1 = 1,LIM1
               RDATA(I1) = BUFF1(IBIND+I1-1)
 165           CONTINUE
C                                       Write.
            CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IRET)
            OBIND = OBIND - 1
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'WRIT', IRET
               GO TO 990
               END IF
C                                       Call NLSQDO
            OBIND = OBIND + 1
            CALL NLSQDO (IPOS, RDATA, BUFF2(OBIND), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1180) IRET
               GO TO 990
               END IF
C                                       Check max, min, blanking.
            LIMIT = OBIND + LIMO
            DO 200 I1 = OBIND,LIMIT
               BLNKD = BLNKD .OR. (BUFF2(I1).EQ.FBLANK)
               IF (BUFF2(I1).NE.FBLANK) THEN
                  OUTMAX = MAX (OUTMAX, BUFF2(I1))
                  OUTMIN = MIN (OUTMIN, BUFF2(I1))
                  END IF
 200           CONTINUE
 250        CONTINUE
C                                       Flush buffer.
         CALL MDISK ('FINI', LUNO, INDO, BUFF2, OBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1120) 'FINI', IRET
            GO TO 990
            END IF
C                                       Update CATBLK.
         CATR(KRDMX) = OUTMAX
         CATR(KRDMN) = OUTMIN
         CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRTCH,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1260) IRET
            GO TO 990
            END IF
 300     CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Mark blanking in CATBLK.
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
C                                       Close input map.
      CALL ZCLOSE (LUNI, INDI, IRET)
C                                       Final call to functions
      IPOS(1) = -1
      CALL NLSQDO (IPOS, RDATA, BUFF2, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1180) IRET
         GO TO 990
         END IF
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('NLSQMA: ERROR',I3,' OPENING INPUT FILE')
 1020 FORMAT ('NLSQMA: ERROR',I5,' OPENING OUTPUT FILE')
 1099 FORMAT ('NLSQMA: COMOFF ERROR',I3)
 1100 FORMAT ('NLSQMA: INIT-FOR-',A4,' ERROR',I3)
 1120 FORMAT ('NLSQMA: ',A4,' ERROR',I3)
 1180 FORMAT ('NLSQMA: NLSQDO ERROR',I3)
 1260 FORMAT ('NLSQMA: CATIO ERROR',I3,' UPDATING CATBLK')
      END
      SUBROUTINE NLSQHI
C-----------------------------------------------------------------------
C   NLSQHI copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72
      INTEGER   LUN1, LUN2, IERR
      LOGICAL   T
      INCLUDE 'NNLSQ.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   SCRTCH(257), SCRTCH, IERR)
      IF (IERR.GE.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
C                                       New history
      ELSE
         CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2,
     *      SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 20
         CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *      SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 20
C                                       BLC
         WRITE (HILINE,2000) TSKNAM, BLC
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 20
C                                       TRC
         WRITE (HILINE,2001) TSKNAM, TRC
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         END IF
C                                       Close HI file
 20   CALL HICLOS (LUN2, T, SCRTCH, IERR)
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('NLSQHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 2000 FORMAT (A6,' BLC =',6(F6.0,','),F6.0)
 2001 FORMAT (A6,' TRC =',6(F6.0,','),F6.0)
      END
      SUBROUTINE NLSQHD (IRET)
C-----------------------------------------------------------------------
C   NLSQHD modifies the catalog header block to
C   define the size of the output file; ie.
C      CATBLK(KIDIM)   = the number of axes,
C      CATBLK(KINAX+i) = the dimension of each axis, and
C      CATBLK(KIBPX)   => 1 = integer*2, 2 = real*4 pixel values.
C   These values are the same as the OLD map.
C   OUTNAME, OUTCLASS, OUTSEQ, OUTDISK, TRC and BLC defaults are
C   set elsewhere.
C
C    Input:
C     CATBLK(256)    I     Output catalog header, also CATR, CATD
C     CATOLD(256)    I     Input catalog header, also OLDR, OLDD
C    Output:
C     CATBLK(256)    I     Modified output catalog header.
C     IRET           I     Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   LIMIT, I, FIRSTI, FIRSTO, IRET
      INTEGER   INDXI, INDEX
      INCLUDE 'NNLSQ.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       Set axes in output CATBLK.
      FIRSTI = -1
      FIRSTO = -1
      LIMIT = CATOLD(KIDIM)
C                                       Copy/update axis values
      DO 80 I = 1,LIMIT
         CATBLK(KINAX+FIRSTO+I) = TRC(I+FIRSTI+1) -
     *      BLC(I+FIRSTI+1) + 1.01
         CATR(KRCRP+FIRSTO+I) = OLDR(KRCRP+FIRSTI+I) - BLC(I+FIRSTI+1)
     *      + 1.0
         CATR(KRCIC+FIRSTO+I) = CATR(KRCIC+FIRSTI+I)
         CATD(KDCRV+FIRSTO+I) = OLDD(KDCRV+FIRSTI+I)
         INDXI = KHCTP + (I+FIRSTI) * 2
         INDEX = KHCTP + (I-1) * 2
         CALL CHCOPY (8, 1, OLDH(INDXI), 1, CATH(INDEX))
 80      CONTINUE
C                                       Finished.
      IRET = 0
C
 999  RETURN
      END
      SUBROUTINE NLSQDO (IPOS, RDATA, RESULT, IRET)
C-----------------------------------------------------------------------
C   This is a skeleton version of subroutine NLSQDO which allows
C   operations on an image one row at a time (1st dimension).
C   Input data is Real*4 with blanking if necessary; output values
C   are R   which may also be blanked.  The calling routine keeps
C   of max., min. and to occurence of blanking.  The calling routine
C   expects CATBLK(KINAX) values per call are expected returned.
C
C   NOTE: blanked values are denoted by the value of the common variable
C   FBLANK
C
C   If IRET .GT. 0 then the output file will be destroyed.
C
C       After all data has been processed a final call will be made to
C   NLSQDO with IPOS(1)=-1.  This is to allow for the completion of
C   pending operations, i.e. preparation of HIstory cards.
C
C   LUN's 16-18 are open and not available to NLSQDO.
C
C       The current contents of CATBLK will be written back to the
C   catalog after the last call to NLSQDO.
C
C   Inputs:
C      IPOS(7)   I    BLC (input image) of first value in RDATA
C      RDATA(*)   R    Input row, magic value blanked.
C   Values from commons:
C      FBLANK    R    Value of blanked pixel.
C      CPARM(10) R    Input adverb array.
C      DPARM(10) R    Input adverb array.
C      CATBLK    I    Output catalog header (also CATR, CATD)
C      CATOLD    I    Input catalog header (also OLDR, OLDD)
C   Output:
C      RESULT(*) R    Output row.
C      IRET      I    Return code   0 => OK
C                               >0 => error, terminate.
C   Output in COMMON
C      CATBLK     I    Catalog header block
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), IRET
      REAL      RDATA(*), RESULT(*)
C
      INTEGER   MDA
      PARAMETER (MDA=21)
C
      INTEGER   LROW, J, I, MODE, NDEX(MDA), NSOLVE
      REAL      A0(MDA,MDA), A(MDA,MDA), B(MDA), X(MDA), RNORM, W(MDA),
     *   Z(MDA), SIG, SUM
      LOGICAL   FIRST
      SAVE FIRST, A0, NSOLVE
      INCLUDE 'NNLSQ.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C                                       Data for NNLSQ:
      DATA FIRST /.TRUE./
C-----------------------------------------------------------------------
      IRET = 0
C                                       Check if last call
      IF (IPOS(1).LT.0) GO TO 900
      LROW = CATOLD(KINAX)
C                                       Initialize A0(,) on first call:
      IF (FIRST) THEN
         IF (LROW.GT.MDA) THEN
            WRITE (MSGTXT,1000) LROW, MDA
            CALL MSGWRT (7)
            IRET = 1
            GO TO 999
            END IF
C
         SIG = CPARM(1)
         IF (SIG.LE.0.0) SIG = 1.0
         DO 40 J = 1, LROW
            SUM = 0.0
            DO 20 I = 1, LROW
               A0(I,J) = EXP ((REAL(I) - REAL(J))**2
     *                              / (-2.0 * SIG * SIG))
               SUM = SUM + A0(I,J)
 20            CONTINUE
            DO 30 I = 1, LROW
               A0(I,J) = A0(I,J) / SUM
 30            CONTINUE
 40      CONTINUE
         FIRST = .FALSE.
         NSOLVE = 0
         END IF
C                                       Set up the equations:
      DO 60 J = 1, LROW
         DO 50 I = 1, LROW
            A(I,J) = A0(I,J)
 50         CONTINUE
         B(J) = RDATA(J)
 60      CONTINUE
C                                       Solve the equations:
      CALL NNLS (A, MDA, LROW, LROW, B, X, RNORM, W, Z, NDEX, MODE)
      NSOLVE = NSOLVE + 1
      IF (MOD(NSOLVE,100).EQ.1) THEN
         WRITE (MSGTXT,1060) NSOLVE, RNORM
         CALL MSGWRT (2)
         END IF
C                                       Copy answers to RDATA:
      DO 70 J = 1, LROW
         RESULT(J) = X(J)
 70      CONTINUE
      GO TO 999
C                                       Last call - do history etc.
 900  CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR. OUTPUT ROW IS ',I7,' MAXIMUM IS ',I5)
 1060 FORMAT ('NSOLVE =',I8,'    RNORM = ',1PE12.5)
      END
      SUBROUTINE NNLS (A,MDA,M,N,B,X,RNORM,W,ZZ,INDEX,MODE)
C-----------------------------------------------------------------------
C     C.L.Lawson and R.J.Hanson, Jet Propulsion Laboratory, 1973 June 15
C     to appear in 'Solving Least Squares Problems', Prentice-Hall, 1974
C
C         **********   NONNEGATIVE LEAST SQUARES   **********
C
C     Given an M by N matrix, A, and an M-vector, B,  compute an
C     N-vector, X, which solves the least squares problem
C
C                      A * X = B  subject to X .GE. 0
C
C  INPUT:
C     MDA  I       The first dimensioning parameter for the
C                  array, A().
C     M    I       First dimension of matrix A(M,N).
C     N    I       Second dimension of matrix A(M,N).
C  IN/OUT:
C     A    R(MDA,?)    On entry A() contains the M by N
C                  matrix, A.  On exit A() contains
C                  the product matrix, Q*A , where Q is an
C                  M by M orthogonal matrix generated implicitly by
C                  this subroutine.
C     B     R(M)   On entry B() contains the M-vector, B.   On exit B()
C                  contains Q*B.
C  OUT:
C     X     R(N)   On entry X() need not be initialized.  On exit X()
C                  will contain the solution vector.
C     RNORM R      On exit RNORM contains the euclidean norm of the
C                  residual vector.
C     W     R(N)   An N-array of working space. On exit W() will contain
C                  the dual solution vector.   W will satisfy W(I) = 0.
C                  For all I in set P  and W(I) .LE. 0. for all I in
C                  set Z.
C     ZZ    R(N)   An M-array of working space.
C     INDEX R(N)   An integer working array of length at least N.
C                  On exit the contents of this array define the sets
C                  P and Z as follows..
C
C                    INDEX(1)   thru INDEX(NSETP) = set P.
C                    INDEX(IZ1) thru INDEX(IZ2)   = set Z.
C                    IZ1 = NSETP + 1 = NPP1
C                    IZ2 = N
C     MODE I       This is a success-failure flag with the following
C                  meanings.
C                  1     The solution has been computed successfully.
C                  2     The dimensions of the problem are bad.
C                        Either M .LE. 0 or N .LE. 0.
C                  3    Iteration count exceeded.  More than 3*N
C                       iterations.
C-----------------------------------------------------------------------
      INTEGER MDA, N, M, IN1
      INTEGER   MODE, ITER, ITMAX, I, IZ2, IZ1, NSETP, NPP1, IZ, J, L,
     *   IZMAX, JZ, JJ, NEXT, IP, II, INDEX(N), I2TMP, MDA2
      REAL   A(MDA,N), B(M), X(N), W(N), ZZ(M), RNORM, ZERO, ONE, TWO,
     *   FACTOR, SM, WMAX, ASAVE, DUMMY(1), UP, UNORM, ZTEST, ALPHA, T,
     *   CC, SS, DIFF
      INCLUDE 'INCS:DMSG.INC'
      DATA IN1 /1/
C-----------------------------------------------------------------------
      ZERO = 0.
      ONE = 1.
      TWO = 2.
      FACTOR = 0.01
C
      MODE = 1
      IF ((M.LE.0) .OR. (N.LE.0)) THEN
         MODE = 2
         GO TO 999
         END IF
      ITER = 0
      ITMAX = 3*N
C                                       Initialize the arrays INDEX()
C                                       and X().
      DO 20 I = 1,N
         X(I) = ZERO
         INDEX(I) = I
 20      CONTINUE
C
      IZ2 = N
      IZ1 = 1
      NSETP = 0
      NPP1 = 1
C                                       Main loop begins here  ******
 30   CONTINUE
C                                       Quit if all coefficients are
C                                       already in the solution or if M
C                                       cols of A have been
C                                       triangularized.
C
      IF (IZ1.GT.IZ2.OR.NSETP.GE.M) GO TO 350
C                                       Compute components of the dual
C                                       (negative gradient) vector W().
         DO 50 IZ = IZ1,IZ2
            J = INDEX(IZ)
            SM = ZERO
            DO 40 L = NPP1,M
               SM = SM+A(L,J)*B(L)
 40            CONTINUE
            W(J) = SM
 50      CONTINUE
C                                       Find largest positive W(J).
 60      WMAX = ZERO
         DO 70 IZ = IZ1,IZ2
             J = INDEX(IZ)
             IF (W(J).GT.WMAX) THEN
                WMAX = W(J)
                IZMAX = IZ
                END IF
 70          CONTINUE
C                                       If WMAX.LE.0. go to termination.
C                                       This indicates satisfaction of
C                                       the Kuhn-Tucker conditions.
C
         IF (WMAX.LE.0) GO TO 350
         IZ = IZMAX
         J = INDEX (IZ)
C                                       The sign of W(J) is ok for J to
C                                       be moved to set P.
C                                       begin the transformation and
C                                       check new diagonal element to
C                                       avoid near linear dependence.
C
      ASAVE = A(NPP1,J)
      I2TMP = NPP1 + 1
      CALL H12 (1, NPP1, I2TMP, M, A(1,J), IN1, UP, DUMMY, 1, 1, 0)
      UNORM = ZERO
      DO 90 L = 1,NSETP
         UNORM = UNORM+A(L,J)**2
 90      CONTINUE
      UNORM = SQRT(UNORM)
      IF (DIFF(UNORM+ABS(A(NPP1,J))*FACTOR,UNORM).GT.0) THEN
C
C     COL J IS SUFFICIENTLY INDEPENDENT.  COPY B INTO ZZ, UPDATE ZZ AND
C   > SOLVE FOR ZTEST ( = PROPOSED NEW VALUE FOR X(J) ).
C
         DO 120 L = 1,M
            ZZ(L) = B(L)
 120        CONTINUE
         I2TMP = NPP1 + 1
         CALL H12 (2, NPP1, I2TMP, M,A(1,J), IN1, UP, ZZ, 1, 1, 1)
         ZTEST = ZZ(NPP1)/A(NPP1,J)
C
C                                     SEE IF ZTEST IS POSITIVE
C     REJECT J AS A CANDIDATE TO BE MOVED FROM SET Z TO SET P.
C     RESTORE A(NPP1,J), SET W(J)=0., AND LOOP BACK TO TEST DUAL
C
         IF (ZTEST.GT.0) GO TO 140
         END IF
C
C     COEFFS AGAIN.
C
      A(NPP1,J) = ASAVE
      W(J) = ZERO
      GO TO 60
C
C     THE INDEX  J=INDEX(IZ)  HAS BEEN SELECTED TO BE MOVED FROM
C     SET Z TO SET P.    UPDATE B,  UPDATE INDICES,  APPLY HOUSEHOLDER
C     TRANSFORMATIONS TO COLS IN NEW SET Z,  ZERO SUBDIAGONAL ELTS IN
C     COL J,  SET W(J)=0.
C
 140  DO 150 L = 1,M
         B(L) = ZZ(L)
 150     CONTINUE
C
      INDEX(IZ) = INDEX(IZ1)
      INDEX(IZ1) = J
      IZ1 = IZ1+1
      NSETP = NPP1
      NPP1 = NPP1+1
C
      MDA2 = MDA
      DO 160 JZ = IZ1,IZ2
         JJ = INDEX(JZ)
         CALL H12 (2, NSETP, NPP1, M, A(1,J), IN1, UP, A(1,JJ), 1,
     *      MDA2, 1)
 160     CONTINUE
C
      IF (NSETP.NE.M) THEN
         DO 180 L = NPP1,M
            A(L,J) = ZERO
 180        CONTINUE
         END IF
C
      W(J) = ZERO
C                                SOLVE THE TRIANGULAR SYSTEM.
C                                STORE THE SOLUTION TEMPORARILY IN ZZ().
      NEXT  =  1
      GO TO 400
 200  CONTINUE
C
C                       ******  SECONDARY LOOP BEGINS HERE ******
C
C                          ITERATION COUNTER.
C
 210  ITER = ITER+1
      IF (ITER.GT.ITMAX) THEN
         MODE = 3
         MSGTXT = 'NNLS Quitting due to iteration count'
         CALL MSGWRT (6)
         GO TO 350
         END IF
C
C                    SEE IF ALL NEW CONSTRAINED COEFFS ARE FEASIBLE.
C                                  IF NOT COMPUTE ALPHA.
C
      ALPHA = TWO
      DO 240 IP = 1,NSETP
         L = INDEX(IP)
         IF (ZZ(IP).LE.0) THEN
            T = -X(L)/(ZZ(IP)-X(L))
            IF (ALPHA.GT.T) THEN
               ALPHA = T
               JJ = IP
               END IF
            END IF
 240     CONTINUE
C
C          IF ALL NEW CONSTRAINED COEFFS ARE FEASIBLE THEN ALPHA WILL
C          STILL = 2.    IF SO EXIT FROM SECONDARY LOOP TO MAIN LOOP.
C
      IF (ALPHA.EQ.TWO) GO TO 330
C
C          OTHERWISE USE ALPHA WHICH WILL BE BETWEEN 0. AND 1. TO
C          INTERPOLATE BETWEEN THE OLD X AND THE NEW ZZ.
C
      DO 250 IP = 1,NSETP
         L = INDEX(IP)
         X(L) = X(L)+ALPHA*(ZZ(IP)-X(L))
 250     CONTINUE
C
C        MODIFY A AND B AND THE INDEX ARRAYS TO MOVE COEFFICIENT I
C        FROM SET P TO SET Z.
C
      I = INDEX(JJ)
 260  X(I) = ZERO
C
      IF (JJ.NE.NSETP) THEN
         JJ = JJ+1
         DO 280 J = JJ,NSETP
            II = INDEX(J)
            INDEX(J-1) = II
            CALL G1 (A(J-1,II), A(J,II), CC, SS, A(J-1,II))
            A(J,II) = ZERO
            DO 270 L = 1,N
               IF (L.NE.II) CALL G2 (CC,SS,A(J-1,L),A(J,L))
 270           CONTINUE
            CALL G2 (CC, SS, B(J-1), B(J))
 280        CONTINUE
         END IF
      NPP1 = NSETP
      NSETP = NSETP-1
      IZ1 = IZ1-1
      INDEX(IZ1) = I
C
C        SEE IF THE REMAINING COEFFS IN SET P ARE FEASIBLE.  THEY SHOULD
C        BE BECAUSE OF THE WAY ALPHA WAS DETERMINED.
C        IF ANY ARE INFEASIBLE IT IS DUE TO ROUND-OFF ERROR.  ANY
C        THAT ARE NONPOSITIVE WILL BE SET TO ZERO
C        AND MOVED FROM SET P TO SET Z.
C
      DO 300 JJ = 1,NSETP
         I = INDEX(JJ)
         IF (X(I).LE.0) GO TO 260
 300     CONTINUE
C
C         COPY B( ) INTO ZZ( ).  THEN SOLVE AGAIN AND LOOP BACK.
C
      DO 310 I = 1,M
         ZZ(I) = B(I)
 310     CONTINUE
      NEXT  =  2
      GO TO 400
 320  CONTINUE
      GO TO 210
C                      ******  END OF SECONDARY LOOP  ******
C
 330  DO 340 IP = 1,NSETP
         I = INDEX(IP)
         X(I) = ZZ(IP)
 340     CONTINUE
C        ALL NEW COEFFS ARE POSITIVE.  LOOP BACK TO BEGINNING.
      GO TO 30
C
C                        ******  END OF MAIN LOOP  ******
C
C                        COME TO HERE FOR TERMINATION.
C                     COMPUTE THE NORM OF THE FINAL RESIDUAL VECTOR.
C
 350  SM = ZERO
      IF (NPP1.LE.M) THEN
         DO 360 I = NPP1,M
            SM = SM+B(I)**2
 360        CONTINUE
      ELSE
         DO 380 J = 1,N
            W(J) = ZERO
 380        CONTINUE
         END IF
      RNORM = SQRT(SM)
      GO TO 999
C
C     THE FOLLOWING BLOCK OF CODE IS USED AS AN INTERNAL SUBROUTINE
C     TO SOLVE THE TRIANGULAR SYSTEM, PUTTING THE SOLUTION IN ZZ().
C
 400  DO 430 L = 1,NSETP
         IP = NSETP+1-L
         IF (L.NE.1) THEN
            DO 410 II = 1,IP
               ZZ(II) = ZZ(II)-A(II,JJ)*ZZ(IP+1)
 410           CONTINUE
            END IF
         JJ = INDEX(IP)
         ZZ(IP) = ZZ(IP)/A(IP,JJ)
 430     CONTINUE
      GO TO (200, 320), NEXT
C
 999  RETURN
      END
      SUBROUTINE H12 (MODE, LPIVOT, L1, M, U, IUE, UP, C, ICE, ICV, NCV)
C-----------------------------------------------------------------------
C     C.L.Lawson and R.J.Hanson, Jet Propulsion Laboratory, 1973 Jun 12
C     To appear in 'Solving Least Squares Problems', Prentice-Hall, 1974
C
C     Construction and/or application of a single
C     Householder transformation..     Q = I + U*(U**T)/B
C
C     Input:
C     In/Out:
C     Output:
C     MODE    = 1 OR 2   TO SELECT ALGORITHM  H1  OR  H2 .
C     LPIVOT IS THE INDEX OF THE PIVOT ELEMENT.
C     L1,M   IF L1 .LE. M   THE TRANSFORMATION WILL BE CONSTRUCTED TO
C            ZERO ELEMENTS INDEXED FROM L1 THROUGH M.   IF L1 GT. M
C            THE SUBROUTINE DOES AN IDENTITY TRANSFORMATION.
C     U(),IUE,UP    ON ENTRY TO H1 U() CONTAINS THE PIVOT VECTOR.
C                   IUE IS THE STORAGE INCREMENT BETWEEN ELEMENTS.
C                                       ON EXIT FROM H1 U() AND UP
C                   CONTAIN QUANTITIES DEFINING THE VECTOR U OF THE
C                   HOUSEHOLDER TRANSFORMATION.   ON ENTRY TO H2 U()
C                   AND UP SHOULD CONTAIN QUANTITIES PREVIOUSLY COMPUTED
C                   BY H1.  THESE WILL NOT BE MODIFIED BY H2.
C     C()    ON ENTRY TO H1 OR H2 C() CONTAINS A MATRIX WHICH WILL BE
C            REGARDED AS A SET OF VECTORS TO WHICH THE HOUSEHOLDER
C            TRANSFORMATION IS TO BE APPLIED.  ON EXIT C() CONTAINS THE
C            SET OF TRANSFORMED VECTORS.
C     ICE    STORAGE INCREMENT BETWEEN ELEMENTS OF VECTORS IN C().
C     ICV    STORAGE INCREMENT BETWEEN VECTORS IN C().
C     NCV    NUMBER OF VECTORS IN C() TO BE TRANSFORMED. IF NCV .LE. 0
C            NO OPERATIONS WILL BE DONE ON C().
C
C-----------------------------------------------------------------------
      INTEGER IUE, M
      INTEGER   ICE, ICV, L1, LPIVOT, MODE, NCV, J, I2, INCR, I3, I4,
     *   I
      REAL   U(IUE,M), C(*), ONE, UP, CL, CLINV, SM1
      DOUBLE PRECISION SM,B
C-----------------------------------------------------------------------
      ONE = 1.
C
      IF ((0.GE.LPIVOT) .OR. (LPIVOT.GE.L1) .OR. (L1.GT.M)) GO TO 999
      CL = ABS(U(1,LPIVOT))
      IF (MODE.NE.2) THEN
C                            ****** CONSTRUCT THE TRANSFORMATION. ******
         DO 10 J = L1,M
            CL = MAX (ABS(U(1,J)), CL)
 10         CONTINUE
         IF (CL.LE.0) GO TO 999
         CLINV = ONE/CL
         SM = (DBLE(U(1,LPIVOT))*CLINV)**2
         DO 30 J = L1,M
            SM = SM+(DBLE(U(1,J))*CLINV)**2
 30         CONTINUE
C                              CONVERT DBLE. PREC. SM TO SNGL. PREC. SM1
         SM1 = SM
         CL = CL * SQRT(SM1)
         IF (U(1,LPIVOT).GT.0) CL = -CL
         UP = U(1,LPIVOT)-CL
         U(1,LPIVOT) = CL
         GO TO 70
         END IF
C            ****** APPLY THE TRANSFORMATION  I+U*(U**T)/B  TO C. ******
C
      IF (CL.LE.0) GO TO 999
 70   IF (NCV.LE.0) GO TO 999
      B = DBLE(UP)*U(1,LPIVOT)
C                       B  MUST BE NONPOSITIVE HERE.  IF B = 0., RETURN.
C
      IF (B.GT.0) GO TO 999
      B = ONE/B
      I2 = 1-ICV+ICE*(LPIVOT-1)
      INCR = ICE*(L1-LPIVOT)
      DO 120 J = 1,NCV
         I2 = I2+ICV
         I3 = I2+INCR
         I4 = I3
         SM = C(I2)*DBLE(UP)
         DO 90 I = L1,M
            SM = SM+C(I3)*DBLE(U(1,I))
            I3 = I3+ICE
 90         CONTINUE
         IF (SM.NE.0) THEN
            SM = SM*B
            C(I2) = C(I2)+SM*DBLE(UP)
            DO 110 I = L1,M
               C(I4) = C(I4)+SM*DBLE(U(1,I))
               I4 = I4+ICE
 110           CONTINUE
            END IF
 120     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE G1 (A, B, COS, SIN, SIG)
C-----------------------------------------------------------------------
C   C.L.Lawson and R.J.Hanson, jet propulsion laboratory, 1973 Jun 12
C   To appear in 'Solving Least Squares Problems', Prentice-Hall, 1974
C   Compute orthogonal rotation matrix..
C   Compute.. MATRIX  (C, S) so that (C, S)(A) = (SQRT(A**2+B**2))
C                     (-S,C)         (-S,C)(B)   (   0          )
C   Compute SIG = SQRT(A**2+B**2)
C      SIG is computed last to allow for the possibility that
C      SIG may be in the same location as A or B .
C-----------------------------------------------------------------------
      REAL   A, B, COS, SIN, SIG, ZERO, ONE, XR, YR
C-----------------------------------------------------------------------
      ZERO = 0.
      ONE = 1.
      IF (ABS(A).GT.ABS(B)) THEN
         XR = B/A
         YR = SQRT(ONE+XR**2)
         COS = SIGN(ONE/YR,A)
         SIN = COS*XR
         SIG = ABS(A)*YR
      ELSE IF (B.NE.0) THEN
         XR = A/B
         YR = SQRT(ONE+XR**2)
         SIN = SIGN(ONE/YR,B)
         COS = SIN*XR
         SIG = ABS(B)*YR
      ELSE
         SIG = ZERO
         COS = ZERO
         SIN = ONE
         END IF
C
 999  RETURN
      END
      SUBROUTINE G2 (COS, SIN, X, Y)
C-----------------------------------------------------------------------
C   C.L.Lawson and R.J.Hanson, Jet Propulsion Laboratory, 1972 Dec 15
C   to appear in 'Solving Least Squares Problems', Prentice-Hall, 1974
C   apply the rotation computed by g1 to (x,y).
C-----------------------------------------------------------------------
      REAL   COS, SIN, X, Y, XR
C-----------------------------------------------------------------------
      XR = COS*X + SIN*Y
      Y = -SIN*X + COS*Y
      X = XR
C
 999  RETURN
      END
      FUNCTION DIFF (X, Y)
C-----------------------------------------------------------------------
C   C.L.Lawson and R.J.Hanson, Jet Propulsion Laboratory, 1973 June 7
C   to appear in 'Solving Least Squares Problems', Prentice-Hall, 1974
C-----------------------------------------------------------------------
      REAL   X, Y, DIFF
C-----------------------------------------------------------------------
      DIFF = X - Y
C
 999  RETURN
      END

      SUBROUTINE VHDRIN
C-----------------------------------------------------------------------
C! computes pointers (subscripts) to address components of the header
C# Header
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2005, 2020
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   VHDRIN computes the pointers required to address catalog records
C   (both normal and image).  The routine sets common /HDRVAL/, which
C   contains 60 integers.  They are then machine independent symbols
C   which have machine dependent values.
C-----------------------------------------------------------------------
      INTEGER   PI, PH, PR, PD, INC4C8
      REAL      X, EPS
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PHDR.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA INC4C8, EPS /2, 0.01/
C-----------------------------------------------------------------------
C                                       set address increments
      PH = 1
C                                       array sizes
      KIPTPN = 14
      KICTPN = 7
      KIEXTN = NIEXTN
C                                       character of 8
      KHOBJ = PH
      KHTEL = PH +   INC4C8
      KHINS = PH + 2*INC4C8
      KHOBS = PH + 3*INC4C8
      KHDOB = PH + 4*INC4C8
      KHDMP = PH + 5*INC4C8
      KHBUN = PH + 6*INC4C8
      KHPTP = PH + 7*INC4C8
      KHCTP = PH + (7+KIPTPN)*INC4C8
      PH = PH + INC4C8 * (7 + KIPTPN + KICTPN)
      PI = PH
C                                       reals: double precision
      X = (PI - 1.0) / NWDPDP + 1.0
      PD = X + EPS
      IF (ABS(PD-X).GT.EPS) THEN
         PD = X + 1.0 - EPS
         PI = (PD-1)*NWDPDP + 1
         END IF
      KDCRV = PD
      PI = PI + NWDPDP * KICTPN
C                                       reals: single precision
      PR = PI
      KRCIC = PR
      KRCRP = PR +   KICTPN
      KRCRT = PR + 2*KICTPN
      PR = PR + 3 * KICTPN
      KREPO = PR
      KRDMX = PR + 1.0
      KRDMN = PR + 2.0
      KRBLK = PR + 3.0
      PR = PR + 4
      PI = PR
C                                       GCN now I, other integers
      KIGCN = PI
      KIPCN = PI + 1
      KIDIM = PI + 2
      KINAX = PI + 3
      KIIMS = PI + (3+KICTPN)
      PI = PI + (4+KICTPN)
C                                       name \\ class \\ phystype
C                                       character(20)
      PH = PI
      KHIMN = PH
      KHIMC = KHIMN
      KHPTY = KHIMN
      KHIMNO = 1
      KHIMCO = 13
      KHPTYO = 19
      PI = PH + 5
C                                       user #, clean parms
      KIIMU = PI
      KIALT = PI + 1
      PI = PI + 2
      PR = PI
      KRBMJ = PR
      KRBMN = PR + 1
      KRBPA = PR + 2
      PI = PI + 3
C                                       iterations
      KINIT = PI
      KITYP = PI + 1
      PI = PI + 2
C                                       Pointing position, alt freq
      X = (PI - 1.0) / NWDPDP + 1.0
      PD = X + EPS
      IF (ABS(X-PD).GT.EPS) THEN
         PD = X + 1.0 - EPS
         PI = (PD-1) * NWDPDP + 1
         END IF
      KDORA = PD
      KDODE = PD + 1
      KDRST = PD + 2
      KDARV = PD + 3
      PD = PD + 4
      PI = (PD - 1) * NWDPDP + 1
      PR = PI
      KRARP = PR
      KRXSH = PR + 1
      KRYSH = PR + 2
      PI = PI + 3
C                                       extension files
      KHEXT = PI
      KIVER = PI + KIEXTN
      PI = PI + 2*KIEXTN
C                                       G&C wcs removed from mainn
C                                       header
C     KRCOK = PI
C     KDLON = PI / NWDPDP + 1
C     KDPRJ = KDLON + 1
C     PD = KDPRJ + 9
C     PI = (PD-1) * NWDPDP + 1
C     KRPCM = PI
C                                       UV weight normalization
      KRWTN = PI
C                                       Imaging type, xpoff, ypoff
      KIITY = PI + 1
      KRXPO = PI + 2
      KRYPO = PI + 3
C                                       count cal applications
      PI = PI + 4
      KICCL = PI
      KICBP = PI + 1
      KICPD = PI + 2
C                                       residual space
      KIRES = PI + 3
      KIRESN = 257 - KIRES
C                                       replace extensions and extra
C                                       position info with image
C                                       parameters in image catalog
      PD = KDORA
      PI = (PD - 1) * NWDPDP + 1
      PR = PI
      IRRAN = PR
C                                       skip alternate axis parms
      PR = KRXSH
      PI = PR
      IIVOL = PI
      IICNO = PI + 1
      IIWIN = PI + 2
      IIDEP = PI + 6
      PI = PI + (6 + KICTPN - 2)
      IICOR = PI
      IITRA = PI + 4
      IIPLT = PI + 5
      IIOTH = PI + 6
C
 999  RETURN
      END

      SUBROUTINE YLOWON (MASK, ICHAN)
C-----------------------------------------------------------------------
C! select least on bit in a bit mask integer
C# Y0 TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YLOWON returns a zero-relative least bit on number up to NGRAY.
C   If MASK=0, it returns 0.  If MASK > 2 ** (NGRAY-1) it returns NGRAY.
C   Since some TVs can't have more than one channel on at a time in
C   each color, determine the lowest channel that is flagged ON in MASK,
C   and return it (zero relative) in ICHAN.  If MASK is clear, set ICHAN
C   to be a 0.
C   Inputs:
C      MASK    I   IIS type channel mask
C   Output:
C      ICHAN   I   # of lowest bit set in MASK
C-----------------------------------------------------------------------
      INTEGER   MASK, ICHAN
      INTEGER   BITS(15), ZAND, I
      INCLUDE 'INCS:DTVC.INC'
      DATA BITS /1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384/
C-----------------------------------------------------------------------
      ICHAN = NGRAY
      IF (MASK.EQ.0) ICHAN = 0
C
      DO 10 I = 1,NGRAY
         IF (ZAND(MASK, BITS(I)).EQ.0) GO TO 10
             ICHAN = I - 1
             GO TO 999
 10      CONTINUE
C
 999  RETURN
      END

      PROGRAM ZSTRTA
C-----------------------------------------------------------------------
C! determine parameters under which AIPS is to run
C# Z System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZSTRTA determines what 'AIPSx' we will be (if any)
C-----------------------------------------------------------------------
      CHARACTER VERSIN*256, PHFILE*48, AIPSN*6, MSGBUF*80, PRGNAM*6,
     *   XLATED*256, MYTTY*256, RESTTX*7, RESTTY*256, POPSNO*1
      INTEGER   IBUF(256), IERR, IPOPS, PID(4), IFIND, LUNCRT, MYPOPS,
     *   MYPRIO, XLEN, XLNB
      LOGICAL   ACTIV1, ACTIV2, ACTIVE, RESRVD(15), T, F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LUNCRT, T, F /5, .TRUE., .FALSE./
      DATA PRGNAM /'ZSTRTA'/
      DATA RESTTX /'RESSTTX'/
C-----------------------------------------------------------------------
C                                       Set values especially NINTRN.
      CALL ZDCHIN (.TRUE., IBUF)
C                                       Copy PRGNAM into TSKNAM.
      TSKNAM = PRGNAM
C                                       Get default version.
      CALL ZMYVER
      VERSIN = VERNAM(1:3)
C                                       Check for LOCAL version AIPS.EXE
      XLEN = LEN (XLATED)
      CALL ZTRLOG (9, 'AIPSLOCAL', XLEN, XLATED, XLNB, IERR)
      IF (IERR.EQ.0) THEN
         VERSIN = XLATED(1:XLNB)
C                                       Not local: Determine LOAD area
C                                       for AIPS.EXE based on the value
C                                       of logical TVLOAD as defined
C                                       by the AIPS startup procedure.
      ELSE
         XLEN = LEN (XLATED)
         CALL ZTRLOG (6, 'TVLOAD', XLEN, XLATED, XLNB, IERR)
         IF (IERR.EQ.0) VERSIN = XLATED(1:XLNB)
         END IF
C                                       Get name of default task message
C                                       terminal (logical TASKTT0 as
C                                       defined via the "tty" command in
C                                       $AIPS_ROOT/AIPSPATH.SH and .CSH
C                                       Default is your terminal
      XLEN = LEN (XLATED)
      CALL ZTRLOG (7, 'TASKTT0', XLEN, XLATED, XLNB, IERR)
      IF (IERR.NE.0) THEN
C                                       If that failed, just continue on
C                                       as this may be, e.g. AIPS
C                                       running from a "here" document
         XLATED = 'NOT A TTY'
         XLNB = 9
         IERR = 0
         END IF
      MYTTY = XLATED(1:XLNB)
C                                       See if MYTTY matches any
C                                       RESSTTx.  If so, this is the
C                                       terminal reserved for AIPSx.
C                                       If no match, then skip all this.
      DO 25 IPOPS = 1,NINTRN
         RESRVD(IPOPS) = .FALSE.
         CALL ZEHEX (IPOPS, 1, RESTTX(7:7))
         XLEN = LEN (XLATED)
         CALL ZTRLOG (7, RESTTX, XLEN, XLATED, XLNB, IERR)
C                                       Record reserved POPS #'s
         IF (IERR.NE.0) GO TO 25
            RESRVD(IPOPS) = .TRUE.
            RESTTY = XLATED(1:XLNB)
C                                       We are on a terminal reserved
C                                       for AIPSx (x = hex IPOPS).
C                                       Make sure AIPSx is not already
C                                       running (if so, it's an error).
            IF (RESTTY.EQ.MYTTY) THEN
               MYPOPS = IPOPS
               CALL ZEHEX (IPOPS, 1, POPSNO)
               AIPSN = 'DAIP' // POPSNO
               CALL FILL (4, 0, PID)
               CALL ZTACTQ (AIPSN, PID(2), ACTIV1, IERR)
               AIPSN = 'AIPS' // POPSNO
               CALL FILL (4, 0, PID)
               CALL ZTACTQ (AIPSN, PID(2), ACTIV2, IERR)
               ACTIVE = (ACTIV1.OR.ACTIV2)
               IF (.NOT.ACTIVE) GO TO 50
C                                       AIPSx reserved for this terminal
C                                       is already running on some other
C                                       terminal.
                  WRITE (MSGTXT,1020) POPSNO
                  GO TO 990
               END IF
 25      CONTINUE
C                                       Not on a reserved terminal.
C                                       Get lowest inactive POPS #
C                                       not reserved.
      DO 30 IPOPS = 1,NINTRN
         IF (RESRVD(IPOPS)) GO TO 30
            CALL ZEHEX (IPOPS, 1, POPSNO)
            AIPSN = 'DAIP' // POPSNO
            CALL FILL (4, 0, PID)
            CALL ZTACTQ (AIPSN, PID(2), ACTIV1, IERR)
            AIPSN = 'AIPS' // POPSNO
            CALL FILL (4, 0, PID)
            CALL ZTACTQ (AIPSN, PID(2), ACTIV2, IERR)
            ACTIVE = (ACTIV1.OR.ACTIV2)
            IF (.NOT.ACTIVE) THEN
               MYPOPS = IPOPS
               GO TO 50
               END IF
 30      CONTINUE
C                                       All AIPSx's in use.
      WRITE (MSGTXT,1040)
      GO TO 990
C                                       Set execution priority.
 50   CALL ZSTRTP (MYPOPS, MYPRIO, IERR)
C                                       Announce what's about to
C                                       happen.
      CALL ZOPEN (LUNCRT, IFIND, 1, PHFILE, F, T, T, IERR)
      WRITE (MSGBUF,1050) POPSNO, RLSNAM, MYPRIO
      CALL ZTTYIO ('WRIT', LUNCRT, IFIND, 72, MSGBUF, IERR)
C                                       Activate AIPSx (x = MYPOPS).
      AIPSN = 'AIPS  '
      CALL ZACTV8 (AIPSN, MYPOPS, VERSIN, PID, IERR)
C                                       Never expect to get here, but
C                                       just in case.
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1060) IERR
 990     CALL MSGWRT (8)
C
 999  STOP
C-----------------------------------------------------------------------
 1020 FORMAT ('ZSTRTA: ',A5,' IS ALREADY RUNNING SOMEWHERE!')
 1040 FORMAT ('ZSTRTA: ******  ALL AIPS ARE IN USE.  ******')
 1050 FORMAT ('Begin the one true AIPS number ',A1,' (release of ',
     *   A7,') at priority = ',I3)
 1060 FORMAT ('ZSTRTA: ACTIVATION ERROR = ',I6)
      END

      SUBROUTINE HIENH (HCHAN, ICHAN, ITYPE, RPOS, IERR)
C-----------------------------------------------------------------------
C! interactive linear enhancement of 2-image hue-intensity TV display
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2008, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   HIENH performs an interactive linear enhancement of the hue and
C   intensity assignments for displaying two images as hue/intensity.
C   X cursor => intercept, Y cursor => slope.
C   Button A: flip which image determines hue and which determines int.
C   Button B: flip whether hue or intensity is being enhanced.
C   Button C: flip sign of enhancement.
C   Button D: exit.
C   Inputs:
C      HCHAN   I          channel select for hue image (1-NGRAY)
C      ICHAN   I          channel select for int. image (1-NGRAY)
C      ITYPE   I          type of color table: 0 -> spectrum
C                                 1 -> circular
C   In/Out:
C      RPOS    R(2)       Cursor position: initial -> final
C   Output:
C      IERR    I          error code of ZM70XF: 0 => ok
C   Common output:
C      /AIPSCR/ BUFFER  I(3072)    scratch buffer
C   NOTE - these dimensions work for MAXINT <= 511 only.  There are no
C   TVs other than IIS M70 and IIS M75 which can do this algorithm at
C   present.
C-----------------------------------------------------------------------
      INTEGER   HCHAN, ICHAN, ITYPE, IERR
      REAL      RPOS(2)
C
      INCLUDE 'INCS:PTVC.INC'
      INTEGER   IX, IX0, IY0, IBUT, IFLIP, MXI, HCC, ICC, SFLIP, IPOS,
     *   QUAD, JERR, ITW(3), I, LOGLUT(TVMLUT), LUT(TVMLUT), IC, HC,
     *   RBUF(TVMLUT), GBUF(TVMLUT), BBUF(TVMLUT), TEMPC, BUFFER(TVMLUT)
      LOGICAL   F, DOIT, HCHANG
      REAL      PPOS(2), A, SAVPOS(2), TMPPOS
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMMON /AIPSCR/ BUFFER, LUT, LOGLUT, RBUF, GBUF, BBUF
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      ICC = ICHAN
      IC = 2 ** (ICHAN-1)
      HCC = HCHAN
      HC = 2 ** (HCHAN-1)
      HCHANG = .FALSE.
C                                       calculate log look up table
      A = LUTOUT / LOG10 (REAL(MAXINT))
      MXI = MAXINT + 1
      DO 10 I = 1,MAXINT
         LOGLUT(I+1) =  A * LOG10 (REAL(I)) + 0.5
 10      CONTINUE
      LOGLUT(1) = 0
C                                       Initialize two channels
C                                       uses MAXINT here, fixed to
C                                       LUTOUT at label 35
C                                       Red table: spectrum
 20   IF (ITYPE.LT.1) THEN
         IX0 = 0.26 * MAXINT
         IX = 0.41 * MAXINT
         CALL STRLIN (0, 0, IX0, 0, RBUF)
         CALL STRLIN (IX0, 0, IX, MAXINT, RBUF)
         CALL STRLIN (IX, MAXINT, MAXINT, MAXINT, RBUF)
C                                       Green table
         IY0 = 0.267 * MAXINT
         IX0 = 0.353 * MAXINT
         IX = 0.479 * MAXINT
         CALL STRLIN (0, IY0, IX0, MAXINT, GBUF)
         CALL STRLIN (IX0, MAXINT, IX, MAXINT, GBUF)
         IX0 = 0.981 * MAXINT
         CALL STRLIN (IX, MAXINT, IX0, 0, GBUF)
         CALL STRLIN (IX0, 0, MAXINT, 0, GBUF)
C                                       blue table
         IX0 = 0.063 * MAXINT
         IX = 0.334 * MAXINT
         CALL STRLIN (0, MAXINT, IX0, MAXINT, BBUF)
         CALL STRLIN (IX0, MAXINT, IX, 0, BBUF)
         CALL STRLIN (IX, 0, MAXINT, 0, BBUF)
C                                       Circular: red table
      ELSE
         IX0 = 0.24 * MAXINT
         IX = 0.36 * MAXINT
         CALL STRLIN (0, 0, IX0, 0, RBUF)
         CALL STRLIN (IX0, 0, IX, MAXINT, RBUF)
         IX0 = 0.77 * MAXINT
         CALL STRLIN (IX, MAXINT, IX0, MAXINT, RBUF)
         IY0 = 0.25 * MAXINT
         CALL STRLIN (IX0, MAXINT, MAXINT, IY0, RBUF)
C                                       Green table
         IX0 = 0.16 * MAXINT
         IX = 0.37 * MAXINT
         CALL STRLIN (0, IY0, IX0, MAXINT, GBUF)
         CALL STRLIN (IX0, MAXINT, IX, MAXINT, GBUF)
         IX0 = 0.66 * MAXINT
         CALL STRLIN (IX, MAXINT, IX0, 0, GBUF)
         CALL STRLIN (IX0, 0, MAXINT, 0, GBUF)
C                                       Blue table
         IX0 = 0.13 * MAXINT
         IX = 0.286 * MAXINT
         CALL STRLIN (0, MAXINT, IX0, MAXINT, BBUF)
         CALL STRLIN (IX0, MAXINT, IX, 0, BBUF)
         IX0 = 0.57 * MAXINT
         CALL STRLIN (IX, 0, IX0, 0, BBUF)
         IX = 0.8 * MAXINT
         CALL STRLIN (IX0, 0, IX, MAXINT, BBUF)
         CALL STRLIN (IX, MAXINT, MAXINT, MAXINT, BBUF)
         END IF
C                                       Take log via lookup
      DO 30 I = 1,MXI
         RBUF(I) = LOGLUT (RBUF(I) + 1)
         GBUF(I) = LOGLUT (GBUF(I) + 1)
         BBUF(I) = LOGLUT (BBUF(I) + 1)
 30      CONTINUE
      RBUF(1) = 0
      GBUF(1) = 0
      BBUF(1) = 0
C                                       init  position values
      IF ((RPOS(1).LT.WINDTV(1)) .OR. (RPOS(1).GT.WINDTV(3)) .OR.
     *   (RPOS(2).LT.WINDTV(2)) .OR. (RPOS(2).GT.WINDTV(4))) THEN
         RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2.0
         RPOS(2) = (WINDTV(4) - WINDTV(2)) / 3.0 + WINDTV(2)
         SAVPOS(1) = RPOS(1)
         SAVPOS(2) = RPOS(2)
         END IF
      IFLIP = 1
      SFLIP = 1
C                                       Init hue LUTs (HCHANG=F) or
C                                       Init intensity LUTs
      DOIT = .NOT.HCHANG
      CALL HILUT (HC, IC, DOIT, SAVPOS, IFLIP, IERR)
      IPOS = 1
      IF (IERR.NE.0) GO TO 900
      IF (HCHANG) THEN
         WRITE (MSGTXT,1040) HCC, ICC
      ELSE
         WRITE (MSGTXT,1041) ICC, HCC
         END IF
      CALL MSGWRT (1)
      WRITE (MSGTXT,1042)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1043)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1044)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1045)
      CALL MSGWRT (1)
C                                       turn on cursor
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      CALL ZTIME (ITW)
      QUAD = -1
      CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IERR)
      IPOS = 2
      IF (IERR.NE.0) GO TO 900
C                                        read loop
 50   CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IERR)
      IPOS = 3
      IF ((IBUT.LE.7) .AND. (IERR.EQ.0)) THEN
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF (DOIT) THEN
C                                        Check for buttons
C                                        Flip hue/intensity assignments
            IF (IBUT.EQ.1) THEN
               TEMPC = IC
               IC = HC
               HC = TEMPC
               TEMPC = ICC
               ICC = HCC
               HCC = TEMPC
               GO TO 20
C                                        Flip which is being enhanced
            ELSE IF (IBUT.EQ.2) THEN
               TMPPOS = SAVPOS(1)
               SAVPOS(1) = RPOS(1)
               RPOS(1) = TMPPOS
               TMPPOS = SAVPOS(2)
               SAVPOS(2) = RPOS(2)
               RPOS(2) = TMPPOS
               TEMPC = IFLIP
               IFLIP = SFLIP
               SFLIP = TEMPC
               CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IERR)
               IPOS = 4
               IF (IERR.NE.0) GO TO 900
               HCHANG = .NOT. HCHANG
               IF (HCHANG) WRITE (MSGTXT,1060) HCC
               IF (.NOT.HCHANG) WRITE (MSGTXT,1061) ICC
               CALL MSGWRT (1)
C                                       Flip sign of slope
            ELSE IF (IBUT.EQ.4) THEN
               IFLIP = -IFLIP
               END IF
C                                        new LUT
            CALL HILUT (HC, IC, HCHANG, RPOS, IFLIP, IERR)
            IPOS = 5
            IF (IERR.NE.0) GO TO 900
            END IF
         GO TO 50
         END IF
C                                        off graphics & cursor
 900  CALL YCURSE ('OFFF', F, F, RPOS, QUAD, IBUT, JERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1900) IERR, IPOS
         CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('Enhance hue channel',I2,' with intensity channel',I2)
 1041 FORMAT ('Enhance intensity channel',I2,' with hue channel',I2)
 1042 FORMAT ('Cursor X controls intercept, Y slope of the LUT')
 1043 FORMAT ('Press button A to switch roles of the channels')
 1044 FORMAT ('Press button B to switch which is enhanced')
 1045 FORMAT ('Press button C to reverse slope, button D to exit')
 1060 FORMAT ('Enhance hue channel',I2)
 1061 FORMAT ('Enhance intensity channel',I2)
 1900 FORMAT ('HIENH: TV ERROR',I4,' AT',I4)
      END

      SUBROUTINE TRED2 (NM, N, A, D, E, Z)
C-----------------------------------------------------------------------
C! Reduces a real, symm. matrix to a symm. tridiagonal matrix.
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE TRED2,
C     NUM. MATH. 11, 181-195(1968) BY MARTIN, REINSCH, AND WILKINSON.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     THIS SUBROUTINE REDUCES A REAL SYMMETRIC MATRIX TO A
C     SYMMETRIC TRIDIAGONAL MATRIX USING AND ACCUMULATING
C     ORTHOGONAL SIMILARITY TRANSFORMATIONS.
C
C     ON INPUT:
C
C        NM MUST BE SET TO THE ROW DIMENSION OF TWO-DIMENSIONAL
C          ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C          DIMENSION STATEMENT;
C
C        N IS THE ORDER OF THE MATRIX;
C
C        A CONTAINS THE REAL SYMMETRIC INPUT MATRIX.  ONLY THE
C          LOWER TRIANGLE OF THE MATRIX NEED BE SUPPLIED.
C
C     ON OUTPUT:
C
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX;
C
C        E CONTAINS THE SUBDIAGONAL ELEMENTS OF THE TRIDIAGONAL
C          MATRIX IN ITS LAST N-1 POSITIONS.  E(1) IS SET TO ZERO;
C
C        Z CONTAINS THE ORTHOGONAL TRANSFORMATION MATRIX
C          PRODUCED IN THE REDUCTION;
C
C        A AND Z MAY COINCIDE.  IF DISTINCT, A IS UNALTERED.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C-----------------------------------------------------------------------
      INTEGER N, NM
      INTEGER   I, J, K, L, II, JP1
      DOUBLE PRECISION A(NM,N), D(N), E(N), Z(NM,N)
      DOUBLE PRECISION F, G, H, HH, SCALE
C-----------------------------------------------------------------------
C
      DO 100 I = 1, N
         DO 99 J = 1, I
            Z(I,J) = A(I,J)
 99         CONTINUE
 100     CONTINUE
C
      IF (N.EQ.1) GO TO 320
C     :::::::::: FOR I=N STEP -1 UNTIL 2 DO -- ::::::::::
      INCLUDE 'INCS:ZVD.INC'
      DO 300 II = 2, N
         I = N + 2 - II
         L = I - 1
         H = 0.0D0
         SCALE = 0.0D0
         IF (L.LT.2) GO TO 130
C     :::::::::: SCALE ROW (ALGOL TOL THEN NOT NEEDED) ::::::::::
      INCLUDE 'INCS:ZVD.INC'
         DO 120 K = 1, L
            SCALE = SCALE + ABS(Z(I,K))
 120        CONTINUE
C
         IF (SCALE .NE. 0.0D0) GO TO 140
  130    E(I) = Z(I,L)
         GO TO 290
C
      INCLUDE 'INCS:ZVD.INC'
  140    DO 150 K = 1, L
            Z(I,K) = Z(I,K) / SCALE
            H = H + Z(I,K) * Z(I,K)
  150       CONTINUE
C
         F = Z(I,L)
         G = -SIGN (SQRT (H), F)
         E(I) = SCALE * G
         H = H - F * G
         Z(I,L) = F - G
         F = 0.0D0
C
      INCLUDE 'INCS:ZVD.INC'
         DO 240 J = 1, L
            Z(J,I) = Z(I,J) / H
            G = 0.0D0
C     :::::::::: FORM ELEMENT OF A*U ::::::::::
      INCLUDE 'INCS:ZVD.INC'
            DO 180 K = 1, J
               G = G + Z(J,K) * Z(I,K)
 180           CONTINUE
C
            JP1 = J + 1
            IF (L.LT.JP1) GO TO 220
C
      INCLUDE 'INCS:ZVD.INC'
            DO 200 K = JP1, L
               G = G + Z(K,J) * Z(I,K)
 200           CONTINUE
C     :::::::::: FORM ELEMENT OF P ::::::::::
  220       E(J) = G / H
            F = F + E(J) * Z(I,J)
  240       CONTINUE
C
         HH = F / (H + H)
C     :::::::::: FORM REDUCED A ::::::::::
      INCLUDE 'INCS:ZVD.INC'
         DO 260 J = 1, L
            F = Z(I,J)
            G = E(J) - HH * F
            E(J) = G
C
      INCLUDE 'INCS:ZVD.INC'
            DO 259 K = 1, J
               Z(J,K) = Z(J,K) - F * E(K) - G * Z(I,K)
 259           CONTINUE
 260        CONTINUE
C
 290     D(I) = H
 300    CONTINUE
C
 320  D(1) = 0.0D0
      E(1) = 0.0D0
C     :::::::::: ACCUMULATION OF TRANSFORMATION MATRICES ::::::::::
      INCLUDE 'INCS:ZVD.INC'
      DO 500 I = 1, N
         L = I - 1
         IF (D(I).EQ.0.0D0) GO TO 380
C
      INCLUDE 'INCS:ZVD.INC'
         DO 360 J = 1, L
            G = 0.0D0
C
      INCLUDE 'INCS:ZVD.INC'
            DO 340 K = 1, L
               G = G + Z(I,K) * Z(K,J)
 340           CONTINUE
C
      INCLUDE 'INCS:ZVD.INC'
            DO 359 K = 1, L
               Z(K,J) = Z(K,J) - G * Z(K,I)
 359           CONTINUE
 360        CONTINUE
C
 380     D(I) = Z(I,I)
         Z(I,I) = 1.0D0
         IF (L.LT.1) GO TO 500
C
         DO 400 J = 1, L
            Z(I,J) = 0.0D0
            Z(J,I) = 0.0D0
  400       CONTINUE
C
  500 CONTINUE
C
      RETURN
      END

      SUBROUTINE ZMKTMP (FLEN, FILNAM, IERR)
C-----------------------------------------------------------------------
C! convert a "temporary" file name into a unique name
C# Z IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Form a unique, fully qualified, temporary file name.
C   Inputs:
C      FLEN     I       Length of "filnam"
C   In/Out:
C      FILNAM   H*(*)   File name with the extension .XXXXXX, (e.g.,
C                       "ZXLPRT.XXXXXX").  The extension will be
C                       transformed by 'mktemp' to make "filnam" a
C                       unique file name.
C   Output:
C      IERR     I       Error return code: 0 => no error
C                          1 => inputs wrong
C                          2 => system service fails
C                          3 => filnam too short
C   VMS version
C-----------------------------------------------------------------------
      INTEGER   FLEN, IERR
      HOLLERITH FILNAM*(*)
C
      INTEGER   ITEM(4), SYS$GETJPIW, JERR, ILOC, LBUFF, BUFF, LLEN,
     *   ITRIM, I
      INTEGER*2 ITEM2(8)
      CHARACTER CTEMP*5, LFILN*256
      LOGICAL   EXISTS
      INCLUDE '($JPIDEF)'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (ITEM2, ITEM)
C-----------------------------------------------------------------------
      IERR = 0
      CALL H2CHR (FLEN, 1, FILNAM, LFILN)
C                                       Locate XXXXXXs
      ILOC = INDEX (LFILN, 'XXXXXX')
      IF (ILOC.LE.0) THEN
         IERR = 1
         MSGTXT = 'ZMKTMP: IMPROPER TEMPLATE FOR TEMPORARY FILE NAME'
         GO TO 995
         END IF
C                                       build structure
      ITEM2(1) = 4
      ITEM2(2) = JPI$_PID
      ITEM(2) = %LOC (BUFF)
      ITEM(3) = %LOC (LBUFF)
      ITEM(4) = 0
C                                       call service
      JERR = SYS$GETJPIW ( , , , ITEM, , , )
      IF (JERR.NE.1) THEN
         IERR = 2
         WRITE (MSGTXT,1010) JERR
         GO TO 995
         END IF
C                                       Build file name
      BUFF = MOD (BUFF-1, 1000000) + 1
      CALL ZHEX (BUFF, 5, CTEMP)
      LFILN(ILOC+1:ILOC+5) = CTEMP
      LLEN = ITRIM (LFILN)
C                                       make unique
      DO 20 I = 1,16
         LBUFF = I - 1
         CALL ZHEX (LBUFF, 1, LFILN(ILOC:ILOC))
         INQUIRE (FILE=LFILN(:LLEN), EXIST=EXISTS)
         IF (.NOT.EXISTS) THEN
            CALL CHR2H (LLEN, LFILN, 1, FILNAM)
            GO TO 999
            END IF
 20      CONTINUE
      IERR = 3
      MSGTXT = 'ZMKTMP: UNABLE TO BUILD UNIQUE NAME'
C
 995  CALL MSGWRT (6)
      MSGTXT = 'ZMKTMP: ' // LFILN
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ZMKTMP: GETJPI RETURNS ERROR CODE',I8)
      END

      SUBROUTINE IMREF1 (DISK, CNO, VER, ATTVER, CATBLK, LUN, ROWF,
     *   IRET)
C-----------------------------------------------------------------------
C! Checks existence of IM table ver 1, changes format if necessary
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2000, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to change the format of the IM table 1 to latest version.
C   N.B. A few projects in the early days of the VLBA correlator had
C   the wrong IM table format (TABREV = 1), this routine updates them.
C
C   NOTE: routine uses LUNs 45 &46 as a temporary logical unit number.
C   Inputs:
C      DISK     I        Volume number
C      CNO      I        Catalogue number
C      VER      I        Version # of old format table
C      ATTVER   I        Version # of output table, may be same as VER
C      CATBLK   I(256)   Catalogue header
C      LUN      I        LUN to use
C   Output:
C      ROWF     I        Start row in output table
C      IRET     I        Error, 0 => OK
C   The common set by DIMV.INC is used on input if the input IM table
C   lacks some of the critical keywords and is altered by this routine.
C-----------------------------------------------------------------------
      INTEGER DISK, CNO, VER, ATTVER, ROWF, CATBLK(256), LUN, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   BUFF1(512), BUFF2(512), OUTVER, OLUN, IDUM, NROW,
     *   IPT, I, J, K, IOFF
      LOGICAL   TABLE, EXIST, FITASC, CHSTAT
      CHARACTER UTYPE*2, CTEMP*12, STAT*4
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DGLB.INC'
C                                       Include for Interferometer
C                                       Model table handling
C                                       routines. Version #1
C                                       IM definitions
      INTEGER   MAXLMC, NKEYLM, MAXWLM, MAXLEC, MAXLCD, MAXLOL
C                                       # cols in LM table
      PARAMETER (MAXLMC=14)
C                                       # keywords in LM table
      PARAMETER (NKEYLM=12)
C                                       max # words in header array
      PARAMETER (MAXWLM=20)
C                                       Max order of polynomial
C                                       for geometrical parameters
      PARAMETER (MAXLOL=10)
C                                       max size of logical record
C                                       in single precision words
      PARAMETER (MAXLEC=8+13*MAXIF+8*MAXLOL)
C                                       max siz of logical record
C                                       in double precision words
      PARAMETER (MAXLCD=MAXLEC/2)
C                                       Parameters specifying the
C                                       position of variables within
C                                       a table row.
      INTEGER   LTLM, LINT, LSOU, LANO, LARR, LFRE, LIFR, LFVR,
     *   LPDL, LGDL, LPRT, LGRT, LPDSP1, LPDT1
      PARAMETER (LTLM=1)
      PARAMETER (LINT=2)
      PARAMETER (LSOU=3)
      PARAMETER (LANO=4)
      PARAMETER (LARR=5)
      PARAMETER (LFRE=6)
      PARAMETER (LIFR=7)
      PARAMETER (LFVR=8)
      PARAMETER (LPDL=9)
      PARAMETER (LGDL=10)
      PARAMETER (LPRT=11)
      PARAMETER (LGRT=12)
      PARAMETER (LPDSP1=13)
      PARAMETER (LPDT1=14)
C                                       IM1 specific keywords
      INTEGER   ILMRNO, NXPOLZ, NXOLY
      REAL      RXVNUM
C                                       IM1 specific column variables
      INTEGER   NXSTA, IXRRAY, IXQID, IXRC
      REAL      TXNT, IXR, FXEQVR(MAXIF), DXSP(MAXIF), DXISP(MAXIF)
      DOUBLE PRECISION TXME, PXELAY(MAXIF,MAXLOL), GXELAY(MAXLOL),
     *   PXATE(MAXIF,MAXLOL), GXATE(MAXLOL)
C                                       Generic table variables
      INTEGER   LKEY, LLEC, LDATP(128,2), LCOL, LPOINT
      INTEGER   LMKOLS(MAXLMC), LMNUMV(MAXLMC), LDTYP(MAXLMC)
      INTEGER   LLOCS(NKEYLM), LEYTYP(NKEYLM)
      INTEGER   LEYVAL(MAXWLM)
      INTEGER   LECI(MAXLEC)
      REAL      LEYVAR(MAXWLM)
      REAL      LECORD(MAXLEC)
      HOLLERITH LEYVAH(MAXWLM)
      HOLLERITH LECH(MAXLEC)
      DOUBLE PRECISION LECD(MAXLCD), KEYVAD
      CHARACTER  LEYW(NKEYLM)*8
      EQUIVALENCE (LEYVAL, LEYVAR, LEYVAH)
      EQUIVALENCE (LECD, LECORD, LECI, LECH)
C                                       local commons only
      COMMON /LMTABV/ LKEY, LLEC, LDATP, LCOL, LPOINT, LMKOLS, LMNUMV,
     *   LDTYP, LLOCS, LEYTYP, LEYVAL
      COMMON /LMVALS/ TXME, PXELAY, GXELAY, PXATE, GXATE, TXNT, IXR,
     *   FXEQVR, DXSP, DXISP, RXVNUM, ILMRNO, NXPOLZ, NXOLY, NXSTA,
     *   IXRRAY, IXQID, IXRC
      INCLUDE 'INCS:DIMV.INC'
C                                       Header leywords
      DATA LEYW /'OBSCODE ', 'NO_STKD ', 'STK_1   ', 'NO_BAND ',
     *   'NO_CHAN', 'REF_FREQ', 'CHAN_BW ', 'REF_PIXL',
     *   'NO_POL', 'NPOLY', 'REVISION', 'TABREV' /
C
      DATA OLUN /45/
C-----------------------------------------------------------------------
C                                       Check existance
      CALL ISTAB ('IM', DISK, CNO, VER, LUN, BUFF1, TABLE, EXIST,
     *   FITASC, IRET)
      IRET = 0
      IF (.NOT.EXIST) GO TO 999
C                                       Copy old file
      OUTVER = 0
      I = MSGSUP
      MSGSUP = 31999
      CALL TABCOP ('IM', VER, OUTVER, LUN, OLUN, DISK, DISK, CNO, CNO,
     *   CATBLK, BUFF1, BUFF2, IRET)
      MSGSUP = I
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Delete old version
      CALL RMEXT (DISK, CNO, 'IM', VER, CATBLK, BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Update CATBLK
      CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'REST', BUFF1, IRET)
C                                       Determine status of file
      UTYPE = 'UV'
      CHSTAT = .FALSE.
      CALL CATDIR ('INFO', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE, IDUM,
     *   STAT, BUFF1, IRET)
C                                       Change status
      IF (STAT.NE.'WRIT') THEN
         CALL STATCH (STAT, 'WRIT', DISK, CNO, UTYPE, BUFF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'CLRD'
            GO TO 990
            END IF
         CHSTAT = .TRUE.
         END IF
C                                       Open old version
C                                       Set up needed variables
      LLEC = 30
      LCOL = 0
      LKEY = NKEYLM
C                                       Open file
      CALL TABINI ('READ', 'IM', DISK, CNO, OUTVER, CATBLK, OLUN, LKEY,
     *   LLEC, LCOL, LDATP, BUFF1, IRET)
      IF (IRET.GT.0) THEN
         CALL TABERR ('READ', 'TABINI', 'IMREF1', IRET)
         GO TO 990
         END IF
C                                       # rows in old table
      NROW = BUFF1(5)
C                                       Read keywords
      IF (LKEY.NE.NKEYLM) THEN
         WRITE (MSGTXT,1020) LKEY, NKEYLM
         CALL MSGWRT (6)
         END IF
      LKEY = NKEYLM
      CALL TABKEY ('READ', LEYW, LKEY, BUFF1, LLOCS, LEYVAL, LEYTYP,
     *   IRET)
      IF ((IRET.GE.1) .AND. (IRET.LE.20)) THEN
         CALL TABERR ('READ', 'TABKEY', 'IMREF1', IRET)
         GO TO 990
         END IF
      IRET = 0
C                                       Observing code
      IPT = 1
      IPOINT = LLOCS(IPT)
      IF (IPOINT.GT.0) CALL H2CHR (8, 1, LEYVAH(IPOINT), OBSCOD)
C                                       # Stokes in data
      IPT = IPT + 1
      IPOINT = LLOCS(IPT)
      IF (IPOINT.GT.0) NOSTKD = LEYVAL(IPOINT)
      IPT = IPT + 1
C                                       1st Stokes in data
      IPOINT = LLOCS(IPT)
      IF (IPOINT.GT.0) STK1 = LEYVAL(IPOINT)
      IPT = IPT + 1
C                                       # band's (IF's) in data
      IPOINT = LLOCS(IPT)
      IF (IPOINT.GT.0) NOBAND = LEYVAL(IPOINT)
      IPT = IPT + 1
C                                       # spectral channels in data
      IPOINT = LLOCS(IPT)
      IF (IPOINT.GT.0) NOCHAN = LEYVAL(IPOINT)
      IPT = IPT + 1
C                                       Ref frq
      IPOINT = LLOCS(IPT)
      IF (IPOINT.GT.0) THEN
         IF (LEYTYP(IPT).EQ.TABDBL) THEN
            CALL RCOPY (NWDPDP, LEYVAR(IPOINT), REFFRQ)
         ELSE
            REFFRQ = LEYVAR(IPOINT)
            END IF
         END IF
      IPT = IPT + 1
C                                       Chn. bw
      IPOINT = LLOCS(IPT)
      IF (IPOINT.GT.0) THEN
         IF (LEYTYP(IPT).EQ.TABDBL) THEN
            CALL RCOPY (NWDPDP, LEYVAR(IPOINT), KEYVAD)
            CHNBW = KEYVAD
         ELSE
            CHNBW = LEYVAR(IPOINT)
            END IF
         END IF
      IPT = IPT + 1
C                                       Ref. pixel
      IPOINT = LLOCS(IPT)
      IF (IPOINT.GT.0) THEN
         IF (LEYTYP(IPT).EQ.TABDBL) THEN
            CALL RCOPY (NWDPDP, LEYVAR(IPOINT), KEYVAD)
            REFPIX = KEYVAD
         ELSE
            REFPIX = LEYVAR(IPOINT)
            END IF
         END IF
      IPT = IPT + 1
C                                       # polzns in table
      IPOINT = LLOCS(IPT)
      IF (IPOINT.GT.0) NOPOLZ = LEYVAL(IPOINT)
      IPT = IPT + 1
C                                       Order of polynomial
      IPOINT = LLOCS(IPT)
      IF (IPOINT.GT.0) NPOLY = LEYVAL(IPOINT)
      IPT = IPT + 1
C                                       Revision number
      IPOINT = LLOCS(IPT)
      IF (IPOINT.GT.0) THEN
         IF (LEYTYP(IPT).EQ.TABDBL) THEN
            CALL RCOPY (NWDPDP, LEYVAR(IPOINT), KEYVAD)
            REVNUM = KEYVAD
         ELSE
            REVNUM = LEYVAR(IPOINT)
            END IF
         END IF
      IPT = IPT + 1
C                                       Table revision number
      IPOINT = LLOCS(IPT)
      IF (IPOINT.GT.0) TABREV = LEYVAL(IPOINT)
C                                       Get array indices and no. values
      DO 40 I = 1,LCOL
         LMKOLS(I) = LDATP(I,1)
         LMNUMV(I) = LDATP(I,2) / 10
   40    CONTINUE
C                                       Set up new table
      TABREV = 2
      CALL IMINI ('WRIT', BUFF2, DISK, CNO, ATTVER, CATBLK, LUN,
     *   IRET)
      IF (IRET.GT.0) THEN
         CALL TABERR ('WRIT', 'IMINI', 'IMREF1', IRET)
         GO TO 990
         END IF
      ROWF = IIMRNO
C                                       Loop and translate
      DO 100 J = 1, NROW
         ILMRNO = J
         CALL TABIO ('READ', 0, ILMRNO, LECI, BUFF1, IRET)
         IF (IRET.GT.0) THEN
            CALL TABERR ('READ', 'TABIO', 'IMREF1', IRET)
            GO TO 990
            END IF
         TIME = LECD(LMKOLS(LTLM))
         TINT = LECORD(LMKOLS(LINT))
         ISRC = LECI(LMKOLS(LSOU))
         NOSTA = LECI(LMKOLS(LANO))
         IARRAY = LECI(LMKOLS(LARR))
         IFQID = LECI(LMKOLS(LFRE))
         IFR = LECORD(LMKOLS(LIFR))
         DO 50 I = 1, NPOLY
            GDELA1(I) = LECD(LMKOLS(LGDL)+I-1)
            GRATE1(I) = LECD(LMKOLS(LGRT)+I-1)
            IF (NOPOLZ.GT.1) THEN
               GDELA2(I) = LECD(LMKOLS(LGDL)+I-1)
               GRATE2(I) = LECD(LMKOLS(LGRT)+I-1)
               END IF
   50       CONTINUE
         DO 60 I = 1, NOBAND
            FREQVR(I) = LECORD(LMKOLS(LFVR)+I-1)
   60       CONTINUE
         DO 80 I = 1, NOBAND
            IOFF = (I-1) * NPOLY
            DO 70 K = 1, NPOLY
               PDELA1(I,K) = LECD(LMKOLS(LPDL)+IOFF+K-1)
               PRATE1(I,K) = LECD(LMKOLS(LPRT)+IOFF+K-1)
               IF (NOPOLZ.GT.1) THEN
                  PDELA2(I,K) = LECD(LMKOLS(LPDL)+IOFF+K-1)
                  PRATE2(I,K) = LECD(LMKOLS(LPRT)+IOFF+K-1)
                  END IF
   70          CONTINUE
   80       CONTINUE
C                                       Initialize missing components
            DISP1 = 0.0
            DISP2 = 0.0
            DDISP1 = 0.0
            DDISP2 = 0.0
C                                       Write new row
         CALL IMTAB ('WRIT', BUFF2, NOBAND, IRET)
         IF (IRET.GT.0) THEN
            CALL TABERR ('WRIT', 'IMTAB', 'IMREF1', IRET)
            GO TO 990
            END IF
  100    CONTINUE
C                                       Close tables
      CALL TABIO ('CLOS', 0, ILMRNO, BUFF1, BUFF1, IRET)
      CALL TABIO ('CLOS', 0, IIMRNO, BUFF2, BUFF2, IRET)
C                                       Delete copy
      CALL RMEXT (DISK, CNO, 'IM', OUTVER, CATBLK, BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Check if changed status
C                                       Change status
      IF (CHSTAT) THEN
         CALL STATCH ('WRIT', STAT, DISK, CNO, UTYPE, BUFF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'CLWR'
            GO TO 990
            END IF
         END IF
C                                       Update CATBLK
      CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'REST', BUFF1, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('IMREF1: ERROR ',I3,' COPYING OLD TABLE')
 1010 FORMAT ('IMREF1: ERROR ',I3,' DELETING OLD TABLE')
 1020 FORMAT ('IMREF1: NUMBER KEYWORDS',I4,' NOT EXPECTED',I3)
 1080 FORMAT ('IMREF1: ERROR ',I3,' CHANGING ',A4,' STATUS')
      END

LOCAL INCLUDE 'AFILE.INC'
      INTEGER   NUMLIN
      PARAMETER (NUMLIN=20000)
C
      HOLLERITH XINFIL(12), XOUTFL(12), XOPCOD(1)
      CHARACTER INFIL*48, OUTFIL*48, OPCODE*4
      REAL      APARM(10)
      INTEGER   LUN1, LUN2, FIND1, FIND2, SCRTCH(256), TOTLIN,
     *   EXPNUM
      CHARACTER LINE(NUMLIN)*256, TIT1*256, TIT2*256
      REAL      TIMIND(NUMLIN)
      INTEGER   BASIND(NUMLIN), AINDEX(NUMLIN)
      COMMON /INPARM/ XINFIL, XOUTFL, XOPCOD, APARM
      COMMON /AFILP/ LUN1, LUN2, FIND1, FIND2, TIMIND, BASIND, SCRTCH,
     *   AINDEX, TOTLIN, EXPNUM
      COMMON /CHARPM/ INFIL, OUTFIL, OPCODE
      COMMON /CHDATA/ LINE, TIT1, TIT2
LOCAL END
      PROGRAM AFILE
C-----------------------------------------------------------------------
C! Task to sort and edit a MkIII correlator A-file.
C# Utility UV UV-util VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2000, 2012, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AFILE allows a user to provide a subroutine which performs an
C   operation on a UV data base, writing an output UV data base.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INFILE         INFIL         Input text A-file
C      OUTFILE        OUTFIL        Output text A-file
C      APARM(10)      APARM         A-FILE selection criteria
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'AFILE.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
C
      DATA PRGM /'AFILE '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
      CALL AFILIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE AFILIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   AFILIN gets input parameters for AFILE.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C
C
C
C  The doumentation of the format is as follows:
C
C A-FILE FORMAT
C
C General rules:
C   1. Any line with a '*' in column 1 is a comment.
C   2. Each field in a data line is separated by one or more spaces.
C   3. A-files are all named #Axxxx where xxxx is a serial# assigned
C      in order of generation.  Each A-file acts as a summary and index
C      for the corresponding set of "A" and "B" archive tapes.
C
C OLD FORMAT: (up through and including A0918):
C
C  1. File name  (6-chars)
C  2. Extent type  (2-chars)
C  3. Extent#  (2-chars)
C  4. #blocks in extent (4-chars)  1 block=256 bytes
C  5. Expt serial#  (3 chars)   (Haystack-assigned)
C  6. Processing date  (10 chars)
C  7. Year of scan  (2-chars)
C  8. Scan ID  (8-chars, in format DDD-HHMM of scheduled start time)
C  9. Source name  (8-chars)
C 10. Baseline  (2-chars)
C     FRNGE quality code (1-char) See below.
C 11. Reference tape#  (8-chars)
C 12. Remote tape#  (8-chars)
C 13. Frequency code  (1-char)
C     #frequencies processed by FRNGE  (2-chars)
C 14. Correlation amplitude  (F5.1, in units of 1.0E-04)
C 15. SNR  (4-chars)
C 16. Residual phase  (Earth centered)  (degrees F5.1)
C 17. Residual single-band delay  (usec F5.2)
C 18. Residual multi-band delay  (usec F7.4)
C 19. Residual delay rate  (psec/sec F7.2)
C 20. Tape quality codes  (6-chars)  See below.
C 21. "A-file#"  (5-chars)
C
C     Total of 131 characters on line.
C
C  NEW FORMAT (from A0919):
C
C Field#
C  1. File name  (6-chars)
C  2. Extent type (2-chars) 50=ROOT 51=COREL 52=FRNGE
C  3. Extent#  2-chars
C  4. Dual purpose (4-chars):
C       For Type 50 & 51 extents: #blocks in extent (1 block=256 bytes)
C       For Type 52: #seconds in scan processed by FRNGE
C  5. Expt serial#  (3-chars)   (Haystack-assigned)
C  6. Processing date and time (10-chars) (6th char indicates COREL
C     version#)
C  7. Year of scan  (2-chars)
C  8. Scan ID (8-chars, in format DDD-HHMM of scheduled start time)
C  9. Source name  (8-chars)
C 10. Baseline  (2-chars)
C     FRNGE quality code (1-char) See below.
C 11. Reference tape#  (8-chars)
C 12. Remote tape#  (8-chars)
C 13. Frequency code  (1-char)
C     Mode  (1-char)
C     #Frequencies processed by FRNGE  (2-chars)
C 14. Correlation amplitude (F6.2 OR F6.1)  (units of 1.0E-04)
C 15. SNR (I4 format, clips at 9999)
C 16. Residual phase (Earth centered)  (deg F5.1)
C 17. Residual single-band delay  (usec F5.2)
C 18. Residual multi-band delay   (usec F7.4)
C 19. Residual delay rate         (psec/sec F7.2)
C 20. Tape quality codes  (6-chars)
C 21. "A-file#"  (5 chars)
C
C     Total of 131 characters in fields 1-21.
C     Normally, only these fields are printed out.
C     Columns beyond 131 contain additional information as follows:
C
C 22. UT Epoch (mmss) to which observables are referred
C 23. Total Earth-centered phase (degrees F5.1)
C 24. Total phase-delay rate (usec/sec F11.8)
C 25. Total multi-band delay (usec F13.6)
C 26. Total single-band delay minus total multiband delay (usec F5.3)
C 27. Multiband group-delay ambiguity (usec F4.3)
C 28. Type 51 extent from which data came, or 0 if data came from
C     multiple
C     Type 51 extents (this information starting in A1718).
C The following fields were added starting in A2923:
C 29. Phase of phase-cal for channel#1 on station 1 (0-360)
C 30. Phase of phase-cal for last channel on station 1
C 31. Phase of phase-cal for channel#1 on station 2 (0-360)
C 32. Phase of phase-cal for last channel on station 2
C
C MODIFIED NEW FORMAT (from A3459):
C
C Same as "new format" except for following fields--
C  2. Extent type (1-char) 0-ROOT 1-COREL 2-FRNGE (instead of 50,51,52)
C  3. Extent# (2-char)  shifted left 1-column
C  4. Dual purpose (4-chars) (shifted left 1-column):
C       For Type 50 & 51 extents: #blocks in extent (1 block=256 bytes)
C       For Type 52: #seconds in scan processed by FRNGE
C  5. Expt serial# expanded to allow 4-chars
C
C EXAMPLE (including title lines, column indicators, and key#'s):
C
C THE FOLLOWING LINES ARE > 72 CHARACTERS (WHICH IS A PAIN FOR
C DOCUMENTATION) SO ARE SPLIT AFTER CHARACTER 65
C
C *!NAME TYP X  LEN EX#   PROCDATE YR   RUN#   SOURCE   BSQ       T
C APES       FM#C   AMP  SNR RPHAS SBDLY   MBDLY  DRATE ESDESP AR
C *!           (sec)
C                       (deg) (usec)  (usec) (ps/s)
C <31800 2  2   75  113 82099?0133 82 083-1800 NRAO150  EF9 SAO-201
C 8 HS001481  XC08   7.68  21  70.9   .02  -.0193    .17 790306 A0
C *'''/''''1''''/''''2''''/''''3''''/''''4''''/''''5''''/''''6''''/
C ''''7''''/''''8''''/''''9''''/''''0''''/''''1''''/''''2''''/'''
C *F# 1   2  3    4  5       6      7    8        9     10     11
C     12      13     14   15   16    17     18       19   20
C
C Beyond character #150: Use LISTV to view as EDIT will only
C show 150 chars.
C
C  EPOC TPHAS   TOTDRATE    TOTMBDELAY  SBRES  AMB X51 -PCAL1- -PCAL2-
C  mmss (deg)  (usec/sec)     (usec)   (usec) (usec)    (deg)   (deg)
C  0055 354.4  -.34549878   6785.276752 -.095 .200   3 221 202  57  42
C '''/''''4''''/''''5''''/''''6''''/''''7''''/''''8''''/''''9''''/
C  22    23       24           25        26    27   28  29  30  31
C ''''0''''/
C  32
C
C FRNGE QUALITY CODE:
C
C Q= quality factor of the run,0= no fringes 3=poor,9=good
C             i.e. higher numbers indicate better quality
C Q quality factor starts at 9 and is reduced by:
C        1 point if RMS PH/SEG >11.46 and theoretical RMS < 5.73
C        2 points if RMS PH/SEG >22.92 and theoretical RMS <11.46
C the factor is further reduced by:
C        1 point if RMS AMP/SEG >20.00% and theoretical RMS <10.00%
C        2 points if RMS AMP/SEG >40.00% and theoretical RMS <20.00%
C the factor is futher reduced by:
C        1 point  if RMS PH/FRQ  > 11.46 and theoretical RMS < 5.73
C        2 points if RMS PH/FRQ  > 22.92 and theoretical RMS <11.46
C the factor is further reduced by:
C        1 point  if RMS AMP/FRQ  > 20.00% and theoretical RMS <10.00%
C        2 points if RMS AMP/FRQ  > 40.00% and theoretical RMS <20.00%
C any error condition sets the quality factor to  letter code in which
C                  A= freqency sequence cannot be handled by FRNGE
C                     requires an FFT of more than 256 points
C                  B= interpolation error check search range fringes
C                     may be on the edge of range
C                  C= epoch error condition all frequencies not at same
C                     epoch
C                  D= no phasecal or manually entered phasecal values
C                  E= single band delay residual too large CAUTION
C                     fringe amplitude may be more than 5% low
C                  F= no data found- dummy FRNGE output
C               Q=0= probability of false detection greater than 1.0E-9
C                     i.e. NO FRNGES
C               Q=1= one or more phase cal signals less than 1% or
C                     greater than 20% in voltage
C               Q=2= one or more channels have amplitude less than half
C                     the strength of the coherent average and SNR.GT.20
C
C TAPE QUALITY CODES:
C
C TAPEQ=6 character tape quality code
C         E (Char 1)=ref.tape error rate exponent i.e. 0=1.0E00 9=1.0E-9
C         S (Char 2)=ref.tape slip sync rate      i.e. 0=10%    9=1%
C         D (Char 3)=percentage data discarded    i.e. 0=10%    9=1%
C         E (Char 4)=rem.tape error rate exponent i.e. 0=1.0E00 9=1.0E-9
C         S (Char 5)=rem.tape slip sync rate      i.e. 0=10%    9=1%
C         P (Char 6)=fraction of data processed   i.e. 0=<5%    9=>95%
C                    that is, INTG.TIME/scheduled run duration
C
C
C "PSEUDO" A-FILES:
C
C     Several programs generate output in A-file like format as follows:
C
C CLOSR-Program which computes closure
C
C Field# 1-15 standard A-file
C Field# 16-19 same as A-file but with closure phase,singleband delay,
C              multiband  delay and rate.
C Field# 20. Closure triangle (A3),fixed "*",closure SNR (I2 format,
C              clips at 99)
C Field# 21 standard A-file
C Field# 22-28 blank
C
C FRNGX-Program which segments FRNGE output
C
C Field# 1-5 standard
C Field# 6. Processing date and time (6th char indicates mode)
C     ":"phases residual to COREL+FRNGE "."phases residual to COREL
C     "&"total observed phases "*"residual to COREL+FRNGE(offset coords)
C     "%"total earth centered
C Field# 7-9  standard
C Field# 10. Baseline (2-chars) FRNGE quality blank
C Field# 11. Decimal seconds of segment CENTER (F5.1)
C Field# 11A. Nominal start time or scan time (hrs 0=0,9=9,A=10 ; min)
C Field# 12. Frequency in MHZ  (F8.2) (mean of all frequencies
C            in sequence)
C Field# 13. Frequency code,blank,#frequencies
C Field# 14-15 standard (note amp. in field 14 is coherent and is NOT
C              noise corrected)
C Field# 16 residual phase (or difference phase if reference file
C           is used)
C Field# 17 incoherent amplitude (cumulative from first segment of
C           scan-NOISE-corrected)
C Field# 18 incoherent SNR       (cumulative from first segment of scan)
C Field# 19 reference file   amplitude or sum of phase cal phases-all
C           freqs or segment number (in mode 10)
C Field# 20 reference file name or Allan var.
C Field# 21 reference file name extent# or coherent integration sec
C Field# 22-28 blank
C
C FRNGX second line (when run in astrometric mode)
C
C Field# 1 standard
C Field# 2 "3"
C Field# 3 standard
C Field# 4 delay in ns
C Field# 5 delay error in ns
C Field# 6 delay rate in ps/s
C Field# 7 delay rate error in ps/s
C Field# 8 total phase deg
C Field# 9 ref. station elevation deg
C Field# 10 rem. station elevation deg
C Field# 11 Correlation coeff. for incoherent addition of frnge segments
C Field# 12 U of standard epoch(1950 or 2000) in millions of wavelengths
C Field# 13 V of standard epoch(1950 or 2000) in millions of wavelengths
C Field# 14 Probability of false detection
C
C VFIND-Program to search EC and A-files for various quantities
C
C Field #7.  The year is deleted, and in its place in I3 format is field
C            #29, the type 51 extent number from which this type 52 was
C            generated.
C
C CRITERIA FOR DATA EXPORT AND QF REPORTS
C
C Because there are processing duplicates in most experiments a choice
C has to be made on which one to accept.The method of duplicate deletion
C used is to first sort the A file of all scans so that all duplicates
C are adjacent and then RU,CLOSR,-64,File of all scans,File of last scan
C in each set of duplicates. With this scheme the criteria of acceptance
C depends on the order in which the duplicates are sorted.
C
C OLD METHOD: accepts most recent processing - used for astronomy
C
C SORT ORDER (MOST SIGNIFICANT FIRST ):
C  SCAN TIME(37:03,41:04),[SOURCE(46:08)],FREQ CODE(77:01),
C  BASELINE(55:02), PROC TIME(23:10)
C
C where [] indicates that this step is usually unnecessary i.e. there
C is normally only one source associated with one scan
C
C       () Afile column # start : # columns
C
C NEW METHOD: accepts quality factors 8 & 9  with highest SNR -used
C             for geodesy
C
C SORT ORDER (MOST SIGNIFICANT FIRST ):
C  SCAN TIME(37:03,41:04),[SOURCE(46:08)],FREQ CODE(77:01),
C  BASELINE(55:02), QFF(58:01),SNR(88:04),[PROC TIME(23:10)]
C
C where  QFF=2 for QF=8 and 9
C        QFF=1 for QF=7,6,5,4,3,2,1,0
C        QFF=0 for QF=letter codes  and fringe searches (NFREQ=1)
C        QFF is derived from Afile using EDIT commands
C
C
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      INTEGER   IERR, NPARM, ICHAR, JTRIM, I, ILINE, IROUND, JT
      REAL      TIM1, TIM2
      LOGICAL   T, APPEND
      INCLUDE 'AFILE.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T, SCRTCH)
      CALL VHDRIN
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 35
      CALL GTPARM (PRGN, NPARM, RQUICK, XINFIL, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRTCH, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (48, 1, XINFIL, INFIL)
      CALL H2CHR (48, 1, XOUTFL, OUTFIL)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      IF ((OPCODE.NE.'SORT') .AND. (OPCODE.NE.'EDIT')) THEN
         WRITE (MSGTXT,1020) OPCODE
         JERR = 1
         GO TO 990
         END IF
      EXPNUM = IROUND(APARM(2))
      IF (EXPNUM.LE.0) EXPNUM = 0
C                                       Open text files
      LUN1 = 10
      LUN2 = 11
      APPEND = .FALSE.
      CALL ZTXOPN ('READ', LUN1, FIND1, INFIL, APPEND, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1010) JERR, INFIL
         GO TO 990
         END IF
      CALL ZTXOPN ('WRIT', LUN2, FIND2, OUTFIL, APPEND, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1010) JERR, OUTFIL
         GO TO 990
         END IF
C                                       Sort the data
      CALL DSORT (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Edit the data
      IF (OPCODE.EQ.'EDIT') THEN
         CALL DEDIT (JERR)
         IF (JERR.NE.0) GO TO 999
         END IF
C                                       Write the final file.
      JT = JTRIM (TIT1)
      CALL ZTXIO ('WRIT', LUN2, FIND2, TIT1(:JT), IERR)
      JT = JTRIM (TIT2)
      CALL ZTXIO ('WRIT', LUN2, FIND2, TIT2(:JT), IERR)
      ILINE = 0
      TIM1 = 0.0
      TIM2 = 0.0
      DO 800 I = 1, TOTLIN
         IF ((OPCODE.EQ.'EDIT') .AND. (AINDEX(I).EQ.0)) GO TO 800
         ICHAR = JTRIM (LINE(I))
         CALL ZTXIO ('WRIT', LUN2, FIND2, LINE(I)(:ICHAR), IERR)
         ILINE = ILINE + 1
         IF (ILINE.EQ.1) CALL TIMCRK (LINE(I)(37:), TIM1)
         IF (ILINE.GT.1) THEN
            CALL TIMCRK (LINE(I)(37:), TIM2)
            IF (TIM2.LT.TIM1) THEN
               WRITE (MSGTXT,1040) ILINE
               GO TO 990
               END IF
            TIM1 = TIM2
            END IF
 800     CONTINUE
      WRITE (MSGTXT,1030) ILINE
      CALL MSGWRT (6)
C
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  CALL ZTXCLS (LUN1, FIND1, IERR)
      CALL ZTXCLS (LUN2, FIND2, IERR)
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AFILIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('AFILIN: ERROR',I3,' OPENING ',A)
 1020 FORMAT ('AFILIN: UNKNOWN OPCODE ',A4,' --- TRY AGAIN')
 1030 FORMAT ('Total number of type 52 lines in output A file = ',I7)
 1040 FORMAT ('AFILIN: line ',I6,' in output file out of time order')
      END
      SUBROUTINE DSORT (IERR)
C-----------------------------------------------------------------------
C  Routine to sort the data by time and baseline. will reject all
C  non type 52 records. It appears that type 52 summaries are the ones
C  we need for our purposes. So routine will first read up to 5000
C  type 52 records into memory, then set up a sorting index based
C  on time and baseline, then use the sorting index to write out the
C  records in the correct order.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'AFILE.INC'
      CHARACTER TEMP*256, TLIN(NUMLIN)*256
      INTEGER   ILINE, KLINE, XBASE(NUMLIN), I, J, K, II, JTRIM, JT,
     *   INDX(NUMLIN), ITIME, NTIM(NUMLIN),
     *   NSTART(NUMLIN), NL, OLDI, IT1, IGRP, NSTOP
      REAL      XTIME(NUMLIN), T1
      LOGICAL   EOF, SORT
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                        Read a line and decode the
C                                        time into days
      NL = NUMLIN
      CALL FILL (NL, 0, NTIM)
      CALL FILL (NL, 0, NSTART)
      ILINE = 0
      KLINE = 0
      IERR = 0
      EOF = .FALSE.
      TIT1 = ' '
      TIT2 = ' '
 100  CALL ZTXIO ('READ', LUN1, FIND1, TEMP, IERR)
      IF (IERR.EQ.2) THEN
         EOF = .TRUE.
         IERR = 0
         END IF
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
      IF (EOF) GO TO 200
      JT = JTRIM (TEMP)
      KLINE = KLINE + 1
C                                        Ignore comment lines,
C                                        except if 2nd character is !
      IF (TEMP(1:1).EQ.' ') GO TO 100
      IF ((TEMP(1:1).EQ.'*') .AND. (TEMP(2:2).NE.'!')) GO TO 100
      IF ((TEMP(2:2).EQ.'!') .AND. (TEMP(3:6).EQ.'NAME')) THEN
         IF (TIT1(1:1).EQ.'  ') TIT1 = TEMP
      ELSE IF ((TEMP(2:2).EQ.'!') .AND. (TEMP(3:6).NE.'NAME')) THEN
         IF (TIT2(1:1).EQ.' ') TIT2 = TEMP
         END IF
C                                        Is it a type 52?
      IF (TEMP(8:8).NE.'2') GO TO 100
C                                        OK we want this one.
      ILINE = ILINE + 1
      LINE(ILINE) = TEMP
C                                        Extract time and encode as
C                                        days
      CALL TIMCRK (TEMP(37:), TIMIND(ILINE))
C                                        Extract baseline names and
C                                        encode as A + 256 * B
      CALL BASCRK (TEMP(55:), BASIND(ILINE))
      GO TO 100
C                                        Now we sort by time
 200  DO 210 I = 1, ILINE
         XTIME(I) = TIMIND(I)
         XBASE(I) = BASIND(I)
         INDX(I) = I
         TLIN(I) = LINE(I)
 210     CONTINUE
C
      SORT = .FALSE.
      K = ILINE - 1
      DO 300 II = 1, ILINE
         DO 250 I = 1, K
            IF (TIMIND(I+1).LT.TIMIND(I)) THEN
               J = INDX(I)
               INDX(I) = INDX(I+1)
               INDX(I+1) = J
               T1 = TIMIND(I)
               TIMIND(I) = TIMIND(I+1)
               TIMIND(I+1) = T1
               END IF
 250        CONTINUE
 300     CONTINUE
C                                       reorder in memory
      ITIME = 0
      OLDI = 1
      TOTLIN = ILINE
      DO 450 I = 1, ILINE
         TIMIND(I) = XTIME(INDX(I))
         BASIND(I) = XBASE(INDX(I))
         LINE(I) = TLIN(INDX(I))
         IF (I.GT.1) THEN
            IF ((TIMIND(I).GT.TIMIND(I-1)).OR.(I.EQ.ILINE)) THEN
               ITIME = ITIME+ 1
               NTIM(ITIME) = I - OLDI
               IF (I.EQ.ILINE) NTIM(ITIME) = NTIM(ITIME) + 1
               NSTART(ITIME) = OLDI
               OLDI = I
               END IF
            END IF
 450     CONTINUE
C                                       Now sort by baseline order,
C                                       but must first gather groups
C                                       with the same time.
      DO 700 IGRP = 1, ITIME
         ILINE = NTIM(IGRP)
         K = ILINE + NSTART(IGRP) - 2
         NSTOP = NSTART(IGRP) + ILINE - 1
         DO 500 I = NSTART(IGRP), NSTOP
            XTIME(I) = TIMIND(I)
            XBASE(I) = BASIND(I)
            INDX(I) = I
            TLIN(I) = LINE(I)
 500        CONTINUE
C
         DO 550 II = NSTART(IGRP), NSTOP
            DO 520 I = NSTART(IGRP), K
               IF (BASIND(I+1).LT.BASIND(I)) THEN
                  J = INDX(I)
                  INDX(I) = INDX(I+1)
                  INDX(I+1) = J
                  IT1 = BASIND(I)
                  BASIND(I) = BASIND(I+1)
                  BASIND(I+1) = IT1
                  END IF
 520              CONTINUE
 550        CONTINUE
C                                       reorder in memory
         DO 610 I = NSTART(IGRP), NSTOP
            TIMIND(I) = XTIME(INDX(I))
            BASIND(I) = XBASE(INDX(I))
            LINE(I) = TLIN(INDX(I))
 610        CONTINUE
 700     CONTINUE
      WRITE (MSGTXT,1010) KLINE
      CALL MSGWRT (6)
      WRITE (MSGTXT,1020) TOTLIN
      CALL MSGWRT (6)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DSORT: ERROR ',I3,' READING INPUT A-FILE')
 1010 FORMAT ('Total number of lines in input A file = ',I7)
 1020 FORMAT ('Total number of type-52 lines in input A file = ',I7)
      END
      SUBROUTINE DEDIT (IERR)
C-----------------------------------------------------------------------
C  Routine to delete duplicate scans from the MkIII A-file. Upon
C  entering DEDIT the A-file will exist in memory, sorted by time
C  and baseline - so duplicate scans should lie together. This
C  routine will read all duplicate scans and delete those that are
C  unnecessary based on 4 criteria:
C    (1) take the one with the latest processing date
C    (2) take the one with the highest quality factor
C    (3) take the one with the highest signal-to-noise ratio
C    (4) take the one with the most data.
C  Also if EXPNUM > 0 will select scans based on experiment number
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'AFILE.INC'
      CHARACTER TLIN(NUMLIN)*256, QCODE*1, EXPCOD*4,
     *   ALPNUM*36
      INTEGER   ILINE, KLINE, BASE, B1, I, FLINE, QINDEX(500),
     *   NLINE, NL, K, LACC, CORCOD(500), CMAX, YR(500), YMAX,
     *   SNR(500), DLEN(500), NUMEXP(1)
      REAL      TIME, T1
      DOUBLE PRECISION PTIME(500), TMAX
      LOGICAL   EOF
      INCLUDE 'INCS:DMSG.INC'
      DATA ALPNUM /'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
C-----------------------------------------------------------------------
C                                        Message to user
      IF (EXPNUM.GT.0) THEN
         WRITE (MSGTXT,1140) EXPNUM
         CALL MSGWRT (6)
         END IF
      IF (APARM(1).EQ.1.0) WRITE (MSGTXT,1100)
      IF (APARM(1).EQ.2.0) WRITE (MSGTXT,1110)
      IF (APARM(1).EQ.3.0) WRITE (MSGTXT,1120)
      IF (APARM(1).EQ.4.0) WRITE (MSGTXT,1130)
      CALL MSGWRT (6)
C                                        Read until time and/or
C                                        baseline changes.
      ILINE = 0
      KLINE = 0
      IERR = 0
      NL = NUMLIN
      CALL FILL (NL, 1, AINDEX)
      EOF = .FALSE.
      TIME = -1.0
      BASE = -1
C
 100  CONTINUE
      ILINE = ILINE + 1
      KLINE = KLINE + 1
      IF (ILINE.GT.TOTLIN) GO TO 200
      TLIN(ILINE) = LINE(ILINE)
      IF (KLINE.EQ.1) THEN
         FLINE = ILINE
         CALL TIMCRK (TLIN(ILINE)(37:), TIME)
         CALL BASCRK (TLIN(ILINE)(55:), BASE)
         END IF
      CALL TIMCRK (TLIN(ILINE)(37:), T1)
      CALL BASCRK (TLIN(ILINE)(55:), B1)
      IF ((T1.GT.TIME) .OR. (B1.NE.BASE)) GO TO 200
C                                        Special case for last line
      IF (ILINE.EQ.TOTLIN) THEN
C                                        Check experiment number
         IF (EXPNUM.GT.0) THEN
            EXPCOD = TLIN(ILINE)(18:)
            CALL GETI4 (1, EXPCOD, NUMEXP)
            IF (NUMEXP(1).NE.EXPNUM) AINDEX(ILINE) = 0
            END IF
         END IF
      GO TO 100
C                                        Do the editing.
 200  NLINE = KLINE - 1 + FLINE - 1
      KLINE = 0
      ILINE = ILINE - 1
C                                        Check for processing date,
C                                        choose latest
      IF (APARM(1).EQ.1.0) THEN
         K = 0
         LACC = FLINE
         TMAX = -1.0D10
         YMAX = -1
         CMAX = -1
         DO 250 I = FLINE, NLINE
            K = K + 1
            CALL PROCDT (TLIN(I)(23:), YR(K), PTIME(K), CORCOD(K))
            AINDEX(I) = 0
            IF (YR(K).EQ.YMAX) THEN
               IF (PTIME(K).GT.TMAX) THEN
                  TMAX = PTIME(K)
                  LACC = I
                  END IF
               END IF
C
            IF (YR(K).GT.YMAX) THEN
               YMAX = YR(K)
               TMAX = PTIME(K)
               LACC = I
               END IF
C
 250        CONTINUE
         AINDEX(LACC) = 1
         END IF
C                                        Check for quality factor,
C                                        choose highest
      IF (APARM(1).EQ.2.0) THEN
         K = 0
         LACC = FLINE
         YMAX = -1
         DO 300 I = FLINE, NLINE
            K = K + 1
            QCODE = TLIN(I)(57:57)
            QINDEX(K) = INDEX (ALPNUM,QCODE)
            IF (QINDEX(K).GT.10) QINDEX(K) = 1
            AINDEX(I) = 0
            IF (QINDEX(K).GT.YMAX) THEN
               YMAX = QINDEX(K)
               LACC = I
               END IF
 300        CONTINUE
         AINDEX(LACC) = 1
         END IF
C                                        Check for SNR
C                                        choose highest
      IF (APARM(1).EQ.3.0) THEN
         K = 0
         LACC = FLINE
         YMAX = -1
         DO 350 I = FLINE, NLINE
            K = K + 1
            CALL GETI4 (1, TLIN(I)(88:91), SNR(K))
            AINDEX(I) = 0
            IF (SNR(K).GT.YMAX) THEN
               YMAX = SNR(K)
               LACC = I
               END IF
 350        CONTINUE
         AINDEX(LACC) = 1
         END IF
C                                        Check for data length,
C                                        choose highest
      IF (APARM(1).EQ.4.0) THEN
         K = 0
         LACC = FLINE
         YMAX = -1
         DO 400 I = FLINE, NLINE
            K = K + 1
            CALL GETI4 (1, TLIN(I)(13:16), DLEN(K))
            AINDEX(I) = 0
            IF (DLEN(K).GT.YMAX) THEN
               YMAX = DLEN(K)
               LACC = I
               END IF
 400        CONTINUE
         AINDEX(LACC) = 1
         END IF
C                                        Check experiment number
      IF (EXPNUM.GT.0) THEN
         DO 710 I = FLINE, NLINE
            EXPCOD = TLIN(I)(18:)
            CALL GETI4 (1, EXPCOD, NUMEXP)
            IF (NUMEXP(1).NE.EXPNUM) AINDEX(I) = 0
 710        CONTINUE
         END IF
C                                       don't go back if last line has
C                                       been encountered
C
      IF (ILINE.LT.TOTLIN) GO TO 100
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('Editing A-file based on last processing date')
 1110 FORMAT ('Editing A-file based on Quality Factor from FRNGE')
 1120 FORMAT ('Editing A-file based on Signal-to-Noise ratio')
 1130 FORMAT ('Editing A-file based on # seconds of data in scan')
 1140 FORMAT ('Selecting scans from experiment # ',I6)
      END
      SUBROUTINE TIMCRK (STRING, DAYS)
C-----------------------------------------------------------------------
C   Routine to crack the time from a character string
C   Input:
C     STRING       C*(*)       String containing time
C   Output:
C     DAYS         R           Time in days
C-----------------------------------------------------------------------
      CHARACTER STRING*(*), CTEMP*20
      REAL      DAYS
      INTEGER   IVAL(3)
C-----------------------------------------------------------------------
      CTEMP = ' '
      CTEMP(1:3) = STRING(1:3)
      CTEMP(5:6) = STRING(5:6)
      CTEMP(8:9) = STRING(7:8)
      CALL GETI4 (3, CTEMP(:9), IVAL)
      DAYS = IVAL(1) + (IVAL(2)/24.) + (IVAL(3)/(24.*60.))
C
 999  RETURN
      END
      SUBROUTINE BASCRK (STRING, BASLN)
C-----------------------------------------------------------------------
C   Routine to crack the baseline from a character string, codify the
C   letters as numbers. BASLN = A*256 + B
C   Input:
C     STRING       C*(*)       String containing baseline
C   Output:
C     BASLN        I        Baseline number
C-----------------------------------------------------------------------
      CHARACTER STRING*(*), A*1, B*1, ALPHA*26
      INTEGER   BASLN, I, J
      DATA ALPHA /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
C-----------------------------------------------------------------------
      A = STRING(1:1)
      B = STRING(2:2)
      I = INDEX(ALPHA,A)
      J = INDEX(ALPHA,B)
      BASLN = J + 256*I
      RETURN
      END
      SUBROUTINE PROCDT (STRING, YR, TIME, CORCOD)
C-----------------------------------------------------------------------
C   Routine to determine the processing date and COREL version.
C   Input:
C     STRING       C*(*)       String.
C   Output:
C     YR           I           Year of correlation
C     TIME         D           Time of processing (years)
C     CORCOD       I           Corel version (number = letter)
C-----------------------------------------------------------------------
      CHARACTER STRING*(*), C*1, CTEMP*20, ALPHA*26
      INTEGER   CORCOD, YR, IVAL(4)
      DOUBLE PRECISION TIME
      DATA ALPHA /'abcdefghijklmnopqrstuvwxyz'/
C-----------------------------------------------------------------------
      CTEMP = ' '
      CTEMP(1:2) = STRING(1:2)
      CTEMP(4:6) = STRING(3:5)
      C = STRING(6:6)
      IF (C.EQ.' ') CORCOD = 0
      IF (C.NE.' ') CORCOD = INDEX(ALPHA,C)
      CTEMP(8:9) = STRING(7:8)
      CTEMP(11:12) = STRING(9:10)
      CALL GETI4 (4, CTEMP(:12), IVAL)
      TIME = IVAL(2) + (IVAL(3)/24.) + (IVAL(4)/(24.*60.))
      YR = IVAL(1)
C
 999  RETURN
      END
      SUBROUTINE GETI4 (N, STRING, IVAL)
C-----------------------------------------------------------------------
C   Routine to extract N free-format integers from a string
C   Input:
C      N        I       Number integers desired
C      STRING   C*(*)   String containing numbers
C   Output
C      IVAL     I(*)    Integers - default 0
C-----------------------------------------------------------------------
      INTEGER   N, IVAL(*)
      CHARACTER STRING*(*)
C
      DOUBLE PRECISION X
      INTEGER   KBP, KBPLIM, I
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
C-----------------------------------------------------------------------
      KBPLIM = LEN (STRING)
      KBP = 1
      CALL FILL (N, 0, IVAL)
C
      DO 20 I = 1,N
         ERRNUM = 0
         CALL GETNUM (STRING, KBPLIM, KBP, X)
         IF ((X.EQ.DBLANK) .OR. (ERRNUM.NE.0)) GO TO 999
         IF (X.GE.0.0D0) THEN
            IVAL(I) = X + 0.5D0
         ELSE
            IVAL(I) = X - 0.5D0
            END IF
 20      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE PUTKEY (IVOL, ISLOT, KEYWRD, KEYTYP, KEYVAL, KEYSTR,
     *   IERR)
C-----------------------------------------------------------------------
C! Adds a keyword/value pair to a catalog header.
C# Header
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Writes a new keyword/value pair in a catalog header and makes an
C   entry in the history file about the new values.
C   Inputs:
C      IVOL    I    Disk number
C      ISLOT   I    Catalog slot number
C      KEYWRD  C*8  Keyword
C      KEYTYPE C*4  Data type ('D','R','C','I','L')
C      KEYVAL  R(2) Numeric data. 'D' uses the sum of (1) & (2)
C                   'R' uses (1), 'I' uses IROUND((1))
C                   'L' is true of KEYVAL(1) > 1
C      KEYSTR  C*8  Character value
C   Output:
C      IERR    I    Return code, 0=OK else failed
C   Output in common (DERR.INC)
C      ERRNUM  I    POPS error number
C      ERRLEV  I    POPS traceback pointer
C      PNAME   C*6(*) Subroutine name in POPS traceback stack.
C-----------------------------------------------------------------------
      INTEGER   IVOL, ISLOT, IERR
      CHARACTER KEYWRD*(*), KEYTYP*(*), KEYSTR*(*)
      REAL      KEYVAL(2)
C
      CHARACTER HILINE*72, PRGNAM*6
      INTEGER   POTERR, IBUFF2(256), IVALUE, ITYPE, NUMKEY, KEYLOC,
     *   IERH, CATBLK(256), IHLUN, IROUND
      REAL      AVALUE(2), RVALUE
      DOUBLE PRECISION DVALUE
      LOGICAL   LVALUE, OPEN
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA PRGNAM /'PUTKEY'/
      DATA IHLUN /27/
C-----------------------------------------------------------------------
      OPEN = .FALSE.
C                                       Get CATBLK
      CALL CATIO ('READ', IVOL, ISLOT, CATBLK, 'WRIT', IBUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         IF (IERR.EQ.5) WRITE (MSGTXT,1001)
         POTERR = 33
         GO TO 970
         END IF
      OPEN = .TRUE.
C                                       Set value by type
C                                       Double precision
      IF (KEYTYP.EQ.'D') THEN
         ITYPE = 1
         CALL POPSRD ('R2D', KEYVAL, DVALUE)
         CALL RCOPY (NWDPDP, DVALUE, AVALUE)
C                                       Real
      ELSE IF (KEYTYP.EQ.'R') THEN
         ITYPE = 2
         RVALUE = KEYVAL(1)
         AVALUE(1) = RVALUE
         AVALUE(2) = 0.0
C                                       Character
      ELSE IF (KEYTYP.EQ.'C') THEN
         ITYPE = 3
         CALL CHR2H (8, KEYSTR, 1, AVALUE)
C                                       Integer
      ELSE IF (KEYTYP.EQ.'I') THEN
         ITYPE = 4
         IVALUE = IROUND (KEYVAL(1))
         AVALUE(2) = 0.0
         CALL COPY (1, IVALUE, AVALUE)
C                                       Logical
      ELSE IF (KEYTYP.EQ.'L') THEN
         ITYPE = 5
         LVALUE = KEYVAL(1) .GT. 0.0
         AVALUE(2) = 0.0
         CALL LCOPY (1, LVALUE, AVALUE)
C                                       Unknown data type
      ELSE
         MSGTXT = 'UNKNOWN DATA TYPE = ' // KEYTYP
         POTERR = 23
         GO TO 970
         END IF
      NUMKEY = 1
      KEYLOC = 1
      CALL CATKEY ('WRIT', IVOL, ISLOT, KEYWRD, NUMKEY, KEYLOC,
     *   AVALUE, ITYPE, IBUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1002) IERR
         POTERR = 33
         GO TO 970
         END IF
C                                       Make history entries
      CALL HIOPEN (IHLUN, IVOL, ISLOT, IBUFF2, IERH)
      IERR = IERH
C                                       Keyword, type
      WRITE (HILINE,2000) TSKNAM, KEYWRD, KEYTYP
      IF (IERH.EQ.0) CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
C                                       Value by type
C                                       Double precision
      IF (KEYTYP.EQ.'D') THEN
         WRITE (HILINE,2001) TSKNAM, DVALUE
C                                       Real
      ELSE IF (KEYTYP.EQ.'R') THEN
         WRITE (HILINE,2002) TSKNAM, RVALUE
C                                       Character
      ELSE IF (KEYTYP.EQ.'C') THEN
         WRITE (HILINE,2003) TSKNAM, KEYSTR
C                                       Integer
      ELSE IF (KEYTYP.EQ.'I') THEN
         WRITE (HILINE,2004) TSKNAM, IVALUE
C                                       Logical
      ELSE IF (KEYTYP.EQ.'L') THEN
         WRITE (HILINE,2005) TSKNAM, KEYVAL(1)
         END IF
      IF (IERH.EQ.0) CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
C                                       Close history file.
      IF (IERR.EQ.0) CALL HICLOS (IHLUN, .TRUE., IBUFF2, IERH)
C                                       Update CATBLK
      CALL CATIO ('UPDT', IVOL, ISLOT, CATBLK, 'CLWR', IBUFF2, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.9)) POTERR = 33
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1005) IERR
         GO TO 970
         END IF
      IERR = 0
      GO TO 999
C                                       Print error.
 970  CALL MSGWRT (8)
C                                       AIPS error management.
      IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C                                       Update CATBLK if necessary
      IF (OPEN) THEN
         CALL CATIO ('UPDT', IVOL, ISLOT, CATBLK, 'CLWR', IBUFF2, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.9)) POTERR = 33
         OPEN = .FALSE.
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1005) IERR
            GO TO 970
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR ',I3,' READING CATALOG HEADER')
 1001 FORMAT ('MAP TOO BUSY')
 1002 FORMAT ('ERROR ',I3,' WRITING KEYWORD/VALUE PAIR')
 1005 FORMAT ('ERROR ',I4,' UPDATING CATALOG HEADER')
 2000 FORMAT (A,' KEYWORD = ''',A,''', KEYTYPE = ''',A,
     *   ''' / new catalog keyword')
 2001 FORMAT (A,' KEYVALUE = ',1PD20.12,',0 / Keyword value')
 2002 FORMAT (A,' KEYVALUE = ',1PE15.7,',0 / Keyword value')
 2003 FORMAT (A,' KEYSTRING = ',A,' / Keyword value')
 2004 FORMAT (A,' KEYVALUE = ',I2,',0 / Keyword value')
 2005 FORMAT (A,' KEYVALUE = ',1PE15.7,',0 / Keyword value')
      END

      SUBROUTINE ZFRE2 (NVOL, VOLNAM, VLEN, TOTBLK, PCTFUL, FRBLKS)
C-----------------------------------------------------------------------
C! return AIPS data disk free space information
C# Z2 IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004, 2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Get AIPS disk free space information.
C   Inputs:
C      NVOL     I      Number of disks
C   Output:
C      VOLNAM   H(*)   Volume names
C      VLEN     I(*)   Length in characters per volume name
C      TOTBLK   I(*)   Total number of Mbytes on device
C      PCTFUL   R(*)   Percentage of device full
C      FRBLKS   I(*)   Number of free Mbytes remaining
C   Generic (stubbed) version
C-----------------------------------------------------------------------
      INTEGER   NVOL, VLEN, TOTBLK(*), FRBLKS(*)
      HOLLERITH VOLNAM(*)
      REAL      PCTFUL(*)
C
      INTEGER   I
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      MSGTXT = 'ZFRE2: REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (9)
      I = NVOL * VLEN
      CALL CHR2H (I, ' ', 1, VOLNAM)
      DO 10 I = 1,NVOL
         TOTBLK(I) = 0
         PCTFUL(I) = 100.0
         FRBLKS(I) = 0
 10      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE DPCOPY (NDPRE, AIN, AOUT)
C-----------------------------------------------------------------------
C! copies one double precision array into another
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DPCOPY copies one double precision array into another
C   To avoid any conversion of format, the arrays are treated as integer
C   internally.  ZDCHIN must have been called prior to the use of this
C   routine.
C   Inputs:
C      NDPRE   I          Number of double precision variables to copy
C      AIN     D(NDPRE)   Input array
C   Output:
C      AOUT    D(NDPRE)   Output array
C-----------------------------------------------------------------------
      INTEGER   NDPRE, AIN(*), AOUT(*)
C
      INTEGER   I, J
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IF (NDPRE.GT.0) THEN
         J = NDPRE * MAX (1, NWDPDP)
         DO 10 I = 1,J
            AOUT(I) = AIN(I)
 10         CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZSTAIP
C-----------------------------------------------------------------------
C! does any system cleanup needed at the end of interactive AIPS session
C# Z System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZSTAIP performs any operations needed to normalize the local
C   operating system at the conclusion of an interactive AIPS session.
C   Outputs:
C      SCRTCH   I(256)   Scratch buffer
C   Generic version  - calls ZSTAI2 in case there is something to do
C   in C or Macro, else a null routine.
C
C   AIPS runs as a child process to $UNIX/AIPSTR between executions of
C   ZSTRTA (estabishes the AIPS environment) and ZSTOPA (cleans up).
C
C   Under VMS, AIPS runs as an overlay to normal job control and all
C   clean-up is done by AIPS.COM procedure and ZSTOPA.
C-----------------------------------------------------------------------
C
      INTEGER   IDRIVE, IDUM, JERR, I, J, ITRIM, RDRIVE, SYSERR
      CHARACTER CDUM*8, PNAME*48, XLATED*132, LMSG*80
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DBBF.INC'
C-----------------------------------------------------------------------
      IF ((TSKNAM.EQ.'AIPS') .OR. (TSKNAM.EQ.'GR2TEX') .OR.
     *   (TSKNAM.EQ.'GRITP') .OR. (TSKNAM.EQ.'TPMON')) THEN
C                                       Dismount mounted tapes
         DO 20 IDRIVE = 1,NTAPED
            IF (TPNAME(IDRIVE).NE.' ') THEN
C                                       Always do remote tapes
               IF (TPNAME(IDRIVE).NE.'LOCAL') THEN
C                                       Real tape
                  PNAME = 'AMT0x:'
                  CALL ZEHEX (IDRIVE, 1, PNAME(5:5))
                  CALL ZTRLOG (6, PNAME, 128, XLATED, J, JERR)
                  RDRIVE = 0
                  IF ((JERR.EQ.0) .AND. (XLATED(:9).NE.'UNMOUNTED'))
     *               THEN
                     CALL ZHEX10 (XLATED(7:7), RDRIVE, I)
                     IF ((RDRIVE.GT.0) .AND. (I.EQ.0)) THEN
                        I = ITRIM (TPNAME(IDRIVE))
                        WRITE (MSGTXT,1000) IDRIVE, RDRIVE,
     *                  TPNAME(IDRIVE)(:I)
                        CALL MSGWRT (2)
                        CALL ZMOUNT (.FALSE., IDRIVE, IDUM,
     *                     TPNAME(IDRIVE), RDRIVE, LMSG, SYSERR, JERR)
                        END IF
                     END IF
C                                       Local tapes may not want this
               ELSE
                  WRITE (MSGTXT,1010) IDRIVE
                  CALL MSGWRT (2)
                  CALL ZMOUNT (.FALSE., IDRIVE, IDUM, CDUM, IDUM,
     *               LMSG, SYSERR, JERR)
                  END IF
               END IF
20         CONTINUE
C                                       Call clean up service.
         CALL ZSTAI2 (NPOPS, NLUSER, BBUFR1)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZSTAIP: Dismounting remote tape',I2,' as drive',I2,
     *   ' on ',A)
 1010 FORMAT ('ZSTAIP: Dismounting local real tape drive',I2)
      END

      SUBROUTINE GETFLD
C-----------------------------------------------------------------------
C! finds the next symbol in KARBUF and determines its pointers
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GETFLD finds the next non-blank character in KARBUF and determines
C   whether the token begun with that character is symbolic (1st char
C   is A - Z), numeric (1st char is 0 - 9 or .), or hollerith (1st
C   char is ').  After the field length is found, appropriate calls
C   are made to the symbol processing routine, number scanning
C   routine, etc.  Communication back to POLISH is via SYTYPE and TAG
C   parameters determined by the processors SYMBOL, GETNUM, LTSTOR...
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6, M*1, M1*2, STRNG*132
      INTEGER  POTERR, J
      DOUBLE PRECISION DBLX
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DIO.INC'
      INCLUDE 'INCS:DSMS.INC'
      DATA PRGNAM /'GETFLD'/
C-----------------------------------------------------------------------
C                                       init pointers
      TAG = 0
      NKAR = 0
      SYTYPE = 0
      X(1) = 0
C                                        skip leading blanks
 10   IF (KBPTR.GT.KARLIM) GO TO 999
         M = KARBUF(KBPTR:KBPTR)
         IF (M.NE.' ') GO TO 20
         KBPTR = KBPTR + 1
         GO TO 10
C                                        classify type by first char.
20    IF ((M.LE.'Z') .AND. (M.GE.'A')) GO TO 30
      IF ((M.LE.'z') .AND. (M.GE.'a')) GO TO 30
      IF (M.EQ.'.') GO TO 50
      IF (M.EQ.'''') GO TO 70
      IF ((M.LE.'9') .AND. (M.GE.'0')) GO TO 50
C                                       In-line comment
      IF (M.NE.'$') GO TO 60
         KBPTR = KARLIM + 1
         GO TO 999
C-----------------------------------------------------------------------
C      S Y M B O L I C    F I E L D
C-----------------------------------------------------------------------
C                                        find end
 30   J = KBPTR
 35   NKAR = NKAR + 1
         J = J + 1
         POTERR = 4
         IF (J.GT.KARLIM) GO TO 980
         M = KARBUF(J:J)
         IF ((M.LE.'Z') .AND. (M.GE.'A')) GO TO 35
         IF ((M.LE.'z') .AND. (M.GE.'a')) GO TO 35
         IF (M.EQ.'_') GO TO 35
         IF ((M.LE.'9') .AND. (M.GE.'0')) GO TO 35
      POTERR = 5
      IF (NKAR.GT.10) GO TO 980
C                                        locate in symbol table
 40   CALL CHLTOU (NKAR, KARBUF(KBPTR:))
      CALL CHR2H (NKAR, KARBUF(KBPTR:), 1, KPAK)
      KBPTR = KBPTR + NKAR
      CALL SYMBOL (1)
      IF (ERRNUM.NE.0) GO TO 980
      GO TO 999
C-----------------------------------------------------------------------
C        N U M E R I C    F I E L D
C-----------------------------------------------------------------------
C                                        find value
 50   J = KBPTR
      CALL GETNUM (KARBUF, KARLIM, KBPTR, DBLX)
      IF (ERRNUM.NE.0) GO TO 980
      X(1) = DBLX
      NKAR = KBPTR - J
C                                        store value
      LX = 1
      SYTYPE = 11
      CALL LTSTOR
      IF (ERRNUM.EQ.1) ERRNUM = 74
      IF (ERRNUM.NE.0) GO TO 980
      GO TO 999
C-----------------------------------------------------------------------
C        ' O T H E R ' (SUCH THINGS AS + - * / ** ETC.)
C-----------------------------------------------------------------------
C                                        find end
 60   J = KBPTR
 65   NKAR = NKAR + 1
         J = J + 1
         POTERR = 2
         IF (NKAR.GT.2) GO TO 980
         M1 = KARBUF(J-1:J)
C                                        watch for combined symbols:
C                                        **, <=, <>, !!, and >=
         IF (M1.EQ.'**') GO TO 65
         IF (M1.EQ.'!!') GO TO 65
         IF (M1.EQ.'<>') GO TO 65
         IF (M1.EQ.'<=') GO TO 65
         IF (M1.EQ.'>=') GO TO 65
      GO TO 40
C-----------------------------------------------------------------------
C        H O L L E R I T H    F I E L D S
C-----------------------------------------------------------------------
 70   SYTYPE = 14
      CALL GETSTR (KARBUF, KARLIM, 132, KBPTR, STRNG, NKAR)
      IF (ERRNUM.NE.0) GO TO 980
      CALL CHR2H (NKAR, STRNG, 1, X)
C                                       force to integer # reals
      LX = (NKAR + 3) / 4
      CALL LTSTOR
      IF (ERRNUM.EQ.1) ERRNUM = 75
      IF (ERRNUM.NE.0) GO TO 980
      K(LOCSYM+1) = SYTYPE + 16*NKAR
      GO TO 999
C-----------------------------------------------------------------------
C                                               Error return.
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
      END

LOCAL INCLUDE 'RLCOR.INC'
C                                       Local include for RLCOR
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      REAL      XSIN, XDISIN, XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF,
     *   XSOUT, XDISO, XCENT, CLCORP(20), SCRBUF(256), BUFF1(UVBFSS),
     *   BUFF2(UVBFSS), PARM(2,20), DIFPIX
      INTEGER   CATOLD(256), SEQIN, SEQOUT, DISKIN, DISKO, JBUFSZ,
     *   ILOCWT, INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECO,
     *   NRPRMI, NRPRMO, OLDCNO, NEWCNO, LBIF, LEIF, ISUBAR, IFQID,
     *   IBUFF1(UVBFSS), IBUFF2(UVBFSS)
      LOGICAL   ISCOMP
      DOUBLE PRECISION UVSCAL
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      EQUIVALENCE (IBUFF1, BUFF1), (IBUFF2, BUFF2)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XBAND, XFREQ, XFQID,
     *   XSUBA, XBIF, XEIF, XNAMOU, XCLAOU, XSOUT, XDISO, XCENT, CLCORP
      COMMON /RLCORP/ CATOLD, UVSCAL, SEQIN, SEQOUT, DISKIN, DISKO,
     *   ILOCWT, INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECO,
     *   NRPRMI, NRPRMO, ISCOMP, OLDCNO, NEWCNO, LBIF, LEIF, PARM,
     *   ISUBAR, IFQID, DIFPIX
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT
      COMMON /BUFRS/ SCRBUF, BUFF1, BUFF2, JBUFSZ
C                                       End local include for RLCOR
LOCAL END
      PROGRAM RLCOR
C-----------------------------------------------------------------------
C! Correct RL and LR for Right-left phase difference
C# Utility UV  Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2009, 2011, 2014-2015, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   RLCOR corrects a data set for the right-left phase difference in
C   up to 20 IFs.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      CLCORPRM(20    CLCORP        Phase differences
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'RLCOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'RLCOR '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL RLCORI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL RLCORU (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL RLCORH
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE RLCORI (PRGN, JERR)
C-----------------------------------------------------------------------
C   RLCORI gets input parameters for RLCOR and creates an output file
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, LUN, NIF
      LOGICAL   MATCH
      REAL      CATR(256), RPARM(20)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'RLCOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      DATA BLANK  /' '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 41
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 1
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         LBIF = 1
         LEIF = 1
      ELSE
         LBIF = IROUND (XBIF)
         LEIF = IROUND (XEIF)
         LBIF = MIN (MAX (1, LBIF), CATBLK(KINAX+JLOCIF))
         IF (LEIF.LT.LBIF) LEIF = CATBLK(KINAX+JLOCIF)
         END IF
      IF (LEIF-LBIF.GT.19) THEN
         MSGTXT = 'YOU MAY DO ONLY 20 IFS AT A TIME'
         JERR = 10
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, SCRBUF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, SCRBUF, IERR)
      ISUBAR = MAX (1, SUBARR)
      IFQID = MAX (1, FRQSEL)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       Put new values in CATBLK.
      IF (JLOCF.LT.0) XCENT = -1.
      IF (XCENT.LE.0.0) THEN
         DIFPIX = 0.0
      ELSE
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
         END IF
      UVSCAL = CATD(KDCRV+JLOCF) / UVFREQ
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       read compressed => write compr.
      IF (ISCOMP) THEN
         CATBLK(KINAX) = 1
         I = CATBLK(KIPCN)
         CALL CHR2H (8, 'WEIGHT  ', 1, CATH(KHPTP+2*I))
         CALL CHR2H (8, 'SCALE   ', 1, CATH(KHPTP+2*I+2))
         CATBLK(KIPCN) = I + 2
         ILOCWT = I
         END IF
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((CCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', SCRBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
      NEWCNO = CCNO
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', SCRBUF, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       Copy any header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
C                                       interpret parms
      NIF = LEIF - LBIF + 1
      DO 20 I = 1,NIF
         PARM(1,I) = COS (CLCORP(I) * DG2RAD)
         PARM(2,I) = SIN (CLCORP(I) * DG2RAD)
 20      CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RLCORI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('RLCORI: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE RLCORU (IRET)
C-----------------------------------------------------------------------
C   RLCORU sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48
      INTEGER   IPTRO, LUNO, INDO, ILENBU, KBIND, NIOUT, NIOLIM, BO, VO,
     *   NUMVIS, XCOUNT, NCORO, NCOPY, CATMP(256), RNXRET
      LOGICAL   T, F
      INCLUDE 'RLCOR.INC'
      REAL      VIS(UVBFSS), RESULT(UVBFSS), RPARM(20)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (BUFF1, VIS)
      DATA LUNO /17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Number of visibilities in input
C                                       and output files.
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       defend cat header from UVGET
      CALL COPY (256, CATBLK, CATMP)
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL COPY (256, CATMP, CATBLK)
      CALL UVPGET (IRET)
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
      NUMVIS = 0
      XCOUNT = 0
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over buffer
      ELSE IF (IRET.EQ.0) THEN
         NUMVIS = NUMVIS + 1
C                                       call user routine
         RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
         RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
         RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
         CALL RLFIX (NUMVIS, RPARM, VIS, RESULT, IRET)
C                                       Error (fatal)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
C                                       Copy to output.
         ELSE IF (IRET.EQ.0) THEN
            XCOUNT = XCOUNT + 1.0D0
            CALL RCOPY (NRPRMI, RPARM, BUFF2(IPTRO))
C                                       update NX table
            CALL RNXUPD (RPARM, RNXRET)
C                                       Compressed
            IF (ISCOMP) THEN
               CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *            BUFF2(IPTRO+NRPRMO))
            ELSE
               CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
               END IF
            IPTRO = IPTRO + LRECO
            NIOUT = NIOUT + 1
            END IF
C                                       Write vis record.
         IF (NIOUT.GE.NIOLIM) THEN
            CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1150) IRET
               GO TO 990
               END IF
            IPTRO = KBIND
            NIOUT = 0
            END IF
C                                       Read next buffer.
         GO TO 100
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
C                                       close NX table
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RLCORU: ERROR',I3,' OPEN/INIT INPUT VIS FILE')
 1010 FORMAT ('RLCORU: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('RLCORU: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1100 FORMAT ('RLCORU: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('RLCORU: RLFIX ERROR',I3)
 1150 FORMAT ('RLCORU: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE RLCORH
C-----------------------------------------------------------------------
C   RLCORH copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, NOTTYP*2
      INTEGER   LUN1, LUN2, IERR, I, NONOT, J, IFNO(2)
      INCLUDE 'RLCOR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1, LUN2 /27,28/
      DATA NONOT, NOTTYP /1, 'NX'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   SCRBUF, IBUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, IBUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, IBUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
C                                       CLCORPRM
      J = 0
      DO 10 I = LBIF,LEIF
         J = J + 1
         WRITE (HILINE,1010) TSKNAM, I, CLCORP(J), I
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
 10      CONTINUE
C                                       Close HI file
 100  CALL HICLOS (LUN2, .TRUE., IBUFF2, IERR)
C                                       Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO, OLDCNO,
     *   NEWCNO, CATBLK, IBUFF1, IBUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'RLCORH: ERROR COPYING TABLES TO OUTPUT UV'
         CALL MSGWRT (6)
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (DISKO, NEWCNO, DIFPIX, IBUFF1, IBUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'RLCORH: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                       fix PCAL solutions
      IFNO(1) = LBIF
      IFNO(2) = LEIF
      CALL ANTCOR (DISKO, NEWCNO, ISUBAR, CATBLK, IFNO, CLCORP, IBUFF1,
     *   IFQID, IERR)
C                                       Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRBUF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RLCORH: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,'CLCORPRM(',I2.2,') = ',F8.3,5X,'/ R-L correction',
     *   ' in deg for IF ',I2)
      END
      SUBROUTINE RLFIX (NUMVIS, RPARM, VIS, RESULT, IRET)
C-----------------------------------------------------------------------
C   RLFIX corrects phase of up to 20 IFs in the desired subarray and
C   FQID.
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      RPARM   R(*) Random parameter array which includes U,V,W etc
C                   but also any other random parameters.
C      VIS     R(3,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C   Inputs from COMMON:
C      NRPARM     I       # random parameters.
C      NCOR       I       # correlators
C      CATBLK     I(256)  Catalog header record. See Going Aips for
C                         details.
C      NRPRMI     I    Input number of random parameters.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
C      LRECO      I    Output file record length
C      NRPRMO     I    Output number of random parameters.
C      INCSO      I    Output Stokes' increment in vis.
C      INCFO      I    Output frequency increment in vis.
C      INCIFO     I    Output IF increment in vis.
C   Output:
C      RESULT     R(3,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IRET
      REAL      VIS(3,*), RPARM(*), RESULT(3,*)
C
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXO, INDEXI, IA1, IA2,
     *   JSUB, JFQ
      REAL      BASEN, VR, VI, GR, GI
      INCLUDE 'RLCOR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.GT.0) THEN
C                                       pointers to traverse the data
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
         IF (ILOCB.GE.0) THEN
            BASEN = RPARM(1+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
            JSUB = 100.0 * (BASEN - 256*IA1 - IA2) + 1.01
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
            JSUB = RPARM(1+ILOCSA) + 0.1
            END IF
         JFQ = 1
         IF (ILOCFQ.GE.0) JFQ = RPARM(1+ILOCFQ) + 0.01
         DO 40 JIF = 1,NIF
            DO 30 JF = 1,NF
               DO 20 JS = 1,NS
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *               (JS-1) * INCSO + 1
                  RESULT(1,INDEXO) = VIS(1,INDEXI)
                  RESULT(2,INDEXO) = VIS(2,INDEXI)
                  RESULT(3,INDEXO) = VIS(3,INDEXI)
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
C                                       correction
         IF ((NS.EQ.4) .AND. (JSUB.EQ.ISUBAR) .AND. (JFQ.EQ.IFQID)) THEN
            DO 80 JIF = LBIF,LEIF
               GR = PARM(1,JIF-LBIF+1)
               GI = -PARM(2,JIF-LBIF+1)
               DO 70 JF = 1,NF
                  DO 60 JS = 3,4
                     INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *                  (JS-1) * INCSO + 1
                     VR = RESULT(1,INDEXO)
                     VI = RESULT(2,INDEXO)
                     GI = -GI
                     RESULT(1,INDEXO) = VR*GR - VI*GI
                     RESULT(2,INDEXO) = VI*GR + VR*GI
 60               CONTINUE
 70            CONTINUE
 80         CONTINUE
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE ANTCOR (DISK, CNO, INVER, CATBLK, IFNO, PCOR, BUFFER,
     *   FREQID, IERR)
C-----------------------------------------------------------------------
C   ANTCOR corrects the left hand polarization solutions by a specified
C   amount.  The correction depends on the polarization solution type
C   indicated by the table header keyword 'POLTYPE'.
C   Inputs:
C      DISK      I      Volume number
C      CNO       I      Catalog slot number
C      INVER     I      Input version number (subarray number)
C      CATBLK(*) I      Catalog header block
C      IFNO(2)   I      Range of IFs; 0 => 1.
C      PCOR(*)   R      Phase offsets of IFs in degrees
C      BUFFER(*) I      I/O Buffer
C      FREQID    I      FQ ID user wishes to change
C   Output:
C      IERR      I      Error code, 0=OK, >0 failed, <0 not PCAL found
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, INVER, CATBLK(256), IFNO(2), BUFFER(*),
     *   FREQID, IERR
      REAL      PCOR(*)
C
      CHARACTER    CHPOLT*8, CHSOL(4)*8, SOLTYP*8
      INTEGER   IIF, LUN, IANT, INDEX, LOCS, KEYTYP, ISTYPE, BIF, EIF,
     *   NXIF, NUMREC, IREF, MSGSAV
      REAL      POLP1, POLP2, SPCOR, CPCOR
      HOLLERITH XSOLTY(2)
      INCLUDE 'INCS:PUVD.INC'
      REAL      PD(MAXIF)
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA CHSOL /'ORI-ELP ', 'APPROX  ', 'X-Y LIN', 'VLBI'/
      DATA CHPOLT /'POLTYPE '/
      DATA LUN /28/
C-----------------------------------------------------------------------
      MSGSAV = MSGSUP
C                                      Open AN extension file.
      CALL ANTINI ('WRIT', BUFFER, DISK, CNO, INVER, CATBLK, LUN,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'WRIT'
         GO TO 990
         END IF
C                                       Check FREQID compatibility.
      IF ((ANFQID.GT.0) .AND. (FREQID.GT.0) .AND. (ANFQID.NE.FREQID)
     *   .AND. (ANAME.NE.'ATCA') .AND. (ANAME.NE.'ATLBA') .AND.
     *   (ANAME.NE.'LBA')) THEN
         MSGTXT = 'WARNING - POTENTIALLY FATAL ERROR'
         CALL MSGWRT (4)
         MSGTXT = '   The polarization variables in your AN table have'
         CALL MSGWRT (4)
         WRITE (MSGTXT,1030) ANFQID
         CALL MSGWRT (4)
         WRITE (MSGTXT,1040) FREQID
         CALL MSGWRT (4)
         MSGTXT = '   Are you sure this is what you want to do?'
         CALL MSGWRT (4)
         END IF
      NUMREC = BUFFER(5)
C                                       IF range to modify.
C                                       This is a risky to tell the
C                                       number of IFs.
      NXIF = ANNUMV(9) / 2
      BIF = IFNO(1)
      IF (BIF.GT.NXIF) BIF = NXIF
      IF (BIF.LE.0) BIF = 1
      EIF = IFNO(2)
      IF (EIF.GT.NXIF) EIF = NXIF
      IF (EIF.LE.0) EIF = 1
C                                       Check solution type keyword.
      MSGSUP = 32000
      CALL TABKEY ('READ', CHPOLT, 1, BUFFER, LOCS, XSOLTY, KEYTYP,
     *   IERR)
      MSGSUP = MSGSAV
      IF (IERR.NE.0) THEN
         IF (IERR.GT.20) THEN
            MSGTXT = 'WARNING: NO PCAL SOLUTION FOUND, ' //
     *         'SO NONE CORRECTED'
            IERR = -1
         ELSE
            WRITE (MSGTXT,1060) IERR
            END IF
         GO TO 990
         END IF
C                                       Decide solution type:
      ISTYPE = 0
      CALL H2CHR (8, 1, XSOLTY, SOLTYP)
      IF (SOLTYP.EQ.CHSOL(1)) ISTYPE = 1
      IF (SOLTYP.EQ.CHSOL(2)) ISTYPE = 2
      IF (SOLTYP.EQ.CHSOL(3)) ISTYPE = 3
      IF (SOLTYP.EQ.CHSOL(4)) ISTYPE = 4
C                                       Unknown pol. solution type.
      IF (ISTYPE.EQ.0) THEN
         MSGTXT = 'WARNING: PCAL SOLUTION UNKNOWN, SO NOT CORRECTED'
         CALL MSGWRT (6)
         IERR = -1
         WRITE (MSGTXT,1070) SOLTYP
         GO TO 990
         END IF
      MSGTXT = 'Correcting polarization solutions in AN table'
      CALL MSGWRT (2)
C                                       For ISTYPE=1 (ORI-ELP) only need
C                                       to modify R-L phase differences
      IF (SOLTYP.EQ.'ORI-ELP ') THEN
C                                       Close AN table
         CALL TABIO ('CLOS', 1, IANRNO, BUFFER, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1200) IERR
            GO TO 990
            END IF
C                                       Fetch old phase differences
         CALL PDRGET (DISK, CNO, INVER, LUN, CATBLK, NXIF, IREF, PD,
     *      BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Update values (radians)
         INDEX = 1
         DO 80 IIF = BIF,EIF
            PD(IIF) = PD(IIF) + PCOR(INDEX) * 1.745329E-2
            INDEX = INDEX + 1
 80         CONTINUE
C                                       Save results
         CALL PDRSET (DISK, CNO, INVER, LUN, CATBLK, NXIF, IREF, PD,
     *      BUFFER, IERR)
C                                       Done
         GO TO 999
         END IF
C                                       Read AN records
      DO 200 IANT = 1,NUMREC
         IANRNO = IANT
         CALL TABAN ('READ', BUFFER, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR, 'READ'
            GO TO 990
            END IF
C                                       Feed polarizations
         INDEX = 1 + (BIF-1) * 2
         DO 150 IIF = BIF,EIF
C                                       Make appropriate correction
            IF ((ISTYPE.GE.2) .AND. (ISTYPE.LE.4)) THEN
C                                       Linear approximation
               CPCOR = COS (PCOR(IIF-BIF+1) * 1.745329E-2)
               SPCOR = SIN (PCOR(IIF-BIF+1) * 1.745329E-2)
C                                       Right hand (or X) parameters
               POLP1 = POLCA(INDEX)
               POLP2 = POLCA(INDEX+1)
               POLCA(INDEX) = POLP1 * CPCOR - POLP2 * SPCOR
               POLCA(INDEX+1) = POLP2 * CPCOR + POLP1 * SPCOR
C                                       Left hand (or Y) parameters
               POLP1 = POLCB(INDEX)
               POLP2 = POLCB(INDEX+1)
               POLCB(INDEX) = POLP1 * CPCOR + POLP2 * SPCOR
               POLCB(INDEX+1) = POLP2 * CPCOR - POLP1 * SPCOR
C                                       Nothing for now
            ELSE
               CONTINUE
               END IF
            INDEX = INDEX + 2
 150        CONTINUE
C                                       Write record
         IANRNO = IANT
         CALL TABAN ('WRIT', BUFFER, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.EQ.0) GO TO 200
            WRITE (MSGTXT,1100) IERR, 'WRIT'
            GO TO 990
 200     CONTINUE
C                                      Close AN extension files
      CALL TABIO ('CLOS', 1, IANRNO, BUFFER, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1200) IERR
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ANTCOR: ERROR',I3,' OPEN-FOR-',A4,'ING AN FILE')
 1030 FORMAT ('   previously been modified for FQID ',I3)
 1040 FORMAT ('   You are now changing them with FREQID =',I3)
 1060 FORMAT ('ANTCOR: ERROR',I3,' FINDING POL. SOLUTION TYPE KEYWORD')
 1070 FORMAT ('ANTCOR: UNKNOWN POLN. SOLN. TYPE = ',A8)
 1100 FORMAT ('ANTCOR: ERROR',I3,1X,A4,'ING AN FILE')
 1200 FORMAT ('ANTCOR: ERROR',I3,' CLOSING AN FILE')
      END

      SUBROUTINE GETI (STR, I)
C-----------------------------------------------------------------------
C! determines integer part from string and returns it
C# FITS Parsing
C-----------------------------------------------------------------------
C;  Copyright (C) 2001
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GETI parses the numeric integer field from a string and returns its
C   value.  Up to 12 numeric characters are supported.
C   Inputs:
C      STR   C(*)   Character string
C   Output:
C      I     I      Value or 1st numeric portion of I
C-----------------------------------------------------------------------
      CHARACTER STR*(*)
      INTEGER   I
C
      INTEGER   J, K, L, N
      CHARACTER LSTR*12
C-----------------------------------------------------------------------
      N = LEN (STR)
      I = 0
      DO 10 J = 1,N
         IF ((STR(J:J).GE.'0') .AND. (STR(J:J).LE.'9')) GO TO 20
 10      CONTINUE
      GO TO 999
C                                       numeric found
 20   DO 30 K = J,N
         IF ((STR(K:K).LT.'0') .OR. (STR(K:K).GT.'9')) GO TO 50
 30      CONTINUE
      K = N + 1
 50   K = K - 1
      LSTR = ' '
      L = 12 - (K-J)
      LSTR(L:) = STR(J:K)
      READ (LSTR,1000) I
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I12)
      END

LOCAL INCLUDE 'IMEAN.INC'
      REAL      DOHIST, PRUSER, SEQIN, DISKIN, BLC(7), TRC(7), DINVER,
     *   XNBOXS, RANGE(2), PIXAVG, PIXSTD, DOMODL, DOCAT, DOALL, XLABEL,
     *   XDOPR, XDOTV, XGRCH, XYRAT, EXCESS(50)
      HOLLERITH XNAMEI(3), XCLASI(2), XFUNTP, XOUTFL(12)
      CHARACTER NAMEIN*12, CLASIN*6, FUNTYP*2, OUTFIL*48
      COMMON /INPARM/ DOHIST, PRUSER, XNAMEI, XCLASI, SEQIN, DISKIN,
     *   BLC, TRC, DINVER, XNBOXS, RANGE, XFUNTP, DOMODL, DOCAT, DOALL,
     *   XLABEL, XDOPR, XOUTFL, XDOTV, XGRCH, XYRAT, PIXAVG, PIXSTD,
     *   EXCESS
      COMMON /CHPARM/ NAMEIN, CLASIN, FUNTYP, OUTFIL
LOCAL END
LOCAL INCLUDE 'GDATA.INC'
      DOUBLE PRECISION DATA(1024)
      INTEGER   NITTER, ITTER
      COMMON /GDATA/ DATA, NITTER, ITTER
LOCAL END
      PROGRAM IMEAN
C-----------------------------------------------------------------------
C! Task to calculate the mean and rms of a region in a map
C# Map-util Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998-2000, 2002-2004, 2006-2007, 2009-2015,
C;  Copyright (C) 2018, 2020-2022, 2024-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Program to calculate the mean and rms of a region in a map.
C   The region is to be specified by BLC and TRC, which could be
C   set by a cursor setting on the display.
C   AIPS inputs:
C      DOHIST     R         True (1.0) means do histogram plot file.
C      USERID     R         User selection number
C      INNAME     R(3)      Catalog name of input image 12 chars.
C      INCLASS    R(3)      Catalog class of input image.(6 chars)
C      INSEQ      R         Sequence # of input image.
C      INDISK     R         Disk volume containing input image.
C      BLC        R(7)      'Bottom Left Corner' position
C      TRC        R(7)      'Top Right Corner'   position.
C      NBOXES     R         Number of boxes in histogram.
C      PIXRANGE   R(2)      Min and max values in histogram. If R(2)
C                           <= R(1) then map min and max are used.
C      FUNCTYPE   R         If 'LG' use Log10 scale for # pixels, else
C                           use linear
C      DOTV       R         > 0 => TV, else plot file
C      GRCHAN     R         graphics channel to use
C      TVCORN     R(4)      TV pixel to use (both > 0 => pixel scale)
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PMAD.INC'
      INTEGER MAXHIS
      PARAMETER (MAXHIS = 16384)
C
      CHARACTER ARRAY*20, PFILE*48, PGMNAM*6, STAT*4, BUNITS*8,
     *   LLCHAR(5)*4, MMCHAR(5)*4, XXCHAR*4, MTYPE*2, MSGBUF*80,
     *   ADATE*12, ATIME*8, PREFIX*5, KEYWRD(2)*8, BUN2*4, TUNITS*8
      INTEGER   IVOL, USID, SCRTCH(256), IRET, IERR, IROUND, LUN1,
     *   FIND1, CNO1, ICPNT, IPBLK(256), INBUF(MABFSS), BLKOF0, NX, NY,
     *   ININD, WIN(4), BLKOF, DEPTH(5), DEPMIN(5), I2TMP1, DEPMAX(5),
     *   ICH, ILEN, NPARMS, ISEQ, IDOHST, INBOXS, NA, MAXDEX, IVER, I3B,
     *   I4B, I5B, I6B, I7B, I3E, I4E, I5E, I6E, I7E, NXW, NYW, NBUF,
     *   IXMIN, IYMIN, IXMAX, IYMAX, I1, I2, I3, I4, I5, I6, I7, IY, IX,
     *   J, INDEX, IPLUN, IPFIND, I, INC, JJ, TXFIND, TXLUN, LENOUT,
     *   JTRIM, GRCHN, TVCHN, TVCORN(4), ID(3), IT(3), RIMAX, IPVT(3),
     *   JNPARM, INFO, JNPTS, RILOW, RIHIGH, RNP, LABEL, LOCS(2),
     *   NUMKEY, KEYTYP(2), MSGSAV, I1B, I2B, I1E, I2E, DOPRNT, LTYPE,
     *   GR2CHN
      REAL      PINT, AREA, ZMIN, ZMAX, RBUF(MABFSS), X, Y, BLOG, BMAX,
     *   XPLANE, ARANGE(2), XRCHAR, PRANGE(2), RINT, RRANGE(2), RMAX,
     *   VALUE(2), RS, XC, YC, RC, TEMP, RX1, RX2, SS, XINT, XRANGE(2)
      DOUBLE PRECISION    S, S2, ZBAR, Z, SKYPOS(3), PARMS(3), ZRMS,
     *   FJAC(3,3), TOL, FVEC(1024), PHIS(1026), RHIS(1026), RHS, NZ,
     *   PTOT, XHIS(MAXHIS), TOTPIX, INCPIX
      LOGICAL   F, RQUICK, T, SAVE, DOLOG, FLUXFL, APPEND, TXOPEN,
     *   DOTV, PFLAG, PLOPEN, CIRCLE, DOINV, DOIT, ADOIT, XDOIT,
     *   DOACTN
      INCLUDE 'IMEAN.INC'
      INCLUDE 'GDATA.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (SCRTCH, INBUF, RBUF)
      DATA LUN1, IPLUN, BLKOF0, TXLUN /16, 26, 1, 10/
      DATA PGMNAM /'IMEAN '/
      DATA T, F, APPEND /.TRUE.,.FALSE.,.TRUE./
      DATA LLCHAR, MMCHAR /'LL  ','RA  ','RA--','GLON','ELON',
     *   'MM  ','DEC ','DEC-','GLAT','ELAT'/
C-----------------------------------------------------------------------
C                                       Start up:
      PLOPEN = .FALSE.
      TXOPEN = .FALSE.
      INFO = 1
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NPARMS = 48
      CALL GTPARM (PGMNAM, NPARMS, RQUICK, DOHIST, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         RQUICK = .FALSE.
         IF (IRET.EQ.1) GO TO 999
            IRET = 16
            WRITE (MSGTXT,1000)
            CALL MSGWRT (9)
         END IF
      IF (IRET.NE.0) GO TO 990
      IRET = 8
      IF (XYRAT.LE.0.0) XYRAT = 1.4
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLASI, CLASIN)
      CALL H2CHR (2, 1, XFUNTP, FUNTYP)
      CALL H2CHR (48, 1, XOUTFL, OUTFIL)
C                                       Interpret input
      DOPRNT = IROUND (XDOPR)
      IF (DOPRNT.EQ.0) OUTFIL = ' '
      ISEQ = IROUND (SEQIN)
      IVOL = IROUND (DISKIN)
      PRUSER = NLUSER
      USID = NLUSER
      DOLOG = FUNTYP.EQ.'LG'
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      GR2CHN = GRCHN / 10
      GRCHN = MOD (GRCHN, 10)
      IF (GR2CHN.EQ.0) GR2CHN = MAX (1, GRCHN)
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
      LABEL = IROUND (XLABEL)
      LTYPE = MOD (ABS(LABEL), 100)
      IF ((LTYPE.EQ.0) .OR. (ABS(LTYPE).GT.10)) LTYPE = 3
      IF (LTYPE.GT.7) LTYPE = 7
      IF ((LTYPE.GE.4) .AND. (LTYPE.LE.6)) LTYPE = 3
      IF (LABEL.LT.0) THEN
         LABEL = (LABEL/100) * 100 - LTYPE
      ELSE
         LABEL = (LABEL/100) * 100 + LTYPE
         END IF
      XLABEL = LABEL
      DOINV = DINVER.GT.0.0
      DOACTN = DOCAT.GT.0.0
C                                       circular aperture?
      JJ = IROUND (BLC(1))
      CIRCLE = JJ.EQ.-1
      IF (CIRCLE) THEN
         XC = TRC(1)
         YC = TRC(2)
         RC = BLC(2)
         BLC(1) = XC - RC
         BLC(2) = YC - RC
         TRC(1) = XC + RC
         TRC(2) = YC + RC
         END IF
C                                       Values for no histogram.
      SAVE = F
      STAT = 'READ'
      IDOHST = -1
      IF (DOHIST.GT.0.0) IDOHST = 1
      IF (DOHIST.GT.1.001) IDOHST = 2
      IF ((IDOHST.GT.0) .AND. (.NOT.DOTV)) STAT = 'HDWR'
      INBOXS = 0
C                                       Open input image:
      MTYPE = 'MA'
      CALL MAPOPN (STAT, IVOL, NAMEIN, CLASIN, ISEQ, MTYPE, USID, LUN1,
     *   FIND1, CNO1, CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (8)
         RQUICK = .FALSE.
         GO TO 990
         END IF
C                                       Check # axes:
      NA = CATBLK(KIDIM)
      CALL WINDOW (NA, CATBLK(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .FALSE.
         GO TO 320
         END IF
C                                       write ACTNOISE?
      IF (DOCAT.LT.2.0) THEN
         IF (DOACTN) THEN
            TOTPIX = CATBLK(KINAX)
            TOTPIX = TOTPIX * CATBLK(KINAX+1)
            INCPIX = (TRC(1)-BLC(1)+1.0) * (TRC(2)-BLC(2)+1.0)
            IF (CIRCLE) INCPIX = INCPIX * PI / 4.0D0
            IF (DOINV) INCPIX = TOTPIX - INCPIX
            DOACTN = INCPIX.GT.0.2D0*TOTPIX
            END IF
         IF (DOACTN) THEN
            DO 10 I = 3,NA
               INCPIX = INCPIX * (TRC(I) - BLC(I) + 1.0)
               TOTPIX = TOTPIX * MAX (1, CATBLK(KINAX+I-1))
 10            CONTINUE
            DOACTN = INCPIX.GT.0.1D0*TOTPIX
            END IF
         END IF
      IF ((DOCAT.GT.0.0) .AND. (.NOT.DOACTN)) THEN
         MSGTXT = 'Window too small to write ACTNOISE keyword'
         CALL MSGWRT (6)
         END IF
C                                       Get physical unit factors:
      CALL H2CHR (8, 1, CATH(KHBUN), BUNITS)
      TUNITS = BUNITS
      CALL CHLTOU (8, TUNITS)
      XRANGE(1) = CATR(KRDMN)
      XRANGE(2) = CATR(KRDMX)
      XINT = (XRANGE(2) - XRANGE(1)) / (MAXHIS - 1.0)
      XRANGE(1) = XRANGE(1) - 0.5*XINT
      XRANGE(2) = XRANGE(2) + 0.5*XINT
C                                       Values for histogram.
      CALL RNGSET (RANGE, CATR(KRDMX), CATR(KRDMN), ARANGE)
      RANGE(1) = ARANGE(1)
      RANGE(2) = ARANGE(2)
      INBOXS = XNBOXS + .5
      IF (INBOXS.LE.1) INBOXS = 101
      IF (INBOXS.GT.1024) INBOXS = 512
      XNBOXS = INBOXS
      MAXDEX = INBOXS + 2
      CALL DFILL (MAXDEX, 0.0D0, PHIS)
      PINT = (RANGE(2) - RANGE(1)) / INBOXS
      ARANGE(1) = RANGE(1)
      ARANGE(2) = RANGE(2)
      RNP = 512
      CALL DFILL (1026, 0.0D0, RHIS)
      CALL DFILL (MAXHIS, 0.0D0, XHIS)
C                                       Check header
      PIXSTD = -1.0
      PIXAVG = 0.0
      NUMKEY = 2
      KEYWRD(1) = 'ACTNOISE'
      KEYWRD(2) = 'ACTMEAN'
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL CATKEY ('READ', IVOL, CNO1, KEYWRD, NUMKEY, LOCS, VALUE,
     *   KEYTYP, INBUF, IERR)
      MSGSUP = MSGSAV
      IF ((IERR.EQ.0) .AND. (VALUE(1).GT.0.0) .AND. (VALUE(2).NE.0.0))
     *   THEN
         PIXSTD = VALUE(1)
         PIXAVG = VALUE(2)
         MSGTXT = 'Initial guess for PIXSTD taken from ACTNOISE in'
     *      // ' header'
         CALL MSGWRT (3)
      ELSE
         MSGTXT = 'Initial guess for PIXSTD taken from robust fit'
         CALL MSGWRT (3)
         CALL ROBGET (LUN1, FIND1, IERR)
         END IF
      WRITE (MSGTXT,1015) PIXAVG, PIXSTD
      CALL MSGWRT (2)
C                                       Noise histogram now
      RINT = 1.0
      RS = 0.0
      IF (PIXSTD.GT.0) THEN
         RINT = PIXSTD / 8.
         RRANGE(1) = PIXAVG - (RNP+0.5) * RINT
         RRANGE(2) = PIXAVG + (RNP+0.5) * RINT
         END IF
C                                       Add plot file to header.
      IF (IDOHST.GE.1) THEN
         SAVE = T
         IVER = 0
         IF (.NOT.DOTV) THEN
            CALL MADDEX ('PL', IVOL, CNO1, CATBLK, IPBLK, T, 'READ',
     *         IVER, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1020)
               CALL MSGWRT (7)
               IDOHST = -1
            ELSE
               PLOPEN = .TRUE.
               END IF
            END IF
         END IF
C                                       #pixels/row & #rows:
      NX = CATBLK(KINAX)
      NY = CATBLK(KINAX + 1)
      STAT = 'READ'
C                                       Set window dimensions:
      IF (DOINV) THEN
         I1B = 1
         I2B = 1
         I3B = 1
         I4B = 1
         I5B = 1
         I6B = 1
         I7B = 1
         I7E = MAX (1, CATBLK(KINAX+6))
         I6E = MAX (1, CATBLK(KINAX+5))
         I5E = MAX (1, CATBLK(KINAX+4))
         I4E = MAX (1, CATBLK(KINAX+3))
         I3E = MAX (1, CATBLK(KINAX+2))
         I2E = MAX (1, CATBLK(KINAX+1))
         I1E = MAX (1, CATBLK(KINAX))
      ELSE
         I1B = IROUND (BLC(1))
         I2B = IROUND (BLC(2))
         I3B = IROUND (BLC(3))
         I4B = IROUND (BLC(4))
         I5B = IROUND (BLC(5))
         I6B = IROUND (BLC(6))
         I7B = IROUND (BLC(7))
         I1E = IROUND (TRC(1))
         I2E = IROUND (TRC(2))
         I3E = IROUND (TRC(3))
         I4E = IROUND (TRC(4))
         I5E = IROUND (TRC(5))
         I6E = IROUND (TRC(6))
         I7E = IROUND (TRC(7))
         END IF
      WIN(1) = I1B
      WIN(2) = I2B
      WIN(3) = I1E
      WIN(4) = I2E
      NXW = WIN(3) - WIN(1) + 1
      NYW = WIN(4) - WIN(2) + 1
      NBUF = MABFSS * 2
C                                       Initialize sums:
      PTOT = 0.0D0
      S = 0.0D0
      S2 = 0.0D0
      NZ = 0.0D0
      ZMIN = CATR(KRDMX)
      IXMIN = 0
      IYMIN = 0
      ZMAX = CATR(KRDMN)
      IXMAX = 0
      IYMAX = 0
      XPLANE = (I7E - I7B + 1) * (I6E - I6B + 1) * (I5E - I5B + 1)
      XPLANE = XPLANE * (I4E - I4B + 1) * (I3E - I3B + 1)
      Z = 0.0
      DO 40 I7 = I7B,I7E
      DO 39 I6 = I6B,I6E
      DO 38 I5 = I5B,I5E
      DO 37 I4 = I4B,I4E
      DO 36 I3 = I3B,I3E
         DOIT = ((I7.LT.BLC(7)) .OR. (I7.GT.TRC(7))
     *      .OR. (I6.LT.BLC(6)) .OR. (I6.GT.TRC(6))
     *      .OR. (I5.LT.BLC(5)) .OR. (I5.GT.TRC(5))
     *      .OR. (I4.LT.BLC(4)) .OR. (I4.GT.TRC(4))
     *      .OR. (I3.LT.BLC(3)) .OR. (I3.GT.TRC(3)))
         DEPTH(1) = I3
         DEPTH(2) = I4
         DEPTH(3) = I5
         DEPTH(4) = I6
         DEPTH(5) = I7
         CALL COMOFF (NA, CATBLK(KINAX), DEPTH, BLKOF, IERR)
         BLKOF = BLKOF + BLKOF0
C                                       Initialize for read:
         CALL MINIT ('READ', LUN1, FIND1, NX, NY, WIN, RBUF, NBUF,
     *      BLKOF, IERR)
         IF (IERR.NE.0) THEN
            RQUICK = .FALSE.
            GO TO 300
            END IF
C                                       Loop on the rows:
         DO 30 IY = I2B,I2E
C                                       Read next row:
            CALL MDISK ('READ', LUN1, FIND1, RBUF, ININD, IERR)
            IF (IERR.NE.0) THEN
               RQUICK = .FALSE.
               GO TO 300
               END IF
C                                       Process current row:
            IF (DOINV) THEN
               ADOIT = (DOIT) .OR. (IY.LT.BLC(2)) .OR. (IY.GT.TRC(2))
            ELSE
               ADOIT = .FALSE.
               END IF
            IF (CIRCLE) THEN
               TEMP = RC * RC - (IY - YC)**2
               TEMP = SQRT (MAX (0.0, TEMP))
               RX1 = XC - TEMP
               RX2 = XC + TEMP
            ELSE
               RX1 = BLC(1)
               RX2 = TRC(1)
               END IF
            DO 20 IX = I1B,I1E
               J = ININD + IX - I1B
               Z = RBUF(J)
               XDOIT = ADOIT
               IF (.NOT.XDOIT) THEN
                  IF (DOINV) THEN
                     XDOIT = (IX.LT.RX1) .OR. (IX.GT.RX2)
                  ELSE
                     XDOIT = (IX.GE.RX1) .AND. (IX.LE.RX2)
                     END IF
                  END IF
               IF ((XDOIT) .AND. (RBUF(J).NE.FBLANK)) THEN
                  IF ((RBUF(J).EQ.0.0) .AND. (DOALL.LE.0.0)) THEN
                     NZ = NZ + 1.0D0
                  ELSE
                     IF (RBUF(J).EQ.0.0) NZ = NZ + 1.0
                     IF (Z.LE.ZMIN) THEN
                        ZMIN = Z
                        IXMIN = IX
                        IYMIN = IY
                        CALL COPY (5, DEPTH, DEPMIN)
                        END IF
                     IF (Z.GE.ZMAX) THEN
                        ZMAX = Z
                        IXMAX = IX
                        IYMAX = IY
                        CALL COPY (5, DEPTH, DEPMAX)
                        END IF
                     S  = S + Z
                     S2 = S2 + Z * Z
                     PTOT = PTOT + 1.0D0
C                                      Collect histogram data.
                     IF (PIXSTD.GT.0.0) THEN
                        X = (Z - RRANGE(1)) / RINT + 2.0
C                                      Overflow, underflow, specl case.
                        IF (X.LT.1) X = 1
                        IF (X.GT.1026) X = 1026
                        INDEX = X
                        IF (Z.EQ.RRANGE(2)) INDEX = 1025
                        RHIS(INDEX) = RHIS(INDEX) + 1.0D0
                        END IF
C                                      Collect plot histogram data.
                     X = (Z - ARANGE(1)) / PINT + 2.0
C                                      Overflow, underflow, specl case.
                     IF (X.LT.1) X = 1
                     IF (X.GT.MAXDEX) X = MAXDEX
                     IF (ABS(2-X).LT.0.01) THEN
                        INDEX = 2
                     ELSE IF (ABS(X-MAXDEX-1).LT.0.01) THEN
                        INDEX = MAXDEX - 1
                     ELSE
                        INDEX = X
                        END IF
                     PHIS(INDEX) = PHIS(INDEX) + 1.0D0
C                                       collect total histogram
                     X = (Z - XRANGE(1)) / XINT + 1.0
                     INDEX = X + 0.001
                     INDEX = MAX (1, MIN (MAXHIS, INDEX))
                     XHIS(INDEX) = XHIS(INDEX) + 1.0D0
                     END IF
                  END IF
 20            CONTINUE
 30         CONTINUE
 36      CONTINUE
 37      CONTINUE
 38      CONTINUE
 39      CONTINUE
 40      CONTINUE
      IF (PTOT.LE.0.0D0) THEN
         MSGTXT = 'NO VALID PIXELS FOUND'
         CALL MSGWRT (7)
         RQUICK = .FALSE.
         GO TO 300
         END IF
      IRET = 0
C                                       analyze total histogram
C                                       make cumulative
      Z = 0.0D0
      DO 50 I = MAXHIS,1,-1
         Z = Z + XHIS(I)
         XHIS(I) = Z / PTOT * 100.0D0
 50      CONTINUE
      XRANGE(1) = XRANGE(1) + 0.5*XINT
      XRANGE(2) = XRANGE(2) - 0.5*XINT
      JJ = 1
      DO 60 I = MAXHIS,1,-1
 55      IF (XHIS(I).GT.JJ) THEN
            IF (I.EQ.MAXHIS) THEN
               EXCESS(JJ) = XRANGE(2)
            ELSE
               Z = I + (XHIS(I)-JJ) / (XHIS(I) - XHIS(I+1))
               EXCESS(JJ) = XRANGE(1) + Z * XINT
               END IF
            JJ = JJ + 1
            IF (JJ.GT.50) GO TO 65
            GO TO 55
            END IF
 60      CONTINUE
C                                       Get mean & rms:
 65   ZBAR = S / PTOT
      ZRMS = S2 / PTOT - ZBAR * ZBAR
      ZRMS = MAX (0.0D0, ZRMS)
      ZRMS = SQRT (ZRMS)
C                                       Look over histogram
      IF (PIXSTD.GE.0.0) THEN
         ITTER = 0
         NITTER = 100
         RIMAX = -1
         RMAX = -1
         RHS = RHIS(1) + RHIS(1026)
         DO 70 I = 2,1025
            RHS = RHS + RHIS(I)
            IF (RHIS(I).GT.RMAX) THEN
               RIMAX = I
               RMAX = RHIS(I)
               END IF
 70         CONTINUE
         IF ((RIMAX.LE.3) .OR. (RIMAX.GE.1024)) GO TO 95
         JNPTS = 0
         RILOW = 0
         RIHIGH = RIMAX + 1
         RMAX = 0.3 * RMAX
         DO 75 I = 1,1024
            I3 = MIN (RIMAX + I, 1025)
            I4 = MAX (RIMAX - I, 2)
            IF ((RHIS(I3).LT.RMAX) .AND. (RHIS(I4).LT.RMAX)) GO TO 80
            IF (RHIS(I4).GE.RMAX) RILOW = I4
            IF (RHIS(I3).GE.RMAX) RIHIGH = I3
 75         CONTINUE
         IF (RIHIGH-RILOW.GT.700) GO TO 95
         RS = 0.0
 80      DO 85 I = RILOW,RIHIGH
            JNPTS = JNPTS + 1
            DATA(JNPTS) = RHIS(I)
            RS = RS + RHIS(I)
 85         CONTINUE
         IF (JNPTS.LT.4) GO TO 95
         IF (RS.LT.0.1*RHS) GO TO 95
         PARMS(1) = RMAX / 0.3
         PARMS(2) = RIMAX - RILOW + 1
         PARMS(3) = 1.3 * (RIHIGH - RILOW + 1.0) / 2.0
C                                       call fitting routine
         I = 1
         CALL XGFUNC (JNPTS, 3, PARMS, FVEC, FJAC, I)
         TOL = 1.D-5
         JNPARM = 3
         CALL XGALMS (JNPTS, JNPARM, PARMS, FVEC, FJAC, 3,
     *      TOL, INFO, IPVT)
         IF ((INFO.LE.0) .OR. (INFO.GT.3)) THEN
            INFO = 1
         ELSE
            INFO = 0
            PARMS(2) = PARMS(2) - 1.0 + RILOW
            PARMS(2) = (PARMS(2) - 1.5) * RINT + RRANGE(1)
            PARMS(3) = PARMS(3) * RINT / SQRT (8.0 * LOG (2.0))
            PIXAVG = PARMS(2)
            PIXSTD = PARMS(3)
            END IF
         IF (INFO.NE.0) PARMS(1) = 0.0D0
C                                       Histogram fails
 95      IF (INFO.NE.0) THEN
            MSGTXT = 'Histogram fit for RMS fails: plot a histogram'
            CALL MSGWRT (6)
            PIXAVG = 0.0
            PIXSTD = -1.0
            END IF
         END IF
      IF (RQUICK) THEN
         CALL PTPARM (52, PIXAVG, SCRTCH, IERR)
         CALL RELPOP (0, SCRTCH, IERR)
         END IF
C                                       Open output file
      LENOUT = JTRIM (OUTFIL)
C                                       If no file, do not write
      IF (LENOUT.LE.0) THEN
         TXLUN = 0
      ELSE
         CALL ZTXOPN ('WRIT', TXLUN, TXFIND, OUTFIL(1:LENOUT),
     *      APPEND, IERR)
         IF (IERR.EQ.0) THEN
            TXOPEN = T
            IF (DOPRNT.EQ.-3) TXLUN = -TXLUN
         ELSE
            IRET = 4
            WRITE (MSGTXT,1128) IERR
            CALL MSGWRT (6)
            TXLUN = 0
            END IF
         END IF
C                                       Initial print out
      IF (IDOHST.LT.1) DOLOG = .FALSE.
C                                       Histogram
      IF (IDOHST.GE.1) THEN
         IF (DOALL.LE.0.0) THEN
            DOALL = -NZ - 1
         ELSE
            DOALL = NZ + 1
            END IF
         CALL ZPHFIL ('PL', IVOL, CNO1, IVER, PFILE, IERR)
         CALL GINIT (IVOL, CNO1, PFILE, 0, 7, NPARMS, DOHIST, DOTV,
     *      TVCHN, GRCHN, TVCORN, CATBLK, IPBLK, IPLUN, IPFIND, IERR)
         IF (IERR.NE.0) GO TO 120
         IF (GR2CHN.GT.0) GPHTVG(1) = GR2CHN + NGRAY
C                                       Get max
         BMAX = -10.0
         BLOG = ALOG10 (0.5)
         DO 110 I = 1,INBOXS
            IF (DOLOG) THEN
               IF (PHIS(I+1).LE.0.0D0) THEN
                  PHIS(I+1) = BLOG
               ELSE
                  PHIS(I+1) = DLOG10 (PHIS(I+1))
                  END IF
               END IF
            IF (PHIS(I+1).GT.BMAX) BMAX = PHIS(I+1)
 110        CONTINUE
         IF (DOMODL.LE.0.0) PARMS(1) = 0.0D0
         IF (IDOHST.EQ.1) THEN
            CALL HISTOY (BMAX, PHIS, INBOXS, ARANGE, DOLOG, LABEL, IVER,
     *         XYRAT, PARMS, IPBLK, IERR)
         ELSE
            CALL HISTOX (BMAX, PHIS, INBOXS, ARANGE, DOLOG, LABEL, IVER,
     *         XYRAT, PARMS, IPBLK, IERR)
            END IF
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1110)
            CALL MSGWRT (5)
            END IF
         CALL GFINIS (IPBLK, IERR)
C                                       Successful plot file finished.
         IF (IERR.EQ.0) THEN
            IF (.NOT.DOTV) THEN
               CALL HIPLOT (IVOL, CNO1, IVER, IPBLK, IERR)
               WRITE (MSGTXT,1115) IVER
               CALL MSGWRT (5)
               IERR = 0
               END IF
            END IF
C                                       Error doing histogram.
 120     IF (IERR.NE.0) THEN
            IRET = 4
            WRITE (MSGTXT,1120)
            CALL MSGWRT (6)
            IF (.NOT.DOTV) THEN
               CALL ZCLOSE (IPLUN, IPFIND, IERR)
               CALL ZDESTR (IVOL, PFILE, IERR)
               END IF
            END IF
         END IF
C                                       Write to screen and log file
      MSGBUF = '**************************************************' //
     *   '******************************'
      CALL PWRITE (-1, TXLUN, TXFIND, MSGBUF)
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, ATIME, ADATE)
      MSGBUF = 'IMEAN run on ' // ADATE // ' at ' // ATIME
      CALL PWRITE (-1, TXLUN, TXFIND, MSGBUF)
      WRITE (MSGBUF,1125) NAMEIN, CLASIN, ISEQ, IVOL, WIN
      CALL PWRITE (5, TXLUN, TXFIND, MSGBUF)
C                                       Calculate flux density?
      FLUXFL = (TUNITS(:4).EQ.'JY/B') .OR. (TUNITS(:4).EQ.'JY/P')
C                                       unweighted print out
      IF (INFO.EQ.0) THEN
         MSGBUF = 'Mean and rms found by fitting peak in histogram:'
         CALL PWRITE (5, TXLUN, TXFIND, MSGBUF)
         WRITE (MSGBUF,1127) PARMS(2), PARMS(3)
         CALL PWRITE (5, TXLUN, TXFIND, MSGBUF)
         PIXAVG = PARMS(2)
         PIXSTD = PARMS(3)
         IF (DOACTN) THEN
            NUMKEY = 2
            KEYWRD(1) = 'ACTNOISE'
            VALUE(1) = PARMS(3)
            KEYWRD(2) = 'ACTMEAN'
            VALUE(2) = PARMS(2)
            LOCS(1) = 1
            LOCS(2) = 2
            KEYTYP(1) = 2
            KEYTYP(2) = 2
            CALL CATKEY ('WRIT', IVOL, CNO1, KEYWRD, NUMKEY, LOCS,
     *         VALUE, KEYTYP, INBUF, IERR)
            END IF
         END IF
      MSGBUF = 'Mean and rms found by including all data:'
      CALL PWRITE (5, TXLUN, TXFIND, MSGBUF)
      WRITE (MSGBUF,1126) ZBAR, ZRMS, BUNITS, PTOT
      CALL PWRITE (5, TXLUN, TXFIND, MSGBUF)
      IF (DOALL.LE.0.0) THEN
         WRITE (MSGBUF,1129) NZ
         DOALL = -NZ - 1
      ELSE
         WRITE (MSGBUF,1139) NZ
         DOALL = NZ + 1
         END IF
      IF (NZ.GT.0) CALL PWRITE (5, TXLUN, TXFIND, MSGBUF)
      SS = -1.E10
      IF (FLUXFL) THEN
         IF (TUNITS.EQ.'JY/BEAM ') BUNITS = 'JY/B'
         IF (TUNITS.EQ.'JY/PIXEL') BUNITS = 'JY/P'
         BUN2 = BUNITS(5:8)
         J = JTRIM(BUN2)
         J = MAX (1, J)
         AREA = 1.1331 * CATR(KRBMJ) * CATR(KRBMN)
         IF (TUNITS(:4).EQ.'JY/P') THEN
            WRITE (MSGBUF,1131) S, BUN2(:J)
            CALL PWRITE (5, TXLUN, TXFIND, MSGBUF)
         ELSE IF (AREA.GT.0.0) THEN
            J = CATBLK(KIDIM)
            I1 = 0
            I2 = 0
            INC = 2
            DO 130 I = 1,J
               ICPNT = KHCTP+(I-1)*INC
               CALL H2CHR (4, 1, CATH(ICPNT), XXCHAR)
               DO 129 JJ = 1,5
                  IF (XXCHAR.EQ.LLCHAR(JJ)) I1 = I
                  IF (XXCHAR.EQ.MMCHAR(JJ)) I2 = I
 129              CONTINUE
 130           CONTINUE
            IF ((I1.GT.0) .AND. (I2.GT.0)) THEN
               XRCHAR = ABS (CATR(KRCIC+I1-1) * CATR(KRCIC+I2-1))
               IF (XRCHAR.GT.0.0) THEN
                  AREA = AREA / XRCHAR
                  SS = S / AREA
                  J = MAX (1, JTRIM(BUN2))
                  WRITE (MSGBUF,1130) SS, BUN2(:J), AREA
                  CALL PWRITE (5, TXLUN, TXFIND, MSGBUF)
                  END IF
               END IF
            END IF
         END IF
C                                       special print out
      IF ((TXLUN.LT.0) .AND. (.NOT.DOINV) .AND. (INFO.EQ.0)) THEN
         IF (SS.GT.-1.E5) THEN
            WRITE (MSGBUF,1135) I3B, I4B, I5B, I6B, I7B, I3E, I4E, I5E,
     *         I6E, I7E, ZMIN, ZMAX, SS, PIXSTD
         ELSE
            WRITE (MSGBUF,1136) I3B, I4B, I5B, I6B, I7B, I3E, I4E, I5E,
     *         I6E, I7E, ZMIN, ZMAX, PIXSTD
            END IF
         CALL PWRITE (-5, -TXLUN, TXFIND, MSGBUF)
         END IF
C                                          if > 2 axes print all
      IF (NA.GT.2) THEN
         I2TMP1 = NA - 2
         WRITE (MSGBUF,1140) ZMIN, IXMIN, IYMIN, (DEPMIN(I),
     *      I = 1,I2TMP1)
      ELSE
         WRITE (MSGBUF,1140) ZMIN, IXMIN, IYMIN
         END IF
      CALL PWRITE (5, TXLUN, TXFIND, MSGBUF)
      LOCNUM = 1
      CALL SETLOC (DEPMIN, T)
      X = IXMIN
      Y = IYMIN
      CALL XYVAL (X, Y, SKYPOS(1), SKYPOS(2), SKYPOS(3), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1141) IERR
         CALL MSGWRT (7)
      ELSE
         IF ((AXTYP(LOCNUM).EQ.2) .OR. (AXTYP(LOCNUM).EQ.3)) CALL
     *      AXSTRN (CTYP(3,LOCNUM), SKYPOS(3), KLOCA(LOCNUM),
     *      NCHLAB(1,LOCNUM), SAXLAB(1,LOCNUM))
         WRITE (MSGBUF,1142)
         ICH = 9
         DO 145 I = 1,2
            I2TMP1 = I - 1
            CALL AXSTRN (CTYP(I,LOCNUM), SKYPOS(I), I2TMP1, ILEN, ARRAY)
            MSGBUF(ICH:) = ARRAY(:ILEN)
            ICH = ICH + ILEN + 2
 145     CONTINUE
         CALL PWRITE (5, TXLUN, TXFIND, MSGBUF)
         END IF
C                                       Secondary axes
      IF ((NCHLAB(1,LOCNUM).GT.0) .OR. (NCHLAB(2,LOCNUM).GT.0)) THEN
         IF ((XPLANE.GE.1.9) .OR. (AXTYP(LOCNUM).EQ.2) .OR.
     *      (AXTYP(LOCNUM).EQ.3)) THEN
            WRITE (MSGBUF,1142)
            ICH = 9
            DO 155 I = 1,2
               IF (NCHLAB(I,LOCNUM).GT.0) THEN
                  MSGBUF(ICH:) = SAXLAB(I,LOCNUM)(:NCHLAB(I,LOCNUM))
                  ICH = ICH + NCHLAB(I,LOCNUM) + 2
                  END IF
 155           CONTINUE
            CALL PWRITE (5, TXLUN, TXFIND, MSGBUF)
            END IF
         END IF
C                                       Maximum point
      IF (NA.GT.2) THEN
         I2TMP1 = NA - 2
         WRITE (MSGBUF,1160) ZMAX, IXMAX, IYMAX, (DEPMAX(I),
     *      I = 1,I2TMP1)
      ELSE
         WRITE (MSGBUF,1160) ZMAX, IXMAX, IYMAX
         END IF
      CALL PWRITE (5, TXLUN, TXFIND, MSGBUF)
      LOCNUM = 2
      CALL SETLOC (DEPMAX, T)
      X = IXMAX
      Y = IYMAX
      CALL XYVAL (X, Y, SKYPOS(1), SKYPOS(2), SKYPOS(3), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGBUF,1141) IERR
         CALL MSGWRT (7)
      ELSE
         IF ((AXTYP(LOCNUM).EQ.2) .OR. (AXTYP(LOCNUM).EQ.3)) CALL AXSTRN
     *      (CTYP(3,LOCNUM), SKYPOS(3), KLOCA(LOCNUM), NCHLAB(1,LOCNUM),
     *      SAXLAB(1,LOCNUM))
         WRITE (MSGBUF,1142)
         ICH = 9
         DO 165 I = 1,2
            I2TMP1 = I-1
            CALL AXSTRN (CTYP(I,LOCNUM), SKYPOS(I), I2TMP1, ILEN, ARRAY)
               MSGBUF(ICH:) = ARRAY(:ILEN)
            ICH = ICH + ILEN + 2
 165        CONTINUE
         CALL PWRITE (5, TXLUN, TXFIND, MSGBUF)
         END IF
C                                       Secondary axes
      IF ((NCHLAB(1,LOCNUM).GT.0) .OR. (NCHLAB(2,LOCNUM).GT.0)) THEN
         WRITE (MSGBUF,1142)
         ICH = 9
         DO 170 I = 1,2
            IF (NCHLAB(I,LOCNUM).GT.0) THEN
               MSGBUF(ICH:) = SAXLAB(I,LOCNUM)(:NCHLAB(I,LOCNUM))
               ICH = ICH + NCHLAB(I,LOCNUM) + 2
               END IF
 170        CONTINUE
         CALL PWRITE (5, TXLUN, TXFIND, MSGBUF)
         END IF
C                                       Histogram to file
      IF (TXLUN.GT.0) THEN
         IF (DOLOG) THEN
            BLOG = ALOG10 (0.5)
            DO 175 I = 1,INBOXS
               IF (PHIS(I+1).EQ.BLOG) THEN
                  PHIS(I+1) = 0.0D0
               ELSE
                  PHIS(I+1) = 10.0 ** PHIS(I+1)
                  END IF
 175           CONTINUE
            END IF
         X = ARANGE(2) - ARANGE(1)
         X = MAX (X, ABS(ARANGE(1)), ABS(ARANGE(2)))
         Y = X
         CALL METSCL (LABEL, X, PREFIX, PFLAG)
         IF (Y.NE.0.0) Y = X / Y
         IF (Y.EQ.0) Y = 1.0
         PINT = PINT * Y
         ARANGE(1) = ARANGE(1) * Y
         ARANGE(2) = ARANGE(2) * Y
         WRITE (MSGBUF,1175) PHIS(1), ARANGE(1), PREFIX, BUNITS
         CALL PWRITE (-1, TXLUN, TXFIND, MSGBUF)
         DO 180 I = 1,INBOXS
            PRANGE(2) = ARANGE(1) + I * PINT
            PRANGE(1) = PRANGE(2) - PINT
            WRITE (MSGBUF,1176) PHIS(I+1), PRANGE, PREFIX, BUNITS
            CALL PWRITE (-1, TXLUN, TXFIND, MSGBUF)
 180        CONTINUE
         WRITE (MSGBUF,1180) PHIS(INBOXS+2), ARANGE(2), PREFIX, BUNITS
         CALL PWRITE (-1, TXLUN, TXFIND, MSGBUF)
         END IF
C                                       Close input file:
C                                       error after plot file
 300  IF ((IRET.EQ.0) .OR. (.NOT.PLOPEN)) GO TO 320
         CALL ZCLOSE (LUN1, FIND1, IERR)
         CALL DELEXT ('PL', IVOL, CNO1, 'READ', CATBLK, SCRTCH, IVER,
     *      IERR)
         GO TO 990
 320  CALL MAPCLS (STAT, IVOL, CNO1, LUN1, FIND1, CATBLK, F,
     *   SCRTCH, IERR)
C                                       That's all folks!
 990  TXLUN = ABS (TXLUN)
      IF ((TXOPEN) .AND. (TXLUN.GT.0)) CALL ZTXCLS (TXLUN, TXFIND, IERR)
      IF (.NOT.RQUICK) CALL PTPARM (52, PIXAVG, SCRTCH, IERR)
      CALL DIETSK (IRET, RQUICK, SCRTCH)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('GET PARAMETER ERR=',I5)
 1010 FORMAT ('ERROR ON OPEN: IERR=', I5)
 1015 FORMAT ('Guess is Mean=',1PE11.4,'  Rms=',1PE11.4)
 1020 FORMAT ('EXT CREATE ERROR - WILL SKIP HISTOGRAM')
 1110 FORMAT ('ERROR. WILL TRY TO FINISH PARTIAL GRAPH.')
 1115 FORMAT ('Successful plot file (histogram) version',I7)
 1120 FORMAT ('ERROR DOING HISTOGRAM. DESTROYING PLOT FILE.')
 1125 FORMAT ('Image= ',A12,'.',A6,'.',I4,I2,3X,'xywind=',4I5)
 1126 FORMAT ('Mean=',1PE10.3,' Rms=',1PE10.3,1X,A8,' over',
     *   0PF13.0,' pixels')
 1127 FORMAT ('Mean=',1PE11.4,' Rms=',1PE11.4,'  **** from histogram')
 1128 FORMAT ('ERROR ON OUTPUT FILE OPEN: ERR=',I5)
 1129 FORMAT ('Ignored',F14.0,' pure-zero pixels')
 1139 FORMAT ('Included',F13.0,' pure-zero pixels')
 1130 FORMAT ('Flux density =',1PE12.4,' Jy',A,'  beam area =',
     *   0PF9.2,' pixels')
 1131 FORMAT ('Flux density =',1PE12.4,' Jy',A)
 1135 FORMAT (I5,I3,3I2,I6,I3,3I2,4(1PE12.4))
 1136 FORMAT (I5,I3,3I2,I6,I3,3I2,2(1PE12.4),12X,1PE12.4)
 1140 FORMAT ('Minimum=',1PE11.4,' at',7I5)
 1141 FORMAT ('ERROR',I3,' CONVERTING TO SKY COORDINATES')
 1142 FORMAT ('Skypos: ')
 1160 FORMAT ('Maximum=',1PE11.4,' at',7I5)
 1175 FORMAT (F14.0,' pixels below  ',F10.4,11X,2A)
 1176 FORMAT (F14.0,' pixels between',2F10.4,1X,2A)
 1180 FORMAT (F14.0,' pixels above  ',F10.4,11X,2A)
      END
      SUBROUTINE HISTOY (BMAX, PHIS, NBOXES, RANGE, DOLOG, LABEL, IVER,
     *   XYR, PARMS, IPBLK, IERR)
C-----------------------------------------------------------------------
C   This routine will write commands to an open plot file for drawing
C   a histogram.  Flux on Y axis, count on X axis.
C   Inputs:
C      BMAX     R        the maximum value in any of the boxes.
C      PHIS     D(NBOXES+2)   The number of entries in each range.
C                        PHIS(1) is the underflow, PHIS(NBOXES+2) is
C                        the overflow.
C      NBOXES   I        number of boxes or value ranges for histogram.
C      RANGE    R(2)     intensity range of histogram
C      DOLOG    L        T => use log(n) rather than linear scale
C      LABEL    I        Type of labeling
C      IVER     I        Plot file version number
C      PARMS    D(4)     Fit parameters (1) = 0 => bad
C   In/out:
C      IPBLK    I(256)   I/O buffer for open, initialized pl file.
C   Output:
C      IERR     I        error code. 0=ok, 1=write error to plot file.
C-----------------------------------------------------------------------
      REAL      BMAX, RANGE(2), XYR
      DOUBLE PRECISION PARMS(3), PHIS(*)
      INTEGER   NBOXES, LABEL, IVER, IPBLK(256), IERR
      LOGICAL   DOLOG
C
      REAL      BLC(7), CH(4), TRC(7), X, Y, FAC, XYRATO, EXF, BFACT,
     *   Y1, Y2, DX, DY, XMULT
      INTEGER   IDEPTH(5), I, LTYPE, NC1, NC2
      CHARACTER TXTMSG*80, STRNG1*16, STRNG2*16
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Set character offsets.
      CALL GTICNT (LABEL, RANGE, I)
C                                       number characters around
      CALL RFILL (4, 0.5, CH)
      LTYPE = MOD (ABS (LABEL), 100)
      IF (LTYPE.EQ.2) CH(1) = 2.5
      IF (LTYPE.GT.2) CH(1) = I + 4.0
      IF (LTYPE.GT.1) CH(2) = 2.0
      IF (LTYPE.GT.2) CH(2) = CH(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CH(2) = CH(2) + 3 * 1.333
      IF (LTYPE.EQ.2) CH(3) = 2.5
      IF (LTYPE.GT.2) THEN
         CH(3) = 4.0
         IF (NBOXES.GE.10) CH(3) = CH(3) + 1.0
         IF (NBOXES.GE.100) CH(3) = CH(3) + 1.0
         IF (NBOXES.GE.1000) CH(3) = CH(3) + 1.0
         END IF
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CH(4) = 2.0
      IF ((LABEL.GT.1) .AND. (LTYPE.LT.7)) CH(4) = CH(4) + 1.333
C                                       Set BLC, TRC, XYRATO.
      CALL RFILL (5, 1.0, BLC(3))
      CALL RFILL (5, 1.0, TRC(3))
      CALL FILL (5, 1, IDEPTH)
      BLC(1) = 0.0
      IF (DOLOG) BLC(1) = ALOG10 (0.5)
      BLC(2) = 0.0
      TRC(2) = NBOXES
      TRC(1) = BMAX * 1.05
      XYRATO = (TRC(2) - BLC(2)) / (TRC(1) - BLC(1)) * XYR
C                                       Kludge to keep XYRATO small
C                                       to prevent overflow in GINITL.
      FAC = 1.0
      DO 50 I = 1,10000
         IF (XYRATO.GT.0.50) GO TO 60
         FAC = FAC * 10.0
         XYRATO = XYRATO * 10.0
 50      CONTINUE
C
 60   TRC(1) = TRC(1) / FAC
      BLC(1) = BLC(1) / FAC
C                                       Initialize plot file line drw.
      CALL GINITL (BLC, TRC, XYRATO, CH, IDEPTH, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GLTYPE (1, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Draw borders.
      CALL GPOS (BLC(1), BLC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (TRC(1), BLC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (TRC(1), TRC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (BLC(1), TRC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (BLC(1), BLC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Labeling.
      I = NBOXES + 2
      CALL HLABY (BLC, TRC, FAC, NBOXES, RANGE, DOLOG, IVER, PHIS(1),
     *   PHIS(I), LABEL, XMULT, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Position at first data point.
      TXTMSG = 'End labeling, draw histogram'
      CALL GCOMNT (-1, TXTMSG, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GLTYPE (2, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      X = BLC(1)
      Y = BLC(2)
      CALL GPOS (X, Y, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Loop for rest of data points.
      DO 100 I = 1,NBOXES
         X = PHIS(I+1) / FAC
         CALL GVEC (X, Y, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         Y = I
         CALL GVEC (X, Y, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         X = BLC(1)
         CALL GVEC (X, Y, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
 100     CONTINUE
C                                       Plot Gaussian fit
      IF (PARMS(1).GT.0.0) THEN
         TXTMSG = 'Draw gaussian fit'
         CALL GCOMNT (2, TXTMSG, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GLTYPE (4, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         EXF = NBOXES / 1000.0
         BFACT = BMAX
         IF (DOLOG) BFACT = 10.0 ** BMAX
         DO 200 I = 1,1001
            Y = RANGE(1) + (I-1.0) * (RANGE(2)-RANGE(1)) / 1000.0
            Y = (Y - PARMS(2)) / PARMS(3)
            Y = Y * Y / 2.0
            IF (Y.LE.69.) THEN
               X = BFACT * EXP (-Y)
            ELSE
               X = 0.
               END IF
            IF (DOLOG) X = ALOG10 (MAX (0.5, X))
            Y = (I - 1) * EXF
            X = X / FAC
            IF (I.EQ.1) THEN
               CALL GPOS (X, Y, IPBLK, IERR)
            ELSE
               CALL GVEC (X, Y, IPBLK, IERR)
               END IF
            IF (IERR.NE.0) GO TO 999
 200        CONTINUE
         CALL GLTYPE (1, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         Y1 = XMULT * PARMS(2)
         Y2 = ABS (Y1)
         IF (Y2.GT.1000.) THEN
            WRITE (STRNG1,1040) 'C =', Y1
         ELSE IF (Y2.GT.1.0) THEN
            WRITE (STRNG1,1041) 'C =', Y1
         ELSE IF (Y2.GT.0.01) THEN
            WRITE (STRNG1,1042) 'C =', Y1
         ELSE
            WRITE (STRNG1,1043) 'C =', Y1
            END IF
         CALL REFRMT (STRNG1, '_', NC1)
         Y1 = XMULT * PARMS(3)
         Y2 = ABS (Y1)
         IF (Y2.GT.1000.) THEN
            WRITE (STRNG2,1040) 'RMS=', Y1
         ELSE IF (Y2.GT.1.0) THEN
            WRITE (STRNG2,1041) 'RMS=', Y1
         ELSE IF (Y2.GT.0.01) THEN
            WRITE (STRNG2,1042) 'RMS=', Y1
         ELSE
            WRITE (STRNG2,1043) 'RMS=', Y1
            END IF
         CALL REFRMT (STRNG2, '_', NC2)
         I = MAX (NC1, NC2)
         DX = -I - 5
         DY = -5.0
         CALL GPOS (TRC(1), TRC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GCHAR (NC1, 0, DX, DY, STRNG1, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         DX = -I - 5
         DY = -7.0
         CALL GPOS (TRC(1), TRC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GCHAR (NC2, 0, DX, DY, STRNG2, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT (A,F7.0)
 1041 FORMAT (A,F8.3)
 1042 FORMAT (A,F8.4)
 1043 FORMAT (A,F9.6)
      END
      SUBROUTINE HLABY (BLC, TRC, FAC, NBOXES, RANGE, DOLOG, IVER,
     *   UNDER, OVER, LABEL, XMULT, IPBLK, IERR)
C-----------------------------------------------------------------------
C   Write labeling for histogram.
C   Inputs:
C      BLC     R(2)     bottom left corner of plot.
C      TRC     R(2)     top right hand corner of plot.
C      FAC     R        FAC*XYRATO = real XYRATIO.
C      IVER    I        plot file version number
C      LABEL   I        labeling type
C      IPBLK   I(256)   I/O buffer for plot file.
C   Output:
C      XMULT   R        X axis metric scaling
C      IERR    I        error code returned from GVEC.
C-----------------------------------------------------------------------
      REAL      BLC(7), TRC(7), FAC, RANGE(2), XMULT
      INTEGER   NBOXES, IVER, LABEL, IPBLK(256), IERR
      LOGICAL   DOLOG
      DOUBLE PRECISION UNDER, OVER
C
      CHARACTER PREFIX*5, TIME*8, DATE*12, CTEMP*8, CSTOK(12)*4,
     *   NAMSTR*18, MSGBUF*80
      LOGICAL   PFLAG
      REAL      XINTER(21), DCX0, DCX, DCY, DIST, ODIST, XDIST, XMAX,
     *   TICSCL, YTICEL, YTICER, XVAL, XPOS, Y, TICLEN, XINT, X, FREQ,
     *   DCXM, DTRC, DBLC, DEG, DU, DL
      INTEGER   INOINT, INCHAR, I, IXO, M, ITRY, NXRA, NXDEC, NXLL,
     *   NXMM, NXFR, NXST, NAX, INC, IANGL, JSTOK, IT(3), ID(3),
     *   ICPNT, ITMP, LTYPE, XNOINT
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA TICSCL /70.0/
      DATA CSTOK /'????','Beam','Ipol','Qpol','Upol','Vpol','Ppol',
     *   'Fpol','Pang','Spix','Optd','    '/
      DATA XINTER /.1, .2, .5, 1., 2., 5., 10., 20., 50., 100., 200.,
     *   500., 1000., 2000., 5000., 10000., 20000., 50000., 100000.,
     *   200000., 500000./
C-----------------------------------------------------------------------
      LTYPE = MOD (ABS(LABEL), 100)
      IF (LTYPE.LE.1) GO TO 999
C                                       Tic positions.
      TICLEN = (TRC(2) - BLC(2)) / TICSCL
      YTICEL = BLC(2) + TICLEN
      YTICER = TRC(2) - TICLEN
C                                       Find interval value.
      DBLC = FAC * BLC(1)
      DTRC = FAC * TRC(1)
      XINT = 9.0
      IF (DOLOG) XINT = 9.0
      DO 20 I = 1,21
         DEG = XINTER(I)
         DU = AINT (DTRC/DEG) * DEG
         IF (DU.GT.DTRC) DU = DU - DEG
         DL = AINT (DBLC/DEG) * DEG
         IF (DL.LT.DBLC) DL = DL + DEG
         XNOINT = AINT ((DU-DL)/DEG) + 1.001
         IF (XNOINT.LE.XINT) GO TO 30
 20      CONTINUE
      GO TO 110
C                                       Interval and no of inter found.
 30   XINT = DEG
      INOINT = XNOINT + 2
      XVAL = AINT (FAC*BLC(1)/XINT) * XINT
      IF (XVAL.GE.FAC*BLC(1)) XVAL = XVAL - XINT
      IXO = I
C                                       Loop for all tics.
      DO 100 I = 1,INOINT
         XVAL = XVAL + XINT
         XPOS = XVAL / FAC
         IF (XPOS.GT.TRC(1)) GO TO 110
C                                       top tic.
         CALL GPOS (XPOS, TRC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (XPOS, YTICER, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       bottom tic.
         CALL GPOS (XPOS, YTICEL, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (XPOS, BLC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Write value.
         IF (LTYPE.GT.2) THEN
            WRITE (MSGBUF,1030) XVAL
            CALL CHTRIM (MSGBUF, 14, MSGBUF, INCHAR)
            IF (IXO.GT.3) INCHAR = INCHAR - 2
            DCX = - INCHAR + 0.5
            DCY = -1.5
            CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 100     CONTINUE
C                                       Number of pixels
 110  DCY = -2.833
      IF (LTYPE.EQ.2) DCY = -1.5
      XPOS = (TRC(1) + BLC(1)) / 2.0
      CALL GPOS (XPOS, BLC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (DOLOG) THEN
         MSGBUF = 'Log10 (number of pixels)'
         INCHAR = 24
      ELSE
         MSGBUF = 'Number of pixels'
         INCHAR = 16
         END IF
      DCX = -INCHAR/2.0
      CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        Write bucket numbers on right
      DCX0 = 0.5
      IF (LTYPE.GT.2) THEN
         DCY = - 0.5
         DCX0 = 1.5
         IF (NBOXES.GE.10) DCX0 = DCX0 + 1.0
         IF (NBOXES.GE.100) DCX0 = DCX0 + 1.0
         IF (NBOXES.GE.1000) DCX0 = DCX0 + 1.0
         END IF
      IF (NBOXES.LE.10) THEN
         M = 1
      ELSE IF (NBOXES.LE.20) THEN
         M = 2
      ELSE IF (NBOXES.LE.50) THEN
         M = 5
      ELSE IF (NBOXES.LE.100) THEN
         M = 10
      ELSE IF (NBOXES.LE.200) THEN
         M = 20
      ELSE IF (NBOXES.LE.500) THEN
         M = 50
      ELSE IF (NBOXES.LE.1000) THEN
         M = 100
      ELSE IF (NBOXES.LE.2000) THEN
         M = 200
         END IF
      TICLEN = (TRC(1)-BLC(1))/TICSCL
      YTICEL = BLC(1) + TICLEN
      YTICER = TRC(1) - TICLEN
      DO 150 I = 0,NBOXES,M
         Y = I - .5
         CALL GPOS (YTICER, Y, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (TRC(1), Y, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         IF (LTYPE.GT.2) THEN
            WRITE (MSGBUF,1115) I
            CALL CHTRIM (MSGBUF, 4, MSGBUF, INCHAR)
            DCX = DCX0 - REAL(INCHAR)
            CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 150     CONTINUE
C                                       Label RHS bucket #
      Y = (TRC(2) + BLC(2)) / 2.0
      CALL GPOS (TRC(1), Y, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      DCX = DCX0 + 1.0
      DCY = 4
      MSGBUF = 'Box number'
      CALL GCHAR (10, 1, DCX, DCY, MSGBUF, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Range =
      CALL H2CHR (8, 1, CATH(KHBUN), CTEMP)
      IF (LTYPE.LT.7) THEN
         CALL GPOS (BLC(1), BLC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         DCX = 0.0
         DCY = -2.833
         IF (LTYPE.GT.2) DCY = DCY - 1.333
         WRITE (MSGBUF,1151) RANGE(1), RANGE(2), CTEMP
         CALL REFRMT (MSGBUF, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Interval =
         CALL GPOS (BLC(1), BLC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         X = (RANGE(2) - RANGE(1)) / NBOXES
         WRITE (MSGBUF,1152) X, CTEMP
         DCY = DCY - 1.333
         CALL REFRMT (MSGBUF, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
C                                       Underflow = overflow =
         CALL GPOS (BLC(1), BLC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         I = UNDER + 0.1
         M = OVER + 0.1
         WRITE (MSGBUF,1154) I, M
         DCY = DCY - 1.333
         CALL REFRMT (MSGBUF, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
         END IF
C                                       Determine label range
      DIST = RANGE(2) - RANGE(1)
      ODIST = DIST
      CALL METSCL (LABEL, DIST, PREFIX, PFLAG)
      IF (PFLAG) GO TO 190
      XDIST = DIST / ODIST
      XMULT = XDIST
      DTRC = XDIST * RANGE(2)
      DBLC = XDIST * RANGE(1)
      ODIST = XDIST * RANGE(1)
C                                       Get interval
      DO 160 ITRY = 1,21
         DEG = XINTER(ITRY)
         DU = AINT (DTRC/DEG) * DEG
         IF (DU.GT.DTRC) DU = DU - DEG
         DL = AINT (DBLC/DEG) * DEG
         IF (DL.LT.DBLC) DL = DL + DEG
         XNOINT = AINT ((DU-DL)/DEG) + 1.001
         IF (XNOINT.LE.8.0) GO TO 170
160     CONTINUE
      GO TO 190
C                                       Left hand (value) tics
 170  XINT = DEG
      DCY = -0.5
      DCX0 = -1.0
      DCXM = -0.5
      XMAX = MAX (ABS(RANGE(2)), ABS(RANGE(1))) * XDIST
      INOINT = XNOINT + 2
      XVAL = AINT (ODIST/XINT) * XINT
      IF (XVAL.GE.ODIST) XVAL = XVAL - XINT
      DO 175 I = 1,INOINT
         XVAL = XVAL + XINT
         Y = ((XVAL-ODIST)/DIST) * NBOXES
         IF (Y.GT.TRC(2)) GO TO 180
         CALL GPOS (YTICEL, Y, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (BLC(1), Y, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         IF (LTYPE.GT.2) THEN
            WRITE (MSGBUF,1030) XVAL
            CALL CHTRIM (MSGBUF, 14, MSGBUF, INCHAR)
            IF (ITRY.GT.3) INCHAR = INCHAR - 2
            DCX = DCX0 - INCHAR
            DCXM = MIN (DCXM, DCX)
            CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 175     CONTINUE
C                                       Label with prefix
 180  DCX = DCXM - 2.0
      Y = (TRC(2) + BLC(2)) / 2.0
      CALL GPOS (BLC(1), Y, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (MSGBUF,1175) PREFIX, CTEMP
      CALL CHTRIM (MSGBUF, 14, MSGBUF, INCHAR)
      DCY = INCHAR/2.0 - 1.0
      CALL GCHAR (INCHAR, 1, DCX, DCY, MSGBUF, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (LTYPE.GE.7) GO TO 999
C                                       which axis is which?
 190  NXRA = 0
      NXDEC = 0
      NXLL = 0
      NXMM = 0
      NXFR = 0
      NXST = 0
      NAX = CATBLK(KIDIM)
      INC = 2
      DO 200 I = 1,NAX
         ICPNT = KHCTP+(I-1)*INC
         CALL H2CHR (8, 1, CATH(ICPNT), CTEMP)
         IF (CTEMP(1:4).EQ.'FREQ') NXFR  = I
         IF (CTEMP(1:4).EQ.'STOK') NXST  = I
 200     CONTINUE
C                                       Source name, stokes, freq.
      CALL GPOS (BLC(1), TRC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      DCX = 0.0
      DCY = 0.5
      IANGL = 0
      CALL H2CHR (8, 1, CATH(KHOBJ), CTEMP)
      FREQ = 0.0
      JSTOK = 12
      IF (NXFR.GT.2) FREQ = CATD(KDCRV+NXFR-1) + CATR(KRCIC+NXFR-1)
     *   * (BLC(NXFR) - CATR(KRCRP+NXFR-1))
      FREQ = FREQ / 1.E6
      IF (NXST.GT.2) JSTOK = CATD(KDCRV+NXST-1) + CATR(KRCIC+NXST-1)
     *   * (BLC(NXST) - CATR(KRCRP+NXST-1)) + 2.5
      IF (NXFR.GT.2) WRITE (MSGBUF,1200) CTEMP, CSTOK(JSTOK),
     *   FREQ
      IF (NXFR.LE.2) WRITE (MSGBUF,1200) CTEMP, CSTOK(JSTOK)
      CALL REFRMT (MSGBUF, '_', INCHAR)
C                                       image name
      INCHAR = INCHAR + 1
      IF (INCHAR.GT.1) THEN
         MSGBUF(INCHAR:INCHAR+2) = '  _'
         INCHAR = INCHAR + 3
         END IF
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), NAMSTR(1:12))
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), NAMSTR(13:18))
      CALL NAMEST (NAMSTR, CATBLK(KIIMS), MSGBUF(INCHAR:), ITMP)
      CALL REFRMT (MSGBUF, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       time/date, version
      IF (LABEL.GT.0) THEN
         CALL GPOS (BLC(1), TRC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, TIME, DATE)
         WRITE (MSGBUF,1210) IVER, DATE, TIME
         CALL REFRMT (MSGBUF, '_', INCHAR)
         DCY = DCY + 1.333
         CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (F14.1)
 1115 FORMAT (I4)
 1151 FORMAT ('Range =',1PE12.4,' to',1PE12.4,1X,A8)
 1152 FORMAT ('Interval =',1PE12.4,1X,A8)
 1154 FORMAT ('Underflow =',I10,' _Overflow =',I10)
 1175 FORMAT (A5,1X,A8)
 1200 FORMAT (A,'  _',A4,'_ ',F10.3,' MHz')
 1210 FORMAT ('Plot file version',I4,'__created ',A,A)
      END
      SUBROUTINE HISTOX (BMAX, PHIS, NBOXES, RANGE, DOLOG, LABEL, IVER,
     *   XYR, PARMS, IPBLK, IERR)
C-----------------------------------------------------------------------
C   This routine will write commands to an open plot file for drawing
C   a histogram.  Flux on X axis, count on Y axis.
C   Inputs:
C      BMAX     R        the maximum value in any of the boxes.
C      PHIS     D(NBOXES+2)   The number of entries in each range.
C                        PHIS(1) is the underflow, PHIS(NBOXES+2) is
C                        the overflow.
C      NBOXES   I        number of boxes or value ranges for histogram.
C      RANGE    R(2)     intensity range of histogram
C      DOLOG    L        T => use log(n) rather than linear scale
C      LABEL    I        Type of labeling
C      IVER     I        Plot file version number
C      PARMS    D(3)     Fit parameters (4) = 0 => use them
C   In/out:
C      IPBLK    I(256)   I/O buffer for open, initialized pl file.
C   Output:
C      IERR     I        error code. 0=ok, 1=write error to plot file.
C-----------------------------------------------------------------------
      REAL      BMAX, RANGE(2), XYR
      DOUBLE PRECISION PARMS(3), PHIS(*)
      INTEGER   NBOXES, LABEL, IVER, IPBLK(256), IERR
      LOGICAL   DOLOG
C
      REAL      BLC(7), CH(4), TRC(7), X, Y, FAC, XYRATO, LOCRAN(2),
     *   EXF, BFACT, Y1, Y2, DX, DY, XMULT
      INTEGER   IDEPTH(5), I, LTYPE, NC1, NC2
      CHARACTER TXTMSG*80, STRNG1*16, STRNG2*16
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Set character offsets.
      LOCRAN(2) = BMAX
      LOCRAN(1) = 0.
      IF (DOLOG) LOCRAN(1) = ALOG10 (0.5)
      CALL GTICNT (LABEL, LOCRAN, I)
C                                       number characters around
      CALL RFILL (4, 0.5, CH)
      LTYPE = MOD (ABS (LABEL), 100)
      IF (LTYPE.EQ.2) CH(1) = 2.5
      IF (LTYPE.GT.2) CH(1) = I + 4.0
      IF (LTYPE.GT.1) CH(2) = 2.0
      IF (LTYPE.GT.2) CH(2) = CH(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CH(2) = CH(2) + 3 * 1.333
      IF (LTYPE.EQ.2) CH(3) = 2.5
      IF (LTYPE.GT.1) CH(4) = CH(4) + 1.5
      IF (LTYPE.GT.2) CH(4) = CH(4) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CH(4) = CH(4) + 1.333
      IF ((LABEL.GT.1) .AND. (LTYPE.LT.7)) CH(4) = CH(4) + 1.333
C                                       Set BLC, TRC, XYRATO.
      CALL RFILL (5, 1.0, BLC(3))
      CALL RFILL (5, 1.0, TRC(3))
      CALL FILL (5, 1, IDEPTH)
      BLC(2) = 0.0
      IF (DOLOG) BLC(2) = ALOG10 (0.5)
      BLC(1) = 0.0
      TRC(1) = NBOXES
      TRC(2) = BMAX * 1.05
      XYRATO = (TRC(1) - BLC(1)) / (TRC(2) - BLC(2)) / XYR
C                                       Kludge to keep XYRATO small
C                                       to prevent overflow in GINITL.
      FAC = 1.0
      DO 50 I = 1,10000
         IF (XYRATO.GT.0.50) GO TO 60
         FAC = FAC * 10.0
         XYRATO = XYRATO * 10.0
 50      CONTINUE
C
 60   TRC(2) = TRC(2) / FAC
      BLC(2) = BLC(2) / FAC
      XYRATO = 1.0 / XYRATO
C                                       Initialize plot file line drw.
      CALL GINITL (BLC, TRC, XYRATO, CH, IDEPTH, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GLTYPE (1, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Draw borders.
      CALL GPOS (BLC(1), BLC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (TRC(1), BLC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (TRC(1), TRC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (BLC(1), TRC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (BLC(1), BLC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Labeling.
      I = NBOXES + 2
      CALL HLABX (BLC, TRC, FAC, NBOXES, RANGE, DOLOG, IVER, PHIS(1),
     *   PHIS(I), LABEL, XMULT, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      TXTMSG = 'End labeling, draw histogram'
      CALL GCOMNT (-1, TXTMSG, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GLTYPE (2, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Position at first data point.
      X = BLC(1)
      Y = BLC(2)
      CALL GPOS (X, Y, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Loop for rest of data points.
      DO 100 I = 1,NBOXES
         Y = PHIS(I+1) / FAC
         CALL GVEC (X, Y, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         X = I
         CALL GVEC (X, Y, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         Y = BLC(2)
         CALL GVEC (X, Y, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
 100     CONTINUE
C                                       Gaussian fit
      IF (PARMS(1).GT.0.0) THEN
         TXTMSG = 'Draw gaussian fit'
         CALL GCOMNT (2, TXTMSG, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GLTYPE (4, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         EXF = NBOXES / 1000.0
         BFACT = BMAX
         IF (DOLOG) BFACT = 10.0 ** BMAX
         DO 200 I = 1,1001
            X = RANGE(1) + (I-1.0) * (RANGE(2)-RANGE(1)) / 1000.0
            X = (X - PARMS(2)) / PARMS(3)
            X = X * X / 2.0
            IF (X.LE.69.) THEN
               Y = BFACT * EXP (-X)
            ELSE
               Y = 0.
               END IF
            IF (DOLOG) Y = ALOG10 (MAX (0.5, Y))
            X = (I - 1) * EXF
            Y = Y / FAC
            IF (I.EQ.1) THEN
               CALL GPOS (X, Y, IPBLK, IERR)
            ELSE
               CALL GVEC (X, Y, IPBLK, IERR)
               END IF
            IF (IERR.NE.0) GO TO 999
 200        CONTINUE
         CALL GLTYPE (1, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         Y1 = XMULT * PARMS(2)
         Y2 = ABS (Y1)
         IF (Y2.GT.1000.) THEN
            WRITE (STRNG1,1040) 'C =', Y1
         ELSE IF (Y2.GT.1.0) THEN
            WRITE (STRNG1,1041) 'C =', Y1
         ELSE IF (Y2.GT.0.01) THEN
            WRITE (STRNG1,1042) 'C =', Y1
         ELSE
            WRITE (STRNG1,1043) 'C =', Y1
            END IF
         CALL REFRMT (STRNG1, '_', NC1)
         Y1 = XMULT * PARMS(3)
         Y2 = ABS (Y1)
         IF (Y2.GT.1000.) THEN
            WRITE (STRNG2,1040) 'RMS=', Y1
         ELSE IF (Y2.GT.1.0) THEN
            WRITE (STRNG2,1041) 'RMS=', Y1
         ELSE IF (Y2.GT.0.01) THEN
            WRITE (STRNG2,1042) 'RMS=', Y1
         ELSE
            WRITE (STRNG2,1043) 'RMS=', Y1
            END IF
         CALL REFRMT (STRNG2, '_', NC2)
         I = MAX (NC1, NC2)
         DX = -I - 5
         DY = -5.0
         CALL GPOS (TRC(1), TRC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GCHAR (NC1, 0, DX, DY, STRNG1, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         DX = -I - 5
         DY = -7.0
         CALL GPOS (TRC(1), TRC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GCHAR (NC2, 0, DX, DY, STRNG2, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT (A,F7.0)
 1041 FORMAT (A,F8.3)
 1042 FORMAT (A,F8.4)
 1043 FORMAT (A,F9.6)
      END
      SUBROUTINE HLABX (BLC, TRC, FAC, NBOXES, RANGE, DOLOG, IVER,
     *   UNDER, OVER, LABEL, XMULT, IPBLK, IERR)
C-----------------------------------------------------------------------
C   Write labeling for histogram.
C   Inputs:
C      BLC     R(2)     bottom left corner of plot.
C      TRC     R(2)     top right hand corner of plot.
C      FAC     R        FAC*XYRATO = real XYRATIO.
C      IVER    I        plot file version number
C      LABEL   I        labeling type
C      IPBLK   I(256)   I/O buffer for plot file.
C   Output:
C      XMULT   R        X axis metric scaling
C      IERR    I        error code returned from GVEC.
C-----------------------------------------------------------------------
      REAL      BLC(7), TRC(7), FAC, RANGE(2), XMULT
      DOUBLE PRECISION UNDER, OVER
      INTEGER   NBOXES, IVER, LABEL, IPBLK(256), IERR
      LOGICAL   DOLOG
C
      CHARACTER PREFIX*5, TIME*8, DATE*12, CTEMP*8, CSTOK(12)*4,
     *   NAMSTR*18, MSGBUF*80
      LOGICAL   PFLAG
      REAL      XINTER(21), DCX, DCY, DIST, ODIST, XDIST, XMAX, TICSCL,
     *   YTICEL, YTICER, XVAL, YPOS, TICLEN, XINT, X, FREQ, DCXM, DEG,
     *   DBLC, DTRC, DU, DL
      INTEGER   INOINT, INCHAR, I, IXO, M, ITRY, NXRA, NXDEC, NXLL,
     *   NXMM, NXFR, NXST, NAX, INC, IANGL, JSTOK, IT(3), ID(3),
     *   ICPNT, ITMP, LTYPE, XNOINT
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA TICSCL /70.0/
      DATA CSTOK /'????','Beam','Ipol','Qpol','Upol','Vpol','Ppol',
     *   'Fpol','Pang','Spix','Optd','    '/
      DATA XINTER /.1, .2, .5, 1., 2., 5., 10., 20., 50., 100., 200.,
     *   500., 1000., 2000., 5000., 10000., 20000., 50000., 100000.,
     *   200000., 500000./
C-----------------------------------------------------------------------
      LTYPE = MOD (ABS(LABEL), 100)
      IF (LTYPE.LE.1) GO TO 999
C                                       Tic positions.
      TICLEN = (TRC(1) - BLC(1)) / TICSCL
      YTICEL = BLC(1) + TICLEN
      YTICER = TRC(1) - TICLEN
C                                       Find interval value.
      DBLC = FAC * BLC(2)
      DTRC = FAC * TRC(2)
      XINT = 8.0
      DO 20 I = 1,21
         DEG = XINTER(I)
         DU = AINT (DTRC/DEG) * DEG
         IF (DU.GT.DTRC) DU = DU - DEG
         DL = AINT (DBLC/DEG) * DEG
         IF (DL.LT.DBLC) DL = DL + DEG
         XNOINT = AINT ((DU-DL)/DEG) + 1.001
         IF (XNOINT.LE.XINT) GO TO 30
 20      CONTINUE
      GO TO 110
C                                       Interval and no of inter found.
 30   XINT = DEG
      INOINT = XNOINT + 2
      XVAL = AINT (FAC*BLC(2)/XINT) * XINT
      IF (XVAL.GE.FAC*BLC(2)) XVAL = XVAL - XINT
      IXO = I
      DCXM = -0.5
C                                       Loop for all tics.
      DO 100 I = 1,INOINT
         XVAL = XVAL + XINT
         YPOS = XVAL / FAC
         IF (YPOS.GT.TRC(2)) GO TO 110
C                                       TOP tic.
         CALL GPOS (TRC(1), YPOS, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (YTICER, YPOS, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Left hand tic.
         CALL GPOS (YTICEL, YPOS, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (BLC(1), YPOS, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Write value.
         IF (LTYPE.GT.2) THEN
            WRITE (MSGBUF,1030) XVAL
            CALL CHTRIM (MSGBUF, 14, MSGBUF, INCHAR)
            IF (IXO.GT.3) INCHAR = INCHAR - 2
            DCX = - INCHAR - 1.0
            DCY = -0.5
            DCXM = MIN (DCXM, DCX)
            CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 100     CONTINUE
C                                       Number of pixels
 110  DCX = DCXM - 2.0
      YPOS = (TRC(2) + BLC(2)) / 2.0
      CALL GPOS (BLC(1), YPOS, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (DOLOG) THEN
         MSGBUF = 'Log10 (number of pixels)'
         INCHAR = 24
      ELSE
         MSGBUF = 'Number of pixels'
         INCHAR = 16
         END IF
      DCY = INCHAR / 2.0 - 1.0
      CALL GCHAR (INCHAR, 1, DCX, DCY, MSGBUF, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        Write bucket numbers on top
      IF (NBOXES.LE.8) THEN
         M = 1
      ELSE IF (NBOXES.LE.16) THEN
         M = 2
      ELSE IF (NBOXES.LE.40) THEN
         M = 5
      ELSE IF (NBOXES.LE.80) THEN
         M = 10
      ELSE IF (NBOXES.LE.160) THEN
         M = 20
      ELSE IF (NBOXES.LE.400) THEN
         M = 50
      ELSE IF (NBOXES.LE.800) THEN
         M = 100
      ELSE IF (NBOXES.LE.1600) THEN
         M = 200
      END IF
      TICLEN = (TRC(2) - BLC(2)) / TICSCL
      YTICEL = BLC(2) + TICLEN
      YTICER = TRC(2) - TICLEN
      DCY = 0.5
      DO 150 I = 0,NBOXES,M
         X = I - .5
         CALL GPOS (X, YTICER, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (X, TRC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         IF (LTYPE.GT.2) THEN
            WRITE (MSGBUF,1115) I
            CALL CHTRIM (MSGBUF, 4, MSGBUF, INCHAR)
            DCX = 0.5 - REAL(INCHAR)
            CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 150     CONTINUE
C                                       Label RHS bucket #
      X = (TRC(1) + BLC(1)) / 2.0
      CALL GPOS (X, TRC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      DCX = -5.0
      DCY = 0.5
      IF (LTYPE.GT.2) DCY = DCY + 1.333
      MSGBUF = 'Box number'
      CALL GCHAR (10, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Range =
      CALL H2CHR (8, 1, CATH(KHBUN), CTEMP)
      IF (LTYPE.LT.7) THEN
         CALL GPOS (BLC(1), BLC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         DCX = 0.0
         DCY = -2.833
         IF (LTYPE.GT.2) DCY = DCY - 1.333
         WRITE (MSGBUF,1151) RANGE(1), RANGE(2), CTEMP
         CALL REFRMT (MSGBUF, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Interval =
         CALL GPOS (BLC(1), BLC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         X = (RANGE(2) - RANGE(1)) / NBOXES
         WRITE (MSGBUF,1152) X, CTEMP
         DCY = DCY - 1.333
         CALL REFRMT (MSGBUF, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
C                                       Underflow = overflow =
         CALL GPOS (BLC(1), BLC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         I = UNDER + 0.1
         M = OVER + 0.1
         WRITE (MSGBUF,1154) I, M
         CALL REFRMT (MSGBUF, '_', INCHAR)
         DCY = DCY - 1.333
         CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
         END IF
C                                       Determine label range
      DIST = RANGE(2) - RANGE(1)
      ODIST = DIST
      CALL METSCL (LABEL, DIST, PREFIX, PFLAG)
      IF (PFLAG) GO TO 190
      XDIST = DIST / ODIST
      XMULT = XDIST
      ODIST = XDIST * RANGE(1)
      DBLC = XDIST * RANGE(1)
      DTRC = XDIST * RANGE(2)
C                                       Get interval
      DO 160 ITRY = 1,21
         DEG = XINTER(ITRY)
         DU = AINT (DTRC/DEG) * DEG
         IF (DU.GT.DTRC) DU = DU - DEG
         DL = AINT (DBLC/DEG) * DEG
         IF (DL.LT.DBLC) DL = DL + DEG
         XNOINT = AINT ((DU-DL)/DEG) + 1.001
         IF (XNOINT.LE.12.0) GO TO 170
 160     CONTINUE
      GO TO 190
C                                       Bottom (value) tics
 170  XINT = DEG
      DCY = -1.5
      XMAX = MAX (ABS(RANGE(2)), ABS(RANGE(1))) * XDIST
      INOINT = XNOINT + 2.5
      XVAL = AINT (ODIST/XINT) * XINT
      IF (XVAL.GE.ODIST) XVAL = XVAL - XINT
      DO 175 I = 1,INOINT
         XVAL = XVAL + XINT
         X = ((XVAL-ODIST)/DIST) * NBOXES
         IF (X.GT.TRC(1)) GO TO 180
         CALL GPOS (X, YTICEL, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (X, BLC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         IF (LTYPE.GT.2) THEN
            WRITE (MSGBUF,1030) XVAL
            CALL CHTRIM (MSGBUF, 14, MSGBUF, INCHAR)
            IF (ITRY.GT.3) INCHAR = INCHAR - 2
            DCX = 0.5 - INCHAR
            CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 175     CONTINUE
C                                       Label with prefix
 180  DCY = -1.5
      IF (LTYPE.GT.2) DCY = -2.833
      X = (TRC(1) + BLC(1)) / 2.0
      CALL GPOS (X, BLC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (MSGBUF,1175) PREFIX, CTEMP
      CALL CHTRIM (MSGBUF, 14, MSGBUF, INCHAR)
      DCX = 0.5 - INCHAR / 2.0
      CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (LTYPE.GE.7) GO TO 999
C                                       which axis is which?
 190  NXRA = 0
      NXDEC = 0
      NXLL = 0
      NXMM = 0
      NXFR = 0
      NXST = 0
      NAX = CATBLK(KIDIM)
      INC = 2
      DO 200 I = 1,NAX
         ICPNT = KHCTP+(I-1)*INC
         CALL H2CHR (8, 1, CATH(ICPNT), CTEMP)
         IF (CTEMP(1:4).EQ.'FREQ') NXFR  = I
         IF (CTEMP(1:4).EQ.'STOK') NXST  = I
 200     CONTINUE
C                                       Source name, stokes, freq.
      CALL GPOS (BLC(1), TRC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      DCX = 0.0
      DCY = 1.833
      IF (LTYPE.GT.2) DCY = DCY + 1.333
      IANGL = 0
      CALL H2CHR (8, 1, CATH(KHOBJ), CTEMP)
      FREQ = 0.0
      JSTOK = 12
      IF (NXFR.GT.2) FREQ = CATD(KDCRV+NXFR-1) + CATR(KRCIC+NXFR-1)
     *   * (BLC(NXFR) - CATR(KRCRP+NXFR-1))
      FREQ = FREQ / 1.E6
      IF (NXST.GT.2) JSTOK = CATD(KDCRV+NXST-1) + CATR(KRCIC+NXST-1)
     *   * (BLC(NXST) - CATR(KRCRP+NXST-1)) + 2.5
      IF (NXFR.GT.2) WRITE (MSGBUF,1200) CTEMP, CSTOK(JSTOK),
     *   FREQ
      IF (NXFR.LE.2) WRITE (MSGBUF,1200) CTEMP, CSTOK(JSTOK)
      CALL REFRMT (MSGBUF, '_', INCHAR)
C                                       image name
      INCHAR = INCHAR + 1
      IF (INCHAR.GT.1) THEN
         MSGBUF(INCHAR:INCHAR+2) = '  _'
         INCHAR = INCHAR + 3
         END IF
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), NAMSTR(1:12))
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), NAMSTR(13:18))
      CALL NAMEST (NAMSTR, CATBLK(KIIMS), MSGBUF(INCHAR:), ITMP)
      CALL REFRMT (MSGBUF, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       time/date, version
      IF (LABEL.GT.0) THEN
         CALL GPOS (BLC(1), TRC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, TIME, DATE)
         WRITE (MSGBUF,1210) IVER, DATE, TIME
         CALL REFRMT (MSGBUF, '_', INCHAR)
         DCY = DCY + 1.333
         CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, IPBLK, IERR)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (F14.1)
 1115 FORMAT (I4)
 1151 FORMAT ('Range =',1PE12.4,' to',1PE12.4,1X,A8)
 1152 FORMAT ('Interval =',1PE12.4,1X,A8)
 1154 FORMAT ('Underflow =',I10,' _Overflow =',I10)
 1175 FORMAT (A5,1X,A8)
 1200 FORMAT (A,'  _',A4,'_ ',F10.3,' MHz')
 1210 FORMAT ('Plot file version',I4,'__created ',A,A)
      END
      SUBROUTINE PWRITE (MSGLEV, TXLUN, TXFIND, TEXT)
C-----------------------------------------------------------------------
C! writes messages to log file and/or terminal and/or output file
C# Utility
C-----------------------------------------------------------------------
C   Inputs:
C      MSGLEV   I       Priority of Message (< 0 => NO MSGWRT)
C      TXFIND   I       Index in FTAB for LUN
C      TEXT     C*(*)   Message
C   In/out:
C      TXLUN    I       Logical unit number (0 IN => no file)
C                          0 out => error
C-----------------------------------------------------------------------
      INTEGER   MSGLEV, TXLUN, TXFIND
      CHARACTER TEXT*(*)
C
      INTEGER   IERR, TXLEN, JTRIM
      INCLUDE 'INCS:DMSG.INC'
C----------------------------------------------------------------------
      IF (MSGLEV.GE.0) THEN
         MSGTXT = TEXT
         CALL MSGWRT (MSGLEV)
         END IF
C                                       If output file opened
C                                       Log Informative Messages
      IF (TXLUN.GT.0) THEN
         TXLEN = JTRIM (TEXT)
         CALL ZTXIO ('WRIT', TXLUN, TXFIND, TEXT(1:TXLEN), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) TXLUN, IERR
            CALL MSGWRT (7)
            CALL ZTXCLS (TXLUN, TXFIND, IERR)
            TXLUN = 0
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OUTFILE WRITE ERROR ON LUN=',I5,', ERR=',I5)
      END
      SUBROUTINE XGALMS (M, N, X, FVEC, FJAC, LDFJAC, TOL, INFO,
     *   IPVT)
C-----------------------------------------------------------------------
C   XGALMS provides an extra interface to the math routine LMSTR1
C   and holds the WORK array (for overlay purposes)
C   Inputs: M      I       Number data points (adj. array dim.)
C           N      I       Number of unknowns (adj. array dim.)
C           LDFJAC I       Number points on first axis of FJAC (adj.
C                          array dim.)
C           TOL    D       Tolerance desired
C   In/out: X      D(N)    Initial guess/ answer
C           FVEC   D(M)    Function (Data - model) evaluation
C           FJAC   D(N,N)
C           INFO   I       Error code: 1 - 3 good, 0 bad input,
C                             4 orthogonal, 5 - 7 poor fit
C           IPVT   D(N)
C   See precursor remarks to LMSTR1 or LMSTR for details.
C-----------------------------------------------------------------------
      EXTERNAL  XGFUNC
      INTEGER   M, N, LDFJAC, LWA
      INTEGER   INFO, IPVT(N)
      DOUBLE PRECISION    TOL, X(M), FVEC(M), FJAC(N,N), WA(920)
      DATA LWA /920/
C-----------------------------------------------------------------------
C                                       It's just a dummy routine
      CALL LMSTR1 (XGFUNC, M, N, X, FVEC, FJAC, LDFJAC, TOL, INFO, IPVT,
     *   WA, LWA)
C
 999  RETURN
      END
      SUBROUTINE XGFUNC (M, N, PARMS, FVEC, FJROW, IFLAG)
C-----------------------------------------------------------------------
C   This routine is called by the Argonne package to calculate the
C   difference between the current fit and the actual data OR the
C   Jacobian for this difference.
C     INPUTS:  M        I   Number of data points in slice (adj. array
C                           dim.).
C              N        I   No. of parameters (adj. array dim.;
C                           NGAUSS * 3)
C              PARMS    D(N)   parameters of gaussian components,
C                       GMAX(1), GPOS(1), GWIDTH(1), GMAX(2), ...
C              IFLAG    I   1=calculate difference for current guess.
C                           2=calculate jacobian for current guess.
C    COMMON:   GDATA
C              DATA     R(?)   Origional slice data points.
C              IDOPOS   I(4)   -1 means hold corresponding position
C                       parameter constant.
C              IDOMAX   I(4)   -1 means hold corresponding maximum
C                       amplitude parameter constant.
C              IDOWTH   I(4)   -1 means hold corresponding half
C                       width parameter constant.
C              ITTER    I   number of calls to evaluate FVEC.
C    OUTPUTS:  FVEC     D(M)   Slice data points minus data points
C                       evaluated for current guess.
C              FJROW    D(N)   Row (IFLAG - 1) of Jacobian.
C-----------------------------------------------------------------------
      INTEGER   N, M
      DOUBLE PRECISION    PARMS(N), FVEC(M), FJROW(N), AMP,
     *   POS, SIG, EFACT, RES2, TSIG2, X, HALFAC
      INTEGER   IFLAG, IDATA
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'GDATA.INC'
      DATA HALFAC /2.77258872D0/
C-----------------------------------------------------------------------
C                                       Determine difference between
C                                       data and current fit.
      IF (IFLAG.LE.1) THEN
         ITTER = ITTER + 1
         IF (ITTER.GT.NITTER) THEN
            IFLAG = -1
         ELSE
            DO 20 IDATA = 1,M
               FVEC(IDATA) = DATA(IDATA)
               IF (FVEC(IDATA).EQ.FBLANK) THEN
                  FVEC(IDATA) = 0.0D0
               ELSE
                  X = IDATA
                  AMP = PARMS(1)
                  IF (AMP.NE.0.0D0) THEN
                     POS = PARMS(2)
                     SIG = PARMS(3)
                     RES2 = (X - POS) / SIG
                     RES2 = HALFAC * RES2 * RES2
                     IF (RES2.LE.69.0D0) FVEC(IDATA) = FVEC(IDATA) -
     *                  AMP * EXP (-RES2)
                     END IF
                  END IF
   20          CONTINUE
            END IF
C                                       Calculate Jacobian.
      ELSE
         IDATA = IFLAG - 1
         X = IDATA
         FJROW(1) = 0.0D0
         FJROW(2) = 0.0D0
         FJROW(3) = 0.0D0
         AMP = PARMS(1)
         POS = PARMS(2)
         SIG = PARMS(3)
         RES2 = HALFAC * (X - POS) * (X - POS)
         TSIG2 = RES2 / (SIG * SIG)
         IF (TSIG2.LE.69.0D0) THEN
            EFACT = -EXP (-TSIG2)
            FJROW(1) = EFACT
            EFACT = 2.0D0 * EFACT * AMP / (SIG * SIG)
            FJROW(2) = HALFAC * EFACT * (X-POS)
            FJROW(3) = EFACT * RES2 / SIG
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE ROBGET (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C   Robust mean and rms of a reasonable portion of the image
C   Inputs:
C      LUN    I   LUN of open image
C      FIND   I   FTAB pointer of open file
C   Outputs:
C      IERR   I   Error code
C      PIXAVG, PIXRMS returned in common
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
C
      INTEGER   NWORDS, I, J
      LOGICAL   DOINV
      REAL      IMAGE(2), LBLC(7), LTRC(7), PIXVS(2)
      LONGINT   PIMAGE
      DOUBLE PRECISION XVAL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'IMEAN.INC'
      EQUIVALENCE (PIXVS, PIXAVG)
C-----------------------------------------------------------------------
C                                       local window
      DOINV = DINVER.GT.0.0
      IF (DOINV) THEN
         CALL RFILL (7, 0.0, LBLC)
         CALL RFILL (7, 0.0, LTRC)
      ELSE
         CALL RCOPY (7, BLC, LBLC)
         CALL RCOPY (7, TRC, LTRC)
         END IF
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), LBLC, LTRC, IERR)
      J = 8
 10   XVAL = 1.0D-3
      DO 20 I = 1,7
         XVAL = XVAL * (LTRC(I) - LBLC(I) + 1.0D0)
 20      CONTINUE
      IF ((XVAL.GT.KAPWRD) .AND. (J.GT.3)) THEN
         J = J - 1
         LTRC(J) = 1.0
         LBLC(J) = 1.0
         GO TO 10
         END IF
      IF (J.LT.8) THEN
         MSGTXT = 'ROBGET: guess of true mean and rms from sub-image'
     *      // ' only'
         CALL MSGWRT (6)
         END IF
      NWORDS = XVAL * 1.D3 + 2048.1
      NWORDS = (NWORDS - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', 'ROBGET', NWORDS, IMAGE, PIMAGE, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'ROBGET: COULD NOT GET DYNAMIC MEMORY'
         CALL MSGWRT (7)
         GO TO 999
         END IF
      CALL DOROB (LUN, FIND, LBLC, LTRC, DOINV, BLC, TRC, DOALL,
     *   IMAGE(1+PIMAGE), PIXVS, IERR)
      CALL ZMEMRY ('FREE', 'ROBGET', NWORDS, IMAGE, PIMAGE, I)
C
 999  RETURN
      END
      SUBROUTINE DOROB (LUN, FIND, LBLC, LTRC, DOINV, BLC, TRC, DOALL,
     *   IMAGE, PIXV, IERR)
C-----------------------------------------------------------------------
C   DOROB actually does the robust rms and mean
C   Inputs:
C      LUN    I      LUN of open image
C      FIND   I      FTAB pointer of open file
C      LBLC   R(7)   bottom left corner
C      LTRC   R(7)   top right corner
C      DOINV  L      do outside only
C      BLC    R(7)   inner region blc
C      TRC    R(7)   inner region trc
C      DOALL  R      >0 include pure zero
C   Outputs:
C      IMAGE  R(*)   work space
C      PIXV   R(2)   mean, rms
C      IERR   I      error code
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
      REAL      LBLC(7), LTRC(7), IMAGE(*), BLC(7), TRC(7), PIXV(2),
     *   DOALL
      LOGICAL   DOINV
C
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   NITER
      PARAMETER (NITER=8)
C
      INTEGER   I2, I3, I4, I5, I6, I7, L1, L2, L3, L4, L5, L6, L7, IT,
     *   U1, U2, U3, U4, U5, U6, U7, NP, IP, NX, NY, NBUF, BLKOF, BIND,
     *   WIN(4), DEPTH(5), NBL, IBL
      REAL      BUFF(MABFSS), WS(NITER), VP, VM
      DOUBLE PRECISION SV, SSV, NV
      LOGICAL   DOIT, YDOIT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA WS /5.0, 4.0, 3.5, 3.0, 2.7, 2.6, 2.5, 3.5/
C-----------------------------------------------------------------------
      L1 = LBLC(1) + 0.1
      L2 = LBLC(2) + 0.1
      L3 = LBLC(3) + 0.1
      L4 = LBLC(4) + 0.1
      L5 = LBLC(5) + 0.1
      L6 = LBLC(6) + 0.1
      L7 = LBLC(7) + 0.1
      U1 = LTRC(1) + 0.1
      U2 = LTRC(2) + 0.1
      U3 = LTRC(3) + 0.1
      U4 = LTRC(4) + 0.1
      U5 = LTRC(5) + 0.1
      U6 = LTRC(6) + 0.1
      U7 = LTRC(7) + 0.1
      NX = U1 - L1 + 1
      NY = U2 - L2 + 1
      WIN(1) = L1
      WIN(2) = L2
      WIN(3) = U1
      WIN(4) = U2
      NBUF = MABFSS * 2
      IP = 1
      NBL = TRC(1) - BLC(1)  + 1.01
      IBL = BLC(1) - 0.1
C                                       read in data
      DO 90 I7 = L7,U7
         DO 80 I6 = L6,U6
            DO 70 I5 = L5,U5
               DO 60 I4 = L4,U4
                  DO 50 I3 = L3,U3
                     DOIT = ((I7.GE.BLC(7)) .AND. (I7.LE.TRC(7))
     *                  .AND. (I6.GE.BLC(6)) .AND. (I6.LE.TRC(6))
     *                  .AND. (I5.GE.BLC(5)) .AND. (I5.LE.TRC(5))
     *                  .AND. (I4.GE.BLC(4)) .AND. (I4.LE.TRC(4))
     *                  .AND. (I3.GE.BLC(3)) .AND. (I3.LE.TRC(3)))
                     DEPTH(1) = I3
                     DEPTH(2) = I4
                     DEPTH(3) = I5
                     DEPTH(4) = I6
                     DEPTH(5) = I7
                     CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), DEPTH,
     *                  BLKOF, IERR)
                     BLKOF = BLKOF + 1
C                                       Initialize for read:
                     CALL MINIT ('READ', LUN, FIND, CATBLK(KINAX),
     *                  CATBLK(KINAX+1), WIN, BUFF, NBUF, BLKOF, IERR)
                     IF (IERR.NE.0) THEN
                        WRITE (MSGTXT,1000) IERR, 'INIT IMAGE I/O'
                        GO TO 990
                        END IF
                     DO 40 I2 = L2,U2
                        YDOIT = DOIT .AND. (I2.GE.BLC(2)) .AND.
     *                     (I2.LE.TRC(2)) .AND. (DOINV)
C                                       Read next row:
                        CALL MDISK ('READ', LUN, FIND, BUFF, BIND, IERR)
                        IF (IERR.NE.0) THEN
                           WRITE (MSGTXT,1000) IERR, 'READ IMAGE ROW'
                           GO TO 990
                           END IF
                        CALL RCOPY (NX, BUFF(BIND), IMAGE(IP))
                        IF (YDOIT) CALL RFILL (NBL, FBLANK,
     *                     IMAGE(IP+IBL))
                        IP = IP + NX
 40                     CONTINUE
 50                  CONTINUE
 60               CONTINUE
 70            CONTINUE
 80         CONTINUE
 90      CONTINUE
      NP = IP - 1
C                                       ROBUST mean, rms
      VP = 1.E5
      VM = -VP
      DO 120 IT = 1,NITER
         SV = 0.0D0
         SSV = 0.0D0
         NV = 0.0D0
         DO 110 IP = 1,NP
            IF ((IMAGE(IP).NE.FBLANK) .AND. ((IMAGE(IP).NE.0.0) .OR.
     *         (DOALL.GT.0.0))) THEN
               IF ((IMAGE(IP).GT.VM) .AND. (IMAGE(IP).LT.VP)) THEN
                  SV = SV + IMAGE(IP)
                  SSV = SSV + IMAGE(IP) * IMAGE(IP)
                  NV = NV + 1.0D0
                  END IF
               END IF
 110        CONTINUE
         IF (NV.GT.0.0D0) THEN
            SV = SV / NV
            SSV = SSV / NV - SV * SV
            SSV = SQRT (MAX (0.0D0, SSV))
            IF (IT.LT.NITER) THEN
               VP = SV + WS(IT+1) * SSV
               VM = SV - WS(IT+1) * SSV
               END IF
         ELSE
            VP = 1.E4
            VM = -1.E4
            END IF
 120     CONTINUE
C                                       return answers
      PIXV(1) = SV
      PIXV(2) = SSV
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DOROB: ERROR',I5,' ON ',A)
      END

      SUBROUTINE UVINCS( INCS, INCF, INCIF, NRPARM, LREC, JNCS, JNCF, 
     *   LRPARM, LLREC)
C-----------------------------------------------------------------------
C! Calculates correlator and visibility length for expanded UV data
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C UV INCrementS: Return Increments in visibility records for 
C un-compressed UV data.
C Inputs:
C  INCS       I     Length of compressed or un-compressed stokes 
C  INCF       I     Length of compressed or un-compressed Frequency group
C  INCIF      I     Length of compressed or un-compressed IF group
C  NRPARM     I     Length of compressed or un-compressed random parms.
C  LREC       I     Length of compressed or un-compressed Visibility
C Output:
C  JNCS       I     Length of un-compressed stokes 
C  JNCF       I     Length of un-compressed frequency group
C  LRPARM     I     Length of un-compressed random parameter (reals)
C  LLREC      I     Length of un-compressed Visibility
C-----------------------------------------------------------------------
      INTEGER INCS, INCF, INCIF, NRPARM, LREC, JNCS, JNCF, LRPARM, LLREC
C-----------------------------------------------------------------------
      LOGICAL ONZE
      INCLUDE 'INCS:DMSG.INC'
      SAVE    ONZE
      DATA    ONZE/.FALSE./
C-----------------------------------------------------------------------
C                                       Assume Uncompressed Visibility 
      JNCS = INCS
      JNCF = INCF
C                                       If IF changes more rapidly 
C                                       than FREQ use IF for frequency 
      IF ((INCIF.GT.0) .AND. (INCIF.LT.INCF)) JNCF = INCIF
C                                       IF compressed data, prepare
      IF (JNCS.EQ.1) THEN
C                                       Compressed has 2 more Random Par
C                                       than Un-comp. (Weight and Scale)
         LRPARM = NRPARM - 2
C                                       Un-comp. Stokes increment is 3
         JNCS = 3
C                                       Increment between Frequencies
         JNCF = JNCF * JNCS
C                                       LLREC is expanded vis length
C                                       Compressed: 1 real per stokes
C                                       Normal: 3 real per stokes
         LLREC  = ((LREC - NRPARM) * 3) + LRPARM
C                                       Tell User Once
         IF (.NOT. ONZE) THEN
            MSGTXT = 'Processing Compressed Data'
            CALL MSGWRT(3)
            ONZE = .TRUE.
            END IF
      ELSE
C                                       Else uncompressed, same value
         LLREC  = LREC
         LRPARM = NRPARM
         END IF
      RETURN
C-----------------------------------------------------------------------
      END

      PROGRAM BATER
C-----------------------------------------------------------------------
C! BATER is stand-alone task to prepare and submit text to batch AIPS
C# Service Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2003, 2010, 2013, 2021-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BATER is a stand-alone AIPS-like program used to prepare and
C   submit text to batch AIPS.
C   It uses NPOPS = NINTRN  +  1.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   IERR
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DIO.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DBAT.INC'
      INCLUDE 'INCS:DBWT.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DSMS.INC'
      INCLUDE 'INCS:DBCR.INC'
      DATA PRGNAM /'BATER '/
C-----------------------------------------------------------------------
      TSKNAM = PRGNAM
      CALL ZDCHIN (.TRUE.)
      CALL ZMYVER
      ISBTCH = 0
      NPOPS = NINTRN + 1
      WASERR = .TRUE.
C                                       init commons
      CALL BATINI (IERR)
      IF (IERR.NE.0) GO TO 999
C                                       process input until error
 20   CALL BATGTL
      IF (ERRNUM.GT.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         CALL OERROR
         IUNIT = 1
         END IF
C                                       loop all errors except EXIT
      IF (ERRNUM.NE.-2) GO TO 20
C                                       EXIT
      WRITE (MSGTXT,1030)
      CALL MSGWRT (1)
      CALL ACOUNT (2)
C
 999  STOP
C-----------------------------------------------------------------------
 1030 FORMAT ('wishes you a good day')
      END
      SUBROUTINE BATGTL
C-----------------------------------------------------------------------
C   BATGTL is the main routine of BATER.  It reads input via PREAD,
C   parses it via BATPOL, and executes it via BATINT.  Returns only
C   on error.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DSMS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DIO.INC'
      DATA PRGNAM /'BATGTL'/
C-----------------------------------------------------------------------
C                                        get line
 10   CALL PREAD (KARBUF)
      IF (ERRNUM.EQ.0) THEN
         AP = 0
         SP = 0
         MSGTXT = JBUFF(:80)
         IF (NBYTES.GT.80) THEN
            MSGTXT = JBUFF(:64)
            CALL MSGWRT (0)
            MSGTXT = JBUFF(65:)
            END IF
         CALL MSGWRT (0)
         IF (KARBUF(1:1).EQ.'*') GO TO 10
         KBPTR = 1
         CALL BATPOL
         IF (ERRNUM.EQ.0) THEN
            CALL BATINT
            IF (ERRNUM.EQ.0) GO TO 10
            END IF
         END IF
C                                        error
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
      END
      SUBROUTINE BATINI (IRET)
C-----------------------------------------------------------------------
C   BATINI initializes commons for BATER
C-----------------------------------------------------------------------
      INTEGER   NSYMS
      PARAMETER (NSYMS=32)
      CHARACTER PHNAME*48, SYMBLS(NSYMS)*8
      INTEGER   LUNCRT, IF, IERR, LCOUNT(NSYMS), LTYPE(NSYMS), I, IRET
      LOGICAL   T, F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DIO.INC'
      INCLUDE 'INCS:DBCR.INC'
      INCLUDE 'INCS:DBAT.INC'
      INCLUDE 'INCS:DRUN.INC'
      DATA LUNCRT / 5/
      DATA T, F /.TRUE.,.FALSE./
      DATA SYMBLS / 'SUBMIT  ', 'BATCH   ', 'BATEDIT ', 'UNQUE   ',
     *              'BATCLEAR', 'BATLIST ', 'QUEUES  ', 'JOBLIST ',
     *              'BAMODIFY', 'INPUTS  ', 'CLRMSG  ', 'PRTMSG  ',
     *              'EXIT    ', 'HELP    ', '        ', '        ',
     *              '        ', '        ', '        ', 'DOCRT   ',
     *              'PRIORITY', 'PRNUMBER', 'PRTIME  ', 'PRTASK  ',
     *              'OUTPRINT', 'DETIME  ', 'BATQUE  ', 'JOBNUM  ',
     *              'BATFLINE', 'BATNLINE', 'REMHOST ', 'REMQUE  '/
      DATA LCOUNT / 6, 5, 7, 5, 8, 7, 6, 7, 8, 6,
     *              6, 6, 4, 4, 0, 0, 0, 0, 0, 5,
     *              8, 8, 6, 6, 8, 6, 6, 6, 8, 8, 7, 6/
      DATA LTYPE  / 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
     *              4, 4, 4, 4, 0, 0, 0, 0, 0, 1,
     *              1, 1, 1, 7, 7, 1, 1, 1, 1, 1, 7, 1/
C-----------------------------------------------------------------------
C                                        POPS controls pointers
      IUNIT = 1
      KARLIM = NCHLIN
      SLIM = 1000
      IDEBUG = 0
      MODE = 0
      IPT = '>'
      NUMRUN = 0
      CALL FILL (MAXRUN, 0, LUNRUN)
C                                        error com
      ERRNUM = 0
      ERRLEV = 0
C                                        message common
      MSGCNT = -1
      CALL ZOPEN (LUNCRT, IF, 1, PHNAME, F, T, T, IERR)
      CALL RDUSER (BATDAT, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL ACOUNT (1)
      CALL ZCLOSE (LUNCRT, IF, IERR)
      CALL CATCR (0, 0, BATDAT, IERR)
C                                        symbol table
      NKSYM = NSYMS
      DO 10 I = 1, NKSYM
         KSYM(I) = SYMBLS(I)
 10      CONTINUE
      CALL COPY (NKSYM, LCOUNT, KCOUNT)
      CALL COPY (NKSYM, LTYPE, KTYP)
      CALL RFILL (NKSYM, 0.0, KVALUE)
      KVALUE(20) = -1.0
C                                        strings: 100*addr + nchar
      KVALUE(24) =  105.
      KVALUE(25) =  248.
      KVALUE(31) =  324.
      NKSTR = NSYMS
      DO 20 I = 1,NKSTR
         KSTRNG(I) = ' '
 20      CONTINUE
      KSTRNG(1) = TSKNAM
C                                        stacks used
      AP = 0
      SP = 0
      CALL FILL (60, 0, CSTACK)
      CALL FILL (60, 0, STACK)
C                                       User instructions
      WRITE (MSGTXT,1010)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1011)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1012)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1013)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1014)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1015)
      CALL MSGWRT (1)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('Hello.  I am a stand-alone program somewhat like AIPS.')
 1011 FORMAT ('However, my vocabulary is limited to verbs and adverbs')
 1012 FORMAT ('related to Batch jobs.  I can take more than one comma',
     *   'nd in a')
 1013 FORMAT ('line and do use min match.  Issue the command INPUTS')
 1014 FORMAT ('for a list of my full vocabulary and current adverb',
     *   ' values.')
 1015 FORMAT ('Have fun!')
      END
      SUBROUTINE BATINT
C-----------------------------------------------------------------------
C   BATINT interprets the stacks prepared by BATPOL.  It executes
C   =, EXIT, INPUTS, and HELP and calls PRTMSG, CUA, and CUB to do the
C   other verbs.
C-----------------------------------------------------------------------
      CHARACTER OP*4, IPRTSK*8, PHNAME*48, PRGNAM*6, PRTASK*6,
     *   LVERS*48, LPNAME*48, RHOST*24
      INTEGER   POTERR, J, NEXIT, NSUBM, NBATCH, NPRINT, NJOBL, I,
     *   NHELP, J1, J2, IUSER, NDONE, NLEFT, IERR, IROUND, NINPU,
     *   HLPLUN, FIND, NCLRM, IPOPS
      REAL      DOCRT, PRIOTY, DTIME, PRTIME, PRNUMB, LSIGN
      LOGICAL   EQUAL, F
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DBCR.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (DOCRT,  KVALUE(20)),   (PRIOTY, KVALUE(21)),
     *            (PRNUMB, KVALUE(22)),   (PRTIME, KVALUE(23))
      EQUIVALENCE (PRTASK, KSTRNG(1)),    (LPNAME, KSTRNG(2)),
     *            (RHOST, KSTRNG(3))
      DATA NSUBM, NBATCH, NJOBL, NINPU, NHELP, NEXIT, NPRINT, NCLRM
     *    /1,2,9, 10,14, 13,12,11/
      DATA PRGNAM /'BATINT'/
      DATA F /.FALSE./
      DATA HLPLUN /11/
C-----------------------------------------------------------------------
C                                        jump pointer, identify op
 10   SP = SP + 1
      IF (SP.GT.AP) GO TO 999
         POTERR = 8
         IF (CSTACK(SP).EQ.1) GO TO 20
         IF (CSTACK(SP).EQ.7) GO TO 25
         IF (CSTACK(SP).EQ.4) GO TO 30
         GO TO 980
C-----------------------------------------------------------------------
C                                        adverbs: reals
 20   IF (SP+1.GT.AP) GO TO 980
C                                        next must be =
C                                        adverb/const after that
         I = CSTACK(SP+1)
         J = STACK(SP)
         LSIGN = 1.0
C                                        unary plus or minus
         IF (I.NE.3) GO TO 23
            SP = SP + 1
            LSIGN = V(SP)
            IF (SP+1.GT.AP) GO TO 980
            I = CSTACK(SP+1)
 23      IF ((I.NE.1) .AND. (I.NE.11)) GO TO 980
            IF (I.EQ.11) KVALUE(J) = LSIGN * V(SP+1)
            IF (I.EQ.1)  KVALUE(J) = LSIGN * KVALUE(STACK(SP+1))
            SP = SP + 1
            GO TO 10
C                                        char const after that
 25   IF (SP+1.GT.AP) GO TO 980
         I = CSTACK(SP+1)
         IF ((I.NE.7) .AND. (I.NE.14)) GO TO 980
            J = STACK(SP)
            J1 = MOD (KVALUE(J), 100.0) + 0.01
            J2 = (KVALUE(J) - J1) / 100.0 + 0.01
            KSTRNG(J2) = ' '
C                                       constant
            IF (I.EQ.7) GO TO 27
               I = MIN (STACK(SP+1), J1)
               CALL H2CHR (I, 1, V(SP+1), KSTRNG(J2))
               SP = SP + (STACK(SP+1) + 3) / 4
               GO TO 10
C                                       adverb
 27         CONTINUE
               I = KVALUE(STACK(SP+1)) + 0.01
               J = I / 100
               I = I - 100 * J
               I = MIN (I, J1)
               KSTRNG(J2)(1:I) = KSTRNG(J)(1:I)
               SP = SP + 1
               GO TO 10
C-----------------------------------------------------------------------
C                                        verbs
 30   IF (STACK(SP).GT.NKSYM) GO TO 980
      J = STACK(SP)
C                                        submit
      IF (J.EQ.NSUBM) THEN
         I = 1
         CALL CUA (I)
         IF (ERRNUM.NE.0) GO TO 980
         GO TO 10
         END IF
C                                        work file ops
      IF ((J.GE.NBATCH) .AND. (J.LE.NJOBL)) THEN
         I = J - NBATCH + 1
         CALL CUB (I)
         IF (ERRNUM.NE.0) GO TO 980
C                                        force pseudoverb on BATCH,EDIT
         IF (J.LE.NBATCH+1) GO TO 999
         GO TO 10
         END IF
C                                        Inputs
      IF (J.EQ.NINPU) THEN
         WRITE (MSGTXT,1045)
         CALL MSGWRT (1)
         DO 50 I = 1,NKSYM
            IF ((KTYP(I).NE.1) .AND. (KTYP(I).NE.4) .AND.
     *         (KTYP(I).NE.7)) GO TO 50
            IF (KTYP(I).EQ.1) WRITE (MSGTXT,1046) KSYM(I), KVALUE(I)
            IF (KTYP(I).EQ.4) WRITE (MSGTXT,1047) KSYM(I)
            IF (KTYP(I).EQ.7) THEN
               WRITE (MSGTXT,1048) KSYM(I)
               J1 = MOD (KVALUE(I), 100.0) + 0.01
               J2 = (KVALUE(I) - J1) / 100.0 + 0.01
               J = 19
               MSGTXT(J:J+J1-1) = KSTRNG(J2)(1:J1)
               J = J + J1
               MSGTXT(J:J) = ''''
               END IF
            CALL MSGWRT (1)
 50         CONTINUE
         GO TO 10
         END IF
C                                        help
      IF (J.EQ.NHELP) THEN
C                                        get desired help name
         I = 0
         SP = SP + 1
         IF (SP.LE.AP) I = STACK(SP)
         IF (I.LE.0) IPRTSK = TSKNAM
         IF (I.GT.0) IPRTSK = KSYM(I)
         CALL ZPHFIL ('HE', 1, 0, 0, PHNAME, IERR)
         LVERS = 'NEW'
         CALL ZTOPEN (HLPLUN, FIND, 1, PHNAME, IPRTSK, LVERS, F, IERR)
         POTERR = 31
         IF (IERR.NE.0) GO TO 980
C                                       skip inputs
 60      CALL ZTREAD (HLPLUN, FIND, MSGTXT, IERR)
            IF (IERR.EQ.2) GO TO 70
            IF (IERR.NE.0) GO TO 75
            EQUAL = MSGTXT(1:4) .EQ. '----'
            IF (.NOT.EQUAL) GO TO 60
 65      CALL ZTREAD (HLPLUN, FIND, MSGTXT, IERR)
            IF (IERR.EQ.2) GO TO 70
            IF (IERR.NE.0) GO TO 75
            IF (MSGTXT(1:1).EQ.';') GO TO 65
            EQUAL = MSGTXT(1:4) .EQ. '----'
            IF (EQUAL) GO TO 70
               CALL MSGWRT (1)
               GO TO 65
 70      CALL ZTCLOS (HLPLUN, FIND, IERR)
         GO TO 10
 75      CALL ZTCLOS (HLPLUN, FIND, IERR)
         POTERR = 50
         GO TO 980
         END IF
C                                        message print and exit
      IF ((J.LT.NCLRM) .OR. (J.GT.NEXIT)) GO TO 10
         I = PRIOTY + 0.1
         IUSER = NLUSER
         OP = 'DELE'
         IF (J.EQ.NPRINT) OP = 'PRIN'
         DTIME = PRTIME
         IF (J.EQ.NEXIT) DTIME = 3.0
         IPOPS = IROUND (PRNUMB)
         IF (IPOPS.EQ.0) IPOPS = NPOPS
         IF (IPOPS.LT.0) IPOPS = 0
         IPRTSK = PRTASK
         IF (J.NE.NEXIT) CALL PRTMSG (OP, IUSER, IPOPS, I, IPRTSK,
     *      DTIME, DOCRT, LPNAME, NDONE, NLEFT, IERR)
         IF (J.EQ.NEXIT) CALL PRTMSG (OP, IUSER, 0, 0, '      ',
     *      DTIME, DOCRT, LPNAME, NDONE, NLEFT, IERR)
         IF ((ERRNUM.NE.0) .AND. (J.EQ.NEXIT)) ERRNUM = -2
         IF (ERRNUM.NE.0) GO TO 980
         IF (J.EQ.NPRINT) WRITE (MSGTXT,1080) NDONE
         IF (J.NE.NPRINT) WRITE (MSGTXT,1081) NDONE
         IF (NDONE.GT.0) CALL MSGWRT (1)
         IF (J.NE.NEXIT) GO TO 10
            POTERR = -2
            GO TO 980
C-----------------------------------------------------------------------
C                                        errors
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
C-----------------------------------------------------------------------
 1045 FORMAT ('Name',7X,'Type',3X,'Value')
 1046 FORMAT (A8,2X,'Adverb',F7.1)
 1047 FORMAT (A8,3X,'Verb')
 1048 FORMAT (A8,2X,'Adverb ''')
 1080 FORMAT ('Printed',I7,' messages')
 1081 FORMAT ('Deleted',I7,' messages')
      END
      SUBROUTINE BATPOL
C-----------------------------------------------------------------------
C   BATPOL is a simplified parser/compiler used by BATER.  It
C   converts text in KARBUF to type, and tag stacks in CSTACK and
C   STACK, resp. with AP pointing at the last entry.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6, M*1, KPAC*48
      INTEGER   POTERR, J, NIPL, ICL, IPL(20), J1, I, NHELP, NINPU
      LOGICAL   FLAG
      DOUBLE PRECISION    DBLX
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSMS.INC'
      INCLUDE 'INCS:DIO.INC'
      INCLUDE 'INCS:DBCR.INC'
      INCLUDE 'INCS:DPOP.INC'
      DATA PRGNAM, NHELP, NINPU /'BATPOL', 14,10/
C-----------------------------------------------------------------------
 5    NKAR = 0
C                                        skip leading blanks
 10   IF (KBPTR.GT.KARLIM) GO TO 70
         M = KARBUF(KBPTR:KBPTR)
         IF (M.NE.' ') GO TO 20
         KBPTR = KBPTR + 1
         GO TO 10
C                                        classify by first character
 20   IF (M.EQ.';') GO TO 70
      IF (M.EQ.'=') GO TO 60
      IF (M.EQ.'''') GO TO 80
      IF (M.EQ.'+') GO TO 90
      IF (M.EQ.'-') GO TO 90
      IF (M.EQ.'.') GO TO 50
      IF ((M.GE.'A') .AND. (M.LE.'Z')) GO TO 30
      IF ((M.GE.'a') .AND. (M.LE.'z')) GO TO 30
      IF ((M.GE.'0') .AND. (M.LE.'9')) GO TO 50
      POTERR = 8
      GO TO 980
C                                        symbol: find end
 30   J = KBPTR
 35   NKAR = NKAR + 1
         J = J + 1
         POTERR = 4
         IF (J.GT.KARLIM) GO TO 980
         M = KARBUF(J:J)
         IF ((M.GE.'A') .AND. (M.LE.'Z')) GO TO 35
         IF ((M.GE.'a') .AND. (M.LE.'z')) GO TO 35
         IF (M.EQ.'_') GO TO 35
         IF ((M.GE.'0') .AND. (M.LE.'9')) GO TO 35
      POTERR = 5
      IF (NKAR.GT.8) GO TO 980
      KPAC = KARBUF(KBPTR:KBPTR+NKAR-1)
      KBPTR = KBPTR + NKAR
      CALL CHLTOU (NKAR, KPAC)
C                                        locate in table
C                                        use min. match
      NIPL = 0
      DO 40 I = 1,NKSYM
         IF (NKAR.GT.KCOUNT(I)) GO TO 40
            DO 38 ICL = 1,NKAR
               FLAG = KSYM(I)(ICL:ICL) .EQ. KPAC(ICL:ICL)
               IF (.NOT.FLAG) GO TO 40
 38            CONTINUE
            IF (NKAR.EQ.KCOUNT(I)) GO TO 45
               NIPL = NIPL + 1
               IPL(NIPL) = I
 40      CONTINUE
      POTERR = 2
      IF (NIPL.EQ.0) GO TO 980
      IF (NIPL.GT.1) GO TO 900
      I = IPL(1)
C                                        put in stack
 45   AP = AP + 1
      CSTACK(AP) = KTYP(I)
      STACK(AP) = I
      V(AP) = KVALUE(I)
      GO TO 5
C                                        numeric field: get value
 50   AP = AP + 1
      CSTACK(AP) = 11
      STACK(AP) = NKSYM + 2
      CALL GETNUM (KARBUF, KARLIM, KBPTR, DBLX)
      IF (ERRNUM.NE.0) GO TO 980
      V(AP) = DBLX
      GO TO 5
C                                        = op: not on stack
 60   POTERR = 8
      IF ((CSTACK(AP).NE.1) .AND. (CSTACK(AP).NE.7)) GO TO 980
      KBPTR = KBPTR + 1
      GO TO 5
C                                        ; ignored
 70   KBPTR = KBPTR + 1
C                                        HELP HELP or no arg
      IF (STACK(AP).NE.NHELP) GO TO 75
         IF ((AP.GT.1) .AND. (STACK(AP-1).NE.NHELP)) AP = AP + 1
         IF (AP.EQ.1) AP = 2
         STACK(AP) = 0
         IF (KBPTR.GT.KARLIM) GO TO 999
         GO TO 5
C                                        HELP INPUTS
 75   IF ((STACK(AP).EQ.NINPU) .AND. (AP.GT.1) .AND.
     *   (STACK(AP-1).EQ.NHELP)) STACK(AP) = 0
      IF (KBPTR.GT.KARLIM) GO TO 999
      GO TO 5
C                                        Character string
 80   AP = AP + 1
      CSTACK(AP) = 14
      CALL GETSTR (KARBUF, KARLIM, 48, KBPTR, KPAC, NKAR)
      CALL CHR2H (NKAR, KPAC, 1, V(AP))
      STACK(AP) = NKAR
      AP = AP + (NKAR-1)/4
      GO TO 5
C                                        unary plus, minus
 90   AP = AP + 1
      CSTACK(AP) = 3
      V(AP) = 1.0
      IF (M.EQ.'-') V(AP) = -1.0
      KBPTR = KBPTR + 1
      GO TO 5
C                                        errors
C                                        multi-match
 900  DO 910 I = 1,NIPL
         J1 = 2 * IPL(I) - 1
         WRITE (MSGTXT,1900) KSYM(J1)
         CALL MSGWRT (1)
 910     CONTINUE
C                                        set branch back to OERROR
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('SYMBOL NOT UNIQUE COULD BE ',A8)
      END
      SUBROUTINE CUA (BRANCH)
C-----------------------------------------------------------------------
C   CUA handles activating batch checker task (AIPSCCn)
C   This version of AUA has small symbol table.
C   Input: BRANCH = 1 activate AIPSn
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      CHARACTER PRGNAM*6, CTASK*8, ANAME*8, VERSON*48, PHNAME*48,
     *   RHOST*24
      INTEGER   POTERR, FINDTD, FINDTT, LUNTTY, IPRBUF(256), IERR,
     *   IRETCD, J, LUNTD, NBLOCK, ITEMP, PID(4), IPTR, JOFF
      REAL      PARBUF(128), EPS, TDL, DOWAIT, BATQUE, JOBNUM, BTFLIN,
     *   BTNLIN, DETIME, REMQUE
      LOGICAL   T, F, ACTIVE, LDOWT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DBCR.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (IPRBUF(1), PARBUF(1))
      EQUIVALENCE (BATQUE, KVALUE(27)),        (JOBNUM, KVALUE(28)),
     *            (BTFLIN, KVALUE(29)),        (BTNLIN, KVALUE(30)),
     *            (DETIME, KVALUE(26)),        (REMQUE, KVALUE(32))
      EQUIVALENCE (RHOST, KSTRNG(3))
      DATA PRGNAM /'CUA '/
      DATA LUNTD, LUNTTY /13,5/
      DATA CTASK /'AIPSC'/
      DATA T, F /.TRUE.,.FALSE./
      DATA EPS /0.01/
      DATA DOWAIT /1.0/
C-----------------------------------------------------------------------
      IF (BRANCH.NE.1) GO TO 999
      NBLOCK = 4
      GO TO (100), BRANCH
C-----------------------------------------------------------------------
C                                       SUBMIT
C                                       start AIPSC
C-----------------------------------------------------------------------
 100  J = BATQUE + EPS
      IF ((J.LT.1) .OR. (J.GT.NBATQS)) THEN
         POTERR = 40
         WRITE (MSGTXT,1100) J, NBATQS
         CALL MSGWRT (7)
         GO TO 980
         END IF
C                                       open output file
      CALL ZPHFIL ('TD', 1, 0, 4, PHNAME, IERR)
      CALL ZOPEN (LUNTD, FINDTD, 1, PHNAME, F, T, T, IERR)
      POTERR = 101
      IF (IERR.NE.0) GO TO 980
      CALL ZFIO ('READ', LUNTD, FINDTD, 1, IPRBUF, IERR)
      POTERR = 50
      IF (IERR.NE.0) GO TO 960
      NBLOCK = MAX (4, IPRBUF(256))
C                                      initial values
      JOFF = (NPOPS-1)*NBLOCK + 2
      CALL FILL (256, 0, IPRBUF)
      IPTR = 11
      IPRBUF(1) = NLUSER
      IPRBUF(2) = 0
      IPRBUF(3) = 0
      IPRBUF(4) = MSGKIL
      IPRBUF(5) = ISBTCH
      IPRBUF(6) = 0
      IPRBUF(7) = 0
      IPRBUF(8) = 0
      PARBUF(IPTR-2) = DOWAIT
      VERSON = VERNAM(1:3)
      CALL CHR2H (4, VERSON, 1, PARBUF(IPTR-1))
      PARBUF(IPTR) = BATQUE
      PARBUF(IPTR+1) = DETIME
      CALL CHR2H (48, VERNAM, 1, PARBUF(IPTR+2))
      CALL CHR2H (24, RHOST, 1, PARBUF(IPTR+14))
      PARBUF(IPTR+20) = REMQUE
      CALL ZFIO ('WRIT', LUNTD, FINDTD, JOFF, IPRBUF, IERR)
      POTERR = 50
      IF (IERR.NE.0) GO TO 960
C                                        pointer block (#1)
      CALL ZFIO ('READ', LUNTD, FINDTD, 1, IPRBUF, IERR)
      POTERR = 50
      IF (IERR.NE.0) GO TO 960
      ITEMP = 5*(NPOPS-1)
      CALL CHR2H (8, CTASK, 1, PARBUF(ITEMP+1))
      IPRBUF(3+ITEMP) = -999
      IPRBUF(4+ITEMP) = 0
      IPRBUF(5+ITEMP) = 0
      IPRBUF(256) = NBLOCK
      CALL ZFIO ('WRIT', LUNTD, FINDTD, 1, IPRBUF, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       close files
      CALL ZCLOSE (LUNTD, FINDTD, IERR)
C                                       task already running
      CALL BLDTNM (CTASK, NPOPS, ANAME, IERR)
      POTERR = 43
      IF (IERR.NE.0) GO TO 980
      CALL FILL (4, 0, PID)
      PID(1) = NLUSER
      CALL ZTACTQ (ANAME, PID, ACTIVE, IERR)
      IF (IERR.NE.0) GO TO 980
      POTERR = 42
      IF (ACTIVE) GO TO 980
C                                        close message file
      CALL MSGWRT (-1)
C                                        close input terminal
      CALL LSERCH ('SRCH', LUNTTY, FINDTT, F, IERR)
      POTERR = 58
      IF (IERR.NE.0) GO TO 980
      CALL ZCLOSE (LUNTTY, FINDTT, IERR)
      IF (IERR.NE.0) GO TO 980
C                                        activate the task
      CALL ZACTV8 (CTASK, NPOPS, VERSON, PID, IERR)
      POTERR = 101
      IF (IERR.NE.0) GO TO 950
C                                       Wait for resumption through
C                                       TD file or abort of task
      TDL = 3.
      IF (DOWAIT.GT.0.0) TDL = 8.
      LDOWT = TDL.GT.4.0
      IF (AIPSMK.GT.0.0) TDL = TDL / MAX (0.5, AIPSMK)
      CALL TASKWT (ANAME, NPOPS, PID, LDOWT, TDL, IPRBUF, IRETCD, IERR)
C                                        reopen terminal
      CALL ZOPEN (LUNTTY, FINDTT, 1, PHNAME, F, T, T, IERR)
C                                       resumption message
      WRITE (MSGTXT,1180)
      CALL MSGWRT (2)
      IF (IRETCD.EQ.0) GO TO 999
         POTERR = 101
C                                       abort batch
         WRITE (MSGTXT,1185) IRETCD
         IF (IRETCD.NE.-999) CALL MSGWRT (9)
         GO TO 980
C                                       errors: close files
 950  CALL ZOPEN (LUNTTY, FINDTT, 1, PHNAME, F, T, T, IERR)
      GO TO 980
 960  CALL ZCLOSE (LUNTD, FINDTD, IERR)
C                                       POPS error management
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.EQ.0) GO TO 999
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('BATQUE',I6,' OUTSIDE RANGE 1 -',I2)
 1180 FORMAT ('Resumes')
 1185 FORMAT ('RETURN CODE',I7,' RECEIVED: STOPPING')
      END
      SUBROUTINE CUB (BRANCH)
C-----------------------------------------------------------------------
C   CUB performs batch preparation operations
C   This version of AUB has small symbol table.
C   WARNING: this now differs substantially from AUB in immediate arg
C   pickup for BATEDIT.
C   BRANCH = 1  BATCH     read input to build batch work file
C            2  BATEDIT   read input to insert in batch work file
C            3  UNQUE     deque job, move back to work file
C            4  BATCLEAR  initialize batch work file
C            5  BATLIST   list part of batch work file
C            6  QUEUE     list contents of job queue
C            7  JOBLIST   list part of submitted (inactive) job
C            8  BAMODIFY  Change text of one line of batch work file
C   Adverbs used: BATQUE    queue number (BRANCH = 1 - 6, 8)
C                 JOBNUM    job number   (         3, 7)
C                 BATFLINE  first line # (         2, 5, 7, 8)
C                 BATNLINE  # of lines   (         5, 7)
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      CHARACTER PRGNAM*6, ATIME*8, ADATE*12, PHNAME*48, STATUS*8, LPT*1,
     *   TEMP*100, QUEUED*8, RUNING*8, SUBMIT*8, DONE*8, FAILED*8,
     *   BVERS(5)*4, HOLD*1, INSRT*1, DELETE*1, SPACE*1, ICHAR*1,
     *   RHOST*24, FILE*64, LHOST*24
      INTEGER   POTERR, IQ, IERR, J, JB, IW, IL, IPX, IM, LINE, J1, J2,
     *   IT0(6), IER2, IT(6), LINES, NLPR, I, NWPL, MSGLUN, INP, KOP,
     *   LBYTES, MSGIND, LIUNIT, ITEMP, NCHCPY, ITRIM, JQ, IREC, LREC,
     *   LBATQS, JTRIM
      REAL      EPS, RLINE, BATQUE, JOBNUM, BTFLIN, BTNLIN
      DOUBLE PRECISION    JD0, JD1
      LOGICAL   T, F, INSERT, INSIGN, BATOPN, BWTOPN
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DBCR.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DIO.INC'
      INCLUDE 'INCS:DBAT.INC'
      INTEGER   BWTBUF(256)
      HOLLERITH BWTBUH(256)
      EQUIVALENCE (BWTBUF, BWTBUH)
      INCLUDE 'INCS:DBWT.INC'
      EQUIVALENCE (BATQUE, KVALUE(27)),        (JOBNUM, KVALUE(28)),
     *            (BTFLIN, KVALUE(29)),        (BTNLIN, KVALUE(30))
      EQUIVALENCE (RHOST, KSTRNG(3))
      DATA PRGNAM /'CUB'/
      DATA T, F /.TRUE.,.FALSE./
      DATA QUEUED, RUNING, SUBMIT, DONE, FAILED /'WAITING ',
     *   'RUNNING ','CHECKING','FINISHED','FAILED  '/
      DATA BVERS /'OLD ','NEW ','TST ','CVX ', '??? '/
      DATA EPS /0.01/
      DATA MSGLUN, HOLD, INSRT, SPACE, DELETE /6, '?', '_', '@','$'/
C-----------------------------------------------------------------------
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.8)) GO TO 999
      BWTLUN = 26
      BATLUN = 4
      NWPL = 2 + (NCHLIN + 3) / 4
      NLPR = 252 / NWPL
      BWTOPN = .FALSE.
      BATOPN = .FALSE.
C                                        test input
      POTERR = 32
      IQ = BATQUE + EPS
      IF ((BRANCH.EQ.3) .OR. (BRANCH.EQ.6) .OR. (BRANCH.EQ.7)) THEN
         LHOST = RHOST
      ELSE
         LHOST = ' '
         END IF
      LBATQS = NBATQS
      IF (LHOST.NE.' ') LBATQS = 33
      IF ((BRANCH.NE.6) .AND. (BRANCH.NE.7)) THEN
         IF ((IQ.LT.1) .OR. (IQ.GT.NBATQS)) THEN
            WRITE (MSGTXT,1000) IQ, NBATQS
            CALL MSGWRT (7)
            GO TO 980
            END IF
         END IF
C
      J = JOBNUM + EPS
      JQ = J / 100
      JB = MOD (J, 100)
      IF (BRANCH.EQ.6) JQ = IQ
C                                        open Queue file
      IF ((BRANCH.EQ.3) .OR. (BRANCH.EQ.6) .OR. (BRANCH.EQ.7)) THEN
         CALL ZPHFIL ('BQ', 1, 0, 0, PHNAME, IERR)
         J = JTRIM (LHOST)
C                                       local
         IF (J.EQ.0) THEN
            FILE = PHNAME
C                                       remote at this location
         ELSE
            FILE = 'NET0:' // LHOST(:J) // '/' // PHNAME(6:)
            END IF
         CALL ZEXIST (1, FILE, LBATQS, IERR)
         IF (IERR.NE.0) GO TO 960
         CALL ZOPEN (BATLUN, BATIND, 1, FILE, F, T, T, IERR)
         IF (IERR.NE.0) GO TO 960
         BATOPN = .TRUE.
         IF (BRANCH.NE.6) THEN
            CALL ZFIO ('READ', BATLUN, BATIND, JQ, BATDAT, IERR)
            IF (IERR.NE.0) GO TO 960
            END IF
         END IF
      IF ((BRANCH.EQ.3) .OR. (BRANCH.EQ.7)) THEN
         IF ((JQ.LT.1) .OR. (JQ.GT.LBATQS)) THEN
            JB = 100*LBATQS + 64
            WRITE (MSGTXT,1010) J, JB
            CALL MSGWRT (7)
            GO TO 980
            END IF
         IF ((JB.LT.1) .OR. (JB.GT.64)) THEN
            WRITE (MSGTXT,1015) J
            CALL MSGWRT (7)
            GO TO 980
            END IF
         END IF
C                                        open work file
      POTERR = 50
      IF ((BRANCH.NE.6) .AND. (BRANCH.NE.7)) THEN
         CALL ZPHFIL ('BA', 1, IQ, NPOPS, BWTNAM, IERR)
         CALL ZOPEN (BWTLUN, BWTIND, 1, BWTNAM, F, T, T, IERR)
         IF (IERR.NE.0) GO TO 980
         BWTOPN = .TRUE.
         CALL ZFIO ('READ', BWTLUN, BWTIND, 1, BWTBUF, IERR)
         IF (IERR.NE.0) GO TO 960
         BWTREC = 1
         BWTNUM = BWTBUF(4)
         END IF
C                                        branch to OP
      GO TO (100, 200, 300, 400, 500, 600, 700, 200), BRANCH
C-----------------------------------------------------------------------
C                                        BATCH
C                                        build work file
C-----------------------------------------------------------------------
C                                        DISP = NEW for new user, MOD
 100  IF (NLUSER.NE.BWTBUF(1)) THEN
         CALL FILL (256, 0, BWTBUF)
         BWTBUF(1) = NLUSER
         BWTBUF(2) = 2
         BWTBUF(3) = 1
         END IF
 110  IW = BWTBUF(2)
      IL = 0
      IPX = BWTBUF(3)
      IM = BWTBUF(2)
      CALL BBUILD (IW, IL, IPX, IM, BWTBUF)
      POTERR = 0
      GO TO 960
C-----------------------------------------------------------------------
C                                        BATEDIT
C                                        insert into work file
C-----------------------------------------------------------------------
C                                        must be user's work file
 200  IF (NLUSER.NE.BWTBUF(1)) THEN
         WRITE (MSGTXT,1200) NLUSER, BWTBUF(1)
         CALL MSGWRT (7)
         POTERR = 40
         GO TO 960
         END IF
C                                        get line #, opt. arg
      RLINE = BTFLIN
      IF (SP+1.LE.AP) THEN
         I = CSTACK(SP+1)
         IF ((I.EQ.1) .OR. (I.EQ.11)) THEN
            IF (I.EQ.11) RLINE = V(SP+1)
            IF (I.EQ.1) RLINE = KVALUE(STACK(SP+1))
            SP = SP + 1
            END IF
         END IF
C                                        check line number
      LINE = RLINE + EPS
      INSERT = (ABS(RLINE-LINE) .GT. EPS) .AND. (BRANCH.EQ.2)
      IF ((RLINE.LE.EPS) .OR. (BRANCH.NE.2)) THEN
         IF ((BRANCH.NE.8) .OR. (LINE.LT.1) .OR. (LINE.GT.BWTBUF(2)-2))
     *      THEN
            WRITE (MSGTXT,1210) RLINE
            CALL MSGWRT (7)
            POTERR = 32
            GO TO 960
            END IF
         END IF
C                                        insert after current text
      IF (LINE.GE.BWTBUF(2)-2) THEN
         IF ((INSERT) .OR. (LINE.NE.BWTBUF(2)-2)) THEN
            WRITE (MSGTXT,1215)
            CALL MSGWRT (3)
            GO TO 110
            END IF
         END IF
C                                        read file to find LINE
      IW = BWTBUF(2)
      IM = IW
      POTERR = 50
      DO 230 I = 1,LINE
         LREC = (BWTREC-1)/NLPR + 1
         J = 5 + NWPL * MOD (BWTREC-1, NLPR)
         BWTREC = BWTBUF(J)
         IF (BWTREC.LE.0) THEN
            IF ((I.NE.LINE) .OR. (LINE.NE.IM-2)) THEN
               WRITE (MSGTXT,1220) I
               CALL MSGWRT (9)
               POTERR = 40
               GO TO 960
               END IF
            END IF
         IREC = (BWTREC-1)/NLPR + 1
         IF (IREC.NE.LREC) THEN
            CALL ZFIO ('READ', BWTLUN, BWTIND, IREC, BWTBUF, IERR)
            IF (IERR.NE.0) GO TO 960
            END IF
 230     CONTINUE
C                                        set pointers
      J = 5 + NWPL * MOD (BWTREC-1, NLPR)
      IF (BRANCH.EQ.8) GO TO 800
      IL = BWTBUF(J)
      IF (INSERT) THEN
          IPX = BWTREC
      ELSE
         IPX = BWTBUF(J+1)
         IW = BWTREC
         END IF
      CALL BBUILD (IW, IL, IPX, IM, BWTBUF)
      POTERR = 0
      GO TO 960
C-----------------------------------------------------------------------
C                                        UNQUEUE
C                                        dequeue & recover text
C-----------------------------------------------------------------------
C                                        only inactive jobs this user
 300  J = 4 * JB - 3
      I = BATDAT(J)
      IF (I.NE.NLUSER) THEN
         IF (I.GT.0) THEN
            WRITE (MSGTXT,1300)
         ELSE IF (I.EQ.0) THEN
            WRITE (MSGTXT,1301)
         ELSE IF (BATDAT(J+1).GT.0) THEN
            WRITE (MSGTXT,1302)
         ELSE IF (BATDAT(J+1).EQ.0) THEN
            WRITE (MSGTXT,1303)
         ELSE
            WRITE (MSGTXT,1304)
            END IF
         CALL MSGWRT (7)
         POTERR = 40
         GO TO 960
         END IF
C                                        mark busy
      BATDAT(J) = -BATDAT(J)
      BATDAT(J+1) = ABS(BATDAT(J+1))
      CALL ZFIO ('WRIT', BATLUN, BATIND, JQ, BATDAT, IERR)
      CALL ZCLOSE (BATLUN, BATIND, IER2)
      IF ((IERR.NE.0) .OR. (IER2.NE.0)) THEN
         WRITE (MSGTXT,1305) IERR, IER2
         CALL MSGWRT (7)
         END IF
      BATOPN = .FALSE.
C                                        open file as input
      ITEMP = JQ + 1 + NINTRN
      J = ITRIM (LHOST)
      CALL ZPHFIL ('BA', 1, JB, ITEMP, PHNAME, IERR)
C                                       local
      IF (J.EQ.0) THEN
         FILE = PHNAME
C                                       remote at this location
      ELSE
         FILE = 'NET0:' // LHOST(:J) // '/' // PHNAME(6:)
         END IF
      CALL ZOPEN (BATLUN, BATIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1310) IERR
         CALL MSGWRT (7)
         POTERR = 50
         GO TO 960
         END IF
      BATOPN = .TRUE.
C                                        set input unit
      LIUNIT = IUNIT
      IUNIT = 3
      BATREC = 1
      CALL ZFIO ('READ', BATLUN, BATIND, 1, BATDAT, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       just like BATCH here
C                                       Do BATCLEAR always now
      CALL FILL (256, 0, BWTBUF)
      BWTBUF(1) = NLUSER
      BWTBUF(2) = 2
      BWTBUF(3) = 1
      IW = BWTBUF(2)
      IL = 0
      IPX = BWTBUF(3)
      IM = BWTBUF(2)
      CALL BBUILD (IW, IL, IPX, IM, BWTBUF)
      POTERR = 0
      IUNIT = LIUNIT
C                                        close & destroy
      CALL ZCLOSE (BATLUN, BATIND, IERR)
      BATOPN = .FALSE.
      CALL ZDESTR (1, PHNAME, IER2)
      IF ((IERR.NE.0) .OR. (IER2.NE.0)) THEN
         WRITE (MSGTXT,1320) IERR, IER2
         CALL MSGWRT (7)
         POTERR = 50
         GO TO 960
         END IF
C                                        remove from queue
      CALL ZPHFIL ('BQ', 1, 0, 0, PHNAME, IERR)
      J = JTRIM (LHOST)
C                                       local
      IF (J.EQ.0) THEN
         FILE = PHNAME
C                                       remote at this location
      ELSE
         FILE = 'NET0:' // LHOST(:J) // '/' // PHNAME(6:)
         END IF
      CALL ZOPEN (BATLUN, BATIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1750) IERR
         CALL MSGWRT (9)
         GO TO 960
         END IF
      BATOPN = .TRUE.
      CALL ZFIO ('READ', BATLUN, BATIND, JQ, BATDAT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1755) IERR
         CALL MSGWRT (9)
         GO TO 960
         END IF
      J = 4 * JB - 3
      CALL FILL (5, 0, BATDAT(J))
      CALL ZFIO ('WRIT', BATLUN, BATIND, JQ, BATDAT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1760) IERR
         CALL MSGWRT (9)
         END IF
      GO TO 960
C-----------------------------------------------------------------------
C                                        BATCLEAR
C                                        init work file
C-----------------------------------------------------------------------
 400  CALL FILL (256, 0, BWTBUF)
      BWTBUF(1) = NLUSER
      BWTBUF(2) = 2
      BWTBUF(3) = 1
      CALL ZFIO ('WRIT', BWTLUN, BWTIND, 1, BWTBUF, IERR)
      POTERR = 0
      IF (IERR.NE.0) POTERR = 50
      GO TO 960
C-----------------------------------------------------------------------
C                                        BATLIST
C                                        list work file
C-----------------------------------------------------------------------
 500  GO TO 720
C-----------------------------------------------------------------------
C                                        QUEUE
C                                        list jobs in queue
C-----------------------------------------------------------------------
 600  IF ((IQ.GE.1) .AND. (IQ.LE.NBATQS)) THEN
         J1 = IQ
         J2 = IQ
      ELSE
         J1 = 1
         J2 = NBATQS
         END IF
      CALL ZDATE (IT0(1))
      CALL ZTIME (IT0(4))
      CALL DAT2JD (IT0, JD0)
      WRITE (MSGTXT,1600)
      CALL MSGWRT (5)
C                                       loop over queues
      IW = 0
      DO 620 JQ = J1,J2
         IF (LHOST.NE.' ') MSGSUP = 32000
         CALL ZFIO ('READ', BATLUN, BATIND, JQ, BATDAT, IERR)
         MSGSUP = 0
         IF ((IERR.NE.0) .AND. (IW.GT.0)) GO TO 630
         IF (IERR.NE.0) GO TO 960
         IF (LHOST.NE.' ') IW = IW + 1
         ITEMP = 100*JQ
         DO 610 I = 1,64
            J = 4*I - 3
            IF (BATDAT(J).NE.0) THEN
               IW = ABS(BATDAT(J))
               IF (BATDAT(J).LE.0) THEN
                  STATUS = RUNING
                  IF (BATDAT(J+1).EQ.0) STATUS = SUBMIT
                  IF (BATDAT(J+1).LT.0) STATUS = DONE
               ELSE
                  STATUS = QUEUED
                  IF (BATDAT(J+1).LT.0) STATUS = FAILED
                  END IF
               BATDAT(J+1) = ABS(BATDAT(J+1))
               CALL CATIME (2, BATDAT(J+1), IT)
               CALL DAT2JD (IT, JD1)
               IF ((STATUS.NE.DONE) .OR. (JD1+7.GE.JD0)) THEN
                  IF ((STATUS.NE.FAILED) .OR. (JD1+15.GE.JD0)) THEN
                     IM = ITEMP + I
                     IF ((BATDAT(J+3).LE.0) .OR. (BATDAT(J+3).GT.4))
     *                  BATDAT(J+3) = 5
                     CALL TIMDAT (IT(4), IT(1), ATIME, ADATE)
                     WRITE (MSGTXT,1605) IM, ADATE, ATIME, STATUS, IW,
     *                  BVERS(BATDAT(J+3))
                     CALL MSGWRT (5)
                     END IF
                  END IF
               END IF
 610        CONTINUE
 620     CONTINUE
C                                        close Q file
 630  CALL ZCLOSE (BATLUN, BATIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1620) IERR
         CALL MSGWRT (8)
         END IF
      BATOPN = .FALSE.
      POTERR = 0
      GO TO 980
C-----------------------------------------------------------------------
C                                        JOBLIST
C                                        list submitted job
C-----------------------------------------------------------------------
C                                        list only inactive this user
 700  J = 4 * JB - 3
      I = BATDAT(J)
      IF (I.NE.NLUSER) THEN
         IF (I.GT.0) THEN
            WRITE (MSGTXT,1300)
         ELSE IF (I.EQ.0) THEN
            WRITE (MSGTXT,1301)
         ELSE IF (BATDAT(J+1).GT.0) THEN
            WRITE (MSGTXT,1302)
         ELSE IF (BATDAT(J+1).EQ.0) THEN
            WRITE (MSGTXT,1303)
         ELSE
            WRITE (MSGTXT,1304)
            END IF
         CALL MSGWRT (7)
         POTERR = 40
         GO TO 960
         END IF
C                                        mark busy
      BATDAT(J) = -BATDAT(J)
      INSIGN = BATDAT(J+1).LT.0
      BATDAT(J+1) = ABS(BATDAT(J+1))
      CALL ZFIO ('WRIT', BATLUN, BATIND, JQ, BATDAT, IERR)
      CALL ZCLOSE (BATLUN, BATIND, IER2)
      IF ((IERR.NE.0) .OR. (IER2.NE.0)) THEN
         WRITE (MSGTXT,1305) IERR, IER2
         CALL MSGWRT (7)
         END IF
      BATOPN = .FALSE.
C                                        open file
      ITEMP = JQ + 1 + NINTRN
      CALL ZPHFIL ('BA', 1, JB, ITEMP, PHNAME, IERR)
      J = JTRIM (LHOST)
C                                       local
      IF (J.EQ.0) THEN
         FILE = PHNAME
C                                       remote at this location
      ELSE
         FILE = 'NET0:' // LHOST(:J) // '/' // PHNAME(6:)
         END IF
      CALL ZOPEN (BWTLUN, BWTIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) GO TO 750
      BWTOPN = .TRUE.
      CALL ZFIO ('READ', BWTLUN, BWTIND, 1, BWTBUF, IERR)
      IF (IERR.NE.0) GO TO 750
C                                        list work or file
 720  BWTREC = 1
      LINE = BTFLIN + EPS
      LINES = BTNLIN + EPS
      IF (BWTBUF(2).LE.2) THEN
         WRITE (MSGTXT,1720)
         CALL MSGWRT (3)
         POTERR = 101
         GO TO 750
         END IF
      IF (LINE.GT.BWTBUF(2)-2) THEN
         LINES = BWTBUF(2)-2
         WRITE (MSGTXT,1723) LINE,LINES
         CALL MSGWRT (7)
         POTERR = 32
         GO TO 750
         END IF
C                                        finish setting line range
      LINE = MAX(LINE, 1)
      IF (LINES.LE.1) LINES = BWTBUF(2) - LINE - 1
      LINES = MIN(LINES, BWTBUF(2)-LINE-1)
      LINES = LINES + LINE - 1
      NCHCPY = MIN (74, NCHLIN)
      DO 740 I = 1,LINES
         LREC = (BWTREC-1)/NLPR + 1
         J = 5 + NWPL * MOD (BWTREC-1, NLPR)
         BWTREC = BWTBUF(J)
         IF ((BWTREC.LE.0) .AND. (I.NE.LINES)) THEN
            WRITE (MSGTXT,1220) I
            CALL MSGWRT (9)
            POTERR = 40
            GO TO 750
            END IF
         IREC = (BWTREC-1)/NLPR + 1
         IF (IREC.NE.LREC) THEN
            CALL ZFIO ('READ', BWTLUN, BWTIND, IREC, BWTBUF, IERR)
            IF (IERR.NE.0) GO TO 750
            END IF
         IF (I.GE.LINE) THEN
            J = 5 + NWPL * MOD (BWTREC-1, NLPR)
            WRITE (MSGTXT,1735) I
            MSGTXT(5:6) = '  '
            CALL H2CHR (NCHCPY, 1, BWTBUH(J+2), MSGTXT(7:))
            CALL MSGWRT (5)
            END IF
 740     CONTINUE
      POTERR = 0
C                                        clear busy setting
 750  IF (BRANCH.NE.7) THEN
         GO TO 960
      ELSE
         CALL ZPHFIL ('BQ', 1, 0, 0, PHNAME, IERR)
         J = JTRIM (LHOST)
C                                       local
         IF (J.EQ.0) THEN
            FILE = PHNAME
C                                       remote at this location
         ELSE
            FILE = 'NET0:' // LHOST(:J) // '/' // PHNAME(6:)
            END IF
         CALL ZOPEN (BATLUN, BATIND, 1, PHNAME, F, T, T, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1750) IERR
            CALL MSGWRT (9)
            GO TO 960
            END IF
         BATOPN = .TRUE.
         CALL ZFIO ('READ', BATLUN, BATIND, JQ, BATDAT, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1755) IERR
            CALL MSGWRT (9)
            GO TO 960
            END IF
         J = 4 * JB - 3
         BATDAT(J) = ABS(BATDAT(J))
         IF (INSIGN) BATDAT(J+1) = -BATDAT(J+1)
         CALL ZFIO ('WRIT', BATLUN, BATIND, JQ, BATDAT, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1760) IERR
            CALL MSGWRT (9)
            END IF
         GO TO 960
         END IF
C-----------------------------------------------------------------------
C                                        BAMODIFY (continued)
C                                        modify text of one line
C-----------------------------------------------------------------------
C                                       Echo old line
 800  TEMP = HOLD
      LBYTES = NCHLIN
      CALL H2CHR (LBYTES, 1, BWTBUH(J+2), TEMP(2:))
      TEMP(LBYTES+2:) = ' '
      INP = ITRIM (TEMP)
      I = MAX (INP, 1)
      CALL ZMSGOP (MSGLUN, MSGIND, 1, PHNAME, IERR)
      CALL ZTTYIO ('WRIT', MSGLUN, MSGIND, I, TEMP, IERR)
      CALL ZMSGCL (MSGLUN, MSGIND, IERR)
      POTERR = 0
C                                       Read new line
      LPT = IPT
      LIUNIT = IUNIT
      IUNIT = 1
      IPT = HOLD
      CALL PREAD (KARBUF)
      IUNIT = LIUNIT
      IPT = LPT
      IF (ERRNUM.NE.0) GO TO 960
      IF (NBYTES.LE.0) GO TO 960
C                                       Merge old and new lines
      INP = 1
      KOP = 1
      INSERT = .FALSE.
      DO 845 I = 1,1000
         ICHAR = KARBUF(I:I)
C                                       Insert mode
         IF (INSERT) THEN
            IF ((ICHAR.EQ.INSRT) .OR. (I.GT.NBYTES)) THEN
               INSERT = .FALSE.
            ELSE
               KARBUF(KOP:KOP) = ICHAR
               IF (ICHAR.EQ.SPACE) KARBUF(KOP:KOP) = ' '
               IF (ICHAR.NE.DELETE) KOP = KOP + 1
               END IF
C                                       Substitute mode
         ELSE
            IF ((I.GT.NBYTES) .AND. (INP.GT.LBYTES)) GO TO 850
C                                       Pure copy at end
            IF (I.GT.NBYTES) THEN
               CALL H2CHR (1, INP, BWTBUH(J+2), KARBUF(KOP:KOP))
               KOP = KOP + 1
               INP = INP + 1
C                                       Start insert
            ELSE IF (ICHAR.EQ.INSRT) THEN
               INSERT = .TRUE.
C                                       Delete a character
            ELSE IF (ICHAR.EQ.DELETE) THEN
               INP = INP + 1
C                                       Change to blank
            ELSE IF (ICHAR.EQ.SPACE) THEN
               KARBUF(KOP:KOP) = ' '
               KOP = KOP + 1
               INP = INP + 1
C                                       Keep old character
            ELSE IF (ICHAR.EQ.' ') THEN
               KARBUF(KOP:KOP) = ' '
               IF (INP.LE.LBYTES) CALL H2CHR (1, INP, BWTBUH(J+2),
     *            KARBUF(KOP:KOP))
               INP = INP + 1
               KOP = KOP + 1
C                                       New character
            ELSE
               KARBUF(KOP:KOP) = ICHAR
               IF ((ICHAR.EQ.SPACE) .OR. (ICHAR.EQ.INSRT) .OR.
     *            (ICHAR.EQ.DELETE)) KARBUF(KOP:KOP) = ' '
               KOP = KOP + 1
               INP = INP + 1
               END IF
            END IF
 845     CONTINUE
C                                       Echo new line
 850  TEMP = ' ' // KARBUF(1:NCHLIN)
      CALL CHR2H (NCHLIN, KARBUF, 1, BWTBUH(J+2))
      INP = ITRIM (TEMP)
      I = MAX (INP, 1)
      CALL ZMSGOP (MSGLUN, MSGIND, 1, PHNAME, IERR)
      CALL ZTTYIO ('WRIT', MSGLUN, MSGIND, I, TEMP, IERR)
      CALL ZMSGCL (MSGLUN, MSGIND, IERR)
C                                       Write out record
      CALL ZFIO ('WRIT', BWTLUN, BWTIND, IREC, BWTBUF, IERR)
      IF (IERR.NE.0) POTERR = 50
      GO TO 960
C-----------------------------------------------------------------------
C                                        Close down area
C                                        close BAT or Q
 960  IF (BATOPN) CALL ZCLOSE (BATLUN, BATIND, IERR)
C                                        work file
      IF (BWTOPN) CALL ZCLOSE (BWTLUN, BWTIND, IERR)
C                                        POPS error mess
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('QUEUE #',I6,' OUTSIDE RANGE 1 -',I3)
 1010 FORMAT ('JOB #',I7,' OUTSIDE RANGE 101 -',I4)
 1015 FORMAT ('JOB #',I7,' INVALID')
 1200 FORMAT ('USER #',I5,' CANNOT EDIT BATCH OF',I5)
 1210 FORMAT ('BATFLINE',F7.1,' OUT OF RANGE')
 1215 FORMAT ('BATFLINE TOO LARGE: ADDING CODE AT END')
 1220 FORMAT ('LINK FAILS TO LINE',I6)
 1300 FORMAT ('YOU MAY ONLY UNQUEUE/JOBLIST YOUR OWN JOBS')
 1301 FORMAT ('JOB DOES NOT EXIST')
 1302 FORMAT ('JOB ALREADY RUNNING')
 1303 FORMAT ('JOB STILL SUBMITTING')
 1304 FORMAT ('JOB ALREADY DONE')
 1305 FORMAT ('DEQUE ERROR: WRITE',I7,' CLOSE',I7)
 1310 FORMAT ('OPEN BATCH FILE ERROR',I7)
 1320 FORMAT ('BATCH FILE ERROR CLOSE',I7,' DESTROY',I7)
 1600 FORMAT ('Job',8X,'Submit time',10X,'Status',11X,'Ver')
 1605 FORMAT (I3,3X,A12,1X,A8,4X,A8,I6,4X,A3)
 1620 FORMAT ('Q FILE CLOSE ERROR',I7)
 1720 FORMAT ('NO LINES IN FILE')
 1723 FORMAT ('BATFLINE',I7,' EXCEEDS MAX LINE',I6)
 1735 FORMAT (I4)
 1750 FORMAT ('JOB REQUEUE OPEN ERROR',I7)
 1755 FORMAT ('JOB REQUEUE READ ERROR',I7)
 1760 FORMAT ('JOB REQUEUE WRITE ERROR',I7)
      END

      SUBROUTINE QXFOR2 (IPASS, ISEP, AINDEX, BINDEX, COSII, SINII, W)
C-----------------------------------------------------------------------
C! Pseudo AP routine: FFT utility routine.
C# AP-FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This program does as section of a FFT but avoids multiplication when
C   addition will do in the cos and sin series
C   Inputs:
C      IPASS   I     Pass number in fft loop
C      ISEP    I     Number of element processed in this pass
C      AINDEX  I     Index for Butterfly  fft loop
C      BINDEX  I     Index for Butterfly  fft loop
C      COSII   R     Cosine term for fft loop
C      SINII   R     Sine   term for fft loop
C   Input/Output:
C      W     R(2,M)  Complex work array.
C-----------------------------------------------------------------------
      INTEGER          IPASS, ISEP, AINDEX, BINDEX
      DOUBLE PRECISION COSII, SINII, W(2,*)
C
      DOUBLE PRECISION NEAR1
      PARAMETER        (NEAR1=0.999999)
      INTEGER          J, JI, JI1
      DOUBLE PRECISION AR, AI
C-----------------------------------------------------------------------
C                                       init indexes
      JI  = AINDEX
      JI1 = BINDEX
C                                       deterime odd or even pass
      IF (IPASS.NE.(2*(IPASS/2))) THEN
C                                       Odd pass
C                                       if special case cos=1
         IF (COSII.GT.NEAR1) THEN
      INCLUDE 'INCS:ZVND.INC'
            DO 100 J = 1,ISEP
               AR = W(1,JI)
               AI = W(2,JI)
               W(1,JI) =  W(1,JI1) - AR
               W(2,JI) =  W(2,JI1) - AI
               W(1,JI1) = W(1,JI1) + AR
               W(2,JI1) = W(2,JI1) + AI
               JI1 = JI1 + 1
               JI = JI + 1
 100           CONTINUE
C                                       if special case sin=1
         ELSE IF (SINII.GT.NEAR1) THEN
      INCLUDE 'INCS:ZVND.INC'
            DO 150 J = 1,ISEP
               AR = -W(2,JI)
               AI =  W(1,JI)
               W(1,JI) =  W(1,JI1) - AR
               W(2,JI) =  W(2,JI1) - AI
               W(1,JI1) = W(1,JI1) + AR
               W(2,JI1) = W(2,JI1) + AI
               JI1 = JI1 + 1
               JI = JI + 1
 150           CONTINUE
C                                       else normal case multiply
         ELSE
      INCLUDE 'INCS:ZVND.INC'
            DO 200 J = 1,ISEP
               AR = W(1,JI) * COSII - W(2,JI) * SINII
               AI = W(1,JI) * SINII + W(2,JI) * COSII
               W(1,JI) =  W(1,JI1) - AR
               W(2,JI) =  W(2,JI1) - AI
               W(1,JI1) = W(1,JI1) + AR
               W(2,JI1) = W(2,JI1) + AI
               JI1 = JI1 + 1
               JI = JI + 1
 200           CONTINUE
            END IF
C                                       else Even pass
      ELSE
C                                       If special cos=1 case
         IF (COSII.GT.NEAR1) THEN
      INCLUDE 'INCS:ZVND.INC'
            DO 300 J = 1,ISEP
               AR = W(2,JI)
               AI = W(1,JI)
               W(1,JI) =  W(1,JI1) + AR
               W(2,JI) =  W(2,JI1) - AI
               W(1,JI1) = W(1,JI1) - AR
               W(2,JI1) = W(2,JI1) + AI
               JI1 = JI1 + 1
               JI = JI + 1
 300           CONTINUE
C                                       if special case sin=1
         ELSE IF (SINII.GT.NEAR1) THEN
      INCLUDE 'INCS:ZVND.INC'
            DO 350 J = 1,ISEP
               AR =  W(1,JI)
               AI = -W(2,JI)
               W(1,JI) =  W(1,JI1) + AR
               W(2,JI) =  W(2,JI1) - AI
               W(1,JI1) = W(1,JI1) - AR
               W(2,JI1) = W(2,JI1) + AI
               JI1 = JI1 + 1
               JI = JI + 1
 350           CONTINUE
C                                       else normal case, multiply
         ELSE
      INCLUDE 'INCS:ZVND.INC'
            DO 400 J = 1,ISEP
               AR = W(1,JI) * SINII + W(2,JI) * COSII
               AI = W(1,JI) * COSII - W(2,JI) * SINII
               W(1,JI) =  W(1,JI1) + AR
               W(2,JI) =  W(2,JI1) - AI
               W(1,JI1) = W(1,JI1) - AR
               W(2,JI1) = W(2,JI1) + AI
               JI1 = JI1 + 1
               JI = JI + 1
 400           CONTINUE
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZBKTP1 (ZLUN, ZBKNAM, BAKTXT, NTAPE, ZMT0N, LZMT0N,
     *   IERR)
C-----------------------------------------------------------------------
C! initialize BACKUP to tape operation for BAKTP
C# Z Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Initialize the host environment in preparation for ZBKTP2.  If
C   OPCODE = 'INIT', initializes the tape too.
C   (used only by task BAKTP)
C   Inputs:
C      NTAPE    I       Tape drive number
C      BAKTXT   C*(*)   lowest file name for file listing (not used
C                       here, only in VMS now)
C   Outputs:
C      ZLUN     I       LUN to use
C      ZBKNAM   C*(*)   Command file name
C      ZMT0N    C*(*)   Tape name (translation of MT0n) n=NTAPE-1
C      LZMT0N   I       Actual length used in ZMT0N
C      IERR     I       Error code: 0 => okay
C   VMS version.
C-----------------------------------------------------------------------
      INTEGER   ZLUN, NTAPE, LZMT0N, IERR
      CHARACTER ZBKNAM*(*), BAKTXT*(*), ZMT0N*(*)
C
      INTEGER   JERR, ITEMP, ITRIM, IL
      CHARACTER COMMND*40, CUSER*3, CTEMP*1, TEXT*128, FNAME*50
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DBTP.INC'
C-----------------------------------------------------------------------
C                                       ZLUN is OS-dependent:
      ZLUN = 79
C                                       create private command file:
      CALL ZEHEX (NPOPS, 1, CTEMP)
      CALL ZEHEX (USER, 3, CUSER)
      ZBKNAM = 'DA00:BAKTP' // CTEMP // '.' // CUSER // ';1'
      IERR = 0
      OPEN (ZLUN, FILE=ZBKNAM, STATUS='UNKNOWN', ERR=900,
     *   CARRIAGECONTROL='LIST')
      REWIND ZLUN
      TEXT = '$ SET DEFAULT DA00:'
      JERR = ITRIM (TEXT)
      WRITE (ZLUN,1000,ERR=900) TEXT(1:JERR)
      TEXT = '$ CREATE/DIRECTORY [.BAKTP' // CTEMP // ']'
      JERR = ITRIM (TEXT)
      WRITE (ZLUN,1000,ERR=900) TEXT(1:JERR)
      TEXT = '$ SET DEFAULT [.BAKTP' // CTEMP // ']'
      JERR = ITRIM (TEXT)
      WRITE (ZLUN,1000,ERR=900) TEXT(1:JERR)
      TEXT = '$ A = "''''F$PARSE(""ANY"",,,""DEVICE"")''"'
      JERR = ITRIM (TEXT)
      WRITE (ZLUN,1000,ERR=900) TEXT(1:JERR)
      TEXT = '$ B = "''''F$PARSE(""ANY"",,,""DIRECTORY"")''"'
      JERR = ITRIM (TEXT)
      WRITE (ZLUN,1000,ERR=900) TEXT(1:JERR)
      TEXT = '$ ASSIGN/JOB "''''A''''''B''"' // ' ZBAKTP' // CTEMP
      JERR = ITRIM (TEXT)
      WRITE (ZLUN,1000,ERR=900) TEXT(1:JERR)
      CLOSE (ZLUN)
      COMMND = '@' // ZBKNAM
      IL = ITRIM (COMMND)
      CALL ZSHCMD (IL, COMMND, 8, 'TASK_OUT', IERR)
C                                       INITialize the BACKUP tape:
C                                       (write label+init-saveset)
      IF (OP.EQ.'INIT') THEN
C                                       generate special catalog file:
         FNAME = 'Z' // ZBKNAM(6:11) // ':' // BAKTXT
         OPEN (ZLUN, FILE=FNAME, STATUS='UNKNOWN', ERR=910,
     *      CARRIAGECONTROL='LIST')
         REWIND ZLUN
         TEXT = 'INIT for AIPS task BAKTP (skipped by task BAKLD)'
         JERR = ITRIM (TEXT)
         WRITE (ZLUN,1000,ERR=910) TEXT(1:JERR)
         CLOSE (ZLUN)
C                                       generate command file:
         OPEN (ZLUN, FILE=ZBKNAM, STATUS='OLD', ERR=910)
         REWIND ZLUN
         TEXT = '$ BACKUP/BLOCK=30720 -'
         JERR = ITRIM (TEXT)
         WRITE (ZLUN,1000,ERR=910) TEXT(1:JERR)
         TEXT = ' '
         JERR = ITRIM (FNAME)
         TEXT(9:) = FNAME(:JERR) // ' -'
         JERR = ITRIM (TEXT)
         WRITE (ZLUN,1000,ERR=910) TEXT(1:JERR)
         ITEMP = NTAPE
         CALL ZEHEX (ITEMP, 1, CTEMP)
         TEXT(9:) = 'AMT0' // CTEMP //
     *      ':BAKINI.BCK/REWIND/LABEL=(BAKAIP)'
         JERR = ITRIM (TEXT)
         WRITE (ZLUN,1000,ERR=910) TEXT(1:JERR)
         CLOSE (ZLUN)
         COMMND = '@' // ZBKNAM
         IL = ITRIM (COMMND)
         CALL ZSHCMD (IL, COMMND, 8, 'TASK_OUT', IERR)
         WRITE (MSGTXT,1010)
         CALL MSGWRT (5)
         END IF
      GO TO 999
C                                       can't create, fatal error:
 900  MSGTXT = 'ZBKTP1: CANNOT CREATE/WRITE ' // ZBKNAM
      GO TO 990
 910  MSGTXT = 'ZBKTP1: CANNOT CREATE/WRITE ' // FNAME
C
 990  CALL MSGWRT (8)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A)
 1010 FORMAT ('Tape initialized for VMS-BACKUP BAKTP use (VSN=BAKAIP).')
      END

LOCAL INCLUDE 'CLSMO.INC'
C                                                          Include CLSMO
C                                       Local include for CLSMO
C                                       Needs parameter from PUVD.INC
C                                       Inputs and general info
      INTEGER   SEQIN, SUBA, DISKIN, CNOIN, NUMHIS, CLVER, NSOUWD,
     *   SOUWAN(30), NANTSL, ANTENS(50), BIF, EIF, ISTOK, FREQID, INVER
      LOGICAL   DOSWNT, DOAWNT
      REAL      XSIN, XDISIN, DOBTWN, XFQID, XBAND, XFREQ, XBIF, XEIF,
     *   XTIME(8), XANT(50), XSUBA, XIPARM(10), CUTOFF, XDOBLK, XNORM,
     *   XGVER, XBAD(10), SELBAN, TSTART, TEND
      CHARACTER  HISCRD(30)*64, NAMEIN*12, CLAIN*6, XSOUR(30)*16,
     *   XSTOK*4, XINTP*4, XSMO*4
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XXSTOK(1),
     *   XXINTP(1), XXSMO(1)
      DOUBLE PRECISION FRQOFF(MAXIF), SELFRQ
C                                       Buffers and file info
      INTEGER   BUFFER(512)
C                                       Inputs and general info
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XXSOUR, DOBTWN,
     *   XXSTOK, XBAND, XFREQ, XFQID, XBIF, XEIF, XTIME, XANT,  XSUBA,
     *   XXINTP, XIPARM, CUTOFF, XDOBLK, XXSMO, XNORM, XGVER, XBAD
     *
      COMMON /CINFO/ FRQOFF, SELFRQ, SELBAN, TSTART, TEND, SEQIN,
     *   DISKIN, CNOIN, SUBA, CLVER, DOSWNT, DOAWNT, NSOUWD, SOUWAN,
     *   NANTSL, ANTENS, BIF, EIF, ISTOK, FREQID, NUMHIS, INVER
      COMMON /CHRCOM/ HISCRD, NAMEIN, CLAIN, XSOUR, XSTOK, XINTP, XSMO
C                                       Buffers and file info
      COMMON /BUFRS/ BUFFER
C                                                          End CLSMO
LOCAL END
      PROGRAM CLSMO
C-----------------------------------------------------------------------
C! Smooths a CL table
C# UV Calibration EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2003-2004, 2010-2012, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task CLSMO smooths a CL tables.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'CLSMO.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'CLSMO '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL CLSMIN (PRGM, IRET)
C                                       Apply corrections
      IF (IRET.EQ.0) CALL CLSUV (IRET)
C                                       Copy and update HI file.
      IF (IRET.EQ.0) CALL CLSMHI
C                                       Close down files, etc.
      CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE CLSMIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   CLSMIN gets input parameters for CLSMO.
C   Inputs:  PRGN    C*6       Program name
C   Output:  JERR    I         Error code: 0 => ok
C                                1 => Invalid request
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   JERR
C
      CHARACTER STAT*4, UTYPE*2
      LOGICAL   T, F, ALLANT, DESEL, MATCH
      INTEGER   NPARM, IERR, I, NEXT, IARG, LIMIT, J, IROUND, LUN, LUN2,
     *   IIVER, ICLRNO, NUMANT, NUMPOL, NUMIF, IRET, NTERM, BUFF2(512)
      REAL      GMMOD
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   DUMMY(MAXIF), CLKOLS(MAXCLC), CLNUMV(MAXCLC)
      REAL      FINC(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'CLSMO.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA LUN, LUN2 /28,29/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 218
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFFER, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      SUBA = XSUBA + 0.5
      INVER = IROUND (XGVER)
      DO 20 I = 1,10
         IBAD(I) = IROUND (XBAD(I))
 20      CONTINUE
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XXSTOK, XSTOK)
      CALL H2CHR (4, 1, XXINTP, XINTP)
      CALL H2CHR (4, 1, XXSMO, XSMO)
      DO 25 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
 25      CONTINUE
C                                       Find file, read CATBLK
      CNOIN = 1
      STAT = 'SRCH'
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK, mark "WRIT"
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'WRIT', BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Register in DFIL.INC
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 1
C                                       Check that CL table present
      CALL CALINI ('READ', BUFFER, DISKIN, CNOIN, INVER, CATBLK, LUN,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
C                                       Close table
      CALL TABIO ('CLOS', 0, ICLRNO, DUMMY, BUFFER, IERR)
      IF ((IRET.NE.0) .OR. (IERR.NE.0)) GO TO 999
C                                       Create new CL table
      CLVER = 0
      CALL TABCOP ('CL', INVER, CLVER, LUN, LUN2, DISKIN, DISKIN, CNOIN,
     *   CNOIN, CATBLK, BUFFER, BUFF2, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'TROUBLE COPYING CL TABLE TO NEW VERSION'
         GO TO 990
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FREQID = IROUND (XFQID)
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FREQID, JERR)
      IF (.NOT.MATCH) THEN
C                                       No match
         WRITE (MSGTXT,1070)
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       IF range
      BIF = IROUND (XBIF)
      EIF = IROUND (XEIF)
      IF (BIF.LE.0) BIF = 1
      IF ((EIF.LE.0) .AND. (JLOCIF.GT.0)) EIF = CATBLK(KINAX+JLOCIF)
      IF (EIF.LE.0) EIF = 1
      IF ((JLOCIF.GT.0) .AND. (BIF.GT.CATBLK(KINAX+JLOCIF)))
     *   BIF = CATBLK(KINAX+JLOCIF)
      IF ((JLOCIF.GT.0) .AND. (EIF.GT.CATBLK(KINAX+JLOCIF)))
     *   EIF = CATBLK(KINAX+JLOCIF)
C                                       Stokes' type.
      ISTOK = 0
      IF (XSTOK.EQ.'R ') ISTOK = 1
      IF (XSTOK.EQ.'L ') ISTOK = 2
C                                       If none selected take what you
C                                       have.
      IF (ISTOK.EQ.0) THEN
         IF ((CATBLK(KINAX+JLOCS).EQ.1) .AND. (ABS (CATD(KDCRV+JLOCS)
     *      +1.0D0) .LE. 0.5D0)) ISTOK = 1
         IF ((CATBLK(KINAX+JLOCS).EQ.1) .AND. (ABS (CATD(KDCRV+JLOCS)
     *      +2.0D0) .LE. 0.5D0)) ISTOK = 2
C                                       Is selected Stokes' available?
      ELSE
         IF ((CATBLK(KINAX+JLOCS).EQ.1) .AND.
     *      (ABS (CATD(KDCRV+JLOCS)+ISTOK).GT.0.5D0)) THEN
            JERR = 1
            MSGTXT = 'STOKES ' // XSTOK // ' UNAVAILABLE IN DATA'
            GO TO 990
            END IF
         END IF
C                                       If Only LCP available set ISTOK
C                                       to 1
      IF (ABS (CATD(KDCRV+JLOCS)+2.0D0).LE.0.1) ISTOK = 1
      JERR = 0
C                                       Antenna list
      ALLANT = T
      NANTSL = 0
      DESEL = F
      DO 100 I = 1,50
         ANTENS(I) = 0
         ALLANT = ALLANT .AND. (ABS (XANT(I)).LE.1.0E-10)
         DESEL = DESEL .OR. (XANT(I).LT.-0.5)
 100     CONTINUE
      NEXT = 1
C                                       Not all selected - make list
C                                       ANTENNAS array.
      IF (.NOT.ALLANT) THEN
         DO 150 I = 1,50
            IARG = ABS (XANT(I)) + 0.5
            IF (IARG.GT.0) THEN
C                                       See if already have
               LIMIT = NEXT - 1
               IF (LIMIT.GE.1) THEN
                  DO 130 J = 1,LIMIT
                     IF (IARG.EQ.ANTENS(J)) GO TO 150
 130                 CONTINUE
                  END IF
C                                       New antenna
               ANTENS(NEXT) = IARG
               NEXT = NEXT + 1
               END IF
 150        CONTINUE
         END IF
      DOAWNT = .NOT. DESEL
      NANTSL = NEXT - 1
C                                       Get source numbers
      CALL FNDSOU (DISKIN, CNOIN, XSOUR, BUFFER, NSOUWD, DOSWNT,
     *   SOUWAN, JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Get IF information
      IIVER = 1
      CALL CHNDAT ('READ', BUFFER, DISKIN, CNOIN, IIVER, CATBLK, LUN,
     *   NUMIF, FRQOFF, DUMMY, FINC, BNDCOD, FREQID, JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Timerange
      TSTART = XTIME(1) + XTIME(2) / 24.0 + XTIME(3) / (24.0*60.0) +
     *   (XTIME(4) / (24.0*60.0*60.0))
      TEND = XTIME(5) + XTIME(6) / 24.0 + XTIME(7) / (24.0*60.0) +
     *   (XTIME(8) / (24.0*60.0*60.0))
      IF ((TEND.LT.TSTART) .OR. (TEND.LT.1.0E-5)) TEND = 1.0E20
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLSMIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
      END
      SUBROUTINE CLSUV (IERR)
C-----------------------------------------------------------------------
C   Smooths selected portions of CL tables.
C   Leaves the output table sorted in time-antenna order.
C   Inputs from common:
C      CLVER        I    Cal (CL) file version number.
C      TSTART       R    First time to process (days) (no default)
C      TEND         R    Last time to process (days) (no default)
C   Output:
C      IERR         I    Return code, 0=>OK, otherwise failed.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MXTIME
C                                       MXTIME = dim work arrays
      PARAMETER (MXTIME = 25000)
      CHARACTER COLHED(2)*24, SMOOS(5)*4
      INTEGER   IRET, KEY(2,2), ICLUN, CLANT, CLTIM, ICLRNO, NKEY,
     *   KOLS(2), MAXTIM, CLNUMV(MAXCLC), CLKOLS(MAXCLC), NUMANT,
     *   NUMPOL, NUMIF, NTERM, SMOTYP, NSMOOS, I, KEYSUB(2,2),
     *   WRKSRC(MXTIME)
      LOGICAL   T
      REAL      FKEY(2,2), WRKTIM(MXTIME), WORK1(MXTIME), WORK2(MXTIME),
     *   WORK3(MXTIME),  WORK4(MXTIME), WORK5(MXTIME), SMOTIM(3,4),
     *   GMMOD
      DOUBLE PRECISION TIMRA(2)
      INCLUDE 'CLSMO.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
C                                       Align WRK* in memory
      COMMON /XXYYZZ/ WRKTIM, WORK1, WORK2, WORK3, WORK4, WORK5, WRKSRC
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
      DATA COLHED /'TIME ', 'ANTENNA NO. '/
      DATA T /.TRUE./
      DATA ICLUN /30/
      DATA NSMOOS /5/
      DATA SMOOS /'AMPL','PHAS','BOTH','FULL','VLBI'/
C-----------------------------------------------------------------------
C                                       MAXTIM = size of work arrays;
C                                       determined by EQUIVALENCE above
      MAXTIM = MXTIME
      IERR = 0
      SMOTIM(1,1) = XIPARM(1) / 24.0
      SMOTIM(1,2) = XIPARM(2) / 24.0
      SMOTIM(1,3) = XIPARM(3) / 24.0
      SMOTIM(1,4) = XIPARM(4) / 24.0
      SMOTIM(2,1) = XIPARM(6) / 24.0
      SMOTIM(2,2) = XIPARM(7) / 24.0
      SMOTIM(2,3) = XIPARM(8) / 24.0
      SMOTIM(2,4) = XIPARM(9) / 24.0
      SMOTIM(3,1) = CUTOFF
      SMOTIM(3,2) = CUTOFF
      SMOTIM(3,3) = CUTOFF
      SMOTIM(3,4) = CUTOFF
      TIMRA(1) = TSTART
      TIMRA(2) = TEND
C                                       Type of data to smooth
      SMOTYP = 1
      DO 10 I = 1,NSMOOS
         IF (XSMO.EQ.SMOOS(I)) SMOTYP = I
 10      CONTINUE
C                                       Sort CL table to antenna-time.
C                                       Need col. pointers, sort order.
C                                       Reformat?
      CALL CLREFM (DISKIN, CNOIN, CLVER, CATBLK, ICLUN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL CALINI ('READ', BUFFER, DISKIN, CNOIN, CLVER, CATBLK, ICLUN,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
C                                       Close table
      CALL TABIO ('CLOS', 0, ICLRNO, BUFFER, BUFFER, IERR)
      IF ((IERR.NE.0) .OR. (IRET.NE.0)) GO TO 995
C                                       Reopen write
      CALL CALINI ('WRIT', BUFFER, DISKIN, CNOIN, CLVER, CATBLK, ICLUN,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Get column pointers
      NKEY = 2
      CALL FNDCOL (NKEY, COLHED, 24, T, BUFFER, KOLS, IRET)
      IF ((IRET.GE.1) .AND. (IRET.LE.10)) GO TO 995
      IRET = 0
      CLTIM = KOLS(1)
      CLANT = KOLS(2)
C                                       Close table
      CALL TABIO ('CLOS', 0, ICLRNO, BUFFER, BUFFER, IERR)
      IF ((IERR.NE.0) .OR. (IRET.NE.0)) GO TO 995
      KEY(1,1) = CLANT
      KEY(1,2) = CLTIM
C                                       Sort to antenna time order.
      IF (((BUFFER(43).NE.CLANT) .OR. (BUFFER(44).NE.CLTIM)))
     *   CALL TABSRT (DISKIN, CNOIN, 'CL', CLVER, CLVER, KEY, KEYSUB,
     *   FKEY, BUFFER, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Smooth.
      IERR = 0
      CALL CLSMTH (DISKIN, CNOIN, CLVER, CATBLK, BUFFER, XINTP, SMOTIM,
     *   SMOTYP, TIMRA, SUBA, DOSWNT, NSOUWD, SOUWAN, DOAWNT, NANTSL,
     *   ANTENS, BIF, EIF, ISTOK, FREQID, XDOBLK, DOBTWN, XNORM, MAXTIM,
     *   WRKTIM, WORK1, WORK2, WORK3, WORK4, WORK5, WRKSRC, IERR)
      GO TO 999
C                                       Error
 995  IF ((IERR.EQ.0) .AND. (IRET.NE.0)) IERR = IRET
C
 999  RETURN
      END
      SUBROUTINE CLSMTH (DISK, CNO, VER, CATBLK, BUFFER, SMMETH, SMOTIM,
     *   SMOTYP, TIMRA, SUBA, DOSWNT, NSOUWD, SOUWAN, DOAWNT, NANTSL,
     *   ANTENS, BIF, EIF, ISTOK, FREQID, XDOBLK, DOBTWN, XNORM, MAXTIM,
     *   WRKTIM, WORK1, WORK2, WORK3, WORK4, WORK5, WRKSRC, IRET)
C-----------------------------------------------------------------------
C   Subroutine to smooth and/or copy an antenna-time sorted CL table
C   to a specified output file associated with the same uv data set.
C   Several work arrays are passed which are used for storing and
C   smoothing data.
C   Input:
C      DISK     I      Disk to use.
C      CNO      I      Catalog slot number
C      VER      I      CL file version must be antenna-time sorted for
C                         both input and output
C      CATBLK   I(256) Catalog header block.
C      SMMETH   C*4    Smoothing method.
C      SMOTIM   R(3,4) Function times (support, FWHM, cutoff) (days)
C                         1=ampl, 2=phase 3=rate 4 = delay
C      SMOTYP   I      Smoothing type
C                         1 = amplitude
C                         2 = phase
C                         3 = amp and phase
C                         4 = amp, phase, delay, rate
C                         5 = delay, rate
C      TIMRA    D(2)   First and last times to be considered. (days)
C      SUBA     I      Subarray number, .le. 0 => all
C      DOSWNT   L      If true sources in SOUWAN are selected else
C                      deselected.
C      NSOUWD   I      Number of entries in SOUWAN, 0=all selected
C      SOUWAN   I(*)   Source list
C      DOAWNT   L      If true antennas in ANTENS selected, else
C                      deselected.
C      NANTSL   I      Number of entries in ANTENS, 0=all selected.
C      ANTENS   I(*)   Antenna list
C      BIF      I      Start IF
C      EIF      I      Highest IF
C      ISTOK    I      Stokes wanted, 0=both, 1=1st, 2=2nd.
C      FREQID   I      Frequency group ID. 0 => all.
C      XDOBLK   R      What values are changed: <= 0 change good values,
C                         >= 0 change blanked values
C      MAXTIM   I      Maximum number of times (dim of WRKTIM etc)
C   Input/Output:
C      BUFFER   I(*)   Buffer for TABIO use.
C      WRKTIM   R(*)   Large work array.
C      WORK1    R(*)   Large work array, same size as WRKTIM
C      WORK2    R(*)   Large work array, same size as WRKTIM
C      WORK3    R(*)   Large work array, same size as WRKTIM
C      WORK4    R(*)   Large work array, same size as WRKTIM
C      WORK5    R(*)   Large work array, same size as WRKTIM
C   Output:
C      IRET     I    Return code 0=OK, else failed.
C   Note: uses LUNs 28, 29 and 30
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, VER, CATBLK(256), BUFFER(*), SMOTYP, SUBA,
     *   NSOUWD, SOUWAN(*),  NANTSL, ANTENS(*), BIF, EIF, ISTOK, FREQID,
     *   MAXTIM, WRKSRC(*), IRET
      LOGICAL   DOSWNT, DOAWNT
      REAL      SMOTIM(3,4), XNORM, WORK1(*), WORK2(*), WORK3(*),
     *   WORK4(*), WORK5(*), WRKTIM(*), XDOBLK, DOBTWN
      DOUBLE PRECISION TIMRA(2)
      CHARACTER SMMETH*4
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NHCOL
C                                       NHCOL = no. column labels known.
      PARAMETER (NHCOL = 17)
      CHARACTER KEYWRD*8, COLHED(NHCOL)*24
      INTEGER   IRCODE, RECORD(1024), CLKOLS(MAXCLC), CLNUMV(MAXCLC),
     *   LUN, NUMANT, NUMPOL, NUMIF, DATP(128,2), ANT, IERR, SUB,
     *   NUMSUB, I, NUMTIM, THSOU, KOLS(NHCOL), NKEY, NREC, NCOL,
     *   TIMKOL, SOUKOL, ANTKOL, SUBKOL, FRQKOL,
     *   RE1KOL, IM1KOL, DL1KOL, RA1KOL, TS1KOL, WT1KOL,
     *   RE2KOL, IM2KOL, DL2KOL, RA2KOL, TS2KOL, WT2KOL,
     *   WTKOL, REKOL, IMKOL, DELKOL, RATKOL, TSKOL
      LOGICAL   BAD, MAT
      INTEGER   NUMREC, LOOPS, LOOPIF, LOOPA, ICLRNO, LOOPR, FSTREC,
     *   SAVE, GMCNT, NLEFT, J, ITIME, NRECDO, CNTDO, NTERM
      REAL      RECR(1024), AMPL, FAC, GMMOD, PHSCHK, TWOPI, LASTPH,
     *   PHASE
      DOUBLE PRECISION RECD(512), TIMOFF, GMSUM
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (RECORD, RECR, RECD)
      EQUIVALENCE (KOLS(1), TIMKOL), (KOLS(2), SOUKOL),
     *   (KOLS(3), ANTKOL), (KOLS(4), SUBKOL),  (KOLS(5), FRQKOL),
     *   (KOLS(6), RE1KOL), (KOLS(7),IM1KOL),
     *   (KOLS(8), RA1KOL), (KOLS(9), DL1KOL),
     *   (KOLS(10), TS1KOL), (KOLS(11), WT1KOL),
     *   (KOLS(12), RE2KOL), (KOLS(13),IM2KOL),
     *   (KOLS(14), RA2KOL), (KOLS(15), DL2KOL),
     *   (KOLS(16), TS2KOL), (KOLS(17), WT2KOL)
      DATA KEYWRD /'MGMOD   '/
      DATA COLHED /'TIME                    ',
     *   'SOURCE ID               ', 'ANTENNA NO.             ',
     *   'SUBARRAY                ', 'FREQ ID                 ',
     *   'REAL1                   ', 'IMAG1                   ',
     *   'RATE 1                  ', 'DELAY 1                 ',
     *   'TSYS 1                  ', 'WEIGHT 1                ',
     *   'REAL2                   ', 'IMAG2                   ',
     *   'RATE 2                  ', 'DELAY 2                 ',
     *   'TSYS 2                  ', 'WEIGHT 2                '/
      DATA LUN /28/
      DATA IRCODE /0/
C-----------------------------------------------------------------------
      TWOPI = 8.0 * ATAN (1.0)
      PHSCHK = 4.0 * ATAN (1.0)
      GMCNT = 0
      GMSUM = 0.0D0
      CNTDO = 0
C                                       Open CL table
C                                       Dummy open to get keywords
      CALL CALINI ('READ', BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Close
      CALL TABIO ('CLOS', IRCODE, LOOPR, RECORD, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 900
C                                       Dummy open to get pointers
      NKEY = 0
      NREC = 0
      NCOL = 0
      CALL TABINI ('READ', 'CL', DISK, CNO, VER, CATBLK, LUN,
     *   NKEY, NREC, NCOL, DATP, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Close
      CALL TABIO ('CLOS', IRCODE, LOOPR, RECORD, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 900
C                                       Reopen WRITE
      CALL CALINI ('WRIT', BUFFER, DISK, CNO, VER, CATBLK, LUN, ICLRNO,
     *   CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Get column pointers
      CALL FNDCOL (NHCOL, COLHED, 24, .TRUE., BUFFER, KOLS, IRET)
C                                       Convert from logical to physical
C                                       pointers.
      DO 10 I = 1,NHCOL
         IF (KOLS(I).GT.0) KOLS(I) = DATP(KOLS(I),1)
 10      CONTINUE
C                                       Get number of records in table
      NUMREC = BUFFER(5)
      IF (NUMREC.LE.0) GO TO 999
C                                       Find number of subarrays.
      CALL FNDEXT ('AN', CATBLK, NUMSUB)
      NUMSUB = MAX (1, NUMSUB)
C                                       Inform user of smoothing:
      WRITE (MSGTXT,1010)
      CALL MSGWRT (3)
C                                       Loop over subarrays
      DO 750 SUB = 1,NUMSUB
C                                       Want this subarray?
         IF ((SUBA.GT.0) .AND. (SUB.NE.SUBA)) GO TO 750
C                                       Set pointers
         WTKOL = WT1KOL
         REKOL = RE1KOL
         IMKOL = IM1KOL
         DELKOL = DL1KOL
         RATKOL = RA1KOL
         TSKOL = TS1KOL
C                                       Loop over Stokes
         DO 700 LOOPS = 1,NUMPOL
C                                       Want this Stokes?
            IF (((ISTOK.EQ.1).AND.(LOOPS.NE.1)) .OR.
     *         ((ISTOK.EQ.2).AND.(LOOPS.NE.2))) GO TO 660
C                                       Loop over IF
            DO 650 LOOPIF = 1,NUMIF
C                                       Want this IF
               IF ((LOOPIF.LT.BIF) .OR. (LOOPIF.GT.EIF)) GO TO 640
               FSTREC = 0
C                                       Loop over antenna
               DO 600 LOOPA = 1,NUMANT
                  ANT = LOOPA
C                                       Want this antenna?
                  IF (NANTSL.GT.0) THEN
                     MAT = .FALSE.
                     DO 25 J = 1,NANTSL
                        MAT = MAT .OR. (ANT.EQ.ANTENS(J))
 25                     CONTINUE
C                                       Check for no match, selected.
                     IF (DOAWNT .AND. .NOT.MAT) GO TO 600
C                                       Check for match excluded
                     IF (.NOT.DOAWNT .AND. MAT) GO TO 600
                     END IF
C                                       Set pointers, counters
      NUMTIM = 0
      NLEFT = NUMREC - FSTREC
      NRECDO = 0
      LASTPH = FBLANK
C                                       Loop in time, reading
      DO 100 LOOPR = 1,NLEFT
         ICLRNO = FSTREC + LOOPR
         CALL TABIO ('READ', IRCODE, ICLRNO, RECORD, BUFFER, IRET)
         NRECDO = NRECDO + 1
         IF (IRET.LT.0) GO TO 100
         IF (IRET.NE.0) GO TO 900
C                                       Finished antenna?
         IF (RECORD(ANTKOL).GT.ANT) GO TO 110
C                                       Want this FQ id?
         IF ((RECORD(FRQKOL).NE.FREQID) .AND. (RECORD(FRQKOL).GT.0)
     *      .AND. (FREQID.GT.0)) GO TO 100
C                                       Want this source?
C                                       Check list
         THSOU = RECORD(SOUKOL)
         IF (NSOUWD.GT.0) THEN
            DO 30 J = 1,NSOUWD
               IF ((THSOU.EQ.SOUWAN(J)) .AND. DOSWNT) GO TO 35
               IF ((THSOU.EQ.SOUWAN(J)) .AND. (.NOT.DOSWNT)) GO TO 100
 30            CONTINUE
            IF (DOSWNT) GO TO 100
            END IF
C                                       Check subarray
 35      IF ((RECORD(SUBKOL).NE.SUB) .AND. (RECORD(SUBKOL).GT.0))
     *      GO TO 100
C                                       Not all antennas wanted
         IF (RECORD(ANTKOL).LT.ANT) GO TO 100
C                                       Check time
         IF ((RECD(TIMKOL).LT.TIMRA(1)) .OR. (RECD(TIMKOL).GT.TIMRA(2)))
     *      GO TO 100
C                                       See if bad (all weights OK.)
         BAD = (RECR(REKOL).EQ.FBLANK). OR.
     *      ((ABS (RECR(REKOL)).LT.1.0E-20) .AND.
     *      (ABS(RECR(IMKOL)).LT.1.0E-20))
         IF (NUMTIM.GE.MAXTIM) GO TO 100
            NUMTIM = NUMTIM + 1
            IF (NUMTIM.EQ.1) TIMOFF = RECD(TIMKOL)
            WRKTIM(NUMTIM) = RECD(TIMKOL) - TIMOFF
            IF (DOBTWN.LE.0.0) THEN
               WRKSRC(NUMTIM) = THSOU
            ELSE
               WRKSRC(NUMTIM) = -1
               END IF
            IF (BAD) THEN
               WORK2(NUMTIM) = FBLANK
               WORK3(NUMTIM) = FBLANK
               WORK4(NUMTIM) = FBLANK
               WORK5(NUMTIM) = FBLANK
C                                       Select by type
C                                       Amplitude
            ELSE IF (SMOTYP.EQ.1) THEN
               WORK2(NUMTIM) = SQRT
     *            (RECR(REKOL)*RECR(REKOL) + RECR(IMKOL)*RECR(IMKOL))
C                                       Need phase for interpolating
C                                       blanked values.
               PHASE = ATAN2 (RECR(IMKOL), RECR(REKOL)+1.0E-20)
C                                       Make phase continious
               IF ((LASTPH.NE.FBLANK) .AND.
     *            ( ABS (PHASE-LASTPH).GT.PHSCHK))
     *            PHASE = PHASE - TWOPI * NINT ((PHASE-LASTPH) / TWOPI)
               LASTPH = PHASE
               WORK3(NUMTIM) = PHASE
C                                       Phase
            ELSE IF (SMOTYP.EQ.2) THEN
               PHASE = ATAN2 (RECR(IMKOL), RECR(REKOL)+1.0E-20)
C                                       Make phase continious
               IF ((LASTPH.NE.FBLANK) .AND.
     *            ( ABS (PHASE-LASTPH).GT.PHSCHK))
     *            PHASE = PHASE - TWOPI * NINT ((PHASE-LASTPH) / TWOPI)
               LASTPH = PHASE
               WORK2(NUMTIM) = PHASE
C                                       Need amplitudes for
C                                       interpolating blanked values.
               WORK3(NUMTIM) = SQRT
     *            (RECR(REKOL)*RECR(REKOL) + RECR(IMKOL)*RECR(IMKOL))
C                                       Amplitude and phase
            ELSE IF (SMOTYP.EQ.3) THEN
               WORK2(NUMTIM) = SQRT
     *            (RECR(REKOL)*RECR(REKOL) + RECR(IMKOL)*RECR(IMKOL))
               PHASE = ATAN2 (RECR(IMKOL), RECR(REKOL)+1.0E-20)
C                                       Make phase continious
               IF ((LASTPH.NE.FBLANK) .AND.
     *            ( ABS (PHASE-LASTPH).GT.PHSCHK))
     *            PHASE = PHASE - TWOPI * NINT ((PHASE-LASTPH) / TWOPI)
               LASTPH = PHASE
               WORK3(NUMTIM) = PHASE
C                                       Amp, phase, delay, rate
            ELSE IF (SMOTYP.EQ.4) THEN
               WORK2(NUMTIM) = SQRT
     *            (RECR(REKOL)*RECR(REKOL) + RECR(IMKOL)*RECR(IMKOL))
               PHASE = ATAN2 (RECR(IMKOL), RECR(REKOL)+1.0E-20)
C                                       Make phase continuous
               IF ((LASTPH.NE.FBLANK) .AND.
     *            ( ABS (PHASE-LASTPH).GT.PHSCHK))
     *            PHASE = PHASE - TWOPI * NINT ((PHASE-LASTPH) / TWOPI)
               LASTPH = PHASE
               WORK3(NUMTIM) = PHASE
               WORK4(NUMTIM) = RECR(RATKOL)
               WORK5(NUMTIM) = RECR(DELKOL)
C                                       Delay, rate
            ELSE IF (SMOTYP.EQ.5) THEN
               WORK2(NUMTIM) = RECR(RATKOL)
               WORK3(NUMTIM) = RECR(DELKOL)
               END IF
 100     CONTINUE
 110  SAVE = ICLRNO - 1
      IF (NUMTIM.LE.0) GO TO 590
C                                       Smooth as requested
C                                       Amplitude
      IF (SMOTYP.EQ.1) THEN
         CALL CLSMSM (SMMETH, SMOTIM(1,1), WRKTIM, WORK2, WRKSRC,
     *      FBLANK, NUMTIM, WORK1)
         CALL CLSMSM (SMMETH, SMOTIM(1,2), WRKTIM, WORK3, WRKSRC,
     *      FBLANK, NUMTIM, WORK2)
      ELSE IF (SMOTYP.EQ.2) THEN
C                                       Phase
         CALL CLSMSM (SMMETH, SMOTIM(1,2), WRKTIM, WORK2, WRKSRC,
     *      FBLANK, NUMTIM, WORK1)
         CALL CLSMSM (SMMETH, SMOTIM(1,1), WRKTIM, WORK3, WRKSRC,
     *      FBLANK, NUMTIM, WORK2)
C                                       Amplitude and phase
      ELSE IF (SMOTYP.EQ.3) THEN
         CALL CLSMSM (SMMETH, SMOTIM(1,1), WRKTIM, WORK2, WRKSRC,
     *      FBLANK, NUMTIM, WORK1)
         CALL CLSMSM (SMMETH, SMOTIM(1,2), WRKTIM, WORK3, WRKSRC,
     *      FBLANK, NUMTIM, WORK2)
C                                       All
      ELSE IF (SMOTYP.EQ.4) THEN
         CALL CLSMSM (SMMETH, SMOTIM(1,1), WRKTIM, WORK2, WRKSRC,
     *      FBLANK, NUMTIM, WORK1)
         CALL CLSMSM (SMMETH, SMOTIM(1,2), WRKTIM, WORK3, WRKSRC,
     *      FBLANK, NUMTIM, WORK2)
         CALL CLSMSM (SMMETH, SMOTIM(1,3), WRKTIM, WORK4, WRKSRC,
     *      FBLANK, NUMTIM, WORK3)
         CALL CLSMSM (SMMETH, SMOTIM(1,4), WRKTIM, WORK5, WRKSRC,
     *      FBLANK, NUMTIM, WORK4)
C                                       rate, delay
      ELSE IF (SMOTYP.EQ.5) THEN
         CALL CLSMSM (SMMETH, SMOTIM(1,3), WRKTIM, WORK2, WRKSRC,
     *      FBLANK, NUMTIM, WORK1)
         CALL CLSMSM (SMMETH, SMOTIM(1,4), WRKTIM, WORK3, WRKSRC,
     *      FBLANK, NUMTIM, WORK2)
         END IF
C                                       Replace with smoothed values
      ITIME = 1
      DO 200 LOOPR = 1,NRECDO
         IF (ITIME.GT.NUMTIM) GO TO 200
         ICLRNO = FSTREC + LOOPR
         CALL TABIO ('READ', IRCODE, ICLRNO, RECORD, BUFFER, IRET)
         IF (IRET.LT.0) GO TO 200
         IF (IRET.NE.0) GO TO 900
C                                       Not all antennas wanted
         IF (RECORD(ANTKOL).LT.ANT) GO TO 200
C                                       Did this FQ id?
         IF ((RECORD(FRQKOL).NE.FREQID) .AND. (RECORD(FRQKOL).GT.0)
     *      .AND. (FREQID.GT.0)) GO TO 200
C                                       Did this source?
C                                       Check list
         IF (NSOUWD.GT.0) THEN
            THSOU = RECORD(SOUKOL)
            DO 150 J = 1,NSOUWD
               IF ((THSOU.EQ.SOUWAN(J)) .AND. DOSWNT) GO TO 170
               IF ((THSOU.EQ.SOUWAN(J)) .AND. (.NOT.DOSWNT)) GO TO 200
 150           CONTINUE
            IF (DOSWNT) GO TO 200
            END IF
C                                       Check subarray
 170     IF ((RECORD(SUBKOL).NE.SUB) .AND. (RECORD(SUBKOL).GT.0))
     *      GO TO 200
C                                       Check time (within 1 sec)
         IF (ABS (RECD(TIMKOL)-WRKTIM(ITIME)-TIMOFF) .GT. 1.574D-5)
     *      GO TO 200
C                                       Update
C                                       Amplitude
         IF (SMOTYP.EQ.1) THEN
            IF (WORK1(ITIME).EQ.FBLANK) GO TO 190
C                                       Use interpolated phase if input
C                                       blanked.
            IF ((RECR(REKOL).EQ.FBLANK) .OR. (RECR(IMKOL).EQ.FBLANK))
     *         THEN
               IF (XDOBLK.GE.0.0) THEN
                  RECR(REKOL) = WORK1(ITIME) * COS (WORK2(ITIME))
                  RECR(IMKOL) = WORK1(ITIME) * SIN (WORK2(ITIME))
                  CNTDO = CNTDO + 1
                  END IF
            ELSE IF (XDOBLK.LE.0.0) THEN
               AMPL = SQRT (RECR(REKOL)*RECR(REKOL) +
     *            RECR(IMKOL)*RECR(IMKOL))
               IF (AMPL.LE.1.0E-20) AMPL = WORK1(ITIME)
               FAC = WORK1(ITIME) / AMPL
               RECR(REKOL) = RECR(REKOL) * FAC
               RECR(IMKOL) = RECR(IMKOL) * FAC
               CNTDO = CNTDO + 1
               END IF
C                                       Mean gain modulus
            IF (RECR(REKOL).NE.FBLANK) THEN
               GMCNT = GMCNT + 1
               GMSUM = GMSUM + SQRT (RECR(REKOL)*RECR(REKOL) +
     *            RECR(IMKOL)*RECR(IMKOL))
               END IF
C                                       Phase
         ELSE IF (SMOTYP.EQ.2) THEN
            IF (WORK1(ITIME).EQ.FBLANK) GO TO 190
C                                       Use interpolated amplitude for
C                                       blanked values.
            IF ((RECR(REKOL).EQ.FBLANK) .OR. (RECR(IMKOL).EQ.FBLANK))
     *         THEN
               IF (XDOBLK.GE.0.0) THEN
                  AMPL = WORK2(ITIME)
                  RECR(REKOL) = AMPL * COS (WORK1(ITIME))
                  RECR(IMKOL) = AMPL * SIN (WORK1(ITIME))
                  CNTDO = CNTDO + 1
                  END IF
            ELSE IF (XDOBLK.LE.0.0) THEN
               AMPL = SQRT (RECR(REKOL)*RECR(REKOL) +
     *            RECR(IMKOL)*RECR(IMKOL))
               RECR(REKOL) = AMPL * COS (WORK1(ITIME))
               RECR(IMKOL) = AMPL * SIN (WORK1(ITIME))
               CNTDO = CNTDO + 1
               END IF
C                                       Amplitude and phase
         ELSE IF (SMOTYP.EQ.3) THEN
            IF ((WORK1(ITIME).EQ.FBLANK) .OR. (WORK2(ITIME).EQ.FBLANK))
     *         GO TO 190
            IF ((RECR(REKOL).EQ.FBLANK) .OR. (RECR(IMKOL).EQ.FBLANK))
     *         THEN
               IF (XDOBLK.GE.0.0) THEN
                  RECR(REKOL) = WORK1(ITIME) * COS (WORK2(ITIME))
                  RECR(IMKOL) = WORK1(ITIME) * SIN (WORK2(ITIME))
                  CNTDO = CNTDO + 1
                  END IF
            ELSE IF (XDOBLK.LE.0.0) THEN
               RECR(REKOL) = WORK1(ITIME) * COS (WORK2(ITIME))
               RECR(IMKOL) = WORK1(ITIME) * SIN (WORK2(ITIME))
               CNTDO = CNTDO + 1
               END IF
C                                       Mean gain modulus
            IF (RECR(REKOL).NE.FBLANK) THEN
               GMCNT = GMCNT + 1
               GMSUM = GMSUM + SQRT (RECR(REKOL)*RECR(REKOL) +
     *            RECR(IMKOL)*RECR(IMKOL))
               END IF
C                                       amp,phase,delay,rate
         ELSE IF (SMOTYP.EQ.4) THEN
            IF ((WORK1(ITIME).EQ.FBLANK) .OR. (WORK2(ITIME).EQ.FBLANK)
     *         .OR. (WORK3(ITIME).EQ.FBLANK)
     *         .OR. (WORK4(ITIME).EQ.FBLANK)) GO TO 190
            IF ((RECR(REKOL).EQ.FBLANK) .OR. (RECR(IMKOL).EQ.FBLANK))
     *         THEN
               IF (XDOBLK.GE.0.0) THEN
                  RECR(REKOL) = WORK1(ITIME) * COS (WORK2(ITIME))
                  RECR(IMKOL) = WORK1(ITIME) * SIN (WORK2(ITIME))
                  RECR(RATKOL) = WORK3(ITIME)
                  RECR(DELKOL) = WORK4(ITIME)
                  CNTDO = CNTDO + 1
                  END IF
            ELSE IF (XDOBLK.LE.0.0) THEN
               RECR(REKOL) = WORK1(ITIME) * COS (WORK2(ITIME))
               RECR(IMKOL) = WORK1(ITIME) * SIN (WORK2(ITIME))
               RECR(RATKOL) = WORK3(ITIME)
               RECR(DELKOL) = WORK4(ITIME)
               CNTDO = CNTDO + 1
               END IF
C                                       Mean gain modulus
            IF (RECR(REKOL).NE.FBLANK) THEN
               GMCNT = GMCNT + 1
               GMSUM = GMSUM + SQRT (RECR(REKOL)*RECR(REKOL) +
     *            RECR(IMKOL)*RECR(IMKOL))
               END IF
C                                       delay,rate
         ELSE IF (SMOTYP.EQ.5) THEN
            IF ((WORK1(ITIME).EQ.FBLANK) .OR. (WORK2(ITIME).EQ.FBLANK))
     *         GO TO 190
            IF ((RECR(DELKOL).EQ.FBLANK) .OR. (RECR(RATKOL).EQ.FBLANK))
     *         THEN
               IF (XDOBLK.GE.0.0) THEN
                  RECR(RATKOL) = WORK1(ITIME)
                  RECR(DELKOL) = WORK2(ITIME)
                  CNTDO = CNTDO + 1
                  END IF
            ELSE IF (XDOBLK.LE.0.0) THEN
               RECR(RATKOL) = WORK1(ITIME)
               RECR(DELKOL) = WORK2(ITIME)
               CNTDO = CNTDO + 1
               END IF
            END IF
C                                       Count entries changed
 190     ITIME = ITIME + 1
C                                       Rewrite record
        CALL TABIO ('WRIT', IRCODE, ICLRNO, RECORD, BUFFER, IRET)
        IF (IRET.NE.0) GO TO 900
 200    CONTINUE
 590               FSTREC = SAVE
C                                       End of antenna loop
 600               CONTINUE
C                                       End of IF loop, update pointers
 640            WTKOL = WTKOL + 1
                REKOL = REKOL + 1
                IMKOL = IMKOL + 1
                DELKOL = DELKOL + 1
                RATKOL = RATKOL + 1
                TSKOL = TSKOL + 1
 650            CONTINUE
C                                       End of Stokes loop, update
 660         WTKOL = WT2KOL
             REKOL = RE2KOL
             IMKOL = IM2KOL
             DELKOL = DL2KOL
             RATKOL = RA2KOL
             TSKOL = TS2KOL
 700         CONTINUE
C                                       End subarray loop
 750      CONTINUE
C                                       Update GMMOD
      IF (((ABS (GMMOD-1.0).GT.1.0E-5) .AND. (XNORM.EQ.0.0)) .OR.
     *   (XNORM.GT.0.0)) THEN
         IF (GMCNT.GT.0) THEN
            GMMOD = GMSUM / GMCNT
            CALL TABKEY ('WRIT', KEYWRD, 1, BUFFER, 1, GMMOD, 2, IERR)
            END IF
         END IF
C                                       Close table
      CALL TABIO ('CLOS', IRCODE, ITIME, RECORD, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 900
C                                       Number changed
      WRITE (MSGTXT,1890) CNTDO
      CALL MSGWRT (4)
      GO TO 999
C                                       TABIO error
 900  WRITE (MSGTXT,1900) IRET
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('CLSMTH: Smoothing CL table')
 1890 FORMAT ('Changed ',I6,' entries')
 1900 FORMAT ('CLSMTH: TABIO ERROR',I3,' SMOOTHING VALUES')
      END
      SUBROUTINE CLSMSM (SMMETH, SMOTIM, TIME, IN, SRC, BLANK, NUMTIM,
     *   OUT)
C-----------------------------------------------------------------------
C   Routine to call appropriate smoothing routine.  Magic value blanking
C   is supported.
C   Inputs:
C      SMMETH   C*4    Method 'BOX','MWF', unknown = 'BOX'
C      SMOTIM   R(3)   Smoothing time (days): support, FWHM, cutoff
C      TIME     R(*)   Times (days)
C      IN       R(*)   Input values.
C      SRC      I(*)   Source number list
C      BLANK    R      Magic blank value.
C      NUMTIM   I      Number of time/values
C   Output:
C      OUT      R(*) Output array
C-----------------------------------------------------------------------
      CHARACTER SMMETH*4
      REAL      SMOTIM(3), TIME(*), IN(*), BLANK, OUT(*)
      INTEGER   SRC(*), NUMTIM
C-----------------------------------------------------------------------
C                                       Median window filter
      IF (SMMETH.EQ.'MWF ') THEN
         CALL MWFBSM (SMOTIM, TIME, IN, SRC, BLANK, NUMTIM, OUT)
C                                       function types
      ELSE IF (SMMETH.EQ.'GAUS') THEN
         CALL FUNBSM (SMMETH, SMOTIM(3), SMOTIM, TIME, IN, SRC, BLANK,
     *      NUMTIM, OUT)
      ELSE IF (SMMETH.EQ.'EXP ') THEN
         CALL FUNBSM (SMMETH, SMOTIM(3), SMOTIM, TIME, IN, SRC, BLANK,
     *      NUMTIM, OUT)
      ELSE IF (SMMETH.EQ.'LINE') THEN
         CALL FUNBSM (SMMETH, SMOTIM(3), SMOTIM, TIME, IN, SRC, BLANK,
     *      NUMTIM, OUT)
C                                       2-point
      ELSE IF (SMMETH.EQ.'2PT ') THEN
         CALL TPTBSM (SMOTIM, TIME, IN, SRC, BLANK, NUMTIM, .FALSE.,
     *      OUT)
C                                       2-point - hanning
      ELSE IF (SMMETH.EQ.'2PTH') THEN
         CALL TPTBSM (SMOTIM, TIME, IN, SRC, BLANK, NUMTIM, .TRUE., OUT)
C                                       Default = Boxcar
      ELSE
         CALL BOXBSM (SMOTIM, TIME, IN, SRC, BLANK, NUMTIM, OUT)
         END IF
C
 999  RETURN
      END
      SUBROUTINE CLSMHI
C-----------------------------------------------------------------------
C   CLSMHI copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, CTIME(2)*12, LABEL*8
      INTEGER   LUN1, IERR, I, TIME(3), DATE(3), LIMIT, LIMIT2, J
      REAL      TIMBEG, TIMEND
      LOGICAL   T
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'CLSMO.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1 /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HIOPEN (LUN1, DISKIN, FCNO(NCFILE), BUFFER, IERR)
      IF (IERR.LE.2) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
C                                       Task message
 10   CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,1010) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN1, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Sources
      IF (NSOUWD.LE.0) THEN
         WRITE (HILINE,3000) TSKNAM
         CALL HIADD (LUN1, HILINE, BUFFER, IERR)
      ELSE
C                                       Included or excluded?
         WRITE (HILINE,3001) TSKNAM
         IF (DOSWNT) WRITE (HILINE,3002) TSKNAM
         CALL HIADD (LUN1, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       1st 2 and label.
         WRITE (HILINE,3003) TSKNAM, XSOUR(1), XSOUR(2)
         CALL HIADD (LUN1, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       Rest of sources
         DO 20 I = 3,NSOUWD,2
            WRITE (HILINE,3004) TSKNAM, XSOUR(I), XSOUR(I+1)
            CALL HIADD (LUN1, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 100
 20         CONTINUE
         END IF
C                                       Antennas
      IF (NANTSL.LE.0) THEN
         WRITE (HILINE,3005) TSKNAM
         CALL HIADD (LUN1, HILINE, BUFFER, IERR)
      ELSE
C                                       Included or excluded?
         WRITE (HILINE,3006) TSKNAM
         IF (DOAWNT) WRITE (HILINE,3007) TSKNAM
         CALL HIADD (LUN1, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       1st 12 and label.
         LIMIT = MIN (12, NANTSL)
         WRITE (HILINE,3008) TSKNAM, (ANTENS(J),J=1,LIMIT)
         CALL HIADD (LUN1, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       Rest of antennas
         DO 30 I = 13,NANTSL,12
            LIMIT = I
            LIMIT2 = I + 11
            LIMIT2 = MIN (NANTSL, LIMIT2)
            WRITE (HILINE,3009) TSKNAM, (ANTENS(J),J=LIMIT,LIMIT2)
            CALL HIADD (LUN1, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 100
 30         CONTINUE
         END IF
C                                       Timerange
      TIMBEG = XTIME(1) + XTIME(2) / 24.0 + XTIME(3) / (24.0*60.0) +
     *   (XTIME(4) / (24.0*60.0*60.0))
      TIMEND = XTIME(5) + XTIME(6) / 24.0 + XTIME(7) / (24.0*60.0) +
     *   (XTIME(8) / (24.0*60.0*60.0))
      IF ((TIMEND.LT.TIMBEG) .OR. (TIMEND.LT.1.0E-5)) TIMEND = 1.0E20
      CALL HITIME (TIMBEG, TIMEND, LUN1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Stokes'
      WRITE (HILINE,2005) TSKNAM, XSTOK
      CALL HIADD (LUN1, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       IF range
      WRITE (HILINE,2004) TSKNAM, BIF, EIF
      CALL HIADD (LUN1, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       SUBARRAY, GAINVER
      WRITE (HILINE,2002) TSKNAM, SUBA, CLVER
      CALL HIADD (LUN1, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Interpolation fn
      WRITE (HILINE,2006) TSKNAM, XINTP
      CALL HIADD (LUN1, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Interpolation parms
      WRITE (HILINE,2007) TSKNAM, XIPARM(1), XIPARM(2), XIPARM(3)
      CALL HIADD (LUN1, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,4007) TSKNAM, XIPARM(4), 'support'
      CALL HIADD (LUN1, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       extra parms
      IF ((XINTP.EQ.'GAUS') .OR. (XINTP.EQ.'EXP ') .OR.
     *   (XINTP.EQ.'LINE')) THEN
         WRITE (HILINE,2007) TSKNAM, XIPARM(6), XIPARM(7), XIPARM(8)
         CALL HIADD (LUN1, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 100
         WRITE (HILINE,4007) TSKNAM, XIPARM(9), 'FWHM'
         CALL HIADD (LUN1, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 100
         WRITE (HILINE,4008) TSKNAM, CUTOFF
         CALL HIADD (LUN1, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 100
         END IF
C                                       smoothing type
      WRITE (HILINE,2008) TSKNAM, XSMO
      CALL HIADD (LUN1, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                      Add any other history.
         IF (NUMHIS.LE.0) GO TO 100
         WRITE (LABEL,1011) TSKNAM
         HILINE(1:8) = LABEL(1:8)
         DO 90 I = 1,NUMHIS
            HILINE(9:72) = HISCRD(I)(1:64)
            CALL HIADD (LUN1, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 100
 90         CONTINUE
C                                       Close HI file
 100  CALL HICLOS (LUN1, T, BUFFER, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLSMHI: ERROR',I3,' OPENING HISTORY FILE')
 1010 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 1011 FORMAT (A6,'  ')
 2002 FORMAT (A6,'SUBARRAY =',I3,' GAINVER = ',I4,' /CL table')
 2004 FORMAT (A6,'BIF =',I4,', EIF =',I4,'/ IF range')
 2005 FORMAT (A6,'STOKES = ''',A4,''' / Stokes type')
 2006 FORMAT (A6,'INTERPOL = ''',A4,''' / Interpolation type')
 2007 FORMAT (A6,'INTPARM = ',3F10.5,' / Interpolation parms')
 4007 FORMAT (A6,'          ',F10.5,' / Interpolation ',A)
 4008 FORMAT (A6,'CUTOFF =',F8.5,'  / sum of weights cutoff')
 2008 FORMAT (A6,'SMOTYPE = ''',A4,''' / Data to be smoothed')
 3000 FORMAT (A6,'SOURCES = ''''     /All sources selected')
 3001 FORMAT (A6,'/Sources excluded:')
 3002 FORMAT (A6,'/Sources included:')
 3003 FORMAT (A6,'SOURCES = ''',A16,''',''',A16,'''')
 3004 FORMAT (A6,'         ,''',A16,''',''',A16,'''')
 3005 FORMAT (A6,'ANTENNAS = 0     /All antennas selected')
 3006 FORMAT (A6,'/Antennas excluded:')
 3007 FORMAT (A6,'/Antennas included:')
 3008 FORMAT (A6,'ANTENNAS = ',12(I3,' '))
 3009 FORMAT (A6,'           ',12(I3,' '))
      END

      SUBROUTINE VISCHK (OPCODE, STYPE, JADR, VISIN, WT, VISOUT, IERR)
C-----------------------------------------------------------------------
C! checks if UV data sample is desired, returns it in RR, LL, RL, LR
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   VISCHK is used with AIPS map making type operations to determine
C   if the uv sample is desired and to return the sample in the
C   normal set (RR, LL, RL, LR).
C   Inputs:
C      OPCODE   C*4       'INIT' inits JADR, checks data set type
C                         'WANT' determines if vis sample wanted
C                         'GETV' does WANT, returns RR et al.
C      STYPE    I         Stokes mapping type: 1 - 7 => I, IQU, IV,
C                         IQUV, R, L, RL
C      VISIN    R(*)      Visibilities from data record (GETV)
C   In/Out:
C      JADR     I(4)      Pointers to pick up vis data: set by INIT,
C                         used by WANT and GETV.
C   Output:
C      WT       R(4)      Weight array (GETV)
C      VISOUT   R(2,4)    Visibilities in RR, LL, RL, LR (GETV)
C      IERR     I         Error code: 0 => ok
C                            1 => bad OPCODE specified
C                            2 => Stokes req. impossible (INIT)
C                            3 => Vis sample not wanted
C   Common:
C      /MAPHDR/ input     CATBLK gives coordinate info
C      /UVHDR/  input     UV pointers set by UVPGET
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   STYPE, JADR(4), IERR
      REAL      VISIN(*), WT(4), VISOUT(8)
C
      REAL      TEMP, RWT, CATR(256)
      INTEGER   I, J, IROUND, IT, K
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      COMMON /MAPHDR/ CATR
C-----------------------------------------------------------------------
C                                       INIT
      IF (OPCODE.EQ.'INIT') THEN
         IERR = 0
         CALL FILL (4, 0, JADR)
C                                       Real Stokes
         IF (ICOR0.GT.0) THEN
            DO 10 I = 1,4
               TEMP = (I-ICOR0) / CATR(KRCIC+JLOCS) + 1.0
               IT = IROUND(TEMP)
               IF ((ABS(TEMP-IT).LT.0.1) .AND. (IT.GE.1) .AND.
     *            (IT.LE.NCOR)) JADR(IT) = (I-1) * INCS + 1
 10            CONTINUE
C                                       Check real Stokes
            IF (JADR(1).LE.0) GO TO 990
            IF ((STYPE.GT.2) .AND. (JADR(4).LE.0)) GO TO 990
            IF (((STYPE.EQ.2) .OR. (STYPE.EQ.4)) .AND. ((JADR(2).LE.0)
     *         .OR. (JADR(3).LE.0))) GO TO 990
C                                       Init RR ...
         ELSE
            DO 30 I = 1,4
               TEMP = -(I+ICOR0) / CATR(KRCIC+JLOCS) + 1.0
               IT = IROUND(TEMP)
               IF ((ABS(TEMP-IT).LT.0.1) .AND. (IT.GE.1) .AND.
     *            (IT.LE.NCOR)) JADR(IT) = (I-1) * INCS + 1
 30            CONTINUE
C                                       Check RR Stokes
            IF ((JADR(1).LE.0) .AND. (JADR(2).LE.0)) GO TO 990
            IF (((STYPE.EQ.3) .OR. (STYPE.EQ.4) .OR. (STYPE.EQ.7)) .AND.
     *         ((JADR(1).LE.0) .OR. (JADR(2).LE.0))) GO TO 990
            IF ((STYPE.EQ.5) .AND. (JADR(1).LE.0)) GO TO 990
            IF ((STYPE.EQ.6) .AND. (JADR(2).LE.0)) GO TO 990
            IF (((STYPE.EQ.2) .OR. (STYPE.EQ.4)) .AND. ((JADR(3).LE.0)
     *         .OR. (JADR(4).LE.0))) GO TO 990
            END IF
C                                       WANT this one?
      ELSE IF ((OPCODE.EQ.'WANT') .OR. (OPCODE.EQ.'GETV')) THEN
         IERR = 3
         IF (ICOR0.GT.0) THEN
            IF (VISIN(JADR(1)+2).LE.0.) GO TO 999
            IF ((STYPE.GT.2) .AND. (VISIN(JADR(4)+2).LE.0.)) GO TO 999
            IF (((STYPE.EQ.2) .OR. (STYPE.EQ.4)) .AND.
     *         (((VISIN(JADR(2)+2).LE.0.) .AND. (JADR(2).GT.0)) .OR.
     *         ((VISIN(JADR(3)+2).LE.0.) .AND. (JADR(3).GT.0))))
     *         GO TO 999
         ELSE
            IF ((JADR(1).GT.0) .AND. (JADR(2).GT.0) .AND.
     *         (VISIN(JADR(1)+2).LE.0.) .AND. (VISIN(JADR(2)+2).LE.0.))
     *         GO TO 999
            IF (((STYPE.EQ.3) .OR. (STYPE.EQ.4) .OR. (STYPE.EQ.7)) .AND.
     *         ((VISIN(JADR(1)+2).LE.0.) .OR. (VISIN(JADR(2)+2).LE.0.)))
     *         GO TO 999
            IF ((STYPE.EQ.5) .AND. (VISIN(JADR(1)+2).LE.0)) GO TO 999
            IF ((STYPE.EQ.6) .AND. (VISIN(JADR(2)+2).LE.0)) GO TO 999
            IF (((STYPE.EQ.2) .OR. (STYPE.EQ.4)) .AND.
     *         ((VISIN(JADR(3)+2).LE.0.) .OR. (VISIN(JADR(4)+2).LE.0.)))
     *         GO TO 999
            END IF
C                                       do GETVis part
         IERR = 0
         IF (OPCODE.EQ.'GETV') THEN
            CALL RFILL (4, 0.0, WT)
C                                       RR type -> correct RR order
            IF (ICOR0.LE.0) THEN
               DO 210 I = 1,4
                  J = JADR(I)
                  IF (J.GT.0) THEN
                     WT(I) = MAX (0.0, VISIN(J+2))
                     VISOUT(2*I-1) = VISIN(J)
                     VISOUT(2*I) = VISIN(J+1)
                     END IF
 210              CONTINUE
C                                       True Stokes -> RR type
 220        ELSE
               J = JADR(1)
               RWT = 0.0
               IF ((J.GT.0) .AND. (VISIN(J+2).GT.0.)) THEN
                  RWT = VISIN(J+2)
                  VISOUT(1) = VISIN(J)
                  VISOUT(2) = VISIN(J+1)
                  VISOUT(3) = VISOUT(1)
                  VISOUT(4) = VISOUT(2)
                  J = JADR(4)
                  IF ((J.GT.0) .AND. (VISIN(J+2).GT.0.)) THEN
                     VISOUT(1) = VISOUT(1) + VISIN(J)
                     VISOUT(2) = VISOUT(2) + VISIN(J+1)
                     VISOUT(3) = VISOUT(3) - VISIN(J)
                     VISOUT(4) = VISOUT(4) - VISIN(J+1)
                     RWT = MIN (RWT, VISIN(J+2))
                     END IF
                  END IF
 230           J = JADR(2)
               K = JADR(3)
               IF ((J.GT.0) .AND. (K.GT.0) .AND. (VISIN(J+2).GT.0.)
     *            .AND. (VISIN(K+2).GT.0.)) THEN
                  VISOUT(5) = VISIN(J) - VISIN(K+1)
                  VISOUT(6) = VISIN(J+1) + VISIN(K)
                  VISOUT(7) = VISIN(J) + VISIN(K+1)
                  VISOUT(8) = VISIN(J+1) - VISIN(K)
                  IF (RWT.EQ.0) RWT = VISIN(J+2)
                  RWT = MIN (RWT, VISIN(J+2))
                  RWT = MIN (RWT, VISIN(K+2))
                  END IF
               CALL RFILL (4, RWT, WT)
               END IF
            END IF
C                                       bad opcode
      ELSE
         IERR = 1
         END IF
      GO TO 999
C                                       Error report on data set
 990  WRITE (MSGTXT,1990)
      CALL MSGWRT (8)
      IERR = 2
C
 999  RETURN
C-----------------------------------------------------------------------
 1990 FORMAT ('REQUESTED STOKES NOT AVAILABLE IN DATA SET')
      END

      SUBROUTINE QMEMSZ (NWORDS)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Find max. value element of a vector.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Manipulates the size of the blank common used for the "AP"
C   memory and vector work space.  The size of the blank common
C   is expanded to NWORDS if that is larger than the current size
C   or reduces the size to zero if NWORDS is zero.
C   Inputs:
C     NWORDS  I    The number of words desired in the blank common
C   Input from common /SPF/ (include D/CAPC.INC)
C     MEMSIZ  I    The current size of the blank common.
C                  -1 => minimum size.
C   Output to common /SPF/
C     MEMSIZ  I    The current size of the blank common.
C                  -1 => minimum size.
C   CRI version (stubbed pending development).
C-----------------------------------------------------------------------
      INTEGER   NWORDS
C
      INTEGER   JWORDS, CHEKIT, IERR
      INCLUDE   'INCS:DAPC.INC'
      DATA CHEKIT /0/
C-----------------------------------------------------------------------
C                                       Check if need to change size
      IF ((NWORDS.LE.MEMSIZ) .AND. (NWORDS.GT.0)) GO TO 999
      IF ((NWORDS.EQ.0) .AND. (MEMSIZ.LT.0)) GO TO 999
C                                       Trap first call (full size).
C                                       NB: May cause trouble for
C                                       overlaying!
         IF (CHEKIT.EQ.0) MEMSIZ = OFF2 + 12 * OFFDEL
         CHEKIT = 1000
C                                       Change size.
         JWORDS = NWORDS - MEMSIZ + 1
         IF (MEMSIZ.LT.0) JWORDS = NWORDS
         IF (NWORDS.EQ.0) JWORDS = - MEMSIZ
C         CALL MEMORY ('UC', JWORDS)
C         CALL HPALLOC (IPTR, JWORDS, IERR, 0)
C         IF (IERR.NE.0) THEN
C            WRITE (6,*) 'QMEMSZ: HPALLOC ERRCODE =', IERR
C            CALL ABORT ()
C            END IF
         IF (NWORDS.GT.0) MEMSIZ = MEMSIZ + JWORDS
         IF (NWORDS.LE.0) MEMSIZ = -1
C
 999  RETURN
      END

      SUBROUTINE ZTTCLS (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C! close a terminal device
C# Z2 Terminal
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Close a terminal - to avoid recursion, don't call MSGWRT
C   Inputs:
C      LUN    I   Logical unit number (only 5 or 6 valid)
C      FIND   I   Pointer into FTAB
C   Output:
C      IERR   I   Error return code: 0 => no error
C                    1 => error - bad LUN
C   VMS version - can return Fortran error in FTAB(find+1)
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
C
      INTEGER   JERR
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
C-----------------------------------------------------------------------
      CLOSE (UNIT=LUN, IOSTAT=JERR)
      IF (JERR.EQ.0) THEN
         IERR = 0
         FTAB(FIND+1+NFCBER) = 0
      ELSE
         IERR = 1
         FTAB(FIND+1+NFCBER) = JERR
         END IF
 
C
 999  RETURN
      END

      SUBROUTINE YGGRAM (OP, VRTRTC, RGBBUF, IERR)
C-----------------------------------------------------------------------
C! controls the TV graphics color assignments
C# Y3 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YGGRAM reads/writes the TV graphics color assignment RAM.  The
C   data are packed in this look up table for colors as:
C         bit 15 (msb)   :   1 - graphics replace 0 - add to image
C         bits 10-14     :   red value for this graphics value
C         bits  5- 9     :   green
C         bits  0- 4     :   blue
C   Inputs:
C      OP      C*4       'READ' from TV or 'WRIT' to TV
C      VRTRTC  L         T => do it only on vertical retrace
C   In/Out:
C      RGBBUF  I(256)    data array
C   Out:
C      IERR    I         error code of Z...XF : 0 => ok
C   Version for IIS Model 75
C   maps the M70 graphics RAM (256 words) to the M75 graphics RAM
C   (512 words) by ignoring the 7th bit plane on M75 and match the
C   7th bit on M70 to 9th bit on M75.
C   i.e.  M70:   0  1  2  3  4  5  6   7
C         M75:   0  1  2  3  4  5  6 7 8
C                                    :........>ignoring
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   RGBBUF(256), IERR
      LOGICAL   VRTRTC
C
      INTEGER   UNIT, HEADER(8), BUFSIZ, NB, I, BUFFER(512)
      LOGICAL   COMAND
      DATA UNIT, COMAND, BUFSIZ /9,.FALSE., 512/
C-----------------------------------------------------------------------
      IF (OP.EQ.'WRIT') THEN
         CALL COPY (128, RGBBUF(1), BUFFER(1))
         CALL COPY (128, RGBBUF(1), BUFFER(129))
         CALL COPY (128, RGBBUF(129), BUFFER(257))
         CALL COPY (128, RGBBUF(129), BUFFER(385))
         END IF
      CALL YMKHDR (OP, UNIT, COMAND, BUFSIZ, 0, 0, 0, 0, VRTRTC, HEADER)
      NB = 2 * BUFSIZ
      CALL ZM70XF (OP, NB, HEADER, BUFFER, IERR)
      IF ((IERR.EQ.0) .AND. (OP.NE.'WRIT')) THEN
         CALL COPY (128, BUFFER(1), RGBBUF(1))
         CALL COPY (128, BUFFER(257), RGBBUF(129))
         END IF
C
 999  RETURN
      END

      SUBROUTINE TABPP (OPCODE, BUFFER, IPPRNO, PPKOLS, PPNUMV, TIME,
     *   SUBA, FREQID, PHASES, ERRORS, IERR)
C-----------------------------------------------------------------------
C! Does I/O to phase differenence (PP) table opened by PPINI
C# EXT-util UV Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 2019, 2021-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to phase difference (PP) extention tables. Used after
C   setup by PPINI.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'READ' = read entry from table.
C                        'WRIT' = write entry in table.
C                        'CLOS' = close file, flush on write
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open. Should have been returned by
C                        PPINI or TABINI.
C      IPPRNO   I        Next entry number to read or write.
C      PPKOLS   I(MAXPPC) The column pointer array in order,
C                        SUBARRAY, FREQID,
C                        data
C      PPNUMV   I(MAXPPC) Element count in each column.
C   Input/output: (written to or read from baseline file)
C      SUBA    I        Subarray number.
C      FREQID  I        Freq. id number
C      PHASES  D(n,m)   Phases: m IFS; n channels; p polns
C      ERRORS  D(n,m)   Phases errors: m IFS; n channels; p polns
C   Output:
C      IPPRNO    I      Next solution number.
C      IERR      I      Error code, 0=>OK else TABIO error.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   XPPRSZ, MAXPPC
      PARAMETER (XPPRSZ = 3 + MAXCIF)
      PARAMETER (MAXPPC = 5)
C
      CHARACTER OPCODE*4
      REAL      TIME
      INTEGER   BUFFER(*), IPPRNO, PPKOLS(MAXPPC), PPNUMV(MAXPPC),
     *   SUBA, FREQID, IERR
      DOUBLE PRECISION PHASES(*), ERRORS(*)
C
      INTEGER   RECI(XPPRSZ), KOLS(MAXPPC), TIMKOL, SUBKOL, FRQKOL,
     *   PHSKOL, ERRKOL, LOOP, NDATA, INDX, NNDX
      REAL      RECORD(XPPRSZ)
      DOUBLE PRECISION RECD(XPPRSZ/2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (KOLS(1), TIMKOL),  (KOLS(2), SUBKOL),
     *    (KOLS(3), FRQKOL), (KOLS(4), PHSKOL), (KOLS(5), ERRKOL)
      SAVE RECORD
      EQUIVALENCE (RECD, RECORD, RECI)
C-----------------------------------------------------------------------
C                                       Close
      IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, IPPRNO, RECORD, BUFFER, IERR)
         IF (IERR.GT.0) GO TO 980
         GO TO 999
         END IF
C                                       Check sizes
      NNDX = PPNUMV(4)
      IF (NNDX.GT.MAXCIF) THEN
         IERR = 1
         MSGTXT = 'TABPP: RECORDS TOO BIG FOR BUFFERS'
         GO TO 985
         END IF
      IF (NNDX.LE.0) THEN
         IERR = 1
         MSGTXT = 'TABPP: ZERO SIZE DATA REQUESTED'
         GO TO 985
         END IF
C                                       Set pointers
      NDATA = MAXPPC
      CALL COPY (NDATA, PPKOLS, KOLS)
C                                       If write fill RECORD
      IF (OPCODE.NE.'READ') THEN
         RECORD(TIMKOL) = TIME
         RECI(SUBKOL) = SUBA
         IF (FRQKOL.GT.0) RECI(FRQKOL) = FREQID
C
         INDX = PHSKOL - 1
         DO 20 LOOP = 1,NNDX
            INDX = INDX + 1
            IF (PHASES(LOOP).EQ.DBLANK) THEN
               RECORD(INDX) = FBLANK
            ELSE
               RECORD(INDX) = PHASES(LOOP)
               END IF
 20         CONTINUE
         INDX = ERRKOL - 1
         DO 25 LOOP = 1,NNDX
            INDX = INDX + 1
            IF (ERRORS(LOOP).EQ.DBLANK) THEN
               RECORD(INDX) = FBLANK
            ELSE
               RECORD(INDX) = ERRORS(LOOP)
               END IF
 25         CONTINUE
         END IF
C                                       Process record.
      CALL TABIO (OPCODE, 0, IPPRNO, RECORD, BUFFER, IERR)
      IPPRNO = IPPRNO + 1
      IF (IERR.GT.0) GO TO 980
C                                       If READ pick data from RECORD.
      IF (OPCODE.EQ.'READ') THEN
         TIME = RECORD(TIMKOL)
         SUBA   = RECI(SUBKOL)
         IF (FRQKOL.LE.0) THEN
            FREQID = 1
         ELSE
            FREQID = RECI(FRQKOL)
            END IF
C                                       phase shifts
         INDX = PHSKOL - 1
         DO 80 LOOP = 1,NNDX
            INDX = INDX + 1
            IF (RECORD(INDX).EQ.FBLANK) THEN
               PHASES(LOOP) = DBLANK
            ELSE
               PHASES(LOOP) = RECORD(INDX)
               END IF
 80         CONTINUE
C                                       errors - may be missing
         CALL DFILL (NNDX, 0.0D0, ERRORS)
         INDX = ERRKOL - 1
         NNDX = PPNUMV(5)
         DO 85 LOOP = 1,NNDX
            INDX = INDX + 1
            IF (RECORD(INDX).EQ.FBLANK) THEN
               ERRORS(LOOP) = DBLANK
            ELSE
               ERRORS(LOOP) = RECORD(INDX)
               END IF
 85         CONTINUE
         END IF
      GO TO 999
C                                       Error
 980  WRITE (MSGTXT,1980) IERR
C
 985  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('TABPP: TABIO ERROR',I3)
      END

LOCAL INCLUDE 'PRMFIT.INC'
      INTEGER   MAXCMP, NCOLRM
      PARAMETER (MAXCMP=4)
      PARAMETER (NCOLRM=14)
LOCAL END
      SUBROUTINE RMINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IRMRNO, RMKOLS, RMNUMV, IBLC, ITRC, IYINC, IZINC, ICLIP,
     *   PCLIP, PDONE, SPIXDO, IRET)
C-----------------------------------------------------------------------
C! RMFIT answer/work table - rotation measure models
C# Table Extension Polarization
C-----------------------------------------------------------------------
C;  Copyright (C) 2013-2015, 2020-2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes Component fit (RM) extension tables.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'WRIT' = create/init for write or read
C                        'READ' = open for read only
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      LUN      I        Logical unit number to use
C   Input/output
C      VER      I        RM file version
C      CATBLK   I(256)   Catalog header block.
C   Input (create) / output (pre-existing)
C      IBLC     I(2)     BLC of Y,Z plane
C      ITRC     I(2)     TRC of Y,Z plane
C      IYINC    I        increment in Y
C      IZINC    I        increment in Z
C      ICLIP    R        fit spectra only above I value ICLIP
C      PCLIP    R        fit spectra only above P value PCLIP
C      PDONE    I        number of planes with fit attempts
C      SPIXDO   I        Fitting spectral index (1), thickness (2)
C   Output:
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      IRMRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      RMKOLS   I(MAXRMC)   The column pointer array in order:
C                        pixel(2), #comp, I average, P average,
C                        Pone(4), ThetaOne(4), rot.measure(4), spectral
C                        index(4), errors 4 of (4)
C      RMNUMV   I(MAXRMC)   Element count in each column.
C      IERR     I        Return error code, 0=>OK, else TABINI or TABIO
C                        error.
C   MAXRMC = 10 only known locally.
C-----------------------------------------------------------------------
      INTEGER   MAXRMK
      PARAMETER (MAXRMK = 10)
      INCLUDE 'PRMFIT.INC'
C
      CHARACTER OPCODE*4
      INTEGER   BUFFER(*), DISK, CNO, VER, CATBLK(256), LUN, IRMRNO,
     *   RMKOLS(NCOLRM), RMNUMV(NCOLRM), IBLC(2), ITRC(2), IYINC, IZINC,
     *   PDONE, SPIXDO, IRET
      REAL      ICLIP, PCLIP
C
      HOLLERITH HOLTMP(6)
      CHARACTER TTITLE*56, TITLE(NCOLRM)*24, UNITS(NCOLRM)*8,
     *   KEYW(MAXRMK)*8
      INTEGER   NKEY, NREC, DATP(128,2), NCOL, NTT, DTYP(NCOLRM), NDATA,
     *   KLOCS(MAXRMK), KEYVAL(MAXRMK+2), KEYTYP(MAXRMK), IPOINT,
     *   MSGSAV, I, NC, JERR, JTRIM, ITEMP(6)
      DOUBLE PRECISION KEYVAD(6), XX
      LOGICAL   DOREAD, NEWFIL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (KEYVAL, KEYVAD), (ITEMP, HOLTMP)
      DATA TTITLE /'AIPS ROTATION MEASURE FIT TABLE'/
      DATA DTYP /24, 14, 12, 12, 8*2, 2*22/
      DATA TITLE /'PIXEL', 'NCOMP', 'IFLUX', 'PFLUX', 'PONE',
     *   'THETA', 'ROT.MEAS', 'SPECINDX', 'ERR P1', 'ERR THET',
     *   'ERR RM', 'ERR SPIX', 'QU RMS ', 'WTED QU RMS'/
      DATA UNITS /'PIXELS', ' ', 2*'JY/BEAM', 'JY/BEAM', 'DEGREES',
     *   'RAD/M/M', ' ', 'JY/BEAM', 'DEGREES', 'RAD/M/M', ' ',
     *   2*'JY/BEAM'/
      DATA KEYW /'YBLC', 'YTRC', 'ZBLC', 'ZTRC', 'YINC', 'ZINC',
     *   'ICLIP', 'PCLIP', 'PIX_FIT', 'DOSPIX'/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NREC = 500
      NKEY = MAXRMK
      NDATA = NCOLRM
      NCOL = NDATA
      CALL FILL (NDATA, 0, RMKOLS)
      CALL FILL (NDATA, 0, RMNUMV)
C                                       Fill in types
      IF (.NOT.DOREAD) THEN
         IF (SPIXDO.GE.2) THEN
            TITLE(8) = 'THICKNESS'
            TITLE(12) = 'ERR THICK'
            UNITS(8) = UNITS(7)
            UNITS(12) = UNITS(7)
            END IF
         CALL COPY (NDATA, DTYP, DATP(1,2))
         DO 5 I = 5,4+2*MAXCMP
            DATP(I,2) = 10 * MAXCMP + 2
 5          CONTINUE
      ELSE
         NCOL = 0
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'RM', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IRET)
      IF (IRET.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'RMINI', IRET)
         GO TO 990
         END IF
      NEWFIL = IRET.LT.0
      MSGSAV = MSGSUP
C                                       Get number of scans
      IRMRNO = BUFFER(5) + 1
      IF (DOREAD) IRMRNO = 1
      NKEY = MAXRMK
C                                       File created, initialize
      IF (NEWFIL) THEN
         CALL H2CHR (8, 1, CATBLK(KHBUN), UNITS(3))
         UNITS(4) = UNITS(3)
         UNITS(5) = UNITS(3)
         UNITS(9) = UNITS(3)
C                                       Col. labels.
         DO 10 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IRET)
            IF (IRET.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'RMINI', IRET)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IRET)
            IF (IRET.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'RMINI', IRET)
               GO TO 990
               END IF
 10         CONTINUE
C                                       Fill in Table title
         NTT = JTRIM (TTITLE)
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       Set keyword values
C                                       yblc
         KLOCS(1) = 1
         KEYTYP(1) = 4
         KEYVAL(1) = IBLC(1)
C                                       ytrc
         KLOCS(2) = 2
         KEYTYP(2) = 4
         KEYVAL(2) = ITRC(1)
C                                       zblc
         KLOCS(3) = 3
         KEYTYP(3) = 4
         KEYVAL(3) = IBLC(2)
C                                       ztrc
         KLOCS(4) = 4
         KEYTYP(4) = 4
         KEYVAL(4) = ITRC(2)
C                                       yinc
         KLOCS(5) = 5
         KEYTYP(5) = 4
         KEYVAL(5) = IYINC
C                                       zinc
         KLOCS(6) = 6
         KEYTYP(6) = 4
         KEYVAL(6) = IZINC
C                                       I clip value
         KLOCS(7) = 7
         KEYTYP(7) = 1
         KEYVAD(4) = ICLIP
C                                       P clip value
         KLOCS(8) = 9
         KEYTYP(8) = 1
         KEYVAD(5) = PCLIP
C                                       number done
         PDONE = 0
         KLOCS(9) = 11
         KEYTYP(9) = 4
         KEYVAL(11) = PDONE
C                                       spectral index, thickness
         KLOCS(10) = 12
         KEYTYP(10) = 4
         KEYVAL(12) = SPIXDO
C                                       Only write if just created.
         CALL TABKEY ('WRIT', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IRET)
         IF ((IRET.GE.1) .AND. (IRET.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'RMINI', IRET)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         MSGSUP = 32000
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IRET)
         MSGSUP = MSGSAV
         IF ((IRET.GE.1) .AND. (IRET.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'RMINI', IRET)
            GO TO 990
            END IF
C                                       Retrieve keyword values
C                                       yblc
         IBLC(1) = 0
         IPOINT = KLOCS(1)
         IF (IPOINT.GT.0) IBLC(1) = KEYVAL(IPOINT)
C                                       ytrc
         ITRC(1) = 0
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) ITRC(1) = KEYVAL(IPOINT)
C                                       zblc
         IBLC(2) = 0
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) IBLC(2) = KEYVAL(IPOINT)
C                                       ztrc
         ITRC(2) = 0
         IPOINT = KLOCS(4)
         IF (IPOINT.GT.0) ITRC(2) = KEYVAL(IPOINT)
C                                       yinc
         IYINC = 0
         IPOINT = KLOCS(5)
         IF (IPOINT.GT.0) IYINC = KEYVAL(IPOINT)
C                                       zinc
         IZINC = 0
         IPOINT = KLOCS(6)
         IF (IPOINT.GT.0) IZINC = KEYVAL(IPOINT)
C                                       I clip level
         ICLIP = 0.0
         IPOINT = KLOCS(7)
         IF (IPOINT.GT.0) THEN
            CALL RCOPY (NWDPDP, KEYVAL(IPOINT), XX)
            ICLIP = XX
            END IF
C                                       clip level
         PCLIP = 0.0
         IPOINT = KLOCS(8)
         IF (IPOINT.GT.0) THEN
            CALL RCOPY (NWDPDP, KEYVAL(IPOINT), XX)
            PCLIP = XX
            END IF
C                                       pixels fits
         PDONE = 0
         IPOINT = KLOCS(9)
         IF (IPOINT.GT.0) PDONE = KEYVAL(IPOINT)
C                                       spectral index/thickness
         SPIXDO = 0
         IPOINT = KLOCS(10)
         IF (IPOINT.GT.0) SPIXDO = KEYVAL(IPOINT)
         IF (SPIXDO.GE.2) THEN
            TITLE(8) = 'THICKNESS'
            TITLE(12) = 'ERR THICK'
            UNITS(8) = UNITS(7)
            UNITS(12) = UNITS(7)
            END IF
         END IF
      IRET = 0
C                                      Get array indices
C                                      Cover your ass from FNDCOL -
C                                      close to flush the buffers and
C                                      then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KEYVAL, BUFFER, IRET)
      IF (IRET.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'RMINI', IRET)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'RM', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IRET)
      IF (IRET.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'RMINI', IRET)
         GO TO 990
         END IF
      CALL FNDCOL (NDATA, TITLE, 24, .TRUE., BUFFER, RMKOLS, JERR)
C                                      Get array indices and no. values
      DO 150 I = 1,NDATA
         IPOINT = RMKOLS(I)
         IF (IPOINT.GT.0) THEN
            RMKOLS(I) = DATP(IPOINT,1)
            RMNUMV(I) = DATP(IPOINT,2) / 10
            IF (RMNUMV(I).LE.0) THEN
               NC = JTRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            RMKOLS(I) = -1
            RMNUMV(I) = 0
            NC = JTRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('RMINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('RMINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('RMINI: ERROR INITIALIZING RM-FIT TABLE FOR ',A)
      END

      SUBROUTINE ZILI16 (NINT, INB, NP, OUTB)
C-----------------------------------------------------------------------
C! convert local integers to 16-bit FITS integers in a buffer
C# Binary
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Convert a buffer of local integers to a buffer of standard 16-bit,
C   2's complement integers.
C   Inputs:
C      NINT   I      Number of integers to convert
C      INB    I(*)   Input buffer (start at index 1)
C      NP     I      Starting index in the output buffer (1-relative)
C                    in units of 16-bit integers
C   Output:
C      OUTB   I(*)   Output buffer
C   Generic version - assumes that the local machine is 32-bit
C-----------------------------------------------------------------------
      INTEGER   NINT, INB(*), NP, OUTB(*)
C
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (NINT.LE.0) GO TO 999
      IF (NBITWD.NE.32) THEN
         WRITE (MSGTXT,1000) NBITWD
         CALL MSGWRT (9)
         STOP 'ZILI16 NEEDS LOCAL DEVELOPMENT'
C                                       Move data
      ELSE
         CALL ZIPACK ('LOTS', NINT, INB, NP, OUTB)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZILI16: REQUIRES LOCAL DEVELOPMENT FOR NBITWD =',I7)
      END

      SUBROUTINE YZOOMC (MAG, XZOOM, YZOOM, VRTRTC, IERR)
C-----------------------------------------------------------------------
C! set the TV zoom magnification and center
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2008
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   YZOOM writes (ONLY!!!!) the zoom control registers of the TV
C   Inputs:
C      MAG     I     0-3 for magnification 1,2,4,8 times, resp.
C      XZOOM   I     X center of expansion (1-512, 1 => LHS)
C      YZOOM   I     Y center of expansion (1-512, 1 => bot)
C      VRTRTC  L     Do on vertical retrace only?
C   Output:
C      IERR    I     error code of Z...XF: 0 -> ok, 2 -> input error
C   YZOOMC updates the /TVDEV/ common TVZOOM parameter
C   SUN Screen Server Version
C-----------------------------------------------------------------------
      INTEGER   MAG, XZOOM, YZOOM, IERR
      LOGICAL   VRTRTC
C
      INTEGER   OPCODE, DAT(4), BUF, NWSD, MAGFAC, JX, JY, I, J
      REAL      TMAG
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA OPCODE /83/
C-----------------------------------------------------------------------
      IERR = 2
      IF ((MAG.LT.0) .OR. (MAG.GT.IABS(MXZOOM))) GO TO 999
      IF ((XZOOM.LT.-MAXXTV(1)) .OR. (XZOOM.GT.2*MAXXTV(1))) GO TO 999
      IF ((YZOOM.LT.-MAXXTV(2)) .OR. (YZOOM.GT.2*MAXXTV(2))) GO TO 999
C                                        Compute the upper left
      MAGFAC = 1 + MAG
      IF (MXZOOM.GT.0) MAGFAC = 2 ** MAG
      TMAG = MAGFAC
      JX = (XZOOM-1.0) * (TMAG-1.0) / TMAG
      JY = (MAXXTV(2)-YZOOM) * (TMAG-1.0) / TMAG
C                                        set data
      J = NGRAY + 1
      DO 10 I = 1,J
         DAT(1) = I
         DAT(2) = MAGFAC
         IF (I.LE.NGRAY) THEN
            DAT(3) = JX - TVSCRX(I)
            DAT(4) = JY + TVSCRY(I)
         ELSE
            DAT(3) = JX - TVSCGX
            DAT(4) = JY + TVSCGY
            END IF
         IF (DAT(3).LT.0) DAT(3) = DAT(3) + MAXXTV(1)
         IF (DAT(3).GE.MAXXTV(1)) DAT(3) = DAT(3) - MAXXTV(1)
         IF (DAT(4).LT.0) DAT(4) = DAT(4) + MAXXTV(2)
         IF (DAT(4).GE.MAXXTV(2)) DAT(4) = DAT(4) - MAXXTV(2)
         CALL ZSSSXF (OPCODE, DAT, 0, BUF, NWSD, IERR)
         IF (IERR.NE.0) GO TO 900
 10      CONTINUE
C                                       update common /TVCHAR/
      TVZOOM(1) = MAG
      TVZOOM(2) = XZOOM
      TVZOOM(3) = YZOOM
      GO TO 999
C
 900  WRITE (MSGTXT,1900) IERR
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('YZOOMC - ERROR',I5,' RETURNED BY ZSSSXF')
      END

      SUBROUTINE GRD (JD, RA, DEC, SINDEC, COSDEC, GRDRA, GRDDEC)
C-----------------------------------------------------------------------
C! Compute the general relativity displacements in RA and DEC.
C# Math Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Compute the general relativity displacements in RA and DEC by a
C   procedure described by Cam Wade in memo dated December, 1975.
C   Input parameters:
C     JD       D    Julian day
C     RA       D    apparent right ascension, radians
C     DEC      D    apparent declination, radians
C     SINDEC   D    DSIN(DEC)
C     COSDEC   D    DCOS(DEC)
C   Output parameters:
C      GRDRA   D    right ascension displacement
C      GRDDEC  D    declination displacement
C   Both are in radians and k here is in radians.
C-----------------------------------------------------------------------
      DOUBLE PRECISION JD, RA, DEC, SINDEC, COSDEC, GRDRA, GRDDEC
      DOUBLE PRECISION K, TWOPI, DEG, L, M, D, DLAM, RLAM, SOLRA,
     *   SINSD, COSSD, RADIF, CORADF, COSD, KK
      INTEGER   I
      DATA K /1.9742D-8/
      DATA TWOPI /6.28318530717959D0/
      DATA DEG /1.74532925199433D-2/
C-----------------------------------------------------------------------
C                                       D=Julian days since Jan.0, 1900
      D = JD - 2415020.D0
C                                       L is Sun's mean longitude, less
C                                       aberration, in radians.
      L = .77692D0 + 2.737909265D-3 * D
      I = L
      L = (L-I) * TWOPI
C                                       M is Sun's mean anomaly, in
C                                       radians.
      M = .996D0 + 2.737778519D-3 * D
      I = M
      M = (M-I) * TWOPI
C                                       DLAM is Sun's apparent longitude
C                                       in degrees.  RLAM is same, but
C                                       in radians.
      DLAM = L / DEG + 1.92D0 * SIN(M) + .02D0 * SIN(M+M)
      RLAM = DLAM * DEG
C                                       SOLRA is solar RA in radians.
      SOLRA = DLAM - 2.47D0 * SIN(RLAM+RLAM) + .05D0 * SIN(4D0*RLAM)
      SOLRA = SOLRA * DEG
C                                       SINSD is DSIN(solar dec)
      SINSD = .3978D0 * SIN(RLAM)
      COSSD = SQRT(1.D0 - SINSD*SINSD)
      RADIF = RA - SOLRA
      CORADF = COS(RADIF)
      COSD = SINDEC * SINSD + COSDEC * COSSD * CORADF
      KK = K * (1.D0 / (1.D0-COSD) + .5D0*COSD)
      GRDRA = KK * SIN(RADIF) * COSSD/COSDEC
      GRDDEC = KK * (SINDEC * COSSD * CORADF - COSDEC * SINSD)
C
 999  RETURN
      END

      SUBROUTINE SETDO3 (UVDISK, UVCNO, IBUFF, IRET)
C-----------------------------------------------------------------------
C! Sets up for UV model computation filling DO3DIM parameter
C# UV Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 2000, 2005, 2008-2009, 2012, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SETDO3 uses some parameters in common /MAPDES/ to find and read the
C   headers of Model images.  It uses this to determine whether 3D
C   imaging or parallel planes images are present.
C   Inputs:
C      UVDISK   I      Disk number for uv data set
C                         O -> scratch file
C      UVCNO    I      Catalog number for UV data set
C                         If scratch, scrcno(uvcno)
C   Inputs from DGDS.INC:
C      CCDISK   I(*)   Disk numbers of files
C      CCCNO    I(*)   Catalog numbers of files.
C      MFIELD   I      Number of fields.
C   Output:
C      IBUFF    I(256) Work buffer
C      IRET     I      Return code, 0=>OK, otherwise failed.
C   Output in DGDS.INC
C      DO3DIM   L      Using 3D imaging?
C   UVPGET must be called before calling this routine too.
C-----------------------------------------------------------------------
      INTEGER   UVDISK, UVCNO, IBUFF(*), IRET
C
      INTEGER   I, CATCLN(256), NCEN, NOFF, ONCE, ONCED, ONCEC, IRAOFF,
     *   IDECOF, LOCS(2), VALUES(2), KEYTYP(2), IERR, J, K, DISKUV,
     *   CNOUV
      REAL      CATCR(256), MAXBLN, PMAT(3,3), UMATN(3,3), RVALS(2)
      DOUBLE PRECISION CATCD(128), CLNRA, CLNDEC
      HOLLERITH CATCH(256)
      LOGICAL   DOUMAT, WASDIF, IN3D, FIRST
      CHARACTER CHTEMP*8
      EQUIVALENCE (VALUES, RVALS)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (CATCLN, CATCH, CATCR, CATCD)
      SAVE ONCE, ONCED, ONCEC
      DATA ONCE, ONCED, ONCEC /-1, -1, -1/
C-----------------------------------------------------------------------
      NCEN = 0
      NOFF = 0
      WASDIF = .FALSE.
      FIRST = .TRUE.
      IN3D = DO3DIM
      IF (UVDISK.GT.0) THEN
         DISKUV = UVDISK
         CNOUV = UVCNO
      ELSE
         DISKUV = SCRVOL(UVCNO)
         CNOUV = SCRCNO(UVCNO)
         END IF
      DOUMAT = (DISKUV.NE.ONCED) .OR. (CNOUV.NE.ONCEC)
      ONCED = DISKUV
      ONCEC = CNOUV
C                                       header of main UV: get rot
      IF (DOUMAT) THEN
         CALL CATIO ('READ', DISKUV, CNOUV, CATCLN, 'REST', IBUFF, IRET)
         IF (IRET.NE.0) THEN

            WRITE (MSGTXT,1010) IRET, DISKUV, CNOUV
            GO TO 990
            END IF
         CALL ROTFND (CATCR, UVROT, IRET)
         END IF
C                                       Loop thru other fields.
 25   DO 40 I = 1,MFIELD
C                                       Read catalog block
         CALL CATIO ('READ', CCDISK(I), CCCNO(I), CATCLN, 'REST',
     *      IBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, CCDISK(I), CCCNO(I)
            GO TO 990
            END IF
         IF (FLDSZ(1,I).LE.0) FLDSZ(1,I) = CATCLN(KINAX)
         IF (FLDSZ(2,I).LE.0) FLDSZ(2,I) = CATCLN(KINAX+1)
C                                       3D image?
         CHTEMP = 'RA'
         CALL AXEFND (2, CHTEMP, KICTPN, CATCH(KHCTP), IRAOFF, IERR)
         CHTEMP = 'DEC'
         CALL AXEFND (3, CHTEMP, KICTPN, CATCH(KHCTP), IDECOF, IERR)
         IF (FIRST) THEN
            IF (((ABS(CATCR(KRCRP+IRAOFF)-CATCLN(KINAX+IRAOFF)/2.0).LT.
     *         0.01) .AND. (ABS(CATCR(KRCRP+IDECOF)-1.0-
     *         CATCLN(KINAX+IDECOF)/2.0).LT.0.01)) .OR.
     *         (CATCLN(KIITY).EQ.2)) NCEN = NCEN + 1
            IF ((ABS(CATCD(KDCRV+IRAOFF)-RA).GT.
     *         0.01*ABS(CATCR(KRCIC+IRAOFF))) .OR.
     *         (ABS(CATCD(KDCRV+IDECOF)-DEC).GT.
     *         0.01*ABS(CATCR(KRCIC+IDECOF)))) NOFF = NOFF + 1
               END IF
C                                       rotation matrix in case
         IF (DOUMAT) THEN
            IF (.NOT.WASDIF) CALL RCOPY (9, UMATS(1,1,I), UMATN)
            CLNRA = CATCD(KDCRV+IRAOFF)
            CLNDEC = CATCD(KDCRV+IDECOF)
            CALL ROTFND (CATCR, MAPROT, IRET)
            IF (DO3DIM) THEN
               CALL PRJMAT (RA, DEC, UVROT, CLNRA, CLNDEC, MAPROT,
     *            UMATS(1,1,I), PMAT)
            ELSE
               CALL P2DMAT (RA, DEC, UVROT, CLNRA, CLNDEC, MAPROT,
     *            UMATS(1,1,I), PMAT)
               END IF
            IF (.NOT.WASDIF) THEN
               DO 35 K = 1,3
                  DO 30 J = 1,3
                     IF (ABS(UMATS(J,K,I)-UMATN(J,K)).GT.3.0E-6)
     *                  WASDIF = .TRUE.
 30                  CONTINUE
 35               CONTINUE
               END IF
            END IF
 40      CONTINUE
C                                       Check/set 3D
      IF (FIRST) THEN
         DO3DIM = .FALSE.
         IF (NOFF.EQ.0) THEN
            MSGTXT = 'SETDO3: imaging done with one tangent plane'
            IF ((MFIELD.GT.1) .AND. (ONCE.NE.1)) THEN
               CALL MSGWRT (2)
               MSGTXT = 'SETDO3: WARNING, THIS HAS CHANGED'
               IF (ONCE.NE.-1) CALL MSGWRT (6)
               END IF
            ONCE = 1
         ELSE IF (NCEN.EQ.MFIELD) THEN
            DO3DIM = .TRUE.
            MSGTXT = 'SETDO3: imaging done with multiple tangent planes'
            IF (ONCE.NE.2) THEN
               CALL MSGWRT (4)
               MSGTXT = 'SETDO3: WARNING, THIS HAS CHANGED'
               IF (ONCE.NE.-1) CALL MSGWRT (6)
               END IF
            ONCE = 2
         ELSE IF (NCEN.EQ.0) THEN
            MSGTXT = 'SETDO3: imaging done with one OFFSET' //
     *         ' tangent plane'
            IF (ONCE.NE.3) THEN
               CALL MSGWRT (2)
               MSGTXT = 'SETDO3: WARNING, THIS HAS CHANGED'
               IF (ONCE.NE.-1) CALL MSGWRT (6)
               END IF
            ONCE = 3
         ELSE
            WRITE (MSGTXT,1050) NCEN, NOFF, MFIELD
            CALL MSGWRT (7)
            ONCE = 0
            END IF
         IF ((DO3DIM.NEQV.IN3D) .AND. (DOUMAT)) THEN
            FIRST = .FALSE.
            GO TO 25
            END IF
         END IF
C                                       Header keyword
      IF ((DOUMAT) .AND. (WASDIF)) THEN
         CALL CATKEY ('REED', DISKUV, CNOUV, 'MAXABSU ', 1, LOCS,
     *      VALUES, KEYTYP, IBUFF, I)
         IF ((I.EQ.0) .AND. (LOCS(1).GT.0)) THEN
            CALL COPY (1, RVALS(LOCS(1)), MAXBLN)
            MAXBLN = -ABS(MAXBLN)
         ELSE
            MAXBLN = -1.0
            END IF
         LOCS(1) = 1
         CALL RCOPY (1, MAXBLN, RVALS(1))
C                                       Record Max Baseline in header
         KEYTYP(1) = 2
         CALL CATKEY ('WRIT', DISKUV, CNOUV, 'MAXABSU', 1, LOCS,
     *      VALUES, KEYTYP, IBUFF, I)
         END IF
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ERROR',I3,' COPYING CATBLK DISK, CNO',I3,I6)
 1050 FORMAT ('SETDO3: CENTERED',I3,' OFFSET',I3,' IN',I3,' MODELS',
     *   ' 3DIMAG INCONSISTENT')
      END

      SUBROUTINE GRDAT (DOXY, IFIELD, CATR, BUFF1, IRET)
C-----------------------------------------------------------------------
C! Getn info about CLEAN components for GRDSUB.
C# EXT-appl Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 1999, 2005-2006, 2008, 2011-2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GRDAT gets information about a CLEAN components file for GRDSUB.
C   Checks to see if data in XY order.
C   Input:
C      DOXY     L        If true then check sort order ('X*')
C      IFIELD   I        Current field number.  <0 => beam -IFIELD
C      CATR     R(256)   The uv data file catalog header record.
C   Input from commons:
C      RA       D        RA of uv data. (deg.)
C      DEC      D        Declination of uv data.
C      DO3DIM   L        T => images produced by reprojecting u,v,w
C   Output:
C      BUFF1    R(256)   Working buffer.
C      IRET     I        Return error code, 0=>OK, otherwise failed.
C   Output in common /MAPDES/
C      FLDSZ    I(2,*)   Size of the CLEAN map field.
C      NXUNF    I        Dimension (cells) of the map in RA to be used
C                        to determine uniform wt. counting box if 0
C                        when called.
C      NYUNF    I        Dimensions (cells) of the map in Dec to be
C                        used to determine uniform wt. counting box if
C                        0 when called.
C      CELLSG   R(2)     Cellsize of the CLEAN maps (asec.)
C      SCLUG    R(*)     Scaling to cells in u coordinate.
C      SCLVG    R(*)     Scaling to cells in v coordinate.
C      SCLWG    R(*)     Scaling to cells in w coordinate.
C      SCLUM    R        Scaling to cells in u for NXUNF
C      SCLVM    R        Scaling to cells in v for NYUNF
C      DXCG     R(*)     Position offset parameter in x (RA) corrected
C                        to uv data set rotation
C      DYCG     R(*)     Position offset parameter in y (dec) corrected
C                        to uv data set rotation
C      DZCG     R(*)     Position offset parameter in z.
C      XSHIFT   R(*)     X shift arc sec
C      YSHIFT   R(*)     Y shift in arc sec
C      XPOFF    R(*)     Pixel offset in x for clean components to
C                        field phase center from tang. point. (deg.)
C      YPOFF    R(*)     Pixel offset in Y for clean components to
C                        field phase center from tang. point. (deg.)
C      XFLD     R(*)     Field of view in X (RA) in seconds.
C      YFLD     R(*)     Field of view in Y (dec) in seconds.
C      CCROT    R        Cosine of position angle difference between
C                        orientation of uv data and CLEAN image times
C                        constant for coordinate conversion.
C      SSROT    R        Sine of position angle difference between
C                        orientation of uv data and CLEAN image.
C      OSFX     R        Over sampling factors in X
C      OSFY     R        Over sampling factors in Y
C      ICNTRX   I(*)     Center cell number in X
C      ICNTRY   I(*)     Center cell number in Y
C      KLNBLK   I(256)   Catalog header record of current CLEAN field.
C-----------------------------------------------------------------------
      LOGICAL   DOXY
      INTEGER   IFIELD, IRET
      REAL      CATR(256), BUFF1(*)
C
      CHARACTER CHTEMP*8, CHTYPE*2
      HOLLERITH KLNH(256)
      INTEGER   NX, NY, JFIELD, KVOL, KCNO, IRAOFF, IDECOF, IERR, NCHK,
     *   INDEX, LFIELD, II
      LOGICAL   DOUBX, DOUBY, ISUV
      REAL      KLNR(256)
      DOUBLE PRECISION KLND(128), KLNRA, KLNDEC, RAX, DECX
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMPR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (KLNBLK, KLNR, KLND, KLNH)
C-----------------------------------------------------------------------
C                                       If beam do field 1
      JFIELD = IFIELD
      IF (IFIELD.LE.0) THEN
         JFIELD = 1
         LFIELD = MAX (1, -IFIELD)
         MSGTXT = 'GRDAT: beam defines image - probably should not'
         CALL MSGWRT (6)
      ELSE
         JFIELD = IFIELD
         LFIELD = 1
         END IF
C                                       Check sort order in /UVHDR/.
C                                       Wrong sort order.
      IF ((ISORT(1:1).NE.'X') .AND. (DOXY)) THEN
         IRET = 9
         WRITE (MSGTXT,1000) ISORT, 'X*'
         GO TO 990
         END IF
      IF (IFIELD.LE.0) THEN
         KVOL = BEMVOL(LFIELD)
         KCNO = CNOBEM(LFIELD)
      ELSE
         KVOL = CCDISK(JFIELD)
         KCNO = CCCNO(JFIELD)
         END IF
      CALL CATIO ('READ', KVOL, KCNO, KLNBLK, 'REST', BUFF1, IRET)
      IF ((IRET.NE.0) .AND. (IRET.LE.4)) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
      CALL H2CHR (2, KHPTYO, KLNH(KHPTY), CHTYPE)
      ISUV = CHTYPE.EQ.'UV'
C                                       Get field information
C                                       Drop hopefully obsolete fix
C     CALL FXSHFT (KLNBLK, IERR)
C                                       Field size
      IF (ISUV) THEN
         FLDSZ(1,JFIELD) = 24
         FLDSZ(2,JFIELD) = 24
      ELSE
         FLDSZ(1,JFIELD) = MAX (FLDSZ(1,JFIELD), KLNBLK(KINAX))
         FLDSZ(2,JFIELD) = MAX (FLDSZ(2,JFIELD), KLNBLK(KINAX+1))
         END IF
      CALL POWER2 (FLDSZ(1,JFIELD), II)
      IF (II.LT.FLDSZ(1,JFIELD)) FLDSZ(1,JFIELD) = II * 2
      CALL POWER2 (FLDSZ(2,JFIELD), II)
      IF (II.LT.FLDSZ(2,JFIELD)) FLDSZ(2,JFIELD) = II * 2
C                                       Uniform weighting size.
      IF (NXUNF.LE.0) NXUNF = FLDSZ(1,JFIELD)
      IF (NYUNF.LE.0) NYUNF = FLDSZ(2,JFIELD)
C                                       Cellsize
      IF (ISUV) THEN
         CELLSG(1) = 120.0
         CELLSG(2) = 120.0
      ELSE
         CELLSG(1) = KLNR(KRCIC) * 3.6E3
         CELLSG(2) = KLNR(KRCIC+1) * 3.6E3
         END IF
C                                       Over sampling factor.
      OSFX = 1.0
      OSFY = 1.0
C                                       Double if possible
      DOUBX = FLDSZ(1,JFIELD).LE.8192
      DOUBY = FLDSZ(2,JFIELD).LE.8192
      IF (DOUBX) OSFX = 2.0
      IF (DOUBY) OSFY = 2.0
      NX = FLDSZ(1,JFIELD)
      NY = FLDSZ(2,JFIELD)
C                                       Field of view
      XFLD(JFIELD) = ABS (CELLSG(1)) * NX
      YFLD(JFIELD) = ABS (CELLSG(2)) * NY
C                                       Set map center.
      ICNTRX(JFIELD) = NX / 2
      ICNTRY(JFIELD) = NY / 2 + 1
C                                       u,v,w scaling
      SCLUG(JFIELD) = NX * ABS (CELLSG(1)) * DG2RAD / 3600.0D0
      SCLVG(JFIELD) = -NY * CELLSG(2) * DG2RAD / 3600.0D0
      SCLWG(JFIELD) = 1.0
      SCLUM = NXUNF * ABS (CELLSG(1)) * DG2RAD / 3600.0D0
      SCLVM = -NYUNF * CELLSG(2) * DG2RAD / 3600.0D0
C                                       Find "CLEAN" RA and Dec axes.
      INDEX = JLOCR * 2
      CALL H2CHR (8, 1, CATR(KHCTP+INDEX), CHTEMP)
      IRAOFF = 0
      NCHK = 4
      IF (CHTEMP(1:4).EQ.'RA  ') NCHK = 2
      CALL AXEFND (NCHK, CHTEMP, KICTPN, KLNH(KHCTP), IRAOFF, IERR)
      INDEX = JLOCD * 2
      CALL H2CHR (8, 1, CATR(KHCTP+INDEX), CHTEMP)
      IDECOF = 1
      NCHK = 4
      IF (CHTEMP(1:4).EQ.'DEC ') NCHK = 3
      CALL AXEFND (NCHK, CHTEMP, KICTPN, KLNH(KHCTP), IDECOF, IERR)
C                                       Get position offsets of phase
C                                       centers.
      IF ((DO3DIM) .OR. (ISUV)) THEN
         KLNRA = KLND(KDCRV+IRAOFF)
         KLNDEC = KLND(KDCRV+IDECOF)
         RAX = RA
         DECX = DEC
      ELSE
         KLNRA = KLND(KDCRV+IRAOFF) + KLNR(KRXSH)
         KLNDEC = KLND(KDCRV+IDECOF) + KLNR(KRYSH)
         RAX = RA + CATR(KRXSH)
         DECX = DEC + CATR(KRYSH)
         END IF
C                                       Prepare for shift and rotate
C                                       of model.
      CALL ROTFND (KLNR, MAPROT, IRET)
      CALL ROTFND (CATR, UVROT, IRET)
C                                       Field offsets.
      CALL SHFTXY (RAX, DECX, MAPROT, KLNRA, KLNDEC, XSHIFT(JFIELD),
     *   YSHIFT(JFIELD))
C                                       set shift terms for field cent.
C                                       -NCP projection
      IF (TYPUVD.EQ.1) THEN
         CALL SHINCP (RAX, DECX, MAPROT, KLNRA, KLNDEC, DXCG(JFIELD),
     *      DYCG(JFIELD), DZCG(JFIELD))
C                                       -SIN projection
      ELSE
         CALL SHISIN (RAX, DECX, MAPROT, KLNRA, KLNDEC, DXCG(JFIELD),
     *      DYCG(JFIELD), DZCG(JFIELD))
         END IF
C                                       Get reference pixel offsets from
C                                       tangent point
      IF (ISUV) THEN
         XPOFF(JFIELD) = 0.0
         YPOFF(JFIELD) = 0.0
      ELSE IF ((KLNBLK(KIITY).EQ.1) .OR. (KLNBLK(KIITY).EQ.2)) THEN
         XPOFF(JFIELD) = KLNR(KRXPO)
         YPOFF(JFIELD) = KLNR(KRYPO)
      ELSE
         XPOFF(JFIELD) = (KLNR(KRCRP+IRAOFF) - KLNBLK(KINAX+IRAOFF)/2)
     *      * KLNR(KRCIC+IRAOFF)
         YPOFF(JFIELD) = (KLNR(KRCRP+IDECOF) - KLNBLK(KINAX+IDECOF)/2 -
     *      1) * KLNR(KRCIC+IDECOF)
         END IF
C                                       Reset rotation for components
      CCROT =  COS (DG2RAD * (UVROT - MAPROT))
      SSROT =  SIN (DG2RAD * (UVROT - MAPROT))
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UV DATA IN WRONG SORT ORDER =''',A2,''' NOT ''',A2,'''')
 1010 FORMAT ('GRDAT: ERROR',I5,' READING CATBLK ')
      END

LOCAL INCLUDE 'RIFRM.INC'
C                                       Local include for RIFRM
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NTMAX, NSMAX
      PARAMETER (NTMAX=10000)
      PARAMETER (NSMAX=100)
C
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XINFIL(16,2)
      REAL      XSIN, XDISIN, GAININ, GAINOU, XANT(50)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XXSOUR, GAININ,
     *   GAINOU, XINFIL, XANT
C
      CHARACTER NAMEIN*12, CLAIN*6, SRCS(30)*16, INFILE*128,
     *   SRCNAM(NSMAX)*16
      INTEGER   SEQIN, DISKIN, CNOIN, CLVIN, CLVOUT, SNUMS(NSMAX),
     *   SCRTCH(512), NTIMES, NFAIL(4), TEVER, SRCBRK(2,NSMAX), NSRCS,
     *   NSORC, NANT, IANT(50)
      LOGICAL   TENEW
      REAL      TIMES(NTMAX), DAZ(NTMAX), DEL(NTMAX), STEC(NTMAX),
     *   VTEC(NTMAX), RMS(NTMAX), SUMRUN, TOTRUN
      COMMON /COPPRM/ SEQIN, DISKIN, CNOIN, CLVIN, CLVOUT, NSORC, SNUMS,
     *   NTIMES, NFAIL, SCRTCH, TIMES, RMS, DAZ, DEL, STEC, VTEC,
     *   TEVER, TENEW, NSRCS, SRCBRK, SUMRUN, TOTRUN, NANT, IANT
      COMMON /CHPARM/ NAMEIN, CLAIN, SRCS, SRCNAM, INFILE
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
LOCAL END
      PROGRAM RIFRM
C-----------------------------------------------------------------------
C! RIFRM reads text file(s) from ALBUS to put IFR, DDelay in CL & TE
C# Spectral UV-util CALIBRATION
C-----------------------------------------------------------------------
C;  Copyright (C) 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   RIFRM reads ALBUS report files and updates a CL and TE table with
C   IFR and Dispersive delay
C   Inputs:
C     AIPS adverb    Prg. name.          Description.
C       INNAME         NAMEIN        Name of input uv data.
C       INCLASS        CLAIN         Class of input uv data.
C       INSEQ          SEQIN         Seq. of input uv data.
C       INDISK         DISKIN        Disk number of input uv data.
C       SOURCES        SRCS          Source names
C       GAINVER        GAININ        Input CL version
C       GAINUSE        GAINOU        Output Cl version
C       ASDMFILE       INFILE        text file name
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, CANT*3
      INTEGER IRET, THEANT, IA, J, I, JTRIM, K
C
      INCLUDE 'RIFRM.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA PRGM /'RIFRM'/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL RIFRMI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Loop over antennas
      J = JTRIM (INFILE)
      DO 50 IA = 1,NANT
         THEANT = IANT(IA)
         CANT = ' '
         IF (THEANT.GT.0) WRITE (CANT,1010) THEANT
C                                       get the data
         NTIMES = 0
         NSRCS = 0
         CALL FILL (2*NSMAX, 0, SRCBRK)
C                                       one input file
         IF (INFILE(J:J).NE.'_') THEN
            INFILE(J+1:) = CANT
            CALL DATGET (INFILE, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING 1 ALBUS DATA FILE'
               IF (NANT.EQ.1) GO TO 980
               CALL MSGWRT (7)
               GO TO 50
               END IF
            IF ((NTIMES.GT.0) .AND. (NSORC.EQ.1) .AND. (NSRCS.EQ.0))
     *         THEN
               NSRCS = 1
               SRCBRK(1,1) = 1
               SRCBRK(2,1) = SNUMS(1)
               MSGTXT = 'Assuming that these data are for ' //
     *            SRCNAM(1)
               CALL MSGWRT (3)
               END IF
C                                       multiple sources
         ELSE
            DO 40 I = 1,NSORC
               NSRCS = NSRCS + 1
               SRCBRK(1,NSRCS) = NTIMES + 1
               SRCBRK(2,NSRCS) = SNUMS(I)
               INFILE(J+1:) = SRCNAM(I)
               K = JTRIM (INFILE)
               INFILE (K+1:) = CANT
               CALL DATGET (INFILE, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'READING DATA FOR ' //
     *               SRCS(I) // CANT
                  CALL MSGWRT (7)
                  END IF
 40            CONTINUE
            END IF
C                                       now rewrite CL, TE tables
         INFILE(J+1:) = ' '
         IF (TENEW) THEN
            CALL RIFRMA (THEANT, IRET)
            TENEW = .FALSE.
         ELSE
            CALL RIFRMO (THEANT, IRET)
            END IF
         IF (IRET.NE.0) GO TO 990
 50      CONTINUE
C
      CALL RIFRMH
      GO TO 990
C                                       Close down files, etc.
 980  CALL MSGWRT (8)
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('MAIN ERROR',I4,' ON ',A)
 1010 FORMAT ('_',I2.2)
      END
      SUBROUTINE RIFRMI (PRGN, JERR)
C-----------------------------------------------------------------------
C   RIFRMI gets input parameters, sets the parameters which are used to
C   select data.
C   Inputs:  PRGN    C*6       Program name
C   Output:  JERR    I         Error code: 0 => ok
C                                5 => catalog troubles
C                                6 => too much data to select ch.
C                                8 => can't start
C----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   JERR
C
      INCLUDE 'RIFRM.INC'
      INTEGER   I, IROUND, NPARM, IERR, J, JTRIM
      CHARACTER STRING*64
      LOGICAL   ISVLBA
      INCLUDE  'RIFRM.INC'
      CHARACTER STAT*4, UTYPE*2
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
      SUMRUN = 0.0
      TOTRUN = 0.0
C                                       Get input parameters.
      NPARM = 211
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'GETTING ADVERB VALUES'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRTCH, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), SRCS(I))
 20      CONTINUE
      CALL H2CHR (64, 1, XINFIL(1,1), INFILE)
      CALL H2CHR (64, 1, XINFIL(1,2), STRING)
      J = JTRIM (INFILE)
      INFILE(J+1:) = STRING
      J = JTRIM (INFILE)
C                                       Crunch input parameters
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
C                                       Get CATBLK from old file.
      CNOIN = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'WRIT', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING DATA SET HEADER'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 1
      CALL H2CHR (8, 1, CATH(KHTEL), STRING)
      ISVLBA = STRING(:4).EQ.'VLBA'
C                                       CL table versions
      CALL FNDEXT ('CL', CATBLK, I)
      CLVIN = GAININ + 0.1
      IF (CLVIN.LE.0) CLVIN = I
      CLVIN = MIN (I, CLVIN)
      CLVOUT = GAINOU + 0.1
      IF ((CLVOUT.LE.I) .AND. (CLVOUT.NE.CLVIN)) CLVOUT = I + 1
      IF (CLVIN.LE.0) THEN
         JERR = 10
         MSGTXT = 'NO CL TABLES FOUND'
         GO TO 990
         END IF
      CALL FNDEXT ('TE', CATBLK, I)
      IF (CLVOUT.EQ.CLVIN) THEN
         TEVER = MAX (1, I)
      ELSE
         TEVER = I + 1
         END IF
      TENEW = TEVER.GT.I
C                                       Source list
      CALL SRCGET (JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1000) JERR, 'FINDING SOURCE NUMBERS'
         GO TO 990
         END IF
      CALL FILL (50, 0, IANT)
      IF (.NOT.ISVLBA) THEN
         NANT = 1
      ELSE
         NANT = 0
         DO 30 I = 1,50
            IANT(I) = XANT(I) + 0.1
            IF (IANT(I).LE.0) GO TO 40
            NANT = NANT + 1
 30         CONTINUE
 40      IF (NANT.EQ.0) THEN
            NANT = 10
            DO 45 I = 1,10
               IANT(I) = I
 45            CONTINUE
            END IF
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RIFRMI: ERROR',I3,' ON ',A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',I3,
     *   ' USID=',I5)
      END
      SUBROUTINE SRCGET (IRET)
C-----------------------------------------------------------------------
C   Determines source list
C   Output
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'RIFRM.INC'
      INTEGER   I, J, NS, TABUFF(512), VER, LUN, LUNTMP, NUMIF, ISURNO,
     *   SUKOLS(MAXSUC), SUNUMV(MAXSUC), FREQID, NREC, IDSOU, QUAL, K,
     *   JTRIM
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*8
      REAL      FLUX(4,MAXIF)
      DOUBLE PRECISION FREQO(MAXIF), BANDW, RAEPO, DECEPO, EPOCH, RAAPP,
     *   DECAPP, RAOBS, DECOBS, LSRVEL(MAXIF), LRESTF(MAXIF), PMRA,
     *   PMDEC
C-----------------------------------------------------------------------
C                                       how many sources specified
      NS = 0
      DO 10 I = 1,30
         IF (SRCS(I).EQ.' ') GO TO 20
         NS = NS + 1
 10      CONTINUE
C                                       open source table
 20   LUN = LUNTMP (1)
      VER = 1
      CALL SOUINI ('READ', TABUFF, DISKIN, CNOIN, VER, CATBLK, LUN,
     *   NUMIF, VELTYP, VELDEF, FREQID, ISURNO, SUKOLS, SUNUMV, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING SOURCE TABLE'
         GO TO 990
         END IF
C                                       read source table
      NREC = TABUFF(5)
      NSORC = 0
      DO 50 I = 1,NREC
         ISURNO = I
         CALL TABSOU ('READ', TABUFF, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF, PMRA,
     *      PMDEC, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING SOURCE TABLE'
            GO TO 990
            END IF
C                                       in list?
         IF (NS.GT.0) THEN
            DO 30 J = 1,NS
               IF (SOUNAM.EQ.SRCS(J)) GO TO 40
 30            CONTINUE
            GO TO 50
            END IF
 40      IF (NSORC.GE.NSMAX) THEN
            WRITE (MSGTXT,1040) NSMAX
            CALL MSGWRT (8)
            GO TO 55
            END IF
         NSORC = NSORC + 1
         SNUMS(NSORC) = IDSOU
         K = JTRIM (SOUNAM)
         DO 45 J = 1,K
            IF (SOUNAM(J:J).EQ.' ') SOUNAM(J:J) = '_'
 45         CONTINUE
         SRCNAM(NSORC) = SOUNAM
 50      CONTINUE
C                                       close source table
 55   CALL TABSOU ('CLOS', TABUFF, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *   SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *   EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF, PMRA,
     *   PMDEC, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING SOURCE TABLE'
         GO TO 990
         END IF
      IF (NSORC.LE.0) THEN
         IRET = 10
         MSGTXT = 'NO SOURCES FOUND'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SRCGET ERROR',I4,' ON ',A)
 1040 FORMAT ('SRCGET SOURCE LIST TERMINATED AFTER',I4,' SOURCES')
      END
      SUBROUTINE DATGET (THEFIL, IRET)
C-----------------------------------------------------------------------
C   Read the ALBUS report file
C   Input
C      THEFIL   C*(*)   ALBUS text file
C   Output
C      IRET     I       Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER THEFIL*(*)
C
      INTEGER   LUN, FIND, I, J, JTRIM, KBPLIM, KBP, NBAD, IY, IM, ID,
     *   LD(3)
      DOUBLE PRECISION XX, T0
      CHARACTER INLINE*256, DOB*8, STRING*16
      INCLUDE 'RIFRM.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA LUN /3/
C-----------------------------------------------------------------------
C                                       Open first file
      I = 1
      CALL ZTXOPN ('READ', LUN, FIND, THEFIL, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN ALBUS OUTPUT TEXT FILE'
         GO TO 990
         END IF
C                                       skip head except ref time
 10   CALL ZTXIO ('READ', LUN, FIND, INLINE, IRET)
      IF (IRET.EQ.0) THEN
         KBPLIM = JTRIM (INLINE)
         IF ((KBPLIM.LE.0) .OR. (INLINE(:1).EQ.'#')) GO TO 10
         IF (INLINE(:9).EQ.'reference') THEN
            J = INDEX (INLINE, ',sec')
            IF (J.GT.0) THEN
               KBP = J + 4
               CALL GETNUM (INLINE, KBPLIM, KBP, XX)
               IF (XX.EQ.DBLANK) GO TO 10
               IY = XX + 0.01D0
               CALL GETNUM (INLINE, KBPLIM, KBP, XX)
               IF (XX.EQ.DBLANK) GO TO 10
               IM = XX + 0.01D0
               CALL GETNUM (INLINE, KBPLIM, KBP, XX)
               IF (XX.EQ.DBLANK) GO TO 10
               ID = XX + 0.01D0
               CALL GETNUM (INLINE, KBPLIM, KBP, XX)
               IF (XX.EQ.DBLANK) GO TO 10
               T0 = XX
               CALL GETNUM (INLINE, KBPLIM, KBP, XX)
               IF (XX.EQ.DBLANK) GO TO 10
               T0 = T0 + XX/60.0D0
               CALL GETNUM (INLINE, KBPLIM, KBP, XX)
               IF (XX.EQ.DBLANK) GO TO 10
               T0 = T0 + XX/3600.0D0
               T0 = T0 / 24.0
               END IF
            END IF
         IF (INLINE(:12).EQ.'observation:') THEN
            CALL LASTRN (INLINE, STRING)
            DO 15 I = 1,NSORC
               IF (STRING.EQ.SRCNAM(I)) THEN
                  IF (NSRCS.EQ.NSMAX) THEN
                     WRITE (MSGTXT,1012) NSMAX
                     IRET = 10
                     GO TO 990
                     END IF
                  NSRCS = NSRCS + 1
                  SRCBRK(1,NSRCS) = NTIMES + 1
                  SRCBRK(2,NSRCS) = SNUMS(I)
                  GO TO 10
                  END IF
 15            CONTINUE
            WRITE (MSGTXT,1015) STRING
            CALL MSGWRT (8)
            END IF
         IF (INLINE(:18).EQ.'process_ionosphere') GO TO 25
         IF (INLINE(:3).NE.'seq') GO TO 10
      ELSE
         WRITE (MSGTXT,1000) IRET, 'READING START OF ALBUS OUTPUT FILE'
         IF ((IRET.NE.2) .OR. (NTIMES.LE.0)) GO TO 990
         IRET = 0
         GO TO 30
         END IF
C                                       right day??
      CALL H2CHR (8, 1, CATH(KHDOB), DOB)
      CALL DATEST (DOB, LD)
      IF ((LD(1).NE.IY) .OR. (LD(2).NE.IM) .OR. (LD(3).NE.ID)) THEN
         WRITE (MSGTXT,1010) IY, IM, ID, LD
         IRET = 10
         GO TO 990
         END IF
C                                       read loop
 20   CALL ZTXIO ('READ', LUN, FIND, INLINE, IRET)
      IF (IRET.EQ.0) THEN
         KBPLIM = JTRIM (INLINE)
         IF ((KBPLIM.LE.0) .OR. (INLINE(:1).EQ.'#')) GO TO 10
         NBAD = NBAD + 1
         IF (INLINE(:18).EQ.'process_ionosphere') THEN
            NBAD = NBAD - 1
            GO TO 25
            END IF
         J = INDEX (INLINE,':')
         IF (J.LT.3) GO TO 20
         KBP = J + 1
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         TIMES(NTIMES+1) = XX / 86400.0D0 + T0
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         DEL(NTIMES+1) = XX
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         DAZ(NTIMES+1) = XX
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         STEC(NTIMES+1) = XX
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         RMS(NTIMES+1) = XX
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         VTEC(NTIMES+1) = XX * STEC(NTIMES+1)
         NTIMES = NTIMES + 1
         IF (NTIMES.GT.NTMAX) THEN
            WRITE (MSGTXT,1020) NTMAX
            IRET = 10
            GO TO 990
            END IF
         NBAD = NBAD - 1
         GO TO 20
      ELSE IF (IRET.NE.2) THEN
         WRITE (MSGTXT,1000) IRET, 'READING ALBUS OUTPUT TEXT FILE'
         GO TO 990
         END IF
      GO TO 30
C                                       last text line
 25   J = INDEX (INLINE,'time:')
      KBP = J + 5
      KBPLIM = JTRIM (INLINE)
      CALL GETNUM (INLINE, KBPLIM, KBP, XX)
      IF (XX.NE.DBLANK) THEN
         TOTRUN = XX
         SUMRUN = SUMRUN + XX
         WRITE (MSGTXT,1025) TOTRUN
         CALL MSGWRT (3)
         END IF
C                                       shut down
 30   CALL ZTXCLS (LUN, FIND, I)
      IRET = 0
      WRITE (MSGTXT,1030) NTIMES
      CALL MSGWRT (3)
      WRITE (MSGTXT,1031) NSRCS
      CALL MSGWRT (3)
      WRITE (MSGTXT,1032) NBAD
      CALL MSGWRT (3)
      GO TO 999
C
  990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETDAT: ERROR',I4,' ON ',A)
 1010 FORMAT ('TEXT FILE FOR',I5,2I3,'  DATA FROM',I5,2I3,' STOPPING')
 1012 FORMAT ('MAXIMUM NUMBER OF SOURCES',I5,' EXCEEDED')
 1015 FORMAT ('SOURCE ''',A,''' NOT FOUND!')
 1020 FORMAT ('MAXIMUM NUMBER OF SOURCE TIMES',I7,' EXCEEDED')
 1025 FORMAT ('ALBUS total run time',F7.2,' minutes')
 1030 FORMAT ('GETDAT read',I4,' times')
 1031 FORMAT ('GETDAT in  ',I4,' sources')
 1032 FORMAT ('GETDAT',I6,' bad values lines')
      END
      SUBROUTINE LASTRN (INLINE, STRING)
C-----------------------------------------------------------------------
C   returns the last string in an input line (drops ' marks if any)
C   Input:
C      INLINE   C*(*)   Text line to parse
C   Output
C      STRING   C*(*)   last string
C-----------------------------------------------------------------------
      CHARACTER   INLINE*(*), STRING*(*)
C
      INTEGER   I, J, JTRIM, I1, I2
C-----------------------------------------------------------------------
      STRING = ' '
      J = JTRIM (INLINE)
      DO 10 I = J,1,-1
         IF ((INLINE(I:I).EQ.' ') .OR. (I.EQ.1)) THEN
            I1 = I + 1
            IF (I.EQ.1) I1 = 1
            IF (INLINE(I1:I1).EQ.'''') THEN
               I1 = I1 + 1
            ELSE IF (INLINE(I1:I1).EQ.'"') THEN
               I1 = I1 + 1
               END IF
            I2 = J
            IF (INLINE(I2:I2).EQ.'''') THEN
               I2 = I2 - 1
            ELSE IF (INLINE(I2:I2).EQ.'"') THEN
               I2 = I2 - 1
               END IF
            STRING = INLINE(I1:I2)
            GO TO 999
            END IF
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE RIFRMA (THEANT, IRET)
C-----------------------------------------------------------------------
C   Reads the input text file(s), copies the CL & TE table
C   Inputs:
C      THEANT   I       Data set antenna number, 0 -> all
C   Inputs (common)
C      DISKIN   I       Data set disk
C      CNOIN    I       Data set catalog number
C      THESRC   I       Data set source number
C      TEVOUT   I       Data set TE version number
C      CLVIN    I       Data set CL input version number
C      CLVOUT   I       Data set CL output version number
C      INFILE   C*(*)   ALBUS output data file
C   Output:
C      IRET   I         Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   THEANT, IRET
C
      INCLUDE 'RIFRM.INC'
      INTEGER   INBUFF(512), OUBUFF(512), LUNI, LUNO, ICLRNO, NUMANT,
     *   CLKOLS(MAXCLC), CLNUMV(MAXCLC), NUMPOL, NUMIF, NTERM, SOURID,
     *   ANTNO, SUBA, FREQID, REFA(2,MAXIF), NREC, I, ITERNO, TUNO,
     *   TEKOLS(16), TENUMV(16), OUTUFF(512)
      REAL      GMMOD, TIMEI, IFR, DOPOFF(MAXIF), ATMOS, DATMOS,
     *   MBDELY(2), CLOCK(2), DCLOCK(2), DISP(2), DDISP(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF),
     *   WEIGHT(2,MAXIF), TEDATA(16)
      DOUBLE PRECISION TIME, GEODLY(MAXIF)
      CHARACTER  RDATE*8, TECTYP*8
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LUNI, LUNO, TUNO /16, 17, 19/
C-----------------------------------------------------------------------
      TECTYP = 'ALBUS'
      CALL H2CHR (8, 1, CATH(KHDOB), RDATE)
C                                       Output new TE table
      CALL TEINI ('WRIT', OUTUFF, DISKIN, CNOIN, TEVER, CATBLK, TUNO,
     *   ITERNO, TEKOLS, TENUMV, RDATE, TECTYP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING NEW OUTPUT TE TABLE'
         GO TO 990
         END IF
C                                       input CL table
      CALL CALINI ('READ', INBUFF, DISKIN, CNOIN, CLVIN, CATBLK, LUNI,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT CL TABLE'
         GO TO 990
         END IF
C                                       Output CL table
      CALL CALINI ('WRIT', OUBUFF, DISKIN, CNOIN, CLVOUT, CATBLK, LUNO,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT CL TABLE'
         GO TO 990
         END IF
      WRITE (MSGTXT,1010) 'Reading CL', CLVIN
      CALL MSGWRT (3)
      WRITE (MSGTXT,1010) 'Writing CL', CLVOUT
      CALL MSGWRT (3)
      WRITE (MSGTXT,1010) 'Creating TE', TEVER
      CALL MSGWRT (3)
C                                       read loop
      NREC = INBUFF(5)
      DO 20 I = 1,NREC
         ICLRNO = I
         CALL TABCAL ('READ', INBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT CL TABLE'
            GO TO 990
            END IF
C                                      get new IFR
         IF ((THEANT.EQ.0) .OR. (ANTNO.EQ.THEANT)) CALL IFRGET (TIME,
     *      SOURID, IFR, DISP, TEDATA)
         ICLRNO = I
         CALL TABCAL ('WRIT', OUBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT CL TABLE'
            GO TO 990
            END IF
         ITERNO = I
         CALL TABTE ('WRIT', OUTUFF, ITERNO, TEKOLS, TENUMV, TIME,
     *      SOURID, ANTNO, TEDATA(1), TEDATA(2), TEDATA(3), TEDATA(4),
     *      TEDATA(5), TEDATA(6), TEDATA(7), TEDATA(8), TEDATA(11),
     *      TEDATA(12), TEDATA(13), TEDATA(14), TEDATA(15), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT TE TABLE'
            GO TO 990
            END IF
 20      CONTINUE
C                                       close
      ICLRNO = NREC
      CALL TABCAL ('CLOS', OUBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *   NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *   GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *   DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OUTPUT CL TABLE'
         GO TO 990
         END IF
      ICLRNO = NREC
      CALL TABCAL ('CLOS', INBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *   NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *   GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *   DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING INPUT CL TABLE'
         GO TO 990
         END IF
      CALL TABTE ('CLOS', OUTUFF, ITERNO, TEKOLS, TENUMV, TIME,
     *   SOURID, ANTNO, TEDATA(1), TEDATA(2), TEDATA(3), TEDATA(4),
     *   TEDATA(5), TEDATA(6), TEDATA(7), TEDATA(8), TEDATA(11),
     *   TEDATA(12), TEDATA(13), TEDATA(14), TEDATA(15), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OUTPUT TE TABLE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RIFMRA: ERROR',I4,' ON ',A)
 1010 FORMAT ('RIFRMA: ',A,' table version',I4)
      END
      SUBROUTINE RIFRMO (THEANT, IRET)
C-----------------------------------------------------------------------
C   Reads the input text file(s), copies the CL & TE table
C   TE file exists, CL version in same as out
C      THEANT   I       Data set antenna number, 0 -> all
C   Inputs (common)
C      DISKIN   I       Data set disk
C      CNOIN    I       Data set catalog number
C      TEVER    I       Data set TE version number
C      CLVOUT   I       Data set CL output version number
C   Output:
C      IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   THEANT, IRET
C
      INCLUDE 'RIFRM.INC'
      INTEGER   INBUFF(512), OUBUFF(512), LUNI, LUNO, ICLRNO, NUMANT,
     *   CLKOLS(MAXCLC), CLNUMV(MAXCLC), NUMPOL, NUMIF, NTERM, SOURID,
     *   ANTNO, SUBA, FREQID, REFA(2,MAXIF), NREC, I, ITERNO, TUNO,
     *   TEKOLS(16), TENUMV(16), OUTUFF(512), TUNI, INTUFF(512)
      REAL      GMMOD, TIMEI, IFR, DOPOFF(MAXIF), ATMOS, DATMOS,
     *   MBDELY(2), CLOCK(2), DCLOCK(2), DISP(2), DDISP(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF),
     *   WEIGHT(2,MAXIF), TEDATA(16)
      DOUBLE PRECISION TIME, GEODLY(MAXIF)
      CHARACTER  RDATE*8, TECTYP*8
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LUNI, LUNO, TUNI, TUNO /16, 17, 18, 19/
C-----------------------------------------------------------------------
C                                       input CL table
      CALL CALINI ('READ', INBUFF, DISKIN, CNOIN, CLVOUT, CATBLK, LUNI,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING CL TABLE AS INPUT'
         GO TO 990
         END IF
C                                       Output CL table
      CALL CALINI ('WRIT', OUBUFF, DISKIN, CNOIN, CLVOUT, CATBLK, LUNO,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING CL TABLE AS OUTPUT'
         GO TO 990
         END IF
      WRITE (MSGTXT,1010) 'Modifying CL', CLVOUT
      CALL MSGWRT (3)
C                                       read loop
      NREC = INBUFF(5)
      DO 20 I = 1,NREC
         ICLRNO = I
         CALL TABCAL ('READ', INBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT CL TABLE'
            GO TO 990
            END IF
C                                       get new IFR
         IF ((THEANT.EQ.0) .OR. (ANTNO.EQ.THEANT)) CALL IFRGET (TIME,
     *      SOURID, IFR, DISP, TEDATA)
         ICLRNO = I
         CALL TABCAL ('WRIT', OUBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT CL TABLE'
            GO TO 990
            END IF
 20      CONTINUE
C                                       close
      ICLRNO = NREC
      CALL TABCAL ('CLOS', OUBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *   NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *   GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *   DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OUTPUT CL TABLE'
         GO TO 990
         END IF
      ICLRNO = NREC
      CALL TABCAL ('CLOS', INBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *   NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *   GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *   DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING INPUT CL TABLE'
         GO TO 990
         END IF
C                                       Input TE table
      CALL TEINI ('READ', INTUFF, DISKIN, CNOIN, TEVER, CATBLK, TUNI,
     *   ITERNO, TEKOLS, TENUMV, RDATE, TECTYP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING TE TABLE AS INPUT'
         GO TO 990
         END IF
C                                       Output same TE table
      TECTYP = 'ALBUS'
      CALL TEINI ('WRIT', OUTUFF, DISKIN, CNOIN, TEVER, CATBLK, TUNO,
     *   ITERNO, TEKOLS, TENUMV, RDATE, TECTYP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING TE TABLE AS OUTPUT'
         GO TO 990
         END IF
      NREC = INTUFF(5)
      WRITE (MSGTXT,1010) 'Modifying TE', TEVER
      CALL MSGWRT (3)
      DO 120 I = 1,NREC
         ITERNO = I
         CALL TABTE ('READ', INTUFF, ITERNO, TEKOLS, TENUMV, TIME,
     *      SOURID, ANTNO, TEDATA(1), TEDATA(2), TEDATA(3), TEDATA(4),
     *      TEDATA(5), TEDATA(6), TEDATA(7), TEDATA(8), TEDATA(11),
     *      TEDATA(12), TEDATA(13), TEDATA(14), TEDATA(15), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING TE TABLE'
            GO TO 990
            END IF
C                                       get new IFR
         IF ((THEANT.EQ.0) .OR. (ANTNO.EQ.THEANT)) CALL IFRGET (TIME,
     *      SOURID, IFR, DISP, TEDATA)
         ITERNO = I
         CALL TABTE ('WRIT', OUTUFF, ITERNO, TEKOLS, TENUMV, TIME,
     *      SOURID, ANTNO, TEDATA(1), TEDATA(2), TEDATA(3), TEDATA(4),
     *      TEDATA(5), TEDATA(6), TEDATA(7), TEDATA(8), TEDATA(11),
     *      TEDATA(12), TEDATA(13), TEDATA(14), TEDATA(15), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING TE TABLE'
            GO TO 990
            END IF
 120     CONTINUE
      CALL TABTE ('CLOS', INTUFF, ITERNO, TEKOLS, TENUMV, TIME,
     *   SOURID, ANTNO, TEDATA(1), TEDATA(2), TEDATA(3), TEDATA(4),
     *   TEDATA(5), TEDATA(6), TEDATA(7), TEDATA(8), TEDATA(11),
     *   TEDATA(12), TEDATA(13), TEDATA(14), TEDATA(15), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING INPUT TE TABLE'
         GO TO 990
         END IF
      CALL TABTE ('CLOS', OUTUFF, ITERNO, TEKOLS, TENUMV, TIME,
     *   SOURID, ANTNO, TEDATA(1), TEDATA(2), TEDATA(3), TEDATA(4),
     *   TEDATA(5), TEDATA(6), TEDATA(7), TEDATA(8), TEDATA(11),
     *   TEDATA(12), TEDATA(13), TEDATA(14), TEDATA(15), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OUTPUT TE TABLE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RIFMRO: ERROR',I4,' ON ',A)
 1010 FORMAT ('RIFRMO: ',A,' table version',I4)
      END
      SUBROUTINE IFRGET (TIME, SOURID, IFR, DISP, TEDATA)
C-----------------------------------------------------------------------
C   IFRGET gets the IFR, DISP, TE values from the tables
C   Inputs
C      SOURID   I      The current source
C      TIME     D      time (days)
C   In/out
C      IFR      R      Ionospheric Faraday rotation radians/m/m
C                      from table or unchanged if fail to find
C      DISP     R(2)   Dispersive delay
C      TEDATA   R(16)  HA, AZ, ZA, AZION, ZAION, DLON, DLAT, B(3),
C                      TEPATH, MAG, TEC, IFR, DISP(2)
C   Common
C-----------------------------------------------------------------------
      DOUBLE PRECISION TIME
      INTEGER   SOURID
      REAL      IFR, DISP(2), TEDATA(16)
C
      INCLUDE 'RIFRM.INC'
      INTEGER   I, LT, LS, LT1, LT2
      REAL      PT, TSC
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      SAVE LT, PT, LS, LT1, LT2
      DATA LT, PT, LS, LT1, LT2 /1, 0.0, 3*0/
C------------------------------------------------------------------------
      IF (TENEW) CALL RFILL (16, FBLANK, TEDATA)
      IF (SOURID.NE.LS) THEN
         DO 10 I = 1,NSRCS
            IF (SOURID.EQ.SRCBRK(2,I)) THEN
               LT1 = SRCBRK(1,I)
               IF (I.LT.NSRCS) THEN
                  LT2 = SRCBRK(1,I+1)
               ELSE
                  LT2 = NTIMES
                  END IF
               LT = 1
               PT = 0.0
               LS = SOURID
               GO TO 30
               END IF
 10         CONTINUE
         GO TO 999
         END IF
C                                       Find time
 30   IF (TIME.LT.PT) LT = LT1
      DO 40 I = LT1,LT2-1
         IF ((TIME.GE.TIMES(I)) .AND. (TIME.LE.TIMES(I+1))) THEN
            LT = I
            PT = TIMES(I)
            GO TO 50
            END IF
 40      CONTINUE
      PT = 0.0
      LT = LT1
      GO TO 999
C                                       interpolate
 50   IF ((RMS(I).EQ.FBLANK) .OR. (RMS(I+1).EQ.FBLANK)) THEN
         IFR = FBLANK
      ELSE
         TSC = (TIME-TIMES(I)) / (TIMES(I+1)-TIMES(I))
         IFR = TSC * (RMS(I+1) - RMS(I)) + RMS(I)
         TEDATA(2) = TSC * (DAZ(I+1)-DAZ(I)) + DAZ(I)
         TEDATA(3) = TSC * (DEL(I+1)-DEL(I)) + DEL(I)
         TEDATA(3) = 90.0 - TEDATA(3)
         TEDATA(11) = TSC * (STEC(I+1)-STEC(I)) + STEC(I)
         TEDATA(13) = TSC * (VTEC(I+1)-VTEC(I)) + VTEC(I)
         TEDATA(14) = IFR
         TEDATA(15) = 40.28 * TEDATA(11) / (VELITE ** 3) * 1.E16
         TEDATA(16) = TEDATA(15)
         END IF
C
 999  RETURN
      END
      SUBROUTINE RIFRMH
C-----------------------------------------------------------------------
C   RIFRMH adds history to the data set
C-----------------------------------------------------------------------
      INCLUDE 'RIFRM.INC'
      INTEGER   IRET, LUN, TIME(3), DATE(3), I, I1, I2, J, JTRIM
      CHARACTER HILINE*72, CTIME(2)*12, CDUM*10
      DATA LUN /27/
C-----------------------------------------------------------------------
      CALL HIINIT (3)
      CALL HIOPEN (LUN, DISKIN, CNOIN, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATE HI FILE'
         GO TO 990
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,2000) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 900
C                                       sources
      CDUM = 'SOURCES ='
      I2 = 0
 10   I1 = I2 + 1
      I2 = MIN (NSORC,I1+2)
      IF (I1.LE.NSORC) THEN
         WRITE (HILINE,2010) TSKNAM, CDUM, (SRCNAM(I), I = I1,I2)
         IF ((I2.EQ.NSORC) .AND. (I2-I1.LT.2)) THEN
            I = JTRIM (HILINE)
            HILINE(I:) = ' '
            END IF
         CALL HIADD (LUN, HILINE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 900
         CDUM = ' '
         GO TO 10
         END IF
C                                       CL/TE versions
      WRITE (HILINE,2025) TSKNAM, 'GAINVER', CLVIN, 'input CL'
      CALL HIADD (LUN, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 900
      WRITE (HILINE,2025) TSKNAM, 'GAINUSE', CLVOUT, 'output CL'
      CALL HIADD (LUN, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 900
      WRITE (HILINE,2025) TSKNAM, 'TEVER', TEVER, 'output TE'
      CALL HIADD (LUN, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 900
C                                       input file
      J = JTRIM (INFILE)
      IF (INFILE(J:J).EQ.'_') THEN
         HILINE = TSKNAM // '/ multiple source reports read'
      ELSE
         HILINE = TSKNAM // '/ all sources use the same report'
         END IF
      CALL HIADD (LUN, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 900
      I = MIN (J, 54)
      HILINE = TSKNAM // '/ ASDMFILE=''' // INFILE(:I)
      IF (I.LT.54) THEN
         I = I + J
         HILINE(I+1:) = ''''
         CALL HIADD (LUN, HILINE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 900
      ELSE
         CALL HIADD (LUN, HILINE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 900
         I1 = MIN (118, J)
         HILINE = TSKNAM // '/ ' // INFILE(I+1:I1)
         I1 = JTRIM (HILINE)
         IF (I1.LT.72) THEN
            HILINE (I1+1:) = ''''
            CALL HIADD (LUN, HILINE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 900
         ELSE
            CALL HIADD (LUN, HILINE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 900
            HILINE = TSKNAM // '/ ' // INFILE(I1+1:J) // ''''
            CALL HIADD (LUN, HILINE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 900
            END IF
         END IF
      WRITE (HILINE,2050) TSKNAM, SUMRUN
      CALL HIADD (LUN, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 900
C
      CALL HICLOS (LUN, .TRUE., SCRTCH, I)
      GO TO 999
C
 900  CALL HICLOS (LUN, .TRUE., SCRTCH, I)
      WRITE (MSGTXT,1000) IRET, 'WRITING HISTORY FILE'
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RIFRMH ERROR',I4,' ON ',A)
 2000 FORMAT (A6,'RELEASE   =''',A7,' ''  /******* Start ',A12,2X,A8)
 2010 FORMAT (A6,A9,3(' ''',A,''''))
 2025 FORMAT (A6,A,' =',I4,5X,'/ ',A,' table version')
 2050 FORMAT (A6,'/ ALBUS reported sum run time',F8.2,' minutes')
      END

LOCAL INCLUDE 'CMPLX.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   CATI1(256), CATI2(256), CATI3(256), CATI4(256),
     *   CATB(256,4), CATIO(256,2)
      REAL      CATR1(256), CATR2(256), CATR3(256), CATR4(256)
      HOLLERITH CATH1(256), CATH2(256), CATH3(256), CATH4(256)
      DOUBLE PRECISION CATD1(128),  CATD2(128), CATD3(128), CATD4(128)
      REAL      IROW(MABFSS,4), FREQ1, FREQ2, LNFREQ, CPARM(10), XN(2),
     *   XX(2), CBMULT(4)
      CHARACTER NAMIN(4)*12, CLSIN(4)*6, NAMOUT(2)*12, CLSOUT(2)*6,
     *   ALGO*4
      LOGICAL   BFLAG, DOFILE(6), PLAIN
      INTEGER   IBLC(7,4), ITRC(7,4), NPI(7,4), NPO(7), FBL(2), ILUN(4),
     *   IIND(4), OLUN(2), OIND(2), ISSEQ(4), IDSEQ(2), NAX, NRDIM(4),
     *   CTYPE, IUSER, IPOINT, FCVOL(6), FCCNO(6), HISTDO, NAX2
      COMMON /CMPLCM/ CATB, CATIO, IROW, FREQ1, FREQ2, LNFREQ,
     *   CPARM, XN, XX, BFLAG, FBL, IBLC, ITRC,
     *   NPI, NPO, ILUN, IIND, OLUN, OIND, ISSEQ, IDSEQ, NAX, NRDIM,
     *   CTYPE, IUSER, IPOINT, DOFILE, PLAIN, FCVOL, FCCNO, HISTDO,
     *   CBMULT, NAX2
      COMMON /CMPLCH/ NAMIN, CLSIN, NAMOUT, CLSOUT, ALGO
      EQUIVALENCE (CATI1, CATR1, CATD1, CATH1, CATB(1,1))
      EQUIVALENCE (CATI2, CATR2, CATD2, CATH2, CATB(1,2))
      EQUIVALENCE (CATI3, CATR3, CATD3, CATH3, CATB(1,3))
      EQUIVALENCE (CATI4, CATR4, CATD4, CATH4, CATB(1,4))
      INCLUDE 'INCS:DCAT.INC'
LOCAL END
      PROGRAM CMPLX
C-----------------------------------------------------------------------
C! Combine two complex maps in various ways, producing an output map.
C# Map-util POLARIZATION ANALYSIS
C-----------------------------------------------------------------------
C;  Copyright (C) 2021-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CMPLX is a general program in which two complex input images are
C   combined on a pixel by pixel level to produce a third image.  It can
C   combine 2 n-dimensional images or one 2-dimensional image with each
C   plane of an n-dimensional image.
C   Inputs: (from AIPS)
C   INNAME......First image name.       Real/amplitude
C   INCLASS.....First image class.
C   INSEQ.......First image seq. #.     0 => highest.
C   INDISK......Disk drive # for the first image.  0 => any.
C   IN2NAME.....First image name.       Imag/phase
C   IN2CLASS....First image class.
C   IN2SEQ......First image seq. #.  0 => highest.
C   IN2DISK.....Disk drive # for the first image.  0 => any.
C   IN3NAME.....Second image name.       Real/amplitude
C   IN3CLASS....Second image class.
C   IN3SEQ......Second image seq. #.   0 => highest.
C   IN3DISK.....Disk # for second image.  0 => any.
C   IN4NAME.....Second image name.       Imag/phase
C   IN4CLASS....Second image class.
C   IN4SEQ......Second image seq. #.  0 => highest.
C   IN4DISK.....Disk # for noise image.  0 => any.
C   DOALIGN.....Controls how the four images are to be aligned (see HELP
C               DOALIGN).  True (>.1) means that the images must agree
C               in their coordinates, though not necessarily in the
C               reference pixel position.  Alignment is by coordinate
C               values (if DOALIGN > -0.1) or by offsets from the
C               reference pixel positions (if DOALIGN <= -0.1).  NOTE:
C               all real axes (>1 point) are aligned.  If DOALIGN = -2,
C               the headers are ignored and the images are aligned at
C               pixel (1,1,...).
C   OUTNAME.....Output image name.       Real/amplitude
C   OUTCLASS....Output image class.   Standard behavior with default =
C               either the output STOKES in string form or the OPCODE if
C               the output STOKES is the same as the first input image.
C   OUTSEQ......Output image seq. #.  0 => highest unique.
C   OUTDISK.....Output disk number. 0 => highest with space.
C   OUT2NAME....Output image name.       Imag/phase
C   OUT2CLAS....Output image class.   Standard behavior with default =
C               either the output STOKES in string form or the OPCODE if
C               the output STOKES is the same as the first input image.
C   OUT2SEQ.....Output image seq. #.  0 => highest unique.
C   OUT2DISK....Output disk number. 0 => highest with space.
C   BLC.........Bottom left corner of the 1st input image. The other
C               images are aligned by coordinates (see DOALIGN) on all
C               axes having > 1 point.  The other images may have fewer
C               real axes than the 1st.  The 4 windows must have the
C               same dimension on the first 2 axes, but the task will
C               select a smaller window than was specified if needed to
C               overlap the 4 images.
C   TRC.........Top right corner of input images. (See BLC.)
C   OPCODE......The combination algorithm specification: (A=APARM)
C   APARM.......Parameters needed for algorithm:
C      APARM(1), APARM(2), APARM(3), APARM(4) used as above.
C           APARM(1) = 0 => APARM(1) = 1.0
C           APARM(2) = 0 => APARM(2) = 1.0 (FOR 'SUM ')
C   DOHIST.....-2 => copy 1st HI only
C              -3 => no copy of HI
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   IRET, IERR, IWIN(4), ISWIN(4), NBY, NX, NY, IDEPTH(5),
     *   IBLKOF, NBYBUF, ISPOS(4), IDPOS(2), I3, I4, I5, I6, I7, I, IY
      INCLUDE 'CMPLX.INC'
      REAL      XBUFF(MABFSS,2)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGNAM /'CMPLX'/
      DATA ISWIN /0,0,0,0/
C-----------------------------------------------------------------------
C                                        Initialize input maps
      IRET = 16
      CALL CMPLXI (PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL CMPLXP (CTYPE, CPARM, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL FILL (4, 1, ISPOS)
      CALL FILL (2, 1, IDPOS)
C                                        Do-loop limits: window
      NBY = 2
      NBYBUF = MABFSS * NBY
      NX = NPO(1)
      NY = NPO(2)
      DO 70 I7 = 1,NPO(7)
      DO 69 I6 = 1,NPO(6)
      DO 68 I5 = 1,NPO(5)
      DO 67 I4 = 1,NPO(4)
      DO 66 I3 = 1,NPO(3)
C                                        Initialize input maps
         DO 10 I = 1,4
            IF (DOFILE(I)) THEN
               CALL FILL (5, 1, IDEPTH(1))
               IF (NRDIM(I).GE.3) IDEPTH(1) = I3 - 1 + IBLC(3,I)
               IF (NRDIM(I).GE.4) IDEPTH(2) = I4 - 1 + IBLC(4,I)
               IF (NRDIM(I).GE.5) IDEPTH(3) = I5 - 1 + IBLC(5,I)
               IF (NRDIM(I).GE.6) IDEPTH(4) = I6 - 1 + IBLC(6,I)
               IF (NRDIM(I).GE.7) IDEPTH(5) = I7 - 1 + IBLC(7,I)
               CALL COMOFF (NAX, NPI(1,I), IDEPTH, IBLKOF, IERR)
               IF (IERR.NE.0) GO TO 995
               IBLKOF = IBLKOF + 1
               IWIN(1) = IBLC(1,I)
               IWIN(2) = IBLC(2,I)
               IWIN(3) = ITRC(1,I)
               IWIN(4) = ITRC(2,I)
               CALL MINIT ('READ', ILUN(I), IIND(I), NPI(1,I), NPI(2,I),
     *            IWIN, IROW(1,I), NBYBUF, IBLKOF, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1010) I, IERR
                  GO TO 980
                  END IF
               END IF
 10         CONTINUE
C                                        Initialize output file
         IDEPTH(1) = I3
         IDEPTH(2) = I4
         IDEPTH(3) = I5
         IDEPTH(4) = I6
         IDEPTH(5) = I7
         CALL COMOFF (NAX, NPO, IDEPTH, IBLKOF, IERR)
         IF (IERR.NE.0) GO TO 995
         IBLKOF = IBLKOF + 1
         ISWIN(1) = 1
         ISWIN(2) = 1
         ISWIN(3) = NPO(1)
         ISWIN(4) = NPO(2)
         DO 20 I = 1,2
            IF (DOFILE(I+4)) THEN
               CALL MINIT ('WRIT', OLUN(I), OIND(I), NX, NY, ISWIN,
     *            XBUFF(1,I), NBYBUF, IBLKOF, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1020) I, IERR
                  GO TO 980
                  END IF
               END IF
 20         CONTINUE
C                                        Loop over rows
         CALL FILL (4, 1, ISPOS)
         DO 50 IY = 1,NY
            DO 30 I = 1,4
               IF (DOFILE(I)) THEN
                  CALL MDISK ('READ', ILUN(I), IIND(I), IROW(1,I),
     *               ISPOS(I), IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1030) IY, I, IERR
                     GO TO 980
                     END IF
                  END IF
 30            CONTINUE
            DO 40 I = 1,2
               IF (DOFILE(I+4)) THEN
                  CALL MDISK ('WRIT', OLUN(I), OIND(I), XBUFF(1,I),
     *               IDPOS(I), IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1040) IY, I, IERR
                     GO TO 980
                     END IF
                  END IF
 40            CONTINUE
            CALL CMPLXN (NX, IROW(ISPOS(1),1), IROW(ISPOS(2),2),
     *         IROW(ISPOS(3),3), IROW(ISPOS(4),4), CTYPE, CPARM,
     *         XBUFF(IDPOS(1),1), XBUFF(IDPOS(2),2))
 50         CONTINUE
C                                        Write the last buffer
         DO 60 I = 1,2
            IF (DOFILE(I+4)) THEN
               CALL MDISK ('FINI', OLUN(I), OIND(I), XBUFF(1,I),
     *            IDPOS(I), IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1060) I, IERR
                  GO TO 980
                  END IF
               END IF
 60         CONTINUE
 66      CONTINUE
 67      CONTINUE
 68      CONTINUE
 69      CONTINUE
 70      CONTINUE
C                                        Create and write HI file
      CALL CMPLXH (IRET)
      GO TO 995
C                                        Error return
 980  CALL MSGWRT (7)
C
 995  CALL DIE (IRET, IROW)
C
 999  STOP
C-----------------------------------------------------------------------
 1010 FORMAT ('COULD NOT INITIALIZE INPUT FILE #',I2,'  IER=',I7)
 1020 FORMAT ('COULD NOT INITIALIZE OUTPUT FILE 3',I2,'  IER=',I7)
 1030 FORMAT ('COULD NOT READ LINE',I4,'  MAP #',I2,'  IER=',I7)
 1040 FORMAT ('COULD NOT WRITE LINE',I4,'  MAP #',I2,'  IER=',I7)
 1060 FORMAT ('COULD NOT WRITE LAST LINE, MAP #',I2,'.  IER=',I7)
      END
      SUBROUTINE CMPLXI (PRGNAM, IER)
C-----------------------------------------------------------------------
C   CMPLXI gets the inputs for CMPLX, opens and checks the input images,
C   creates the output image(s), and prepares parameters in common for
C   the later stages of CMPLX.
C   Inputs:
C      PRGNAM   C*6   Program name
C   Outputs:
C      IER      I     Error return: 0-->  Okay
C                        3-->  Cannot create and open output file
C                        2-->  Cannot open either input map
C                        1-->  Error in getting input parameters
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   IER
C
      CHARACTER IDCDEF*6, PHNAME*48, MTYPE*2, ALGOS(12)*4,
     *   STOKES*8, CHTMP*8, CHTMP1*8
      INTEGER   I, IERR, IRETCD, INPRMS, NB, NALGOS, INC, J, I1, IROUND,
     *   K
      LOGICAL   REDUCE, T
      REAL      EPS, X, AXV
      REAL      XSEQ1, XDSK1, XSEQ2, XDSK2, XSEQ3, XDSK3, XSEQ4, XDSK4,
     *   SEQOU1, DSKOU1, SEQOU2, DSKOU2, C(10), BLC(7), TRC(7), GRIDCR,
     *   DOHIST
      HOLLERITH XNAM1(3), XCLS1(2), XNAM2(3), XCLS2(2), XNAM3(3),
     *   XCLS3(2), XNAM4(3), XCLS4(2), XNAMO1(3), XCLSO1(2), XNAMO2(3),
     *   XCLSO2(2), XALGO
      DOUBLE PRECISION    DAXV
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'CMPLX.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMMON /INPARM/ XNAM1, XCLS1, XSEQ1, XDSK1, XNAM2, XCLS2, XSEQ2,
     *   XDSK2, XNAM3, XCLS3, XSEQ3, XDSK3, XNAM4, XCLS4, XSEQ4, XDSK4,
     *   GRIDCR, XNAMO1, XCLSO1, SEQOU1, DSKOU1, XNAMO2, XCLSO2, SEQOU2,
     *   DSKOU2, BLC, TRC, XALGO, C, DOHIST
      DATA EPS /0.2/
      DATA T /.TRUE./
      DATA NALGOS, ALGOS /12, 'CONJ', 'SWAP', 'SUM', 'SUMC', 'SUMI',
     *   'ISUM' ,'DIV', 'DIVC', 'DIVI', 'MULT','MULC', 'MULI'/
      DATA STOKES /'STOKES  '/
C-----------------------------------------------------------------------
C                                        Initialize file and header I/O
      ILUN(1) = 17
      ILUN(2) = 18
      ILUN(3) = 19
      ILUN(4) = 20
      OLUN(1) = 21
      OLUN(2) = 22
C
      CALL ZDCHIN (T)
      CALL VHDRIN
      NSCR = 0
      NCFILE = 0
      IER = 0
C                                        Get inputs from AIPS
      INPRMS = 69
      CALL GTPARM (PRGNAM, INPRMS, RQUICK, XNAM1, IROW, IERR)
      IRETCD = IERR
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (7)
         END IF
      IF (RQUICK) CALL RELPOP (IRETCD, IROW, IERR)
      IF (IRETCD.NE.0) GO TO 980
C                                       Change input OPCODE - char
      HISTDO = IROUND (DOHIST)
      CTYPE = 0
      CALL H2CHR (4, 1, XALGO, ALGO)
      DO 20 I = 1,NALGOS
         IF (ALGO.EQ.ALGOS(I)) CTYPE = I
 20      CONTINUE
      IF (CTYPE.LE.0) THEN
         WRITE (MSGTXT,1020) ALGO
         CALL MSGWRT (8)
         GO TO 980
         END IF
      CALL RCOPY (10, C, CPARM)
      IF (CTYPE.EQ.2) THEN
         IF (CPARM(8).GT.0.0) THEN
            CPARM(10) = -1.0
         ELSE
            CPARM(10) = 1.0
            END IF
         END IF
      DOFILE(1) = .TRUE.
      DOFILE(2) = .TRUE.
      DOFILE(3) = CTYPE.GT.2
      DOFILE(4) = CTYPE.GT.2
      DOFILE(5) = .TRUE.
      DOFILE(6) = .TRUE.
C                                        Transfer inputs into integer
C                                        variables
      FCVOL(1) = IROUND (XDSK1)
      FCVOL(2) = IROUND (XDSK2)
      FCVOL(3) = IROUND (XDSK3)
      FCVOL(4) = IROUND (XDSK4)
      ISSEQ(1) = IROUND (XSEQ1)
      ISSEQ(2) = IROUND (XSEQ2)
      ISSEQ(3) = IROUND (XSEQ3)
      ISSEQ(4) = IROUND (XSEQ4)
      FCVOL(5) = IROUND (DSKOU1)
      FCVOL(6) = IROUND (DSKOU1)
      IDSEQ(1) = IROUND (SEQOU1)
      IDSEQ(2) = IROUND (SEQOU2)
      IUSER = NLUSER
C                                       Hollerith -> Char.
      CALL H2CHR (12, 1, XNAM1(1), NAMIN(1))
      CALL H2CHR (6, 1, XCLS1(1), CLSIN(1))
      CALL H2CHR (12, 1, XNAM2(1), NAMIN(2))
      CALL H2CHR (6, 1, XCLS2(1), CLSIN(2))
      CALL H2CHR (12, 1, XNAM3(1), NAMIN(3))
      CALL H2CHR (6, 1, XCLS3(1), CLSIN(3))
      CALL H2CHR (12, 1, XNAM4(1), NAMIN(4))
      CALL H2CHR (6, 1, XCLS4(1), CLSIN(4))
      CALL H2CHR (12, 1, XNAMO1(1), NAMOUT(1))
      CALL H2CHR (6, 1, XCLSO1(1), CLSOUT(1))
      CALL H2CHR (12, 1, XNAMO2(1), NAMOUT(2))
      CALL H2CHR (6, 1, XCLSO2(1), CLSOUT(2))
C                                        Open both input maps
      MTYPE = 'MA'
      CALL RFILL (4, 0.0, CBMULT)
      DO 35 I = 1,4
         IF (DOFILE(I)) THEN
            CALL MAPOPN ('READ', FCVOL(I), NAMIN(I), CLSIN(I), ISSEQ(I),
     *         MTYPE, IUSER, ILUN(I), IIND(I), FCCNO(I), CATBLK,
     *         IROW(1,I), IERR)
            CALL COPY (256, CATBLK, CATB(1,I))
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1025) I,IERR
               CALL MSGWRT (7)
               GO TO 960
               END IF
            NCFILE = NCFILE + 1
            FRW(NCFILE) = 0
            FVOL(NCFILE) = FCVOL(I)
            FCNO(NCFILE) = FCCNO(I)
            NB = CATBLK(KIDIM)
            CALL FILL (KICTPN, 1, NPI(1,I))
            CALL COPY (NB, CATBLK(KINAX), NPI(1,I))
            NRDIM(I) = NB
            DO 30 J = 1,NB
               NPI(J,I) = MAX (1, NPI(J,I))
               IF (NPI(J,I).LE.1) NRDIM(I) = NRDIM(I) - 1
 30            CONTINUE
            CALL H2CHR (8, 1, CATH(KHBUN), CHTMP)
            CALL CHLTOU (8, CHTMP)
            IF (CHTMP.EQ.'JY/BEAM') CBMULT(I) = CATR(KRBMJ)*CATR(KRBMN)
            END IF
 35      CONTINUE
      IF (CBMULT(1).LE.0.0) THEN
         CALL RFILL (4, 1.0, CBMULT)
      ELSE
         DO 36 I = 2,4
            IF ((DOFILE(I)) .AND. (CBMULT(I).NE.1.0) .AND.
     *         (CBMULT(1).NE.1.0)) THEN
               CBMULT(I) = CBMULT(I) / CBMULT(1)
               IF (CBMULT(I).LE.0.0) CBMULT(I) = 1.0
               CBMULT(I) = 1.0 / CBMULT(I)
            ELSE
               CBMULT(I) = 1.0
               END IF
 36         CONTINUE
         CBMULT(1) = 1.0
         END IF
C                                        Set up some needed header vals
      REDUCE = .FALSE.
      NAX = CATI1(KIDIM)
      NAX2 = CATI2(KIDIM)
      CALL WINDOW (NAX, NPI(1,1), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 960
      DO 40 I = 1,7
         IBLC(I,1) = BLC(I) + EPS
         ITRC(I,1) = TRC(I) + EPS
         NPO(I) = ITRC(I,1) - IBLC(I,1) + 1
 40      CONTINUE
C                                       Are input maps coincident?
C                                       Set 2nd map corners
      INC = 2
      DO 70 K = 2,4
         IF (DOFILE(K)) THEN
            CALL COPY (256, CATB(1,K), CATBLK)
            DO 65 I = 1,7
               J = I - 1
C                                       null axis
               IBLC(I,K) = 1
               ITRC(I,K) = 1
               IF (NPI(I,K).GT.1) THEN
                  AXV = CATR(KRCRP+J) - CATR1(KRCRP+J) + IBLC(I,1)
                  IF (GRIDCR.LT.-1.5) AXV = IBLC(I,1)
                  IF (GRIDCR.GT.-0.1) THEN
                     DAXV = CATD1(KDCRV+J) + (IBLC(I,1) -
     *                  CATR1(KRCRP+J)) * CATR1(KRCIC+J)
                     IF (CATR(KRCIC+J).EQ.0.0) GO TO 75
                     AXV = (DAXV - CATD(KDCRV+J)) / CATR(KRCIC+J) +
     *                  CATR(KRCRP+J)
                     END IF
                  IBLC(I,K) = IROUND (AXV)
                  IF ((GRIDCR.GE.0.1) .AND. (ABS(AXV-IBLC(I,K)).GT.EPS))
     *               GO TO 75
                  ITRC(I,K) = IBLC(I,K) + ITRC(I,1) - IBLC(I,1)
C                                       smaller subimage required?
                  IF (IBLC(I,K).LT.1) THEN
                     IBLC(I,1) = IBLC(I,1) + 1 - IBLC(I,K)
                     BLC(I) = IBLC(I,1)
                     IF (K.GT.2) IBLC(I,2) = IBLC(I,2) + 1 - IBLC(I,K)
                     IF (K.GT.3) IBLC(I,3) = IBLC(I,3) + 1 - IBLC(I,K)
                     REDUCE = .TRUE.
                     IBLC(I,K) = 1
                     END IF
                  IF (ITRC(I,K).GT.NPI(I,K)) THEN
                     ITRC(I,1) = ITRC(I,1) + NPI(I,K) - ITRC(I,K)
                     TRC(I) = ITRC(I,1)
                     IF (K.GT.2) ITRC(I,2) = ITRC(I,2) + NPI(I,K) -
     *                  ITRC(I,K)
                     IF (K.GT.3) ITRC(I,3) = ITRC(I,3) + NPI(I,K) -
     *                  ITRC(I,K)
                     REDUCE = .TRUE.
                     ITRC(I,K) = NPI(I,K)
                     END IF
                  IF (IBLC(I,1).GT.ITRC(I,1)) GO TO 75
                  NPO(I) = ITRC(I,1) - IBLC(I,1) + 1
C                                        Check coincidence
                  IF (GRIDCR.GE.0.1) THEN
                     IPOINT = KHCTP+J*INC
                     CALL H2CHR (8, 1, CATH(IPOINT), CHTMP)
                     CALL H2CHR (8, 1, CATH1(IPOINT), CHTMP1)
                     IF (CHTMP.NE.CHTMP1) GO TO 75
                     X = EPS * EPS * ABS(CATR1(KRCIC+J))
                     IF (ABS(CATR(KRCIC+J)-CATR1(KRCIC+J)).GT.X)
     *                  GO TO 75
                     IF (ABS(CATR(KRCRT+J)-CATR1(KRCRT+J)).GT.1.)
     *               GO TO 75
                     END IF
                  END IF
 65            CONTINUE
            END IF
 70      CONTINUE
      GO TO 80
C                                        Maps not coincident
 75   WRITE (MSGTXT,1075) I
      CALL MSGWRT (7)
      GO TO 960
C                                       Create output map
C                                       Get stokes value of input maps
C                                       Insert proper Stokes value
 80   MSGTXT = 'CMPLXI: input maps coincident on reduced subimage only'
      IF (REDUCE) CALL MSGWRT (6)
      XX(1) = -1.0E30
      XX(2) = -1.0E30
      XN(1) = 1.0E30
      XN(2) = 1.0E30
      BFLAG = .FALSE.
      CALL COPY (256, CATI1, CATBLK)
      INC = 2
C                                        Default out class
      IDCDEF = 'R ' // ALGO
      IF (CPARM(10).GT.0.0) IDCDEF = 'A ' // ALGO
      CALL MAKOUT (NAMIN(1), CLSIN(1), ISSEQ(1), IDCDEF, NAMOUT(1),
     *   CLSOUT(1), IDSEQ(1))
      CALL CHR2H (12, NAMOUT(1), KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLSOUT(1), KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = IDSEQ(1)
      CATBLK(KIIMU) = NLUSER
      CALL SUBHDR (BLC, TRC, 1.0, 1.0)
      CALL MCREAT (FCVOL(5), FCCNO(5), IROW, IERR)
      IDSEQ(1) = CATBLK(KIIMS)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) IERR
         CALL MSGWRT (8)
         GO TO 950
         END IF
      NCFILE = NCFILE + 1
      FRW(NCFILE) = 2
      FVOL(NCFILE) = FCVOL(5)
      FCNO(NCFILE) = FCCNO(5)
C                                       Copy header keywords from first
C                                       input.
      CALL KEYPCP (FCVOL(1), FCCNO(1), FCVOL(5), FCCNO(5), 0, ' ', IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1135) IERR
         CALL MSGWRT (7)
C                                       Let it slide.
         IERR = 0
         END IF
C                                        Open the output file
      CALL ZPHFIL ('MA', FCVOL(5), FCCNO(5), 1, PHNAME, IERR)
      CALL ZOPEN (OLUN(1), OIND(1), FCVOL(5), PHNAME, T, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1136) IERR
         CALL MSGWRT (7)
         GO TO 950
         END IF
      CALL COPY (256, CATBLK, CATIO(1,1))
C                                       imaginary/phase
      IDCDEF = 'I ' // ALGO
      IF (CPARM(10).GT.0.0) IDCDEF = 'P ' // ALGO
      CALL MAKOUT (NAMIN(2), CLSIN(2), ISSEQ(2), IDCDEF, NAMOUT(2),
     *   CLSOUT(2), IDSEQ(2))
      CALL CHR2H (12, NAMOUT(2), KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLSOUT(2), KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = IDSEQ(2)
      CATBLK(KIIMU) = NLUSER
      IF (CPARM(10).GT.0.0) CALL CHR2H (8, 'Degrees ', 1, CATH(KHBUN))
      CALL MCREAT (FCVOL(6), FCCNO(6), IROW, IERR)
      IDSEQ(2) = CATBLK(KIIMS)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1110) IERR
         CALL MSGWRT (8)
         GO TO 950
         END IF
      NCFILE = NCFILE + 1
      FRW(NCFILE) = 2
      FVOL(NCFILE) = FCVOL(6)
      FCNO(NCFILE) = FCCNO(6)
C                                       Copy header keywords from first
C                                       input.
      CALL KEYPCP (FCVOL(1), FCCNO(1), FCVOL(6), FCCNO(6), 0, ' ', IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1135) IERR
         CALL MSGWRT (7)
C                                       Let it slide.
         IERR = 0
         END IF
C                                        Open the output file
      CALL ZPHFIL ('MA', FCVOL(6), FCCNO(6), 1, PHNAME, IERR)
      CALL ZOPEN (OLUN(2), OIND(2), FCVOL(6), PHNAME, T, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1136) IERR
         CALL MSGWRT (7)
         GO TO 950
         END IF
      CALL COPY (256, CATBLK, CATIO(1,2))
      GO TO 999
C-----------------------------------------------------------------------
C                                        Error returns
C                                        Failed to create output file
 950  IER = IER + 1
C                                        Error in MAPOPN
 960  IER = IER + 1
C                                        Error in getting parameters
 980  IER = IER + 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('CMPLXI: COULD NOT GET PARMS.  IER=',I7)
 1020 FORMAT ('DO NOT RECOGNIZE OPCODE = ',A4)
 1025 FORMAT ('CMPLXI: COULD NOT OPEN MAP # ',I1,'  IER=',I7)
 1075 FORMAT ('CMPLXI: INPUT MAPS ARE NOT COINCIDENT ON AXIS',I2)
 1110 FORMAT ('CMPLXI: COULD NOT CREATE OUTPUT MAP.  IER=',I7)
 1135 FORMAT ('CMPLXI: ERROR ', I3,' COPYING KEYWORDS - CONTINUING')
 1136 FORMAT ('CMPLXI: COULD NOT OPEN OUTPUT MAP.  IER=',I7)
      END
      SUBROUTINE CMPLXP (COMB, C, IER)
C-----------------------------------------------------------------------
C   CMPLXP writes output describing the algorithm, prepares default
C   values and obtains necessary parameters for CMPLXN.
C   Inputs:
C      COMB     I        The algorithm type
C      C        R(*)     The algorithm parameters
C   Outputs:
C      IER      I        Error code: 0 --> okay
C                                    1 --> not okay
C      FREQ1    R        Frequency of first map
C      FREQ2    R        Frequency of second map
C      LNFREQ   R        Log(FREQ1/FREQ2)
C      FBLANK   R        Blanking value used in scratch file
C-----------------------------------------------------------------------
      INTEGER   COMB, IER
      REAL      C(*)

      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'CMPLX.INC'
C-----------------------------------------------------------------------
C                                       Initialize
      IER = 0
C                                       Conjugate
      IF (COMB.EQ.1) THEN
         IF (C(1).EQ.0.0) C(1) = 1.0
         WRITE (MSGTXT,1010) C(1), C(2), C(3)
C                                       SWAP
      ELSE IF (COMB.EQ.2) THEN
         IF (C(1).EQ.0.0) C(1) = 1.0
         WRITE (MSGTXT,1020) C(1), C(2), C(3)
C                                       Linear combination 'SUM '
      ELSE IF (COMB.EQ.3) THEN
         IF (C(1).EQ.0.0) C(1) = 1.0
         IF (C(2).EQ.0.0) C(2) = 1.0
         WRITE (MSGTXT,1030) C(1), C(2), C(3), C(4)
C                                       Linear combination 'SUMC'
      ELSE IF (COMB.EQ.4) THEN
         IF (C(1).EQ.0.0) C(1) = 1.0
         IF (C(2).EQ.0.0) C(2) = 1.0
         WRITE (MSGTXT,1040) C(1), C(2), C(3), C(4)
C                                       Linear combination 'SUMI'
      ELSE IF (COMB.EQ.5) THEN
         IF (C(1).EQ.0.0) C(1) = 1.0
         IF (C(2).EQ.0.0) C(2) = 1.0
         WRITE (MSGTXT,1050) C(1), C(2), C(3), C(4)
C                                       Linear combination 'ISUM'
      ELSE IF (COMB.EQ.6) THEN
         IF (C(1).EQ.0.0) C(1) = 1.0
         IF (C(2).EQ.0.0) C(2) = 1.0
         WRITE (MSGTXT,1060) C(1), C(2), C(3), C(4)
C                                       Division 'DIV '
      ELSE IF (COMB.EQ.7) THEN
         IF (C(1).EQ.0.0) C(1) = 1.0
         WRITE (MSGTXT,1070) C(1), C(2), C(3)
C                                       division 'DIVC'
      ELSE IF (COMB.EQ.8) THEN
         IF (C(1).EQ.0.0) C(1) = 1.0
         WRITE (MSGTXT,1080) C(1), C(2), C(3)
C                                       division 'DIVI'
      ELSE IF (COMB.EQ.9) THEN
         IF (C(1).EQ.0.0) C(1) = 1.0
         WRITE (MSGTXT,1090) C(1), C(2), C(3)
C                                       Product 'MULT'
      ELSE IF (COMB.EQ.10) THEN
         IF (C(1).EQ.0.0) C(1) = 1.0
         WRITE (MSGTXT,1100) C(1), C(2), C(3)
C                                       Product 'MULC'
      ELSE IF (COMB.EQ.11) THEN
         IF (C(1).EQ.0.0) C(1) = 1.0
         WRITE (MSGTXT,1110) C(1), C(2), C(3)
C                                       Product 'MULI'
      ELSE IF (COMB.EQ.12) THEN
         IF (C(1).EQ.0.0) C(1) = 1.0
         WRITE (MSGTXT,1120) C(1), C(2), C(3)
         END IF
      CALL MSGWRT (2)
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('CONJ',F7.3,'*conj(M(1)) +',F7.3,' + i*',F7.3)
 1020 FORMAT ('SWAP',F7.3,'*M(1) +',F7.3,' + i*',F7.3)
 1030 FORMAT ('SUM ',F7.3,'*M(1) +',F7.3,'*M(2) +',F7.3,' + i*',F7.3)
 1040 FORMAT ('SUMC',F7.3,'*M(1) +',F7.3,'*conj(M(2)) +',F7.3,' + i*',
     *   F7.3)
 1050 FORMAT ('SUMI',F7.3,'*M(1) +',F7.3,'*i*M(2) +',F7.3,' + i*',F7.3)
 1060 FORMAT ('ISUM i*(',F7.3,'*M(1) +',F7.3,'*M(2)) +',F7.3,' + i*',
     *   F7.3)
 1070 FORMAT ('DIV ',F7.3,'*M(1) / M(2) +',F7.3,' + i*',F7.3)
 1080 FORMAT ('DIVC',F7.3,'*M(1) / conj(M(2)) +',F7.3,' + i*',F7.3)
 1090 FORMAT ('DIVI',F7.3,'*M(1) / (i*M(2)) +',F7.3,' + i*',F7.3)
 1100 FORMAT ('MULT',F7.3,'*M(1) * M(2) +',F7.3,' + i*',F7.3)
 1110 FORMAT ('MULC',F7.3,'*M(1) * conj(M(2)) +',F7.3,' + i*',F7.3)
 1120 FORMAT ('MULI',F7.3,'*M(1) * (i*M(2)) +',F7.3,' + i*',F7.3)
      END
      SUBROUTINE CMPLXN (NX, V1, V2, V3, V4, COMB, C, R1, R2)
C-----------------------------------------------------------------------
C   CMPLXN combines complex pixel rows V1/V2 and V3/V4 to form result
C   row R1/R2   The algorithm is specified by COMB and any parameters
C   are stored in the array C.
C   Inputs:
C      NX     I       Number of pixels in each vector.
C      V1     R(NX)   The pixel values of the input map 1
C      V2     R(NX)   The pixel values of the input map 2
C      COMB   I       The algorithm type: see Main pgm
C      C      R(20)   Up to 20 inputs parameters
C   Outputs:
C      R1     R(NX)   The result of the combination
C-----------------------------------------------------------------------
      INTEGER   NX, COMB
      REAL      V1(*), V2(*), V3(*), V4(*), R1(*), R2(*), C(*)
C
      INTEGER   I
      REAL      BRES, A, P, DEN
      LOGICAL   BLANK
      INCLUDE 'CMPLX.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       Value for blanked on output
      BRES = FBLANK
C                                       convert amp/phase
      IF (C(8).GT.0.0) THEN
         DO 10 I = 1,NX
            IF ((V1(I).NE.FBLANK) .AND. (V2(I).NE.FBLANK)) THEN
               A = V1(I)
               P = V2(I) * DG2RAD
               V1(I) = A * COS (P)
               V2(I) = A * SIN (P)
            ELSE
               V1(I) = FBLANK
               V2(I) = FBLANK
               END IF
 10         CONTINUE
         END IF
      IF ((COMB.GT.2) .AND. (C(9).GT.0.0)) THEN
         DO 20 I = 1,NX
            IF ((V3(I).NE.FBLANK) .AND. (V4(I).NE.FBLANK)) THEN
               A = V3(I)
               P = V4(I) * DG2RAD
               V3(I) = A * COS (P)
               V4(I) = A * SIN (P)
            ELSE
               V3(I) = FBLANK
               V4(I) = FBLANK
               END IF
 20         CONTINUE
         END IF
      IF (CBMULT(2).NE.1.0) THEN
         DO 30 I = 1,NX
            IF (V2(I).NE.FBLANK) V2(I) = CBMULT(2) * V2(I)
 30         CONTINUE
         END IF
      IF ((DOFILE(3)) .AND. (CBMULT(3).NE.1.0)) THEN
         DO 40 I = 1,NX
            IF (V3(I).NE.FBLANK) V3(I) = CBMULT(3) * V3(I)
 40         CONTINUE
         END IF
      IF ((DOFILE(4)) .AND. (CBMULT(4).NE.1.0)) THEN
         DO 50 I = 1,NX
            IF (V4(I).NE.FBLANK) V4(I) = CBMULT(4) * V3(I)
 50         CONTINUE
         END IF
C                                       CONJ
      IF (COMB.EQ.1) THEN
         DO 110 I = 1,NX
            BLANK = (V1(I).EQ.FBLANK) .OR. (V2(I).EQ.FBLANK)
            IF (.NOT.BLANK) THEN
               R1(I) = C(1) * V1(I) + C(2)
               R2(I) = -C(1) * V2(I) + C(3)
            ELSE
               R1(I) = FBLANK
               R2(I) = FBLANK
               END IF
 110        CONTINUE
C                                       SWAP
      ELSE IF (COMB.EQ.2) THEN
         DO 120 I = 1,NX
            BLANK = (V1(I).EQ.FBLANK) .OR. (V2(I).EQ.FBLANK)
            IF (.NOT.BLANK) THEN
               R1(I) = C(1) * V1(I) + C(2)
               R2(I) = C(1) * V2(I) + C(3)
            ELSE
               R1(I) = FBLANK
               R2(I) = FBLANK
               END IF
 120        CONTINUE
C                                       SUM
      ELSE IF (COMB.EQ.3) THEN
         DO 130 I = 1,NX
            BLANK = (V1(I).EQ.FBLANK) .OR. (V2(I).EQ.FBLANK) .OR.
     *         (V3(I).EQ.FBLANK) .OR. (V4(I).EQ.FBLANK)
            IF (.NOT.BLANK) THEN
               R1(I) = C(1) * V1(I) + C(2) * V3(I) + C(3)
               R2(I) = C(1) * V2(I) + C(2) * V4(I) + C(4)
            ELSE
               R1(I) = FBLANK
               R2(I) = FBLANK
               END IF
 130        CONTINUE
C                                       SUMC
      ELSE IF (COMB.EQ.4) THEN
         DO 140 I = 1,NX
            BLANK = (V1(I).EQ.FBLANK) .OR. (V2(I).EQ.FBLANK) .OR.
     *         (V3(I).EQ.FBLANK) .OR. (V4(I).EQ.FBLANK)
            IF (.NOT.BLANK) THEN
               R1(I) = C(1) * V1(I) + C(2) * V3(I) + C(3)
               R2(I) = C(1) * V2(I) - C(2) * V4(I) + C(4)
            ELSE
               R1(I) = FBLANK
               R2(I) = FBLANK
               END IF
 140        CONTINUE
C                                       SUMI
      ELSE IF (COMB.EQ.5) THEN
         DO 150 I = 1,NX
            BLANK = (V1(I).EQ.FBLANK) .OR. (V2(I).EQ.FBLANK) .OR.
     *         (V3(I).EQ.FBLANK) .OR. (V4(I).EQ.FBLANK)
            IF (.NOT.BLANK) THEN
               R1(I) = C(1) * V1(I) - C(2) * V4(I) + C(3)
               R2(I) = C(1) * V2(I) + C(2) * V3(I) + C(4)
            ELSE
               R1(I) = FBLANK
               R2(I) = FBLANK
               END IF
 150        CONTINUE
C                                       ISUM
      ELSE IF (COMB.EQ.6) THEN
         DO 160 I = 1,NX
            BLANK = (V1(I).EQ.FBLANK) .OR. (V2(I).EQ.FBLANK) .OR.
     *         (V3(I).EQ.FBLANK) .OR. (V4(I).EQ.FBLANK)
            IF (.NOT.BLANK) THEN
               R1(I) = C(1) * V2(I) + C(2) * V4(I) + C(3)
               R1(I) = -(C(1) * V1(I) + C(2) * V3(I)) + C(4)
            ELSE
               R1(I) = FBLANK
               R2(I) = FBLANK
               END IF
 160        CONTINUE
C                                       DIV
      ELSE IF (COMB.EQ.7) THEN
         DO 170 I = 1,NX
            BLANK = (V1(I).EQ.FBLANK) .OR. (V2(I).EQ.FBLANK) .OR.
     *         (V3(I).EQ.FBLANK) .OR. (V4(I).EQ.FBLANK)
            DEN = V3(I)*V3(I) + V4(I)*V4(I)
            IF ((.NOT.BLANK) .AND. (DEN.NE.0.0)) THEN
               R1(I) = C(1)/DEN * (V1(I)*V3(I) + V2(I)*V4(I)) + C(2)
               R2(I) = C(1)/DEN * (V2(I)*V3(I) - V1(I)*V4(I)) + C(3)
            ELSE
               R1(I) = FBLANK
               R2(I) = FBLANK
               END IF
 170        CONTINUE
C                                       DIVC
      ELSE IF (COMB.EQ.8) THEN
         DO 180 I = 1,NX
            BLANK = (V1(I).EQ.FBLANK) .OR. (V2(I).EQ.FBLANK) .OR.
     *         (V3(I).EQ.FBLANK) .OR. (V4(I).EQ.FBLANK)
            DEN = V3(I)*V3(I) + V4(I)*V4(I)
            IF ((.NOT.BLANK) .AND. (DEN.NE.0.0)) THEN
               R1(I) = C(1)/DEN * (V1(I)*V3(I) - V2(I)*V4(I)) + C(2)
               R2(I) = C(1)/DEN * (V2(I)*V3(I) + V1(I)*V4(I)) + C(3)
            ELSE
               R1(I) = FBLANK
               R2(I) = FBLANK
               END IF
 180        CONTINUE
C                                       DIVI
      ELSE IF (COMB.EQ.9) THEN
         DO 190 I = 1,NX
            BLANK = (V1(I).EQ.FBLANK) .OR. (V2(I).EQ.FBLANK) .OR.
     *         (V3(I).EQ.FBLANK) .OR. (V4(I).EQ.FBLANK)
            DEN = V3(I)*V3(I) + V4(I)*V4(I)
            IF ((.NOT.BLANK) .AND. (DEN.NE.0.0)) THEN
               R1(I) = C(1)/DEN * (V2(I)*V3(I) - V1(I)*V4(I)) + C(2)
               R2(I) = -C(1)/DEN * (V1(I)*V3(I) + V2(I)*V4(I)) + C(3)
            ELSE
               R1(I) = FBLANK
               R2(I) = FBLANK
               END IF
 190        CONTINUE
C                                       MULT
      ELSE IF (COMB.EQ.10) THEN
         DO 200 I = 1,NX
            BLANK = (V1(I).EQ.FBLANK) .OR. (V2(I).EQ.FBLANK) .OR.
     *         (V3(I).EQ.FBLANK) .OR. (V4(I).EQ.FBLANK)
            IF (.NOT.BLANK) THEN
               R1(I) = C(1) * (V1(I)*V3(I) - V2(I)*V4(I)) + C(2)
               R2(I) = C(1) * (V2(I)*V3(I) + V1(I)*V4(I)) + C(3)
            ELSE
               R1(I) = FBLANK
               R2(I) = FBLANK
               END IF
 200        CONTINUE
C                                       MULC
      ELSE IF (COMB.EQ.11) THEN
         DO 210 I = 1,NX
            BLANK = (V1(I).EQ.FBLANK) .OR. (V2(I).EQ.FBLANK) .OR.
     *         (V3(I).EQ.FBLANK) .OR. (V4(I).EQ.FBLANK)
            IF (.NOT.BLANK) THEN
               R1(I) = C(1) * (V1(I)*V3(I) + V2(I)*V4(I)) + C(2)
               R2(I) = C(1) * (V2(I)*V3(I) - V1(I)*V4(I)) + C(3)
            ELSE
               R1(I) = FBLANK
               R2(I) = FBLANK
               END IF
 210        CONTINUE
C                                       MULI
      ELSE IF (COMB.EQ.12) THEN
         DO 220 I = 1,NX
            BLANK = (V1(I).EQ.FBLANK) .OR. (V2(I).EQ.FBLANK) .OR.
     *         (V3(I).EQ.FBLANK) .OR. (V4(I).EQ.FBLANK)
            IF (.NOT.BLANK) THEN
               R1(I) = -C(1) * (V1(I)*V4(I) + V2(I)*V3(I)) + C(2)
               R2(I) = C(1) * (V1(I)*V3(I) - V2(I)*V4(I)) + C(3)
            ELSE
               R1(I) = FBLANK
               R2(I) = FBLANK
               END IF
 220        CONTINUE
         END IF
C                                       to amp/phase
      IF (C(10).GT.0.0) THEN
         DO 250 I = 1,NX
            IF (R1(I).NE.FBLANK) THEN
               A = SQRT (R1(I)*R1(I) + R2(I)*R2(I))
               P = 0.0
               IF (A.GT.0.0) P = ATAN2 (R2(I), R1(I)) * RAD2DG
               R1(I) = A
               R2(I) = P
               END IF
 250        CONTINUE
         END IF
C                                       Common processing
      DO 910 I = 1,NX
C                                       Get max/min
         IF (R1(I).NE.FBLANK) THEN
            XX(1) = MAX (XX(1), R1(I))
            XN(1) = MIN (XN(1), R1(I))
            XX(2) = MAX (XX(2), R2(I))
            XN(2) = MIN (XN(2), R2(I))
         ELSE
            BFLAG = .TRUE.
            END IF
 910     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE CMPLXH (IRET)
C-----------------------------------------------------------------------
C   CMPLXH creates and writes the HI file associated with task CMPLX.
C   Outputs:
C      IRET   I      > 0 => output all blanks
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER HILINE*72, WORD(12)*40, FTYPE(2,2)*4, NOTTYP*2
      INTEGER   NHISTF, IHDLUN, IHSLUN, I, IER, IERR, IBUFF1(256), J,
     *    IBUFF2(256), IPTR, ITEMP, NONOT, JTRIM, K
      LOGICAL   TRUE, FALSE
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'CMPLX.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (IBUFF1(1),IROW(1,1)),  (IBUFF2(1),IROW(257,1))
      DATA NHISTF, IHDLUN, IHSLUN /2,27,28/
      DATA WORD /'Conjugate', 'Real/imag <-> Amp/phase',
     *   'A(1)*M1 + A(2)*M2 + A(3) + i*A(4)',
     *   'A(1)*M1 + A(2)*conj(M2) + A(3) + i*A(4)',
     *   'A(1)*M1 + i*a(2)*M2 + A(3) + i*A(4)',
     *   'i*(A(1)*M1 + A(2)*M2) + A(3) + i*A(4)',
     *   'A(1)*(M1 / M2) + A(2) + i*A(3)',
     *   'A(1)*(M1 / conj(M2)) + A(2) + i*A(3)',
     *   'A(1)*(M1 / (i*M2)) + A(2) + i*A(3)',
     *   'A(1)*(M1 * M2) + A(2) + i*A(3)',
     *   'A(1)*(M1 * conj(M2)) + A(2) + i*A(3)',
     *   'A(1)*(M1 * (i*M2)) + A(2) + i*A(3)'/
      DATA TRUE, FALSE /.TRUE.,.FALSE./
      DATA FTYPE /'REAL','IMAG', 'AMP ','PHAS'/
      DATA NONOT, NOTTYP /1, 'CC'/
C-----------------------------------------------------------------------
C                                       Initialize HITAB
      CALL HIINIT (NHISTF)
      IRET = 0
      K = 1
      IF (CPARM(10).GT.0.0) K = 2
      DO 200 J = 2,1,-1
         IF (DOFILE(4+J)) THEN
C                                       Test validity of result
            IF (XX(J).LT.XN(J)) THEN
               WRITE (MSGTXT,1000) FTYPE(J,K)
               CALL MSGWRT (6)
               BFLAG = .TRUE.
            ELSE IF (XX(J).EQ.XN(J)) THEN
               WRITE (MSGTXT,1001) FTYPE(J,K), XX(J)
               CALL MSGWRT (6)
               END IF
C                                       Insert header parameters
            CALL COPY (256, CATIO(1,J), CATBLK)
            CATR(KRDMN) = XN(J)
            CATR(KRDMX) = XX(J)
C                                       Create and open new HI file
            CALL HICREA (IHDLUN, FCVOL(4+J), FCCNO(4+J), CATBLK, IBUFF2,
     *         IERR)
            IPTR = IBUFF2(3)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1010) FTYPE(J,K), IERR
               CALL MSGWRT (7)
               GO TO 200
               END IF
C                                       Copy both input HI files
            DO 50 I = 1,2
               IF (HISTDO.GE.-3+I) THEN
                  WRITE (HILINE,1020) I
                  CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
                  IF (IERR.NE.0) GO TO 190
                  ITEMP = HITAB(IPTR+2)
                  CALL HIOPEN (IHSLUN, FCVOL(I), FCCNO(I), IBUFF1, IERR)
                  IF (IERR.NE.0) GO TO 30
                  CALL HICOPY (IHSLUN, IBUFF1, IHDLUN, IBUFF2, IERR)
                  CALL HICLOS (IHSLUN, FALSE, IBUFF1, IER)
                  IF (IERR.EQ.0) GO TO 50
                     IF (IERR.GE.100) HITAB(IPTR+2) = ITEMP
 30                  WRITE (MSGTXT,1030) I, IERR
                     CALL MSGWRT (6)
                     WRITE (HILINE,1031)
                     CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
                     IF (IERR.NE.0) GO TO 190
               ELSE
                  WRITE (HILINE,1032) TSKNAM, I
                  CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
                  IF (IERR.NE.0) GO TO 190
                  END IF
 50            CONTINUE
            WRITE (HILINE,1050)
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            WRITE (HILINE,1055) TSKNAM, RLSNAM
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
C                                       Add input parameters
            CALL HENCO1 (TSKNAM, NAMIN(1), CLSIN(1), ISSEQ(1), FCVOL(1),
     *         IHDLUN, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            CALL HENCO2 (TSKNAM, NAMIN(2), CLSIN(2), ISSEQ(2), FCVOL(2),
     *         IHDLUN, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            IF (CTYPE.GT.2) THEN
               CALL HENCO1 (TSKNAM, NAMIN(3), CLSIN(3), ISSEQ(3),
     *            FCVOL(3), IHDLUN, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
               CALL HENCO2 (TSKNAM, NAMIN(4), CLSIN(4), ISSEQ(4),
     *            FCVOL(4), IHDLUN, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
               END IF
            CALL HENCOO (TSKNAM, NAMOUT(J), CLSOUT(J), IDSEQ(J),
     *         FCVOL(4+J), IHDLUN, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            WRITE (HILINE,1090) TSKNAM, IUSER
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            I = JTRIM (WORD(CTYPE))
            WRITE (HILINE,1092) TSKNAM, ALGO, WORD(CTYPE)(:I)
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            WRITE (HILINE,1094) TSKNAM, (IBLC(I,1), I = 1,7)
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            WRITE (HILINE,1096) TSKNAM, (ITRC(I,1), I = 1,7)
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            IF ((NRDIM(1).GT.2) .AND. (NRDIM(2).LE.2)) THEN
               WRITE (HILINE,1098) TSKNAM
               CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
               END IF
C                                       Parameters
            IF ((CTYPE.GT.2) .AND. (CTYPE.LE.5)) THEN
               WRITE (HILINE,1100) TSKNAM, (I, CPARM(I), I = 1,4)
            ELSE
               WRITE (HILINE,1101) TSKNAM, (I, CPARM(I), I = 1,3)
               END IF
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
C                                       blanking
            WRITE (HILINE,1110) TSKNAM
            CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
C                                       Clean beam scaling
            DO 60 I = 2,4
               IF ((CBMULT(I).NE.1.0) .AND. (DOFILE(I))) THEN
                  WRITE (HILINE,1112) TSKNAM, I, CBMULT(I)
                  CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
                  IF (IERR.NE.0) GO TO 190
                  MSGTXT = HILINE(7:)
                  CALL MSGWRT (3)
                  END IF
 60            CONTINUE
C                                       amp/phase
            IF (CPARM(8).GT.0.0) THEN
               HILINE = TSKNAM // '/ Input image 1 converted from'
     *            // ' amplitude/phase'
               CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
               END IF
            IF (CPARM(9).GT.0.0) THEN
               HILINE = TSKNAM // '/ Input image 2 converted from'
     *            // ' amplitude/phase'
               CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
               END IF
            IF (CPARM(10).GT.0.0) THEN
               HILINE = TSKNAM // '/ Output image converted to'
     *            // ' amplitude/phase'
               CALL HIADD (IHDLUN, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
               END IF
C                                       Close HI file
 190        CALL HICLOS (IHDLUN, TRUE, IBUFF2, IER)
            WRITE (MSGTXT,1900) FTYPE(J,K)
            IF ((IER.NE.0) .OR. (IERR.NE.0)) WRITE (MSGTXT,1901)
     *         FTYPE(J,K), IERR, IER
            CALL MSGWRT (2)
C                                       copy tables
            CALL ALLTAB (NONOT, NOTTYP, 44, 45, FCVOL(1), FCVOL(4+J),
     *         FCCNO(1), FCCNO(4+J), CATBLK, IBUFF1, IBUFF2, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1905) FTYPE(J,K), IERR
               CALL MSGWRT (6)
               END IF
C                                       Close map file
            CALL MAPCLS ('INIT', FCVOL(4+J), FCCNO(4+J), OLUN(J),
     *         OIND(J), CATBLK, TRUE, IBUFF2, IERR)
            NCFILE = NCFILE - 1
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1910) FTYPE(J,K), IERR
               CALL MSGWRT (6)
               END IF
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OUTPUT ',A,' FILE COMPLETELY BLANKED',
     *   ' -- saving it anyway')
 1001 FORMAT ('Output ',A,' FILE constant at',1PE13.5,
     *   ' -- saving it anyway')
 1010 FORMAT ('CMPLXH: could not create HISTORY FOR ',A,' FILE.  IER=',
     *   I5)
 1020 FORMAT (31X,'/ History of input map', I2)
 1030 FORMAT ('WARNING COULD NOT OPEN/COPY INPUT HI FILE=',I2,
     *   '.  IER=',I7)
 1031 FORMAT (31X,'/ NO HISTORY TO BE FOUND')
 1032 FORMAT (A6,'/ No history copied from file',I2)
 1050 FORMAT (31X,'/ End of old histories')
 1055 FORMAT (A6,'RELEASE=''',A7,' ''')
 1090 FORMAT (A6,'USERID=',I5)
 1092 FORMAT (A6,'CTYPE=''',A,'''',2X,' /',A)
 1094 FORMAT (A6,'BLC=',7I5,' / Bottom left corner')
 1096 FORMAT (A6,'TRC=',7I5,' / Top right corner')
 1098 FORMAT (A6,'/ Single plane of Map 2 applied to all planes of',
     *   ' Map 1')
 1100 FORMAT (A6,4('A(',I1,')=',F9.4,2X))
 1101 FORMAT (A6,3('A(',I1,')=',1PE12.4,2X))
 1110 FORMAT (A6,'/ Undefined pixels magic-value blanked')
 1112 FORMAT (A6,'CBMULT(',I1,')=',F9.5,'  / scaled to match image 1',
     *   ' units')
 1900 FORMAT ('History file created and written for ',A,' file')
 1901 FORMAT ('HISTORY FILE FOR ',A,' INCOMPLETE.  IERRS =',2I7)
 1905 FORMAT ('WARNING CMPLXH COULD NOT COPY TABLES TO OUTPUT ',A,
     *   ' FILE.  IER=',I7)
 1910 FORMAT ('WARNING CMPLXH COULD NOT CLOSE OUTPUT ',A,
     *   ' FILE.  IER=',I7)
      END

      SUBROUTINE SUMARY (NUMCMP, CLNVOL, VER, CNO, CATBLK, LUNCLN,
     *   NCLEAN, X, Y, Z, FLX, ICOUNT, BUFFER, IERR)
C-----------------------------------------------------------------------
C! Accumulates and lists CLEAN components
C# EXT-appl Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2020
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SUMARY is a diagonostic routine which reads a component file,
C   collects the flux density cleaned from the first NUMCMP locations
C   and then may list the results. Component locations are given
C   in degrees; flux densities in Janskys.
C   Input:
C      NUMCMP   I           Number of clean locations to be sumarized.
C      CLNVOL   I           Volumn number of the CLEAN components file.
C      VER      I           CC file version number.
C      CNO      I           Catalog slot number of clean map.
C      CATBLK   I(256)      Catalog header block of clean map.
C      LUNCLN   I           Logical unit number to use.
C      NCLEAN   I           Number of CLEAN components on the file.
C                           If 0 searches entire file.
C      BUFFER   I(768)      Buffer for reading CLEAN components file.
C   Output:
C      NCLEAN   I           No. CLEAN comps searched.
C      X        R(NUMCMP)   Array of the RA values.
C      Y        R(NUMCMP)   Array of the Dec values.
C      Z        R(NUMCMP)   Array of the 3D values.
C      FLX      R(NUMCMP)   Array of the cell summed flux densities
C      ICOUNT   I           Number of cells actually populated.
C      IERR     I           Error code: 0 => ok, else TABINI or TABIO
C   WARNING: THIS IS A NON-STANDARD ROUTINEl IT USES A BRUTE FORCE SORT
C-----------------------------------------------------------------------
      INTEGER   NUMCMP, CLNVOL, VER, CNO, CATBLK(256), LUNCLN, NCLEAN,
     *   ICOUNT, BUFFER(768), IERR
      REAL      X(*), Y(*), Z(*), FLX(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IRNO, K4, I4, IDX, CCKOLS(MAXCCC), CCNUMV(MAXCCC),
     *   CCRNO, CCNCOL, CCTYPE, I0
      REAL      XX, YY, ZZ, FLUX, PARMS(3)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Skip if NUMCMP = 0
      IERR = 0
      ICOUNT = 0
      IF (NUMCMP.LE.0) GO TO 999
C                                       Open CLEAN component file.
      CALL CCMINI ('READ', BUFFER, CLNVOL, CNO, VER, CATBLK, LUNCLN,
     *   CCRNO, CCKOLS, CCNUMV, CCNCOL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
      IRNO = BUFFER(5)
      IF (NCLEAN.LE.0) NCLEAN = IRNO
      IF (NCLEAN.GT.IRNO) NCLEAN = IRNO
C                                      Read first record.
      CCRNO = 1
 15   CALL TABCCM ('READ', BUFFER, CCRNO, CCKOLS, CCNUMV, CCNCOL, XX,
     *   YY, ZZ, FLUX, CCTYPE, PARMS, IERR)
      IF (IERR.GT.0) GO TO 900
C                                      Check if point.
      IF ((CCTYPE.NE.0) .OR. (IERR.LT.0)) GO TO 15
      ICOUNT = 1
      X(1) = XX
      Y(1) = YY
      Z(1) = ZZ
      FLX(1) = FLUX
      IF (NCLEAN.LE.CCRNO-1) GO TO 900
C                                       loop over all clean comps
C                                       no matter what NUMCMP !!
      I0 = CCRNO
      DO 200 K4 = I0,NCLEAN
C                                       Read
         CALL TABCCM ('READ', BUFFER, CCRNO, CCKOLS, CCNUMV, CCNCOL, XX,
     *      YY, ZZ, FLUX, CCTYPE, PARMS, IERR)
         IF (IERR.GT.0) GO TO 900
C                                       Make sure point.
         IF ((CCTYPE.EQ.0) .AND. (IERR.EQ.0)) THEN
C                                       does current point match
C                                       position of previous point
            DO 150 I4 = 1,ICOUNT
               IDX = I4
               IF ((X(I4).EQ.XX) .AND. (Y(I4).EQ.YY) .AND.
     *            (Z(I4).EQ.ZZ)) THEN
                  FLX(I4) = FLX(I4) + FLUX
                  GO TO 200
                  END IF
 150           CONTINUE
C                                       No match found
            IF (ICOUNT.LT.NUMCMP) THEN
               ICOUNT = ICOUNT + 1
               X(ICOUNT) = XX
               Y(ICOUNT) = YY
               Z(ICOUNT) = ZZ
               FLX(ICOUNT) = FLUX
               END IF
            END IF
 200     CONTINUE
C                                       Close CLEAN component file.
 900  CALL TABCCM ('CLOS', BUFFER, CCRNO, CCKOLS, CCNUMV, CCNCOL, XX,
     *   YY, ZZ, FLUX, CCTYPE, PARMS, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SUMARY: ERROR',I3,' OPENING FILE ')
      END

      SUBROUTINE QCFFT (C, N, F)
C-----------------------------------------------------------------------
C! Convex Pseudo AP routine: Full complex FFT.
C# AP-FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Convex version
C   Full complex 1-D FFT.
C   Inputs:
C      C  I  Base address (0-rel) of complex array to transform
C      N  I  Number of points in array (must be power of two).
C      F  I  Transform direction; 1 -> Forward
C                                  -1 -> Backward
C-----------------------------------------------------------------------
      INTEGER   C, N, F, IF, GAMMA
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF = F
C                                       need the following for CONVEX
C                                       FFTs
C      GAMMA = ALOG (FLOAT(N)) / 0.693147 + 0.1
      CALL QXFOUR (APCORE(C+1), N, IF, WKVEC9)
C
 999  RETURN
      END

      SUBROUTINE MSKIP (LUN, FIND, BUFF, BIND, IFIN, IERR)
C-----------------------------------------------------------------------
C! reads noncontiguous, but evenly spaced rows in a map (see also MINSK)
C# AP-fft Map-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   MSKIP reads rows in a map file which are evenly spaced.  The reads
C   are double, single buffered or partial buffers if the row size
C   1) is .Le. BUFSZ/2, 2) between BUFSZ/2 and BUFSZ or 3).GT.BUFSZ.
C   For case 3) multiple calls (NBUF from MINS3) are required to read
C   each row.  Each call returns LROW*BP/NBUF bytes and I/O is
C   single buffered.  IFIN = 0 indicates a row is completed.  See
C   MINS3 for more details.
C   Input:
C      LUN    I      Logical unit number.
C      FIND   I      pointer for FTAB
C      BUFF   R(*)   Buffer
C   Output:
C      BIND   I      Pointer for BUFF
C      IFIN   I      0 if row complete, 1 otherwise.
C      IERR   I      error code: 0 = OK
C                                1 = file not open
C                                2 = attempt to read past end of map.
C                               10+= I/O error = 10 +  ZWAIT error.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, BIND, IFIN, IERR
      REAL      BUFF(*)
C
      INTEGER   IER, NSEC, BYTOFF, IBUF, JBUF, KBUF, IP, NBYTES
      DOUBLE PRECISION DPTEMP
      LOGICAL   DOUBUF
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Check for file open.
      IERR = 1
      IF (FTAB(FIND).NE.LUN) GO TO 999
C                                       Check if next read past end
C                                       of map
      IERR = 2
      IF (FTAB(FIND+6).GT.FTAB(FIND+13)) GO TO 999
      IERR = 0
      DOUBUF = FTAB(FIND+11).GT.0
C                                       Set buffer pointers.
      JBUF = ABS (FTAB(FIND+11))
      KBUF = 1
      IF (DOUBUF) KBUF = 3 - JBUF
      IBUF = (KBUF - 1) * FTAB(FIND+12)
      IP = (IBUF / 2) * 2 + 1
C                                       If double buffering,
C                                       skip last read.
      IF ((DOUBUF) .AND. (FTAB(FIND+6).GE.FTAB(FIND+13))) GO TO 40
C                                       Compute position in file.
         DPTEMP = (FTAB(FIND+6) - 1) * FTAB(FIND+4) * FTAB(FIND+5)
         DPTEMP = ((DPTEMP + (FTAB(FIND+9) - 1) * FTAB(FIND+10)) /
     *      NBPS) + FTAB(FIND+2)
         NSEC = DPTEMP
C                                       Compute byte offset.
         BYTOFF = (DPTEMP-NSEC) * NBPS + 0.3D0
C                                       Compute # bytes.
         NBYTES = BYTOFF + FTAB(FIND+10)
C                                       Do I/O
         CALL ZMIO ('READ', LUN, FIND, NSEC, NBYTES, BUFF(IP),
     *      KBUF, IER)
         IERR = IERR + 10 * IER
         IF (IER.NE.0) GO TO 999
C                                       Update counters.
 40   FTAB(FIND+9) = FTAB(FIND+9) + 1
C                                       See if finished with record.
      IFIN = 1
      IF (FTAB(FIND+9) .LE. FTAB(FIND+8)) GO TO 50
         FTAB(FIND+9) = 1
         FTAB(FIND+6) = FTAB(FIND+6) + FTAB(FIND+7)
         IFIN = 0
C                                       Set output buffer pointer.
 50   IF (DOUBUF) GO TO 60
         BIND = BYTOFF / 2 + 1
         GO TO 70
C                                       Double buffer.
 60   FTAB(FIND+11) = KBUF
      BIND = FTAB(FIND+14) / 2 + 1 + (JBUF-1) * FTAB(FIND+12)
      FTAB(FIND+14) = BYTOFF
C                                       Wait for I/O
 70   CALL ZWAIT (LUN, FIND, JBUF, IER)
      IERR = IERR + 10 * IER
C
 999  RETURN
      END

      SUBROUTINE ISTAB (ETYPE, IVOL, ISLOT, IVER, LUN, BUFFER, TABLE,
     *   EXIST, FITASC, IERR)
C-----------------------------------------------------------------------
C! finds if an extension file exists and whether it is a standard table
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Given an extension type, volume, version, determine if the extension
C   file exists, and if so, is it a standard table.
C   Inputs:
C      ETYPE    C*2   Extension type like 'CC'
C      IVOL     I     Disk Volume.
C      ISLOT    I     Map catalog slot number.
C      LUN      I     AIPS LUN to use for opening & reading a block.
C   Output:
C      TABLE    L     True if this extension type is a table or this
C                     version does not exist.
C      EXIST    L     True if the extension file exists, else false.
C      FITASC   L     True if the file can be written as a FITS ASCII
C                     table.
C      IERR     I     Error code, 0=>OK else failed
C-----------------------------------------------------------------------
      CHARACTER ETYPE*2
      INTEGER   IVOL, ISLOT, IVER, LUN, BUFFER(256), IERR
      LOGICAL   TABLE, EXIST, FITASC
C
      CHARACTER PNAME*48, ATLAB*12, PATLAB*12
      LOGICAL   NOEXCL, NOWAIT, NOMAP
      INTEGER   FIND, IER, ISIZE
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (NOMAP, NOEXCL, NOWAIT)
      DATA NOMAP /.FALSE./
      DATA ATLAB /'*AIPS TABLE*'/
C-----------------------------------------------------------------------
C                                       Set up some fall thru values.
      TABLE = .TRUE.
      EXIST = .FALSE.
      FITASC = .FALSE.
C                                       Try to open file.
C                                       suppress file missing error
      CALL ZPHFIL (ETYPE, IVOL, ISLOT, IVER, PNAME, IERR)
      CALL ZEXIST (IVOL, PNAME, ISIZE, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.EQ.1) IERR = 0
         GO TO 999
         END IF
      CALL ZOPEN (LUN, FIND, IVOL, PNAME, NOMAP, NOEXCL, NOWAIT, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.EQ.2) IERR = 0
         GO TO 999
         END IF
      EXIST = .TRUE.
C                                       Read first block.
      CALL ZFIO ('READ', LUN, FIND, 1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Check that really a table file
      CALL H2CHR (12, 1, BUFFER(54), PATLAB)
      TABLE = PATLAB.EQ.ATLAB
C                                       Check if can be FITS ASCII
      FITASC = BUFFER(60).NE.1
C
 980  CALL ZCLOSE (LUN, FIND, IER)
      IF (IERR.EQ.0) IERR = IER
C
 999  RETURN
      END

LOCAL INCLUDE 'FXVLA.INC'
C                                       Local include for FXVLA
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      REAL      XSIN, XDISIN, XSOUT, XDISO, APARM(10), TINT
      REAL BUFF1(UVBFSS), BUFF2(UVBFSS)
      INTEGER JBUFF(1024)
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS, JBUFSZ,
     *   ILOCWT, CATOLD(256), INCSI, INCFI, INCIFI, INCSO,
     *   INCFO, INCIFO, LRECI, LRECO, NRPRMI, NRPRMO, ICNOIN,
     *   ILUN1, NSUBA
      LOGICAL   ISCOMP
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, LOPCOD*4,
     *   HISCRD(10)*64
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XCLAOU,
     *   XSOUT, XDISO, APARM, TINT, SEQIN, SEQOUT, DISKIN, DISKO,
     *   NUMHIS, ILOCWT, CATOLD, INCSI, INCFI, INCIFI, INCSO, INCFO,
     *   INCIFO, LRECI, LRECO, NRPRMI, NRPRMO, ICNOIN, ILUN1, NSUBA,
     *   ISCOMP
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, HISCRD, LOPCOD
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFF, JBUFSZ
C                                       FQ table data
      INTEGER MXFQID
      PARAMETER (MXFQID = 12)
      DOUBLE PRECISION DFOFF(MAXIF,MXFQID)
      REAL FINC(MAXIF,MXFQID)
      INTEGER IFQID(MXFQID), NFQID
      COMMON /FQTAB/ DFOFF, FINC, IFQID, NFQID
C                                       End local include for FXVLA
LOCAL END
      PROGRAM FXVLA
C-----------------------------------------------------------------------
C! Allows user to provide subroutine to operate on UV data base
C# Utility UV UV-util VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2000-2001, 2004, 2007-2008, 2012,
C;  Copyright (C) 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FXVLA allows a user to provide a subroutine which performs an
C   operation on a UV data base, writing an output UV data base.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
C
      INTEGER ISUBA
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FXVLA.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'FXVLA '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL FXVLIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      DO 100 ISUBA = 1, NSUBA
         CALL SENDUV (ISUBA, IRET)
         IF (IRET.NE.0) GO TO 990
100      CONTINUE
C
         CALL FXVHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE FXVLIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   FXVLIN gets input parameters for FXVLA and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER  STAT*4, BLANK*6, PTYPE*2
      INTEGER   OLDCNO, IROUND, NPARM, IERR, INCX
      LOGICAL   T
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FXVLA.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK  /'      '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
      ILUN1 = 28
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 24
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Integration time in data
      TINT = APARM(1)
C                                       Only option implemented at
C                                       present corrects leap second
C                                       clock error between 30 Dec 95
C                                       and 5 Jan 96.
      LOPCOD = '96-1'
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      ICNOIN = OLDCNO
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((CCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
C                                       Read FQ table into common
      CALL FQREAD (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Find number of subarrays
      CALL FNDEXT ('AN', CATOLD, NSUBA)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FXVLIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('FXVLIN: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE SENDUV (ISUBA, IRET)
C-----------------------------------------------------------------------
C   SENDUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Inputs:
C      ISUBA   I  Subarray number.
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   ISUBA, IRET
C
      CHARACTER OFILE*48, IFILE*48
      INTEGER   INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, ILENBU,
     *   KBIND, NIOUT, NIOLIM, IBIND, I, IA1, IA2, INCX, BO, VO,
     *   NUMVIS, XCOUNT, NCORI, NCORO, NCOPY, IDUM
      LOGICAL   T, F
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FXVLA.INC'
      REAL      DUM, BASEN, CBUFF(UVBFSS), RESULT(UVBFSS)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI, LUNO /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Get antenna information for
C                                       this subarray.
      CALL GETANT (DISKIN, ICNOIN, ISUBA, CATOLD, BUFF1, IRET)
      IF (IRET.NE.0) THEN
         IRET = 10
         WRITE (MSGTXT,1005) ISUBA
         GO TO 990
         END IF
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
      IF (ISCOMP) INCX = 3
C                                       Number of visibilities in input
C                                       and output files.
      NCORI = (LRECI - NRPRMI) / CATOLD(KINAX)
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Out of data?
         IF (INIO.LE.0) GO TO 200
C                                       Loop over buffer
         DO 190 I = 1,INIO
            IF (ILOCB.GE.0) THEN
               BASEN = BUFF1(IPTRI+ILOCB)
               IA1 = BASEN / 256. + 0.1
               IA2 = BASEN - IA1*256. + 0.1
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               END IF
            NUMVIS = NUMVIS + 1
C                                      Call user routine.
            IF (ISCOMP) THEN
C                                       Compressed data.
               CALL ZUVXPN (NCORI, BUFF1(IPTRI+NRPRMI),
     *            BUFF1(IPTRI+ILOCWT), CBUFF)
               CALL FXVMOD (NUMVIS, BUFF1(IPTRI+ILOCU),
     *            BUFF1(IPTRI+ILOCV), BUFF1(IPTRI+ILOCW),
     *            BUFF1(IPTRI+ILOCT), IA1, IA2, ISUBA, CBUFF,
     *            BUFF1(IPTRI), INCX, RESULT, IRET)
            ELSE
C                                       Un compressed data
            CALL FXVMOD (NUMVIS, BUFF1(IPTRI+ILOCU),
     *         BUFF1(IPTRI+ILOCV), BUFF1(IPTRI+ILOCW),
     *         BUFF1(IPTRI+ILOCT), IA1, IA2, ISUBA,
     *         BUFF1(IPTRI+NRPRMI), BUFF1(IPTRI), INCX, RESULT, IRET)
            END IF
C                                       Branch on his return
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
C                                       Copy to output.
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1.0D0
               CALL RCOPY (NRPRMO, BUFF1(IPTRI), BUFF2(IPTRO))
C                                       Compressed
               IF (ISCOMP) THEN
                  CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *               BUFF2(IPTRO+NRPRMO))
               ELSE
                  CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
                  END IF
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               END IF
C                                       OK, but no output please
            IPTRI = IPTRI + LRECI
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
C                                       Read next buffer.
         GO TO 100
C                                       Final call to FXVMOD.
 200     NUMVIS = -1
         CALL FXVMOD (NUMVIS, DUM, DUM, DUM, DUM, IA1, IA2, IDUM, BUFF1,
     *      BUFF1, INCX, RESULT, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
            END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SENDUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1005 FORMAT ('SENDUV: ERROR READING AN TABLE', I5)
 1010 FORMAT ('SENDUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('SENDUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('SENDUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('SENDUV: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('SENDUV: FXVMOD ERROR',I3)
 1150 FORMAT ('SENDUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE FXVHIS
C-----------------------------------------------------------------------
C   FXVHIS copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP*2, HILINE*72, LABEL*8
      INTEGER   LUN1, LUN2, IERR, I, NONOT
      LOGICAL   T
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FXVLA.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NONOT, NOTTYP /0, '  '/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any other history.
      IF (NUMHIS.LE.0) GO TO 200
         WRITE (LABEL,1010) TSKNAM
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
C                                       Close HI file
 200   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO,
     *   FCNO(2), FCNO(1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1200)
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST',
     *   BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FXVHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,' /')
 1200 FORMAT ('FXVHIS: ERROR COPYING TABLES')
      END
      SUBROUTINE FXVMOD (NUMVIS, U, V, W, T, IA1, IA2, ISUB, VIS,
     *   RPARM, INCX, RESULT, IRET)
C-----------------------------------------------------------------------
C   Correct each VLA record individually.
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      U       R    U in wavelengths
C      V       R    V in wavelengths
C      W       R    W in wavelengths
C      T       R    Time in days since 0 IAT on the first day for
C                   which there is data, the julian day corresponding
C                   to this day can be obtained in D   form by:
C                   CALL JULDAY (CATH(KHDOB),XDAY) where XDAY will
C                   be the Julian day number.
C      IA1     I    First antenna number
C      IA2     I    Second antenna number
C      ISUB    I    Subarray to process
C      RPARM   R(*) Random parameter array which includes U,V,W etc
C                   but also any other random parameters.
C      VIS     R(INCX,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                   NOTE: INCX may be any value .GE. 2
C   Inputs from COMMON:
C      RA         D       Right ascension (1950) of phase center. (deg)
C      DEC        D       Declination (1950) of phase center. (deg)
C      FREQ       D       Frequency of observation (Hz)
C      NRPARM     I       # random parameters.
C      NCOR       I       # correlators
C      CATBLK     I(256)  Catalog header record. See Going Aips for
C                         details.
C      LRECI      I    Input file record length
C      NRPRMI     I    Input number of random parameters.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
C      LRECO      I    Output file record length
C      NRPRMO     I    Output number of random parameters.
C      INCSO      I    Output Stokes' increment in vis.
C      INCFO      I    Output frequency increment in vis.
C      INCIFO     I    Output IF increment in vis.
C   Output:
C      U          R    U in wavelengths
C      V          R    V in wavelengths
C      W          R    W in wavelengths
C      T          R    Time in same units as input.
C      RPARM      R    Modified random parameter array.
C      RESULT  R(INCX,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C
C   Output in COMMON:
C      NUMHIS    I         # history entries (max. 10)
C      HISCRD    C(NUMHIS) History records
C      CATBLK    I         Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IA1, IA2, ISUB, INCX, IRET
      REAL      U, V, W, T, VIS(INCX,*), RPARM(*), RESULT(INCX,*)
C
      LOGICAL   WGR
      DOUBLE PRECISION DFACT, DXC, DYC, DZC, DJD, DHAERR, DSHFT,
     *   DTOTFQ, DXX, DJJD, DMJD, DLONG, DLX, DLY, DLZ, DU, DV,
     *   DW, DTUVW, DTUT1, DCOSD, DSIND, DCOSHA, DSINHA, DRAX,
     *   DECX, DRHO, DGEO, DLST, DELDAT, DCROTP, DSROTP, DFUV,
     *   DGASTM, DTC, DEPS, DELPSI, DELEPS, DSPSI, DSEPS, DEQEQ,
     *   DROTP, DSRA, DSDEC, DRAY, DECY, DHA, OBSPOS(3)
      COMPLEX ZVIS, ZROT
      REAL TERR, UTCIAT, TU1UTC, POLAR(2)
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXO, INDEXI, ISOU,
     *   IBASE, IARRAY, J, IFQD, IFQENT, WDIR
      SAVE DJD, DMJD, DLONG, DGASTM, DFUV
C
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FXVLA.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA DELDAT / 0.05D0/
      DATA WDIR, WGR /1, .TRUE./
      DATA POLAR /2 * 0.0/
C-----------------------------------------------------------------------
      IRET = 0
C                                       Initialize earth rotation/time
C                                       parameters for this subarray
      IF (NUMVIS.EQ.1) THEN
C                                       Check for missing/inconsistent
C                                       AN table parameters:
         IF (ANAME.NE.'VLA') THEN
            IRET = 1
            WRITE (MSGTXT,1010)
            GO TO 990
            END IF
C                                       MJD of reference date
         CALL JULDAY (RDATE, DJD)
         DMJD = DJD - 2400000.5D0
C                                       Array center longitude
         DLONG = ATAN2 (-ARRAYC(2), ARRAYC(1))
C                                       Equation of equinoxes
         DTC = (DJD - 2433282.423D0) / 36524.21988D0
         DEPS = -46.850D0 * DTC - 0.0034D0 * DTC * DTC +
     *      0.0018D0 * DTC * DTC * DTC
         DEPS = (84404.84D0 + DEPS) / 3600.0D0 * DG2RAD
         CALL NUT4 (DJD, DELPSI, DELEPS, DSPSI, DSEPS)
         DEQEQ = DELPSI * COS (DEPS)
C                                       Position for diurnal
C                                       aberration
         DRHO = SQRT (ARRAYC(1)**2 + ARRAYC(2)** 2 + ARRAYC(3)**2)
         OBSPOS(3) = DRHO
         DRHO = DRHO / 6378140.0D0

         DGEO = SQRT (ARRAYC(1)**2 + ARRAYC(2)**2)
         DGEO = ATAN2 (ARRAYC(3), DGEO)
         OBSPOS(1) = DGEO
C                                       East longtitude
         OBSPOS(2) = - DLONG
C                                       GAST at UT midnight
         DGASTM = GSTIAT + DEQEQ
C                                       (u,v,w) scaling factor
         DFUV = SAFREQ / VELITE
         END IF
C
      IF (NUMVIS.GT.0) THEN
C                                       Get data pointers
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
C                                       Case option of:
C                                       1: '96-1' - leap sec.
C                                          error Dec95/Jan96.
         IF (LOPCOD.NE.'96-1') GO TO 200
C                                       Is source no. current ?
            ISOU = 1
            IF (ILOCSU.GE.0) ISOU = RPARM(1+ILOCSU)
            IF ((NUMVIS.EQ.1).OR.(ISOU.NE.IDSOUR)) THEN
C                                       Read source data
               CALL GETSOU (ISOU, DISKIN, ICNOIN, CATOLD, ILUN1, IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
C                                       Get subarray number
            IF (ILOCB.GE.0) THEN
               IBASE = RPARM(1+ILOCB)
               IARRAY = 100.0 * (RPARM(1+ILOCB) - IBASE) + 1.5
            ELSE
               IARRAY = RPARM(1+ILOCSA)
               END IF
C                                       Process only data for the
C                                       selected subarray
            IF (IARRAY.NE.ISUB) THEN
               CALL RCOPY (NIF*NF*NS*INCX, VIS, RESULT)
               GO TO 999
               END IF
C                                       Get freqid.
            IFQD = 1
            IF (ILOCFQ.GE.0) IFQD = RPARM(1+ILOCFQ)
C                                       Search FQ table
            IFQENT = 0
            DO 80 J = 1, NFQID
               IF (IFQID(J).EQ.IFQD) IFQENT = J
80             CONTINUE
            IF (IFQENT.EQ.0) THEN
               IRET = 1
               WRITE (MSGTXT,1080) IFQD
               GO TO 990
               END IF
C
            CALL CLK96 (DJD, T, TERR, UTCIAT, TU1UTC)
C                                       Convert IAT to UT1 (include
C                                       known VLA clock error)
            DTUVW = T - (TINT / 2.0 - TERR) / 86400.0D0
            DTUT1 = DTUVW + (TU1UTC + UTCIAT) / 86400.0D0
C                                       Calculate LST
            DLST = DGASTM + DTUVW * ROTIAT
C                                       Precess to date to obtain
C                                       apparent position that would
C                                       have been obtained without
C                                       clock error.
            DJJD = DJD + DTUT1
C                                       JPRECS works for both J2000 and
C                                       B1950 starting December 2004
            CALL JPRECS (DJJD, EPOCH, DELDAT, WDIR, WGR, OBSPOS, POLAR,
     *         RAEPO, DECEPO, DRAX, DECX)
C                                       Precess with clock error
C                                       to obtain apparent position
C                                       used by the VLA.
            DJJD = DJJD - TERR / 86400.0D0
C
            CALL JPRECS (DJJD, EPOCH, DELDAT, WDIR, WGR, OBSPOS, POLAR,
     *         RAEPO, DECEPO, DRAY, DECY)
C                                       Convert clock error to
C                                       a position offset.
            DHAERR = -TERR / 86400.0 * ROTIAT + (DRAY - DRAX)
            DXC = COS (DECY) * SIN (DHAERR)
            DYC = -COS (DECY) * SIN (DECX) * COS (DHAERR) +
     *         COS (DECX) * SIN (DECY)
            DZC = TWOPI * (SQRT (1.0D0 - DXC*DXC - DYC*DYC) - 1.0D0)
            DXC = TWOPI * DXC
            DYC = TWOPI * DYC
C                                       Shift factor
            DSHFT = U * DXC + V * DYC + W * DZC
C
            DO 140 JIF = 1,NIF
               DO 130 JF = 1,NF
                  DO 120 JS = 1,NS
                     INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *                  (JS-1) * INCSI + 1
                     INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *                  (JS-1) * INCSO + 1
C                                       Calculate true freq. scaling
                     DTOTFQ = FREQ + (JF - 1) * FINC(JIF,IFQENT) +
     *                  DFOFF(JIF,IFQENT)
                     DFACT = DTOTFQ / SAFREQ
C                                       Rotate phase for position
C                                       offset
                     DXX = DFACT * DSHFT
                     ZROT = CMPLX (COS (DXX), -SIN (DXX))
                     ZVIS = CMPLX (VIS(1,INDEXI), VIS(2,INDEXI))
                     ZVIS = ZVIS * ZROT
                     RESULT(1,INDEXO) = REAL (ZVIS)
                     RESULT(2,INDEXO) = AIMAG (ZVIS)
                     RESULT(3,INDEXO) = VIS(3,INDEXI)
 120                 CONTINUE
 130              CONTINUE
 140           CONTINUE
C                                       Recompute (u,v,w)
C                                       Compute hour angle
            DHA = DGASTM - DLONG + DTUT1 * ROTIAT - DRAX
            DCOSD = COS (DECX)
            DSIND = SIN (DECX)
            DCOSHA = COS (DHA)
            DSINHA = SIN (DHA)
            DLX = (STNX(IA1) - STNX(IA2)) * DFUV
            DLY = (STNY(IA1) - STNY(IA2)) * DFUV
            DLZ = (STNZ(IA1) - STNZ(IA2)) * DFUV
            DU = DLX * DSINHA + DLY * DCOSHA
            DV = DSIND * (-DLX * DCOSHA + DLY * DSINHA) + DLZ * DCOSD
            DW = DCOSD * (DLX * DCOSHA - DLY * DSINHA) + DLZ * DSIND
C                                       Coefficients for rotation
C                                       of (u,v,w) to epoch. Precess
C                                       two nearby positions.
C            DLST = 0.0D0
C
            CALL JPRECS (DJD, EPOCH, DELDAT, WDIR, WGR, OBSPOS, POLAR,
     *         RAEPO, DECEPO, DRAX, DECX)
C
            DSRA = RAEPO
            DSDEC = DECEPO + (10.0 / 3600.0) * DG2RAD
            CALL JPRECS (DJD, EPOCH, DELDAT, WDIR, WGR, OBSPOS, POLAR,
     *         DSRA, DSDEC, DRAY, DECY)
            DROTP = -ATAN2 ((DRAY-DRAX)*COS(DECEPO), DECY-DECX)
            DCROTP = COS (DROTP)
            DSROTP = SIN (DROTP)
C                                       Rotate to orientation of epoch
            U = DU * DCROTP + DV * DSROTP
            V = DV * DCROTP - DU * DSROTP
            W = DW
            GO TO 700
C                                       2: Other
200      CONTINUE
C                                       Endcase
700      CONTINUE
C
         END IF
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C
999   RETURN
C----------------------------------------------------------------------
1010  FORMAT ('THESE DATA ARE NOT FROM THE VLA; CHECK AN TABLE')
1080  FORMAT ('MISSING FQID ',I3,' IN FQ TABLE')
      END
      SUBROUTINE FQREAD (IRET)
C----------------------------------------------------------------------
C   Subroutine to read parts of the FQ table into memory
C   Outputs:
C      IRET      I      Return code; (0 => ok)
C----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FXVLA.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      REAL      TOTBW(MAXIF)
      INTEGER   FQKOLS(MAXFQC), FQNUMV(MAXFQC)
      INTEGER   ISBAND(MAXIF), NIF, I, J, IVER, IFQRNO, IERR
      CHARACTER BNDCOD(MAXIF)*8
C---------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C                                       Find no. of FQ_ID's
      IVER = 1
      CALL FQINI ('READ', JBUFF, DISKIN, ICNOIN, IVER, CATOLD, ILUN1,
     *   I, FQKOLS, FQNUMV, NIF, IRET)
      IF (IRET.NE.0) GO TO 999
      NFQID = JBUFF(5)
C                                       Exceeds maximum ?
      IF (NFQID.GT.MXFQID) THEN
         IRET = 10
         WRITE (MSGTXT,1020)
         GO TO 990
         END IF
C                                       Read FQ table into memory
      DO 100 I = 1, NFQID
         IFQRNO = I
         CALL TABFQ ('READ', JBUFF, IFQRNO, FQKOLS, FQNUMV, NIF,
     *      IFQID(I), DFOFF(1,I), FINC(1,I), TOTBW, ISBAND, BNDCOD,
     *      IERR)
         IF (IERR.NE.0) THEN
            IRET = 1
            WRITE (MSGTXT,1100) IERR
            GO TO 990
            END IF
C                                       Correct for sideband
         DO 80 J = 1, NIF
            IF (ISBAND(J).LT.0) FINC(J,I) = -ABS (FINC(J,I))
80          CONTINUE
100      CONTINUE
C                                       Close FQ table
      CALL TABIO ('CLOS', 0, I, JBUFF, JBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Exit
999   RETURN
C----------------------------------------------------------------------
1020  FORMAT ('FQREAD: PARAMETER MXFQID TOO SMALL; CONTACT AIPS ADMIN')
1100  FORMAT ('FQREAD: ERR',I3,' READING FQ/CH TABLE')
      END
      SUBROUTINE CLK96 (DJD, T, TERR, UTCIAT, TU1UTC)
C----------------------------------------------------------------------
C   Compute the UTC clock error for leap sec. err. 30 Dec 95-5 Jan 96
C   Input:
C      DJD      D      Modified Julian date (ref. date)
C      T        R      Time wrt DJD
C   Output:
C      TERR     R      Difference to be added to VLA claimed UTC
C                      to yield true UTC.
C      UTCIAT   R      UTC - IAT (seconds)
C      TU1UTC   R      UT1 - UTC (seconds)
C----------------------------------------------------------------------
      DOUBLE PRECISION DJD
      REAL T, TERR, UTCIAT, TU1UTC
C
      DOUBLE PRECISION DERROR(7), DTFRAC
      REAL TABIAT(7), TABUT1(7)
      INTEGER I, IT
C                                       Values start at MJD 50081
C                                       (= Dec 30, 1995)
      DATA DERROR /-0.1438, -0.2943, -0.4442, 0.4057, 0.2555, 0.1054,
     *   -0.0448/
      DATA TABUT1 /-0.4407, -0.4431, 0.5548, 0.5527, 0.5507, 0.5487,
     *    0.5468/
      DATA TABIAT /-29.0, -29.0, -30.0, -30.0, -30.0, -30.0, -30.0/
C----------------------------------------------------------------------
C                                       Intialization
      TERR = 0.0
      UTCIAT = 0.0
      TU1UTC = 0.0
C
      IT = T
      DTFRAC = T - IT
      I = (DJD - 2450080.5D0) + IT
      IF ((I.GE.1).AND.(I.LE.8)) THEN
C                                       UTC - IAT
         UTCIAT = TABIAT(I)
C                                       UT1 - UTC
         TU1UTC = TABUT1(I)
C                                       Error in VLA UTC
         DTFRAC = DTFRAC + UTCIAT / 86400.0
         TERR = DERROR(I) - 0.006265 * DTFRAC * 24.0
         END IF
C
      RETURN
      END

      SUBROUTINE BLTGLE (XT, YT, X1, Y1, X2, Y2, ANG)
C-----------------------------------------------------------------------
C! returns angle from A through a test position to B
C# Map-util Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   BLTGLE returns the angle in degrees from (X1, Y1) to (XT, YT) to
C   (X2, Y2).
C   Inputs:  XT    R      Test position (X)
C            YT    R      Test position (Y)
C            X1    I      Mark position 1 (X)
C            Y1    I      Mark position 1 (Y)
C            X2    I      Mark position 2 (X)
C            Y2    I      Mark position 2 (Y)
C   Output:  ANG   I      Angle between 1 -> T -> 2
C-----------------------------------------------------------------------
      INTEGER   X1, Y1, X2, Y2
      REAL      XT, YT, ANG
C
      REAL      XX1, XX2, YY1, YY2, CROSS, DOT, R2D
      DATA R2D /57.29578/
C-----------------------------------------------------------------------
C                                       vector coordinates
      XX1 = X1 - XT
      YY1 = Y1 - YT
      XX2 = X2 - XT
      YY2 = Y2 - YT
C                                       CROSS prop SIN
C                                       DOT prop COS
      CROSS = XX1 * YY2  -  XX2 * YY1
      DOT   = XX1 * XX2  +  YY1 * YY2
      ANG = 0.0
      IF ((CROSS.NE.0.) .OR. (DOT.NE.0.)) ANG = R2D *
     *   ATAN2 (CROSS, DOT)
C
 999  RETURN
      END

      SUBROUTINE STARPL (FACTOR, IVOL, CNO, VERS, BLC, TRC, BLUN, BIND,
     *   BCATB, BBLC, BLOCN, PLBUF, IERR)
C-----------------------------------------------------------------------
C! adds to plot mark at coordinates given in an ST (star) file
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2002-2006, 2011, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   STARPL plots star positions in a plot file as given by an ST
C   extension file of version VERS.  The ST file contains the center
C   position (RA-DEC, GLON-GLAT, ELON-ELAT) of each star and the
C   "uncertainties" in those star positions.  The plotted plus signs
C   are scaled by these uncertainties and then further scaled by
C   multiplying by FACTOR.
C   Inputs:
C      FACTOR  R         Star scaling factor: <= 0 => no plot.
C      VERS    I         Desired ST file version number: 0 => high
C      IVOL    I         File disk number
C      CNO     I         File catalog number
C      BLC     R(2)      Plot lower left corner (pixels)
C      TRC     R(2)      Plot upper right corner (pixels)
C      BLUN    I         LUN of open backgraound (grey image) 0 -> none
C      BIND    I         FTAB pointer for BLUN 0 -> none
C      BCATR   I(256)    Header for background image
C      BBLC    R(7)      BLC for background image (3 - 7) are used
C      BLOCN   I         LOCNUM for background image - SETLOC must have
C                        been called.  LOCNUM on input is assumed to be
C                        the plot images location common.
C   In/Out:
C      PLBUF   I(256)    Plot IO buffer
C   Output:
C      IERR    I         Error code: 0 => okay
C                                -1 => there was no ST file
C                                +1 => logical error in ST file
C                                +2 => IO error in ST file
C                                +3 => IO error in plotting
C   Common:
C      DCAT.INC     Image header having the ST file
C      DLOC.INC     Parameters set for LOCNUM and BLOCN
C      DCNT.INC     Buffers used for background image
C      DGPH.INC     Graphics buffer already used to plot grey-scale
C                   background
C   STARPL plots four kinds of marks, and a 24 character star label
C   The types are 0=Cross, 1=Ellipse, 2=Box, 3=triangle, 4=diamond,
C   5=pentagon, 6=hexigon, 7=septigon, 8=octigon, 9=9-gon, etc
C   20=cross with a gap in center
C-----------------------------------------------------------------------
      REAL      FACTOR, BLC(2), TRC(2), BBLC(7)
      INTEGER   VERS, IVOL, CNO, BLUN, BIND, BCATB(256), BLOCN,
     *   PLBUF(256), IERR
C                                       Max Numb Columns, Label length
      INTEGER   MXSTCL, MXSTLB, MXLINE
      PARAMETER (MXSTCL=7, MXSTLB=24, MXLINE=72)
C
      INTEGER   BUFFER(512), STKOLS(MXSTCL), STNUMV(MXSTCL), ISTRNO,
     *   IV, I, JTRIM, TABLUN, IER, NPL, SCRTCH(50), NST, IST, NCHAR,
     *   LRNO, STTYPE, IROUND, SLOCN, BPOS, BVALUE, BCUT
      REAL      DELJ, DELN, AX(5), AY(5), POSANG, TX, TY, LBBLC(7),
     *   LBTRC(7), STWID(3)
      DOUBLE PRECISION DX, DY, COSPA, SINPA, COSDEC, STXY(2)
      LOGICAL   DOBACK, DOTHIS, BLACKN, DOLABL
      CHARACTER LABEL*24, TXTMSG*80
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DCNT.INC'
      DATA TABLUN /27/
C-----------------------------------------------------------------------
      IERR = 0
      IF (FACTOR.EQ.0.0) GO TO 999
C                                       Is there an ST file
      IERR = -1
      CALL FNDEXT ('ST', CATBLK, I)
      IF (I.LE.0) GO TO 999
      IV = VERS
      IF ((IV.LE.0) .OR. (IV.GT.I)) IV = I
      DOBACK = (BLUN.GT.0) .AND. (BIND.GT.0) .AND. (GPHDOD)
      IF (DOBACK) BCUT = GPHCUT * GPHTHI + (1.0-GPHCUT) * GPHTLO
      SLOCN = LOCNUM
      CALL RCOPY (7, BBLC, LBBLC)
      CALL RCOPY (7, BBLC, LBTRC)
C                                       Open ST table file
      CALL STINI ('READ', BUFFER, IVOL, CNO, IV, CATBLK, TABLUN, ISTRNO,
     *   STKOLS, STNUMV, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, IV
         GO TO 990
         END IF
      NST = BUFFER(5)
C                                       comment in plot file
      WRITE (TXTMSG,1095) NST, IV
      CALL GCOMNT (-1, TXTMSG, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 985
C                                       I guess we can do it now
      NPL = 0
      LRNO = 0
      DO 100 IST = 1,NST
         CALL TABST ('READ', BUFFER, ISTRNO, STKOLS, STNUMV, STXY,
     *      STWID, STTYPE, LABEL, IER)
         IF (IER.LT.0) GO TO 100
         IF (IER.NE.0) GO TO 975
C                                       Convert to radians
         POSANG = STWID(3) * TWOPI / 360.0
         COSPA = COS (POSANG)
         SINPA = SIN (POSANG)
         COSDEC = ABS (COS (STXY(2)*DG2RAD))
C                                       Calc center of star pos
         DOTHIS = DOBACK
         IF (DOBACK) THEN
            LOCNUM = BLOCN
            CALL XYPIX (STXY(1), STXY(2), LBBLC(1), LBBLC(2), IER)
            LBBLC(1) = IROUND (LBBLC(1))
            LBBLC(2) = IROUND (LBBLC(2))
            DOTHIS = (IER.EQ.0) .AND. (LBBLC(1).GE.1) .AND.
     *         (LBBLC(2).GT.1) .AND. (LBBLC(1).LE.BCATB(KINAX)) .AND.
     *         (LBBLC(2).LE.BCATB(KINAX+1))
            LBTRC(1) = LBBLC(1)
            LBTRC(2) = LBBLC(2)
            LOCNUM = SLOCN
            END IF
         CALL XYPIX (STXY(1), STXY(2), AX(1), AY(1), IER)
C                                       If star not in plot, get next
         IF ((BLC(1).GT.AX(1)) .OR. (BLC(2).GT.AY(1)) .OR.
     *       (TRC(1).LT.AX(1)) .OR. (TRC(2).LT.AY(1))) GO TO 100
C                                       Move and Put Text on plot
C                                       Calculate ends of star mark
         DELJ = 0.5 * STWID(1) * ABS(FACTOR)
         DELN = 0.5 * STWID(2) * ABS(FACTOR)
         IF (CORTYP(LOCNUM).EQ.1) THEN
            COSDEC = ABS (COS (STXY(2)*DG2RAD))
            DX = STXY(1) + DELJ*SINPA/COSDEC
            DY = STXY(2) + DELJ*COSPA
         ELSE IF (CORTYP(LOCNUM).EQ.2) THEN
            COSDEC = ABS (COS (STXY(1)*DG2RAD))
            DX = STXY(1) + DELJ*COSPA
            DY = STXY(2) + DELJ*SINPA/COSDEC
         ELSE
            DX = STXY(1)
            DY = STXY(2) + DELJ
            END IF
         CALL XYPIX (DX, DY, AX(2), AY(2), IER)
         IF (IER.NE.0) GO TO 100
         DX = 2.0 * STXY(1) - DX
         DY = 2.0 * STXY(2) - DY
         CALL XYPIX (DX, DY, AX(3), AY(3), IER)
         IF (IER.NE.0) GO TO 100
         IF (CORTYP(LOCNUM).EQ.1) THEN
            DX = STXY(1) - DELN*COSPA/COSDEC
            DY = STXY(2) + DELN*SINPA
         ELSE IF (CORTYP(LOCNUM).EQ.2) THEN
            DX = STXY(1) + DELN*SINPA
            DY = STXY(2) - DELN*COSPA/COSDEC
         ELSE
            DX = STXY(1) - DELN
            DY = STXY(2)
            END IF
         CALL XYPIX (DX, DY, AX(4), AY(4), IER)
         IF (IER.NE.0) GO TO 100
         DX = 2.0 * STXY(1) - DX
         DY = 2.0 * STXY(2) - DY
         CALL XYPIX (DX, DY, AX(5), AY(5), IER)
         IF (IER.NE.0) GO TO 100
C                                       If type > 22, draw an ellipse
         IF (STTYPE.GT.23) STTYPE = 3
C                                       check the background value
         IF (DOTHIS) THEN
            CALL DBINIT (BLUN, BIND, BCATB, LBBLC, LBTRC, JBUFSZ, IBUFF,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1090) 'INIT', IERR
               GO TO 990
               END IF
            CALL MDISK ('READ', BLUN, BIND, IBUFF, BPOS, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1090) 'READ', IERR
               GO TO 990
               END IF
            CALL GSCALE (GPHFUN, GPHRNG, 1, 1, BUFF(BPOS), BVALUE)
            BLACKN = BVALUE.GT.BCUT
         ELSE
            BLACKN = .FALSE.
            END IF
C                                        If the label is requested
         NCHAR = JTRIM (LABEL)
         DOLABL = (FACTOR.LT.0.0) .AND. (NCHAR.GT.0)
         IF (DOLABL) THEN
C                                        IF a box or no mark
C                                        Then top right corner
            IF ((STTYPE.EQ.4) .OR. (STTYPE.LE.0)) THEN
               TX =  AX(1) + (AX(2) - AX(3) - AX(4) + AX(5))/2
               TY =  AY(1) + (AY(2) - AY(3) - AY(4) + AY(5))/2
C                                        Else right edge of mark
            ELSE
               TX = AX(5)
               TY = AY(5)
               END IF
C                                       If label starts in the plot
C                                       Move and Put Text on plot
            IF ((BLC(1).LE.TX) .AND. (BLC(2).LE.TY) .AND.
     *         (TRC(1).GE.TX) .AND. (TRC(2).GE.TY)) THEN
               CALL GPOS (TX, TY, PLBUF, IERR)
               IF (IERR.NE.0) GO TO 985
               IF (BLACKN) THEN
                  I = 2
               ELSE
                  I = 1
                  END IF
               CALL GICHAR (I, NCHAR, 0, 0., 0., LABEL, PLBUF, IERR)
               IF (IERR.NE.0) GO TO 985
               END IF
            END IF
C                                       plot the point
         IF ((STTYPE.GT.0) .OR. ((.NOT.DOLABL) .AND. (STTYPE.EQ.0)))
     *      THEN
            CALL PNTPLT (STTYPE, AX, AY, BLC, TRC, BLACKN, .FALSE.,
     *         PLBUF, IERR)
            IF (IERR.NE.0) GO TO 985
            NPL = NPL + 1
         ELSE
            IF (DOLABL) NPL = NPL + 1
            END IF
 100     CONTINUE
      IERR = 0
      WRITE (MSGTXT,1100) NPL, NST, IV
      CALL MSGWRT (2)
      GO TO 985
C                                       Error print and close
 975  WRITE (MSGTXT,1975) IER
      IERR = 2
 980  CALL MSGWRT (8)
 985  CALL TABIO ('CLOS', 0, IST, SCRTCH, BUFFER, IER)
      GO TO 999
C                                       Error print
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' OPENING ST FILE VERSION',I4)
 1020 FORMAT ('CANNOT FIND COLUMNS IN STAR TABLE: HAS IMAGE',
     *   ' BEEN TRANSPOSED?')
 1090 FORMAT ('STARPL: ERROR ',A,'ING BACKGROUND IMAGE =',I4)
 1095 FORMAT ('Plotting',I6,' possible positions from ST table version',
     *   I4)
 1100 FORMAT ('Plotted',I6,' of',I6,' positions from ST table version',
     *   I4)
 1975 FORMAT ('IO ERROR',I5,' IN STAR TABLE FILE')
      END

      SUBROUTINE DFITPN (ARG, FUNC, WT, NFIT, NEQUAT, FITPAR, VARRES,
     *   IRET)
C-----------------------------------------------------------------------
C! Fit a polynomial in double precision to a data array
C# math
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 2010
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to fit a polynomial to the data by Least Square method
C   Fits
C      FUNC(i) = FITPAR(1) + FITPAR(2)*ARG(I) + FITPAR(3)*ARG(I)^2 +
C         FITPAR(4)*ARG(I)^3 + ...
C   Input:
C      ARG      D(*)   x: Array of data arguments
C      FUNC     D(*)   Y: Array of data function
C      NFIT     I      Number of parameters to fit, equals the
C                         polynomial degree + 1
C      NEQUAT   I      Number of points in arrays ARG, FUNC
C   Output:
C      FITPAR   D(*)   Array of fitted polynomial coefficients
C      VARRES   D      SQRT of residuals
C      IRET     I      Error; 0 => OK
C   Double precision version of POLINO uses DLESQR rather than LEASQR
C-----------------------------------------------------------------------
      INTEGER   NFIT, NEQUAT, IRET
      DOUBLE PRECISION ARG(*), FUNC(*), WT(*), VARRES, FITPAR(*)
c
      INTEGER   I, IFIT, KFIT, IKFIT
      DOUBLE PRECISION R(20), MATR(400), NOBS, SUM, SSQ, VX(20), SSQRES,
     *   VARY, FIT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (NFIT.GT.20) THEN
         IRET = 1
         WRITE (MSGTXT,1000) NFIT
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Force result vector R(NFIT),
C                                       matrix M(NFIT*NFIT) to zero
      DO 20 IFIT = 1,NFIT
         R(IFIT) = 0.0D0
         DO 10 KFIT = 1,NFIT
            IKFIT = IFIT + (KFIT - 1)*NFIT
            MATR(IKFIT) = 0.0D0
 10         CONTINUE
 20      CONTINUE
      SUM = 0.0D0
      SSQ = 0.0D0
      NOBS = 0.0D0
C                                       Prepare result vector R(NFIT)
C                                       and matrix MATR(NFIT*NFIT)
C                                       for routine LEASQR
      DO 80 I = 1,NEQUAT
         NOBS = NOBS + 1.0D0
         SUM = SUM + WT(I) * FUNC(I)
         SSQ = SSQ + WT(I) * FUNC(I)*FUNC(I)
C
         DO 60 IFIT = 1,NFIT
            R(IFIT) = R(IFIT) + WT(I) * FUNC(I) * (ARG(I) ** (IFIT - 1))
C                                       calculate upper/right
C                                       triangle of MATR
            DO 40 KFIT = IFIT, NFIT
               IKFIT = IFIT + (KFIT-1)*NFIT
               MATR(IKFIT) = MATR(IKFIT) + WT(I) *
     *            (ARG(I) ** (IFIT - 1)) * (ARG(I) ** (KFIT - 1))
 40            CONTINUE
 60         CONTINUE
 80      CONTINUE
C
      CALL DLESQR (NFIT, NOBS, SUM, SSQ, R, MATR, FITPAR, VX, SSQRES,
     *   VARRES, VARY, FIT, IRET)
      VARRES = SQRT (VARRES)
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DFITPN: REQESTED POLYNOMIAL ORDER',I4,' EXCEEDS 20')
      END

      SUBROUTINE ZBYTF2 (NWORDS, BYTFLP, NBITWD, INBUF, OUTBUF)
C----------------------------------------------------------------------
C! interchange bytes in buffer if needed to go between local & standard
C# Z2 Tape FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C----------------------------------------------------------------------
C   ZBYTF2 will interchange the low order and high order bytes for all
C   words in the input buffer and put the results in an output buffer.
C   The input buffer is unchanged except in the special case where the
C   input buffer has the same starting address as the output buffer.
C   Inputs:
C      NWORDS   I       The length of the input buffer in 16-BIT words.
C      BYTFLP   I       Byte flip code: 0 none, 1 bytes, 2 word, 3 both
C      NBITWD   I       Number bits / word
C      INBUF    I*2(*)  Input buffer
C   Output:
C      OUTBUF   I*2(*)  Buffer containing byte swapped words
C   Generic version - stub
C----------------------------------------------------------------------
      INTEGER   NWORDS, BYTFLP, NBITWD
      INTEGER*2 INBUF(*), OUTBUF(*)
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      MSGTXT = 'ZBYTF2 REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (10)
      IF (NLUSER.GT.0) STOP 'ZBYTF2 missing'
C
 999  RETURN
      END

      SUBROUTINE ZWAIT (LUN, FIND, IBUFF, IERR)
C-----------------------------------------------------------------------
C! wait for asynchronous ("MAP") IO to finish
C# IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Wait until an asynchronous I/O operation completes.
C   Inputs:
C      LUN     I   Logical unit number
C      FIND    I   Index in FTAB to file control block for LUN
C      IBUFF   I   Buffer # to wait for (1 or 2)
C   Output:
C      IERR    I   Error return code: 0 => no error
C                     1 => LUN not open in FTAB
C                     2 => error in inputs
C                     3 => I/O error
C                     4 => end of file
C                     7 => wait service error
C   Generic version: uses ZWAI2
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IBUFF, IERR
C
      INTEGER   FCBOFF, IEREOF
      LOGICAL   T
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA T /.TRUE./
      DATA IEREOF /4/
C-----------------------------------------------------------------------
      IERR = 0
C                                       LUN open in FTAB?
      IF (FTAB(FIND).EQ.LUN) GO TO 10
         IERR = 1
         WRITE (MSGTXT,1000) LUN
         GO TO 995
C                                       Valid buffer number?
 10   IF ((IBUFF.EQ.1) .OR. (IBUFF.EQ.2)) GO TO 20
         IERR = 2
         WRITE (MSGTXT,1010) IBUFF
         GO TO 995
C                                       Does not handle tapes (as of
C                                       the 15APR87 release).
 20   IF (LUN.LT.129-NTAPED) GO TO 30
         IERR = 2
         WRITE (MSGTXT,1020)
         GO TO 995
C                                       Calculate offset in FTAB to
C                                       file control block for IBUFF.
 30   FCBOFF = FIND + MOFF + (IBUFF - 1) * MFCB
      CALL ZWAI2 (FTAB(FCBOFF), IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.IEREOF)) THEN
         WRITE (MSGTXT,1030) IERR, LUN, IBUFF
         CALL MSGWRT (7)
         CALL ZERROR ('ZWAI2 ', FTAB(FCBOFF+FCBERR), ' ',
     *      FTAB(FIND+MOFF), T)
         END IF
      GO TO 999
C
 995  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZWAIT: LUN = ',I2,' NOT OPEN IN FTAB')
 1010 FORMAT ('ZWAIT: INVALID BUFFER NUMBER = ',I2)
 1020 FORMAT ('ZWAIT: DOES NOT PERFORM TAPE I/O AS OF 15APR87')
 1030 FORMAT ('ZWAIT: ZWAI2 RETURNS ERROR ',I1,' FOR LUN = ',I2,
     *   ' BUFFER = ',I1)
      END

      SUBROUTINE GMCAT (INO, IBLK, IPBLK, IERR)
C-----------------------------------------------------------------------
C! writes a copy-misc-image-catalog-info records into a plot file or TV
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   This routine will write a 'copy misc info into the image catalog'
C   command record to a graph file.
C   The output record description is:
C            I        opcode, 8 for this record type.
C            I        number of words.
C            I(INO)   miscellaneous information.
C   Inputs:
C      INO     I       number of words of misc info.
C      IBLK    I(INO)  array containing misc info.
C      IPBLK   I       plot file I/O block.
C   Output:
C      IERR    I       error code 0=ok, 3=no. of words over 20,
C                         2 disk error
C   Common:
C      GPHPOS  I       incremented by 2 + INO.
C      GPHRRN  I       incremented by 1 if write to disk necessary.
C-----------------------------------------------------------------------
      INTEGER   INO, IBLK(*), IPBLK(256), IERR
C
      INTEGER   ICODE, NEED, IER
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA ICODE /8/
C-----------------------------------------------------------------------
      IERR = 0
C                                       Too many words.
      IF ((INO.GE.21) .OR. (INO.LT.1)) THEN
         IERR = 3
         WRITE (MSGTXT,1000) INO
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Plot file
      IF (.NOT.GPHDOT) THEN
C                                       Calculate space needed.
         NEED = 254 - INO
         IF (GPHPOS.GT.NEED) THEN
            CALL GPHWRT (IPBLK, IER)
            IF (IER.NE.0) THEN
               IERR = 1
               GO TO 999
               END IF
            END IF
C                                       Put stuff in plot file buff.
         IPBLK(GPHPOS+1) = ICODE
         IPBLK(GPHPOS+2) = INO
         CALL COPY (INO, IBLK, IPBLK(GPHPOS+3))
         GPHPOS = GPHPOS + INO + 2
C                                       TV mode
      ELSE
         CALL COPY (INO, IBLK, GPHCAT(IIOTH))
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GMCAT: MAX WORDS = 20, YOUR WORDS =',I7)
      END

      SUBROUTINE GICHAR (ITY, NCHAR, IANGL, DX, DY, STR, BUFF, IERR)
C-----------------------------------------------------------------------
C! writes a draw character string command record into a plot file or TV
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GICHAR will write a 'draw in-plot string' command record, bright or
C   dark, to a graph file.
C   The output record description is:
C      I             opcode, 14 or 15 (dark) in this program.
C      I             number of characters (NCHAR).
C      I             angle (IANGL).
C      I             X offset in characters * 100  (DX * 100).
C      I             Y offset in characters * 100  (DY * 100).
C      I(4*NCHAR))   characters (STR).
C   The characters may go instead to the TV in TV mode.
C   Inputs:
C      ITY     I        Type: 0 characters outside main plot
C                             1 bright chars inside main plot
C                             2 dark chars inside manin plot
C      NCHAR   I        number of characters in STR
C      IANGL   I        angle to print STR. 0=horizontal, 1=vertical.
C      DX      R        x offset in characters from current position for
C                       the bottom left corner of first character printed.
C      DY      R        y offset in characters from current position for
C                       the bottom left corner of first character printed.
C      STR     C*(*)    string to be printed.
C      BUFF    I(256)   buffer to use for I/O.
C   Output:
C      IERR    I        error code:  0 => ok
C                       1 => disk problems
C                       2 => TV problems
C                       3 => string too big
C   Common:
C      GPHPOS  incremented by 5 + (NCHAR+1)/2 .
C      GPHRRN  incremented by 1 if a write to disk is needed.
C-----------------------------------------------------------------------
      INTEGER   ITY, NCHAR, IANGL, BUFF(256), IERR
      REAL      DX, DY
      CHARACTER STR*(*)
C
      INTEGER   CWORDS, NEED, OPCODE(3), NMAX, IER, JANGL, MCHAR, LX,
     *   LY, IX, IY, LCHAR, I
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA OPCODE /6,14,15/
C-----------------------------------------------------------------------
      IERR = 0
      IF (NCHAR.LE.0) GO TO 999
      I = ITY + 1
      IF ((I.LT.1) .OR. (I.GT.3)) I = 1
C                                       plot file
      IF (.NOT.GPHDOT) THEN
C                                       Calc no. of words needed.
         CWORDS = (NCHAR+3) / 4
         NEED = 252 - CWORDS
         IF (NEED.LE.0) THEN
            IERR = 3
            NMAX = 251 * 4
            WRITE (MSGTXT,1000) NCHAR, NMAX
            GO TO 990
            END IF
C                                       See if enough room in buffer.
         IF (GPHPOS.GE.NEED) THEN
            CALL GPHWRT (BUFF, IER)
            IF (IER.NE.0) THEN
               IERR = 1
               GO TO 999
               END IF
            END IF
C                                       Put data in buffer.
         BUFF(GPHPOS+1) = OPCODE(I)
         BUFF(GPHPOS+2) = NCHAR
         BUFF(GPHPOS+3) = IANGL
         BUFF(GPHPOS+4) = DX * 100.
         BUFF(GPHPOS+5) = DY * 100.
         CALL CHR2H (NCHAR, STR, 1, BUFF(GPHPOS+6))
         GPHPOS = GPHPOS + 5 + CWORDS
C                                       TV mode
      ELSE
C                                       Channel okay?
         IF ((ITY.EQ.2) .AND. (GPHDOD)) THEN
            I = GPHTVG(8)
         ELSE
            GPHLTY = MAX (1, GPHLTY)
            I = GPHTVG(GPHLTY)
            END IF
         CALL GCINIT (I, 0, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       NOTE: plot file angle 1 => 3
         JANGL = IANGL
         IF (JANGL.EQ.1) JANGL = 3
         IX = GPHIXL + DX * CSIZTV(1)
         IY = GPHIYL + DY * CSIZTV(2)
         MCHAR = NCHAR
         LCHAR = 1
         IF (JANGL.EQ.0) THEN
            LY = IY
            LX = IX + NCHAR * CSIZTV(1) - 1
            IF ((IY.LE.0) .OR. (IY+CSIZTV(2)-1.GT.MAXXTV(2))) THEN
               GPHERC = GPHERC + 1
               GO TO 999
               END IF
            IF ((GPHPLY(2).EQ.LY) .AND. (GPHPLX(2).GT.IX) .AND.
     *         (GPHPLX(1).LE.LX)) THEN
               GPHERO = GPHERO + 1
               GO TO 999
               END IF
            IF (LX.GT.MAXXTV(1)) THEN
               GPHERC = GPHERC + 1
               NCHAR = (MAXXTV(1) + 1 - IX) / CSIZTV(1)
               IF (NCHAR.LE.0) GO TO 999
               END IF
            IF (IX.LT.1) THEN
               GPHERC = GPHERC + 1
               LCHAR = (-IX + CSIZTV(1) - 1) / CSIZTV(1) + 1
               IX = IX + (LCHAR - 1) * CSIZTV(1)
               END IF
            GPHPLY(1) = LY + CSIZTV(2) - 1
            GPHPLY(2) = LY
            GPHPLX(1) = IX
            GPHPLX(2) = IX + (NCHAR-LCHAR+1) * CSIZTV(1) - 1
         ELSE
            LX = IX
            LY = IY - (NCHAR-1) * CSIZTV(2)
            IF ((IX.LE.0) .OR. (IX+CSIZTV(1)-1.GT.MAXXTV(1))) THEN
               GPHERC = GPHERC + 1
               GO TO 999
               END IF
            IF ((GPHPLX(1).EQ.LX) .AND. (GPHPLY(2).LT.IY) .AND.
     *         (GPHPLY(1).GE.LY)) THEN
               GPHERO = GPHERO + 1
               GO TO 999
               END IF
            IF (LY.LT.1) THEN
               GPHERC = GPHERC + 1
               NCHAR = (IY - 1) / CSIZTV(2) + 1
               IF (NCHAR.LE.0) GO TO 999
               END IF
            IF (IY.GT.MAXXTV(2)) THEN
               GPHERC = GPHERC + 1
               LCHAR = (IY - MAXXTV(2) + CSIZTV(2) -1) / CSIZTV(2) + 1
               IY = IY - (LCHAR-1) * CSIZTV(2)
               END IF
            GPHPLY(1) = IY + CSIZTV(2) - 1
            GPHPLY(2) = IY - (NCHAR-LCHAR) * CSIZTV(2)
            GPHPLX(1) = IX
            GPHPLX(2) = IX + CSIZTV(1) - 1
            END IF
         IF (LCHAR.GT.NCHAR) GO TO 999
         CALL IMCHAR (I, IX, IY, JANGL, 0, STR(LCHAR:NCHAR), GPHSCR,
     *      IERR)
         IF (IERR.EQ.2) IERR = 0
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) 'IMCHAR', IERR
            IERR = 2
            GO TO 990
            END IF
         END IF
      GO TO 999
C                                       error
 990  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GCHAR: LENGTH OF STRING:',I7,' OVER ',I4,' CHARACTERS')
 1100 FORMAT ('GCHAR: TV ROUTINE ',A,' RETURNS ERROR',I7)
      END

      SUBROUTINE KILSRV
C-----------------------------------------------------------------------
C! Function to shut down X-windows type TEK, MSG, TV servers
C# POPS Graphics TV
C-----------------------------------------------------------------------
C;  Copyright (C) 1998, 2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Kills TEK, MSG, TV servers
C-----------------------------------------------------------------------
      INTEGER   IERR, I, WORK(2), MSGTER, MSGIND, MSGSAV
      CHARACTER MESSAG*80, TMPNAM*6
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTKS.INC'
      DATA MSGTER /6/
C-----------------------------------------------------------------------
      MSGSAV = MSGSUP
      MSGSUP = 32000
C                                       TEKtronix emulator
      IF (NTKDEV.GT.0) THEN
C                                       Open the TEK
         CALL ZTKOPN (IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'TKKILL: TEKTRONIX OPEN ERROR'
            CALL MSGWRT (6)
C                                       only server implementations
         ELSE
            IF (TKTYPE.NE.0) THEN
               I = 3
               CALL ZPUTCH (I, WORK(1), 1)
               CALL ZPUTCH (I, WORK(1), 2)
               CALL ZFIO ('WRIT', TKLUN, TKFIND, 2, WORK, IERR)
               IF (IERR.NE.0) THEN
                  MSGTXT = 'TKKILL: TEKTRONIX WRITE ERROR'
                  CALL MSGWRT (6)
                  END IF
               END IF
C                                       close
            CALL ZTKCLS (IERR)
            IF (IERR.NE.0) THEN
               MSGTXT = 'TKKILL: TEKTRONIX CLOSE ERROR'
               CALL MSGWRT (6)
               END IF
            END IF
         END IF
C                                       kill TV servers too
      IF (NTVDEV.GT.0) CALL YDIE
C                                       Message server
      TMPNAM = TSKNAM
      TSKNAM = 'KILSRV'
      CALL ZMSGOP (MSGTER, MSGIND, 0, MESSAG, IERR)
      TSKNAM = TMPNAM
      IF (IERR.EQ.0) THEN
         MESSAG = ' '
         MESSAG(1:1) = CHAR (3)
         MESSAG(2:2) = CHAR (3)
         CALL ZTTYIO ('WRIT', MSGTER, MSGIND, 72, MESSAG, IERR)
         CALL ZMSGCL (MSGTER, MSGIND, IERR)
         END IF
C
      MSGSUP = MSGSAV
C
 999  RETURN
      END

      SUBROUTINE SOINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IERR)
C-----------------------------------------------------------------------
C! creates and intializes a SOurce data table.
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2000, 2006, 2010, 2012, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes antenna characteristics tables.
C   Inputs:
C      OPCODE         C*4  Operation code:
C                          'WRIT' = create/init for write or read
C                          'READ' = open for read only
C      BUFFER(512)    I    I/O buffer and related storage, also defines
C                          file if open.
C      DISK           I    Disk to use.
C      CNO            I    Catalog slot number
C      CATBLK(256)    I    Catalog header block.
C      LUN            I    Logical unit number to use
C   In/out:
C      VER            I    SO file version
C   Input (create) / output (pre-existing) via common(file keywords):
C      OBSCOD         C*8  Observing code.
C      NOSTKD         I    No. polzns. in data.
C      STK1           I    First Stokes' parameter in data.
C      NOBAND         I    Number of bands (=IFs) in data.
C      NOCHAN         I    Number of spectral channels in data.
C      REFFRQ         D    Freq. at reference pixel (Hz)
C      CHNBW          R    Bandwidth of single spectral channel (Hz)
C      REFPIX         R    Reference pixel
C      TABREV         I    Table revision number.
C                          Revision 1 - table invented, BJ, Feb 19, 1991
C      SONUMV(MAXSOC) I    Element count in each column. On input only
C                          used if the file is created.
C   Output:
C      ISORNO         I    Next row number, start of the file if READ,
C                          the last+1 if WRITE
C      SOKOLS(MAXSOC) I    The column pointer array in order:
C                          ID. NO., SOURCE, QUAL, CALCODE, FREQID,
C                          IFLUX, QFLUX, UFLUX, VFLUX, ALPHA, FREQOFF,
C                          RAEPO, DECEPO, EQUINOX, RAAPP, DECAPP,
C                          SYSVEL, VELTYP, VELDEF, RESTFREQ, PMRA,
C                          PMDEC, PARALLAX
C      IERR           I    Return error code, 0=>OK, else TABINI or
C                          TABIO error.
C----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DGLB.INC'
C                                       Input variables
      CHARACTER OPCODE*4
      INTEGER   BUFFER(*), DISK, CNO, VER, CATBLK(256), LUN, IERR
C                                       Local variables
      INTEGER   I, ITEMP(6), JERR, NTT, NC, ITRIM
      LOGICAL   T, DOREAD, NEWFIL
      HOLLERITH HOLTMP(6)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (HOLTMP, ITEMP)
      INCLUDE 'INCS:DSOV.INC'
      CHARACTER  KEYW(NKEYSO)*8, TITLE(MAXSOC)*24, UNITS(MAXSOC)*8,
     *   TTITLE*56, EPOCH*24, TITLES*24
C                                       SO and generic data statements
      DATA NTT /18/
      DATA TTITLE /'SOURCE TABLE'/
C                                       Table column titles
      DATA EPOCH /'EPOCH'/
      DATA TITLE /'SOURCE_ID','SOURCE','QUAL','CALCODE','FREQID',
     *   'IFLUX','QFLUX','UFLUX','VFLUX','ALPHA','FREQOFF','RAEPO',
     *   'DECEPO','EQUINOX','RAAPP','DECAPP','RAOBS','DECOBS',
     *   'SYSVEL','VELTYP','VELDEF','RESTFREQ','PMRA','PMDEC',
     *   'PARALLAX'/
      DATA TITLES /'ID_NO.'/
C
C                                       Units of table columns
      DATA UNITS /5*' ', 4*'JY', ' ', 'HZ', 2*'DEGREES', 'YEARS',
     *   4*'DEGREES', 'M/S', 2*' ', 'HZ', 2*'DEG/DAY',
     *   'ARCSEC'/
C
C                                       Header keywords
      DATA KEYW /'OBSCODE ', 'NO_STKD ', 'STK_1   ', 'NO_BAND ',
     *   'NO_CHAN ', 'REF_FREQ', 'CHAN_BW ', 'REF_PIXL', 'TABREV  ' /
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Set up needed variables
      NREC = 30
      NCOL = MAXSOC
      NKEY = NKEYSO
C                                       Fill in types, lengths
C                                       See Going AIPS Vol 2 p13-3.
      IF (.NOT.DOREAD) THEN
         DTYP(KSID) = TABINT + 10
         DTYP(KNAM) = TABHOL + 10 * 16
         DTYP(KQUA) = TABINT + 10
         DTYP(KCOD) = TABHOL + 10 * 4
         DTYP(KFRQ) = TABINT + 10
         DTYP(KIFX) = TABFLT  + 10 * NOBAND
         DTYP(KQFX) = TABFLT  + 10 * NOBAND
         DTYP(KUFX) = TABFLT  + 10 * NOBAND
         DTYP(KVFX) = TABFLT  + 10 * NOBAND
         DTYP(KALF) = TABFLT  + 10 * NOBAND
         DTYP(KFQO) = TABDBL  + 10 * NOBAND
         DTYP(KRAE) = TABDBL  + 10
         DTYP(KDEE) = TABDBL  + 10
C                                       EQUINOX either double or string
         DTYP(KEQU) = TABDBL  + 10
         DTYP(KRAA) = TABDBL  + 10
         DTYP(KDEA) = TABDBL  + 10
         DTYP(KRAO) = TABDBL  + 10
         DTYP(KDEO) = TABDBL  + 10
         DTYP(KSVL) = TABDBL  + 10 * NOBAND
         DTYP(KVTP) = TABHOL + 10 * 8
         DTYP(KVDF) = TABHOL + 10 * 8
         DTYP(KRFQ) = TABDBL  + 10 * NOBAND
         DTYP(KPMR) = TABDBL  + 10
         DTYP(KPMD) = TABDBL  + 10
         DTYP(KPAR) = TABFLT  + 10
         CALL COPY (NCOL, DTYP, DATP(1,2))
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'SO', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'SOINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
C                                       Get number of records
      ISORNO = BUFFER(5) + 1
      IF (DOREAD) ISORNO = 1
      NKEY = NKEYSO
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 40 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'SOINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'SOINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       Set keyword values
         CALL SOIO ('WRIT', KEYVAL, IERR)
         IF (IERR.GT.0) THEN
            CALL TABERR ('WRIT', 'SOIO', 'SOINI', IERR)
            GO TO 990
            END IF
C                                       Write if just created
         CALL TABKEY (OPCODE, KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR (OPCODE, 'TABKEY', 'SOINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'SOINI', IERR)
            GO TO 990
            END IF
C                                       Retrieve keyword values
         CALL SOIO ('READ', KEYVAL, IERR)
         IF (IERR.GT.0) THEN
            CALL TABERR ('READ', 'SOIO', 'SOINI', IERR)
            GO TO 990
            END IF
         END IF
C                                       Get array indices
C                                       Cover your ass from FNDCOL -
C                                       close to flush the buffers and
C                                       then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KEYVAL, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'SOINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'SO', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'SOINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (MAXSOC, TITLE, 24, T, BUFFER, SOKOLS, JERR)
C                                       allow epoch for equinox
      IF (SOKOLS(14).LE.0) CALL FNDCOL (1, EPOCH, 24, T, BUFFER,
     *   SOKOLS(14), JERR)
C                                       allow ID_NO. for SOURCE_ID
      IF (SOKOLS(1).LE.0) CALL FNDCOL (1, TITLES, 24, T, BUFFER,
     *   SOKOLS(1), JERR)
C                                       Get array indices and no. values
      DO 150 I = 1,MAXSOC
         IPOINT = SOKOLS(I)
         IF (IPOINT.GT.0) THEN
            SOKOLS(I) = DATP(IPOINT,1)
            SONUMV(I) = DATP(IPOINT,2) / 10
            IF (SONUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            SOKOLS(I) = -1
            SONUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('SOINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('SOINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('SOINI: ERROR INITIALIZING SOURCE (SO) TABLE FOR ',A4)
      END

      SUBROUTINE DA46 (DATJUL, A4, A5, A6)
C-----------------------------------------------------------------------
C! Computes arguments A4, A5 and A6 of the mean motion of the moon
C# Math Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Calculation of the basic arguments A4, A5, A6 of the mean motion of
C   the Moon.  A4 is the mean longitude of the Moon, measured from the
C   mean equinox of DATJUL along the ecliptic to mean ascending node,
C   and then along the orbit.  A5 is the longitude of mean ascending
C   node at DATJUL, referred to the mean equinox of DATJUL.  A6 is the
C   mean anomaly of the Moon at DATJUL.
C-----------------------------------------------------------------------
      DOUBLE PRECISION DATJUL, A4, A5, A6
      DOUBLE PRECISION TWOPI, CC, T
C-----------------------------------------------------------------------
      TWOPI = 8.D0 * ATAN(1.D0)
      CC = TWOPI / 1296000.D0
      T = (DATJUL - 2415020.D0) / 36525.D0
      A4 = (((.0068D0 * T - 4.08D0) * T + 1732564379.31D0) * T
     *   + 973562.99D0) * CC
      A5 = (((.008D0 * T + 7.48D0) * T - 6962911.23D0) * T
     *   + 933059.79D0) * CC
      A6 = (((.0518D0 * T + 33.09D0) * T + 1717915856.79D0)
     *   * T + 1065976.59D0) * CC
      A4 = MOD (A4, TWOPI)
      A5 = MOD (A5, TWOPI)
      A6 = MOD (A6, TWOPI)
C
 999  RETURN
      END

LOCAL INCLUDE 'UVDGP.INC'
C                                       Local include for UVDGP
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS, JBUFSZ
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, HISCRD(10)*64
      REAL      XSIN, XDISIN, XSOUT, XDISO, APARM(10), BUFF1(UVBFSS),
     *   BUFF2(UVBFSS)
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN,
     *   XNAMOU, XCLAOU, XSOUT, XDISO, APARM,
     *   SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, HISCRD
LOCAL END
      PROGRAM UVDGP
C-----------------------------------------------------------------------
C! Copies uv data omitting Mth Nth of the data
C# UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2000, 2008, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVDGP copies a visibility data file, omitting the Mth Nth of
C   the data, where M=APARM(1) and N=APARM(2).  For example, if
C   M=1 and N=2, then the first half of the data set is deleted.
C   Or, if M=3 and N=8, then the third eighth of the data set is
C   deleted.
C   It's adapted from FUDGE:
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input UV data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      APARM(10)      APARM         User specified array.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'UVDGP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'UVDGP '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL UVDGIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL UVDGUV (IRET)
      IF (IRET.EQ.0) CALL UVDGHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE UVDGIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   UVDGIN gets input parameters for FUDGE and creates an output file
C   if necessary.
C   Inputs:  PRGN    C*6       Program name
C   Output:  JERR    I         Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER  STAT*4, PRGN*6, UTYPE*2
      INTEGER   JERR, OLDCNO, IROUND, NPARM, IERR
      LOGICAL   T
      INCLUDE 'UVDGP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 24
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
      WRITE (MSGTXT,4000)
      CALL MSGWRT (2)
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Disallow packed uv data
      IF (CATBLK(KINAX).EQ.1) THEN
         JERR = 9
         MSGTXT = 'ERROR: I CANNOT PROCESS PACKED UV DATA, USE SPLIT'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
      IF (IERR.EQ.0) GO TO 70
         IF (IERR.EQ.2) GO TO 60
            WRITE (MSGTXT,1050) IERR
            GO TO 990
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
 60      IF ((CCNO.EQ.OLDCNO) .AND. (DISKO.EQ.DISKIN)) GO TO 65
            WRITE (MSGTXT,1060)
            GO TO 990
C                                       Recover existing CATBLK
 65      CONTINUE
            FRW(NCFILE+1) = 2
            CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', BUFF1,
     *         IERR)
            IF (IERR.EQ.0) GO TO 70
               WRITE (MSGTXT,1065) IERR
               CALL MSGWRT (6)
 70   NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                        Put input file in READ
      UTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVDGIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('UVDGIN: ERROR',I3,' UPDATING NEW CATBLK')
 4000 FORMAT ('You are using a non-standard program')
      END
      SUBROUTINE UVDGUV (IRET)
C-----------------------------------------------------------------------
C   UVDGUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER PHNAME*48
      INTEGER   IRET, INIO, IPTRI, IPTRO, LUNI, LUNO, I, INDI, INDO,
     *   LRECO, ILENBU, KBIND, NIOUT, NIOLIM, IBIND, IA1, IA2, BO, VO,
     *   NUMVIS, XCOUNT
      LOGICAL   T, F
      INCLUDE 'UVDGP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNI, LUNO /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, PHNAME, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, PHNAME, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, PHNAME, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, PHNAME, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
C                                       LRECO = length of output rec.
      LRECO = LREC
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       Read vis. record.
 100  CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
      ELSE IF ((IRET.EQ.0) .AND. (INIO.GT.0)) THEN
         IPTRI = IBIND
         DO 190 I = 1,INIO
            IF (ILOCB.GE.0) THEN
               IA1 = BUFF1(IPTRI+ILOCB) / 256. + 0.1
               IA2 = BUFF1(IPTRI+ILOCB) - IA1*256. + 0.1
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               END IF
            NUMVIS = NUMVIS + 1
C                                      Call user routine.
            CALL UVDGIT (NUMVIS, IRET)
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
C                                       Copy to output.
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1
               CALL RCOPY (LREC, BUFF1(IPTRI), BUFF2(IPTRO))
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               END IF
C                                       OK, but no output please
            IPTRI = IPTRI + LREC
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
         GO TO 100
         END IF
C                                       Final call to UVDGIT.
      NUMVIS = -1
      CALL UVDGIT (NUMVIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVDGUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1010 FORMAT ('UVDGUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1020 FORMAT ('UVDGUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('UVDGUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('UVDGUV: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('UVDGUV: UVDGIT ERROR',I3)
 1150 FORMAT ('UVDGUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE UVDGHI
C-----------------------------------------------------------------------
C   UVDGHI copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, LABEL*8, NOTTYP(1)*2
      INTEGER   LUN1, LUN2, IERR, I, NONOT
      LOGICAL   T
      INCLUDE 'UVDGP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NONOT, NOTTYP /1,'NX'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.LE.2) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 20
C                                       New history
 10   CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                      Add any other history.
      IF (NUMHIS.LE.0) GO TO 20
         WRITE (LABEL,1010) TSKNAM
         DO 15 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 20
 15         CONTINUE
C                                       Close HI file
 20   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO, FCNO(2),
     *   FCNO(1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1020)
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST', BUFF1,
     *   IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVDGHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,' /')
 1020 FORMAT ('UVDGHI:  ERROR COPYING TABLES')
      END
      SUBROUTINE UVDGIT (NUMVIS, IRET)
C-----------------------------------------------------------------------
C   UVDGIT
C   Inputs:
C      NUMVIS     I    Visibility number, -1 => final call, no data
C                      passed but allows any operations to be completed.
C   Inputs from COMMON
C      APARM(10)  R    User array.
C      RA         D    Right ascension (1950) of phase center. (deg)
C      DEC        D    Declination (1950) of phase center. (deg)
C      FREQ       D    Frequency of observation (Hz)
C      NRPARM     I    # random parameters.
C      NCOR       I    # correlators
C      CATBLK(256)I    Catalog header record.
C   Output:
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C   Output in COMMON
C      NUMHIS     I    # history entries (max. 10)
C      HISCRD(NUMHIS) C   History records
C      CATBLK     I    Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IRET
C
      INTEGER   M, N, NTOT, I4N1, I4N2, K
C  M -- which group to delete
C  N -- number of groups
C  NTOT -- total number of visibility records
C  I4N1 -- number of the first record to delete
C  I4N2 -- number of the last record to delete
      INCLUDE 'UVDGP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      IRET = 0
      M = APARM(1)
      N = APARM(2)
      NTOT = NVIS
      I4N1 = (NTOT/N) * (M-1) + 1
      I4N2 = I4N1 + NTOT / N - 1
      IF (M.EQ.N) I4N2 = NTOT
      K = NUMVIS
      IF (K.EQ.-1) GO TO 900
         IF ((K.GE.I4N1) .AND. (K.LE.I4N2)) IRET = -1
         GO TO 999
C                                       history on last call
 900  NUMHIS = 2
      WRITE (HISCRD(1),8888) M, N
      WRITE (HISCRD(2),8889) I4N1, I4N2
C
 999  RETURN
C-----------------------------------------------------------------------
 8888 FORMAT (' M=',I4,'    N=',I4)
 8889 FORMAT (I7,'th through ',I7,'th visibility records deleted.')
      END

      SUBROUTINE  RESCSL (DISK, CNO, SCALE, OFFSET, LUN, BUFFER, IERR)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C! Rescale flux-like data in any SLice files.
C# EXT-util
C-----------------------------------------------------------------------
C   This routine applies a scaling and offset to the amplitude like data
C   in any SLice extention files associated with a cataloged image.
C   No modification is made to the catalog status.
C   Inputs:
C      DISK     I        Disk number of the file.
C      CNO      I        Catalog slot number.
C      SCALE    D        Scale factor, new = SCALE * old + OFFSET
C      OFFSET   D        Offset
C      LUN      I        Lun to use for I/O
C   Input in common /MAPHDR/ (include DCAT.INC):
C      CATBLK   I        Catalog header record
C   Output:
C      BUFFER   I(512)   I/O buffer for EXTINI
C      IERR     I        0 => OK, 5 => EXTINI error, 6 => ZFIO error,
C                        7 => EXTIO close error.
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, LUN, BUFFER(*), IERR
      DOUBLE PRECISION SCALE, OFFSET
C
      INTEGER   NOSL, SLVER, LOOP, JERR, LREC, NREC, RECNO, FIND,
     *   NOSLRC, I, J, NGAUS, RECI(256)
      LOGICAL   TABLE, EXIST, FITASC, OPEN
      REAL      RECR(256)
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (RECI, RECR)
C-----------------------------------------------------------------------
      IERR = 0
C                                       Any SL tables?
      CALL FNDEXT ('SL', CATBLK, NOSL)
      IF (NOSL.LE.0) GO TO 999
C                                       Rescale SL tables
      LREC = 256
      NREC = 1
      OPEN = .FALSE.
      DO 500 SLVER = 1,NOSL
C                                       Table extant?
         CALL ISTAB ('SL', DISK, CNO, SLVER, LUN, BUFFER, TABLE, EXIST,
     *      FITASC, JERR)
         IF (.NOT.EXIST .OR. (JERR.NE.0)) GO TO 500
C                                       Open table
         CALL EXTINI ('WRIT', 'SL', DISK, CNO, SLVER, CATBLK, LUN, FIND,
     *      LREC, NREC, BUFFER, JERR)
         IF (JERR.NE.0) THEN
            IERR = 5
            WRITE (MSGTXT, 1000) JERR
            GO TO 990
            END IF
         OPEN = .TRUE.
C                                       Do max-min in second record
         RECNO = 2
         CALL ZFIO ('READ', LUN, FIND, RECNO, RECR, JERR)
         IF (JERR.NE.0) THEN
            IERR = 6
            WRITE (MSGTXT, 1010) JERR, 'READ'
            GO TO 990
            END IF
C                                       Max
         RECR(34) = RECR(34) * SCALE + OFFSET
C                                       Min
         RECR(35) = RECR(35) * SCALE + OFFSET
C                                       Rewrite record
         CALL ZFIO ('WRIT', LUN, FIND, RECNO, RECR, JERR)
         IF (JERR.NE.0) THEN
            IERR = 6
            WRITE (MSGTXT, 1010) JERR, 'WRIT'
            GO TO 990
            END IF
C                                       Slice data
         NOSLRC = (BUFFER(57) / 256.0) + 0.999
         DO 100 LOOP = 1,NOSLRC
            RECNO = 2 + LOOP
            CALL ZFIO ('READ', LUN, FIND, RECNO, RECR, JERR)
            IF (JERR.NE.0) THEN
               IERR = 6
               WRITE (MSGTXT, 1010) JERR, 'READ'
               GO TO 990
               END IF
C                                       Rescale record
            DO 50 I = 1,256
               IF (RECR(I).NE.FBLANK) RECR(I) = RECR(I) * SCALE + OFFSET
 50            CONTINUE
C                                       Rewrite record
            CALL ZFIO ('WRIT', LUN, FIND, RECNO, RECR, JERR)
            IF (JERR.NE.0) THEN
               IERR = 6
               WRITE (MSGTXT, 1010) JERR, 'WRIT'
               GO TO 990
               END IF
 100        CONTINUE
C                                       Slice models
         NOSLRC = BUFFER(58)
         IF (NOSLRC.LE.0) GO TO 400
         DO 200 LOOP = 1,NOSLRC
            RECNO = LOOP + BUFFER(59) - 1
            CALL ZFIO ('READ', LUN, FIND, RECNO, RECR, JERR)
            IF (JERR.NE.0) THEN
               IERR = 6
               WRITE (MSGTXT, 1010) JERR, 'READ'
               GO TO 990
               END IF
C                                       Rescale model amplitudes
            NGAUS = MIN (RECI(27), 4)
            DO 150 I = 1,NGAUS
               J = (I-1) * 4 + 1
               RECR(J) = RECR(J) * SCALE + OFFSET
               RECR(J+12) = RECR(J+12) * SCALE + OFFSET
 150           CONTINUE
C                                       Rewrite record
            CALL ZFIO ('WRIT', LUN, FIND, RECNO, RECR, JERR)
            IF (JERR.NE.0) THEN
               IERR = 6
               WRITE (MSGTXT, 1010) JERR, 'WRIT'
               GO TO 990
               END IF
 200        CONTINUE
C                                       Close file
 400     CALL EXTIO ('CLOS', LUN, FIND, RECNO, RECI, BUFFER, JERR)
         IF (JERR.NE.0) THEN
            IERR = 7
            WRITE (MSGTXT, 1200) JERR
            GO TO 990
            END IF
         OPEN = .FALSE.
 500     CONTINUE
C                                       Error
 990  CALL MSGWRT (6)
C                                       Close SL file if necessary
      IF (OPEN) CALL ZCLOSE (LUN, FIND, JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RESCSL: EXTINI ERROR ',I3,' RESCALING SL FILE')
 1010 FORMAT ('RESCSL: ZFIO ERROR ',I3, 1X, A4, 'ING SL FILE')
 1200 FORMAT ('RESCSL: EXTIO ERROR ',I3, ' CLOSING SL FILE')
      END

      SUBROUTINE TVCLOS (BUF, IERR)
C-----------------------------------------------------------------------
C! does error checks on device open, then closes the TV via YTVCLS
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2011
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TVCLOS closes the TV device and the TV status disk file, updating
C   the information on the disk.  Does this all by call to YTVCLS.
C   Outputs:
C      BUF   I(256)     Scratch buffer
C      IERR  I          Error code : 0 => ok,   2 => not open in parms,
C                       else as returned by YTVCLS
C-----------------------------------------------------------------------
      INTEGER   IERR, BUF(256)
C
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Check inputs
      IERR = 2
      IF ((TVIND.LE.0) .OR. (TVIND2.LE.0)) GO TO 900
      IF ((TVLUN.NE.9) .OR. (TVLUN2.NE.8)) GO TO 900
C                                       Close TV device
      CALL YTVCLS (BUF, IERR)
      IF (TVBROK.EQ.0) TVBROK = -1
      GO TO 999
C                                       error
 900  WRITE (MSGTXT,1900) TVLUN, TVLUN2, TVIND, TVIND2
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('TVCLOS: BAD PARAMETERS: LUNS, INDS =',4I6)
      END

      SUBROUTINE MKYBUF (OP, PGM, BUFSW, BUFSR, BUFFER, HEADER)
C-----------------------------------------------------------------------
C! packages a command line into machine-independent form
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MKYBUF is a routine for packaging TV commands in a machine
C   independent form for later transmission through a communication
C   line.  The READ/WRITE operation code and program name are converted
C   to packed ASCII strings at the beginning of HEADER and the integer
C   parameter array is converted to 16-bit packed integers beginning at
C   the 9th 32-bit integer in HEADER.  The 6th integer is used for the
C   integer buffer size to write across the wire and the 7th to read
C   back from the wire.
C   Inputs:
C      OP      C*4      Operation code: 'READ', 'WRIT'
C      PGM     C*6      Subroutine name
C      BUFSW   I        Number I*4 values in BUFFER to send
C      BUFSR   I        Number of I*4 values in BUFFER to receive
C      BUFFER  I(*)     Buffer of parameter values - local integers,
C                       values range -32768 to 32767 only.
C   Output:
C      HEADER  I(*)     Machine independent (FITS standard) parameters
C                       for communication.  Must be >= 8 I*2s longer
C                       than BUFFER - in 16-bit form.
C-----------------------------------------------------------------------
      CHARACTER OP*4, PGM*(*)
      INTEGER   BUFSW, BUFSR, BUFFER(*), HEADER(*)
C
      CHARACTER CT*10
      INTEGER   IDUM(2)
C-----------------------------------------------------------------------
C                                       Pack the OP codes:
      CT(1:4) = OP
      CT(5:) = PGM
      IDUM(2) = 0
      CALL ZCLC8 (10, CT, 1, HEADER)
      IDUM(1) = BUFSW
      CALL ZILI16 (1, IDUM, 6, HEADER)
      IDUM(2) = BUFSR
      CALL ZILI16 (1, IDUM, 7, HEADER)
      IDUM(1) = 0
      CALL ZILI16 (1, IDUM, 8, HEADER)
      IF (BUFSW.GT.0) CALL ZILI16 (BUFSW, BUFFER, 9, HEADER)
C
 999  RETURN
      END

      SUBROUTINE YSLECT (OP, CHAN, COLOR, LBUFF, IERR)
C-----------------------------------------------------------------------
C! turn gray and graphics planes on and off
C# Y0 TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YSLECT enables and disables gray and graphics planes
C   Inputs:
C      OP       C*4      'ONNN' or 'OFFF'
C      CHAN     I        channel number ( 1 to NGRAY+NGRAPH)
C      COLOR    I        0 - all,   1,2,3 = R,G,B, resp.
C   Output:
C      LBUFF    I(256)   scratch buffer (for graphics only)
C      IERR     I        error code of Z...XF: 0 - ok, 2 - input error
C   YSLECT sets TVLIMG in the TV device parms common /TVDEV/
C   Virtual TV version (TV by communication).
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   CHAN, COLOR, LBUFF(*), IERR
C
      INTEGER   ZEOR, ZOR, ZAND, I, MASK
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
C                                        check input
      IERR = 2
      IF ((CHAN.LT.1) .OR. (CHAN.GT.NGRAY+NGRAPH)) GO TO 999
      IF ((OP.NE.'ONNN') .AND. (OP.NE.'OFFF')) GO TO 999
      IF (((COLOR.LT.0) .OR. (COLOR.GT.3)) .AND. (CHAN.LE.NGRAY))
     *   GO TO 999
C                                       send parms
      BUFFER(1) = 0
      IF (OP.EQ.'ONNN') BUFFER(1) = 1
      BUFFER(2) = CHAN
      BUFFER(3) = COLOR
      BUFSW = 3
      BUFSR = 0
      CALL MKYBUF ('WRIT', 'YSLECT', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
C                                        reset common
      IF (IERR.EQ.0) THEN
         MASK = 2 ** (CHAN - 1)
         IF (OP.EQ.'OFFF') MASK = ZEOR (-1, MASK)
         DO 10 I = 1,4
            IF (OP.EQ.'ONNN') THEN
               TVLIMG(I) = ZOR (TVLIMG(I), MASK)
            ELSE
               TVLIMG(I) = ZAND (TVLIMG(I), MASK)
               END IF
 10         CONTINUE
         END IF
C
 999  RETURN
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE Q1GRD (UV, VIS, WT, L, INCF, NT2, M,
     *   LROW, CNT, NFREQ)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Grid a uv data.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Vectorizing compiler version
C     Grids visibility data that has been loaded into the AP previously,
C   If requested, positions are shifted and then a taper is applied to
C   the weights if requested before gridding. Multiple frequency
C   channels may be gridded together for bandwidth synthesis.
C      Two work words are assumed before the first visibility.
C   Inputs:
C      UV    I  base address of u,v vector
C      VIS   I  base address of visibility
C      WT    I  base address of weights
C      L     I  length of visibility record
C      INCF  I  Increment between visibilities and weights,
C               stepping in frequency.
C      NT2   I  INT ( (no. cells used on a row)/2 )
C      M     I  number of rows kept in AP (MUST be odd)
C      LROW  I  length of a row (V)
C      CNT   I  number of visibility points.
C      NFREQ I  number of frequencies to grid.
C               If NFREQ is negative then tapering is requested.
C               If CNT is neg, do not shift data.
C   Expects necessary constants in following AP locations:
C           8 = Row number of lowest central row to grid
C           9 = -SIG(U)**2 (CELLS**2) for taper
C          10 = -SIG(V)**2 (CELLS**2) for taper
C          11 = U scaling to cells
C          12 = V scaling to cells
C          13 = W scaling to cells
C          14 = DXC = -2 * PI * delta RA (in 1/cells) for 1ST
C          15 = DYC = -2 * PI * delta DEC         frequency channel
C          16 = DZC = -2 * PI * delta Z
C          17 = AP address containing address of base address of row
C               convolving fn. (Y on sky)
C          18 = AP address containing address of base address of col.
C               convolving fn. (X on sky)
C          19 = AP address containing address of base address of grid.
C          20...20+NFREQ-2 = differential frequency scaling table
C               for channels after the first one.
C               FREQ(n) = (1+MD(16+n-1)) * FREQ(n-1) for n>1
C   NOTE: Input addresses are 0 relative, must be converted to
C   1 relative before use.
C-----------------------------------------------------------------------
      INTEGER   UV, VIS, WT, L, INCF, NT2, M, LROW, CNT, NFREQ,
     *   NOTAP, NOSHF, VVIS, WWT, IFRQ, JNFREQ, JCNT, JA, JC, LOOP,
     *   IWRK, WORK
      REAL      VALUE1, VALUE2, VALUE3, TEMPR1, TEMPR2, TEMPI1, TEMPI2
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                       Save variables to be changed
      JCNT = CNT
      JNFREQ = NFREQ
      VVIS = VIS
      WWT = WT
      WORK = VIS - 2
C                                       Check if tapered
      NOTAP = JNFREQ
      IF (JNFREQ.LT.0) JNFREQ = - JNFREQ
C                                       Check shift
      NOSHF = JCNT
      IF (JCNT.EQ.0) GO TO 999
      IF (JCNT.LT.0) JCNT = -JCNT
C                                       Scale u,v,w to cells.
      JA = UV + 1
      VALUE1 = APCORE(12)
      VALUE2 = APCORE(13)
      VALUE3 = APCORE(14)
C@DIR IGNORE RECRDEPS(APCORE)
      DO 20 LOOP = 1,JCNT
         APCORE (JA) = APCORE(JA) * VALUE1
         APCORE (JA+1) = APCORE(JA+1) * VALUE2
         APCORE (JA+2) = APCORE(JA+2) * VALUE3
         JA = JA + L
 20      CONTINUE
C                                       Frequency looping, rescale uv
      DO 300 IFRQ = 1,JNFREQ
C                                       Don't rescale on first pass.
         IF (IFRQ.NE.1) THEN
            VALUE1 = APCORE(IFRQ+19)
            JA = UV + 1
C@DIR IGNORE RECRDEPS(APCORE)
            DO 100 LOOP = 1,JCNT
               APCORE(JA) = (VALUE1 * APCORE(JA)) + APCORE(JA)
               APCORE(JA+1) = (VALUE1 * APCORE(JA+1)) + APCORE(JA+1)
               APCORE(JA+2) = (VALUE1 * APCORE(JA+2)) + APCORE(JA+2)
               JA = JA + L
 100           CONTINUE
C                                       end if first pass
            END IF
C                                       Taper
         IF (NOTAP.LE.0) THEN
            JA = UV + 1
            JC = WWT + 1
            VALUE1 = APCORE(10)
            VALUE2 = APCORE(11)
C@DIR IGNORE RECRDEPS(APCORE)
            DO 120 LOOP = 1,JCNT
               APCORE(JC) = APCORE(JC) * EXP ((VALUE1 * APCORE(JA) *
     *            APCORE(JA)) + (VALUE2 * APCORE(JA+1) * APCORE(JA+1)))
               JA = JA + L
               JC = JC + L
 120           CONTINUE
C                                       end if taper
            END IF
C                                       Shift position.
         IF (NOSHF.GT.0) THEN
            VALUE1 = APCORE(15)
            VALUE2 = APCORE(16)
            VALUE3 = APCORE(17)
            JA = UV + 1
            IWRK = WORK + 1
C@DIR IGNORE RECRDEPS(APCORE)
            DO 150 LOOP = 1,JCNT
C                                       Set phase to shift
               APCORE(IWRK+1) = APCORE(JA) * VALUE1 +
     *            APCORE(JA+1) * VALUE2 + APCORE(JA+2) * VALUE3
               JA = JA + L
               IWRK = IWRK + L
 150           CONTINUE
C                                       Calc Cos and Sin of Phase
            CALL QRECT1 (WORK, L, WORK, L, JCNT)
            JC = VVIS + 1
            IWRK = WORK + 1
C@DIR IGNORE RECRDEPS(APCORE)
            DO 160 LOOP = 1,JCNT
C                                       Shift positions
               TEMPR1 = APCORE(IWRK)
               TEMPI1 = APCORE(IWRK+1)
               TEMPR2 = APCORE(JC)
               TEMPI2 = APCORE(JC+1)
               APCORE(JC)   = TEMPR1 * TEMPR2 - TEMPI1 * TEMPI2
               APCORE(JC+1) = TEMPR1 * TEMPI2 + TEMPI1 * TEMPR2
               IWRK = IWRK + L
               JC = JC + L
 160           CONTINUE
C                                       end if shifting
            END IF
C                                       Grid, Correct row number to
C                                       lowest central row.
         CALL QGRD4 (UV, VVIS, WWT, 19, 17, 18, NT2, M, LROW,
     *      8, L, JCNT)
         VVIS = VVIS + INCF
         WWT = WWT + INCF
 300     CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'FORMAT.INC'
C
C     Variables in this common block are used in formatting the table
C     data for output.
C
C     BUFLEN    The length of the output buffer in characters
C     OFBUFF    The output buffer
C     OFPOS     Index of last  filled character position in the output
C     buffer
C
C     NUMCOL    The number of output columns
C
C     OFLUN     The AIPS LUN for the output text file.
C     OFFIND    The AIPS FTAB index for the output text file
C
C     OFSEP     The character that will be used to separated fields on
C     the same line of the output file
C
C     OFDPWD    The maximum width of a double-precision floating-point
C     field in characters
C     OFSPWD    The maximum width of a single-precision floating-point
C     field in characters
C     OFINWD    The maximum width of an integer field in characters
C     OFLGWD    The maximum width of a logical field in characters
C     OFTMWD    The maximum width of a time field
C
C     If the formats in OFWRDP, OFWRSP, OFWRIN, OFWRLG, or OFWRTM are
C     changed then OFDPWD, OFSPWD, OFINWD, OFLGWD and OFTMWD should be
C     changed accordingly.
C
      INTEGER   BUFLEN
      PARAMETER (BUFLEN = 500)
      CHARACTER OFBUFF*(BUFLEN)
      INTEGER   OFPOS
C
      INTEGER   NUMCOL
C
      INTEGER   OFLUN
      PARAMETER (OFLUN = 10)
      INTEGER   OFFIND
C
      CHARACTER OFSEP
C
      INTEGER   OFDPWD, OFSPWD, OFINWD, OFLGWD, OFTMWD
      PARAMETER (OFDPWD = 25)
      PARAMETER (OFSPWD = 25)
      PARAMETER (OFINWD = 20)
      PARAMETER (OFLGWD = 5)
      PARAMETER (OFTMWD = 14)
C
      COMMON /OFNUMS/ OFPOS, NUMCOL, OFFIND
      COMMON /OFCHAR/ OFBUFF, OFSEP
      SAVE /OFNUMS/
      SAVE /OFCHAR/
C
LOCAL END
      PROGRAM EXTAB
C-----------------------------------------------------------------------
C!    Task to EXPORT contents of table extension files as text files.
C#    Calibration EXT-appl EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1999, 2022, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;  Internet email: aipsmail@nrao.edu.
C;  Postal address: AIPS Project Office
C;  National Radio Astronomy Observatory
C;  520 Edgemont Road
C;  Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C     Write selected data from an AIPS table to a text file using tab-
C     separated values. Convert array-valued columns to multiple output
C     columns while doing this.
C
C
C     Local variables:
C
C     TABLE     Name of TABLE object used to access input table
C     OUTFIL    Name of output file
C
C     MAXCOL    Maximum number of columns in a table
C     NCOLS     Number of columns selected from input table
C     COLS      List of columns selected from input table
C
C     BCOUNT    Number of first table row to be written
C     ECOUNT    Number of last table row to be written
C     XINC      Increment between row numbers to be written
C
C     DOHMS     Convert times to hh:mm:ss.s form?
C
C     NCOUNT    Number of array entries to be written from first block
C     BDROP     First array entry to be written from second block
C     EDROP     Last array entry to be written from second block
C
C     IRET      Return status
C     IRET2     Return status from TABCLO
C     DIEBUF    Scratch buffer for DIE
C
      CHARACTER TABLE*11, OUTFIL*48
      PARAMETER (TABLE = 'Input Table')
C
      INTEGER   MAXCOL, NCOLS
      PARAMETER (MAXCOL = 500)
      INTEGER   COLS(MAXCOL)
C
      INTEGER   BCOUNT, ECOUNT, XINC
      LOGICAL   DOHMS
      INTEGER   NCOUNT, BDROP, EDROP
C
      INTEGER   IRET, IRET2, DIEBUF(256)
C
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C
C     Initialize AIPS run-time and interpret input adverbs:
C
      CALL ETINIT (TABLE, MAXCOL, OUTFIL, NCOLS, COLS, BCOUNT, ECOUNT,
     *   XINC, DOHMS, NCOUNT, BDROP, EDROP, IRET)
C
C     If IRET is zero then all of the preconditions for calling ETPROC
C     are guaranteed to hold. If IRET is not zero then TABLE is either
C     undefined or closed.
C
      IF (IRET.EQ.0) THEN
C
C     Copy the selected data to the output file:
C
         CALL ETPROC (TABLE, OUTFIL, NCOLS, COLS, BCOUNT, ECOUNT, XINC,
     *      DOHMS, NCOUNT, BDROP, EDROP, IRET)
C
C     If IRET is 0 or -1 then the selected data have been written to
C     the output file and the input table is still open. If IRET is
C     -1 then no unflagged rows were selected by the user.
C
         IF (IRET.EQ.-1) THEN
            IRET = 0
            END IF
C
C
         CALL TABCLO (TABLE, IRET2)
         IF (IRET2.NE.0) THEN
            WRITE (MSGTXT, 9000) IRET2
            CALL MSGWRT (9)
C
C     Only set IRET to indicate an error in closing the table
C     if there is no previous error code to be reported:
C
            IF (IRET.EQ.0) THEN
               IRET = IRET2
               END IF
            END IF
         END IF
C
      CALL DIE (IRET, DIEBUF)
C-----------------------------------------------------------------------
 9000 FORMAT ('ERROR ', I4, ' ATTEMPTING TO CLOSE INPUT TABLE')
      END
      SUBROUTINE ETINIT (TABLE, MAXCOL, OUTFIL, NCOLS, COLS, BCOUNT,
     *   ECOUNT, XINC, DOHMS, NCOUNT, BDROP, EDROP, IRET)
C-----------------------------------------------------------------------
C   Read the input adverbs and initialize the AIPS run-time system.
C
C   Inputs:
C      TABLE  C*(*)      Name of TABLE object that will be used to read
C                        the input table. May not be all blanks.
C                        If IRET is zero on exit then this object is
C                        attached to the table specified by the values
C                        of the INNAME, INCLASS, INSEQ, INDISK, INEXT,
C                        and INVERS adverbs and this table is open
C                        for reading. If IRET is not zero then this
C                        object is either undefined or the table to
C                        which it is attached is closed.
C      MAXCOL I          Maximum number of input table columns that can
C                        be selected. Must be greater than or equal to
C                        zero.
C
C   Outputs:
C      OUTFIL C*48       The value of the OUTFILE adverb if IRET is
C                        zero; undefined otherwise. If IRET is zero
C                        then OUTFIL contains a logical name prefix
C                        that is a least one character long followed
C                        by a colon and at least one non-blank
C                        character.
C      NCOLS  I          If IRET is zero and the NCOLS is the number of
C                        input table columns that the user selected.
C                        That is, if the BOX adverb contained at
C                        least one positive entry that was no larger
C                        than the the number or columns in the input
C                        table then NCOLS is the number of entries in
C                        BOX that meet this condition otherwise NCOLS
C                        is the number of columns in the input table.
C                        If IRET is zero then 1 <= NCOLS <= MAXCOL.
C                        If IRET is not zero the NCOLS is undefined.
C      COLS   I(MAXCOL)  If IRET is zero then the first NCOLS entries
C                        list the selected columns in order or their
C                        selection. In other words, if the BOX adverb
C                        contained at least one positive entry that
C                        was no larger than the the number or columns
C                        in the input table then the first NCOLS
C                        entries in COLS are these entries from BOX
C                        in the order that they occurred otherwise
C                        the first NCOLS entries are 1, 2, ..., NCOLS.
C                        Note that there may be duplicate entries in
C                        COLS. If IRET is not zero then COLS is
C                        undefined.
C      BCOUNT I          If IRET is zero then BCOUNT is the minimum
C                        row number to be written out. If the BCOUNT
C                        adverb had a positive value then this is
C                        the value of BCOUNT otherwise it is 1. If
C                        IRET is not zero the BCOUNT is undefined.
C      ECOUNT I          If IRET is zero then ECOUNT is the maximum
C                        table row number to be written out. If the
C                        value of the ECOUNT adverb was positive and
C                        greater than the value of the BCOUNT adverb
C                        then this is the value of the ECOUNT adverb
C                        otherwise it is the highest row number in the
C                        table.
C      XINC   I          If IRET is zero then XINC is the row number
C                        increment. If the value if the XINC adverb
C                        was positive then this is the value of the
C                        XINC adverb otherwise it is 1. If IRET is not
C                        zero then XINC is undefined.
C      DOHMS  L          If IRET is zero then DOHMS indicates whether
C                        columns whose titles begin with 'TIME' should
C                        be output using hh:mm:ss.s representations:
C                        DOHMS is true if the value of the DOMHS adverb
C                        was positive and false otherwise. If IRET is
C                        not zero then DOHMS is undefined.
C      NCOUNT I          If IRET is zero then NCOUNT is the number of
C                        array indices to write in the first block of
C                        column values. If the NCOUNT adverb had a
C                        positive value then this is the value of the
C                        NCOUNT adverb otherwise it is 10000. If IRET
C                        not zero then NCOUNT is undefined.
C      BDROP  I          If IRET is zero then BDROP is the first array
C                        index to write in the second block of column
C                        values. If the BDROP adverb has a value greater
C                        than NCOUNT then this is the value of the BDROP
C                        adverb otherwise it is NCOUNT + 1. If IRET is
C                        not zero then BDROP is undefined.
C      EDROP  I          If IRET is zero then EDROP is the last array
C                        index to write in the second block of column
C                        values. If the EDROP adverb has a value greater
C                        than or equal to the value of the BDROP adverb
C                        then this is the value of the EDROP adverb
C                        otherwise it is 10000.
C                        If IRET is not zero then EDROP is undefined.
C      IRET   I          Status:
C                           0 - successful
C                           1 - failed to open input table
C                           2 - OUTFILE was blank or not formatted
C                               correctly
C                           3 - too many columns were selected
C                           4 - the AIPS run-time system was not
C                               initialized or the adverb values could
C                               not be read
C                           5 - the TABLE object could not be created
C                           6 - adverb values were not transferred to
C                               the table object
C                           999 - a logic error was detected
C
C   Notes:
C      - EDROP < BDROP indicates that the second block of column values
C        is empty (ie. only the first NDROP array indices will be
C        written to the output file).
C      - The ranges 1..NCOUNT and BDROP..EDROP are guaranteed not to
C        overlap.
C      - Error messages will already have been printed if IRET is not
C        zero on exit.
C      - It would be more intuitive if the default values for BDROP and
C        EDROP were interpreted to be a request for no second block of
C        array values. The current behaviour was chosen to be "bug-
C        compatible" with PRTAB.
C-----------------------------------------------------------------------
      CHARACTER TABLE*(*)
      INTEGER   MAXCOL
      CHARACTER OUTFIL*48
      INTEGER   NCOLS, COLS(MAXCOL), BCOUNT, ECOUNT, XINC
      LOGICAL   DOHMS
      INTEGER   NCOUNT, BDROP, EDROP, IRET
C
      INCLUDE 'INCS:PAOOF.INC'
C
C     Local variables
C
C     INPUTS    Name of INPUTS object used to access adverbs (parameter)
C     TASK      Name of task (parameter)
C     NPARM     Number of input adverbs (parameter)
C     AVNAME    Input adverb names
C     AVTYPE    Input adverb type codes
C     AVDIM     Input adverb dimensions
C
C     NKEYS     Number of input adverbs to copy to TABLE object
C     INKEY     Adverbs to copy to TABLE object
C     OUTKEY    TABLE attributes to receive adverb values
C
C     BOX       Value of BOX adverb
C
C     TROW      Number of rows in table
C     TCOL      Number of columns in table
C
C     TYPE      Attribute type code
C     DIM       Attribute dimensionality
C     CDUMMY    Character placeholder
C
C     IRET2     Temporary holder for TABCLO return status
C
C     IDX       Array index
C
      CHARACTER INPUTS*6, TASK*6
      PARAMETER (INPUTS = 'Inputs')
      PARAMETER (TASK   = 'EXTAB ')
      INTEGER   NPARM
      PARAMETER (NPARM  = 15)
      CHARACTER AVNAME(NPARM)*8
      INTEGER   AVTYPE(NPARM), AVDIM(2, NPARM)
C
      INTEGER   NKEYS
      PARAMETER (NKEYS = 6)
      CHARACTER INKEY(NKEYS)*8, OUTKEY(NKEYS)*8
C
      INTEGER   BOX(40)
C
      INTEGER   TROW, TCOL
C
      INTEGER   TYPE, DIM(3)
      CHARACTER CDUMMY
C
      INTEGER   IDX
C
      INTEGER   IRET2
C
      INTEGER   ITRIM
      EXTERNAL  ITRIM
C
      INTEGER   IDUM(4)
      LOGICAL   LDUM(4)
      REAL      RDUM(4)
      DOUBLE PRECISION DDUM(2)
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
C
      INCLUDE 'INCS:DMSG.INC'
C
      DATA AVNAME / 'INNAME  ', 'INCLASS ', 'INSEQ   ', 'INDISK  ',
     *              'INEXT   ', 'INVERS  ', 'BCOUNT  ', 'ECOUNT  ',
     *              'XINC    ', 'OUTFILE ', 'DOHMS   ', 'NCOUNT  ',
     *              'BDROP   ', 'EDROP   ', 'BOX     ' /
      DATA AVTYPE / OOACAR, OOACAR, OOAINT, OOAINT,
     *              OOACAR, OOAINT, OOAINT, OOAINT,
     *              OOAINT, OOACAR, OOALOG, OOAINT,
     *              OOAINT, OOAINT, OOAINT /
      DATA AVDIM / 12, 1,   6, 1,   1,  1,   1, 1,
     *              2, 1,   1, 1,   1,  1,   1, 1,
     *              1, 1,  48, 1,   1,  1,   1, 1,
     *              1, 1,   1, 1,   4, 10 /
C
      DATA INKEY  / 'INNAME  ', 'INCLASS ', 'INSEQ   ', 'INDISK  ',
     *              'INEXT   ', 'INVERS  ' /
      DATA OUTKEY / 'NAME    ', 'CLASS   ', 'IMSEQ   ', 'DISK    ',
     *              'TBLTYPE ', 'VER     ' /
C-----------------------------------------------------------------------
C
C     Initialize the AIPS run-time system and read the adverb values:
C
      CALL AV2INP (TASK, NPARM, AVNAME, AVTYPE, AVDIM, INPUTS, IRET)
      IF (IRET.EQ.0) THEN
C
C        Create a new TABLE object, transfer the adverb values that
C        specify the input table to it, and open the corresponding
C        table for reading:
C
         CALL TABCRE (TABLE, IRET)
         IF (IRET.EQ.0) THEN
            CALL IN2OBJ (INPUTS, NKEYS, INKEY, OUTKEY, TABLE, IRET)
            IF (IRET.EQ.0) THEN
               CALL TABOPN (TABLE, 'READ', IRET)
               IF (IRET.EQ.0) THEN
C
C                 The table is now open for reading.
C
C                 Retrieve the output file name and check that it
C                 has the correct format:
C
                  CALL INGET (INPUTS, 'OUTFILE', TYPE, DIM, IDUM,
     *               OUTFIL, IRET)
                  CALL CHECK ('ETINIT', 1,
     *                        (IRET.EQ.0) .AND. (TYPE.EQ.OOACAR)
     *                        .AND. (DIM(1).LE.48)
     *                        .AND. (DIM(2).EQ.1)
     *                        .AND. (DIM(3).EQ.0), IRET)
                  IF (IRET.NE.0) GO TO 999
                  IDX = INDEX (OUTFIL, ':')
                  IF ((IDX.GT.1) .AND. (IDX.LT.ITRIM(OUTFIL))) THEN
C
C                    There is a least one character before the colon
C                    and at least one character after the colon so
C                    OUTFIL has the required format.
C
C                    Set up the first and last rows and the row
C                    increment:
C
                     CALL TABGET (TABLE, 'NROW', TYPE, DIM, IDUM,
     *                            CDUMMY, IRET)
                     TROW = IDUM(1)
                     CALL CHECK ('ETINIT', 2,
     *                           (IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *                           .AND. (DIM(1).EQ.1)
     *                           .AND. (DIM(2).EQ.1)
     *                           .AND. (DIM(3).EQ.0), IRET)
                     IF (IRET.NE.0) GO TO 999
                     CALL INGET (INPUTS, 'BCOUNT', TYPE, DIM, IDUM,
     *                           CDUMMY, IRET)
                     BCOUNT = IDUM(1)
                     CALL CHECK ('ETINIT', 3,
     *                           (IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *                           .AND. (DIM(1).EQ.1)
     *                           .AND. (DIM(2).EQ.1)
     *                           .AND. (DIM(3).EQ.0), IRET)
                     IF (IRET.NE.0) GO TO 999
                     IF (BCOUNT.LE.0) THEN
                        BCOUNT = 1
                        END IF
                     CALL INGET (INPUTS, 'ECOUNT', TYPE, DIM, IDUM,
     *                           CDUMMY, IRET)
                     ECOUNT = IDUM(1)
                     CALL CHECK ('ETINIT', 4,
     *                           (IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *                           .AND. (DIM(1).EQ.1)
     *                           .AND. (DIM(2).EQ.1)
     *                           .AND. (DIM(3).EQ.0), IRET)
                     IF (IRET.NE.0) GO TO 999
                     IF (ECOUNT.LT.BCOUNT) THEN
                        ECOUNT = TROW
                        END IF
                     CALL INGET (INPUTS, 'XINC', TYPE, DIM, IDUM,
     *                           CDUMMY, IRET)
                     XINC = IDUM(1)
                     CALL CHECK ('ETINIT', 5,
     *                           (IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *                           .AND. (DIM(1).EQ.1)
     *                           .AND. (DIM(2).EQ.1)
     *                           .AND. (DIM(3).EQ.0), IRET)
                     IF (IRET.NE.0) GO TO 999
                     IF (XINC.LE.0) THEN
                        XINC = 1
                        END IF
C
C                    Find out whether time columns should be printed
C                    using hh:mm:ss formats:
C
                     CALL INGET (INPUTS, 'DOHMS', TYPE, DIM, IDUM,
     *                           CDUMMY, IRET)
                     DOHMS = LDUM(1)
                     CALL CHECK ('ETINIT', 6,
     *                           (IRET.EQ.0) .AND. (TYPE.EQ.OOALOG)
     *                           .AND. (DIM(1).EQ.1)
     *                           .AND. (DIM(2).EQ.1)
     *                           .AND. (DIM(3).EQ.0), IRET)
                     IF (IRET.NE.0) GO TO 999
C
C                    Get array index ranges:
C
                     CALL INGET (INPUTS, 'NCOUNT', TYPE, DIM, IDUM,
     *                           CDUMMY, IRET)
                     NCOUNT = IDUM(1)
                     CALL CHECK ('ETINIT', 7,
     *                           (IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *                           .AND. (DIM(1).EQ.1)
     *                           .AND. (DIM(2).EQ.1)
     *                           .AND. (DIM(3).EQ.0), IRET)
                     IF (IRET.NE.0) GO TO 999
                     IF (NCOUNT.LE.0) THEN
                        NCOUNT = 10000
                        END IF
                     CALL INGET (INPUTS, 'BDROP', TYPE, DIM, IDUM,
     *                           CDUMMY, IRET)
                     BDROP = IDUM(1)
                     CALL CHECK ('ETINIT', 8,
     *                           (IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *                           .AND. (DIM(1).EQ.1)
     *                           .AND. (DIM(2).EQ.1)
     *                           .AND. (DIM(3).EQ.0), IRET)
                     IF (IRET.NE.0) GO TO 999
C
C                    Keep a temporary copy of BDROP to test EDROP
C                    against:
C
                     IDX = MAX (1, BDROP)
C
                     IF (BDROP.LE.NCOUNT) THEN
                        BDROP = NCOUNT + 1
                        END IF
                     CALL INGET (INPUTS, 'EDROP', TYPE, DIM, IDUM,
     *                           CDUMMY, IRET)
                     EDROP = IDUM(1)
                     CALL CHECK ('ETINIT', 9,
     *                           (IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *                           .AND. (DIM(1).EQ.1)
     *                           .AND. (DIM(2).EQ.1)
     *                           .AND. (DIM(3).EQ.0), IRET)
                     IF (IRET.NE.0) GO TO 999
                     IF (EDROP.LT.IDX) THEN
                        EDROP = 10000
                        END IF
C
C                    Build the list of columns to be written:
C
                     CALL TABGET (TABLE, 'NCOL', TYPE, DIM, IDUM,
     *                            CDUMMY, IRET)
                     TCOL = IDUM(1)
                     CALL CHECK ('ETINIT', 10,
     *                           (IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *                           .AND. (DIM(1).EQ.1)
     *                           .AND. (DIM(2).EQ.1)
     *                           .AND. (DIM(3).EQ.0), IRET)
                     IF (IRET.NE.0) GO TO 999
                     CALL INGET (INPUTS, 'BOX', TYPE, DIM, BOX, CDUMMY,
     *                           IRET)
                     CALL CHECK ('ETINIT', 11,
     *                           (IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *                           .AND. (DIM(1) * DIM(2).LE.40)
     *                           .AND. (DIM(3).EQ.0), IRET)
                     IF (IRET.NE.0) GO TO 999
C
                     NCOLS = 0
                     IDX = 0
C
C                    Invariant: If IRET is zero then NCOLS is the number
C                               of entries in BOX(1:IDX) that lie in the
C                               range 1:TCOL and COLS(1:NCOLS) is a list
C                               of these values in the order that they
C                               occur in BOX; If IRET is 3 then there
C                               are more than MAXCOL entries in the
C                               range 1:TCOL in BOX(1:IDX).
C                    Bound: 40 - IDX
C
   10                IF ((IRET.EQ.0) .AND. (IDX.NE.40)) THEN
                        IDX = IDX + 1
                        IF ((1.LE.BOX(IDX))
     *                      .AND. (BOX(IDX).LE.TCOL)) THEN
                           IF (NCOLS.NE.MAXCOL) THEN
                              NCOLS = NCOLS + 1
                              COLS(NCOLS) = BOX(IDX)
                           ELSE
                              WRITE (MSGTXT, 9010) MAXCOL
                              CALL MSGWRT (9)
                              WRITE (MSGTXT, 9011)
                              CALL MSGWRT (9)
                              IRET = 3
                              END IF
                           END IF
                        GO TO 10
                        END IF
C
C                    NCOLS is now the number of columns selected using
C                    BOX. If this is zero then there is no explicit
C                    column selection so select all columns in the
C                    table (NB. IRET == 3 imples NCOLS /= 0):
C
                     IF (NCOLS.EQ.0) THEN
                        IF (TCOL.LE.MAXCOL) THEN
                           NCOLS = TCOL
C
C                          Invariant: COLS(1:IDX) = 1:IDX
C
                           DO 20 IDX = 1, NCOLS
                              COLS(IDX) = IDX
   20                         CONTINUE
                        ELSE
                           WRITE (MSGTXT, 9020) MAXCOL
                           CALL MSGWRT (9)
                           WRITE (MSGTXT, 9011)
                           CALL MSGWRT (9)
                           IRET = 3
                           END IF
                        END IF
                  ELSE
                     WRITE (MSGTXT, 9021)
                     CALL MSGWRT (9)
                     IRET = 2
                     END IF
C
C                 Close the input table if errors have been detected
C
                  IF (IRET.NE.0) THEN
                     CALL TABCLO (TABLE, IRET2)
C
C                    Report any problems closing the table but do not
C                    overwrite the existing error indicator:
C
                     IF (IRET2.NE.0) THEN
                        WRITE (MSGTXT, 9022) IRET2
                        CALL MSGWRT (9)
                        END IF
                     END IF
               ELSE
                  WRITE (MSGTXT, 9023)
                  CALL MSGWRT (9)
                  IRET = 1
                  END IF
            ELSE
               WRITE (MSGTXT, 9024) IRET
               CALL MSGWRT (9)
               IRET = 6
               END IF
         ELSE
            WRITE (MSGTXT, 9025) IRET
            CALL MSGWRT (9)
            IRET = 5
            END IF
      ELSE
         WRITE (MSGTXT, 9026) IRET
         CALL MSGWRT (9)
         IRET = 4
         END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 9010 FORMAT ('MORE THAN ', I4, ' COLUMNS WERE SELECTED')
 9011 FORMAT ('USE BOX TO SELECT FEWER COLUMNS')
 9020 FORMAT ('TABLE HAS MORE THAN ', I4, 'COLUMNS')
 9021 FORMAT ('OUTFILE MUST HAVE THE FORM ''LOGICAL:FILENAME''')
 9022 FORMAT ('ERROR ', I6, ' CLOSING INPUT TABLE AFTER ERROR')
 9023 FORMAT ('COULD NOT OPEN INPUT TABLE: CHECK INPUTS')
 9024 FORMAT ('ERROR ', I6, ' COPYING INPUTS TO TABLE OBJECT')
 9025 FORMAT ('ERROR ', I6, ' CREATING NEW TABLE OBJECT')
 9026 FORMAT ('ERROR ', I6, ' INITIALIZING TASK')
      END
      SUBROUTINE ETPROC (TABLE, OUTFIL, NCOLS, COLS, BCOUNT, ECOUNT,
     *                   XINC, DOHMS, NCOUNT, BDROP, EDROP, IRET)
C-----------------------------------------------------------------------
C   Write selected data from TABLE to OUTFIL.
C
C   Inputs:
C      TABLE   C*(*)     Name of the TABLE object that refers to the
C                        input table. Must not be blank and must refer
C                        to a table that is open for reading and that
C                        has no more than 500 columns.
C      OUTFIL  C*(*)     Name of output file. Must not be blank and
C                        must contain a logical area prefix followed by
C                        a colon and then the file name.
C      NCOLS   I         The number of input table columns to be written
C                        to the output file. Must be greater than or
C                        equal to zero.
C      COLS    I(NCOLS)  The list of input table column numbers to be
C                        written to the output file. Each antry must
C                        be greater than 0 and less than or equal to
C                        the number of columns in TABLE.
C      BCOUNT  I         The first row to write to the output file.
C                        Must be greater than zero.
C      ECOUNT  I         The last row to write to the output file. Must
C                        not be greater than the number of rows in
C                        TABLE.
C      XINC    I         Row number increment. Must be greater than 0.
C      DOHMS   L         Should times be written as hh:mm:ss?
C      NCOUNT  I         Number of array indices in first block. Must
C                        be greater than or equal to 0.
C      BDROP   I         First array index in second block. Must be
C                        greater than NCOUNT.
C      EDROP   I         Last array index in second block.
C
C   Output:
C      IRET    I         Status:
C                         0 - All selected data was written to the
C                             output file.
C                        -1 - No rows were selected: output file
C                             contains no data
C                         1 - Could not open the output file
C                         2 - Failed to read data from input file
C                         3 - Failed to write data to output file
C                         4 - At least one table column had more
C                             array elements than could fit in the
C                             local buffers
C
C   Notes:
C      - If IRET is not zero on completion then an error message has
C        already been written.
C      - If ECOUNT < BCOUNT then no rows are selected
C      - If EDROP < BDROP then the second index block is empty
C-----------------------------------------------------------------------
      CHARACTER TABLE*(*), OUTFIL*(*)
      INTEGER   NCOLS
      INTEGER   COLS(NCOLS)
      INTEGER   BCOUNT, ECOUNT, XINC
      LOGICAL   DOHMS
      INTEGER   NCOUNT, BDROP, EDROP, IRET
C
C     Local variables:
C
C     MAXCOL    Maximum number of columns in the input table
C     TCOL      Actual number of columns in the input table
C     COLLBL    Column labels
C     COLTYP    Column types
C     COLDIM    Column dimensions
C
C     TABDTM    Special type code for double-precision value to be
C               printed as hh:mm:ss time.
C     TABSTM    Special type code for single-precision value to be
C               printed as hh:mm:ss time.
C
C     MAXSTR    Maximum length of string-values columns
C     MAXIND    Maximum index for array-valued columns
C     DBLVAL    Buffer for double-precision valued columns
C     FLTVAL    Buffer for single-precision valued columns
C     CHRVAL    Buffer for character-valued columns
C     INTVAL    Buffer for integer-valued columns
C     LOGVAL    Buffer for logical-valued columns
C
C     ROWOUT    Number of rows written
C     ROW       Current row number
C     COL       Current column number
C
C     TYPE      Attribute type
C     DIM       Attribute dimensions
C     CDUMMY    Character place-holder
C
C     MSGSAV    Saved message threshold
C
C     I         Array index
C
      INTEGER   MAXCOL
      PARAMETER (MAXCOL = 500)
      INTEGER   TCOL
      CHARACTER COLLBL(MAXCOL)*24
      INTEGER   COLTYP(MAXCOL), COLDIM(MAXCOL)
C
      INTEGER   TABDTM, TABSTM
      PARAMETER (TABDTM = 11)
      PARAMETER (TABSTM = 12)
C
      INTEGER MAXSTR, MAXIND
      PARAMETER (MAXSTR = 1000)
      PARAMETER (MAXIND = 20000)
      DOUBLE PRECISION DBLVAL(MAXIND)
      REAL      FLTVAL(MAXIND)
      CHARACTER CHRVAL*(MAXSTR)
      INTEGER   INTVAL(MAXIND)
      LOGICAL   LOGVAL(MAXIND)
      EQUIVALENCE (DBLVAL, FLTVAL, INTVAL, LOGVAL)
C
      INTEGER   ROWOUT, ROW, COL
C
      INTEGER   TYPE, DIM(3)
      CHARACTER CDUMMY
C
      INTEGER   MSGSAV
C
      INTEGER   I
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PTAB.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C
C     Read table metadata:
C
      CALL TABGET (TABLE, 'NCOL', TYPE, DIM, INTVAL, CDUMMY, IRET)
      TCOL = INTVAL(1)
      CALL CHECK ('ETPROC', 1, (IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *            .AND. (DIM(1).EQ.1) .AND. (DIM(2).EQ.1)
     *            .AND. (DIM(3).EQ.0), IRET)
      IF (IRET.NE.0) GO TO 999
      CALL TABGET (TABLE, 'COLABEL', TYPE, DIM, INTVAL, COLLBL, IRET)
      CALL CHECK ('ETPROC', 2, (IRET.EQ.0) .AND. (TYPE.EQ.OOACAR)
     *            .AND. (DIM(1).LE.24) .AND. (DIM(2).LE.MAXCOL)
     *            .AND. (DIM(3).EQ.0), IRET)
      IF (IRET.NE.0) GO TO 999
      CALL TABGET (TABLE, 'COLTYPE', TYPE, DIM, COLTYP, CDUMMY, IRET)
      CALL CHECK ('ETPROC', 2, (IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *            .AND. (DIM(1).LE.MAXCOL) .AND. (DIM(2).EQ.1)
     *            .AND. (DIM(3).EQ.0), IRET)
      IF (IRET.NE.0) GO TO 999
      CALL TABGET (TABLE, 'COLDIM', TYPE, DIM, COLDIM, CDUMMY, IRET)
      CALL CHECK ('ETPROC', 3, (IRET.EQ.0) .AND. (TYPE.EQ.OOAINT)
     *            .AND. (DIM(1).LE.MAXCOL) .AND. (DIM(2).EQ.1)
     *            .AND. (DIM(3).EQ.0), IRET)
      IF (IRET.NE.0) GO TO 999
C
C     Mark columns that should be presented as time strings rather
C     than floating-point numbers:
C
      IF (DOHMS) THEN
C
C        Invariant: for all i, 1 <= i <= COL, if COLTYP(i)^ = TABDBL
C                   and COLLBL(i)(1:4) = 'TIME' then COLTYP(i)' = TABDTM
C                   or if COLTYP(i)^ = TABFLT and
C                   COLLBL(I)(1:4) = 'TIME' then COLTYP(i)' = TABSTM
C                   otherwise COLTYP(i)' = COLTYP(i)^ (where ' indicates
C                   the current state and ^ the state before the loop).
C
         DO 10 COL = 1, TCOL
            IF (COLLBL(COL)(1:4).EQ.'TIME') THEN
               IF (COLTYP(COL).EQ.TABDBL) THEN
                  COLTYP(COL) = TABDTM
               ELSE IF (COLTYP(COL).EQ.TABFLT) THEN
                  COLTYP(COL) = TABSTM
                  END IF
               END IF
   10       CONTINUE
         END IF
C
C     Check for columns that are too large for the local buffers:
C
      IRET = 0
      COL = 0
C
C     Invariant: IRET = 0 implies that for all i, 1 <= i <= COL,
C                COLTYP(COLS(i)) = TABSEL,
C                COLTYP(COLS(i)) = TABHOL and
C                COLDIM(COLS(i)) <= MAXSTR, or
C                COLTYP(COLS(i)) = TABDBL, TABFLT, TABINT, TABLOG,
C                TABSTM, TABDTM or TABBIT and
C                COLDIM(COLS(i)) <= MAXIND; IRET = 4 implies that there
C                is some i for which COLTYP(COLS(i)) = TABHOL and
C                COLDIM(COLS(i)) > MAXSTR or COLTYP(COLS(i)) = TABDBL,
C                TABFLT, TABIND, TABLOG, TABBIT, TABDTM, or TABSTM and
C                COLDIM(COLS(i)) > MAXIND
C     Bound: NCOLS - COL
C
   20 IF ((IRET.EQ.0) .AND. (COL.NE.NCOLS)) THEN
         COL = COL + 1
C
C        Note that TABBIT and TABSEL column types are ignored.
C
         IF ((COLTYP(COLS(COL)).NE.TABHOL)
     *       .AND. (COLTYP(COLS(COL)).NE.TABSEL)
     *       .AND. (COLDIM(COLS(COL)).GT.MAXIND)) THEN
            WRITE (MSGTXT, 9020) COLS(COL), MAXIND
            CALL MSGWRT (9)
            IRET = 4
         ELSE IF ((COLTYP(COLS(COL)).EQ.TABHOL)
     *            .AND. (COLDIM(COLS(COL)).GT.MAXSTR)) THEN
            WRITE (MSGTXT, 9021) COLS(COL), MAXSTR
            CALL MSGWRT (9)
            IRET = 4
            END IF
         GO TO 20
         END IF
C
C     If IRET is zero then all of the selected columns fit in the local
C     buffers.
C
      IF (IRET.EQ.0) THEN
C
C        Set up the output file:
C
         CALL OFINIT (OUTFIL, COLLBL, COLTYP, COLDIM, NCOLS, COLS,
     *                NCOUNT, BDROP, EDROP, IRET)
         IF (IRET.EQ.0) THEN
C
C           Process each selected row:
C
            ROWOUT = 0
            ROW = BCOUNT
C
C           Invariant: IRET = 0 implies that all selected and unflagged
C                      rows in the range BCOUNT:ROW have been written
C                      to the output file and that NUMROW is the number
C                      of rows that have been written
C           Bound: MAX ((ECOUNT + XINC - ROW) / XINC, 0)
C
   30       IF ((IRET.EQ.0) .AND. (ROW.LE.ECOUNT)) THEN
               CALL OFSROW (IRET)
               IF (IRET.EQ.0) THEN
C
C              Suppress messages from TABDGT:
C
                  MSGSAV = MSGSUP
                  MSGSUP = 32000
                  COL = 0
C
C                 Invariant: IRET = 0 implies that the first COL
C                            selected columns from row ROW have been
C                            written to the output file
C                 Bound: NCOLS - COL
C
   40             IF ((IRET.EQ.0) .AND. (COL.NE.NCOLS)) THEN
                     COL = COL + 1
                     IF (COLTYP(COLS(COL)).EQ.TABDBL) THEN
                        CALL TABDGT (TABLE, ROW, COLS(COL), TYPE, DIM,
     *                     INTVAL, CDUMMY, IRET)
                        IF (IRET.EQ.0) THEN
                           CALL OFWRDP (DBLVAL, COLDIM(COLS(COL)),
     *                        NCOUNT, BDROP, EDROP, IRET)
                           IF (IRET.NE.0) THEN
                              IRET = 3
                              END IF
                        ELSE IF (IRET.NE.-1) THEN
                           IRET = 2
                           END IF
                     ELSE IF (COLTYP(COLS(COL)).EQ.TABFLT) THEN
                        CALL TABDGT (TABLE, ROW, COLS(COL), TYPE, DIM,
     *                     INTVAL, CDUMMY, IRET)
                        IF (IRET.EQ.0) THEN
                           CALL OFWRSP (FLTVAL, COLDIM(COLS(COL)),
     *                        NCOUNT, BDROP, EDROP, IRET)
                           IF (IRET.NE.0) THEN
                              IRET = 3
                              END IF
                        ELSE IF (IRET.NE.-1) THEN
                           IRET = 2
                           END IF
                     ELSE IF (COLTYP(COLS(COL)).EQ.TABHOL) THEN
                        CALL TABDGT (TABLE, ROW, COLS(COL), TYPE, DIM,
     *                     INTVAL, CHRVAL, IRET)
                        IF (IRET.EQ.0) THEN
                           CALL OFWRST (CHRVAL, COLDIM(COLS(COL)),
     *                        IRET)
                           IF (IRET.NE.0) THEN
                              IRET = 3
                              END IF
                        ELSE IF (IRET.NE.-1) THEN
                           IRET = 2
                           END IF
                     ELSE IF (COLTYP(COLS(COL)).EQ.TABINT) THEN
                        CALL TABDGT (TABLE, ROW, COLS(COL), TYPE, DIM,
     *                     INTVAL, CDUMMY, IRET)
                        IF (IRET.EQ.0) THEN
                           CALL OFWRIN (INTVAL, COLDIM(COLS(COL)),
     *                        NCOUNT, BDROP, EDROP, IRET)
                           IF (IRET.NE.0) THEN
                              IRET = 3
                              END IF
                        ELSE IF (IRET.NE.-1) THEN
                           IRET = 2
                           END IF
                     ELSE IF (COLTYP(COLS(COL)).EQ.TABLOG) THEN
                        CALL TABDGT (TABLE, ROW, COLS(COL), TYPE, DIM,
     *                     INTVAL, CDUMMY, IRET)
                        IF (IRET.EQ.0) THEN
                           CALL OFWRLG (LOGVAL, COLDIM(COLS(COL)),
     *                                  NCOUNT, BDROP, EDROP, IRET)
                           IF (IRET.NE.0) THEN
                              IRET = 3
                              END IF
                        ELSE IF (IRET.NE.-1) THEN
                           IRET = 2
                           END IF
                     ELSE IF (COLTYP(COLS(COL)).EQ.TABBIT) THEN
                        CALL TABDGT (TABLE, ROW, COLS(COL), TYPE, DIM,
     *                     INTVAL, CDUMMY, IRET)
                        IF (IRET.EQ.0) THEN
                           CALL OFWRLG (LOGVAL, COLDIM(COLS(COL)),
     *                        NCOUNT, BDROP, EDROP, IRET)
                           IF (IRET.NE.0) THEN
                              IRET = 3
                              END IF
                        ELSE IF (IRET.NE.-1) THEN
                           IRET = 2
                           END IF
                     ELSE IF (COLTYP(COLS(COL)).EQ.TABDTM) THEN
                        CALL TABDGT (TABLE, ROW, COLS(COL), TYPE, DIM,
     *                     INTVAL, CDUMMY, IRET)
                        IF (IRET.EQ.0) THEN
                           CALL OFWRTM (DBLVAL, COLDIM(COLS(COL)),
     *                                  NCOUNT, BDROP, EDROP, IRET)
                           IF (IRET.NE.0) THEN
                              IRET = 3
                              END IF
                        ELSE IF (IRET.NE.-1) THEN
                           IRET = 2
                           END IF
                     ELSE IF (COLTYP(COLS(COL)).EQ.TABSTM) THEN
                        CALL TABDGT (TABLE, ROW, COLS(COL), TYPE, DIM,
     *                     INTVAL, CDUMMY, IRET)
                        IF (IRET.EQ.0) THEN
C
C                          Convert values to double-precision:
C
                           DO 50 I = 1, COLDIM(COLS(COL))
                              IF (FLTVAL(I).EQ.FBLANK) THEN
                                 DBLVAL(I) = DBLANK
                              ELSE
                                 DBLVAL(I) = DBLE (FLTVAL(I))
                                 END IF
   50                         CONTINUE
C
                           CALL OFWRTM (DBLVAL, COLDIM(COLS(COL)),
     *                                  NCOUNT, BDROP, EDROP, IRET)
                           IF (IRET.NE.0) THEN
                              IRET = 3
                              END IF
                        ELSE IF (IRET.NE.-1) THEN
                           IRET = 2
                           END IF
                        END IF
                     GO TO 40
                     END IF
C
C                 Stop suppressing error messages:
C
                  MSGSUP = MSGSAV
C
                  IF (IRET.EQ.0) THEN
                     CALL OFFROW (IRET)
                     IF (IRET.EQ.0) THEN
                        ROWOUT = ROWOUT + 1
                     ELSE
                        WRITE (MSGTXT, 9050) ROW
                        CALL MSGWRT (9)
                        IRET = 3
                        END IF
                  ELSE IF (IRET.EQ.-1) THEN
C
C                    Row was flagged, ignore error and write out the
C                    line buffer (assumed to be blank) so that the
C                    output file module is reset to a between-lines
C                    state:
C
                     CALL OFFROW (IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT, 9050) ROW
                        CALL MSGWRT (9)
                        IRET = 3
                        END IF
                  ELSE IF (IRET.EQ.2) THEN
                     WRITE (MSGTXT, 9051) ROW
                     CALL MSGWRT (9)
                  ELSE IF (IRET.EQ.3) THEN
                     WRITE (MSGTXT, 9050) ROW
                     CALL MSGWRT (9)
                     END IF
               ELSE IF (IRET.NE.0) THEN
                  WRITE (MSGTXT, 9050) ROW
                  CALL MSGWRT (9)
                  IRET = 3
                  END IF
               ROW = ROW + XINC
               GO TO 30
               END IF
C
C           Finish up:
C
            IF (IRET.EQ.0) THEN
               CALL OFFINI (IRET)
               IF (IRET.NE.0) THEN
                  IRET = 3
                  END IF
               IF (ROWOUT.EQ.0) THEN
                  WRITE (MSGTXT, 1050)
                  CALL MSGWRT (5)
C
C                 Note this unless an error condition has been flagged:
C
                  IF (IRET.EQ.0) THEN
                     IRET = -1
                     END IF
                  END IF
               END IF
         ELSE
            IRET = 1
            END IF
         END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('WARNING: no unflagged rows were selected')
 9020 FORMAT ('COLUMN ', I5, ' HAS TOO MANY ARRAY ELEMENTS (> ', I6,
     *        ')')
 9021 FORMAT ('COLUMN ', I5, ' IS TOO WIDE (> ', I6, ' CHARACTERS)')
 9050 FORMAT ('FAILED WHILE WRITING ROW NUMBER ', I6)
 9051 FORMAT ('FAILED WHILE READING ROW NUMBER ', I6)
      END
      SUBROUTINE OFINIT (OUTFIL, COLLBL, COLTYP, COLDIM, NCOLS, COLS,
     *                   NCOUNT, BDROP, EDROP, IRET)
C-----------------------------------------------------------------------
C   Initialize the output module, set the field separator to the
C   horizontal tabulation character  and check whether the requested
C   data will fit in the output buffer. If so open the output file and
C   add column headings.
C
C   Inputs:
C      OUTFIL  C*(*)      The name of the output file. Must comprise a
C                         logical area name followed by a colon and a
C                         filename.
C      COLLBL  C(*)*24    Column labels
C      COLTYP  I(*)       Column type codes:
C                          1 - double-precision
C                          2 - single-precision
C                          3 - character string
C                          4 - integer
C                          5 - logical
C                          7 - bit field
C                          9 - select flag
C                         11 - double-precision time
C                         12 - single-precision time
C      COLDIM   I(*)      Column dimensions
C      NCOLS    I         Number of requested columns; greater than or
C                         equal to zero.
C      COLS     I(NCOLS)  List of requested columns: each entry must
C                         be the index of defined entries in COLLBL,
C                         COLTYP, and COLDIM
C      NCOUNT   I         Number of array indices in first block;
C                         greater than or equal to 1
C      BDROP    I         First index in second block; greater than
C                         NCOUNT
C      EDROP    I         Last index in second block
C
C   Output:
C      IRET     I         Return status
C                         0 - success
C                         1 - table data overflows line buffer
C                         2 - no translation for logical area name
C                         3 - output file already exists
C                         4 - failed to open output file
C                         5 - failed to write to output file
C
C   Notes:
C      - If IRET is not zero on return then a message will have been
C        written to the AIPS message system.
C      - If EDROP < BDROP then there are no array indices in the
C        second block
C      - The first and second blocks of array indices do not overlap
C      - Bit field and selection flag columns are excluded from the
C        output file
C-----------------------------------------------------------------------
      CHARACTER OUTFIL*(*), COLLBL(*)*24
      INTEGER   COLTYP(*), COLDIM(*), NCOLS
      INTEGER   COLS(NCOLS), NCOUNT, BDROP, EDROP, IRET
C
C     Local variables:
C
C     COL       Column number
C     I         Array index
C     LASTIX    Last array index in block
C     HDRLEN    Cumulative length of output column headers
C     DATLEN    Cumulative width of output data columns
C
C     TABDTM    Special code for double-precision times
C     TABSTM    Special code for single-precision times
C
      INTEGER   COL, I, LASTIX, HDRLEN, DATLEN
C
      INTEGER   TABDTM, TABSTM
      PARAMETER (TABDTM = 11)
      PARAMETER (TABSTM = 12)
C
      INTEGER   ITRIM
      EXTERNAL  ITRIM
      CHARACTER ZSCHAR
      EXTERNAL  ZSCHAR
C
      INCLUDE 'INCS:PTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'FORMAT.INC'
C-----------------------------------------------------------------------
C
C     Calculate the number of output columns and their total width:
C
      NUMCOL = 0
      DATLEN = 0
      HDRLEN = 0
C
C     Invariant: NUMCOL is the number of output columns required for
C                the first COL input columns, HDRLEN is the sum of the
C                lengths of their titles and DATLEN is the sum of their
C                maximum data widths.
C
      DO 30 COL = 1, NCOLS
C
C        Ignore bit selection flags:
C
         IF (COLTYP(COLS(COL)).NE.TABSEL) THEN
            IF ((COLDIM(COLS(COL)).EQ.1)
     *          .OR. ((COLTYP(COLS(COL)).EQ.TABHOL)
     *                .AND. (COLDIM(COLS(COL)).GT.0))) THEN
C
C              Column has a scalar value and maps to a single output
C              column.
C
               NUMCOL = NUMCOL + 1
               HDRLEN = HDRLEN + ITRIM(COLLBL(COLS(COL)))
               IF (COLTYP(COLS(COL)).EQ.TABDBL) THEN
                  DATLEN = DATLEN + OFDPWD
               ELSE IF (COLTYP(COLS(COL)).EQ.TABFLT) THEN
                  DATLEN = DATLEN + OFSPWD
               ELSE IF (COLTYP(COLS(COL)).EQ.TABHOL) THEN
                  DATLEN = DATLEN + COLDIM(COLS(COL))
               ELSE IF (COLTYP(COLS(COL)).EQ.TABINT) THEN
                  DATLEN = DATLEN + OFINWD
               ELSE IF (COLTYP(COLS(COL)).EQ.TABLOG) THEN
                  DATLEN = DATLEN + OFLGWD
               ELSE IF (COLTYP(COLS(COL)).EQ.TABBIT) THEN
                  DATLEN = DATLEN + OFLGWD
               ELSE IF ((COLTYP(COLS(COL)).EQ.TABDTM)
     *                  .OR. (COLTYP(COLS(COL)).EQ.TABSTM)) THEN
                  DATLEN = DATLEN + OFTMWD
                  END IF
            ELSE IF (COLDIM(COLS(COL)).GT.1) THEN
C
C              Column has an array value and maps to multiple output
C              columns. That array index is added to the output column
C              headings.
C
C              First block of array indices:
C
               LASTIX = MIN (NCOUNT, COLDIM(COLS(COL)))
C
C              Invariant: NUMCOL is the total number of output columns
C                         required for input columns 1 to COL-1 and
C                         indices 1 to I of column COL; HDRLEN is the
C                         sum of the lengths of their titles and DATLEN
C                         is the sum of their maximum widths
C
               DO 10 I = 1, LASTIX
                  NUMCOL = NUMCOL + 1
                  HDRLEN = HDRLEN + ITRIM (COLLBL(COLS(COL)))
     *                     + INT (LOG10 (REAL (I))) + 1 + 2
C
C                 Length of index is int(log10(i)) + 1 plus 2 for the
C                 parentheses.
                  IF (COLTYP(COLS(COL)).EQ.TABDBL) THEN
                     DATLEN = DATLEN + OFDPWD
                  ELSE IF (COLTYP(COLS(COL)).EQ.TABFLT) THEN
                     DATLEN = DATLEN + OFSPWD
                  ELSE IF (COLTYP(COLS(COL)).EQ.TABHOL) THEN
                     DATLEN = DATLEN + COLDIM(COLS(COL))
                  ELSE IF (COLTYP(COLS(COL)).EQ.TABINT) THEN
                     DATLEN = DATLEN + OFINWD
                  ELSE IF (COLTYP(COLS(COL)).EQ.TABLOG) THEN
                     DATLEN = DATLEN + OFLGWD
                  ELSE IF (COLTYP(COLS(COL)).EQ.TABBIT) THEN
                     DATLEN = DATLEN + OFLGWD
                  ELSE IF ((COLTYP(COLS(COL)).EQ.TABDTM)
     *                     .OR. (COLTYP(COLS(COL)).EQ.TABSTM)) THEN
                     DATLEN = DATLEN + OFTMWD
                     END IF
   10             CONTINUE
C
C              Second block of array indices
C
               LASTIX = MIN (EDROP, COLDIM(COLS(COL)))
C
C              Invariant: NUMCOL is the total number of output columns
C                         required for input columns 1 to COL-1 and
C                         indices 1 to I of column COL; HDRLEN is the
C                         sum of the lengths of their titles and DATLEN
C                         is the sum of their maximum widths
C
               DO 20 I = MIN (BDROP, COLDIM(COLS(COL)) + 1), LASTIX
                  NUMCOL = NUMCOL + 1
                  HDRLEN = HDRLEN + ITRIM (COLLBL(COLS(COL)))
     *                     + INT (LOG10 (REAL (I))) +1 + 2
C
C                 Length of index is int(log10(i)) +1 plus 2 for the
C                 parentheses.
                  IF (COLTYP(COLS(COL)).EQ.TABDBL) THEN
                     DATLEN = DATLEN + OFDPWD
                  ELSE IF (COLTYP(COLS(COL)).EQ.TABFLT) THEN
                     DATLEN = DATLEN + OFSPWD
                  ELSE IF (COLTYP(COLS(COL)).EQ.TABHOL) THEN
                     DATLEN = DATLEN + COLDIM(COLS(COL))
                  ELSE IF (COLTYP(COLS(COL)).EQ.TABINT) THEN
                     DATLEN = DATLEN + OFINWD
                  ELSE IF (COLTYP(COLS(COL)).EQ.TABLOG) THEN
                     DATLEN = DATLEN + OFLGWD
                  ELSE IF (COLTYP(COLS(COL)).EQ.TABBIT) THEN
                     DATLEN = DATLEN + OFLGWD
                  ELSE IF ((COLTYP(COLS(COL)).EQ.TABDTM)
     *                     .OR. (COLTYP(COLS(COL)).EQ.TABSTM)) THEN
                     DATLEN = DATLEN + OFTMWD
                     END IF
   20             CONTINUE
               END IF
         ELSE
            WRITE (MSGTXT, 1020) COLS(COL)
            CALL MSGWRT (5)
            END IF
   30    CONTINUE
C
C     DATLEN and HDRLEN do not include the separator characters.
C
      IF (((HDRLEN + NUMCOL - 1).LE.BUFLEN)
     *    .AND. ((DATLEN + NUMCOL - 1).LE.BUFLEN)) THEN
C
C        Titles and data will fit in the output buffer.
C
C        Set the separator character:
C
         CALL OFSTSP (ZSCHAR ('tab'))
C
C        Open the output file:
C
         CALL ZTXOPN ('WRIT', OFLUN, OFFIND, OUTFIL, .FALSE., IRET)
         IF (IRET.EQ.0) THEN
C
C           Write the column titles:
C
            CALL OFTITL (NCOLS, COLS, NCOUNT, BDROP, EDROP, COLLBL,
     *                   COLTYP, COLDIM, IRET)
            IF (IRET.NE.0) THEN
               IRET = 5
               END IF
         ELSE IF (IRET.EQ.4) THEN
            WRITE (MSGTXT, 9030)
            CALL MSGWRT (8)
            IRET = 2
         ELSE IF (IRET.EQ.5) THEN
            WRITE (MSGTXT, 9031)
            CALL MSGWRT (8)
            IRET = 3
         ELSE
            WRITE (MSGTXT, 9032) IRET
            CALL MSGWRT (8)
            IRET = 4
            END IF
      ELSE
         WRITE (MSGTXT, 9033)
         CALL MSGWRT (8)
         WRITE (MSGTXT, 9034)
         CALL MSGWRT (8)
         IRET = 1
         END IF
C-----------------------------------------------------------------------
 1020 FORMAT ('WARNING: ignoring selection flag column ', I6)
 9030 FORMAT ('COULD NOT TRANSLATE LOGICAL AREA NAME FOR OUTPUT FILE')
 9031 FORMAT ('I WILL NOT OVERWRITE AN EXISTING FILE')
 9032 FORMAT ('ERROR ', I4, ' OPENING OUTPUT FILE')
 9033 FORMAT ('OUTPUT ROWS WILL NOT FIT ON A SINGLE LINE')
 9034 FORMAT ('SELECT FEWER TABLE COLUMNS')
      END
      SUBROUTINE OFTITL (NCOLS, COLS, NCOUNT, BDROP, EDROP, COLLBL,
     *                   COLTYP, COLDIM, IRET)
C-----------------------------------------------------------------------
C   Write column titles to output file. Should only be called from
C   OFINIT after establishing that the output buffer can hold the
C   titles.
C
C   Inputs:
C      NCOLS    I         Number of requested columns; greater than or
C                         equal to zero.
C      COLS     I(NCOLS)  List of requested columns: each entry must
C                         be the index of defined entries in COLLBL,
C                         COLTYP, and COLDIM
C      NCOUNT   I         Number of array indices in first block;
C                         greater than or equal to 1
C      BDROP    I         First index in second block; greater than
C                         NCOUNT
C      EDROP    I         Last index in second block
C      COLLBL   C(*)*24   Column labels
C      COLTYP   I(*)      Column type codes:
C                          1 - double-precision
C                          2 - single-precision
C                          3 - character string
C                          4 - integer
C                          5 - logical
C                          7 - bit field
C                          9 - select flag
C                         11 - double-precision time
C                         12 - single-precision time
C      COLDIM  I(*)       Column dimensions
C
C   Output:
C      IRET    I          Status:
C                         0 - titles written
C                         1 - failed to write to output file and
C                             wrote error message
C-----------------------------------------------------------------------
      INTEGER   NCOLS
      INTEGER   COLS(NCOLS), NCOUNT, BDROP, EDROP
      CHARACTER COLLBL(*)*24
      INTEGER   COLTYP(*), COLDIM(*), IRET
C
C     Local variables:
C
C     COL       Input column
C     I         Array index
C     LASTIX    Last array index in current block
C     TITLE     Current column title, less index
C     TLEN      Number of characters in TITLE (without trailing spaces)
C     NUM       Formatted array index
C     NUMLEN    Length of formatted array index
C
      INTEGER   COL, I, LASTIX
      CHARACTER TITLE*24
      INTEGER   TLEN
      CHARACTER NUM*20
      INTEGER   NUMLEN
C
      INTEGER   ITRIM
      EXTERNAL  ITRIM
C
      INCLUDE 'INCS:PTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'FORMAT.INC'
C-----------------------------------------------------------------------
      OFPOS = 0
C
C     Invariant: the output buffer contains the titles for the output
C                columns corresponding to input columns 1 to COL
C
      DO 30 COL = 1, NCOLS
         TITLE = COLLBL (COLS(COL))
         TLEN = ITRIM (TITLE)
         IF (COLTYP(COLS(COL)).NE.TABSEL) THEN
            IF ((COLDIM(COLS(COL)).EQ.1)
     *          .OR. ((COLTYP(COLS(COL)).EQ.TABHOL)
     *                .AND. (COLDIM(COLS(COL)).GT.0))) THEN
C
C              Column has a scalar value and maps to a single output
C              column.
C
               IF (OFPOS.GT.0) THEN
C
C                 A separator is needed.
C
                  OFPOS = OFPOS + 1
                  OFBUFF(OFPOS:OFPOS) = OFSEP
                  END IF
               OFBUFF(OFPOS+1:OFPOS+TLEN) = TITLE(1:TLEN)
               OFPOS = OFPOS + TLEN
            ELSE IF (COLDIM(COLS(COL)).GT.1) THEN
C
C              Column maps to several output columns.
C
               LASTIX = MIN (NCOUNT, COLDIM(COLS(COL)))
C
C              Invariant: OFBUF contains separated titles for the output
C                         columns corresponding to table columns
C                         COLS(1:COL-1) plus array indices 1:I of
C                         table column COL.
C
               DO 10 I = 1, LASTIX
                  IF (OFPOS.GT.0) THEN
C
C                    A separator is needed.
C
                     OFPOS = OFPOS + 1
                     OFBUFF(OFPOS:OFPOS) = OFSEP
                     END IF
                  OFBUFF(OFPOS+1:OFPOS+TLEN) = TITLE(1:TLEN)
                  OFPOS = OFPOS + TLEN
                  OFBUFF(OFPOS+1:OFPOS+1) = '('
                  OFPOS = OFPOS + 1
                  WRITE (NUM, 1000) I
                  CALL CHTRIM (NUM, LEN(NUM), NUM, NUMLEN)
                  OFBUFF(OFPOS+1:OFPOS+NUMLEN) = NUM(1:NUMLEN)
                  OFPOS = OFPOS + NUMLEN
                  OFBUFF(OFPOS+1:OFPOS+1) = ')'
                  OFPOS = OFPOS + 1
   10             CONTINUE
C
               LASTIX = MIN (EDROP, COLDIM(COLS(COL)))
C
C              Invariant: OFBUF contains separated titles for the output
C                         columns corresponding to table columns
C                         COLS(1:COL-1) plus array indices 1:I and
C                         MIN(COLDIM(COLS(COL))+1, BDROP):I of
C                         table column COL.
C
               DO 20 I = MIN (BDROP, COLDIM(COLS(COL)) + 1), LASTIX
                  IF (OFPOS.GT.0) THEN
C
C                    A separator is needed.
C
                     OFPOS = OFPOS + 1
                     OFBUFF(OFPOS:OFPOS) = OFSEP
                     END IF
                  OFBUFF(OFPOS+1:OFPOS+TLEN) = TITLE(1:TLEN)
                  OFPOS = OFPOS + TLEN
                  OFBUFF(OFPOS+1:OFPOS+1) = '('
                  OFPOS = OFPOS + 1
                  WRITE (NUM, 1000) I
                  CALL CHTRIM (NUM, LEN(NUM), NUM, NUMLEN)
                  OFBUFF(OFPOS+1:OFPOS+NUMLEN) = NUM(1:NUMLEN)
                  OFPOS = OFPOS + NUMLEN
                  OFBUFF(OFPOS+1:OFPOS+1) = ')'
                  OFPOS = OFPOS + 1
   20             CONTINUE
               END IF
            END IF
   30    CONTINUE
C
C     Write titles to file:
C
      CALL ZTXIO ('WRIT', OFLUN, OFFIND, OFBUFF(1:OFPOS), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT, 9030) IRET
         CALL MSGWRT (8)
         IRET = 1
         END IF
C-----------------------------------------------------------------------
 1000 FORMAT (I20)
 9030 FORMAT ('ERROR ', I5, ' WRITING COLUMN TITLES TO OUTPUT FILE')
      END
      SUBROUTINE OFFINI (IRET)
C-----------------------------------------------------------------------
C   Close the output file.
C
C   Output:
C      IRET     I        Status
C                        0 - new row started
C                        1 - failed to close output file and generated
C                            an error message.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'FORMAT.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL ZTXCLS (OFLUN, OFFIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT, 9000) IRET
         CALL MSGWRT (8)
         WRITE (MSGTXT, 9001)
         CALL MSGWRT (8)
         IRET = 1
         END IF
C-----------------------------------------------------------------------
 9000 FORMAT ('ERROR ', I4, ' CLOSING OUTPUT FILE')
 9001 FORMAT ('SOME DATA MAY HAVE BEEN LOST')
      END
      SUBROUTINE OFSTSP (NEWSEP)
C-----------------------------------------------------------------------
C   Set the separator character used in the output file.
C
C   Input
C      NEWSEP   C*1      New separator character
C-----------------------------------------------------------------------
      CHARACTER NEWSEP
C
      INCLUDE 'FORMAT.INC'
C-----------------------------------------------------------------------
      OFSEP = NEWSEP
      END
      SUBROUTINE OFSROW (IRET)
C-----------------------------------------------------------------------
C   Start a new output row. OFINIT must have been called.
C
C   Output:
C      IRET     I        Status
C                        0 - new row started
C                        1 - failed to write output file and generated
C                            an error message.
C
C   Notes:
C      - If you are adapting EXTAB to generate a new output format,
C        then this is the place to perform and tasks that need to be
C        be done at the start of a new row.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'FORMAT.INC'
C-----------------------------------------------------------------------
C
C     Position output pointer at the start of the output buffer:
C
      OFPOS = 0
      IRET = 0
      END
      SUBROUTINE OFFROW (IRET)
C-----------------------------------------------------------------------
C   Finish an output row. This ensures that the row is written to the
C   output file unless it is empty, in which case it will be discarded
C
C   Output:
C      IRET     I        Status
C                        0 - new row started
C                        1 - failed to write to output file and
C                            generated an error message.
C
C   Notes:
C      - If you are adapting EXTAB to generate a new output format,
C        then this is the place to perform and tasks that need to be
C        be done at the end of a row of output.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'FORMAT.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (OFPOS.GT.0) THEN
         CALL ZTXIO ('WRIT', OFLUN, OFFIND, OFBUFF(1:OFPOS), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT, 9000) IRET
            CALL MSGWRT (8)
            IRET = 1
            END IF
      ELSE
         IRET = 0
         END IF
C-----------------------------------------------------------------------
 9000 FORMAT ('ERROR ', I4, ' WRITING A ROW TO THE OUTPUT FILE')
      END
      SUBROUTINE OFWRDP (VALUE, DIM, NCOUNT, BDROP, EDROP, IRET)
C-----------------------------------------------------------------------
C   Write out elements 1:MIN(NCOUNT, DIM) and
C   MIN(BDROP, DIM+1):MIN(EDROP, DIM) of double-precision array VALUE.
C
C   Inputs:
C      VALUE   D(DIM)    Value of double-precision column
C      DIM     I         Dimension of column value; greater than or
C                        equal to zero
C      NCOUNT  I         Number of array indices in first block;
C                        greater than or equal to zero
C      BDROP   I         First array index in second block; greater
C                        than NCOUNT
C      EDROP   I         Last array index in second block
C
C   Output:
C      IRET     I        Status
C                        0 - values written
C                        1 - failed to write to output file and
C                            generated an error message.
C-----------------------------------------------------------------------
      INTEGER   DIM
      DOUBLE PRECISION VALUE(DIM)
      INTEGER   NCOUNT, BDROP, EDROP, IRET
C
C     Local variables:
C
C     I         Array index
C     LAST      Last index in block
C
      INTEGER   I, LAST
C
      INCLUDE 'FORMAT.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C
C     Write first block:
C
      LAST = MIN (DIM, NCOUNT)
C
C     Invariant: array elements 1:I have been written out
C
      DO 10 I = 1, LAST
         IF (OFPOS.GT.0) THEN
C
C           A separator is needed.
C
            OFBUFF(OFPOS+1:OFPOS+1) = OFSEP
            OFPOS = OFPOS + 1
            END IF
         IF (VALUE(I).EQ.DBLANK) THEN
            OFBUFF(OFPOS+1:OFPOS+10) = 'indefinite'
            OFPOS = OFPOS + 10
         ELSE
            WRITE (OFBUFF(OFPOS+1:OFPOS+OFDPWD), 1000) VALUE(I)
            OFPOS = OFPOS + OFDPWD
            END IF
   10    CONTINUE
C
C     Write second block:
C
      LAST = MIN (DIM, EDROP)
C
C     Invariant: array elements MIN(BDROP, DIM+1):I have been written out
C
      DO 20 I = MIN(BDROP, DIM+1), LAST
         IF (OFPOS.GT.0) THEN
C
C           A separator is needed.
C
            OFBUFF(OFPOS+1:OFPOS+1) = OFSEP
            OFPOS = OFPOS + 1
            END IF
         IF (VALUE(I).EQ.DBLANK) THEN
            OFBUFF(OFPOS+1:OFPOS+10) = 'indefinite'
            OFPOS = OFPOS + 10
         ELSE
            WRITE (OFBUFF(OFPOS+1:OFPOS+OFDPWD), 1000) VALUE(I)
            OFPOS = OFPOS + OFDPWD
            END IF
   20    CONTINUE
C
      IRET = 0
C-----------------------------------------------------------------------
 1000 FORMAT (E25.17)
      END
      SUBROUTINE OFWRSP (VALUE, DIM, NCOUNT, BDROP, EDROP, IRET)
C-----------------------------------------------------------------------
C   Write out elements 1:MIN(NCOUNT, DIM) and
C   MIN(BDROP, DIM+1):MIN(EDROP, DIM) of single-precision array VALUE.
C
C   Inputs:
C      VALUE   R(DIM)    Value of double-precision column
C      DIM     I         Dimension of column value; greater than or
C                        equal to zero
C      NCOUNT  I         Number of array indices in first block;
C                        greater than or equal to zero
C      BDROP   I         First array index in second block; greater
C                        than NCOUNT
C      EDROP   I         Last array index in second block
C
C   Output:
C      IRET     I        Status
C                        0 - values written
C                        1 - failed to write to output file and
C                            generated an error message.
C-----------------------------------------------------------------------
      INTEGER   DIM
      REAL      VALUE(DIM)
      INTEGER   NCOUNT, BDROP, EDROP, IRET
C
C     Local variables:
C
C     I         Array index
C     LAST      Last index in block
C
      INTEGER   I, LAST
C
      INCLUDE 'FORMAT.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C
C     Write first block:
C
      LAST = MIN (DIM, NCOUNT)
C
C     Invariant: array elements 1:I have been written out
C
      DO 10 I = 1, LAST
         IF (OFPOS.GT.0) THEN
C
C           A separator is needed.
C
            OFBUFF(OFPOS+1:OFPOS+1) = OFSEP
            OFPOS = OFPOS + 1
            END IF
         IF (VALUE(I).EQ.FBLANK) THEN
            OFBUFF(OFPOS+1:OFPOS+10) = 'indefinite'
            OFPOS = OFPOS + 10
         ELSE
            WRITE (OFBUFF(OFPOS+1:OFPOS+OFSPWD), 1000) VALUE(I)
            OFPOS = OFPOS + OFSPWD
            END IF
   10    CONTINUE
C
C     Write second block:
C
      LAST = MIN (DIM, EDROP)
C
C     Invariant: array elements MIN(BDROP, DIM+1):I have been written
C                out
C
      DO 20 I = MIN(BDROP, DIM+1), LAST
         IF (OFPOS.GT.0) THEN
C
C           A separator is needed.
C
            OFBUFF(OFPOS+1:OFPOS+1) = OFSEP
            OFPOS = OFPOS + 1
            END IF
         IF (VALUE(I).EQ.FBLANK) THEN
            OFBUFF(OFPOS+1:OFPOS+10) = 'indefinite'
            OFPOS = OFPOS + 10
         ELSE
            WRITE (OFBUFF(OFPOS+1:OFPOS+OFSPWD), 1000) VALUE(I)
            OFPOS = OFPOS + OFSPWD
            END IF
   20    CONTINUE
C
      IRET = 0
C-----------------------------------------------------------------------
 1000 FORMAT (E25.17)
      END
      SUBROUTINE OFWRST (VALUE, DIM, IRET)
C-----------------------------------------------------------------------
C   Write character string VALUE to the output file provided that
C   DIM > 0.
C
C   Inputs
C      VALUE    C*(*)   Character string
C      DIM      I       Length of character string
C
C   Output:
C      IRET     I        Status
C                        0 - values written
C                        1 - failed to write to output file and
C                            generated an error message.
C-----------------------------------------------------------------------
      CHARACTER VALUE*(*)
      INTEGER   DIM, IRET
C
      INCLUDE 'FORMAT.INC'
C-----------------------------------------------------------------------
      IF (DIM.GT.0) THEN
         IF (OFPOS.GT.0) THEN
C
C           A separator is needed.
C
            OFBUFF(OFPOS+1:OFPOS+1) = OFSEP
            OFPOS = OFPOS + 1
            END IF
         OFBUFF(OFPOS+1:OFPOS+DIM) = VALUE(1:DIM)
         OFPOS = OFPOS + DIM
         END IF
C
      IRET = 0
C
      END
      SUBROUTINE OFWRIN (VALUE, DIM, NCOUNT, BDROP, EDROP, IRET)
C-----------------------------------------------------------------------
C   Write out elements 1:MIN(NCOUNT, DIM) and
C   MIN(BDROP, DIM+1):MIN(EDROP, DIM) of integer array VALUE.
C
C   Inputs:
C      VALUE   I(DIM)    Value of double-precision column
C      DIM     I         Dimension of column value; greater than or
C                        equal to zero
C      NCOUNT  I         Number of array indices in first block;
C                        greater than or equal to zero
C      BDROP   I         First array index in second block; greater
C                        than NCOUNT
C      EDROP   I         Last array index in second block
C
C   Output:
C      IRET     I        Status
C                        0 - values written
C                        1 - failed to write to output file and
C                            generated an error message.
C-----------------------------------------------------------------------
      INTEGER   DIM
      INTEGER   VALUE(DIM)
      INTEGER   NCOUNT, BDROP, EDROP, IRET
C
C     Local variables:
C
C     I         Array index
C     LAST      Last index in block
C
      INTEGER   I, LAST
C
      INCLUDE 'FORMAT.INC'
C-----------------------------------------------------------------------
C
C     Write first block:
C
      LAST = MIN (DIM, NCOUNT)
C
C     Invariant: array elements 1:I have been written out
C
      DO 10 I = 1, LAST
         IF (OFPOS.GT.0) THEN
C
C           A separator is needed.
C
            OFBUFF(OFPOS+1:OFPOS+1) = OFSEP
            OFPOS = OFPOS + 1
            END IF
         WRITE (OFBUFF(OFPOS+1:OFPOS+OFINWD), 1000) VALUE(I)
         OFPOS = OFPOS + OFINWD
   10    CONTINUE
C
C     Write second block:
C
      LAST = MIN (DIM, EDROP)
C
C     Invariant: array elements MIN(BDROP, DIM+1):I have been written
C                out
C
      DO 20 I = MIN(BDROP, DIM+1), LAST
         IF (OFPOS.GT.0) THEN
C
C           A separator is needed.
C
            OFBUFF(OFPOS+1:OFPOS+1) = OFSEP
            OFPOS = OFPOS + 1
            END IF
         WRITE (OFBUFF(OFPOS+1:OFPOS+OFINWD), 1000) VALUE(I)
         OFPOS = OFPOS + OFINWD
   20    CONTINUE
C
      IRET = 0
C-----------------------------------------------------------------------
 1000 FORMAT (I20)
      END
      SUBROUTINE OFWRLG (VALUE, DIM, NCOUNT, BDROP, EDROP, IRET)
C-----------------------------------------------------------------------
C   Write out elements 1:MIN(NCOUNT, DIM) and
C   MIN(BDROP, DIM+1):MIN(EDROP, DIM) of logical array VALUE.
C
C   Inputs:
C      VALUE   L(DIM)    Value of double-precision column
C      DIM     I         Dimension of column value; greater than or
C                        equal to zero
C      NCOUNT  I         Number of array indices in first block;
C                        greater than or equal to zero
C      BDROP   I         First array index in second block; greater
C                        than NCOUNT
C      EDROP   I         Last array index in second block
C
C   Output:
C      IRET     I        Status
C                        0 - values written
C                        1 - failed to write to output file and
C                            generated an error message.
C-----------------------------------------------------------------------
      INTEGER   DIM
      LOGICAL   VALUE(DIM)
      INTEGER   NCOUNT, BDROP, EDROP, IRET
C
C     Local variables:
C
C     I         Array index
C     LAST      Last index in block
C
      INTEGER   I, LAST
C
      INCLUDE 'FORMAT.INC'
C-----------------------------------------------------------------------
C
C     Write first block:
C
      LAST = MIN (DIM, NCOUNT)
C
C     Invariant: array elements 1:I have been written out
C
      DO 10 I = 1, LAST
         IF (OFPOS.GT.0) THEN
C
C           A separator is needed.
C
            OFBUFF(OFPOS+1:OFPOS+1) = OFSEP
            OFPOS = OFPOS + 1
            END IF
         IF (VALUE(I)) THEN
            OFBUFF(OFPOS+1:OFPOS+4) = 'true'
            OFPOS = OFPOS + 4
         ELSE
            OFBUFF(OFPOS+1:OFPOS+5) = 'false'
            OFPOS = OFPOS + 5
            END IF
   10    CONTINUE
C
C     Write second block:
C
      LAST = MIN (DIM, EDROP)
C
C     Invariant: array elements MIN(BDROP, DIM+1):I have been written
C                out
C
      DO 20 I = MIN(BDROP, DIM+1), LAST
         IF (OFPOS.GT.0) THEN
C
C           A separator is needed.
C
            OFBUFF(OFPOS+1:OFPOS+1) = OFSEP
            OFPOS = OFPOS + 1
            END IF
         IF (VALUE(I)) THEN
            OFBUFF(OFPOS+1:OFPOS+4) = 'true'
            OFPOS = OFPOS + 4
         ELSE
            OFBUFF(OFPOS+1:OFPOS+5) = 'false'
            OFPOS = OFPOS + 5
            END IF
   20    CONTINUE
C
      IRET = 0
C
      END
      SUBROUTINE OFWRTM (VALUE, DIM, NCOUNT, BDROP, EDROP, IRET)
C-----------------------------------------------------------------------
C   Write out elements 1:MIN(NCOUNT, DIM) and
C   MIN(BDROP, DIM+1):MIN(EDROP, DIM) of double-precision array VALUE as
C   times.
C
C   Inputs:
C      VALUE    D(DIM)   Value of double-precision column
C      DIM      I        Dimension of column value; greater than or
C                        equal to zero
C      NCOUNT   I        Number of array indices in first block;
C                        greater than or equal to zero
C      BDROP    I        First array index in second block; greater
C                        than NCOUNT
C      EDROP    I        Last array index in second block
C
C   Output:
C      IRET     I        Status
C                        0 - values written
C                        1 - failed to write to output file and
C                            generated an error message.
C-----------------------------------------------------------------------
      INTEGER   DIM
      DOUBLE PRECISION VALUE(DIM)
      INTEGER   NCOUNT, BDROP, EDROP, IRET
C
C     Local variables:
C
C     I         Array index
C     LAST      Last index in block
C     D         Day number
C     H         Hour number
C     M         Minute number
C     S         Seconds
C
      INTEGER   I, LAST, D, H, M, J
      DOUBLE PRECISION S
C
      INCLUDE 'FORMAT.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C
C     Write first block:
C
      LAST = MIN (DIM, NCOUNT)
C
C     Invariant: array elements 1:I have been written out
C
      DO 10 I = 1, LAST
         IF (OFPOS.GT.0) THEN
C
C           A separator is needed.
C
            OFBUFF(OFPOS+1:OFPOS+1) = OFSEP
            OFPOS = OFPOS + 1
            END IF
         IF (VALUE(I).EQ.DBLANK) THEN
            OFBUFF(OFPOS+1:OFPOS+10) = 'indefinite'
            OFPOS = OFPOS + 10
         ELSE
            S = VALUE(I)
            D = INT (S)
            S = 24.0D0 * (S - D)
            H = INT (S)
            S = 60.0D0 * (S - H)
            M = INT (S)
            S = 60.0D0 * (S - M)
            WRITE (OFBUFF(OFPOS+1:OFPOS+OFTMWD), 1000) D, H, M, S
            J = OFPOS + 11
            IF (OFBUFF(J:J).EQ.' ') OFBUFF(J:J) = '0'
            OFPOS = OFPOS + OFTMWD
            END IF
   10    CONTINUE
C
C     Write second block:
C
      LAST = MIN (DIM, EDROP)
C
C     Invariant: array elements MIN(BDROP, DIM+1):I have been written
C                out
C
      DO 20 I = MIN(BDROP, DIM+1), LAST
         IF (OFPOS.GT.0) THEN
C
C           A separator is needed.
C
            OFBUFF(OFPOS+1:OFPOS+1) = OFSEP
            OFPOS = OFPOS + 1
            END IF
         IF (VALUE(I).EQ.DBLANK) THEN
            OFBUFF(OFPOS+1:OFPOS+10) = 'indefinite'
            OFPOS = OFPOS + 10
         ELSE
            S = VALUE(I)
            D = INT (S)
            S = 24.0D0 * (S - D)
            H = INT (S)
            S = 60.0D0 * (S - H)
            M = INT (S)
            S = 60.0D0 * (S - M)
            WRITE (OFBUFF(OFPOS+1:OFPOS+OFTMWD), 1000) D, H, M, S
            J = OFPOS + 11
            IF (OFBUFF(J:J).EQ.' ') OFBUFF(J:J) = '0'
            OFPOS = OFPOS + OFTMWD
            END IF
 20      CONTINUE
C
      IRET = 0
C-----------------------------------------------------------------------
 1000 FORMAT (I3.3,'/',I2.2,':',I2.2,':',F4.1)
      END

      SUBROUTINE FILCOP (TYPE, INVER, OUTVER, LUNOLD, LUNNEW, VOLOLD,
     *   VOLNEW, CNOOLD, CNONEW, CATNEW, BUFF1, BUFF2, IRET)
C-----------------------------------------------------------------------
C! copies one or all extension files of specified type
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FILCOP copies extension file(s) of any type.  The output file must
C   be a new extension - old ones cannot be rewritten.  The output file
C   must be opened WRIT in the catalog and will have its CATBLK updated
C   on disk.
C   Inputs:
C      TYPE     C*2     Extension file type (e.g. 'CC','AN')
C      INVER    I       Version number to copy, 0 => copy all.
C      OUTVER   I       Version number on output file, if more than one
C                       copied (INVER=0) this will be the number of the
C                       first file.  If OUTVER = 0, it will be taken as
C                       1 higher than the previous highest version.
C      LUNOLD   I       LUN for old file
C      LUNNEW   I       LUN for new file
C      VOLOLD   I       Disk number for old file.
C      VOLNEW   I       Disk number for new file.
C      CNOOLD   I       Catalog slot number for old file
C      CNONEW   I       Catalog slot number for new file
C   In/out:
C      CATNEW   I(256)  Catalog header for new file.
C   Output:
C      BUFF1    I(256)  Work buffer
C      BUFF2    I(256)  Work buffer
C      IRET     I       Return error code  0 => ok
C                          1 => files the same, no copy.
C                          2 => no input files exist
C                          3 => failed
C                          4 => no output files created.
C                          5 => failed to update CATNEW
C                          6 => output file exists
C   Inputs from MSG common:
C      MSGSUP   I       If 31990 < MSGSUP < 32000, the file copied
C                       message is suppressed.
C-----------------------------------------------------------------------
      INTEGER   INVER, OUTVER, LUNOLD, LUNNEW, VOLOLD, VOLNEW, CNOOLD,
     *   CNONEW, BUFF1(256), BUFF2(256), CATNEW(256), IRET
      CHARACTER TYPE*2
C
      CHARACTER PHNAME*48, ERRTYP(6)*4, CHTEMP*2
      INTEGER   FINDO, FINDN, COUNT, IVERI, IVERO, OVO, OVN, I, J, II,
     *   LIM, IER, LER, LTYE, NTYE, JERR, IRNO, ISIZE, LSIZE
      LOGICAL   T, F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA ERRTYP /' OLD',' NEW','OPEN','READ','WRIT','CREA'/
C-----------------------------------------------------------------------
C                                       Set initial version numbers.
      COUNT = 0
      IVERI = MAX (1, INVER)
      IVERO = OUTVER
C                                       Check if files the same
      IRET = 1
      IF ((VOLOLD.EQ.VOLNEW) .AND. (CNOOLD.EQ.CNONEW) .AND.
     *   (INVER.EQ.OUTVER)) GO TO 999
C                                       See if new file exists
      IRET = 6
      CALL ZPHFIL (TYPE, VOLNEW, CNONEW, OUTVER, PHNAME, JERR)
      CALL ZEXIST (VOLNEW, PHNAME, ISIZE, JERR)
      IF (JERR.NE.1) GO TO 999
C                                       Get old CATBLK in BUFF2.
      IRET = 3
      CALL CATIO ('READ', VOLOLD, CNOOLD, BUFF2, 'REST', BUFF1, IER)
      IF ((IER.LE.0) .OR. (IER.GE.5)) GO TO 10
         WRITE (MSGTXT,1010) IER
         CALL MSGWRT (6)
         GO TO 999
C                                       Find # TYPE ext. files.
 10   OVO = 0
      OVN = 0
      J = 0
      CALL FXHDEX (BUFF2)
      CALL FXHDEX (CATNEW)
      DO 20 I = 1,KIEXTN
         II = KHEXT + I - 1
         CALL H2CHR (2, 1, BUFF2(II), CHTEMP)
         IF (TYPE.EQ.CHTEMP) OVO = I
         CALL H2CHR (2, 1, CATNEW(II), CHTEMP)
         IF (TYPE.EQ.CHTEMP) OVN = I
         IF ((CHTEMP.EQ.' ') .AND. (J.LE.0)) J = I
 20      CONTINUE
C                                       Old table files exist?
      IRET = 2
      IF (OVO.LE.0) GO TO 999
      LIM = BUFF2(KIVER+OVO-1)
      IF (LIM.LE.0) GO TO 999
      IF (INVER.GT.0) LIM = 1
C                                       No room to catalog new type
      IF ((J.GT.0) .OR. (OVN.GT.0)) GO TO 25
         WRITE (MSGTXT,1020)
         CALL MSGWRT (6)
         IRET = 3
         GO TO 999
C                                       Add ext. type to catalog
 25   IF (OVN.GT.0) GO TO 30
         OVN = J
         CALL CHR2H (2, TYPE, 1, CATNEW(KHEXT+OVN-1))
         CATNEW(KIVER+OVN-1) = 0
C                                       Default output version
 30   IF (IVERO.LE.0) IVERO = CATNEW(KIVER+OVN-1) + 1
C                                       Loop copying files.
      DO 100 J = 1,LIM
         FINDN = 0
C                                       Open input file
         CALL ZPHFIL (TYPE, VOLOLD, CNOOLD, IVERI, PHNAME, IER)
         CALL ZEXIST (VOLOLD, PHNAME, ISIZE, IER)
         CALL ZOPEN (LUNOLD, FINDO, VOLOLD, PHNAME, F, F, T, IER)
         LTYE = 1
         NTYE = 3
         IF (IER.NE.0) GO TO 90
C                                       create output file
         CALL ZPHFIL (TYPE, VOLNEW, CNONEW, IVERO, PHNAME, IER)
         CALL ZCREAT (VOLNEW, PHNAME, ISIZE, F, LSIZE, IER)
         LTYE = 2
         NTYE = 6
         IF (IER.NE.0) GO TO 85
C                                       Open output file
         CALL ZOPEN (LUNNEW, FINDN, VOLNEW, PHNAME, F, T, T, IER)
         NTYE = 3
         IF (IER.NE.0) FINDN = 0
         IF (IER.NE.0) GO TO 80
C                                       Write/read loop
         DO 40 IRNO = 1,ISIZE
            CALL ZFIO ('READ', LUNOLD, FINDO, IRNO, BUFF1, IER)
            LTYE = 1
            NTYE = 4
            IF (IER.NE.0) GO TO 80
            CALL ZFIO ('WRIT', LUNNEW, FINDN, IRNO, BUFF1, IER)
            LTYE = 2
            NTYE = 5
            IF (IER.NE.0) GO TO 80
 40         CONTINUE
         COUNT = COUNT + 1
         IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
            WRITE (MSGTXT,1050) TYPE, VOLOLD, CNOOLD, IVERI, VOLNEW,
     *         CNONEW, IVERO
            CALL MSGWRT (3)
            END IF
         GO TO 85
C                                       Error: destroy output
 80      IF (FINDN.GT.0) CALL ZCLOSE (LUNNEW, FINDN, LER)
         CALL ZDESTR (VOLNEW, PHNAME, LER)
         FINDN = 0
C                                       Close files
 85      CALL ZCLOSE (LUNOLD, FINDO, LER)
         IF (FINDN.GT.0) CALL ZCLOSE (LUNNEW, FINDN, LER)
C                                       Report error
 90      IF (IER.GT.0) THEN
            WRITE (MSGTXT,1090) IER, ERRTYP(NTYE), ERRTYP(LTYE), TYPE,
     *         IVERI, IVERO
            CALL MSGWRT (6)
            END IF
         I = KIVER + OVN - 1
         CATNEW(I) = MAX (IVERO, CATNEW(I))
         IVERI = IVERI + 1
         IVERO = IVERO + 1
 100     CONTINUE
      IRET = 0
      CALL CATIO ('UPDT', VOLNEW, CNONEW, CATNEW, 'REST', BUFF1, IER)
      IF (IER.NE.0) IRET = 5
      IF (COUNT.EQ.0) IRET = 4
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('FILCOP: ERROR',I5,' READING OLD CATBLK')
 1020 FORMAT ('FILCOP: NO ROOM IN NEW CATBLK FOR NEW EXTENSION TYPE')
 1050 FORMAT ('Copied ',A2,' file from vol/cno/vers',I3,I5,I4,' to',
     *   I3,I5,I4)
 1090 FORMAT ('FILCOP: ERROR',I5,1X,A4,'ING',A4,1X,A2,' FILE VERS',
     *   I4,' TO',I4)
      END

      SUBROUTINE SETGRD (SCRGRD, SCRWRK, BUFFER, IRET)
C-----------------------------------------------------------------------
C! Sets up for gridding uv data.
C# UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SETGRD sets up for the gridding routines, mostly creates scratch
C   files.
C   Inputs from common:
C      MFIELD   I        The number of fields which are going to to be
C                        imaged (excluding any beam). MUST be filled in
C      DO3DIM   L        If true, doing MFIELD beams, else 1 beam
C      FLDSZ    I(2,*)   Dimension of map in RA, Dec (cells) of each
C                        field.  MUST be completely filled in
C                        if files currently do not exist or zeroed
C                        or filled in if they do.
C      NXBEM    I(*)     X dimension of Beam(s)
C      NYBEM    I(*)     Y dimension (cells) of beam(s)
C      CCDISK   I(*)     Disk numbers of the output images.
C                        Must be filled in or zeroed.
C      CCCNO    I(*)     Catalog slot numbers of output images.
C                        Must be filled in or zeroed.
C   Input/Output:
C      SCRGRD   I        /CFILES/ file number for grid file.
C      SCRWRK   I        /CFILES/ file number for work file
C   Output:
C      BUFFER   I(512)   Work buffer.
C      IRET     I        Return code, 0=>OK, otherwise failed.
C-----------------------------------------------------------------------
      INTEGER   SCRGRD, SCRWRK, BUFFER(512), IRET
C
      INTEGER   MX, MY, NP(5), NCVSIZ, IFIELD, SIZE, II
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMPR.INC'
C-----------------------------------------------------------------------
C                                       Setup.
      NCVSIZ = 10
C                                       Find largest input file.
      MX = 1
      MY = 1
      DO 10 IFIELD = 1,MFIELD
         IRET = 3
         IF ((CCDISK(IFIELD).GT.0) .AND. (CCCNO(IFIELD).GT.0))
     *      CALL CATIO ('READ', CCDISK(IFIELD), CCCNO(IFIELD), BUFFER,
     *         'REST', BUFFER(257), IRET)
         IF (IRET.NE.3) THEN
            MX = MAX (MX, BUFFER(KINAX))
            MY = MAX (MY, BUFFER(KINAX+1))
C                                       If not there use FLDSIZ
         ELSE
            MX = MAX (MX, FLDSZ(1,IFIELD))
            MY = MAX (MY, FLDSZ(1,IFIELD))
            IRET = 0
            END IF
         IF ((IRET.NE.0) .AND. (IRET.LT.5)) THEN
            WRITE (MSGTXT,1000) IRET, IFIELD
            GO TO 990
            END IF
         IF ((IFIELD.EQ.1) .OR. (DO3DIM)) THEN
            MX = MAX (MX, NXBEM(IFIELD))
            MY = MAX (MY, NYBEM(IFIELD))
            END IF
 10      CONTINUE
      CALL POWER2 (MX, II)
      IF (II.LT.MX) MX = 2 * II
      CALL POWER2 (MY, II)
      IF (II.LT.MY) MY = 2 * II
      IRET = 0
C                                       Grid. file.
C                                       Increase size if possible for
C                                       interpolation
      IF (MX.LE.8192) MX = 2 * MX
      IF (MY.LE.8192) MY = 2 * MY
      NP(1) = MIN (MX, MY) + 2
      NP(2) = MAX (MX, MY)
C                                       Add extra rows for bandwidth
C                                       synthesis.
      NP(1) = NP(1) + 2 * NCVSIZ
C                                       Determine file size
      CALL MAPSIZ (2, NP, SIZE)
C                                       Don't create if it already exists
C                                       Make GRID (SCRGRD) file.
      IF (SCRGRD.LE.0) THEN
         CALL SCREAT (SIZE, BUFFER, IRET)
         SCRGRD = NSCR
         IF (IRET.NE.0) THEN
            IF (IRET.EQ.1) WRITE (MSGTXT,1010)
            IF (IRET.GT.1) WRITE (MSGTXT,1011)
            GO TO 990
            END IF
         END IF
C                                       WORK file (SCRWRK)
      IF (SCRWRK.LE.0) THEN
         CALL SCREAT (SIZE, BUFFER, IRET)
         SCRWRK = NSCR
         IF (IRET.NE.0) THEN
            IF (IRET.EQ.1) WRITE (MSGTXT,1010)
            IF (IRET.GT.1) WRITE (MSGTXT,1011)
            GO TO 990
            END IF
         END IF
C                                       Fill LUNS array in /CFILES/
      LUNS(1) = 16
      LUNS(2) = 17
      LUNS(3) = 18
      LUNS(4) = 19
      LUNS(5) = 20
      IRET = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SETGRD: ERROR',I5,' READING CATBLK FIELD',I3)
 1010 FORMAT ('TOO LITTLE DISK SPACE FOR SCRATCH FILE')
 1011 FORMAT ('TROUBLE CREATING SCRATCH FILE')
      END

      SUBROUTINE DSIDI (A, LDA, N, KPVT, DET, INERT, WORK, JOB)
C-----------------------------------------------------------------------
C! Computes the determinant, inertia and inverse of a symm. matrix.
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C     DSIDI COMPUTES THE DETERMINANT, INERTIA AND INVERSE
C     OF A DOUBLE PRECISION SYMMETRIC MATRIX USING THE FACTORS FROM
C     DSIFA.
C
C     ON ENTRY
C
C        A       DOUBLE PRECISION(LDA,N)
C                THE OUTPUT FROM DSIFA.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY A.
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX A.
C
C        KPVT    INTEGER(N)
C                THE PIVOT VECTOR FROM DSIFA.
C
C        WORK    DOUBLE PRECISION(N)
C                WORK VECTOR.  CONTENTS DESTROYED.
C
C        JOB     INTEGER
C                JOB HAS THE DECIMAL EXPANSION  ABC  WHERE
C                   IF  C .NE. 0, THE INVERSE IS COMPUTED,
C                   IF  B .NE. 0, THE DETERMINANT IS COMPUTED,
C                   IF  A .NE. 0, THE INERTIA IS COMPUTED.
C
C                FOR EXAMPLE, JOB = 111  GIVES ALL THREE.
C
C     ON RETURN
C
C        VARIABLES NOT REQUESTED BY JOB ARE NOT USED.
C
C        A      CONTAINS THE UPPER TRIANGLE OF THE INVERSE OF
C               THE ORIGINAL MATRIX.  THE STRICT LOWER TRIANGLE
C               IS NEVER REFERENCED.
C
C        DET    DOUBLE PRECISION(2)
C               DETERMINANT OF ORIGINAL MATRIX.
C               DETERMINANT = DET(1) * 10.0**DET(2)
C               WITH 1.0.LE.DABS(DET(1)).LT.10.0
C               OR DET(1) = 0.0.
C
C        INERT  INTEGER(3)
C               THE INERTIA OF THE ORIGINAL MATRIX.
C               INERT(1)  =  NUMBER OF POSITIVE EIGENVALUES.
C               INERT(2)  =  NUMBER OF NEGATIVE EIGENVALUES.
C               INERT(3)  =  NUMBER OF ZERO EIGENVALUES.
C
C     ERROR CONDITION
C
C        A DIVISION BY ZERO MAY OCCUR IF THE INVERSE IS REQUESTED
C        AND  DSICO  HAS SET RCOND.EQ.0.0
C        OR  DSIFA  HAS SET  INFO .NE. 0 .
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     JAMES BUNCH, UNIV. CALIF. SAN DIEGO, ARGONNE NAT. LAB
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS DAXPY,DCOPY,DFDOT,DSWAP
C     FORTRAN DABS,IABS,MO
C-----------------------------------------------------------------------
      INTEGER   LDA, N
      INTEGER   JOB, KPVT(*), INERT(3)
      DOUBLE PRECISION A(LDA,*), WORK(*)
      DOUBLE PRECISION DET(2)
C
C     INTERNAL VARIABLES.
C
      DOUBLE PRECISION AKKP1, DFDOT, TEMP
      DOUBLE PRECISION TEN, D, T, AK, AKP1
      INTEGER   J, JB, K, KM1, KS, KSTEP
      LOGICAL NOINV, NODET, NOERT
      INTEGER   IT1, I1
      DATA I1 /1/
C-----------------------------------------------------------------------
C
      IT1 = 10
      NOINV = MOD (JOB,IT1).EQ.0
      IT1 = 100
      NODET = MOD (JOB,IT1)/10.EQ.0
      IT1 = 1000
      NOERT = MOD (JOB,IT1)/100.EQ.0
C
      IF (NODET .AND. NOERT) GO TO 140
         IF (NOERT) GO TO 10
            INERT(1) = 0
            INERT(2) = 0
            INERT(3) = 0
   10    CONTINUE
         IF (NODET) GO TO 20
            DET(1) = 1.0D0
            DET(2) = 0.0D0
            TEN = 10.0D0
   20    CONTINUE
         T = 0.0D0
         DO 130 K = 1, N
            D = A(K,K)
C
C           CHECK IF 1 BY 1
C
            IF (KPVT(K).GT.0) GO TO 50
C
C              2 BY 2 BLOCK
C              USE DET (D  S)  =  (D/T * C - T) * T  ,  T = DABS(S)
C                      (S  C)
C              TO AVOID UNDERFLOW/OVERFLOW TROUBLES.
C              TAKE TWO PASSES THROUGH SCALING.  USE  T  FOR FLAG.
C
               IF (T .NE. 0.0D0) GO TO 30
                  T = ABS(A(K,K+1))
                  D = (D/T)*A(K+1,K+1) - T
               GO TO 40
   30          CONTINUE
                  D = T
                  T = 0.0D0
   40          CONTINUE
   50       CONTINUE
C
            IF (NOERT) GO TO 60
               IF (D.GT.0.0D0) INERT(1) = INERT(1) + 1
               IF (D.LT.0.0D0) INERT(2) = INERT(2) + 1
               IF (D.EQ.0.0D0) INERT(3) = INERT(3) + 1
   60       CONTINUE
C
            IF (NODET) GO TO 120
               DET(1) = D*DET(1)
               IF (DET(1).EQ.0.0D0) GO TO 110
   70             IF (ABS(DET(1)).GE.1.0D0) GO TO 80
                     DET(1) = TEN*DET(1)
                     DET(2) = DET(2) - 1.0D0
                  GO TO 70
   80             CONTINUE
   90             IF (ABS(DET(1)).LT.TEN) GO TO 100
                     DET(1) = DET(1)/TEN
                     DET(2) = DET(2) + 1.0D0
                  GO TO 90
  100             CONTINUE
  110          CONTINUE
  120       CONTINUE
  130    CONTINUE
  140 CONTINUE
C
C     COMPUTE INVERSE(A)
C
      IF (NOINV) GO TO 270
         K = 1
  150    IF (K.GT.N) GO TO 260
            KM1 = K - 1
            IF (KPVT(K).LT.0) GO TO 180
C
C              1 BY 1
C
               A(K,K) = 1.0D0/A(K,K)
               IF (KM1.LT.1) GO TO 170
                  CALL DCOPY (KM1, A(1,K), I1, WORK, I1)
                  DO 160 J = 1, KM1
                     A(J,K) = DFDOT (J, A(1,J), I1, WORK, I1)
                     IT1 = J-1
                     CALL DAXPY (IT1, WORK(J), A(1,J), I1, A(1,K), I1)
  160             CONTINUE
                  A(K,K) = A(K,K) + DFDOT (KM1, WORK, I1, A(1,K), I1)
  170          CONTINUE
               KSTEP = 1
            GO TO 220
  180       CONTINUE
C
C              2 BY 2
C
               T = ABS (A(K,K+1))
               AK = A(K,K) / T
               AKP1 = A(K+1,K+1) / T
               AKKP1 = A(K,K+1) / T
               D = T*(AK*AKP1 - 1.0D0)
               A(K,K) = AKP1 / D
               A(K+1,K+1) = AK / D
               A(K,K+1) = -AKKP1 / D
               IF (KM1.LT.1) GO TO 210
                  CALL DCOPY( KM1, A(1,K+1), I1, WORK, I1)
                  DO 190 J = 1, KM1
                     A(J,K+1) = DFDOT (J, A(1,J), I1, WORK, I1)
                     IT1 = J-1
                     CALL DAXPY (IT1, WORK(J), A(1,J), I1, A(1,K+1), I1)
  190             CONTINUE
                  A(K+1,K+1) = A(K+1,K+1) +
     *               DFDOT (KM1, WORK, I1, A(1,K+1), I1)
                  A(K,K+1) = A(K,K+1) +
     *               DFDOT (KM1, A(1,K), I1, A(1,K+1), I1)
                  CALL DCOPY (KM1, A(1,K), I1, WORK, I1)
                  DO 200 J = 1, KM1
                     A(J, K) = DFDOT (J, A(1,J), I1, WORK, I1)
                     IT1 = J-1
                     CALL DAXPY (IT1, WORK(J), A(1,J), I1, A(1,K), I1)
  200             CONTINUE
                  A(K,K) = A(K,K) + DFDOT (KM1, WORK, I1, A(1,K), I1)
  210          CONTINUE
               KSTEP = 2
  220       CONTINUE
C
C           SWAP
C
            KS = ABS (KPVT(K))
            IF (KS.EQ.K) GO TO 250
               CALL DSWAP (KS, A(1,KS), I1, A(1,K), I1)
      INCLUDE 'INCS:ZVD.INC'
               DO 230 JB = KS, K
                  J = K + KS - JB
                  TEMP = A(J,K)
                  A(J,K) = A(KS,J)
                  A(KS,J) = TEMP
  230          CONTINUE
               IF (KSTEP.EQ.1) GO TO 240
                  TEMP = A(KS,K+1)
                  A(KS,K+1) = A(K,K+1)
                  A(K,K+1) = TEMP
  240          CONTINUE
  250       CONTINUE
            K = K + KSTEP
         GO TO 150
  260    CONTINUE
  270 CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'BSPRT.INC'
C
C   Miscellaneous global data.
C
C   MODE      BS table solution mode ('INDE', 'VLBA', 'MK3 ' or 'RATE')
C   NUMIF     Number of logical IFs in the BS table
C             (1 <= NUMIF)
C   CURSRC    Source ID of current source (used to identify source
C             changes)
C   MAXSUB    The highest subarray number for the input data file
C   HAVPOL    Is the polarization with the Stokes code corresponding
C             to the index present
C
      CHARACTER MODE*4
      INTEGER   NUMIF, CURSRC, MAXSUB
      LOGICAL   HAVPOL(-8:-1)
C
      COMMON /NBSPRT/ NUMIF, CURSRC, MAXSUB, HAVPOL
      COMMON /CBSPRT/ MODE
      SAVE /NBSPRT/, /CBSPRT/
C
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(4)
      LOGICAL   LDUM(4)
      REAL      RDUM(4)
      DOUBLE PRECISION DDUM(2)
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
      COMMON /BSPRTG/ DDUM
LOCAL END
      PROGRAM BSPRT
C-----------------------------------------------------------------------
C! Apply baseline-based fringe corrections.
C# UV Calibration Ext-appl Table Hardcopy VLBI
C-----------------------------------------------------------------------
C;  Copyright (C) 1996, 2017, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BSPRT prints the contents of a BS table using a more organized
C   presentation than is possible with PRTAB.
C-----------------------------------------------------------------------
C
C   Local variables:
C
C   UVFILE    UVDATA object used to access the uv data file (parameter)
C   BSTAB     TABLE object used to access the input BS table (parameter)
C   OUTPRT    PRINTER object used to output report (parameter)
C   IRET      Error code (0 implies no errors have been detected)
C   DIEBUF    Scratch buffer for DIE
C
      CHARACTER UVFILE*12, BSTAB*8, OUTPRT*7
      INTEGER   IRET, DIEBUF(256)
C
      PARAMETER (UVFILE = 'uv data file')
      PARAMETER (BSTAB  = 'BS table')
      PARAMETER (OUTPRT = 'printer')
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSOU.INC'
C-----------------------------------------------------------------------
      CALL SETUP (UVFILE, BSTAB, OUTPRT, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL PRNTBL (UVFILE, BSTAB, OUTPRT, IRET)
      IF (IRET.NE.0) GO TO 999
C
      CALL PRTCLO (OUTPRT, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL TABCLO (BSTAB, IRET)
      IF (IRET.NE.0) GO TO 999
C
  999 CALL DIE (IRET, DIEBUF)
      END
      SUBROUTINE SETUP (UVFILE, BSTAB, OUTPRT, IRET)
C-----------------------------------------------------------------------
C   Initialize the task and open the input table and the printer.
C
C   Inputs:
C      UVFILE    C*(*)    UVDATA object used to access the input file
C      BSTAB     C*(*)    TABLE object used to access the BS table
C      OUTPRT    C*(*)    PRINTER object used to print the report
C
C   Outputs:
C      IRET      I        Error code (0 implies no errors detected)
C
C   Preconditions:
C      UVFILE, BSTAB and OUTPRT are not blank and are unique
C
C   Postconditions:
C      IRET.EQ.0 implies that
C         UVFILE is initialized and closed
C         BSTAB is open for reading and in time order
C         OUTPRT is open
C         MODE and NUMIF are set from BSTAB
C         CURSRC < 0
C         MAXSUB is set
C-----------------------------------------------------------------------
      CHARACTER UVFILE*(*), BSTAB*(*), OUTPRT*(*)
      INTEGER   IRET
C
C   Task description:
C
C   PRGN      Task name (parameter)
C   INPUTS    INPUTS object name (parameter)
C   NUMADV    Number of adverbs (parameter)
C   AVNAME    Adverb names
C   AVTYPE    Adverb types
C   AVDIM     Adverb types
C
      CHARACTER PRGN*6, INPUTS*6
      PARAMETER (PRGN = 'BSPRT ')
      PARAMETER (INPUTS = 'inputs')
      INTEGER   NUMADV
      PARAMETER (NUMADV = 7)
      CHARACTER AVNAME(NUMADV)*8
      INTEGER   AVTYPE(NUMADV), AVDIM(2, NUMADV)
C
C   UV data file
C
C   NKEY1     Number of adverbs to transfer to UVFILE (parameter)
C   INKEY1    Adverbs to transfer to UVFILE
C   OUTKY1    Attributes to receive adverb values
C
      INTEGER   NKEY1
      PARAMETER (NKEY1 = 4)
      CHARACTER INKEY1(NKEY1)*8, OUTKY1(NKEY1)*16
C
C   BS table
C
C   BSVER     Version number of BS table
C   BSROW     First row in BS table (ignored)
C   SORT      BS table sort order
C
      INTEGER   BSROW, BSVER, SORT(2)
C
C   Printer
C
C   NKEY2     Number of adverbs to transfer to OUTPRT
C   INKEY2    Adverbs to transfer to OUTPRT
C   OUTKY2    Attributes to receive adverb values
C
      INTEGER   NKEY2
      PARAMETER (NKEY2 = 2)
      CHARACTER INKEY2(NKEY2)*8, OUTKY2(NKEY2)*8
C
C   Other local variables
C
C   ANTAB     Temporary TABLE object for antenna files (parameter)
C   TYPE      AIPS attribute type code
C   DIM       AIPS attribute dimensions
C   CDUMMY    Placeholder
C
      CHARACTER ANTAB*8
      PARAMETER (ANTAB = 'an table')
      INTEGER   TYPE, DIM(3)
      CHARACTER CDUMMY
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'BSPRT.INC'
      INCLUDE 'GFORT'
C
      DATA AVNAME /'INNAME  ', 'INCLASS ', 'INSEQ   ', 'INDISK  ',
     *             'INVERS  ', 'DOCRT   ', 'OUTPRINT'/
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOAINT, OOAINT,
     *   OOACAR/
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 1,1, 1,1, 48,1/
C
      DATA INKEY1 /'INNAME  ', 'INCLASS ', 'INSEQ   ', 'INDISK  '/
      DATA OUTKY1 /'FILE_NAME.NAME  ', 'FILE_NAME.CLASS ',
     *             'FILE_NAME.IMSEQ ', 'FILE_NAME.DISK  '/
C
      DATA INKEY2 /'DOCRT   ', 'OUTPRINT'/
      DATA OUTKY2 /'DOCRT   ', 'LPFILE  '/
C-----------------------------------------------------------------------
      CALL AV2INP (PRGN, NUMADV, AVNAME, AVTYPE, AVDIM, INPUTS, IRET)
      IF (IRET.NE.0) GO TO 999
C
C     Try opening the uv file to check that it exists and to initialize
C     descriptive information in common blocks:
C
      CALL OUVCRE (UVFILE, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL IN2OBJ (INPUTS, NKEY1, INKEY1, OUTKY1, UVFILE, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OUVOPN (UVFILE, 'READ', IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'CAN NOT OPEN UV FILE - CHECK ADVERBS'
         CALL MSGWRT (9)
         GO TO 999
         END IF
      CALL OUVCLO (UVFILE, IRET)
      IF (IRET.NE.0) GO TO 999
C
C     Find the highest AN table version number (this is the highest
C     subarray number):
C
      CALL UV2TAB (UVFILE, ANTAB, 'AN', 0, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL TBLHIV (ANTAB, MAXSUB, IRET)
      IF ((IRET.NE.0) .OR. (MAXSUB.LE.0)) THEN
         MSGTXT = 'CAN NOT DETERMINE THE NUMBER OF SUBARRAYS'
         CALL MSGWRT (9)
         MSGTXT = 'ANTENNA TABLES ARE MISSING'
         CALL MSGWRT (9)
         IRET = 999
         GO TO 999
         END IF
      CALL TABDES (ANTAB, IRET)
      IF (IRET.NE.0) GO TO 999
C
C     Open the BS table and sort it into time order, if necessary:
C
      CALL INGET (INPUTS, 'INVERS', TYPE, DIM, IDUM, CDUMMY, IRET)
      BSVER = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL UV2TAB (UVFILE, BSTAB, 'BS', BSVER, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OBSINI (BSTAB, 'READ', BSROW, MODE, NUMIF, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'BS TABLE IS MISSING - CHECK ADVERBS'
         CALL MSGWRT (9)
         GO TO 999
         END IF
      CALL TABGET (BSTAB, 'SORT', TYPE, DIM, SORT, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (SORT(1).NE.1) THEN
         CALL TABCLO (BSTAB, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL TBLSRT (BSTAB, 'TIME    ', 'TIME    ', IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OBSINI (BSTAB, 'READ', BSROW, MODE, NUMIF, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C
C     Open the printer:
C
      CALL PRTCRE (OUTPRT, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL IN2OBJ (INPUTS, NKEY2, INKEY2, OUTKY2, OUTPRT, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL PRTOPN (OUTPRT, '    ', IRET)
      IF (IRET.NE.0) GO TO 999
C
C     Set the current source number to an impossible value so that
C     source data will be read automatically on encountering the
C     first source in the BS table.
C
      CURSRC = -9999
C
  999 RETURN
      END
      SUBROUTINE PRNTBL (UVFILE, BSTAB, OUTPRT, IRET)
C-----------------------------------------------------------------------
C   Print the contents of BSTAB on OUTPRT.
C
C   Inputs:
C      UVFILE    C*(*)    UVDATA object used to access data file
C      BSTAB     C*(*)    TABLE object used to access BS table
C      OUTPRT    C*(*)    PRINTER object used for report
C
C   Output:
C      IRET      I        Error code (0 implies no errors detected)
C
C   Preconditions:
C      UVFILE is initialized and closed
C      BSTAB is open and in time order
C      OUTPRT is open
C
C   Postconditions
C      IRET.EQ.0 implies that
C         the BS table has been printed or the user has aborted the
C         printing
C-----------------------------------------------------------------------
      CHARACTER UVFILE*(*), BSTAB*(*), OUTPRT*(*)
      INTEGER   IRET
C
C   Local variables
C
C   SUBARR    Current subarray number
C   CATBLK    UV file header
C   CNO       UV file catalogue number
C   DISK      UV file disk number
C   MSGSAV    Saved minimum message level
C   TYPE      AIPS attribute type
C   DIM       AIPS attribute dimensions
C   CDUMMY    Placeholder
C   ANBUFF    Buffer for GETANT
C
      INTEGER   SUBARR, CATBLK(256), CNO, DISK, MSGSAV, TYPE, DIM(3),
     *   ANBUFF(512)
      CHARACTER CDUMMY
C
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'BSPRT.INC'
      INCLUDE 'GFORT'
C-----------------------------------------------------------------------
      CALL PRNHDR (UVFILE, BSTAB, OUTPRT, IRET)
      IF (IRET.LT.0) THEN
C                                       User terminated printout
         IRET = 0
         GO TO 999
      ELSE IF (IRET.GT.0) THEN
         GO TO 999
         END IF
C
C     Get physical file information for calls to GETANT:
C
      CALL OUVCGT (UVFILE, CATBLK, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL FNAGET (UVFILE, 'CNO', TYPE, DIM, IDUM, CDUMMY, IRET)
      CNO = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL FNAGET (UVFILE, 'DISK', TYPE, DIM, IDUM, CDUMMY, IRET)
      DISK = IDUM(1)
      IF (IRET.NE.0) GO TO 999
C
C     Process each subarray.  If GETANT fails then the subarray is
C     assumed not to exist.  Since this is not regarded as an error,
C     messages are suppressed when GETANT is called.  Note that
C     SETUP protects against the case where there are no AN tables
C     present.
C
      DO 10 SUBARR = 1, MAXSUB
         MSGSAV = MSGSUP
         MSGSUP = 32000
         CALL GETANT (DISK, CNO, SUBARR, CATBLK, ANBUFF, IRET)
         MSGSUP = MSGSAV
         IF (IRET.EQ.0) THEN
            CALL PRNSUB (UVFILE, BSTAB, OUTPRT, SUBARR, IRET)
            IF (IRET.LT.0) THEN
               IRET = 0
               GO TO 999
            ELSE IF (IRET.GT.0) THEN
               GO TO 999
               END IF
         ELSE
            IRET = 0
            END IF
   10    CONTINUE
C
  999 RETURN
      END
      SUBROUTINE PRNHDR (UVFILE, BSTAB, OUTPRT, IRET)
C-----------------------------------------------------------------------
C   Print a header describing BSTAB.
C
C   Inputs
C      UVFILE    C*(*)    UVDATA object used to access uv data file
C      BSTAB     C*(*)    TABLE object used to access BS table
C      OUTPRT    C*(*)    PRINTER object used for report
C
C   Output
C      IRET      I        Error code (0 implies no errors detected;
C                           < 0 implies user requested termination)
C
C   Preconditions:
C      UVFILE is initialized and closed
C      BSTAB is open
C      OUTPRT is open
C
C-----------------------------------------------------------------------
      CHARACTER UVFILE*(*), BSTAB*(*), OUTPRT*(*)
      INTEGER   IRET
C
C   Local variables
C
C   UVNAME    UV file name
C   UVCLAS    UV file class
C   UVSEQ     UV file sequence number
C   UVDISK    UV file disk number
C   BSVER     BS table version number
C   LINE      line buffer
C   QUIT      does user wish to terminate program?
C   TYPE      AIPS attribute type code
C   DIM       AIPS attribute dimension
C   CDUMMY    placeholder
C
      CHARACTER UVNAME*12, UVCLAS*6, LINE*132, CDUMMY
      INTEGER   UVSEQ, UVDISK, BSVER, TYPE, DIM(3)
      LOGICAL   QUIT
C
      INTEGER   ITRIM
      EXTERNAL  ITRIM
C
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'BSPRT.INC'
      INCLUDE 'GFORT'
C-----------------------------------------------------------------------
      QUIT = .FALSE.
      CALL TABGET (BSTAB, 'VER', TYPE, DIM, IDUM, CDUMMY, IRET)
      BSVER = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL FNAGET (UVFILE, 'NAME', TYPE, DIM, IDUM, UVNAME, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL FNAGET (UVFILE, 'CLASS', TYPE, DIM, IDUM, UVCLAS, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL FNAGET (UVFILE, 'IMSEQ', TYPE, DIM, IDUM, CDUMMY, IRET)
      UVSEQ = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL FNAGET (UVFILE, 'DISK', TYPE, DIM, IDUM, CDUMMY, IRET)
      UVDISK = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      WRITE (LINE, 1000) BSVER
      CALL PRTWRI (OUTPRT, LINE, QUIT, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (QUIT) THEN
         IRET = -1
         GO TO 999
         END IF
      WRITE (LINE, 1001) UVNAME(1:ITRIM(UVNAME)),
     *   UVCLAS(1:ITRIM(UVCLAS)), UVSEQ, UVDISK
      CALL PRTWRI (OUTPRT, LINE, QUIT, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (QUIT) THEN
         IRET = -1
         GO TO 999
         END IF
C
      WRITE (LINE, 1002) MODE
      CALL PRTWRI (OUTPRT, LINE, QUIT, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (QUIT) THEN
         IRET = -1
         GO TO 999
         END IF
      WRITE (LINE, 1003) NUMIF
      CALL PRTWRI (OUTPRT, LINE, QUIT, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (QUIT) THEN
         IRET = -1
         GO TO 999
         END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Listing for BS table version number ', I4)
 1001 FORMAT ('from file ', A, '.', A, '.', I3.3, ' on disk ', I2,
     *   '.')
 1002 FORMAT ('Baseline fringe solutions generated in mode ''', A4,
     *   '''.')
 1003 FORMAT ('Table contains solutions for ', I4, ' distinct IFs.')
      END
      SUBROUTINE PRNSUB (UVFILE, BSTAB, OUTPRT, SUBARR, IRET)
C-----------------------------------------------------------------------
C   Print solutions for SUBARR.
C
C   Inputs
C      UVFILE    C*(*)    UVDATA object used to access uv data file
C      BSTAB     C*(*)    TABLE object used to access BS table
C      OUTPRT    C*(*)    PRINTER object used for report
C      SUBARR    I        Subarray number
C
C   Output
C      IRET      I        Error code (0 implies no errors detected;
C                           < 0 implies user requested termination)
C
C   Preconditions:
C      UVFILE is initialized and closed
C      BSTAB is open
C      OUTPRT is open
C      1 <= SUBARR <= MAXSUB
C      information for SUBARR has been loaded into DANS.INC commons
C
C-----------------------------------------------------------------------
      CHARACTER UVFILE*(*), BSTAB*(*), OUTPRT*(*)
      INTEGER   SUBARR, IRET
C
C   Local variables
C
C   A1        First antenna index
C   A2        Second antenna index
C   BASELN    Baseline antenna indices
C             (indices refer to DANS.INC arrays)
C
      INTEGER   A1, A2, BASELN(2)
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'BSPRT.INC'
C-----------------------------------------------------------------------
      DO 20 A1 = 1, NSTNS - 1
         DO 10 A2 = A1 + 1, NSTNS
            BASELN(1) = A1
            BASELN(2) = A2
            CALL PRNBAS (UVFILE, BSTAB, OUTPRT, SUBARR, BASELN, IRET)
            IF (IRET.NE.0) GO TO 999
   10       CONTINUE
   20    CONTINUE
C
  999 RETURN
      END
      SUBROUTINE PRNBAS (UVFILE, BSTAB, OUTPRT, SUBARR, BASELN, IRET)
C-----------------------------------------------------------------------
C   Print solutions for BASELN in SUBARR.
C
C   Inputs
C      UVFILE    C*(*)    UVDATA object used to access uv data file
C      BSTAB     C*(*)    TABLE object used to access BS table
C      OUTPRT    C*(*)    PRINTER object used for report
C      SUBARR    I        Subarray number
C      BASELN    I(2)     Antenna indices in DANS.INC arrays defining
C                         a baseline.
C
C   Output
C      IRET      I        Error code (0 implies no errors detected;
C                           < 0 implies user requested termination)
C
C   Preconditions:
C      UVFILE is initialized and closed
C      BSTAB is open
C      OUTPRT is open
C      1 <= SUBARR <= MAXSUB
C      information for SUBARR has been loaded into DANS.INC commons
C      1 <= BASELN(1) < BASELN(2) <= NSTNS
C
C-----------------------------------------------------------------------
      CHARACTER UVFILE*(*), BSTAB*(*), OUTPRT*(*)
      INTEGER   SUBARR, BASELN(2), IRET
C
C   Local variables
C
C   POL       Stokes code (-8 <= POL <= -1)
C
      INTEGER   POL
C
      INCLUDE 'BSPRT.INC'
C-----------------------------------------------------------------------
C
C     Start by assuming that only RR is present.  Any other polariza-
C     tions present will be found on the first pass through the table.
C
      HAVPOL(-1) = .TRUE.
      DO 10 POL = -2, -8, -1
         HAVPOL(POL) = .FALSE.
   10    CONTINUE
C
C     Loop through the possible polarizations and print them if they
C     are present
C
      DO 20 POL = -1, -8, -1
         IF (HAVPOL(POL)) THEN
            CALL PRNPOL (UVFILE, BSTAB, OUTPRT, SUBARR, BASELN, POL,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
   20    CONTINUE
C
  999 RETURN
      END
      SUBROUTINE PRNPOL (UVFILE, BSTAB, OUTPRT, SUBARR, BASELN, POL,
     *         IRET)
C-----------------------------------------------------------------------
C   Print results for Stokes code POL on baseline BASELN from SUBARR.
C
C   Inputs
C      UVFILE    C*(*)    UVDATA object used to access uv data file
C      BSTAB     C*(*)    TABLE object used to access BS table
C      OUTPRT    C*(*)    PRINTER object used for report
C      SUBARR    I        Subarray number
C      BASELN    I(2)     Antenna indices in DANS.INC arrays defining
C                         a baseline.
C      POL       I        Stokes code
C
C   Output
C      IRET      I        Error code (0 implies no errors detected;
C                           < 0 implies user requested termination)
C
C   Preconditions:
C      UVFILE is initialized and closed
C      BSTAB is open
C      OUTPRT is open
C      1 <= SUBARR <= MAXSUB
C      information for SUBARR has been loaded into DANS.INC commons
C      1 <= BASELN(1) < BASELN(2) <= NSTNS
C      -8 <= POL <= -1
C
C-----------------------------------------------------------------------
      CHARACTER UVFILE*(*), BSTAB*(*), OUTPRT*(*)
      INTEGER   SUBARR, BASELN(2), POL, IRET
C
C     Solution mode
C
C     MODES     Solution mode names
C     MODENO    Solution mode number
C
      CHARACTER MODES(4)*4
      INTEGER   MODENO
C
C     Width calculation
C
C     COLS      Width of each field in each mode
C     CURFLD    Current field number
C     WIDTH     Current cumulative width
C     NACROS    Width of print-out
C     FLD1      First varying field in current pass
C     NXTFLD    First varying field in next pass
C     DOCRT     Value of DOCRT adverbs
C
      INTEGER   COLS(11, 4), CURFLD, WIDTH, NACROS, FLD1, NXTFLD, DOCRT
C
C     Titles
C
C     TITLE1    First row of page title
C     TITLE2    Second row of page title
C     TITLES    Column titles
C
      CHARACTER TITLE1*80, TITLE2*132, TITLES(11)*24
C
C     Other
C
C     TYPE      AIPS attribute type
C     DIM       AIPS attribute dimensions
C     CDUMMY    Placeholder
C     POLNAM    Polarization names
C
      INTEGER   TYPE, DIM(3)
      CHARACTER POLNAM(-8:-1)*2, CDUMMY
C
      INTEGER   ITRIM
      EXTERNAL  ITRIM
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'BSPRT.INC'
      INCLUDE 'GFORT'
C
      DATA MODES /'INDE', 'VLBA', 'MK3 ', 'RATE'/
      DATA COLS /16, 12, 18, 6, 14, 14,  0, 23, 23, 23, 17,
     *           16, 12, 18, 0, 14, 14,  0, 23, 23, 23, 17,
     *           16, 12, 18, 0, 14, 14, 23, 23, 23, 23, 17,
     *           16, 12, 18, 0, 14, 14,  0,  0, 23, 23, 17/
      DATA TITLES /'      Time              ',
     *             '  Interval              ',
     *             '     Source             ',
     *             '  IF                    ',
     *             'Vector Amp/Jy           ',
     *             'Scalar Amp/Jy           ',
     *             '  Multiband Delay/ns    ',
     *             ' Single-band Delay/ns   ',
     *             '       Rate/mHz         ',
     *             '  Acceleration/uHz**2   ',
     *             '   Phase/deg            '/
      DATA POLNAM /'HV', 'VH', 'HH', 'VV', 'LR', 'RL', 'LL', 'RR'/
C-----------------------------------------------------------------------
C
C     Get the number of columns in the printer output from the printer
C     object
C
      CALL PRTGET (OUTPRT, 'DOCRT', TYPE, DIM, IDUM, CDUMMY, IRET)
      DOCRT = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      NACROS = 72
      IF (DOCRT.LE.0) NACROS = NCHPRT
      IF ((DOCRT.GT.72) .AND. (DOCRT.LE.132)) NACROS = DOCRT
      IF (DOCRT.GT.132) NACROS = 132
C
C     Set the main title
C
      IF (TELNO(BASELN(1)).LT.TELNO(BASELN(2))) THEN
         WRITE (TITLE1, 1000)
     *      STNNAM(BASELN(1))(1:ITRIM(STNNAM(BASELN(1)))),
     *      STNNAM(BASELN(2))(1:ITRIM(STNNAM(BASELN(2)))),
     *      SUBARR, POLNAM(POL)
      ELSE
         WRITE (TITLE1, 1000)
     *      STNNAM(BASELN(2))(1:ITRIM(STNNAM(BASELN(2)))),
     *      STNNAM(BASELN(1))(1:ITRIM(STNNAM(BASELN(1)))),
     *      SUBARR, POLNAM(POL)
         END IF
      TYPE = OOACAR
      DIM(1) = ITRIM(TITLE1)
      DIM(2) = 1
      DIM(3) = 0
      CALL PRTPUT (OUTPRT, 'TITLE1', TYPE, DIM, IDUM, TITLE1, IRET)
      IF (IRET.NE.0) GO TO 999
C
C     Find the mode number:
C
      MODENO = 1
   10 IF (MODENO.LE.4) THEN
         IF (MODES(MODENO).NE.MODE) THEN
            MODENO = MODENO + 1
            GO TO 10
            END IF
         END IF
      IF (MODENO.GT.4) THEN
         WRITE (MSGTXT, 1010) MODE
         CALL MSGWRT (8)
         IRET = 999
         GO TO 999
         END IF
C
C     Make as many passes through the file as is necessary to print
C     all of the required data:
C
      NXTFLD = 5
   20 IF (NXTFLD.LE.11) THEN
C
C        Find out how many fields can be printed in the current pass
C        and set the column headers in the second line of the page
C        header.  The first 4 fields (time, time interval, source
C        and IF) will appear in every pass.
C
         WIDTH = 0
         TITLE2 = ' '
         DO 30 CURFLD = 1, 4
            TITLE2(WIDTH+1:WIDTH+COLS(CURFLD, MODENO)) =
     *         TITLES(CURFLD)(1:COLS(CURFLD, MODENO))
            WIDTH = WIDTH + COLS(CURFLD, MODENO)
   30       CONTINUE
         FLD1 = NXTFLD
   40    IF (NXTFLD.LE.11) THEN
            IF (WIDTH + COLS(NXTFLD, MODENO).LE.NACROS) THEN
               TITLE2(WIDTH+1:WIDTH+COLS(NXTFLD, MODENO)) =
     *            TITLES(NXTFLD)(1:COLS(NXTFLD, MODENO))
               WIDTH = WIDTH + COLS(NXTFLD, MODENO)
               NXTFLD = NXTFLD + 1
               GO TO 40
               END IF
            END IF
C
C        Set the second line of the page title and force the next line
C        to start a new page:
C
         TYPE = OOACAR
         DIM(1) = ITRIM (TITLE2)
         DIM(2) = 1
         DIM(3) = 0
         CALL PRTPUT (OUTPRT, 'TITLE2', TYPE, DIM, IDUM, TITLE2, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL PRTNUP (OUTPRT, IRET)
         IF (IRET.NE.0) GO TO 999
C
C        Traverse the table:
C
         CALL PRNPAS (UVFILE, BSTAB, OUTPRT, SUBARR, BASELN, POL, FLD1,
     *      NXTFLD - 1, COLS, MODENO, IRET)
         IF (IRET.NE.0) GO TO 999
C
         GO TO 20
         END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Baseline ', A, '-', A, ' from subarray ', I3,
     *   ' polarization ', A2)
 1010 FORMAT ('MODE ''', A4, ''' IS NOT RECOGNIZED - ABORTING')
      END
      SUBROUTINE PRNPAS (UVFILE, BSTAB, OUTPRT, SUBARR, BASELN, POL,
     *   START, FINISH, COLS, MODENO, IRET)
C-----------------------------------------------------------------------
C   Print out the data for the varying fields START through FINISH
C   together with the 4 fixed fields for BASELN, SUBARR and POL.
C
C   Inputs
C      UVFILE    C*(*)    UVDATA object used to access uv data file
C      BSTAB     C*(*)    TABLE object used to access BS table
C      OUTPRT    C*(*)    PRINTER object used for report
C      SUBARR    I        Subarray number
C      BASELN    I(2)     Antenna indices in DANS.INC arrays defining
C                         a baseline.
C      POL       I        Stokes code
C      START     I        First varying field to print
C      FINISH    I        Last varying field to print
C      COLS      I(11, 4) Width of each field in each mode
C      MODENO    I        Mode number
C
C   Output
C      IRET      I        Error code (0 implies no errors detected;
C                           < 0 implies user requested termination)
C
C   Preconditions:
C      UVFILE is initialized and closed
C      BSTAB is open
C      OUTPRT is open
C      1 <= SUBARR <= MAXSUB
C      information for SUBARR has been loaded into DANS.INC commons
C      1 <= BASELN(1) < BASELN(2) <= NSTNS
C      -8 <= POL <= -1
C      5 <= START <= FINISH <= 11
C      COLS(1:11, 1:4) >= 0
C      1 <= MODENO <= 4
C
C-----------------------------------------------------------------------
      CHARACTER UVFILE*(*), BSTAB*(*), OUTPRT*(*)
      INTEGER   SUBARR, BASELN(2), POL, START, FINISH, COLS(11, 4),
     *   MODENO, IRET
C
      INCLUDE 'INCS:PUVD.INC'
C
C   BS table
C
C   ROW       Current row number
C   NROWS     Number of rows in table
C   TIME      Timestamp (days)
C   INTERV    Time interval (days)
C   BL        Baseline
C   SUB       Subarray
C   STOKES    Stokes code
C   SRCID     Source ID
C   VAMP      Vector amplitude sum (Jy)
C   SAMP      Scalar amplitude sum (Jy)
C   RMBD      Residual multiband delay (s)
C   MBDERR    Residual multiband delay error (s)
C   MBDAMB    Residual multiband delay ambiguity (s)
C   RSBD      Residual single-band delay (s)
C   SBDERR    Residual single-band delay error (s)
C   SBDAMB    Residual single-band delay ambiguity (s)
C   RRATE     Residual rate (Hz)
C   RTERR     Residual rate error (Hz)
C   RTAMB     Residual-rate ambiguity (Hz)
C   RACCEL    Residual acceleration (Hz**2)
C   ACCERR    Residual acceleration error (Hz**2)
C   RPHASE    Residual phase (deg)
C   PHSERR    Residual-phase error (deg)
C
      INTEGER   ROW, NROWS, BL(2), SUB, STOKES, SRCID
      DOUBLE PRECISION TIME
      REAL INTERV, VAMP(MAXIF), SAMP(MAXIF), RMBD, MBDERR, MBDAMB,
     *   RSBD(MAXIF), SBDERR(MAXIF), SBDAMB(MAXIF), RRATE(MAXIF),
     *   RTERR(MAXIF), RTAMB(MAXIF), RACCEL(MAXIF), ACCERR(MAXIF),
     *   RPHASE(MAXIF), PHSERR(MAXIF)
C
C   uv file details for GETSOU
C
C   CATBLK    Header record
C   CNO       Catalogue number
C   DISK      Disk number
C
      INTEGER   CATBLK(256), CNO, DISK
C
C   Formatting and print output
C
C   COL       Current output column
C   LINE      Output line
C   FMTBUF    Formatting buffer
C   CURFLD    Current field
C   QUIT      Does the user want to finish?
C
      INTEGER   COL, CURFLD
      CHARACTER LINE*132, FMTBUF*24
      LOGICAL   QUIT
C
C   Other local variables
C
C   IFNUM     Current IF number
C   MSGSAV    Saved message suppression level
C   DHMS      Split time (day, hour. min, sec)
C   TYPE      AIPS attribute type code
C   DIM       AIPS attribute dimensions
C   CDUMMY    Placeholder
C
      INTEGER   IFNUM, MSGSAV, TYPE, DIM(3)
      REAL      DHMS(4)
      CHARACTER CDUMMY
C
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'BSPRT.INC'
      INCLUDE 'GFORT'
C-----------------------------------------------------------------------
      QUIT = .FALSE.
C
C     Extract file information for future calls to GETSOU
C
      CALL OUVCGT (UVFILE, CATBLK, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OUVGET (UVFILE, 'CNO', TYPE, DIM, IDUM, CDUMMY, IRET)
      CNO = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OUVGET (UVFILE, 'DISK', TYPE, DIM, IDUM, CDUMMY, IRET)
      DISK = IDUM(1)
      IF (IRET.NE.0) GO TO 999
C
C     Find the number of rows in the table
C
      CALL TABGET (BSTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IRET)
      NROWS = IDUM(1)
      IF (IRET.NE.0) GO TO 999
C
C     Scan the table
C
      ROW = 1
   10 IF (ROW.LE.NROWS) THEN
         CALL OTABBS (BSTAB, 'READ', ROW, NUMIF, TIME, INTERV, BL, SUB,
     *      STOKES, SRCID, VAMP, SAMP, RMBD, MBDERR, MBDAMB, RSBD,
     *      SBDERR, SBDAMB, RRATE, RTERR, RTAMB, RACCEL, ACCERR,
     *      RPHASE ,PHSERR, IRET)
         IF (IRET.GT.0) GO TO 999
         IF (IRET.EQ.0) THEN
C                                       Unflagged
            HAVPOL(STOKES) = .TRUE.
            IF ((((BL(1).EQ.BASELN(1)) .AND. (BL(2).EQ.BASELN(2)))
     *         .OR. ((BL(1).EQ.BASELN(2))
     *         .AND. (BL(2).EQ.BASELN(1)))) .AND. (SUB.EQ.SUBARR)
     *         .AND. (STOKES.EQ.POL)) THEN
C
C              Read in new source information if the source has changed.
C              Suppress error messages since errors are non-fatal
C
               IF (SRCID.NE.CURSRC) THEN
                  MSGSAV = MSGSUP
                  MSGSUP = 3200
                  CALL GETSOU (SRCID, DISK, CNO, CATBLK, 25, IRET)
                  MSGSUP = MSGSAV
                  IF (IRET.NE.0) THEN
                     IRET = 0
                     SNAME = 'Unknown source'
                     END IF
                  CURSRC = SRCID
                  END IF
C
C              Process each IF
C
               DO 50 IFNUM = 1, NUMIF
                  LINE = ' '
                  COL = 0
                  IF (IFNUM.EQ.1) THEN
                     CALL TSPLIT (REAL (TIME), DHMS)
                     WRITE (FMTBUF, 1010) INT(DHMS(1)), INT(DHMS(2)),
     *                  INT(DHMS(3)), DHMS(4)
                     LINE(COL+1:COL+COLS(1, MODENO)) =
     *                  FMTBUF(1:COLS(1, MODENO))
                     END IF
                  COL = COL + COLS(1, MODENO)
                  IF (IFNUM.EQ.1) THEN
                     CALL TSPLIT (INTERV, DHMS)
                     WRITE (FMTBUF, 1011) INT(DHMS(2)), INT(DHMS(3)),
     *                  DHMS(4)
                     LINE(COL+1:COL+COLS(2, MODENO)) =
     *                  FMTBUF(1:COLS(2, MODENO))
                     END IF
                  COL = COL + COLS(2, MODENO)
                  IF (IFNUM.EQ.1) THEN
                     LINE(COL+1:COL + COLS(3, MODENO)) =
     *                  SNAME(1:COLS(3, MODENO))
                     END IF
                  COL = COL + COLS(3, MODENO)
                  WRITE (FMTBUF, 1012) IFNUM
                  LINE(COL+1:COL+COLS(4, MODENO)) =
     *               FMTBUF(1:COLS(4, MODENO))
                  COL = COL + COLS(4, MODENO)
                  DO 40 CURFLD = START, FINISH
                     FMTBUF = ' '
                     IF (COLS(CURFLD, MODENO).GE.0) THEN
                        IF (CURFLD.EQ.5) THEN
                           IF (VAMP(IFNUM).NE.FBLANK) THEN
                              WRITE (FMTBUF, 1013) VAMP(IFNUM)
                           ELSE
                              WRITE (FMTBUF, 1014)
                              END IF
                        ELSE IF (CURFLD.EQ.6) THEN
                           IF (SAMP(IFNUM).NE.FBLANK) THEN
                              WRITE (FMTBUF, 1013) SAMP(IFNUM)
                           ELSE
                              WRITE (FMTBUF, 1014)
                              END IF
                        ELSE IF ((CURFLD.EQ.7) .AND. (IFNUM.EQ.1))
     *                        THEN
                           IF ((RMBD.NE.FBLANK) .AND.
     *                        (MBDERR.NE.FBLANK)) THEN
                              WRITE (FMTBUF, 1015) 1.0E9 * RMBD,
     *                           1.0E9 * MBDERR
                           ELSE
                              WRITE (FMTBUF, 1016)
                              END IF
                        ELSE IF (CURFLD.EQ.8) THEN
                           IF ((RSBD(IFNUM).NE.FBLANK) .AND.
     *                        (SBDERR(IFNUM).NE.FBLANK)) THEN
                              WRITE (FMTBUF, 1015) 1.0E9 * RSBD(IFNUM),
     *                           1.0E9 * SBDERR(IFNUM)
                           ELSE
                              WRITE (FMTBUF, 1016)
                              END IF
                        ELSE IF (CURFLD.EQ.9) THEN
                           IF ((RRATE(IFNUM).NE.FBLANK) .AND.
     *                        (RTERR(IFNUM).NE.FBLANK)) THEN
                              WRITE (FMTBUF, 1015) 1.0E3 * RRATE(IFNUM),
     *                           1.0E3 * RTERR(IFNUM)
                           ELSE
                              WRITE (FMTBUF, 1016)
                              END IF
                        ELSE IF (CURFLD.EQ.10) THEN
                           IF ((RACCEL(IFNUM).NE.FBLANK) .AND.
     *                        (ACCERR(IFNUM).NE.FBLANK)) THEN
                              WRITE (FMTBUF, 1015)
     *                           1.0E6 * RACCEL(IFNUM),
     *                           1.0E6 * ACCERR(IFNUM)
                           ELSE
                              WRITE (FMTBUF, 1016)
                              END IF
                        ELSE IF (CURFLD.EQ.11) THEN
                           IF ((RPHASE(IFNUM).NE.FBLANK) .AND.
     *                        (PHSERR(IFNUM).NE.FBLANK)) THEN
                              WRITE (FMTBUF, 1017) RPHASE(IFNUM),
     *                           PHSERR(IFNUM)
                           ELSE
                              WRITE (FMTBUF, 1018)
                              END IF
                           END IF
                        END IF
                     LINE(COL+1:COL+COLS(CURFLD, MODENO)) =
     *                  FMTBUF(1: COLS(CURFLD, MODENO))
                     COL = COL + COLS(CURFLD, MODENO)
   40                CONTINUE
                  CALL PRTWRI (OUTPRT, LINE, QUIT, IRET)
                  IF (IRET.NE.0) GO TO 999
                  IF (QUIT) THEN
                     IRET = -1
                     GO TO 999
                     END IF
   50             CONTINUE
               END IF
            END IF
         GO TO 10
         END IF
C
  999 RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (I3.3, '/', I2.2, ':', I2.2, ':', F4.1, '  ')
 1011 FORMAT (I2.2, ':', I2.2, ':', F4.1, '  ')
 1012 FORMAT (I4, '  ')
 1013 FORMAT (1PE12.5, '  ')
 1014 FORMAT ('    INDE    ')
 1015 FORMAT (F8.3, ' +/- ', F8.3, '  ')
 1016 FORMAT ('         INDE          ')
 1017 FORMAT (F6.1, ' +/- ', F6.1)
 1018 FORMAT ('      INDE       ')
      END
      SUBROUTINE TSPLIT(DAYS, TIME)
C-----------------------------------------------------------------------
C   Split a time in days into its component parts.
C
C   Input:
C      DAYS    R       Time in days
C
C   Output:
C      TIME    R(4)    Time in days, hours, minutes and seconds
C-----------------------------------------------------------------------
      REAL   DAYS, TIME(4)
C
      REAL   D
C-----------------------------------------------------------------------
      TIME(1) = INT (DAYS)
      D = 24.0 * (DAYS - TIME(1))
      TIME(2) = INT (D)
      D = 60.0 * (D - TIME(2))
      TIME(3) = INT (D)
      TIME(4) = 60.0 * (D - TIME(3))
      END

      SUBROUTINE BASLIN (NA, X, Y, Z, FREQ, ARRLON, BX, BY, BZ,
     *   B1, B2, GH)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Subroutine to calculate baseline coordinates from a given set of
C   station coordinates
C   Inputs:
C      NA       I      Number of antennas
C      X        D(*)   X station coordinates
C      Y        D(*)   X station coordinates
C      X        D(*)   Z station coordinates
C      FREQ     D      frequency in Hz
C      ARRLON   D      Array longitude (rad.)
C   Outputs:
C      BX       D(*)   baseline coordinates in wavelengths X
C      BY       D(*)   baseline coordinates in wavelengths Y
C      BZ       D(*)   baseline coordinates in wavelengths Z
C      B1       D(*)   baseline coordinates in polar coordinates
C      B2       D(*)      relative Greenwich meridian
C      GH       D      hour angle
C-----------------------------------------------------------------------
      INTEGER   NA
      DOUBLE PRECISION X(*), Y(*), Z(*), FREQ, ARRLON, BX(*), BY(*),
     *   BZ(*), B1(*), B2(*), GH(*)
C
      INTEGER   I, J, NB
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       baselines
      NB = 0
      DO 20 I = 1,NA-1
         DO 10 J = I+1,NA
            NB = NB + 1
            BX(NB) = X(J) - X(I)
            BY(NB) = Y(J) - Y(I)
            BZ(NB) = Z(J) - Z(I)
C                                       Sign of B1 and B2 flipped to
C                                       agree with AIPS phase convention
            B2(NB) = -SQRT (BX(NB) * BX(NB) + BY(NB) * BY(NB)) *
     *         FREQ/VELITE
            B1(NB) = -BZ(NB) * FREQ / VELITE
            GH(NB) = -ARRLON
            IF ((BY(NB).NE.0.0D0) .OR. (BX(NB).NE.0.0D0))
     *         GH(NB)  = GH(NB) + ATAN2 (-BY(NB), BX(NB))
            IF (GH(NB).GT.PI) GH(NB) = GH(NB) - TWOPI
            IF (GH(NB).LE.-PI) GH(NB) = GH(NB) + TWOPI
 10         CONTINUE
 20      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE BUFGET (APCORE, NIO, OPARM, IREC, OREC, IDATA, BUFF,
     *   TEMPBF)
C-----------------------------------------------------------------------
C! Get a buffer of visibilities from AP, then pack data, if needed
C# AP-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Get Visibility data from AP then determines whether UV data must
C   be compressed.
C   Input/Output buffer is assumed to be large enough to hold expanded
C   Visibility
C    Inputs:
C     NIO    I        Number of visiblilities to expand
C     OPARM  I        Output Number of random parameters in visibility
C     IREC   I        Input  Length of compressed vis (1 reals per vis)
C     OREC   I        Output Length of un-comp.   vis (3 reals per vis)
C     IDATA  I        Index into AP array were Visibilities are placed
C    Output
C     BUFF     R(*)   Compressed/Uncompressed array of visibilities
C     TEMPBF   R(*)   Scratch array, large enough to hold expanded vis
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   NIO, OPARM, IREC, OREC, IDATA
      REAL      BUFF(*), TEMPBF(*)
C
      INTEGER   WRK
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSCD.INC'
C-----------------------------------------------------------------------
C                                       Calc Expanded Vis length
      WRK = NIO * OREC
C                                       IF compressed,
      IF (SCRCAT(KINAX).EQ.1) THEN
C                                       Read Expanded vis from AP
         CALL QGET (APCORE, TEMPBF(1), IDATA, WRK, 2)
         CALL QWD
C                                       Compress all points in buff
         CALL BUFPAK (NIO, OPARM, IREC, OREC, TEMPBF(1))
C                                       Copy temp into output buff
         CALL COPY (NIO*IREC, TEMPBF(1), BUFF(1))
      ELSE
C                                       Read record from AP
         CALL QGET (APCORE, BUFF(1), IDATA, WRK, 2)
C                                       Wait for AP to finish
         CALL QWD
         END IF
C
      RETURN
      END

      SUBROUTINE QUVINT (UV, VIS, WORK, L, G, CX, M, LROW, NFREQ,
     *   CNT, SCR)
C-----------------------------------------------------------------------
C! FPS AP version: Interpolate model visibility from grid
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FPS AP version
C   Interpolates model visibility values from a grid, corrects the model
C   for the phase of the z*w term and subtracts the model from the data.
C   Will loop over several frequency channels.  Two words of work space
C   are assumed in front of the visibilities.
C    Inputs:
C      UV    I  Base address of U,V vector
C      VIS   I  Base address of visibility
C      WORK  I  Base address of complex work vector length CNT
C      L     I  Length of visibility record
C      G     I  Base address of grid
C      CX    I  Base address of row interpolation function
C                 interpolation fns tabulated every 1/200 cell.
C      M     I  Width of interpolation fn support size,  also
C                 the number of rows kept in AP (must be odd)
C      LROW  I  length of a row (V)
C      NFREQ I  Number of frequencies to process.
C      CNT   I  Number of visibility points.
C      SCR   I  Base address of scratch complex vector
C                 in each vis rec, inc=L.
C   NOTE: only really works for one frequency (unless they are
C   very close)
C     Also expects necessary constants in following AP locations:
C          0 = U scaling to cells
C          1 = V scaling to cells
C          2 = DXC = -2 * Pi * delta RA (in cells)
C          3 = DYC = -2 * Pi * delta DEC (cells)
C          4 = DZC = -2 * Pi * delta Z (in radians) for 1st
C              frequency channel.
C          5 = Used as work space.
C          6 = Used as work space.
C          16...16+NFREQ-2 = Differential frequency scaling table
C               for channels after the first one.
C               FREQ(n) = (1+MD(16+n-1)) * FREQ(n-1) FOR n>1
C-----------------------------------------------------------------------
      INTEGER UV, VIS, WORK, L, G, CX, M, LROW, NFREQ, CNT, SCR
      INTEGER*2 IUV, IVIS, IWORK, IL, IG, ICX, IM, ILROW, INFREQ,
     *   ICNT, ISCR
C-----------------------------------------------------------------------
C                                        Convert inputs to unsigned I*2
      IF (UV.LT.32768) IUV = UV
      IF (UV.GE.32768) IUV = UV - 65536
      IF (VIS.LT.32768) IVIS = VIS
      IF (VIS.GE.32768) IVIS = VIS - 65536
      IF (WORK.LT.32768) IWORK = WORK
      IF (WORK.GE.32768) IWORK = WORK - 65536
      IF (L.LT.32768) IL = L
      IF (L.GE.32768) IL = L - 65536
      IF (G.LT.32768) IG = G
      IF (G.GE.32768) IG = G - 65536
      IF (CX.LT.32768) ICX = CX
      IF (CX.GE.32768) ICX = CX - 65536
      IF (M.LT.32768) IM = M
      IF (M.GE.32768) IM = M - 65536
      IF (LROW.LT.32768) ILROW = LROW
      IF (LROW.GE.32768) ILROW = LROW - 65536
      IF (NFREQ.LT.32768) INFREQ = NFREQ
      IF (NFREQ.GE.32768) INFREQ = NFREQ - 65536
      IF (CNT.LT.32768) ICNT = CNT
      IF (CNT.GE.32768) ICNT = CNT - 65536
      IF (SCR.LT.32768) ISCR = SCR
      IF (SCR.GE.32768) ISCR = SCR - 65536
C                                        Call FPS routine.
      CALL UVINTP (IUV, IVIS, IWORK, IL, IG, ICX, IM, ILROW, INFREQ,
     *   ICNT, ISCR)
C
 999  RETURN
      END

      SUBROUTINE YLUT (OP, CHANNL, COLOR, VRTRTC, LUT, IERR)
C-----------------------------------------------------------------------
C! read/write channel-based look-up-table
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2008
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   YLUT reads/writes full channel look up tables to TV.
C   Inputs:
C      OP      C*4    'READ' from TV, 'WRIT' to TV
C      CHANNL  I      channel select bit mask
C      COLOR   I      color select bit mask (RGB <-> 421)
C      VRTRTC  L      T => do it only during vertical retrace
C   In/Out:
C      LUT     I(*)   look up table (dimension = MAXINT+1, values to
C                     LUTOUT are used)
C   Out:
C      IERR    I      error code of Z...XF : 0 => ok, 2 => input error
C   SUN Screen Server Version
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   CHANNL, COLOR, LUT(*), IERR
      LOGICAL   VRTRTC
C
      INTEGER   DAT(4), OPCODE, NWSD, TMPCLR, BUFSIZ, BITS(16), I,
     *   NBYTES
      LOGICAL   WASYNC
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
      DAT(1) = 0
      DAT(2) = 0
      DAT(3) = 0
      TMPCLR = COLOR
      CALL ZGTBIT (16, CHANNL, BITS)
      IERR = 2
      BUFSIZ = MAXINT + 1
      NBYTES = 2 * BUFSIZ
C                                       Read - one color
      IF (OP.EQ.'READ') THEN
         IF (TMPCLR.GE.4) THEN
            DAT(1) = 1
         ELSE IF (TMPCLR.GE.2) THEN
            DAT(2) = 1
         ELSE
            DAT(3) = 1
            END IF
C                                       old code 42
         OPCODE = 40
         DAT(4) = 0
         DO 10 I = 1,NGRAY
            IF (BITS(I).GT.0) DAT(4) = I
 10         CONTINUE
         IF (DAT(4).LE.0) GO TO 999
         I = 0
         CALL ZSSSXF (OPCODE, DAT, I, LUT, NWSD, IERR)
         IF ((IERR.EQ.0) .AND. (NWSD.NE.NBYTES)) THEN
            WRITE (MSGTXT,1000) NWSD, NBYTES
            CALL MSGWRT (7)
            END IF
C                                       write: get sep colors
      ELSE IF (OP.EQ.'WRIT') THEN
         WASYNC = ISYNCH.EQ.0
         IF (WASYNC) CALL YHOLD ('ONNN', I)
         IF (TMPCLR.GE.4) THEN
            DAT(1) = 1
            TMPCLR = TMPCLR - 4
            END IF
         IF (TMPCLR.GE.2) THEN
            DAT(2) = 1
            TMPCLR = TMPCLR - 2
            END IF
         IF (TMPCLR.GE.1) THEN
            DAT(3) = 1
            TMPCLR = TMPCLR - 1
            END IF
C                                       old code 41
         OPCODE = 39
         CALL ZILI16 (BUFSIZ, LUT, 1, LUT)
         DO 20 I = 1,NGRAY
            IF (BITS(I).GT.0) THEN
               DAT(4) = I
               CALL ZSSSXF (OPCODE, DAT, NBYTES, LUT, NWSD, IERR)
               IF (IERR.NE.0) GO TO 999
               END IF
 20         CONTINUE
         IF (WASYNC) CALL YHOLD ('OFFF', I)
         END IF
C                                       convert/reconvert to local I
      IF (IERR.EQ.0) CALL ZI16IL (BUFSIZ, 1, LUT, LUT)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('YLUT: READ',I7,' VALUES OF',I7,' REQUESTED')
      END

      SUBROUTINE ZBKLD1 (IERR)
C-----------------------------------------------------------------------
C! initialize environment for BAKLD
C# Z Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Routine to initialize the host environment in preparation for
C   execution of ZBKLD2 under task BAKLD.
C   Output:
C      IERR   I   error code : 0 => okay
C                    1 => can't create listing subdirectory
C                    2 => input error - translates fail
C   UNIX version
C   NOTE: the private subdirectory on DA00 is only used by ZBKLD2 when
C   it is doing OP=PRNT/SKIP; it avoids dynamic creation of
C   subdirectories just for the little BAKTP catalog files.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   XLEN, JERR, ITEMP, ITRIM, CLEN
      CHARACTER COMMND*40, CUSER*3, HTEMP*1, CTEMP*5, TEXT*128
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DBKL.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       ZLUNn may be host-dependent:
      ZLUN1 = 78
      ZLUN2 = 79
C                                       translate logical DA00:
      CTEMP = 'DA00'
      XLEN = LEN (ZDA00)
      CALL ZTRLOG (4, CTEMP, XLEN, ZDA00, LZDA00, JERR)
C                                       translate logical MT0n:
      IF (JERR.EQ.0) THEN
         ITEMP = NTAPE
         CALL ZEHEX (ITEMP, 1, HTEMP)
         CTEMP = 'AMT0' // HTEMP
         XLEN = LEN (ZMT0N)
         CALL ZTRLOG (5, CTEMP, XLEN, ZMT0N, LZMT0N, JERR)
         END IF
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1000) CTEMP, JERR
         IERR = 2
         GO TO 990
         END IF
C                                       create private command file:
      CALL ZEHEX (USER, 3, CUSER)
      CALL ZEHEX (NPOPS, 1, HTEMP)
      ZBKNAM = '/tmp/BAKLD' // CTEMP // '.' // CUSER
      OPEN (ZLUN2, FILE=ZBKNAM, STATUS='UNKNOWN', ERR=900)
C                                       create private subdirectory:
 40   REWIND ZLUN2
      TEXT = 'mkdir ' // ZDA00(1:LZDA00) // '/BAKLD' // HTEMP // '.DIR'
      ITEMP = ITRIM (TEXT)
      WRITE (ZLUN2, 1040, ERR=900) TEXT(1:ITEMP)
      CLOSE (ZLUN2)
C                                       make file executable:
      COMMND = 'chmod +x ' // ZBKNAM
      CLEN = ITRIM (COMMND)
      CALL ZSHCMD (CLEN, COMMND, 8, 'TASK_OUT', IERR)
C                                       now execute it (Bourne shell):
      IF (IERR.EQ.0) THEN
         COMMND = ZBKNAM
         CLEN = ITRIM (COMMND)
         CALL ZSHCMD (CLEN, COMMND, 8, 'TASK_OUT', IERR)
         END IF
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1045) IERR
         CALL MSGWRT (8)
         MSGTXT = 'ZBKLD1: ' // COMMND
         GO TO 990
         END IF
C                                       Must close tape under Unix.
C                                       Perhaps this means we are
C                                       undefended against simultaneous
C                                       access while BAKLD is running?
      CALL ZTPCLS (TLUN, TIND, JERR)
      TIND = 0
      GO TO 999
C                                       can't create, fatal error:
 900  MSGTXT = 'ZBKLD1: CANNOT CREATE/WRITE ' // ZBKNAM
      IERR = 1
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZBKLD1: CANNOT TRANSLATE ''',A,''' IERR ',I5)
 1040 FORMAT (A)
 1045 FORMAT ('ZBKLD1: ZSHCMD ERROR',I5,' COMMAND =')
      END

      SUBROUTINE SUREFM (DISK, CNO, VER, CATBLK, LUN, IRET)
C-----------------------------------------------------------------------
C! Checks existence of SU table, changes format if necessary
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2012, 2014
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to change the format of the SU table from one containing
C   19 columns to the 21 columns needed by the addition of the RAOBS
C   and DECOBS columns.
C   NOTE: routine uses LUN 45 as a temporary logical unit number.
C   Inputs:
C      DISK            I       Volume number
C      CNO             I       Catalogue number
C      VER             I       Version to check/modify
C      CATBLK(256)     I       Catalog header
C      LUN             I       LUN to use
C   Output:
C      IRET            I       Error, 0 => OK
C
C   Note, routine will leave no trace of its operation, i.e. SU table
C   will be closed on output and will have same number as one specified.
C   Difference will be only that number of columns has changed if that
C   is required.
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, VER, CATBLK(256), LUN, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER CTEMP*12, UTYPE*2, STAT*4
      INTEGER   BUFFER(512), OVER, OLUN, OBUFF(512), I, OSURNO, NSUROW,
     *   OKOLS(MAXSUC), ONUMV(MAXSUC), MSGSAV, IDUM, CASAFE(256), NUMIF,
     *   ISURNO, SUKOLS(MAXSUC), SUNUMV(MAXSUC)
      LOGICAL   CHSTAT
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA OLUN /45/
C-----------------------------------------------------------------------
C                                       Open existing SU file
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL SUINI ('READ', BUFFER, DISK, CNO, VER, CATBLK, LUN, NUMIF,
     *   VELTYP, VELDEF, SUFQID, ISURNO, SUKOLS, SUNUMV, IRET)
      MSGSUP = MSGSAV
      IF (IRET.EQ.2) THEN
         IRET = 0
         GO TO 999
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, 'OPEN INPUT'
         GO TO 990
         END IF
C                                       Is it new format?
      IF ((BUFFER(10).EQ.21) .AND. (SUKOLS(16).GT.0) .AND.
     *   (SUKOLS(17).GT.0)) THEN
         CALL TABIO ('CLOS', 0, ISURNO, BUFFER, BUFFER, IRET)
         GO TO 999
         END IF
C                                       Check is old format
      IF ((BUFFER(10).GT.19) .AND. (BUFFER(10).NE.21)) THEN
         WRITE (MSGTXT,1000) BUFFER(10)
         IRET = 1
         GO TO 990
      ELSE IF (BUFFER(10).LT.19) THEN
         WRITE (MSGTXT,1001) 19-BUFFER(10)
         CALL MSGWRT (7)
         END IF
C                                       # rows in old table
      NSUROW = BUFFER(5)
C                                       input one mey be modified and
C                                       we don't dare put it back to
C                                       disk - so get safe one
      CALL CATIO ('READ', DISK, CNO, CASAFE, 'REST', OBUFF, IRET)
      IF ((IRET.NE.0) .AND. ((IRET.LT.6) .OR. (IRET.GT.8))) THEN
         WRITE (MSGTXT,1010) IRET, 'CATIO READ FOR SAFE HEADER'
         GO TO 990
         END IF
C                                       Determine status of file
      UTYPE = 'UV'
      CHSTAT = .FALSE.
 20   CALL CATDIR ('INFO', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE, IDUM,
     *   STAT, OBUFF, IRET)
C                                       Remove 1 read status: loop
      IF (STAT.EQ.'READ') THEN
         STAT = 'CLRD'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'CLRD'
            GO TO 990
            END IF
         CHSTAT = .TRUE.
         GO TO 20
         END IF
C                                       now add write
      IF (CHSTAT) THEN
         STAT = 'WRIT'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'WRIT'
            GO TO 990
            END IF
         END IF
C
C                                       Open up new SU table
      OVER = 0
      CALL SUINI ('WRIT', OBUFF, DISK, CNO, OVER, CASAFE, OLUN, NUMIF,
     *   VELTYP, VELDEF, SUFQID, OSURNO, OKOLS, ONUMV, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Loop and copy
      DO 100 I = 1,NSUROW
         ISURNO = I
         CALL TABSOU ('READ', BUFFER, ISURNO, SUKOLS, SUNUMV, IDSOUR,
     *      SNAME, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA,
     *      PMDEC, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1010) IRET, 'READ INPUT'
            GO TO 990
         ELSE IF (IRET.EQ.0) THEN
            OSURNO = I
C                                       assumption of old routines
            RAOBS = RAEPO
            DECOBS = DECEPO
C                                       now copy
            CALL TABSOU ('WRIT', OBUFF, OSURNO, OKOLS, ONUMV, IDSOUR,
     *         SNAME, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *         EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ,
     *         PMRA, PMDEC, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'WRITE OUTPUT'
               GO TO 990
               END IF
            END IF
 100     CONTINUE
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ISURNO, BUFFER, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OSURNO, OBUFF, OBUFF, IRET)
C                                       Delete the original file
      CALL RMEXT (DISK, CNO, 'SU', VER, CASAFE, BUFFER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, 'DELETE ORIGINAL'
         GO TO 990
         END IF
C                                       Copy new file to place
C                                       occupied by old one
      MSGSAV = MSGSUP
      MSGSUP = 31999
      CALL TABCOP ('SU', OVER, VER, OLUN, LUN, DISK, DISK, CNO, CNO,
     *   CASAFE, OBUFF, BUFFER, IRET)
      MSGSUP = MSGSAV
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, 'COPYING TEMP TO OLD'
         GO TO 990
         END IF
C                                       Delete the now defunct
C                                       original output file
      CALL RMEXT (DISK, CNO, 'SU', OVER, CASAFE, BUFFER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, 'DELETE TEMP'
         GO TO 990
         END IF
C                                       Check if changed status
      IF (CHSTAT) THEN
         STAT = 'CLWR'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'CLWR'
            GO TO 990
            END IF
         STAT = 'READ'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'READ'
            GO TO 990
            END IF
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SUREFM: UNKNOWN SU FORMAT, # COLS = ',I3)
 1001 FORMAT ('SUREFM: UNKNOWN SU FORMAT: MISSING',I3,
     *   ' COLS - try fix anyway')
 1010 FORMAT ('SUREFM: ERROR ',I3,' DOING ',A,' SU FILE')
 1080 FORMAT ('SUREFM: ERROR ',I3,' CHANGING ',A4,' STATUS')
      END

      SUBROUTINE PCCARD (GROUP, CARD, PCMATX, CDMATX, PVMATX)
C-----------------------------------------------------------------------
C! parses PCi_j, CDi_j, PVi_j FITS cards
C# FITS Parsing
C-----------------------------------------------------------------------
C;  Copyright (C) 2003, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PCCARD parses PCi_j and CDi_j cards.  If there is any problem, such
C   as a format error in the card, then the output is left unchanged.
C   Inputs:
C      GROUP    I        1 for Random group, 0 otherwise (corrects
C                        subscripts by subtracting GROUP)
C      CARD     C*80     The FITS card image
C   In/Out
C      PCMATX   R(7,7)   The PC matrix values
C      CDMATX   R(7,7)   The CD matrix values
C      PVMATX   R(7,7)   The PV matrix values
C-----------------------------------------------------------------------
      INTEGER   GROUP
      CHARACTER CARD*80
      REAL      PCMATX(7,7), CDMATX(7,7), PVMATX(7,7)
C
      INTEGER   KBP, I, J, N
      CHARACTER CTEMP*4
      DOUBLE PRECISION X
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       get subscripts
      N = INDEX (CARD(:8), '_')
      IF (N.LE.3) GO TO 999
      CTEMP = CARD(3:N-1)
      KBP = 1
      CALL GETNUM (CTEMP, 4, KBP, X)
      IF (X.EQ.DBLANK) GO TO 999
      I = X + 0.01 - GROUP
      IF ((I.LE.0) .OR. (I.GT.7)) GO TO 999
      CTEMP = CARD(N+1:8)
      KBP = 1
      CALL GETNUM (CTEMP, 4, KBP, X)
      IF (X.EQ.DBLANK) GO TO 999
      J = X + 0.01 - GROUP
      IF ((J.LE.0) .OR. (J.GT.7)) GO TO 999
C                                       get value
      N = INDEX (CARD, '=')
      IF (N.LE.8) GO TO 999
      KBP = N + 1
      CALL GETNUM (CARD, 80, KBP, X)
      IF (X.NE.DBLANK) THEN
         IF (CARD(:2).EQ.'CD') CDMATX(I,J) = X
         IF (CARD(:2).EQ.'PC') PCMATX(I,J) = X
         IF (CARD(:2).EQ.'PV') PVMATX(I,J) = X
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZTPOPN (LUN, FIND, IVOL, PNAME, OPER, IERR)
C-----------------------------------------------------------------------
C! open tape or pseudo-tape device
C# Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998-1999, 2001-2002, 2004-2005, 2010
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Open a tape drive (as well as its corresponding disk control file)
C   for sequential, "map" (double buffered, asynchronous) I/O or open
C   a pseudo-tape sequential disk file.  Exclusive use and wait to open
C   are assumed.  Uses a 'TP' disk "lock" file for real tapes.
C   Inputs:
C      LUN     I       Logical unit number (128-NTAPED < LUN <= 128
C                         => tape, else disk)
C      IVOL    I       Tape drive
C      PNAME   C*48    tape disk physical file name
C      OPER    C*4     'READ' => read only or 'WRIT' => read/write
C   Output:
C      FIND    I       Index in FTAB to file control block for LUN
C      IERR    I       Error return code: 0 => no error
C                         1 => LUN already in use
C                         2 => file not found
C                         3 => volume not found
C                         4 => exclusive use denied
C                         5 => no room for LUN in FTAB
C                         6 => other open errors
C   Generic version.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IVOL, IERR
      CHARACTER PNAME*(*), OPER*4
C
      INTEGER   JERR, DELMAX, DELCNT, DLMAX2, DLCNT2, MODE, MTLUN, I, J,
     *   MTIND, IMAP, IEXCL, FCBOFF, IL, ITRIM
      REAL      TDELAY
      HOLLERITH ANAME(12), BNAME(64)
      LOGICAL   T, F, TAPE
      CHARACTER MTNAM*48, LNAME*256, TAPLOG*8, XLATED*256, JUNK*4,
     *   LTPNAM*24, FILNAM*256
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA T, F /.TRUE., .FALSE./
C                                       tape lock file be impatient
      DATA TDELAY, DELMAX, DLMAX2 /1.0, 10, 2/
      DATA IMAP /0/
C-----------------------------------------------------------------------
C                                       Check inputs.
      IERR = 6
      LNAME = PNAME
C                                       Valid LUN?
      TAPE = (LUN.GE.129-NTAPED) .AND. (LUN.LT.129)
      LTPNAM = TPNAME(IVOL)
C                                       check device names:tape
      IF (TAPE) THEN
         IF (TPNAME(IVOL).EQ.' ') THEN
            CALL ZEHEX (IVOL, 4, JUNK)
            TAPLOG = 'TAPE' // JUNK(4:4)
            CALL ZTRLOG (5, TAPLOG, 256, XLATED, J, IERR)
            IF (IERR.NE.0) THEN
               MSGTXT = 'ZTPOPN: UNABLE TO TRANSLATE LOGICAL NAME ' //
     *            TAPLOG
               GO TO 995
               END IF
            IF (XLATED(:6).NE.'REMOTE') THEN
               LTPNAM = 'LOCAL'
            ELSE
               TAPLOG(:4) = 'AMT0'
               CALL ZTRLOG (5, TAPLOG, 256, XLATED, J, IERR)
               IF (IERR.NE.0) THEN
                  MSGTXT = 'ZTPOPN: UNABLE TO TRANSLATE LOGICAL NAME '
     *               // TAPLOG
                  CALL MSGWRT (6)
                  MSGTXT = 'ZTPOPN: DID YOU FORGET TO DO A MOUNT?'
                  GO TO 995
                  END IF
               I = INDEX (XLATED, ':')
               IF (I.NE.8) THEN
                  MSGTXT = 'FUNNY ' // TAPLOG(:5)
                  CALL MSGWRT (7)
                  MSGTXT = 'XLATED =' // XLATED
                  IERR = 2
                  GO TO 995
               ELSE
                  LTPNAM = XLATED(9:)
                  END IF
               END IF
            END IF
C                                       check device names:disk
      ELSE
         I = INDEX (PNAME, '::')
         IF (I.GT.0) THEN
            J = I - 1
            TPDNAM = PNAME(:J)
            CALL CHLORU ('DOWN', J, TPDNAM)
            LNAME = PNAME(I+2:)
         ELSE
            TPDNAM = 'LOCAL'
            END IF
         END IF
C                                       Proper device type?
      IF ((TAPE) .AND. (DEVTAB(LUN).EQ.2)) GO TO 20
      IF ((.NOT.TAPE) .AND. (DEVTAB(LUN).EQ.0)) GO TO 20
         WRITE (MSGTXT,1010) LUN, DEVTAB(LUN)
         GO TO 995
C                                       Valid opcode?
 20   IF ((OPER.EQ.'READ') .OR. (OPER.EQ.'WRIT')) GO TO 25
         WRITE (MSGTXT,1020) OPER
         GO TO 995
C                                       match tape LUN and IVOL
 25   IF ((.NOT.TAPE) .OR. (LUN.EQ.129-IVOL)) GO TO 30
         WRITE (MSGTXT,1025) IVOL, LUN
         GO TO 995
C                                       Real tapes:
C                                       Open tape control disk file.
 30   IF (TAPE) THEN
         CALL ZPHFIL ('TP', 1, 1, IVOL, MTNAM, IERR)
         MTLUN = LUN - NTAPED
C                                       Allocate area in FTAB for MTLUN.
         CALL LSERCH ('OPEN', MTLUN, MTIND, F, JERR)
         IF (JERR.EQ.0) GO TO 40
C                                       MTLUN already in use.
            IF (JERR.EQ.2) THEN
               IERR = 1
               WRITE (MSGTXT,1031) MTLUN
C                                       No room in FTAB for MTLUN.
            ELSE IF (JERR.EQ.3) THEN
               IERR = 5
               WRITE (MSGTXT,1032) MTLUN
C                                       Other error
            ELSE
               WRITE (MSGTXT,1030) JERR, 'OPEN', MTLUN
               END IF
            GO TO 995
C                                       Okay, so far.
 40      IERR = 0
         DELCNT = 0
         DLCNT2 = 0
         FCBOFF = MTIND + NMOFF
         IEXCL = 1
 50      CALL CHR2H (48, MTNAM, 1, ANAME)
         CALL ZDAOPN (FTAB(FCBOFF), ANAME, IMAP, IEXCL, IERR)
         IF (IERR.EQ.0) GO TO 70
            IL = MIN (24, ITRIM (MTNAM))
C                                       File not found
            IF (IERR.EQ.2) THEN
               WRITE (MSGTXT,1050) MTNAM(:IL)
               CALL MSGWRT (6)
C                                       Volume not found?
            ELSE IF (IERR.EQ.3) THEN
               WRITE (MSGTXT,1051) IVOL, MTNAM(:IL)
               CALL MSGWRT (6)
C                                       File busy?
            ELSE IF (IERR.EQ.4) THEN
C                                       Wait and try again every TDELAY
C                                       seconds up to DELMAX*DLMAX2
C                                       times.  Issue a message every
C                                       DLMAX2 wait.
               DELCNT = DELCNT + 1
               IF (DELCNT.LE.DELMAX) THEN
                  CALL ZDELAY (TDELAY, IERR)
               ELSE
                  DLCNT2 = DLCNT2 + 1
                  IF (DLCNT2.GT.DLMAX2) GO TO 53
                     DELCNT = 0
                     WRITE (MSGTXT,1052) MTNAM(:IL)
                     CALL MSGWRT (2)
                  END IF
               GO TO 50
C                                       No more patience
 53            WRITE (MSGTXT,1053) MTNAM(:IL)
               CALL MSGWRT (6)
               MSGTXT = 'PERHAPS YOU ARE USING THE TAPE DRIVE'
               CALL MSGWRT (6)
C                                       Other open error.
 54         ELSE
               CALL ZERROR ('ZDAOPN', FTAB(FCBOFF+FCBERR), MTNAM,
     *            FTAB(FCBOFF), F)
               END IF
            GO TO 915
         END IF
C                                       Allocate area in FTAB for LUN.
 70   CALL LSERCH ('OPEN', LUN, FIND, T, JERR)
      IF (JERR.EQ.0) GO TO 80
C                                       LUN already in use.
         IF (JERR.EQ.2) THEN
            IERR = 1
            WRITE (MSGTXT,1071) LUN
C                                       No room in FTAB for LUN.
         ELSE IF (JERR.EQ.3) THEN
            IERR = 5
            WRITE (MSGTXT,1072) MTLUN
         ELSE
            WRITE (MSGTXT,1070) JERR, 'OPEN', LUN
            END IF
         CALL MSGWRT (6)
         GO TO 910
C                                       Finally, open the tape drive.
 80   IERR = 0
      FCBOFF = FIND + MOFF
      MODE = 0
      IF (OPER.EQ.'WRIT') MODE = 2
C                                       Open real tape.
      IF (TAPE) THEN
         LNAME = 'AMT0x:'
         CALL ZEHEX (IVOL, 1, LNAME(5:5))
         IF (LTPNAM.NE.'LOCAL') THEN
            CALL ZTPOPR (LUN, FIND, IVOL, LNAME, OPER, IERR)
            IF (IERR.NE.0) THEN
               IL = ITRIM (TPNAME(IVOL))
               WRITE (MSGTXT,1082) IERR, TPNAME(IVOL)(:IL)
               CALL MSGWRT (6)
               GO TO 905
               END IF
         ELSE
            CALL CHR2H (48, LNAME, 1, ANAME)
            CALL ZTPOP2 (FTAB(FCBOFF), ANAME, MODE, IERR)
            IF (IERR.NE.0) THEN
C                                       Device not found?
               IL = ITRIM(LNAME)
               IF (IERR.EQ.2) THEN
                  WRITE (MSGTXT,1080) LNAME(:IL)
                  CALL MSGWRT (6)
C                                       No such logical?
               ELSE IF (IERR.EQ.3) THEN
                  WRITE (MSGTXT,1081) LNAME(:IL)
                  CALL MSGWRT (6)
C                                       Other open error.
               ELSE
                  CALL ZERROR ('ZTPOP2', FTAB(FCBOFF+FCBERR), LNAME,
     *               FTAB(FCBOFF), T)
                  END IF
               GO TO 905
               END IF
            END IF
C                                       Pseudo-tape disk files.
      ELSE
         IF (TPDNAM.NE.'LOCAL') THEN
            CALL ZTPOPR (LUN, FIND, IVOL, LNAME, OPER, IERR)
            IF (IERR.NE.0) THEN
               IL = ITRIM (TPDNAM)
               WRITE (MSGTXT,1082) IERR, TPDNAM(:IL)
               CALL MSGWRT (6)
               GO TO 905
               END IF
         ELSE
            CALL ZFULLN (LNAME, 'FITS', ' ', FILNAM, IERR)
            IF (IERR.NE.0) FILNAM = LNAME
            CALL CHR2H (256, FILNAM, 1, BNAME)
            CALL ZTPOPD (FTAB(FCBOFF), BNAME, MODE, IERR)
            IF (IERR.NE.0) THEN
C                                       Device not found?
               IL = ITRIM (LNAME)
               IL = MIN (IL, 24)
               IF (IERR.EQ.2) THEN
                  WRITE (MSGTXT,1280) LNAME(:IL)
                  CALL MSGWRT (6)
C                                       No such logical?
               ELSE IF (IERR.EQ.3) THEN
                  WRITE (MSGTXT,1281) LNAME(:IL)
                  CALL MSGWRT (6)
C                                       Other open error.
               ELSE
                  CALL ZERROR ('ZTPOPD', FTAB(FCBOFF+FCBERR), LNAME,
     *               FTAB(FCBOFF), T)
                  END IF
               GO TO 925
               END IF
            END IF
         END IF
C                                       store file name
      CALL FSERCH (FIND, I, J, JERR)
      IF (JERR.EQ.0) THEN
         IF (I.EQ.1) DEVNAM(J) = LNAME
         IF (I.EQ.2) NONNAM(J) = LNAME
         IF (I.EQ.3) MAPNAM(J) = LNAME
         END IF
      IF ((TAPE) .AND. (IERR.EQ.0)) TPNAME(IVOL) = LTPNAM
      GO TO 999
C                                       Error.  Close files ignoring
C                                       error returns and clear FTAB
C                                       entries for MTLUN and LUN.
 905  CALL LSERCH ('CLOS', LUN, FIND, T, JERR)
 910  IF (TAPE) CALL ZDACLS (FTAB(MTIND+NMOFF), IMAP, JERR)
 915  IF (TAPE) CALL LSERCH ('CLOS', MTLUN, MTIND, F, JERR)
      GO TO 999
 925  CALL LSERCH ('CLOS', LUN, FIND, T, JERR)
      GO TO 999
C
 995  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ZTPOPN: IMPROPER DEVICE TYPE DEVTAB(',I3,') = ',I1,
     *   'FOR TAPE I/O')
 1020 FORMAT ('ZTPOPN: INVALID OPERATION CODE = ',A4)
 1025 FORMAT ('ZTPOPN: TAPE NUMBER',I5,' DOESN''T MATCH LUN',I5)
 1030 FORMAT ('ZTPOPN: LSERCH ERROR ',I1,' FOR ',A4,' ON MTLUN = ',I3)
 1031 FORMAT ('ZTPOPN: MTLUN = ',I3,' ALREADY OPEN IN FTAB')
 1032 FORMAT ('ZTPOPN: NO ROOM IN FTAB FOR MTLUN = ',I3)
 1050 FORMAT ('ZTPOPN: TAPE CONTROL FILE = ',A,' NOT FOUND')
 1051 FORMAT ('ZTPOPN: VOLUME = ',I2,' FOR FILE = ',A,' NOT FOUND')
 1052 FORMAT ('ZTPOPN: STILL WAITING FOR FILE = ',A)
 1053 FORMAT ('ZTPOPN: FILE = ',A,' NOT AVAILABLE')
 1070 FORMAT ('ZTPOPN: LSERCH ERROR ',I1,' FOR ',A4,' ON LUN = ',I3)
 1071 FORMAT ('ZTPOPN: LUN = ',I3,' ALREADY OPEN IN FTAB')
 1072 FORMAT ('ZTPOPN: NO ROOM IN FTAB FOR LUN = ',I3)
 1080 FORMAT ('ZTPOPN: TAPE DEVICE = ',A,' NOT FOUND')
 1081 FORMAT ('ZTPOPN: NO SUCH LOGICAL DEVICE = ',A)
 1082 FORMAT ('ZTPOPN: REMOTE OPEN ERROR',I4,' TO ',A)
 1280 FORMAT ('ZTPOPN: DISK DEVICE = ',A,' NOT FOUND')
 1281 FORMAT ('ZTPOPN: NO SUCH LOGICAL DEVICE = ',A)
      END

LOCAL INCLUDE 'ALBUS.INC'
C                                       Local include for ALBUS
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   STNMAX, HISMAX
      PARAMETER (STNMAX = 500)
      PARAMETER (HISMAX = 4*STNMAX)
C
      HOLLERITH XNAMEI(3), XCLAIN(2), DATOUT(12), XSOUR(4,30), XTECT(1),
     *   XSTATS(2,30), XAVER(1), XPGM(3)
      REAL      XSIN, XDISIN, XGAINV, XGAINU, XANT(50), DODATE, DETIME,
     *   DOBTW, XRAD, DOALL, PRTLEV
      INTEGER   SEQIN, DISKIN, CATOLD(256), CLVIN, CLVOUT, TEVOUT,
     *   CNOIN, JANT(50), JANTS, SCRTCH(512), RADIUS, THEANT, THESRC,
     *   NUMHIS, HISTRT, NUMSTN
      LOGICAL   NEWANT, DOADV
      DOUBLE PRECISION THELON, THELAT
      CHARACTER NAMEIN*12, CLAIN*6, DATDIR*48, SRCS(30)*12, ROOT*256,
     *   CURDIR*256, TECTYP*3, SRCTXT*256, DIRDAT*256, AGSTAT(STNMAX)*4,
     *   THENAM*16, ALBVER*4, PRGT*12, STATNS(30)*4, HISCRD(HISMAX)*64,
     *   AGSTAC(STNMAX)*3, STNTXT*256
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XANT, XGAINV,
     *   XGAINU, DATOUT, DODATE, XTECT, DETIME, DOBTW, XRAD, DOALL,
     *   XSTATS, PRTLEV, XAVER, XPGM
      COMMON /TPARMS/ CATOLD, THELON, THELAT, SCRTCH, SEQIN, DISKIN,
     *   CNOIN, CLVIN, CLVOUT, TEVOUT, JANT, JANTS, RADIUS, THEANT,
     *   THESRC, NUMHIS, NEWANT, HISTRT, NUMSTN, DOADV
      COMMON /CHARPM/ NAMEIN, CLAIN, DATDIR, SRCS, ROOT, CURDIR, SRCTXT,
     *   DIRDAT, AGSTAT, AGSTAC, HISCRD, THENAM, TECTYP, ALBVER, PRGT,
     *   STATNS, STNTXT
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
C                                       End local include for ALBUS
LOCAL END
LOCAL INCLUDE 'ALBUSD.INC'
      INTEGER   ANTMAX, SRCMAX
      PARAMETER (ANTMAX=50, SRCMAX=250)
C
      INTEGER   NSORC, NANTS, SRCNUM(SRCMAX), ANTNUM(ANTMAX)
      LOGICAL   ISPLAN(SRCMAX)
      DOUBLE PRECISION SRA(SRCMAX), SDEC(SRCMAX), ANTPOS(3,ANTMAX),
     *   ANTLL(3,ANTMAX)
      REAL      TSTART, TSTOP
      COMMON /DALBUS/ SRA, SDEC, ANTPOS, ANTLL, SRCNUM, ISPLAN, NSORC,
     *   NANTS, TSTART, TSTOP, ANTNUM
      CHARACTER SRCNAM(SRCMAX)*16, CSTART*20, CSTOP*20
      COMMON /CALBUS/ SRCNAM, CSTART, CSTOP
LOCAL END
LOCAL INCLUDE 'RIFRM.INC'
C                                       Local include for RIFRM
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NTMAX, NSMAX
      PARAMETER (NTMAX=10000)
      PARAMETER (NSMAX=100)
C
      INTEGER   NTIMES, SRCBRK(2,NSMAX), NSRCS, BADIFR, GUDIFR
      LOGICAL   TENEW
      REAL      TIMES(NTMAX), DAZ(NTMAX), DEL(NTMAX), STEC(NTMAX),
     *   VTEC(NTMAX), RMS(NTMAX), TOTRUN, SUMRUN
      COMMON /RIFRMD/ TIMES, DAZ, DEL, STEC, VTEC, RMS, NTIMES, TENEW,
     *   SRCBRK, NSRCS, TOTRUN, SUMRUN, BADIFR, GUDIFR
LOCAL END
      PROGRAM ALBUS
C-----------------------------------------------------------------------
C! Run ALBUS package for DISP and IFR for data set
C# Utility UV UV-util VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 2024-2026
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ALBUS invokes the ALBUS package to compute ionospheric Faraday
C   rotation and dispersive delay.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      GAINVER        CLVIN         Initial CL table
C      GAINUSE        CLVOUT        Output CL table
C      DATAOUT        DATDIR        Disk area for files
C      DODATE         DODATE        > 0 use dated subdirectory
C      TECRTYPE       TECTYP        'G03' or 4 or 5
C      DETIME         DETIME        Delay allowed in downloading sec
C      DOBTWEEN       DOBTW         # download areas, number parallel
C      RADIUS         XRAD          Radius km to search
C      DOALL          DOALL         >0 all sources in one pass
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, ANTNAM*8
      INTEGER   IRET, IANT, ISRC, NS, KANT, HM(2)
      DOUBLE PRECISION XX, ELEV
      INCLUDE 'ALBUS.INC'
      INCLUDE 'ALBUSD.INC'
      INCLUDE 'RIFRM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA PRGM /'ALBUS '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL ALBUSI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
      BADIFR = 0
      GUDIFR = 0
      DOADV = .TRUE.
      NUMHIS = 0
C                                       Call routine to do ALBUS
      NS = NSORC
      IF (DOALL.GT.0.0) NS = 1
      IF ((NANTS.GT.0) .AND. (NUMSTN.GT.0)) THEN
         MSGTXT = 'STATIONS NOT ALLOWED FOR MULTIPLE ANTENNAS'
         CALL MSGWRT (7)
         NUMSTN = 0
         END IF
      DO 20 IANT = 1,MAX(1,NANTS)
         THELON = ANTLL(1,IANT)
         THELAT = ANTLL(2,IANT)
         ELEV = ANTLL(3,IANT)
         KANT = ANTNUM(IANT)
         ANTNAM = STNNAM(KANT)
         XX = ABS(THELON) * RAD2DG
         HM(1) = XX
         XX = (XX - HM(1)) * 60.0D0
         HM(2) = XX
         XX = (XX - HM(2)) * 60.0D0
         IF (THELON.LT.0.0D0) HM(1) = -HM(1)
         WRITE (MSGTXT,1000) KANT, ANTNAM, 'Longitude', HM, XX
         IF (NANTS.LE.0) MSGTXT(:6) = 'Array '
         CALL MSGWRT (8)
         XX = ABS(THELAT) * RAD2DG
         HM(1) = XX
         XX = (XX-HM(1)) * 60.0D0
         HM(2) = XX
         XX = (XX-HM(2)) * 60.0D0
         IF (THELAT.LT.0.0D0) HM(1) = -HM(1)
         WRITE (MSGTXT,1000) KANT, ANTNAM, 'Latitude ', HM, XX
         IF (NANTS.LE.0) MSGTXT(:6) = 'Array '
         CALL MSGWRT (8)
         WRITE (MSGTXT,1001) KANT, ANTNAM, 'Elevation', ELEV
         IF (NANTS.LE.0) MSGTXT(:6) = 'Array '
         CALL MSGWRT (8)
         NEWANT = .TRUE.
         HISTRT = NUMHIS+1
         DO 10 ISRC = 1,NS
            CALL ALBUSD (IANT, ISRC, IRET)
            IF (IRET.NE.0) GO TO 990
            NEWANT = .FALSE.
 10         CONTINUE
 20      CONTINUE
C                                       history
      CALL ALBUSH
      WRITE (MSGTXT,1020) BADIFR
      CALL MSGWRT (4)
      WRITE (MSGTXT,1021) GUDIFR
      CALL MSGWRT (4)
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('Ant',I3,2X,A,2X,A,I6.2,I3.2,F7.3)
 1001 FORMAT ('Ant',I3,2X,A,2X,A,F9.2)
 1020 FORMAT ('Found',I9,' bad IFR values')
 1021 FORMAT ('Found',I9,' reasonable IFR values')
      END
      SUBROUTINE ALBUSI (PRGN, JERR)
C-----------------------------------------------------------------------
C   ALBUSI gets input parameters for ALBUS and determines source and
C   antenna lists.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, PTYPE*2, DOB*8, THEDAT*12, MONTH(12)*3
      INTEGER   IROUND, NPARM, IERR, I, J, JTRIM, IT(4), ID(3)
      LOGICAL   T, F
      INCLUDE 'ALBUS.INC'
      INCLUDE 'ALBUSD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA MONTH /'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN', 'JUL',
     *   'AUG', 'SEP', 'OCT', 'NOV', 'DEC'/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 264
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'FINDING INPUT PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Do not restart AIPS
      IF (PRTLEV.LE.1.0) RQUICK = .FALSE.
      IF (RQUICK) CALL RELPOP (IERR, SCRTCH, JERR)
      IF (IERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (48, 1, DATOUT, DATDIR)
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (3, 1, XTECT, TECTYP)
      IF ((TECTYP.NE.'G04') .AND. (TECTYP.NE.'G05') .AND.
     *   (TECTYP.NE.'G03') .AND. (TECTYP.NE.'G02') .AND.
     *   (TECTYP.NE.'G06') .AND. (TECTYP.NE.'G07') .AND.
     *   (TECTYP.NE.'G08') .AND. (TECTYP.NE.'G09') .AND.
     *   (TECTYP.NE.'G00')) TECTYP = 'G01'
      CALL H2CHR (4, 1, XAVER, ALBVER)
      IF (ALBVER.NE.'0.1') ALBVER = '1.0'
      IF (ALBVER.EQ.'0.1') DOALL = -1.0
      CALL H2CHR (12, 1, XPGM, PRGT)
      CALL CHLTOU (12, PRGT)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SRCS(I))
 10      CONTINUE
      JANTS = 0
      DO 15 I = 1,50
         J = XANT(I) + 0.1
         IF (J.GT.0) THEN
            JANTS = JANTS + 1
            JANT(JANTS) = J
            END IF
 15      CONTINUE
      NUMSTN = 21
      DO 20 I = 1,30
         CALL H2CHR (4, 1, XSTATS(1,I), STATNS(I))
         CALL CHUTOL (4, STATNS(I))
         IF (STATNS(I).EQ.' ') NUMSTN = MIN (NUMSTN, I-1)
 20      CONTINUE
      IF (NUMSTN.GT.20) NUMSTN = 0
C                                       Create new file.
C                                       Get CATBLK from old file.
      CNOIN = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'WRIT', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING DATA HEADER'
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 999
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 1
C                                       versions
      CALL FNDEXT ('CL', CATBLK, I)
      CLVIN = XGAINV + 0.1
      IF ((CLVIN.LE.0) .OR. (CLVIN.GT.I)) CLVIN = I
      CLVOUT = XGAINU + 0.1
      IF (CLVOUT.NE.CLVIN) CLVOUT = I + 1
      CALL FNDEXT ('TE', CATBLK, I)
      TEVOUT = I + 1
      IF (CLVOUT.EQ.CLVIN) TEVOUT = I
C                                       time range
      CALL UVTIME (DISKIN, CNOIN, CATBLK, TSTART, TSTOP, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FINDING DATA TIME RANGE'
         GO TO 990
         END IF
      CALL H2CHR (8, 1, CATH(KHDOB), DOB)
      CALL DATEST (DOB, ID)
      TSTART = TSTART - 5./(60.*24.)
      TSTART = MAX (TSTART, 0.0)
      CALL TODHMS (TSTART, IT)
      WRITE (CSTART,1010) ID, IT(2), IT(3), IT(4)
      TSTOP = TSTOP + 5./(60.*24.)
      CALL TODHMS (TSTOP, IT)
      ID(3) = ID(3) + IT(1)
      WRITE (CSTOP,1010) ID, IT(2), IT(3), IT(4)
C                                       source, antenna data
      CALL ANTGET (IERR)
      IF (IERR.NE.0) GO TO 999
      CALL SRCGET (IERR)
      IF (IERR.NE.0) GO TO 999
C                                       ALBUS directory
      I = JTRIM (DATDIR)
      IF (I.LE.0) THEN
         DATDIR = 'HOME:'
         I = 5
         END IF
      IF (DATDIR(I:I).EQ.':') THEN
         I = I - 1
         CALL ZTRLOG (I, DATDIR(:I), 256, ROOT, J, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'TRANSLATING OUTFILE'
            GO TO 990
            END IF
      ELSE
         ROOT = DATDIR
         END IF
      I = JTRIM (ROOT)
      IF (ROOT(I:I).NE.'/') ROOT(I+1:) = '/'
      IF (DODATE.GT.0.0) THEN
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         ID(1) = MOD (ID(1), 100)
         WRITE (THEDAT,1040) ID(3), MONTH(ID(2)), ID(1), IT(1), IT(2)
         I = JTRIM (ROOT)
         ROOT(I+1:) = THEDAT
         END IF
      CALL ZTRLOG (3, 'PWD', 256, CURDIR, J, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'TRANSLATING PWD'
         CALL MSGWRT (8)
         END IF
      I = JTRIM (CURDIR)
      IF (CURDIR(I:I).NE.'/') CURDIR(I+1:) = '/'
      JERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ALBUSI: ERROR',I3,' ON ',A)
 1010 FORMAT (I4.4,'/',I2.2,'/',I2.2,I3.2,':',I2.2,':',I2.2)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT (I2.2,A,3I2.2,'/')
      END
      SUBROUTINE ANTGET (IRET)
C-----------------------------------------------------------------------
C   Determines antenna average location or list of VLB antennas
C   Output
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'ALBUS.INC'
      INCLUDE 'ALBUSD.INC'
      INTEGER   I, J, ANBUFF(512), ISUBA
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
C-----------------------------------------------------------------------
      CALL GETANT (DISKIN, CNOIN, ISUBA, CATBLK, ANBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING ANTENNA FILE'
         GO TO 990
         END IF
      IF (ANAME.EQ.'VLBA') THEN
         IF (JANTS.EQ.0) THEN
            NANTS = NSTNS
            IF (NANTS.GT.ANTMAX) THEN
               MSGTXT = 'TOO MANY ANTENNAS'
               GO TO 980
               END IF
            DO 20 I = 1,NANTS
               ANTNUM(I) = I
               ANTPOS(1,I) = STNX(I)
               ANTPOS(2,I) = STNY(I)
               ANTPOS(3,I) = STNZ(I)
               ANTLL(1,I) = STNLON(I)
               ANTLL(2,I) = STNLAT(I)
               ANTLL(3,I) = STELEV(I)
 20         CONTINUE
         ELSE
            NANTS = 0
            DO 30 I = 1,NSTNS
               DO 25 J = 1,JANTS
                  IF (JANT(J).EQ.TELNO(I)) THEN
                     NANTS = NANTS + 1
                     ANTNUM(NANTS) = TELNO(I)
                     ANTPOS(1,NANTS) = STNX(I)
                     ANTPOS(2,NANTS) = STNY(I)
                     ANTPOS(3,NANTS) = STNZ(I)
                     ANTLL(1,NANTS) = STNLON(I)
                     ANTLL(2,NANTS) = STNLAT(I)
                     ANTLL(3,NANTS) = STELEV(I)
                     GO TO 30
                     END IF
 25               CONTINUE
 30            CONTINUE
            END IF
      ELSE
         JANTS = 0
         ANTPOS(1,1) = 0.0D0
         ANTPOS(2,1) = 0.0D0
         ANTPOS(3,1) = 0.0D0
         ANTLL(1,1) = 0.0D0
         ANTLL(2,1) = 0.0D0
         ANTLL(3,1) = 0.0D0
         J = 0
         NANTS = 0
         ANTNUM(1) = 1
         STNNAM(1) = ANAME
         DO 40 I = 1,NSTNS
            IF ((ABS(STNX(I)).GT.1.D3) .OR. (ABS(STNY(I)).GT.1.D3)) THEN
               J = J + 1
               ANTPOS(1,1) = ANTPOS(1,1) + STNX(I)
               ANTPOS(2,1) = ANTPOS(2,1) + STNY(I)
               ANTPOS(3,1) = ANTPOS(3,1) + STNZ(I)
               ANTLL(1,1) = ANTLL(1,1) + STNLON(I)
               ANTLL(2,1) = ANTLL(2,1) + STNLAT(I)
               ANTLL(3,1) = ANTLL(3,1) + STELEV(I)
               END IF
 40         CONTINUE
         IF (J.LE.0) THEN
            MSGTXT = 'NO VALID ANTENNAS FOUND'
            GO TO 980
            END IF
         ANTPOS(1,1) = ANTPOS(1,1) / J
         ANTPOS(2,1) = ANTPOS(2,1) / J
         ANTPOS(3,1) = ANTPOS(3,1) / J
         ANTLL(1,1) = ANTLL(1,1) / J
         ANTLL(2,1) = ANTLL(2,1) / J
         ANTLL(3,1) = ANTLL(3,1) / J
         END IF
      GO TO 999
C
 980  IRET = 10
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ANTGET ERROR',I4,' ON ',A)
      END
      SUBROUTINE SRCGET (IRET)
C-----------------------------------------------------------------------
C   Determines source list
C   Output
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'ALBUS.INC'
      INCLUDE 'ALBUSD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DPOV.INC'
      INTEGER   I, J, NS, TABUFF(512), VER, LUN, LUNTMP, NUMIF, ISURNO,
     *   SUKOLS(MAXSUC), SUNUMV(MAXSUC), FREQID, NREC, IDSOU, QUAL, K,
     *   TABVER, IPORNO, POKOLS(MAXPOC), PONUMV(MAXPOC), NP, PLS(20),
     *   JTRIM
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*8, OBSDAT*8
      REAL      FLUX(4,MAXIF)
      DOUBLE PRECISION FREQO(MAXIF), BANDW, RAEPO, DECEPO, EPOCH, RAAPP,
     *   DECAPP, RAOBS, DECOBS, LSRVEL(MAXIF), LRESTF(MAXIF), PMRA,
     *   PMDEC, SOUDST, TIME
C-----------------------------------------------------------------------
C                                       how many sources specified
      NS = 0
      DO 10 I = 1,30
         IF (SRCS(I).EQ.' ') GO TO 20
         NS = NS + 1
 10      CONTINUE
C                                       open source table
 20   LUN = LUNTMP (1)
      VER = 1
      CALL SOUINI ('READ', TABUFF, DISKIN, CNOIN, VER, CATBLK, LUN,
     *   NUMIF, VELTYP, VELDEF, FREQID, ISURNO, SUKOLS, SUNUMV, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING SOURCE TABLE'
         GO TO 990
         END IF
C                                       read source table
      NREC = TABUFF(5)
      NSORC = 0
      DO 50 I = 1,NREC
         ISURNO = I
         CALL TABSOU ('READ', TABUFF, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF, PMRA,
     *      PMDEC, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING SOURCE TABLE'
            GO TO 990
            END IF
C                                       in list?
         IF (NS.GT.0) THEN
            DO 30 J = 1,NS
               IF (SOUNAM.EQ.SRCS(J)) GO TO 40
 30            CONTINUE
            GO TO 50
            END IF
 40      IF (NSORC.GE.SRCMAX) THEN
            WRITE (MSGTXT,1040) SRCMAX
            CALL MSGWRT (8)
            GO TO 55
            END IF
         NSORC = NSORC + 1
         SRCNUM(NSORC) = IDSOU
         SRA(NSORC) = RAAPP
         SDEC(NSORC) = DECAPP
         K = JTRIM (SOUNAM)
         DO 45 J = 1,K
            IF (SOUNAM(J:J).EQ.' ') SOUNAM(J:J) = '_'
 45         CONTINUE
         SRCNAM(NSORC) = SOUNAM
 50      CONTINUE
C                                       close source table
 55   CALL TABSOU ('CLOS', TABUFF, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *   SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *   EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF, PMRA,
     *   PMDEC, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING SOURCE TABLE'
         GO TO 990
         END IF
      IF (NSORC.LE.0) THEN
         IRET = 10
         MSGTXT = 'NO SOURCES FOUND'
         GO TO 990
         END IF
C                                       planets??
      CALL LFILL (NSORC, .FALSE., ISPLAN)
      CALL FNDEXT ('PO', CATBLK, I)
      IF (I.GT.0) THEN
         CALL POINI ('READ', TABUFF, DISKIN, CNOIN, VER, CATBLK, LUN,
     *      IPORNO, POKOLS, PONUMV, OBSDAT, TABVER, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING THE PO TABLE'
            GO TO 990
            END IF
         NP = 0
         NREC = TABUFF(5)
         DO 70 I = 1,NREC
            IPORNO = I
            CALL TABPO ('READ', TABUFF, IPORNO, POKOLS, PONUMV, TIME,
     *         IDSOU, RAAPP, DECAPP, SOUDST, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING PO TABLE'
               GO TO 990
               END IF
            DO 60 J = 1,NP
               IF (IDSOU.EQ.PLS(J)) GO TO 70
 60            CONTINUE
            NP = NP + 1
            PLS(NP) = IDSOU
 70         CONTINUE
         CALL TABPO ('CLOS', TABUFF, IPORNO, POKOLS, PONUMV, TIME,
     *      IDSOU, RAAPP, DECAPP, SOUDST, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING PO TABLE'
            GO TO 990
            END IF
C                                       put in list
         DO 80 I = 1,NP
            DO 75 J = 1,NSORC
               IF (PLS(I).EQ.SRCNUM(J)) THEN
                  ISPLAN(J) = .TRUE.
                  IF (DOALL.GT.0.0) THEN
                     MSGTXT = 'DOALL SET TO 0 BECAUSE OF A PLANET'
                     CALL MSGWRT (7)
                     DOALL = 0.0
                     END IF
                  END IF
 75            CONTINUE
 80         CONTINUE
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SRCGET ERROR',I4,' ON ',A)
 1040 FORMAT ('SRCGET SOURCE LIST TERMINATED AFTER',I4,' SOURCES')
      END
      SUBROUTINE ALBUSD (IANT, ISRC, IRET)
C-----------------------------------------------------------------------
C   ALBUSD writes the python and shell scripts to text files.  It then
C   executes the ALBUS program in a container.  It then reads the ALBUS
C   output file and causes the CL and TE tables to be updated.
C   Inputs:
C      IANT   I   Antenna number
C      ISRC   I   Source number in source lists
C   Output
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IANT, ISRC, IRET
C
      INCLUDE 'ALBUS.INC'
      INCLUDE 'ALBUSD.INC'
      INCLUDE 'RIFRM.INC'
      INCLUDE 'INCS:DANS.INC'
      INTEGER   TLUN, TIND, I, J, JTRIM, HM(2), KANT, K, DHM(2)
      REAL      SEC, DSEC
      LOGICAL   FIRST, DODIR, DOAPP
      CHARACTER FNAME*256, OUTLIN*512, ENAME*256, CHM*1, COMMND*256,
     *   SYSOUT*64, OUTCOM*512, ANTC*3, DIROLD*256, SCR*500
      SAVE FIRST, DIROLD, DOAPP
      DATA FIRST, DOAPP /2*.TRUE./
      DATA TLUN /3/
      DATA DIROLD /' '/
C-----------------------------------------------------------------------
      IF (FIRST) SUMRUN = 0.0
      IF ((ABS(ANTPOS(1,IANT)).LT.1.D3) .OR.
     *   (ABS(ANTPOS(2,IANT)).LT.1.D3) .OR.
     *   (ABS(ANTPOS(3,IANT)).LT.1.D3)) THEN
         WRITE (MSGTXT,1001) IANT
         IRET = 0
         GO TO 990
         END IF
      THENAM = SRCNAM(ISRC)
      THESRC = SRCNUM(ISRC)
C                                       make output dir
      IF ((DODATE.GT.0.0) .AND. (DODATE.LT.2.0)) THEN
         J = JTRIM (ROOT)
         COMMND = 'mkdir ' // ROOT(:J)
         J = J + 6
         I = 0
         SYSOUT = ' '
         CALL ZSHCMD (J, COMMND, I, SYSOUT, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'EXECUTING MKDIR FOR DODATE>0'
            GO TO 990
            END IF
         DODATE = 3.0
         END IF
C                                       store adverbs
      IF (DOADV) THEN
         CALL ADVERB (IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING ADVERB FILE'
            GO TO 990
            END IF
         DOADV = .FALSE.
         END IF
C                                       DOALL - write source list
      IF (DOALL.GT.0.0) THEN
         J = JTRIM (ROOT)
         SRCTXT = ROOT(:J) // 'source_list.txt'
         MSGSUP = 32000
         CALL ZTXZAP (TLUN, SRCTXT, IRET)
         IRET = 0
         MSGSUP = 0
         CALL ZTXOPN ('WRIT', TLUN, TIND, SRCTXT, .FALSE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATING SOURCE LIST FILE'
            GO TO 990
            END IF
         DO 20 I = 1,NSORC
            CALL COORDD (1, SRA(I), CHM, HM, SEC)
            CALL COORDD (2, SDEC(I), CHM, DHM, DSEC)
            J = JTRIM (SRCNAM(I))
            WRITE (OUTLIN,1020) HM, SEC, CHM, DHM, DSEC,
     *         SRCNAM(I)(:J)
            J = JTRIM (OUTLIN)
            CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITING SOURCE LIST FILE'
               GO TO 990
               END IF
 20         CONTINUE
         CALL ZTXCLS (TLUN, TIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING SOURCE LIST FILE'
            GO TO 990
            END IF
         THENAM = 'Allsource'
         THESRC = 0
         END IF
C                                       DOALL - write station list
      IF (NUMSTN.GT.0.0) THEN
         J = JTRIM (ROOT)
         STNTXT = ROOT(:J) // 'list_station.txt'
         MSGSUP = 32000
         CALL ZTXZAP (TLUN, STNTXT, IRET)
         IRET = 0
         MSGSUP = 0
         CALL ZTXOPN ('WRIT', TLUN, TIND, STNTXT, .FALSE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATING STATION LIST FILE'
            GO TO 990
            END IF
         WRITE (OUTLIN,1030) (STATNS(I), I=1,NUMSTN)
         WRITE (SCR,1031) (STATNS(I), I=1,NUMSTN)
         J = JTRIM (SCR)
         SCR(J-1:) = ']'
         J = JTRIM (OUTLIN)
         OUTLIN(J:) = ' '
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING STATION LIST FILE'
            GO TO 990
            END IF
         CALL ZTXCLS (TLUN, TIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING STATION LIST FILE'
            GO TO 990
            END IF
         END IF
C                                       processing message
      J = JTRIM (SRCNAM(ISRC))
      KANT = ANTNUM(IANT)
      IF (DOALL.GT.0.0) THEN
         IF (NANTS.EQ.0) THEN
            MSGTXT = 'Processing all sources all antennas'
            ANTC = ' '
         ELSE
            WRITE (MSGTXT,1004) KANT, STNNAM(KANT)
            WRITE (ANTC,1007) KANT
            END IF
      ELSE IF (NANTS.EQ.0) THEN
         WRITE (MSGTXT,1005) SRCNUM(ISRC), SRCNAM(ISRC)(:J)
         ANTC = ' '
      ELSE
         WRITE (MSGTXT,1006) SRCNUM(ISRC), SRCNAM(ISRC)(:J), KANT,
     *      STNNAM(KANT)
         WRITE (ANTC,1007) KANT
         END IF
      CALL MSGWRT (4)
      IF ((CLVIN.EQ.CLVOUT) .AND. (TEVOUT.GT.0)) FIRST = .FALSE.
C                                       output file name
C                                       remove old versions if any
      J = JTRIM (ROOT)
      IF (DOBTW.LE.0.0) THEN
         FNAME = ROOT(:J) // 'albus_report_parallel_RI_' // TECTYP //
     *      '_' // THENAM
      ELSE
         FNAME = ROOT(:J) // 'albus_report_serial_RI_' // TECTYP //
     *      '_' // THENAM
         END IF
      MSGSUP = 32000
      CALL ZTXZAP (TLUN, FNAME, IRET)
      IF (NANTS.LT.1) THEN
         WRITE (FNAME,1010) ROOT(:J), THESRC
      ELSE
         WRITE (FNAME,1011) ROOT(:J), THESRC, KANT
         END IF
      CALL ZTXZAP (TLUN, FNAME, IRET)
      IRET = 0
      MSGSUP = 0
C                                       python file open
      CALL ZTXOPN ('WRIT', TLUN, TIND, FNAME, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATING PYTHON OUTPUT FILE'
         GO TO 990
         END IF
      OUTLIN = 'import os'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = 'import time'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = 'import MS_Iono_functions as iono'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = 'import math'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = 'import numpy as np'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = 'import Albus_RINEX'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
C                                       station file proc
      IF (NUMSTN.GT.0) THEN
         OUTLIN = 'def read_stations_from_csv(filepath):'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         OUTLIN = '  try:'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         OUTLIN = '    with open(filepath, ''r'') as f:'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         OUTLIN = '      # Read the first line, strip whitespace, and'
     *      // ' split by the comma ('','')'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         OUTLIN = '      first_line = f.readline().strip()'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         OUTLIN = '      if first_line:'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         OUTLIN = '        gps_station_list = [station.strip() for'
     *      // ' station in first_line.split('','')]'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         OUTLIN = '        return gps_station_list'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         OUTLIN = '      else:'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         OUTLIN = '        return[]'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         OUTLIN = '  except FileNotFoundError:'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         OUTLIN = '    print(f"Error: File not found at {filepath}")'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         OUTLIN = '    return[]'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         END IF
      OUTLIN = 'if __name__ == "__main__":'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = '  os.system(''date'')'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = '  process_start = time.time()'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = '  startime = time.strftime("%a, %d %b %Y %H:%M:%S",' //
     *   ' time.localtime())'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = '  print("program start at %s" % startime)'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      WRITE (OUTLIN,2000) (ANTPOS(I,IANT), I = 1,3)
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      IF (DOALL.LE.0.0) THEN
         CALL COORDD (1, SRA(ISRC), CHM, HM, SEC)
         WRITE (OUTLIN,2010) 'RA', ' ', HM, SEC
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         CALL COORDD (2, SDEC(ISRC), CHM, HM, SEC)
         WRITE (OUTLIN,2010) 'DEC', CHM, HM, SEC
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         END IF
      OUTLIN = '  START_TIME="' // CSTART // '"'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = '  END_TIME="' // CSTOP // '"'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      J = JTRIM (ROOT)
      OUTlIN = '  OUTPUT_DIR="' // ROOT(:J) // '"'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      J = JTRIM (ROOT)
      IF (DOBTW.LE.0.0) THEN
         IF (NANTS.LE.0) THEN
            WRITE (MSGTXT,2005) SRCNUM(ISRC), 0
         ELSE
            WRITE (MSGTXT,2005) SRCNUM(ISRC), KANT
            END IF
      ELSE
         IF (NANTS.LE.0) THEN
            WRITE (MSGTXT,2005) 0
         ELSE
            WRITE (MSGTXT,2005) KANT
            END IF
         END IF
      K = JTRIM(MSGTXT)
      DIRDAT = ROOT(:J) // MSGTXT(:K)
      DODIR = DIRDAT.NE.DIROLD
      DIROLD = DIRDAT
      OUTlIN = '  DATA_DIR="' // DIRDAT(:K+J) // '"'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = '  RED_TYPE = ''RI_' // TECTYP // ''''
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = '  TIME_STEP = 300'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      IF (PRTLEV.GT.2.0) THEN
         OUTLIN = '  iono.set_debug_option(True)'
      ELSE
         OUTLIN = '  iono.set_debug_option(False)'
         END IF
      J = JTRIM (OUTLIN)
c      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      IF ((XRAD.GT.50.) .AND. (XRAD.LT.1000.1)) THEN
         RADIUS = XRAD + 0.5
         WRITE (OUTLIN,2015) RADIUS
      ELSE IF (STNNAM(KANT).EQ.'OV') THEN
         OUTLIN = '  MAX_DIST = 150E3'
         RADIUS = 150
      ELSE
         OUTLIN = '  MAX_DIST = 300E3'
         RADIUS = 300
         END IF
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      IF (ABS(DOBTW).GE.10.0) THEN
         OUTLIN = '  NUM_PROCESSORS = 1'
      ELSE
         OUTLIN = '  NUM_PROCESSORS = 36'
         END IF
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      IF (DOBTW.GT.0.0) THEN
         OUTLIN = '  DO_SER = 1'
      ELSE
         OUTLIN = '  DO_SER = 0'
         END IF
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      IF ((DETIME.LT.100.) .OR. (DETIME.GT.600.)) DETIME = 250.
      K = DETIME
      WRITE (OUTLIN,2020) K
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      J = JTRIM (THENAM)
      OUTLIN = '  OBJECT="' // THENAM(:J) // '"'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      IF (DOALL.GT.0.0) THEN
         J = JTRIM (SRCTXT)
         OUTLIN = '  positions_file = "' // SRCTXT(:J) // '"'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         OUTLIN = '  positions_ascii = np.loadtxt(positions_file, ' //
     *      'delimiter='','', dtype=str)'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         OUTLIN = '  print(''positions ascii'', positions_ascii)'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         END IF
      IF (NUMSTN.GT.0) THEN
         OUTLIN = '  GPS_FILE_PATH = ''list_station.txt'''
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         OUTLIN = '  GPS_STATION_LIST = read_stations_from_csv' //
     *      '(GPS_FILE_PATH)'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
      END IF
      J = JTRIM (SCR)
      IF ((NUMSTN.GT.0) .AND. (DOALL.GT.0.0)) THEN
         OUTCOM = '  iono.process_ionosphere_multi_dir(' //
     *      'time_step=TIME_STEP,telescope_pos=stn,end_time=END_TIME,'
     *      // 'start_time=START_TIME,max_dist=MAX_DIST,' //
     *      'processing_option=RED_TYPE,num_processors=NUM_PROCESSORS,'
     *      // 'gps_data_directory=DATA_DIR,do_serial=DO_SER,'
     *      // 'output_data_directory=OUTPUT_DIR,' //
     *      'positions_file=positions_ascii,object=OBJECT,'
     *      // 'station_list=' // SCR(:J) // ')'
C     *      // 'station_list=GPS_STATION_LIST)'
      ELSE IF (NUMSTN.GT.0) THEN
         OUTCOM = '  iono.process_ionosphere(' //
     *      'time_step=TIME_STEP,telescope_pos=stn,end_time=END_TIME,'
     *      // 'start_time=START_TIME,max_dist=MAX_DIST,' //
     *      'processing_option=RED_TYPE,num_processors=NUM_PROCESSORS,'
     *      // 'gps_data_directory=DATA_DIR,do_serial=DO_SER,'
     *      // 'output_data_directory=OUTPUT_DIR,' //
     *     'object=OBJECT,Ra=RA,Dec=DEC,'
     *      // 'station_list=' // SCR(:J) // ')'
c     *      // 'GPS_STATION_LIST=' // SCR(:J) // ')'
C    *      'gps_station_list=GPS_STATION_LIST)'
      ELSE IF (DOALL.GT.0.0) THEN
         OUTCOM = '  iono.process_ionosphere_multi_dir(' //
     *      'time_step=TIME_STEP,telescope_pos=stn,end_time=END_TIME,'
     *      // 'start_time=START_TIME,max_dist=MAX_DIST,' //
     *      'processing_option=RED_TYPE,num_processors=NUM_PROCESSORS,'
     *      // 'gps_data_directory=DATA_DIR,do_serial=DO_SER,'
     *      // 'output_data_directory=OUTPUT_DIR,' //
     *      'positions_file=positions_ascii,object=OBJECT)'
      ELSE IF (ISPLAN(ISRC)) THEN
         J = JTRIM (SRCNAM(ISRC))
         OUTCOM = '  iono.process_ionosphere(time_step=TIME_STEP,' //
     *      'object=OBJECT,telescope_pos=stn,start_time=START_TIME,'//
     *      'end_time=END_TIME,max_dist=MAX_DIST,' //
     *      'special_body="' // SRCNAM(ISRC)(:J) // '",' //
     *      'processing_option=RED_TYPE,num_processors=NUM_PROCESSORS,'
     *      // 'gps_data_directory=DATA_DIR,do_serial=DO_SER,'
     *      // 'output_data_directory=OUTPUT_DIR)'
      ELSE
         OUTCOM = '  iono.process_ionosphere(time_step=TIME_STEP,' //
     *      'object=OBJECT,Ra=RA,Dec=DEC,telescope_pos=stn,start_time'//
     *      '=START_TIME,end_time=END_TIME,max_dist=MAX_DIST,' //
     *      'processing_option=RED_TYPE,num_processors=NUM_PROCESSORS,'
     *      // 'gps_data_directory=DATA_DIR,do_serial=DO_SER,'
     *      // 'output_data_directory=OUTPUT_DIR)'
         END IF
      J = JTRIM (OUTCOM)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTCOM(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = '  os.system(''date'')'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = '  endtime = time.strftime("%a, %d %b %Y %H:%M:%S"' //
     *   ', time.localtime())'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = '  print("program end at %s" % endtime)'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = '  print ('' '')'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = '  process_end = time.time()'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = '  duration = (process_end - process_start)/60.0'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = '  print("program total run time: %7.2f minutes"' //
     *   ' % duration);'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      OUTLIN = ' '
      J = 4
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
C                                       quit
      CALL ZTXCLS (TLUN, TIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING PYTHON FILE'
         GO TO 990
         END IF
C                                       executable file
      J = JTRIM (ROOT)
      ENAME = ROOT(:J) // 'doit'
      MSGSUP = 32000
      CALL ZTXZAP (TLUN, ENAME, IRET)
      IRET = 0
      MSGSUP = 0
      CALL ZTXOPN ('WRIT', TLUN, TIND, ENAME, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATING EXECUTABLE FILE'
         GO TO 990
         END IF
      OUTLIN = 'export APPTAINER_BIND="' // ROOT(:J) // '"'
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 985
      IF (DOAPP) THEN
         OUTLIN = 'echo $APPTAINER_BIND'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 985
         DOAPP = .FALSE.
         END IF
      OUTLIN = 'chmod +x ' // FNAME
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 985
      OUTLIN = 'cat ' // FNAME
      IF (PRTLEV.GT.1.0) THEN
         J = JTRIM (ROOT)
         K = JTRIM (OUTLIN)
         OUTLIN(K+1:) = ' >> ' // ROOT(:J) // 'msg.txt 2>&1'
         END IF
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 985
      IF (DODIR) THEN
         J = JTRIM (DIRDAT)
         OUTLIN = '"/bin/rm" -rf ' // DIRDAT(:J) // '/'
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 985
         END IF
      IF (PRGT.EQ.'SINGULARITY') THEN
         IF (ALBVER.EQ.'0.1') THEN
            OUTLIN = 'singularity exec $LOAD/contain_albus_0.1.sif '
     *         // 'python ' // FNAME
         ELSE
            OUTLIN = 'singularity exec $LOAD/contain_albus.sif python '
     *         // FNAME
            END IF
      ELSE
         IF (ALBVER.EQ.'0.1') THEN
            OUTLIN = 'apptainer exec $LOAD/contain_albus_0.1.sif python'
     *         // ' ' // FNAME
         ELSE
            OUTLIN = 'apptainer exec $LOAD/contain_albus.sif python ' //
     *         FNAME
            END IF
         END IF
      IF (PRTLEV.GT.1.0) THEN
         J = JTRIM (ROOT)
         K = JTRIM (OUTLIN)
         OUTLIN(K+1:) = ' >> ' // ROOT(:J) // 'msg.txt 2>&1'
         END IF
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 985
      IF (ANTC.NE.' ') THEN
         J = JTRIM (ROOT)
         K = JTRIM (THENAM)
         IF (DOBTW.LE.0.0) THEN
            OUTLIN = ROOT(:J) // 'albus_report_parallel_RI_' // TECTYP
     *         // '_' // THENAM(:K)
            FNAME = ROOT(:J) // 'albus_report_parallel_RI_' // TECTYP
     *         // '_' // THENAM(:K) // ANTC
         ELSE
            OUTLIN = ROOT(:J) // 'albus_report_serial_RI_' // TECTYP
     *         // '_' // THENAM(:K)
            FNAME = ROOT(:J) // 'albus_report_serial_RI_' // TECTYP
     *         // '_' // THENAM(:K) // ANTC
            END IF
         J = JTRIM (OUTLIN)
         OUTCOM = '"/bin/mv" ' // OUTLIN(:J+1) // FNAME
         J = JTRIM (OUTCOM)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTCOM(:J), IRET)
         IF (IRET.NE.0) GO TO 985
         END IF
      CALL ZTXCLS (TLUN, TIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING PYTHON FILE'
         GO TO 990
         END IF
      COMMND = 'chmod +x ' // ENAME
      J = JTRIM (COMMND)
      MSGTXT = 'Doing command;'
      CALL MSGWRT (2)
      MSGTXT = COMMND(:MIN(80,J))
      CALL MSGWRT (2)
      I = 0
      SYSOUT = ' '
      CALL ZSHCMD (J, COMMND, I, SYSOUT, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'EXECUTING chmod +x doit'
         GO TO 990
         END IF
      COMMND = ENAME
      J = JTRIM (COMMND)
      MSGTXT = 'Doing command;'
      CALL MSGWRT (2)
      MSGTXT = COMMND(:MIN(80,J))
      CALL MSGWRT (2)
      I = 0
      SYSOUT = ' '
      CALL ZSHCMD (J, COMMND, I, SYSOUT, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'EXECUTING PYTHON SCRIPT'
         GO TO 990
         END IF
C                                       CL TE file update
      THEANT = 0
      IF (NANTS.GT.0) THEANT = KANT
      J = JTRIM (ROOT)
      K = JTRIM (THENAM)
C                                       ????
      IF (DOBTW.LE.0.0) THEN
         FNAME = ROOT(:J) // 'albus_report_parallel_RI_' // TECTYP //
     *      '_' // THENAM(:K) // ANTC
      ELSE
         FNAME = ROOT(:J) // 'albus_report_serial_RI_' // TECTYP //
     *      '_' // THENAM(:K) // ANTC
         END IF
      IF (FIRST) THEN
         TENEW = .TRUE.
         CALL RIFRMA (DISKIN, CNOIN, THESRC, THEANT, TEVOUT, CLVIN,
     *      CLVOUT, FNAME, TECTYP, IRET)
         FIRST = .FALSE.
         TENEW = .FALSE.
      ELSE
         CALL RIFRMO (DISKIN, CNOIN, THESRC, THEANT, TEVOUT, CLVOUT,
     *      FNAME, TECTYP, IRET)
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'UPDATING CL AND TE TABLES'
         GO TO 990
         END IF
      GO TO 999
C
 980  WRITE (MSGTXT,1000) IRET, 'WRITING PYTHON FILE'
      GO TO 990
C
 985  WRITE (MSGTXT,1000) IRET, 'WRITING EXECUTABLE FILE'
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ALBUSD ERROR',I4,' ON ',A)
 1001 FORMAT ('SKIPPING ANTENNA',I3,' POSITION NEAR 0')
 1004 FORMAT ('Processing all sources, antenna',I3,1X,A)
 1005 FORMAT ('Processing source',I3,1X,A,'    all antennas')
 1006 FORMAT ('Processing source',I3,1X,A,' antenna',I3,1X,A)
 1007 FORMAT ('_',I2.2)
 1010 FORMAT (A,'ALBSRC',I3.3,'dat.py')
 1011 FORMAT (A,'ALBSRC',I3.3,'ANT',I2.2,'dat.py')
 1020 FORMAT (2(I2.2,':'),F8.5,',',A,2(I2.2,':'),F8.5,',',A,',')
 1030 FORMAT (20(A4,','))
 1031 FORMAT ('[',20('''',A4,''','))
 2000 FORMAT ('  stn=np.array([[',F12.3,',',F12.3,',',F12.3,
     *   ']])')
 2005 FORMAT ('ALBUSdata',2I2.2)
 2010 FORMAT ('  ',A,' = "',A,I2.2,':',I2.2,':',F8.5,'"')
 2015 FORMAT ('  MAX_DIST = ',I4,'E3')
 2020 FORMAT ('  Albus_RINEX.DEFAULT_TIMEOUT=',I5)
      END
      SUBROUTINE ADVERB (IRET)
C-----------------------------------------------------------------------
C   Writes out text file with adverb values
C   Output
C      IRET   I   error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'ALBUS.INC'
      INCLUDE 'ALBUSD.INC'
      CHARACTER OUTLIN*80
      INTEGER   TLUN, TIND, JTRIM, J, I
      INCLUDE 'INCS:DMSG.INC'
      DATA TLUN /11/
C-----------------------------------------------------------------------
      J = JTRIM (ROOT)
      SRCTXT = ROOT(:J) // 'albus.inputs.txt'
      MSGSUP = 32000
      CALL ZTXZAP (TLUN, SRCTXT, IRET)
      IRET = 0
      MSGSUP = 0
      CALL ZTXOPN ('WRIT', TLUN, TIND, SRCTXT, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATING ADVERB LIST FILE'
         GO TO 980
         END IF
      J = JTRIM (NAMEIN)
      OUTLIN = 'INNAME = ''' // NAMEIN(:J) // ''''
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 900
      J = JTRIM (CLAIN)
      OUTLIN = 'INCLASS = ''' // CLAIN(:J) // ''''
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 900
      WRITE (OUTLIN,2000) 'INSEQ', SEQIN
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 900
      WRITE (OUTLIN,2000) 'INDISK', DISKIN
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 900
      DO 20 I = 1,NSORC
         J = JTRIM (SRCNAM(I))
         WRITE (OUTLIN,2010) 'SOURCES', I, SRCNAM(I)(:J)
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 900
 20      CONTINUE
      DO 30 I = 1,NANTS
         WRITE (OUTLIN,2011) 'ANTENNAS', I, ANTNUM(I)
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 900
 30      CONTINUE
      WRITE (OUTLIN,2000) 'GAINVER', CLVIN
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 900
      WRITE (OUTLIN,2000) 'GAINUSE', CLVOUT
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 900
      J = JTRIM (DATDIR)
      OUTLIN = 'DATAOUT = ''' // DATDIR(:J) // ''''
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 900
      WRITE (OUTLIN,2001) 'DODATE', DODATE
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 900
      OUTLIN = 'TECRTYPE = ''' // TECTYP // ''''
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 900
      WRITE (OUTLIN,2001) 'DETIME', DETIME
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 900
      WRITE (OUTLIN,2001) 'DOBTWEEN', DOBTW
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 900
      WRITE (OUTLIN,2001) 'RADIUS', XRAD
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 900
      WRITE (OUTLIN,2001) 'DOALL', DOALL
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 900
      DO 40 I = 1,MAX(1,NUMSTN)
         WRITE (OUTLIN,2012) 'STATIONS', I, STATNS(I)
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 900
 40      CONTINUE
      WRITE (OUTLIN,2020) 'AVERSION', ALBVER
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:J), IRET)
      IF (IRET.EQ.0) GO TO 990
C
 900  WRITE (MSGTXT,1000) IRET, 'WRITING INPUTS LIST FILE'
 980  CALL MSGWRT (8)
C
 990  CALL ZTXCLS (TLUN, TIND, I)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ADVERB: ERROR',I4,' ON ',A)
 2000 FORMAT (A,' =',I6)
 2001 FORMAT (A,' =',F7.1)
 2010 FORMAT (A,'(',I3.3,') = ',A)
 2011 FORMAT (A,'(',I3.3,') =',I4)
 2012 FORMAT (A,'(',I2.2,') = ''',A4,'''')
 2020 FORMAT (A,' = ''',A4,'''')
      END
      SUBROUTINE STATID (IRET)
C-----------------------------------------------------------------------
C   Adds station ID to text file with adverb values
C   Output
C      IRET   I   error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'ALBUS.INC'
      INCLUDE 'ALBUSD.INC'
      CHARACTER OUTLIN*80, TEST*4
      LOGICAL   DONEG
      INTEGER   TLUN, TIND, JTRIM, J, I, LUN, FIND, KBP, KBPLIM, NS, K
      DOUBLE PRECISION XX, LONG, LAT, ST, CT, YY, ZZ
      REAL      AGDIST(STNMAX), MDIST, AGP(2,STNMAX)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUN, TLUN /3, 11/
C-----------------------------------------------------------------------
      CALL RFILL (STNMAX, 9999.0, AGDIST)
C                                       count stations used
      NS = 0
      DO 10 I = 1,STNMAX
         IF (AGSTAT(I).EQ.' ') GO TO 15
         NS = I
 10      CONTINUE
C
C                                       open files
 15   J = JTRIM (ROOT)
      OUTLIN = ROOT(:J) // 'albus.inputs.txt'
      CALL ZTXOPN ('WRIT', TLUN, TIND, OUTLIN, .TRUE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'ADDING TO ADVERB LIST FILE'
         GO TO 980
         END IF
      OUTLIN = 'AIPSIONS:ALBUS.stations'
      CALL ZTXOPN ('READ', LUN, FIND, OUTLIN, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING ALBUS STATIONS LIST FILE'
         GO TO 980
         END IF
C                                       header
      IF (THEANT.GT.0) THEN
         IF (THESRC.GT.0) THEN
            J = JTRIM (THENAM)
            WRITE (MSGTXT,1015) THENAM(:J), THEANT, STNNAM(THEANT)
         ELSE
            WRITE (MSGTXT,1016) THEANT, STNNAM(THEANT)
            END IF
         IF (NUMHIS.LT.HISMAX) THEN
            NUMHIS = NUMHIS + 1
            HISCRD(NUMHIS) = MSGTXT(:64)
            END IF
      ELSE
         MSGTXT =  'Finding stations for whole array for source ' //
     *      THENAM
         END IF
      CALL MSGWRT (3)
      J = JTRIM (MSGTXT)
      CALL ZTXIO ('WRIT', TLUN, TIND, MSGTXT(:J), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET,
     *      'WRITING ALBUS STATIONS TO ADVERB FILE'
         GO TO 980
         END IF
      IF (NEWANT) THEN
         J = 0
 20      K = J + 1
         J = MIN (K+7, NS)
         WRITE (MSGTXT,1020) (AGSTAT(I), I = K,J)
         IF (NUMHIS.LT.HISMAX) THEN
            NUMHIS = NUMHIS + 1
            HISCRD(NUMHIS) = MSGTXT(:64)
            END IF
         IF (J.LT.NS) GO TO 20
         END IF
C                                       read precursor part
 25   CALL ZTXIO ('READ', LUN, FIND, OUTLIN, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING ALBUS STATIONS LIST START'
         GO TO 980
         END IF
      IF (OUTLIN(:8).NE.'+SITE/ID') GO TO 25
C                                       read data part
 30   CALL ZTXIO ('READ', LUN, FIND, OUTLIN, IRET)
      IF (IRET.EQ.2) THEN
         IRET = 0
         GO TO 900
      ELSE IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING ALBUS STATIONS LIST DATA'
         GO TO 980
         END IF
      IF (OUTLIN(:1).EQ.'#') GO TO 30
      KBPLIM = JTRIM (OUTLIN)
      IF (KBPLIM.LT.70) GO TO 30
      IF (OUTLIN(:8).EQ.'-SITE/ID') GO TO 900
      TEST = OUTLIN(2:5)
      DO 35 I = 1,NS
         IF (TEST.EQ.AGSTAT(I)) GO TO 50
 35      CONTINUE
      GO TO 30
C                                       Got one!
 50   IF (OUTLIN(58:58).EQ.'-') THEN
         DONEG = .TRUE.
         OUTLIN(58:58) = ' '
      ELSE
         DONEG = .FALSE.
         END IF
      KBP = 44
      CALL GETNUM (OUTLIN, KBPLIM, KBP, XX)
      IF (XX.EQ.DBLANK) GO TO 30
      LONG = XX
      CALL GETNUM (OUTLIN, KBPLIM, KBP, XX)
      IF (XX.EQ.DBLANK) GO TO 30
      LONG = LONG + XX/60.0D0
      CALL GETNUM (OUTLIN, KBPLIM, KBP, XX)
      IF (XX.EQ.DBLANK) GO TO 30
      LONG = LONG + XX/3600.0D0
      CALL GETNUM (OUTLIN, KBPLIM, KBP, XX)
      IF (XX.EQ.DBLANK) GO TO 30
      LAT = ABS(XX)
      CALL GETNUM (OUTLIN, KBPLIM, KBP, XX)
      IF (XX.EQ.DBLANK) GO TO 30
      LAT = LAT + ABS(XX)/60.0D0
      CALL GETNUM (OUTLIN, KBPLIM, KBP, XX)
      IF (XX.EQ.DBLANK) GO TO 30
      LAT = LAT + ABS(XX)/3600.0D0
      LONG = LONG * DG2RAD
      LAT = LAT * DG2RAD
      IF (DONEG) LAT = -LAT
      XX = 1.0D0 - COS(LAT-THELAT) +
     *   COS(LAT) * COS(THELAT) * (1.D0 - COS(LONG-THELON))
      XX = SQRT (MAX (0.0D0, XX/2.D0))
      XX = 2.D0 * 6378.D0 * XX
      YY = SIN((THELAT-LAT)/2.0D0)**2 +
     *   COS(THELAT)*COS(LAT)*(SIN((LONG-THELON)/2.D0)**2)
      YY = 2.0D0 * ATAN2 (SQRT(YY), SQRT(1.D0-YY)) * 6378.D0
      ZZ = SIN(LAT)*SIN(THELAT) + COS(LAT)*COS(THELAT)*COS(LONG-THELON)
      ZZ = ACOS(ZZ)
      ZZ = 40075 * ZZ / TWOPI
      AGDIST(I) = (XX + YY + ZZ) / 3.0D0
C
      XX = SIN(LAT)*SIN(THELAT) + COS(LAT)*COS(THELAT)*COS(LONG-THELON)
      XX = MAX (-1.0D0, MIN (1.0D0, XX))
      XX = ACOS (XX)
      ST = SIN(THELON-LONG) * COS (THELAT) / SIN (XX)
      ST = MAX (-1.0D0, MIN (1.0D0, ST))
      CT = (SIN(THELAT)*COS(LAT)-COS(THELAT)*SIN(LAT)*COS(THELON-LONG))
     *    / SIN(XX)
      ST = RAD2DG * ATAN2 (ST, CT) + 180.0
      IF (ST.GT.180.) ST = ST - 360.
      AGP(1,I) = 6378.0D0 * XX
      AGP(2,I) = ST
      KBPLIM= MIN (79, KBPLIM)
      MSGTXT = OUTLIN(2:7) // OUTLIN(22:43) // OUTLIN(44:KBPLIM)
      IF (.NOT.NEWANT) THEN
         DO 60 J = HISTRT,NUMHIS
            IF (MSGTXT(:4).EQ.HISCRD(J)(:4)) GO TO 30
 60         CONTINUE
         END IF
      IF (NUMHIS.LT.HISMAX) THEN
         NUMHIS = NUMHIS + 1
         HISCRD(NUMHIS) = MSGTXT(:64)
         END IF
      CALL MSGWRT(3)
      CALL ZTXIO ('WRIT', TLUN, TIND, OUTLIN(:KBPLIM), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET,
     *      'WRITING ALBUS STATIONS TO ADVERB FILE'
         GO TO 980
         END IF
      GO TO 30
C                                       sort/print distances
 900  MDIST = 7000.
      J = 0
      DO 910 I = 1,NS
         IF (AGDIST(I).LT.MDIST) THEN
            MDIST = AGDIST(I)
            J = I
            END IF
 910     CONTINUE
      IF (J.GT.0) THEN
         WRITE (MSGTXT,1910) AGSTAT(J), AGSTAC(J), AGP(1,J), AGP(2,J)
         AGDIST(J) = 100000.
         IF (.NOT.NEWANT) THEN
            DO 920 I = HISTRT,NUMHIS
               IF (AGSTAT(J).EQ.HISCRD(I)(33:36)) GO TO 900
 920           CONTINUE
            END IF
         IF (NUMHIS.LT.HISMAX) THEN
            NUMHIS = NUMHIS + 1
            HISCRD(NUMHIS) = MSGTXT(:64)
            END IF
         CALL MSGWRT (3)
         J = JTRIM (MSGTXT)
         CALL ZTXIO ('WRIT', TLUN, TIND, MSGTXT(:J), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET,
     *         'WRITING ALBUS STATIONS TO ADVERB FILE'
            GO TO 980
            END IF
         GO TO 900
         END IF
      DO 940 I = 1,NS
         IF (AGDIST(I).EQ.9999.0) THEN
            WRITE (MSGTXT,1920) AGSTAT(I)
            IF (.NOT.NEWANT) THEN
               DO 930 J = HISTRT,NUMHIS
                  IF (AGSTAT(I).EQ.HISCRD(J)(33:36)) GO TO 940
 930              CONTINUE
               END IF
            IF (NUMHIS.LT.HISMAX) THEN
               NUMHIS = NUMHIS + 1
               HISCRD(NUMHIS) = MSGTXT(:64)
               END IF
            CALL MSGWRT (3)
            J = JTRIM (MSGTXT)
            CALL ZTXIO ('WRIT', TLUN, TIND, MSGTXT(:J), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET,
     *            'WRITING ALBUS STATIONS TO ADVERB FILE'
               GO TO 980
               END IF
            END IF
 940     CONTINUE
      GO TO 990
C
 980  CALL MSGWRT (8)
C
 990  CALL ZTXCLS (TLUN, TIND, I)
      CALL ZTXCLS (LUN, FIND, I)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('STATID: ERROR',I4,' ON ',A)
 1015 FORMAT ('Finding stations for source ',A,' antenna',I3,1X,A)
 1016 FORMAT ('Finding stations for all sources, antenna',I3,1X,A)
 1020 FORMAT ('Stations used',8(2X,A))
 1910 FORMAT ('Approximate distance to station ',A,1X,A,F8.1,
     *   ' km at az',F7.0)
 1920 FORMAT ('Approximate distance to station ',A,' UNKNOWN')
      END
      SUBROUTINE RIFRMA (DISKIN, CNOIN, THESRC, THEANT, TEVOUT, CLVIN,
     *   CLVOUT, INFILE, TECTYP, IRET)
C-----------------------------------------------------------------------
C   Reads the input text file(s), copies the CL & TE table
C   Inputs:
C      DISKIN   I       Data set disk
C      CNOIN    I       Data set catalog number
C      THESRC   I       Data set source number
C      THEANT   I       Data set antenna number, 0 -> all
C      TEVOUT   I       Data set TE version number
C      CLVIN    I       Data set CL input version number
C      CLVOUT   I       Data set CL output version number
C      INFILE   C*(*)   ALBUS output data file
C   Output:
C      IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   DISKIN, CNOIN, THESRC, THEANT, TEVOUT, CLVIN, CLVOUT,
     *   IRET
      CHARACTER INFILE*(*), TECTYP*3
C
      INCLUDE 'RIFRM.INC'
      INTEGER   INBUFF(512), OUBUFF(512), LUNI, LUNO, ICLRNO, NUMANT,
     *   CLKOLS(MAXCLC), CLNUMV(MAXCLC), NUMPOL, NUMIF, NTERM, SOURID,
     *   ANTNO, SUBA, FREQID, REFA(2,MAXIF), NREC, I, ITERNO, TUNO,
     *   TEKOLS(16), TENUMV(16), OUTUFF(512)
      REAL      GMMOD, TIMEI, IFR, DOPOFF(MAXIF), ATMOS, DATMOS,
     *   MBDELY(2), CLOCK(2), DCLOCK(2), DISP(2), DDISP(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF),
     *   WEIGHT(2,MAXIF), TEDATA(16)
      DOUBLE PRECISION TIME, GEODLY(MAXIF)
      CHARACTER  RDATE*8, TECRTY*8
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNI, LUNO, TUNO /16, 17, 19/
C-----------------------------------------------------------------------
      CALL RIFRMG (INFILE, IRET)
      IF (IRET.NE.0) GO TO 999
      TECRTY = 'ALBUS' // TECTYP
      CALL H2CHR (8, 1, CATH(KHDOB), RDATE)
C                                       Output new TE table
      CALL TEINI ('WRIT', OUTUFF, DISKIN, CNOIN, TEVOUT, CATBLK, TUNO,
     *   ITERNO, TEKOLS, TENUMV, RDATE, TECRTY, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING NEW OUTPUT TE TABLE'
         GO TO 990
         END IF
C                                       input CL table
      CALL CALINI ('READ', INBUFF, DISKIN, CNOIN, CLVIN, CATBLK, LUNI,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT CL TABLE'
         GO TO 990
         END IF
C                                       Output CL table
      CALL CALINI ('WRIT', OUBUFF, DISKIN, CNOIN, CLVOUT, CATBLK, LUNO,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT CL TABLE'
         GO TO 990
         END IF
C                                       read loop
      NREC = INBUFF(5)
      DO 20 I = 1,NREC
         ICLRNO = I
         CALL TABCAL ('READ', INBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT CL TABLE'
            GO TO 990
            END IF
C                                      get new IFR
         IF (((THEANT.EQ.0) .OR. (THEANT.EQ.ANTNO)) .AND.
     *      ((THESRC.EQ.0) .OR. (SOURID.EQ.THESRC))) THEN
            CALL IFRGET (TIME, THESRC, SOURID, IFR, DISP, TEDATA)
            IF (IFR.EQ.FBLANK) BADIFR = BADIFR + 1
            IF (IFR.NE.FBLANK) GUDIFR = GUDIFR + 1
            END IF
         ICLRNO = I
         CALL TABCAL ('WRIT', OUBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT CL TABLE'
            GO TO 990
            END IF
         ITERNO = I
         CALL TABTE ('WRIT', OUTUFF, ITERNO, TEKOLS, TENUMV, TIME,
     *      SOURID, ANTNO, TEDATA(1), TEDATA(2), TEDATA(3), TEDATA(4),
     *      TEDATA(5), TEDATA(6), TEDATA(7), TEDATA(8), TEDATA(11),
     *      TEDATA(12), TEDATA(13), TEDATA(14), TEDATA(15), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT TE TABLE'
            GO TO 990
            END IF
 20      CONTINUE
C                                       close
      ICLRNO = NREC
      CALL TABCAL ('CLOS', OUBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *   NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *   GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *   DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OUTPUT CL TABLE'
         GO TO 990
         END IF
      ICLRNO = NREC
      CALL TABCAL ('CLOS', INBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *   NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *   GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *   DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING INPUT CL TABLE'
         GO TO 990
         END IF
      CALL TABTE ('CLOS', OUTUFF, ITERNO, TEKOLS, TENUMV, TIME,
     *   SOURID, ANTNO, TEDATA(1), TEDATA(2), TEDATA(3), TEDATA(4),
     *   TEDATA(5), TEDATA(6), TEDATA(7), TEDATA(8), TEDATA(11),
     *   TEDATA(12), TEDATA(13), TEDATA(14), TEDATA(15), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OUTPUT TE TABLE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RIFMRA: ERROR',I4,' ON ',A)
      END
      SUBROUTINE RIFRMO (DISKIN, CNOIN, THESRC, THEANT, TEVOUT, CLVER,
     *   INFILE, TECTYP, IRET)
C-----------------------------------------------------------------------
C   Reads the input text file(s), copies the CL & TE table
C   TE file exists, CL version in same as out
C   Inputs:
C      DISKIN   I       Data set disk
C      CNOIN    I       Data set catalog number
C      THESRC   I       Data set source number
C      THEANT   I       Data set antenna number, 0 -> all
C      TEVOUT   I       Data set TE version number
C      CLVIN    I       Data set CL input version number
C      CLVOUT   I       Data set CL output version number
C      INFILE   C*(*)   ALBUS output data file
C   Output:
C      IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   DISKIN, CNOIN, THESRC, THEANT, TEVOUT, CLVER, IRET
      CHARACTER INFILE*(*), TECTYP*3
C
      INCLUDE 'RIFRM.INC'
      INTEGER   INBUFF(512), OUBUFF(512), LUNI, LUNO, ICLRNO, NUMANT,
     *   CLKOLS(MAXCLC), CLNUMV(MAXCLC), NUMPOL, NUMIF, NTERM, SOURID,
     *   ANTNO, SUBA, FREQID, REFA(2,MAXIF), NREC, I, ITERNO, TUNO,
     *   TEKOLS(16), TENUMV(16), OUTUFF(512), TUNI, INTUFF(512)
      REAL      GMMOD, TIMEI, IFR, DOPOFF(MAXIF), ATMOS, DATMOS,
     *   MBDELY(2), CLOCK(2), DCLOCK(2), DISP(2), DDISP(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF),
     *   WEIGHT(2,MAXIF), TEDATA(16)
      DOUBLE PRECISION TIME, GEODLY(MAXIF)
      CHARACTER  RDATE*8, TECRTY*8
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LUNI, LUNO, TUNI, TUNO /16, 17, 18, 19/
C-----------------------------------------------------------------------
      CALL RIFRMG (INFILE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       input CL table
      CALL CALINI ('READ', INBUFF, DISKIN, CNOIN, CLVER, CATBLK, LUNI,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING CL TABLE AS INPUT'
         GO TO 990
         END IF
C                                       Output CL table
      CALL CALINI ('WRIT', OUBUFF, DISKIN, CNOIN, CLVER, CATBLK, LUNO,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING CL TABLE AS OUTPUT'
         GO TO 990
         END IF
C                                       read loop
      NREC = INBUFF(5)
      DO 20 I = 1,NREC
         ICLRNO = I
         CALL TABCAL ('READ', INBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT CL TABLE'
            GO TO 990
            END IF
C                                       get new IFR
         IF (((THEANT.EQ.0) .OR. (THEANT.EQ.ANTNO)) .AND.
     *      ((THESRC.EQ.0) .OR. (SOURID.EQ.THESRC))) THEN
            CALL IFRGET (TIME, THESRC, SOURID, IFR, DISP, TEDATA)
            IF (IFR.EQ.FBLANK) BADIFR = BADIFR + 1
            IF (IFR.NE.FBLANK) GUDIFR = GUDIFR + 1
            END IF
         ICLRNO = I
         CALL TABCAL ('WRIT', OUBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT CL TABLE'
            GO TO 990
            END IF
 20      CONTINUE
C                                       close
      ICLRNO = NREC
      CALL TABCAL ('CLOS', OUBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *   NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *   GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *   DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OUTPUT CL TABLE'
         GO TO 990
         END IF
      ICLRNO = NREC
      CALL TABCAL ('CLOS', INBUFF, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *   NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *   GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *   DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING INPUT CL TABLE'
         GO TO 990
         END IF
C                                       Input TE table
      CALL TEINI ('READ', INTUFF, DISKIN, CNOIN, TEVOUT, CATBLK, TUNI,
     *   ITERNO, TEKOLS, TENUMV, RDATE, TECRTY, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING TE TABLE AS INPUT'
         GO TO 990
         END IF
C                                       Output same TE table
      TECRTY = 'ALBUS' // TECTYP
      CALL TEINI ('WRIT', OUTUFF, DISKIN, CNOIN, TEVOUT, CATBLK, TUNO,
     *   ITERNO, TEKOLS, TENUMV, RDATE, TECRTY, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING TE TABLE AS OUTPUT'
         GO TO 990
         END IF
      NREC = INTUFF(5)
      DO 120 I = 1,NREC
         ITERNO = I
         CALL TABTE ('READ', INTUFF, ITERNO, TEKOLS, TENUMV, TIME,
     *      SOURID, ANTNO, TEDATA(1), TEDATA(2), TEDATA(3), TEDATA(4),
     *      TEDATA(5), TEDATA(6), TEDATA(7), TEDATA(8), TEDATA(11),
     *      TEDATA(12), TEDATA(13), TEDATA(14), TEDATA(15), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING TE TABLE'
            GO TO 990
            END IF
C                                       get new IFR
         IF (((THEANT.EQ.0) .OR. (THEANT.EQ.ANTNO)) .AND.
     *      ((THESRC.EQ.0) .OR. (SOURID.EQ.THESRC))) THEN
            CALL IFRGET (TIME, THESRC, SOURID, IFR, DISP, TEDATA)
            IF (IFR.EQ.FBLANK) BADIFR = BADIFR + 1
            IF (IFR.NE.FBLANK) GUDIFR = GUDIFR + 1
            END IF
         ITERNO = I
         CALL TABTE ('WRIT', OUTUFF, ITERNO, TEKOLS, TENUMV, TIME,
     *      SOURID, ANTNO, TEDATA(1), TEDATA(2), TEDATA(3), TEDATA(4),
     *      TEDATA(5), TEDATA(6), TEDATA(7), TEDATA(8), TEDATA(11),
     *      TEDATA(12), TEDATA(13), TEDATA(14), TEDATA(15), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING TE TABLE'
            GO TO 990
            END IF
 120     CONTINUE
      CALL TABTE ('CLOS', INTUFF, ITERNO, TEKOLS, TENUMV, TIME,
     *   SOURID, ANTNO, TEDATA(1), TEDATA(2), TEDATA(3), TEDATA(4),
     *   TEDATA(5), TEDATA(6), TEDATA(7), TEDATA(8), TEDATA(11),
     *   TEDATA(12), TEDATA(13), TEDATA(14), TEDATA(15), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING INPUT TE TABLE'
         GO TO 990
         END IF
      CALL TABTE ('CLOS', OUTUFF, ITERNO, TEKOLS, TENUMV, TIME,
     *   SOURID, ANTNO, TEDATA(1), TEDATA(2), TEDATA(3), TEDATA(4),
     *   TEDATA(5), TEDATA(6), TEDATA(7), TEDATA(8), TEDATA(11),
     *   TEDATA(12), TEDATA(13), TEDATA(14), TEDATA(15), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OUTPUT TE TABLE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RIFMRO: ERROR',I4,' ON ',A)
      END
      SUBROUTINE RIFRMG (INFILE, IRET)
C-----------------------------------------------------------------------
C   Read the ALBUS report and good_station files
C   Input
C      INFILE  C*(*)   ALBUS text file
C   Output
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER INFILE*(*)
C
      INTEGER   LUN, FIND, I, J, JTRIM, KBPLIM, KBP, NBAD, IY, IM, ID,
     *   LD(3)
      DOUBLE PRECISION XX, T0
      CHARACTER INLINE*256, DOB*8, STRING*16
      INCLUDE 'ALBUS.INC'
      INCLUDE 'ALBUSD.INC'
      INCLUDE 'RIFRM.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN /3/
C-----------------------------------------------------------------------
C                                       Open first file
      I = 1
      CALL ZTXOPN ('READ', LUN, FIND, INFILE, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN ALBUS OUTPUT TEXT FILE'
         GO TO 990
         END IF
      NTIMES = 0
      NBAD = 0
      NSRCS = 0
      CALL FILL (2*NSMAX, 0, SRCBRK)
C                                       skip head except ref time
 10   CALL ZTXIO ('READ', LUN, FIND, INLINE, IRET)
      IF (IRET.EQ.0) THEN
         KBPLIM = JTRIM (INLINE)
         IF ((KBPLIM.LE.0) .OR. (INLINE(:1).EQ.'#')) GO TO 10
         IF (INLINE(:9).EQ.'reference') THEN
            J = INDEX (INLINE, ',sec')
            IF (J.GT.0) THEN
               KBP = J + 4
               CALL GETNUM (INLINE, KBPLIM, KBP, XX)
               IF (XX.EQ.DBLANK) GO TO 10
               IY = XX + 0.01D0
               CALL GETNUM (INLINE, KBPLIM, KBP, XX)
               IF (XX.EQ.DBLANK) GO TO 10
               IM = XX + 0.01D0
               CALL GETNUM (INLINE, KBPLIM, KBP, XX)
               IF (XX.EQ.DBLANK) GO TO 10
               ID = XX + 0.01D0
               CALL GETNUM (INLINE, KBPLIM, KBP, XX)
               IF (XX.EQ.DBLANK) GO TO 10
               T0 = XX
               CALL GETNUM (INLINE, KBPLIM, KBP, XX)
               IF (XX.EQ.DBLANK) GO TO 10
               T0 = T0 + XX/60.0D0
               CALL GETNUM (INLINE, KBPLIM, KBP, XX)
               IF (XX.EQ.DBLANK) GO TO 10
               T0 = T0 + XX/3600.0D0
               T0 = T0 / 24.0
               END IF
            END IF
         IF ((INLINE(:12).EQ.'observation:') .OR.
     *      (INLINE(:9).EQ.'Observing')) THEN
            CALL LASTRN (INLINE, STRING)
            DO 15 I = 1,NSORC
               IF (STRING.EQ.SRCNAM(I)) THEN
                  IF (NSRCS.EQ.NSMAX) THEN
                     WRITE (MSGTXT,1012) NSMAX
                     IRET = 10
                     GO TO 990
                     END IF
                  NSRCS = NSRCS + 1
                  SRCBRK(1,NSRCS) = NTIMES + 1
                  SRCBRK(2,NSRCS) = SRCNUM(I)
                  GO TO 10
                  END IF
 15            CONTINUE
            WRITE (MSGTXT,1015) STRING
            CALL MSGWRT (8)
            END IF
         IF (INLINE(:18).EQ.'process_ionosphere') GO TO 25
         IF (INLINE(:3).NE.'seq') GO TO 10
      ELSE
         WRITE (MSGTXT,1000) IRET, 'READING START OF ALBUS OUTPUT FILE'
         IF ((IRET.NE.2) .OR. (NTIMES.LE.0)) GO TO 990
         IRET = 0
         GO TO 30
         END IF
C                                       right day??
      CALL H2CHR (8, 1, CATH(KHDOB), DOB)
      CALL DATEST (DOB, LD)
      IF ((LD(1).NE.IY) .OR. (LD(2).NE.IM) .OR. (LD(3).NE.ID)) THEN
         WRITE (MSGTXT,1010) IY, IM, ID, LD
         IRET = 10
         GO TO 990
         END IF
C                                       read loop
 20   CALL ZTXIO ('READ', LUN, FIND, INLINE, IRET)
      IF (IRET.EQ.0) THEN
         KBPLIM = JTRIM (INLINE)
         IF ((KBPLIM.LE.0) .OR. (INLINE(:1).EQ.'#')) GO TO 10
         NBAD = NBAD + 1
         IF (INLINE(:18).EQ.'process_ionosphere') THEN
            NBAD = NBAD - 1
            GO TO 25
            END IF
         J = INDEX (INLINE,':')
         IF (J.LT.3) GO TO 20
         KBP = J + 1
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         TIMES(NTIMES+1) = XX / 86400.0D0 + T0
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         DEL(NTIMES+1) = XX
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         DAZ(NTIMES+1) = XX
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         STEC(NTIMES+1) = XX
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         RMS(NTIMES+1) = XX
         CALL GETNUM (INLINE, KBPLIM, KBP, XX)
         IF (XX.EQ.DBLANK) GO TO 20
         VTEC(NTIMES+1) = XX * STEC(NTIMES+1)
         NTIMES = NTIMES + 1
         IF (NTIMES.GT.NTMAX) THEN
            WRITE (MSGTXT,1020) NTMAX
            IRET = 10
            GO TO 990
            END IF
         NBAD = NBAD - 1
         GO TO 20
      ELSE IF (IRET.NE.2) THEN
         WRITE (MSGTXT,1000) IRET, 'READING ALBUS OUTPUT TEXT FILE'
         GO TO 990
         END IF
      GO TO 30
C                                       last text line
 25   J = INDEX (INLINE,'time:')
      KBP = J + 5
      KBPLIM = JTRIM (INLINE)
      CALL GETNUM (INLINE, KBPLIM, KBP, XX)
      IF (XX.NE.DBLANK) THEN
         TOTRUN = XX
         SUMRUN = SUMRUN + XX
         WRITE (MSGTXT,1025) TOTRUN
         CALL MSGWRT (3)
         END IF
C                                       shut down
 30   CALL ZTXCLS (LUN, FIND, I)
      IRET = 0
      WRITE (MSGTXT,1030) NTIMES
      CALL MSGWRT (3)
      WRITE (MSGTXT,1031) NSRCS
      CALL MSGWRT (3)
      WRITE (MSGTXT,1032) NBAD
      CALL MSGWRT (3)
C                                       good stations
      CALL CFILL (STNMAX, '    ', AGSTAT)
      J = JTRIM (DIRDAT)
      INLINE = DIRDAT(:J) // '/albus_good_stations'
      CALL ZTXOPN ('READ', LUN, FIND, INLINE, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN GOOD STATIONS FILE'
         GO TO 980
         END IF
      IM = 0
 50   CALL ZTXIO ('READ', LUN, FIND, INLINE, IRET)
      IF (IRET.EQ.0) THEN
         IF (INLINE(:4).NE.' ') THEN
            IF (IM.LT.STNMAX) THEN
               IM = IM + 1
               AGSTAT(IM) = INLINE(:4)
               AGSTAC(IM) = INLINE(5:7)
            ELSE
               MSGTXT = 'USED STATION LIST OVERFLOWS'
               IF (IM.EQ.STNMAX) CALL MSGWRT (6)
               IM = IM + 1
               END IF
            END IF
         GO TO 50
      ELSE IF (IRET.NE.2) THEN
         WRITE (MSGTXT,1000) IRET, 'READING GOOD STATIONS FILE'
         GO TO 980
         END IF
      CALL ZTXCLS (LUN, FIND, ID)
      IRET = 0
      ID = 0
 55   IY = ID + 1
      ID = MIN (IY+7, IM)
      WRITE (MSGTXT,1055) (AGSTAT(I), I = IY,ID)
      CALL MSGWRT (3)
      IF (ID.LT.IM) GO TO 55
C                                       document stations
      CALL STATID (IRET)
      GO TO 999
C
 980  IRET = 0
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RIFRMG: ERROR',I4,' ON ',A)
 1010 FORMAT ('TEXT FILE FOR',I5,2I3,'  DATA FROM',I5,2I3,' STOPPING')
 1012 FORMAT ('MAXIMUM NUMBER OF SOURCES',I5,' EXCEEDED')
 1015 FORMAT ('SOURCE ''',A,''' NOT FOUND!')
 1020 FORMAT ('MAXIMUM NUMBER OF SOURCE TIMES',I7,' EXCEEDED')
 1025 FORMAT ('ALBUS total run time',F7.2,' minutes')
 1030 FORMAT ('RIFRMG read',I4,' times')
 1031 FORMAT ('RIFRMG in  ',I4,' sources')
 1032 FORMAT ('RIFRMG',I6,' bad values lines')
 1055 FORMAT ('Stations used',8(2X,A))
      END
      SUBROUTINE IFRGET (TIME, THESRC, SOURID, IFR, DISP, TEDATA)
C-----------------------------------------------------------------------
C   IFRGET gets the IFR, DISP, TE values from the tables
C   Inputs
C      THESRC   I      Source being processed (0 -> all)
C      SOURID   I      The current source
C      TIME     D      time (days)
C   In/out
C      IFR      R      Ionospheric Faraday rotation radians/m/m
C                      from table or unchanged if fail to find
C      DISP     R(2)   Dispersive delay
C      TEDATA   R(16)  HA, AZ, ZA, AZION, ZAION, DLON, DLAT, B(3),
C                      TEPATH, MAG, TEC, IFR, DISP(2)
C   Common
C-----------------------------------------------------------------------
      DOUBLE PRECISION TIME
      INTEGER   THESRC, SOURID
      REAL      IFR, DISP(2), TEDATA(16)
C
      INCLUDE 'RIFRM.INC'
      INTEGER   I, LT, LS, LT1, LT2
      REAL      PT, TSC
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      SAVE LT, PT, LS, LT1, LT2
      DATA LT, PT, LS, LT1, LT2 /1, 0.0, 3*0/
C------------------------------------------------------------------------
      IF (TENEW) CALL RFILL (16, FBLANK, TEDATA)
      IF (THESRC.GT.0) THEN
         LT1 = 1
         LT2 = NTIMES
      ELSE IF (SOURID.NE.LS) THEN
         DO 10 I = 1,NSRCS
            IF (SOURID.EQ.SRCBRK(2,I)) THEN
               LT1 = SRCBRK(1,I)
               IF (I.LT.NSRCS) THEN
                  LT2 = SRCBRK(1,I+1)
               ELSE
                  LT2 = NTIMES
                  END IF
               LT = 1
               PT = 0.0
               LS = SOURID
               GO TO 30
               END IF
 10         CONTINUE
         GO TO 999
         END IF
C                                       Find time
 30   IF (TIME.LT.PT) LT = LT1
      DO 40 I = LT1,LT2-1
         IF ((TIME.GE.TIMES(I)) .AND. (TIME.LE.TIMES(I+1))) THEN
            LT = I
            PT = TIMES(I)
            GO TO 50
            END IF
 40      CONTINUE
      PT = 0.0
      LT = LT1
      GO TO 999
C                                       interpolate
 50   IF ((RMS(I).EQ.FBLANK) .OR. (RMS(I+1).EQ.FBLANK)) THEN
         IFR = FBLANK
      ELSE
         TSC = (TIME-TIMES(I)) / (TIMES(I+1)-TIMES(I))
         IFR = TSC * (RMS(I+1) - RMS(I)) + RMS(I)
         IF (ABS(IFR).GT.100.0) IFR = FBLANK
         TEDATA(2) = TSC * (DAZ(I+1)-DAZ(I)) + DAZ(I)
         TEDATA(3) = TSC * (DEL(I+1)-DEL(I)) + DEL(I)
         TEDATA(3) = 90.0 - TEDATA(3)
         TEDATA(11) = TSC * (STEC(I+1)-STEC(I)) + STEC(I)
         TEDATA(13) = TSC * (VTEC(I+1)-VTEC(I)) + VTEC(I)
         TEDATA(14) = IFR
         TEDATA(15) = 40.28 * TEDATA(11) / (VELITE ** 3) * 1.E16
         TEDATA(16) = TEDATA(15)
         END IF
C
 999  RETURN
      END
      SUBROUTINE ALBUSH
C-----------------------------------------------------------------------
C     ALBUSH adds history to the data set
C-----------------------------------------------------------------------
      INCLUDE 'ALBUS.INC'
      INCLUDE 'ALBUSD.INC'
      INCLUDE 'RIFRM.INC'
      INTEGER   IRET, LUN, TIME(3), DATE(3), I, I1, I2, J, JTRIM
      CHARACTER HILINE*72, CTIME(2)*12, CDUM*10, LABEL*8
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN /27/
C-----------------------------------------------------------------------
      CALL HIINIT (3)
      CALL HIOPEN (LUN, DISKIN, CNOIN, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATE HI FILE'
         GO TO 990
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,2000) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 900
C                                       sources
      CDUM = 'SOURCES ='
      I2 = 0
 10   I1 = I2 + 1
      I2 = MIN (NSORC,I1+2)
      IF (I1.LE.NSORC) THEN
         WRITE (HILINE,2010) TSKNAM, CDUM, (SRCNAM(I), I = I1,I2)
         IF ((I2.EQ.NSORC) .AND. (I2-I1.LT.2)) THEN
            I = JTRIM (HILINE)
            HILINE(I:) = ' '
            END IF
         CALL HIADD (LUN, HILINE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 900
         CDUM = ' '
         GO TO 10
      END IF
C                                       antennas
      IF (NANTS.EQ.0) THEN
         HILINE = TSKNAM // '/  all antennas treated as one'
         CALL HIADD (LUN, HILINE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 900
      ELSE
         I2 = 0
         CDUM = 'ANTENNAS ='
 20      I1 = I2 + 1
         I2 = MIN (NANTS, I1+13)
         IF (I1.LT.NANTS) THEN
            WRITE (HILINE,2020) TSKNAM, CDUM, (ANTNUM(I), I = I1,I2)
            IF (I2.EQ.NANTS) THEN
               I = JTRIM (HILINE)
               HILINE(I:) = ' '
               END IF
            CALL HIADD (LUN, HILINE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 900
            CDUM = ' '
            GO TO 20
            END IF
         END IF
C                                       CL/TE versions
      WRITE (HILINE,2025) TSKNAM, 'GAINVER', CLVIN, 'input CL'
      CALL HIADD (LUN, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 900
      WRITE (HILINE,2025) TSKNAM, 'GAINUSE', CLVOUT, 'output CL'
      CALL HIADD (LUN, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 900
      WRITE (HILINE,2025) TSKNAM, 'TEVER', TEVOUT, 'output TE'
      CALL HIADD (LUN, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 900
C                                       directory
      J = JTRIM (ROOT)
      I2 = 0
      CDUM = 'DATAOUT= '''
 30   I1 = I2 + 1
      I2 = MIN (J, I1+54)
      IF (I1.LE.J) THEN
         WRITE (HILINE,2030) TSKNAM, CDUM, ROOT(I1:I2)
         IF (I2.EQ.J) THEN
            I = JTRIM (HILINE)
            HILINE(I+1:) = ''''
            END IF
         CALL HIADD (LUN, HILINE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 900
         CDUM = ' '
         GO TO 30
         END IF
C                                       adverbs
      WRITE (HILINE,2040) TSKNAM, TECTYP
      CALL HIADD (LUN, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 900
      WRITE (HILINE,2041) TSKNAM, DETIME
      CALL HIADD (LUN, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 900
      WRITE (HILINE,2042) TSKNAM, RADIUS
      CALL HIADD (LUN, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 900
      IF ((DOBTW.LE.0.0) .AND. (DOALL.LE.0.0)) THEN
         HILINE = TSKNAM // '/ each source has separate downloaded data'
      ELSE
         HILINE = TSKNAM // '/ all sources use the same downloaded data'
         END IF
      CALL HIADD (LUN, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 900
      IF (ABS(DOBTW).GE.10.0) THEN
         HILINE = TSKNAM // '/ python run on one cpu only'
         CALL HIADD (LUN, HILINE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 900
         END IF
      WRITE (HILINE,2050) TSKNAM, SUMRUN
      CALL HIADD (LUN, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 900
      IF (NUMHIS.LE.0) THEN
         J = 0
         DO 40 I = 1,STNMAX
            IF (AGSTAT(I).NE.' ') J = I
 40         CONTINUE
         I2 = 0
 45      I1 = I2 + 1
         I2 = MIN (I1+6, J)
         WRITE (HILINE,2045) TSKNAM, (AGSTAT(I), I=I1,I2)
         CALL HIADD (LUN, HILINE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 900
         IF (I2.LT.J) GO TO 45
      ELSE
         LABEL = TSKNAM // '/ '
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN, HILINE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 900
 50         CONTINUE
         END IF
      DO 60 I = 1,NUMSTN
         WRITE (HILINE,2060) TSKNAM, I, STATNS(I)
         CALL HIADD (LUN, HILINE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 900
 60      CONTINUE
      CALL HICLOS (LUN, .TRUE., SCRTCH, I)
      GO TO 999
C
 900  CALL HICLOS (LUN, .TRUE., SCRTCH, I)
      WRITE (MSGTXT,1000) IRET, 'WRITING HISTORY FILE'
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ALBUSH ERROR',I4,' ON ',A)
 2000 FORMAT (A6,'RELEASE   =''',A7,' ''  /******* Start ',A12,2X,A8)
 2010 FORMAT (A6,A9,3(' ''',A,''''))
 2020 FORMAT (A6,A10,I3.2,13(',',I3.2))
 2025 FORMAT (A6,A,' =',I4,5X,'/ ',A,' table version')
 2030 FORMAT (A6,A10,A)
 2040 FORMAT (A6,'TECRTYPE = ''',A,'''    / Ionospheric model type')
 2041 FORMAT (A6,'DETIME ',F5.0,5X,'/ Download timeout in seconds')
 2042 FORMAT (A6,'RADIUS ',I5,5X,'/ Radius in km to find data sources')
 2045 FORMAT (A6,'/ stations used',7(1X,'''',A,''''))
 2050 FORMAT (A6,'/ ALBUS reported sum run time',F8.2,' minutes')
 2060 FORMAT (A6,'STATIONS(',I2.2,') = ''',A4,
     *   '''  / use only these stations')
      END
      SUBROUTINE LASTRN (INLINE, STRING)
C-----------------------------------------------------------------------
C   returns the last string in an input line (drops ' marks if any)
C   Input:
C      INLINE   C*(*)   Text line to parse
C   Output
C      STRING   C*(*)   last string
C-----------------------------------------------------------------------
      CHARACTER   INLINE*(*), STRING*(*)
C
      INTEGER   I, J, JTRIM, I1, I2
C-----------------------------------------------------------------------
      STRING = ' '
      J = JTRIM (INLINE)
      DO 10 I = J,1,-1
         IF ((INLINE(I:I).EQ.' ') .OR. (I.EQ.1)) THEN
            I1 = I + 1
            IF (I.EQ.1) I1 = 1
            IF (INLINE(I1:I1).EQ.'''') THEN
               I1 = I1 + 1
            ELSE IF (INLINE(I1:I1).EQ.'"') THEN
               I1 = I1 + 1
               END IF
            I2 = J
            IF (INLINE(I2:I2).EQ.'''') THEN
               I2 = I2 - 1
            ELSE IF (INLINE(I2:I2).EQ.'"') THEN
               I2 = I2 - 1
               END IF
            STRING = INLINE(I1:I2)
            GO TO 999
            END IF
 10      CONTINUE
C
 999  RETURN
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QXFOUR (X, M, ISIG, W)
C-----------------------------------------------------------------------
C! Pseudo AP routine: FFT routine.
C# AP-FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   This program will produce a fast Fourier transform of a complex data
C   set using quarter-length tables by based on an algorithm devised by
C   William Newman, Cornell September 1, 1973.
C   Currently will handle up to M=4096
C      The file INCLUDEd should contain the compiler No-dependency
C   directive on vectorizing compilers.
C       On scalar systems the code can be simplified by
C   removing the branch to 400 and lines from label 400 to 490.
C   Inputs:
C      X     R(2,M)  Complex array to be transformed.
C      M     I       Length of X (must be a power of 2)
C      ISIG  I       Direction of the transform - same convention as FPS
C   Outputs:
C      X     R(2,M)  Resulting transformed array.
C      W     R(2,M)  Complex work array.
C   Modified for vector machines by W. D. Cotton, NRAO, Feb. 1986
C-----------------------------------------------------------------------
      INTEGER   M, ISIG, OLDM, N, I, J, L, M4, NM2, I1, K, MSTEP, ISEP,
     *   ITIMES, ISEPI1, JI, JI1, II, ISEP4
      INTEGER   IBITRV(4096)
      REAL      X(2,M), W(2,M), C(1024), S(1024), XT, ARG, AR, AI
      DOUBLE PRECISION DARG, TPI
      SAVE OLDM, C, S, IBITRV
      DATA OLDM /0/
C-----------------------------------------------------------------------
      IF (M.EQ.OLDM) GO TO 200
C                                       Initialize tables
C                                       Find power of 2
      ARG = M
      N = (LOG (ARG) / LOG(2.0)) + 0.1
C                                       Fill sine & cosine tables
      M4 = M / 4
      NM2 = N - 2
      TPI = 8.0D0 * ATAN (1.0D0)
      TPI = TPI / M
      DO 10 I = 1,M4
         DARG = TPI * (I-1)
         C(I) = COS (DARG)
         S(I) = SIN (DARG)
 10      CONTINUE
C                                       Reverse bit order
      DO 50 I = 1,M4
         I1 = I - 1
         J = 0
         DO 20 K = 1,NM2
            L = I1 / 2
            J = I1 + 2 * (J-L)
            I1 = L
 20         CONTINUE
         J = J + 1
         IF (I.GE.J) GO TO 50
            XT = C(I)
            C(I) = C(J)
            C(J) = XT
            XT = S(I)
            S(I) = S(J)
            S(J) = XT
 50      CONTINUE
C                                       Bit reversal index array
      DO 100 I = 1,M
         I1 = I - 1
         J = 0
         DO 80 K = 1,N
            L = I1 / 2
            J = I1 + 2 * (J-L)
            I1 = L
 80         CONTINUE
         J = J + 1
         IBITRV(I) = J
 100     CONTINUE
C                                       Do transform
 200  OLDM = M
C                                       Copy to work vector (w/ conj.)
      XT = -ISIG
      DO 210 I = 1,M
         W(1,I) = X(1,I)
         W(2,I) = XT * X(2,I)
 210     CONTINUE
C                                       Butterfly loop
      DO 500 MSTEP = 1,N
         ISEP = 2 ** (N-MSTEP)
         ISEP4 = ISEP * 4
         ITIMES = 2 ** (MSTEP-1)
C                                       Move longer loop to inner
         IF (ITIMES.GT.ISEP) GO TO 400
         DO 390 I = 1,ITIMES
            ISEPI1 = 2 * (I-1) * ISEP
            II = (I+1) / 2
            JI1 = ISEPI1 + 1
            JI = JI1 + ISEP
            IF (I.EQ.(2*(I/2))) GO TO 260
C                                       Odd pass
C@DIR IGNORE RECRDEPS
               DO 250 J = 1,ISEP
                 AR = W(1,JI) * C(II) - W(2,JI) * S(II)
                 AI = W(1,JI) * S(II) + W(2,JI) * C(II)
                 W(1,JI) = W(1,JI1) - AR
                 W(2,JI) = W(2,JI1) - AI
                 W(1,JI1) = W(1,JI1) + AR
                 W(2,JI1) = W(2,JI1) + AI
                 JI1 = JI1 + 1
                 JI = JI + 1
 250             CONTINUE
              GO TO 390
C                                       Even pass
C@DIR IGNORE RECRDEPS
 260          DO 280 J = 1,ISEP
                 AR = W(1,JI) * S(II) + W(2,JI) * C(II)
                 AI = W(1,JI) * C(II) - W(2,JI) * S(II)
                 W(1,JI) = W(1,JI1) + AR
                 W(2,JI) = W(2,JI1) - AI
                 W(1,JI1) = W(1,JI1) - AR
                 W(2,JI1) = W(2,JI1) + AI
                 JI1 = JI1 + 1
                 JI = JI + 1
 280             CONTINUE
 390          CONTINUE
         GO TO 500
C                                       Switch order of loops
 400     DO 490 J = 1,ISEP
C                                       Odd passes
            II = 1
            JI1 = J
            JI = JI1 + ISEP
C@DIR IGNORE RECRDEPS
            DO 450 I = 1,ITIMES,2
               AR = W(1,JI) * C(II) - W(2,JI) * S(II)
               AI = W(1,JI) * S(II) + W(2,JI) * C(II)
               W(1,JI) = W(1,JI1) - AR
               W(2,JI) = W(2,JI1) - AI
               W(1,JI1) = W(1,JI1) + AR
               W(2,JI1) = W(2,JI1) + AI
               II = II + 1
               JI1 = JI1 + ISEP4
               JI = JI + ISEP4
 450           CONTINUE
C                                       Even passes
            II = 1
            JI1 = J + 2 * ISEP
            JI = JI1 + ISEP
C@DIR IGNORE RECRDEPS
            DO 480 I = 2,ITIMES,2
               AR = W(1,JI) * S(II) + W(2,JI) * C(II)
               AI = W(1,JI) * C(II) - W(2,JI) * S(II)
               W(1,JI) = W(1,JI1) + AR
               W(2,JI) = W(2,JI1) - AI
               W(1,JI1) = W(1,JI1) - AR
               W(2,JI1) = W(2,JI1) + AI
               II = II + 1
               JI1 = JI1 + ISEP4
               JI = JI + ISEP4
 480           CONTINUE
 490       CONTINUE
 500    CONTINUE
C                                       Bit reverse and conjugate back
C                                       to X
      XT = -ISIG
      DO 600 I = 1,M
         II = IBITRV(I)
         X(1,I) = W(1,II)
         X(2,I) = XT * W(2,II)
 600     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE QCLNSZ (APCORE, LAPSIZ)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Determine AP size for CLEAN
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006-2008, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Determine the amount of memory available for CLEAN.
C   Generic version: allows both primary and secondary AP memory.
C   Outputs:
C      LAPSIZ  I  Numbers of words of memory available.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   LAPSIZ
C
      INTEGER   I1, I2, I3
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
C-----------------------------------------------------------------------
C                                       New method: alocate minimum
      IF (PSAPNW.LE.0) THEN
         I1 = 0
         CALL QINIT (APCORE, I1, I2, I3)
         END IF
      LAPSIZ = 1024 * PSAPNW
C
 999  RETURN
      END

      SUBROUTINE COPTAB (DISKIN, CNOIN, DISKOU, CNOOUT, IRET)
C-----------------------------------------------------------------------
C! copies tables when calibration has been applied
C# subroutine editing UV
C-----------------------------------------------------------------------
C;  Copyright (C) 2007, 2009-2013, 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Updates tables for selection by IF etc
C   Inputs:
C      DISKIN   I   Input disk number
C      CONIN    I   Input catalog number
C      DISKOU   I   Output disk number
C      CNOOUT   I   Output catalog number
C   Inputs in common:
C      BIF   I  First IF
C      EIF   I  Highest IF selected
C      FQOFF D  Frequency offset
C      SELIF L  Select IFs or not
C   Output:
C      IRET  I  Return code, 0=>OK
C-----------------------------------------------------------------------
      INTEGER   DISKIN, CNOIN, DISKOU, CNOOUT, IRET
C
      INCLUDE 'INCS:DSEL.INC'
      DOUBLE PRECISION CATD(128)
      REAL      CATR(256), FINC(MAXIF)
      LOGICAL   TABLE, EXIST, FITASC, SELIF, ISBAND(MAXIF), MULTI
      CHARACTER NOTTYP(22)*2, BNDCOD(MAXIF)*8
      INTEGER   IERR, LUN1, LUN2, VER, NVER, OFQID, ISUB, JSUB, AN(50),
     *   NA, NNIF, I, FREQID, BUFF1(512), BUFF2(512), ISURNO, SIDSOU,
     *   SQUAL, SUFQID, NSOURC, INOGRP, KOLS(MAXSUC), NUMV(MAXSUC),
     *   NONOT, BPOL, EPOL, IROUND, BVER
      CHARACTER VELTYP*8, VELDEF*8, SSNAME*16, SCALCO*4
      DOUBLE PRECISION SBANDW, SRAEPO, SDECEP, SEPOCH, SRAAPP, SDECAP,
     *   SPMRA, SPMDEC, SLSRVE(MAXIF), SFREQO(MAXIF), SLREST(MAXIF),
     *   TIME1, TIME2, FOFF(MAXIF), FQOFF, SRAOBS, SDECOB
      REAL     SFLUX(4,MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATR, CATD, CATBLK)
      DATA LUN1, LUN2 /28, 29/
      DATA NONOT, NOTTYP /22, 'NX','FQ','CH','CL','SN','SU','FG','BP',
     *   'IM','CQ','PC','TY','GC','MC','WX','BL','AN','CP','PD','SY',
     *   'CD','PP'/
C-----------------------------------------------------------------------
C                                       Single source now?
      MULTI = ILOCSU.GT.0
C                                       polarization
      IF (CATUV(KINAX+JLOCS).EQ.CATBLK(KINAX+JLOCS)) THEN
         BPOL = 1
         EPOL = MIN (2, CATBLK(KINAX+JLOCS))
      ELSE
         FINC(1) = CATD(KDCRV+JLOCS) + (1 - CATR(KRCRP+JLOCS)) *
     *      CATR(KRCIC+JLOCS)
         BPOL = ABS (IROUND (FINC(1)))
         EPOL = MIN (2, CATBLK(KINAX+JLOCS))
         EPOL = MAX (EPOL, BPOL)
         END IF
C                                       Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKOU, CNOIN,
     *   CNOOUT, CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'FLGIHI: ERROR COPYING TABLES'
         CALL MSGWRT (6)
         END IF
C                                       more complex tables
      MSGTXT = 'Updating tables for IF/FREQID/channel selection'
      CALL MSGWRT (4)
      ISUB = 0
      JSUB = -1
      NA = 0
C                                       allow 15 min extra to be sure
C                                       that one gets all needed rows
      TIME1 = TSTART - 0.0104D0
      TIME2 = TEND + 0.0104D0
      SELIF = (BIF.GT.1) .OR. (EIF.LT.CATUV(KINAX+KLOCIF)) .OR.
     *   (FRQSEL.GT.0)
      CALL FILL (50, 0, AN)
C                                       FQ table
      IF (JLOCIF.GT.0) THEN
         CALL DFILL (MAXIF, 0.0D0, SFREQO)
C                                       Multi to single source
         IF ((KLOCSU.GE.0) .AND. (ILOCSU.LT.0)) THEN
C                                       Open file
            CALL SOUINI ('READ', BUFF2, IUDISK, IUCNO, 1, CATUV, LUN1,
     *         INOGRP, VELTYP, VELDEF, SUFQID, I, KOLS, NUMV, IRET)
            IF (IRET.NE.0) GO TO 20
C                                       Get number of sources.
            NSOURC = BUFF2(5)
C                                       Loop looking for source.
            DO 10 I = 1,NSOURC
               ISURNO = I
               CALL TABSOU ('READ', BUFF2, ISURNO, KOLS, NUMV, SIDSOU,
     *            SSNAME, SQUAL, SCALCO, SFLUX, SFREQO, SBANDW, SRAEPO,
     *            SDECEP, SEPOCH, SRAAPP, SDECAP, SRAOBS, SDECOB,
     *            SLSRVE, SLREST, SPMRA, SPMDEC, IRET)
               IF (IRET.GT.0) CALL DFILL (MAXIF, 0.0D0, SFREQO)
               IF ((SIDSOU.EQ.SOUWAN(1)) .OR. (IRET.GT.0)) GO TO 15
 10            CONTINUE
C                                       Didn't find
            CALL DFILL (MAXIF, 0.0D0, SFREQO)
C                                       Close file
 15         CALL TABIO ('CLOS', 0, I, BUFF2, BUFF2, IRET)
            END IF
C                                       Read old
 20      VER = 1
         CALL CHNDAT ('READ', BUFF1, DISKIN, CNOIN, VER, CATUV, LUN1,
     *      NNIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Fixup
         NNIF = EIF - BIF + 1
         FQOFF = FOFF(BIF)
C                                       force the first IF to zero
         DO 30 I = BIF,EIF
            FOFF(I) = FOFF(I) - FQOFF + (SFREQO(I) - SFREQO(BIF))
 30         CONTINUE
C                                       Output ref IF = 1
         CATD(KDCRV+JLOCIF) = 1.0D0
         CATR(KRCRP+JLOCIF) = 1.0
C                                       Rewrite new
         VER = 1
         FREQID = 1
         CALL CHNDAT ('WRIT', BUFF1, DISKOU, CNOOUT, VER, CATBLK, LUN1,
     *      NNIF, FOFF(BIF), ISBAND(BIF), FINC(BIF), BNDCOD(BIF),
     *      FREQID, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Reference frequency in AN table
C                                       IF selection
      CALL FNDEXT ('AN', CATUV, NVER)
      DO 100 VER = 1,NVER
         CALL ISTAB ('AN', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF ((EXIST) .AND. (IERR.EQ.0)) CALL ANSEL (DISKIN, CNOIN,
     *      DISKOU, CNOOUT, VER, VER, CATUV, CATBLK, LUN1, LUN2, BIF,
     *      EIF, FQOFF, DOPOL, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 100     CONTINUE
C                                       Revise tables:
      OFQID = FRQSEL
C                                       BP tables
      IF (DOBAND.LE.0) THEN
         CALL FNDEXT ('BP', CATUV, NVER)
         DO 120 VER = 1,NVER
            CALL ISTAB ('BP', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *         EXIST, FITASC, IERR)
            IF (EXIST .AND. (IERR.EQ.0)) CALL BPSEL (DISKIN, CNOIN,
     *         DISKOU, CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BPOL,
     *         EPOL, BIF, EIF, BCHAN, ECHAN, TIME1, TIME2, OFQID, ISUB,
     *         JSUB, BUFF1, BUFF2, IRET)
            IF (IRET.GT.0) GO TO 999
 120        CONTINUE
         END IF
C                                       CL tables
      CALL FNDEXT ('CL', CATUV, NVER)
C                                       write FO table only
      IF (.NOT.MULTI) THEN
         VER = 1
         CALL ISTAB ('CL', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL CL2FO (DISKIN, CNOIN,
     *      VER, LUN1, CATUV, DISKOU, CNOOUT, LUN2, CATBLK, SOUWAN,
     *      BUFF1, BUFF2, IRET)
C                                       write null table
      ELSE IF (DOCAL) THEN
         VER = 1
         CALL ISTAB ('CL', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
C                                       do NOT select on sources
         IF (EXIST .AND. (IERR.EQ.0)) CALL CLNULL (DISKIN, CNOIN,
     *      DISKOU, CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BIF, EIF, OFQID, TIME1, TIME2, 0, SOUWAN, AN, NA, ISUB,
     *      JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.NE.0) GO TO 999
      ELSE
         DO 140 VER = 1,NVER
            CALL ISTAB ('CL', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *         EXIST, FITASC, IERR)
C                                       do NOT select on sources
            IF (EXIST .AND. (IERR.EQ.0)) CALL CLSEL (DISKIN, CNOIN,
     *         DISKOU, CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BPOL,
     *         EPOL, BIF, EIF, OFQID, TIME1, TIME2, 0, SOUWAN, AN, NA,
     *         ISUB, JSUB, BUFF1, BUFF2, IRET)
            IF (IRET.GT.0) GO TO 999
 140        CONTINUE
         END IF
C                                       CD tables
      CALL FNDEXT ('CD', CATUV, NVER)
      DO 145 VER = 1,NVER
         CALL ISTAB ('CD', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
C                                       do not select on antenna
         IF (EXIST.AND.(IERR.EQ.0)) CALL CDSEL (DISKIN, CNOIN, DISKOU,
     *      CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BPOL, EPOL, BIF,
     *      EIF, OFQID, AN, 0, ISUB, JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 145     CONTINUE
C                                       CP tables
      CALL FNDEXT ('CP', CATUV, NVER)
      DO 150 VER = 1,NVER
         CALL ISTAB ('CP', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST.AND.(IERR.EQ.0)) CALL CPSEL (DISKIN, CNOIN, DISKOU,
     *      CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BIF, EIF, BCHAN,
     *      ECHAN, OFQID, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 150     CONTINUE
C                                       CQ tables
      CALL FNDEXT ('CQ', CATUV, NVER)
      DO 160 VER = 1,NVER
         CALL ISTAB ('CQ', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST.AND.(IERR.EQ.0)) CALL CQSEL (DISKIN, CNOIN, DISKOU,
     *      CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BIF, EIF, OFQID,
     *      ISUB, JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 160     CONTINUE
C                                       FG tables
      CALL FNDEXT ('FG', CATUV, NVER)
      IF ((FGVER.GT.0) .AND. (NVER.GT.0)) THEN
         BVER = FGVER + 1
         IF (NVER.LE.FGVER) THEN
            MSGTXT = 'WARNING: NO FG TABLES ARE COPIED SINCE HIGHEST'
     *         // ' WAS APPLIED'
            NVER = 0
         ELSE
            WRITE (MSGTXT,1160) BVER, NVER
            END IF
         CALL MSGWRT (6)
         END IF
      DO 180 VER = BVER,NVER
         CALL ISTAB ('FG', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0) .AND. (VER.GT.FGVER))
     *      CALL FGSEL (DISKIN, CNOIN, DISKOU, CNOOUT, VER, CATUV,
     *      CATBLK, LUN1, LUN2, BIF, EIF, BCHAN, ECHAN,  TIME1,
     *      TIME2, OFQID, ISUB, JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 180     CONTINUE
C                                       GC tables
      CALL FNDEXT ('GC', CATUV, NVER)
      DO 200 VER = 1,NVER
         CALL ISTAB ('GC', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL GCSEL (DISKIN, CNOIN,
     *      DISKOU, CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BCHAN, ECHAN, BIF, EIF, OFQID, AN, NA, ISUB, JSUB, BUFF1,
     *      BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 200     CONTINUE
C                                       IM tables
      CALL FNDEXT ('IM', CATUV, NVER)
      DO 220 VER = 1,NVER
         CALL ISTAB ('IM', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL IMSEL (DISKIN, CNOIN,
     *      DISKOU, CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BIF, EIF, OFQID, TIME1, TIME2, NSOUWD, SOUWAN, AN, NA, ISUB,
     *      JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 220     CONTINUE
C                                       MC tables
      CALL FNDEXT ('MC', CATUV, NVER)
      DO 240 VER = 1,NVER
         CALL ISTAB ('MC', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL MCSEL (DISKIN, CNOIN,
     *      DISKOU, CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BIF, EIF, OFQID, TIME1, TIME2, NSOUWD, SOUWAN, AN, NA, ISUB,
     *      JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 240     CONTINUE
C                                       PC tables
      CALL FNDEXT ('PC', CATUV, NVER)
      DO 260 VER = 1,NVER
         CALL ISTAB ('PC', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL PCSEL (DISKIN, CNOIN,
     *      DISKOU, CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BIF, EIF, OFQID, TIME1, TIME2, NSOUWD, SOUWAN, AN, NA, ISUB,
     *      JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 260     CONTINUE
C                                       PD tables
      CALL FNDEXT ('PD', CATUV, NVER)
      IF (DOPOL.LE.0) THEN
         DO 270 VER = 1,NVER
            CALL ISTAB ('PD', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *         EXIST, FITASC, IERR)
            IF (EXIST .AND. (IERR.EQ.0)) CALL PDSEL (DISKIN, CNOIN,
     *         DISKOU, CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BPOL,
     *         EPOL, BIF, EIF, BCHAN, ECHAN, OFQID, ISUB, JSUB, BUFF1,
     *         BUFF2, IRET)
            IF (IRET.GT.0) GO TO 999
 270        CONTINUE
         END IF
C                                       PP tables
      CALL FNDEXT ('PP', CATUV, NVER)
      DO 275 VER = 1,NVER
         CALL ISTAB ('PP', DISKIN, FCNO(2), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL PPSEL (DISKIN, CNOIN,
     *      DISKOU, CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BIF, EIF,
     *      BCHAN, ECHAN, TIME1, TIME2, OFQID, ISUB, JSUB, BUFF1, BUFF2,
     *      IRET)
         IF (IRET.GT.0) GO TO 999
 275     CONTINUE
C                                       SN tables
      CALL FNDEXT ('SN', CATUV, NVER)
      IF (DOCAL) NVER = 0
      DO 280 VER = 1,NVER
         CALL ISTAB ('SN', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL SNSEL (DISKIN, CNOIN,
     *      DISKOU, CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BIF, EIF, OFQID, TIME1, TIME2, ISUB, JSUB, BUFF1, BUFF2,
     *      IRET)
         IF (IRET.GT.0) GO TO 999
 280     CONTINUE
C                                       SY tables
      CALL FNDEXT ('SY', CATUV, NVER)
      DO 290 VER = 1,NVER
         CALL ISTAB ('SY', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL SYSEL (DISKIN, CNOIN,
     *      DISKOU, CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BIF, EIF, OFQID, TIME1, TIME2, NSOUWD, SOUWAN, AN, NA, ISUB,
     *      JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 290     CONTINUE
C                                       SU tables
      IF (ILOCSU.GE.0) THEN
         CALL FNDEXT ('SU', CATUV, NVER)
         DO 300 VER = 1,NVER
            CALL ISTAB ('SU', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *         EXIST, FITASC, IERR)
            IF (EXIST .AND. (IERR.EQ.0)) CALL SUSEL (DISKIN, CNOIN,
     *         DISKOU, CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BIF, EIF,
     *         OFQID, BUFF1, BUFF2, IRET)
            IF (IRET.GT.0) GO TO 999
 300        CONTINUE
         END IF
C                                       TY tables
      CALL FNDEXT ('TY', CATUV, NVER)
      DO 320 VER = 1,NVER
         CALL ISTAB ('TY', DISKIN, CNOIN, VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL TYSEL (DISKIN, CNOIN,
     *      DISKOU, CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      BIF, EIF, OFQID, TIME1, TIME2, AN, NA, ISUB, JSUB, BUFF1,
     *      BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 320     CONTINUE
C                                       WX tables
      CALL FNDEXT ('WX', CATUV, NVER)
      DO 340 VER = 1,NVER
         CALL ISTAB ('WX', DISKIN, FCNO(2), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL WXSEL (DISKIN, CNOIN,
     *      DISKOU, CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, TIME1,
     *      TIME2, AN, NA, ISUB, JSUB, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 340     CONTINUE
C                                       BL tables
      CALL FNDEXT ('BL', CATUV, NVER)
      IF (DOBL) NVER = 0
      DO 350 VER = 1,NVER
         CALL ISTAB ('BL', DISKIN, FCNO(2), VER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) CALL BLSEL (DISKIN, CNOIN,
     *      DISKOU, CNOOUT, VER, CATUV, CATBLK, LUN1, LUN2, BPOL, EPOL,
     *      AN, NA, ISUB, JSUB, BIF, EIF, OFQID, BUFF1, BUFF2, IRET)
         IF (IRET.GT.0) GO TO 999
 350     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1160 FORMAT ('COPTAB: ONLY FG TABLE VERSIONS',I4,' TO',I4,' COPIED')
      END

      PROGRAM MATHS
C-----------------------------------------------------------------------
C! Performs mathematical functions on an image
C# Map-util math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 1999-2000, 2008-2010, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MATHS operates on your image with one of a variety of simple
C   mathematical functions.
C RPARM    INPUTS:
C  1        USERID               Owner of the image
C  2-4      INNAME(3)            Image name (name)
C  5-6      INCLASS(2)           Image name (class)
C  7        INSEQ                Image name (seq. #)
C  8        INDISK               Disk # of image
C  9-11     OUTNAME(3)           Output image name (name)
C  12-13    OUTCLASS(2)          Output image name (class)
C  14       OUTSEQ               Output image name (seq. #)
C  15       OUTDISK              Disk # of output image
C  16-22    BLC(7)               BLC of input image
C  23-29    TRC(7)               TRC of input image
C  30       OPCODE               Operator, SIN, COS, TAN, ASIN, ACOS,
C                                ATAN, LOG, ALOG, LOGN, EXP, POLY, POWR,
C                                MOD, DIVP
C  31-40    CPARM(10)            User supplied parameters, 1-6 used
C     Neil Killeen, April 1987
C-----------------------------------------------------------------------
      INTEGER   NOP
      PARAMETER (NOP = 15)
C
      CHARACTER INNAM*36, OUTNAM*36, OPCODE*4, LIST(NOP)*4
      REAL      RPARM(40), CPARM(10), BLKVAL
      INTEGER   NROWS, NCOLS, BLC(7), TRC(7), LIN, LOUT, NPARMS, IERR,
     *   IER, INSL, OUTSL, INVOL, OUTVOL
      DATA LIN, LOUT, NPARMS /17, 18, 39/
      DATA LIST /'SIN ', 'COS ', 'TAN ', 'ASIN', 'ACOS', 'ATAN',
     *           'LOG ', 'LOGN', 'ALOG', 'EXP ', 'POLY', 'POWR',
     *           'MOD ', 'ABS ', 'DIVP'/
C-----------------------------------------------------------------------
C                                       Start up task & get inputs
      CALL START (NPARMS, RPARM, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Extract some user parameters
      CALL EXTRAC (RPARM, NOP, LIST, CPARM, OPCODE, BLKVAL, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Open input & output images
      CALL OPENIM (OPCODE, RPARM, LIN, LOUT, INNAM, OUTNAM, INSL,
     *             OUTSL, INVOL, OUTVOL, BLC, TRC, NCOLS, NROWS, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Compute output image
      CALL OUTPUT (LIST, OPCODE, CPARM, LIN, LOUT, NROWS, NCOLS,
     *             BLKVAL, OUTSL, OUTVOL, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Add history file
      CALL MATHHI (INNAM, OUTNAM, INSL, OUTSL, INVOL, OUTVOL,
     *             BLC, TRC, OPCODE, CPARM, LIST, IERR)
C
 900  IF (IERR.EQ.0) THEN
         IER = 0
      ELSE
         IER = 1
         END IF
      CALL CLENUP
      CALL TSKEND (IER)
C
      STOP
      END
      SUBROUTINE START (NPARMS, RPARM, IERR)
C-----------------------------------------------------------------------
C     Start up the task and get AIPS inputs
C     INPUT:
C       NPARMS   I       Number of AIPS parameters
C     OUTPUT:
C       RPARM    R       AIPS input parameters
C       IERR     I       0 => OK
C-----------------------------------------------------------------------
      REAL   RPARM(*)
      INTEGER   NPARMS, IERR
      CHARACTER PRGNAM*6
      INCLUDE 'INCS:DMSG.INC'
      DATA PRGNAM /'MATHS '/
C-----------------------------------------------------------------------
      CALL TSKBEG (PRGNAM, NPARMS, RPARM(2), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
      ELSE
         WRITE (MSGTXT,2000)
         END IF
      CALL MSGWRT (8)
      RPARM(1) = NLUSER
C
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('START: COULD NOT GET INPUTS, IERR=', I3)
 2000 FORMAT ('You are using a non-standard program')
      END
      SUBROUTINE EXTRAC (RPARM, NOP, LIST, CPARM, OPCODE, BLKVAL, IERR)
C-----------------------------------------------------------------------
C     Extract some of the user supplied parameters from the INPUTS
C     INPUT:
C        RPARM    R      AIPS inputs
C        NOP      I      Number of allowed operators
C        LIST     C(*)*4 List of allowed operators
C     OUTPUT:
C        CPARM    R      Scale and additive factors for image
C        OPCODE   C*4    Operator; SIN, COS, TAN, ASIN, ACOS, ATAN,
C                                  LOG, LOGN, ALOG, EXP, POLY, POWR,
C                                  MOD
C        BLKVAL   R      Value to use for undefined output pixels
C                        'INDE' or 0.0
C        IERR     I      0 => OK
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, LIST(*)*4
      REAL      CPARM(*), RPARM(*), BLKVAL
      INTEGER   I, NOP
      INTEGER   IERR
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Check if OPCODE acceptable
      CALL H2CHR (4, 1, RPARM(30), OPCODE)
      IERR = 0
      DO 100 I = 1,NOP
         IF (OPCODE.EQ.LIST(I)) THEN
            GO TO 200
            END IF
 100     CONTINUE
C                                       No match found
      WRITE (MSGTXT,1000) OPCODE
      CALL MSGWRT (8)
      IERR = 1
      GO TO 999
C                                       Fill CPARMS and set defaults
 200  CPARM(1) = RPARM(31)
      CPARM(2) = RPARM(32)
      IF ((RPARM(32).EQ.0.0) .AND. (OPCODE.NE.'POLY') .AND.
     *   (OPCODE.NE.'DIVP')) CPARM(2) = 1.0
      CPARM(3) = RPARM(33)
      IF ((RPARM(33).EQ.0.0) .AND. (OPCODE.NE.'POLY') .AND.
     *   (OPCODE.NE.'DIVP')) CPARM(3) = 1.0
      CPARM(4) = RPARM(34)
      CPARM(5) = RPARM(35)
C                                       Tell user what's going on
      WRITE (MSGTXT,2000)
      CALL MSGWRT (8)
      IF (OPCODE.EQ.'MOD') THEN
         WRITE (MSGTXT,3000) CPARM(1), CPARM(2), CPARM(3),
     *      CPARM(4), CPARM(5)
      ELSE IF (OPCODE.EQ.'POWR') THEN
         WRITE (MSGTXT,4000) CPARM(1), CPARM(2), CPARM(3),
     *      CPARM(4), CPARM(5)
      ELSE IF (OPCODE.EQ.'POLY') THEN
         WRITE (MSGTXT,5000) CPARM(1), CPARM(2), CPARM(3), CPARM(4)
      ELSE IF (OPCODE.EQ.'DIVP') THEN
         WRITE (MSGTXT,5010) CPARM(1), CPARM(2), CPARM(3), CPARM(4)
      ELSE
         WRITE (MSGTXT,6000) CPARM(1), CPARM(2), OPCODE, CPARM(3),
     *      CPARM(4)
         END IF
      CALL MSGWRT (8)
C                                       Blank with magic values or
C                                       zeroes
      CPARM(6) = RPARM(36)
      IF (CPARM(6).GT.0.0) THEN
         BLKVAL = 0.0
         WRITE (MSGTXT,7000)
      ELSE
         BLKVAL = FBLANK
         WRITE (MSGTXT,8000)
         END IF
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OPCODE ''', A4, ''' IS UNRECOGNIZED')
 2000 FORMAT ('Output pixel formed from input pixel according to:')
 3000 FORMAT (1PE10.3, '+', 1PE10.3, '* MOD[', 1PE10.3, '*in+',
     *        1PE10.3, ',', 1PE10.3, ']')
 4000 FORMAT (1PE10.3, '+', 1PE10.3, '*[', 1PE10.3, '*in+',
     *        1PE10.3, ']**', 1PE10.3)
 5000 FORMAT (1PE10.3, '+', 1PE10.3, '*in + ', 1PE10.3, '*in**2 + ',
     *        1PE10.3, '*in**3')
 5010 FORMAT (1PE10.3, '+', 1PE10.3, '/in + ', 1PE10.3, '/in**2 + ',
     *        1PE10.3, '/in**3')
 6000 FORMAT (1PE10.3, '+', 1PE10.3, '*', A4, '[', 1PE10.3, '*in+',
     *        1PE10.3, ']')
 7000 FORMAT ('EXTRAC: All undefined output pixels zeroed')
 8000 FORMAT ('EXTRAC: All undefined output pixels magic blanked')
      END
      SUBROUTINE OPENIM (OPCODE, RPARM, LIN, LOUT, INNAM, OUTNAM,
     *   INSL, OUTSL, INVOL, OUTVOL, BLC, TRC, NCOLS, NROWS, IERR)
C-----------------------------------------------------------------------
C     Open the input image, create and open the output image
C     Input:
C         OPCODE    C*4     Operator, determines default class of
C                           output image
C         RPARM     R       array of AIPS input parameters
C         LIN       I       logical unit number for input image
C         LOUT      I       logical unit number for output image
C     Output:
C         INNAM     C*36    Namestring for input image
C         OUTNAM    C*36    Namestring for output image
C         INSL      I       Cat slot of input image
C         OUTSL     I       Cat slot of output image
C         INVOL     I       Volume number of input image
C         OUTVOL    I       Volume number of output image
C         BLC       I       Input image BLC, defaults filled in
C         TRC       I       Input image TRC, defaults filled in
C         NCOLS     I       Number of columns in output image
C         NROWS     I       Number of rows in output image
C         IERR      I       Error status, 0=> OK
C-----------------------------------------------------------------------
      CHARACTER INNAM*36, OUTNAM*36, OPCODE*4
      REAL      RPARM(*)
      INTEGER   NROWS, NCOLS, BLC(7), TRC(7)
      INTEGER   LIN, LOUT, IERR, INSL, OUTSL, OUTVOL, INVOL
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Open input image
      CALL OPENIN (RPARM, LIN, INNAM, BLC, TRC, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 900
         END IF
C                                       Get catalog slot
      CALL CATSLV (LIN, INSL, INVOL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,2000) IERR
         GO TO 900
         END IF
C                                       Create and open output image
      CALL OPENOU (OPCODE, RPARM, LOUT, BLC, TRC, OUTNAM, NCOLS, NROWS,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,3000) IERR
         GO TO 900
         END IF
C                                       Get catalog slot
      CALL CATSLV (LOUT, OUTSL, OUTVOL, IERR)
      IF (IERR.NE.0) WRITE (MSGTXT,4000) IERR
C
 900  IF (IERR.NE.0) CALL MSGWRT (8)
C
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OPENIM: COULD NOT OPEN INPUT IMAGE, IERR=', I3)
 2000 FORMAT ('OPENIM: COULD NOT FIND INPUT IMAGE CAT SLOT, IERR=', I3)
 3000 FORMAT ('OPENIM: COULD NOT OPEN OUTPUT IMAGE, IERR=', I3)
 4000 FORMAT ('OPENIM: COULD NOT FIND OUTPUT IMAGE CAT SLOT, IERR=', I3)
      END
      SUBROUTINE OPENIN (RPARM, LIN, INNAM, BLC, TRC, IERR)
C-----------------------------------------------------------------------
C     Set up the input namestring, open the input image, get the header
C     and window the input image
C     Input:
C         RPARM     R       array of AIPS input parameters
C         LIN       I       LUN of input image
C     Output:
C         INNAM     C*36    Namestring for input image
C         BLC,TRC   I       Window with defaults filled in
C         IERR      I       error status, 0=> OK
C-----------------------------------------------------------------------
      CHARACTER INNAM*36
      HOLLERITH MAP(1)
      REAL   OLDR(256), RPARM(*), RBLC(7), RTRC(7)
      INTEGER   BLC(7), TRC(7)
      INTEGER   LIN, OLDI(256), IERR, DUM(256)
      INCLUDE 'INCS:DMSG.INC'
      COMMON /HEADS/ OLDI, DUM
      EQUIVALENCE (OLDI, OLDR)
C-----------------------------------------------------------------------
C                                       Set up input namestring
      CALL CHR2H (4, 'MA  ', 1, MAP)
      CALL H2WAWA (RPARM(2), RPARM(5), RPARM(7), MAP, RPARM(8),
     *   RPARM(1), INNAM)
      CALL H2WAWA (RPARM(2), RPARM(5), RPARM(7), MAP, RPARM(8),
     *   RPARM(1), INNAM)
C                                       Open input image
      CALL OPENCF (LIN, INNAM, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 900
         END IF
C                                       Get header
      CALL GETHDR (LIN, OLDI, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,2000) IERR
         GO TO 900
         END IF
C                                       Set up image window
      CALL RCOPY (7, RPARM(16), RBLC)
      CALL RCOPY (7, RPARM(23), RTRC)
      CALL CHKWIN (RBLC, RTRC, OLDI, BLC, TRC, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,3000) IERR
         GO TO 900
         END IF
      CALL MAPWIN (LIN, RBLC, RTRC, IERR)
      IF (IERR.NE.0) WRITE (MSGTXT,4000) IERR
C
 900  IF (IERR.NE.0) CALL MSGWRT (8)
C
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OPENIN: ERROR OPENING INPUT IMAGE, IERR=', I3)
 2000 FORMAT ('OPENIN: ERROR GETTING INPUT IMAGE HEADER, IERR=', I3)
 3000 FORMAT ('OPENIN: ILLEGAL WINDOW, IERR = ', I3)
 4000 FORMAT ('OPENIM: ERROR WINDOWING INPUT IMAGE, IERR = ', I3)
      END
      SUBROUTINE CHKWIN (BLC, TRC, HEADI, IBLC, ITRC, IERR)
C-----------------------------------------------------------------------
C     Check that a 2-D window is sensible, and set zero defaults to
C     (1,1) and (NCOLS,NROWS)  Both R   and I   versions of the
C     window, with defaults filled in, are returned.
C     Input/output:
C       BLC      R       BLC of window
C       TRC      R       TRC of window
C     Input:
C       HEADI    I       Header of associated image
C     Output:
C       IBLC     I       BLC of (corrected) window
C       ITRC     I       TRC of (corrected) window
C       IERR     I       0 => OK
C-----------------------------------------------------------------------
      REAL   BLC(7), TRC(7)
      INTEGER   IBLC(7), ITRC(7)
      INTEGER   HEADI(256), IERR, I
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       Extract size and window
      CALL WINDOW (HEADI(KIDIM), HEADI(KINAX), BLC, TRC, IERR)
      IF (IERR.EQ.0) THEN
         DO 10 I = 1,7
           IBLC(I) = BLC(I) + 0.01
           ITRC(I) = TRC(I) + 0.01
 10        CONTINUE
         END IF
C
      RETURN
      END
      SUBROUTINE CATSLV (LUN, SLOT, VOL, IERR)
C-----------------------------------------------------------------------
C     Get catalog slot and volume number for open image file specified
C     by its LUN
C     Input:
C       LUN      I       Logical unit number of OPEN image
C    Output:
C       SLOT     I       Catalog slot of image
C       VOL      I       Volume number
C       IERR     I       Error status, 0 => OK
C
C-----------------------------------------------------------------------
      INTEGER   LUN, SLOT, VOL, IERR, I
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DITB.INC'
C-----------------------------------------------------------------------
C                                       Match LUN in FILTAB
      DO 100 I = 1,EFIL
         IF (FILTAB(POLUN,I).EQ.LUN) THEN
            SLOT = FILTAB(POCAT,I)
            VOL  = FILTAB(POVOL,I)
            IERR = 0
            GO TO 999
            END IF
 100     CONTINUE
C                                       Didn't find LUN in FILTAB
      WRITE (MSGTXT,1000) LUN
      CALL MSGWRT (8)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CATSLV: CAN''T FIND LUN = ', I3, ' IN FILTAB')
      END
      SUBROUTINE OPENOU (OPCODE, RPARM, LOUT, BLC, TRC, OUTNAM, NCOLS,
     *   NROWS, IERR)
C-----------------------------------------------------------------------
C     Create and open output image
C     Inputs:
C         OPCODE    C*4     Operator , determines default class
C         RPARM     R       array of AIPS input parameters
C         LOUT      I       LUN for output image
C         BLC,TRC   I       Input image window
C     OUTPUTS:
C         OUTNAM    C*36    Namestring for output image
C         NCOLS     I       Number of columns in output image
C         NROWS     I       Number of rows in output image
C         IERR      I       error status, 0=> OK
C
C-----------------------------------------------------------------------
      CHARACTER DEFNAM*36, OUTNAM*36, OPCODE*4
      REAL   RPARM(*)
      HOLLERITH MAP(1), XCLAS(2)
      INTEGER   BLC(7), TRC(7), NCOLS, NROWS
      INTEGER   LOUT, IERR, OLDI(256), CATBLK(256)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      COMMON /HEADS/ OLDI, CATBLK
C-----------------------------------------------------------------------
C                                       Output name string
      CALL CHR2H (4, 'MA  ', 1, MAP)
      CALL CHR2H (6, OPCODE, 1, XCLAS)
      CALL H2WAWA (RPARM(2), XCLAS, RPARM(7), MAP, RPARM(8),
     *   RPARM(1), DEFNAM)
      CALL H2WAWA (RPARM(9), RPARM(12), RPARM(14), MAP, RPARM(15),
     *   RPARM(1), OUTNAM)
C                                       Create output map header
      CALL HEADER (BLC, TRC, NCOLS, NROWS)
C                                       Create output image
      CALL MAPCR (DEFNAM, OUTNAM, CATBLK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 900
         END IF
C                                       Open output image
      CALL OPENCF (LOUT, OUTNAM, IERR)
      IF (IERR.NE.0) WRITE (MSGTXT,2000) IERR
C
 900  IF (IERR.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OPENOU: COULD NOT CREATE OUTPUT IMAGE, IERR=', I3)
 2000 FORMAT ('OPENOU: COULD NOT OPEN OUTPUT IMAGE, IERR=',  I3)
      END
      SUBROUTINE HEADER (BLC, TRC, NCOLS, NROWS)
C-----------------------------------------------------------------------
C     Make the output image header
C     Input:
C         BLC       I       BLC of input image
C         TRC       I       TRC of input image
C     Ouput:
C         NCOLS     I       Number of columns in output image
C         NROWS     I       Number of rows in output image
C-----------------------------------------------------------------------
      DOUBLE PRECISION OLDD(128), CATD(128)
      REAL   CATR(256)
      CHARACTER UNITS*8
      HOLLERITH CATH(256)
      INTEGER   BLC(7), TRC(7), NCOLS, NROWS, I
      INTEGER   OLDI(256), CATBLK(256), CATEMP(256)
      REAL      RBLC(7), RTRC(7)
      INCLUDE 'INCS:DHDR.INC'
      COMMON /HEADS/ OLDI, CATBLK
      COMMON /MAPHDR/ CATEMP
      EQUIVALENCE (OLDI, OLDD), (CATBLK, CATR, CATD, CATH)
      DATA UNITS /'UNDEFINE'/
C-----------------------------------------------------------------------
C                                              Make output image header
      CALL COPY (256, OLDI, CATEMP)
      NCOLS = TRC(1) - BLC(1) + 1
      NROWS = 1
      DO 10 I = 1,7
         RBLC(I) = BLC(I)
         RTRC(I) = TRC(I)
         NROWS = NROWS * (TRC(I) - BLC(I) + 1)
 10      CONTINUE
      NROWS = NROWS / NCOLS
      CALL SUBHDR (RBLC, RTRC, 1.0, 1.0)
      CALL COPY (256, CATEMP, CATBLK)
C
      CALL CHR2H (8, UNITS, 1, CATH(KHBUN))
      CATR(KRBLK) = 0.0
C
 999  RETURN
      END
      SUBROUTINE OUTPUT (LIST, OPCODE, CPARM, LIN, LOUT, NROWS,
     *   NCOLS, BLKVAL, OUTSL, OUTVOL, IERR)
C-----------------------------------------------------------------------
C   Main subroutine to operate on image with the desired scalpel
C   Input:
C       LIST(*)    C*4   List of allowed operators
C       OPCODE     C*4   Operator code
C       CPARM      R     Multiplicative and additive factors for input
C                        image
C       LIN,LOUT   I     LUNS for input and output files
C       NROWS      I     Number of rows in output image
C       NCOLS      I     Number of columns in output image
C       BLKVAL     R     Value assigned to undefined pixels, 'INDE' or
C                        0.0
C       OUTSL      I     Output image cat slot
C       OUTVOL     I     Output image volume number
C     OUTPUT:
C       IERR       I     0 => OK
C-----------------------------------------------------------------------
      CHARACTER LIST(*)*4, OPCODE*4
      INCLUDE 'INCS:PMAD.INC'
      REAL   CPARM(*), RBUF(MAXIMG), CATR(256), DMIN, DMAX, BLKVAL
      INTEGER   NROWS, NCOLS
      INTEGER   LIN, LOUT, IERR, OUTSL, OUTVOL, DUM2(256),
     *   CATBLK(256), IBUFF(256)
      LOGICAL BLANKS
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMMON /HEADS/ DUM2, CATBLK
      EQUIVALENCE (CATBLK, CATR)
      DATA DMIN, DMAX, BLANKS /1.0E34, -1.0E34, .FALSE./
C-----------------------------------------------------------------------
C                                       Branch for each operator
      IF (OPCODE.EQ.'SIN') THEN
         CALL SINE (NROWS, NCOLS, LIN, LOUT, CPARM, BLKVAL,
     *      RBUF, DMIN, DMAX, BLANKS, IERR)
      ELSE IF (OPCODE.EQ.'COS') THEN
         CALL COSINE (NROWS, NCOLS, LIN, LOUT, CPARM, BLKVAL,
     *      RBUF, DMIN, DMAX, BLANKS, IERR)
      ELSE IF (OPCODE.EQ.'TAN') THEN
         CALL TANGEN (NROWS, NCOLS, LIN, LOUT, CPARM, BLKVAL,
     *      RBUF, DMIN, DMAX, BLANKS, IERR)
      ELSE IF (OPCODE.EQ.'ASIN') THEN
         CALL ASINE (NROWS, NCOLS, LIN, LOUT, CPARM, BLKVAL,
     *      RBUF, DMIN, DMAX, BLANKS, IERR)
      ELSE IF (OPCODE.EQ.'ACOS') THEN
         CALL ACOSIN (NROWS, NCOLS, LIN, LOUT, CPARM, BLKVAL,
     *      RBUF, DMIN, DMAX, BLANKS, IERR)
      ELSE IF (OPCODE.EQ.'ATAN') THEN
         CALL ATANGE (NROWS, NCOLS, LIN, LOUT, CPARM, BLKVAL,
     *      RBUF, DMIN, DMAX, BLANKS, IERR)
      ELSE IF (OPCODE.EQ.'LOG') THEN
         CALL LOGARI (NROWS, NCOLS, LIN, LOUT, CPARM, BLKVAL,
     *      RBUF, DMIN, DMAX, BLANKS, IERR)
      ELSE IF (OPCODE.EQ.'LOGN') THEN
         CALL NLOGAR (NROWS, NCOLS, LIN, LOUT, CPARM, BLKVAL,
     *      RBUF, DMIN, DMAX, BLANKS, IERR)
      ELSE IF (OPCODE.EQ.'ALOG') THEN
         CALL ALOGAR (NROWS, NCOLS, LIN, LOUT, CPARM, BLKVAL,
     *      RBUF, DMIN, DMAX, BLANKS, IERR)
      ELSE IF (OPCODE.EQ.'EXP') THEN
         CALL EXPONE (NROWS, NCOLS, LIN, LOUT, CPARM, BLKVAL,
     *      RBUF, DMIN, DMAX, BLANKS, IERR)
      ELSE IF (OPCODE.EQ.'POLY') THEN
         CALL POLYNO (NROWS, NCOLS, LIN, LOUT, CPARM, BLKVAL,
     *      RBUF, DMIN, DMAX, BLANKS, IERR)
      ELSE IF (OPCODE.EQ.'POWR') THEN
         CALL POWER (NROWS, NCOLS, LIN, LOUT, CPARM, BLKVAL,
     *      RBUF, DMIN, DMAX, BLANKS, IERR)
      ELSE IF (OPCODE.EQ.'MOD') THEN
         CALL MODUL (NROWS, NCOLS, LIN, LOUT, CPARM, BLKVAL,
     *      RBUF, DMIN, DMAX, BLANKS, IERR)
      ELSE IF (OPCODE.EQ.'ABS') THEN
         CALL ABSOL (NROWS, NCOLS, LIN, LOUT, CPARM, BLKVAL,
     *      RBUF, DMIN, DMAX, BLANKS, IERR)
      ELSE IF (OPCODE.EQ.'DIVP') THEN
         CALL DIVPOL (NROWS, NCOLS, LIN, LOUT, CPARM, BLKVAL,
     *      RBUF, DMIN, DMAX, BLANKS, IERR)
         END IF
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 900
         END IF
C                                       Update header
      IF (BLANKS .AND. BLKVAL.NE.FBLANK) THEN
         DMIN = MIN (BLKVAL, DMIN)
         DMAX = MAX (BLKVAL, DMAX)
         END IF
      CATR(KRDMN) = DMIN
      CATR(KRDMX) = DMAX
C
      IF (BLANKS .AND. BLKVAL.EQ.FBLANK) CATR(KRBLK) = FBLANK
      CALL CATIO ('UPDT', OUTVOL, OUTSL, CATBLK, 'REST', IBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,2000) IERR
         GO TO 900
      END IF
C                                       Close image files
      CALL FILCLS (LIN)
      CALL FILCLS (LOUT)
C
 900  IF (IERR.NE.0) CALL MSGWRT (8)
C
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OUTPUT: ERROR COMPUTING OUTPUT IMAGE, IERR = ', I3)
 2000 FORMAT ('OUTPUT: COULD NOT UPATE HEADER, IERR=', I3)
      END
      SUBROUTINE SINE (NROWS, NCOLS, LIN, LOUT, C, BLKVAL, RBUF,
     *   DMIN, DMAX, BLANKS, IERR)
C-----------------------------------------------------------------------
C   Take SINE of image in DEGREES
C      OUT = C(1) + C(2) * SIN (C(3) * IN + C(4))
C   Input:
C      NROWS       I            Number of rows in output image
C      NCOLS       I            Number of columns in output image
C      LIN         I            LUN of input image
C      LOUT        I            LUN of output image
C      C           R            Scale and offset factors
C      BLKVAL      R            Value for undefined pixels
C   Input/output:
C      RBUF        R            Data buffer
C      DMIN,DMAX   R            Min and max in image
C      BLANKS      L            .true. if MAGIC blank in output image
C      IERR        I            0 => OK
C-----------------------------------------------------------------------
      REAL      RBUF(*), DMIN, DMAX,  C(*), FAC, DR, BLKVAL
      INTEGER   NCOLS, NROWS, I, J
      INTEGER   LIN, LOUT, IERR
      LOGICAL   BLANKS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA DR /1.7453293E-2/
C-----------------------------------------------------------------------
      DO 200 J = 1, NROWS
         CALL MAPIO ('READ', LIN, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 100 I = 1, NCOLS
            IF (RBUF(I).EQ.FBLANK) THEN
               BLANKS = .TRUE.
               RBUF(I) = BLKVAL
            ELSE
               FAC = DR * (C(3) * RBUF(I) + C(4))
               RBUF(I) = C(1) + C(2) * SIN (FAC)
               DMIN = MIN (DMIN, RBUF(I))
               DMAX = MAX (DMAX, RBUF(I))
               END IF
 100        CONTINUE
         CALL MAPIO ('WRIT', LOUT, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SINE: COULD NOT READ LINE # ', I4, ' IERR=', I3)
 2000 FORMAT ('SINE: COULD NOT WRITE LINE # ', I4, ' IERR=', I3)
      END
      SUBROUTINE COSINE (NROWS, NCOLS, LIN, LOUT, C, BLKVAL,
     *   RBUF, DMIN, DMAX, BLANKS, IERR)
C-----------------------------------------------------------------------
C     Take COSINE of image in DEGREES.
C         OUT = C(1) + C(2) * COS (C(3) * IN + C(4))
C     Input:
C       NROWS       I            Number of rows in output image
C       NCOLS       I            Number of columns in output image
C       LIN         I            LUN of input image
C       LOUT        I            LUN of output image
C       C           R            Scale and offset factors
C       BLKVAL      R            Value for undefined pixels
C     Input/output:
C       RBUF        R            Data buffer
C       DMIN,DMAX   R            Min and max in image
C       BLANKS      L            .true. if MAGIC blank in output image
C       IERR        I            0 => OK
C-----------------------------------------------------------------------
      REAL   RBUF(*), DMIN, DMAX,  C(*), FAC, DR, BLKVAL
      INTEGER   NCOLS, NROWS, I, J
      INTEGER   LIN, LOUT, IERR
      LOGICAL BLANKS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA DR /1.7453293E-2/
C-----------------------------------------------------------------------
      DO 200 J = 1, NROWS
         CALL MAPIO ('READ', LIN, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 100 I = 1, NCOLS
            IF (RBUF(I).EQ.FBLANK) THEN
               BLANKS = .TRUE.
               RBUF(I) = BLKVAL
            ELSE
               FAC = DR * (C(3) * RBUF(I) + C(4))
               RBUF(I) = C(1) + C(2) * COS (FAC)
               DMIN = MIN (DMIN, RBUF(I))
               DMAX = MAX (DMAX, RBUF(I))
               END IF
 100        CONTINUE
         CALL MAPIO ('WRIT', LOUT, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('COSINE: COULD NOT READ LINE # ', I4, ' IERR=', I3)
 2000 FORMAT ('COSINE: COULD NOT WRITE LINE # ', I4, ' IERR=', I3)
      END
      SUBROUTINE TANGEN (NROWS, NCOLS, LIN, LOUT, C, BLKVAL,
     *   RBUF, DMIN, DMAX, BLANKS, IERR)
C-----------------------------------------------------------------------
C     Take TANGENT of image in DEGREES
C         OUT = C(1) + C(2) * TAN (C(3) * IN + C(4))
C     Input:
C       NROWS       I            Number of rows in output image
C       NCOLS       I            Number of columns in output image
C       LIN         I            LUN of input image
C       LOUT        I            LUN of output image
C       C           R            Scale and offset factors
C       BLKVAL      R            Value for undefined pixels
C     Input/output:
C       RBUF        R            Data buffer
C       DMIN,DMAX   R            Min and max in image
C       BLANKS      L            .true. if MAGIC blank in output image
C       IERR        I            0 => OK
C-----------------------------------------------------------------------
      REAL   RBUF(*), DMIN, DMAX,  C(*), FAC, REM, DR, BLKVAL
      INTEGER   NCOLS, NROWS, I, J
      INTEGER   LIN, LOUT, IERR
      LOGICAL BLANKS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA DR /1.7453293E-2/
C-----------------------------------------------------------------------
      DO 200 J = 1, NROWS
         CALL MAPIO ('READ', LIN, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 100 I = 1, NCOLS
            IF (RBUF(I).EQ.FBLANK) THEN
               BLANKS = .TRUE.
               RBUF(I) = BLKVAL
            ELSE
               FAC = C(3) * RBUF(I) + C(4)
               REM = ABS (MOD (FAC, 360.0))
               IF (REM.EQ.90.0 .OR. REM.EQ.270.0) THEN
                  RBUF(I) = BLKVAL
                  BLANKS = .TRUE.
               ELSE
                  RBUF(I) = C(1)  +  C(2) * TAN (DR * FAC)
                  DMIN = MIN (DMIN, RBUF(I))
                  DMAX = MAX (DMAX, RBUF(I))
                  END IF
               END IF
 100        CONTINUE
         CALL MAPIO ('WRIT', LOUT, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TANGEN: COULD NOT READ LINE # ', I4, ' IERR=', I3)
 2000 FORMAT ('TANGEN: COULD NOT WRITE LINE # ', I4, ' IERR=', I3)
      END
      SUBROUTINE ASINE (NROWS, NCOLS, LIN, LOUT, C, BLKVAL,
     *   RBUF, DMIN, DMAX, BLANKS, IERR)
C-----------------------------------------------------------------------
C     Take ARCSINE of image, THETA returned in the range
C                       -90 < THETA < 90  degrees
C         OUT = C(1) + C(2) * ASIN (C(3) * IN + C(4))
C     Input:
C       NROWS       I            Number of rows in output image
C       NCOLS       I            Number of columns in output image
C       LIN         I            LUN of input image
C       LOUT        I            LUN of output image
C       C           R            Scale and offset factors
C       BLKVAL      R            Value for undefined pixels
C     Input/output:
C       RBUF        R            Data buffer
C       DMIN,DMAX   R            Min and max in image
C       BLANKS      L            .true. if MAGIC blank in output image
C       IERR        I            0 => OK
C-----------------------------------------------------------------------
      REAL   RBUF(*), DMIN, DMAX,  C(*), FAC, RD, BLKVAL
      INTEGER   NCOLS, NROWS, I, J
      INTEGER   LIN, LOUT, IERR
      LOGICAL BLANKS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA RD /5.72957795E1/
C-----------------------------------------------------------------------
      DO 200 J = 1, NROWS
         CALL MAPIO ('READ', LIN, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 100 I = 1, NCOLS
            IF (RBUF(I).EQ.FBLANK) THEN
               BLANKS = .TRUE.
               RBUF(I) = BLKVAL
            ELSE
               FAC = C(3) * RBUF(I) + C(4)
               IF (ABS(FAC).GT.1.0) THEN
                  RBUF(I) = BLKVAL
                  BLANKS = .TRUE.
               ELSE
                  RBUF(I) = C(1) + C(2) * RD * ASIN (FAC)
                  DMIN = MIN (DMIN, RBUF(I))
                  DMAX = MAX (DMAX, RBUF(I))
                  END IF
               END IF
 100        CONTINUE
         CALL MAPIO ('WRIT', LOUT, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ASINE: COULD NOT READ LINE # ', I4, ' IERR=', I3)
 2000 FORMAT ('ASINE: COULD NOT WRITE LINE # ', I4, ' IERR=', I3)
      END
      SUBROUTINE ACOSIN (NROWS, NCOLS, LIN, LOUT, C, BLKVAL,
     *   RBUF, DMIN, DMAX, BLANKS, IERR)
C-----------------------------------------------------------------------
C     Take ARCCOSINE of image, THETA returned in the range
C                         0 < THETA < 180 degrees
C         OUT = C(1) + C(2) * ACOS (C(3) * IN + C(4))
C     Input:
C       NROWS       I            Number of rows in output image
C       NCOLS       I            Number of columns in output image
C       LIN         I            LUN of input image
C       LOUT        I            LUN of output image
C       C           R            Scale and offset factors
C       BLKVAL      R            Value for undefined pixels
C     Input/output:
C       RBUF        R            Data buffer
C       DMIN,DMAX   R            Min and max in image
C       BLANKS      L            .true. if MAGIC blank in output image
C       IERR        I            0 => OK
C-----------------------------------------------------------------------
      REAL   RBUF(*), DMIN, DMAX,  C(*), FAC, RD, BLKVAL
      INTEGER   NCOLS, NROWS, I, J
      INTEGER   LIN, LOUT, IERR
      LOGICAL BLANKS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA RD /5.72957795E1/
C-----------------------------------------------------------------------
      DO 200 J = 1, NROWS
         CALL MAPIO ('READ', LIN, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 100 I = 1, NCOLS
            IF (RBUF(I).EQ.FBLANK) THEN
               BLANKS = .TRUE.
               RBUF(I) = BLKVAL
            ELSE
               FAC = C(3) * RBUF(I) + C(4)
               IF (ABS(FAC).GT.1.0) THEN
                  RBUF(I) = BLKVAL
                  BLANKS = .TRUE.
               ELSE
                  RBUF(I) = C(1)  +  C(2) * RD * ACOS (FAC)
                  DMIN = MIN (DMIN, RBUF(I))
                  DMAX = MAX (DMAX, RBUF(I))
                  END IF
               END IF
 100        CONTINUE
         CALL MAPIO ('WRIT', LOUT, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ACOSIN: COULD NOT READ LINE # ', I4, ' IERR=', I3)
 2000 FORMAT ('ACOSIN: COULD NOT WRITE LINE # ', I4, ' IERR=', I3)
      END
      SUBROUTINE ATANGE (NROWS, NCOLS, LIN, LOUT, C, BLKVAL,
     *   RBUF, DMIN, DMAX, BLANKS, IERR)
C-----------------------------------------------------------------------
C     Take ARCTANGENT of image, THETA returned in the range
C                       -90 < THETA < 90 degrees
C         OUT = C(1) + C(2) * ATAN (C(3) * IN + C(4))
C     Input:
C       NROWS       I            Number of rows in output image
C       NCOLS       I            Number of columns in output image
C       LIN         I            LUN of input image
C       LOUT        I            LUN of output image
C       C           R            Scale and offset factors
C       BLKVAL      R            Value for undefined pixels
C     Input/output:
C       RBUF        R            Data buffer
C       DMIN,DMAX   R            Min and max in image
C       BLANKS      L            .true. if MAGIC blank in output image
C       IERR        I            0 => OK
C-----------------------------------------------------------------------
      REAL   RBUF(*), DMIN, DMAX,  C(*), RD, BLKVAL
      INTEGER   NCOLS, NROWS, I, J
      INTEGER   LIN, LOUT, IERR
      LOGICAL BLANKS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA RD /5.72957795E1/
C-----------------------------------------------------------------------
      DO 200 J = 1, NROWS
         CALL MAPIO ('READ', LIN, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 100 I = 1, NCOLS
            IF (RBUF(I).EQ.FBLANK) THEN
               BLANKS = .TRUE.
               RBUF(I) = BLKVAL
            ELSE
               RBUF(I) = C(1) + C(2) * RD * ATAN (C(3) * RBUF(I) + C(4))
               DMIN = MIN (DMIN, RBUF(I))
               DMAX = MAX (DMAX, RBUF(I))
               END IF
 100        CONTINUE
         CALL MAPIO ('WRIT', LOUT, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ATANGE: COULD NOT READ LINE # ', I4, ' IERR=', I3)
 2000 FORMAT ('ATANGE: COULD NOT WRITE LINE # ', I4, ' IERR=', I3)
      END
      SUBROUTINE LOGARI (NROWS, NCOLS, LIN, LOUT, C, BLKVAL,
     *   RBUF, DMIN, DMAX, BLANKS, IERR)
C-----------------------------------------------------------------------
C     Take LOGARITHM (base 10) of image
C         OUT = C(1) + C(2) * LOG10 (C(3) * IN + C(4))
C     Input:
C       NROWS       I            Number of rows in output image
C       NCOLS       I            Number of columns in output image
C       LIN         I            LUN of input image
C       LOUT        I            LUN of output image
C       C           R            Scale and offset factors
C       BLKVAL      R            Value for undefined pixels
C     Input/output:
C       RBUF        R            Data buffer
C       DMIN,DMAX   R            Min and max in image
C       BLANKS      L            .true. if MAGIC blank in output image
C       IERR        I            0 => OK
C-----------------------------------------------------------------------
      REAL   RBUF(*), DMIN, DMAX,  C(*), FAC, BLKVAL
      INTEGER   NCOLS, NROWS, I, J
      INTEGER   LIN, LOUT, IERR
      LOGICAL BLANKS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      DO 200 J = 1, NROWS
         CALL MAPIO ('READ', LIN, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 100 I = 1, NCOLS
            IF (RBUF(I).EQ.FBLANK) THEN
               BLANKS = .TRUE.
               RBUF(I) = BLKVAL
            ELSE
               FAC = C(3) * RBUF(I) + C(4)
               IF (FAC.GT.0.0) THEN
                  RBUF(I) = C(1) + C(2) * LOG10 (FAC)
                  DMIN = MIN (DMIN, RBUF(I))
                  DMAX = MAX (DMAX, RBUF(I))
               ELSE
                  RBUF(I) = BLKVAL
                  END IF
               END IF
 100        CONTINUE
         CALL MAPIO ('WRIT', LOUT, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('LOGARI: COULD NOT READ LINE # ', I4, ' IERR=', I3)
 2000 FORMAT ('LOGARI: COULD NOT WRITE LINE # ', I4, ' IERR=', I3)
      END
      SUBROUTINE NLOGAR (NROWS, NCOLS, LIN, LOUT, C, BLKVAL,
     *   RBUF, DMIN, DMAX, BLANKS, IERR)
C-----------------------------------------------------------------------
C     Take LOGARITHM (natural-base e) of image
C         OUT = C(1) + C(2) * LOG (C(3) * IN + C(4))
C     Input:
C       NROWS       I            Number of rows in output image
C       NCOLS       I            Number of columns in output image
C       LIN         I            LUN of input image
C       LOUT        I            LUN of output image
C       C           R            Scale and offset factors
C       BLKVAL      R            Value for undefined pixels
C     Input/output:
C       RBUF        R            Data buffer
C       DMIN,DMAX   R            Min and max in image
C       BLANKS      L            .true. if MAGIC blank in output image
C       IERR        I            0 => OK
C-----------------------------------------------------------------------
      REAL   RBUF(*), DMIN, DMAX,  C(*), FAC, BLKVAL
      INTEGER   NCOLS, NROWS, I, J
      INTEGER   LIN, LOUT, IERR
      LOGICAL BLANKS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      DO 200 J = 1, NROWS
         CALL MAPIO ('READ', LIN, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 100 I = 1, NCOLS
            IF (RBUF(I).EQ.FBLANK) THEN
               BLANKS = .TRUE.
               RBUF(I) = BLKVAL
            ELSE
               FAC = C(3) * RBUF(I) + C(4)
               IF (FAC.GT.0.0) THEN
                  RBUF(I) = C(1) + C(2) * LOG(FAC)
                  DMIN = MIN (DMIN, RBUF(I))
                  DMAX = MAX (DMAX, RBUF(I))
               ELSE
                  RBUF(I) = BLKVAL
                  END IF
               END IF
 100        CONTINUE
         CALL MAPIO ('WRIT', LOUT, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('NLOGAR: COULD NOT READ LINE # ', I4, ' IERR=', I3)
 2000 FORMAT ('NLOGAR: COULD NOT WRITE LINE # ', I4, ' IERR=', I3)
      END
      SUBROUTINE ALOGAR (NROWS, NCOLS, LIN, LOUT, C, BLKVAL,
     *   RBUF, DMIN, DMAX, BLANKS, IERR)
C-----------------------------------------------------------------------
C     Take ANTI-LOGARITHM (base 10) of image
C         OUT = C(1) + C(2) * EXP(C(3) * IN + C(4))
C     Input:
C       NROWS       I            Number of rows in output image
C       NCOLS       I            Number of columns in output image
C       LIN         I            LUN of input image
C       LOUT        I            LUN of output image
C       C           R            Scale and offset factors
C       BLKVAL      R            Value for undefined pixels
C     Input/output:
C       RBUF        R            Data buffer
C       DMIN,DMAX   R            Min and max in image
C       BLANKS      L            .true. if MAGIC blank in output image
C       IERR        I            0 => OK
C-----------------------------------------------------------------------
      REAL   RBUF(*), DMIN, DMAX,  C(*), BLKVAL
      INTEGER   NCOLS, NROWS, I, J
      INTEGER   LIN, LOUT, IERR
      LOGICAL BLANKS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      DO 200 J = 1, NROWS
         CALL MAPIO ('READ', LIN, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 100 I = 1, NCOLS
            IF (RBUF(I).EQ.FBLANK) THEN
               BLANKS = .TRUE.
               RBUF(I) = BLKVAL
            ELSE
               RBUF(I) = C(1) + C(2) * 10**(C(3) * RBUF(I) + C(4))
               DMIN = MIN (DMIN, RBUF(I))
               DMAX = MAX (DMAX, RBUF(I))
               END IF
 100        CONTINUE
         CALL MAPIO ('WRIT', LOUT, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ALOGAR: COULD NOT READ LINE # ', I4, ' IERR=', I3)
 2000 FORMAT ('ALOGAR: COULD NOT WRITE LINE # ', I4, ' IERR=', I3)
      END
      SUBROUTINE EXPONE (NROWS, NCOLS, LIN, LOUT, C, BLKVAL,
     *   RBUF, DMIN, DMAX, BLANKS, IERR)
C-----------------------------------------------------------------------
C     Take ANTI-LOGARITHM (natural-base e) of image
C        OUT = C(1) + C(2) * EXP(C(3) * IN + C(4))
C     Input:
C       NROWS       I            Number of rows in output image
C       NCOLS       I            Number of columns in output image
C       LIN         I            LUN of input image
C       LOUT        I            LUN of output image
C       C           R            Scale and offset factors
C       BLKVAL      R            Value for undefined pixels
C     Input/output:
C       RBUF        R            Data buffer
C       DMIN,DMAX   R            Min and max in image
C       BLANKS      L            .true. if MAGIC blank in output image
C       IERR        I            0 => OK
C-----------------------------------------------------------------------
      REAL   RBUF(*), DMIN, DMAX,  C(*), BLKVAL
      INTEGER   NCOLS, NROWS, I, J
      INTEGER   LIN, LOUT, IERR
      LOGICAL BLANKS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      DO 200 J = 1, NROWS
         CALL MAPIO ('READ', LIN, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 100 I = 1, NCOLS
            IF (RBUF(I).EQ.FBLANK) THEN
               BLANKS = .TRUE.
               RBUF(I) = BLKVAL
            ELSE
               RBUF(I) = C(1) + C(2) * EXP(C(3) * RBUF(I) + C(4))
               DMIN = MIN (DMIN, RBUF(I))
               DMAX = MAX (DMAX, RBUF(I))
               END IF
 100        CONTINUE
         CALL MAPIO ('WRIT', LOUT, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('EXPONE: COULD NOT READ LINE # ', I4, ' IERR=', I3)
 2000 FORMAT ('EXPONE: COULD NOT WRITE LINE # ', I4, ' IERR=', I3)
      END
      SUBROUTINE POLYNO (NROWS, NCOLS, LIN, LOUT, C, BLKVAL,
     *   RBUF, DMIN, DMAX, BLANKS, IERR)
C-----------------------------------------------------------------------
C     Form third order polynomial from image
C        OUT = C(1) + C(2)*IN + C(3)*IN**2 + C(4)*IN**3
C     Input:
C       NROWS       I            Number of rows in output image
C       NCOLS       I            Number of columns in output image
C       LIN         I            LUN of input image
C       LOUT        I            LUN of output image
C       C           R            Scale and offset factors
C       BLKVAL      R            Value for undefined pixels
C     Input/output:
C       RBUF        R            Data buffer
C       DMIN,DMAX   R            Min and max in image
C       BLANKS      L            .true. if MAGIC blank in output image
C       IERR        I            0 => OK
C-----------------------------------------------------------------------
      REAL   RBUF(*), DMIN, DMAX,  C(*), D, DSQ, DCUB, BLKVAL
      INTEGER   NCOLS, NROWS, I, J
      INTEGER   LIN, LOUT, IERR
      LOGICAL BLANKS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      DO 200 J = 1, NROWS
         CALL MAPIO ('READ', LIN, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 100 I = 1, NCOLS
            IF (RBUF(I).EQ.FBLANK) THEN
               BLANKS = .TRUE.
               RBUF(I) = BLKVAL
            ELSE
               D = RBUF(I)
               DSQ = RBUF(I) * RBUF(I)
               DCUB = DSQ * D
               RBUF(I) = C(1) + C(2)*D + C(3)*DSQ + C(4)*DCUB
               DMIN = MIN (DMIN, RBUF(I))
               DMAX = MAX (DMAX, RBUF(I))
               END IF
 100        CONTINUE
         CALL MAPIO ('WRIT', LOUT, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('POLYNO: COULD NOT READ LINE # ', I4, ' IERR=', I3)
 2000 FORMAT ('POLYNO: COULD NOT WRITE LINE # ', I4, ' IERR=', I3)
      END
      SUBROUTINE DIVPOL (NROWS, NCOLS, LIN, LOUT, C, BLKVAL,
     *   RBUF, DMIN, DMAX, BLANKS, IERR)
C-----------------------------------------------------------------------
C     Form third order polynomial from inverse of image
C        OUT = C(1) + C(2)/IN + C(3)/IN**2 + C(4)/IN**3
C     Input:
C       NROWS       I            Number of rows in output image
C       NCOLS       I            Number of columns in output image
C       LIN         I            LUN of input image
C       LOUT        I            LUN of output image
C       C           R            Scale and offset factors
C       BLKVAL      R            Value for undefined pixels
C     Input/output:
C       RBUF        R            Data buffer
C       DMIN,DMAX   R            Min and max in image
C       BLANKS      L            .true. if MAGIC blank in output image
C       IERR        I            0 => OK
C-----------------------------------------------------------------------
      REAL   RBUF(*), DMIN, DMAX,  C(*), D, DSQ, DCUB, BLKVAL
      INTEGER   NCOLS, NROWS, I, J
      INTEGER   LIN, LOUT, IERR
      LOGICAL BLANKS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      DO 200 J = 1, NROWS
         CALL MAPIO ('READ', LIN, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 100 I = 1, NCOLS
            IF ((RBUF(I).EQ.FBLANK) .OR. (RBUF(I).EQ.0.0)) THEN
               BLANKS = .TRUE.
               RBUF(I) = BLKVAL
            ELSE
               D = RBUF(I)
               DSQ = RBUF(I) * RBUF(I)
               DCUB = DSQ * D
               RBUF(I) = C(1) + C(2)/D
               IF (C(3).NE.0.0) RBUF(I) = RBUF(I) + C(3)/DSQ
               IF (C(4).NE.0.0) RBUF(I) = RBUF(I) + C(4)/DCUB
               DMIN = MIN (DMIN, RBUF(I))
               DMAX = MAX (DMAX, RBUF(I))
               END IF
 100        CONTINUE
         CALL MAPIO ('WRIT', LOUT, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('POLYNO: COULD NOT READ LINE # ', I4, ' IERR=', I3)
 2000 FORMAT ('POLYNO: COULD NOT WRITE LINE # ', I4, ' IERR=', I3)
      END
      SUBROUTINE POWER (NROWS, NCOLS, LIN, LOUT, C, BLKVAL,
     *   RBUF, DMIN, DMAX, BLANKS, IERR)
C-----------------------------------------------------------------------
C     Raise image to specified power
C        OUT = C(1) + C(2)*[C(3) * IN + C(4)]**C(5)
C     Note: if c(5) = 2.0 exactly, and the function in square brackets
C           is negative, then a special case is trapped and the
C           usual undefined exponentiation is avoided. square
C
C     Input:
C       NROWS       I            Number of rows in output image
C       NCOLS       I            Number of columns in output image
C       LIN         I            LUN of input image
C       LOUT        I            LUN of output image
C       C           R            Scale and offset factors
C       BLKVAL      R            Value for undefined pixels
C     Input/output:
C       RBUF        R            Data buffer
C       DMIN,DMAX   R            Min and max in image
C       BLANKS      L            .true. if MAGIC blank in output image
C       IERR        I            0 => OK
C-----------------------------------------------------------------------
      REAL   RBUF(*), DMIN, DMAX,  C(*), FAC, BLKVAL
      INTEGER   NCOLS, NROWS, I, J, I5, IROUND
      INTEGER   LIN, LOUT, IERR
      LOGICAL   BLANKS, POWOK
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      I5 = IROUND (C(5))
      POWOK = ABS(I5-C(5)).LT.0.0001
      DO 200 J = 1, NROWS
         CALL MAPIO ('READ', LIN, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 100 I = 1, NCOLS
            IF (RBUF(I).EQ.FBLANK) THEN
               BLANKS = .TRUE.
               RBUF(I) = BLKVAL
            ELSE
               FAC = C(3) * RBUF(I) + C(4)
               IF ((POWOK) .AND. (FAC.NE.0.0)) THEN
                  RBUF(I) = C(1) + C(2) * FAC**I5
                  DMIN = MIN (DMIN, RBUF(I))
                  DMAX = MAX (DMAX, RBUF(I))
               ELSE IF ((FAC.LT.0.0) .OR. (FAC.EQ.0.0.AND.C(5).EQ.0.0))
     *            THEN
                  RBUF(I) = BLKVAL
                  BLANKS = .TRUE.
               ELSE
                  RBUF(I) = C(1) + C(2) * FAC**C(5)
                  DMIN = MIN (DMIN, RBUF(I))
                  DMAX = MAX (DMAX, RBUF(I))
                  END IF
               END IF
 100        CONTINUE
         CALL MAPIO ('WRIT', LOUT, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('POWER: COULD NOT READ LINE # ', I4, ' IERR=', I3)
 2000 FORMAT ('POWER: COULD NOT WRITE LINE # ', I4, ' IERR=', I3)
      END
      SUBROUTINE MODUL (NROWS, NCOLS, LIN, LOUT, C, BLKVAL,
     *   RBUF, DMIN, DMAX, BLANKS, IERR)
C-----------------------------------------------------------------------
C     Find remainder of image with MOD function
C        OUT = C(1) + C(2) * MOD[C(3) * IN + C(4), C(5)]
C     Input:
C       NROWS       I            Number of rows in output image
C       NCOLS       I            Number of columns in output image
C       LIN         I            LUN of input image
C       LOUT        I            LUN of output image
C       C           R            Scale and offset factors
C       BLKVAL      R            Value for undefined pixels
C     Input/output:
C       RBUF        R            Data buffer
C       DMIN,DMAX   R            Min and max in image
C       BLANKS      L            .true. if MAGIC blank in output image
C       IERR        I            0 => OK
C-----------------------------------------------------------------------
      REAL   RBUF(*), DMIN, DMAX,  C(*), FAC, BLKVAL
      INTEGER   NCOLS, NROWS, I, J
      INTEGER   LIN, LOUT, IERR
      LOGICAL BLANKS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      DO 200 J = 1, NROWS
         CALL MAPIO ('READ', LIN, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 100 I = 1, NCOLS
            IF (RBUF(I).EQ.FBLANK) THEN
               BLANKS = .TRUE.
               RBUF(I) = BLKVAL
            ELSE
               FAC = C(3) * RBUF(I) + C(4)
               IF (C(5).NE.0.0) THEN
                  RBUF(I) = C(1) + C(2) * MOD (FAC, C(5))
                  DMIN = MIN (DMIN, RBUF(I))
                  DMAX = MAX (DMAX, RBUF(I))
               ELSE
                  RBUF(I) = BLKVAL
                  BLANKS = .TRUE.
                  END IF
               END IF
 100        CONTINUE
         CALL MAPIO ('WRIT', LOUT, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MODUL: COULD NOT READ LINE # ', I4, ' IERR=', I3)
 2000 FORMAT ('MODUL: COULD NOT WRITE LINE # ', I4, ' IERR=', I3)
      END
      SUBROUTINE ABSOL (NROWS, NCOLS, LIN, LOUT, C, BLKVAL,
     *   RBUF, DMIN, DMAX, BLANKS, IERR)
C-----------------------------------------------------------------------
C     Find remainder of image with ABS function
C        OUT = C(1) + C(2) * ABS[C(3) * IN + C(4)]
C     Input:
C       NROWS       I            Number of rows in output image
C       NCOLS       I            Number of columns in output image
C       LIN         I            LUN of input image
C       LOUT        I            LUN of output image
C       C           R            Scale and offset factors
C       BLKVAL      R            Value for undefined pixels
C     Input/output:
C       RBUF        R            Data buffer
C       DMIN,DMAX   R            Min and max in image
C       BLANKS      L            .true. if MAGIC blank in output image
C       IERR        I            0 => OK
C-----------------------------------------------------------------------
      REAL   RBUF(*), DMIN, DMAX,  C(*), FAC, BLKVAL
      INTEGER   NCOLS, NROWS, I, J
      INTEGER   LIN, LOUT, IERR
      LOGICAL BLANKS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       default is simple OUT = ABS[IN]
      IF (ABS(C(1)+C(2)+C(3)+C(4)) .LE. 0.0001) THEN
         C(1) = 0
         C(2) = 1
         C(3) = 1
         C(4) = 0
         END IF
      DO 200 J = 1, NROWS
         CALL MAPIO ('READ', LIN, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 100 I = 1, NCOLS
            IF (RBUF(I).EQ.FBLANK) THEN
               BLANKS = .TRUE.
               RBUF(I) = BLKVAL
            ELSE
               FAC = C(3) * RBUF(I) + C(4)
               RBUF(I) = C(1) + C(2) * ABS (FAC)
               DMIN = MIN (DMIN, RBUF(I))
               DMAX = MAX (DMAX, RBUF(I))
               END IF
 100        CONTINUE
         CALL MAPIO ('WRIT', LOUT, RBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000) J, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ABSOL: COULD NOT READ LINE # ', I4, ' IERR=', I3)
 2000 FORMAT ('ABSOL: COULD NOT WRITE LINE # ', I4, ' IERR=', I3)
      END
      SUBROUTINE MATHHI (INNAM, OUTNAM, INSL, OUTSL, INVOL, OUTVOL,
     *   BLC, TRC, OPCODE, CPARM, LIST, IERR)
C-----------------------------------------------------------------------
C    MATHHI writes the history file for the task MATHS
C
C    Inputs:
C        INNAM            C*36 Input map namestring
C        OUTNAM           C*36  Output map namestring
C        INSL             I     Slot number for input map
C        OUTSL            I     Slot number for output map
C        INVOL            I     Input image volume number
C        OUTVOL           I     Output image volume number
C        BLC,TRC          I     Input image window
C        OPCODE           C*4   MATHS operator
C        CPARM            R     Scale factors
C        LIST(*)          C*4   Allowed OPCODEs
C   Outputs:
C        IERR             I     Error return
C                               0-> okay
C                               1-> no good
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6, INNAM*36, OUTNAM*36, HILINE*72, OPCODE*4,
     *   LIST(*)*4, NAME*12, CLASS*6, TYPE*2, NOTTYP*2
      REAL   CPARM(*)
      INTEGER   BLC(7), TRC(7)
      INTEGER   IERR, NHISTF, LHIN, LHOUT, INSL, OUTSL, INVOL,
     *   OUTVOL, INSEQ, OUTSEQ, IBUFF1(256), IBUFF2(256), USID,
     *   OLDI(256), CATBLK(256)
      LOGICAL   T
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      COMMON /HEADS/ OLDI, CATBLK
      DATA NHISTF, LHIN, LHOUT /2, 27, 28/
      DATA PRGNAM /'MATHS '/
      DATA T /.TRUE./
      DATA NOTTYP /'CC'/
C-----------------------------------------------------------------------
C                                       copy most keywords
      CALL KEYPCP (INVOL, INSL, OUTVOL, OUTSL, 0, ' ', IERR)
C                                       Init HI
      CALL HIINIT (NHISTF)
C                                       Copy old to new
      CALL HISCOP (LHIN, LHOUT, INVOL, OUTVOL, INSL, OUTSL, CATBLK,
     *    IBUFF1, IBUFF2, IERR)
      IF (IERR.GE.3) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 900
      ELSE
         IERR = 0
         END IF
C                                       Add INNAME
      CALL WAWA2A (INNAM, NAME, CLASS, INSEQ, TYPE, INVOL, USID)
      CALL HENCO1 (PRGNAM, NAME, CLASS, INSEQ, INVOL, LHOUT,
     *    IBUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,2000) IERR
         GO TO 900
         END IF
C                                       Add OUTNAME
      CALL WAWA2A (OUTNAM, NAME, CLASS, OUTSEQ, TYPE, OUTVOL, USID)
      CALL HENCOO (PRGNAM, NAME, CLASS, OUTSEQ, OUTVOL, LHOUT,
     *    IBUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,3000) IERR
         GO TO 900
         END IF
C                                       Add window
      WRITE (HILINE,4000) PRGNAM, BLC(1), BLC(2), TRC(1), TRC(2)
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,5000) IERR
         GO TO 900
         END IF
C                                       Add OPCODE
      WRITE (HILINE,6000) PRGNAM, OPCODE
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,7000) IERR
         GO TO 900
         END IF
C                                       Add CPARM's
      IF (OPCODE.EQ.'POWR' .OR. OPCODE.EQ.'MOD') THEN
         WRITE (HILINE,8000) PRGNAM, CPARM(1), CPARM(2),
     *                           CPARM(3), CPARM(4), CPARM(5)
      ELSE
         WRITE (HILINE,8500) PRGNAM, CPARM(1), CPARM(2),
     *                           CPARM(3), CPARM(4)
         END IF
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) THEN
        WRITE (MSGTXT,9000) IERR
        GO TO 900
      END IF
C
      IF (CPARM(6).GT.0.0) THEN
         WRITE (HILINE,9200) PRGNAM, CPARM(6)
      ELSE
         WRITE (HILINE,9300) PRGNAM, CPARM(6)
         END IF
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,9400) IERR
         GO TO 900
         END IF
C                                       Close history file
      CALL HICLOS (LHOUT, T, IBUFF2, IERR)
      IF (IERR.NE.0) WRITE (MSGTXT,9500) IERR
C
900   IF (IERR.NE.0) CALL MSGWRT (8)
C                                        Copy tables
      CALL ALLTAB (1, NOTTYP, LHIN, LHOUT, INVOL, OUTVOL, INSL, OUTSL,
     *   CATBLK, IBUFF1, IBUFF2, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MATHHI: COULD NOT COPY OLD HISTORY FILE TO NEW, IERR=',
     *        I3)
 2000 FORMAT ('MATHHI: COULD NOT WRITE INNAME TO HISTORY FILE, IERR=',
     *        I3)
 3000 FORMAT ('MATHHI: COULD NOT WRITE OUTNAME TO HISTORY FILE, IERR=',
     *        I3)
 4000 FORMAT (A6, 'BLC = ', I4, ',', I4, '   TRC = ', I4, ',', I4)
 5000 FORMAT ('MATHHI: COULD NOT ADD INPUT WINDOW, IERR=', I3)
 6000 FORMAT (A6, 'OPCODE = ''', A4, '''')
 7000 FORMAT ('MATHHI: COULD NOT ADD OPCODE TO HISTORY, IERR=', I3)
 8000 FORMAT (A6, 'CPARM = ', 5(1PE10.3, 1X))
 8500 FORMAT (A6, 'CPARM(1:4) = ', 4(1PE11.4, 1X))
 9000 FORMAT ('MATHHI: COULD NOT ADD CPARMS(1:5) TO HISTORY, IERR=', I3)
 9200 FORMAT (A6, 'CPARM(6) = ', 1PE11.4, '/ Undefined pixels zeroed')
 9300 FORMAT (A6, 'CPARM(6) = ', 1PE11.4,
     *        '/ Undefined pixels magic blanked')
 9400 FORMAT ('MATHHI: COULD NOT ADD CPARM(6) TO HISTORY, IERR=', I3)
 9500 FORMAT ('MATHHI: COULD NOT CLOSE HISTORY FILE, IERR=', I3)
      END

      SUBROUTINE MDISK (OP, LUN, FIND, BUFF, BIND, IERR)
C-----------------------------------------------------------------------
C! reads or writes a row from an image
C# Map-util IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MDISK reads or writes a row of an image.  MDISK is called only after
C   a call to MINIT and you should read the precursor remarks of MINIT.
C   MDISK actually sets an array index (BIND) to the start of the next
C   line wanted.  Actual IO is done only when needed and a row is
C   written not on "its" call to MDISK but on some subsequent call (or
C   the FINI call.  NOTE: the line sequence is set by the WIN parameter
C   in the MINIT call.
C   Inputs:
C      OP    C*4   Op code 'WRIT', 'READ', 'FINI' (flush write buffers)
C      LUN   I     logical unit number
C      FIND  I     Pointer to FTAB returned by ZOPEN
C   Input and output:
C      BUFF  R(*)  Buffer holding data
C   Output:
C      BIND  I     Pointer to position in buffer of first pixel in
C                  window in the present line
C      IERR  I     Error return: 0 => ok
C                        1 => file not open
C                        2 => input error
C                        3 => I/O error
C                        4 => end of file
C                        5 => beginning of medium
C                        6 => end of medium
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   LUN, FIND, BIND, IERR
      REAL      BUFF(*)
C
      INTEGER   IOP, NBYTE, JBUF, FNX, FXC, FYC, FIBUF, FIXC, FBBLK,
     *   DBUF, IBUF, FUNF, FIBLK, FNBYTE, IWRITE, IREAD, IFINI
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA IWRITE, IREAD, IFINI /1, 2, 4/
C-----------------------------------------------------------------------
C                                       decode OPcode
      IOP = 0
      IF (OP.EQ.'WRIT') IOP = IWRITE
      IF (OP.EQ.'READ') IOP = IREAD
      IF (OP.EQ.'FINI') IOP = IFINI
      IERR = 2
      IF ((IOP.NE.FTAB(FIND+11)) .AND. (IOP.NE.IFINI)) GO TO 999
      IF ((IREAD.EQ.FTAB(FIND+11)) .AND. (IOP.EQ.IFINI)) GO TO 999
C                                       check if file open
      IERR = 1
      IF (FTAB(FIND).NE.LUN) GO TO 999
      IERR = 0
C                                       set pointers to FTAB
      FNX = FIND + 1
      FXC = FIND + 2
      FYC = FIND + 3
      FIBUF  = FIND + 6
      FBBLK  = FIND + 7
      FIBLK  = FIND + 9
      FNBYTE = FIND + 10
      FIXC = FIND + 14
      IBUF   = FTAB(FIBUF)
C                                       which buffer ???
      JBUF = IBUF
      IF (JBUF.LT.0) JBUF = -JBUF
 20   CONTINUE
         DBUF = (JBUF - 1) * ((1+FTAB(FNBYTE))/2)
C                                       FINI: decr XCount, reset YCount
         IF (IOP.EQ.IFINI) THEN
            FTAB(FIXC) = FTAB(FIXC) - 1
            IF (FTAB(FIXC).LE.0) FTAB(FXC) = FTAB(FXC) - 1
            FTAB(FYC) = FTAB(FXC)
C                                       other: stay in buffer?
         ELSE
            IF (FTAB(FXC).LE.FTAB(FNX)) GO TO 200
            END IF
C                                       prepare to read next buffer
C                                       if all lines in, just flip bufs
         IF (FTAB(FYC).GT.0) THEN
            NBYTE = FTAB(FNBYTE)
            FUNF = FTAB(FNX) - FTAB(FYC)
C                                       finish the IO now
            IF (FUNF.GT.0) THEN
               IF (FTAB(FIBLK).GE.0) THEN
                  NBYTE = NBYTE -FUNF* FTAB(FIBLK) * NBPS
C                                       modify to finish backwards cycle
               ELSE
                  NBYTE = NBYTE + FUNF * FTAB(FIBLK) * NBPS
                  DBUF = DBUF - (FUNF*NBPS*FTAB(FIBLK))/2
                  FTAB(FBBLK) = FTAB(FBBLK) - FUNF * FTAB(FIBLK)
                  END IF
               END IF
C                                       do I/O required
            IF (IOP.EQ.IREAD) CALL ZMIO ('READ', LUN, FIND, FTAB(FBBLK),
     *         NBYTE, BUFF(1+DBUF), JBUF, IERR)
            IF ((IOP.EQ.IWRITE) .OR. (IOP.EQ.IFINI)) CALL ZMIO ('WRIT',
     *         LUN, FIND, FTAB(FBBLK), NBYTE, BUFF(1+DBUF), JBUF, IERR)
            IF (IERR.NE.0) GO TO 999
            FTAB(FIND+12) = FTAB(FIND+12) + JBUF
C                                       if FINI, don't flip buffer
            IF (IOP.EQ.IFINI) GO TO 140
C                                       update begin block & Y counters
            FTAB(FBBLK) = FTAB(FBBLK) + FTAB(FNX) * FTAB(FIBLK)
            FTAB(FYC) = FTAB(FYC) - FTAB(FNX)
            END IF
C                                       single buffering?
         IF (IBUF.LE.0) THEN
            JBUF = 1
C                                       if double, flip buffer
         ELSE
            JBUF = 3 - IBUF
            FTAB(FIBUF) = JBUF
            END IF
 140     CALL ZWAIT (LUN, FIND, JBUF, IERR)
         IF (IERR.NE.0) GO TO 999
         FTAB(FIND+12) = FTAB(FIND+12) - JBUF
         IF (IOP.EQ.IFINI) THEN
            JBUF = FTAB(FIND+12)
            IF ((JBUF.EQ.1) .OR. (JBUF.EQ.2)) CALL ZWAIT (LUN, FIND,
     *         JBUF, IERR)
            FTAB(FIND+12) = FTAB(FIND+12) - JBUF
            GO TO 999
         ELSE
            FTAB(FXC) = 1
            GO TO 20
            END IF
C                                       return pointer
 200  BIND = DBUF + FTAB(FIND+4) + (FTAB(FXC) - 1)*FTAB(FIND+5) +
     *   (FTAB(FIXC) - 1)*FTAB(FIND+15)
C                                       advance row counter
      IF (FTAB(FIXC).LT.FTAB(FIND+13)) THEN
         FTAB(FIXC) = FTAB(FIXC) + 1
      ELSE
         FTAB(FIXC) = 1
         FTAB(FXC) = FTAB(FXC) + 1
         END IF
C
 999  RETURN
      END

      SUBROUTINE AU5B (BRANCH)
C-----------------------------------------------------------------------
C! verbs to anotate TV images
C# POPS-appl TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2000, 2002-2006, 2008, 2010-2015,
C;  Copyright (C) 2019-2021, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BRANCH = 1 does Verb TVLABEL (for MAps).
C            2           TVWLABEL (for WEdges).
C            3           TVANOT  (extra string on TV)
C            4           TVLINE  (draw line on TV graphics or grey ch)
C            5           TVSTAR  (plot stars atop images)
C            6           COSTAR  (plot symbol at coordinate atop image)
C            7           TVILINE (plot line between image pixels)
C            8           IM2TV   (return TVXY for PIXXY)
C            9           TVLAYOUT (overlay antenna layout pattern)
C   Draw axis and label on image on the the TV display device.
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      CHARACTER IMTYPE*2, CTEST*2, PRGNAM*6, STRING*64, CDUM*1,
     *   INFILE*48
      REAL      RPOS(2), RDUM(2), BLC(2), TRC(2), XCOORD(6), AX(5),
     *   AY(5), STFACT, PIXXY(7)
      INTEGER   IERR, ILAB, INBUF(2560), IPL, IP, JERR, POTERR, IQ, NCH,
     *   IBUT, NXC, NYC, IX0, IY0, I, ITRIM, J, IX1, IY1, XP(2), YP(2),
     *   IDUM, IROUND, MVER, IVER, IG, MSGSAV, DOZERO, CBCORN
      LOGICAL   UNIQUE, DOGRID, DOBKND, DOVERT
      DOUBLE PRECISION XPOS, YPOS
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DGPH.INC'
      COMMON /AIPSCR/ INBUF
      EQUIVALENCE (XP(1), IX0),    (XP(2), IX1)
      EQUIVALENCE (YP(1), IY0),    (YP(2), IY1)
      DATA PRGNAM /'AU5B '/
C-----------------------------------------------------------------------
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.9)) GO TO 999
      MSGSAV = MSGSUP
      POTERR = 101
      CALL TVOPEN (INBUF, JERR)
      IF (JERR.NE.0) GO TO 980
      GO  TO (100, 100, 300, 400, 500, 600, 700, 800, 900), BRANCH
C-----------------------------------------------------------------------
C                                       TVLABEL
C                                       label image on TV
C-----------------------------------------------------------------------
C                                       Which image? : get cat block
 100  IMTYPE = 'MA'
      LOCNUM = 1
      IF (BRANCH.EQ.2) IMTYPE = 'WE'
      CALL ADVERB ('GRCHAN', 'I', 1, 0, IBUT, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IBUT = MOD (IBUT, 10)
      IF ((IBUT.LE.0) .OR. (IBUT.GT.7)) IBUT = 2
      CALL TVFIND (NGRAY, IMTYPE, IP, UNIQUE, CATBLK, INBUF, IERR)
      IF (IERR.NE.0) GO TO 975
      POTERR = 49
      CALL COPY (256, CATBLK, GPHCAT)
C                                       write axis & labeling to TV.
      CALL H2CHR (2, KHPTYO, CATH(KHPTY), CTEST)
      IF (CTEST.EQ.'ZZ') GO TO 960
C                                       Normal image labels
      CALL ADVERB ('LTYPE', 'I', 1, 0, ILAB, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      ILAB = ABS (ILAB)
      IF (CTEST.NE.'WE') THEN
         I = MOD (ILAB, 100)
         IF ((I.LE.0) .OR. (I.GT.10)) ILAB = (ILAB/100)*100 + 3
         CALL ADVERB ('DOCIRCLE', 'R', 1, 0, IDUM, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 975
         DOGRID = RDUM(1).GT.0.0
C                                       Wedge type image
      ELSE
         DOGRID = .FALSE.
         ILAB = (ILAB/100)*100 + 7
         END IF
      LABTYP(LOCNUM) = 0
      DOZERO = -1
      IF (UNIQUE) DOZERO = 1
      CALL IAXIS1 (INBUF, ILAB, IBUT, DOZERO, DOGRID, IERR)
      IF (IERR.NE.0) GO TO 975
      IF (BRANCH.EQ.1) THEN
         CALL COPY (256, GPHCAT, CATBLK)
         CALL SETLOC (CATBLK(IIDEP), .FALSE.)
         CALL ADVERB ('CBPLOT', 'I', 1, 0, CBCORN, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 975
         DOZERO = 0
         IF (CBCORN.LT.0) DOZERO = -1
         CBCORN = ABS (CBCORN)
         IF (CBCORN.GT.0) CALL ICBPLT (INBUF, CBCORN, IBUT, DOZERO,
     *      IERR)
         IERR = MAX (0, IERR)
         IF (IERR.EQ.10) IERR = 0
         END IF
      IF (IERR.EQ.0) POTERR = 0
      GO TO 975
C-----------------------------------------------------------------------
C                                       TVANOT
C                                       string label on TV
C-----------------------------------------------------------------------
C                                       Do we have a string?
 300  CALL ADVERB ('COMMENT', 'C', 1, 64, IDUM, RDUM, STRING)
      IF (ERRNUM.NE.0) GO TO 975
      NCH = ITRIM (STRING)
      IF (NCH.LE.0) THEN
         POTERR = 13
         MSGTXT = 'STRING EMPTY: SET COMMENT'
         GO TO 970
         END IF
      CALL ADVERB ('DOINVERS', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      DOVERT = RDUM(1).GT.0.0
      IF (DOVERT) THEN
         NXC = CSIZTV(1)
         NYC = NCH * CSIZTV(2)
      ELSE
         NXC = NCH * CSIZTV(1)
         NYC = CSIZTV(2)
         END IF
      CALL ADVERB ('TVCORN', 'R', 2, 0, IDUM, RPOS, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IX0 = RPOS(1) + 0.5
      IY0 = RPOS(2) + 0.5
      IBUT = 0
      POTERR = 49
C                                       Read cursor
 305  IF ((IX0.LE.0) .OR. (IX0+NXC.GT.MAXXTV(1)) .OR. (IY0.LE.0) .OR.
     *   (IY0+NYC.GT.MAXXTV(2))) THEN
         IF (IBUT.GE.8) GO TO 975
         MSGTXT = 'Set cursor to string BLC, then push any button'
         CALL MSGWRT (1)
         CALL TVWHER (IQ, RPOS, IBUT, IERR)
         IF (IERR.NE.0) GO TO 975
         IF ((IX0.LE.0) .OR. (IX0+NXC.GT.MAXXTV(1))) IX0 = RPOS(1) + 0.5
         IF ((IY0.LE.0) .OR. (IY0+NYC.GT.MAXXTV(2))) IY0 = RPOS(2) + 0.5
         GO TO 305
         END IF
C                                       Where to put and do it
      CALL ADVERB ('GRCHAN', 'I', 1, 0, IBUT, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IBUT = MOD (IBUT, 10)
      CALL ADVERB ('GR2CHAN', 'I', 1, 0, IPL, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      CALL ADVERB ('TVCHAN', 'I', 1, 0, IP, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IF ((IBUT.LE.0) .AND. ((IP.LE.0) .OR. (IP.GT.NGRAY))) THEN
         IBUT = 2
         IPL = 8
         END IF
      IQ = 0
      IF (DOVERT) THEN
         IQ = 3
         IY0 = IY0 + (NCH-1)*CSIZTV(2)
         END IF
      CALL YHOLD ('ONNN', IERR)
      IF (IBUT.GT.0) THEN
         IP = IBUT
         DOBKND = (IPL.EQ.8) .OR. (IP.EQ.8)
         IF ((IPL.GT.0) .AND. (IP.GT.0)) THEN
            IPL = MIN (IP, IPL)
         ELSE IF (DOBKND) THEN
            IPL = 2
         ELSE
            IPL = MAX (IP, IPL)
            END IF
C                                       Graphics channels IPL & NGRAPH
         IF (DOBKND) THEN
            CALL IMANOT ('ONNN', IPL, IX0, IY0, IQ, 0, STRING(1:NCH),
     *         INBUF, IERR)
            IF (IERR.NE.0) GO TO 975
            CALL IMANOT ('WRIT', IPL, IX0, IY0, IQ, 0, STRING(1:NCH),
     *         INBUF, IERR)
            IF (IERR.EQ.0) POTERR = 0
         ELSE
            IPL = IPL + NGRAY
            CALL YSLECT ('ONNN', IPL, 0, INBUF, IERR)
            IF (IERR.NE.0) GO TO 975
            CALL IMCHAR (IPL, IX0, IY0, IQ, 0, STRING(1:NCH), INBUF,
     *         IERR)
            IF (IERR.EQ.0) POTERR = 0
            END IF
C                                       Grey plane
      ELSE
         CALL YSLECT ('ONNN', IP, 0, INBUF, IERR)
         IF (IERR.NE.0) GO TO 975
         CALL IMCHAR (IP, IX0, IY0, IQ, 0, STRING(1:NCH), INBUF, IERR)
         IF (IERR.NE.0) GO TO 975
C                                       Image catalog junk
         CALL FILL (256, 0, CATBLK)
         IF (DOVERT) IY0 = IY0 - (NCH-1)*CSIZTV(2)
         CALL RFILL (5, HBLANK, CATH(KHIMN))
         CALL CHR2H (2, 'ZZ', KHPTYO, CATH(KHPTY))
         CATBLK(IICOR  ) = IX0
         CATBLK(IICOR+1) = IY0
         CATBLK(IICOR+2) = IX0 + NXC - 1
         CATBLK(IICOR+3) = IY0 + NYC - 1
         CALL COPY (4, CATBLK(IICOR), CATBLK(IIWIN))
         CATBLK(KIDIM) = 2
         CATBLK(KINAX) = NXC
         CATBLK(KINAX+1) = NYC
         CATR(KRDMX) = 1.0
         CATR(KRDMN) = 0.0
         CATR(IRRAN) = CATR(KRDMN)
         CATR(IRRAN+1) = CATR(KRDMX)
         CALL RCOPY (2, HBLANK, CATH(KHBUN))
         CATR(KRCRP) = (CATBLK(IICOR) + CATBLK(IICOR+2)) / 2.0
         CATD(KDCRV) = (CATR(KRDMX) + CATR(KRDMN)) / 2.0
         CATR(KRCIC) = (CATR(KRDMX) - CATR(KRDMN)) / (CATBLK(IICOR+2) -
     *      CATBLK(IICOR))
         I = 2 * KICTPN
         CALL RFILL (I, HBLANK, CATH(KHCTP))
         CATR(KRCIC+1) = 0.0
         CATR(KRCRP+1) = CATBLK(IICOR+1) - 1
         CATD(KDCRV+1) = 0.0
         CALL YCWRIT (IP, CATBLK(IICOR), CATBLK, INBUF, IERR)
         POTERR = 0
         END IF
      CALL YHOLD ('OFFF', IERR)
      GO TO 975
C-----------------------------------------------------------------------
C                                       TVLINE
C                                       draw line on TV
C-----------------------------------------------------------------------
C                                       Do we have a string?
 400  CALL ADVERB ('GRCHAN', 'I', 1, 0, J, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      J = MOD (J, 10)
      CALL ADVERB ('TVCHAN', 'I', 1, 0, I, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IF ((J.LE.0) .OR. (J.GT.NGRAPH)) J = MIN (2, NGRAPH)
C                                       set channel ID
      IF ((I.GT.0) .AND. (I.LE.NGRAY)) THEN
         NCH = I
      ELSE
         NCH = NGRAY + J
         END IF
      IF ((NCH.LE.0) .OR. (NCH.GT.NGRAY+NGRAPH)) NCH = NGRAY +
     *    MIN (NGRAPH, 2)
C                                       corners
      CALL ADVERB ('TVCORN', 'R', 2, 0, IDUM, RPOS, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IX0 = IROUND (RPOS(1))
      IY0 = IROUND (RPOS(2))
      CALL ADVERB ('TVXY', 'R', 2, 0, IDUM, RPOS, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IX1 = IROUND (RPOS(1))
      IY1 = IROUND (RPOS(2))
      IBUT = 0
      POTERR = 49
      IQ = 0
C                                       Read cursor for point 1
 410  IF ((IX0.GT.0) .AND. (IX0.LE.MAXXTV(1)) .AND. (IY0.GT.0) .AND.
     *   (IY0.LE.MAXXTV(2))) GO TO 420
         IF (IBUT.GE.8) GO TO 975
         WRITE (MSGTXT,1410) 'first'
         CALL MSGWRT (1)
         CALL TVWHER (IQ, RPOS, IBUT, IERR)
         IF (IERR.NE.0) GO TO 975
         IF ((IX0.LE.0) .OR. (IX0.GT.MAXXTV(1))) IX0 = RPOS(1) + 0.5
         IF ((IY0.LE.0) .OR. (IY0.GT.MAXXTV(2))) IY0 = RPOS(2) + 0.5
         GO TO 410
C                                       Read cursor for point 2
 420  IF ((IX1.GT.0) .AND. (IX1.LE.MAXXTV(1)) .AND. (IY1.GT.0) .AND.
     *   (IY1.LE.MAXXTV(2))) GO TO 430
         IF (IBUT.GE.8) GO TO 975
         WRITE (MSGTXT,1410) 'second'
         CALL MSGWRT (1)
         CALL TVWHER (IQ, RPOS, IBUT, IERR)
         IF (IERR.NE.0) GO TO 975
         IF ((IX1.LE.0) .OR. (IX1.GT.MAXXTV(1))) IX1 = RPOS(1) + 0.5
         IF ((IY1.LE.0) .OR. (IY1.GT.MAXXTV(2))) IY1 = RPOS(2) + 0.5
         GO TO 420
C                                       draw line
 430  CALL YHOLD ('ONNN', IERR)
      CALL YSLECT ('ONNN', NCH, 0, INBUF, IERR)
      IF (IERR.EQ.0) CALL IMVECT ('ONNN', NCH, 2, XP, YP, INBUF, IERR)
      IF (IERR.EQ.0) POTERR = 0
      CALL YHOLD ('OFFF', IERR)
      GO TO 975
C-----------------------------------------------------------------------
C                                       TVSTAR
C                                       plot image's stars on TV
C-----------------------------------------------------------------------
C                                       Which image? : get cat block
 500  IMTYPE = 'MA'
      LOCNUM = 1
      CALL TVFIND (NGRAY, IMTYPE, IP, UNIQUE, CATBLK, INBUF, IERR)
      IF (IERR.NE.0) GO TO 975
C                                       test type
      CALL H2CHR (2, KHPTYO, CATH(KHPTY), CTEST)
      IF (CTEST.NE.'MA') THEN
         POTERR = 101
         MSGTXT = 'TVSTAR WORKS ON IMAGES ONLY, NOT ' // CTEST
         GO TO 970
         END IF
C                                       set Graphics common
      CALL COPY (256, CATBLK, GPHCAT)
      GPHIX0 = GPHCAT(IICOR)
      GPHIY0 = GPHCAT(IICOR+1)
      GPHSCX = GPHCAT(IICOR+2) - GPHIX0
      GPHSCY = GPHCAT(IICOR+3) - GPHIY0
      GPHIX1 = GPHCAT(IIWIN)
      GPHIY1 = GPHCAT(IIWIN+1)
      GPHIX2 = GPHCAT(IIWIN+2)
      GPHIY2 = GPHCAT(IIWIN+3)
      GPHX1 = GPHIX1
      GPHX2 = GPHIX2
      GPHY1 = GPHIY1
      GPHY2 = GPHIY2
      GPHDOT = .TRUE.
      GPHDOD = .FALSE.
      GPHLTY = 1
      BLC(1) = GPHX1
      BLC(2) = GPHY1
      TRC(1) = GPHX2
      TRC(2) = GPHY2
C                                       get actual image header
      MSGSUP = 32000
      CALL CATIO ('READ', GPHCAT(IIVOL), GPHCAT(IICNO), CATBLK, 'REST',
     *   INBUF, IERR)
      MSGSUP = MSGSAV
      IF (IERR.NE.0) THEN
         POTERR = 33
         WRITE (MSGTXT,1500) IERR
         GO TO 970
         END IF
C                                       check: do conversions
C                                       like TVLOD/TVFIND
      CALL CATN2L ('L2N', CATBLK, INBUF)
      CALL CATN2L ('N2L', INBUF, CATBLK)
      DO 510 I = 1,112
         IF (GPHCAT(I).NE.CATBLK(I)) THEN
            POTERR = 33
            WRITE (MSGTXT,1505) I
            GO TO 970
            END IF
 510     CONTINUE
C                                       get adverbs
      CALL ADVERB ('INVERS', 'I', 1, 0, IVER, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      CALL ADVERB ('GRCHAN', 'I', 1, 0, IG, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IG = MOD (IG, 10)
      CALL ADVERB ('STFACTOR', 'R', 1, 0, IDUM, RDUM, CDUM)
      STFACT = RDUM(1)
      IF (ERRNUM.NE.0) GO TO 975
      IF (STFACT.EQ.0.0) STFACT = 1.0
      IF ((IG.LT.1) .OR. (IG.GT.NGRAPH)) IG = MIN (2, NGRAPH)
      CALL FNDEXT ('ST', CATBLK, MVER)
      IF (MVER.LE.0) THEN
         POTERR = 33
         MSGTXT = 'IMAGE MUST HAVE AN ST FILE'
         GO TO 970
         END IF
      IF ((IVER.LT.1) .OR. (IVER.GT.MVER)) IVER = MVER
      GPHTVG(1) = IG + NGRAY
      CALL YSLECT ('ONNN', GPHTVG(1), 0, INBUF, IERR)
      POTERR = 49
      IF (IERR.NE.0) GO TO 975
C                                       plot the things
      CALL SETLOC (GPHCAT(IIDEP), .FALSE.)
      CALL YHOLD ('ONNN', IERR)
      CALL STARPL (STFACT, GPHCAT(IIVOL), GPHCAT(IICNO), IVER, BLC, TRC,
     *   0, 0, GPHCAT, BLC, LOCNUM, INBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1510) IERR
         GO TO 970
      ELSE
         CALL YHOLD ('OFFF', IERR)
         POTERR = 0
         GO TO 975
         END IF
C-----------------------------------------------------------------------
C                                       COSTAR
C                                       plot cordinate pos on image
C-----------------------------------------------------------------------
C                                       Which image? : get cat block
 600  IMTYPE = 'MA'
      LOCNUM = 1
      CALL TVFIND (NGRAY, IMTYPE, IP, UNIQUE, CATBLK, INBUF, IERR)
      IF (IERR.NE.0) GO TO 975
C                                       test type
      CALL H2CHR (2, KHPTYO, CATH(KHPTY), CTEST)
      IF (CTEST.NE.'MA') THEN
         POTERR = 101
         MSGTXT = 'COSTAR WORKS ON IMAGES ONLY, NOT ' // CTEST
         GO TO 970
         END IF
C                                       set Graphics common
      CALL COPY (256, CATBLK, GPHCAT)
      GPHIX0 = GPHCAT(IICOR)
      GPHIY0 = GPHCAT(IICOR+1)
      GPHSCX = GPHCAT(IICOR+2) - GPHIX0
      GPHSCY = GPHCAT(IICOR+3) - GPHIY0
      GPHIX1 = GPHCAT(IIWIN)
      GPHIY1 = GPHCAT(IIWIN+1)
      GPHIX2 = GPHCAT(IIWIN+2)
      GPHIY2 = GPHCAT(IIWIN+3)
      GPHX1 = GPHIX1
      GPHX2 = GPHIX2
      GPHY1 = GPHIY1
      GPHY2 = GPHIY2
      GPHDOT = .TRUE.
      GPHDOD = .FALSE.
      GPHLTY = 1
      BLC(1) = GPHX1
      BLC(2) = GPHY1
      TRC(1) = GPHX2
      TRC(2) = GPHY2
C                                       get adverbs
      CALL ADVERB ('SYMBOL', 'I', 1, 0, NCH, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      NCH = MAX (1, MIN (23, NCH))
      CALL ADVERB ('COORDINA', 'R', 6, 0, IG, XCOORD, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      CALL ADVERB ('GRCHAN', 'I', 1, 0, IG, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IG = MOD (IG, 10)
      IF ((IG.LT.1) .OR. (IG.GT.NGRAPH)) IG = MIN (2, NGRAPH)
      CALL ADVERB ('STFACTOR', 'R', 1, 0, IDUM, RDUM, CDUM)
      STFACT = RDUM(1)
      IF (ERRNUM.NE.0) GO TO 975
      IF (STFACT.EQ.0.0) STFACT = 1.0
      STFACT = ABS (STFACT)
C                                       on graphics
      GPHTVG(1) = IG + NGRAY
      CALL YHOLD ('ONNN', IERR)
      CALL YSLECT ('ONNN', GPHTVG(1), 0, INBUF, IERR)
      POTERR = 49
      IF (IERR.NE.0) GO TO 975
C                                       do coordinates
      CALL SETLOC (GPHCAT(IIDEP), .FALSE.)
      UNIQUE = (XCOORD(1).LT.0.0) .OR. (XCOORD(2).LT.0.0) .OR.
     *   (XCOORD(3).LT.0.0)
      XPOS = ABS (XCOORD(1)) + ABS (XCOORD(2))/60.0D0 +
     *   ABS (XCOORD(3))/3600.0D0
      IF (UNIQUE) XPOS = -XPOS
      IF ((CTYP(1,LOCNUM)(:4).EQ.'RA  ') .OR.
     *   (CTYP(1,LOCNUM)(:4).EQ.'RA--')) XPOS = XPOS * 15.0D0
      UNIQUE = (XCOORD(4).LT.0.0) .OR. (XCOORD(5).LT.0.0) .OR.
     *   (XCOORD(6).LT.0.0)
      YPOS = ABS(XCOORD(4)) + ABS(XCOORD(5))/60.0D0 +
     *   ABS(XCOORD(6))/3600.0D0
      IF (UNIQUE) YPOS = -YPOS
      IF ((CTYP(2,LOCNUM)(:4).EQ.'RA  ') .OR.
     *   (CTYP(2,LOCNUM)(:4).EQ.'RA--')) YPOS = YPOS * 15.0D0
C                                       Calc center of star pos
      CALL XYPIX (XPOS, YPOS, AX(1), AY(1), IERR)
C                                       If star not in plot, boo boo
      IF ((BLC(1).GT.AX(1)) .OR. (BLC(2).GT.AY(1)) .OR.
     *   (TRC(1).LT.AX(1)) .OR. (TRC(2).LT.AY(1))) IERR = 1
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1600) AX(1), AY(1)
         GO TO 970
         END IF
      AX(2) = AX(1)
      AX(3) = AX(1)
      AX(4) = AX(1) - 2.0 * STFACT
      AX(5) = AX(1) + 2.0 * STFACT
      AY(2) = AY(1) + 2.0 * STFACT
      AY(3) = AY(1) - 2.0 * STFACT
      AY(4) = AY(1)
      AY(5) = AY(1)
      CALL PNTPLT (NCH, AX, AY, BLC, TRC, .FALSE., .FALSE., INBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1510) IERR
         GO TO 970
      ELSE
         CALL YHOLD ('OFFF', IERR)
         POTERR = 0
         GO TO 975
         END IF
C-----------------------------------------------------------------------
C                                       TVILINE
C                                       plot line between pixels
C-----------------------------------------------------------------------
C                                       Which image? : get cat block
 700  IMTYPE = 'MA'
      LOCNUM = 1
      CALL TVFIND (NGRAY, IMTYPE, IP, UNIQUE, CATBLK, INBUF, IERR)
      IF (IERR.NE.0) GO TO 975
C                                       test type
      CALL H2CHR (2, KHPTYO, CATH(KHPTY), CTEST)
      IF (CTEST.NE.'MA') THEN
         POTERR = 101
         MSGTXT = 'TVILINE WORKS ON IMAGES ONLY, NOT ' // CTEST
         GO TO 970
         END IF
C                                       input adverbs
      CALL ADVERB ('GRCHAN', 'I', 1, 0, J, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      J = MOD (J, 10)
      CALL ADVERB ('TVCHAN', 'I', 1, 0, I, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IF ((J.LE.0) .OR. (J.GT.NGRAPH)) J = MIN (2, NGRAPH)
C                                       set channel ID
      IF ((I.GT.0) .AND. (I.LE.NGRAY)) THEN
         NCH = I
      ELSE
         NCH = NGRAY + J
         END IF
      IF ((NCH.LE.0) .OR. (NCH.GT.NGRAY+NGRAPH)) NCH = NGRAY +
     *    MIN (NGRAPH, 2)
C                                       corners
      CALL ADVERB ('PIXXY', 'R', 7, 0, IDUM, PIXXY, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      RPOS(1) = (CATBLK(IIWIN+2) - CATBLK(IIWIN))
      IF (RPOS(1).NE.0.0) RPOS(1) = (PIXXY(1) - CATBLK(IIWIN)) *
     *  (CATBLK(IICOR+2) - CATBLK(IICOR)) / RPOS(1) + CATBLK(IICOR)
      RPOS(2) = (CATBLK(IIWIN+3) - CATBLK(IIWIN+1))
      IF (RPOS(2).NE.0.0) RPOS(2) = (PIXXY(2) - CATBLK(IIWIN+1)) *
     *  (CATBLK(IICOR+3) - CATBLK(IICOR+1)) / RPOS(2) + CATBLK(IICOR+1)
      IX0 = IROUND (RPOS(1))
      IY0 = IROUND (RPOS(2))
      CALL ADVERB ('PIX2XY', 'R', 7, 0, IDUM, PIXXY, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      RPOS(1) = (CATBLK(IIWIN+2) - CATBLK(IIWIN))
      IF (RPOS(1).NE.0.0) RPOS(1) = (PIXXY(1) - CATBLK(IIWIN)) *
     *  (CATBLK(IICOR+2) - CATBLK(IICOR)) / RPOS(1) + CATBLK(IICOR)
      RPOS(2) = (CATBLK(IIWIN+3) - CATBLK(IIWIN+1))
      IF (RPOS(2).NE.0.0) RPOS(2) = (PIXXY(2) - CATBLK(IIWIN+1)) *
     *  (CATBLK(IICOR+3) - CATBLK(IICOR+1)) / RPOS(2) + CATBLK(IICOR+1)
      IX1 = IROUND (RPOS(1))
      IY1 = IROUND (RPOS(2))
C                                       draw line
      IF ((IX0.GE.1) .AND. (IX0.LE.MAXXTV(1)) .AND. (IX1.GE.1) .AND.
     *   (IX1.LE.MAXXTV(1)) .AND. (IY0.GE.1) .AND. (IY0.LE.MAXXTV(2))
     *   .AND. (IY1.GE.1) .AND. (IY1.LE.MAXXTV(2))) THEN
         CALL YHOLD ('ONNN', IERR)
         CALL YSLECT ('ONNN', NCH, 0, INBUF, IERR)
         IF (IERR.EQ.0) CALL IMVECT ('ONNN', NCH, 2, XP, YP, INBUF,
     *      IERR)
         IF (IERR.EQ.0) POTERR = 0
         CALL YHOLD ('OFFF', IERR)
      ELSE
         WRITE (MSGTXT,1700) IX0, IY0, IX1, IY1
         CALL MSGWRT (7)
         POTERR = 101
         END IF
      GO TO 975
C-----------------------------------------------------------------------
C                                       IM2TV
C                                       plot line between pixels
C-----------------------------------------------------------------------
C                                       Which image? : get cat block
 800  IMTYPE = 'MA'
      LOCNUM = 1
      CALL TVFIND (NGRAY, IMTYPE, IP, UNIQUE, CATBLK, INBUF, IERR)
      IF (IERR.NE.0) GO TO 975
C                                       test type
      CALL H2CHR (2, KHPTYO, CATH(KHPTY), CTEST)
      IF (CTEST.NE.'MA') THEN
         POTERR = 101
         MSGTXT = 'TVILINE WORKS ON IMAGES ONLY, NOT ' // CTEST
         GO TO 970
         END IF
C                                       corner
      CALL ADVERB ('PIXXY', 'R', 7, 0, IDUM, PIXXY, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      RPOS(1) = (CATBLK(IIWIN+2) - CATBLK(IIWIN))
      IF (RPOS(1).NE.0.0) RPOS(1) = (PIXXY(1) - CATBLK(IIWIN)) *
     *  (CATBLK(IICOR+2) - CATBLK(IICOR)) / RPOS(1) + CATBLK(IICOR)
      RPOS(2) = (CATBLK(IIWIN+3) - CATBLK(IIWIN+1))
      IF (RPOS(2).NE.0.0) RPOS(2) = (PIXXY(2) - CATBLK(IIWIN+1)) *
     *  (CATBLK(IICOR+3) - CATBLK(IICOR+1)) / RPOS(2) + CATBLK(IICOR+1)
      POTERR = 0
      CALL ADVRBS ('TVXY', 'R', 2, 0, IDUM, RPOS, CDUM)
      GO TO 975
C-----------------------------------------------------------------------
C                                       TVLAYOUT
C                                       layout image on TV
C-----------------------------------------------------------------------
C                                       Which image? : get cat block
 900  IMTYPE = 'MA'
      LOCNUM = 1
      CALL ADVERB ('GRCHAN', 'I', 1, 0, IBUT, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 975
      IBUT = MOD (IBUT, 10)
      IF ((IBUT.LE.0) .OR. (IBUT.GT.8)) IBUT = 2
      IBUT = IBUT + NGRAY
      CALL TVFIND (NGRAY, IMTYPE, IP, UNIQUE, CATBLK, INBUF, IERR)
      IF (IERR.NE.0) GO TO 975
      CALL ADVERB ('INFILE', 'C', 1, 48, IDUM, RDUM, INFILE)
      IF (ERRNUM.NE.0) GO TO 975
      POTERR = 49
      CALL YSLECT ('ONNN', IBUT, 0, INBUF, IERR)
      CALL LAYOUT (IBUT, INFILE, INBUF, IERR)
      IF (IERR.EQ.0) POTERR = 0
      GO TO 975
C-----------------------------------------------------------------------
C                                       error handling and close
 960  MSGTXT = 'I DO NOT LABEL IMAGES WHICH ARE ALL ZEROES'
 970  CALL MSGWRT (6)
 975  CALL TVCLOS (INBUF, JERR)
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.GT.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1410 FORMAT ('Set cursor to ',A,' end point, push Button A, B, or C')
 1500 FORMAT ('ERROR',I5,' READING IMAGE HEADER FROM MAIN CATALOG')
 1505 FORMAT ('DISK HEADER DOES NOT MATCH IMAGE CATALOG WORD',I4)
 1510 FORMAT ('ERROR',I5,' FROM STARPL, PLOTTING THE STARS')
 1600 FORMAT ('PIXEL',2F10.2,' NOT IN IMAGE')
 1700 FORMAT ('ENDS NOT ON TV:',4I7)
      END

      SUBROUTINE AVGCHN (VIS, NUMPOL, BCHAN, ECHAN, BIF, EIF, CHNSEL,
     *   JNCS, JNCIF, VISOUT)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to average a spectrum in frequency to produce a so-called
C   pseudo-continuum channel. The CHNSEL array is used to specify which
C   channels are required in the average.  It must be okay - it is not
C   checked here.
C   Inputs:
C      VIS      R(*)      Array containing the input visibility data
C                         (Re, Im, Wt) includes only BIF-EIF,
C                         BCHAN-ECHAN
C      NUMPOL   I         Number of polarizations
C      BCHAN    I         Start channel to accept
C      ECHAN    I         Final channel to accept
C      BIF      I         Start IF to accept
C      EIF      I         End IF to accept
C      CHNSEL   I(3,20,*) Array of start,stop,incr channel numbers by IF
C                         channel numbers in this array are absolute
C                         numbers i.e. not relative to BCHAN. BIF
C      JNCS     I         Index for polzn in output array
C      JNCIF    I         Index for IF in output array
C   Output:
C      VISOUT   R(*)      Pseudo-continuum visibility
C-----------------------------------------------------------------------
      INTEGER   NUMPOL, BCHAN, ECHAN, BIF, EIF, CHNSEL(3,20,*),
     *   JNCS, JNCIF
      REAL      VIS(*), VISOUT(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   LOOPS, LOOPIF, LOOPF, INDEX, INP, OUTDEX
      REAL      SUMWT, SUMRE, SUMIM, WT, XNORM, CHWT
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       Select/average
      DO 40 LOOPS = 1,NUMPOL
         DO 30 LOOPIF = BIF,EIF
            SUMWT = 0.0
            SUMRE = 0.0
            SUMIM = 0.0
            INDEX = 1 + (LOOPS-1)*INCS + (LOOPIF-BIF)*INCIF
            OUTDEX = 1 + (LOOPS-1)*JNCS + (LOOPIF-BIF)*JNCIF
            DO 20 LOOPF = BCHAN,ECHAN
               CHWT = 1.0
               CALL WANTCH (CHNSEL(1,1,LOOPIF), LOOPF, CHWT)
               INP = INDEX + (LOOPF-BCHAN)*INCF
               WT = VIS(INP+2)
               IF ((WT.GT.0.0) .AND. (CHWT.GT.0.0)) THEN
                  SUMRE = SUMRE + VIS(INP)*WT
                  SUMIM = SUMIM + VIS(INP+1)*WT
                  SUMWT = SUMWT + WT
                  END IF
 20            CONTINUE
            XNORM = 1.0
            IF (SUMWT.GT.1.0E-10) XNORM = 1.0 / SUMWT
            VISOUT(OUTDEX) = SUMRE * XNORM
            VISOUT(OUTDEX+1) = SUMIM * XNORM
            VISOUT(OUTDEX+2) = SUMWT
 30         CONTINUE
 40      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE QWTSUM (APCORE, IU, IU1, IU2)
C-----------------------------------------------------------------------
C! Does Hermitian corrections & summing for Robust weighting
C# AP-appl Imaging
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Converts the summing arrays to include the Hermitian terms if needed
C   Does the summing for robust weighting - basically a sum over a count
C   array and a dot product of that count array with the weight sum
C   array.  Does one row at a time, depends on rows haveing odd number
C   of points.
C   Inputs:
C      IU       I      Desired row >= 0.  0 is last call.
C      IU1      I      Lowest row number in array
C      IU2      I      Highest row number in array
C   APCORE on input - fixed address in ()
C      (0)      I      NU - number rows in array (# U values)
C      (1)      I      NV - number points in row of array (# V values)
C      (2)      I      MU - U-direction conv. function radius
C      (3)      I      MV - V-direction conv. function radius
C      (4)      I      NCH - Number spectral channels
C      (5)      I      U0 - row number for U = 0
C      (6)      I      V0 - column number of V = 0
C      (7)      I      GRDADD - Address of array for convolved weights
C      (8)      I      CNTADD - Address of array for counting samples
C                               -1 => none
C      (9)      I      FUNADD - Address of conv function array
C      (10)     I      FCTADD - Address of uv factors for channels
C      (11)     I      UVADDR - Address of uv value pair
C      (12)     I      WTADDR - Address of weights - each channel is
C                               separated by 3 words, next vis by LREC
C      (13)     I      SUMADD - Address of summing counters
C      SUMS     R(2)   Summed on readback: # Vis, for avg cell weight
C      UV       R(2)   U and V in cells at channel 1
C      FCT      R(*)   * = NCH - factors to convert U, V to cells at
C                      channel n
C      WTS      R(*)   * = NCH - weights to be convolved
C      FUN      R(*)   * = (MU+1)*(MV+1) convolving function (up-right
C                      quadrant)
C      GRD      R(*)   * = NV * # rows - convolved weight grid
C      CNT      R(*)   * = NV * # rows - count of samples (optional)
C   APCORE - in/out
C      SUMS     R(2)   Summed on readback: # Vis, for avg cell weight
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   IU, IU1, IU2
C
      DOUBLE PRECISION WTS, DTEMP(13)
      INTEGER*8 IC, ONE
      INTEGER   I, NV, NH
      LONGINT   JW, JW2, JC, LTEMP(13)
      EQUIVALENCE (DTEMP, LTEMP)
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (IU.LT.0) GO TO 999
      DO 5 I = 1,13
         DTEMP(I) = APCORE(I+PSAPOF)
 5       CONTINUE
      NV = LTEMP(1)
      JW = LTEMP(7) + NV * (IU - IU1) + PSAPOF
      ONE = 1
C                                       Hermitian
      IF (IU.GE.IU1) THEN
         IF (IU.EQ.0) THEN
            NH = NV / 2
            JW2 = JW + NV - 1
            DO 10 I = 1,NH
               APCORE(JW) = APCORE(JW) + APCORE(JW2)
               APCORE(JW2) = APCORE(JW)
               JW = JW + 1
               JW2 = JW2 - 1
 10            CONTINUE
         ELSE IF (IU.LT.LTEMP(2)) THEN
            JW2 = LTEMP(7) + PSAPOF - NV * (IU + IU1) + NV - 1
            DO 20 I = 1,NV
               APCORE(JW) = APCORE(JW) + APCORE(JW2)
               JW = JW + 1
               JW2 = JW2 - 1
 20           CONTINUE
            END IF
C                                       counting turned on
         IF (LTEMP(8).GT.0) THEN
            JW = LTEMP(7) + NV * (IU - IU1) + PSAPOF - 1
            JC = LTEMP(8) + NV * (IU - IU1) + PSAPOF - 1
            DTEMP(6) = APCORE(LTEMP(13)+PSAPOF)
            IC = LTEMP(6)
            WTS = APCORE(LTEMP(13)+1+PSAPOF)
            DO 30 I = 1,NV
               JW = JW + 1
               JC = JC + 1
               DTEMP(6) = APCORE(JC)
               IC = IC + LTEMP(6)
               WTS = WTS + LTEMP(6) * APCORE(JW)
 30            CONTINUE
            LTEMP(6) = IC
            APCORE(LTEMP(13)+PSAPOF) = DTEMP(6)
            APCORE(LTEMP(13)+1+PSAPOF) = WTS
            END IF
         END IF
C                                       row zero average
      IF ((IU.EQ.0) .AND. (LTEMP(8).GT.0)) THEN
         DTEMP(6) = APCORE(LTEMP(13)+PSAPOF)
         IC = LTEMP(6)
         WTS = APCORE(LTEMP(13)+1+PSAPOF)
         APCORE(LTEMP(13)+1+PSAPOF) = WTS / MAX (ONE, IC)
         END IF
C
 999  RETURN
      END

      SUBROUTINE YSHIFT (OP, SHIFTR, SHIFTG, SHIFTB, VRTRTC, IERR)
C-----------------------------------------------------------------------
C! read/write the shift (bias) registers of the TV (IIS M70, not used)
C# Y2 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YSHIFT reads/writes the TV shift registers - which shift the
C   13-bit output of the adders before entry into the 10-bit OFM
C   Inputs:
C      OP      C*4   'READ' from TV or 'WRIT' to TV
C      VRTRTC  L     T => do on vertical retrace only
C   In/Out:
C      SHIFTR  I     # bits to shift (right) red channel
C      SHIFTG  I     # bits to shift green channel
C      SHIFTB  I     # bits to shift blue channel
C   Output:
C      IERR    I     error code of Z...XF : 0 - ok, 2 - input error
C   TV by communication version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   SHIFTR, SHIFTG, SHIFTB, IERR
      LOGICAL   VRTRTC
C
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      BUFFER(1) = 0
      IF (VRTRTC) BUFFER(1) = 1
      IF (OP.EQ.'WRIT') THEN
         BUFFER(2) = SHIFTR
         BUFFER(3) = SHIFTG
         BUFFER(4) = SHIFTB
         BUFSW = 4
         BUFSR = 0
      ELSE
         BUFSW = 1
         BUFSR = 4
         END IF
      CALL MKYBUF (OP, 'YSHIFT', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
      IF ((IERR.EQ.0) .AND. (OP.NE.'WRIT')) THEN
         CALL UNYBUF (BUFSR, HEADER, BUFFER)
         SHIFTR = BUFFER(2)
         SHIFTG = BUFFER(3)
         SHIFTB = BUFFER(4)
         END IF
C
 999  RETURN
      END

      SUBROUTINE LPSEC (UTC, SECS, DATE)
C-----------------------------------------------------------------------
C! Calculate TAI - UTC
C# Util
C-----------------------------------------------------------------------
C;  Copyright (C) 1997-1998, 2000, 2007, 2010, 2012, 2017
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  Calculate the difference between TAI and UTC in seconds.  Returns
C  a fixed offset of 10 seconds for dates prior to Jan 1 1972 (NB:
C  the Astronomical Almanac states that TAI-UTC should be extrapolated
C  prior to 1972).
C
C  Note that this routine should be updated every time there is a leap
C  second.  Currently includes leap seconds up to July 1 1997.
C
C   Input:
C      UTC    D      UTC as a modified JD (JD-2400000.5)
C
C   Output:
C      SECS   D      TAI-UTC in seconds
C      DATE   C*11   Date of most recent encoded leap second IN
C                    YYYY-MMM-DD format
C-----------------------------------------------------------------------
      DOUBLE PRECISION UTC, SECS
      CHARACTER        DATE*(*)
C
      INTEGER   NUMLP
      PARAMETER (NUMLP = 27)
C                                       Number of leap seconds
C
      DOUBLE PRECISION LEAPS(NUMLP)
      SAVE             LEAPS
C                                       Dates of leap seconds
C
      INTEGER   I
C
C                  1972-07-01, 1973-01-01, 1974-01-01, 1975-01-01,
      DATA LEAPS / 41499.0D0,  41683.0D0,  42048.0D0,  42413.0D0,
C
C                  1976-01-01, 1977-01-01, 1978-01-01, 1979-01-01,
     *             42778.0D0,  43144.0D0,  43509.0D0,  43874.0D0,
C
C                  1980-01-01, 1981-07-01, 1982-07-01, 1983-07-01,
     *             44239.0D0,  44786.0D0,  45151.0D0,  45516.0D0,
C
C                  1985-07-01, 1988-01-01, 1990-01-01, 1991-01-01,
     *             46247.0D0,  47161.0D0,  47892.0D0,  48257.0D0,
C
C                  1992-07-01, 1993-07-01, 1994-07-01, 1996-01-01,
     *             48804.0D0,  49169.0D0,  49534.0D0,  50083.0D0,
C
C                  1997-07-01, 1999-01-01, 2006-01-01, 2009-01-01,
     *             50630.0D0,  51179.0D0,  53736.0D0,  54832.0D0,
C
C                  2012-07-01  2015-07-01  2017-01-01
     *             56109.0D0,  57204.0D0,  57754.0D0 /
C-----------------------------------------------------------------------
      SECS = 10.0D0
      DO 10 I = 1,NUMLP
         IF (UTC.GE.LEAPS(I)) SECS = SECS + 1.0D0
 10      CONTINUE
C
      DATE = '2017-JAN-01'
C
 999  RETURN
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QGRIDA (UV, VIS, WT, L, G, CX, CY, NO2, M, LROW,
     *   CNT, TY)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Grid visibility data.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Vectorizing compiler version (also OK for Scalar).
C   QGRIDA grids visibility data that has been loaded into the AP
C   previously.  If requested, positions are shifted and then
C   a taper is applied to the weights if requested before gridding.
C   when taper is requested and TY=2 or 3 locations VIS-2 and
C   VIS-1 are used for work space. If TY=1 locations VIS+2 and
C   VIS+3 are used.
C   Inputs:
C      UV    I  Base address of U,V vector
C      VIS   I  Base address of visibility
C      WTP   I  Base address of weights
C      L     I  Length of visibility record
C      G     I  Base address of grid
C      CX    I  Base address of row convolving fn. (Y on sky)
C      CY    I  Base address of col. convolving fn. (X on sky)
C               Convolving fns. tabulated every 1/100 cell
C      NO2   I  INT ( (no. cells used on a row)/2 )
C      M     I  Number of rows kept in AP (must be odd)
C      LROW  I  Length of a row (V)
C      CNT   I  Number of visibility points.
C      TY    I  Type of visibility data.
C                      1 = I maps
C                      2 = Q,U maps, or two line maps
C                      3 = V maps
C                If TY is negative then tapering is requested.
C                If CNT is neg, do not shift data.
C   Also expects necessary constants in following AP locations:
C           8 = -SIG(U)**2 (CELLS**2) for taper
C           9 = -SIG(V)**2 (CELLS**2) for taper
C          10 = U scaling to cells
C          11 = V scaling to cells
C          12 = W scaling to cells
C          13 = DXC = -2 * Pi * delta RA (in 1/cells)
C          14 = DYC = -2 * Pi * delta DEC
C          15 = DZC = -2 * Pi * delta Z
C-----------------------------------------------------------------------
      INTEGER   UV, VIS, WT, L, G, CX, CY, NO2, M, LROW,
     *   CNT, TY, UV1, UV2, IWORK1, IWORK2, VIS2, NOSHF,
     *   NOTAP, JCNT, II, IUV, IVIS, IWT, ITY, IABS,
     *   LOOP, JA, JC, IWRK
      REAL      VALUE1, VALUE2, VALUE3, TEMPR1, TEMPI1, TEMPR2, TEMPI2
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                       Set other pointers
      UV1 = UV + 1
      UV2 = UV + 2
C                                       Save values to be changed
      IUV = UV
      IVIS = VIS
      IWT = WT
      JCNT = ABS (CNT)
C                                       Check shift
      NOSHF = CNT
      IF (JCNT.LE.0) GO TO 999
C                                       Scale u,v,w to cells.
      JA = UV + 1
      VALUE1 = APCORE(11)
      VALUE2 = APCORE(12)
      VALUE3 = APCORE(13)
C@DIR IGNORE RECRDEPS(APCORE)
      DO 20 LOOP = 1,JCNT
         APCORE (JA) = APCORE(JA) * VALUE1
         APCORE (JA+1) = APCORE(JA+1) * VALUE2
         APCORE (JA+2) = APCORE(JA+2) * VALUE3
         JA = JA + L
 20      CONTINUE
C                                       Check if tapered and set work
C                                       pointers.
      NOTAP = TY
      ITY = ABS (TY)
C                                       Set addresses of work array
      IF (ITY.EQ.1) IWORK1 = VIS + 2
      IF (ITY.NE.1) IWORK1 = VIS - 2
      IWORK2 = IWORK1 + 1
C                                       Taper
      IF (NOTAP.LE.0) THEN
         JA = UV + 1
         JC = WT + 1
         VALUE1 = APCORE(9)
         VALUE2 = APCORE(10)
C@DIR IGNORE RECRDEPS(APCORE)
         DO 80 LOOP = 1,JCNT
            APCORE(JC) = APCORE(JC) * EXP ((VALUE1 * APCORE(JA) *
     *         APCORE(JA)) + (VALUE2 * APCORE(JA+1) * APCORE(JA+1)))
            JA = JA + L
            JC = JC + L
 80         CONTINUE
C                                       end if taper
         END IF
C                                       Shift position.
      IF (NOSHF.GE.0) THEN
            VALUE1 = APCORE(14)
            VALUE2 = APCORE(15)
            VALUE3 = APCORE(16)
            JA = UV + 1
C                                       put phase in second element
            IWRK = IWORK1 + 2
C@DIR IGNORE RECRDEPS(APCORE)
            DO 150 LOOP = 1,JCNT
C                                       Set phase to shift
               APCORE(IWRK) = APCORE(JA) * VALUE1 +
     *            APCORE(JA+1) * VALUE2 + APCORE(JA+2) * VALUE3
               JA = JA + L
               IWRK = IWRK + L
 150           CONTINUE
C                                       Convert to polar
            CALL QRECT1 (IWORK1, L, IWORK1, L, JCNT)
            JC = VIS + 1
            IWRK = IWORK1 + 1
C@DIR IGNORE RECRDEPS(APCORE)
            DO 160 LOOP = 1,JCNT
C                                       Shift positions
               TEMPR1 = APCORE(IWRK)
               TEMPI1 = APCORE(IWRK+1)
               TEMPR2 = APCORE(JC)
               TEMPI2 = APCORE(JC+1)
               APCORE(JC) = TEMPR1 * TEMPR2 - TEMPI1 * TEMPI2
               APCORE(JC+1) = TEMPR1 * TEMPI2 + TEMPI1 * TEMPR2
               IWRK = IWRK + L
               JC = JC + L
 160           CONTINUE
C                                       end if shift
            END IF
C                                       IPOL (and beam) or VPOL.
      IF (ITY.NE.2) THEN
         DO 250 II = 1,JCNT
            CALL QGRD3 (IUV, IVIS, IWT, G, CX, CY, NO2, M, LROW)
C                                       Update pointers
            IUV = IUV + L
            IVIS = IVIS + L
            IWT = IWT + L
 250        CONTINUE
      ELSE
C                                       Two map gridding. (Q-UPOL-line)
C                                       Shift positions (vis2).
         IF (NOSHF.GE.0) THEN
            VIS2 = VIS + 2
            JC = VIS2 + 1
            IWRK = IWORK1 + 1
C@DIR IGNORE RECRDEPS(APCORE)
            DO 350 LOOP = 1,JCNT
C                                       Shift positions
               TEMPR1 = APCORE(IWRK)
               TEMPI1 = APCORE(IWRK+1)
               TEMPR2 = APCORE(JC)
               TEMPI2 = APCORE(JC+1)
               APCORE(JC) = TEMPR1 * TEMPR2 - TEMPI1 * TEMPI2
               APCORE(JC+1) = TEMPR1 * TEMPI2 + TEMPI1 * TEMPR2
               IWRK = IWRK + L
               JC = JC + L
 350           CONTINUE
C                                       end if shift
            END IF
 400     DO 450 II = 1,JCNT
            CALL QGRD2 (IUV, IVIS, IWT, G, CX, CY, NO2, M, LROW)
C                                       Update pointers.
            IUV = IUV + L
            IVIS = IVIS + L
            IWT = IWT + L
 450        CONTINUE
C                                       end if IPOL or VPOL or Q-UPOL
         END IF
C
 999  RETURN
      END

      SUBROUTINE DSMEAR (IUDISK, IUCNO, CATUV, BUFF, JLUN, FRQSEL,
     *   FINC, LTAPER, NSPECA, DELBIT, NFFTSZ, NETVLB, ITYPTF, TAVGTF,
     *   WDODSM, WARN, NSIZ, NSIZ2, IRET)
C-----------------------------------------------------------------------
C! Read the VLBA delay smearing/segmentation loss parameters in CQ table
C# EXT-appl Calibration UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2006-2007, 2011, 2018
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Read CQ table information for VLBA delay decorrelation corrections
C    Input:
C      IUDISK   I    Disk number of uv-data file
C      IUCNO    I    Catalog number of uv-data file
C      CATUV    I(256)   Catalog header
C      BUFF     I(512)
C      JLUN         I    Logical unit number for table I/O
C      FRQSEL       I    FQ_ID selection
C      FINC         R(*) Channel bandwidth per IF for this FQ_ID
C      NSIZ         I    Dimension of LTAPER, NSPECA, DELBIT, NFFTSZ,
C                        ITYPTF, TAVGTF.
C      NSIZ2        I    Dimension of WARN
C    Output: (all indexed on IF and subarray)
C      LTAPER       C(*) Taper function (eg. 'HANNING')
C      NSPECA       R(*) Spectral averaging factor
C      DELBIT       D(*) Time interval per bit in FFT (s)
C      NFFTSZ       I(*) FFT size
C      ITYPTF       I(*) Time filter type (0=>boxcar; 3=>32-4;
C                        4=>64-8)
C      TAVGTF       R(*) Time filter averaging time (sec)
C      WDODSM       L(*) VLBA delay decor. correction enabled ?
C            (indexed on subarray only)
C      NETVLB       I(*) Subarray correlator type (1=VLBA;
C                        else non-VLBA)
C      WARN         L(*) Print warning message about missing CQ
C                        information for this (IF,subarray)
C    Output:
C      IRET         I    Return code (0=> ok)
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IUDISK, IUCNO, CATUV(256), JLUN, FRQSEL, NSIZ, NSIZ2,
     *   IRET
      LOGICAL   WDODSM(NSIZ), WARN(NSIZ2)
      CHARACTER LTAPER(NSIZ)*8
      DOUBLE PRECISION DELBIT(NSIZ)
      REAL      FINC(MAXIF), NSPECA(NSIZ), TAVGTF(NSIZ)
      INTEGER   BUFF(512), NFFTSZ(NSIZ), ITYPTF(NSIZ), NETVLB(NSIZ2)
C
      INCLUDE 'INCS:PCQV.INC'
      CHARACTER LTAB*2, LANAME*8, LTAPCQ(MAXIF)*8, LKEY*8, RDATE*8
      DOUBLE PRECISION DFRQCQ(MAXIF), DCBWCQ(MAXIF), DFACT
      REAL      TAVGCQ(MAXIF), JFACT
      INTEGER   NSUBA, I, MSGSAV, IVER, NKEY, NREC, NCOL, DATP(128,2),
     *   IERR, JKLOCS, KEYVAL(2), KEYTYP, IPOINT, ICQRNO, IDATE(3),
     *   CQKOLS(MAXCQC), CQNUMV(MAXCQC), NOIFCQ, IFQDCQ, ISUBCQ,
     *   NFFTCQ(MAXIF), NCHCQ(MAXIF), NSAVCQ(MAXIF), NOVSCQ(MAXIF),
     *   NZPDCQ(MAXIF), NBITCQ(MAXIF), IFLTCQ(MAXIF), IOVLCQ(MAXIF),
     *   INDX, JIF, ISUB, ICORR, IFILT, ID, JTRIM
      INCLUDE 'INCS:DMSG.INC'
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C
      DO 40 I = 1,NSIZ
         LTAPER(I) = ' '
         TAVGTF(I) = 0.0
         NSPECA(I) = 0.0
         DELBIT(I) = 0.0D0
         NFFTSZ(I) = 0
         ITYPTF(I) = 0
         WDODSM(I) = .FALSE.
 40      CONTINUE
C
      DO 45 I = 1,NSIZ2
         NETVLB(I) = 0
         WARN(I) = .FALSE.
 45      CONTINUE
C                                       Determine which subarrays
C                                       contain VLBA data
      CALL FNDEXT ('AN', CATUV, NSUBA)
C                                       Suppress error messages
      MSGSAV = MSGSUP
      MSGSUP = 32000
C                                       Loop over each subarray
      DO 50 I = 1,NSUBA
         LTAB = 'AN'
         IVER = I
         LANAME = ' '
         CALL TABINI ('READ', LTAB, IUDISK, IUCNO, IVER, CATUV, JLUN,
     *      NKEY, NREC, NCOL, DATP, BUFF, IERR)
         IDATE(1) = 0
         IF (IERR.EQ.0) THEN
C                                       Extract ARRAY_NAME keyword
            NKEY = 1
            LKEY = 'ARRNAM'
            CALL TABKEY ('READ', LKEY, NKEY, BUFF, JKLOCS, KEYVAL,
     *         KEYTYP, IERR)
            IF (IERR.EQ.0) THEN
               IPOINT = JKLOCS
               IF (IPOINT.EQ.1) CALL H2CHR (8, 1, KEYVAL, LANAME)
               END IF
            NKEY = 1
            LKEY = 'RDATE'
            CALL TABKEY ('READ', LKEY, NKEY, BUFF, JKLOCS, KEYVAL,
     *         KEYTYP, IERR)
            IF (IERR.EQ.0) THEN
               IPOINT = JKLOCS
               IF (IPOINT.EQ.1) CALL H2CHR (8, 1, KEYVAL, RDATE)
               CALL DATEST (RDATE, IDATE)
               END IF
            END IF
C                                       Set flags for VLBA
         IF (LANAME.EQ.'VLBA') NETVLB(I) = 1
         IF (LANAME.EQ.'EVLA') THEN
             IF ((IDATE(1).EQ.2018) .AND. (IDATE(2).GE.7)) NETVLB(I) = 2
             IF (IDATE(1).GT.2018) NETVLB(I) = 2
             END IF
         WARN(I) = NETVLB(I).GT.0
C                                       Close AN table
         CALL TABIO ('CLOS', 0, 0, BUFF, BUFF, IERR)
 50      CONTINUE
C                                       Read CQ table information
      IVER = 1
      CALL CQINI ('READ', BUFF, IUDISK, IUCNO, IVER, CATUV, JLUN,
     *   ICQRNO, CQKOLS, CQNUMV, NOIFCQ, IERR)
      IF (IERR.EQ.0) THEN
         NREC = BUFF(5)
         DO 200 I = 1,NREC
C                                       Read CQ table record
            CALL TABCQ ('READ', BUFF, ICQRNO, CQKOLS, CQNUMV, NOIFCQ,
     *         IFQDCQ, ISUBCQ, NFFTCQ, NCHCQ, NSAVCQ, DFRQCQ, DCBWCQ,
     *         LTAPCQ, NOVSCQ, NZPDCQ, IFLTCQ, TAVGCQ, NBITCQ,
     *         IOVLCQ, IERR)
            IF (IERR.NE.0) THEN
               GO TO 200
               END IF
C                                       Select on FQ_ID
            IF ((IFQDCQ.NE.FRQSEL) .AND. (FRQSEL.GT.0) .AND.
     *         (IFQDCQ.GT.0)) GO TO 200
C                                       Fill output arrays
            ISUB = MAX (ISUBCQ, 1)
            DO 150 JIF = 1,NOIFCQ
C                                       Extract correlation id.
               ID = MAX (IFLTCQ(JIF), 0)
               IFILT = MOD (ID, 256)
               ICORR = (ID - IFILT) / 256 + 1.1
               INDX = (ICORR - 1) * MAXIF + JIF
C                                       Taper function
               ID = JTRIM (LTAPCQ(JIF))
               LTAPER(INDX) = LTAPCQ(JIF)(:ID)
C                                       Spectral avg. function
               NSPECA(INDX) = NSAVCQ(JIF)
C                                       Scale by current channel
C                                       bandwidth in case data have
C                                       been averaged since correlation
               IF (ABS (DCBWCQ(JIF)).GT.0.0) THEN
                  JFACT = ABS (FINC(JIF) / DCBWCQ(JIF))
                  JFACT = MAX (1.0, JFACT)
               ELSE
                  JFACT = 1.0
                  END IF
               NSPECA(INDX) = NSPECA(INDX) * JFACT
C                                       FFT size
               NFFTSZ(INDX) = NFFTCQ(JIF)
C                                       Time interval per bit
               IF ((ABS(DCBWCQ(JIF)).GT.0.0).AND.(NCHCQ(JIF).GT.0))THEN
                  DELBIT(INDX) = 1.0D0 / (2 * DCBWCQ(JIF) * NCHCQ(JIF))
               ELSE
                  DELBIT(INDX) = -1.0D0
                  END IF
C                                       Filter type
               ITYPTF(INDX) = IFILT
C                                       Filter averaging time
               TAVGTF(INDX) = TAVGCQ(JIF)
C                                       Can delay decorrelation
C                                       corrections be done for this
C                                       (IF,corr_id) combination ?
C                                       Are taper function and FFT
C                                       size valid ?
               IF (LTAPER(INDX).EQ.' ') LTAPER(INDX) =
     *            LTAPER(INDX+1-JIF)
               CALL FXSEG (LTAPER(INDX), NFFTSZ(INDX), 0.0D0,
     *            DFACT, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1010)
                  CALL MSGWRT (8)
                  WRITE (MSGTXT,1020)
                  CALL MSGWRT (8)
                  END IF
C                                       Incorporate other conditions
               WDODSM(INDX) = ((NSPECA(INDX).GT.0.0) .AND.
     *            (DELBIT(INDX).GT.0.0) .AND. (IERR.EQ.0))
               IERR = 0
 150           CONTINUE
 200        CONTINUE
         END IF
C                                       Close CQ table
      CALL TABIO ('CLOS', 0, 0, BUFF, BUFF, IERR)
C                                       Exit
      MSGSUP = MSGSAV
 999  RETURN
C----------------------------------------------------------------------
 1010 FORMAT ('FXSEG: Problem with calculating segmetation loss factor',
     *   ' using')
 1020 FORMAT ('FXSEG: the CQ table.')
      END

      SUBROUTINE PAD (NIFRQ, NXTTWO, DATA, NFRQ)
C-----------------------------------------------------------------------
C! Zero pad a spectrum
C# Spectral Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  If a spectrum has a prime number of channels this routine will
C  pad it with zeroes up to the next power of two to speed up
C  the FFT process.
C
C  Inputs:
C    NIFRQ         I     Number of channels in input spectrum (prime)
C    NXTTWO        I     The next power of two above NIFRQ
C    DATA (2,*)    R     The spectrum
C
C  Outputs:
C    DATA (2,*)    R     The padded spectrum
C    NFRQ          I     The # channels in the padded spectrum
C                        = NXTTWO
C-----------------------------------------------------------------------
      INTEGER   NIFRQ, NXTTWO, NFRQ, I, DIFF
      REAL      DATA (2,*)
C-----------------------------------------------------------------------
      NFRQ = NXTTWO
      DIFF = NXTTWO - NIFRQ
      DO 100 I = 1, DIFF
         DATA (1,NIFRQ+I) = 0.0
         DATA (2,NIFRQ+I) = 0.0
 100     CONTINUE
C
      RETURN
      END

       SUBROUTINE ZSSSOP (LUN, IND, IERR)
C-----------------------------------------------------------------------
C! open SUN-Screen-Server (TV) device
C# TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   open SUN-Screen-Server (TV) device
C   Inputs:
C      LUN    I   FORTRAN logical file number.
C   Output:
C      IND    I   Index into FTAB for the file control block.
C      IERR   I   Error return code: 0 = no error
C                    1 = LUN already in use
C                    2 = file not found
C                    3 = volume not found
C                    4 = excl requested but not available
C                    5 = no room for lun
C                    6 = other open errors
C
C   UNIX version. Although this doesn't really seem to do anything I
C   kept it around rather than than opening the socket directly because
C   I'm not sure if it is important to have an FTAB entry (even though,
C   e.g., LUN will never be used). ZPHFIL is called as normal, but then
C   the new routine ZSSSO2 (socket assign) is called.
C-----------------------------------------------------------------------
      INTEGER   LUN, IND, IERR
C
      CHARACTER PNAME*48
      HOLLERITH HNAME(12)
      LOGICAL   F
      INTEGER   ERRLUN, ERRTER, IER
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA F /.FALSE./
      DATA ERRLUN, ERRTER /12, 6/
C-----------------------------------------------------------------------
      CALL ZPHFIL ('TV', 1, 1, 1, PNAME, IER)
C
      IERR = 6
      IF ((LUN.EQ.ERRLUN) .OR. (LUN.EQ.ERRTER)) GO TO 980
      IF ((LUN.LE.0) .OR. (LUN.GT.50)) GO TO 980
      IF (DEVTAB(LUN).NE.4) GO TO 970
      IERR = 0
C                                       allocate table
      CALL LSERCH ('OPEN', LUN, IND, F, IER)
      IF (IER.EQ.0) GO TO 20
         IF (IER.NE.2) GO TO 10
            IERR = 1
            WRITE (MSGTXT,1000) LUN
            GO TO 990
 10      IF (IER.NE.3) GO TO 20
            IERR = 5
            WRITE (MSGTXT,1010) LUN
            GO TO 990
C                                       non-disk devices
 20   TVBROK = 0
      CALL CHR2H (48, PNAME, 1, HNAME)
      CALL ZSSSO2 (FTAB(IND+NMOFF), HNAME, IER)
      TVBROK = IER
      IF (IER.EQ.0) GO TO 999
         IERR = 6
         WRITE (MSGTXT,1020) LUN
C                                       Errors
C                                       remove FTAB
 900  CALL LSERCH ('CLOS', LUN, IND, F, IER)
      IF (IERR.EQ.6) GO TO 990
C                                       illegal device
 970  WRITE (MSGTXT,1970) LUN
      GO TO 990
C                                       illegal lun
 980  WRITE (MSGTXT,1980) LUN, PNAME(1:24)
C                                       print msg
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZSSSOP: LUN',I4,' ALREADY IN USE')
 1010 FORMAT ('ZSSSOP: LUN TABLE FULL, CANT FIT LUN',I4)
 1020 FORMAT ('ZSSSOP: CHANNEL ASSIGN ERROR FOR LUN ',I4)
 1970 FORMAT ('ZSSSOP: CALLED FOR NON-TV DEVICE WITH LUN',I4)
 1980 FORMAT ('ZSSSOP: LUN',I6,' ILLEGAL FOR ',A24)
      END

      SUBROUTINE GETDEL (CLTIME, CLSRC, CLSTA, CLARR, CLFQID,
     *   IMBUFF, GEODLY, DISP, DDISP, NUMREC, IRET)
C-----------------------------------------------------------------------
C! Moves delay polynomials from IM to CL tables with time shift
C# EXT-appl VLBI
C-----------------------------------------------------------------------
C;  Copyright (C) 1997-2000, 2008, 2014
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Look up the geometric delay polynomial for CLTIME, CLSRC, CLSTA, and
C   CLFQID in an IM table and return it as GEODLY with it's time origin
C   shifted to CLTIME.  The contents of GEODLY are suitable for use in
C   a CL table record defined by CLTIME, CLSRC, CLSTA, CLFQID.
C
C   If no IM table record can be found covering CLTIME an earlier one
C   will be used providing that CLTIME - IMTIME < 2 * IMTINT where
C   IMTIME is the reference time for the IM table record and IMTINT is
C   the time interval covered by the IM table record: a warning message
C   will be printed if CLTIME - IMTIME > 1.1.
C
C   If no IM table record covers CLTIME with the extended duration then
C   the polynomial will be set to all zeros and a warning message will
C   be printed.
C
C   The delay polynomial is assumed to have no more than 17 terms.
C
C   The IM table is assumed to be in order of ascending time and
C   calls to GETDEL should be made in ascending order of CLTIME.
C
C   Inputs:
C      CLTIME   D      CL entry time (days)
C      CLSRC    I      CL entry source number
C      CLSTA    I      CL entry antenna number
C      CLARR    I      CL entry array number (currently ignored)
C      CLFQID   I      CL entry frequency ID
C
C   Input/output:
C      NUMREC   I      Set to 0 to force re-hash of file -
c                        leave alone otherwise
C      IMBUFF   I(*)   I/O buffer and control block for open IM table
C
C   Output:
C      GEODLY   D(*)   Delay polynomial
C      DISP     R(2)   Dispersive delay (sec)
C      DDISP    R(2)   Rate of change of DISP (sec/sec)
C      IRET     I      Return status: 0 -> successful
C                                         other -> table I/O error
C-----------------------------------------------------------------------
      DOUBLE PRECISION CLTIME, GEODLY(*)
      INTEGER   CLSRC, CLSTA, CLARR, CLFQID, IMBUFF(*), NUMREC, IRET
      REAL      DISP(2), DDISP(2)
C
C                                       Saved variables
C     NUMREC       I      Number of records in the IM table.
C     IMTIME       D      Reference time of best candidate IM table
C                         record
C     IMTINT       R      Nominal duration of best candidate IM table
C                         record
C     SROW,EROW    I      Row number range around current time
C     TROWS        I(*)   Hash table - row numbers
C     TTIMES       R(*)   Hash table - times
C     TINTS        R(*)   Has table increments
C
      INTEGER   HASHSZ
      PARAMETER (HASHSZ = 1024)
      INTEGER   TDHMS(4), NTIMES, TROWS(HASHSZ), IB, IE, SROW, EROW, I,
     *   ROW, MROW
      REAL      IMTINT, TTIMES(HASHSZ), TINTS(HASHSZ), TMPINT, TDI(2),
     *   TDD(2), MTIME
      DOUBLE PRECISION IMTIME, IMPOLY(17), DELTIM, TMPTIM
      LOGICAL   WARNLO, WARNHI, VALID
C
      SAVE      SROW, EROW, NTIMES, TROWS, TTIMES, TINTS, WARNLO,
     *   WARNHI, IMTINT, IMTIME
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DGLB.INC'
      INCLUDE 'INCS:DIMV.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA WARNLO, WARNHI /2 * .FALSE./
C-----------------------------------------------------------------------
C                                       NUMREC change => reset hash
C                                       table since file has changed
      IF (IMBUFF(5).NE.NUMREC) THEN
         NUMREC = IMBUFF(5)
         CALL FILL (HASHSZ, NUMREC, TROWS)
         CALL RFILL (HASHSZ, 9999.0, TTIMES)
         NTIMES = MIN (HASHSZ, NUMREC)
         IMTIME = -999.0D0
         IMTINT = 1.E-9
         DO 20 I = 1,NTIMES
            IF (NTIMES.LE.1) THEN
               ROW = 1
            ELSE
               ROW = (NUMREC-1.0) * (I-1.0) / (NTIMES - 1.0) + 1.5
               END IF
            TROWS(I) = ROW
            IIMRNO = ROW
            CALL IMTAB ('READ', IMBUFF, NOBAND, IRET)
            IF (IRET.GT.0) GO TO 990
            TTIMES(I) = TIME
            TINTS(I) = TINT * 2.0
 20         CONTINUE
         END IF
C                                       Fill-in default values:
      CALL DFILL (NPOLY, 0.0D0, GEODLY)
      DISP(1) = 0.0
      DISP(2) = 0.0
      DDISP(1) = 0.0
      DDISP(2) = 0.0
C                                       check total range
      IF (CLTIME.LT.TTIMES(1)) THEN
         IF (.NOT.WARNLO) THEN
            WARNLO = .TRUE.
            MSGTXT = 'WARNING: times encountered before start' //
     *         ' of IM table'
            GO TO 900
         ELSE
            GO TO 910
            END IF
         END IF
      IF (CLTIME.GT.TTIMES(NTIMES)+TINTS(NTIMES)) THEN
         IF (.NOT.WARNHI) THEN
            WARNHI = .TRUE.
            MSGTXT = 'WARNING: times encountered after end' //
     *         ' of MC table'
            GO TO 900
         ELSE
            GO TO 910
            END IF
         END IF
C
C        To minimize the amount of table reading we need to set bounds
C        on the rows to be searched so that the sections of the table
C        that contain no candidate matches are not read. We start by
C        setting bounds IB and IE on the has table so that for all
C        i such that 1 <= i < IB, TTIMES(i) + TINTS(i) < CLTIME and
C        for all i such that IE < i <= NTIMES, TTIMES(i) < CLTIME
C        since a record with hash table index j can only be valid if
C        TTIMES(j) <= CLTIME <= TTIMES(j) + TINTS(j)
C
      IB = 1
 30   IF ((IB.LT.NTIMES) .AND. (TTIMES(IB)+TINTS(IB).LT.CLTIME)) THEN
         IB = IB + 1
         GO TO 30
         END IF
      IE = NTIMES
 40   IF ((IE.GT.IB) .AND. (TTIMES(IE).GT.CLTIME)) THEN
         IE = IE - 1
         GO TO 40
         END IF
C
C        If there are more IM records than hash table entries then
C        there may be potentialy valid records with
C        TROWS(IB-1) < row < TROWS(IB) or TROWS(IE) < row < TROWS(IE+1)
C        so adjust IB and IE to make sure these rows are not excluded:
C
      IF (IB.GT.1) IB = IB - 1
      IF (IE.LT.NTIMES) IE = IE + 1
C
C        Now translate the hash indices to row numbers:
C
      SROW = TROWS(IB)
      EROW = TROWS(IE)
C                                       Search records SROW to EROW for
C                                       CLSRC and CLSTA
C                                       and closest time
      TMPTIM = -999.9D0
      TMPINT = 0.0
      MROW = 0
      MTIME = 1.E9
      DO 70 ROW = SROW,EROW
         IIMRNO = ROW
         CALL IMTAB ('READ', IMBUFF, NOBAND, IRET)
         IF (IRET.GT.0) GO TO 990
         IF (IRET.EQ.0) THEN
            VALID = (CLTIME-TIME).LE.2.0*TINT
            VALID = VALID .AND. ((CLTIME-TIME).GT.-TINT/200.0)
            VALID = ((NOSTA.LE.0) .OR. (CLSTA.LE.0) .OR.
     *         (CLSTA.EQ.NOSTA)) .AND. VALID
            VALID = ((ISRC.LE.0) .OR. (CLSRC.LE.0) .OR. (CLSRC.EQ.ISRC))
     *         .AND. VALID
            VALID = ((IARRAY.LE.0) .OR. (CLARR.LE.0) .OR.
     *         (CLARR.EQ.IARRAY)) .AND. VALID
            VALID = ((IFQID.LE.0) .OR. (CLFQID.LE.0) .OR.
     *         (CLFQID.EQ.IFQID)) .AND. VALID
            IF (VALID) THEN
               IF (ABS(CLTIME-TIME).LT.MTIME) THEN
                  MROW = ROW
                  MTIME = ABS(CLTIME-TIME)
                  END IF
               END IF
            END IF
 70      CONTINUE
      IF (MROW.GT.0) THEN
         IIMRNO = MROW
         CALL IMTAB ('READ', IMBUFF, NOBAND, IRET)
         IF (IRET.GT.0) GO TO 990
         IF (IRET.EQ.0) THEN
            TMPTIM = TIME
            TMPINT = TINT
            CALL DPCOPY (NPOLY, GDELA1, IMPOLY)
            TDI(1) = DISP1
            TDD(1) = DDISP1
            TDI(2) = DISP2
            TDD(2) = DDISP2
            IF ((CLTIME-TIME.LT.TINT) .AND. (CLTIME-TIME.GE.0.0))
     *         GO TO 80
            END IF
         END IF
      IF (TMPTIM.LT.0.0D0) GO TO 910
C                                       found one
 80   IMTIME = TMPTIM
      IMTINT = TMPINT
C                                       IMTIME, IMTINT, and IMPOLY now
C                                       contain data from the latest
C                                       applicable IM table record.
      IF (ABS(CLTIME-IMTIME).GT.1.10*IMTINT) THEN
         CALL TODHMS (REAL(CLTIME), TDHMS)
         WRITE (MSGTXT,1080) CLSTA, CLSRC, TDHMS(1), TDHMS(2), TDHMS(3),
     *      TDHMS(4)
         CALL MSGWRT (6)
         END IF
      DELTIM = 86400.0D0 * (CLTIME - IMTIME)
      CALL PSHIFT (DELTIM, IMPOLY, NPOLY-1)
      CALL DPCOPY (NPOLY, IMPOLY, GEODLY)
      DDISP(1) = TDD(1)
      DDISP(2) = TDD(2)
      DISP(1)  = TDI(1) + (CLTIME - IMTIME) * DDISP(1) * 86400.
      DISP(2)  = TDI(2) + (CLTIME - IMTIME) * DDISP(2) * 86400.
      IRET = 0
      GO TO 999
C
 900  CALL MSGWRT (6)
C
 910  CALL TODHMS (REAL(CLTIME), TDHMS)
      WRITE (MSGTXT,1910) CLSTA, CLSRC, CLARR, CLFQID, TDHMS(1),
     *   TDHMS(2), TDHMS(3), TDHMS(4)
      CALL MSGWRT (6)
      IRET = -1
      GO TO 999
C
 990  WRITE (MSGTXT,1990) IRET, IIMRNO
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1080 FORMAT ('GETDEL: Using previous IM entry stn',I3,' src',I4,' at',
     *   I4,'/',2(I2.2,':'),I2.2)
 1910 FORMAT ('GETDEL: No IM entry stn',I3,' src',I4,' sub',I3,' FQ',
     *   I3,' at',I4,'/',2(I2.2,':'),I2.2)
 1990 FORMAT ('GETDEL: ERROR ', I3, ' READING IM TABLE ROW',I9)
      END

      SUBROUTINE YIMGIO (OP, CHAN, X, Y, IANGL, NPIX, IMAGE, IERR)
C-----------------------------------------------------------------------
C! read/write data to the TV grey and graphics memories
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YIMGIO reads/writes a line of image data to the TV screen.  For
C   graphics overlay planes, the data are solely 0's and 1's in the
C   least significant bit of IMAGE after a READ.  For 'WRIT', all bits
C   of each word should be equal (i.e. all 1's or all 0's for graphics).
C   NOTE***** on 'WRIT', the buffer may be altered by this routine for
C   some IANGLs.
C   Inputs:
C      OP      C*4       'READ' from TV or 'WRIT' to TV
C      CHAN    I         channel number (1 to NGRAY+NGRAPH)
C      X       I         start pixel position
C      Y       I         end pixel position
C      IANGL   I         = 0 => horizontal (to right)
C                        = 1 => vertical (up the screen)
C                        = 2 => horizontal (to left)
C                        = 3 => vertical (down the screen)
C      NPIX    I         number of pixels
C   In/Out:
C      IMAGE   I(NPIX)   data (only no header)
C   Output:
C      IERR    I         error code of Z...XF - 0 => ok
C                                                  2 => input err
C   Version for IIS Models M70 and M75
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   CHAN, X, Y, IANGL, NPIX, IMAGE(*), IERR
C
      INTEGER   IC, IB, IX, IY, NB, HDR(8), JANGL, K, I, J, N, ZAND,
     *   BIT16
      LOGICAL   T, F, SWAP
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA BIT16 /-32768/
C-----------------------------------------------------------------------
C                                        check input
      IERR = 2
      IF (NPIX.LT.1) GO TO 990
      IF ((OP.NE.'READ') .AND. (OP.NE.'WRIT')) GO TO 990
      IF ((CHAN.LT.1) .OR. (CHAN.GT.NGRAY+NGRAPH)) GO TO 990
      IF ((X.LT.1) .OR. (X.GT.MAXXTV(1))) GO TO 990
      IF ((Y.LT.1) .OR. (Y.GT.MAXXTV(2))) GO TO 990
      IF ((IANGL.LT.0) .OR. (IANGL.GT.3)) GO TO 990
      IF ((IANGL.EQ.0) .AND. (X+NPIX-1.GT.MAXXTV(1))) GO TO 990
      IF ((IANGL.EQ.1) .AND. (Y+NPIX-1.GT.MAXXTV(2))) GO TO 990
      IF ((IANGL.EQ.2) .AND. (X-NPIX+1.LT.1)) GO TO 990
      IF ((IANGL.EQ.3) .AND. (Y-NPIX+1.LT.1)) GO TO 990
C                                        channel codes: gray
      IF (CHAN.LE.NGRAY) THEN
         IC = 2 ** (CHAN-1)
         IB = -1
C                                        graphics
      ELSE
         IC = BIT16
         IB = 2 ** (CHAN-NGRAY-1)
         END IF
C                                        set position
 20   IX = X
      IY = Y
      SWAP = .FALSE.
      JANGL = IANGL
      IF ((IANGL.EQ.0) .AND. (TVXMOD.EQ.1)) GO TO 30
      IF ((IANGL.EQ.1) .AND. (TVYMOD.EQ.1)) GO TO 30
      IF ((IANGL.EQ.2) .AND. (TVXMOD.EQ.2)) GO TO 30
      IF ((IANGL.EQ.3) .AND. (TVYMOD.EQ.2)) GO TO 30
         JANGL = MOD (JANGL+2, 4)
         IF (IANGL.EQ.0) IX = X + NPIX - 1
         IF (IANGL.EQ.1) IY = Y + NPIX - 1
         IF (IANGL.EQ.2) IX = X - NPIX + 1
         IF (IANGL.EQ.3) IY = Y - NPIX + 1
         SWAP = .TRUE.
C                                        swap buffer order
         IF (OP.EQ.'WRIT') THEN
            N = NPIX / 2
            K = 1 + NPIX
            DO 25 I = 1,N
               J = IMAGE(I)
               IMAGE(I) = IMAGE(K-I)
               IMAGE(K-I) = J
 25            CONTINUE
            END IF
C                                        do it
 30   NB = 2 * NPIX
      CALL YGYHDR (OP, NPIX, IX, IY, JANGL, IC, IB, F, T, F, F, F, F,
     *   HDR, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZM70XF (OP, NB, HDR, IMAGE, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (OP.EQ.'WRIT') GO TO 999
C                                        fix graphics
      IF (CHAN.GT.NGRAY) THEN
         DO 40 I = 1,NPIX
            IMAGE(I) = ZAND (IMAGE(I), IB) / IB
 40         CONTINUE
         END IF
C                                        fix vertical order
      IF (SWAP) THEN
         N = NPIX / 2
         K = 1 + NPIX
         DO 60 I = 1,N
            J = IMAGE(I)
            IMAGE(I) = IMAGE(K-I)
            IMAGE(K-I) = J
 60         CONTINUE
         END IF
      GO TO 999
C                                       Input error
 990  WRITE (MSGTXT,1900) OP, CHAN, NPIX, X, Y, IANGL
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('YIMGIO: OP,CHAN,NPIX,X,Y,ANGL ERROR: ',A4,I4,3I5,I3)
      END

      SUBROUTINE YTVMC
C-----------------------------------------------------------------------
C! issue a master clear to reinitialize IO to the TV
C# Y1 TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YTVMC issues a "master clear" to the TV.  This resets the TV IO
C   system (if necessary) to expect a command record next.
C   YTVMC gets all needed parameters from the TV device common.
C   The TV must already be open.
C   DeAnza version
C-----------------------------------------------------------------------
      INTEGER   UOFF
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE 'INCS:DTVD.INC'
C-----------------------------------------------------------------------
      UOFF = TVIND + NMOFF
      CALL ZDEAMC (FTAB(UOFF))
C
 999  RETURN
      END

      SUBROUTINE TABSRT (DISK, CNO, TYPE, INVER, OUTVER, KEY, KEYSUB,
     *   FKEY, TABUFF, CATIN, IERR)
C-----------------------------------------------------------------------
C! Sorts the entries in an AIPS table.
C# EXT-util IO-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1999, 2005, 2007-2008, 2011-2012, 2015, 2018-2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Subroutine to sort an AIPS table extension file.  First key changes
C   the most slowly.  A linear combination of two columns or a substring
C   of a bit or character string may be used.  The columns and factors
C   are specified in KEY and FKEY, the first (slower varying key) is:
C      KEY_VALUE1 = COL_VALUE(KEY(1,1)) * FKEY(1,1) +
C                   COL_VALUE(KEY(2,1)) * FKEY(2,1)
C   The faster changing key value is:
C      KEY_VALUE2 = COL_VALUE(KEY(1,2)) * FKEY(1,2) +
C                   COL_VALUE(KEY(2,2)) * FKEY(2,2)
C   In the case of bit or character strings only one column is used to
C   generate the key values.
C   A KEY(m,n) < 0 => use ABS (COL_VALUE(-KEY(m,n))).
C   Inputs:
C      DISK     I        Disk number of the file.
C      CNO      I        Catalog slot number.
C      TYPE     I        Two character type code (e.g. 'CC')
C      INVER    I        Input version number
C      OUTVER   I        Output version number
C      KEY      I(2,2)   Sort keys: may be linear combination of two
C                        numeric value columns.  KEY contains the column
C                        numbers and FKEY contains the factors.  If the
C                        column is a string (bit or char.) then
C                        FKEY(1,n)=first char/bit and FKEY(2,n)=number
C                        of char/bit and KEY(2,n) is ignored.
C                        KEY(2,n)=0 => ignore, <0 => use abs. value.
C                        Column no. is the logical number.
C      KEYSUB   I(2,2)   Subscript in array columns for sort key value
C                        Normally (1,1,1,1)
C      FKEY     R(2,2)   Key  coefficients, 0=>1, see above.
C      CATIN    I(256)   Catalog header record.
C   Output:
C      TABUFF   I(512)   Buffer to handle I/O to table.
C      IERR     I        Error code, 0 => OK, else error.
C                        10 => Couldn't find or open file.
C   Useage Notes:
C        Normally the keys are sorted into ascending order, to sort into
C   descending order negate the values of FKEYn.
C        TWO standard scratch files will be created and entered into the
C   /CFILES/ common.  These scratch files will be deleted on normal
C   termination.  Includes DFIL.INC should be included in the main
C   routine and a call made to DIE rather than DIETSK should be made at
C   the end of the program execution.  The values in BADD (adverb
C   BADDISK) in the /CFILES/ common should be initialized.
C        IF a disk based sort is required, then a 4-way merge sort will
C   be used; the FTAB declaration in the main program and the call to
C   ZDCHIN should be large enough to handle 8 map-like files and 2
C   Non-map files at the same time.  (Additional files may be required
C   if they are left open by the calling program).
C        Since keys are converted into floating point numbers some
C   accuracy may be lost sorting on character or bit strings.
C        For a 1 key sort use KEY2(1) = 0.
C   NB: Will modify the contents of common /MAPHDR/.
C   CODE ADDED: 11/26/08 will invoke a brute force sort for long data
C   rows.  This sorts a list of key values plus row-in number in a
C   brute-force sort and then reads in/writes out directly.
C   Uses large dynamic memory (09/21/11) instead of input.
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, INVER, OUTVER, KEY(2,2), KEYSUB(2,2),
     *   TABUFF(*), CATIN(256), IERR
      REAL      FKEY(2,2)
      CHARACTER TYPE*2
C
      INTEGER   LUN, NKEY, NREC, NCOL, DATP(128,2), IP1, IP2, ISCR,
     *   IPCOL(2,2), STRLEN(2,2), COLTYP(2,2), J, NBUFF, NSORT, IN, OUT,
     *   KEY1, KEY2, LRECM, LUNM(10), LENBU, SCRPNT, SCFRW(10), MSCR,
     *   IBUFF, NUMREC, BUFSZ, NWORDS, LUNTMP
      LONGINT   PBUF
      REAL      BUFFER(256)
      CHARACTER PNAME*6
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNM /16,17,18,19,20,21,22,23,24,25/
C-----------------------------------------------------------------------
C                                       Save pointer in scratch file
C                                       common
      SCRPNT = NSCR + 1
      MSCR = NSCR
      PNAME = 'SORT' // TYPE
C                                       Open table file and create
C                                       scratch file.
      NREC = 20
      NCOL = 0
      NKEY = 0
      LUN = LUNTMP (1)
      CALL TABINI ('READ', TYPE, DISK, CNO, INVER, CATIN, LUN, NKEY,
     *   NREC, NCOL, DATP, TABUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         IERR = 10
         GO TO 990
         END IF
C                                       Get number of records.
      NUMREC = TABUFF(5)
C                                       Check for empty table
      IF (NUMREC.LE.0) THEN
         CALL TABIO ('CLOS', 0, 1, TABUFF, TABUFF, IERR)
         IF (INVER.NE.OUTVER) CALL TABCOP (TYPE, INVER, OUTVER, LUNM(1),
     *      LUNM(2), DISK, DISK, CNO, CNO, CATIN, TABUFF, TABUFF(257),
     *      IERR)
         GO TO 999
         END IF
C                                       get big work space
      NWORDS = TABUFF(8) + 5
      NWORDS = MAX (NUMREC*NWORDS, 102400)
      NWORDS = (NWORDS - 1) / 1024 + 1
      NWORDS = MIN (NWORDS, KAPWRD)
C                                       don't overflow byte count
      NWORDS = MIN (NWORDS, 1048000)
      IF (NWORDS.LE.0) NWORDS = 1048000
      CALL ZMEMRY ('GET ', PNAME, NWORDS, BUFFER, PBUF, IERR)
C                                       try 2nd time
      IF (IERR.NE.0) THEN
         NWORDS = (NWORDS-1) / 8 + 1
         CALL ZMEMRY ('GET ', PNAME, NWORDS, BUFFER, PBUF, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'TABSRT: UNABLE TO GET NEEDED DYNAMIC MEMORY'
            GO TO 990
            END IF
         END IF
C                                       aips bytes
      BUFSZ = 2048 * NWORDS
C                                       Get column types
      DO 120 J = 1,2
         IP1 = ABS (KEY(1,J))
         IPCOL(1,J) = 1
         IF (IP1.GT.0) IPCOL(1,J) = DATP(IP1,1)
         IP2 = ABS (KEY(2,J))
         IPCOL(2,J) = 1
         IF (IP2.GT.0) IPCOL(2,J) = DATP(IP2,1)
C                                       Check factors.
         IF (FKEY(1,J).EQ.0.0) FKEY(1,J) = 1.0
         IF (FKEY(2,J).EQ.0.0) FKEY(2,J) = 1.0
C                                       Column out of range.
         IF (((IP1.GE.1) .AND. (IP1.LE.NCOL)) .AND.
     *      ((IP2.GE.0) .AND. (IP2.LE.NCOL))) GO TO 110
         IF ((J.EQ.2) .AND. (IP1.EQ.0)) GO TO 110
            IERR = 1
            WRITE (MSGTXT,1100) J, IP1, IP2
            GO TO 990
C                                       Get type (and length) of col.
 110     STRLEN(1,J) = DATP(IP1,2) / 10
         COLTYP(1,J) = DATP(IP1,2) - STRLEN(1,J) * 10
         IF (IP2.GT.0) STRLEN(2,J) = DATP(IP2,2) / 10
         IF (IP2.GT.0) COLTYP(2,J) = DATP(IP2,2) - STRLEN(2,J) * 10
C                                       Only 1 col. for strings.
         IF ((COLTYP(1,J).EQ.3) .OR. (COLTYP(2,J).EQ.3) .OR.
     *      (COLTYP(1,J).EQ.7) .OR. (COLTYP(2,J).EQ.7)) THEN
            KEY(2,J) = 0
            IP2 = 0
            END IF
         IF ((KEYSUB(1,J).GE.1) .AND. (KEYSUB(1,J).LE.STRLEN(1,J)) .AND.
     *      (COLTYP(1,J).NE.3) .AND. (COLTYP(1,J).NE.7)) IPCOL(1,J) =
     *      IPCOL(1,J) + KEYSUB(1,J) - 1
         IF ((KEYSUB(2,J).GE.1) .AND. (KEYSUB(2,J).LE.STRLEN(2,J)) .AND.
     *      (COLTYP(2,J).NE.3) .AND. (COLTYP(2,J).NE.7) .AND.
     *      (IP2.NE.0)) IPCOL(2,J) = IPCOL(2,J) + KEYSUB(2,J) - 1
 120     CONTINUE
C                                       are rows long?
      J = (BUFSZ - 10 * NBPS) / (20 * TABUFF(8))
C                                       brute sort
      IF ((TABUFF(9).LT.0) .AND. (J.LE.100) .AND.
     *   (6*TABUFF(5).LT.BUFSZ)) THEN
         CALL BTBSRT (KEY, FKEY, COLTYP, IPCOL, BUFFER(1+PBUF), TABUFF,
     *      DISK, CNO, TYPE, INVER, OUTVER, CATIN, IERR)
         CALL ZMEMRY ('FREE', PNAME, NWORDS, BUFFER, PBUF, J)
      ELSE
C                                       Read and partially sort data
C                                       to scratch file.
         CALL ITBSRT (KEY, FKEY, COLTYP, IPCOL, BUFFER(1+PBUF), BUFSZ,
     *      TABUFF, ISCR, NBUFF, NSORT, IN, OUT, LENBU, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Merge data.
         IF (NUMREC.GT.NSORT) THEN
            LRECM = 2 + TABUFF(8)
            KEY1 = 1
            KEY2 = 2
            IBUFF = NBUFF
            CALL AMERGE (KEY1, KEY2, NUMREC, LRECM, NSORT, IBUFF, LUNM,
     *         SCRVOL(ISCR), SCRCNO(ISCR), LENBU, BUFFER(IN+PBUF),
     *         BUFFER(OUT+PBUF), IERR)
            IF (IERR.NE.0) THEN
               CALL ZMEMRY ('FREE', PNAME, NWORDS, BUFFER, PBUF, J)
               GO TO 999
               END IF
            END IF
C                                       Write data back to table file.
         BUFSZ = MIN (BUFSZ, 512000000)
         CALL OTBSRT (DISK, CNO, TYPE, INVER, OUTVER, BUFFER(1+PBUF),
     *      BUFSZ, TABUFF, CATIN, KEY, FKEY, ISCR, IERR)
         CALL ZMEMRY ('FREE', PNAME, NWORDS, BUFFER, PBUF, J)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1200) IERR
            GO TO 990
            END IF
         END IF
C                                       Destroy scratch files
      IF (NSCR.GT.MSCR) THEN
         MSCR = NSCR - MSCR
         CALL FILL (MSCR, 2, SCFRW)
C                                       Save CATBLK - MAPCLR may
C                                       modify.
         CALL COPY (256, CATBLK, TABUFF)
         CALL MAPCLR (MSCR, SCRVOL(SCRPNT), SCRCNO(SCRPNT), SCFRW,
     *      BUFFER)
         IF (MSCR.LE.0) NSCR = SCRPNT - 1
C                                       Restore CATBLK
         CALL COPY (256, TABUFF, CATBLK)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TABSRT: ERROR ',I3,' OPENING INPUT TABLE')
 1100 FORMAT ('TABSRT: COLUMN OUT OF RANGE KEY ',I2,' = ',2I4)
 1200 FORMAT ('TABSRT: OTBSRT ERROR ',I3)
      END

      PROGRAM BAKLD
C-----------------------------------------------------------------------
C! read catalog entries from machine-dependent bakup tapes from BAKTP
C# Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   BAKLD is the task to read files written to tape by task BAKTP in a
C   host-dependent format (BACKUP under VMS, "tar" under Unix).  BAKLD
C   has two modes of operation: 'LOAD' and 'PRNT'. The LOAD mode
C   selectively reloads AIPS files from tape to disk. The PRNT mode
C   produces a directory of a tape, which can be used to select files
C   for LOADing.
C   AIPS input parameters:
C      INTAPE     R      Input tape unit #
C      OUTNAME    H*12   Image name (name)
C      OUTCLASS   H*6    Image name (class)
C      OUTSEQ     R      Image name (seq #) (< 0 => tape value)
C      OUTDISK    R      Output disk unit #
C      NCOUNT     R      Number of images to load.
C      NFILES     R      Number of files to skip first (<0 back, 0 to
C                        start of current file)
C      OPCODE     h*4    'LOAD', 'PRNT', or ' '
C      DOCRT      R      'PRNT' listing to terminal, or printer?
C-----------------------------------------------------------------------
      INTEGER   IRET, ISCR(256), JERR, I, N, IROUND, K, ERRLIM, ERRCNT
      CHARACTER OP*4
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DBKL.INC'
C-----------------------------------------------------------------------
      TIND = 0
      CALL BKLINI (RQUICK, ISCR, IRET)
      IF (IRET.NE.0) GO TO 995
      ERRLIM = 3
      ERRCNT = 0
C                                       Process the tape:
      DO 150 K = 1,2
C                                       skip files first:
         IF (K.EQ.1) THEN
            N = IROUND (NFILES)
            IF (N.LT.0) N = 0
            OP = 'SKIP'
            ERRLIM = ERRLIM - N
C                                       then process files:
         ELSE
            N = NCOUNS + .05
            IF (N.LE.0) N = 1
            CALL H2CHR (4, 1, OPCODE, OP)
            END IF
C                                       tape loop:
         IF (N.GT.0) THEN
            DO 140 I = 1,N
C                                       virgin copy of parms:
 130           CALL ZBKLD2 (OP, IRET)
               IF (IRET.EQ.999) THEN
                  ERRCNT = ERRCNT + 1
                  IF ((K.NE.2) .OR. (ERRCNT.GT.ERRLIM)) GO TO 160
                     MSGTXT = 'Try it (' // OP // ') again'
                     CALL MSGWRT (6)
                     GO TO 130
               ELSE IF (IRET.NE.0) THEN
                  GO TO 995
               ELSE
                  IF (K.EQ.2) ERRLIM = 0
                  END IF
 140           CONTINUE
            END IF
 150     CONTINUE
C                                       Clean up
 160  CALL ZBKLD3 (IRET)
C
 995  IF (TIND.GT.0) CALL ZTPCLS (TLUN, TIND, JERR)
      CALL DIE (IRET, ISCR)
C
 999  STOP
      END
      SUBROUTINE BKLINI (RQUICK, ISCR, IRET)
C-----------------------------------------------------------------------
C   BKLINI does the most basic inits for BAKLD.  Get the parameters,
C   restart AIPS if required, fill in defaults, init the tape I/O.
C   Outputs:
C      RQUICK  L         T -> AIPS already restarted
C      ISCR    I(256)    Scratch buffer
C      IRET    I         Return code : 0 => ok, else quit
C   Common
C      /INPARM/
C      /MORPRM/
C-----------------------------------------------------------------------
      INTEGER   ISCR(256), IRET
      LOGICAL   RQUICK
C
      CHARACTER PRGNAM*6, TNAME*48, OP*4
      INTEGER   IERR
      LOGICAL   T
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DBKL.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA PRGNAM /'BAKLD '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
      CALL ZDCHIN (.TRUE., ISCR)
      CALL VHDRIN
C                                       Initialize for AIPS
      NPARM = 11
      CALL GTPARM (PRGNAM, NPARM, RQUICK, NTAPE4, ISCR, IRET)
      IF (IRET.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (8)
         GO TO 20
C                                       Only interactive tasks
 10   IF ((NPOPS.LE.NINTRN) .AND. (ISBTCH.NE.32000)) GO TO 20
         WRITE (MSGTXT,1010)
         CALL MSGWRT (8)
         IRET = 4
C                                       Restart AIPS
 20   IF (RQUICK) CALL RELPOP (IRET, ISCR, IERR)
      IF (IRET.NE.0) GO TO 999
C                                       get tape drive:
      NTAPE = NTAPE4 + 0.5
      IF (NTAPE.EQ.0) NTAPE = 1
      TLUN = 129 - NTAPE
      CALL ZPHFIL ('MT', NTAPE, 1, 1, TNAME, IERR)
      IF (IERR.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) IERR
         GO TO 990
C
 30   CALL ZTPOPN (TLUN, TIND, NTAPE, TNAME, 'READ', IERR)
      IF (IERR.EQ.0) GO TO 40
         WRITE (MSGTXT,1030) IERR
         GO TO 990
C                                       Set some default values,
C                                       and global parameters.
 40   USER = NLUSER
C                                       verify OPCODE:
      CALL H2CHR (4, 1, OPCODE, OP)
      IF (OP.EQ.' ') OP = 'LOAD'
      IF ((OP.EQ.'LOAD') .OR. (OP.EQ.'PRNT')) GO TO 50
         WRITE (MSGTXT,1040) OP
         GO TO 990
 50   CALL CHR2H (4, OP, 1, OPCODE)
      WRITE (MSGTXT,1050)
      CALL MSGWRT (6)
C                                       BAKLD init:
      BAKTXT = 'BAKAIP.TXT'
      CALL ZBKLD1 (IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
      IRET = 16
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('COULD NOT GET PARMS.  IER=',I3)
 1010 FORMAT ('TAPES NOT AVAILABLE TO BATCH AIPS  ')
 1020 FORMAT ('COULD NOT GET PHYSICAL NAME OF TAPE.  IER=',I4)
 1030 FORMAT ('COULD NOT OPEN TAPE.  IER=',I4)
 1040 FORMAT ('OPCODE=',A4,' ILLEGAL; Legal = LOAD or PRNT')
 1050 FORMAT (4X,1X,'User',1X,'Rlsnam ',1X,'Bak-date',1X,'Map-date',
     *   1X,'TY',1X,'Name        ',1X,'Class ',1X,'Seq ')
      END

LOCAL INCLUDE 'ACFIT.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      CHARACTER NAMEIN*12, CLAIN*6, XSTOK*4, NAME2*12, CLAS2*6,
     *   XCALCO*4, NAMOUT*12, CLAOUT*6
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XNAME2(3),
     *   XCLAS2(2), XXCALC(1), XNAMOU(3), XCLAOU(2)
      REAL     XSIN, XDISIN, XQUAL, XBAND, XFREQ, XFQID, XTIME(8),
     *   XSUBA, XANT(50), XS2, XD2, XDOCAL, XGUSE, XFLAG, XSOLIN,
     *   XDOBAN, XBPVER, XSMOTH(3), XBCHAN, XECHAN, APARM(10),
     *   BPARM(10), CPARM(10), DPARM(10), EPARM(10), XSNVER, XSOUT,
     *   XDSOUT, XBADD(10), ACSMAX, MINGAN, MAXGAN, MXGERR, XRFANT
      INTEGER   SEQIN, SEQ2, DISKIN, DISK2, CNOIN, CNOIN2, PRTLV,
     *   IBEGIN, IEND, NPOLY, BASE(10), NPOLZN, NUMBIF, NUMTEL, NUMFRQ,
     *   MAXANO, IACMAX, ACSOUR, REFANT, NPOLTP, SEQOUT, DISOUT, CNOOUT,
     *   LUNOUT, FINDOU, NCHNTP, SCRTCH(512)
      REAL   SOLINT, RTSYS(10), LTSYS(10), RJYDEG, LJYDEG,
     *   BUFOUT(UVBFSL)
      LOGICAL   DOBASE, DOAUTO, DOWRIT, SINGLE
C                                       Template information
      REAL    TPLATE(MAXCIF), TPLMAX
      INTEGER TSIZE, ITPMAX
      LOGICAL DOTBAS
C                                       SN table information
      INTEGER SNKOLS(MAXSNC), SNNUMV(MAXSNC), ISNRNO, NUMNOD, SNVER,
     *   SNLUN, SNBUFF(512)
      REAL    GNMOD
      LOGICAL ISAPPL
      DOUBLE PRECISION RANOD, DECNOD
C
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XXSOUR, XQUAL,
     *   XXCALC, XBAND, XFREQ, XFQID, XTIME, XSUBA, XANT, XNAME2,
     *   XCLAS2, XS2, XD2, XRFANT, XDOCAL, XGUSE, XFLAG, XSOLIN, XDOBAN,
     *   XBPVER, XSMOTH, XBCHAN, XECHAN, APARM, BPARM, CPARM, DPARM,
     *   EPARM, XSNVER, XNAMOU, XCLAOU, XSOUT, XDSOUT, XBADD
      COMMON /ACPARM/ SEQIN, SEQ2, SEQOUT, DISK2, DISKIN, DISOUT, CNOIN,
     *   CNOIN2, CNOOUT, LUNOUT, FINDOU, NCHNTP, SOLINT, RTSYS, LTSYS,
     *   RJYDEG, LJYDEG, PRTLV, IBEGIN, IEND, NPOLY,  NPOLTP, BASE,
     *   NPOLZN, NUMBIF, NUMTEL, NUMFRQ, MAXANO, REFANT, ACSMAX, MINGAN,
     *   MAXGAN, MXGERR, IACMAX, BUFOUT, ACSOUR, DOBASE, DOAUTO, DOWRIT,
     *   SINGLE, SCRTCH
      COMMON /TMPLAT/ TSIZE, ITPMAX, TPLATE, TPLMAX, DOTBAS
      COMMON /CHPARM/ NAMEIN, CLAIN, XSTOK, NAME2, CLAS2, XCALCO,
     *   NAMOUT, CLAOUT
      COMMON /SNPARM/ RANOD, DECNOD, SNBUFF, SNKOLS, SNNUMV, ISNRNO,
     *   NUMNOD, SNVER, SNLUN, GNMOD, ISAPPL
LOCAL END
      PROGRAM ACFIT
C-----------------------------------------------------------------------
C! ACFIT estimates antenna gains from autocorrelation data
C# Calibration Spectral VLA VLB EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2000, 2003-2009, 2011-2012, 2015-2016, 2019,
C;  Copyright (C) 2021-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task:  To create a 'SN' (SOLUTION) table which will contain
C   estimates of the real gains of the antennas. This is done
C   by performing a least-squares fit of a "perfectly calibrated"
C   template spectrum from one antenna to autocorrelation spectra
C   from other antennas. The resultant 'quality factors' are
C   written into an SN table.
C   AIPS Adverbs:
C     INNAME.....Input UV file name (name).      Standard defaults.
C     INCLASS....Input UV file name (class).     Standard defaults.
C     INSEQ......Input UV file name (seq. #).    0 => highest.
C     INDISK.....Disk drive # of input UV file.  0 => any.
C     SOURCES....Source list.  If the data is a multi-source file
C                BPASS will form the cross-power spectrum for the
C                first source specified. If the data is a single
C                source file no source name need be specified.
C     UVRANGE....Range (min, max) of projected baselines to include
C                0,0 => all baselines (units: klamda)
C     TIMERANG...Time range of the data to be selected. In order:
C                Start day, hour, min. sec,
C                end day, hour, min. sec. Days relative to ref.
C                date.
C     BCHAN......First channel to select. 0=>all.
C     ECHAN......Highest channel to select.
C     SUBARRAY...Subarray number to select. 0=>all.
C     ANTENNAS...A list of the antennas to be plotted.
C                If any number is negative then all antennas listed
C                are NOT to be selected and all others are.
C                                      CLEAN map (optional)
C     IN2NAME....Cleaned map name (name)
C     IN2CLASS...Cleaned map name (class)
C     IN2SEQ.....Cleaned map name (seq. #)
C     IN2DISK....Cleaned map disk unit #
C     INVERS.....CC file version #.
C     NCOMP......# comps to use for model.
C                1 value per field
C     NMAPS......No. Clean map files
C     SMODEL.....Source model to use instead of CLEAN map
C     DOCALIB....If true (>0) then calibrate the data using
C                information in the specified Cal (CL or SN).
C     GAINUSE....version number of the CL table to apply to
C                multisource files or the SN table for single
C                source files.  0 => highest.
C     FLAGVER....specifies the version of the flagging table to be
C                applied. 0 => highest numbered table.
C                <0 => no flagging to be applied.
C     SOLINT.....the interval over which to average the data
C                before solving for the bandpasses. (0 => scan)
C     BPVER......the version of the BP table to fill. (0 => 1)
C     SMOOTH.....Smoothing function.
C     ANTWT......Antenna weights for up to 30 antennas. (0=>1.0)
C     APARM......Control parameters
C     BADDISK....A list of disks on which scratch files are not to
C                be placed.  This will not affect the output file.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ACFIT.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'ACFIT '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL ACFTIN (PRGM, IRET)
      IF ( IRET.NE.0 ) GO TO 990
C                                       Read data and estimate gains
      CALL ESTGAN (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Write history
      CALL ACFHIS
C
 990  CALL DIE (IRET, SCRTCH)
C
      STOP
      END
      SUBROUTINE ACFTIN (PRGN, JERR)
C-----------------------------------------------------------------------
C  ACFTIN gets input parameters for ACFIT and finds input file.
C  All selection criteria are filled into commons in D/CSEL.INC
C
C  Inputs:
C      PRGN      C*6)     Program name (2chars/word)
C  Outputs:
C      JERR      I        Error code : 0 => OK
C                                      5 => catalog troubles
C                                      8 => can't start
C-----------------------------------------------------------------------
      CHARACTER  STAT*4, PRGN*6, UTYPE*2
      INTEGER  NPARM, IROUND, IERR, IRET, I, IUSER, LUNTB, LUNAN,
     *   CAT2(256), LUNTPL, FRQID2, LUN, TBASE(10), NUMANS(513), JERR,
     *   NPLIM
      REAL   CATR(256)
      LOGICAL   T, F, TABLE, MULTI, FITASC, MATCH
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ACFIT.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATR,CATBLK)
      DATA T, F /.TRUE.,.FALSE./
      DATA LUNTB, LUNAN, LUNTPL /29, 27, 30/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      TSKNAM = PRGN
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 278
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRTCH, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
      WRITE (MSGTXT,4000)
      CALL MSGWRT (2)
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XXCALC, XCALCO)
      CALL H2CHR (12, 1, XNAME2, NAME2)
      CALL H2CHR (6, 1, XCLAS2, CLAS2)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      SEQ2  = IROUND (XS2)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISK2  = IROUND (XD2)
      DISOUT = IROUND (XDSOUT)
      IUSER = NLUSER
      SNVER = IROUND (XSNVER)
      REFANT = IROUND (XRFANT)
C                                        Baseline-independent fit ?
      DOAUTO = APARM(9) .GT. 0
      IF (DOAUTO) THEN
         WRITE (MSGTXT,1020)
         CALL MSGWRT (6)
         END IF
C                                       Write out baseline corrected
C                                       autocorrelations?
      DOWRIT = APARM(10).GT.0
      IF (DOAUTO) DOWRIT = .FALSE.
      IF (DOWRIT) THEN
         WRITE (MSGTXT,1110)
         CALL MSGWRT (6)
         END IF
C                                       Get CATBLK etc for template
C                                       file
      CNOIN2 = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISK2, CNOIN2, NAME2, CLAS2, SEQ2, UTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAME2, CLAS2, SEQ2, DISK2,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISK2, CNOIN2, CATBLK, 'REST', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISK2, CNOIN2, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, IERR)
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1070)
         IERR = 1
         GO TO 990
         END IF
      IF (IERR.GT.0) GO TO 999
      FRQID2 = FRQSEL
C                                       Get the template
      CALL COPY (256, CATBLK, CAT2)
      CALL COPY (256, CATBLK, CATUV)
      NPOLTP = MAX (IROUND (APARM(2)), 0)
      DOTBAS = F
      DO 150 I = 1, 10
         TBASE(I) = IROUND(CPARM(I))
         IF (TBASE(I).GT.0) DOTBAS = T
 150     CONTINUE
      NPOLZN = 1
      IF (NCOR.GT.1) NPOLZN = 2
      CALL GETTPL (TBASE, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1050) IERR
         GO TO 990
         END IF
C                                       Get CATBLK from main file.
      CALL SELINI
      CNOIN = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'REST', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Determine if multi-source file
      CALL MULSDB (CATBLK, MULTI)
      IF (MULTI) THEN
         CALL ISTAB ('SU', DISKIN, CNOIN, 1, LUNTB, SCRTCH, TABLE,
     *      MULTI, FITASC, IERR)
         MULTI = MULTI .AND. (IERR.EQ.0)
         END IF
      SINGLE = .NOT. MULTI
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Check channel compatibility
      IF (NCHNTP.NE.CATBLK(KINAX+JLOCF)) THEN
         WRITE (MSGTXT,1010) NCHNTP
         CALL MSGWRT (6)
         WRITE (MSGTXT,1015) CATBLK(KINAX+JLOCF)
         JERR = 1
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, IERR)
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1080)
         IERR = 1
         GO TO 990
         END IF
      IF (IERR.GT.0) GO TO 999
      IF ((FRQSEL.NE.FRQID2).AND.(FRQID2.GT.0)) THEN
         WRITE (MSGTXT,1090) FRQSEL, FRQID2
         IERR = 1
         GO TO 990
         END IF
C                                       BADDISK
      DO 10 I = 1,10
         IBAD(I) = IROUND (XBADD(I))
 10      CONTINUE
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DO 20 I= 1,30
         CALSOU(I) = ' '
         CALL H2CHR (16, 1, XXSOUR(1,I), SOURCS(I))
 20      CONTINUE
      SELQUA = IROUND (XQUAL)
      SELCOD = XCALCO
      CALL RCOPY (8, XTIME, TIMRNG)
      DO 30 I = 1,50
         ANTENS(I) = IROUND (XANT(I))
 30      CONTINUE
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = MAX (1, MIN (BIF, CATBLK(KINAX+JLOCIF)))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         EIF = MAX (1, MIN (EIF, CATBLK(KINAX+JLOCIF)))
         END IF
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOAPPL = F
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.EQ.0) SUBARR = 1
      FGVER = IROUND (XFLAG)
      CLUSE = IROUND (XGUSE)
      DXTIME = 0.0
      DOBAND = IROUND(XDOBAN)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
C                                       Channel range to fit
      IBEGIN = IROUND (XBCHAN)
      IBEGIN = MAX (1, MIN (IBEGIN, CATBLK(KINAX+JLOCF)))
      IEND = IROUND (XECHAN)
      IF (IEND.LT.IBEGIN) IEND = CATBLK(KINAX+JLOCF)
      IEND = MAX (1, MIN (IEND, CATBLK(KINAX+JLOCF)))
C                                        Solution interval
      IF (XSOLIN.LT.0.0) THEN
         SOLINT = 0.0
      ELSE
         SOLINT = XSOLIN / (24.0 * 60.0)
         END IF
C                                       Default multisource = scan
      IF ((.NOT.SINGLE) .AND. (SOLINT.LE.1.0E-10)) SOLINT = 1.0
      IF (SOLINT.LT.1.0E-10) SOLINT = 1.0E10
C                                        Use autocorrelations only
      DOACOR = T
      DOXCOR = F
C                                        Print level
      PRTLV = IROUND (APARM(8))
C                                       Tsys, gain
      DO 45 I = 1, 10
         RTSYS(I) = DPARM(I)
         IF (RTSYS(I) .LE. 0.0) RTSYS(I) = 1.0
         LTSYS(I) = EPARM(I)
         IF (LTSYS(I) .LE. 0.0) LTSYS(I) = 1.0
   45 CONTINUE
      RJYDEG = APARM(3)
      LJYDEG = APARM(4)
      IF (RJYDEG.LE.0.0) RJYDEG = 1.0
      IF (LJYDEG.LE.0.0) LJYDEG = 1.0
C                                       Max,Min allowed gains
      MINGAN = APARM(5)
      MAXGAN = APARM(6)
      IF (MAXGAN.EQ.0.0) MAXGAN = 1.0E10
      MXGERR = APARM(7)
C                                       Polynomial fitting
      NPOLY = MAX (IROUND (APARM(1)), 0)
C                                        Check degree for baseline-
C                                       independent fit.
      IF (DOAUTO) THEN
         NPLIM = IEND - IBEGIN - 3
         NPLIM = MIN (NPLIM, 24)
         IF (NPOLY.GT.NPLIM) THEN
            NPOLY = NPLIM
            WRITE (MSGTXT,1100) NPOLY
            CALL MSGWRT (6)
            END IF
         END IF
C
      DOBASE = F
      DO 50 I = 1, 10
         BASE(I) = IROUND(BPARM(I))
         IF (BASE(I).GT.0) DOBASE = T
 50      CONTINUE
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATUV)
      LUNAN = 27
      CALL GETNAN (DISKIN, CNOIN, CATBLK, LUNAN, SCRTCH, NUMANS, IRET)
      NUMTEL = NUMANS(2)
      GO TO 999
C
 990  CALL MSGWRT (8)
      IF (JERR.EQ.0) JERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ACFTIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('ACFTIN: TEMPLATE HAS ',I4,' CHANNELS')
 1015 FORMAT ('ACFTIN: MAIN FILE HAS ',I4,' CHANNELS - INCOMPATIBLE')
 1020 FORMAT ('Baseline-independent fit; ignoring BPARM & CPARM')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' OBTAINING TEMPLATE SPECTRUM')
 1070 FORMAT ('NO MATCH TO FQ ADVERBS IN TEMPLATE FILE - CHECK INPUTS')
 1080 FORMAT ('NO MATCH TO FQ ADVERBS IN DATA FILE - CHECK INPUTS')
 1090 FORMAT ('FRQSEL IN DATA = ',I2,', IN TEMPLATE = ',I2)
 1100 FORMAT ('ACFTIN: NPOLY too large; reduced to ',I4)
 1110 FORMAT ('Will write out baseline-corrected autocorrelations')
 4000 FORMAT ('You are using a non-standard program')
      END
      SUBROUTINE ESTGAN (IRET)
C-----------------------------------------------------------------------
C   Routine to read data, apply any requested calibration, average
C   over selected time interval, fit template spectra to A/C data
C   and then write results of fitting into SN table.
C-----------------------------------------------------------------------
      INTEGER IRET
C
      LOGICAL EOF
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ACFIT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:PSTD.INC'
C                                       Parameters for arrays
C                                       256*28*2*3+eps
      INTEGER BIGSIZ
      PARAMETER (BIGSIZ=3*MAXCIF)
      INTEGER   ANTLAB(MAXANT), TIME(8), SCANUM, I, J, VISSIZ, IANT,
     *   NODENO, IDUM, IPOL, IIF, TIT(4), LUNSO, L, NNSOU, NIO,
     *   IREFA(2,MAXIF), VISOFF, BIND, LENBU, LRECO, BO, NOUT, KBUFSZ,
     *   NONOT, KEYLOC, KEYTYP, ORIGIN, NUMKEY, MXANT
      LONGINT   VISOO, KLONG
      REAL      VISOUT(2), BFIT(11), RPARM(20), VIS(BIGSIZ),
     *   GFACT(MAXANT,MAXIF,2), GERR(MAXANT,MAXIF,2), DISP(2), DDISP(2),
     *   CONST(MAXANT,MAXIF,2), CONERR(MAXANT,MAXIF,2), MBDELY(2),
     *   GREAL(2,MAXIF), GIMAG(2,MAXIF), GDELA(2,MAXIF), GRATE(2,MAXIF),
     *   GWT(2,MAXIF), RIFR, PRTIME, HAT, EL, TEMP, SOLACT, AZ
      DOUBLE PRECISION AVTIME(MAXANT), TIMRA(2), AVTMAX, JD0, DRA, DDEC
      HOLLERITH CATH(256)
      EQUIVALENCE (CATBLK, CATH)
      CHARACTER CTEMP*12, UTYPE*2, STAT*4, REASON*12, NAME*48,
     *   NOTTYP(5)*2
      LOGICAL   T, F, FIRST, NUSCAN, HAVFIT(2,MAXIF), CHSTAT, ALLFLG,
     *   PLANET
      DATA T, F /.TRUE., .FALSE./
      DATA MXANT /MAXANT/, RIFR /0.0/, LUNSO /49/, NODENO /0/
      DATA MBDELY, DISP, DDISP /6*0.0/
      DATA NONOT, NOTTYP /5, 'NX', 'SN', 'CL', 'BP', 'SU'/
C-----------------------------------------------------------------------
      I = REFANT
      I = MAX (1, I)
      J = 2 * MAXIF
      CALL FILL (J, I, IREFA)
C                                       Purge old SN table
      IF (SNVER.GT.0) THEN
C                                       Determine NSOUWD & NANTSL
         CALL UVGET ('INIT', RPARM, VIS, IRET)
         IF (IRET.GT.0) GO TO 990
         CALL UVGET ('CLOS', RPARM, VIS, IRET)
         IF (IRET.GT.0) GO TO 990
         NNSOU = NSOUWD
         TIMRA(1) = XTIME(1) + XTIME(2) / 24.0 + XTIME(3) / (24.0*60.0)
     *      + (XTIME(4) / (24.0*60.0*60.0))
         TIMRA(2) = XTIME(5) + XTIME(6) / 24.0 + XTIME(7) / (24.0*60.0)
     *      + (XTIME(8) / (24.0*60.0*60.0))
         IF ((TIMRA(2).LT.TIMRA(1)) .OR. (TIMRA(2).LT.1.0E-5))
     *      TIMRA(2) = 1.0E20
         CALL CALSEL (DISKIN, CNOIN, 'SN', SNVER, CATUV, SNBUFF, NNSOU,
     *      SOUWAN, DOSWNT, NANTSL, ANTENS, DOAWNT, TIMRA, SUBARR,
     *      FRQSEL, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Init. file reading
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.GT.0) GO TO 990
C                                       Create output file if
C                                       needed
      IF (DOWRIT) THEN
         CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT,
     *      CLAOUT, SEQOUT)
         CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
         CATBLK(KIIMS) = SEQOUT
         CCNO = 1
         FRW(NCFILE+1) = 3
         CALL UVCREA (DISOUT, CCNO, SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1120) IRET
            CALL MSGWRT (8)
            GO TO 999
            END IF
         CNOOUT = CCNO
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISOUT
         FCNO(NCFILE) = CCNO
         FRW(NCFILE) = FRW(NCFILE) - 1
C                                       copy keywords
         CALL KEYCOP (DISKIN, CNOIN, DISOUT, CCNO, IRET)
C                                       Open output file.
         LUNOUT = 18
         CALL ZPHFIL ('UV', DISOUT, CNOOUT, 1, NAME, IRET)
         CALL ZOPEN (LUNOUT, FINDOU, DISOUT, NAME, T, F, T, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1130) IRET
            GO TO 990
            END IF
C                                       Init output vis file for write
         LENBU = 1
         LRECO = LREC
         KBUFSZ = UVBFSL
         BO = 1
         NOUT = 0
         CALL UVINIT ('WRIT', LUNOUT, FINDOU, CATBLK(KIGCN),
     *      VISOFF, LRECO, LENBU, KBUFSZ, BUFOUT, BO, BIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1140) IRET
            GO TO 990
            END IF
         END IF
C                                       Determine # polzns, antennas,
C                                       IF's and frequency channels
      NUMFRQ = CATUV(KINAX+KLOCFY)
      NUMBIF = CATUV(KINAX+KLOCIF)
C                                       Change status to 'writ'
C                                       Determine status of file
      UTYPE = 'UV'
      CHSTAT = .FALSE.
      CALL CATDIR ('INFO', IUDISK, IUCNO, CTEMP, CTEMP, IDUM, UTYPE,
     *   IDUM, STAT, SCRTCH, IRET)
C                                       Change status
      IF (STAT.EQ.'READ') THEN
         STAT = 'CLRD'
         CALL CATDIR ('CSTA', IUDISK, IUCNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLRD'
            GO TO 990
            END IF
         STAT = 'WRIT'
         CALL CATDIR ('CSTA', IUDISK, IUCNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRIT'
            GO TO 990
            END IF
         CHSTAT = .TRUE.
         END IF
C                                       Create SN table
      ISAPPL = F
      GNMOD = 1.0
      RANOD = 0.D0
      DECNOD = 0.D0
      SNLUN = 48
      CALL SNINI ('WRIT', SNBUFF, IUDISK, IUCNO, SNVER, CATUV, SNLUN,
     *   ISNRNO, SNKOLS, SNNUMV, NUMTEL, NPOLZN, NUMBIF, NUMNOD,
     *   GNMOD, RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.GT.0) GO TO 990
      WRITE (MSGTXT,1010) SNVER
      CALL MSGWRT (6)
C                                       Add the ORIGIN keyword
      KEYLOC = 1
      KEYTYP = 4
      ORIGIN = 0
      NUMKEY = 1
      IF (SINGLE) ORIGIN = 1
      CALL TABKEY ('WRIT', 'SNORIGIN', NUMKEY, SNBUFF, KEYLOC, ORIGIN,
     *   KEYTYP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1015) IRET
         GO TO 990
         END IF
C                                       Check if changed status
      IF (CHSTAT) THEN
         STAT = 'CLWR'
         CALL CATDIR ('CSTA', IUDISK, IUCNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLWR'
            GO TO 990
            END IF
         STAT = 'READ'
         CALL CATDIR ('CSTA', IUDISK, IUCNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ'
            GO TO 990
            END IF
         END IF
C                                       Set up ANTLAB array
      CALL LABSET (ANTLAB, IRET)
      IF (IRET.GT.0) GO TO 990
C                                       Message
      IF (NPOLZN.EQ.1) THEN
         WRITE (MSGTXT,1044) RJYDEG
         CALL MSGWRT (4)
         WRITE (MSGTXT,1039) (RTSYS(I), I=1,8)
         CALL MSGWRT (4)
         END IF
      IF (NPOLZN.GT.1) THEN
         WRITE (MSGTXT,1040) (RTSYS(I), I=1,8)
         CALL MSGWRT (4)
         WRITE (MSGTXT,1041) (LTSYS(I), I=1,8)
         CALL MSGWRT (4)
         WRITE (MSGTXT,1045) RJYDEG
         CALL MSGWRT (4)
         WRITE (MSGTXT,1046) LJYDEG
         CALL MSGWRT (4)
         END IF
      IF (DOBAND.GT.0) THEN
         WRITE (MSGTXT,1100)
         CALL MSGWRT (4)
         END IF
C                                       If PRTLV>1 need some source
C                                       and antenna info.
      IF (PRTLV.GT.1) THEN
         CALL GETANT (DISKIN, CNOIN, SUBARR, CATUV, SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1050) IRET
            GO TO 990
            END IF
         END IF
C                                       Read data, calibrate and
C                                       average over specified
C                                       time interval
      EOF = F
      FIRST = T
      SCANUM = -1
C                                       dynamic array for averaging
      VISSIZ = 3 * NCOR * NUMBIF * NUMFRQ
      IANT = VISSIZ * MAXANO
      IANT = (IANT - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', 'ESTGAN',  IANT, VISOUT, VISOO, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO ALLOCATE ENOUGH MEMORY, SORRY'
         CALL MSGWRT (8)
         GO TO 999
         END IF

 100  CALL DATAVG (ANTLAB, FIRST, SOLINT, NUMBIF, NUMFRQ, VISSIZ,
     *   MAXANO, VISOUT(1+VISOO), AVTIME, SOLACT, TIME, NUSCAN, SCANUM,
     *   ACSOUR, RPARM, VIS, IRET)
      IF (IRET.GT.0) GO TO 990
      IF (IRET.LT.0) EOF = T
      AVTMAX = 0.0D0
      DO 110 I = 1,MAXANO
         AVTMAX = MAX (AVTMAX, AVTIME(I))
 110     CONTINUE
      IF (EOF .AND. (AVTMAX.EQ.0.D0)) GO TO 800
C                                       Loop over antennas to do
C                                       the fitting.
      DO 500 I = 1,MAXANO
C                                       Find antenna number
         IANT = 0
         DO 150 J = 1,MXANT
            IF (I.EQ.ANTLAB(J)) IANT = ANTLAB(J)
 150        CONTINUE
         IF (IANT.EQ.0) GO TO 500
C                                       Copy data to small array
         KLONG = 1 + VISOO + (IANT-1) * VISSIZ
C                                       Fit with template
         IF (DOAUTO) THEN
            CALL AUTOFT (NUMFRQ, NUMBIF, NPOLZN, VISOUT(KLONG), TPLATE,
     *         NPOLY, IBEGIN, IEND, I, MINGAN, MAXGAN, GFACT, GERR,
     *         HAVFIT, ACSMAX, IACMAX, IRET)
         ELSE
            CALL DOACFT (NUMFRQ, NUMBIF, NPOLZN, VISOUT(KLONG), TPLATE,
     *         NPOLY, BASE, DOBASE, IBEGIN, IEND, I, MINGAN, MAXGAN,
     *         GFACT, GERR, CONST, CONERR, HAVFIT, ACSMAX, IACMAX, BFIT,
     *         IRET)
            END IF
         REASON = 'BAD SOLUTION'
C                                       If desired write out the
C                                       corrected data
         IF (DOWRIT) THEN
            BUFOUT(BIND+ILOCU) = 0.0
            BUFOUT(BIND+ILOCV) = 0.0
            BUFOUT(BIND+ILOCW) = 0.0
            IF (ILOCB.GE.0) THEN
               BUFOUT(BIND+ILOCB) = I + 256*I
            ELSE
               BUFOUT(BIND+ILOCA1) = I
               BUFOUT(BIND+ILOCA2) = I
               BUFOUT(BIND+ILOCSA) = 1
               END IF
            BUFOUT(BIND+ILOCT) = AVTIME(I)
            CALL RCOPY (VISSIZ, VISOUT(KLONG), BUFOUT(BIND+NRPARM))
            NIO = 1
            NOUT = NOUT + 1
            CALL UVDISK ('WRIT', LUNOUT, FINDOU, BUFOUT, NIO, BIND,
     *         IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1150) IRET
               GO TO 990
               END IF
            END IF
C                                       Write the SN entry
         ALLFLG = T
         DO 400 IPOL = 1,NPOLZN
            DO 300 IIF = 1,NUMBIF
               IF (PRTLV.GT.0) THEN
C                                       Write a message
                  PRTIME = AVTIME(I)
                  CALL TODHMS (PRTIME, TIT)
C                                       Check percentage error
                  IF (MXGERR.GT.0.0) THEN
                     IF (HAVFIT(IPOL,IIF)) THEN
                        TEMP = GERR(I,IIF,IPOL) /
     *                     GFACT(I,IIF,IPOL)
                        TEMP = TEMP * 100.0
                        IF (TEMP.GT.MXGERR) THEN
                           HAVFIT(IPOL,IIF) = .FALSE.
                           GFACT(I,IIF,IPOL) = FBLANK
                           GERR(I,IIF,IPOL) = FBLANK
                           REASON = 'LARGE ERROR'
                           END IF
                        END IF
                     END IF
                  IF (HAVFIT(IPOL,IIF)) THEN
                     WRITE (MSGTXT,1020) TIT, IPOL, IIF, I,
     *                  GFACT(I,IIF,IPOL), GERR(I,IIF,IPOL)
                     CALL MSGWRT (4)
                     IF (IPOL.EQ.1) THEN
                        TEMP = SQRT (GFACT(I,IIF,IPOL) * RTSYS(IIF)
     *                     * RJYDEG)
                     ELSE IF (IPOL.EQ.2) THEN
                        TEMP = SQRT (GFACT(I,IIF,IPOL) * LTSYS(IIF)
     *                     * LJYDEG)
                        END IF
                     WRITE (MSGTXT,1021) TEMP
                  ELSE
                     WRITE (MSGTXT,1025) TIT, IPOL, IIF, I,
     *                  REASON
                     END IF
                  CALL MSGWRT (4)
                  IF (PRTLV.GT.1) THEN
                     CALL JULDAY (RDATE, JD0)
                     PRTIME = AVTIME(I)
                     CALL FNDCOO (0, JD0, ACSOUR, DISKIN, CNOIN, CATUV,
     *                  LUNSO, PRTIME, DRA, DDEC, PLANET, IRET)
C                    CALL GETSOU (ACSOUR, DISKIN, CNOIN, CATUV, LUNSO,
C    *                  IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1060) IRET
                        GO TO 990
                        END IF
                     CALL COOELV (I, AVTIME(I), DRA, DDEC, HAT, EL, AZ)
                     EL = EL * RAD2DG
                     IF (DOAUTO) THEN
                        WRITE (MSGTXT,1032) EL
                     ELSE
                        WRITE (MSGTXT,1030) CONST(I,IIF,IPOL),
     *                     CONERR(I,IIF,IPOL), EL
                        END IF
                     CALL MSGWRT (4)
                     WRITE (MSGTXT,1070) TPLMAX, ITPMAX,
     *                  ACSMAX, IACMAX
                     CALL MSGWRT (4)
                     IF (.NOT.DOAUTO)WRITE(MSGTXT,1080)(BFIT(L),L=1,5)
                     CALL MSGWRT (4)
                     IF (.NOT.DOAUTO)WRITE(MSGTXT,1090)(BFIT(L),L=6,11)
                     CALL MSGWRT (4)
                     END IF
                  END IF
               IF (HAVFIT(IPOL,IIF)) THEN
C                                       Store the gain
                  IF (IPOL.EQ.1) THEN
                     GREAL(IPOL,IIF) =
     *                  SQRT (GFACT(I,IIF,IPOL) * RTSYS(IIF) * RJYDEG)
                  ELSE IF (IPOL.EQ.2) THEN
                     GREAL(IPOL,IIF) =
     *                  SQRT (GFACT(I,IIF,IPOL) * LTSYS(IIF) * LJYDEG)
                     END IF
                  IF (GERR(I,IIF,IPOL).GT.0.0) THEN
                     GWT(IPOL,IIF) = 1. / GERR(I,IIF,IPOL)
                  ELSE
                     GWT(IPOL,IIF) = 1000.0
                     END IF
                  IF (GERR(I,IIF,IPOL).EQ.FBLANK)
     *                  GWT(IPOL,IIF) = 0.0
                  ALLFLG = F
                  GIMAG(IPOL,IIF) = 0.0
                  GDELA(IPOL,IIF) = 0.0
                  GRATE(IPOL,IIF) = 0.0
C                                       No gain solution
               ELSE
                  GREAL(IPOL,IIF) = FBLANK
                  GIMAG(IPOL,IIF) = FBLANK
                  GDELA(IPOL,IIF) = FBLANK
                  GRATE(IPOL,IIF) = FBLANK
                  GWT(IPOL,IIF) = FBLANK
                  END IF
 300           CONTINUE
 400        CONTINUE
         IF (.NOT.ALLFLG)
     *      CALL TABSN ('WRIT', SNBUFF, ISNRNO, SNKOLS, SNNUMV,
     *         NPOLZN, AVTIME(I), SOLACT, ACSOUR, I, SUBARR, FRQSEL,
     *         RIFR, NODENO, MBDELY, DISP, DDISP, GREAL, GIMAG, GDELA,
     *         GRATE, GWT, IREFA, IRET)
         CALL RFILL (11, 0.0, BFIT)
 500     CONTINUE
      IF (PRTLV.GE.1) THEN
         WRITE (MSGTXT,1110)
         CALL MSGWRT (4)
         END IF
C                                       End?
 800  IF (.NOT. EOF) GO TO 100
      CALL TABIO ('CLOS', 0, ISNRNO, SNBUFF, SNBUFF, IRET)
C                                       Flush output
      IF (DOWRIT) THEN
         NIO = 0
         CALL UVDISK ('FLSH', LUNOUT, FINDOU, BUFOUT, NIO, BIND,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1160) IRET
            GO TO 990
            END IF
C                                       Compress output file.
         NVIS = NOUT + VISOFF
         CALL UCMPRS (NVIS, DISOUT, CNOOUT, LUNOUT, CATBLK, IRET)
C                                       Put vis. count in CATBLK
         CATBLK(KIGCN) = NVIS
C                                        Copy tables
         IF (ILOCSU.GE.0) NONOT = NONOT - 1
         CALL ALLTAB (NONOT, NOTTYP, IULUN, LUNOUT, IUDISK, DISOUT,
     *      IUCNO, CNOOUT, CATBLK, SCRTCH, BUFOUT, IRET)
         IF (IRET.GT.2) THEN
            WRITE (MSGTXT,1200)
            CALL MSGWRT (6)
            END IF
C                                        Update CATBLK.
         CALL CATIO ('UPDT', DISOUT, CNOOUT, CATBLK, 'REST',
     *      SCRTCH, IRET)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ESTGAN: ERROR ',I3,' CHANGING ',A4,' STATUS')
 1010 FORMAT ('ESTGAN: Writing SN table version ',I3)
 1015 FORMAT ('ESTGAN: ERROR ',I3,' WRITING ORIGIN KEYWORD TO SN TABLE')
 1020 FORMAT (I3,'/',3I3,' Pol:',I1,' IF:',I2,' Ant:',I2,
     *   ' Gain = ',F8.3,' +/- ',F10.3)
 1021 FORMAT (23X,'SN value: Gain = ',F8.3)
 1025 FORMAT (I3,'/',3I3,' Pol:',I1,' IF:',I2,' Ant:',I2,
     *   ' Gain = FLAGGED: ',A)
 1030 FORMAT (10X,' Offset = ',F8.5,' +/- ',F8.5,' El: ',F4.1)
 1032 FORMAT (10X,'El: ',F4.1)
 1070 FORMAT (10X,' Template max = ',F7.2,1X,I3,
     *   ' Scan max = ',F7.2,1X,I3)
 1080 FORMAT ('Poly coeffs: ',5(1X,F8.5))
 1090 FORMAT (4X,6(1X,F8.5))
 1039 FORMAT ('Tsys = ',8F6.1,';')
 1040 FORMAT ('Rpol Tsys = ',8F6.1,';')
 1041 FORMAT ('Lpol Tsys = ',8F6.1,';')
 1044 FORMAT ('JY/DEG = ',F5.2)
 1045 FORMAT ('Rpol JY/DEG =', F5.2)
 1046 FORMAT ('Lpol JY/DEG =', F5.2)
 1050 FORMAT ('ESTGAN: ERROR ',I3,' GETTING ANTENNA INFORMATION')
 1060 FORMAT ('ESTGAN: ERROR ',I3,' GETTING SOURCE INFORMATION')
 1100 FORMAT ('Applying bandpass corrections to data before fitting')
 1110 FORMAT ('----------------------------------------------------')
 1120 FORMAT ('ESTGAN: ERROR',I3,' CREATING OUTPUT FILE')
 1130 FORMAT ('ESTGAN: ERROR',I3,' OPENING OUTPUT FILE')
 1140 FORMAT ('ESTGAN: ERROR',I5,' INIT. OUTPUT FILE')
 1150 FORMAT ('ESTGAN: ERROR',I5,' WRITING OUTPUT FILE')
 1160 FORMAT ('ESTGAN: ERROR',I5,' FLUSHING OUTPUT FILE')
 1200 FORMAT ('ESTGAN: ERROR COPYING TABLES')
      END
      SUBROUTINE LABSET (ANTLAB, IRET)
C-----------------------------------------------------------------------
C   Routine to set up the antenna selection array; checks that data in
C   "TB" order and prepares the list of antennas (ANTENS) for UVGET that
C   includes all antennas mentioned in either XANT or XBASE.
C   Also checks allowed Stokes types.
C   Input from common:
C      ISORT              C    Two char. sort order, must be 'TB'
C      XANT(*)            R    Antenna array
C      XBASE(*)           R    Baseline array
C   Output:
C      ANTLAB(MAXANT)     I    The antenna number selected
C      IRET               I    Return code, 0=OK, else failed
C   Output in Common:
C      ANTENS(*)          I    Selected antenna numbers
C-----------------------------------------------------------------------
      INTEGER   IRET, I, NEXT, IARG, MXANT, IROUND, J, NOSEL, NUMAN(51),
     *   NOANT, IANT1, LUN
      LOGICAL   T, ALLANT, DESEL
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ANTLAB(MAXANT)
      INCLUDE 'ACFIT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA T /.TRUE./
      DATA MXANT /MAXANT/
C-----------------------------------------------------------------------
      IRET = 0
C                                       Check sort order
      IF (ISORT.NE.'TB') THEN
         IRET = 1
         WRITE (MSGTXT,1030) ISORT
         GO TO 990
         END IF
C                                       Check for all ant. selected
      ALLANT = T
      DO 100 I = 1,50
         ANTENS(I) = 0
         ALLANT = ALLANT .AND. (ABS (XANT(I)).LE.1.0E-10)
 100     CONTINUE
C                                       Not all selected - make list
      DESEL = .FALSE.
      IF (.NOT.ALLANT) THEN
         NEXT = 1
C                                       ANTENNAS array.
         DO 120 I = 1,50
            IARG = IROUND (XANT(I))
            IF (IARG.NE.0) THEN
               IF (IARG.LT.0) DESEL = .TRUE.
               ANTENS(NEXT) = IARG
               NEXT = NEXT + 1
               END IF
 120        CONTINUE
         NOSEL = NEXT - 1
         END IF
C                                       Fill ANTLAB with antenna
C                                       numbers.
      CALL FILL (MXANT, 0, ANTLAB)
C                                       Find number of antennas
      LUN = 44
      CALL GETNAN (DISKIN, CNOIN, CATUV, LUN, SCRTCH, NUMAN, IRET)
      IF ((IRET.NE.0) .OR. (NUMAN(1).LT.SUBARR)) THEN
         IF (NUMAN(1).LE.SUBARR) WRITE (MSGTXT,1510) NUMAN(1),
     *      SUBARR
         IF (IRET.NE.0) WRITE (MSGTXT,1511) IRET
         IRET = 2
         GO TO 990
         END IF
      NOANT = NUMAN(SUBARR+1)
      IF (SUBARR.LE.0) NOANT = NUMAN(2)
C                                       Fill  arrays
      MAXANO = 0
      NEXT = 0
      IF (DESEL) THEN
         DO 550 I = 1,NOANT
            DO 540 J = 1,NOSEL
               IF (I.EQ.ABS(ANTENS(J))) GO TO 550
 540           CONTINUE
            NEXT = NEXT + 1
            ANTLAB(NEXT) = I
            MAXANO = MAX (MAXANO, I)
 550        CONTINUE
      ELSE
         DO 560 I = 1,50
            IF (ALLANT) THEN
               IANT1 = I
            ELSE
               IANT1 = ANTENS(I)
               END IF
            IF ((IANT1.GT.0) .AND. (IANT1.LE.NOANT)) THEN
               NEXT = NEXT + 1
               ANTLAB(NEXT) = IANT1
               MAXANO = MAX (MAXANO, IANT1)
               END IF
 560        CONTINUE
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('INCORRECT SORT ORDER = ',A2,' NOT TB')
 1510 FORMAT ('FEWER SUBARRAYS AVAILABLE (',I3,') THAN SPECIFIED ',I4)
 1511 FORMAT ('COLSET: GETNAN ERROR ',I3,' SEARCHING ANTENNA TABLES')
      END
      SUBROUTINE DOACFT (NUMFRQ, NUMBIF, NPOLZN, VIS, TPLATE, NPOLY,
     *   IBASE, DOBASE, IBEGIN, IEND, ANT, MINGAN, MAXGAN, GFACT, GERR,
     *   CONST, CONERR, HAVFIT, ACSMAX, IACMAX, BFIT, IRET)
C-----------------------------------------------------------------------
C  Routine determines antenna gain factors by fitting a template
C  autocorrelation spectrum to spectra from all antennas.
C
C  Inputs:
C    NUMFRQ             I         # channels in spectrum
C    VIS (*)            R         Autocorrelation spectrum
C    TPLATE(*)          R         Template spectrum
C    NPOLY              I         Degree of polynomial to be
C                                 removed before fitting
C    IBASE(2,5)         I         Array of start and stop channel
C                                 numbers specifying the channels
C                                 to be used for baseline fitting
C    DOBASE             L         .TRUE. if baseline fitting
C    IBEGIN             I         Start channel for AC fitting
C    IEND               I         End channel for AC fitting
C    ANT                I         Antenna being fitted
C    MINGAN             R         Minimum acceptable gain
C    MAXGAN             R         Maximum acceptable gain
C
C  Outputs:
C    GFACT(*,*,*)       R         Gain factor for each antenna, IF,
C                                 polzn
C    GERR(*,*,*)        R         Associated error
C    CONST(*,*,*)       R         Constant offset for each antenna,IF,
C                                 polzn
C    CONERR(*,*,*)      R         Associated error
C    HAVFIT(4,MAXIF)    L         .TRUE. if fit succesful
C    ACSMAX             R         Max value in spectrum
C    IACMAX             I         Channel of max value
C    BFIT(11)           R         Array containing polynomial
C                                 removed from data
C    IRET               I         Error code, 0 => OK
C
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER NUMFRQ, NPOLY, IBASE(2,5), IBEGIN, IEND, IRET, ANT,
     *   IACMAX, NPOLZN, NUMBIF
      REAL    VIS(*), TPLATE(MAXCIF), ACSMAX, BFIT(11), MINGAN, MAXGAN
      LOGICAL HAVFIT(2,MAXIF)
      REAL    GFACT(MAXANT,MAXIF,2), GERR(MAXANT,MAXIF,2),
     *   CONST(MAXANT,MAXIF,2), CONERR(MAXANT,MAXIF,2)
C
      INTEGER IB0, IE0, INDEX, INP, I, LOOPS, LOOPIF, NFLAG, INX
      REAL    SCALE, ESCALE, CNSTNT, ECONST, RHO, SIGSQ,
     *   ACSPEC(MAXCHA), TPLSPC(MAXCHA), INVSC
      LOGICAL DOBASE
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
      ACSMAX = -1.0E10
C                                       Check defaults on channel
C                                       fitting range
      IB0 = IBEGIN
      IF (IBEGIN .EQ. 0)  IB0 = 5
      IE0 = IEND
      IF (IEND .EQ. 0)  IE0 = NUMFRQ - 5
C                                       Loop over IF's, polzns
      INX = 0
      DO 300 LOOPS = 1,NPOLZN
         DO 200 LOOPIF = 1,NUMBIF
            HAVFIT(LOOPS,LOOPIF) = .FALSE.
            NFLAG = 0
            INDEX = 1 + (LOOPS-1) * INCS + (LOOPIF-1) * INCIF
            DO 100 I = 1,NUMFRQ
               INX = INX + 1
               INP = INDEX + (I-1) * INCF
               IF (VIS(INP+2).LE.0.0) THEN
                  NFLAG = NFLAG + 1
                  ACSPEC(I) = FBLANK
               ELSE
                  ACSPEC(I) = VIS(INP)
                  END IF
               TPLSPC(I) = TPLATE(INX)
 100           CONTINUE
            IF (NFLAG.EQ.NUMFRQ) GO TO 200
C                                       Remove baseline from spectrum
            IF (DOBASE) THEN
               CALL BLINE (ACSPEC, NUMFRQ, NPOLY, IBASE, BFIT, IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
            DO 110 I = 1, NUMFRQ
               IF ((ACSPEC(I).GT.ACSMAX) .AND. (ACSPEC(I).NE.FBLANK))
     *            THEN
                  ACSMAX = ACSPEC(I)
                  IACMAX = I
                  END IF
               INP = INDEX + (I-1) * INCF
               VIS(INP) = ACSPEC(I)
               IF (VIS(INP+2).LE.0.0) VIS(INP) = 0.0
 110           CONTINUE
C                                       Do the fit
            CALL FIT (IB0, IE0, ACSPEC, TPLSPC, SCALE, ESCALE, CNSTNT,
     *         ECONST, RHO, SIGSQ, IRET)
            IF (IRET.EQ.1) GO TO 999
            INVSC = -1.0E10
            IF (SCALE.NE.0.0) INVSC = 1.0/SCALE
            IF (SIGSQ.GT.0.0)  HAVFIT(LOOPS,LOOPIF) = .TRUE.
            IF ((INVSC.LT.MINGAN) .OR. (INVSC.GT.MAXGAN))
     *         HAVFIT(LOOPS,LOOPIF) = .FALSE.
C                                       Fill in values
            IF (HAVFIT(LOOPS,LOOPIF)) THEN
               GFACT(ANT,LOOPIF,LOOPS) = 1./SCALE
               GERR(ANT,LOOPIF,LOOPS)  =
     *            GFACT(ANT,LOOPIF,LOOPS)**2*ESCALE
               CONST(ANT,LOOPIF,LOOPS) = CNSTNT
               CONERR(ANT,LOOPIF,LOOPS)= ECONST
            ELSE
               GFACT(ANT,LOOPIF,LOOPS) = FBLANK
               GERR(ANT,LOOPIF,LOOPS)  = FBLANK
               CONST(ANT,LOOPIF,LOOPS) = FBLANK
               CONERR(ANT,LOOPIF,LOOPS)= 0.0
               END IF
 200        CONTINUE
 300     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE DATAVG (ANTLAB, FIRST, DT, NMIFS, NMFRQS, VISSIZ,
     *   MXANT, VISOUT, AVTIME, SOLACT, TIME, NUSCAN, SCANUM, ACSOUR,
     *   RPARM,  VIS, IERR)
C-----------------------------------------------------------------------
C   Reads a uv data base and averages spectra over a specified
C   time period.
C   Needs to be initialized by a call to UVGET.
C   The  order of the baselines returned in VISOUT is defined by
C   the order in the array ANTLAB.  All data specified
C   are averaged.
C   Inputs:
C     ANTLAB(MAXANT)    I    The antennas selected.
C     FIRST             L    Logical flag specifying if first call
C     DT                R    Averaging time in days
C     NMIFS             I    # IF's in data
C     NMFRQS            I    # freq. channels in data
C     NBGSIZ            I    Size of VIS array.
C    Input/output:
C     VISOUT(VISSIZ,*)  R    Array containing the result
C                            of the average, maximum size needs to
C                            be MAXANT*VISSIZ*3
C     AVTIME(MAXANT)    D    Mid time of averaged record. (Days)
C     SOLACT            R    Actual averaging time used (days).
C     TIME(8)           I    Center, end time (days, hours, min, sec)
C                            Unless NUSCAN only first 4 values are set.
C     NUSCAN            L    True IF the first record in a new scan.
C     ACSOUR            I    Source just averaged
C     IERR              I    Return code, 0 => OK, -1 => out of data,
C                            > 0 => failed.
C     RPARM            R(*)  Random parameters from last UVGET call.
C     VIS              R(*)  Visibility array from last UVGET call.
C   Output to common in D/CSOU.INC
C     SNAME            C*16  Source name (16 char. 4 / word.)
C     QUAL               I   Source qualifier.
C     CALCOD           C*4   Calibrator code 4 char.
C     FLUX(4,IF)         R   Total flux density I, Q, U, V pol,
C                            (Jy) each IF
C     FREQO(IF)          D   Frequency offset (Hz)
C   Note:   If the end of data is encountered (IERR=-1) then UVGET is
C   called with OPCODE='CLOS'.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ANTLAB(MAXANT), NMIFS, NMFRQS, VISSIZ, MXANT, TIME(8),
     *   SCANUM
      REAL      DT, VIS(*), RPARM(*), VISOUT(VISSIZ,*), SOLACT
      DOUBLE PRECISION AVTIME(MAXANT)
      LOGICAL   NUSCAN, FIRST
C
      LOGICAL   DONE1, GOTDAT, T, F, WPCNT
      DOUBLE PRECISION DTIMSM(MAXANT), DWTSUM(MAXANT)
      INTEGER   IERR, I, J, K, JA1, JA2, SUNUM, JERR, ISLUN, IANT,
     *   CNTTIM, INDEX, INP, ACSOUR, NPNTS(MAXANT,4,4), NPNTMX
      REAL      T1, SUMTIM, TLAST, FRACN, TIMLST
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSOU.INC'
      SAVE TLAST, DONE1, NPNTMX
      DATA ISLUN, T, F /26, .TRUE., .FALSE./
C-----------------------------------------------------------------------
C                                       See if first record read
      IF (FIRST) THEN
         DONE1 = F
         NPNTMX = 1
         END IF
C                                       Clear arrays
 10   CONTINUE
      FIRST = T
      GOTDAT = .FALSE.
      DO 50 IANT = 1,MXANT
         DTIMSM(IANT) = 0.0D0
         DWTSUM(IANT) = 0.0D0
         DO 40 I = 1,NCOR
            DO 30 J = 1,NMIFS
               NPNTS(IANT,I,J) = 0
 30            CONTINUE
 40         CONTINUE
         CALL RFILL (VISSIZ, 0.0, VISOUT(1,IANT))
 50      CONTINUE
      SUMTIM = 0.0
      CNTTIM = 0
C                                       Initialize time
      T1 = 1.0E10
      TIMLST = 0.0
      IF (FIRST) TLAST = -1.0
C                                       Save scan number (0= no index)
      NUSCAN = SCANUM.NE.INXRNO
      SCANUM = INXRNO
C                                       Loop reading data
 100     IF (.NOT.DONE1) CALL UVGET ('READ', RPARM, VIS, IERR)
         IF (IERR.GT.0) GO TO 999
         DONE1 = F
C                                       Antenna numbers
         IF (ILOCB.GE.0) THEN
            JA1 = RPARM(ILOCB+1) / 256. + 0.1
            JA2 = RPARM(ILOCB+1) - JA1 * 256 + 0.1
         ELSE
            JA1 = RPARM(ILOCA1+1) + 0.1
            JA2 = RPARM(ILOCA2+1) + 0.1
            END IF
         IF (JA1.NE.JA2) GO TO 100
C                                       Find antenna
         DO 110 I = 1,MXANT
            IANT = ANTLAB(I)
            IF (JA1.EQ.ANTLAB(I)) GO TO 120
 110        CONTINUE
C                                       Not wanted
         GO TO 100
 120     CONTINUE
C                                             Times
         IF (T1.GT.1.0E9) T1 = RPARM(ILOCT+1)
         IF (FIRST) THEN
            IF (TLAST.EQ.-1.0) TLAST = T1 + DT
            END IF
C                                       Check if avg. or scan done
         IF ((INXRNO.GT.SCANUM) .OR. (IERR.LT.0) .OR.
     *      (RPARM(ILOCT+1).GT.(TLAST))) GO TO 500
C                                       Time
         TIMLST = RPARM(ILOCT+1)
         SUMTIM = SUMTIM + RPARM(ILOCT+1)
         CNTTIM = CNTTIM + 1
C                                       Source no.
         SUNUM = CURSOU
         ACSOUR = SUNUM
C                                       Average:
         DO 150 I = 1, NCOR
            DO 140 J = 1, NMIFS
               INDEX = 1 + (I-1)*INCS + (J-1)*INCIF
               DO 130 K = 1, NMFRQS
                  INP = INDEX + (K-1)*INCF
                  IF (VIS(INP+2).GT.0.0) THEN
                     GOTDAT = .TRUE.
                     VISOUT(INP,IANT) = VISOUT(INP,IANT) + VIS(INP) *
     *                  VIS(INP+2)
                     VISOUT(INP+1,IANT) = VISOUT(INP+1,IANT) +
     *                  VIS(INP+1) * VIS(INP+2)
                     VISOUT(INP+2,IANT) = VISOUT(INP+2,IANT) +
     *                  VIS(INP+2)
                     NPNTS(IANT,I,J) = NPNTS(IANT,I,J) + 1
                     NPNTMX = MAX (NPNTS(IANT,I,J), NPNTMX)
                     DTIMSM(IANT) = DTIMSM(IANT) + TIMLST * VIS(INP+2)
                     DWTSUM(IANT) = DWTSUM(IANT) + VIS(INP+2)
                     END IF
 130              CONTINUE
 140           CONTINUE
 150        CONTINUE
         GO TO 100
C                                       Scan done
C                                       See if have enough data.
C                                       Must have more than 20% of
C                                       the maximum no of points
C                                       averaged in any previous
C                                       interval, for at least one
C                                         ant/if/polzn.
 500  SOLACT = TIMLST - T1
      WPCNT = F
      DO 515 IANT = 1,MXANT
         DO 510 I = 1,NCOR
            DO 505 J = 1,NMIFS
               FRACN = (1.0 * NPNTS(IANT,I,J)) / NPNTMX
               IF (FRACN.GT.0.2) WPCNT = T
 505           CONTINUE
 510        CONTINUE
 515     CONTINUE
      GOTDAT = GOTDAT .AND. WPCNT
      IF ((.NOT.GOTDAT) .AND. (IERR.EQ.0)) GO TO 10
      IF (.NOT.GOTDAT) GO TO 800
C                                       Normalization
      IF (RPARM(ILOCT+1).GT.TLAST) DONE1 = T
      DO 550 IANT = 1, MXANT
         AVTIME(IANT) = SUMTIM / CNTTIM
         DO 540 I = 1,NCOR
            DO 530 J = 1, NMIFS
               INDEX = 1 + (I-1)*INCS + (J-1)*INCIF
               FRACN = (1.0 * NPNTS(IANT,I,J)) / NPNTMX
C                                           Reject if too few points
               IF (FRACN.LT.0.2) GO TO 530
C                                       Mean time for this antenna
               IF (DWTSUM(IANT).GT.0)
     *            AVTIME(IANT) = DTIMSM(IANT) / DWTSUM(IANT)
               DO 520 K = 1, NMFRQS
                  INP = INDEX + (K-1)*INCF
                  IF (VISOUT(INP+2,IANT).GT.0.0) THEN
                     VISOUT(INP,IANT) = VISOUT(INP,IANT) /
     *                  VISOUT(INP+2,IANT)
                     VISOUT(INP+1,IANT) = VISOUT(INP+1,IANT) /
     *                  VISOUT(INP+2,IANT)
                     IF (I.LE.2) VISOUT(INP+1,IANT) = 0.0
                     END IF
 520              CONTINUE
 530           CONTINUE
 540        CONTINUE
 550     CONTINUE
C                                       Get source info
      IF (.NOT.NUSCAN) GO TO 800
      CALL GETSOU (SUNUM, IUDISK, IUCNO, CATUV, ISLUN, JERR)
      IF (JERR.EQ.11) THEN
C                                       Didn't find source
         WRITE (MSGTXT,1750) SUNUM
         CALL MSGWRT (8)
         JERR = 0
         END IF
      IF (JERR.LE.0) GO TO 800
         IERR = JERR
         WRITE (MSGTXT,1700) JERR
         GO TO 990
C                                       Time
 800  T1 = 0
      IF (CNTTIM.GT.0) T1 = SUMTIM / CNTTIM
      TIME(1) = T1
      T1 = (T1 - TIME(1)) * 24.0
      TIME(2) = T1
      T1 = (T1 - TIME(2)) * 60.0
      TIME(3) = T1
      T1 = (T1 - TIME(3)) * 60.0
      TIME(4) = T1 + 0.5
      FIRST = F
C                                       If end of data, close UVGET
      IF (IERR.LT.0) CALL UVGET ('CLOS', RPARM, VIS, JERR)
      IF (JERR.NE.0) IERR = JERR
      IF ((IERR.LT.0) .AND. (.NOT.GOTDAT)) IERR = -2
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1700 FORMAT ('DATAVG: ERROR',I3,' READING SOURCE TABLE')
 1750 FORMAT ('DATAVG: SOURCE ',I3,' NOT IN SU TABLE')
      END
      SUBROUTINE BLINE (ACSPEC, NUMFRQ, NP, BASE, BFIT, IRET)
C-----------------------------------------------------------------------
C  Routine BLINE fits a polynomial baseline to spectra. The
C  fitted parameters are returned and the data is returned
C  with the baseline removed.
C  The routine assumes that only one IF/POLZN is passed down.
C  The calling routine must call BLINE over a loop of # IF's
C  and # polzns.
C
C  Inputs:
C     ACSPEC(*)      R        Input spectrum
C     NUMFRQ         I        # freq. channels in the spectrum
C     NP             I        The degree of polynomial to fit
C     BASE(2,5)      I        Array of start and stop channel
C                             numbers specifying the channels
C                             to be used for fitting
C  Outputs:
C     ACSPEC(*)      R        Output spectrum
C     BFIT(11)       R        The fitted parameters
C     IRET           I        Error code: 0 => OK
C                                         1 => error
C-----------------------------------------------------------------------
      REAL    ACSPEC(*), BFIT(11)
      INTEGER NUMFRQ, NP, BASE(2,5), IRET
C
      INTEGER IB, IBB, IBB1, I, NCHNLS, J, N
      REAL    XB(1024), YB(1024), YBAVG, TEMP
      REAL VARRES
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
      NCHNLS = 0
C                                       Check channel ranges
      DO 100 IB = 1, 5
         IF (BASE(1,IB).LT.0 .OR. BASE(2,IB).LT.0) THEN
            IRET = 1
            WRITE (MSGTXT,1000) BASE(1,IB), BASE(2,IB)
            GO TO 990
            END IF
         IF (BASE(1,IB).GT.NUMFRQ .OR. BASE(2,IB).GT.NUMFRQ) THEN
            IRET = 1
            WRITE (MSGTXT,1010) BASE(1,IB), BASE(2,IB), NUMFRQ
            GO TO 990
            END IF
         IF (BASE(2,IB).LT.BASE(1,IB)) THEN
            IRET = 1
            WRITE (MSGTXT,1020) BASE(1,IB), BASE(2,IB)
            GO TO 990
            END IF
C                                       Select data
         IBB=BASE(1,IB)
         IBB1=BASE(2,IB)
         IF ((IBB.EQ.0) .OR. (IBB1.EQ.0)) GO TO 100
         DO 50 I=IBB,IBB1
            IF (ACSPEC(I).NE.FBLANK) THEN
               NCHNLS = NCHNLS + 1
               XB(NCHNLS) = I
               YB(NCHNLS) = ACSPEC(I)
               END IF
 50         CONTINUE
 100     CONTINUE
C                                       Special case, NP = 0
      IF (NP.EQ.0) THEN
         YBAVG = 0.0
         IF (NCHNLS.EQ.0) GO TO 120
         DO 110 I = 1, NCHNLS
            YBAVG = YBAVG + YB(I)
 110        CONTINUE
         YBAVG = YBAVG / NCHNLS
 120     DO 150 I = 1, NUMFRQ
            IF (ACSPEC(I).NE.FBLANK) ACSPEC(I) = ACSPEC(I) - YBAVG
 150        CONTINUE
         BFIT(1) = YBAVG
         GO TO 999
         END IF
C                                       Set up for polynomial fit
C                                       Jump out if nothing to fit
      IF (NCHNLS.EQ.0) GO TO 999
C                                       fit polinom to the data
      N = NP + 1
      CALL POLINO (XB, YB, N, NCHNLS, BFIT, VARRES, IRET)
C                                       Subtract baseline from data
      DO 700 I=1,NUMFRQ
         TEMP=0.0
         DO 650 J=1,N
            TEMP=TEMP+BFIT(J)*I**(J-1)
  650       CONTINUE
         IF (ACSPEC(I).NE.FBLANK) ACSPEC(I)=ACSPEC(I)-TEMP
  700    CONTINUE
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BLINE: BASELINE CHN SELECTION = ',2I5,' CHECK BPARMS')
 1010 FORMAT ('BLINE: BASELINE CHN SELECTION = ',2I5,' NUMFRQ = ',I5)
 1020 FORMAT ('BLINE: BASELINE CHN SELECTION = ',2I5,' INVERTED??')
      END
      SUBROUTINE FIT (I0, I1, SPEC, TPLSPC, SCALE, ERRSCL, CONST,
     *   ERRCON, RHO, SIGSQ, IRET)
C-----------------------------------------------------------------------
C Routine which actually does the least squares fit of the
C template spectrum to the AC spectrum.
C
C Inputs:
C   I0           I         Start channel of the fit
C   I1           I         End channel of the fit
C   SPEC(*)      R         Spectrum to be fitted
C   TPLSPC(*)    R         Template spectrum
C Outputs:
C   SCALE        R         Scale factor - result of fit
C   ERRSCL       R         Error on scale factor
C   CONST        R         Constant offset - result of fit
C   ERRCON       R         Error on offset
C   RHO          R
C   SIGSQ        R
C   IRET         I         Error flag, 0 => OK
C                                      1 => fatal error
C                                      2 => ignore this value
C-----------------------------------------------------------------------
      INTEGER I0, I1, IRET
      REAL    SPEC(*), TPLSPC(*), SCALE, ERRSCL, CONST, ERRCON, RHO,
     *   SIGSQ
C
      INTEGER ASKIP(2,5), N, I, J
      REAL    TSUM, TSQ, DSUM, DSQ, PRODCT, DETERM
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Set initial values
      IRET = 0
      N      = 0
      TSUM   = 0.
      TSQ    = 0.
      DSUM   = 0.
      DSQ    = 0.
      PRODCT = 0.
C                                       ASKIP is here for later
C                                       when I figure out how to
C                                       pass bad channels thru AIPS
      CALL FILL (10, 0, ASKIP(1,1))
C                                       Form sums, squares etc
      DO 200 I = I0,I1
C                                       Check for bad channels
         DO 100 J = 1,5
            IF (ASKIP(J,1).EQ.0) GO TO 110
            IF ((I.GE.ASKIP(J,1)) .AND. (I.LE.ASKIP(J,2))) GO TO 200
 100        CONTINUE
 110     N = N + 1
         TSUM = TSUM + TPLSPC(I)
         TSQ = TSQ + TPLSPC(I)**2
         IF (SPEC(I).NE.FBLANK) THEN
            DSUM = DSUM + SPEC(I)
            DSQ = DSQ + SPEC(I)**2
            PRODCT = PRODCT + SPEC(I)*TPLSPC(I)
            END IF
 200     CONTINUE
C                                       Ensure N > 2
      IF (N.LE.2) THEN
         WRITE (MSGTXT,1000) N
         IRET = 1
         GO TO 990
         END IF
C                                       Determine scale & offset
      DETERM = N*TSQ - TSUM**2
      IF (DETERM.LE.0) THEN
         WRITE (IRET,1100)  DETERM
         IRET = 2
         GO TO 990
         END IF
      SCALE = (N*PRODCT - TSUM*DSUM)/DETERM
      CONST = (-TSUM*PRODCT + TSQ*DSUM)/DETERM
C                                       Determine sigma square etc
      SIGSQ = 0.
      DO 300 I = I0,I1
         DO 250 J = 1,5
            IF (ASKIP(J,1).EQ.0) GO TO 260
            IF ((I.GE.ASKIP(J,1)) .AND. (I.LE.ASKIP(J,2))) GO TO 300
 250        CONTINUE
 260     IF (SPEC(I).NE.FBLANK)
     *      SIGSQ = SIGSQ + (SPEC(I) - (TPLSPC(I)*SCALE+CONST))**2
 300     CONTINUE
      SIGSQ = SIGSQ / (N-2.)
      ERRSCL = SQRT( SIGSQ*N/DETERM )
      ERRCON = SQRT( SIGSQ*TSQ/DETERM )
      RHO = -TSUM/SQRT(N*TSQ)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FIT: ONLY ',I2,' CHANNELS AVAILABLE FOR GAIN FITTING')
 1100 FORMAT ('FIT: WARNING DETERMINANT = ',E12.3,' GAIN IS FLAGGED')
      END
      SUBROUTINE GETTPL (KBASE, IERR)
C-----------------------------------------------------------------------
C  Routine to get the template spectrum from a uv-file described
C  by the input parms. Uses UVGET so that things have to be reset
C  afterwards.
C  Input:
C     KBASE   I(2,5)   Array of start and stop channel numbers
C                      specifying the channels to be used for
c                      baseline fitting
C  Output:
C     IERR    I        Error code, 0 => OK
C-----------------------------------------------------------------------
      INTEGER   KBASE(2,5), IERR
      INCLUDE 'INCS:PUVD.INC'
C
      HOLLERITH CATH(256)
      INTEGER   NTVIS, IROUND, IA1, IA2, NUMTFQ, I, IPOL, IIF, IFRQ,
     *   INDEX, OIA1, KFREQ, CNTTIM, TIT(3), INX, NUMTIF
      REAL      TIME, WT, RPARM(20), VIS(3*MAXCIF+20), LINWT(2,MAXIF),
     *   XNORM, SUMWT, TFIT(11), TSPEC(MAXCHA), SUMTIM, AVTIME, TITSEC
      LOGICAL   T, F
      INCLUDE 'ACFIT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (CATH, CATBLK)
      DATA T, F / .TRUE., .FALSE./
C-----------------------------------------------------------------------
C                                       Set up all variables for UVGET
      CALL SELINI
      UNAME = NAME2
      UCLAS = CLAS2
      UDISK = DISK2
      USEQ = SEQ2
      DO 20 I = 1,30
         CALSOU(I) = ' '
         SOURCS(I) = ' '
 20      CONTINUE
      SELQUA = IROUND (XQUAL)
      SELCOD = XCALCO
      CALL RFILL (8, 0.0, TIMRNG)
      DO 30 I = 1,50
         ANTENS(I) = 0
 30      CONTINUE
      BIF = 1
      EIF = 0
      BCHAN = 0
      ECHAN = 0
      DOCAL = F
      DOAPPL = F
      DOXCOR = F
      DOACOR = T
      DOBAND = -1
      DXTIME = 0.0
      FRQSEL = IROUND (XFQID)
C                                       Init I/O
      MSGSUP = 31000
      CALL UVGET ('INIT', RPARM, VIS, IERR)
      MSGSUP = 0
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INIT'
         GO TO 990
         END IF
      NUMTIF = EIF - BIF + 1
      NUMTFQ = ECHAN - BCHAN + 1
      NTVIS = NVIS
      SUMTIM = 0.0
      CNTTIM = 0
      NCHNTP = CATUV(KINAX+JLOCF)
C                                       Check # freq. channels
      IF (NUMTFQ.LT.2) THEN
         MSGTXT = 'Your template spectrum has too few channels'
         IERR = 1
         GO TO 990
         END IF
C                                       Zero arrays
      I = NPOLZN * NUMTIF * NUMTFQ
      CALL RFILL (I, 0.0, TPLATE)
      I = 2 * MAXIF
      CALL RFILL (I, 0.0, LINWT)
      OIA1 = 0
C                                       Read the data
      DO 300 I = 1,NTVIS
         CALL UVGET ('READ', RPARM, VIS, IERR)
         IF (IERR.LT.0) GO TO 400
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READ'
            GO TO 990
            END IF
C
         TIME = RPARM(1+ILOCT)
         IF (ILOCB.GE.0) THEN
            IA1 = RPARM(1+ILOCB) / 256.0 + 0.1
            IA2 = RPARM(1+ILOCB) - 256 * IA1 + 0.1
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
            END IF
         IF (IA1.NE.IA2) GO TO 300
         IF ((REFANT.GT.0) .AND. (IA1.NE.REFANT)) GO TO 300
         IF (OIA1.EQ.0) OIA1 = IA1
         IF ((OIA1.NE.0) .AND. (IA1.NE.OIA1)) THEN
            WRITE (MSGTXT, 1010) IA1, OIA1
            IERR = 1
            CALL MSGWRT (6)
            GO TO 990
            END IF
         SUMTIM = SUMTIM + TIME
         CNTTIM = CNTTIM + 1
         TPLMAX = -1.0E10
C                                       Average the data to obtain
C                                       the template spectrum
         INX = 0
         DO 230 IPOL = 1,NPOLZN
            DO 220 IIF = 1,NUMTIF
               KFREQ = 0
               SUMWT = 0.0
               DO 210 IFRQ = 1,NUMTFQ
                  INX = INX + 1
                  INDEX = (IFRQ-1) * INCF + (IIF-1) * INCIF +
     *               (IPOL-1) * INCS + 1
                  WT = VIS(INDEX+2)
                  IF (WT.GT.0.0) THEN
                     KFREQ = KFREQ + 1
                     SUMWT = SUMWT + WT
                     TPLATE(INX) = TPLATE(INX) + VIS(INDEX) * WT
                     END IF
 210              CONTINUE
               IF (KFREQ.GT.0) LINWT(IPOL,IIF) = LINWT(IPOL,IIF)
     *            + (SUMWT / KFREQ)
 220           CONTINUE
 230        CONTINUE
 300     CONTINUE
C                                       Print average time
 400  IF (CNTTIM.LE.0) THEN
         WRITE (MSGTXT,1400) REFANT
         IERR = 4
         GO TO 990
         END IF
      AVTIME = SUMTIM / CNTTIM
      CALL PTIME (AVTIME, F, TIT, TITSEC)
      WRITE (MSGTXT,1020) TIT, TITSEC
      CALL MSGWRT (4)
C                                       Normalize averaged spectrum
C                                       and remove constant offset.
      INX = 0
      DO 430 IPOL = 1,NPOLZN
         DO 420 IIF = 1,NUMTIF
            XNORM = 1.0
            IF (LINWT(IPOL,IIF).GT.1.0E-10) XNORM = 1.0 /
     *         LINWT(IPOL,IIF)
            DO 410 IFRQ = 1,NUMTFQ
               INX = INX + 1
               TSPEC(IFRQ) = TPLATE(INX) * XNORM
 410           CONTINUE
C                                       Remove the baseline unless
C                                       baseline-independent fit.
            IF (DOTBAS .AND. (.NOT.DOAUTO)) THEN
               CALL BLINE (TSPEC, NUMTFQ, NPOLTP, KBASE, TFIT, IERR)
               IF (IERR.NE.0) GO TO 990
C                                       Print fitting message
               IF (TFIT(1).NE.0.0) THEN
                  WRITE (MSGTXT,1030) IPOL, IIF, TFIT(1)
                  CALL MSGWRT (4)
                  END IF
               END IF
            INX = INX - NUMTFQ
            DO 415 IFRQ = 1,NUMTFQ
               INX = INX + 1
               IF (TSPEC(IFRQ).GT.TPLMAX) THEN
                  TPLMAX = TSPEC(IFRQ)
                  ITPMAX = IFRQ
                  END IF
               TPLATE(INX) = TSPEC(IFRQ)
 415           CONTINUE
 420        CONTINUE
 430     CONTINUE
C
      CALL UVGET ('CLOS', RPARM, VIS, IERR)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETTPL: ERROR ',I3,1X,A4,'ING TEMPLATE FILE')
 1010 FORMAT ('GETTPL: ANTENNA ',I3,' DIFFERS FROM FIRST FOUND ',I3)
 1020 FORMAT ('Mid time of template scan = ',I3,'/',2I3,1X,F4.1)
 1030 FORMAT ('Template: POL: ',I2,' IF: ',I2,' offset of',F13.5,
     *   ' removed')
 1400 FORMAT ('GETTPL: NO DATA FOR REFANT',I4,' FOUND')
      END
      SUBROUTINE ACFHIS
C-----------------------------------------------------------------------
C   ACFHIS copies and updates history file.  It also copies any tables
C   extension files.
C-----------------------------------------------------------------------
      CHARACTER CTIME(2)*12, HILINE*72
      INTEGER   IERR, I, J, LUN, LUN2, TIME(3), DATE(3), I1, I2
      REAL      CATR(128), SOLMIN
      LOGICAL   T
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ACFIT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (CATBLK, CATR)
      DATA LUN, LUN2 /28, 29/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      IF (DOWRIT) THEN
         CALL HISCOP (LUN, LUN2, DISKIN, DISOUT, CNOIN,
     *      CNOOUT, CATBLK, SCRTCH, SCRTCH(257), IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (6)
            GO TO 200
            END IF
         END IF
C                                       Open history file.
      CALL HIOPEN (LUN, DISKIN, CNOIN, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME(2)(1:8), CTIME)
      WRITE (HILINE,1010) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Template file
      WRITE (HILINE,2000) TSKNAM, DISK2, NAME2, CLAS2, SEQ2
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Source list
C                                       Sources
      IF (NSOUWD.LE.0) THEN
         WRITE (HILINE,3000) TSKNAM
         CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      ELSE
C                                       Included or excluded?
         WRITE (HILINE,3001) TSKNAM
         IF (DOSWNT) WRITE (HILINE,3002) TSKNAM
         CALL HIADD (LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       1st 2 and label.
         I1 = 1
         IF (SOURCS(1)(1:1).EQ.'-') I1 = 2
         I2 = 1
         IF (SOURCS(2)(1:1).EQ.'-') I2 = 2
         WRITE (HILINE,3003) TSKNAM, SOURCS(1)(I1:), SOURCS(2)(I2:)
         CALL HIADD (LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       Rest of sources
         DO 20 I = 1,NSOUWD,2
            IF ((SOURCS(I).NE.' ') .OR. (SOURCS(I+1).NE.' ')) THEN
               I1 = 1
               IF (SOURCS(I)(1:1).EQ.'-') I1 = 2
               I2 = 1
               IF (SOURCS(I+1)(1:1).EQ.'-') I2 = 2
               WRITE (HILINE,3004) TSKNAM, SOURCS(I)(I1:),
     *            SOURCS(I+1)(I2:)
               CALL HIADD (LUN, HILINE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 200
               END IF
 20         CONTINUE
         END IF
C                                       QUAL, CALCODE
      WRITE (HILINE,3010) TSKNAM, SELQUA, SELCOD
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       FQ adverbs
      WRITE (HILINE,3005) TSKNAM, FRQSEL, SELBAN
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,3006) TSKNAM, SELFRQ
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       TIMERANG
      CALL HITIME (TSTART, TEND, LUN, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       IF'S
      WRITE (HILINE,3020) TSKNAM, BIF, EIF
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Subarray
      WRITE (HILINE,2003) TSKNAM, SUBARR
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Antennas
      IF (NANTSL.LE.0) THEN
         WRITE (HILINE,3030) TSKNAM
         CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      ELSE
C                                       Included or excluded?
         WRITE (HILINE,3031) TSKNAM
         IF (DOAWNT) WRITE (HILINE,3032) TSKNAM
         CALL HIADD (LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       1st 10 and label.
         WRITE (HILINE,3033) TSKNAM, (ANTENS(I),I=1,10)
         CALL HIADD (LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
         IF (NANTSL.GT.10) THEN
C                                       Rest of antennas
            DO 30 I = 11,NANTSL,10
               WRITE (HILINE,3034) TSKNAM, (ANTENS(J),J=I,I+9)
               CALL HIADD (LUN, HILINE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 200
 30            CONTINUE
            END IF
         END IF
C                                       Calibration
C                                       Tables
      IF (DOCAL) THEN
         WRITE (HILINE,2005) TSKNAM, CLVER
         CALL HIADD (LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       Flag table
      WRITE (HILINE,2006) TSKNAM, FGVER
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Bandpass correction
      IF (DOBAND.GT.0) THEN
         WRITE (HILINE,2007) TSKNAM, DOBAND, BPVER
         CALL HIADD (LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       smoothing type
      IF (SMOOTH(1).GT.0.5) THEN
         I1 = SMOOTH(1) + 0.5
         I2 = SMOOTH(3) + 0.5
         WRITE (HILINE,2008) TSKNAM, I1, SMOOTH(2), I2
         CALL HIADD (LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       Solution interval
      IF (SOLINT.GE.1.0) THEN
         WRITE (HILINE,2018) TSKNAM
      ELSE
         SOLMIN = SOLINT * 24 * 60
         WRITE (HILINE,2011) TSKNAM, SOLMIN
         END IF
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Fitting range
      WRITE (HILINE,2012) TSKNAM, IBEGIN, IEND
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Polynomial
      WRITE (HILINE,2013) TSKNAM, APARM(1)
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,2015) TSKNAM
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,2014) TSKNAM, (BASE(I),I=1,10)
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Tsys, Jydeg
      WRITE (HILINE,2016) TSKNAM, (RTSYS(I), I=1,8)
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,2019) TSKNAM, (LTSYS(I), I=1,8)
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,2116) TSKNAM,  APARM(3)
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      WRITE (HILINE,2117) TSKNAM,  APARM(4)
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Min, Max gains
      WRITE (HILINE,2017) TSKNAM, APARM(5), APARM(6)
      CALL HIADD (LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Close HI file
 200  CALL HICLOS (LUN, T, SCRTCH, IERR)
      IF (DOWRIT) CALL HICLOS (LUN2, T, SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ACFHIS: ERROR',I3,' OPENING HISTORY FILE')
 1010 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 2000 FORMAT (A6,' Template file: Vol = ',I3,1X,A12,1X,A6,1X,I4)
 2003 FORMAT (A6,'SUBARRAY =',I4)
 2005 FORMAT (A6,'GAINVER =',I3,' / Calibrating with this table')
 2006 FORMAT (A6,'FLAGVER =',I3,' / FG table')
 2007 FORMAT (A6,'DOBAND =',I2,' BPVER = ',I3,' / Bandpass ')
 2008 FORMAT (A6,'SMOOTH = ',I1,',',F6.1,',',I4,
     *   ' / Frequency smoothing function')
 2011 FORMAT (A6,'SOLINT = ',F8.2,' / Data average interval (mins)')
 2018 FORMAT (A6,'Data averaged over whole scan before fitting')
 2012 FORMAT (A6,'BCHAN = ',I3,' ECHAN = ',I3,' / Spectral ',
     *   'fitting range')
 2013 FORMAT (A6,'APARM(1) = ',F4.0,' / Order of polynomial')
 2014 FORMAT (A6,'BASE= ',10(1X,I3))
 2015 FORMAT (A6,'/ Start & stop channels for polynomial removal')
 2016 FORMAT (A6,'Rpol TSYS= ',8F6.1)
 2019 FORMAT (A6,'Lpol TSYS= ',8F6.1)
 2116 FORMAT (A6,'Rpol JYDEG= ',F5.2,' / Template cal')
 2117 FORMAT (A6,'Lpol JYDEG= ',F5.2,' / Template cal')
 2017 FORMAT (A6,'APARM(5,6) = ',2(F8.2,1X), ' / Min, max gains')
 3000 FORMAT (A6,'SOURCES = ''''     /All sources selected')
 3001 FORMAT (A6,'/Sources excluded from gain estimation:')
 3002 FORMAT (A6,'/Sources used to estimate gain:')
 3003 FORMAT (A6,'SOURCES = ''',A16,''',''',A16,'''')
 3004 FORMAT (A6,'         ,''',A16,''',''',A16,'''')
 3005 FORMAT (A6,'FRQSEL =',I3,' SELBAN =',F8.3,' Hz')
 3006 FORMAT (A6,'SELFREQ = ',F20.5,' Hz')
 3010 FORMAT (A6,'QUAL = ',I4,' CALCODE = ',A4)
 3020 FORMAT (A6,'BIF = ',I4,' EIF = ',I4)
 3030 FORMAT (A6,'ANTENNAS = 0     /All antennas selected')
 3031 FORMAT (A6,'/Antennas excluded from gain estimation:')
 3032 FORMAT (A6,'/Antennas used in gain estimation:')
 3033 FORMAT (A6,'Antennas = ',10(1X,I3))
 3034 FORMAT (A6,'           ',10(1X,I3))
      END
      SUBROUTINE MTXINV (DA, N, NMAX, DET)
C---------------------------------------------------------------------
C   MTXINV uses the Gauss-Jordan method as described in
C   Introduction to Numerical Analysis, Stoer and Bulirsch, p171.
C   Input parameters:
C      DA     D(N,N)    Double precision square matrix.
C      N      I         Degree of matrix (<= 100).
C      NMAX   I         Degree of array A in calling program.
C   Output parameter:
C      DET    D         Determinant.
C---------------------------------------------------------------------
      INTEGER N, NMAX
      DOUBLE PRECISION DA(NMAX,NMAX), DET
C
      DOUBLE PRECISION DTMPCL(100), DCOLMX, DTEMP
      INTEGER ISWAP(100), I, J, K, IMAX, JP1, ITEMP,  NSWAP
C---------------------------------------------------------------------
      NSWAP = 0
      DET = 0.0
      IF (N.GT.100) GO TO 999
C                                              Use ISWAP to track row swaps.
      DET = 1.0
      DO 50 I = 1,N
         ISWAP(I) = I
  50     CONTINUE
C                                       Loop through the columns.
      DO 300 J = 1,N
C                                        Find a pivot in this column.
         DCOLMX = DA(J,J)
         IMAX = J
         JP1 = J + 1
         DO 100 I = JP1,N
            IF (ABS(DA(I,J)) .GT. ABS(DCOLMX)) THEN
               DCOLMX = DA(I,J)
               IMAX = I
               END IF
 100        CONTINUE
C                                        Accumulate the determinant
         DET = DET * DCOLMX
C                                        Is the matrix singular ?
         IF (DCOLMX.EQ.0) GO TO 999
C                                       Swap rows if neccessary.
         IF (IMAX.GT.J) THEN
            NSWAP = NSWAP + 1
            DO 150 K = 1,N
               DTEMP = DA(J,K)
               DA(J,K) = DA(IMAX,K)
               DA(IMAX,K) = DTEMP
150            CONTINUE
            ITEMP = ISWAP(J)
            ISWAP(J) = ISWAP(IMAX)
            ISWAP(IMAX) = ITEMP
            END IF
C                                       Transform the matrix;
C                                       excl current column.
         DTEMP = DA(J,J)
         DO 220 I = 1,N
            DO 200 K = 1,N
               IF ((I.EQ.J).OR.(K.EQ.J)) GO TO 200
               DA(I,K) = DA(I,K) - DA(I,J) * DA(J,K) / DTEMP
 200           CONTINUE
 220        CONTINUE
C                                       Set up current column.
         DO 250 I=1,N
            DA(I,J) = -DA(I,J) / DTEMP
 250        CONTINUE
C                                       Normalise the current row.
         DO 280 K = 1,N
            DA(J,K) = DA(J,K) / DTEMP
 280        CONTINUE
         DA(J,J) = 1.0 / DTEMP
C
 300     CONTINUE
C                                        Restore the original row order.
      DO 350 I = 1,N
         DO 320 K = 1,N
            DTMPCL(ISWAP(K)) = DA(I,K)
 320        CONTINUE
         DO 330 K = 1,N
            DA(I,K) = DTMPCL(K)
 330        CONTINUE
 350     CONTINUE
      IF (MOD(NSWAP,2).NE.0) DET = -DET
C                                        Exit
 999  RETURN
      END
      SUBROUTINE AUTOFT (NUMFRQ, NUMBIF, NPOLZN, VIS, TPLATE, NPOLY,
     *   IBEGIN, IEND, ANT, MINGAN, MAXGAN, GFACT, GERR, HAVFIT, ACSMAX,
     *   IACMAX, IRET)
C-----------------------------------------------------------------------
C  Routine determines antenna gain factors by fitting a template
C  autocorrelation spectrum to spectra from all antennas.
C  The method does not require a baseline range to be specified for
C  the template or AC spectrum but does assume the baseline
C  to be a polynomial with degree no higher than NPOLY.
C  Inputs:
C    NUMFRQ             I         # channels in spectrum
C    VIS (*)            R         Autocorrelation spectrum
C    TPLATE(*)          R         Template spectrum
C    NPOLY              I         Degree of polynomial describing
C                                 the baseline.
C    IBEGIN             I         Start channel for AC fitting.
C    IEND               I         End channel for AC fitting.
C    ANT                I         Antenna being fitted
C    MINGAN             R         Minimum acceptable gain
C    MAXGAN             R         Maximum acceptable gain
C
C  Outputs:
C    GFACT(*,*,*)       R         Gain factor for each antenna, IF,
C                                 polzn
C    GERR(*,*,*)        R         Associated error
C    HAVFIT(4,MAXIF)    L         .TRUE. if fit succesful
C    ACSMAX             R         Max value in spectrum
C    IACMAX             I         Channel of max value
C    IRET               I         Error code, 0 => OK
C
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER NUMFRQ, NUMBIF, NPOLZN, NPOLY, IBEGIN, IEND, IRET, ANT,
     *   IACMAX
      REAL    VIS(*), TPLATE(MAXCIF), ACSMAX, MINGAN, MAXGAN
      LOGICAL HAVFIT(2,MAXIF)
      REAL    GFACT(MAXANT,MAXIF,2), GERR(MAXANT,MAXIF,2)
C
      INTEGER  INDEX, INP, I, LOOPS, LOOPIF, NFLAG, IERR, INX
      REAL    SCALE, ESCALE, ACSPEC(MAXCHA), TPLSPC(MAXCHA)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
      ACSMAX = -1.0E10
C                                       Loop over IF's, polzns
      INX = 0
      IRET = 10
      DO 300 LOOPS = 1,NPOLZN
         DO 200 LOOPIF = 1,NUMBIF
            HAVFIT(LOOPS,LOOPIF) = .FALSE.
            NFLAG = 0
            INDEX = 1 + (LOOPS-1) * INCS + (LOOPIF-1) * INCIF
            DO 100 I = 1,NUMFRQ
               INX = INX + 1
               INP = INDEX + (I-1) * INCF
               IF (VIS(INP+2).LE.0.0) THEN
                  NFLAG = NFLAG + 1
                  ACSPEC(I) = FBLANK
               ELSE
                  ACSPEC(I) = VIS(INP)
                  IF (ACSPEC(I).GT.ACSMAX) THEN
                     ACSMAX = ACSPEC(I)
                     IACMAX = I
                     END IF
                  END IF
               TPLSPC(I) = TPLATE(INX)
 100           CONTINUE
            IF (NFLAG.EQ.NUMFRQ) GO TO 200
C                                       Do the fit
            CALL GAINFT (ACSPEC, TPLSPC, NUMFRQ, FBLANK, NPOLY,
     *         IBEGIN, IEND, SCALE, ESCALE, IERR)
            HAVFIT(LOOPS,LOOPIF) = (IERR.EQ.0) .AND. (SCALE.NE.FBLANK)
     *         .AND. (SCALE.GE.MINGAN) .AND. (SCALE.LE.MAXGAN) .AND.
     *         (SCALE.NE.0.0)
C                                       Fill in values
            IF (HAVFIT(LOOPS,LOOPIF)) THEN
               GFACT(ANT,LOOPIF,LOOPS) = SCALE
               GERR(ANT,LOOPIF,LOOPS)  = ESCALE
               IRET = 0
            ELSE
               GFACT(ANT,LOOPIF,LOOPS) = FBLANK
               GERR(ANT,LOOPIF,LOOPS)  = FBLANK
               END IF
 200        CONTINUE
 300     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE GAINFT (ACSPEC, TEMPL, NCHAN, SNULL, NP,
     *   ISTART, IEND, SCALE, ERRSCL, IRET)
C---------------------------------------------------------------------
C  Determine the scaling of an AC spectrum with respect to the
C  template AC spectrum, thus determining the gain of an antenna.
C  This routine does "automatic" baseline removal, i.e. no
C  no baselines are removed from the spectra prior to fitting and
C  the baselines are assumed to have polynomial form of degree <= NP.
C  The source spectrum is fitted in the form
C   Gain*Template + Poly (Degree NP)
C  using linear least squares over the channel range (ISTART,IEND).
C   Input parameters:
C      ACSPEC R(NCHAN)  Spectrum.
C      TEMPL  R(NCHAN)  Template spectrum.
C      NCHAN  I         Number of frequency channels.
C      SNULL  R         Value of blanked pixel in spectra.
C      NP     I         Degree of polynomial expected for baseline.
C      ISTART I         Start channel for AC fit.
C      IEND   I         End channel for AC fit.
C   Output parameters:
C      SCALE  R         Scale factor to multiply ACSPEC.
C                       Returns SNULL if no solution.
C      ERRSCL R         Error in scale factor.
C                       Returns SNULL if no solution.
C      IRET   I         Return code (0 => ok).
C---------------------------------------------------------------------
      INTEGER NCHAN, NP, IRET, ISTART, IEND
      REAL ACSPEC(NCHAN), TEMPL(NCHAN), SNULL, SCALE, ERRSCL
C
      INTEGER MAXNP
      PARAMETER (MAXNP = 26)
      DOUBLE PRECISION DCURV(MAXNP,MAXNP), DB(MAXNP), DSUM,
     *  DSUMJ, DSUMK, DX, DET, DVAR
      REAL A(MAXNP), AERR(MAXNP)
      INTEGER J, K, M, NP2, NPMAX, N
      DATA NPMAX /MAXNP/
C--------------------------------------------------------------------
C                                        Initialisation
      NP2 = NP + 2
      N = IEND - ISTART + 1
      IRET = 0
      SCALE = SNULL
      ERRSCL = SNULL
      IF ((NP2.GT.N).OR.(NP2.LE.0).OR.(NP2.GT.NPMAX)) IRET = 1
      IF (IRET.NE.0) GO TO 999
C                                        Accumulate the curvature matrix
      DO 200 J = 1,NP2
         DO 100 K = J,NP2
            DCURV(J,K) = 0.0D0
            DO 50 M = ISTART,IEND
               IF ((M.LE.0).OR.(ACSPEC(M).EQ.SNULL).OR.
     *           (TEMPL(M).EQ.SNULL)) GO TO 50
               DX = 1.0D0 * M
               DSUMJ = 1.0D0
               IF (J.GT.2) DSUMJ = DX ** (J-2)
               IF (J.EQ.1) DSUMJ = TEMPL(M)
               DSUMK = 1.0D0
               IF (K.GT.2) DSUMK = DX ** (K-2)
               IF (K.EQ.1) DSUMK = TEMPL(M)
               DCURV(J,K) = DCURV(J,K) + DSUMJ * DSUMK
  50           CONTINUE
 100        CONTINUE
 200     CONTINUE
C                                        Fill in the symmetric elements.
      DO 300 J = 2,NP2
         M = J - 1
         DO 250 K = 1,M
            DCURV(J,K) = DCURV(K,J)
 250        CONTINUE
 300     CONTINUE
C                                        Generate the row matrix.
      DO 400 J = 1,NP2
         DB(J) = 0.0D0
         DO 350 M = ISTART,IEND
            IF ((M.LE.0).OR.(ACSPEC(M).EQ.SNULL).OR.
     *         (TEMPL(M).EQ.SNULL)) GO TO 350
            DX = 1.0D0 * M
            DSUM = 1.0D0
            IF (J.GT.2) DSUM = DX ** (J-2)
            IF (J.EQ.1) DSUM = TEMPL(M)
            DB(J) = DB(J) + ACSPEC(M) * DSUM
 350        CONTINUE
 400     CONTINUE
C                                        Invert the curvature matrix.
      CALL MTXINV (DCURV, NP2, NPMAX, DET)
      IF (DET.EQ.0.0D0) IRET = 2
      IF (IRET.NE.0) GO TO 999
C                                        Calculate the coefficients
      DO 500 J = 1,NP2
         DSUM = 0.0D0
         DO 450 K = 1,NP2
            DSUM = DSUM + DCURV(J,K) * DB(K)
 450        CONTINUE
         A(J) = DSUM
 500     CONTINUE
C                                       Calculate the variance for
C                                       the fit.
      DVAR = 0.0D0
      DO 600 M = ISTART,IEND
         IF ((M.LE.0).OR.(ACSPEC(M).EQ.SNULL).OR.
     *      (TEMPL(M).EQ.SNULL)) GO TO 600
         DSUM = TEMPL(M) * A(1)
         IF (NP2.GE.2) DSUM = DSUM + A(2)
         DO 550 K = 3,NP2
            DX = 1.0D0 * M
            DSUM = DSUM + A(K) * DX ** (K - 2)
 550        CONTINUE
         DVAR = DVAR + (ACSPEC(M) - DSUM) ** 2
 600     CONTINUE
      IF (N.GT.NP2) DVAR = DVAR / (N - NP2)
C                                       Error for coefficients
      DO 650 J = 1,NP2
         AERR(J) = 0.0
         IF (DCURV(J,J).GT.0.0D0) AERR(J) = SQRT (DVAR * DCURV(J,J))
 650     CONTINUE
C                                        Return gain and gain error
      IF (A(1).GT.0) THEN
         SCALE = 1.0 / A(1)
         ERRSCL = AERR(1) / (A(1) * A(1))
         END IF
C
 999  RETURN
      END

      SUBROUTINE QVMOV (A, I, C, K, N)
C-----------------------------------------------------------------------
C! VMS Pseudo AP routine: Vector move.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   VMS version.
C   Copy one vector to another:
C       C(mK) = A(mI)  for m=0 to N-1
C   Inputs:
C      A  I  Source vector base address
C      I  I  A address increment
C      C  I  Destination vector base address
C      K  I  C address increment
C      N  I  Element count
C-----------------------------------------------------------------------
      INTEGER   A, I, C, K, N, JA, JC, LOOP, NPASS, LENGTH, STAT,
     *   NLEFT, LEN
      INTEGER*2 ILEN
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Check increments = 1
      IF ((I.EQ.1) .AND. (K.EQ.1)) GO TO 200
C                                       Check increments = -1
      IF (((I.EQ.-1) .AND. (K.EQ.-1)) .AND. ((C-A).GT.10)) GO TO 300
C                                       Addresses 1-rel
      JA = A + 1
      JC = C + 1
C                                       Loop
      INCLUDE 'INCS:ZVND.INC'
      DO 100 LOOP = 1,N
         APCORE (JC) = APCORE (JA)
         JC = JC + K
         JA = JA + I
 100     CONTINUE
      GO TO 999
C                                       Increment = 1 use library
C                                       routine
 200  CONTINUE
C                                       Real Values, Init block transfer
      LENGTH = 8191
      NLEFT = N
C                                       Send what is left if less than max
      LEN = MIN (NLEFT, LENGTH)
C                                       Calc Num. block transfers + a few.
      NPASS = (REAL(N) / REAL(LENGTH)) + 2.0
C                                       Start at the beginning of the blocks
      JA = A + 1
      JC = C + 1
      DO 250 LOOP = 1,NPASS
         ILEN = LEN * 4
         CALL LIB$MOVC3 (ILEN, APCORE(JA), APCORE(JC))
         NLEFT = NLEFT - LEN
C                                       Exit if none left
         IF (NLEFT .LE. 0) GO TO 999
         JA = JA + LEN
         JC = JC + LEN
         LEN = MIN (NLEFT, LENGTH)
 250     CONTINUE
      GO TO 999
C                                       Increment = -1 use library
C                                       routine in sections
 300  CONTINUE
      LENGTH = (C - A)
      IF (LENGTH.GT.8191) LENGTH = 8191
      NLEFT = N
C                                       Send what is left if less than max
      LEN = MIN (NLEFT, LENGTH)
C                                       Calc Num. block transfers + a few.
      NPASS = (REAL(N) / REAL(LENGTH)) + 2.0
C                                       Start at the beginning of the blocks
      JA = A + 2 - LEN
      JC = C + 2 - LEN
      DO 350 LOOP = 1,NPASS
         ILEN = LEN * 4
         CALL LIB$MOVC3 (ILEN, APCORE(JA), APCORE(JC))
         NLEFT = NLEFT - LEN
C                                       Exit if none left
         IF (NLEFT .LE. 0) GO TO 999
         JA = JA - LEN
         JC = JC - LEN
         LEN = MIN (NLEFT, LENGTH)
 350     CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'FXTIM.INC'
C                                       Local include for FXTIM
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2), XREFDA(2)
      REAL      XSIN, XDISIN, XSOUT, XDISO, XCENT,
     *   BUFF1(UVBFSS), BUFF2(UVBFSS), DIFPIX
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, JBUFSZ, ILOCWT,
     *   CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI,
     *   LRECO, NRPRMI, NRPRMO, TOFF, IBUFF1(UVBFSS), IBUFF2(UVBFSS)
      LOGICAL   ISCOMP
      DOUBLE PRECISION UVSCAL
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, REFDAY*8
      EQUIVALENCE (IBUFF1, BUFF2), (IBUFF2, BUFF2)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XCLAOU,
     *   XSOUT, XDISO, XREFDA, XCENT
      COMMON /OTPARM/ CATOLD, UVSCAL, SEQIN, SEQOUT, DISKIN, DISKO,
     *   ILOCWT, INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI,
     *   LRECO, NRPRMI, NRPRMO, ISCOMP, TOFF, DIFPIX
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, REFDAY
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
C                                       End local include for FXTIM
LOCAL END
      PROGRAM FXTIM
C-----------------------------------------------------------------------
C! Fixes times in a uv data set
C# Utility UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 2000, 2007-2008, 2014-2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FXTIM fixes the times in a uv data set by determining the minimum
C   and adding a sutiable number of days.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'FXTIM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'FXTIM '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL FXTIMI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL FXTIMU (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL FXTIMH
C                                       Close down files, etc.
 990  CALL DIE (IRET, IBUFF1)
C
 999  STOP
      END
      SUBROUTINE FXTIMI (PRGN, JERR)
C-----------------------------------------------------------------------
C   FXTIMI gets input parameters for FXTIM and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in FXTIM for more details.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER  STAT*4, BLANK*6, PTYPE*2
      INTEGER   OLDCNO, IROUND, NPARM, IERR, INCX
      LOGICAL   T
      INCLUDE 'FXTIM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK  /'      '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 17
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, IBUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, IBUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (8, 1, XREFDA, REFDAY)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, IBUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', IBUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
      IF (JLOCF.LT.0) XCENT = -1.
      IF (XCENT.LE.0.0) THEN
         UVSCAL = 1.0D0
         DIFPIX = 0.0
      ELSE
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
         UVSCAL = CATD(KDCRV+JLOCF) / FREQ
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, IBUFF1, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((CCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', IBUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', IBUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FXTIMI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('FXTIMI: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE FXTIMU (IRET)
C-----------------------------------------------------------------------
C   FXTIMU finds the minimum time and then copies the data adding an
C   integer number of days.
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48, IFILE*48, OBSDAT*8
      INTEGER   INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, ILENBU,
     *   KBIND, NIOUT, NIOLIM, IBIND, I, IA1, IA2, INCX, BO, VO,
     *   NUMVIS, XCOUNT, NCORI, NCORO, NCOPY
      LOGICAL   T, F
      DOUBLE PRECISION JD, JDR
      INCLUDE 'FXTIM.INC'
      REAL      DUM, BASEN, CBUFF(UVBFSS), RESULT(UVBFSS), TMIN, TMAX
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI, LUNO /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
      IF (ISCOMP) INCX = 3
      TMIN = 1.E20
      TMAX = -TMIN
C                                       REFDATE used?
      IF (REFDAY.NE.' ') THEN
         CALL H2CHR (8, 1, CATH(KHDOB), OBSDAT)
         CALL JULDAY (OBSDAT, JD)
         CALL JULDAY (REFDAY, JDR)
         TMIN = JDR - JD + 0.000001D0
         END IF
C                                       Number of visibilities in input
C                                       and output files.
      NCORI = (LRECI - NRPRMI) / CATOLD(KINAX)
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN', 'READ'
         GO TO 990
         END IF
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT', 'READ'
         GO TO 990
         END IF
C                                       Loop
 10   CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'READ'
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Loop over buffer
         IF (INIO.GT.0) THEN
            DO 20 I = 1,INIO
               TMIN = MIN (TMIN, BUFF1(IPTRI+ILOCT))
               TMAX = MAX (TMAX, BUFF1(IPTRI+ILOCT))
               IPTRI = IPTRI + LRECI
 20            CONTINUE
            GO TO 10
            END IF
C                                       have extreme times
      WRITE (MSGTXT,1020) TMIN, TMAX
      CALL MSGWRT (3)
C                                       no correction
      IF (TMIN.GE.0.0) THEN
         TOFF = 0
      ELSE
         TOFF = -TMIN + 0.99999
         CALL H2CHR (8, 1, CATH(KHDOB), OBSDAT)
         CALL JULDAY (OBSDAT, JD)
         JD = JD - TOFF
         CALL GREG (JD, OBSDAT)
         CALL CHR2H (8, OBSDAT, 1, CATH(KHDOB))
         END IF
      WRITE (MSGTXT,1025) TOFF
      CALL MSGWRT (3)
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN', 'WRITE'
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT', 'WRITE'
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT', 'READ'
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'READ'
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Loop over buffer
         DO 190 I = 1,INIO
            IF (ILOCB.GE.0) THEN
               BASEN = BUFF1(IPTRI+ILOCB)
               IA1 = BASEN / 256. + 0.1
               IA2 = BASEN - IA1*256. + 0.1
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               END IF
            BUFF1(IPTRI+ILOCU) = BUFF1(IPTRI+ILOCU) * UVSCAL
            BUFF1(IPTRI+ILOCV) = BUFF1(IPTRI+ILOCV) * UVSCAL
            BUFF1(IPTRI+ILOCW) = BUFF1(IPTRI+ILOCW) * UVSCAL
            NUMVIS = NUMVIS + 1
C                                      Call user routine.
            IF (ISCOMP) THEN
C                                       Compressed data.
               CALL ZUVXPN (NCORI, BUFF1(IPTRI+NRPRMI),
     *            BUFF1(IPTRI+ILOCWT), CBUFF)
               CALL DIDDLE (NUMVIS, BUFF1(IPTRI+ILOCT), CBUFF,
     *            INCX, RESULT, IRET)
            ELSE
C                                       Un compressed data
               CALL DIDDLE (NUMVIS, BUFF1(IPTRI+ILOCT),
     *            BUFF1(IPTRI+NRPRMI), INCX, RESULT, IRET)
               END IF
C                                       Branch on his return
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
C                                       Copy to output.
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1.0D0
               CALL RCOPY (NRPRMO, BUFF1(IPTRI), BUFF2(IPTRO))
C                                       Compressed
               IF (ISCOMP) THEN
                  CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *               BUFF2(IPTRO+NRPRMO))
               ELSE
                  CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
                  END IF
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               END IF
C                                       OK, but no output please
            IPTRI = IPTRI + LRECI
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1010) IRET, 'WRITE'
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
C                                       Read next buffer.
         IF (INIO.GT.0) GO TO 100
C                                       Final call to DIDDLE.
      NUMVIS = -1
      CALL DIDDLE (NUMVIS, DUM, BUFF1, INCX, RESULT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, 'FLUSH'
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FXTIMU: ERROR',I3,1X,A,' FOR ',A,' VIS FILE')
 1010 FORMAT ('FXTIMU: ERROR',I3,1X,A,' VIS FILE')
 1020 FORMAT ('FXTIMU: TMIN=',F9.3,'  TMAX',F9.3)
 1025 FORMAT ('FXTIMU: times corrected by adding',I6,' days')
 1120 FORMAT ('FXTIMU: DIDDLE ERROR',I3)
      END
      SUBROUTINE FXTIMH
C-----------------------------------------------------------------------
C   FXTIMH copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP*2, HILINE*72
      INTEGER   LUN1, LUN2, IERR, NONOT
      LOGICAL   T
      INCLUDE 'FXTIM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NONOT, NOTTYP /0, '  '/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, IBUFF1, IBUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, IBUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, IBUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any other history.
      IF (REFDAY.NE.' ') THEN
         WRITE (HILINE,1005) TSKNAM, REFDAY
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
      WRITE (HILINE,1010) TSKNAM, TOFF
      CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, IBUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO,
     *   FCNO(2), FCNO(1), CATBLK, IBUFF1, IBUFF2, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'FXTIMH: ERROR COPYING TABLES'
         CALL MSGWRT (6)
         END IF
C                                       correct times
      CALL DTIMTA (LUN1, LUN2, DISKO, FCNO(1), TOFF, IBUFF1, IBUFF2,
     *   IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'FXTIMH: ERROR CHANGING TIMES IN TABLES'
         CALL MSGWRT (6)
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (DISKO, FCNO(1), DIFPIX, IBUFF1, IBUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'FXTIMH: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST',
     *   IBUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FXTIMH: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1005 FORMAT (A6,'REFDATE =''',A,'''   / new reference date forced')
 1010 FORMAT (A6,'TOFFSET =',I8, ' / Days added to time')
      END
      SUBROUTINE DIDDLE (NUMVIS, T, VIS, INCX, RESULT, IRET)
C-----------------------------------------------------------------------
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      T       R    Time in days since 0 IAT on the first day for
C                   which there is data, the julian day corresponding
C                   to this day can be obtained in D   form by:
C                   CALL JULDAY (CATH(KHDOB),XDAY) where XDAY will
C                   be the Julian day number.
C      VIS     R(INCX,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                   NOTE: INCX may be any value .GE. 2
C   Inputs from COMMON:
C      RA         D       Right ascension (1950) of phase center. (deg)
C      DEC        D       Declination (1950) of phase center. (deg)
C      FREQ       D       Frequency of observation (Hz)
C      NRPARM     I       # random parameters.
C      NCOR       I       # correlators
C      CATBLK     I(256)  Catalog header record. See Going Aips for
C                         details.
C      LRECI      I    Input file record length
C      NRPRMI     I    Input number of random parameters.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
C      LRECO      I    Output file record length
C      NRPRMO     I    Output number of random parameters.
C      INCSO      I    Output Stokes' increment in vis.
C      INCFO      I    Output frequency increment in vis.
C      INCIFO     I    Output IF increment in vis.
C   Output:
C      T          R    Time in same units as input.
C      RESULT  R(INCX,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C
C   Output in COMMON:
C      CATBLK    I         Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, INCX, IRET
      REAL      T, VIS(INCX,*), RESULT(INCX,*)
C
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXO, INDEXI, I
      INCLUDE 'FXTIM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.GT.0) THEN
         T = T + TOFF
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
         DO 40 JIF = 1,NIF
            DO 30 JF = 1,NF
               DO 20 JS = 1,NS
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *               (JS-1) * INCSO + 1
                  DO 10 I = 1,INCX
                     RESULT(I,INDEXO) = VIS(I,INDEXI)
 10                  CONTINUE
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE DTIMTA (LUN1, LUN2, VOL, CNO, TOFF, BUFF1, BUFF2, IRET)
C-----------------------------------------------------------------------
C   DTIMTA re-writes tables correcting the times if any.
C   Inputs:
C      LUN1     I        LUN for read
C      LUN2     I        LUN for write
C      VOL      I        Disk number
C      CNO      I        Catalog slot number
C      TOFF     I        Time increment in days
C   Output:
C      BUFF1    I(512)   Work buffer
C      BUFF2    I(512)   Work buffer
C      IRET     I        Return error code  0 => ok
C                           1 => files the same, no copy.
C                           2 => no input files exist
C                           3 => failed
C                           4 => no output files created.
C                           5 => failed to update CATBLK
C-----------------------------------------------------------------------
      INTEGER   LUN1, LUN2, VOL, CNO, TOFF, BUFF1(*), BUFF2(*), IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER TIMKEY(2)*24, TYPE*2
      REAL      RECR(XBPRSZ)
      DOUBLE PRECISION RECD(XBPRSZ/2)
      INTEGER   NVERS, NKEY, NREC, NCOL, DATP(128,2,2), IER, I, TIMKOL,
     *   RECORD(XBPRSZ), NRECIN, INREC, OUTREC, LOOP, INVER,
     *   OUTVER, ITYPE, NT, LENGTH, RTYPE
      LOGICAL   T, F, TABLE, EXIST, FITASC, OPEN1, OPEN2
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (RECORD, RECR, RECD)
      DATA TIMKEY /'TIME', 'TIME RANGE'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       loop over types
      DO 100 ITYPE = 1,KIEXTN
         CALL H2CHR (2, 1, CATH(KHEXT+ITYPE-1), TYPE)
         NVERS = CATBLK(KIVER+ITYPE-1)
         DO 90 INVER = 1,NVERS
            OPEN1 = F
            OPEN2 = F
            EXIST = .FALSE.
            IRET = 0
            IF ((TYPE.NE.'HI') .AND. (TYPE.NE.'PL') .AND. (TYPE.NE.'SL')
     *         .AND. (TYPE.NE.' ') .AND. (TYPE.NE.'SU')) CALL ISTAB
     *         (TYPE, VOL, CNO, INVER,LUN1, BUFF1, TABLE, EXIST, FITASC,
     *         IRET)
            IF ((IRET.EQ.0) .AND. (EXIST) .AND. (TABLE)) THEN
C                                       Open first (input) file
               CALL TABINI ('READ', TYPE, VOL, CNO, INVER, CATBLK, LUN1,
     *            NKEY, NREC, NCOL, DATP(1,1,1), BUFF1, IER)
C                                       If not there - quit
               IF (IER.GT.0) GO TO 90
               OPEN1 = T
C                                       Find source id column.
               NT = 0
               CALL FNDCOL (1, TIMKEY(I), 8, T, BUFF1, TIMKOL, IER)
               IF (IER.EQ.0) THEN
                  NT = 1
               ELSE
                  CALL FNDCOL (1, TIMKEY(2), 12, T, BUFF1, TIMKOL, IER)
                  IF (IER.EQ.0) NT = 2
                  END IF
C                                       quit if no source column
               IF (NT.GT.0) THEN
C                                       Open second (output) file
                  OUTVER = INVER
                  CALL TABINI ('WRIT', TYPE, VOL, CNO, OUTVER, CATBLK,
     *               LUN2, NKEY, NREC, NCOL, DATP(1,1,2), BUFF2, IER)
                  IF (IER.GT.0) GO TO 80
                  OPEN2 = T
C                                       Get number of records in the
C                                       files.
                  NRECIN = BUFF1(5)
                  OUTREC = 1
C                                       translate to physical place in
C                                       record
                  LENGTH = DATP(TIMKOL,2,1) / 10
                  RTYPE = DATP(TIMKOL,2,1) - LENGTH * 10
                  TIMKOL = DATP(TIMKOL,1,1)
C                                       Copy
                  DO 40 LOOP = 1,NRECIN
                     INREC = LOOP
                     CALL TABIO ('READ', 0, INREC, RECORD, BUFF1, IER)
                     IF (IER.GT.0) THEN
                        WRITE (MSGTXT,1070) IER, 'READ', TYPE
                        GO TO 990
                        END IF
C                                       time translate
                     DO 20 I = 1,NT
                        IF (RTYPE.EQ.1) THEN
                           RECD(TIMKOL+I-1) = RECD(TIMKOL+I-1) + TOFF
                        ELSE
                           RECR(TIMKOL+I-1) = RECR(TIMKOL+I-1) + TOFF
                           END IF
 20                     CONTINUE
                     CALL TABIO ('WRIT', 0, OUTREC, RECORD, BUFF2, IER)
                     IF (IER.GT.0) THEN
                        WRITE (MSGTXT,1070) IER, 'WRIT', TYPE
                        GO TO 990
                        END IF
                     OUTREC = OUTREC + 1
 40                  CONTINUE
                  END IF
C                                       Close tables.
 80            IF (OPEN1) THEN
                  CALL TABIO ('CLOS', 0, INREC, RECORD, BUFF1, IER)
                  IF (IER.GT.0) THEN
                     WRITE (MSGTXT,1070) IER, 'CLOS', TYPE
                     GO TO 990
                     END IF
                  END IF
               OPEN1 = F
               IF (OPEN2) THEN
                  CALL TABIO ('CLOS', 0, OUTREC, RECORD, BUFF2, IER)
                  IF (IER.GT.0) THEN
                     WRITE (MSGTXT,1070) IER, 'CLOS', TYPE
                     GO TO 990
                     END IF
                  END IF
               END IF
 90         CONTINUE
 100     CONTINUE
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
      IF (OPEN1) CALL TABIO ('CLOS', 0, INREC, RECORD, BUFF1, IER)
      IF (OPEN2) CALL TABIO ('CLOS', 0, OUTREC, RECORD, BUFF2, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1070 FORMAT ('DSOUTA: ERROR ',I3,2X,A4,'ING ',A2,' TABLE')
      END

      PROGRAM AIPMAN
C-----------------------------------------------------------------------
C! AIPMAN reads and prints the AIPS manual from tape.
C# Service Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   AIPMAN reads and prints the AIPS manual from a tape written by
C   PRNTMN.  Line printer is logical unit 1, talks to unit 5.
C   The program assumes that the tape is written with 100 card images
C   per block in ASCII.
C-----------------------------------------------------------------------
      CHARACTER TEMP*4, PHNAME*48,  MSGBUF*80, TC(500)*6, TCNOW*6,
     *   TR(1000)*8, TRNOW*8, BUFF(100,2)*80, PRGNAM*6
      INTEGER   NTAPE, NLINES, NTC, NTR, IPAGE, TTYLUN, TTYIND, TTY(2),
     *   ILINES, IBUFF(1024), TCP(500), TRP(1000), I, J, MAXTC, MAXTR,
     *   TLUN, TIND, NBYTES, LPLUN, LPIND, I1, I2, IT, IP1, FLAG, IERR
      LOGICAL   FIRST, T, F, WASEOF, EQUAL, LEOF, LOPAGE, LRPAGE,
     *   EQUAL1, LASER
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMMON /MANCOM/ TLUN, TIND, NBYTES, LPLUN, LPIND
      COMMON /MANCHR/ TCNOW, TRNOW
      EQUIVALENCE (TTY(1), TTYLUN),  (TTY(2), TTYIND)
      DATA T, F /.TRUE.,.FALSE./
      DATA MAXTC, MAXTR /500,1000/
      DATA TTYLUN /5/
      DATA PRGNAM /'AIPMAN'/
C-----------------------------------------------------------------------
C                                        Initialize
      CALL AIPINI (TTY, PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 970
      NLINES = 0
      TCNOW = ' '
      TRNOW = ' '
      I1 = 1
      I2 = 2
      IPAGE = 0
      WASEOF = F
      NTC = 0
      NTR = 0
      FLAG = 1
      FIRST = T
C                                        Ask which tape drive?
 10   WRITE (MSGBUF,1000)
      CALL INQINT (TTY, MSGBUF, 1, NTAPE, IERR)
      IF (IERR.LT.0) GO TO 10
      IF (IERR.GT.0) GO TO 970
      NTAPE = MAX (1, NTAPE)
C                                        Is it a QMS laser printer?
      WRITE (MSGBUF,1010)
      CALL INQSTR (TTY, MSGBUF, 1, TEMP, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL CHLTOU (1, TEMP)
      LASER = TEMP(1:1).EQ.'Y'
      IF (LASER) FLAG = 2
C                                        Read first buffer.
      CALL GETREC (FIRST, NTAPE, BUFF(1,I1), IERR)
      IF (IERR.NE.0) GO TO 980
C                                        Label first page.
      CALL PAGER (FLAG, NLINES, IPAGE)
C                                        Begin main loop.
 100  CONTINUE
C                                        Read next buffer.
         CALL GETREC (FIRST, NTAPE, BUFF(1,I2), IERR)
         WASEOF = IERR.EQ.4
         IF ((IERR.NE.0) .AND. (IERR.NE.4)) GO TO 980
C                                        Loop thru first buffer.
         DO 300 I = 1,100
C                                        Check for special records.
            LOPAGE = BUFF(I,I1)(1:2).EQ.'@@'
            LRPAGE = (LOPAGE) .AND. (BUFF(I,I1)(3:4).EQ.'@@')
            LEOF   = BUFF(I,I1)(1:2) .EQ. '$$'
C                                        Check for end of file
            IF (LEOF) GO TO 500
C                                        If normal line print.
            IF (LOPAGE) GO TO 120
               WRITE (LPLUN,1100) BUFF(I,I1)
               NLINES = NLINES + 1
C                                        Check for new page.
               IF (NLINES.GT.PRTMAX-3) CALL PAGER (FLAG, NLINES, IPAGE)
               GO TO 300
C                                        New section.
 120        TCNOW = BUFF(I,I1)(5:10)
            TRNOW = BUFF(I,I1)(11:16)
C                                        Check for required page.
            IF ((.NOT.LRPAGE) .AND. (NLINES.LT.(PRTMAX-3))) GO TO 130
               CALL PAGER (FLAG, NLINES, IPAGE)
               GO TO 200
C                                        Check if next section will fit
C                                        on current page.
 130        CONTINUE
               ILINES = 6
               IP1 = I + 1
               DO 140 J = IP1,100
                  LOPAGE = BUFF(J,I1)(1:2).EQ.'@@'
                  LEOF   = BUFF(J,I1)(1:2).EQ.'$$'
                  IF (LOPAGE.OR.LEOF) GO TO 160
                     ILINES = ILINES + 1
 140              CONTINUE
C                                        Loop thru second buffer.
               IF (WASEOF) GO TO 160
                  DO 150 J = 1,100
                     LOPAGE = BUFF(J,I2)(1:2).EQ.'@@'
                     LEOF   = BUFF(J,I2)(1:2).EQ.'$$'
                     IF (LOPAGE.OR.LEOF) GO TO 160
                        ILINES = ILINES + 1
 150                 CONTINUE
C                                        Next section will fit.
 160           IF((NLINES+ILINES).GT.(PRTMAX-3)) GO TO 180
                  NLINES = NLINES + 6
                  WRITE (LPLUN,1160)
                  GO TO 200
C                                        New page.
 180           CONTINUE
                  CALL PAGER (FLAG, NLINES, IPAGE)
C                                        Chapter index entry.
 200        EQUAL = TCNOW .EQ. TC(NTC)
            EQUAL1 = TCNOW .EQ. '      '
            IF ((EQUAL1) .OR. ((NTC.NE.0) .AND. (EQUAL))) GO TO 210
            IF (NTC.GE.MAXTC) GO TO 210
               NTC = NTC + 1
               TC(NTC) = TCNOW
               TCP(NTC) = IPAGE
C                                        Section index entry.
 210        EQUAL = TRNOW .EQ. TR(NTR)
            EQUAL1 = TRNOW .EQ. '        '
            IF ((EQUAL1) .OR. ((NTR.NE.0).AND.(EQUAL))) GO TO 300
            IF (NTR.GE.MAXTR) GO TO 300
               NTR = NTR + 1
               TR(NTR) = TRNOW
               TRP(NTR) = IPAGE
 300        CONTINUE
C                                        Move BUFF2 to BUFF1
         IF (WASEOF) GO TO 500
            IT = I1
            I1 = I2
            I2 = IT
            GO TO 100
C                                        Finished - do index.
C                                        Chapter index.
 500  TCNOW = 'INDEX '
      TRNOW = ' '
      CALL PAGER (FLAG, NLINES, IPAGE)
      IF (NTC.LT.1) GO TO 525
         DO 520 I = 1,NTC
            IF (MOD (I,5).NE.0) GO TO 510
               NLINES = NLINES + 1
               IF (NLINES.GE.(PRTMAX-3))
     *            CALL PAGER (FLAG, NLINES, IPAGE)
               IF (NLINES.LT.(PRTMAX-3)) WRITE (LPLUN,1500)
 510        NLINES = NLINES + 1
            IF (NLINES.GE.(PRTMAX-3))
     *         CALL PAGER (FLAG, NLINES, IPAGE)
            WRITE (LPLUN,1510) TC(I), TCP(I)
 520        CONTINUE
C                                         Section index.
 525  NLINES = NLINES + 4
      IF ((NLINES.GT.PRTMAX-3) .AND. (NTR.GT.0)) WRITE (LPLUN,1525)
       DO 540 I = 1,NTR
         IF (MOD(I,5).NE.0) GO TO 530
            NLINES = NLINES + 1
            IF (NLINES.GE.(PRTMAX-3)) CALL PAGER (FLAG, NLINES, IPAGE)
            IF (NLINES.LT.(PRTMAX-3)) WRITE (LPLUN,1500)
 530     NLINES = NLINES + 1
         IF (NLINES.GE.(PRTMAX-3)) CALL PAGER (FLAG, NLINES, IPAGE)
         WRITE (LPLUN,1530) TR(I), TRP(I)
 540     CONTINUE
C                                        Finished - close printer.
      FLAG = -1
      IF (LASER) FLAG = -2
      CALL PAGER (FLAG, NLINES, IPAGE)
      GO TO 980
C                                       Error: TTY
 970  WRITE (MSGTXT,1970) IERR
      CALL MSGWRT (7)
C                                       Close TTY
 980  CALL ZCLOSE (TTYLUN, TTYIND, IERR)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('Enter tape drive number (I)')
 1010 FORMAT ('Is it a QMS laser printer? Yes or no (A4)')
 1100 FORMAT (1X,A80)
 1160 FORMAT (//////)
 1500 FORMAT ('   ')
 1510 FORMAT (26X,A6,4X,I5)
 1525 FORMAT (////)
 1530 FORMAT (26X,A8,4X,I5)
 1970 FORMAT ('TTY I/O ERROR = ',I6)
      END
      SUBROUTINE PAGER (FLAG, NLINES, IPAGE)
C-----------------------------------------------------------------------
C   PAGER  opens and closes the line printer and prints page headers.
C   Inputs:
C      FLAG    I    If 2 open laser file, then write laser commands
C                   and page header.
C                   If 1 open file then write page header.
C                   If 0 write page header.
C                   If -1 close line printer.
C      IPAGE    I   Page number.
C   In/Output:
C      NLINES   I   Line count initialized to 3
C      IPAGE    I   Page count incremented.
C-----------------------------------------------------------------------
      CHARACTER LPNAME*48, OUTFIL*48, TCNOW*6, TRNOW*8, CTYP(4)*2
      INTEGER   FLAG, NLINES, IPAGE, TIND, TLUN, NBYTES, LPLUN, LPIND,
     *    IERR, I
      LOGICAL   T, F
      COMMON /MANCOM/ TLUN, TIND, NBYTES, LPLUN, LPIND
      COMMON /MANCHR/ TCNOW, TRNOW
      DATA T, F /.TRUE.,.FALSE./
      DATA CTYP /'1C','2C','3C','4C'/
      DATA OUTFIL /' '/
C-----------------------------------------------------------------------
C                                        Check FLAG
      IF (FLAG) 300, 200, 100
C                                        Open
 100  LPLUN = 1
C                                       non-QMS
      IF (FLAG.EQ.2) GO TO 120
         CALL ZPHFIL ('LP', 1, 1, 1, LPNAME, IERR)
         CALL ZOPEN (LPLUN, LPIND, 1, LPNAME, F, T, T, IERR)
         GO TO 150
C                                       QMS
 120  CONTINUE
         LPIND = 0
         CALL ZLASIO ('POPN', LPLUN, OUTFIL, 1, LPNAME, IERR)
         IF (IERR.NE.0) GO TO 999
         WRITE (LPLUN, 1120)
         WRITE (LPLUN, 1121)
 150  IF (IERR.NE.0) GO TO 999
      FLAG = 0
C                                        Page header.
 200  IF (NLINES.EQ.3) GO TO 999
      IPAGE = IPAGE + 1
      NLINES = 3
      IF (IPAGE.GT.1) GO TO 210
         WRITE (LPLUN, 1200)
         GO TO 999
 210  CONTINUE
         DO 215 I = 1,4
            IF (CTYP(I).EQ.TCNOW(1:2)) GO TO 220
 215        CONTINUE
         WRITE (LPLUN,1215) TCNOW, TRNOW, IPAGE
         GO TO 999
 220  CONTINUE
         WRITE (LPLUN,1220) TCNOW, TRNOW, IPAGE
         GO TO 999
C                                        Close printer.
 300  IF (FLAG.EQ.-2) GO TO 320
         CALL ZCLOSE (LPLUN, LPIND, IERR)
         GO TO 999
 320  CONTINUE
         WRITE (LPLUN,1320)
         WRITE (LPLUN,1321)
         CALL ZLASIO ('CLOS', LPLUN, OUTFIL, 1, LPNAME, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1120 FORMAT (' ^PY^-')
 1121 FORMAT (' ^IOP^IL0600^IS404^IC1000^IJ00450^IT00700^N``PN`-')
 1200 FORMAT ('1',16X///)
 1215 FORMAT ('1',A6,22X,A8,22X,'PAGE',I7///)
 1220 FORMAT ('1','Volume ',A1,'  Chapter ',A2,' ',A2,13X,A8,15X,
     *   'PAGE',I7///)
 1320 FORMAT (' `PY`-')
 1321 FORMAT (' `N^^PN^-')
      END
      SUBROUTINE GETREC (FIRST, NTAPE, REC, IERR)
C-----------------------------------------------------------------------
C   GETREC reads the tape and returns 8000 byte records.  Will also
C   open and close tape file if necessary.
C   Inputs:
C      FIRST     L    If true then open tape.
C      NTAPE     I    Tape drive number.
C   Output:
C      REC(8000) C    Data record from tape.
C      IERR      I    Error code, 0=>OK, 4=>EOF, otherwise error.
C-----------------------------------------------------------------------
      CHARACTER REC*8000, TNAME*48
      INTEGER   NTAPE, IERR, TLUN, TIND, NBYTES, JERR, LPLUN, LPIND,
     *    LBYTES, LREC(4000)
      LOGICAL   T, F, FIRST
      INCLUDE 'INCS:DMSG.INC'
      COMMON /MANCOM/ TLUN, TIND, NBYTES, LPLUN, LPIND
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                        Initialize
      NBYTES = 8000
      TLUN = 30 + NTAPE
C                                        Check if need to open tape.
C                                        Open tape.
      IF (.NOT.FIRST) GO TO 100
         CALL ZPHFIL ('MT', NTAPE, 1, 1, TNAME, JERR)
         CALL ZTPOPN (TLUN, TIND, NTAPE, TNAME, 'READ', IERR)
         FIRST = F
         IF (IERR.NE.0) GO TO 999
C                                        Read record.
 100  CALL ZTPMIO ('READ', TLUN, TIND, NBYTES, LREC, 1, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL ZTPWAT (TLUN, TIND, 1, LBYTES, IERR)
      IF (IERR.NE.0) GO TO 900
      IF (LBYTES.LT.NBYTES-2) IERR = 3
      IF (LBYTES.LT.NBYTES-2) GO TO 900
      CALL ZC8CL (NBYTES, 1, LREC, REC)
      GO TO 999
C                                       Error:
 900  WRITE (MSGTXT,1900) LBYTES, IERR
      IF (IERR.NE.4) CALL MSGWRT (8)
      CALL ZTPCLS (TLUN, TIND, JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('GETREC: I/O ERROR: BYTES=',I8,' IERR=',I5)
      END

      SUBROUTINE FITBM (IFIELD, X, Y, CELLSP, ROT, BMAJ, BMIN, BPA)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FITBM fits an eliptical Gaussian given the least squares Hessian
C   matrix and residual vector.  If the fit fails a default Gaussian
C   with sigma of one cell is returned.
C   Inputs:
C      IFIELD  I      Field number in message, 0 => no field number
C                     < 0 => no message
C      X       R(3,3) Hessian matrix, (i,j) = SUM P_i * P_j where P_i is
C                     the partial derivative of each data point w.r.t
C                     parameter i and the sum is over all beam pixels
C                     included in the fit.  Parameter 1 is the
C                     coefficient of X*X, 2 of Y*Y and 3 of X*Y.
C      Y       R(3)   Residual vector (i) is the SUM over all included
C                     beam pixels of - ln(pixel_value) * P_i.
C      CELLSP  R      Cell spacing in arcseconds of the first axis.
C      ROT     R      Rotation angle on the sky in degrees.
C   Outputs:
C      BMAJ    R    Major axis size (FWHP in sec).
C      BMIN    R    Minor axis size (FWHP in sec).
C      BPA     R    Position angle of major axis (degrees).
C-----------------------------------------------------------------------
      REAL      X(3,3), Y(3), CELLSP, ROT, BMAJ, BMIN, BPA
      INTEGER   IFIELD
C
      INTEGER   JERR
      LOGICAL LERR
      CHARACTER PREFIX*5
      REAL      XFACT, C1, C2, C3, TEMP, S, C, SS, CC, XBMAJ, XBMIN
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      XFACT = ABS (CELLSP)
C                                       Solve linear equations.
C                                       Invert matrix
      CALL SYMINV (3, X, JERR)
C                                       Solution failed, write message
      IF (JERR.NE.0) THEN
         MSGTXT = 'FITBM: SOLUTION FOR RESTORING BEAM FAILED '
         CALL MSGWRT (6)
C                                       default = 3 cell circular.
         C1 = 1.5
         C2 = 1.5
         C3 = 0.0
C                                       Get Gaussian parameters
      ELSE
         C1 = Y(1) * X(1,1) + Y(2) * X(2,1) + Y(3) * X(3,1)
         C2 = Y(1) * X(1,2) + Y(2) * X(2,2) + Y(3) * X(3,2)
         C3 = Y(1) * X(1,3) + Y(2) * X(2,3) + Y(3) * X(3,3)
         END IF
C                                       Convert to sigmas and PA.
C                                       Make sure arg of ATAN
C                                       is determinate.
 100  IF (ABS (C1-C2).LT.1.0E-10) THEN
         BPA = SIGN (45.0, C3)
      ELSE
         BPA = 28.6478 * ATAN (C3 / (C1-C2))
         END IF
C                                       Compute sigma**2
      S = SIN (BPA/57.29578)
      C = COS (BPA/57.29578)
      SS = S * S
      CC = C * C
      IF (ABS (SS-CC) .GT. 1.0E-4) THEN
         BMAJ = 0.5 * (CC*CC - SS*SS) / (CC*C1 - SS*C2)
         BMIN = 0.5 * (SS*SS - CC*CC) / (SS*C1 - CC*C2)
C                                       Special case near 45 deg.
      ELSE
         BMAJ = C3 / (4.0 * S * C) + C1
         BMIN = 0.5 / (C1/CC - BMAJ)
         BMAJ = 0.5 / BMAJ
         END IF
C                                       Check if soln. is real
C                                       Use default
      IF ((BMAJ.LE.0.0) .OR. (BMIN.LE.0.0)) THEN
         C1 = 0.5
         C2 = 0.5
         C3 = 0.0
         MSGTXT = 'FITBM: SOLUTION FOR RESTORING BEAM FAILED '
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       Convert to sigmas.
      BMAJ = SQRT (BMAJ) * XFACT
      BMIN = SQRT (BMIN) * XFACT
C                                       Up to here BMAJ is minor
C                                       axis: rest of pgm wants it as
C                                       major - fix this here
      IF (BMAJ.GT.BMIN) THEN
         BPA = BPA - 90.0
      ELSE
         TEMP = BMAJ
         BMAJ = BMIN
         BMIN = TEMP
         END IF
C                                       Convert to FWHM
      BMAJ = BMAJ * 2.3548
      BMIN = BMIN * 2.3548
C                                       Add map rotation.
      BPA = BPA - ROT
      IF (BPA.GT.90.0) BPA = BPA - 180.0
      IF (BPA.LT.-90.0) BPA = BPA + 180.0
C                                       Write results.
C                                       Scale
      XBMAJ = BMAJ
      CALL METSCA (XBMAJ, PREFIX, LERR)
      XBMIN = BMIN * XBMAJ / BMAJ
      IF (IFIELD.EQ.0) THEN
         WRITE (MSGTXT,1100) XBMAJ, XBMIN, PREFIX, BPA
         CALL MSGWRT (4)
      ELSE IF (IFIELD.GT.0) THEN
         WRITE (MSGTXT,1110) IFIELD, XBMAJ, XBMIN, PREFIX, BPA
         CALL MSGWRT (4)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('Fit Gaussian FWHM = ',F8.3,' x ',F8.3,1X,A,'arcsec, PA=',
     *   F7.1)
 1110 FORMAT ('Field',I5,' fit FWHM= ',F8.3,' x ',F8.3,1X,A,
     *   'arcsec, PA=',F7.1)
      END

      SUBROUTINE MAPCOP (NAMIN, ONAME, NAMOUT, ERROR)
C-----------------------------------------------------------------------
C! Copy a map
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   WaWa IO system: Copy a map specified by NAMIN to a new map specified
C   by NAMOUT.  ONAME is a filled-in namestring representing, for
C   example, the original input map name.  It is used to provide
C   defaults for NAMOUT.
C   Inputs:
C      NAMIN   C*36  Namestring for input map (filled in)
C      ONAME   C*36  Namestring for original input image
C      NAMOUT  C*36  Namestring for output map (can include wildcards,
C                    blanks, etc.)
C   Outputs:
C      NAMIN   C*36  Changed to that actually used
C      NAMOUT  C*36  Changed to that actually used
C      ERROR   I     Error codes: 0 => ok
C                             1 => file not open
C                             2 => bad parameters
C                           3-6 => IO errors
C                            10 => catalog read/write... error
C                            12 => map not in catalog
C                            14 => no room in FILTAB or catlg
C                            21 => file already exists
C                            22 => volume unavailable
C                            23 => create error
C                            26 => open error
C   Written by WaWa (4/21/81)
C-----------------------------------------------------------------------
      CHARACTER NAMIN*(*), NAMOUT*(*), ONAME*(*)
      INTEGER   ERROR
C
      CHARACTER CHTM12*12, CHTM6*6, CHTM2*2, OPER*4, STAT*4
      LOGICAL   F, WASBLK, DONCR
      INTEGER   IERR, NX, NY, NDIM, IPLANE, NPLANE, DEP(5), LUN1, DUM,
     *   LUN2, FIND1, FIND2, IDINT, RDINT, BIND1, BIND2, BLK1, BLK2,
     *   DBLK1, DBLK2, IX, IY, CATER, NSUB, BUFSZ, I, IFIL, IFIL1,
     *   IFIL2, IND1, IND2
      REAL      XMAX, XMIN, TEMP
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA F /.FALSE./
      DATA DEP /2,1,1,1,1/
      DATA CATER /10/
      DATA LUN1, LUN2 /18, 19/
C-----------------------------------------------------------------------
      DONCR = .FALSE.
C                                       Open input file
      CALL FILOPN (LUN1, NAMIN, F, DUM, DUM, ERROR)
      IF (ERROR.NE.0) GO TO 999
C                                       Set up output header
 10   NX = CATBLK(KINAX)
      NY = CATBLK(KINAX+1)
      XMAX = CATR(KRDMX)
      XMIN = CATR(KRDMN)
C                                       If max,min not known, find them
      IF ((XMAX.NE.FBLANK) .AND. (XMIN.NE.FBLANK) .AND. (XMAX.GT.XMIN))
     *   GO TO 20
         CALL MAPMAX (LUN1, XMAX, XMIN, ERROR)
         IF (ERROR.EQ.0) GO TO 20
            WRITE (MSGTXT,1010) ERROR
            GO TO 990
C                                       Create output map
 20   CALL MAPCR (ONAME, NAMOUT, CATBLK, ERROR)
      IF (ERROR.NE.0) GO TO 999
      DONCR = .TRUE.
C                                       Open output map
      CALL FILOPN (LUN2, NAMOUT, F, DUM, DUM, ERROR)
      IF (ERROR.NE.0) GO TO 999
C                                       Find pointers
      DO 30 IFIL = 6,EFIL
         IF (FILTAB(POLUN,IFIL).EQ.LUN1) IFIL1 = IFIL
         IF (FILTAB(POLUN,IFIL).EQ.LUN2) IFIL2 = IFIL
 30      CONTINUE
C                                       Set status
      NSUB = 1
      OPER = 'CSTA'
      ERROR = CATER
      STAT = 'READ'
      CALL CATDIR ('CSTA', FILTAB(POVOL,IFIL1), FILTAB(POCAT,IFIL1),
     *   CHTM12, CHTM6, DUM, CHTM2, DUM, STAT, WBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      FILTAB(POIOP,IFIL1) = 2
      STAT = 'WRIT'
      CALL CATDIR ('CSTA', FILTAB(POVOL,IFIL2), FILTAB(POCAT,IFIL2),
     *   CHTM12, CHTM6, DUM, CHTM2, DUM, STAT, WBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      FILTAB(POIOP,IFIL2) = 1
      FIND1 = FILTAB(POFIN,IFIL1)
      FIND2 = FILTAB(POFIN,IFIL2)
      BUFSZ = 2 * LREAL
      IDINT = (IFIL2 - 6) * LREAL
      RDINT = (IFIL1 - 6) * LREAL
C                                       Determine # of planes
      NDIM = CATBLK(KIDIM)
      NPLANE = 1
      DBLK1 = 0
      DBLK2 = 0
      IF (NDIM.LE.2) GO TO 50
         DO 40 I = 3,NDIM
            NPLANE = NPLANE * CATBLK(KINAX+I-1)
 40         CONTINUE
         CALL COMOFF (NDIM, CATBLK(KINAX), DEP, DBLK1, IERR)
         CALL COMOFF (NDIM, CATBLK(KINAX), DEP, DBLK2, IERR)
 50   BLK1 = 1
      BLK2 = 1
      WASBLK = .FALSE.
C                                       Loop over planes
      DO 100 IPLANE = 1,NPLANE
         NSUB = 3
         OPER = 'WRIT'
         CALL MINIT ('WRIT', LUN2, FIND2, NX, NY, 0, RBUF(IDINT+1),
     *      BUFSZ, BLK2, ERROR)
         IF (ERROR.NE.0) GO TO 970
         OPER = 'READ'
         CALL MINIT ('READ', LUN1, FIND1, NX, NY, 0, RBUF(RDINT+1),
     *      BUFSZ, BLK1, ERROR)
         IF (ERROR.NE.0) GO TO 970
         NSUB = 4
         DO 90 IY = 1,NY
            OPER = 'READ'
            CALL MDISK ('READ', LUN1, FIND1, RBUF(RDINT+1), BIND1,
     *         ERROR)
            IF (ERROR.NE.0) GO TO 970
            OPER = 'WRIT'
            CALL MDISK ('WRIT', LUN2, FIND2, RBUF(IDINT+1), BIND2,
     *         ERROR)
            IF (ERROR.NE.0) GO TO 970
            IND1 = BIND1 + RDINT - 1
            IND2 = BIND2 + IDINT - 1
            DO 75 IX = 1,NX
               TEMP = RBUF(IND1+IX)
               IF (TEMP.EQ.FBLANK) WASBLK = .TRUE.
               RBUF(IND2+IX) = TEMP
 75            CONTINUE
 90         CONTINUE
         OPER = 'FINI'
         CALL MDISK ('FINI', LUN2, FIND2, RBUF(IDINT+1), BIND2, ERROR)
         IF (ERROR.NE.0) GO TO 970
         BLK1 = BLK1 + DBLK1
         BLK2 = BLK2 + DBLK2
 100     CONTINUE
C                                       Close files
      CALL FILCLS (LUN1)
      CATR(KRBLK) = 0.0
      IF (WASBLK) CATR(KRBLK) = FBLANK
      CALL CATIO ('UPDT', FILTAB(POVOL,IFIL2), FILTAB(POCAT,IFIL2),
     *   CATBLK, 'CLWR', WBUFF, IERR)
      CALL ZCLOSE (LUN2, FIND2, IERR)
      FILTAB(POLUN,IFIL2) = 0
      ERROR = 0
      GO TO 999
C                                       Error
 970  IERR = ERROR
C
 980  WRITE (MSGTXT,1980) SUBNAM(NSUB), OPER, IERR
C
 990  CALL MSGWRT (8)
C                                       Destroy output file
      IF (.NOT.DONCR) GO TO 999
         CALL FILCLS (LUN2)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('MAPFIX: MAX,MIN ERROR ',I6)
 1980 FORMAT ('MAPFIX: ',A6,2X,A4,' ERROR',I7)
      END

      SUBROUTINE GTWCRD (ICARD, NOSYM, NLIMIT, SYMTAB, FITBLK, NPNT,
     *   CARD, SYMBOL, TABNO, NFOUND, IFOUND, CVER, END, IERR)
C-----------------------------------------------------------------------
C! returns allowed keyword from FITS header card image
C# Parsing FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GTWCRD (get wild card) will unpack a given card image from a header
C   block of FITS data, search table SYMTAB for a recognizable key word
C   in the form KEYWORDn where 'n' is an integer between 1 and
C   NLIMIT(i) where i corresponds to the position of the keyword in
C   SYMTAB. If NLIMIT(i)=0 KEYWORD must match the SYMTAB entry exactly.
C   Inputs:
C      ICARD   I            the card image (1-36) in FITS data block.
C      NOSYM   I            the number of entries in key word table.
C      NLIMIT  I(NOSYM)     Upper limit on 'n'. 0 means KEYWORD must
C                           match symbol table value exactly.
C                           < 0 => must match char 2:N, return IFOUND
C      SYMTAB  C(NOSYM)*8   Keywords.
C      FITBLK  C*2880       the block of FITS header cards.
C   Outputs:
C      NPNT    I            Pointer in CARD after "="
C      CARD    C*80         Packed card.
C      SYMBOL  C*8          Symbol before "=" (unpacked)
C      TABNO   I            KEYWORD matches SYMTAB(TABNO).
C      NFOUND  I            Value of 'n' for KEYWORDn is the column
C                              number of the parameter
C      IFOUND  I            Value of 'i' for iKEYWnn is the axis number
C                              for array in cell
C      CVER    C*1          Coordinate version code: 'C' in iKEYWnnC
C      END     L            True if end card found, else false.
C      IERR    I            0=match found, 1=no match on otherwise
C                           valid keyword, 2=card ends or other trouble
C-----------------------------------------------------------------------
      INTEGER   ICARD, NOSYM, NLIMIT(*), NPNT, TABNO, NFOUND, IFOUND,
     *   IERR
      LOGICAL   END
      CHARACTER SYMTAB(*)*8, FITBLK*2880, CARD*80, SYMBOL*8, CVER*1
C
      CHARACTER TABSYM*8
      INTEGER   ITYP, ILEN, ILEN2, INC, JTRIM, IP, KBP
C-----------------------------------------------------------------------
      IERR = 0
      END = .FALSE.
      CVER = ' '
      NFOUND = 0
      IFOUND = 0
C                                       Unpack new card.
      INC = (ICARD - 1) * 80 + 1
      CARD = FITBLK(INC:INC+79)
      ILEN = JTRIM (CARD)
C                                       Get next symbol on card
      NPNT = 1
      CALL GETSSY (CARD, NPNT, SYMBOL, ITYP)
C                                       Test for END card.
      IF (SYMBOL.EQ.'END') THEN
         END = .TRUE.
C                                       No KEYWORD= format.
      ELSE IF (ITYP.NE.0) THEN
         IERR = 2
C                                       Check KEYWORD= for recognizable
C                                       symbol.
      ELSE
         DO 100 TABNO = 1,NOSYM
            TABSYM = SYMTAB(TABNO)
            ILEN = 8
            IP = 1
            IF (NLIMIT(TABNO).LT.0) IP = 2
            IF (NLIMIT(TABNO).NE.0) CALL CHTRIM (TABSYM, 8, TABSYM,
     *         ILEN)
C                                       Character parts are equal.
            IF (SYMBOL(IP:ILEN).EQ.TABSYM(IP:ILEN)) THEN
               NFOUND = 0
               IFOUND = 0
               IERR = 0
               ILEN = ILEN + 1
               IF (ILEN.LE.8) THEN
                  TABSYM = SYMBOL
                  CALL CHTRIM (TABSYM, 8, TABSYM, ILEN2)
                  IF (IP.EQ.2) THEN
                     KBP = 1
                     CALL GETINT (TABSYM, 8, KBP, IFOUND)
                     END IF
                  KBP = ILEN
                  CALL GETINT (TABSYM, 8, KBP, NFOUND)
                  IF (KBP.LE.8) CVER = TABSYM(KBP:KBP)
                  END IF
               IF (NFOUND.LE.ABS(NLIMIT(TABNO))) GO TO 999
               END IF
 100        CONTINUE
C                                       Keyword but not in list
         IERR = 1
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'UVHOL.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      CHARACTER NAMEIN*12, CLAIN*6, LPNAME(4)*96, TITL1*132, TITL2*132,
     *   SCRTCH*132, LINE*132, CHSIG1*1, CHSIG2*1, OPER*4, DATOBS*8
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4,30), XCALC(1), XLPNAM(12),
     *   XOPER(1), XSTOK(1)
      REAL      XSIN, XDISIN, XQUAL, XBAND, XFREQ, XFQID, XTIME(8),
     *   XANT(50), XBASE(50), XSUBA, XCHANS(4,20), XBIF, XDOCAL,
     *   XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER,
     *   XSMOTH(3), XNCNT, XUVFAC, XNPTS, XOTFM, APARM(10), DPARM(10),
     *   XBDROP, DOCRT, PIXRNG(2), FACTOR, SYMBOL, DO3COL, XLTYPE,
     *   XDOTV, XGRCHN, XYRATO, XBADD(10)
      REAL      BUFF(UVBFSS), XAMP, XWT, NWT, UVM, WBASE, ACH,
     *   RNGPIX(2), FLUXS
      INTEGER   UVINC, SEQIN, DISKIN, LUNI, INDI, JBUFSZ, IANT(50),
     *   NANT, IBAS(50), NBAS, CNOIN, NACROS, OTYPE, NCOLS, LUNP(4),
     *   FINDP(4), PAGE, IPCNT, HM(2), DD(2), LQUAL, NSTKS, NPARM,
     *   CHNSEL(3,20), NFIT, SCRBUF(512)
      LOGICAL   MULTI, DESEL, ISCROS(4), LPOPN(4), DOCONV, OTFMOD
      DOUBLE PRECISION LFREQ
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XSTOK, XBAND, XFREQ, XFQID, XTIME, XANT, XBASE, XSUBA, XCHANS,
     *   XBIF, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND,
     *   XBPVER, XSMOTH, XNCNT, XUVFAC, XOPER, XNPTS, XOTFM, APARM,
     *   XBDROP, DPARM, DOCRT, XLPNAM, PIXRNG, FACTOR, SYMBOL, DO3COL,
     *   XLTYPE, XDOTV, XGRCHN, XYRATO, XBADD
      COMMON /CHPARM/ NAMEIN, CLAIN, LPNAME, TITL1, TITL2, SCRTCH,
     *   LINE, OPER, CHSIG1, CHSIG2, DATOBS
      COMMON /BUFRS/ BUFF, SCRBUF, JBUFSZ
      COMMON /UVPCOM/ LFREQ, MULTI, UVINC, SEQIN, DISKIN, LUNI, INDI,
     *   CNOIN, NACROS, OTYPE, NCOLS, LUNP, FINDP, PAGE, IPCNT, HM, DD,
     *   LQUAL, XAMP, XWT, NWT, UVM, ISCROS, LPOPN, NSTKS, DOCONV,
     *   WBASE, CHNSEL, ACH, NPARM, RNGPIX, FLUXS, NFIT, OTFMOD
      COMMON /BASSEL/ DESEL, IANT, NANT, IBAS, NBAS
LOCAL END
LOCAL INCLUDE 'PARAL.INC'
      LOGICAL   DOPARA
      COMMON /PARALL/ DOPARA
LOCAL END
LOCAL INCLUDE 'SAMBUF.INC'
      INTEGER   MSAMP
      PARAMETER (MSAMP=10000)
      INTEGER   RPMM(2,MSAMP)
      REAL      RPTIME(MSAMP), RPUV(2,MSAMP), VIS(7,4,MSAMP)
      COMMON /SAMBUF/ RPTIME, RPUV, VIS, RPMM
LOCAL END
LOCAL INCLUDE 'UVHPLT.INC'
      INTEGER   MAXPLT
      PARAMETER (MAXPLT=50000)
C
      INTEGER   PLANTS(2), PLPNT
      REAL      PLAMP(MAXPLT,4), PLPHAS(MAXPLT,4), PLEAMP(MAXPLT,4),
     *   PLEPHS(MAXPLT,4), PLU(MAXPLT), PLV(MAXPLT), PLTI(MAXPLT)
      COMMON /UVHPLT/ PLAMP, PLPHAS, PLEAMP, PLEPHS, PLU, PLV, PLTI,
     *   PLANTS, PLPNT
LOCAL END
      PROGRAM UVHOL
C-----------------------------------------------------------------------
C! UVHOL prints holography uvdata with calibration
C# Printer appl UV-util VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1999-2000, 2003-2007, 2009-2012, 2014-2018, 2020-2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVHOL prints and plots uv holography data with calibration.
C   Inputs:
C      INNAME         NAMEIN        File name to be imaged
C      INCLASS        CLAIN         File class to be imaged
C      INSEQ          SEQIN         File sequence number
C      INDISK         DISKIN        Disk volume on which file resides
C      SOURCES        XSOUR(4,30)   Sources selected
C      QUAL           XQUAL         Source qualifier #, -1 => all
C      CALCODE                      Calibrator code, ' ' all
C      SELBAND        XBAND         Bandwidth to select (kHz)
C      SELFREQ        XFREQ         Frequency to select (MHz)
C      FREQID         XFQID         Freq. ID to select.
C      TIMERANG       XTIME(8)      Timerange
C      ANTENNAS       XANT(50)      Antenna numbers
C      BASELINE       XBASE(50)     Antenna numbers to pair up
C      UVRANGE        UVRANG        Range of UV in 1000s wavelengths
C      SUBARRAY       SUBARR        Subarray: 0 => all
C      CHANNEL        XCHAN         Channel number
C      BIF            XBIF          IF number: begin
C      DOCALIB        DOCAL         Calibrate?
C      GAINUSE        GAUSE         CL version to apply.
C      DOPOL                        If >0 correct polarization.
C      BLVER                        BL table to apply.
C      FLAGVER        FGVER         Flag table version
C      DOBAND                       Bandpass calibration?
C      BPVER                        BP table to apply
C      SMOOTH                       Smoothing function
C      NCOUNT         XNCNT         # samples printed
C      DOCRT          DOCRT         <= 0 use line printer/file, > 0
C                                   use CRT, >72 -> CRT width
C      OUTPRINT       XLPNAM        File name to hold line printer out
C      BADDISK        XBADD(10)     Disks to avoid for scratch
C-----------------------------------------------------------------------
      CHARACTER  PRGM*6
      INTEGER  IRET
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'UVHOL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA PRGM /'UVHOL '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL UVHOIN (PRGM, IRET)
C                                       check line printer job size
      OTFMOD = XOTFM.GT.0.0
      IF (OTFMOD) XNPTS = 1.0
      IF (IRET.EQ.0) CALL UVHOCH (IRET)
C                                       Do print scaling, uv init
      IF ((IRET.EQ.0) .AND. (DPARM(1).LT.0.0)) CALL UVHOSC (IRET)
C                                       Do print
      IF (IRET.EQ.0) THEN
         IF (OPER.EQ.'PLOT') THEN
            CALL UVHOPL (IRET)
         ELSE
            CALL UVHODO (IRET)
            END IF
         END IF
C                                       Close down
      CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE UVHOIN (PRGM, IRET)
C-----------------------------------------------------------------------
C   UVPIN gets input parameters for UVHOL.
C   Inputs:
C      PRGM   C*6   Program name
C    Output:
C      IRET   I      Error code: 0 => ok, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
C
      CHARACTER UTYPE*2, STAT*4, JSTOKE(13)*2
      INTEGER   IUSER, I, IERR, IROUND, LUNTB, LUN, JS, J, K
      LOGICAL   T, TABLE, FITASC, F, MATCH, SNEXST
      REAL      CATR(256), RTEMP
      DOUBLE PRECISION CATD(128)
      HOLLERITH CATH(256)
      INCLUDE 'UVHOL.INC'
      INCLUDE 'PARAL.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DSOU.INC'
      EQUIVALENCE (CATBLK, CATR, CATD, CATH)
      DATA T, F /.TRUE., .FALSE./
      DATA LUNTB /39/
      DATA JSTOKE /'HV','VH','HH','VV','LR','RL','LL','RR','  ','I',
     *   'Q','U','V'/
C-----------------------------------------------------------------------
C                                       Init IO et al.
      TSKNAM = PRGM
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      LPOPN(1) = .FALSE.
      LPOPN(2) = .FALSE.
      LPOPN(3) = .FALSE.
      LPOPN(4) = .FALSE.
C                                       Get input parameters.
      NPARM = 392
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMEI, SCRBUF, IRET)
      IF (IRET.NE.0) THEN
         RQUICK = .TRUE.
         IF (IRET.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF ((IRET.NE.0) .OR. (NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   DOCRT = MIN (-1.0, DOCRT)
      IF (IRET.EQ.0) THEN
         CALL H2CHR (4, 1, XOPER, OPER)
         IF (OPER.EQ.'HOLG') DOCRT = MIN (-1.0, DOCRT)
         IF (OPER.EQ.'PLOT') DOCRT = MIN (-1.0, DOCRT)
         END IF
      RQUICK = (RQUICK) .AND. (DOCRT.LE.0.0)
      IF (RQUICK) CALL RELPOP (IRET, SCRBUF, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
      DOPARA = APARM(10).GT.0.0
      RNGPIX(1) = PIXRNG(1)
      RNGPIX(2) = PIXRNG(2)
C                                       Hollerith -> Char
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (4, 1, XSTOK, STOKES)
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
C                                       scaling
      IF (DPARM(1).GE.0.0) THEN
         IF (DPARM(2).LE.0.0) DPARM(2) = 99.9
         IF (DPARM(3).LE.0.0) DPARM(3) = 0.11
         IF (DPARM(4).LE.0.0) DPARM(4) = 9.9
         IF (DPARM(5).LE.0.0) DPARM(5) = 99.9
         XWT = DPARM(2)
         NWT = DPARM(3)
         XAMP = DPARM(4)
         UVM = DPARM(5)
         END IF
      IF ((APARM(7).GT.0.0) .OR. (DPARM(7).GT.0.0)) DPARM(6) = 0.0
C                                       Crunch input parameters.
      IUSER = NLUSER
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
C                                       Get CATBLK from file.
      LUNI = 48
      UTYPE = 'UV'
      STAT = 'INIT'
      CALL MAPOPN (STAT, DISKIN, NAMEIN, CLAIN, SEQIN, UTYPE, IUSER,
     *   LUNI, INDI, CNOIN, CATBLK, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         GO TO 990
         END IF
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
      XDISIN = DISKIN
      XSIN = SEQIN
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 0
      CALL H2CHR (8, 1, CATH(KHDOB), DATOBS)
      MSGTXT = 'DATE-OBS = ''' // DATOBS // ''''
      CALL MSGWRT (5)
C                                       Multi-source file?
      CALL MULSDB (CATBLK, MULTI)
      IF (MULTI) THEN
         CALL ISTAB ('SU', DISKIN, CNOIN, 1, LUNTB, SCRBUF, TABLE,
     *      MULTI, FITASC, IERR)
         MULTI = MULTI .AND. (IERR.EQ.0)
         END IF
      IF (.NOT.MULTI) DPARM(10) = 0.0
C                                       If calibrating, does SN exist
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
C                                       Look for SN file
      IF ((DOCAL) .AND. (.NOT.MULTI)) THEN
         CALL ISTAB ('SN', DISKIN, CNOIN, 1, LUNTB, SCRBUF,
     *      TABLE, SNEXST, FITASC, IERR)
         IF ((.NOT.SNEXST) .OR. (IERR.NE.0)) THEN
            WRITE (MSGTXT,1020)
            CALL MSGWRT (8)
            DOCAL = .FALSE.
            END IF
         END IF
      XSIN = SEQIN
      XDISIN = DISKIN
C                                       Get uv header info.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      CALL RCOPY (8, XTIME, TIMRNG)
      BCHAN = 1
      ECHAN = CATBLK(KINAX+JLOCF)
      IF (JLOCIF.LT.0) THEN
         BIF = 1
      ELSE
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, CATBLK(KINAX+JLOCIF)))
         END IF
      EIF = BIF
      DOPOL = IROUND (XDOPOL)
      IF ((DOPOL.EQ.0) .AND. (XDOPOL.GT.0.0)) DOPOL = 1
      PDVER = IROUND (XPDVER)
      DOAPPL = F
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LE.0) SUBARR = 1
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      SELQUA = IROUND (XQUAL)
C                                       channel sel
      K = 0
      CALL FILL (60, 0, CHNSEL)
      DO 20 J = 1,20
         I = IROUND (XCHANS(2,J))
         IF (I.GT.0) THEN
            I = IROUND (XCHANS(4,J))
            IF ((I.LE.0) .OR. (I.EQ.BIF)) THEN
               CHNSEL(1,K+1) = IROUND (XCHANS(1,J))
               IF (CHNSEL(1,K+1).LE.ECHAN) THEN
                  K = K + 1
                  CHNSEL(2,K) = IROUND (XCHANS(2,J))
                  CHNSEL(3,K) = IROUND (XCHANS(3,J))
                  IF (CHNSEL(3,K).LE.0) CHNSEL(3,K) = 1
                  END IF
               END IF
            END IF
 20      CONTINUE
      IF (K.EQ.0) THEN
         MSGTXT = 'Using default ICHANSEL = inner 3/4'
         CALL MSGWRT (2)
         CHNSEL(1,1) = (ECHAN+1)/8 + 1
         CHNSEL(2,1) = ECHAN - ((ECHAN+1)/8)
         CHNSEL(3,1) = 1
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
C                                       Find specified FQ id
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, IRET)
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1030)
         IRET = 1
         GO TO 990
         END IF
      IF (IRET.GT.0) GO TO 999
C                                       get average channel and freq
      CALL SETFRQ (IRET)
      IF (IRET.GT.0) GO TO 999
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
      DO 40 I = 1,10
         IBAD(I) = IROUND (XBADD(I))
 40      CONTINUE
C                                       Clear antenna selection
C                                       criteria for UVGET
      CALL FILL (50, 0, ANTENS)
C                                       Holography
      CALL SETANT (50, XANT, XBASE, NANT, NBAS, IANT, IBAS, DESEL)
      ANTENS(1) = IANT(1)
      ANTENS(2) = IBAS(1)
      IF ((IANT(1).LE.0) .OR. (IBAS(1).LE.0) .OR. DESEL) THEN
         IRET = 1
         MSGTXT = 'HOLOGRAPHY REQUIRES ANTEN(1) AND BASELI(1), NO DESEL'
         GO TO 990
         END IF
C                                       get antenna info
      CALL GETANT (DISKIN, CNOIN, SUBARR, CATBLK, SCRBUF, IRET)
      IF (ANAME.EQ.'EVLA') THEN
         WBASE = 0.0
         LQUAL = 40000
      ELSE
         WBASE = 40000.0
         LQUAL = 0
         END IF
C                                       Decode printer parms
C                                       Open "line printer"
      IF ((OPER.NE.'HOLG') .AND. (OPER.NE.'PLOT')) THEN
         LPNAME(1) = ' '
         CALL H2CHR (48, 1, XLPNAM, LPNAME(1))
         IF (LPNAME(1).EQ.' ') DOCRT = MAX (-1.0, DOCRT)
         CALL LPOPEN (LPNAME(1), DOCRT, LUNP(1), FINDP(1), NACROS,
     *      SCRBUF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1040) IRET
            GO TO 990
            END IF
         LPOPN(1) = .TRUE.
      ELSE
         NACROS = 132
         END IF
      IF (XNCNT.LT.1.0) THEN
         XNCNT = PRTMAX - 10
         IF ((DOCRT.GT.0.0).OR.(LPNAME(1)(1:1).NE.' ')) XNCNT = 30000
         END IF
      IF ((OPER.EQ.'HOLG') .OR. (OPER.EQ.'PLOT')) THEN
         XNCNT = 1000000
         IF ((XUVFAC.LT.0.1) .OR. (XUVFAC.GT.10.0)) THEN
            MSGTXT = 'LM scaling factor changed to 1.0'
            IF (XUVFAC.GT.0.) CALL MSGWRT (2)
            XUVFAC = 1.0
            END IF
      ELSE
         IF (XUVFAC.LE.1.E-10) XUVFAC = 1000.0
         END IF
C                                       Check STOKES - requested
      JS = 14
      NSTKS = CATBLK(KINAX+JLOCS)
      IF (NSTKS.EQ.1) THEN
         RTEMP = CATD(KDCRV+JLOCS) + (1 - CATR(KRCRP+JLOCS)) *
     *      CATR(KRCIC+JLOCS)
         J = IROUND (RTEMP) + 9
         STOKES = JSTOKE(J)
         DOCONV = .FALSE.
      ELSE IF (NSTKS.EQ.2) THEN
         DOCONV = (STOKES(1:1).EQ.'I') .AND. (ICOR0.LT.0)
         IF (OPER.EQ.'HOLG') JS = 15
         IF (OPER.EQ.'PLOT') JS = 15
         IF (.NOT.DOCONV) THEN
            STOKES = 'HALF'
         ELSE
            IF (OPER.NE.'PLOT') STOKES = 'IV'
            IF (CATD(KDCRV+JLOCS).LE.-5.0D0) STOKES = 'I'
            END IF
      ELSE IF (NSTKS.EQ.4) THEN
         DOCONV = STOKES(1:1).EQ.'I'
         NSTKS = 2
         IF (STOKES.EQ.'IQU') STOKES = 'IQUV'
         IF (STOKES.EQ.'FULL') NSTKS = 4
         IF (STOKES.EQ.'IQUV') NSTKS = 4
C                                       Holography = RR and LL only
         IF ((OPER.EQ.'HOLG') .OR. (OPER.EQ.'PLOT')) THEN
            IF (DOCONV) THEN
               IF (STOKES.NE.'IQUV') THEN
                  IF (OPER.NE.'PLOT') STOKES = 'IV'
                  IF (CATD(KDCRV+JLOCS).LE.-5.0D0) STOKES = 'I'
                  JS = 15
                  END IF
            ELSE
               IF (STOKES.NE.'FULL') THEN
                  STOKES = 'HALF'
                  JS = 15
                  END IF
               END IF
         ELSE
            STOKES = 'FULL'
            IF (DOCONV) STOKES = 'IQUV'
            END IF
         END IF
      IF (STOKES.EQ.'I') NSTKS = 1
      ISCROS(1) = F
      ISCROS(2) = F
      ISCROS(3) = F
      ISCROS(4) = F
      NCOLS = 1
      IF (JS.EQ.14) THEN
         NCOLS = 4
         IF (DOCONV) THEN
            ISCROS(2) = T
            ISCROS(3) = T
         ELSE
            ISCROS(3) = T
            ISCROS(4) = T
            END IF
      ELSE
         NCOLS = 2
         IF (STOKES.EQ.'I') NCOLS = 1
         END IF
      NCOLS = MIN (NCOLS, CATBLK(KINAX+JLOCS))
C                                    Determine output type
      IF (NACROS.GE.46+19*NCOLS) THEN
         OTYPE = 1
      ELSE IF (NACROS.GE.41+18*NCOLS) THEN
         OTYPE = 2
      ELSE IF (NACROS.GE.37+17*NCOLS) THEN
         OTYPE = 3
      ELSE IF (NACROS.GE.35+15*NCOLS) THEN
         OTYPE = 4
      ELSE IF (NACROS.GE.16+14*NCOLS) THEN
         OTYPE = 5
      ELSE
         MSGTXT = 'FORMAT TOO WIDE FOR PRINTER: CHANGE STOKES'
         IRET = 2
         GO TO 990
         END IF
C                                       flux scaling
      IF (DPARM(10).LE.0.0) THEN
         FLUXS = 1.0
      ELSE
         CALL FNDSOU (DISKIN, CNOIN, SOURCS, BLBUFF, NSOUWD, DOSWNT,
     *      SOUWAN, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1900) IRET, 'FINDING SOURCE NUMBER'
            GO TO 990
            END IF
         CALL GETSOU (SOUWAN(1), DISKIN, CNOIN, CATBLK, LUN, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1900) IRET, 'GETTING SOURCE FLUXES'
            GO TO 990
            END IF
         FLUXS = FLUX(1,BIF)
         IF (FLUXS.LE.0.0) FLUXS = 1.0
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVPIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('ERROR',I3,' FINDING THE UV DATA SET')
 1020 FORMAT ('NO SN FILE FOUND, BUT DOCALIB IS TRUE: NO CAL APPLIED')
 1030 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
 1040 FORMAT ('ERROR',I5,' OPENING OUTPUT DEVICE')
 1900 FORMAT ('UVPIN ERROR',I4,' ON ',A)
      END
      SUBROUTINE SETFRQ (IRET)
C-----------------------------------------------------------------------
C   Find average channel number and frequency of observation
C   Output:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'UVHOL.INC'
      INTEGER  NUMC, I, J, LUNO, LUNTMP, VER
      REAL     SUMC, CATR(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCHND.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (CATBLK, CATD, CATR)
C-----------------------------------------------------------------------
C                                       average channel
      NUMC = 0
      SUMC = 0.0
      DO 20 J = 1,20
         IF ((CHNSEL(1,J).GT.0) .AND. (CHNSEL(2,J).GT.0) .AND.
     *      (CHNSEL(2,J).GE.CHNSEL(1,J))) THEN
            DO 10 I = CHNSEL(1,J),CHNSEL(2,J)
               NUMC = NUMC + 1
               SUMC = SUMC + I
 10            CONTINUE
            END IF
 20      CONTINUE
      IF (NUMC.LT.1) THEN
         MSGTXT = 'NO CHANNELS SPECIFIED'
         GO TO 990
         END IF
      ACH = SUMC / NUMC
C                                       frequencies
      LUNO = LUNTMP (1)
C                                       get FQ settings first
      VER = 1
      CALL CHNDAT ('READ', SCRBUF, DISKIN, CNOIN, VER, CATBLK, LUNO,
     *   NUMIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING FQ TABLE FOR VELOCITIES'
         GO TO 990
         END IF
      LFREQ = CATD(KDCRV+JLOCF) + FOFF(BIF) + (ACH - CATR(KRCRP+JLOCF))
     *   * FINC(BIF)
      LFREQ = LFREQ * 1.D-9
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SETFRQ ERROR',I4,' ON ',A)
      END
      SUBROUTINE CHWANT (NC, NI, CHNSEL, CHFLGS)
C-----------------------------------------------------------------------
C   Makes a mask of the desired channels
C   Inputs:
C      NC       I            Number spectral chans
C      NI       I            Number IFs
C      CHNSEL   I(3,20,*)    Start, stop, incr 20 sets per IF
C   Outputs
C      CHFLGS   I(*,*)       1 => use, 0 => don't use
C-----------------------------------------------------------------------
      INTEGER   NC, NI, CHNSEL(3,20,*), CHFLGS(NC,NI)
C
      INTEGER   I, J, K
C-----------------------------------------------------------------------
      J = NC * NI
      CALL FILL (J, 0, CHFLGS)
      DO 30 K = 1,NI
         DO 20 J = 1,20
            IF ((CHNSEL(1,J,K).GT.0) .AND. (CHNSEL(3,J,K).GT.0) .AND.
     *         (CHNSEL(2,J,K).GE.CHNSEL(1,J,K))) THEN
               DO 10 I = CHNSEL(1,J,K),CHNSEL(2,J,K),CHNSEL(3,J,K)
                  CHFLGS(I,K) = 1
 10               CONTINUE
               END IF
 20         CONTINUE
 30      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE DATAVG (NC, NS, CHFLGS, VIS, FLUXS, AVIS)
C-----------------------------------------------------------------------
C   DATAVG averages a spectrum
C   Inputs:
C      NC       I      Number spectral channels
C      NS       I      Number Stokes
C      CHFLGS   I(*)   =1 -> use channel
C      VIS      R(3,*)   Input vis
C      FLUXS    R      scale by flux
C   Outputs:
C      AVIS     R(3,*)   Average vis
C-----------------------------------------------------------------------
      INTEGER   NC, NS, CHFLGS(*)
      REAL      VIS(3,*), FLUXS, AVIS(7,*)
C
      INTEGER   IS, IC, I
C-----------------------------------------------------------------------
      I = 7 * NS
      CALL RFILL (I, 0.0, AVIS)
      I = 1
      DO 20 IC = 1,NC
         IF (CHFLGS(IC).GT.0) THEN
            DO 10 IS = 1,NS
               IF (VIS(3,I).GT.0.0) THEN
                  AVIS(1,IS) = AVIS(1,IS) + VIS(3,I) * VIS(1,I)
                  AVIS(2,IS) = AVIS(2,IS) + VIS(3,I) * VIS(2,I)
                  AVIS(4,IS) = AVIS(4,IS) + VIS(3,I) * (VIS(1,I) ** 2)
                  AVIS(5,IS) = AVIS(5,IS) + VIS(3,I) * (VIS(2,I) ** 2)
                  AVIS(3,IS) = AVIS(3,IS) + VIS(3,I)
                  AVIS(6,IS) = AVIS(6,IS) + 1.0
C                 AVIS(7,IS) = AVIS(7,IS) + VIS(3,I) *
C    *               SQRT (VIS(1,I)*VIS(1,I) + VIS(2,I)*VIS(2,I))
                  END IF
               I = I + 1
 10            CONTINUE
         ELSE
            I = I + NS
            END IF
 20      CONTINUE
      IF (FLUXS.LE.0.0) FLUXS = 1.0
      DO 30 IS = 1,NS
         IF (AVIS(3,IS).GT.0.0) THEN
            AVIS(1,IS) = AVIS(1,IS) / AVIS(3,IS) / FLUXS
            AVIS(2,IS) = AVIS(2,IS) / AVIS(3,IS) / FLUXS
            AVIS(4,IS) = AVIS(4,IS) / AVIS(3,IS) / FLUXS / FLUXS
            AVIS(5,IS) = AVIS(5,IS) / AVIS(3,IS) / FLUXS / FLUXS
C            AVIS(7,IS) = AVIS(7,IS) / AVIS(3,IS)
            AVIS(7,IS) = SQRT (AVIS(1,IS)**2 + AVIS(2,IS)**2)
            END IF
 30      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE UVHOSC (IRET)
C-----------------------------------------------------------------------
C   determines scaling parameters
C   Output:
C      IRET     I      Return code, 1=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   IROUND, K, IA1, IA2, PCOUNT, SOUID, OLDSOU, LBL, JERR,
     *   IUSER, JTT(3), JJTT(4), M, KBL, MBAS, MANT, LASTM, NOPTIO,
     *   NNBEG, NNEND, NSAMP , INVERT, I, ISAMP, KSAMP, MINSAM, NPOINT,
     *   NN
      LOGICAL   REQBAS, UVOPN, DOAVER, DOMAVE, DOTIME, FINISH
      REAL      AMP, WEIGHT, YAMP, U, V, W, XX, YY, RPARM(20), NSTIME,
     *   CATR(256), EPS, VDAT(28)
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'UVHOL.INC'
      INCLUDE 'SAMBUF.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DFIL.INC'
      INTEGER   CHFLGS(MAXCHA)
      EQUIVALENCE (JJTT, JTT)
      EQUIVALENCE (CATBLK, CATR)
C-----------------------------------------------------------------------
C                                       init the range parameters
      EPS = 0.1 / (3600. * 24.)
      LASTM = -40001
      XAMP = 0.0
      UVM = 0.0
      XWT = 0.0
      NWT = 1.E10
      MSGTXT = 'Finding the scaling parameters to set formats'
      CALL MSGWRT (1)
      CALL CHWANT (ECHAN, 1, CHNSEL, CHFLGS)
C                                       Set pointers, counters
      LBL = 1
      KBL = 1
      MBAS = 1
      MANT = 1
      DOAVER = APARM(5).GT.0.0
      IF (DOAVER) MANT = NANT
      DOMAVE = APARM(8).GT.0.0
      IF (DOMAVE) MBAS = NBAS
      DOTIME = APARM(6).GT.0.0
      NOPTIO = APARM(1) + 0.1
      NNBEG = APARM(2) + 0.1
      NNEND = APARM(3) + 0.1
      MINSAM = XBDROP + 0.1
      NPOINT = XNPTS + 0.1
      IF (NPOINT.LE.0) NPOINT = 100
C                                       Timerange
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
C                                       Set time range.
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.)
     *   + TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.)
     *   + TIMRNG(8) / (24. * 60. * 60.)
C                                       Holography loop point
 20   UVOPN = .FALSE.
      OLDSOU = -1
      CALL COPY (MANT, IANT(KBL), ANTENS)
      CALL COPY (MBAS, IBAS(LBL), ANTENS(MANT+1))
C                                      first page
      IUSER = NLUSER
      INITVS = 1
C                                       Initialize reading VIS. file.
      CALL UVGET ('INIT', RPARM, BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT, 1090) IRET
         CALL MSGWRT (8)
         IRET = 4
         GO TO 970
         END IF
      UVOPN = .TRUE.
      PCOUNT = XNCNT
      IF ((OPER.NE.'HOLG') .AND. (OPER.NE.'PLOT')) PCOUNT = 0
      SOUID = 1
      IF (NSOUWD.EQ.1) SOUID = SOUWAN(1)
C                                       zero summing arrays
      NSAMP = 0
      CALL RFILL (MSAMP, 0.0, RPTIME)
      CALL RFILL (2*MSAMP, 0.0, RPUV)
      CALL FILL (2*MSAMP, 0, RPMM)
      CALL RFILL (28*MSAMP, 0.0, VIS)
      NSTIME = -100.0
C                                       Start looping thru data.
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, BUFF, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         CALL MSGWRT (8)
         IRET = 4
         GO TO 970
      ELSE
         FINISH = IRET.EQ.-1
         IRET = 0
C                                       Check whether we need this
C                                       baseline
         IF (.NOT.FINISH) THEN
            IF (ILOCB.GE.0) THEN
               IA1 = INT (RPARM(ILOCB+1)) / 256
               IA2 = MOD (INT (RPARM(ILOCB+1)), 256)
            ELSE
               IA1 = RPARM(1+ILOCA1) + 0.1
               IA2 = RPARM(1+ILOCA2) + 0.1
               END IF
            IF (.NOT.REQBAS (IA1, IA2, DESEL, IANT(KBL), MANT,
     *         IBAS(LBL), MBAS)) GO TO 100
            INVERT = 1
            DO 110 K = 1,MBAS
               IF (IA1.EQ.IBAS(LBL+K-1)) INVERT = -1
 110           CONTINUE
            CALL DATAVG (ECHAN, NCOLS, CHFLGS, BUFF, FLUXS, VDAT)
            END IF
C                                       Include this count?
         IF (FINISH) THEN
            M = -40001
            SOUID = -2
         ELSE
            W = RPARM(ILOCW+1)
            M = W - WBASE + 0.1
            IF (M.LE.0) THEN
               LASTM = -10000
               GO TO 100
               END IF
            M = MOD (M, 256)
            IF (ILOCSU.GE.0) SOUID = IROUND (RPARM(ILOCSU+1))
            END IF
C                                       accumulate buffer
         IF ((M.EQ.LASTM) .AND. ((.NOT.OTFMOD) .OR.
     *      (RPARM(ILOCT+1)-NSTIME.LE.EPS)) .AND. (SOUID.EQ.OLDSOU)
     *      .AND. (LQUAL.GE.40000)) THEN
            IF (RPARM(ILOCT+1)-NSTIME.GT.EPS) THEN
               NSAMP = NSAMP + 1
               NSTIME = RPARM(ILOCT+1)
               END IF
            RPTIME(NSAMP) = RPTIME(NSAMP) + RPARM(ILOCT+1)
            RPUV(1,NSAMP) = RPUV(1,NSAMP) + RPARM(ILOCU+1)
            RPUV(2,NSAMP) = RPUV(2,NSAMP) + RPARM(ILOCV+1)
            RPMM(1,NSAMP) = M
            RPMM(2,NSAMP) = RPMM(2,NSAMP) + 1
            I = 1
            DO 120 K = 1,NCOLS
               VIS(1,K,NSAMP) = VIS(1,K,NSAMP) + VDAT(I) * VDAT(I+2)
               VIS(2,K,NSAMP) = VIS(2,K,NSAMP) +
     *            INVERT * VDAT(I+1) * VDAT(I+2)
               VIS(3,K,NSAMP) = VIS(3,K,NSAMP) + VDAT(I+2)
               I = I + 7
 120           CONTINUE
C                                       test and restart buffer
         ELSE
            IF (NOPTIO.GT.0) THEN
               ISAMP = MIN (NSAMP-1, NNBEG) + 1
               KSAMP = MAX (1, NSAMP - NNEND)
               IF ((NSAMP.LT.MINSAM) .OR. (NSAMP.EQ.0)) KSAMP = -1
            ELSE
               ISAMP = MAX (0, NSAMP-NPOINT) + 1
               KSAMP = NSAMP
               IF (NSAMP.LT.MINSAM) KSAMP = -1
               END IF
            IF (LQUAL.LT.40000) KSAMP = -1
            IF ((DOTIME) .AND. (KSAMP.GT.ISAMP)) THEN
               DO 130 NN = ISAMP+1,KSAMP
                  RPTIME(ISAMP) = RPTIME(ISAMP) + RPTIME(NN)
                  RPUV(1,ISAMP) = RPUV(1,ISAMP) + RPUV(1,NN) * XUVFAC
                  RPUV(2,ISAMP) = RPUV(2,ISAMP) + RPUV(2,NN) * XUVFAC
                  RPMM(2,ISAMP) = RPMM(2,ISAMP) + RPMM(2,NN)
                  DO 125 K = 1,NCOLS
                     VIS(1,K,ISAMP) = VIS(1,K,ISAMP) + VIS(1,K,NN)
                     VIS(2,K,ISAMP) = VIS(2,K,ISAMP) + VIS(2,K,NN)
                     VIS(3,K,ISAMP) = VIS(3,K,ISAMP) + VIS(3,K,NN)
 125                 CONTINUE
 130              CONTINUE
               KSAMP = ISAMP
               END IF
            DO 150 NN = ISAMP,KSAMP
               U = RPUV(1,NN) / MAX (1, RPMM(2,NN))
               V = RPUV(2,NN) / MAX (1, RPMM(2,NN))
               M = RPMM(1,NN)
               IF (U.GT.0.0) THEN
                  UVM = MAX (UVM, U)
               ELSE
                  UVM = MAX (UVM, -10.0*U)
                  END IF
               IF (V.GT.0.0) THEN
                  UVM = MAX (UVM, V)
               ELSE
                  UVM = MAX (UVM, -10.0*V)
                  END IF
C                                       Get vis.
               DO 140 K = 1,NCOLS
                  WEIGHT = VIS(3,K,NN)
                  IF (WEIGHT.GT.0.0) THEN
                     XX = VIS(1,K,NN) / WEIGHT
                     YY = VIS(2,K,NN) / WEIGHT
                     XWT = MAX (XWT, WEIGHT)
                     NWT = MIN (NWT, WEIGHT)
                     AMP = SQRT (XX*XX + YY*YY)
                     XAMP = MAX (XAMP, AMP)
                     YAMP = MIN (YAMP, AMP)
                     END IF
 140              CONTINUE
 150           CONTINUE
C                                       Check source
            IF (.NOT.FINISH) THEN
               CALL SOURS (.FALSE., SOUID, OLDSOU, IRET)
               IF (IRET.NE.0) THEN
                  MSGTXT = 'ERROR PROCESSING NEW SOURCE'
                  CALL MSGWRT (8)
                  GO TO 970
                  END IF
               NSAMP = 1
               W = RPARM(ILOCW+1)
               M = W - WBASE + 0.1
               M = MOD (M, 256)
               CALL RFILL (MSAMP, 0.0, RPTIME)
               CALL RFILL (2*MSAMP, 0.0, RPUV)
               CALL FILL (2*MSAMP, 0, RPMM)
               CALL RFILL (28*MSAMP, 0.0, VIS)
               NSTIME = RPARM(ILOCT+1)
               RPTIME(NSAMP) = RPARM(ILOCT+1)
               RPUV(1,NSAMP) = RPARM(ILOCU+1) * XUVFAC
               RPUV(2,NSAMP) = RPARM(ILOCV+1) * XUVFAC
               RPMM(1,NSAMP) = M
               RPMM(2,NSAMP) = 1
               I = 1
               DO 155 K = 1,NCOLS
                  VIS(1,K,NSAMP) = VDAT(I) * VDAT(I+2)
                  VIS(2,K,NSAMP) = INVERT * VDAT(I+1) * VDAT(I+2)
                  VIS(3,K,NSAMP) = VDAT(I+2)
                  I = I + 7
 155              CONTINUE
               LASTM = M
               END IF
            END IF
         PCOUNT = PCOUNT + 1
         IF ((PCOUNT.LT.XNCNT) .AND. (.NOT.FINISH)) GO TO 100
         END IF
C                                       Close files.
 970  IF (UVOPN) CALL UVGET ('CLOS', RPARM, BUFF, JERR)
      IF (IRET.EQ.0) THEN
         KBL = KBL + MANT
         IF ((KBL.LE.50) .AND. (IANT(KBL).GT.0)) GO TO 20
         KBL = 1
         END IF
      IF (IRET.EQ.0) THEN
         LBL = LBL + MBAS
         IF ((LBL.LE.50) .AND. (IBAS(LBL).GT.0)) GO TO 20
         END IF
      IF (IRET.LT.0) IRET = 0
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1090 FORMAT ('ERROR:',I7,' INITIALIZING UV FILE')
 1100 FORMAT ('ERROR:',I7,' READING VIS ')
      END
      SUBROUTINE UVHOCH (IRET)
C-----------------------------------------------------------------------
C   Prints selected portions of uv data file.
C   Output:
C      IRET     I      Return code, 1=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   ICH, IROUND, I, K, IA1, IA2, PCOUNT, KBL, SOUID, OLDSOU,
     *   LBL, JERR, IUSER, JTT(3), JJTT(4), M, LASTM, NSAMP, ISAMP, NN,
     *   INVERT, KSAMP, LSTSOU, LSTANT, MANT, MBAS, SUMCNT, NCNT,
     *   NCOUNT, TTY(2), NNBEG, NNEND, MINSAM, NOPTIO, NPOINT
      CHARACTER STR*24
      LOGICAL   T, REQBAS, UVOPN, FINISH, DOAVER, DOMAVE, DOTIME
      REAL      W, RPARM(20), TADAY, CATR(256), EPS, NSTIME
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'UVHOL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (JJTT, JTT)
      EQUIVALENCE (CATBLK, CATR)
      DATA T /.TRUE./
C-----------------------------------------------------------------------
      IRET = 0
      IF ((OPER.EQ.'HOLG') .OR. (DOCRT.GT.0.0) .OR. (LPNAME(1).NE.' ')
     *   .OR. (OPER.EQ.'PLOT')) GO TO 999
      LASTM = -40001
      NPOINT = XNPTS + 0.1
      IF (NPOINT.LE.0) NPOINT = 100
      MINSAM = XBDROP + 0.1
      NOPTIO = APARM(1) + 0.1
      NNBEG = APARM(2) + 0.1
      NNEND = APARM(3) + 0.1
      DOTIME = APARM(6).GT.0.0
      DOAVER = APARM(5).GT.0.0
      DOMAVE = APARM(8).GT.0.0
      MBAS = 1
      MANT = 1
      IF (DOAVER) MANT = NANT
      IF (DOMAVE) MBAS = NBAS
      LSTSOU = 0
      LSTANT = -1
      EPS = 0.1 / (3600. * 24.)
C                                       Set pointers, counters
      ICH = ACH + 0.5
      LBL = 1
      KBL = 1
      TADAY = -100.
C                                       Timerange
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
C                                       Set time range.
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.)
     *   + TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.)
     *   + TIMRNG(8) / (24. * 60. * 60.)
      NCOUNT = 0
C                                       Regular printing
C                                       Holography loop point
 20   UVOPN = .FALSE.
      OLDSOU = -1
      CALL COPY (MANT, IANT(KBL), ANTENS(1))
      CALL COPY (MBAS, IBAS(LBL), ANTENS(MANT+1))
C                                       zero summing arrays
      NSAMP = 0
      NSTIME = -100.0
      SUMCNT = 0
      NCNT = 0
C                                      first page
      IPCNT = 998
      IUSER = NLUSER
      IF (DOCRT.GT.-2.5) THEN
         NCOUNT = NCOUNT + 4
C                                       UV scaling
         IF (((OTYPE.GE.1) .AND. (OTYPE.LE.4))) NCOUNT = NCOUNT + 1
         END IF
C                                       Page titles
C                                       Initialize reading VIS. file.
      INITVS = 1
      CALL UVGET ('INIT', RPARM, BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1090) IRET
         CALL MSGWRT (8)
         IRET = 4
         GO TO 970
         END IF
      UVOPN = .TRUE.
      PCOUNT = 0
      SOUID = 1
      IF (NSOUWD.EQ.1) SOUID = SOUWAN(1)
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, BUFF, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         CALL MSGWRT (8)
         IRET = 4
         GO TO 970
      ELSE
         FINISH = IRET.LT.0
         IRET = 0
C                                       Check whether we need this
C                                       baseline
         IF (.NOT.FINISH) THEN
            IF (ILOCB.GE.0) THEN
               IA1 = INT (RPARM(ILOCB+1)) / 256
               IA2 = MOD (INT (RPARM(ILOCB+1)), 256)
            ELSE
               IA1 = RPARM(1+ILOCA1) + 0.1
               IA2 = RPARM(1+ILOCA2) + 0.1
               END IF
            IF (.NOT.REQBAS (IA1, IA2, DESEL, IANT(KBL), MANT,
     *         IBAS(LBL), MBAS)) GO TO 100
            INVERT = 1
            DO 102 K = 1,MBAS
               IF (IA1.EQ.IBAS(LBL+K-1)) INVERT = -1
 102           CONTINUE
            END IF
C                                       Include this count?
         IF (FINISH) THEN
            M = -40001
            SOUID = -2
         ELSE
            W = RPARM(ILOCW+1)
            M = W - WBASE + 0.1
            IF (M.LE.0) THEN
               LASTM = -10000
               GO TO 100
               END IF
            M = MOD (M, 256)
            IF (ILOCSU.GE.0) SOUID = IROUND (RPARM(ILOCSU+1))
            END IF
C                                       accumulate buffer
         IF ((M.EQ.LASTM) .AND. ((.NOT.OTFMOD) .OR.
     *      (RPARM(ILOCT+1)-NSTIME.LE.EPS)) .AND. (SOUID.EQ.OLDSOU)
     *      .AND. (LQUAL.GE.40000)) THEN
            IF (RPARM(ILOCT+1)-NSTIME.GT.EPS) THEN
               NSAMP = NSAMP + 1
               NSTIME = RPARM(ILOCT+1)
               END IF
C                                       print and restart buffer
         ELSE
            IF (NOPTIO.GT.0) THEN
               ISAMP = MIN (NSAMP-1, NNBEG) + 1
               KSAMP = MAX (1, NSAMP - NNEND)
               IF ((NSAMP.LT.MINSAM) .OR. (NSAMP.EQ.0)) KSAMP = -1
            ELSE
               ISAMP = MAX (0, NSAMP-NPOINT) + 1
               KSAMP = NSAMP
               IF (NSAMP.LT.MINSAM) KSAMP = -1
               END IF
            IF (LQUAL.LT.40000) KSAMP = -1
            IF ((DOTIME) .AND. (KSAMP.GT.ISAMP)) KSAMP = ISAMP
            DO 150 NN = ISAMP,KSAMP
               NCOUNT = NCOUNT + 1
               PCOUNT = PCOUNT + 1
               IF (ILOCB.GE.0) THEN
                  LSTANT = IROUND (RPARM(ILOCB+1)) / 256
               ELSE
                  LSTANT = RPARM(ILOCA1+1) + 0.1
                  END IF
               LSTSOU = OLDSOU
               IF(FINISH) THEN
                  LSTSOU = 0
                  LSTANT = -1
                  ENDIF
               IF (PCOUNT.GE.XNCNT) GO TO 970
 150           CONTINUE
C                                       Check source
            IF (.NOT.FINISH) THEN
               CALL SOURS (.FALSE., SOUID, OLDSOU, IRET)
               IF (IRET.NE.0) THEN
                  MSGTXT = 'ERROR PROCESSING NEW SOURCE'
                  CALL MSGWRT (8)
                  GO TO 970
                  END IF
               NSAMP = 1
               W = RPARM(ILOCW+1)
               M = W - WBASE + 0.1
               M = MOD (M, 256)
               LASTM = M
               NSTIME = RPARM(ILOCT+1)
               END IF
            END IF
         IF (.NOT.FINISH) GO TO 100
         END IF
C                                       Close files.
 970  IF (UVOPN) CALL UVGET ('CLOS', RPARM, BUFF, JERR)
      IF (IRET.EQ.0) THEN
         KBL = KBL + MANT
         IF ((KBL.LE.50) .AND. (IANT(KBL).GT.0)) GO TO 20
         KBL = 1
         END IF
      IF (IRET.EQ.0) THEN
         LBL = LBL + MBAS
         IF ((LBL.LE.50) .AND. (IBAS(LBL).GT.0)) GO TO 20
         END IF
      WRITE (MSGTXT,4000) NCOUNT
      CALL MSGWRT (8)
 4000 FORMAT ('CHECK EXPECTS NCOUNT=',I10)
      IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) THEN
         IF (NCOUNT.GT.1000) THEN
            IRET = -1
            IPCNT = -1
            CALL LPCLOS (LUNP(1), FINDP(1), IPCNT, IRET)
            END IF
      ELSE IF (NCOUNT.GT.500) THEN
         TTY(1) = 5
         CALL ZOPEN (TTY(1), TTY(2), 1, SCRTCH, .FALSE., .FALSE.,
     *      .TRUE., IRET)
         MSGTXT = 'PROBLEM OPENING TERMINAL'
         IF (IRET.GT.0) GO TO 975
         WRITE (SCRTCH,1970) NCOUNT
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, IRET)
         MSGTXT = 'PROBLEM DOING IO TO TERMINAL'
         IF (IRET.GT.0) GO TO 975
         SCRTCH = 'Do you really want to print this much??' //
     *      ' Enter Y or y if so'
         CALL INQSTR (TTY, SCRTCH, 1, STR, IRET)
         IF (IRET.GT.0) GO TO 975
         IF ((STR(:1).NE.'y') .AND. (STR(:1).NE.'Y')) THEN
            IPCNT = -1
            CALL LPCLOS (LUNP(1), FINDP(1), IPCNT, IRET)
            IRET = -1
            SCRTCH = 'Good choice - save trees'
         ELSE
            SCRTCH = 'OKAY, printing anyway'
            END IF
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, I)
         CALL ZCLOSE (TTY(1), TTY(2), I)
         END IF
 975  IF (IRET.GT.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1090 FORMAT ('ERROR:',I7,' INITIALIZING UV FILE')
 1100 FORMAT ('ERROR:',I7,' READING VIS ')
 1970 FORMAT ('Requested print job is',I10,' lines long!')
      END
      SUBROUTINE UVHODO (IRET)
C-----------------------------------------------------------------------
C   Prints selected portions of uv holography data file.
C   Output:
C      IRET     I      Return code, 1=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   ICH, JJ, IROUND, I, K, IA1, IA2, PCOUNT, PHASE(4), KBL,
     *   IWT(4), SOUID, OLDSOU, ITT(4), JCOR, LBL, JERR, FLEN, JTRIM,
     *   IUSER, NWR(4), JTT(3), JJTT(4), M, WTFM, LASTM, ICOUNT,
     *   NSAMP, NPOINT, ISAMP, MINSAM, NN, NNBEG, NNEND, INVERT, J,
     *   KSAMP, NOPTIO, ILEN, LUNTS(4), SULUN, IPH(4),
     *   LSTSOU, LSTANT, NXVER, LOOP, NXSOUR, NXSUB, NXVS, NXVE,
     *   NXFQI, INXLUN, MANT, MBAS, IAR, IAM, SUMCNT, NCNT, KK, LA1, LA2
      CHARACTER ISTOKE(4)*2, JSTOKE(4,3)*2, TCHAR*12, PREFIX*5, UVCH*4,
     *   TCHR1*13, STR*24, UVCC*5
      LOGICAL   T, REQBAS, FLAG, UVOPN, FINISH, DOELAZ, TABLE, EXIST,
     *   FITASC, NEW(500), DOTIME, DOAVER, DOMAVE
      REAL      AMP(4), WEIGHT, TPHS, U, V, W, XX, YY, RWT(4), XDAY,
     *   TEMP, RPHAS(4), TDAY, TIMS, RPARM(20), TADAY, WTSC, CATR(256),
     *   HA, EL, AZ, BEGSC(1000), ENDSC(1000), NXTIME, NXDTIM, EPS,
     *   NSTIME, RRE(4), RIM(4), SRE(4), SIM(4), SAM(4), SPH(4), RX, RY,
     *   RAMP, VDAT(28)
      DOUBLE PRECISION LSTIME, RA2DEG
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'UVHOL.INC'
      INCLUDE 'SAMBUF.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DFIL.INC'
      INTEGER   CHFLGS(MAXCHA), NCOUNT, VISINC, VISMSG
      EQUIVALENCE (JJTT, JTT)
      EQUIVALENCE (CATBLK, CATR)
      DATA T /.TRUE./
      DATA JSTOKE /'VV','HH','VH','HV','RR','LL','RL','LR',
     *   'I_','Q_','U_','V_'/
      DATA LUNTS /3,11,10,91/
      DATA SULUN, INXLUN /17,18/
C-----------------------------------------------------------------------
      CALL CHWANT (ECHAN, 1, CHNSEL, CHFLGS)
      NCOUNT = 0
      DEVTAB(LUNTS(4)) = 3
      RA2DEG = 57.29577951
      LASTM = -40001
      NPOINT = XNPTS + 0.1
      IF (NPOINT.LE.0) NPOINT = 100
      MINSAM = XBDROP + 0.1
      NOPTIO = APARM(1) + 0.1
      NNBEG = APARM(2) + 0.1
      NNEND = APARM(3) + 0.1
      DOAVER = APARM(5).GT.0.0
      DOMAVE = APARM(8).GT.0.0
      DOTIME = APARM(6).GT.0.0
      MBAS = 1
      MANT = 1
      IF (DOAVER) MANT = NANT
      IF (DOMAVE) MBAS = NBAS
      LSTSOU = 0
      LSTANT = -1
      LSTIME = -1.D0
      DOELAZ = (APARM(4).GT.0.0) .AND. (OPER.EQ.'HOLG')
      EPS = 0.1 / (3600. * 24.)
C                                       Set pointers, counters
      ICH = ACH + 0.5
C                                       If get elevation and azimuth
C                                       run GETANT, and initalize
C                                       NX table
      IF (DOELAZ) THEN
         CALL GETANT (DISKIN, CNOIN, SUBARR, CATUV, SCRBUF, IRET)
         CALL ISTAB ('NX', DISKIN, CNOIN, 1, INXLUN, SCRBUF, TABLE,
     *      EXIST, FITASC, IRET)
         IF ((.NOT.EXIST) .OR. (IRET.NE.0)) THEN
            MSGTXT = 'ERROR IN ISTAB INITALIZING NX TABLE'
            IRET = 1
            GO TO 960
            END IF
         NXVER = 1
         CALL NDXINI ('READ', NXBUFF, DISKIN, CNOIN, NXVER, CATUV,
     *      INXLUN, INXRNO, NXKOLS, NXNUMV, IRET)
         IF (.NOT.EXIST.OR.IRET.NE.0) THEN
            MSGTXT = 'ERROR IN NDXINI INITALIZING NX TABLE'
            IRET = 1
            GO TO 960
            END IF
C                                      Get number of index records
         NINDEX = NXBUFF(5)
         IF (NINDEX.GT.500)  THEN
            MSGTXT = 'NO MORE THAN 500 SCANS ALLOWED'
            CALL MSGWRT(8)
            MSGTXT = 'THE AIPS MANAGER COULD FIX THIS'
            CALL MSGWRT(8)
            GOTO 960
            END IF
C                                      Get begin and end scan times
         DO 10 LOOP = 1,NINDEX
            INXRNO = LOOP
            CALL TABNDX ('READ', NXBUFF, INXRNO, NXKOLS, NXNUMV, NXTIME,
     *         NXDTIM, NXSOUR, NXSUB, NXVS, NXVE, NXFQI, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1012) IRET
               CALL MSGWRT (8)
               GO TO 999
               END IF
C                                       Convert time
            BEGSC(LOOP) = NXTIME - 0.5 * NXDTIM
            ENDSC(LOOP) = NXTIME + 0.5 * NXDTIM
 10         CONTINUE
         CALL TABIO ('CLOS', 0, INXRNO, NXBUFF, NXBUFF, IRET)
         END IF
C                                       Stokes labels
      JJ = 2
      IF (ICOR0.LT.-4) JJ = 1
      IF (DOCONV) JJ = 3
      DO 15 I = 1,NCOLS
         ISTOKE(I) = JSTOKE(I,JJ)
 15      CONTINUE
      IF (STOKES.EQ.'IV') ISTOKE(2) = 'V_'
      LBL = 1
      KBL = 1
      TADAY = -100.
C                                       Timerange
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
C                                       Set time range.
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.)
     *   + TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.)
     *   + TIMRNG(8) / (24. * 60. * 60.)
C                                       Regular printing
      WTSC = 1.0
      IF (OPER.NE.'HOLG') THEN
C                                       weight scaling
         TCHAR = ' Amp Phas Wt'
         TCHR1 = 'Amp  Phas  Wt'
         IF (XWT.LE.0.0) THEN
            XWT = 1.0
            NWT = 1.0
            END IF
         TEMP = LOG10 (XWT/0.995)
         I = TEMP + 99.0
         I =  100 - I
         WTSC = 10.0 ** I
         IF (OTYPE.LE.3) THEN
            TEMP = XWT / NWT
            IF (TEMP.GT.10**(6-OTYPE)) THEN
               MSGTXT = 'Full dynamic range of weights cannot' //
     *            ' be printed'
               CALL MSGWRT (6)
               END IF
             WTFM = 4 - OTYPE
            IF (OTYPE.EQ.1) THEN
               IF ((XWT.LT.9.99995) .AND. (NWT.GE.0.0001)) THEN
                  WTSC = 1.0
                  WTFM = 4
                  IF (XWT.LT.0.09995) WTSC = 10.0
               ELSE IF ((XWT.LT.99.9995) .AND. (NWT.GE.0.001)) THEN
                  WTSC = 1.0
                  WTFM = 3
               ELSE IF ((XWT.LT.999.995) .AND. (NWT.GE.0.01)) THEN
                  WTSC = 1.0
                  WTFM = 2
               ELSE IF ((XWT.LT.9999.95) .AND. (NWT.GE.0.1)) THEN
                  WTSC = 1.0
                  WTFM = 1
                  END IF
            ELSE IF (OTYPE.EQ.2) THEN
               IF ((XWT.LT.9.99995) .AND. (NWT.GE.0.001)) THEN
                  WTSC = 1.0
                  WTFM = 3
                  IF (XWT.LT.0.09995) WTSC = 10.0
               ELSE IF ((XWT.LT.99.9995) .AND. (NWT.GE.0.01)) THEN
                  WTSC = 1.0
                  WTFM = 2
               ELSE IF ((XWT.LT.999.995) .AND. (NWT.GE.0.1)) THEN
                  WTSC = 1.0
                  WTFM = 1
                  END IF
            ELSE IF (OTYPE.EQ.3) THEN
               IF ((XWT.LT.9.99995) .AND. (NWT.GE.0.01)) THEN
                  WTSC = 1.0
                  WTFM = 2
                  IF (XWT.LT.0.09995) WTSC = 10.0
               ELSE IF ((XWT.LT.99.9995) .AND. (NWT.GE.0.1)) THEN
                  WTSC = 1.0
                  WTFM = 1
                  END IF
               END IF
         ELSE
            TEMP = XWT / NWT
            IF (TEMP.GT.99.50) THEN
               MSGTXT = 'Full dynamic range of weights cannot' //
     *            ' be printed'
               CALL MSGWRT (6)
               END IF
            END IF
         END IF
      PAGE = 0
C                                       Holography loop point
 20   UVOPN = .FALSE.
      OLDSOU = -1
      CALL COPY (MANT, IANT(KBL), ANTENS(1))
      CALL COPY (MBAS, IBAS(LBL), ANTENS(MANT+1))
C                                       zero summing arrays
      NSAMP = 0
      CALL RFILL (MSAMP, 0.0, RPTIME)
      CALL RFILL (2*MSAMP, 0.0, RPUV)
      CALL FILL (2*MSAMP, 0, RPMM)
      CALL RFILL (28*MSAMP, 0.0, VIS)
      NSTIME = -100.0
C                                       Initalize NEW for DOELAZ
      CALL LFILL (500, .TRUE., NEW)
      SUMCNT = 0
      NCNT = 0
C                                       Holography
C                                       Append stokes to filename
      IF ((OPER.EQ.'HOLG') .AND. (KBL.EQ.1)) THEN
         DO 30 I = 1,NSTKS
            LPNAME(I) = ' '
            CALL H2CHR (48, 1, XLPNAM, LPNAME(I))
            FLEN = INDEX (LPNAME(I), ':')
            IF (FLEN.LE.0) THEN
               FLEN = JTRIM (LPNAME(I))
               LPNAME(I)(FLEN+1:) = ':'
               END IF
            ILEN = JTRIM (LPNAME(I))
            FLEN = INDEX (LPNAME(I), ':')
            IF (ILEN.LE.FLEN) THEN
               JJ = 0
               IF (IANT(2).LE.0) JJ = IANT(KBL)
               KK = IBAS(LBL)
               IF (MBAS.GT.1) KK = 0
               WRITE (STR,1015) KK, JJ, ISTOKE(I), BIF
               LPNAME(I)(FLEN+1:) = STR
            ELSE
               WRITE (STR,1016) ISTOKE(I), BIF
               LPNAME(I)(ILEN+1:) = STR
               END IF
C                                       Open 2 text files
            LUNP(I) = LUNTS(I)
            CALL ZTXOPN ('WRIT', LUNP(I), FINDP(I), LPNAME(I), T, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1030) IRET
               CALL MSGWRT (8)
               GO TO 960
               END IF
            LPOPN(I) = .TRUE.
            NWR(I) = 0
 30         CONTINUE
         END IF
C                                       Holography comment lines
      IF (OPER.EQ.'HOLG') THEN
         DO 40 I = 1,NSTKS
            JJ = IANT(KBL)
            IF (MANT.GT.1) JJ = 100
            KK = IBAS(LBL)
            IF (MBAS.GT.1) KK = 100
            WRITE (LINE,1020) JJ, KK, ISTOKE(I), LFREQ, DATOBS
            CALL ZTXIO ('WRIT', LUNP(I), FINDP(I), LINE(1:JTRIM(LINE)),
     *         IRET)
            IF (IRET.NE.0) GO TO 960
            IF (MBAS.GT.1) THEN
               JJ = 1
 31            IF (JJ.LE.MBAS) THEN
                  K = MIN (MBAS, JJ+13)
                  WRITE (LINE,2020) (IBAS(LBL+IA1-1), IA1 = JJ,K)
                  CALL ZTXIO ('WRIT', LUNP(I), FINDP(I),
     *               LINE(1:JTRIM(LINE)), IRET)
                  IF (IRET.NE.0) GO TO 960
                  JJ = K + 1
                  GO TO 31
                  END IF
               END IF
            IF (NOPTIO.EQ.0) THEN
               WRITE (LINE,1021) MINSAM, NPOINT
               CALL ZTXIO ('WRIT', LUNP(I), FINDP(I),
     *            LINE(1:JTRIM(LINE)), IRET)
            ELSE
               WRITE (LINE,2021) MINSAM, NNBEG, NNEND
               CALL ZTXIO ('WRIT', LUNP(I), FINDP(I),
     *            LINE(1:JTRIM(LINE)), IRET)
               END IF
            IF (IRET.NE.0) GO TO 960
            WRITE (LINE,1022) BIF, ACH
            CALL ZTXIO ('WRIT', LUNP(I), FINDP(I), LINE(1:JTRIM(LINE)),
     *         IRET)
            IF (IRET.NE.0) GO TO 960
            TDAY = MAX (-99.0, TSTART)
            TIMS = MIN (999.0, TEND)
            CALL TODHMS (TDAY, ITT)
            CALL TODHMS (TIMS, JJTT)
            WRITE (LINE,1023) ITT, JJTT
            CALL ZTXIO ('WRIT', LUNP(I), FINDP(I), LINE(1:JTRIM(LINE)),
     *         IRET)
            IF (IRET.NE.0) GO TO 960
            IF (MANT.GT.1) THEN
               JJ = 1
 35            IF (JJ.LE.MANT) THEN
                  K = MIN (MANT, JJ+13)
                  WRITE (LINE,1040) (IANT(IA1), IA1 = JJ,K)
                  CALL ZTXIO ('WRIT', LUNP(I), FINDP(I),
     *               LINE(1:JTRIM(LINE)), IRET)
                  IF (IRET.NE.0) GO TO 960
                  JJ = K + 1
                  GO TO 35
                  END IF
               END IF
            WRITE (LINE,1041) DOCAL, DOPOL
            CALL ZTXIO ('WRIT', LUNP(I), FINDP(I), LINE(1:JTRIM(LINE)),
     *         IRET)
            IF (IRET.NE.0) GO TO 960
            DO 38 J = 1,20
               IF ((CHNSEL(1,J).GT.0) .AND. (CHNSEL(2,J).GT.0) .AND.
     *            (CHNSEL(2,J).GE.CHNSEL(1,J))) THEN
                  WRITE (LINE,1042) CHNSEL(1,J), CHNSEL(2,J),
     *               CHNSEL(3,J)
                  CALL ZTXIO ('WRIT', LUNP(I), FINDP(I),
     *               LINE(1:JTRIM(LINE)), IRET)
                  IF (IRET.NE.0) GO TO 960
                  END IF
 38            CONTINUE
            IF (APARM(7).LE.0.0) THEN
               WRITE (LINE,1045)
            ELSE
               WRITE (LINE,1046)
               END IF
            CALL ZTXIO ('WRIT', LUNP(I), FINDP(I), LINE(1:JTRIM(LINE)),
     *         IRET)
            IF (IRET.NE.0) GO TO 960
 40         CONTINUE
         END IF
C                                      UV scaling
      TEMP = 1.01 / XUVFAC
      CALL METSCA (TEMP, PREFIX, FLAG)
      IF (ABS(TEMP-1.0).LT.0.02) THEN
         UVCH = PREFIX(:4)
         IF (UVCH.EQ.' ') UVCH = 'ASin'
         UVCC = PREFIX
         IF (UVCC.EQ.' ') UVCC = 'ASin'
      ELSE
         UVCH = 'ASin'
         UVCC = 'ASin'
         END IF
C                                      first page
      IPCNT = 998
      TITL1 = ' '
      TITL2 = ' '
      IUSER = NLUSER
      IF ((OPER.NE.'HOLG') .AND. (DOCRT.GT.-2.5)) THEN
         IF (NACROS.GE.90) THEN
            WRITE (LINE,1050) NAMEIN, CLAIN, SEQIN, DISKIN, IUSER,
     *         ACH, BIF
         ELSE
            WRITE (LINE,1051) NAMEIN, CLAIN, SEQIN, DISKIN, IUSER,
     *         ACH, BIF
            END IF
         CALL PRTLIN (LUNP(1), FINDP(1), DOCRT, NACROS, TITL1, TITL2,
     *      LINE, IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 960
         WRITE (LINE,1055) LFREQ, NCOR, NVIS, ISORT
         CALL PRTLIN (LUNP(1), FINDP(1), DOCRT, NACROS, TITL1, TITL2,
     *      LINE, IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 960
         NCOUNT = NCOUNT + 2
C                                       UV scaling
         IF (((OTYPE.GE.1) .AND. (OTYPE.LE.4))) THEN
            LINE = 'l and m, not w, are in ' // PREFIX //
     *         '''s of asin(l or m)'
            CALL PRTLIN (LUNP(1), FINDP(1), DOCRT, NACROS, TITL1,
     *         TITL2, LINE, IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 960
            NCOUNT = NCOUNT + 1
            END IF
         IF (WTSC.NE.1.0) THEN
            WRITE (LINE,1057) WTSC
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *        IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 960
            NCOUNT = NCOUNT + 1
            END IF
         LINE = ' '
         CALL PRTLIN (LUNP(1), FINDP(1), DOCRT, NACROS, TITL1, TITL2,
     *      LINE, IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 960
         NCOUNT = NCOUNT + 1
         END IF
C                                       Page titles
      IF (OPER.NE.'HOLG') THEN
         IF (OTYPE.EQ.1) THEN
            WRITE (TITL1,1061) SOURCE, LFREQ, ISORT, (ICH, ISTOKE(JCOR),
     *         JCOR = 1,NCOLS)
            WRITE (TITL2,1071) UVCC, UVCC, (TCHR1, JCOR = 1,NCOLS)
         ELSE IF (OTYPE.EQ.2) THEN
            WRITE (TITL1,1062) SOURCE, LFREQ, ISORT, (ICH, ISTOKE(JCOR),
     *         JCOR = 1,NCOLS)
            WRITE (TITL2,1072) UVCH, UVCH, (TCHR1, JCOR = 1,NCOLS)
         ELSE IF (OTYPE.EQ.3) THEN
            WRITE (TITL1,1063) SOURCE, LFREQ, ISORT, (ICH, ISTOKE(JCOR),
     *         JCOR = 1,NCOLS)
            WRITE (TITL2,1073) UVCH, UVCH, (TCHR1, JCOR = 1,NCOLS)
         ELSE IF (OTYPE.EQ.4) THEN
            WRITE (TITL1,1064) SOURCE, LFREQ, ISORT, (ICH, ISTOKE(JCOR),
     *         JCOR = 1,NCOLS)
            WRITE (TITL2,1074) UVCH, UVCH, (TCHAR, JCOR = 1,NCOLS)
         ELSE IF (OTYPE.EQ.5) THEN
            WRITE (TITL1,1065) SOURCE, LFREQ, (ICH, ISTOKE(JCOR),
     *         JCOR = 1,NCOLS)
            WRITE (TITL2,1075) (TCHAR, JCOR = 1,NCOLS)
            END IF
         END IF
C                                       Initialize reading VIS. file.
      INITVS = 1
      CALL UVGET ('INIT', RPARM, BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT, 1090) IRET
         CALL MSGWRT (8)
         IRET = 4
         GO TO 970
         END IF
      UVOPN = .TRUE.
      PCOUNT = 0
      SOUID = 1
      IF (NSOUWD.EQ.1) SOUID = SOUWAN(1)
      VISINC = CATBLK(KIGCN) / 20
      VISINC = MAX (20000, MIN (200000,VISINC))
      VISMSG = 3 * VISINC
      ICOUNT = 0
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, BUFF, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         CALL MSGWRT (8)
         IRET = 4
         GO TO 970
      ELSE
         FINISH = IRET.LT.0
         IRET = 0
         ICOUNT = ICOUNT + 1
         IF (MOD(ICOUNT-1,VISMSG).EQ.0) THEN
            WRITE (MSGTXT,1101) ICOUNT
            CALL MSGWRT (2)
         ELSE IF (MOD(ICOUNT-1,VISINC).EQ.0) THEN
            WRITE (MSGTXT,1101) ICOUNT
            CALL MSGWRT (1)
            END IF
C                                       Check whether we need this
C                                       baseline
         IF (.NOT.FINISH) THEN
            IF (ILOCB.GE.0) THEN
               LA1 = INT (RPARM(ILOCB+1)) / 256
               LA2 = MOD (INT (RPARM(ILOCB+1)), 256)
            ELSE
               LA1 = RPARM(1+ILOCA1) + 0.1
               LA2 = RPARM(1+ILOCA2) + 0.1
               END IF
            IF (.NOT.REQBAS (LA1, LA2, DESEL, IANT(KBL), MANT,
     *         IBAS(LBL), MBAS)) GO TO 100
            IA1 = LA1
            IA2 = LA2
            INVERT = 1
            DO 102 K = 1,MBAS
               IF (IA1.EQ.IBAS(LBL+K-1)) INVERT = -1
 102           CONTINUE
            CALL DATAVG (ECHAN, NCOLS, CHFLGS, BUFF, FLUXS, VDAT)
            END IF
C                                       Include this count?
         IF (FINISH) THEN
            M = -40001
            SOUID = -2
         ELSE
            W = RPARM(ILOCW+1)
            M = W - WBASE + 0.1
            IF (M.LE.0) THEN
               LASTM = -10000
               GO TO 100
               END IF
            M = MOD (M, 256)
            IF (ILOCSU.GE.0) SOUID = IROUND (RPARM(ILOCSU+1))
            END IF
C                                       accumulate buffer
         IF ((M.EQ.LASTM) .AND. ((.NOT.OTFMOD) .OR.
     *      (RPARM(ILOCT+1)-NSTIME.LE.EPS)) .AND. (SOUID.EQ.OLDSOU)
     *      .AND. (LQUAL.GE.40000)) THEN
            IF (RPARM(ILOCT+1)-NSTIME.GT.EPS) THEN
               NSAMP = NSAMP + 1
               NSTIME = RPARM(ILOCT+1)
               END IF
            RPTIME(NSAMP) = RPTIME(NSAMP) + RPARM(ILOCT+1)
            RPUV(1,NSAMP) = RPUV(1,NSAMP) + RPARM(ILOCU+1) * XUVFAC
            RPUV(2,NSAMP) = RPUV(2,NSAMP) + RPARM(ILOCV+1) * XUVFAC
            RPMM(1,NSAMP) = M
            RPMM(2,NSAMP) = RPMM(2,NSAMP) + 1
            I = 1
            DO 105 K = 1,NCOLS
               VIS(1,K,NSAMP) = VIS(1,K,NSAMP) + VDAT(I) * VDAT(I+2)
               VIS(2,K,NSAMP) = VIS(2,K,NSAMP) +
     *            INVERT * VDAT(I+1) * VDAT(I+2)
               VIS(3,K,NSAMP) = VIS(3,K,NSAMP) + VDAT(I+2)
               VIS(4,K,NSAMP) = VIS(4,K,NSAMP) + VDAT(I+3) * VDAT(I+2)
               VIS(5,K,NSAMP) = VIS(5,K,NSAMP) + VDAT(I+4) * VDAT(I+2)
               VIS(6,K,NSAMP) = VIS(6,K,NSAMP) + VDAT(I+5)
               VIS(7,K,NSAMP) = VIS(7,K,NSAMP) + VDAT(I+6) * VDAT(I+2)
               I = I + 7
 105           CONTINUE
C                                       print and restart buffer
         ELSE
            IF (NOPTIO.GT.0) THEN
               ISAMP = MIN (NSAMP-1, NNBEG) + 1
               KSAMP = MAX (1, NSAMP - NNEND)
               IF ((NSAMP.LT.MINSAM) .OR. (NSAMP.EQ.0)) KSAMP = -1
            ELSE
               ISAMP = MAX (0, NSAMP-NPOINT) + 1
               KSAMP = NSAMP
               IF (NSAMP.LT.MINSAM) KSAMP = -1
               END IF
            IF (LQUAL.LT.40000) KSAMP = -1
            IF ((DOTIME) .AND. (KSAMP.GT.ISAMP)) THEN
               DO 110 NN = ISAMP+1,KSAMP
                  RPTIME(ISAMP) = RPTIME(ISAMP) + RPTIME(NN)
                  RPUV(1,ISAMP) = RPUV(1,ISAMP) + RPUV(1,NN)
                  RPUV(2,ISAMP) = RPUV(2,ISAMP) + RPUV(2,NN)
                  RPMM(2,ISAMP) = RPMM(2,ISAMP) + RPMM(2,NN)
                  DO 109 K = 1,NCOLS
                     VIS(1,K,ISAMP) = VIS(1,K,ISAMP) + VIS(1,K,NN)
                     VIS(2,K,ISAMP) = VIS(2,K,ISAMP) + VIS(2,K,NN)
                     VIS(3,K,ISAMP) = VIS(3,K,ISAMP) + VIS(3,K,NN)
                     VIS(4,K,ISAMP) = VIS(4,K,ISAMP) + VIS(4,K,NN)
                     VIS(5,K,ISAMP) = VIS(5,K,ISAMP) + VIS(5,K,NN)
                     VIS(6,K,ISAMP) = VIS(6,K,ISAMP) + VIS(6,K,NN)
                     VIS(7,K,ISAMP) = VIS(7,K,ISAMP) + VIS(7,K,NN)
 109                 CONTINUE
 110              CONTINUE
               KSAMP = ISAMP
               END IF
            DO 150 NN = ISAMP,KSAMP
               XDAY = RPTIME(NN) / MAX (1, RPMM(2,NN))
               CALL T2DHMS (0, XDAY, ITT, TIMS)
               CALL T2DHMS (1, XDAY, JJTT, TIMS)
C                                       Scale uvw as user desires
               U = RPUV(1,NN) / MAX (1, RPMM(2,NN))
               V = RPUV(2,NN) / MAX (1, RPMM(2,NN))
               M = RPMM(1,NN)
               SUMCNT = SUMCNT + RPMM(2,NN)
               NCNT = NCNT + 1
C                                       Get vis.
               DO 115 K = 1,NCOLS
                  WEIGHT = VIS(3,K,NN)
                  XX = VIS(1,K,NN) / MAX (1.E-8, WEIGHT)
                  YY = VIS(2,K,NN) / MAX (1.E-8, WEIGHT)
                  RX = VIS(4,K,NN) / MAX (1.E-8, WEIGHT)
                  RY = VIS(5,K,NN) / MAX (1.E-8, WEIGHT)
                  RAMP = VIS(7,K,NN) / MAX (1.E-8, WEIGHT)
                  RX = RX - XX * XX
                  RY = RY - YY * YY
                  RX = SQRT (MAX (0.0, RX))
                  RY = SQRT (MAX (0.0, RY))
                  RRE(K) = XX
                  RIM(K) = YY
                  SRE(K) = RX / SQRT (MAX (1.0, VIS(6,K,NN)-1.0))
                  SIM(K) = RY / SQRT (MAX (1.0, VIS(6,K,NN)-1.0))
                  TPHS = WEIGHT * WTSC
                  RWT(K) = TPHS
                  IWT(K) = IROUND (TPHS)
                  IF (IWT(K).EQ.0) THEN
                     IF (TPHS.LT.0.0) IWT(K) = -1
                     IF (TPHS.GT.0.0) IWT(K) = 1
                     END IF
                  IF ((IA1.NE.IA2) .OR. (ISCROS(K))) THEN
                     AMP(K) = SQRT (XX*XX+YY*YY)
                     TPHS = 57.296 * ATAN2 (YY, XX+1.0E-20)
                     SAM(K) = 0.0
                     SPH(K) = 0.0
                     IF (AMP(K).GT.0.0) THEN
                        SAM(K) = SQRT ((XX*RX/AMP(K))**2 +
     *                     (YY*RY/AMP(K))**2)
     *                     / SQRT (MAX (1.0, VIS(6,K,NN)-1.0))
                        SPH(K) = 57.296 * SQRT ((XX*RY)**2 + (YY*RX)**2)
     *                     / (XX*XX + YY*YY)
     *                     / SQRT (MAX (1.0, VIS(6,K,NN)-1.0))
                        END IF
                     IF (APARM(9).GT.0.0) THEN
                        RRE(K) = RRE(K) / AMP(K) * RAMP
                        RIM(K) = RIM(K) / AMP(K) * RAMP
                        SRE(K) = SRE(K) / AMP(K) * RAMP
                        SIM(K) = SIM(K) / AMP(K) * RAMP
                        SAM(K) = SAM(K) / AMP(K) * RAMP
                        AMP(K) = RAMP
                        END IF
                  ELSE
                     AMP(K) = XX
                     TPHS = 0.0
                     END IF
                  RPHAS(K) = TPHS
                  PHASE(K) = IROUND (TPHS)
                  IPH(K) = IROUND (SPH(K))
 115              CONTINUE
C                                       Write VIS data
C                                       Holography viscera
               IF (OPER.EQ.'HOLG') THEN
C                                       Print beg/end time, el and az
                  IF (DOELAZ) THEN
                     DO 120 LOOP = 1, NINDEX
                        IF (RPTIME(NN).GE.BEGSC(LOOP).AND.
     *                     NEW(LOOP).AND.
     *                     RPTIME(NN).LE.ENDSC(LOOP)) THEN
                           IF (LSTANT.GT.0.AND.LSTIME.GT.0.0) THEN
                              CALL GETSOU (LSTSOU, DISKIN, CNOIN, CATUV,
     *                           SULUN, IRET)
                              IF (IRET.NE.0) THEN
                                 WRITE (MSGTXT,1013) IRET
                                 CALL MSGWRT (8)
                                 GO TO 999
                                 END IF
                              CALL SOUELV (LSTANT, LSTIME, HA, EL, AZ)
                              DO 118 I = 1,NSTKS
                                 WRITE (LINE,1166) LSTIME, EL*RA2DEG,
     *                              AZ*RA2DEG
                                 CALL ZTXIO ('WRIT', LUNP(I), FINDP(I),
     *                              LINE(1:JTRIM(LINE)), IRET)
                                 IF (IRET.NE.0) GO TO 960
 118                             CONTINUE
                              END IF
                           NEW(LOOP)=.FALSE.
                           CALL GETSOU (OLDSOU, DISKIN, CNOIN, CATUV,
     *                        SULUN, IRET)
                           IF (IRET.NE.0) THEN
                              WRITE (MSGTXT,1013) IRET
                              CALL MSGWRT (8)
                              GO TO 999
                              END IF
                           CALL SOUELV (IA1, DBLE(RPTIME(NN)), HA, EL,
     *                        AZ)
                           DO 119 I = 1,NSTKS
                              WRITE (LINE,1165) RPTIME(NN), EL*RA2DEG,
     *                           AZ*RA2DEG
                              CALL ZTXIO ('WRIT', LUNP(I), FINDP(I),
     *                           LINE(1:JTRIM(LINE)), IRET)
                              IF (IRET.NE.0) GO TO 960
 119                          CONTINUE
                           END IF
 120                    CONTINUE
                     END IF
C                                       Write to file
                  DO 125 I = 1,NSTKS
                     IF (RWT(I).GT.0) THEN
                        IF (APARM(7).LE.0.0) THEN
                           WRITE (LINE,1160,ERR=145) U, V, AMP(I),
     *                        RPHAS(I), SAM(I), SPH(I)
                        ELSE
                           WRITE (LINE,1160,ERR=145) U, V, RRE(I),
     *                        RIM(I), SRE(I), SIM(I)
                           END IF
                        CALL ZTXIO ('WRIT', LUNP(I), FINDP(I),
     *                     LINE(1:JTRIM(LINE)), IRET)
                        IF (IRET.NE.0) GO TO 960
                        NWR(I) = NWR(I) + 1
                        END IF
 125                 CONTINUE
                  IF ((DOELAZ) .AND. (FINISH) .AND. (NN.EQ.KSAMP)) THEN
                     CALL GETSOU (OLDSOU, DISKIN, CNOIN, CATUV, SULUN,
     *                  IRET)
                     IF(IRET.NE.0) THEN
                        WRITE (MSGTXT,1013) IRET
                        CALL MSGWRT (8)
                        GO TO 999
                        END IF
                     CALL SOUELV (IA1, DBLE(RPTIME(NN)), HA, EL, AZ)
                     DO 130 I = 1,NSTKS
                        WRITE (LINE,1166) RPTIME(NN), EL*RA2DEG,
     *                     AZ*RA2DEG
                        CALL ZTXIO ('WRIT', LUNP(I), FINDP(I),
     *                     LINE(1:JTRIM(LINE)), IRET)
                        IF (IRET.NE.0) GO TO 960
 130                    CONTINUE
                     END IF
C                                       Printing
               ELSE
                  IAR = IANT(KBL)
                  IF (MANT.GT.1) IAR = 100
                  IAM = IBAS(LBL)
                  IF (MBAS.GT.1) IAM = 100
                  IF ((OTYPE.EQ.1) .AND. (WTFM.EQ.1)) THEN
                     WRITE (LINE,2101,ERR=140) JTT, TIMS, IAR, IAM, U,
     *                  V, M, (AMP(K), PHASE(K), RWT(K), K = 1,NCOLS)
                  ELSE IF ((OTYPE.EQ.1) .AND. (WTFM.EQ.2)) THEN
                     WRITE (LINE,2102,ERR=140) JTT, TIMS, IAR, IAM, U,
     *                  V, M, (AMP(K), PHASE(K), RWT(K), K = 1,NCOLS)
                  ELSE IF ((OTYPE.EQ.1) .AND. (WTFM.EQ.3)) THEN
                     WRITE (LINE,2103,ERR=140) JTT, TIMS, IAR, IAM, U,
     *                  V, M,(AMP(K), PHASE(K), RWT(K), K = 1,NCOLS)
                  ELSE IF ((OTYPE.EQ.1) .AND. (WTFM.EQ.4)) THEN
                     WRITE (LINE,2104,ERR=140) JTT, TIMS, IAR, IAM, U,
     *                  V, M, (AMP(K), PHASE(K), RWT(K), K = 1,NCOLS)
                  ELSE IF ((OTYPE.EQ.2) .AND. (WTFM.EQ.1)) THEN
                     IF (UVM.LE.9999.98) THEN
                        WRITE (LINE,2201,ERR=140) JTT, TIMS, IAR, IAM,
     *                     U, V, M, (AMP(K), PHASE(K), RWT(K), K =
     *                     1,NCOLS)
                     ELSE
                        WRITE (LINE,2211,ERR=140) JTT, TIMS, IAR, IAM,
     *                     U, V, M, (AMP(K), PHASE(K), RWT(K), K =
     *                     1,NCOLS)
                        END IF
                  ELSE IF ((OTYPE.EQ.2) .AND. (WTFM.EQ.2)) THEN
                     IF (UVM.LE.9999.98) THEN
                        WRITE (LINE,2202,ERR=140) JTT, TIMS, IAR, IAM,
     *                     U, V, M, (AMP(K), PHASE(K), RWT(K), K =
     *                     1,NCOLS)
                     ELSE
                        WRITE (LINE,2212,ERR=140) JTT, TIMS, IAR, IAM,
     *                     U, V, M, (AMP(K), PHASE(K), RWT(K), K =
     *                     1,NCOLS)
                        END IF
                  ELSE IF ((OTYPE.EQ.2) .AND. (WTFM.EQ.3)) THEN
                    IF (UVM.LE.9999.98) THEN
                        WRITE (LINE,2203,ERR=140) JTT, TIMS, IAR, IAM,
     *                     U, V, M, (AMP(K), PHASE(K), RWT(K), K =
     *                     1,NCOLS)
                     ELSE
                        WRITE (LINE,2213,ERR=140) JTT, TIMS, IAR, IAM,
     *                     U, V, M, (AMP(K), PHASE(K), RWT(K), K =
     *                     1,NCOLS)
                        END IF
                  ELSE IF ((OTYPE.EQ.3) .AND. (WTFM.EQ.1)) THEN
                     IF (UVM.LE.9999.98) THEN
                        WRITE (LINE,2301,ERR=140) JTT, TIMS, IAR, IAM,
     *                     U, V, (AMP(K), PHASE(K), RWT(K), K = 1,NCOLS)
                     ELSE
                        WRITE (LINE,2311,ERR=140) JTT, TIMS, IAR, IAM,
     *                     U, V, (AMP(K), PHASE(K), RWT(K), K = 1,NCOLS)
                        END IF
                  ELSE IF ((OTYPE.EQ.3) .AND. (WTFM.EQ.2)) THEN
                     IF (UVM.LE.9999.98) THEN
                        WRITE (LINE,2302,ERR=140) JTT, TIMS, IAR, IAM,
     *                     U, V, (AMP(K), PHASE(K), RWT(K), K = 1,NCOLS)
                     ELSE
                        WRITE (LINE,2312,ERR=140) JTT, TIMS, IAR, IAM,
     *                     U, V, (AMP(K), PHASE(K), RWT(K), K = 1,NCOLS)
                        END IF
                  ELSE IF (OTYPE.EQ.4) THEN
                     IF (UVM.LE.9999.98) THEN
                        WRITE (LINE,2400,ERR=140) ITT, IAR, IAM, U, V,
     *                     (AMP(K), PHASE(K), IWT(K), K = 1,NCOLS)
                     ELSE
                        WRITE (LINE,2410,ERR=140) ITT, IAR, IAM, U, V,
     *                     (AMP(K), PHASE(K), IWT(K), K = 1,NCOLS)
                        END IF
                  ELSE IF (OTYPE.EQ.5) THEN
                     IF (XAMP.LE.99.9) THEN
                        WRITE (LINE,2500,ERR=140) JTT(2), JTT(3), TIMS,
     *                     IAR, IAM, (AMP(K), PHASE(K), IWT(K), K =
     *                     1,NCOLS)
                     ELSE
                        WRITE (LINE,2510,ERR=140) JTT(2), JTT(3), TIMS,
     *                     IAR, IAM, (AMP(K), PHASE(K), IWT(K), K =
     *                     1,NCOLS)
                        END IF
                     END IF
C                                       Leading zero(s)
                  IF (OTYPE.EQ.5) THEN
                     IF (LINE(7:7).EQ.' ') LINE(7:7) = '0'
                     IF (LINE(8:8).EQ.' ') LINE(8:8) = '0'
                  ELSE
                     IF (LINE(10:10).EQ.' ') LINE(10:10) = '0'
                     IF (LINE(11:11).EQ.' ') LINE(11:11) = '0'
                     END IF
C                                       Write VIS data
 140              CALL PRTLIN (LUNP(1), FINDP(1), DOCRT, NACROS, TITL1,
     *               TITL2, LINE, IPCNT, PAGE, SCRTCH, IRET)
                  IF (IRET.NE.0) GO TO 960
                  NCOUNT = NCOUNT + 1
                  END IF
 145           PCOUNT = PCOUNT + 1
               LSTIME = DBLE(RPTIME(NN))
               IF (ILOCB.GE.0) THEN
                  LSTANT = IROUND (RPARM(ILOCB+1)) / 256
               ELSE
                  LSTANT = RPARM(ILOCA1+1) + 0.1
                  END IF
               LSTSOU = OLDSOU
               IF(FINISH) THEN
                  LSTSOU = 0
                  LSTANT = -1
                  LSTIME = -1.D0
                  ENDIF
               IF (PCOUNT.GE.XNCNT) GO TO 970
 150           CONTINUE
C                                       Check source
            IF (.NOT.FINISH) THEN
               CALL SOURS (.TRUE., SOUID, OLDSOU, IRET)
               IF (IRET.NE.0) THEN
                  MSGTXT = 'ERROR PROCESSING NEW SOURCE'
                  CALL MSGWRT (8)
                  GO TO 970
                  END IF
               NSAMP = 1
               W = RPARM(ILOCW+1)
               M = W - WBASE + 0.1
               M = MOD (M, 256)
               CALL RFILL (MSAMP, 0.0, RPTIME)
               CALL RFILL (2*MSAMP, 0.0, RPUV)
               CALL FILL (2*MSAMP, 0, RPMM)
               CALL RFILL (28*MSAMP, 0.0, VIS)
               NSTIME = RPARM(ILOCT+1)
               RPTIME(NSAMP) = RPARM(ILOCT+1)
               RPUV(1,NSAMP) = RPARM(ILOCU+1) * XUVFAC
               RPUV(2,NSAMP) = RPARM(ILOCV+1) * XUVFAC
               RPMM(1,NSAMP) = M
               RPMM(2,NSAMP) = 1
               I = 1
               DO 155 K = 1,NCOLS
                  VIS(1,K,NSAMP) = VDAT(I) * VDAT(I+2)
                  VIS(2,K,NSAMP) = INVERT * VDAT(I+1) * VDAT(I+2)
                  VIS(3,K,NSAMP) = VDAT(I+2)
                  VIS(4,K,NSAMP) = VDAT(I+3) * VDAT(I+2)
                  VIS(5,K,NSAMP) = VDAT(I+4) * VDAT(I+2)
                  VIS(6,K,NSAMP) = VDAT(I+5)
                  VIS(7,K,NSAMP) = VDAT(I+6) * VDAT(I+2)
                  I = I + 7
 155              CONTINUE
               LASTM = M
               END IF
            END IF
         IF (.NOT.FINISH) GO TO 100
         END IF
C                                       CRT error
 960  IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1960) IRET
         CALL MSGWRT (8)
         END IF
C                                       Close files.
 970  IF (UVOPN) CALL UVGET ('CLOS', RPARM, BUFF, JERR)
      IF (IRET.EQ.0) THEN
         KBL = KBL + MANT
         IF ((KBL.LE.50) .AND. (IANT(KBL).GT.0)) GO TO 20
         KBL = 1
         END IF
      IF (OPER.EQ.'HOLG') THEN
         WEIGHT = SUMCNT
         IF (NCNT.GT.0) WEIGHT = WEIGHT / NCNT
         WRITE (LINE,1970) WEIGHT
         DO 975 I = 1,NCOLS
            CALL ZTXIO ('WRIT', LUNP(I), FINDP(I), LINE(1:JTRIM(LINE)),
     *         JERR)
            IF (LPOPN(I)) CALL ZTXCLS (LUNP(I), FINDP(I), JERR)
            LPOPN(I) = .FALSE.
 975        CONTINUE
         LPOPN(2) = .FALSE.
         LPOPN(3) = .FALSE.
         LPOPN(4) = .FALSE.
         WRITE (MSGTXT,1975) NWR(1), ISTOKE(1), NWR(2), ISTOKE(2)
         CALL MSGWRT (5)
         WRITE (MSGTXT,1975) NWR(3), ISTOKE(3), NWR(4), ISTOKE(4)
         IF (NSTKS.GT.2) CALL MSGWRT (5)
         END IF
      IF (IRET.EQ.0) THEN
         LBL = LBL + MBAS
         IF ((LBL.LE.50) .AND. (IBAS(LBL).GT.0)) GO TO 20
         END IF
      IF (IRET.LT.0) IRET = 0
      IF ((OPER.NE.'HOLG') .AND. (LPOPN(1))) CALL LPCLOS (LUNP(1),
     *   FINDP(1), IPCNT, JERR)
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1012 FORMAT ('ERROR',I5,' filling antenna common for el and az calc')
 1013 FORMAT ('ERROR',I5,' filling source common for el and az calc')
 1015 FORMAT ('HOLO',I2.2,'-',I2.2,A2,I2.2)
 1016 FORMAT (A2,I2.2)
 1020 FORMAT ('#! RefAnt = ',I2.2,' Antenna = ',I2.2,' Stokes = ''',
     *   A2,''' Freq =',F13.9,' DATE-OBS = ''',A8,'''')
 2020 FORMAT ('#! Averaged antennas =',14(I3,','))
 1021 FORMAT ('#! MINsamp =',I4,'  Npoint =',I4)
 2021 FORMAT ('#! MINsamp =',I4, ';', I3,',', I3,
     *   ' samples dropped at the beginning and at the end')
 1022 FORMAT ('#! IFnumber =',I4,'   Channel =',F8.1)
 1023 FORMAT ('#! TimeRange =',I4,3(',',I3),',',I5,3(',',I3))
 1030 FORMAT ('ERROR',I5,' OPENING OUTPUT DEVICE')
 1040 FORMAT ('#! Averaged Ref-Ants =',14(I3,','))
 1041 FORMAT ('#! DOCAL = ',L1,'  DOPOL =',I2)
 1042 FORMAT ('#! BCHAN=',I6,' ECHAN=',I6,' CHINC=',I3,' averaged')
 1045 FORMAT ('#!',4X,'LL',13X,'MM',13X,'AMPLITUDE',6X,'PHASE',9X,
     *   'SIGMA(AMP)',3X,'SIGMA(PHASE)')
 1046 FORMAT ('#!',4X,'LL',13X,'MM',13X,'REAL',11X,'IMAGINARY',4X,
     *   'SIGMA(REAL)',4X,'SIGMA(IMAG)')
 1050 FORMAT ('File = ',A12,'.',A6,'.',I4,'   Vol =',I2,4X,'Userid =',
     *   I5,5X,'Channel =',F7.1,3X,'IF =',I3)
 1051 FORMAT (A12,'.',A6,'.',I4,' Vol=',I2,' User=',I5,'  Channel=',
     *   F7.1,'  IF=',I3)
 1055 FORMAT ('Ref freq=',F13.9,' GHz  Ncor=',I3,'  No. vis=',I10,
     *   '  Sort order= ',A2)
 1057 FORMAT ('Weights have been multiplied by',1PE12.4)
 1061 FORMAT ('Source= ',A8,3X,'Freq= ',F13.9,3X,'Sort= ',A2,1X,
     *   4(I4,3X,A2,6X,4X))
 1062 FORMAT (A8,4X,'Freq=',F13.9,4X,'Sort= ',A2,3X,4(I4,3X,A2,9X))
 1063 FORMAT (A8,2X,'Freq=',F13.9,2X,'Sort= ',A2,1X,4(2X,I4,2X,A2,7X))
 1064 FORMAT (A8,1X,'Freq=',F13.9,1X,'Sort= ',A2,1X,4(2X,I4,2X,A2,5X))
 1065 FORMAT (A8,F8.4,4(4X,I4,1X,A2,3X))
 1071 FORMAT (4X,'Time',7X,'Ant    l(',A,')   m(',A,')    w',4(3X,A,3X))
 1072 FORMAT (4X,'Time',7X,'Ant   l(',A,')  m(',A,')   w',4(3X,A,2X))
 1073 FORMAT (4X,'Time',7X,'Ant   l(',A,')  m(',A,')',4(3X,A,1X))
 1074 FORMAT (3X,'Time',6X,'Ant   l(',A,')  m(',A,')',4(3X,A))
 1075 FORMAT (3X,'Time',5X,'Ant ',4(2X,A))
 1090 FORMAT ('ERROR:',I7,' INITIALIZING UV FILE')
 1100 FORMAT ('ERROR:',I7,' READING VIS ')
 1101 FORMAT ('Processing input visibility',I10)
 2101 FORMAT (I2,'/',I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,2F11.2,
     *   I5,4(F8.3,I4,F7.1))
 2102 FORMAT (I2,'/',I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,2F11.2,
     *   I5,4(F8.3,I4,F7.2))
 2103 FORMAT (I2,'/',I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,2F11.2,
     *   I5,4(F8.3,I4,F7.3))
 2104 FORMAT (I2,'/',I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,2F11.2,
     *   I5,4(F8.3,I4,F7.4))
 2201 FORMAT (I2,'/',I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,2F9.2,
     *   I4,4(F8.3,I4,F6.1))
 2202 FORMAT (I2,'/',I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,2F9.2,
     *   I4,4(F8.3,I4,F6.2))
 2203 FORMAT (I2,'/',I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,2F9.2,
     *   I4,4(F8.3,I4,F6.3))
 2211 FORMAT (I2,'/',I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,2F9.0,
     *   I4,4(F8.3,I4,F6.1))
 2212 FORMAT (I2,'/',I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,2F9.0,
     *   I4,4(F8.3,I4,F6.2))
 2213 FORMAT (I2,'/',I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,2F9.0,
     *   I4,4(F8.3,I4,F6.3))
 2301 FORMAT (I2,'/',I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,2F9.2,
     *   4(F8.3,I4,F5.1))
 2302 FORMAT (I2,'/',I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,2F9.2,
     *   4(F8.3,I4,F5.2))
 2311 FORMAT (I2,'/',I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,2F9.0,
     *   4(F8.3,I4,F5.1))
 2312 FORMAT (I2,'/',I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,2F9.0,
     *   4(F8.3,I4,F5.2))
 2400 FORMAT (I2,'/',I2.2,':',I2.2,':',I2.2,1X,I2.2,'-',I2.2,2F9.2,
     *   4(F8.3,I4,I3))
 2410 FORMAT (I2,'/',I2.2,':',I2.2,':',I2.2,1X,I2.2,'-',I2.2,2F9.0,
     *   4(F8.3,I4,I3))
 2500 FORMAT (I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,4(F7.3,I4,I3))
 2510 FORMAT (I2.2,':',I2.2,':',F4.1,1X,I2.2,'-',I2.2,4(F7.1,I4,I3))
 1160 FORMAT (6F15.7)
 1165 FORMAT ('#! Time_beg =',F9.6,' El_beg=',F9.4,' Az_beg=',F9.4)
 1166 FORMAT ('#! Time_end =',F9.6,' El_end=',F9.4,' Az_end=',F9.4)
 1960 FORMAT ('ERROR',I5,' DOING I/O TO TERMINAL, PRINTER, OR FILE')
 1970 FORMAT ('#! Average number samples per point =',F8.3)
 1975 FORMAT ('Wrote',I8,1X,A2,' and',I8,1X,A2,' vis to text files')
      END
      SUBROUTINE UVHOPL (IRET)
C-----------------------------------------------------------------------
C   Plots selected portions of uv holography data file.
C   Output:
C      IRET     I      Return code, 1=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   ICH, JJ, IROUND, I, K, IA1, IA2, PCOUNT, PHASE(4), KBL,
     *   IWT(4), SOUID, OLDSOU, ITT(4), LBL, JERR, IUSER, NWR(4),
     *   JTT(3), JJTT(4), M, LASTM, NSAMP, NPOINT, ISAMP, MINSAM, NN,
     *   NNBEG, NNEND, INVERT, KSAMP, NOPTIO, LUNTS(4), SULUN, IPH(4),
     *   LSTSOU, LSTANT, INXLUN, MANT, MBAS, SUMCNT, NCNT, KK, LA1, LA2
      CHARACTER ISTOKE(4)*2, JSTOKE(4,3)*2, PREFIX*5, UVCH*4, UVCC*5,
     *   PLSTOK(4)*2
      LOGICAL   T, REQBAS, FLAG, UVOPN, FINISH, DOTIME, DOAVER, DOMAVE,
     *   DOIT, DOLAST
      REAL      AMP(4), WEIGHT, TPHS, U, V, W, XX, YY, RWT(4), XDAY,
     *   TEMP, RPHAS(4), TIMS, RPARM(20), TADAY, WTSC, CATR(256), EPS,
     *   NSTIME, RRE(4), RIM(4), SRE(4), SIM(4), SAM(4), SPH(4), RX, RY,
     *   RAMP, VDAT(28), UVDIF, ANGLE(1000), UDIF, VDIF, UD, VD, AN
      DOUBLE PRECISION LSTIME, RA2DEG
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'UVHOL.INC'
      INCLUDE 'SAMBUF.INC'
      INCLUDE 'UVHPLT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DFIL.INC'
      INTEGER   CHFLGS(MAXCHA), NCOUNT, NGROUP, I1, J, LIMIT(1000),
     *   NUMBR(1000), LINC
      EQUIVALENCE (JJTT, JTT)
      EQUIVALENCE (CATBLK, CATR)
      DATA T /.TRUE./
      DATA JSTOKE /'VV','HH','VH','HV','RR','LL','RL','LR',
     *   'I_','Q_','U_','V_'/
      DATA LUNTS /3,11,10,91/
      DATA SULUN, INXLUN /17,18/
C-----------------------------------------------------------------------
      CALL CHWANT (ECHAN, 1, CHNSEL, CHFLGS)
      NCOUNT = 0
      RA2DEG = 57.29577951
      LASTM = -40001
      NPOINT = XNPTS + 0.1
      IF (NPOINT.LE.0) NPOINT = 100
      MINSAM = XBDROP + 0.1
      NOPTIO = APARM(1) + 0.1
      NNBEG = APARM(2) + 0.1
      NNEND = APARM(3) + 0.1
      DOAVER = APARM(5).GT.0.0
      DOMAVE = APARM(8).GT.0.0
      DOTIME = APARM(6).GT.0.0
      MBAS = 1
      MANT = 1
      IF (DOAVER) MANT = NANT
      IF (DOMAVE) MBAS = NBAS
      LSTSOU = 0
      LSTANT = -1
      LSTIME = -1.D0
      EPS = 0.1 / (3600. * 24.)
      LINC = NPOINT
      IF (DOTIME) LINC = 1
C                                       Set pointers, counters
      ICH = ACH + 0.5
C                                       Stokes labels
      JJ = 2
      IF (ICOR0.LT.-4) JJ = 1
      IF (DOCONV) JJ = 3
      NFIT = MIN (2, NCOLS)
      IF (DOCONV) NFIT = 1
      DO 15 I = 1,NCOLS
         ISTOKE(I) = JSTOKE(I,JJ)
 15      CONTINUE
      IF (STOKES.EQ.'IV') ISTOKE(2) = 'V_'
      LBL = 1
      KBL = 1
      TADAY = -100.
C                                       Timerange
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
C                                       Set time range.
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.)
     *   + TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.)
     *   + TIMRNG(8) / (24. * 60. * 60.)
      WTSC = 1.0
C                                       Holography loop point
 20   UVOPN = .FALSE.
      OLDSOU = -1
      CALL COPY (MANT, IANT(KBL), ANTENS(1))
      CALL COPY (MBAS, IBAS(LBL), ANTENS(MANT+1))
C                                       zero summing arrays
      NSAMP = 0
      CALL RFILL (MSAMP, 0.0, RPTIME)
      CALL RFILL (2*MSAMP, 0.0, RPUV)
      CALL FILL (2*MSAMP, 0, RPMM)
      CALL RFILL (28*MSAMP, 0.0, VIS)
      NSTIME = -100.0
      SUMCNT = 0
      NCNT = 0
      PLPNT = 0
C                                       Holography
C                                       Append stokes to filename
      IF (KBL.EQ.1) THEN
         DO 30 I = 1,NSTKS
            JJ = 0
            IF (IANT(2).LE.0) JJ = IANT(KBL)
            KK = IBAS(LBL)
            IF (MBAS.GT.1) KK = 0
            PLANTS(1) = KK
            PLANTS(2) = JJ
            PLSTOK(I) = ISTOKE(I)
            NWR(I) = 0
 30         CONTINUE
         END IF
C                                       Holography comment:
C                                       LFREQ, DATOBS
C                                       IBAS(1:MBAS)
C                                       UV scaling
      TEMP = 1.01 / XUVFAC
      CALL METSCA (TEMP, PREFIX, FLAG)
      IF (ABS(TEMP-1.0).LT.0.02) THEN
         UVCH = PREFIX(:4)
         IF (UVCH.EQ.' ') UVCH = 'ASin'
         UVCC = PREFIX
         IF (UVCC.EQ.' ') UVCC = 'ASin'
      ELSE
         UVCH = 'ASin'
         UVCC = 'ASin'
         END IF
C                                      first page
      IPCNT = 998
      TITL1 = ' '
      TITL2 = ' '
      IUSER = NLUSER
C                                       Initialize reading VIS. file.
      INITVS = 1
      CALL UVGET ('INIT', RPARM, BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT, 1090) IRET
         CALL MSGWRT (8)
         IRET = 4
         GO TO 200
         END IF
      UVOPN = .TRUE.
      PCOUNT = 0
      SOUID = 1
      IF (NSOUWD.EQ.1) SOUID = SOUWAN(1)
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, BUFF, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         CALL MSGWRT (8)
         IRET = 4
         GO TO 200
      ELSE
         FINISH = IRET.LT.0
         IRET = 0
C                                       Check whether we need this
C                                       baseline
         IF (.NOT.FINISH) THEN
            IF (ILOCB.GE.0) THEN
               LA1 = INT (RPARM(ILOCB+1)) / 256
               LA2 = MOD (INT (RPARM(ILOCB+1)), 256)
            ELSE
               LA1 = RPARM(1+ILOCA1) + 0.1
               LA2 = RPARM(1+ILOCA2) + 0.1
               END IF
            IF (.NOT.REQBAS (LA1, LA2, DESEL, IANT(KBL), MANT,
     *         IBAS(LBL), MBAS)) GO TO 100
            IA1 = LA1
            IA2 = LA2
            INVERT = 1
            DO 102 K = 1,MBAS
               IF (IA1.EQ.IBAS(LBL+K-1)) INVERT = -1
 102           CONTINUE
            CALL DATAVG (ECHAN, NCOLS, CHFLGS, BUFF, FLUXS, VDAT)
            END IF
C                                       Include this count?
         IF (FINISH) THEN
            M = -40001
            SOUID = -2
         ELSE
            W = RPARM(ILOCW+1)
            M = W - WBASE + 0.1
            IF (M.LE.0) THEN
               LASTM = -10000
               GO TO 100
               END IF
            M = MOD (M, 256)
            IF (ILOCSU.GE.0) SOUID = IROUND (RPARM(ILOCSU+1))
            END IF
C                                       accumulate buffer
         IF ((M.EQ.LASTM) .AND. ((.NOT.OTFMOD) .OR.
     *      (RPARM(ILOCT+1)-NSTIME.LE.EPS)) .AND. (SOUID.EQ.OLDSOU)
     *      .AND. (LQUAL.GE.40000)) THEN
            IF (RPARM(ILOCT+1)-NSTIME.GT.EPS) THEN
               NSAMP = NSAMP + 1
               NSTIME = RPARM(ILOCT+1)
               END IF
            RPTIME(NSAMP) = RPTIME(NSAMP) + RPARM(ILOCT+1)
            RPUV(1,NSAMP) = RPUV(1,NSAMP) + RPARM(ILOCU+1) * XUVFAC
            RPUV(2,NSAMP) = RPUV(2,NSAMP) + RPARM(ILOCV+1) * XUVFAC
            RPMM(1,NSAMP) = M
            RPMM(2,NSAMP) = RPMM(2,NSAMP) + 1
            I = 1
            DO 105 K = 1,NCOLS
               VIS(1,K,NSAMP) = VIS(1,K,NSAMP) + VDAT(I) * VDAT(I+2)
               VIS(2,K,NSAMP) = VIS(2,K,NSAMP) +
     *            INVERT * VDAT(I+1) * VDAT(I+2)
               VIS(3,K,NSAMP) = VIS(3,K,NSAMP) + VDAT(I+2)
               VIS(4,K,NSAMP) = VIS(4,K,NSAMP) + VDAT(I+3) * VDAT(I+2)
               VIS(5,K,NSAMP) = VIS(5,K,NSAMP) + VDAT(I+4) * VDAT(I+2)
               VIS(6,K,NSAMP) = VIS(6,K,NSAMP) + VDAT(I+5)
               VIS(7,K,NSAMP) = VIS(7,K,NSAMP) + VDAT(I+6) * VDAT(I+2)
               I = I + 7
 105           CONTINUE
C                                       print and restart buffer
         ELSE
            IF (NOPTIO.GT.0) THEN
               ISAMP = MIN (NSAMP-1, NNBEG) + 1
               KSAMP = MAX (1, NSAMP - NNEND)
               IF ((NSAMP.LT.MINSAM) .OR. (NSAMP.EQ.0)) KSAMP = -1
            ELSE
               ISAMP = MAX (0, NSAMP-NPOINT) + 1
               KSAMP = NSAMP
               IF (NSAMP.LT.MINSAM) KSAMP = -1
               END IF
            IF (LQUAL.LT.40000) KSAMP = -1
            IF ((DOTIME) .AND. (KSAMP.GT.ISAMP)) THEN
               DO 110 NN = ISAMP+1,KSAMP
                  RPTIME(ISAMP) = RPTIME(ISAMP) + RPTIME(NN)
                  RPUV(1,ISAMP) = RPUV(1,ISAMP) + RPUV(1,NN)
                  RPUV(2,ISAMP) = RPUV(2,ISAMP) + RPUV(2,NN)
                  RPMM(2,ISAMP) = RPMM(2,ISAMP) + RPMM(2,NN)
                  DO 109 K = 1,NCOLS
                     VIS(1,K,ISAMP) = VIS(1,K,ISAMP) + VIS(1,K,NN)
                     VIS(2,K,ISAMP) = VIS(2,K,ISAMP) + VIS(2,K,NN)
                     VIS(3,K,ISAMP) = VIS(3,K,ISAMP) + VIS(3,K,NN)
                     VIS(4,K,ISAMP) = VIS(4,K,ISAMP) + VIS(4,K,NN)
                     VIS(5,K,ISAMP) = VIS(5,K,ISAMP) + VIS(5,K,NN)
                     VIS(6,K,ISAMP) = VIS(6,K,ISAMP) + VIS(6,K,NN)
                     VIS(7,K,ISAMP) = VIS(7,K,ISAMP) + VIS(7,K,NN)
 109                 CONTINUE
 110              CONTINUE
               KSAMP = ISAMP
               END IF
            DO 150 NN = ISAMP,KSAMP
               XDAY = RPTIME(NN) / MAX (1, RPMM(2,NN))
               CALL T2DHMS (0, XDAY, ITT, TIMS)
               CALL T2DHMS (1, XDAY, JJTT, TIMS)
C                                       Scale uvw as user desires
               U = RPUV(1,NN) / MAX (1, RPMM(2,NN))
               V = RPUV(2,NN) / MAX (1, RPMM(2,NN))
               M = RPMM(1,NN)
               SUMCNT = SUMCNT + RPMM(2,NN)
               NCNT = NCNT + 1
C                                       Get vis.
               DO 115 K = 1,NCOLS
                  WEIGHT = VIS(3,K,NN)
                  XX = VIS(1,K,NN) / MAX (1.E-8, WEIGHT)
                  YY = VIS(2,K,NN) / MAX (1.E-8, WEIGHT)
                  RX = VIS(4,K,NN) / MAX (1.E-8, WEIGHT)
                  RY = VIS(5,K,NN) / MAX (1.E-8, WEIGHT)
                  RAMP = VIS(7,K,NN) / MAX (1.E-8, WEIGHT)
                  RX = RX - XX * XX
                  RY = RY - YY * YY
                  RX = SQRT (MAX (0.0, RX))
                  RY = SQRT (MAX (0.0, RY))
                  RRE(K) = XX
                  RIM(K) = YY
                  SRE(K) = RX / SQRT (MAX (1.0, VIS(6,K,NN)-1.0))
                  SIM(K) = RY / SQRT (MAX (1.0, VIS(6,K,NN)-1.0))
                  TPHS = WEIGHT * WTSC
                  RWT(K) = TPHS
                  IWT(K) = IROUND (TPHS)
                  IF (IWT(K).EQ.0) THEN
                     IF (TPHS.LT.0.0) IWT(K) = -1
                     IF (TPHS.GT.0.0) IWT(K) = 1
                     END IF
                  IF ((IA1.NE.IA2) .OR. (ISCROS(K))) THEN
                     AMP(K) = SQRT (XX*XX+YY*YY)
                     TPHS = 57.296 * ATAN2 (YY, XX+1.0E-20)
                     SAM(K) = 0.0
                     SPH(K) = 0.0
                     IF (AMP(K).GT.0.0) THEN
                        SAM(K) = SQRT ((XX*RX/AMP(K))**2 +
     *                     (YY*RY/AMP(K))**2)
     *                     / SQRT (MAX (1.0, VIS(6,K,NN)-1.0))
                        SPH(K) = 57.296 * SQRT ((XX*RY)**2 + (YY*RX)**2)
     *                     / (XX*XX + YY*YY)
     *                     / SQRT (MAX (1.0, VIS(6,K,NN)-1.0))
                        END IF
                     IF (APARM(9).GT.0.0) THEN
                        RRE(K) = RRE(K) / AMP(K) * RAMP
                        RIM(K) = RIM(K) / AMP(K) * RAMP
                        SRE(K) = SRE(K) / AMP(K) * RAMP
                        SIM(K) = SIM(K) / AMP(K) * RAMP
                        SAM(K) = SAM(K) / AMP(K) * RAMP
                        AMP(K) = RAMP
                        END IF
                  ELSE
                     AMP(K) = XX
                     TPHS = 0.0
                     END IF
                  RPHAS(K) = TPHS
                  PHASE(K) = IROUND (TPHS)
                  IPH(K) = IROUND (SPH(K))
 115              CONTINUE
C                                       Write VIS data
C                                       Holography viscera
C                                       Print beg/end time, el and az
C                                       Write to file
               DOIT = .FALSE.
               DO 120 I = 1,NSTKS
                  IF (RWT(I).GT.0) DOIT = .TRUE.
 120              CONTINUE
               IF (DOIT) THEN
                  PLPNT = PLPNT + 1
                  PLU(PLPNT) = U
                  PLV(PLPNT) = V
                  PLTI(PLPNT) = XDAY
                  DO 125 I = 1,NSTKS
                     IF (RWT(I).GT.0) THEN
                        IF (APARM(7).LE.0.0) THEN
                           PLAMP(PLPNT,I) = AMP(I)
                           PLPHAS(PLPNT,I) = RPHAS(I)
                           PLEAMP(PLPNT,I) = SAM(I)
                           PLEPHS(PLPNT,I) = SPH(I)
                        ELSE
                           PLAMP(PLPNT,I) = RRE(I)
                           PLPHAS(PLPNT,I) = RIM(I)
                           PLEAMP(PLPNT,I) = SRE(I)
                           PLEPHS(PLPNT,I) = SIM(I)
                           END IF
                     ELSE
                        PLAMP(PLPNT,I)  = FBLANK
                        PLPHAS(PLPNT,I) = FBLANK
                        PLEAMP(PLPNT,I) = FBLANK
                        PLEPHS(PLPNT,I) = FBLANK
                        END IF
 125                 CONTINUE
                  END IF
               PCOUNT = PCOUNT + 1
               LSTIME = DBLE(RPTIME(NN))
               IF (ILOCB.GE.0) THEN
                  LSTANT = IROUND (RPARM(ILOCB+1)) / 256
               ELSE
                  LSTANT = RPARM(ILOCA1+1) + 0.1
                  END IF
               LSTSOU = OLDSOU
               IF (FINISH) THEN
                  LSTSOU = 0
                  LSTANT = -1
                  LSTIME = -1.D0
                  ENDIF
               IF (PCOUNT.GE.XNCNT) GO TO 200
 150           CONTINUE
C                                       Check source
            IF (.NOT.FINISH) THEN
               CALL SOURS (.FALSE., SOUID, OLDSOU, IRET)
               IF (IRET.NE.0) THEN
                  MSGTXT = 'ERROR PROCESSING NEW SOURCE'
                  CALL MSGWRT (8)
                  GO TO 200
                  END IF
               NSAMP = 1
               W = RPARM(ILOCW+1)
               M = W - WBASE + 0.1
               M = MOD (M, 256)
               CALL RFILL (MSAMP, 0.0, RPTIME)
               CALL RFILL (2*MSAMP, 0.0, RPUV)
               CALL FILL (2*MSAMP, 0, RPMM)
               CALL RFILL (28*MSAMP, 0.0, VIS)
               NSTIME = RPARM(ILOCT+1)
               RPTIME(NSAMP) = RPARM(ILOCT+1)
               RPUV(1,NSAMP) = RPARM(ILOCU+1) * XUVFAC
               RPUV(2,NSAMP) = RPARM(ILOCV+1) * XUVFAC
               RPMM(1,NSAMP) = M
               RPMM(2,NSAMP) = 1
               I = 1
               DO 155 K = 1,NCOLS
                  VIS(1,K,NSAMP) = VDAT(I) * VDAT(I+2)
                  VIS(2,K,NSAMP) = INVERT * VDAT(I+1) * VDAT(I+2)
                  VIS(3,K,NSAMP) = VDAT(I+2)
                  VIS(4,K,NSAMP) = VDAT(I+3) * VDAT(I+2)
                  VIS(5,K,NSAMP) = VDAT(I+4) * VDAT(I+2)
                  VIS(6,K,NSAMP) = VDAT(I+5)
                  VIS(7,K,NSAMP) = VDAT(I+6) * VDAT(I+2)
                  I = I + 7
 155              CONTINUE
               LASTM = M
               END IF
            END IF
         IF (.NOT.FINISH) GO TO 100
         END IF
C                                       Close files.
 200  IF (UVOPN) CALL UVGET ('CLOS', RPARM, BUFF, JERR)
      IF (IRET.EQ.0) THEN
         DOLAST = ((KBL+MANT.LE.50) .AND. (IANT(KBL+MANT).GT.0)) .OR.
     *      ((LBL+MBAS.LE.50) .AND. (IBAS(LBL+MBAS).GT.0))
C                                       Analyze the list
         IF (PLPNT.GT.1) THEN
            NGROUP = 1
            I1 = 1
C                                       allow 6 degree offset
            IF (ABS(PLU(I1+LINC)-PLU(I1)).GT.ABS(PLV(I1+LINC)-PLV(I1)))
     *         THEN
               UVDIF = ABS(PLU(I1+LINC)-PLU(I1))
            ELSE
               UVDIF = ABS(PLV(I1+LINC)-PLV(I1))
               END IF
            UVDIF = UVDIF / 10.0
            MSGTXT = 'SCAN NOT AT 0 OR 90: CHECK L AND M'
 210        IF (ABS(PLU(I1+LINC)-PLU(I1)).LT.UVDIF) THEN
               ANGLE(NGROUP) = ATAN2 (PLU(I1+LINC)-PLU(I1),
     *            PLV(I1+LINC)-PLV(I1)) * RAD2DG
               DOIT = ABS(PLU(I1+LINC)-PLU(I1)).GT.0.00001
               IF (DOIT) CALL MSGWRT (7)
               DO 220 I = I1,PLPNT-LINC
                  IF (ABS(PLU(I+LINC)-PLU(I)).GT.UVDIF) THEN
                     LIMIT(NGROUP) = I + LINC - 1
                     NUMBR(NGROUP) = I + LINC - I1
                     I1 = I + LINC
                     NGROUP = NGROUP + 1
                     GO TO 210
                     END IF
 220              CONTINUE
               LIMIT(NGROUP) = PLPNT
               NUMBR(NGROUP) = PLPNT - I1 + 1
               GO TO 250
            ELSE IF (ABS(PLV(I1+LINC)-PLV(I1)).LT.UVDIF) THEN
               DOIT = ABS(PLV(I1+LINC)-PLV(I1)).GT.0.00001
               IF (DOIT) CALL MSGWRT (7)
               ANGLE(NGROUP) = ATAN2 (PLU(I1+LINC)-PLU(I1),
     *            PLV(I1+LINC)-PLV(I1)) * RAD2DG
               DO 230 I = I1,PLPNT-LINC
                  IF (ABS(PLV(I+LINC)-PLV(I)).GT.UVDIF) THEN
                     LIMIT(NGROUP) = I + LINC - 1
                     NUMBR(NGROUP) = I + LINC - I1
                     I1 = I + LINC
                     NGROUP = NGROUP + 1
                     GO TO 210
                     END IF
 230              CONTINUE
               LIMIT(NGROUP) = PLPNT
               NUMBR(NGROUP) = PLPNT - I1 + 1
            ELSE
               UDIF = ABS (PLU(I1+LINC)-PLU(I1)) * 1.1
               VDIF = ABS (PLV(I1+LINC)-PLV(I1)) * 1.1
               ANGLE(NGROUP) = ATAN2 (PLU(I1+LINC)-PLU(I1),
     *            PLV(I1+LINC)-PLV(I1)) * RAD2DG
               DO 240 I = I1,PLPNT-LINC
                  UD = PLU(I+LINC) - PLU(I)
                  VD = PLV(I+LINC) - PLV(I)
                  AN = ATAN2 (UD, VD) * RAD2DG
                  IF (((ABS(UD).GT.UDIF) .OR. (ABS(VD).GT.VDIF)) .AND.
     *               (ABS(AN-ANGLE(NGROUP)).GT.6.0)) THEN
                     LIMIT(NGROUP) = I + LINC - 1
                     NUMBR(NGROUP) = I + LINC - I1
                     I1 = I + LINC
                     NGROUP = NGROUP + 1
                     GO TO 210
                     END IF
 240              CONTINUE
               LIMIT(NGROUP) = PLPNT
               NUMBR(NGROUP) = PLPNT - I1 + 1
               END IF
C                                       plot the groups
 250        DOIT = .TRUE.
            I1 = 1
            IF ((APARM(7).GT.0.0) .OR. (DPARM(7).GT.0.0)) DPARM(8) = 0.0
            DO 260 J = 1,NGROUP
               IF (NUMBR(J).LE.0) THEN
                  WRITE (MSGTXT,1250) J
                  CALL MSGWRT (7)
                  GO TO 260
                  END IF
               IF (J.EQ.NGROUP) DOIT = DOLAST
               IF ((APARM(7).LE.0.0) .AND. (DPARM(7).GT.0.0)) THEN
                  CALL PLOTPH (PLSTOK, MANT, IANT(KBL), MBAS, IBAS(LBL),
     *               I1, NUMBR(J), DOIT, ANGLE(J), IRET)
               ELSE IF ((APARM(7).LE.0.0) .OR. (DPARM(7).LE.0.0)) THEN
                  CALL PLOTAM (PLAMP, PLSTOK, MANT, IANT(KBL), MBAS,
     *               IBAS(LBL), I1, NUMBR(J), DOIT, ANGLE(J), IRET)
               ELSE
                  CALL PLOTAM (PLPHAS, PLSTOK, MANT, IANT(KBL), MBAS,
     *               IBAS(LBL), I1, NUMBR(J), DOIT, ANGLE(J), IRET)
                  END IF
               IF (IRET.NE.0) GO TO 975
               I1 = I1 + NUMBR(J)
 260           CONTINUE
            END IF
         KBL = KBL + MANT
         IF ((KBL.LE.50) .AND. (IANT(KBL).GT.0)) GO TO 20
         KBL = 1
         END IF
 975  IF (IRET.EQ.0) THEN
         LBL = LBL + MBAS
         IF ((LBL.LE.50) .AND. (IBAS(LBL).GT.0)) GO TO 20
         END IF
      IF (IRET.LT.0) IRET = 0
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1090 FORMAT ('ERROR:',I7,' INITIALIZING UV FILE')
 1100 FORMAT ('ERROR:',I7,' READING VIS ')
 1250 FORMAT ('GROUP',I3,' HAS NO DATA POINTS: CHECK L AND M')
      END
      SUBROUTINE SOURS (DOPRT, SOUID, OLDSOU, IRET)
C-----------------------------------------------------------------------
C   Process the next source number adding header info if the source
C   changes. Calls GETSOU to fill in commons with source info using
C   GETSOU.
C   Input:
C      DOPRT   L      Print things?
C      SOUID   I      Source ID number
C   Input from common:
C      MULTI   L      If true then this is a multi source file.
C      DISK    I      Input file disk number.
C      CNO     I      Input file catalog slot number
C      NSOUWD  I      Number of source numbers to check in SOUWAN
C      SOUWAN  I(*)   List of source numbers desired.
C      LUNP    I      LUN for output.
C      FINDP   I      FTAB pointer for output.
C      DOCRT   R      Requested output type and width.
C      NACROS  I      Actual output width.
C      OTYPE   I      Output width type.
C   Input/output:
C      OLDSOU  I      Last source number, -1 on input => first call.
C   Input/output from common:
C      TITL1   C*132  First title line
C      TITL2   C*132  Second title line
C      IPCNT   I      Line count on page
C      PAGE    I      Page number
C   Output:
C      IRET    I      Return error code, 0=>OK else failed
C   Output in common:C      SNAME   C*8    Source name (DUVH.INC)
C      All values in DSOU.INC
C-----------------------------------------------------------------------
      INTEGER   SOUID, OLDSOU, IRET
      LOGICAL   DOPRT
C
      INTEGER   SULUN, ILQUAL, LPAGE, OLDQ
      CHARACTER OLDNAM*8, LLCH*4, MMCH*4
      HOLLERITH CATUVH(256)
      REAL      RSEC, DSEC
      INCLUDE 'UVHOL.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      EQUIVALENCE (CATUV, CATUVH)
      DATA SULUN /17/
C-----------------------------------------------------------------------
      IRET = 0
C                                       If same source as last skip.
      IF (SOUID.EQ.OLDSOU) GO TO 999
C                                       Get new source info
      OLDQ = LQUAL
      IF (MULTI) THEN
         CALL GETSOU (SOUID, DISKIN, CNOIN, CATUV, SULUN, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1020) IRET, SOUID
            GO TO 990
            END IF
         SOURCE = SNAME(:8)
         RA = RAEPO / DG2RAD
         DEC = DECEPO / DG2RAD
         LQUAL = QUAL
         IF (WBASE.EQ.0.0) LQUAL = QUAL + 40000
         END IF
C                                       Change source name in TITL1
      IF ((DOPRT) .AND. (LQUAL.GE.40000)) THEN
         IF (OTYPE.LE.1) THEN
            OLDNAM = TITL1(9:16)
            TITL1(9:16) = SOURCE
         ELSE
            OLDNAM = TITL1(:8)
            TITL1(1:8) = SOURCE
            END IF
C                                       RA-Dec labels
         CALL H2CHR (4, 1, CATUVH(KHCTP+JLOCR*2), LLCH)
         CALL H2CHR (4, 1, CATUVH(KHCTP+JLOCD*2), MMCH)
         IF (LLCH(:2).EQ.'RA') THEN
            CALL COORDD (1, RA, CHSIG1, HM, RSEC)
         ELSE
            CALL COORDD (2, RA, CHSIG1, HM, RSEC)
            END IF
         CALL COORDD (2, DEC, CHSIG2, DD, DSEC)
C                                       Blank line for new source
         LPAGE = PAGE
         IF (OPER.NE.'HOLG') THEN
            IF ((OLDSOU.GE.0) .AND. (DOCRT.GT.-2.5)) THEN
               LINE = ' '
               CALL PRTLIN (LUNP(1), FINDP(1), DOCRT, NACROS, TITL1,
     *            TITL2, LINE, IPCNT, PAGE, SCRTCH, IRET)
               IF (IRET.NE.0) GO TO 950
            ELSE IF ((OLDSOU.LT.0) .AND. (DOCRT.LE.-2.5)) THEN
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            TITL1, IPCNT, PAGE, SCRTCH, IRET)
               IF (IRET.NE.0) GO TO 950
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            TITL2, IPCNT, PAGE, SCRTCH, IRET)
               IF (IRET.NE.0) GO TO 950
               END IF
C                                       Title for subsequent new source.
            IF ((OLDSOU.LT.0) .OR. (SOURCE.NE.OLDNAM) .OR.
     *         (OLDQ.NE.LQUAL)) THEN
               ILQUAL = MAX (-9999, MIN (99999, QUAL))
               WRITE (LINE,1055) SOURCE, ILQUAL, LLCH, CHSIG1, HM, RSEC,
     *            MMCH, CHSIG2, DD, DSEC
               CALL PRTLIN (LUNP(1), FINDP(1), DOCRT, NACROS, TITL1,
     *            TITL2, LINE, IPCNT, PAGE, SCRTCH, IRET)
               IF (IRET.NE.0) GO TO 950
               IF ((LPAGE.GE.PAGE) .AND. (DOCRT.GT.-2.5)) THEN
                  CALL PRTLIN (LUNP(1), FINDP(1), DOCRT, NACROS, TITL1,
     *               TITL2, TITL1, IPCNT, PAGE, SCRTCH, IRET)
                  IF (IRET.NE.0) GO TO 950
                  END IF
               IF ((LPAGE.GE.PAGE) .AND. (DOCRT.GT.-2.5)) THEN
                  CALL PRTLIN (LUNP(1), FINDP(1), DOCRT, NACROS, TITL1,
     *               TITL2, TITL2, IPCNT, PAGE, SCRTCH, IRET)
                  IF (IRET.NE.0) GO TO 950
                  END IF
               END IF
C                                       Blank line after first
            IF ((OLDSOU.LT.0) .AND. (DOCRT.GT.-2.5)) THEN
               LINE = ' '
               CALL PRTLIN (LUNP(1), FINDP(1), DOCRT, NACROS, TITL1,
     *            TITL2, LINE, IPCNT, PAGE, SCRTCH, IRET)
               IF (IRET.NE.0) GO TO 950
               END IF
            END IF
         END IF
C                                       Save old source number
      OLDSOU = SOUID
      GO TO 999
C                                       Error writing output
 950  WRITE (MSGTXT,1950) IRET
C                                       Error
 990  IF (IRET.GT.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('ERROR:',I7,' OBTAINING DATA FOR SOURCE #',I5)
 1055 FORMAT ('Source ',A8,' (',I5,')  ',A4,' = ',A1,I2.2,I3.2,F6.2,2X,
     *   A4,' = ',A1,I2.2,I3.2,F5.1)
 1950 FORMAT ('ERROR',I5,' DOING I/O TO TERMINAL OR PRINTER')
      END
      SUBROUTINE T2DHMS (NDIG, TIMEIN, TIME, TIMS)
C-----------------------------------------------------------------------
C   Convert from Time to Days Hours Minutes Seconds format
C   Input:
C      NDIG     I       Number of digits in display, determines rounding
C                       for TIMS.
C      TIMEIN   R       Time in days
C   Output:
C      TIME     I*(4)   Output Time in Days Hours Minutes Seconds
C      TIMS     R       Output Time in Seconds
C-----------------------------------------------------------------------
      REAL     TIMEIN, TIMS
      INTEGER  NDIG, TIME(4)
C
      REAL     T
      INTEGER  MUL
C-----------------------------------------------------------------------
      MUL = 10 ** (MAX (0, NDIG))
      T = TIMEIN
      IF (TIMEIN.LT.0.0) T = -T
C
      TIME(1) = T
      T = (T - TIME(1)) * 24.0
      TIME(2) = T
      T = (T - TIME(2)) * 60.0
      TIME(3) = T
      T = (T - TIME(3)) * 60.0
      TIMS = T
      TIME(4) = T*MUL + 0.5
C                                       Now Remove 60 seconds
      IF (TIME(4).GE.60*MUL) THEN
         TIME(4) = TIME(4) - 60*MUL
         TIME(3) = TIME(3) + 1
         END IF
C                                       Now Remove 60 minutes
      IF (TIME(3).GE.60) THEN
         TIME(3) = TIME(3) - 60
         TIME(2) = TIME(2) + 1
         END IF
C                                       Now Remove 24 hours
      IF (TIME(2).GE.24) THEN
         TIME(2) = TIME(2) - 24
         TIME(1) = TIME(1) + 1
         END IF
C                                       Sign
      IF (TIMEIN.LT.0.0) TIME(1) = -TIME(1)
C                                       Seconds
      TIMS = REAL (TIME(4)) / REAL (MUL)
      TIME(4) = TIMS + 0.5
C
 999  RETURN
      END
      SUBROUTINE DATPOL (IA1, IA2, TIME, VIS, IERR)
C-----------------------------------------------------------------------
C   LOCAL VERSION - DOES NOT ROTATE BY PARALLACTIC ANGLE
C
C   Applies polarization correction to data.  This operation is only
C   really defined if KNCOR = 4.  However, it will also apply the
C   parallel hand corrections if KNCOR = 2.
C   Inputs:
C      IA1     I      First antenna number
C      IA2     I      Second antenna number
C      TIME    R      Time in days; used for parallactic angle.
C   Inputs from common in DSEL.INC
C      PARTIM  R      Time of current parallactic angles.
C      PARAGL  R(2,*) Cos and sin of the parallactic angles of
C                     antennas.
C      PARSOU  I      Source ID for current parallactic angles.
C      IFR     R(*)   Ionospheric Faraday RM for each antenna
C      LAMBDA  R(*)   Wavelength of each channel and IF
C      STNPST  C*8    Polarization model type NOW IGNORED
C      SOLTYP  I      Model type numeric code NOW USED (from POLSET)
C      POLCAL  R(2,*) Polarization correction
C                     Values in order:
C                     By baseline
C                        By IF (EIF-BIF+1)
C                           A 4x4 complex matrix to be multiplied by
C                               the observed polarization vector
C                               (RR,LL,RL,LR or XX,YY,XY,YX) to produce
C                                the corrected data.
C                    Indexing scheme: an entry defined by ant1<ant2
C                    starts in element:
C      (((ant1-1)*numant-((ant1+1)*ant1)/2 + ant2) - 1) + 1
C   Input/output:
C      VIS     R(*)  Input visibility array in form of "RR,LL,LR,RL"
C              or "XX,YY,XY,YY"  on output = "RR,LL,RL,LR"
C   NOTE: Uses AIPS LUN 49.
C     Output:
C      IERR         I    Error code, 0=OK, else failed.
C-----------------------------------------------------------------------
      INTEGER   IA1, IA2, IERR
      REAL      TIME, VIS(*)
C
      INTEGER   IIF, IPOL, IFQ, I, LUN, INCPX, IOFF, JOFF, INDEX, JNDEX,
     *   BLNDX, LIMIT, LENTRY, BLPNT, IPNT, PNT(8), OFF(32), OFF2(8),
     *   STORDR, STINC, LOFF, JRL, JLR
      REAL      GR, GI, TR, TI, VTEMP(2,16), XTEMP(2,16), VTEMPX(32),
     *   DPANG, GR1, GI1, TINC, PAINC
      LOGICAL   DOORI, WFLAG
      INCLUDE 'INCS:PUVD.INC'
      REAL      PANGO(MAXANT)
      LONGINT   PP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      INCLUDE 'INCS:DPDC.INC'
      INCLUDE 'PARAL.INC'
      EQUIVALENCE (VTEMP, VTEMPX)
C
      SAVE OFF, OFF2, PANGO, DOORI, INCPX, STINC
C
      DATA PNT /1,2,1,2,1,2,1,2/
      DATA PANGO /MAXANT*100.0/
      DATA LUN /49/
C                                       Time increment (days) to update
C                                       correction matrices (0.1 sec.)
      DATA TINC /1.15E-6/
C                                       Parallac. angle change(rad) to
C                                       update corr. matrices (0 deg)
      DATA PAINC /0.0/
C-----------------------------------------------------------------------
C                                       Orientation-ellipticity?
C                                       DOORI = STNPST.EQ.'ORI-ELP '
      DOORI = SOLTYP.EQ.2
      IF (BCHANS.LE.0) BCHANS = BCHAN
      IF (ECHANS.LE.0) ECHANS = ECHAN
C                                       This routine has no defined
C                                       function at all unless
C                                       KNCOR = 2 or 4.
      IF ((KNCOR.NE.2) .AND. (KNCOR.NE.4)) GO TO 999
C                                       See if parallactic angles
C                                       current
      IF ((CURSOU.NE.PARSOU) .OR. (ABS(TIME-PARTIM).GT.TINC)) THEN
C                                       Source info
         IF ((CURSOU.NE.PARSOU) .OR. (CURSOU.NE.IDSOUR)) THEN
            CALL GETSOU (CURSOU, IUDISK, IUCNO, CATUV, LUN, IERR)
            IF (IERR.NE.0) GO TO 999
            PANGO(1) = 1000.0
            END IF
         PARSOU = CURSOU
C                                       Parallactic angles
         CALL PARANG (TIME, PANGLE)
         DPANG = 0.0
         DO 10 I = 1,NSTNS
            PARAGL(1,I) = COS (PANGLE(I))
            PARAGL(2,I) = -SIN (PANGLE(I))
            DPANG = MAX (DPANG, ABS (PANGO(I)-PANGLE(I)))
 10         CONTINUE
C                                       Update par. angle time
         PARTIM = TIME
C                                       Set visibility increment
         INCPX = CATUV(KINAX)
C                                       Compressed data expanded
         IF (INCPX.EQ.1) INCPX = 3
C                                       Find order of Stokes axis in
C                                       input data.
         CALL AXEFND (8, 'STOKES  ', CATUV(KIDIM), CATUV(KHCTP), STORDR,
     *      IERR)
         IF ((IERR.NE.0) .OR. (STORDR.LT.1)) THEN
            MSGTXT = 'DATPOL: STOKES AXIS NOT FOUND'
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       Find Stokes Increment
         STINC = INCPX
         IF (STORDR.GT.1) STINC = STINC * MAX (1, CATUV(KINAX+1))
         IF (STORDR.GT.2) STINC = STINC * MAX (1, CATUV(KINAX+2))
         IF (STORDR.GT.3) STINC = STINC * MAX (1, CATUV(KINAX+3))
         IF (STORDR.GT.4) STINC = STINC * MAX (1, CATUV(KINAX+4))
C                                       Offset array for vis data
         LIMIT = 8 * KNCOR
         IPNT = -1
         DO 50 IPOL = 1,LIMIT,8
            OFF(IPOL) = IPNT + 1
            OFF(IPOL+1) = IPNT + 2
            OFF(IPOL+2) = IPNT + 1
            OFF(IPOL+3) = IPNT + 2
            OFF(IPOL+4) = IPNT + 1
            OFF(IPOL+5) = IPNT + 2
            OFF(IPOL+6) = IPNT + 1
            OFF(IPOL+7) = IPNT + 2
            IPNT = IPNT + STINC
 50         CONTINUE
         LIMIT = 2 * KNCOR
         IPNT = -1
         DO 60 IPOL = 1,LIMIT,2
            OFF2(IPOL) = IPNT + 1
            OFF2(IPOL+1) = IPNT + 2
            IPNT = IPNT + STINC
 60         CONTINUE
C                                       Time for a new set of matrices
C                                       for linear feeds? Check change
C                                       in parallactic angle.
         IF ((SOLTYP.GT.1) .AND. (DPANG.GT.PAINC)) THEN

C                                       Save parallactic angles
            DO 70 I = 1,NSTNS
               PANGO(I) = PANGLE(I)
 70            CONTINUE
C                                       Use central channel.
            IFQ = (BCHAN + ECHAN)/2
C                                       Get matrices for
C                                       orientation-ellipticity model.
            IF (DOORI) THEN
               CALL ORIPOL
C                                       Get matrices for lin. pol.
            ELSE IF (SOLTYP.EQ.3) THEN
               CALL LXYPOL (IERR)
               IF (IERR.NE.0) GO TO 999
C                                       Get  matrices for VLBI
            ELSE IF (SOLTYP.EQ.4) THEN
               CALL VLBPOL
               END IF
            END IF
         END IF
C                                       Set baseline index
      BLNDX = ((IA1-1)*NSTNS) - (((IA1-1)*IA1)/2) + IA2
      LENTRY = 32 * PCLIF  * PCLCH
C                                       Loop thru IF
      DO 400 IIF = BIF,EIF
         IOFF = (IIF-1) * KNCIF
         BLPNT = LENTRY * (BLNDX-1) + (IIF-BIF)*32*PCLCH + 1
C                                       Loop thru channels
         DO 300 IFQ = BCHANS,ECHANS
            JOFF = ((IFQ-1) * KNCF + IOFF) * INCPX + 1
C                                       Loop thru polarization
C                                       Deal with case of missing
C                                       parallel poln; use one present
C                                       for correction.
            WFLAG = .FALSE.
C                                       1st par. poln missing
            IF (VIS(JOFF+2).LE.0.0) THEN
               VIS(JOFF) = VIS(JOFF+OFF2(3))
               VIS(JOFF+1) = VIS(JOFF+OFF2(4))
               VIS(JOFF+2) = 0.0
               END IF
C                                       2nd par. poln missing
            IF (VIS(JOFF+OFF2(3)+2).LE.0.0) THEN
               VIS(JOFF+OFF2(3)) = VIS(JOFF)
               VIS(JOFF+OFF2(4)) = VIS(JOFF+1)
               VIS(JOFF+OFF2(3)+2) = 0.0
C                                       Flag all if neither parallel
C                                       poln present.
               IF (VIS(JOFF+2).LE.0.0) WFLAG = .TRUE.
               END IF
C                                       Check for missing cross-hand
C                                       data
            IF (KNCOR.GT.2) THEN
               JRL = JOFF + OFF2(5)
               JLR = JOFF + OFF2(7)
C                                       Check if both missing
               IF ((VIS(JRL+2).LE.0.0).AND.(VIS(JLR+2).LE.0.0)) THEN
C                                       Zero cross-hand data used in
C                                       correction
                  CALL RFILL (2, 0.0, VIS(JRL))
                  CALL RFILL (2, 0.0, VIS(JLR))
C                                       1st cross-hand missing
               ELSE IF (VIS(JRL+2).LE.0.0) THEN
C                                       Use RL=conjg(LR) approx.
                  VIS(JRL) = VIS(JLR)
                  VIS(JRL+1) = -VIS(JLR+1)
C                                       2nd cross-hand missing
               ELSE IF (VIS(JLR+2).LE.0.0) THEN
C                                       Use LR=conjg(RL) approx.
                  VIS(JLR) = VIS(JRL)
                  VIS(JLR+1) = -VIS(JRL+1)
                  END IF
               END IF
C                                       If DOPOL > 2 check for
C                                       any missing correlations
            IF ((DOPOL.EQ.3) .OR. (DOPOL.EQ.8)) THEN
               LIMIT = 2 * KNCOR
               DO 100 IPOL = 1, LIMIT, 2
                  IF (VIS(JOFF+OFF2(IPOL)+2).LE.0.0) WFLAG = .TRUE.
100               CONTINUE
               END IF
C                                       Check for blanked IFR
            IF ((IFR(IA1).EQ.FBLANK) .OR. (IFR(IA2).EQ.FBLANK)) THEN
               WFLAG = .TRUE.
               END IF
C                                       Flag all output data if
C                                       both par. hands missing or
C                                       (DOPOL > 2) and any polzn.
C                                       correlations are missing.
C                                       Also flag output data if
C                                       IFR corrections are blanked
            IF (WFLAG) THEN
               LIMIT = 2 * KNCOR
               DO 120 IPOL = 1, LIMIT, 2
                  VIS(JOFF+OFF2(IPOL)+2) = 0.0
120               CONTINUE
               END IF
C                                       Save old data
            LIMIT = 8 * KNCOR
            DO 150 IPOL = 1,LIMIT
               JNDEX = JOFF + OFF(IPOL)
               VTEMPX(IPOL) = VIS(JNDEX)
 150           CONTINUE
C                                       Clear XTEMP (in case KNCOR < 4)
            CALL RFILL (2*16, 0.0, XTEMP)
C                                       Matrix x vector multiply
            PP = BLPNT + PPOLCL
            LIMIT = 4 * KNCOR
            DO 200 IPOL = 1,LIMIT
               XTEMP(1,IPOL) = VTEMP(1,IPOL) * POLCAL(PP) -
     *            VTEMP(2,IPOL) * POLCAL(PP+1)
               XTEMP(2,IPOL) = VTEMP(1,IPOL) * POLCAL(PP+1) +
     *            VTEMP(2,IPOL) * POLCAL(PP)
               PP = PP + 2
 200           CONTINUE
            IF (PDVER.GT.0) BLPNT = BLPNT + 32
C                                       sum
            INDEX = 1
            LIMIT = KNCOR * 2
            DO 250 IPOL = 1,LIMIT
               INDEX = ((IPOL-1)/2) + 1
               IPNT = PNT(IPOL)
               JNDEX = JOFF + OFF2(IPOL)
               VIS(JNDEX) = XTEMP(IPNT,INDEX) + XTEMP(IPNT,INDEX+4) +
     *            XTEMP(IPNT,INDEX+8) + XTEMP(IPNT,INDEX+12)
 250           CONTINUE
C                                       Done if 'ORI-ELI'
            IF (DOORI) GO TO 300
C                                       Done if not 4 polarizations
            IF (KNCOR .LT. 4) GO TO 300
C                                       PARALLACTIC angle
            IF (DOPARA) THEN
               GR = PARAGL(1,IA1) * PARAGL(1,IA2) - PARAGL(2,IA1) *
     *            PARAGL(2,IA2)
               GI = PARAGL(1,IA1) * PARAGL(2,IA2) + PARAGL(2,IA1) *
     *            PARAGL(1,IA2)
C                                       no rotation
            ELSE
               GR = 1.0
               GI = 0.0
               END IF
C                                       Correct RL,LR for parallactic
C                                       angle and ionospheric Faraday
C                                       rotation:
            LOFF = (IIF - 1) * NLAMDA + IFQ
            GR1 = GR * COS (LAMBDA(LOFF)**2 * (IFR(IA1) + IFR(IA2))) -
     *         GI * SIN (LAMBDA(LOFF)**2 * (IFR(IA1) + IFR(IA2)))
            GI1 = GI * COS (LAMBDA(LOFF)**2 * (IFR(IA1) + IFR(IA2))) +
     *         GR * SIN (LAMBDA(LOFF)**2 * (IFR(IA1) + IFR(IA2)))
C                                       Correct RL
            IPNT = 5
            TR = VIS(JOFF+OFF2(IPNT))
            TI = VIS(JOFF+OFF2(IPNT+1))
            VIS(JOFF+OFF2(IPNT)) = TR * GR1 + TI * GI1
            VIS(JOFF+OFF2(IPNT+1)) = TI * GR1 - TR * GI1
C                                       Correct LR
            IPNT = 7
            TR = VIS(JOFF+OFF2(IPNT))
            TI = VIS(JOFF+OFF2(IPNT+1))
            VIS(JOFF+OFF2(IPNT)) = TR * GR1 - TI * GI1
            VIS(JOFF+OFF2(IPNT+1)) =  TI * GR1 + TR * GI1
 300        CONTINUE
 400     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE PLOTAM (PLDATA, PLSTOK, MANT, JANT, MBAS, JBAS, I1, NN,
     *   DOIT, ANGLE, IRET)
C-----------------------------------------------------------------------
C   Does TV or plot file of the data - amplitude like parameters
C   Inputs:
C      PLDATA   R(*)     Data to be plotted
C      PLSTOK   C(*)*2   Stokes labels
C      MANT     I        Number antennas in JANT
C      JANT     I(*)     Antenna numbers
C      MBAS     I        Number antennas in JBAS
C      JBAS     I(*)     Antenna numbers
C      I1       I        Start index in arrays
C      NN       I        Number of points
C      DOIT     L        T => there are more plots to come
C      ANGLE    R        scan angle
C   Output:
C      IRET     I        > 0 => failure
C-----------------------------------------------------------------------
      INCLUDE 'UVHPLT.INC'
      REAL      PLDATA(MAXPLT,*), ANGLE
      INTEGER   MANT, JANT(*), MBAS, JBAS(*), I1, NN, IRET
      LOGICAL   DOIT
      CHARACTER PLSTOK(*)*2
C
      INTEGER   PLBUFF(256), VER, IPSIZE, ITYPE, LUNPL, FINDPL, TVCHN,
     *   GRCHN, TVCORN(2), I, J, INCHAR, INP, IT(3), ID(3), LTYPE,
     *   DEPTH(5), IERR, LABEL, IROUND, ILITY, ISYM, NGOOD, NNOFIT,
     *   I2, ITT(4), JTT(4)
      REAL      BLC(2), TRC(2), UMIN, UMAX, VMIN, VMAX, DMIN, DMAX,
     *   XYSCL(2), XYOFF(2) , CHOUT(4), DX, DY, TI, TR, XMULT(2),
     *   COLR, AX(5), AY(5), VALUE, XY(2), PEAKS(2,3,4), XX, YY, YY1(3),
     *   VV1, VV2, RATIO, XSEP
      LOGICAL   DOTV, VSIGN, DOLOG, GOOD, DO3C, DOLINE, BLNKD, OKAY(4)
      CHARACTER PFILE*48, XUNITS*20, CHTMP*18, ATIME*8, ADATE*12,
     *   TEXT*132 , TEXT2*132, CAXIS*1
      HOLLERITH CATH(256)
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'UVHOL.INC'
      REAL      XVAL(MAXPLT), XMIN, XMAX, XSCALE, LSCAL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (CATUV, CATH)
      DATA LUNPL /26/
      DATA DEPTH /5*1/
C-----------------------------------------------------------------------
      ISYM = IROUND (SYMBOL)
      IF ((ISYM.LE.0) .OR. (ISYM.GT.24)) ISYM = 1
      NGOOD = 0
      NNOFIT = 0
      IF (ABS(FACTOR).LT.0.1) FACTOR = 1
      DOLOG = DPARM(6).GT.0.0
      LSCAL = 20.0
      IF (DPARM(6).GT.1.5) LSCAL = 10.0
      DOLINE = FACTOR.LT.0.0
C                                       examine data to be plotted
      UMIN = 1.E10
      UMAX = -UMIN
      VMIN = UMIN
      VMAX = UMAX
      DMIN = UMIN
      DMAX = UMAX
      I2 = I1 + NN - 1
      DO 20 I = I1,I2
         DO 10 J = 1,NSTKS
            IF (PLDATA(I,J).NE.FBLANK) THEN
               IF (DOLOG) PLDATA(I,J) = LSCAL * LOG10 (ABS(PLDATA(I,J)))
               DMIN = MIN (DMIN, PLDATA(I,J))
               DMAX = MAX (DMAX, PLDATA(I,J))
               END IF
 10         CONTINUE
         PLU(I) = ASIN (PLU(I))
         PLV(I) = ASIN (PLV(I))
         UMIN = MIN (UMIN, PLU(I))
         UMAX = MAX (UMAX, PLU(I))
         VMIN = MIN (VMIN, PLV(I))
         VMAX = MAX (VMAX, PLV(I))
 20      CONTINUE
      IF ((ABS(UMAX-UMIN).LT.0.00001) .AND. (ABS(VMAX-VMIN).LT.0.00001))
     *   THEN
         MSGTXT = 'GROUP SKIPPED - NO POSITION CHANGE'
         IRET = 0
         CALL MSGWRT (6)
         GO TO 999
         END IF
      VSIGN = (VMAX-VMIN).GT.(UMAX-UMIN)
      IF (VSIGN) THEN
         CAXIS = 'M'
      ELSE
         CAXIS = 'L'
         END IF
      XMIN = 1.E10
      XMAX = -XMIN
      DO 30 I = I1,I2
         XVAL(I) = SQRT (PLU(I)*PLU(I) + PLV(I)*PLV(I))
         IF (VSIGN) THEN
            IF (PLV(I).LT.0) XVAL(I) = -XVAL(I)
         ELSE
            IF (PLU(I).LT.0) XVAL(I) = -XVAL(I)
            END IF
         XMIN = MIN (XMIN, XVAL(I))
         XMAX = MAX (XMAX, XVAL(I))
 30      CONTINUE
      CALL LFILL (4, .FALSE., OKAY)
      IF (DPARM(8).GT.0.0) THEN
         CALL FITIT (I1, I2, NFIT, XVAL, PLDATA, PEAKS, OKAY)
         END IF
      DX = (XMAX - XMIN) * 0.03
      XMAX = XMAX + DX
      XMIN = XMIN - DX
      XSCALE = RAD2DG
      XUNITS = 'Degrees'
      IF (XMAX-XMIN.LT.DG2RAD) THEN
         XSCALE = XSCALE*60.0
         XUNITS = 'Arc minutes'
         END IF
      IF (XMAX-XMIN.LT.DG2RAD/60.0) THEN
         XSCALE = XSCALE*60.0
         XUNITS = 'Arc seconds'
         END IF
      DO 35 I = I1,I2
         XVAL(I) = XVAL(I) * XSCALE
 35      CONTINUE
      XMIN = XMIN * XSCALE
      XMAX = XMAX * XSCALE
C                                       create plot file
      DOTV = XDOTV.GT.0.0
      IF (.NOT.DOTV) THEN
         VER = 0
         CALL MADDEX ('PL', DISKIN, CNOIN, CATUV, PLBUFF, .TRUE.,
     *      'WRIT', VER, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATING PLOT FILE'
            GO TO 980
            END IF
         END IF
      CALL ZPHFIL ('PL', DISKIN, CNOIN, VER, PFILE, IRET)
      IPSIZE = 0
      ITYPE = 53
      TVCHN = 1
      GRCHN = XGRCHN + 0.1
      TVCORN(1) = 0
      TVCORN(2) = 0
C                                       adjust adverbs for plot files
      IF (.NOT.DOTV) THEN
         IF (RNGPIX(2).LE.RNGPIX(1)) THEN
            PIXRNG(1) = DMIN
            PIXRNG(2) = DMAX
            END IF
         CALL TODHMS (PLTI(I1), ITT)
         CALL TODHMS (PLTI(I2), JTT)
         DO 39 J = 1,4
            XTIME(J) = ITT(J)
            XTIME(J+4) = JTT(J)
 39         CONTINUE
         CALL RFILL (50, 0.0, XANT)
         CALL RFILL (50, 0.0, XBASE)
         DO 40 J = 1,MANT
            XANT(J) = JANT(J)
 40         CONTINUE
         DO 41 J = 1,MBAS
            XBASE(J) = JBAS(J)
 41         CONTINUE
         END IF
      CALL GINIT (DISKIN, CNOIN, PFILE, IPSIZE, ITYPE, NPARM,
     *   XNAMEI, DOTV, TVCHN, GRCHN, TVCORN, CATUV, PLBUFF, LUNPL,
     *   FINDPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT PLOT WITH GINIT'
         GO TO 980
         END IF
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      IF (DOTV) THEN
         TRC(1) = WINDTV(3) - WINDTV(1)
         TRC(2) = WINDTV(4) - WINDTV(2)
         IF (DO3COL.LE.0.0) THEN
            CALL GCINIT (GPHTVG(4), 0, IRET)
            IF (IRET.NE.0) GO TO 960
            CALL GCINIT (GPHTVG(3), 0, IRET)
            IF (IRET.NE.0) GO TO 960
            END IF
         END IF
      IF (XYRATO.LT.0.01) XYRATO = 1.0
C                                       fool with location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      IF (RNGPIX(2).GT.RNGPIX(1)) THEN
         DMAX = RNGPIX(2)
         DMIN = RNGPIX(1)
         END IF
      DX = (DMAX - DMIN) * 0.03
      DMAX = DMAX + DX
      DMIN = DMIN - DX
      TR = 1.1 * (DMAX - DMIN)
      IF (TR.LE.0.0) TR = 1.0
      TI = TR
      IF (XLTYPE.EQ.0.0) XLTYPE = 3.0
      LABEL = IROUND (XLTYPE)
      CALL METSCL (LABEL, TR, CPREF(2,LOCNUM), GOOD)
      XMULT(2) = TR / TI
      CPREF(1,LOCNUM) = ' '
      XMULT(1) = 1.0
      DO 50 I = 1,2
         IF (I.EQ.1) THEN
            TR = XMAX - XMIN
            XYOFF(I) = XMIN
         ELSE
            TR = DMAX - DMIN
            XYOFF(I) = DMIN
            END IF
         XYSCL(I) = (TRC(I) - BLC(I)) / TR
         RPLOC(I,LOCNUM) = BLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I) * XMULT(I)
         AXINC(I,LOCNUM) = TR * XMULT(I) / (TRC(I) - BLC(I))
 50      CONTINUE
      CTYP(1,LOCNUM) = XUNITS
      IF ((APARM(7).LE.0.0) .AND. (DPARM(7).LE.0.0)) THEN
         CTYP(2,LOCNUM) = 'Amplitude'
         IF (DOLOG) CTYP(2,LOCNUM) = 'Power'
      ELSE IF (DPARM(7).LE.0.0) THEN
         CTYP(2,LOCNUM) = 'Real part'
      ELSE
         CTYP(2,LOCNUM) = 'Imaginary part'
         END IF
C                                       character borders
      CALL RFILL (4, 0.5, CHOUT)
      CALL CHNTIC (BLC, TRC, INP)
      INP = MAX (INP, 3)
      LTYPE = MOD (ABS (LABEL), 100)
      IF (LTYPE.EQ.2) CHOUT(1) = 2.5
      IF (LTYPE.GT.2) CHOUT(1) = INP + 4
      IF (LTYPE.GT.1) CHOUT(2) = 2.0
      IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = 3.333
      IF ((LABEL.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7))
     *   CHOUT(4) = CHOUT(4) + 1.333
C                                       Init for line drawing.
      CALL GINITL (BLC, TRC, XYRATO, CHOUT, DEPTH, PLBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT LINE DRAWING'
         GO TO 965
         END IF
      IF (.NOT.DOTV) THEN
         WRITE (MSGTXT,1050) VER
         CALL MSGWRT (2)
         END IF
C                                       Draw border
      CALL GLTYPE (1, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), BLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), BLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), TRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), TRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DX = 0.0
         DY = 1.833
C                                       The second line of the header
         CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
C                                       File name
         CALL H2CHR (18, KHIMNO, CATH(KHIMN), CHTMP)
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), CHTMP(13:18))
         CALL NAMEST (CHTMP, CATUV(KIIMS), TEXT(1:), INCHAR)
         CALL REFRMT (TEXT, ' ', INCHAR)
C                                       time range
         CALL TODHMS (PLTI(I1), ITT)
         CALL TODHMS (PLTI(I2), JTT)
         TEXT(INCHAR+1:) = '__TIME RANGE'
         INCHAR = INCHAR + 14
         IF (JTT(1).GT.0) THEN
            WRITE (TEXT(INCHAR:),1055) ITT, JTT
         ELSE
            WRITE (TEXT(INCHAR:),1056) ITT(2), ITT(3), ITT(4), JTT(2),
     *         JTT(3), JTT(4)
            END IF
         CALL REFRMT (TEXT, '_', INCHAR)
         WRITE (TEXT(INCHAR+1:),1057) ANGLE
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
C                                       refant, moving
         DY = 0.5
         CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
         WRITE (TEXT,1060) BIF, 'REFANT', (JANT(J), J = 1,MANT)
         WRITE (TEXT2,1061) ' ANT', (JBAS(J), J=1,MBAS)
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL REFRMT (TEXT2, ' ', J)
         TEXT(INCHAR+3:) = TEXT2(:J)
         INCHAR = INCHAR + 2 + J
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
C                                       Date/time/version
         IF ((LABEL.GT.0) .AND. (LTYPE.GT.1)) THEN
            DY = 0.5 + 2 * 1.333
C                                       the first line of the header
            CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 970
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (TEXT,1065) VER, ADATE, ATIME
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 970
            END IF
         END IF
C                                       Put on labels and ticks
      CALL CLAB1 (BLC, TRC, CHOUT, LABEL, XYRATO, .FALSE., PLBUFF,
     *   IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Loop
      ILITY = 4
      CALL GLTYPE (ILITY, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      COLR =  NSTKS - 1
      DO3C =  (DO3COL.GT.0.0) .AND. (COLR.GE.1)
      DO 200 J = 1,NSTKS
         IF (DO3C) THEN
            ILITY = 5 - J
            CALL GLTYPE (ILITY, PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 970
            END IF
C                                       stokes labels
         INCHAR = 2
         IF (PLSTOK(J)(2:).EQ.'_') INCHAR = 1
         CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
         DY = - 2.5
         DX = (1.5 + 3 * J)
         CALL GICHAR (1, INCHAR, 0, DX, DY, PLSTOK(J), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
C                                       Extrema fits
         IF (OKAY(J)) THEN
            DO 110 I = 1,3
               XX = PEAKS(2,I,J) * XSCALE
               XX = XYSCL(1) * (XX - XYOFF(1)) + BLC(1)
               YY = PEAKS(1,I,J)
               YY  = XYSCL(2) * (YY - XYOFF(2)) + BLC(2)
               CALL GPOS (XX, BLC(2), PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 970
               CALL GVEC (XX, YY, PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 970
               IF (J.EQ.1) YY1(I) = YY
               IF (I.EQ.1) THEN
                  YY = (YY1(I) - BLC(2)) / 1.5 + BLC(2)
                  IF ((DPARM(6).GT.0.0) .AND. (NSTKS.GT.NFIT))
     *               YY = (YY1(I) - BLC(2)) / 1.15 + BLC(2)
               ELSE
                  YY = (YY1(I) - BLC(2)) * 1.2 + BLC(2)
                  IF ((DPARM(6).GT.0.0) .AND. (NSTKS.GT.NFIT))
     *               YY = (YY1(I) - BLC(2)) * 1.05 + BLC(2)
                  END IF
               WRITE (CHTMP,1100) PEAKS(1,I,J)
               CALL REFRMT (CHTMP, '_', INCHAR)
               DX = -INCHAR/2.0
               IF (I.EQ.1) THEN
                  DY = -1.6*(J-1)
               ELSE
                  DY = (J - 1) * 1.6
                  END IF
               CALL GPOS (XX, YY, PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 970
               CALL GICHAR (1, INCHAR, 0, DX, DY, CHTMP, PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 970
 110           CONTINUE
            IF (PEAKS(2,2,J).GT.0.0) THEN
               VV1 = PEAKS(1,2,J)
               VV2 = PEAKS(1,3,J)
               XSEP = PEAKS(2,2,J) - PEAKS(2,3,J)
            ELSE
               VV2 = PEAKS(1,2,J)
               VV1 = PEAKS(1,3,J)
               XSEP = PEAKS(2,3,J) - PEAKS(2,2,J)
               END IF
            WRITE (MSGTXT,1110) J, XSEP*XSCALE, XUNITS
            CALL MSGWRT (4)
            IF (DPARM(6).GT.1.5) THEN
               VV1 = 10.0 ** (VV1/10.0)
               VV2 = 10.0 ** (VV2/10.0)
            ELSE IF (DPARM(6).GT.0.0) THEN
               VV1 = 10.0 ** (VV1/20.0)
               VV2 = 10.0 ** (VV2/20.0)
               END IF
            RATIO = 0.0
            IF (VV2.NE.0.0) RATIO = 20.0 * LOG10 (VV1/VV2)
            IF (DPARM(6).GT.1.5) RATIO = RATIO / 2.0
            WRITE (MSGTXT,1115) J, RATIO
            CALL MSGWRT (4)
            WRITE (CHTMP,1100) RATIO
            CALL REFRMT (CHTMP, '_', INCHAR)
            DX = -INCHAR - 2.5
            DY = -2.5 - 1.6 * J
            CALL GPOS (TRC(1), TRC(2), PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 970
            CALL GICHAR (1, INCHAR, 0, DX, DY, CHTMP, PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 970
            END IF
         DO 120 I = I1,I2
            VALUE = PLDATA(I,J)
            IF (VALUE.EQ.FBLANK) GO TO 120
            XY(1) = XYSCL(1) * (XVAL(I) - XYOFF(1)) + BLC(1)
            IF ((XY(1).LT.BLC(1)) .OR. (XY(1).GT.TRC(1))) THEN
               NNOFIT = NNOFIT + 1
               GO TO 120
               END IF
            XY(2) = XYSCL(2) * (VALUE - XYOFF(2)) + BLC(2)
            IF ((XY(2).LT.BLC(2)) .OR. (XY(2).GT.TRC(2))) THEN
               NNOFIT = NNOFIT + 1
               GO TO 120
               END IF
            NGOOD = NGOOD + 1
C                                       Mark point
            DY = 5.0 * ABS (FACTOR)
            DX = DY
            AX(1) = XY(1)
            AY(1) = XY(2)
            AX(2) = AX(1)
            AX(3) = AX(1)
            AX(4) = AX(1) - DX
            AX(5) = AX(1) + DX
            AY(2) = AY(1) + DY
            AY(3) = AY(1) - DY
            AY(4) = AY(1)
            AY(5) = AY(1)
            IF ((DO3COL.LE.0) .AND. (ILITY.NE.4)) THEN
               ILITY = 4
               CALL GLTYPE (ILITY, PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 970
               END IF
            CALL PNTPLT (ISYM, AX, AY, BLC, TRC, .FALSE., .FALSE.,
     *         PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 970
 120        CONTINUE
         IF (DOLINE) THEN
            BLNKD = .TRUE.
            DO 140 I = I1,I2
               VALUE = PLDATA(I,J)
               IF (VALUE.EQ.FBLANK) GO TO 140
               XY(1) = XYSCL(1) * (XVAL(I) - XYOFF(1)) + BLC(1)
               IF ((XY(1).LT.BLC(1)) .OR. (XY(1).GT.TRC(1))) THEN
                  BLNKD = .TRUE.
                  GO TO 140
                  END IF
               XY(2) = XYSCL(2) * (VALUE - XYOFF(2)) + BLC(2)
               IF ((XY(2).LT.BLC(2)) .OR. (XY(2).GT.TRC(2))) THEN
                  BLNKD = .TRUE.
                  GO TO 140
                  END IF
C                                       Mark point
               IF (BLNKD) THEN
                  CALL GPOS (XY(1), XY(2), PLBUFF, IRET)
                  BLNKD = .FALSE.
               ELSE
                  CALL GVEC (XY(1), XY(2), PLBUFF, IRET)
                  END IF
               IF (IRET.NE.0) GO TO 970
 140           CONTINUE
            END IF
 200     CONTINUE
C                                       Done: finish plot
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      GPHPAG = DOIT
      CALL GFINIS (PLBUFF, IRET)
      IF (IRET.GT.0) GO TO 975
      IF (.NOT.DOTV) THEN
         CALL HIPLOT (DISKIN, CNOIN, VER, SCRBUF, IERR)
         END IF
      GO TO 999
C                                       ZPHFIL or GINIT failure.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      IF (.NOT.DOTV) THEN
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATUV, SCRBUF,
     *      VER, I)
         NCFILE = NCFILE - 1
         END IF
      GO TO 999
C
 965  CALL MSGWRT (8)
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      GPHPAG = DOIT
      CALL GFINIS (PLBUFF, I)
      IF (I.NE.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, SCRBUF, I)
            END IF
         GO TO 999
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, SCRBUF,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
      GO TO 999

 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PLOTIT ERROR',I4,' ON ',A)
 1050 FORMAT ('Plot file version',I4,'  created.')
 1055 FORMAT (I3,'/',2(I2.2,':'),I2.2,' - ',I3,'/',2(I2.2,':'),I2.2)
 1056 FORMAT (2(I2.2,':'),I2.2,' - ',2(I2.2,':'),I2.2)
 1057 FORMAT ('__scan'F7.1,' deg')
 1060 FORMAT ('IF',I4,'_ ',A,30I3)
 1061 FORMAT (A,30I3)
 1065 FORMAT ('Plot file version',I4,'__created ',A, A)
 1100 FORMAT (F8.3)
 1110 FORMAT ('Stokes',I2,'   Sidelobe separation',F7.3,1X,A)
 1115 FORMAT ('Stokes',I2,'   Power ratio',F9.5,' in db')
 1200 FORMAT ('PLOTIT:',I9,' points plotted')
 1202 FORMAT ('PLOTIT:',I9,' points did not fit')
 1960 FORMAT ('PLOTIT: ERROR DURING GRAPH FILE CREATION')
 1970 FORMAT ('PLOTIT: ERROR DURING GRAPHING. WILL TRY TO FINISH ',
     *   'PARTIAL GRAPH')
      END
      SUBROUTINE PLOTPH (PLSTOK, MANT, JANT, MBAS, JBAS, I1, NN, DOIT,
     *   ANGLE, IRET)
C-----------------------------------------------------------------------
C   Does TV or plot file of the data - phase
C   Inputs:
C      PLSTOK   C(*)*2   Stokes labels
C      MANT     I        Number antennas in JANT
C      JANT     I(*)     Antenna numbers
C      MBAS     I        Number antennas in JBAS
C      JBAS     I(*)     Antenna numbers
C      I1       I        Start index in arrays
C      NN       I        Number of points
C      DOIT     L        T => there are more plots to come
C      ANGLE    R        scan angle
C   Output:
C      IRET     I        > 0 => failure
C-----------------------------------------------------------------------
      INTEGER   MANT, JANT(*), MBAS, JBAS(*), I1, NN, IRET
      LOGICAL   DOIT
      CHARACTER PLSTOK(*)*2
      REAL      ANGLE
C
      INTEGER   PLBUFF(256), VER, IPSIZE, ITYPE, LUNPL, FINDPL, TVCHN,
     *   GRCHN, TVCORN(2), I, J, INCHAR, INP, IT(3), ID(3), LTYPE,
     *   DEPTH(5), IERR, LABEL, IROUND, ILITY, ISYM, NGOOD, NNOFIT,
     *   I2, ITT(4), JTT(4)
      REAL      BLC(2), TRC(2), UMIN, UMAX, VMIN, VMAX, DMIN, DMAX,
     *   XYSCL(2), XYOFF(2) , CHOUT(4), DX, DY, TI, TR, XMULT(2),
     *   COLR, AX(5), AY(5), VALUE, XY(2), PMIN, PMAX, TEMP
      LOGICAL   DOTV, VSIGN, GOOD, DO3C, DOLINE, BLNKD
      CHARACTER PFILE*48, XUNITS*20, CHTMP*18, ATIME*8, ADATE*12,
     *   TEXT*132 , TEXT2*132, CAXIS*1
      HOLLERITH CATH(256)
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'UVHOL.INC'
      INCLUDE 'UVHPLT.INC'
      REAL      XVAL(MAXPLT), XMIN, XMAX, XSCALE
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (CATUV, CATH)
      DATA LUNPL /26/
      DATA DEPTH /5*1/
C-----------------------------------------------------------------------
      ISYM = IROUND (SYMBOL)
      IF ((ISYM.LE.0) .OR. (ISYM.GT.24)) ISYM = 1
      NGOOD = 0
      NNOFIT = 0
      IF (ABS(FACTOR).LT.0.1) FACTOR = 1
      DOLINE = FACTOR.LT.0.0
C                                       examine data to be plotted
      UMIN = 1.E10
      UMAX = -UMIN
      VMIN = UMIN
      VMAX = UMAX
      DMIN = UMIN
      DMAX = UMAX
      PMIN = UMIN
      PMAX = UMAX
      I2 = I1 + NN - 1
      DO 20 I = I1,I2
         DO 10 J = 1,NSTKS
            IF (PLPHAS(I,J).NE.FBLANK) THEN
               IF (RNGPIX(2).GT.RNGPIX(1)) THEN
                  IF (PLPHAS(I,J).LT.RNGPIX(1)) PLPHAS(I,J) =
     *               PLPHAS(I,J) + 360.0
                  IF (PLPHAS(I,J).GT.RNGPIX(2)) PLPHAS(I,J) =
     *               PLPHAS(I,J) - 360.0
                  END IF
               TEMP = PLPHAS(I,J)
               IF (TEMP.LT.0.0) TEMP = TEMP + 360.0
               DMIN = MIN (DMIN, PLPHAS(I,J))
               DMAX = MAX (DMAX, PLPHAS(I,J))
               PMIN = MIN (PMIN, TEMP)
               PMAX = MAX (PMAX, TEMP)
               END IF
 10         CONTINUE
         PLU(I) = ASIN (PLU(I))
         PLV(I) = ASIN (PLV(I))
         UMIN = MIN (UMIN, PLU(I))
         UMAX = MAX (UMAX, PLU(I))
         VMIN = MIN (VMIN, PLV(I))
         VMAX = MAX (VMAX, PLV(I))
 20      CONTINUE
      IF ((ABS(UMAX-UMIN).LT.0.00001) .AND. (ABS(VMAX-VMIN).LT.0.00001))
     *   THEN
         MSGTXT = 'GROUP SKIPPED - NO POSITION CHANGE'
         IRET = 0
         CALL MSGWRT (6)
         GO TO 999
         END IF
      VSIGN = (VMAX-VMIN).GT.(UMAX-UMIN)
      IF (VSIGN) THEN
         CAXIS = 'M'
      ELSE
         CAXIS = 'L'
         END IF
      XMIN = 1.E10
      XMAX = -XMIN
      DO 30 I = I1,I2
         XVAL(I) = SQRT (PLU(I)*PLU(I) + PLV(I)*PLV(I))
         IF (VSIGN) THEN
            IF (PLV(I).LT.0) XVAL(I) = -XVAL(I)
         ELSE
            IF (PLU(I).LT.0) XVAL(I) = -XVAL(I)
            END IF
         XMIN = MIN (XMIN, XVAL(I))
         XMAX = MAX (XMAX, XVAL(I))
 30      CONTINUE
      DX = (XMAX - XMIN) * 0.03
      XMAX = XMAX + DX
      XMIN = XMIN - DX
      XSCALE = RAD2DG
      XUNITS = 'Degrees'
      IF (XMAX-XMIN.LT.DG2RAD) THEN
         XSCALE = XSCALE*60.0
         XUNITS = 'Arc minutes'
         END IF
      IF (XMAX-XMIN.LT.DG2RAD/60.0) THEN
         XSCALE = XSCALE*60.0
         XUNITS = 'Arc seconds'
         END IF
      DO 35 I = I1,I2
         XVAL(I) = XVAL(I) * XSCALE
 35      CONTINUE
      XMIN = XMIN * XSCALE
      XMAX = XMAX * XSCALE
C                                       create plot file
      DOTV = XDOTV.GT.0.0
      IF (.NOT.DOTV) THEN
         VER = 0
         CALL MADDEX ('PL', DISKIN, CNOIN, CATUV, PLBUFF, .TRUE.,
     *      'WRIT', VER, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATING PLOT FILE'
            GO TO 980
            END IF
         END IF
      CALL ZPHFIL ('PL', DISKIN, CNOIN, VER, PFILE, IRET)
      IPSIZE = 0
      ITYPE = 53
      TVCHN = 1
      GRCHN = XGRCHN + 0.1
      TVCORN(1) = 0
      TVCORN(2) = 0
C                                       adjust adverbs for plot files
      IF (.NOT.DOTV) THEN
         IF (RNGPIX(2).LE.RNGPIX(1)) THEN
            PIXRNG(1) = DMIN
            PIXRNG(2) = DMAX
            END IF
         CALL TODHMS (PLTI(I1), ITT)
         CALL TODHMS (PLTI(I2), JTT)
         DO 39 J = 1,4
            XTIME(J) = ITT(J)
            XTIME(J+4) = JTT(J)
 39         CONTINUE
         CALL RFILL (50, 0.0, XANT)
         CALL RFILL (50, 0.0, XBASE)
         DO 40 J = 1,MANT
            XANT(J) = JANT(J)
 40         CONTINUE
         DO 41 J = 1,MBAS
            XBASE(J) = JBAS(J)
 41         CONTINUE
         END IF
      CALL GINIT (DISKIN, CNOIN, PFILE, IPSIZE, ITYPE, NPARM,
     *   XNAMEI, DOTV, TVCHN, GRCHN, TVCORN, CATUV, PLBUFF, LUNPL,
     *   FINDPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT PLOT WITH GINIT'
         GO TO 980
         END IF
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      IF (DOTV) THEN
         TRC(1) = WINDTV(3) - WINDTV(1)
         TRC(2) = WINDTV(4) - WINDTV(2)
         IF (DO3COL.LE.0.0) THEN
            CALL GCINIT (GPHTVG(4), 0, IRET)
            IF (IRET.NE.0) GO TO 960
            CALL GCINIT (GPHTVG(3), 0, IRET)
            IF (IRET.NE.0) GO TO 960
            END IF
         END IF
      IF (XYRATO.LT.0.01) XYRATO = 1.0
C                                       fool with location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      IF (RNGPIX(2).GT.RNGPIX(1)) THEN
         DMAX = RNGPIX(2)
         DMIN = RNGPIX(1)
      ELSE IF (PMAX-PMIN.LT.DMAX-DMIN) THEN
         DMAX = PMAX
         DMIN = PMIN
         DO 45 I = I1,I2
            DO 44 J = 1,NSTKS
               IF (PLPHAS(I,J).LT.0.0) PLPHAS(I,J) = PLPHAS(I,J) + 360.0
 44            CONTINUE
 45         CONTINUE
         END IF
      DX = (DMAX - DMIN) * 0.03
      DMAX = DMAX + DX
      DMIN = DMIN - DX
      TR = 1.1 * (DMAX - DMIN)
      IF (TR.LE.0.0) TR = 1.0
      TI = TR
      IF (XLTYPE.EQ.0.0) XLTYPE = 3.0
      LABEL = IROUND (XLTYPE)
      CALL METSCL (LABEL, TR, CPREF(2,LOCNUM), GOOD)
      XMULT(2) = TR / TI
      CPREF(1,LOCNUM) = ' '
      XMULT(1) = 1.0
      DO 50 I = 1,2
         IF (I.EQ.1) THEN
            TR = XMAX - XMIN
            XYOFF(I) = XMIN
         ELSE
            TR = DMAX - DMIN
            XYOFF(I) = DMIN
            END IF
         XYSCL(I) = (TRC(I) - BLC(I)) / TR
         RPLOC(I,LOCNUM) = BLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I) * XMULT(I)
         AXINC(I,LOCNUM) = TR * XMULT(I) / (TRC(I) - BLC(I))
 50      CONTINUE
      CTYP(1,LOCNUM) = XUNITS
      CTYP(2,LOCNUM) = 'Phase'
C                                       character borders
      CALL RFILL (4, 0.5, CHOUT)
      CALL CHNTIC (BLC, TRC, INP)
      INP = MAX (INP, 3)
      LTYPE = MOD (ABS (LABEL), 100)
      IF (LTYPE.EQ.2) CHOUT(1) = 2.5
      IF (LTYPE.GT.2) CHOUT(1) = INP + 4
      IF (LTYPE.GT.1) CHOUT(2) = 2.0
      IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = 3.333
      IF ((LABEL.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7))
     *   CHOUT(4) = CHOUT(4) + 1.333
C                                       Init for line drawing.
      CALL GINITL (BLC, TRC, XYRATO, CHOUT, DEPTH, PLBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT LINE DRAWING'
         GO TO 965
         END IF
      IF (.NOT.DOTV) THEN
         WRITE (MSGTXT,1050) VER
         CALL MSGWRT (2)
         END IF
C                                       Draw border
      CALL GLTYPE (1, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), BLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), BLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), TRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), TRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DX = 0.0
         DY = 1.833
C                                       The second line of the header
         CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
C                                       File name
         CALL H2CHR (18, KHIMNO, CATH(KHIMN), CHTMP)
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), CHTMP(13:18))
         CALL NAMEST (CHTMP, CATUV(KIIMS), TEXT(1:), INCHAR)
         CALL REFRMT (TEXT, ' ', INCHAR)
C                                       time range
         CALL TODHMS (PLTI(I1), ITT)
         CALL TODHMS (PLTI(I2), JTT)
         TEXT(INCHAR+1:) = '__TIME RANGE'
         INCHAR = INCHAR + 14
         IF (JTT(1).GT.0) THEN
            WRITE (TEXT(INCHAR:),1055) ITT, JTT
         ELSE
            WRITE (TEXT(INCHAR:),1056) ITT(2), ITT(3), ITT(4), JTT(2),
     *         JTT(3), JTT(4)
            END IF
         CALL REFRMT (TEXT, '_', INCHAR)
         WRITE (TEXT(INCHAR+1:),1057) ANGLE
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
C                                       refant, moving
         DY = 0.5
         CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
         WRITE (TEXT,1060) BIF, 'REFANT', (JANT(J), J = 1,MANT)
         WRITE (TEXT2,1061) ' ANT', (JBAS(J), J=1,MBAS)
         CALL REFRMT (TEXT, ' ', INCHAR)
         CALL REFRMT (TEXT2, ' ', J)
         TEXT(INCHAR+3:) = TEXT2(:J)
         INCHAR = INCHAR + 2 + J
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
C                                       Date/time/version
         IF ((LABEL.GT.0) .AND. (LTYPE.GT.1)) THEN
            DY = 0.5 + 2 * 1.333
C                                       the first line of the header
            CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 970
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (TEXT,1065) VER, ADATE, ATIME
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 970
            END IF
         END IF
C                                       Put on labels and ticks
      CALL CLAB1 (BLC, TRC, CHOUT, LABEL, XYRATO, .FALSE., PLBUFF,
     *   IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Loop
      ILITY = 4
      CALL GLTYPE (ILITY, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      COLR =  NSTKS - 1
      DO3C =  (DO3COL.GT.0.0) .AND. (COLR.GE.1)
      DO 200 J = 1,NSTKS
         IF (DO3C) THEN
            ILITY = 5 - J
            CALL GLTYPE (ILITY, PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 970
            END IF
C                                       stokes labels
         INCHAR = 2
         IF (PLSTOK(J)(2:).EQ.'_') INCHAR = 1
         CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
         DY = - 2.5
         DX = (1.5 + 3 * J)
         CALL GICHAR (1, INCHAR, 0, DX, DY, PLSTOK(J), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
         DO 120 I = I1,I2
            VALUE = PLPHAS(I,J)
            IF (VALUE.EQ.FBLANK) GO TO  120
            XY(1) = XYSCL(1) * (XVAL(I) - XYOFF(1)) + BLC(1)
            IF ((XY(1).LT.BLC(1)) .OR. (XY(1).GT.TRC(1))) THEN
               NNOFIT = NNOFIT + 1
               GO TO 120
               END IF
            XY(2) = XYSCL(2) * (VALUE - XYOFF(2)) + BLC(2)
            IF ((XY(2).LT.BLC(2)) .OR. (XY(2).GT.TRC(2))) THEN
               NNOFIT = NNOFIT + 1
               GO TO 120
               END IF
            NGOOD = NGOOD + 1
C                                       Mark point
            DY = 5.0 * ABS (FACTOR)
            DX = DY
            IF (XYRATO.GT.1.0) THEN
               DY = DY * XYRATO
            ELSE
               DX = DX / XYRATO
               END IF
            AX(1) = XY(1)
            AY(1) = XY(2)
            AX(2) = AX(1)
            AX(3) = AX(1)
            AX(4) = AX(1) - DX
            AX(5) = AX(1) + DX
            AY(2) = AY(1) + DY
            AY(3) = AY(1) - DY
            AY(4) = AY(1)
            AY(5) = AY(1)
            IF ((DO3COL.LE.0) .AND. (ILITY.NE.4)) THEN
               ILITY = 4
               CALL GLTYPE (ILITY, PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 970
               END IF
            CALL PNTPLT (ISYM, AX, AY, BLC, TRC, .FALSE., .FALSE.,
     *         PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 970
 120        CONTINUE
         IF (DOLINE) THEN
            BLNKD = .TRUE.
            DO 140 I = I1,I2
               VALUE = PLPHAS(I,J)
               IF (VALUE.EQ.FBLANK) GO TO 140
               XY(1) = XYSCL(1) * (XVAL(I) - XYOFF(1)) + BLC(1)
               IF ((XY(1).LT.BLC(1)) .OR. (XY(1).GT.TRC(1))) THEN
                  BLNKD = .TRUE.
                  GO TO 140
                  END IF
               XY(2) = XYSCL(2) * (VALUE - XYOFF(2)) + BLC(2)
               IF ((XY(2).LT.BLC(2)) .OR. (XY(2).GT.TRC(2))) THEN
                  BLNKD = .TRUE.
                  GO TO 140
                  END IF
C                                       Mark point
               IF (BLNKD) THEN
                  CALL GPOS (XY(1), XY(2), PLBUFF, IRET)
                  BLNKD = .FALSE.
               ELSE
                  CALL GVEC (XY(1), XY(2), PLBUFF, IRET)
                  END IF
               IF (IRET.NE.0) GO TO 970
 140           CONTINUE
            END IF
 200     CONTINUE
C                                       Done: finish plot
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      GPHPAG = DOIT
      CALL GFINIS (PLBUFF, IRET)
      IF (IRET.GT.0) GO TO 975
      IF (.NOT.DOTV) THEN
         CALL HIPLOT (DISKIN, CNOIN, VER, SCRBUF, IERR)
         END IF
      GO TO 999
C                                       ZPHFIL or GINIT failure.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      IF (.NOT.DOTV) THEN
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATUV, SCRBUF,
     *      VER, I)
         NCFILE = NCFILE - 1
         END IF
      GO TO 999
C
 965  CALL MSGWRT (8)
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      GPHPAG = DOIT
      CALL GFINIS (PLBUFF, I)
      IF (I.NE.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, SCRBUF, I)
            END IF
         GO TO 999
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, SCRBUF,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
      GO TO 999

 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PLOTPH ERROR',I4,' ON ',A)
 1050 FORMAT ('Plot file version',I4,'  created.')
 1055 FORMAT (I3,'/',2(I2.2,':'),I2.2,' - ',I3,'/',2(I2.2,':'),I2.2)
 1056 FORMAT (2(I2.2,':'),I2.2,' - ',2(I2.2,':'),I2.2)
 1057 FORMAT ('__scan'F7.1,' deg')
 1060 FORMAT ('IF',I4,'_ ',A,30I3)
 1061 FORMAT (A,30I3)
 1065 FORMAT ('Plot file version',I4,'__created ',A, A)
 1200 FORMAT ('PLOTPH:',I9,' points plotted')
 1202 FORMAT ('PLOTPH:',I9,' points did not fit')
 1960 FORMAT ('PLOTPH: ERROR DURING GRAPH FILE CREATION')
 1970 FORMAT ('PLOTPH: ERROR DURING GRAPHING. WILL TRY TO FINISH ',
     *   'PARTIAL GRAPH')
      END
      SUBROUTINE FITIT (I1, I2, NSTKS, XVAL, PLDATA, PEAKS, OKAY)
C-----------------------------------------------------------------------
C   FITIT tries to fit the main peak and both sidelobes of the amplitude
C   for up to 4 polarizations
C   Inputs:
C      I1       I        Start point in data array
C      I2       I        End point in data array
C      NSTKS    I        # Stokes
C      XVAL     R(*)     X coordinate
C      PLDATA   R(*,*)   Data values
C   Outputs:
C     PEAKS     R(*)     Values: max, pos x; center 2 sides; x pol
C     OKAY      L(4)     T -> got useful values (pol)
C-----------------------------------------------------------------------
      INCLUDE 'UVHPLT.INC'
      INTEGER   I1, I2, NSTKS
      REAL      XVAL(*), PLDATA(MAXPLT,*), PEAKS(2,3,4)
      LOGICAL   OKAY(4)
C
      INTEGER   IC, IM, IP(2), ISTKS, I, NSUM(4), J, IERR
      REAL      DMAX, PMAX(2), DMIN, FF(512,4), XX(512), FSUM(4), XL,
     *   XEPS, FS, FX, FXX(3), SXX(3)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Average data
      XEPS = 0.314159/(180.*3600.)
      XL = XVAL(I1)
      CALL FILL (4, 0, NSUM)
      CALL RFILL (4,  0.0, FSUM)
      J = 0
      DO 25 I = I1,I2
         IF (ABS(XVAL(I)-XL).LE.XEPS) THEN
            DO 10 ISTKS = 1,NSTKS
               IF (PLDATA(I,ISTKS).NE.FBLANK) THEN
                  FSUM(ISTKS) = FSUM(ISTKS) + PLDATA(I,ISTKS)
                  NSUM(ISTKS) = NSUM(ISTKS) + 1
                  END IF
 10            CONTINUE
         ELSE
            J = J + 1
            XX(J) = XL
            DO 15 ISTKS = 1,NSTKS
               IF (NSUM(ISTKS).GT.0) THEN
                  FF(J,ISTKS) = FSUM(ISTKS) / NSUM(ISTKS)
               ELSE
                  FF(J,ISTKS) = FBLANK
               END IF
 15         CONTINUE
            XL = XVAL(I)
            CALL FILL (4, 0, NSUM)
            CALL RFILL (4,  0.0, FSUM)
            DO 20 ISTKS = 1,NSTKS
               IF (PLDATA(I,ISTKS).NE.FBLANK) THEN
                  FSUM(ISTKS) = FSUM(ISTKS) + PLDATA(I,ISTKS)
                  NSUM(ISTKS) = NSUM(ISTKS) + 1
                  END IF
 20            CONTINUE
            END IF
 25      CONTINUE
      J = J + 1
      XX(J) = XL
      DO 30 ISTKS = 1,NSTKS
         IF (NSUM(ISTKS).GT.0) THEN
            FF(J,ISTKS) = FSUM(ISTKS) / NSUM(ISTKS)
         ELSE
            FF(J,ISTKS) = FBLANK
            END IF
 30      CONTINUE
C                                       Loop over Stokes
      DO 100 ISTKS = 1,NSTKS
         DMAX = -1.E10
         IC = 0
         DO 40 I = 1,J
            IF (FF(I,ISTKS).NE.FBLANK) THEN
               IF (FF(I,ISTKS).GT.DMAX) THEN
                  DMAX = FF(I,ISTKS)
                  IC = I
                  END IF
               END IF
 40         CONTINUE
         IF (IC.LE.0) GO TO 100
C                                       check left side
         DMIN = 1.E6
         IM = 0
         DO 45 I = IC,2,-1
            IF (FF(I,ISTKS).NE.FBLANK) THEN
               IF (FF(I,ISTKS).LT.DMIN) THEN
                  DMIN = FF(I,ISTKS)
                  IM = I
                  END IF
               IF ((FF(I-1,ISTKS).GT.FF(I,ISTKS)) .AND.
     *            (FF(I-1,ISTKS).NE.FBLANK)) GO TO 50
               END IF
 45         CONTINUE
 50      IF (IM.LE.2) GO TO 100
         IP(1) = 0
         PMAX(1) = DMIN
         DO 55 I = IM-1,1,-1
            IF (FF(I,ISTKS).NE.FBLANK) THEN
               IF (FF(I,ISTKS).GT.PMAX(1)) THEN
                  PMAX(1) = FF(I,ISTKS)
                  IP(1) = I
                  END IF
               END IF
 55         CONTINUE
         IF (IP(1).LE.1) GO TO 100
C                                       check right side
         DMIN = 1.E6
         IM = 0
         DO 60 I = IC,J-1
            IF (FF(I,ISTKS).NE.FBLANK) THEN
               IF (FF(I,ISTKS).LT.DMIN) THEN
                  DMIN = FF(I,ISTKS)
                  IM = I
                  END IF
               IF ((FF(I+1,ISTKS).GT.FF(I,ISTKS)) .AND.
     *            (FF(I+1,ISTKS).NE.FBLANK)) GO TO 65
               END IF
 60         CONTINUE
 65      IF (IM.LE.0) GO TO 100
         IF (IM.GE.i2-1) GO TO 100
         IP(2) = 0
         PMAX(2) = DMIN
         DO 70 I = IM+1,J
            IF (FF(I,ISTKS).NE.FBLANK) THEN
               IF (FF(I,ISTKS).GT.PMAX(2)) THEN
                  PMAX(2) = FF(I,ISTKS)
                  IP(2) = I
                  END IF
               END IF
 70         CONTINUE
         IF (IP(2).GE.J) GO TO 100
         I = IC
C                                       fit parabolas
         CALL SPFIT (FF(I-1,ISTKS), FS, FX, IERR)
         IF (IERR.NE.0) GO TO 100
         FXX(2) = FX + I
         SXX(2) = FS
         IF (FX.GT.0.0) THEN
            XL = XX(I) + FX * (XX(I+1) - XX(I))
         ELSE
            XL = XX(I) + FX * (XX(I) - XX(I-1))
            END IF
         PEAKS(1,1,ISTKS) = FS
         PEAKS(2,1,ISTKS) = XL
         I = IP(1)
         CALL SPFIT (FF(I-1,ISTKS), FS, FX, IERR)
         IF (IERR.NE.0) GO TO 100
         FXX(1) = FX + I
         SXX(1) = FS
         IF (FX.GT.0.0) THEN
            XL = XX(I) + FX * (XX(I+1) - XX(I))
         ELSE
            XL = XX(I) + FX * (XX(I) - XX(I-1))
            END IF
         PEAKS(1,2,ISTKS) = FS
         PEAKS(2,2,ISTKS) = XL
         I = IP(2)
         CALL SPFIT (FF(I-1,ISTKS), FS, FX, IERR)
         IF (IERR.NE.0) GO TO 100
         FXX(3) = FX + I
         SXX(3) = FS
         IF (FX.GT.0.0) THEN
            XL = XX(I) + FX * (XX(I+1) - XX(I))
         ELSE
            XL = XX(I) + FX * (XX(I) - XX(I-1))
            END IF
         PEAKS(1,3,ISTKS) = FS
         PEAKS(2,3,ISTKS) = XL
         OKAY(ISTKS) = .TRUE.
         WRITE (MSGTXT,1040) ISTKS, SXX
         CALL MSGWRT (4)
         WRITE (MSGTXT,1041) FXX
         CALL MSGWRT (4)
 100     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('Stokes',I2,'  Peaks=',3F8.3)
 1041 FORMAT ('at sample',7X,3F8.3)
      END
      SUBROUTINE SPFIT (AA, S, XX, IERR)
C-----------------------------------------------------------------------
C   Make a parabolic least-squares fit to a 3*3 matrix about the
C   point IX to determine strength and position of maximum.
C   Inputs:
C      A      R(16,16)   Data input array
C      IX     I(2)       Initial guess pixel position of max
C   Outputs:
C      DX     R(2)       Position of max relative to IX
C      S      R          Strength of max
C      IERR   I          0 => o.k., 1 => initial guess out of array
C-----------------------------------------------------------------------
      REAL       AA(3), XX, S
      INTEGER    IERR
C
      INTEGER    IX(2), I
      REAL       DX(2), A(16,16), X, Y, MAT(3,3), TEMP(6), MOMAR(6), D
      DATA MAT /0.55555, -0.33333, -0.33333,   -0.33333, 0.5, 0.0,
     *   -0.33333, 0.0, 0.5/
C-----------------------------------------------------------------------
      CALL RFILL (256, 0.0, A)
      DO 10 I = 1,3
         A(I,2) = AA(I)
         A(I,1) = AA(I) / 2.
         A(I,3) = AA(I) / 2.
 10      CONTINUE
      IX(1) = 2
      IX(2) = 2
C                                       calculate xy-moments :
C                                       00, 01, 02, 10, 11, 20
      X = IX(1)
      Y = IX(2)
      CALL MOM (A, X, Y, 3, 3, MOMAR, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       multiply matrix * even moms
C                                       yields const & quadratic terms
      TEMP(1) = MOMAR(1)
      TEMP(2) = MOMAR(3)
      TEMP(3) = MOMAR(6)
      CALL MATVMU (MAT, TEMP, TEMP(4), 3)
C                                       pick up linear & cross terms
      TEMP(1) = MOMAR(2) / 6.
      TEMP(2) = MOMAR(4) / 6.
      TEMP(3) = MOMAR(5) / 4.
C                                       offset of peak
      D = 4.* TEMP(5) * TEMP(6) - TEMP(3)**2
      IERR = 2
      IF (D.EQ.0.0) GO TO 999
      IERR = 0
      DX(1) = (TEMP(3)*TEMP(1) - 2.*TEMP(2)*TEMP(5)) / D
      DX(2) = (TEMP(3)*TEMP(2) - 2.*TEMP(1)*TEMP(6)) / D
      XX = DX(1)
C                                       value of peak
      S = TEMP(4) + DX(1)*(TEMP(2) + DX(1)*TEMP(6)
     *   + DX(2)*TEMP(3)) + DX(2)*(TEMP(1)+DX(2)*TEMP(5))
C
 999  RETURN
      END

      SUBROUTINE POSEL (DISKI, CNOI, DISKO, CNOO, VER, CATIN, CATOUT,
     *   LUNI, LUNO, ISOU, BUFFER, OBUFF, IRET)
C-----------------------------------------------------------------------
C! Copies one or all sources in a PO table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   copies one or all sources in a PO table
C   Inputs:
C      DISKI    I        Input volume number
C      CNOI     I        Input catalog number
C      DISKO    I        Output volume number
C      CNOO     I        Output catalog number
C      VER      I        Version to check/modify
C      CATIN    I(256)   Input catalog header
C      CATOUT   I(256)   Output catalog header
C      LUNI     I        LUN to use
C      LUNO     I        LUN to use
C      ISOU     I        0 -> copy all, else copy only ISOU and set to 1
C   Input/Output:
C      BUFFER   I(*)     Work buffer
C      OBUFF    I(*)     Work buffer
C   Output:
C      IRET     I        Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER   DISKI, CNOI, DISKO, CNOO, VER, CATIN(256), CATOUT(256),
     *   LUNI, LUNO, ISOU, BUFFER(*), OBUFF(*), IRET
C
      INCLUDE 'INCS:DPOV.INC'
      INTEGER   IPORNO, POKOLS(MAXPOC), PONUMV(MAXPOC), TABVER, OVER, I,
     *   NROWS, OPORNO, SOUID
      DOUBLE PRECISION TIME, DRA, DDEC, DDIST
      CHARACTER OBSDAT*8
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL POINI ('READ', BUFFER, DISKI, CNOI, VER, CATIN, LUNI,
     *   IPORNO, POKOLS, PONUMV, OBSDAT, TABVER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT PO TABLE'
         GO TO 980
         END IF
      NROWS = BUFFER(5)
C                                       does the 1 source exist?
C                                       avoid making an empty PO file
      IF (ISOU.GT.0) THEN
         DO 20 I = 1,NROWS
            IPORNO = I
            CALL TABPO ('READ', BUFFER, IPORNO, POKOLS, PONUMV, TIME,
     *         SOUID, DRA, DDEC, DDIST, IRET)
            IF (IRET.NE.0) THEN
               IF (IRET.LT.0) GO TO 20
               WRITE (MSGTXT,1000) IRET, 'READING INPUT PO TABLE'
               GO TO 980
               END IF
            IF (SOUID.EQ.ISOU) GO TO 50
 20         CONTINUE
         GO TO 910
         END IF
C                                       open new table
 50   OVER = VER
      CALL POINI ('WRIT', OBUFF, DISKO, CNOO, OVER, CATOUT, LUNO,
     *   OPORNO, POKOLS, PONUMV, OBSDAT, TABVER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT PO TABLE'
         GO TO 980
         END IF
      DO 100 I = 1,NROWS
         IPORNO = I
         CALL TABPO ('READ', BUFFER, IPORNO, POKOLS, PONUMV, TIME,
     *      SOUID, DRA, DDEC, DDIST, IRET)
         IF (IRET.NE.0) THEN
            IF (IRET.LT.0) GO TO 100
            WRITE (MSGTXT,1000) IRET, 'READING INPUT PO TABLE'
            GO TO 980
            END IF
         IF (ISOU.GT.0) THEN
            IF (SOUID.NE.ISOU) GO TO 100
            SOUID = 1
            END IF
         CALL TABPO ('WRIT', OBUFF, OPORNO, POKOLS, PONUMV, TIME,
     *      SOUID, DRA, DDEC, DDIST, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT PO TABLE'
            GO TO 980
            END IF
 100     CONTINUE
      CALL TABPO ('CLOS', OBUFF, OPORNO, POKOLS, PONUMV, TIME, SOUID,
     *   DRA, DDEC, DDIST, I)
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         WRITE (MSGTXT,1100) DISKI, CNOI, VER, DISKO, CNOO, OVER
         CALL MSGWRT (3)
         END IF
 910  CALL TABPO ('CLOS', BUFFER, IPORNO, POKOLS, PONUMV, TIME, SOUID,
     *   DRA, DDEC, DDIST, I)
      GO TO 999
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('POSEL ERROR',I4,' ON ',A)
 1100 FORMAT ('Copied PO file from vol/cno/vers',I3,I5,I4,' to',
     *   I3,I5,I4)
      END

      SUBROUTINE ZBKLD2 (OP, IERR)
C-----------------------------------------------------------------------
C! does BACKUP operation: load images from tape to directory
C# Z Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Host-dependent routine to process input tape for task BAKLD.
C   The input tape is presumed to have been produced by task BAKTP
C   executing on the same host/OS combination. Data format is the
C   hosts 'backup' utility (BACKUP on VMS, 'tar' on Unix).
C   Inputs:
C      OP    C*4   'SKIP' skips over a saveset.
C                  'PRNT' moves over a saveset, listing directory info.
C                  'LOAD' loads a saveset.
C   Output:
C      IERR  I     Error return
C   Unix version.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      INTEGER   ITRIM, JERR, LZDA0N, XLEN, ITEMP, CLEN
      LOGICAL   EOI
      CHARACTER COMMND*40, FNAME*50, GDA0N*4, ZDA0N*50, TEXT*128,
     *   TEMP*60, LLO*40, TY*2, DV*1, SN*3, PQ*1, BAKLDN*7,
     *   VQ*1, TEMP2*60, CCNO*3, CUSER*3, HTEMP*1, BACKSL*2
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DBKL.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       trick to get >= 1 \ thru compile
      BACKSL = '\\'
      IF ((OP.NE.'PRNT') .AND. (OP.NE.'SKIP') .AND. (OP.NE.'LOAD')) THEN
         WRITE (MSGTXT,1000) OP
         IERR = 99
         GO TO 990
         END IF
      IF (OP.EQ.'LOAD') THEN
         IVOL = KVOL4 + 0.01
         IF (IVOL.LE.0) THEN
            IVOL = 1
            WRITE (MSGTXT,1001) IVOL
            END IF
         END IF
C                                       translate DA0v
      CALL ZEHEX (IVOL, 1, HTEMP)
      GDA0N = 'DA0' // HTEMP
      XLEN = LEN (ZDA0N)
      CALL ZTRLOG (4, GDA0N, XLEN, ZDA0N, LZDA0N, JERR)
C                                       generate command file
      OPEN (ZLUN2, FILE=ZBKNAM, STATUS='OLD', ERR=900)
      REWIND ZLUN2
      CALL ZEHEX (NPOPS, 1, HTEMP)
      BAKLDN = '/BAKLD' // HTEMP
      TEMP = ZDA0N(1:LZDA0N) // BAKLDN // '.DIR'
      ITEMP = ITRIM (TEMP)
C                                       make directory on LOAD
      IF (OP.EQ.'LOAD') THEN
         TEXT = 'mkdir ' // TEMP
         JERR = ITEMP + 6
         WRITE (ZLUN2,1010,ERR=910) TEXT(1:JERR)
         END IF
C                                       change to directory
      TEXT = 'cd ' // TEMP
      JERR = ITEMP + 3
      WRITE (ZLUN2,1010,ERR=910) TEXT(1:JERR)
C                                       The 'dd' command itself
      TEXT = 'dd if=' // ZMT0N(1:LZMT0N) // ' ibs=60b obs=1b 2>' //
     *   ZDA00(1:LZDA00) // BAKLDN // '.DDE' // ' ' // BACKSL(1:1)
      JERR = ITRIM (TEXT)
      WRITE (ZLUN2,1010,ERR=910) TEXT(1:JERR)
      IF (OP.NE.'LOAD') THEN
         TEMP = BAKTXT
      ELSE
         TEMP = ' '
         END IF
      TEXT = ' | tar xvbf 1 - ' // TEMP(1:ITRIM(TEMP)) // ' 2>' //
     *   ZDA00(1:LZDA00) // BAKLDN // '.TARE'
      JERR = ITRIM (TEXT)
      WRITE (ZLUN2,1010,ERR=910) TEXT(1:JERR)
C-----------------------------------------------------------------------
C     NOTE#1: we assume that "dd" will copy to the tapemark at the end
C        of the saveset, and will leave tape positioned BEFORE the mark.
C        Therefore, we will skip a tapemark if we actually
C        got a file from the tar.
C     NOTE#2: if empty file, and dd hits tapemark, it leaves tape
C        positioned AFTER the mark, and so in this case we back over
C        the mark to leave tape positioned at EOI. It is certainly
C        conceivable that not all Unixes will display the same behavior
C        on these subtle points!
C   NO to the 2nd one - leave tape past the "empty" file.
C-----------------------------------------------------------------------
      LLO = ZDA00(1:LZDA00) // BAKLDN // '.LLO'
      TEXT = 'if test -f ' // BAKTXT(1:ITRIM(BAKTXT))
      JERR = ITRIM (TEXT)
      WRITE (ZLUN2,1010,ERR=910) TEXT(1:JERR)
      WRITE (ZLUN2,1010,ERR=910) 'then'
      TEXT = '   mt -f ' // ZMT0N(1:LZMT0N) // ' fsf'
      JERR = ITRIM (TEXT)
      WRITE (ZLUN2,1010,ERR=910) TEXT(1:JERR)
      IF (OP.EQ.'LOAD') THEN
         TEXT = '   ls -1 ?????????.???' // BACKSL(1:1) // '; 1>' //
     *      LLO(1:ITRIM(LLO))
         JERR = ITRIM (TEXT)
         WRITE (ZLUN2,1010,ERR=910) TEXT(1:JERR)
         END IF
C                                       leave tape past file makr
C      WRITE (ZLUN2,1010,ERR=910) 'else'
C      TEXT = '   mt -f ' // ZMT0N(1:LZMT0N) // ' bsf'
C      JERR = ITRIM (TEXT)
C      WRITE (ZLUN2,1010,ERR=910) TEXT(1:JERR)
      WRITE (ZLUN2,1010,ERR=910) 'fi'
      CLOSE (ZLUN2)
C                                       execute the command file
      COMMND = ZBKNAM
      CLEN = ITRIM (COMMND)
      CALL ZSHCMD (CLEN, COMMND, 8, 'TASK_OUT', IERR)
C                                       read special catalog file:
      FNAME = ZDA0N(1:LZDA0N) // BAKLDN // '.DIR/' // BAKTXT
      OPEN (ZLUN1, FILE=FNAME, STATUS='OLD', ERR=20)
      REWIND ZLUN1
      READ  (ZLUN1,1010,ERR=20) BAKREC
      READ  (ZLUN1,1010,ERR=20) BAKVER
      CLOSE (ZLUN1)
      EOI = .FALSE.
      GO TO 30
C                                       Fortran error
 20   EOI = .TRUE.
      GO TO 100
C                                       log the file read:
 30   WRITE (MSGTXT,1030) OP, BAKREC
      CALL MSGWRT (6)
C                                       LOAD only
      IF (OP.EQ.'LOAD') THEN
C                                       Begin file rename stuff:
C                                       execute mach-indep code:
         CALL BAKLDS ('CREA', IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Rename data files:
         OPEN (UNIT=ZLUN1, FILE=LLO, STATUS='OLD',ERR=920)
         REWIND ZLUN1
         OPEN (UNIT=ZLUN2, FILE=ZBKNAM, STATUS='UNKNOWN',ERR=900)
         REWIND ZLUN2
         CALL ZEHEX (CNO, 3, CCNO)
         CALL ZEHEX (USER, 3, CUSER)
C                                       delete old files if any
         TEXT = 'rm ' // ZDA0N(1:LZDA0N) // '/???' // CCNO // '????' //
     *      CUSER // '?'
         JERR = ITRIM (TEXT)
         WRITE (ZLUN2,1010,ERR=910) TEXT(1:JERR)
C                                       move to BAKLD directory
         TEXT = 'cd ' // ZDA0N(1:LZDA0N) // BAKLDN // '.DIR'
         JERR = ITRIM (TEXT)
         WRITE (ZLUN2,1010,ERR=910) TEXT(1:JERR)
C                                       read file names loop
 50      READ (ZLUN1,1010,END=60,ERR=930) TEMP
            READ (TEMP,1050) TY, DV, SN, PQ, VQ
            IF ((PQ.NE.'.') .OR. (VQ.NE.';')) THEN
               MSGTXT = 'ZBKLD2: BAD FILE NAME ''' // TEMP(1:14) // ''''
               IERR = 2
               GO TO 990
               END IF
            TEMP2 = TEMP(1:12)
C                                       escape the ';' in the filename:
            TEMP2(13:13) = BACKSL(1:1)
            TEMP2(14:15) = TEMP(13:14)
            TEMP = TEMP2
            TEXT = 'ln ' // TEMP(1:15) // ' ../' // TY // DV // CCNO //
     *         SN // '.' // CUSER // BACKSL(1:1) // ';'
            JERR = ITRIM (TEXT)
            WRITE (ZLUN2,1010,ERR=910) TEXT(1:JERR)
            GO TO 50
 60      CLOSE (UNIT=ZLUN1)
         TEXT = 'rm -r ' // ZDA0N(1:LZDA0N) // BAKLDN // '.DIR'
         JERR = ITRIM (TEXT)
         WRITE (ZLUN2,1010,ERR=910) TEXT(1:JERR)
         CLOSE (UNIT=ZLUN2)
         COMMND = ZBKNAM
         CLEN = ITRIM (COMMND)
         CALL ZSHCMD (CLEN, COMMND, 8, 'TASK_OUT', IERR)
C                                       do some more mach-indep code:
         CALL BAKLDS ('UPDT', IERR)
         GO TO 999
         END IF
C-----------------------------------------------------------------------
C                                       cleanup private directory:
 100  IF (IVOL.LE.0) THEN
         IF (EOI) GO TO 110
         COMMND = 'rm ' // ZDA0N(1:LZDA0N) // BAKLDN // '.DIR/*'
      ELSE
         COMMND = 'rm -r ' // ZDA0N(1:LZDA0N) // BAKLDN // '.DIR'
         END IF
      IF ((.NOT.EOI) .OR. (IVOL.GT.0)) THEN
         CLEN = ITRIM (COMMND)
         CALL ZSHCMD (CLEN, COMMND, 8, 'TASK_OUT', IERR)
         END IF
C                                       baby catalog didn't exist:
 110  IF (.NOT.EOI) GO TO 999
         IF (OP.NE.'SKIP') THEN
            MSGTXT = 'Not a BAKTP saveset - is tape positioned'
     *         // ' correctly?'
            IERR = 999
         ELSE
            MSGTXT = 'Skipped a file which was not a BAKTP saveset'
            END IF
         GO TO 990
C                                       Error: open command file
 900  MSGTXT = 'ZBKLD2: UNABLE TO OPEN ' // ZBKNAM
      IERR = 1
      GO TO 990
C                                       Error: write command file
 910  MSGTXT = 'ZBKLD2: UNABLE TO WRITE ' // ZBKNAM
      IERR = 1
      CALL MSGWRT (8)
      MSGTXT = TEXT
      GO TO 990
C                                       Error: open command file
 920  MSGTXT = 'ZBKLD2: UNABLE TO OPEN ' // LLO
      IERR = 1
      GO TO 990
C                                       Error: read command file
 930  MSGTXT = 'ZBKLD2: UNABLE TO READ ' // LLO
      IERR = 1
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZBKLD2: BAD OPCODE = ',A4,'; FATAL ERROR.')
 1001 FORMAT ('File(s) will be loaded to default OUTDISK; using',I2)
 1010 FORMAT (A)
 1030 FORMAT (A4,1X,A58)
 1050 FORMAT (A2,A1,3X,A3,A1,3X,A1)
      END

      SUBROUTINE BUFPUT (APCORE, NIO, IPARM, IREC, OREC, IDATA, BUFF,
     *   TEMPBF)
C-----------------------------------------------------------------------
C! Places a buffer of visibilities in AP after unpacking data, if needed
C# AP-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Determines whether UV data must be un-compressed before putting
C   data into AP.
C   Input/Output buffer is assumed to be large enough to hold expanded
C   Visibility
C    Inputs:
C     NIO    I        Number of visiblilities to expand
C     IPARM  I        Input Number of random parameters in visibility
C     IREC   I        Input  Length of compressed vis (1 reals per vis)
C     OREC   I        Output Length of un-comp.   vis (3 reals per vis)
C     IDATA  I        Index into AP array were Visibilities are placed
C     BUFF     R(*)   Compressed/Uncompressed array of visibilities
C    Output
C     TEMPBF   R(*)   Scratch array, large enough to hold expanded vis
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   NIO, IPARM, IREC, OREC, IDATA
      REAL      BUFF(*), TEMPBF(*)
C
      INTEGER   WRK
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSCD.INC'
C-----------------------------------------------------------------------
C                                       Calc Expanded Vis length
      WRK = NIO * OREC
C                                       IF compressed,
      IF (SCRCAT(KINAX).EQ.1) THEN
C                                       Copy compressed vis to temp
         CALL COPY (NIO*IREC, BUFF(1), TEMPBF(1))
C                                       Expand all points in buffer
         CALL BUFXPN (NIO, IPARM, IREC, OREC, TEMPBF(1))
C                                       Move expanded Vis into AP
         CALL QPUT (APCORE, TEMPBF(1), IDATA, WRK, 2)
C                                       Move Vis into AP
      ELSE
         CALL QPUT (APCORE, BUFF(1), IDATA, WRK, 2)
         END IF
C                                       Wait for AP to finish
      CALL QWD
C
      RETURN
      END

      SUBROUTINE IMTAB (OPCODE, BUFFER, NUMBND, IERR)
C-----------------------------------------------------------------------
C! I/O to interferometer model tables (following init. by IMINI)
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to interferometer model tables. Usually used after setup by
C   IMINI.
C   Inputs:
C      OPCODE   C*4        Operation code:
C                          'READ' = read entry from table.
C                          'WRIT' = write entry in table.
C                          'CLOS' = close file, flush on write
C      BUFFER   I(512)     I/O buffer and related storage, also defines
C                          file if open. Should have been returned by
C                          IMINI.
C      NUMBND   I          # band's (IF's) in data
C   Inputs via common:
C      IIMRNO   I          Next scan number to read or write.
C      IMKOLS   I(MAXIMC)  The column pointer array in order:
C                          TIME, TIME INTERVAL, SOURCE ID, ANTENNA NO.,
C                          ARRAY, FREQID, I.FAR.ROT, FREQ. VAR,
C                          PDELAY1, GDELAY1, PRATE1, GRATE1, DISP1,
C                          DDISP1,
C                          the following are only present if NOPOLZ = 2
C                          PDELAY2, GDELAY2, PRATE2, GRATE2, DISP2,
C                          DDISP2,
C      IMNUMV   I(MAXIMC)  Element count in each column.
C      NOPOLZ   I          # polzns in table
C      NPOLY    I          Order of polynomial for geometric model
C   Input/output: (written to or read from model file)
C      TIME     D          Time of centre of interval since 0hr on
C                          reference day (days)
C      TINT     R          Interval over which calibration constants
C                          apply (days)
C      ISRC     I          Source ID number
C      NOSTA    I          Station number
C      IARRAY   I          Array number
C      IFQID    I          Freq ID number
C      IFR      R          Ionospheric Faraday Rotation (Rad/m**2)
C      FREQVR   R(MAXIF)   Time variable freq. offset from ref + FR
C                          value + SO value
C      PDELA1   D(MAXIF,MAXPOL)
C                          Total phase delay (seconds) at ref. time
C      GDELA1   D(MAXPOL)  Total group delay (seconds) at ref. time
C      PRATE1   D(MAXIF,MAXPOL)
C                          Phase delay rate (sec/sec)
C      GRATE1   D(MAXPOL)  Group delay rate (sec/sec)
C      DISP1    R          Dispersive portion of delay for polzn 1
C                          (seconds/m^2 - scales as lambda^2)
C      DDISP1   R          Time derivative of DISP1 (sec/sec/m^2)
C    The follwing are only used if NOPOLZ = 2.
C      PDELA2   D(MAXIF,MAXPOL)
C                          Total phase delay (seconds) at ref. time
C      GDELA2   D(MAXPOL)  Total group delay (seconds) at ref. time
C      PRATE2   D(MAXIF,MAXPOL)
C                          Phase delay rate (sec/sec)
C      GRATE2   D(MAXPOL)  Group delay rate (sec/sec)
C      DISP2    R          Dispersive portion of delay for polzn 1
C                          (seconds/m^2 - scaoles as lambda^2)
C      DDISP2   R          Time derivative of DISP1 (sec/sec/m^2)
C   Output:
C      IIMRNO   I          Next row number.
C      IERR     I          Error code, 0=>OK else TABIO error.
C                          Note: -1=> read but record deselected.
C   Usage NOTE: use the include 'DIMV.INC' for the declarations in
C   IMINI and IMTAB.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DGLB.INC'
      CHARACTER OPCODE*4
      INTEGER   BUFFER(*), IERR, NUMBND
C
      LOGICAL   DOREAD, DOCLOS
      INTEGER   I, K, IOFF
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DIMV.INC'
      INTEGER   RECI(MAXREC)
      REAL      RECORD(MAXREC)
      HOLLERITH RECH(MAXREC)
      DOUBLE PRECISION RECD(MAXRCD)
      EQUIVALENCE (RECD, RECORD, RECI, RECH)
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
      DOCLOS = OPCODE.EQ.'CLOS'
C                                       Branch for CLOS
      IF (DOCLOS) GO TO 800
C                                       If write fill RECORD
      IF (.NOT.DOREAD) THEN
C                                       Time
         RECD(IMKOLS(KTIM)) = TIME
C                                       Interval
         RECORD(IMKOLS(KINT)) = TINT
C                                       Source ID
         RECI(IMKOLS(KSOU)) = ISRC
C                                       Antenna number
         RECI(IMKOLS(KANO)) = NOSTA
C                                       Array number
         RECI(IMKOLS(KARR)) = IARRAY
C                                       Freqid number
         RECI(IMKOLS(KFRE)) = IFQID
C                                       IFR
         RECORD(IMKOLS(KIFR)) = IFR
C                                       Dispersive delay
         RECORD(IMKOLS(KDSP1)) = DISP1
C                                       Dispersive delay rate
         RECORD(IMKOLS(KDDT1)) = DDISP1
C                                       2nd polzn
         IF (NOPOLZ.EQ.2) THEN
C                                       Dispersive delay
            RECORD(IMKOLS(KDSP2)) = DISP2
C                                       Dispersive delay rate
            RECORD(IMKOLS(KDDT2)) = DDISP2
            END IF
C                                       Variables that vary with
C                                       NPOLY
         DO 100 I = 1, NPOLY
C                                       Group delay
            RECD(IMKOLS(KGDL1)+I-1) = GDELA1(I)
C                                       Group delay rate
            RECD(IMKOLS(KGRT1)+I-1) = GRATE1(I)
C                                       2nd polzn
            IF (NOPOLZ.EQ.2) THEN
C                                       Group delay
               RECD(IMKOLS(KGDL2)+I-1) = GDELA2(I)
C                                       Group delay rate
               RECD(IMKOLS(KGRT2)+I-1) = GRATE2(I)
               END IF
 100        CONTINUE
C                                       Variables that vary over IF's
         DO 150 I = 1, NUMBND
C                                       Time variable freq offset
            RECORD(IMKOLS(KFVR)+I-1) = FREQVR(I)
 150        CONTINUE
C                                       Variables that vary with IF and
C                                       NPOLY
         DO 170 I = 1, NUMBND
            IOFF = (I-1) * NPOLY
            DO 160 K = 1, NPOLY
C                                       Phase delay
               RECD(IMKOLS(KPDL1)+IOFF+K-1) = PDELA1(I,K)
C                                       Phase delay rate
               RECD(IMKOLS(KPRT1)+IOFF+K-1) = PRATE1(I,K)
C                                       2nd polzn
               IF (NOPOLZ.EQ.2) THEN
C                                       Phase delay
                  RECD(IMKOLS(KPDL2)+IOFF+K-1) = PDELA2(I,K)
C                                       Phase delay rate
                  RECD(IMKOLS(KPRT2)+IOFF+K-1) = PRATE2(I,K)
                  END IF
 160           CONTINUE
 170        CONTINUE
         END IF
C                                       Process record.
 50   CALL TABIO (OPCODE, 0, IIMRNO, RECORD, BUFFER, IERR)
      IIMRNO = IIMRNO + 1
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABIO', 'IMTAB', IERR)
         GO TO 990
         END IF
      IF (IERR.LT.0) GO TO 50
C                                       If READ pick data from RECORD.
      IF (DOREAD) THEN
C                                       Time
         TIME = RECD(IMKOLS(KTIM))
C                                       Interval
         TINT = RECORD(IMKOLS(KINT))
C                                       Source ID
         ISRC = RECI(IMKOLS(KSOU))
C                                       Antenna number
         NOSTA = RECI(IMKOLS(KANO))
C                                       Array number
         IARRAY = RECI(IMKOLS(KARR))
C                                       Freqid number
         IFQID = RECI(IMKOLS(KFRE))
C                                       IFR
         IFR = RECORD(IMKOLS(KIFR))
C                                       Dispersive delay
         DISP1 = RECORD(IMKOLS(KDSP1))
C                                       Dispersive delay rate
         DDISP1 = RECORD(IMKOLS(KDDT1))
C                                       2nd polzn
         IF (NOPOLZ.EQ.2) THEN
C                                       Dispersive delay
            DISP2 = RECORD(IMKOLS(KDSP2))
C                                       Dispersive delay rate
            DDISP2 = RECORD(IMKOLS(KDDT2))
            END IF
C                                       Variables that vary with
C                                       NPOLY
         DO 200 I = 1, NPOLY
C                                       Group delay
            GDELA1(I) = RECD(IMKOLS(KGDL1)+I-1)
C                                       Group delay rate
            GRATE1(I) = RECD(IMKOLS(KGRT1)+I-1)
C                                       2nd polzn
            IF (NOPOLZ.EQ.2) THEN
C                                       Group delay
               GDELA2(I) = RECD(IMKOLS(KGDL2)+I-1)
C                                       Group delay rate
               GRATE2(I) = RECD(IMKOLS(KGRT2)+I-1)
               END IF
 200        CONTINUE
C                                       Variables that vary over IF's
         DO 250 I = 1, NUMBND
C                                       Time variable freq offset
            FREQVR(I) = RECORD(IMKOLS(KFVR)+I-1)
 250        CONTINUE
C                                       Variables that vary with IF and
C                                       NPOLY
         DO 270 I = 1, NUMBND
            IOFF = (I-1) * NPOLY
            DO 260 K = 1, NPOLY
C                                       Phase delay
               PDELA1(I,K) = RECD(IMKOLS(KPDL1)+IOFF+K-1)
C                                       Phase delay rate
               PRATE1(I,K) = RECD(IMKOLS(KPRT1)+IOFF+K-1)
C                                       2nd polzn
               IF (NOPOLZ.EQ.2) THEN
C                                       Phase delay
                  PDELA2(I,K) = RECD(IMKOLS(KPDL2)+IOFF+K-1)
C                                       Phase delay rate
                  PRATE2(I,K) = RECD(IMKOLS(KPRT2)+IOFF+K-1)
                  END IF
 260           CONTINUE
 270        CONTINUE
         END IF
         GO TO 999
C                                       Close
 800  CALL TABIO ('CLOS', 0, IIMRNO, RECORD, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'IMTAB', IERR)
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1800) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1800 FORMAT ('IMTAB: TABIO ERROR',I5)
      END

      SUBROUTINE APLPBI (IFIELD, IN, VAL, OUT1, OUT2, IERR)
C-----------------------------------------------------------------------
C! *TESS routine to apply a taper to an image. VLA only!
C# Map-util VLA
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2000, 2003, 2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   APLPBI multiplies IN by VAL into OUT1, applying a PB taper,
C   while applying a PB taper^2 to VAL and putting in OUT2
C   Programmer =  R. Braun                               November 1987
C   BEAMTP=2 uses PBCALC with LAMBDA in BMSIZE,
C   BEAMTP=1 uses Gaussian with FWHM in BMSIZE
C-----------------------------------------------------------------------
      INTEGER   IN, OUT1, OUT2, IFIELD
      REAL      VAL, XCEN, YCEN
      REAL      RCONSX, RCONSY, YSQ, RADSQ, TAPER
      INTEGER   AKOPEN, AKCESS, AKCLOS
      DOUBLE PRECISION ANGLE, LAMBDA
      LOGICAL   OUTSID
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IERR = 0
C
      IF ((BMSIZE(IFIELD).GT.0.0) .AND. (BEAMTP(IFIELD).GT.0)) THEN
         IF (BEAMTP(IFIELD).EQ.1) THEN
            RCONSX = 2.772588722 * (CELLX/BMSIZE(IFIELD))**2
            RCONSY = 2.772588722 * (CELLY/BMSIZE(IFIELD))**2
         ELSE
            LAMBDA = BMSIZE(IFIELD)
            RCONSX = (CELLX/3600.)**2
            RCONSY = (CELLY/3600.)**2
            END IF
      ELSE
         RCONSX = 0.0
         RCONSY = 0.0
         END IF
C
      XCEN = RCENX(IFIELD) - BLC(1) + XBEG
      YCEN = RCENY(IFIELD) - BLC(2) + YBEG
C
      IF (AKOPEN (IN,1,'READ',BUFFR1).NE.0) GO TO 990
      IF (AKOPEN (OUT1,2,'WRIT',BUFFR2).NE.0) GO TO 990
      IF (AKOPEN (OUT2,3,'WRIT',BUFFR3).NE.0) GO TO 990
C                                        Loop thru map
      DO 30 IY = 1,HNY
C
         IF (AKCESS(OUT1,BUFFR2).NE.0) GO TO 990
         IF (AKCESS(OUT2,BUFFR3).NE.0) GO TO 990
C                                        Find new map estimate
         CALL RFILL (HNX, FBLANK, BUFFR2(BIND(2)))
         CALL RFILL (HNX, FBLANK, BUFFR3(BIND(3)))
         IF ((IY.GE.YBEG) .AND. (IY.LE.YEND)) THEN
            IF (AKCESS(IN,BUFFR1).NE.0)  GO TO 990
            I1 = BIND(1)
            I2 = BIND(2) + XBEG - 1
            I3 = BIND(3) + XBEG - 1
            YSQ = RCONSY*(REAL(IY)-YCEN)**2
            IF (RCONSY.EQ.0.) THEN
               DO 20 IX = XBEG,XEND
                  IF (BUFFR1(I1).NE.FBLANK) THEN
                     BUFFR2(I2) = BUFFR1(I1) * VAL
                     BUFFR3(I3) = VAL
                     END IF
                  I1 = I1 + 1
                  I2 = I2 + 1
                  I3 = I3 + 1
 20               CONTINUE
            ELSE IF (BEAMTP(IFIELD).EQ.1) THEN
               DO 21 IX = XBEG,XEND
                  RADSQ = YSQ + RCONSX*(REAL(IX)-XCEN)**2
                  TAPER = EXP(-RADSQ)
                  IF ((TAPER.GT.PBPARM(1)) .AND.
     *               (BUFFR1(I1).NE.FBLANK)) THEN
                     BUFFR2(I2) = TAPER * BUFFR1(I1) * VAL
                     BUFFR3(I3) = TAPER * TAPER * VAL
                     END IF
                  I1 = I1 + 1
                  I2 = I2 + 1
                  I3 = I3 + 1
 21               CONTINUE
            ELSE
               DO 25 IX = XBEG,XEND
                  IF (BUFFR1(I1).NE.FBLANK) THEN
                     RADSQ = YSQ + RCONSX*(REAL(IX)-XCEN)**2
                     ANGLE = SQRT (RADSQ)
                     CALL PBCALC (ANGLE, LAMBDA, ANAME, PBPARM(2),
     *                  TAPER, OUTSID)
                     OUTSID = OUTSID .OR. (TAPER.LE.PBPARM(1))
                     IF (.NOT.OUTSID) THEN
                        BUFFR2(I2) = TAPER * BUFFR1(I1) * VAL
                        BUFFR3(I3) = TAPER * TAPER * VAL
                        END IF
                     END IF
                  I1 = I1 + 1
                  I2 = I2 + 1
                  I3 = I3 + 1
 25               CONTINUE
               END IF
            END IF
 30      CONTINUE
C
      IF (AKCLOS (IN,BUFFR1).NE.0) GO TO 990
      IF (AKCLOS (OUT1,BUFFR2).NE.0) GO TO 990
      IF (AKCLOS (OUT2,BUFFR3).NE.0) GO TO 990
      GO TO 999
C
 990  WRITE (MSGTXT,1990)
      CALL MSGWRT (8)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1990 FORMAT ('ERROR FROM APLPBI')
      END

      SUBROUTINE ZTPWAD (FCB, IERR)
C-----------------------------------------------------------------------
C! "wait" for IO operation to complete on pseudo-tape disk file (ZTPMID)
C# Tape FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Wait until an I/O operation is complete for sequential pseudo-tape
C   disk files and return its status.
C   Inputs:
C      FCB    I(*)   File control block for opened pseudo-tape disk
C                    file involved
C   Output:
C      IERR   I      Error return code: 0 => no error
C                       3 => I/O error
C                       4 => end of file
C                       7 => wait service error
C   NOTE: EOFERR value will vary between systems.  If synchronous I/O,
C   no need to wait.
C   Generic version (stubbed).
C-----------------------------------------------------------------------
      INTEGER   FCB(*), IERR
C
      INTEGER   JERR, EOFERR
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
C                                       System dependent EOFERR value:
C                                       VMS =  36
C                                       COS => doesn't work this way
C                                       UNIX (Alliant, SUN) = -1
C                                       UNIX (Convex) = 134
      DATA EOFERR /-1/
C-----------------------------------------------------------------------
C                                       Return wait service error until
C                                       this routine is developed.
      IERR = 7
      WRITE (MSGTXT,1000)
      CALL MSGWRT (8)
      IF (IERR.NE.0) GO TO 999
C                                       Generic code:
      IERR = 0
C                                       System error code from the file
C                                       control block.
      JERR = FCB(1+FCBERR)
C                                       I/O error?
      IF (JERR.NE.0) THEN
         IERR = 3
C                                       End of file?
         IF ((JERR.LT.0). OR. (JERR.EQ.EOFERR)) IERR = 4
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZTPWAD: THIS ROUTINE REQUIRES LOCAL DEVELOPMENT')
      END

      SUBROUTINE ZPRI2 (OP, SYSERR, IERR)
C-----------------------------------------------------------------------
C! raise or lower the process priority
C# Z2 System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZPRIO changes the current program's machine priority between that of
C   batch programs and that of interactive programs.
C   Inputs:
C      OP    C*4    'UPPP' to inter., 'DOWN' to batch
C   Outputs:
C      SYSERR   I     System-level error code
C      IERR     I     Error code: 0 => ok
C                        2 => illegal request
C                        3 => other failures
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   SYSERR, IERR
C
      INTEGER   JERR, SYS$SETPRI, OLDPRI, PRIO
C-----------------------------------------------------------------------
      IF (OP.EQ.'UPPP') THEN
         PRIO = 4
      ELSE
         PRIO = 3
         END IF
      JERR = SYS$SETPRI ( , , %VAL(PRIO), OLDPRI)
      IF (JERR.EQ.1) THEN
         IERR = 0
         SYSERR = 0
      ELSE
         IERR = 3
         SYSERR = JERR
         END IF
C
 999  RETURN
      END

      SUBROUTINE CONDRW (IMLUN, IMFIND, IBLUN, IBFIND, XMULT, BLC, TRC,
     *   LEVS, DOCOLR, BBLC, BTRC, RGBLEV, IGBLK, IERR)
C-----------------------------------------------------------------------
C! writes contour plot to a plot file
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2002-2004, 2006, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CONDRW will write commands to a plot file for the execution of
C   a contour plot.
C   Inputs:
C      IMLUN    I         logical unit number for the contour map file
C      IMFIND   I         FTAB index for open contour map file.
C      IBLUN    I         logical unit number of background gray image
C      IBFIND   I         FTAB index of open background gray image
C      IGBLK    I(256)    I/O block for graph file.
C      XMULT    R         Contour interval (image units)
C      BLC      R(7)      Bottom left corner
C      TRC      R(7)      Top right corner
C      LEVS     R(30)     Selected contour intervals in increasing order
C                         (any decrease terminates the list)
C      DOCOLR   I         0 no color, 1, use existing color, 2 use
C                         RGBLEV
C      BBLC     I(2)      BLC of blanked area
C      BTRC     I(2)      TRC of blanked area
C      RGBLEV   R(3,30)   RGB colors when level i not blacked
C   Common:
C      CATBLK   I(256)  map header.
C      CNTRBU   R(8192) buffers
C   Output:
C      IERR     I   error code. 0 = ok.
C-----------------------------------------------------------------------
      INTEGER   IMLUN, IMFIND, IBLUN, IBFIND, IGBLK(256), DOCOLR,
     *   BBLC(2), BTRC(2), IERR
      REAL      XMULT, BLC(7), TRC(7), LEVS(*), RGBLEV(3,*)
C
      REAL      VAL(3), XPOS(3), YPOS(3), TEMP, VC, VL, VM, VS, XA, XB,
     *   XL, XLAST, XM, XS, YA, YB, YL, YLAST, YM, YS, DELTAX, DELTAY,
     *   TLEV, XLEV, ALEVS(30)
      INTEGER   IPERM(3,6), IBLCX, IBLCY, IBLCY1, ICOL, II, INDEX,
     *   INLEVS, INPIXS, IPLUS, IPOS, IROW, ISKIP, ITRCX, ITRCXM,
     *   ITRCY, ITRI, I, MININT, LOCINT, IROUND, BPOS, ISLEV, JJ, BCUT,
     *   BVAL, BXOFF, BXSIZ, LASTC
      LOGICAL   DOBACK
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DCNT.INC'
      INCLUDE 'INCS:DGPH.INC'
      DATA IPERM /1,3,2, 3,2,1, 3,1,2, 2,1,3, 1,2,3, 2,3,1/
C-----------------------------------------------------------------------
      DOBACK = (IBLUN.GT.0) .AND. (IBFIND.GT.0) .AND. (DOCOLR.LE.0)
      IF (DOBACK) BCUT = 3.0 * (GPHCUT * GPHTHI + (1.0-GPHCUT) * GPHTLO)
      ISKIP = 2
      XLAST = -1000.
      YLAST = -1000.
      TEMP = MAX (TRC(1)-BLC(1), TRC(2)-BLC(2))
      TEMP = 10 - 3 * LOG10 (TEMP)
      LOCINT = IROUND (TEMP)
      IF (LOCINT.LT.2) LOCINT = 2
      IBLCY = BLC(2) + .5
      ITRCY = TRC(2) + .5
      ITRCX = TRC(1) + .5
      IBLCX = BLC(1) + .5
      INPIXS = ITRCX - IBLCX + 1
      BXSIZ = BTRC(1) - BBLC(1) + 1
      BXOFF = BBLC(1) - IBLCX
      LASTC = 0
C                                       magic parms for dashed lines
      XLEV = 256.0 / INPIXS
      TLEV = 256.0 / (ITRCY - IBLCY + 1.0)
      ISLEV = SQRT (1.0 / (XLEV * TLEV)) + 0.1
      IF (ISLEV.LT.1) ISLEV = 1
      IF (XLEV.LT.1.0) XLEV = (SQRT (XLEV) + 3.0*XLEV) / 4.0
C                                       Determine number of levels.
C                                       and convert to absolute levels.
      TEMP = LEVS(1)
      ALEVS(1) = XMULT * LEVS(1)
      DO 45 INLEVS = 2,30
         IF (TEMP.GE.LEVS(INLEVS)) GO TO 50
         TEMP = LEVS(INLEVS)
         ALEVS(INLEVS) = XMULT * LEVS(INLEVS)
 45      CONTINUE
 50   INLEVS = INLEVS - 1
C                                       Read and save first row.
      CALL MDISK ('READ', IMLUN, IMFIND, BUFF, IPOS, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) 'Contour', IERR
         GO TO 990
         END IF
      IF ((IBLCY.GE.BBLC(2)) .AND. (IBLCY.LE.BTRC(2)))
     *   CALL RFILL (BXSIZ, FBLANK, BUFF(IPOS+BXOFF))
      CALL RCOPY (INPIXS, BUFF(IPOS), RLROW)
      IF (DOBACK) THEN
         CALL MDISK ('READ', IBLUN, IBFIND, BBUFF, BPOS, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) 'Background', IERR
            GO TO 990
            END IF
         CALL GSCALE (GPHFUN, GPHRNG, INPIXS, 1, BBUFF(BPOS),
     *      IBBUFF(BPOS))
         CALL COPY (INPIXS, IBBUFF(BPOS), IBLROW)
         END IF
C                                       Loop over all rows.
      IBLCY1 = IBLCY + 1
      DO 300 IROW = IBLCY1,ITRCY
C                                       Read proper row.
         CALL MDISK ('READ', IMLUN, IMFIND, BUFF, IPOS, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) 'Contour', IERR
            GO TO 990
            END IF
         IF ((IROW.GE.BBLC(2)) .AND. (IROW.LE.BTRC(2))) THEN
            CALL RFILL (BXSIZ, FBLANK, BUFF(IPOS+BXOFF))
            END IF
         IF (DOBACK) THEN
            CALL MDISK ('READ', IBLUN, IBFIND, BBUFF, BPOS, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) 'Background', IERR
               GO TO 990
               END IF
            CALL GSCALE (GPHFUN, GPHRNG, INPIXS, 1, BBUFF(BPOS),
     *         IBBUFF(BPOS))
            END IF
C                                       Loop over all pixels in row.
         IPLUS = 0
         ITRCXM = ITRCX - 1
         DO 250 ICOL = IBLCX,ITRCXM
            IPLUS = IPLUS + 1
C                                       Init values
            VAL(1) = BUFF(IPOS+IPLUS-1)
            VAL(2) = BUFF(IPOS+IPLUS)
            VAL(3) = RLROW(IPLUS)
            IF (DOBACK) BVAL = IBBUFF(BPOS+IPLUS-1) + IBBUFF(BPOS+IPLUS)
     *         + IBLROW(IPLUS)
C                                       Init positions.
            XPOS(1) = ICOL
            XPOS(2) = ICOL + 1
            XPOS(3) = ICOL
            YPOS(1) = IROW
            YPOS(2) = IROW
            YPOS(3) = IROW - 1
C                                       Loop for both triangles.
            DO 200 ITRI = 1,2
C                                       Changes for 2nd triangle.
               IF (ITRI.EQ.2) THEN
                  VAL(1) = RLROW(IPLUS+1)
                  IF (DOBACK) BVAL = BVAL - IBBUFF(BPOS+IPLUS-1) +
     *               IBLROW(IPLUS+1)
                  XPOS(1) = ICOL + 1
                  YPOS(1) = IROW - 1
                  END IF
C                                       Order points in triangle.
               DO 130 II = 1,3
                  IF (VAL(II).EQ.FBLANK) GO TO 200
 130              CONTINUE
               INDEX = 0
               IF (VAL(1).GT.VAL(2)) INDEX = 1
               IF (VAL(3).GE.VAL(1)) INDEX = INDEX + 2
               IF (VAL(2).GE.VAL(3)) INDEX = INDEX + 4
C                                       find large, med, small
C                                       values and X,Y positions.
               II = IPERM(1,INDEX)
               VL = VAL(II)
               XL = XPOS(II)
               YL = YPOS(II)
C
               II = IPERM(2,INDEX)
               VM = VAL(II)
               XM = XPOS(II)
               YM = YPOS(II)
C
               II = IPERM(3,INDEX)
               VS = VAL(II)
               XS = XPOS(II)
               YS = YPOS(II)
C                                       Loop for all levels.
               DO 190 II = 1,INLEVS
                  VC = ALEVS(II)
C                                       Cut down negatives
                  IF (VC.GE.0.0) GO TO 140
                     IF ((XLEV.LT.2.85) .AND. (ITRI.EQ.2)) GO TO 190
                     IF (XLEV.GE.1.0) GO TO 140
                        JJ = IROW + ICOL + II
                        IF (MOD(JJ, ISLEV).NE.0) GO TO 190
 140              IF ((VC.GT.VL) .OR. ((VL-VS).LE.0.0)) GO TO 200
C                                       If level not right, next lev.
                  IF (VC.LE.VS) GO TO 190
C                                       Interpolate btwn max two corns.
                  TEMP = (VC-VS) / (VL-VS)
                  XA = TEMP * (XL-XS) + XS
                  YA = TEMP * (YL-YS) + YS
C                                       See which corners 2nd pt. btwn.
                  IF (VC.GT.VM) GO TO 150
                  IF (VM.EQ.VS) GO TO 150
C                                       Level btwn med & small corners.
                     TEMP = (VC-VS) / (VM-VS)
                     XB = TEMP * (XM-XS) + XS
                     YB = TEMP * (YM-YS) + YS
                     GO TO 160
C                                       Level btwn large & med corners.
 150                 TEMP = (VC-VM) / (VL-VM)
                     XB = TEMP * (XL-XM) + XM
                     YB = TEMP * (YL-YM) + YM
C                                       Issue position & write commands
C                                       We can avoid position command
C                                       if we switch A and B.
 160              IF ((XLAST.EQ.XB) .AND. (YLAST.EQ.YB)) THEN
                     TEMP = XA
                     XA = XB
                     XB = TEMP
                     TEMP = YA
                     YA = YB
                     YB = TEMP
C                                       See if we need to position.
                  ELSE IF ((XLAST.NE.XA) .OR. (YLAST.NE.YA)) THEN
                     CALL GPOS (XA, YA, IGBLK, IERR)
                     IF (IERR.NE.0) GO TO 999
                     END IF
C                                       Draw vector.
                  IF (VC.GE.0.0) THEN
                     IF ((DOBACK) .AND. (BVAL.GT.BCUT)) THEN
                        CALL GDVEC (XB, YB, IGBLK, IERR)
                     ELSE IF (DOCOLR.GT.0) THEN
                        IF ((DOCOLR.EQ.2) .AND. (LASTC.NE.II)) THEN
                           CALL G3VCOL (RGBLEV(1,II), RGBLEV(2,II),
     *                        RGBLEV(3,II), IGBLK, IERR)
                           IF (IERR.NE.0) GO TO 999
                           LASTC = II
                           END IF
                        CALL G3VEC (XB, YB, IGBLK, IERR)
                     ELSE
                        CALL GVEC (XB, YB, IGBLK, IERR)
                        END IF
                     IF (IERR.NE.0) GO TO 999
                     XLAST = XB
                     YLAST = YB
                     GO TO 190
C                                       Negative contours broken
                  ELSE
                     TEMP = LOCINT * SQRT (((XB-XA)**2 + (YB-YA)**2)
     *                  / 2.0)
                     MININT = IROUND (TEMP)
                     IF (MININT.LT.2) MININT = 2
                     DELTAX = (XB - XA) / MININT
                     DELTAY = (YB - YA) / MININT
                     DO 185 I = 1,MININT,2
                        XB = XA + DELTAX
                        YB = YA + DELTAY
                        IF ((DOBACK) .AND. (BVAL.GT.BCUT)) THEN
                           CALL GDVEC (XB, YB, IGBLK, IERR)
                        ELSE IF (DOCOLR.GT.0) THEN
                           IF ((DOCOLR.EQ.2) .AND. (LASTC.NE.II)) THEN
                              CALL G3VCOL (RGBLEV(1,II), RGBLEV(2,II),
     *                           RGBLEV(3,II), IGBLK, IERR)
                              IF (IERR.NE.0) GO TO 999
                              LASTC = II
                              END IF
                           CALL G3VEC (XB, YB, IGBLK, IERR)
                        ELSE
                           CALL GVEC (XB, YB, IGBLK, IERR)
                           END IF
                        IF (IERR.NE.0) GO TO 999
                        IF (I.LT.MININT-1) THEN
                           XA = XB + DELTAX
                           YA = YB + DELTAY
                           CALL GPOS (XA, YA, IGBLK, IERR)
                           IF (IERR.NE.0) GO TO 999
                           END IF
 185                    CONTINUE
                     XLAST = XB
                     YLAST = YB
                     END IF
 190              CONTINUE
 200           CONTINUE
 250        CONTINUE
         CALL RCOPY (INPIXS, BUFF(IPOS), RLROW)
         IF (DOBACK) CALL COPY (INPIXS, IBBUFF(BPOS), IBLROW)
 300     CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ON ',A,' IMAGE, MDISK ERROR',I6)
      END

      SUBROUTINE AU3A (BRANCH)
C-----------------------------------------------------------------------
C! verbs for disk management: FREE, ALLDEST, TIMDEST, etc.
C# POPS-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999, 2003, 2007-2008, 2012-2013, 2015,
C;  Copyright (C) 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AU3A contains the disk management verbs ALLDEST (verb to destroy
C   all or most of a users data files) and SCRDEST (destroy all
C   scratch files created by a specific task).  SAVDEST destroy user's
C   SAVE/GET files.
C   Inputs:
C      BRANCH I   1 = FREESPAC (print total freespace on disks)
C                 2 = ALLDEST
C                 3 = TIMDEST  (destroy all old files)
C                 4 = SAVDEST
C                 5 = SCRDEST
C                 6 = M2CAT   **** NOW IN AU4A ***
C                 7 = U2CAT   **** NOW IN AU4A ***
C                 8 = GETVERS   get max vers of extension
C                 9 = QGETVERS  ditto but quietly
C                10 = DAYNUMBR
C   Common:  /CAPL/
C      INNAME   H(3)   (ALLDEST) image name.
C      INCLASS  H(2)   (ALLDEST) image class.
C      INSEQ    R      (ALLDEST) image seq no.
C      NLUSER   I      (ALLDEST, SAVDEST, SCRDEST) logon user #.
C      TASK     H(2)   (SCRDEST) task name.
C      DETIME   R      (ALLDEST, TIMDEST) min age for destroy
C      PRTIME   R      (TIMDEST) min age message file destroy
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      CHARACTER LOCNAM*12, LOCCLS*6, LOCTYP*2, PFILE*48, PRGNAM*6,
     *   DNAME*12, DCLAS*6, DTYPE*2, EXTYPE*2, ANAME*16, NOTASK*6,
     *   NOLP*48, CDUM*1, XXTYPE*2, STAT*4, OBSDAT*8
      DOUBLE PRECISION    JD, JD0, DTIME(36)
      REAL      TIMRUL(36), TIMSG, MTIME, TIMSC, TIMCA, MANAGR, RDUM,
     *   DELTIM
      INTEGER   IUSERS(400), ITIME(6), IBLK(256), ISCR(256), I, I4T,
     *   IBVOL, ICLUN, ICNO, ICUR, IERR, IEVOL, IFIND, IMAX, IMOD, J1,
     *   INUSER, LOCSEQ, IUSER, IVER, IVOL, J, POTERR, LVOL, NCLS, NN,
     *   NNAME, NPTY, NSEQ, NSTAT, XLUSER, ILUSER, XLUSE1, XLUSE2, IE,
     *   IECNT, IER, IKEEP, INO, NLEFT, J2, NDEST, NLPR, NWPL, NPAT(12),
     *   CPAT(6), NDONE, HLUN, HIND, LREC, IREC, IHREC, IDUM, QUICK,
     *   SASSGN(280), CONF, IDATE(3), DAYN
      LOGICAL   EQUAL, ALLDEF, T, F, PRIVAT, SEQUAL
      HOLLERITH HBLK(256)
      INCLUDE 'INCS:DIO.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /AIPSCR/ IBLK, ISCR, IUSERS
      EQUIVALENCE (IBLK, HBLK)
      DATA T, F /.TRUE.,.FALSE./
      DATA PRGNAM /'AU3A  '/
      DATA MANAGR /3.0/
      DATA ICLUN, HLUN /15, 16/
      DATA NCLS, NSEQ, NSTAT, NPTY, NNAME /13, 4, 1, 19, 5/
C-----------------------------------------------------------------------
      NOTASK = ' '
      NOLP = ' '
      CALL COPY (280, DASSGN, SASSGN)
C                                       TIMDEST limits from common
C                                       data: disks 1 - 15, Save/Gets
      CALL RCOPY (35, TIMEDA, TIMRUL)
      TIMRUL(36) = TIMESG
C                                       messages (in days)
      TIMSG = TIMEMS
C                                       Scratch files limit
      TIMSC = TIMESC
C                                       Empty catalog files limit
      TIMCA = TIMECA
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.10)) GO TO 995
C                                       block TIMDEST
      IF (BRANCH.EQ.3) THEN
         MSGTXT = 'TIMDEST IS NO LONGER ALLOWED'
         CALL MSGWRT (8)
         GO TO 995
         END IF
      POTERR = 33
      NWPL = 10
      NLPR = 256 / NWPL
C                                       Determine defaults for disk.
      IF ((BRANCH.NE.6) .AND. (BRANCH.NE.7)) THEN
         CALL ADVERB ('INDISK', 'I', 1, 0, IVOL, RDUM, CDUM)
      ELSE
         CALL ADVERB ('IN2DISK', 'I', 1, 0, IVOL, RDUM, CDUM)
         END IF
      IF (ERRNUM.NE.0) GO TO 980
C                                       Only one disk.
      IF ((IVOL.NE.0) .AND. (BRANCH.NE.3)) THEN
         IBVOL = IVOL
         IEVOL = IVOL
      ELSE
         IBVOL = 1
         IEVOL = NVOL
         END IF
C                                       Check confirm on ALLDEST
      IF ((BRANCH.EQ.2) .OR. (BRANCH.EQ.4)) THEN
         CALL ADVERB ('DOCONFRM', 'I', 1, 0, CONF, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         IF (CONF.GE.-1) THEN
            IF ((IUNIT.NE.1) .AND. (IUNIT.NE.4)) THEN
               WRITE (MSGTXT,1010)
               CALL MSGWRT (8)
               POTERR = 53
               IF (IUNIT.EQ.3) POTERR = 60
               GO TO 980
               END IF
            END IF
         END IF
C                                       Branch on opcode.
      GO TO (100, 200, 200, 400, 500, 600, 600, 800, 800, 800), BRANCH
C-----------------------------------------------------------------------
C                                       FREESPAC
C                                       available disk space display
C-----------------------------------------------------------------------
 100  CONTINUE
         I = 1
         IF ((IUNIT.EQ.2) .OR. (IUNIT.EQ.3)) THEN
            I = 2
         ELSE
            CALL ADVERB ('PRTLEV', 'R', 1, 0, IDUM, RDUM, CDUM)
            IF (ERRNUM.NE.0) GO TO 980
            IF (RDUM.GE.1.0) I = 2
            END IF
         CALL ZFREE (I, IERR)
         GO TO 995
C-----------------------------------------------------------------------
C                                       ALLDEST
C                                       Destroy all images matching
C                                       adverbs
C                                       TIMDEST
C                                       Destroy all old images despite
C                                       owner
C-----------------------------------------------------------------------
 200  CALL ZDATE (ITIME(1))
      CALL ZTIME (ITIME(4))
      CALL DAT2JD (ITIME, JD0)
      CALL ADVERB ('DETIME', 'R', 1, 0, IDUM, DELTIM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      DO 201 I = 1,36
         DTIME(I) = DELTIM
         IF (BRANCH.EQ.3) DTIME(I) = MAX (DELTIM, TIMRUL(I))
         IF (DTIME(I).LE.0.0) DTIME(I) = 0.0
 201     CONTINUE
      ALLDEF = .TRUE.
      CALL ADVERB ('INSEQ', 'I', 1, 0, LOCSEQ, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
C                                       Private/public catlgs
      XLUSER = NLUSER
      XLUSE1 = NLUSER
      XLUSE2 = NLUSER
      PRIVAT = .FALSE.
      IF ((BRANCH.EQ.3) .AND. (UCTSIZ.GT.0)) THEN
         PRIVAT = .TRUE.
         XLUSE1 = 1
         XLUSE2 = USELIM
         END IF
C                                       Check for all default values.
      IF (BRANCH.NE.3) THEN
         CALL ADVERB ('INNAME', 'C', 1, 12, IDUM, RDUM, LOCNAM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('INCLASS', 'C', 1, 6, IDUM, RDUM, LOCCLS)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('INTYPE', 'C', 1, 2, IDUM, RDUM, LOCTYP)
         IF (ERRNUM.NE.0) GO TO 980
         IF ((LOCNAM.NE.' ') .OR. (LOCCLS.NE.' ') .OR.
     *      (LOCTYP.NE.' ') .OR. (LOCSEQ.NE.0)) THEN
            ALLDEF = .FALSE.
            WRITE (MSGTXT,1200) LOCTYP, LOCNAM, LOCCLS, LOCSEQ
            CALL MSGWRT (4)
            CALL PSFORM (12, LOCNAM, NPAT)
            CALL PSFORM (6, LOCCLS, CPAT)
            END IF
         END IF
      IF (DTIME(1).GT.0.0) THEN
         J1 = 1
         J2 = MIN (5, NVOL)
         WRITE (MSGTXT,1205) (DTIME(I), I = J1,J2)
         CALL MSGWRT (4)
         ALLDEF = .FALSE.
 206     J1 = J2 + 1
         J2 = MIN (NVOL, J1 + 9)
         IF (J1.LE.NVOL) THEN
            WRITE (MSGTXT,1206) (DTIME(I), I = J1,J2)
            CALL MSGWRT (4)
            GO TO 206
            END IF
         END IF
      IF (BRANCH.EQ.2) WRITE (MSGTXT,1207) NLUSER, IBVOL, IEVOL
      IF (BRANCH.EQ.3) WRITE (MSGTXT,1208)
      CALL MSGWRT (4)
C                                       Chance to back out
      POTERR = 39
      IF (CONF.GE.-1) THEN
         CALL CONFRM (IERR)
         IF (IERR.EQ.1) GO TO 995
         IF (IERR.GT.1) GO TO 980
         END IF
      IF (BRANCH.EQ.3) CALL FILL (280, 0, DASSGN)
      POTERR = 33
      INUSER = 0
      IUSERS(1) = -99
C                                       Loop through all volumes.
      DO 290 ILUSER = XLUSE1,XLUSE2
      DO 289 IVOL = IBVOL,IEVOL
         NDEST = 0
         NLUSER = ILUSER
         IF (PRIVAT) MSGSUP = 32000
         LVOL = -IVOL
         CALL CATOPN (LVOL, IFIND, IBLK, IMAX, IERR)
         MSGSUP = 0
         NLUSER = XLUSER
         IF (IERR.NE.0) GO TO 289
C                                       get catalog access time
         IKEEP = 0
         CALL  DAT2JD (IBLK(10), JD)
         IF (JD0-JD.LT.TIMCA) IKEEP = 10
         IF ((PRIVAT) .AND. (ILUSER.EQ.1). AND. (JD0-JD.LT.MANAGR*TIMCA)
     *      .AND. (BRANCH.EQ.3)) IKEEP = 10
C                                       Loop through all cat entries.
         ICUR = 995
         IREC = 1
         DO 270 ICNO = 1,IMAX
            IMOD = (ICNO - 1) / NLPR
            NN = 1 + NWPL * (ICNO - NLPR*IMOD - 1)
            ICUR = ICUR + NWPL
            IF (ICUR.LT.NWPL*NLPR) GO TO 215
C                                       Save last record.
               IF (NDEST.EQ.0) GO TO 210
                  CALL ZFIO ('WRIT', ICLUN, IFIND, IREC, IBLK, IERR)
                  IF (IERR.NE.0) GO TO 280
                  NDEST = 0
C                                       Read new buffer.
 210           CONTINUE
                  IREC = IREC + 1
                  CALL ZFIO ('READ', ICLUN, IFIND, IREC, IBLK, IERR)
                  IF (IERR.NE.0) GO TO 280
                  ICUR = 1
C                                       See if entry matches values.
C                                       Time
 215        IF (IBLK(NN).EQ.-1) GO TO 270
            IKEEP = IKEEP + 1
            CALL H2CHR (6, NCLS, HBLK(NN+NNAME), DCLAS)
            CALL H2CHR (12, 1, HBLK(NN+NNAME), DNAME)
            CALL H2CHR (2, NPTY, HBLK(NN+NNAME), DTYPE)
            SEQUAL = 'SC'.EQ.DTYPE
            CALL CATIME (2, IBLK(NN+2), ITIME)
            CALL DAT2JD (ITIME, JD)
            IF ((SEQUAL) .AND. (JD0-JD.LT.TIMSC)) GO TO 270
            IF ((.NOT.SEQUAL) .AND. (JD0-JD.LT.DTIME(IVOL))) GO TO 270
            IF ((.NOT.SEQUAL) .AND. (JD0-JD.LT.MANAGR*DTIME(IVOL)) .AND.
     *         (IBLK(NN).EQ.1) .AND. (BRANCH.EQ.3)) GO TO 270
            IF (BRANCH.EQ.3) GO TO 230
C                                       User #: ALLDEST only
               IF (NLUSER.NE.IBLK(NN)) GO TO 270
C                                       Test name.
               IF (LOCNAM.EQ.' ') GO TO 220
                  CALL CHWMAT (12, LOCNAM, NPAT, 1, DNAME, EQUAL)
                  IF (.NOT.EQUAL) GO TO 270
C                                       Test class.
 220           IF (LOCCLS.EQ.' ') GO TO 225
                  CALL CHWMAT (6, LOCCLS, CPAT, 1, DCLAS, EQUAL)
                  IF (.NOT.EQUAL) GO TO 270
C                                       Test seq #, phys type
 225           IF ((LOCSEQ.NE.0) .AND. (IBLK(NN+NSEQ).NE.LOCSEQ))
     *               GO TO 270
               IF (LOCTYP.EQ.' ') GO TO 230
                  IF (LOCTYP.NE.DTYPE) GO TO 270
C                                       Do this one hopefully
C                                       File busy: NOW A REMARK ONLY
 230        IF ((IBLK(NN+NSTAT).EQ.0) .OR. (SEQUAL)) GO TO 235
               WRITE (MSGTXT,1230) DTYPE, DNAME, DCLAS, IBLK(NN+NSEQ),
     *            IVOL, IBLK(NN)
               CALL MSGWRT (3)
C                                       Confirm deletion
 235        IF (CONF.GT.0) THEN
               WRITE (MSGTXT,1235) DTYPE, DNAME, DCLAS, IBLK(NN+NSEQ),
     *            IVOL, IBLK(NN)
               CALL MSGWRT (3)
               CALL CONFRM (IERR)
               IF (IERR.GT.0) GO TO 270
C                                       Progress report
            ELSE
               WRITE (MSGTXT,1237) DTYPE, DNAME, DCLAS, IBLK(NN+NSEQ),
     *            IVOL, IBLK(NN)
               CALL MSGWRT (3)
               END IF
C                                       Get header.
            IHREC = 1
            NLUSER = ILUSER
            CALL ZPHFIL ('CB', IVOL, ICNO, 1, PFILE, IERR)
            NLUSER = XLUSER
            IER = 0
            CALL ZOPEN (HLUN, HIND, IVOL, PFILE, F, F, T, IERR)
            IF (IERR.NE.0) GO TO 270
            CALL ZFIO ('READ', HLUN, HIND, IHREC, CATBLK, IERR)
            IF (IERR.NE.0) CALL ZCLOSE (HLUN, HIND, IER)
            IF (IERR.NE.0) GO TO 270
C                                       Do extension files.
            IECNT = 0
            CALL FXHDEX (CATBLK)
            DO 250 I = 1,KIEXTN
               J2 = MIN (46655, CATBLK(KIVER+KIEXTN-I))
               IF (J2.LE.0) GO TO 250
                  CALL H2CHR (2, 1, CATH(KHEXT-I+KIEXTN), EXTYPE)
                  INO = 0
                  IE = 0
C                                       Destroy all possible versions.
                  DO 240 J = 1,J2
                     IVER = J2 - J + 1
                     NLUSER = ILUSER
                     CALL ZPHFIL (EXTYPE, IVOL, ICNO, IVER, PFILE, IERR)
                     NLUSER = XLUSER
                     CALL ZEXIST (1, PFILE, I4T, IERR)
                     IF (IERR.EQ.0) CALL ZDESTR (IVOL, PFILE, IERR)
                     IF (IERR.EQ.0) INO = INO + 1
                     IF (IERR.GE.2) THEN
                        IE = MIN (IE, IVER)
                        WRITE (MSGTXT,1238) EXTYPE, IVER
                        CALL MSGWRT (8)
                        IECNT = IECNT + 1
                        END IF
 240                 CONTINUE
                  CATBLK(KIVER+KIEXTN-I) = IE
C                                       Print message of success
                  IF (INO.GT.0) THEN
                     WRITE (MSGTXT,1240) INO, EXTYPE
                     CALL MSGWRT (2)
                     END IF
 250           CONTINUE
C                                       Put header back
            IERR = 0
            IF (IECNT.GT.0) CALL ZFIO ('WRIT', HLUN, HIND, IHREC,
     *         CATBLK, IERR)
            CALL ZCLOSE (HLUN, HIND, IER)
            IF (IERR.NE.0) GO TO 270
C                                       Destroy main file.
            NLUSER = ILUSER
            CALL ZPHFIL (DTYPE, IVOL, ICNO, 1, PFILE, IERR)
            NLUSER = XLUSER
            CALL ZDESTR (IVOL, PFILE, IERR)
            IF (IERR.LT.2) GO TO 260
               WRITE (MSGTXT,1250) IERR
               CALL MSGWRT (6)
               IECNT = IECNT + 1
C                                       Remove from catalog.
 260        IF (IECNT.GT.0) GO TO 270
               IUSER = IBLK(NN)
               IBLK(NN) = -1
               NDEST = NDEST + 1
               IKEEP = IKEEP - 1
C                                       destroy header file
               NLUSER = ILUSER
               CALL ZPHFIL ('CB', IVOL, ICNO, 1, PFILE, IERR)
               NLUSER = XLUSER
               CALL ZDESTR (IVOL, PFILE, IERR)
               IF (IERR.LT.2) GO TO 264
                  WRITE (MSGTXT,1260) IERR
                  CALL MSGWRT (6)
C                                       Accumulate user #'s
 264           DO 265 J = 1,INUSER
                  IF (IUSERS(J).EQ.IUSER) GO TO 270
 265              CONTINUE
               INUSER = INUSER + 1
               IUSERS(INUSER) = IUSER
 270        CONTINUE
C                                       Save last record.
         IF (NDEST.EQ.0) GO TO 280
            CALL ZFIO ('WRIT', ICLUN, IFIND, IREC, IBLK, IERR)
C                                       Close catalog
 280     CALL ZCLOSE (ICLUN, IFIND, IER)
C                                       Destroy Catlg file?
         IF ((IERR.NE.0) .OR. (IKEEP.GT.0) .OR. (BRANCH.NE.3) .OR.
     *      (ILUSER.EQ.XLUSER)) GO TO 289
            NLUSER = ILUSER
            CALL ZPHFIL ('CA', IVOL, 0, 0, PFILE, IERR)
            NLUSER = XLUSER
            CALL ZDESTR (IVOL, PFILE, IERR)
            IF (IERR.LE.1) THEN
               WRITE (MSGTXT,1280) ILUSER, IVOL
               CALL MSGWRT (2)
               END IF
 289     CONTINUE
 290     CONTINUE
C                                       Continue with others ?
      IF (BRANCH.EQ.3) GO TO 300
         IF (ALLDEF) GO TO 400
         GO TO 995
C-----------------------------------------------------------------------
C                                       TIMDEST
C                                       Continue by killing SG, TS
C-----------------------------------------------------------------------
C                                       Loop over users so far deleted
 300  DO 390 IUSER = 1,USELIM
         IVOL = 1
C                                       Save/get directory file
         NLUSER = IUSER
         CALL ZPHFIL ('SG', IVOL, IUSER, 0, PFILE, IERR)
         NLUSER = XLUSER
         CALL ZEXIST (1, PFILE, I4T, IERR)
         IF (IERR.EQ.0) CALL ZOPEN (ICLUN, IFIND, IVOL, PFILE, F, T, T,
     *      IERR)
         IBVOL = 0
         IEVOL = 0
         IF (IERR.NE.0) GO TO 350
            NWPL = 7
            NLPR = 256 / NWPL
            LREC = 1
            CALL ZFIO ('READ', ICLUN, IFIND, LREC, IBLK, IERR)
            IF (IERR.NE.0) GO TO 345
C                                       Check time
            CALL CATIME (2, IBLK(3), ITIME)
            CALL DAT2JD (ITIME, JD)
            IF (JD0-JD.LT.DTIME(36)) GO TO 345
            IF ((IUSER.EQ.1) .AND. (JD0-JD.LT.MANAGR*DTIME(36)) .AND.
     *         (BRANCH.EQ.3)) GO TO 345
            CALL CATIME (2, IBLK(5), ITIME)
            CALL DAT2JD (ITIME, JD)
            IF (JD0-JD.LT.DTIME(36)) GO TO 345
            IF ((IUSER.EQ.1) .AND. (JD0-JD.LT.MANAGR*DTIME(36)) .AND.
     *         (BRANCH.EQ.3)) GO TO 345
            LOCSEQ = IBLK(1)
            IF (LOCSEQ.LE.0) GO TO 330
               DO 320 I = 1,LOCSEQ
                  IREC = I / NLPR + 1
                  IF (IREC.EQ.LREC) GO TO 310
                     CALL ZFIO ('WRIT', ICLUN, IFIND, LREC, IBLK, IERR)
                     IF (IERR.NE.0) GO TO 330
                     LREC = IREC
                     CALL ZFIO ('READ', ICLUN, IFIND, LREC, IBLK, IERR)
                     IF (IERR.NE.0) GO TO 330
 310              IREC = MOD (I, NLPR) * NWPL + 1
                  IF (IBLK(IREC).LE.0) GO TO 320
                     NLUSER = IUSER
                     CALL ZPHFIL ('SG', IVOL, IUSER, I, PFILE, IERR)
                     NLUSER = XLUSER
                     CALL ZDESTR (IVOL, PFILE, IERR)
                     CALL H2CHR (16,1, HBLK(IREC+3), ANAME)
                     IF (IERR.LT.2) WRITE (MSGTXT,1310) IUSER, ANAME
                     IF (IERR.GE.2) WRITE (MSGTXT,1311) IUSER, ANAME
                     CALL MSGWRT (2)
                     IF (IERR.GE.2) IEVOL = IEVOL + 1
                     IF (IERR.GE.2) GO TO 320
                        IBVOL = IBVOL + 1
                        IBLK(IREC) = 0
 320              CONTINUE
               CALL ZFIO ('WRIT', ICLUN, IFIND, LREC, IBLK, IERR)
 330        CALL ZCLOSE (ICLUN, IFIND, IERR)
C                                       Kill directory
            IF (IEVOL.GT.0) GO TO 340
               NLUSER = IUSER
               CALL ZPHFIL ('SG', IVOL, IUSER, 0, PFILE, IERR)
               NLUSER = XLUSER
               CALL ZDESTR (IVOL, PFILE, IERR)
               IF (IERR.LT.2) WRITE (MSGTXT,1330) IUSER
               IF (IERR.GE.2) WRITE (MSGTXT,1331) IUSER
               IF (IERR.NE.1) CALL MSGWRT (2)
C                                       Print summary also
 340     IF (IBVOL+IEVOL.LE.0) GO TO 350
            WRITE (MSGTXT,1340) IBVOL, IUSER
            CALL MSGWRT (2)
            IF (IEVOL.LE.0) GO TO 350
               WRITE (MSGTXT,1341) IEVOL, IUSER
               CALL MSGWRT (2)
               GO TO 350
 345     CALL ZCLOSE (ICLUN, IFIND, IERR)
C                                       Destroy Task-save file
 350     DO 365 IVER = 1,36
            DO 364 J1 = 1,2
               NLUSER = IUSER
               J2 = 400 * J1
               CALL ZPHFIL ('TG', IVOL, J2, IVER-1, PFILE, IERR)
               NLUSER = XLUSER
               CALL ZEXIST (1, PFILE, I4T, IERR)
               IF (IERR.EQ.0) CALL ZOPEN (ICLUN, IFIND, 1, PFILE, F, T,
     *            T, IERR)
               IF (IERR.EQ.0) THEN
                  LREC = 1
                  CALL ZFIO ('READ', ICLUN, IFIND, LREC, IBLK, IERR)
                  CALL ZCLOSE (ICLUN, IFIND, IDUM)
                  IF (IERR.EQ.0) THEN
                     CALL CATIME (2, IBLK(3), ITIME)
                     CALL DAT2JD (ITIME, JD)
                     IF ((JD0-JD.GE.DTIME(36)) .AND. ((IUSER.NE.1) .OR.
     *                  (JD0-JD.GE.MANAGR*DTIME(36)) .OR.
     *                  (BRANCH.NE.3))) THEN
                        CALL ZDESTR (IVOL, PFILE, IERR)
                        IF (IERR.LT.2) WRITE (MSGTXT,1350) IUSER
                        IF (IERR.GE.2) WRITE (MSGTXT,1351) IUSER
                        IF ((IERR.NE.1) .AND. (IVER.EQ.1))
     *                     CALL MSGWRT (2)
                        END IF
                     END IF
                  END IF
 364           CONTINUE
 365        CONTINUE
C                                       Clear/Destroy message file
         NLUSER = IUSER
         CALL ZPHFIL ('MS', IVOL, IUSER, 0, PFILE, IERR)
         NLUSER = XLUSER
         CALL ZEXIST (1, PFILE, I4T, IERR)
         IF (IERR.NE.0) GO TO 390
         CALL ADVERB ('PRTIME', 'R', 1, 0, IDUM, MTIME, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         IF (BRANCH.EQ.3) MTIME = MAX (MTIME, TIMSG)
         IF (MTIME.LE.0.0) MTIME = 0.0
         CALL PRTMSG ('DELE', IUSER, 0, 0, NOTASK, MTIME, -1, NOLP,
     *      NDONE, NLEFT, IERR)
         ERRNUM = 0
         IF (IERR.NE.0) GO TO 390
         WRITE (MSGTXT,1370) NDONE, IUSER
         IF (NDONE.GT.0) CALL MSGWRT (2)
         IF ((NLEFT.GT.4) .OR. (IUSER.EQ.XLUSER) .OR. (IUSER.EQ.1))
     *      GO TO 390
            CALL ZDESTR (1, PFILE, IERR)
            IF (IERR.LT.2) WRITE (MSGTXT,1371) IUSER
            IF (IERR.GE.2) WRITE (MSGTXT,1372) IUSER
            IF (IERR.NE.1) CALL MSGWRT (2)
 390     CONTINUE
      GO TO 995
C-----------------------------------------------------------------------
C                                       SAVDEST
C-----------------------------------------------------------------------
C                                       Ask permision.
 400  WRITE (MSGTXT,1400) NLUSER
      CALL MSGWRT (4)
      POTERR = 39
      IF (CONF.GE.-1) THEN
         CALL CONFRM (IERR)
         IF (IERR.EQ.1) GO TO 995
         IF (IERR.GT.1) GO TO 980
         END IF
C                                       Delete all save files.
      IVOL = 1
C                                       Get directory
      CALL ZPHFIL ('SG', IVOL, NLUSER, 0, PFILE, IERR)
      CALL ZEXIST (1, PFILE, I4T, IERR)
      IF (IERR.EQ.0) CALL ZOPEN (ICLUN, IFIND, IVOL, PFILE, F, T, T,
     *   IERR)
      IBVOL = 0
      IEVOL = 0
      IF (IERR.EQ.0) THEN
         NWPL = 7
         NLPR = 256 / NWPL
         LREC = 1
         CALL ZFIO ('READ', ICLUN, IFIND, LREC, IBLK, IERR)
         LOCSEQ = IBLK(1)
         IF ((IERR.EQ.0) .AND. (LOCSEQ.GT.0)) THEN
            DO 420 I = 1,LOCSEQ
               IREC = I / NLPR + 1
               IF (IREC.NE.LREC) THEN
                  CALL ZFIO ('WRIT', ICLUN, IFIND, LREC, IBLK, IERR)
                  IF (IERR.NE.0) GO TO 430
                  LREC = IREC
                  CALL ZFIO ('READ', ICLUN, IFIND, LREC, IBLK, IERR)
                  IF (IERR.NE.0) GO TO 430
                  END IF
               IREC = MOD (I, NLPR) * NWPL + 1
               IF (IBLK(IREC).GT.0) THEN
                  CALL ZPHFIL ('SG', IVOL, NLUSER, I, PFILE, IERR)
                  CALL ZDESTR (IVOL, PFILE, IERR)
                  CALL H2CHR (16, 1, HBLK(IREC+3), ANAME)
                  IF (IERR.LT.2) WRITE (MSGTXT,1310) NLUSER, ANAME
                  IF (IERR.GE.2) WRITE (MSGTXT,1311) NLUSER, ANAME
                  CALL MSGWRT (2)
                  IF (IERR.LT.2) THEN
                     IBVOL = IBVOL + 1
                     IBLK(IREC) = 0
                  ELSE
                     IEVOL = IEVOL + 1
                     END IF
                  END IF
 420           CONTINUE
            CALL ZFIO ('WRIT', ICLUN, IFIND, LREC, IBLK, IERR)
            END IF
 430     CALL ZCLOSE (ICLUN, IFIND, IERR)
C                                       Kill directory
         IF (IEVOL.LE.0) THEN
            CALL ZPHFIL ('SG', IVOL, NLUSER, 0, PFILE, IERR)
            CALL ZDESTR (IVOL, PFILE, IERR)
            IF (IERR.LT.2) WRITE (MSGTXT,1330) NLUSER
            IF (IERR.GE.2) WRITE (MSGTXT,1331) NLUSER
            IF (IERR.NE.1) CALL MSGWRT (2)
            END IF
         END IF
C                                       Print summary also
      WRITE (MSGTXT,1340) IBVOL, NLUSER
      CALL MSGWRT (2)
      IF (IEVOL.GT.0) THEN
         WRITE (MSGTXT,1341) IEVOL, NLUSER
         CALL MSGWRT (2)
         END IF
C                                       Destroy Task-save file
C                                       Ask permision.
      WRITE (MSGTXT,1450) NLUSER
      CALL MSGWRT (4)
      POTERR = 39
      IF (CONF.GE.-1) THEN
         CALL CONFRM (IERR)
         IF (IERR.EQ.1) GO TO 995
         IF (IERR.GT.1) GO TO 980
         END IF
C                                       Do it
      CALL ZPHFIL ('TS', IVOL, NLUSER, 0, PFILE, IERR)
      CALL ZDESTR (IVOL, PFILE, IERR)
      IF (IERR.LT.2) WRITE (MSGTXT,1350) 'TS', NLUSER
      IF (IERR.GE.2) WRITE (MSGTXT,1351) 'TS', NLUSER
      IF (IERR.NE.1) CALL MSGWRT (2)
      CALL ZPHFIL ('TG', IVOL, 400, 0, PFILE, IERR)
      CALL ZDESTR (IVOL, PFILE, IERR)
      IF (IERR.LT.2) WRITE (MSGTXT,1350) 'old TG', NLUSER
      IF (IERR.GE.2) WRITE (MSGTXT,1351) 'old TG', NLUSER
      IF (IERR.NE.1) CALL MSGWRT (2)
      CALL ZPHFIL ('TG', IVOL, 800, 0, PFILE, IERR)
      CALL ZDESTR (IVOL, PFILE, IERR)
      IF (IERR.LT.2) WRITE (MSGTXT,1350) 'new TG', NLUSER
      IF (IERR.GE.2) WRITE (MSGTXT,1351) 'new TG', NLUSER
      IF (IERR.NE.1) CALL MSGWRT (2)
      GO TO 995
C-----------------------------------------------------------------------
C                                       SCRDEST
C-----------------------------------------------------------------------
 500  CALL DESCR (ISCR)
      GO TO 995
C-----------------------------------------------------------------------
C                                       M2CAT, U2CAT
C                                       quick listing maps, UV disk 2
C-----------------------------------------------------------------------
 600  MSGTXT = '**** Do a COMPRESS to update your vocabulary ****'
      CALL MSGWRT (3)
      QUICK = 1
      CALL ADVERB ('DOALPHA', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IF (RDUM.GT.0.0) QUICK = 2 * QUICK
      I = 0
      IF (BRANCH.EQ.6) XXTYPE = 'MA'
      IF (BRANCH.EQ.7) XXTYPE = 'UV'
      LOCNAM = ' '
      LOCCLS = ' '
      LOCSEQ = 0
      CALL CATLST (IVOL, LOCNAM, LOCCLS, LOCSEQ, XXTYPE, IUSER, QUICK,
     *   I, IBLK, ISCR, IERR)
      GO TO 999
C-----------------------------------------------------------------------
C                                       GETVERS, QGETVERS
C                                       get extension file version max
C                                       DAYNUMBR
C                                       get day number of data file
C-----------------------------------------------------------------------
 800  IMAX = 0
      J1 = 1
      CALL ADVERB ('INNAME', 'C', 1, 12, IDUM, RDUM, LOCNAM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INCLASS', 'C', 1, 6, IDUM, RDUM, LOCCLS)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INSEQ', 'I', 1, 0, LOCSEQ, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INEXT', 'C', 1, 2, IDUM, RDUM, XXTYPE)
      IF (ERRNUM.NE.0) GO TO 980
      ICNO = 1
      LOCTYP = ' '
      CALL CATDIR ('SRNH', IVOL, ICNO, LOCNAM, LOCCLS, LOCSEQ, LOCTYP,
     *    IUSER, STAT, IBLK, I)
C                                       one found: read catlg block
      IF (I.EQ.0) CALL CATIO ('READ', IVOL, ICNO, CATBLK, 'REST', IBLK,
     *   IERR)
C                                       DAYNUMBR
      IF (BRANCH.EQ.10) THEN
         IF ((I.EQ.0) .AND. ((IERR.LE.0) .OR. (IERR.GT.5))) THEN
            CALL H2CHR (8, 1, CATH(KHDOB), OBSDAT)
            CALL DATEST (OBSDAT, IDATE)
            CALL DAYNUM (IDATE(1), IDATE(3), IDATE(2), DAYN)
            WRITE (MSGTXT,1900) OBSDAT, DAYN
            CALL MSGWRT (5)
            POTERR = 0
            END IF
         GO TO 980
         END IF

      IF ((I.EQ.0) .AND. ((IERR.LE.0) .OR. (IERR.GT.5)) .AND.
     *   (XXTYPE.NE.' ')) THEN
         CALL FNDEXT (XXTYPE, CATBLK, IMAX)
         IF (IMAX.GT.0) J1 = -1
         END IF
      CALL ADVRBS ('MAXVERS', 'I', 1, 1, IMAX, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVRBS ('ERROR', 'I', 1, 1, J1, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
C                                       be noisy
      IF (BRANCH.EQ.8) THEN
         IF (J1.GT.0) THEN
            WRITE (MSGTXT,1800) LOCNAM, LOCCLS, LOCSEQ, XXTYPE
            CALL MSGWRT (8)
         ELSE
            WRITE (MSGTXT,1801) LOCNAM, LOCCLS, LOCSEQ, XXTYPE, IMAX
            CALL MSGWRT (3)
            END IF
         END IF
      GO TO 999
C-----------------------------------------------------------------------
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.GT.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 995  CALL COPY (280, SASSGN, DASSGN)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('CONFIRMATION ALLOWED ONLY IN INTERACTIVE MODE')
 1200 FORMAT ('Limited to ',A2,' files matching name parms ',A12,
     *   '.',A6,'.',I4)
 1205 FORMAT ('Limited to files last used >',5(F5.1,','))
 1206 FORMAT (10(F5.1,','))
 1207 FORMAT ('Destroy all files for user',I5,' disks',I3,'-',I2,
     *   '?   enter YES or NO')
 1208 FORMAT ('Destroy all files last used too many days ago?',
     *   '   Enter YES or NO')
 1230 FORMAT (A2,' FILE ',A12,'.',A6,'.',I4,' DISK',I2,' USER',I5,
     *   ' MARKED BUSY')
 1235 FORMAT ('Destroy ',A2,' file ',A12,'.',A6,'.',I4,' disk',
     *   I2,' user',I5,' Y or N')
 1237 FORMAT ('Destroying ',A2,' file ',A12,'.',A6,'.',I4,' disk',
     *   I3,' user',I5)
 1238 FORMAT ('FAILED TO DESTROY ',A2,' EXT. FILE VERSION',I7)
 1240 FORMAT ('Destroyed',I6,' extension files of type ',A2)
 1250 FORMAT ('FAILED TO DESTROY MAIN FILE, ERROR',I5)
 1260 FORMAT ('FAILED TO DESTROY HEADER FILE, ERROR',I5)
 1280 FORMAT ('Destroyed catalog file for user',I5,' disk',I3)
 1310 FORMAT ('Destroyed user',I5,' SAVE/GET file ',A16)
 1311 FORMAT ('FAILED TO DESTROY USER',I5,' SAVE/GET FILE ',A16)
 1330 FORMAT ('Destroyed user',I5,' SAVE/GET directory too')
 1331 FORMAT ('FAILED TO DESTROY USER',I5,' SAVE/GET DIRECTORY')
 1340 FORMAT ('Destroyed',I3,' SAVE/GET files for user',I5)
 1341 FORMAT ('FAILED TO DESTROY',I3,' SAVE/GET FILES FOR USER',I5)
 1350 FORMAT ('Destroyed task adverb ',A,' save file for user',I5)
 1351 FORMAT ('FAILED TO DESTROY TASK ADVERB ',A,' SAVE FILE FOR USER',
     *   I5)
 1370 FORMAT ('Cleared',I7,' messages from user',I5)
 1371 FORMAT ('Destroyed message file for user',I5)
 1372 FORMAT ('FAILED TO DESTROY MESSAGE FILE FOR USER',I5)
 1400 FORMAT ('Destroy all SAVE files for user',I5,'?  enter YES or NO')
 1450 FORMAT ('Destroy TPUT/TGET files for user',I5,
     *   '?  enter YES or NO')
 1800 FORMAT (A12,'.',A6,'.',I6,2X,A2,'  NOT FOUND')
 1801 FORMAT (A12,'.',A6,'.',I6,2X,A2,'  maxvers=',I6)
 1900 FORMAT ('Date ',A,'  has day number',I4)
      END

      SUBROUTINE ZBFLIP (NB, NVALS, INBUF, OUTBUF)
C-----------------------------------------------------------------------
C! interchange bytes in buffer if needed to go between local & standard
C# Z Binary Tape FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Interchange the low order and high order bytes for all words in the
C   input buffer and put the results in output buffer (which may be the
C   same as the input buffer).  For machines that are not byte flipped,
C   the output buffer is identical to the input buffer (see BYTFLP in
C   ZDCHIN).  Any required byte swapping is performed via a call to
C   ZBYTF2.  NOTE a byte is 8 bits here.  Words are swapped as well
C   unlike ZBYTFL.
C   Inputs:
C      NB       I      Number bytes in a value
C      NVALS    I      Number of NB-byte values
C      INBUF    I(*)   Input buffer
C   Output:
C      OUTBUF   I(*)   Output buffer containing byte/word swapped values
C   Generic version - uses ZBYTF2 and ZADDR, works for 16, 32, 48, and
C   64-bit machines only
C   VMS version uses INTEGER*2
C-----------------------------------------------------------------------
      INTEGER   NB, NVALS, INBUF(*), OUTBUF(*)
C
      INTEGER*2 S2(4), JT
      INTEGER   S4(2), K, I
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (S4, S2)
C-----------------------------------------------------------------------
      IF (NBITWD.EQ.32) THEN
         K = NB * NVALS / 2
         CALL ZBYTFL (K, INBUF, OUTBUF)
         IF (BYTFLP.GE.2) THEN
            IF (NB.EQ.4) THEN
               DO 10 I = 1,NVALS
                  S4(1) = OUTBUF(I)
                  JT = S2(1)
                  S2(1) = S2(2)
                  S2(2) = JT
                  OUTBUF(I) = S4(1)
 10               CONTINUE
            ELSE IF (NB.EQ.8) THEN
               K = 2 * NVALS
               DO 20 I = 1,K,2
                  S4(1) = OUTBUF(I)
                  JT = S2(1)
                  S2(1) = S2(2)
                  S2(2) = JT
                  S4(2) = OUTBUF(I+1)
                  JT = S2(3)
                  S2(2) = S2(4)
                  S2(4) = JT
                  OUTBUF(I+1) = S4(1)
                  OUTBUF(I) = S4(2)
 20               CONTINUE
               END IF
            END IF
      ELSE
         MSGTXT = 'ZBFLIP REQUIRES LOCAL DEVELOPMENT'
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
      END

      SUBROUTINE CUBINT (A, MAPXY, NX, NY, ANS, IERR)
C-----------------------------------------------------------------------
C! does 2-dimensional cubic interpolation of array values to position
C# Math Map-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2014
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   CUBINT does a two dimentional cubic interpolation to the position in
C   array A specified by MAPXY.  It checks for blanked pixels.
C   Inputs:
C      A      R(16,16)    Data array
C      MAPXY  R(2)        Position in array A (count from 1 wrt A)
C      NX     I           X-dimension of actual data in A
C      NY     I           Y-dimension of actual data in A
C   Output:
C      ANS    R           Interpolated pixel value.
C      IERR   I           0 -> ok, 1 can't interpolate (array size)
C                              2 -> can't interpolate (blanked)
C-----------------------------------------------------------------------
      REAL      A(16,16), MAPXY(2), ANS
      INTEGER   NX, NY, IERR
C
      REAL      DX, DY, AM1, AZ, AP1, AP2, X, FM1, FZ, FP1, FP2, EPS,
     *   CUBE
      INTEGER   IX, IY, LX, LY, I, J
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA EPS /1.E-3/
C-----------------------------------------------------------------------
C                                       Inline cubic interpolation.
      CUBE (X, FM1, FZ, FP1, FP2) = FZ
     *   + X *         (FP1 - (FP2 + 3.*FZ + 2.*FM1) / 6.)
     *   + X * X *     ((FM1 + FP1) / 2. - FZ)
     *   + X * X * X * (FP2 - 3.*FP1 + 3.*FZ - FM1) / 6.
C-----------------------------------------------------------------------
      IERR = 0
      ANS = 0.
C                                       Coords in array
      IX = MAPXY(1) + EPS
      IY = MAPXY(2) + EPS
      LX = IX - 1
      LY = IY - 1
      DX = MAPXY(1) - IX
      DY = MAPXY(2) - IY
C                                       On cell:
      IF ((ABS(DX).GE.EPS) .OR. (ABS(DY).GE.EPS)) GO TO 10
         ANS = A(IX,IY)
         IF (ANS.EQ.FBLANK) IERR = 2
         IF ((IX.LT.1) .OR. (IX.GT.NX) .OR. (IY.LT.1) .OR. (IY.GT.NY))
     *      IERR = 1
         GO TO 990
C                                       Check Y interpolation range
 10   IF (ABS(DY).LT.EPS) GO TO 30
         IF (LY.GE.1) GO TO 20
            LY = LY + 1
            DY = DY - 1.0
            GO TO 10
 20      IF (LY.LE.NY-3) GO TO 30
            LY = LY - 1
            DY = DY + 1.0
            IF (LY.GE.1) GO TO 20
               IERR = 1
               GO TO 990
C                                       Check X interpolation range
 30   IF (ABS(DX).LT.EPS) GO TO 50
         IF (LX.GE.1) GO TO 40
            LX = LX + 1
            DX = DX - 1.0
            GO TO 30
 40      IF (LX.LE.NX-3) GO TO 50
            LX = LX - 1
            DX = DX + 1.0
            IF (LX.GE.1) GO TO 40
               IERR = 1
               GO TO 990
C                                       On an X pixel
 50   IF (ABS(DX).GE.EPS) GO TO 60
         IF ((A(IX,LY).EQ.FBLANK) .OR. (A(IX,LY+1).EQ.FBLANK) .OR.
     *      (A(IX,LY+2).EQ.FBLANK) .OR. (A(IX,LY+3).EQ.FBLANK)) IERR = 2
         IF (IERR.EQ.0) ANS = CUBE (DY, A(IX,LY), A(IX,LY+1),
     *      A(IX,LY+2), A(IX,LY+3))
         GO TO 990
C                                       On a Y pixel
 60   IF (ABS(DX).GE.EPS) GO TO 70
         IF ((A(LX,IY).EQ.FBLANK) .OR. (A(LX+1,IY).EQ.FBLANK) .OR.
     *      (A(LX+2,IY).EQ.FBLANK) .OR. (A(LX+3,IY).EQ.FBLANK)) IERR = 2
         IF (IERR.EQ.0) ANS = CUBE (X, A(LX,IY), A(LX+1,IY),
     *      A(LX+2,IY), A(LX+3,IY))
         GO TO 990
C                                       Interpolate in X, then Y.
 70   CONTINUE
C                                       Check
         IERR = 2
         DO 80 I = 1,4
            DO 75 J = 1,4
               IF (A(LX+I-1,LY+J-1).EQ.FBLANK) GO TO 990
 75            CONTINUE
 80         CONTINUE
         IERR = 0
C                                       Interpolate in X.
         AM1 = CUBE (DX, A(LX,LY), A(LX+1,LY), A(LX+2,LY),
     *      A(LX+3,LY))
         AZ = CUBE (DX, A(LX,LY+1), A(LX+1,LY+1), A(LX+2,LY+1),
     *      A(LX+3,LY+1))
         AP1 = CUBE (DX, A(LX,LY+2), A(LX+1,LY+2), A(LX+2,LY+2),
     *      A(LX+3,LY+2))
         AP2 = CUBE (DX, A(LX,LY+3), A(LX+1,LY+3), A(LX+2,LY+3),
     *      A(LX+3,LY+3))
C                                       Interpolate in Y.
         ANS = CUBE (DY, AM1, AZ, AP1, AP2)
C                                       Possible error
 990  IF (IERR.EQ.0) GO TO 999
         IF (IERR.EQ.1) WRITE (MSGTXT,1990)
         IF (IERR.EQ.2) WRITE (MSGTXT,1991)
         CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1990 FORMAT ('CUBINT: ARRAY IS TOO SMALL FOR INTERPOLATION')
 1991 FORMAT ('CUBINT: REQUIRED PIXEL VALUE IS BLANKED')
      END

      SUBROUTINE YSCROL (CHANNL, SCROLX, SCROLY, VRTRTC, IERR)
C-----------------------------------------------------------------------
C! write the scroll registers (shift location of 1 or more TV channels)
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YSCROL writes the scroll registers on the TV.
C   Inputs:
C      CHANNL   I   bit map channel select: bits 1-NGRAY gray channels,
C                   bit NGRAY+1 => all graphics
C      VRTRTC   L   T => do it on vertical retrace only
C   In/Out:
C      SCROLX   I   amount of X scroll (>0 to right)
C      SCROLY   I   amount of Y scroll (>0 upwards)
C   Output:
C      IERR     I   error from Z...XF : 0 => ok, 2 => input error
C   YSCROL updates the scroll variables in /TVDEV/ common
C   Virtual TV version.
C-----------------------------------------------------------------------
      INTEGER   CHANNL, SCROLX, SCROLY, IERR
      LOGICAL   VRTRTC
C
      INTEGER   BITS(16), I, J
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
C                                        write: set buffer
      BUFFER(1) = CHANNL
      BUFFER(2) = SCROLX
      BUFFER(3) = SCROLY
      BUFFER(4) = 0
      IF (VRTRTC) BUFFER(4) = 1
      BUFSW = 4
      BUFSR = 4
C                                        header & IO
      CALL MKYBUF ('READ', 'YSCROL', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
C                                       return MODed scrolls
      IF (IERR.EQ.0) THEN
         CALL UNYBUF (BUFSR, HEADER, BUFFER)
         SCROLX = BUFFER(2)
         SCROLY = BUFFER(3)
C                                        reset common scroll record
         CALL ZGTBIT (16, CHANNL, BITS)
         DO 10 I = 1,NGRAY
            IF (BITS(I).EQ.1) THEN
               TVSCRX(I) = SCROLX
               TVSCRY(I) = SCROLY
               END IF
 10         CONTINUE
         IF (BITS(16).EQ.1) THEN
            TVSCRX(NGRAY+1) = -BUFFER(1)
            TVSCRY(NGRAY+1) = BUFFER(2)
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE CATCR (IVOL, IMAX, BUFFER, IERR)
C-----------------------------------------------------------------------
C! Create and initialize catalog (CA) files
C# Catalog
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CATCR creates and initializes catalog files ('CA').  If the file
C   already exists, nothing is done and no error is generated.
C   CATCR also will create and initialize the user's message file.
C   Inputs:
C      IVOL    I       Disk volume (0 => all)
C      IMAX    I       Min # entries in catalog (>0 ONLY)
C   Output:
C      BUFFER  I(256)  Scratch buffer
C      IERR    I       Number of disks for which there was some error
C-----------------------------------------------------------------------
      INTEGER   IVOL, IMAX, BUFFER(256), IERR
C
      CHARACTER PHNAME*48
      INTEGER   IER, NWPL, NLPR, I, NREC, IX, IV, IV1, IV2, LUN, FIND,
     *   IRNO, ISIZE, LSIZE
      LOGICAL   T, F, IAMOK
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA LUN /15/
C-----------------------------------------------------------------------
      IERR = 0
C                                       Message file
 10   CONTINUE
C                                       file size
         NWPL = 25
         NLPR = 255 / NWPL
         ISIZE = 25/NLPR + 1
         CALL ZPHFIL ('MS', 1, NLUSER, 0, PHNAME, IER)
         CALL ZEXIST (1, PHNAME, LSIZE, IER)
         IF (IER.EQ.0) GO TO 100
         CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IER)
         IF (IER.EQ.1) GO TO 100
            IF (IER.EQ.0) GO TO 20
               IERR = IERR + 10
               WRITE (MSGTXT,1010) IER
               CALL MSGWRT (7)
               GO TO 100
 20         CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IER)
            IF (IER.EQ.0) GO TO 30
               IERR = IERR + 10
               WRITE (MSGTXT,1020) IER
               CALL MSGWRT (7)
               GO TO 100
 30         CALL FILL (256, 0, BUFFER)
            NREC = LSIZE
            BUFFER(1) = 0
            BUFFER(2) = NREC
            IRNO = 1
            CALL ZFIO ('WRIT', LUN, FIND, IRNO, BUFFER, IER)
            IF (IER.EQ.0) GO TO 40
               IERR = IERR + 10
               WRITE (MSGTXT,1030) IER
               CALL MSGWRT (7)
 40         CALL ZCLOSE (LUN, FIND, IER)
C                                       CATAlog files
 100  IF (IMAX.LE.0) GO TO 999
C                                       file size
         NWPL = 10
         NLPR = 256 / NWPL
         ISIZE = 2 + (IMAX-1)/NLPR
C                                       Disks to do
         IV1 = IVOL
         IV2 = IVOL
         IF ((IVOL.GT.0) .AND. (IVOL.LE.NVOL)) GO TO 110
            IV1 = 1
            IV2 = NVOL
C                                       Loop on disks
 110     DO 170 IV = IV1,IV2
            IF (IV1.LT.IV2) THEN
               IF (.NOT.IAMOK(IV,'CA')) GO TO 170
               END IF
            CALL ZPHFIL ('CA', IV, 0, 0, PHNAME, IER)
            CALL ZEXIST (IV, PHNAME, LSIZE, IER)
            IF (IER.EQ.0) GO TO 170
            CALL ZCREAT (IV, PHNAME, ISIZE, F, LSIZE, IER)
            IF (IER.EQ.1) GO TO 170
               IF (IER.EQ.0) GO TO 115
                  IERR = IERR + 1
                  WRITE (MSGTXT,1110) IV, IER
                  CALL MSGWRT (7)
                  GO TO 170
 115           CALL ZOPEN (LUN, FIND, IV, PHNAME, F, T, T, IER)
               IF (IER.EQ.0) GO TO 120
                  IERR = IERR + 1
                  WRITE (MSGTXT,1115) IV, IER
                  CALL MSGWRT (7)
                  GO TO 170
 120           CALL FILL (256, 0, BUFFER)
C                                       How many will it actually hold
               NREC = LSIZE
               IX = (NREC - 1) * NLPR
               IF (IX.GT.46655) IX = 46655
               BUFFER(1) = IV
               BUFFER(3) = IX
               CALL ZDATE (BUFFER(4))
               CALL ZTIME (BUFFER(7))
               CALL COPY (6, BUFFER(4), BUFFER(10))
               IRNO = 1
               CALL ZFIO ('WRIT', LUN, FIND, IRNO, BUFFER, IER)
               IF (IER.EQ.0) GO TO 145
                  IERR = IERR + 1
                  WRITE (MSGTXT,1140) IV, 1, IER
                  CALL MSGWRT (7)
                  GO TO 160
 145           CALL FILL (20, 0, BUFFER)
               DO 150 I = 1,256,NWPL
                  BUFFER(I) = -1
 150              CONTINUE
               DO 155 I = 2,NREC
                  IRNO = I
                  CALL ZFIO ('WRIT', LUN, FIND, IRNO, BUFFER, IER)
                  IF (IER.EQ.0) GO TO 155
                     IERR = IERR + 1
                     WRITE (MSGTXT,1140) IV, I, IER
                     CALL MSGWRT (7)
                     GO TO 160
 155              CONTINUE
 160           CALL ZCLOSE (LUN, FIND, IER)
 170        CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('CATCR: CREATE MESSAGE FILE ERROR',I7)
 1020 FORMAT ('CATCR: OPEN MESSAGE FILE ERROR',I7)
 1030 FORMAT ('CATCR: WRITE MESSAGE FILE REC 1: ERROR',I7)
 1110 FORMAT ('CATCR: CREATE CATLG ON VOL',I2,' ERROR',I7)
 1115 FORMAT ('CATCR: OPEN CATLG ON VOL',I2,' ERROR',I7)
 1140 FORMAT ('CATCR: WRITE CATLG ON VOL',I2,' REC',I4,' ERROR',I7)
      END

      SUBROUTINE UVZERO( WTOFF, LVIS, U, NCHGRD, BUFF)
C-----------------------------------------------------------------------
C! Zero's a single VIS rec, except U value to maintain sorting.
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C UV ZERO Buffer: zeros one UV point and assigns weight to zero.
C Band width synthesis is handled by this routine
C Inputs:
C  WTOFF      I     Offset to UV Weight
C  LVIS       I     Length of Visibility record
C  U          R     U value of output Vis record.
C  NCHGRD     I     Number of channels to Grid
C Output:
C  BUFF       R(*)  Visibility record
C-----------------------------------------------------------------------
      REAL U, BUFF(*)
      INTEGER WTOFF, LVIS, NCHGRD
C-----------------------------------------------------------------------
      INTEGER JJ, JNDX
C-----------------------------------------------------------------------
C                                       reset U and V
      BUFF(1)   = U
      BUFF(2) = 0.0
C                                       set index to weight
      JNDX = 1 + WTOFF
C                                       if weight with random parms
      IF (LVIS.LE.2) THEN
C                                       set weight once in random parm.
         BUFF(JNDX) = 0.0
      ELSE
C                                       weight in vis recs,
C                                       for all channels
         DO 130 JJ = 1,NCHGRD
C                                       set weight in each channel
            BUFF(JNDX) = 0.0
C                                       update pointer for next chan.
            JNDX = JNDX + LVIS
 130        CONTINUE
         END IF
      RETURN
C-----------------------------------------------------------------------
      END

      SUBROUTINE ZTTBUF (BUF, BYTCNT, SYSERR, IERR)
C-----------------------------------------------------------------------
C! reads terminal input with no prompt or wait - simulates TV trackball
C# Z Terminal TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZTTBUF dumps the contents (if any) of the input buffer into the
C   array BUF without issuing a prompt or waiting for input.  It issues
C   a call to ZQIOW with timeout set to zero.
C   Outputs:
C      BUF      C*(*)   Input buffer
C      BYTCNT   I       Number of bytes (characters) read
C      IOSB     I       System error code
C      IERR     I       Returned error code:  0 = OK
C                          2 = no access to terminal
C                          3 = IO error
C                          8 = channel not deassigned
C   This routine was written to simulate trackball buttons on
C   the keyboard.    Andy Lubenow   22 Nov 1983
C   VMS version
C-----------------------------------------------------------------------
      CHARACTER BUF*(*)
      INTEGER   BYTCNT, SYSERR, IERR
C
      INTEGER   ISTAT, TTCHAN, SYS$ASSIGN, SYS$DASSGN, SYS$QIOW,
     *   FUNC
      INTEGER*2 IOSB(4)
      HOLLERITH LBUF(20)
      INCLUDE '($IODEF)'
      INCLUDE '($SSDEF)'
C-----------------------------------------------------------------------
C                                       Open channel to terminal
      IERR = 2
      SYSERR = SYS$ASSIGN ('TT', TTCHAN,,)
      IF (SYSERR.NE.SS$_NORMAL) GO TO 999
C                                       Read from terminal
      FUNC = IOR (IO$_READVBLK, IO$M_TIMED)
      FUNC = IOR (FUNC, IO$M_NOECHO)
      SYSERR = SYS$QIOW ( , %VAL(TTCHAN), %VAL(FUNC), IOSB, , , LBUF,
     *   %VAL(80), %VAL(0), , , , )
      IF ((SYSERR.EQ.SS$_TIMEOUT) .OR. (SYSERR.EQ.SS$_NORMAL)) SYSERR =
     *   IOSB(1)
      IF ((SYSERR.EQ.SS$_TIMEOUT) .OR. (SYSERR.EQ.SS$_NORMAL)) THEN
         BYTCNT = IOSB(2)
         IERR = 0
      ELSE
         BYTCNT = 0
         IERR = 3
         END IF
      CALL H2CHR (BYTCNT, 1, LBUF, BUF)
C                                       deassign the TT
      SYSERR = SYS$DASSGN (%VAL(TTCHAN))
      IF ((SYSERR.NE.SS$_NORMAL) .AND. (IERR.EQ.0)) IERR = 8
C
 999  RETURN
      END

      SUBROUTINE REFDLY (ISUB, REFA, ANT, TIMKOL, SUBKOL, ANTKOL,
     *   SOUKOL, FRQKOL, REFKOL, DLYKOL, BUFFER, MXTIME, WRKTIM, WORK2,
     *   WORK3, IRET)
C-----------------------------------------------------------------------
C! Adjusts the reference antenna for delays in an SN table.
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Routine to rereference a delay like column in an open table.
C   A single IF and polarization is processed.   All valid entries are
C   included.
C      Note: this routine should be called before REFFAZ.  This routine
C   does not modify the reference antennas in the table
C   Inputs:
C      ISUB     I  Subarray number, 0=>1
C      REFA     I  Primary reference antenna
C      ANT      I  Secondary reference antenna
C      TIMKOL   I  Time column pointer.
C      SUBKOL   I  Subarray column pointer
C      ANTKOL   I  Antenna column pointer
C      SOUKOL   I  Source ID column pointer
C      FRQKOL   I  FQ id column pointer
C      REFKOL   I  Reference antenna pointer
C      DLYKOL   I  Delay  column pointer
C      MXTIME   I  Dimension of work arrays
C   Input/Output:
C      BUFFER   I(*) Table I/O buffer
C      WRKTIM   R(*) Work array
C      WORK2    R(*) Work array
C      WORK3    R(*) Work array
C   Output:
C      IRET     I  Error code, 0=OK else failed.
C-----------------------------------------------------------------------
      INTEGER   ISUB, REFA, ANT, TIMKOL, SUBKOL, ANTKOL, SOUKOL, FRQKOL,
     *   REFKOL, DLYKOL, BUFFER(*), MXTIME, IRET
      REAL      WRKTIM(MXTIME), WORK2(MXTIME), WORK3(MXTIME)

C
      INTEGER   LOOPR, IRCODE, NUMTIM, IPNT1, IPNT2, NUMREC, SUB, SA
      DOUBLE PRECISION TIMOFF, TIME, TIME1, TIME2
      REAL      WT1, WT2, SMOTIM, DLY1, DLY2
      INTEGER   RECORD(1024)
      REAL      RECR(1024)
      DOUBLE PRECISION RECD(512)
      EQUIVALENCE (RECORD, RECR, RECD)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA IRCODE /0/
C-----------------------------------------------------------------------
C                                       Loop thru table referring ANT
C                                       to REFA.
      SUB = MAX (1, ISUB)
      NUMTIM = 0
      NUMREC = BUFFER(5)
      DO 100 LOOPR = 1,NUMREC
         CALL TABIO ('READ', IRCODE, LOOPR, RECORD, BUFFER, IRET)
         IF (IRET.LT.0) GO TO 100
         IF (IRET.NE.0) GO TO 900
         IF ((RECORD(ANTKOL).NE.ANT) .AND. (RECORD(ANTKOL).NE.REFA))
     *      GO TO 100
         IF ((RECORD(REFKOL).NE.ANT) .AND. (RECORD(REFKOL).NE.REFA))
     *      GO TO 100
         IF (RECORD(ANTKOL).EQ.RECORD(REFKOL)) GO TO 100
         IF (RECR(DLYKOL).EQ.FBLANK) GO TO 100
C                                       Right subarray?
         SA = RECORD(SUBKOL)
         IF ((SA.NE.SUB) .AND. (SA.GT.0)) GO TO 100
         IF (NUMTIM.GE.MXTIME) GO TO 100
            NUMTIM = NUMTIM + 1
            IF (NUMTIM.EQ.1) TIMOFF = RECD(TIMKOL)
            WRKTIM(NUMTIM) = RECD(TIMKOL) - TIMOFF
            IF (RECORD(REFKOL).NE.ANT) THEN
C                                       REFA is reference ant
               WORK3(NUMTIM) = RECR(DLYKOL)
            ELSE
C                                       ANT is reference ant
               WORK3(NUMTIM) = -RECR(DLYKOL)
               END IF
 100     CONTINUE
      IRET = 0
      IF (NUMTIM.LE.0) GO TO 999
C                                       Smooth (2 sec to extrapolate)
C                                       This doesn't really do anything
      SMOTIM = 2.0 / 86400.0
      CALL BOXSMO (SMOTIM, WRKTIM, WORK3, NUMTIM, WORK2)
C                                       Set up for interpolation
      IPNT1 = 1
      IPNT2 = 2
      TIME1 = WRKTIM(1)
      TIME2 = WRKTIM(2)
      IF (NUMTIM.EQ.1) THEN
         IPNT2 = 1
         TIME2 = TIME1
         END IF
C                                       Loop thru table changing any
C                                       data with ref=ANT to ref=REFA
      DO 200 LOOPR = 1,NUMREC
         CALL TABIO ('READ', IRCODE, LOOPR, RECORD, BUFFER, IRET)
         IF (IRET.LT.0) GO TO 200
         IF (IRET.NE.0) GO TO 900
C                                       Right subarray?
         SA = RECORD(SUBKOL)
         IF ((SA.NE.SUB) .AND. (SA.GT.0)) GO TO 200
         IF (RECORD(REFKOL).NE.ANT) GO TO 200
            IF (RECR(DLYKOL).EQ.FBLANK) GO TO 190
C                                       Interpolate
               TIME = RECD(TIMKOL) - TIMOFF
 140           IF ((TIME.GE.TIME1) .AND. (TIME.LE.TIME2)) THEN
C                                       Between entries
                  IF (TIME2.NE.TIME1) THEN
                     WT1 = 1.0 - ((TIME-TIME1) / (TIME2-TIME1))
                  ELSE
                     WT1 = 1.0
                     END IF
               ELSE IF (TIME.LT.TIME1) THEN
C                                       Before first time
                  WT1 = 1.0
               ELSE IF (IPNT2.GE.NUMTIM) THEN
C                                       After last time
                  WT1 = 0.0
               ELSE
C                                       Shift in interpolation arrays
                  IPNT1 = IPNT1 + 1
                  TIME1 = WRKTIM(IPNT1)
                  IPNT2 = IPNT2 + 1
                  TIME2 = WRKTIM(IPNT2)
                  GO TO 140
                  END IF
C                                       Interpolate
                  WT2 = 1.0 - WT1
                  DLY1 = WORK2(IPNT1)
                  DLY2 = WORK2(IPNT2)
                  RECR(DLYKOL) = RECR(DLYKOL) + WORK2(IPNT1) * WT1 +
     *               WORK2(IPNT2) * WT2
C                                       Rewrite record
 190        CALL TABIO ('WRIT', IRCODE, LOOPR, RECORD, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 900
 200     CONTINUE
      IRET = 0
      GO TO 999
C                                       TABIO error
 900  WRITE (MSGTXT,1900) IRET, ANT, REFA
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('REFDLY: TABIO ERROR',I3,' REREFERENCING ANT ',I3,' TO ',
     *   I3)
      END

      SUBROUTINE SRTIN (APCORE, DISKI, CNOSCI, DISKO, CNOSCO, SORT,
     *   ROTATE, ONEPAS, NSORT, LUN, JBUFSZ, BUFF1, BUFF2, IERR)
C-----------------------------------------------------------------------
C! Reads input data and does (partial) sort in AP memory
C# Sort UV-util AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2015, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Sort routine called by UVSORT.
C   Reads input data and does (partial) sort in AP memory. Applies
C   rotation if necessary.
C      If ONEPAS is true the the sort keys are stripped off the output
C   else they are left on.
C   Input:
C      DISKI    I        Input file disk number for cataloged files,
C                        .LE. 0 => /CFILES/ scratch file.
C      CNOSCI   I        Input file catalog slot number or /CFILES/
C                        scratch file number.
C      DISKO    I        Output file disk number for cataloged files,
C                        .LE. 0 => /CFILES/ scratch file.
C      CNOSCO   I        Output file catalog slot number or /CFILES/
C                        scratch file number.
C      SORT    C*2       desired sort order keys:
C                        T=time, B=baseline, X=abs (U), Y=abs (V)
C      ROTATE   R        U, V rotation in deg.
C      ONEPAS   L        If true strip sort keys from output
C      NSORT    I        Number of vis to presort.
C      LUN      I(2)     LUNs for I/O
C   Input from DUVH.INC common:
C      LREC     I        Length of input vis rec.
C      NVIS     I        Number of visibilities
C   Input/Output:
C      JBUFSZ   I        I/O buffer size in bytes
C      BUFF1    R(*)     I/O buffer
C      BUFF2    R(*)     I/O buffer
C   Output:
C      IERR     I        Return code, 0=OK else failed.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   DISKI, CNOSCI, DISKO, CNOSCO, NSORT, LUN(2), JBUFSZ,
     *   IERR
      LOGICAL   ONEPAS
      CHARACTER SORT*2
      REAL      ROTATE, BUFF1(*), BUFF2(*)
C
      INTEGER   APW1, APW2, APVIS, IAPLOC, IAPU, IAPKEY, FINDI, FINDO,
     *   DISK1, DISK2, JERR, LENBU, VO, BO, IBIND, OBIND, NIOUT, LREC2,
     *   LRECO, LOOP, IVIS, NDO, NAP, INIO, I, IAPKE2, I4096
      LOGICAL   EXCL
      REAL      ROT(2), R4096
      CHARACTER FILE1*48, FILE2*48, ERRTXT*80
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C                                       Set AP pointers
      APW1 = 2
      APW2 = APW1 + 2*NSORT + 5
      APVIS = APW2 + NSORT + 3
      IAPU = APVIS + 2 + ILOCU
      I4096 = 0
      R4096 = 4096.0
C                                       Open input
      ERRTXT = 'SRTIN: ERROR OPENING UV DATA FILE'
C                                       Scratch file
      IF (DISKI.LE.0) THEN
         DISK1 = SCRVOL(CNOSCI)
         CALL ZPHFIL ('SC', DISK1, SCRCNO(CNOSCI), 1, FILE1, JERR)
C                                       UV data file
      ELSE
         DISK1 = DISKI
         CALL ZPHFIL ('UV', DISK1, CNOSCI, 1, FILE1, JERR)
         END IF
C                                       Open Output
C                                       Scratch file
      IF (DISKO.LE.0) THEN
         DISK2 = SCRVOL(CNOSCO)
         CALL ZPHFIL ('SC', DISK2, SCRCNO(CNOSCO), 1, FILE2, JERR)
C                                       UV data file
      ELSE
         DISK2 = DISKO
         CALL ZPHFIL ('UV', DISK2, CNOSCO, 1, FILE2, JERR)
         END IF
      EXCL = FILE1.NE.FILE2
      CALL ZOPEN (LUN(1), FINDI, DISK1, FILE1, .TRUE., EXCL, .TRUE.,
     *   IERR)
      IF (IERR.NE.0) GO TO 990
      CALL ZOPEN (LUN(2), FINDO, DISK2, FILE2, .TRUE., EXCL, .TRUE.,
     *   IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Init I/O
      LENBU = 1
      VO = 0
      BO = 1
      ERRTXT = 'SRTIN: ERROR INITIALIZING I/O'
      CALL UVINIT ('READ', LUN(1), FINDI, NVIS, VO, LREC, LENBU,
     *   JBUFSZ, BUFF1, BO, IBIND, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Output
      LENBU = 1
      LREC2 = LREC + 2
      IF (ONEPAS) THEN
         LRECO = LREC
      ELSE
         LRECO = LREC2
         END IF
      CALL UVINIT ('WRIT', LUN(2), FINDO, NVIS, VO, LRECO, LENBU,
     *   JBUFSZ, BUFF2, BO, OBIND, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Allocate AP
C                                       size was set by UVSORT
      CALL QINIT (APCORE, 0, 0, NAP)
      ROT(1) = R4096
      CALL QPUT (APCORE, ROT, I4096, 1, 2)
C                                       Loop thru file by NSORT
      ERRTXT = 'SRTIN: ERROR DOING I/O'
      DO 500 LOOP = 1,NVIS,NSORT
         NDO = MIN (NSORT, (NVIS-LOOP+1))
C                                       Load into AP
         IAPLOC = APVIS
         INIO = 1
         DO 100 IVIS = 1,NDO
            CALL UVDISK ('READ', LUN(1), FINDI, BUFF1, INIO, IBIND,
     *         IERR)
            IF (IERR.NE.0) GO TO 990
            CALL QPUT (APCORE, BUFF1(IBIND), IAPLOC+2, LREC, 2)
            IAPLOC = IAPLOC + LREC2
 100        CONTINUE
C                                       Rotate if necessary
         IF (ABS (ROTATE).GT.1.0E-10) THEN
            IAPLOC = APVIS
            ROT(1) = 1.0
            ROT(2) = -ROTATE / 57.29578
            CALL QPUT (APCORE, ROT, IAPLOC, 2, 2)
            CALL QVFILL (APCORE, IAPLOC, IAPLOC, LREC2, NDO)
            CALL QVFILL (APCORE, IAPLOC+1, IAPLOC+1, LREC2, NDO)
            CALL QRECT (APCORE, IAPLOC, LREC2, IAPLOC, LREC2, NDO)
C                                       Rotate U,V
            CALL QCVMUL (APCORE, IAPLOC, LREC2, IAPU, LREC2, IAPU,
     *         LREC2, NDO, 1)
            END IF
C                                       Set sort keys
         IAPLOC = APVIS
         DO 200 I = 1,2
C                                       Time
            IF (SORT(I:I).EQ.'T') THEN
               IAPKEY = APVIS + 2 + ILOCT
               CALL QVMOV (APCORE, IAPKEY, LREC2, IAPLOC, LREC2, NDO)
               CALL QVNEG (APCORE, IAPLOC, LREC2, IAPLOC, LREC2, NDO)
C                                       Baseline
            ELSE IF (SORT(I:I).EQ.'B') THEN
               IF (ILOCB.GE.0) THEN
                  IAPKEY = APVIS + 2 + ILOCB
                  CALL QVMOV (APCORE, IAPKEY, LREC2, IAPLOC, LREC2, NDO)
                  CALL QVNEG (APCORE, IAPLOC, LREC2, IAPLOC, LREC2, NDO)
               ELSE
                  IAPKEY = APVIS + 2 + ILOCA1
                  IAPKE2 = APVIS + 2 + ILOCA2
                  CALL QVSMA (APCORE, IAPKEY, LREC2, I4096, IAPKE2,
     *               LREC2, IAPLOC, LREC2, NDO)
                  CALL QVNEG (APCORE, IAPLOC, LREC2, IAPLOC, LREC2, NDO)
                  END IF
C                                       X (desc abs (U))
            ELSE IF (SORT(I:I).EQ.'X') THEN
               IAPKEY = APVIS + 2 + ILOCU
               CALL QVABS (APCORE, IAPKEY, LREC2, IAPLOC, LREC2, NDO)
C                                       Y (desc abs (V))
            ELSE IF (SORT(I:I).EQ.'Y') THEN
               IAPKEY = APVIS + 2 + ILOCV
               CALL QVABS (APCORE, IAPKEY, LREC2, IAPLOC, LREC2, NDO)
               END IF
C                                       Ready for second key
            IAPLOC = IAPLOC + 1
 200        CONTINUE
C                                       Sort
         CALL QSORT (APCORE, APVIS, 1, 2, LREC2, NDO, APW1, APW2)
C                                       Copy back to disk
         IAPLOC = APVIS
C                                       Strip keys?
         IF (ONEPAS) IAPLOC = IAPLOC + 2
         DO 400 IVIS = 1,NDO
            CALL QGET (APCORE, BUFF2(OBIND), IAPLOC, LRECO, 2)
            IAPLOC = IAPLOC + LREC2
            NIOUT = 1
            CALL UVDISK ('WRIT', LUN(2), FINDO, BUFF2, NIOUT, OBIND,
     *         IERR)
            IF (IERR.NE.0) GO TO 990
 400        CONTINUE
 500     CONTINUE
C                                       Release AP
      CALL QRLSE
C                                       Flush output buffer
      NIOUT = 0
      ERRTXT = 'SRTIN: FLUSHING VIS FILE'
      CALL UVDISK ('FLSH', LUN(2), FINDO, BUFF2, NIOUT, OBIND, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Close files
      CALL ZCLOSE (LUN(1), FINDI, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL ZCLOSE (LUN(2), FINDO, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = ERRTXT
      CALL MSGWRT (7)
      MSGTXT = 'SRTIN: ERROR SORTING UV DATA'
 995  CALL MSGWRT (7)
C
 999  RETURN
      END

      SUBROUTINE TRTOCF (APCORE, ISB, NFRQ, DATA, WORK)
C-----------------------------------------------------------------------
C! FFT spectra -> correlation functions
C# UV IO-appl Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  Routine to transform a complex spectrum DATA of length NFRQ
C  to a complex correlation function.
C
C  Inputs:
C     ISB          I         Sideband
C     NFRQ         I         No. frq channels in input spectrum
C     DATA(2,*)    R         Complex spectrum
C     WORK(2,*)    R         Work array (same size as data array)
C
C  Outputs:
C     DATA(2,*)    R         Complex cross correlation function
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   ISB, NFRQ, KSTART, KSTOP, K, KK, LL, NOUT
      INTEGER   FFTDIR, KPTS
      REAL      WORK(2,*), DATA(2,*), TEMP1, TEMP2
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DCVL.INC'
C-----------------------------------------------------------------------
C                                       Set some parameters
      KPTS = NFRQ*2
      NOUT = NFRQ*2
C                                       Fill lower sideband array
C                                       slots with zeroes
      KSTART = NFRQ + 1
      KSTOP  = KPTS
      DO 10 K = KSTART,KSTOP
         DATA(1,K) = 0.
         DATA(2,K) = 0.
 10      CONTINUE
C                                       Transform to XCF
      FFTDIR = -ISB
C                                       Use AP routines
      IF (POWRTO .OR. PRIME) THEN
         CALL QPUT (APCORE, DATA(1,1), APBEG, NCMPLX, APTYPE)
         CALL QWD
         FFTDIR = -FFTDIR
         CALL QCFFT (APCORE, APBEG, KPTS, FFTDIR)
         CALL QWR
         CALL QGET (APCORE, DATA(1,1), APBEG, NCMPLX, APTYPE)
         CALL QWD
C                                       non-AP
      ELSE
         CALL FOURG (DATA, KPTS, FFTDIR, WORK)
         END IF
C                                       Flip data around to
C                                       centre correlation function
C                                       in first half of array
      KSTOP = NFRQ
      DO 20 K =1, KSTOP
         KK = KPTS - KSTOP + K
         LL = NOUT - KSTOP + K
         TEMP1 = DATA(1,K)
         TEMP2 = DATA(2,K)
         DATA(1,K) = DATA(1,KK) / KPTS
         DATA(2,K) = DATA(2,KK) / KPTS
         DATA(1,LL) = TEMP1 / KPTS
         DATA(2,LL) = TEMP2 / KPTS
 20      CONTINUE
C
      RETURN
      END

      SUBROUTINE YRHIST (MODE, COLOR, INITI, NINT, HISTOG, IERR)
C-----------------------------------------------------------------------
C! read the histogram of the selected TV output color
C# Y2 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YRHIST reads the histogram of the output of a selected OFM of the
C   TV.   Intensity values 0 through OFMOUT may be read.
C   Inputs:
C      MODE    I         selects area to histogram: 0 blotch,
C                        1 not blotch, 2 all, 3 external blotch
C      COLOR   I         bit map of single color (RGB - 4,2,1)
C      INITI   I         first intensity to histo (1 - 1024)
C      NINT    I         # values to get
C   Output:
C      HISTOG  I(NINT)   histogram
C      IERR    I         error code of Z...XF : 0 => ok, 2 => input err
C   Version for IIS Model 75
C-----------------------------------------------------------------------
      INTEGER   MODE, COLOR, INITI, NINT, HISTOG(*), IERR
C
      INTEGER   HEADER(8), UNIT, BUFSIZ, NB, COUNT, IX, IY, I, J,
     *   SCRTCH(2048)
      LOGICAL   VRTRTC, COMND1, COMND2
      DATA UNIT, COMND1, COMND2, BUFSIZ /7,.TRUE.,.FALSE.,1/
      DATA VRTRTC /.FALSE./
C-----------------------------------------------------------------------
C                                       Check errors
      IERR = 2
      IF ((MODE.LT.0) .OR. (MODE.GT.3)) GO TO 999
      IF ((COLOR.NE.1) .AND. (COLOR.NE.2) .AND. (COLOR.NE.4)) GO TO 999
      IF ((INITI.LT.1) .OR. (NINT.LT.1) .OR. (INITI+NINT-1.GT.1024))
     *   GO TO 999
C                                       Write command buffer
      CALL YMKHDR ('WRIT', UNIT, COMND1, BUFSIZ, 0, 0, 0, 0, VRTRTC,
     *   HEADER)
      NB = 2 * BUFSIZ
      CALL ZM70XF ('WRIT', NB, HEADER, MODE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Read histogram
      COUNT = 2 * NINT
C                                       The address is passed only
C                                       through X register.
C      IY = 2 * (INITI-1)
C      IX = MOD (IY, 512)
C      IY = IY / 512
      IX = 2 * (INITI - 1)
      CALL YMKHDR ('READ', UNIT, COMND2, COUNT, IX, 0, COLOR, 0, VRTRTC,
     *   HEADER)
      NB = 2 * COUNT
      CALL ZM70XF ('READ', NB, HEADER, SCRTCH, IERR)
C                                       16 bit words in ZM70XF
C                                       repack into full integers
      CALL ZIPACK ('LTOS', COUNT, SCRTCH, 1, HISTOG)
C
 999  RETURN
      END

      SUBROUTINE YIMGIO (OP, CHAN, X, Y, IANGL, NPIX, IMAGE, IERR)
C-----------------------------------------------------------------------
C! read/write data to the TV grey and graphics memories
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YIMGIO reads/writes a line of image data to the TV screen.  For
C   graphics overlay planes, the data are solely 0's and 1's in the
C   least significant bit of IMAGE after a READ.  For 'WRIT', all bits
C   of each word should be equal (i.e. all 1's or all 0's for graphics).
C   NOTE***** on 'WRIT', the buffer may be altered by this routine for
C   some IANGLs.
C   Inputs:
C      OP      C*4       'READ' from TV or 'WRIT' to TV
C      CHAN    I         channel number (1 to NGRAY+NGRAPH)
C      X       I         start pixel position
C      Y       I         end pixel position
C      IANGL   I         = 0 => horizontal (to right)
C                        = 1 => vertical (up the screen)
C                        = 2 => horizontal (to left)
C                        = 3 => vertical (down the screen)
C      NPIX    I         number of pixels
C   In/Out:
C      IMAGE   I(NPIX)   data (only no header)
C   Output:
C      IERR    I         error code of Z...XF - 0 => ok
C                                                  2 => input err
C   NO TV VERSION - stub
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   CHAN, X, Y, IANGL, NPIX, IMAGE(*), IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'YIMGIO: THERE IS NO TV CONFIGURED'
      CALL MSGWRT (8)
C
 999  RETURN
      END

      PROGRAM TACOP
C-----------------------------------------------------------------------
C! Task to copy table extension files.
C# EXT-util Utility Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2002, 2005, 2008-2009, 2015, 2017-2019,
C;  Copyright (C) 2022, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  TACOP copies AIPS extension tables files.  The specified output table
C  should not exist before the execution of TACOP.
C  ADVERBS:
C    INNAME      Input image name (name)
C    INCLASS     Input image name (class)
C    INSEQ       Input image name (seq. #)
C    INDISK      Input image disk unit #
C    INEXT       Input table extension type
C    INVERS      Input table file version no.
C    OUTNAME     Output image name (name)
C    OUTCLASS    Output image name (class)
C    OUTSEQ      Output image name (seq. #)
C    OUTDISK     Output image disk unit #.
C    OUTVERS     Output table file version.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER  NAMEIN*12, CLAIN*6, FTYPE*2, STAT*4, NAMOUT*12,
     *   CLAOUT*6, XEXT*2, XKEYS*16, TSTSTR*8, PRGM*6, TABTYP*2,
     *   KEYW*8, ATIME*8, ADATE*12, XKEYW*8
      HOLLERITH XNAMIN(3), XCLAIN(2), XNMOUT(3), XCLOUT(2), XNEXT,
     *   CATHLD(256), XHKEYW(2), XHKEYS(4)
      INTEGER  IRET, SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO, I,
     *   CATOLD(256), BUFF1(512), BUFF2(512), IERR, IVER, OVER, LUN1,
     *   LUN2, NPARM, IROUND,  NTAB, ITAB, LOCS, KTYPE, VALI2, NKEY,
     *   NREC, NCOL, ICHPAT(8), NOLDT, CPYCNT, TIME(3), DATE(3),
     *   FLAGV
      LOGICAL   EQUAL, EXIST, TABLE, FITASC
      INTEGER   I4TEMP, VALI4
      REAL      XSEQIN, XDISKI, XIVER, XNC, XFLAG, XSEQO, XDISKO, XOVER,
     *   XKEYV(2), VALR4(2), VALUE, DDFLAG, BADD(10), SCRTCH(XBPRSZ)
      DOUBLE PRECISION    VALR8
      LOGICAL   T, SAME
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /INPARM/ XNAMIN, XCLAIN, XSEQIN, XDISKI, XNEXT, XIVER,
     *   XNC, XFLAG, XNMOUT, XCLOUT, XSEQO, XDISKO, XOVER, XHKEYW,
     *   XKEYV, XHKEYS, DDFLAG, BADD
      EQUIVALENCE (VALI2, VALI4, VALR4, VALR8)
      EQUIVALENCE (CATOLD, CATHLD)
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA PRGM /'TACOP '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 38
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMIN, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
      CALL SELINI
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMIN, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNMOUT, NAMOUT)
      CALL H2CHR (6, 1, XCLOUT, CLAOUT)
      CALL H2CHR (2, 1, XNEXT, XEXT)
      CALL H2CHR (16, 1, XHKEYS, XKEYS)
      CALL H2CHR (8, 1, XHKEYW, XKEYW)
C                                       Crunch input parameters.
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      SEQIN  = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO  = IROUND (XDISKO)
      IVER   = IROUND (XIVER)
      OVER   = IROUND (XOVER)
      NTAB   = IROUND (XNC)
      FLAGV  = IROUND (XFLAG)
      XOVER  = OVER
      TABTYP = XEXT
C                                       Prevent write to disk # 0 !
      IF (DISKO.EQ.0) DISKO = DISKIN
C                                       Default output = input.
      IF (NAMOUT.EQ.' ') NAMOUT = NAMEIN
      IF (CLAOUT.EQ.' ') CLAOUT = CLAIN
C                                       Set up for character compare
      CALL PSFORM (8, XKEYS, ICHPAT)
C                                       Find input
      OLDCNO = 1
      FTYPE = ' '
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, FTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Find output
      NEWCNO = 1
      FTYPE = ' '
      CALL CATDIR ('SRCH', DISKO, NEWCNO, NAMOUT, CLAOUT, SEQOUT, FTYPE,
     *    NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMOUT, CLAOUT, SEQOUT, DISKO,
     *      NLUSER
         GO TO 990
         END IF
      SAME = (DISKIN.EQ.DISKO) .AND. (OLDCNO.EQ.NEWCNO)
      STAT = 'READ'
      IF (SAME) STAT = 'REST'
C                                       Read old CATBLK and mark 'READ'
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, STAT, BUFF1, IERR)
      IF ((IERR.GT.0) .AND. (IERR.LT.5)) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      IF (.NOT.SAME) THEN
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKIN
         FCNO(NCFILE) = OLDCNO
         FRW(NCFILE) = 0
         END IF
C                                       Read new CATBLK and mark 'WRIT'
      CALL CATIO ('READ', DISKO, NEWCNO, CATBLK, 'WRIT', BUFF1, IERR)
      IF ((IERR.GT.0) .AND. (IERR.LT.5)) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 1
C                                       Check number of tables
      CALL FNDEXT (TABTYP, CATOLD, NOLDT)
C                                       use highest version when IVER = 0
      IF (IVER.LE.0) IVER = NOLDT
      XIVER = IVER
C                                       NCOUNT .le. 0 => do all with
C                                       version numbers greater than or
C                                       equal to IVER.
      IF (NTAB.LE.0) NTAB = NOLDT - IVER + 1
      NTAB = MIN (NTAB, NOLDT - IVER + 1)
      KEYW(1:8) = XKEYW(1:8)
      CPYCNT = 0
C                                       init flagging
      IF ((FLAGV.GT.0) .AND. (FTYPE.EQ.'UV')) THEN
         IF ((TABTYP.EQ.'SN') .OR. (TABTYP.EQ.'TY') .OR.
     *      (TABTYP.EQ.'SY')) THEN
            CALL COPY (256, CATBLK, BUFF1)
            CALL COPY (256, CATOLD, CATBLK)
            CALL UVPGET (IERR)
            CALL COPY (256, BUFF1, CATBLK)
            CALL INITFG (FLAGV, DISKIN, OLDCNO, CATOLD, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1045) IERR
               GO TO 990
               END IF
            END IF
         END IF
C                                       Loop over tables
      DO 90 ITAB = 1,NTAB
C                                       Is it a table
         CALL ISTAB (TABTYP, DISKIN, OLDCNO, IVER, LUN1, BUFF1, TABLE,
     *      EXIST, FITASC, IERR)
         IF (IERR.NE.0) THEN
            IRET = 5
            WRITE (MSGTXT,1080) IERR
            GO TO 990
            END IF
         IF (.NOT.EXIST) THEN
            WRITE (MSGTXT,1050) TABTYP, IVER
            CALL MSGWRT (6)
            GO TO 85
            END IF
C                                       See if desired:
         IF (KEYW.NE.' ') THEN
            IF (.NOT.TABLE) THEN
               MSGTXT = 'KEYWORD TEST MAY NOT BE APPLIED TO NON TABLES'
               IRET = 5
               GO TO 990
               END IF
C                                       Do test on table keyword
            NKEY = 0
            NREC = 0
            NCOL = 0
C                                       Open table
            CALL TABINI ('READ', TABTYP, DISKIN, OLDCNO, IVER, CATOLD,
     *         LUN1, NKEY, NREC, NCOL, BUFF2, BUFF1, IERR)
            IF (IERR.NE.0) THEN
               IRET = 5
               WRITE (MSGTXT,1081) IERR
               GO TO 990
               END IF
C                                       Get keyword
            NKEY = 1
            CALL TABKEY ('READ', KEYW, NKEY, BUFF1, LOCS, VALR8, KTYPE,
     *         IERR)
            IF ((IERR.GT.0) .AND. (IERR.LE.20)) THEN
               IRET = 5
               WRITE (MSGTXT,1082) IERR
               GO TO 990
               END IF
C                                       Don't do table with missing
C                                       keyword.
            IF (IERR.GT.20) GO TO 85
C                                       Close table
            CALL TABIO ('CLOS', 1, I4TEMP, SCRTCH, BUFF1, IERR)
            IF (IERR.NE.0) THEN
               IRET = 5
               WRITE (MSGTXT,1083) IERR
               GO TO 990
               END IF
C                                       Decide if table wanted
            VALUE = 0.0
            IF (KTYPE.EQ.1) VALUE = VALR8
            IF (KTYPE.EQ.2) VALUE = VALR4(1)
            IF (KTYPE.EQ.4) VALUE = VALI4
            IF (KTYPE.EQ.6) VALUE = VALI2
            IF (KTYPE.EQ.3) THEN
C                                       Character
               CALL H2CHR (8, 1, VALR4, TSTSTR)
               CALL CHWMAT (8, XKEYS, ICHPAT, 1, TSTSTR, EQUAL)
               IF (.NOT.EQUAL) GO TO 85
            ELSE
C                                       Numeric keyword
C                                       Inclusive range
               IF (((VALUE.LT.XKEYV(1)) .OR. (VALUE.GT.XKEYV(2)))
     *            .AND. (XKEYV(1).LT.XKEYV(2))) GO TO 85
C                                       Exclusive range
               IF (((VALUE.GT.XKEYV(2)) .AND. (VALUE.LT.XKEYV(1)))
     *            .AND. (XKEYV(1).GT.XKEYV(2))) GO TO 85
               END IF
            END IF
C                                       Copy table
         IF ((FLAGV.GT.0) .AND. (TABTYP.EQ.'SN')) THEN
            CALL SNFCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IVER, OVER,
     *         CATOLD, CATBLK, LUN1, LUN2, DDFLAG, BUFF1, BUFF2, IRET)
         ELSE IF ((FLAGV.GT.0) .AND. (TABTYP.EQ.'TY')) THEN
            CALL TYFCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IVER, OVER,
     *         CATOLD, CATBLK, LUN1, LUN2, DDFLAG, BUFF1, BUFF2, IRET)
         ELSE IF ((FLAGV.GT.0) .AND. (TABTYP.EQ.'SY')) THEN
            CALL SYFCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IVER, OVER,
     *         CATOLD, CATBLK, LUN1, LUN2, DDFLAG, BUFF1, BUFF2, IRET)
         ELSE IF (TABLE) THEN
            CALL TBLCOP (TABTYP, IVER, OVER, LUN1, LUN2, DISKIN, DISKO,
     *         OLDCNO, NEWCNO, CATBLK, DDFLAG, BUFF1, BUFF2, SCRTCH,
     *         IRET)
         ELSE
            CALL FILCOP (TABTYP, IVER, OVER, LUN1, LUN2, DISKIN, DISKO,
     *         OLDCNO, NEWCNO, CATBLK, BUFF1, BUFF2, IRET)
            END IF
         IF (IRET.NE.0) THEN
            IF (IRET.EQ.1) THEN
               MSGTXT = 'INPUT AND OUTPUT EXTSION FILES ARE THE SAME.'
               GO TO 990
            ELSE IF (IRET.EQ.6) THEN
               WRITE (MSGTXT,1085) TABTYP, OVER
               GO TO 990
            ELSE
               WRITE (MSGTXT,1086) IRET, TABTYP, IVER
               GO TO 990
               END IF
            END IF
         CPYCNT = CPYCNT + 1
         IF (OVER.GT.0) OVER = OVER + 1
 85      IVER = IVER + 1
 90      CONTINUE
C                                       Finished copying tables
      IRET = 0
C                                       Add history to output
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN1, DISKO, NEWCNO, BUFF1, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1090) IERR
         CALL MSGWRT (6)
         GO TO 150
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
      WRITE (MSGTXT,1100) TSKNAM, RLSNAM, ADATE, ATIME
      CALL HIADD (LUN1, MSGTXT, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
C                                       Input file
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN1, BUFF1,
     *   IERR)
      IF (IERR.NE.0) GO TO 150
C                                       Type and version
      IVER = IROUND (XIVER)
      OVER = IROUND (XOVER)
      WRITE (MSGTXT,2000) TSKNAM, TABTYP, IVER, OVER
      CALL HIADD (LUN1, MSGTXT, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
C                                       NCOUNT
      WRITE (MSGTXT,2001) TSKNAM, NTAB
      CALL HIADD (LUN1, MSGTXT, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
C                                       Keyword
      IF (KEYW.NE.' ') THEN
         WRITE (MSGTXT,2002) TSKNAM, KEYW
         CALL HIADD (LUN1, MSGTXT, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 150
C                                       KEYSTRNG
         IF (KTYPE.EQ.3) THEN
            TSTSTR(1:8) = XKEYS(1:8)
            WRITE (MSGTXT,2003) TSKNAM, TSTSTR
            CALL HIADD (LUN1, MSGTXT, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 150
         ELSE
C                                       KEYVALUE
            WRITE (MSGTXT,2004) TSKNAM, XKEYV
            CALL HIADD (LUN1, MSGTXT, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 150
            END IF
         END IF
C                                       Number of tables copied
      IF (CPYCNT.LE.0) THEN
         WRITE (MSGTXT,2006) TSKNAM
         CALL MSGWRT (6)
      ELSE
         WRITE (MSGTXT,2005) TSKNAM, CPYCNT
         CALL MSGWRT (4)
         END IF
      CALL HIADD (LUN1, MSGTXT, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
C                                       Close HI file
 150  CALL HICLOS (LUN1, T, BUFF1, IERR)
      GO TO 995
C                                       Error
 990  CALL MSGWRT (8)
C                                       Close down files, etc
 995  CALL DIE (IRET, BUFF1)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' GETING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1045 FORMAT ('ERROR',I4,' INITIALIZING FLAGGING')
 1050 FORMAT ('Extension file ',A2,' version',I5,' missing')
 1080 FORMAT ('ISTAB ERROR ',I3,' CHECKING FILE')
 1081 FORMAT ('TABINI ERROR ',I3,' EXAMINING KEYWORD')
 1082 FORMAT ('TABKEY ERROR ',I3,' EXAMINING KEYWORD')
 1083 FORMAT ('TABIO CLOSE ERROR ',I3,' EXAMINING KEYWORD')
 1085 FORMAT ('OUTPUT EXTENSION FILE ALREADY EXISTS: ',A2,I5)
 1086 FORMAT ('TBLCOP ERROR ',I4,' COPYING EXT FILE ',A2,I5)
 1090 FORMAT ('ERROR',I3,' OPENING HISTORY FILE')
 1100 FORMAT (A6,'Release =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 2000 FORMAT (A6,' INEXT=''',A2,''' INVERS=',I4,' OUTVERS=', I4)
 2001 FORMAT (A6,' NCOUNT=',I5,' /Number of tables to copy')
 2002 FORMAT (A6,' KEYWORD=''',A8,''' / Keyword for test')
 2003 FORMAT (A6,' KEYSTRNG=''',A8,''' / String for test')
 2004 FORMAT (A6,' KEYVALUE=',1PE12.5,',',E12.5,' / Allowed range')
 2005 FORMAT (A6,' / Copied ',I6,' extension files')
 2006 FORMAT (A6,' / Warning: NO extension files copied')
      END
      SUBROUTINE TBLCOP (TYPE, INVER, OUTVER, LUNOLD, LUNNEW, VOLOLD,
     *   VOLNEW, CNOOLD, CNONEW, CATNEW, DDFLAG, BUFOLD, BUFNEW, SCRTCH,
     *   IRET)
C-----------------------------------------------------------------------
C   TABCOP copies Table extension file(s).  The output file must be a
C   new extension - old ones cannot be rewritten.  The output file
C   must be opened WRIT in the catalog and will have its CATBLK
C   updated on disk.
C     LOCAL VERSION: adds option to drop flagged records and so uses
C     TABINI etc rather than ZFIO.
C   Inputs:
C      TYPE     C*2     Extension file type (e.g. 'CC','AN')
C      INVER    I       Version number to copy, 0 => copy all.
C      OUTVER   I       Version number on output file, if more than one
C                       copied (INVER=0) this will be the number of the
C                       first file.  If OUTVER = 0, it will be taken as
C                       1 higher than the previous highest version.
C      LUNOLD   I       LUN for old file
C      LUNNEW   I       LUN for new file
C      VOLOLD   I       Disk number for old file.
C      VOLNEW   I       Disk number for new file.
C      CNOOLD   I       Catalog slot number for old file
C      CNONEW   I       Catalog slot number for new file
C      DDFLAG   R       > 0 => copy flagged rows
C   In/out:
C      CATNEW   I(256)  Catalog header for new file.
C   Output:
C      BUFOLD   I(512)  Work buffer
C      BUFNEW   I(512)  Work buffer
C      SCRTCH   I(*)    Buffer large enough for one data row
C      IRET     I       Return error code  0 => ok
C                          1 => files the same, no copy.
C                          2 => no input files exist
C                          3 => failed
C                          4 => no output files created.
C                          5 => failed to update CATNEW
C                          6 => output file exists
C   Inputs from MSG common:
C      MSGSUP   I       If 31990 < MSGSUP < 32000, the file copied
C                       message is suppressed.
C-----------------------------------------------------------------------
      INTEGER   INVER, OUTVER, LUNOLD, LUNNEW, VOLOLD, VOLNEW, CNOOLD,
     *   CNONEW, BUFOLD(512), BUFNEW(512), CATNEW(256), IRET
      CHARACTER TYPE*2
      REAL      DDFLAG, SCRTCH(*)
C
      INTEGER   COUNT, IVERI, IVERO, OVO, OVN, I, J, II, LIM, IER, JERR,
     *   IRNO, CATOLD(256), IDATP(128,2), ODATP(128,2), NREC, NCOL,
     *   NKEY, OFIND, IFIND, NFIRST, OREC, ITEMP(2)
      HOLLERITH CATHLD(256), HTEMP(2)
      LOGICAL   TABLE, EXIST, FITASC
      CHARACTER CHTEMP*2
      EQUIVALENCE (CATOLD, CATHLD), (ITEMP, HTEMP)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Set initial version numbers.
      COUNT = 0
      IVERI = MAX (1, INVER)
      IVERO = OUTVER
C                                       Check if files the same
      IRET = 1
      IF ((VOLOLD.EQ.VOLNEW) .AND. (CNOOLD.EQ.CNONEW) .AND.
     *   (INVER.EQ.OUTVER)) GO TO 999
C                                       See if new file exists
      IRET = 6
      CALL ISTAB (TYPE, VOLNEW, CNONEW, OUTVER, LUNNEW, BUFOLD, TABLE,
     *   EXIST, FITASC, JERR)
      IF (EXIST .AND. (JERR.EQ.0)) GO TO 999
C                                       Get old CATBLK in BUFNEW.
      IRET = 3
      CALL CATIO ('READ', VOLOLD, CNOOLD, CATOLD, 'REST', BUFOLD, IER)
      IF ((IER.GT.0) .AND. (IER.LT.5)) THEN
         WRITE (MSGTXT,1010) IER
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Find # TYPE ext. files.
      OVO = 0
      OVN = 0
      J = 0
      CALL FXHDEX (CATOLD)
      CALL FXHDEX (CATNEW)
      DO 20 I = 1,KIEXTN
         II = KHEXT + I - 1
         CALL H2CHR (2, 1, CATHLD(II), CHTEMP)
         IF (TYPE.EQ.CHTEMP) OVO = I
         ITEMP(1) = CATNEW(II)
         CALL H2CHR (2, 1, HTEMP, CHTEMP)
         IF (TYPE.EQ.CHTEMP) OVN = I
         IF ((CHTEMP.EQ.' ') .AND. (J.LE.0)) J = I
 20      CONTINUE
C                                       Old table files exist?
      IRET = 2
      IF (OVO.LE.0) GO TO 999
      LIM = CATOLD(KIVER+OVO-1)
      IF (LIM.LE.0) GO TO 999
      IF (INVER.GT.0) LIM = 1
C                                       No room to catalog new type
      IF ((J.LE.0) .AND. (OVN.LE.0)) THEN
         WRITE (MSGTXT,1020)
         CALL MSGWRT (6)
         IRET = 3
         GO TO 999
         END IF
C                                       Loop copying files.
      DO 100 J = 1,LIM
C                                       Open input file
         NREC = 20
         NCOL = 0
         NKEY = 0
         CALL TABINI ('READ', TYPE, VOLOLD, CNOOLD, IVERI, CATOLD,
     *      LUNOLD, NKEY, NREC, NCOL, IDATP, BUFOLD, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OLD', IVERI
            GO TO 990
            END IF
         NREC = BUFOLD(5)
         CALL COPY (256, IDATP, ODATP)
         CALL COPY (256, BUFOLD, BUFNEW)
C                                       create
         CALL TABINI ('WRIT', TYPE, VOLNEW, CNONEW, IVERO, CATNEW,
     *      LUNNEW, NKEY, NREC, NCOL, ODATP, BUFNEW, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN NEW', IVERO
            GO TO 990
            END IF
         IRET = 0
C                                       Save info from input header
C                                       Creation date, time
         CALL COPY (6, BUFOLD(11), BUFNEW(11))
C                                       Creation task
         CALL COPY (3, BUFOLD(29), BUFNEW(29))
C                                       Sort info
         BUFNEW(43) = BUFOLD(43)
         BUFNEW(44) = BUFOLD(44)
C                                       Number of keywords
         BUFNEW(53) = BUFOLD(53)
C                                       Selection strings
         CALL COPY (10, BUFOLD(61), BUFNEW(61))
C                                       Title
         CALL COPY (28, BUFOLD(101), BUFNEW(101))
C                                       Copy Keywords et al.
         OFIND = BUFNEW(82)
         IFIND = BUFOLD(82)
         NFIRST = BUFOLD(50) - 1
         DO 30 I = 2,NFIRST
            IRNO = I
            CALL ZFIO ('READ', LUNOLD, IFIND, IRNO, BUFOLD(257), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1030) IRET, 'READ', IRNO
               GO TO 990
               END IF
            CALL ZFIO ('WRIT', LUNNEW, OFIND, IRNO, BUFOLD(257), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1030) IRET, 'WRIT', IRNO
               GO TO 990
               END IF
 30         CONTINUE
         BUFOLD(77) = 5
         BUFOLD(78) = NFIRST
C                                       more set ups
         NREC = BUFOLD(5)
         OREC = 0
         DO 50 I = 1,NREC
            CALL TABIO ('READ', 0, I, SCRTCH, BUFOLD, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1030) IRET, 'READ', I
               GO TO 990
            ELSE IF (IRET.EQ.0) THEN
               OREC = OREC + 1
               CALL TABIO ('WRIT', 0, OREC, SCRTCH, BUFNEW, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1030) IRET, 'WRIT', OREC
                  GO TO 990
                  END IF
            ELSE IF ((IRET.LT.0) .AND. (DDFLAG.GT.0.0)) THEN
               OREC = OREC + 1
               CALL TABIO ('FLAG', 0, OREC, SCRTCH, BUFNEW, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1030) IRET, 'FLAG', OREC
                  GO TO 990
                  END IF
               END IF
 50         CONTINUE
         COUNT = COUNT + 1
         IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
            WRITE (MSGTXT,1050) TYPE, VOLOLD, CNOOLD, IVERI, VOLNEW,
     *         CNONEW, IVERO
            CALL MSGWRT (3)
            IF (OREC.NE.NREC) THEN
               WRITE (MSGTXT,1051) OREC, NREC
               CALL MSGWRT (3)
               END IF
            END IF
C                                       Close files
         CALL TABIO ('CLOS', 0, I, SCRTCH, BUFOLD, IRET)
         CALL TABIO ('CLOS', 0, OREC, SCRTCH, BUFNEW, IRET)
         IVERI = IVERI + 1
         IVERO = IVERO + 1
 100     CONTINUE
      IRET = 0
      CALL CATIO ('UPDT', VOLNEW, CNONEW, CATNEW, 'REST', BUFOLD, IER)
      IF (IER.NE.0) IRET = 5
      IF (COUNT.EQ.0) IRET = 4
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TBLCOP ERROR',I4,' DOING ',A,' VERSION',I4)
 1010 FORMAT ('TBLCOP: ERROR',I5,' READING OLD CATBLK')
 1020 FORMAT ('TBLCOP: NO ROOM IN NEW CATBLK FOR NEW EXTENSION TYPE')
 1030 FORMAT ('TBLCOP ERROR',I4,' ON ',A,' ROW',I5)
 1050 FORMAT ('Copied ',A2,' file from vol/cno/vers',I3,I5,I4,' to',
     *   I3,I5,I4)
 1051 FORMAT ('Copied only',I8,' unflagged records from',I8,' in input')
      END
      SUBROUTINE INITFG (FLAGV, DISKIN, CNOIN, CATIN, IRET)
C-----------------------------------------------------------------------
C   Set the DSEL common to do flagging
C   Output:
C      IRET   I   > 0 messed up
C-----------------------------------------------------------------------
      INTEGER   FLAGV, DISKIN, CNOIN, CATIN(*), IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INTEGER   IERR, KEY(2,2), KEYSUB(2,2), LUNTMP, K
      REAL      FKEY(2,2), SCRTCH(2)
      DATA KEY /5,0, 1,0/
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
C-----------------------------------------------------------------------
      DOFLAG = .TRUE.
      IFLUN = LUNTMP (1)
      CALL COPY (256, CATIN, CATUV)
      KLOCSU = ILOCSU
      KLOCFQ = ILOCFQ
      KLOCIF = JLOCIF
      KLOCFY = JLOCF
      KCOR0 = ICOR0
C                                       Reformat table?
      CALL FGREFM (DISKIN, CNOIN, FLAGV, CATIN, IFLUN, IERR)
      CALL FLGINI ('READ', FGBUFF, DISKIN, CNOIN, FLAGV, CATIN,
     *   IFLUN, IFGRNO, FGKOLS, FGNUMV, IERR)
      IF (IERR.NE.0) DOFLAG = .FALSE.
C                                       Resort if necessary.
      IF ((DOFLAG) .AND. (FGBUFF(43).NE.KEY(1,1))) THEN
C                                       Sort to time order.
         CALL TABIO ('CLOS', 0, K, SCRTCH, FGBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL TABSRT (DISKIN, CNOIN, 'FG', FLAGV, FLAGV, KEY, KEYSUB,
     *      FKEY, FGBUFF, CATIN, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Re initialize.
         CALL FLGINI ('READ', FGBUFF, DISKIN, CNOIN, FLAGV, CATIN,
     *      IFLUN, IFGRNO, FGKOLS, FGNUMV, IERR)
         END IF
      IF (DOFLAG) THEN
         WRITE (MSGTXT,1000) FLAGV
      ELSE
         MSGTXT = 'No flag table is applied this time'
         END IF
      CALL MSGWRT (3)
      IRET = 0
      IF (.NOT.DOFLAG) IRET = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Applying flag table version',I4,' to the table data')
      END
      SUBROUTINE TYFCOP (DISKI, CNOI, DISKO, CNOO, IVER, OVER, CATIN,
     *   CATOUT, LUNI, LUNO, DDFLAG, BUFFER, OBUFF, IRET)
C-----------------------------------------------------------------------
C   Copies a TY table with flagging
C   Inputs:
C      DISKI    I        Input volume number
C      CNOI     I        Input catalog number
C      DISKO    I        Output volume number
C      CNOO     I        Output catalog number
C      IVER     I        Version to read
C      OVER     I        Version to write
C      CATIN    I(256)   Input catalog header
C      CATOUT   I(256)   Output catalog header
C      LUNI     I        LUN to use
C      LUNO     I        LUN to use
C      DDFLAG   I        > 0 copy fully flagged
C   Input/Output:
C      CATOUT   I(256)   Output catalog header
C      BUFFER   I(*)     Work buffer
C      OBUFF    I(*)     Work buffer
C   Output:
C      IRET     I        Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER DISKI, CNOI, DISKO, CNOO, IVER, OVER, CATIN(256),
     *   CATOUT(256), LUNI, LUNO, BUFFER(*), OBUFF(*), IRET
      REAL    DDFLAG
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ITYRNO, TYKOLS(MAXTYC), TYNUMV(MAXTYC), NUMPOL, NUMIF,
     *   OKOLS(MAXTYC), ONUMV(MAXTYC), NTYROW, I, SOURID, ANTNO,
     *   SUBA, FREQID, OTYRNO, NDEL, NTOT, JRET
      REAL      TIME, TIMEI, TSYS(2,MAXIF), TANT(2,MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
C-----------------------------------------------------------------------
C                                       open flag table
      TMFLST = -1.E20
      NUMFLG = 0
      IFGRNO = 1
      NDEL = 0
      NTOT = 0
C                                       Open TY file
      CALL TYINI ('READ', BUFFER, DISKI, CNOI, IVER, CATIN, LUNI,
     *   ITYRNO, TYKOLS, TYNUMV, NUMPOL, NUMIF, IRET)
      IF (IRET.EQ.2) THEN
         IRET = 0
         GO TO 999
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       # rows in old table
      NTYROW = BUFFER(5)
C                                       Open up new TY table
      CALL TYINI ('WRIT', OBUFF, DISKO, CNOO, OVER, CATOUT, LUNO,
     *   OTYRNO, OKOLS, ONUMV, NUMPOL, NUMIF, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 100 I = 1,NTYROW
         CALL TABTY ('READ', BUFFER, ITYRNO, TYKOLS, TYNUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, TSYS, TANT,
     *      IRET)
C                                       Error reading table
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1020) IRET
            GO TO 990
C                                       check subarray, time
         ELSE IF (IRET.EQ.0) THEN
            CALL TYFLG (NUMPOL, NUMIF, TIME, SOURID, ANTNO, SUBA,
     *         FREQID, TSYS, TANT, JRET)
            IF (JRET.GT.0) THEN
               IRET = JRET
               GO TO 999
               END IF
            IF (JRET.LT.0) NDEL = NDEL + 1
C                                       Write new one
            IF ((JRET.EQ.0) .OR. (DDFLAG.GT.0.0)) THEN
               NTOT = NTOT + 1
               CALL TABTY ('WRIT', OBUFF, OTYRNO, OKOLS, ONUMV, NUMPOL,
     *            NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID,
     *            TSYS, TANT, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1020) IRET
                  GO TO 990
                  END IF
               END IF
            END IF
 100     CONTINUE
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ITYRNO, TSYS, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OTYRNO, TSYS, OBUFF, IRET)
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         WRITE (MSGTXT,1100) 'Copied TY', DISKI, CNOI, IVER, DISKO,
     *      CNOO, OVER
         CALL MSGWRT (3)
         WRITE (MSGTXT,1101) NDEL, NTYROW
         CALL REFRMT (MSGTXT, '_', I)
         CALL MSGWRT (3)
         IF ((DDFLAG.GT.0.0) .AND. (NDEL.GT.0)) THEN
            MSGTXT = '   Copied all records anyway'
            CALL MSGWRT (3)
            END IF
         END IF
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('TYFSEL: ERROR ',I3,' RETURNED FROM TYINI')
 1020 FORMAT ('TYFSEL: ERROR ',I3,' RETURNED FROM TABTY')
 1100 FORMAT (A,' file from vol/cno/vers',I3,I5,I4,' to',I3,I5,I4)
 1101 FORMAT ('__Fully deleted',I10,' of',I12,' TY records applying',
     *   ' flag table')
      END
      SUBROUTINE TYFLG (NPOL, NIF, TIME, SOURID, ANTNO, SUBA, FREQID,
     *   TSYS, TANT, IRET)
C-----------------------------------------------------------------------
C   Flags a TY table row based on the flags in FG table loaded to Common
C   Inputs:
C      NPOL     I      Number polarizations in TY data
C      NIF      I      Number of IFs in those data
C      TIME     R      Time of table row
C      SOURID   I      Source number of row
C      ANTNO    I      Antenna number of row
C      SUBA     I      Subarray of row
C      FREQID   I      Frequency ID if row
C   In/Out:
C      TSYS     R(*)   System temperature array - flagged -> FBLANK
C      TANT     R(*)   Antenna temperature array
C   Inputs from include DSEL.INC:
C      NUMFLG     I    Number of flagging entries.
C      TMFLST     R    Time of last visibility for which flagging
C                      was checked.
C      FLGSOU(*)  I    Source id numbers to flag, 0=all.
C      FLGANT(*)  I    Antenna numbers to flag, 0=all.
C      FLGBAS(*)  I    Baseline (A1*32768+A2) numbers to flag, 0=all.
C      FLGSUB(*)  I    Subarray numbers to flag, 0=all.
C      FLGFQD(*)  I    Freqid numbers to flag, <=0=all.
C                      Following should have defaults filled in.
C      FLGBIF(*)  I    First IF to flag.
C      FLGEIF(*)  I    Highest IF to flag.
C      FLGBCH(*)  I    First channel to flag.
C      FLGECH(*)  I    Highest channel to flag.
C      FLGPOL(4,*)L    Flags for the polarizations, should correspond
C                      to selected polarization types.
C   Output:
C      IRET     I      0 -> okay, -1 -> all flagged
C-----------------------------------------------------------------------
      INTEGER   NPOL, NIF, SOURID, ANTNO, SUBA, FREQID, IRET
      REAL      TIME, TSYS(2,*), TANT(2,*)
C
      INTEGER   IFLAG, FLGA, JPOLN, JIF, LIMF1, LIMF2, IPOLPT
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (TMFLST.LT.TIME) CALL NXTFLG (TIME, .TRUE., IRET)
      IF (IRET.NE.0) GO TO 999
      IF (NUMFLG.LE.0) GO TO 999
C                                       loop over current flags
      DO 50 IFLAG = 1,NUMFLG
C                                       Check time if needed
         IF ((TIME.LT.FLGTST(IFLAG)) .OR. (TIME.GT.FLGTND(IFLAG)))
     *      GO TO 50
C                                       Check source
         IF ((FLGSOU(IFLAG).NE.SOURID) .AND. (FLGSOU(IFLAG).NE.0) .AND.
     *      (SOURID.NE.0)) GO TO 50
C                                       Check antenna
         FLGA = FLGANT(IFLAG)
         IF ((FLGA.NE.0) .AND. (FLGA.NE.ANTNO)) GO TO 50
C                                       Check subarray
         IF ((FLGSUB(IFLAG).GT.0) .AND. (FLGSUB(IFLAG).NE.SUBA))
     *      GO TO 50
C                                       Check freqid.: may be changed
C                                       from input to 1 already
         IF ((FLGFQD(IFLAG).GT.0) .AND. (FLGFQD(IFLAG).NE.FREQID) .AND.
     *      (FREQID.GT.0)) GO TO 50
C                                       Some data to be flagged
C                                       Set limits
         LIMF1 = FLGBIF(IFLAG)
         LIMF2 = FLGEIF(IFLAG)
C                                       Loop over polarizations
         IPOLPT = ABS(KCOR0) - 1
         IF (KCOR0.LT.-4) IPOLPT = IPOLPT - 4
         DO 40 JPOLN = 1,NPOL
            IF (FLGPOL(JPOLN+IPOLPT,IFLAG)) THEN
C                                       Loop over IF
               DO 30 JIF = LIMF1,LIMF2
                  TSYS(JPOLN,JIF) = FBLANK
                  TANT(JPOLN,JIF) = FBLANK
 30               CONTINUE
               END IF
 40         CONTINUE
 50      CONTINUE
C                                       Check if data all
      DO 70 JPOLN = 1,NPOL
         DO 60 JIF = 1,NIF
            IF ((TSYS(JPOLN,JIF).NE.FBLANK) .OR.
     *         (TANT(JPOLN,JIF).NE.FBLANK)) GO TO 999
 60         CONTINUE
 70      CONTINUE
      IRET = -1
C
 999  RETURN
      END
      SUBROUTINE SNFCOP (DISKI, CNOI, DISKO, CNOO, IVER, OVER, CATIN,
     *   CATOUT, LUNI, LUNO, DDFLAG, BUFFER, OBUFF, IRET)
C-----------------------------------------------------------------------
C   Copies an subset of IFs in a SN table, can also modify the FQ ID
C   Applies flagging as well
C   Inputs:
C      DISKI    I        Input volume number
C      CNOI     I        Input catalog number
C      DISKO    I        Output volume number
C      CNOO     I        Output catalog number
C      VER      I        Version to check/modify
C      CATIN    I(256)   Input catalog header
C      CATOUT   I(256)   Output catalog header
C      LUNI     I        LUN to use
C      LUNO     I        LUN to use
C   Input/Output:
C      BUFFER   I(*)     Work buffer
C      OBUFF    I(*)     Work buffer
C   Output:
C      IRET     I        Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER   DISKI, CNOI, DISKO, CNOO, IVER, OVER, CATIN(256),
     *   CATOUT(256), LUNI, LUNO, BUFFER(*), OBUFF(*), IRET
      REAL      DDFLAG
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ISNRNO, SNKOLS(MAXSNC), SNNUMV(MAXSNC), NUMANT, NUMPOL,
     *   NUMIF, NUMNOD, OKOLS(MAXSNC), ONUMV(MAXSNC), NSNROW, I,
     *   SOURID, ANTNO, SUBA, FREQID, NODENO, REFA(2,MAXIF), OSNRNO,
     *   NDEL, NTOT, JRET
      LOGICAL   ISAPPL
      REAL      GMMOD, RANOD(25), DECNOD(25), TIMEI, IFR, MBDELY(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF),
     *   WEIGHT(2,MAXIF), DISP(2), DDISP(2)
      DOUBLE PRECISION TIME
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
C-----------------------------------------------------------------------
C                                       open flag table
      TMFLST = -1.E20
      NUMFLG = 0
      IFGRNO = 1
      NDEL = 0
      NTOT = 0
C                                       Open SN file
      CALL SNINI ('READ', BUFFER, DISKI, CNOI, IVER, CATIN, LUNI,
     *   ISNRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD,
     *   GMMOD, RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.EQ.2) THEN
         IRET = 0
         GO TO 999
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       # rows in old table
      NSNROW = BUFFER(5)
C                                       Open up new SN table
      CALL SNINI ('WRIT', OBUFF, DISKO, CNOO, OVER, CATOUT, LUNO,
     *   OSNRNO, OKOLS, ONUMV, NUMANT, NUMPOL, NUMIF, NUMNOD,
     *   GMMOD, RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 100 I = 1,NSNROW
         CALL TABSN ('READ', BUFFER, ISNRNO, SNKOLS, SNNUMV, NUMPOL,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
C                                       check subarray and FQ
C                                       Error reading table
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1020) IRET
            GO TO 990
         ELSE IF (IRET.EQ.0) THEN
            CALL SNFLG (NUMPOL, NUMIF, TIME, SOURID, ANTNO, SUBA,
     *         FREQID, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, JRET)
            IF (JRET.GT.0) THEN
               IRET = JRET
               GO TO 999
               END IF
C                                       Select IFs
            IF (JRET.LT.0) NDEL = NDEL + 1
C                                       Write new one
            IF ((JRET.EQ.0) .OR. (DDFLAG.GT.0.0)) THEN
               NTOT = NTOT + 1
               CALL TABSN ('WRIT', OBUFF, OSNRNO, OKOLS, ONUMV, NUMPOL,
     *            TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *            MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE,
     *            WEIGHT, REFA, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1020) IRET
                  GO TO 990
                  END IF
               END IF
            END IF
 100     CONTINUE
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ISNRNO, CREAL, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OSNRNO, CREAL, OBUFF, IRET)
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         WRITE (MSGTXT,1100) 'Copied SN', DISKI, CNOI, IVER, DISKO,
     *      CNOO, OVER
         CALL MSGWRT (3)
         WRITE (MSGTXT,1101) NDEL, NSNROW
         CALL REFRMT (MSGTXT, '_', I)
         CALL MSGWRT (3)
         IF ((DDFLAG.GT.0.0) .AND. (NDEL.GT.0)) THEN
            MSGTXT = '   Copied all records anyway'
            CALL MSGWRT (3)
            END IF
         END IF
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SNSEL: ERROR ',I3,' RETURNED FROM SNINI')
 1020 FORMAT ('SNSEL: ERROR ',I3,' RETURNED FROM TABSN')
 1100 FORMAT (A,' file from vol/cno/vers',I3,I5,I4,' to',I3,I5,I4)
 1101 FORMAT ('__Fully deleted',I10,' of',I12,' SN records applying',
     *   ' flag table')
      END
      SUBROUTINE SNFLG (NPOL, NIF, TIME, SOURID, ANTNO, SUBA,
     *   FREQID, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
C-----------------------------------------------------------------------
C   Flags a SN table row based on the flags in FG table loaded to Common
C   Inputs:
C      NPOL     I        Number polarizations in TY data
C      NIF      I        Number of IFs in those data
C      TIME     D        Time of table row
C      SOURID   I        Source number of row
C      ANTNO    I        Antenna number of row
C      SUBA     I        Subarray of row
C      FREQID   I        Frequency ID if row
C   In/Out:
C      CREAL    R(2,*)   Real part of solution
C      CIMAG    R(2,*)   Imaginary part of solution
C      DELAY    R(2,*)   Delay
C      RATE     R(2,*)   Rate
C      WEIGHT   R(2,*)   Solution weight
C      REFA     I(2,*)   Reference antenna
C   Inputs from include DSEL.INC:
C      NUMFLG     I    Number of flagging entries.
C      TMFLST     R    Time of last visibility for which flagging
C                      was checked.
C      FLGSOU(*)  I    Source id numbers to flag, 0=all.
C      FLGANT(*)  I    Antenna numbers to flag, 0=all.
C      FLGBAS(*)  I    Baseline (A1*32768+A2) numbers to flag, 0=all.
C      FLGSUB(*)  I    Subarray numbers to flag, 0=all.
C      FLGFQD(*)  I    Freqid numbers to flag, <=0=all.
C                      Following should have defaults filled in.
C      FLGBIF(*)  I    First IF to flag.
C      FLGEIF(*)  I    Highest IF to flag.
C      FLGBCH(*)  I    First channel to flag.
C      FLGECH(*)  I    Highest channel to flag.
C      FLGPOL(4,*)L    Flags for the polarizations, should correspond
C                      to selected polarization types.
C   Output:
C      IRET     I      0 -> okay, -1 -> all flagged
C-----------------------------------------------------------------------
      DOUBLE PRECISION TIME
      INTEGER   NPOL, NIF, SOURID, ANTNO, SUBA, FREQID, REFA(2,*), IRET
      REAL      CREAL(2,*), CIMAG(2,*), DELAY(2,*), RATE(2,*),
     *   WEIGHT(2,*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IFLAG, FLGA, JPOLN, JIF, LIMF1, LIMF2, IPOLPT
      REAL      RTIME
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
      RTIME = TIME
      IF (TMFLST.LT.TIME) CALL NXTFLG (RTIME, .TRUE., IRET)
      IF (IRET.NE.0) GO TO 999
      IF (NUMFLG.LE.0) GO TO 999
C                                       loop over current flags
      DO 50 IFLAG = 1,NUMFLG
C                                       Check time if needed
         IF ((TIME.LT.FLGTST(IFLAG)) .OR. (TIME.GT.FLGTND(IFLAG)))
     *      GO TO 50
C                                       Check source
         IF ((FLGSOU(IFLAG).NE.SOURID) .AND. (FLGSOU(IFLAG).NE.0) .AND.
     *      (SOURID.NE.0)) GO TO 50
C                                       Check antenna
         FLGA = FLGANT(IFLAG)
         IF ((FLGA.NE.0) .AND. (FLGA.NE.ANTNO)) GO TO 50
C                                       Check subarray
         IF ((FLGSUB(IFLAG).GT.0) .AND. (FLGSUB(IFLAG).NE.SUBA))
     *      GO TO 50
C                                       Check freqid.: may be changed
C                                       from input to 1 already
         IF ((FLGFQD(IFLAG).GT.0) .AND. (FLGFQD(IFLAG).NE.FREQID) .AND.
     *      (FREQID.GT.0)) GO TO 50
C                                       Some data to be flagged
C                                       Set limits
         LIMF1 = FLGBIF(IFLAG)
         LIMF2 = FLGEIF(IFLAG)
C                                       Loop over polarizations
         IPOLPT = ABS(KCOR0) - 1
         IF (KCOR0.LT.-4) IPOLPT = IPOLPT - 4
         DO 40 JPOLN = 1,NPOL
            IF (FLGPOL(JPOLN+IPOLPT,IFLAG)) THEN
C                                       Loop over IF
               DO 30 JIF = LIMF1,LIMF2
                  CREAL(JPOLN,JIF) = FBLANK
                  CIMAG(JPOLN,JIF) = FBLANK
                  DELAY(JPOLN,JIF) = FBLANK
                  RATE(JPOLN,JIF) = FBLANK
                  WEIGHT(JPOLN,JIF) = 0.0
                  REFA(JPOLN,JIF) = 0
 30               CONTINUE
               END IF
 40         CONTINUE
 50      CONTINUE
C                                       Check if data all gone
      DO 70 JPOLN = 1,NPOL
         DO 60 JIF = 1,NIF
            IF ((CREAL(JPOLN,JIF).NE.FBLANK) .AND.
     *         (CIMAG(JPOLN,JIF).NE.FBLANK)) GO TO 999
 60         CONTINUE
 70      CONTINUE
      IRET = -1
C
 999  RETURN
      END
      SUBROUTINE SYFCOP (DISKI, CNOI, DISKO, CNOO, IVER, OVER, CATIN,
     *   CATOUT, LUNI, LUNO, DDFLAG, BUFFER, OBUFF, IRET)
C-----------------------------------------------------------------------
C   Copies a subset of IFs in a SY table, can also modify the FQ ID
C   Inputs:
C      DISKI    I        Input volume number
C      CNOI     I        Input catalog number
C      DISKO    I        Output volume number
C      CNOO     I        Output catalog number
C      VER      I        Version to check/modify
C      CATIN    I(256)   Input catalog header
C      CATOUT   I(256)   Output catalog header
C      LUNI     I        LUN to use
C      LUNO     I        LUN to use
C   Input/Output:
C      BUFFER   I(*)     Work buffer
C      OBUFF    I(*)     Work buffer
C   Output:
C      IRET     I        Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER   DISKI, CNOI, DISKO, CNOO, IVER, OVER, CATIN(256),
     *   CATOUT(256), LUNI, LUNO, BUFFER(*), OBUFF(*), IRET
      REAL    DDFLAG
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ISYRNO, SYKOLS(MAXSYC), SYNUMV(MAXSYC), NUMANT, NUMPOL,
     *   NUMIF, OKOLS(MAXSYC), ONUMV(MAXSYC), NSYROW, I, SOURID, ANTNO,
     *   SUBA, FREQID, OSYRNO, NDEL, NTOT, JRET, NPART, CALTYP
      REAL      PDIFF(2,MAXIF), PSUM(2,MAXIF), PGAIN(2,MAXIF), TIMEI
      DOUBLE PRECISION TIME
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
C-----------------------------------------------------------------------
C                                       open flag table
      TMFLST = -1.E20
      NUMFLG = 0
      IFGRNO = 1
      NDEL = 0
      NTOT = 0
      NPART = 0
C                                       Open SY file
      CALL SYINI ('READ', BUFFER, DISKI, CNOI, IVER, CATIN, LUNI,
     *   ISYRNO, SYKOLS, SYNUMV, NUMANT, NUMPOL, NUMIF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       # rows in old table
      NSYROW = BUFFER(5)
C                                       Open up new SY table
      CALL SYINI ('WRIT', OBUFF, DISKO, CNOO, OVER, CATOUT, LUNO,
     *   OSYRNO, OKOLS, ONUMV, NUMANT, NUMPOL, NUMIF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 100 I = 1,NSYROW
         CALL TABSY ('READ', BUFFER, ISYRNO, SYKOLS, SYNUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA, FREQID,
     *      PDIFF, PSUM, PGAIN, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1030) IRET
            GO TO 990
C                                       flag info
         ELSE IF (IRET.EQ.0) THEN
            CALL SYFLG (NUMPOL, NUMIF, TIME, SOURID, ANTNO, SUBA,
     *         FREQID, PDIFF, PSUM, PGAIN, NPART, JRET)
            IF (JRET.GT.0) THEN
               IRET = JRET
               GO TO 999
               END IF
            IF (JRET.LT.0) NDEL = NDEL + 1
C                                       Write new one
            IF ((JRET.EQ.0) .OR. (DDFLAG.GT.0.0)) THEN
               NTOT = NTOT + 1
               CALL TABSY ('WRIT', OBUFF, OSYRNO, OKOLS, ONUMV, NUMPOL,
     *            NUMIF, TIME, TIMEI, CALTYP, SOURID, ANTNO, SUBA,
     *            FREQID, PDIFF, PSUM, PGAIN, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1040) IRET
                  GO TO 990
                  END IF
               END IF
            END IF
 100     CONTINUE
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ISYRNO, PDIFF, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OSYRNO, PDIFF, OBUFF, IRET)
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         WRITE (MSGTXT,1100) 'Copied SY', DISKI, CNOI, IVER, DISKO,
     *      CNOO, OVER
         CALL MSGWRT (3)
         WRITE (MSGTXT,1101) NDEL, NSYROW
         CALL REFRMT (MSGTXT, '_', I)
         CALL MSGWRT (3)
         IF ((DDFLAG.GT.0.0) .AND. (NDEL.GT.0)) THEN
            MSGTXT = '   Copied all records anyway'
            CALL MSGWRT (3)
            END IF
         END IF
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SYFSEL: ERROR ',I3,' INITING OLD TABLE')
 1020 FORMAT ('SYFSEL: ERROR ',I3,' INITING NEW TABLE')
 1030 FORMAT ('SYFSEL: ERROR ',I3,' READING OLD TABLE')
 1040 FORMAT ('SYFSEL: ERROR ',I3,' WRITING NEW TABLE')
 1100 FORMAT (A,' file from vol/cno/vers',I3,I5,I4,' to',I3,I5,I4)
 1101 FORMAT ('__Fully deleted',I10,' of',I12,' SY records applying',
     *   ' flag table')
      END
      SUBROUTINE SYFLG (NPOL, NIF, TIME, SOURID, ANTNO, SUBA,
     *   FREQID, PDIFF, PSUM, PGAIN, NPART, IRET)
C-----------------------------------------------------------------------
C   Flags a TY table row based on the flags in FG table loaded to Common
C   Inputs:
C      NPOL     I      Number polarizations in TY data
C      NIF      I      Number of IFs in those data
C      TIME     R      Time of table row
C      SOURID   I      Source number of row
C      ANTNO    I      Antenna number of row
C      SUBA     I      Subarray of row
C      FREQID   I      Frequency ID if row
C   In/Out:
C      PDIFF    R(*)   Pon-Poff
C      PSUM     R(*)   Pon+Poff
C      PGAIN    R(*)   Post detection gains
C      NPART    I      count of partly flagged records
C   Inputs from include DSEL.INC:
C      NUMFLG     I    Number of flagging entries.
C      TMFLST     R    Time of last visibility for which flagging
C                      was checked.
C      FLGSOU(*)  I    Source id numbers to flag, 0=all.
C      FLGANT(*)  I    Antenna numbers to flag, 0=all.
C      FLGBAS(*)  I    Baseline (A1*32768+A2) numbers to flag, 0=all.
C      FLGSUB(*)  I    Subarray numbers to flag, 0=all.
C      FLGFQD(*)  I    Freqid numbers to flag, <=0=all.
C                      Following should have defaults filled in.
C      FLGBIF(*)  I    First IF to flag.
C      FLGEIF(*)  I    Highest IF to flag.
C      FLGBCH(*)  I    First channel to flag.
C      FLGECH(*)  I    Highest channel to flag.
C      FLGPOL(4,*)L    Flags for the polarizations, should correspond
C                      to selected polarization types.
C   Output:
C      IRET     I      0 -> okay, -1 -> all flagged
C-----------------------------------------------------------------------
      INTEGER   NPOL, NIF, SOURID, ANTNO, SUBA, FREQID, NPART, IRET
      REAL      PDIFF(2,*), PSUM(2,*), PGAIN(2,*)
      DOUBLE PRECISION TIME
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IFLAG, FLGA, JPOLN, JIF, LIMF1, LIMF2, IPOLPT
      REAL      RTIME
      LOGICAL   PART
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
      RTIME = TIME
      IF (TMFLST.LT.TIME) CALL NXTFLG (RTIME, .TRUE., IRET)
      IF (IRET.NE.0) GO TO 999
      IF (NUMFLG.LE.0) GO TO 999
      PART = .FALSE.
C                                       loop over current flags
      DO 50 IFLAG = 1,NUMFLG
C                                       Check time if needed
         IF ((TIME.LT.FLGTST(IFLAG)) .OR. (TIME.GT.FLGTND(IFLAG)))
     *      GO TO 50
C                                       Check source
         IF ((FLGSOU(IFLAG).NE.SOURID) .AND. (FLGSOU(IFLAG).NE.0) .AND.
     *      (SOURID.NE.0)) GO TO 50
C                                       Check antenna
         FLGA = FLGANT(IFLAG)
         IF ((FLGA.NE.0) .AND. (FLGA.NE.ANTNO)) GO TO 50
C                                       Check subarray
         IF ((FLGSUB(IFLAG).GT.0) .AND. (FLGSUB(IFLAG).NE.SUBA))
     *      GO TO 50
C                                       Check freqid.: may be changed
C                                       from input to 1 already
         IF ((FLGFQD(IFLAG).GT.0) .AND. (FLGFQD(IFLAG).NE.FREQID) .AND.
     *      (FREQID.GT.0)) GO TO 50
C                                       Some data to be flagged
C                                       Set limits
         LIMF1 = FLGBIF(IFLAG)
         LIMF2 = FLGEIF(IFLAG)
C                                       Loop over polarizations
         IPOLPT = ABS(KCOR0) - 1
         IF (KCOR0.LT.-4) IPOLPT = IPOLPT - 4
         DO 40 JPOLN = 1,NPOL
            IF (FLGPOL(JPOLN+IPOLPT,IFLAG)) THEN
               PART = .TRUE.
C                                       Loop over IF
               DO 30 JIF = LIMF1,LIMF2
                  PDIFF(JPOLN,JIF) = FBLANK
                  PSUM(JPOLN,JIF) = FBLANK
                  PGAIN(JPOLN,JIF) = FBLANK
 30               CONTINUE
               END IF
 40         CONTINUE
 50      CONTINUE
C                                       Check if data all flagged
      IF (PART) NPART = NPART + 1
      DO 70 JPOLN = 1,NPOL
         DO 60 JIF = 1,NIF
            IF ((PDIFF(JPOLN,JIF).NE.FBLANK) .OR.
     *         (PSUM(JPOLN,JIF).NE.FBLANK)) GO TO 999
 60         CONTINUE
 70      CONTINUE
      IF (PART) NPART = NPART - 1
      IRET = -1
C
 999  RETURN
      END

      PROGRAM IMLHS
C-----------------------------------------------------------------------
C! Makes false color display on TV of up to 3 images
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998-1999, 2002, 2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   IMLHS uses up to 3 maps to create a false (but not pseudo) color
C   image on the TV.  It uses the first map to modulate the brightness
C   of the image, the 2nd to modulate the hue, and the 3rd to modulate
C   the saturation.  If any of the INNAMEs are missing, the corres-
C   ponding parameter is set to a constant.
C   Inputs: adverbs from AIPS -
C   USERID             Input map user ID
C   INNAME(3)          Input map name
C   INCLASS(2)         Input map class
C   INSEQ              First input map seq no.
C   INDISK             Input map disk: 0 = any
C   IN2NAME(3)         IN2put map name default INNAME
C   IN2CLASS(2)        IN2put map class default INCLASS
C   IN2SEQ             IN2put map seq no. 0 => lowest unique
C   IN2DISK            IN2put map disk
C   IN3NAME(3)         Saturation map name
C   IN3CLASS(2)        Saturation map class
C   IN3SEQ             Saturation map seq. no.
C   IN3DISK            Saturation map disk
C   BLC(7)             Bottom left corner all input maps
C   TRC(7)             Top right corner all input maps
C   TVCORN(2)          Image corners on TV
C   FUNCTYPE           'LG'=logrithmic, otherwise linear
C   APARM(10)           ?
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER NAMS(3)*36, ONCODE(2)*4, PRGNAM*6, MTYPE(3)*12,
     *   SUBS(10)*8, CHTM4*4
      HOLLERITH XMA
      REAL      RPARM(46), IN(MAXIMG,3), IHDR4(256),DMAX(3), DMIN(3),
     *   PIXR(2,3), BLC(7), TRC(7), TVCORN(2), TVC(2), SCALE(3), OFF(3),
     *   XRANGE(2,3), IMDEF(3), HUE0, HUEFUN, SATFUN, XIFUN
      LOGICAL   LLOG, LSQRT, ISMAP(3)
      INTEGER   ERROR, NSUB, IROUND, IHDR(256), NRET, EOM, LUNSL(3),
     *   IERR, IYTV, OUT(MAXIMG), IPL(3), NBYTES, NLINES, IM, IP, IX,
     *   ID, IXTV, NPIX, ICOLOR, NPARM
      DOUBLE PRECISION IHDR8(128)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DBUF.INC'
      EQUIVALENCE (IHDR, IHDR4, IHDR8)
      EQUIVALENCE (BLC, RPARM(23)),       (TRC, RPARM(30))
      EQUIVALENCE (TVCORN, RPARM(37)),    (PIXR, RPARM(40))
      EQUIVALENCE (HUE0, RPARM(46))
      EQUIVALENCE (OUT, RBUF(6145))
      DATA PRGNAM /'IMLHS '/
      DATA LUNSL /18,19,20/
      DATA ONCODE /'ONNN', 'OFFF'/
      DATA MTYPE /'INTENSITY   ', '         HUE', 'SATURATION  '/
      DATA IMDEF /1., 1., 1./
      DATA IPL /1, 2, 3/
      DATA EOM /9/
      DATA SUBS /'GTPARM  ', 'OPENCF  ',
     *   'GETHDR  ', 'MAPIO   ', 'WINDOW  ', 'TVOPEN  ', 'MAPWIN  ',
     *   'MINIT   ', 'MDISK   ', 'YIMGIO  '/
C-----------------------------------------------------------------------
C                                       Task init, get parms
      NRET = 0
C                                       Fixed PPM 1996.09.30: was 46
      NPARM = 50
      NSUB = 1
      CALL TSKBEG (PRGNAM, NPARM, RPARM(2), ERROR)
      IF (ERROR.NE.0) GO TO 980
      WRITE (MSGTXT,4000)
      CALL MSGWRT (2)
      RPARM(1) = NLUSER
C                                       Set up file NAMEstrings
      CALL CHR2H (4, 'MA  ', 1, XMA)
      DO 10 IM = 1,3
         CALL H2WAWA (RPARM(7*IM-5), RPARM(7*IM-2), RPARM(7*IM),
     *      XMA,  RPARM(7*IM+1), RPARM(1), NAMS(IM))
C                                       Does this input map exist?
         ISMAP(IM) = NAMS(IM)(1:12) .EQ. '            '
         IF (ISMAP(IM)) GO TO 10
            NSUB = 2
            CALL OPENCF (LUNSL(IM), NAMS(IM), ERROR)
            IF (ERROR.NE.0) GO TO 980
            NSUB = 3
            CALL GETHDR (LUNSL(IM), IHDR, ERROR)
            IF (ERROR.NE.0) GO TO 980
            DMAX(IM) = IHDR4(KRDMX)
            DMIN(IM) = IHDR4(KRDMN)
 10      CONTINUE
C                                      Open TV
      NSUB = 6
      CALL TVOPEN (IN, ERROR)
      IF (ERROR.NE.0) GO TO 980
      CALL YINIT (IN, ERROR)
C                                      Set up TV colors
      DO 20 IP = 1,NGRAY
         CALL YSLECT (ONCODE(2), IP, 0, OUT, ERROR)
 20      CONTINUE
      DO 30 IP = 1,3
         CALL YSLECT (ONCODE(1), IP, IP, OUT, ERROR)
 30      CONTINUE
      DO 40 IM = 1,3
         IF (ISMAP(IM)) GO TO 40
            WRITE (MSGTXT,1040) MTYPE(IM)
            CALL MSGWRT (3)
            CALL PRTNAM (NAMS(IM), 3)
 40      CONTINUE
C                                Rationalize window
      CALL WINDOW (IHDR(KIDIM), IHDR(KINAX), BLC, TRC, ERROR)
C                                Adjust window so image fits screen
      DO 50 ID = 1,2
         TVC(ID) = TVCORN(ID)
         IF ((TVC(ID).LE.0.) .OR. (TVC(ID).GT.MAXXTV(ID)))
     *      TVC(ID) = 1.
         BLC(ID) = MAX (BLC(ID), 0.5*(BLC(ID)+TRC(ID)-MAXXTV(ID)
     *      +TVC(ID)))
         TRC(ID) = MIN (TRC(ID), BLC(ID)+MAXXTV(ID)-TVC(ID))
C                                 If TVC=0 center image
         IF ((TVCORN(ID).GT.0.) .AND. (TVCORN(ID).LT.MAXXTV(ID)))
     *      GO TO 50
         TVC(ID) = 1. + 0.5 * (MAXXTV(ID) - 1. + BLC(ID) - TRC(ID))
 50      CONTINUE
      IYTV = TVC(2)
      IXTV = TVC(1)
C                                    Set windows internally
      NSUB = 7
      DO 70 IM = 1,3
         IF (ISMAP(IM)) GO TO 70
            CALL MAPWIN (LUNSL(IM), BLC, TRC, ERROR)
            IF (ERROR.NE.0) GO TO 980
 70      CONTINUE
      NPIX = IROUND (1.+TRC(1)-BLC(1))
      CALL H2CHR (4, 1, RPARM(39), CHTM4)
      LLOG = CHTM4(1:2) .EQ. 'LG'
      LSQRT = CHTM4(1:2) .EQ. 'SQ'
C                                    Set scale factors
      DO 80 IM = 1,3
         IF (ISMAP(IM)) GO TO 80
            CALL RNGSET (PIXR(1,IM), DMAX(IM), DMIN(IM), XRANGE(1,IM))
            SCALE(IM) = 1./(XRANGE(2,IM) - XRANGE(1,IM))
            OFF(IM)   = -XRANGE(1,IM)
 80      CONTINUE
C                                  Start TV output
      NLINES = 3 * IROUND (1. + TRC(2) - BLC(2))
      NBYTES = 8192
      NSUB = 8
C                                   Read loop for maps
 200  CONTINUE
         DO 250 IM = 1,3
            IF (ISMAP(IM)) GO TO 230
               NSUB = 4
               CALL MAPIO ('READ', LUNSL(IM), IN(1,IM), ERROR)
C                                   Test on end of map
               IF (ERROR.EQ.EOM) GO TO 290
               IF (ERROR.NE.0) GO TO 980
C                                    Scale Lum and Hue and Sat
               DO 210 IX = 1,NPIX
                  IN(IX,IM) = SCALE(IM) * (IN(IX,IM) + OFF(IM))
 210              CONTINUE
               GO TO 250
C                                      Fill in default if no map
 230        CONTINUE
               DO 240 IX = 1,NPIX
                  IN(IX,IM) = IMDEF(IM)
 240              CONTINUE
 250        CONTINUE
C                                     Offset hue if desired
         IF (HUE0.EQ.0.) GO TO 265
            DO 260 IX = 1,NPIX
               IN(IX,2) = IN(IX,2) + HUE0
 260           CONTINUE
 265     DO 280 ICOLOR = 1,3
            NSUB = 10
            DO 270 IX = 1,NPIX
               IN(IX,2) = IN(IX,2) - 0.33333
               HUEFUN = IN(IX,2)
               HUEFUN = HUEFUN - INT(HUEFUN)
               IF (HUEFUN.LT.0.) HUEFUN = 1. + HUEFUN
               HUEFUN = MIN (1., MAX (0., 1.-3.* ABS(0.33333-HUEFUN)))
               SATFUN = MIN (1., MAX (0., IN(IX,3)))
               HUEFUN = SQRT (SATFUN * HUEFUN + 0.33333 * (1. - SATFUN))
C                                   SQRT simulates gamma correction
C                                   should be **1/gamma = **0.4
               XIFUN = MAX (0., MIN (1., IN(IX, 1)))
               IF (LLOG) XIFUN = LOG10 (1. + 9. * XIFUN)
               IF (LSQRT) XIFUN = SQRT (XIFUN)
               OUT(IX) = MAXINT * HUEFUN * XIFUN
 270           CONTINUE
            CALL YIMGIO ('WRIT', IPL(ICOLOR), IXTV, IYTV, 0, NPIX,
     *         OUT, ERROR)
            IF (ERROR.NE.0) GO TO 980
 280        CONTINUE
         IYTV = IYTV + 1
         GO TO 200
C                                       Close files
 290  IF (ERROR.EQ.EOM) ERROR = 0
      DO 400 IM = 1,3
         CALL FILCLS (LUNSL(IM))
 400     CONTINUE
      CALL TVCLOS (IN, IERR)
C                                       Report any errors
      IF (ERROR.EQ.0) ERROR = IERR
      IF (ERROR.EQ.0) GO TO 990
C                                       Print error message
 980  WRITE (MSGTXT,1980) SUBS(NSUB), ERROR
      CALL MSGWRT (8)
C                                       Print offending file
      CALL PRTNAM (NAMS(IM), 8)
      NRET = 16
C                                       go home
 990  CALL TSKEND (NRET)
C
 999  STOP
C-----------------------------------------------------------------------
 1040 FORMAT (A12, ' MAP')
 1980 FORMAT (A6,' ERROR NO ',I6)
 4000 FORMAT ('You are using a non-standard program')
         END

LOCAL INCLUDE 'XTRAN.INC'
C                                       Local include for XTRAN
      INTEGER   NPNTS, NLINES, X0, Y0, NLSQ, NPAR
      REAL      XSEQI, XDISKI, XSEQO, XDISKO, BLC(7), TRC(7), XPAR,
     *   DOUTP, CSN, SN, DX, DY, XINC, YINC, DMAX, DMIN, ANGL
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2), XINFIL(12)
      CHARACTER INFILE*48, INSTR*36, OUTSTR*36
      DOUBLE PRECISION A(6), B(6)
      COMMON /PARAM/ XNAMEI, XCLAIN, XSEQI, XDISKI, XNAMOU, XCLAOU,
     *   XSEQO, XDISKO, BLC, TRC, XPAR, DOUTP, XINFIL
      COMMON /RTN1/ CSN, SN, DX, DY, DMAX, DMIN, ANGL, NPAR
      COMMON /RTN2/ NPNTS, NLINES, X0, Y0
      COMMON /QUAD/ A, B, XINC, YINC, NLSQ
      COMMON /CHRCOM/ INFILE, INSTR, OUTSTR
LOCAL END
      PROGRAM XTRAN
C-----------------------------------------------------------------------
C! Find and apply coordinate transformation given pixel positions.
C# Map Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 1999-2000, 2004-2005, 2008-2010, 2012
C;  Copyright (C) 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Generalized coordinate transform routine.  Adapted from program
C   by C.B. Opal.
C   INPUTS:  Adverbs from AIPS
C     INNAME    H(3)   Input image name.
C     INCLASS   H(2)   Input image class.
C     INSEQ     R   Input image sequence.
C     INDISK    R   Disk number for input image.
C     OUTNAME   H(3)   Name of output image.
C     OUTCLASS  H(2)   Class of the output image.
C     OUTSEQ    R   Sequence number of the output image.
C     OUTDISK   R   Disk number for output image.
C     BLC       R(7)   Bottom left corner of input cube. 0=> 1,1,1
C     TRC       R(7)   Top right corner of input cube. 0=> max.
C     NPOINTS   R   Number of parameters (3 or 6) to be fit.
C     DOUTP     R   If true, do transform.
C     STRC2     H(12) Name of file with standard star postions.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   INLUN, OUTLUN, IHOTL, IHINL, IERR, BUF1(256), BUF2(256)
      LONGINT   NEWOFF, WTOFF
      REAL      NEWIM(2), NEWWT(2)
      INCLUDE 'XTRAN.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA PRGNAM /'XTRAN '/
      DATA INLUN, OUTLUN, IHOTL, IHINL /16,17,27,28/
C-----------------------------------------------------------------------
      DMAX = 0.0
C                                       Set up, get parms, open, create
C                                       all files.
      CALL XTRINI (PRGNAM, INLUN, OUTLUN, NEWIM, NEWOFF, NEWWT, WTOFF,
     *   IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Check coordinates
      IF ((DOUTP.LE.0.0) .OR. (DOUTP.GT.1.5)) CALL XTRCHK (IERR)
C                                       Transform coordinates.
      IF (DOUTP.GT.0.0) THEN
         CALL ROTATE (INLUN, OUTLUN, NPNTS, NLINES, NEWIM(1+NEWOFF),
     *      NEWWT(1+WTOFF), IERR)
         IF (IERR.NE.0) GO TO 980
C                                       New max, min
         CALL GETHDR (INLUN, CATBLK, IERR)
         CALL OPENCF (OUTLUN, OUTSTR, IERR)
         CALL GETHDR (OUTLUN, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 980
         CATR(KRDMX) = DMAX
         CATR(KRDMN) = DMIN
         CALL SAVHDR (OUTLUN, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Create, copy, update hist file.
         CALL HISTRY (PRGNAM, INLUN, OUTLUN, IHINL, IHOTL, BUF1, BUF2)
         END IF
C                                       Release AIPS if necessary,
C                                       close, clear files, delete any
C                                       new files if error.
 980  CALL TSKEND (IERR)
C
 999  STOP
      END
      SUBROUTINE XTRINI (PRGNAM, INLUN, OUTLUN, NEWIM, NEWOFF, NEWWT,
     *   WTOFF, IERR)
C-----------------------------------------------------------------------
C   XTRINI will initialize the WAWA IO package, open the input image,
C   create the output image , determine the name strings of the
C   output image and initialize the output image.
C   Inputs:
C      PRGNAM   C*6    Program name.
C      INLUN    I      Input image logical unit numbers.
C      OUTLUN   I      New image input logical unit number.
C      NEWIM    R(*)   Base address of output image
C      NEWWT    R(*)   Base address of weight image
C   Outputs:
C      NEWOFF   LI     Offset to allocated memory
C      WTOFF    LI     Offset to allocated memory
C      IERR     I      Standard WAWA IO error message.
C   (in common block)
C      BLC      R(7)   bottom left hand corner of input map.
C      TRC      R(7)   top right hand corner of input map.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      REAL      NEWIM(*), NEWWT(*)
      INTEGER   INLUN, OUTLUN, IERR
      LONGINT   NEWOFF, WTOFF
C
      CHARACTER OUTCL*6
      INTEGER   NOPARM, NWORDS, IROUND
      HOLLERITH MAP(2)
      REAL      XUSID
      INCLUDE 'XTRAN.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      NOPARM = 42
      CALL TSKBEG (PRGNAM, NOPARM, XNAMEI, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL H2CHR (48, 1, XINFIL, INFILE)
      XUSID = NLUSER
C                                       Fix the input image name string
      CALL CHR2H (4, 'MA  ', 1, MAP)
      CALL H2WAWA (XNAMEI, XCLAIN, XSEQI, MAP, XDISKI, XUSID, INSTR)
C                                       Open the old file. Get header.
      CALL OPENCF (INLUN, INSTR, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL GETHDR (INLUN, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Fix BLC, TRC.
      CALL HDRWIN (BLC, TRC, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 990
      NPNTS = TRC(1) - BLC(1) + 1
      NLINES = TRC(2) - BLC(2) + 1
      X0 = 0.5*NPNTS
      Y0 = 0.5*NLINES
      NPAR = IROUND (XPAR)
      IF (NPAR.EQ.6) THEN
         IF (ABS(DOUTP).GT.1.5) THEN
            MSGTXT = 'Warning: ORDER=6 not appropriate for simple'
     *         // ' header change'
            CALL MSGWRT (6)
            END IF
      ELSE IF (NPAR.NE.3) THEN
         NPAR = 3
         MSGTXT = 'ORDER SET TO 3'
         CALL MSGWRT (6)
         END IF
C                                       Fill in defaults for INSTR.
      CALL GTNAME (INLUN, INSTR, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Check out class
      CALL H2CHR (6, 1, XCLAOU, OUTCL)
C                                       If blank use program name
      IF (OUTCL.EQ.' ') OUTCL = PRGNAM
C                                       Pack class back
      CALL CHR2H (6, OUTCL, 1, XCLAOU)
C                                       Set up output name string.
      CALL H2WAWA (XNAMOU, XCLAOU, XSEQO, MAP, XDISKO, XUSID, OUTSTR)
      CALL FILDEF (INSTR, OUTSTR)
C                                       Find coordinate transform
      CALL XY2AD (IERR)
      IF (IERR.NE.0) GO TO 990
C                                       If not making new image, exit
      IF (DOUTP.GT.0.0) THEN
C                                       allocate memory for output
         NWORDS = NPNTS * NLINES
         IF (DOUTP.GT.1.5) NWORDS = (2 * NPNTS - 1) / 1024 + 1
         CALL ZMEMRY ('GET ', TSKNAM, NWORDS, NEWIM, NEWOFF, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL ZMEMRY ('GET ', TSKNAM, NWORDS, NEWWT, WTOFF, IERR)
         IF (IERR.NE.0) GO TO 999
C                                      No history file
         CATR(KRBLK) = FBLANK
         CALL CATCLR (CATBLK)
C                                       Create output image.
         CALL MAPCR (OUTSTR, OUTSTR, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
      GO TO 999
C                                       error handling.
 970  CALL PRTERR (IERR, OUTLUN)
      GO TO 999
 980  CALL PRTERR (IERR, INLUN)
      GO TO 999
 990  CALL PRTERR (IERR, 0)
C
 999  RETURN
      END
      SUBROUTINE XY2AD (IERR)
C-----------------------------------------------------------------------
C   Finds the xy to RA,Dec transformation using a user supplied list
C   of standard star positions.  The function that is fit is a linear
C   function (NPAR=3) or a linear plus quadratic (NPAR=6) in the tangent
C   plane.  Axis increments, rotation angle, and axis offets are found.
C   If the user requests the transformation to be applied, these values
C   are put in the image header.
C   Inputfrom common:
C      INFILE   C*48   Name of file in with star postions.
C   Output:
C      IERR     I      Error return code
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   MXSTAR
      PARAMETER (MXSTAR=1000)
      CHARACTER LINE*80, AXRA*4, AXDEC*4, EXTEND*4, NAME(MXSTAR)*20,
     *   DECSIN*1, PTYPE*4, INNAME*20
      INTEGER   LUNSTR, I, IVOL, NSEQ, IVER, NSTDS, FND, ICHR, IER
      REAL      INXY(2), XY(2,MXSTAR), AD(2,MXSTAR), RES(2,MXSTAR),
     *   HR(3), DEG(3)
      DOUBLE PRECISION REFVAL(2), REFINC(2), REFPIX(2), ANGLE
      INCLUDE 'XTRAN.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNSTR /10/
      DATA AXRA /'RA--'/, AXDEC /'DEC-'/, EXTEND /'-TAN'/
C-----------------------------------------------------------------------
      IVOL = 1
      NSEQ = 1
      IVER = 0
      IERR = 1
C                                       Open text file
      CALL ZTXOPN ('READ', LUNSTR, FND, INFILE, .FALSE., IER)
      IF (IER.NE.0) THEN
         FND = 0
         GO TO 960
         END IF
C                                       Read in reference center
 10   CALL ZTXIO ('READ', LUNSTR, FND, LINE, IER)
      IF (IER.NE.0) GO TO 960
      IF (LINE(1:1).EQ.'$') GO TO 10
      READ (LINE,1000,ERR=960) HR, DEG
C                                       Is Dec negative ?
      DECSIN = ' '
      DO 20 ICHR = 31,44
         IF (LINE(ICHR:ICHR).EQ.'-') DECSIN = '-'
 20      CONTINUE
C                                       Image center: Convert to radians
      REFVAL(1) = (HR(1) + (HR(2) + HR(3)/60.)/6.D1)*15.
      REFVAL(2) = ABS(DEG(1)) + (ABS(DEG(2)) + ABS(DEG(3))/60.)/6.D1
      IF (DECSIN.EQ.'-') REFVAL(2) = -REFVAL(2)
C                              Read standard star position
      NSTDS = 0
      DO 100 I = 1,MXSTAR
 30      CALL ZTXIO ('READ', LUNSTR, FND, LINE, IER)
         IF (IER.EQ.2) GO TO 120
         IF (IER.NE.0) GO TO 960
         IF (LINE(1:1).EQ.'$') GO TO 30
         READ (LINE,1001,ERR=960) INNAME, INXY(1), INXY(2), HR, DEG
         IF ((INXY(1).GE.BLC(1)) .AND. (INXY(1).LE.TRC(1)) .AND.
     *      (INXY(2).GE.BLC(2)) .AND. (INXY(2).LE.TRC(2))) THEN
            NSTDS = NSTDS + 1
            NAME(NSTDS) = INNAME
            AD(1,NSTDS) = (HR(1) + (HR(2) + HR(3)/60.)/6.D1)*15.
C                                       Is Dec negative ?
            DECSIN = ' '
            DO 50 ICHR = 31, 44
               IF (LINE(ICHR:ICHR).EQ.'-') DECSIN = '-'
 50            CONTINUE
            AD(2,NSTDS) = ABS(DEG(1)) + (ABS(DEG(2)) +
     *         ABS(DEG(3))/60.)/6.D1
            IF (DECSIN.EQ.'-') AD(2,NSTDS) = -AD(2,NSTDS)
            XY(1,NSTDS) = INXY(1)
            XY(2,NSTDS) = INXY(2)
            END IF
 100     CONTINUE
C
 120  CALL ZTXCLS (LUNSTR, FND, IER)
      FND = 0
      IF ((CATR(KRCRP).GE.BLC(1)) .AND. (CATR(KRCRP).LE.TRC(1)) .AND.
     *   (CATR(KRCRP+1).GE.BLC(2)) .AND. (CATR(KRCRP+1).LE.TRC(2))
     *   .AND. (ABS(DOUTP).GT.1.5)) THEN
         REFPIX(1) = CATR(KRCRP)
         REFPIX(2) = CATR(KRCRP+1)
      ELSE
         REFPIX(1) = (BLC(1)+TRC(1))/2.
         REFPIX(2) = (BLC(2)+TRC(2))/2.
         END IF
C                                       If not 6 pameters, do 3
C                                       Then do a 3 parameter fit
      IF (NPAR.NE.6) THEN
         NLSQ = 1
C                                       6 parms requires 2 passes
      ELSE
         NLSQ = 2
         END IF
C                                       Transform and print results
      CALL XTRFIT (NPAR, NSTDS, XY, AD, NAME, .TRUE., REFPIX, REFVAL,
     *   REFINC, ANGLE, A, B, RES, IERR)
C                                       Put results in common
      IF (IERR.NE.0) THEN
         IERR = 2
C                                       Put ref. params in header
      ELSE
C                                       Reference value (degrees)
         CATD(KDCRV)   = REFVAL(1)
         CATD(KDCRV+1) = REFVAL(2)
C                                       Coordinate Increment (degrees)
         CATR(KRCIC)   = REFINC(1)
         CATR(KRCIC+1) = REFINC(2)
C                                       Reference pixel
         CATR(KRCRP)   = REFPIX(1) - BLC(1) + 1.
         CATR(KRCRP+1) = REFPIX(2) - BLC(2) + 1.
         CATR(KRCRT) = 0.0
         IF ((DOUTP.GT.1.5) .OR.(DOUTP.LE.0.0)) THEN
            CATR(KRCRT+1) = ANGLE
            ANGL = 0.0
         ELSE
            CATR(KRCRT+1) = 0.0
            ANGL = -ANGLE * DG2RAD
            END IF
         CALL H2CHR (4, 1, CATH(KHCTP+1), PTYPE)
         CALL CHR2H (4, AXRA, 1, CATH(KHCTP))
         IF (PTYPE(:1).NE.'-') CALL CHR2H (4, EXTEND, 1, CATH(KHCTP+1))
         CALL CHR2H (4, AXDEC, 1, CATH(KHCTP+2))
         IF (PTYPE(:1).NE.'-') CALL CHR2H (4, EXTEND, 1, CATH(KHCTP+3))
         XINC = REFINC(1) * DG2RAD
         YINC = REFINC(2) * DG2RAD
C                                       Setup output header
         CATBLK(KINAX) = TRC(1) - BLC(1) + 1
         CATBLK(KINAX+1) = TRC(2) - BLC(2) + 1
         CATBLK(KINAX+2) = 1
         END IF
C                                       Error handling
 960  IF (IERR.EQ.1) THEN
         MSGTXT = 'ERROR OPENING OR READING FILE '// INFILE
         CALL MSGWRT (5)
         END IF
      IF (FND.GT.0) CALL ZTXCLS (LUNSTR, FND, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (18X,2F3.0,F7.3,2F3.0,F6.2)
 1001 FORMAT (A4,2F7.2,2F3.0,F7.3,2F3.0,F6.2)
      END
      SUBROUTINE XTRCHK (IERR)
C-----------------------------------------------------------------------
C   Input from common:
C      INFILE   C*48   Name of file in with star postions.
C   Output:
C      IERR     I      Error return code
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   MXSTAR
      PARAMETER (MXSTAR=1000)
      CHARACTER LINE*80, NAME*20, DECSIN*1
      INTEGER   LUNSTR, I, IVOL, NSEQ, IVER, FND, ICHR, IER, DEPTH(5)
      LOGICAL   SWAPOK
      REAL      HR(3), DEG(3), XP, YP, XSP, YSP, XI, YI
      DOUBLE PRECISION XD, XR
      INCLUDE 'XTRAN.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      DATA LUNSTR /10/
      DATA SWAPOK, DEPTH /.FALSE., 5*1/
C-----------------------------------------------------------------------
      MSGTXT = 'Residuals computed from image header'
      CALL MSGWRT (2)
      MSGTXT = 'If these are larger, you may have skew'
      CALL MSGWRT (2)
      IVOL = 1
      NSEQ = 1
      IVER = 0
      IERR = 1
      LOCNUM = 1
      CALL SETLOC (DEPTH, SWAPOK)
C                                       Open text file
      CALL ZTXOPN ('READ', LUNSTR, FND, INFILE, .FALSE., IER)
      IF (IER.NE.0) GO TO 999
C                                       Read in reference center
 10   CALL ZTXIO ('READ', LUNSTR, FND, LINE, IERR)
      IF (IER.NE.0) GO TO 980
      IF (LINE(1:1).EQ.'$') GO TO 10
      READ (LINE,1000,ERR=980) HR, DEG
C                                       Is Dec negative ?
      DECSIN = ' '
      DO 20 ICHR = 31,44
         IF (LINE(ICHR:ICHR).EQ.'-') DECSIN = '-'
 20      CONTINUE
C                                       Image center: Convert to radians
      XR = (HR(1) + (HR(2) + HR(3)/60.)/6.D1)*15.
      XD = ABS(DEG(1)) + (ABS(DEG(2)) + ABS(DEG(3))/60.)/6.D1
      IF (DECSIN.EQ.'-') XD = -XD
      CALL XYPIX (XR, XD, XP, YP, IERR)
      XI = CATR(KRCIC) * 3600.0
      YI = CATR(KRCIC+1) * 3600.0
      XSP = CATR(KRCRP)
      YSP = CATR(KRCRP+1)
      XP = (XP - XSP) * XI * COS (XD * DG2RAD)
      YP = (YP - YSP) * YI
      NAME = 'REF PIX'
      MSGTXT = 'TEST COORDINATES WITH HEADER'
      CALL MSGWRT (3)
      WRITE (MSGTXT,1010)
      CALL MSGWRT(3)
      WRITE (MSGTXT,1015) NAME(:8), XSP, XP, YSP, YP
      CALL MSGWRT (3)
C                              Read standard star positions
      DO 100 I = 1,MXSTAR
 30      CALL ZTXIO ('READ', LUNSTR, FND, LINE, IER)
         IF (IER.EQ.2) GO TO 980
         IF (IER.NE.0) GO TO 980
         IF (LINE(1:1).EQ.'$') GO TO 30
         READ (LINE,1001,ERR=980) NAME, XSP, YSP, HR, DEG
         IF ((XSP.GE.BLC(1)) .AND. (XSP.LE.TRC(1)) .AND. (YSP.GE.BLC(2))
     *      .AND. (YSP.LE.TRC(2))) THEN
            XR = (HR(1) + (HR(2) + HR(3)/60.)/6.D1)*15.
C                                       Is Dec negative ?
            DECSIN = ' '
            DO 50 ICHR = 31, 44
               IF (LINE(ICHR:ICHR).EQ.'-') DECSIN = '-'
 50            CONTINUE
            XD = ABS(DEG(1)) + (ABS(DEG(2)) + ABS(DEG(3))/60.)/6.D1
            IF (DECSIN.EQ.'-') XD = -XD
            CALL XYPIX (XR, XD, XP, YP, IERR)
            XSP = XSP - BLC(1) + 1.
            YSP = YSP - BLC(2) + 1.
            XP = (XP - XSP) * XI * COS (XD * DG2RAD)
            YP = (YP - YSP) * YI
            WRITE (MSGTXT,1015) NAME(:8), XSP, XP, YSP, YP
            CALL MSGWRT (3)
            END IF
 100     CONTINUE
C
 980  CALL ZTXCLS (LUNSTR, FND, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (18X,2F3.0,F7.3,2F3.0,F6.2)
 1001 FORMAT (A4,2F7.2,2F3.0,F7.3,2F3.0,F6.2)
 1010 FORMAT ('NAME',8X,'XPIX',4X,'DX_ASEC',6X,'YPIX',4X,'DY_ASEC')
 1015 FORMAT (A,F10.3,F9.3,F12.3,F9.3)
      END
      SUBROUTINE ROTATE (INLUN, OUTLUN, NX, NY, NEWIM, NEWWT, IERR)
C-----------------------------------------------------------------------
C   Sets up parameters, and feeds the transform alogorithm one line of
C   the input map at a time.
C   Inputs:
C      INLUN    I      Input image logical unit numbers.
C      OUTLUN   I      New image input logical unit number.
C      NX       I      X axis dim of output image
C      NY       I      Y axis dim of output image
C   (from common block)
C      BLC      R(7)   bottom left hand corner of input map.
C      TRC      R(7)   top right hand corner of input map.
C   Output:
C      IERR     I      Standard WAWA IO error message.
C-----------------------------------------------------------------------
      INTEGER   INLUN, OUTLUN, NX, NY, IERR
      REAL      NEWIM(NX,NY), NEWWT(NX,NY)
      INTEGER   IL, I, IINC
      REAL      ZBLC(7), ZTRC(7)
      INCLUDE 'XTRAN.INC'
      INCLUDE 'INCS:PMAD.INC'
      REAL      DATA(MAXIMG)
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      CSN = COS (ANGL)
      SN  = SIN (ANGL)
      DX = CSN
      DY = DX
C                                       all in core for regridded!
      IF (DOUTP.LE.1.5) THEN
C                                       Initialize the new image array
         I = NX * NY
         CALL RFILL (I, 0.0, NEWIM)
         CALL RFILL (I, 0.0, NEWWT)
         IINC = (8192 * 512) / NX
C                                       Init old image for read
         CALL MAPWIN (INLUN, BLC, TRC, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Feed rows to rotation algorithm
         DO 20 IL = 1,NY
            IF (MOD(IL-1,IINC).EQ.0) THEN
               WRITE (MSGTXT,1000) IL
               CALL MSGWRT (2)
               END IF
            CALL MAPIO ('READ', INLUN, DATA, IERR)
            IF (IERR.NE.0) GO TO 980
            CALL MAPROT (DATA, IL, NX, NY, NEWIM, NEWWT)
 20         CONTINUE
C                                       Write out new image
         CALL OPENCF (OUTLUN, OUTSTR, IERR)
         IF (IERR.NE.0) GO TO 990
         ZBLC(1) = 1.
         ZBLC(2) = 1.
         ZTRC(1) = NX
         ZTRC(2) = NY
         CALL MAPWIN (OUTLUN, ZBLC, ZTRC, IERR)
         IF (IERR.NE.0) GO TO 990
         DMIN = 1.E10
         DMAX = -DMIN
         MSGTXT = 'Writing the regridded image to disk'
         CALL MSGWRT (2)
         DO 40 IL = 1,NY
            DO 30 I = 1,NX
               IF (NEWWT(I,IL).EQ.0.0) NEWIM(I,IL) = FBLANK
               IF (NEWIM(I,IL).NE.FBLANK) THEN
                  NEWIM(I,IL) = NEWIM(I,IL) / NEWWT(I,IL)
                  DMAX = MAX (DMAX, NEWIM(I,IL))
                  DMIN = MIN (DMIN, NEWIM(I,IL))
                  END IF
 30            CONTINUE
            CALL MAPIO ('WRIT', OUTLUN, NEWIM(1,IL), IERR)
            IF (IERR.NE.0) GO TO 990
 40        CONTINUE
C                                       read/write as go for copy
      ELSE
C                                       Init old image for read
         CALL MAPWIN (INLUN, BLC, TRC, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Write out new image
         CALL OPENCF (OUTLUN, OUTSTR, IERR)
         IF (IERR.NE.0) GO TO 990
         ZBLC(1) = 1.
         ZBLC(2) = 1.
         ZTRC(1) = NX
         ZTRC(2) = NY
         CALL MAPWIN (OUTLUN, ZBLC, ZTRC, IERR)
         IF (IERR.NE.0) GO TO 990
         DMIN = 1.E10
         DMAX = -DMIN
C                                       Feed rows to rotation algorithm
         DO 140 IL = 1,NY
            CALL MAPIO ('READ', INLUN, DATA, IERR)
            IF (IERR.NE.0) GO TO 980
            DO 130 I = 1,NX
               IF (DATA(I).NE.FBLANK) THEN
                  DMAX = MAX (DMAX, DATA(I))
                  DMIN = MIN (DMIN, DATA(I))
                  END IF
 130           CONTINUE
            CALL MAPIO ('WRIT', OUTLUN, DATA, IERR)
            IF (IERR.NE.0) GO TO 990
 140       CONTINUE
         END IF
      CALL FILCLS (OUTLUN)
      GO TO 999
C                                       error handling
 980  CALL PRTERR (IERR, INLUN)
      GO TO 999
 990  CALL PRTERR (IERR, OUTLUN)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Regridding image now at row',I6)
      END
      SUBROUTINE MAPROT (DATA, LINE, NX, NY, NEWIM, NEWWT)
C-----------------------------------------------------------------------
C   Does the actual transform of map coordinates.
C   If NLSQ = 2, then NPAR = 6 and the map is subjected to a nonlinear
C   stretch in addition to rotation.
C   Inputs:
C      DATA   R(*)       Line of data from input map.
C      LINE   I          Row number of line to work on
C      NX     I          X dimension of output
C      NY     I          Y dimension of output
C   Output:
C      NEWIM  R(NX,NY)   Output image
C      NEWWT  R(NX,NY)   Output sum of weights image
C-----------------------------------------------------------------------
      INTEGER   LINE, NX, NY
      REAL      DATA(*), NEWIM(NX,NY), NEWWT(NX,NY)
C
      INTEGER   IX, IY, KK, OX, OY, NPM2, NLM2, ITEMP, I, J, JJ, K, XA,
     *   YA, JMAX, KMAX
      REAL      XOFF, YOFF, Y1, Y2, X1, X2, XMIN, XMAX, YMIN,
     *   YMAX, EPSX(3), EPSY(3), AREA, PPIX, XOFF2, YOFF2, YCSN, YSN,
     *   CXINC, CYINC, WPIX
      INCLUDE 'XTRAN.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      CALL RFILL (7, 1.0, BLC)
      CALL RFILL (7, 1.0, TRC)
      NPM2 = NPNTS - 2
      NLM2 = NLINES - 2
      ITEMP = NPNTS - 1
      OX = X0
      OY = Y0
C                                     Calc offset from middle
      YOFF  = LINE - OY - 0.5
      YOFF2 = LINE - OY
      YSN   = YOFF * SN
      YCSN  = YOFF2 * CSN
      CXINC = 1.0/XINC
      CYINC = 1.0/YINC
C                                     For all points but 2
      DO 900 I = 2,ITEMP
         IF (DATA(I).NE.FBLANK) THEN
            XOFF  = I - OX
            XOFF2 = I - OX - 0.5
C                                          Else stretch and rotate
            X1 = OX + CXINC*(XOFF*A(3) + YOFF*A(2)
     *         + (XOFF**2)*A(4) + (YOFF**2)*A(5) + XOFF*YOFF*A(6))
            DX = CXINC*(A(3) + A(6)*YOFF + A(4)*(2.*XOFF + 1.))
            Y1 = OY + CYINC*(XOFF2*B(3) + YOFF2*B(2)
     *         + (XOFF2**2)*B(4) + (YOFF2**2)*B(5) + XOFF2*YOFF2*B(6))
            DY = CYINC*(B(2) + B(6)*XOFF2 + B(5)*(2.*YOFF2+1.))
C                                          Calc Compression area
            X2 = X1 + DX
            Y2 = Y1 + DY
            XMIN = MIN (X1, X2)
            XMAX = MAX (X1, X2)
            YMIN = MIN (Y1, Y2)
            YMAX = MAX (Y1, Y2)
            IX = XMIN
            IY = YMIN
            IF ((IX.LT.1) .OR. (IX.GT.NPM2)) GO TO 900
            IF ((IY.LT.1) .OR. (IY.GT.NLM2)) GO TO 900
C                                     Track lowest point to rotate
            XA = IX
            YA = IY
C                                     Init expansion factors
            EPSX(2) = 0.
            EPSX(3) = 0.
            EPSY(2) = 0.
            EPSY(3) = 0.
C                                     Assume rotation of into 9 pixels
            IF (XMAX.LE.(XA+1.)) THEN
               EPSX(1) = XMAX - XMIN
C                                     X rotation stays in 1 pixel
               KMAX = 1
            ELSE
               EPSX(1) = (XA+1.) - XMIN
               IF (XMAX.LE.(XA+2.)) THEN
                  EPSX(2) = XMAX - (XA+1.)
                  KMAX = 2
               ELSE
                  EPSX(2) = 1.
                  EPSX(3) = XMAX - (XA+2.)
                  KMAX = 3
                  END IF
               END IF
C                                       Calc Y expansion factor
            IF (YMAX.LE.(YA+1.)) THEN
               EPSY(1) = YMAX - YMIN
C                                       Y rotation stays in 1 pixel
               JMAX = 1
            ELSE
               EPSY(1) = (YA+1.) - YMIN
               IF (YMAX.LE.(YA+2.)) THEN
                  EPSY(2) = YMAX - (YA+1.)
                  JMAX = 2
               ELSE
                  EPSY(2) = 1.
                  EPSY(3) = YMAX - (YA+2.)
                  JMAX = 3
                  END IF
               END IF
            AREA = ABS ((XMAX-XMIN)*(YMAX-YMIN))
            PPIX = DATA(I) / AREA
            WPIX = 1.0 / AREA
C                                     For 9 pixels around data
            DO 700 J = 1,JMAX
               JJ = IY + J - 1
               DO 690 K = 1,KMAX
                  KK = IX + K - 1
C                                     If inside region
                  IF ((KK.GE.1) .AND. (JJ.GE.1)) THEN
                     NEWIM(KK,JJ) = NEWIM(KK,JJ)+PPIX*EPSX(K)*EPSY(J)
                     NEWWT(KK,JJ) = NEWWT(KK,JJ)+WPIX*EPSX(K)*EPSY(J)
                     END IF
 690              CONTINUE
 700           CONTINUE
            END IF
 900     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE HISTRY (PRGNAM, INLUN, OUTLUN, IHINL, IHOTL, IDATA,
     *   IWORK)
C-----------------------------------------------------------------------
C  HISTRY will create and write the history file for the new image.
C  Inputs:  PRGNAM  C*6 program name.
C           INLUN   I   the LUN for the input map.
C           OUTLUN  I   the LUN for the output map.
C           IHINL   I   the LUN to use for the input history file.
C           IHOTL   I   the LUN to use for the new output history file.
C           IDATA   I(256)   History I/O buffer.
C           IWORK   I(256)   work buffer.
C-----------------------------------------------------------------------
      CHARACTER NAMSTR*36, PRGNAM*6, HILINE*72, NAME*12, CLASS*6,
     *   PTYPE*2
      INTEGER   IWORK(256), IDATA(256), IERR2, SEQ, DISK, USID
      INTEGER   IBLC(7), ITRC(7), INPTR, IOPTR, IERR, IPTR, I
      INTEGER   INLUN, OUTLUN, IHINL, IHOTL, NC, ITRIM
      LOGICAL   UPDATE
      INCLUDE 'XTRAN.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA UPDATE /.TRUE./
C-----------------------------------------------------------------------
C                                       Get additional data from common
      INPTR = 0
      IOPTR = 0
      DO 20 IPTR = 1,EFIL
         IF (INLUN.EQ.FILTAB(POLUN,IPTR)) INPTR = IPTR
         IF (OUTLUN.EQ.FILTAB(POLUN,IPTR)) IOPTR = IPTR
 20      CONTINUE
C                                       Check for file not open error.
      IF ((INPTR.EQ.0) .OR. (IOPTR.EQ.0)) GO TO 330
C                                       copy keywords
      CALL KEYCOP ( FILTAB(POVOL,INPTR), FILTAB(POCAT,INPTR),
     *   FILTAB(POVOL,IOPTR), FILTAB(POCAT,IOPTR), IERR)
C                                       Create history file and
C                                       copy HI of INSEQ
      CALL HIINIT (2)
      CALL HISCOP (IHINL, IHOTL, FILTAB(POVOL,INPTR),
     *   FILTAB(POVOL,IOPTR), FILTAB(POCAT,INPTR), FILTAB(POCAT,IOPTR),
     *   CATBLK, IWORK, IDATA, IERR)
      IF (IERR.NE.0) GO TO 330
C                                       Add new history.
C                                       Input map.
      CALL GTNAME (INLUN, NAMSTR, IERR)
      IF (IERR.NE.0) GO TO 320
      CALL WAWA2A (NAMSTR, NAME, CLASS, SEQ, PTYPE, DISK, USID)
      CALL HENCO1 (PRGNAM, NAME, CLASS, SEQ,
     *   FILTAB(POVOL,INPTR), IHOTL, IDATA, IERR)
      IF (IERR.NE.0) GO TO 320
C                                       Output map.
      CALL GTNAME (OUTLUN, NAMSTR, IERR)
      IF (IERR.NE.0) GO TO 320
      CALL WAWA2A (NAMSTR, NAME, CLASS, SEQ, PTYPE, DISK, USID)
      CALL HENCOO (PRGNAM,  NAME, CLASS, SEQ,
     *   FILTAB(POVOL,IOPTR), IHOTL, IDATA, IERR)
      IF (IERR.NE.0) GO TO 320
C                                       BLC, TRC
      DO 40 I = 1,7
         IBLC(I) = BLC(I) + .5
         ITRC(I) = TRC(I) + .5
 40      CONTINUE
      WRITE (HILINE,1010) PRGNAM, IBLC
      CALL HIADD (IHOTL, HILINE, IDATA, IERR)
      IF (IERR.NE.0) GO TO 320
      WRITE (HILINE,1011) PRGNAM, ITRC
      CALL HIADD (IHOTL, HILINE, IDATA, IERR)
      IF (IERR.NE.0) GO TO 320
      WRITE (HILINE,1012) PRGNAM, NPAR
      CALL HIADD (IHOTL, HILINE, IDATA, IERR)
      IF (IERR.NE.0) GO TO 320
      WRITE (HILINE,1013) PRGNAM, ANGL*57.29577951
      CALL HIADD (IHOTL, HILINE, IDATA, IERR)
      IF (IERR.NE.0) GO TO 320
      NC = ITRIM (INFILE)
      HILINE = PRGNAM // 'INFILE = ''' // INFILE(:NC) // ''''
      CALL HIADD (IHOTL, HILINE, IDATA, IERR)
      IF (IERR.NE.0) GO TO 320
      DO 50 I = 1,6
         WRITE (HILINE,1015) PRGNAM, 'A', I, A(I), 'X'
         CALL HIADD (IHOTL, HILINE, IDATA, IERR)
         IF (IERR.NE.0) GO TO 320
 50      CONTINUE
      DO 55 I = 1,6
         WRITE (HILINE,1015) PRGNAM, 'B', I, B(I), 'Y'
         CALL HIADD (IHOTL, HILINE, IDATA, IERR)
         IF (IERR.NE.0) GO TO 320
 55      CONTINUE
C                                       Close HI file
 320  CALL HICLOS (IHOTL, UPDATE, IDATA, IERR2)
      IF ((IERR.NE.0) .OR. (IERR2.NE.0)) GO TO 330
C                                        Copy tables
      CALL ALLTAB (1, '  ', IHINL, IHOTL,  FILTAB(POVOL,INPTR),
     *   FILTAB(POVOL,IOPTR), FILTAB(POCAT,INPTR), FILTAB(POCAT,IOPTR),
     *   CATBLK, IWORK, IDATA, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
      GO TO 999
C                                       Error comment
 330  WRITE (MSGTXT,1030)
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (A6,'BLC =',7I6)
 1011 FORMAT (A6,'TRC =',7I6)
 1012 FORMAT (A6,'/ NUMBER OF PARAMETERS FIT =',I2)
 1013 FORMAT (A6,'/ ROTATION ANGLE =',F8.3,' DEGREES')
 1015 FORMAT (A6,A,'(',I1,') = ',1PD12.5,4X,'/ ',A,'_fit parameter')
 1030 FORMAT('WARNING. ERROR WRITING HISTORY FILE.')
      END

      PROGRAM GRCHEK
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C     Program to read a gripe file and check its format, sequencing,
C     etc.
C     DCW, 28Sept84
C-----------------------------------------------------------------------
      IMPLICIT    NONE
      INTEGER     NGRIPE, LGRIPE, L5, L6, LIN, NFIRST, NCOUNT, K
      CHARACTER   GRIPE*5000, NEWLIN*3, INFILE*30, GRARGS(9)*5000
      DATA        NEWLIN /'|||'/
C-----------------------------------------------------------------------
C                                       initialize:
      LGRIPE = -1
      NCOUNT = 0
      L5 = 5
      L6 = 6
 5    CONTINUE
         LIN = 1
         WRITE (L6, 1005) 'INFILE'
         READ (L5, 1007, ERR=5) INFILE
         IF (INFILE.EQ.' ') GO TO 7
            CALL PADTEX (L6, INFILE)
            OPEN (UNIT=LIN, FILE=INFILE, STATUS='OLD', ERR=5)
            GO TO 10
 7       CONTINUE
            OPEN (UNIT=LIN, FILE='GRINFIL', STATUS='OLD', ERR=5)
C                                       big loop:
 10   CONTINUE
         CALL GETGRI (L6, LIN, NEWLIN, NGRIPE, GRIPE, GRARGS)
         IF (GRIPE.EQ.' ') GO TO 900
         NCOUNT = NCOUNT + 1
         IF (LGRIPE.NE.-1) GO TO 20
            NFIRST = NGRIPE
            GO TO 30
 20      CONTINUE
            K = (NGRIPE - (LGRIPE + 1))
            IF (K.EQ.1) WRITE (L6, 1020) (LGRIPE + 1)
            IF (K.GT.1) WRITE (L6, 1025) (LGRIPE + 1), (NGRIPE - 1)
            IF (K.LT.0) WRITE (L6, 1027) NGRIPE, LGRIPE
 30      CONTINUE
         LGRIPE = NGRIPE
         GO TO 10
 900  CONTINUE
      CLOSE (UNIT=LIN)
      WRITE (L6, 1900) NCOUNT, NFIRST, LGRIPE
C-----------------------------------------------------------------------
 1005 FORMAT (' GRCHEK: enter name for file ', A6, ': ', $)
 1007 FORMAT (A30)
 1020 FORMAT (' GRCHEK: gripe ', 5X, '   ', I5, '  is missing.')
 1025 FORMAT (' GRCHEK: gripes', I5, ' to', I5, ' are missing.')
 1027 FORMAT (' GRCHEK: out of order! gripe', I5, ' follows gripe', I5)
 1900 FORMAT (' GRCHEK:', I5, ' gripes. first=', I5, ', last=', I5)
      END

      SUBROUTINE CFFTI(N, WSAVE, WSAVEI)
C-----------------------------------------------------------------------
C! Initialize FFT work array.
C# AP-FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Initialize a workspace for a complex-to-complex FFT of length N.
C   The workspace should be an array of at least 4*N+15 elements and
C   N should be a positive integer.
C
C   This routine should not be called directly: use QCFT1I instead
C   which may call an FFT routine that has been optimized for the
C   machine you are working on.  QCFT1I will call this routine if
C   there is no specific optimized routine available.
C
C   Input:
C      N       I        Length of Fourier transform.
C   Output:
C      WSAVE   R(*)     Workspace.
C      WSAVEI  i(*)     Workspace (same as WSAVE)
C   Adapted from the FFTPACK routine by Paul N. Schwartztrauber.
C   This file also contains subroutine CFFTI1.
C-----------------------------------------------------------------------
      INTEGER   N, WSAVEI(*)
      REAL      WSAVE(*)
C
      INTEGER IW1, IW2
C-----------------------------------------------------------------------
      IF (N .GT. 1) THEN
C                                       Set indices for real and
C                                       integer workspaces; the integer
C                                       workspace is storage-associated
C                                       with WSAVE(IW2:?) in the call
C                                       to CFFTI1.
         IW1 = N + N + 1
         IW2 = IW1 + N + N
         CALL CFFTI1(N, WSAVE(IW1), WSAVEI(IW2))
         END IF
C
      RETURN
      END
      SUBROUTINE CFFTI1(N, WA, IFAC)
C-----------------------------------------------------------------------
C   Prepare the workspace for a complex-to-complex FFT of length N.
C   N should be at least 2.
C
C   Input:
C      N       I       Length of Fourier transform
C
C   Output:
C      WA      R(*)    Real workspace
C      IFAC    I(*)    Integer workspace
C-----------------------------------------------------------------------
      INTEGER   N, IFAC(*)
      REAL      WA(*)
C
      REAL ARG, ARGH, ARGLD, FI
      INTEGER I, I1, IB, IDO, IDOT, II, IP, IPM, J, K1, L1, L2,
     *   LD, NF, NL, NQ, NR, NTRY
      INTEGER NTRYH(4)
      SAVE    NTRYH
C
      INCLUDE 'INCS:PSTD.INC'
C
      DATA NTRYH /3, 4, 2, 5/
C-----------------------------------------------------------------------
      NL = N
      NF = 0
      J = 0
 100  J = J + 1
      IF ( J.LE.4 ) THEN
         NTRY = NTRYH(J)
      ELSE
         NTRY = NTRY + 2
      END IF
 200  NQ = NL/NTRY
      NR = NL - NTRY*NQ
      IF ( NR.NE.0 ) GO TO 100
      NF = NF + 1
      IFAC(NF+2) = NTRY
      NL = NQ
      IF ( NTRY.EQ.2 ) THEN
         IF ( NF.NE.1 ) THEN
            DO 220 I = 2, NF
               IB = NF - I + 2
               IFAC(IB+2) = IFAC(IB+1)
 220        CONTINUE
            IFAC(3) = 2
         END IF
      END IF
      IF ( NL.NE.1 ) GO TO 200
      IFAC(1) = N
      IFAC(2) = NF
      ARGH = TWOPI/FLOAT(N)
      I = 2
      L1 = 1
      DO 300 K1 = 1, NF
         IP = IFAC(K1+2)
         LD = 0
         L2 = L1*IP
         IDO = N/L2
         IDOT = IDO + IDO + 2
         IPM = IP - 1
         DO 250 J = 1, IPM
            I1 = I
            WA(I-1) = 1.
            WA(I) = 0.
            LD = LD + L1
            FI = 0.
            ARGLD = FLOAT(LD)*ARGH
            DO 240 II = 4, IDOT, 2
               I = I + 2
               FI = FI + 1.
               ARG = FI*ARGLD
               WA(I-1) = COS(ARG)
               WA(I) = SIN(ARG)
 240        CONTINUE
            IF ( IP.GT.5 ) THEN
               WA(I1-1) = WA(I-1)
               WA(I1) = WA(I)
            END IF
 250     CONTINUE
         L1 = L2
 300  CONTINUE
      RETURN
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NPARMS
      PARAMETER (NPARMS=29)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                      1        2         3          4
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           5           6          7          8          9
     *   'TIMERANG', 'DOCALIB', 'GAINUSE', 'FLAGVER', 'STOKES',
C           10         11          12        13         14        15
     *   'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK', 'OPTYPE', 'APARM',
C           16        17          18        19       20         21
     *   'IMSIZE', 'CELLSIZE', 'ROTATE', 'SHIFT', 'REWEIGHT', 'XTYPE',
C           22       23       24       25        26        27
     *   'YTYPE', 'XPARM', 'YPARM', 'FACTOR', 'NCOUNT', 'DPARM',
C           28
     *   'DOCAT', 'BADDISK'/
C                    1       2       3       4
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT,
C          5       6       7       8       9
     *   OOARE,  OOALOG, OOAINT, OOAINT, OOACAR,
C          10      11      12      13      14      15
     *   OOACAR, OOACAR, OOAINT, OOAINT, OOACAR, OOARE,
C          16      17      18      19      20      21
     *   OOAINT, OOARE,  OOARE,  OOARE,  OOARE,  OOAINT,
C          22      23      24      25      26      27
     *   OOAINT, OOARE,  OOARE,  OOARE,  OOAINT, OOARE,
C          28
     *   OOALOG, OOAINT/
C                   1     2     3     4
      DATA AVDIM /12,1,  6,1,  1,1,  1,1,
C         5     6     7     8     9
     *   8,1,  1,1,  1,1,  1,1,  4,1,
C         10    11    12    13    14    15
     *   12,1, 6,1,  1,1,  1,1,  4,1, 10,1,
C         16    17    18    19    20    21
     *   2,1,  2,1,  1,1,  2,1,  2,1,  1,1,
C         22    23    24    25    26    27   28    29
     *   1,1, 10,1, 10,1,  1,1,  1,1, 10,1, 1,1, 10,1/
LOCAL END
LOCAL INCLUDE 'BSGRD.INC'
      INTEGER   CTYPX, CTYPY, CTYPX2, CTYPY2
      REAL      XPARM(10), YPARM(10), XPARM2(10), YPARM2(10)
      COMMON /BSGRID/ CTYPX, CTYPY, CTYPX2, CTYPY2, XPARM, YPARM,
     *   XPARM2, YPARM2
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(10)
      REAL      RDUM(10)
      LOGICAL   LDUM(1)
      DOUBLE PRECISION DDUM(5)
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
      COMMON /BSGRDG/ DDUM
LOCAL END
      PROGRAM BSGRD
C-----------------------------------------------------------------------
C! Singledish beam-switched continuum imaging
C# Task AP Imaging OOP SINGLEDISH
C-----------------------------------------------------------------------
C;  Copyright (C) 1997-2000, 2015, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, BSIMAG*32, UVDATA(2)*32, SDTEMP(2)*32
      INTEGER  IRET, BUFF1(256)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'BSGRD'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL BSGRIN (PRGM, UVDATA, SDTEMP, BSIMAG, IRET)
C                                       grid
      IF (IRET.EQ.0) CALL BSGRIT (UVDATA, SDTEMP, BSIMAG, IRET)
C                                       History
      IF (IRET.EQ.0) CALL BSGRHI (UVDATA(1), BSIMAG)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE BSGRIN (PRGN, UVDATA, SDTEMP, BSIMAG, IRET)
C-----------------------------------------------------------------------
C   BSGRIN gets input parameters for BSGRD and creates the needed
C   objects.
C   Inputs:
C      PRGN     C*6    Program name
C   Output:
C      BSIMAG   C*32   Name of IMAGE object (contains output objects)
C      UVDATA   C*32   Name of input uv data.
C      IRET     I      Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6, BSIMAG*(*), UVDATA(2)*(*), SDTEMP(2)*(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NKEY1, NKEY2, NKEY3
C                                       NKEY1=no. adverbs to copy to
C                                       UVDATA object
      PARAMETER (NKEY1=13)
C                                       NKEY2 = no. adverb for SD image
      PARAMETER (NKEY2=6)
C                                       NKEY3 = # adverb for SD grid
      PARAMETER (NKEY3=6)
      INCLUDE 'INPUT.INC'
      INTEGER   DIM(7), TYPE, BCHAN, ECHAN, NAXIS(7), IMSI(2), IWT,
     *   BIF, EIF, FQINDX, IDDEG
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32, INK3(NKEY3)*8, OUTK3(NKEY3)*32, STOKES*4,
     *   UVTYPE*2, CHTYPE*4, TNAME*12, TCLASS*6, CDUMMY*1, CNAME*8,
     *   KEYW*8
      REAL      APARM(10), RWT(2)
      DOUBLE PRECISION COORD(2)
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'BSGRD.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs for UVDATA object
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'OUTNAME',
     *   'OUTCLASS', 'OUTDISK', 'OUTSEQ', 'STOKES', 'DOCALIB',
     *   'GAINUSE', 'FLAGVER', 'TIMERANG'/
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'OUTNAME',
     *   'OUTCLASS', 'OUTDISK', 'OUTSEQ', 'CALEDIT.STOKES',
     *   'CALEDIT.DOCAL', 'CALEDIT.CLUSE', 'CALEDIT.FGVER',
     *   'CALEDIT.TIMRNG'/
C                                       Adverbs for BSIMAG image object
      DATA INK2 /'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK', 'CELLSIZE',
     *   'SHIFT'/
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'CELLSIZE',
     *   'SHIFT'/
C                                       Adverbs for +- image objects
      DATA INK3 /'OUTNAME', 'OUTSEQ', 'OUTDISK', 'CELLSIZE', 'XPARM',
     *   'YPARM'/
      DATA OUTK3 /'NAME', 'IMSEQ', 'DISK', 'CELLSIZE', 'XPARM', 'YPARM'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       BADDISK
      CALL OGET ('Input', 'BADDISK', TYPE, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL COPY (DIM(1), IDUM, IBAD)
C                                       Grid types
      CALL OGET ('Input', 'XTYPE', TYPE, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CTYPX = IDUM(1)
      CALL OGET ('Input', 'YTYPE', TYPE, DIM, RDUM, CDUMMY, IRET)
      CTYPY = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'XPARM', TYPE, DIM, XPARM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'YPARM', TYPE, DIM, YPARM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CTYPX2 = CTYPX/100
      CTYPY2 = CTYPY/100
      CTYPX = MOD (CTYPX, 100)
      CTYPY = MOD (CTYPY, 100)
      IF (CTYPX2.EQ.0) CTYPX2 = CTYPX
      IF (CTYPY2.EQ.0) CTYPY2 = CTYPY
      CALL RCOPY (10, XPARM, XPARM2)
      CALL RCOPY (10, YPARM, YPARM2)
C                                       Declare 'BSTHROW' a header
C                                       keyword for the image class.
C                                       Also TOTHROW as header word
      CNAME = 'IMAGE'
      KEYW = 'BSTHROW'
      CALL OBVHKW (CNAME, KEYW, OOARE, IRET)
      IF (IRET.NE.0) GO TO 999
      KEYW = 'TOTHROW'
      CALL OBVHKW (CNAME, KEYW, OOARE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Default output Name = input
      CALL OGET ('Input', 'OUTNAME', TYPE, DIM, RDUM, TNAME, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (TNAME.EQ.' ') THEN
         CALL OGET ('Input', 'INNAME', TYPE, DIM, RDUM, TNAME, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT ('Input', 'OUTNAME', TYPE, DIM, RDUM, TNAME, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Default output Class = TSKNAM
      CALL OGET ('Input', 'OUTCLASS', TYPE, DIM, RDUM, TCLASS, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (TCLASS.EQ.' ') THEN
         TCLASS = TSKNAM
         CALL OPUT ('Input', 'OUTCLASS', TYPE, DIM, RDUM, TCLASS, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Set default stokes.
      CALL OGET ('Input', 'STOKES', TYPE, DIM, RDUM, STOKES, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (STOKES .EQ. ' ') STOKES = 'I'
      CALL OPUT ('Input', 'STOKES', TYPE, DIM, RDUM, STOKES, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create BSIMAG object
      BSIMAG = 'BSIMAG process object'
      CALL CREATE (BSIMAG, 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, BSIMAG, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 1
      DIM(2) = 1
      IDUM(1) = CTYPX2
      CALL OPUT (BSIMAG, 'CTYPX', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = CTYPY2
      CALL OPUT (BSIMAG, 'CTYPY', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 10
      DIM(2) = 1
      IF (CTYPX2.NE.CTYPX) CALL RFILL (10, 0.0, XPARM2)
      IF (CTYPY2.NE.CTYPY) CALL RFILL (10, 0.0, YPARM2)
      CALL OPUT (BSIMAG, 'XPARM', OOARE, DIM, XPARM2, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (BSIMAG, 'YPARM', OOARE, DIM, YPARM2, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create Plus grid object
      SDTEMP(1) = 'Plus throw image'
      CALL CREATE (SDTEMP(1), 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create Plus grid object
      SDTEMP(2) = 'Minus throw image'
      CALL CREATE (SDTEMP(2), 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY3, INK3, OUTK3, SDTEMP(1), IRET)
      IF (IRET.NE.0) GO TO 999
      CALL IN2OBJ ('Input', NKEY3, INK3, OUTK3, SDTEMP(2), IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 1
      DIM(2) = 1
      IDUM(1) = CTYPX
      CALL OPUT (SDTEMP(1), 'CTYPX', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (SDTEMP(2), 'CTYPX', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = CTYPY
      CALL OPUT (SDTEMP(1), 'CTYPY', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (SDTEMP(2), 'CTYPY', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create other objects
C                                       UVDATA: plus
      UVDATA(1) = 'Plus throw UVdata'
      CALL CREATE (UVDATA(1), 'UVDATA', IRET)
      IF (IRET.NE.0) GO TO 999
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, UVDATA(1), IRET)
      IF (IRET.NE.0) GO TO 999
C                                       UVDATA: minus
      UVDATA(2) = 'Minus throw UVdata'
      CALL CREATE (UVDATA(2), 'UVDATA', IRET)
      IF (IRET.NE.0) GO TO 999
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, UVDATA(2), IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Fix class name
      CALL OGET ('Input', 'INCLASS', TYPE, DIM, RDUM, TCLASS, IRET)
      IF (IRET.NE.0) GO TO 999
      TCLASS(6:6) = '+'
      CALL OPUT (UVDATA(1), 'CLASS', TYPE, DIM, RDUM, TCLASS, IRET)
      IF (IRET.NE.0) GO TO 999
      TCLASS(6:6) = '-'
      CALL OPUT (UVDATA(2), 'CLASS', TYPE, DIM, RDUM, TCLASS, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Get IF channel selection
      CALL SECSLT (UVDATA(1), BIF, EIF, BCHAN, ECHAN, STOKES, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       All Stokes', IF, channels
      CALL SECSAV (UVDATA(1), 1, 0, 1, 0, '    ', IRET)
      IF (IRET.NE.0) GO TO 999
      CALL SECSAV (UVDATA(2), 1, 0, 1, 0, '    ', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Open UVDATA to be sure it's OK.
      CALL OOPEN (UVDATA(1), 'READ', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Get type of data
      CALL UVDGET (UVDATA(1), 'TYPEUVD', TYPE, DIM, RDUM, UVTYPE, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (UVTYPE.NE.'SB') THEN
         MSGTXT = 'I ONLY WORK ON SB DATA NOT ''' // UVTYPE // ''''
         CALL MSGWRT (8)
         IRET = 8
         GO TO 999
         END IF
      CALL OCLOSE (UVDATA(1), IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OOPEN (UVDATA(2), 'READ', IRET)
      IF (IRET.NE.0) GO TO 999
      CALL UVDGET (UVDATA(2), 'TYPEUVD', TYPE, DIM, RDUM, UVTYPE, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (UVTYPE.NE.'SB') THEN
         MSGTXT = 'I ONLY WORK ON SB DATA NOT ''' // UVTYPE // ''''
         CALL MSGWRT (8)
         IRET = 8
         GO TO 999
         END IF
      CALL OCLOSE (UVDATA(2), IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Reset Selection: one IF
      EIF = BIF
      CALL SECSAV (UVDATA(1), BIF, EIF, BCHAN, ECHAN, STOKES, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL SECSAV (UVDATA(2), BIF, EIF, BCHAN, ECHAN, STOKES, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Attach UVDATA to image
      DIM(1) = LEN (UVDATA(1))
      DIM(2) = 1
      CALL OPUT (SDTEMP(1), 'UVDATA', OOACAR, DIM, RDUM, UVDATA(1),
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (SDTEMP(2), 'UVDATA', OOACAR, DIM, RDUM, UVDATA(2),
     *   IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Min. image sizes
      CALL OGET ('Input', 'IMSIZE', TYPE, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL COPY (DIM(1), IDUM, IMSI)
C                                       No images smaller than 32
C                                       and must be even
      IMSI(1) = MAX (IMSI(1), 32)
      IMSI(2) = MAX (IMSI(2), 32)
      IMSI(1) = ((IMSI(1) + 1) / 2) * 2
      IMSI(2) = ((IMSI(2) + 1) / 2) * 2
      CALL COPY (2, IMSI, IDUM)
      CALL OPUT ('Input', 'IMSIZE', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (BSIMAG, 'IMSIZE', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (SDTEMP(1), 'IMSIZE', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (SDTEMP(2), 'IMSIZE', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Coordinates
      CALL OGET ('Input', 'APARM', TYPE, DIM, APARM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      COORD(1) = (APARM(1) + APARM(2)/60. + APARM(3)/3600.) * 15.0
      IDDEG = ABS (APARM(4))
      COORD(2) = (IDDEG + APARM(5)/60. + (APARM(6)/3600.)) *
     *   SIGN (1.0, APARM(4))
      DIM(1) = 2
      CALL DPCOPY (2, COORD, DDUM)
      CALL OPUT (BSIMAG, 'CCENTER', OOADP, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'OPTYPE', TYPE, DIM, RDUM, CHTYPE, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (CHTYPE.EQ.' ') CHTYPE = '-SIN'
      CALL OPUT (BSIMAG, 'CPROJ', OOACAR, DIM, RDUM, CHTYPE, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (SDTEMP(1), 'CPROJ', OOACAR, DIM, RDUM, CHTYPE, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (SDTEMP(2), 'CPROJ', OOACAR, DIM, RDUM, CHTYPE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Image type, cutoff
      CALL OGET ('Input', 'REWEIGHT', TYPE, DIM, RWT, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IWT = -1
      IF (RWT(2).EQ.0.0) RWT(2) = -0.01
      RWT(1) = MIN (0.05, RWT(2))
      DIM(1) = 1
C                                        SD type, cutoff
      RDUM(1) = RWT(1)
      CALL OPUT (BSIMAG, 'SDCUTOFF', OOARE, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = IWT
      CALL OPUT (SDTEMP(1), 'SDTYPE', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      RDUM(1) = RWT(2)
      CALL OPUT (SDTEMP(1), 'SDCUTOFF', OOARE, DIM, RDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = IWT
      CALL OPUT (SDTEMP(2), 'SDTYPE', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      RDUM(1) = RWT(2)
      CALL OPUT (SDTEMP(2), 'SDCUTOFF', OOARE, DIM, RDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Default BCHAN, ECHAN
C                                       Find size of freq. axis.
      CALL UVDFND (UVDATA(1), 2, 'FREQ', FQINDX, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET (UVDATA(1), 'UV_DESC.NAXIS', TYPE, DIM, RDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL COPY (DIM(1), IDUM, NAXIS)
      BCHAN = 1
      ECHAN = NAXIS(FQINDX)
      DIM(1) = 1
      IDUM(1) = BCHAN
      CALL OPUT (SDTEMP(1), 'BCHAN', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (SDTEMP(2), 'BCHAN', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = ECHAN
      CALL OPUT (SDTEMP(1), 'ECHAN', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (SDTEMP(2), 'ECHAN', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       two were for coordinates
      ECHAN = NAXIS(FQINDX) - 2
      IDUM(1) = BCHAN
      CALL OPUT (BSIMAG, 'BCHAN', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT ('Input', 'BCHAN', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = ECHAN
      CALL OPUT (BSIMAG, 'ECHAN', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT ('Input', 'ECHAN', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       IF numbers
      BIF = 1
      EIF = 1
C                                       Save in Inputs for history
      DIM(1) = 1
      IDUM(1) = BIF
      CALL OPUT ('Input', 'BIF', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = EIF
      CALL OPUT ('Input', 'EIF', OOAINT, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       fix temp file names
      DIM(1) = LEN (TCLASS)
      DIM(2) = 1
      TCLASS = 'BSGRD+'
      CALL OPUT (SDTEMP(1), 'CLASS', OOACAR, DIM, RDUM, TCLASS, IRET)
      IF (IRET.NE.0) GO TO 999
      TCLASS = 'BSGRD-'
      CALL OPUT (SDTEMP(2), 'CLASS', OOACAR, DIM, RDUM, TCLASS, IRET)
      IF (IRET.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE BSGRIT (UVDATA, SDTEMP, BSIMAG, IRET)
C-----------------------------------------------------------------------
C   Routine to call OUVIMG to make image
C   Inputs:
C      UVDATA   C*?   Input UV data
C      BSIMAG   C*?   Image process object
C   Output:
C      IRET     I     > 0 => die
C-----------------------------------------------------------------------
      CHARACTER BSIMAG*(*), UVDATA(2)*(*), SDTEMP(2)*(*)
      INTEGER   IRET
C
      CHARACTER ROTEMP*32, CDUMMY*1, NAME*12, CLASS*6, KEYW*8, CNAME*8
      INTEGER   DIM(7), TYPE, I, DISK, HWIDTH, ORDER, WIN(4), IROUND,
     *   IMSIZE(2), IDISK, ICNO, ODISK, OCNO, BUFFER(512), IMSEQ
      REAL      ROTATE, SHIFT(2), CROTA(7), DPARM(10), FACTOR, MAXCWT,
     *   XNLIM, BMJ, BMN, BPA, THROWP, THROWM
      LOGICAL   DOCAT
      DOUBLE PRECISION APCORE(2)
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'BSGRD.INC'
      INCLUDE 'GFORT'
C-----------------------------------------------------------------------
      CALL OGET ('Input', 'OUTSEQ', TYPE, DIM, RDUM, CDUMMY, IRET)
      IMSEQ = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'DOCAT', TYPE, DIM, RDUM, CDUMMY, IRET)
      DOCAT = LDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'ROTATE', TYPE, DIM, RDUM, CDUMMY, IRET)
      ROTATE = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      IF (ROTATE.GT.0) THEN
C                                       Declare 'BSTHROW' a header
C                                       keyword for the uvdata class
         CNAME = 'UVDATA'
         KEYW = 'BSTHROW'
         CALL OBVHKW (CNAME, KEYW, OOARE, IRET)
         CALL OGET (UVDATA(1), 'BSTHROW', TYPE, DIM, RDUM, CDUMMY,
     *      IRET)
         THROWP = RDUM(1)
         IF (IRET.NE.0) GO TO 999
         SHIFT(1) = -THROWP * (1.0 - 1.0 / COS (ROTATE * DG2RAD))
         SHIFT(2) = -THROWP * SIN (ROTATE * DG2RAD)
         DIM(1) = 2
         DIM(2) = 1
         CALL OPUT (SDTEMP(1), 'SHIFT', OOARE, DIM, SHIFT, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      CALL OSDIMG (APCORE, UVDATA(1), SDTEMP(1), IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET (SDTEMP(1), 'XPARM', TYPE, DIM, XPARM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET (SDTEMP(1), 'YPARM', TYPE, DIM, YPARM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (ROTATE.GT.0) THEN
         CALL OGET (UVDATA(2), 'BSTHROW', TYPE, DIM, RDUM, CDUMMY,
     *      IRET)
         THROWM = RDUM(1)
         IF (IRET.NE.0) GO TO 999
         SHIFT(1) = -THROWM * (1.0 - 1.0 / COS (ROTATE * DG2RAD))
         SHIFT(2) = -THROWM * SIN (ROTATE * DG2RAD)
         DIM(1) = 2
         DIM(2) = 1
         CALL OPUT (SDTEMP(2), 'SHIFT', OOARE, DIM, SHIFT, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      CALL OSDIMG (APCORE, UVDATA(2), SDTEMP(2), IRET)
      IF (IRET.NE.0) GO TO 999
C                                       save for final output image
      CALL OGET (SDTEMP(1), 'MAXCWT', TYPE, DIM, RDUM, CDUMMY, IRET)
      MAXCWT = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET (SDTEMP(1), 'XNLIM', TYPE, DIM, RDUM, CDUMMY, IRET)
      XNLIM = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET (SDTEMP(1), 'BSTHROW', TYPE, DIM, RDUM, CDUMMY, IRET)
      THROWP = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET (SDTEMP(2), 'BSTHROW', TYPE, DIM, RDUM, CDUMMY, IRET)
      THROWM = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL UVDGET (UVDATA(1), 'BMAJ', TYPE, DIM, RDUM, CDUMMY, IRET)
      BMJ = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL UVDGET (UVDATA(1), 'BMIN', TYPE, DIM, RDUM, CDUMMY, IRET)
      BMN = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL UVDGET (UVDATA(1), 'BPA', TYPE, DIM, RDUM, CDUMMY, IRET)
      BPA = RDUM(1)
      IF (IRET.NE.0) GO TO 999
C                                       rotate
      CALL OGET ('Input', 'ROTATE', TYPE, DIM, RDUM, CDUMMY, IRET)
      ROTATE = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      IF (ROTATE.LT.0) THEN
         SHIFT(1) = THROWP * (1.0 - 1.0 / COS (ROTATE * DG2RAD))
         SHIFT(2) = THROWP * SIN (ROTATE * DG2RAD)
         ROTATE = 0.0
         HWIDTH = 1
         ROTEMP = 'Plus image rotated'
         DO 20 I = 1,2
            CALL CREATE (ROTEMP, 'IMAGE', IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OGET (SDTEMP(I), 'NAME', TYPE, DIM, RDUM, NAME, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OPUT (SDTEMP(I), 'OUTNAME', TYPE, DIM, RDUM, NAME,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OGET (SDTEMP(I), 'CLASS', TYPE, DIM, RDUM, CLASS,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
            CLASS(1:5) = 'BSROT'
            CALL OPUT (SDTEMP(I), 'OUTCLASS', TYPE, DIM, RDUM, CLASS,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OGET (SDTEMP(I), 'DISK', TYPE, DIM, RDUM, CDUMMY, IRET)
            DISK = IDUM(1)
            IF (IRET.NE.0) GO TO 999
            CALL OPUT (SDTEMP(I), 'OUTDISK', TYPE, DIM, RDUM, CDUMMY,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
            IDUM(1) = IMSEQ
            CALL OPUT (SDTEMP(I), 'OUTSEQ', TYPE, DIM, RDUM, CDUMMY,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
            CALL IMGCLN (SDTEMP(I), ROTEMP, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OGET (SDTEMP(I), 'IMAGE_DESC.CROTA', TYPE, DIM, CROTA,
     *         CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
            CROTA(2) = CROTA(2) + ROTATE
            CALL OPUT (ROTEMP, 'IMAGE_DESC.CROTA', TYPE, DIM, CROTA,
     *         CDUMMY, IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Interpolate
            CALL IMGINT (SDTEMP(I), SHIFT, ROTATE, HWIDTH, ROTEMP, IRET)
            IF (IRET.NE.0) GO TO 999
            SHIFT(1) = THROWM * SHIFT(1) / THROWP
            SHIFT(2) = THROWM * SHIFT(2) / THROWP
C                                       Copy catalog header keywords.
            CALL OBDSKC (SDTEMP(I), IDISK, ICNO, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OBDSKC (ROTEMP, ODISK, OCNO, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL KEYCOP (IDISK, ICNO, ODISK, OCNO, IRET)
            IF (IRET.NE.0) GO TO 999
C                                       kill the old one
            IF (.NOT.DOCAT) THEN
               CALL IMGZAP (SDTEMP(I), IRET)
               IF (IRET.NE.0) GO TO 999
C                                       Try to move in the beam parms
            ELSE
               CALL BEMCOP (SDTEMP(I), ROTEMP, IRET)
               IF (IRET.NE.0) GO TO 999
               CALL OCLOSE (ROTEMP, IRET)
               END IF
            SDTEMP(I) = ROTEMP
            ROTEMP = 'Minus image rotated'
 20         CONTINUE
         END IF
C                                       Correction step
      ROTEMP = 'Corrected Az-El image'
      CALL CREATE (ROTEMP, 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET (SDTEMP(1), 'NAME', TYPE, DIM, RDUM, NAME, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (SDTEMP(1), 'OUTNAME', TYPE, DIM, RDUM, NAME, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET (SDTEMP(1), 'CLASS', TYPE, DIM, RDUM, CLASS, IRET)
      IF (IRET.NE.0) GO TO 999
      CLASS = 'BSGCOR'
      CALL OPUT (SDTEMP(1), 'OUTCLASS', TYPE, DIM, RDUM, CLASS, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET (SDTEMP(1), 'DISK', TYPE, DIM, RDUM, CDUMMY, IRET)
      DISK = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (SDTEMP(1), 'OUTDISK', TYPE, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = IMSEQ
      CALL OPUT (SDTEMP(1), 'OUTSEQ', TYPE, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL IMGCLN (SDTEMP(1), ROTEMP, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create
      CALL OOPEN (ROTEMP, 'DEST', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy beam parameters
      CALL BEMCOP (SDTEMP(1), ROTEMP, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Total throw
      DIM(1) = 1
      THROWP = THROWP - THROWM
      RDUM(1) = THROWP
      CALL OPUT (ROTEMP, 'TOTHROW', OOARE, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OCLOSE (ROTEMP, IRET)
C                                       Move adverbs from input
      CALL OGET ('Input', 'IMSIZE', TYPE, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL COPY (DIM(1), IDUM, IMSIZE)
      CALL OGET ('Input', 'FACTOR', TYPE, DIM, RDUM, CDUMMY, IRET)
      FACTOR = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      IF (FACTOR.LE.0.0) FACTOR = 1.0
      RDUM(1) = FACTOR
      CALL OPUT ('Input', 'FACTOR', TYPE, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'NCOUNT', TYPE, DIM, RDUM, CDUMMY, IRET)
      ORDER = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      ORDER = MAX (0, MIN (1, ORDER))
      IDUM(1) = ORDER
      CALL OPUT ('Input', 'NCOUNT', TYPE, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'DPARM', TYPE, DIM, DPARM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (DPARM(1).LE.0.0) DPARM(1) = 1.0
      IF (DPARM(2).GT.0.0) THEN
         DPARM(2) = DPARM(1)
         DPARM(1) = 1.0
      ELSE
         DPARM(2) = 1.0
         END IF
      WIN(1) = IROUND (DPARM(3))
      WIN(2) = IROUND (DPARM(4))
      WIN(3) = IROUND (DPARM(5))
      WIN(4) = IROUND (DPARM(6))
      WIN(1) = MAX (1, WIN(1))
      IF (WIN(2).LT.WIN(1)) WIN(2) = IMSIZE(1)
      IF (WIN(4).LE.0) WIN(4) = IMSIZE(1)
      IF (WIN(3).LE.0) WIN(3) = IMSIZE(1) * 10
      DPARM(3) = WIN(1)
      DPARM(4) = WIN(2)
      DPARM(5) = WIN(3)
      DPARM(6) = WIN(4)
      CALL OPUT ('Input', 'DPARM', TYPE, DIM, DPARM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DO 30 I = 1,2
         DIM(1) = 1
         DIM(2) = 1
         RDUM(1) = FACTOR
         CALL OPUT (SDTEMP(I), 'FACTOR', TYPE, DIM, RDUM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         IDUM(1) = ORDER
         CALL OPUT (SDTEMP(I), 'BLORDER', OOAINT, DIM, RDUM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         DIM(1) = 2
         CALL OPUT (SDTEMP(I), 'REWEIGHT', OOAINT, DIM, DPARM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         DIM(1) = 4
         CALL COPY (4, WIN, IDUM)
         CALL OPUT (SDTEMP(I), 'BLWINDOW', OOAINT, DIM, RDUM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
 30      CONTINUE
C                                       Correct
      CALL IMGBSC (SDTEMP(1), SDTEMP(2), ROTEMP, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Clean up keywords
      CALL OBDSKC (ROTEMP, ODISK, OCNO, IRET)
      IF (IRET.NE.0) GO TO 999
      KEYW = 'BSTHROW'
      CALL REMKEY (ODISK, OCNO, KEYW, 1, BUFFER, IRET)
      IF (IRET.GT.0) GO TO 999
C                                       clean up
      IF (.NOT.DOCAT) THEN
         DO 40 I = 1,2
            CALL IMGZAP (SDTEMP(I), IRET)
            IF (IRET.NE.0) GO TO 999
 40         CONTINUE
         END IF
C                                       Regrid
      CALL IMGRGR (ROTEMP, BSIMAG, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      IF (.NOT.DOCAT) THEN
         CALL IMGZAP (ROTEMP, IRET)
         IF (IRET.NE.0) GO TO 999
      ELSE
         CALL OOPEN (ROTEMP, 'WRIT', IRET)
         IF (IRET.NE.0) GO TO 999
         CALL BEMCOP (SDTEMP(1), ROTEMP, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OCLOSE (ROTEMP, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      RDUM(1) = MAXCWT
      CALL OPUT (BSIMAG, 'MAXCWT', OOARE, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      RDUM(1) = XNLIM
      CALL OPUT (BSIMAG, 'XNLIM', OOARE, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      RDUM(1) = BMJ
      CALL OPUT (BSIMAG, 'BEAM.BMAJ', OOARE, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      RDUM(1) = BMN
      CALL OPUT (BSIMAG, 'BEAM.BMIN', OOARE, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      RDUM(1) = BPA
      CALL OPUT (BSIMAG, 'BEAM.BPA', OOARE, DIM, RDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OCLOSE (BSIMAG, IRET)
C
 999  RETURN
      END
      SUBROUTINE BSGRHI (UVDATA, BSIMAG)
C-----------------------------------------------------------------------
C   Routine to write history file to output BSIMAG image object.
C   Inputs:
C      UVDATA   C*?   Input UV data
C      BSIMAG   C*?   Image process object
C-----------------------------------------------------------------------
      CHARACTER BSIMAG*(*), UVDATA*32
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NADV0
      PARAMETER (NADV0=26)
      CHARACTER LIST(NADV0)*8, CDUMMY*1, CPROJ*4, LINE*64
      INTEGER   IERR, TYPE, DIM(7), I, DUMMY, MSGSAV
      REAL      PARM(10), MAXCWT, XNLIM, RWT
      DOUBLE PRECISION COORD(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'BSGRD.INC'
      INCLUDE 'GFORT'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'TIMERANG', 'DOCALIB',
     *   'GAINUSE', 'FLAGVER', 'STOKES', 'BCHAN', 'ECHAN', 'BIF',
     *   'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'IMSIZE', 'CELLSIZE', 'XTYPE',
     *   'YTYPE', 'XPARM', 'YPARM', 'OPTYPE', 'APARM', 'SHIFT',
     *   'FACTOR', 'ROTATE', 'DPARM'/
C-----------------------------------------------------------------------
      MSGSAV = MSGSUP
C                                       Move adverbs to Input
      CALL OGET (BSIMAG, 'XPARM', TYPE, DIM, XPARM2, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OPUT ('Input', 'XPARM', TYPE, DIM, XPARM2, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OGET (BSIMAG, 'YPARM', TYPE, DIM, YPARM2, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OPUT ('Input', 'YPARM', TYPE, DIM, YPARM2, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OGET (BSIMAG, 'CTYPX', TYPE, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OPUT ('Input', 'XTYPE', TYPE, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OGET (BSIMAG, 'CTYPY', TYPE, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OPUT ('Input', 'YTYPE', TYPE, DIM, RDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OGET (BSIMAG, 'CPROJ', TYPE, DIM, RDUM, CPROJ, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OPUT ('Input', 'OPTYPE', TYPE, DIM, RDUM, CPROJ, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OGET (BSIMAG, 'CCENTER', TYPE, DIM, RDUM, CDUMMY, IERR)
      COORD(1) = DDUM(1)
      COORD(2) = DDUM(2)
      IF (IERR.NE.0) GO TO 990
      COORD(1) = COORD(1) / 15.0D0
      I = COORD(1)
      PARM(1) = I
      COORD(1) = 60.0D0 * (COORD(1) - I)
      I = COORD(1)
      PARM(2) = I
      PARM(3) = 60.0D0 * (COORD(1) - I)
      DUMMY = 1
      IF (COORD(2).LT.0) DUMMY = -1
      COORD(2) = ABS (COORD(2))
      I = COORD(2)
      PARM(4) = I * DUMMY
      COORD(2) = 60.0D0 * (COORD(2) - I)
      I = COORD(2)
      PARM(5) = I
      PARM(6) = 60.0D0 * (COORD(2) - I)
      IF ((DUMMY.LT.0) .AND. (PARM(4).EQ.0.0)) PARM(4) = -1.0E-10
      DIM(1) = 10
      DIM(2) = 1
      CALL OPUT ('Input', 'APARM', OOARE, DIM, PARM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy old history
      CALL OHCOPY (UVDATA, BSIMAG, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy base adverb values.
      CALL OHLIST ('Input', LIST, NADV0, BSIMAG, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       First grid type:
      IF ((CTYPX2.NE.CTYPX) .OR. (CTYPY2.NE.CTYPY)) THEN
         LINE = '/ Convolution function for Az-El'
         CALL OHWRIT (LINE, BSIMAG, IERR)
         IF (IERR.NE.0) GO TO 990
         WRITE (LINE,1000) 'X', CTYPX
         CALL OHWRIT (LINE, BSIMAG, IERR)
         IF (IERR.NE.0) GO TO 990
         WRITE (LINE,1001) 'X', (XPARM(I), I = 1,5)
         CALL OHWRIT (LINE, BSIMAG, IERR)
         IF (IERR.NE.0) GO TO 990
         WRITE (LINE,1000) 'Y', CTYPY
         CALL OHWRIT (LINE, BSIMAG, IERR)
         IF (IERR.NE.0) GO TO 990
         WRITE (LINE,1001) 'Y', (YPARM(I), I = 1,5)
         CALL OHWRIT (LINE, BSIMAG, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       computed results
      CALL OGET (BSIMAG, 'SDCUTOFF', TYPE, DIM, RDUM, CDUMMY, IERR)
      RWT = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (BSIMAG, 'MAXCWT', TYPE, DIM, RDUM, CDUMMY, IERR)
      MAXCWT = RDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OGET (BSIMAG, 'XNLIM', TYPE, DIM, RDUM, CDUMMY, IERR)
      XNLIM = RDUM(1)
      IF (IERR.NE.0) GO TO 990
      IF (RWT.GT.0.0) THEN
         WRITE (LINE,1010) XNLIM
      ELSE
         WRITE (LINE,1011) XNLIM
         END IF
      CALL OHWRIT (LINE, BSIMAG, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // BSIMAG
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A1,'TYPE  =',I3,'  /convolution type with parms:')
 1001 FORMAT (A1,'PARM  =',4(F8.4,','),F7.1)
 1010 FORMAT ('WEIGHT  =',F9.3,' / Scaled min sum of convolved weights')
 1011 FORMAT ('WEIGHT  =',F9.3,
     *   ' / Scaled min ABS(sum of convolved weights)')
      END

      SUBROUTINE PASS1 (APCORE, IDIR, FULL, LUN, VOL, FIL, BO, XBUFF1,
     *   BUFSZ1, XBUFF2, BUFSZ2, NX, NY, IERR)
C-----------------------------------------------------------------------
C! First of two routines to FFT an image file.
C# AP-FFT Math Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2006, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PASS1 = first pass of a 2-dimensional disk-based AP FFT  Several
C   rows are loaded into the AP, FFTed and then partially transposed
C   and written on the work file.  If the entire map will fit into the
C   AP the intermediate results are not written to the WORK file.
C   Note: for Complex to Real transforms, NX/2+1 rows are expected.
C   Input:
C     IDIR        I    -1 = reverse transform
C                       1 = forward transform, keep real part only.
C                       2 = forward transform, keep amplitudes only,
C                       3 = forward transform, keep full complex.
C                       (In this step, no difference between 1,2,3)
C     FULL        L    If .TRUE. then COMPLEX to COMPLEX transform,
C                      otherwise, half plane complex to real or reverse
C     LUN(3)      I    LUNs for files
C     VOL(3)      I    Volume numbers for the files.
C     FIL(3)      C*48 Physical names for the files.
C     BO(3)       I    Block offsets for the files.
C     XBUFF1(),XBUFF2()  R    Work buffers for I/O
C     BUFSZ1,BUFSZ2  I    Size in bytes for XBUFF1 and XBUFF2
C     NX,NY          I    Number of grid cells in X and Y of maps.
C   Output:
C     IERR          I    Return error code, 0=>OK, otherwise failed.
C                        3=>image too small to FFT
C     Partially transformed and transposed file left in the AP or
C     on the WORK file if necessary.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      CHARACTER FIL(3)*48, BADOP*4
      INTEGER   IDIR, LUN(3), VOL(3), BO(3), BUFSZ1, BUFSZ2,
     *   NX, NY, IHALF, IERR, IWIN(4), APSIZ
      REAL      XBUFF1(*), XBUFF2(*)
      INTEGER   FIND1, FIND2, BIND1, BIND2, BADFIL, WIN(4), IER,
     *   J, K, MPASS, NCOL, NROW, JAPWRD, ITEMP, I, ILIM, IT,
     *   HALFNX, INDEX, ONENX, TWONY, ONEROW, JNDEX, ONENY, NWORD, JDIR,
     *   KNDEX, LNDEX
      DOUBLE PRECISION XNDEX
      LOGICAL   FULL, MAP, WAIT, EXCL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      DATA MAP, WAIT, EXCL /2*.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IERR = 0
C                                       Get power of 2 size of AP.
      JAPWRD = PSAPNW
      CALL AP2SIZ (JAPWRD, APSIZ)
C                                       Make sure min. dim .ge. 4
      IF ((NX.LT.4) .OR. (NY.LT.4)) THEN
         WRITE (MSGTXT,1000) NX,NY
         CALL MSGWRT (8)
         IERR = 3
         GO TO 999
         END IF
C                                       Determine number of AP loads
C                                       required
      XNDEX = APSIZ
      XNDEX = NX / XNDEX
      IF (FULL) XNDEX = XNDEX * 2.0D0
      MPASS = NY * XNDEX + 0.1
      MPASS = MAX (MPASS, 1)
      HALFNX = NX / 2
      ONENX = NX
      ONENY = NY
      NWORD = 0
C                                       Open input and work file.
      BADFIL = 1
      BADOP = 'OPEN'
      CALL ZOPEN (LUN(1), FIND1, VOL(1), FIL(1), MAP, EXCL, WAIT,
     *   IERR)
      IF (IERR.GT.0) GO TO 900
C                                        Writeonly on multiple AP loads
      IF (MPASS.GT.1) THEN
C                                        DEBUG WARNING MESSAGE
         MSGTXT = '***********************************************'
         CALL MSGWRT (9)
         MSGTXT = 'PASS1: USING MORE THAN ONE PASS!'
         CALL MSGWRT (9)
         MSGTXT = '***********************************************'
         CALL MSGWRT (9)
         BADFIL = 2
         CALL ZOPEN (LUN(2), FIND2, VOL(2), FIL(2), MAP, EXCL, WAIT,
     *      IERR)
         IF (IERR.GT.0) GO TO 900
         END IF
      BADOP = 'INIT'
C                                       REAL TO COMPLEX, scramble data.
      IF ((IDIR.LT.0) .OR. FULL) GO TO 500
C                                       INIT output file.
         WIN(1) = 1
         WIN(2) = 1
         WIN(3) = NX
         WIN(4) = NY
C                                        Write only for multiple AP
C                                        loads.
         IF (MPASS.LE.1) GO TO 35
            CALL MINIT ('WRIT', LUN(2), FIND2, NX, NY, WIN, XBUFF2,
     *         BUFSZ2, BO(2), IERR)
            IF (IERR.NE.0) GO TO 900
            WIN(2) = NY / 2 + 1
C                                       NROW = no. rows loaded at once.
 35      NROW = APSIZ / NX
         NROW = MIN (NROW, NY)
         ONEROW = NROW
C                                       Load second half first.
C                                       Jump to here for first half.
 40      CONTINUE
C                                       INIT Input file.
            CALL MINIT ('READ', LUN(1), FIND1, NX, NY, WIN, XBUFF1,
     *         BUFSZ1, BO(1), IERR)
            IF (IERR.NE.0) THEN
               BADOP = 'INIT'
               BADFIL = 1
               GO TO 900
               END IF
            ILIM = MPASS / 2
            ILIM = MAX (ILIM, 1)
            DO 120 I = 1,ILIM
               DO 80 J = 1,NROW
                  CALL MDISK ('READ', LUN(1), FIND1, XBUFF1, BIND1,
     *               IERR)
                  IF (IERR.NE.0) THEN
                     IT = (I - 1) * NROW + WIN(3) + J - 1
                     BADOP = 'READ'
                     BADFIL = 1
                     GO TO 900
                     END IF
                  K = J
C                                       Following to scramble input
C                                       if MPASS = 1.
                  IF (MPASS.GT.1) GO TO 70
                     K = J - NY / 2
                     IF (J.LE.NY/2) K = J + NY / 2
 70               INDEX = (K - 1) * ONENX
C                                       Load data in AP, scramble.
                  CALL QWR
                  CALL QPUT (APCORE, XBUFF1(BIND1+NX/2), INDEX, HALFNX,
     *               2)
                  JNDEX = INDEX + HALFNX
                  CALL QPUT (APCORE, XBUFF1(BIND1), JNDEX, HALFNX, 2)
                  CALL QWD
C                                       Row loaded, do FFT.
                  CALL QRFFT (APCORE, INDEX, ONENX, 1)
 80               CONTINUE
               CALL QWR
C                                       Transpose.
               IHALF = HALFNX
               CALL APXPOS (APCORE, NROW, IHALF, 0, IERR)
               IF (IERR.NE.0) GO TO 990
C                                       Write out from AP to work file.
C                                       Writeonly on multiple AP loads.
               IF (MPASS.LE.1) GO TO 120
                  DO 110 J = 1,NROW
                     CALL MDISK ('WRIT', LUN(2), FIND2, XBUFF2, BIND2,
     *                  IERR)
                     IF (IERR.NE.0) THEN
                        IT = WIN(2) + I + J - 1
                        BADOP = 'WRIT'
                        BADFIL = 2
                        GO TO 900
                        END IF
                     INDEX = (J - 1) * ONENX
                     CALL QGET (APCORE, XBUFF2(BIND2), INDEX, ONENX, 2)
                     CALL QWD
 110                 CONTINUE
C                                       Roll AP if necessary.
C                                       Roll whole AP memory if
C                                       MPASS=1 otherwise none.
 115           NWORD = 0
               IF (MPASS.EQ.1) NWORD = APSIZ
               CALL QROLL (APCORE, NWORD, XBUFF1, BUFSZ1, IERR)
               IF (IERR.NE.0) GO TO 999
C                                       Reset NWORD
               NWORD = 0
 120           CONTINUE
C                                       Check to see if finished.
            IF (WIN(2).EQ.1) GO TO 130
               WIN(2) = 1
               GO TO 40
C                                       Writeonly on multiple AP loads
 130     IF (MPASS.LE.1) GO TO 990
            BADFIL = 2
            BADOP = 'FINI'
            CALL MDISK ('FINI', LUN(2), FIND2, XBUFF2, BIND2, IERR)
            IF (IERR.NE.0) GO TO 900
            GO TO 990
C                                       COMPLEX to REAL or FULL
C                                       COMPLEX transform.
 500  CONTINUE
C                                       INIT read and write files.
         WIN(1) = 1
         WIN(2) = 1
         WIN(3) = NY * 2
         WIN(4) = NX / 2
         IF (FULL) WIN(4) = NX
         BADFIL = 1
         NCOL = APSIZ / (NY * 2)
         ITEMP = NX / 2
         IF (FULL) ITEMP = NX
         NCOL = MIN (NCOL, ITEMP)
         TWONY = 2 * NY
         JDIR = -1
         IF (FULL) JDIR = IDIR
C                                       If Complex=>real then do last
C                                       row (NX/2+1) to pack with first.
         IF (.NOT.FULL) THEN
            BADOP = 'INIT'
            IWIN(1) = 1
            IWIN(3) = NY * 2
            IWIN(2) = (NX / 2) + 1
            IWIN(4) = (NX / 2) + 1
            CALL MINIT ('READ', LUN(1), FIND1, IWIN(3), IWIN(4), IWIN,
     *         XBUFF1, BUFSZ1, BO(1), IERR)
            IF (IERR.NE.0) GO TO 900
            BADOP = 'READ'
            INDEX = ONENY * 2
            JNDEX = INDEX
            CALL MDISK ('READ', LUN(1), FIND1, XBUFF1, BIND1, IERR)
            IF (IERR.NE.0) THEN
               IT = NCOL
               GO TO 900
               END IF
            CALL QWR
            CALL QPUT (APCORE, XBUFF1(BIND1), JNDEX, TWONY, 2)
            CALL QWD
C                                       FFT row
            CALL QCFFT (APCORE, INDEX, ONENY, JDIR)
            END IF
         BADOP = 'INIT'
         CALL MINIT ('READ', LUN(1), FIND1, WIN(3), WIN(4), WIN, XBUFF1,
     *      BUFSZ1, BO(1), IERR)
         IF (IERR.NE.0) GO TO 900
C                                       Writeonly on multiple AP loads
         IF (MPASS.GT.1) THEN
            BADFIL = 2
            CALL MINIT ('WRIT', LUN(2), FIND2, WIN(3), WIN(4), WIN,
     *         XBUFF2, BUFSZ2, BO(2), IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         DO 600 I = 1,MPASS
            DO 560 J = 1,NCOL
               INDEX = (J-1) * 2 * ONENY
               JNDEX = INDEX
               CALL MDISK ('READ', LUN(1), FIND1, XBUFF1, BIND1, IERR)
               IF (IERR.NE.0) THEN
                  IT = I + J - 1
                  BADFIL = 1
                  BADOP = 'READ'
                  GO TO 900
                  END IF
               CALL QWR
               CALL QPUT (APCORE, XBUFF1(BIND1), JNDEX, TWONY, 2)
               CALL QWD
C                                       Row loaded, do FFT.
               CALL QCFFT (APCORE, INDEX, ONENY, JDIR)
               IF ((I.GT.1) .OR. (J.GT.1) .OR. FULL) GO TO 560
C                                       Pack first (real) and
C                                       last (imag.)
                  LNDEX = 1
                  KNDEX = TWONY
                  CALL QVMOV (APCORE, KNDEX, 2, LNDEX, 2, ONENY)
 560           CONTINUE
C                                       Transpose.
            CALL APXPOS (APCORE, NCOL, NY, 0, IERR)
            IF (IERR.NE.0) GO TO 990
C                                       Writeonly on multiple AP loads
            IF (MPASS.GT.1) THEN
C                                       Write out AP to work file.
               DO 590 J = 1,NCOL
                  INDEX = (J - 1) * ONENY * 2
                  JNDEX = INDEX
                  CALL MDISK ('WRIT', LUN(2), FIND2, XBUFF2, BIND2,
     *               IERR)
                  IF (IERR.NE.0) THEN
                     IT = I + J - 1
                     BADOP = 'WRIT'
                     BADFIL = 2
                     GO TO 900
                     END IF
                  CALL QGET (APCORE, XBUFF2(BIND2), JNDEX, TWONY, 2)
                  CALL QWD
 590              CONTINUE
               END IF
C                                       Roll AP if necessary.
C                                       Roll whole AP memory if
C                                       MPASS=1 otherwise none.
               NWORD = 0
               IF (MPASS.EQ.1) NWORD = APSIZ
               CALL QROLL (APCORE, NWORD, XBUFF1, BUFSZ1, IERR)
               IF (IERR.NE.0) GO TO 999
C                                       Reset NWORD
               NWORD = 0
 600        CONTINUE
C                                       Finish write.
C                                       Writeonly on multiple AP loads
         IF (MPASS.LE.1) GO TO 990
            CALL MDISK ('FINI', LUN(2), FIND2, XBUFF2, BIND2, IERR)
            IF (IERR.EQ.0) GO TO 990
               BADFIL = 2
               BADOP = 'FINI'
               GO TO 900
C                                       Errors
 900  WRITE (MSGTXT,1900) BADOP, IERR, FIL(BADFIL)
      IF ((BADOP.EQ.'READ') .OR. (BADOP.EQ.'WRIT')) THEN
         WRITE (MSGTXT,1901) BADOP, IERR, IT
         CALL MSGWRT (8)
         WRITE (MSGTXT,1902) FIL(BADFIL)
         END IF
      CALL MSGWRT (8)
C                                       Close files.
 990  IF ((MPASS.GT.1) .AND. (BADOP.NE.'OPEN')) CALL ZCLOSE (LUN(2),
     *   FIND2, IER)
      IF ((BADOP.NE.'OPEN') .OR. (BADFIL.EQ.2)) CALL ZCLOSE (LUN(1),
     *   FIND1, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PASS1: NX OR NY (',I5,',',I5,') LESS THAN 4')
 1900 FORMAT ('PASS1: ',A4,' ERROR',I7,' FILE ',A)
 1901 FORMAT ('PASS1: ',A4,' ERROR',I7,' ROW',I5)
 1902 FORMAT ('   FILE = ',A)
      END

      SUBROUTINE TVLOAD (LUN, IND, IPL, PXINC, IMAWIN, WIN, BUFSZ,
     *   MBUFF, IERR)
C-----------------------------------------------------------------------
C! load image to a TV memory from open MA file
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000, 2002, 2014, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Subroutine to load a map from an already opened map file to one
C   TV memory plane.  TVLOAD puts TV and map windows in the image
C   header and writes it in the image catalog.  It assumes that the
C   other parts of the image header are already filled in (and uses
C   them) and that the windows are all computed.
C   Inputs:
C      LUN      I      Logical unit # of map file
C      IND      I      FTAB pointer for map file
C      IPL      I      Channel to load
C      PXINC    I(2)   Increment in x,y between included pixels
C      IMAWIN   I(4)   TV corners: BLC x,y TRC x,y
C      WIN      I(4)   Map window: ""
C      BUFSZ    I      Buffer size in bytes
C   Outputs
C      MBUFF    R(*)   Buffer
C      IERR     I      Error code: 0 => ok
C                                  1 => input errors
C                                  2 => MINIT errors
C                                  3 => MDISK errors
C   Commons: /MAPHDR/ CATBLK  image header
C   Integer value 0 => pixel blanked
C-----------------------------------------------------------------------
      INTEGER   LUN, IND, IPL, PXINC(2), IMAWIN(4), WIN(4), BUFSZ, IERR
      REAL      MBUFF(*)
C
      CHARACTER TRANFN*2
      INTEGER   JERR, ININD, DELBLK, I, IYTV, MPIX, NPIX, IM1, IM2,
     *   HORIZ, IX, PLINC(2), NXINT, NYINT, LPIX, IY
      REAL      X, Y
      LOGICAL   WASYNC
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DCNT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INTEGER   JBUFF(MAXIMG), TBUFF(MAXIMG)
      EQUIVALENCE (JBUFF, IBBUFF), (TBUFF, ILROW)
      DATA HORIZ /0/
C-----------------------------------------------------------------------
      IERR = 1
      IF ((IPL.LT.1) .OR. (IPL.GT.NGRAY)) GO TO 999
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CATBLK(IIDEP), DELBLK,
     *   JERR)
      IF (JERR.NE.0) GO TO 999
      WASYNC = ISYNCH.EQ.0
      DELBLK = DELBLK + 1
C                                       fix up img cat block
      CALL COPY (4, WIN, CATBLK(IIWIN))
      CALL COPY (4, IMAWIN, CATBLK(IICOR))
      CALL H2CHR (2, 1, CATH(IITRA), TRANFN)
C                                       write img cat block
      IERR = 2
      CALL YCWRIT (IPL, IMAWIN, CATBLK, IBUFF, JERR)
      IF (JERR.NE.0) GO TO 999
      IF (WASYNC) CALL YHOLD ('ONNN', IERR)
C                                       start map read
      PLINC(1) = MAX (1, PXINC(1))
      PLINC(2) = MAX (1, PXINC(2))
      NXINT = MAX (1, -PXINC(1))
      NYINT = MAX (1, -PXINC(2))
      NPIX = 1 + WIN(3) - WIN(1)
      MPIX = 1 + (IMAWIN(3) - IMAWIN(1)) / NXINT
      LPIX = 1 + IMAWIN(3) - IMAWIN(1)
      CALL MINIT ('READ', LUN, IND, CATBLK(KINAX), CATBLK(KINAX+1), WIN,
     *   MBUFF, BUFSZ, DELBLK, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1010) JERR
         GO TO 980
         END IF
C                                       set up TV writing
      IM1 = WIN(2)
      IM2 = WIN(4)
      IERR = 3
      IYTV = IMAWIN(2)-1
C                                       read 1st row
      CALL MDISK ('READ', LUN, IND, MBUFF, ININD, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1020) JERR
         GO TO 980
         END IF
      CALL ISCALE (TRANFN, MAXINT, CATR(IRRAN), NPIX, PLINC,
     *   MBUFF(ININD), TBUFF)
      CALL LINTER (MPIX, NXINT, TBUFF, IBUFF)
      DO 70 IY = IM1,IM2
C                                       End: write row only
         IF (IY.GE.IM2) THEN
            IYTV = IYTV + 1
            CALL YIMGIO ('WRIT', IPL, IMAWIN(1), IYTV, HORIZ, LPIX,
     *         IBUFF, JERR)
            IF (JERR.NE.0) THEN
               WRITE (MSGTXT,1025) JERR
               GO TO 980
            ELSE
               IERR = 0
               GO TO 990
               END IF
            END IF
         CALL MDISK ('READ', LUN, IND, MBUFF, ININD, JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1020) JERR
            GO TO 980
            END IF
         IF (MOD(IY-IM1,PLINC(2)).EQ.0) THEN
            CALL ISCALE (TRANFN, MAXINT, CATR(IRRAN), NPIX, PLINC,
     *         MBUFF(ININD), TBUFF)
            CALL LINTER (MPIX, NXINT, TBUFF, JBUFF)
            IYTV = IYTV + 1
            CALL YIMGIO ('WRIT', IPL, IMAWIN(1), IYTV, HORIZ, LPIX,
     *         IBUFF, JERR)
            IF (JERR.NE.0) THEN
               WRITE (MSGTXT,1025) JERR
               GO TO 980
               END IF
C                                       interpolate rows
            IF (NYINT.GT.1) THEN
               X = 1.0 / NYINT
               DO 60 I = 2,NYINT
                  Y = (I-1) * X
                  DO 55 IX = 1,LPIX
                     IF ((JBUFF(IX).EQ.0) .OR. (IBUFF(IX).EQ.0)) THEN
                        TBUFF(IX) = 0
                     ELSE
                        TBUFF(IX) = IBUFF(IX) + Y*(JBUFF(IX)-IBUFF(IX))
     *                     + 0.4999
                        END IF
 55                  CONTINUE
                  IYTV = IYTV + 1
                  CALL YIMGIO ('WRIT', IPL, IMAWIN(1), IYTV, HORIZ,
     *               LPIX, TBUFF, JERR)
                  IF (JERR.NE.0) THEN
                     WRITE (MSGTXT,1025) JERR
                     GO TO 980
                     END IF
 60               CONTINUE
               END IF
            CALL COPY (LPIX, JBUFF, IBUFF)
            END IF
 70      CONTINUE
      IERR = 0
      GO TO 990
C                                       write error message
 980  CALL MSGWRT (7)
C
 990  IF (WASYNC) CALL YHOLD ('OFFF', JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('TVLOAD: MINIT DISK I/O ERROR =',I6)
 1020 FORMAT ('TVLOAD: MDISK DISK I/O ERROR =',I6)
 1025 FORMAT ('TVLOAD: MDISK TV I/O ERROR =',I6)
      END

      SUBROUTINE TYINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   ITYRNO, TYKOLS, TYNUMV, NUMPOL, NUMIF, IERR)
C-----------------------------------------------------------------------
C! Create/open/initialize Tsys (TY) table
C# EXT-appl UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2006, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes T sys (TY) extension tables.
C    Inputs:
C     OPCODE       C*4 Operation code:
C                      'WRIT' = create/init for write or read
C                      'READ' = open for read only
C     BUFFER(512)  I   I/O buffer and related storage, also defines file
C                      if open.
C     DISK         I   Disk to use.
C     CNO          I   Catalog slot number
C     VER          I   TY file version
C     CATBLK(256)  I   Catalog header block.
C     LUN          I   Logical unit number to use
C     NUMPOL       I   Number of polarizations (1 or 2)
C     NUMIF        I   Number of IFs for which data is stored in file
C    Output:
C     ITYRNO       I   Next record number, start of the file if 'READ',
C                      the last+1 if WRITE
C     TYKOLS(*)    I   The column pointer array in order defined in
C                      PTYTAB.INC.
C     TYNUMV(*)    I   Element count in each column
C     IERR         I   Return error code, 0=>OK, else TABINI or TABIO
C                      error.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PTYTAB.INC'
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, ITYRNO,
     *   TYKOLS(MAXTYC), TYNUMV(MAXTYC), NUMPOL, NUMIF, IERR
C
      CHARACTER TTITLE*56, TITLE(TYRTA2)*24, UNITS(TYRTA2)*8,
     *   KEYWRD(3)*8
      HOLLERITH HOLTMP(6)
      INTEGER    NKEY, NREC, DATP(128,2), NCOL, KLOCS(3), KEYVAL(3),
     *   KEYTYP(3), NTT, NDATA, REVNO, IPOINT, MSGSAV, DTYP(TYRTA2), J,
     *   I, JERR, NC, ITRIM, ITEMP(6)
      LOGICAL    DOREAD, NEWFIL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (HOLTMP, ITEMP)
      DATA NTT /56/
      DATA TTITLE /'AIPS UV DATA FILE TSYS TABLE                  '/
      DATA KEYWRD /'NO_POL', 'NO_IF','REVISION'/
C                                        Values larger than 10 are
C                                        scalars
      DATA DTYP /12,12,14,14,14,14,4*2/
C                                       NOTE: change PTYTAB.INC if the
C                                       columns are changed.
      DATA TITLE /'TIME                    ',
     *   'TIME INTERVAL          ',
     *   'SOURCE ID               ', 'ANTENNA NO.             ',
     *   'SUBARRAY                ', 'FREQ ID                 ',
     *   'TSYS 1                  ', 'TANT 1                  ',
     *   'TSYS 2                  ', 'TANT 2                  '/
      DATA UNITS /'DAYS    ', 'DAYS    ', 4*'        ',4*'KELVINS '/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NREC = 1000
      NCOL = 6 + 2 * NUMPOL
      IF (DOREAD) NCOL = 0
      NKEY = 3
      NDATA = MAXTYC
      CALL FILL (NDATA, 0, TYKOLS)
      CALL FILL (NDATA, 0, TYNUMV)
C                                       Fill in types
      IF (.NOT.DOREAD) THEN
         CALL COPY (NDATA, DTYP, DATP(1,2))
         DO 10 J = 1,NDATA
            IF (DTYP(J).LT.10) DATP(J,2) = DTYP(J) + 10 * NUMIF
 10         CONTINUE
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'TY', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'TYINI', IERR)
         GO TO 990
         END IF
C                                       Reset NKEY
      NKEY = 3
      NEWFIL = IERR .LT. 0
C                                       See if file exists.
      IF (NEWFIL) THEN
C                                       File created, initialize
         DO 40 I = 1,NCOL
C                                       Col. labels.
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'TYINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'TYINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       No. polarizations
         KLOCS(1) = 1
         KEYTYP(1) = 4
         KEYVAL(1) = NUMPOL
C                                       No. IFs
         KLOCS(2) = 2
         KEYTYP(2) = 4
         KEYVAL(2) = NUMIF
C                                       Revision number from PTYTAB.INC
         KLOCS(3) = 3
         KEYTYP(3) = 4
         KEYVAL(3) = TYREV
C                                       write keywords
         CALL TABKEY ('WRIT', KEYWRD, NKEY, BUFFER, KLOCS, KEYVAL,
     *      KEYTYP, IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'TYINI', IERR)
            GO TO 990
            END IF
C                                       pre-existing read keywords
      ELSE
         MSGSAV = MSGSUP
         MSGSUP = 32000
         CALL TABKEY ('READ', KEYWRD, NKEY, BUFFER, KLOCS, KEYVAL,
     *      KEYTYP, IERR)
         MSGSUP = MSGSAV
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'TYINI', IERR)
            GO TO 990
            END IF
C                                       Retrieve keyword values
C                                       No. polarizations
         IPOINT = KLOCS(1)
         NUMPOL = 1
         IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. IF s
         IPOINT = KLOCS(2)
         NUMIF = 1
         IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       Revision number
         IPOINT = KLOCS(3)
         REVNO = -1
         IF (IPOINT.GT.0) REVNO = KEYVAL(IPOINT)
         END IF
C                                       Set ITYRNO
      ITYRNO = BUFFER(5) + 1
      IF (DOREAD) ITYRNO = 1
C                                       Get array indices
C                                       Cover your ass from FNDCOL -
C                                       close to flush the buffers and
C                                       then reopen.
      CALL TABIO ('CLOS', 0, ITYRNO, KEYVAL, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'TYINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'TY', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'TYINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (NDATA, TITLE, 24, .TRUE., BUFFER, TYKOLS, JERR)
C                                       INTERPRET
      NCOL = 6 + 2 * NUMPOL
      DO 150 I = 1,NDATA
         IPOINT = TYKOLS(I)
         IF (IPOINT.GT.0) THEN
            TYKOLS(I) = DATP(IPOINT,1)
            TYNUMV(I) = DATP(IPOINT,2) / 10
            IF (TYNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               IF (I.LE.NCOL) CALL MSGWRT (6)
               END IF
         ELSE
            TYKOLS(I) = -1
            TYNUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            IF (I.LE.NCOL) CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('TYINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('TYINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('TYINI: ERROR INITIALIZING TSYS TABLE FOR ',A4)
      END

      SUBROUTINE BPASET (IERR)
C-----------------------------------------------------------------------
C! Sets up the bandpass table array for use by DATBND.
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2000-2001, 2005-2006, 2009-2012, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Sets up the bandpass table array for use by DATBND, also sets
C   up the arrays necessary for VLBA bandpass corrections.
C   Output:
C      IERR     I        Return error code 0=>OK, else failed.
C   Inputs from common
C      BPBUFF   I(512)   BP table I/O TABIO buffer
C      NBPINR   I        Number of BP records in file.
C      NANTBP   I        Number of antennas
C      NPOLBP   I        Number of IFs per group (polarizations)
C      NIFBP    I        Number of IFs.
C      NCHNBP   I        Number of channels
C   Output to common
C      PBPBUF   LI       Pointer to start of actual BPBUF
C      BPBUF    R(*)     Dynamic memory to hold BP corrs with initial
C                        set of corrections
C      PVLBUF   LI       Pointer to start of actual VLBUF if VLBA
C      VLBUF    R(*)     Dynamic memory to hold VLBA BP corrs
C      ANTNX    LI(2,*)  Index array contains 1 or 2 pointers for each
C                        antenna, if pointer = 0 antenna not present 1
C                        or 2 times.  Pointer is to time (vis 2 later).
C      MXANUM   I        The maximum antenna number
C      ANTREC   I(2,*)   First and last BP rec # for each antenna
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      CHARACTER KEYS(6)*24, BNDCOD(MAXIF)*8
      INTEGER   IERR, ANTNO, SUBA, NIO, SOURID, BPREF(2), IFRQ, IFNO,
     *   LENBU, LRECS, LRECW, KLOCT, KLOCA, JERR, OANTNO, FREQID,
     *   KOLS(12), KEY(2,2), NKEY, I, J, INDEX, CVER, ICHLUN, ANVER,
     *   LNX, INXW, LNXW, NWD, LRECWT, LRECBP, LRECA, KEYSUB(2,2)
      LONGINT   BIND, VIND, IIND, INXP, LNXP, JNDEX, INX
      LOGICAL   SORT, TABEND, SOMANT, ANTFLG
      REAL      INTERV, FKEY(2,2), WTP1, WTP2, RTMP, BNDPAS(2*MAXCIF),
     *   WEIGHT(2*MAXIF), WTS(MAXCIF)
      DOUBLE PRECISION    TIME, ARRLON
      SAVE BNDPAS, WTS
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DBPC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCVL.INC'
      INCLUDE 'INCS:DANT.INC'
C      DATA T, F /.TRUE.,.FALSE./
      DATA NKEY /6/
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
      DATA KEYS /'ANTENNA ', 'REFANT 1 ', 'SUBARRAY ', 'TIME ',
     *   'REAL 1 ', 'IMAG 1 '/
C-----------------------------------------------------------------------
C                                       Is this VLBA data?
      ANVER = 1
      CALL ANTINI ('READ', BPBUFF, IUDISK, IUCNO, ANVER, CATUV, IPLUN,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READ', 'AN TABLE'
         GO TO 990
         END IF
      CALL TABIO ('CLOS', 1, IANRNO, BPBUFF, BPBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      ISVLA = (ANAME(1:4).NE.'VLBA') .AND. (ANAME(1:3).NE.'EVN')
      ISVLBA = ANAME(1:4).EQ.'VLBA'
      IF (ISVLBA) THEN
         I = MAXANT * MAXIF
         CALL RFILL (I, 0.0, AVDELI)
         END IF
C                                      Init various things in the
C                                      common
      CALL RFILL (MAXANT, 0.0, CURSHF)
      CALL FILL (4, 0, BPGOT)
      MXANUM = 0
C                                      Check if need all antennas
      SOMANT = .FALSE.
      DO 10 I = 1,MAXANT
         IF (ANTENS(I).NE.0) SOMANT = .TRUE.
 10      CONTINUE
C                                      Sort BP table, reformat
      CALL BPREFM (IUDISK, IUCNO, BPVER, CATUV, IPLUN, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1005) IERR
         CALL MSGWRT (8)
         END IF
      CALL BPINI ('READ', BPBUFF, IUDISK, IUCNO, BPVER, CATUV, IPLUN,
     *   IBPRNO, BPKOLS, BPNUMV, NANTBP, NPOLBP, NIFBP, NCHNBP, BCHNBP,
     *   NUMSHF, LOWSHF, DELSHF, LTYPBP, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN', 'BP TABLE'
         GO TO 990
         END IF
      WPOLY = LTYPBP.NE.' '
C                                       Check sizes
      NWD = NPOLBP * NIFBP * NCHNBP
      IF ((NIFBP.GT.MAXIF) .OR. (NCHNBP.GT.MAXCHA) .OR. (NWD.GT.MAXCIF))
     *   THEN
         IERR = 1
         MSGTXT = 'BPASET: SINGLE VISIBILITY TOO BIG FOR BUFFERS'
         GO TO 990
         END IF
C                                       allocate memory
      IF (PBPBUF.EQ.0) THEN
C                                       interpolation areas
         IF (DOBAND.GT.1) THEN
            NWD = NANTBP * (2 * NPOLBP * NIFBP * NCHNBP + 2)
            NWD = (NWD + NPOLBP * NIFBP * NANTBP) * 2
            NWD = (NWD - 1) / 1024 + 1
            CALL ZMEMRY ('GET ', 'BPASET', NWD, BPIBUF(1), PBPIBF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1010) IERR, NWD
               GO TO 990
               END IF
            END IF
C                                       applied area(s)
         NWD = NANTBP * (2 * NPOLBP * NIFBP * NCHNBP + 2)
         IF ((WPOLY) .OR. (ISVLBA)) NWD = 2 * NWD
         NWD = (NWD - 1) / 1024 + 1
         CALL ZMEMRY ('GET ', 'BPASET', NWD, BPBUF(1), PBPBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, NWD
            GO TO 990
            END IF
         NWD = NWD * 1024
         IF ((WPOLY) .OR. (ISVLBA)) THEN
            NWD = NWD / 2
            PVLBUF = PBPBUF + NWD
         ELSE
            PVLBUF = PBPBUF
            END IF
         END IF
C                                       Set column pointers for sort
      CALL FNDCOL (NKEY, KEYS, 24, .TRUE., BPBUFF, KOLS, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FIND', 'BP COLUMNS'
         GO TO 990
         END IF
C                                       Close
      CALL TABIO ('CLOS', 0, IBPRNO, BPBUFF, BPBUFF, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOS', 'BP TABLE'
         GO TO 990
         END IF
C                                       Sort to ant-time order if
C                                       BPAVG is true
C                                       See if sort necessary
      SORT = (BPBUFF(43).NE.KOLS(1)) .OR. (BPBUFF(44).NE.KOLS(4))
C                                       sort it
      IF (SORT) THEN
         KEY(1,1) = KOLS(1)
         KEY(2,1) = KOLS(1)
         KEY(1,2) = KOLS(4)
         KEY(2,2) = KOLS(4)
         CALL TABSRT (IUDISK, IUCNO, 'BP', BPVER, BPVER, KEY, KEYSUB,
     *      FKEY, BPBUFF, CATUV, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'SORT', 'BP TABLE'
            GO TO 990
            END IF
         END IF
C                                       Open BP table for read
      CALL BPINI ('READ', BPBUFF, IUDISK, IUCNO, BPVER, CATUV, IPLUN,
     *   IBPRNO, BPKOLS, BPNUMV, NANTBP, NPOLBP, NIFBP, NCHNBP, BCHNBP,
     *   NUMSHF, LOWSHF, DELSHF, LTYPBP, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN', 'BP TABLE'
         GO TO 990
         END IF
      NBPINR = BPBUFF(5)
C                                       Do we need to initialize the
C                                       frequency shifting stuff?
      IF (ISVLBA) THEN
         USEAP = .FALSE.
C                                       Get frequency info.
         CVER = 1
         ICHLUN = 50
         CALL CHNDAT ('READ', BNDPAS, IUDISK, IUCNO, CVER, CATUV,
     *      ICHLUN, CNNIF, CFOFF, CSBAND, CFINC, BNDCOD, FRQSEL, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READ', 'FQ TABLE'
            GO TO 990
            END IF
C                                       Fill AN information
C                                       into common in DANS.INC
         CALL GETANT (IUDISK, IUCNO, SUBARR, CATUV, BNDPAS, IERR)
         IF (IERR .NE. 0) THEN
            WRITE (MSGTXT,1000) IERR, 'READ', 'AN TABLE'
            GO TO 990
            END IF
C                                       Correct station positions for
C                                       centre array offset if non-zero
         MSTNS = 0
C                                       use right-hand system
C                                       (DETRAT has been fixed to RH)
         ARRLON = 0.0D0
         IF ((ABS(CNTRX).GT.1.D2) .AND. (ABS(CNTRY).GT.1.D2) .AND.
     *      (ABS(CNTRZ).GT.1.D2)) ARRLON = ATAN2 (CNTRY, CNTRX)
         DO 30 I = 1,MAXANT
            IF ((TELNO(I).GT.0) .AND. (TELNO(I).LT.MAXANT)) THEN
               MSTNS = MAX (MSTNS, TELNO(I))
               CFIRST(TELNO(I)) = .TRUE.
               ANTX(TELNO(I)) = CNTRX + STNX(TELNO(I))*COS(ARRLON) -
     *            STNY(TELNO(I)) * SIN(ARRLON)
               ANTY(TELNO(I)) = CNTRY + STNY(TELNO(I))*COS(ARRLON) +
     *            STNX(TELNO(I)) * SIN(ARRLON)
               ANTZ(TELNO(I)) = CNTRZ + STNZ(TELNO(I))
               END IF
 30         CONTINUE
         OLDCSU = -1
         END IF
C                                       Create scratch file for
C                                       BP data
      LENBU = 1
C                                       Determine size and define
C                                       random pointers
      LRECW = NPOLBP * NCHNBP * NIFBP
      LRECBP = 2 * LRECW
      LRECWT = 0
      IF (DOBAND.GT.1) LRECWT = NPOLBP * NIFBP
      LRECA = LRECBP + 2
      LRECS = LRECA + LRECWT
      KLOCT = 0
      KLOCA = 1
C                                       Define scratch data increments
      KSNCF = 2
      KSNCIF = NCHNBP * KSNCF
      KSNCS =  NIFBP * KSNCIF
      CALL FILL (2*MAXANT, 0, ANTREC)
      DO 40 I = 1,MAXANT
         ANTNX(1,I) = 0
         ANTNX(2,I) = 0
         ANTNX(3,I) = 0
 40      CONTINUE
      BIND = 1 + PBPBUF
      VIND = 1 + PVLBUF
      IIND = 1 + PBPIBF
C                                       If BPAVG then average table
C                                       into scratch file
      IF (DOBAND.EQ.1) THEN
         OANTNO = -1
         CALL RFILL (NWD, 0.0, BPBUF(BIND))
         CALL RFILL (LRECW, 0.0, WTS)
         NIO = 1
C                                       Average the data
 60      CALL TABBP ('READ', BPBUFF, IBPRNO, BPKOLS, BPNUMV, NIFBP,
     *      NCHNBP, NPOLBP, TIME, INTERV, SOURID, SUBA, ANTNO, CHNBND,
     *      BPFREQ, FREQID, BPREF, WEIGHT, BNDPAS, JERR)
         ANTFLG = JERR.LT.0
         TABEND = .FALSE.
         IF (JERR.GT.0) THEN
            IERR = JERR
            WRITE (MSGTXT,1000) IERR, 'READ', 'BP TABLE'
            GO TO 990
            END IF
C                                       Check freq id
         IF (((FREQID.NE.FRQSEL) .AND. (FREQID.GT.0) .AND.
     *      (FRQSEL.GT.0)) .OR. ((SUBARR.GT.0) .AND.
     *      (SUBA.NE.SUBARR) .AND. (SUBA.GT.0))) THEN
            IF (IBPRNO.GT.NBPINR) THEN
               TABEND = .TRUE.
               GO TO 150
               END IF
            GO TO 60
            END IF
C                                      Need this antenna ?
         IF (SOMANT) THEN
            DO 80 I = 1,MAXANT
               IF ((ANTNO.EQ.ABS(ANTENS(I))) .AND. (.NOT.DOAWNT))
     *            GO TO 90
               IF ((ANTNO.EQ.ABS(ANTENS(I))) .AND. DOAWNT) GO TO 95
 80            CONTINUE
            IF (.NOT.DOAWNT) GO TO 95
C                                       Decide if at end of table
 90         IF (IBPRNO.GT.NBPINR) THEN
               TABEND = .TRUE.
               GO TO 150
               END IF
            GO TO 60
            END IF
C                                      Write random parms
 95      IF ((ANTNO.NE.OANTNO) .AND. (OANTNO.NE.-1)) GO TO 150
 100     OANTNO = ANTNO
         IF (ANTNO.GT.MXANUM) MXANUM = ANTNO
         BPBUF(BIND+KLOCT) = TIME
         BPBUF(BIND+KLOCA) = ANTNO + 0.01 * MAX (SUBARR-1, 0)
         IF (JERR.NE.-3) THEN
            DO 130 IFNO = 1,NIFBP
               IF (ISVLBA) THEN
                  RTMP = BPFREQ(IFNO)
                  AVDELI(ANTNO,IFNO) = MAX(AVDELI(ANTNO,IFNO),RTMP)
                  END IF
               INXW = (IFNO-1) * NCHNBP
               INX = (IFNO-1) * NCHNBP * 2 - 1
               INXP = INX + BIND + 1
               LNXW = INXW + NCHNBP * NIFBP
               LNX = INX + NCHNBP * NIFBP * 2
               LNXP = LNX + BIND + 1
               WTP1 = MAX (0.0, WEIGHT(IFNO))
               WTP2 = MAX (0.0, WEIGHT(IFNO+NIFBP))
               DO 120 IFRQ = 1,NCHNBP
                  INXW = INXW + 1
                  INX = INX + 2
                  INXP = INXP + 2
                  IF ((JERR.NE.-1) .AND. (BNDPAS(INX).NE.FBLANK) .AND.
     *               (BNDPAS(INX+1).NE.FBLANK)) THEN
                     BPBUF(INXP) = BPBUF(INXP) + BNDPAS(INX) * WTP1
                     BPBUF(INXP+1) = BPBUF(INXP+1) + BNDPAS(INX+1) *
     *                  WTP1
                     WTS(INXW) = WTS(INXW) + WTP1
                     END IF
C                                       Second polarization
                  IF (NPOLBP.GT.1) THEN
                     LNXW = LNXW + 1
                     LNX = LNX + 2
                     LNXP = LNXP + 2
                     IF ((JERR.NE.-2) .AND. (BNDPAS(LNX).NE.FBLANK)
     *                  .AND. (BNDPAS(LNX+1).NE.FBLANK)) THEN
                        BPBUF(LNXP) = BPBUF(LNXP) + BNDPAS(LNX) * WTP2
                        BPBUF(LNXP+1) = BPBUF(LNXP+1) + BNDPAS(LNX+1) *
     *                     WTP2
                        WTS(LNXW) = WTS(LNXW) + WTP2
                        END IF
                     END IF
 120              CONTINUE
 130           CONTINUE
            END IF
C                                       Decide if at end of table
         IF (IBPRNO.LE.NBPINR) GO TO 60
         TABEND = .TRUE.
C                                       Normalize table
 150     INDEX = 0
         JNDEX = BIND
         LNX = NCHNBP * NIFBP
         INX = 2 * NCHNBP * NIFBP + BIND
         DO 190 IFNO = 1,NIFBP
            DO 180 IFRQ = 1,NCHNBP
               INDEX = INDEX + 1
               JNDEX = JNDEX + 2
               IF ((ANTFLG .AND. ((BPBUF(JNDEX).EQ.0.0) .AND.
     *            (BPBUF(JNDEX+1).EQ.0.0))) .OR.
     *            (WTS(INDEX).LT.1E-8)) THEN
                  BPBUF(JNDEX) = FBLANK
                  BPBUF(JNDEX+1) = FBLANK
               ELSE
                  BPBUF(JNDEX) = BPBUF(JNDEX) / WTS(INDEX)
                  BPBUF(JNDEX+1) = BPBUF(JNDEX+1) / WTS(INDEX)
                  END IF
C                                       Second polarization
               IF (NPOLBP.GT.1) THEN
                  LNX = LNX + 1
                  INX = INX + 2
                  IF ((ANTFLG .AND. ((BPBUF(INX).EQ.0.0) .AND.
     *               (BPBUF(INX+1).EQ.0.0))) .OR.
     *               (WTS(LNX).LT.1E-8)) THEN
                     BPBUF(INX) = FBLANK
                     BPBUF(INX+1) = FBLANK
                  ELSE
                     BPBUF(INX) = BPBUF(INX) / WTS(LNX)
                     BPBUF(INX+1) = BPBUF(INX+1) / WTS(LNX)
                     END IF
                  END IF
 180           CONTINUE
 190        CONTINUE
         ANTNX(1,OANTNO) = BIND
C                                       Copy data to large VLB buffer
         IF (ISVLBA) CALL RCOPY (LRECA, BPBUF(BIND), VLBUF(VIND))
         BIND = BIND + LRECA
         VIND = VIND + LRECA
         CALL RFILL (LRECW, 0.0, WTS)
         ANTFLG = .FALSE.
         IF (.NOT.TABEND) GO TO 100
C                                       If interpolating or taking
C                                       the nearest bandpass cal
C                                       make list of rec numbers
C                                       get 1st time
      ELSE
         DO 290 I = 1,NBPINR
            CALL TABBP ('READ', BPBUFF, IBPRNO, BPKOLS, BPNUMV, NIFBP,
     *         NCHNBP, NPOLBP, TIME, INTERV, SOURID, SUBA, ANTNO,
     *         CHNBND, BPFREQ, FREQID, BPREF, WEIGHT, BNDPAS, IERR)
            IF (IERR.GT.0) THEN
               WRITE (MSGTXT,1000) IERR, 'READ', 'BP TABLE'
               GO TO 990
               END IF
C                                       Check freqid
            IF ((FREQID.NE.FRQSEL) .AND. (FREQID.GT.0) .AND.
     *         (FRQSEL.GT.0)) GO TO 290
            IF ((SUBA.NE.SUBARR) .AND. (SUBA.GT.0) .AND. (SUBARR.GT.0))
     *         GO TO 290
            IF (ANTREC(1,ANTNO).LE.0) ANTREC(1,ANTNO) = I
            ANTREC(2,ANTNO) = I
C                                      Need this antenna ?
            IF (SOMANT) THEN
               DO 210 J = 1,MAXANT
                  IF ((ANTNO.EQ.ABS(ANTENS(I))) .AND. (.NOT.DOAWNT))
     *               GO TO 290
                  IF ((ANTNO.EQ.ABS(ANTENS(J))) .AND. DOAWNT) GO TO 220
 210              CONTINUE
               IF (DOAWNT) GO TO 290
               END IF
C                                      Save first record in core
 220        IF (ANTREC(1,ANTNO).EQ.ANTREC(2,ANTNO)) THEN
               ANTNX(2,ANTNO) = IIND
               ANTNX(1,ANTNO) = BIND
               BPIBUF(IIND+KLOCT) = TIME
               BPIBUF(IIND+KLOCA) = ANTNO + 0.01 * MAX (SUBARR-1, 0)
               CALL RCOPY (LRECBP, BNDPAS, BPIBUF(IIND+2))
               CALL RCOPY (LRECWT, WEIGHT, BPIBUF(IIND+2+LRECBP))
               CALL RCOPY (LRECA, BPIBUF(IIND), BPBUF(BIND))
               IF (ISVLBA) CALL RCOPY (LRECA, BPIBUF(IIND), VLBUF(VIND))
               IIND = IIND + LRECS
               VIND = VIND + LRECA
               BIND = BIND + LRECA
               END IF
C                                       copy second for DOBAND>1
            IF (ANTREC(1,ANTNO).EQ.ANTREC(2,ANTNO)-1) THEN
               ANTNX(3,ANTNO) = IIND
               BPIBUF(IIND+KLOCT) = TIME
               BPIBUF(IIND+KLOCA) = ANTNO + 0.01 * MAX (SUBARR-1, 0)
               CALL RCOPY (LRECBP, BNDPAS, BPIBUF(IIND+2))
               CALL RCOPY (LRECWT, WEIGHT, BPIBUF(IIND+2+LRECBP))
               IIND = IIND + LRECS
               END IF
            IF (ANTNO.GT.MXANUM) MXANUM = ANTNO
            IF (ISVLBA) THEN
               DO 230 IFNO = 1,NIFBP
                  RTMP = BPFREQ(IFNO)
                  AVDELI(ANTNO,IFNO) = MAX(AVDELI(ANTNO,IFNO),RTMP)
 230              CONTINUE
               END IF
 290        CONTINUE
         END IF
      IERR = MAX (0, IERR)
      GO TO 999
C
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPASET: ERROR',I5,' ',A,'ING ',A)
 1005 FORMAT ('BPASET: ERROR',I4,' UPDATING BP FORMAT, CONTINUING')
 1010 FORMAT ('BPASET: ERROR',I5,' ALLOCATING',I8,' WORDS OF MEMORY')
      END

      SUBROUTINE SHSORT (A, N, KEY1, KEY2, LEN, IERR)
C-----------------------------------------------------------------------
C! Shell sort of an array or records on two keys
C# Sort UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SHSORT does a shell sort of records on two keys.  The algorithm is
C   CALCACM number 201.  Data are ordered to descending values of the
C   keys.
C   Inputs:
C      A      R(LEN,N)   Data array to be sorted.
C      N      I          Number of records to be sorted.
C      KEY1   I          Word number in record of slower varying key
C      KEY2   I          Word number in record of faster varying key
C      LEN    I          Length of record in REAL words (must be <=50)
C   Output:
C      A      R(LEN,N)   Sorted data.
C      IERR   I          Return code: 0 ok
C                             1 = bad input parameters.
C   Programmer: W. D. Cotton, Feb. 1981.
C-----------------------------------------------------------------------
      INTEGER   LEN, N, KEY1, KEY2, IERR
      REAL      A(LEN,N)
C
      INTEGER   D, I, J, LLN, LLEN
      REAL      Y(50)
C-----------------------------------------------------------------------
C                                        Check LEN
      IERR = 1
      LLN = N
      LLEN = LEN
      IF (LEN.GT.50) GO TO 999
      D = 1.442695 * LOG(REAL(LLN)) + 0.01
      D = 2**D - 1
      IERR = 0
 10   IF (D.LE.0) GO TO 999
         I = 1
 20      CONTINUE
            J = I
            CALL RCOPY (LLEN, A(1,I+D), Y)
 30         CONTINUE
            IF ((Y(KEY1).GT.A(KEY1,J)) .OR.((Y(KEY1).EQ.A(KEY1,J)) .AND.
     *         (Y(KEY2).GT.A(KEY2,J)))) GO TO 70
 50            CALL RCOPY (LLEN, Y, A(1,J+D))
               I = I + 1
               IF (I+D.LE.LLN) GO TO 20
               D = (D-1) / 2
               GO TO 10
 70         CONTINUE
               CALL RCOPY (LLEN, A(1,J), A(1,J+D))
               J = J - D
               IF (J.GT.0) GO TO 30
               GO TO 50
C
 999  RETURN
      END

      SUBROUTINE GTF3D (FDVEC, TBIND, NEXT, BUFFER, NBYTE, LINE, IERR)
C-----------------------------------------------------------------------
C! Copies real-world bytes from a tape buffer, reading if necessary.
C# IO-util Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   copies the next NBYTE bytes (8-bit, NOT half short integer) from the
C   input TAPIO stream pointed to by FDVEC to LINE.  A new tape record
C   will be read if necessary.
C   Inputs:
C      FDVEC(50)   I    File Descriptor vector used by TAPIO.  File
C                       must be in active read state.
C      NBYTE       I    Number of bytes to move.
C   Input/Output:
C      TBIND       I    Buffer pointer from TAPIO
C      NEXT        I    Pointer in BUFFER for next read (bytes).
C      BUFFER(*)   I    TAPIO buffer
C   Output:
C      LINE(*)     I    Output byte stream.
C      IERR        I    Error code, 0=> OK, else TAPIO error.
C                       10 => encountered problem with pointers
C-----------------------------------------------------------------------
      INTEGER   FDVEC(50), NBYTE, TBIND, NEXT, BUFFER(*), LINE(*), IERR
      INTEGER   NCOPY, NMOV, POINT, NBYTLF, EOB
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (NBYTE.LE.0) GO TO 999
C                                       Setup
      POINT = 1
      NMOV = NBYTE
C                                       Determine number of bytes in
C                                       current record.
 100     EOB = 1 + FDVEC(2)
         NBYTLF = EOB - NEXT
         NCOPY = NMOV
         IF (NBYTLF.LT.NCOPY) NCOPY = NBYTLF
C                                       Trap problem
         IF (NEXT.GT.EOB) GO TO 900
C                                       Copy bytes
         CALL ZBYMOV (NCOPY, NEXT, BUFFER(TBIND), POINT, LINE)
         NEXT = NEXT + NCOPY
         IF (NCOPY.GE.NMOV) GO TO 999
C                                       More to do
         POINT = POINT + NCOPY
         NMOV = NMOV - NCOPY
C                                       Read next record
         CALL TAPIO ('READ', FDVEC, BUFFER, TBIND, IERR)
         NEXT = 1
         IF (IERR.EQ.0) GO TO 100
      GO TO 999
C                                       Problem
 900  IERR = 10
      WRITE (MSGTXT,1900) NEXT, EOB
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('GTF3D: NEXT (',I6,') AND EOB (',I6,') ARE INCONSISTENT')
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QMTRAN (A, I, C, K, MC, NC)
C-----------------------------------------------------------------------
C! Pseudo AP routine: matrix transpose.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Transpose a matrix, doesn't work inplace.
C     C((p+qMC)K) = A((q+pNC)I)
C                 p = 0 to MC-1
C                 q = 0 to NC-1
C   Inputs:
C      A  I  Source matrix base address
C      I  I  A address increment
C      C  I  Destination  matrix base address
C      K  I  C address increment
C      MC I  Number of columns of A
C      NC I  Numbers of rows of A
C-----------------------------------------------------------------------
      INTEGER   A, I, C, K, MC, NC, IM, IN, JA, JC, JC1, JA1, DJC
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                       Addresses to 1-rel
      JA = A + 1
      JC = C + 1
      DJC = K * MC
C                                       Loop transposing.
C@DIR IGNORE RECRDEPS(APCORE)
      DO 200 IM = 1,MC
         JC1 = JC + K * (IM - 1)
         JA1 = JA + I * NC * (IM - 1)
C@DIR IGNORE RECRDEPS(APCORE)
         DO 100 IN = 1,NC
            APCORE(JC1) = APCORE(JA1)
            JC1 = JC1 + DJC
            JA1 = JA1 + I
 100        CONTINUE
 200     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE VLBPOL
C-----------------------------------------------------------------------
C! Fills polarization correction table for VLBI polarization data
C# UV EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2007, 2010, 2012, 2017-2018
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Fills polarization correction table from info in AN table for VLBI
C   polarization data.
C   Note:the elements of POLCAL are adjusted such that when DATPOL
C   rotates the values of RL and LR by the parallactic + Faraday
C   rotation angles that the result will be correct.
C   Inputs:
C      PANGLE   R(*)     Parallactic angles of the antennas (Rad)
C   Input from common: (DSEL.INC)
C      LAMBDA   R(*)     Wavelength of each channel and IF (m)
C      NLAMDA   I        Number channels in 1-d LAMBDA
C      IFR      R(*)     Faraday rotation of each antenna (rad/m**2)
C   Output to common DSEL.INC
C      POLCAL   R(2,*)   Polarization correction Values in order:
C                        By baseline
C                           By IF (EIF-BIF+1)
C                              A 4x4 complex matrix to be multiplied by
C                                  the observed polarization vector
C                                  (RR,LL,RL,LR) to produce the
C                                  corrected data.
C   Indexing scheme: an entry defined by ant1<ant2 starts in element:
C      (((ant1-1)*numant-((ant1+1)*ant1)/2 + ant2) - 1) + 1
C-----------------------------------------------------------------------
C      REAL      PANGLE(*)
C
      INTEGER   IIF, IANT1, IANT2, LIMIT, BLNDX, LIMIT2, BLPNT, LENTRY,
     *   II, LOFF, IC1, IC2, ICH, KR1, KR2, KL1, KL2, IFQ
      REAL      ANG1, ANG2, XSUM, XDIF, SXSUM, CXSUM, SXDIF, CXDIF,
     *   C2X1, S2X1, C2X2, S2X2, C2XDIF, S2XDIF
      COMPLEX   DR1, DR2, DL1, DL2, BLMAT(4,4), CD, CF
      LONGINT   POLPTR
      LOGICAL   FLAGED
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DPDC.INC'
C-----------------------------------------------------------------------
      CALL RFILL (32, 0.0, BLMAT)
      DO 30 II = 1,4
         BLMAT(II,II) = CMPLX (1.0, 0.0)
 30      CONTINUE
      IF (PDVER.GT.0) THEN
         IC1 = BCHAN
         IC2 = ECHAN
      ELSE
         IC1 = 1
         IC2 = 1
         IFQ = (BCHAN + ECHAN) / 2
         END IF
C                                       Compute correction matrices.
      LENTRY = PCLIF * PCLCH * 32
      LIMIT = NSTNS - 1
      DO 500 IANT1 = 1,LIMIT
         LIMIT2 = IANT1 + 1
         DO 490 IANT2 = LIMIT2,NSTNS
C                                       Set baseline index
            BLNDX = ((IANT1-1)*NSTNS) - (((IANT1-1)*IANT1)/2) + IANT2
C                                       Loop over IF
            DO 120 IIF = BIF,EIF
               BLPNT = LENTRY * (BLNDX-1) + (IIF-BIF)*32*PCLCH
               POLPTR = PPOLCL + BLPNT + 1 - 32
               IF (PDVER.GT.0) THEN
                  KR1 = (4 * PDNUMF * PDNUMI) * (IANT1 - 1) +
     *               2 * PDNUMF * (IIF - 1) + 2 * (BCHAN -1) + 1
                  KR2 = (4 * PDNUMF * PDNUMI) * (IANT2 - 1) +
     *               2 * PDNUMF * (IIF - 1) + 2 * (BCHAN -1) + 1
                  KL1 = KR1 + (2 * PDNUMF * PDNUMI)
                  KL2 = KR2 + (2 * PDNUMF * PDNUMI)
                  END IF
               DO 110 ICH = IC1,IC2
                  IF (PDVER.GT.0) IFQ = ICH
                  POLPTR = POLPTR + 32
                  FLAGED = .FALSE.
C                                       D-terms: continuum
                  IF (PDVER.LE.0) THEN
                     IF ((STNELP(1,IIF,IANT1).EQ.FBLANK) .OR.
     *                  (STNELP(2,IIF,IANT1).EQ.FBLANK) .OR.
     *                  (STNELP(1,IIF,IANT2).EQ.FBLANK) .OR.
     *                  (STNELP(2,IIF,IANT2).EQ.FBLANK) .OR.
     *                  (STNORI(1,IIF,IANT1).EQ.FBLANK) .OR.
     *                  (STNORI(2,IIF,IANT1).EQ.FBLANK) .OR.
     *                  (STNORI(1,IIF,IANT2).EQ.FBLANK) .OR.
     *                  (STNORI(2,IIF,IANT2).EQ.FBLANK)) THEN
                        FLAGED = .TRUE.
                     ELSE
                        DR1 = CMPLX (STNELP(1,IIF,IANT1),
     *                     STNORI(1,IIF,IANT1))
                        DL1 = CMPLX (STNELP(2,IIF,IANT1),
     *                     STNORI(2,IIF,IANT1))
                        DR2 = CMPLX (STNELP(1,IIF,IANT2),
     *                     STNORI(1,IIF,IANT2))
                        DL2 = CMPLX (STNELP(2,IIF,IANT2),
     *                     STNORI(2,IIF,IANT2))
                        END IF
                  ELSE
                     IF ((DTERMS(PDTERM+KR1).EQ.FBLANK) .OR.
     *                  (DTERMS(PDTERM+KR1+1).EQ.FBLANK) .OR.
     *                  (DTERMS(PDTERM+KL1).EQ.FBLANK) .OR.
     *                  (DTERMS(PDTERM+KL1+1).EQ.FBLANK) .OR.
     *                  (DTERMS(PDTERM+KR2).EQ.FBLANK) .OR.
     *                  (DTERMS(PDTERM+KR2+1).EQ.FBLANK) .OR.
     *                  (DTERMS(PDTERM+KL2).EQ.FBLANK) .OR.
     *                  (DTERMS(PDTERM+KL2+1).EQ.FBLANK)) THEN
                        FLAGED = .TRUE.
                     ELSE
                        DR1 = CMPLX (DTERMS(PDTERM+KR1),
     *                     DTERMS(PDTERM+KR1+1))
                        DL1 = CMPLX (DTERMS(PDTERM+KL1),
     *                     DTERMS(PDTERM+KL1+1))
                        DR2 = CMPLX (DTERMS(PDTERM+KR2),
     *                     DTERMS(PDTERM+KR2+1))
                        DL2 = CMPLX (DTERMS(PDTERM+KL2),
     *                     DTERMS(PDTERM+KL2+1))
                        END IF
                     KR1 = KR1 + 2
                     KL1 = KL1 + 2
                     KR2 = KR2 + 2
                     KL2 = KL2 + 2
                     END IF
C                                       D terms: line
C                                       Paralactic angle, Faraday
C                                       rotation terms
C                                       NOTE: DATPOL will flag the data
C                                       if either IFR is blank so we
C                                       just ignore it here.
                  LOFF = (IIF - 1) * NLAMDA + IFQ
                  IF (IFR(IANT1).NE.FBLANK) THEN
                     ANG1 = PANGLE(IANT1) + LAMBDA(LOFF)**2 * IFR(IANT1)
                  ELSE
                     ANG1 = PANGLE(IANT1)
                     END IF
                  IF (IFR(IANT2).NE.FBLANK) THEN
                     ANG2 = PANGLE(IANT2) + LAMBDA(LOFF)**2 * IFR(IANT2)
                  ELSE
                     ANG2 = PANGLE(IANT2)
                     END IF
                  XSUM = ANG1 + ANG2
                  XDIF = ANG1 - ANG2
                  CXSUM = COS (XSUM)
                  SXSUM = SIN (XSUM)
                  CXDIF = COS (XDIF)
                  SXDIF = SIN (XDIF)
C                                       Linear approximation
                  IF ((MOD(DOPOL,10).LE.1) .OR. (MOD(DOPOL,10).EQ.6))
     *               THEN
                     IF (FLAGED) THEN
                        BLMAT(3,1) = CMPLX (FBLANK, 0.0)
                        BLMAT(3,2) = CMPLX (FBLANK, 0.0)
                        BLMAT(3,3) = CMPLX (FBLANK, 0.0)
C                                       2nd cross.
                        BLMAT(4,1) = CMPLX (FBLANK, 0.0)
                        BLMAT(4,2) = CMPLX (FBLANK, 0.0)
                        BLMAT(4,4) = CMPLX (FBLANK, 0.0)
C                                       Add correction terms:
                     ELSE
C                                       1st cross.
                        BLMAT(3,1) = -CONJG (DL2) * CMPLX (CXDIF,-SXDIF)
                        BLMAT(3,2) = -DR1 * CMPLX (CXDIF, SXDIF)
                        BLMAT(3,3) = CMPLX (CXSUM, -SXSUM)
C                                       2nd cross.
                        BLMAT(4,1) = -DL1 * CMPLX (CXDIF, -SXDIF)
                        BLMAT(4,2) = -CONJG (DR2) * CMPLX (CXDIF, SXDIF)
                        BLMAT(4,4) = CMPLX (CXSUM, SXSUM)
                        END IF
C                                       Full 2nd order correction
                  ELSE
                     IF (FLAGED) THEN
                        CALL RFILL (32, FBLANK, BLMAT)
                     ELSE
                        C2X1 = COS (2.0 * ANG1)
                        S2X1 = SIN (2.0 * ANG1)
                        C2X2 = COS (2.0 * ANG2)
                        S2X2 = SIN (2.0 * ANG2)
                        C2XDIF = COS (2.0 * XDIF)
                        S2XDIF = SIN (2.0 * XDIF)
                        CD = DR1 * DL1 + CONJG (DR2) * CONJG (DL2)
                        CF = 1.0 / (1.0 - 2.0 * CD)
C                                       1st par.
                        BLMAT(1,1) = CF * (1.0 - CD)
                        BLMAT(1,2) = CF * (DR1 * CONJG (DR2) *
     *                     CMPLX (C2XDIF, S2XDIF))
                        BLMAT(1,3) = CF * (-CONJG (DR2) *
     *                     CMPLX (C2X2, -S2X2))
                        BLMAT(1,4) = CF * (-DR1 * CMPLX (C2X1, S2X1))
C                                       2nd par..
                        BLMAT(2,1) = CF * (DL1 * CONJG (DL2) *
     *                     CMPLX (C2XDIF, -S2XDIF))
                        BLMAT(2,2) = CF * (1.0 - CD)
                        BLMAT(2,3) = CF * (-DL1 * CMPLX (C2X1, -S2X1))
                        BLMAT(2,4) = CF * (-CONJG (DL2) *
     *                     CMPLX (C2X2, S2X2))
C                                       1st cross.
                        BLMAT(3,1) = CF * (-CONJG (DL2) *
     *                     CMPLX (CXDIF, -SXDIF))
                        BLMAT(3,2) = CF * (-DR1 * CMPLX (CXDIF, SXDIF))
                        BLMAT(3,3) = CF * (1.0 - CD) *
     *                     CMPLX (CXSUM, -SXSUM)
                        BLMAT(3,4) = CF * (CONJG (DL2) * DR1 *
     *                     CMPLX (CXSUM, SXSUM))
C                                       2nd cross.
                        BLMAT(4,1) = CF * (-DL1 * CMPLX (CXDIF, -SXDIF))
                        BLMAT(4,2) = CF * (-CONJG (DR2) *
     *                     CMPLX (CXDIF, SXDIF))
                        BLMAT(4,3) = CF * (DL1 * CONJG (DR2) *
     *                     CMPLX (CXSUM, -SXSUM))
                        BLMAT(4,4) = CF * (1.0 - CD) *
     *                     CMPLX (CXSUM, SXSUM)
                        END IF
                     END IF
                  CALL RCOPY (32, BLMAT, POLCAL(POLPTR))
 110              CONTINUE
 120           CONTINUE
 490        CONTINUE
 500     CONTINUE
C                                       Exit
 999  RETURN
      END

      SUBROUTINE SCHOLD (QUIT)
C-----------------------------------------------------------------------
C! wait for user input on screen full, allows type ahead, quit, continue
C# POPS-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   SCHOLD (screen hold) will wait for the user to press return or enter
C   a 'Q' for quit, thus giving the user time to read his screen before
C   CRT printout continues.  This also gives the user a chance to stop a
C   long printout without waiting for it to finish.
C   Output:
C      QUIT   L    F if Q not entered, T if Q entered by user
C-----------------------------------------------------------------------
      LOGICAL   QUIT
C
      CHARACTER LPT*1
      INTEGER   LIUNIT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DIO.INC'
C-----------------------------------------------------------------------
      QUIT = .FALSE.
C                                       meaningful only in non-batch
      IF (NPOPS.GT.NINTRN+1) GO TO 999
      IF (ISBTCH.EQ.32000) GO TO 999
      IF ((NPOPS.EQ.NINTRN+1) .AND. (TSKNAM.NE.'BATER') .AND.
     *   (TSKNAM.NE.'GRIPR')) GO TO 999
      IF (TSKNAM(1:5).EQ.'AIPSC') GO TO 999
C                                      Stop until user reads this page.
      IF ((IUNIT.NE.1) .AND. (IUNIT.NE.4)) GO TO 999
         WRITE (MSGTXT,1000)
         CALL MSGWRT (1)
         LPT = IPT
         LIUNIT = IUNIT
         IUNIT = 1
         IPT = '#'
         CALL PREAD (KARBUF)
         IUNIT = LIUNIT
         IPT = LPT
C                                       See if we need to quit print.
         IF (NBYTES.EQ.0) GO TO 999
            QUIT = .TRUE.
            CALL CHLTOU (4, JBUFF)
            IF ((JBUFF(1:2).EQ.'Q ') .OR. (JBUFF(1:5).EQ.'QUIT ') .OR.
     *         (IUNIT.EQ.4)) GO TO 999
               HOLDUF = JBUFF
               IUNIT = 4
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('** press RETURN for more, enter Q or next line ',
     *   'to quit print **')
      END

      SUBROUTINE YWINDO (OPER, WIND, IERR)
C-----------------------------------------------------------------------
C! set the current window (viewport) into the TV memory
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   YWINDO reads the current viewport into the TV memory.  It is hoped
C   that someday we will also offer writing to force the size.
C   Inputs:
C      OPER   C*4    'READ', 'WRIT'
C   In/out:
C      WIND   I(4)   BLC x,y, TRC x,y of window in TV pixels
C                    In: desired window ('WRIT' only)
C                    Out: actual window given
C   Output:
C      IERR    I     error code of Z...XF: 0 -> ok, 2 -> input error
C                    1 -> bad window returned, 11 -> comm. failure
C   SUN Screen Server TV version.
C-----------------------------------------------------------------------
      CHARACTER OPER*(*)
      INTEGER   WIND(4), IERR
C
      INTEGER   OPCODE, DAT(4), NWSD, TMPBUF(4), SCRTCH(256)
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF (OPER.EQ.'WRIT') THEN
         IF (WIND(1).GE.WIND(3)) GO TO 999
         IF (WIND(2).GE.WIND(4)) GO TO 999
         IF ((WIND(1).LT.1) .OR. (WIND(1).GT.MAXXTV(1))) GO TO 999
         IF ((WIND(2).LT.1) .OR. (WIND(2).GT.MAXXTV(2))) GO TO 999
         IF ((WIND(3).LT.1) .OR. (WIND(3).GT.MAXXTV(1))) GO TO 999
         IF ((WIND(4).LT.1) .OR. (WIND(4).GT.MAXXTV(2))) GO TO 999
         CALL COPY (4, WIND, DAT)
      ELSE IF (OPER.EQ.'READ') THEN
         CALL FILL (4, 0, DAT)
      ELSE
         GO TO 999
         END IF
C                                       Do it now
      OPCODE = 14
      CALL ZSSSXF (OPCODE, DAT, 0, TMPBUF, NWSD, IERR)
      IF ((NWSD.NE.8) .AND. (IERR.EQ.0)) IERR = 11
      IF (IERR.NE.0) GO TO 999
C                                       returned corners
      CALL ZI16IL (4, 1, TMPBUF, WIND)
      IF (WIND(1).GE.WIND(3)) IERR = 1
      IF (WIND(2).GE.WIND(4)) IERR = 1
      IF ((WIND(1).LT.1) .OR. (WIND(1).GT.MAXXTV(1))) IERR = 1
      IF ((WIND(2).LT.1) .OR. (WIND(2).GT.MAXXTV(2))) IERR = 1
      IF ((WIND(3).LT.1) .OR. (WIND(3).GT.MAXXTV(1))) IERR = 1
      IF ((WIND(4).LT.1) .OR. (WIND(4).GT.MAXXTV(2))) IERR = 1
      IF (IERR.NE.0) THEN
         MSGTXT = 'Window size error: interogating parms'
         CALL MSGWRT (6)
C                                       Now ask it for parameter common
         CALL YDTVC ('GET ', SCRTCH, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'Get parameters from XAS'
            CALL MSGWRT (7)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' on ',A)
      END

      SUBROUTINE JULDAY (CLD, JD)
C-----------------------------------------------------------------------
C! converts a character-encoded calendar date to Julian day number
C# Utility Header FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   converts a character encoded Gregorian calendar date into a Julian
C   day number.
C   Inputs:
C       CLD   C*8   Gregorian calander date in form 'DD/MM/YY' or in new
C                   form 'YYYYMMDD'
C   Output:
C       JD    D     Julian date.
C   Algorithm from ACM Algorithm number 199
C   NOTE:  This routine is good from 1 Mar 1900 indefinitely.
C-----------------------------------------------------------------------
      CHARACTER CLD*8
      DOUBLE PRECISION JD
C
      INTEGER   IDATE(3)
      DOUBLE PRECISION K, D, M, YA, C
C-----------------------------------------------------------------------
C                                       Get date
      CALL DATEST (CLD, IDATE)
C                                       Convert to D
      YA = IDATE(1)
      M  = IDATE(2)
      D  = IDATE(3)
      IF (M.LE.2.0D0) THEN
         M = AINT (M + 9.0D0)
         YA = AINT (YA - 1.0D0)
      ELSE
         M = AINT (M - 3.0D0)
         END IF
      C = AINT (YA/100.0D0)
      YA = YA - 100.0D0 * C
      K = AINT (146097.D0 * C * 0.25D0) + AINT (1461.0D0 * YA * 0.25D0)
     *   + AINT ((153.0D0 * M + 2.0D0) * 0.2D0) + D
C                                       Following good for > 20th cent.
      JD = AINT (K) + 1721118.50D0
      GO TO 999
C                                       Error
 900  JD = 0.0D0
C
 999  RETURN
      END

      SUBROUTINE ZSSSCL (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C! close the SUN-Screen-Server device
C# TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Close the SUNview AIPS TV device associated with LUN and clear its
C   FTAB entry.
C   Inputs:
C      LUN    I   Logical unit number
C      FIND   I   Index in FTAB to file control block for LUN
C   Output:
C      IERR   I   Error return code: 0 => no error
C                    1 => close error or flush error
C                    2 => file already closed in FTAB
C                    3 => both errors
C                    4 => erroneous LUN
C   SUN - SSS (SUNview Screen Server) version.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
C
      INTEGER   JERR, TVDEVN
      LOGICAL   F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA F /.FALSE./
      DATA TVDEVN /4/
C-----------------------------------------------------------------------
C                                       Check inputs.
      IERR = 4
C                                       Valid LUN?
      IF (LUN.EQ.TVLUN) GO TO 10
         WRITE (MSGTXT,1000) LUN
         GO TO 995
C                                       Valid device type?
 10   IF (DEVTAB(LUN).EQ.TVDEVN) GO TO 20
         WRITE (MSGTXT,1010) LUN, DEVTAB(LUN)
         GO TO 995
C                                       Locate LUN in FTAB.
 20   IERR = 0
      CALL LSERCH ('SRCH', LUN, FIND, F, JERR)
C                                       LUN already closed in FTAB.
      IF (JERR.EQ.0) GO TO 30
         IERR = 2
         WRITE (MSGTXT,1020) LUN
         GO TO 995
C                                       Deassign socket
 30   CALL ZSSSC2 (FTAB(FIND+NMOFF), JERR)
      IF (JERR.NE.0) THEN
         IERR = IERR + 2
         WRITE (MSGTXT,1030)
         CALL MSGWRT (7)
         END IF
      TVBROK = 0
C                                       Clear FTAB entry.
 40   CALL LSERCH ('CLOS', LUN, FIND, F, JERR)
C                                       LUN already closed in FTAB.
      IF (JERR.EQ.0.) GO TO 999
         IERR = IERR + 2
         WRITE (MSGTXT,1040) LUN
C
 995  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZSSSCL: INVALID LUN = ',I2)
 1010 FORMAT ('ZSSSCL: DEVTAB(',I2,') = ',I1,' = INVALID DEVICE TYPE')
 1020 FORMAT ('ZSSSCL: LUN = ',I2,' ALREADY CLOSED IN FTAB ON SEARCH')
 1030 FORMAT ('ZSSSCL: ZSSSC2 RETRUNS ERROR DEASSIGNING THE TV SOCKET')
 1040 FORMAT ('ZSSSCL: LUN = ',I2,' ALREADY CLOSED IN FTAB ON CLOSE')
      END

      SUBROUTINE ZRXDWR (LUN, FIND, CODE, IRET)
C-----------------------------------------------------------------------
C! write expedited data to a server
C# IO-remote Z
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Write one byte of expedited data to a server.
C
C   Inputs:
C      LUN          I         Logical unit number of connection.
C      FIND         I         Index of connection entry in FTAB
C                             (redundant).
C      CODE         I         Byte to be written.
C
C   Outputs:
C      IRET         I         Error code:
C                                0 => byte sent successfully
C                                1 => bad inputs
C                                2 => LUN not open
C                                3 => system error
C                                4 => partner closed connection
C                               99 => other error.
C
C   Generic version.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, CODE, IRET

      INTEGER   FCBOFF, ITYP, INUM, IERR

      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE 'INCS:DMSG.INC'

      INTEGER    MAXLUN
      PARAMETER (MAXLUN = 50)
C-----------------------------------------------------------------------
      IRET = 0

C                                       Check inputs:
      IF ((CODE.LT.0) .OR. (CODE.GT.255)) THEN
         IRET = 1
         WRITE (MSGTXT, 1000)
         CALL MSGWRT (6)
         END IF
      IF (IRET .EQ. 0) THEN
         IF ((LUN.LT.1) .OR. (LUN.GT.MAXLUN)) THEN
            IRET = 1
            WRITE (MSGTXT, 1001) LUN, MAXLUN
            CALL MSGWRT (6)
            END IF
         END IF
      IF (IRET .EQ. 0) THEN
         IF ((DEVTAB(LUN).EQ.1) .OR. (DEVTAB(LUN).EQ.3)) THEN
            IRET = 1
            WRITE (MSGTXT, 1002) LUN, DEVTAB(LUN)
            CALL MSGWRT (6)
            END  IF
         END IF

      IF (IRET .EQ. 0) THEN
C                                       Find location of file control
C                                       block:
         CALL LSERCH ('SRCH', LUN, FIND, .FALSE., IERR)
         IF (IERR .EQ. 1) THEN
            IRET = 2
            WRITE (MSGTXT, 1003) LUN
            CALL MSGWRT (6)
         ELSE IF (IERR .NE. 0) THEN
            IRET = 99
            WRITE (MSGTXT, 1004) IERR
            CALL MSGWRT (6)
         ELSE
            FCBOFF = FIND + NMOFF
            END IF
         END IF

      IF (IRET .EQ. 0) THEN
C                                       Find the location of the channel
C                                       name (NONNAM(INUM)) for error
C                                       messages:
         CALL FSERCH (FIND, ITYP, INUM, IERR)
         IF (IERR .NE. 0) THEN
            IRET = 99
            WRITE (MSGTXT, 1005) IERR
            CALL MSGWRT (6)
            END IF
         END IF

      IF (IRET .EQ. 0) THEN
C                                       Write expedited data:
         CALL ZRXDW2 (FTAB(FCBOFF), CODE, IERR)
         IF (IERR .EQ. 2) THEN
            IRET = 4
            WRITE (MSGTXT, 1006)
            CALL MSGWRT (6)
         ELSE IF (IERR .NE. 0) THEN
            IRET = 3
            WRITE (MSGTXT, 1007)
            CALL MSGWRT (6)
            CALL ZERROR ('ZRXDWR', FTAB(FCBOFF+FCBERR), NONNAM(INUM),
     *         FTAB(FCBOFF), .TRUE.)
            END IF
         END IF

      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZRXDWR: CODE MUST BE IN RANGE 0 TO 255')
 1001 FORMAT ('ZRXDWR: LUN ', I4, ' OUT OF RANGE (1 TO ', I2, ')')
 1002 FORMAT ('ZRXDWR: LUN ', I2, ' HAS WRONG TYPE (', I1, ')')
 1003 FORMAT ('ZRXDWR: LUN ', I2, ' IS NOT OPEN')
 1004 FORMAT ('ZRXDWR: LSERCH (SEARCH) RETURNS ERROR ', I2)
 1005 FORMAT ('ZRXDWR: FSERCH RETURNS ERROR ', I2)
 1006 FORMAT ('ZRXDWR: PARTNER UNEXPECTED CLOSED CONNECTION')
 1007 FORMAT ('ZRXDWR: FAILED TO WRITE EXPEDITED DATA')
      END

      SUBROUTINE SOUNDX (DISKIN, CNOIN, DOWANT, NUMSOU, SULIST, IERR)
C-----------------------------------------------------------------------
C! Compares source wanted list with INDEX table
C# EXT-util UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SOUNDX: compares a source list with entries in the INDEX table to
C   Determine whether sources were observed with a requested Frequency
C   ID (FRQSEL).  SOUNDX removes sources from an already created list
C   or adds sources to a wanted source list.  SOUNDX does nothing
C   if all Frequency Ids are selected (FRQSEL<=0).
C   This program is designed to solve the problem of two identical
C   source names with different qualifiers.
C    Inputs:
C     DISKIN       I   Input Disk Number
C     CNOIN        I   Input Catalog number
C    Input/output:
C     DOWANT       L   TRUE if sources in list are wanted (not excluded)
C     NUMSOU       I   Number of sources wanted/unwanted
C     SULIST(?)    I   List of sources wanted
C    Output:
C     IERR         I   Error code, 0=>OK else TABIO error.
C                                 10=>buffer size error
C    Inputs from common:
C     FRQSEL       I   Frequency ID wanted
C-----------------------------------------------------------------------
      INTEGER DISKIN, CNOIN, NUMSOU, SULIST(*), IERR
      LOGICAL DOWANT
C-----------------------------------------------------------------------
      INCLUDE 'INCS:DSEL.INC'
      INTEGER INXLUN, NDXRNO, LOOP, I, NXSOUR, NXSUB, NXVS, NXVE, NXFQI,
     *   NXVER, SELIST(XSTBSZ), NINLST
      LOGICAL INLIST, WANTED
      REAL    NXTIME, NXDTIM
      INCLUDE 'INCS:DMSG.INC'
      DATA INXLUN /28/
C-----------------------------------------------------------------------
      IERR=0
C                                       If no frequencies selected, exit
      IF (FRQSEL.LE.0) GO TO 999
C                                       If no sources in list, exclude
      WANTED = DOWANT
      IF (NUMSOU.LE.0) WANTED = .FALSE.
C                                       If not enough buffer space
      IF (NUMSOU.GT.XSTBSZ) THEN
         MSGTXT = 'SCRATCH SOURCE LIST BUFFER SIZE EXCEEDED'
         CALL MSGWRT(5)
         NUMSOU = XSTBSZ
         IERR = 10
         END IF
C                                       If wanted init Search list
      IF (WANTED) THEN
         CALL FILL (NUMSOU, 0, SELIST)
C                                       Else copy unwanted list
      ELSE
         CALL COPY (NUMSOU, SULIST, SELIST)
         END IF
C                                       Init Output Count Source
      NINLST = 0
C                                       Initialize index table
      NXVER = 1
      CALL NDXINI ('READ', NXBUFF, DISKIN, CNOIN, NXVER, CATBLK, INXLUN,
     *   NDXRNO, NXKOLS, NXNUMV, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get number of index records
      NINDEX = NXBUFF(5)
C                                       Loop thru index table
      DO 300 LOOP = 1,NINDEX
C                                       Read index table
         NDXRNO = LOOP
         CALL TABNDX ('READ', NXBUFF, NDXRNO, NXKOLS, NXNUMV, NXTIME,
     *      NXDTIM, NXSOUR, NXSUB, NXVS, NXVE, NXFQI, IERR)
         IF (IERR.GT.0) GO TO 999
C                                       For all sources in wanted list
         IF (WANTED) THEN
C                                       If source # is wanted + OK freq
C                                       Mark as a wanted source
            DO 100 I = 1,NUMSOU
               IF ((NXSOUR.EQ.SULIST(I)) .AND. ((FRQSEL.EQ.NXFQI) .OR.
     *            (FRQSEL.LE.0) .OR. (NXFQI.LE.0))) SELIST(I) = NXSOUR
 100           CONTINUE
C                                       Else an unwanted list
         ELSE
C                                       Assume source not in list
            INLIST = .FALSE.
C                                       If source # is in unwanted list
            IF (NUMSOU.GT.0) THEN
               DO 200 I = 1,NUMSOU
                  IF (NXSOUR.EQ.SELIST(I)) INLIST = .TRUE.
 200              CONTINUE
               END IF
C                                       If source # is in wanted list
C                                       Do not add again
            IF (NINLST.GT.0) THEN
               DO 250 I = 1,NINLST
                  IF (NXSOUR.EQ.SULIST(I)) INLIST = .TRUE.
 250              CONTINUE
               END IF
C                                       If freq id matched add to wanted
C                                       list
            IF ((.NOT.INLIST) .AND. ((FRQSEL.EQ.NXFQI) .OR.
     *         (FRQSEL.LE.0) .OR. (NXFQI.LE.0))) THEN
               NINLST = NINLST + 1
               IF (NINLST.GT.XSTBSZ) THEN
                  MSGTXT = 'SOUNDX: SOURCE LIST SIZE EXCEEDED'
                  CALL MSGWRT(5)
                  NINLST = XSTBSZ
                  IERR = 10
                  END IF
               SULIST(NINLST) = NXSOUR
               END IF
            END IF
 300     CONTINUE
C                                       Close  INDEX table
      CALL TABIO ('CLOS', 0, NDXRNO, NXBUFF, NXBUFF, IERR)
C                                       If started with a wanted list
      IF (WANTED) THEN
C                                       Re-Fill Wanted list
C                                       If in match list
         DO 400 I = 1,NUMSOU
            IF (SELIST(I).GT.0) THEN
               NINLST = NINLST + 1
               SULIST(NINLST) = SELIST(I)
               END IF
 400        CONTINUE
         END IF
C                                       Rest count
      NUMSOU = NINLST
C                                       Zero rest of list
      IF (NUMSOU.LT.XSTBSZ)
     *   CALL FILL (XSTBSZ-NUMSOU, 0, SULIST(NUMSOU+1))
C                                       If sources are left, use WANTED
      IF (NUMSOU.GE.0) DOWANT = .TRUE.
C
 999  RETURN
      END

      SUBROUTINE COLR2S (NLEVS, TYPE, X0, SATUR, HUE, GAMMA, IERR)
C-----------------------------------------------------------------------
C! writes OFM with 2-color
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   COLOR2S uses an STC algorithm to produce 2-color intensity wedges
C   in the lightness-hue-saturation space.
C   Inputs:
C      NLEVS   I      number of intensities
C      TYPE    I      -1 down from X0, 0 level, +1 up from X0
C      X0      R      break point between the colors
C      SATUR   R(2)   saturation at X0, saturation at ends
C      HUE     R(2)   hue at left, hue at right (0 - 360)
C      GAMMA   R      gamma correction power (2.7 or 1.8 ok?)
C   Output:
C      IERR    I          error code of ZM70XF
C-----------------------------------------------------------------------
      INTEGER    NLEVS, TYPE, IERR
      REAL       X0, SATUR(2), HUE(2), GAMMA
C
      INCLUDE 'INCS:PTVC.INC'
      INTEGER    KOLR, IT, LEVS, NW, IX0, I
      REAL       ALPHA, BETA, GAMINV, H, DTOR, Z, X, S, A, B, L, Y3, Y,
     *   COLR, COLX(3), COLY(3), COLZ(3),LBUF(TVMOFM,3), V
      LOGICAL     VRTRTC
      INCLUDE 'INCS:DTVC.INC'
      DATA  COLX /  0.125, -1.090,  2.580/,
     *      COLY / -0.295,  2.040, -1.150/,
     *      COLZ /  1.170,  0.058, -0.422/
      DATA VRTRTC, DTOR /.TRUE., 0.017452393/
C-----------------------------------------------------------------------
C                                        check input some
      IERR = 2
      IF (GAMMA.LE.0.0) GO TO 999
      NW = TVMOFM
      LEVS = MIN (OFMINP+1, NLEVS)
      IF (LEVS.LT.32) LEVS = LUTOUT + 1
      IF (LEVS.GT.OFMINP+1) LEVS = OFMINP + 1
      IX0 = X0 * LEVS + 0.05
      ALPHA = 0.0
      BETA = (SATUR(2) - SATUR(1))
      GAMINV = 1.0 / GAMMA
      IT = OFMINP + 1
      CALL RFILL (IT, 0.0, LBUF(1,1))
      CALL RFILL (IT, 0.0, LBUF(1,2))
      CALL RFILL (IT, 0.0, LBUF(1,3))
C                                       constant
      S = 100.0
      H = HUE(1) * DTOR
      V  = 1.0
      DO 20 I = 1,LEVS
         IF (I.LE.IX0) THEN
            L = 20.
            S = FLOAT (IX0-I) / FLOAT (IX0) * BETA + SATUR(1)
            A = S * COS(H)
            B = S * SIN(H)
            IF (TYPE.LT.0) THEN
               V = FLOAT (I-1) / FLOAT (IX0-1)
            ELSE IF (TYPE.EQ.0.0) THEN
               V = 1.0
            ELSE
               V = FLOAT (IX0-I) / FLOAT (IX0-1)
               END IF
            V = V ** 1.5
C                                       LAB colors to RGB colors
            Y3 = (L + 16.0) / 116.0
            Y = Y3 ** 3
            X = (A/500.0 + Y3) ** 3
            Z = (Y3 - B/200.0) ** 3
            DO 10 KOLR = 1,3
               COLR = X * COLX(KOLR) + Y * COLY(KOLR) + Z * COLZ(KOLR)
               COLR = MAX (0.0, MIN (1.0, COLR))
               COLR = COLR ** GAMINV
               COLR = COLR * V
               COLR = MAX (0.0, MIN (1.0, COLR))
               LBUF(I,KOLR) = COLR
 10            CONTINUE
            IF (I.EQ.IX0) THEN
               H = HUE(2) * DTOR
               A = S * COS(H)
               B = S * SIN(H)
            END IF
         ELSE
            L = 65.
            S = FLOAT (IX0-I) / FLOAT (IX0) * BETA + SATUR(1)
            A = S * COS(H)
            B = S * SIN(H)
            IF (TYPE.LT.0) THEN
               V = FLOAT (LEVS-I) / FLOAT (LEVS-IX0-1)
            ELSE IF (TYPE.EQ.0.0) THEN
               V = 1.0
            ELSE
               V = FLOAT (I-IX0-1) / FLOAT (LEVS-IX0-1)
               END IF
            V = V ** 1.5
C                                       LAB colors to RGB colors
            Y3 = (L + 16.0) / 116.0
            Y = Y3 ** 3
            X = (A/500.0 + Y3) ** 3
            Z = (Y3 - B/200.0) ** 3
            DO 15 KOLR = 1,3
               COLR = X * COLX(KOLR) + Y * COLY(KOLR) + Z *
     *            COLZ(KOLR)
               COLR = MAX (0.0, MIN (1.0, COLR))
               COLR = COLR ** GAMINV
               COLR = COLR * V
               COLR = MAX (0.0, MIN (1.0, COLR))
               LBUF(I,KOLR) = COLR
 15            CONTINUE
            END IF
 20      CONTINUE
C                                        loop over colors r g b
      LBUF(1,1) = 0.
      LBUF(1,2) = 0.
      LBUF(1,3) = 0.
      CALL OFMIO ('WRIT', NW, LEVS, VRTRTC, LBUF, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END

      SUBROUTINE CENTFQ (DISK, CNO, DIFPIX, BUFF1, BUFF2, IRET)
C-----------------------------------------------------------------------
C! Correct FQ values for centering frequency axis
C# UV IO-appl Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 2014
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Corrects FQ table ref pixel frequencies for a change in ref pixel
C   Inputs:
C     DISK     I      Volume number
C     CNO      I      Catalog number
C     DIFPIX   R      Pixel shift
C   Input (via common DUVH, MAPHDR)
C     JLOCF    I      frequency axis pointer
C     CATBLK   I(*)   output image header
C   Outputs:
C     IRET     I      Error code, 0 => OK, > 0 => FQ table error
C-----------------------------------------------------------------------
      INTEGER  DISK, CNO, BUFF1(*), BUFF2(*), IRET
      REAL     DIFPIX
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER  NIF, NUMFQE, FQID, FQSID(MAXIF), I, VER, LUNI, LUNO,
     *   FQKOLI(MAXFQC), FQNUMI(MAXFQC), FQKOLO(MAXFQC), FQNUMO(MAXFQC),
     *   IFQRNO, LUNTMP, J, NVER, MSGSAV
      REAL     FQCHB(MAXIF), FQTBW(MAXIF), HEDCHB
      DOUBLE PRECISION FQFRQ(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (DIFPIX.EQ.0.0) GO TO 999
      CALL FNDEXT ('FQ', CATBLK, I)
      IF (I.LE.0) GO TO 500
      HEDCHB = CATR(KRCIC+JLOCF)
C                                       Open FQ table
      VER = 1
      LUNI = LUNTMP (1)
      CALL FQINI ('READ', BUFF1, DISK, CNO, VER, CATBLK, LUNI, IFQRNO,
     *   FQKOLI, FQNUMI, NIF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT FQ TABLE'
         GO TO 990
         END IF
      NUMFQE = BUFF1(5)
C                                       output
      LUNO = LUNTMP (1)
      NVER = 0
      CALL FQINI ('WRIT', BUFF2, DISK, CNO, NVER, CATBLK, LUNO, IFQRNO,
     *   FQKOLO, FQNUMO, NIF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT FQ TABLE'
         GO TO 990
         END IF
C
      DO 100 I = 1,NUMFQE
         IFQRNO = I
         CALL TABFQ ('READ', BUFF1, IFQRNO, FQKOLI, FQNUMI, NIF, FQID,
     *      FQFRQ, FQCHB, FQTBW, FQSID, BNDCOD, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT FQ TABLE'
            GO TO 990
            END IF
C                                       adjust
         DO 20 J = 1,NIF
            FQFRQ(J) = FQFRQ(J) + DIFPIX * (FQCHB(J) - HEDCHB)
 20         CONTINUE
C                                       write
         IFQRNO = I
         CALL TABFQ ('WRIT', BUFF2, IFQRNO, FQKOLO, FQNUMO, NIF, FQID,
     *      FQFRQ, FQCHB, FQTBW, FQSID, BNDCOD, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT FQ TABLE'
            GO TO 990
            END IF
 100     CONTINUE
C                                       Close table
      CALL TABIO ('CLOS', 0, IFQRNO, BUFF1, BUFF1, I)
      CALL TABIO ('CLOS', 0, IFQRNO, BUFF2, BUFF2, I)
C                                       Delete the original file
      CALL RMEXT (DISK, CNO, 'FQ', VER, CATBLK, BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'DELETE ORIGINAL'
         GO TO 990
         END IF
C                                       Copy new file to place
C                                       occupied by old one
      MSGSAV = MSGSUP
      MSGSUP = 31999
      CALL TABCOP ('FQ', NVER, VER, LUNO, LUNI, DISK, DISK, CNO, CNO,
     *   CATBLK, BUFF1, BUFF2, IRET)
      MSGSUP = MSGSAV
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'COPYING TEMP TO OLD'
         GO TO 990
         END IF
C                                       Delete the now defunct
C                                       original output file
      CALL RMEXT (DISK, CNO, 'FQ', NVER, CATBLK, BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'DELETE TEMP'
         GO TO 990
         END IF
C                                       check SU table too
 500  CALL CENTSU (DISK, CNO, DIFPIX, BUFF1, BUFF2, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CENTFQ ERROR:',I5,' ON ',A)
      END

      SUBROUTINE HUNT (K, L, NT, ISTART, KHUNT)
C-----------------------------------------------------------------------
C! searches a linked list for words to be matched
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   HUNT searches a linked list by words - usually the literal values
C   list, since CHUNT is used to do min-match on the SYMBOL names.
C   Inputs:
C      K      I(*)   contains linked tables
C      NT     I      number of words to match
C      ISTART I      offset within each table entry for matching
C      KHUNT  I(NT)  words to be matched
C   In/out:
C      L      I      in:  start address in K for tables
C                    out: pointer to entry found (0 if none)
C-----------------------------------------------------------------------
      INTEGER   K(*), L, NT, ISTART, KHUNT(*)
C
      INTEGER   I, J, LENGTH
C-----------------------------------------------------------------------
C                                        zero link -> none
 10   IF (L.EQ.0) GO TO 999
C                                        compare
         LENGTH = K(L+1) / 16
         IF (LENGTH.NE.NT) GO TO 30
            J = L + ISTART
            DO 20 I = 1,NT
               IF (K(J).NE.KHUNT(I)) GO TO 30
               J = J + 1
 20            CONTINUE
C                                        found it!
            GO TO 999
C                                        link to next
 30      L = K(L)
         GO TO 10
C
 999  RETURN
      END

      SUBROUTINE REFFAZ (ISUB, REFA, ANT, TIMKOL, SUBKOL, ANTKOL,
     *   RF1KOL, RE1KOL, IM1KOL, WT1KOL, RF2KOL, RE2KOL, IM2KOL, WT2KOL,
     *   BUFFER, MXTIME, WRKTIM, WORK1, WORK2, WORK3, WORK4, WORK5,
     *   IRET)
C-----------------------------------------------------------------------
C! Adjusts the reference antenna in an SN table.
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2003, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to rereference phases in an a polarization coherent fashion;
C   i.e. both polarizations must be present (if possible) in data used
C   to determine the relative phase between the primary and secondary
C   reference antennas.  This routine does one IF at a time but both
C   polarizations (if present) are done.
C   All valid entries are included.
C      Note: reference antenna values in the table are modified.
C   Inputs:
C      ISUB     I  Subarray number, 0=>1
C      REFA     I  Primary reference antenna
C      ANT      I  Secondary reference antenna
C      TIMKOL   I  Time column pointer.
C      SUBKOL   I  Subarray column pointer
C      ANTKOL   I  Antenna column pointer
C      RF1KOL   I  Reference antenna 1 pointer
C      RE1KOL   I  Real 1  column pointer
C      IM1KOL   I  Imaginary 1  column pointer
C      WT1KOL   I  Weight 1 column pointer.
C      RF2KOL   I  Reference antenna 2 pointer <1 => not present
C      RE2KOL   I  Real 2  column pointer <1 => not present
C      IM2KOL   I  Imaginary 2  column pointer
C      WT2KOL   I  Weight 2 column pointer <1 => not present
C      MXTIME   I  Dimension of work arrays
C   Input/Output:
C      BUFFER   I(*) Table I/O buffer
C      WRKTIM   R(*) Work array
C      WORK1    R(*) Work array
C      WORK2    R(*) Work array
C      WORK3    R(*) Work array
C      WORK4    R(*) Work array
C      WORK5    R(*) Work array
C   Output:
C      IRET     I  Error code, 0=OK else failed.
C-----------------------------------------------------------------------
      INTEGER   ISUB,REFA, ANT, TIMKOL, SUBKOL, ANTKOL, RF1KOL, RE1KOL,
     *   IM1KOL, WT1KOL, RF2KOL, RE2KOL, IM2KOL, WT2KOL, BUFFER(*),
     *   MXTIME, IRET
      REAL      WRKTIM(MXTIME), WORK1(MXTIME), WORK2(MXTIME),
     *   WORK3(MXTIME), WORK4(MXTIME), WORK5(MXTIME)
C
      INTEGER    LOOPR, IRCODE, NUMTIM, IPNT1, IPNT2, REFA1, REFA2,
     *   NUMREC, SUB, SA, SORC
      LOGICAL   NEED2, DOTWO
      REAL    WT1, WT2, RE1, RE2, IM1, IM2, AMP, TRE, TIM, SMOTIM
      DOUBLE PRECISION TIMOFF, TIME, TIME1, TIME2
      INTEGER   RECORD(1024)
      REAL      RECR(1024)
      DOUBLE PRECISION RECD(512)
      EQUIVALENCE (RECORD, RECR, RECD)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA IRCODE /0/
C-----------------------------------------------------------------------
      SORC = -1
C                                       Initially require both
C                                       polarizations if present
      NEED2 = RE2KOL.GT.0
      DOTWO = RE2KOL.GT.0
      SUB = MAX (1, ISUB)
C                                       Loop thru table referring ANT
C                                       to REFA.
      NUMREC = BUFFER(5)
 10   NUMTIM = 0
      DO 100 LOOPR = 1,NUMREC
         CALL TABIO ('READ', IRCODE, LOOPR, RECORD, BUFFER, IRET)
         IF (IRET.LT.0) GO TO 100
         IF (IRET.NE.0) GO TO 900
         IF ((RECORD(ANTKOL).NE.ANT) .AND. (RECORD(ANTKOL).NE.REFA))
     *      GO TO 100
C                                       Right subarray?
         SA = RECORD(SUBKOL)
         IF ((SA.NE.SUB) .AND. (SA.GT.0)) GO TO 100
C                                       Find and check reference
C                                       antennas.  Must all be the
C                                       same.
         REFA1 = RECORD(RF1KOL)
         REFA2 = RECORD(RF2KOL)
C                                        Bad solution?
         IF (((RECR(WT1KOL).LE.0.0) .OR.
     *      (RECR(RE1KOL).EQ.FBLANK) .OR.
     *      (RECORD(RF1KOL).LE.0))) GO TO 100
         IF (NEED2 .AND. ((RE2KOL.GT.0) .AND. ((RECR(WT2KOL).LE.0.0)
     *      .OR. (RECR(RE2KOL).EQ.FBLANK) .OR.
     *      (RECORD(RF2KOL).LE.0)))) GO TO 100
C                                       Desired antenna combination?
         IF (NEED2 .AND. (REFA1.GT.0) .AND. (REFA2.GT.0) .AND.
     *      (REFA1.NE.REFA2)) GO TO 100
         IF (REFA1.LT.0) REFA1 = REFA2
         IF ((REFA1.NE.ANT) .AND. (REFA1.NE.REFA))
     *      GO TO 100
         IF (RECORD(ANTKOL).EQ.REFA1) GO TO 100
         IF (NUMTIM.GE.MXTIME) GO TO 100
            NUMTIM = NUMTIM + 1
            IF (NUMTIM.EQ.1) TIMOFF = RECD(TIMKOL)
            WRKTIM(NUMTIM) = RECD(TIMKOL) - TIMOFF
            IF (REFA1.NE.ANT) THEN
C                                       REFA is reference ant
               WORK2(NUMTIM) = RECR(RE1KOL)
               WORK3(NUMTIM) = RECR(IM1KOL)
               IF (DOTWO) THEN
                  WORK4(NUMTIM) = RECR(RE2KOL)
                  WORK5(NUMTIM) = RECR(IM2KOL)
                  END IF
            ELSE
C                                       ANT is reference ant
               WORK2(NUMTIM) = RECR(RE1KOL)
               WORK3(NUMTIM) = -RECR(IM1KOL)
               IF (DOTWO) THEN
                  WORK4(NUMTIM) = RECR(RE2KOL)
                  WORK5(NUMTIM) = -RECR(IM2KOL)
                  END IF
               END IF
 100     CONTINUE
      IRET = 0
      IF (NEED2 .AND. (NUMTIM.LE.0)) THEN
C                                       Try again with only one poln.
         NEED2 = .FALSE.
         GO TO 10
         END IF
C                                       Find any?
      IF (NUMTIM.LE.0) GO TO 999
C                                       Smooth (2 sec to extrapolate)
      SMOTIM = 2.0 / 86400.0
      CALL BOXBSM (SMOTIM, WRKTIM, WORK2, SORC, FBLANK, NUMTIM, WORK1)
      CALL BOXBSM (SMOTIM, WRKTIM, WORK3, SORC, FBLANK, NUMTIM, WORK2)
      IF (DOTWO) THEN
         CALL BOXBSM (SMOTIM, WRKTIM, WORK4, SORC, FBLANK, NUMTIM,
     *      WORK3)
         CALL BOXBSM (SMOTIM, WRKTIM, WORK5, SORC, FBLANK, NUMTIM,
     *      WORK4)
         END IF
C                                       Set up for interpolation
      IPNT1 = 1
      IPNT2 = 2
      TIME1 = WRKTIM(1)
      TIME2 = WRKTIM(2)
      IF (NUMTIM.EQ.1) THEN
         IPNT2 = 1
         TIME2 = TIME1
         END IF
C                                       Loop thru table changing any
C                                       data with ref=ANT to ref=REFA
      DO 200 LOOPR = 1,NUMREC
         CALL TABIO ('READ', IRCODE, LOOPR, RECORD, BUFFER, IRET)
         IF (IRET.LT.0) GO TO 200
         IF (IRET.NE.0) GO TO 900
         IF ((RECORD(RF1KOL).NE.ANT) .AND. ((RF2KOL.GT.0) .AND.
     *      (RECORD(RF2KOL).NE.ANT))) GO TO 200
C                                       Right subarray?
         SA = RECORD(SUBKOL)
C                                       Interpolate
         IF ((SA.EQ.SUB) .OR. (SA.LE.0)) THEN
            TIME = RECD(TIMKOL) - TIMOFF
 140        IF ((TIME.GE.TIME1) .AND. (TIME.LE.TIME2)) THEN
C                                       Between entries
               IF (TIME2.NE.TIME1) THEN
                  WT1 = 1.0 - ((TIME-TIME1) / (TIME2-TIME1))
               ELSE
                  WT1 = 1.0
                  END IF
C                                       Before first time
            ELSE IF (TIME.LT.TIME1) THEN
               WT1 = 1.0
C                                       After last time
            ELSE IF (IPNT2.GE.NUMTIM) THEN
               WT1 = 0.0
C                                       Shift in interpolation arrays
            ELSE
               IPNT1 = IPNT1 + 1
               TIME1 = WRKTIM(IPNT1)
               IPNT2 = IPNT2 + 1
               TIME2 = WRKTIM(IPNT2)
               GO TO 140
               END IF
C                                       Interpolate
            WT2 = 1.0 - WT1
            IF (RECORD(RF1KOL).EQ.ANT) THEN
C                                       Interpolate phase pol 1
               IF ((RECR(IM1KOL).NE.FBLANK) .AND.
     *            (RECR(RE1KOL).NE.FBLANK)) THEN
                  RE1 = WT1 * WORK1(IPNT1) + WT2 * WORK1(IPNT2)
                  IM1 = WT1 * WORK2(IPNT1) + WT2 * WORK2(IPNT2)
                  AMP = MAX (SQRT (RE1*RE1 + IM1*IM1), 1.0E-10)
                  RE1 = RE1 / AMP
                  IM1 = IM1 / AMP
C                                       Correct phase 1
                  TRE = RECR(RE1KOL)
                  TIM = RECR(IM1KOL)
                  RECR(RE1KOL) = TRE*RE1 - TIM*IM1
                  RECR(IM1KOL) = TRE*IM1 + TIM*RE1
                  END IF
C                                       Relabel reference antenna
               RECORD(RF1KOL) = REFA
C                                       Null ref ant
            ELSE IF (RECORD(RF1KOL).EQ.0) THEN
C                                       Relabel if blanked
               IF ((RECR(IM1KOL).EQ.FBLANK) .OR.
     *            (RECR(RE1KOL).EQ.FBLANK)) RECORD(RF1KOL) = REFA
               END IF
            IF ((RE2KOL.GT.0) .AND. (RECORD(RF2KOL).EQ.ANT)) THEN
C                                       Interpolate second poln.
               IF ((RECR(IM2KOL).NE.FBLANK) .AND.
     *            (RECR(RE2KOL).NE.FBLANK)) THEN
                  RE2 = WT1 * WORK3(IPNT1) + WT2 * WORK3(IPNT2)
                  IM2 = WT1 * WORK4(IPNT1) + WT2 * WORK4(IPNT2)
                  AMP = MAX (SQRT (RE2*RE2 + IM2*IM2), 1.0E-10)
                  RE2 = RE2 / AMP
                  IM2 = IM2 / AMP
C                                       Correct phase.
                  TRE = RECR(RE2KOL)
                  TIM = RECR(IM2KOL)
                  RECR(RE2KOL) = TRE*RE2 - TIM*IM2
                  RECR(IM2KOL) = TRE*IM2 + TIM*RE2
                  END IF
C                                       Relabel reference antenna
               RECORD(RF2KOL) = REFA
C                                       Null ref ant
            ELSE IF ((RE2KOL.GT.0) .AND. (RECORD(RF2KOL).EQ.0)) THEN
C                                       Relabel if blanked
               IF ((RECR(IM2KOL).EQ.FBLANK) .OR.
     *            (RECR(RE2KOL).EQ.FBLANK)) RECORD(RF2KOL) = REFA
               END IF
C                                       Rewrite record
            CALL TABIO ('WRIT', IRCODE, LOOPR, RECORD, BUFFER, IRET)
            IF (IRET.NE.0) GO TO 900
            END IF
 200     CONTINUE
      IRET = 0
      GO TO 999
C                                       TABIO error
 900  WRITE (MSGTXT,1900) IRET, ANT, REFA
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('REFFAZ: TABIO ERROR',I3,' REREFERENCING ANT ',I3,' TO ',
     *   I3)
      END

      SUBROUTINE GCALC1 (INIT, VOBS, IS, JS, WT, NUMBL, REFANT, MODE,
     *   MINNO, G, NREF, PRTLV, FFLIM, FFLAST, FRAC, RMS, IERR)
C-----------------------------------------------------------------------
C! Gain Soln: Does L1 solution for gains - can do it robustly
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004-2005, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GCALC1 does an L1 type gain solution similar to GCALC.
C   Inputs:
C      INIT     L        T -> start with (1,0) compute NREF if needed
C                        F -> start with GLAST, keep NREF as is
C      VOBS     R(2,*)   Averaged visibility (real, imaginary)
C      IS       I(*)     Array of first antenna numbers.
C      JS       I(*)     Array of second antenna numbers.
C      NUMBL    I        Number of observations.
C      REFANT   I        Desired reference antenna.
C      MODE     I        Solution mode: 0 = full gain soln.
C                           1 = phase only keep ampl. info.
C                           2 = phase only discard ampl. info.
C                        + 10 * weight func (1 sqrt, 2 4th root, 3 -> 1
C      MINNO    I        Min. number of antennas acceptable.
C      PRTLV    I        Print level,   0 = none
C                           1 = print (MSGWRT) soln.
C                           2 = print RMS at each iteration
C                           3 = print data plus soln.
C      FFLIM    R        Limit clip to max (std, FFLIM) * rms
C      FFLAST   R        Mark bad those data with closure error >
C                        FFLAST * rms closure error on last iteration
C   In/out:
C      WT       R(*)     Array of visibility weights - adjusted for
C                        amplitude normalizations and weight function
C   Outputs:
C      G        R(2,*)   Antenna gains to be applied (real, imaginary)
C                        returnsd 1,0 for missing antennas
C      WORK     R(*)     Work array the size of VOBS
C      NREF     I        Reference antenna used.
C      FRAC     R        Fraction of data excluded in robust solution
C      RMS      R        RMS closure error
C      IERR     I        Return error code 0 = OK
C                           1 = no valid data
C                           2 = didn't converge
C                           3 = too few antennas
C   Task BPASS does not change reference if it is set and sets it if
C   it needs to.
C-----------------------------------------------------------------------
      LOGICAL   INIT
      INTEGER   IS(*), JS(*), NUMBL, REFANT, MODE, MINNO, NREF, PRTLV,
     *   IERR
      REAL      VOBS(2,*), WT(*), G(2,*), FFLIM, FFLAST, FRAC, RMS
C
      INTEGER   ITRMAX
      PARAMETER (ITRMAX = 10)
C
      INTEGER   K, NT, NTD, NE, IT, ITMAX, I, II, NIT, J, JJ, MAXANS,
     *   LMODE, LWT, ITRMIN, ITER, IE
      REAL      EPSS(3), AMP, PH, XLAMB, PTERM, FF(ITRMAX), GG(ITRMAX)
      DOUBLE PRECISION GD, T, EPS, F, TOL, S, QQ, W, XX, YY, X,
     *   XRR, XRD, XRZ, XRTEMP, XRGNG, XIR, XID, XIZ, XITEMP, XIGNG,
     *   D1, D2, F1, F2, RMEAN, T1, T2, SUMWT, XXX
      LOGICAL   CONVGD, TR, FA, DORMS
      INCLUDE 'INCS:PUVD.INC'
      REAL      SWT(MAXANT), P1(MAXANT), P2(MAXANT), GLAST(2,MAXANT)
      DOUBLE PRECISION XRDG(MAXANT), XIDG(MAXANT), XRGLAS(MAXANT),
     *   XIGLAS(MAXANT)
      INCLUDE 'INCS:DMSG.INC'
      COMMON /GLASTS/ GLAST
      DATA TR, FA /.TRUE.,.FALSE./
      DATA EPSS /5.E-3, 5.E-4, 5.E-5/
      DATA GG /7.0, 5.0, 4.0, 3.5, 3.0, 2.8, 2.6, 2.4, 2.2, 2.5/
C-----------------------------------------------------------------------
      IERR = 1
      IF (NUMBL.LE.0) GO TO 999
      CALL RCOPY (ITRMAX, GG, FF)
      DO 5 I = 1,ITRMAX
         FF(I) = MAX (FF(I), FFLIM)
 5       CONTINUE
      IF (FFLAST.GE.1.0) FF(ITRMAX) = FFLAST
C                                       interpret mode
      LMODE = MOD (MODE, 10)
      ITRMIN = ITRMAX
      IF (LMODE.GT.3) THEN
         ITRMIN = 1
         LMODE = LMODE - 4
         END IF
      LWT = MODE / 10
C                                       inits
      XLAMB = 0.0
      PTERM = 0.0
      MAXANS = MAXANT
      NE = 3
      ITMAX = 60
      TOL = 5.0E-5
      NT = 0
      NTD = 0
      SUMWT = 0.0
      DO 10 I = 1,MAXANS
         SWT(I) = 0.
 10      CONTINUE
C                                       Find which antennae have data
C                                       and normalize to unit amplitude
C                                       if requested.
      DO 20 K = 1,NUMBL
         I = IS(K)
         J = JS(K)
         XXX = SQRT ((VOBS(1,K)*VOBS(1,K)) + (VOBS(2,K)*VOBS(2,K)))
         IF (XXX.LE.1.0E-20) WT(K) = 0.0
         IF (WT(K).GT.0.0) THEN
            NT = MAX (NT, J)
C                                       Normalize by amplitude if only
C                                       solving for phase without ampl.
            IF (LMODE.EQ.2) THEN
               VOBS(1,K) = VOBS(1,K) / XXX
               VOBS(2,K) = VOBS(2,K) / XXX
               WT(K)  = WT(K) * XXX * XXX
               END IF
            CALL REWAIT (LWT, WT(K))
            SWT(I) = SWT(I) + WT(K)
            SWT(J) = SWT(J) + WT(K)
            SUMWT = SUMWT + WT(K)
         ELSE
            WT(K) = 0.0
            END IF
 20      CONTINUE
C                                       No data
      IF (SUMWT.LE.1.0E-20) GO TO 999
      IF ((TSKNAM.EQ.'BPASS') .AND. (REFANT.GT.0) .AND.
     *   (SWT(REFANT).LE.0.0)) GO TO 999
C                                       Print data if requested
      IF (PRTLV.GE.3) THEN
         DO 30 K = 1,NUMBL
            IF (WT(K).GT.1.0E-20) THEN
               AMP = SQRT (VOBS(1,K)*VOBS(1,K) + VOBS(2,K)*VOBS(2,K))
               PH = 57.296 * ATAN2 (VOBS(2,K), VOBS(1,K)+1.0E-20)
               WRITE (MSGTXT,1000) K, AMP, PH, IS(K), JS(K), WT(K)
               CALL MSGWRT (3)
               END IF
 30         CONTINUE
         END IF
C                                       Initialize solutions
      DO 40 I = 1,MAXANS
         IF ((INIT) .OR. (SWT(I).LE.0.0)) THEN
            G(1,I) = 1.0
            G(2,I) = 0.0
            XRDG(I) = 1.0D0
            XIDG(I) = 0.0D0
         ELSE
            G(1,I) = GLAST(1,I)
            G(2,I) = GLAST(2,I)
            XRDG(I) = GLAST(1,I)
            XIDG(I) = GLAST(2,I)
            END IF
         XRGLAS(I) = 1.0D0
         XIGLAS(I) = 0.0D0
         IF (SWT(I).GT.0.) NTD = NTD + 1
 40      CONTINUE
      DORMS = (2.5*(NTD-1).LE.NUMBL)
C                                       Pick reference antenna
      IF ((INIT) .OR. (NREF.LE.0) .OR. (NREF.GT.MAXANS)) THEN
         NREF = REFANT
         IF ((NREF.LT.1) .OR. (NREF.GT.MAXANS) .OR. (SWT(NREF).LE.0.0))
     *      THEN
            XX = 0.0
            DO 50 I = 1,NT
               IF (SWT(I).GT.XX) THEN
                  XX = SWT(I)
                  NREF = I
                  END IF
 50            CONTINUE
            IF (TSKNAM.EQ.'BPASS') REFANT = NREF
            END IF
         END IF
C                                       Robust iteration
 100  IF (.NOT.DORMS) ITRMIN = ITRMAX
      DO 400 ITER = ITRMIN,ITRMAX
C                                       Too few antennas
         IF (NTD.LT.MINNO) THEN
            IERR = 3
            GO TO 999
            END IF
C                                       L1 loop
         DO 270 IE = 1,NE
            EPS = EPSS(IE)
            IF (PRTLV.GE.2) THEN
               S = 0.0
               DO 110 K = 1,NUMBL
                  IF (WT(K).GT.0.) THEN
                     I = IS(K)
                     J = JS(K)
                     XRZ = VOBS(1,K) - (XRDG(I) * XRDG(J) +
     *                  XIDG(I) * XIDG(J))
                     XIZ = VOBS(2,K) - (XRDG(J) * XIDG(I) -
     *                  XRDG(I) * XIDG(J))
                     QQ = XRZ * XRZ + XIZ * XIZ
                     S = S + WT(K) * SQRT (QQ + EPS)
                     END IF
 110              CONTINUE
               RMEAN = S / SUMWT
               IT = 0
               WRITE (MSGTXT,1110) IT, S, RMEAN
               CALL MSGWRT (3)
               END IF
C                                       Solution loop
            DO 260 IT = 1,ITMAX
               IF (IT.GT.15) TOL = (IT-10) * 1.0E-5
               NIT = IT
C                                       Section to solve for full
C                                       complex gains:
               IF (LMODE.LE.0) THEN
                  IF (IT.EQ.1) W = 0.5
                  IF (IT.EQ.2) W = 1.5
                  IF (IT.EQ.3) W = 1.5
                  IF (NTD.LE.6) W = .25
                  DO 130 I = 1,NT
                     IF (SWT(I).EQ.0.) GO TO 130
                     XRGNG = 0.0D0
                     XIGNG = 0.0D0
                     GD = 0.
                     DO 120 K = 1,NUMBL
                        II = IS(K)
                        JJ = JS(K)
                        IF ((WT(K).GT.0.0) .AND. (SWT(II).GT.0.) .AND.
     *                     (SWT(JJ).GT.0.)) THEN
                           IF (I.EQ.II) THEN
                              XRR = VOBS(1,K) - (XRDG(II) * XRDG(JJ) +
     *                           XIDG(II) * XIDG(JJ))
                              XIR = VOBS(2,K) - (XRDG(JJ) * XIDG(II) -
     *                           XRDG(II) * XIDG(JJ))
                              T = WT(K) / SQRT (XRR * XRR + XIR * XIR +
     *                           EPS)
                              XRZ = XRDG(JJ)
                              XIZ = XIDG(JJ)
                              GD = GD + T * (XRZ * XRZ + XIZ * XIZ)
                              XRGNG = XRGNG + T * (XRDG(JJ) * VOBS(1,K)
     *                           - XIDG(JJ) * VOBS(2,K))
                              XIGNG = XIGNG + T * (XRDG(JJ) * VOBS(2,K)
     *                           + VOBS(1,K) * XIDG(JJ))
                           ELSE IF (I.EQ.JJ) THEN
                              XRR = VOBS(1,K) - (XRDG(II) * XRDG(JJ) +
     *                           XIDG(II) * XIDG(JJ))
                              XIR = VOBS(2,K) - (XRDG(JJ) * XIDG(II) -
     *                           XRDG(II) * XIDG(JJ))
                              T = WT(K) / SQRT (XRR * XRR + XIR * XIR +
     *                           EPS)
                              XRZ = XRDG(II)
                              XIZ = XIDG(II)
                              GD = GD + T * (XRZ * XRZ + XIZ * XIZ)
                              XRGNG = XRGNG + T * (XRDG(II) * VOBS(1,K)
     *                           + XIDG(II) * VOBS(2,K))
                              XIGNG = XIGNG + T * (VOBS(1,K) * XIDG(II)
     *                           - XRDG(II) * VOBS(2,K))
                              END IF
                           END IF
 120                    CONTINUE
                     XRDG(I) = XRDG(I) + W * (XRGNG / GD - XRDG(I))
                     XIDG(I) = XIDG(I) + W * (XIGNG / GD - XIDG(I))
 130                 CONTINUE
C                                       Section to solve for phase
C                                       corrections alone:
               ELSE
                  DO 210 I = 1,NT
                     P1(I) = 0.
                     P2(I) = 0.
 210                 CONTINUE
                  W = 0.5
                  IF (IT.LE.3) W = .25
                  IF (NTD.LE.6) W = .25
                  DO 220 K = 1,NUMBL
                     I = IS(K)
                     J = JS(K)
                     IF ((SWT(I).GT.0.) .AND. (SWT(J).GT.0.) .AND.
     *                  (WT(K).GT.0.)) THEN
                        XRD = XRDG(I) * XRDG(J) + XIDG(I) * XIDG(J)
                        XID = XRDG(J) * XIDG(I) - XRDG(I) * XIDG(J)
                        XRR = VOBS(1,K) - XRD
                        XIR = VOBS(2,K) - XID
                        XRTEMP = XRD
                        XITEMP = XID
                        XRD = XRTEMP * VOBS(1,K) + XITEMP * VOBS(2,K)
                        XID = VOBS(1,K) * XITEMP - XRTEMP * VOBS(2,K)
                        QQ = XRR * XRR + XIR * XIR
                        F = QQ + EPS
                        F1 = SQRT (F)
                        F2 = F * F1
                        D1 = 2.0 * XID
                        D2 = 2.0 * XRD
                        T1 = .5 * WT(K) / F1 * D1
                        T2 = .5 * WT(K) * (D2 / F1-.5 * (D1 ** 2) / F2)
                        P1(I) = P1(I) + T1
                        P1(J) = P1(J) - T1
                        P2(I) = P2(I) + T2
                        P2(J) = P2(J) + T2
                        END IF
 220                 CONTINUE
                  DO 230 I = 1,NT
                     IF (SWT(I).GT.0.) THEN
                        XX = ATAN2 (XIDG(I), XRDG(I))
                        YY = ATAN2 (P1(I), P2(I))
                        XRDG(I) = COS (XX - W * YY)
                        XIDG(I) = SIN (XX - W * YY)
                        END IF
 230                 CONTINUE
                  END IF
C
               CONVGD = TR
               DO 240 I = 1,NT
                  IF ((SWT(I).GT.0.) .AND. (CONVGD)) THEN
                     X = TOL * (5E-7 + SQRT (XRDG(I) * XRDG(I) +
     *                  XIDG(I) * XIDG(I)))
                     IF (ABS (XRDG(I)-XRGLAS(I)).GT.X) CONVGD = FA
                     IF (ABS (XIDG(I)-XIGLAS(I)).GT.X) CONVGD = FA
                     END IF
                  XRGLAS(I) = XRDG(I)
                  XIGLAS(I) = XIDG(I)
 240              CONTINUE
               IF (PRTLV.GE.2) THEN
                  S = 0.0
                  DO 250 K = 1,NUMBL
                     IF (WT(K).GT.0.) THEN
                        I = IS(K)
                        J = JS(K)
                        XRZ = VOBS(1,K) - (XRDG(I) * XRDG(J) +
     *                     XIDG(I) * XIDG(J))
                        XIZ = VOBS(2,K) - (XRDG(J) * XIDG(I) -
     *                     XRDG(I) * XIDG(J))
                        QQ = XRZ * XRZ + XIZ * XIZ
                        S = S + WT(K) * SQRT(QQ + EPS)
                        END IF
 250                 CONTINUE
                  RMEAN = S / SUMWT
                  WRITE (MSGTXT,1110) IT, S, RMEAN
                  CALL MSGWRT (3)
                  END IF
               IF (CONVGD) GO TO 270
 260           CONTINUE
 270        CONTINUE
C                                       finished this robust iteration
C                                       get rms
         S = 0.0
         XXX = 1.0
         DO 280 K = 1,NUMBL
            IF (WT(K).GT.0.) THEN
               I = IS(K)
               J = JS(K)
               IF (LMODE.EQ.1) XXX = SQRT ((VOBS(1,K)*VOBS(1,K)) +
     *            (VOBS(2,K)*VOBS(2,K)))
               XRZ = VOBS(1,K)/XXX - (XRDG(I) * XRDG(J) +
     *            XIDG(I) * XIDG(J))
               XIZ = VOBS(2,K)/XXX - (XRDG(J) * XIDG(I) -
     *            XRDG(I) * XIDG(J))
               QQ = XRZ * XRZ + XIZ * XIZ
               S = S + WT(K) * QQ
               END IF
 280        CONTINUE
         RMS = SQRT (S / SUMWT)
C                                       converged: what to use this time
 300     SUMWT = 0.0
         CALL RFILL (MAXANS, 0.0, SWT)
         XXX = 1.0
         IF (.NOT.DORMS) RMS = 1.0E10
         DO 310 K = 1,NUMBL
            I = IS(K)
            J = JS(K)
            IF (WT(K).NE.0.0) THEN
               WT(K) = ABS (WT(K))
               IF (LMODE.EQ.1) XXX = SQRT ((VOBS(1,K)*VOBS(1,K)) +
     *            (VOBS(2,K)*VOBS(2,K)))
               XRZ = ABS (VOBS(1,K)/XXX - (XRDG(I) * XRDG(J) +
     *            XIDG(I) * XIDG(J))) / RMS
               XIZ = ABS (VOBS(2,K)/XXX - (XRDG(J) * XIDG(I) -
     *            XRDG(I) * XIDG(J))) / RMS
               IF (((XRZ.GT.FF(ITER)) .OR. (XIZ.GT.FF(ITER))) .AND.
     *            (DORMS)) THEN
                  WT(K) = -WT(K)
               ELSE
                  SWT(I) = SWT(I) + WT(K)
                  SWT(J) = SWT(J) + WT(K)
                  SUMWT = SUMWT + WT(K)
                  END IF
               END IF
 310        CONTINUE
 400     CONTINUE
C                                       all done finally
      IERR = 0
      IF (.NOT.DORMS) RMS = 0.0
C                                       fraction excluded
      XX = 0.0
      YY = 0.0
      DO 410 K = 1,NUMBL
         IF (WT(K).NE.0.0) THEN
            XX = XX + 1.0
            IF (WT(K).LT.0.0) YY = YY + 1.0
            END IF
 410     CONTINUE
      FRAC = 1.0
      IF (XX.GT.0.0) FRAC = YY / XX
C                                       Refer solutions to reference
C                                       antenna.
      G(1,NREF) = XRDG(NREF)
      G(2,NREF) = XIDG(NREF)
      XX = 1.0 / SQRT (G(1,NREF)*G(1,NREF) + G(2,NREF)*G(2,NREF))
      DO 420 I = 1,NT
         G(1,I) = XRDG(I)
         G(2,I) = XIDG(I)
         IF ((I.NE.NREF) .AND. (SWT(I).GT.0.)) THEN
            XRR = G(1,I) * G(1,NREF) + G(2,I) * G(2,NREF)
            XIR = G(2,I) * G(1,NREF) - G(1,I) * G(2,NREF)
            G(1,I) = XX * XRR
            G(2,I) = XX * XIR
            GLAST(1,I) = G(1,I)
            GLAST(2,I) = G(2,I)
            END IF
 420     CONTINUE
      G(1,NREF) = SQRT (G(1,NREF)*G(1,NREF) + G(2,NREF)*G(2,NREF))
      G(2,NREF) = 0.0
      GLAST(1,NREF) = G(1,NREF)
      GLAST(2,NREF) = G(2,NREF)
C                                       print results
      IF (PRTLV.GE.1) THEN
         DO 430 I = 1,NT
            IF (SWT(I).GT.0.) THEN
               AMP = SQRT (G(1,I)*G(1,I) + G(2,I)*G(2,I))
               PH = 57.2958 * ATAN2 (G(2,I), G(1,I))
               WRITE (MSGTXT,1090) I, AMP, PH
               CALL MSGWRT (3)
               END IF
 430        CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (1X,I4,1PE12.3,1E12.3,2I3,E12.3)
 1110 FORMAT ('Iter=',I5,' s=',1PE15.5,' rmean=',1E15.5)
 1090 FORMAT ('Ant=',I5,' amp=',F12.5,' phase=',F12.2)
      END

      SUBROUTINE ZUVPAK (NCORR, VISIN, WTSCL, VISOUT)
C-----------------------------------------------------------------------
C! Pack visibility data, 1 correlator per real with magic value blank.
C# Binary Z
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to pack uv data with magic value blanking.  One AIPS
C   logical uv data record is processed at a time.
C   Inputs:
C      NCORR  I       Number of correlator values in data
C      VISIN  R(3,*)  Unpacked uv data as real, imag and weight per
C                     correlator.
C   Output:
C      WTSCL  R(2)    "Weight" and "scale" random parameters for the
C                     packed record.
C      VISOUT R(*)    Packed visibility data with local magic value
C                     blanking.
C   Version for machines with 32-bit integers/reals
C-----------------------------------------------------------------------
      INTEGER   NCORR
      REAL      VISIN(3,*), WTSCL(2), VISOUT(*)
C
      INTEGER   LOOP, LIMIT, IBLANK, IVIS(2), NP
      REAL      MAXVIS, MAXWT, SCL, XR, XI
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C                                       Magic blanking value
      DATA IBLANK /-32767/
C-----------------------------------------------------------------------
      IF (NCORR.LE.0) GO TO 999
C                                       Validity check
      IF (NBITWD.NE.32) THEN
         WRITE (MSGTXT,1000) NBITWD
         CALL MSGWRT (9)
         STOP ' ZUVPAK MISSING'
         END IF
      LIMIT = NCORR
C                                       Find max wt, vis
      MAXWT = 0.0
      MAXVIS = 0.0
      DO 100 LOOP = 1,LIMIT
         IF (VISIN(3,LOOP).GT.0.0) THEN
            MAXVIS = MAX (MAXVIS, ABS (VISIN(1,LOOP)),
     *         ABS (VISIN(2,LOOP)))
            MAXWT = MAX (MAXWT, VISIN(3,LOOP))
            END IF
 100     CONTINUE
C                                       Set weight and scaling
C                                       parameters
      WTSCL(1) = MAXWT
      WTSCL(2) = MAXVIS / 32760.
      SCL = 1.0
      IF (WTSCL(2).GT.1.0E-10) SCL = 1.0 / WTSCL(2)
C                                       Scale to integer
      NP = 1
      DO 200 LOOP = 1,LIMIT
         IF (VISIN(3,LOOP).GT.0.0) THEN
            XR = VISIN(1,LOOP) * SCL
            XI = VISIN(2,LOOP) * SCL
            IVIS(1) = XR + SIGN (0.5, XR)
            IVIS(2) = XI + SIGN (0.5, XI)
         ELSE
            IVIS(1) = IBLANK
            IVIS(2) = IBLANK
            END IF
         CALL ZIPACK ('LTOS', 2, IVIS, NP, VISOUT)
         NP = NP + 2
 200     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZUVPAK: REQUIRES LOCAL DEVELOPMENT FOR NBITWD =',I7)
      END

      PROGRAM RTIME
C-----------------------------------------------------------------------
C! Task to grab the AP for a specified time
C# AP-util Batch Service
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Task RTIME suspends itself for an amount of time specified by the
C   adverb DETIME.  The purpose of this is that AP tasks think that
C   RTIME uses the AP and while it is running tasks with higher POPS
C   numbers have reduced access to the AP.
C   Inputs:
C      AIPS Adverb   Prg. Name          Description
C      DETIME         DETIME        No. min to suspend before quiting.
C-----------------------------------------------------------------------
      INTEGER   INNER, OUTER
      PARAMETER (INNER = 2000000)
      PARAMETER (OUTER = 1000)
C
      CHARACTER PRGM*6
      LOGICAL   RQUICK
      INTEGER   NPARM, IRET, IERR, I, J, NCOUNT, ISUM, IT1(6), IT2(6),
     *   IFACT, IB(INNER), IB0, IOFF, ISS(OUTER)
      REAL      DETIME, BUFF(256), RSUM, CPU1, CPU2, RFACT,
     *   RB(INNER), RB0, RSS(OUTER)
      DOUBLE PRECISION JD1, JD2, RR
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA PRGM /'RTIME '/
C-----------------------------------------------------------------------
C                                       Init I/O
      CALL ZDCHIN (.TRUE., BUFF)
C                                       Get input parameters.
      NPARM = 1
      CALL GTPARM (PRGM, NPARM, RQUICK, DETIME, BUFF, IRET)
      IF (IRET.NE.0) THEN
         IF (IRET.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS.
      IF (RQUICK) CALL RELPOP (IRET, BUFF, IERR)
      IF (IRET.NE.0) GO TO 990
      IRET = 0
      NCOUNT = DETIME + 0.5
      IF (NCOUNT.GT.OUTER) NCOUNT = OUTER
      IF (NCOUNT.LE.0) NCOUNT = 50
      IFACT = 3000
      RFACT = 30000.
      J = -1
      DO 10 I = 1,INNER
         J = - J
         IB(I) = J
         RB(I) = J
 10      CONTINUE
      IB0 = IB(1)
      RB0 = RB(1)
      WRITE (MSGTXT,1010) NCOUNT, INNER
      CALL MSGWRT (5)
      IOFF = INNER + 1
C                                       mark time
      CALL ZDATE (IT1(1))
      CALL ZTIME (IT1(4))
      CALL ZCPU (CPU1, I)
C                                       floating
      DO 110 J = 1,NCOUNT
         RSUM = 0.0
         DO 105 I = 1,INNER
            RSUM = RSUM + RB0
 105        CONTINUE
         RSS(J) = RSUM
 110     CONTINUE
C                                       end time
      CALL ZDATE (IT2(1))
      CALL ZTIME (IT2(4))
      CALL ZCPU (CPU2, I)
C                                       report
      CALL DAT2JD (IT1, JD1)
      CALL DAT2JD (IT2, JD2)
      RR = (JD2 - JD1) * 8.64D4
      CPU1 = CPU2 - CPU1
      WRITE (MSGTXT,1120) RR, CPU1, '1 = Float sum'
      CALL MSGWRT (5)
C                                       mark time
      CALL ZDATE (IT1(1))
      CALL ZTIME (IT1(4))
      CALL ZCPU (CPU1, I)
C                                       floating
      DO 120 J = 1,NCOUNT
         RSUM = 0.0
         DO 115 I = 1,INNER
            RSUM = RSUM + RB0 - RSUM/RFACT
 115        CONTINUE
         RSS(J) = RSUM
 120     CONTINUE
C                                       end time
      CALL ZDATE (IT2(1))
      CALL ZTIME (IT2(4))
      CALL ZCPU (CPU2, I)
C                                       report
      CALL DAT2JD (IT1, JD1)
      CALL DAT2JD (IT2, JD2)
      RR = (JD2 - JD1) * 8.64D4
      CPU1 = CPU2 - CPU1
      WRITE (MSGTXT,1120) RR, CPU1, '2 = Float sum, div'
      CALL MSGWRT (5)
C                                       mark time
      CALL ZDATE (IT1(1))
      CALL ZTIME (IT1(4))
      CALL ZCPU (CPU1, I)
C                                       floating
      DO 130 J = 1,NCOUNT
         RSUM = 0.0
         DO 125 I = 1,INNER
            RSUM = RSUM + RB(I) - RSUM/RFACT + RB(IOFF-I)
 125        CONTINUE
         RSS(J) = RSUM
 130     CONTINUE
C                                       end time
      CALL ZDATE (IT2(1))
      CALL ZTIME (IT2(4))
      CALL ZCPU (CPU2, I)
C                                       report
      CALL DAT2JD (IT1, JD1)
      CALL DAT2JD (IT2, JD2)
      RR = (JD2 - JD1) * 8.64D4
      CPU1 = CPU2 - CPU1
      WRITE (MSGTXT,1120) RR, CPU1, '3 = Float sum, div, matrix'
      CALL MSGWRT (5)
C                                       mark time
      CALL ZDATE (IT1(1))
      CALL ZTIME (IT1(4))
      CALL ZCPU (CPU1, I)
C                                       integer
      DO 210 J = 1,NCOUNT
         ISUM = 0
         DO 205 I = 1,INNER
            ISUM = ISUM + IB0
 205        CONTINUE
         ISS(J) = ISUM
 210     CONTINUE
C                                       end time
      CALL ZDATE (IT2(1))
      CALL ZTIME (IT2(4))
      CALL ZCPU (CPU2, I)
C                                       report
      CALL DAT2JD (IT1, JD1)
      CALL DAT2JD (IT2, JD2)
      RR = (JD2 - JD1) * 8.64D4
      CPU1 = CPU2 - CPU1
      WRITE (MSGTXT,1120) RR, CPU1, '4 = Integer sum'
      CALL MSGWRT (5)
C                                       mark time
      CALL ZDATE (IT1(1))
      CALL ZTIME (IT1(4))
      CALL ZCPU (CPU1, I)
C                                       integer
      DO 220 J = 1,NCOUNT
         ISUM = 0
         DO 215 I = 1,INNER
            ISUM = ISUM + IB0 - ISUM/IFACT
 215        CONTINUE
         ISS(J) = ISUM
 220     CONTINUE
C                                       end time
      CALL ZDATE (IT2(1))
      CALL ZTIME (IT2(4))
      CALL ZCPU (CPU2, I)
C                                       report
      CALL DAT2JD (IT1, JD1)
      CALL DAT2JD (IT2, JD2)
      RR = (JD2 - JD1) * 8.64D4
      CPU1 = CPU2 - CPU1
      WRITE (MSGTXT,1120) RR, CPU1, '5 = Integer sum, div'
      CALL MSGWRT (5)
C                                       mark time
      CALL ZDATE (IT1(1))
      CALL ZTIME (IT1(4))
      CALL ZCPU (CPU1, I)
C                                       integer
      DO 230 J = 1,NCOUNT
         ISUM = 0
         DO 225 I = 1,INNER
            ISUM = ISUM + IB(I) - ISUM/IFACT + IB(IOFF-I)
 225        CONTINUE
         ISS(J) = ISUM
 230     CONTINUE
C                                       end time
      CALL ZDATE (IT2(1))
      CALL ZTIME (IT2(4))
      CALL ZCPU (CPU2, I)
C                                       report
      CALL DAT2JD (IT1, JD1)
      CALL DAT2JD (IT2, JD2)
      RR = (JD2 - JD1) * 8.64D4
      CPU1 = CPU2 - CPU1
      WRITE (MSGTXT,1120) RR, CPU1, '6 = Integer sum, div, matrix'
      CALL MSGWRT (5)
C                                        Write end message
 990  CALL DIETSK (IRET, RQUICK, BUFF)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR:',I7,'GETTING INPUT PARAMETERS')
 1010 FORMAT ('Iterating',I6,' times of inner loop of size',I9)
 1120 FORMAT ('Real ',F8.1,' cpu',F8.2,' for Loop ',A)
      END

      SUBROUTINE QCLNSU (COMP, AMAP, LMAP, ABEAM, BBEAM)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Low level Clark CLEAN routine.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   QCLNSU does a CLEAN on the map points in the pseudo AP
C   using the portion of the beam in the pseudo AP.
C   Inputs:
C      COMP  I  Base address of the component vector:
C               0 => intensity
C               1 => x in cells
C               2 => Y in cells
C               3 => CLEAN loop gain (fractional)
C      AMAP  I  Base address of the map stored as (X,Y,intensity)
C               -1<X<NX  -1<Y<NY
C      LMAP  I  Number of map points
C      ABEAM I  Base address of the piece of the beam.  The Y
C               dimension varies the fastest: -BY<Y<BY,
C               X varies slowest -1<X<BX
C      BBEAM I  Base address of beam descriptor vector (BX,BY)
C-----------------------------------------------------------------------
      INTEGER   COMP, AMAP, LMAP, ABEAM, BBEAM, IBX, IBY, IDX, IDY,
     *   JCOMP, JAMAP, JBBEAM, LOOP, BEAMO, SAVLOC, IBY21, AABEAM
      REAL      DX, DY, SUBT, XCOMP, YCOMP, BX, BY, AXMAX, BY21
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                        Get 1-rel addresses.
      JCOMP = COMP + 1
      JAMAP = AMAP + 1
      JBBEAM = BBEAM + 1
      IF (LMAP.LE.0) GO TO 999
C                                        Get component to be CLEANed
      XCOMP = APCORE(JCOMP+1)
      YCOMP = APCORE(JCOMP+2)
      SUBT  = APCORE(JCOMP) * APCORE(JCOMP+3)
C                                        Get beam patch
      IBX = APCORE(JBBEAM) + 0.1
      IBY = APCORE(JBBEAM+1) + 0.1
C                                        Add Beam Y address to start
      AABEAM = ABEAM + IBY
C                                        Value useful for inner loop
      IBY21 = (IBY * 2) - 1
      BY21  = IBY21
C                                        Get beam patch in reals
      BX = APCORE(JBBEAM)
      BY = APCORE(JBBEAM+1)
C                                        Subtraction loop
      INCLUDE 'INCS:ZVND.INC'
      DO 100 LOOP = 1,LMAP
C                                        Get next residual loc
         DX = APCORE(JAMAP) - XCOMP
C                                        Check if X in beam patch.
         IF (ABS (DX) .LT. BX) THEN
C                                        Calc Y of residual
            DY = APCORE(JAMAP+1) - YCOMP
C                                        Check if Y in beam patch.
            IF (ABS (DY) .LT. BY) THEN
C                                        Yes, Calc Ap loc of beam
C               IDX = DX + SIGN (0.1, DX)
C               IDY = DY + SIGN (0.1, DY)
C                                        Get location of beam value
               IF (DX.GE.0) THEN
                  BEAMO = +DY + (DX * BY21)
               ELSE
                  BEAMO = -DY - (DX * BY21)
                  END IF
C                                        Subtract
               APCORE(JAMAP+2) = APCORE(JAMAP+2) -
     *            (SUBT * APCORE(BEAMO+AABEAM))
C                                        End if Y in beam patch.
               END IF
C                                        End if X in beam patch.
            END IF
C                                        Update pointer
         JAMAP = JAMAP + 3
 100     CONTINUE
C                                        Find largest mag. residual
      JAMAP = AMAP + 3
      AXMAX = ABS (APCORE(JAMAP))
      SAVLOC = JAMAP
C                                        Loop
      INCLUDE 'INCS:ZVND.INC'
      DO 200 LOOP = 1,LMAP
         IF (AXMAX.LT.ABS (APCORE(JAMAP))) THEN
C                                        New maximum.
            AXMAX = ABS (APCORE(JAMAP))
            SAVLOC = JAMAP
            END IF
         JAMAP = JAMAP+3
 200     CONTINUE
C                                        Crunch location
      APCORE(JCOMP) = APCORE(SAVLOC)
      APCORE(JCOMP+1) = APCORE(SAVLOC-2)
      APCORE(JCOMP+2) = APCORE(SAVLOC-1)
C
 999  RETURN
      END

      SUBROUTINE QSVESQ (A, I, C ,N)
C-----------------------------------------------------------------------
C! FPS AP version: Sum squares of the elements of a vector
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FPS AP version
C   Sum the squares of the elements of a vector:
C        C = SUM ( A(mI) * [BA(mI)) for m=0 to N-1
C    Inputs:
C     A  I  Source vector base address.
C     I  I  Increment of A
C     C  I  Destination scalar address
C     N  I  Element count
C-----------------------------------------------------------------------
      INTEGER A, I, C, N
      INTEGER*2 IA, II, IC, IN
C-----------------------------------------------------------------------
C                                        Convert inputs to unsigned I*2
      IF (A.LT.32768) IA = A
      IF (A.GE.32768) IA = A - 65536
      IF (I.LT.32768) II = I
      IF (I.GE.32768) II = I - 65536
      IF (C.LT.32768) IC = C
      IF (C.GE.32768) IC = C - 65536
      IF (N.LT.32768) IN = N
      IF (N.GE.32768) IN = N - 65536
C                                        Call FPS routine.
      CALL SVESQ (IA, II, IC, IN)
C
 999  RETURN
      END

      SUBROUTINE RSORT (LEN, A)
C-----------------------------------------------------------------------
C! sort a real array into descending order
C# Sort Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   RSORT sorts by Shell-Mezgar algorithm.  It is faster for ordered 
C   data.  This is sort of a binary sort
C   Input:
C      LEN   I         Length of array
C   Input/Output:
C      A     R(LEN)  Sorted data.
C Reference: Kunuth, Donald, Sorting and Searching,
C                            The art of computer Programming
C-----------------------------------------------------------------------
      INTEGER   LEN
      REAL      A(*)
C
      INTEGER   OUTER, INNER, M, II, K, I, L
C-----------------------------------------------------------------------
      M = LEN
C                                       Set outer loop lengths
      OUTER = INT ( ALOG(FLOAT(LEN))/LOG(2.)+1.0E-6)
C                                       Begin sort loop.
      DO 200 II = 1, OUTER
         M = M / 2
         K = LEN - M
C                                       Search for next highest value.
         DO 100 INNER = 1, K
            I = INNER
 50         CONTINUE
               L = I + M
C                                       Consider a swap
               IF (A(L).GT.A(I)) THEN
C                                       Its bigger, swap
                  CALL RSWAP ( A(I), A(L))
                  I = I - M
                  IF (I.GE.1)  GO TO 50
C                                       End if swapping
                  END IF
 100        CONTINUE
C                                       End Outer loop
 200     CONTINUE
C
      RETURN
      END

      SUBROUTINE RESCCC (IVOL, SLOT, FACTOR, LUN, BUFFER, IERR)
C-----------------------------------------------------------------------
C! rescale CC files
C# POPS-appl Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 2019-2020
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   RESCC rescales CC files in place
C   Inputs:
C      IVOL     I      Disk number
C      SLOT     I      Slot number
C      FACTOR   R      Scale factor
C      LUN      I      LUN to use
C   Outputs
C      BUFFER   I(*)   work buffer
C      IERR     I      error code
C-----------------------------------------------------------------------
      INTEGER   IVOL, SLOT, LUN, BUFFER(*), IERR
      DOUBLE PRECISION FACTOR
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   VER, NVER, ICCRNO, CCKOLS(MAXCCC), CCNUMV(MAXCCC), NCOL,
     *   NCC, TYPE, I
      REAL      X, Y, Z, FLUX, PARMS(3)
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (FACTOR.EQ.1.0) GO TO 999
C                                       Any SL tables?
      CALL FNDEXT ('CC', CATBLK, NVER)
      IF (NVER.LE.0) GO TO 999
C                                       loop over versions
      DO 100 VER = 1,NVER
         CALL CCMINI ('WRIT', BUFFER, IVOL, SLOT, VER, CATBLK, LUN,
     *      ICCRNO, CCKOLS, CCNUMV, NCOL, IERR)
         IF (IERR.EQ.2) THEN
            WRITE (MSGTXT,1010) VER
            CALL MSGWRT (6)
            IERR = 0
            GO TO 100
         ELSE IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, VER, 'OPENING CC FILE'
            GO TO 980
            END IF
C                                       read/write
         NCC = BUFFER(5)
         DO 30 I = 1,NCC
            ICCRNO = I
            CALL TABCCM ('READ', BUFFER, ICCRNO, CCKOLS, CCNUMV, NCOL,
     *         X, Y, Z, FLUX, TYPE, PARMS, IERR)
            IF (IERR.GT.0) THEN
               WRITE (MSGTXT,1000) IERR, VER, 'READING CC FILE'
               GO TO 980
            ELSE IF (IERR.EQ.0) THEN
               IF (FLUX.NE.FBLANK) FLUX = FLUX * FACTOR
               ICCRNO = I
               CALL TABCCM ('WRIT', BUFFER, ICCRNO, CCKOLS, CCNUMV,
     *            NCOL, X, Y, Z, FLUX, TYPE, PARMS, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, VER, 'WRITING CC FILE'
                  GO TO 980
                  END IF
               END IF
 30         CONTINUE
C                                       close
         CALL TABIO ('CLOS', 0, ICCRNO, PARMS, BUFFER, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, VER, 'CLOSING THE CC FILE'
            GO TO 980
            END IF
 100     CONTINUE
      GO TO 999
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RESCCC ERROR',I4,' VERSION',I4,' ON ',A)
 1010 FORMAT ('RESCCC DID NOT FIND CC FILE VERSION',I4)
      END

      SUBROUTINE GFINIS (BUFF, IERR)
C-----------------------------------------------------------------------
C! writes the end of plot record into a plot file and closes it down
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2002-2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GFINIS places an "end of plot" command in the buffer, writes the
C   last buffer to disk, compresses the plot file if needed, and
C   closes the plot file.  ******  NOTE: any catalog operations for
C   the plot file must be performed by the calling program. *******
C   The plot common is reinitialized in part.
C   The command record has the form
C            I     opcode (32767)
C   In TV mode, it closes the TV, updates the image catalog, and
C   reports any errors.
C   In/out:
C      BUFF  I(256)     plot file work buffer
C   Output:
C      IERR  I          error code: 0 => ok
C                         -1 => user requested stop on multi-page TV
C                          1 => disk error
C                          2 => data error
C                          3 => compress error
C                          4 => close error
C-----------------------------------------------------------------------
      INTEGER   BUFF(256), IERR
C
      INTEGER   NEED, OPCODE, IER, ISIZE, IMAWIN(4), IQ, IB, I, NC, IC
      REAL      RPOS(2), TD
      LOGICAL   F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA NEED, OPCODE /256, 32767/
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      IERR = 0
C                                       plot file
      IF (.NOT.GPHDOT) THEN
C                                       fill & out last rec(s)
         IERR = 1
         IF (GPHPOS.GE.NEED) THEN
            CALL GPHWRT (BUFF, IER)
            IF (IER.NE.0) GO TO 999
            END IF
         BUFF(GPHPOS+1) = OPCODE
         GPHPOS = GPHPOS + 1
         CALL GPHWRT (BUFF, IER)
         IF (IER.NE.0) GO TO 999
C                                       size info message:temp ?
         WRITE (MSGTXT,1000) GPHRRN
         CALL MSGWRT (2)
C                                       compress file: check size
         IF (GPHSIZ.GT.GPHRRN) THEN
            ISIZE = GPHRRN + 1
            IERR = 3
            CALL ZCMPRS (GPHVOL, GPHNAM, GPHLUN, ISIZE, IER)
            IF (IER.NE.0) GO TO 999
            END IF
C                                       close
         IERR = 4
         CALL ZCLOSE (GPHLUN, GPHIND, IER)
         IF (IER.EQ.0) IERR = 0
C                                       TV mode
      ELSE
         CALL YHOLD ('OFFF', IER)
C                                       grey image catalog
         IMAWIN(1) = GPHIX0
         IMAWIN(2) = GPHIY0
         IMAWIN(3) = GPHIX0 + GPHIX2 - GPHIX1
         IMAWIN(4) = GPHIY0 + GPHIY2 - GPHIY1
         DO 10 I = 1,NGRAY
            IF (GPHCON(I).GT.0) THEN
               IF (I.EQ.GPHTVC(2)) CALL RCOPY (2, GPHRNG(1,2),
     *            GPHCAT(IRRAN))
               IF (I.EQ.GPHTVC(3)) CALL RCOPY (2, GPHRNG(1,3),
     *            GPHCAT(IRRAN))
               CALL YCWRIT (I, IMAWIN, GPHCAT, GPHSCR, IER)
               IF (IER.NE.0) THEN
                  WRITE (MSGTXT,1100) IER, GPHTVC
                  CALL MSGWRT (6)
                  END IF
               END IF
 10         CONTINUE
C                                       graphics plane catalog
         IMAWIN(1) = 1
         IMAWIN(2) = 1
         IMAWIN(3) = MAXXTV(1)
         IMAWIN(4) = MAXXTV(2)
         DO 20 I = NGRAY+1,NGRAY+8
            IF (GPHCON(I).GT.0) THEN
               CALL YCWRIT (I, IMAWIN, GPHCAT, GPHSCR, IER)
               IF (IER.NE.0) THEN
                  WRITE (MSGTXT,1110) IER
                  CALL MSGWRT (6)
                  END IF
               END IF
 20         CONTINUE
         IF (GPHERV.GT.0) THEN
            WRITE (MSGTXT,1120) GPHERV
            CALL MSGWRT (3)
            END IF
         IF (GPHERC.GT.0) THEN
            WRITE (MSGTXT,1121) GPHERC
            CALL MSGWRT (3)
            END IF
         IF (GPHERG.GT.0) THEN
            WRITE (MSGTXT,1122) GPHERG
            CALL MSGWRT (3)
            END IF
         IF (GPHERO.GT.0) THEN
            WRITE (MSGTXT,1123) GPHERO
            CALL MSGWRT (3)
            END IF
C                                       there will be another page
C                                       wait for 30 seconds or button
         IF (GPHPAG) THEN
            MSGTXT = 'Waiting 30 seconds:'
            CALL MSGWRT (1)
            MSGTXT = '   Hit TV button A to pause indefinitely.' //
     *         '  Hit button'
            CALL MSGWRT (1)
            MSGTXT = '   B or C to continue sooner, button D' //
     *         ' to stop plotting'
            CALL MSGWRT (1)
            RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2.0
            RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2.0
            TD = 3. / SQRT (MAX (1.0, AIPSMK))
            CALL YCURSE ('ONNN', F, F, RPOS, IQ, IB, IERR)
            IF (IERR.NE.0) GO TO 145
            NC = 30.0 / TD + 0.5
            IC = NC
 130        CONTINUE
            DO 140 I = 1,NC
               CALL ZDELAY (TD, IERR)
               CALL YCURSE ('READ', F, F, RPOS, IQ, IB, IERR)
               IF ((IB.GT.0) .OR. (IERR.NE.0)) THEN
                  IF ((IB.EQ.1) .AND. (NC.LE.IC)) THEN
                     NC = 3000.0 / TD + 0.5
                     MSGTXT = 'Pausing indefinitely:'
                     CALL MSGWRT (1)
                     MSGTXT = '   Hit TV button A, B, or C to continue,'
     *                  // ' D to quit'
                     CALL MSGWRT (1)
                     GO TO 130
                  ELSE
                     GO TO 145
                     END IF
                  END IF
 140           CONTINUE
C                                       Wants to quit
 145        IF (IB.GT.7) THEN
               WRITE (MSGTXT,1145)
               CALL MSGWRT (3)
               IF (IERR.EQ.0) IERR = -1
            ELSE
               WRITE (MSGTXT,1146)
               CALL MSGWRT (1)
               END IF
C                                       Off cursor
            CALL YCURSE ('OFFF', F, F, RPOS, IQ, IB, IER)
            END IF
C                                       close TV
         CALL TVCLOS (GPHSCR, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1150) IER
            CALL MSGWRT (6)
            END IF
         END IF
C                                        clear common some
      GPHSIZ = 0
      GPHLUN = 0
      GPHPOS = 0
      GPHRRN = 0
      GPHVOL = 0
      GPHNAM = ' '
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GFINIS: number records used',I8)
 1100 FORMAT ('GFINIS: ERROR',I5,' UPDATING CHANNEL',I3,
     *   ' IN IMAGE CATALOG')
 1110 FORMAT ('GFINIS: ERROR',I5,' UPDATING GRAPHICS CHANNEL',
     *   ' IN IMAGE CATALOG')
 1120 FORMAT (I8,' vectors truncated at edges')
 1121 FORMAT (I8,' character strings truncated at edges')
 1122 FORMAT (I8,' grey scale lines truncated at edges')
 1123 FORMAT (I8,' character strings omitted due to overlaps')
 1145 FORMAT ('Button D was hit - stop plots now')
 1146 FORMAT ('Continuing')
 1150 FORMAT ('GFINIS: ERROR',I5,' CLOSING THE TV')
      END

      SUBROUTINE DTTIME (POINT, COMENT)
C-----------------------------------------------------------------------
C! displays elapsed CPU and real times since last call to DTINIT
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DTTIME will print the elapsed real time, cpu time and IO count since
C   an init call, along with a comment or a call number supplied by
C   the calling routine.
C   Inputs:
C      POINT    I      Number to appear in print: < 0 => init
C                         0 means print COMENT instead.
C      COMENT   C*8    String comment to appear if POINT is 0.
C-----------------------------------------------------------------------
      INTEGER   POINT
      CHARACTER COMENT*(*)
C
      CHARACTER LOMENT*8
      REAL      LSTTIM, LSTCPU, TIME, CPU
      INTEGER   LSTIOC, NOW(3), IOCNT
      INCLUDE 'INCS:DMSG.INC'
      SAVE LSTTIM, LSTCPU, LSTIOC
      DATA LSTTIM, LSTCPU, IOCNT /0.0, 0.0, 0/
C-----------------------------------------------------------------------
C                                       init
      IF ((LSTTIM.LE.0.0) .OR. (LSTCPU.LE.0.0) .OR. (POINT.LT.0)) THEN
         CALL ZTIME (NOW)
         LSTTIM = NOW(3) + 60.0 * NOW(2) + 3600.0 * NOW(1)
         CALL ZCPU (LSTCPU, LSTIOC)
C                                       display
      ELSE
         LOMENT = COMENT
         CALL ZTIME (NOW)
         TIME = NOW(3) + 60.0 * NOW(2) + 3600.0 * NOW(1)
         TIME = TIME - LSTTIM
         CALL ZCPU (CPU, IOCNT)
         IOCNT = IOCNT - LSTIOC
         CPU = CPU - LSTCPU
         IF (POINT.EQ.0) THEN
            WRITE (MSGTXT,1000) LOMENT, TIME, CPU, IOCNT
         ELSE
            WRITE (MSGTXT,1001) POINT, TIME, CPU, IOCNT
            END IF
         CALL MSGWRT (5)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A8,': SECS REAL TIME=',F9.0,' CPU=',F9.2,
     *   ' IO CNT=',I8)
 1001 FORMAT ('PT',I6,': SECS REAL TIME=',F9.0,' CPU=',F9.2,
     *   ' IO CNT=',I8)
      END

      SUBROUTINE TABTE (OPCODE, BUFFER, ITERNO, TEKOLS, TENUMV, TIME,
     *   SOURCE, ANTEN, HA, AZ, ZA, AZION, ZAION, DLON, DLAT, B,
     *   TEPATH, MAG, TEC, IFR, DISP, IERR)
C-----------------------------------------------------------------------
C! Does I/O to TECOR details table
C# EXT-util UV Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 2023-2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to phase difference (TE) extention tables. Used after
C   setup by TEINI.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'READ' = read entry from table.
C                        'WRIT' = write entry in table.
C                        'CLOS' = close file, flush on write
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open. Should have been returned by
C                        TEINI or TABINI.
C      ITERNO   I        Next entry number to read or write.
C      TEKOLS   I(MAXTEC) The column pointer array in order,
C      TENUMV   I(MAXTEC) Element count in each column.
C   Input/output: (written to or read from baseline file)
C      TIME     D       Time (days)
C      SOURCE   I       Source number
C      ANTEN    I       Antenna number
C      HA       R       Hour angle degrees
C      AZ       R       Azimuth degrees
C      za       R       Zenith angle degrees
C      AZION    R       pierce point azimuth degrees
C      ZAION    R       pierce point zenith angle degrees
C      DLON     R       pierce point longitude offset degrees
C      DLAT     R       pierce point latitude offset degrees
C      B        R(3)    Magnetic field vector (gauss),
C                         (1) = positive away from earth center,
C                         (2) = positive east,
C                         (3) = positive north.
C      TEPATH   R       Electrons/meter^2 / 10^16 toward source
C      MAG      R       Earth magnetic field in direction of source
C      TEC      R       Electrons/meter^2 / 10^16 vertical
C      IFR      R       Ionospheric rotation measure radians/meter^2
C      DISP     R(2)       Dispersive delay seconds/meter^2
C   Output:
C      ITERNO    I      Next solution number.
C      IERR      I      Error code, 0=>OK else TABIO error.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   XTERSZ, MAXTEC
      PARAMETER (XTERSZ = 20)
      PARAMETER (MAXTEC = 16)
C
      CHARACTER OPCODE*4
      DOUBLE PRECISION TIME
      INTEGER   BUFFER(*), ITERNO, TEKOLS(MAXTEC), TENUMV(MAXTEC),
     *   SOURCE, ANTEN, IERR
      REAL      HA, AZ, ZA, AZION, ZAION, DLON, DLAT, B(3), TEPATH,
     *   MAG, TEC, IFR, DISP(2)
C
      INTEGER   RECI(XTERSZ)
      REAL      RECORD(XTERSZ)
      DOUBLE PRECISION RECD(XTERSZ/2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      SAVE RECORD
      EQUIVALENCE (RECD, RECORD, RECI)
C-----------------------------------------------------------------------
C                                       Close
      IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, ITERNO, RECORD, BUFFER, IERR)
         IF (IERR.GT.0) GO TO 980
         GO TO 999
         END IF
C                                       If write fill RECORD
      IF (OPCODE.NE.'READ') THEN
         RECD(TEKOLS(1)) = TIME
         RECI(TEKOLS(2)) = SOURCE
         RECI(TEKOLS(3)) = ANTEN
         RECORD(TEKOLS(4)) = HA
         RECORD(TEKOLS(5)) = AZ
         RECORD(TEKOLS(6)) = ZA
         RECORD(TEKOLS(7)) = AZION
         RECORD(TEKOLS(8)) = ZAION
         RECORD(TEKOLS(9)) = DLON
         RECORD(TEKOLS(10)) = DLAT
         CALL RCOPY (3, B, RECORD(TEKOLS(11)))
         RECORD(TEKOLS(12)) = TEPATH
         RECORD(TEKOLS(13)) = MAG
         RECORD(TEKOLS(14)) = TEC
         RECORD(TEKOLS(15)) = IFR
         IF (TEKOLS(16).GT.0) CALL RCOPY (2, DISP, RECORD(TEKOLS(16)))
         END IF
C                                       Process record.
      CALL TABIO (OPCODE, 0, ITERNO, RECORD, BUFFER, IERR)
      ITERNO = ITERNO + 1
      IF (IERR.GT.0) GO TO 980
C                                       If READ pick data from RECORD.
      IF (OPCODE.EQ.'READ') THEN
         TIME   = RECD(TEKOLS(1))
         SOURCE = RECI(TEKOLS(2))
         ANTEN  = RECI(TEKOLS(3))
         HA     = RECORD(TEKOLS(4))
         AZ     = RECORD(TEKOLS(5))
         ZA     = RECORD(TEKOLS(6))
         AZION  = RECORD(TEKOLS(7))
         ZAION  = RECORD(TEKOLS(8))
         DLON   = RECORD(TEKOLS(9))
         DLAT   = RECORD(TEKOLS(10))
         CALL RCOPY (3, RECORD(TEKOLS(11)), B)
         TEPATH = RECORD(TEKOLS(12))
         MAG    = RECORD(TEKOLS(13))
         TEC    = RECORD(TEKOLS(14))
         IFR    = RECORD(TEKOLS(15))
         CALL RFILL (2, 0.0, DISP)
         IF (TEKOLS(16).GT.0) CALL RCOPY (2, RECORD(TEKOLS(16)), DISP)
         END IF
      GO TO 999
C                                       Error
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('TABTE: TABIO ERROR',I3)
      END

      SUBROUTINE YCNECT (X1, Y1, X2, Y2, IC, LBUFF, IERR)
C-----------------------------------------------------------------------
C! write line segment between 2 points on TV
C# Y0 TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YCNECT writes a line segment on the TV.  This version will work on
C   all TVs.  It is called a Y routine to allow the use of hardware
C   vector generators on those TVs equiped with them.
C   Inputs:
C      X1      I      start X position
C      Y1      I      start Y position
C      X2      I      end X position
C      Y2      I      end Y position
C      IC      I      Channel (1 to NGRAY+NGRAPH)
C      LBUFF   I(*)   Buffer contains desired intensity (size > max
C                     horizontal or vertical line, e.g., 1280)
C   Output:
C      IERR    I      error code : 0 => ok
C   Virtual TV version for TV by COMMUNICATION
C-----------------------------------------------------------------------
      INTEGER    X1, Y1, X2, Y2, IC, LBUFF(*), IERR
C
      INCLUDE 'INCS:DVTV.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
C                                       test
      IF ((X1.LT.1) .OR. (X1.GT.MAXXTV(1))) GO TO 900
      IF ((Y1.LT.1) .OR. (Y1.GT.MAXXTV(2))) GO TO 900
      IF ((X2.LT.1) .OR. (X2.GT.MAXXTV(1))) GO TO 900
      IF ((Y2.LT.1) .OR. (Y2.GT.MAXXTV(2))) GO TO 900
      IF ((IC.LT.1) .OR. (IC.GT.NGRAY+NGRAPH)) GO TO 900
C                                       doit
      BUFFER(1) = X1
      BUFFER(2) = Y1
      BUFFER(3) = X2
      BUFFER(4) = Y2
      BUFFER(5) = IC
      BUFFER(6) = LBUFF(1)
      BUFSW = 6
      BUFSR = 0
      CALL MKYBUF ('WRIT', 'YCNECT', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
      GO TO 999
C                                       error
 900  WRITE (MSGTXT,1900) IC, X1, X2, Y1, Y2
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('YCNECT: BAD CHAN, X1,X2,Y1,Y2:',5I7)
      END

      SUBROUTINE BCLEAN
C-----------------------------------------------------------------------
C! Pops items from B-stack to A-stack until BPR-stack precedence < NEXTP
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   BCLEAN pops items from B-stack to A-stack until the precedence
C   in the BPR-stack is less than the parameter NEXTP.  Used in
C   generating Polish postfix string of opcodes and operands.
C   Changes STACK, AP, BP in /POPS/
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   BPR(100), A(100), B(100), M
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DSMS.INC'
      EQUIVALENCE (STACK(1), A(1)), (CSTACK(1), B(1)), (BPR(1), V(1))
      DATA PRGNAM /'BCLEAN'/
C-----------------------------------------------------------------------
 10   IF (BP.LE.0) GO TO 999
         M = B(BP)
         IF (BPR(BP).LT.NEXTP) GO TO 999
            CALL PUSH (A, AP, M)
            IF (ERRNUM.NE.0) GO TO 980
            BP = BP - 1
            GO TO 10
C                                         Error return.
 980  ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
      END

LOCAL INCLUDE 'CHEBI.INC'
C                                       Local include for CHEBI
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XOUTFL(12)
      REAL      APARM(10)
      INTEGER   NNCHEB, NCHEB(10), SCRTCH(256)
      CHARACTER OUTFIL*48
      COMMON /INPARM/ APARM, XOUTFL
      COMMON /CHARPM/ OUTFIL
      COMMON /CHEBIC/ NNCHEB, NCHEB, SCRTCH
C                                       End local include for CHEBI
LOCAL END
      PROGRAM CHEBI
C-----------------------------------------------------------------------
C! Write Chebysev polynomial values to text file for PLOTR
C# Utility Plot
C-----------------------------------------------------------------------
C;  Copyright (C) 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CHEBI computes a polarized point source model with polarized
C   antennas.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      APARM          APARM         Chebyshev orders
C      OUTFILE        OUTFIL        Output file name
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'CHEBI.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA PRGM /'CHEBI '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL CHEBII (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL CHEBID (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE CHEBII (PRGN, JERR)
C-----------------------------------------------------------------------
C   CHEBII gets input parameters for CHEBI and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      INTEGER   IROUND, NPARM, I, IERR
      INCLUDE 'CHEBI.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 22
      CALL GTPARM (PRGN, NPARM, RQUICK, APARM, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRTCH, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (48, 1, XOUTFL, OUTFIL)
      NNCHEB = 0
      CALL FILL (10, 0, NCHEB)
      DO 10 I = 1,10
         NCHEB(I) = IROUND (APARM(I))
         NCHEB(I) = MIN (NCHEB(I), 99)
         IF (NCHEB(I).GT.0) THEN
            NNCHEB = NNCHEB + 1
         ELSE
            GO TO 990
            END IF
 10      CONTINUE
C
 990  IF (NNCHEB.GT.0) THEN
         JERR = 0
         WRITE (MSGTXT,1010) NNCHEB, NCHEB
         CALL MSGWRT (3)
      ELSE
         MSGTXT = 'NO CHEBYSHEV PLOTS REQUESTED'
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CHEBII: ERROR',I3,' ON',A)
 1010 FORMAT ('Read',I3,' Chebyshevs',10I3)
      END
      SUBROUTINE CHEBID (IRET)
C-----------------------------------------------------------------------
C   CHEBID writes the text FILE
C   Output
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'CHEBI.INC'
      INTEGER   I, J, N, JTRIM, TXLUN, TXIND, K, NX
      DOUBLE PRECISION DA, DB, X, DCHEB(101)
      CHARACTER ALINE*132
      REAL      COL, DC, DX
      INCLUDE 'INCS:DMSG.INC'
      DATA TXLUN /3/
C-----------------------------------------------------------------------
C                                       create output text file
      CALL ZTXOPN ('WRIT', TXLUN, TXIND, OUTFIL, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATE OUTPUT TEXT FILE'
         GO TO 990
         END IF
C                                       initial lines
      ALINE = 'Chebyshev polynomial values'
      J = JTRIM (ALINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, ALINE(:J), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE TEXT FILE'
         GO TO 980
         END IF
      WRITE (ALINE,1010) (NCHEB(I), I = 1,NNCHEB)
      J = JTRIM (ALINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, ALINE(:J), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE TEXT FILE'
         GO TO 980
         END IF
      ALINE = ' '
      J = 1
      CALL ZTXIO ('WRIT', TXLUN, TXIND, ALINE(:J), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE TEXT FILE'
         GO TO 980
         END IF
      ALINE = 'X'
      CALL ZTXIO ('WRIT', TXLUN, TXIND, ALINE(:J), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE TEXT FILE'
         GO TO 980
         END IF
      ALINE = 'Chebyshev value'
      J = JTRIM (ALINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, ALINE(:J), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE TEXT FILE'
         GO TO 980
         END IF
C                                       now the values
      DA = 0.0D0
      DB = 1.0D0
      DC = 1.0 / (NNCHEB + 1)
      DO 100 K = 1,NNCHEB
         N = NCHEB(K)
         COL = K * DC
         IF (N.LT.7) THEN
            DX = 0.02
         ELSE IF (N.LT.12) THEN
            DX = 0.01
         ELSE
            DX = 0.005
            END IF
         NX = 1 / DX
         DO 90 I = 0,NX
            X = I * DX
            CALL CHEBY (DA, DB, X, DCHEB, N, IRET)
            IF (IRET.EQ.0) THEN
               IF (NNCHEB.GT.1) THEN
                  WRITE (ALINE,1020) X, DCHEB(N+1), K, COL
               ELSE
                  WRITE (ALINE,1020) X, DCHEB(N+1), K
                  END IF
               J = JTRIM (ALINE)
               CALL ZTXIO ('WRIT', TXLUN, TXIND, ALINE(:J), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITE TEXT FILE'
                  GO TO 980
                  END IF
               END IF
 90         CONTINUE
 100     CONTINUE
      CALL ZTXCLS (TXLUN, TXIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSE TEXT FILE'
         GO TO 990
         END IF
      GO TO 999
C                                       errors
 980  CALL MSGWRT (8)
      CALL ZTXCLS (TXLUN, TXIND, I)
      IF (I.EQ.0) GO TO 999
      WRITE (MSGTXT,1000) I, 'CLOSE TEXT FILE'
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CHEBID ERROR',I4,' ON ',A)
 1010 FORMAT ('Chebyshev orders',10I3)
 1020 FORMAT (F8.4,F9.4,I4,F7.3)
      END

      PROGRAM COOKNS
C-----------------------------------------------------------------------
C! Converts COOKNS.SRT, the semi-sorted CookBook index, to TeX
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 2004, 2012-2013, 2018
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Program to read in the semi-sorted list of index entries for the
C   CookBook (produced by "sort -f COOK*.ndx > COOKNS.SRT"
C   Reads COOKNS.SRT for a list of index entries and writes two
C   different tex files for different formats of index.
C      A logical or enviroment variable named MYDIR must be defined
C   before running COOKNS.
C-----------------------------------------------------------------------
      INTEGER   NEQ
      PARAMETER (NEQ = 200)
C
      CHARACTER INLINE*132, LNLINE*132, OUTLIN*512, OUTFIL*48, LFIL*48,
     *   LTOPIC*128, ITOPIC*128, CCH(NEQ)*2, CTTYP*1, CPTYP(NEQ)*1,
     *   LFC*1, IFC*1, ITUPIC*128, LTUPIC*128, CSYM(NEQ)*20
      INTEGER   IOERR, I, J, BUFFER(512), LUNO, FINDO, LUNI, FINDI,
     *   IPT, IPS, IPTT, IPCT, IL, IP, IEQ, J1, LUNT, FINDT, IPC, IPP,
     *   JT, JTRIM
      LOGICAL   WASEOF
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LUNO, LUNI, LUNT /16, 17, 18/
C-----------------------------------------------------------------------
C                                       AIPS system start up stuff
      TSKNAM ='COOKNS'
      NPOPS = 1
      CALL ZDCHIN (.FALSE., BUFFER)
      DEVTAB(LUNO) = 3
      DEVTAB(LUNI) = 3
      DEVTAB(LUNT) = 3
C                                       Get list of index entries
      LFIL = 'MYDIR:COOKNS.SRT'
      CALL ZTXOPN ('READ', LUNI, FINDI, LFIL, .FALSE., IOERR)
      IF (IOERR.NE.0) GO TO 999
C                                       Open output file
      OUTFIL = 'MYDIR:COOKJ.TEX'
      CALL ZTXOPN ('WRIT', LUNO, FINDO, OUTFIL, .TRUE., IOERR)
      IF (IOERR.NE.0) GO TO 900
C                                       Open template file
      LFIL = 'MYDIR:COOKJ.TEMP'
      CALL ZTXOPN ('READ', LUNT, FINDT, LFIL, .FALSE., IOERR)
      IF (IOERR.NE.0) GO TO 999
C                                       Read template until insert point
 10      CALL ZTXIO ('READ', LUNT, FINDT, INLINE, IOERR)
         IF (IOERR.NE.0) GO TO 900
         JT = JTRIM (INLINE)
         IF (INLINE.NE.'%%Insert here') THEN
            OUTLIN = INLINE
            IP = JTRIM (OUTLIN)
            CALL ZTXIO ('WRIT', LUNO, FINDO, OUTLIN(:IP), IOERR)
            IF (IOERR.NE.0) GO TO 900
            GO TO 10
            END IF
C                                       init pointers
      LTOPIC = ' '
      LTUPIC = ' '
      WASEOF = .FALSE.
      IEQ = 0
C                                       Begin looping over input file
 15   CALL ZTXIO ('READ', LUNI, FINDI, INLINE, IOERR)
         IF (IOERR.EQ.2) THEN
            WASEOF = .TRUE.
            ITOPIC = ' '
            ITUPIC = ' '
         ELSE IF (IOERR.NE.0) THEN
            GO TO 900
         ELSE
            JT = JTRIM (INLINE)
C                                       skip blanks, repeats, comments
            IF ((INLINE.EQ.' ') .OR. (INLINE.EQ.LNLINE)) GO TO 15
            IF (INLINE(1:1).EQ.'%') GO TO 15
C                                       current pointers
            IPT = INDEX (INLINE(1:), ':') + 1
            IPC = INDEX (INLINE(IPT:), ':') + IPT
            IPP = INDEX (INLINE(IPC:), ':') + IPC
            IPS = INDEX (INLINE(IPP:), ':') + IPP
            IPTT = INDEX (INLINE(IPS:), ':') + IPS
            IPCT = INDEX (INLINE(IPTT:), ':') + IPTT
            ITOPIC = INLINE(IPT:IPC-2)
C                                       special cases
            IF (INLINE(IPTT:IPTT).NE.'T') THEN
               IF (ITOPIC.EQ.'Aips') ITOPIC = '\AIPS'
               IF (ITOPIC.EQ.'AIPS') ITOPIC = '\AIPS'
               IF ((ITOPIC(:5).EQ.'Pops ') .OR. (ITOPIC(:5).EQ.'POPS'))
     *            THEN
                  ITUPIC = ITOPIC
                  IF (ITUPIC(5:).EQ.' ') THEN
                     ITOPIC = '\POPS'
                  ELSE
                     ITOPIC = '\POPS\ ' // ITUPIC(5:)
                     END IF
                  END IF
               IF (ITOPIC.EQ.'Aipsletter') ITOPIC = '\Aipsletter'
               IF (ITOPIC.EQ.'COOKBOOK') ITOPIC = '\COOKBOOK'
               IF (ITOPIC.EQ.'Cookbook') ITOPIC = '\COOKBOOK'
               IF (ITOPIC.EQ.'TEX') ITOPIC = '\TEX'
               IF (ITOPIC.EQ.'AIPS++') ITOPIC = '\AIPTOO'
               IF (ITOPIC.EQ.'aips++') ITOPIC = '\AIPTOO'
               IF (ITOPIC.EQ.'Going AIPS') ITOPIC = '\it Going \AIPS'
               END IF
            ITUPIC = ITOPIC
            CALL CHLTOU (128, ITUPIC)
            END IF
C                                       dump current list
         IF (ITUPIC.NE.LTUPIC) THEN
            IL = JTRIM (LTOPIC)
            J = 0
            OUTLIN = ' '
 20         J = J + 1
            IF (J.LE.IEQ) THEN
               OUTLIN = '\scls{'
               IF (J.NE.1) OUTLIN(5:5) = 'p'
               IP = 7
               IF (CTTYP.EQ.'T') THEN
                  OUTLIN(IP:) = '\tt '
                  IP = IP + 4
               ELSE IF (CTTYP.EQ.'I') THEN
                  OUTLIN(IP:) = '\it '
                  IP = IP + 4
                  END IF
               I = JTRIM (CCH(J))
               OUTLIN(IP:) = LTOPIC(:IL) // '}{' // CCH(J)(:I) // '}{'
               IP = IP + IL + I + 4
C                                       any more in this chapter
               DO 25 I = J,MIN(J+5,IEQ)
                  IF (CCH(J).NE.CCH(I)) GO TO 30
                  J1 = I
 25               CONTINUE
 30            IF (J.LE.J1) THEN
                  I = JTRIM (CSYM(J))
                  IF (CPTYP(J).EQ.'B') THEN
                     OUTLIN(IP:) = '{\bf \ISec{' // CSYM(J)(:I)
     *                   // '}}'
                     IP = IP + 13 + I
                  ELSE
                     OUTLIN(IP:) = '\ISec{' // CSYM(J)(:I) // '}'
                     IP = IP + 7 + I
                     END IF
                  IF (J.LT.J1) THEN
                     J = J + 1
                     OUTLIN(IP:) = ', '
                     IP = IP + 2
                     GO TO 30
                     END IF
                  END IF
               IP = JTRIM (OUTLIN)
               IF (IP.GT.0) THEN
                  IP = IP + 1
                  OUTLIN(IP:IP) = '}'
                  CALL ZTXIO ('WRIT', LUNO, FINDO, OUTLIN(:IP), IOERR)
                  IF (IOERR.NE.0) GO TO 900
                  END IF
               GO TO 20
               END IF
            IEQ = 0
C                                       alphabet
            IF (.NOT.WASEOF) THEN
               CALL FNDFST (ITUPIC, IFC)
               CALL FNDFST (LTUPIC, LFC)
               IF (IFC.NE.LFC) THEN
                  OUTLIN = '\alphasect{' // IFC // '}'
                  IP = JTRIM (OUTLIN)
                  CALL ZTXIO ('WRIT', LUNO, FINDO, OUTLIN(:IP), IOERR)
                  IF (IOERR.NE.0) GO TO 900
                  END IF
               END IF
            END IF
C                                       add to list
         IF (.NOT.WASEOF) THEN
            IEQ = IEQ + 1
            CSYM(IEQ) = INLINE(IPS:IPTT-2)
            IP = INDEX (CSYM(IEQ), '.')
            CCH(IEQ) = CSYM(IEQ)(:IP-1)
            CPTYP(IEQ) = INLINE(IPCT:IPCT)
            IF ((IEQ.EQ.1) .OR. (CTTYP.EQ.'R')) CTTYP =
     *         INLINE(IPTT:IPTT)
            IF (LTUPIC.NE.ITUPIC) THEN
               LTOPIC = ITOPIC
               LTUPIC = ITUPIC
               END IF
            LNLINE = INLINE
            GO TO 15
            END IF
C                                       copy last of template
 50      CALL ZTXIO ('READ', LUNT, FINDT, INLINE, IOERR)
         IF (IOERR.EQ.2) THEN
            IOERR = 0
            GO TO 900
         ELSE IF (IOERR.NE.0) THEN
            GO TO 900
         ELSE
            OUTLIN = INLINE
            IP = JTRIM (OUTLIN)
            CALL ZTXIO ('WRIT', LUNO, FINDO, OUTLIN(:IP), IOERR)
            IF (IOERR.NE.0) GO TO 900
            GO TO 50
            END IF
C                                       Done - close files
 900  IF (IOERR.NE.0) THEN
         WRITE (MSGTXT,1900) IOERR
         CALL MSGWRT (7)
         END IF
      CALL ZTXCLS (LUNO, FINDO, IOERR)
      CALL ZTXCLS (LUNI, FINDI, IOERR)
      CALL ZTXCLS (LUNT, FINDT, IOERR)
C
 999  STOP
C-----------------------------------------------------------------------
 1900 FORMAT ('ERROR',I7,' DOING READS OR WRITES')
      END
      SUBROUTINE FNDFST (TOPIC, FCH)
C-----------------------------------------------------------------------
C   finds first character by alphabetic rules
C   Input:
C      TOPIC   C*(*)   String
C   Output
C      FCH     C*1     First usable character in upper case
C-----------------------------------------------------------------------
      CHARACTER TOPIC*(*), FCH*1
C
      INTEGER   I, J, L, JTRIM
      CHARACTER LC*1, ALPHA*36, LTOPIC*132
      LOGICAL   WASBKS
      DATA ALPHA /'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'/
C-----------------------------------------------------------------------
      FCH = ' '
      L = JTRIM (TOPIC)
      L = MIN (132, L)
      LTOPIC = TOPIC(:L)
      WASBKS = .FALSE.
      IF (L.GT.0) THEN
         CALL CHLTOU (L, LTOPIC)
         DO 20 I = 1,L
            LC = LTOPIC(I:I)
            IF (WASBKS) THEN
               WASBKS = LC.NE.' '
            ELSE IF (LC.EQ.'\') THEN
               WASBKS = LTOPIC(I:I+3).EQ.'\IT '
            ELSE
               DO 10 J = 1,36
                  IF (LC.EQ.ALPHA(J:J)) GO TO 30
 10               CONTINUE
               END IF
 20         CONTINUE
         LC = ' '
 30      FCH = LC
         END IF
C
 999  RETURN
      END
      SUBROUTINE CHANUM (CHN)
C-----------------------------------------------------------------------
C   changes chapter numbers that are too large to letters
C   In/out:
C      CHN    C*(*)    Chapter number letter code
C-----------------------------------------------------------------------
      CHARACTER CHN*(*)
C
      INTEGER   I, NAPPEN
      PARAMETER (NAPPEN = 11)
      CHARACTER CHLIST(2,NAPPEN)*2
      DATA CHLIST /'21','A', '22','B', '23','C', '24','D','26','L',
     *   '27','F', '28','O', '30','Z', '35','V', '40','G', '41','I'/
C-----------------------------------------------------------------------
      DO 10 I = 1,NAPPEN
         IF (CHN.EQ.CHLIST(1,I)) CHN = CHLIST(2,I)
 10      CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'TEPLT.INC'
      INTEGER   NCODE
      PARAMETER (NCODE=16)
C                                       Local include for TEPLT
      INCLUDE 'INCS:PUVD.INC'
C                                       Input parameters
      REAL      XSIN, XDISIN, XNVER, XNVER2, XQUAL, XTIME(8), XANT(50),
     *   PIXR(2), XNCOU, XXINC, APARM(10), BPARM(10), CPARM(10), XDO3C,
     *   XSYM, FACTOR, XSCAN, XLABEL, XDOTV, XGRCH, XYRATO
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XOPTY(1), XOPCOD(1)
      CHARACTER NAMEIN*12, CLAIN*6, TYPE*2, XSOUR(30)*16, OPTYPE*4,
     *   OPCODE*4, TECTYP*8
C                                       Program info
C
      INTEGER   MXSCAN
      PARAMETER (MXSCAN=5000)
C
      REAL      TSTART, TSTOP, TINT, XYSCL(2), XYOFF(2), YYMX(10),
     *   YYMN(10), XMX, XMN, XMXW, XMNW, GMMOD, RATFAC(MAXIF), SELBAN,
     *   XSTART, XSTOP, CHOUT(4), XXMIN(MAXANT), XXMAX(MAXANT),
     *   YYMIN(MAXANT,10), TSCAN(MXSCAN),
     *   YYMAX(MAXANT,10), PRAN(2,2),
     *   DO3COL, TCAL(4,MAXIF,MAXANT), CSMIN, CSMAX
      INTEGER   SEQIN, DISKIN, CNOIN, IVER, BIF, ANTS(50), NCOUNT,
     *   ICODES(10), NCODES, NPARMS, NID, SID(500), NANTSL, NPLOTS,
     *   ISTOK, FRQSEL, XINC, GRCHN, GR2CHN, TVCHN, TVCORN(4), XVAR,
     *   ISOU, OSOU, IANT, EIF, ITPLOT, ITVER, PCNUM, LABEL, SUBARR,
     *   MUMPAR, MUMPOL, MUMIF, MUMANT, NTONE, NUMPTS(MAXANT), ISYM,
     *   NANREC(MAXANT), FANREC(MAXANT), NOSCAN, STRANS(MXSCAN),
     *   REFANT, I2VER
      LOGICAL   DOAWNT, DOTV, NNODAT, DOLINE, SWAP, REREF
      DOUBLE PRECISION SELFRQ, JD0
C                                       Constants
      DOUBLE PRECISION SIDER, CLIGHT
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNVER, XNVER2,
     *   XXSOUR, XQUAL, XTIME, XANT, PIXR, XNCOU, XXINC, XOPTY, XOPCOD,
     *   APARM, BPARM, CPARM, XDO3C, XSYM, FACTOR, XSCAN, XLABEL, XDOTV,
     *   XGRCH, XYRATO
      COMMON /VPARM/ SEQIN, DISKIN, CNOIN, IVER, BIF, EIF, ANTS, NCOUNT,
     *   ICODES, NCODES, NPARMS, GRCHN, TVCHN, TVCORN, XVAR, ISOU, OSOU,
     *   IANT, ITPLOT, ITVER, PCNUM, DOTV, NNODAT, LABEL, CHOUT, DO3COL,
     *   DOLINE, NOSCAN, TSCAN, STRANS, SWAP, REREF, REFANT, GR2CHN,
     *   I2VER
      COMMON /VGNCOM/ SELFRQ, JD0,
     *   TSTART, TSTOP, TINT, XYSCL, XYOFF, SELBAN, XMX, XMN, XMXW,
     *   XMNW, XSTART, XSTOP, GMMOD, RATFAC, NID, SID, NANTSL, PRAN,
     *   NPLOTS, DOAWNT, ISTOK, FRQSEL, XINC,
     *   SUBARR, MUMPAR, MUMPOL, MUMIF, MUMANT, NUMPTS, NTONE,
     *   XXMIN, XXMAX, YYMIN, YYMAX, YYMX, YYMN, ISYM,
     *   TCAL, NANREC, FANREC, CSMIN, CSMAX
      COMMON /VGNCHR/ NAMEIN, CLAIN, TYPE, XSOUR, OPTYPE, OPCODE, TECTYP
      COMMON /CONST/ SIDER, CLIGHT
C                                                          End TEPLT
LOCAL END
LOCAL INCLUDE 'TEFILE.INC'
      INTEGER   TEBUFF(512), ITERNO, TEKOLS(16), TENUMV(16), TESOUR,
     *   TEANTE, NTEINR, TEBUF2(512)
      DOUBLE PRECISION TETIME
      REAL      TEHA, TEAZ, TEEL, TEAZIO, TEZAIO, TEDLON, TEDLAT,
     *   TEB(3), TEPATH, TEMAG, TETEC, TEIFR, TEDISP(2), TEVALS(17)
      EQUIVALENCE (TEVALS(2), TEHA)
      COMMON /TEDATA/ TEBUFF, TEBUF2, TETIME, TEHA, TEAZ, TEEL, TEAZIO,
     *   TEZAIO, TEDLON, TEDLAT, TEB, TEPATH, TEMAG, TETEC, TEIFR,
     *   TEDISP, ITERNO, TEKOLS, TENUMV, TESOUR, TEANTE, NTEINR
LOCAL END
      PROGRAM TEPLT
C-----------------------------------------------------------------------
C! Plots data from a TE (TECOR) table
C# UV Plot EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2023-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TEPLT plots SN or CL extension files. A 'PL' extension file is made
C   which can be displayed in the usual ways .
C   Inputs:
C      INNAME.....UV file name (name).       Standard defaults.
C      INCLASS....UV file name (class).      Standard defaults.
C      INSEQ......UV file name (seq. #).     0 => highest.
C      INDISK.....Disk unit #.               0 => any.
C      INEXT......'TE'
C      INVERS.....Version number of table to plot, 0=>highest no.
C      SOURCES....Source list.  '*' = all; a "-" before a source
C                 name means all except ANY source named.
C      TIMERANG...Time range of the data to be plotted. In order:
C                 Start day, hour, min. sec,
C                 end day, hour, min. sec. Days relative to ref.
C                 date.
C      ANTENNAS...A list of the antennas to be plotted. All 0 => all.
C                 If any number is negative then all antennas listed
C                 are NOT to be plotted and all others are.
C      PIXRANGE...Limit the plot to values between PIXR(1) and
C                 PIXR(2).  The plots will not exceed the min/max in
C                 the actual gains.  Basically, if PIXR(1) < PIXR(2),
C                 all plots will be on the same scale and be limited
C                 to max (datamin, PIXR(1)) through min (datamax,
C                 PIXR(2)).  If PIXR(1) >= PIXR(2), each plot will be
C                 self-scaled individually.
C      NCOUNT.....Number of antennas to plot per page (try 5).
C      OPTYPE.....Data to be plotted on Y:
C      OPCODE.....Data to be plotted on X
C      APARM......Types to be plotted on Y for MULT
C      BPARM, CPARM... Pixrange for MULT
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C-----------------------------------------------------------------------
C
      CHARACTER PRGN*6
      REAL      PLTPTS(2)
      LONGINT   PPLTPT
      INTEGER   IRET, MVAL, NWORDS, NROWS
      INCLUDE 'TEPLT.INC'
      INCLUDE 'TEFILE.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGN /'TEPLT '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL TEPIN (PRGN, NROWS, IRET)
      MUMANT = MAX (1, MUMANT)
      MVAL = 3 + NCODES
      NWORDS = (MVAL * NROWS - 1) / 1024  + 21
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, PLTPTS, PPLTPT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         END IF
C                                       read data to figure out
C                                       distribution
      NWORDS = NWORDS * 1024
      IF (IRET.EQ.0) CALL TEPCNT (NWORDS, IRET)
C                                       Fetch data, determine scaling
      IF (IRET.EQ.0) CALL TEPMAX (MVAL, PLTPTS(1+PPLTPT), IRET)
C                                       Do plots
      IF (IRET.EQ.0) CALL TEPLOT (MVAL, MUMANT, PLTPTS(1+PPLTPT), IRET)
      IF (IRET.LT.0) IRET = 0
C                                       Close down
      CALL DIE (IRET, TEBUFF)
C
 999  STOP
      END
      SUBROUTINE TEPIN (PRGN, NROWS, IERR)
C-----------------------------------------------------------------------
C   Gets the inputs parameters for TEPLT.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IERR    I    Error code: 0 => ok
C      ISTOK   I    1 = R, 2 = L
C      ICODE   I   'TIME','HA','AZ','ZA','AZIO','ZAIO','DLON','DLAT',
C                   'BX','BY','BZ','STEC','MAG', TEC','IFR', 'DISP'
C                   'MULT', 'DIFF' are special
C-----------------------------------------------------------------------
      INTEGER   NROWS, IERR
      CHARACTER PRGN*6
C
      INCLUDE 'TEPLT.INC'
      CHARACTER STAT*4, CODE(NCODE)*4, TYPTMP*2
      INTEGER   IRET, BUFF(256), I, J, K, JERR, QUAL(30), NSOUR, LTYPE,
     *   BUFFER(512), IROUND, LUN, ICODE
      LOGICAL T, F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA CODE /'TIME', 'HA', 'AZ', 'ZA', 'AZIO', 'ZAIO', 'DLON',
     *  'DLAT', 'BX', 'BY', 'BZ', 'STEC', 'MAG', 'TEC', 'IFR', 'DISP'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      OSOU = -1
      NPARMS = 232
C                                        Get input parameters.
      CALL SETUP (PRGN, NPARMS, XNAMEI, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRET = 8
         RQUICK = .FALSE.
         GO TO 990
         END IF
C                                       Decode inputs.
C                                       characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      TYPE = 'TE'
      CALL H2CHR (4, 1, XOPTY, OPTYPE)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      ISYM = IROUND (XSYM)
      IF ((ISYM.LE.0) .OR. (ISYM.GT.24)) ISYM = 1
C
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
         QUAL(I) = IROUND (XQUAL)
 20      CONTINUE
      CALL FILL (MAXANT, 0, NUMPTS)
C                                       Integers
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      IVER = IROUND (XNVER)
      I2VER = IROUND (XNVER2)
      NCOUNT = IROUND (XNCOU)
      IF (NCOUNT.LE.0) NCOUNT = 5
      XNCOU = NCOUNT
      XINC = IROUND (XXINC)
      IF (XINC.LE.0) XINC = 1
      XXINC = XINC
      DOLINE = FACTOR.LT.0.0
      FACTOR = ABS (FACTOR)
      IF ((.NOT.DOLINE) .AND. (FACTOR.LT.0.1)) FACTOR = 1.0
      IF (FACTOR.GT.10.0) FACTOR = 1.0
C                                       plot types
      IF ((OPTYPE.EQ.'MULT') .OR. (OPTYPE.EQ.'DIFF')) THEN
         NCODES = 0
         DO 25 I = 1,10
            ICODE = IROUND (APARM(I))
            IF ((ICODE.LT.1) .OR. (ICODE.GT.NCODE)) GO TO 26
            NCODES = NCODES + 1
            ICODES(NCODES) = ICODE
            APARM(I) = ICODE
 25         CONTINUE
 26      IF (NCODES.LE.0) THEN
            MSGTXT = 'OPTYPE ''' // OPTYPE //
     *         ''' HAS NO VALID TYPE CODES'
            CALL MSGWRT (8)
            IERR = 10
            GO TO 999
            END IF
         IF (NCODES.EQ.1) THEN
            CALL CHR2H (4, CODE(ICODES(1)), 1, XOPTY)
            PIXR(1) = BPARM(1)
            PIXR(2) = CPARM(1)
            END IF
      ELSE
         ICODE = 15
         DO 30 I = 1,NCODE
            IF (OPTYPE.EQ.CODE(I)) ICODE = I
 30         CONTINUE
         CALL CHR2H (4, CODE(ICODE), 1, XOPTY)
         APARM(1) = ICODE
         NCODES = 1
         ICODES(1) = ICODE
         BPARM(1) = PIXR(1)
         CPARM(1) = PIXR(2)
         END IF
      CALL RFILL (10-NCODES, 0.0, APARM(NCODES+1))
      CALL RFILL (10-NCODES, 0.0, BPARM(NCODES+1))
      CALL RFILL (10-NCODES, 0.0, CPARM(NCODES+1))
C                                       x axis
      XVAR = 1
      DO 35 I = 1,NCODE
         IF (OPCODE.EQ.CODE(I)) XVAR = I
 35      CONTINUE
      IF (XVAR.GT.0) CALL CHR2H (4, CODE(XVAR), 1, XOPCOD)
      DO 40 I = 1,NCODES
         IF (APARM(I).EQ.16) THEN
            BPARM(I) = BPARM(I) * 1.E-9
            CPARM(I) = CPARM(I) * 1.E-9
            END IF
 40      CONTINUE
C                                       Time range
      TSTART = XTIME(1) + (XTIME(2) / 24.0) + (XTIME(3) / (24.0*60.0)) +
     *   (XTIME(4) / (24.0*3600.0))
      TSTOP = XTIME(5) + (XTIME(6) / 24.0) + (XTIME(7) / (24.0*60.0)) +
     *   (XTIME(8) / (24.0*3600.0))
      IF (TSTART.GE.TSTOP) THEN
         TSTART = 0.0
         TSTOP = 999.0
         END IF
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      GR2CHN = GRCHN / 10
      GRCHN = MOD (GRCHN, 10)
      IF (GR2CHN.EQ.0) GR2CHN = MAX (1, GRCHN)
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
      LABEL = IROUND (XLABEL)
      LTYPE = MOD (ABS(LABEL), 100)
      IF ((LTYPE.EQ.0) .OR. (LTYPE.GT.10)) LTYPE = 3
      IF (LTYPE.GT.7) LTYPE = 7
      IF ((LTYPE.GE.4) .AND. (LTYPE.LE.6)) LTYPE = 3
      IF (LABEL.LT.0) THEN
         LABEL = (LABEL/100)*100 - LTYPE
      ELSE
         LABEL = (LABEL/100)*100 + LTYPE
         END IF
C                                       Find input catalog
      CNOIN = 1
      TYPTMP = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, TYPTMP,
     *   NLUSER, STAT, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      'UV', NLUSER
         GO TO 990
         END IF
C                                       Save name class etc.
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
      XDISIN = DISKIN
      XSIN = SEQIN
C                                       Read catalog header
      STAT = 'WRIT'
      IF (DOTV) STAT = 'READ'
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, STAT, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FCNO(NCFILE) = CNOIN
      FVOL(NCFILE) = DISKIN
      FRW(NCFILE) = 1
      IF (DOTV) FRW(NCFILE) = 0
      XDISIN = DISKIN
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 990
      SEQIN = CATBLK(KIIMS)
      XSIN = SEQIN
      CALL FNDEXT ('TE', CATBLK, I)
      IF ((IVER.LT.1) .OR. (IVER.GT.I)) IVER = I
      IF (OPTYPE.EQ.'DIFF') THEN
         IF ((I2VER.LT.1) .OR. (I2VER.GT.I) .OR. (I2VER.EQ.IVER))
     *      I2VER = I - 1
      ELSE
         I2VER = 0
         END IF
C                                       Look up sources
      NID = 500
      NSOUR = 30
      MSGSUP = 32000
      CALL SOURNU (XSOUR, QUAL, NSOUR, DISKIN, CNOIN, NID, BUFFER, SID,
     *   JERR)
      MSGSUP = 0
      IF (JERR.LT.0) THEN
         MSGTXT = 'SPECIFIED SOURCE(S) NOT FOUND - CONTINUING'
         CALL MSGWRT (6)
         END IF
      IF (JERR.NE.0) NID = 0
C                                       Check antennas desired.
      NANTSL = 0
      DOAWNT = T
      DO 70 J = 1,50
         ANTS(J) = IROUND (XANT(J))
         IF (ANTS(J).LT.0) DOAWNT = F
C                                       Make positive
         ANTS(J) = ABS (ANTS(J))
         IF (NANTSL.LT.1) GO TO 60
            DO 50 K = 1,NANTSL
               IF (ANTS(J).EQ.ANTS(K)) ANTS(J) = 0
 50            CONTINUE
C                                       Check for multiple entries
 60      IF (ABS (ANTS(J)).GE.1) NANTSL = J
 70      CONTINUE
C                                       Make sure not too many
      IF (NANTSL.GT.MAXANT) NANTSL = MAXANT
C                                       Get antenna names
      CALL GETANT (DISKIN, CNOIN, MAX (1, SUBARR), CATBLK, BUFFER, JERR)
      MUMANT = NSTNS
      IF (MUMANT.LE.1) THEN
         MUMANT = MAXANT
         TIMLAB = 'IAT'
         END IF
      CALL JULDAY (RDATE, JD0)
C                                       Open table to check
      CALL TEPOPN (NROWS, IERR)
      IF (IERR.NE.0) GO TO 999
      XNVER = IVER
      XNVER2 = I2VER
      CSMAX = -100000
      CSMIN = 1000000
      CALL RFILL (MAXANT, 1.E5, XXMIN)
      CALL RFILL (MAXANT, -1.E5, XXMAX)
      I = MAXANT
      I = I * 10
      CALL RFILL (I, 1.E8, YYMIN)
      CALL RFILL (I, -1.E8, YYMAX)
      CALL RFILL (10, -1.E8, YYMX)
      CALL RFILL (10,  1.E8, YYMN)
      IF ((XVAR.EQ.1) .AND. (TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         CALL RFILL (MAXANT, TSTART, XXMIN)
         CALL RFILL (MAXANT, TSTOP, XXMAX)
         END IF
      IF ((XSCAN.GT.0.0) .AND. (XVAR.EQ.1)) THEN
         LUN = 25
         CALL GETNX (LUN, DISKIN, CNOIN, CATBLK, SUBARR, BUFFER, NOSCAN,
     *      TSCAN)
      ELSE
         NOSCAN = 0
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR;',I7,'GETTING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',I3,
     *   ' TYPE=',A2,' USER=',I4)
 1040 FORMAT ('ERROR',I3,' COPYING CATALOG HEADER')
      END
      SUBROUTINE TEPOPN (NROWS, IERR)
C-----------------------------------------------------------------------
C   Routine to open TE table
C   information
C   Input from Common:
C      TYPE     C*2  'TE'
C      DISKIN   I     Disk number
C      CNOIN    I     Catalog slot number
C      CATBLK   I(*)  Catalog header
C   Output:
C      IERR     I     Error code, 0=OK else failed.
C   Output in common:
C      ITERNO       I    Current TE record number
C      NTEINR       I    Number of gain records in file.
C      ITEVER       I    Version number opened.
C-----------------------------------------------------------------------
      INTEGER   NROWS, IERR
C
      INCLUDE 'TEPLT.INC'
      INCLUDE 'TEFILE.INC'
      INTEGER   LUN
      CHARACTER RDATE*8, TTYP*8, RD*8
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Open table
      LUN = 28
      CALL TEINI ('READ', TEBUFF, DISKIN, CNOIN, IVER, CATBLK, LUN,
     *   ITERNO, TEKOLS, TENUMV, RDATE, TECTYP, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING TE TABLE'
         GO TO 990
         END IF
      ITVER = IVER
C                                       Get number of scans
      NTEINR = TEBUFF(5)
      NROWS = NTEINR
C                                       Check if empty
      IF (NTEINR.LE.0) THEN
         IERR = 6
         MSGTXT = 'ERROR: SELECTED TABLE IS EMPTY'
         GO TO 990
         END IF
C                                       DIFF
      IF (I2VER.GT.0) THEN
         LUN = 39
         CALL TEINI ('READ', TEBUF2, DISKIN, CNOIN, I2VER, CATBLK, LUN,
     *      ITERNO, TEKOLS, TENUMV, RD, TTYP, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPENING 2ND TE TABLE'
            GO TO 990
         END IF
         IF (RD.NE.RDATE) THEN
            MSGTXT = 'DIFF DATES DO NOT MATCH'
            IERR = 10
            GO TO 990
            END IF
         IF (TEBUF2(5).NE.NROWS) THEN
            MSGTXT = 'DIFF: TE FILE SIZES NOT THE SAME'
            IERR = 10
            GO TO 990
            END IF
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR ',I3,' ON ',A)
      END
      LOGICAL FUNCTION ISTYPE (FTYPE)
C-----------------------------------------------------------------------
C   ISTYPE inquires if type in list of requested types
C   Inputs:
C      FTYPE    I   Test type
C   Output:
C      ISTYPE   L   T => TYPE in ICODES
C-----------------------------------------------------------------------
      INTEGER   FTYPE
C
      INTEGER   I
      INCLUDE 'TEPLT.INC'
C-----------------------------------------------------------------------
      ISTYPE = .FALSE.
      DO 10 I = 1,NCODES
         IF (ICODES(I).EQ.FTYPE) ISTYPE = .TRUE.
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE TEPCNT (NWORDS, IERR)
C-----------------------------------------------------------------------
C   TEPCNT reads the TE table to find the number of samples for each ant
C   Input:
C      NWORDS   I      Size of work array
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NWORDS, IERR
C
      INCLUDE 'TEPLT.INC'
      INCLUDE 'TEFILE.INC'
      LOGICAL   NODATA, OKAY
      INTEGER   I, NP, SCNT(MXSCAN), IRNO
      REAL      TB, TE, GTIME, XVARIB, CSOU
      REAL      VALUE(2*MAXIF,10)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      CALL FILL (MAXANT, 0, NANREC)
      CALL FILL (MXSCAN, 0, SCNT)
      NODATA = .TRUE.
      TB = 1.0E5
      TE = -1.0E5
      IF ((XVAR.EQ.1) .AND. (TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TB = TSTART
         TE = TSTOP
         END IF
      XMX = TE
      XMN = TB
      XMXW = TE
      XMNW = TB
C                                       Loop thru data
      DO 100 IRNO = 1,NTEINR,XINC
         ITERNO = IRNO
         CALL TABTE ('READ', TEBUFF, ITERNO, TEKOLS, TENUMV, TETIME,
     *      TESOUR, TEANTE, TEHA, TEAZ, TEEL, TEAZIO, TEZAIO, TEDLON,
     *      TEDLAT, TEB, TEPATH, TEMAG, TETEC, TEIFR, TEDISP, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READING THE TE TABLE'
            GO TO 990
            END IF
C                                       time range ?
         GTIME = TETIME
         IF ((GTIME.LT.TSTART) .OR. (GTIME.GT.TSTOP)) GO TO 100
C                                       Antenna?
         IANT = TEANTE
         IF (NANTSL.GT.0) THEN
            DO 50 I = 1,NANTSL
               IF ((IANT.EQ.ANTS(I)).AND.DOAWNT) GO TO 60
               IF ((IANT.EQ.ANTS(I)).AND.(.NOT.DOAWNT)) GO TO 100
 50            CONTINUE
            IF (DOAWNT) GO TO 100
            END IF
C                                       Check source
 60      IF (NID.GT.0) THEN
            ISOU = TESOUR
            DO 70 I = 1,NID
               IF (ISOU.EQ.SID(I)) GO TO 80
 70            CONTINUE
            GO TO 100
            END IF
C                                      Get start, stop times
 80      TB = MIN (TB, GTIME)
         TE = MAX (TE, GTIME)
C                                       Get value
         CALL TEPDAT (VALUE, XVARIB, CSOU, OKAY)
C                                       Max. - Min
         IF ((OKAY) .AND. (XVARIB.NE.FBLANK)) THEN
            IF (OKAY) NODATA = .FALSE.
            NANREC(IANT) = NANREC(IANT) + 1
            I = CSOU + 0.1
            IF ((I.GT.0) .AND. (I.LE.MXSCAN)) SCNT(I) = SCNT(I) + 1
            END IF
 100     CONTINUE
      IERR = MAX (0, IERR)
      FANREC(1) = 1
      DO 120 I = 2,MAXANT
         FANREC(I) = FANREC(I-1) + NANREC(I-1)
 120     CONTINUE
      IF (NWORDS.LT.FANREC(MAXANT)+NANREC(MAXANT)) THEN
         MSGTXT = 'MEMORY TOO SMALL'
         IERR = 10
         END IF
C                                       source number translation
      NP = 0
      CALL FILL (MXSCAN, 0, STRANS)
      DO 130 I = 1,MXSCAN
         IF (SCNT(I).GT.0) THEN
            NP = NP + 1
            STRANS(I) = NP
            END IF
 130     CONTINUE
C
 990  IF (IERR.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TEPCNT: ERROR',I4,' ON ',A)
      END
      SUBROUTINE TEPMAX (NV, PLTPTS, IERR)
C-----------------------------------------------------------------------
C   TEPMAX reads the TE table to find the max and min values for
C   each station prior to plotting.
C   Input:
C      NV       I      Number values per time (source, T, X, n*Y)
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      PLTPTS   R(*)   Data to be plotted (NV, *)
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NV, IERR
      REAL      PLTPTS(NV,*)
C
      LOGICAL   NODATA, OKAY
      INTEGER   I, NN, IS, KK, IRNO, T2SOUR, T2ANTE
      REAL      TB, TE, TMAX, TMIN, GTIME, XVARIB, CSOU, TEMP
      INCLUDE 'TEPLT.INC'
      INCLUDE 'TEFILE.INC'
      REAL      VALUE(10), T2VALS(17)
      DOUBLE PRECISION T2TIME
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      NODATA = .TRUE.
      TB = 1.0E5
      TE = -1.0E5
      IF ((XVAR.EQ.1) .AND. (TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TB = TSTART
         TE = TSTOP
         END IF
      XMX = TE
      XMN = TB
      XMXW = TE
      XMNW = TB
C                                       Loop thru data
      DO 100 IRNO = 1,NTEINR,XINC
C                                       DIFF
         IF (I2VER.GT.0) THEN
            ITERNO = IRNO
            CALL TABTE ('READ', TEBUF2, ITERNO, TEKOLS, TENUMV, TETIME,
     *         TESOUR, TEANTE, TEHA, TEAZ, TEEL, TEAZIO, TEZAIO, TEDLON,
     *         TEDLAT, TEB, TEPATH, TEMAG, TETEC, TEIFR, TEDISP, IERR)
            IF (IERR.LT.0) GO TO 100
            IF (IERR.GT.0) THEN
               WRITE (MSGTXT,1000) IERR, 'READING THE 2ND TE TABLE'
               GO TO 990
               END IF
            CALL RCOPY (17, TEVALS, T2VALS)
            T2TIME = TETIME
            T2SOUR = TESOUR
            T2ANTE = TEANTE
            END IF
         ITERNO = IRNO
         CALL TABTE ('READ', TEBUFF, ITERNO, TEKOLS, TENUMV, TETIME,
     *      TESOUR, TEANTE, TEHA, TEAZ, TEEL, TEAZIO, TEZAIO, TEDLON,
     *      TEDLAT, TEB, TEPATH, TEMAG, TETEC, TEIFR, TEDISP, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READING THE TE TABLE'
            GO TO 990
            END IF
C                                       Record within specified
C                                       time range ?
         GTIME = TETIME
         IF ((GTIME.LT.TSTART) .OR. (GTIME.GT.TSTOP)) GO TO 100
C                                       Antenna?
         IANT = TEANTE
         IF (NANTSL.GT.0) THEN
            DO 50 I = 1,NANTSL
               IF ((IANT.EQ.ANTS(I)).AND.DOAWNT) GO TO 60
               IF ((IANT.EQ.ANTS(I)).AND.(.NOT.DOAWNT)) GO TO 100
 50            CONTINUE
            IF (DOAWNT) GO TO 100
            END IF
C                                       Check source
 60      IF (NID.GT.0) THEN
            ISOU = TESOUR
            DO 70 I = 1,NID
               IF (ISOU.EQ.SID(I)) GO TO 80
 70            CONTINUE
            GO TO 100
            END IF
C                                      Get start, stop times
 80      TB = MIN (TB, GTIME)
         TE = MAX (TE, GTIME)
C                                       DIFF
         IF (I2VER.GT.0) THEN
            IF ((T2SOUR.NE.TESOUR) .OR. (T2ANTE.NE.TEANTE) .OR.
     *         (ABS(T2TIME-TETIME).GT.1.E-7)) THEN
               MSGTXT = 'TEPMAX: TWO TE FILES DO NOT MATCH'
               IERR = 11
               GO TO 990
               END IF
            DO 85 I = 2,17
               IF ((T2VALS(I).EQ.FBLANK) .OR. (TEVALS(I).EQ.FBLANK))
     *            THEN
                  TEVALS(I) = FBLANK
               ELSE
                  TEVALS(I) = TEVALS(I) - T2VALS(I)
                  END IF
 85            CONTINUE
            END IF
C                                       Get value
         CALL TEPDAT (VALUE, XVARIB, CSOU, OKAY)
C                                       Max. - Min
         IF ((OKAY) .AND. (XVARIB.NE.FBLANK)) THEN
            IF (OKAY) NODATA = .FALSE.
C                                       Put in array
            NUMPTS(IANT) = NUMPTS(IANT) + 1
            NN = FANREC(IANT) + NUMPTS(IANT) - 1
            IS = CSOU + 0.1
            IF ((IS.GT.0) .AND. (IS.LE.MXSCAN)) CSOU = STRANS(IS)
            PLTPTS(1,NN) = CSOU
            PLTPTS(2,NN) = GTIME
            PLTPTS(3,NN) = XVARIB
            KK = 4
            DO 81 I = 1,NCODES
               PLTPTS(KK,NN) = VALUE(I)
               KK = KK + 1
 81            CONTINUE
            IF ((XVAR.EQ.1) .OR. (XVAR.GT.8)) THEN
               XMX = MAX (XMX, XVARIB)
               XMN = MIN (XMN, XVARIB)
            ELSE
               TEMP = XVARIB
               IF (TEMP.LT.0.0) TEMP = TEMP + 360.
               XMX = MAX (XMX, TEMP)
               XMN = MIN (XMN, TEMP)
               IF (TEMP.GT.180.0) TEMP = TEMP - 360
               XMXW = MAX (XMXW, TEMP)
               XMNW = MIN (XMNW, TEMP)
               END IF
            XXMAX(IANT) = MAX (XXMAX(IANT), XVARIB)
            XXMIN(IANT) = MIN (XXMIN(IANT), XVARIB)
            CSMIN = MIN (CSMIN, CSOU)
            CSMAX = MAX (CSMAX, CSOU)
C                                       If not a summary plot
            DO 95 KK = 1,NCODES
               IF (VALUE(KK).NE.FBLANK) THEN
                  YYMX(KK) = MAX (YYMX(KK), VALUE(KK))
                  YYMN(KK) = MIN (YYMN(KK), VALUE(KK))
                  IF ((ICODES(KK).GT.1) .AND. (ICODES(KK).LE.8)) THEN
                     IF (VALUE(KK).LE.-180.0) THEN
                        VALUE(KK) = VALUE(KK) + 360.
                     ELSE IF (VALUE(KK).GT.180.) THEN
                        VALUE(KK) = VALUE(KK) - 360.
                        END IF
                     YYMIN(IANT,KK) = MIN (VALUE(KK),
     *                  YYMIN(IANT,KK))
                     YYMAX(IANT,KK) = MAX (VALUE(KK),
     *                  YYMAX(IANT,KK))
                     IF (VALUE(KK).LT.0.0) VALUE(KK) =
     *                  VALUE(KK) + 360.0
                  ELSE
                     YYMIN(IANT,KK) = MIN (VALUE(KK),
     *                  YYMIN(IANT,KK))
                     YYMAX(IANT,KK) = MAX (VALUE(KK),
     *                  YYMAX(IANT,KK))
                     END IF
                  END IF
 95            CONTINUE
            END IF
 100     CONTINUE
      IERR = MAX (0, IERR)
C                                       reset max min on fixed scale
      DO 125 KK = 1,NCODES
         IF (BPARM(KK).LT.CPARM(KK)) THEN
            YYMX(KK) = CPARM(KK)
            YYMN(KK) = BPARM(KK)
            DO 120 IANT = 1,MUMANT
               IF (YYMAX(IANT,KK).GE.
     *            YYMIN(IANT,KK)) THEN
                  YYMAX(IANT,KK) = CPARM(KK)
                  YYMIN(IANT,KK) = BPARM(KK)
                  END IF
 120           CONTINUE
            END IF
 125     CONTINUE
C                                       Set actual X range
      SWAP = .FALSE.
      IF (XVAR.EQ.1) THEN
         XSTART = TB
         XSTOP = TE
      ELSE IF ((XVAR.GE.2) .AND. (XVAR.LE.8)) THEN
         IF (XMX-XMN.LE.XMXW-XMNW) THEN
            XSTART = XMN
            XSTOP  = XMX
         ELSE
            XSTART = XMNW
            XSTOP  = XMXW
            SWAP = .TRUE.
            END IF
      ELSE
         XSTART = XMN
         XSTOP  = XMX
         END IF
C                                       Check for no data
      IF (NODATA) THEN
         IERR = 6
         MSGTXT = 'NO DATA SELECTED'
         GO TO 990
         END IF
C                                       check and set scaling
      IF ((XVAR.EQ.1) .AND. (TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TMAX = (XSTOP + 0.03 * (XSTOP - XSTART)) * 360.0
         TMIN = (XSTART- 0.03 * (XSTOP - XSTART)) * 360.0
      ELSE IF (XVAR.EQ.1) THEN
         TMAX = (XSTOP + 0.1 * (XSTOP - XSTART)) * 360.0
         TMIN = (XSTART- 0.1 * (XSTOP - XSTART)) * 360.0
      ELSE
         TMAX = (XSTOP + 0.1 * (XSTOP - XSTART))
         TMIN = (XSTART- 0.1 * (XSTOP - XSTART))
         END IF
C                                       If start time is stop time,
      IF (ABS (TMAX-TMIN) .LT. 0.01) THEN
         TMIN = MAX( TMIN-0.005, 0.0)
         TMAX = TMIN + 0.01
         END IF
      TSTART = TB
      TSTOP = TE
      XYOFF(1) = TMIN
      XYSCL(1) = 1000.0 / (TMAX - TMIN)
      PRAN(1,1) = TMIN
      PRAN(2,1) = TMAX
C                                       Send back time range
      XTIME(1) = TSTART
      XTIME(2) = 0.0
      XTIME(3) = 0.0
      XTIME(4) = 0.0
      XTIME(5) = TSTOP
      XTIME(6) = 0.0
      XTIME(7) = 0.0
      XTIME(8) = 0.0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TEPMAX: ERROR',I4,' ON ',A)
      END
      SUBROUTINE GETSCL (KK, LANT, DOIT)
C-----------------------------------------------------------------------
C   GETSCL converts a number of max/min's to a scale
C   Inputs:
C      KK      I   parameter number
C      LANT    I   Antenna number
C   Output:
C      DOIT    L      There were valid values
C   Output in common
C      XYSCL   R(2)   Scaling - only 2nd one changed
C      XYOFF   R(2)   Offset  - only second one changed
C-----------------------------------------------------------------------
      INTEGER   KK, LANT
      LOGICAL   DOIT
C
      INCLUDE 'TEPLT.INC'
      REAL      YMX, YMN, PMX, PMN, TMAX, TMIN, TDIF, TOLER(NCODE),
     *   SIZEY, FACT
C                                       Minimum value range for each
C                                       ICODE
c                 time   angles,  B field    tec  B      tec  ifr
      DATA TOLER /0.001, 7 * 1.0, 3 * 0.001, 0.1, 0.001, 0.1, 0.005,
c        disp
     *   1.E-9/
C-----------------------------------------------------------------------
      DOIT = .FALSE.
      FACT = 1.0
      IF (I2VER.GT.0) FACT = 100.0
      YMX = -1.E8
      YMN = -YMX
      PMX = YMX
      PMN = YMN
      IF (YYMAX(LANT,KK).GE.YYMIN(LANT,KK)) THEN
         DOIT = .TRUE.
         YMX = MAX (YMX, YYMAX(LANT,KK))
         YMN = MIN (YMN, YYMIN(LANT,KK))
         END IF
      SIZEY = 1000.0 / NCOUNT
      TMAX = YMX + 0.1 * (YMX - YMN)
      TMIN = YMN - 0.1 * (YMX - YMN)
      IF (ABS (TMAX-TMIN) .LT. TOLER(ICODES(KK))/FACT) THEN
         TMAX = TMAX + TOLER(ICODES(KK))/FACT
         TMIN = TMIN - TOLER(ICODES(KK))/FACT
         END IF
      TDIF = TMAX - TMIN
      IF (ABS (TDIF).LE.1.0E-25) TDIF = 1.0E-25
      XYOFF(2) = TMIN
      XYSCL(2) = 1000.0 / TDIF / NCOUNT
      PRAN(1,2) = TMIN
      PRAN(2,2) = TMAX
C
 999  RETURN
      END
      SUBROUTINE TEPDAT (VALUE, XVARIB, CSOU, OKAY)
C-----------------------------------------------------------------------
C   Routine to get the specified value from a TE table entry
C   Input from common:
C      ICODE    I     Plot code
C   Also uses pointers etc. set in TEPOPN
C   Output:
C      VALUE    R(*)   Table value, magic value blanked (amp on ICODE 6)
C      XVARIB   R      Value of associated x-axis variable
C      CSOU     R      source number
C      OKAY     L      Some values are good
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      REAL      VALUE(*), XVARIB, CSOU
      LOGICAL   OKAY
C
      INTEGER   KK, ICODE
      LOGICAL   T
      INCLUDE 'TEPLT.INC'
      INCLUDE 'TEFILE.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       In case the data is bad
      OKAY = .FALSE.
      CSOU = TESOUR
      IF (XVAR.EQ.1) THEN
         XVARIB = TETIME
      ELSE
         XVARIB = TEVALS(XVAR)
C         IF (XVAR.EQ.16) XVARIB = XVARIB * 1.0E9
         END IF
      DO 20 KK = 1,NCODES
         ICODE = ICODES(KK)
         IF (ICODE.EQ.1) THEN
            VALUE(KK) = TETIME
         ELSE
            VALUE(KK) = TEVALS(ICODE)
c            IF (ICODE.EQ.16) VALUE(KK) = VALUE(KK) * 1.E9
            END IF
         IF (VALUE(KK).NE.FBLANK) OKAY = .TRUE.
 20      CONTINUE
      IF (XVARIB.EQ.FBLANK) OKAY = .FALSE.
C
 999  RETURN
      END
      SUBROUTINE TEPLOT (NV, NA, PLTPTS, IRET)
C-----------------------------------------------------------------------
C   TEPLOT plots the data thru calls to PLTTE.
C   Input:
C      NV       I      Number values per antenna (source, T, X, Y data)
C      NA       I      Number antennas in data array
C      PLTPTS   R(*)   Data (NV,*)
C   Output:
C      IRET     I      Return code, 0=OK else failed
C-----------------------------------------------------------------------
      INTEGER   NV, NA, IRET
      REAL      PLTPTS(NV,*)
C
      INTEGER   IPLOT, JPLT, IPLT, NPLT, KK
      LOGICAL   DOIT
      INCLUDE 'TEPLT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IPLOT = 0
C                                       count the plots
      NPLOTS = 0
      DO 40 IPLT = 1,MUMANT
         DO 25 KK = 1,NCODES
            CALL GETSCL (KK, IPLT, DOIT)
            IF (DOIT) NPLOTS = NPLOTS + 1
 25         CONTINUE
 40      CONTINUE
C                                       Now plot
      NPLT = 0
      DO 100 IPLT = 1,MUMANT
         DO 70 KK = 1,NCODES
            CALL GETSCL (KK, IPLT, DOIT)
            IF (DOIT) THEN
               NPLT = NPLT + 1
               JPLT = NPLT
               IPLOT = MOD (NPLT-1, NCOUNT) + 1
               IF (NPLT.EQ.NPLOTS) IPLOT = -IPLOT
               CALL PLTTE (IPLOT, KK, IPLT, NV, PLTPTS, IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
 70         CONTINUE
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE PLTTE (IPLOT, KK, ANTNO, NV, PLTPTS, IRET)
C-----------------------------------------------------------------------
C   PLTTE actually plots data.
C   Input:
C      IPLOT    I      Plot number on current page. If neg. then this is
C                      last plot.
C      KK       I      Parameter number
C      ANTNO    I      Antenna number
C      NV       I      Number values
C      PLTPTS   R(*)   Data to plot (NV,*)
C   Output:
C      IRET     I      Return code, 0 => OK, otherwise abort.
C                       -1 => user request termination
C                        1 => failed to add to catalog
C                        2 => failed to create
C                        3 => graph file write error
C                        4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   IPLOT, KK, ANTNO, NV, IRET
      REAL      PLTPTS(NV,*)
C
      INCLUDE 'TEPLT.INC'
C
      CHARACTER TEXT*132, PFILE*48, ATIME*8, ADATE*12, CHTMP*18,
     *   AUNITS(NCODE)*8, CHTYPE(NCODE)*16, TXTMSG*80, CSAVE*5
      INTEGER   BUFFER(256), VER, IERR, ITYPE, IPSIZE, LUNPL, LTYPE,
     *   FINDPL, DEPTH(5), INCHAR, INP, IT(3), ID(3), IAXLAB, IAPLOT,
     *   I, NGOOD, NNOFIT, JCODE, NN, IP, ILITY, NNN, JTRIM
      REAL      BLC(2), TRC(2), DX, DY, TR, VALUE, TI, XY(2),
     *   XTRC(2), XBLC(2), TLC(2), PLTINC, YYOFF(2), SIZE, XMULT(2),
     *   DBY, COLV, COL(3), AX(5), AY(5), OLDSRC
      LOGICAL   T, F, GOOD, CATUP, DONEG, BLNKD, SCOLOR, DOCOLR
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      SAVE XMULT, CSAVE, LTYPE, BUFFER
      DATA LUNPL /26/
      DATA DEPTH /5*1/
      DATA T, F /.TRUE.,.FALSE./
      DATA AUNITS /'Days', 7*'Degrees', 3*'Gauss', '^16 /m/m',
     *   'Gauss', '^16 /m/m', 'Rad/m/m', 'Sec/m/m'/

      DATA CHTYPE /'Time', 'Hour angle', 'Azimuth', 'Zenith angle',
     *   'Ion azimuth', 'Ion zenith angle', 'Delta longitude',
     *   'Delta latitude', 'B radial', 'B east', 'B north',
     *   'Source TEC', 'Projected B', 'Vertical TEC', 'IFR',
     *   'Disp delay'/
C-----------------------------------------------------------------------
C                                       Time system from AN table
      SCOLOR = (XDO3C.GT.0.0) .AND. (CSMAX-CSMIN.GT.0.99)
      DOCOLR = SCOLOR
      OLDSRC = -1000.0
      NGOOD = 0
      NNOFIT = 0
      IRET = 3
      CATUP = T
C
      JCODE = ICODES(KK)
C                                       Create plot file
      IF (ABS (IPLOT).EQ.1) THEN
C                                       Update catalog header.
         VER = 0
         IRET = 1
         IF (.NOT.DOTV) THEN
            CALL MADDEX ('PL', DISKIN, CNOIN, CATBLK, BUFFER, CATUP,
     *         'WRIT', VER, IERR)
            IF (IERR.NE.0) THEN
               NCFILE = NCFILE - 1
               GO TO 999
               END IF
            END IF
         CALL ZPHFIL ('PL', DISKIN, CNOIN, VER, PFILE, IERR)
         IF (IERR.NE.0) GO TO 960
         IPSIZE = 0
         ITYPE = 77
         CALL GINIT (DISKIN, CNOIN, PFILE, IPSIZE, ITYPE, NPARMS,
     *      XNAMEI, DOTV, TVCHN, GRCHN, TVCORN, CATBLK, BUFFER, LUNPL,
     *      FINDPL, IERR)
         IRET = 2
         IF (IERR.NE.0) GO TO 960
         IF (GR2CHN.GT.0) GPHTVG(1) = GR2CHN + NGRAY
         END IF
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      IF (DOTV) THEN
         TRC(1) = WINDTV(3) - WINDTV(1)
         TRC(2) = WINDTV(4) - WINDTV(2)
         END IF
      PLTINC = TRC(2) / NCOUNT
      IF (XYRATO.LT.0.01) XYRATO = 1.0
C                                       Set window for current plot.
      XBLC(1) = BLC(1)
      XBLC(2) = TRC(2) - ABS (IPLOT) * PLTINC
      XTRC(1) = TRC(1)
      XTRC(2) = XBLC(2) + PLTINC - 1.0
      TLC(1) = XBLC(1)
      TLC(2) = XTRC(2)
C                                       Offsets for current plot.
      YYOFF(1) = XBLC(1)
      YYOFF(2) = XBLC(2)
C                                       fool with location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 7
      IF (XVAR.EQ.2) LABTYP(LOCNUM) = 8
      IF (XVAR.GT.2) LABTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      TR = 1.1 * (PRAN(2,2)-PRAN(1,2))
      IF (TR.LE.0.0) TR = 1.0
      IF ((ABS(IPLOT).EQ.1) .OR. (NCODES.GT.1)) THEN
         TI = TR
         CALL METSCL (LABEL, TR, CPREF(2,LOCNUM), GOOD)
         XMULT(2) = TR / TI
         CSAVE = CPREF(2,LOCNUM)
         END IF
      CPREF(1,LOCNUM) = ' '
      XMULT(1) = 1.0
      DO 50 I = 1,2
         SIZE = XTRC(I) - XBLC(I) + 1
         TR = PRAN(2,I) - PRAN(1,I)
         XYSCL(I) = (XTRC(I) - XBLC(I)) / TR
         RPLOC(I,LOCNUM) = XBLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I) * XMULT(I)
         AXINC(I,LOCNUM) = TR * XMULT(I) / (XTRC(I) - XBLC(I))
 50      CONTINUE
      CTYP(1,LOCNUM) = AUNITS(XVAR)
      CTYP(2,LOCNUM) = AUNITS(JCODE)
C                                       Init plot calls again
C                                       Number of characters on each
C                                       side of the plot
      IF (ABS (IPLOT).EQ.1) THEN
         CALL RFILL (4, 0.5, CHOUT)
C                                       Not fully initialized, may make
C                                       INP too large which is okay.
         CALL CHNTIC (XBLC, XTRC, INP)
         INP = MAX (INP, 3)
         IF (NCODES.GT.1) INP = MAX (INP, 7)
         LTYPE = MOD (ABS (LABEL), 100)
         IF (LTYPE.EQ.2) CHOUT(1) = 2.5
         IF (LTYPE.GT.2) CHOUT(1) = INP + 4
         IF (LTYPE.GT.1) CHOUT(2) = 2.0
         IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
         IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = 3.333
         IF ((LABEL.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7))
     *      CHOUT(4) = CHOUT(4) + 1.333
C                                       Init for line drawing.
         CALL GINITL (BLC, TRC, XYRATO, CHOUT, DEPTH, BUFFER, IERR)
         IRET = 3
         IF (IERR.NE.0) GO TO 970
         IF (.NOT.DOTV) THEN
            WRITE (MSGTXT,1000) VER
            CALL MSGWRT (2)
            END IF
         END IF
      IRET = 3
      CATUP = T
C                                       Draw border
      CALL GLTYPE (1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Top labels: type & name
      IF ((ABS(IPLOT).EQ.1) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DX = 0.0
         DY = 1.833
C                                       The second line of the header
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         INCHAR = 16
         INP = 1
         TEXT = CHTYPE(JCODE)
         IF (NCODES.GT.1) TEXT = 'Multiple'
         CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
         INP = INP + 1
         IF (XVAR.EQ.1) THEN
            TEXT(INP:INP+16) = ' vs '// TIMLAB(1:3) // ' time for '
            INP = INP + 17
         ELSE
            TEXT(INP:) = ' vs ' // CHTYPE(XVAR)
            INP = JTRIM (TEXT)
            TEXT(INP+1:) = ' for'
            INP = INP + 6
            END IF
C                                       File name
         CALL H2CHR (18, KHIMNO, CATH(KHIMN), CHTMP)
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), CHTMP(13:18))
         CALL NAMEST (CHTMP, CATBLK(KIIMS), TEXT(INP:), INCHAR)
         CALL REFRMT (TEXT, ' ', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       the third line of header
         DY = 0.5
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         INP = 1
C
         WRITE (TEXT(INP:),1010) TYPE, ITVER, TECTYP
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Date/time/version
         IF ((LABEL.GT.0) .AND. (LTYPE.GT.1)) THEN
            DY = 0.5 + 2 * 1.333
C                                       the first line of the header
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (TEXT,1030) VER, ADATE, ATIME
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
         END IF
C                                       station ID
      CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      DX =  1.5
      DY = -1.8
      WRITE (TEXT,1040) ANTNO
      INP = 4
      TEXT(INP+1:) = STNNAM(ANTNO)
      CALL CHTRIM (TEXT, 132, TEXT, INCHAR)
      CALL REFRMT (TEXT, '_', INCHAR)
      CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       type of plot
      IF (NCODES.GT.1) THEN
         TEXT = CHTYPE(JCODE)
         CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
         CALL GPOS (XTRC(1), XTRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         DX = -INP - 3.0
         DY = -2.8
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Set up location common
C                                       Blank bottom label.
      IF ((IPLOT.GE.0) .AND. (ABS (IPLOT).NE.NCOUNT)) THEN
         CPREF(1,LOCNUM) = ' '
         CTYP(1,LOCNUM) = ' '
         END IF
C                                       Only label Y axis once.
      IAXLAB = NCOUNT / 2 + 1
      IAPLOT = ABS (IPLOT)
      IF (NCODES.LE.1) THEN
         CPREF(2,LOCNUM) = CSAVE
         IF ((IAPLOT.NE.IAXLAB) .AND. ((IPLOT.GE.0) .OR.
     *      (IAPLOT.GT.IAXLAB))) CPREF(2,LOCNUM) = '-1'
         END IF
C                                       Put on labels and ticks
      CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XYRATO, F, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Size of symbol.
      DBY = 0.5 * FACTOR
C                                       Loop
      ILITY = 4
      CALL GLTYPE (ILITY, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Outer loop: IF, stokes
      IP = 3 + KK
C                                       Point plot
      DO 120 NN = 1,NUMPTS(ANTNO)
         DONEG = (JCODE.GT.1) .AND. (JCODE.LT.9)
C                                       Scale X
         NNN = NN - 1 + FANREC(ANTNO)
         XY(1) = PLTPTS(3,NNN)
         IF ((SWAP) .AND. (XY(1).GT.180.0)) XY(1) = XY(1) - 360.0
         IF (XVAR.EQ.1) XY(1) = XY(1) * 360.0
         XY(1) = XYSCL(1) * (XY(1) - XYOFF(1)) + YYOFF(1)
         IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1))) THEN
            NNOFIT = NNOFIT + 1
            GO TO 120
            END IF
C                                       source color
         IF ((SCOLOR) .AND. (ABS(PLTPTS(1,NNN)-OLDSRC).GT.0.1)) THEN
            COLV = 0.97 * (PLTPTS(1,NNN)-CSMIN) / (CSMAX-CSMIN)
            CALL COLOR3 (COLV, .FALSE., COL)
            CALL G3VCOL (COL(1), COL(2), COL(3), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            OLDSRC = PLTPTS(1,NNN)
            END IF
C                                       loop for points
         VALUE = PLTPTS(IP,NNN)
C                                       ?????????????????
         IF (VALUE.NE.FBLANK) THEN
 110        XY(2) = VALUE
            XY(2) = XYSCL(2) * (XY(2) - XYOFF(2)) + YYOFF(2)
            IF ((XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2))) THEN
               IF (DONEG) THEN
                  IF (VALUE.LT.0.) THEN
                     VALUE = VALUE + 360.
                  ELSE
                     VALUE = VALUE - 360.
                     END IF
                  DONEG = .FALSE.
                  GO TO 110
               ELSE
                  NNOFIT = NNOFIT + 1
                  END IF
            ELSE
               NGOOD = NGOOD + 1
C                                       Mark point
               DY = 5.0 * FACTOR
               DX = 5.0 * FACTOR
               IF (XYRATO.GT.1.0) THEN
                  DY = DY * XYRATO
               ELSE
                  DX = DX / XYRATO
                  END IF
               AX(1) = XY(1)
               AY(1) = XY(2)
               AX(2) = AX(1)
               AX(3) = AX(1)
               AX(4) = AX(1) - DX
               AX(5) = AX(1) + DX
               AY(2) = AY(1) + DY
               AY(3) = AY(1) - DY
               AY(4) = AY(1)
               AY(5) = AY(1)
               CALL PNTPLT (ISYM, AX, AY, XBLC, XTRC, .FALSE.,
     *            DOCOLR, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               END IF
            END IF
 120     CONTINUE
C                                       Line plot
      IF (DOLINE) THEN
         BLNKD = .TRUE.
         DO 140 NN = 1,NUMPTS(ANTNO)
            DONEG = (JCODE.EQ.1) .OR. (JCODE.EQ.NCODE+1)
C                                       Scale X
            NNN = NN - 1 + FANREC(ANTNO)
            XY(1) = PLTPTS(3,NNN)
            IF (XVAR.EQ.1) XY(1) = XY(1) * 360.0
            XY(1) = XYSCL(1) * (XY(1) - XYOFF(1)) + YYOFF(1)
            IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1))) GO TO 140
C                                       loop for points
            VALUE = PLTPTS(IP,NNN)
            IF (VALUE.EQ.FBLANK) THEN
               BLNKD = .TRUE.
            ELSE
 130           XY(2) = VALUE
               XY(2) = XYSCL(2) * (XY(2) - XYOFF(2)) + YYOFF(2)
               IF ((XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2))) THEN
                  IF (DONEG) THEN
                     IF (VALUE.LT.0.) THEN
                        VALUE = VALUE + 360.
                     ELSE
                        VALUE = VALUE - 360.
                        END IF
                     DONEG = .FALSE.
                     GO TO 130
                     END IF
               ELSE
                  NGOOD = NGOOD + 1
C                                       Mark point
                  IF (BLNKD) THEN
                     CALL GPOS (XY(1), XY(2), BUFFER, IERR)
                     BLNKD = .FALSE.
                  ELSE IF (DOCOLR) THEN
                     CALL G3VEC (XY(1), XY(2), BUFFER, IERR)
                  ELSE
                     CALL GVEC (XY(1), XY(2), BUFFER, IERR)
                     END IF
                  IF (IERR.NE.0) GO TO 970
                  END IF
               END IF
 140        CONTINUE
         END IF
C                                       plot scan boundaries
      IF ((XSCAN.GT.0.0) .AND. (NOSCAN.GT.0)) THEN
         WRITE (TXTMSG,1150) NOSCAN
         CALL GCOMNT (-1, TXTMSG, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         I = 3
         CALL GLTYPE (I, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         AY(1) = XYSCL(2) * (PRAN(1,2)-XYOFF(2)) + YYOFF(2)
         AY(2) = XYSCL(2) * (PRAN(2,2)-XYOFF(2)) + YYOFF(2)
         IF (XSCAN.GE.1.5) AY(2) = AY(1) + 0.1*(AY(2)-AY(1))
         DO 160 I = 1,NOSCAN
            AX(1) = XYSCL(1) * (TSCAN(I)*360.-XYOFF(1)) + YYOFF(1)
            IF ((AX(1).GE.XBLC(1)) .AND. (AX(1).LE.XTRC(1))) THEN
               CALL GPOS (AX(1), AY(1), BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               CALL GVEC (AX(1), AY(2), BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               END IF
 160        CONTINUE
         END IF
C                                       Done: finish plot
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      IF ((IPLOT.GT.0) .AND. (ABS(IPLOT).LT.NCOUNT)) GO TO 210
         GPHPAG = IPLOT.GT.0
         CALL GFINIS (BUFFER, IERR)
         IF (IERR.GT.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
            IERR = 0
            END IF
 210  IF (IERR.GT.0) GO TO 975
         IRET = MIN (IERR, 0)
         GO TO 999
C                                       ZPHFIL or GINIT failure.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      IF (.NOT.DOTV) THEN
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
      GO TO 999
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      GPHPAG = IPLOT.GT.0
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.NE.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
            IERR = 0
            END IF
         GO TO 999
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Plot file version',I4,'  created.')
 1010 FORMAT (A2,' version',I4,'__ TECRtype ',A)
 1030 FORMAT ('Plot file version',I4,'__created ',A, A)
 1040 FORMAT (I3)
 1150 FORMAT ('Plotting',I4,' scan breaks')
 1200 FORMAT ('PLTTE:',I9,' points plotted')
 1202 FORMAT ('PLTTE:',I9,' points did not fit')
 1960 FORMAT ('PLTTE: ERROR DURING GRAPH FILE CREATION')
 1970 FORMAT ('PLTTE: ERROR DURING GRAPHING. WILL TRY TO FINISH ',
     *   'PARTIAL GRAPH')
      END

LOCAL INCLUDE 'UVLSD.INC'
C                                       Local include for UVLSD
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4), XCALC(1), XNAMOU(3),
     *   XCLAOU(2)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XSUBA, XBIF, XEIF, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER,
     *   XFLAG, XDOBND, XBPVER, XSMOTH(3), XDOAC, XSOUT, XDISO, XBCHAN,
     *   XECHAN, XCHSEL(4,20), XORD, DOOUT, XCHANF, MFLUX, RFLUX,
     *   SHIFT(2), XCENT, BADD(10),
     *   BUFF1(UVBFSS), BUFF2(UVBFSS), BUFF3(UVBFSS), FINC(MAXIF),
     *   DIFPIX
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, LBCHAN, LECHAN, JBUFSZ,
     *   ILOCWT, CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO,
     *   INCIFO, LRECO, NRPRMI, NRPRMO, CHNSEL(4,20,MAXIF), LBIF,
     *   NCHSEL, CHFIT0, DISK2, SEQO2, CAT2(256), INCS2, INCF2, INCIF2,
     *   LREC2, NRPRM2, CHMASK(MAXCIF), NORDER, NIF, NFREQ, OLDCNO,
     *   NEWCNO(2), ISBAND(MAXIF)
      LOGICAL   ISCOMP, DOFLUX
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      DOUBLE PRECISION FOFF(MAXIF)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XTIME, XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF, XDOCAL, XGUSE,
     *   XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH, XDOAC,
     *   XNAMOU, XCLAOU, XSOUT, XDISO, XBCHAN, XECHAN, XCHSEL, XORD,
     *   DOOUT, XCHANF, MFLUX, RFLUX, SHIFT, XCENT, BADD
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT
      COMMON /BUFRS/ BUFF1, BUFF2, BUFF3, JBUFSZ
      COMMON /INFO/ CATOLD, CAT2, FOFF, FINC, ISBAND, SEQIN, SEQOUT,
     *   DISKIN, DISKO, LBCHAN, LECHAN, ILOCWT, INCSI, INCFI, INCIFI,
     *   INCSO, INCFO, INCIFO, LRECO, NRPRMI, NRPRMO, ISCOMP, CHNSEL,
     *   NCHSEL, CHFIT0, DISK2, SEQO2, INCS2, INCF2, INCIF2, LREC2,
     *   NRPRM2, CHMASK, DOFLUX, NORDER, NIF, NFREQ, OLDCNO, NEWCNO,
     *   LBIF, DIFPIX
LOCAL END
      PROGRAM UVLSD
C-----------------------------------------------------------------------
C! Averages several channels and divides the uv data.
C# Utility UV UV-util VLA VLB SPECTRAL
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000, 2007-2012, 2014-2015, 2018, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVLSD averages a set of channels and divides them into another
C   range of channels.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C          calibration adverbs added
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      BCHAN          BCHAN         Start channel to write out
C      ECHAN          ECHAN         End channel to write out
C      CHANSEL(3,10)  CHNSEL        Channels to select for baseline
C      DOOUTPUT       DOOUT         > 0 => write fit uv data also
C      CHANNEL        CHFIT0        first fit channel out
C      SHIFT          SHIFT(2)      RA and Dec phase shift done before
C                                   fit and then undone.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'UVLSD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'UVLSD '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL UVLSDI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Filter data.
      CALL UVLSDU (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL UVLSDH
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE UVLSDI (PRGN, JERR)
C-----------------------------------------------------------------------
C   UVLSDI gets input parameters for UVLSD and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      BCHAN   I  Lowest channel number to write.
C      ECHAN   I  Highest channel number to write.
C      ISCOMP  L  If true data is compressed
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, CATMP(256), J, K, K1, K2
      LOGICAL   T, MATCH
      INCLUDE 'UVLSD.INC'
      INTEGER   NW(MAXIF), IOFF, LUN
      REAL      CATR(256), RPARM(20)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      DATA BLANK /' '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 146
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (16, 1, XSOUR, SOURCS(1))
      SELQUA = IROUND (XQUAL)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
      DISK2 = DISKO
      SEQO2 = SEQOUT
      DOFLUX = (MFLUX.GT.0.0) .OR. (RFLUX.GT.0.0)
      IF (MFLUX.LE.0.0) MFLUX = 1.E20
      IF (RFLUX.LE.0.0) RFLUX = 1.E20
      NORDER = XORD + 0.1
      NORDER = MAX (0, MIN (1, NORDER))
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = XDOAC.GT.0.0
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
        WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NIF = EIF - BIF + 1
      LBIF = BIF
      NFREQ = CATBLK(KINAX+JLOCF)
      LBCHAN = IROUND (XBCHAN)
      LECHAN = IROUND (XECHAN)
      CHFIT0 = IROUND (XCHANF)
      IF ((CHFIT0.LE.0) .OR. (CHFIT0.GT.NFREQ)) CHFIT0 = IROUND
     *   (CATR(KRCRP+JLOCF))
      IF ((CHFIT0.LE.0) .OR. (CHFIT0.GT.NFREQ)) CHFIT0 =
     *   IROUND (CATR(KRCRP+JLOCF))
      BCHAN = 1
      ECHAN = NFREQ
C
      IF ((LBCHAN.LE.0) .OR. (LBCHAN.GT.NFREQ)) LBCHAN = 1
      IF ((LECHAN.LE.0) .OR. (LECHAN.GT.NFREQ)) LECHAN = NFREQ
      IF (LBCHAN.GT.LECHAN) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       get freq info
      I = 1
      CALL CHNDAT ('READ', BUFF1, DISKIN, OLDCNO, I, CATBLK, LUN, K,
     *   FOFF, ISBAND, FINC, BNDCOD, FRQSEL, JERR)
      IF (JERR.GT.0) THEN
         MSGTXT = 'ERROR READING FQ FILE'
         GO TO 990
         END IF
C                                       Set fit windows
      I = 60 * MAXIF
      CALL FILL (I, 0, CHNSEL)
      CALL FILL (MAXIF, 0, NW)
      DO 20 J = 1,20
         K = IROUND (XCHSEL(2,J))
         IF (K.LE.0) GO TO 25
         K = IROUND (XCHSEL(4,J))
         IF ((K.LE.0) .OR. (K.GT.NIF)) THEN
            K1 = 1
            K2 = NIF
         ELSE
            K1 = K
            K2 = K
            END IF
         DO 15 K = K1,K2
            NW(K) = NW(K) + 1
            CHNSEL(1,NW(K),K) = MAX (0, IROUND (XCHSEL(1,J)))
            CHNSEL(2,NW(K),K) = MAX (0, IROUND (XCHSEL(2,J)))
            CHNSEL(3,NW(K),K) = MAX (1, IROUND (XCHSEL(3,J)))
 15         CONTINUE
 20      CONTINUE
C                                       If no channel selection
C                                       use 1 - NFREQ
 25   CALL FILL (MAXCIF, 0, CHMASK)
      DO 35 K = 1,NIF
         IOFF = (K - 1) * NFREQ
         IF (NW(K).LE.0) THEN
            NW(K) = 1
            CHNSEL(1,1,K) = 1
            CHNSEL(2,1,K) = NFREQ
            CHNSEL(3,1,K) = 1
            END IF
         DO 30 I = 1,NW(K)
            CHNSEL(1,I,K) = MAX (1, MIN (CHNSEL(1,I,K), NFREQ))
            IF (CHNSEL(2,I,K).LT.CHNSEL(1,I,K)) CHNSEL(2,I,K) = NFREQ
            CHNSEL(2,I,K) = MAX (1, MIN (CHNSEL(2,I,K), NFREQ))
            DO 28 J = CHNSEL(1,I,K),CHNSEL(2,I,K),CHNSEL(3,I,K)
               CHMASK(J+IOFF) = 1
 28            CONTINUE
 30         CONTINUE
 35      CONTINUE
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1035) IERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, BUFF1, IERR)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       check that single source by now
      CALL AXEFND (6, 'SOURCE', CATBLK(KIPCN), CATH(KHPTP), I, IERR)
      IF (IERR.EQ.0) THEN
         MSGTXT = 'MORE THAN ONE SOURCE SELECTED: NOT ALLOWED'
         JERR = 10
         GO TO 990
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       read compressed => write compr.
      IF (ISCOMP) THEN
         CATBLK(KINAX) = 1
         I = CATBLK(KIPCN)
         CALL CHR2H (8, 'WEIGHT  ', 1, CATH(KHPTP+2*I))
         CALL CHR2H (8, 'SCALE   ', 1, CATH(KHPTP+2*I+2))
         CATBLK(KIPCN) = I + 2
         ILOCWT = I
         END IF
C                                       Frequency axis
      CATBLK(KINAX+JLOCF) = LECHAN - LBCHAN + 1
      CATR(KRCRP+JLOCF) = CATR(KRCRP+JLOCF) - LBCHAN + 1
      CATR(KRARP) = CATR(KRARP) - LBCHAN + 1
C                                       center frequencies
      IF (JLOCF.LT.0) XCENT = -1.
      IF (XCENT.GT.0.0) THEN
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
      ELSE
         DIFPIX = 0.0
         END IF
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((CCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
      NEWCNO(1) = CCNO
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                       copy header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       second output file
      IF (DOOUT.GT.0.0) THEN
         CALL COPY (256, CATBLK, CATMP)
         CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, 'BASFIT', KHIMCO, CATH(KHIMC))
         CATBLK(KIIMS) = SEQO2
C                                       continuum not compressed
         IF (ISCOMP) THEN
            CATBLK(KINAX) = 3
            CATBLK(KIPCN) = CATBLK(KIPCN) - 2
            END IF
C                                       Frequency axis
         CATBLK(KINAX+JLOCF) = 1
         CATR(KRCRP+JLOCF) = CATR(KRCRP+JLOCF) - CHFIT0 + 1
         CATR(KRARP) = CATR(KRARP) - CHFIT0 + 1
C                                       Create output file.
         NEWCNO(2) = 1
         FRW(NCFILE+1) = 3
         JERR = 4
         CALL UVCREA (DISK2, NEWCNO(2), BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISK2
         FCNO(NCFILE) = NEWCNO(2)
         FRW(NCFILE) = FRW(NCFILE) - 1
C                                       Save output file info
         CALL UVPGET (JERR)
         IF (JERR.NE.0) GO TO 999
         INCX = CATBLK(KINAX)
         LREC2 = LREC
         NRPRM2 = NRPARM
         INCS2 = INCS / INCX
         INCF2 = INCF / INCX
         INCIF2 = INCIF / INCX
         JERR = 0
C                                       save catblk
         SEQO2 = CATBLK(KIIMS)
         CALL COPY (256, CATBLK, CAT2)
         CALL COPY (256, CATMP, CATBLK)
C                                       copy header keywords
         CALL KEYCOP (DISKIN, OLDCNO, DISK2, NEWCNO(2), IERR)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVLSDI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('UVLSDI: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE UVLSDU (IRET)
C-----------------------------------------------------------------------
C   UVLSDU sends uv data one point at a time to the filtering
C   routine and then writes the modified data if requested.
C   Input in common:
C      BCHAN   I  Lowest channel number to write.
C      ECHAN   I  Highest channel number to write.
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48
      INTEGER   IPTRO, LUNO, INDO, LUN2, IND2, ILENBU, KBIND, NIOUT,
     *   NIOLIM, IA1, IA2, BO, VO, NUMVIS, XCOUNT, NCORO, RNXRET, NCOPY,
     *   NCOR2, NCOP2, IPTR2, NIOU2, NIOLI2, CATMP(256)
      LOGICAL   T, F
      INCLUDE 'UVLSD.INC'
      REAL      DUM, VIS(UVBFSS), RESULT(UVBFSS), RESUL2(UVBFSS),
     *   RPARM(20)
      DOUBLE PRECISION UVSCAL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (BUFF1, VIS)
      DATA LUNO, LUN2 /17, 18/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Number of visibilities in input
C                                       and output files.
      NCORO = (LRECO - NRPRMO)
      IF (.NOT.ISCOMP) NCORO = NCORO / 3
      NCOPY = LRECO - NRPRMO
      NCOR2 = (LREC2 - NRPRM2) / 3
      NCOP2 = LREC2 - NRPRM2
C                                       Open and init for read
C                                       defend cat header from UVGET
      CALL COPY (256, CATBLK, CATMP)
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL COPY (256, CATMP, CATBLK)
      CALL UVPGET (IRET)
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO(1), CATBLK, RNXRET)
C                                       Open vis file for write
      IF (DOOUT.GT.0.0) THEN
         CALL ZPHFIL ('UV', DISK2, NEWCNO(2), 1, OFILE, IRET)
         CALL ZOPEN (LUN2, IND2, DISK2, OFILE, T, F, F, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1010) IRET
            GO TO 990
            END IF
C                                       Init vis file for write
         ILENBU = 0
         CALL UVINIT ('WRIT', LUN2, IND2, NVIS, VO, LREC2, ILENBU,
     *      JBUFSZ, BUFF3, BO, KBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1020) IRET
            GO TO 990
            END IF
         IPTR2 = KBIND
         NIOU2 = 0
         NIOLI2 = ILENBU
         END IF
C                                       Init vis file for read.
      NUMVIS = 0
      XCOUNT = 0
      IF ((FREQ.GT.0.0D0) .AND. (UVFREQ.GT.0.0D0)) THEN
         UVSCAL = FREQ / UVFREQ
      ELSE
         UVSCAL = 1.0D0
         END IF
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVGET ('READ', RPARM, VIS, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
C                                       Loop over buffer
         IF (IRET.EQ.0) THEN
            IF (ILOCB.GE.0) THEN
               IA2 = RPARM(1+ILOCB) + 0.1
               IA1 = IA2 / 256
               IA2 = IA2 - IA1*256
            ELSE
               IA1 = RPARM(1+ILOCA1) + 0.1
               IA2 = RPARM(1+ILOCA2) + 0.1
               END IF
            NUMVIS = NUMVIS + 1
C                                       Call filtering routine.
            CALL UVLSDF (NUMVIS, RPARM(1+ILOCU), RPARM(1+ILOCV),
     *         RPARM(1+ILOCW), VIS, RESULT, RESUL2, IRET)
C                                       Branch on his return
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
C                                       Copy to output.
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1
C                                       update NX table
               CALL RNXUPD (RPARM, RNXRET)
               RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
               RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
               RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
               CALL RCOPY (NRPRMO, RPARM, BUFF2(IPTRO))
               IF (ISCOMP) THEN
                  CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *               BUFF2(IPTRO+NRPRMO))
               ELSE
                  CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
                  END IF
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               IF (DOOUT.GT.0.0) THEN
                  CALL RCOPY (NRPRM2, RPARM, BUFF3(IPTR2))
                  CALL RCOPY (NCOP2, RESUL2, BUFF3(IPTR2+NRPRM2))
                  IPTR2 = IPTR2 + LREC2
                  NIOU2 = NIOU2 + 1
                  END IF
               END IF
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET, XCOUNT
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
C                                       Write vis record.
            IF ((DOOUT.GT.0.0) .AND. (NIOU2.GE.NIOLI2)) THEN
               CALL UVDISK ('WRIT', LUN2, IND2, BUFF3, NIOLI2, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET, XCOUNT
                  GO TO 990
                  END IF
               IPTR2 = KBIND
               NIOU2 = 0
               END IF
C                                       Read next buffer.
            GO TO 100
            END IF
C                                       Final call to UVLSDF.
      NUMVIS = -1
      CALL UVLSDF (NUMVIS, DUM, DUM, DUM, BUFF1, RESULT, RESUL2, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET, XCOUNT
         GO TO 990
         END IF
C                                       Finish write
      IF (DOOUT.GT.0.0) THEN
         NIOU2 = - NIOU2
         CALL UVDISK ('FLSH', LUN2, IND2, BUFF3, NIOU2, KBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1150) IRET, XCOUNT
            GO TO 990
            END IF
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       close NX table
      CALL RNXCLS (RNXRET)
C                                       compress other output file
      IF (DOOUT.GT.0.0) CALL UCMPRS (NVIS, DISK2, NEWCNO(2), LUN2, CAT2,
     *   IRET)
C                                       Close files
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IF (DOOUT.GT.0.0) CALL ZCLOSE (LUN2, IND2, IRET)
      IRET = 0
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVLSDU: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1010 FORMAT ('UVLSDU: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('UVLSDU: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1100 FORMAT ('UVLSDU: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('UVLSDU: UVLSDF ERROR',I3)
 1150 FORMAT ('UVLSDU: ERROR',I3,' WRITING VIS FILE AT VIS',I9)
      END
      SUBROUTINE UVLSDH
C-----------------------------------------------------------------------
C   UVLSDH copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72
      INTEGER   LUN1, LUN2, IERR, I, K, INVER, OUVER
      LOGICAL   T
      INCLUDE 'UVLSD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO(1), CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
C                                       calibration adverbs
      CALL CALHIS (LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       LBCHAN, LECHAN
      WRITE (HILINE,2000) TSKNAM, LBCHAN, LECHAN
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       shifts
      IF ((SHIFT(1).NE.0.0) .OR. (SHIFT(2).NE.0.0)) THEN
         WRITE (HILINE,2015) TSKNAM, SHIFT
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
         END IF
C                                      CHANSEL
      DO 25 K = 1,NIF
         DO 20 I = 1,20
            IF ((CHNSEL(1,I,K).GT.0) .AND.
     *         (CHNSEL(2,I,K).GE.CHNSEL(1,I,K))) THEN
               WRITE (HILINE,2020) TSKNAM, I, CHNSEL(1,I,K),
     *            CHNSEL(2,I,K), CHNSEL(3,I,K), K
               CALL HIADD (LUN2, HILINE, BUFF2, IERR)
               IF (IERR.NE.0) GO TO 100
               END IF
 20         CONTINUE
 25      CONTINUE
C                                       ORDER
      WRITE (HILINE,2025) TSKNAM, NORDER
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Close HI file
 100  CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL COPTAB (DISKIN, OLDCNO, DISKO, NEWCNO(1), IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'UVLSDH: ERROR COPYING TABLES TO LINE UV'
         CALL MSGWRT (6)
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (DISKO, NEWCNO(1), DIFPIX, BUFF1, BUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'UVLSDH: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO(1), CATBLK, 'REST', BUFF1, IERR)
C
      IF (DOOUT.GT.0.0) THEN
         CALL COPY (256, CAT2, CATBLK)
C                                       Copy/open history file.
         CALL HISCOP (LUN1, LUN2, DISKIN, DISK2, OLDCNO, NEWCNO(2),
     *      CATBLK, BUFF1, BUFF2, IERR)
         IF (IERR.GT.2) THEN
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (6)
            GO TO 200
            END IF
C                                       New history
         CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *      IERR)
         IF (IERR.NE.0) GO TO 200
         CALL HENCOO (TSKNAM, NAMOUT, 'BASFIT', SEQO2, DISK2, LUN2,
     *      BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       calibration adverbs
         CALL CALHIS (LUN2, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       output channel
         WRITE (HILINE,2010) TSKNAM, CHFIT0
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       shifts
         IF ((SHIFT(1).NE.0.0) .OR. (SHIFT(2).NE.0.0)) THEN
            WRITE (HILINE,2015) TSKNAM, SHIFT
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 100
            END IF
C                                      CHANSEL
         DO 125 K = 1,NIF
            DO 120 I = 1,20
               IF ((CHNSEL(1,I,K).GT.0) .AND.
     *            (CHNSEL(2,I,K).GE.CHNSEL(1,I,K))) THEN
                  WRITE (HILINE,2020) TSKNAM, I, CHNSEL(1,I,K),
     *               CHNSEL(2,I,K), CHNSEL(3,I,K), K
                  CALL HIADD (LUN2, HILINE, BUFF2, IERR)
                  IF (IERR.NE.0) GO TO 200
                  END IF
 120           CONTINUE
 125        CONTINUE
C                                       ORDER
         WRITE (HILINE,2025) TSKNAM, NORDER
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 100
C                                       Close HI file
 200     CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                       copy new NX table
         INVER = 1
         OUVER = 1
         CALL TABCOP ('NX', INVER, OUVER, LUN1, LUN2, DISKO, DISK2,
     *      NEWCNO(1), NEWCNO(2), CATBLK, BUFF1, BUFF2, IERR)
C                                        Copy tables
         CALL COPTAB (DISKIN, OLDCNO, DISK2, NEWCNO(2), IERR)
         IF (IERR.GT.2) THEN
            MSGTXT = 'UVLSDH: ERROR COPYING TABLES TO CONTINUUM UV'
            CALL MSGWRT (6)
            END IF
C                                       correct for FQCENTER
         CALL CENTFQ (DISK2, NEWCNO(2), DIFPIX, BUFF1, BUFF2, IERR)
         IF (IERR.GT.0) THEN
            MSGTXT = 'UVLSDH: ERROR CORRECTING FQ TABLE'
            CALL MSGWRT (6)
            END IF
C                                        Update CATBLK.
         CALL CATIO ('UPDT', DISK2, NEWCNO(2), CATBLK, 'REST', BUFF1,
     *      IERR)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVLSDH: ERROR',I3,' COPY/OPEN HISTORY FILE')
 2000 FORMAT (A6,'BCHAN =',I4,', ECHAN =',I4,
     *   ' / Output channel selection')
 2010 FORMAT (A6,'CHANNEL =',I5,5X,'/ Channel at which fit evaluated')
 2015 FORMAT (A6,'SHIFT =',F10.5,' , ',F10.5,' / shifts in asec before',
     *   ' fit')
 2020 FORMAT (A6,'CHANSEL(',I2,')=',I5,',',I5,',',I2,5X,
     *   '/ channels fit IF =',I3)
 2025 FORMAT (A6,'ORDER =',I3,10X,'/ order of polynomial fit')
      END
      SUBROUTINE UVLSDF (NUMVIS, U, V, W, VIS, RESULT, RESUL2, IRET)
C-----------------------------------------------------------------------
C   Routine to fit baseline to channels, divide and perhaps flag
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      U       R    U in wavelengths
C      V       R    V in wavelengths
C      W       R    W in wavelengths
C      T       R    Time in days.
C      VIS     R(3,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C   Inputs from COMMON:
C      CHNSEL(3,10) Gives channel selection
C      BCHAN   I    Lowest channel number to write.
C      ECHAN   I    Highest channel number to write.
C      NRPRMI  I    Input number of random parameters.
C      INCSI   I    Input Stokes' increment in vis.
C      INCFI   I    Input frequency increment in vis.
C      INCIFI  I    Input IF increment in vis.
C      LRECO   I    Output file record length
C      NRPRMO  I    Output number of random parameters.
C      INCSO   I    Output Stokes' increment in vis.
C      INCFO   I    Output frequency increment in vis.
C      INCIFO  I    Output IF increment in vis.
C   Output:
C      RESULT  R(3,*) Output visibilities selected in frequency.
C      RESUL2  R(3,*) Baseline fit value at CHFIT0
C      IRET    I  Return code  -1 => don't write
C                               0 => OK
C                              >0 => error, terminate.
C   Output in COMMON:
C      CATBLK    I         Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IRET
      REAL      U, V, W, VIS(3,*), RESULT(3,*), RESUL2(3,*)
C
      INTEGER   NPOLN, INDEX, OFF, IS, IIF, INDEX2, NFIT, IOFF, ICHAN,
     *   NSX, NFLUXF
      REAL      SX, SXX, RSY, ISY, RSXY, ISXY, RM, RB, IM, IB, SSX, MSX,
     *   XX, SW, CATR(256)
      COMPLEX   VS, ZZ
      DOUBLE PRECISION DXC, DYC, DZC, RFREQ, DFREQ, CFREQ, RA0, DEC0,
     *   TRUEF
      LOGICAL   FLGWT, DOSHIF
      INCLUDE 'UVLSD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (CATR, CATBLK)
      SAVE NPOLN, NFLUXF, DXC, DYC, DZC, RFREQ, DOSHIF
C-----------------------------------------------------------------------
C                                       Set up on first call
      IF (NUMVIS.EQ.1) THEN
         NFLUXF = 0
         NPOLN = CATBLK(KINAX+JLOCS)
C                                       shift parameters
         DOSHIF = (ABS(SHIFT(1)).GT.1E-6) .OR. (ABS(SHIFT(2)).GT.1E-6)
         IF (DOSHIF) THEN
            RFREQ = CATR(KRCRP+JLOCF)
            RA0 = RA
            DEC0 = DEC
            IF (COS(DG2RAD*DEC0).NE.0.0D0) RA = RA0 + SHIFT(1) / 3600.D0
     *         / COS(DG2RAD * DEC0)
            DEC = DEC + SHIFT(2) / 3600.D0
            DXC = SIN (DG2RAD * (RA-RA0)) * COS (DEC * DG2RAD)
            DYC = COS (DEC0 * DG2RAD) * SIN (DEC * DG2RAD) -
     *         SIN (DEC0 * DG2RAD) * COS (DEC * DG2RAD) *
     *         COS ((RA - RA0) * DG2RAD)
            DZC = SIN (DG2RAD * DEC0) * SIN (DG2RAD * DEC) +
     *         COS (DG2RAD * DEC0) * COS (DG2RAD * DEC) *
     *         COS (DG2RAD * (RA - RA0)) - 1.0D0
            DXC = TWOPI * DXC
            DYC = TWOPI * DYC
            DZC = TWOPI * DZC
            END IF
         END IF
      IRET = 0
      IF (NUMVIS.GT.0) THEN
C                                       Loop over IF
         DO 400 IIF = 1,NIF
            IOFF = (IIF - 1) * NFREQ
            TRUEF = 1.0D0 + FOFF(IIF+LBIF-1) / UVFREQ
            DFREQ = FINC(IIF+LBIF-1) / UVFREQ
C                                       Loop over Stokes
            DO 350 IS = 1,NPOLN
C                                       Offset in Stokes and IF
               OFF = (IS - 1) * INCSI + (IIF - 1) * INCIFI + 1
C                                       shift phases before fit
               IF (DOSHIF) THEN
                  DO 20 ICHAN = LBCHAN,LECHAN
                     INDEX = OFF + (ICHAN-1) * INCFI
                     CFREQ = TRUEF + DFREQ * (ICHAN - RFREQ)
                     XX = (U * DXC + V * DYC + W * DZC) * CFREQ
                     ZZ = CMPLX (COS(XX), -SIN(XX))
                     VS = CMPLX (VIS(1,INDEX), VIS(2,INDEX)) * ZZ
                     VIS(1,INDEX) = REAL (VS)
                     VIS(2,INDEX) = AIMAG (VS)
 20                  CONTINUE
                  END IF
C                                       Least squares fit to real and
C                                       imaginary parts of selected
C                                       channels
               SX = 0.0
               RSY = 0.0
               ISY = 0.0
               RSXY = 0.0
               ISXY = 0.0
               SXX = 0.0
               NFIT = 0
               SW = 0.0
C
               DO 50 ICHAN = LBCHAN,LECHAN
                  IF (CHMASK(ICHAN+IOFF).GT.0) THEN
                     INDEX = OFF + (ICHAN-1) * INCFI
C                                       Compute sums
                     IF (VIS(3,INDEX).GT.0.0) THEN
                        NFIT = NFIT + 1
                        RSY = RSY + VIS(1,INDEX)
                        ISY = ISY + VIS(2,INDEX)
                        SW = SW + VIS(3,INDEX)
                        IF (NORDER.EQ.1) THEN
                           SX = SX + ICHAN
                           RSXY = RSXY + ICHAN*VIS(1,INDEX)
                           ISXY = ISXY + ICHAN*VIS(2,INDEX)
                           SXX = SXX + ICHAN*ICHAN
                           END IF
                        END IF
                     END IF
 50               CONTINUE
C                                       Compute m & b; y = mx + b
C                                       Real and imaginary separately
               RM = 0.0
               IM = 0.0
               FLGWT = .FALSE.
               IF ((NFIT.GT.1) .AND. (NORDER.EQ.1)) THEN
                  RM = (NFIT * RSXY) - (SX * RSY)
                  RM = RM / (NFIT * SXX - SX**2)
                  RB = (RSY / NFIT) - (RM * SX / NFIT)
C
                  IM = (NFIT * ISXY) - (SX * ISY)
                  IM = IM / (NFIT * SXX - SX**2)
                  IB = (ISY / NFIT) - (IM * SX / NFIT)
C                                       DC terms only
               ELSE IF ((NFIT.GT.0) .AND. (NORDER.EQ.0)) THEN
                  RB = RSY / NFIT
                  IB = ISY / NFIT
C                                       No data
               ELSE
                  RB = 0.0
                  IB = 0.0
                  SW = 0.0
                  FLGWT = .TRUE.
                  END IF
C                                       Subtract baseline from input
C                                       if could get a fit
               INDEX = OFF + (LBCHAN - 1) * INCFI
               INDEX2 =  (IS - 1) * INCSO + (IIF - 1) * INCIFO + 1
               SSX = 0.0
               MSX = 0.0
C
      INCLUDE 'INCS:ZVND.INC'
               DO 300 ICHAN = LBCHAN,LECHAN
C                                       Subtract from vis.
                  VS = CMPLX (VIS(1,INDEX), VIS(2,INDEX))
                  ZZ = CMPLX (RB + RM*ICHAN, IB + IM*ICHAN)
                  IF (CABS(ZZ).EQ.0.0) THEN
                     RESULT(3,INDEX2) = -ABS(VIS(3,INDEX))
                     RESULT(1,INDEX2) = VIS(1,INDEX)
                     RESULT(2,INDEX2) = VIS(2,INDEX)
                  ELSE
                     VS = VS / ZZ
                     RESULT(1,INDEX2) = REAL (VS)
                     RESULT(2,INDEX2) = AIMAG (VS)
                     RESULT(3,INDEX2) = VIS(3,INDEX)
                     END IF
                  IF (FLGWT) RESULT(3,INDEX2) = - ABS (VIS(3,INDEX))
                  IF ((DOFLUX) .AND. (RESULT(3,INDEX2).GT.0.0) .AND.
     *               (CHMASK(ICHAN+IOFF).GT.0)) THEN
                     SX = RESULT(1,INDEX2) * RESULT(1,INDEX2) +
     *                  RESULT(2,INDEX2) * RESULT(2,INDEX2)
                     SSX = SSX + SX
                     MSX = MAX (MSX, SX)
                     NSX = NSX + 1
                     END IF
C                                       NO shift phases back after fit
                  INDEX = INDEX + INCFI
                  INDEX2 = INDEX2 + INCFO
 300              CONTINUE
               IF (NSX.GT.0) THEN
                  SSX = SQRT (SSX / NSX)
                  MSX = SQRT (MSX)
                  IF ((SSX.GT.RFLUX) .OR. (MSX.GT.MFLUX)) THEN
                     NFLUXF = NFLUXF + 1
                     INDEX2 =  (IS - 1) * INCSO + (IIF - 1) * INCIFO + 1
                     DO 310 ICHAN = LBCHAN,LECHAN
                        RESULT(3,INDEX2) = - ABS (RESULT(3,INDEX2))
                        INDEX2 = INDEX2 + INCFO
 310                    CONTINUE
                     FLGWT = .TRUE.
                     END IF
                  END IF
               IF (DOOUT.GT.0.0) THEN
                  INDEX2 =  (IS - 1) * INCS2 + (IIF - 1) * INCIF2 + 1
                  RESUL2(1,INDEX2) = (RB + RM*CHFIT0)
                  RESUL2(2,INDEX2) = (IB + IM*CHFIT0)
                  RESUL2(3,INDEX2) = SW
                  IF (FLGWT) RESUL2(3,INDEX2) = - ABS (SW)
C                                       shift phases back after fit
                  IF (DOSHIF) THEN
                     CFREQ = TRUEF+ DFREQ * (CHFIT0 - RFREQ)
                     XX = (U * DXC + V * DYC + W * DZC) * CFREQ
                     ZZ = CMPLX (COS(XX), SIN(XX))
                     VS = CMPLX (RESUL2(1,INDEX2), RESUL2(2,INDEX2))*ZZ
                     RESUL2(1,INDEX2) = REAL (VS)
                     RESUL2(2,INDEX2) = AIMAG (VS)
                     END IF
                  END IF
 350           CONTINUE
 400        CONTINUE
C                                       last call
      ELSE
         IF (DOFLUX) THEN
            WRITE (MSGTXT,1500) NFLUXF
            IF (NFLUXF.LE.0) MSGTXT = 'No points flagged for excess'
     *         // ' residuals'
            CALL MSGWRT (6)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1500 FORMAT ('Flagged',I9,' time/IF/Stokes samples for excess',
     *   ' residuals')
      END

      SUBROUTINE ZVTPRX (FIND, BUFSW, NTPDEV, THOSTS, THLEN, NTH,
     *                   TPFIND, HBUF, IERR)
C-----------------------------------------------------------------------
C! does IO for server (real tape) to client (Virtual-tape), close/reopen
C# Tape Z
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZVTPRX performs "I/O" over some communication mechanism to a
C   cooperating program with the intention of driving a real tape device
C   controlled by this program.
C   Inputs:
C      FIND    I      FTAB location for socket to remote machine
C      BUFSW   I      Number 32-bit integers total data to send
C                     If BUFSW > 0, write to client; if <= 0, read
C                     from client machine.
C      NTPDEV  I      Tape device number (used on error close only)
C      THOSTS  C*(*)  Names or wildcards for authorized hosts
C      THLEN   I      Length of a hostname (fixed)
C      NTH     I      Number of hosts to check
C                       See TPMON.FOR local include for details
C   In/Out:
C      TPFIND  I      FTAB pointer for tape device: > 0 => it needs
C                     to be closed on error.  Returns 0, if that done.
C      HBUF    I(*)   Buffer: in FITS standard 16 bit
C                        (1,2) : subroutine name packed ASCII
C                        (3)   : BUFSW - 5
C                        (4)   : BUFSR
C                        (5)   : error returned to client
C                        (6..) : extra data
C   Output:
C      IERR    I      Error code: 0 => ok.
C   Generic version - does little except call ZVTPX3
C-----------------------------------------------------------------------
      INTEGER   FIND, BUFSW, NTPDEV, TPFIND, HBUF(*), THLEN, NTH, IERR
C                                       See also TPMON.FOR local include
      HOLLERITH THOSTS(*)
C
      INTEGER   ICOUNT, IER, TPLUN, JER
      CHARACTER MSG*80
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
C-----------------------------------------------------------------------
      ICOUNT = 0
 10   CALL ZVTPX3 (FTAB(FIND+NMOFF), BUFSW, HBUF, IERR)
      IF (IERR.EQ.0) GO TO 999
C                                       try to survive
      IF (IERR.NE.4) THEN
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (7)
         END IF
C                                       EOF or read error
      IF (ICOUNT.LT.100) THEN
         ICOUNT = ICOUNT + 1
C                                       Close TP: lost client didn't
C                                       close the device
         IF (TPFIND.GT.0) THEN
            MSGTXT = 'ZVTPRX: UNEXPECTED EOF'
            CALL MSGWRT (7)
            MSGTXT = 'ZVTPRX: Having to close open Tape device'
            CALL MSGWRT (7)
            TPLUN = FTAB(TPFIND)
            IF ((TPLUN.GT.0) .AND. (TPLUN.LE.50) .AND. ((NTPDEV.LE.0)
     *         .OR. (TPLUN.EQ.NTPDEV+30))) THEN
               CALL ZTPCLS (TPLUN, TPFIND, IER)
               IF (IER.GT.0) THEN
                  WRITE (MSGTXT,1015) 'ZTPCLS', IER
                  CALL MSGWRT (7)
C                                       dismount on non-eof error
               ELSE IF ((IERR.NE.4) .AND. (NTPDEV.GT.0)) THEN
                  ICOUNT = ICOUNT + 9
                  MSGTXT = 'ZVTPRX: Dismount tape device on error'
                  CALL MSGWRT (7)
                  CALL ZMOUNT (.FALSE., NTPDEV, 0, ' ', 0, MSG, JER,
     *               IER)
                  IF ((JER.NE.0) .OR. (IER.NE.0)) THEN
                     MSGTXT = MSG
                     IF (JER.NE.0) CALL MSGWRT (7)
                     WRITE (MSGTXT,1015) 'ZMOUNT', IER
                     CALL MSGWRT (7)
                  END IF
                     END IF
               TPFIND = 0
               END IF
            END IF
C                                       close connection, get new client
         CALL ZVTPGC (THOSTS, THLEN, NTH, FTAB(FIND+NMOFF), IERR)
         IF (IERR.EQ.0) GO TO 10
            WRITE (MSGTXT,1020) IERR
            CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ZVTPX3 RETURNS ERROR CODE',I7)
 1015 FORMAT ('ZVTPRX: FORCED CALL ',A,' RETURNS ERROR',I7)
 1020 FORMAT ('ZVTPGC (GET CLIENT) RETURNS ERROR CODE',I7)
      END

      SUBROUTINE ZACTV8 (NAME, INPOPS, RVERSN, PID, IERR)
C-----------------------------------------------------------------------
C! activate the requested program, returning process ID information
C# Z System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Activate the specified program and return the activated process
C   identification information.
C   Inputs:
C      NAME     C*6    Program name
C      INPOPS   I      POPS # for the task to use
C      RVERSN   C*48   Logical name or fully qualified name of the
C                      directory from which to get the required
C                      executable module
C   In/Out:
C      PID      I(4)   Process identification information used directly
C                      by subsequent calls to ZTACTQ where
C                      In:  PID(1)   = user number for systems that use
C                                      it (= 0 otherwise and on all
C                                      AIPSB invocations)
C                      Out: PID(2-4) = process ID number(s) as needed
C   Output:
C      IERR     I      Error return code: 0 => no error
C                         1 => program name too long
C                         2 => activation error
C   Common: DMSG.INC
C      DBGAIP   I      > 10 => start tasks in DEBUG mode if possible
C   Generic version = stub
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), RVERSN*(*)
      INTEGER   INPOPS, PID(4), IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'ZACTV8: REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (9)
C
 999  RETURN
      END

      SUBROUTINE UVTBUW (APCORE, DISKI, CNOSCI, DISKO, CNOSCO, CATUVR,
     *   JBUFSZ, BUFF1, BUFF2, IRET)
C-----------------------------------------------------------------------
C! Determines and applies uniform weighting (by weight) to uv data.
C# AP-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2000, 2006, 2012, 2015, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVTBUW computes uniform weighting corrections and applies them to
C   the weights in the visibility data base.  The corrections are done
C   by summing the weights of the data in a box rather than the counts
C   of the visibilities.
C      The visibility weights are divided by the number of visibilities
C   occuring in cells within a box of half width UNFBOX centered on the
C   cell in which a given visibility resides.  UNFBOX is implemented by
C   increasing the cellsize of the counting grid (i.e. reducing the grid
C   element size). The uniform weighting correction is done for the uv
C   cellsize defined by CELLSG, NXUNF, NYUNF and UNFBOX.  All channels
C   are included in the weighting although the summing boxes are
C   determined by the first channel.
C      This version will work on arbitrary sort orders but only if
C   sufficient "AP" memory is available.
C   Input uv data file in uv file DISKI, CNOSCI.
C   Output uv data file in uv file DISKO, CNOSCO.
C   Uses AIPS LUNs 18, 20 (all files closed on successful return)
C   Inputs:
C      DISKI    I       Input file disk number for cataloged files,
C                       if .LE. 0 => scratch file.
C      CNOSCI   I       Output file catalog slot number or /CFILES/
C                       scratch file number.
C      DISKO    I       Output file disk number for cataloged files,
C                       if .LE. 0 => scratch file.
C      CNOSCO   I       Output file catalog slot number or /CFILES/
C                       scratch file number.  Can be input file
C      CATUVR   R(256)  UV data catalog header record.
C      JBUFSZ   I       Size in bytes of buffers. Dimension of
C                       BUFF1,2,BUFF3  must be at least 4096 words.
C   From commons: (Includes DGDS, DMPR, DUVH)
C      UNFBOX   I       Half width of unif. wt. counting box size.
C      NVIS     I       Number of visibility measurments. (/UVHDR/)
C      LREC     I       Number of words per visibility record (/UVHDR/)
C      NCHAVG   I       Number of continuum channels to grid
C                       together. (Used to determine number of weights
C                       per visibility to correct.)
C      CHUV1    I       First channel number in file to correct weight
C                       (1 relative) (first ch. to be gridded)
C      FREQG(*) D       Frequencies of the channels
C      FREQUV   D       Reference frequency of the u, v, w
C      NGRDAT   L       If FALSE get map size, scaling etc. parms
C                       from the model map cat. header. If TRUE
C                       then the values filled in by GRDAT must
C                       already be filled into the common.
C      GUARDB       R(2) Fraction of UMAX and VMAX to blank on edge of
C                        field
C   The following must be provided if NGRDAT is .TRUE.
C      CELLSG   R(2)    The cell spacing in X and Y in arcseconds.
C      NXUNF    I       X-dimension (cells) of the map in RA to be used
C                       to determine uniform wt. counting box
C      NYUNF    I       Y-dimension (cells) of the map in Dec to be used
C                       to determine uniform wt. counting box
C   The following must be provided if NGRDAT is .FALSE.
C      CCDISK   I(16)   Disk numbers of the output images.
C      CCCNO    I(16)   Catalog slot numbers of output images.
C
C   Output:
C      BUFF1    R(*)    Working buffer
C      BUFF2    R(*)    Working buffer
C      IRET     I       Return error code, 0=>OK, error otherwise.
C   Usage Notes:
C    1) The input uvdata file is, with one exception, assumed to be
C     accurately described by the contents of CATUVR and the common
C     /UVHDR/ (include DUVH).  The exception is that the u, v and
C     w may refer to a different frequency.  The common input variable
C     FREQUV gives the reference frequency for the u, v, and w.
C    2) the contents of common /UVHDR/ (=include DUVH)
C     are filled in by UVPGET from the catalog header; UVPGET should
C     be called before calling UVTBUW.
C    3) if NGRDAT is .FALSE. then the properties (e.g. cellsize) of the
C     desired output image are assumed to be described in the catalog
C     header of the existant file pointed to by CCDISK,CCCNO(IFIELD).
C    4) the random parameters in the data should include, in order,
C     u, v, w, weight (optional), time (optional) and baseline
C     (optional).  The weights are required but may be passed
C     either as random parameters or as part of the regular data
C     array, CATUVR should tell which.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   DISKI, CNOSCI, DISKO, CNOSCO, JBUFSZ, IRET
      REAL      BUFF1(*), BUFF2(*), CATUVR(256)
C
      INTEGER   BO, IER, II, IBIND, KBIND, OPTR, IXX, IYY, IU, JNPTR,
     *   NIO, NIOUT, NPOINT, INPTR, FIND1, FIND2, ILENBU, LUNUVI,
     *   LUNUVO, JJ, UV, AMAX, AMIN, GRID, IVMAX, WMAX, WMIN, KAP,
     *   ITEMP, APSIZE, VO, IVN2, SIZGRD, MAXREC, CNT, XMAX, NEEDED,
     *   NUMBIN, APLOC, IP, IVMIN, NXUNFS, NYUNFS, IUMIN, IUMAX, NUMWT,
     *   WTOFF, MXUNF, MYUNF, NWORD, ICELL, LTEMP(2), NEED, MSGSAV
      LOGICAL   F
      REAL      TEMP(10), FFRAC, ZSCLU, ZSCLV, SCLU, SCLV, XX, YY,
     *   MAXBLN, APSCAL, UMAX, VMAX, UUMAXG, VVMAXG, RCELL, RTEMP(2)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMPR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DAPM.INC'
      EQUIVALENCE (ICELL, RCELL), (RTEMP, LTEMP)
      DATA F /.FALSE./
      DATA UV /10/
      DATA VO, BO /0, 1/
      DATA LUNUVI, LUNUVO /18, 20/
C-----------------------------------------------------------------------
      IRET = 0
      IF ((GUARDB(1).LT.0.0) .OR. (GUARDB(1).GT.0.9)) GUARDB(1) = 0.0
      IF ((GUARDB(2).LT.0.0) .OR. (GUARDB(2).GT.0.9)) GUARDB(2) = 0.0
C                                       Get field info. if nec.
      IF (.NOT.NGRDAT) THEN
         CALL GRDAT (F, 0, CATUVR, BUFF1, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Implement UNFBOX by reducing the
C                                       size of the grid.
      IF (UNFBOX.LT.0) UNFBOX = 0
      MXUNF = NXUNF / (1 + UNFBOX)
      MYUNF = NYUNF / (1 + UNFBOX)
C                                       Find where weight is.
C                                       WTOFF + => Offset in rec.
C                                       WTOFF - => Offset in vis.
      WTOFF = 0
      CALL AXEFND (8, 'WEIGHT  ', KIPTPN, CATUVR(KHPTP), WTOFF, IER)
      NUMWT = 1
C                                       If COMPLEX axis more then
C                                       2 long assume it has weight.
      IF (INCF.GT.2) THEN
C                                       Include offset to first channel
         WTOFF = NRPARM + (CHUV1-1) * INCF + 2
C                                       Set number of weights.
         NUMWT = NCHAVG
         END IF
C                                       Is there sufficient memory?
      SIZGRD = ((MXUNF / 2) + 1) * MYUNF
      NEEDED = SIZGRD + (JBUFSZ/2) + 100
      NEED = NEEDED / 1024 + 2
C                                       Grab AP.
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL QINIT (APCORE, NEED, 0, KAP)
      MSGSUP = MSGSAV
      IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
         NEED = NEED / 2
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            MSGTXT = 'UVTBUN CANNOT GET NEEDED MEMORY'
            IRET = 8
            GO TO 999
            END IF
         END IF
      APSIZE = PSAPNW * 1024
C                                       If only part of grid fits in AP
      IF (NEEDED.GT.APSIZE) THEN
C                                       rescale to fit in AP
         GRID   = (JBUFSZ/2) + 100
C                                       number of bins for weighting
         NUMBIN = APSIZE - GRID
C                                       convert grid size to AP available
         APSCAL = SQRT(REAL(NUMBIN)/REAL(SIZGRD))
C                                       scale uniform grid
         NXUNFS = APSCAL * MXUNF / 2.
         NYUNFS = APSCAL * MYUNF / 2.
C                                       make X and Y grid even
         NXUNFS = 2 * NXUNFS
         NYUNFS = 2 * NYUNFS
C                                       Recalculate grid size
         SIZGRD = ((NXUNFS / 2) + 1) * NYUNFS
C                                       tell user
         WRITE (MSGTXT,1002) NEEDED, APSCAL
         CALL MSGWRT (7)
C                                       All fits in AP
      ELSE
         NXUNFS = MXUNF
         NYUNFS = MYUNF
         END IF
C                                       Set AP pointers
      GRID   = APSIZE - SIZGRD - 1
      NUMBIN = SIZGRD
C                                       Clear grid
      CALL QVCLR (APCORE, GRID, 1, NUMBIN)
C                                       Tell about weighting
      WRITE (MSGTXT,1000) NXUNFS, NYUNFS, UNFBOX
      CALL MSGWRT (2)
C                                       Maximum number of visibility
C                                       points which fit in the AP.
      MAXREC = (GRID - UV) / LREC - 5
      IF (MAXREC.LE.10) THEN
         XMAX = - MAXREC * LREC
         IF (MAXREC.GT.0) XMAX = (11 - MAXREC) * LREC
         WRITE (MSGTXT,1060) XMAX
         IRET = 1
         GO TO 995
         END IF
      ILENBU = MIN (NVIS, MAXREC)
C                                       Open visibility file.
      CALL UVPREP ('READ', DISKI, CNOSCI, LUNUVI, FIND1, NVIS,
     *   LREC, ILENBU, JBUFSZ, BUFF1, NIO, IBIND, MAXBLN, IRET)
       IF (IRET.NE.0) GO TO 999
C                                       Load AP values: Maximum u, v.
      IUMAX   =  (NXUNFS / 2)
      IVMAX   =  (NYUNFS / 2 - 1)
C                                       Set AP location and value
      AMAX    = 0
      LTEMP(1) = IVMAX + ((NXUNFS / 2) * NYUNFS)
      TEMP(1) = LTEMP(1)
C                                       Minimum u, v.
      IUMIN   = 0
      IVMIN   = -(NYUNFS / 2)
      AMIN    = 1
      LTEMP(2) = IVMIN
      TEMP(2) = IVMIN
C                                       AP loc, value of Minimum sum wt.
      WMIN = 2
      TEMP(3) = 1.0E-20
C                                       AP loc, value of Maximum sum wt.
      WMAX = 3
      TEMP(4) = 1.0E20
C                                       Put limits in AP
      CALL QPUT (APCORE, TEMP, 0, 10, 2)
      CALL QWD
      CALL QPUT (APCORE, RTEMP, 0, 2, 1)
      CALL QWD
C                                       Scale factors for u,v to cells
      ZSCLU =  1.0 / (RAD2AS / (NXUNFS * ABS (CELLSG(1))))
      ZSCLV =  1.0 / (RAD2AS / (NYUNFS * CELLSG(2)))
C                                       Find frequency of obs
      IF (FREQG(CHUV1).GT.0.0) THEN
         FFRAC = FREQG(CHUV1)
C                                       Else, freq table not set,
      ELSE
         FFRAC = FREQ
         END IF
C                                       Frequency correction factor.
      FFRAC = (FFRAC / FREQUV) - 1.0D0
      SCLV = ZSCLV + FFRAC * ZSCLV
      SCLU = ZSCLU + FFRAC * ZSCLU
C                                       Convert grid maxs to lambda
      UMAX    =  (IUMAX + 0.5) / ABS (SCLU)
      VMAX    =  (IVMAX + 0.5) / ABS (SCLV)
      UUMAXG = (1. - GUARDB(1)) * UMAX
      VVMAXG = (1. - GUARDB(2)) * VMAX
C                                       Init counters
      NPOINT = 0
      CNT = 0
      INPTR = IBIND
C                                       Begin read through data loop
 150  CONTINUE
         IP = IBIND
C                                       Munge Buffer
         DO 200 IU = 1,NIO
            JNPTR = INPTR + ILOCU
C                                       Check if U neg.; if so then flip
C                                       data to other half plane.
            IF (BUFF1(JNPTR).LT.0.0) THEN
C                                       Flip U, V
               BUFF1(JNPTR) = -BUFF1(JNPTR)
               BUFF1(JNPTR+1) = -BUFF1(JNPTR+1)
               END IF
C                                       Scale to cell
            XX = BUFF1(JNPTR) * SCLU
            YY = BUFF1(JNPTR+1) * SCLV
            IYY = YY + SIGN (0.5, YY)
            IYY = MIN ( MAX (IYY, IVMIN), IVMAX)
            IXX = XX + 0.5
            IXX = MIN ( MAX (IXX, IUMIN), IUMAX)
            ICELL = (IXX * NYUNFS) + IYY - IVMIN + 1
C                                       Pass Histogram cell number
C                                       Note equivalence use
            BUFF1(IP)  = RCELL
            IP = IP + LREC
            NPOINT = NPOINT + 1
            INPTR = INPTR + LREC
 200        CONTINUE
C                                       Move to  AP.
         CNT = NPOINT
         NWORD = CNT * LREC
         CALL QPUT (APCORE, BUFF1(IBIND), UV, NWORD, 1)
         NPOINT = 0
C                                       Count using QWTCNT
         IP = UV + WTOFF
         DO 210 JJ = 1,NUMWT
            CALL QWTCNT (APCORE, UV, LREC, IP, LREC, GRID, CNT, NUMBIN,
     *         AMAX, AMIN)
            IP = IP + INCF
 210        CONTINUE
C                                       Read more data
         CALL UVDISK ('READ', LUNUVI, FIND1, BUFF1, NIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1070) IRET
            GO TO 995
            END IF
         INPTR = IBIND
C                                       If more data jump back to beginning
         IF (NIO.GT.0) GO TO 150
C                                       Conjugate U=0 row
C                                       Calc length of V=1 to V=N/2-1
      ITEMP = (NYUNFS/2) - 1
C                                       Cal position of V=N/2
      IVN2 = GRID + NYUNFS - 1
C                                       Add V<0 to V>0
      CALL QVADD (APCORE, GRID+1, 1, IVN2, -1, IVN2, -1, ITEMP)
      CALL QWAIT
C                                       Copy V>0 to V<0
      CALL QVMOV (APCORE, IVN2, -1, GRID+1, 1, ITEMP)
      CALL QWAIT
C                                       Clip
      CALL QVCLIP (APCORE, GRID, 1, WMIN, WMAX, GRID, 1, NUMBIN)
      CALL QWAIT
C                                       Correct data.
      ILENBU = 0
C                                       Open visibility file for writing
      CALL UVPREP ('WRIT', DISKO, CNOSCO, LUNUVO, FIND2, NVIS, LREC,
     *   ILENBU, JBUFSZ, BUFF2, NIO, KBIND, MAXBLN, IRET)
      IF (IRET.NE.0) GO TO 999
      OPTR = KBIND
C                                       Initialize vis. file for read.
      CALL UVINIT ('READ', LUNUVI, FIND1, NVIS, VO, LREC, ILENBU,
     *   JBUFSZ, BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1040) IRET
         GO TO 995
         END IF
C                                       Init Counters
      NPOINT = 0
C                                       AP Loc of U=V=0
      APLOC = GRID + (NYUNFS / 2)
C                                       Loop through data.
 750     CALL UVDISK ('READ', LUNUVI, FIND1, BUFF1, NIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1070) IRET
            GO TO 995
            END IF
         INPTR = IBIND
         IF (NIO.LE.0) GO TO 900
         IP = IBIND
C                                       Copy to output buffer
         CALL RCOPY (NIO*LREC, BUFF1(IBIND), BUFF2(KBIND))
C                                       Munge Buffer
         DO 800 IU = 1,NIO
            JNPTR = INPTR + ILOCU
C                                       Check if U neg.; if so then flip
C                                       data to other half plane.
            IF (BUFF1(JNPTR).LT.0.0) THEN
C                                       Flip U, V
               BUFF1(JNPTR) = -BUFF1(JNPTR)
               BUFF1(JNPTR+1) = -BUFF1(JNPTR+1)
               END IF
C                                       Scale to cell
            XX = BUFF1(JNPTR) * SCLU
            YY = BUFF1(JNPTR+1) * SCLV
            IYY = YY + SIGN (0.5, YY)
            IXX = XX + 0.5
            IYY = MIN (MAX (IYY, IVMIN), IVMAX)
            IXX = MIN (MAX (IXX, IUMIN), IUMAX)
            ICELL = (IXX * NYUNFS) + IYY - IVMIN
C                                       Pass Histogram 0-rel cell number
C                                       Note use of equivalence
            BUFF1(IP)  = RCELL
            IP = IP + 1
            NPOINT = NPOINT + 1
            INPTR = INPTR + LREC
            OPTR = OPTR + LREC
 800        CONTINUE
C                                       Move to AP as INTEGER!
         CNT = NPOINT
         CALL QPUT (APCORE, BUFF1(IBIND), UV, CNT, 1)
C                                       Look up counts
         CALL QWD
         CALL QVINDE (APCORE, GRID, UV, 1, UV, 1, CNT)
         CALL QWR
         CALL QGET (APCORE, BUFF1(IBIND), UV, CNT, 2)
         CALL QWD
         NPOINT = 0
C                                       Loop over buffer
         OPTR = KBIND
         DO 830 II = 1,NIO
C                                       Correct by weights
            IP = OPTR + WTOFF
C                                       Read U,V for grid test
            XX = ABS( BUFF2(OPTR))
            YY = ABS( BUFF2(OPTR+1))
C                                       If inside grid
            IF ((XX.LE.UUMAXG) .AND. (YY.LE.VVMAXG)) THEN
               IF (BUFF1(IBIND+II-1).LE.0.0) BUFF1(IBIND+II-1) = 1.0
C                                       Scale change weight
               DO 820 JJ = 1,NUMWT
                  IF (BUFF2(IP).GT.0.0)
     *               BUFF2(IP) = BUFF2(IP) / BUFF1(IBIND+II-1)
                  IP = IP + INCF
 820              CONTINUE
               END IF
            OPTR = OPTR + LREC
 830        CONTINUE
C                                      Write
         NIOUT = NIO
         CALL UVDISK ('WRIT', LUNUVO, FIND2, BUFF2, NIOUT, KBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1505) IRET
            GO TO 995
            END IF
         OPTR = KBIND
C                                       Read more data
         IF (NIO.GT.0) GO TO 750
 900  NIOUT = 0
      CALL UVDISK ('FLSH', LUNUVO, FIND2, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1505) IRET
         GO TO 995
         END IF
C                                       Close files.
      CALL ZCLOSE (LUNUVI, FIND1, IER)
      CALL ZCLOSE (LUNUVO, FIND2, IER)
      GO TO 999
C                                       Error
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVTBUW: Weighting grid = ',I5,' X ',I5,', Box = ',I3)
 1002 FORMAT ('UVTBUW: Need ',I9,' words AP memory. Scaling by',F8.4)
 1040 FORMAT ('UVTBUW: ERROR',I3,' INIT. VIS. FILE FOR READ')
 1060 FORMAT ('UVTBUW:',I8,' TOO FEW AP WORDS AVAILABLE')
 1070 FORMAT ('UVTBUW: ERROR',I3,' READING VIS RECORD')
 1505 FORMAT ('UVTBUW: ERROR',I3,' WRITING VIS. RECORD')
      END

      SUBROUTINE ZVTPGC (THOSTS, THLEN, NTH, FCB, IERR)
C-----------------------------------------------------------------------
C! close & reopen connection in server (real-TP) to client (virtual-TP)
C# Tape Z2
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZVTPGC opens the connection in TPMON to the remote machine which is
C   running the AIPS Virtual tape code.  This differs from ZVTPO3 in
C   that the socket is already there and an old connection must be
C   closed before a new one can be accepted.  Called by ZVTPRX.
C   Inputs:
C      THOSTS H(*)  up to 512 hosts or pseudo-wildcards
C      THLEN  I     Length of each character string (fixed)
C      NTH    I     Number of hosts to check
C                   (see TPMON.FOR local include for details)
C   Inputs/Outputs:
C      FCB   I(*)   File descriptor
C   Outputs
C      IERR  I      Error: 0 => okay
C   Generic version - stub
C-----------------------------------------------------------------------
      HOLLERITH THOSTS(*)
      INTEGER   THLEN, NTH, FCB(*), IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 8
      WRITE (MSGTXT,1000)
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZVTPGC: REQUIRES DEVELOPMENT; GENERIC IS A STUB')
      END

      SUBROUTINE BAKLDS (OPER, IERR)
C-----------------------------------------------------------------------
C! manage catalog entries for BAKLD as it reads the tape made by BAKTP
C# Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Machine-independent code to call from ZBKLD2
C   Input:
C      OPER   C*4   'UPDT' updates the image header with actual output
C                          image names.
C                   'CREA' create new entry
C   Output:
C      IERR   I      Error return: 0 => okay
C                          1 => couldnt create,no room
C                          2 => no create, duplicate name
C                          3 => no room in catalog
C                          4 => i/o problem on catalog
C                          5 => Other Create errors
C                          6 => no catalog file
C   Common: (in/out)
C      /MAPHDR/ CATBLK  Catalog block
C   Subroutine to create a map file using the parameters in a CATBLK.
C   The file will be cataloged and marked with WRITE status.  The image
C   name parameters incl. physical type must be filled in.  The OUTSEQ
C   default is applied (0 => highest matching+1).  The name must be
C   unique ignoring the physical type.  The extension file areas of
C   the CATBLK are cleared and the "DATE-MAP" string is filled in.
C   This subroutine is a clone of MCREAT.
C-----------------------------------------------------------------------
      CHARACTER OPER*4
      INTEGER   IERR
C
      INTEGER   WBUFF(256), SNO, IER, ITEMP, KERR
      CHARACTER LTYPE*2, STAT*4, PTYPE*2
      LOGICAL   IAMOK
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DBKL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IERR = 7
C                                       update the CB file info:
      IF (OPER.EQ.'UPDT') THEN
         CALL CATIO ('READ', IVOL, CNO, CATBLK, 'REST', WBUFF, IERR)
         CALL CHR2H (12, OUTN, KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, OUTCL, KHIMCO, CATH(KHIMC))
         CATBLK(KIIMS) = OUTS
         CATBLK(KIIMU) = USER
         CALL CATIO ('UPDT', IVOL, CNO, CATBLK, 'CLWR', WBUFF, IERR)
         IERR = 0
C                                       Creat the output file
      ELSE IF (OPER.EQ.'CREA') THEN
C                                       crack the file name stuff:
         INN = BAKREC(35:)
         INCL = BAKREC(48:)
         READ (BAKREC,1000) INS
         CALL H2CHR (12, 1, NAME, OUTN)
         CALL H2CHR (6, 1, CLASS, OUTCL)
         OUTS = SEQ4 + 0.01
         CALL MAKOUT (INN, INCL, INS, INCL, OUTN, OUTCL, OUTS)
C                                       Generate directory entry:
         CALL FILL (256, 0, CATBLK)
         PTYPE = BAKREC(32:33)
         IF (PTYPE.EQ.' ') PTYPE = 'MA'
         CALL CHR2H (2, PTYPE, KHPTYO, CATH(KHPTY))
         CALL CHR2H (12, OUTN, KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, OUTCL, KHIMCO, CATH(KHIMC))
         CATBLK(KIIMS) = OUTS
C                                       Subroutine inserted
C                                       BKLDIR (IVOL, CNO, WBUFF, IERR)
         CALL CATCLR (CATBLK)
C                                      Check for default seqno
         KERR = 0
C                                       get highest sequence #
 5       IF (OUTS.LE.0) THEN
            SNO = 0
            ITEMP = 0
            CNO = 1
            LTYPE = ' '
            CALL CATDIR ('SRCH', ITEMP, CNO, OUTN, OUTCL, SNO, LTYPE,
     *         CATBLK(KIIMU), STAT, WBUFF, IER)
            IF ((IER.GT.0) .AND. (IER.NE.5)) GO TO 25
            OUTS = SNO + 1
            IF (IER.EQ.5) OUTS = 1
            END IF
 10      SNO = OUTS
         IERR = 0
C                                      Is user name unique?
         CNO = 1
         LTYPE = ' '
         ITEMP = 0
         CALL CATDIR ('SRNN', ITEMP, CNO, OUTN, OUTCL, SNO, LTYPE,
     *      CATBLK(KIIMU), STAT, WBUFF, IER)
C                                      Error or found the name
         IF (IER.NE.5) THEN
            IF (IER.EQ.0) THEN
               IERR = 2
               WRITE (MSGTXT,1010) OUTN, OUTCL, SNO
               CALL MSGWRT (8)
               KERR = KERR + 1
               IF (KERR.LT.5) GO TO 5
               GO TO 980
            ELSE
               IF (IER.NE.1) GO TO 25
               IERR = 0
               END IF
            END IF
C                                       Allowed?
 20      IF (.NOT.IAMOK(IVOL,PTYPE)) THEN
            IERR = 1
            WRITE (MSGTXT,1020) OUTN, OUTCL, SNO, IVOL
            GO TO 980
            END IF
C                                      create catalog slot
         CNO = 1
         CATBLK(KIIMS) = SNO
         OUTS = SNO
         CALL CATDIR ('OPEN', IVOL, CNO, OUTN, OUTCL, SNO, PTYPE,
     *      CATBLK(KIIMU), STAT, WBUFF, IER)
         IF (IER.EQ.0) GO TO 30
C                                      No catalog file
            IF (IER.NE.1) GO TO 22
               IERR = 6
               GO TO 975
C                                      No room in catalog
 22         IF (IER.NE.5) GO TO 25
               WRITE (MSGTXT,1022) IVOL
               IERR = 3
               GO TO 980
C                                      I/O error in catalog
 25         CONTINUE
               WRITE (MSGTXT,1025) IER
               IERR = 4
               GO TO 980
C                                       We do not create the file here
 30      WRITE (MSGTXT,1030) OUTN, OUTCL, SNO, PTYPE, IVOL, CNO
         CALL MSGWRT (2)
         GO TO 999
C                                      Errors:
 975     WRITE (MSGTXT,1975)
C
 980     CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (54X,I4)
 1010 FORMAT ('BKLDIR: DUPLICATE NAME ',A12,'.',A6,'.',I4,
     *   ' - WILL RENUMBER')
 1020 FORMAT ('BLKDIR: ',A12,'.',A6,'.',I4,' PROHIBITED ON DISK',I3)
 1022 FORMAT ('BKLDIR: CATALOG FULL ON VOL ',I1)
 1025 FORMAT ('BKLDIR: CATDIR IO ERROR=',I4)
 1030 FORMAT ('Create ',A12,'.',A6,'.',I4,' (',A2,')  on disk',I2,
     *   ' cno',I5)
 1975 FORMAT ('UNABLE TO CREATE SLOT ON SPECIFIED VOLUME')
      END

      SUBROUTINE CHNNCP (INVER, OUTVER, LUNOLD, LUNNEW, VOLOLD,
     *   VOLNEW, CNOOLD, CNONEW, CATOLD, CATNEW, BIF, EIF, NAVG, FREQID,
     *   SFOFF, BUFF1, FOFF, ISBAND, FINC, IRET)
C-----------------------------------------------------------------------
C! Copies selected portions of the IF table
C# EXT-util Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CHNNCP copies selected portions of a Channel (IF) table extension
C   file.
C   Inputs:
C      LUNOLD   I        LUN for old file
C      LUNNEW   I        LUN for new file
C      VOLOLD   I        Disk number for old file.
C      VOLNEW   I        Disk number for new file.
C      CNOOLD   I        Catalog slot number for old file
C      CNONEW   I        Catalog slot number for new file
C      BIF      I        First IF to copy to output.
C      EIF      I        Last IF to copy.
C      NAVG     I        average channels
C      FREQID   I        FREQ ID to copy.
C                        If an FQ table exists and FREQID .le. 0 then
C                        if there is only one row in the FQ table, that
C                        row is copied; if there are multiple rows an
C                        error message is returned from CHNDAT.
C      CATOLD   I(256)   Catalog header for old file.
C      SFOFF    D(*)     Frequency offsets to be added to FQ table
C                        offsets in the output FQ table.  These are
C                        usually those of the 1 source in the output
C                        file taken from the SU table in the input.
C   In/out:
C      INVER    I        Version number to copy, 0 => copy all.
C      OUTVER   I        Version number on output file, if more than one
C                        copied (INVER=0) this will be the number of the
C                        first file.  If OUTVER = 0, it will be taken as
C                        1 higher than the previous highest version.
C      CATNEW   I(256)   Catalog header for new file.
C   Output:
C      BUFF1    I(512)   Work buffer
C      FOFF     D(*)     Frequency table.  Must be >= MAXIF
C      ISBAND   I(*)     Sideband table.  Must be >= MAXIF
C      FINC     R(*)     Channel increment table  Must be >= MAXIF
C      IRET     I        Return error code  0 => ok
C                           6 => asked for too many IFs.
C                           other = CHNDAT error.
C-----------------------------------------------------------------------
      INTEGER   INVER, OUTVER, LUNOLD, LUNNEW, VOLOLD, VOLNEW,
     *   CNOOLD, CNONEW, BIF, EIF, BUFF1(*), ISBAND(*), CATNEW(256),
     *   CATOLD(256), NAVG, FREQID, IRET
      DOUBLE PRECISION SFOFF(*), FOFF(*)
      REAL      FINC(*)
      INTEGER   NIF, IEIF, IBIF
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Read all IFs from old
C                                       CH/FQ table
      CALL CHNDAT ('READ', BUFF1, VOLOLD, CNOOLD, INVER, CATOLD, LUNOLD,
     *   NIF, FOFF, ISBAND, FINC, BNDCOD, FREQID, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Check number
      IBIF = MAX (BIF, 1)
      IEIF = MAX (EIF, IBIF)
      IF (NIF.LT.IEIF) THEN
         IRET = 6
         WRITE (MSGTXT,1030) IEIF, NIF
         GO TO 990
         END IF
C                                       Offset
      NAVG = MAX (NAVG, 1)
      DO 40 NIF = IBIF,IEIF
         FOFF(NIF) = FOFF(NIF) + SFOFF(NIF)
         FINC(NIF) = FINC(NIF) * NAVG
 40      CONTINUE
C                                       Number of output IFs.
      NIF = IEIF - IBIF + 1
C                                       Write new FQ table for
C                                       selected IFs
      CALL CHNDAT ('WRIT', BUFF1, VOLNEW, CNONEW, OUTVER, CATNEW,
     *   LUNNEW, NIF, FOFF(IBIF), ISBAND(IBIF), FINC(IBIF),
     *   BNDCOD(IBIF), FREQID, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1040) IRET
         GO TO 990
         END IF
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CHNNCP: ERROR',I5,' READING OLD IF TABLE')
 1030 FORMAT ('CHNNCP: REQUESTED TOO MANY IFS : ',I4,'>',I4)
 1040 FORMAT ('CHNNCP: ERROR',I5,' WRITING NEW IF TABLE')
      END

C   "Q-routine" utility module
C-----------------------------------------------------------------------
C! Object Oriented AIPS Fortran "Q" utility module.
C# Ext-util Utility Object-Oriented
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2012, 2015, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   The routines in this module mostly copy data to and from "AP" memory
C   and will only work for the pseudo AP as they directly access "AP"
C   memory.  The other one implements the recommended method for
C   "reserving" the AP to a particular subroutine.
C   Public functions:
C
C   APOBJ (op, subrou, ierr)
C      Reserve or free the AP for a particular subroutine
C
C   AP2IMG (ap, image, plane, ierr)
C      Copy an image plane from "AP" memory to an image object.
C   IMG2AP (image, plane, ap, ierr)
C      Copy an image plane from an image object to "AP" memory.
C   AP2UV (ap, uv, nv, lv, nr, ierr)
C      Copy a set of visibilities from the "AP" to uv object.
C   UV2AP (uv, ap, nv, lv, nr, ierr)
C      Copy a set of visibilities from a uv object to the "AP".
C
C-----------------------------------------------------------------------
      SUBROUTINE APOBJ (OP, SUBROU, IERR)
C-----------------------------------------------------------------------
C   reserve or free the AP using the APDEVICE object
C   Inputs:
C      OP       C*?   'OPEN' or 'RESE..'  reserve the space
C                     'CLOS..' or 'FREE'  free the space
C      SUBROU   C*?   Subroutine name
C   Outputs:
C      IERR     I     Error code
C-----------------------------------------------------------------------
      CHARACTER OP*(*), SUBROU*(*)
      INTEGER   IERR
C
      CHARACTER APDEVI*32, STATUS*4
      INTEGER   JERR
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      APDEVI = 'APdevice for ' // SUBROU
C                                       open
      STATUS = OP
      IF ((STATUS.EQ.'OPEN') .OR. (STATUS.EQ.'RESE')) THEN
         CALL APDCRE (APDEVI, IERR)
         IF (IERR.NE.0) CALL APDOPN (APDEVI, STATUS, IERR)
C                                       close
      ELSE IF ((STATUS.EQ.'CLOS') .OR. (STATUS.EQ.'FREE')) THEN
         CALL APDCLO (APDEVI, IERR)
         CALL APDDES (APDEVI, JERR)
         IERR = MAX (IERR, JERR)
C                                       bad op
      ELSE
         MSGTXT = 'APOBJ: UNRECOGNIZED OP = ''' // OP // ''''
         CALL MSGWRT (8)
         IERR = 2
         END IF
C
 999  RETURN
      END
      SUBROUTINE AP2IMG (APCORE, AP, IMAGE, PLANE, IERR)
C-----------------------------------------------------------------------
C   "Q" utility routine
C   Copy an image plane from "AP" memory to an image object.
C   Inputs:
C      AP      I    0 rel "AP" memory base address of image plane
C      IMAGE   C*?  Name of IMAGE object
C      PLANE   I(7) Plane in image (blc of image)
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      CHARACTER IMAGE*(*)
      INTEGER   AP, PLANE(7), IERR
C
      LONGINT   IAP
      INTEGER   TYPE, DIM(3), NAXIS(7), BLC(7), TRC(7), DUMMY
      CHARACTER ACCESS*8, CDUMMY*1
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DAPC.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Set image array access to PLANE
      ACCESS = 'PLANE'
      DIM(1) = LEN (ACCESS)
      DIM(2) = 1
      DIM(3) = 0
      CALL ARPPUT (IMAGE, 'ACCESS', OOACAR, DIM, DUMMY, ACCESS, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       set window for access
      CALL ARDGET (IMAGE, 'NAXIS', TYPE, DIM, NAXIS, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Plane = BLC
      PLANE(1) = 1
      PLANE(2) = 1
      CALL COPY (7, PLANE, BLC)
      CALL COPY (7, PLANE, TRC)
      TRC(1) = NAXIS(1)
      TRC(2) = NAXIS(2)
C                                       Save new window
      CALL ARDPUT (IMAGE, 'BLC', OOAINT, DIM, BLC, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL ARDPUT (IMAGE, 'TRC', OOAINT, DIM, TRC, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Transfer
      IAP = AP + PSAPOF
C                                       Plane
      DIM(1) = 10
      DIM(2) = 10
      DIM(3) = 0
      CALL ARDWRI (IMAGE, DIM, APCORE(IAP), IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Close array
      CALL ARRCLO (IMAGE, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Reset image array access.
      ACCESS = 'ROW'
      DIM(1) = LEN (ACCESS)
      DIM(2) = 1
      CALL ARPPUT (IMAGE, 'ACCESS', OOACAR, DIM, DUMMY, ACCESS, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'AP2IMG: ERROR COPYING FROM AP:' // IMAGE
      CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE IMG2AP (APCORE, IMAGE, PLANE, AP, IERR)
C-----------------------------------------------------------------------
C   "Q" Utility routine
C   Copy an image plane from an image object to "AP" memory.
C   Inputs:
C      AP      I    0 rel "AP" memory base address of image plane
C      IMAGE   C*?  Name of image object
C      PLANE   I(7) Plane in image (blc of image)
C   Output:
C      IERR    I    Error code: 0 => OK
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      CHARACTER IMAGE*(*)
      INTEGER   AP, PLANE(7), IERR
C
      LONGINT   IAP
      INTEGER   TYPE, DIM(7), NAXIS(7), BLC(7), TRC(7), DUMMY
      CHARACTER ACCESS*8, CDUMMY*1
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DAPC.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Set image array access to plane
      ACCESS = 'PLANE'
      DIM(1) = LEN (ACCESS)
      DIM(2) = 1
      DIM(3) = 0
      CALL ARPPUT (IMAGE, 'ACCESS', OOACAR, DIM, DUMMY, ACCESS, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       set window for access
      CALL ARDGET (IMAGE, 'NAXIS', TYPE, DIM, NAXIS, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Plane = BLC
      PLANE(1) = 1
      PLANE(2) = 1
      CALL COPY (7, PLANE, BLC)
      CALL COPY (7, PLANE, TRC)
      TRC(1) = NAXIS(1)
      TRC(2) = NAXIS(2)
C                                       Save new window
      CALL ARDPUT (IMAGE, 'BLC', OOAINT, DIM, BLC, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL ARDPUT (IMAGE, 'TRC', OOAINT, DIM, TRC, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Transfer
      IAP = AP + PSAPOF
      CALL ARDRED (IMAGE, DIM, APCORE(IAP), IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Close array
      CALL ARRCLO (IMAGE, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Reset image array access
      ACCESS = 'ROW'
      DIM(1) = LEN (ACCESS)
      DIM(2) = 1
      CALL ARPPUT (IMAGE, 'ACCESS', OOACAR, DIM, DUMMY, ACCESS, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'IMG2AP: ERROR COPYING TO AP:' // IMAGE
      CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE AP2UV (APCORE, AP, UV, NV, LV, NR, IERR)
C-----------------------------------------------------------------------
C   "Q" utility routine
C   Copy a set of visibilities from the "AP" to uv object.
C   Inputs:
C      AP      I    0 rel "AP" memory base address of image plane
C      UV      C*?  Name of uvdata object
C      NV      I    Number of visibilities to transfer.
C      LV      I    Length in words of a visibility record.
C      NR      I    Number of random parameters
C   Output:
C      IERR    I    Error code: 0 => OK
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      CHARACTER UV*(*)
      INTEGER   AP, NV, LV, NR, IERR
C
      INTEGER   LOOP, IV
      LONGINT   IAP
      INCLUDE 'INCS:PUVD.INC'
      REAL      RPARM(20), VIS(3*MAXCIF)
      SAVE VIS
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DAPC.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
      IAP = AP + PSAPOF
      DO 100 LOOP = 1,NV
         DO 10 IV = 1,NR
            RPARM(IV) = APCORE(IAP+IV)
 10         CONTINUE
         DO 20 IV = NR+1,LV
            VIS(IV) = APCORE(IAP+IV)
 20         CONTINUE
         CALL UVWRIT (UV, RPARM, VIS, IERR)
         IF (IERR.NE.0) GO TO 990
         IAP = IAP + LV
 100     CONTINUE
      GO TO 999
C                                       Error
 990  MSGTXT = 'AP2UV: ERROR COPYING FROM AP:' // UV
      CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE UV2AP (APCORE, UV, AP, NV, LV, NR, IERR)
C-----------------------------------------------------------------------
C   "Q" utility routine
C   Copy a set of visibilities from the "AP" to uv object.
C   Inputs:
C      UV      C*?  Name of uvdata object
C      AP      I    0 rel "AP" memory base address of image plane
C      NR      I    Number of random parameters
C   Input/Output:
C      NV      I    Number of visibilities to transfer. Reset if end of
C                   data found.
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      CHARACTER UV*(*)
      INTEGER   AP, NV, LV, NR, IERR
C
      INTEGER   LOOP, IV
      LONGINT   IAP
      INCLUDE 'INCS:PUVD.INC'
      REAL      RPARM(20), VIS(3*MAXCIF)
      SAVE VIS
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DAPC.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
      IAP = AP + PSAPOF - 1
      DO 100 LOOP = 1,NV
         CALL UVREAD (UV, RPARM, VIS, IERR)
C                                       End of data?
         IF (IERR.LT.0) GO TO 700
         IF (IERR.NE.0) GO TO 990
         DO 10 IV = 1,NR
            APCORE(IAP+IV) = RPARM(IV)
 10         CONTINUE
         DO 20 IV = NR+1,LV
            APCORE(IAP+IV) = VIS(IV-NR)
 20         CONTINUE
         IAP = IAP + LV
 100     CONTINUE
      GO TO 999
C                                       End of data encountered
 700  NV = LOOP - 1
      IERR = 0
      GO TO 999
C                                       Error
 990  MSGTXT = 'UV2AP: ERROR COPYING TO AP:' // UV
      CALL MSGWRT (8)
C
 999  RETURN
      END

      SUBROUTINE ZI8IL (NVAL, NP, INB, OUTB)
C-----------------------------------------------------------------------
C! convert 8-bit unsigned integers in buffer to local integers
C# Binary
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Convert 8-bit unsigned binary numbers to local integers.  This must
C   work even when the input and output buffers are the same.
C   Inputs:
C      NVAL   I         Number of 8-bit values to convert
C      NP     I         Starting position in the input buffer counting
C                       from 1 in units of 8-bit values
C      INB    I(*)      Input buffer
C   Output:
C      OUTB   I(NVAL)   Output buffer
C   Generic version - for NBITWD = n*8 uses ZGETCH, else is stubbed
C-----------------------------------------------------------------------
      INTEGER   NVAL, NP, INB(*), OUTB(*)
C
      INTEGER   I, J, K, I1, I2, L
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (NVAL.LE.0) GO TO 999
      L = NBITWD / 8
      IF (L*8.NE.NBITWD) THEN
         WRITE (MSGTXT,1000) NBITWD
         CALL MSGWRT (9)
         STOP 'ZI8IL NEEDS LOCAL DEVELOPMENT'
      ELSE
         J = NP + NVAL - 1
         K = NVAL
         DO 30 I = 1,NVAL
            I1 = (J - 1) / L + 1
            I2 = MOD (J-1, L) + 1
            CALL ZGETCH (OUTB(K), INB(I1), I2)
            J = J - 1
            K = K - 1
 30         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZI8IL NEEDS LOCAL DEVELOPMENT FOR NBITWD =',I7)
      END

      SUBROUTINE WTFUNC (APCORE, UNFBOX, NBXFUN, IAPADD, BUFF)
C-----------------------------------------------------------------------
C! Computes weighting convolution functions and puts into AP
C# UV-util AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Computes weighting convolution functions and puts into AP
C   Inputs:
C      UNFBOX   I      Support radius (cells)
C      NBXFUN   I      -4 -> 4 function shape and type (see below)
C      IAPADD   I      0-relative address in AP for func(0,0)
C   In/Out
C      BUFF     R(*)   Scratch buffer
C   Functions are
C      1 : Pill box      f(x) = 1             (x <= UVBOX)
C      2 : linear        f(x) = 1 - x / (UVBOX+1)
C      3 : exponential   f(x) = exp(-2(x/(UVBOX+1))
C      4 : Gaussian      f(x) = exp(-4(x/(UVBOX+1)**2)
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   UNFBOX, NBXFUN, IAPADD
      REAL      BUFF(*)
C
      INTEGER   LF, I, J, N, LAPADD
      REAL      X, Y, R, SCALE, EDGE, T, F
C-----------------------------------------------------------------------
C                                       null case
      IF (UNFBOX.LE.0) THEN
         BUFF(1) = 1.0
         CALL QPUT (APCORE, BUFF, IAPADD, 1, 2)
C                                       some real diameter
      ELSE
         LF = ABS (NBXFUN)
         N = UNFBOX + 1
         SCALE = 1.0 / N
         LAPADD = IAPADD
C                                       Circular
         IF (LF.GE.0) THEN
            EDGE = UNFBOX + 0.05
C                                       Linear
            IF (LF.EQ.2) THEN
               DO 25 I = 1,N
                  Y = I - 1.0
                  DO 20 J = 1,N
                     X = J - 1.0
                     R = SQRT (X*X + Y*Y)
                     IF (R.LE.EDGE) THEN
                        BUFF(J) = MAX (0.0, 1.0 - R * SCALE)
                     ELSE
                        BUFF(J) = 0.0
                        END IF
 20                  CONTINUE
                  CALL QPUT (APCORE, BUFF, LAPADD, N, 2)
                  LAPADD = LAPADD + N
 25               CONTINUE
C                                       Exponential
            ELSE IF (LF.EQ.3) THEN
               DO 35 I = 1,N
                  Y = I - 1.0
                  DO 30 J = 1,N
                     X = J - 1.0
                     R = SQRT (X*X + Y*Y)
                     IF (R.LE.EDGE) THEN
                        BUFF(J) = EXP (- 2.0 * R * SCALE)
                     ELSE
                        BUFF(J) = 0.0
                        END IF
 30                  CONTINUE
                  CALL QPUT (APCORE, BUFF, LAPADD, N, 2)
                  LAPADD = LAPADD + N
 35               CONTINUE
C                                       Gaussian
            ELSE IF (LF.EQ.4) THEN
               DO 45 I = 1,N
                  Y = I - 1.0
                  DO 40 J = 1,N
                     X = J - 1.0
                     R = SQRT (X*X + Y*Y)
                     IF (R.LE.EDGE) THEN
                        T = 2.0 * R * SCALE
                        BUFF(J) = EXP (- T*T)
                     ELSE
                        BUFF(J) = 0.0
                        END IF
 40                  CONTINUE
                  CALL QPUT (APCORE, BUFF, LAPADD, N, 2)
                  LAPADD = LAPADD + N
 45               CONTINUE
C                                       Pill-box
            ELSE
               DO 55 I = 1,N
                  Y = I - 1.0
                  DO 50 J = 1,N
                     X = J - 1.0
                     R = SQRT (X*X + Y*Y)
                     IF (R.LE.EDGE) THEN
                        BUFF(J) = 1.0
                     ELSE
                        BUFF(J) = 0.0
                        END IF
 50                  CONTINUE
                  CALL QPUT (APCORE, BUFF, LAPADD, N, 2)
                  LAPADD = LAPADD + N
 55               CONTINUE
               END IF
C                                       Square
         ELSE
C                                       Linear
            IF (LF.EQ.2) THEN
               DO 125 I = 1,N
                  Y = I - 1.0
                  F = MAX (0.0, 1.0 - Y * SCALE)
                  DO 120 J = 1,N
                     X = J - 1.0
                     T = MAX (0.0, 1.0 - X * SCALE)
                     BUFF(J) = F * T
 120                 CONTINUE
                  CALL QPUT (APCORE, BUFF, LAPADD, N, 2)
                  LAPADD = LAPADD + N
 125              CONTINUE
C                                       Exponential
            ELSE IF (LF.EQ.3) THEN
               DO 135 I = 1,N
                  Y = I - 1.0
                  F = EXP (- 2.0 * Y * SCALE)
                  DO 130 J = 1,N
                     X = J - 1.0
                     T = EXP (- 2.0 * X * SCALE)
                     BUFF(J) = F * T
 130                 CONTINUE
                  CALL QPUT (APCORE, BUFF, LAPADD, N, 2)
                  LAPADD = LAPADD + N
 135              CONTINUE
C                                       Gaussian
            ELSE IF (LF.EQ.4) THEN
               DO 145 I = 1,N
                  Y = I - 1.0
                  F = EXP (- 4.0 * Y * Y * SCALE * SCALE)
                  DO 140 J = 1,N
                     X = J - 1.0
                     T = EXP (- 4.0 * X * X * SCALE * SCALE)
                     BUFF(J) = F * T
 140                 CONTINUE
                  CALL QPUT (APCORE, BUFF, LAPADD, N, 2)
                  LAPADD = LAPADD + N
 145              CONTINUE
C                                       Pill-box
            ELSE
               CALL RFILL (N, 1.0, BUFF)
               DO 155 I = 1,N
                  CALL QPUT (APCORE, BUFF, LAPADD, N, 2)
                  LAPADD = LAPADD + N
 155              CONTINUE
               END IF
            END IF
         END IF
C
      CALL QWD
C
 999  RETURN
      END

      SUBROUTINE QGRD4 (UV, VIS, WT, GRID, CONX, CONY, NO2, M, LROW,
     *   ROW, INC, NVIS)
C-----------------------------------------------------------------------
C! Convex Pseudo AP routine: Convolve UV data onto a grid.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Vector compiler version.
C   Depends on gather/scatter and will probably be slower than the
C   scalar version on scalar machines.
C   The vector length in the vectorized loop here will typically be 49
C   but will never be less than 9.
C   Convolves visibility data onto a grid.
C   A single channel is gridded at a time.
C   It assumes that NO points lie within one half the convolving
C   function support size of the outside edge.
C   Also assumes that the convolving support function contains no more
C   than 512 pixels (32*16).
C   Inputs:
C      UV    I  Location of (u,v) values in cells.
C      VIS   I  Location of (complex) visibilities.
C      WT    I  Weight for data. Assumes any tapering
C               has already been done.
C      GRID  I  base address of gridded data.
C               Order assumed to be the following
C               for each of the M rows:
C                1) 2 * LROW visibilities
C      CONX  I  base address of X convolving fn.
C      CONY  I  base address of Y convolving fn.
C      NO2   I  INT( (# cells used on a row) / 2 )
C      M     I  number of rows kept in the AP.
C      LROW  I  length of a row ( max. X).
C      ROW   I  address of lowest central row number.
C               (contents of ROW subtracted from Y)
C      INC   I  increment for UV, VIS and WT
C      NVIS  I  number of visibilities to grid.
C   In the above, X refers to rows and y to columns
C   in the gridded data, NOT on the sky.  The total
C   numbers of rows and cells used on a row should be odd.
C   All AP memory I/O values are assumed floating.
C   It is assumed that all values of v correspond to row M/2.
C-----------------------------------------------------------------------
      INTEGER   UV, VIS, WT, GRID, CONX,  CONY, NO2, M, LROW, ROW, INC,
     *   NVIS,  N, INCR, HAF, IX, IY, LOOP, LIMIT
      INTEGER   JUV, JVIS, JWT, JGRID, JCONX, JCONY, JCX, JCY,
     *   JG, JJLOOP, IRND, ICX, ICY, IG
      INTEGER   INCX(121), INCY(121), INCG(121), OLDM, OLDN, OLDLRO
      REAL      AIM, RE, X, XX, XWT, Y, WWT, RROW
      INCLUDE 'INCS:DAPC.INC'
      SAVE OLDM, OLDN, OLDLRO, INCX, INCY, INCG
C-----------------------------------------------------------------------
      IRND(XX) = INT (XX + SIGN (0.5, XX))
C                                        Convert addresses to 1 rel.
      JUV = UV + 1
      JVIS = VIS + 1
      JWT = WT + 1
      JGRID = GRID + 1
      JCONX = CONX + 1
      JCONY = CONY + 1
      RROW = APCORE(ROW+1)
      N = NO2 * 2 + 1
      HAF = LROW / 2 - NO2
      INCR = 2 * LROW
      LIMIT = N * M
      IF ((OLDN.EQ.N) .AND. (OLDM.EQ.M) .AND. (OLDLRO.EQ.LROW)) GO TO 70
C                                       Fill increment tables
      OLDN = N
      OLDM = M
      OLDLRO = LROW
      DO 50 LOOP = 1,LIMIT
         IY = (LOOP-1) / N
         IX = (LOOP-1) - IY * N
         INCX(LOOP) = IX * 100
         INCY(LOOP) = IY * 100
         INCG(LOOP) = IX * 2 + IY * INCR
 50      CONTINUE
C                                       Loop over visibilities.
C                                       This loop contains dependencies.
      INCLUDE 'INCS:ZVD.INC'
 70   DO 300 JJLOOP = 1,NVIS
C                                        Check weight.
         XWT = MAX (0.0, APCORE(JWT))
C                                        Determine location.
         X = APCORE(JUV+1)
         Y = APCORE(JUV)
C                                        Deter. conv. fn loc.
         JCX = IRND (100. * (IRND (X) - X - 0.5))
         JCY = IRND (100. * (IRND (Y) - Y - 0.5))
         JCX = JCONX + 100 + JCX
         JCY = JCONY + 100 + JCY
C                                        Determine grid loc.
         Y = Y - RROW
         JG = IRND (X) + IRND (Y) * LROW
         JG = JGRID + 2 * (JG + HAF)
C                                        Get visibility
         RE = APCORE(JVIS) * XWT
         AIM = APCORE(JVIS+1) * XWT
C                                        Gridding loop
      INCLUDE 'INCS:ZVND.INC'
         DO 200 LOOP = 1,LIMIT
            ICX = JCX + INCX(LOOP)
            ICY = JCY + INCY(LOOP)
            IG = JG + INCG(LOOP)
C                                        Sum to grid.
            WWT = APCORE(ICX) * APCORE(ICY)
            APCORE(IG) = APCORE(IG) + WWT * RE
            APCORE(IG+1) = APCORE(IG+1) + WWT * AIM
 200        CONTINUE
C                                       Update for next vis.
         JUV = JUV + INC
         JVIS = JVIS + INC
         JWT = JWT + INC
 300     CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'DFTQU.INC'
C                                       Local include for DFTQU
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXSAM
      PARAMETER (MAXSAM=10000)
C
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMEO(3), XCLAOU(2), XSOUR(4),
     *   XCALC(1)
      REAL      XSIN, XDISIN, XSOU, XDISOU, XIMSIZ(2), UVRANG(2),
     *   TIMER(8), SHIFT(2), BPARM(10), XQUAL, XBAND, XFREQ, XFQID,
     *   XSUBA, XBIF, XEIF, XBCHAN, XECHAN, XANT(50), XBASL(50), XDOCAL,
     *   XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER,
     *   XSMOTH(3), BADD(10)
      DOUBLE PRECISION FOFF(MAXIF), DXC, DYC, DZC, RAS, DECS
      REAL      BUFF1(UVBFSS), TIMR(MAXSAM), DFT(MAXSAM,3), TBEG, TFIN,
     *   ERROR(MAXSAM,3), XYSCL(2,3), XYOFF(2,3), AREA(2), OFREQ, FRPIX,
     *   TAVG, XNUL, FINC(MAXIF), VRANGE(2,2), XY(2,3)
      CHARACTER NAMEIN*12, CLAIN*6, NAMEOU*12, CLAOU*6
      INTEGER   SEQIN, DISKIN, LUNI, INDI, LABEL, VER, NBASL, BCNT,
     *   TESTEM(2), JBUFSZ, GRCHN, TVCHN, TVCORN(4), NPARMS, IPLOT,
     *   FREQID, KNCS, KNCF, KNCIF, LTYPE, NPOL, NXANT, IXANT(50),
     *   NXBASL, IXBASL(50), NX, NY, SCRTCH(256), CATOLD(256), SEQOU,
     *   DISKOU, OLDCNO
      LOGICAL   UVREV, SCALEM(2), NOUVR, PACKED, DESEL
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMEO, XCLAOU,
     *   XSOU, XDISOU, XIMSIZ, UVRANG, TIMER, SHIFT, BPARM, XSOUR,
     *   XQUAL, XCALC, XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF, XBCHAN,
     *   XECHAN, XANT, XBASL, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER,
     *   XFLAG, XDOBND, XBPVER, XSMOTH, BADD
      COMMON /BUFRS/ BUFF1, JBUFSZ
      COMMON /FTPCOM/ FOFF, CATOLD, DXC, DYC, DZC, RAS, DECS, FINC,
     *   TIMR, DFT, ERROR, TBEG, TFIN, TAVG, XYSCL, XYOFF, OFREQ, FRPIX,
     *   AREA, XNUL, UVREV, SCALEM, NOUVR, NBASL, BCNT, SEQIN,
     *   DISKIN, SEQOU, DISKOU, LUNI, INDI, LABEL, VER, TESTEM, GRCHN,
     *   TVCHN, TVCORN, NPARMS, IPLOT, FREQID, PACKED, KNCS, KNCF,
     *   KNCIF, LTYPE, NPOL, VRANGE, NXANT, IXANT, NXBASL, IXBASL,
     *   DESEL, NX, NY, XY, SCRTCH, OLDCNO
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMEOU, CLAOU
C                                                          End DFTQU.
LOCAL END
      PROGRAM DFTQU
C-----------------------------------------------------------------------
C! Computes summed uv data for a position in the sky in Q & U vs time
C# UV polarization
C-----------------------------------------------------------------------
C;  Copyright (C) 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DFTQU creates a 'PL' extension file for display of the DFT of the
C   Qpol and Upol visibilities for an arbitrary position in the sky.
C   Color is used to indicate time.
C   NOTE 1: DFTQU wants the first key of the sort order of the UV data
C           base to be TIME.
C   NOTE 2: At present, DFTQU will only plot up to 10000 bins.C
C   Inputs:
C     INNAME         NAMEIN        Name of input UV data.
C     INCLASS        CLAIN         Class of input UV data.
C     INSEQ          SEQIN         Seq. of input UV data.
C     INDISK         DISKIN        Disk number of input VU data.
C     UVRANGE....Range of UV projected spacings to include (Klambda)
C     TIMER......Selection parameters:
C        1 = Start IAT day (day 0 = first day in data base)
C        2 = Start IAT hour
C        3 = Start IAT minute
C        4 = Start IAT second
C        5 = Stop IAT day (day 0 = first day in data base)
C        6 = Stop IAT hour
C        7 = Stop IAT minute
C        8 = Stop IAT second
C        9 = Offset in right ascension (asec)
C       10 = Offset in declination (asec)
C     BPARM......Control parameters:
C        1 = Change color each BP(1) averaging intervals
C        2 = averaging interval in sec
C        3 = Do not autoscale if > zero, use following values:
C        4 = Minimum of X-axis,
C        5 = Maximum of X-axis,
C        6 = Minimum of Y-axis.
C        7 = Maximum of Y-axis,
C        8 = X to Y ratio
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, NWORDS
      REAL      IMAGE(2)
      LONGINT   PIMAGE
      INCLUDE 'DFTQU.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'DFTQU '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL FTPIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Do DFT's
      CALL ACDFT (IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Grid image
      NWORDS = (NX * NY * 3 - 1) / 1024 + 4
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, IMAGE, PIMAGE, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'COULD NOT GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 995
         END IF
      CALL GRDFT (NX, NY, IMAGE(1+PIMAGE), IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Plot 'em up
      CALL OUTFT (NX, NY, IMAGE(1+PIMAGE), IRET)
C                                       Close down
 995  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE FTPIN (PRGM, JERR)
C-----------------------------------------------------------------------
C   FTPIN gets input parameters for DFTQU .
C   Inputs:
C      PRGM    C*6    Program name
C   Output:
C      JERR    I      Error code: 0 => ok, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   JERR
C
      INCLUDE 'DFTQU.INC'
      CHARACTER BNDCOD(MAXIF)*8, CSTOK(11)*4
      INTEGER   IUSER, I, IERR, IROUND, FQVER, NIF, CHBUFF(512),
     *   ISBAND(MAXIF), LUNCH
      REAL      CATR(256), RPARM(20)
      LOGICAL   T
      DOUBLE PRECISION RA0, DEC0, CATD(128)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (CATBLK, CATR, CATD)
      DATA T /.TRUE./
      DATA CSTOK /'RR', 'LL', 'I', 'V', 'Q', 'U', 'VV', 'HH', 'HALF',
     *   'IQU', 'FPA'/
C-----------------------------------------------------------------------
C                                       Init IO et al.
      CALL ZDCHIN (T, BUFF1)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
      VER = MAXSAM
C                                       Get input parameters.
      NPARMS = 173
      CALL GTPARM (PRGM, NPARMS, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         JERR = 8
         RQUICK = .TRUE.
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR, 'GETTING USER ADVERB VALUES'
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      IUSER = NLUSER
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      SEQOU = IROUND (XSOU)
      DISKOU = IROUND (XDISOU)
      TBEG = TIMER(1) + (TIMER(2)+(TIMER(3)+TIMER(4)/60.)/60.)/24.
      TFIN = TIMER(5) + (TIMER(6)+(TIMER(7)+TIMER(8)/60.)/60.)/24.
      IF (TFIN.LE.TBEG) TFIN = 1.E6
      IF (TBEG.LE.0.0) TBEG = -1.E6
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMEO, NAMEOU)
      CALL H2CHR (6, 1, XCLAOU, CLAOU)
      STOKES ='QU'
      NPOL = 2
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (16, 1, XSOUR, SOURCS(1))
      SELQUA = IROUND (XQUAL)
C                                       Antennas
      CALL SETANT (50, XANT, XBASL, NXANT, NXBASL, IXANT, IXBASL, DESEL)
      IF ((NXANT.LE.0) .AND. (NXBASL.GT.0)) THEN
         CALL COPY (NXBASL, IXBASL, IXANT)
         NXANT = NXBASL
         NXBASL = 0
         END IF
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = .FALSE.
      CALL RCOPY (8, TIMER, TIMRNG)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
      BCHAN = XBCHAN
      ECHAN = XECHAN
      BIF = XBIF
      EIF = XEIF
C                                       Test UV range
      NOUVR = .FALSE.
      IF ((UVRANG(1).GE.UVRANG(2)) .OR. (UVRANG(1).LT.0.0)) THEN
         NOUVR = .TRUE.
         UVRANG(1) = 0.0
         UVRANG(2) = 1.E10
         END IF
      UVRNG(1) = UVRANG(1)
      UVRNG(2) = UVRANG(2)
      UVRANG(1) = UVRANG(1) * 1.0E3
      UVRANG(2) = UVRANG(2) * 1.0E3
C                                       Autoscale ?
      SCALEM(1) = (BPARM(3).LE.0.0) .OR. (BPARM(4).EQ.BPARM(5))
      SCALEM(2) = (BPARM(3).LE.0.0) .OR. (BPARM(6).EQ.BPARM(7))
      TESTEM(1) = 1
      IF (BPARM(4).GT.BPARM(5)) TESTEM(1) = -1
      IF ((BPARM(3).EQ.0.0) .OR. (BPARM(4).EQ.BPARM(5))) TESTEM(1) = 0
      TESTEM(2) = 1
      IF (BPARM(6).GT.BPARM(7)) TESTEM(2) = -1
      IF ((BPARM(3).EQ.0.0) .OR. (BPARM(6).EQ.BPARM(7))) TESTEM(2) = 0
C                                       X/Y ratio ?
      AREA(1) = 1000.
      AREA(2) = 1000.
C                                       Get CATBLK from UVGET
      CALL UVGET ('INIT', RPARM, BUFF1, IERR)
      IF (IERR.LT.0) THEN
         MSGTXT = 'INITIAL UVGET RETURNS NO DATA FOUND'
         GO TO 980
      ELSE IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INITIAL UVGET CALL'
         GO TO 980
         END IF
C                                       save adverbs
      XSIN = IUSEQ
      XDISIN = IUDISK
      CALL CHR2H (12, UNAME, 1, XNAMEI)
      CALL CHR2H (6, UCLAS, 1, XCLAIN)
      OLDCNO = IUCNO
      XBCHAN = BCHAN
      XECHAN = ECHAN
      XBIF = BIF
      XEIF = EIF
      XSUBA = SUBARR
      CALL UVGET ('CLOS', RPARM, BUFF1, IERR)
      IF (NCFILE.LE.0) THEN
         NCFILE = 1
         FVOL(NCFILE) = IUDISK
         FCNO(NCFILE) = IUCNO
         FRW(NCFILE) = 0
         END IF
      CALL COPY (256, CATUV, CATBLK)
      CALL COPY (256, CATUV, CATOLD)
C                                       UVPGET was called for output
      IF ((ILOCSU.GE.0) .OR. ((RA.EQ.0.0D0) .AND. (DEC.EQ.0.0D0))) THEN
         IERR = 8
         MSGTXT = 'YOU MUST SELECT ONLY ONE SOURCE'
         GO TO 980
         END IF
C                                       Source offsets
      RA0 = RA
      DEC0 = DEC
      IF (COS(DG2RAD*DEC0).NE.0.0D0) RA = RA0 + SHIFT(1) / 3600.D0
     *   / COS(DG2RAD * DEC0)
      DEC = DEC + SHIFT(2) / 3600.D0
      RAS = RA
      DECS = DEC
      DXC = SIN (DG2RAD * (RA-RA0)) * COS (DEC * DG2RAD)
      DYC = COS (DEC0 * DG2RAD) * SIN (DEC * DG2RAD) -
     *   SIN (DEC0 * DG2RAD) * COS (DEC * DG2RAD) *
     *   COS ((RA - RA0) * DG2RAD)
      DZC = SIN (DG2RAD * DEC0) * SIN (DG2RAD * DEC) +
     *   COS (DG2RAD * DEC0) * COS (DG2RAD * DEC) *
     *   COS (DG2RAD * (RA - RA0)) - 1.0D0
      DXC = TWOPI * DXC
      DYC = TWOPI * DYC
      DZC = TWOPI * DZC
C                                       Sort order OK ?
      IF (ISORT(:1).NE.'T') THEN
         MSGTXT = 'FIRST KEY OF SORT ORDER MUST BE TIME !!'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 999
         END IF
C                                       Frequency and bandwidth
      IF (JLOCIF.LT.0) THEN
         FOFF(1) = 0.0D0
         FINC(1) = CATR(KRCIC+JLOCF)
      ELSE
         FQVER = 1
         LUNCH = 87
         CALL CHNDAT ('READ',  CHBUFF, DISKIN, OLDCNO, FQVER, CATBLK,
     *      LUNCH, NIF, FOFF, ISBAND, FINC, BNDCOD, FREQID, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR
            CALL MSGWRT (7)
            JERR = 1
            GO TO 999
            END IF
         END IF
      OFREQ = CATD(KDCRV+JLOCF)
      FRPIX = CATR(KRCRP+JLOCF)
      NX = XIMSIZ(1) + 0.1
      NY = XIMSIZ(2) + 0.1
      IF (NX.LT.128) NX = 1024
      IF (NY.LT.128) NY = 1024
C                                       Update catalog header.
      FRW(NCFILE) = 0
      JERR = 0
      GO TO 999
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FTPIN: ERROR',I3,' ON ',A)
 1050 FORMAT ('ERROR',I5,' READING FREQUENCIES WITH CHNDAT')
      END
      SUBROUTINE ACDFT (IRET)
C-----------------------------------------------------------------------
C   ACDFT accumlates the flux density for each averaging interval as
C   well as an estimate of the error. Also sets scaling for later use.
C   Output:
C      IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'DFTQU.INC'
      INTEGER   FLAG, NUMVIS, XUMVIS, IA1, IA2
      REAL      VIS(UVBFSS), RPARM(20), BASEN
      DOUBLE PRECISION T1, T2
      LOGICAL   REQBAS
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C                                       Set up binning
      XNUL = FBLANK
      CALL RFILL (MAXSAM, XNUL, DFT)
      CALL RFILL (MAXSAM, XNUL, TIMR)
      CALL RFILL (MAXSAM, 0.0, ERROR)
C                                       Get start/stop times
      CALL TBTIME (TBEG, TFIN, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINDING START AND STOP TIMES'
         GO TO 990
         END IF
C                                       set bin count, T averaging
      BCNT = 1
      IF (BPARM(2).LE.0.001) BPARM(2) = 864. * (TFIN - TBEG)
      TAVG = BPARM(2) / 86400.
      T1 = TBEG
      T2 = T1 + TAVG
C                                       Init vis file for read.
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT UV IO'
         GO TO 990
         END IF
      NUMVIS = 0
      XUMVIS = 0
      KNCS = INCS
      KNCF = INCF
      KNCIF = INCIF
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING UV DATA'
         GO TO 990
      ELSE IF (IRET.EQ.0) THEN
C                                       antenna/baseline
         IF (ILOCB.GE.0) THEN
            BASEN = RPARM(1+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
            END IF
         IF (.NOT.REQBAS (IA1, IA2, DESEL, IXANT, NXANT, IXBASL,
     *      NXBASL)) GO TO 100
C                                       Is this a valid point ?
 125     CALL WANTED (RPARM, VIS, T1, T2, FLAG)
C                                       Bad point, try again
         IF (FLAG.EQ.1) GO TO 100
C                                       End of time search
         IF (FLAG.EQ.3) GO TO 200
C                                       Next time interval
         IF (FLAG.EQ.2) THEN
            CALL DODFT (RPARM, VIS, T1, T2, FLAG, IRET)
            T1 = T2
            T2 = T1 + TAVG
            GO TO 125
            END IF
C                                       Good point
         CALL DODFT (RPARM, VIS, T1, T2, FLAG, IRET)
         XUMVIS = XUMVIS + 1
         GO TO 100
         END IF
C                                       Any valid points
 200  IF (XUMVIS.LE.1) THEN
         IRET = 4
         WRITE (MSGTXT,1200) XUMVIS
         GO TO 990
         END IF
C                                       Get plot ranges and scales
      BCNT = BCNT - 1
      CALL XYSCAL (IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1110) IRET
         GO TO 990
         END IF
C                                       close UV data
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ACDFT: ERROR',I3,' ON ',A)
 1110 FORMAT ('ACDFT: XYSCL ERROR',I3)
 1200 FORMAT ('FOUND',I5,' POINTS: NOT ENOUGH TO SELF-SCALE')
      END
      SUBROUTINE XYSCAL (IRET)
C-----------------------------------------------------------------------
C   XYSCAL converts to FPA if reqested, finds max/min over data, and
C   finds the scaling parameters needed to fit X and Y into a 1000x1000
C   plotting area .
C   Outputs:
C      XY      R(2,3)   Min, max of up to 3 parameters
C      XYOFF   R(2,3)   when added to XY changes minimum to zero .
C      XYSCL   R(2,3)   scale XY so that maximum is 1000.
C      IRET    I        Error return code , non-zero if error .
C-----------------------------------------------------------------------
      INTEGER   IRET
c
      INTEGER   I, IROUND, J, IP
      REAL      RI, TEMP
      INCLUDE 'DFTQU.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       MAX/MIN
      XY(1,1) = 1.E10
      XY(2,1) = -1.E10
      XY(1,2) = 1.E10
      XY(2,2) = -1.E10
      XY(1,3) = 1.E10
      XY(2,3) = -1.E10
      DO 40 I = 1,BCNT
         IF (TIMR(I).NE.FBLANK) THEN
            DO 35 IP = 1,NPOL
               IF (DFT(I,IP).NE.FBLANK) THEN
                  RI = DFT(I,IP)
                  XY(1,IP) = MIN (XY(1,IP), RI)
                  XY(2,IP) = MAX (XY(2,IP), RI)
                  END IF
 35            CONTINUE
            END IF
 40      CONTINUE
      CALL RCOPY (6, XY, VRANGE(1,1))
C                                       Are they in requested range
      J = IROUND (BPARM(3))
      IF (J.GT.0) THEN
         IF (BPARM(4).LT.BPARM(5)) THEN
            XY(1,1) = BPARM(4)
            XY(2,1) = BPARM(5)
            END IF
         IF (BPARM(6).LT.BPARM(7)) THEN
            XY(1,2) = BPARM(6)
            XY(2,2) = BPARM(7)
            END IF
      ELSE IF (J.LT.0) THEN
         IF (BPARM(4).LT.BPARM(5)) THEN
            XY(1,1) = MAX (XY(1,1), BPARM(4))
            XY(2,1) = MIN (XY(2,1), BPARM(5))
            END IF
         IF (BPARM(6).LT.BPARM(7)) THEN
            DO 50 IP = 1,NPOL
               XY(1,IP) = MAX (XY(1,IP), BPARM(6))
               XY(2,IP) = MIN (XY(2,IP), BPARM(7))
 50            CONTINUE
            END IF
         END IF
C                                       provide room at edges too.
      TEMP = 0.01 * (XY(2,1) - XY(1,1))
      XY(1,1) = XY(1,1) - TEMP
      XY(2,1) = XY(2,1) + TEMP
      TEMP = 0.01 * (XY(2,2) - XY(1,2))
      XY(1,2) = XY(1,2) - TEMP
      XY(2,2) = XY(2,2) + TEMP
C
 999  RETURN
      END
      SUBROUTINE WANTED (RPBUF, VIS, T1, T2, FLAG)
C-----------------------------------------------------------------------
C   WANTED determines whether the current visibility sample is valid
C   and selected via the selection parameters.
C   Inputs:
C      RPBUF   R(*)   Random parameters
C      VIS     R(*)   Visibilities
C      T1      D      Start desired time range
C      T2      D      End desired time range
C   Outputs:
C      FLAG    I      0 => data selected as good
C                     1    data NO GOOD
C                     2    time exceeds T2
C                     3    time exceeds TFIN
C-----------------------------------------------------------------------
      REAL      RPBUF(*), VIS(*)
      DOUBLE PRECISION T1, T2
      INTEGER   FLAG
C
      REAL      TEMP
      INTEGER   LAD, IIF, ICH, IROUND
      LOGICAL   GOOD, ANY
      INCLUDE 'DFTQU.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
      FLAG = 1
C                                       Check FREQID
      IF (ILOCFQ.GE.0) THEN
         IIF = IROUND (RPBUF(1+ILOCFQ))
         IF ((FREQID.GT.0) .AND. (IIF.GT.0) .AND. (IIF.NE.FREQID))
     *      GO TO 999
         END IF
C                                       Check UV range
      IF (.NOT.NOUVR) THEN
         TEMP = SQRT (RPBUF(1+ILOCU)**2 + RPBUF(1+ILOCV)**2)
         IF ((TEMP.LT.UVRANG(1)) .OR. (TEMP.GT.UVRANG(2))) GO TO 999
         END IF
C                                       Are data flagged?
      ANY = .FALSE.
      DO 20 IIF = BIF,EIF
         DO 10 ICH = BCHAN,ECHAN
            LAD = 1 + (IIF-BIF)*KNCIF + (ICH-BCHAN)*KNCF
            GOOD = VIS(LAD+2).GT.0.0
            ANY = ANY .OR. GOOD
 10         CONTINUE
 20      CONTINUE
      IF (.NOT.ANY) GO TO 999
C                                       Test time range
      TEMP = RPBUF(1+ILOCT)
      IF (TEMP.LT.T1) GO TO 999
      FLAG = 2
      IF (TEMP.GE.T2) GO TO 999
      FLAG = 3
      IF (TEMP.GT.TFIN) GO TO 999
      FLAG = 0
C
 999  RETURN
      END
      SUBROUTINE GRDFT (KX, KY, IMAGE, IRET)
C-----------------------------------------------------------------------
C   GRDFT grids the qu data into an image
C   Inputs
C      KX      I      X axis dimension
C      KY      I      Y axis dimension
C   Outputs
C      IMAGE   R(*)   IMAGE
C      IRET    I      error code
C-----------------------------------------------------------------------
      INTEGER   KX, KY, IRET
      REAL      IMAGE(KX,KY,3)
C
      INCLUDE 'DFTQU.INC'
      INTEGER   IM, IX, IY, I, NCOL, EX, LX, LY
      REAL      COLV, DCOLV, COL(3)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (BPARM(1).LT.1) BPARM(1) = 1
      IF (BCNT/BPARM(1).LT.3.) BPARM(1) = 1
      NCOL = (BCNT - 1) / BPARM(1) + 1
      IM = BPARM(1)
      EX = BPARM(8) + 0.1
      DCOLV = 0.97 / (NCOL-1)
      COLV = -DCOLV

      DO 100 I = 1,BCNT
         IF (MOD(I-1,IM).EQ.0) THEN
            COLV = COLV + DCOLV
            CALL COLOR3 (COLV, .FALSE., COL)
            END IF
         IX = (DFT(I,1) - XY(1,1)) / (XY(2,1) - XY(1,1)) * (NX - 1)
     *      + 1.5
         IY = (DFT(I,2) - XY(1,2)) / (XY(2,2) - XY(1,2)) * (NY - 1)
     *      + 1.5
         DO 80 LY = MAX(1,IY-EX),MIN(KY,IY+EX)
            DO 70 LX = MAX(1,IX-EX),MIN(KX,IX+EX)
               IMAGE(LX,LY,1) = COL(1)
               IMAGE(LX,LY,2) = COL(2)
               IMAGE(LX,LY,3) = COL(3)
 70            CONTINUE
 80         CONTINUE
 100     CONTINUE
      IRET = 0
C
 999  RETURN
      END
      SUBROUTINE DODFT (RPBUF, VIS, T1, T2, FLAG, IRET)
C-----------------------------------------------------------------------
C   DODFT computes the DFT for a given set of visibilities with the
C   proper sky offset applied.
C   Inputs:
C     RPBUF   R(*)   one visibility record - random parameters
C     VIS     R(*)   one visibility record - data
C     T1      D      Start of interval
C     T2      D      End of interval
C     FLAG    I      If 0, continue summing DFT
C                    If 2, wrap it up, clear
C   Outputs:
C     IRET    I      0 => operation sucessful
C                    1 => trouble
C                    -1 => no data to average
C-----------------------------------------------------------------------
      REAL      RPBUF(*), VIS(*)
      INTEGER   FLAG, IRET
C
      REAL      TR, TI, WT, DELS, UU, VV, WW, SMN, TNR, TNI, TNU1(3,3),
     *   TNU2(3,3), TUMWT(3), TNA, XX
      DOUBLE PRECISION T1, T2, AFREQ
      INTEGER   IIF, ICH, TAMP(3), LAD, IP, J
      LOGICAL   GOOD
      INCLUDE 'DFTQU.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      SAVE TNU1, TNU2, TUMWT, TAMP
      DATA TNU1, TNU2, TUMWT, TAMP /21*0.0, 3*0/
C-----------------------------------------------------------------------
      TR = 0.0
      TI = 0.0
      IRET = 0
      IF (FLAG.NE.0) GO TO 500
C                                       loop over IF and channel
      DO 100 IIF = BIF,EIF
         DO 90 ICH = BCHAN,ECHAN
            AFREQ = OFREQ + FOFF(IIF) + (ICH-FRPIX) * FINC(IIF)
C                                       Set U and V
            UU = RPBUF(ILOCU+1) * AFREQ / OFREQ
            VV = RPBUF(ILOCV+1) * AFREQ / OFREQ
            WW = RPBUF(ILOCW+1) * AFREQ / OFREQ
            DO 80 IP = 1,NPOL
C                                       Find visibilities and weights
               LAD = 1 + (ICH-BCHAN)*KNCF + (IIF-BIF)*KNCIF +
     *            (IP-1)*KNCS
               IF (VIS(LAD+2).GT.0.0) THEN
                  TR = VIS(LAD)
                  TI = VIS(LAD+1)
                  WT = VIS(LAD+2)
C                                       sum it up
                  XX = UU * DXC + VV * DYC + WW * DZC
                  TNR = TR * COS (XX) + TI * SIN (XX)
                  TNI = TI * COS (XX) - TR * SIN (XX)
                  TNA = SQRT (TNR*TNR + TNI*TNI)
                  TNU1(IP,1) = TNU1(IP,1) + WT * TNR
                  TNU2(IP,1) = TNU2(IP,1) + WT * TNR * TNR
                  TNU1(IP,2) = TNU1(IP,2) + WT * TNI
                  TNU2(IP,2) = TNU2(IP,2) + WT * TNI * TNI
                  TNU1(IP,3) = TNU1(IP,3) + WT * TNA
                  TNU2(IP,3) = TNU2(IP,3) + WT * TNA * TNA
                  TUMWT(IP) = TUMWT(IP) + WT
                  TAMP(IP) = TAMP(IP) + 1
                  END IF
 80            CONTINUE
 90         CONTINUE
 100     CONTINUE
      GO TO 999
C                                      Finish up this interval
 500  GOOD = .FALSE.
      J = 1
       DO 510 IP = 1,NPOL
         IF (TUMWT(IP).GT.0.0) THEN
            GOOD = .TRUE.
            SMN = TNU1(IP,J) / TUMWT(IP)
            DELS = TNU2(IP,J) / TUMWT(IP) - SMN*SMN
            DELS = SQRT (MAX (0.0, DELS))
            DFT(BCNT,IP) = SMN
            ERROR(BCNT,IP) = DELS / SQRT (MAX (1.0, TAMP(IP)-1.))
            TIMR(BCNT) = (T1+T2)/2.
         ELSE
            DFT(BCNT,IP) = FBLANK
            ERROR(BCNT,IP) = FBLANK
            END IF
 510     CONTINUE
      IF (GOOD) THEN
         IRET = 0
         BCNT = BCNT + 1
      ELSE
         IRET = -1
         END IF
      CALL RFILL (9, 0.0, TNU1)
      CALL RFILL (9, 0.0, TNU2)
      CALL RFILL (3, 0.0, TUMWT)
      CALL FILL (3, 0, TAMP)
C
 999  RETURN
      END
      SUBROUTINE OUTFT (KX, KY, IMAGE, IRET)
C-----------------------------------------------------------------------
C   OUTFT writes the qu iimage to aips image file
C   Inputs
C      KX      I      X axis dimension
C      KY      I      Y axis dimension
C      IMAGE   R(*)   Image
C   Outputs
C      IRET    I      error code
C-----------------------------------------------------------------------
      INTEGER   KX, KY, IRET
      REAL      IMAGE(KX,KY,3)
C
      INCLUDE 'DFTQU.INC'
      INTEGER   IX, IY, IC, SLOT, LUNO, INDO, WIN(4), BOI, DEPTH(5),
     *   IBUFF(256), OBUFF(256), LUN1, LUN2, BIND, I
      LOGICAL   BLANKD
      REAL      RMIN, RMAX
      HOLLERITH CATOH(256)
      CHARACTER AXTY(5)*8, PHNAME*48, HILINE*72
      EQUIVALENCE (CATOLD, CATOH)
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUNO, LUN1, LUN2, DEPTH /39, 40, 41, 5*1/
      DATA AXTY /'Q','U','RGB','RA','DEC'/
C-----------------------------------------------------------------------
C                                       max/min, blanked?
      BLANKD = .FALSE.
      RMIN = 1.E10
      RMAX = -1.E10
      DO 20 IY = 1,KY
         DO 15 IX = 1,KX
            DO 10 IC = 1,3
               IF (IMAGE(IX,IY,IC).EQ.FBLANK) THEN
                  BLANKD = .TRUE.
               ELSE
                  RMIN = MIN (RMIN, IMAGE(IX,IY,IC))
                  RMAX = MAX (RMAX, IMAGE(IX,IY,IC))
                  END IF
 10            CONTINUE
 15         CONTINUE
 20      CONTINUE
      CALL CATINI (CATBLK)
      CALL RCOPY (2, XSOUR, CATH(KHOBJ))
      CALL RCOPY (2, CATOH(KHTEL), CATH(KHTEL))
      CALL RCOPY (2, CATOH(KHINS), CATH(KHINS))
      CALL RCOPY (2, CATOH(KHOBS), CATH(KHOBS))
      CALL RCOPY (2, CATOH(KHDOB), CATH(KHDOB))
      CALL CHR2H (8, 'COLOR   ', 1, CATH(KHBUN))
      CATBLK(KIDIM) = 5
      DO 25 I = 1,5
         CALL CHR2H (8, AXTY(I), 1, CATH(KHCTP+2*I-2))
 25      CONTINUE
      CATBLK(KINAX) = KX
      CATBLK(KINAX+1) = KY
      CATBLK(KINAX+2) = 3
      CATBLK(KINAX+4) = 1
      CATD(KDCRV) = XY(1,1)
      CATD(KDCRV+1) = XY(1,2)
      CATD(KDCRV+2) = 1.0D0
      CATD(KDCRV+3) = RAS
      CATD(KDCRV+4) = DECS
      CATR(KRCIC) = (XY(2,1) - XY(1,1)) / (KX-1.0)
      CATR(KRCIC+1) = (XY(2,2) - XY(1,2)) / (KY-1.0)
      CATR(KRDMN) = RMIN
      CATR(KRDMX) = RMAX
      IF (NAMEOU.EQ.' ') NAMEOU = NAMEIN
      IF (CLAOU.EQ.' ') CLAOU = TSKNAM
      CALL CHR2H (12, NAMEOU, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOU, KHIMCO, CATH(KHIMN))
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHIMN))
      CATBLK(KIIMS) = SEQOU
      CALL MCREAT (DISKOU, SLOT, BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATE OUTPUT IMAGE FILE'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKOU
      FCNO(NCFILE) = SLOT
      FRW(NCFILE) = 2
C                                       start IO
      CALL ZPHFIL ('MA', DISKOU, SLOT, 1, PHNAME, IRET)
      CALL ZOPEN (LUNO, INDO, DISKOU, PHNAME, .TRUE., .TRUE., .TRUE.,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT IMAGE'
         GO TO 990
         END IF
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NX
      WIN(4) = NY
      DO 50 IC = 1,3
         DEPTH(1) = IC
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), DEPTH, BOI, IRET)
         BOI = BOI + 1
         CALL MINIT ('WRIT', LUNO, INDO, NX, NY, WIN, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT I/O TO OUTPUT IMAGE'
            GO TO 990
            END IF
         DO 40 IY = 1,KY
            CALL MDISK ('WRIT', LUNO, INDO, BUFF1, BIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT IMAGE'
               GO TO 990
               END IF
            CALL RCOPY (KX, IMAGE(1,IY,IC), BUFF1(BIND))
 40         CONTINUE
         CALL MDISK ('FINI', LUNO, INDO, BUFF1, BIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'FINISH WRITE OUTPUT'
            GO TO 990
            END IF
 50      CONTINUE
      CALL ZCLOSE (LUNO, INDO, IRET)
C                                       history
C                                       Initialize HITAB
      CALL HIINIT (3)
C                                       Create and copy history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKOU, OLDCNO, SLOT, CATBLK,
     *   IBUFF, OBUFF, IRET)
      IF (IRET.GT.3) GO TO 999
      IF (IRET.EQ.3) GO TO 100
C                                       Add SUBIM history.
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, OBUFF,
     *   IRET)
      IF (IRET.NE.0) GO TO 100
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), CLAOU)
      CALL HENCOO (TSKNAM, NAMEOU, CLAOU, CATBLK(KIIMS), DISKOU, LUN2,
     *   OBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       shift
      WRITE (HILINE,2000) TSKNAM, SHIFT
      CALL HIADD (LUN2, HILINE, OBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       SOLINT
      WRITE (HILINE,2001) TSKNAM, BPARM(2)
      CALL HIADD (LUN2, HILINE, OBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
      I = BPARM(1) + 0.1
      WRITE (HILINE,2002) TSKNAM, I
      CALL HIADD (LUN2, HILINE, OBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
      I = BPARM(8) + 0.1
      WRITE (HILINE,2003) TSKNAM, I
      CALL HIADD (LUN2, HILINE, OBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       cal adverbs
      CALL CALHIS (LUN2, OBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       close
 100  CALL HICLOS (LUN2, .TRUE., OBUFF, I)
      CALL CATIO ('UPDT', DISKOU, SLOT, CATBLK, 'CLWR', IBUFF, I)
      IF (I.NE.0) THEN
         WRITE (MSGTXT,1000) I, 'ON UPDATE HEADER WITH CATIO'
         CALL MSGWRT (8)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OUTFT: ERROR',I4,' ON ',A)
 2000 FORMAT (A6,'SHIFT=',F9.4,',',F9.4,4X,'/ position shift in asec')
 2001 FORMAT (A6,'BPARM(2)=',F7.1,15X,'/ seconds averaging time')
 2002 FORMAT (A6,'BPARM(1)=',I7,18X,'/ intervals at same color')
 2003 FORMAT (A6,'BPARM(8)=',I7,18X,'/ pixel expansion number')
      END

LOCAL INCLUDE 'XBASL.INC'
C                                                          Include XBASL
      INCLUDE 'INCS:PMAD.INC'
C                                       Local include for XBASL
      REAL      XSEQIN, XDISKI, XSEQO, XDISKO, BLC(7), TRC(7), YINC,
     *   ZINC, FCUT, DOCAT, DOCONT, DOSLIC, DOMODL, DORESI, RANGE(2),
     *   PLTYPE, PIXVAL, PORDER, XBOXES, BOXES(2,20), DOTV, GRCHAN,
     *   BADD(10)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      DOUBLE PRECISION OLDD(128)
      HOLLERITH OLDH(256)
      REAL      OLDR(256), PMIN(22), PMAX(22), BUFF1(MABFSS),
     *    BUFF2(MABFSS)
      INTEGER   CATOLD(256), SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO,
     *   OLDCNO, JBUFSZ, ICODE, NORDER, NBOXES, NBOX(2,20),
     *   IBUFF1(MABFSS), IBUFF2(MABFSS)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XNAMOU, XCLAOU,
     *   XSEQO, XDISKO, BLC, TRC, YINC, ZINC, FCUT, DOCAT, DOCONT,
     *   DOSLIC, DOMODL, DORESI, RANGE, PLTYPE, PIXVAL, PORDER, XBOXES,
     *   BOXES, DOTV, GRCHAN, BADD
      COMMON /BSLCHR/ NAMEIN, CLAIN, NAMOUT, CLAOUT
      COMMON /PARMS/ CATOLD, PMAX, PMIN, SEQIN, SEQOUT, DISKIN,
     *   DISKO, NEWCNO, OLDCNO, JBUFSZ, ICODE, NORDER, NBOXES, NBOX
      COMMON /BUFRS/ BUFF1, BUFF2
      EQUIVALENCE (CATOLD, OLDR, OLDD, OLDH)
      EQUIVALENCE (IBUFF1, BUFF1),  (IBUFF2, BUFF2)
      INCLUDE 'INCS:DCAT.INC'
C                                                          End XBASL.
LOCAL END
LOCAL INCLUDE 'XBASL2.INC'
C                                                         Include XBASL2
      INCLUDE 'INCS:PMAD.INC'
C                                       Local include for XBASL
      INTEGER   NITTER, ITTER, JJC, MASK(MABFSS), NPTS, IGR1, IGR2,
     *   IGR3, IGR4, DEVON, IDATA(MABFSS)
      REAL      XBAR, DATA(MABFSS), AARRAY(5,5), CARRAY(5,5), GAMMA(5),
     *   MOMENT(15), POLYFN(5), POLAVG(5), POLXFN(MABFSS,5), IGNORD,
     *   SOLVED, UCHAN
      EQUIVALENCE (DATA, IDATA)
      COMMON /GDATA/ DATA, AARRAY, CARRAY, GAMMA, MOMENT, POLYFN, XBAR,
     *   POLAVG, POLXFN, SOLVED, IGNORD, NPTS, NITTER, ITTER, JJC, MASK,
     *   UCHAN, IGR1, IGR2, IGR3, IGR4, DEVON
C                                                          End XBASL2
LOCAL END
      PROGRAM XBASL
C-----------------------------------------------------------------------
C! Fits polynomial baselines to rows of an image.
C# Map Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2000, 2005, 2007, 2009-2010, 2012
C;  Copyright (C) 2014-2015, 2022, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   XBASL fits n'th order polynomial baselines to rows of an image.
C   It writes out an n-dim cube with the baseline average added and the
C   baseline function subtracted and, if DOOUTPUT > 0, n-1 dimensional
C   images of the polynomial parameters and errors.  It will display
C   the data, model, and residual for each row on the TEK.  After each
C   fit so displayed, it asks for permission to keep the results.
C
C   CONTAINS: 1. Harvey Liszt math fitting methods.
C             2. Compute polynomials to array only at each change
C                of window.
C
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLAOUT        Class of the output image.
C                                   Default is task name.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      YINC           YINC          Pixel increment on 2nd axis
C      ZINC           ZINC          Pixel increment on 3rd axis
C      FLUX           FCUT          Flux cutoff: > 2 consecutive
C                                   points must > FLUX to fit
C                                   Also in initial auto-guesses
C      DOCAT          DOCAT         Catalog the parameter images
C      DOSLICE        DOSLIC        Plot data on TEK
C      DOMODEL        DOMODL        Plot model on TEK
C      DORESID        DORESI        Plot residuals on TEK
C      LTYPE                        Type of labeling: 1 border,
C                                   2 no ticks, 3 standard, 4 rel
C                                   to center, 5 rel to subim cen
C                                   6 map pixels
C      PIXRANGE                     Min,Max of image intensity
C                                   Max <= Min => entire range
C      PIXVAL         PIXVAL        Display only if peak < PIXVAL
C      NITER          XNIT          Limit on iterations in fit
C      BADD(10)       IBAD          Disk numbers to avoid.
C   Programmer Eric W. Greisen based on his XGAUS  April 1984.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      LOGICAL   ABLANK
      INCLUDE 'XBASL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'XBASL '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL XBASIN (PRGM, IRET)
C                                       Call routine that sends data
C                                       to the user routine.
      IF (IRET.EQ.0) CALL XBASDO (ABLANK, IRET)
      IF (IRET.EQ.0) CALL XBASOU (ABLANK, IRET)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE XBASIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   XBASIN gets input parameters for XBASL and creates an output file
C   plus files IF requested for the parameter images.
C   Inputs:
C      PRGN   C*6   Program name
C   Output:
C      IRET   I     Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C      /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   IRET
C
      CHARACTER   STAT*4, BLANK*6, CTYPE(19)*4, BUNITS(9)*4, MTYPE*2,
     *   SEQTYP(2,8)*8, CORDER(6)*2, FLXTYP(2)*8, OTYPE*8
      INTEGER   IERR, NPARM, IROUND, NAX, I, ITYP, NTYP, IG, IP, INPSEQ
      INCLUDE 'XBASL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA BLANK /'      '/
      DATA NTYP, CTYPE /19, 'TIME','FREQ','LAMB','VELO','FELO','    ',
     *   'PIXE','DIST','ANGL','RA  ','RA--','LL  ','DEC ','DEC-',
     *   'MM  ','GLON','GLAT','ELON','ELAT'/
      DATA BUNITS /'/SEC', '/HZ ', '/M  ', '/M/S', '/M/S', '/PIX',
     *   '/PIX', '/DEG', '/UNK'/
      DATA SEQTYP /'CONST   ', 'DCONST  ',
     *             'DERIV1  ', 'DDERV1  ',
     *             'DERIV2  ', 'DDERV2  ',
     *             'DERIV3  ', 'DDERV3  ',
     *             'DERIV4  ', 'DDERV4  ',
     *             'DERIV5  ', 'DDERV5  ',
     *             'DERIV6  ', 'DDERV6  ',
     *             'DERIV7  ', 'DDERV7  '/
      DATA CORDER /'22','33','44','55','66','77'/
      DATA FLXTYP /'FLUX    ', 'DFLUX   '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 94
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, IBUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Using the TEK?
      ICODE = -1
      IF ((DOSLIC.GT.0.) .OR. (DOMODL.GT.0.) .OR. (DORESI.GT.0.))
     *   ICODE = 1
      IF ((NPOPS.GT.NINTRN) .OR. (NTKDEV.LE.0)) ICODE = -1
C                                       Restart AIPS
      IF ((RQUICK) .AND. ((ICODE.LE.0) .OR. (IRET.NE.0))) CALL RELPOP
     *    (IRET, IBUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO = IROUND (XDISKO)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      DO 20 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 20      CONTINUE
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, IBUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, 'READ', IBUFF1,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Copy old CATBLK to new.
      CALL COPY (256, CATOLD, CATBLK)
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATR(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATR(KHIMC))
      CATBLK(KIIMS) = SEQOUT
      INPSEQ = SEQOUT
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATOLD(KIDIM), CATOLD(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Get user modification to CATBLK
      IRET = 4
      CALL BASHED (IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Create output file for residual
      IRET = 4
      NEWCNO = 1
      CALL MCREAT (DISKO, NEWCNO, IBUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
C                                       Make names, classes, disks OK.
      SEQOUT = CATBLK(KIIMS)
      CALL RFILL (22, -1.0E15, PMAX)
      CALL RFILL (22, 1.0E15, PMIN)
C                                       save the residual header
      CALL COPY (256, CATBLK, IBUFF2)
      NORDER = PORDER + 1.01
      IF (NORDER.GT.5) NORDER = 5
C                                       Basic output header: results
      IF (DOCAT.LE.0.0) GO TO 180
         CATBLK(KIDIM) = CATBLK(KIDIM) - 1
         NAX = CATBLK(KIDIM)
         DO 80 I = 1,NAX
            CATBLK(KINAX+I-1) = CATBLK(KINAX+I)
            CATR(KRCRP+I-1) = CATR(KRCRP+I)
            CATR(KRCRT+I-1) = CATR(KRCRT+I)
            CATR(KRCIC+I-1) = CATR(KRCIC+I)
            CATD(KDCRV+I-1) = CATD(KDCRV+I)
            CALL CHCOPY (8, 1, CATH(KHCTP+I*2), 1, CATH(KHCTP+(I-1)*2))
 80         CONTINUE
         DO 85 I = NAX,6
            CATBLK(KINAX+I) = 1
 85         CONTINUE
C                                       Find type of old axis
         CALL H2CHR (8, 1, OLDH(KHCTP), OTYPE)
         DO 90 ITYP = 1,NTYP
            IF (OTYPE.EQ.CTYPE(ITYP)) GO TO 100
 90         CONTINUE
         ITYP = 0
         WRITE (MSGTXT,1090) OTYPE
         CALL MSGWRT (6)
 100     IF (ITYP.GT.7) ITYP = 8
         IF (ITYP.EQ.0) ITYP = 9
C                                       Output polynomial parms
         CATBLK(KIIMS) = INPSEQ
         DO 120 IG = 1,NORDER
            DO 119 IP = 1,2
               CALL CHR2H (6, SEQTYP(IP,IG), KHIMCO, CATR(KHIMC))
               CALL CHCOPY (8, 1, OLDH(KHBUN), 1, CATR(KHBUN))
               IF (IG.NE.1) CALL CHR2H (4, BUNITS(ITYP),
     *            5, CATR(KHBUN))
               IF (IG.GT.2) CALL CHR2H (1, CORDER(IG-2),
     *            8, CATR(KHBUN))
C                                       Create
               DISKO = XDISKO + 0.01
               NEWCNO = 1
               CALL MCREAT (DISKO, NEWCNO, IBUFF1, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1100) IERR, SEQTYP(IP,IG)
                  GO TO 990
                  END IF
C                                       Record the creation
               NCFILE = NCFILE + 1
               FVOL(NCFILE) = DISKO
               FCNO(NCFILE) = NEWCNO
               FRW(NCFILE) = 2
 119           CONTINUE
 120        CONTINUE
C                                       Flux maps
         DO 170 IP = 1,2
            CALL CHR2H (6, FLXTYP(IP), KHIMCO, CATR(KHIMC))
            CALL CHCOPY (4, 1, OLDH(KHBUN), 1, CATR(KHBUN))
C                                       Create
            DISKO = XDISKO + 0.01
            NEWCNO = 1
            CALL MCREAT (DISKO, NEWCNO, IBUFF1, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1100) IERR, FLXTYP(IP)
               GO TO 990
               END IF
C                                       Record the creation
            NCFILE = NCFILE + 1
            FVOL(NCFILE) = DISKO
            FCNO(NCFILE) = NEWCNO
            FRW(NCFILE) = 2
 170        CONTINUE
C                                       close this one up
 180  IRET = 0
      NORDER = NORDER - 1
      CALL COPY (256, IBUFF2, CATBLK)
      DISKO = FVOL(2)
      NEWCNO = FCNO(2)
      GO TO 999
C
 990  CALL MSGWRT (8)
C                                       Restart AIPS
 995  IF ((RQUICK) .AND. (IRET.NE.0) .AND. (ICODE.GT.0)) CALL RELPOP
     *   (IRET, IBUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XBASIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I2,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT RESIDUALS FILE')
 1090 FORMAT ('AXIS TYPE ',A8,' DOES NOT HAVE KNOWN UNITS')
 1100 FORMAT ('ERROR',I5,' CREATING FILE TYPE ',A6)
      END
      SUBROUTINE XBASDO (TBLNKD, IRET)
C-----------------------------------------------------------------------
C   XBASDO sends image one row at a time to the baseline fitting routine
C   and then writes the modified data.
C   Output:
C      TBLNKD   L   Answers contain blanked pixels?
C      IRET     I   Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      LOGICAL   TBLNKD
      INTEGER   IRET
C
      INCLUDE 'XBASL.INC'
      INCLUDE 'XBASL2.INC'
      CHARACTER IFILE*48, PHNAME*48
      INTEGER   IROUND, LUNI, LUNO, NYI, NXI, WINI(4), NXO, NYO, BOI, J,
     *   WINO(4), BOO, LIM2, LIM3, LIM4, LIM5, LIM6, LIM7, I1, I2, I3,
     *   I4, I5, I6, I7, IPOS(7), CORN(7), BOTEMP, KOFF, LIMO, LIMIT,
     *   IBIND, OBIND, INDI, INDO, LIM1, IG, WINT(4), LUNT, INDT, SIZE,
     *   NAXT(7), OBINDT, IBUFF3(MABFSS), JBUFS3, IINC2, IINC3, IERR, I
      REAL      PLTODO, PLDONE, OUTMAX, OUTMIN, BUFF3(MABFSS), XPLD
      LOGICAL   T, F, BLNKD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (IBUFF3, BUFF3)
      DATA LUNI, LUNO, LUNT /16,17,18/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      OBINDT = 1
C                                       Note: CATOLD & CATBLK must be
C                                       switched in their addresses
C                                       Move the data that way
      CALL COPY (256, CATOLD, IBUFF2)
      CALL COPY (256, CATBLK, CATOLD)
      CALL COPY (256, IBUFF2, CATBLK)
      JBUFS3 = 2 * MABFSS
      IGNORD = 0.0
      SOLVED = 0.0
C                                       pass TV parameter to include 2
      UCHAN = GRCHAN
      DEVON = 0
C                                       Open and init for read
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Create scratch files.
C                                       For answers: temp scratch
      IF (DOCAT.GT.0.0) THEN
         CALL COPY (7, CATOLD(KINAX), NAXT)
         NAXT(1) = PORDER + 2.1
         NAXT(1) = NAXT(1) * 2
         CALL MAPSIZ (CATOLD(KIDIM), NAXT, SIZE)
         CALL SCREAT (SIZE, IBUFF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET
            GO TO 990
            END IF
         CALL ZPHFIL ('SC', SCRVOL(NSCR), SCRCNO(NSCR), 1, PHNAME, IERR)
         CALL ZOPEN (LUNT, INDT, SCRVOL(NSCR), PHNAME, T, T, T, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1015) IRET
            GO TO 990
            END IF
         END IF
C                                       For residual map:
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
C                                       Use actual f.p. output
      CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Setup for I/O
C                                       remember names switched
      NXI = CATBLK(KINAX)
      NYI = CATBLK(KINAX+1)
      NXO = CATOLD(KINAX)
      NYO = CATOLD(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      WINT(1) = 1
      WINT(2) = 1
      WINT(3) = NAXT(1)
      WINT(4) = NAXT(2)
      OUTMAX = -1.0E20
      OUTMIN = 1.0E20
      BLNKD = F
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
      PLDONE = 0.0
      PLTODO = REAL(LIM7) * REAL(LIM4) * REAL(LIM5) * REAL(LIM6)
      PLTODO = PLTODO * CATOLD(KINAX+2)
      KOFF = 0
      CORN(7) = 1
      LIMO = CATOLD(KINAX) - 1
      IINC2 = YINC + 0.01
      IINC3 = ZINC + 0.01
      TBLNKD = .FALSE.
C                                       baseline windows
      JJC = NORDER + 1
      CALL FILL (40, 0, NBOX)
      NBOXES = XBOXES + 0.01
      IG = TRC(1) - BLC(1) + 1.01
      I1 = BLC(1) - 0.99
      IF (NBOXES.LE.0) THEN
         NBOXES = 2
         BOXES(1,1) = 2.
         BOXES(2,1) = 3. + IG / 10.
         BOXES(1,2) = IG - 1.0 - IG / 10.
         BOXES(2,2) = IG - 1.0
         END IF
      CALL FILL (IG, 0, MASK)
      DO 55 I = 1,NBOXES
         NBOX(1,I) = BOXES(1,I) - I1
         NBOX(2,I) = BOXES(2,I) - I1
         NBOX(1,I) = MAX (NBOX(1,I), 1)
         NBOX(2,I) = MIN (NBOX(2,I), IG)
         IF (NBOX(2,I).LT.NBOX(1,I)) NBOX(2,I) = IG
         J = NBOX(2,I) - NBOX(1,I) + 1
         CALL FILL (J, 1, MASK(NBOX(1,I)))
 55      CONTINUE
      NPTS = 0
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         CORN(7+KOFF) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            CORN(6+KOFF) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               CORN(5+KOFF) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  CORN(4+KOFF) = I4
                  DO 300 I3 = 1,LIM3,IINC3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     CORN(3+KOFF) = (I3 - 1) / IINC3 + 1
                     XPLD = AINT (PLDONE / 10.0 + 0.01)
                     XPLD = 10.0 * XPLD + 1.0
                     PLDONE = PLDONE + 1.
                     IF ((ICODE.EQ.1) .OR. (ABS(XPLD-PLDONE).LE.0.1))
     *                  THEN
                        WRITE (MSGTXT,1090) PLDONE, PLTODO
                        CALL MSGWRT (1)
                        END IF
C                                       Init. files, first input.
                     CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IPOS(3),
     *                   BOTEMP, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1099) IRET
                        GO TO 990
                        END IF
                     BOI = BOTEMP + 1
                     CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI,
     *                  BUFF1, JBUFSZ, BOI, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1100) 'READ', IRET
                        GO TO 990
                        END IF
C                                       Init answer file.
                     IF (DOCAT.GT.0.0) THEN
                        CALL COMOFF (CATOLD(KIDIM), NAXT, CORN(3),
     *                     BOTEMP, IRET)
                        BOO = BOTEMP + 1
                        CALL MINIT ('WRIT', LUNT, INDT, NAXT, NAXT(2),
     *                     WINT, BUFF3, JBUFS3, BOO, IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1100) 'WRIT', IRET
                           GO TO 990
                           END IF
                        END IF
C                                       Init output file.
                     CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), CORN(3),
     *                  BOTEMP, IRET)
                     BOO = BOTEMP + 1
                     CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO,
     *                  BUFF2, JBUFSZ, BOO, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1100) 'WRIT', IRET
                        GO TO 990
                        END IF
                     DO 250 I2 = 1,LIM2
                        IPOS(2) = BLC(2) + I2 - 0.9
                        IPOS(1) = IROUND (BLC(1))
C                                       Read.
                        CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND,
     *                     IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1120) 'READ', IRET
                           GO TO 990
                           END IF
C                                       Want this row?
                        IF (MOD(I2-1,IINC2).EQ.0) THEN
C                                       Copy to buffer.
                           DO 160 I1 = 1,LIM1
                              DATA(I1) = BUFF1(IBIND+I1-1)
 160                          CONTINUE
C                                       Write.
                           IF (DOCAT.GT.0.0) THEN
                              CALL MDISK ('WRIT', LUNT, INDT, BUFF3,
     *                           OBINDT, IRET)
                              IF (IRET.NE.0) THEN
                                 WRITE (MSGTXT,1120) 'WRIT', IRET
                                 GO TO 990
                                 END IF
                              END IF
                           CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND,
     *                        IRET)
                           IF (IRET.NE.0) THEN
                              WRITE (MSGTXT,1120) 'WRIT', IRET
                              GO TO 990
                              END IF
C                                       Call DO1BAS
                           CALL DO1BAS (IPOS, BUFF3(OBINDT),
     *                        BUFF2(OBIND), IRET)
                           IF (IRET.NE.0) THEN
                              WRITE (MSGTXT,1180) IRET
                              IF (IRET.EQ.99) WRITE (MSGTXT,1181)
                              GO TO 990
                              END IF
C                                       Check max, min, blanking.
                           LIMIT = OBIND + LIMO
                           DO 200 I1 = OBIND,LIMIT
                              BLNKD = BLNKD .OR. (BUFF2(I1).EQ.FBLANK)
                              IF (BUFF2(I1).NE.FBLANK) THEN
                                 OUTMAX = MAX (OUTMAX, BUFF2(I1))
                                 OUTMIN = MIN (OUTMIN, BUFF2(I1))
                                 END IF
 200                          CONTINUE
                           IF ((.NOT.TBLNKD) .AND. (DOCAT.GT.0.0)) THEN
                              LIMIT = OBINDT + WINT(3) - 1
                              DO 210 I1 = OBINDT,LIMIT
                                 TBLNKD = (BUFF3(I1).EQ.FBLANK) .OR.
     *                              (TBLNKD)
 210                             CONTINUE
                              END IF
                           END IF
 250                    CONTINUE
C                                       Flush buffers.
                     IF (DOCAT.GT.0.0) THEN
                        CALL MDISK ('FINI', LUNT, INDT, BUFF3, OBINDT,
     *                     IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1120) 'FINI', IRET
                           GO TO 990
                           END IF
                        END IF
                     CALL MDISK ('FINI', LUNO, INDO, BUFF2, OBIND, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1120) 'FINI', IRET
                        GO TO 990
                        END IF
C                                       Update CATBLK.
                     OLDR(KRDMX) = OUTMAX
                     OLDR(KRDMN) = OUTMIN
                     CALL CATIO ('UPDT', DISKO, NEWCNO, CATOLD, 'REST',
     *                  IDATA, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1260) IRET
                        GO TO 990
                        END IF
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
      WRITE (MSGTXT,1700) SOLVED, IGNORD
      CALL MSGWRT (7)
C                                       Resume AIPS
      IRET = 0
      IF ((RQUICK) .AND. (ICODE.GT.0)) CALL RELPOP (IRET, IBUFF1, IERR)
C                                       Mark blanking in CATBLK.
      OLDR(KRBLK) = 0.0
      IF (BLNKD) OLDR(KRBLK) = FBLANK
      OLDR(KRDMN) = OUTMIN
      OLDR(KRDMX) = OUTMAX
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      IF (DOCAT.GT.0.) CALL ZCLOSE (LUNT, INDT, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
C                                       return catblk's to normal
      CALL COPY (256, CATOLD, IBUFF2)
      CALL COPY (256, CATBLK, CATOLD)
      CALL COPY (256, IBUFF2, CATBLK)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C                                       Resume AIPS
      IF ((RQUICK) .AND. (ICODE.GT.0)) CALL RELPOP (IRET, IBUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XBASDO: ERROR',I3,' OPENING INPUT FILE')
 1010 FORMAT ('XBASDO: ERROR',I3,' CREATING ANSWER SCRATCH FILE')
 1015 FORMAT ('XBASDO: ERROR',I3,' OPENING ANSWER SCRATCH FILE')
 1020 FORMAT ('XBASDO: ERROR',I5,' OPENING OUTPUT FILE')
 1090 FORMAT ('Begin plane',F8.0,' of',F8.0)
 1099 FORMAT ('XBASDO: COMOFF ERROR',I3)
 1100 FORMAT ('XBASDO: INIT-FOR-',A4,' ERROR',I3)
 1120 FORMAT ('XBASDO: ',A4,' ERROR',I3)
 1180 FORMAT ('XBASDO: DO1BAS ERROR',I3)
 1181 FORMAT ('QUITTING AT USER REQUEST')
 1260 FORMAT ('XBASDO: CATIO ERROR',I3,' UPDATING CATBLK')
 1700 FORMAT ('Solved in',F12.0,' rows, simply copied',F12.0,' rows')
      END
      SUBROUTINE BASHED (IRET)
C-----------------------------------------------------------------------
C   BASHED modifies the new image header for the subimaging and for
C   replacing the first axis with parameters.
C   Input:
C      CATBLK(256)    I     Output catalog header, also CATR, CATD
C      CATOLD(256)    I     Input catalog header, also OLDR, OLDD
C   Output:
C      CATBLK(256)    I     Modified output catalog header.
C      IRET           I     Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER FCHARS(3)*4, CHTM12*12
      INTEGER   I, IRET
      INCLUDE 'XBASL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA FCHARS /'FREQ','VELO','FELO'/
C-----------------------------------------------------------------------
C                                       Check input axes
      DO 10 I = 1,3
         CALL H2CHR (4, 1, CATR(KHCTP), CHTM12)
         IF (FCHARS(I).EQ.CHTM12) GO TO 20
 10      CONTINUE
      WRITE (MSGTXT,1010)
      CALL MSGWRT (4)
C                                       Set axes in output CATBLK.
 20   I = YINC + 0.01
      IF (I.LE.0) I = 1
      YINC = I
      I = ZINC + 0.01
      IF (I.LE.0) I = 1
      ZINC = I
      CALL SUBHD3 (BLC, TRC, 1.0, YINC, ZINC)
      IF (FCUT.LE.0.0) FCUT = 0.00005
      IF (PIXVAL.LE.FCUT) PIXVAL = 100. * FCUT
C                                       Check polynomial order
      PORDER = MAX (0.0, PORDER)
      IF (PORDER.GT.4.0) THEN
         WRITE (MSGTXT,1030) PORDER
         CALL MSGWRT (6)
         PORDER = 4.0
         END IF
C                                       Check input size
      IRET = 0
      IF (TRC(1)-BLC(1).GT.MAXIMG) THEN
         WRITE (MSGTXT,1040) MAXIMG
         CALL MSGWRT (8)
         IRET = 4
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('WARNING: FIRST AXIS NOT FREQUENCY OR VELOCITY')
 1030 FORMAT ('ORDER=',F7.3,' TOO LARGE: REDUCED TO 4.0')
 1040 FORMAT ('WORKS ONLY ON (SUB)ROWS <=',I6,' PIXELS')
      END
      SUBROUTINE DO1BAS (IPOS, RESULT, RESIDS, IRET)
C-----------------------------------------------------------------------
C   DO1BAS fits baselines to a row of an image and returns the
C   answers in RESULT and the residuals in RESIDS (if DOCAT > 0).
C   Inputs:
C      IPOS(7)   I    BLC (input image) of first value in DATA
C   Values from commons:
C      DATA(*)   D    Input row, magic value blanked.
C      FBLANK    R    Value of blanked pixel.
C      CATBLK    I    Output catalog header (also CATR, CATD)
C      CATOLD    I    Input catalog header (also OLDR, OLDD)
C   Output:
C      RESULT(*) R    Output row (parameter answers, errors).
C      RESIDS(*) R    Residuals (DATA - model).
C      IRET      I    Return code   0 => OK
C                               >0 => error, terminate.
C   Output in COMMON
C     CATBLK     I    Catalog header block
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), IRET
      REAL      RESULT(*), RESIDS(*)
C
      INCLUDE 'XBASL.INC'
      INCLUDE 'XBASL2.INC'
      INTEGER   ING, INPARM, INPTS, LABEL, TERR, LCODE, I, IERR, OUPARM,
     *    NTRY, LERR, J
       REAL      PARMS(9), FVEC(MABFSS), ORANGE(2), AVER
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVS.INC'
C-----------------------------------------------------------------------
      IRET = 0
      NTRY = 0
      LABEL = ABS (PLTYPE)
      IF (MOD(LABEL,100).LE.0) LABEL = (LABEL/100)*100 + 3
      PLTYPE = LABEL
C                                       Not last call
      IF (IPOS(1).GE.0) THEN
C                                       Get the initial guess
 10      NTRY = NTRY + 1
         LCODE = ICODE
         ING = PORDER + 0.1
         INPARM = ING + 1
         OUPARM = 2 * INPARM + 2
         INPTS = TRC(1) - BLC(1) + 1.01
         ITTER = 0
         NITTER = 100
         XBAR = IPOS(1) - 1 - CATR(KRCRP)
         TERR = 0
         CALL POLYIN (INPTS, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL XBASGE (NORDER, INPTS, FCUT, LCODE, PIXVAL, PARMS, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       Plot it
         IF (LCODE.EQ.1) THEN
            IF (DOTV.GT.0.0) THEN
               CALL BTVINI (IPOS, INPTS, NORDER, LABEL, RANGE, DOSLIC,
     *            PARMS, NBOXES, NBOX, PORDER, ORANGE, TERR)
            ELSE
               CALL BTKINI (IPOS, INPTS, NORDER, LABEL, RANGE, DOSLIC,
     *            PARMS, NBOXES, NBOX, PORDER, ORANGE, FVEC, TERR)
               END IF
            JJC = NORDER + 1
            IF ((NTRY.GT.1) .AND. (TERR.LT.100)) TERR = 103
            IF (TERR.EQ.102) THEN
               IRET = 99
               GO TO 990
            ELSE IF (TERR.EQ.101) THEN
               GO TO 900
C                                       Redo guess
            ELSE IF (TERR.GE.100) THEN
               TERR = 0
               IF (DOTV.GT.0.0) THEN
                  CALL BTVGUS (INPTS, ORANGE, NBOXES, NBOX, TERR)
               ELSE
                  CALL BTKGUS (INPTS, ORANGE, NBOXES, NBOX, FVEC, TERR)
                  END IF
               IF (TERR.GT.100) GO TO 900
C                                       reset parms
               CALL FILL (INPTS, 0, MASK)
               DO 15 I = 1,NBOXES
                  IF ((NBOX(1,I).LT.1) .OR. (NBOX(2,I).GT.INPTS))
     *               GO TO 15
                     J = NBOX(2,I) - NBOX(1,I) + 1
                     CALL FILL (J, 1, MASK(NBOX(1,I)))
 15               CONTINUE
               NPTS = 0
               CALL POLYIN (INPTS, IERR)
               IF (IERR.NE.0) GO TO 900
               END IF
            END IF
C                                       Fit baselines
         CALL XBALMS (INPTS, PARMS)
C                                       Get errors and nice units
         CALL XBASFI (INPARM, PARMS, RESULT)
         I = 1
         ITTER  = ITTER - 1
         CALL XBFUNC (INPTS, PARMS, FVEC)
         IF ((LCODE.EQ.1) .AND. (TERR.LE.0)) THEN
            IF (DOTV.GT.0.0) THEN
               CALL BTVMOD (DOMODL, DORESI, INPTS, ING, ORANGE, FVEC,
     *            LERR, TERR)
            ELSE
               CALL BTKMOD (DOMODL, DORESI, INPTS, ING, ORANGE, FVEC,
     *            LERR, TERR)
               END IF
            IF (TERR.EQ.101) THEN
               GO TO 900
            ELSE IF (TERR.EQ.102) THEN
               IRET = 99
               GO TO 990
            ELSE IF (TERR.EQ.103) THEN
               GO TO 10
               END IF
            END IF
C                                       Fill residual values
         AVER = RESULT(INPARM+1)
         IF (DOCONT.LE.0.0) AVER = 0.0
         DO 40 I = 1,INPTS
            IF (DATA(I).EQ.FBLANK) THEN
               RESIDS(I) = FBLANK
            ELSE
               RESIDS(I) = FVEC(I) + AVER
               END IF
 40         CONTINUE
         SOLVED = SOLVED + 1.0
C                                       Max / Min
         IF (DOCAT.GT.0.) THEN
            DO 45 I = 1,OUPARM
               IF (RESULT(I).NE.FBLANK) THEN
                  PMAX(I) = MAX (PMAX(I), RESULT(I))
                  PMIN(I) = MIN (PMIN(I), RESULT(I))
                  END IF
 45            CONTINUE
            END IF
         GO TO 990
C                                       Blank outputs
 900     IF (DOCAT.GT.0.) CALL RFILL (OUPARM, FBLANK, RESULT)
         DO 910 I = 1,INPTS
            RESIDS(I) = DATA(I)
 910        CONTINUE
         IGNORD = IGNORD + 1.0
         END IF
C                                       close TV on error
 990  IF (DEVON.EQ.2) THEN
         CALL TVCLOS (INBUF, IERR)
      ELSE IF (DEVON.EQ.1) THEN
         CALL ZTKCLS (IERR)
         END IF
      DEVON = 0
C
 999  RETURN
      END
      SUBROUTINE XBALMS (INPTS, PARMS)
C-----------------------------------------------------------------------
C   XBALMS computes the answers
C   Inputs:
C      INPTS   I      Number data points
C   Output:
C      PARMS   R(9)   Answers (1 - 8), sigma ** 2 (9)
C-----------------------------------------------------------------------
      INTEGER   INPTS
      REAL      PARMS(9)
C
      INTEGER   I, J
      REAL      YBAR, YBAR2
      INCLUDE 'XBASL2.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       clear sum variables
      DO 10 I = 1,9
         PARMS(I) = 0.0
 10      CONTINUE
      YBAR = 0.0
      YBAR2 = 0.0
C                                       sum: data, data**2
C                                       data*polyfunc(j)
      DO 30 I = 1,INPTS
         IF ((MASK(I).EQ.1) .AND. (DATA(I).NE.FBLANK)) THEN
            YBAR = YBAR + DATA(I)
            YBAR2 = YBAR2 + DATA(I)**2
            DO 20 J = 1,JJC
               PARMS(J) = PARMS(J) + DATA(I) * POLXFN(I,J)
 20            CONTINUE
            END IF
 30      CONTINUE
C                                       average
C                                       sigma**2=ybar2-sum(parms**2)
      YBAR = YBAR / NPTS
      YBAR2 = YBAR2 / NPTS
      PARMS(9) = YBAR2
      DO 40 J = 1,JJC
         PARMS(J) = PARMS(J) / NPTS
         PARMS(9) = PARMS(9) - PARMS(J)**2
 40      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE XBASGE (NG, ND, FC, LCODE, PIXVAL, PARMS, IERR)
C-----------------------------------------------------------------------
C   XBASGE obtains an initial guess for the parameters of the baseline.
C   It sets a linear one only.
C   Inputs:
C      NG       I         order of polynomial
C      ND       I         Number of data samples
C      FC       R         Flux cutoff
C      PIXVAL   R         No plot if peak > PIXVAL
C   In/out:
C      LCODE    I         in: 1 => plot possible, out: 1 => wanted
C   Output:
C      PARMS    R(NG+1)   Guess to use
C      IERR     I         0 => ok, 1 => all data too low
C                         2 => input error
C-----------------------------------------------------------------------
      INTEGER   NG, ND, LCODE, IERR
      REAL      FC, PIXVAL, PARMS(9)
C
      INTEGER   IM, I, NS
      REAL      X, XM, R, BLS, BLO, BL, BLP, BLM, SD, SDX, SX, SXX
      INCLUDE 'XBASL2.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Fit baseline
      BLS = 0.
      BLO = 0.
      DO 10 I = 1,9
         PARMS(I) = 0.0
 10      CONTINUE
      NS = 0
      SD = 0.0
      SX = 0.0
      SXX = 0.0
      SDX = 0.0
      DO 20 I = 1,ND
         IF ((MASK(I).EQ.1) .AND. (DATA(I).NE.FBLANK)) THEN
            NS = NS + 1
            SD = SD + DATA(I)
            IF (NG.GT.0) THEN
               R = I + XBAR
               SX = SX + R
               SXX = SXX + R * R
               SDX = SDX + R * DATA(I)
               END IF
            END IF
 20      CONTINUE
      IF (NS.LT.NG+1) THEN
         IERR = 3
         GO TO 999
         END IF
      R = NS * SXX - SX * SX
      IF (R.NE.0.0) BLS = (NS * SDX - SD * SX) / R
      IF (NS.GT.0) BLO = (SD - BLS * SX) / NS
      PARMS(1) = BLO
      PARMS(2) = BLS
C                                       Are there 3 big enough
C                                       and do we want to plot
      IM = 0
      XM = 0.
      DO 40 I = 2,ND
         IF ((I.NE.ND) .AND. (DATA(I).NE.FBLANK)) THEN
            R = I + XBAR
            BL = DATA(I) - BLO - BLS * R
            IF ((ABS(BL).GE.FC) .AND. (DATA(I-1).NE.FBLANK) .AND.
     *         (DATA(I+1).NE.FBLANK)) THEN
               BLM = DATA(I-1) - BLO - BLS * (R-1.)
               BLP = DATA(I+1) - BLO - BLS * (R+1.)
               IF (((BL.GT.0.0) .AND. (BLP.GE.FC) .AND. (BLM.GE.FC))
     *            .OR. ((BL.LT.0.0) .AND. (-BLP.GE.FC) .AND.
     *            (-BLM.GE.FC))) THEN
                  X = ABS (BLP + BL + BLM)
                  IF (X.GT.XM) THEN
                     XM = X
                     IM = I
                     END IF
                  END IF
               END IF
            END IF
 40      CONTINUE
C                                       Find anything?
      IF (IM.LT.1) THEN
         IERR = 1
         LCODE = 0
C                                       test desire to plot
      ELSE
         IERR = 0
         IF (XM/3.0.GT.PIXVAL) LCODE = 0
         END IF
C
 999  RETURN
      END
      SUBROUTINE XBASFI (NP, PARMS, RESULT)
C-----------------------------------------------------------------------
C   XBASFI determines the errors in the fit and converts the results
C   to normal units for output.
C   Inputs:
C      NP       I       Number of parameters (max) - JJC gives number
C                          fit this time
C      PARMS    R(9)    Answers from XBALMS
C   Output:
C      RESULT   R(18)   Answers then errors in normal units
C-----------------------------------------------------------------------
      INTEGER   NP
      REAL      PARMS(9), RESULT(18)
C
      INTEGER   I, JC, L, J
      DOUBLE PRECISION    OLDD(128)
      REAL      OLDR(256), R, AVER
      INTEGER   CATOLD(256)
      INCLUDE 'XBASL2.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /MAPHDR/ CATOLD
      EQUIVALENCE (CATOLD, OLDR, OLDD)
C-----------------------------------------------------------------------
C                                       Convert to output
      IF (PARMS(9).GT.0.0) PARMS(9) = SQRT (PARMS(9))
      IF (OLDR(KRCIC).EQ.0.0) OLDR(KRCIC) = 1.0
      R = 1.0
      JC = NP + 1
      DO 20 I = 1,NP
         L = I + JC
         RESULT(I) = FBLANK
         RESULT(L) = FBLANK
         IF (I.LE.JJC) THEN
            RESULT(I) = 0.0
            RESULT(L) = 0.0
            DO 10 J = I,JJC
               RESULT(I) = RESULT(I) + PARMS(J) * CARRAY(J,I)
               RESULT(L) = RESULT(L) + CARRAY(J,I) ** 2
 10            CONTINUE
            RESULT(I) = RESULT(I) * R
            RESULT(L) = PARMS(9) * SQRT (RESULT(L)/NPTS) * ABS(R)
            R = R / OLDR(KRCIC)
            END IF
 20      CONTINUE
C                                       flux
      R = 0.0
      AVER = 0.0
      DO 30 J = 1,JJC
         AVER = AVER + PARMS(J) * POLAVG(J)
         R = R + POLAVG(J) ** 2
 30      CONTINUE
      RESULT(JC) = AVER
      RESULT(2*JC) = PARMS(9) * SQRT (R/NPTS)
C
 999  RETURN
      END
      SUBROUTINE XBFUNC (NDATA, PARMS, FVEC)
C-----------------------------------------------------------------------
C   XBFUNC computes the difference between the data and the model
C   Inputs:
C      NDATA   I      Number of data points in row
C      PARMS   R(9)   factors of orthogonal polynomials
C   Common: /GDATA/
C      DATA    R(?)   Original slice data points.
C   Output:
C      FVEC    R(*)   Slice data points minus data points evaluated for
C                     current guess.
C-----------------------------------------------------------------------
      INTEGER   NDATA
      REAL      PARMS(9), FVEC(*)
C
      INTEGER   I, J
      REAL      SUM
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'XBASL2.INC'
C-----------------------------------------------------------------------
C                                       Determine difference between
C                                       data and current fit.
      DO 20 I = 1,NDATA
         FVEC(I) = FBLANK
         IF (DATA(I).NE.FBLANK) THEN
            SUM = 0.0
            DO 10 J = 1,JJC
               SUM = SUM + PARMS(J) * POLXFN(I,J)
 10            CONTINUE
            FVEC(I) = DATA(I) - SUM
            END IF
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE BTKINI (IPOS, INPTS, NORDER, LABEL, PIXR, DOSLIC,
     *   PARMS, NBOXES, NBOX, PORDER, ORANGE, FVEC, IERR)
C-----------------------------------------------------------------------
C   BTKINI initializes the TEK for a XBASL plot, plots axis labels,
C   and, if requested, plots the data.
C   Inputs:
C      IPOS     I(7)      Position in cube first point in row.
C      INPTS    I         Number of points in row.
C      LABEL    I         Requested label type
C      PIXR     R(2)      Requested plot value range
C      DOSLIC   R         > 0. => plot data
C      PARMS    R(10)     Initial guess
C      NBOXES   I         # windows
C      NBOX     I(2,20)   windows
C      PORDER   R         Max polynomial order
C   Output:
C      NORDER   I         Order of polynomial to use now
C      ORANGE   R(2)      Actual plot range in plot units
C      FVEC     R(*)      Scratch buffer
C      IERR     I         > 0 => plot failed
C                         101 => bad initial guess
C                         102 => DIE
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), INPTS, NORDER, LABEL, NBOXES, NBOX(2,20), IERR
      REAL      PIXR(2), DOSLIC, PARMS(9), PORDER, ORANGE(2), FVEC(*)
C
      CHARACTER TEMP*1, TEXT(2)*80, MSGBUF*132, NTEXT*80
      REAL      XBLC(7), XTRC(7), PBLC(2), PTRC(2), YGAP, CH(4), XYRATO,
     *   X, XX, Y, XFAC, XOFF, DX, DY, Y1, Y2, X1,  X2, Y3, Y4, FQFINC
      DOUBLE PRECISION FQFREQ
      INTEGER   IT, IDROP(2), IX1, IX2, IY1, IY2, ICHL, ICHB, ICHR,
     *   ICHT, NXA, NYA, I, J, JERR, TTYLUN, TTYIND, IPLANE, I4XTRA
      LOGICAL   T, F, BLAST, BNEXT
      INCLUDE 'XBASL2.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTKS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA TTYLUN /5/
C-----------------------------------------------------------------------
C                                       inits, open TEK
      CALL ZTKOPN (IERR)
      IF (IERR.GT.1) GO TO 999
      DEVON = 1
      CALL TKCATL ('INIT', I, I, CATBLK, IERR)
      IF (IERR.GT.1) GO TO 999
C                                       "Slice" corners
      IDROP(1) = 0
      IDROP(2) = 0
      DO 10 I = 1,7
         XBLC(I) = IPOS(I)
         XTRC(I) = XBLC(I)
 10      CONTINUE
      XTRC(1) = XBLC(1) + INPTS - 1
C                                       Set PIX ranges
      ORANGE(1) = PIXR(1)
      ORANGE(2) = PIXR(2)
C                                       Default: actual range
      IF (PIXR(2).LE.PIXR(1)) THEN
         ORANGE(1) = 1.0E10
         ORANGE(2) = -ORANGE(1)
         DO 15 I = 1,INPTS
            IF (DATA(I).NE.FBLANK) THEN
               ORANGE(1) = MIN (ORANGE(1), DATA(I))
               ORANGE(2) = MAX (ORANGE(2), DATA(I))
               END IF
 15         CONTINUE
         XFAC = ORANGE(2) - ORANGE(1)
         ORANGE(2) = ORANGE(2) + 0.25 * XFAC
         ORANGE(1) = ORANGE(1) - 0.25 * XFAC
         END IF
      CATR(IRRAN) = ORANGE(1)
      CATR(IRRAN+1) = ORANGE(2)
      XFAC = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      XOFF = 40000.0 - XFAC * CATR(IRRAN+1)
      PBLC(2) = ORANGE(1) * XFAC + XOFF
      PTRC(2) = ORANGE(2) * XFAC + XOFF
C                                       Label inits
      LOCNUM = 1
      FQFINC = 0.0
      FQFREQ = 0.0D0
      CALL SLBINI (IDROP, INPTS, ORANGE, PBLC, PTRC, XBLC, XTRC,
     *   FQFREQ, FQFINC, CATBLK(IIDEP), LABEL, YGAP, CH, TEXT, NTEXT)
      ORANGE(1) = XFAC*ORANGE(1) + XOFF
      ORANGE(2) = XFAC*ORANGE(2) + XOFF
      XYRATO = (PTRC(2) - PBLC(2)) / (PTRC(1) - PBLC(1))
      IX1 = PBLC(1) + .5
      IY1 = PBLC(2) + .5
      IX2 = PTRC(1) + .5
      IY2 = PTRC(2) + .5
      ICHL = CH(1) * CSIZTK(1) + .5
      ICHB = CH(2) * CSIZTK(2) + .5
      ICHR = CH(3) * CSIZTK(1) + .5
      ICHT = CH(4) * CSIZTK(2) + .5
      NYA = MAXXTK(2) - ICHT -ICHB -1
      NXA = MAXXTK(1) - ICHL - ICHR - 1
C                                       compute scaling
      X = IX2
      X = ABS (X - IX1)
      XX = X * XYRATO
      Y = IY2
      Y = ABS (Y - IY1)
      IF ((XX.LE.0.0) .OR. (Y.LE.0.0)) THEN
         WRITE (MSGTXT,1020)
         CALL MSGWRT (8)
         IERR = 1
         GO TO 999
         END IF
      IF ((XX/Y).LE.FLOAT(NXA)/FLOAT(NYA)) THEN
         SCALEY = NYA / Y
         SCALEX = SCALEY * Y / X
      ELSE
         SCALEX = NXA / X
         SCALEY = SCALEX * X / Y
         END IF
C
      NXA = SCALEX * X + ICHL + ICHR
      RX0 = ICHL + MAX (0, MAXXTK(1)-NXA) / 2 + 1
      NYA = SCALEY * Y + ICHB + ICHT
      RY0 = ICHB + MAX (0, MAXXTK(2)-NYA) / 2 + 1
C                                       Put stuff in image catalog.
      CATBLK(IIWIN  ) = IX1
      CATBLK(IIWIN+1) = IY1
      CATBLK(IIWIN+2) = IX2
      CATBLK(IIWIN+3) = IY2
      CATBLK(IICOR  ) = RX0 + 0.5
      CATBLK(IICOR+1) = RY0 + 0.5
      CATBLK(IICOR+2) = RX0 + X * SCALEX + 0.5
      CATBLK(IICOR+3) = RY0 + Y * SCALEY + 0.5
      CATBLK(IIPLT) = 5
      CATBLK(IIOTH) = LABEL
      CATBLK(IIOTH+1) = IDROP(1)
      CATBLK(IIOTH+2) = IDROP(2)
      I4XTRA = IIOTH + 3
      CATR(I4XTRA  ) = XBLC(1)
      CATR(I4XTRA+1) = XBLC(2)
      CATR(I4XTRA+2) = XTRC(1)
      CATR(I4XTRA+3) = XTRC(2)
      CALL TKCATL ('WRIT', IPLANE, IPLANE, CATBLK, IERR)
C                                       set scale for plot routines
      RX0 = RX0 - PBLC(1) * SCALEX + 0.5
      RY0 = RY0 - PBLC(2) * SCALEY + 0.5
C                                       label the plot
      CALL TKLAB (PBLC, PTRC, LABEL, YGAP, TEXT, NTEXT, CH, F, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       add pixel coordinates
      DX = -8.5
      DY = -2.0
      CALL TEKVEC (PTRC(1), PTRC(2), 1, IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (MSGBUF,1060) IPOS(2)
      J = 7
      CALL TKCHAR (J, 0, DX, DY, MSGBUF, IERR)
      IF (IERR.NE.0) GO TO 999
      DY = DY - 1.5
      CALL TEKVEC (PTRC(1), PTRC(2), 1, IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (MSGBUF,1061) IPOS(3)
      CALL TKCHAR (J, 0, DX, DY, MSGBUF, IERR)
      IF (IERR.NE.0) GO TO 999
      DY = DY - 1.5
      CALL TEKVEC (PTRC(1), PTRC(2), 1, IERR)
      IF (IERR.NE.0) GO TO 999
      I = JJC - 1
      WRITE (MSGBUF,1062) I
      CALL TKCHAR (J, 0, DX, DY, MSGBUF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       plot data
      IF (DOSLIC.GT.0.) THEN
         BLAST = .TRUE.
         DO 70 I = 1,INPTS
            BNEXT = DATA(I).EQ.FBLANK
            IF (.NOT.BNEXT) THEN
               X = I - 0.5
               Y = DATA(I) * XFAC + XOFF
               Y = MIN (ORANGE(2), MAX (ORANGE(1), Y))
               J = 2
               IF (BLAST) J = 1
               CALL TEKVEC (X, Y, J, IERR)
               IF (IERR.NE.0) GO TO 999
               X = I + 0.5
               J = 2
               CALL TEKVEC (X, Y, J, IERR)
               IF (IERR.NE.0) GO TO 999
               END IF
            BLAST = BNEXT
 70         CONTINUE
         END IF
      IF (DOSLIC.GT.1.0) THEN
         DO 90 I = 1,NBOXES
            IT = NBOX(1,I)
 75         IF (DATA(IT).EQ.FBLANK) THEN
               IT = IT + 1
               IF (IT.GT.NBOX(2,I)) GO TO 90
               GO TO 75
               END IF
            X1 = NBOX(1,I)
            Y = DATA(IT) * XFAC + XOFF
            Y1 = Y + 0.15 * (ORANGE(2) - ORANGE(1))
            Y2 = Y - 0.15 * (ORANGE(2) - ORANGE(1))
            Y1 = MIN (ORANGE(2), MAX (ORANGE(1), Y1))
            Y2 = MIN (ORANGE(2), MAX (ORANGE(1), Y2))
            IT = NBOX(2,I)
 80         IF (DATA(IT).EQ.FBLANK) THEN
               IT = IT - 1
               IF (IT.LT.NBOX(1,I)) GO TO 90
               GO TO 80
               END IF
            X2 = NBOX(2,I)
            Y = DATA(IT) * XFAC + XOFF
            Y3 = Y + 0.15 * (ORANGE(2) - ORANGE(1))
            Y4 = Y - 0.15 * (ORANGE(2) - ORANGE(1))
            Y3 = MIN (ORANGE(2), MAX (ORANGE(1), Y3))
            Y4 = MIN (ORANGE(2), MAX (ORANGE(1), Y4))
            CALL TEKVEC (X1, Y1, 1, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TEKVEC (X1, Y2, 2, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TEKVEC (X2, Y4, 2, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TEKVEC (X2, Y3, 2, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TEKVEC (X1, Y1, 2, IERR)
            IF (IERR.NE.0) GO TO 999
 90         CONTINUE
         END IF
C                                       alpha mode
      I = 31
      CALL ZTKBUF (I, 1, IERR)
      CALL TEKFLS (IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Talk to user
      IF (DOSLIC.GT.1.0) THEN
         CALL ZOPEN (TTYLUN, TTYIND, 1, MSGBUF, F, T, T, JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1900) JERR
            CALL MSGWRT (6)
            GO TO 999
            END IF
C                                       change order of polynomial
 910     I = PORDER + 0.01
         IF (I.GT.0) THEN
            WRITE (MSGBUF,1910) I
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, JERR)
            IF (JERR.NE.0) GO TO 920
            CALL ZTTYIO ('READ', TTYLUN, TTYIND, 72, MSGBUF, JERR)
            IF (JERR.NE.0) GO TO 920
            READ (MSGBUF,1911) TEMP, J
            IF ((TEMP.EQ.'C') .OR. (TEMP.EQ.'c')) THEN
               IF ((J.LT.0) .OR. (J.GT.I)) GO TO 910
               NORDER = J
               IF (NORDER.LT.1) PARMS(2) = 0.0D0
               END IF
            END IF
C                                       Quit etc
         WRITE (MSGBUF,1915)
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, JERR)
         IF (JERR.NE.0) GO TO 920
         CALL ZTTYIO ('READ', TTYLUN, TTYIND, 72, MSGBUF, JERR)
         IF (JERR.NE.0) GO TO 920
         READ (MSGBUF,1916) TEMP
         IF ((TEMP.EQ.'B') .OR. (TEMP.EQ.'b')) THEN
            IERR = 101
         ELSE IF ((TEMP.EQ.'Q') .OR. (TEMP.EQ.'q')) THEN
            IERR = 102
         ELSE IF ((TEMP.EQ.'E') .OR. (TEMP.EQ.'e')) THEN
            IERR = 103
            END IF
         GO TO 930
C                                       TTY error
 920     WRITE (MSGTXT,1920) JERR
         CALL MSGWRT (6)
 930     CALL ZCLOSE (TTYLUN, TTYIND, JERR)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('SCALING ERROR.')
 1060 FORMAT ('Y=',I5)
 1061 FORMAT ('Z=',I5)
 1062 FORMAT ('Order=',I1)
 1900 FORMAT ('OPEN TERMINAL ERROR',I7)
 1910 FORMAT ('??? Type ''C0'' TO ''C',I1,''' to change order of',
     *   ' polynomial')
 1911 FORMAT (A1,I1)
 1915 FORMAT ('??? Type ''E'' to enter windows, ''B'' to skip row,',
     *   ' hit return to procede')
 1916 FORMAT (A1)
 1920 FORMAT ('TERMINAL I/O ERROR',I7)
      END
      SUBROUTINE BTKGUS (INPTS, ORANGE, NBOXES, NBOX, FVEC, IERR)
C-----------------------------------------------------------------------
C   BTKGUS has the user point at the desired baseline windows setting
C   COMMON parameters NBOXES and NBOX.
C   Inputs:
C      INPTS    I         Number data points in row
C      ORANGE   R(2)      Plot range in plot units
C   Output:
C      NBOXES   I         Number windows
C      NBOX     I(2,20)   Window parameters
C      FVEC     R(*)      Work buffer
C      IERR     I         error code: 0 -> ok
C-----------------------------------------------------------------------
      INTEGER   INPTS, IERR, NBOXES, NBOX(2,20)
      REAL      FVEC(*), ORANGE(2)
C
      CHARACTER MSGBUF*80
      REAL      XFAC, XOFF, DY, Y, X1, X2
      INTEGER   I, J, TTYLUN, TTYIND, IXT, IYT, IX, IY, IX0, IY0, JERR
      LOGICAL   T, F
      INCLUDE 'XBASL2.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTKS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA TTYLUN /5/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Set scales
      XFAC = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      XOFF = 40000.0 - XFAC * CATR(IRRAN+1)
      IXT = RX0 + SCALEX * INPTS + 0.5
      IYT = RY0 + SCALEY * ORANGE(2) + 0.5
      IX0 = RX0 + SCALEX + 0.5
      IY0 = RY0 + SCALEY * ORANGE(1) + 0.5
C                                       Open terminal
      CALL ZOPEN (TTYLUN, TTYIND, 1, MSGBUF, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Loop over components.
 20   DO 40 I = 1,20
C                                       read left edge window
         WRITE (MSGBUF,1020) I
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL TKCURS (FVEC, IX, IY, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       suppress double hitting
         CALL ZTKCLS (IERR)
         CALL ZTKOPN (IERR)
C                                       Set it
         IF ((IY.LT.IY0) .OR. (IX.GT.IXT) .OR. (IY.GT.IYT)) GO TO 50
         IX = MAX (IX, IX0)
         NBOX(1,I) = (IX - RX0) / SCALEX + 0.5
C                                       read right edge
         WRITE (MSGBUF,1021) I
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL TKCURS (FVEC, IX, IY, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       suppress double hitting
         CALL ZTKCLS (IERR)
         CALL ZTKOPN (IERR)
C                                       Set it
         IF ((IX.LT.IX0) .OR. (IY.LT.IY0) .OR. (IY.GT.IYT)) GO TO 50
         IX = MIN (IX, IXT)
         NBOX(2,I) = (IX - RX0) / SCALEX + 0.5
         IF (NBOX(2,I).LT.NBOX(1,I)) THEN
            IX = NBOX(2,I)
            NBOX(2,I) = NBOX(1,I)
            NBOX(1,I) = IX
            END IF
         NBOX(1,I) = MAX (1, NBOX(1,I))
         NBOX(2,I) = MIN (INPTS, NBOX(2,I))
         NBOXES = I
 40      CONTINUE
 50   IF (NBOXES.LE.0) GO TO 20
C                                       Plot new windows
      DY = (ORANGE(2) - ORANGE(1)) / 20.0
      DO 60 I = 1,NBOXES
         J = (NBOX(1,I) + NBOX(2,I)) / 2
         X1 = NBOX(1,I)
         X2 = NBOX(2,I)
         Y = DATA(J) * XFAC + XOFF
         Y = MIN (ORANGE(2), MAX (ORANGE(1), Y))
         CALL TEKVEC (X1, Y+DY, 1, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL TEKVEC (X1, Y-DY, 2, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL TEKVEC (X2, Y-DY, 2, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL TEKVEC (X2, Y+DY, 2, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL TEKVEC (X1, Y+DY, 2, IERR)
         IF (IERR.NE.0) GO TO 990
 60      CONTINUE
C                                       alpha mode
      I = 31
      CALL ZTKBUF (I, 1, IERR)
      CALL TEKFLS (IERR)
      GO TO 990
C                                       terminal error
 900  WRITE (MSGTXT,1900) IERR
      CALL MSGWRT (6)
C                                       Close TTY anyway
 990  CALL ZCLOSE (TTYLUN, TTYIND, JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' OPENING TERMINAL')
 1020 FORMAT ('Position cursor at left edge of window ',I2)
 1021 FORMAT ('Position cursor at right edge of window ',I2)
 1900 FORMAT ('ERROR',I5,' WRITING TO TERMINAL')
      END
      SUBROUTINE BTKMOD (DOMODL, DORESI, INPTS, NG, ORANGE, FVEC, PERR,
     *   IERR)
C-----------------------------------------------------------------------
C   BTKMOD plots the residual and model functions on the TEK.  It asks
C   the user for permission to proceed.
C   Inputs:
C       DOMODL   R      > 0. => plot model
C       DORESI   R      > 0. => plot residuals
C       INPTS    I      Number of data points
C       NG       I      Order of baseline (max)
C       ORANGE   R(2)   Plot intensity range (plot units)
C       FVEC     R(*)   data - model
C       PERR     I      > 0 => probable parameter bad
C  Output:
C       IERR     I      TEK error code
C                          101 => blank this solution
C                          102 => User wants to quit
C                          103 => do a retry
C-----------------------------------------------------------------------
      INTEGER   INPTS, NG, PERR, IERR
      REAL      FVEC(*), DOMODL, DORESI, ORANGE(2)
C
      CHARACTER TEMP*1, MSGBUF*80
      INTEGER   I, J, TTYLUN, TTYIND, NPPL, K, JERR
      REAL      XFAC, XOFF, X, Y, XP, YP, TP, DX, DY
      LOGICAL   BLAST, T, F
      INCLUDE 'XBASL2.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTKS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA TTYLUN /5/
C-----------------------------------------------------------------------
      IERR = 0
      IF ((DOMODL.LE.0.) .AND. (DORESI.LE.0.)) GO TO 900
      XFAC = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      XOFF = 40000.0 - XFAC * CATR(IRRAN+1)
C                                       Plot residuals
      K = 0
      IF (DORESI.GT.0.) THEN
C                                       Do any show?
         DO 10 I = 1,INPTS
            IF (DATA(I).EQ.FBLANK) GO TO 10
               Y = FVEC(I) * XFAC + XOFF
               IF ((Y.LT.ORANGE(2)) .AND. (Y.GT.ORANGE(1))) K = K + 1
 10         CONTINUE
         END IF
      IF (K.GT.1) THEN
         BLAST = .TRUE.
         DO 30 I = 1,INPTS
            IF (DATA(I).EQ.FBLANK) THEN
               BLAST = .TRUE.
            ELSE
               X = I
               Y = FVEC(I) * XFAC + XOFF
               XP = X * SCALEX + RX0 - RXL
               YP = Y * SCALEY + RY0 - RYL
               TP = MAX (ABS(XP), ABS(YP))
               NPPL = (TP + 9) / 16.0 + 0.5
               IF (BLAST) NPPL = 1
               XP = (RXL - RX0) / SCALEX
               YP = (RYL - RY0) / SCALEY
               DX = (X - XP) / NPPL
               DY = (Y - YP) / NPPL
               DO 25 K = 1,NPPL
                  X = XP + (K-0.6) * DX
                  Y = YP + (K-0.6) * DY
                  Y = MIN (ORANGE(2), MAX (ORANGE(1), Y))
                  J = 2
                  IF ((BLAST) .OR. (MOD(K,2).EQ.0)) J = 1
                  CALL TEKVEC (X, Y, J, IERR)
                  IF (IERR.NE.0) GO TO 100
                  X = XP + K * DX
                  Y = YP + K * DY
                  Y = MIN (ORANGE(2), MAX (ORANGE(1), Y))
                  J = 1
                  CALL TEKVEC (X, Y, J, IERR)
                  IF (IERR.NE.0) GO TO 100
 25               CONTINUE
               BLAST = .FALSE.
               END IF
 30         CONTINUE
         END IF
C                                       Plot model
      IF (DOMODL.GT.0.) THEN
         BLAST = .TRUE.
         DO 60 I = 1,INPTS
            IF (DATA(I).EQ.FBLANK) THEN
               BLAST = .TRUE.
            ELSE
               X = I
               Y = (DATA(I) - FVEC(I)) * XFAC + XOFF
               Y = MIN (ORANGE(2), MAX (ORANGE(1), Y))
               J = 2
               IF (BLAST) J = 1
               CALL TEKVEC (X, Y, J, IERR)
               IF (IERR.NE.0) GO TO 100
               BLAST = .FALSE.
               END IF
 60         CONTINUE
         END IF
C                                       Alpha mode
 100  I = 31
      CALL ZTKBUF (I, 1, IERR)
      CALL TEKFLS (IERR)
      BLAST = PERR.GT.0
C                                       talk to user
 900  CALL ZOPEN (TTYLUN, TTYIND, 1, MSGBUF, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1900) IERR
         CALL MSGWRT (6)
         GO TO 999
         END IF
      IF (BLAST) THEN
         WRITE (MSGBUF,1910)
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         END IF
      IF (NG.GT.1) THEN
         WRITE (MSGBUF,1915)
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         END IF
      WRITE (MSGBUF,1920)
      CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL ZTTYIO ('READ', TTYLUN, TTYIND, 72, MSGBUF, IERR)
      IF (IERR.NE.0) GO TO 980
      READ (MSGBUF,1921) TEMP
      CALL CHLTOU (4, TEMP)
      IF ((TEMP.EQ.'B') .OR. (TEMP.EQ.'b')) THEN
         IERR = 101
      ELSE IF ((TEMP.EQ.'Q') .OR. (TEMP.EQ.'q')) THEN
         IERR = 102
      ELSE IF ((TEMP.EQ.'R') .OR. (TEMP.EQ.'r')) THEN
         IF (NG.GT.1) IERR = 103
         END IF
      GO TO 990
C                                       TTY error
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (6)
 990  CALL ZCLOSE (TTYLUN, TTYIND, JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('OPEN TERMINAL ERROR',I7)
 1910 FORMAT ('>>>> PARAMETERS SEEM OUT OF RANGE.  SOLUTION PROBABLY ',
     *   'BAD! <<<<')
 1915 FORMAT ('**** Enter RETR to repeat the row (must enter a guess)')
 1920 FORMAT ('**** Enter BAD to flag solution, QUIT to die, ',
     *   'Hit return to continue')
 1921 FORMAT (A1)
 1980 FORMAT ('TERMINAL I/O ERROR',I7)
      END
      SUBROUTINE XBASOU (BLNKD, IRET)
C-----------------------------------------------------------------------
C   XBASOU, if any, creates and fills (via PSCALE) the individual
C   baseline parameters.  It calls XBASHI for history info for all.
C   Inputs:
C      BLNKD   L   Are any parameters blanked?
C   Output:
C      IRET    I   0 => ok,  4 => real trouble.
C-----------------------------------------------------------------------
      INTEGER   IRET
      LOGICAL   BLNKD
C
      CHARACTER SEQTYP*6
      INTEGER   NG, NXO, NYO, WINI(4), WINO(4), IERR, IP, NCN,
     *   IG, IOFF
      INCLUDE 'XBASL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      NCN = 2
C                                       Residual map history
      CALL XBASHI (IRET, NCN)
      IF (DOCAT.LE.0.0) GO TO 999
C                                       loop limits etc.
      NG = PORDER + 2.01
      WINI(1) = 1
      WINI(2) = 1
      WINI(3) = 2 * NG
      WINO(1) = 1
      WINO(2) = 1
C                                       Output all parms
      DO 30 IG = 1,NG
         DO 20 IP = 1,2
            IOFF = IG
            IF (IP.EQ.2) IOFF = NG + IP
            NCN = NCN + 1
            NEWCNO = FCNO(NCN)
            DISKO = FVOL(NCN)
            CALL CATIO ('READ', DISKO, NEWCNO, CATBLK, 'REST', IBUFF1,
     *         IERR)
            IF ((IERR.NE.0) .AND. (IERR.NE.6)) THEN
               WRITE (MSGTXT,1001) IERR, NCN
               GO TO 990
               END IF
            CALL H2CHR (6, KHIMCO, CATH(KHIMC), SEQTYP)
            WRITE (MSGTXT,1010) SEQTYP
            CALL MSGWRT (1)
            SEQOUT = CATBLK(KIIMS)
            CALL H2CHR (12, KHIMNO, CATR(KHIMN), NAMOUT)
            CALL H2CHR (6, KHIMCO, CATR(KHIMC), CLAOUT)
            NXO = CATBLK(KINAX)
            NYO = CATBLK(KINAX+1)
            WINI(4) = NXO
            WINO(3) = NXO
            WINO(4) = NYO
C                                       Fill image
            CALL PSCALE (IOFF, NSCR, WINI, NEWCNO, DISKO, WINO, JBUFSZ,
     *         PMAX, PMIN, BLNKD, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1011) IERR, SEQTYP
               GO TO 990
               END IF
C                                       History, close
            CALL XBASHI (IOFF, NCN)
 20         CONTINUE
 30      CONTINUE
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
      IRET = 4
C
 999  RETURN
C-----------------------------------------------------------------------
 1001 FORMAT ('ERROR',I5,' RECOVERING FILE HEADER NUMBER',I5)
 1010 FORMAT ('Begin writing file of type ',A6)
 1011 FORMAT ('ERROR',I5,' MOVING DATA TO FILE TYPE ',A)
      END
      SUBROUTINE PSCALE (IOFF, ISCR, WINI, NEWCNO, DISKO, WINO, JBUFSZ,
     *   PMAX, PMIN, BLNKD, IERR)
C-----------------------------------------------------------------------
C   PSCALE reads a floating point map file extracting one point per row
C   and writes an image out.
C   Inputs:
C      IOFF     I       Pixel in row to extract (1-rel)
C      ISCR     I       Scratch file number in CFIL common
C      WINI     I(4)    Input window
C      NEWCNO   I       Output catalog number
C      DISKO    I       Output disk number
C      WINO     I(4)    Output Window
C      JBUFSZ   I       Buffer size in bytes
C      PMAX     R(22)   Max values by columns
C      PMIN     R(22)   Min values by columns
C      BLNKD    L       Image is blanked
C   Output:
C      IERR     I       0 -> ok, else IO error
C      CATBLK in common: change max/min and scaling and blanking
C      Buffers in common
C-----------------------------------------------------------------------
      INTEGER   IOFF, ISCR, WINI(4), NEWCNO, DISKO, WINO(4), JBUFSZ,
     *   IERR
      REAL      PMAX(22), PMIN(22)
      LOGICAL   BLNKD
C
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER PHNAME*48
      LOGICAL   T
      INTEGER   NXO, L3, L4, L5, L6, L7, I2, I3, I4, I5, I6, I7, J,
     *   LUNI, LUNO, INDI, INDO, IPOS(8), NAXT(8), INDIM, BOTEMP, OBIND,
     *   IBIND, L, JERR
      REAL      BUFF1(MABFSS), BUFF2(MABFSS)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /BUFRS/ BUFF1, BUFF2
      DATA T /.TRUE./
      DATA LUNI, LUNO /16, 17/
C-----------------------------------------------------------------------
C                                       Set maxima, clear blanking
      CATR(KRDMX) = PMAX(IOFF)
      CATR(KRDMN) = PMIN(IOFF)
      CATR(KRBLK) = 0.0
C                                       Floating output
      IF (BLNKD) CATR(KRBLK) = FBLANK
C                                       loop limits
      L3 = CATBLK(KINAX+1)
      L4 = CATBLK(KINAX+2)
      L5 = CATBLK(KINAX+3)
      L6 = CATBLK(KINAX+4)
      L7 = CATBLK(KINAX+5)
      NXO = WINO(3)
C                                       Open files
      CALL ZPHFIL ('SC', SCRVOL(ISCR), SCRCNO(ISCR), 1, PHNAME, IERR)
      CALL ZOPEN (LUNI, INDI, SCRVOL(ISCR), PHNAME, T, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, PHNAME, IERR)
      CALL ZOPEN (LUNO, INDO, DISKO, PHNAME, T, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1035) IERR
         CALL MSGWRT (8)
         GO TO 980
         END IF
C                                       Prepare to read
      IPOS(8) = 1
      CALL COPY (7, CATBLK(KINAX), NAXT(2))
      NAXT(1) = WINI(3)
      INDIM = CATBLK(KIDIM) + 1
C                                       loop
      DO 700 I7 = 1,L7
         IPOS(7) = I7
         DO 600 I6 = 1,L6
            IPOS(6) = I6
            DO 500 I5 = 1,L5
               IPOS(5) = I5
               DO 400 I4 = 1,L4
                  IPOS(4) = I4
C                                       Init output
                  CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IPOS(4),
     *               BOTEMP, IERR)
                  BOTEMP = BOTEMP + 1
                  CALL MINIT ('WRIT', LUNO, INDO, WINO(3), WINO(4),
     *               WINO, BUFF2, JBUFSZ, BOTEMP, IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1100) IERR
                     GO TO 970
                     END IF
                  DO 300 I3 = 1,L3
                     IPOS(3) = I3
                     CALL COMOFF (INDIM, NAXT, IPOS(3), BOTEMP, IERR)
                     BOTEMP = BOTEMP + 1
                     CALL MINIT ('READ', LUNI, INDI, WINI(3), WINI(4),
     *                  WINI, BUFF1, JBUFSZ, BOTEMP, IERR)
                     IF (IERR.NE.0) THEN
                        WRITE (MSGTXT,1110) IERR
                        GO TO 970
                        END IF
C                                       Init a write
                     CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IERR)
                     IF (IERR.NE.0) THEN
                        WRITE (MSGTXT,1120) 'WRIT', IERR
                        GO TO 970
                        END IF
C                                       Loop thru input plane
                     DO 200 I2 = 1,NXO
                        CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND,
     *                     IERR)
                        IF (IERR.NE.0) THEN
                           WRITE (MSGTXT,1120) 'READ', IERR
                           GO TO 970
                           END IF
                        J = IBIND + IOFF - 1
                        L = OBIND + I2 - 1
                        BUFF2(L) = BUFF1(J)
 200                    CONTINUE
 300                 CONTINUE
C                                       Flush output plane
                  CALL MDISK ('FINI', LUNO, INDO, BUFF2, OBIND, IERR)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1120) 'FINI', IERR
                     GO TO 970
                     END IF
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
      GO TO 975
C                                       Close down (error)
 970  CALL MSGWRT (8)
C                                       Close files
 975  CALL ZCLOSE (LUNO, INDO, JERR)
 980  CALL ZCLOSE (LUNI, INDI, JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('PSCALE: ERROR',I5,' OPENING SCRATCH FILE')
 1035 FORMAT ('PSCALE: ERROR',I5,' OPENING MAP FILE')
 1100 FORMAT ('PSCALE: ERROR',I5,' ON INIT MAP FILE')
 1110 FORMAT ('PSCALE: ERROR',I5,' ON INIT SCRATCH FILE')
 1120 FORMAT ('PSCALE: ',A4,' ERROR',I5)
      END
      SUBROUTINE XBASHI (ITYP, NCN)
C-----------------------------------------------------------------------
C   XBASHI copies and updates history file.
C   Inputs:
C      ITYP   I   Output map type: 0 => residual
C                 1 => answers (get 1st axis info also)
C      NCN    I   Position in FILES common on catlgd file
C-----------------------------------------------------------------------
      INTEGER   ITYP, NCN
C
      CHARACTER HILINE*72, LABEL*8, NOTTYP*2
      INTEGER   LUN1, LUN2, IERR, I, IG
      LOGICAL   T
      INCLUDE 'XBASL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NOTTYP /'  '/
C-----------------------------------------------------------------------
C                                       Copy keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
C                                        Copy tables
      CALL ALLTAB (1, NOTTYP, LUN1, LUN2, DISKIN, DISKO, OLDCNO,
     *   NEWCNO, CATBLK, IBUFF1, IBUFF2, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   IBUFF1, IBUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 50
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, IBUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 50
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       BLC
      WRITE (HILINE,2000) TSKNAM, BLC
      CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       TRC
      WRITE (HILINE,2001) TSKNAM, TRC
      CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       other Parms
      WRITE (HILINE,2002) TSKNAM, YINC, ZINC
      IF ((YINC.GE.2.) .OR. (ZINC.GE.2.)) THEN
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 50
         END IF
      CALL H2CHR (8, 1, OLDH(KHBUN), LABEL)
      WRITE (HILINE,2003) TSKNAM, FCUT, LABEL
      CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       Baseline limits
      IG = PORDER + 0.01
      WRITE (HILINE,2005) TSKNAM, IG
      CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       list windows in batch-like
      IF (ICODE.NE.1) THEN
         DO 15 I = 1,NBOXES
            WRITE (HILINE,2006) TSKNAM, NBOX(1,I), NBOX(2,I), I
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 50
 15         CONTINUE
         END IF
C                                       Old axis 1
      IF (ITYP.GT.0) THEN
         CALL H2CHR (8, 1, OLDH(KHCTP), LABEL)
         WRITE (HILINE,2020) TSKNAM, LABEL
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 50
         WRITE (HILINE,2021) TSKNAM, CATOLD(KINAX)
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 50
         WRITE (HILINE,2022) TSKNAM, OLDR(KRCRP)
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 50
         WRITE (HILINE,2023) TSKNAM, OLDR(KRCIC)
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 50
         WRITE (HILINE,2024) TSKNAM, OLDD(KDCRV)
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         END IF
C                                       Close HI file
 50   CALL HICLOS (LUN2, T, IBUFF2, IERR)
C                                        Update CATBLK and close
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'CLWR', IBUFF1, IERR)
      FRW(NCN) = -1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XBASHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 2000 FORMAT (A6,'BLC =',6(F6.0,','),F6.0)
 2001 FORMAT (A6,'TRC =',6(F6.0,','),F6.0)
 2002 FORMAT (A6,'YINC =',F6.0,'  ZINC =',F6.0)
 2003 FORMAT (A6,'FLUX =',1PE12.4,14X,'/ Flux cutoff in ',A8)
 2005 FORMAT (A6,'PORDER =',I2,22X,'/ Max polynomial fit')
 2006 FORMAT (A6,'BOXES =',2I6,12X,'/ Window',I2,' wrt BLC(1)')
 2020 FORMAT (A6,'CTYPE1  = ''',A8,'''',12X,'/ old axis 1')
 2021 FORMAT (A6,'NAXIS1  = ',I6,16X,'/ Old axis 1')
 2022 FORMAT (A6,'CRPIX1  = ',F9.3,13X,'/ Old axis 1')
 2023 FORMAT (A6,'CDELT1  = ',1PE13.5,9X,'/ Old axis 1')
 2024 FORMAT (A6,'CRVAL1  = ',1PE18.10,4X,'/ Old axis 1')
      END
      SUBROUTINE SUBHD3 (BLC, TRC, XINC, YINC, ZINC)
C-----------------------------------------------------------------------
C   SUBHD3 corrects the header for subimaging: changes number of points
C   on the axes, the reference pixels, and the alternate axis (freq vs
C   velocity) reference pixel.  It corrects the first 3 axes for use
C   of pixel increments - namely the number of pixels, the reference
C   pixel and the axis increment.
C   Inputs:
C      BLC    R(7)   Bottom left corner to use
C      TRC    R(7)   Top right corner to use
C      XINC   R      Pixel increment on first axis
C      YINC   R      Pixel increment on second axis
C      ZINC   R      Pxel increment on third axis
C   Common /MAPHDR/ CATBLK     map header (in/out)
C-----------------------------------------------------------------------
      REAL      BLC(7), TRC(7), XINC, YINC, ZINC
C
      CHARACTER FCHARS(3)*4, CHTM12*12
      REAL      AINC(7)
      INTEGER   IPL, IPH, NAX, I, J
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA FCHARS /'FREQ','VELO','FELO'/
C-----------------------------------------------------------------------
C                                       Regular axis parameters
      NAX = CATBLK(KIDIM)
      CALL RFILL (7, 1.0, AINC)
      IF (XINC.GT.0.0) AINC(1) = XINC
      IF (YINC.GT.0.0) AINC(2) = YINC
      IF (ZINC.GT.0.0) AINC(3) = ZINC
      DO 10 I = 1,NAX
         IPL = BLC(I) + 0.01
         IPH = TRC(I) + 0.01
         CATBLK(KINAX+I-1) = (IPH - IPL) / AINC(I) + 1
         CATR(KRCRP+I-1) = (CATR(KRCRP+I-1) - IPL) / AINC(I) + 1.
         CATR(KRCIC+I-1) = CATR(KRCIC+I-1) * AINC(I)
 10      CONTINUE
C                                       Alternate axis
      IF (CATBLK(KIALT).NE.0) THEN
         DO 25 I = 1,NAX
            IPL = KHCTP + (I-1)*2
            DO 20 J = 1,3
               CALL H2CHR (4, 1, CATR(IPL), CHTM12)
               IF (FCHARS(J).EQ.CHTM12(:4)) THEN
                  IPL = BLC(I) + 0.01
                  CATR(KRARP) = (CATR(KRARP) - IPL) / AINC(I) + 1.0
                  GO TO 999
                  END IF
 20            CONTINUE
 25         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE POLYIN (NDATA, IERR)
C-----------------------------------------------------------------------
C   POLYIN prepares the parameters of a set of orthogonal polynomials.
C   All are carried in COMMON /GDATA/.
C   Input:
C      NDATA   I   Number of points in data array
C   Output:
C      IERR    I   0 ok, 1 no good data, 2 other singularity
C-----------------------------------------------------------------------
      INTEGER   NDATA, IERR
C
      REAL      PP, AL, SUM, TEMP
      INTEGER   MMAX, I, J, K, JJ, KK, N, MM
      INCLUDE 'XBASL2.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       calculate moments
      MMAX = 2 * JJC - 1
      CALL RFILL (MMAX, 0.0, MOMENT)
      NPTS = 0
      DO 20 I = 1,NDATA
         IF ((MASK(I).EQ.1) .AND. (DATA(I).NE.FBLANK)) THEN
            PP = 1
            AL = I + XBAR
            NPTS = NPTS + 1
            DO 15 J = 2,MMAX
               PP = PP * AL
               MOMENT(J) = MOMENT(J) + PP
 15            CONTINUE
            END IF
 20      CONTINUE
      IERR = 1
      IF (NPTS.LE.0) GO TO 999
      IERR = 2
      DO 25 J = 2,MMAX
         MOMENT(J) = MOMENT(J) / NPTS
 25      CONTINUE
      MOMENT(1) = 1.0
C                                       Matrix: P(K) = G(K) * (X**K
C                                        - SUM (A(K,J)*P(J)))
      MMAX = 25
      CALL RFILL (MMAX, 0.0, AARRAY)
      CALL RFILL (MMAX, 0.0, CARRAY)
      GAMMA(1) = 1.0
      DO 50 K = 2,JJC
         SUM = 0.0
         KK = K - 1
         DO 40 J = 1,KK
            AARRAY(K,J) = MOMENT(J+K-1)
            IF (J.GT.1) THEN
               JJ = J - 1
               DO 30 MM = 1,JJ
                  AARRAY(K,J) = AARRAY(K,J) - AARRAY(J,MM)*AARRAY(K,MM)
 30               CONTINUE
               END IF
            AARRAY(K,J) = AARRAY(K,J) * GAMMA(J)
            SUM = SUM + AARRAY(K,J) ** 2
 40         CONTINUE
         TEMP = MOMENT(2*K-1) - SUM
         IF (TEMP.LE.0.0) GO TO 999
         GAMMA(K) = 1.0 / SQRT (TEMP)
 50      CONTINUE
C                                       Matrix: P(K) = SUM (C(K,J) *
C                                                      X**J)
      CARRAY(1,1) = GAMMA(1)
      DO 65 K = 2,JJC
         CARRAY(K,K) = GAMMA(K)
         KK = K - 1
         DO 60 MM = 1,KK
            DO 55 N = MM,KK
               CARRAY(K,MM) = CARRAY(K,MM) - GAMMA(K) * AARRAY(K,N)
     *            * CARRAY(N,MM)
 55            CONTINUE
 60         CONTINUE
 65      CONTINUE
C                                       average of polynomials
      MMAX = 5
      CALL RFILL (MMAX, 0.0, POLAVG)
      DO 75 I = 1,NDATA
         CALL POLYEV (I)
         DO 70 J = 1,MMAX
            POLAVG(J) = POLAVG(J) + POLYFN(J)
            POLXFN(I,J) = POLYFN(J)
 70         CONTINUE
 75      CONTINUE
      DO 80 J = 1,MMAX
         POLAVG(J) = POLAVG(J) / NDATA
 80      CONTINUE
      IERR = 0
C
 999  RETURN
      END
      SUBROUTINE POLYEV (IX)
C-----------------------------------------------------------------------
C   POLYEV evaluates the orthogonal polynomials at the X value given.
C   Inputs:
C      IX   I   X position
C-----------------------------------------------------------------------
      INTEGER   IX
C
      REAL      AX
      INTEGER   J, K, KK
      INCLUDE 'XBASL2.INC'
C-----------------------------------------------------------------------
      POLYFN(1) = 1.0
      AX = IX + XBAR
      DO 20 K = 2,JJC
         POLYFN(K) = AX**(K-1)
         KK = K-1
         DO 10 J = 1,KK
            POLYFN(K) = POLYFN(K) - AARRAY(K,J) * POLYFN(J)
 10         CONTINUE
         POLYFN(K) = POLYFN(K) * GAMMA(K)
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE BTVINI (IPOS, INPTS, NORDER, LABEL, PIXR, DOSLIC,
     *   PARMS, NBOXES, NBOX, PORDER, ORANGE, IERR)
C-----------------------------------------------------------------------
C   BTVINI initializes the TEK for a XBASL plot, plots axis labels,
C   and, if requested, plots the data.
C   Inputs:
C      IPOS     I(7)      Position in cube first point in row.
C      INPTS    I         Number of points in row.
C      LABEL    I         Requested label type
C      PIXR     R(2)      Requested plot value range
C      DOSLIC   R         > 0. => plot data
C      PARMS    R(10)     Initial guess
C      NBOXES   I         # windows
C      NBOX     I(2,20)   windows
C      PORDER   R         Max polynomial order
C   Output:
C      PORDER   I         Order of polynomial to use now
C      ORANGE   R(2)      Actual plot range in plot units
C      IERR     I         > 0 => plot failed
C                         101 => bad initial guess
C                         102 => DIE
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), INPTS, NORDER, LABEL, NBOXES, NBOX(2,20), IERR
      REAL      PIXR(2), DOSLIC, PARMS(9), PORDER, ORANGE(2)
C
      CHARACTER TEMP*1, TEXT(2)*80, MSGBUF*132, NTEXT*80
      REAL      XBLC(7), XTRC(7), PBLC(2), PTRC(2), YGAP, CH(4), XYRATO,
     *   X, XX, Y, XFAC, XOFF, DX, DY, Y1, Y2, X1,  X2, Y3, Y4, FQFINC
      INTEGER   IT, IDROP(2), IX1, IX2, IY1, IY2, ICHL, ICHB, ICHR,
     *   ICHT, NXA, NYA, I, J, JERR, TTYLUN, TTYIND, I4XTRA, IDX, IDY,
     *   TVWIND(4), TVSIZE(2)
      LOGICAL   T, F, BLAST, BNEXT, FIRST
      DOUBLE PRECISION FQFREQ
      INCLUDE 'XBASL2.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVS.INC'
      INCLUDE 'INCS:DCAT.INC'
      SAVE FIRST
      DATA T, F, FIRST /.TRUE.,.FALSE.,.TRUE./
      DATA TTYLUN /5/
C-----------------------------------------------------------------------
C                                       inits, open TEK
      CALL TVOPEN (INBUF, IERR)
      IF (IERR.GT.1) GO TO 999
      DEVON = 2
      CALL YHOLD ('ONNN', IERR)
      IF (FIRST) THEN
         IGR1 = UCHAN + 0.01
         IGR1 = MOD (IGR1, 10)
         IF ((IGR1.LE.0) .OR. (IGR1.GT.7)) THEN
            IGR1 = 1
            IGR2 = 2
            IGR3 = 3
            IGR4 = 4
         ELSE
            IGR2 = IGR1
            IGR3 = IGR1
            IGR4 = IGR1
            END IF
         IGR1 = IGR1 + NGRAY
         IGR2 = IGR2 + NGRAY
         IGR3 = IGR3 + NGRAY
         IGR4 = IGR4 + NGRAY
         DO 5 I = 1,NGRAY+NGRAPH
            CALL YSLECT ('OFFF', I, 0, INBUF, IERR)
            IF (IERR.NE.0) GO TO 999
 5          CONTINUE
         CALL YSLECT ('ONNN', IGR1, 0, INBUF, IERR)
         IF (IERR.NE.0) GO TO 999
         IF (IGR1.NE.IGR2) THEN
            CALL YSLECT ('ONNN', IGR2, 0, INBUF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL YSLECT ('ONNN', IGR3, 0, INBUF, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL YSLECT ('ONNN', IGR4, 0, INBUF, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         FIRST = .FALSE.
         END IF
C                                       "Slice" corners
      IDROP(1) = 0
      IDROP(2) = 0
      DO 10 I = 1,7
         XBLC(I) = IPOS(I)
         XTRC(I) = XBLC(I)
 10      CONTINUE
      XTRC(1) = XBLC(1) + INPTS - 1
C                                       Set PIX ranges
      ORANGE(1) = PIXR(1)
      ORANGE(2) = PIXR(2)
C                                       Default: actual range
      IF (PIXR(2).LE.PIXR(1)) THEN
         ORANGE(1) = 1.0E10
         ORANGE(2) = -ORANGE(1)
         DO 15 I = 1,INPTS
            IF (DATA(I).NE.FBLANK) THEN
               ORANGE(1) = MIN (ORANGE(1), DATA(I))
               ORANGE(2) = MAX (ORANGE(2), DATA(I))
               END IF
 15         CONTINUE
         XFAC = ORANGE(2) - ORANGE(1)
         ORANGE(2) = ORANGE(2) + 0.25 * XFAC
         ORANGE(1) = ORANGE(1) - 0.25 * XFAC
         END IF
      CATR(IRRAN) = ORANGE(1)
      CATR(IRRAN+1) = ORANGE(2)
      XFAC = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      XOFF = 40000.0 - XFAC * CATR(IRRAN+1)
      PBLC(2) = ORANGE(1) * XFAC + XOFF
      PTRC(2) = ORANGE(2) * XFAC + XOFF
C                                       Label inits
      LOCNUM = 1
      FQFINC = 0.0
      FQFREQ = 0.0D0
      CALL SLBINI (IDROP, INPTS, ORANGE, PBLC, PTRC, XBLC, XTRC,
     *   FQFREQ, FQFINC, CATBLK(IIDEP), LABEL, YGAP, CH, TEXT, NTEXT)
      ORANGE(1) = XFAC*ORANGE(1) + XOFF
      ORANGE(2) = XFAC*ORANGE(2) + XOFF
      XYRATO = (PTRC(2) - PBLC(2)) / (PTRC(1) - PBLC(1))
      IX1 = PBLC(1) + .5
      IY1 = PBLC(2) + .5
      IX2 = PTRC(1) + .5
      IY2 = PTRC(2) + .5
      ICHL = CH(1) * CSIZTV(1) + .5
      ICHB = CH(2) * CSIZTV(2) + .5
      ICHR = CH(3) * CSIZTV(1) + .5
      ICHT = CH(4) * CSIZTV(2) + .5
      CALL YWINDO ('READ', TVWIND, IERR)
      IF (IERR.NE.0) THEN
         TVWIND(1) = 1
         TVWIND(2) = 1
         TVWIND(3) = MAXXTV(1)
         TVWIND(4) = MAXXTV(2)
         END IF
      TVSIZE(1) = TVWIND(3) - TVWIND(1) + 1
      TVSIZE(2) = TVWIND(4) - TVWIND(2) + 1
      NYA = TVSIZE(2) - ICHT -ICHB -1
      NXA = TVSIZE(1) - ICHL - ICHR - 1
C                                       compute scaling
      X = IX2
      X = ABS (X - IX1)
      XX = X * XYRATO
      Y = IY2
      Y = ABS (Y - IY1)
      IF ((XX.LE.0.0) .OR. (Y.LE.0.0)) THEN
         WRITE (MSGTXT,1020)
         CALL MSGWRT (8)
         IERR = 1
         GO TO 999
         END IF
      IF ((XX/Y).LE.FLOAT(NXA)/FLOAT(NYA)) THEN
         SCALEY = NYA / Y
         SCALEX = SCALEY * Y / X
      ELSE
         SCALEX = NXA / X
         SCALEY = SCALEX * X / Y
         END IF
C
      NXA = SCALEX * X + ICHL + ICHR
      RX0 = ICHL + MAX (0, TVSIZE(1)-NXA) / 2 + TVWIND(1)
      NYA = SCALEY * Y + ICHB + ICHT
      RY0 = ICHB + MAX (0, TVSIZE(2)-NYA) / 2 + TVWIND(2)
C                                       Put stuff in image catalog.
      CATBLK(IIWIN  ) = IX1
      CATBLK(IIWIN+1) = IY1
      CATBLK(IIWIN+2) = IX2
      CATBLK(IIWIN+3) = IY2
      CATBLK(IICOR  ) = RX0 + 0.5
      CATBLK(IICOR+1) = RY0 + 0.5
      CATBLK(IICOR+2) = RX0 + X * SCALEX + 0.5
      CATBLK(IICOR+3) = RY0 + Y * SCALEY + 0.5
      CATBLK(IIPLT) = 5
      CATBLK(IIOTH) = LABEL
      CATBLK(IIOTH+1) = IDROP(1)
      CATBLK(IIOTH+2) = IDROP(2)
      I4XTRA = IIOTH + 3
      CATR(I4XTRA  ) = XBLC(1)
      CATR(I4XTRA+1) = XBLC(2)
      CATR(I4XTRA+2) = XTRC(1)
      CATR(I4XTRA+3) = XTRC(2)
C                                       Update image catalog
      CALL YCINIT (IGR1, INBUF)
      CALL YCWRIT (IGR1, CATBLK(IICOR), CATBLK, INBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040)
         CALL MSGWRT (6)
         END IF
C                                       clear screen
      CALL YZERO (IGR1, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (IGR2.NE.IGR1) THEN
         CALL YCINIT (IGR2, INBUF)
         CALL YCINIT (IGR3, INBUF)
         CALL YCINIT (IGR4, INBUF)
         CALL YZERO (IGR2, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL YZERO (IGR3, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL YZERO (IGR4, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       set scale for plot routines
      RX0 = RX0 - PBLC(1) * SCALEX + 0.5
      RY0 = RY0 - PBLC(2) * SCALEY + 0.5
C                                       label the plot
      IGR = IGR1
      CALL TVLAB (PBLC, PTRC, LABEL, YGAP, TEXT, NTEXT, CH, F, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       add pixel coordinates
      DX = PTRC(1)*SCALEX + RX0 - 8.5 * CSIZTV(1)
      DY = PTRC(2)*SCALEY + RY0 - 2.0 * CSIZTV(2)
      IDX = DX + 0.5
      IDY = DY + 0.5
      WRITE (MSGBUF,1060) IPOS(2)
      CALL IMCHAR (IGR, IDX, IDY, 0, 0, MSGBUF(:7), INBUF, IERR)
      IF (IERR.NE.0) GO TO 999
      DY = DY - 1.5 * CSIZTV(2)
      IDY = DY + 0.5
      WRITE (MSGBUF,1061) IPOS(3)
      CALL IMCHAR (IGR, IDX, IDY, 0, 0, MSGBUF(:7), INBUF, IERR)
      IF (IERR.NE.0) GO TO 999
      DY = DY - 1.5 * CSIZTV(2)
      IDY = DY + 0.5
      I = JJC - 1
      WRITE (MSGBUF,1062) I
      CALL IMCHAR (IGR, IDX, IDY, 0, 0, MSGBUF(:7), INBUF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       plot data
      IF (DOSLIC.GT.0.) THEN
         BLAST = .TRUE.
         DO 70 I = 1,INPTS
            BNEXT = DATA(I).EQ.FBLANK
            IF (.NOT.BNEXT) THEN
               X = I - 0.5
               Y = DATA(I) * XFAC + XOFF
               Y = MIN (ORANGE(2), MAX (ORANGE(1), Y))
               J = 2
               IF (BLAST) J = 1
               CALL TVVEC (X, Y, J, IERR)
               IF (IERR.NE.0) GO TO 999
               X = I + 0.5
               J = 2
               CALL TVVEC (X, Y, J, IERR)
               IF (IERR.NE.0) GO TO 999
               END IF
            BLAST = BNEXT
 70         CONTINUE
         END IF
      IF (DOSLIC.GT.1.0) THEN
         IGR = IGR2
         DO 90 I = 1,NBOXES
            IT = NBOX(1,I)
 75         IF (DATA(IT).EQ.FBLANK) THEN
               IT = IT + 1
               IF (IT.GT.NBOX(2,I)) GO TO 90
               GO TO 75
               END IF
            X1 = NBOX(1,I)
            Y = DATA(IT) * XFAC + XOFF
            Y1 = Y + 0.11 * (ORANGE(2) - ORANGE(1))
            Y2 = Y - 0.11 * (ORANGE(2) - ORANGE(1))
            Y1 = MIN (ORANGE(2), MAX (ORANGE(1), Y1))
            Y2 = MIN (ORANGE(2), MAX (ORANGE(1), Y2))
            IT = NBOX(2,I)
 80         IF (DATA(IT).EQ.FBLANK) THEN
               IT = IT - 1
               IF (IT.LT.NBOX(1,I)) GO TO 90
               GO TO 80
               END IF
            X2 = NBOX(2,I)
            Y = DATA(IT) * XFAC + XOFF
            Y3 = Y + 0.11 * (ORANGE(2) - ORANGE(1))
            Y4 = Y - 0.11 * (ORANGE(2) - ORANGE(1))
            Y3 = MIN (ORANGE(2), MAX (ORANGE(1), Y3))
            Y4 = MIN (ORANGE(2), MAX (ORANGE(1), Y4))
            CALL TVVEC (X1, Y1, 1, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TVVEC (X1, Y2, 2, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TVVEC (X2, Y4, 2, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TVVEC (X2, Y3, 2, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TVVEC (X1, Y1, 2, IERR)
            IF (IERR.NE.0) GO TO 999
 90         CONTINUE
         END IF
      CALL YHOLD ('OFFF', JERR)
C                                       Talk to user
      IF (DOSLIC.GT.1.0) THEN
         CALL ZOPEN (TTYLUN, TTYIND, 1, MSGBUF, F, T, T, JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1900) JERR
            CALL MSGWRT (6)
            GO TO 999
            END IF
C                                       change order of polynomial
 910     I = PORDER + 0.01
         IF (I.GT.0) THEN
            WRITE (MSGBUF,1910) I
            CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, JERR)
            IF (JERR.NE.0) GO TO 920
            CALL ZTTYIO ('READ', TTYLUN, TTYIND, 72, MSGBUF, JERR)
            IF (JERR.NE.0) GO TO 920
            READ (MSGBUF,1911) TEMP, J
            IF ((TEMP.EQ.'C') .OR. (TEMP.EQ.'c')) THEN
               IF ((J.LT.0) .OR. (J.GT.I)) GO TO 910
               NORDER = J
               IF (NORDER.LT.1) PARMS(2) = 0.0D0
               END IF
            END IF
C                                       Quit etc
         WRITE (MSGBUF,1915)
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, JERR)
         IF (JERR.NE.0) GO TO 920
         CALL ZTTYIO ('READ', TTYLUN, TTYIND, 72, MSGBUF, JERR)
         IF (JERR.NE.0) GO TO 920
         READ (MSGBUF,1916) TEMP
         IF ((TEMP.EQ.'B') .OR. (TEMP.EQ.'b')) THEN
            IERR = 101
         ELSE IF ((TEMP.EQ.'Q') .OR. (TEMP.EQ.'q')) THEN
            IERR = 102
         ELSE IF ((TEMP.EQ.'E') .OR. (TEMP.EQ.'e')) THEN
            IERR = 103
            END IF
         GO TO 930
C                                       TTY error
 920     WRITE (MSGTXT,1920) JERR
         CALL MSGWRT (6)
 930     CALL ZCLOSE (TTYLUN, TTYIND, JERR)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('SCALING ERROR.')
 1040 FORMAT ('TV IMAGE CATALOG ERROR.')
 1060 FORMAT ('Y=',I5)
 1061 FORMAT ('Z=',I5)
 1062 FORMAT ('Order=',I1)
 1900 FORMAT ('OPEN TERMINAL ERROR',I7)
 1910 FORMAT ('??? Type ''C0'' TO ''C',I1,''' to change order of',
     *   ' polynomial')
 1911 FORMAT (A1,I1)
 1915 FORMAT ('??? Type ''E'' to enter windows, ''B'' to skip row,',
     *   ' hit return to procede')
 1916 FORMAT (A1)
 1920 FORMAT ('TERMINAL I/O ERROR',I7)
      END
      SUBROUTINE BTVGUS (INPTS, ORANGE, NBOXES, NBOX, IERR)
C-----------------------------------------------------------------------
C   BTVGUS has the user point at the desired baseline windows setting
C   COMMON parameters NBOXES and NBOX.
C   Inputs:
C      INPTS    I         Number data points in row
C      ORANGE   R(2)      Plot range in plot units
C   Output:
C      NBOXES   I         Number windows
C      NBOX     I(2,20)   Window parameters
C      FVEC     R(*)      Work buffer
C      IERR     I         error code: 0 -> ok
C-----------------------------------------------------------------------
      INTEGER   INPTS, IERR, NBOXES, NBOX(2,20)
      REAL      ORANGE(2)
C
      CHARACTER MSGBUF*80
      REAL      XFAC, XOFF, DY, X1, X2, RPOS(2), Y1, Y2, Y3, Y4, Y
      INTEGER   I, TTYLUN, TTYIND, IXT, IYT, IX, IY, IX0, IY0, JERR,
     *   QUAD, IBUT, IT
      LOGICAL   T, F
      INCLUDE 'XBASL2.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA TTYLUN /5/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Set scales
      XFAC = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      XOFF = 40000.0 - XFAC * CATR(IRRAN+1)
      IXT = RX0 + SCALEX * INPTS + 0.5
      IYT = RY0 + SCALEY * ORANGE(2) + 0.5
      IX0 = RX0 + SCALEX + 0.5
      IY0 = RY0 + SCALEY * ORANGE(1) + 0.5
C                                       Open terminal
      CALL ZOPEN (TTYLUN, TTYIND, 1, MSGBUF, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Loop over components.
 20   DO 40 I = 1,20
C                                       read left edge window
         WRITE (MSGBUF,1020) I
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL TVWHER (QUAD, RPOS, IBUT, IERR)
         IF (IERR.NE.0) GO TO 990
         IX = RPOS(1) + 0.5
         IY = RPOS(2) + 0.5
C                                       Set it
         IF ((IY.LT.IY0) .OR. (IX.GT.IXT) .OR. (IY.GT.IYT)) GO TO 50
         IF (IBUT.GE.8) GO TO 50
         IX = MAX (IX, IX0)
         NBOX(1,I) = (IX - RX0) / SCALEX + 0.5
C                                       read right edge
         WRITE (MSGBUF,1021) I
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL TVWHER (QUAD, RPOS, IBUT, IERR)
         IF (IERR.NE.0) GO TO 990
         IX = RPOS(1) + 0.5
         IY = RPOS(2) + 0.5
C                                       Set it
         IF ((IX.LT.IX0) .OR. (IY.LT.IY0) .OR. (IY.GT.IYT)) GO TO 50
         IF (IBUT.GE.8) GO TO 50
         IX = MIN (IX, IXT)
         NBOX(2,I) = (IX - RX0) / SCALEX + 0.5
         IF (NBOX(2,I).LT.NBOX(1,I)) THEN
            IX = NBOX(2,I)
            NBOX(2,I) = NBOX(1,I)
            NBOX(1,I) = IX
            END IF
         NBOX(1,I) = MAX (1, NBOX(1,I))
         NBOX(2,I) = MIN (INPTS, NBOX(2,I))
         NBOXES = I
 40      CONTINUE
 50   IF (NBOXES.LE.0) GO TO 20
C                                       Plot new windows
      CALL YHOLD ('ONNN', JERR)
      CALL YZERO (IGR, IERR)
      IF (IERR.NE.0) GO TO 990
      DY = (ORANGE(2) - ORANGE(1)) / 20.0
      DO 90 I = 1,NBOXES
         IT = NBOX(1,I)
 75      IF (DATA(IT).EQ.FBLANK) THEN
            IT = IT + 1
            IF (IT.GT.NBOX(2,I)) GO TO 90
            GO TO 75
            END IF
         X1 = NBOX(1,I)
         Y = DATA(IT) * XFAC + XOFF
         Y1 = Y + 0.11 * (ORANGE(2) - ORANGE(1))
         Y2 = Y - 0.11 * (ORANGE(2) - ORANGE(1))
         Y1 = MIN (ORANGE(2), MAX (ORANGE(1), Y1))
         Y2 = MIN (ORANGE(2), MAX (ORANGE(1), Y2))
         IT = NBOX(2,I)
 80      IF (DATA(IT).EQ.FBLANK) THEN
            IT = IT - 1
            IF (IT.LT.NBOX(1,I)) GO TO 90
            GO TO 80
            END IF
         X2 = NBOX(2,I)
         Y = DATA(IT) * XFAC + XOFF
         Y3 = Y + 0.11 * (ORANGE(2) - ORANGE(1))
         Y4 = Y - 0.11 * (ORANGE(2) - ORANGE(1))
         Y3 = MIN (ORANGE(2), MAX (ORANGE(1), Y3))
         Y4 = MIN (ORANGE(2), MAX (ORANGE(1), Y4))
         CALL TVVEC (X1, Y1, 1, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL TVVEC (X1, Y2, 2, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL TVVEC (X2, Y4, 2, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL TVVEC (X2, Y3, 2, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL TVVEC (X1, Y1, 2, IERR)
         IF (IERR.NE.0) GO TO 990
 90      CONTINUE
      GO TO 990
C                                       terminal error
 900  WRITE (MSGTXT,1900) IERR
      CALL MSGWRT (6)
C                                       Close TTY anyway
 990  CALL ZCLOSE (TTYLUN, TTYIND, JERR)
      CALL YHOLD ('OFFF', JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' OPENING TERMINAL')
 1020 FORMAT ('Position cursor at left edge of window ',I2,
     *   ' hit button')
 1021 FORMAT ('Position cursor at right edge of window ',I2,
     *   ' hit button')
 1900 FORMAT ('ERROR',I5,' WRITING TO TERMINAL')
      END
      SUBROUTINE BTVMOD (DOMODL, DORESI, INPTS, NG, ORANGE, FVEC, PERR,
     *   IERR)
C-----------------------------------------------------------------------
C   BTVMOD plots the residual and model functions on the TEK.  It asks
C   the user for permission to proceed.
C   Inputs:
C       DOMODL   R      > 0. => plot model
C       DORESI   R      > 0. => plot residuals
C       INPTS    I      Number of data points
C       NG       I      Order of baseline (max)
C       ORANGE   R(2)   Plot intensity range (plot units)
C       FVEC     R(*)   data - model
C       PERR     I      > 0 => probable parameter bad
C  Output:
C       IERR     I      TEK error code
C                          101 => blank this solution
C                          102 => User wants to quit
C                          103 => do a retry
C-----------------------------------------------------------------------
      INTEGER   INPTS, NG, PERR, IERR
      REAL      FVEC(*), DOMODL, DORESI, ORANGE(2)
C
      CHARACTER TEMP*1, MSGBUF*80
      INTEGER   I, J, TTYLUN, TTYIND, NPPL, K, JERR
      REAL      XFAC, XOFF, X, Y, XP, YP, TP, DX, DY
      LOGICAL   BLAST, T, F
      INCLUDE 'XBASL2.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA TTYLUN /5/
C-----------------------------------------------------------------------
      IERR = 0
      IF ((DOMODL.LE.0.) .AND. (DORESI.LE.0.)) GO TO 900
      XFAC = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      XOFF = 40000. - XFAC * CATR(IRRAN+1)
C                                       Plot residuals
      K = 0
      IF (DORESI.GT.0.) THEN
C                                       Do any show?
         DO 10 I = 1,INPTS
            IF (DATA(I).EQ.FBLANK) GO TO 10
               Y = FVEC(I) * XFAC + XOFF
               IF ((Y.LT.ORANGE(2)) .AND. (Y.GT.ORANGE(1))) K = K + 1
 10         CONTINUE
         END IF
      IF (K.GT.1) THEN
         CALL YHOLD ('ONNN', I)
         IGR = IGR3
         BLAST = .TRUE.
         DO 30 I = 1,INPTS
            IF (DATA(I).EQ.FBLANK) THEN
               BLAST = .TRUE.
            ELSE
               X = I
               Y = FVEC(I) * XFAC + XOFF
               XP = X * SCALEX + RX0 - RXL
               YP = Y * SCALEY + RY0 - RYL
               TP = MAX (ABS(XP), ABS(YP))
               NPPL = (TP + 9) / 16.0 + 0.5
               IF (BLAST) NPPL = 1
               XP = (RXL - RX0) / SCALEX
               YP = (RYL - RY0) / SCALEY
               DX = (X - XP) / NPPL
               DY = (Y - YP) / NPPL
               DO 25 K = 1,NPPL
                  X = XP + (K-0.6) * DX
                  Y = YP + (K-0.6) * DY
                  Y = MIN (ORANGE(2), MAX (ORANGE(1), Y))
                  J = 2
                  IF ((BLAST) .OR. (MOD(K,2).EQ.0)) J = 1
                  CALL TVVEC (X, Y, J, IERR)
                  IF (IERR.NE.0) GO TO 100
                  X = XP + K * DX
                  Y = YP + K * DY
                  Y = MIN (ORANGE(2), MAX (ORANGE(1), Y))
                  J = 1
                  CALL TVVEC (X, Y, J, IERR)
                  IF (IERR.NE.0) GO TO 100
 25               CONTINUE
               BLAST = .FALSE.
               END IF
 30         CONTINUE
         CALL YHOLD ('OFFF', I)
         END IF
C                                       Plot model
      IF (DOMODL.GT.0.) THEN
         CALL YHOLD ('ONNN', I)
         IGR = IGR4
         BLAST = .TRUE.
         DO 60 I = 1,INPTS
            IF (DATA(I).EQ.FBLANK) THEN
               BLAST = .TRUE.
            ELSE
               X = I
               Y = (DATA(I) - FVEC(I)) * XFAC + XOFF
               Y = MIN (ORANGE(2), MAX (ORANGE(1), Y))
               J = 2
               IF (BLAST) J = 1
               CALL TVVEC (X, Y, J, IERR)
               IF (IERR.NE.0) GO TO 100
               BLAST = .FALSE.
               END IF
 60         CONTINUE
         CALL YHOLD ('OFFF', I)
         END IF
 100  BLAST = PERR.GT.0
C                                       talk to user
 900  CALL ZOPEN (TTYLUN, TTYIND, 1, MSGBUF, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1900) IERR
         CALL MSGWRT (6)
         GO TO 999
         END IF
      IF (BLAST) THEN
         WRITE (MSGBUF,1910)
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         END IF
      IF (NG.GT.1) THEN
         WRITE (MSGBUF,1915)
         CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         END IF
      WRITE (MSGBUF,1920)
      CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL ZTTYIO ('READ', TTYLUN, TTYIND, 72, MSGBUF, IERR)
      IF (IERR.NE.0) GO TO 980
      READ (MSGBUF,1921) TEMP
      CALL CHLTOU (4, TEMP)
      IF ((TEMP.EQ.'B') .OR. (TEMP.EQ.'b')) THEN
         IERR = 101
      ELSE IF ((TEMP.EQ.'Q') .OR. (TEMP.EQ.'q')) THEN
         IERR = 102
      ELSE IF ((TEMP.EQ.'R') .OR. (TEMP.EQ.'r')) THEN
         IF (NG.GT.1) IERR = 103
         END IF
      GO TO 990
C                                       TTY error
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (6)
 990  CALL ZCLOSE (TTYLUN, TTYIND, JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('OPEN TERMINAL ERROR',I7)
 1910 FORMAT ('>>>> PARAMETERS SEEM OUT OF RANGE.  SOLUTION PROBABLY ',
     *   'BAD! <<<<')
 1915 FORMAT ('**** Enter RETR to repeat the row (must enter a guess)')
 1920 FORMAT ('**** Enter BAD to flag solution, QUIT to die, ',
     *   'Hit return to continue')
 1921 FORMAT (A1)
 1980 FORMAT ('TERMINAL I/O ERROR',I7)
      END

LOCAL INCLUDE 'BPFLG.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DBPC.INC'
      REAL      XSEQ, XDISK, XVER, FGVIN, FGVOUT,  XTIME(8), XBIF, XEIF,
     *   XBCHAN, XECHAN, XANT(50), APARM(10), BADD(10)
      HOLLERITH XINNAM(3), XINCLS(2)
      CHARACTER INNAM*12, INCLS*6
      COMMON /INPARM/ XINNAM, XINCLS, XSEQ, XDISK, XVER, FGVIN, FGVOUT,
     *   XTIME, XBIF, XEIF, XBCHAN, XECHAN, XANT, APARM, BADD
      COMMON /CHPARM/ INNAM, INCLS
      INTEGER   INSEQ, INDISK, BPVER, CNO, INFG, OUTFG, BIF, EIF,
     *   ANTS(50), NANT, NFLAGS, BCHAN, ECHAN
      DOUBLE PRECISION TIME, TIMBEG, TIMEND
      REAL      BNDPAS(2,MAXCIF)
      LOGICAL   DOCOPY
      COMMON /BPFLGC/ TIME, TIMBEG, TIMEND, INSEQ, INDISK, BPVER, CNO,
     *   BNDPAS, BIF, EIF, ANTS, NANT, NFLAGS, INFG, OUTFG, BCHAN,
     *   ECHAN, DOCOPY
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
LOCAL END
      PROGRAM BPFLG
C-----------------------------------------------------------------------
C! Flags uv data based on bad BP values
C# EXT-appl Calibration Editing
C-----------------------------------------------------------------------
C;  Copyright (C) 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Flags uv data based on BP values
C   Inputs from user
C      INNAME.....Input UV file name (name).      Standard defaults.
C      INCLASS....Input UV file name (class).     Standard defaults.
C      INSEQ......Input UV file name (seq. #).    0 => highest.
C      INDISK.....Disk drive # of input UV file.  0 => any.
C      BPVER......Specifies the version of the BP table to be read as
C                 input.   0 -> highest.
C                 The output version is always highest + 1.
C      APARM(1) = lowest good BP amp
C      APARM(2) = highest good BP amp
C      APARM(3) = lowest good BP phase
C      APARM(4) = highest good BP phase
C-----------------------------------------------------------------------
      INTEGER   IRET
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'BPFLG.INC'
C-----------------------------------------------------------------------
C                                       Get parms, open things
      CALL BPFLGI (IRET)
C                                       do smoothing
      IF (IRET.EQ.0) CALL BPFLGT (IRET)
C                                       do history
      IF (IRET.EQ.0) CALL BPFLHI (IRET)
C                                       close down
      CALL DIE (IRET, BPBUFF)
C
 999  STOP
      END
      SUBROUTINE BPFLGI (IERR)
C-----------------------------------------------------------------------
C   BPSMIN performs initialization for AIPS task BPFLG.  It gets the
C   adverbs, opens the catalog file for 'WRIT', sorts and opens the BP
C   input file, creates the BP output file, and determines which FQs,
C   times, and antenna counts apply to the table.
C   Output:
C      IERR    I      Error code: 0 => keep going, else quit.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'BPFLG.INC'
      CHARACTER INTYP*2, STAT*4, PRGN*6, KEYS(2)*24, LTYPBP*8
      INTEGER   NPARM, IROUND, BPLUN, JERR, I, J, KEY(2,2), NKEY,
     *   KOLS(2),
     *   KEYSUB(2,2)
      REAL      FKEY(2,2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA BPLUN, INTYP /27, 'UV'/
      DATA PRGN /'BPFLG '/
      DATA NKEY /2/
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
      DATA KEYS /'ANTENNA ', 'TIME '/
C-----------------------------------------------------------------------
C                                       AIPS init
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NCFILE = 0
      NSCR = 0
C                                       get adverbs
      NPARM = 92
      IERR = 0
      CALL GTPARM (PRGN, NPARM, RQUICK, XINNAM, BPBUFF, JERR)
      IF (JERR.NE.0) THEN
         RQUICK = .TRUE.
         IERR = 8
         IF (JERR.EQ.1) THEN
            GO TO 999
         ELSE
            WRITE (MSGTXT,1000) JERR, 'GET INPUT ADVERBS'
            CALL MSGWRT (8)
            END IF
         END IF
C                                       restart AIPS
      IF (RQUICK) CALL RELPOP (IERR, BPBUFF, JERR)
      IF (IERR.NE.0) GO TO 999
C                                       Hollerith -> Char
      CALL H2CHR (12, 1, XINNAM, INNAM)
      CALL H2CHR (6, 1, XINCLS, INCLS)
      INSEQ = IROUND (XSEQ)
      INDISK = IROUND (XDISK)
      BPVER = IROUND (XVER)
      CNO = 1
      CALL CATDIR ('SRCH', INDISK, CNO, INNAM, INCLS, INSEQ, INTYP,
     *   NLUSER, STAT, BPBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, INNAM, INCLS, INSEQ, INTYP,
     *      INDISK, NLUSER
         GO TO 990
         END IF
C                                       Get catblk, mark file write
      CALL CATIO ('READ', INDISK, CNO, CATBLK, 'WRIT', BPBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READ CATALOG HEADER'
         GO TO 990
         END IF
      NCFILE = 1
      FVOL(1) = INDISK
      FCNO(1) = CNO
      FRW(1) = 1
      CALL UVPGET (IERR)
C                                       flag versions
      CALL FNDEXT ('FG', CATBLK, I)
      INFG = FGVIN + 0.1
      IF ((INFG.EQ.0) .OR. (INFG.GT.I)) INFG = I
      OUTFG = FGVOUT + 0.1
      DOCOPY = (INFG.GT.0) .AND. (OUTFG.LE.0)
      IF (OUTFG.LE.0) OUTFG = I + 1
C                                       IFs, channels
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = XBIF + 0.1
         EIF = XEIF + 0.1
         IF ((BIF.LT.1) .OR. (BIF.GT.CATBLK(KINAX+JLOCIF))) BIF = 1
         IF ((EIF.LT.BIF) .OR. (EIF.GT.CATBLK(KINAX+JLOCIF))) EIF =
     *      CATBLK(KINAX+JLOCIF)
         END IF
      BCHAN = XBCHAN + 0.1
      ECHAN = XECHAN + 0.1
      IF ((BCHAN.LT.1) .OR. (BCHAN.GT.CATBLK(KINAX+JLOCF))) BCHAN = 1
      IF ((ECHAN.LT.BCHAN) .OR. (ECHAN.GT.CATBLK(KINAX+JLOCF))) ECHAN =
     *      CATBLK(KINAX+JLOCF)
C                                       Open BP file
      CALL BPREFM (INDISK, CNO, BPVER, CATBLK, BPLUN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL BPINI ('READ', BPBUFF, INDISK, CNO, BPVER, CATBLK, BPLUN,
     *   IBPRNO, BPKOLS, BPNUMV, NANTBP, NPOLBP, NIFBP, NCHNBP, BCHNBP,
     *   NUMSHF, LOWSHF, DELSHF, LTYPBP, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN INPUT BP TABLE'
         GO TO 990
         END IF
      WPOLY = LTYPBP.NE.' '
C                                       Set column pointers for sort
      CALL FNDCOL (NKEY, KEYS, 24, .TRUE., BPBUFF, KOLS, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FIND BP COLUMNS'
         GO TO 990
         END IF
C                                       Sort to ant-time order
      IF ((BPBUFF(43).NE.KOLS(1)) .OR. (BPBUFF(44).NE.KOLS(2))) THEN
C                                       Close
         CALL TABIO ('CLOS', 0, IBPRNO, BPBUFF, BPBUFF, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'CLOSE BP TABLE'
            GO TO 990
            END IF
C                                       sort
         KEY(1,1) = KOLS(1)
         KEY(2,1) = KOLS(1)
         KEY(1,2) = KOLS(2)
         KEY(2,2) = KOLS(2)
         CALL TABSRT (INDISK, CNO, 'BP', BPVER, BPVER, KEY, KEYSUB,
     *      FKEY, BPBUFF, CATBLK, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'SORT BP TABLE'
            GO TO 990
            END IF
C                                       Re-open BP table for read
         CALL BPINI ('READ', BPBUFF, INDISK, CNO, BPVER, CATBLK, BPLUN,
     *      IBPRNO, BPKOLS, BPNUMV, NANTBP, NPOLBP, NIFBP, NCHNBP,
     *      BCHNBP, NUMSHF, LOWSHF, DELSHF, LTYPBP, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPEN INPUT BP TABLE'
            GO TO 990
            END IF
         END IF
C                                       set up APARM, other parameters
      IF (APARM(2).LE.APARM(1)) THEN
         APARM(1) = 0.0
         APARM(2) = 1000000.
         END IF
      IF (APARM(4).LE.APARM(3)) THEN
         APARM(1) = -180.0
         APARM(2) = 180.0
         END IF
      TIMBEG = XTIME(1) + XTIME(2) / 24.0D0 + XTIME(3) / (24.0D0*60.0D0)
     *   + (XTIME(4) / (24.0D0*60.0D0*60.0D0))
      TIMEND = XTIME(5) + XTIME(6) / 24.0D0 + XTIME(7) / (24.0D0*60.0D0)
     *   + (XTIME(8) / (24.0D0*60.0D0*60.0D0))
      IF (TIMEND.LE.TIMBEG) THEN
         TIMEND = 1000000.
         TIMBEG = -1000.
      END IF
      NANT = 0
      DO 20 I = 1,50
         J = XANT(I) + 0.1
         IF (J.GT.0) THEN
            NANT = NANT + 1
            ANTS(NANT) = J
            END IF
 20      CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPFLGI: ERROR',I5,' ON ',A)
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,1X,A2,
     *   'DISK=',I2,' USER=',I5)
      END
      SUBROUTINE BPFLGT (IRET)
C-----------------------------------------------------------------------
C   BPFLGT reads the open BP tables, generates flags as needed
C   Output:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'BPFLG.INC'
      INTEGER   I, J, SOURID, SUBA, ANTNO, FREQID, BPREF(2), JERR,
     *   NBPREC, LUN1, LUN2, IFGRNO, IOFF, LP, FGNUMV(MAXFGC),
     *   FGKOLS(MAXFGC), NW, IT(3), ID(3), LIF, LCH, BUFF1(512),
     *   FGBUFF(512), WOFF, BCH, ECH
      REAL      INTERV, AMP, PHASE, BT, ET, TEPS, WEIGHT(2*MAXIF)
      CHARACTER REASON*24, CSTOKE(2)*4
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1, LUN2 /28, 29/
      DATA CSTOKE /'1011', '0111'/
C-----------------------------------------------------------------------
      NBPREC = BPBUFF(5)
      NFLAGS = 0
      TEPS = 0.1/(24.0*3600.0)
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      WRITE (REASON,1010) TSKNAM, ID, IT
C                                       read BP table
      DO 100 J = 1,NBPREC
         IBPRNO = J
         CALL TABBP ('READ', BPBUFF, IBPRNO, BPKOLS, BPNUMV, NIFBP,
     *      NCHNBP, NPOLBP, TIME, INTERV, SOURID, SUBA, ANTNO, CHNBND,
     *      BPFREQ, FREQID, BPREF, WEIGHT, BNDPAS, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ BP TABLE'
            GO TO 990
            END IF
         IF ((TIME.LT.TIMBEG) .OR. (TIME.GT.TIMEND)) GO TO 100
         IF (NANT.GT.0) THEN
            DO 10 I = 1,NANT
               IF (ANTNO.EQ.ANTS(I)) GO TO 15
 10            CONTINUE
            GO TO 100
            END IF
C                                       loop through BP
 15      DO 50 LP = 1,NPOLBP
            WOFF = (LP - 1) * NIFBP
            DO 40 LIF = BIF,EIF
               IOFF = (LIF - 1) * NCHNBP + (LP - 1) * NCHNBP * NIFBP
               BCH = 0
               DO 30 LCH = BCHAN,ECHAN
                  IF ((BNDPAS(1,LCH+IOFF).NE.FBLANK) .AND.
     *               (BNDPAS(2,LCH+IOFF).NE.FBLANK) .AND.
     *               (WEIGHT(WOFF+LIF).GT.0.0)) THEN
                     AMP = SQRT (BNDPAS(1,LCH+IOFF)**2 +
     *                  BNDPAS(2,LCH+IOFF)**2)
                     PHASE = ATAN2 (BNDPAS(2,LCH+IOFF),
     *                  BNDPAS(1,LCH+IOFF)) * RAD2DG
C                                       flag it
                     IF ((AMP.LT.APARM(1)) .OR. (AMP.GT.APARM(2)) .OR.
     *                  (PHASE.LT.APARM(3)) .OR. (PHASE.GT.APARM(4)))
     *                  THEN
C                                       copy old FG table
                        IF (DOCOPY) THEN
                           CALL TABCOP ('FG', INFG, OUTFG, LUN1, LUN2,
     *                        INDISK, INDISK, CNO, CNO, CATBLK, BUFF1,
     *                        FGBUFF, IRET)
                           IF (IRET.NE.0) THEN
                              WRITE (MSGTXT,1000) IRET,
     *                           'COPYING OLD FG TABLE'
                              GO TO 990
                              END IF
                           CALL FILL (512, 0, FGBUFF)
                           DOCOPY = .FALSE.
                           END IF
                        BT = TIME - TEPS
                        ET = TIME + TEPS
                        IF (BCH.LE.0) BCH = LCH
                        ECH = LCH
                     ELSE IF (BCH.GT.0) THEN
                        CALL FLAGUP ('FLAG', LUN1, INDISK, CNO, OUTFG,
     *                     FGBUFF, IFGRNO, FGKOLS, FGNUMV, SOURID, 1,
     *                     SUBA, FREQID, 1, ANTNO, 0, BT, ET, LIF, LIF,
     *                     BCH, ECH, CSTOKE(LP), REASON, NW, IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET,
     *                        'ADDING FLAGS TO TABLE'
                           GO TO 990
                           END IF
                        NFLAGS = NFLAGS + NW
                        BCH = 0
                        END IF
                     END IF
 30               CONTINUE
               IF (BCH.GT.0) THEN
                  CALL FLAGUP ('FLAG', LUN1, INDISK, CNO, OUTFG,
     *               FGBUFF, IFGRNO, FGKOLS, FGNUMV, SOURID, 1,
     *               SUBA, FREQID, 1, ANTNO, 0, BT, ET, LIF, LIF,
     *               BCH, ECH, CSTOKE(LP), REASON, NW, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'ADDING FLAGS TO TABLE'
                     GO TO 990
                     END IF
                  NFLAGS = NFLAGS + NW
                  END IF
 40            CONTINUE
 50         CONTINUE
 100     CONTINUE
      WRITE (MSGTXT,1100) NFLAGS, OUTFG
      CALL MSGWRT (4)
C                                       close
      CALL TABBP ('CLOS', BPBUFF, IBPRNO, BPKOLS, BPNUMV, NIFBP, NCHNBP,
     *   NPOLBP, TIME, INTERV, SOURID, SUBA, ANTNO, CHNBND, BPFREQ,
     *   FREQID, BPREF, WEIGHT, BNDPAS, JERR)
      CALL FLAGUP ('CLOS', LUN1, INDISK, CNO, OUTFG, FGBUFF, IFGRNO,
     *   FGKOLS, FGNUMV, SOURID, 1, SUBA, FREQID, 1, ANTNO, 0, BT, ET,
     *   LIF, LIF, LCH, LCH, CSTOKE(LP), REASON, NW, IRET)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPFLGT: ERROR',I5,' ON ',A)
 1010 FORMAT (A6,I5,2('/',I2.2),I3.2,2I2.2)
 1100 FORMAT ('Wrote',I12,' new flags to FG table version',I4)
      END
      SUBROUTINE BPFLHI (IRET)
C-----------------------------------------------------------------------
C   BPFGHI writes some history records to record what we did
C   Output:
C      IRET   I   Error code - always 0
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'BPFLG.INC'
      INTEGER   IERR, HIBUFF(256), IT(4), ID(3), IHLUN, I, I1, I2
      CHARACTER HILINE*72, ATIME*8, ADATE*12
      REAL      TEMP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA IHLUN /29/
C-----------------------------------------------------------------------
      IRET = 0
      IF (NFLAGS.LE.0) GO TO 999
C                                       Initialize HI common
      CALL HIINIT (3)
C                                       Open HI file
      CALL HIOPEN (IHLUN, INDISK, CNO, HIBUFF, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.EQ.5) THEN
            WRITE (MSGTXT,1000)
         ELSE
            WRITE (MSGTXT,1010) IERR
            END IF
         GO TO 990
         END IF
C                                       Header text
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, ATIME, ADATE)
      WRITE (HILINE,1020) TSKNAM, RLSNAM, ADATE, ATIME
      CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
      IF (IERR.NE.0) GO TO 90
C                                       versions
      WRITE (HILINE,1025) TSKNAM, BPVER
      CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
      IF (IERR.NE.0) GO TO 90
      WRITE (HILINE,1030) TSKNAM, INFG
      CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
      IF (IERR.NE.0) GO TO 90
      WRITE (HILINE,1035) TSKNAM, OUTFG
      CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
      IF (IERR.NE.0) GO TO 90
C                                       IFs
      WRITE (HILINE,1040) TSKNAM, 'BIF', BIF
      CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
      IF (IERR.NE.0) GO TO 90
      WRITE (HILINE,1040) TSKNAM, 'EIF', EIF
      CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
      IF (IERR.NE.0) GO TO 90
C                                       times
      IF (TIMBEG.GT.0.0) THEN
         IT(1) = TIMBEG
         TEMP  = (TIMBEG - IT(1)) * 24.0
         IT(2) = TEMP
         TEMP = (TEMP - IT(2)) * 60.0
         IT(3) = TEMP
         TEMP = (TEMP - IT(3)) * 60.0
         IT(4) = TEMP
         WRITE (HILINE,1050) TSKNAM, 'BEG', IT
         CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
         IF (IERR.NE.0) GO TO 90
         END IF
      IF (TIMEND.LT.1000.0) THEN
         IT(1) = TIMEND
         TEMP  = (TIMBEG - IT(1)) * 24.0
         IT(2) = TEMP
         TEMP = (TEMP - IT(2)) * 60.0
         IT(3) = TEMP
         TEMP = (TEMP - IT(3)) * 60.0
         IT(4) = TEMP
         WRITE (HILINE,1050) TSKNAM, 'END', IT
         CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
         IF (IERR.NE.0) GO TO 90
         END IF
C                                       antennas
      IF (NANT.LE.0) THEN
         WRITE (HILINE,1055) TSKNAM
         CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
         IF (IERR.NE.0) GO TO 90
      ELSE
         I1 = 1
 10      I2 = MIN (I1+13, NANT)
         WRITE (HILINE,1060) TSKNAM, (ANTS(I), I = I1,I2)
         IF (I1.GT.1) HILINE(:16) = ' '
         CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
         IF (IERR.NE.0) GO TO 90
         IF (I2.LT.NANT) GO TO 10
         END IF
C                                       number flagged
      WRITE (HILINE,1070) TSKNAM, NFLAGS
      CALL HIADD (IHLUN, HILINE, HIBUFF, IERR)
      IF (IERR.NE.0) GO TO 90
      GO TO 100
C                                       ERROR
 90   WRITE (MSGTXT,1090) IERR
      CALL MSGWRT (6)
C                                       Close file updating it
 100  CALL HICLOS (IHLUN, .TRUE., HIBUFF, IERR)
      GO TO 999
C
 990  CALL MSGWRT (6)

C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPSMHI: HISTORY FILE DOES NOT EXIST')
 1010 FORMAT ('BPSMHI: ERROR',I5,' OPENING THE HISTORY FILE')
 1020 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',A12,2X,A8)
 1025 FORMAT (A6,'INVERS   =',I5,'  / BP table version number')
 1030 FORMAT (A6,'FLAGVER  =',I5,'  / FG table input version')
 1035 FORMAT (A6,'OUTFGVER =',I5,'  / FG table output version')
 1040 FORMAT (A6,A3,'      =',I5,'  / IF range')
 1050 FORMAT (A6,A3,'TIM   =',I3,2(':',I2.2),I2.2,'  / time range')
 1055 FORMAT (A6,'ANTENNAS =   0','  / all antennas included')
 1060 FORMAT (A6,'ANTENNAS =',14(I3,','))
 1070 FORMAT (A6,'/  NFLAGS=',I10,'  / number flag recirds written')
 1090 FORMAT ('BPSMHI: ERROR',I5,' ADDING TO THE HISTORY FILE')
      END

      SUBROUTINE SHINCP (RA, DEC, ROTATE, XRA, XDEC, DXC, DYC, DZC)
C-----------------------------------------------------------------------
C! Returns shifts of coordinates in phase-shift units (-NCP projection)
C# Map Header coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1999
C;  Associated Universities, Inc. Washington DC, USA.
C;  Eric W. Greisen
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Finds coordinate shift frm RA,DEC to XRA, XDEC and phase terms for
C   -NCP projection
C   Input:
C      RA       D   Initial RA in degrees: reference position
C      DEC      D   Initial Declination in degrees
C      ROTATE   R   Image rotation in degrees
C      XRA      D   RA of shifted point in degrees
C      XDEC     D   Declination of shifted point in degrees
C   Output
C      DXC      R        U Phase term for Position offset in X
C      DYC      R        V Phase term for Position offset in Y
C      DZC      R        W Phase term for Position offset in X, Y
C-----------------------------------------------------------------------
      DOUBLE PRECISION RA, DEC, XRA, XDEC
      REAL      ROTATE, DXC, DYC, DZC
C
      REAL      MAPRR, XSHIFT, YSHIFT
      DOUBLE PRECISION XXSHFT, YYSHFT
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      MAPRR = ROTATE * DG2RAD
C                                       L, M
      XXSHFT = COS (DG2RAD*XDEC) * SIN (DG2RAD*(XRA-RA))
      YYSHFT = SIN (DG2RAD * DEC)
      IF (YYSHFT.NE.0.0D0) THEN
         YYSHFT = (COS (DG2RAD*DEC) - COS (DG2RAD*XDEC) *
     *       COS (DG2RAD*(XRA-RA))) / YYSHFT
      ELSE
         YYSHFT = XDEC - DEC
         END IF
C                                       Undo rotation
      XSHIFT = (COS (MAPRR) * XXSHFT + SIN (MAPRR) * YYSHFT) / DG2RAD *
     *   3600.0
      YSHIFT = (-SIN (MAPRR) * XXSHFT + COS (MAPRR) * YYSHFT) / DG2RAD *
     *   3600.0
C                                       Convert to radians
      DXC = XSHIFT * DG2RAD / 3600.0D0
      DYC = YSHIFT * DG2RAD / 3600.0D0
C                                       Prepare phase calc; mult by 2pi
      DXC = TWOPI * DXC
      DYC = TWOPI * DYC
      DZC = 0.0
C
 999  RETURN
      END

LOCAL INCLUDE 'OFUDG.INC'
C                                       Local include for OFUDG
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAME2(3), XCLAS2(2),
     *   XNAMOU(3), XCLAOU(2)
      REAL      XSIN, XDISIN, XS2, XDISK2, XSOUT, XDISO, APARM(10),
     *   BPARM(10), BOX(4,10)
      REAL       BUFF1(UVBFSS), BUFF2(UVBFSS)
      INTEGER   SEQIN, SEQ2, SEQOUT, DISKIN, DISK2, DISKO, NUMHIS,
     *   JBUFSZ, ILOCWT, CATOLD(256), INCSI, INCFI, INCIFI, INCSO,
     *   INCFO, INCIFO, LRECI, LRECO, NRPRMI, NRPRMO, OLDCNO, NEWCNO
      LOGICAL   ISCOMP
      CHARACTER NAMEIN*12, CLAIN*6, NAME2*12, CLAS2*6,
     *   NAMOUT*12, CLAOUT*6, HISCRD(10)*64
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAME2, XCLAS2,
     *   XS2, XDISK2, XNAMOU, XCLAOU, XSOUT, XDISO, APARM, BPARM, BOX
      COMMON /TPARMS/ CATOLD, SEQIN, SEQ2, SEQOUT, DISKIN, DISK2, DISKO,
     *   NUMHIS, ILOCWT, INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO,
     *   LRECI, LRECO, NRPRMI, NRPRMO, ISCOMP, OLDCNO, NEWCNO
      COMMON /CHARPM/ NAMEIN, CLAIN, NAME2, CLAS2, NAMOUT, CLAOUT,
     *   HISCRD
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
C                                       End local include for OFUDG
LOCAL END
      PROGRAM OFUDG
C-----------------------------------------------------------------------
C! Allows user to provide subroutine to operate on UV data base
C# Utility UV UV-util VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000, 2002, 2011, 2020-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   OFUDG allows a user to provide a subroutine which performs an
C   operation on a UV data base, writing an output UV data base.
C   OFUDG is FUDGE before all of the calibration adverbs were added.
C   IMPORTANT NOTE: to avoid confusion this task should be renamed.
C   To rename (max. 5 char) and install the new task :
C     1) copy the source code to a new file with the name newname.
C        then add desired code to subroutine DIDDLE.
C     2) using the source editor change all references to OFUDG to
C        newname.  It is especially important to change the string
C        entered into PRGM at or near line 61 to the new name.
C     3) copy inputs file for OFUDG to inputs file for newname.
C     4) compile and link edit with the APL and NOTST subroutine
C        libraries from AIPS.
C     5) copy and modify as appropriate the OFUDG HELP file.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      IN2NAME        NAME2         Name of aux. file.
C      IN2CLASS       CLAS2         Class of aux. file.
C      IN2SEQ         SEQ2          Seq. no. of aux. file.
C      IN2DISK        DISK2         Vol. no. of aux. file.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      APARM(10)      APARM         User specified array.
C      BPARM(10)      BPARM         User specified array.
C      BOX(4,10)      BOX           User specified array.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'OFUDG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
C
C   CHANGE THIS DATA STMT. IF CHANGING THE PROGRAM NAME.
C
      DATA PRGM /'OFUDG '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL FUDGIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL SENDUV (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL FUGHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE FUDGIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   FUDGIN gets input parameters for OFUDG and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in OFUDG for more details.
C
C   To change the adverb list sent to this task change:
C   1)  the inputs file.
C   2)  the contents of COMMON /INPARM/.  Remember all adverbs are sent
C       as R, INNAME etc. are 12 char. 3 words;
C       INCLASS etc. are 6 char., 2 words.
C       Values will be filled into COMMON /INPARM/ in the order
C       specified in the inputs file.
C   3)  If the first adverb is not INNAME (NAMEIN) then replace
C       NAMEIN in the call to GTPARM with the name of the first
C       adverb.
C   4)  Change the value of NPARM sent to GTPARM to the number of
C       R words desired.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX
      LOGICAL   T, F
      INCLUDE 'OFUDG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK  /'      '/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 81
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAME2, NAME2)
      CALL H2CHR (6, 1, XCLAS2, CLAS2)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      SEQ2 = IROUND (XS2)
      DISKIN = IROUND (XDISIN)
      DISK2 = IROUND (XDISK2)
      DISKO = IROUND (XDISO)
C                                       Example code scale factor
      IF (APARM(1).EQ.0.0) APARM(1) = 1.0
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      NEWCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, NEWCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((NEWCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, NEWCNO, CATBLK, 'WRIT', BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FUDGIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('FUDGIN: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE SENDUV (IRET)
C-----------------------------------------------------------------------
C   SENDUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48, IFILE*48
      INTEGER   INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, ILENBU,
     *   KBIND, NIOUT, NIOLIM, IBIND, I, IA1, IA2, INCX, BO, VO,
     *   NUMVIS, XCOUNT, NCORI, NCORO, NCOPY, RNXRET, VISINC, VISMSG
      LOGICAL   T, F
      INCLUDE 'OFUDG.INC'
      REAL      DUM, BASEN, CBUFF(UVBFSS), RESULT(UVBFSS)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI, LUNO /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
      IF (ISCOMP) INCX = 3
      VISINC = CATBLK(KIGCN) / 20
      VISMSG = CATBLK(KIGCN) / 10
      VISINC = MAX (20000, MIN (200000,VISINC))
      VISMSG = (VISMSG / VISINC) * VISINC
      IF (VISMSG.LT.VISINC) VISMSG = 100 * VISINC
C                                       Number of visibilities in input
C                                       and output files.
      NCORI = (LRECI - NRPRMI) / CATOLD(KINAX)
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, NEWCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Out of data?
         IF (INIO.LE.0) GO TO 200
C                                       Loop over buffer
         DO 190 I = 1,INIO
            IF (ILOCB.GE.0) THEN
               BASEN = BUFF1(IPTRI+ILOCB)
               IA1 = BASEN / 256. + 0.1
               IA2 = BASEN - IA1*256. + 0.1
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               END IF
            NUMVIS = NUMVIS + 1
            IF (MOD(NUMVIS-1,VISMSG).EQ.0) THEN
               WRITE (MSGTXT,1105) NUMVIS
               CALL MSGWRT (2)
            ELSE IF (MOD(NUMVIS-1,VISINC).EQ.0) THEN
               WRITE (MSGTXT,1105) NUMVIS
               CALL MSGWRT (1)
               END IF
C                                      Call user routine.
            IF (ISCOMP) THEN
C                                       Compressed data.
               CALL ZUVXPN (NCORI, BUFF1(IPTRI+NRPRMI),
     *            BUFF1(IPTRI+ILOCWT), CBUFF)
               CALL DIDDLE (NUMVIS, BUFF1(IPTRI+ILOCU),
     *            BUFF1(IPTRI+ILOCV), BUFF1(IPTRI+ILOCW),
     *            BUFF1(IPTRI+ILOCT), IA1, IA2, CBUFF, BUFF1(IPTRI),
     *            INCX, RESULT, IRET)
            ELSE
C                                       Un compressed data
               CALL DIDDLE (NUMVIS, BUFF1(IPTRI+ILOCU),
     *            BUFF1(IPTRI+ILOCV), BUFF1(IPTRI+ILOCW),
     *            BUFF1(IPTRI+ILOCT), IA1, IA2, BUFF1(IPTRI+NRPRMI),
     *            BUFF1(IPTRI), INCX, RESULT, IRET)
               END IF
C                                       Branch on his return
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
C                                       Copy to output.
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1.0D0
               CALL RCOPY (NRPRMO, BUFF1(IPTRI), BUFF2(IPTRO))
C                                       update NX table
               CALL RNXUPD (BUFF1(IPTRI), RNXRET)
C                                       Compressed
               IF (ISCOMP) THEN
                  CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *               BUFF2(IPTRO+NRPRMO))
               ELSE
                  CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
                  END IF
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               END IF
C                                       OK, but no output please
            IPTRI = IPTRI + LRECI
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
C                                       Read next buffer.
         GO TO 100
C                                       Final call to DIDDLE.
 200     NUMVIS = -1
         CALL DIDDLE (NUMVIS, DUM, DUM, DUM, DUM, IA1, IA2, BUFF1,
     *      BUFF1, INCX, RESULT, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
            END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, NEWCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SENDUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1010 FORMAT ('SENDUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('SENDUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('SENDUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('SENDUV: ERROR',I3,' READING VIS FILE')
 1105 FORMAT ('SENDUV: at visibility record',I10)
 1120 FORMAT ('SENDUV: DIDDLE ERROR',I3)
 1150 FORMAT ('SENDUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE FUGHIS
C-----------------------------------------------------------------------
C   FUGHIS copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP*2, HILINE*72, LABEL*8
      INTEGER   LUN1, LUN2, IERR, I, NONOT
      LOGICAL   T, F
      INCLUDE 'OFUDG.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T, F /.TRUE.,.FALSE./
      DATA NONOT, NOTTYP /0, '  '/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any other history.
      IF (NUMHIS.GT.0) THEN
         WRITE (LABEL,1010) TSKNAM
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
         END IF
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO,
     *   FCNO(2), FCNO(1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1200)
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST',
     *   BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FUGHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,' /')
 1200 FORMAT ('FUGHIS: ERROR COPYING TABLES')
      END
      SUBROUTINE DIDDLE (NUMVIS, U, V, W, T, IA1, IA2, VIS, RPARM,
     *   INCX, RESULT, IRET)
C-----------------------------------------------------------------------
C   This is a skeleton version of subroutine DIDDLE which allows the
C   user to modify a UV data base.  Visibilities are sent one at a time
C   and when returned are written on the output file if so specified.
C
C   Up to 10 history entries can be written by using WRITE to
C   record up to 64 characters per entry into array HISCRD.  Format:
C          WRITE (HISCRD(entry #),format) history information
C   The history is written after the last call to DIDDLE.
C
C   Messages can be written to the monitor/logfile by WRITEing
C   the message (up to 80 char) into array MSGTXT in COMMON /MSGCOM/
C   and then issuing a call:
C            CALL MSGWRT (priority #)
C
C   Unit 1 is the line printer
C
C   If IRET > 0, then the output file will be destroyed iff
C   it was created in the current execution.
C
C   If the size of the vis record is to be changed, appropriate
C   modifications should be made to CATBLK in FUDGIN before the call
C   to UVCREA.  Pointers and increments are passed in the common to
C   interprete the structure of the input and output data records.
C   See the precursor comments for UVPGET for a description.
C
C   After all data has been processed a final call will be made to
C   DIDDLE with NUMVIS = -1.  This is to allow for the completion of
C   pending operations, i.e. preparation of HIstory cards.
C
C   LUN's 16 and 17 are open and not available to DIDDLE.
C
C   The current contents of CATBLK will be written back to the
C   catalog after the last call to DIDDLE.
C
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      U       R    U in wavelengths
C      V       R    V in wavelengths
C      W       R    W in wavelengths
C      T       R    Time in days since 0 IAT on the first day for
C                   which there is data, the julian day corresponding
C                   to this day can be obtained in D   form by:
C                   CALL JULDAY (CATH(KHDOB),XDAY) where XDAY will
C                   be the Julian day number.
C      IA1     I    First antenna number
C      IA2     I    Second antenna number
C      RPARM   R(*) Random parameter array which includes U,V,W etc
C                   but also any other random parameters.
C      VIS     R(INCX,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                   NOTE: INCX may be any value .GE. 2
C   Inputs from COMMON:
C      NAME2      C*12    Name of the aux. file
C      CLAS2      C*6     Class of the aux. file.
C      SEQ2       I       Sequence number of the aux. file.
C      DISK2      I       Volumn number of the aux. file.
C      APARM(10)  R(10)   User array.
C      BPARM(10)  R(10)   User array.
C      BOX(4,10)  R(4,10) User array.
C      RA         D       Right ascension (1950) of phase center. (deg)
C      DEC        D       Declination (1950) of phase center. (deg)
C      FREQ       D       Frequency of observation (Hz)
C      NRPARM     I       # random parameters.
C      NCOR       I       # correlators
C      CATBLK     I(256)  Catalog header record. See Going Aips for
C                         details.
C      LRECI      I    Input file record length
C      NRPRMI     I    Input number of random parameters.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
C      LRECO      I    Output file record length
C      NRPRMO     I    Output number of random parameters.
C      INCSO      I    Output Stokes' increment in vis.
C      INCFO      I    Output frequency increment in vis.
C      INCIFO     I    Output IF increment in vis.
C   Output:
C      U          R    U in wavelengths
C      V          R    V in wavelengths
C      W          R    W in wavelengths
C      T          R    Time in same units as input.
C      RPARM      R    Modified random parameter array.
C      RESULT  R(INCX,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C
C   Output in COMMON:
C      NUMHIS    I         # history entries (max. 10)
C      HISCRD    C(NUMHIS) History records
C      CATBLK    I         Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IA1, IA2, INCX, IRET
      REAL      U, V, W, T, VIS(INCX,*), RPARM(*), RESULT(INCX,*)
C
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXO, INDEXI, I
      REAL      WFAC
      INCLUDE 'OFUDG.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.GT.0) THEN
C
C    USER CODE GOES HERE - for actual visibilities
C
C                                       EXAMPLE - copy data with scale
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
         WFAC = 1.0
         IF (APARM(1).NE.0.0) WFAC = 1.0 / (APARM(1) * APARM(1))
         DO 40 JIF = 1,NIF
            DO 30 JF = 1,NF
               DO 20 JS = 1,NS
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *               (JS-1) * INCSO + 1
C                                       Example does scaling
                  DO 10 I = 1,INCX
                     IF (I.LE.2) THEN
                        RESULT(I,INDEXO) = VIS(I,INDEXI) * APARM(1)
                     ELSE
                        RESULT(I,INDEXO) = VIS(I,INDEXI) * WFAC
                        END IF
 10                  CONTINUE
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
C                                       end of example (vis)
C                                       last call - no vis
      ELSE
C
C
C   USER CODE GOES HERE - for last call (no data)
C                                       example of scaling
         NUMHIS = 1
         WRITE (HISCRD(1),1100) TSKNAM, APARM(1)
C
C
C
C
C
C
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
C   FORMAT STATEMENTS GO HERE
 1100 FORMAT (A6,'APARM(1) =',F9.4,'  / amplitude scale factor')
      END

      SUBROUTINE XGPOLY (MINC, MPOLY, IG, NPY, NV, XV, YV, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! Does blotch setting with TV on pixel-replicated TV images
C# Map Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GRPOLY uses a graphics plane to let the user develop a set of
C   closed polygons as a "blotch" region.  Handles pixel replicated
C   images
C   Inputs:
C      MINC    I          Number TV pixels per image pixel > 1 usually
C      MPOLY   I          Dimension of NV, XV/YV 10 times this
C      IG      I          graphics plane to use
C   Output:
C      NPY     I          Number of polygons set
C      NV      I(MPOLY)   Number of vertices in each polygon
C      XV      I(*)       X-position of vertices in image
C      YV      I(*)       Y-position of vertices in image
C      SCRTCH  I(*)       Scratch buffer: > 1 line length (> 1280)
C      IERR    I          Error code
C   Common:
C      /MAPHDR/ CATBLK image catalog block of blotched image
C                      (actually used at lower level in YCUCOR)
C-----------------------------------------------------------------------
      INTEGER   MINC, MPOLY, IG, NPY, NV(MPOLY), XV(*), YV(*),
     *   SCRTCH(*), IERR
C
      INTEGER   ICH, ITW(3), IX(3), IY(3), IPOS, IB, IE, QUAD, IBUT,
     *   I, LB, LE, IBO, J, JERR, ITEMP, KERR, SCROLX, SCROLY
      REAL      PPOS(7), RPOS(2), DLIM
      LOGICAL   T, F, DOIT, ONGR
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Check inputs
      IERR = 2
      IF ((IG.LT.1) .OR. (IG.GT.NGRAPH)) GO TO 999
C                                       Init
      CALL YHOLD ('ONNN', IERR)
      ICH = NGRAY + IG
      CALL YZERO (ICH, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZTIME (ITW)
C                                       turn on graphics to be sure
      I = 2 ** (ICH - 1)
      ONGR = MOD (TVLIMG(1)/I, 2) .EQ. 1
      CALL YSLECT ('ONNN', ICH, 0, SCRTCH, IERR)
      IPOS = 1
      IF (IERR.NE.0) GO TO 900
C                                       no scroll on graphics now
      ITEMP = 2 ** NGRAY
      SCROLX = TVSCRX(1)
      SCROLY = TVSCRY(1)
      CALL YSCROL (ITEMP, SCROLX, SCROLY, T, IERR)
      IPOS = 2
      IF (IERR.NE.0) GO TO 900
      NPY = 0
      IB = 0
      IE = 0
C                                       Start new polygon
 40   IF (NPY.GE.MPOLY) GO TO 800
      NPY = NPY + 1
      IB = IE + 1
      IE = IB
      NV(NPY) = 0
      WRITE (MSGTXT,1040) NPY
      CALL MSGWRT (1)
      MSGTXT = 'Press button A to set intermediate vertex'
      CALL MSGWRT (1)
      MSGTXT = 'Press buttons B, C, or D to set final vertex'
      CALL MSGWRT (1)
      MSGTXT = 'C => then reset a vertex,  D => then exit'
      CALL MSGWRT (1)
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
      RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2
C                                       No scroll correction
C      QUAD = -1
C                                       ON cursor at desired position
      CALL YHOLD ('OFFF', IERR)
      CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 900
      IF (IERR.EQ.2) CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IERR)
      IPOS = 3
      IF (IERR.NE.0) GO TO 900
C                                       Cursor read loop
 50   CALL YCURSE ('READ', T, T, RPOS, QUAD, IBUT, IERR)
         IPOS = 4
         IF (IERR.NE.0) GO TO 900
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF (.NOT.DOIT) GO TO 50
C                                       No button -> no action
         IF (IBUT.EQ.0) GO TO 50
C                                       Time to quit marking
         IF ((IBUT.LT.4) .OR. (IB.LT.IE)) GO TO 60
            NPY = NPY - 1
            GO TO 200
C                                       check new vertex
 60      QUAD = 0
         CALL YCUCOR (RPOS, QUAD, PPOS, KERR)
         IF (KERR.NE.0) THEN
            MSGTXT = 'NOT ON IMAGE - TRY AGAIN'
            CALL MSGWRT (1)
            GO TO 50
            END IF
C                                       Mark new vertex
         NV(NPY) = NV(NPY) + 1
         XV(IE) = RPOS(1) + 0.51
         YV(IE) = RPOS(2) + 0.51
         IF (IB.EQ.IE) XV(IE+1) = XV(IE)
         IF (IB.EQ.IE) YV(IE+1) = YV(IE)
         I = MAX (IB, IE-1)
         IE = IE + 1
C                                       draw line
         CALL XGVECT ('ONNN', ICH, 2, XV(I), YV(I), SCRTCH, IERR)
         IPOS = 6
         IF (IERR.NE.0) GO TO 900
C                                       done with polygon
         IF ((IBUT.LT.2) .AND. (IE.LT.10*MPOLY)) GO TO 50
            NV(NPY) = NV(NPY) + 1
            XV(IE) = XV(IB)
            YV(IE) = YV(IB)
C                                       draw line
            CALL XGVECT ('ONNN', ICH, 2, XV(IE-1), YV(IE-1), SCRTCH,
     *         IERR)
            IPOS = 7
            IF (IERR.NE.0) GO TO 900
C                                       Respond further to buttons
         IF (IE.GE.10*MPOLY) GO TO 810
         IF (IBUT.LT.4) GO TO 40
C                                       Vertex correction area
         IF (IBUT.GE.8) GO TO 200
C                                       some already set box
C                                       wait for indication which
 100  MSGTXT = '*************  Move cursor to vertex to be reset'
      CALL MSGWRT (1)
      MSGTXT = 'Then push button A or B to do resetting -- or'
      CALL MSGWRT (1)
      MSGTXT = 'push C to go to next region  or D to exit'
      CALL MSGWRT (1)
      CALL YCURSE ('READ', T, T, RPOS, QUAD, IBUT, IERR)
      IPOS = 10
      IF (IERR.NE.0) GO TO 900
C                                       check button
      IF (IBUT.GE.8) GO TO 200
C                                       redraw polygons to be safe
      IF (IBUT.LT.4) GO TO 120
         LB = 1
         CALL YHOLD ('ONNN', IERR)
         DO 110 I = 1,NPY
            CALL XGVECT ('ONNN', ICH, NV(I), XV(LB), YV(LB), SCRTCH,
     *         IERR)
            IPOS = 10
            IF (IERR.NE.0) GO TO 900
            LB = LB + NV(I)
 110        CONTINUE
         CALL YHOLD ('OFFF', IERR)
         GO TO 40
C                                       Find nearest corner
 120  DLIM = MAX (0.5, MINC/3.0)
 125  LB = 1
      DO 135 I = 1,NPY
         LE = LB + NV(I) - 1
         DO 130 J = LB,LE
            IF ((ABS(RPOS(1)-XV(J)).LE.DLIM) .AND. (ABS(RPOS(2)
     *         -YV(J)).LE.DLIM)) GO TO 140
 130        CONTINUE
         LB = LE + 1
 135     CONTINUE
      DLIM = DLIM + 1.5
      IF (DLIM.LE.MINC-1) GO TO 125
      GO TO 100
C                                       Got one
 140  IF (J.EQ.LE) J = LB
      IBO = J
      RPOS(1) = XV(IBO)
      RPOS(2) = YV(IBO)
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      IX(2) = XV(IBO)
      IX(1) = XV(IBO-1)
      IX(3) = XV(IBO+1)
      IF (IBO.EQ.LB) IX(1) = XV(LE-1)
      IY(2) = YV(IBO)
      IY(1) = YV(IBO-1)
      IY(3) = YV(IBO+1)
      IF (IBO.EQ.LB) IY(1) = YV(LE-1)
C                                       Cursor read loop
 150  CALL YCURSE ('READ', F, T, RPOS, QUAD, IBUT, IERR)
         IPOS = 15
         IF (IERR.NE.0) GO TO 900
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF (.NOT.DOIT) GO TO 150
C                                       draw new lines
         CALL YHOLD ('ONNN', IERR)
         CALL XGVECT ('OFFF', ICH, 3, IX, IY, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         IX(2) = RPOS(1) + 0.5
         IY(2) = RPOS(2) + 0.5
         CALL XGVECT ('ONNN', ICH, 3, IX, IY, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL YHOLD ('OFFF', IERR)
C                                       mark this one
         IF (IBUT.EQ.0) GO TO 150
            XV(IBO) = IX(2)
            YV(IBO) = IY(2)
            IF (IBUT.LT.4) GO TO 100
            IF (IBUT.LT.8) GO TO 40
C                                       DONE: fill in real boxes
 200  IERR = 2
      IF (NPY.LT.1) GO TO 999
C                                       fill them in for fun
      CALL YHOLD ('ONNN', IERR)
      CALL BLTFIL (NPY, NV, XV, YV, IG, SCRTCH, IERR)
      IPOS = 20
      IF (IERR.NE.0) GO TO 900
      CALL YHOLD ('OFFF', IERR)
C                                       corners with scroll now
      TVSCRX(1) = 0
      TVSCRY(1) = 0
      LB = 1
      DO 230 I = 1,NPY
         LE = LB + NV(I) - 1
         DO 220 J = LB,LE
            RPOS(1) = XV(J)
            RPOS(2) = YV(J)
            QUAD = 0
            CALL YCUCOR (RPOS, QUAD, PPOS, KERR)
            IF (KERR.NE.0) THEN
               WRITE (MSGTXT,1200) KERR
               IF (KERR.EQ.1) WRITE (MSGTXT,1201) XV(J), YV(J)
               CALL MSGWRT (7)
               IF (KERR.NE.1) IERR = KERR
               IF (KERR.NE.1) GO TO 900
               IERR = IERR + KERR
               END IF
            XV(J) = PPOS(1) + 0.5
            YV(J) = PPOS(2) + 0.5
 220        CONTINUE
         LB = LE + 1
 230     CONTINUE
      IF (IERR.GT.0) IERR = 10 + IERR
      TVSCRX(1) = SCROLX
      TVSCRY(1) = SCROLY
      GO TO 900
C                                       Overflow problems
 800  WRITE (MSGTXT,1800) MPOLY
      CALL MSGWRT (7)
      GO TO 900
 810  WRITE (MSGTXT,1810) 10*MPOLY
      CALL MSGWRT (7)
      GO TO 200
C                                       Off cursor, graphics, scroll
C                                       leave graphics on
 900  CALL YCURSE ('OFFF', F, T, RPOS, QUAD, IBUT, JERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1900) IERR, IPOS
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('>>>>>>>>>>>>> Begin setting region number',I4)
 1200 FORMAT ('ERROR',I5,' CONVERTING TV TO PIXEL COORDINATES')
 1201 FORMAT (2I5,' NOT IN ANY VISIBLE IMAGE')
 1800 FORMAT ('REACHED LIMIT OF',I4,' POLYGONS')
 1810 FORMAT ('REACHED LIMIT OF',I5,' VERTICES')
 1900 FORMAT ('XGPOLY: ERROR CODE',I7,' AT',I5)
      END

      PROGRAM FILINI
C-----------------------------------------------------------------------
C! FILINI creates and initializes AIPS files.
C# Service
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FILINI is a service program to create & initialize AIPS files.
C-----------------------------------------------------------------------
      CHARACTER MPASS*12, PHNAME*48, FTYP(11)*2, ITYP*2, MSGBUF*80,
     *   OPCODE(4)*4, OP*4, PRGNAM*6, LPASS*12
      HOLLERITH APASS(3)
      INTEGER   ISEQ, IVER, IERR, LUN, FIND, IQ1, IQ2, I, J1, J2, IR,
     *   INPOPS, BUFFER(256), NL, ILUSER, LTVDEV, TTYLUN, TTYIND, IVOL,
     *   IC, ICMAX, IMAX, INPOP1, INPOP2, IOP, IQ, IVOL1, IVOL2, J,
     *   NOP, IUS1, IUS2, I4T, ISIZE, IRNO, LSIZE, TTY(2), IARR(5),
     *   LIST(6), NREC, IDUM(5)
      REAL      RBUFFR(256)
      DOUBLE PRECISION DOUT
      LOGICAL   F, T
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PKSZ.INC'
      EQUIVALENCE (BUFFER, RBUFFR)
      EQUIVALENCE (TTY(1), TTYLUN),  (TTY(2), TTYIND)
      DATA MPASS /'AMANAGER    '/
      DATA OPCODE /'QUIT','CREA','DEST','INIT'/
      DATA F, T /.FALSE.,.TRUE./
      DATA LUN, TTYLUN /15,5/
      DATA LIST /2, -1, -1, -1, -1, 0/
      DATA NOP, FTYP /11,
     *   'BQ','BA','MS','IC','CA','TD','AC','ID','GR','PW','TC'/
      DATA PRGNAM /'FILINI'/
C-----------------------------------------------------------------------
C                                        Init itself
      CALL AIPINI (TTY, PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 990
      ILUSER = 0
      LTVDEV = NTVDEV
      CALL YTVCIN
C                                       Is this job ok?
C                                       Does password file exist
      CALL ZPHFIL (FTYP(10), 1, 0, 0, PHNAME, IERR)
      CALL ZEXIST (1, PHNAME, ISIZE, IERR)
C                                       Ask for password
      IF (IERR.EQ.0) THEN
         CALL PASWRD (BUFFER, IERR)
         IF (IERR.NE.0) GO TO 995
      ELSE IF (IERR.NE.1) THEN
         WRITE (MSGTXT,1005) IERR
         CALL MSGWRT (8)
         END IF
C                                        get basic op
 10   WRITE (MSGBUF,1010)
      CALL INQSTR (TTY, MSGBUF, 4, OP, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL CHLTOU (4, OP)
      IF (OP.EQ.OPCODE(1)) GO TO 995
      IF (OP.EQ.OPCODE(4)) GO TO 50
      IF (OP.EQ.OPCODE(3)) GO TO 30
      IF (OP.NE.OPCODE(2)) GO TO 10
C                                        CREATE
 20   WRITE (MSGBUF,1020) ILUSER
      CALL INQGEN (TTYLUN, MSGBUF, LIST, IARR, DOUT, ITYP, IERR)
      IF (IERR.GT.0) GO TO 990
      IF (IERR.LT.0) GO TO 20
      IVOL = IARR(1)
      ISEQ = IARR(2)
      IVER = IARR(3)
      IR = IARR(4)
      IF (IR.GT.0) ILUSER = IR
 25   WRITE (MSGBUF,1022) 0
      ISIZE = 3
      ISIZE = 256 / ISIZE
      ISIZE = (USELIM - 1) / ISIZE + 1
C                                       memory file
      IF (ITYP.EQ.'ME') THEN
         ISIZE = KBLOCK + LBLOCK
C                                       Not PW file
      ELSE IF (ITYP.NE.FTYP(10)) THEN
         CALL INQINT (TTY, MSGBUF, 1, IDUM, IERR)
         ISIZE = IDUM(1)
         IF (IERR.GT.0) GO TO 990
         IF (IERR.LT.0) GO TO 25
         IF (ISIZE.LE.0) ISIZE = 2
         END IF
      NLUSER = ILUSER
      CALL ZPHFIL (ITYP, IVOL, ISEQ, IVER, PHNAME, IERR)
      NLUSER = 1
      CALL ZEXIST (1, PHNAME, LSIZE, IERR)
      IF (IERR.EQ.0) THEN
         CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
         IF (IERR.NE.0) GO TO 910
         IF (LSIZE.LT.ISIZE) THEN
            MSGTXT = 'Expanding the file'
            CALL MSGWRT (2)
            NREC = (ISIZE - LSIZE)
            CALL ZEXPND (LUN, IVOL, PHNAME, NREC, IERR)
         ELSE IF (LSIZE.GT.ISIZE) THEN
            MSGTXT = 'Compressing the file'
            CALL MSGWRT (2)
            CALL ZCMPRS (IVOL, PHNAME, LUN, ISIZE, IERR)
         ELSE
            MSGTXT = 'File already exists of correct size'
            CALL MSGWRT (2)
            END IF
         CALL ZCLOSE (LUN, FIND, I)
      ELSE IF (IERR.EQ.1) THEN
         CALL ZCREAT (IVOL, PHNAME, ISIZE, F, LSIZE, IERR)
         END IF
      IF (IERR.NE.0) GO TO 900
      GO TO 10
C                                        DESTROY
 30   WRITE (MSGBUF,1020) ILUSER
      CALL INQGEN (TTYLUN, MSGBUF, LIST, IARR, DOUT, ITYP, IERR)
      IF (IERR.GT.0) GO TO 990
      IF (IERR.LT.0) GO TO 30
      IVOL = IARR(1)
      ISEQ = IARR(2)
      IVER = IARR(3)
      IR = IARR(4)
      IF (IR.GT.0) ILUSER = IR
      NLUSER = ILUSER
      CALL ZPHFIL (ITYP, IVOL, ISEQ, IVER, PHNAME, IERR)
      NLUSER = 1
      CALL ZDESTR (IVOL, PHNAME, IERR)
      IF (IERR.NE.0) GO TO 900
      GO TO 10
C-----------------------------------------------------------------------
C                                        INIT
 50   WRITE (MSGBUF,1050)
      CALL INQSTR (TTY, MSGBUF, 2, ITYP, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL CHLTOU (2, ITYP)
      DO 55 IOP = 1,NOP
         IF (ITYP.EQ.FTYP(IOP)) GO TO 60
 55      CONTINUE
      GO TO 10
C
 60   GO TO (100, 150, 200, 250, 300, 350, 400, 450, 500, 550, 600),
     *   IOP
      GO TO 10
C-----------------------------------------------------------------------
C                                        batch queuing
 100  WRITE (MSGBUF,1100)
      CALL INQINT (TTY, MSGBUF, 3, IARR, IERR)
      IF (IERR.GT.0) GO TO 990
      IF (IERR.LT.0) GO TO 100
      IQ = IARR(1)
      J1 = IARR(2)
      J2 = IARR(3)
      CALL ZPHFIL (ITYP, 1, 0, 0, PHNAME, IERR)
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) GO TO 910
      IF ((IQ.GT.0) .AND. (IQ.LE.NBATQS)) THEN
         IQ1 = IQ
         IQ2 = IQ
      ELSE
         IQ1 = 1
         IQ2 = NBATQS
         END IF
      J1 = MAX (1,J1)
      J2 = MIN (64,J2)
      IF (J2.LT.J1) THEN
         J1 = 1
         J2 = 64
         END IF
      J2 = 4 * (J2 - J1 + 1)
      J1 = 4*J1 - 3
      DO 130 IRNO = IQ1,IQ2
         CALL ZFIO ('READ', LUN, FIND, IRNO, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 920
         CALL FILL (J2, 0, BUFFER(J1))
         CALL ZFIO ('WRIT', LUN, FIND, IRNO, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 930
 130     CONTINUE
      GO TO 950
C-----------------------------------------------------------------------
C                                        batch work file
 150  WRITE (MSGBUF,1150)
      CALL INQINT (TTY, MSGBUF, 2, IARR, IERR)
      IF (IERR.GT.0) GO TO 990
      IF (IERR.LT.0) GO TO 150
      IQ = IARR(1)
      INPOPS = IARR(2)
      IF ((IQ.GE.1) .AND. (IQ.LE.NBATQS)) THEN
         IQ1 = IQ
         IQ2 = IQ
      ELSE
         IQ1 = 1
         IQ2 = NBATQS
         END IF
C                                       note BATER runs NPOPS =
C                                       NINTRN + 1
      IF ((INPOPS.GE.1) .AND. (INPOPS.LE.NINTRN+1)) THEN
         INPOP1 = INPOPS
         INPOP2 = INPOPS
      ELSE
         INPOP1 = 1
         INPOP2 = NINTRN + 1
         END IF
      DO 175 INPOPS = INPOP1,INPOP2
         DO 170 IQ = IQ1,IQ2
            CALL ZPHFIL (ITYP, 1, IQ, INPOPS, PHNAME, IERR)
            CALL ZEXIST (1, PHNAME, ISIZE, IERR)
            IF (IERR.NE.0) GO TO 940
            IR = ISIZE
            CALL FILL (256, 0, BUFFER)
            BUFFER(2) = 2
            BUFFER(3) = 1
            BUFFER(4) = IR
            CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
            IF (IERR.NE.0) GO TO 910
            CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 930
            CALL ZCLOSE (LUN, FIND, IERR)
 170        CONTINUE
 175     CONTINUE
      GO TO 900
C-----------------------------------------------------------------------
C                                        message files
 200  WRITE (MSGBUF,1502) ILUSER
      CALL INQINT (TTY, MSGBUF, 1, IDUM, IERR)
      I = IDUM(1)
      IF (IERR.GT.0) GO TO 990
      IF (IERR.LT.0) GO TO 200
      IF (I.GT.0) ILUSER = I
      IVOL = 1
      NLUSER = ILUSER
      CALL ZPHFIL (ITYP, IVOL, ILUSER, 0, PHNAME, IERR)
      CALL ZEXIST (1, PHNAME, ISIZE, IERR)
      NLUSER = 1
      IF (IERR.NE.0) GO TO 940
      CALL FILL (256, 0, BUFFER)
      BUFFER(2) = ISIZE
      CALL ZOPEN (LUN, FIND, IVOL, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) GO TO 910
      CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 930
      CALL ZCLOSE (LUN, FIND, IERR)
      GO TO 900
C-----------------------------------------------------------------------
C                                        image catalog
 250  IF (NTVDEV.LE.0) GO TO 270
         IC = NTVDEV
         WRITE (MSGTXT, 1230) IC
         CALL MSGWRT (2)
         MSGTXT = 'Use SETTVP to change TV parameters'
         CALL MSGWRT (2)
         DO 265 NTVDEV = 1,IC
 252        WRITE (MSGBUF,1250) NTVDEV
            CALL INQINT (TTY, MSGBUF, 1, IDUM, IERR)
            J1 = IDUM(1)
            IF (IERR.GT.0) GO TO 990
            IF (IERR.LT.0) GO TO 252
            IF (J1.EQ.-2) GO TO 269
            IF (J1.LT.0) GO TO 265
               CALL YTVCIN
               MSGTXT =  'Use TVINIT when running AIPS TVs'
               CALL MSGWRT (2)
 265        CONTINUE
 269     NTVDEV = IC
C                                       Graphics devices
 270  IF (NTKDEV.LE.0) GO TO 10
         INPOPS = NTKDEV
         WRITE (MSGBUF,1270)
         CALL INQINT (TTY, MSGBUF, 1, IDUM, IERR)
         J1 = IDUM(1)
         IF (IERR.GT.0) GO TO 990
         IF (IERR.LT.0) GO TO 270
         IF (J1.LE.0) GO TO 10
            NTKDEV = INPOPS
            GO TO 10
C-----------------------------------------------------------------------
C                                        file catalog
 300  WRITE (MSGBUF,1300)
      CALL INQINT (TTY, MSGBUF, 1, IDUM, IERR)
      IVOL = IDUM(1)
      IF (IERR.GT.0) GO TO 990
      IF (IERR.LT.0) GO TO 300
 301  IF (UCTSIZ.LE.0) GO TO 305
         WRITE (MSGBUF,1302) ILUSER
         CALL INQINT (TTY, MSGBUF, 1, IDUM, IERR)
         I = IDUM(1)
         IF (IERR.LT.0) GO TO 301
         IF (IERR.GT.0) GO TO 990
         IF (I.GT.0) ILUSER = I
         IF (ILUSER.LE.0) GO TO 301
 305  IF ((IVOL.GE.1) .AND. (IVOL.LE.NVOL)) THEN
         IVOL1 = IVOL
         IVOL2 = IVOL
      ELSE
         IVOL1 = 1
         IVOL2 = NVOL
         END IF
      DO 330 IVOL = IVOL1,IVOL2
         NLUSER = ILUSER
         CALL ZPHFIL (ITYP, IVOL, 0, 0, PHNAME, IERR)
         CALL ZEXIST (IVOL, PHNAME, ISIZE, IERR)
         IF (IERR.NE.0) GO TO 940
         ISIZE = ISIZE - 1
         NL = 256 / 10
         ICMAX = ISIZE * NL
         IF (ICMAX.GT.46655) ICMAX = 46655
         NLUSER = 1
         CALL ZOPEN (LUN, FIND, IVOL, PHNAME, F, T, T, IERR)
         IF (IERR.NE.0) GO TO 910
         CALL FILL (256, 0, BUFFER)
         BUFFER(1) = IVOL
         BUFFER(3) = ICMAX
         CALL ZDATE (BUFFER(4))
         CALL ZTIME (BUFFER(7))
         CALL ZDATE (BUFFER(10))
         CALL ZTIME (BUFFER(13))
         CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 930
         CALL FILL (16, 0, BUFFER)
         DO 310 I = 1,256,10
            BUFFER(I) = -1
 310        CONTINUE
         J1 = 2
         J2 = J1 + (ICMAX-1)/NL
         DO 320 IRNO = J1,J2
            CALL ZFIO ('WRIT', LUN, FIND, IRNO, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 930
 320        CONTINUE
         CALL ZCLOSE (LUN, FIND, IERR)
 330     CONTINUE
      GO TO 900
C-----------------------------------------------------------------------
C                                       task data file
 350  WRITE (MSGBUF,1200)
      CALL INQINT (TTY, MSGBUF, 1, IDUM, IERR)
      INPOPS = IDUM(1)
      IF (IERR.GT.0) GO TO 990
      IF (IERR.LT.0) GO TO 350
      CALL ZPHFIL (ITYP, 1, 0, 4, PHNAME, IERR)
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) GO TO 910
      CALL ZFIO ('READ', LUN, FIND, 1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 920
      IMAX = NINTRN + 1 + NBATQS
      IF (NBATQS.LE.0) IMAX = NINTRN
      IF ((INPOPS.GE.1) .AND. (INPOPS.LE.IMAX)) THEN
         INPOP1 = INPOPS
         INPOP2 = INPOPS
      ELSE
         INPOP1 = 1
         INPOP2 = IMAX
         END IF
      J1 = 5 * (INPOP2-INPOP1+1)
      J = 5*INPOP1 - 4
      CALL FILL (J1, 0, BUFFER(J))
      BUFFER(256) = 4
      CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 930
      GO TO 950
C-----------------------------------------------------------------------
C                                        Accounting
 400  CALL ZPHFIL (ITYP, 1, 0, 0, PHNAME, IERR)
      CALL ZEXIST (1, PHNAME, ISIZE, IERR)
      IF (IERR.NE.0) GO TO 940
      IR = ISIZE
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) GO TO 910
      CALL FILL (256, 0, BUFFER)
      BUFFER(3) = 9
      BUFFER(4) = 256 / BUFFER(3)
      BUFFER(2) = IR * BUFFER(4) - 1
      CALL ZFIO ('WRIT', LUN, FIND, 1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 930
      CALL ZCLOSE (LUN, FIND, IERR)
      GO TO 900
C-----------------------------------------------------------------------
C                                        TV device control
 450  WRITE (MSGBUF,1450)
      CALL INQINT (TTY, MSGBUF, 1, IDUM, IERR)
      IC = IDUM(1)
      IF (IERR.GT.0) GO TO 990
      IF (IERR.LT.0) GO TO 450
      IVOL1 = IC
      IVOL2 = IC
      IF ((IC.GT.0) .AND. (IC.LE.LTVDEV)) GO TO 460
         IVOL1 = 1
         IVOL2 = LTVDEV
 460  DO 470 NTVDEV = IVOL1,IVOL2
         CALL YTVCIN
         CALL ZPHFIL (ITYP, 1, 0, NTVDEV, PHNAME, IERR)
         CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
         IF (IERR.NE.0) GO TO 910
         CALL FILL (256, 0, BUFFER)
         CALL COPY (88, NGRAY, BUFFER)
         IRNO = 1
         CALL ZFIO ('WRIT', LUN, FIND, IRNO, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 930
         IF (ISUNUM.LE.0) GO TO 465
            CALL FILL (256, 0, BUFFER)
            IRNO = 2
            CALL ZFIO ('WRIT', LUN, FIND, IRNO, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 930
 465     CALL ZCLOSE (LUN, FIND, IERR)
 470     CONTINUE
      NTVDEV = LTVDEV
      GO TO 900
C-----------------------------------------------------------------------
C                                        Gripes
 500  CALL ZPHFIL (ITYP, 1, 0, 0, PHNAME, IERR)
      CALL ZEXIST (1, PHNAME, ISIZE, IERR)
      IF (IERR.NE.0) GO TO 940
      IR = ISIZE
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) GO TO 910
      CALL FILL (256, 0, BUFFER)
      BUFFER(1) = IR
      BUFFER(3) = 2
      BUFFER(4) = 1
      IRNO = 1
      CALL ZFIO ('WRIT', LUN, FIND, IRNO, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 930
      CALL ZCLOSE (LUN, FIND, IERR)
      GO TO 900
C-----------------------------------------------------------------------
C                                       Password file
 550  WRITE (MSGBUF,1550) USELIM
      CALL INQINT (TTY, MSGBUF, 2, IARR, IERR)
      IF (IERR.GT.0) GO TO 990
      IF (IERR.LT.0) GO TO 550
      IUS1 = MAX (1, IARR(1))
      IUS2 = MIN (USELIM, IARR(2))
      IF (IUS2.LT.IUS1) IUS2 = USELIM
      CALL ZPHFIL (ITYP, 1, 0, 0, PHNAME, IERR)
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) GO TO 910
      LPASS = ' '
      CALL PASENC (LPASS, APASS)
      I4T = 0
      J = 3
      J = 256 / J
      DO 560 I = IUS1,IUS2
         IRNO = (I-1) / J + 1
         IF (IRNO.EQ.I4T) GO TO 555
            IF (I4T.GT.0) CALL ZFIO ('WRIT', LUN, FIND, I4T, BUFFER,
     *         IERR)
            IF (IERR.NE.0) GO TO 930
            CALL ZFIO ('READ', LUN, FIND, IRNO, BUFFER, IERR)
            I4T = IRNO
            IF (IERR.NE.0) GO TO 920
 555     J1 = MOD (I-1, J)
         J1 = 3 * J1 + 1
         IF (I.NE.1) CALL RCOPY (3, APASS, RBUFFR(J1))
         IF (I.EQ.1) CALL PASENC (MPASS, RBUFFR(J1))
 560     CONTINUE
      IF (I4T.GT.0) CALL ZFIO ('WRIT', LUN, FIND, I4T, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 930
      CALL ZCLOSE (LUN, FIND, IERR)
      GO TO 900
C-----------------------------------------------------------------------
C                                       Task communications (SHOW, TELL)
 600  WRITE (MSGBUF,1200)
      CALL INQINT (TTY, MSGBUF, 1, IDUM, IERR)
      INPOPS = IDUM(1)
      IF (IERR.GT.0) GO TO 990
      IF (IERR.LT.0) GO TO 600
      CALL ZPHFIL (ITYP, 1, 0, 1, PHNAME, IERR)
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) GO TO 910
      IF (INPOPS.LE.0) THEN
         CALL FILL (256, 0, BUFFER)
         DO 610 IRNO = 1,18
            CALL ZFIO ('WRIT', LUN, FIND, IRNO, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 930
 610        CONTINUE
      ELSE
         IRNO = (INPOPS - 1) / 2 + 1
         CALL ZFIO ('READ', LUN, FIND, IRNO, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 920
         J = 128 * (INPOPS + 1 - 2*IRNO) + 1
         CALL FILL (128, 0, BUFFER(J))
         CALL ZFIO ('WRIT', LUN, FIND, IRNO, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 930
         END IF
      GO TO 950
C-----------------------------------------------------------------------
C                                        messages & close file
 900  WRITE (MSGTXT,1900) IERR
      CALL MSGWRT (7)
      GO TO 10
 910  WRITE (MSGTXT,1910) IERR
      CALL MSGWRT (7)
      GO TO 10
 920  WRITE (MSGTXT,1920) IERR
      CALL MSGWRT (7)
      GO TO 950
 930  WRITE (MSGTXT,1930) IERR
      CALL MSGWRT (7)
      GO TO 950
 940  WRITE (MSGTXT,1940) IERR
      CALL MSGWRT (7)
C
 950  CALL ZCLOSE (LUN, FIND, IERR)
      GO TO 900
 990  WRITE (MSGTXT,1990) IERR
      CALL MSGWRT (8)
C
 995  CALL ZCLOSE (TTYLUN, TTYIND, IERR)
      CALL ACOUNT (2)
C
 999  STOP
C-----------------------------------------------------------------------
 1005 FORMAT ('ERROR',I7,' FROM ZEXIST ON PASSWORD FILE')
 1010 FORMAT ('Quit Create Init Destroy (A4)')
 1020 FORMAT ('Type Vol Seq Ver User (A2, 4 of I)   Default user',I5)
 1022 FORMAT ('Number 256-word records (I)  Default=',I5)
 1050 FORMAT ('Filetype (A2)')
 1100 FORMAT ('Q# , first thru last jobnos (3 I)')
 1150 FORMAT ('Q# POPS# (2 I) 0''S => All')
 1200 FORMAT ('POPS# (I) 0''S => All')
 1230 FORMAT ('About to initialize ', I3, ' TV image catalogs...')
 1250 FORMAT ('TV #',I3,', which plane? (I) 0 => All, -1 => None,',
     *   ' -2 => Quit')
 1270 FORMAT ('Graphics device # (I) 0 => All, -1 => None')
 1300 FORMAT ('Vol (I) 0 => All')
 1302 FORMAT ('User number (I) default=',I4)
 1450 FORMAT ('TV number (I) 0 => all')
 1502 FORMAT ('User number (I) default=',I4)
 1550 FORMAT ('User number range (2 I) default= 0, ',I4)
 1900 FORMAT ('ERROR CODE = ',I7)
 1910 FORMAT ('OPEN ERROR',I7)
 1920 FORMAT ('READ ERROR',I7)
 1930 FORMAT ('WRITE ERROR',I7)
 1940 FORMAT ('ZEXIST ERROR',I7)
 1990 FORMAT ('ERROR',I7,' IN TERMINAL IO')
      END

      SUBROUTINE KEYIN (KEYS, VALUES, VALCHR, N, MRKEND, MODE, LUN,
     *   FIND, IERR)
C-----------------------------------------------------------------------
C! AIPS version of CIT parsing routine
C# Parsing
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1999, 2007, 2012, 2017
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Standard Fortran version of the CIT VLBI Keyin subroutines.
C   These subroutines read keyed parameters on cards images.
C   The text file should be opened via a call to ZTXOPN before the
C   first call to KEYIN and closed via a call to ZTXCLS after the last
C   call.  (HINT: use LUN = 10)
C   Note: in this version time like entries in the form hh:mm:ss
C   will be returned in hours.
C  Inputs:
C     KEYS(N)    C*8  Array of parameter names .
C                     Array names should have the last characters
C                     indicate the element number.  Should all be
C                     in upper case characters.
C     VALUES(N)  D    array to receive numeric values or defaults,
C                     each value corresponds to a KEY.
C     VALCHR(N)  C*8  array to receive character values or defaults,
C                     each value corresponds to a KEY.
C     N          I    number of parameters (dimension of keys, values)
C     MRKEND     C*?  special keyword to indicate end of input
C     MODE       I    1 = turn on reflection, 0 = turn off
C                     2 = interactive mode (prompts for input,
C                         no reflection, no limit on errors)
C                     3 = Pass values until ENDMRK, File should not
C                         contain keywords.
C                     4 = As for mode 3, but with reflection
C                     Note: currently only reads from a file.
C     LUN        I    LUN to read from (used in call to ZTXOPN)
C     FIND       I    FTAB pointer for input. (from ZTXOPN)
C  Outputs:
C     VALUES(N)  D    Values or input defaults.
C     N          I    (MODE=3 or 4 only) number of values found
C     IERR       I    error code, 0=>OK, 1=>EOF found, 2=>Error
C-----------------------------------------------------------------------
      CHARACTER VALCHR(*)*(*), KEYS(*)*(*), ENDMRK*16, LINE*2560,
     *   WORD*16, DELIM*1, MRKEND*(*), CWORD*16, CBLANK*16
      INTEGER   MODE, LUN, FIND, IERR, ERRCNT, N, NK, JERR, NCHAR, I,
     *   MAXREC, I1, NLETS, K, NW, ITEMP, IVALUE, I1T, NKT, JTRIM,
     *   NCOMP, LNGCNT
      LOGICAL   REFLEC, ACTIVE, EQUAL
      DOUBLE PRECISION    VALUES(*), XVALUE, ZVALUE
      CHARACTER TAB, CR
      CHARACTER ZSCHAR
      EXTERNAL  ZSCHAR
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA CBLANK /' '/
C-----------------------------------------------------------------------
      REFLEC = ((MODE.EQ.1).OR.(MODE.EQ.4))
      ACTIVE = .FALSE.
      ERRCNT = 0
      LNGCNT = 0
      IERR = 0
      NK = 1
      TAB = ZSCHAR ('tab')
      CR  = ZSCHAR ('cr')
      ENDMRK = MRKEND
      NCOMP = LEN(KEYS(1))
C                                       Read next record.
 100  CALL ZTXIO ('READ', LUN,  FIND,  LINE, JERR)
      IF (JERR.EQ.2) GO TO 340
      IF (JERR.NE.0) GO TO 999
C                                       Reflect line ?
         IF (REFLEC) THEN
            MSGTXT = LINE(:64)
            CALL MSGWRT (3)
            END IF
C                                       skip simple comment
         I = 1
         IF (LINE(I:I).EQ.'!') GO TO 100
C                                       'MAXREC' points to last
C                                       non-blank character in record)
         MAXREC = JTRIM (LINE)
 120     IF (ACTIVE) GO TO 270
C                                       Look for keyword;
 130     CALL CITSKP (LINE, MAXREC, I)
         IF (I.GT.MAXREC) GO TO 100
         IF (LINE(I:I).EQ.'!') GO TO 100
         I1 = I
         NLETS = 1
 140     I = I + 1
         IF (I.LE.MAXREC) THEN
            IF ((LINE(I:I).EQ.' ') .OR. (LINE(I:I).EQ.'=') .OR.
     *          (LINE(I:I).EQ.'(') .OR. (LINE(I:I).EQ.TAB) .OR.
     *          (LINE(I:I).EQ.CR)) GO TO 150
               NLETS = NLETS + 1
               GO TO 140
            END IF
C                                       Copy into WORD
 150     IF (NLETS.GT.16) THEN
            I = MIN (NLETS, 50) + I1 - 1
            WRITE (MSGTXT,1150) LINE(I1:I)
            IERR = NLETS
            LNGCNT = LNGCNT + 1
            GO TO 330
            END IF
         WORD = LINE(I1:I1+NLETS-1)
C                                       Convert to upper case.
         CALL CHLTOU (16, WORD)
C                                       Scan 'KEYS' for 'WORD';
C                                       error if not found
C                                       (check first that 'WORD'
C                                       is not 'ENDMRK'
C                                       or a special command-word)
         CALL CITCPR (WORD, ENDMRK, NCOMP, '?', EQUAL)
         IF (EQUAL) GO TO 340
C                                       Check for mode=3 or 4
         IF ((MODE.EQ.3).OR.(MODE.EQ.4)) I = I1
         IF ((MODE.EQ.3).OR.(MODE.EQ.4)) GO TO 200
         DO 160 K = 1,N
            IF ((MODE.NE.3).AND.(MODE.NE.4)) NK = K
            CWORD = KEYS(K)
            CALL CITCPR (WORD, CWORD, NCOMP, '?', EQUAL)
            IF (EQUAL) GO TO 170
 160        CONTINUE
C                                       Error: unknown parameter
         IERR = 4
         GO TO 330
C                                       Look for (subscript) to keyword
 170     IF (LINE(I:I).NE.'(') GO TO 190
            I = I + 1
            CALL CITC2I (LINE, MAXREC, I, IVALUE)
            NK = NK - 1 + IVALUE
C                                       subscript error?
            IERR = 1
            IF (LINE(I:I).NE.')') GO TO 330
            I = I+1
 180        IF (NK.LT.1) GO TO 330
C                                       too many values?
            IERR = 2
            IF (NK.GT.N) GO TO 330
            CWORD = KEYS(K)
            CALL CITCPR (WORD, CWORD, NCOMP, '?', EQUAL)
            IF (.NOT.EQUAL) GO TO 330
C                                       Look for value
C                                       after optional ' = '
 190     VALUES(NK) = 0.0
         CALL CITSKP (LINE, MAXREC, I)
         IF (I.GT.MAXREC) GO TO 100
         IF (LINE(I:I).NE.'=') GO TO 200
            I = I + 1
            CALL CITSKP (LINE, MAXREC, I)
C                                       missing value after ' = '?
            IERR = 5
            IF (I.GT.MAXREC) GO TO 330
C                                       Numerical value
 200     IF ((LINE(I:I).EQ.'''') .OR. (LINE(I:I).EQ.'"')) GO TO 210
         IF (LINE(I:I).EQ.'(') GO TO 205
            CALL CITC2R (LINE, MAXREC, I, XVALUE)
            VALUES(NK) = XVALUE
            GO TO 260
C                                       Arithmetic expression
 205        CALL CITEXP (LINE, MAXREC, I, ZVALUE, IERR)
            VALUES(NK) = ZVALUE
            IF (IERR.NE.0) GO TO 330
            GO TO 260
C                                       Textual value - 'NW' words
C                                       of 8 characters
C                                       Find number of blank keywords
 210     NW = 1
         VALCHR(NK) = '        '
 220     IF (NK+NW.GT.N) GO TO 230
         CWORD = KEYS(NK+NW)
         CALL CITCPR (CWORD, CBLANK, NCOMP, '?', EQUAL)
         IF (.NOT.EQUAL) GO TO 230
            VALCHR(NK+NW) = '        '
            NW = NW + 1
            GO TO 220
 230     DELIM = LINE(I:I)
         I1 = I + 1
         NLETS = 0
 240     I = I + 1
C                                       missing quote?
         IERR = 3
         IF (I.GT.MAXREC) GO TO 330
         IF (LINE(I:I).EQ.DELIM) GO TO 250
            NLETS = NLETS + 1
            GO TO 240
 250     ITEMP = 8 * NW
         NCHAR = MIN (ITEMP, NLETS)
         NKT = NK
         I1T = I1
C                                       Loop filling words
 255        ITEMP = MIN (8, NCHAR)
            VALCHR(NKT) = LINE(I1T:I1T+ITEMP-1)
            NCHAR = NCHAR - 8
            I1T = I1T + 8
            NKT = NKT + 1
            IF (NCHAR.GT.0) GO TO 255
         I = I + 1
         NK = NK + NW - 1
C                                       Look for another value,
C                                       if allowed
 260     IF ((MODE.EQ.3).OR.(MODE.EQ.4)) GO TO 280
         CALL CITSKP (LINE, MAXREC, I)
         IF (I.GT.MAXREC) GO TO 100
         IF (LINE(I:I).NE.',') GO TO 130
         I = I + 1
         ACTIVE = .TRUE.
         CALL CITSKP (LINE, MAXREC, I)
         IF (I.GT.MAXREC) GO TO 100
 270     ACTIVE = .FALSE.
         NK = NK + 1
         GO TO 180
 280     NK = NK + 1
         CALL CITSKP (LINE, MAXREC, I)
         IF (I.GT.MAXREC) GO TO 100
         GO TO 130
C-----------------------------------------------------------------------
C                                       Error report
 330  IF (IERR.EQ.1)  WRITE (MSGTXT,1331) WORD
      IF (IERR.EQ.2)  WRITE (MSGTXT,1332) WORD
      IF (IERR.EQ.3)  WRITE (MSGTXT,1333)
      IF (IERR.EQ.4)  WRITE (MSGTXT,1334) WORD
      IF (IERR.EQ.5)  WRITE (MSGTXT,1335) WORD
      IF (IERR.EQ.11) WRITE (MSGTXT,1336)
      IF (IERR.EQ.12) WRITE (MSGTXT,1337)
      IF (IERR.EQ.13) WRITE (MSGTXT,1338)
      IF (IERR.EQ.14) WRITE (MSGTXT,1339)
      IF ((IERR.GT.0) .AND. (IERR.LT.16)) ERRCNT = ERRCNT + 1
C                                       Report error
      IF (IERR.NE.0) CALL MSGWRT (8)
      IF (ERRCNT.LT.10) GO TO 100
C                                       Finished
 340  IERR = 0
      IF (JERR.EQ.2) IERR = 1
      IF (ERRCNT.GT.0) IERR = 2
      IF  ((MODE.EQ.3).OR.(MODE.EQ.4)) N = NK - 1
      IF (LNGCNT.GT.0) THEN
         WRITE (MSGTXT,1340) LNGCNT
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1150 FORMAT ('KEYIN: PARAMETER TOO LONG ''',A,'''')
 1331 FORMAT ('KEYIN: ERROR IN SUBSCRIPT OF ',A)
 1332 FORMAT ('KEYIN: ERROR, TOO MANY VALUES FOR ',A)
 1333 FORMAT ('KEYIN: ERROR, UNMATCHED QUOTE ')
 1334 FORMAT ('KEYIN: ERROR, UNKNOWN PARAMETER ',A)
 1335 FORMAT ('KEYIN: ERROR IN VALUE OF ',A)
 1336 FORMAT ('KEYIN: ERROR, TOO MANY PARENTHESES')
 1337 FORMAT ('KEYIN: ERROR, EXPECTING '')'' ')
 1338 FORMAT ('KEYIN: ERROR, VALUE EXPECTED AFTER OPERATOR')
 1339 FORMAT ('KEYIN: ERROR, ATTEMPT TO DIVIDE BY ZERO')
 1340 FORMAT ('KEYIN: IGNORED',I5,' INPUT LINES DUE TO LONG SYMBOLS')
      END

      SUBROUTINE FXHDEX (CATBLK)
C-----------------------------------------------------------------------
C! Corrects header format from 20 to 50 extension file types
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;  Eric W. Greisen
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FXHDEX checks the header to see if it is in the old format with a
C   maximum of 20 extension file types or the new (18-Mar-1997) format
C   with 50.  It changes old ones to new ones.
C   In/out::
C      CATBLK   I(256)   File header
C-----------------------------------------------------------------------
      INTEGER   CATBLK(256)
C
      INTEGER   J, I, K
      CHARACTER TEST*2
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      J = KHEXT + 20 - 1
C                                       check 3 types for legitimate
C                                       characters since DEC machines
C                                       can have some possible
C                                       ambiguities, but there will
C                                       never be two types with > 8000
C                                       versions
      DO 10 I = 1,3
         J = J + 1
C                                       old version # in range ?
         IF (CATBLK(J).GT.46656) GO TO 999
         IF (CATBLK(J).LT.0) GO TO 999
C                                       test characters
         CALL H2CHR (2, 1, CATBLK(J), TEST)
         IF (TEST.EQ.'  ') GO TO 10
         IF ((TEST(:1).GE.'A') .AND. (TEST(:1).LE.'Z') .AND.
     *      (TEST(2:).GE.'A') .AND. (TEST(2:).LE.'Z')) GO TO 10
C                                       old format
            CALL COPY (20, CATBLK(KHEXT+20), CATBLK(KIVER))
            K = KIEXTN - 20
            CALL FILL (K, 0, CATBLK(KIVER+20))
            CALL RFILL (K, HBLANK, CATBLK(KHEXT+20))
            GO TO 999
 10      CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'SERCH.INC'
C                                       Local include for SERCH
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PMAD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      CHARACTER NAMEIN*12, CLAIN*6, OUTFIL*48, FUNTYP*2, NAMOUT*12,
     *   CLAOUT*6
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMEO(3), XCLAOU(2), XFUNTP,
     *   XOUTFL(12)
      REAL      XSIN, XDISIN, XBLC(7), XTRC(7), XYINC, XZINC, BCHAN,
     *   ECHAN, CHINC, XCHSEL(3,10), PIXAVG, PIXSTD, XNBOXS, XBOX(2,20),
     *   REPORT, DOWGHT, DOOUT, XSEQO, XDISKO, DOHIST, XLABEL, XDOTV,
     *   XGRCH, XBAD(10)
      INTEGER   SEQIN, DISKIN, SLUN, SIND, BLC(7), TRC(7), YINC, ZINC,
     *   NCHSEL, CHSEL(3,10), CATOLD(256), SCRTCH(512), SELECT(MAXCHA),
     *   TXLUN, TXIND, IINC(7), NPARMS, CATNEW(256), SEQO, DISKO,
     *   CATSCR(256), OUTAX, SLOTO, LUNO, INDO, NBOXS, BOX(2,20)
      REAL      IBUFF(MABFSS), OBUFF(MABFSS), SIGMA(MAXCHA), CATNR(256),
     *   S2NMAX, S2NMIN, CATSR(256)
      DOUBLE PRECISION CATSD(128)
      LOGICAL   DOTV
      EQUIVALENCE (CATNEW, CATNR), (CATSCR, CATSD, CATSR)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XBLC, XTRC, XYINC,
     *   XZINC, BCHAN, ECHAN, CHINC, XCHSEL, PIXAVG, PIXSTD, XNBOXS,
     *   XBOX, REPORT, DOWGHT, DOOUT, XNAMEO, XCLAOU, XSEQO, XDISKO,
     *   DOHIST, XFUNTP, XLABEL, XOUTFL, XDOTV, XGRCH, XBAD
      COMMON /SERCOM/ CATSCR, CATOLD, CATNEW, SIGMA, SEQIN, DISKIN,
     *   SLUN, SIND, BLC, TRC, YINC, ZINC, NCHSEL, CHSEL, SELECT, TXLUN,
     *   TXIND, IINC, DOTV, NPARMS, SEQO, DISKO, OUTAX, SLOTO, LUNO,
     *   INDO, S2NMAX, S2NMIN, NBOXS, BOX
      COMMON /SERBUF/ IBUFF, OBUFF, SCRTCH
      COMMON /SERCHR / NAMEIN, CLAIN, NAMOUT, CLAOUT, OUTFIL, FUNTYP
LOCAL END
      PROGRAM SERCH
C-----------------------------------------------------------------------
C! searches transposed cube for line signals
C# UV Plot-appl Analysis Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1997-1998, 2002, 2007-2008, 2010, 2012, 2014-2015,
C;  Copyright (C) 2021-2022, 2024-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SERCH goes through a spectral-line cube looking for Gaussians above
C   the noise level.
C   Inputs:
C     INNAME         NAMEIN        Name of input UV data.
C     INCLASS        CLAIN         Class of input UV data.
C     INSEQ          SEQIN         Seq. of input UV data.
C     INDISK         DISKIN        Disk number of input UV data.
C     BLC            BLC           Bottom left corner of input
C     TRC            TRC           Top right corner of input
C     YINC           YINC          Pixel increment on Y axis
C                                  (usually right ascension)
C     ZINC           ZINC          Pixel increment on Z axis
C                                  (usually declination)
C     BCHAN          BCHAN         Lowest width in channels
C     ECHAN          ECHAN         Highest width in channels
C     CHINC          CHINC         Increment in widths
C     CHANSEL        CHNSEL(3,10)  Sets of begin, end increment channel
C                                  numbers for line search regions
C     PIXSTD         PIXSTD        Estimate of true noise rms
C     NBOXES         NBOXS         Number of spectral regions to be used
C                                  in fitting baseline 0 => no fit
C     BOX            BOX(2,20)     Pairs of begin-end channels for
C                                  spectral baseline regions
C     ICUT                         Report all "signals" with sig/noise
C                                  over ICUT.   0 => 8
C     BADDISK                      Disk to avoid for scratch
C   Based on algorithm by Juan Uson.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, IERR, IPL
      REAL      WIDTH
      LOGICAL   LAST
      INCLUDE 'SERCH.INC'
      DATA PRGM /'SERCH '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create scratch file
C                                       Subimage, baseline, rms's
      CALL SERCIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 995
C
      IPL = 0
      WIDTH = BCHAN - CHINC
 10   WIDTH = WIDTH + CHINC
      IF (WIDTH.LE.ECHAN) THEN
         LAST = WIDTH+CHINC.GT.ECHAN
         IPL = IPL + 1
         CALL SERCIT (WIDTH, IPL, LAST, IRET)
         IF (IRET.NE.0) GO TO 995
         GO TO 10
         END IF
C                                       close output with history
      IF (DOOUT.GT.0.0) CALL SERCHI (IERR)
C                                       Close down
 995  IF (TXLUN.NE.0) THEN
         TXLUN = ABS (TXLUN)
         CALL ZTXCLS (TXLUN, TXIND, IERR)
         END IF
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE SERCIN (PRGM, IRET)
C-----------------------------------------------------------------------
C   SERCIN gets input parameters for SERCH, creates scratch
C   Removes baseline and solves for rms's
C   Inputs:
C      PRGM   C*6   Program name
C   Output:
C      IRET   I     Error code: 0 => ok, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
C
      INCLUDE 'SERCH.INC'
      CHARACTER TYPE*2, PHNAME*48, STAT*4
      INTEGER   CNO, IERR, IUSER, I, L, J, IROUND, SIZE, IWIN(4),
     *   OWIN(4), NPT(MAXCHA), IDEPTH(5), IBLKOF, NBY, IPOS, OPOS, I1,
     *   I2, I3, I4, I5, I6, I7, NCHAN, LUNI, INDI, JTRIM
      REAL      SUM(MAXCHA), SUMS(MAXCHA), AVE(MAXCHA), CUT(MAXCHA)
C-----------------------------------------------------------------------
C                                       Init IO et al.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NBY = MABFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
C                                       Get input parameters.
      NPARMS = 136
      CALL GTPARM (PRGM, NPARMS, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.EQ.0) GO TO 10
         IRET = 8
         RQUICK = .TRUE.
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
C                                       Restart AIPS
 10   IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
C                                       open input image
      IUSER = 0
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMEO, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (2, 1, XFUNTP, FUNTYP)
      CALL H2CHR (48, 1, XOUTFL, OUTFIL)
      TYPE = 'MA'
      LUNI = 21
      DOTV = XDOTV.GT.0.0
      STAT = 'READ'
      IF ((DOHIST.GT.0.0) .AND. (.NOT.DOTV)) STAT = 'HDWR'
      CALL MAPOPN (STAT, DISKIN, NAMEIN, CLAIN, SEQIN, TYPE, IUSER,
     *   LUNI, INDI, CNO, CATBLK, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 999
      XSIN = SEQIN
      XDISIN = DISKIN
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
      NCFILE = NCFILE + 1
      FCNO(NCFILE) = CNO
      FVOL(NCFILE) = DISKIN
      FRW(NCFILE) = 0
      CALL COPY (256, CATBLK, CATOLD)
C                                       other inputs
      DO 15 I = 1,10
         IBAD(I) = IROUND (XBAD(I))
 15      CONTINUE
C                                       window
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), XBLC, XTRC, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (REPORT.LE.0.01) REPORT = 8
      CALL FILL (7, 1, IINC)
      YINC = 1
      ZINC = 1
      IF (XYINC.GE.0.5) YINC = IROUND (XYINC)
      IF (XZINC.GE.0.5) ZINC = IROUND (XZINC)
      IINC(2) = YINC
      IINC(3) = ZINC
      DO 20 I = 1,7
         BLC(I) = IROUND (XBLC(I))
         TRC(I) = IROUND (XTRC(I))
         CATBLK(KINAX+I-1) = (TRC(I) - BLC(I)) / IINC(I) + 1
         CATR(KRCRP+I-1) = (CATR(KRCRP+I-1) - BLC(I)) / IINC(I) + 1.
         CATR(KRCIC+I-1) = CATR(KRCIC+I-1) * IINC(I)
 20      CONTINUE
C                                      Figure out how big, make, open
      CALL MAPSIZ (CATBLK(KIDIM), CATBLK(KINAX), SIZE)
      CALL SCREAT (SIZE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL CATIO ('UPDT', SCRVOL(NSCR), SCRCNO(NSCR), CATBLK, 'REST',
     *   SCRTCH, IERR)
      CALL ZPHFIL ('SC', SCRVOL(NSCR), SCRCNO(NSCR), 1, PHNAME, IERR)
      SLUN = 16
      CALL ZOPEN (SLUN, SIND, SCRVOL(NSCR), PHNAME, .TRUE., .TRUE.,
     *   .TRUE., IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Windows, ...
      CALL COPY  (256, CATBLK, CATSCR)
      NCHAN = CATSCR(KINAX)
      IWIN(1) = BLC(1)
      IWIN(2) = BLC(2)
      IWIN(3) = TRC(1)
      IWIN(4) = TRC(2)
      OWIN(1) = 1
      OWIN(2) = 1
      OWIN(3) = CATSCR(KINAX)
      OWIN(4) = CATSCR(KINAX+1)
      NCHSEL = 0
      CALL FILL (MAXCHA, 0, SELECT)
      DO 30 I = 1,10
         CHSEL(1,I) = IROUND (XCHSEL(1,I))
         CHSEL(2,I) = IROUND (XCHSEL(2,I))
         CHSEL(3,I) = IROUND (XCHSEL(3,I))
         CHSEL(1,I) = MAX (1, CHSEL(1,I))
         CHSEL(2,I) = MIN (NCHAN, CHSEL(2,I))
         CHSEL(3,I) = MAX (1, CHSEL(3,I))
         IF (CHSEL(2,I).GE.CHSEL(1,I)) THEN
            IF (I.EQ.NCHSEL+1) NCHSEL = NCHSEL + 1
            DO 25 J = CHSEL(1,I),CHSEL(2,I),CHSEL(3,I)
               SELECT(J) = 1
 25            CONTINUE
            END IF
 30      CONTINUE
      IF (NCHSEL.LE.0) THEN
         NCHSEL = 1
         CHSEL(1,1) = 1
         CHSEL(2,1) = NCHAN
         CHSEL(3,1) = 1
         CALL FILL (NCHAN, 1, SELECT)
         END IF
      NBOXS = IROUND (XNBOXS)
      IF (NBOXS.GT.0) THEN
         DO 40 I = 1,NBOXS
            BOX(1,I) = MAX (1, IROUND (XBOX(1,I)))
            BOX(2,I) = MIN (NCHAN, IROUND (XBOX(2,I)))
 40         CONTINUE
         END IF
C                                       Zero summing arrays
      CALL FILL (NCHAN, 0, NPT)
      CALL RFILL (NCHAN, 0.0, SUM)
      CALL RFILL (NCHAN, 0.0, SUMS)
      CALL RFILL (NCHAN, PIXAVG, AVE)
      IF (PIXSTD.LE.0) PIXSTD = 1.E10
      PIXSTD = 4.0 * PIXSTD
      CALL RFILL (NCHAN, PIXSTD, CUT)
      MSGTXT = 'Finding channel rms''s and copying to scratch file'
      CALL MSGWRT (2)
C                                       read subimage to scratch file
      DO 90 I7 = BLC(7),TRC(7)
      DO 89 I6 = BLC(6),TRC(6)
      DO 88 I5 = BLC(5),TRC(5)
      DO 87 I4 = BLC(4),TRC(4)
      DO 86 I3 = BLC(3),TRC(3),ZINC
C                                       Set corner selection.
         IDEPTH(1) = I3
         IDEPTH(2) = I4
         IDEPTH(3) = I5
         IDEPTH(4) = I6
         IDEPTH(5) = I7
C                                       Block offset for source file.
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IDEPTH, IBLKOF,
     *      IRET)
         IBLKOF = IBLKOF + 1
C                                       Initialize for double buffering
         CALL MINIT ('READ', LUNI, INDI, CATOLD(KINAX), CATOLD(KINAX+1),
     *      IWIN, IBUFF, NBY, IBLKOF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'INIT READ', IRET
            GO TO 990
            END IF
C                                       Find block offset for subimage.
         IDEPTH(1) = (I3 - BLC(3)) / ZINC + 1
         IDEPTH(2) = I4 - BLC(4) + 1
         IDEPTH(3) = I5 - BLC(5) + 1
         IDEPTH(4) = I6 - BLC(6) + 1
         IDEPTH(5) = I7 - BLC(7) + 1
         CALL COMOFF (CATSCR(KIDIM), CATSCR(KINAX), IDEPTH, IBLKOF,
     *      IRET)
         IBLKOF = IBLKOF + 1
C                                       init write
         CALL MINIT ('WRIT', SLUN, SIND, CATSCR(KINAX), CATSCR(KINAX+1),
     *      OWIN, OBUFF, NBY, IBLKOF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'INIT WRITE', IRET
            GO TO 990
            END IF
C                                       Read row
         DO 80 I2 = BLC(2),TRC(2)
            CALL MDISK ('READ', LUNI, INDI, IBUFF, IPOS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1100) 'READ', IRET
               GO TO 990
               END IF
C                                       use only desired ones
            IF (MOD(I2-BLC(2),YINC).EQ.0) THEN
C                                       set output index
               CALL MDISK ('WRIT', SLUN, SIND, OBUFF, OPOS, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1100) 'WRITE', IRET
                  GO TO 990
                  END IF
C                                       move data to output
               CALL RCOPY (NCHAN, IBUFF(IPOS), OBUFF(OPOS))
C                                       fit baseline
               IF (NBOXS.GT.0) CALL SERCBL (NBOXS, BOX, NCHAN,
     *            OBUFF(OPOS))
C                                       sum into arrays
               DO 50 I1 = 1,NCHAN
                  J = I1 + OPOS - 1
                  IF (OBUFF(J).NE.FBLANK) THEN
                     IF (ABS(OBUFF(J)-AVE(I1)).LT.CUT(I1)) THEN
                        NPT(I1) = NPT(I1) + 1
                        SUM(I1) = SUM(I1) + OBUFF(J)
                        SUMS(I1) = SUMS(I1) + OBUFF(J) * OBUFF(J)
                        END IF
                     END IF
 50               CONTINUE
               END IF
 80         CONTINUE
C                                       finish write
         CALL MDISK ('FINI', SLUN, SIND, OBUFF, OPOS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'FINISH WRITE', IRET
            GO TO 990
            END IF
 86      CONTINUE
 87      CONTINUE
 88      CONTINUE
 89      CONTINUE
 90      CONTINUE
      CALL ZCLOSE (LUNI, INDI, IRET)
      L = 0
C                                       are we done?
 100  L = L + 1
      J = 0
      DO 110 I = 1,NCHAN
         IF (NPT(I).GT.1) THEN
            AVE(I) = SUM(I) / NPT(I)
            SIGMA(I) = (SUMS(I) - SUM(I)*SUM(I)/NPT(I)) / (NPT(I) - 1)
            IF (SIGMA(I).GT.0.0) THEN
               SIGMA(I) = SQRT (SIGMA(I))
               IF (ABS(CUT(I)/4.0/SIGMA(I)-1.0).GT.0.01) THEN
                  CUT(I) = 4.0 * SIGMA(I)
                  J = J + 1
                  END IF
            ELSE
               AVE(I) = 0.0
               CUT(I) = 1.E10
               SIGMA(I) = 0.0
               J = J + 1
               END IF
            END IF
 110     CONTINUE
C                                       NO - reread
      NBY = MABFSS * 2
      IF ((J.GT.NCHAN/16) .AND. (L.LE.10)) THEN
         CALL FILL (NCHAN, 0, NPT)
         CALL RFILL (NCHAN, 0.0, SUM)
         CALL RFILL (NCHAN, 0.0, SUMS)
         DO 150 I7 = 1,CATSCR(KINAX+6)
         DO 149 I6 = 1,CATSCR(KINAX+5)
         DO 148 I5 = 1,CATSCR(KINAX+4)
         DO 147 I4 = 1,CATSCR(KINAX+3)
         DO 146 I3 = 1,CATSCR(KINAX+2)
            IDEPTH(1) = I3
            IDEPTH(2) = I4
            IDEPTH(3) = I5
            IDEPTH(4) = I6
            IDEPTH(5) = I7
            CALL COMOFF (CATSCR(KIDIM), CATSCR(KINAX), IDEPTH, IBLKOF,
     *         IRET)
            IBLKOF = IBLKOF + 1
C                                       init read
            CALL MINIT ('READ', SLUN, SIND, CATSCR(KINAX),
     *         CATSCR(KINAX+1), OWIN, IBUFF, NBY, IBLKOF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1100) 'INIT SC READ', IRET
               GO TO 990
               END IF
C                                       Read row
            DO 130 I2 = 1,CATSCR(KINAX+1)
               CALL MDISK ('READ', SLUN, SIND, IBUFF, OPOS, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1100) 'READ SC', IRET
                  GO TO 990
                  END IF
C                                       sum into arrays
               DO 120 I1 = 1,NCHAN
                  J = I1 + OPOS - 1
                  IF (IBUFF(J).NE.FBLANK) THEN
                     IF (ABS(IBUFF(J)-AVE(I1)).LT.CUT(I1)) THEN
                        NPT(I1) = NPT(I1) + 1
                        SUM(I1) = SUM(I1) + IBUFF(J)
                        SUMS(I1) = SUMS(I1) + IBUFF(J) * IBUFF(J)
                        END IF
                     END IF
 120              CONTINUE
 130           CONTINUE
 146        CONTINUE
 147        CONTINUE
 148        CONTINUE
 149        CONTINUE
 150        CONTINUE
         GO TO 100
         END IF
C                                       finished more or less
      IF (J.LE.0) THEN
         WRITE (MSGTXT,1150) L
      ELSE
         WRITE (MSGTXT,1151) J, L
         END IF
      CALL MSGWRT (4)
C                                       Create an output file
      IF (DOOUT.GT.0.0) THEN
C                                       find new axis
         J = CATBLK(KIDIM)
         L = 3
         DO 160 I = 1,J
            IF (CATBLK(KINAX+I-1).GT.1) L = I
 160        CONTINUE
         OUTAX = L + 1
         IF (OUTAX.GT.KICTPN) THEN
            MSGTXT = 'ALL AXES > 1 POINT, CANNOT CREATE OUTPUT'
            CALL MSGWRT (8)
            IRET = 8
            GO TO 999
            END IF
         J = MIN (J, KICTPN-1)
C                                       move 1-pt axes up one
         CATBLK(KIDIM) = J + 1
         IF (L.LT.J) THEN
            I = J - L
            CALL COPY (I, CATSCR(KINAX+L), CATBLK(KINAX+L+1))
            CALL RCOPY (I, CATSR(KRCRP+L), CATR(KRCRP+L+1))
            CALL RCOPY (I, CATSR(KRCIC+L), CATR(KRCIC+L+1))
            CALL RCOPY (I, CATSR(KRCRT+L), CATR(KRCRT+L+1))
            CALL DPCOPY (I, CATSD(KDCRV+L), CATD(KDCRV+L+1))
            I = 2 * I
            CALL RCOPY (I, CATSR(KHCTP+2*L), CATR(KHCTP+2*L+2))
            END IF
C                                       insert line width
         CATBLK(KINAX+L) = (ECHAN - BCHAN) / CHINC + 1.001
         CATR(KRCRP+L) = 1.0
         CATR(KRCRT+L) = 0.0
         CATR(KRCIC+L) = CHINC
         CATD(KDCRV+L) = BCHAN
         CATR(KRDMX) = 0.0
         CATR(KRDMN) = 0.0
         CALL CHR2H (8, 'SIG2NOIS', 1, CATH(KHBUN))
         CALL CHR2H (8, 'LINWIDTH', 1, CATH(KHCTP+2*L))
         DISKO = IROUND (XDISKO)
         SEQO = IROUND (XSEQO)
         CALL MAKOUT (NAMEIN, CLAIN, SEQIN, ' ', NAMOUT, CLAOUT, SEQO)
         CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
         CATBLK(KIIMS) = SEQO
         CALL MCREAT (DISKO, SLOTO, SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1160) IRET
            GO TO 990
            END IF
         SEQO = CATBLK(KIIMS)
         TYPE = 'MA'
         IUSER = NLUSER
         LUNO = 17
         CALL MAPOPN ('INIT', DISKO, NAMOUT, CLAOUT, SEQO, TYPE, IUSER,
     *      LUNO, INDO, SLOTO, CATBLK, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 999
         S2NMAX = -1.E10
         S2NMIN = 1.E10
         NCFILE = NCFILE + 1
         FCNO(NCFILE) = SLOTO
         FVOL(NCFILE) = DISKO
         FRW(NCFILE) = 2
C                                       copy some keywords
         CALL KEYPCP (DISKIN, CNO, DISKO, SLOTO, 0, ' ', IERR)
         END IF
      CALL COPY (256, CATBLK, CATNEW)
C                                       Open output text file
      J = JTRIM (OUTFIL)
      IF (J.LE.0) THEN
         TXLUN = 0
      ELSE
         TXLUN = 10
         CALL ZTXOPN ('WRIT', TXLUN, TXIND, OUTFIL(1:J), .TRUE., IRET)
         IF (IRET.NE.0) THEN
            TXLUN = 0
            WRITE (MSGTXT,1165) IRET
            GO TO 990
            END IF
         MSGTXT = 'Channel      Sigma     offset'
         J = JTRIM (MSGTXT)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, MSGTXT(:J), IERR)
         IF (IERR.NE.0) THEN
            TXLUN = -TXLUN
            GO TO 999
            END IF
         DO 170 I = 1,NCHAN
            WRITE (MSGTXT,1170) I, SIGMA(I), AVE(I)
            J = JTRIM (MSGTXT)
            CALL ZTXIO ('WRIT', TXLUN, TXIND, MSGTXT(:J), IERR)
            IF (IERR.NE.0) THEN
               TXLUN = -TXLUN
               GO TO 999
               END IF
 170        CONTINUE
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR GETTING PARAMETERS FROM AIPS. ERR=',I5)
 1100 FORMAT ('SERCIN: DOING ',A,' ERROR',I4)
 1150 FORMAT ('All channel rms''s converged after',I3,' read passes')
 1151 FORMAT ('All but',I4,' rms''s converged after',I3,' read passes')
 1160 FORMAT ('ERROR',I5,' CREATING OUTPUT HYPER CUBE')
 1165 FORMAT ('ERROR ON OUTPUT TEXT FILE OPEN: ERR=',I5)
 1170 FORMAT (I7,2(1PE11.3))
      END
      SUBROUTINE SERCBL (NBOXS, BOX, NCHAN, ROW)
C-----------------------------------------------------------------------
C   fits and subtracts a linear baseline
C   Inputs:
C      NBOXS   I        Number of baseline regions
C      BOX     I(2,*)   Channel numbers
C      NCHAN   I        Total number of channels
C   In/out:
C      ROW     R(*)     Spectrum
C-----------------------------------------------------------------------
      INTEGER   NBOXS, BOX(2,*), NCHAN
      REAL      ROW(*)
C
      INTEGER   I, J, ND
      REAL      SX, SY, SXX, SXY, SYY, DELTA, A, B
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      SX = 0.0
      SY = 0.0
      SXX = 0.0
      SXY = 0.0
      SYY = 0.0
      ND = 0
      DO 20 J = 1,NBOXS
         DO 10 I = BOX(1,J),BOX(2,J)
            IF (ROW(I).NE.FBLANK) THEN
               SX = SX + I
               SY = SY + ROW(I)
               SXX = SXX + I * I
               SXY = SXY + I * ROW(I)
               SYY = SYY + ROW(I) * ROW(I)
               END IF
 10         CONTINUE
 20      CONTINUE
      DELTA = ND * SXX - SX * SX
      IF ((ND.GT.2) .AND. (DELTA.GT.0.0)) THEN
         A = (SXX * SY - SX * SXY) / DELTA
         B = (SXY * ND - SX * SY) / DELTA
         DO 30 I = 1,NCHAN
            IF (ROW(I).NE.FBLANK) ROW(I) = ROW(I) - A - B * I
 30         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE SERCIT (WIDTH, IPL, LAST, IRET)
C-----------------------------------------------------------------------
C   does the weighted or unweighted filtering plus histogram plotting
C   for a single filter width
C   Input:
C      WIDTH   R      Filter width in channels
C      IPL     I      Output plane
C      LAST    L      This is the last width to do
C   Output:
C      IRET    I      0 => continue, else quit.  > 0 -> error, <0 user
C                     request to quit.
C-----------------------------------------------------------------------
      REAL     WIDTH
      LOGICAL  LAST
      INTEGER  IPL, IRET
C
      INCLUDE 'SERCH.INC'
      INTEGER NHIST
      PARAMETER (NHIST=400)
      CHARACTER CTIME*8, CDATE*12
      INTEGER   I, I2, I3, I4, I5, I6, I7, IDEPTH(5), OWIN(4), IBLKOF,
     *   NBY, IPOS, NCHAN, NUMBER, II, JJ, HISTSN(NHIST+3), JTRIM, J, K,
     *   IERR, NGV, TIME(3), DATE(3), OPOS
      REAL     NORMS(MAXCHA), NORM, DOF, TOTSWT, Y, TEMP, SBW1, SBW2,
     *   AVESIG, AVES2, AINVS2, NOISE, SIGNAL, HSCALE, OUT, SIG, GAUSS,
     *   STON, GVS(MAXCHA), MAXSIG, GVSLIM
      DATA GVSLIM /1.0E-6/
      DATA OWIN /4*0/
C-----------------------------------------------------------------------
      IF (TXLUN.GT.0) THEN
         CALL ZDATE (DATE)
         CALL ZTIME (TIME)
         CALL TIMDAT (TIME, DATE, CTIME, CDATE)
         WRITE (MSGTXT,1000) TSKNAM, RLSNAM, CDATE, CTIME
         J = JTRIM (MSGTXT)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, MSGTXT(:J), IERR)
         IF (IERR.NE.0) TXLUN = -TXLUN
         END IF
      WRITE (MSGTXT,1001) WIDTH
      CALL MSGWRT (3)
      IF (TXLUN.GT.0) THEN
         J = JTRIM (MSGTXT)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, MSGTXT(:J), IERR)
         IF (IERR.NE.0) TXLUN = -TXLUN
         END IF
      CALL FILL (NHIST, 0, HISTSN)
      HSCALE = 20.0 / NHIST
      AVESIG = 0.0
      AVES2 = 0.0
      AINVS2 = 0.0
      NUMBER = 0
      MAXSIG = -1.
      TOTSWT = 0
      DOF = 0.0
C                                       Filter values
      NCHAN = CATSCR(KINAX)
      NGV = 0
      DO 10 I = 1,NCHAN
         CALL FILTER (I, WIDTH, GVS(I))
         IF (ABS(GVS(I)).GT.GVSLIM) NGV = I
 10      CONTINUE
C                                       normalization factors
      CALL RFILL (NCHAN, 0.0, NORMS)
      DO 20 K = 1,NCHAN
         IF (SELECT(K).GT.0) THEN
            NORM = 0.0
            DO 15 J = 1,NCHAN
               I = ABS (J-K) + 1
               IF ((SELECT(J).GT.0) .AND. (I.LE.NGV)) THEN
                  GAUSS = GVS(I) * GVS(I)
                  NORM = NORM + GAUSS
                  IF (DOWGHT.GT.0.0) THEN
                     NORMS(K) = NORMS(K) + GAUSS / SIGMA(J)**2
                  ELSE
                     NORMS(K) = NORMS(K) + GAUSS
                     END IF
                  END IF
 15            CONTINUE
            DOF = DOF + NORM
            TOTSWT = TOTSWT + 1
            IF (TXLUN.GT.0) THEN
               WRITE (MSGTXT,1015) K, NORM, NORMS(K)
               J = JTRIM (MSGTXT)
               CALL ZTXIO ('WRIT', TXLUN, TXIND, MSGTXT(:J), IERR)
               IF (IERR.NE.0) THEN
                  TXLUN = -TXLUN
                  GO TO 999
                  END IF
               END IF
            END IF
 20      CONTINUE
      IF ((CATNR(KRBMJ).GT.0.0) .AND. (CATNR(KRCIC+1).NE.0.0)) THEN
         SBW1 = CATNR(KRBMJ) / ABS (CATNR(KRCIC+1))
      ELSE
         SBW1 = 3.0
         END IF
      IF ((CATNR(KRBMN).GT.0.0) .AND. (CATNR(KRCIC+2).NE.0.0)) THEN
         SBW2 = CATNR(KRBMN) / ABS (CATNR(KRCIC+2))
      ELSE
         SBW2 = 3.0
         END IF
      DOF = TOTSWT * TOTSWT / DOF
      DOF = DOF * CATSCR(KINAX+1) * CATSCR(KINAX+2) / 0.5666 / SBW1 /
     *   SBW2
      WRITE (MSGTXT,1020) DOF
      CALL MSGWRT (3)
      IF (TXLUN.GT.0) THEN
         J = JTRIM (MSGTXT)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, MSGTXT(:J), IERR)
         IF (IERR.NE.0) TXLUN = -TXLUN
         END IF
      MSGTXT = 'Channel Xpix  Ypix     Signal      Noise'
     *   // '   Width     S/N'
      CALL MSGWRT (3)
      IF (TXLUN.GT.0) THEN
         J = JTRIM (MSGTXT)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, MSGTXT(:J), IERR)
         IF (IERR.NE.0) TXLUN = -TXLUN
         END IF
C                                       loop through cube
      NBY = MABFSS * 2
      DO 100 I7 = 1,CATSCR(KINAX+6)
      DO 99 I6 = 1,CATSCR(KINAX+5)
      DO 98 I5 = 1,CATSCR(KINAX+4)
      DO 97 I4 = 1,CATSCR(KINAX+3)
      DO 96 I3 = 1,CATSCR(KINAX+2)
         IDEPTH(1) = I3
         IDEPTH(2) = I4
         IDEPTH(3) = I5
         IDEPTH(4) = I6
         IDEPTH(5) = I7
         CALL COMOFF (CATSCR(KIDIM), CATSCR(KINAX), IDEPTH, IBLKOF,
     *      IRET)
         IBLKOF = IBLKOF + 1
C                                       init write
         CALL MINIT ('READ', SLUN, SIND, CATSCR(KINAX), CATSCR(KINAX+1),
     *      OWIN, IBUFF, NBY, IBLKOF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'INIT SC READ', IRET
            GO TO 990
            END IF
C                                       output file
         IF (DOOUT.GT.0.0) THEN
            IDEPTH(OUTAX-2) = IPL
            CALL COMOFF (CATNEW(KIDIM), CATNEW(KINAX), IDEPTH, IBLKOF,
     *         IRET)
            IBLKOF = IBLKOF + 1
C                                       init write
            CALL MINIT ('WRIT', LUNO, INDO, CATNEW(KINAX),
     *         CATNEW(KINAX+1), OWIN, OBUFF, NBY, IBLKOF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1100) 'INIT OUT WRITE', IRET
               GO TO 990
               END IF
            END IF
C                                       Read row
         DO 50 I2 = 1,CATSCR(KINAX+1)
            CALL MDISK ('READ', SLUN, SIND, IBUFF, IPOS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1100) 'READ SC', IRET
               GO TO 990
               END IF
            IF (DOOUT.GT.0.0) THEN
               CALL MDISK ('WRIT', LUNO, INDO, OBUFF, OPOS, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1100) 'WRIT OUT', IRET
                  GO TO 990
                  END IF
               CALL RFILL (NCHAN, 0.0, OBUFF(OPOS))
               END IF
C                                       filter
            DO 40 K = 1,NCHAN
               IF (SELECT(K).GT.0) THEN
                  OUT = 0.0
                  SIG = 0.0
                  DO 30 J = 1,NCHAN
                     I = ABS (J-K) + 1
                     IF ((SELECT(J).GT.0) .AND. (I.LE.NGV) .AND.
     *                  (IBUFF(IPOS+J-1).NE.FBLANK)) THEN
                        GAUSS = GVS(I)
                        IF (DOWGHT.GT.0.0) THEN
                           SIG = SIG + GAUSS * GAUSS / SIGMA(J) /
     *                        SIGMA(J)
                           OUT = OUT + GAUSS * IBUFF(IPOS+J-1) /
     *                        SIGMA(J) / SIGMA(J)
                        ELSE
                           SIG = SIG + GAUSS * GAUSS * SIGMA(J) *
     *                        SIGMA(J)
                           OUT = OUT + GAUSS * IBUFF(IPOS+J-1)
                           END IF
                        END IF
 30                  CONTINUE
                  IF ((NORMS(K).GT.0.0) .AND. (SIG.GT.0.0)) THEN
                     NOISE = SQRT (SIG) / NORMS(K)
                     SIGNAL = OUT / NORMS(K)
                     STON = SIGNAL / NOISE
                     IF (ABS(STON).GT.REPORT) THEN
                        IF (DOOUT.GT.0.0) THEN
                           OBUFF(OPOS+K-1) = STON
                           S2NMAX = MAX (STON, S2NMAX)
                           S2NMIN = MIN (STON, S2NMIN)
                           END IF
                        II = BLC(2) + (I2 - 1) * IINC(2)
                        JJ = BLC(3) + (I3 - 1) * IINC(3)
                        J = BLC(1) + K - 1
                        WRITE (MSGTXT,1030) J, II, JJ, SIGNAL, NOISE,
     *                     WIDTH, STON
                        CALL MSGWRT (5)
                        IF (TXLUN.GT.0) THEN
                           J = JTRIM (MSGTXT)
                           CALL ZTXIO ('WRIT', TXLUN, TXIND, MSGTXT(:J),
     *                        IERR)
                           IF (IERR.NE.0) TXLUN = -TXLUN
                           END IF
                        END IF
                     MAXSIG = MAX (MAXSIG, ABS(STON))
                     AVESIG = AVESIG + NOISE
                     AVES2 = AVES2 + NOISE * NOISE
                     AINVS2 = AINVS2 + 1.0 / NOISE / NOISE
                     NUMBER = NUMBER + 1
                     J = NHIST/2 + 1.5 + STON/HSCALE
                     J = MAX (1, MIN (NHIST+2, J))
                     HISTSN(J) = HISTSN(J) + 1
                     END IF
                  END IF
 40            CONTINUE
 50         CONTINUE
         IF (DOOUT.GT.0.0) THEN
            CALL MDISK ('FINI', LUNO, INDO, OBUFF, OPOS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1100) 'FINISH OUT', IRET
               GO TO 990
               END IF
            CATNR(KRDMX) = S2NMAX
            CATNR(KRDMN) = S2NMIN
            END IF
 96      CONTINUE
 97      CONTINUE
 98      CONTINUE
 99      CONTINUE
 100     CONTINUE
      IF (NUMBER.LE.0) THEN
         MSGTXT = 'NO POINTS FOUND'
         IRET = 9
         GO TO 990
         END IF
      AVESIG = AVESIG / NUMBER
      AVES2 = SQRT (AVES2 / NUMBER)
      AINVS2 = SQRT (NUMBER / AINVS2)
      WRITE (MSGTXT,1100) MAXSIG, NUMBER
      CALL MSGWRT (4)
      IF (TXLUN.GT.0) THEN
         J = JTRIM (MSGTXT)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, MSGTXT(:J), IERR)
         IF (IERR.NE.0) TXLUN = -TXLUN
         END IF
      WRITE (MSGTXT,1101) AVESIG, AVES2, AINVS2
      CALL MSGWRT (4)
      IF (TXLUN.GT.0) THEN
         J = JTRIM (MSGTXT)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, MSGTXT(:J), IERR)
         IF (IERR.NE.0) TXLUN = -TXLUN
         END IF
C                                       print histogram
      IF ((DOHIST.GE.0.0) .AND. (TXLUN.GT.0)) THEN
         DO 120 I = 1,NHIST+2
            IF (TXLUN.GT.0) THEN
               Y = HISTSN(I)
               TEMP = MAX (0.1, Y)
               Y = SQRT (Y)
               TEMP = ALOG10 (TEMP)
               WRITE (MSGTXT,1110) I, HISTSN(I), Y, TEMP
               J = JTRIM (MSGTXT)
               CALL ZTXIO ('WRIT', TXLUN, TXIND, MSGTXT(:J), IERR)
               IF (IERR.NE.0) TXLUN = -TXLUN
               END IF
 120        CONTINUE
         END IF
C                                       plot histogram
      IF (DOHIST.GT.0.0) THEN
         CALL COPY (256, CATOLD, CATBLK)
         CALL PLTHST (NHIST, HISTSN, WIDTH, LAST, IRET)
         CALL COPY (256, CATBLK, CATOLD)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',A12,2X,A8)
 1001 FORMAT ('**********  Starting width ',F8.3,' channels **********')
 1015 FORMAT ('Channel, norm norm**2',I6,2(1PE12.4))
 1020 FORMAT ('Degrees of freedom =',F12.2)
 1030 FORMAT (3I6,2(1PE11.3),2(0PF8.3))
 1100 FORMAT ('Max S/N',1PE11.3,' over',I14,' channels*pixels')
 1101 FORMAT ('Average noise',1PE11.3,' square',1PE11.3,' inverse',
     *   1PE11.3)
 1110 FORMAT ('Hist(',I3.3,')=',I12,'   sqrt',F8.2,'   log10',F8.2)
      END
      SUBROUTINE SERCHI (IRET)
C-----------------------------------------------------------------------
C   finishes output file header and copies a history
C   Output:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   HLUNI, HLUNO, I
      CHARACTER HILINE*72, NOTTYP*2
      INCLUDE 'SERCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA HLUNI, HLUNO /25, 26/
      DATA NOTTYP /'  '/
C-----------------------------------------------------------------------
      CALL HIINIT (3)
C                                       copy old
      CALL HISCOP (HLUNI, HLUNO, DISKIN, DISKO, FCNO(1), SLOTO, CATNEW,
     *   SCRTCH(257), SCRTCH, IRET)
      IF (IRET.GT.3) GO TO 100
      IF (IRET.EQ.3) GO TO 45
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, HLUNO, SCRTCH,
     *   IRET)
      IF (IRET.NE.0) GO TO 45
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQO, DISKO, HLUNO, SCRTCH,
     *   IRET)
      IF (IRET.NE.0) GO TO 45
C                                       corners
      WRITE (HILINE,1000) TSKNAM, BLC
      CALL HIADD (HLUNO, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 45
      WRITE (HILINE,1001) TSKNAM, TRC
      CALL HIADD (HLUNO, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 45
C                                       Yinc, Zinc
      IF ((YINC.GT.1) .OR. (ZINC.GT.1)) THEN
         WRITE (HILINE,1005) TSKNAM, YINC, ZINC
         CALL HIADD (HLUNO, HILINE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 45
         END IF
C                                       Chansel
      DO 10 I = 1,NCHSEL
         WRITE (HILINE,1010) TSKNAM, I, CHSEL(1,I), CHSEL(2,I),
     *      CHSEL(3,I)
         CALL HIADD (HLUNO, HILINE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 45
 10      CONTINUE
C                                       Nboxes, box
      IF (NBOXS.GT.0) THEN
         DO 20 I = 1,NBOXS
            WRITE (HILINE,1011) TSKNAM, I, BOX(1,I), BOX(2,I)
            CALL HIADD (HLUNO, HILINE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 45
 20         CONTINUE
         END IF
C                                       Icut
      WRITE (HILINE,1020) TSKNAM, REPORT
      CALL HIADD (HLUNO, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 45
C                                       Doweight
      IF (DOWGHT.GT.0.0) THEN
         WRITE (HILINE,1025) TSKNAM, 'T'
      ELSE
         WRITE (HILINE,1025) TSKNAM, 'F'
         END IF
      CALL HIADD (HLUNO, HILINE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 45
C
 45   CALL HICLOS (HLUNO, .TRUE., SCRTCH, IRET)
C                                        Copy tables
      CALL ALLTAB (1, NOTTYP, HLUNI, HLUNO, DISKIN, DISKO, FCNO(1),
     *   SLOTO, CATNEW, SCRTCH(257), SCRTCH, IRET)
      IF (IRET.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
C                                       close output file
 100  CALL MAPCLS ('INIT', DISKO, SLOTO, LUNO, INDO, CATNEW, .TRUE.,
     *   SCRTCH, IRET)
      NCFILE = NCFILE - 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A,'BLC=',6(I5,','),I5,' / bottom left corner')
 1001 FORMAT (A,'TRC=',6(I5,','),I5,' / top right corner')
 1005 FORMAT (A,'YINC=',I4,'  ZINC=',I4,
     *   ' / Y, Z pixel input increments')
 1010 FORMAT (A,'CHANSEL(*,',I2.2,')=',2(I5,','),I3,
     *   ' / channels searched for signal')
 1011 FORMAT (A,'BOX(*,',I2.2,')=',I5,',',I5,
     *   ' / channels used for baseline')
 1020 FORMAT (A,'ICUT =',1PE11.4,' / S/N recorded if greater than ICUT')
 1025 FORMAT (A,'DOWEIGHT = ',A,' / solutions weighted by channel rms?')
      END
      SUBROUTINE FILTER (I, S, GAUSS)
C-----------------------------------------------------------------------
C   returns filter function symmetric about 0
C   Input:
C      I       I   separation in cells + 1
C      S       R   width in cells
C   Output:
C      GAUSS   R   Value of Gaussian
C-----------------------------------------------------------------------
      INTEGER   I
      REAL      S, GAUSS
C-----------------------------------------------------------------------
      GAUSS = (I-1) / S
      GAUSS = GAUSS * GAUSS
      GAUSS = EXP ( 4.0 * ALOG(0.5) * GAUSS)
C
 999  RETURN
      END
      SUBROUTINE PLTHST (NHIST, HISTSN, WIDTH, LAST, IRET)
C-----------------------------------------------------------------------
C   Plots the histogram on the TV or a plot file
C   Inputs:
C      NHIST    I      Number values in histogram (1, NHIST+2 for
C                      overflows)
C      HISTSN   I(*)   Histogram
C      WIDTH    R      Filter width in channels (for labeling)
C      LAST     L      This is the last plot?
C   Output:
C      IRET     I      Return code: 0 nominal, < 0 please quit,
C                      > 0 error
C-----------------------------------------------------------------------
      INTEGER   NHIST, HISTSN(*), IRET
      REAL      WIDTH
      LOGICAL   LAST
C
      INCLUDE 'SERCH.INC'
      CHARACTER STAT*4, PFILE*48
      INTEGER   I, BMAX, PBLK(256), IVER, PLUN, PIND, GRCHN, TVCORN(2),
     *   LABEL, IROUND, LTYPE
      LOGICAL   DOLOG
      REAL      ARANGE(2)
      INCLUDE 'INCS:DGPH.INC'
      DATA TVCORN /2*0/
C-----------------------------------------------------------------------
      LABEL = IROUND (XLABEL)
      LTYPE = MOD (ABS(LABEL), 100)
      IF ((LTYPE.EQ.0) .OR. (LTYPE.GT.10)) LTYPE = 3
      IF (LTYPE.GT.7) LTYPE = 7
      IF ((LTYPE.GE.4) .AND. (LTYPE.LE.6)) LTYPE = 3
      IF (LABEL.GE.0) THEN
         LABEL = (LABEL/100)*100 + LTYPE
      ELSE
         LABEL = (LABEL/100)*100 - LTYPE
         END IF
      DOLOG = FUNTYP.EQ.'LG'
      ARANGE(1) = -10. - 20.0/(NHIST-1)
      ARANGE(2) =  10. + 20.0/(NHIST-1)
C
      IVER = 0
      IF (.NOT.DOTV) THEN
         STAT = 'WRIT'
         IF (LAST) STAT = 'READ'
         CALL MADDEX ('PL', FVOL(1), FCNO(1), CATBLK, PBLK, .TRUE.,
     *      STAT, IVER, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'CANNOT CREATE PLOT FILE - TURN OFF PLOT'
            GO TO 990
            END IF
         END IF
C
      GRCHN = XGRCH + 0.5
      CALL ZPHFIL ('PL', FVOL(1), FCNO(1), IVER, PFILE, IRET)
      CALL GINIT (FVOL(1), FCNO(1), PFILE, 0, 38, NPARMS, XNAMEI, DOTV,
     *   1, GRCHN, TVCORN, CATOLD, PBLK, PLUN, PIND, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       move zero
      I = NHIST/2 + 1
      HISTSN(NHIST+3) = HISTSN(I)
      HISTSN(I) = HISTSN(I-1) + HISTSN(I+1) - (HISTSN(I-2) +
     *   HISTSN(I+2)) / 2
C                                       Get max
      BMAX = -10
      DO 10 I = 1,NHIST
         BMAX = MAX (BMAX, HISTSN(I+1))
 10      CONTINUE
      CALL HISTOX (BMAX, NHIST, HISTSN, ARANGE, DOLOG, LABEL, WIDTH,
     *   IVER, PBLK, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'ERROR PLOTTING HISTOGRAM'
         CALL MSGWRT (7)
         END IF
      GPHPAG = .NOT.LAST
      CALL GFINIS (PBLK, IRET)
C                                       Successful plot file finished.
      IF (IRET.EQ.0) THEN
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (FVOL(1), FCNO(1), IVER, PBLK, IRET)
            WRITE (MSGTXT,1010) IVER
            CALL MSGWRT (5)
            IRET = 0
            END IF
         END IF
       GO TO 999
C
 990   DOHIST = 0.0
       CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('Successful plot file (histogram) version',I7)
      END
      SUBROUTINE HISTOX (BMAX, NBOXES, XNIB, RANGE, DOLOG, LABEL, WIDTH,
     *   IVER, PBLK, IRET)
C-----------------------------------------------------------------------
C   This routine will write commands to an open plot file for drawing
C   a histogram.  Flux on X axis, count on Y axis.
C   Inputs:
C      BMAX     I        the maximum value in any of the boxes.
C      XNIB     I(NBOXES+2)   The number of entries in each range.
C                        XNIB(1) is the underflow, XNIB(NBOXES+2) is
C                        the overflow. (NBOXES+3) = actual zero count
C      NBOXES   I        number of boxes or value ranges for histogram.
C      RANGE    R(2)     intensity range of histogram
C      DOLOG    L        T => use log(n) rather than linear scale
C      LABEL    I        Type of labeling
C      WIDTH    R        Smoothing width in channels
C      IVER     I        Plot file version number
C   In/out:
C      PBLK    I(256)   I/O buffer for open, initialized pl file.
C   Output:
C      IRET     I        error code. 0=ok, 1=write error to plot file.
C-----------------------------------------------------------------------
      REAL      RANGE(2), WIDTH
      INTEGER   BMAX, XNIB(*), NBOXES, LABEL, IVER, PBLK(256), IRET
      LOGICAL   DOLOG
C
      REAL      BLC(7), CH(4), TRC(7), X, Y, FAC, XYRATO, YMAX(2)
      INTEGER   IDEPTH(5), I, LTYPE
C-----------------------------------------------------------------------
C                                       Set character offsets.
      IF (DOLOG) THEN
         YMAX(2) = ALOG10 (BMAX+0.0001)
         YMAX(1) = ALOG10 (0.5)
      ELSE
         YMAX(2) = BMAX
         YMAX(1) = 0.0
         END IF
      CALL GTICNT (LTYPE, YMAX, I)
C                                       number characters around
      CALL RFILL (4, 0.5, CH)
      LTYPE = MOD (ABS (LABEL), 100)
      IF (LTYPE.EQ.2) CH(1) = 2.5
      IF (LTYPE.GT.2) CH(1) = I + 4.0
      IF (LTYPE.GT.1) CH(2) = 2.0
      IF (LTYPE.GT.2) CH(2) = CH(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CH(2) = CH(2) + 3 * 1.333
      IF (LTYPE.EQ.2) CH(3) = 2.5
      IF (LTYPE.GT.1) CH(4) = CH(4) + 1.5
      IF (LTYPE.GT.2) CH(4) = CH(4) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CH(4) = CH(4) + 1.333
      IF ((LABEL.GT.1) .AND. (LTYPE.LT.7)) CH(4) = CH(4) + 1.333
C                                       Set BLC, TRC, XYRATO.
      CALL RFILL (5, 1.0, BLC(3))
      CALL RFILL (5, 1.0, TRC(3))
      CALL FILL (5, 1, IDEPTH)
      BLC(2) = 0.0
      IF (DOLOG) BLC(2) = ALOG10 (0.5)
      BLC(1) = 0.0
      TRC(1) = NBOXES
      TRC(2) = YMAX(2) * 1.05
      XYRATO = (TRC(1) - BLC(1)) / (TRC(2) - BLC(2))
C                                       Kludge to keep XYRATO small
C                                       to prevent overflow in GINITL.
      FAC = 1.0
      DO 50 I = 1,10000
         IF (XYRATO.GT.0.50) GO TO 60
         FAC = FAC * 10.0
         XYRATO = XYRATO * 10.0
 50      CONTINUE
C
 60   TRC(2) = TRC(2) / FAC
      BLC(2) = BLC(2) / FAC
      XYRATO = 1.0 / XYRATO
C                                       Initialize plot file line drw.
      CALL GINITL (BLC, TRC, XYRATO, CH, IDEPTH, PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL GLTYPE (1, PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Draw borders.
      CALL GPOS (BLC(1), BLC(2), PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL GVEC (TRC(1), BLC(2), PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL GVEC (TRC(1), TRC(2), PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL GVEC (BLC(1), TRC(2), PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL GVEC (BLC(1), BLC(2), PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Labeling.
      I = NBOXES + 2
      CALL HLABX (BLC, TRC, FAC, NBOXES, RANGE, DOLOG, IVER, XNIB(1),
     *   XNIB(I), XNIB(I+1), WIDTH, LABEL, PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL GLTYPE (2, PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Position at first data point.
      X = BLC(1)
      Y = BLC(2)
      CALL GPOS (X, Y, PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Loop for rest of data points.
      DO 100 I = 1,NBOXES
         Y = XNIB(I+1)
         IF (DOLOG) THEN
            IF (XNIB(I+1).LE.0) THEN
               Y = ALOG10 (0.5)
            ELSE
               Y = ALOG10 (Y)
               END IF
            END IF
         Y = Y / FAC
         CALL GVEC (X, Y, PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
         X = I
         CALL GVEC (X, Y, PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
         Y = BLC(2)
         CALL GVEC (X, Y, PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE HLABX (BLC, TRC, FAC, NBOXES, RANGE, DOLOG, IVER,
     *   UNDER, OVER, ZERO, WIDTH, LABEL, PBLK, IRET)
C-----------------------------------------------------------------------
C   Write labeling for histogram.
C   Inputs:
C      BLC     R(2)     bottom left corner of plot.
C      TRC     R(2)     top right hand corner of plot.
C      FAC     R        FAC*XYRATO = real XYRATIO.
C      IVER    I        plot file version number
C      LABEL   I        labeling type
C      PBLK   I(256)   I/O buffer for plot file.
C   Output:
C      IRET    I        error code returned from GVEC.
C-----------------------------------------------------------------------
      REAL      BLC(7), TRC(7), FAC, RANGE(2), WIDTH
      INTEGER   NBOXES, IVER, UNDER, OVER, ZERO, LABEL, PBLK(256), IRET
      LOGICAL   DOLOG
C
      CHARACTER PREFIX*5, TIME*8, DATE*12, CTEMP*12, CSTOK(12)*4,
     *   NAMSTR*18, MSGBUF*80
      LOGICAL   PFLAG
      REAL      XINTER(21), DCX, DCY, DIST, ODIST, XDIST, XMAX,
     *   TICSCL, YTICEL, YTICER, XVAL, YPOS, TICLEN, XINT, X, FREQ,
     *   DCXM, DEG, DBLC, DTRC, DU, DL
      INTEGER   INOINT, INCHAR, I, IXO, M, ITRY, NXRA, NXDEC, NXLL,
     *   NXMM, NXFR, NXST, NAX, INC, IANGL, JSTOK, IT(3), ID(3),
     *   ICPNT, ITMP, LTYPE, XNOINT
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA TICSCL /70.0/
      DATA CSTOK /'????','Beam','Ipol','Qpol','Upol','Vpol','Ppol',
     *   'Fpol','Pang','Spix','Optd','    '/
      DATA XINTER /.1, .2, .5, 1., 2., 5., 10., 20., 50., 100., 200.,
     *   500., 1000., 2000., 5000., 10000., 20000., 50000., 100000.,
     *   200000., 500000./
C-----------------------------------------------------------------------
      LTYPE = MOD (ABS(LABEL), 100)
      IF (LTYPE.LE.1) GO TO 999
C                                       Tic positions.
      TICLEN = (TRC(1) - BLC(1)) / TICSCL
      YTICEL = BLC(1) + TICLEN
      YTICER = TRC(1) - TICLEN
C                                       Find interval value.
      DBLC = FAC * BLC(2)
      DTRC = FAC * TRC(2)
      DIST = FAC * (TRC(2) - BLC(2))
      XINT = 8.0
      DO 20 I = 1,21
         DEG = XINTER(I)
         DU = AINT (DTRC/DEG) * DEG
         IF (DU.GT.DTRC) DU = DU - DEG
         DL = AINT (DBLC/DEG) * DEG
         IF (DL.LT.DBLC) DL = DL + DEG
         XNOINT = (DU-DL) / DEG + 1.001
         IF (XNOINT.LE.XINT) GO TO 30
 20      CONTINUE
      GO TO 110
C                                       Interval and no of inter found.
 30   XINT = DEG
      INOINT = XNOINT + 2
      XVAL = AINT (FAC*BLC(2)/XINT) * XINT
      IF (XVAL.GE.FAC*BLC(2)) XVAL = XVAL - XINT
      IXO = I
      DCXM = -0.5
C                                       Loop for all tics.
      DO 100 I = 1,INOINT
         XVAL = XVAL + XINT
         YPOS = XVAL / FAC
         IF (YPOS.GT.TRC(2)) GO TO 110
C                                       TOP tic.
         CALL GPOS (TRC(1), YPOS, PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL GVEC (YTICER, YPOS, PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Left hand tic.
         CALL GPOS (YTICEL, YPOS, PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL GVEC (BLC(1), YPOS, PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Write value.
         IF (LTYPE.GT.2) THEN
            WRITE (MSGBUF,1030) XVAL
            CALL CHTRIM (MSGBUF, 14, MSGBUF, INCHAR)
            IF (IXO.GT.3) INCHAR = INCHAR - 2
            DCX = - INCHAR - 1.0
            DCY = -0.5
            DCXM = MIN (DCXM, DCX)
            CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, PBLK, IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
 100     CONTINUE
C                                       Number of pixels
 110  DCX = DCXM - 2.0
      YPOS = (TRC(2) + BLC(2)) / 2.0
      CALL GPOS (BLC(1), YPOS, PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (DOLOG) THEN
         MSGBUF = 'Log10 (number of pixels)'
         INCHAR = 24
      ELSE
         MSGBUF = 'Number of pixels'
         INCHAR = 16
         END IF
      DCY = INCHAR / 2.0 - 1.0
      CALL GCHAR (INCHAR, 1, DCX, DCY, MSGBUF, PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
C                                        Write bucket numbers on top
      IF (NBOXES.LE.8) THEN
         M = 1
      ELSE IF (NBOXES.LE.16) THEN
         M = 2
      ELSE IF (NBOXES.LE.40) THEN
         M = 5
      ELSE IF (NBOXES.LE.80) THEN
         M = 10
      ELSE IF (NBOXES.LE.160) THEN
         M = 20
      ELSE IF (NBOXES.LE.400) THEN
         M = 50
      ELSE IF (NBOXES.LE.800) THEN
         M = 100
      ELSE IF (NBOXES.LE.1600) THEN
         M = 200
      END IF
      TICLEN = (TRC(2) - BLC(2)) / TICSCL
      YTICEL = BLC(2) + TICLEN
      YTICER = TRC(2) - TICLEN
      DCY = 0.5
      DO 150 I = 0,NBOXES,M
         X = I - .5
         CALL GPOS (X, YTICER, PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL GVEC (X, TRC(2), PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
         IF (LTYPE.GT.2) THEN
            WRITE (MSGBUF,1115) I
            CALL CHTRIM (MSGBUF, 4, MSGBUF, INCHAR)
            DCX = 0.5 - REAL(INCHAR)
            CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, PBLK, IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
 150     CONTINUE
C                                       Label RHS bucket #
      X = (TRC(1) + BLC(1)) / 2.0
      CALL GPOS (X, TRC(2), PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
      DCX = -5.0
      DCY = 0.5
      IF (LTYPE.GT.2) DCY = 1.833
      MSGBUF = 'Box number'
      CALL GCHAR (10, 0, DCX, DCY, MSGBUF, PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Range =
      CTEMP = 'Signal/Noise'
      IF (LTYPE.LT.7) THEN
         CALL GPOS (BLC(1), BLC(2), PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
         DCX = 0.0
         DCY = -2.833
         IF (LTYPE.GT.2) DCY = DCY - 1.333
         WRITE (MSGBUF,1151) RANGE(1), RANGE(2), CTEMP
         CALL REFRMT (MSGBUF, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Interval =
         CALL GPOS (BLC(1), BLC(2), PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
         X = (RANGE(2) - RANGE(1)) / NBOXES
         WRITE (MSGBUF,1152) X, CTEMP, WIDTH
         DCY = DCY - 1.333
         CALL REFRMT (MSGBUF, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, PBLK, IRET)
C                                       Underflow = overflow =
         CALL GPOS (BLC(1), BLC(2), PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
         IF ((UNDER.NE.0) .OR. (OVER.NE.0)) THEN
            WRITE (MSGBUF,1154) UNDER, OVER, ZERO
         ELSE
            WRITE (MSGBUF,1155) ZERO
            END IF
         CALL REFRMT (MSGBUF, '_', INCHAR)
         DCY = DCY - 1.333
         CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, PBLK, IRET)
         END IF
C                                       Determine label range
      DIST = RANGE(2) - RANGE(1)
      ODIST = DIST
      CALL METSCL (LABEL, DIST, PREFIX, PFLAG)
      IF (PFLAG) GO TO 190
      XDIST = DIST / ODIST
      ODIST = XDIST * RANGE(1)
      DTRC = XDIST * RANGE(2)
      DBLC = XDIST * RANGE(1)
C                                       Get interval
      DO 160 ITRY = 1,21
         DEG = XINTER(I)
         DU = AINT (DTRC/DEG) * DEG
         IF (DU.GT.DTRC) DU = DU - DEG
         DL = AINT (DBLC/DEG) * DEG
         IF (DL.LT.DBLC) DL = DL + DEG
         XNOINT = (DU-DL) / DEG + 1.001
         IF (XNOINT.LE.9.0) GO TO 170
 160     CONTINUE
      GO TO 190
C                                       Bottom (value) tics
 170  XINT = DEG
      DCY = -1.5
      XMAX = MAX (ABS(RANGE(2)), ABS(RANGE(1))) * XDIST
      INOINT = XNOINT + 2
      XVAL = AINT (ODIST/XINT) * XINT
      IF (XVAL.GE.ODIST) XVAL = XVAL - XINT
      DO 175 I = 1,INOINT
         XVAL = XVAL + XINT
         X = ((XVAL-ODIST)/DIST) * NBOXES
         IF (X.GT.TRC(1)) GO TO 180
         CALL GPOS (X, YTICEL, PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL GVEC (X, BLC(2), PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
         IF (LTYPE.GT.2) THEN
            WRITE (MSGBUF,1030) XVAL
            CALL CHTRIM (MSGBUF, 14, MSGBUF, INCHAR)
            IF (ITRY.GT.3) INCHAR = INCHAR - 2
            DCX = 0.5 - INCHAR
            CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, PBLK, IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
 175     CONTINUE
C                                       Label with prefix
 180  DCY = -1.5
      IF (LTYPE.GT.2) DCY = -2.833
      X = (TRC(1) + BLC(1)) / 2.0
      CALL GPOS (X, BLC(2), PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
      WRITE (MSGBUF,1175) PREFIX, CTEMP
      CALL CHTRIM (MSGBUF, 18, MSGBUF, INCHAR)
      DCX = 0.5 - INCHAR / 2.0
      CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (LTYPE.GE.7) GO TO 999
C                                       which axis is which?
 190  NXRA = 0
      NXDEC = 0
      NXLL = 0
      NXMM = 0
      NXFR = 0
      NXST = 0
      NAX = CATBLK(KIDIM)
      INC = 2
      DO 200 I = 1,NAX
         ICPNT = KHCTP+(I-1)*INC
         CALL H2CHR (8, 1, CATH(ICPNT), CTEMP)
         IF (CTEMP(1:4).EQ.'FREQ') NXFR  = I
         IF (CTEMP(1:4).EQ.'STOK') NXST  = I
 200     CONTINUE
C                                       Source name, stokes, freq.
      CALL GPOS (BLC(1), TRC(2), PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
      DCX = 0.0
      DCY = 1.833
      IF (LTYPE.GT.2) DCY = DCY + 1.333
      IANGL = 0
      CALL H2CHR (8, 1, CATH(KHOBJ), CTEMP)
      FREQ = 0.0
      JSTOK = 12
      IF (NXFR.GT.2) FREQ = CATD(KDCRV+NXFR-1) + CATR(KRCIC+NXFR-1)
     *   * (BLC(NXFR) - CATR(KRCRP+NXFR-1))
      FREQ = FREQ / 1.E6
      IF (NXST.GT.2) JSTOK = CATD(KDCRV+NXST-1) + CATR(KRCIC+NXST-1)
     *   * (BLC(NXST) - CATR(KRCRP+NXST-1)) + 2.5
      IF (NXFR.GT.2) THEN
         WRITE (MSGBUF,1200) CTEMP, CSTOK(JSTOK), FREQ
      ELSE
         WRITE (MSGBUF,1200) CTEMP, CSTOK(JSTOK)
         END IF
      CALL REFRMT (MSGBUF, '_', INCHAR)
C                                       image name
      INCHAR = INCHAR + 1
      IF (INCHAR.GT.1) THEN
         MSGBUF(INCHAR:INCHAR+2) = '   '
         INCHAR = INCHAR + 3
         END IF
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), NAMSTR(1:12))
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), NAMSTR(13:18))
      CALL NAMEST (NAMSTR, CATBLK(KIIMS), MSGBUF(INCHAR:), ITMP)
      CALL REFRMT (MSGBUF, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, PBLK, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       time/date, version
      IF (LABEL.GT.0) THEN
         CALL GPOS (BLC(1), TRC(2), PBLK, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, TIME, DATE)
         WRITE (MSGBUF,1210) IVER, DATE, TIME
         CALL REFRMT (MSGBUF, '_', INCHAR)
         DCY = DCY + 1.333
         CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, PBLK, IRET)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (F14.1)
 1115 FORMAT (I4)
 1151 FORMAT ('Range =',F6.1,' to',F5.1,1X,A)
 1152 FORMAT ('Interval =',F7.4,1X,A,3X,'Width',F5.1,' channels')
 1154 FORMAT ('Underflow=',I10,' _Overflow=',I10,' _Zero=',I10)
 1155 FORMAT ('Count at zero =',I12)
 1175 FORMAT (A5,1X,A)
 1200 FORMAT (A8,' _',A4,'_ ',F10.3,' MHz')
 1210 FORMAT ('Plot file version',I4,'__created ',A,A)
      END

      SUBROUTINE PROPOE (DT, SEMIMA, ECCEN, INCLIN, RAANOD, APERIG,
     *                   MANMLY, RANODT, APERIT, MANMLT)
C-----------------------------------------------------------------------
C! Propagate orbital elements in time.
C# Util Orbits
C-----------------------------------------------------------------------
C;  Copyright (C) 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Propagate the right ascension of the ascending node, the argument
C   of perigee, and the mean anomaly of an Earth orbit through DT days
C   allowing for precession due to the oblateness of the Earth.
C
C   Inputs:
C      SEMIMA    D      Semimajor axis of orbit (m)
C      ECCEN     D      Orbital eccentricity
C      INCLIN    D      Inclination of orbit (radians)
C      RAANOD    D      Right ascension of ascending node (radians)
C      APERIG    D      Argument of perigee (radians)
C      MANMLY    D      Mean anomaly (radians)
C
C   Outputs:
C      RANODT    D      Right ascension of ascending node after time
C                       DT (radians)
C      APERIT    D      Argument of perigee after time DT (radians)
C      MANMLT    D      Mean anomaly after time DT (radians)
C
C   References:
C     "Orbital Motion", A.E. Roy, Institute of Physics Press, 1988
C     (Section 10.4.2)
C-----------------------------------------------------------------------
      DOUBLE PRECISION DT, SEMIMA, ECCEN, INCLIN, RAANOD, APERIG,
     *                 MANMLY, RANODT, APERIT, MANMLT
C
C     Local variables:
C
C     DTSEC     Time difference in seconds
C     N0        Unperturbed mean motion (radians s**-1)
C     NBAR      Perturbed mean motion
C
      DOUBLE PRECISION P, DTSEC, N0, NBAR
C
      INCLUDE 'INCS:PEARTH.INC'
C-----------------------------------------------------------------------
      DTSEC = 24.0D0 * 3600.0D0 * DT
      P = SEMIMA * (1.0D0 - ECCEN ** 2)
      N0 = SQRT (EMU / SEMIMA ** 3)
      NBAR = N0 * (1.0D0 + 1.5D0 * (EJ2 * ERAD ** 2 / P ** 2)
     *       * (1.0D0 - 1.5D0 * (SIN (INCLIN)) ** 2)
     *       * SQRT (1.0D0 - ECCEN ** 2))
C
      RANODT = RAANOD - 1.5D0 * (EJ2 * ERAD ** 2 / P ** 2) * NBAR
     *         * COS (INCLIN) * DTSEC
      APERIT = APERIG + 1.5D0 * (EJ2 * ERAD ** 2 / P ** 2) * NBAR
     *         * (2.0D0 - 2.5D0 * (SIN (INCLIN)) ** 2) * DTSEC
      MANMLT = MANMLY + NBAR * DTSEC
C
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QVTRAN (M, N, IAD, LV)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Inplace transpose of a matrix of vectors.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Vectorizing compiler version
C   VTRANS transposes a (row-stored) M X N array of row vectors
C   of length LV.  The starting address is given by IAD.  The
C   algorithm works in place.  It is adapted from Boothroyd's
C   CACM ALG.#302.  Other, probably better, algorithms, are
C   CACM #'S 380 and 467, but they're not as simple to program.
C   Inputs:
C      M   I  First dimension of the vector array
C      N   I  Second dimension of the vector array
C      IAD I  Base address of the array
C      LV  I  Length of the vectors.
C-----------------------------------------------------------------------
      INTEGER   I, IAD, IADI, IADJ, IDN, IL1, J, K, LV, M, MDMN, MNM1,
     *   N, JN, J4, DLV, LOOP, KK
      REAL      TEMP
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                       Setup
      DLV = LV
      MNM1 = M * N - 1
      MDMN = MNM1 - N
      IDN = MNM1 - 1
      IF ((LV.LE.0) .OR. (IDN.LT.2)) GO TO 999
      K = 0
      IL1 = 1
C                                       Loop
C@DIR IGNORE RECRDEPS(APCORE)
      DO 80 I = 2,IDN
         KK = K + N
         IF (K.GT.MDMN) KK = K - MDMN
         K = KK
 40      J = K
 50      IF (J.GE.IL1) GO TO 60
C                                       J = MOD (J*N, MNM1)
            J = J * N - (J * N / MNM1) * MNM1
            GO TO 50
 60      IF (J.EQ.IL1) GO TO 75
            J = J + 1
            IADI = IAD + (I-1) * DLV
            IADJ = IAD + (J-1) * DLV
C                                       Swap rows
C@DIR IGNORE RECRDEPS(APCORE)
            DO 70 LOOP = 1,LV
               TEMP = APCORE(IADI+LOOP)
               APCORE(IADI+LOOP) = APCORE(IADJ+LOOP)
               APCORE(IADJ+LOOP) = TEMP
 70            CONTINUE
 75      IL1 = I
 80      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ANFIND (ARRAY, STN, BVAL, TYPE)
C-----------------------------------------------------------------------
C! Recognizes the array or station name, checks By for handedness
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2009-2016, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to recognize the handedness of the Bx-By-Bz antenna system
C   from a list of known array and station names,
C   Inputs:
C      ARRAY   C*8    Array name
C      STN     C*8    Station name
C      BVAL    D(3)   Bx,By,Bz coordinate of station/array center
C   Output:
C      TYPE    I      1 - don't know, 2 - left, 3 - right
C-----------------------------------------------------------------------
      CHARACTER ARRAY*(*), STN*(*)
      INTEGER   TYPE
      DOUBLE PRECISION BVAL(3)
C
      INTEGER   NXPYMP, NXMYMP, NXPYPP, NXMYPP, NXPYMM, NXMYMM, NXPYPM,
     *   NXMYPM
      PARAMETER (NXPYMP=24)
      PARAMETER (NXMYMP=27)
      PARAMETER (NXPYPP=13)
      PARAMETER (NXMYPP=1)
      PARAMETER (NXPYMM=1)
      PARAMETER (NXMYMM=1)
      PARAMETER (NXPYPM=1)
      PARAMETER (NXMYPM=9)
C
      INTEGER   I
      CHARACTER XPYMZP(NXPYMP)*8, XMYMZP(NXMYMP)*8,  XPYPZP(NXPYPP)*8,
     *   XMYPZP(NXMYPP)*8, XPYMZM(NXPYMM)*8, XMYMZM(NXMYMM)*8,
     *   XPYPZM(NXPYPM)*8, XMYPZM(NXMYPM)*8, LSTN*8
      INCLUDE 'INCS:DMSG.INC'
      DATA XPYMZP /'SC','GB','HN','AR','RO','YS','JB','DEF','KNO','DAR',
     *   'MK2','TAB','VLBA_SC','VLBA_HN','PV','PICOVEL','SC-VLBA',
     *   'HN-VLBA','Lo','Mk2','Kn','De','Pi','Da'/
      DATA XMYMZP /'BR','FD','KP','LA','NL','OV','PT','Y','MK','GO',
     *   'VLBA_BR','VLBA_FD','VLBA_KP','VLBA_LA','VLBA_NL','VLBA_OV',
     *   'VLBA_PT','VLBA_MK','BR-VLBA','FD-VLBA','KP-VLBA','LA-VLBA',
     *   'NL-VLBA','OV-VLBA','PT-VLBA','MK-VLBA','DSS13'/
      DATA XPYPZP /'EB','EF','NT','WB','UR','MC','ON','CAM','EFLSBERG',
     *   'ONSALA60','PDBURE','CRIMEA','Cm'/
      DATA XMYPZP /'SH'/
      DATA XPYMZM /'  '/
      DATA XMYMZM /'  '/
      DATA XPYPZM /'HH'/
      DATA XMYPZM /'AT','PA','PKS','TI','HOB','CD','CED','MOP','CAT'/
C-----------------------------------------------------------------------
      TYPE = 1
      I = LEN (STN)
      I = MIN (I, 8)
      LSTN = STN(:I)
C                                       VLA/EVLA simple case
      IF ((ARRAY.EQ.'VLA') .OR. (ARRAY.EQ.'EVLA')) THEN
         IF (BVAL(2).LT.0.0D0) THEN
            TYPE = 3
         ELSE
            TYPE = 2
            END IF
         IF ((BVAL(1).GT.0.0D0) .OR. (BVAL(3).LT.0.0D0)) THEN
            GO TO 900
         ELSE
            GO TO 999
            END IF
C                                       ALMA
      ELSE IF (ARRAY.EQ.'ALMA') THEN
         IF (BVAL(2).LT.0.0D0) THEN
            TYPE = 3
         ELSE
            TYPE = 2
            END IF
         IF ((BVAL(1).LT.0.0D0) .OR. (BVAL(3).GT.0.0D0)) THEN
            GO TO 900
         ELSE
            GO TO 999
            END IF
C                                       ATCA
      ELSE IF ((ARRAY.EQ.'ATCA') .OR. (ARRAY.EQ.'ASKAP')) THEN
         IF (BVAL(2).GT.0.0D0) THEN
            TYPE = 3
         ELSE IF (BVAL(2).LT.0.0D0) THEN
            TYPE = 2
            END IF
         IF ((BVAL(1).GT.0.0D0) .OR. (BVAL(3).GT.0.0D0)) THEN
            GO TO 900
         ELSE
            GO TO 999
            END IF
C                                       MeerKAT
      ELSE IF (ARRAY.EQ.'MeerKAT') THEN
         IF (BVAL(2).GT.0.0D0) THEN
            TYPE = 3
         ELSE IF (BVAL(2).LT.0.0D0) THEN
            TYPE = 2
            END IF
         IF ((BVAL(1).LT.0.0D0) .OR. (BVAL(3).GT.0.0D0)) THEN
            GO TO 900
         ELSE
            GO TO 999
            END IF
C                                       GMRT also has array center
      ELSE IF (ARRAY.EQ.'GMRT') THEN
         IF (BVAL(2).GT.0.0D0) THEN
            TYPE = 3
         ELSE
            TYPE = 2
            END IF
         IF ((BVAL(1).LT.0.0D0) .OR. (BVAL(3).LT.0.0D0)) THEN
            GO TO 900
         ELSE
            GO TO 999
            END IF
C                                       MWA (-32T or other)
      ELSE IF (ARRAY(:3).EQ.'MWA') THEN
         IF (BVAL(2).GT.0.0D0) THEN
            TYPE = 3
         ELSE
            TYPE = 2
            END IF
         IF ((BVAL(1).GT.0.0D0) .OR. (BVAL(3).GT.0.0D0)) THEN
            GO TO 900
         ELSE
            GO TO 999
            END IF
C                                       MWA (-32T or other)
      ELSE IF (ARRAY(:4).EQ.'WSRT') THEN
         IF (BVAL(2).GT.0.0D0) THEN
            TYPE = 3
         ELSE
            TYPE = 2
            END IF
         IF ((BVAL(1).LT.0.0D0) .OR. (BVAL(3).LT.0.0D0)) THEN
            GO TO 900
         ELSE
            GO TO 999
            END IF
      ELSE IF (ARRAY.EQ.'SAO SMA') THEN
         IF (BVAL(2).LT.0.0D0) THEN
            TYPE = 3
         ELSE
            TYPE = 2
            END IF
         IF ((BVAL(1).GT.0.0D0) .OR. (BVAL(3).LT.0.0D0)) THEN
            GO TO 900
         ELSE
            GO TO 999
            END IF
C                                       Nobeyama Radioheliograph
      ELSE IF (ARRAY(:4).EQ.'NORH') THEN
         IF (BVAL(2).GT.0.0D0) THEN
            TYPE = 3
         ELSE
            TYPE = 2
            END IF
         IF ((BVAL(1).GT.0.0D0) .OR. (BVAL(3).LT.0.0D0)) THEN
            GO TO 900
         ELSE
            GO TO 999
            END IF
C                                       LOFAR
      ELSE IF (ARRAY.EQ.'LOFAR') THEN
         IF (BVAL(2).GT.0.0D0) THEN
            TYPE = 3
            IF (STN(:2).EQ.'UK') TYPE = 2
         ELSE
            TYPE = 2
            IF (STN(:2).EQ.'UK') TYPE = 3
            END IF
         IF ((BVAL(1).LT.0.0D0) .OR. (BVAL(3).LT.0.0D0)) THEN
            GO TO 900
         ELSE
            GO TO 999
            END IF
C                                       array name only
      ELSE IF (LSTN.EQ.' ') THEN
C                                       look mainly for station
      ELSE
         IF ((BVAL(1).EQ.0.0D0) .AND. (BVAL(2).EQ.0.0D0) .AND.
     *      (BVAL(3).EQ.0.0D0)) GO TO 900
         DO 110 I = 1,NXPYMP
            IF (LSTN.EQ.XPYMZP(I)) THEN
               IF (BVAL(2).LT.0.0D0) THEN
                  TYPE = 3
               ELSE IF (BVAL(2).GT.0.0D0) THEN
                  TYPE = 2
                  END IF
               IF ((BVAL(1).LT.0.0D0) .OR. (BVAL(3).LT.0.0D0)) THEN
                  GO TO 900
               ELSE
                  GO TO 999
                  END IF
               END IF
 110        CONTINUE
         DO 120 I = 1,NXMYMP
            IF (LSTN.EQ.XMYMZP(I)) THEN
               IF (BVAL(2).LT.0.0D0) THEN
                  TYPE = 3
               ELSE IF (BVAL(2).GT.0.0D0) THEN
                  TYPE = 2
                  END IF
               IF ((BVAL(1).GT.0.0D0) .OR. (BVAL(3).LT.0.0D0)) THEN
                  GO TO 900
               ELSE
                  GO TO 999
                  END IF
               END IF
 120        CONTINUE
         DO 130 I = 1,NXPYPP
            IF (LSTN.EQ.XPYPZP(I)) THEN
               IF (BVAL(2).GT.0.0D0) THEN
                  TYPE = 3
               ELSE IF (BVAL(2).LT.0.0D0) THEN
                  TYPE = 2
                  END IF
               IF ((BVAL(1).LT.0.0D0) .OR. (BVAL(3).LT.0.0D0)) THEN
                  GO TO 900
               ELSE
                  GO TO 999
                  END IF
               END IF
 130        CONTINUE
         DO 140 I = 1,NXMYPP
            IF (LSTN.EQ.XMYPZP(I)) THEN
               IF (BVAL(2).GT.0.0D0) THEN
                  TYPE = 3
               ELSE IF (BVAL(2).LT.0.0D0) THEN
                  TYPE = 2
                  END IF
               IF ((BVAL(1).GT.0.0D0) .OR. (BVAL(3).LT.0.0D0)) THEN
                  GO TO 900
               ELSE
                  GO TO 999
                  END IF
               END IF
 140        CONTINUE
         DO 150 I = 1,NXPYMM
            IF (LSTN.EQ.XPYMZM(I)) THEN
               IF (BVAL(2).LT.0.0D0) THEN
                  TYPE = 3
               ELSE IF (BVAL(2).GT.0.0D0) THEN
                  TYPE = 2
                  END IF
               IF ((BVAL(1).LT.0.0D0) .OR. (BVAL(3).GT.0.0D0)) THEN
                  GO TO 900
               ELSE
                  GO TO 999
                  END IF
               END IF
 150        CONTINUE
         DO 160 I = 1,NXMYMM
            IF (LSTN.EQ.XMYMZM(I)) THEN
               IF (BVAL(2).LT.0.0D0) THEN
                  TYPE = 3
               ELSE IF (BVAL(2).GT.0.0D0) THEN
                  TYPE = 2
                  END IF
               IF ((BVAL(1).GT.0.0D0) .OR. (BVAL(3).GT.0.0D0)) THEN
                  GO TO 900
               ELSE
                  GO TO 999
                  END IF
               END IF
 160        CONTINUE
         DO 170 I = 1,NXPYPM
            IF (LSTN.EQ.XPYPZM(I)) THEN
               IF (BVAL(2).GT.0.0D0) THEN
                  TYPE = 3
               ELSE IF (BVAL(2).LT.0.0D0) THEN
                  TYPE = 2
                  END IF
               IF ((BVAL(1).LT.0.0D0) .OR. (BVAL(3).GT.0.0D0)) THEN
                  GO TO 900
               ELSE
                  GO TO 999
                  END IF
               END IF
 170        CONTINUE
         DO 180 I = 1,NXMYPM
            IF (LSTN.EQ.XMYPZM(I)) THEN
               IF (BVAL(2).GT.0.0D0) THEN
                  TYPE = 3
               ELSE IF (BVAL(2).LT.0.0D0) THEN
                  TYPE = 2
                  END IF
               IF ((BVAL(1).GT.0.0D0) .OR. (BVAL(3).GT.0.0D0)) THEN
                  GO TO 900
               ELSE
                  GO TO 999
                  END IF
               END IF
 180        CONTINUE
         END IF
      GO TO 999
C
 900  WRITE (MSGTXT,1000) ARRAY, STN, BVAL
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ANFIND: ODD ',A8,1X,A8,3(1PE10.3))
      END

      SUBROUTINE YGRAFE (OP, BLOTCH, STATUS, VRTRTC, IERR)
C-----------------------------------------------------------------------
C! controls the graphics control register (IIS function)
C# Y3 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YGRAFE reads/writes the TV graphics control register.  This
C   version does not support all the TV options: it forces the
C   black & white status monitor on and refuses to allow the disable
C   video, graphics, and cursor options.
C   Inputs:
C      OP      C*4   'READ' from TV or 'WRIT' to TV
C      VRTRTC  L     T => do it only during vertical retrace
C   In/Out:
C      BLOTCH  I     graphics plane used as blotch (1 - 7)
C      STATUS  I     graphics plane used as status (1 - 7)
C   Output:
C      IERR    I     error code of Z...XF : 0 => ok
C                                           2 => input error
C   NO TV VERSION - this is an IIS M70/M75 level 3 function
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   BLOTCH, STATUS, IERR
      LOGICAL   VRTRTC
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'THERE IS NO TV CONFIGURED WITH GRAPHICS CONTROL REGS'
      CALL MSGWRT (8)
C
 999  RETURN
      END

      SUBROUTINE MAKNAM (INAME, INCLAS, SEQ, VOL, TYPE, USER, NAMSTR)
C-----------------------------------------------------------------------
C! Constructs WAWA namestring (Now use H2WAWA or A2WAWA)
C# IO-wawa Obselete
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   This routine will construct a WaWa IO name string, given the
C   values that make up the thing.
C   NOTE: Now call H2WAWA or A2WAWA directly instead of MAKNAM.
C   Inputs:
C      INAME   C*12    file name
C      INCLAS  C*6     file class
C      SEQ     R       file sequence number.
C      VOL     R       file disk volume.
C      TYPE    C*2     file type.
C      USER    R       file user number.
C   Output:
C      NAMSTR  C*36    "Name string" in the tradition of WaWa IO.
C-----------------------------------------------------------------------
      CHARACTER INAME*12, INCLAS*6, TYPE*2, NAMSTR*36
      REAL      SEQ, VOL, USER
      INTEGER   ISEQ, IVOL, IUSER
C-----------------------------------------------------------------------
      ISEQ = SEQ + 0.5
      IVOL = VOL + 0.5
      IUSER = USER + 0.5
      CALL A2WAWA (INAME, INCLAS, ISEQ, TYPE, IVOL, IUSER, NAMSTR)
C
 999  RETURN
      END

      SUBROUTINE CQMAKE (IDISK, JCNO, CATUV, JBUF1, JBUF2, JLUN1, JLUN2,
     *   IRET)
C-----------------------------------------------------------------------
C! Create a CQ table using FQ, MC and catalog header information.
C# EXT-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2007, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Inputs:
C      IDISK    I        Disk volume number
C      JCNO     I        Catalog slot number of uv file
C      CATUV    I(256)   Catalog header block
C      JBUF1    I(512)   I/O buffer 1
C      JBUF2    I(512)   I/O buffer 2
C      JLUN1    I        LUN 1 to use for table I/O
C      JLUN2    I        LUN 2 to use for table I/O
C   Output:
C      IRET     I        Return code; 0=> ok
C   Output to common:
C      Uses DCAT.INC and DUVH.INC
C-----------------------------------------------------------------------
      INTEGER   IDISK, JCNO, CATUV(256), JLUN1, JLUN2, JBUF1(512),
     *   JBUF2(512), IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCQV.INC'
      INTEGER   MAXKEY, MAXKY2
      PARAMETER (MAXKEY = 50, MAXKY2 = 2 * MAXKEY)
      LOGICAL   WEXIT
      CHARACTER LTYPE*2, KEYSTR(MAXKEY)*8, LTAPER*8, LTAPCQ(MAXIF)*8
      DOUBLE PRECISION DFOFF(MAXIF), DFRQCQ(MAXIF), DCBWCQ(MAXIF)
      REAL      FINC(MAXIF), BANDW(MAXIF), TAVGCQ(MAXIF)
      INTEGER   NOIFCQ, IFQRNO, FQKOLS(MAXFQC), FQNUMV(MAXFQC), NUMIF,
     *   ICQRNO, CQKOLS(MAXCQC), CQNUMV(MAXCQC), IFQID, JIF, IROW,
     *   IFQDCQ, ISUBCQ, NFFTCQ(MAXIF), NCHCQ(MAXIF), NSAVCQ(MAXIF),
     *   NOVSCQ(MAXIF), NZPDCQ(MAXIF), IFLTCQ(MAXIF), NBITCQ(MAXIF),
     *   IOVLCQ(MAXIF), IFSIDE(MAXIF), IKLOC(MAXKEY), KEYVAL(MAXKY2),
     *   KEYTYP(MAXKEY), NSUBA, IVER, NKEY, NCOL, NREC, DATP(128,2),
     *   IERR, MSGSAV, I, IPOINT, NFFT, NOVS, NZPD, NCHAN
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Copy CATUV to CATBLK and
C                                       determine header pointers
      CALL COPY (256, CATUV, CATBLK)
      CALL UVPGET (IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         IRET = 1
         GO TO 990
         END IF
C                                       Get no. of AN tables (subarrays)
      CALL FNDEXT ('AN', CATBLK, NSUBA)
C                                       Get keywords from the MC table
      LTYPE = 'MC'
      IVER = 1
      MSGSAV = MSGSUP
      MSGSUP = 32000
C                                       Initialization
      NFFT = -1
      NOVS = -1
      NZPD = -1
      LTAPER = ' '
C
      CALL TABINI ('READ', LTYPE, IDISK, JCNO, IVER, CATBLK, JLUN1,
     *   NKEY, NREC, NCOL, DATP, JBUF1, IERR)
C                                       Extract keywords
      IF (IERR.LE.0) THEN
         NKEY = MAXKEY
         CALL TABKEY ('ALL ', KEYSTR, NKEY, JBUF1, IKLOC, KEYVAL,
     *      KEYTYP, IERR)
         IF (IERR.EQ.0) THEN
            DO 50 I = 1, NKEY
               IPOINT = IKLOC(I)
               IF (IPOINT.LE.0) GO TO 50
               IF (KEYSTR(I).EQ.'FFT_SIZE') NFFT = KEYVAL(IPOINT)
               IF (KEYSTR(I).EQ.'OVERSAMP') NOVS = KEYVAL(IPOINT)
               IF (KEYSTR(I).EQ.'ZERO_PAD') NZPD = KEYVAL(IPOINT)
               IF (KEYSTR(I).EQ.'TAPER_FN')
     *            CALL H2CHR (8, 1, KEYVAL(IPOINT), LTAPER)
50             CONTINUE
            END IF
C                                       Close MC table
         CALL TABIO ('CLOS', 0, 0, JBUF1, JBUF1, IERR)
         END IF
      MSGSUP = MSGSAV
C                                       Get NCHAN from catalog hdr.
      IF (JLOCF.GT.0) THEN
         NCHAN = CATBLK(KINAX+JLOCF)
      ELSE
         NCHAN = 1
         END IF
C                                       Get NO_IF from catalog hdr.
      IF (JLOCIF.GT.0) THEN
         NOIFCQ = CATBLK(KINAX+JLOCIF)
      ELSE
         NOIFCQ = 1
         END IF
C                                       Can a CQ table be created ?
      WEXIT = ((NSUBA.LE.0).OR.(NFFT.LT.0).OR.(NOVS.LT.0).OR.
     *   (NZPD.LT.0).OR.(LTAPER.EQ.' '))
C                                       Exit if not possible
      IF (WEXIT) THEN
         WRITE (MSGTXT,1070)
         IRET = 2
         GO TO 990
         END IF
C                                       Open FQ table for READ
      IVER = 1
      CALL FQINI ('READ', JBUF1, IDISK, JCNO, IVER, CATBLK, JLUN1,
     *   IFQRNO, FQKOLS, FQNUMV, NUMIF, IERR)
      IF (IERR.NE.0) THEN
         CALL TABERR ('READ', 'FQINI', 'CQMAKE', IERR)
         IRET = 3
         GO TO 999
         END IF
C                                       Delete pre-existing CQ table
      CALL RMEXT (IDISK, JCNO, 'CQ', 1, CATBLK, JBUF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1080) IERR
         IRET = 4
         GO TO 990
         END IF
C                                       Open CQ table for WRIT
      IVER = 1
      CALL CQINI ('WRIT', JBUF2, IDISK, JCNO, IVER, CATBLK, JLUN2,
     *   ICQRNO, CQKOLS, CQNUMV, NOIFCQ, IERR)
      IF (IERR.NE.0) THEN
         CALL TABERR ('WRIT', 'CQINI', 'CQMAKE', IERR)
         IRET = 5
         GO TO 999
         END IF
C                                       Get no. records in FQ table
      NREC = JBUF1(5)
C                                       While NOT EOF(FQ_table) do
      DO 250 IROW = 1,NREC
         IFQRNO = IROW
         CALL TABFQ ('READ', JBUF1, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *      IFQID, DFOFF, FINC, BANDW, IFSIDE, LTAPCQ, IERR)
         IF (IERR.NE.0) THEN
            CALL TABERR ('READ', 'TABFQ', 'CQMAKE', IERR)
            IRET = 6
            GO TO 999
            END IF
C                                       Loop over all subarrays
         DO 200 I = 1,NSUBA
C                                       Fill CQ record
            IFQDCQ = IFQID
            ISUBCQ = I
            DO 150 JIF = 1,NOIFCQ
               NFFTCQ(JIF) = NFFT
               NCHCQ(JIF) = NCHAN
               IF (NCHAN.GT.0) THEN
                  NSAVCQ(JIF) = NFFT / (2.0 * NCHAN)
               ELSE
                  NSAVCQ(JIF) = -1
                  END IF
               DFRQCQ(JIF) = FREQ + DFOFF(JIF)
               DCBWCQ(JIF) = FINC(JIF)
               LTAPCQ(JIF) = LTAPER
               NOVSCQ(JIF) = NOVS
               NZPDCQ(JIF) = NZPD
               IFLTCQ(JIF) = -1
               TAVGCQ(JIF) = 0.0
               NBITCQ(JIF) = 0
               IOVLCQ(JIF) = 0
150            CONTINUE
C                                       Write CQ record
            CALL TABCQ ('WRIT', JBUF2, ICQRNO, CQKOLS, CQNUMV, NOIFCQ,
     *         IFQDCQ, ISUBCQ, NFFTCQ, NCHCQ, NSAVCQ, DFRQCQ, DCBWCQ,
     *         LTAPCQ, NOVSCQ, NZPDCQ, IFLTCQ, TAVGCQ, NBITCQ, IOVLCQ,
     *         IERR)
            IF (IERR.NE.0) THEN
               CALL TABERR ('WRIT', 'TABCQ', 'CQMAKE', IERR)
               IRET = 7
               GO TO 999
               END IF
200         CONTINUE
250      CONTINUE
C                                       Hard close FQ, CQ tables
      CALL TABIO ('CLOS', 0, IFQRNO, JBUF1, JBUF1, IRET)
      CALL TABIO ('CLOS', 0, ICQRNO, JBUF2, JBUF2, IRET)
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Exit
999   RETURN
C----------------------------------------------------------------------
1000  FORMAT ('CQMAKE: ERROR',I4,' FROM UVPGET')
1070  FORMAT ('CQMAKE: NOT ENOUGH INFORMATION TO CREATE CQ TABLE')
1080  FORMAT ('CQMAKE: ERROR',I4,' DELETING OLD CQ TABLE')
      END

      SUBROUTINE YCUCOR (RPOS, QUAD, CORN, IERR)
C-----------------------------------------------------------------------
C! correct cursor position for scroll; return image coordinates, header
C# Y0 TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2008
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   YCUCOR takes a cursor position (corrected for zoom, but not scroll)
C   corrects it for scroll, determines the quadrant of the TV, and gets
C   the corresponding image header in common /MAPHDR/ and returns the
C   image coordinates.
C   NOTE WELL: RPOS ON INPUT MUST BE CORRECTED FOR ZOOM AND NOT SCROLL.
C   To get this from a raw TV position call YCURSE with OPCODE 'FXIT'
C   (or, of course, 'READ') and quadrant set to -1.    *************
C   Inputs:
C      RPOS    R(2)    X,Y screen pos before  zoom & scroll
C   Output:
C      QUAD    I       TV quadrant to use for scrolls
C                      Out: if in=-1, no scroll, else find quadrant
C                           (needs real TV pos)
C      CORN    R(7)    Image coordinates (pixels)
C      IERR    I       error code of Z...XF : 0 - ok
C                                             2 - input error
C   Generic version
C-----------------------------------------------------------------------
      REAL      RPOS(2), CORN(7)
      INTEGER   IERR, QUAD
C
      REAL      SRX, SRY, SRS(2), TMAG, TEMP
      INTEGER   MAG, ISX, ISY, IX, IY, IP, ZAND, J, I, NSCR, ISCRX,
     *   ISCRY, IXC, IYC
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (SRS(1), SRX),    (SRS(2), SRY)
C-----------------------------------------------------------------------
C                                       uncorrect zoom
      MAG = 1 + TVZOOM(1)
      IF (MXZOOM.GT.0) MAG = 2 ** TVZOOM(1)
      TMAG = MAG
      SRX = MOD (RPOS(1) - 1.0 + 10.0*MAXXTV(1), REAL(MAXXTV(1))) + 1.0
      SRY = MOD (RPOS(2) - 1.0 + 10.0*MAXXTV(2), REAL(MAXXTV(2))) + 1.0
      IXC = (TVZOOM(2) - 1.0) * (TMAG - 1.0) / TMAG + 1.
      ISX = TMAG * (SRX - IXC) + 1.001
      IYC = (MAXXTV(2) - TVZOOM(3)) * (TMAG - 1.) / TMAG
      TEMP = MAXXTV(2) - IYC - MAXXTV(2) / TMAG + 1.0
      ISY = TMAG * (SRY - TEMP) + 1.001
      ISX = ISX + (MAG-1)/2
      ISY = ISY + (MAG-1)/2
      IX = ISX
      IY = ISY
C                                        What quadr. scroll
      ISCRX = 0
      ISCRY = 0
      QUAD = 4
      IF ((IX.GE.TVSPLT(1)) .AND. (IY.GE.TVSPLT(2))) QUAD = 1
      IF ((IX.LT.TVSPLT(1)) .AND. (IY.GE.TVSPLT(2))) QUAD = 2
      IF ((IX.LT.TVSPLT(1)) .AND. (IY.LT.TVSPLT(2))) QUAD = 3
      NSCR = NGRAY + NGRAPH
      DO 30 I = 1,NSCR
         J = 2 ** (I-1)
         IF (ZAND(J,TVLIMG(QUAD)).NE.0) THEN
            IF (I.LE.NGRAY) THEN
               ISCRX = TVSCRX(I)
               ISCRY = TVSCRY(I)
            ELSE
               ISCRX = TVSCGX
               ISCRY = TVSCGY
               END IF
            GO TO 50
            END IF
 30      CONTINUE
C                                        correct for zoom
 50   IX = IX - (MAG-1)/2
      IY = IY - (MAG-1)/2
      IXC = (TVZOOM(2) - 1.0) * (TMAG - 1.0) / TMAG + 1.
      SRX = (IX - 1.0) / TMAG + IXC
      IYC = (MAXXTV(2) - TVZOOM(3)) * (TMAG - 1.) / TMAG
      TEMP = MAXXTV(2) - IYC - MAXXTV(2) / TMAG + 1.0
      SRY = (IY - 1.0) / TMAG + TEMP
C                                       correct for scroll
 70   SRX = MOD (SRX - 1.0 - ISCRX + 10.0*MAXXTV(1),
     *   REAL(MAXXTV(1))) +  1.0
      SRY = MOD (SRY - 1.0 - ISCRY + 10.0*MAXXTV(2),
     *   REAL(MAXXTV(2)))  +  1.0
C
      IX = SRX + 0.5
      IY = SRY + 0.5
      DO 80 IP = 1,NSCR
         J = 2 ** (IP-1)
         IF (ZAND(TVLIMG(QUAD), J).EQ.0) GO TO 80
            CALL YCREAD (IP, IX, IY, CATBLK, IERR)
            IF (IERR.EQ.0) GO TO 90
            IF (IERR.GT.1) GO TO 999
 80      CONTINUE
      IERR = 1
      CALL RFILL (7, 0.0, CORN)
      GO TO 999
C                                       found it ok
 90   CALL IMA2MP (SRS, CORN)
      DO 95 J = 3,7
         CORN(J) = CATBLK(IIDEP+J-3)
 95      CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'CALIB.INC'
C                                                          Include CALIB
C                                       Local include for CALIB
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXPRM, XBFSZ, MPOLIF
C                                       MAXPRM = maximum no. parms in
C                                       Least squares solutions
      PARAMETER (MAXPRM = MAXANT * 2)
C                                       XBFSZ = buffer size
      PARAMETER (XBFSZ = UVBFSL)
C                                       MPOLIF = Max NPOL*MAXIF
      PARAMETER (MPOLIF = MAXIF*2)
      INTEGER   CATIN(256), SEQIN, SEQ2, SEQOUT, DISKIN, DISK2, DISOUT,
     *   CNOIN, CNOOUT, JBUFSZ, BUFFS(XBFSZ), NANT, CNOIN2, CCTVER,
     *   NFREQ, REFANT, NPOL, NVAL, SNVER, VISDSK, VISCNO, VER, NUMNOD,
     *   NUMBL, NUMTIM, PRTLV, BLDO, MODE, MINNO, LOCIF, LOCF, CNTMGM,
     *   CNTMG(MPOLIF), IPOLIF, NFLAGD, DOMGM, CHNSEL(3,20,MAXIF),
     *   LECHAN, LBCHAN, DOSAVG, CNTMMM, CATMOD(256), SCRTCH(256)
      LOGICAL   SINGLE, DOMODL, TSMOTH, AVGIF, AVGPOL, DOL1, DOGCON,
     *   DOPASS, GSOLV(MAXANT+1), SLMEAN(MAXANT), ALZERO, ONENEG,
     *   FLAGIT, ISLINE
      INTEGER   NCOMP(MAXFLD), REFUSE(MAXANT), REFUSS(MAXANT,100)
      INTEGER   LSTUSE(MAXANT), NUSE
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XXCALC(1),
     *   XNAME2(3), XCLAS2(2), XNAMOU(3), XCLAOU(2), XXSOLT(1),
     *   XXSOLM(1), XCMETH(1), XCMOD(1)
      CHARACTER NAMEIN*12, CLAIN*6, XSOUR(30)*16, XCALCO*4, NAME2*12,
     *   CLAS2*6, NAMOUT*12, CLAOUT*6, XSOLTY*4, XSOLMO*4, CMETH*4,
     *   CMOD*4, MODTYP*2
      REAL      XSI, XDI, XQUAL, XBAND, XFREQ, XFQID, XTIME(8),
     *   XCHNS(4,20), XANTS(50), XANUSE(50), XSUBA, XUVRA(2), XWTUV,
     *   XWTIT, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND,
     *   XBPVER, XSMOTH(3), XS2, XD2, XVER, XSO, XDO, APPLY,
     *   XNCOMP(MAXAFL), XFLUX, XNMAP, SMODEL(7), XREFA, XSOLIN, XSOLS,
     *   XSOLM, APARM(10), XDOFL, XSOLCO, MNAMPE, MNPHSE, XNORM,
     *   CPARM(10), XSNVER, XANT(30), XGERR(30), DOHIST, XBADD(10),
     *   DELTIM, BUFF1(XBFSZ), BUFF2(XBFSZ), ANTWT(MAXANT), IATOFF,
     *   SOLINT, DELWIN, RATWIN, GAERR(MAXANT), CONFAC, SNRMIN, MXPABL,
     *   MNPABL, WTPABL, FINC(MAXIF), SUMMGM, SUMMG(MPOLIF),
     *   CLOSER(2,2), XDOFIT(30), GMINEL, SUMMMM, AGMMO(MAXIF,2,100)
      INTEGER   ANTUSE(50), CNTOK, CNTBAD, CNTFEW, CNTSAD, TOTREC(2,3),
     *   ISBAND(MAXIF), IBUFF2(XBFSZ), MLOCB, MLOCA1, MLOCA2, MLOCT
      DOUBLE PRECISION  RANOD, DECNOD
      CHARACTER BNDCOD(MAXIF)*8
      EQUIVALENCE (BUFF2, IBUFF2)
      COMMON /CINFO/ RANOD, DECNOD, CATIN, CATMOD, DELTIM, IATOFF,
     *   ANTWT, SOLINT, DELWIN, RATWIN, GAERR, CONFAC, SNRMIN, MXPABL,
     *   MNPABL, WTPABL, NCOMP, REFUSE, SINGLE, DOMODL, TSMOTH, AVGIF,
     *   GSOLV, AVGPOL, DOMGM, DOL1, DOGCON, DOSAVG, DOPASS, CNOIN,
     *   CNOOUT, NANT, NFREQ, NPOL, NVAL, REFANT, CNTMGM, SUMMGM,
     *   CNOIN2, CCTVER, SNVER, VISDSK, VISCNO, VER, NUMNOD, NUMBL,
     *   NUMTIM, PRTLV, BLDO, MODE, MINNO, LOCIF, LOCF, FINC, ISBAND,
     *   ANTUSE, LSTUSE, NUSE, CLOSER, CNTMG, SUMMG, IPOLIF, SLMEAN,
     *   ALZERO, ONENEG, DISKIN, DISK2, DISOUT, SEQIN, SEQ2, SEQOUT,
     *   GMINEL, FLAGIT, NFLAGD, CHNSEL, LECHAN, LBCHAN, SUMMMM, CNTMMM,
     *   REFUSS, AGMMO, ISLINE, MLOCB, MLOCA1, MLOCA2, MLOCT
      COMMON /RESLTS/ CNTOK, CNTBAD, CNTFEW, CNTSAD, TOTREC
      COMMON /BUFRS/ BUFF1, BUFF2, BUFFS, SCRTCH, JBUFSZ
      COMMON /CHRCOM/ NAMEIN, CLAIN, XSOUR, XCALCO, NAME2, CLAS2,
     *   NAMOUT, CLAOUT, XSOLTY, XSOLMO, CMETH, CMOD, BNDCOD, MODTYP
      COMMON /XINPUT/ XNAMEI, XCLAIN, XSI, XDI, XXSOUR, XQUAL, XXCALC,
     *   XBAND, XFREQ, XFQID, XTIME, XCHNS, XANTS, XDOFIT, XANUSE,
     *   XSUBA, XUVRA, XWTUV, XWTIT, XDOCAL, XGUSE, XDOPOL, XPDVER,
     *   XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH, XNAME2, XCLAS2, XS2,
     *   XD2, XVER, XNCOMP, XFLUX, XNMAP, XCMETH, XCMOD, SMODEL, XNAMOU,
     *   XCLAOU, XSO, XDO, APPLY, XREFA, XSOLIN, XSOLS, XSOLM, APARM,
     *   XDOFL, XXSOLT, XXSOLM, XSOLCO, MNAMPE, MNPHSE, XNORM, CPARM,
     *   XSNVER, XANT, XGERR, DOHIST, XBADD
LOCAL END
LOCAL INCLUDE 'CALFLAG'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   FGKOLS(MAXFGC), FGNUMV(MAXFGC), FGVERO, LFGRNO,
     *   FGBUFL(512), FLGLUN
      CHARACTER REASON*24
      COMMON /CALFP/ FGBUFL, FGKOLS, FGNUMV, LFGRNO, FGVERO, FLGLUN
      COMMON /CALFC/ REASON
LOCAL END
      PROGRAM CALIB
C-----------------------------------------------------------------------
C! Basic continuum calibration routine using source models
C# UV Calibration EXT-appl AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1996-2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This task determines the calibration to be applied to a uv data set
C   given a model of the source(s).  The output data will have the
C   corrections applied for a single source input file; and the
C   Cal (CL) table will be updated for a multi source data set.
C       For multisource (raw) data sets the current contents of a
C   specified Cal (CL) table can be applied to the data before
C   determining the new calibration constants.
C   Adverbs:
C                                      Input uv data.
C   INNAME                                UV file name (name)
C   INCLASS                               UV file name (class)
C   INSEQ              0.0      9999.0    UV file name (seq. #)
C   INDISK             0.0         9.0    UV file disk drive #
C                                      Data selection (multisource):
C   CALSOUR                            Calibrator sources
C   QUAL            -10.0              Calibrator qualifier -1=>all
C   CALCODE                            Calibrator code '    '=>all
C   SELBAND                            Bandwidth to select (kHz)
C   SELFREQ                            Frequency to select (MHz)
C   FREQID                             Freq. ID to select.
C   TIMERANG                           Time range to use.
C   ICHANSEL          0.0     2048.0   begin/end chan, incr, if
C                                      for averaging data
C   ANTENNAS                           Antennas to select. 0=all
C   DOFIT                              Subset of ANTENNAS list for
C                                      which solns are desired.  0
C                                      => all in ANTENNAS, < 0 all
C                                      but those in DOFIT
C   ANTUSE                             Mean gain is calculated
C                                      (CPARM(2)>0) using only the
C                                      listed antennas. See explain.
C   SUBARRAY          0.0     1000.0   Subarray, 0=>all
C   UVRANGE                            Range of uv distance for full
C                                      weight
C   WTUV                               Weight outside UVRANGE 0=0.
C
C                                      Cal. info for input:
C   DOCALIB          -1.0        2.0   If >0 calibrate data
C                                      = 2 calibrate weights
C   GAINUSE                            CL table to apply.
C   DOPOL            -1.0       10.0   If >0 correct polarization.
C   BLVER                              BL table to apply.
C   FLAGVER                            Flag table version
C   DOBAND           -1.0       10.0   If >0 apply bandpass cal.
C                                      Method used depends on value
C                                      of DOBAND (see HELP file).
C   BPVER                              Bandpass table version
C   SMOOTH                             Smoothing function. See
C                                      HELP SMOOTH for details.
C
C                                      CLEAN map. See HELP.
C   IN2NAME                               Cleaned map name (name)
C   IN2CLASS                              Cleaned map name (class)
C   IN2SEQ            0.0     9999.0      Cleaned map name (seq. #)
C   IN2DISK           0.0        9.0      Cleaned map disk unit #
C   INVERS           -1.0    46655.0   CC file version #.
C   NCOMP                              # comps to use for model.
C                                      1 value per field
C   FLUX                               Lowest CC component used.
C   NMAPS             0.0     4096.0   No. Clean map files
C   CMETHOD                            Modeling method:
C                                      'DFT','GRID','    '
C   CMODEL                             Model type: 'COMP','IMAG'
C   SMODEL                             Source model, 1=flux,2=x,3=y
C                                      See HELP SMODEL for models.
C
C                                      Output uv data file.
C   OUTNAME                               UV file name (name)
C   OUTCLASS                              UV file name (class)
C   OUTSEQ            -1.0      9999.0    UV file name (seq. #)
C   OUTDISK            0.0         9.0    UV file disk drive #
C
C                                      Solution control adverbs:
C   REFANT                             Reference antenna
C   SOLINT                             Solution interval (min)
C   APARM                              General parameters
C                                         1=min. no. antennas
C                                         2 > 0 => data divided
C                                         3 > 0 => avg. RR,LL
C                                         5 > 0 => avg. IFs.
C                                         6=print level, 1=good,
C                                           2 closure, 3 SNR
C                                         7=SNR cutoff (0=>5)
C                                         8=max. ant. # (no AN)
C                                         9 > 0 => pass failed soln
C                                      Phase-amplitude Parameters:
C   SOLTYPE                            Soln type,'  ','L1','GCON'
C   SOLMODE                            Soln. mode: 'A&P','P','P!A',
C                                      'GCON', 'A&PR', 'PR', 'P!AR'
C   SOLCON                             Gain constraint factor.
C   MINAMPER          0.0              Amplitude closure error
C                                      regarded as excessive in %
C   MINPHSER          0.0              Phase closure error regarded
C                                      as excessive in degrees
C   CPARM                              Phase-amp. parameters
C                                         1 = Min el for gain
C                                              normalization (deg)
C                                         2 >0 => normalize gain
C                                         3 avg. amp. closure err
C                                         4 avg. ph. closure err
C                                         5 >0 => scalar average
C                                         6 limit robust discard levels
C   SNVER             -1.0     46655.0 Output SN table, 0=>new table
C   ANTWT                              Ant. weights (0=>1.0)
C   GAINERR                            Std. Dev. of antenna gains.
C   BADDISK                            Disk no. not to use for
C                                         scratch files.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   MAXBL, MAXFRQ
      INTEGER   NUMSUB, ISUB, IS1, IS2, IST, IRET, IPOL, J, KK2, IERR
      LOGICAL   GOTD
      INCLUDE 'CALIB.INC'
      INCLUDE 'CALFLAG'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DSEL.INC'
      REAL      GMMO(MAXIF,2)
      DATA PRGM /'CALIB '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL CLBIN (PRGM, MAXBL, MAXFRQ, NUMSUB, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Loop over subarrays
      GOTD = .FALSE.
      IST = SUBARR
      IF (SUBARR.EQ.0) THEN
         IS1 = 1
         IS2 = NUMSUB
      ELSE
         IS1 = SUBARR
         IS2 = SUBARR
         IF (DOMGM.GE.6) DOMGM = DOMGM - 2
         END IF
      DO 100 ISUB = IS1,IS2
         WRITE (MSGTXT,1000) ISUB, IS2
         IF (IS1.NE.IS2) CALL MSGWRT (3)
         SUBARR = ISUB
         IF (DOMGM.GE.3) THEN
            CNTMGM = 0
            SUMMGM = 0.0
            END IF
C                                       Select data.
         CALL CLBSEL (IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Check if data found
         IF (NVIS.LE.0) GO TO 100
         GOTD = .TRUE.
C                                       Divide data by model if nec.
         IF (DOMODL) CALL CLBMOD (IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Do solutions.
         CALL CLBSOL (MAXBL, MAXFRQ, IRET)
         IF (IRET.NE.0) GO TO 990
 100     CONTINUE
C                                       No data selected
      IF (.NOT.GOTD) THEN
         IRET = 1
         WRITE (MSGTXT,1100)
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       normalize over subarray
      IF (DOMGM.GE.6) THEN
         SUBARR = -1
         IF (DOMGM.EQ.6) THEN
            MSGTXT = 'Apply mean gain modulus to SN table by IF'
            CALL MSGWRT (3)
            DO 120 KK2 = BIF,EIF
               J = 0
               GMMO(KK2,1) = 0.0
               DO 110 ISUB = 1,NUMSUB
                  DO 105 IPOL = 1,NUMPOL
                     IF (AGMMO(KK2,IPOL,ISUB).NE.FBLANK) THEN
                        GMMO(KK2,1) = GMMO(KK2,1) + AGMMO(KK2,IPOL,ISUB)
                        J = J + 1
                        END IF
 105                 CONTINUE
 110              CONTINUE
               IF (J.GT.0) THEN
                  GMMO(KK2,1) = GMMO(KK2,1) / J
               ELSE
                  GMMO(KK2,1) = 1.0
                  END IF
               WRITE (MSGTXT,1110) KK2, GMMO(KK2,1)
               CALL MSGWRT (5)
               GMMO(KK2,2) = GMMO(KK2,1)
 120           CONTINUE
         ELSE IF (DOMGM.EQ.7) THEN
            MSGTXT = 'Apply mean gain modulus to SN table by IF/pol'
            CALL MSGWRT (3)
            DO 140 KK2 = BIF,EIF
               DO 130 IPOL = 1,NUMPOL
                  J = 0
                  GMMO(KK2,IPOL) = 0.0
                  DO 125 ISUB = 1,NUMSUB
                     IF (AGMMO(KK2,IPOL,ISUB).NE.FBLANK) THEN
                        GMMO(KK2,IPOL) = GMMO(KK2,IPOL) +
     *                     AGMMO(KK2,IPOL,ISUB)
                        J = J + 1
                        END IF
 125                 CONTINUE
                  IF (J.GT.0) THEN
                     GMMO(KK2,IPOL) = GMMO(KK2,IPOL) / J
                  ELSE
                     GMMO(KK2,IPOL) = 1.0
                     END IF
 130              CONTINUE
               WRITE (MSGTXT,1130) KK2, IPOL, GMMO(KK2,IPOL)
               CALL MSGWRT (5)
 140           CONTINUE
            END IF
         CALL GMODIT (DISKIN, CNOIN, SNVER, SUBARR, BIF, EIF, CATIN,
     *      GMMO, IERR)
         END IF
C                                       Restore subarray
      SUBARR = IST
C                                       Smooth solutions
      CALL CLBADJ (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Apply solns. and average data.
C                                       Single source files only.
      IF ((SINGLE) .AND. (DOMODL) .AND. (APPLY.GE.0.0)) THEN
         IF (NFLAGD.GT.0) FGVER = FGVERO
         CALL CLBAPL (IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
C                                       Write history.
      CALL CLBHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT (' START SUBARRAY ',I4,' OF ',I4)
 1100 FORMAT (' WARNING: NO DATA SELECTED')
 1110 FORMAT ('IF =',I3,' apply average gain over subarray/pol',
     *   1PE10.3)
 1130 FORMAT ('IF =',I3,' pol',I2,' apply average gain over subarray',
     *   1PE10.3)
      END
      SUBROUTINE CLBIN (PRGN, MAXBL, MAXFRQ, NUMSUB, IRET)
C-----------------------------------------------------------------------
C   CLBIN gets input parameters for CALIB and creates an output file
C   if necessary.
C   Inputs:  PRGN    C*6       Program name
C   Output:  MAXBL   I         Maximum number of baselines in data.
C            MAXFRQ  I         Maximum number of frequency channels.
C            NUMSUB  I         Number of subarrays (AN tables)
C            IRET    I         Error code: 0 => ok
C                                1 => too few frequency channels.
C                                5 => catalog troubles
C                                7 => Too many ant. for ls.
C                                8 => cannot start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in CALIB for more details.
C-----------------------------------------------------------------------
      CHARACTER PRGN*6, STAT*4, MODCOD(4)*4, TYPCOD(6)*4, UTYPE*2,
     *   ATIME*8, ADATE*12, LSTOK*4
      HOLLERITH CATH(256)
      INTEGER   MAXBL, MAXFRQ, NUMSUB, IRET
      INTEGER   IERR, NPARM, I, J, MXFLD, SOLTYP, IROUND, MXANT, NUMFRQ,
     *   LUN1, ANVER, LIM1, LIM2, KK1, IKK1, DATE(3), TIME(3), K, K1,
     *   K2, INDEX, LLOCWT, NUMCAL(3)
      LOGICAL   T, F, TABLE, EXIST, FITASC, MATCH, DOCMP
      REAL      CATR(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'CALIB.INC'
      INCLUDE 'CALFLAG'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DANS.INC'
      INTEGER   NW(MAXIF), NCHAN
      EQUIVALENCE (CATR, CATBLK, CATH, CATD)
      DATA MODCOD /'A&P','P','P!A','GCON'/
      DATA TYPCOD /' ','L1  ','GCON', 'R', 'L1R', 'GCOR'/
      DATA LUN1 /28/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      TSKNAM = PRGN
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = 2 * XBFSZ
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
      NSOUWD = 1
      CNTMGM = 0
      SUMMGM = 0.0
      CNTMMM = 0
      SUMMMM = 0.0
      NFLAGD = 0
C                                       Get input parameters.
      MXFLD = MAXAFL
      NPARM = 364 + MXFLD + 50 + 80
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSI)
      SEQ2 = IROUND (XS2)
      SEQOUT = IROUND (XSO)
      DISKIN = IROUND (XDI)
      DISK2 = IROUND (XD2)
      DISOUT = IROUND (XDO)
      CCTVER = IROUND (XVER)
      CCTVER = MAX (0, CCTVER)
      FLAGIT = XDOFL.GT.0.0
      IF (XDOFL.GT.0.0) THEN
         IF (XDOFL.LT.2.0) XDOFL = 2.5
      ELSE IF (XDOFL.GT.-1.0) THEN
         XDOFL = -2.5
         IF (APARM(6).GT.0.5) XDOFL = -99.0
         END IF
      XDOFL = ABS (XDOFL)
C                                       Set flagging reason
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
      REASON = TSKNAM // ADATE // ' ' // ATIME(:5)
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAME2, NAME2)
      CALL H2CHR (6, 1, XCLAS2, CLAS2)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (4, 1, XXCALC, XCALCO)
      CALL H2CHR (4, 1, XXSOLT, XSOLTY)
      CALL H2CHR (4, 1, XXSOLM, XSOLMO)
      CALL H2CHR (4, 1, XCMETH, CMETH)
      CALL H2CHR (4, 1, XCMOD, CMOD)
      GSOLV(1) = .FALSE.
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
         J = IROUND (XDOFIT(I))
         IF (J.NE.0) GSOLV(1) = .TRUE.
 10      CONTINUE
C                                      Default ant. wt = 1.0
      MXANT = MAXANT
      CALL RFILL (MXANT, 1.0, ANTWT)
      DO 15 I = 1, 30
         ANTWT(I) = XANT(I)
         IF (XANT(I).LE.0.0) ANTWT(I) = 1.0
 15      CONTINUE
C                                       Zero ref. ant. count.
      CALL FILL (MAXANT, 0, REFUSE)
      I = 100 * MAXANT
      CALL FILL (I, 0, REFUSS)
C                                       what type is model?
      IF ((NAME2.NE.' ') .AND. (CLAS2.NE.' ')) THEN
         CNOIN2 = 1
         MODTYP = ' '
         CALL CATDIR ('SRCH', DISK2, CNOIN2, NAME2, CLAS2, SEQ2, MODTYP,
     *      NLUSER, STAT, SCRTCH, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR, NAME2, CLAS2, SEQ2, DISK2, NLUSER
            GO TO 990
            END IF
         CALL CATIO ('READ', DISK2, CNOIN2, CATMOD, 'REST', SCRTCH,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING MODEL HEADER'
            GO TO 990
            END IF
         IF (MODTYP.EQ.'UV') THEN
            CALL COPY (256, CATMOD, CATBLK)
            CALL UVPGET (IRET)
            MLOCB = ILOCB
            MLOCA1 = ILOCA1
            MLOCA2 = ILOCA2
            MLOCT = ILOCT
            END IF
         END IF
C                                       Get CATBLK from old file.
      CNOIN = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'REST', SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING MAIN UV HEADER'
         GO TO 990
         END IF
C                                       Save Input file info
      VISDSK = DISKIN
      VISCNO = CNOIN
C                                       Get uv header info.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       set flag versions
      ISLINE = CATD(KDCRV+JLOCS).LE.-5.0D0
      CALL FNDEXT ('FG', CATBLK, I)
      FGVERO = I + 1
      FGVER = IROUND (XFLAG)
      IF ((FGVER.EQ.0) .OR. (FGVER.GT.I)) FGVER = I
      LFGRNO = -1
      FLGLUN = 48
      CALL FILL (512, 0, FGBUFL)
C                                       See if a multiple source file
      LUNS(1) = 29
      CALL ISTAB ('SU', DISKIN, CNOIN, 1, LUNS, SCRTCH, TABLE, EXIST,
     *   FITASC, IERR)
      SINGLE = (.NOT.EXIST) .OR. (IERR.NE.0) .OR. (ILOCSU.LT.0)
C
      WRITE (MSGTXT,3010) NAMEIN, CLAIN, SEQIN, DISKIN, NLUSER
      CALL REFRMT (MSGTXT, '_', I)
      CALL MSGWRT (3)
C                                       Save IF and freq pointers
      LOCIF = JLOCIF
      LOCF = JLOCF
C                                       Freq id
      IF (SINGLE) THEN
         FRQSEL = 1
      ELSE IF (.NOT.SINGLE) THEN
         IF (XBAND.GT.0.0) SELBAN = XBAND
         IF (XFREQ.GT.0.0) SELFRQ = XFREQ
         FRQSEL = IROUND (XFQID)
         IF (FRQSEL.EQ.0) FRQSEL = -1
         CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN1, SELBAN, SELFRQ,
     *      MATCH, FRQSEL, IRET)
         IF (.NOT.MATCH) THEN
            WRITE (MSGTXT,1040)
            IRET = 1
            GO TO 990
            END IF
         IF (IRET.GT.0) GO TO 999
         END IF
C                                       General parms
      SOLINT = XSOLIN / (24.0 * 60.0)
      MXPABL = XUVRA(2)
      IF (MXPABL.LE.1.0E-20) MXPABL = 1.0E15
      MNPABL = XUVRA(1)
      WTPABL = XWTUV
      REFANT = IROUND (XREFA)
      DOMODL = APARM(2).LE.1.0E-20
      PRTLV = IROUND (APARM(6))
      SNRMIN = APARM(7)
      AVGPOL = APARM(3).GT.0.0
      IF (AVGPOL) THEN
         IF (((ICOR0.NE.-1) .AND. (ICOR0.NE.-5)) .OR.
     *      (CATBLK(KINAX+JLOCS).LT.2)) THEN
            MSGTXT = 'POLARIZATION AVERAGING INAPPROPRIATE - TURNED OFF'
            CALL MSGWRT (6)
            AVGPOL = .FALSE.
            END IF
         END IF
      AVGIF = APARM(5).GT.0.0
      IF ((AVGIF) .AND. ((JLOCIF.LT.0) .OR.
     *   (CATBLK(KINAX+JLOCIF).LT.2))) THEN
         MSGTXT = 'AVERAGING OF IFs INAPPROPRIATE - TURNED OFF'
         CALL MSGWRT (6)
         AVGIF = .FALSE.
         END IF
      IF (AVGPOL) ISLINE = .FALSE.
C                                       Pass data with failed soln?
      DOPASS = APARM(9).GT.0.01
      IF (DOPASS) THEN
         MSGTXT = 'Warning: failed solutions replaced by (1,0)'
         CALL MSGWRT (6)
         END IF
C                                       Def. SNR min = 5.0
      IF (SNRMIN.LE.1.0E-30) SNRMIN = 5.0
C                                       Default s.i. = 10 sec.
      IF (SINGLE .AND. (SOLINT.LE.1.0E-10))
     *   SOLINT = 10.0 / (24.0 * 60.0 * 60.0)
C                                       Default multisource = scan
      IF ((.NOT.SINGLE) .AND. (SOLINT.LE.1.0E-10)) SOLINT = 0.1
C                                       Solution type.
      SOLTYP = -1
      IF (XSOLTY.EQ.TYPCOD(1)) SOLTYP = 1
      IF (XSOLTY.EQ.TYPCOD(2)) SOLTYP = 2
      IF (XSOLTY.EQ.TYPCOD(3)) SOLTYP = 3
      IF (XSOLTY.EQ.TYPCOD(4)) SOLTYP = 4
      IF (XSOLTY.EQ.TYPCOD(5)) SOLTYP = 5
      IF (XSOLTY.EQ.TYPCOD(6)) SOLTYP = 6
      IF ((GSOLV(1)) .AND. (SOLTYP.NE.1) .AND. (SOLTYP.NE.4)) THEN
         MSGTXT = 'Sorry. DOFIT invalidates SOLTYPE for now...'
         CALL MSGWRT (6)
         SOLTYP = SOLTYP/4 + 1
         SOLTYP = MAX (1, SOLTYP)
         END IF
      DOL1 = SOLTYP.EQ.2 .OR. SOLTYP.EQ.5
      DOGCON = SOLTYP.EQ.3 .OR. SOLTYP.EQ.6
C                                       Tell user which type
      IF (DOL1) THEN
         MSGTXT = 'L1 Solution type'
         CALL MSGWRT (3)
         END IF
      IF (DOGCON) THEN
         MSGTXT = 'Gain constraint solution type'
         CALL MSGWRT (3)
         END IF
C                                       Invalid TYPE
      IF (SOLTYP.LT.0) THEN
         WRITE (MSGTXT,1060) XSOLTY
         IRET = 6
         GO TO 990
         END IF
      IF ((.NOT.DOGCON) .AND. ((MODE.EQ.3) .OR. (MODE.EQ.7))) THEN
         MSGTXT = 'SOLMODE IS ''GCON'' BUT SOLTYPE IS NOT'
         IRET = 6
         GO TO 990
         END IF
C                                       Solution mode
      MODE = -1
      IF (XSOLMO.EQ.MODCOD(1)) MODE = 0
      IF (XSOLMO.EQ.MODCOD(2)) MODE = 1
      IF (XSOLMO.EQ.MODCOD(3)) MODE = 2
      IF (XSOLMO.EQ.MODCOD(4)) MODE = 3
      IF ((MODE.EQ.-1) .AND. SINGLE) MODE = 1
      IF (MODE.EQ.-1) MODE = 0
      IF ((MODE.EQ.0) .OR. (MODE.EQ.3)) THEN
         DOMGM = 1
         IF (XNORM.GT.0.0) DOMGM = 2
         IF (XNORM.GT.1.5) DOMGM = 3
         IF (XNORM.GT.2.5) DOMGM = 4
         IF (XNORM.GT.3.5) DOMGM = 5
         IF (XNORM.GT.4.5) DOMGM = 6
         IF (XNORM.GT.5.5) DOMGM = 7
      ELSE
         DOMGM = 0
         END IF
      IF (SOLTYP.GT.3) THEN
         MODE = MODE + 4
         SOLTYP = SOLTYP - 3
         END IF
      CONFAC = XSOLCO
      IF (CONFAC.LE.1.0E-20)  CONFAC = 1.0
      IF (CPARM(5).LE.0.0) THEN
         DOSAVG = 0
      ELSE
         DOSAVG = MAX (1., MIN (2., CPARM(5)+0.5)) + 0.01
         END IF
C                                       Check closure error print limits
      IF (CPARM(3).LE.1.0E-10) CPARM(3) = 1.E12
      IF (CPARM(4).LE.1.0E-10) CPARM(4) = 1.E12
      IF (MNAMPE.LE.1.0E-10) MNAMPE = 1.E12
      IF (MNPHSE.LE.1.0E-10) MNPHSE = 1.E12
C                                       Solving for gain?
      IF ((MODE.NE.0) .AND. (MODE.NE.3)) CPARM(3) = 1.0E12
      IF ((MODE.NE.0) .AND. (MODE.NE.3)) MNAMPE = 1.0E12
      I = IROUND (XWTIT)
      IF ((I.GT.0) .AND. (I.LE.3)) MODE = 10 * I + MODE
C                                       Convert to fraction, rad.
      CLOSER(1,1) = CPARM(3) * 0.01
      CLOSER(1,2) = CPARM(4) / 57.296
      CLOSER(2,1) = MNAMPE * 0.01
      CLOSER(2,2) = MNPHSE / 57.296
      CALL RFILL (MXANT, 0.0, GAERR)
      CALL RCOPY (30, XGERR, GAERR)
C                                       BADDISK
      DO 20 I = 1,10
         IBAD(I) = IROUND (XBADD(I))
 20      CONTINUE
C                                       Check sort order, must be T*
      IF (ISORT(1:1) .NE.'T') THEN
         IRET = 4
         WRITE (MSGTXT,1070) ISORT, 'T*'
         GO TO 990
         END IF
C                                       Save input header.
      CALL COPY (256, CATBLK, CATIN)
      CALL COPY (3, CATBLK(KICCL), NUMCAL)
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      IF (.NOT.SINGLE) THEN
         DO 25 I = 1,30
            SOURCS(I) = XSOUR(I)
            CALSOU(I) = XSOUR(I)
 25         CONTINUE
         SELQUA = IROUND (XQUAL)
         SELCOD = XCALCO
         END IF
      CALL RCOPY (8, XTIME, TIMRNG)
      NCHAN = CATBLK(KINAX+JLOCF)
      DXTIME = 0.0
      BIF = 1
      EIF = 1
      IF (JLOCIF.GE.0) EIF = CATBLK(KINAX+JLOCIF)
C                                       Channel selection
      I = 60 * MAXIF
      CALL FILL (I, 0, CHNSEL)
      CALL FILL (MAXIF, 0, NW)
      DO 40 J = 1,20
         K = IROUND (XCHNS(2,J))
         IF (K.GT.0) THEN
            K = IROUND (XCHNS(4,J))
            IF ((K.LE.0) .OR. (K.GT.MAXIF)) THEN
               K1 = 1
               K2 = MAXIF
            ELSE
               K1 = K
               K2 = K
               END IF
            DO 35 K = K1,K2
               NW(K) = NW(K) + 1
               DO 30 I = 1,3
                  CHNSEL(I,NW(K),K) = IROUND (XCHNS(I,J))
                  IF (CHNSEL(I,NW(K),K).LT.0) CHNSEL(I,NW(K),K) = 0
 30               CONTINUE
               IF (CHNSEL(3,NW(K),K).EQ.0) CHNSEL(3,NW(K),K) = 1
 35            CONTINUE
            END IF
 40      CONTINUE
C                                       If no channel selection
C                                       use VLA definition of
C                                       channel 0
      BCHAN = NCHAN
      ECHAN = 1
      DO 50 K = 1,MAXIF
         IF (NW(K).LE.0) THEN
            NW(K) = 1
            CHNSEL(1,1,K) = (NCHAN+1)/8 + 1
            CHNSEL(2,1,K) = NCHAN - ((NCHAN+1)/8)
            CHNSEL(3,1,K) = 1
            END IF
         DO 45 I = 1,NW(K)
            CHNSEL(1,I,K) = MAX (1, MIN (CHNSEL(1,I,K), NCHAN))
            IF (CHNSEL(2,I,K).LT.CHNSEL(1,I,K))
     *         CHNSEL(2,I,K) = NCHAN
            CHNSEL(2,I,K) = MAX (1, MIN (CHNSEL(2,I,K), NCHAN))
            BCHAN = MIN (BCHAN, CHNSEL(1,I,K))
            ECHAN = MAX (ECHAN, CHNSEL(2,I,K))
 45         CONTINUE
 50      CONTINUE
C                                       squirrel away for HIstory
      LBCHAN = BCHAN
      LECHAN = ECHAN
C                                       Warn user about what will happen
C                                       if not all channels are selected
C                                       from a single source file
      IF (SINGLE
     *   .AND.((CHNSEL(1,1,1).GT.1) .OR. (CHNSEL(2,1,1).LT.NCHAN))) THEN
         MSGTXT = 'WARNING: Calibration will be determined from ' //
     *      'selected'
         CALL MSGWRT (6)
         MSGTXT = '         frequency channels but applied to all ' //
     *      'channels'
         CALL MSGWRT (6)
         END IF
C                                       offset to sub-set
      DO 55 K = 1,MAXIF
         DO 54 I = 1,NW(K)
            CHNSEL(1,I,K) = CHNSEL(1,I,K) - BCHAN + 1
            CHNSEL(2,I,K) = CHNSEL(2,I,K) - BCHAN + 1
 54         CONTINUE
 55      CONTINUE
C                                       initialize arrays needed for
C                                       normalization of gains
      DO 65 I = 1,2
         DO 60 J = BIF,EIF
            IPOLIF = I + (J - 1) * NUMPOL
            CNTMG(IPOLIF) = 0
            SUMMG(IPOLIF) = 0.0
 60         CONTINUE
 65      CONTINUE
C                                       Antennas
      DO 70 I = 1,50
         ANTENS(I) = IROUND (XANTS(I))
         ANTUSE(I) = IROUND (XANUSE(I))
 70      CONTINUE
C                                       If any GSOLV entries are non-blank
C                                       solve only for those antennas.
C                                       excepting the reference antenna
      GSOLV(1) = .FALSE.
      DO 75 I = 1,30
         J = IROUND (XDOFIT(I))
         IF (J.LT.0) GSOLV(1) = .TRUE.
 75      CONTINUE
      CALL LFILL (MAXANT, GSOLV(1), GSOLV(2))
      IF (GSOLV(1)) THEN
         DO 80 I = 1,30
            J = IROUND (XDOFIT(I))
            J = ABS (J)
            IF ((J.GT.0) .AND. (J.LE.MAXANT)) GSOLV(J+1) = .FALSE.
 80         CONTINUE
      ELSE
         DO 85 I = 1,30
            J = IROUND (XDOFIT(I))
            IF ((J.GT.0) .AND. (J.LE.MAXANT)) THEN
               GSOLV(J+1) = .TRUE.
               GSOLV(1) = .TRUE.
               END IF
 85         CONTINUE
         END IF
      IF ((XDOCAL.GT.0.0) .AND. (SINGLE)) THEN
         MSGTXT = 'DOCALIB FOR SINGLE-SOURCE FILE CAN CAUSE TROUBLE'
         CALL MSGWRT (7)
         MSGTXT = 'OUTPUT SN TABLE IS NOT CUMULATIVE, SO NOT USEFUL'
         CALL MSGWRT (7)
         IF (APPLY.GE.0.0) THEN
            APPLY = -1.0
            MSGTXT = 'SETTING DOAPPLY TO FALSE'
            CALL MSGWRT (7)
            END IF
C         XDOCAL = -1.0
         END IF
      IF (GSOLV(1)) THEN
         IF (REFANT.LE.0) THEN
            IRET = 8
            MSGTXT = 'DOFIT OPTION REQUIRES A REFANT > 0'
            GO TO 990
         ELSE IF (GSOLV(REFANT+1)) THEN
            IRET = 8
            MSGTXT = 'REFANT MUST NOT BE IN DOFIT LIST'
            GO TO 990
            END IF
         END IF
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      SUBARR = IROUND (XSUBA)
      FGVER = IROUND (XFLAG)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      SNVER = IROUND (XSNVER)
      BLVER = IROUND (XBLVER)
      DOPOL = IROUND (XDOPOL)
      IF ((DOPOL.EQ.0) .AND. (XDOPOL.GT.0.0)) DOPOL = 1
      PDVER = IROUND (XPDVER)
C                                       Stokes' - ask for what's needed
      STOKES = '    '
      IF (CATD(KDCRV+JLOCS).GT.0.0) STOKES = 'I'
      IF ((CATD(KDCRV+JLOCS).LT.0.0) .AND. (CATBLK(KINAX+JLOCS).GE.2))
     *   STOKES = 'HALF'
C                                       Spectral smoothing
      CALL RCOPY (3, XSMOTH, SMOOTH)
C                                       Put new values in CATBLK.
      IF (CLAOUT.EQ.' ') CLAOUT = 'CALIB '
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       set no. frequencies
      NFREQ = CATBLK(KINAX+JLOCF)
      IRET = 0
      NANT = IROUND (APARM(8))
      IATOFF = 0.0
C                                       Find number of subarrays
      CALL FNDEXT ('AN', CATBLK, NUMSUB)
      NUMSUB = MAX (1, NUMSUB)
C                                       Max. ant. no.
      IF (NANT.LE.0) THEN
C                                       Check selected subarrays
         IF (SUBARR.GT.0) THEN
            LIM1 = SUBARR
            LIM2 = SUBARR
         ELSE
            LIM1 = 1
            LIM2 = NUMSUB
            END IF
         DO 165 I = LIM1,LIM2
            ANVER = I
            CALL GETANT (DISKIN, CNOIN, ANVER, CATIN, BUFFS, IRET)
            DO 162 J = 1, NSTNS
               NANT = MAX (NANT, TELNO(J))
 162           CONTINUE
C                                       Most likely screwup is for the
C                                       VLA.
            IF (IRET.NE.0) THEN
               NANT = 28
               MSGTXT = 'There was a problem with the AN table so I' //
     *            ' assume that this is VLA data'
               CALL MSGWRT (6)
               MSGTXT = 'If there are fewer than 28 ant. set APARM(8)'
     *            // ' if necessary'
               CALL MSGWRT (6)
               IRET = 0
               GO TO 170
               END IF
 165        CONTINUE
         END IF
C                                       Determine max. bl., time.
 170  NUMANT = NANT
C                                       Def. min. no. of antennas = 6
      MINNO = IROUND (APARM(1))
      IF (MINNO.LE.1) THEN
         MINNO = MIN (6, NUMANT/2)
         MINNO = MAX (3, MINNO)
      ELSE IF (MINNO.EQ.2) THEN
         MSGTXT = 'WARNING: PURE BASELINE RATHER THAN '
     *      // 'ONLY ANTENNA SOLUTIONS ALLOWED'
         CALL MSGWRT (6)
         END IF
C                                       Get the minimum elevation
C                                       for gain normalization.
      IF (DOMGM.GT.0) THEN
         GMINEL = CPARM(1)
      ELSE
         GMINEL = -90.0
         END IF
      IF ((GMINEL.GT.80.0) .OR. (GMINEL.LE.0.0)) GMINEL = -100.0
C                                       select the list of antennas
C                                       used in the averaging
      IF (DOMGM.GT.0) THEN
         ALZERO = T
         ONENEG = F
         DO 175 KK1 = 1,NUMANT
            SLMEAN(KK1) = T
            IF (KK1.LE.50) THEN
               ALZERO = ALZERO .AND. (ANTUSE(KK1).EQ.0)
               ONENEG = ONENEG .OR. (ANTUSE(KK1).LT.0)
               END IF
 175        CONTINUE
C                                       Deselect antennas if any of
C                                       ANTUSE is negative
         IF (ONENEG) THEN
            DO 180 KK1 = 1,50
               IKK1 = ABS (ANTUSE(KK1))
               IF ((IKK1.GT.0) .AND. (IKK1.LE.MAXANT)) SLMEAN(IKK1) = F
 180           CONTINUE
C                                       Use all antennas selected by
C                                       ANTUSE
         ELSE IF (.NOT.ALZERO) THEN
            DO 185 KK1 = 1,NUMANT
               SLMEAN(KK1) = F
 185           CONTINUE
            DO 190 KK1 = 1,50
               IKK1 = ANTUSE(KK1)
               IF ((IKK1.GT.0) .AND. (IKK1.LE.MAXANT)) SLMEAN(IKK1) = T
 190           CONTINUE
            END IF
         NUSE = 0
         DO 200 KK1 = 1,NUMANT
            IF (SLMEAN(KK1)) THEN
               NUSE = NUSE + 1
               LSTUSE(NUSE) = KK1
               END IF
 200        CONTINUE
         END IF
C
      NUMIF = 1
      IF (JLOCIF.GE.0) NUMIF = CATBLK(KINAX+JLOCIF)
      MAXBL = (NANT * (NANT - 1)) / 2
      MAXFRQ = NUMIF * 2
      IRET = 0
C                                       Create output file for SINGLE
C                                       and not already divided by
C                                       model.
      IF ((SINGLE) .AND. (DOMODL) .AND. (APPLY.GE.0.0)) THEN
         BCHAN = 1
         ECHAN = NCHAN
         LSTOK = STOKES
         STOKES = ' '
         DOCMP = CATBLK(KINAX).EQ.1
C                                       get a proper UVGET header
         CALL UVGET ('INIT', BUFF1, BUFF2, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1140) IRET
            GO TO 990
            END IF
C                                       add compressed back
         IF (DOCMP) THEN
            LLOCWT = CATBLK(KIPCN)
            INDEX = KHPTP + 2 * LLOCWT
            CALL CHR2H (8, 'WEIGHT  ', 1, CATH(INDEX))
            CALL CHR2H (8, 'SCALE   ', 1, CATH(INDEX+2))
            CATBLK(KINAX) = 1
            CATBLK(KIPCN) = CATBLK(KIPCN) + 2
            END IF
         CALL UVGET ('CLOS', BUFF1, BUFF2, IRET)
         CALL COPY (3, NUMCAL, CATBLK(KICCL))
         CATBLK(KICCL) = CATBLK(KICCL) + 1
         IF (DOBAND.GT.0) CATBLK(KICBP) = CATBLK(KICBP) + 1
         IF (DOPOL.GT.0) CATBLK(KICPD) = CATBLK(KICPD) + 1
         CNOOUT = 1
         FRW(NCFILE+1) = 3
         IRET = 4
         IF (.NOT.DOMODL) CATBLK(KIGCN) = 1
         NUMFRQ = CATBLK(KINAX+JLOCF)
         CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
         CATBLK(KIIMS) = SEQOUT
         CALL UVCREA (DISOUT, CNOOUT, SCRTCH, IRET)
         CATBLK(KINAX+JLOCF) = NUMFRQ
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1150) IRET
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISOUT
         FCNO(NCFILE) = CNOOUT
         FRW(NCFILE) = FRW(NCFILE) - 1
C                                       Save CATBLK for output.
         CALL CATIO ('UPDT', DISOUT, CNOOUT, CATBLK, 'REST', SCRTCH,
     *      IRET)
         IF ((IRET.NE.0) .AND. (IRET.LT.5)) THEN
            WRITE (MSGTXT,1170) IRET
            GO TO 990
            END IF
C                                       Other "single" parameters
C                                       allow flagging and BP cal now
C         DOBAND = 0
C         FGVER = -1
C                                       Make SN be cumulative not
C                                       incremental for single source
         SNVER = 0
C                                       copy keywords
         CALL KEYCOP (DISKIN, CNOIN, DISOUT, CNOOUT, IRET)
         STOKES = LSTOK
         BCHAN = LBCHAN
         ECHAN = LECHAN
         END IF
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
      GO TO 999
C
 990  CALL REFRMT (MSGTXT, '_', I)
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLBIN: ERROR',I3,' ON 'A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,' . ',A6,' .',
     *   I5,' _DISK=',I3,' USID=',I4)
 1040 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
 1060 FORMAT ('UNKNOWN SOLUTION TYPE = ',A4)
 1070 FORMAT ('SORT ORDER IS ',A2,' NOT ',A2,' AS REQUIRED')
 1140 FORMAT ('ERROR',I3,' OPENING INPUT FILE')
 1150 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1170 FORMAT ('ERROR',I3,' UPDATING OUTPUT FILE CATBLK')
 3010 FORMAT ('Using ',A12,' . ',A6,' .',I5,' _Disk=',I3,' Usid=',I6)
      END
      SUBROUTINE CLBSEL (IRET)
C-----------------------------------------------------------------------
C   CLBSEL will read a multi source data set into a temporary scratch
C   file.  Editing and calibration may be applied.
C   Inputs via common /SELCAL/  (Include DSEL.INC)
C      UNAME        C    AIPS name of input file.
C      UCLAS        C    AIPS class of input file.
C      UDISK        R    AIPS disk of input file.
C      USEQ         R    AIPS sequence of input file.
C      SOURCS(30)   C    Names (16 char) of up to 30 sources, *=>all
C                        First character of name '-' => all except those
C                        specified.
C      TIMRNG(8)    R    Start day, hour, min, sec, end day, hour,
C                        min,sec. 0 => all
C      UVRNG(2)     R    Minimum and maximum baseline lengths in
C                        1000s wavelengths. 0 => all
C      STOKES       C    Stokes types wanted.
C                        'I','Q','U','V','R','L','IQU','IQUV'
C      BCHAN        I    First channel number selected, 1 rel. to first
C                        channel in data base. 0 => all
C      ECHAN        I    Last channel selected. 0=>all
C      BIF          I    First IF number selected, 1 rel. to first
C                        IF in data base. 0 => all
C      EIF          I    Last IF selected. 0=>all
C      DOCAL        L    If true apply calibration, else not.
C      ANTENS(50)   I    List of antennas selected, 0=>all,
C                        any negative => all except those specified
C      FGVER        I    FLAG file version number, if .le. 0 then
C                        NO flagging is applied.
C      CLUSE        I    Cal file version number to apply.
C   Output:
C      IRET         I    Error code: 0 => OK,
C                        -1 => end of data
C                        >0 => failed, abort process.
C-----------------------------------------------------------------------
      INTEGER   IRET, LUN1, LUN2, IIVER, OOVER
      INCLUDE 'CALIB.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DOUBLE PRECISION FOFF(MAXIF)
      DATA LUN1, LUN2 /28, 29/
C-----------------------------------------------------------------------
C                                       Setup
      CALL UVGET ('INIT', BUFF1, BUFF2, IRET)
      IF (IRET.GT.0) GO TO 999
      IF ((NVIS.LE.0) .OR. (IRET.LT.0)) THEN
          MSGTXT = 'CLBSEL: NO DATA FOUND; CHECK ADVERBS'
          CALL MSGWRT (8)
          NVIS = 0
          GO TO 100
          END IF
C                                       Message
      IF (DOCAL) THEN
         IF (DOFLAG) THEN
            MSGTXT = 'Selecting, editing and calibrating the data'
         ELSE
            MSGTXT = 'Selecting and calibrating the data'
            END IF
      ELSE
         IF (DOFLAG) THEN
            MSGTXT = 'Selecting and editing the data'
         ELSE
            MSGTXT = 'Selecting the data'
            END IF
         END IF
      CALL MSGWRT (2)
C                                       Copy
      VISDSK = 0
      VISCNO = 0
      CALL CALCOP (VISDSK, VISCNO, BUFF1, JBUFSZ, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy relevant portion of IF
C                                       table.
      IIVER = 1
      OOVER = 1
      CALL CHNCOP (IIVER, OOVER, LUN1, LUN2, DISKIN, SCRVOL(VISCNO),
     *   CNOIN, SCRCNO(VISCNO), CATUV, CATBLK, BIF, EIF, FRQSEL,
     *   SFREQS, BUFF1, FOFF, ISBAND, FINC, IRET)
      GO TO 999
C                                       No data
 100  CALL UVGET ('CLOS', BUFF1, BUFF2, IRET)
C
 999  RETURN
      END
      SUBROUTINE CLBMOD (IRET)
C-----------------------------------------------------------------------
C   CLBMOD divides the CLEAN model visibilities into the data.
C   If no model is found or a point model is specified then the data
C   is divided by the flux density found in the Source (SU) table.
C   Inputs: from commons
C     XNCOMP    R    Number of components to be divided.
C     DISKIN    R    Input file disk number.
C     CNOIN     I    Input file catalog number.
C     DISK2     R    CLEAN file disk number.
C     XNMAP     R    Number of model files.
C     CCTVER    I    CC table version number.
C     NAME2     C    Cleaned map name (name)
C     CLAS2     C    Cleaned map name (class)
C     SMODEL(1) R    Flux of a point model
C   Output:
C     CNOIN2    I    CLEAN file catalog number.
C     IRET      I    Return code, 0 => ok, otherwise not.
C-----------------------------------------------------------------------
      INTEGER   IRET
      INTEGER   MODEL, METHOD, ISTOKE, DISKO, ISCR, CHAN, NCHAN, I, IIF,
     *   IROUND
      LOGICAL   DOMSG, F, NONAM, WASOME
      DOUBLE PRECISION APCORE(2)
      INCLUDE 'CALIB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGDS.INC'
      INTEGER   BITER(MAXFLD)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSCD.INC'
      REAL RBUF(MAXIF)
      DATA DOMSG, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IRET = 0
C                                       Check for correct request
      IF (SINGLE) NSOUWD = 1
      NONAM = (NAME2.EQ.' ') .OR. (CLAS2.EQ.' ')
C                                       multi-source request
      IF (NSOUWD.NE.1) THEN
         IF (.NOT.NONAM) THEN
            MSGTXT = 'A CLEAN MODEL WAS REQESTED FOR MULTIPLE SOURCES'
            CALL MSGWRT (8)
            IRET = 5
            GO TO 999
         ELSE
            GO TO 300
            END IF
C                                       single source request
      ELSE IF (SINGLE) THEN
         IF ((NONAM) .AND. (SMODEL(1).LE.1.0E-20)) THEN
            MSGTXT = 'SINGLE-SOURCE REQUIRES CLEAN OR SMODEL MODEL'
            CALL MSGWRT (8)
            IRET = 5
            GO TO 999
         ELSE IF ((.NOT.NONAM) .AND. (SMODEL(1).GT.1.E-20)) THEN
            MSGTXT = 'BOTH CLEAN AND SMODEL SPECIFIED FOR SINGLE-SOURCE'
     *         // ' FILE'
            CALL MSGWRT (8)
            IRET = 5
            GO TO 999
            END IF
C                                       multi-source file
      ELSE IF (NONAM) THEN
C                                       valid SMODEL
         IF ((NSOUWD.EQ.1) .AND. ((SMODEL(1).NE.0.0) .OR.
     *      (SMODEL(2).NE.0.0) .OR. (SMODEL(3).NE.0.0))) THEN
            IF (SMODEL(1).EQ.0.0) SMODEL(1) = 1.0
C                                       no model
         ELSE
            GO TO 300
            END IF
C                                       CC model, no SMODEL
      ELSE
         SMODEL(1) = 0.0
         END IF
C                                       UV model
      IF (MODTYP.EQ.'UV') THEN
         CALL UVMODL (IRET)
         GO TO 999
         END IF
C                                       Get  modeling method
      METHOD = 0
      IF (CMETH.EQ.'DFT ') METHOD = -1
      IF (CMETH.EQ.'GRID') METHOD = 1
C                                       Get  model type
      MODEL = 0
      IF (CMOD.EQ.'COMP') MODEL = 1
      IF (CMOD.EQ.'IMAG') MODEL = 2
      IF (CMOD.EQ.'SUBI') MODEL = 3
C                                       If Model required
C                                       then model must be specified
      IF (((CMETH.EQ.'GRID') .OR. (CMOD.EQ.'IMAG')) .AND. (NONAM)) THEN
         IRET = 5
         MSGTXT = 'YOU MUST SPECIFY A MODEL IMAGE IF CMETH=''GRID'''
     *      // 'OR CMOD=''IMAG'''
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Point source parameters
      DOPTMD = NONAM .AND. (ABS (SMODEL(1)).GT.1.0E-20)
      PTFLX = SMODEL(1)
      PTRAOF = SMODEL(2)
      PTDCOF = SMODEL(3)
      PARMOD(1) = SMODEL(4)
      PARMOD(2) = SMODEL(5)
      PARMOD(3) = SMODEL(6)
      PARMOD(4) = SMODEL(7)
C                                       Get info on model file(s)
      LIMFLX = XFLUX
      MFIELD = MAX (IROUND (XNMAP), 1)
      IF (DOPTMD) MFIELD = 0
      NONEG = F
      WASOME = F
      DO 10 I = 1,MFIELD
         BITER(I) = 1
         IF (I.LE.MAXAFL) THEN
            NCOMP(I) = ABS (XNCOMP(I)) + 0.1
            IF (XNCOMP(I).LE.-0.5) NONEG = .TRUE.
            IF (NCOMP(I).GT.0) WASOME = .TRUE.
         ELSE
            NCOMP(I) = 0
            IF (WASOME) NCOMP(I) = 1000000000
            END IF
 10      CONTINUE
C                                       If using CCs, check comps.
      FACGRD(1) = 1.0
      IF (DOPTMD) THEN
         DO3DIM = .FALSE.
         MSGTXT = 'Doing self-cal mode with point model'
         CALL MSGWRT (3)
         MODEL = 0
      ELSE
         IF (MODEL.EQ.3) THEN
            MSGTXT = 'Using sub-images for the source model'
         ELSE IF (MODEL.EQ.2) THEN
            MSGTXT = 'Using images for the self-cal source model'
         ELSE
            MSGTXT = 'Using Clean Component self-cal source model'
            END IF
         CALL MSGWRT (3)
         CALL SETGDS (DISKIN, CNOIN, NAME2, CLAS2, SEQ2, DISK2, MFIELD,
     *      CCTVER, NCOMP, BITER, MODEL, METHOD, BUFF1, BUFF2, ISTOKE,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         IF (MODEL.GT.0) THEN
            CALL FACSET (DISKIN, CNOIN, 1, SOUWAN(1), MODEL, 1.0, IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
         END IF
      XVER = CCTVER
      CNOIN2 = CCCNO(1)
C                                       Divide data by model
      DISKO = VISDSK
      ISCR = VISCNO
C                                       Set division parameters
      FACGRD(2) = 1.0
      COMPDT = .FALSE.
      DATDIV = .TRUE.
C                                       Consider whether to process
C                                       1 IF at a time
      IF ((NUMIF.GT.1) .AND. (MODEL.GT.0) .AND. (FACFLX.GT.0.0)) THEN
C                                       number of channels
         NCHAN = CATBLK(KINAX+JLOCF)
C                                       For each IF
         DO 15 IIF = 1,NUMIF
C                                       Already know IF 1 scale
            IF (IIF.GT.1) THEN
C                                       Reset Components for div
               IF (MFIELD.GT.0) THEN
                  DO 12 I = 1,MFIELD
                     BITER(I) = 1
                     IF (I.LE.MAXAFL) THEN
                        NCOMP(I) = ABS (XNCOMP(I)) + 0.1
                     ELSE
                        NCOMP(I) = 0
                        IF (WASOME) NCOMP(I) = 1000000000
                        END IF
 12                  CONTINUE
                  CALL SETGDS (DISKIN, CNOIN, NAME2, CLAS2, SEQ2, DISK2,
     *               MFIELD, CCTVER, NCOMP, BITER, MODEL, METHOD, BUFF1,
     *               BUFF2, ISTOKE, IRET)
                  IF (IRET.NE.0) GO TO 999
                  XVER = VER
                  CNOIN2 = CCCNO(1)
                  END IF
C                                       Divide data by model
               DISKO = VISDSK
               ISCR = VISCNO
C                                       Set division parameters
               COMPDT = .FALSE.
               DATDIV = .TRUE.
               FACGRD(1) = 1.0
               IF (MODEL.GT.0) THEN
                  CALL FACSET (DISKIN, CNOIN, IIF, SOUWAN(1), MODEL,
     *               1.0, IRET)
                  IF (IRET.NE.0) GO TO 999
                  END IF
               END IF
C                                       start channel
            CHAN = 1 + (NCHAN * (IIF-1))
C                                       Divide 1 IF by model
            CALL UVMDIV (APCORE, VISDSK, VISCNO, DISKO, ISCR, MODEL,
     *         METHOD,DOMSG, CHAN, NCHAN, CATBLK, JBUFSZ, FRQSEL,
     *         BUFF1, BUFF2, UBUFF, RBUF, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL UNSETG (BUFF2)
            DOMSG  = .FALSE.
 15         CONTINUE
C                                       else processing all IFs
      ELSE
         CHAN = 1
         NCHAN = CATBLK(KINAX+JLOCF) * NUMIF
C                                       Div all vis by model
         CALL UVMDIV (APCORE, VISDSK, VISCNO, DISKO, ISCR, MODEL,
     *      METHOD, DOMSG, CHAN, NCHAN, CATBLK, JBUFSZ, FRQSEL, BUFF1,
     *      BUFF2, UBUFF, RBUF, IRET)
         IF (IRET.NE.0) GO TO 999
         IF (.NOT.DOPTMD) CALL UNSETG (BUFF2)
         END IF
C                                       Get true values of NCOMP
      DO 20 I = 1,MFIELD
         NCOMP(I) = MAX (NSUBG(I), 1) - 1
C                                       Tell user about CCs
         IF (LIMFLX.GT.0.0) THEN
            IF (NONEG) THEN
               WRITE (MSGTXT,1000) I, NCOMP(I), LIMFLX
            ELSE
               WRITE (MSGTXT,1010) I, NCOMP(I), LIMFLX
               END IF
         ELSE
            IF (NONEG) THEN
               WRITE (MSGTXT,1100) I, NCOMP(I)
            ELSE
               WRITE (MSGTXT,1110) I, NCOMP(I)
               END IF
            END IF
         CALL MSGWRT(3)
 20      CONTINUE
C                                       Model divided by data now
C                                       in scratch file.
      VISDSK = 0
      VISCNO = ISCR
      GO TO 999
C                                       Multiple sources, use point
C                                       source at phase center only.
 300  MSGTXT = 'Doing cal transfer mode with point model for each' //
     *   ' source'
      CALL MSGWRT (3)
      MSGTXT = 'This is not self-calibration'
      CALL MSGWRT (3)
      IF (ISLINE) THEN
         CALL CLBLIN (IRET)
      ELSE
         CALL CLBDIV (IRET)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Field',I5,' used',I8,' CCs before 1st neg with flux>',
     *   F9.6)
 1010 FORMAT ('Field',I5,' used',I8,' CCs with flux>',F9.6)
 1100 FORMAT ('Field',I5,' used',I8,' CCs before 1st negative')
 1110 FORMAT ('Field',I5,' used',I8,' CCs')
      END
      SUBROUTINE UVMODL (IRET)
C-----------------------------------------------------------------------
C   UVMODL divides the model visibilities from a UVSUB model into the
C   data.  It can use the source table to determine fluxes and scales
C   the model by the fluxes as a function of IF, getting the model flux
C   from the model history file.
C   Inputs: from commons
C     DISKIN    R    Input file disk number.
C     CNOIN     I    Input file catalog number.
C     DISK2     R    model file disk number.
C     NAME2     C    model uv name (name)
C     CLAS2     C    model uv name (class)
C   Output:
C     CNOIN2    I    model uv file catalog number.
C     IRET      I    Return code, 0 => ok, otherwise not.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'CALIB.INC'
      INTEGER   I, NIF, LUN, LUNTMP, LUNI, LUNM, LUNO, INDI, INDO,
     *   INDM, BINDI, BINDO, BINDM, INIO, MNIO, MNCS, MNCF, MNCIF,
     *   BO, VO, VOL, NS, NF, LS, LF, LIF, NFAIL, IA1, IA2, MA1, MA2,
     *   ICNTI, IX, MX, LENBM, LENBI, LENBO, LRECM, MPTR, NRECI, NRECO,
     *   IPTRI, IPTRO, IPTRM, LX, ICNTO, NRPI, NRPM
      REAL      MODFLX, SCALE(MAXIF), BUFF3(XBFSZ), FACT, AMP, MRE, MIM,
     *   TIME, MIME, RATRE, RATIM, WT, magic
      CHARACTER NAME*48
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSOU.INC'
c      EQUIVALENCE (BUFFS, BUFF3)
      DATA BO, VO /1,0/
C-----------------------------------------------------------------------
C                                       test data set size
      IF (CATMOD(KIGCN).LT.CATBLK(KIGCN)) THEN
         WRITE (MSGTXT,1001) CATMOD(KIGCN), CATBLK(KIGCN)
         IRET = 10
         GO TO 990
         END IF
      NRECI = 0
      NRECO = 0
      NRPI = CATBLK(KIPCN)
      NRPM = CATMOD(KIPCN)
C                                       get model fluxes
      CALL RFILL (MAXIF, 1.0, SCALE)
      IF (SINGLE) THEN
         MSGTXT = 'Single-source file assumes all IFs have same flux'
         CALL MSGWRT (6)
      ELSE
         LUN = LUNTMP (1)
         CALL GETSOU (SOUWAN(1), DISKIN, CNOIN, CATIN, LUN, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'GETTING CAL SOURCE FLUX'
            GO TO 990
            END IF
         CALL HIGET (DISK2, CNOIN2, MODFLX, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'GETTING MODEL FLUX FROM HISTORY'
            GO TO 990
            END IF
         IF (MODFLX.LE.0.0) MODFLX = 1.0
         NIF = CATBLK(KINAX+JLOCIF)
         DO 10 I = 1,NIF
            SCALE(I) = FLUX(1,I) / MODFLX
 10         CONTINUE
         END IF
C                                       input data file
      NFAIL = 0
      NIF = CATBLK(KINAX+JLOCIF)
      NF = CATBLK(KINAX+JLOCF)
      NS = CATBLK(KINAX+JLOCS)
      VOL = SCRVOL(1)
      CALL ZPHFIL ('SC', VOL, SCRCNO(1), 1, NAME, IRET)
      LUNI = LUNTMP (0)
      CALL ZOPEN (LUNI, INDI, VOL, NAME, .TRUE., .FALSE., .TRUE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN SC VIS FILE FOR INPUT'
         GO TO 990
         END IF
      LUNO = LUNTMP (0)
      CALL ZOPEN (LUNO, INDO, VOL, NAME, .TRUE., .FALSE., .TRUE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN SC DIVIDED FILE FOR OUTPUT'
         GO TO 990
         END IF
      LUNM = LUNTMP (0)
      CALL ZPHFIL ('UV', DISK2, CNOIN2, 1, NAME, IRET)
      CALL ZOPEN (LUNM, INDM, VOL, NAME, .TRUE., .FALSE., .TRUE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN MODEL FILE FOR INPUT'
         GO TO 990
         END IF
      LENBO = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LREC, LENBO, JBUFSZ,
     *   BUFF2, BO, BINDO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT I/O FOR OUTPUT DIVIDED VIS'
         GO TO 990
         END IF
      IPTRO = BINDO
      LENBI = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, LENBI, JBUFSZ,
     *   BUFF1, BO, BINDI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT I/O FOR INPUT VIS DATA'
         GO TO 990
         END IF
      MNCS = CATMOD(KINAX)
      MNCF = CATMOD(KINAX+1) * MNCS
      MNCIF = CATMOD(KINAX+2) * MNCF
      LRECM = CATMOD(KINAX+3) * MNCIF + NRPM
      LENBM = 0
      I = CATMOD(KIGCN)
      CALL UVINIT ('READ', LUNM, INDM, I, VO, LRECM, LENBM, JBUFSZ,
     *   BUFF3, BO, BINDI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT I/O FOR INPUT MODEL DATA'
         GO TO 990
         END IF
      CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, BINDI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FIRST READ INPUT VIS DATA'
         GO TO 990
         END IF
      ICNTI = 1
      ICNTO = 1
      CALL UVDISK ('READ', LUNM, INDM, BUFF3, MNIO, BINDM, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FIRST READ INPUT MODEL DATA'
         GO TO 990
         END IF
      MPTR = 1
      IPTRI = BINDI
      IPTRO = BINDO
      IPTRM = BINDM
      magic = buff1(bindi+3)
C                                       Loop
 100  CALL RCOPY (NRPI, BUFF1(IPTRI), BUFF2(IPTRO))
      IF (buff2(bindo+3).ne.magic) THEN
         MSGTXT = 'WE ARE HERE'
         END IF
      IF (ILOCB.GE.0) THEN
         IA1 = BUFF1(IPTRI+ILOCB) / 256. + 0.1
         IA2 = BUFF1(IPTRI+ILOCB) - IA1*256. + 0.1
      ELSE
         IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
         IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
         END IF
      TIME = BUFF1(IPTRI+ILOCT)
      NRECI = NRECI + 1
C                                       find in model buffer
 110  IF (MLOCB.GE.0) THEN
         MA1 = BUFF3(IPTRM+MLOCB) / 256. + 0.1
         MA2 = BUFF3(IPTRM+MLOCB) - MA1*256. + 0.1
      ELSE
         MA1 = BUFF3(IPTRM+MLOCA1) + 0.1
         MA2 = BUFF3(IPTRM+MLOCA2) + 0.1
         END IF
      MIME = BUFF3(IPTRM+MLOCT)
      IF ((MA1.NE.IA1) .OR. (MA2.NE.IA2) .OR. (ABS(TIME-MIME).GT.1.E-8))
     *   THEN
         NFAIL = NFAIL + 1
         MPTR = MPTR + 1
         IPTRM = IPTRM + LRECM
         IF (MPTR.GT.MNIO) THEN
            MPTR = 1
            CALL UVDISK ('READ', LUNM, INDM, BUFF3, MNIO, BINDM, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'LATER READ INPUT MODEL DATA'
               GO TO 990
               END IF
            IF (MNIO.LE.0) THEN
               WRITE (MSGTXT,1110) NFAIL
               CALL MSGWRT (8)
               MSGTXT = 'WE HAVE RUN OUT OF MODEL WITH DATA LEFT'
               IRET = 10
               GO TO 990
               END IF
            IPTRM = BINDM
            END IF
         GO TO 110
         END IF
C                                       they match, apply
      DO 140 LIF = 1,NIF
         FACT = SCALE(LIF)
         DO 130 LF = 1,NF
            DO 120 LS = 1,NS
               IX = (LS-1) * INCS + (LF-1) * INCF + (LIF-1) * INCIF +
     *            IPTRI + NRPI
               LX = (LS-1) * INCS + (LF-1) * INCF + (LIF-1) * INCIF +
     *            IPTRO + NRPI
               MX = (LS-1) * MNCS + (LF+BCHAN-2)*MNCF + (LIF-1)*MNCIF
     *            + IPTRM + NRPM
               MRE = BUFF3(MX) * FACT
               MIM = BUFF3(MX+1) * FACT
               AMP = MRE*MRE + MIM*MIM
               IF (BUFF3(MX+2).LE.0.0) AMP = 0.0
               RATRE = 0.0
               RATIM = 0.0
               WT = 0.0
               IF (AMP.GT.1.E-20) THEN
                  AMP = 1.0 / AMP
                  RATRE = AMP * (BUFF1(IX) * MRE + BUFF1(IX+1) * MIM)
                  RATIM = AMP * (BUFF1(IX+1) * MRE - BUFF1(IX) * MIM)
                  WT = BUFF1(IX+2) / AMP
               END IF
               BUFF2(LX) = RATRE
               BUFF2(LX+1) = RATIM
               BUFF2(LX+2) = WT
 120           CONTINUE
 130        CONTINUE
 140     CONTINUE
C                                       advance counters
      ICNTI = ICNTI + 1
      ICNTO = ICNTO + 1
      IPTRI = IPTRI + LREC
      IPTRO = IPTRO + LREC
      IF (ICNTO.GT.LENBO) THEN
         CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, ICNTO-1, BINDO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'LATER WRIT OUTPUT DIVIDED DATA'
            GO TO 990
         END IF
         IPTRO = BINDO
         ICNTO = 1
         END IF
      IF (ICNTI.GT.INIO) THEN
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, BINDI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'LATER READ INPUT VIS DATA'
            GO TO 990
            END IF
         IF (INIO.LE.0) GO TO 200
         ICNTI = 1
         IPTRI = BINDI
         magic = buff1(bindi+3)
         END IF
      MPTR = MPTR + 1
      IPTRM = IPTRM + LRECM
      IF (MPTR.GT.MNIO) THEN
         MPTR = 1
         CALL UVDISK ('READ', LUNM, INDM, BUFF3, MNIO, BINDM, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET,
     *         'MISSED SAMPLE READ INPUT MODEL DATA'
            GO TO 990
            END IF
         IF (MNIO.LE.0) THEN
            WRITE (MSGTXT,1110) NFAIL
            CALL MSGWRT (8)
            MSGTXT = 'WE HAVE RUN OUT OF MODEL WITH DATA LEFT'
            IRET = 10
            GO TO 990
            END IF
         IPTRM = BINDM
         END IF
      GO TO 100
C                                       DONE
 200  CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, ICNTO-1, BINDO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FLUSH OUTPUT DIVIDED DATA'
         GO TO 990
         END IF
      CALL ZCLOSE (LUNI, INDI, I)
      CALL ZCLOSE (LUNO, INDO, I)
      CALL ZCLOSE (LUNM, INDM, I)
      IF (NFAIL.GT.0) THEN
         WRITE (MSGTXT,1110) NFAIL
      ELSE
         MSGTXT = 'Model samples and input vis file align perfectly'
         END IF
      CALL MSGWRT (5)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVMODL: EEROR',I4,' ON ',A)
 1001 FORMAT ('# VIS IN MODEL',I10,' LESS THAN DATA',I10)
 1110 FORMAT ('Number of model samples not in input vis file',I10)
      END
      SUBROUTINE HIGET (DISK, CNO, MODFLX, IRET)
C-----------------------------------------------------------------------
C   HIGET tries to get the frequencies from the history file
C   Inputs:
C      DISK     I   Disk number
C      CNO      I   Catalog number
C   Output
C      MODFLX   R   model flux
C      IRET     I   Error code
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, IRET
      REAL      MODFLX
C
      INTEGER   IHLUN, NREC, IHPTR, HIBUFF(256), IBLK, ICARD, ICUR,
     *   IHIND, II, LUNTMP
      HOLLERITH HHBUFF(256)
      CHARACTER LINE*72
      DOUBLE PRECISION X
      EQUIVALENCE (HIBUFF, HHBUFF)
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      MODFLX = 0.0
C                                       open history file
      IHLUN = LUNTMP (1)
C                                       Open history file.
      CALL HIINIT (3)
      CALL HIOPEN (IHLUN, DISK, CNO, HIBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL HILOCT ('SRCH', IHLUN, IHPTR, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       Determine no. of hist. recs.
      NREC = HITAB(IHPTR+2)
      IHIND = HITAB(IHPTR+1)
      IBLK = 0
      ICARD = NHILPR
      DO 20 ICUR = 1,NREC
C                                       Read next buffer.
         ICARD = ICARD + 1
         IF (ICARD.GT.NHILPR) THEN
            IBLK = IBLK + 1
            ICARD = 1
            CALL ZFIO ('READ', IHLUN, IHIND, IBLK, HIBUFF, IRET)
            IF (IRET.NE.0) GO TO 100
            END IF
C                                       desired task?
         II = (ICARD-1) * NHIWPL + 5
         CALL H2CHR (72, 1, HHBUFF(II), LINE)
         IF (LINE(:12).EQ.'UVSUB FACMOD') THEN
            READ (LINE,1000) X
            MODFLX = X
            END IF
 20      CONTINUE
      WRITE (MSGTXT,1001) MODFLX
      CALL MSGWRT (3)
C                                       Close history file.
 100  CALL HICLOS (IHLUN, .FALSE., HIBUFF, II)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (15X,F10.5)
 1001 FORMAT ('Found in UVSUB history model flux',F10.5,' Jy')
      END
      SUBROUTINE CLBDIV (IRET)
C-----------------------------------------------------------------------
C   CLBDIV divides multisource data in a scratch file  by the
C   calibrator flux densities given in the source table; if 0, 1.0 is
C   used.  If all calibrator flux densities are 1.0 then no operation
C   is performed.
C   Input from common:
C    NSOUWD        I    Number of sources included or excluded; if
C                       0 all sources are included.
C    DOSWNT        L    If .TRUE. then sources in SOUWAN are included
C                       If .FALSE. then excluded.
C    SOUWAN(30)    I    The source numbers of sources included or
C                       excluded.
C    DISKIN        I    Disk number of the input multisource data file
C                       whose SU table is to be used.
C    CNOIN         I    Catalog slot number for SU file.
C    VISCNO        I    /CFILES/ number of the scratch file
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C   Note: also uses buffers, BUFF1, BUFF2, UBUFF, NXBUFF
C   Note: assumes that IF  is the most slowly variable axis.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4
      INTEGER   INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, LENVIS, BO,
     *   ILENBU, KBIND, IBIND, I, J, IVIS, IOFF, NOVIS, VO, ISURNO,
     *   SUKOLS(MAXSUC), SUNUMV(MAXSUC), IDSOU, QUAL, SULUN, IFNO, INDX,
     *   NVPIF, NUMSOU, LOOP, SUFQID, NUMSTK, ISTKNO
      LOGICAL   T, F, DOIT
      REAL      XSFLUX, RRFLUX(32768), LLFLUX(32768), RLFLUX(32768),
     *   LRFLUX(32768), PFLUX(32768,4)
      CHARACTER IFILE*48
      DOUBLE PRECISION BANDW, RAEPO, DECEPO, EPOCH, RAAPP, DECAPP,
     *   PMRA, PMDEC, RAOBS, DECOBS
      INCLUDE 'CALIB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DSEL.INC'
      DOUBLE PRECISION LSRVEL(MAXIF), RESTFQ(MAXIF), FREQO(MAXIF)
      REAL     FLUX(4,MAXIF)
      EQUIVALENCE (PFLUX(1,1), RRFLUX), (PFLUX(1,2), LLFLUX)
      EQUIVALENCE (PFLUX(1,3), RLFLUX), (PFLUX(1,4), LRFLUX)
      DATA SULUN, LUNI, LUNO /27, 16,17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IF (SOUWAN(1).LE.0) SOUWAN(1) = 1
C                                       Message
      MSGTXT = 'Dividing data by source flux densities'
      CALL MSGWRT (2)
C                                       UVGET forces: complex, stokes
C                                       freq, IF axis order
      LENVIS = CATBLK(KINAX)
      NUMSTK = CATBLK(KINAX+1)
C                                       Open source (SU) table
      CALL SOUINI ('READ', NXBUFF, DISKIN, CNOIN, 1, CATUV,
     *   SULUN, NUMIF, VELTYP, VELDEF, SUFQID, ISURNO, SUKOLS, SUNUMV,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Get number of sources
      NUMSOU = NXBUFF(5)
C                                       Read flux array
      DOIT = F
      DO 30 LOOP = 1,NUMSOU
         ISURNO = LOOP
         CALL TABSOU ('READ', NXBUFF, ISURNO, SUKOLS, SUNUMV,
     *      IDSOU, SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO,
     *      DECEPO, EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ,
     *      PMRA, PMDEC, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET
            GO TO 990
            END IF
C                                       Get flux densities
         INDX = (IDSOU-1) * NUMIF
         DO 25 I = 1,NUMIF
            IF (FLUX(1,I).LE.1.0E-10) FLUX(1,I) = 1.0
            DOIT = DOIT .OR. (ABS (FLUX(1,I)-1.0).GT.1.0E-10)
            IF (FLUX(1,I).NE.FLUX(4,I)) THEN
               RRFLUX(INDX+I) = 1.0 / (FLUX(1,I) + FLUX(4,I))
               LLFLUX(INDX+I) = 1.0 / (FLUX(1,I) - FLUX(4,I))
            ELSE
               RRFLUX(INDX+I) = 1.0 / FLUX(1,I)
               LLFLUX(INDX+I) = 1.0 / FLUX(1,I)
               WRITE (MSGTXT,1025) LOOP, I
               CALL MSGWRT (8)
               END IF
            RLFLUX(INDX+I) = 1.0 / FLUX(1,I)
            LRFLUX(INDX+I) = 1.0 / FLUX(1,I)
 25         CONTINUE
 30      CONTINUE
C                                       Close table
      CALL TABIO ('CLOS', 0, ISURNO, BUFF1, NXBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
C                                       Check if work to be done.
      IF (.NOT.DOIT) GO TO 999
C                                       Do divisions
      NOVIS = (LREC - NRPARM) / LENVIS
      NVPIF = NOVIS / NUMIF
      IF (NVPIF.LT.1) NVPIF = 1
C                                       Open and init for write
C                                       visibility file
      CALL ZPHFIL ('SC', SCRVOL(VISCNO), SCRCNO(VISCNO), 1, IFILE, IRET)
      CALL ZOPEN (LUNO, INDO, SCRVOL(VISCNO), IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1040) IRET, 'WRIT'
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IPTRO = KBIND
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1050) IRET, 'WRIT'
         GO TO 990
         END IF
C                                       Open and init for read
C                                       visibility file
      CALL ZOPEN (LUNI, INDI, SCRVOL(VISCNO), IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1040) IRET, 'READ'
         GO TO 990
         END IF
C                                       Init vis file for read
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1050) IRET, 'READ'
         GO TO 990
         END IF
C                                       Loop
C                                       Read vis. record.
 100  CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET, 'READ'
            GO TO 990
            END IF
         IPTRI = IBIND
         IF (INIO.LE.0) GO TO 200
C                                       loop thru buffer full
         DO 180 I = 1,INIO
            DO 120 J = 1,LREC
               BUFF2(IPTRO+J-1) = BUFF1(IPTRI+J-1)
 120           CONTINUE
C                                       Trap single source
            IDSOU = SOUWAN(1)
            IF (ILOCSU.GE.0) IDSOU = BUFF2(IPTRO+ILOCSU) + 0.5
            IOFF = NRPARM
C                                       This assumes that IF is axis 4 as
C                                       is forced by UVGET
            DO 140 IVIS = 1,NOVIS
               ISTKNO = MOD (IVIS-1, NUMSTK) + 1
               IFNO = ((IVIS-1) / NVPIF) + 1
               INDX = (IDSOU-1) * NUMIF + IFNO
               XSFLUX = PFLUX(INDX,ISTKNO)
               BUFF2(IPTRO+IOFF) = BUFF2(IPTRO+IOFF) * XSFLUX
               BUFF2(IPTRO+IOFF+1) = BUFF2(IPTRO+IOFF+1) * XSFLUX
               IOFF = IOFF + LENVIS
 140           CONTINUE
            IPTRI = IPTRI + LREC
            IPTRO = IPTRO + LREC
 180        CONTINUE
C                                       Write vis. record.
         CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, INIO, KBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET, 'WRIT'
            GO TO 990
            END IF
         IPTRO = KBIND
         GO TO 100
C                                       Done
C                                       Flush buffer
 200  INIO = 0
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, INIO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) IRET, 'FLSH'
         GO TO 990
         END IF
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1210) IRET, 'READ'
         GO TO 990
         END IF
      CALL ZCLOSE (LUNO, INDO, IRET)
      IF (IRET.EQ.0) GO TO 999
         WRITE (MSGTXT,1210) IRET, 'WRIT'
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLBDIV: ERROR',I3,' OPENING SOURCE TABLE')
 1010 FORMAT ('CLBDIV: ERROR',I3,' READING SOURCE TABLE')
 1025 FORMAT ('CLBDIV IGNORING EQUAL I AND V FLUX: SOURCE',I4,' IF',I3)
 1030 FORMAT ('CLBDIV: ERROR',I3,' CLOSING SOURCE TABLE')
 1040 FORMAT ('CLBDIV: ERROR',I3,' OPEN-FOR-',A4,' VIS FILE')
 1050 FORMAT ('CLBDIV: ERROR',I3,' INIT-FOR-',A4,' VIS FILE')
 1100 FORMAT ('CLBDIV: ERROR',I3,1X,A4,'ING VIS FILE')
 1210 FORMAT ('CLBDIV: ERROR',I3,'CLOSING ',A4,' VIS FILE')
      END
      SUBROUTINE CLBLIN (IRET)
C-----------------------------------------------------------------------
C   CLBLIN is CLBDIV for linear feeds - it divides by total flux
C   corrected by source Q and U modified by parallactic angle.
C   It is assumed that any source in the input CALSEL scratch file is
C   a calibrator. GETANT and GETSOU are used together with PARANG.
C   Output:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'CALIB.INC'
      INTEGER   LSOU, LSUB, ISUB, IA1, IA2, ISOU, LENVIS, NUMSTK, I, J,
     *   NOVIS, NVPIF, LUNI, LUNO, INDI, INDO, TALUN(1), VO, BO, ILENBU,
     *   KBIND, IBIND, IPTRO, INIO, TABUFF(512), IFNO, IPTRI, IOFF,
     *   IVIS
      REAL      LTIME, TIME, PANGLE(MAXANT), PCOS, PSIN, PMUL0, PM,
     *   TEPS, XSFLUX
      CHARACTER IFILE*48
      LOGICAL   T, F
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      EQUIVALENCE (CATBLK, CATD)
      DATA T, F /.TRUE., .FALSE./
      DATA LSOU, LSUB, LTIME /-1, -1, -1.0/
      DATA LUNI, LUNO, TALUN /16, 17, 26/
      DATA VO, BO /0, 1/
      DATA TEPS /1.157E-5/
C-----------------------------------------------------------------------
C                                       message
      MSGTXT = 'Dividing data by source polarized flux densities'
      CALL MSGWRT (2)
C                                       UVGET forces: complex, stokes
C                                       freq, IF axis order
      LENVIS = CATBLK(KINAX)
      NUMSTK = CATBLK(KINAX+1)
      NUMIF  = CATBLK(KINAX+3)
      PMUL0 = 1.0
      IF (CATD(KDCRV+1).EQ.-6.0D0) PMUL0 = -1.0
C                                       Do divisions
      NOVIS = (LREC - NRPARM) / LENVIS
      NVPIF = NOVIS / NUMIF
      IF (NVPIF.LT.1) NVPIF = 1
C                                       Open and init for write
C                                       visibility file
      CALL ZPHFIL ('SC', SCRVOL(VISCNO), SCRCNO(VISCNO), 1, IFILE, IRET)
      CALL ZOPEN (LUNO, INDO, SCRVOL(VISCNO), IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN FOR WRITE'
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IPTRO = KBIND
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT FOR WRIT'
         GO TO 990
         END IF
C                                       Open and init for read
C                                       visibility file
      CALL ZOPEN (LUNI, INDI, SCRVOL(VISCNO), IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN FOR READ'
         GO TO 990
         END IF
C                                       Init vis file for read
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT FOR READ'
         GO TO 990
         END IF
C                                       Loop
C                                       Read vis. record.
 100  CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING DATA'
            GO TO 990
            END IF
         IPTRI = IBIND
         IF (INIO.LE.0) GO TO 200
C                                       loop thru buffer full
         DO 180 I = 1,INIO
            DO 120 J = 1,LREC
               BUFF2(IPTRO+J-1) = BUFF1(IPTRI+J-1)
 120           CONTINUE
C                                       check source subarray time
            IF (ILOCB.GE.0) THEN
               IA1 = BUFF1(IPTRI+ILOCB) / 256. + 0.1
               IA2 = BUFF1(IPTRI+ILOCB) - IA1*256. + 0.1
               ISUB = 100.0 * (BUFF1(IPTRI+ILOCB) - IA1*256 - IA2)+1.5
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               ISUB = BUFF1(IPTRI+ILOCSA) + 0.1
               END IF
            ISOU = SOUWAN(1)
            IF (ILOCSU.GE.0) ISOU = BUFF2(IPTRO+ILOCSU) + 0.5
            TIME = BUFF2(IPTRO+ILOCT)
            IF (ISUB.NE.LSUB) THEN
               CALL GETANT (DISKIN, CNOIN, ISUB, CATUV, TABUFF, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'READING ANTENNA INFO', ISUB
                  GO TO 990
                  END IF
               LSUB = ISUB
               LTIME = -1.0
               END IF
            IF (ISOU.NE.LSOU) THEN
               CALL GETSOU (ISOU, DISKIN, CNOIN, CATUV, TALUN, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'READING SOURCE INFO', ISOU
                  GO TO 990
                  END IF
               LSOU = ISOU
               LTIME = -1.0
               END IF
           IF (TIME-LTIME.GE.TEPS) THEN
              CALL PARANG (TIME, PANGLE)
              LTIME = TIME
              END IF
            IOFF = NRPARM
C                                       This assumes that IF is axis 4 as
C                                       is forced by UVGET
            PCOS = COS (PANGLE(IA1) + PANGLE(IA2))
            PSIN = SIN (PANGLE(IA1) + PANGLE(IA2))
            PM = PMUL0
            DO 140 IVIS = 1,NOVIS
               IFNO = ((IVIS-1) / NVPIF) + 1
               XSFLUX = FLUX(1,IFNO) + PM * (FLUX(2,IFNO)*PCOS +
     *            FLUX(3,IFNO)*PSIN)
               IF (XSFLUX.EQ.0.0)  XSFLUX= 1.0
               BUFF2(IPTRO+IOFF) = BUFF2(IPTRO+IOFF) / XSFLUX
               BUFF2(IPTRO+IOFF+1) = BUFF2(IPTRO+IOFF+1) / XSFLUX
               IOFF = IOFF + LENVIS
               IF (NUMSTK.EQ.2) PM = -PM
 140           CONTINUE
            IPTRI = IPTRI + LREC
            IPTRO = IPTRO + LREC
 180        CONTINUE
C                                       Write vis. record.
         CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, INIO, KBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'RE-WRITING DATA'
            GO TO 990
            END IF
         IPTRO = KBIND
         GO TO 100
C                                       Done
C                                       Flush buffer
 200  INIO = 0
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, INIO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FLUSHG OUTPUT BUFFER'
         GO TO 990
         END IF
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING READ'
         GO TO 990
         END IF
      CALL ZCLOSE (LUNO, INDO, IRET)
      IF (IRET.EQ.0) GO TO 999
         WRITE (MSGTXT,1000) IRET, 'CLOSING WRITE'
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLBLIN: ERROR',I4,' ON ',A,I6)
      END
      SUBROUTINE CLBHIS
C-----------------------------------------------------------------------
C   CLBHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP(7)*2, CTIME(2)*12, HILINE*72, WTCOD(4)*4
      INTEGER   LUN1, LUN2, LIMIT, LIMIT2, IERR, ITEMP, I, J, TIME(3),
     *   DATE(3), NONOT, I1, I2, SOLSUB, SOLMIN, MHIST, MH1, MH2, IROUND
      LOGICAL   T, ONEWTT
      COMMON /SOLCOM/ SOLSUB, SOLMIN
      INCLUDE 'CALIB.INC'
      INCLUDE 'CALFLAG'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA WTCOD /'1.00', '0.50', '0.25', '0.0'/
      DATA NONOT, NOTTYP /7,'SN','NX','CL','CH','BP','FQ','BL'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
      MH1 = 1
      MH2 = 2
      IF ((SINGLE) .AND. (DOMODL) .AND. (APPLY.GE.0.0)) THEN
         IF (DOHIST.LT.0.0) MH2 = 1
      ELSE
         MH1 = 2
         END IF
      DO 200 MHIST = MH1,MH2
C                                       Copy/open history file.
         IF (MHIST.EQ.1) THEN
            CALL HISCOP (LUN1, LUN2, DISKIN, DISOUT, CNOIN, CNOOUT,
     *         CATBLK, BUFF1, IBUFF2, IERR)
            IF (IERR.GT.2) THEN
               WRITE (MSGTXT,1100) IERR
               CALL MSGWRT (6)
               GO TO 190
               END IF
C                                       New history
            CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISOUT, LUN2,
     *         IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
C                                       Multisource - open old history
         ELSE
            CALL HIOPEN (LUN2, DISKIN, CNOIN, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
C                                       Task message
            CALL ZDATE (DATE)
            CALL ZTIME (TIME)
            CALL TIMDAT (TIME, DATE, CTIME(2), CTIME)
            WRITE (HILINE,1000) TSKNAM, RLSNAM, CTIME
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            END IF
         CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2,
     *      IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       calibration data
         CALL CALHIS (LUN2, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       General information
C                                       Write control info.
C                                       Write CC tables if used
         IF ((DOMODL) .AND. (SMODEL(1).LE.0.0) .AND.
     *      ((NAME2.NE.' ') .OR. (CLAS2.NE.' '))) THEN
C                                       CC File Name etc.
            CALL HENCO2 (TSKNAM, NAME2, CLAS2, SEQ2, DISK2, LUN2,
     *         IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
C                                        CCfile version no.
            WRITE (HILINE,2001) TSKNAM, CCTVER
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
C                                        Number of images
            WRITE (HILINE,2002) TSKNAM, MFIELD
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
C                                       Number of CLEAN components.
            DO 130 I = 1,MFIELD
               WRITE (HILINE,2003) TSKNAM, I, NCOMP(I)
               CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
 130        CONTINUE
            END IF
C                                       Soln. interval.
         XSOLIN = SOLINT * 24.0 * 60.0
         IF (XSOLIN.GT.9999.99) XSOLIN = 9999.99
         WRITE (HILINE,2010) TSKNAM, XSOLIN
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       Soln. sub and min interval.
         IF (SOLMIN.NE.0 .OR. SOLSUB.NE.0) THEN
            WRITE (HILINE,2024) TSKNAM, SOLSUB
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            WRITE (HILINE,2026) TSKNAM, SOLMIN
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            END IF
C                                        Min. no. antennas
         WRITE (HILINE,2011) TSKNAM, MINNO
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                        Average RR,LL
         ITEMP = -1
         IF (AVGPOL) ITEMP = 1
         WRITE (HILINE,2013) TSKNAM, ITEMP
         IF (NCOR.GT.1) CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                        Average freq in IF
         ITEMP = -1
         IF (AVGIF) ITEMP = 1
         WRITE (HILINE,2015) TSKNAM, ITEMP
         IF (EIF.GT.BIF) CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                        SNR cutoff.
         WRITE (HILINE,2016) TSKNAM, SNRMIN
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       Pass failed solutions?
         IF (DOPASS) THEN
            WRITE (HILINE,2017) TSKNAM
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            END IF
C                                       Point source model
         IF (ABS (SMODEL(1)).GT.0.0) THEN
            WRITE (HILINE,2020) TSKNAM, SMODEL(1), SMODEL(2), SMODEL(3)
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
C                                       Other parameters
            WRITE (HILINE,2021) TSKNAM, SMODEL(4), SMODEL(5),
     *         SMODEL(6), SMODEL(7)
            IF (SMODEL(4).GT.0.01) CALL HIADD (LUN2, HILINE, IBUFF2,
     *         IERR)
            END IF
         IF (IERR.NE.0) GO TO 190
C                                        Already divided by model
         WRITE (HILINE,2022) TSKNAM
         IF (APARM(2).GT.0.0) CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       Solution type
         WRITE (HILINE,2030) TSKNAM, XSOLTY
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       Mode
         WRITE (HILINE,2031) TSKNAM, XSOLMO
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         ITEMP = MODE / 10
         IF (ITEMP.GE.0) THEN
            WRITE (HILINE,2032) TSKNAM, ITEMP, WTCOD(ITEMP+1)
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            END IF
C                                       Normalize gain?
         ITEMP = -1
         IF (DOMGM.GT.1) ITEMP = DOMGM-1
         WRITE (HILINE,2033) TSKNAM, ITEMP
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       Scalar average
         IF (CPARM(5).GT.0.0) THEN
            I = MIN (MAX (1.0, CPARM(5)+0.5), 2.0) + 0.01
            IF (I.EQ.1) THEN
               WRITE (HILINE,3033) TSKNAM, I
            ELSE
               WRITE (HILINE,3034) TSKNAM, I
               END IF
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            END IF
C                                       Robust soln limit
         IF (CPARM(6).GT.2.0) THEN
            WRITE (HILINE,3035) TSKNAM, CPARM(6)
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            END IF
         WRITE (HILINE,3036) TSKNAM, CPARM(7)
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       input docal, gainuse
         IF (XDOCAL.GT.0.0) THEN
            I = XGUSE + 0.1
            IF (I.LE.0) CALL FNDEXT ('CL', CATUV, I)
            WRITE (HILINE,2063) TSKNAM, I
         ELSE
            HILINE = TSKNAM // '/ No calibration applied to input file'
            END IF
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       Output SN table
         WRITE (HILINE,2062) TSKNAM, SNVER
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       Ref antenna
         WRITE (HILINE,2064) TSKNAM, REFANT
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       fit only
         DO 140 I = 1,30
            J = IROUND (XDOFIT(I))
            IF (J.NE.0) GO TO 145
 140        CONTINUE
         GO TO 155
 145     DO 150 I = 1,30
            J = IROUND (XDOFIT(I))
            WRITE (HILINE,2065) TSKNAM, I, J
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
 150        CONTINUE
C                                       Gain constraint factor
 155     IF (DOGCON) THEN
            WRITE (HILINE,2034) TSKNAM, CONFAC
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            END IF
C                                        Full weight annulus
         WRITE (HILINE,2035) TSKNAM, MNPABL, MXPABL
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                        If ants outside annulus used
         IF (WTPABL.GT.0.0) THEN
            WRITE (HILINE,2037) TSKNAM, WTPABL
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            END IF
C                                       Antennas
         IF (NANTSL.LE.0) THEN
            WRITE (HILINE,2038) TSKNAM
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
         ELSE
C                                       Included or excluded?
            WRITE (HILINE,2039) TSKNAM
            IF (DOAWNT) WRITE (HILINE,2040) TSKNAM
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
C                                       1st 12 and label.
            LIMIT = MIN (12, NANTSL)
            WRITE (HILINE,2041) TSKNAM, (ANTENS(J),J=1,LIMIT)
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            IF (NANTSL.GT.12) THEN
C                                       Rest of antennas
               DO 180 I = 13,NANTSL,12
                  LIMIT = I
                  LIMIT2 = I + 11
                  LIMIT2 = MIN (NANTSL, LIMIT2)
                  WRITE (HILINE,2042) TSKNAM, (ANTENS(J),J=LIMIT,LIMIT2)
                  CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
                  IF (IERR.NE.0) GO TO 190
 180              CONTINUE
               END IF
            END IF
C
         IF (DOMGM.GT.1) THEN
            IF (ALZERO) THEN
               WRITE (HILINE,2044) TSKNAM
               CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
            ELSE
               WRITE (HILINE,2046) TSKNAM
               CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
               LIMIT = MIN (15, NUSE)
               WRITE (HILINE,2048) TSKNAM, (LSTUSE(I), I=1,LIMIT)
               CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
               IF (NUSE.GT.15) THEN
C                                       Rest of antennas
                  DO 181 I = 16,NUSE,15
                     LIMIT = I
                     LIMIT2 = I + 14
                     LIMIT2 = MIN (NUSE, LIMIT2)
                     WRITE (HILINE,2048) TSKNAM, (LSTUSE(J),
     *                  J = LIMIT,LIMIT2)
                     CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
                     IF (IERR.NE.0) GO TO 190
  181                CONTINUE
                  END IF
               END IF
C                                       Minimum elevation for the
C                                       gain normalization.
            WRITE (HILINE,2049) TSKNAM, GMINEL
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            END IF
C                                        Antenna weights.
C                                        Are they all the same?
         ONEWTT = .TRUE.
          DO 182 I = 2,NANT
            IF (ANTWT(1).NE.ANTWT(I)) ONEWTT = .FALSE.
 182        CONTINUE
C                                        All ants have same weight
         IF (ONEWTT) THEN
            WRITE (HILINE,2052) TSKNAM, ANTWT(1)
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         ELSE
C                                        Else have different weights
            LIMIT2 = MIN(9, NANT)
            WRITE (HILINE,2050) TSKNAM, (ANTWT(I), I = 1,LIMIT2)
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
C                                        for rest of antennas
            DO 184 J = 2,4
               LIMIT  = 1 + (J*9)
               LIMIT2 = MIN( 9*J, NANT)
C                                       If not out of antennas
               IF (LIMIT.LE.LIMIT2) THEN
                  WRITE (HILINE,2051) TSKNAM, (ANTWT(I),I=LIMIT,LIMIT2)
                  CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
                  END IF
 184           CONTINUE
            END IF
         IF (IERR.NE.0) GO TO 190
C                                        GAINERR
         IF ((DOGCON) .AND. ((MOD(MODE,10).EQ.3) .OR.
     *      (MOD(MODE,10).EQ.7))) THEN
            I1 = 1
 185        I2 = I1 + 8
            I2 = MIN (I2, NANT)
            IF (I2.GE.I1) THEN
               IF (I1.EQ.1) THEN
                  WRITE (HILINE,2060) TSKNAM, (GAERR(I), I = I1,I2)
               ELSE
                  WRITE (HILINE,2061) TSKNAM, (GAERR(I), I = I1,I2)
                  END IF
               CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
               I1 = I2 + 1
               GO TO 185
               END IF
            END IF
         IF ((LBCHAN.GT.1) .OR. (LECHAN.GT.LBCHAN)) THEN
            DO 187 I = BIF,EIF
               DO 186 J = 1,20
                  IF (CHNSEL(1,J,I).GT.0) THEN
                     CHNSEL(1,J,I) = CHNSEL(1,J,I) + LBCHAN - 1
                     CHNSEL(2,J,I) = CHNSEL(2,J,I) + LBCHAN - 1
                     WRITE (HILINE,2185) TSKNAM, J, I, CHNSEL(1,J,I),
     *                  CHNSEL(2,J,I), CHNSEL(3,J,I)
                     CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
                     IF (IERR.NE.0) GO TO 190
                     END IF
 186              CONTINUE
 187           CONTINUE
            END IF

C                                       Add solution summary.
C                                       If not all zero
         IF (TOTREC(1,1).NE.0 .OR. TOTREC(1,2).NE.0 .OR.
     *       TOTREC(1,3).NE.0 .OR. TOTREC(2,1).NE.0 .OR.
     *         TOTREC(2,2).NE.0 .OR. TOTREC(2,3).NE.0) THEN
            WRITE (HILINE, 3200) TSKNAM
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            WRITE (HILINE, 3201) TSKNAM, (TOTREC (1,I), I = 1,3)
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            WRITE (HILINE, 3202) TSKNAM, (TOTREC (2,I), I = 1,3)
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
C                                       End if summary data present
            END IF
C
         IF (CNTOK.LE.0) THEN
C                                       Nothing worked
            WRITE (HILINE,3210) TSKNAM
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
         ELSE
            WRITE (HILINE,3220) TSKNAM, CNTOK
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            IF (CNTBAD.GT.0) THEN
               WRITE (HILINE,3221) TSKNAM, CNTBAD
               CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
            END IF
            IF (CNTFEW.GT.0) THEN
               WRITE (HILINE,3222) TSKNAM, CNTFEW
               CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
               END IF
            IF (CNTSAD.GT.0) THEN
               WRITE (HILINE,3223) TSKNAM, CNTSAD
               CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
               END IF
            END IF
C                                       flags
         IF (FLAGIT) THEN
            WRITE (HILINE,3300) TSKNAM, FGVERO
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            WRITE (HILINE,3301) TSKNAM, NFLAGD
            CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
            END IF
C                                       Close HI file
 190     CALL HICLOS (LUN2, T, IBUFF2, IERR)
 200     CONTINUE
C                                       a little for old HI file
      IF (MH2.EQ.1) THEN
         CALL HIOPEN (LUN2, DISKIN, CNOIN, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 210
C                                       Task message
         CALL ZDATE (DATE)
         CALL ZTIME (TIME)
         CALL TIMDAT (TIME, DATE, CTIME(2), CTIME)
         WRITE (HILINE,1000) TSKNAM, RLSNAM, CTIME
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 210
         CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2,
     *      IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 210
         CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISOUT, LUN2,
     *      IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 210
C                                       input docal, gainuse
         IF (XDOCAL.GT.0.0) THEN
            I = XGUSE + 0.1
            IF (I.LE.0) CALL FNDEXT ('CL', CATUV, I)
            WRITE (HILINE,2063) TSKNAM, I
         ELSE
            HILINE = TSKNAM // '/ No calibration applied to input file'
            END IF
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 210
C                                       Output SN table
         WRITE (HILINE,2062) TSKNAM, SNVER
         CALL HIADD (LUN2, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 210
 210     CALL HICLOS (LUN2, T, IBUFF2, IERR)
         END IF
C                                        Copy tables.
      IF (MH1.EQ.1) THEN
         CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISOUT,
     *      CNOIN, CNOOUT, CATBLK, BUFF1, IBUFF2, IERR)
         IF (IERR.GT.2) THEN
            WRITE (MSGTXT,1190)
            CALL MSGWRT (6)
            END IF
C                                        Update CATBLK.
         CALL CATIO ('UPDT', DISOUT, CNOOUT, CATBLK, 'REST', SCRTCH,
     *      IERR)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE   =''',A7,' ''  /******* Start ',A12,2X,A8)
 1100 FORMAT ('CLBHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1190 FORMAT ('CLBHIS: ERROR COPYING TABLES')
 2001 FORMAT (A6,'INVER    =',I5,' /CC file version no.')
 2002 FORMAT (A6,'NMAPS    =',I5,' /Number of clean images used')
 2003 FORMAT (A6,'NCOMP(',I2,')=',I8,' /Number of clean comps.')
 2010 FORMAT (A6,'SOLINT   =',F8.2,' /Soln. inter. (min)')
 2011 FORMAT (A6,'APARM(1) =',I5,' /Min. no antennas')
 2013 FORMAT (A6,'APARM(3) =',I5,' />0 => avg. RR,LL')
 2015 FORMAT (A6,'APARM(5) =',I5,' />0 => average IFs')
 2016 FORMAT (A6,'APARM(7) =',F5.1,' /SNR cutoff')
 2017 FORMAT (A6,'APARM(9) =  1.0 /Pass failed solutions')
 2020 FORMAT (A6,'SMODEL   = ',2(F10.3,','),F10.3,
     *   ' /Pt. model parameters')
 2021 FORMAT (A6,'        ',4F10.3,' /Other parms.')
 2022 FORMAT (A6,'APARM(2) =    1 /Data already divided by model')
 2024 FORMAT (A6,'SOLSUB =',I5,' /Soln. subinterval')
 2026 FORMAT (A6,'SOLMIN =',I5,' /Minimum soln. int. (min)')
 2030 FORMAT (A6,'SOLTYPE  =''',A4,'''/Solution type')
 2031 FORMAT (A6,'SOLMODE  =''',A4,'''/Solution mode')
 2032 FORMAT (A6,'WEIGHTIT =',I2,' / fit wts = wt**',A)
 2033 FORMAT (A6,'NORMALIZ =',I5,' />=1 => Normalize gain')
 3033 FORMAT (A6,'CPARM(5) =',I5,' /1 => Scalar average in time only')
 3034 FORMAT (A6,'CPARM(5) =',I5,' /2 => Scalar average everything')
 3035 FORMAT (A6,'CPARM(6) =',F5.2,' /limit robust discards')
 3036 FORMAT (A6,'CPARM(7) =',F6.3,' /limit closure displays')
 2034 FORMAT (A6,'SOLCON   =   ',1PE10.3,' /Gain constraint factor')
 2035 FORMAT (A6,'UVRANGE  =   ',1PE10.3,',',1E10.3,
     *           ' /Min, Max Baseline')
 2037 FORMAT (A6,'WTUV     =   ',1PE10.3,' /Weight outside annulus')
 2038 FORMAT (A6,'ANTENNAS =    0 /All antennas selected')
 2039 FORMAT (A6,'/Antennas excluded:')
 2040 FORMAT (A6,'/Antennas included:')
 2041 FORMAT (A6,'ANTENNAS =',12(I3,' '))
 2042 FORMAT (A6,'          ',12(I3,' '))
 2044 FORMAT (A6,'ANTUSE = 0 /All antennas were used in the gain',
     *   ' normalization')
 2046 FORMAT (A6,'/The following antennas were used in the gain',
     *   ' normalization')
 2048 FORMAT (A6, 15I3)
 2049 FORMAT (A6,'/Minimum elevation for gain normalization:',F7.2 )
 2050 FORMAT (A6,'ANTWT  =',9F5.1,'/Ant. wt')
 2051 FORMAT (A6,'        ',9F5.1)
 2052 FORMAT (A6,'ANTWT    =',F5.1,' /Weight same for all Ant')
 2060 FORMAT (A6,'GAINERR=',9F5.2)
 2061 FORMAT (A6,'        ',9F5.2)
 2062 FORMAT (A6,'SNVER    =',I5,' /Output SN table version')
 2063 FORMAT (A6,'INGAINUSE=',I5,' /Input calibrated with CL table')
 2064 FORMAT (A6,'REFANT   =',I5,' /Reference antenna')
 2065 FORMAT (A6,'DOFIT(',I2.2,') =',I5,
     *   ' /Do or do not fit this antenna')
 2185 FORMAT (A6,'CHANSEL(,',I2,',',I2,') =',I5,',',I5,',',I2)
 3200 FORMAT (A6,'/SUMMARY: ','  Previously flagged ',
     *   '    Flagged by gain   ','   Kept')
 3201 FORMAT (A6,'/Partially ',2I20,I10)
 3202 FORMAT (A6,'/Fully     ',2I20,I10)
 3210 FORMAT (A6,'/No valid solutions found!')
 3220 FORMAT (A6,'/Found     ',I8,' good solutions')
 3221 FORMAT (A6,'/Failed on ',I8,' solutions')
 3222 FORMAT (A6,'/          ',I8,' solutions had insufficient data')
 3223 FORMAT (A6,'/          ',I8,' solutions had no data')
 3300 FORMAT (A6,'FLAGVERO =',I5,' /Output flag table version')
 3301 FORMAT (A6,'NFLAGD   =',I8,' /Number flags added to FG table')
      END
      SUBROUTINE CLBADJ (IRET)
C-----------------------------------------------------------------------
C   CLBADJ massages the solutions so that interpolation between points
C   is reasonable.
C   Output:
C   IRET   I     Return error code. 0 => OK, otherwise error.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER KEYS(18)*24
      HOLLERITH CATUVH(256)
      INTEGER   ANT, REF, KOLS(18), LUN, LOOP, NKEY, LKEY, IFLOOP,
     *   KEY(2,2), IPNT, IIVER, NIF, IERR, MXINDX, REFTMP, NUMSUB,
     *   LIMS1, LIMS2, LOOPSA, KEYSUB(2,2)
      LOGICAL   T, ISAPPL, DOIT
      INTEGER   ISNRNO, MXCNT, NUMROW, NWORDS
      LONGINT   OFFSET
      REAL      WORK(2), SMOTIM(3), FKEY(2,2)
      LOGICAL   NOTREF
      INCLUDE 'CALIB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      DOUBLE PRECISION FOFF(MAXIF), FREQIF
      EQUIVALENCE (CATUVH, CATUV)
      DATA NKEY, LKEY /9,24/
      DATA T /.TRUE./
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
      DATA KEYS /'ANTENNA NO.             ',
     *   'REFANT 1                ', 'SUBARRAY                ',
     *   'WEIGHT 1                ', 'TIME                    ',
     *   'REAL1                   ', 'IMAG1                   ',
     *   'DELAY 1                 ', 'RATE 1                  ',
     *   'ANTENNA NO.             ',
     *   'REFANT 2                ', 'SUBARRAY                ',
     *   'WEIGHT 2                ', 'TIME                    ',
     *   'REAL2                   ', 'IMAG2                   ',
     *   'DELAY 2                 ', 'RATE 2                  '/
C-----------------------------------------------------------------------
C                                       Initialize OFFSET; if OFFSET = 0
C                                       then workspace has not been
C                                       allocated
      OFFSET = 0
C                                       NOTREF indicates that some
C                                       antenna solutions were not
C                                       adjusted.
      NOTREF = .FALSE.
C                                       See if any work to be done.
      DOIT = .FALSE.
      MXCNT = 0
      DO 5 LOOP = 1,NUMANT
         DOIT = DOIT .OR. ((REFUSE(LOOP).GT.0) .AND. (LOOP.NE.REFANT))
         IF (REFUSE(LOOP).GT.MXCNT) MXINDX = LOOP
         IF (REFUSE(LOOP).GT.MXCNT) MXCNT = REFUSE(LOOP)
 5       CONTINUE
      IF (.NOT.DOIT) GO TO 999
C                                       Message
      WRITE (MSGTXT,2000)
      CALL MSGWRT (2)
C                                       If no REFANT specified pick the
C                                       one with the most solutions.
      REFTMP = REFANT
      IF (REFTMP.LE.0) REFTMP = MXINDX
      LUN = 29
C                                       Get IF frequencies
      FOFF(1) = 0.0
      IIVER = 1
      IF (EIF.GT.1)
     *   CALL CHNDAT ('READ', CLBUFF, DISKIN, CNOIN, IIVER, CATIN, LUN,
     *   NIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IERR)
C                                       Open solution table
      CALL SNINI ('READ', CLBUFF, DISKIN, CNOIN, SNVER, CATIN, LUN,
     *   ISNRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.GT.0) GO TO 990
C
      NUMROW = CLBUFF(5)
C                                       Set column pointers for sort
      CALL FNDCOL (NKEY, KEYS, LKEY, T, CLBUFF, KOLS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 980
         END IF
C                                       Close
      CALL TABIO ('CLOS', 0, ISNRNO, BUFF1, CLBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 980
         END IF
C                                       Allocate workspace for CALREF.
C                                       If each of the 5 scratch arrays
C                                       has NUMROW then CALREF is
C                                       guaranteed to have enough space
C                                       to re-refence the table. In most
C                                       cases this will be less than a
C                                       megabyte of data so the
C                                       allocation should rarely fail.
C                                       A single array is allocated and
C                                       divided up for the CALREF calls.
      NWORDS = (5 * NUMROW - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', 'CLBADJ', NWORDS, WORK, OFFSET, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'Could not allocate enough workspace to reference'
         CALL MSGWRT (6)
         MSGTXT = 'solutions to a common antenna. Solutions will not'
         CALL MSGWRT (6)
         MSGTXT = 'be adjusted. If this is not acceptable then either'
         CALL MSGWRT (6)
         MSGTXT = 'increase SOLINT or shutdown some applications and'
         CALL MSGWRT (6)
         MSGTXT = 'run CALIB again.'
         IRET = 0
         GO TO 999
         END IF
C                                       Sort to time-ant order.
      KEY(1,1) = KOLS(5)
      KEY(2,1) = KOLS(5)
      KEY(1,2) = KOLS(1)
      KEY(2,2) = KOLS(1)
      CALL TABSRT (DISKIN, CNOIN, 'SN', SNVER, SNVER, KEY, KEYSUB, FKEY,
     *   CLBUFF, CATIN, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 980
         END IF
C                                       Find number of subarrays
      CALL FNDEXT ('AN', CATUV, NUMSUB)
      NUMSUB = MAX (1, NUMSUB)
      LIMS1 = 1
      LIMS2 = NUMSUB
      IF (SUBARR.GT.0) LIMS1 = SUBARR
      IF (SUBARR.GT.0) LIMS2 = SUBARR
C                                       Open for write
      CALL SNINI ('WRIT', CLBUFF, DISKIN, CNOIN, SNVER, CATIN, LUN,
     *   ISNRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.GT.0) GO TO 990
C                                       Set column pointers
      DO 40 LOOP = 1,9
         IPNT = KOLS(LOOP)
         KOLS(LOOP) = CLKOLS(IPNT)
 40      CONTINUE
      IF (NUMPOL.GT.1) THEN
C                                       Second Stokes
         CALL FNDCOL (NKEY, KEYS(10), LKEY, T, CLBUFF, KOLS(10), IRET)
         IF (IRET.EQ.0) GO TO 50
         WRITE (MSGTXT,1000) IRET
         GO TO 980
 50      DO 60 LOOP = 10,18
            IPNT = KOLS(LOOP)
            KOLS(LOOP) = CLKOLS(IPNT)
 60         CONTINUE
         END IF
C                                       Smoothing times
      SMOTIM(1) = 1.0E-6
      SMOTIM(2) = 1.0E-6
      SMOTIM(3) = 1.0E-6
C                                       Loop over IFs
      DO 200 IFLOOP = 1,NUMIF
         FREQIF = FREQ + FOFF(IFLOOP-BIF+1)
C                                       Loop over subarrays
         DO 100 LOOPSA = LIMS1,LIMS2
C                                       Loop over reference antennas
C                                       used.
            REF = REFTMP
            DO 99 LOOP = 1,NUMANT
               IF ((REFUSS(LOOP,LOOPSA).GT.0) .AND. (LOOP.NE.REF)) THEN
                  ANT = LOOP
C                                       First Stokes
                  CALL CALREF (ANT, REF, LOOPSA, KOLS(1), FREQIF,
     *               SMOTIM, NUMROW, CLBUFF, WORK(OFFSET + 1),
     *               WORK(OFFSET + NUMROW + 1),
     *               WORK(OFFSET + 2 * NUMROW + 1),
     *               WORK(OFFSET + 3 * NUMROW + 1),
     *               WORK(OFFSET + 4 * NUMROW + 1), IRET)
C                                       Inability to connect ANT to
C                                       REF is not necessarily an
C                                       error
                  IF (IRET.EQ.1) THEN
                     IRET = 0
                     NOTREF = .TRUE.
                  END IF
                  IF (IRET.GT.0) GO TO 990
                  IF (NUMPOL.LE.1) GO TO 99
C                                       Second Stokes
                  CALL CALREF (ANT, REF, LOOPSA, KOLS(10), FREQIF,
     *               SMOTIM, NUMROW, CLBUFF, WORK(OFFSET + 1),
     *               WORK(OFFSET + NUMROW + 1),
     *               WORK(OFFSET + 2 * NUMROW + 1),
     *               WORK(OFFSET + 3 * NUMROW + 1),
     *               WORK(OFFSET + 4 * NUMROW + 1), IRET)
C                                       Inability to connect ANT to
C                                       REF is not necessarily an
C                                       error
                  IF (IRET.EQ.1) THEN
                     IRET = 0
                     NOTREF = .TRUE.
                     END IF
                  IF (IRET.GT.0) GO TO 990
                  END IF
 99            CONTINUE
 100        CONTINUE
C                                       Update column pointers for IF
         KOLS(2) = KOLS(2) + 1
         KOLS(4) = KOLS(4) + 1
         KOLS(6) = KOLS(6) + 1
         KOLS(7) = KOLS(7) + 1
         KOLS(8) = KOLS(8) + 1
         KOLS(9) = KOLS(9) + 1
         KOLS(11) = KOLS(11) + 1
         KOLS(13) = KOLS(13) + 1
         KOLS(15) = KOLS(15) + 1
         KOLS(16) = KOLS(16) + 1
         KOLS(17) = KOLS(17) + 1
         KOLS(18) = KOLS(18) + 1
 200     CONTINUE
C                                       Warn user if re-referencing was
C                                       partially successful
      IF (NOTREF) THEN
         MSGTXT = 'Some solutions were not adjusted to the common'
         CALL MSGWRT (6)
         MSGTXT = 'reference antenna. This may be because one or more'
         CALL MSGWRT (6)
         MSGTXT = 'antennas were not used. Check your data before'
         CALL MSGWRT (6)
         MSGTXT = 'proceeding.'
         CALL MSGWRT (6)
      END IF
C                                       Close table
      CALL TABIO ('CLOS', 0, ISNRNO, BUFF1, CLBUFF, IRET)
      GO TO 999
C                                       Error
 980  CALL MSGWRT (8)
 990  WRITE (MSGTXT,1990)
      CALL MSGWRT (8)
C
 999  CONTINUE
C                                       De-allocate any dynamic
C                                       workspace. Ignore errors.
      IF (OFFSET.NE.0) THEN
         CALL ZMEMRY ('FREE', 'CLBADJ', 5 * NUMROW, WORK, OFFSET, IERR)
         END IF
C
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR ',I5,' FINDING SN TABLE COLUMNS')
 1010 FORMAT ('TABIO ERROR ',I5,' CLOSING SN TABLE')
 1020 FORMAT ('TABSRT ERROR ',I5,' SORTING SN TABLE')
 1990 FORMAT ('ERROR OCCURED IN CLBADJ')
 2000 FORMAT ('Adjusting solutions to a common reference antenna')
      END
      SUBROUTINE CLBAPL (IRET)
C-----------------------------------------------------------------------
C   CLBAPL corrects single source data files.
C   Input from common:
C      DISOUT I     Output disk number.
C      CNOOUT I     Output catalog slot number.
C      INCF   I     Increment in freq. of data from UVGET
C      INCIF  I     Increment in IF of data from UVGET
C      INCS   I     Increment in Stokes' of data from UVGET
C      JLOCF  I     Offset of freq. of data from UVGET
C      JLOCIF I     Offset of IF of data from UVGET
C      JLOCS  I     Offset of Stokes' of data from UVGET
C   Output:
C      IRET   I     Return error code, 0=>OK, otherwise error.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER NAME*48
      HOLLERITH CATH(256), CATUVH(256)
      INTEGER   LUN, FIND, BIND, LENBU, NIO, JNCIF, JNCS, LRECO, NUMFRQ,
     *   NUMSUB, SUB, LIMS1, LIMS2, SUBTMP, LUN1, LUN2, NUMPRM, BO, I,
     *   XCOUNT, IIVER, OOVER, NUMVIS, OLDVIS, JERR,MMVIS, MMCOR, WTOFF,
     *   RNXRET
      LOGICAL   T, F, DOCMP
      INCLUDE 'CALIB.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DSEL.INC'
      REAL    VIS(XBFSZ), VIS2(XBFSZ)
      DOUBLE PRECISION FOFF(MAXIF)
      EQUIVALENCE (CATBLK, CATH),  (CATUV, CATUVH)
      EQUIVALENCE (BUFF2, VIS)
      EQUIVALENCE (BUFFS, VIS2)
      DATA T, F /.TRUE.,.FALSE./
      DATA LUN, LUN1, LUN2, BO /27,27,28,1/
C-----------------------------------------------------------------------
C                                       Message
      WRITE (MSGTXT,2000)
      CALL MSGWRT (2)
C                                       set DSEL parameters
      DOCAL = T
      DOWTCL = (XDOCAL.LE.99.0) .AND. (APARM(10).LE.99.0)
      CLUSE = SNVER
      CLVER = SNVER
      STOKES = '    '
C                                       Zero flag counts
      TOTREC(1,1) = 0
      TOTREC(2,1) = 0
      TOTREC(1,2) = 0
      TOTREC(2,2) = 0
      TOTREC(1,3) = 0
      TOTREC(2,3) = 0
C                                       Find number of subarrays
      CALL FNDEXT ('AN', CATUV, NUMSUB)
      NUMSUB = MAX (1, NUMSUB)
      LIMS1 = 1
      LIMS2 = NUMSUB
      IF (SUBARR.GT.0) LIMS1 = SUBARR
      IF (SUBARR.GT.0) LIMS2 = SUBARR
      SUBTMP = SUBARR
      NUMVIS = 0
C                                       Get output CATBLK from DISK
      MSGSUP = 32000
      CALL CATIO ('READ', DISOUT, CNOOUT, CATBLK, 'REST', SCRTCH, IRET)
      MSGSUP = 0
      IF ((IRET.GT.0) .AND. (IRET.LT.5)) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
      CALL UVPGET (JERR)
C                                       Set lengths of input axes.
      OLDVIS = CATBLK(KIGCN)
      NUMFRQ = CATBLK(KINAX+JLOCF)
      NUMIF = 1
      IF (JLOCIF.GT.0) NUMIF = CATBLK(KINAX+JLOCIF)
      NUMPOL = CATBLK(KINAX+JLOCS)
C                                       Set output increments
C                                       (averaging)
      JNCIF = INCIF
      IF (JLOCF.LT.JLOCIF) JNCIF = INCIF / NUMFRQ
      JNCS = INCS
      IF (JLOCF.LT.JLOCS) JNCS = INCS / NUMFRQ
C                                       Compressed data?
      DOCMP = CATBLK(KINAX).EQ.1
      NUMPRM = NRPARM
      IF (DOCMP) THEN
         MMVIS = LREC - NUMPRM
         MMCOR = LREC - NUMPRM
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), WTOFF,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            IRET = 9
            GO TO 990
            END IF
      ELSE
C                                       Un compressed
         MMVIS = LREC - NUMPRM
         MMCOR = (LREC - NUMPRM) / 3
         WTOFF = 0
         END IF
C                                       make an index table
      CALL RNXGET (DISKIN, CNOIN, CATIN)
      CALL RNXINI (DISOUT, CNOOUT, CATBLK, RNXRET)
C                                       Set output file name
      CALL ZPHFIL ('UV', DISOUT, CNOOUT, 1, NAME, IRET)
C                                       Open output file.
      CALL ZOPEN (LUN, FIND, DISOUT, NAME, T, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      LENBU = 1
      LRECO = LREC
      CALL UVINIT ('WRIT', LUN, FIND, CATBLK(KIGCN), NUMVIS, LRECO,
     *   LENBU, JBUFSZ, BUFF1, BO, BIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
C                                       Remove channel selection
C                                       constraints
      BCHAN = 0
      ECHAN = 0
C                                       Loop over subarray
      XCOUNT = 0
      DO 200 SUB = LIMS1,LIMS2
         SUBARR = SUB
C                                       Setup
C                                       Save CATBLK
         CALL COPY (256, CATBLK, IBUFF2)
         CALL UVGET ('INIT', BUFF1, BUFF2, IRET)
C                                       Restore CATBLK
         CALL COPY (256, IBUFF2, CATBLK)
C                                       Check buffer size for use of
C                                       VIS, VIS2
         IF ((LREC.GT.XBFSZ) .AND. DOCMP) THEN
            MSGTXT = 'CLBAPL: BUFFER SIZE TOO SMALL FOR VISIBILITY ' //
     *         ' RECORD'
            IRET = 1
            GO TO 990
            END IF
         IF (IRET.GT.0) GO TO 999
         IF ((NVIS.LE.0) .OR. (IRET.LT.0)) THEN
            NVIS = 0
            GO TO 120
            END IF
C                                       If multiple subarrays mark
C                                       unsorted
         IF (NUMVIS.GT.0) CALL CHR2H (2, '**', 1, CATH(KITYP))
C                                       Copy file
         DO 100 I = 1,NVIS
C                                       Write/compress to output buffer
            IF (DOCMP) THEN
               CALL UVGET ('READ', BUFF1(BIND), VIS2, IRET)
               CALL ZUVPAK (MMCOR, VIS2, BUFF1(BIND+WTOFF),
     *            BUFF1(BIND+NUMPRM))
            ELSE
               CALL UVGET ('READ', BUFF1(BIND), BUFF1(BIND+NUMPRM),
     *            IRET)
               END IF
            IF (IRET.LT.0) GO TO 120
            IF (IRET.NE.0) GO TO 999
C                                       update NX table
            CALL RNXUPD (BUFF1(BIND), RNXRET)
C                                       Write new
            NIO = 1
            XCOUNT = XCOUNT + 1
            CALL UVDISK ('WRIT', LUN, FIND, BUFF1, NIO, BIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1090) IRET
               GO TO 990
               END IF
 100           CONTINUE
C                                       Close Input file
 120     CALL UVGET ('CLOS', BUFF1, BUFF2, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Sum flag counts
         TOTREC(1,1) = TOTREC(1,1) + CNTREC(1,1)
         TOTREC(2,1) = TOTREC(2,1) + CNTREC(2,1)
         TOTREC(1,2) = TOTREC(1,2) + CNTREC(1,2)
         TOTREC(2,2) = TOTREC(2,2) + CNTREC(2,2)
         TOTREC(1,3) = TOTREC(1,3) + CNTREC(1,3)
         TOTREC(2,3) = TOTREC(2,3) + CNTREC(2,3)
 200     CONTINUE
      SUBARR = SUBTMP
C                                       Flush output
      NIO = 0
      CALL UVDISK ('FLSH', LUN, FIND, BUFF1, NIO, BIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1090) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISOUT, CNOOUT, LUN, CATBLK, IRET)
C                                       close NX table
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         CALL MSGWRT (7)
         END IF
C                                      Put vis. count in CATBLK
      CATBLK(KIGCN) = NVIS
C                                       Copy relevant portion of IF
C                                       table.
      IIVER = 1
      OOVER = 1
      CALL CHNCOP (IIVER, OOVER, LUN1, LUN2, DISKIN, DISOUT, CNOIN,
     *   CNOOUT, CATIN, CATBLK, BIF, EIF, FRQSEL, SFREQS, BUFF1, FOFF,
     *   ISBAND, FINC, IRET)
      IRET = 0
C                                       Update CATBLK.
      CALL CATIO ('UPDT', DISOUT, CNOOUT, CATBLK, 'REST', SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1230) IRET
         CALL MSGWRT (6)
         END IF
C                                       Close output
      CALL ZCLOSE (LUN, FIND, IRET)
C                                       Give data summary
      WRITE (MSGTXT,2800)
      CALL MSGWRT (5)
      WRITE (MSGTXT,2801) TOTREC(1,1), TOTREC(1,2), TOTREC(1,3)
      CALL MSGWRT (5)
      WRITE (MSGTXT,2802) TOTREC(2,1), TOTREC(2,2), TOTREC(2,3)
      CALL MSGWRT (5)
C                                       No data found.
      IF (NVIS.GT.0) GO TO 999
         IRET = 9
         WRITE (MSGTXT,1800)
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('CLBAPL: ERROR',I5,' READING OUTPUT CATBLK')
 1020 FORMAT ('CLBAPL: ERROR',I5,' OPENING OUTPUT FILE')
 1030 FORMAT ('CLBAPL: ERROR',I5,' INIT. OUTPUT FILE')
 1090 FORMAT ('CLBAPL: ERROR',I5,' WRITING OUTPUT FILE')
 1230 FORMAT ('CLBAPL: ERROR',I3,' UPDATING CATALOG HEADER')
 1800 FORMAT ('CLBAPL: ERROR - NO DATA WRITTEN')
 2000 FORMAT ('Applying solutions to data')
 2800 FORMAT (10X,' Previously flagged ','  Flagged by gain   ',
     *   '      Kept')
 2801 FORMAT ('Partially ',2I20,I10)
 2802 FORMAT ('Fully     ',2I20,I10)
      END
      SUBROUTINE CLBSOL (MAXBL, MAXFRQ, IRET)
C-----------------------------------------------------------------------
C   CLBSOL calls GASOLV.  Its only purpose is to declare various arrays
C   outside of the main routine, to allow dynamic memory to be used.
C-----------------------------------------------------------------------
      INTEGER   MAXBL, MAXFRQ, IRET
C
      INTEGER   MAXIFS, NWORDS, SOLSUB, SOLMIN, I
      LONGINT   PVOBS, PVWT
      INCLUDE 'CALIB.INC'
      INCLUDE 'INCS:DGDS.INC'
      REAL      CREAL(2*MAXIF*MAXANT), CIMAG(2*MAXIF*MAXANT),
     *   CDELY(2*MAXIF*MAXANT), CRATE(2*MAXIF*MAXANT),
     *   CWT(2*MAXIF*MAXANT), VOBS(2), VWT(2)
      COMMON /SOLCOM/ SOLSUB, SOLMIN
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      MAXIFS = 1
      IF (JLOCIF.GT.0) MAXIFS = CATBLK(KINAX+JLOCIF)
C                                       sub interval parameters
      SOLMIN = XSOLM + 0.1
      SOLSUB = XSOLS + 0.1
      IF (SOLSUB.LE.0) SOLSUB = 1
      IF (SOLSUB.GT.10) SOLSUB = 10
      IF ((SOLMIN.LE.0) .OR. (SOLMIN.GT.SOLSUB)) SOLMIN = SOLSUB
C                                       allocate memory
      NWORDS = (2 * MAXBL * MAXFRQ * SOLSUB - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', 'CLBSOL', NWORDS, VOBS, PVOBS, IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', 'CLBSOL', NWORDS, VWT, PVWT,
     *   IRET)
C                                       solve
      IF (IRET.EQ.0) CALL GASOLV (VOBS(1+PVOBS), VWT(1+PVWT), CREAL,
     *   CIMAG, CDELY, CRATE, CWT, MAXBL, MAXFRQ, MAXIFS, SOLSUB,
     *   SOLMIN, IRET)
C                                       free memory
      CALL ZMEMRY ('FRAL', 'CLBSOL', NWORDS, VOBS, PVOBS, I)
C
 999  RETURN
      END
      SUBROUTINE GASOLV (VOBS, VWT, CREAL, CIMAG, CDELY, CRATE, CWT,
     *   MAXBL, MAXFRQ, MAXIFS, SOLSUB, SOLMIN, IERR)
C-----------------------------------------------------------------------
C   GASOLV reads thru a data file which has been divided by the model
C   and makes the requested solutions which are written into a solution
C   (SN) table.
C   Notes:
C    1) When more than one polarization (max of 2) is to be processed
C       then a second set of frequency slots in VOBS is used for this
C       data.
C   In/out
C      VOBS     R(*)   Work array: (2,MAXBL,MAXFRQ,SOLSUB)
C      VWT      R(*)   Work array: (2,MAXBL,MAXFRQ,SOLSUB)
C      CREAL    R(*)   Work array. (2,MAXIFS,NUMANT)
C      CIMAG    R(*)   Work array. (2,MAXIFS,NUMANT)
C      CDELY    R(*)   Work array. (2,MAXIFS,NUMANT)
C      CRATE    R(*)   Work array. (2,MAXIFS,NUMANT)
C      CWT      R(*)   Work array. (2,MAXIFS,NUMANT)
C      MAXBL    I      Max. number of baselines in data.
C      MAXFRQ   I      Maximum number of frequency channels * pols
C      MAXIFS   I      Max number of IFs
C      SOLSUB   I      Number of sub-intervals to use
C      SOLMIN   I      Minimum number subintervals for solution
C   From common:
C    SOLINT        R    Solution interval (days).
C    REFANT        I    Ref ant to use.
C    DOL1          L    True if L1 solution wanted.
C    DOGCON        L    True if gain constrained soln. wanted.
C    DOMGM         L    True then find the mean gain modulus and save it
C    DOSAVG        I    True if amp-scalar averaging requested.
C    GAERR(*)      R    Gain error for constraints.
C    CONFAC        R    Factor for penalty term
C    AVGPOL        L    True if RR and LL to be averaged
C    AVGIF         L    True if all IFs to be averaged
C    GSOLV(*)      L    List of antennas to solve for.
C    NUMBL         I    Number of baselines
C    NUMIF         I    Number of IFs
C    SNRMIN        R    Minimum acceptable SNR
C    PRTLV         I    Print level
C    MODE          I    0=full gain, 1=phase only, 2 phase(no amp),
C                       3 = amp. constr
C    MINNO         I    Min. no. antennas.
C    ANTWT(20)     R    Antenna weights.
C    CATBLK(256)   I    Output catalog header.
C    CATIN(256)    I    Input catalog header.
C    CNOIN         I    Input data cat. #.
C    CNOOUT        I    Output data cat #.
C    DISKIN        I    Input data disk number.
C    DISOUT        I    Output data disk number.
C    SNVER         I    Version of SN table to use
C    JBUFSZ        I    Buffer size.
C    BUFF1(*)      I    Work buffer
C    BUFF2(*)      I    Work buffer. Used for EQUIVALENCEs.
C   Output:
C      IERR     I      Return code, 0=>OK, otherwise error.
C-----------------------------------------------------------------------
      INTEGER   MAXBL, MAXFRQ, MAXIFS, SOLSUB, SOLMIN, IERR
      REAL      VOBS(2,MAXBL,MAXFRQ,SOLSUB), VWT(2,MAXBL,MAXFRQ,SOLSUB),
     *   CREAL(2,MAXIFS,*), CIMAG(2,MAXIFS,*), CDELY(2,MAXIFS,*),
     *   CRATE(2,MAXIFS,*), CWT(2,MAXIFS,*)
C
      INTEGER   HDIM
      PARAMETER (HDIM = 50)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   LUNI, LUNSS, FINDI, BINDI, NIN, NBL, NTIM, IC, NRMS,
     *   NBLANK, I, IBL, DISK, INDEX, JBL, KK1, KK2, KK3, INCIII, II,
     *   NANTM1, I1P1, I1, I2, IROUND, SCNSOU, SCNSUB, SUBA, NUMINT,
     *   NFPIF, NUMFRQ, JERR, NOIF, MFRQ, SNKOLS(MAXSNC), IBASE,
     *   SNNUMV(MAXSNC), NODENO, JFRQ, JIF, NXVER, FREQID, NNSOU,
     *   OFFIF, LLL, BO, VO, VISCNT, ISNRNO, IDUM1, IDUM2, VCNO, IMGM,
     *   KEYLOC, KEYTYP, ORIGIN, NUMKEY, LIMIT, LIMIT2, J, IRET, ISUB,
     *   MSUB, HFRAC(HDIM+1), NFLAGS, NSNREC, NWORDS, KK4, IPOL, IDUM
      REAL      DELT, CATR(128), WT, CATIR(256), SCNTIM, SCNDT, BASEL,
     *   MX2BAS, MN2BAS, BLFACT, XXAMP, YYAMP, IFRM, ELSOL, HASOL,
     *   ZASOL, CURSUB, SSRMS, SRMS, RATE, CHFLGS(MAXCIF), SUMR, SUMI,
     *   SUMA, SUMW, GMMO(MAXIF,2), SNWORK(2), SNDATA(2), TEMP, RDUM
      LONGINT   PSNDAT, PSNWRK
      CHARACTER IFILE*48, KEYWRD*8, CPOL(2,2)*1
      LOGICAL   T, F, JUSRED, DONDX, TWOSTO, ISAPPL, ISIQUV
      DOUBLE PRECISION TIMEC, CATD(128), TIMRA(2), LASTIM, STTIME(10),
     *   CURTIM, ENDTIM, CURINT, CUREND, SCNEND, SIUSE, DEPS
      INCLUDE 'CALIB.INC'
      INCLUDE 'CALFLAG'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:PSTD.INC'
      INTEGER   BLCODE(MXBASE), IS(MXBASE), JS(MXBASE), REFAN(2,MAXIF)
      LOGICAL   GOTANT(MAXANT,10), GOTDAT(2,MAXIF,MAXANT,10)
      EQUIVALENCE (CATIN, CATIR),        (CATBLK, CATR, CATD)
      EQUIVALENCE (IDUM, RDUM)
      DATA ISAPPL /.FALSE./
      DATA KEYWRD /'MGMOD   '/
      DATA T,F /.TRUE.,.FALSE./
      DATA LUNI, LUNSS /16, 27/
      DATA BO, VO /1,0/
      DATA CPOL /'R','L','X','Y'/
C-----------------------------------------------------------------------
C                                       0.001 sec
      DEPS = 1.157407D-9
      SOLSUB = MAX (1, MIN (10, SOLSUB))
      CALL FILL (HDIM+1, 0, HFRAC)
      NFLAGS = 0
      NRMS = 0
      SRMS = 0
      SSRMS = 0
      NSNREC = 0
C                                       Message(s)
      IF (DOSAVG.EQ.2) THEN
         MSGTXT = 'Determining solutions using full amp-scalar' //
     *      ' averaging'
      ELSE IF (DOSAVG.EQ.1) THEN
         MSGTXT = 'Determining solutions using amp-scalar' //
     *      ' averaging only in time'
      ELSE
         MSGTXT = 'Determining solutions using full vector averaging'
         END IF
      CALL MSGWRT (2)
      CNTOK = 0
      CNTBAD = 0
      CNTFEW = 0
      CNTSAD = 0
C                                       Square baseline limits
      MX2BAS = MXPABL * MXPABL * 1.0E6
      MN2BAS = MNPABL * MNPABL * 1.0E6
      NOIF = EIF - BIF + 1
      NUMFRQ = NOIF * (ECHAN - BCHAN + 1)
      NFPIF = NUMFRQ / NUMIF
      CALL CHWANT (NFPIF, NOIF, CHNSEL, CHFLGS)
      IMGM = 0
      NUMBL = (NUMANT * (NUMANT-1)) / 2
C                                       Purge old SN table?
      IF (SNVER.GT.0) THEN
         NNSOU = NSOUWD
         IF (SINGLE) NNSOU = 0
         TIMRA(1) = XTIME(1) + XTIME(2) / 24.0 + XTIME(3) / (24.0*60.0)
     *      + (XTIME(4) / (24.0*60.0*60.0))
         TIMRA(2) = XTIME(5) + XTIME(6) / 24.0 + XTIME(7) / (24.0*60.0)
     *      + (XTIME(8) / (24.0*60.0*60.0))
         IF ((TIMRA(2).LT.TIMRA(1)) .OR. (TIMRA(2).LT.1.0E-5))
     *      TIMRA(2) = 1.0E20
         CALL CALSEL (DISKIN, CNOIN, 'SN', SNVER, CATIN, CLBUFF, NNSOU,
     *      SOUWAN, DOSWNT, NANTSL, ANTENS, DOAWNT, TIMRA, SUBARR,
     *      FRQSEL, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Init. Gain. file.
      NUMNOD = 0
      NODENO = 0
      NUMPOL = 1
      GMMOD = 1.0
      IF (NCOR.GT.1) NUMPOL = 2
C                                       protect catalog status
      CALL CATFIX (DISKIN, CNOIN, 'NOTR')
C                                        IQUV?
      ISIQUV = CATD(KDCRV+JLOCS).GT.0.0
      IF (ISIQUV) NUMPOL = 1
      CALL SNINI ('WRIT', CLBUFF, DISKIN, CNOIN, SNVER, CATIN, LUNSS,
     *   ISNRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD,
     *   GMMOD, RANOD, DECNOD, ISAPPL, IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (MSGTXT,1140) SNVER
      CALL MSGWRT (3)
      IFRM = 0.0
C                                       get antenna info
      CALL GETANT (DISKIN, CNOIN, SUBARR, CATIN, BUFFS, IRET)
C                                       Add the ORIGIN keyword
      KEYLOC = 1
      KEYTYP = 4
      ORIGIN = 0
      NUMKEY = 1
      IF (SINGLE) ORIGIN = 1
      IDUM = ORIGIN
      CALL TABKEY ('WRIT', 'SNORIGIN', NUMKEY, CLBUFF, KEYLOC, RDUM,
     *   KEYTYP, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1150) IERR
         GO TO 990
         END IF
C                                        Open vis. file
      DISK = VISDSK
      VCNO = VISCNO
      IF (VISDSK.EQ.0) THEN
         DISK = SCRVOL(VISCNO)
         VCNO = SCRCNO(VISCNO)
         CALL ZPHFIL ('SC', DISK, VCNO, 1, IFILE, IRET)
      ELSE
         CALL ZPHFIL ('UV', DISK, VCNO, 1, IFILE, IRET)
         END IF
      CALL ZOPEN (LUNI, FINDI, DISK, IFILE, T, F, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1005) IERR
         GO TO 990
         END IF
C                                        Initialize UV file
      NIN = 1
      VO = 0
      CALL UVINIT ('READ', LUNI, FINDI, NVIS, VO, LREC, NIN, JBUFSZ,
     *   BUFF1, BO, BINDI, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         GO TO 990
         END IF
C                                       Setup.
      VISCNT = 0
C                                        Clear "got data" flag
      JUSRED = F
C                                        Set baseline arrays.
      NANTM1 = NUMANT - 1
      NBL = 0
      IF (ILOCB.GE.0) THEN
         IBASE = 256
      ELSE
         IBASE = 32768
         END IF
      DO 20 I1 = 1, NANTM1
         I1P1 = I1 + 1
         DO 10 I2 = I1P1, NUMANT
            NBL = NBL + 1
            BLCODE(NBL) = I1 * IBASE + I2
            IS(NBL) = I1
            JS(NBL) = I2
 10         CONTINUE
 20      CONTINUE
C                                       Initialize I/O to INDEX file
      MSGSUP = 32000
      NXVER = 1
      CALL NDXINI ('READ', NXBUFF, DISKIN, CNOIN, NXVER, CATIN,
     *   IXLUN, INXRNO, NXKOLS, NXNUMV, IRET)
      MSGSUP = 0
      DONDX = IRET.EQ.0
C                                       Dummy if no scans
      SCNTIM = -1.0E10
      SCNEND =  1.0E10
      SCNSOU = 0
      SCNSUB = 0
      SUBA = SUBARR
C                                       Read first scan info
      IF (DONDX) THEN
 30      IF (INXRNO.LE.NXBUFF(5)) THEN
            CALL TABNDX ('READ', NXBUFF, INXRNO, NXKOLS, NXNUMV, SCNTIM,
     *         SCNDT, SCNSOU, SCNSUB, IDUM1, IDUM2, FREQID, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       Scan match current data?
            IF ((SCNSUB.GT.0) .AND. (SUBARR.GT.0) .AND.
     *         (SUBARR.NE.SCNSUB)) GO TO 30
            IF ((FREQID.GT.0) .AND. (FRQSEL.GT.0) .AND.
     *         (FRQSEL.NE.FREQID)) GO TO 30
            SCNTIM = SCNTIM - 0.5D0 * SCNDT
            SCNEND = SCNTIM + SCNDT + 5.0D0*DEPS
            IF (SCNTIM.LT.TSTART) THEN
               SCNDT = SCNDT - (TSTART - SCNTIM)
               SCNTIM = TSTART
               END IF
            IF (SCNEND.GT.TEND) THEN
               SCNDT = SCNDT - (SCNEND - TEND)
               SCNEND = TEND + 10.0D0*DEPS
               END IF
            NUMINT = IROUND (SCNDT / SOLINT)
            NUMINT = MAX (NUMINT, 1)
            SIUSE = SCNDT / NUMINT
            IF (SIUSE.LE.0.0) SIUSE = SOLINT
            END IF
      ELSE
         FREQID = FRQSEL
         SIUSE = SOLINT
         END IF
C                                       Stokes' parameter
      ICOR0 = ABS (ICOR0)
      INCS = ABS (INCS)
C                                       See if can use spare frequency
C                                       for 2nd Stokes (e.g. RR & LL)
C                                       Don't if IQUV poln.
      TWOSTO = (NCOR.GT.1) .AND. (.NOT.AVGPOL) .AND. (.NOT.ISIQUV)
C                                       Offset in IF for Stokes no. 2
      OFFIF = NOIF + 1
      IF (AVGPOL) OFFIF = 1
C                                       Increment for IF
      INCIII = 1
      IF (AVGIF) INCIII = 0
C                                       Begin Loop in time.
 80   NIN = 1
C                                       Clear "Got data" flags
      J = 2 * NUMIF
      DO 90 ISUB = 1,SOLSUB
         DO 85 LLL = 1,NUMANT
            GOTANT(LLL,ISUB) = F
            CALL LFILL (J, F, GOTDAT(1,1,LLL,ISUB))
 85         CONTINUE
 90      CONTINUE
C                                       Blank/zero solution values
      NBLANK = 2 * NUMIF * NUMANT
      CALL RFILL (NBLANK, FBLANK, CREAL)
      CALL RFILL (NBLANK, FBLANK, CIMAG)
      CALL RFILL (NBLANK, 0.0, CDELY)
      CALL RFILL (NBLANK, 0.0, CRATE)
      CALL RFILL (NBLANK, 0.0, CWT)

      IC = 1
C                                       IC=0 means averaged Stokes
      IF (AVGPOL) IC = 0
C                                       IC=-1 means both Stokes
      IF (TWOSTO) IC = -1
C                                       IC=3 means Ipol
      IF (ISIQUV) IC = 3
C                                       Init. for sol. interval.
      VISCNT = 0
C                                        Zero fill VOBS
      DO 110 ISUB = 1,SOLSUB
         DO 105 KK3 = 1,MAXFRQ
            DO 100 KK2 = 1,NUMBL
               VOBS(1,KK2,KK3,ISUB) = 0.0
               VOBS(2,KK2,KK3,ISUB) = 0.0
               VWT(1,KK2,KK3,ISUB) = 0.0
               VWT(2,KK2,KK3,ISUB) = 0.0
 100           CONTINUE
 105        CONTINUE
 110     CONTINUE
C                                       Read first record (if nec)
C                                       and setup
      IF (.NOT.JUSRED) THEN
         NIN = 0
         CALL UVDISK ('READ', LUNI, FINDI, BUFF1, NIN, BINDI, IERR)
         IF ((NIN.LE.0) .OR. (IERR.EQ.4)) THEN
            IERR = 0
            NIN = 0
            GO TO 300
         ELSE IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR, 'READ'
            GO TO 990
            END IF
         JUSRED = T
         END IF
C                                       parameters of data point
      CURTIM = BUFF1(BINDI+ILOCT)
      GO TO 130
C                                       Find index record
 120  IF (INXRNO.LE.NXBUFF(5)) THEN
         CALL TABNDX ('READ', NXBUFF, INXRNO, NXKOLS, NXNUMV, SCNTIM,
     *      SCNDT, SCNSOU, SCNSUB, IDUM1, IDUM2, FREQID, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Scan match current data?
         IF ((SCNSUB.GT.0) .AND. (SUBARR.GT.0) .AND.
     *      (SUBARR.NE.SCNSUB)) GO TO 120
         IF ((FREQID.GT.0) .AND. (FRQSEL.GT.0) .AND.
     *      (FRQSEL.NE.FREQID)) GO TO 120
         SCNTIM = SCNTIM - 0.5D0 * SCNDT
         SCNEND = SCNTIM + SCNDT + 5.0*DEPS
         IF (SCNTIM.LT.TSTART) THEN
            SCNDT = SCNDT - (TSTART - SCNTIM)
            SCNTIM = TSTART
            END IF
         IF (SCNEND.GT.TEND) THEN
            SCNDT = SCNDT - (SCNEND - TEND)
            SCNEND = TEND + 10.0D0*DEPS
            END IF
         NUMINT = IROUND (SCNDT / SOLINT)
         NUMINT = MAX (NUMINT, 1)
         SIUSE = SCNDT / NUMINT
         IF (SIUSE.LE.0.0) SIUSE = SOLINT
      ELSE
         SCNEND = CURTIM + SOLINT
         SIUSE = SOLINT
         END IF
C                                       done already?
 130  IF (CURTIM.GT.SCNEND+195.0D0*DEPS) GO TO 120
      LASTIM = CURTIM + SIUSE
C                                       if this leave a dangle interval
C                                       < 0.6 * SIUSE go to the end
C                                       extend a ways for time accuracy
C                                       issues but not more than 1 min
      IF (LASTIM.GT.SCNEND-0.6D0*SIUSE) LASTIM = SCNEND +
     *   MIN (0.5D0 * SIUSE, 0.0007D0)
      NTIM = 1
      STTIME(1) = CURTIM
      CURINT = SIUSE
C                                       make array of subinterval start
C                                       times
      CURSUB = CURINT / SOLSUB
      DO 140 ISUB = 2,SOLSUB
         STTIME(ISUB) = STTIME(ISUB-1) + CURSUB
 140     CONTINUE
      MSUB = 0
C                                       Load data into array.
C                                       Begin Loop.
C                                       If next point already read,
C                                       skip read.
      IF (JUSRED) GO TO 210
 200     NIN = 0
         CALL UVDISK ('READ', LUNI, FINDI, BUFF1, NIN, BINDI, IERR)
         IF ((NIN.LE.0) .OR. (IERR.EQ.4)) THEN
            IERR = 0
            NIN = 0
            GO TO 300
         ELSE IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR, 'READ'
            GO TO 990
            END IF
 210     CURTIM = BUFF1(BINDI+ILOCT)
C                                       Check for last time.
         IF (CURTIM.GT.LASTIM-DEPS) GO TO 300
C                                       Check if finished.
         IF (NIN.LE.0) GO TO 300
C                                       Determine baseline code.
         IF (ILOCB.GE.0) THEN
            JBL = BUFF1(BINDI+ILOCB) + 0.1
            I1 = JBL / 256
            I2 = JBL - I1 * 256
         ELSE
            I1 = BUFF1(BINDI+ILOCA1) + 0.1
            I2 = BUFF1(BINDI+ILOCA2) + 0.1
            JBL = 32768 * I1 + I2
            END IF
C                                       Look for match.
         DO 220 I = 1,NBL
            IBL = I
            IF (JBL.EQ.BLCODE(I)) GO TO 240
 220        CONTINUE
C                                       Bad baseline code.
C                                       No message on AC data
         IF (I2.NE.I1) THEN
            WRITE (MSGTXT,1130) I1, I2, NUMANT
            CALL MSGWRT (6)
            END IF
C                                       Go to next data point
         GO TO 200
C                                       Datum OK
 240     ENDTIM = CURTIM
C                                       find sub interval
         DO 250 I1 = 1,SOLSUB
            IF (CURTIM.GE.STTIME(I1)) ISUB = I1
 250        CONTINUE
         MSUB = MAX (MSUB, ISUB)
C                                       Baseline factors
         I1 = IS(IBL)
         I2 = JS(IBL)
         GOTANT(I1,ISUB) = T
         GOTANT(I2,ISUB) = T
         BLFACT = ANTWT(I1) * ANTWT(I2)
         BASEL = BUFF1(BINDI+ILOCU) * BUFF1(BINDI+ILOCU) +
     *      BUFF1(BINDI+ILOCV) * BUFF1(BINDI+ILOCV)
         IF ((BASEL.LT.MN2BAS) .OR. (BASEL.GT.MX2BAS))
     *      BLFACT = BLFACT * WTPABL
C                                       Accumulate
         VISCNT = VISCNT + 1
         I = 0
         DO 260 JIF = 1,NUMIF
            INDEX = BINDI + NRPARM + (JIF-1) * INCIF
            II = (JIF-1) * INCIII + 1
            SUMR = 0.0
            SUMI = 0.0
            SUMA = 0.0
            SUMW = 0.0
            DO 255 JFRQ = 1, NFPIF
               I = I + 1
               WT = BLFACT * BUFF1(INDEX+2) * CHFLGS(I)
               IF (WT.GT.0.0) THEN
                  GOTDAT(1,JIF,I1,ISUB) = T
                  GOTDAT(1,JIF,I2,ISUB) = T
                  SUMR = SUMR + WT * BUFF1(INDEX)
                  SUMI = SUMI + WT * BUFF1(INDEX+1)
                  SUMW = SUMW + WT
                  IF (DOSAVG.EQ.2) SUMA = SUMA +
     *               WT * SQRT (BUFF1(INDEX)*BUFF1(INDEX) +
     *               BUFF1(INDEX+1)*BUFF1(INDEX+1))
                  END IF
               INDEX = INDEX + INCF
 255           CONTINUE
            VOBS(1,IBL,II,ISUB) = VOBS(1,IBL,II,ISUB) + SUMR
            VOBS(2,IBL,II,ISUB) = VOBS(2,IBL,II,ISUB) + SUMI
            VWT(1,IBL,II,ISUB) = VWT(1,IBL,II,ISUB) + SUMW
            IF (DOSAVG.EQ.1) SUMA = SQRT (SUMR*SUMR + SUMI*SUMI)
            IF (DOSAVG.GT.0) VWT(2,IBL,II,ISUB) = VWT(2,IBL,II,ISUB) +
     *         SUMA
 260        CONTINUE
C                                       Sum or include 2nd Stokes
         IF (AVGPOL .OR. TWOSTO) THEN
            I = 0
            DO 270 JIF = 1,NUMIF
               INDEX = BINDI + NRPARM + (JIF-1) * INCIF + INCS
               II = (JIF-1) * INCIII + OFFIF
               SUMR = 0.0
               SUMI = 0.0
               SUMA = 0.0
               SUMW = 0.0
               DO 265 JFRQ = 1,NFPIF
                  I = I + 1
                  WT = BLFACT * BUFF1(INDEX+2) * CHFLGS(I)
                  IF (WT.GT.0.0) THEN
                     GOTDAT(2,JIF,I1,ISUB) = T
                     GOTDAT(2,JIF,I2,ISUB) = T
                     SUMR = SUMR + WT * BUFF1(INDEX)
                     SUMI = SUMI + WT * BUFF1(INDEX+1)
                     SUMW = SUMW + WT
                     IF (DOSAVG.EQ.2) SUMA = SUMA +
     *                  WT * SQRT (BUFF1(INDEX)*BUFF1(INDEX) +
     *                  BUFF1(INDEX+1)*BUFF1(INDEX+1))
                     END IF
                  INDEX = INDEX + INCF
 265              CONTINUE
               VOBS(1,IBL,II,ISUB) = VOBS(1,IBL,II,ISUB) + SUMR
               VOBS(2,IBL,II,ISUB) = VOBS(2,IBL,II,ISUB) + SUMI
               VWT(1,IBL,II,ISUB) = VWT(1,IBL,II,ISUB) + SUMW
               IF (DOSAVG.EQ.1) SUMA = SQRT (SUMR*SUMR + SUMI*SUMI)
               IF (DOSAVG.GT.0) VWT(2,IBL,II,ISUB) = VWT(2,IBL,II,ISUB)
     *            + SUMA
 270           CONTINUE
            END IF
C                                       Loop back for next time
         GO TO 200
C                                       End of solution interval.
 300  JUSRED = T
      MFRQ = NOIF
      IF (TWOSTO) MFRQ = 2 * NOIF
C                                       Compress subintervals into 1
      DO 330 ISUB = 2,MSUB
         DO 320 I1 = 1,MFRQ
            DO 310 I2 = 1,NUMBL
               VOBS(1,I2,I1,1) = VOBS(1,I2,I1,1) + VOBS(1,I2,I1,ISUB)
               VOBS(2,I2,I1,1) = VOBS(2,I2,I1,1) + VOBS(2,I2,I1,ISUB)
               VWT(1,I2,I1,1) = VWT(1,I2,I1,1) + VWT(1,I2,I1,ISUB)
               VWT(2,I2,I1,1) = VWT(2,I2,I1,1) + VWT(2,I2,I1,ISUB)
 310           CONTINUE
 320        CONTINUE
         DO 325 LLL = 1,NUMANT
            IF (GOTANT(LLL,ISUB)) GOTANT(LLL,1) = T
            DO 324 JIF = 1,NUMIF
               IF (GOTDAT(1,JIF,LLL,ISUB)) GOTDAT(1,JIF,LLL,1) = T
               IF (GOTDAT(2,JIF,LLL,ISUB)) GOTDAT(2,JIF,LLL,1) = T
 324           CONTINUE
 325        CONTINUE
 330     CONTINUE
C                                       Normalize visibility array
      DO 360 I1 = 1,MFRQ
         DO 340 I2 = 1,NUMBL
            IF (VWT(1,I2,I1,1).GT.1.0E-20) THEN
               VOBS(1,I2,I1,1) = VOBS(1,I2,I1,1) / VWT(1,I2,I1,1)
               VOBS(2,I2,I1,1) = VOBS(2,I2,I1,1) / VWT(1,I2,I1,1)
               END IF
 340        CONTINUE
C                                       Amp-scalar averaging
         IF (DOSAVG.GT.0) THEN
            DO 350 I2 = 1,NUMBL
               IF (VWT(1,I2,I1,1).GT.1.0E-20) THEN
                  XXAMP = SQRT ((VOBS(1,I2,I1,1)**2) +
     *               (VOBS(2,I2,I1,1)**2)) * VWT(1,I2,I1,1)
                  YYAMP = 1.0
                  IF (XXAMP.GT.1.0E-20)
     *               YYAMP = VWT(2,I2,I1,1) / XXAMP
                  VOBS(1,I2,I1,1) = VOBS(1,I2,I1,1) * YYAMP
                  VOBS(2,I2,I1,1) = VOBS(2,I2,I1,1) * YYAMP
                  END IF
 350           CONTINUE
            END IF
 360     CONTINUE
C                                       Lookup source name
      CALL GETSOU (SCNSOU, DISKIN, CNOIN, CATUV, LUNS(1), JERR)
C                                       Amplitude, phase soln.
      TIMEC = (STTIME(1) + ENDTIM) * 0.5D0
      CALL CLBPA (IS, JS, VOBS, VWT, CREAL, CIMAG, CWT, REFAN,
     *   MAXFRQ, MAXIFS, MAXBL, NUMANT, NUMBL, NOIF, REFANT, AVGIF,
     *   DOL1, DOGCON, GAERR, MODE, MINNO, CONFAC, SNRMIN, PRTLV,
     *   CPARM(7), CPARM(6), XDOFL, CLOSER, TIMEC, SNAME, IC, GSOLV,
     *   HDIM, HFRAC, NRMS, SRMS, SSRMS)
C                                       Write solution record.
      DELT = ENDTIM - STTIME(1)
      IF (DELT.LT.0) DELT = 0.0
      CALL CLSNOU (TIMEC, DELT, SCNSOU, IFRM, NODENO, SUBA, MAXIFS,
     *   GOTANT, GOTDAT, ISNRNO, SNKOLS, SNNUMV, CREAL, CIMAG, CDELY,
     *   CRATE, CWT, REFAN, NSNREC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       write FG table
      IF (FLAGIT) THEN
         CALL FLAGWT ('WRIT', STTIME(1), ENDTIM, IS, JS, VWT, MAXBL,
     *      NUMBL, NOIF, AVGIF, IC, DISKIN, CNOIN, CATIN, NFLAGS, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Sum mean gain modulus
      IF (DOMGM.GT.0) THEN
         DO 430 KK1 = 1,NUMANT
C                                       Select on antenna.
            IF (SLMEAN(KK1)) THEN
C                                       Select on elevation.
               CALL SOUELV (KK1, TIMEC, HASOL, ELSOL, ZASOL)
               IF (ELSOL/DG2RAD.GE.GMINEL) THEN
                  DO 420 KK2 = BIF,EIF
                     DO 410 KK3 = 1,NUMPOL
                        IPOLIF = KK3 + (KK2 - 1) * NUMPOL
                        IF ((GOTANT(KK1,1)) .AND.
     *                     (CWT(KK3,KK2,KK1).GT.1.0E-20) .AND.
     *                     (CREAL(KK3,KK2,KK1).NE.FBLANK) .AND.
     *                     (CIMAG(KK3,KK2,KK1).NE.FBLANK)) THEN
                           CNTMG(IPOLIF) = CNTMG(IPOLIF) + 1
                           SUMMG(IPOLIF) = SUMMG(IPOLIF) +
     *                        SQRT(CREAL(KK3,KK2,KK1)*CREAL(KK3,KK2,KK1)
     *                        + CIMAG(KK3,KK2,KK1)*CIMAG(KK3,KK2,KK1))
                           CNTMGM = CNTMGM + 1
                           SUMMGM = SUMMGM +
     *                        SQRT(CREAL(KK3,KK2,KK1)*CREAL(KK3,KK2,KK1)
     *                        + CIMAG(KK3,KK2,KK1)*CIMAG(KK3,KK2,KK1))
                           END IF
 410                    CONTINUE
 420                 CONTINUE
                  END IF
               END IF
 430        CONTINUE
         END IF
C                                       Shift subintervals
      DO 470 ISUB = 2,MSUB
         DO 450 I1 = 1,MFRQ
            DO 440 I2 = 1,NUMBL
               VOBS(1,I2,I1,ISUB-1) = VOBS(1,I2,I1,ISUB)
               VOBS(2,I2,I1,ISUB-1) = VOBS(2,I2,I1,ISUB)
               VWT(1,I2,I1,ISUB-1) = VWT(1,I2,I1,ISUB)
               VWT(2,I2,I1,ISUB-1) = VWT(2,I2,I1,ISUB)
               IF (ISUB.EQ.MSUB) THEN
                  VOBS(1,I2,I1,ISUB) = 0.0
                  VOBS(2,I2,I1,ISUB) = 0.0
                  VWT(1,I2,I1,ISUB) = 0.0
                  VWT(2,I2,I1,ISUB) = 0.0
                  END IF
 440           CONTINUE
 450        CONTINUE
         DO 460 LLL = 1,NUMANT
            GOTANT(LLL,ISUB-1) = GOTANT(LLL,ISUB)
            GOTANT(LLL,ISUB) = .FALSE.
            DO 459 JIF = 1,NUMIF
               GOTDAT(1,JIF,LLL,ISUB-1) = GOTDAT(1,JIF,LLL,ISUB)
               GOTDAT(2,JIF,LLL,ISUB-1) = GOTDAT(2,JIF,LLL,ISUB)
               GOTDAT(1,JIF,LLL,ISUB) = .FALSE.
               GOTDAT(2,JIF,LLL,ISUB) = .FALSE.
 459           CONTINUE
 460        CONTINUE
         STTIME(ISUB-1) = STTIME(ISUB)
 470     CONTINUE
      MSUB = MSUB - 1
      IF (MSUB.GT.0) THEN
         DO 475 ISUB = MSUB+1,SOLSUB
            STTIME(ISUB) = STTIME(ISUB-1) + CURSUB
 475        CONTINUE
         END IF
      CUREND = STTIME(SOLSUB) + CURSUB
      CUREND = MIN (CUREND, SCNEND)
C                                       If not finished, loop back.
      IF (NIN.GT.0) THEN
         IF (MSUB.LE.0) GO TO 80
         IF ((CURTIM.GE.CUREND) .AND. (MSUB.LT.SOLMIN)) GO TO 80
         IF (CURTIM.GE.CUREND) GO TO 300
         LASTIM = CUREND
         GO TO 210
      ELSE
         IF (MSUB.GE.SOLMIN) GO TO 300
         END IF
C                                       Done: check gain normalization
      IF (DOMGM.GT.1) THEN
         IF (ALZERO) THEN
            MSGTXT = 'All selected antennas are used in the' //
     *         ' gain normalization'
            CALL MSGWRT (5)
         ELSE
            MSGTXT = 'The following antennas are used in the' //
     *         ' gain normalization'
            CALL MSGWRT (5)
            LIMIT = MIN (15, NUSE)
            WRITE (MSGTXT,1215) (LSTUSE(I), I=1,LIMIT)
            CALL MSGWRT (5)
            IF (NUSE.GT.15) THEN
C                                       Rest of antennas
               DO 480 I = 16,NUSE,15
                  LIMIT = I
                  LIMIT2 = I + 14
                  LIMIT2 = MIN (NUSE, LIMIT2)
                  WRITE (MSGTXT,1215) (LSTUSE(J),J=LIMIT,LIMIT2)
                  CALL MSGWRT (5)
 480              CONTINUE
               END IF
            END IF
         END IF
      IF (DOMGM.GT.0) THEN
         KK4 = 1
         IF (CATD(KDCRV+JLOCS).LT.-4.5) KK4 = 2
         CALL RFILL (MAXIF*NUMPOL, 1.0, GMMO)
         DO 490 KK3 = 1,NUMPOL
            DO 485 KK2 = BIF,EIF
               IPOLIF = KK3 + (KK2 - 1) * NUMPOL
C                                       Update mean gain modulus
C                                       for each IF and polarization
               GMMO(KK2,KK3) = 1.0
               IF (CNTMG(IPOLIF).GT.0)
     *            GMMO(KK2,KK3) = SUMMG(IPOLIF) / CNTMG(IPOLIF)
               WRITE (MSGTXT,1200) CPOL(KK3,KK4), KK2, GMMO(KK2,KK3)
               CALL MSGWRT (5)
 485           CONTINUE
 490        CONTINUE
         IF (CNTMGM.GT.0) GMMOD = SUMMGM / CNTMGM
         END IF
C                                       close uv file.
      CALL ZCLOSE (LUNI, FINDI, IERR)
C                                       Close solution file
      CALL TABIO ('CLOS', 0, ISNRNO, BUFF1, CLBUFF, IERR)
C                                       Close index file
      IF (DONDX) CALL TABIO ('CLOS', 0, INXRNO, BUFF1, NXBUFF, IERR)
      IERR = 0
C                                       Nothing worked
      IF (CNTOK.LE.0) THEN
         MSGTXT = 'ERROR: NO VALID SOLUTIONS FOUND'
         IERR = 8
         GO TO 990
C                                       Give body count
      ELSE
         RATE = 0.0
         WRITE (MSGTXT,1490) CNTOK
         CALL MSGWRT (5)
         IF (CNTBAD.GT.0) THEN
            WRITE (MSGTXT,1491) CNTBAD
            CALL MSGWRT (5)
            RATE = CNTBAD * 100.0
            RATE = (RATE / CNTOK) * (1 + CNTBAD/1000)
            END IF
         IF (CNTFEW.GT.0) THEN
            WRITE (MSGTXT,1492) CNTFEW
            CALL MSGWRT (5)
            END IF
         IF (CNTSAD.GT.0) THEN
            WRITE (MSGTXT,1493) CNTSAD
            CALL MSGWRT (5)
            END IF
         IF (RATE.GE.10.0) THEN
            MSGTXT = '********** THIS IS A PRETTY HIGH FAILURE RATE' //
     *         ' **********'
            CALL MSGWRT (3)
            MSGTXT = '********** Consider WEIGHTIT = 1 or higher   ' //
     *         ' **********'
            CALL MSGWRT (3)
            MSGTXT = '********** and/or SOLTYPE = ''L1R'' and/or     '//
     *         ' **********'
            CALL MSGWRT (3)
            MSGTXT = '********** UVRANGE limits or larger SOLINT   ' //
     *         ' **********'
            CALL MSGWRT (3)
            MSGTXT = '********** or redo the NX table with INDXR   ' //
     *         ' **********'
            IF (DONDX) CALL MSGWRT (3)
            END IF
         END IF
C                                       rms of closure
      IF ((NRMS.GT.0) .AND. (SRMS.GT.0.0)) THEN
         SRMS = SRMS / NRMS
         SSRMS = SSRMS / NRMS - SRMS*SRMS
         SSRMS = SQRT (MAX (0.0, SSRMS))
         WRITE (MSGTXT,1494) SRMS, SSRMS
         CALL MSGWRT (4)
         END IF
C                                       fractional discards
      IF (HFRAC(1).GT.0) THEN
         II = 0
         DO 494 I = 1,HDIM
            IF (HFRAC(I+1).GT.0.0) II = I
 494        CONTINUE
         IF (II.GT.0) THEN
            WRITE (MSGTXT,1495) XDOFL
            CALL MSGWRT (4)
            WT = HFRAC(1)
            DO 495 I = 1,II
               I1 = (100/HDIM) * (I - 1)
               I2 = I1 + (100/HDIM)
               XXAMP = HFRAC(I+1) / WT
               WRITE (MSGTXT,1496) XXAMP, I1, I2, XDOFL
               IF (XXAMP.GT.0.0) CALL MSGWRT (4)
 495           CONTINUE
         ELSE
            WRITE (MSGTXT,1497) XDOFL
            CALL MSGWRT (4)
            END IF
         END IF
      IF (NFLAGS.GT.0) THEN
         NFLAGD = NFLAGD + NFLAGS
         WRITE (MSGTXT,1500) NFLAGS, FGVERO
         CALL MSGWRT (4)
         CALL FLAGWT ('CLOS', STTIME(1), ENDTIM, IS, JS, VWT, MAXBL,
     *      NUMBL, NOIF, AVGIF, IC, DISKIN, CNOIN, CATIN, NFLAGS, IERR)
         END IF
      IF (DOMGM.GT.1) THEN
         IF (CPARM(2).GT.0.0) THEN
            MSGTXT = 'Finding median amplitudes in SN table'
            CALL MSGWRT (2)
            NWORDS = (NUMPOL * EIF * NSNREC - 1) / 1024 + 3
            CALL ZMEMRY ('GET ', 'GASOLV', NWORDS, SNDATA, PSNDAT, IERR)
            IF (IERR.NE.0) THEN
               MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY FOR MEDIANS'
               GO TO 990
               END IF
            CALL ZMEMRY ('GET ', 'GASOLV', NWORDS, SNWORK, PSNWRK, IERR)
            IF (IERR.NE.0) THEN
               MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY FOR MEDIANS'
               GO TO 990
               END IF
            CALL GMEDIA (DISKIN, CNOIN, SNVER, SUBARR, BIF, EIF, NUMPOL,
     *         CATIN, NSNREC, DOMGM, SNDATA(1+PSNDAT), SNWORK(1+PSNWRK),
     *         GMMO, GMMOD, IERR)
C                                       Update GLOBAL mean gain modulus
            IF (DOMGM.EQ.2) THEN
               SUMMMM = SUMMMM + GMMOD
               CNTMMM = CNTMMM + 1
               GMMOD = SUMMMM / CNTMMM
               END IF
         ELSE
            IF (DOMGM.EQ.3) THEN
               MSGTXT = 'Apply global mean gain modulus to SN table'
               CALL MSGWRT (3)
               WRITE (MSGTXT,1510) SUBARR, GMMOD
               CALL MSGWRT (3)
               II = EIF - BIF + 1
               CALL RFILL (II, GMMOD, GMMO(BIF,1))
               IF (NUMPOL.EQ.2) CALL RFILL (II, GMMOD, GMMO(BIF,2))
            ELSE IF ((DOMGM.EQ.4) .AND. (NUMPOL.GT.1)) THEN
               MSGTXT = 'Apply mean gain modulus to SN table by IF'
               CALL MSGWRT (3)
               DO 496 KK2 = BIF,EIF
                  IPOLIF = 1 + (KK2 - 1) * NUMPOL
                  GMMO(KK2,1) = 1.0
                  IF ((CNTMG(IPOLIF)+CNTMG(IPOLIF+1)).GT.0)
     *               GMMO(KK2,1) = (SUMMG(IPOLIF) + SUMMG(IPOLIF+1)) /
     *               (CNTMG(IPOLIF) + CNTMG(IPOLIF+1))
                  GMMO(KK2,2) = GMMO(KK2,1)
 496              CONTINUE
            ELSE IF (DOMGM.EQ.5) THEN
               MSGTXT = 'Apply mean gain modulus to SN table by IF/pol'
               CALL MSGWRT (3)
               END IF
            END IF
         IF (DOMGM.GE.6) THEN
            DO 498 KK2 = BIF,EIF
               DO 497 IPOL = 1,NUMPOL
                  IPOLIF = IPOL + (KK2 - 1) * NUMPOL
                  IF (CNTMG(IPOLIF).GT.0) THEN
                     AGMMO(KK2,IPOL,SUBARR) = SUMMG(IPOLIF) /
     *                  CNTMG(IPOLIF)
                  ELSE
                     AGMMO(KK2,IPOL,SUBARR) = FBLANK
                     END IF
 497              CONTINUE
 498           CONTINUE
         ELSE IF (DOMGM.GT.2) THEN
            CALL GMODIT (DISKIN, CNOIN, SNVER, SUBARR, BIF, EIF, CATIN,
     *         GMMO, IERR)
         ELSE
            MSGTXT = 'The global average gain which is actually '
            CALL MSGWRT (5)
            WRITE (MSGTXT,1300) GMMOD
            CALL MSGWRT (5)
            CALL SNINI ('WRIT', CLBUFF, DISKIN, CNOIN, SNVER, CATIN,
     *         LUNSS, ISNRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF,
     *         NUMNOD, TEMP, RANOD, DECNOD, ISAPPL, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL TABKEY ('WRIT', KEYWRD, 1, CLBUFF, 1, GMMOD, 2,
     *         IERR)
            CALL TABIO ('CLOS', 0, ISNRNO, BUFF1, CLBUFF, IERR)
            END IF
         END IF
      GO TO 999
C                                        Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1005 FORMAT ('GASOLV: ERROR',I3,' OPENING INPUT UV FILE')
 1010 FORMAT ('GASOLV: ERROR',I3,' INITING UV FILE')
 1100 FORMAT ('GASOLV: ERROR',I3,1X,A4,'ING UV FILE')
 1130 FORMAT ('BAD BASELINE CODE=',I4,'-',I4,' NO. ANT.=',I4)
 1140 FORMAT ('Writing SN table ',I4)
 1150 FORMAT ('GASOLV: ERROR ',I3,' WRITING ORIGIN KEYWORD TO SN TABLE')
 1200 FORMAT (A1,'POL, IF=', I2,
     *   ' The average gain over these antennas is ', 1PE10.3)
 1215 FORMAT (15I3)
 1300 FORMAT ('applied to all data, is  ', 1PE11.4)
 1490 FORMAT ('Found     ',I8,' good solutions')
 1491 FORMAT ('Failed on ',I8,' solutions')
 1492 FORMAT ('          ',I8,' solutions had insufficient data')
 1493 FORMAT ('          ',I8,' solutions had no data')
 1494 FORMAT ('Average closure rms =',F9.5,' +-',F9.5)
 1495 FORMAT ('Fraction of times having data >',F5.1,
     *   ' rms from solution')
 1496 FORMAT (F7.5,' of the times had',I3,' -',I3,' percent outside',
     *   F5.1,' times rms')
 1497 FORMAT ('No data were found >',F5.1,' rms from solution')
 1500 FORMAT (I6,' flags added to the output FG table version',I4)
 1510 FORMAT ('Subarray',I3,' global mean gain modulus is',1PE12.4)
      END
      SUBROUTINE CLSNOU (TIMEC, DELT, SCNSOU, IFRM, NODENO, SUBA,
     *   MAXIFS, GOTANT, GOTDAT, ISNRNO, SNKOLS, SNNUMV, CREAL, CIMAG,
     *   CDELY, CRATE, CWT, REFAN, NSNREC, IERR)
C-----------------------------------------------------------------------
C   CLSNOU prepares a set of SN table entries and writes them to an SN
C   table.  If the weight of a solution is 0.0 it is assumed that there
C   was insufficient data for the solution.  CLBPA sets weights to -1 if
C   the solution fails.
C   Input:
C      TIMEC    D     Time in days
C      DELT     R     Solution interval in days
C      SCNSOU   I     Source number
C      IFRM     R     Ionospheric Faraday Rotation
C      NODENO   I     Node numbe.
C      SUBA     I     Subarray number
C      MAXIFS   I     Maximum number of IFs
C      GOTANT   L(*)  Flags indicating if there was data for each ant.
C      GOTDAT   L(*)  Flags indicating if there was data for each pol,
C                     IF, ant.
C      ISNRNO   I     TABSN counter.
C      SNKOLS   I(*)  SN table column pointers
C      SNNUMV   I(*)  SN table element counts.
C      CREAL    R(2,NUMIF,NUMANT) Real part of solution
C      CIMAG    R(2,NUMIF,NUMANT) Imag part of solution
C      CDELY    R(2,NUMIF,NUMANT) delays in seconds.
C      CRATE    R(2,NUMIF,NUMANT) Rates in Hz.
C      CWT      R(2,NUMIF,NUMANT) Weights = SNR
C      REFAN    I(2,NUMIF) Reference antennas used
C      NSNREC   I          Count of SN records this subarray
C   Input in common:
C      NUMANT   I     The number of antennas.
C      NUMIF    I     The number of IFs.
C      NUMPOL   I     The number of polarizations.
C      SNRMIN   R     Minimum allowed SNR for a solution.
C      DOPASS   L     If true write (1,0) for failed solutions.
C   Input/output in common:
C      REFUSE   I(*)  The number of useages of each antenna as reference
C                     antenna.
C      CNTOK    I     Count of good solutions
C      CNTBAD   I     Count of failed solutions.
C      CNTFEW   I     Count of solutions with too little data.
C   Output:
C      IERR     I     Return code, 0=>OK, else TABSN error.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      DOUBLE PRECISION TIMEC
      INTEGER   SCNSOU, NODENO, SUBA, MAXIFS, ISNRNO, SNKOLS(*),
     *   SNNUMV(*), REFAN(2,*), NSNREC, IERR
      REAL      DELT, IFRM, CREAL(2,MAXIFS,*), CIMAG(2,MAXIFS,*),
     *   CDELY(2,MAXIFS,*), CRATE(2,MAXIFS,*), CWT(2,MAXIFS,*)
      LOGICAL   GOTANT(*), GOTDAT(2,MAXIF,*)
C
      INTEGER   IANT, IIF, IREF
      REAL      MBDELY(2), DISP(2), DDISP(2)
      INCLUDE 'CALIB.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA MBDELY, DISP, DDISP /6*0.0/
C-----------------------------------------------------------------------
C                                       Loop over antennae
      DO 420 IANT = 1,NUMANT
         DO 410 IIF = 1,NUMIF
C                                       Keep track of reference ants
            IREF = REFAN(1,IIF)
            IF ((IREF.GT.0) .AND. (IREF.LE.NUMANT)) THEN
               REFUSE(IREF) = REFUSE(IREF) + 1
               REFUSS(IREF,SUBA) = REFUSS(IREF,SUBA) + 1
C                                       Deal with ref SNR
C              IF (CWT(1,IIF,IREF).LT.(SNRMIN+1.0))
C    *            CWT(1,IIF,IREF) = SNRMIN + 1.0
               END IF
C                                        Second polarization
            IREF = REFAN(2,IIF)
            IF ((IREF.GT.0) .AND. (IREF.LE.NUMANT)) THEN
               REFUSE(IREF) = REFUSE(IREF) + 1
               REFUSS(IREF,SUBA) = REFUSS(IREF,SUBA) + 1
C              IF (CWT(2,IIF,IREF).LT.(SNRMIN+1.0))
C    *            CWT(2,IIF,IREF) = SNRMIN + 1.0
               END IF
C                                       Count good and bad solns
            IF (GOTANT(IANT)) THEN
               IF (CWT(1,IIF,IANT).GE.SNRMIN) THEN
                  CNTOK = CNTOK + 1
               ELSE IF ((ABS (CWT(1,IIF,IANT)).LT.0.1) .AND.
     *            (CWT(1,IIF,IANT).NE.0.0)) THEN
                  CNTFEW = CNTFEW + 1
               ELSE IF (CWT(1,IIF,IANT).GT.-1.1) THEN
                  IF (GOTDAT(1,IIF,IANT)) THEN
                     CNTBAD = CNTBAD + 1
                  ELSE
                     CNTSAD = CNTSAD + 1
                     END IF
                  END IF
C                                       Second poln.
               IF (NUMPOL.GT.1) THEN
                  IF (CWT(2,IIF,IANT).GE.SNRMIN) THEN
                     CNTOK = CNTOK + 1
                  ELSE IF ((ABS (CWT(2,IIF,IANT)).LT.0.1) .AND.
     *               (CWT(2,IIF,IANT).NE.0.0)) THEN
                     CNTFEW = CNTFEW + 1
                  ELSE IF ((CWT(2,IIF,IANT).GT.-1.1) .AND.
     *               (GOTDAT(2,IIF,IANT))) THEN
                     CNTBAD = CNTBAD + 1
                  ELSE
                     CNTSAD = CNTSAD + 1
                     END IF
                  END IF
               END IF
C                                       Keep bad solutions?
            IF (DOPASS) THEN
               IF (CWT(1,IIF,IANT).LT.SNRMIN) THEN
                  CREAL(1,IIF,IANT) = 1.0
                  CIMAG(1,IIF,IANT) = 0.0
                  CWT(1,IIF,IANT) = 1.0
                  END IF
               IF (CWT(2,IIF,IANT).LT.SNRMIN) THEN
                  CREAL(2,IIF,IANT) = 1.0
                  CIMAG(2,IIF,IANT) = 0.0
                  CWT(2,IIF,IANT) = 1.0
                  END IF
               END IF
 410        CONTINUE
         IF (GOTANT(IANT)) THEN
            CALL TABSN ('WRIT', CLBUFF, ISNRNO, SNKOLS, SNNUMV, NUMPOL,
     *         TIMEC, DELT, SCNSOU, IANT, SUBA, FRQSEL, IFRM, NODENO,
     *         MBDELY, DISP, DDISP, CREAL(1,1,IANT), CIMAG(1,1,IANT),
     *         CDELY(1,1,IANT), CRATE(1,1,IANT), CWT(1,1,IANT), REFAN,
     *         IERR)
            IF (IERR.NE.0) GO TO 999
            NSNREC = NSNREC + 1
            END IF
 420     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE GMEDIA (DISK, CNO, VER, SUBARR, BIF, EIF, NPOL, CATIN,
     *   NSNREC, DOMGM, SNDATA, SNWORK, GMMO, GMMOD, IERR)
C-----------------------------------------------------------------------
C   GMODIT applies the mean gain modulus to the SN table in place.
C   Inputs:
C      DISK     I      Disk
C      CNO      I      Catalog number
C      VER      I      SN table version #
C      SUBARR   I      Subarray number
C      BIF      I      Begin IF
C      EIF      I      End IF
C      NPOL     I      Number polarizations (1 or 2)
C      CATIN    I(*)   Input file catalog header
C      NSNREC   I      Number records this subarray in SN table
C      DOMGM    I      2 global, 3 subarray, 4 subarray & IF,
C                      5 subarray, IF, pol
C   Output:
C      GMMO     R(*)   Mean gain modulus (MAXIF,2) set for DOMGM type
C      GMMOD    R      global mean modulus
C      IERR     I      Error code
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   DISK, CNO, VER, SUBARR, BIF, EIF, NPOL, CATIN(*), DOMGM,
     *   NSNREC, IERR
      REAL      SNDATA(NSNREC,NPOL,*), SNWORK(*), GMMO(MAXIF,2), GMMOD
C
      INTEGER   LUN, ISNRNO, SNKOLS(MAXSNC), SNNUMV(MAXSNC), NUMANT,
     *   NUMPOL, NUMIF, NUMNOD, IANT, SUBA, LF, SNBUFF(512), I, LUNTMP,
     *   NUMROW,  ANTKOL, SUBKOL, RE1KOL, IM1KOL, RE2KOL, IM2KOL,
     *   RECI(XCLRSZ), NVAL(2,MAXIF), NN, LP
      REAL      RECR(XCLRSZ), IGMMOD, AMP, MEDIAN
      LOGICAL   ISAPPL, OPEN
      DOUBLE PRECISION  RANOD, DECNOD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSNTAB.INC'
      EQUIVALENCE (RECI, RECR)
C-----------------------------------------------------------------------
      OPEN = .FALSE.
      LUN = LUNTMP (1)
      I = 2 * MAXIF
      CALL FILL (I, 0, NVAL)
C                                       open SN table to get parms
C                                       Open solution table
      CALL SNINI ('READ', SNBUFF, DISK, CNO, VER, CATIN, LUN, ISNRNO,
     *   SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, IGMMOD, RANOD,
     *   DECNOD, ISAPPL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN SN TABLE FOR READ'
         GO TO 990
         END IF
      OPEN = .NOT.OPEN
C                                       pointers, number rows
      NUMROW = SNBUFF(5)
      ANTKOL = SNKOLS(SNIANT)
      SUBKOL = SNKOLS(SNISUB)
      RE1KOL = SNKOLS(SNRRE1)
      IM1KOL = SNKOLS(SNRIM1)
      RE2KOL = SNKOLS(SNRRE2)
      IM2KOL = SNKOLS(SNRIM2)
      DO 100 I = 1,NUMROW
         ISNRNO = I
         CALL TABIO ('READ', 0, ISNRNO, RECR, SNBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READ SN TABLE'
            GO TO 990
            END IF
         IANT = RECI(ANTKOL)
         SUBA = RECI(SUBKOL)
         IF (SUBA.EQ.SUBARR) THEN
            DO 20 LF = BIF,EIF
               IF (RECR(RE1KOL+LF-1).NE.FBLANK) THEN
                  AMP = RECR(RE1KOL+LF-1)**2 + RECR(IM1KOL+LF-1)**2
                  NVAL(1,LF) = NVAL(1,LF) + 1
                  SNDATA(NVAL(1,LF),1,LF) = SQRT (AMP)
                  END IF
               IF (NUMPOL.GT.1) THEN
                  IF (RECR(RE2KOL+LF-1).NE.FBLANK) THEN
                     AMP = RECR(RE2KOL+LF-1)**2 + RECR(IM2KOL+LF-1)**2
                     NVAL(2,LF) = NVAL(2,LF) + 1
                     SNDATA(NVAL(2,LF),2,LF) = SQRT (AMP)
                     END IF
                  END IF
 20            CONTINUE
            END IF
 100     CONTINUE
C                                       Close
      CALL TABIO ('CLOS', 0, ISNRNO, RECR, SNBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSE SN WRITE'
         GO TO 990
         END IF
      OPEN = .FALSE.
C                                       find medians
C                                       each individually
      IF ((DOMGM.GE.5) .OR. ((DOMGM.GE.4) .AND. (NUMPOL.EQ.1))) THEN
         MSGTXT = 'Apply median gain modulus to SN table by IF/pol'
         CALL MSGWRT (3)
         DO 120 LF = BIF,EIF
            DO 110 LP = 1,NUMPOL
               GMMO(LF,LP) = MEDIAN (NVAL(LP,LF), SNDATA(1,LP,LF))
 110           CONTINUE
            WRITE (MSGTXT,1110) LF, (GMMO(LF,LP), LP = 1,NUMPOL)
            CALL MSGWRT (4)
 120        CONTINUE
C                                       polarizations blended
      ELSE IF (DOMGM.GE.4) THEN
         MSGTXT = 'Apply median gain modulus to SN table by IF'
         CALL MSGWRT (3)
         DO 140 LF = BIF,EIF
            CALL RCOPY (NVAL(1,LF), SNDATA(1,1,LF), SNWORK(1))
            NN = NVAL(1,LF)
            CALL RCOPY (NVAL(2,LF), SNDATA(1,2,LF), SNWORK(NN+1))
            NN = NN + NVAL(2,LF)
            GMMO(LF,1) = MEDIAN (NN, SNWORK)
            GMMO(LF,2) = GMMO(LF,1)
            WRITE (MSGTXT,1130) LF, GMMO(LF,1)
            CALL MSGWRT (4)
 140        CONTINUE
C                                       all together
      ELSE
         MSGTXT = 'Apply global median gain modulus to SN table'
         IF (DOMGM.GT.2) CALL MSGWRT (3)
         NN = 0
         DO 160 LF = BIF,EIF
            DO 150 LP = 1,NUMPOL
               CALL RCOPY (NVAL(LP,LF), SNDATA(1,LP,LF), SNWORK(NN+1))
               NN = NN + NVAL(LP,LF)
 150           CONTINUE
 160        CONTINUE
         GMMOD = MEDIAN (NN, SNWORK)
         WRITE (MSGTXT,1160) GMMOD
         CALL MSGWRT (4)
         NN = EIF - BIF + 1
         CALL RCOPY (NN, GMMOD, GMMO(BIF,1))
         CALL RCOPY (NN, GMMOD, GMMO(BIF,2))
         END IF
      GO TO 999
C
 990  CALL MSGWRT (7)
      IF (OPEN) CALL TABIO ('CLOS', 0, ISNRNO, RECR, SNBUFF, I)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GMEDIA ERROR',I4,' ON ',A)
 1110 FORMAT ('Median gain modulus IF',I3,' R',1PE12.4,' L',1PE12.4)
 1130 FORMAT ('Median gain modulus IF',I3,1PE12.4,' both pols')
 1160 FORMAT ('Median gain modulus overall',1PE12.4)
      END
      SUBROUTINE GMODIT (DISK, CNO, VER, SUBARR, BIF, EIF, CATIN, GMMO,
     *   IERR)
C-----------------------------------------------------------------------
C   GMODIT applies the mean gain modulus to the SN table in place.
C   Inputs:
C      DISK     I      Disk
C      CNO      I      Catalog number
C      VER      I      SN table version #
C      SUBARR   I      Subarray number
C      BIF      I      Begin IF
C      EIF      I      End IF
C      GMMO     R(*)   Mean gain modulus (MAXIF,2)
C      CATIN    I(*)   Input file catalog header
C   Output:
C      IERR     I      Error code
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   DISK, CNO, VER, SUBARR, BIF, EIF, CATIN(*), IERR
      REAL      GMMO(MAXIF,2)
C
      INTEGER   LUN, ISNRNO, SNKOLS(MAXSNC), SNNUMV(MAXSNC), NUMANT,
     *   NUMPOL, NUMIF, NUMNOD, IANT, SUBA, LF, SNBUFF(512), I, LUNTMP,
     *   NUMROW,  DATP(128,2), ANTKOL, SUBKOL, RE1KOL, IM1KOL, RE2KOL,
     *   IM2KOL, RECI(XCLRSZ), NCOL, NREC, NKEY
      REAL      GMMOD, RECR(XCLRSZ)
      LOGICAL   ISAPPL, OPEN
      DOUBLE PRECISION  RANOD, DECNOD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSNTAB.INC'
      EQUIVALENCE (RECI, RECR)
C-----------------------------------------------------------------------
      OPEN = .FALSE.
      LUN = LUNTMP (1)
C                                       open SN table to get parms
C                                       Open solution table
      CALL SNINI ('READ', SNBUFF, DISK, CNO, VER, CATIN, LUN, ISNRNO,
     *   SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, GMMOD, RANOD,
     *   DECNOD, ISAPPL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN SN TABLE FOR READ'
         GO TO 990
         END IF
      OPEN = .NOT.OPEN
C                                       pointers, number rows
      NUMROW = SNBUFF(5)
      ANTKOL = SNKOLS(SNIANT)
      SUBKOL = SNKOLS(SNISUB)
      RE1KOL = SNKOLS(SNRRE1)
      IM1KOL = SNKOLS(SNRIM1)
      RE2KOL = SNKOLS(SNRRE2)
      IM2KOL = SNKOLS(SNRIM2)
      CALL TABIO ('CLOS', 0, ISNRNO, RECR, SNBUFF, I)
      OPEN = .NOT.OPEN
C                                       re-open for write
      CALL TABINI ('WRIT', 'SN', DISK, CNO, VER, CATIN, LUN, NKEY,
     *   NREC, NCOL, DATP, SNBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN SN TABLE FOR WRITE'
         GO TO 990
         END IF
      OPEN = .NOT.OPEN
      DO 100 I = 1,NUMROW
         ISNRNO = I
         CALL TABIO ('READ', 0, ISNRNO, RECR, SNBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READ SN TABLE'
            GO TO 990
            END IF
         IANT = RECI(ANTKOL)
         SUBA = RECI(SUBKOL)
         IF ((SUBA.EQ.SUBARR) .OR. (SUBARR.LE.0)) THEN
            DO 20 LF = BIF,EIF
               IF (GMMO(LF,1).LE.0.0) GMMO(LF,1) = 1.0
               IF (RECR(RE1KOL+LF-1).NE.FBLANK) THEN
                  RECR(RE1KOL+LF-1) = RECR(RE1KOL+LF-1) / GMMO(LF,1)
                  RECR(IM1KOL+LF-1) = RECR(IM1KOL+LF-1) / GMMO(LF,1)
                  END IF
               IF (NUMPOL.GT.1) THEN
                  IF (GMMO(LF,2).LE.0.0) GMMO(LF,2) = 1.0
                  IF (RECR(RE2KOL+LF-1).NE.FBLANK) THEN
                     RECR(RE2KOL+LF-1) = RECR(RE2KOL+LF-1) / GMMO(LF,2)
                     RECR(IM2KOL+LF-1) = RECR(IM2KOL+LF-1) / GMMO(LF,2)
                     END IF
                  END IF
 20            CONTINUE
            END IF
         ISNRNO = I
         CALL TABIO ('WRIT', 0, ISNRNO, RECR, SNBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'WRITE SN TABLE'
            GO TO 990
            END IF
 100     CONTINUE
C                                       Close
      CALL TABIO ('CLOS', 0, ISNRNO, RECR, SNBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSE SN WRITE'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (7)
      IF (OPEN) CALL TABIO ('CLOS', 0, ISNRNO, RECR, SNBUFF, I)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GMODIT ERROR',I4,' ON ',A)
      END
      SUBROUTINE FLAGWT (OPCODE, BTIME, ETIME, IS, JS, VWT, MAXBL,
     *   NUMBL, NOIF, AVGIF, IC, DISK, CNO, CATIN, NFLAGS, IERR)
C-----------------------------------------------------------------------
C   Goes through weight array and flags data with wt < 0.  That with
C   wt=0 already flagged presumably
C   Inputs:
C      OPCODE    C*4    'CLOS' to close file, else write
C      BTIME     R      Interval begin time
C      ETIME     R      Interval end time
C      IS        I(*)   First ant. of baseline numbers
C      JS        I(*)   2nd ant. of baseline numbers
C      VWT       R(2,MAXBL,MAXFRQ) Visibility weights
C      MAXBL     I      Maximum number of baselines
C      NUMBL     I      Number of baselines
C      NOIF      I      Number of IFs
C      AVGIF     L      T => IFs averaged
C      IC        I      Stokes' number passed, -1 => both as separate
C                       sets of frequencies; 0=> data for poln.
C                       averaged. 1 = R, 2 = L, 3 = I
C      DISK      I      UV file disk number
C      CNO       I      UV file cno
C   In/out:
C      CATIN     I(*)   Header
C      NFLAGS    I      Count of records written to FG table
C   Outputs:
C      IERR      I      Error code
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   MAXBL, IS(*), JS(*), NUMBL, NOIF, IC, DISK, CNO,
     *   CATIN(*), NFLAGS, IERR
      DOUBLE PRECISION  BTIME, ETIME
      REAL      VWT(2,MAXBL,*)
      LOGICAL   AVGIF
C
      INTEGER   IA1, IA2, CIF, LIF1, LIF2, IST, JST, NST, ISTOFF, IBL
      LOGICAL   PFLAGS(4)
      REAL      WGT, T1, T2, DT
      INCLUDE 'CALFLAG'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
C                                       (Loop) over Stokes' type
      IF (OPCODE.NE.'CLOS') THEN
         DT = 0.05 / (3600.0 * 24.0)
         IF (IC.LT.0) THEN
            NST = 2
         ELSE
            NST = 1
            END IF
         PFLAGS(3) = .TRUE.
         PFLAGS(4) = .TRUE.
         T1 = BTIME - DT
         T2 = ETIME + DT
         DO 60 JST = 1,NST
C                                       Ipol soln:
            IF ((IC.EQ.3) .OR. (IC.EQ.0)) THEN
               IST = 1
               PFLAGS(1) = .TRUE.
               PFLAGS(2) = .TRUE.
            ELSE IF (IC.LT.0) THEN
               IST = JST
               PFLAGS(IST) = .TRUE.
               PFLAGS(3-IST) = .FALSE.
            ELSE
               IST = IC
               PFLAGS(IST) = .TRUE.
               PFLAGS(3-IST) = .FALSE.
               END IF
C                                       Trap funny business with Stokes
            ISTOFF = 0
            IF ((IC.LT.0) .AND. (JST.EQ.2)) ISTOFF = NOIF
C                                       Loop over IF
            DO 40 CIF = 1,NOIF
C                                       Copy data to XOBS
               IF (AVGIF) THEN
                  LIF1 = BIF
                  LIF2 = EIF
               ELSE
                  LIF1 = CIF + BIF - 1
                  LIF2 = LIF1
                  END IF
               DO 20 IBL = 1,NUMBL
                  WGT = VWT(1,IBL,CIF+ISTOFF)
                  IF (WGT.LT.0.0) THEN
                     IA1 = IS(IBL)
                     IA2 = JS(IBL)
                     CALL FLAGER ('WRIT', FLGLUN, DISK, CNO, FGVER,
     *                  FGVERO, LFGRNO, FGKOLS, FGNUMV, 0, SUBARR,
     *                  FRQSEL, IA1, IA2, T1, T2, LIF1, LIF2, 1, 0,
     *                  PFLAGS, REASON, 0.0, CATIN, FGBUFL, IERR)
                     IF (IERR.NE.0) GO TO 999
                     NFLAGS = NFLAGS + 1
                     END IF
 20               CONTINUE
 40            CONTINUE
 60         CONTINUE
      ELSE
         CALL FLAGER ('CLOS', FLGLUN, DISK, CNO, FGVER, FGVERO, LFGRNO,
     *      FGKOLS, FGNUMV, 0, SUBARR, FRQSEL,IA1, IA2, T1, T2, LIF1,
     *      LIF2, 1, 0, PFLAGS, REASON,0.0, CATIN, FGBUFL, IERR)
         END IF
C
 999  RETURN
      END
      SUBROUTINE FLAGER (OPCODE, LUN, DISK, CNO, VERI, VER, LFGRNO,
     *   FGKOLS, FGNUMV, ID, SUBA, FQID, ANT1, ANT2, BTIME, ETIME, BIF,
     *   EIF, BCHAN, ECHAN, PFLAGS, REASON, DOIFS, CATUV, BUFF, IRET)
C-----------------------------------------------------------------------
C   Updates the Flag (FG) table. Adapted from FLAGUP
C   One entry is made indicating a visibility to be rejected.
C   The FLAG table will be opened on the first call but a final call
C   with OPCODE='CLOS' is required to close the file.
C   Inputs:
C      OPCODE   C*4      Operation desired, 'CLOS'=>close file
C                        Anything else = 'FLAG'
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      VERI     I        Input version number
C      VER      I        FG file version
C      LUN      I        Logical unit number to use
C      ID       I(NID)   List of source ID as defined in SOURCE table
C      NID      I        Number of elements in ID
C      SUBA     I        Subarray number.
C      FQID     I        Freqid number
C      ANT1     I        First antenna number in baseline
C      ANT2     I        Second antenna number in baseline
C      BTIME    R        Start time of data to be flagged (Days)
C      ETIME    R        End time of data to be flagged (Days)
C      BIF      I        First IF number to flag. 0=>all
C      EIF      I        Last IF number to flag. 0=>all higher than IFS(1)
C      BCHAN    I        First channel number to flag. 0=>all
C      ECHAN    I        Last channel number to flag. 0=>all higher.
C      PFLAGS   L(4)     Correlator flags
C      REASON   C*24     Reason for flagging blank => ignore for unflag.
C      DOIFS    R        > 0 flag all IFs
C   Input/Output:
C      CATUV    I(256)   Header for disk file to get FG table
C      BUFF     I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      LFGRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      FGKOLS   I(*)     The column pointer array in order, SOURCE,
C                        SUBARRAY, ANTS, TIMERANG, IFS, CHANS, PFLAGS,
C                        REASON
C      FGNUMV   I(*)     Element count in each column.
C   Output:
C      IRET     I        Error code, 0=>OK else TABIO error.
C                        Note: -1 => read, but record deselected.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, REASON*24
      INTEGER   LUN, DISK, CNO, VERI, VER, LFGRNO, FGKOLS(*), FGNUMV(*),
     *   ID, SUBA, FQID, ANT1, ANT2, BIF, EIF, BCHAN, ECHAN, CATUV(256),
     *   BUFF(*), IRET
      REAL      BTIME, ETIME, DOIFS
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER TREAS*24, CTEMP*12
      INTEGER   IDT, SUBT, ANTS(2), IFS(2), CHANS(2), IDUM, FIND, I,
     *   BUFF2(512), LUN2, IFGKOL(MAXFGC), IFGNUM(MAXFGC), NROW, IFQ,
     *   IFGRNO
      LOGICAL   PFLAGS(4), TFLAGS(4), FIRST
      REAL      TIMER(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      SAVE FIRST
      DATA FIRST /.TRUE./
C-----------------------------------------------------------------------
C                                       See if table open - check FTAB
      IF (OPCODE.NE.'CLOS') THEN
         FIND = BUFF(82)
C                                       Open file
         IF ((FIND.LT.0) .OR. (FIND.GT.10000) .OR. (LUN.NE.FTAB(FIND)))
     *      THEN
            CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV',
     *         IDUM, 'WRIT', BUFF2, IRET)
C
            CALL FLGINI ('WRIT', BUFF, DISK, CNO, VER, CATUV, LUN,
     *         LFGRNO, FGKOLS, FGNUMV, IRET)
C                                       Report on the need for flagging
            WRITE (MSGTXT,1000) VER
C            IF (.NOT.FIRST) WRITE (MSGTXT,1001) VER
            IF (FIRST) CALL MSGWRT (2)
            IF (IRET.NE.0) GO TO 999
C                                       Copy the old file
            IF ((FIRST) .AND. (VERI.GT.0)) THEN
               LUN2 = LUN + 1
               CALL FLGINI ('READ', BUFF2, DISK, CNO, VERI, CATUV, LUN2,
     *            IFGRNO, IFGKOL, IFGNUM, IRET)
               IF (IRET.NE.0) GO TO 999
               NROW = BUFF2(5)
               WRITE (MSGTXT,1002) NROW, VERI, VER
               CALL MSGWRT (2)
               DO 20 I = 1,NROW
                  CALL TABFLG ('READ', BUFF2, IFGRNO, IFGKOL, IFGNUM,
     *               IDT, SUBT, IFQ, ANTS, TIMER, IFS, CHANS, TFLAGS,
     *               TREAS, IRET)
                  IF (IRET.GT.0) GO TO 999
                  IF (IRET.EQ.0) THEN
                     CALL TABFLG ('WRIT', BUFF, LFGRNO, FGKOLS, FGNUMV,
     *                  IDT, SUBT, IFQ, ANTS, TIMER, IFS, CHANS, TFLAGS,
     *                  TREAS, IRET)
                     IF (IRET.NE.0) GO TO 999
                     END IF
 20               CONTINUE
               CALL TABIO ('CLOS', 0, IFGRNO, TIMER, BUFF2, I)
               END IF
            FIRST = .FALSE.
C                                       Mark as unsorted
            BUFF(43) = 0
            BUFF(44) = 0
            END IF
C                                       Set up for flagging
         ANTS(1) = ANT1
         ANTS(2) = ANT2
         TIMER(1) = BTIME
         TIMER(2) = ETIME
         IF (DOIFS.LE.0.0) THEN
            IFS(1) = BIF
            IFS(2) = EIF
         ELSE
            IFS(1) = 1
            IFS(2) = 0
            END IF
         CHANS(1) = BCHAN
         CHANS(2) = ECHAN
C                                       Flag table entry.
         CALL TABFLG ('WRIT', BUFF, LFGRNO, FGKOLS, FGNUMV, ID, SUBA,
     *      FQID, ANTS, TIMER, IFS, CHANS, PFLAGS, REASON, IRET)
C                                       Close
      ELSE
         CALL TABFLG ('CLOS', BUFF, LFGRNO, FGKOLS, FGNUMV, IDT, SUBT,
     *      FQID, ANTS, TIMER, IFS, CHANS, TFLAGS, TREAS, IRET)
C                                       Clear write status
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV', IDUM,
     *      'CLWR', BUFF, IRET)
         BUFF(82) = 0
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Found some bad data, will write flags to table FG', I4)
C1001 FORMAT ('Found some bad data, will add   flags to table FG', I4)
 1002 FORMAT ('Copy',I8,' rows from FG vers',I3,' to',I3)
      END
      SUBROUTINE CHWANT (NCH, NIF, CHNSEL, CHFLGS)
C-----------------------------------------------------------------------
C   Makes a mask of the desired channels
C   Inputs:
C      NCH      I            Number spectral chans
C      NIF      I            Number IFs
C      CHNSEL   I(3,20,*)    Start, stop, incr 20 sets per IF
C   Outputs
C      CHFLGS   R(*,*)       1.0 => use, 0.0 => do not use
C-----------------------------------------------------------------------
      INTEGER   NCH, NIF, CHNSEL(3,20,*)
      REAL      CHFLGS(NCH,NIF)
C
      INTEGER   I, J, K
C-----------------------------------------------------------------------
      J = NCH * NIF
      CALL RFILL (J, 0.0, CHFLGS)
      DO 30 K = 1,NIF
         DO 20 J = 1,20
            IF ((CHNSEL(1,J,K).GT.0) .AND. (CHNSEL(3,J,K).GT.0) .AND.
     *         (CHNSEL(2,J,K).GE.CHNSEL(1,J,K))) THEN
               DO 10 I = CHNSEL(1,J,K),CHNSEL(2,J,K),CHNSEL(3,J,K)
                  CHFLGS(I,K) = 1.0
 10               CONTINUE
               END IF
 20         CONTINUE
 30      CONTINUE
C
 999  RETURN
      END

      PROGRAM COLOR
C-----------------------------------------------------------------------
C! converts python color maps to OFM
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Program to extract a colormap from the python definition.
C      A logical or enviroment variable named MYDIR must be defined
C   before running COLOR.
C   The output will be written to a file named name.000 and will
C   be of OFM format (j : B G R) where the python ones are R G B one
C   line per value.  The python have 256 values (none zero), the OFM
C   have j=0 as 0, j=1-2045 interpolating the python values.
C-----------------------------------------------------------------------
      INTEGER   MAXTYP, NGNU
      PARAMETER (MAXTYP = 100)
      PARAMETER (NGNU = 23)
C
      CHARACTER INLINE*100, OUTLIN*100, INFIL*48, OUTFIL*48,
     *   NAME(MAXTYP)*10, GPLBRK(2)*35, GPLDAT*16, GPLTXT(2,NGNU)*35,
     *   GPLTX1(2,10)*35, GPLTX2(2,10)*35, GPLTX3(2,NGNU-20)*35
      INTEGER   I, J, JTRIM, INAME, LUNO, LUNI, NNAMES, IRET, JV,
     *   IB, IG, IR, FINDI, FINDO, K, KBP, KBPLIM, LUTOUT, IDATE(3)
      LOGICAL   REVERS
      REAL      X, V
      DOUBLE PRECISION RV(2048), GV(2048), BV(2048)
      EQUIVALENCE (GPLTXT(1,1), GPLTX1(1,1))
      EQUIVALENCE (GPLTXT(1,11), GPLTX2(1,1))
      EQUIVALENCE (GPLTXT(1,21), GPLTX3(1,1))
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LUNI, LUNO /3, 11/
      DATA GPLDAT /'  Copyright (C) '/
      DATA GPLBRK /'-----------------------------------',
     *             '-----------------------------------'/
      DATA GPLTX1 /'  Associated Universities, Inc. Was',
     *             'hington DC, USA.                   ',
     *             '                                   ',
     *             '                                   ',
     *             '  This program is free software; yo',
     *             'u can redistribute it and/or       ',
     *             '  modify it under the terms of the ',
     *             'GNU General Public License as      ',
     *             '  published by the Free Software Fo',
     *             'undation; either version 2 of      ',
     *             '  the License, or (at your option) ',
     *             'any later version.                 ',
     *             '                                   ',
     *             '                                   ',
     *             '  This program is distributed in th',
     *             'e hope that it will be useful,     ',
     *             '  but WITHOUT ANY WARRANTY; without',
     *             ' even the implied warranty of      ',
     *             '  MERCHANTABILITY or FITNESS FOR A ',
     *             'PARTICULAR PURPOSE.  See the       '/
      DATA GPLTX2 /'  GNU General Public License for mo',
     *             're details.                        ',
     *             '                                   ',
     *             '                                   ',
     *             '  You should have received a copy o',
     *             'f the GNU General Public           ',
     *             '  License along with this program; ',
     *             'if not, write to the Free          ',
     *             '  Software Foundation, Inc., 675 Ma',
     *             'ssachusetts Ave, Cambridge,        ',
     *             '  MA 02139, USA.                   ',
     *             '                                   ',
     *             '                                   ',
     *             '                                   ',
     *             '  Correspondence concerning AIPS sh',
     *             'ould be addressed as follows:      ',
     *             '         Internet email: aipsmail@n',
     *             'rao.edu.                           ',
     *             '         Postal address: AIPS Proje',
     *             'ct Office                          '/
      DATA GPLTX3 /'                         National R',
     *             'adio Astronomy Observatory         ',
     *             '                         520 Edgemo',
     *             'nt Road                            ',
     *             '                         Charlottes',
     *             'ville, VA 22903-2475 USA           '/
C-----------------------------------------------------------------------
C                                       AIPS system start up stuff
      TSKNAM ='COLOR'
      NPOPS = 1
      MSGKIL = 32000
      MSGSUP = 32000
      LUTOUT = 2045
      CALL ZDCHIN (.FALSE.)
      MSGKIL = 32000
C                                       Get list of routines
      INFIL = 'MYDIR:LIST.COLOR'
      CALL ZTXOPN ('READ', LUNI, FINDI, INFIL, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING LIST OF NAMES'
         GO TO 990
         END IF
      NNAMES = 0
C                                       Get names
      DO 20 I = 1,MAXTYP
         CALL ZTXIO ('READ', LUNI, FINDI, INLINE, IRET)
         IF (IRET.EQ.2) THEN
            IRET = 0
            GO TO 30
         ELSE IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING LIST.COLOR'
            GO TO 990
            END IF
         IF ((INLINE(:1).NE.';') .AND. (INLINE(:1).NE.'#')) THEN
            NNAMES = NNAMES + 1
            J = JTRIM (INLINE)
            NAME(NNAMES) = INLINE(:J)
            END IF
 20      CONTINUE
 30   CALL ZTXCLS (LUNI, FINDI, IRET)
C                                       loop over types
      DO 100 INAME = 1,NNAMES
         IF (NAME(INAME)(:1).EQ.'#') GO TO 100
         REVERS = NAME(INAME)(:1).EQ.'-'
         IF (REVERS) THEN
            INFIL = NAME(INAME)(2:)
            NAME(INAME) = INFIL
            END IF
         J = JTRIM (NAME(INAME))
         INFIL = 'MYDIR:' // NAME(INAME)(:J) // '.py'
         CALL ZTXOPN ('READ', LUNI, FINDI, INFIL, .FALSE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING PYTHON FILE'
            GO TO 990
            END IF
         CALL CHLORU('UP', J, NAME(INAME))
         OUTFIL = 'MYDIR:' // NAME(INAME)(:J) // '.000'
         CALL ZTXOPN ('WRIT', LUNO, FINDO, OUTFIL, .FALSE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING OFM FILE WRITE'
            GO TO 990
            END IF
         CALL ZTXIO ('READ', LUNI, FINDI, INLINE, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING FIRST LINE OF PY FILE'
            GO TO 990
            END IF
         OUTLIN = ';;  ' // NAME(INAME)
         J = JTRIM (OUTLIN)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING FIRST LINES OF OFM FILE'
            GO TO 990
            END IF
         OUTLIN = ';;' // GPLBRK(1) // GPLBRK(2)
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', LUNO, FINDO, OUTLIN(:J), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING GPL'
            GO TO 990
            END IF
         CALL ZDATE (IDATE)
         IF (IDATE(1).LT.200) IDATE(1) = IDATE(1) + 1900
         WRITE (OUTLIN,1300) GPLDAT, IDATE(1)
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', LUNO, FINDO, OUTLIN(:J), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING GPL'
            GO TO 990
            END IF
         DO 310 I = 1,NGNU
            OUTLIN = ';;' // GPLTXT(1,I) // GPLTXT(2,I)
            J = JTRIM (OUTLIN)
            CALL ZTXIO ('WRIT', LUNO, FINDO, OUTLIN(:J), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITING GPL'
               GO TO 990
               END IF
 310        CONTINUE
         OUTLIN = ';;' // GPLBRK(1) // GPLBRK(2)
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', LUNO, FINDO, OUTLIN(:J), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING GPL'
            GO TO 990
            END IF
         OUTLIN = ';; AUTHORS: ' // INLINE
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', LUNO, FINDO, OUTLIN(:J), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING FIRST LINE OF OFM FILE'
            GO TO 990
            END IF
C                                       read the python data
         CALL ZTXIO ('READ', LUNI, FINDI, INLINE, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING 2ND LINE OF PY FILE'
            GO TO 990
            END IF
         JV = 1
         KBPLIM = JTRIM (INLINE)
         KBP = INDEX (INLINE, '[[') + 2
         CALL GETNUM (INLINE, KBPLIM, KBP, RV(JV))
         CALL GETNUM (INLINE, KBPLIM, KBP, GV(JV))
         CALL GETNUM (INLINE, KBPLIM, KBP, BV(JV))
         DO 40 JV = 2,1024
            CALL ZTXIO ('READ', LUNI, FINDI, INLINE, IRET)
            IF (IRET.EQ.2) THEN
               IRET = 0
               GO TO 50
            ELSE IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING A LINE OF PY FILE'
               GO TO 990
               END IF
            KBPLIM = INDEX (INLINE, ']') - 1
            KBP = INDEX (INLINE, '[') + 1
            CALL GETNUM (INLINE, KBPLIM, KBP, RV(JV))
            CALL GETNUM (INLINE, KBPLIM, KBP, GV(JV))
            CALL GETNUM (INLINE, KBPLIM, KBP, BV(JV))
            RV(JV) = RV(JV) ** 2.2
            GV(JV) = GV(JV) ** 2.2
            BV(JV) = BV(JV) ** 2.2
 40         CONTINUE
C                                       write the OFM
 50      CALL ZTXCLS (LUNI, FINDI, IRET)
         JV = JV - 1
         write (msgtxt,1150) name(iname), jv
         call msgwrt (4)
 1150    format ('File ',A,' read',I6,' rows')
         WRITE (OUTLIN,1050) 0, 0, 0, 0
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', LUNO, FINDO, OUTLIN(:J), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING 2ND LINE OF OFM FILE'
            GO TO 990
            END IF
         DO 90 I = 1,LUTOUT
            IF (REVERS) THEN
               X = (LUTOUT-I) / (LUTOUT-1.0) * (JV-1.0) + 1.0
            ELSE
               X = (I-1.0) / (LUTOUT-1.0) * (JV-1.0) + 1.0
               END IF
            K = X + 0.0001
            IF (K.EQ.JV) K = K - 1
            V = RV(K) + (RV(K+1)-RV(K)) * (X-K)
            IR = 10000 * V + 0.5
            V = GV(K) + (GV(K+1)-GV(K)) * (X-K)
            IG = 10000 * V + 0.5
            V = BV(K) + (BV(K+1)-BV(K)) * (X-K)
            IB = 10000 * V + 0.5
            WRITE (OUTLIN,1050) I, IB, IG, IR
            CALL ZTXIO ('WRIT', LUNO, FINDO, OUTLIN(:J), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITING OFM FILE'
               GO TO 990
               END IF
 90         CONTINUE
         CALL ZTXCLS (LUNO, FINDO, IRET)
 100  CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I4,' ON ',A)
 1050 FORMAT (I4,' :',3I6)
 1300 FORMAT (';;',A,I4)
      END

      SUBROUTINE ZBKTP2 (ZLUN, ZBKNAM, BAKTXT, BAKREC, IVOL, ICNO,
     *   NTAPE, ZMT0N, LZMT0N, IERR)
C-----------------------------------------------------------------------
C! write a cataloged file plus extensions to BACKUP tape in BAKTP
C# Z Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Host-dependent subroutine to write a file and its extensions to
C   tape using the hosts "backup" utility.
C   Inputs:
C      ZLUN     I       LUN for command file
C      ZBKNAM   C*(*)   Name of command file
C      BAKTXT   C*(*)   lowest file name for file listing
C      BAKREC   C*60    ?
C      IVOL     I       Disk number
C      ICNO     I       Catalog number
C      NTAPE    I       Tape drive number
C      ZMT0N    C*(*)   Tape name (translation of MT0n) n=NTAPE-1
C      LZMT0N   I       Actual length used in ZMT0N
C   Output:
C      IERR     I       Error code: 0 => okay, else ZSHCMD
C   Unix version
C-----------------------------------------------------------------------
C   WRITE (ZLUN,'(''tar cvf /tmp/BAKAIP.TAR *'')')
C   NOTE#1: "tar" normally defaults to reading to EOI and then appending
C   new files. We want to create "savesets" delimited by tapemarks.
C   Therefore, we use the "c" mode of tar to suppress the read, and pass
C   the output through "dd" so that tar will not be able to rewind the
C   tape.
C   NOTE#2: another reason to pipe through "dd" is that it can reblock
C   the file. Experiments show that "dd" is much slower when reblocking,
C   and this is disappointing, but the default block copy ["bs=20b"]
C   results in lots of irregular blocks.  Therefore, we tell tar to
C   produce "1b" [512] blocks, and tell dd to reblock them to "60b"
C   [30720, 94% efficiency 6250].  We need to build a custom
C   asynchronous reblocker for maximum performance on the Convex.
C   NOTE#3: evidence suggests that the Convex Unix "dd" writes a
C   double-tapemark EOI and positions in between the marks.
C-----------------------------------------------------------------------
      INTEGER   ZLUN, IVOL, ICNO, NTAPE, LZMT0N, IERR
      CHARACTER ZBKNAM*(*), BAKTXT*(*), BAKREC*(*), ZMT0N*(*)
C
      INTEGER   ITRIM, JERR, NP, XLEN, LZDA0N, CLEN
      CHARACTER COMMND*40, FNAME*50, GDA0N*4, CTEMP*1, CUSER*3, CCNO*3,
     *   TYPINO*2, MNAME*48, DATVER*1, TEXT*128, ZDA0N*128
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DBTP.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       translate logical DA0n:
      CALL ZEHEX (IVOL, 1, CTEMP)
      GDA0N = 'DA0' // CTEMP
      XLEN = LEN (ZDA0N)
      CALL ZTRLOG (4, GDA0N, XLEN, ZDA0N, LZDA0N, JERR)
      IF (JERR.NE.0) THEN
         IERR = 2
         WRITE (MSGTXT,1000) JERR
         GO TO 990
         END IF
C                                       generate special catalog file:
      CALL ZEHEX (NPOPS, 1, CTEMP)
      FNAME = ZDA0N(1:LZDA0N) // '/BAKTP' // CTEMP // '.TXT'
      OPEN (ZLUN, FILE=FNAME, STATUS='UNKNOWN', ERR=900)
      REWIND ZLUN
      WRITE (ZLUN,1010) BAKREC
      WRITE (ZLUN,1010) SYSNAM
      CLOSE (ZLUN)
C                                       get data-version code:
      CALL H2CHR (2, KHPTYO, CATH(KHPTY), TYPINO)
      CALL ZPHFIL (TYPINO, IVOL, ICNO, 1, MNAME, IERR)
      NP = INDEX (MNAME, TYPINO)
      NP = NP + 2
      DATVER =  MNAME(NP:NP)
C                                       generate command file:
      OPEN (ZLUN, FILE=ZBKNAM, STATUS='OLD', ERR=910)
      REWIND ZLUN
C                                       change to base directory
      TEXT = 'cd ' // ZDA0N(1:LZDA0N)
      JERR = ITRIM (TEXT)
      WRITE (ZLUN,1010,ERR=920) TEXT(1:JERR)
C                                       make special directory
      TEXT = 'mkdir BAKTP' // CTEMP // '.DIR'
      JERR = ITRIM (TEXT)
      WRITE (ZLUN,1010,ERR=920) TEXT(1:JERR)
C                                       change to it
      TEXT = 'cd BAKTP' // CTEMP // '.DIR'
      JERR = ITRIM (TEXT)
      WRITE (ZLUN,1010,ERR=920) TEXT(1:JERR)
C                                       link
      TEXT = 'ln '// FNAME(1:ITRIM(FNAME)) // ' ' //
     *   BAKTXT(1:ITRIM(BAKTXT))
      JERR = ITRIM (TEXT)
      WRITE (ZLUN,1010,ERR=920) TEXT(1:JERR)
      CALL ZEHEX (USER, 3, CUSER)
      CALL ZEHEX (ICNO, 3, CCNO)
      TEXT = 'ln ../??' // DATVER // CCNO // '???.' // CUSER // '? .'
      JERR = ITRIM (TEXT)
      WRITE (ZLUN,1010,ERR=920) TEXT(1:JERR)
C                                       Wait for the Exabyte.
      TEXT = 'MTEX -f ' // ZMT0N(1:LZMT0N)
      JERR = ITRIM (TEXT)
      WRITE (ZLUN,1010,ERR=920) TEXT(1:JERR)
C                                       tar
      TEXT = 'tar cbf 1 - * | dd of=' // ZMT0N(1:LZMT0N) //
     *   ' ibs=1b obs=60b'
      JERR = ITRIM (TEXT)
      WRITE (ZLUN,1010,ERR=920) TEXT(1:JERR)
C                                       cd back up to base
      WRITE (ZLUN,1010,ERR=920) 'cd ..'
C                                       clean up the files
      TEXT = 'rm -r BAKTP' // CTEMP // '.DIR ' // FNAME(1:ITRIM(FNAME))
      JERR = ITRIM (TEXT)
      WRITE (ZLUN,1010,ERR=920) TEXT(1:JERR)
      CLOSE (ZLUN)
C                                       now execute it (Bourne shell):
      COMMND = ZBKNAM
      CLEN = ITRIM (COMMND)
      CALL ZSHCMD (CLEN, COMMND, 8, 'TASK_OUT', IERR)
      GO TO 999
C                                       Errors - can't open catalog
 900  MSGTXT = 'ZBKTP2: CAN''T OPEN ' // FNAME
      IERR = 1
      GO TO 990
C                                       Errors - can't open command
 910  MSGTXT = 'ZBKTP2: CAN''T OPEN ' // ZBKNAM
      IERR = 1
      GO TO 990
C                                       Errors - can't write command
 920  MSGTXT = 'ZBKTP2: CAN''T WRITE ' // ZBKNAM
      IERR = 1
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZBKTP2: CAN''T TRANSLATE DISK LOGICAL NAME, ERR',I6)
 1010 FORMAT (A)
      END

      SUBROUTINE ZBKTP1 (ZLUN, ZBKNAM, BAKTXT, NTAPE, ZMT0N, LZMT0N,
     *   IERR)
C-----------------------------------------------------------------------
C! initialize BACKUP to tape operation for BAKTP
C# Z Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Initialize the host environment in preparation for ZBKTP2.  If
C   OPCODE = 'INIT', initializes the tape too.
C   (used only by task BAKTP)
C   Inputs:
C      NTAPE    I       Tape drive number
C      BAKTXT   C*(*)   lowest file name for file listing (not used
C                       here, only in VMS now)
C   Outputs:
C      ZLUN     I       LUN to use
C      ZBKNAM   C*(*)   Command file name
C      ZMT0N    C*(*)   Tape name (translation of MT0n) n=NTAPE-1
C      LZMT0N   I       Actual length used in ZMT0N
C      IERR     I       Error code: 0 => okay
C   Generic stub
C-----------------------------------------------------------------------
      INTEGER   ZLUN, NTAPE, LZMT0N, IERR
      CHARACTER ZBKNAM*(*), BAKTXT*(*), ZMT0N*(*)
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'ZBKTP1: REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (8)
C
 999  RETURN
      END

      SUBROUTINE QCFFT (C, N, F)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Complex 1-D FFT.
C# AP-FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Full complex 1-D FFT.
C   Inputs:
C      C  I  Base address (0-rel) of complex array to transform
C      N  I  Number of points in array (must be power of two).
C      F  I  Transform direction; 1 -> Forward
C                                -1 -> Backward
C   Input/Output in Common (Include DAPC)
C      WRKFFT(*)  R    Table used in FFT
C      FFTDIR     I    Direction of FFT, used to determine if
C                      WRKFFT needs to be initilized.
C      FFTSZE     I    Size of FFT, used to determine if WRKFFT
C                      needs to be initilized.
C   Usage notes:
C      The array WRKFFT is used to contain the tables necessary for
C   FFTs.  QCFFT initilizes this table if F*2 .NE. FFTDIR or N .NE.
C   FFTSZE.
C   CRI version - WKVECB is used.
C-----------------------------------------------------------------------
      INTEGER   C, N, F
      INCLUDE 'INCS:DAPC.INC'
      INTEGER  IF
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
      IF = -F
C                                       Init table.
      IF (((2*F).NE.FFTDIR) .OR. (N.NE.FFTSZE)) THEN
         CALL CFFT2 (1, IF, N, WKVECB, WRKFFT, WKVECB)
         FFTDIR = F * 2
         FFTSZE = N
         END IF
C
      CALL CFFT2 (0, IF, N, APCORE(C+1), WRKFFT, APCORE(C+1))
C
 999  RETURN
      END

      SUBROUTINE CLD (JD, IY, IM, ID, IWD)
C-----------------------------------------------------------------------
C! Converts Julian date to civil date
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Given is the Julian date corresponding to any instant of
C   absolute time.  Computed are the year, the month, the day in the
C   month, and the day within the week, on the the Greenwich
C   meridian.  NOTE: JD IS ROUNDED BACK TO THE NEAREST NOON.
C-----------------------------------------------------------------------
      DOUBLE PRECISION JD, JD0
      INTEGER   IY, IM, ID, IWD, MTDAY(13), IADD, LEAP,  I
      DOUBLE PRECISION    IDAYS, IREST, JDATE
      DATA MTDAY /0,31,59,90,120,151,181,212,243,273,304,334,365/
      DATA JD0 /1721425.5D0/
C-----------------------------------------------------------------------
      IDAYS = DINT (JD - JD0)
      JDATE = IDAYS
      IY = (IDAYS / 146097)
      IY = IY * 400
      IREST = MOD (IDAYS, 146097.D0)
      IADD = IREST / 36524.0D0
      IF (IADD.NE.4) GO TO 5
         IY = IY + 400
         IDAYS = 365.0D0
         GO TO 15
 5    CONTINUE
         IY = IY + IADD * 100
         IREST = MOD (IREST, 36524.0D0)
         IADD = IREST / 1461.0D0
         IY = IY + IADD * 4
         IREST = MOD (IREST, 1461.D0)
         IADD = IREST / 365.D0
         IF (IADD.NE.4) GO TO 10
            IY = IY + 4
            IDAYS = 365.D0
            GO TO 15
 10      CONTINUE
            IY = IY + IADD + 1
            IDAYS = MOD (IREST, 365.D0)
 15   LEAP = 0
      IF (MOD(IY,4).NE.0) GO TO 20
         LEAP = 1
         IF ((MOD(IY,100).EQ.0) .AND. (MOD(IY,400).NE.0)) LEAP = 0
         IDAYS = IDAYS - LEAP
 20   DO 30 I = 2,13
         IF (IDAYS.GE.MTDAY(I)) GO TO 30
            ID = IDAYS - MTDAY(I-1) + 1
            IM = I - 1
            IF ((LEAP.EQ.0) .OR. (I.GT.3)) GO TO 40
               ID = ID + 1
               IF (ID.NE.32) GO TO 40
                  ID = 1
                  IM = 2
                  GO TO 40
 30      CONTINUE
 40   IWD = MOD (JDATE, 7.D0) + 1
C
 999  RETURN
      END

      SUBROUTINE ZREHEX (NC, HVAL, IVAL)
C-----------------------------------------------------------------------
C! converts extended hexadecimal (base 36) characters into integer
C# Z Service
C-----------------------------------------------------------------------
C;  Copyright (C) 1999
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  Convert nc character extended hexidecimal 'string' to decimal
C  Input:
C     NC     I       Width of receiving field
C     HVAL   C*(*)   Extended hexidecimal string
C  Output:
C     IVAL   I       Decimal value to convert
C  Generic version - klunky but works
C-----------------------------------------------------------------------
      INTEGER   IVAL, NC
      CHARACTER HVAL*(*)
C
      INTEGER   I, J, LC
      CHARACTER HEXC*36
      INCLUDE 'INCS:DDCH.INC'
      DATA HEXC /'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
C-----------------------------------------------------------------------
      LC = MIN (NC, LEN(HVAL))
      IVAL = 0
C                                       loop through digits
      DO 20 I = 1,LC
         DO 10 J = 1,36
            IF (HEXC(J:J).EQ.HVAL(I:I)) GO TO 15
 10         CONTINUE
         GO TO 999
C                                       char found
 15      IVAL = IVAL * 36 + J - 1
 20      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ZDACLS (FCB, MAP, IERR)
C-----------------------------------------------------------------------
C! close a disk file
C# Z2 IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C--------------------------------------------------------------------
C   Close a disk file.
C   Inputs:
C      FCB    I(*)   File control block for open disk file
C      MAP    I      I/O type: 0 => non-map (single buffered)
C                              1 => map (double buffered)
C   Output:
C      IERR   I      Error return code: 0 => ok
C                       1 => error
C                       2 => deassign error
C   Must not call MSGWRT.
C   VMS version.
C-----------------------------------------------------------------------
      INTEGER   FCB(*), MAP, IERR
C
      INTEGER   JERR, SYS$QIOW, SYS$DASSGN, FCODE
      INTEGER*2 IOSB2(4)
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE '($IODEF)'
C-----------------------------------------------------------------------
      IERR = 0
      FCODE = IO$_DEACCESS
      JERR = SYS$QIOW ( , %VAL(FCB(1+FCBFD)), %VAL(FCODE), IOSB2, , , ,
     *   , , , , )
      IF (JERR.EQ.1) THEN
         FCB(1+FCBERR) = IOSB2(1)
         IF (MAP) FCB(1+MFCB+FCBERR) = IOSB2(1)
      ELSE
         IERR = 1
         FCB(1+FCBERR) = JERR
         IF (MAP) FCB(1+MFCB+FCBERR) = JERR
         END IF
C                                       Deassign device
      JERR = SYS$DASSGN (%VAL(FCB(1+FCBFD)))
      IF (JERR.NE.1) THEN
         IERR = 2
         FCB(1+FCBERR) = JERR
         IF (MAP) FCB(1+MFCB+FCBERR) = JERR
         END IF
      FCB(1+FCBFD) = 0
      IF (MAP) FCB(1+MFCB+FCBFD) = 0
C
 999  RETURN
      END

      SUBROUTINE ZR8P4 (OP, INTG, DX)
C-----------------------------------------------------------------------
C! converts pseudo I*4 to double precision - for tape handling only
C# Binary Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZR8P4 converts between pseudo I*4 and Double Precision.  The main
C   use of this is to handle I*4 integers in buffers with mainly I*2
C   integers for tape IO - i.e. EXPORT and IBM format headers.  The
C   assumption is that the full buffer has been treated with (on read
C   of tape) ZI16IL and needs to be repacked to 32 bits and then
C   changed to local integer and then to local D.P.  And the reverse
C   on tape writing.
C   Inputs:
C      OP     C*4    '4IB8' IBM I*4 to D
C                    '8IB4' D to IBM I*4
C   In/out:
C      INTG   I(2)   the I
C      DX     D      the D
C   IBM pseudo-I*4 has the form of a 2's complement, 32-bit integer
C   with the most significant 16 bits in the I word of lower index and
C   the least significant 16 bits in the I word of higher index.
C   Generic version - may work for all
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   INTG(2)
      DOUBLE PRECISION DX
C
      INTEGER   ITEMP, I4
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       '4IB8' : IBM to D.P.
      IF (OP.EQ.'4IB8') THEN
         CALL ZILI16 (2, INTG, 1, ITEMP)
         CALL ZI32IL (1, 1, ITEMP, I4)
         DX = I4
C                                       '8IB4' : D.P. to IBM
      ELSE IF (OP.EQ.'8IB4') THEN
         IF (DX.GT.0.0D0) THEN
            I4 = DX + 0.5D0
         ELSE
            I4 = DX - 0.5D0
            END IF
         CALL ZILI32 (1, I4, 1, ITEMP)
         CALL ZI16IL (2, 1, ITEMP, INTG)
C                                       Illegal OP
      ELSE
         WRITE (MSGTXT,1000) OP
         CALL MSGWRT (9)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZR8P4: OP = ''',A4,''' NOT SUPPORTED - CALL PROGRAMMERS',
     *   ' PLEASE')
      END

      SUBROUTINE TABFQ (OPCODE, BUFFER, IFQRNO, FQKOLS, FQNUMV,
     *   NUMIF, FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IERR)
C-----------------------------------------------------------------------
C! Does I/O to frequency (FQ) table opened by FQINI
C# EXT-util UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2005, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to frequency (FQ) extension tables. Usually used after
C   setup by FQINI.
C   Inputs:
C      OPCODE   C*4    Operation code:
C                      'READ' = read entry from table.
C                      'WRIT' = write entry in table.
C                      'CLOS' = close file, flush on write
C      BUFFER   I(*)   I/O buffer and related storage, also defines file
C                      if open. Should have been returned by FQINI or
C                      TABINI.
C      IFQRNO   I      Next entry number to read or write.
C      FQKOLS   I(*)   The column pointer array in order,
C                      FQID, IFFREQ, IFCHW, IFTBW, IFSIDE
C      FQNUMV   I(*)   Element count in each column.
C      NUMIF    I      Number of IF's
C   Input/output: (written to or read from frequency table)
C      FQID     I      Frequency ID number, is random parameter
C                      in uv-data.
C      IFFREQ   D(*)   Reference frequency for each IF (Hz)
C      IFCHW    R(*)   Bandwidth of an individual channel (Hz)
C                      Now always written and read as a signed value.
C      IFTBW    R(*)   Total bandwidth of the IF (Hz).  Now written
C                      and read as an unsigned value.
C      IFSIDE   I(*)   Sideband of the IF (-1 => lower, +1 => upper)
C                      Now always written and read as +1
C      BNDCOD   C*8(*) Band code - code for receiver/feed used
C   Output:
C      IFQRNO   I      Next row number.
C      IERR     I      Error code, 0=>OK else TABIO error.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, BNDCOD(*)*(*)
      INTEGER   BUFFER(*), IFQRNO, FQKOLS(*), FQNUMV(*), NUMIF, FQID,
     *   IFSIDE(*), IERR
      DOUBLE PRECISION IFFREQ(*)
      REAL      IFCHW(*), IFTBW(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   RECI(1+MAXIF*5), KOLS(MAXFQC), IDKOL, FRQKOL, CHKOL,
     *   TBWKOL, SIDKOL, BNDKOL, IFLP, NDATA, ISIGN, JTRIM, I
      REAL      RECORD(1+MAXIF*7)
      HOLLERITH RECH(1+MAXIF*7)
      DOUBLE PRECISION RECD(MAXIF*4)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (KOLS(1), IDKOL), (KOLS(2), FRQKOL),
     *   (KOLS(3), CHKOL), (KOLS(4), TBWKOL), (KOLS(5), SIDKOL),
     *   (KOLS(6), BNDKOL)
      EQUIVALENCE (RECD, RECORD, RECI, RECH)
C-----------------------------------------------------------------------
C                                       set local pointers
      NDATA = MAXFQC
      CALL COPY (NDATA, FQKOLS, KOLS)
C                                       Close
      IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, IFQRNO, RECORD, BUFFER, IERR)
C                                       If write fill RECORD
      ELSE IF (OPCODE.EQ.'WRIT') THEN
         RECI(IDKOL) = FQID
         DO 10 IFLP = 1, NUMIF
C                                       Work out sign of increment
            ISIGN = +1
            IF ((IFCHW(IFLP).LT.0.0) .OR. (IFSIDE(IFLP).LT.0))
     *         ISIGN = -1
            RECD(FRQKOL) = IFFREQ(IFLP)
            FRQKOL = FRQKOL + 1
            RECORD(CHKOL) = ISIGN * ABS(IFCHW(IFLP))
            CHKOL = CHKOL + 1
            RECORD(TBWKOL) = ABS(IFTBW(IFLP))
            TBWKOL = TBWKOL + 1
            RECI(SIDKOL) = +1
            SIDKOL = SIDKOL + 1
            IF (BNDKOL.GT.0) THEN
               I = JTRIM (BNDCOD(IFLP))
               CALL CHR2H (8, BNDCOD(IFLP), 1, RECH(BNDKOL))
               BNDKOL = BNDKOL + 2
               END IF
 10         CONTINUE
         CALL TABIO ('WRIT', 0, IFQRNO, RECORD, BUFFER, IERR)
         IFQRNO = IFQRNO + 1
C                                       READ
      ELSE
         CALL TABIO (OPCODE, 0, IFQRNO, RECORD, BUFFER, IERR)
         IFQRNO = IFQRNO + 1
C                                       If READ pick data from RECORD.
         IF (IERR.LE.0) THEN
            FQID = RECI(IDKOL)
            DO 20 IFLP = 1, NUMIF
C                                       Work out sign of increment
               ISIGN = +1
               IF ((RECORD(CHKOL).LT.0.0) .OR. (RECI(SIDKOL).LT.0))
     *            ISIGN = -1
               IFFREQ(IFLP) = RECD(FRQKOL)
               FRQKOL = FRQKOL + 1
               IFCHW(IFLP) = ISIGN * ABS(RECORD(CHKOL))
               CHKOL = CHKOL + 1
               IFTBW(IFLP) = ABS(RECORD(TBWKOL))
               TBWKOL = TBWKOL + 1
               IFSIDE(IFLP) = +1
               SIDKOL = SIDKOL + 1
               IF (BNDKOL.GT.0) THEN
                  CALL H2CHR (8, 1, RECH(BNDKOL), BNDCOD(IFLP))
                  I = JTRIM (BNDCOD(IFLP))
                  BNDKOL = BNDKOL + 2
               ELSE
                  BNDCOD(IFLP) = ' '
                  END IF
 20            CONTINUE
            END IF
         END IF
C                                       Error
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('TABFQ: TABIO ERROR',I3)
      END

LOCAL INCLUDE 'DT2PD.INC'
C                                       Local include for TAPPE
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   SEQI, OUTVER, CNOI, DISKI, MAXVER, NROW, NIF, NCH, NANT
      HOLLERITH XNAMEI(3), XCLASI(2), XINFIL(12)
      CHARACTER NAMEI*12, CLASSI*6, TTYPE*2, INFILE*48
      REAL      XSEQI, XDISKI, XFQID, XSUBA, BADD(10)
      COMMON /INPARM/ XNAMEI, XCLASI, XSEQI, XDISKI, XFQID, XSUBA,
     *   XINFIL, BADD
      COMMON /OTHER/ SEQI, OUTVER, CNOI, DISKI, MAXVER, NROW, NIF, NCH,
     *   NANT
      COMMON /CHRCOM/ NAMEI, CLASSI, TTYPE, INFILE
LOCAL END
      PROGRAM DT2PD
C-----------------------------------------------------------------------
C! Converts D term text file to PD extension table
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2021-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task DT2PD converts D term text file to PD table
C   Inputs:
C      AIPS Adverb   Prg. Name          Description
C      INNAME         NAMEI         File name.
C      INCLASS        CLASI         File class.
C      INSEQ          SEQI          File sequence number.
C      INDISK         DISKI         Disk volume on which file resides.
C      OUTVER         OUTVER        Input file input version number
C      FREQID         FRQSEL        FQ ID number     0 -> 1
C      SUBARRAY       ISUBA         Subarray number  0 -> 1
C      INFILE         INFILE        text file
C      BADDISK        IBADD(10)     Disks to avoid for scratch.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   IRET, SCRBUF(512)
      LONGINT   PDTERM
      REAL      DTERMS(2)
      INCLUDE 'DT2PD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C                                       Set file info
      CALL DT2PDI (SCRBUF, PDTERM, DTERMS, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Do operation
      CALL DT2PDD (NIF, NCH, NANT, DTERMS(1+PDTERM), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Write end message
 990  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE DT2PDI (SCRBUF, PDTERM, DTERMS, IRET)
C-----------------------------------------------------------------------
C   DT2PDI performs initialization for DT2PD and reads the D term text
C   file
C   Output:
C      SCRBUF   I(*)     Scratch
C      IRET     I        Error code: 0 -> okay
C-----------------------------------------------------------------------
      INTEGER   IRET, SCRBUF(*)
      LONGINT   PDTERM
      REAL      DTERMS(*)
C
      CHARACTER PRGM*6, PTYPE*2, STAT*4
      INTEGER   NPARM, IROUND, I, NWORDS
      INCLUDE 'DT2PD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA PRGM /'DT2PD'/
C-----------------------------------------------------------------------
C                                       Init I/O, parameters
      NPARM = 31
      CALL SETUP (PRGM, NPARM, XNAMEI, SCRBUF, IRET)
      IF (IRET.NE.0) GO TO 990
      SEQI = IROUND (XSEQI)
      DISKI = IROUND (XDISKI)
      SUBARR = XSUBA + 0.1
      FRQSEL = XFQID + 0.1
      IF (SUBARR.LE.0) SUBARR = 1
      IF (FRQSEL.LE.0) FRQSEL = 1
      CALL H2CHR (12, 1, XNAMEI, NAMEI)
      CALL H2CHR (6, 1, XCLASI, CLASSI)
      CALL H2CHR (48, 1, XINFIL, INFILE)
      TTYPE = 'PD'
C                                       Open file and get CATBLK.
C                                       Get CATBLK from old file.
      CNOI = 1
      PTYPE = '  '
      CALL CATDIR ('SRCH', DISKI, CNOI, NAMEI, CLASSI, SEQI, PTYPE,
     *   NLUSER, STAT, SCRBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1005) IRET, NAMEI, CLASSI, SEQI, DISKI, NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKI, CNOI, CATBLK, 'REST', SCRBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       BADDISK
      DO 10 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 10      CONTINUE
C                                       find version numbers
      CALL FXHDEX (CATBLK)
      CALL FNDEXT (TTYPE, CATBLK, MAXVER)
      OUTVER = MAXVER + 1
      CALL UVPGET (IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'ERROR GETTING HEADER PARAMETERS'
         GO TO 990
         END IF
C                                       get Dterms
      CALL COPY (256, CATBLK, CATUV)
      IUDISK = DISKI
      IUCNO = CNOI
      CALL GETANT (IUDISK, IUCNO, SUBARR, CATUV, SCRBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ ANTNENNA INFORMATION'
         GO TO 990
         END IF
      NCH = CATBLK(KINAX+JLOCF)
      NIF = 1
      IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
      NANT = NSTNS
      NWORDS = 2 * NCH * NIF * 2 * NANT + 2048
      NWORDS = (NWORDS - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', 'DT2PD', NWORDS, DTERMS, PDTERM, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'FAILED TO GET REQUESTED MEMORY FOR PD FILE'
         GO TO 990
         END IF
      KLOCFY = JLOCF
      CALL GDTERM (NIF, NCH, NANT, INFILE, DTERMS(1+PDTERM), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'GETTING D TERMS FROM TEXT FILE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DT2PDI: ERROR',I4,' ON ',A)
 1005 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1010 FORMAT ('ERROR',I3,' READ HEADER, SETTING STATUS')
      END
      SUBROUTINE DT2PDD (NI, NF, NA, DTERMS, IRET)
C-----------------------------------------------------------------------
C   DT2PDD writes the PD table
C   Input:
C      NIF      I      Number IFs
C      NCH      I      Number spectral channels
C      NANT     I      Number antennas
C      DTERMS   R(*)   Dterms (2,nch,nif,2,nant)
C   Output:
C      IRET     I      Error code - 0 okay
C-----------------------------------------------------------------------
      INTEGER   NI, NF, NA, IRET
      REAL      DTERMS (2,NF,NI,2,*)
C
      INTEGER   MAXPDC
      PARAMETER (MAXPDC = 9)
      INCLUDE 'INCS:PUVD.INC'
C
      INCLUDE 'DT2PD.INC'
      INTEGER   PDBUFF(512), LUN, IPDRNO, PDKOLS(MAXPDC),
     *   PDNUMV(MAXPDC), ISUB, IFQ, REFA, IROW, NUMP
      REAL      PHDIFF(MAXCIF)
      CHARACTER POLTYP*8
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
C                                       open PD table
      LUN = 32
      NUMP = 2
      POLTYP = 'APPROX'
      CALL PDINI ('WRIT', PDBUFF, DISKI, CNOI, OUTVER, CATBLK, LUN,
     *   IPDRNO, PDKOLS, PDNUMV, NANT, NUMP, NIF, NCH, POLTYP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATING, OPENING PD TABLE'
         GO TO 980
         END IF
      ISUB = 0
      IFQ = 0
      REFA = 0
      CALL RFILL (MAXCIF, 0.0, PHDIFF)
C                                       write PD table
      DO 100 IROW = 1,NANT
         IPDRNO = IROW
         CALL TABPD ('WRIT', PDBUFF, IPDRNO, PDKOLS, PDNUMV, NIF,
     *      NCH, NUMP, IROW, ISUB, IFQ, REFA, PHDIFF,
     *      DTERMS(1,1,1,1,IROW), IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE PD TABLE'
            GO TO 980
            END IF
 100     CONTINUE
C                                       done!
      CALL TABPD ('CLOS', PDBUFF, IPDRNO, PDKOLS, PDNUMV, NIF,
     *   NCH, NUMP, NANT, ISUB, IFQ, REFA, PHDIFF, DTERMS, IRET)
      IRET = 0
      GO TO 999
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DT2PDD: ERROR',I4,' ON ',A)
      END

       SUBROUTINE AU5 (BRANCH)
C-----------------------------------------------------------------------
C! basic TV verbs to do on/off, read cursor position, init the TV, ...
C# POPS-appl TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2003, 2006, 2008-2009, 2012
C;  Copyright (C) 2014-2015, 2021, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Do most common image functions:
C   BRANCH =   1 => initialize image device
C              2 => clear image channel(s)
C              3 => clear graphics channel(s)
C              4 => turn on selected image channel(s)
C              5 => turn off image channel(s)
C              6 => turn on graphics channel(s)
C              7 => turn off graphics
C              8 => select standard color channels
C              9 => read cursor position in screen coord
C             10 => read cursor position in map coord
C             11 => read cursor position in sky coord
C             12 => use cursor to fill in INNAME, INCLASS, INSEQ
c                   from selected image
C             13 => Switch cursor to/from blinking
C             14 => Read graphics channel color
C             15 => Write graphics channel color
C             16 => Write character multiply factor
C             17 => Set JMFIT/IMFIT initial guess adverbs
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER RSTR*20, ONCODE(2)*4, NAME*18, CLASS*6, TYPE*2,
     *   PRGNAM*6, CDUM*1, VNAME(3)*6
      INTEGER   IERR, IPL, ICHAN, INCH, INBUF(MABFSS), ICOLOR, JON,
     *   JTVPOS, DUM, IN1, IN2, I, ICH, ILEN, IX, IY, JERR, POTERR, IGR,
     *   ITEMP, ZAND, ZOR, IDUM, IC, MSGSAV, NBO, MBOX, NG, QUAD, DLUN,
     *   DIND, JBUFSZ, WIN(4), OFBLK, IBUT, CNO, SEQNO, IVOL, NX, NY,
     *   CATIMG(256), ININD, IXC(33), IYC(33)
      LOGICAL   F, LGRAPH, PFLAG, ROAMED
      REAL      EPS, RPOS(2), RDUM(2), XYPOS(7), XCOORD(6), BLCO(7),
     *   TRCO(7), GMAX(4), GPOS(2,4), GWID(3,4), ARRAY(16,16), DX(2),
     *   RBUFF(MABFSS), SLOPE, OFFS, CG, SG, X, Y
      DOUBLE PRECISION SKYPOS(3)
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (INBUF, RBUFF)
      COMMON /AIPSCR/ INBUF
      DATA PRGNAM /'AU5 '/
      DATA F /.FALSE./
      DATA JON, JTVPOS /4, 9/
      DATA ONCODE /'ONNN', 'OFFF'/
      DATA EPS /.01/
      DATA VNAME /'TVPOS', 'IMXY', 'IMPOS'/
C-----------------------------------------------------------------------
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.17)) GO TO 999
      POTERR = 49
      CALL TVOPEN (CATBLK, JERR)
      IF (JERR.NE.0) THEN
         POTERR = 101
         GO TO 990
         END IF
      ROAMED = (TVLIMG(1).NE.TVLIMG(2)) .OR. (TVLIMG(1).NE.TVLIMG(3))
     *   .OR. (TVLIMG(1).NE.TVLIMG(4))
      MSGSAV = MSGSUP
      JBUFSZ = 2 * MABFSS
C
      GO TO (100, 200, 300, 400, 400, 400, 400, 500, 600, 600, 600,
     *   650, 700, 750, 750, 800, 650), BRANCH
C-----------------------------------------------------------------------
C                                       TVINIT
C                                       initialize subunits
C-----------------------------------------------------------------------
 100  CALL YINIT (INBUF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1100) JERR
         GO TO 980
         END IF
      GO TO 970
C-----------------------------------------------------------------------
C                                       TVCLEAR
C                                       clear gray img & catalog
C-----------------------------------------------------------------------
 200  CALL ADVERB ('TVCHAN', 'I', 1, 0, ICHAN, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 985
      IF ((ICHAN.GE.1) .AND. (ICHAN.LE.NGRAY)) THEN
         IC = 2 ** (ICHAN-1)
      ELSE
         ITEMP = 2 ** NGRAY - 1
         IC = ZAND (IC, TVLIMG(1))
         IC = ZOR (IC, TVLIMG(2))
         IC = ZOR (IC, TVLIMG(3))
         IC = ZOR (IC, TVLIMG(4))
         END IF
      CALL MOVIST ('OFFF', IC, 0, 0, 0, IERR)
      CALL YHOLD ('ONNN', JERR)
      DO 210 IP = 1,NGRAY
         ITEMP = 2**(IP-1)
         IF (ZAND(IC,ITEMP).NE.0) THEN
            CALL YCINIT (IP, INBUF)
            CALL YZERO (IP, JERR)
            IF (JERR.NE.0) GO TO 985
            END IF
 210     CONTINUE
      CALL YHOLD ('OFFF', JERR)
      GO TO 970
C-----------------------------------------------------------------------
C                                       GRCLEAR
C                                       clear graphics plane
C-----------------------------------------------------------------------
 300  CALL ADVERB ('GRCHAN', 'I', 1, 0, ICHAN, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 985
      ICHAN = MOD (ICHAN, 10)
      IF ((ICHAN.GT.0) .AND. (ICHAN.LE.NGRAPH)) THEN
         IC = 2 ** (ICHAN-1)
      ELSE
         IC = 2 ** NGRAPH - 1
         END IF
      IN1 = NGRAY + 1
      IN2 = NGRAY + NGRAPH
      CALL YHOLD ('ONNN', JERR)
      DO 310 IP = IN1,IN2
         ITEMP = 2 ** (IP-IN1)
         IF (ZAND(IC, ITEMP).NE.0) THEN
            CALL YCINIT (IP, INBUF)
            CALL YZERO (IP, JERR)
            IF (JERR.NE.0) GO TO 985
            END IF
 310     CONTINUE
      CALL YHOLD ('OFFF', JERR)
      GO TO 970
C-----------------------------------------------------------------------
C                                       TVON
C                                       TVOFF
C                                       GRON
C                                       GROFF
C                                       select TV channels on/off
C-----------------------------------------------------------------------
 400  IF ((ROAMED) .AND. (BRANCH.EQ.4)) THEN
         POTERR = 77
         GO TO 985
         END IF
      DUM = BRANCH - JON
      DUM = MOD (DUM , 2)
      LGRAPH = ((BRANCH - JON)/2.EQ.1)
      INCH = NGRAY
      IF (LGRAPH) INCH = NGRAPH
      IC = 0
      IF ((SP.GE.1) .AND. (STACK(SP).NE.2)) THEN
         IC = V(SP) + EPS
         SP = SP - 1
         END IF
      IF (IC.LE.0) THEN
         IF (LGRAPH) THEN
            CALL ADVERB ('GRCHAN', 'I', 1, 0, ICHAN, RDUM, CDUM)
            ICHAN = MOD (ICHAN, 10)
         ELSE
            CALL ADVERB ('TVCHAN', 'I', 1, 0, ICHAN, RDUM, CDUM)
            END IF
         IF (ERRNUM.NE.0) GO TO 985
         IF ((ICHAN.GT.0) .AND. (ICHAN.LE.INCH)) IC = 2 ** (ICHAN-1)
         END IF
      IF ((BRANCH.EQ.7) .AND. (IC.EQ.0)) IC = 2 ** NGRAPH - 1
      CALL ADVERB ('COLORS', 'I', 1, 0, ICOLOR, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 985
      IF ((ICOLOR.LT.0) .OR. (ICOLOR.GT.3)) THEN
         POTERR = 101
         WRITE (MSGTXT,1410) ICOLOR
         GO TO 980
         END IF
      IF (IC.EQ.0) IC = 1
      IF (LGRAPH) THEN
         IN1 = 1 + NGRAY
         IN2 = NGRAPH + NGRAY
         IC = IC * (2**NGRAY)
      ELSE
         IN1 = 1
         IN2 = NGRAY
         END IF
      CALL YHOLD ('ONNN', JERR)
      DO 425 IP = IN1,IN2
         ITEMP = 2**(IP-1)
         IF (ZAND (IC,ITEMP).NE.0) THEN
            CALL YSLECT (ONCODE(1+DUM), IP, ICOLOR ,INBUF, JERR)
            IF (JERR.NE.0) GO TO 985
            END IF
 425     CONTINUE
      CALL YHOLD ('OFFF', JERR)
      GO TO 970
C-----------------------------------------------------------------------
C                                       TV3COLOR
C                                       set standard RGB in chan 123
C-----------------------------------------------------------------------
C                                       turn all off first
 500  IF (ROAMED) THEN
         POTERR = 77
         GO TO 985
         END IF
      CALL ADVERB ('TVCHAN', 'I', 1, 0, ICHAN, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 985
      ICHAN = MAX (1, MIN (NGRAY-2, ICHAN))
      CALL YHOLD ('ONNN', JERR)
      DO 510  IP = 1,NGRAY
         CALL YSLECT ('OFFF', IP, 0, INBUF, JERR)
         IF (JERR.NE.0) GO TO 985
 510     CONTINUE
      DO 520  IP = 1,3
         CALL YSLECT ('ONNN', ICHAN, IP, INBUF, JERR)
         IF (JERR.NE.0) GO TO 985
         ICHAN = ICHAN + 1
 520     CONTINUE
      CALL YHOLD ('OFFF', JERR)
      GO TO 970
C-----------------------------------------------------------------------
C                                       TVPOS
C                                       IMXY
C                                       IMPOS
C                                       read cursor to get position
C-----------------------------------------------------------------------
 600  MSGTXT = VNAME(BRANCH-8)(:5) // ': position TV cursor, then push'
     *   // ' button A, B, C, or D'
      CALL MSGWRT (1)
      CALL TVWHER (QUAD, RPOS, IBUT, JERR)
      IF (JERR.NE.0) GO TO 985
      CALL ADVRBS ('TVBUT', 'I', 1, 0, IBUT, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 985
      IF (BRANCH.EQ.JTVPOS) THEN
         CALL ADVRBS ('TVXY', 'R', 2, 0, IDUM, RPOS, CDUM)
         IF (ERRNUM.NE.0) GO TO 985
         GO TO 970
         END IF
C                                       image pix -> map pixel pos
      IX = RPOS(1) + EPS
      IY = RPOS(2) + EPS
C                                       Find lowest plane with x,y
      IN2 = NGRAY + NGRAPH
      DO 610 IP = 1,IN2
C                                       skip off channels
         ITEMP = 2**(IP-1)
         IF (ZAND (TVLIMG(QUAD), ITEMP).NE.0) THEN
C                                       get img cat block
            CALL YCREAD (IP, IX, IY, CATBLK, IERR)
            IF (IERR.EQ.0) GO TO 620
C                                       loop if x,y not in image
            IF (IERR.NE.1) GO TO 985
            END IF
 610     CONTINUE
C                                       x,y not in on image
      WRITE (MSGTXT,1610) IX, IY
      CALL MSGWRT (6)
      GO TO 970
C                                       image -> map positions
 620  CALL IMA2MP (RPOS, RPOS)
      WRITE (MSGTXT,1620) RPOS
      CALL MSGWRT (5)
      IF (BRANCH.EQ.JTVPOS+1) THEN
         XYPOS(1) = RPOS(1)
         XYPOS(2) = RPOS(2)
         DO 625 I = 3,7
            XYPOS(I) = CATBLK(IIDEP+I-3)
 625        CONTINUE
         CALL ADVRBS ('PIXXY', 'R', 7, 0, IDUM, XYPOS, CDUM)
         IF (ERRNUM.NE.0) GO TO 985
C                                       map -> sky positions
      ELSE
         LOCNUM = 1
         CALL MP2SKY (RPOS, SKYPOS, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1625) IERR
            CALL MSGWRT (6)
            GO TO 970
            END IF
         IF ((AXTYP(LOCNUM).EQ.2) .OR. (AXTYP(LOCNUM).EQ.3)) CALL AXSTRN
     *      (CTYP(3,LOCNUM), SKYPOS(3), KLOCA(LOCNUM), NCHLAB(1,LOCNUM),
     *      SAXLAB(1,LOCNUM))
C                                       Primary axes
         MSGTXT = 'IMPOS: '
         ICH = 8
         DO 630 I = 1,2
            ITEMP = I-1
            CALL AXSTRN (CTYP(I,LOCNUM), SKYPOS(I), ITEMP, ILEN, RSTR)
            MSGTXT(ICH:) = RSTR(:ILEN)
            ICH = ICH + ILEN + 2
            IF ((CTYP(I,LOCNUM)(:4).EQ.'RA  ') .OR.
     *         (CTYP(I,LOCNUM)(:4).EQ.'RA--')) SKYPOS(I) = SKYPOS(I) /
     *         15.0D0
            PFLAG = SKYPOS(I).LT.0.0D0
            SKYPOS(I) = ABS (SKYPOS(I))
            IX = SKYPOS(I)
            XCOORD(3*I-2) = IX
            SKYPOS(I) = (SKYPOS(I) - IX) * 60.0D0
            IX = SKYPOS(I)
            XCOORD(3*I-1) = IX
            XCOORD(3*I) = (SKYPOS(I) - IX) * 60.0D0
            IF (PFLAG) THEN
               XCOORD(3*I-2) = -XCOORD(3*I-2)
               XCOORD(3*I-1) = -XCOORD(3*I-1)
               XCOORD(3*I) = -XCOORD(3*I)
               END IF
 630        CONTINUE
         CALL MSGWRT (5)
         CALL ADVRBS ('COORDINA', 'R', 6, 0, IDUM, XCOORD, CDUM)
C                                       Secondary axes values
         IF ((NCHLAB(1,LOCNUM).GT.0) .OR. (NCHLAB(2,LOCNUM).GT.0)) THEN
            ICH = 8
            MSGTXT(ICH:) = ' '
            DO 635 I = 1,2
               IF (NCHLAB(I,LOCNUM).GT.0) THEN
                  MSGTXT(ICH:) = SAXLAB(I,LOCNUM)(:NCHLAB(I,LOCNUM))
                  ICH = ICH + NCHLAB(I,LOCNUM) + 2
                  END IF
 635           CONTINUE
            CALL MSGWRT (5)
            END IF
         END IF
      GO TO 970
C-----------------------------------------------------------------------
C                                       TVNAME
C                                       read cursor to set name adverbs
C-----------------------------------------------------------------------
 650  IX = NGRAY + NGRAPH
      MSGSUP = 32000
      CALL TVFIND (IX, 'MA', IP, LGRAPH, CATBLK, INBUF, JERR)
      MSGSUP = MSGSAV
C                                       roamed - find anyway
      IF (JERR.EQ.4) THEN
         MSGTXT = 'TVNAME: position TV cursor, then push'
     *      // ' button A, B, C, or D'
         CALL MSGWRT (1)
         CALL TVWHER (QUAD, RPOS, IBUT, JERR)
         IF (JERR.NE.0) GO TO 985
         IX = RPOS(1) + EPS
         IY = RPOS(2) + EPS
         IN2 = NGRAY + NGRAPH
         DO 660 IP = 1,IN2
C                                       skip off channels
            ITEMP = 2**(IP-1)
            IF (ZAND (TVLIMG(QUAD), ITEMP).NE.0) THEN
               CALL YCREAD (IP, IX, IY, CATBLK, JERR)
C                                       loop if x,y not in image
               IF (JERR.NE.1) GO TO 670
               END IF
 660        CONTINUE
         END IF
 670  IF (JERR.NE.0) GO TO 985
C                                       set name adverbs
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), NAME)
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), CLASS)
      CALL H2CHR (2, KHPTYO, CATH(KHPTY), TYPE)
      CALL ADVRBS ('INNAME', 'C', 1, 12, IDUM, RDUM, NAME(:12))
      IF (ERRNUM.NE.0) GO TO 985
      CALL ADVRBS ('INCLASS', 'C', 1, 6, IDUM, RDUM, CLASS)
      IF (ERRNUM.NE.0) GO TO 985
      CALL ADVRBS ('INTYPE', 'C', 1, 2, IDUM, RDUM, TYPE)
      IF (ERRNUM.NE.0) GO TO 985
      SEQNO = CATBLK(KIIMS)
      CALL ADVRBS ('INSEQ', 'I', 1, 0, SEQNO, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 985
      IVOL = CATBLK(IIVOL)
      IF ((IVOL.GT.0) .AND. (IVOL.LE.NVOL)) THEN
         CALL ADVRBS ('INDISK', 'I', 1, 0, IVOL, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 985
         END IF
      CALL ADVERB ('INDISK', 'I', 1, 0, I, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 985
      WRITE (MSGTXT,1670) CATBLK(KIIMU), I, TYPE
      NAME(13:) = CLASS
      CALL NAMEST (NAME, CATBLK(KIIMS), MSGTXT(40:), I)
      CALL MSGWRT (2)
      IF (BRANCH.EQ.17) GO TO 850
      GO TO 970
C-----------------------------------------------------------------------
C                                       CURBLINK
C                                       Switch cursor blink / steady
C-----------------------------------------------------------------------
 700  CALL YCURSE ('BLNK', F, F, RPOS, IPL, ICH, JERR)
      IF (JERR.NE.0) GO TO 985
      GO TO 970
C-----------------------------------------------------------------------
C                                       GREAD/GWRITE
C                                       read/write graphics colrs
C-----------------------------------------------------------------------
 750  CALL ADVERB ('GRCHAN', 'I', 1, 0, ICHAN, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 985
      ICHAN = MOD (ICHAN, 10)
      IF ((ICHAN.LT.0) .OR. (ICHAN.GT.NGRAPH+1)) THEN
         WRITE (MSGTXT,1750) ICHAN, NGRAPH
         POTERR = 101
         GO TO 980
      ELSE IF (ICHAN.EQ.NGRAPH+1) THEN
         ICHAN = 0
         END IF
C                                       Do the read
      IF (BRANCH.EQ.14) THEN
         CALL YGRAFX ('READ', ICHAN, XYPOS(1), XYPOS(2), XYPOS(3),
     *      JERR)
         IF (JERR.NE.0) GO TO 985
         IF (ICHAN.NE.0) THEN
            WRITE (MSGTXT,1760) ICHAN, XYPOS(1), XYPOS(2), XYPOS(3)
         ELSE
            WRITE (MSGTXT,1761) XYPOS(1), XYPOS(2), XYPOS(3)
            END IF
         CALL MSGWRT (3)
         CALL ADVRBS ('RGBCOLOR', 'R', 3, 0, IDUM, XYPOS, CDUM)
         IF (ERRNUM.NE.0) GO TO 985
C                                       Check Write values
      ELSE
         CALL ADVERB ('RGBCOLOR', 'R', 3, 0, IDUM, XYPOS, CDUM)
         IF (ERRNUM.NE.0) GO TO 985
         IF ((XYPOS(1).LT.0.0) .OR. (XYPOS(1).GT.1.0) .OR.
     *      (XYPOS(2).LT.0.0) .OR. (XYPOS(2).GT.1.0) .OR.
     *      (XYPOS(3).LT.0.0) .OR. (XYPOS(3).GT.1.0)) THEN
            POTERR = 101
            WRITE (MSGTXT,1770) XYPOS(1), XYPOS(2), XYPOS(3)
            GO TO 980
            END IF
         IF ((XYPOS(1).LT.0.1) .AND. (XYPOS(2).LT.0.1) .AND.
     *      (XYPOS(3).LT.0.1)) THEN
            IF (ICHAN.EQ.0) THEN
               MSGTXT = 'COLORS TOO DARK FOR A CURSOR'
               POTERR = 101
               GO TO 980
            ELSE IF (ICHAN.NE.NGRAPH) THEN
               MSGTXT = 'You may not like this dark color'
               CALL MSGWRT (6)
               END IF
         ELSE IF (ICHAN.EQ.NGRAPH) THEN
            MSGTXT = 'You may not like this bright background color'
            CALL MSGWRT (6)
            END IF
         CALL YGRAFX ('WRIT', ICHAN, XYPOS(1), XYPOS(2), XYPOS(3),
     *      JERR)
         IF (JERR.NE.0) GO TO 985
         END IF
      GO TO 970
C-----------------------------------------------------------------------
C                                       CHARMULT
C                                       multiply tv character
C-----------------------------------------------------------------------
 800  IC = 0
      IF ((SP.GE.1) .AND. (STACK(SP).NE.2)) THEN
         IC = V(SP) + EPS
         SP = SP - 1
         END IF
      IF ((IC.LE.0) .OR. (IC.GT.5)) THEN
         CALL ADVERB ('FACTOR', 'I', 1, 0, IC, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 985
         IF ((IC.LE.0) .OR. (IC.GT.5)) THEN
            MSGTXT = 'FACTOR OUT OF RANGE 1-5'
            POTERR = 27
            GO TO 980
            END IF
         END IF
      POTERR = 49
      CALL YCMULT (IC, JERR)
      IF (JERR.NE.0) GO TO 985
      GO TO 970
C-----------------------------------------------------------------------
C                                       MFITSET
C                                       set JMFIT initial guess
C-----------------------------------------------------------------------
C                                       TVWIN set BLC, TRC
 850  POTERR = 31
      IGR = MIN (3, NGRAPH)
      IF (IGR.LE.0) GO TO 985
      IPL = IGR + NGRAY
      CALL YCINIT (IPL, INBUF)
      CALL ADVERB ('BLC', 'R', 7, 0, IDUM, BLCO, CDUM)
      IF (ERRNUM.NE.0) GO TO 985
      CALL ADVERB ('BLC', 'R', 7, 0, IDUM, TRCO, CDUM)
      IF (ERRNUM.NE.0) GO TO 985
      NBO = 0
      MBOX = 1
      CALL GRBOXS (IGR, MBOX, NBO, BLCO, TRCO, INBUF, IERR)
      POTERR = 49
      IF (IERR.NE.0) GO TO 985
C                                       store BLC, TRC
      POTERR = 0
      WRITE (MSGTXT,1850) 'BLC', BLCO
      CALL MSGWRT (2)
      WRITE (MSGTXT,1850) 'TRC', TRCO
      CALL MSGWRT (2)
      CALL ADVRBS ('BLC', 'R', 7, 0, IDUM, BLCO, CDUM)
      IF (ERRNUM.NE.0) GO TO 985
      CALL ADVRBS ('TRC', 'R', 7, 0, IDUM, TRCO, CDUM)
      IF (ERRNUM.NE.0) GO TO 985
      CALL ADVERB ('GRCHAN', 'I', 1, 0, ICHAN, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 985
      ICHAN = MOD (ICHAN, 10)
C                                       open map file
      DLUN = 16
      CALL MAPOPN ('READ', IVOL, NAME, CLASS, SEQNO, TYPE, NLUSER, DLUN,
     *    DIND, CNO, CATIMG, INBUF, JERR)
      POTERR = 33
      IF (JERR.GT.1) GO TO 985
      NG = 0
      CALL RFILL (4, 0.0, GMAX)
      CALL RFILL (8, 0.0, GPOS)
      CALL RFILL (12, 0.0, GWID)
      POTERR = 49
C                                       Gaussian loop
 860  IF (NG.LT.4) THEN
         NG = NG + 1
         WRITE (CDUM,1860) NG
         MSGTXT = '*** Position cursor at peak of component ' // CDUM
         CALL MSGWRT (1)
         MSGTXT = 'Then hit button A, B, or C; hit D to quit'
         CALL MSGWRT (1)
         CALL TVWHER (QUAD, RPOS, IBUT, JERR)
         IF (JERR.NE.0) GO TO 960
         IF (IBUT.LT.8) THEN
            CALL IMA2MP (RPOS, RPOS)
            IF ((RPOS(1).LT.BLCO(1)) .OR. (RPOS(1).GT.TRCO(1)) .OR.
     *         (RPOS(2).LT.BLCO(2)) .OR. (RPOS(2).GT.TRCO(2))) THEN
               MSGTXT = 'POSITION OUTSIDE WINDOW'
               CALL MSGWRT (8)
               GO TO 960
               END IF
            NX = 5
            NY = 5
            WIN(1) = RPOS(1) - 0.5 * NX + 1.
            WIN(1) = MAX (1, WIN(1))
            WIN(2) = RPOS(2) - 0.5 * NY + 1.
            WIN(2) = MAX (1, WIN(2))
            WIN(3) = WIN(1) + NX - 1
            WIN(3) = MIN (WIN(3), CATIMG(KINAX))
            WIN(4) = WIN(2) + NY - 1
            WIN(4) = MIN (WIN(4), CATIMG(KINAX+1))
            NX = WIN(3) - WIN(1) + 1
            NY = WIN(4) - WIN(2) + 1
            POTERR = 50
            CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CATBLK(IIDEP),
     *         OFBLK, JERR)
            IF (JERR.NE.0) GO TO 960
            OFBLK = OFBLK + 1
            CALL MINIT ('READ', DLUN, DIND, CATBLK(KINAX),
     *         CATBLK(KINAX+1), WIN, RBUFF, JBUFSZ, OFBLK, JERR)
            IF (JERR.NE.0) GO TO 960
            DO 870 IY = 1,NY
               CALL MDISK ('READ', DLUN, DIND, RBUFF, ININD, JERR)
               IF (JERR.NE.0) GO TO 960
               DO 865 IX = 1,NX
                  ARRAY(IX,IY) = RBUFF(IX+ININD-1)
 865              CONTINUE
 870           CONTINUE
               DX(1) = RPOS(1) + 1.0 - WIN(1)
               DX(2) = RPOS(2) + 1.0 - WIN(2)
               JERR = 0
C                                       find maximum in array
            CALL CUBINT (ARRAY, DX, NX, NY, GMAX(NG), JERR)
            IF (JERR.NE.0) GO TO 960
            GPOS(1,NG) = DX(1) + WIN(1) - 1.0
            GPOS(2,NG) = DX(2) + WIN(2) - 1.0
            MSGTXT = 'Position cursor at major axis half-power of '
     *         // 'component ' // CDUM
            CALL MSGWRT (1)
            MSGTXT = 'Then hit button A, B, or C; hit D to quit'
            CALL MSGWRT (1)
            CALL TVWHER (QUAD, RPOS, IBUT, JERR)
            IF (JERR.NE.0) GO TO 960
            IF (IBUT.LT.8) THEN
               CALL IMA2MP (RPOS, RPOS)
               GWID(1,NG) = 2.0 * SQRT ((RPOS(1)-GPOS(1,NG))**2 +
     *            (RPOS(2)-GPOS(2,NG))**2)
               IF (GWID(1,NG).GT.0.0) THEN
                  GWID(3,NG) = -RAD2DG * ATAN2 ((GPOS(1,NG)-RPOS(1)),
     *               (GPOS(2,NG)-RPOS(2)))
                  IF (GWID(3,NG).LT.-90.0) GWID(3,NG) = GWID(3,NG)+180.0
                  IF (GWID(3,NG).GT.90.0) GWID(3,NG) = GWID(3,NG)-180.0
                  END IF
               MSGTXT = 'Position cursor at minor axis half-power of '
     *            // 'component ' // CDUM
               CALL MSGWRT (1)
               MSGTXT = 'Then hit button A, B, or C; hit D to quit'
               CALL MSGWRT (1)
               CALL TVWHER (QUAD, RPOS, IBUT, JERR)
               IF (JERR.NE.0) GO TO 960
               IF (IBUT.LT.8) THEN
                  CALL IMA2MP (RPOS, RPOS)
                  GWID(2,NG) = 2.0 * SQRT ((RPOS(1)-GPOS(1,NG))**2 +
     *               (RPOS(2)-GPOS(2,NG))**2)
                  END IF
               END IF
            END IF
         IF (IBUT.LE.7) THEN
            IF (ICHAN.GT.0) THEN
               IGR = NGRAY + ICHAN
               IF (NG.EQ.1) THEN
                  CALL YZERO (IGR, JERR)
                  IF (JERR.NE.0) THEN
                     WRITE (MSGTXT,1000) JERR, 'ZERO GRAPHICS PLANE'
                     GO TO 955
                     END IF
                  CALL YSLECT ('ONNN', IGR, 7, INBUF, JERR)
                  IF (JERR.NE.0) THEN
                     WRITE (MSGTXT,1000) JERR, 'TURN GRAPHICS PLANE ON'
                     GO TO 955
                     END IF
                  END IF
               SLOPE = TWOPI / 32.0D0
               OFFS = 0.0
               CG = COS (GWID(3,NG) * DG2RAD)
               SG = SIN (GWID(3,NG) * DG2RAD)
               DO 880 I = 1,33
                  X = GWID(1,NG) * COS (OFFS) / 2.0
                  Y = GWID(2,NG) * SIN (OFFS) / 2.0
                  RPOS(1) = Y * CG - X * SG + GPOS(1,NG)
                  RPOS(2) = X * CG + Y * SG + GPOS(2,NG)
                  CALL MP2IMA (RPOS, RPOS)
                  IXC(I) = RPOS(1) + 0.5
                  IYC(I) = RPOS(2) + 0.5
                  IXC(I) = MAX (1, MIN (MAXXTV(1), IXC(I)))
                  IYC(I) = MAX (1, MIN (MAXXTV(2), IYC(I)))
                  OFFS = OFFS + SLOPE
 880              CONTINUE
               CALL IMVECT ('ONNN', IGR, 33, IXC, IYC, RBUFF, JERR)
               IF (JERR.NE.0) THEN
                  WRITE (MSGTXT,1000) JERR,
     *               'DRAWING GAUSSIAN HALF-WIDTH'
                  GO TO 955
                  END IF
               END IF
            GO TO 860
            END IF
         END IF
      IF (IBUT.GT.7) NG = NG - 1
C                                       put adverbs
      POTERR = 0
      CALL ADVRBS ('GMAX', 'R', 4, 0, IDUM, GMAX, CDUM)
      IF (ERRNUM.NE.0) GO TO 960
      CALL ADVRBS ('GPOS', 'R', 8, 0, IDUM, GPOS, CDUM)
      IF (ERRNUM.NE.0) GO TO 960
      CALL ADVRBS ('GWIDTH', 'R', 12, 0, IDUM, GWID, CDUM)
      IF (ERRNUM.NE.0) GO TO 960
      CALL ADVRBS ('NGAUSS', 'I', 1, 0, NG, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 960
      GO TO 960
C-----------------------------------------------------------------------
C                                       close image
 955  CALL MSGWRT (8)
 960  CALL MAPCLS ('READ', IVOL, CNO, DLUN, DIND, CATIMG, .FALSE.,
     *   INBUF, JERR)
      GO TO 985
C                                       normal TV close
 970  CALL TVCLOS (CATBLK, JERR)
      GO TO 999
C                                       error handling
 980  CALL MSGWRT (8)
 985  CALL TVCLOS (CATBLK, JERR)
 990  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.GT.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AU5 ERROR',I4,' ON ',A)
 1100 FORMAT ('AU5: TVINIT ERROR =',I6)
 1410 FORMAT ('REQUESTED COLOR',I7,' ILLEGAL')
 1610 FORMAT ('AU5:',I6,',',I5,' NOT IN ANY IMAGE')
 1620 FORMAT ('IMXY: ',2F8.2)
 1625 FORMAT ('IMPOS ERROR',I3,' CONVERTING TO SKY COORDINATES')
 1670 FORMAT ('Got(1)  user=',I4,'  disk=',I2,'  type= ',A2)
 1750 FORMAT ('GRAPHICS CHANNEL',I4,' NOT IN RANGE 0 -',I2)
 1760 FORMAT ('Graphics channel',I2,': red =',F6.3,' green =',F6.3,
     *   ' blue =',F6.3)
 1761 FORMAT ('Cursor color: red =',F6.3,' green =',F6.3,' blue =',
     *   F6.3)
 1770 FORMAT ('COLORS',3F8.3,' OUT OF RANGE 0.0 - 1.0')
 1850 FORMAT (A,' = ',7F8.2)
 1860 FORMAT (I1)
      END

      SUBROUTINE CITC2I (S, N, I, IVALUE)
C-----------------------------------------------------------------------
C! KEYIN routine: parse an integer from a character string.
C# Parsing
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  CITC2I decodes an integer in the character string S starting at
C  location I;  I is updated to point after the end of the value on
C  return.
C   Inputs:
C     S(N)    C    Character string with value encoded
C     N       I    Length of S
C     I       I    Pointer in S to beginning of value.
C   Outputs:
C     I       I    Pointer in S to first character after value.
C     IVALUE  I    Integer value encodes in character string.
C   TJP 1977 DECEMBER 4  CIT 370/158
C   MODIFIED 1979 FEB 6  VAX/VMS FORTRAN 4
C   Modified 1985 June  for AIPS and renamed
C-----------------------------------------------------------------------
      CHARACTER S*(*), DIGITS*10
      INTEGER   IVALUE, N, I, IPOINT
      DATA      DIGITS /'0123456789'/
C-----------------------------------------------------------------------
      IVALUE = 0
C                                       Check for end of string
  10     IF (I.GT.N) GO TO 999
C                                       Find digit.
         IPOINT = INDEX (DIGITS, S(I:I))
C                                       Found any?
         IF (IPOINT.LE.0) GO TO 999
C                                       Add to value
         IVALUE = IVALUE * 10 + IPOINT - 1
         I = I + 1
         GO TO 10
C
 999  RETURN
      END

      SUBROUTINE RDUSER (BUF, IRET)
C-----------------------------------------------------------------------
C! reads the user number from the terminal
C# POPS-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2004, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   RDUSER reads the user ID # from the terminal
C   Outputs:
C      BUF   I(256)     Scratch buffer
C      IRET  I          Error code: none 0 => die!!!
C   Common:
C      /MSGCOM/ NLUSER is set
C-----------------------------------------------------------------------
      INTEGER   BUF(256), IRET
C
      CHARACTER IXT*1
      INTEGER   IERR, KBP, NC, JTRIM
      DOUBLE PRECISION    X
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DIO.INC'
C-----------------------------------------------------------------------
      NC = 0
      IRET = 1
 10   NC = NC + 1
      IF (NC.GT.10) GO TO 999
         NLUSER = 1
         ERRNUM = 0
         ERRLEV = 0
C                                       does user 1 have a message file
         CALL MSGONE (BUF)
C                                       request number
         WRITE (MSGTXT,1010)
         CALL MSGWRT (1)
         IXT = '?'
         CALL ZPROMP (IXT, JBUFF, IERR)
         IF (IERR.NE.0) GO TO 10
         KBP = JTRIM (JBUFF)
         KARBUF = JBUFF
         KBP = 1
         CALL GETNUM (KARBUF, NCHLIN, KBP, X)
         IF (ERRNUM.NE.0) GO TO 10
         IF (X.LE.0.) GO TO 10
         NLUSER = X + 0.5
         IF ((NLUSER.LE.0) .OR. (NLUSER.GT.USELIM)) GO TO 10
C                                       Check password
      CALL PASWRD (BUF, IRET)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('Enter user ID number')
      END

      SUBROUTINE FILCLS (LUN)
C-----------------------------------------------------------------------
C! close file opened by FILOPN, flushing write buffers, clearing catalog
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   WaWa IO system: Close a file opened by FILOPN, taking care of
C   catalog bookkeeping and flush last write buffers if any.
C   Inputs:
C      LUN       I      Logical unit no. of file to close
C   Written by WaWa (4/21/81)
C-----------------------------------------------------------------------
      INTEGER   LUN
C
      CHARACTER CHTM12*12, CHTM6*6, DUM2*2, CLROP*4, OPER*4
      INTEGER   IFIL, IERR, NSUB, IOP, RDINT, WARN, IDUM
      LOGICAL   ASSOC, LWRIT, MAP
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DBUF.INC'
      DATA WARN /10/
C-----------------------------------------------------------------------
C                                       Is file in fact open?
      DO 10 IFIL = 1,EFIL
         IF (FILTAB(1,IFIL).EQ.LUN) GO TO 20
 10      CONTINUE
      GO TO 999
C                                       Recover some info from FILTAB
 20   ASSOC = FILTAB(POASS,IFIL).EQ.1
      MAP = (LUN.GE.16) .AND. (LUN.LE.25)
      IOP = ABS (FILTAB(POIOP,IFIL))
      LWRIT = IOP.EQ.1
C                                       Flush out output buffers
      IF (.NOT. (LWRIT .AND. MAP)) GO TO 40
         OPER = 'FINI'
         NSUB = 4
         RDINT = LREAL * (IFIL - 6) + 1
         CALL MDISK ('FINI', LUN, FILTAB(POFIN,IFIL), RBUF(RDINT), IDUM,
     *      IERR)
         IF (IERR.NE.0) GO TO 980
C                                       READ/WRIT reset status
 40   IF ((IOP.LT.1) .OR. (IOP.GT.2)) GO TO 50
         NSUB = 1
         OPER = 'CSTA'
         CLROP = 'CLRD'
         IF (LWRIT .AND. (.NOT.ASSOC)) CLROP = 'CLWR'
         CALL CATDIR ('CSTA', FILTAB(POVOL,IFIL), FILTAB(POCAT,IFIL),
     *      CHTM12, CHTM6, IDUM, DUM2, IDUM, CLROP, WBUFF, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.WARN)) GO TO 980
C                                       Close the file
 50   NSUB = 5
      OPER = 'CLOS'
      CALL ZCLOSE (LUN, FILTAB(POFIN,IFIL), IERR)
      FILTAB(POLUN,IFIL) = 0
      IF (IERR.EQ.0) GO TO 999
C                                       Error return
 980  WRITE (MSGTXT,1980) SUBNAM(NSUB), OPER, LUN, IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('FILCLS: ',A6,2X,A4,' LUN',I4,' ERROR ',I6)
      END

      SUBROUTINE ZEXPND (LUN, IVOL, PNAME, NREC, IERR)
C-----------------------------------------------------------------------
C! expand an open disk file --- either map or non-map now allowed
C# Z IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Increase the size of a disk file --- it must be open
C   Inputs:
C      LUN     I      LUN of file open file
C      IVOL    I      Disk volume containing file, 1,2,3,...
C      PNAME   C*48   Physical file name
C   In/Out:
C      NREC    I      # 256-integer records requested/received
C   Output:
C      IERR    I      Error return code: 0 => no error
C                        1 => input error
C                        2 => expansion error
C                        3 => ZEXIST error
C                       -1 => some, but less than all of request met
C                        4 => no disk added to file
C   Generic version - uses ZEXPN2.
C-----------------------------------------------------------------------
      INTEGER   LUN, IVOL, NREC, IERR
      CHARACTER PNAME*48
C
      INTEGER   FIND, FCBOFF, IMAP, ISIZE, LSIZE, JERR, LREC, KREC
      LOGICAL   MAP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
C-----------------------------------------------------------------------
      IERR = 1
C                                       Valid number of records.
      IF (NREC.GT.0) GO TO 10
         WRITE (MSGTXT,1000) NREC
         GO TO 990
C                                       Valid volume?
 10   IF ((IVOL.GT.0) .OR. (IVOL.LE.NVOL)) GO TO 20
         WRITE (MSGTXT,1010) IVOL
         GO TO 990
C                                       Locate file in FTAB.
 20   MAP = .FALSE.
      CALL LSERCH ('SRCH', LUN, FIND, MAP, IERR)
      IF (IERR.EQ.0) GO TO 30
         MAP = .TRUE.
         CALL LSERCH ('SRCH', LUN, FIND, MAP, IERR)
         IF (IERR.EQ.0) GO TO 30
            WRITE (MSGTXT,1020) PNAME(1:24), LUN
            GO TO 990
C                                       Expand file.
 30   IF (MAP) THEN
         FCBOFF = FIND + MOFF
         IMAP = 1
      ELSE
         FCBOFF = FIND + NMOFF
         IMAP = 0
         END IF
      CALL ZEXIST (IVOL, PNAME, ISIZE, JERR)
      IF (JERR.NE.0) THEN
         IERR = 3
         GO TO 999
         END IF
      LREC = NREC
      CALL ZEXPN2 (FTAB(FCBOFF), IMAP, NREC, IERR)
      IF (IERR.EQ.0) THEN
         CALL ZEXIST (IVOL, PNAME, LSIZE, JERR)
         IF (JERR.NE.0) THEN
            IERR = 3
            GO TO 999
            END IF
         KREC = NREC
         NREC = LSIZE - ISIZE
         IF ((NREC.LT.KREC) .OR. (NREC.LT.LREC)) THEN
            IERR = -1
            IF (NREC.LE.0) IERR = 4
            WRITE (MSGTXT,1025) LREC, KREC, NREC
            CALL MSGWRT (6)
            END IF
C                                       Error
      ELSE
         IERR = 2
         WRITE (MSGTXT,1030) PNAME(1:24), NREC
         CALL MSGWRT (7)
         CALL ZERROR ('ZEXPN2', FTAB(FCBOFF+FCBERR), PNAME,
     *      FTAB(FCBOFF), MAP)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (7)
      NREC = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZEXPND: INVALID RECORD REQUEST = ',I6)
 1010 FORMAT ('ZEXPND: INVALID VOLUME REQUEST = ',I6)
 1020 FORMAT ('ZEXPND: FILE ',A24,' NOT OPEN IN FTAB.  LUN = ',I2)
 1025 FORMAT ('ZEXPND: REQUEST, CLAIMED, ACTUAL',3I7,' BLOCKS')
 1030 FORMAT ('ZEXPND: EXPANSION FAILED ON FILE ',A24,' NREC = ',I6)
      END

LOCAL INCLUDE 'UVLOD.INC'
C                                       Local include for UVLOD
      INCLUDE 'INCS:ZPBUFSZ.INC'
      DOUBLE PRECISION PSCAL(20), POFF(20), BSC, BZE, WTSCAL,
     *   BXSTA(50), BYSTA(50), BZSTA(50), NZERO(3,2)
      HOLLERITH XNAMEI(2), XNAMOU(3), XCLAOU(2), XBAND(1), XINFIL(12)
      CHARACTER NAMEIN*8, NAMOUT*12, CLAOUT*6, BAND*4, INFILE*48,
     *   NAMSTA(50)*8, PTYPES(40)*8
      REAL      DOALL, BITER, NITER, QUAL, TAPE, DOEOF, XFILES, XDOUVC,
     *   DOKEEP, XOUTS, DISO, XVSMAX, XPIECE, XERROR, BUFF2(UVBFSL),
     *   PCMATX(7,7), CDMATX(7,7), PVMATX(7,7)
      INTEGER   IBLANK, NUMVIS, BUFF1(UVBFSL), FDVEC(50), TBIND, LENREC,
     *   IQUAL, NFILES, DISOUT, TAPEIN, GROUP, ICEND, TABLES, IBPP,
     *   NPARMS, ITAB(20), JADR(4), NSTACT, JBAND, SCRBUF(256), KLOCWT,
     *   TAPBUF(29184), UNKNWN, IPIECE, NPIECE, NPV(4), CONCAT, INITVS,
     *   OUTSEQ, USED(300), CATSAV(256), DPIECE, PBASE, PANT1, PANT2,
     *   NSKIP, IBUFF2(UVBFSL)
      LOGICAL   NDOEOF, ISBLNK, LCMPLX, LSTOKE, STDEXT, DODISK, DOUVCM,
     *   UVTABL, ISMEER, ISAIPS
      EQUIVALENCE (BUFF2, IBUFF2)
      COMMON /BUFRS/ TAPBUF, BUFF2, BUFF1, SCRBUF
      COMMON /INPARM/ DOALL, XNAMEI, QUAL, XBAND, BITER, NITER, TAPE,
     *   XFILES, XINFIL, XDOUVC, DOEOF, DOKEEP, XNAMOU, XCLAOU, XOUTS,
     *   DISO, XVSMAX, XPIECE, XERROR
      COMMON /SCRINF/ NUMVIS, NDOEOF, IQUAL, NFILES, DISOUT,
     *   TAPEIN, LENREC, FDVEC, TBIND, JBAND, INITVS
      COMMON /FITINF/ CATSAV, PSCAL, POFF, BSC, BZE, WTSCAL, NZERO,
     *   GROUP, UNKNWN, ICEND, IBLANK, TABLES, IBPP, NPARMS, ITAB, JADR,
     *   NSTACT, KLOCWT, DODISK, ISBLNK, LCMPLX, LSTOKE, STDEXT, DOUVCM,
     *   UVTABL, IPIECE, NPIECE, NPV, CONCAT, OUTSEQ, PCMATX, CDMATX,
     *   PVMATX, USED, DPIECE, NSKIP, PBASE, PANT1, PANT2, ISMEER,
     *   ISAIPS
      COMMON /STACOM/ BXSTA, BYSTA, BZSTA
      COMMON /CHRCOM/ NAMEIN, NAMOUT, CLAOUT, BAND, INFILE, NAMSTA,
     *   PTYPES
LOCAL END
      PROGRAM UVLOD
C-----------------------------------------------------------------------
C! Read uv data from FITS or VLA Export format file
C# UV Tape FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2001, 2003-2004, 2007-2013, 2015-2017, 2019-2020,
C;  Copyright (C) 2022, 2024-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVLOD will load a uv data base from a VLA export tape or an AIPS/
C   Charlottesville IBM FITS tape (and possibly other FITS tapes) and
C   catalog them on disk.  A VLB version of the Export format is also
C   supported.  This version extends the RUN structure (1) to indicate
C   that antenna locations must be multiplied by 1000, (2) possibly to
C   give 4 frequencies rather than 4 Stokes, and (3) to give various
C   timing values.
C   Inputs:
C      Adverb  Pgm. name         Comments.
C      DOALL     DOALL      Load all sources in Export fmt file
C      SOURCE    NAMEIN     Source name. (Ignored on FITS)
C      QUAL      IQUAL      Source qualifier. (Ignored on FITS)
C      BAND      JBAND      Observing band (eq. 'L','C').  Ignored
C                           when reading FITS.
C      BCOUNT    BITER      Sequence # of first source to include
C      NCOUNT    NITER      Number of sequential source to load
C      INTAPE    TAPEIN     Input tape drive number
C      NFILES    NFILES     Number of files to skip.
C      INFILE    INFILE     Disk file name for FITS file
C      DCONCAT   NDOEOF     > 0 => concatanate all selected data in
C                           one file (DOALL must be false)
C      OUTNAME   NAMOUT     Output file name (default = NAMEIN)
C      OUTCLASS  CLAOUT     Output file class (default = 'UVDATA')
C      OUTSEQ    OUTSEQ     Output sequence number requested (<0 =>
C                           use one found on FITS tape header)
C      OUTDISK   DISOUT     Output disk volumn.
C      NPOINTS   XVSMAX     No. thousands of vis. (Ignored on FITS)
C      NPIECE    NPIECE     Max piece number to be read.
C   Adverbs SOURCE, QUAL, BAND, BCOUNT, NCOUNT, and NPOINTS do not
C   apply to FITS format data.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER PRGM*6
      INTEGER   ISLOT, IERR, IHLUN, JERR
      LOGICAL   FITS, EOF, LAST
      INCLUDE 'UVLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'UVLOD '/
      DATA IHLUN /27/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL UVPARM (PRGM, FITS, IERR)
      IF (IERR.NE.0) GO TO 900
      UNKNWN = 0
      DPIECE = 0
C                                       Read vis tape, copy to
C                                       catalogd file.
C                                       VLA Export format
      IF (.NOT.FITS) THEN
         CALL VISIN (IERR)
C                                       FITS of some sort
      ELSE
         NSKIP = 0
 10      IPIECE = IPIECE + 1
         IF (IPIECE.LE.NPIECE) THEN
            LAST = IPIECE.EQ.NPIECE
            TABLES = 0
            CALL FILL (300, 0, USED)
            CALL COPY (256, CATBLK, CATSAV)
            CALL UVFHDR (ISLOT, IERR)
            IF (IERR.LT.0) GO TO 800
            IF (IERR.NE.0) GO TO 850
            CALL PCHDR (PCMATX, CDMATX, PVMATX)
            CALL UVFHIS (ISLOT, IHLUN, IERR)
            IF (IERR.NE.0) GO TO 850
            CALL DFILL (6, 0.0D0, NZERO)
            IF (.NOT.UVTABL) THEN
               CALL UVFDAT (ISLOT, IERR)
               IF (IERR.NE.0) GO TO 850
               END IF
C                                       keep file now if error
            FRW(1) = 1
C                                       Try new table extension files
            CALL FITRXU (ISLOT, IHLUN, LAST, EOF, IERR)
            IF (IERR.NE.0) GO TO 850
C                                       Old table format.
            IF (.NOT.EOF) THEN
               CALL UVFEXT (ISLOT, IHLUN, IERR)
               IF (IERR.NE.0) GO TO 850
               END IF
            CONCAT = 1
            GO TO 10
            END IF
C                                       source table
         CALL SUCHCK (DISOUT, ISLOT)
C                                       index table
         CALL NXCHCK (DISOUT, ISLOT, BUFF2)
C                                       file ending reads
 800     IF (UNKNWN.GT.0) THEN
            WRITE (MSGTXT,1800) UNKNWN
            CALL MSGWRT (6)
            END IF
         END IF
C                                       Close input
 850  CALL TAPIO ('CLOS', FDVEC, TAPBUF, TBIND, JERR)
C                                       Finished
 900  CALL DIE (IERR, SCRBUF)
C
 999  STOP
C-----------------------------------------------------------------------
 1800 FORMAT ('WARNING:',I7,' unknown records skipped while reading',
     *   ' tape')
      END
      SUBROUTINE UVPARM (PRGM, FITS, JERR)
C-----------------------------------------------------------------------
C   UVPARM reads input parameters for Task UVLOD.  See header comments
C   in PROGRAM UVLOD for more details.
C   Inputs: PRGM   C*6      Program name
C   Output: FITS   L        T => FITS tape
C           JERR   I        Error code: 0 => ok, else quit
C   Common: /MAPHDR/ initial cat block header (heavily filled in if
C                    FITS is false)
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, KBAND(7)*1, IRAN(5)*8, ICOOR(5)*8, CHTMP*400,
     *   TRYTWO*48
      LOGICAL   FITS, T
      INTEGER   NAXIS, NRAN, IFIL, JERR, IERR, I, INDEXX, IRET, IROUND,
     *   IT, J, NBYT, ITRIM
      HOLLERITH HFDVEC(50)
      REAL      EPS
      INCLUDE 'UVLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (HFDVEC, FDVEC)
      DATA T /.TRUE./
      DATA KBAND /'L','C','U','K','P','X','S'/
      DATA IRAN /'UU-L    ','VV-L    ','WW-L    ','BASELINE','TIME1   '/
      DATA ICOOR /'COMPLEX ','STOKES  ','FREQ    ','RA      ',
     *   'DEC     '/
      DATA NAXIS, NRAN /5,5/
C-----------------------------------------------------------------------
C                                       Initialize I/O
      CALL ZDCHIN (T)
      CALL HIINIT (3)
      CALL VHDRIN
      CALL FILL (50, 0, FDVEC)
      JERR = 0
      BSC = 1.0D0
      BZE = 0.0D0
C                                       Initialize COMMON /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARMS = 34
      CALL GTPARM (PRGM, NPARMS, RQUICK, DOALL, SCRBUF, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRET = 8
         GO TO 20
C                                       Convert characters
 10   CALL H2CHR (8, 1, XNAMEI, NAMEIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (4, 1, XBAND, BAND)
      CALL H2CHR (48, 1, XINFIL, INFILE)
      OUTSEQ = XOUTS + 0.5
C                                       Compressed output?
      DOUVCM = XDOUVC.GT.0.0
C                                       Check if disk file output
      DODISK = INFILE.NE.' '
      CALL CATINI (CATBLK)
      CALL RFILL (49, 0.0, PCMATX)
      CALL RFILL (49, 0.0, PVMATX)
      CALL RFILL (49, 0.0, CDMATX)
      EPS = 0.1
      IPIECE = 0
      NPIECE = IROUND (XPIECE)
C                                       Get TAPEIN
      TAPEIN = TAPE + EPS
C                                       Get NFILES
      NFILES = XFILES + EPS
      IF (XFILES.LT.-EPS) NFILES = XFILES - EPS
C                                       Get DISOUT
      DISOUT = DISO + EPS
C                                       Get max. no. visibilities.
      IF (XVSMAX.LE.0.) XVSMAX = 50.
      XVSMAX = XVSMAX * 1200.0D0
C                                       Set user id in CATBLK
      CATBLK(KIIMU) = NLUSER
C                                       If RQUICK, restart AIPS
      IRET = 0
C                                       Test legality
      IF (NTAPED.EQ.1) TAPEIN = 1
      IF (((TAPEIN.GE.1) .AND. (TAPEIN.LE.NTAPED)) .OR. DODISK) GO TO 15
         WRITE (MSGTXT,1010) TAPEIN
         CALL MSGWRT (8)
         IRET = 8
         GO TO 20
 15   IF (((NPOPS.LE.NINTRN) .AND. (ISBTCH.NE.32000)) .OR. DODISK)
     *    GO TO 20
         WRITE (MSGTXT,1015)
         CALL MSGWRT (8)
         IRET = 8
 20   JERR = IRET
      IF (RQUICK) CALL RELPOP (IRET, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
C                                       Setup for Tape I/O
C                                       Buffer size.
      FDVEC(3) = (29184 * NBITWD) / 8
C                                       Logical record size (FITS)
      FDVEC(2) = 2880
      CALL CHR2H (48, INFILE, 1, HFDVEC(7))
C                                       Disk input.
      TRYTWO = ' '
      IF (DODISK) THEN
         FDVEC(1) = 25
         TAPEIN = 1
         FDVEC(5) = 1
         MSGSUP = 32000
         CALL TAPIO ('OPRD', FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.EQ.0) THEN
            CALL TAPIO ('CLOS', FDVEC, TAPBUF, TBIND, IERR)
         ELSE
            TRYTWO = INFILE
            I = ITRIM (INFILE)
            INFILE(I+1:) = '1'
            CALL CHR2H (48, INFILE, 1, HFDVEC(7))
            END IF
         MSGSUP = 0
C                                       Tape input
      ELSE
         TAPEIN = TAPE + 0.5
         IF (TAPEIN.LE.0) TAPEIN = 1
         FDVEC(1) = 129 - TAPEIN
         FDVEC(5) = TAPEIN
         FDVEC(6) = 10
         WRITE (MSGTXT,1024) TAPEIN
         CALL MSGWRT (6)
         END IF
C                                       Open tape
      CALL TAPIO ('OPRD', FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.GT.1) THEN
         IF (TRYTWO.NE.' ') THEN
            MSGTXT = 'ALSO COULD NOT OPEN ' // TRYTWO
            CALL MSGWRT (8)
            END IF
         WRITE (MSGTXT,1025) IERR
         CALL MSGWRT (8)
         JERR = 8
         GO TO 999
         END IF
C                                       Skip to correct file.
      IERR = 0
      IF ((NFILES.GT.0) .AND. (.NOT.DODISK))
     *   CALL ZTAPE ('ADVF', FDVEC(1), FDVEC(40), NFILES, IERR)
      IFIL = 1 - NFILES
      IF ((NFILES.LT.0) .AND. (.NOT.DODISK))
     *   CALL ZTAPE ('BAKF', FDVEC(1), FDVEC(40), IFIL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1026) IERR
         CALL MSGWRT (8)
         JERR = 8
         GO TO 990
         END IF
C                                       Read first tape rec
      MSGSUP = 32000
      CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, JERR)
      MSGSUP = 0
      NBYT = FDVEC(42)
      IF ((JERR.NE.0) .AND. (JERR.NE.10)) THEN
         WRITE (MSGTXT,1030) JERR
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       Look for "SIMPLE  = "
      CALL ZC8CL (400, 1, TAPBUF, CHTMP)
      FITS = CHTMP(:10).EQ.'SIMPLE  = '
      IF (FITS) THEN
         IF (JERR.NE.10) THEN
            IT = INDEX (CHTMP(:80), '/')
            IF (IT.LE.0) IT = 80
            DO 40 J = 11,IT
               IF (CHTMP(J:J).NE.' ') THEN
                  IF (CHTMP(J:J).NE.'T') JERR = 10
                  GO TO 45
                  END IF
 40            CONTINUE
            JERR = 10
            END IF
 45      IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1045) NBYT
            CALL MSGWRT (8)
            GO TO 990
            END IF
         UVTABL = (CHTMP(188:190).EQ.'  2') .AND.
     *      (CHTMP(348:350).EQ.'  0') .AND.
     *      (CHTMP(262:268).EQ.'7777777')
         CONCAT = -1
         IF (.NOT.UVTABL) THEN
            NPIECE = 1
         ELSE
            IF (NPIECE.LE.0) NPIECE = 999
            IF (DOEOF.GT.0.0) CONCAT = 0
            END IF
C                                       EXPORT format
      ELSE
         NPIECE = 1
         JERR = 0
         CALL TAPIO ('BAKF', FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) THEN
            JERR = IERR
            WRITE (MSGTXT,1035) JERR
            CALL MSGWRT (8)
            GO TO 990
            END IF
C                                       set LRECL
         FDVEC(2) = 4008
         FDVEC(6) = 1
C                                       Variable length records
         FDVEC(31) = 1
C                                       Prepare header for VLA Export
         IF (DOALL.GT.0.0) DOEOF = -1.0
         NDOEOF = DOEOF.LE.0.0
         IF (BITER.LT.1.0) BITER = 1.0
         IF ((NITER.LT.1.0) .AND. (DOALL.GT.0.0)) NITER = 10.0
         IF (NITER.LT.1.0) NITER = 100.0
C                                       Get Source qualifier.
         IQUAL = IROUND (QUAL)
C                                       Get band.
         JBAND = 0
         DO 50 I = 1,7
            IF (BAND(1:1).EQ.KBAND(I)) JBAND = I
 50         CONTINUE
         JBAND = JBAND - 1
C                                       Fill CATBLK.
C                                       Set units.
         CHTMP = 'JY'
         CALL CHR2H (8, CHTMP, 1, CATH(KHBUN))
C                                       Random para. types.
         DO 60 I = 1,NRAN
            INDEXX = KHPTP + (I-1)*2
            CALL CHR2H (8, IRAN(I), 1, CATH(INDEXX))
 60         CONTINUE
         CATBLK(KIPCN) = NRAN
         CATR(KRCIC) = 1.0
         CATR(KRCIC+1) = -1.0
         CATD(KDCRV) = 1.0D0
         CATD(KDCRV+1) = -1.0D0
C                                       Axis types.
         DO 70 I = 1,NAXIS
            INDEXX = KHCTP + (I-1)*2
            CALL CHR2H (8, ICOOR(I), 1, CATH(INDEXX))
 70         CONTINUE
         CATBLK(KIDIM) = NAXIS
C                                       Axis dimensions.
         CATBLK(KINAX) = 3
         CATBLK(KINAX+1) = 4
         CATBLK(KINAX+2) = 1
         CATBLK(KINAX+3) = 1
         CATBLK(KINAX+4) = 1
C                                       Set file type to 'UV'
         CALL CHR2H (2, 'UV', KHPTYO, CATH(KHPTY))
         END IF
      GO TO 999
C
 990  CALL TAPIO ('CLOS', FDVEC, TAPBUF, TBIND, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVPARM: ERROR',I3,' OBTAINING INPUT PARAMETERS ')
 1010 FORMAT ('UVPARM: INTAPE =',I7,' ILLEGAL')
 1015 FORMAT ('TAPE JOBS ARE NOT ALLOWED IN BATCH')
 1024 FORMAT ('Reading tape drive number ',I3)
 1025 FORMAT ('ERROR',I7,' OPENING TAPE')
 1026 FORMAT ('ERROR',I7,' POSITIONING TAPE')
 1030 FORMAT ('ERROR',I7,' READING FIRST TAPE RECORD')
 1035 FORMAT ('ERROR',I7,' RE-POSITIONING TAPE WITH BAKF(1)')
 1045 FORMAT ('NON-STANDARD FITS HEADER OF',I7,' BYTES READ, QUITTING')
      END
      SUBROUTINE VISIN (JERR)
C-----------------------------------------------------------------------
C   VISIN reads an EXPORT visibility tape, finds the requested data and
C   copies it into a cataloged file.
C   Inputs (via COMMON /SRCINF/):
C      NAMEIN           C*8  Source name
C      IQUAL            I    Source qualifier
C      JBAND            I    Source band number.
C      TAPEIN           I    Tape drive number
C      NFILES           I    No. tape files to skip.
C      XVSMAX           R    Max. no. visibilities.
C   from /BUFRS/
C      BUFF1(9220)      I    Work buffer
C      BUFF2(9220)      R    Work buffer
C      TAPBUF(*)        I    Tape buffer
C   Output:
C      JERR             I    Return error code.
C                            0 = OK
C                            5 = Did not find requested data.
C                            8 = I/O error.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER SOURCE*8, OBSDAT*11, DEFNAM*12, DEFCLS*6, LOCNAM*12,
     *   LOCCLS*6, TYPES(6)*4, PNAME*48, IBAND(7)*1, CHTEMP*8
      INTEGER   BLKOF, MJAD, VO, ITEMP(8), ITYPES(2,6), JERR, LUNO,
     *   INDO, LENBU, I2(4), SZBUFF, MXXANT, LQUAL, IW(2), I, NRPARM,
     *   NUMANT, ANVER, IDISO, IERR, IN, INDEXX, IOCNT, IOFF, IS, ITYP,
     *   KIND, NCOR, NIOUT, NWD, SPAT(8), IDUM(2)
      LOGICAL   T, F, FIRST, GOTDAT, WANTED, EQUAL, STARTD, GANDAT,
     *   DOFRQ, DOVLB, DONONE, ISNAME, WSNAME
      REAL      TIMADD, BASADD, XIAT, XUT1, SCUV, SCUVN, SCVIS, XCNT,
     *   XREC, YREC, NUMSOR, R4
      DOUBLE PRECISION FREQ, F8, XMJAD, TIMFAC, XDAT, STFAC, GST0
      INCLUDE 'UVLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DANT.INC'
      EQUIVALENCE (F8, R4, I2(1))
      DATA TYPES /'VIS ','SOUR','ANTE','DEF ','RUN ','END '/
      DATA T, F /.TRUE.,.FALSE./
      DATA IBAND /'P','L','C','U','K','X','S'/
      DATA NRPARM /5/
      DATA LUNO, LENBU, BLKOF, VO /16, 128, 1, 0/
C-----------------------------------------------------------------------
      TIMFAC = 1.0D0 / 65536.0D0
      IOCNT = 0
      NUMSOR = 0.0
      WANTED = F
      STARTD = F
      GOTDAT = F
      DONONE = F
      DOVLB = F
      DOFRQ = F
      XIAT = 0.0
      XUT1 = 0.0
      GST0 = 0.0D0
      MXXANT = 0
      NUMANT = 0
      JERR = 0
      CCNO = 0
      GANDAT = F
      ANVER = 0
      TIMADD = 0.0
      BASADD = 0.0
      XREC = 0.0
      ISNAME = NAMEIN.NE.' '
      IF (ISNAME) CALL PSFORM (8, NAMEIN, SPAT)
      I = INDEX (NAMEIN, '*')
      IF (I.LE.0) I = INDEX (NAMEIN, '?')
      WSNAME = ISNAME .AND. (I.LE.0)
C                                       Convert data to mess on tape.
      IN = -3
      DO 10 I = 1,6
         IN = IN + 4
         CALL ZCLC8 (4, TYPES(I), IN, BUFF2)
 10      CONTINUE
      CALL ZI16IL (12, 1, IBUFF2, ITYPES)
      FIRST = T
      NUMVIS = 0
C                                       Begin loop reading tape records
 60   CONTINUE
         CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
         XREC = XREC + 1.0
         IF (IERR.EQ.0) GO TO 70
         IF (IERR.EQ.4) GO TO 900
            WRITE (MSGTXT,1060) IERR, XREC
            CALL MSGWRT (8)
            JERR = 8
            GO TO 990
C                                       Flip bytes off tape.
 70      CALL ZI16IL (1, 1, TAPBUF(TBIND), IDUM)
         IN = IDUM(1)
         NWD = IN / 2
         IF ((NWD.GT.0) .AND. (NWD.LE.2004)) GO TO 75
            WRITE (MSGTXT,1070) NWD
            CALL MSGWRT (8)
            JERR = 8
            GO TO 990
 75      CALL ZI16IL (NWD, 1, TAPBUF(TBIND), BUFF1)
C                                       Is this first tape block?
         IF (.NOT.FIRST) GO TO 90
C                                       Find first record type.
            IW(1) = BUFF1(5)
            IW(2) = BUFF1(6)
            ITYP = 7
            DO 80 I = 1,6
               IF ((IW(1).EQ.ITYPES(1,I)) .AND. (IW(2).EQ.ITYPES(2,I)))
     *            ITYP = I
 80            CONTINUE
C                                       Set record pointer.
            IS = 15
            FIRST = F
            GO TO 100
C                                       Subsequent blocks.
 90      IS = 9
C                                       Begin loop thru block.
C                                       Check if block finished.
 100     IF (IS.GT.NWD) GO TO 60
C                                       Process record.
 110  IF ((GOTDAT) .AND. (DOALL.GT.0.0) .AND. (ITYP.NE.1) .AND.
     *   (ITYP.NE.7)) GO TO 900
      GO TO (500, 400, 300, 600, 200, 700, 800),  ITYP
C                                       RUN record.
 200  CONTINUE
         NUMANT = 0
C                                       Get info for CATBLK.
C                                       Get uv scaling
         SCUVN = 2.0D0**(2-BUFF1(IS+3))
C                                       Get observer
         CALL ZILI16 (2, BUFF1(IS), 1, ITEMP)
         CHTEMP = ' '
         CALL ZC8CL (4, 1, ITEMP, CHTEMP)
         CALL CHR2H (8, CHTEMP, 1, CATH(KHOBS))
C                                       Get MJAD and Obs. date.
         CALL ZR8P4 ('4IB8', BUFF1(IS+4), XMJAD)
         CALL ZR8P4 ('4IB8', BUFF1(IS+6), F8)
         XDAT = XMJAD + 2400000.5D0
C                                       Subtract 32768 from MJAD
         XMJAD = (XMJAD - 32768.0D0) * 65536.0D0
         MJAD = XMJAD
C                                       Convert Julian date to calender
         CALL GREG (XDAT, CHTEMP)
         CALL CHR2H (8, CHTEMP, 1, CATH(KHDOB))
C                                       VLB extension
         IF (BUFF1(IS-6).LE.32) GO TO 850
            DOFRQ = BUFF1(IS+10).EQ.2
            DOVLB = BUFF1(IS+10).GT.0
            XIAT = BUFF1(IS+11)
            XUT1 = 0.001 * BUFF1(IS+14)
            CALL ZR8P4 ('4IB8', BUFF1(IS+12), F8)
            GST0 = 360.0D0 * (2.0D0 **(-31)) * F8
            GO TO 850
C                                       ANTE records
 300     NUMANT = NUMANT + 1
C                                       Initialize antenna file
         IF (NUMANT.GT.1) GO TO 320
            CALL DUMPAN (MXXANT, FREQ, XIAT, XUT1, ANVER, DOVLB, IERR)
            IF ((ANVER.EQ.0) .OR. (GANDAT)) ANVER = ANVER + 1
            STFAC = .2997924562D0 * (2.0D0**(-12))
            IF (DOVLB) STFAC = STFAC * 1.D3
 320     CALL ZR8P4 ('4IB8', BUFF1(IS), BXSTA(NUMANT))
         BXSTA(NUMANT) = BXSTA(NUMANT) * STFAC
         CALL ZR8P4 ('4IB8', BUFF1(IS+2), BYSTA(NUMANT))
         BYSTA(NUMANT) = BYSTA(NUMANT) * STFAC
         CALL ZR8P4 ('4IB8', BUFF1(IS+4), BZSTA(NUMANT))
         BZSTA(NUMANT) = BZSTA(NUMANT) * STFAC
         CALL ZILI16 (4, BUFF1(IS+6), 1, ITEMP)
         NAMSTA(NUMANT) = '        '
         CALL ZC8CL (4, 1, ITEMP, NAMSTA(NUMANT)(1:4))
         GANDAT = F
         MXXANT = MAX (MXXANT, NUMANT)
         GO TO 850
C                                       SOUR records.
 400  CONTINUE
         NUMSOR = NUMSOR + 1.0
         IF (NUMSOR.GE.NITER+BITER) GO TO 900
C                                       Check if desired source.
         CALL ZILI16 (4, BUFF1(IS), 1, ITEMP)
         CALL ZC8CL (8, 1, ITEMP, SOURCE)
         CALL CHLTOU (8, SOURCE)
         EQUAL = .TRUE.
         IF (ISNAME) CALL CHWMAT (8, NAMEIN, SPAT, 1, SOURCE, EQUAL)
         WANTED = (EQUAL) .AND. ((JBAND.EQ.BUFF1(IS+26)) .OR.
     *      (JBAND.LT.0)) .AND. ((IQUAL.EQ.BUFF1(IS+4)) .OR.
     *      (IQUAL.LT.0))
         WANTED = (WANTED) .AND. (NUMSOR.GE.BITER) .AND.
     *      (NUMSOR.LT.NITER+BITER)
         IF ((GOTDAT) .AND. (NDOEOF)) GO TO 900
         LQUAL = BUFF1(IS+4)
         NUMANT = 0
         IF (.NOT.WANTED) GO TO 850
C                                       Found right source, get info
C                                       and create output file.
C                                       Get vis. scaling
         SCVIS = 2.0D0**(BUFF1(IS+5))
C                                       Get sort order.
         CALL ZILI16 (2, BUFF1(IS+8), 1, ITEMP)
         CALL ZC8CL (2, 1, ITEMP, CHTEMP)
         CALL CHR2H (2, CHTEMP, 1, CATH(KITYP))
C                                       Get RA
         CALL ZR8P4 ('4IB8', BUFF1(IS+18), F8)
         CATD(KDCRV+3) = 360.0 * (2.0D0**(-31)) * F8
         CATD(KDORA) = CATD(KDCRV+3)
C                                       Get Declination.
         CALL ZR8P4 ('4IB8', BUFF1(IS+20), F8)
         CATD(KDCRV+4) = 360.0 * (2.0D0**(-31)) * F8
         CATD(KDODE) = CATD(KDCRV+4)
C                                       Get frequency (Hz)
         CALL ZR8P4 ('4IB8', BUFF1(IS+22), CATD(KDCRV+2))
         CATD(KDCRV+2) = CATD(KDCRV+2) * 1.0D3
         FREQ = CATD(KDCRV+2) * 1.0D-9
C                                       Set uv scaling in wavelengths
         SCUV = FREQ*SCUVN
C                                       Get bandwidth (Hz)
         CALL ZR8P4 ('4IB8', BUFF1(IS+24), F8)
         CATR(KRCIC+2) = F8 * 1.0E3
C                                       Get source name
         CALL CHR2H (8, SOURCE, 1, CATH(KHOBJ))
C                                       Write message to user who is
C                                       waiting breathlessly to see if
C                                       his/her data is there.
         CALL H2CHR (8, 1, CATH(KHDOB), CHTEMP)
         CALL DATDAT (CHTEMP, OBSDAT)
         WRITE (MSGTXT,1400) SOURCE, LQUAL, FREQ, OBSDAT
         CALL MSGWRT (5)
         TIMADD = MAX ((ANVER-1) * 5.0, 0.0)
         BASADD = MAX ((ANVER-1) * 0.01, 0.0)
         IF ((STARTD) .AND. (GOTDAT)) GO TO 850
         IF (.NOT.STARTD) GO TO 410
            WRITE (MSGTXT,1401)
            CALL MSGWRT (6)
            CALL ZCLOSE (LUNO, INDO, IERR)
            IF (IERR.EQ.0) GO TO 405
               WRITE (MSGTXT,1402) IERR
               CALL MSGWRT (8)
               GO TO 990
 405        CALL MDESTR (FVOL(1), FCNO(1), CATBLK, BUFF2, I, IERR)
            IF (IERR.EQ.0) NCFILE = 0
            IF (IERR.EQ.0) GO TO 410
               WRITE (MSGTXT,1405) IERR
               CALL MSGWRT (6)
C                                       File name parms
 410     DEFNAM = NAMEIN
         IF (.NOT.WSNAME) DEFNAM = SOURCE
         IF (IQUAL.GE.0) WRITE (DEFNAM(9:12),1410) IQUAL
         DEFCLS = 'UVDATA'
         LOCNAM = NAMOUT
         LOCCLS = CLAOUT
         CATBLK(KIIMS) = 0
         IF (OUTSEQ.GE.1) CATBLK(KIIMS) = OUTSEQ
         CALL MAKOUT (DEFNAM, DEFCLS, 0, DEFCLS, LOCNAM, LOCCLS,
     *      CATBLK(KIIMS))
         CALL CHR2H (12, LOCNAM, KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, LOCCLS, KHIMCO, CATH(KHIMC))
C                                       Get number of correlators.
         NCOR = BUFF1(IS+27)
         CATBLK(KINAX+1) = NCOR
C                                       VLB modification
         IF (.NOT.DOFRQ) GO TO 420
            CATBLK(KINAX+2) = 4
            CATBLK(KINAX+1) = 1
            NCOR = 4
C                                       Set output rec length words
 420     LENREC = NRPARM + CATBLK(KINAX) * CATBLK(KINAX+1) *
     *      CATBLK(KINAX+2) * CATBLK(KINAX+3) * MAX (1,CATBLK(KINAX+4))
C                                       Create catalogd output file.
         GOTDAT = F
         NUMVIS = 0
         IOCNT = 0
         CATBLK(KIGCN) = XVSMAX
         IDISO = DISOUT
         CALL UVCREA (IDISO, CCNO, IBUFF2, IERR)
         IF (IERR.EQ.0) GO TO 425
            WRITE (MSGTXT,1420) IERR
            CALL MSGWRT (8)
            JERR = 8
            GO TO 990
C                                       Construct output file name.
 425     CALL ZPHFIL ('UV', IDISO, CCNO, 1, PNAME, IERR)
C                                       Mark output file in /CFILES/
         NCFILE = 1
         FVOL(1) = IDISO
         FCNO(1) = CCNO
         FRW(1) = 2
C                                       Initialize vis. count.
         XCNT = 0.0
C                                       Open output file.
         CALL ZOPEN (LUNO, INDO, IDISO, PNAME, T, T, T, IERR)
         IF (IERR.EQ.0) GO TO 430
            WRITE (MSGTXT,1425) IERR
            CALL MSGWRT (8)
            JERR = 8
            GO TO 990
C                                       Initialize output file.
 430     NUMVIS = 32760000
         NIOUT = LENBU
         SZBUFF = UVBFSL * 2
         CALL UVINIT ('WRIT', LUNO, INDO, NUMVIS, VO, LENREC, NIOUT,
     *      SZBUFF, BUFF2, BLKOF, KIND, IERR)
         IF (IERR.EQ.0) GO TO 440
            WRITE (MSGTXT,1430) IERR
            CALL MSGWRT (8)
            JERR = 8
            GO TO 990
 440     YREC = 0.0
         JERR = 8
C                                       Initialize vis count
         IOCNT = 0
         NUMVIS = 0
         STARTD = T
         GO TO 850
C
C                                       VIS records.
 500     NUMANT = 0
C                                       Check if correct source.
         IF (.NOT.WANTED) GO TO 850
C                                       Update vis. count and check
         XCNT = XCNT + 1.0
         IF (XCNT.LE.XVSMAX) GO TO 505
            WRITE (MSGTXT,1500)
            CALL MSGWRT (6)
            GO TO 900
C                                       Subtract MJAD from time.
 505     CALL ZR8P4 ('4IB8', BUFF1(IS+4), F8)
         F8 = F8 - MJAD
C                                       Copy to output buffer.
         INDEXX = KIND + IOCNT*LENREC
         IOCNT = IOCNT + 1
C                                       Random parameters - U
         BUFF2(INDEXX) = BUFF1(IS)*SCUV
C                                       V
         BUFF2(INDEXX+1) = BUFF1(IS+1)*SCUV
C                                       W
         BUFF2(INDEXX+2) = BUFF1(IS+2)*SCUV
C                                       Baseline
         BUFF2(INDEXX+3) = BUFF1(IS+3) + BASADD
C                                       Time (days)
         BUFF2(INDEXX+4) = F8*TIMFAC + TIMADD
C                                       Set further random parameters
C                                       here. NRPARM = # ran. parm.
C                                       Visibilities.
         DO 510 I = 1,NCOR
            IOFF = NRPARM+(I-1)*CATBLK(KINAX)
            BUFF2(INDEXX+IOFF) = BUFF1(IS+IOFF+1)*SCVIS
            BUFF2(INDEXX+IOFF+1) = BUFF1(IS+IOFF+2)*SCVIS
            BUFF2(INDEXX+IOFF+2) = BUFF1(IS+IOFF+3)
 510        CONTINUE
         GANDAT = T
         GOTDAT = T
C                                       See if output buffer is full.
         IF (IOCNT.LT.NIOUT) GO TO 850
C                                       Write output buffer.
            NIOUT = IOCNT
            IOCNT = 0
            YREC = YREC + 1.0
            CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOUT, KIND, IERR)
            IF (IERR.EQ.0) GO TO 520
               WRITE (MSGTXT,1510) IERR,YREC
               CALL MSGWRT (8)
               JERR = 8
               GO TO 990
C                                       Update vis. count.
 520        NUMVIS = NUMVIS + LENBU
            GO TO 850
C
C                                       DEF records.
 600     NUMANT = 0
         GO TO 850
C
C                                       END records
 700     NUMANT = 0
         GO TO 900
C
C                                       Records of unknown origin.
 800     GO TO 850
C
C                                       Get set for next record.
 850  IW(1) = BUFF1(IS-4)
      IW(2) = BUFF1(IS-3)
      ITYP = 7
      DO 860 I = 1,6
         EQUAL = (IW(1).EQ.ITYPES(1,I)) .AND. (IW(2).EQ.ITYPES(2,I))
         IF (EQUAL) ITYP = I
         IF (EQUAL) GO TO 870
 860     CONTINUE
C                                       Loop back for next record.
 870  IF (BUFF1(IS-6).GT.1) GO TO 875
         WRITE (MSGTXT,1870) BUFF1(IS-6)
         CALL MSGWRT (8)
         JERR = 8
         GO TO 990
 875  IS = IS + BUFF1(IS-6)/2
      GO TO 100
C                                       Finished; cleanup and go home.
C                                       Finish vis. count.
 900  NUMVIS = NUMVIS + IOCNT
C                                       Check if no data.
      IF (NUMVIS.NE.0) GO TO 905
         IF (DONONE) GO TO 990
            JERR = 5
            WRITE (MSGTXT,1900) NAMEIN, IQUAL, IBAND(JBAND+1)
            CALL MSGWRT (8)
            GO TO 990
C                                       Finish write and close files.
 905  YREC = YREC + 1.0
      NIOUT = -IOCNT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KIND, IERR)
      IF (IERR.EQ.0) GO TO 910
         WRITE (MSGTXT,1510) IERR, YREC
         CALL MSGWRT (8)
C                                       Write out last antenna file
C                                       Make sure one is written.
 910  IF (ANVER.LE.0) ANVER = 1
      CALL DUMPAN (MXXANT, FREQ, XIAT, XUT1, ANVER, DOVLB, IERR)
      DONONE = T
C                                       Shrink output file to correct
C                                       size
      CALL UCMPRS (NUMVIS, IDISO, CCNO, LUNO, CATBLK, IERR)
C                                       Write message about how many vis
      WRITE (MSGTXT,1910) NUMVIS
      CALL MSGWRT (5)
C                                       Close output file.
      CALL ZCLOSE (LUNO, INDO, IERR)
      IF (IERR.EQ.0) GO TO 930
         WRITE (MSGTXT,1911) IERR
         CALL MSGWRT (6)
 930  JERR = 0
C                                       Write history file
      CALL UVHIS
      NCFILE = 0
C                                       Reset parms and loop DOALL=T
      IF ((DOALL.LE.0.0) .OR. (ITYP.EQ.6)) GO TO 990
         STARTD = F
         GANDAT = F
         GOTDAT = F
         ANVER = 1
         TIMADD = 0.0
         BASADD = 0.0
         WANTED = F
         NUMVIS = 0
         IOCNT = 0
         IF (NUMSOR.LT.NITER+BITER) GO TO 110
 990  CALL TAPIO ('CLOS', FDVEC, TAPBUF, TBIND, JERR)
      IF (IERR.EQ.0) IERR = JERR
C
 999  RETURN
C-----------------------------------------------------------------------
 1060 FORMAT ('VISIN: READ ERROR',I7,' TAPE BLOCK ',F10.0)
 1070 FORMAT ('VISIN: PHYSICAL RECORD LENGTH=',I8,' ERROR')
 1400 FORMAT ('VISIN: Found ',A8,' .',I4,F12.6,' GHz',1X,A)
 1401 FORMAT ('VISIN: PREVIOUS SOURCE WAS EMPTY: DESTROY IT')
 1402 FORMAT ('VISIN: UNABLE TO CLOSE PREVIOUS SOURCE, ERROR',I6)
 1405 FORMAT ('VISIN: UNABLE TO DELETE PREVIOUS SOURCE, ERROR',I6)
 1410 FORMAT (':',I3)
 1420 FORMAT ('VISIN: ERROR',I7,' CREATING CATALOGUED OUTPUT FILE')
 1425 FORMAT ('VISIN: ERROR',I7,' OPENING OUTPUT FILE')
 1430 FORMAT ('VISIN: ERROR',I7,' INIT OUTPUT FILE')
 1500 FORMAT ('WARNING: ESTIMATED NUMBER OF VIS RECORDS EXCEEDED:',
     *   ' DATA LOST?')
 1510 FORMAT ('VISIN: WRITE ERROR',I7,' BLOCK ',F10.0)
 1870 FORMAT ('VISIN: LOGICAL RECORD LENGTH',I8,' ERROR')
 1900 FORMAT ('VISIN: COULD NOT FIND ',A8,' . ',I3,2X,A1,' BAND')
 1910 FORMAT ('VISIN: COPIED ',I12,' VIS. RECORDS')
 1911 FORMAT ('VISIN: ERROR',I7,' CLOSING CATALOGUED UV FILE')
      END
      SUBROUTINE DUMPAN (MXXANT, FREQ, XIAT, XUT1, ANVER, DOVLB, IERR)
C-----------------------------------------------------------------------
C   DUMPAN creates an AN file and writes the AN common data to it.
C   Inputs: MXXANT  I     # antennas
C           FREQ    D     frequency (GHz)
C           XIAT    R     IAT - UTC
C           XUT1    R     UT1 - UTC
C           ANVER   I     desired version number (0 => none)
C           DOVLB   L     If .true. the data is from a VLBI array.
C   Output: IERR    I     error code of TABINI/TABAN
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MXXANT, ANVER, IERR
      LOGICAL   DOVLB
      DOUBLE PRECISION FREQ, JD, GASTM, DEG2RD
      REAL      XIAT, XUT1
      INTEGER   LUNA,  IABUF(512), FINDA, I, JERR
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'UVLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA LUNA /30/
C-----------------------------------------------------------------------
      IERR = 0
      DEG2RD = 3.141592653589793D0 / 180.0D0
      IF (ANVER.LE.0) GO TO 999
C                                       Setup for AN table initization
      NUMORB = 0
      NOPCAL = 2
      ANTNIF = 2
C                                       Position of the earth's pole
      POLRXY(1) = 0.0
      POLRXY(2) = 0.0
      UT1UTC = XUT1
      DATUTC = XIAT
      IF (ABS (XIAT) .GT. 0.1) THEN
         TIMSYS = 'IAT'
      ELSE
         TIMSYS = 'UTC'
         END IF
C                                       Array name and center
C                                       (rel to center of earth)
      IF (DOVLB) THEN
         ANAME = 'VLBI '
         ARRAYC(1) = 0.0D0
         ARRAYC(2) = 0.0D0
         ARRAYC(3) = 0.0D0
      ELSE
         ANAME = 'VLA '
C                                       old values
C                                       ARRAYC(1) = -1601162.D0
C                                       ARRAYC(2) =  -5042003.D0
C                                       ARRAYC(3) =  3554915.D0
C                                       new values 2-Jul-2001
         ARRAYC(1) = -1601185.365D0
         ARRAYC(2) =  -5041977.547D0
         ARRAYC(3) =  3554875.87D0
         END IF
C                                       Get GST0 and Earth rotation rate
      CALL H2CHR (8, 1, CATH(KHDOB), RDATE)
      CALL JULDAY (RDATE, JD)
      CALL GSTROT (JD, GSTIA0, GASTM, DEGPDY)
      SAFREQ = FREQ * 1.0D9
      ANFQID = -1
      XYZHAN = ' '
      TFRAME = ' '
C                                       Create/init file
      CALL ANTINI ('WRIT', IABUF, FVOL(1), FCNO(1), ANVER, CATBLK, LUNA,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *   RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME,
     *   NUMORB, NOPCAL, ANTNIF, ANFQID, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       init basic AN record
      ANNAME = 'VLA: '
      STAXOF = 0.0
      STAXYZ(1) = 0.0D0
      STAXYZ(2) = 0.0D0
      STAXYZ(3) = 0.0D0
      ORBPRM(1) = 0.0D0
      NOSTA = 0
      MNTSTA = 0
      POLAA = 0.0
      POLAB = 0.0
      CALL RFILL (3, 0.0, POLCA)
      CALL RFILL (3, 0.0, POLCB)
      POLTYA = 'R'
      POLTYB = 'L'
      DIAMAN = 25.0
      CALL RFILL (MAXIF, 0.0, FWHMAN)
      DO 10 I = 1,MXXANT
         STAXYZ(1) = BXSTA(I)
         STAXYZ(2) = BYSTA(I)
         STAXYZ(3) = BZSTA(I)
         NOSTA = I
         IF (.NOT.DOVLB) THEN
            ANNAME(5:8) = NAMSTA(I)(1:4)
         ELSE
            ANNAME = NAMSTA(I)
            END IF
         IANRNO = I
         CALL TABAN ('WRIT', IABUF, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.NE.0) GO TO 990
 10      CONTINUE
C                                       Close/update AN file.
      CALL TABIO ('CLOS', 1, IANRNO, IABUF, IABUF, IERR)
      GO TO 999
C                                       Error
 990  CALL ZCLOSE (LUNA, FINDA, JERR)
C
 999  RETURN
      END
      SUBROUTINE UVHIS
C-----------------------------------------------------------------------
C   UVHIS writes the history file for a uv data base: from EXPORT format
C   Inputs:
C      NAMEIN      C*8     Source name.
C      IQUAL       I       Source qualifier.
C      JBAND       I       Observing band (eg. 'L','C')
C      NUMVIS      I       Number of visibility points.
C      NAME
C      NAMOUT      C*12    Output file name
C      CLAOUT      C*6     Output file class.
C      SEQOUT      I       Output file sequence no.
C-----------------------------------------------------------------------
      CHARACTER CDUM*12, LNAM*12, LCLAS*6, HILINE*72, ATIME*8,
     *   HILI80*80, ADATE*12, CBAND(11)*2
      INTEGER   TIME(3), DATE(3), LUN, IERR, DUM
      LOGICAL   T
      DOUBLE PRECISION XVIS
      INCLUDE 'UVLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T /.TRUE./
      DATA LUN, DUM /28, 0.0/
      DATA CBAND /'  ','P','L','C','U','K','X','S',3*' '/
C-----------------------------------------------------------------------
C                                       Create/open hist. file.
      CALL HICREA (LUN, FVOL(1), FCNO(1), CATBLK, SCRBUF, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 900
C                                       Get current date/time.
 10   CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
C                                       Write first record.
      WRITE (HILI80,1010) TSKNAM, RLSNAM, ADATE, ATIME, NLUSER
      CALL HIAD80 (LUN, 1, HILI80, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       Write file name,class,seq.
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), LNAM)
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), LCLAS)
      CALL HENCOO (TSKNAM, LNAM, LCLAS, CATBLK(KIIMS), FVOL(1),
     *   LUN, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       If DISK file give name.
      IF (INFILE.NE.' ') THEN
         WRITE (HILINE,1013) TSKNAM, INFILE
         CALL HIADD (LUN, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 20
         END IF
C                                       Source name/qualifier/band.
      WRITE (HILINE,1011) TSKNAM, NAMEIN, IQUAL, CBAND(JBAND+2)
      CALL HIADD (LUN, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       Number of vis.
      XVIS = NUMVIS
      WRITE (HILINE,1012) TSKNAM, XVIS
      CALL HIADD (LUN, HILINE, SCRBUF, IERR)
 20   IF (IERR.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (6)
C                                       Close file
 30   CALL HICLOS (LUN, T, SCRBUF, IERR)
      IF (IERR.EQ.0) GO TO 910
C                                       Create error: make sure header
C                                       got to catalog and
 900  CALL CATIO ('UPDT', FVOL(1), FCNO(1), CATBLK, 'REST', SCRBUF,
     *   IERR)
      NCFILE = NCFILE - 1
      IF (IERR.EQ.0) GO TO 910
         WRITE (MSGTXT,1900) IERR
         CALL MSGWRT (6)
C                                       Clear write status.
 910  CALL CATDIR ('CSTA', FVOL(1), FCNO(1), CDUM, CDUM, DUM, CDUM, DUM,
     *   'CLWR', SCRBUF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVHIS: ERROR',I3,' CREATING HISTORY FILE')
 1010 FORMAT (A6,'Release=''',A7,' '' / Created at ',A,A,' by user',
     *   I5)
 1011 FORMAT (A6,' SOURCE=''',A8,''' QUAL=',I3,' BAND=''',A2,'''')
 1012 FORMAT (A6,' /Number of vis. points = ',F9.0)
 1013 FORMAT (A6,' INFILE=''',12A4,'''')
 1020 FORMAT ('UVHIS: ERROR',I3,' WRITING HISTORY FILE')
 1900 FORMAT ('ERROR',I7,' UPDATING CATALOG HEADER')
      END
      SUBROUTINE UVFHDR (ISLOT, IERR)
C-----------------------------------------------------------------------
C   UVFHDR reads the tape which must be open and positioned at beginning
C   of file and builds a catalog header and pointers from the tape
C   header records.  It then rewinds the tape in preparation for the
C   history subroutine.  It should work on any random-parameter FITS
C   tape, but is intended primarily for UV data.  UVFHDR also creates
C   the output file.
C   Output:
C      ISLOT  I     Catalog slot number for new UV file.
C      ERR   I        =0 => ok
C                     other => quit
C-----------------------------------------------------------------------
      CHARACTER DATOBS*11, CHTM8*8, DEFNAM*12, DEFCLS*6, LOCNAM*12,
     *   LOCCLS*6, FITBLK*2880, UVW(3)*4, UVW2(3)*4, ULVLWL(3)*4,
     *   UVWL2(3)*8, TELTYP*4, UVTP*2, STAT*4, PNAME*48, CHTEMP*8
      DOUBLE PRECISION XFREQ, JDAY, NEWD(128)
      REAL      ATEMP, NEWR(256)
      INTEGER   IWORK(256), ICARD, IERR, ISLOT, IREC, FPARMS, I, J, K,
     *   INC2, ISTVAL, ISTINC, ISTREF, IROUND, ISTNUM, NAXIS, IN, IS,
     *   IE, IAX, WTOFF, SCLOFF, LADR(4), LPIECE, IUSER, NEWBLK(256),
     *   IDLUN, IDFIND, ITRIM, ISIZE, LSIZE
      HOLLERITH NEWH(256), HFDVEC(50)
      LOGICAL   END, F, T, TIMDON
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'UVLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (NEWR, NEWBLK, NEWH, NEWD)
      EQUIVALENCE (IWORK, BUFF2),  (HFDVEC, FDVEC)
      DATA UVW    /'UU  ','VV  ','WW  '/
      DATA UVW2   /'UU--','VV--','WW--'/
      DATA ULVLWL /'UU-L','VV-L','WW-L'/
      DATA UVWL2 /'UU-L-NCP', 'VV-L-NCP', 'WW-L-NCP'/
      DATA IDLUN /16/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Default scalling parm for wt.
      WTSCAL = 1.0D0
C                                       Init. Stokes pointers
C                                       Init. Stokes pointers
      JADR(1) = 1
      JADR(2) = 2
      JADR(3) = 3
      JADR(4) = 4
      CALL FILL (4, 0, NPV)
C                                       Initialize BLANK values flag
C                                       to false.
      ISBLNK = .FALSE.
C                                       Zero scaling values.
      DO 10 I = 1,20
         PSCAL(I) = 0.0D0
         POFF(I) = 0.0D0
         PTYPES(I) = ' '
 10      CONTINUE
C                                       open new version
      IF (IPIECE.GT.1) THEN
C                                       close old
         IF (DODISK) THEN
            CALL TAPIO ('CLOS', FDVEC, TAPBUF, TBIND, IERR)
            I = ITRIM (INFILE)
            IF (IPIECE-1.GT.9) I = I - 1
            IF (IPIECE-1.GT.99) I = I - 1
            IF (IPIECE.LE.9) THEN
               WRITE (INFILE(I:),1010) IPIECE
            ELSE IF (IPIECE.LE.99) THEN
               WRITE (INFILE(I:),1011) IPIECE
            ELSE
               WRITE (INFILE(I:),1012) IPIECE
               END IF
            CALL CHR2H (48, INFILE, 1, HFDVEC(7))
            CALL TAPIO ('OPRD', FDVEC, TAPBUF, TBIND, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1015) IERR
               CALL MSGWRT (8)
               GO TO 999
               END IF
            END IF
C                                       read 1st record
         CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       record 1 already read from tape.
      CALL ZC8CL (2880, 1, TAPBUF(TBIND), FITBLK)
C                                       Decode required cards.
      CALL REQCD (FITBLK, ICEND, IERR)
      IF (IERR.NE.0) GO TO 999
      IF ((GROUP.EQ.1) .AND. (UVTABL)) GO TO 980
      IF ((GROUP.NE.1) .AND. (.NOT.UVTABL)) GO TO 980
      ICARD = ICEND + 1
C                                       Loop until END card found.
      DO 90 IREC = 1,100000000
C                                       Parse card, put value in hdr.
         CALL PARSCD (ICARD, FITBLK, END, IERR)
         IF (END) GO TO 100
         IF (IERR.GT.0) GO TO 999
         ICARD = ICARD + 1
 90      CONTINUE
C                                       Read more cards than we counted
C                                       on.
      WRITE (MSGTXT,1090)
      GO TO 990
C                                       End card found.
 100  CONTINUE
C                                       Reposition file
      CALL TAPIO ('BAKF', FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Correct 0 PCOUNT
      IF ((CATBLK(KIPCN).LE.0) .AND. (.NOT.UVTABL)) THEN
         DO 98 IAX = 1,KIPTPN
            IF (PTYPES(IAX).EQ.' ') THEN
               CATBLK(KIPCN) = IAX - 1
               WRITE (MSGTXT,1098) IAX-1
               CALL MSGWRT (6)
               GO TO 99
               END IF
 98         CONTINUE
         END IF
C                                       Check piece ID numbers
 99   LPIECE = IPIECE
      IF (UVTABL) THEN
         IF (NPV(1).GT.0) IPIECE = NPV(1)
         NPIECE = MIN (NPIECE, MAX (1, NPV(2)))
         IF (IPIECE.GT.NPIECE) THEN
            IERR = -1
            GO TO 999
            END IF
         IF (DPIECE.GT.0) CALL COPY (256, CATSAV, CATBLK)
         END IF
C                                       Check names.
C                                       Make axis increments non zero
C                                       to help out dumb programs.
      IN = KINAX
      IS = KRCIC
      IE = IS + CATBLK(KIDIM) - 1
      DO 101 IAX = IS,IE
         IF ((CATR(IAX).EQ.0.0).AND.(CATBLK(IN).EQ.1)) CATR(IAX) = 1.0
         IN = IN + 1
 101     CONTINUE
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), DEFNAM)
      IF (DEFNAM.EQ.' ') DEFNAM = NAMEIN
      IF (DEFNAM.EQ.' ') CALL H2CHR (8, 1, CATH(KHOBJ), DEFNAM)
      IF (DEFNAM.EQ.' ') DEFNAM(1:8) = 'NO NAME'
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), DEFCLS)
      IF (DEFCLS.EQ.' ') DEFCLS = 'UVDATA'
      IF (OUTSEQ.GE.0) CATBLK(KIIMS) = OUTSEQ
      LOCNAM = NAMOUT
      LOCCLS = CLAOUT
      CALL MAKOUT (DEFNAM, DEFCLS, 0, DEFCLS, LOCNAM, LOCCLS,
     *   CATBLK(KIIMS))
      CALL CHR2H (12, LOCNAM, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, LOCCLS, KHIMCO, CATH(KHIMC))
      CALL CHR2H (2, 'UV', KHPTYO, CATH(KHPTY))
C                                       Message to user
      CALL H2CHR (8, 1, CATH(KHDOB), CHTM8)
      CALL DATDAT (CHTM8, DATOBS)
      CALL H2CHR (8, 1, CATH(KHOBJ), CHTM8)
      WRITE (MSGTXT,1100) CHTM8, DATOBS
      IF ((CHTM8.NE.' ') .OR. (DATOBS.NE.'BAD DATE')) CALL MSGWRT (5)
C                                       Check PCOUNT
      IF (CATBLK(KIPCN).GT.20) GO TO 960
C                                       Make a number of changes needed
C                                       for our internal UV format.
      XFREQ = -1.0D0
      LCMPLX = F
      LSTOKE = F
      NAXIS = CATBLK(KIDIM)
      DO 150 I = 1,NAXIS
         J = 2 * (I - 1)  +  KHCTP
C                                       Complex axis
         CALL H2CHR (8, 1, CATH(J), CHTM8)
         IF (CHTM8.NE.'COMPLEX ') GO TO 110
            IF (I.EQ.1) GO TO 103
               WRITE (MSGTXT,1101) I
               GO TO 990
C                                       Check for non-standard Complex
 103        IF (CATBLK(KINAX+I-1).EQ.3) GO TO 150
               IF (CATBLK(KINAX+I-1).EQ.2) GO TO 105
               IF (UVTABL) GO TO 150
                  WRITE (MSGTXT,1103) CATBLK(KINAX+I-1)
                  GO TO 990
C                                       Check for need to convert
C                                       2 value complex to 3 value
C                                       complex numbers.
 105        CONTINUE
               LCMPLX = T
               CATBLK(KINAX+I-1) = 3
               GO TO 150
C                                       Check for stokes parameter that
C                                       we need to convert to RR, etc.
 110     IF ((CHTM8.NE.'STOKES  ') .OR. (UVTABL)) GO TO 130
            ATEMP = CATD(KDCRV+I-1) + (1-CATR(KRCRP+I-1)) *
     *         CATR(KRCIC+I-1)
            ISTVAL = IROUND (ATEMP)
            ISTINC = IROUND (CATR(KRCIC+I-1))
            ISTREF = IROUND (CATR(KRCRP+I-1))
            ISTNUM = CATBLK(KINAX+I-1)
            NSTACT = CATBLK(KINAX) * CATBLK(KINAX+1)
C                                       Non-standard Stokes
            IF ((ISTNUM.EQ.1) .AND. ((ABS(ISTVAL).EQ.1) .OR.
     *         (ISTVAL.EQ.-2))) GO TO 150
            IF ((ISTNUM.EQ.4) .AND. (ISTVAL.EQ.1) .AND. (ISTINC.EQ.1))
     *         GO TO 150
            IF ((ISTNUM.EQ.3) .AND. (ISTVAL.EQ.1) .AND. (ISTINC.EQ.1))
     *         GO TO 150
            IF (((ISTNUM.EQ.2) .OR. (ISTNUM.EQ.4)) .AND. (ISTVAL.EQ.-1)
     *         .AND. (ISTINC.EQ.-1)) GO TO 150
            IF (((ISTNUM.EQ.2) .OR. (ISTNUM.EQ.4)) .AND. (ISTVAL.EQ.-5)
     *         .AND. (ISTINC.EQ.-1)) GO TO 150
            IF ((ISTNUM.EQ.2) .AND. (ISTVAL.EQ.1) .AND. (ISTINC.EQ.3))
     *         GO TO 150
               IF ((I.EQ.2) .AND. (ISTNUM.EQ.4)) GO TO 115
 111              WRITE (MSGTXT,1111)
                  CALL MSGWRT (6)
                  GO TO 150
C                                       Stokes look up table
 115           DO 120 J = 1,ISTNUM
                  LADR(J) = ISTVAL + (J-ISTREF) * ISTINC
                  LADR(J) = ABS(LADR(J))
                  IF ((LADR(J).LT.1) .OR. (LADR(J).GT.4)) GO TO 111
 120              CONTINUE
               CALL COPY (4, LADR, JADR)
               LSTOKE = T
               CATD(KDCRV+I-1) = SIGN (1, ISTVAL)
               CATR(KRCIC+I-1) = CATD(KDCRV+I-1)
               CATR(KRCRP+I-1) = 1.0
               CATBLK(KINAX+I-1) = 4
               GO TO 150
C                                       Look for frequency.
 130     IF (CHTM8.EQ.'FREQ ') XFREQ = CATD(KDCRV+I-1)
 150     CONTINUE
C                                       MeerKAT
      CALL H2CHR (8, 1, CATH(KHTEL), CHTEMP)
      ISMEER = CHTEMP.EQ.'MeerKAT'
C                                       Check for the use of 2 PVALS
C                                       values to represent 1 PTYPE
      NPARMS = CATBLK(KIPCN)
      IF ((PTYPES(NPARMS-1).EQ.'WEIGHT') .AND.
     *   (PTYPES(NPARMS).EQ.'SCALE')) NPARMS = NPARMS - 2
      FPARMS = 1
      ITAB(1) = 1
      CALL CHR2H (8, PTYPES(1), 1, CATH(KHPTP))
      DO 180 I = 2,NPARMS
         DO 160 K = 1,FPARMS
            INC2 = 2 * (K-1) + KHPTP
            CALL H2CHR (8, 1, CATH(INC2), CHTM8)
            IF (PTYPES(I).EQ.CHTM8) GO TO 170
 160        CONTINUE
C                                       No equal PTYPEn's this pass.
         FPARMS = FPARMS + 1
         INC2 = 2 * (FPARMS-1) + KHPTP
         IF (FPARMS.LE.KIPTPN) CALL CHR2H (8, PTYPES(I), 1, CATH(INC2))
         K = FPARMS
C                                       Set pointer
 170     ITAB(I) = K
 180     CONTINUE
      CATBLK(KIPCN) = FPARMS
C                                       Loop through parameters
C                                       looking for DATE change
C                                       to TIME1 and UU, VV, WW
C                                       to fix up.
      TIMDON = .FALSE.
      PBASE = 0
      DO 220 I = 1,NPARMS
         INC2 = 2 * (ITAB(I) - 1) + KHPTP
         IF (PTYPES(I).EQ.'BASELINE') PBASE = I
C                                       Convert DATE to TIME1.
         IF ((.NOT.TIMDON) .AND. (PTYPES(I).EQ.'DATE')) THEN
            CALL H2CHR (8, 1, CATH(KHDOB), CHTM8)
            CALL JULDAY (CHTM8, JDAY)
            POFF(I) = POFF(I) - JDAY
            CHTM8 = 'TIME1'
            CALL CHR2H (8, CHTM8, 1, CATH(INC2))
            TIMDON = .TRUE.
C                                       Multiply UU, VV, WW random
C                                       parameters by freq.
         ELSE IF (XFREQ.GT.0.0D0) THEN
            DO 190 J = 1,3
C                                       Found one.
               IF ((UVW(J).EQ.PTYPES(I)(:4)) .OR.
     *            (UVW2(J).EQ.PTYPES(I)(:4))) THEN
                  PSCAL(I) = PSCAL(I) * XFREQ
                  POFF(I) = POFF(I) * XFREQ
                  CALL H2CHR (4, 1, CATH(KHTEL), TELTYP)
                  IF (TELTYP.EQ.'ATCA') THEN
                     CALL CHR2H (8, UVWL2(J), 1, CATH(INC2))
                  ELSE
                     CALL CHR2H (4, ULVLWL(J), 1, CATH(INC2))
                     END IF
                  GO TO 220
                  END IF
 190           CONTINUE
            END IF
 220     CONTINUE
      CATBLK(KIIMU) = NLUSER
C                                       Compressed output data?
      IF (UVTABL) DOUVCM = .FALSE.
C                                       expand baseline if allowed
      IF (PBASE.GT.0) THEN
         I = FPARMS
         IF (DOUVCM) I = I + 2
         IF (I+2.LE.KIPTPN) THEN
            PTYPES(PBASE) = 'SUBARRAY'
            PBASE = ITAB(PBASE)
            INC2 = 2 * (PBASE - 1) + KHPTP
            CALL CHR2H (8, 'SUBARRAY', 1, CATH(INC2))
            CALL APPRPM ('ANTENNA1')
            PANT1 = CATBLK(KIPCN)
            CALL APPRPM ('ANTENNA2')
            PANT2 = CATBLK(KIPCN)
         ELSE
            PBASE = 0
            END IF
         END IF
      IF (DOUVCM) THEN
         MSGTXT = 'UV data will be written in compressed format'
         CALL MSGWRT (4)
         CATBLK(KINAX) = 1
C                                       Make sure that the random
C                                       parameter list contains one
C                                       WEIGHT parameter immediately
C                                       followed by a SCALE parameter:
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), WTOFF,
     *      IERR)
         IF (IERR.NE.0) THEN
            WTOFF = -1
            IERR = 0
            END IF
C                                       WTOFF is now the offset of the
C                                       WEIGHT parameter if it already
C                                       exists and -1 otherwise.
         CALL AXEFND (8, 'SCALE   ', CATBLK(KIPCN), CATH(KHPTP), SCLOFF,
     *      IERR)
         IF (IERR.NE.0) THEN
            SCLOFF = -1
            IERR = 0
            END IF
C                                       SCLOFF is now the offset of the
C                                       SCALE parameter if it already
C                                       exists and -1 otherwise.
         IF ((WTOFF.GT.-1) .AND. (WTOFF.LT.NPARMS-1) .AND.
     *      (SCLOFF.NE.WTOFF+1)) THEN
            CALL DELRPM (WTOFF)
            WTOFF = -1
            END IF
         IF (WTOFF.EQ.-1) THEN
            CALL APPRPM ('WEIGHT  ')
            CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP),
     *         WTOFF, IERR)
C                                       AXEFND is not really necessary
C                                       here as APPRPM always adds a new
C                                       random parameter to the end of
C                                       the parameter list but leaves us
C                                       open for a more intelligent
C                                       APPRPM that re-uses deleted
C                                       parameters.
            END IF
         IF ((SCLOFF.NE.-1).AND.(SCLOFF.NE.WTOFF+1)) THEN
            CALL DELRPM (SCLOFF)
            SCLOFF = -1
            END IF
         IF (SCLOFF.EQ.-1) THEN
            CALL APPRPM ('SCALE   ')
            CALL AXEFND (8, 'SCALE   ', CATBLK(KIPCN), CATH(KHPTP),
     *         SCLOFF, IERR)
            END IF
         KLOCWT = WTOFF
         END IF
C                                       Does our file already exist
      ISLOT = 0
      IF (OUTSEQ.GT.0) THEN
         UVTP = 'UV'
         IUSER = NLUSER
         CALL CATDIR ('SRNH', DISOUT, ISLOT, LOCNAM, LOCCLS, OUTSEQ,
     *      UVTP, IUSER, STAT, SCRBUF, IERR)
         IF (IERR.EQ.5) THEN
            ISLOT = 0
            IERR = 0
            END IF
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1220) IERR, 'CATDIR'
            CALL MSGWRT (8)
            GO TO 999
            END IF
         END IF
C                                       File not found
      IF (ISLOT.LE.0) THEN
         INITVS = 0
C                                       But it is required
         IF (CONCAT.GT.0) THEN
            MSGTXT = 'OUTPUT CONCATANATION FILE NOT FOUND'
            CALL MSGWRT (8)
            IERR = -1
            GO TO 999
            END IF
C                                       Create the UV file.
         DPIECE = DPIECE + 1
         CALL UVCREA (DISOUT, ISLOT, IWORK, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Tell common we have a UV file.
         NCFILE = 1
         FVOL(1) = DISOUT
         FCNO(1) = ISLOT
         FRW(1) = 2
         OUTSEQ = CATBLK(KIIMS)
C                                       File found
      ELSE
         IF (DPIECE.GT.0) CALL COPY (256, CATSAV, CATBLK)
         DPIECE = DPIECE + 1
C                                       But that is not allowed
         IF (CONCAT.EQ.-1) THEN
            MSGTXT = 'FILE ALREADY EXISTS'
            CALL MSGWRT (8)
            IERR = -1
            GO TO 999
            END IF
         CONCAT = 1
         CALL COPY (256, CATBLK, NEWBLK)
         CALL CATIO ('READ', DISOUT, ISLOT, CATBLK, 'WRIT', IWORK, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1220) IERR, 'CATBLK READ'
            CALL MSGWRT (8)
            GO TO 999
            END IF
         INITVS = CATBLK(KIGCN)
C                                       compare things
         IF (CATBLK(KIDIM).NE.NEWBLK(KIDIM)) THEN
            WRITE (MSGTXT,1230) CATBLK(KIDIM), NEWBLK(KIDIM),
     *          'AXIS COUNT'
            GO TO 990
            END IF
         IF ((CATBLK(KIPCN).NE.NEWBLK(KIPCN)) .AND.
     *      (CATBLK(KIPCN).NE.NEWBLK(KIPCN)-2) .AND.
     *      (CATBLK(KIPCN).NE.NEWBLK(KIPCN)+2)) THEN
            WRITE (MSGTXT,1230) CATBLK(KIPCN), NEWBLK(KIPCN),
     *          'PARAMETER COUNT'
            GO TO 990
            END IF
         K = MIN (CATBLK(KIPCN), NEWBLK(KIPCN))
         DO 230 I = 1,K
            J = KHPTP + 2 * I - 2
            CALL H2CHR (8, 1, CATH(J), CHTM8)
            CALL H2CHR (8, 1, NEWH(J), CHTEMP)
            IF (CHTEMP.NE.CHTM8) THEN
               WRITE (MSGTXT,1231) CHTM8, CHTEMP, 'RANDOM PARAMETER'
               GO TO 990
               END IF
 230        CONTINUE
         K = CATBLK(KIDIM)
         DO 240 I = 2,K
            J = KHCTP + 2 * I - 2
            CALL H2CHR (8, 1, CATH(J), CHTM8)
            CALL H2CHR (8, 1, NEWH(J), CHTEMP)
            IF (CHTEMP.NE.CHTM8) THEN
               WRITE (MSGTXT,1231) CHTM8, CHTEMP, 'AXIS PARAMETER'
               GO TO 990
               END IF
            IF (CATBLK(KINAX+I-1).NE.NEWBLK(KINAX+I-1)) THEN
               WRITE (MSGTXT,1230) CATBLK(KINAX+I-1), NEWBLK(KINAX+I-1),
     *            'AXIS DIMENSION'
               GO TO 990
               END IF
            IF (ABS(CATR(KRCRP+I-1)-NEWR(KRCRP+I-1)).GT.0.01) THEN
               WRITE (MSGTXT,1232) CATR(KRCRP+I-1), NEWR(KRCRP+I-1),
     *            'REFERENCE PIXEL'
               GO TO 990
               END IF
            IF (ABS(CATD(KDCRV+I-1)-NEWD(KDCRV+I-1)).GT.0.01) THEN
               WRITE (MSGTXT,1232) CATD(KDCRV+I-1), NEWD(KDCRV+I-1),
     *            'REFERENCE VALUE'
               GO TO 990
               END IF
            IF (ABS(CATR(KRCRT+I-1)-NEWR(KRCRT+I-1)).GT.0.01) THEN
               WRITE (MSGTXT,1232) CATR(KRCRT+I-1), NEWR(KRCRT+I-1),
     *            'ROTATION'
               GO TO 990
               END IF
 240        CONTINUE
C                                       expand file
         IF (.NOT.UVTABL) THEN
            CALL UVPGET (IERR)
            CALL ZPHFIL ('UV', DISOUT, ISLOT, 1, PNAME, IERR)
            CALL ZEXIST (DISOUT, PNAME, LSIZE, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1220) IERR, 'FILE EXISTS CHECK'
               CALL MSGWRT (8)
               GO TO 999
               END IF
            CATBLK(KIGCN) = CATBLK(KIGCN) + NEWBLK(KIGCN)
            CALL UVSIZE (LREC, CATBLK(KIGCN), ISIZE)
            IF (ISIZE.GT.LSIZE) THEN
               CALL ZOPEN (IDLUN, IDFIND, DISOUT, PNAME, .TRUE., .TRUE.,
     *            .TRUE., IERR)
               IF (IERR.NE.0) GO TO 999
               I = ISIZE - LSIZE
               CALL ZEXPND (IDLUN, DISOUT, PNAME, I, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1220) IERR, 'EXPAND FILE'
                  CALL MSGWRT (8)
                  GO TO 999
                  END IF
               CALL ZCLOSE (IDLUN, IDFIND, IERR)
               IF (IERR.NE.0) GO TO 999
               END IF
            END IF
C                                       Tell common we have a UV file.
         NCFILE = 1
         FVOL(1) = DISOUT
         FCNO(1) = ISLOT
         FRW(1) = 1
         END IF
      GO TO 999
C                                       Too many random parameters.
 960  WRITE (MSGTXT,1960) CATBLK(KIPCN)
      GO TO 990
C                                       Not random parameter structure.
 980  WRITE (MSGTXT,1980)
      CALL MSGWRT (7)
      WRITE (MSGTXT,1981)
C
 990  CALL MSGWRT (7)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (I1)
 1011 FORMAT (I2)
 1012 FORMAT (I3)
 1015 FORMAT ('ERROR OPENING NEW DISK FILE:',I7)
 1090 FORMAT ('READ MORE THAN 10**8 CARDS WITHOUT FINDING AN END CARD')
 1098 FORMAT ('PCOUNT 0 CORRECTED TO',I3)
 1100 FORMAT ('Found ',A8,' observed on ',A)
 1101 FORMAT ('FOUND COMPLEX IN AXIS',I3,'. WE ONLY HANDLE AXIS 1.')
 1103 FORMAT ('FOUND ILLEGAL COMPLEX AXIS WITH',I7,' POINTS')
 1111 FORMAT ('WARNING! STOKES VALUES NOT CONVERTED TO NORMAL FORMS')
 1220 FORMAT ('ERROR',I4,' ON ',A)
 1230 FORMAT ('MISMATCH',2I12,2X,A)
 1231 FORMAT ('MISMATCH ''',A,''' ''',A,'''',2X,A)
 1232 FORMAT ('MISMATCH',2(1PE12.4),2X,A)
 1960 FORMAT ('FOUND',I7,' RANDOM PARAMETERS.  MAX = 20')
 1980 FORMAT ('EXPECTED RANDOM PARAMETER STRUCTURE NOT FOUND.')
 1981 FORMAT ('UVLOD CANNOT DO IMAGES.  IT WORKS ON UV DATA ONLY.')
      END
      SUBROUTINE REQCD (FITBLK, ICARD, IERR)
C-----------------------------------------------------------------------
C   This routine will look for the required cards in a FIT header block
C   SIMPLE, BITPIX, NAXIS, NAXISn, and update a catalog header with the
C   information from these cards.
C   Inputs:  FITBLK    C*2880 a block of fit header data.
C   Outputs: ICARD        I   The number of the last card parsed.
C            IERR         I   0=ok, 1=messed up. An error message will
C                                     be printed.
C   COMMON /MAPHDR/ Axis dimension information will be filled in.
C   COMMON /FITINF/ Sets GROUP to 1 if NAXIS1 is zero, else 0.
C-----------------------------------------------------------------------
      CHARACTER KL*80, SYMBOL*8, FITBLK*2880
      DOUBLE PRECISION    X
      INTEGER   ICARD, NPNT, IERR, ITYP, NAXIS, ITABNO, IVAL, I, IAX,
     *   IKEYWD
      LOGICAL   ISHIST, END
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFUV.INC'
      INCLUDE 'UVLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:VFUV.INC'
C-----------------------------------------------------------------------
C                                       Look for SIMPLE=T card
      ICARD = 1
      IKEYWD = 1
      NPNT = 1
      CALL GETCRD (ICARD, 1, 1, CWORD(IKEYWD), FITBLK, NPNT, KL,
     *   SYMBOL, ITABNO, ISHIST, END, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GETLG (KL, 80, NPNT, ITYP)
      USED(IKEYWD) = USED(IKEYWD) + 1
C                                       Not .TRUE.
      IF (ITYP.NE.1) GO TO 940
C                                       Look for BITPIX.
      ICARD = ICARD + 1
      IKEYWD = IKEYWD + 1
      NPNT = 1
      CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GETCRD (ICARD, 1, 1, CWORD(IKEYWD), FITBLK, NPNT, KL, SYMBOL,
     *   ITABNO, ISHIST, END, IERR)
      IF (IERR.NE.0) GO TO 970
      USED(IKEYWD) = USED(IKEYWD) + 1
C                                       Check value of BITPIX
      CALL GETNUM (KL, 80, NPNT, X)
      IF (X.EQ.DBLANK) GO TO 975
      IF (X.GE.0.0) IVAL = X + 0.1
      IF (X.LT.0.0) IVAL = X - 0.1
      IBPP = IVAL
      IF ((IVAL.NE.8) .AND. (IVAL.NE.16) .AND. (IVAL.NE.32) .AND.
     *   (IVAL.NE.-32) .AND. (IVAL.NE.-64)) GO TO 950
      IF (IVAL.EQ.-64) THEN
         MSGTXT = 'WARNING: 64-bit input stored in 32 bits inside AIPS'
         CALL MSGWRT (6)
         END IF
C                                       Check NAXIS
      ICARD = ICARD + 1
      IKEYWD = IKEYWD + 1
      NPNT = 1
      CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GETCRD (ICARD, 1, 1, CWORD(IKEYWD), FITBLK, NPNT, KL,
     *   SYMBOL, ITABNO, ISHIST, END, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL GETNUM (KL, 80, NPNT, X)
      IF (X.EQ.DBLANK) GO TO 975
      NAXIS = X + .01
      USED(IKEYWD) = USED(IKEYWD) + 1
C                                       Check NAXIS1 for group format.
      ICARD = ICARD + 1
      IKEYWD = IKEYWD + 1
      NPNT = 1
      CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GETCRD (ICARD, 1, 1, CWORD(IKEYWD), FITBLK, NPNT, KL, SYMBOL,
     *   ITABNO, ISHIST, END, IERR)
      IF (IERR.NE.0) GO TO 980
      USED(IKEYWD) = USED(IKEYWD) + 1
      CALL GETNUM (KL, 80, NPNT, X)
      IF (X.EQ.DBLANK) GO TO 975
      IVAL = X + .01
      IAX = KINAX
C                                       Set values for group structure.
      GROUP = 1
      CATBLK(KIDIM) = NAXIS - 1
C                                       Reset values for non group.
      IF (IVAL.EQ.0) GO TO 20
         GROUP = 0
         CATBLK(KIDIM) = NAXIS
         CATBLK(IAX) = IVAL
         IAX = IAX + 1
C                                       Check for invalid no. of axis
C                                       for our header.
 20   IF ((NAXIS.LT.2) .OR. (CATBLK(KIDIM).GT.7)) GO TO 960
C                                       Check NAXISm
      DO 30 I = 2,NAXIS
         ICARD = ICARD + 1
         IKEYWD = IKEYWD + 1
         NPNT = 1
         CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GETCRD (ICARD, 1, 1, CWORD(IKEYWD), FITBLK, NPNT, KL,
     *      SYMBOL, ITABNO, ISHIST, END, IERR)
         IF (IERR.NE.0) GO TO 970
         USED(IKEYWD) = USED(IKEYWD) + 1
         CALL GETNUM (KL, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 975
         CATBLK(IAX) = X + .01
         IAX = IAX + 1
 30      CONTINUE
C                                       No longer use EXTEND card
      STDEXT = .TRUE.
      GO TO 999
C                                       Not SIMPLE FITS tape.
 940  WRITE (MSGTXT,1940)
      GO TO 980
C                                       Invalid bits per pixel value.
 950  WRITE (MSGTXT,1950) IVAL
      GO TO 980
C                                       Invalid number of axis.
 960  WRITE (MSGTXT,1960) NAXIS
      GO TO 980
C                                       Expected keyword not found.
 970  WRITE (MSGTXT,1970) CWORD(IKEYWD), SYMBOL
      GO TO 980
 975  MSGTXT = 'REQCD: NUMBER ERROR ON ' // SYMBOL
C                                       Print error message set flag.
 980  CALL MSGWRT (6)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1940 FORMAT ('NOT SIMPLE FITS TAPE. PROGRAM STOPPING.')
 1950 FORMAT ('INVALID BITS PER PIXEL =',I6)
 1960 FORMAT ('INVALID NUMBER OF AXIS =',I6)
 1970 FORMAT ('EXPECTED KEYWORD ',A8,'. FOUND ',A8,'.')
      END
      SUBROUTINE PARSCD (ICARD, FITBLK, END, IERR)
C-----------------------------------------------------------------------
C   PARSCD (parse FITS card) will unpack and interpret a card image
C   from a block of FITS data and put that data into the internal AIPS
C   header.
C   Inputs:
C      ICARD   I         The card number (1-36) in block to interpret.
C      FITBLK  C*2880    A block of FITS header data.
C   Outputs:
C      END     L         True if end card found, else false.
C      IERR    I         error code 0=ok. 1=error.
C   COMMON /MAPHDR/
C   COMMON /FITINF/
C-----------------------------------------------------------------------
      CHARACTER KL*80, SYMBOL*8, STR*80, FITBLK*2880, CHTEMP*24
      DOUBLE PRECISION X
      REAL      VAL
      INTEGER   KPNTR(65), PNTR, IPOFF, TABNO, JERR, IERR, ICARD, NPNT,
     *   KT, IL, IVAL, NCHAR, NBYT, NN, NNSTR, IT, NPNTS
      LOGICAL   ISHIST, END, LHIST, FIRST
      INCLUDE 'INCS:DFUV.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'UVLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (KPNTR(1), KHOBJ)
      INCLUDE 'INCS:VFUV.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Find next symbol on the card
C                                       and look for it in the table.
      NPNT = 1
      FIRST = .TRUE.
      NN = NKT + NCT
      NNSTR = 1
      CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) GO TO 999
 10   CALL GETCRD (ICARD, NN, NNSTR, AWORD, FITBLK, NPNT, KL, SYMBOL,
     *    TABNO, LHIST, END, JERR)
      IF (END) GO TO 999
      IF (FIRST) THEN
         ISHIST = LHIST
         FIRST = .FALSE.
         IF ((KL(:12).EQ.'HISTORY AIPS') .AND.
     *      (KL(:19).NE.'HISTORY AIPS WTSCAL')) ISAIPS = .TRUE.
         IF (KL(:13).EQ.'HISTORY FITLD') ISAIPS = .TRUE.
         IF (KL(:13).EQ.'HISTORY UVLOD') ISAIPS = .TRUE.
         END IF
      IF (ISHIST) THEN
         IF (XERROR.GT.1.5) GO TO 999
         IF (JERR.EQ.1) GO TO 10
         IF ((USED(TABNO).GT.0) .AND. (JERR.EQ.0)) GO TO 10
         END IF
      IF ((JERR.EQ.1) .AND. ((SYMBOL(:2).EQ.'CD') .OR.
     *   (SYMBOL(:2).EQ.'PC') .OR. (SYMBOL(:2).EQ.'PV')))
     *   CALL PCCARD (GROUP, KL, PCMATX, CDMATX, PVMATX)
      IF (JERR.NE.0) GO TO 999
      IF (.NOT.ISHIST) USED(TABNO) = USED(TABNO) + 1
C                                       Header pointer for this
C                                       keyword, number bytes and
C                                       offset position from pointer
      PNTR = MOD (APOINT(TABNO), 1000)
      IPOFF = PNTR / 100
      PNTR = MOD (PNTR, 100)
      IF (PNTR.GT.0) PNTR = KPNTR(PNTR)
      NBYT = APOINT(TABNO) / 1000
C                                       Readjust axis pointers for grp
      IF ((GROUP.EQ.1) .AND. (TABNO.GE.21) .AND. (TABNO.LE.60))
     *   IPOFF = IPOFF - 1
C                                       Type value of keyword
C                                       1=LOGICAL
C                                       2=NUMBER
C                                       3=STRING
      KT = ATYPE(TABNO)
C                                       Logical value
      NPNTS = NPNT
      IF (KT.EQ.1) THEN
         CALL GETLG (KL, 80, NPNT, IL)
C                                       Illegal logical value.
         IF (IL.LT.0) THEN
            WRITE (MSGTXT,1100) SYMBOL
            GO TO 990
            END IF
C                                       Check for logical value
C                                       special cases.
         IF (AWORD(TABNO).EQ.'GROUPS') THEN
C                                       Structure indicated by NAXIS
C                                       and GROUP don't match.
            IF (GROUP.NE.IL) THEN
               IERR = 1
               WRITE (MSGTXT,1110)
               GO TO 990
               END IF
C                                       Handle normal logical cases.
         ELSE
            CATBLK(PNTR+IPOFF) = IL
            END IF
C                                       Number
      ELSE IF (KT.EQ.2) THEN
         CALL GETNUM (KL, 80, NPNT, X)
C                                       special parse for EQUINOX
         IF (X.EQ.DBLANK) THEN
            IF ((AWORD(TABNO).EQ.'EQUINOX') .OR.
     *         (AWORD(TABNO).EQ.'EPOCH')) THEN
               NPNT = NPNTS
               CALL GETSTR (KL, 80, 68, NPNT, STR, NCHAR)
               IF (INDEX(STR,'1950').GT.0) THEN
                  X = 1950.0D0
               ELSE IF (INDEX(STR,'2000').GT.0) THEN
                  X = 2000.0D0
                  END IF
               END IF
            END IF
         IF (X.EQ.DBLANK) THEN
            MSGTXT = 'PARSCD NUMBER ERROR ON ' // SYMBOL
            CALL MSGWRT (7)
            X = 0.0D0
            END IF
C                                       Check for number special cases.
C                                       Blank pixel value.
         IF (AWORD(TABNO).EQ.'BLANK') THEN
            IF (X.EQ.-2147483648.0D0) THEN
               IBLANK = -2147483647 - 1
            ELSE
               IBLANK = X
               END IF
            ISBLNK = .TRUE.
C                                       Scaling factors and offsets for
C                                       random parms (used in FITDAT).
         ELSE IF (AWORD(TABNO)(:5).EQ.'PSCAL') THEN
            CALL GETI (AWORD(TABNO), IT)
            PSCAL(IT) = X
         ELSE IF (AWORD(TABNO)(:5).EQ.'TSCAL') THEN
            CALL GETI (AWORD(TABNO), IT)
            PSCAL(IT) = X
         ELSE IF (AWORD(TABNO)(:5).EQ.'PZERO') THEN
            CALL GETI (AWORD(TABNO), IT)
            POFF(IT) = X
         ELSE IF (AWORD(TABNO)(:5).EQ.'TZERO') THEN
            CALL GETI (AWORD(TABNO), IT)
            POFF(IT) = X
C                                       Handle normal cases. Put value
C                                       into proper header slot.
C                                       4-byte integer
         ELSE IF (NBYT.EQ.2) THEN
            IVAL = X + SIGN (0.5D0, X)
            IF (AWORD(TABNO).EQ.'TABLES') TABLES = IVAL
            IF (PNTR.GT.0) CATBLK(PNTR+IPOFF) = IVAL
            IF (AWORD(TABNO).EQ.'IPIECE  ') THEN
               NPV(1) = IVAL
            ELSE IF (AWORD(TABNO).EQ.'NPIECE  ') THEN
               NPV(2) = IVAL
            ELSE IF (AWORD(TABNO).EQ.'FIRSTVIS') THEN
               NPV(3) = IVAL
            ELSE IF (AWORD(TABNO).EQ.'LASTVIS ') THEN
               NPV(4) = IVAL
               END IF
C                                       4-byte real
         ELSE IF (NBYT.EQ.4) THEN
            VAL = X
            IF (PNTR.GT.0) CATR(PNTR+IPOFF) = VAL
            IF (AWORD(TABNO).EQ.'WTSCAL') WTSCAL = X
C                                       8-byte real
         ELSE IF (NBYT.EQ.8) THEN
            IF (PNTR.GT.0) CATD(PNTR+IPOFF) = X
            IF (AWORD(TABNO).EQ.'BSCALE') BSC = X
            IF (AWORD(TABNO).EQ.'BZERO') BZE = X
            END IF
C                                       String
      ELSE IF (KT.EQ.3) THEN
         CALL GETSTR (KL, 80, 68, NPNT, STR, NCHAR)
C                                       Dates are special
         IF (AWORD(TABNO)(:4).EQ.'DATE') THEN
            CALL DATFST ('F2L', STR)
            NCHAR = 8
            END IF
         NCHAR = MIN (NBYT, NCHAR)
C                                       IMCLASS
         IF (AWORD(TABNO).EQ.'IMCLASS') THEN
            IPOFF = NBYT * IPOFF + 1
            CHTEMP = ' '
            CALL CHR2H (NBYT, CHTEMP, IPOFF, CATH(PNTR))
            CALL CHR2H (NCHAR, STR(1:NCHAR), IPOFF, CATH(PNTR))
         ELSE
            IPOFF = ((NBYT+3)/4) * IPOFF
C                                       Start string on integer boundary
            IF (AWORD(TABNO)(:7).EQ.'SORTORD') THEN
               CATH(PNTR+IPOFF) = HBLANK
               CALL CHR2H (NCHAR, STR(1:NCHAR), 1, CATH(PNTR+IPOFF))
C                                       Random parameter type
            ELSE IF (AWORD(TABNO)(:5).EQ.'PTYPE') THEN
               CALL GETI (AWORD(TABNO), IT)
               PTYPES(IT) = STR(1:NCHAR)
C                                       Start string on real boundary.
            ELSE
               CHTEMP = ' '
               CALL CHR2H (NBYT, CHTEMP, 1, CATH(PNTR+IPOFF))
               CALL CHR2H (NCHAR, STR(1:NCHAR), 1, CATH(PNTR+IPOFF))
               END IF
            END IF
         END IF
C                                       Loop on History cards
      IF (ISHIST) GO TO 10
      GO TO 999
C
 990  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT (A8,' LOGICAL VARIABLE HAS ILLEGAL VALUE')
 1110 FORMAT ('NAXIS AND GROUP STRUCTURE DO NOT MATCH')
      END
      SUBROUTINE UVFDAT (ISLOT, IERR)
C-----------------------------------------------------------------------
C   UVFDAT reads the tape (which must be open and positioned at begin.
C   of the binary data) and reorders and floats the binary data,
C   writing it to an AIPS random parameter catalogd file.  It leaves
C   the tape at the start of the next file.  It should work on any
C   random-parameter FITS tape, but is intended primarily for UV data.
C   Input:
C      ISLOT   I   catalog slot number of UV file.
C   Output:
C      IERR    I   0 => ok
C                  other => quit
C-----------------------------------------------------------------------
      INCLUDE 'UVLOD.INC'
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER UVNAME*48
      REAL      IOBLK(UVBFSL), RECR(UVBFSL), RECBYR(UVBFSL), XF,
     *   TBUFF(UVBFSL), WTS(10),  FITBR(720), BASEL
      DOUBLE PRECISION FITBD(360), RECBYD(UVBFSL/2)
      INTEGER   NVISOF, DVIS, VISMAX, NWDLF, FITBIN(1440), IERR, IDCTR,
     *   IVCTR, IVMAX, IDFIND, IDLUN, INDEXX, NCORR, MRPARM, NTOTAL,
     *   NAXIS, NAXVAL, ISTCNT, I, ISIZE, ISLOT, IWTCTR, NEXT, LOOP,
     *   RECBYT(UVBFSL), DATTYP, LIMIT, NW, IP, IP2, OUTP, NUMCPX,
     *   NCMPLX, VISPNT(MAXCIF), NCOPY, NMOV, POINT, NUMDO, NSTOKE,
     *   STKNUM, JNCS, STKCNT, NBLKOF, ZTYPE, ISUB, IANT1, IANT2, NVCTR
      LOGICAL   MAP, EXCL, WAIT, GOOD, DOSWAP
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (RECBYT, RECBYR, RECBYD)
      EQUIVALENCE (BUFF1, FITBIN, FITBR, FITBD),     (BUFF2, IOBLK)
      EQUIVALENCE (MAP, EXCL, WAIT)
      DATA MAP /.TRUE./
      DATA NVISOF, NBLKOF, IDLUN /0, 1, 16/
C-----------------------------------------------------------------------
      DOSWAP = ISMEER .AND. (.NOT.ISAIPS)
C                                       Crunch CATBLK
      MSGSUP = 32000
      CALL UVPGET (IERR)
      MSGSUP = 0
      CALL DFILL (6, 0.0D0, NZERO)
      IF (DOSWAP) THEN
         MSGTXT = 'Will automatically do an SWPOL on MeerKAT data'
         CALL MSGWRT (5)
      ELSE IF ((ISMEER) .AND. (ISAIPS)) THEN
         MSGTXT = 'MeerKAT data via AIPS so no SWPOL will be done'
         CALL MSGWRT (5)
         END IF
C                                       Open UV file.
      CALL ZPHFIL ('UV', DISOUT, ISLOT, 1, UVNAME, IERR)
      CALL ZOPEN (IDLUN, IDFIND, DISOUT, UVNAME, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Determine number of groups to
C                                       process.
      VISMAX = CATBLK(KIGCN)
C                                       Data type
      DATTYP = ABS (IBPP) / 8
      NW = 2880 / DATTYP
      NUMCPX = CATBLK(KINAX)
      NCMPLX = 3
      IF (LCMPLX) NCMPLX = 2
C                                       Determine number of values in
C                                       a group.
      NAXIS = CATBLK(KIDIM)
      NAXVAL = NCMPLX
      DO 10 I = 2,NAXIS
         NAXVAL = NAXVAL * CATBLK(KINAX+I-1)
 10      CONTINUE
      NCORR = NAXVAL / NCMPLX
      MRPARM = CATBLK(KIPCN)
C                                      Total vals/visrec on tape.
      NTOTAL = NPARMS + NAXVAL
C                                       test our limitations
      IF ((NTOTAL.LE.UVBFSL) .AND. (LREC.LE.UVBFSL) .AND.
     *   (NCORR.LE.MAXCIF)) GO TO 15
         WRITE (MSGTXT,1010) NTOTAL, LREC
         IERR = 2
         GO TO 995
C                                       Set visibility pointers
C                                       Put Stokes' in proper order
 15   NSTOKE = 1
      IF (JLOCS.GT.0) NSTOKE = CATBLK(KINAX+JLOCS)
      IF (JLOCS.LT.0) INCS = NUMCPX
      JNCS = INCS / NUMCPX
      LIMIT = (3 * (NAXVAL / NCMPLX)) / NUMCPX
      DO 20 LOOP = 1,LIMIT
         STKCNT = (LOOP-1) / JNCS
         STKNUM = MOD (STKCNT, NSTOKE) + 1
         INDEXX = (LOOP-1) + (JADR(STKNUM) - STKNUM) * JNCS
         VISPNT(LOOP) = CATBLK(KIPCN) + INDEXX * NUMCPX
         IF (DOUVCM) VISPNT(LOOP) = CATBLK(KIPCN) + INDEXX * 3
 20      CONTINUE
C                                       Initialize uv writing system.
      ISIZE = 2 * UVBFSL
      IVMAX = 0
      CALL UVINIT ('WRIT', IDLUN, IDFIND, CATBLK(KIGCN), NVISOF, LREC,
     *   IVMAX, ISIZE, IOBLK, NBLKOF, IDCTR, IERR)
      IF (IERR.NE.0) GO TO 999
      IVCTR = 0
      NVCTR = 0
      IWTCTR = 1
      ISTCNT = 0
      DVIS = 0
C                                      Read first record
      CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) GO TO 970
      NEXT = 1
C                                       Convert data types
      IF (IBPP.EQ.8) CALL ZI8IL (NW, 1, TAPBUF(TBIND), FITBIN)
      IF (IBPP.EQ.16) CALL ZI16IL (NW, 1, TAPBUF(TBIND), FITBIN)
      IF (IBPP.EQ.32) CALL ZI32IL (NW, 1, TAPBUF(TBIND), FITBIN)
      IF (IBPP.EQ.-32) CALL ZR32RL (NW, 1, TAPBUF(TBIND), FITBR)
      IF (IBPP.EQ.-64) CALL ZR64RL (NW, 1, TAPBUF(TBIND), FITBD)
C                                       Loop until we exhaust data.
 40   CONTINUE
         DVIS = DVIS + 1
C                                       Get next record from tape
         POINT = 1
         NMOV = NTOTAL
C                                       Determine number of words in
C                                       current record.
 50         NWDLF = NW + 1 - NEXT
            NCOPY = NMOV
            IF (NWDLF.LT.NCOPY) NCOPY = NWDLF
            NUMDO = NCOPY
C                                       integers
            IF (IBPP.GT.0) THEN
               CALL COPY (NUMDO, FITBIN(NEXT), RECBYT(POINT))
C                                       32-bit floating
            ELSE IF (IBPP.EQ.-32) THEN
               CALL RCOPY (NUMDO, FITBR(NEXT), RECBYR(POINT))
C                                       64-bit floating
            ELSE
               CALL DPCOPY (NUMDO, FITBD(NEXT), RECBYD(POINT))
               END IF
C                                       Are we done with I/O for now?
            NEXT = NEXT + NCOPY
C                                       More to do
            IF (NCOPY.GE.NMOV) GO TO 100
               POINT = POINT + NCOPY
               NMOV = NMOV - NCOPY
C                                       Read next record
               CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
               IF (IERR.NE.0) GO TO 970
C                                       Convert data types
               IF (IBPP.EQ.8) CALL ZI8IL (NW, 1, TAPBUF(TBIND), FITBIN)
               IF (IBPP.EQ.16) CALL ZI16IL (NW, 1, TAPBUF(TBIND),
     *            FITBIN)
               IF (IBPP.EQ.32) CALL ZI32IL (NW, 1, TAPBUF(TBIND),
     *            FITBIN)
               IF (IBPP.EQ.-32) CALL ZR32RL (NW, 1, TAPBUF(TBIND),
     *            FITBR)
               IF (IBPP.EQ.-64) CALL ZR64RL (NW, 1, TAPBUF(TBIND),
     *            FITBD)
               NEXT = 1
               GO TO 50
C                                       Scale and offset to R:
C                                       Integer inputs
 100     IF (IBPP.GT.0) THEN
C                                       Random parms
            DO 120 LOOP = 1,NPARMS
               RECR(LOOP) = PSCAL(LOOP) * RECBYT(LOOP) + POFF(LOOP)
 120           CONTINUE
C                                       Regular data
            LIMIT = NPARMS + 1
            IF (.NOT.ISBLNK) THEN
               DO 125 LOOP = LIMIT,NTOTAL
                  RECR(LOOP) = BSC * RECBYT(LOOP) + BZE
 125              CONTINUE
               GO TO 200
C                                       Possibly blanked
            ELSE
               DO 130 LOOP = LIMIT,NTOTAL
                  IF (RECBYT(LOOP).EQ.IBLANK) THEN
                     RECR(LOOP) = FBLANK
                  ELSE
                     RECR(LOOP) = BSC * RECBYT(LOOP) + BZE
                     END IF
 130              CONTINUE
               END IF
C                                       32 bit floating input
         ELSE IF (IBPP.EQ.-32) THEN
C                                       Random parameters
            DO 140 LOOP = 1,NPARMS
               RECR(LOOP) = PSCAL(LOOP) * RECBYR(LOOP) + POFF(LOOP)
 140           CONTINUE
C                                       Possibly blanked
C                                       Regular data
            LIMIT = NPARMS + 1
            DO 145 LOOP = LIMIT,NTOTAL
               IF (RECBYR(LOOP).EQ.FBLANK) THEN
                  RECR(LOOP) = FBLANK
               ELSE
                  RECR(LOOP) = BSC * RECBYR(LOOP) + BZE
                  END IF
 145           CONTINUE
C                                       64 bit floating input
         ELSE
C                                       Random parameters
            DO 150 LOOP = 1,NPARMS
               RECR(LOOP) = PSCAL(LOOP) * RECBYD(LOOP) + POFF(LOOP)
 150           CONTINUE
C                                       Possibly blanked
C                                       Regular data
            LIMIT = NPARMS + 1
            DO 155 LOOP = LIMIT,NTOTAL
               IF (RECBYD(LOOP).EQ.DBLANK) THEN
                  RECR(LOOP) = FBLANK
               ELSE
                  RECR(LOOP) = BSC * RECBYD(LOOP) + BZE
                  END IF
 155           CONTINUE
            END IF
C                                       Other data type go here:
C                                       Sum to output record
 200     CALL RFILL (LREC, 0.0, IOBLK(IDCTR))
         CALL RFILL (NUMCPX, 1.0, WTS)
         WTS(3) = WTSCAL
C                                       Random  parms
         DO 210 LOOP = 1,NPARMS
            IP = IDCTR + ITAB(LOOP) - 1
            IOBLK(IP) = IOBLK(IP) + RECR(LOOP)
 210        CONTINUE
         IF ((PBASE.GT.0) .OR. (ILOCB.GE.0)) THEN
            IF (PBASE.GT.0) THEN
               IP = IDCTR-1+PBASE
            ELSE
               IP = IDCTR+ILOCB
               END IF
            ZTYPE = IOBLK(IP) + 0.01
            IF ((ZTYPE/257)*257.EQ.ZTYPE) THEN
               ZTYPE = 2
            ELSE
               ZTYPE = 1
               END IF
         ELSE IF ((ILOCA1.GE.0) .AND. (ILOCA2.GE.0)) THEN
            IF (IOBLK(IDCTR+ILOCA1).EQ.IOBLK(IDCTR+ILOCA2)) THEN
               ZTYPE = 2
            ELSE
               ZTYPE = 1
               END IF
            END IF
C                                       baseline -> subarray, antenna1/2
         IF (PBASE.GT.0) THEN
            BASEL = IOBLK(IDCTR-1+PBASE)
            IANT1 = BASEL/256
            BASEL = BASEL - 256*IANT1
            IANT2 = BASEL
            ISUB = (BASEL - IANT2) * 100.0 + 1.05
            IOBLK(IDCTR-1+PBASE) = ISUB
            IOBLK(IDCTR-1+PANT1) = IANT1
            IOBLK(IDCTR-1+PANT2) = IANT2
            END IF
C                                       Regular data
C                                       Normal Complex and unblanked
         LIMIT = NPARMS + 1
         IF ((LCMPLX) .OR. (ISBLNK)) GO TO 240
C                                       Compress?
            IP = 1
            IF (DOUVCM) THEN
               DO 220 LOOP = LIMIT,NTOTAL,3
                  IP2 = VISPNT(IP) - MRPARM
                  IF ((RECR(LOOP).EQ.FBLANK) .OR.
     *               (RECR(LOOP+1).EQ.FBLANK) .OR.
     *               (RECR(LOOP+2).EQ.FBLANK)) THEN
                     CALL RFILL (3, 0.0, TBUFF(1+IP2))
                  ELSE
                     TBUFF(1+IP2) = RECR(LOOP)
                     TBUFF(2+IP2) = RECR(LOOP+1)
                     TBUFF(3+IP2) = RECR(LOOP+2) * WTSCAL
                     END IF
                  IP = IP + 1
 220              CONTINUE
               CALL UVZERO (CATBLK, DOSWAP, TBUFF, NZERO(1,ZTYPE), GOOD)
               CALL ZUVPAK (NCORR, TBUFF, IOBLK(IDCTR+KLOCWT),
     *            IOBLK(IDCTR+MRPARM))
            ELSE
               DO 230 LOOP = LIMIT,NTOTAL,3
                  IP2 = VISPNT(IP)
                  IF ((RECR(LOOP).EQ.FBLANK) .OR.
     *               (RECR(LOOP+1).EQ.FBLANK) .OR.
     *               (RECR(LOOP+2).EQ.FBLANK)) THEN
                     CALL RFILL (3, 0.0, IOBLK(IDCTR+IP2))
                  ELSE
                     IOBLK(IDCTR+IP2) = RECR(LOOP)
                     IOBLK(IDCTR+IP2+1) = RECR(LOOP+1)
                     IOBLK(IDCTR+IP2+2) = RECR(LOOP+2) * WTSCAL
                     END IF
                  IP = IP + 1
 230              CONTINUE
               CALL UVZERO (CATBLK, DOSWAP, IOBLK(IDCTR+CATBLK(KIPCN)),
     *            NZERO(1,ZTYPE), GOOD)
               END IF
            GO TO 290
C                                       Blanked and/or 2 complex axis
C                                       data.
 240     CONTINUE
            IP = 0
C                                       Compress?
            IF (DOUVCM) THEN
               DO 250 LOOP = LIMIT,NTOTAL,NCMPLX
                  IP = IP + 1
                  OUTP = VISPNT(IP) - MRPARM + 1
C                                       Check if blanked
                  IF ((RECR(LOOP).NE.FBLANK) .AND.
     *               (RECR(LOOP+1).NE.FBLANK)) THEN
                     TBUFF(OUTP) = RECR(LOOP)
                     TBUFF(OUTP+1) = RECR(LOOP+1)
                     IF (LCMPLX) THEN
                        TBUFF(OUTP+2) = 1.0
                     ELSE
                        TBUFF(OUTP+2) = RECR(LOOP+2) * WTSCAL
                        END IF
                  ELSE
C                                       Blanked
                     TBUFF(OUTP) = 0.0
                     TBUFF(OUTP+1) = 0.0
                     TBUFF(OUTP+2) = 0.0
                     END IF
 250              CONTINUE
               CALL UVZERO (CATBLK, DOSWAP, TBUFF, NZERO(1,ZTYPE), GOOD)
               CALL ZUVPAK (NCORR, TBUFF, IOBLK(IDCTR+KLOCWT),
     *            IOBLK(IDCTR+MRPARM))
            ELSE
C                                       Normal output data
               DO 260 LOOP = LIMIT,NTOTAL,NCMPLX
                  IP = IP + 1
                  OUTP = VISPNT(IP) + IDCTR
C                                       Check if blanked
                  IF ((RECR(LOOP).NE.FBLANK) .AND.
     *               (RECR(LOOP+1).NE.FBLANK)) THEN
                     IOBLK(OUTP) = RECR(LOOP)
                     IOBLK(OUTP+1) = RECR(LOOP+1)
                     IF (LCMPLX) THEN
                        IOBLK(OUTP+2) = 1.0
                     ELSE
                        IOBLK(OUTP+2) = RECR(LOOP+2) * WTSCAL
                        END IF
                  ELSE
C                                       Blanked
                     IOBLK(OUTP) = 0.0
                     IOBLK(OUTP+1) = 0.0
                     IOBLK(OUTP+2) = 0.0
                     END IF
 260              CONTINUE
               CALL UVZERO (CATBLK, DOSWAP, IOBLK(IDCTR+CATBLK(KIPCN)),
     *            NZERO(1,ZTYPE), GOOD)
               END IF
C                                       Write
 290     IF ((DOKEEP.GT.0.0) .OR. (GOOD)) THEN
            IVCTR = IVCTR + 1
            NVCTR = NVCTR + 1
            IDCTR = IDCTR + LREC
            IF (MOD(NVCTR,100000).EQ.1) THEN
               WRITE (MSGTXT,1290) NVCTR
               CALL MSGWRT (2)
               END IF
C                                       Write this full buffer.
            IF (IVCTR.GE.IVMAX) THEN
               CALL UVDISK ('WRIT', IDLUN, IDFIND, IOBLK, IVMAX, IDCTR,
     *            IERR)
               IF (IERR.NE.0) GO TO 980
               IVCTR = 0
               END IF
         ELSE
            NSKIP = NSKIP + 1
            END IF
C                                       Test to see if we continue main
C                                       loop.
         IF (DVIS.LT.VISMAX) GO TO 40
C                                       Finish up any pending disk I/O.
      IVCTR = -IVCTR
      CALL UVDISK ('FLSH', IDLUN, IDFIND, IOBLK, IVCTR, IDCTR, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       not all written
      IF (NSKIP.GT.0) THEN
         VISMAX = VISMAX - NSKIP
         CALL UCMPRS (VISMAX, DISOUT, ISLOT, IDLUN, CATBLK, IERR)
         IERR = 0
         END IF
C                                       messages
      DO 310 ZTYPE = 1,2
         IF (ZTYPE.EQ.1) THEN
            MSGTXT = 'UVFDAT: counts for cross-correlations'
         ELSE
            MSGTXT = 'UVFDAT: counts for auto-correlations'
            END IF
         IF ((NZERO(1,ZTYPE).GT.0.0D0) .OR. (NZERO(2,ZTYPE).GT.0.0D0))
     *      CALL MSGWRT (4)
         IF (NZERO(1,ZTYPE).GT.0.0D0) THEN
            WRITE (MSGTXT,1300) NZERO(1,ZTYPE)
            CALL MSGWRT (4)
            IF (NZERO(3,ZTYPE).GT.0) THEN
               XF = 100.0 * NZERO(1,ZTYPE) / NZERO(3,ZTYPE)
               WRITE (MSGTXT,1301) XF
               CALL MSGWRT (4)
               END IF
            END IF
         IF (NZERO(2,ZTYPE).GT.0.0D0) THEN
            WRITE (MSGTXT,1302) NZERO(2,ZTYPE)
            CALL MSGWRT (4)
            IF (NZERO(3,ZTYPE).GT.0) THEN
               XF = 100.0 * NZERO(2,ZTYPE) / NZERO(3,ZTYPE)
               WRITE (MSGTXT,1303) XF
               CALL MSGWRT (4)
               END IF
            END IF
 310     CONTINUE
      IF (NSKIP.GT.0) THEN
         WRITE (MSGTXT,1310) NSKIP
         CALL MSGWRT (4)
         END IF
      GO TO 999
C                                       Problem reading tape.
 970  WRITE (MSGTXT,1970) IERR
      GO TO 995
C                                       Problem writing data.
 980  WRITE (MSGTXT,1980) IERR
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('UVFDAT: BUFFERS TOO SMALL FOR THESE DATA; NEED',2I8)
 1290 FORMAT ('UVFDAT at record',I12)
 1300 FORMAT ('Flagged',F14.0,' valid spectra samples which',
     *   ' were pure 0')
 1301 FORMAT ('Flagged',F14.3,' percent valid samples',
     *   ' which were pure 0')
 1302 FORMAT ('Found',F14.0,' spectra samples already flagged')
 1303 FORMAT ('Found',F14.3,' percent samples already flagged')
 1310 FORMAT ('Omitted',I12,' totally flagged vis records')
 1970 FORMAT ('UVFDAT: ERROR READING TAPE. IERR=', I6)
 1980 FORMAT ('UVFDAT: ERROR WRITTING TO DISK. IERR=', I6)
      END
      SUBROUTINE UVFHIS (ISLOT, IHLUN, IERR)
C-----------------------------------------------------------------------
C   UVFHIS reads the tape (which must be open and positioned at begin.
C   of file) and builds a history file from the FITS history and other
C   keywords in the FITS header.  The Antenna file is also created at
C   this time and the antenna information found in the history is put
C   in this file.  This program leaves the tape positioned at the
C   start of the binary data.  It should work on any random-parameter
C   FITS tape, but is intended primarily for UV data.
C   INPUT:  ISLOT  I        catalog slot of UV data file.
C           IHLUN  I        history file logical unit number.
C   Output: IERR   I        =0 => ok
C                           other => quit
C-----------------------------------------------------------------------
      CHARACTER KL*80, SYMBOL*8, LNAM*12, LCLAS*6, CARD*80, HILINE*72,
     *   CHTMP*8, FITBLK*2880
      DOUBLE PRECISION    DABLK(128)
      REAL      ABLK(256)
      INTEGER   IHBLK(256), IABLK(512), IERR, ISLOT, ICARD, IREC,
     *   ITABNO, IALUN, INC, IST, I, NOANT, NPNT, NN, NNSTR, IHLUN,
     *   IHERR, JERR, I4, ITRIM
      LOGICAL   UPDATE, END, ISHIST, EQUAL
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'UVLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFUV.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (DABLK, ABLK, IABLK)
      INCLUDE 'INCS:VFUV.INC'
      DATA UPDATE /.TRUE./
      DATA IALUN /30/
C-----------------------------------------------------------------------
      IERR = 0
C                                       Init number of ant records.
      NOANT = 0
      NN = NCT + NKT
      NNSTR = NCT + 1
C                                       Create HI file
      IF (CONCAT.EQ.1) MSGSUP = 32000
      CALL HICREA (IHLUN, DISOUT, ISLOT, CATBLK, IHBLK, IHERR)
      MSGSUP = 0
      IF (IHERR.NE.0) GO TO 950
C                                       Header msg in HI
         WRITE (HILINE,1000) ('----', I = 1,17)
         IF (IHERR.EQ.0) CALL HIADD (IHLUN, HILINE, IHBLK, IHERR)
      IF (CONCAT.NE.1) THEN
         WRITE (HILINE,1002)
      ELSE
         WRITE (HILINE,1003)
         END IF
      IF (IHERR.EQ.0) CALL HIADD (IHLUN, HILINE, IHBLK, IHERR)
C                                       Read record 1 from tape.
      CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
      IF (IERR.NE.0) GO TO 960
      CALL ZC8CL (2880, 1, TAPBUF(TBIND), FITBLK)
C                                       Skip required cards.
      ICARD = ICEND
C                                       Loop until END card found.
      DO 30 IREC = 1,100000000
         ICARD = ICARD + 1
C                                       Read next non-blank record.
         CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) GO TO 960
C                                       Parse card, put unknown cards
C                                       in history file.
         INC = (ICARD-1) * 80 + 1
         CHTMP = FITBLK(INC:INC+7)
         EQUAL = ('HISTORY'.EQ.CHTMP) .OR. ('COMMENT'.EQ.CHTMP) .OR.
     *      (' '.EQ.CHTMP)
         IST = 1
         IF (EQUAL) IST = 9
         IF (CONCAT.EQ.1) THEN
            IF (CHTMP.EQ.'END     ') GO TO 40
            INC = (ICARD - 1) * 80  +  1
            CARD = FITBLK(INC:INC+79)
            IF (CARD(:15).EQ.'HISTORY AIPS   ') THEN
               IF ((CARD(16:21).EQ.'IPIECE') .OR.
     *            (CARD(16:21).EQ.'FIRSTV') .OR.
     *            (CARD(16:21).EQ.'LASTVI')) THEN
                  IF (IHERR.EQ.0) CALL HIAD80 (IHLUN, IST, CARD, IHBLK,
     *               IHERR)
                  END IF
               END IF
         ELSE
            NPNT = 1
            CALL GETCRD (ICARD, NN, NNSTR, AWORD, FITBLK, NPNT, KL,
     *         SYMBOL, ITABNO, ISHIST, END, JERR)
            IF (END) GO TO 40
            IF ((JERR.NE.0) .OR. (IST.NE.1)) THEN
               INC = (ICARD - 1) * 80  +  1
               CARD = FITBLK(INC:INC+79)
C                                       special header keywords
               IF (JERR.EQ.-1) THEN
                  CALL PUTCRD (CARD, DISOUT, ISLOT, JERR)
                  IF (JERR.GT.1) THEN
                     WRITE (MSGTXT,1010) JERR
                     CALL MSGWRT (7)
                     IERR = JERR
                     GO TO 999
                     END IF
C                                       Antenna record.
               ELSE IF ((ISHIST) .AND. (SYMBOL(:4).EQ.'ANT ')) THEN
                  CALL ANTREC (KL, NPNT, IALUN, ISLOT, NOANT, IABLK,
     *               JERR)
C                                       Add this unknown card to hist.
               ELSE
                  IF (IHERR.EQ.0) CALL HIAD80 (IHLUN, IST, CARD, IHBLK,
     *               IHERR)
                  END IF
               END IF
            END IF
 30      CONTINUE
C                                       Read more cards than expected.
      GO TO 970
C                                       End card found.
C                                       Clean up antenna file stuff.
 40   IF (NOANT.EQ.0) GO TO 70
C                                       Close ant file, save last recrd
      CALL TABIO ('CLOS', 1, I4, BUFF1, IABLK, JERR)
C                                       Add history info
 70   IF (CONCAT.NE.1) THEN
         WRITE (HILINE,1070)
         IF (IHERR.EQ.0) CALL HIADD (IHLUN, HILINE, IHBLK, IHERR)
         WRITE (HILINE,1072) RLSNAM, ('----', I = 1,11)
         IF (IHERR.EQ.0) CALL HIADD (IHLUN, HILINE, IHBLK, IHERR)
         CALL H2CHR (12, KHIMNO, CATH(KHIMN), LNAM)
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), LCLAS)
         IF (IHERR.EQ.0) CALL HENCOO (TSKNAM, LNAM, LCLAS,
     *      CATBLK(KIIMS), FVOL(1), IHLUN, IHBLK, IHERR)
         END IF
C                                       If DISK file give name.
      IF (INFILE.NE.' ') THEN
         I = ITRIM (INFILE)
         WRITE (HILINE,1074) TSKNAM, INFILE(:I)
         IF (IHERR.EQ.0) CALL HIADD (IHLUN, HILINE, IHBLK, IERR)
         END IF
      CALL HICLOS (IHLUN, UPDATE, IHBLK, I)
      IF (IHERR.EQ.0) GO TO 999
C                                       Error handling.
C                                       History file error.
 950  WRITE (MSGTXT,1950)
      GO TO 990
C                                       Tape read problem.
 960  WRITE (MSGTXT,1960)
      GO TO 990
C                                       Read more cards than we
C                                       expected.
 970  WRITE (MSGTXT,1970)
C
 990  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('/',17A4)
 1002 FORMAT ('/Begin "HISTORY" information found in FITS tape ',
     *   'header by UVLOD')
 1003 FORMAT ('/Begin concatanated "HISTORY" information from FITS ',
     *   'header by UVLOD')
 1010 FORMAT ('ERROR',I5,' ADDING KEYWORD TO HEADER FILE')
 1070 FORMAT ('/End FITS tape header "HISTORY" information')
 1072 FORMAT ('UVLOD RELEASE= ''',A7,' '' /',11A4)
 1074 FORMAT (A6,'INFILE=''',A,'''')
 1950 FORMAT ('HISTORY FILE PROBLEM.')
 1960 FORMAT ('TAPE PROBLEM DURING HISTORY FILE READ.')
 1970 FORMAT ('READ MORE THAN 10**8 CARDS WITHOUT AN END CARD.')
      END
      SUBROUTINE ANTREC (KL, NPNT, IALUN, ISLOT, NOANT, IABLK, IERR)
C-----------------------------------------------------------------------
C   ANTREC will parse the part of a antenna record history card
C   after 'HISTORY AIPS_or_CVAX ANT' and put the values it finds in an
C   antenna record and write the antenna record to the antenna
C   extension file.  If no antenna file exists (NOANT equals zero)
C   then one will be created.
C   Inputs:
C      KL     C*80     history card.
C      NPNT   I        index into KL after HISTORY AIPS ANT has been
C                      parsed.
C      IALUN  I        logical unit number for antenna file.
C      ISLOT  I        Catalog slot number for UV catalog file.
C   In/out:
C      NOANT  I        Current number of antenna records.
C      IABLK  I(512)   Antenna file I/O buffer.
C   Output:
C      IERR   I        error code. 0=ok. A message will be printed if
C                      an error occurs.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER  CHFREQ*8, ANTTAB(5)*8, IDUMMY*2, KL*80, SYMBOL*8,
     *   STR*80
      DOUBLE PRECISION X, C, JD, GASTM
      INTEGER   IABLK(512), NPNT, IERR, NOANT, INTDUM, IALUN,
     *   ITABNO, NCHAR, I, ISLOT, VER, JLOCF, KERR
      LOGICAL   ISHIST, END
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'UVLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA CHFREQ /'FREQ    '/
      DATA C /.2997924562D0/
      DATA ANTTAB /'N       ','X       ','Y       ',
     *             'Z       ','ST      '/
C-----------------------------------------------------------------------
C                                       Create antenna file.
      IF (NOANT.GT.0) GO TO 100
C                                       Setup for AN table initization
         NUMORB = 0
         NOPCAL = 2
         ANFQID = -1
         ANTNIF = 2
C                                       Position of the earth's pole
         POLRXY(1) = 0.0
         POLRXY(2) = 0.0
         UT1UTC = 0.0
         DATUTC = 0.0
         TIMSYS = 'IAT'
C                                       Array name
         CALL H2CHR (8, 1, CATH(KHTEL), ANAME)
C                                       Array center (rel to center of
C                                       earth)
         ARRAYC(1) = 0.0D0
         ARRAYC(2) = 0.0D0
         ARRAYC(3) = 0.0D0
C                                       Get GST0 and Earth rotation rate
         CALL H2CHR (8, 1, CATH(KHDOB), RDATE)
         CALL JULDAY (RDATE, JD)
         CALL GSTROT (JD, GSTIA0, GASTM, DEGPDY)
         CALL AXEFND (4, CHFREQ, KICTPN, CATH(KHCTP), JLOCF, KERR)
         SAFREQ = CATD(KDCRV+JLOCF)
         VER = 1
         XYZHAN = ' '
         TFRAME = ' '
C                                       Create/init file
         CALL ANTINI ('WRIT', IABLK, DISOUT, ISLOT, VER, CATBLK, IALUN,
     *      IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *      RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *      TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       init basic AN record
         ANNAME = '        '
         STAXOF = 0.0
         STAXYZ(1) = 0.0D0
         STAXYZ(2) = 0.0D0
         STAXYZ(3) = 0.0D0
         ORBPRM(1) = 0.0D0
         NOSTA = 0
         MNTSTA = 0
         POLAA = 0.0
         POLAB = 0.0
         CALL RFILL (3, 0.0, POLCA)
         CALL RFILL (3, 0.0, POLCB)
         POLTYA = 'R'
         POLTYB = 'L'
         DIAMAN = 25.
         FWHMAN(1) = 0.0
         FWHMAN(2) = 0.0
         DIAMAN = 0.0
         CALL RFILL (MAXIF, 0.0, FWHMAN)
C                                       Write NULL antenna record
         DO 10 I = 1,30
            IANRNO = NOSTA
            CALL TABAN ('WRIT', IABLK, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
            IF (IERR.NE.0) GO TO 999
 10         CONTINUE
C                                       Parse rest of antenna card.
 100  DO 200 I = 1,5
         CALL GETCRD (INTDUM, 5, 1, ANTTAB, IDUMMY, NPNT, KL, SYMBOL,
     *      ITABNO, ISHIST, END, IERR)
         IF (IERR.EQ.1) GO TO 200
         IF (IERR.NE.0) GO TO 980
         IF (ITABNO.NE.5) THEN
            CALL GETNUM (KL, 80, NPNT, X)
            IF (X.EQ.DBLANK) GO TO 975
            END IF
         GO TO (110, 120, 130, 140, 150), ITABNO
C                                       Station number.
 110        CONTINUE
               NOSTA = X + .5
               GO TO 200
C                                       X
 120        CONTINUE
               STAXYZ(1) = X * C
               GO TO 200
C                                       Y
 130        CONTINUE
               STAXYZ(2) = X * C
               GO TO 200
C                                       Z
 140        CONTINUE
               STAXYZ(3) = X * C
               GO TO 200
C                                       Station name.
 150           CALL GETSTR (KL, 80, 4, NPNT, STR, NCHAR)
               NCHAR = MIN (4, NCHAR)
               ANNAME(1:NCHAR) = STR(1:NCHAR)
 200     CONTINUE
C                                       Write antenna record.
         IANRNO = NOSTA
         CALL TABAN ('WRIT', IABLK, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Increment no. of ant records.
      NOANT = NOANT + 1
      GO TO 999
C                                       Incorrect ant rec format.
 975  MSGTXT = 'ANTREC: INVALID NUMBER VALUE'
      IERR = 1
      GO TO 990
 980  MSGTXT = 'ANTREC: INVALID ANTENNA RECORD CARD FORMAT'
 990  CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE UVFEXT (CNO, HLUN, IRET)
C-----------------------------------------------------------------------
C   UVFEXT processes records following the normal FITS image.  If
C   TABLES <= 0, it simply counts the number of such records.  Else,
C   it parses through the Table records creating the appropriate
C   extension files and adding the table header cards to the
C   history file.  This is for the old tables of AIPS style.
C   Inputs:
C      CNO    I         Catalog slot number of UV file.
C      HLUN   I         LUN of open history file
C   Output:
C      IRET   I         Error code: 0 => ok, 8 => some error
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER  CHFREQ*8, ISTR*80, SYM*8, CARD*80, CTYPES(1)*4,
     *   SYMS(15)*8, TABNAM*8, TTYPE(10)*8, FITBLK*2880
      DOUBLE PRECISION C, X, DABLK(1), JD, DEG2RD, DELDAT, GASTM
      REAL      ABLK(1)
      INTEGER   HLUN, HBUFF(256), IRET, IOFF, IERR, TERR, TABVER, J,
     *   TABCNT, TABWID, TABCRD, NC, INC, NPNT, ITYP, NSYMS, NCHAR, NIF,
     *   ITABL, NTYPES, IT, LUN, BUFFER(512), IP, I, CNO, IREC
      LOGICAL   HISERR, NODATA
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'UVLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (BUFFER, ABLK, DABLK, BUFF2)
      DATA NSYMS, NTYPES, LUN /15, 1, 28/
      DATA CHFREQ /'FREQ    '/
      DATA CTYPES /'  AN'/
      DATA SYMS /'TTYPE1  ', 'TTYPE2  ', 'TTYPE3  ', 'TTYPE4  ',
     *   'TTYPE5  ', 'TTYPE6  ', 'TTYPE7  ', 'TTYPE8  ',
     *   'TTYPE9  ', 'TTYPE10 ', 'TABNAME ', 'TABVER  ',
     *   'TABCOUNT', 'TABWIDTH', 'TABCARDS'/
      DATA C /.2997924562D0/
C-----------------------------------------------------------------------
      IERR = 0
      TERR = 0
      IRET = 0
      DELDAT = 0.1D0
      DEG2RD = 3.141592653589793D0 / 180.0D0
      IF (TABLES.LE.0) GO TO 910
      CALL HIOPEN (HLUN, DISOUT, CNO, HBUFF, IERR)
      HISERR = IERR.NE.0
      IRET = 8
C                                       Loop over tables
      DO 300 ITABL = 1,TABLES
         WRITE (MSGTXT,1000) ITABL
         IF (.NOT.HISERR) CALL HIAD80 (HLUN, 1, MSGTXT, HBUFF, IERR)
         IF (IERR.NE.0) HISERR = .TRUE.
C                                       Init table parm values
         TABVER = 0
         TABCNT = 0
         TABWID = 0
         TABCRD = 0
         TABNAM = ' '
         DO 20 I = 1,10
            TTYPE(I) = '        '
 20         CONTINUE
C                                       Read and parse header
         DO 90 IREC = 1,100
C                                       1st Block read in EXTREQ.
            IF (IREC.EQ.1) GO TO 50
               CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, TERR)
               IF (TERR.EQ.0) GO TO 30
                  WRITE (MSGTXT,1020) TERR
                  GO TO 890
 30            NC = 0
               CALL ZC8CL (2880, 1, TAPBUF(TBIND), FITBLK)
C                                       card loop
 50         NC = NC + 1
            IF (NC.GT.36) GO TO 90
C                                       card to history
            INC = (NC-1) * 80 + 1
            CARD = FITBLK(INC:INC+79)
            IF (HISERR) GO TO 55
               IF (CARD(1:4).NE.'END ') CALL HIAD80 (HLUN, 1, CARD,
     *            HBUFF, IERR)
               HISERR = IERR.NE.0
C                                       Parse
 55         NPNT = 1
            CALL GETSYM (CARD, NPNT, SYM, ITYP)
            IF (SYM.EQ.'END ') GO TO 100
C                                       only keyword = value accepted
            IF (ITYP.NE.0) GO TO 50
            DO 60 I = 1,NSYMS
               IF (SYM.EQ.SYMS(I)) GO TO 70
 60            CONTINUE
            GO TO 50
C                                       Numeric keywords
 70         IF (I.LE.11) GO TO 80
               CALL GETNUM (CARD, 80, NPNT, X)
               IF (X.EQ.DBLANK) GO TO 875
               IF (I.EQ.12) TABVER = X + 0.01
               IF (I.EQ.13) TABCNT = X + 0.01
               IF (I.EQ.14) TABWID = X + 0.01
               IF (I.EQ.15) TABCRD = X + 0.01
               GO TO 50
C                                       Got a string variable
 80         CONTINUE
               CALL GETSTR (CARD, 80, 68, NPNT, ISTR, NCHAR)
               NCHAR = MIN (NCHAR, 8)
               IF (I.EQ.11) TABNAM = ISTR(1:NCHAR)
               IF (I.LT.11) TTYPE(I) = ISTR(1:NCHAR)
               GO TO 50
 90         CONTINUE
         WRITE (MSGTXT,1090) ITABL
         GO TO 890
C                                       END card found
C                                       null table
 100     IF ((TABCNT.GT.0) .AND. (TABWID.GT.0)) GO TO 105
            WRITE (MSGTXT,1100) ITABL
            CALL MSGWRT (6)
            GO TO 270
C                                       illegal format
 105     IF ((TABCRD.GT.0) .AND. (TABCRD.LE.40)) GO TO 110
            WRITE (MSGTXT,1105) TABCRD, ITABL
            GO TO 890
C                                       A recognized type?
 110     NODATA = .TRUE.
         IF (TABNAM(1:4).NE.'AIPS') GO TO 125
            DO 115 IT = 1,NTYPES
               IF (CTYPES(IT).EQ.TABNAM(5:8)) GO TO 120
 115           CONTINUE
            GO TO 125
C                                       Yes: do it - AN files only
 120     IF (IT.NE.1) GO TO 125
C                                       Setup for AN table initization
            NUMORB = 0
            NOPCAL = 2
            ANFQID = -1
C                                       Position of the earth's pole
            POLRXY(1) = 0.0
            POLRXY(2) = 0.0
            UT1UTC = 0.0
            DATUTC = 0.0
            TIMSYS = 'IAT'
C                                       Array name
            CALL H2CHR (8, 1, CATH(KHTEL), ANAME)
C                                       Array center (rel to center of
C                                       earth)
            ARRAYC(1) = 0.0D0
            ARRAYC(2) = 0.0D0
            ARRAYC(3) = 0.0D0
C                                       Get GST0 and Earth rotation rate
            CALL H2CHR (8, 1, CATH(KHDOB), RDATE)
            CALL JULDAY (RDATE, JD)
            CALL GSTROT (JD, GSTIA0, GASTM, DEGPDY)
C                                       Get frequency
            IOFF = 0
            CALL AXEFND (4, CHFREQ, KICTPN, CATH(KHCTP), IOFF, IERR)
            SAFREQ = CATD(KDCRV+IOFF)
C                                       Number of values in each column
C                                       in the AN table.
            MSGSUP = 32000
            CALL UVPGET (IERR)
            MSGSUP = 0
            NIF = 1
            IF (JLOCIF.GE.0) NIF = MAX (1, CATBLK(KINAX+JLOCIF))
            ANTNIF = NIF
C                                       init basic AN record
            ANNAME = '        '
            STAXOF = 0.0
            STAXYZ(1) = 0.0D0
            STAXYZ(2) = 0.0D0
            STAXYZ(3) = 0.0D0
            ORBPRM(1) = 0.0D0
            NOSTA = 0
            MNTSTA = 0
            POLAA = 0.0
            POLAB = 0.0
            CALL RFILL (3, 0.0, POLCA)
            CALL RFILL (3, 0.0, POLCB)
            POLTYA = 'R'
            POLTYB = 'L'
            XYZHAN = ' '
            TFRAME = ' '
            DIAMAN = 0.0
            CALL RFILL (MAXIF, 0.0, FWHMAN)
C                                       Create/init file
            CALL ANTINI ('WRIT', BUFFER, DISOUT, CNO, TABVER, CATBLK,
     *         LUN, IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY,
     *         SAFREQ, RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME,
     *         XYZHAN, TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IERR)
            IF (IERR.EQ.0) GO TO 125
               WRITE (MSGTXT,1120) IERR
               CALL MSGWRT (7)
C
 125     IP = TABCRD
         NODATA = .FALSE.
         DO 260 I = 1,TABCNT
            DO 250 J = 1,TABWID
               IP = IP + 1
               IF (IP.LE.TABCRD) GO TO 140
                  NC = NC + 1
C                                       read a record
                  IF (NC.LE.36) GO TO 130
                     NC = 1
                     CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, TERR)
                     CALL ZC8CL (2880, 1, TAPBUF(TBIND), FITBLK)
                     IF (TERR.EQ.0) GO TO 130
                        WRITE (MSGTXT,1020) TERR
                        GO TO 890
C                                       spread new card
 130              IP = 1
                  IF (NODATA) GO TO 140
                     INC = (NC-1) * 80 + 1
                     CARD = FITBLK(INC:INC+79)
                     NPNT = 1
 140              IF (NODATA) GO TO 250
C                                       Set proper Ant rec variable.
                     IF (J.NE.2) THEN
                        CALL GETNUM (CARD, 80, NPNT, X)
                        IF (X.EQ.DBLANK) GO TO 875
                        END IF
                     GO TO (150, 160, 170, 180, 190), J
C                                       Station number.
 150                    NOSTA = X + .5
                        GO TO 250
C                                       Station name.
 160                    CALL GETSTR (CARD, 80, 8, NPNT, ISTR, NCHAR)
                        ANNAME = ISTR(1:NCHAR)
C                                       STATION X
 170                    STAXYZ(1) = C * X
                        GO TO 250
C                                       STATION Y
 180                    STAXYZ(2) = C * X
                        GO TO 250
C                                       STATION Z
 190                    STAXYZ(3) = C * X
 250              CONTINUE
               IF (NODATA) GO TO 260
                  IANRNO = NOSTA
                  CALL TABAN ('WRIT', BUFFER, IANRNO, ANKOLS, ANNUMV,
     *               ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF,
     *               DIAMAN, FWHMAN, POLTYA, POLAA, POLCA, POLTYB,
     *               POLAB, POLCB, IERR)
                  IF (IERR.NE.0) GO TO 900
 260           CONTINUE
C                                       Close ant file.
               CALL TABIO ('CLOS', 1, IANRNO, BUFFER, BUFFER, IERR)
               WRITE (MSGTXT,1267) 'AN', TABVER
               CALL MSGWRT (2)
               GO TO 300
C                                       Data ignored
 270        CONTINUE
               WRITE (MSGTXT,1270) ITABL
               CALL MSGWRT (2)
               IF (HISERR) GO TO 300
                  CALL HIAD80 (HLUN, 1, MSGTXT, HBUFF, IERR)
                  HISERR = IERR.NE.0
 300     CONTINUE
      IRET = 0
      GO TO 900
C
 875  MSGTXT = 'FITEXT: NUMBER ERROR ON ' // SYM
      IRET = 1
C
 890  CALL MSGWRT (8)
C                                       OK if EOF found
      IF (TERR.EQ.4) IRET = 0
C                                       Read rest of tape
 900  CALL HICLOS (HLUN, .TRUE., HBUFF, IERR)
 910  IF (TERR.NE.4) CALL MLREOF (FDVEC, TBIND, UNKNWN, TAPBUF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVLOD  / Header for table',I7)
 1020 FORMAT ('UVFEXT: FITS IO ERROR',I7)
 1090 FORMAT ('UVFEXT: NO END TO TABLE HEADER #',I7)
 1100 FORMAT ('TABLE',I7,' HAS NO DATA')
 1105 FORMAT ('UVFEXT: TABCARDS=',I7,' ILLEGAL')
 1120 FORMAT ('UVFEXT: UNABLE TO CREATE EXTENSION FILE',I7)
 1267 FORMAT ('Extension file type ',A2,' version',I4,' written')
 1270 FORMAT ('UVLOD / Table',I7,' skipped')
      END
      SUBROUTINE FITRXU (CNO, HLUN, LAST, EOF, IERR)
C-----------------------------------------------------------------------
C  This routine will read all fits extension files associated with UV
C  data and process the ones it recognizes (XTENSION = 'TABLE'
C  and 'BINTABLE' (or temporary names 'A3DTABLE' & '3D TABLE').
C  Inputs:
C     CNO     I    Catalog number of the UV file.
C     HLUN    I    History file LUN. Already open.
C     LAST    L    Last piece?
C  OUTPUTS:
C     EOF     L    An end of file was read during processing.
C     IERR    I    Error code. 0=ok.
C-----------------------------------------------------------------------
      INTEGER   CNO, HLUN, IERR
      LOGICAL   LAST, EOF
C                                       MXTBKW=max. no. table keywords
      INTEGER   MXTBKW
      PARAMETER (MXTBKW = 200)
      CHARACTER KEYWRD(MXTBKW)*8, KEYCHR(MXTBKW)*8, TAB3D(3)*8,
     *   FITBLK*2880, HILINE*72
      HOLLERITH KEYH(2)
      DOUBLE PRECISION  NBITS, AXCNT, KEYVAL(MXTBKW), KEYD
      REAL      KEYR, XF
      INTEGER   I, II, ICARD, ANLUN, INBLK, IKEY, HBUFF(256), IVER,
     *   TABLUN, SRTORD, DATP(128,2), BUFFER(512), KEYI(2), NUMKEY,
     *   KEYTYP(MXTBKW), KEYLOC(MXTBKW), KEYV(2*MXTBKW), LENKEY(5),
     *   JERR, JTRIM, JT
      LOGICAL   EXTEN, KEYL, DOHDR, WASSU
      INCLUDE 'UVLOD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DEHD.INC'
      INCLUDE 'INCS:DTHD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (KEYL, KEYI, KEYH, KEYR, KEYD)
      DATA TAB3D /'BINTABLE', 'A3DTABLE', '3D TABLE'/
      DATA ANLUN, TABLUN /28, 29/
C-----------------------------------------------------------------------
C                                       Length of keyword values
      LENKEY(1) = NWDPDP
      LENKEY(2) = 1
      LENKEY(3) = 2
      LENKEY(4) = 1
      LENKEY(5) = 1
      CALL HIOPEN (HLUN, DISOUT, CNO, HBUFF, IERR)
      WASSU = .FALSE.
C                                       Loop for all FITS extensions.
      DO 200 I = 1,32000
         NUMKEY = 0
C                                       Process all required FITS table
C                                       cards.
         CALL EXTREQ (FDVEC, TBIND, TAPBUF, FITBLK, ICARD, EXTEN, EOF,
     *      UNKNWN, IERR)
         IF (EOF) GO TO 900
         IF (.NOT.EXTEN) GO TO 900
         IF (IERR.NE.0) GO TO 910
C                                       Calculate no. of data blocks.
         AXCNT = 1.0D0
         DO 20 II = 1,NAXIS
            AXCNT = AXCNT * NAXISI(II)
 20         CONTINUE
         AXCNT = AXCNT + PCOUNT
         NBITS = ABS (BITPIX) * GCOUNT * AXCNT
         INBLK = INT ((NBITS + 23039.0D0) / 23040.0D0)
         DOHDR = .FALSE.
C                                       See if we have an ASCII table.
         IF (EXTTYP.NE.'TABLE') GO TO 40
            IF (NAXISI(1).LE.2880) GO TO 25
               WRITE (MSGTXT,1020) NAXISI(1)
               CALL MSGWRT (8)
               GO TO 100
C                                       initialize default values.
 25         CALL SETDEF
C                                       Process table file header.
            NUMKEY = MXTBKW
            CALL TABHDR (FDVEC, TBIND, ICARD, HLUN, HBUFF, 0, NUMKEY,
     *         KEYWRD, KEYVAL, KEYCHR, KEYTYP, TAPBUF, FITBLK, IERR)
            IF (IERR.LT.0) GO TO 100
            IF (IERR.NE.0) GO TO 910
C                                       Process AN table and write
C                                       AN file records.
            IF (ITYPE.NE.'AN') GO TO 30
               CALL ANTAB (FDVEC, TBIND, DISOUT, CNO, ANLUN, NAXISI,
     *            TAPBUF, IERR)
C                                       Add AIPS AN history
               WRITE (MSGTXT,1025)
               CALL EXTHIS (HLUN, HBUFF, IERR)
               GO TO 200
C                                       Normal table files. Special
C                                       processing if its an AIPS style
C                                       table.
 30            SRTORD = 0
               IF (ITYPE.NE.'UK') CALL ATCONV (NUMKEY, KEYWRD,
     *            KEYVAL, KEYTYP, KEYCHR, SRTORD)
C                                       Create and initialize the table
C                                       header with data in common.
               IVER = 0
               CALL MAKTAB (SRTORD, DISOUT, CNO, IVER, CATBLK, TABLUN,
     *            DATP, BUFFER, IERR)
               IF (IERR.GT.0) GO TO 110
C                                       Prepare keywords
               IKEY = 1
               DO 35 II = 1,NUMKEY
                  KEYLOC(II) = IKEY
                  IF (KEYTYP(II).EQ.2) KEYTYP(II) = 1
                  IF (KEYTYP(II).EQ.1) KEYD = KEYVAL(II)
                  IF (KEYTYP(II).EQ.3) THEN
                     JT = JTRIM (KEYCHR(II))
                     CALL CHR2H (8, KEYCHR(II), 1, KEYH)
                     END IF
                  IF (KEYTYP(II).EQ.4) KEYI(1) = KEYVAL(II)
                  IF (KEYTYP(II).EQ.5) KEYL = KEYVAL(II).GT.0.0D0
                  CALL COPY (LENKEY(KEYTYP(II)), KEYI, KEYV(IKEY))
                  IKEY = IKEY + LENKEY(KEYTYP(II))
 35               CONTINUE
C                                       Write keywords
               CALL TABKEY ('WRIT', KEYWRD, NUMKEY, BUFFER, KEYLOC,
     *            KEYV, KEYTYP, IERR)
               IF (IERR.NE.0) THEN
                  CALL TABIO ('CLOS', 0, II, BUFFER, BUFFER, IERR)
                  GO TO 110
                  END IF
C                                       Read the data from tape and
C                                       write to the table disk file.
               CALL RWTAB (FDVEC, TBIND, DATP, NAXISI, BUFFER, TAPBUF,
     *            IERR)
               EOF = EOF .OR. (IERR.EQ.4)
               IF (IERR.NE.0) GO TO 910
               GO TO 200
C                                       See if we have a 3-D table.
 40      IF ((EXTTYP.NE.TAB3D(1)) .AND. (EXTTYP.NE.TAB3D(2)) .AND.
     *      (EXTTYP.NE.TAB3D(3))) GO TO 100
C                                       initialize default values.
            CALL SETDEF
C                                       Process table file header.
            NUMKEY = MXTBKW
            CALL TABHDR (FDVEC, TBIND, ICARD, HLUN, HBUFF, 1, NUMKEY,
     *         KEYWRD, KEYVAL, KEYCHR, KEYTYP, TAPBUF, FITBLK, IERR)
            IF (IERR.LT.0) GO TO 100
            IF (IERR.NE.0) GO TO 910
C                                       plot file
            IF ((ITYPE.EQ.'PL') .OR. (ITYPE.EQ.'SL')) THEN
               CALL READPL (ITYPE, DISOUT, CNO, IVER, CATBLK, FDVEC,
     *            INBLK, TBIND, TAPBUF, IERR)
               IF (IERR.NE.0) THEN
                  MSGTXT = 'FITRXM ERROR READING ' // ITYPE //
     *               ' PSEUDO-TABLE'
                  CALL MSGWRT (7)
                  END IF
               GO TO 200
               END IF
            IF (ITYPE.NE.'UV') THEN
C                                       Normal table files. Special
C                                       processing if its an AIPS style
C                                       table.
               SRTORD = 0
               IF (ITYPE.NE.'UK') CALL ATCONV (NUMKEY, KEYWRD, KEYVAL,
     *            KEYTYP, KEYCHR, SRTORD)
C                                       Create and initialize the table
C                                       header with data in common.
               IVER = 0
               IF (UVTABL) IVER = EXTVER
               CALL MAKTAB (SRTORD, DISOUT, CNO, IVER, CATBLK, TABLUN,
     *            DATP, BUFFER, IERR)
               IF (IERR.GT.0) GO TO 110
C                                       file already exists
               IF ((UVTABL) .AND. (IERR.EQ.0)) THEN
                  IF ((ITYPE.NE.'CL') .AND. (ITYPE.NE.'SN') .AND.
     *               (ITYPE.NE.'TY') .AND. (ITYPE.NE.'MC') .AND.
     *               (ITYPE.NE.'IM') .AND. (ITYPE.NE.'BP')) THEN
                     CALL TABIO ('CLOS', 0, II, BUFFER, BUFFER, IERR)
                     GO TO 110
                     END IF
                  END IF
C                                       Prepare keywords
               IF ((IERR.EQ.-1) .OR. (.NOT.UVTABL)) THEN
                  IERR = 0
                  IKEY = 1
                  DO 80 II = 1,NUMKEY
                     KEYLOC(II) = IKEY
                     IF (KEYTYP(II).EQ.2) KEYTYP(II) = 1
                     IF (KEYTYP(II).EQ.1) KEYD = KEYVAL(II)
                     IF (KEYTYP(II).EQ.3) THEN
                        JT = JTRIM (KEYCHR(II))
                        CALL CHR2H (8, KEYCHR(II), 1, KEYH)
                        END IF
                     IF (KEYTYP(II).EQ.4) KEYI(1) = KEYVAL(II)
                     IF (KEYTYP(II).EQ.5) KEYL = KEYVAL(II).GT.0.0D0
                     CALL COPY (LENKEY(KEYTYP(II)), KEYI, KEYV(IKEY))
                     IKEY = IKEY + LENKEY(KEYTYP(II))
 80                  CONTINUE
C                                       Write keywords
                  CALL TABKEY ('WRIT', KEYWRD, NUMKEY, BUFFER, KEYLOC,
     *               KEYV, KEYTYP, IERR)
                  IF (IERR.NE.0) THEN
                     CALL TABIO ('CLOS', 0, II, BUFFER, BUFFER, IERR)
                     GO TO 110
                     END IF
                  END IF
C                                       Read the data from tape and
C                                       write to the table disk file.
               CALL R3DTAB (FDVEC, TBIND, DATP, NAXISI, BUFFER, TAPBUF,
     *            IERR)
               EOF = EOF .OR. (IERR.EQ.4)
               IF (IERR.NE.0) GO TO 910
               IF (ITYPE.EQ.'SU') WASSU = .TRUE.
C                                       UV data table
            ELSE
               CALL RUVTAB (NPV, FDVEC, TBIND, NAXISI, DISOUT, CNO,
     *            LAST, NSKIP, DOKEEP, BUFF1, BUFF2, TAPBUF, IERR)
               EOF = EOF .OR. (IERR.EQ.4)
               IF (IERR.NE.0) GO TO 910
               END IF
            GO TO 200
C                                       Skip unknown extension file.
 100     CONTINUE
C                                       read rest header code
            DOHDR = .TRUE.
C                                       else header already read
 110        CALL SKPEXT (DOHDR, FDVEC, TBIND, HLUN, ICARD, INBLK, HBUFF,
     *         TAPBUF, FITBLK, IERR)
            IF (IERR.NE.0) GO TO 910
 200     CONTINUE
C                                       Shouldn't get here.
      MSGTXT = 'MORE THAN 32000 EXTENSION FILES. SOME NOT PROCESSED'
      CALL MSGWRT (8)
C                                       zero records flagged
 900  IF (NZERO(1,1).GT.0.0D0) THEN
         WRITE (HILINE,1900) TSKNAM, NZERO(1,1), 'cross'
         CALL HIADD (HLUN, HILINE, HBUFF, JERR)
         END IF
      IF (NZERO(1,2).GT.0.0D0) THEN
         WRITE (HILINE,1900) TSKNAM, NZERO(1,2), 'auto'
         CALL HIADD (HLUN, HILINE, HBUFF, JERR)
         END IF
      IF ((NZERO(2,1).GT.0.0D0) .AND. (NZERO(3,1).GT.0.0D0)) THEN
         XF = 100.0 * NZERO(2,1) / NZERO(3,1)
         WRITE (HILINE,1905) TSKNAM, 'cross', XF
         CALL HIADD (HLUN, HILINE, HBUFF, JERR)
         END IF
      IF ((NZERO(2,2).GT.0.0D0) .AND. (NZERO(3,2).GT.0.0D0)) THEN
         XF = 100.0 * NZERO(2,2) / NZERO(3,2)
         WRITE (HILINE,1905) TSKNAM, 'auto', XF
         CALL HIADD (HLUN, HILINE, HBUFF, JERR)
         END IF
 910  CALL HICLOS (HLUN, .TRUE., HBUFF, JERR)
C                                       source table apparent positions
      IF (WASSU) CALL SUPREC (DISOUT, CNO, CATBLK, JERR)
      CALL CATIO ('UPDT', DISOUT, CNO, CATBLK, 'CLWR', SCRBUF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1910) JERR, 'CATBLK UPDATE'
         CALL MSGWRT (8)
         END IF
      NCFILE = 0
      IERR = MAX (0, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('FITRXU: ASCII TABLE ROW LENGTH',I7,' TOO LONG FOR ME')
 1025 FORMAT ('UVLOD / AIPS antennas table')
 1900 FORMAT (A,'NZERO=',F12.0,' / ',A,
     *   '-corr spectra flagged as pure 0')
 1905 FORMAT (A,'/ percent ',A,'corr SPWs previously flagged',F7.2)
 1910 FORMAT ('ERROR',I5,' DOING ',A)
      END
      SUBROUTINE ANTAB (FDVEC, TBIND, IVOL, ICNO, ANLUN, NAXIS, TAPBUF,
     *   IERR)
C-----------------------------------------------------------------------
C  This routine will read the data section of a FITS extension file
C  of type TABLE and with the EXTNAM of AIPS AN (antenna), decode this
C  information using data obtained from the header section of the
C  extension file, and write the AIPS version of the ANtenna file.
C  Inputs:
C     FDVEC    I(50)     File descriptor vector for TAPIO input
C     IVOL     I         Disk volume number of map.
C     ICNO     I         Catalog number of map.
C     ANLUN    I         AIPS LUN to use for AN file
C     NAXIS    I(2)      Length of card, number of cards in table.
C     IHDR     I(256)    Catalog header of map.
C  Input/output:
C     TAPBUF   I(*)      TAPIO buffer
C     TBIND    I         Buffer pointer in TAPBUF
C  Outputs:
C     IERR     I        Error code. 0=ok.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER  CHFREQ*8, LINE*1024, TLINE*1024, ANTNO*8, STATON*8,
     *   LX*8, LY*8, LZ*8
      INTEGER   NAXIS(2), IVOL, ICNO, ANLUN, FDVEC(40), TBIND, IERR,
     *   TAPBUF(*), JT, JTRIM, NIF
      DOUBLE PRECISION X, DABLK(128), JD, DEG2RD, DELDAT, GASTM
      REAL      ANBUF(1)
      INTEGER   NCTR, EXTVER, INDEXX, I, NAXIS1, NAXIS2, LCTR, NPNTR,
     *   IWIDTH, IFRAC, IANBUF(512), TORDER(5), IOFF
      LOGICAL   EQUAL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTHD.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (DABLK, ANBUF, IANBUF)
      DATA CHFREQ /'FREQ'/
      DATA ANTNO, STATON /'ANT NO. ','STATION '/
      DATA LX, LY, LZ /'LX      ','LY      ','LZ      '/
C-----------------------------------------------------------------------
      NAXIS1 = NAXIS(1)
      NAXIS2 = NAXIS(2)
C
      DEG2RD = 3.141592653589793D0 / 180.0D0
      DELDAT = 0.1D0
C                                       Setup for AN table initization
      NUMORB = 0
      NOPCAL = 2
C                                       Position of the earth's pole
      POLRXY(1) = 0.0
      POLRXY(2) = 0.0
      UT1UTC = 0.0
      DATUTC = 0.0
      TIMSYS = 'IAT'
C                                       Array name
      CALL H2CHR (8, 1, CATH(KHTEL), ANAME)
C                                       Array center (rel to center of
C                                       earth)
      ARRAYC(1) = 0.0D0
      ARRAYC(2) = 0.0D0
      ARRAYC(3) = 0.0D0
C                                       Get GST0 and Earth rotation rate
      CALL H2CHR (8, 1, CATH(KHDOB), RDATE)
      CALL JULDAY (RDATE, JD)
      CALL GSTROT (JD, GSTIA0, GASTM, DEGPDY)
C                                       Get frequency
      IOFF = 0
      CALL AXEFND (4, CHFREQ, KICTPN, CATH(KHCTP), IOFF, IERR)
      SAFREQ = CATD(KDCRV+IOFF)
C                                       init basic AN record
      ANNAME = '        '
      STAXOF = 0.0
      STAXYZ(1) = 0.0D0
      STAXYZ(2) = 0.0D0
      STAXYZ(3) = 0.0D0
      ORBPRM(1) = 0.0D0
      NOSTA = 0
      MNTSTA = 0
      POLAA = 0.0
      POLAB = 0.0
      CALL RFILL (3, 0.0, POLCA)
      CALL RFILL (3, 0.0, POLCB)
      POLTYA = 'R'
      POLTYB = 'L'
      ANFQID = -1
      MSGSUP = 32000
      CALL UVPGET (IERR)
      MSGSUP = 0
      NIF = 1
      IF (JLOCIF.GE.0) NIF = MAX (1, CATBLK(KINAX+JLOCIF))
      ANTNIF = NIF
      XYZHAN = ' '
      TFRAME = ' '
C                                       Create/init file
      EXTVER = 0
      CALL ANTINI ('WRIT', IANBUF, IVOL, ICNO, EXTVER, CATBLK, ANLUN,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IERR)
      IF (IERR.NE.0) GO TO 999
      NCTR = 2881
C                                       Determine order of standard
C                                       values on card.
      DO 100 I = 1,ITNCOL
         IF (TTYPE(I).EQ.ANTNO) TORDER(1) = I
         IF (TTYPE(I).EQ.STATON) TORDER(2) = I
         IF (TTYPE(I).EQ.LX) TORDER(3) = I
         IF (TTYPE(I).EQ.LY) TORDER(4) = I
         IF (TTYPE(I).EQ.LZ) TORDER(5) = I
 100     CONTINUE
      DIAMAN = 0.0
      CALL RFILL (MAXIF, 0.0, FWHMAN)
C                                       Loop for all lines in table.
      DO 800 LCTR = 1, NAXIS2
C                                       Read a FITS table data line.
         CALL TABLIN (NAXIS1, FDVEC, TBIND, NCTR, TAPBUF, TLINE, IERR)
         LINE(1:NAXIS1) = TLINE(1:NAXIS1)
         IF (IERR.NE.0) GO TO 999
         DO 200 I = 1,5
C                                       Decode the 5 data fields.
            INDEXX = TORDER(I)
            NPNTR = TBCOL(INDEXX)
            IWIDTH = TWIDTH(INDEXX)
            GO TO (150, 120, 150, 150, 150) , I
 120        CONTINUE
C                                       Station name.
               ANNAME = TLINE(NPNTR:NPNTR+IWIDTH-1)
               JT = JTRIM (ANNAME)
               GO TO 200
C                                       Station No. or Position.
 150        CONTINUE
               IFRAC = TFRAC(INDEXX)
               X = 0.0D0
               EQUAL = TLINE(NPNTR:NPNTR+NAXIS1-1) .EQ.
     *            TNULL(INDEXX)(1:NAXIS1)
               IF (.NOT.EQUAL)
     *            CALL DCODEF (NPNTR, IWIDTH, IFRAC, LINE, X, IERR)
               IF (I.EQ.1) NOSTA = X + .01
               IF (I.EQ.3) STAXYZ(1) =  X
               IF (I.EQ.4) STAXYZ(2) =  X
               IF (I.EQ.5) STAXYZ(3) =  X
 200        CONTINUE
C                                       Write the AIPS AN record.
         IANRNO = NOSTA
         CALL TABAN ('WRIT', IANBUF, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
C
 800     CONTINUE
      CALL TABIO ('CLOS', 1, IANRNO, IANBUF, IANBUF, IERR)
C
 999  RETURN
      END
      SUBROUTINE DELRPM (IOFF)
C-----------------------------------------------------------------------
C   Delete the random parameter at offset IOFF from the random parameter
C   list (0 <= IOFF < CATBLK(KIPCN)). If the indicated parameter is at
C   the end of the random parameter list then the number of random
C   parameters is decreased by one, otherwise the name of the random
C   parameter is set to 'REMOVED '.
C
C   Inputs:
C     IOFF       I       Offset of random parameter to delete
C
C   Input/Output in common:
C     CATBLK     I(*)    UV file header
C     CATH       H(*)    UV file header
C     KIPCN      I       CATBLK(KIPCN) is the number of random
C                        parameters
C     KHPTP      I       The list of random parameter names starts at
C                        CATH(KHPTP)
C-----------------------------------------------------------------------
      INTEGER   IOFF

      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      IF (IOFF .EQ. CATBLK(KIPCN)-1) THEN
         CATBLK(KIPCN) = CATBLK(KIPCN) - 1
      ELSE
         CALL CHR2H (8, 'REMOVED ', 1, CATH(KHPTP+2*IOFF))
         END IF
C
 999  RETURN
      END
      SUBROUTINE APPRPM (NAME)
C-----------------------------------------------------------------------
C   Append a random parameter with name NAME to the end of the random
C   parameter list.
C
C   Input:
C     NAME       C*8       Name of new random parameter
C
C   Input/output in common:
C     CATBLK     I*(*)     UV data header
C     CATH       H*(*)     UV data header
C     KIPCN      I         CATBLK(KIPCN) is the number of random
C                          parameters
C     KHPTP      I         The list of random parameter names starts at
C                          CATH(KHPTP)
C-----------------------------------------------------------------------
      CHARACTER NAME*8

      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      CALL CHR2H (8, NAME, 1, CATH(KHPTP + 2 * CATBLK(KIPCN)))
      CATBLK(KIPCN) = CATBLK(KIPCN) + 1
C
 999  RETURN
      END
      SUBROUTINE SUPREC (DISK, CNO, CATBLK, IERR)
C-----------------------------------------------------------------------
C   SUPREC re-writes the SU table, precessing the coordinates of epoch
C   to approximate apparent coordinates when J2000 is being used.
C   Input:
C      DISK     I      Disk number
C      CNO      I      Catalog number
C      CATBLK   I(*)   Catalog header
C   Output:
C      IERR     I       Error code
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, CATBLK(256), IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   BUFFER(512), LUN, NUMIF, FREQID, ISURNO, SUKOLS(MAXSUC),
     *   SUNUMV(MAXSUC), IDSOU, QUAL, VER, NREC, IREC, IHOL(2)
      HOLLERITH HHOL(2)
      REAL      FLUX(4,MAXIF), POLAR(2)
      DOUBLE PRECISION FREQO(MAXIF), BANDW, RAEPO, DECEPO, EQUINX, JD0,
     *   RAAPP, DECAPP, LSRVEL(MAXIF), LRESTF(MAXIF), PMRA, PMDEC,
     *   OBSPOS(3), RAOBS, DECOBS
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4, RDATE*8
      LOGICAL   ISOPEN
      EQUIVALENCE (IHOL, HHOL)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA OBSPOS, POLAR /3*0.0D0, 2*0.0/
C-----------------------------------------------------------------------
      IERR = 0
      CALL FNDEXT ('SU', CATBLK, VER)
      IF (VER.LE.0) GO TO 999
      LUN = 57
      ISOPEN = .FALSE.
      CALL SOUINI ('WRIT', BUFFER, DISK, CNO, VER, CATBLK, LUN, NUMIF,
     *   VELTYP, VELDEF, FREQID, ISURNO, SUKOLS, SUNUMV, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INIT'
         GO TO 990
         END IF
      ISOPEN = .TRUE.
      NREC = BUFFER(5)
      CALL COPY (2, CATBLK(KHDOB), IHOL)
      CALL H2CHR (8, 1, HHOL, RDATE)
      CALL JULDAY (RDATE, JD0)
      DO 100 IREC = 1,NREC
         ISURNO = IREC
         CALL TABSOU ('READ', BUFFER, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EQUINX, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF, PMRA,
     *      PMDEC, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READ'
            GO TO 990
            END IF
C                                       compute apparents pos
         CALL JPRECS (JD0, EQUINX, 1.0D-6, 1, .TRUE., OBSPOS,
     *      POLAR, DG2RAD * RAEPO, DG2RAD * DECEPO, RAAPP, DECAPP)
         RAAPP = RAD2DG * RAAPP
         DECAPP = RAD2DG * DECAPP
         IF (RAAPP.LT.0.0D0) RAAPP = RAAPP + 360.0D0
C                                       put back in file
         ISURNO = IREC
         CALL TABSOU ('WRIT', BUFFER, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EQUINX, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF, PMRA,
     *      PMDEC, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'WRIT'
            GO TO 990
            END IF
 100     CONTINUE
      GO TO 995
C
 990  CALL MSGWRT (7)
 995  IF (ISOPEN) CALL TABSOU ('CLOS', BUFFER, ISURNO, SUKOLS, SUNUMV,
     *   IDSOU,SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO,
     *   DECEPO, EQUINX, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF,
     *   PMRA, PMDEC, IREC)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SUPREC ERROR',I4,' ON ',A,' FIXING APPARENT COORDINATES')
      END
      SUBROUTINE SUCHCK (DISK, CNO)
C-----------------------------------------------------------------------
C   SUCHCK re-writes the SU table changing duplicate source names
C   Input:
C      DISK   I   Disk number
C      CNO    I   Catalog number
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO
C
      INTEGER   MAXSOU
      PARAMETER (MAXSOU = 1000)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   BUFFER(512), LUN, NUMIF, FREQID, ISURNO, SUKOLS(MAXSUC),
     *   SUNUMV(MAXSUC), IDSOU, QUAL, VER, NREC, IREC, IERR, JTRIM,
     *   SNUM(MAXSOU), LUNTMP, JREC, J, CHANGE, SQUAL(MAXSOU)
      REAL      FLUX(4,MAXIF)
      DOUBLE PRECISION FREQO(MAXIF), BANDW, RAEPO, DECEPO, EQUINX,
     *   RAAPP, DECAPP, LSRVEL(MAXIF), LRESTF(MAXIF), PMRA, PMDEC,
     *   RAOBS, DECOBS
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4,
     *   SNAM(MAXSOU)*16, SCALC(MAXSOU)*4
      LOGICAL   ISOPEN
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      IERR = 0
      CALL FNDEXT ('SU', CATBLK, VER)
      IF (VER.LE.0) GO TO 999
      LUN = LUNTMP (1)
      ISOPEN = .FALSE.
      CALL SOUINI ('WRIT', BUFFER, DISK, CNO, VER, CATBLK, LUN, NUMIF,
     *   VELTYP, VELDEF, FREQID, ISURNO, SUKOLS, SUNUMV, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INIT'
         GO TO 990
         END IF
      ISOPEN = .TRUE.
      NREC = BUFFER(5)
C                                       read in names
      DO 20 IREC = 1,NREC
         ISURNO = IREC
         CALL TABSOU ('READ', BUFFER, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EQUINX, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF, PMRA,
     *      PMDEC, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READ'
            GO TO 990
            END IF
         J = JTRIM (SOUNAM)
         SNAM(IREC) = SOUNAM
         SNUM(IREC) = IDSOU
         SQUAL(IREC) = QUAL
         SCALC(IREC) = CALCOD
 20      CONTINUE
C                                       chck for duplicates
      CHANGE = 0
 30   DO 50 IREC = 1,NREC-1
         DO 40 JREC = IREC+1,NREC
            IF ((SNAM(IREC).EQ.SNAM(JREC)) .AND.
     *         (SNUM(IREC).NE.SNUM(JREC)) .AND.
     *         (SCALC(IREC).EQ.SCALC(JREC)) .AND.
     *         (SQUAL(IREC).EQ.SQUAL(JREC))) THEN
               ISURNO = JREC
               CALL TABSOU ('READ', BUFFER, ISURNO, SUKOLS, SUNUMV,
     *            IDSOU, SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW,
     *            RAEPO, DECEPO, EQUINX, RAAPP, DECAPP, RAOBS, DECOBS,
     *            LSRVEL, LRESTF, PMRA, PMDEC, IERR)
               IF (IERR.GT.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'RE-READ'
                  GO TO 990
                  END IF
               QUAL = QUAL + 1
               SQUAL(JREC) = QUAL
               ISURNO = JREC
               CALL TABSOU ('WRIT', BUFFER, ISURNO, SUKOLS, SUNUMV,
     *            IDSOU, SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW,
     *            RAEPO, DECEPO, EQUINX, RAAPP, DECAPP, RAOBS, DECOBS,
     *            LSRVEL, LRESTF, PMRA, PMDEC, IERR)
               IF (IERR.GT.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'RE-READ'
                  GO TO 990
                  END IF
               CHANGE = CHANGE + 1
               WRITE (MSGTXT,1030) IDSOU, SOUNAM, QUAL
               CALL MSGWRT (3)
               GO TO 30
               END IF
 40         CONTINUE
 50      CONTINUE
      IF (CHANGE.GT.0) THEN
         WRITE (MSGTXT,1050) CHANGE
         CALL MSGWRT (2)
         END IF
      GO TO 995
C
 990  CALL MSGWRT (7)
 995  IF (ISOPEN) CALL TABSOU ('CLOS', BUFFER, ISURNO, SUKOLS, SUNUMV,
     *   IDSOU,SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO,
     *   DECEPO, EQUINX, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF,
     *   PMRA, PMDEC, IREC)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SUCHCK ERROR',I4,' ON ',A,' CHECKING SOURCE NAMES')
 1030 FORMAT ('SUCHCK: source number',I5,' named ',A,' new qual',I5)
 1050 FORMAT ('SUCHCK: changed',I4,' total duplicate source names')
      END
      SUBROUTINE UVZERO (CATBLK, DOSWAP, VIS, NZERO, GOOD)
C-----------------------------------------------------------------------
C   Checks for all freq channels pure zero in real and imag and flags
C   them
C   Inputs:
C      CATBLK   I(*)     Header
C      DOSWAP   L        Swap polarizations on MeerKAT data
C   In/out
C      VIS      R(3,*)   data
C      NZERO    D(3)     Number spectra all zero counter, (3) total,
C                        (2) previously flagged
C   Output:
C      GOOD     L        Some good data?
C-----------------------------------------------------------------------
      INTEGER   CATBLK(256)
      DOUBLE PRECISION NZERO(3)
      REAL      VIS(3,*)
      LOGICAL   DOSWAP, GOOD
C
      INTEGER   NS, NIF, NF, NC, JNCIF, JNCF, JNCS, I, J, JIF, JS, JF, K
      REAL      TEMP
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       pointers to traverse the data
      NS = 1
      NIF = 1
      NF = 1
      NC = CATBLK(KINAX)
      JNCIF = INCIF / NC
      JNCF  = INCF / NC
      JNCS  = INCS / NC
      IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
      IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
      IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
      DO 40 JIF = 1,NIF
         DO 30 JS = 1,NS
            J = (JIF-1) * JNCIF + (JS-1) * JNCS + 1
            I = J - JNCF
            NZERO(3) = NZERO(3) + 1.0D0
C                                       all already flagged?
            DO 10 JF = 1,NF
               I = I + JNCF
               IF (VIS(3,I).GT.0.0) GO TO 15
 10            CONTINUE
            NZERO(2) = NZERO(2) + 1.0D0
            GO TO 30
C                                      all valid are zero?
 15         I = J - JNCF
            DO 20 JF = 1,NF
               I = I + JNCF
               IF ((VIS(3,I).GT.0.0) .AND. ((VIS(1,I).NE.0.0) .OR.
     *            (VIS(2,I).NE.0.0))) GO TO 30
 20            CONTINUE
C                                       all zero: flag
            NZERO(1) = NZERO(1) + 1.0D0
            I = J - JNCF
            DO 25 JF = 1,NF
               I = I + JNCF
               VIS(3,I) = MIN (0.0, -ABS(VIS(3,I)))
 25            CONTINUE
 30         CONTINUE
 40      CONTINUE
C                                       look again, anything good
      GOOD = .TRUE.
      DO 70 JIF = 1,NIF
         DO 60 JS = 1,NS
            J = (JIF-1) * JNCIF + (JS-1) * JNCS + 1
            I = J - JNCF
C                                       all already flagged?
            DO 50 JF = 1,NF
               I = I + JNCF
               IF (VIS(3,I).GT.0.0) GO TO 100
 50            CONTINUE
 60         CONTINUE
 70      CONTINUE
      GOOD = .FALSE.
      GO TO 999
C                                       Swap MeerKAT
 100  IF (DOSWAP) THEN
         DO 140 JIF = 1,NIF
            DO 130 JS = 1,NS,2
               J = (JIF-1) * JNCIF + (JS-1) * JNCS + 1
               I = J - JNCF
               J = J + JNCS - JNCF
               DO 120 JF = 1,NF
                  I = I + JNCF
                  J = J + JNCF
                  DO 110 K = 1,3
                     TEMP = VIS(K,I)
                     VIS(K,I) = VIS(K,J)
                     VIS(K,J) = TEMP
 110                 CONTINUE
 120              CONTINUE
 130           CONTINUE
 140        CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE YCUCOR (RPOS, QUAD, CORN, IERR)
C-----------------------------------------------------------------------
C! correct cursor position for scroll; return image coordinates, header
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YCUCOR takes a cursor position (corrected for zoom, but not scroll)
C   corrects it for scroll, determines the quadrant of the TV, and gets
C   the corresponding image header in common /MAPHDR/ and returns the
C   image coordinates.
C   NOTE WELL: RPOS ON INPUT MUST BE CORRECTED FOR ZOOM AND NOT SCROLL.
C   To get this from a raw TV position call YCURSE with OPCODE 'FXIT'
C   (or, of course, 'READ') and quadrant set to -1.    *************
C   Inputs:
C      RPOS    R(2)    X,Y screen pos before  zoom & scroll
C   Output:
C      QUAD    I       TV quadrant to use for scrolls
C                      Out: if in=-1, no scroll, else find quadrant
C                           (needs real TV pos)
C      CORN    R(7)    Image coordinates (pixels)
C      IERR    I       error code of Z...XF : 0 - ok
C                                             2 - input error
C   Version for no TV at all - stubbed.
C-----------------------------------------------------------------------
      REAL       RPOS(2), CORN(7)
      INTEGER    IERR, QUAD
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'YCUCOR: THERE IS NO TV CONFIGURED'
      CALL MSGWRT (8)
C
 999  RETURN
      END

      SUBROUTINE ZR64RL (NVAL, NP, INB, OUTB)
C-----------------------------------------------------------------------
C! convert 64-bit IEEE floating-point buffer to local "DOUBLE PRECISION"
C# Binary
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Converts from 64 bit IEEE floating format data to local double
C   precision (or corresponding 64 bit precision).
C
C   The IEEE format is:
C
C                1         2         3         4         5         6
C      0123456789012345678901234567890123456789012345678901234567890123
C      seeeeeeeeeeemmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
C
C   where sign = -1 _*_* s, exponent = eee..., mantissa = 1.mmmmm...
C
C   The value is given by:
C
C      value = sign _* 2 _*_*(exp-1023) _* mantissa
C
C   Note: these values have a "hidden" bit and must always be normalized
C   The IEEE nan (not a number) values are used to indicate an invalid
C   number; a value with all bits set is recognized as a "nan".
C
C   The AIPS internal format for an invalid number is the value which
C   has the same bit pattern as 'INDE    '.
C
C   The IEEE special values (-0., +/- Infty) are not recognized.
C
C   A multiplication by a factor of 4.0 converts between VAX G and IEEE
C   64 bit formats.
C
C   Inputs:
C      NVAL   I      Number of values to convert
C      NP     I      First value in INB to convert
C      INB    D(*)   64-bit IEEE format values
C   OUTPUT:
C      OUTB   D(*)   Local format values ("nan" values are replaced
C                    with AIPS' D.P. blank = 'INDE    ')
C   Generic version  - does IEEE and VAX G formats for 32-bit machines,
C   is stubbed with STOP for all others.
C-----------------------------------------------------------------------
      INTEGER   NVAL, NP
      DOUBLE PRECISION INB(*), OUTB(*)
C
      INTEGER   LOOP, I4NAN, J, I8TEST(2), I, IP, ZAND, I4NANV, L4NAN
      DOUBLE PRECISION R8TEST
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (I8TEST, R8TEST)
C                                       = 7FF00000
      DATA I4NAN /2146435072/
C                                       VMS version
      DATA I4NANV /32752/
C-----------------------------------------------------------------------
      IF (NVAL.LE.0) GO TO 999
C                                       Does BYTFLP need a check?
C                                       no place to test at the moment
      IP = 1
C                                       only works for 32-bit words
      IF ((NBITWD.NE.32) .OR. (NWDPDP.NE.2)) THEN
         WRITE (MSGTXT,1000) NBITWD, NWDPDP
         CALL MSGWRT (10)
         STOP
      ELSE
C                                       select the integer equiv exp
         IF (BYTFLP.GT.1) THEN
            L4NAN = I4NANV
         ELSE
            L4NAN = I4NAN
            END IF
C                                       IEEE floating-point - copy
         IF (DPFRMT.EQ.1) THEN
            LOOP = 4 * NVAL
            CALL ZBYTFL (LOOP, INB(NP), INB(NP))
            DO 10 LOOP = 1,NVAL
               J = LOOP + NP - 1
               R8TEST = INB(J)
               I = ZAND (L4NAN, I8TEST(IP))
               IF (I.EQ.0) THEN
                  OUTB(LOOP) = 0.0D0
               ELSE IF (I.EQ.L4NAN) THEN
                  OUTB(LOOP) = DBLANK
               ELSE
                  OUTB(LOOP) = INB(J)
                  END IF
 10            CONTINUE
C                                       VAX G - multiply by 4
         ELSE IF (DPFRMT.EQ.3) THEN
            LOOP = 4 * NVAL
            CALL ZBYTFL (LOOP, INB(NP), INB(NP))
            DO 20 LOOP = 1,NVAL
               J = LOOP + NP - 1
               R8TEST = INB(J)
               I = ZAND (L4NAN, I8TEST(IP))
               IF (I.EQ.0) THEN
                  OUTB(LOOP) = 0.0D0
               ELSE IF (I.EQ.L4NAN) THEN
                  OUTB(LOOP) = DBLANK
               ELSE
                  OUTB(LOOP) = INB(J) * 4.0D0
                  END IF
 20            CONTINUE
C                                       IBM - yeah, right
         ELSE IF (DPFRMT.EQ.4) THEN
            CALL D2IBM(NVAL,INB(NP),OUTB(1))
C                                       VAX F not easy
         ELSE
            WRITE (MSGTXT,1020) DPFRMT
            CALL MSGWRT (10)
            STOP
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZR64RL: REQUIRES LOCAL DEVELOPMENT FOR NBITWD =',I3,
     *   ' NWDPDP =',I2)
 1020 FORMAT ('ZR64RL: REQUIRES LOCAL DEVELOPMENT FOR DPFRMT =',I7)
      END

      SUBROUTINE YIFM (OP, START, COUNT, PACK, VRTRTC, IFM, IERR)
C-----------------------------------------------------------------------
C! read/write TV Input look-up-table
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YIFM reads/writes a section of TV input function memory.  This
C   look up table takes 13 bits in and gives 8 bits out.
C   Inputs:
C      OP      C*4    'READ' from TV or 'WRIT' to TV
C      START   I      start address of IFM (1 - 8192)
C      COUNT   I      # elements of IFM to transfer (1-8192)
C      PACK    L      T => 2 values/word, F => 1 value/word
C      VRTRTC  L      T => do it only on vertical retrace
C   In/Out:
C      IFM     I(*)   function values (0-255)
C   Output:
C      IERR    I      error code of Z...XF: 0 - ok
C                                           2 - input error
C   IIS Model 70 version
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   START, COUNT, IFM(*), IERR
      LOGICAL   PACK, VRTRTC
C
      INTEGER   UNIT, HEADER(8), NB, BITS(16), MSB, LSB
      LOGICAL   COMAND
      DATA UNIT, COMAND / 4, .FALSE./
C-----------------------------------------------------------------------
C                                        check size error
      IERR = 2
      IF ((START.LE.0) .OR. (COUNT.LE.0)) GO TO 999
      IF (START+COUNT-1.GT.8192) GO TO 999
C                                        header
      MSB = (START-1) / 512
      LSB = START - 1 - 512*MSB
      CALL YMKHDR (OP, UNIT, COMAND, COUNT, LSB, MSB, 0, 0, VRTRTC,
     *   HEADER)
      NB = 2 * COUNT
      IF (PACK) THEN
         CALL ZGTBIT (16, HEADER(1), BITS)
         BITS(15) = 1
         CALL ZPTBIT (16, HEADER(1), BITS)
         NB = ((COUNT+1)/2) * 2
         END IF
C                                        IO
      CALL ZM70XF (OP, NB, HEADER, IFM, IERR)
C
 999  RETURN
      END

LOCAL INCLUDE 'IRING.INC'
      INTEGER   IBLK(256), ICN, JVOL, LUN2, FIND, SCRTCH(256), IVER,
     *   GRCHN, TVCHN, TVCORN(4), ISYM
      LOGICAL   AXES, DOTV, CONECT, EBARS
      HOLLERITH XNMIN(3), XCLIN(2), KEYSTR(4), XOTEXT(12), XUNTYP(1)
      REAL      USER, SQIN, DKIN, BLC(7), TRC(7), APM(10), CPM(10),
     *   SCX, OFX, SCY, OFY, XBLC(2), XTRC(2), XSYM, FACTOR, XDOTV,
     *   XGRCH
      CHARACTER OUTEXT*48, FUNCT*2
      COMMON /INPARM/ USER, XNMIN, XCLIN, SQIN, DKIN, BLC, TRC, APM,
     *   CPM, KEYSTR, XSYM, FACTOR, XUNTYP, XDOTV, XGRCH, XOTEXT
      COMMON /PLOT/ SCX, OFX, SCY, OFY, XBLC, XTRC, AXES, IBLK, ICN,
     *   JVOL, LUN2, FIND, SCRTCH, IVER, GRCHN, TVCHN, TVCORN, DOTV,
     *   CONECT, EBARS, ISYM
      COMMON /PLOTCH/ OUTEXT, FUNCT
LOCAL END
      PROGRAM IRING
C-----------------------------------------------------------------------
C! Integrates an image in projected concentric rings.
C# Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2005, 2007-2009, 2013-2015, 2017, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   IRING integrates map in projected concentric rings.
C   adverb    variable  description
C    USERID     USER     User ID owner. ignored
C    INNAME     NMIN     Image name(name).  blank=>any
C    INCLASS    CLIN     Image name(class). blank=>any
C    INSEQ      SQIN     Image name(seq).  0=>any
C    INDISK     DKIN     Disk drive # of image.  0=>any
C    BLC        BLC      Bottom Left hand pixel of subimage
C    TRC        TRC      Top Right hand pixel of subimage
C    APARM      APM      Orientation parameters disk. (1),(2): x and
C                        y pixels of center, (3) pos. angle major
C                        axis, (4) inclination.
C                        (5) aximuthal extent of wedge, 0=>360 degrees
C                        (6) central azimuthal angle of wedge
C    CPARM      CPM      (1) radius inner ring, (2) radius outer ring,
C                        (3) width of one ring, (4) 1=>treat blanks as
C                        zero, (5) 1=>plot results. (6) 1=>1 pixel~ 1".
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   MAXRNG
      PARAMETER (MAXRNG=10240)
C
      CHARACTER PGMNAM*6, NMIN*12, CLIN*6, ARCS*8, CHARS(4)*8,
     *   XUN*8, YUN*12, SRCH*8, YUO*12, MTYPE*2, COORD*6, LINE*132,
     *   KEYU*16
      INTEGER   IPARMS, NRING, SCR(256), NPARMS, IRET, IER, ISEQ, IVOL,
     *   IUSR, L16, WIN(4), NBUF, NXW, NYW, I, J, NP(MAXRNG), IOUT, NAX,
     *   PAX(7), DPT(5), BOF, K, NNZ(MAXRNG), TLUN, TIND, JT, JTRIM,
     *   FSUM, FMEAN, FERR
      REAL    RBUF(MABFSS), ARR(MABFSS), BLNK, R, RR, RX, RY, CSP, SNP,
     *   CSH, CSI, LLMIN, LMOU, RMIN, DX, DY, AMX, AMN, ASX, SOM, BMA,
     *   BMI, PPB, SNI, TMP1, TMP2, RCEN(2), RRT, DPM(10), ASN, XRNG(2),
     *   AZ1, AZ2, AZ, DZ, AEN, AEX, PMEAN(MAXRNG), PDIST(MAXRNG),
     *   PERR(MAXRNG), PSUM(MAXRNG), PERRS(MAXRNG), PPBC, PARMS(62),
     *   XPRIME, YPRIME, RRIME, X1, X2
      DOUBLE PRECISION MEAN(MAXRNG), MEANSQ(MAXRNG), VAL, ERR(MAXRNG),
     *   ERRS(MAXRNG), SUM(MAXRNG), DIST(MAXRNG), SIGMA
      LOGICAL   T, F, RQUICK, REPL, PIXEL
      INCLUDE 'IRING.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (PARMS, USER)
      DATA PGMNAM,  NPARMS, TLUN /'IRING ' ,63, 3/
      DATA T, F /.TRUE.,.FALSE./
      DATA L16 /16/
      DATA ARCS /'Arcsec  '/
      DATA CHARS /'/BEAM ', '/Beam ', '/B ', '   ? '/
C-----------------------------------------------------------------------
      CALL ZDCHIN (T)
      CALL VHDRIN
      BLNK = FBLANK
      CALL GTPARM (PGMNAM, NPARMS, RQUICK, USER, SCR, IRET)
      IF (IRET.NE.0) THEN
         IF (IRET.EQ.1) GO TO 999
         IRET = 16
         WRITE (MSGTXT,1000)
         CALL MSGWRT (8)
         END IF
      IF (RQUICK) CALL RELPOP (IRET, SCR, IER)
      IF (IRET.NE.0) GO TO 990
      IRET  = 8
C                                         interpret input
      ISEQ = SQIN + 0.01
      IVOL = DKIN + 0.01
      USER = NLUSER
      IUSR = NLUSER
      CALL H2CHR (12, 1, XNMIN, NMIN)
      CALL H2CHR (6, 1, XCLIN, CLIN)
      CONECT = FACTOR.LE.0.0
      IF (FACTOR.EQ.0.0) FACTOR = 1.0
      FACTOR = ABS (FACTOR)
      EBARS = XSYM.GT.0.0
      ISYM = ABS (XSYM) + 0.01
      ISYM = MAX (1, MIN (ISYM, 24))
      CALL H2CHR (48, 1, XOTEXT, OUTEXT)
      CALL H2CHR (2, 1, XUNTYP, FUNCT)
C                                       if inclination = 90 degrees,
C                                       may ge 1.0/0.0 later, and this
C                                       projection is
C                                       meaningless anyway
      IF (APM(4).EQ.90.0) THEN
         WRITE (MSGTXT,1010)
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       bypass arcsec calculation
      PIXEL = (CPM(6).GT.0)
C                                         open input image
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
      MTYPE = 'MA'
      CALL MAPOPN ('READ', IVOL, NMIN, CLIN, ISEQ, MTYPE, IUSR, L16,
     *   FIND, ICN, CATBLK, SCR, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1030) IER
         CALL MSGWRT (8)
         GO TO 980
         END IF
C                                         # axes, # points/axis
      USER = IUSR
      DKIN = IVOL
      SQIN = ISEQ
      NAX = CATBLK(KIDIM)
      DO 35 I = 1,NAX
         PAX(I) = CATBLK(KINAX+I-1)
 35      CONTINUE
C                                         check, interpret constants
      CALL WINDOW (NAX, PAX, BLC, TRC, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1040) IER
         CALL MSGWRT (8)
         GO TO 980
         END IF
      DO 45 I = 1,5
         DPT(I) = BLC(I+2) + 0.01
 45      CONTINUE
      LOCNUM = 1
      CALL SETLOC (DPT, F)
C                                         position axes ?
      IF (PIXEL) THEN
C                           Non-astronomical images. "1 pixel = 1 arcsec"
         DX = 1.
         DY = 1.
         YUO = '        '
         CALL H2CHR (8, 1, CATH(KHBUN), YUN)
         COORD = 'pixels'
         XUN = COORD
         PPB = 1.0
         PPBC = 1.0
         RRT = 0.
      ELSE
         IF (AXTYP(LOCNUM).NE.1) THEN
            WRITE (MSGTXT,1050)
            CALL MSGWRT (5)
            GO TO 980
            END IF
         XUN = ARCS
         CALL H2CHR (8, 1, CATH(KHBUN), YUN)
         BMA = CATR(KRBMJ)
         BMI = CATR(KRBMN)
         DX = CATR(KRCIC)
         DY = CATR(KRCIC+1)
         RRT = CATR(KRCRT+1)
         COORD = 'arcsec'
C                                        PPB means points per beam
         IF ((BMA.EQ.0.0).OR.(BMI.EQ.0.0)) THEN
            PPB = 1.0
            YUO = CHARS(4)
            WRITE (MSGTXT,1070)
            CALL MSGWRT (5)
            PPBC = 1.0
         ELSE
            PPB = 1.133 * BMA / DX * BMI / DY
            PPB = ABS (PPB)
            PPBC = CPM(3) / 3600.0
            IF (PPBC.GT.BMI) THEN
               PPBC = PPB
            ELSE
               PPBC = PPB * PPBC / BMI
               END IF
            WRITE (MSGTXT,1071) PPB, PPBC
            IF (OUTEXT.NE.'NONE') CALL MSGWRT (5)
            SRCH = CHARS(1)
            CALL CHDELE (YUN, 8, 1, SRCH, 5, YUO, REPL)
            IF (.NOT.REPL) THEN
               SRCH = CHARS(2)
               CALL CHDELE (YUN, 8, 1, SRCH, 5, YUO, REPL)
               IF (.NOT.REPL) THEN
                  SRCH = CHARS(3)
                  CALL CHDELE (YUN, 8, 1, SRCH, 2, YUO, REPL)
                  IF (.NOT.REPL) THEN
                     YUO = YUN
                     WRITE (MSGTXT,1060)
                     CALL MSGWRT (5)
                     MSGTXT = '**** or some other unit not / beam ****'
                     CALL MSGWRT (5)
                     END IF
                  END IF
               END IF
            END IF
         DX = DX * 3600.0
         DY = DY * 3600.0
         END IF
      WIN(1) = BLC(1) + 0.01
      WIN(2) = BLC(2) + 0.01
      WIN(3) = TRC(1) + 0.01
      WIN(4) = TRC(2) + 0.01
      NXW = WIN(3) - WIN(1) + 1
      NYW = WIN(4) - WIN(2) + 1
      IF (NXW.GT.MABFSS) THEN
         WRITE(MSGTXT,1075) NXW
         CALL MSGWRT(2)
         GO TO 980
         END IF
      NBUF = 2*MABFSS
      IF (CPM(2).EQ.0.0) CPM(2)  = MIN (ABS(DX)*NXW/2.0,
     *   ABS(DY)*NYW/2.0)
      IF (CPM(3).EQ.0.0) CPM(3)  = (CPM(2) - CPM(1)) / 10.0
      NRING = (CPM(2) - CPM(1)) / CPM(3)
      IF (NRING.GT.MAXRNG) THEN
         WRITE (MSGTXT,1080) NRING, MAXRNG
         CALL MSGWRT (7)
         GO TO 980
         END IF
      DO 90 K = 1,NRING
         NP(K) = 0
         NNZ(K) = 0
         MEAN(K) = 0.0D0
         MEANSQ(K) = 0.0D0
         DIST(K) = 0.0D0
         ERR(K) = 0.0D0
         ERRS(K) = 0.0D0
 90      CONTINUE
      CALL RCOPY (10, CPM, DPM)
      RCEN(1) = CATR(KRCRP) + APM(1) + 1.0 - BLC(1)
      RCEN(2) = CATR(KRCRP+1) + APM(2) + 1.0 - BLC(2)
C                                          determine proper offset
      CALL COMOFF (NAX, PAX, DPT, BOF, IER)
      BOF = BOF + 1
C                                          initialize reading
      CALL MINIT ('READ', L16, FIND, PAX(1), PAX(2), WIN, RBUF, NBUF,
     *   BOF, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1090) IER
         CALL MSGWRT (8)
         GO TO 980
         END IF
C                                       convert width of angle into
C                                       halfwidth
      IF (APM(5).LE.0.0) THEN
         APM(5) = 360.0
         APM(6) = 0.0
         END IF
      AZ1 = APM(6) - APM(5) / 2.0
      AZ2 = APM(6) + APM(5) / 2.0
      CSP = COS ((APM(3) + RRT) * DG2RAD)
      SNP = SIN ((APM(3) + RRT) * DG2RAD)
      SNI = SIN ((APM(4) + RRT) * DG2RAD)
      CSI = COS ((APM(4) + RRT) * DG2RAD)
      RMIN = 1.0E-3 * MIN (ABS(DX), ABS(DY))
C                                        read
      VAL = 0.0D0
      DO 200 J = 1,NYW
         CALL LINIO ('READ', L16, FIND, RBUF, NXW, ARR, 1, BLNK, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1100) IER
            CALL MSGWRT (8)
            GO TO 980
            END IF
         DO 180 I = 1,NXW
            IF (ARR(I).EQ.BLNK) THEN
               ARR(I) = 0.0
               IF (CPM(4).LE.0.0) GO TO 180
               END IF
C                                       RX, RY - position of the
C                                       given pixel relative to center
C                                       of the field
            RX = (I - RCEN(1)) * DX
            RY = (J - RCEN(2)) * DY
            AZ = ATAN2 (-RX, RY) / DG2RAD
            R = SQRT (RY ** 2 + RX ** 2)
            IF (((AZ.GE.AZ1) .AND. (AZ.LE.AZ2)) .OR. ((AZ+360.GE.AZ1)
     *         .AND. (AZ+360.LE.AZ2)) .OR. ((AZ-360.GE.AZ1) .AND.
     *         (AZ-360.LE.AZ2))) THEN
               RR = 0
               IF (R.GT.RMIN) THEN
C                                       not right somehow
                  CSH =  (CSP * RX / R + SNP * RY / R)
                  RR = R * SQRT (1.0 - CSH * CSH * SNI * SNI) / CSI
C                                       more straightforward
                  XPRIME = RX * SNP + RY * CSP
                  YPRIME = RY * SNP - RX * CSP
                  RRIME = SQRT (XPRIME*XPRIME + (YPRIME/CSI)**2)
                  RR = RRIME
                  END IF
               K = (RR - CPM(1)) / CPM(3) + 1.0
               IF ((K.GE.1).AND.(K.LE.NRING)) THEN
                  NP(K) = NP(K) + 1
                  IF (ARR(I).NE.0.0) NNZ(K) = NNZ(K) + 1
                  VAL = ARR(I)
                  MEAN(K) = MEAN(K) + VAL
                  MEANSQ(K) = MEANSQ(K) + VAL * VAL
                  DIST(K) = DIST(K) + RR
                  END IF
               END IF
 180        CONTINUE
 200     CONTINUE
C                                        close map
      CALL MAPCLS ('READ', IVOL, ICN, L16, FIND, CATBLK, T, SCR, IER)
C                                        output
      IF (OUTEXT.NE.'NONE') THEN
         WRITE (MSGTXT,1120)
         CALL MSGWRT (5)
         WRITE (MSGTXT,1130) COORD, YUN, YUN, YUO
         CALL MSGWRT (5)
         END IF
      AMN =  1.0E12
      AMX = -1.0E12
      ASN =  1.0E12
      ASX = -1.0E12
      AEX = -1.0E12
      AEN =  1.0E12
      SOM =  0.0
      IF ((OUTEXT.NE.' ') .AND. (OUTEXT.NE.'NONE')) THEN
         CALL ZTXOPN ('WRIT', TLUN, TIND, OUTEXT, .TRUE., IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1200) IER, 'OPEN'
            CALL MSGWRT (7)
            OUTEXT = ' '
            IER = 0
            END IF
         END IF
C                                       header
      IF ((OUTEXT.NE.' ') .AND. (OUTEXT.NE.'NONE')) THEN
         IF (CPM(7).GT.0.0) THEN
            CALL H2CHR (16, 1, KEYSTR, KEYU)
         ELSE
            KEYU = 'radius (asec)'
            END IF
         JT = JTRIM (KEYU)
         IF (CPM(5).GT.1.5) THEN
            WRITE (LINE,1201) KEYU(:JT), 'sum', YUN
         ELSE
            WRITE (LINE,1201) KEYU(:JT), 'mean', YUN
            END IF
         JT = JTRIM (LINE)
         CALL ZTXIO ('WRIT', TLUN, TIND, LINE(:JT), IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1200) IER, 'WRIT'
            CALL MSGWRT (7)
            CALL ZTXCLS (TLUN, TIND, IER)
            IER = 0
            OUTEXT = ' '
            END IF
         END IF
      DO 220 K = 1,NRING
         LLMIN = CPM(1) + (K-1) * CPM(3)
         LMOU = LLMIN + CPM(3)
         SUM(K) = SOM + MEAN(K) / PPB
         SOM = SUM(K)
         IF (NP(K).LT.1) THEN
            MEAN(K) = 0.0D0
            MEANSQ(K) = 0.0D0
            DIST(K) = 0.0D0
            ERR(K) = 0.0D0
            ERRS(K) = 0.0D0
         ELSE
            MEAN(K) = MEAN(K) / NP(K)
            MEANSQ(K) = MEANSQ(K) / NP(K)
            DIST(K) = DIST(K) / NP(K)
            IF (CPM(7).GT.0.0) DIST(K) = DIST(K) * CPM(7)
            SIGMA = SQRT (MAX (0.0D0, MEANSQ(K) - MEAN(K) * MEAN(K)))
            IF (NNZ(K).GT.1) SIGMA = SIGMA / SQRT ((NNZ(K)-1.0) / PPBC)
            ERR(K) = SIGMA
            ERRS(K) = SIGMA * SIGMA
            IF (K.GT.1) ERRS(K) = ERRS(K) + ERRS(K-1)**2
            ERRS(K) = SQRT (ERRS(K))
            END IF
         IF (EBARS) THEN
            IF (MEAN(K)+ERR(K).GT.AMX) AMX = MEAN(K) + ERR(K)
            IF (MEAN(K)-ERR(K).LT.AMN) AMN = MEAN(K) - ERR(K)
            IF (SUM(K)+ERRS(K).GT.ASX) ASX = SUM(K) + ERRS(K)
            IF (SUM(K)-ERRS(K).LT.ASN) ASN = SUM(K) - ERRS(K)
         ELSE
            IF (MEAN(K).GT.AMX) AMX = MEAN(K)
            IF (MEAN(K).LT.AMN) AMN = MEAN(K)
            IF (SUM(K).GT.ASX) ASX = SUM(K)
            IF (SUM(K).LT.ASN) ASN = SUM(K)
            END IF
         IF (ERR(K).GT.AEX) AEX = ERR(K)
         IF (ERR(K).LT.AEN) AEN = ERR(K)
         PMEAN(K) = MEAN(K)
         PERR(K) = ERR(K)
         PSUM(K) = SUM(K)
         PERRS(K) = ERRS(K)
         PDIST(K) = DIST(K)
 220     CONTINUE
C                                       decide on formats
      FMEAN = 1
      IF (AMX.GT.99999.) FMEAN = 2
      IF (AMX.GT.9999999.) FMEAN = 3
      IF (AMX.LT.0.1) FMEAN = 3
      FERR = 1
      IF (AEX.GT.99999.) FERR = 2
      IF (AEX.GT.9999999.) FERR = 3
      IF (AEX.LT.0.1) FERR = 3
      FSUM = 1
      IF (ASX.GT.99999.) FSUM = 2
      IF (ASX.GT.9999999.) FSUM = 3
      IF (ASX.LT.0.1) FSUM = 3
      IF ((OUTEXT.NE.' ') .AND. (OUTEXT.NE.'NONE')) THEN
         DO 240 K = 1,NRING
            IF (CPM(5).GT.1.5) THEN
               DY = SUM(K)
               DZ = ERRS(K)
            ELSE
               DY = MEAN(K)
               DZ = ERR(K)
               END IF
            IF (FMEAN.EQ.1) THEN
               WRITE (LINE,1210) DIST(K), DY, DZ
            ELSE IF (FMEAN.EQ.2) THEN
               WRITE (LINE,1211) DIST(K), DY, DZ
            ELSE
               WRITE (LINE,1212) DIST(K), DY, DZ
               END IF
            JT = JTRIM (LINE)
            CALL ZTXIO ('WRIT', TLUN, TIND, LINE(:JT), IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,1200) IER, 'WRIT'
               CALL MSGWRT (7)
               CALL ZTXCLS (TLUN, TIND, IER)
               IER = 0
               OUTEXT = ' '
               END IF
 240        CONTINUE
         CALL ZTXCLS (TLUN, TIND, IER)
         END IF
C                                       fixed scale
      IF (CPM(8).GT.0.0) THEN
         AMN = CPM(9)
         AMX = CPM(10)
         ASN = CPM(9)
         ASX = CPM(10)
         END IF
C                                       now print
      IF (OUTEXT.NE.'NONE') THEN
         DO 250 K = 1,NRING
            LLMIN = CPM(1) + (K-1) * CPM(3)
            LMOU = LLMIN + CPM(3)
            WRITE (MSGTXT,1140) K, LLMIN, LMOU, NNZ(K)
            IF (FMEAN.EQ.1) THEN
               WRITE (MSGTXT(30:),1141) MEAN(K)
            ELSE IF (FMEAN.EQ.2) THEN
               WRITE (MSGTXT(30:),1142) MEAN(K)
            ELSE
               WRITE (MSGTXT(30:),1143) MEAN(K)
               END IF
            IF (FERR.EQ.1) THEN
               WRITE (MSGTXT(42:),1141) ERR(K)
            ELSE IF (FERR.EQ.2) THEN
               WRITE (MSGTXT(42:),1142) ERR(K)
            ELSE
               WRITE (MSGTXT(42:),1143) ERR(K)
               END IF
            IF (FSUM.EQ.1) THEN
               WRITE (MSGTXT(54:),1141) SUM(K)
            ELSE IF (FSUM.EQ.2) THEN
               WRITE (MSGTXT(54:),1142) SUM(K)
            ELSE
               WRITE (MSGTXT(54:),1143) SUM(K)
               END IF
            CALL MSGWRT (5)
 250        CONTINUE
         END IF
      IER = 0
C                                       logaritmic plot?
      IF ((FUNCT.EQ.'LG') .AND. (CPM(5).LT.1.5)) THEN
         LINE = 'LOG ' // YUN(:8)
         YUN = LINE(:12)
         IF (CPM(8).LE.0.0) THEN
            IF (AMN.GT.0.0) THEN
               AMN = LOG10 (AMN)
            ELSE
               AMN = -2.0
               END IF
            AMX = LOG10 (AMX)
            END IF
         DO 260 K = 1,NRING
            X1 = PMEAN(K) + PERR(K)
            IF (X1.GT.0.0) THEN
               X1 = LOG10 (X1)
            ELSE
               X1 = AMN
               END IF
            X2 = PMEAN(K) - PERR(K)
            IF (X2.GT.0.0) THEN
               X2 = LOG10 (X2)
            ELSE
               X2 = AMN
               END IF
            PERR(K) = (X2 - X1) / 2.0
            IF (PMEAN(K).GT.0.0) THEN
               PMEAN(K) = LOG10 (PMEAN(K))
            ELSE
               PMEAN(K) = AMN
               END IF
 260        CONTINUE
      ELSE
         AMN = MIN (AMN, 0.0)
         ASN = MIN (ASN, 0.0)
         END IF
C                                         plot results
      IF (CPM(5).GT.0.0) THEN
         IPARMS = NPARMS
         CALL PLINIT (IVOL, NMIN, CLIN, ISEQ, IUSR, L16, IPARMS,
     *      PARMS, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,2060) IER
            CALL MSGWRT (8)
            GO TO 980
            END IF
         XRNG(1) = CPM(1)
         XRNG(2) = CPM(2)
         IF (CPM(7).GT.0.0) THEN
            CALL H2CHR (8, 1, KEYSTR, XUN)
            XRNG(1) = CPM(1) * CPM(7)
            XRNG(2) = CPM(2) * CPM(7)
            END IF
         IF (CPM(5).LT.1.5) THEN
            TMP1 = XRNG(2) + 0.07 * (XRNG(2) - XRNG(1))
            TMP2 = AMX + 0.07 * (AMX - AMN)
C                                       CHANGE????
            CALL PLAXES (XRNG(1), TMP1, AMN, TMP2, 1.0, XUN, YUN, IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,2070) IER
               CALL MSGWRT (8)
               GO TO 980
               END IF
            CALL PLDATA (NRING, PDIST, PMEAN, PERR, IOUT, IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,2080) IER
               CALL MSGWRT (8)
               GO TO 980
               END IF
         ELSE
            SRCH = CHARS(1)
            CALL CHDELE (YUN, 8, 1, SRCH, 5, YUO, REPL)
            IF (.NOT.REPL) THEN
               SRCH = CHARS(2)
               CALL CHDELE (YUN, 8, 1, SRCH, 5, YUO, REPL)
               IF (.NOT.REPL) THEN
                  SRCH = CHARS(3)
                  CALL CHDELE (YUN, 8, 1, SRCH, 2, YUO, REPL)
                  IF (.NOT.REPL) THEN
                     YUO = YUN
                     WRITE (MSGTXT,1060)
                     CALL MSGWRT (5)
                     MSGTXT = '**** or some other unit not / beam ****'
                     CALL MSGWRT (5)
                     END IF
                  END IF
               END IF
            TMP1 = XRNG(2) + 0.07 * (XRNG(2) - XRNG(1))
            TMP2 = ASX + 0.07 * (ASX - ASN)
            CALL PLAXES (XRNG(1), TMP1, ASN, TMP2, 1.0, XUN, YUO, IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,2070) IER
               CALL MSGWRT (8)
               GO TO 980
               END IF
            CALL PLDATA (NRING, PDIST, PSUM, PERRS, IOUT, IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,2080) IER
               CALL MSGWRT (8)
               GO TO 980
               END IF
            END IF
         CALL PLFINI (IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,2100) IER
            CALL MSGWRT (8)
            GO TO 980
            END IF
         END IF
      IRET = 0
      GO TO 990
C
 980  CALL MAPCLS ('READ', IVOL, ICN, L16, FIND, CATBLK, F, SCR, IER)
C
 990  CALL DIETSK (IRET, RQUICK, SCR)
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('GET PARAMETER ERROR ',I5)
 1010 FORMAT ('THE GALAXY IS EDGE ON, THIS IS NOT A MEANINGFUL ',
     *        'PROJECTION')
 1030 FORMAT ('MAPOPN ERROR: IER = ',I2)
 1040 FORMAT ('WINDOW ERROR: IER = ',I2)
 1050 FORMAT ('X- AND Y-AXIS ARE NOT A POSITION PAIR')
 1060 FORMAT ('**** Y-axis of plot in (original map units) * beam ',
     *   '****')
 1070 FORMAT ('**** No beam in header, last column contains sum ****')
 1071 FORMAT ('Beam area',F7.2,' pixels, correlation correction',F7.2,
     *   ' pixels')
 1075 FORMAT ('Error: Dimension in X: ', I5,'; exceeds compiled max')
 1080 FORMAT ('Error:',I6,' rings required; maximum is',I6)
 1090 FORMAT ('MINIT ERROR : IER = ',I2)
 1100 FORMAT ('LINIO ERROR : IER  = ',I2)
 1120 FORMAT ('Ring  Inner  Outer  Points    Average     Sigma    ',
     *   ' Cumul. Flux')
 1130 FORMAT ('         (',A6,')',4X,'Not 0',4X,'(',A8,')',2X,'(',A8,
     *   ') (',A8,')')
 1140 FORMAT (I3,1X,2(1X,F6.1),1X,I8)
 1141 FORMAT (F11.4)
 1142 FORMAT (F11.1)
 1143 FORMAT (1PE11.4)
 1200 FORMAT ('ERROR',I4,2X,A,'ING THE OUTTEXT FILE')
 1201 FORMAT (A16,A6,'(',A,')',5X,'uncertainty')
 1210 FORMAT (3F16.7)
 1211 FORMAT (3F16.3)
 1212 FORMAT (F16.3,2(1PE16.4))
 2060 FORMAT ('PLINIT: IER = ',I2)
 2070 FORMAT ('PLAXES: IER = ',I2)
 2080 FORMAT ('PLDATA: IER = ',I2)
 2100 FORMAT ('PLFINI: IER = ',I2)
      END
      SUBROUTINE CHDELE (STRI, NI, NB, STRD, ND, STRO, REPL)
C-----------------------------------------------------------------------
C   subroutine to delete a character string of ND characters
C   from another string of NI characters.
C     STRI    C(*)     input    String to be changed
C     NI      I        input    # characters in STRI
C     NB      I        input    begin search at char. NB of STRI
C     STRD    C(*)     input    String to be deleted from STRI
C     ND      I        input    # characters in STRD
C     STRO    C(*)    output    Changed string, if REPL true
C     REPL    L       output    If true, a replacement was done.
C-----------------------------------------------------------------------
      INTEGER   NI, ND, NB, IPNT
      CHARACTER STRI*(*), STRD*(*), STRO*(*)
      LOGICAL   REPL
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      REPL = .FALSE.
      IPNT = INDEX (STRI(NB:NI), STRD(1:ND)) + NB - 1
      IF (IPNT.LE.0) GO TO 999
      REPL = .TRUE.
C                                       Delete
      IF (IPNT.GT.1) THEN
         STRO = STRI(1:IPNT-1)
      ELSE
         STRO = '    '
         END IF
      IF ((IPNT+ND).LE.NI) STRO(IPNT:) = STRI(IPNT+ND:NI)
C
 999  RETURN
      END
      SUBROUTINE PLINIT (IVOL, NAM, CLAS, ISEQ, USID, LUN, IP,
     *   RPARM, IERR)
C-----------------------------------------------------------------------
C   opens map, creates plot extension file
C     IVOL   I      I  disk volume #
C     NAM    C*12   I  image name
C     CLAS   C*6    I  image class
C     ISEQ   I      I  image sequence #
C     USID   I      I  user #
C     LUN    I      I  map logical unit #
C     IP     I      I  # parameters
C     RPARM  R (IP) I  parameter list
C     IERR   I      O  output code. two digit, first digit indi-
C                      cates subroutine: 1: MAPOPN, 2: MADDEX,
C                      3: ZPHFIL, 4: GINIT, second digit indi-
C                      cates error code of that subroutine.
C-----------------------------------------------------------------------
      CHARACTER PHNAME*48, NAM*12, CLAS*6, MTYPE*2, OP*4
      INTEGER   IP, IVOL, ISEQ, USID, LUN, NP, IERR, BLOK(256), GLUN,
     *   GFIND, JERR
      REAL      RPARM(*)
      LOGICAL   T, F
      INCLUDE 'IRING.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T, F /.TRUE., .FALSE./
C-----------------------------------------------------------------------
C                                        open map
      IERR = 0
      AXES = .FALSE.
      JVOL = IVOL
      LUN2 = LUN
      MTYPE = 'MA'
      OP = 'HDWR'
      IF (DOTV) OP = 'READ'
      CALL MAPOPN (OP, IVOL, NAM, CLAS, ISEQ, MTYPE, USID, LUN,
     *    FIND, ICN, CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         IERR = IERR + 10
         GO TO 990
         END IF
C                                        add plot file to header
      IVER = 0
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', IVOL, ICN, CATBLK, BLOK, T, 'READ', IVER,
     *      IERR)
         IF (IERR.NE.0) THEN
            IERR = IERR + 20
            GO TO 990
            END IF
         END IF
C                                        make physical filename
      CALL ZPHFIL ('PL', IVOL, ICN, IVER, PHNAME, IERR)
      IF (IERR.NE.0) THEN
         IERR = IERR + 30
         GO TO 980
         END IF
C                                        open plot file
      NP = IP
      CALL GINIT (IVOL, ICN, PHNAME, 0, 33, NP, RPARM, DOTV, TVCHN,
     *   GRCHN, TVCORN, CATBLK, IBLK, GLUN, GFIND, IERR)
      IF (IERR.EQ.0) GO TO 999
         IERR = IERR + 40
C
 980  CALL MAPCLS ('READ', JVOL, ICN, LUN2, FIND, CATBLK, F, SCRTCH,
     *   JERR)
      GO TO 999
C
 990  CALL MAPCLS ('WRIT', JVOL, ICN, LUN2, FIND, CATBLK, F, SCRTCH,
     *   JERR)
C
 999  RETURN
      END
      SUBROUTINE PLFINI (IERR)
C-----------------------------------------------------------------------
C     IERR   I      O  output code. two digit, first digit indi-
C                      cates subroutine: 1: GFINIS, 2: MAPCLS,
C                      second digit indicates error code of
C                      that subroutine.
C-----------------------------------------------------------------------
      INTEGER   IERR, JERR
      LOGICAL   F
      INCLUDE 'IRING.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                        close plot file
      CALL GFINIS (IBLK, IERR)
      IF (IERR.NE.0) IERR = IERR + 10
      IF (.NOT.DOTV) CALL HIPLOT (JVOL, ICN, IVER, SCRTCH, JERR)
C                                        close map file
      CALL MAPCLS ('READ', JVOL, ICN, LUN2, FIND, CATBLK, F, SCRTCH,
     *   IERR)
      IF (IERR.NE.0) IERR = IERR + 20
C
 999  RETURN
      END
      SUBROUTINE PLAXES (XMN, XMX, YMN, YMX, XY, XUNIT, YUNIT, IERR)
C-----------------------------------------------------------------------
C   plots axes and ticks, MUST  be called prior to PLDATA or PLFUNC
C   parameters:
C     XMN    R         I  value of x-variable at llhc
C     XMX    R         I  value of x-variable at urhc
C     YMN    R         I  value of y-variable at llhc
C     YMX    R         I  value of y-variable at urhc
C     XY     R         I  ratio x-axis / y-axis
C     XUNIT  C*8      I  units along x-axis. (char. string)
C     YUNIT  C*8      I  units along y-axis. (char. string)
C     IERR   I        O  error code, IERR=-1 indicates illegal
C                        inputs, IERR<10 indicates errors in
C                        drawing, IERR>10 indicates error in
C                        GINITL, with IERR-10 the error number.
C-----------------------------------------------------------------------
      CHARACTER SPRTXT*80, ATIME*8, ADATE*12, XUNIT*(*), YUNIT*(*)
      INTEGER   IERR, DEPT(5), I, LABEL, JERR, ID(3), IT(3), INCHAR,
     *   IANGL, INP, LTYPE
      REAL   XRANGE, YRANGE, XR, YR, XY, XMX, YMX, XMN, YMN, CHOUT(4)
      LOGICAL   F, PFLG
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'IRING.INC'
C
C        This common contains the necessary relations between pixels
C        and values of the x- and y-variables.  E.g. the relation
C        between x-pixel and x-variable is:
C           PIX  =  SCX * X  +  OFX
C        BLC and TRC are the lower left and upper right corner, res-
C        pectively, fixed at (1,1) and (1024,1024).
C
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                        fill common /LOCATI/
      DO 5 I = 1,5
         DEPT(I) = 1
 5       CONTINUE
      CALL SETLOC (DEPT, F)
      AXFUNC(1,LOCNUM) = 0
      AXFUNC(2,LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 0
C                                        proper scaling labels
      XRANGE = XMX - XMN
      YRANGE = YMX - YMN
      IF ((XRANGE.LE.0.0) .OR. (YRANGE.LE.0.0)) THEN
         IERR = -1
         GO TO 990
         END IF
      XR = XRANGE
      LTYPE = 103
      CALL METSCL (LTYPE, XR, CPREF(1,LOCNUM), PFLG)
      YR = YRANGE
      CALL METSCL (LTYPE, YR, CPREF(2,LOCNUM), PFLG)
C                                        proceed filling /LOCATI/
      XBLC(1) = 1.0
      XBLC(2) = 1.0
      XTRC(1) = 1024.0
      XTRC(2) = 1024.0
      SCX = (XTRC(1) - XBLC(1)) / XRANGE
      SCY = (XTRC(2) - XBLC(2)) / YRANGE
      OFX = XBLC(1) - XMN * SCX
      OFY = XBLC(2) - YMN * SCY
      RPLOC(1,LOCNUM) = 1.0
      RPLOC(2,LOCNUM) = 1.0
      RPVAL(1,LOCNUM) = XMN * XR / XRANGE
      RPVAL(2,LOCNUM) = YMN * YR / YRANGE
      AXINC(1,LOCNUM) = XR / XRANGE / SCX
      AXINC(2,LOCNUM) = YR / YRANGE / SCY
      CTYP(1,LOCNUM) = XUNIT
      CTYP(2,LOCNUM) = YUNIT
C                                        space around axes
      CALL CHNTIC (XBLC, XTRC, INP)
      CHOUT(1) = 4.0 + INP
      CHOUT(2) = 3.333
      CHOUT(3) = 0.5
      CHOUT(4) = 2.0
C                                        initialize line drawing
      CALL GINITL (XBLC, XTRC, XY, CHOUT, DEPT, IBLK, IERR)
      IF (IERR.NE.0) THEN
         IERR = IERR + 10
         GO TO 990
         END IF
      LABEL = 3
C                                        proper labeling
      CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XY, F, IBLK, IERR)
      IF (IERR.NE.0) GO TO 990
C                                        draw rectangle
      CALL GLTYPE (1, IBLK, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL GPOS (XBLC(1), XBLC(2), IBLK, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL GVEC (XTRC(1), XBLC(2), IBLK, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL GVEC (XTRC(1), XTRC(2), IBLK, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL GVEC (XBLC(1), XTRC(2), IBLK, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL GVEC (XBLC(1), XBLC(2), IBLK, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Date/time version
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, ATIME, ADATE)
      WRITE (SPRTXT,1020) IVER, ADATE, ATIME
      CALL REFRMT (SPRTXT, '_', INCHAR)
      YR = 0.5
      XR = 0.
      IANGL = 0
      CALL GPOS (XBLC(1), XTRC(2), IBLK, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL GCHAR (INCHAR, IANGL, XR, YR, SPRTXT, IBLK, IERR)
      IF (IERR.EQ.0) THEN
         AXES = .TRUE.
         GO TO 999
         END IF
C                                        close map in case of error
 990  CALL MAPCLS ('READ', JVOL, ICN, LUN2, FIND, CATBLK, F, SCRTCH,
     *   JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('Plot file version',I4,'__created ',A12,A8)
      END
      SUBROUTINE PLDATA (N, X, Y, DY, IOUT, IERR)
C-----------------------------------------------------------------------
C   plots array of N points.
C   Inputs:
C      N      I      total number of points.
C      X      R(N)   x-values of the N points
C      Y      R(N)   y-values of the N points
C      DY     R(N)   uncertainty in Y
C   Outputs:
C      IOUT   I      number of points outside plot
C      IERR   I      error code. IERR=-1 indicates that
C                            there has not been a legal call to
C                            PLAXES, IERR>0 indicates errors in
C                            drawing routines.
C-----------------------------------------------------------------------
      INTEGER   N, IOUT, IERR
      REAL      X(N), Y(N), DY(N)
C
      INTEGER   JERR, I
      REAL      PX, PY, AX(6), AY(6)
      LOGICAL   XOUT, YOUT, F, GOOD
      INCLUDE 'IRING.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DGPH.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      IERR = 0
      IOUT = 0
      IF (.NOT.AXES) THEN
         IERR = -1
         GO TO 990
         END IF
C
      CALL GLTYPE (4, IBLK, IERR)
      IF (IERR.NE.0) GO TO 990
      DO 10 I = 1,N
         IF (Y(I).NE.FBLANK) THEN
            PX  = X(I) * SCX + OFX
            PY  = Y(I) * SCY + OFY
            XOUT = ((PX.LT.XBLC(1)) .OR. (PX.GT.XTRC(1)))
            YOUT = ((PY.LT.XBLC(2)) .OR. (PY.GT.XTRC(2)))
            IF ((XOUT) .OR. (YOUT)) THEN
               IOUT = IOUT + 1
            ELSE
               AX(1) = PX
               AX(2) = PX
               AX(3) = PX
               AX(4) = PX - 5 * FACTOR
               AX(5) = PX + 5 * FACTOR
               AY(1) = PY
               AY(2) = PY + 5 * FACTOR
               AY(3) = PY - 5 * FACTOR
               AY(4) = PY
               AY(5) = PY
               CALL PNTPLT (ISYM, AX, AY, XBLC, XTRC, .FALSE., .FALSE.,
     *            IBLK, IERR)
               IF (IERR.NE.0) GO TO 990
C                                       error bars
               IF (EBARS) THEN
                  AX(1) = PX + 2 * FACTOR
                  AX(2) = PX - 2 * FACTOR
                  AX(3) = PX
                  AX(4) = PX
                  AX(5) = PX + 2 * FACTOR
                  AX(6) = PX - 2 * FACTOR
                  PY = (Y(I)+DY(I)) * SCY + OFY
                  AY(1) = PY
                  AY(2) = PY
                  AY(3) = PY
                  PY = (Y(I)-DY(I)) * SCY + OFY
                  AY(4) = PY
                  AY(5) = PY
                  AY(6) = PY
                  CALL GPOS (AX(1), AY(1), IBLK, IERR)
                  IF (IERR.EQ.0) CALL GVEC (AX(2), AY(2), IBLK, IERR)
                  IF (IERR.EQ.0) CALL GPOS (AX(3), AY(3), IBLK, IERR)
                  IF (IERR.EQ.0) CALL GVEC (AX(4), AY(4), IBLK, IERR)
                  IF (IERR.EQ.0) CALL GPOS (AX(5), AY(5), IBLK, IERR)
                  IF (IERR.EQ.0) CALL GVEC (AX(6), AY(6), IBLK, IERR)
                  IF (IERR.NE.0) GO TO 990
                  END IF
               END IF
            END IF
 10      CONTINUE
      IF (CONECT) THEN
         CALL GLTYPE (2, IBLK, IERR)
         IF (IERR.NE.0) GO TO 990
         GOOD = .FALSE.
         DO 20 I = 1,N
            IF (Y(I).NE.FBLANK) THEN
               PX  = X(I) * SCX + OFX
               PY  = Y(I) * SCY + OFY
               XOUT = ((PX.LT.XBLC(1)) .OR. (PX.GT.XTRC(1)))
               YOUT = ((PY.LT.XBLC(2)) .OR. (PY.GT.XTRC(2)))
               IF ((XOUT) .OR. (YOUT)) THEN
                  GOOD = .FALSE.
                  IOUT = IOUT + 1
               ELSE
                  IF (GOOD) THEN
                     CALL GVEC (PX, PY, IBLK, IERR)
                  ELSE
                     CALL GPOS (PX, PY, IBLK, IERR)
                     END IF
                  GOOD = .TRUE.
                  END IF
            ELSE
               GOOD = .FALSE.
               END IF
 20         CONTINUE
         END IF
      GO TO 999
C
 990  CALL MAPCLS ('READ', JVOL, ICN, LUN2, FIND, CATBLK, F, SCRTCH,
     *   JERR)
C
 999  RETURN
      END

      SUBROUTINE ALSGET (ALIST, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C! Fetch value from Associative list (ALIST)
C# Utility 
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Public
C   Fetch the value (array) for a specified keyword.
C   Recognizes special keyword 'LISTNAME' as the name of the ALIST
C   Recognizes special keyword 'GET SIZE' as the size of the ALIST
C   See ALSINI for details of the package.
C   Note the AIPS datatypes are defined as parameters in the INCLUDE
C   'INCS:PAOOF.INC': OOADP = double precision, OOARE = real, 
C   OOACAR = character, OOAINT = integer, and OOALOG = logical.
C   Inputs:
C      ALIST  I(*)  ALIST array
C      KEYWRD C*16  Keyword
C   Outputs:
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of value, an axis dimension of zero
C                    means that that dimension and higher are undefined.
C      VALUE   ?     associated value (non character)
C      VALUEC  C(*)*?   associated value (character)
C      IERR    I     Error code, 0=OK.  1=> didn't find.
C-----------------------------------------------------------------------
      INTEGER   ALIST(*), TYPE, DIM(*), VALUE(*), IERR
      CHARACTER KEYWRD*(*), VALUEC(*)*(*)
C
      INTEGER   NVAL, KEYPNT, NDIM, DATOFF, I
      CHARACTER ALNAME*32
      INCLUDE 'INCS:PALIST.INC'
C-----------------------------------------------------------------------
      IERR = 0
      NDIM = ALIST(ALSNDM)
      DATOFF = ALIST(ALSDAT)
C                                       Validity test
      IF (ALIST(ALSCHK).NE.ALSCVL) THEN
         MSGTXT = 'ALSGET: DAMAGED OR UNINITIALIZED ALIST'
         IERR = 6
         GO TO 990
         END IF
C                                       Special trap for ALIST name
      IF (KEYWRD(1:8).EQ.'LISTNAME') THEN
         CALL H2CHR (32, 1, ALIST(ALSNAM), VALUEC)
         TYPE = 3
         DIM(1) = 32
         CALL FILL (NDIM-1, 1, DIM(2))
         GO TO 999
C                                       Special trap for ALIST size
      ELSE IF (KEYWRD(1:8).EQ.'GET SIZE') THEN
         VALUE(1) = ALIST(ALSIZE)
         TYPE = 4
         CALL FILL (NDIM, 1, DIM(1))
         GO TO 999
         END IF
C                                       See if keyword is in the list
      CALL ALSKEY (ALIST, KEYWRD, KEYPNT, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'COULD NOT FIND ALIST KEYWORD '
         GO TO 990
         END IF
C                                       Type
      TYPE = ALIST(KEYPNT+ALSTYP)
C                                       Dimensions
      CALL COPY (NDIM, ALIST(KEYPNT+ALSDIM), DIM)
C                                       Get data: Character
C                                       Size of value
      NVAL = 1
      DO 20 I = 1,NDIM
         NVAL = NVAL * DIM(I)
 20      CONTINUE
      IF (TYPE.EQ.1) NVAL = NVAL * NWDPDP
      IF (TYPE.EQ.3) THEN
C                                       Check String length
         IF (LEN (VALUEC(1)) .LT. DIM(1)) THEN
            IERR = 5
            MSGTXT = 'ALSGET: OUTPUT CHARACTER STRING TOO SMALL'
            GO TO 990
            END IF
         CALL ALSH2C (ALIST(KEYPNT+DATOFF), NDIM, DIM, VALUEC)
C                                       Other
      ELSE
         CALL COPY (NVAL, ALIST(KEYPNT+DATOFF), VALUE)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
      MSGTXT = 'KEYWORD =' // KEYWRD
      CALL MSGWRT (6)
      CALL H2CHR (32, 1, ALIST(ALSNAM), ALNAME)
      MSGTXT = 'PROBLEM WITH ALIST: ' // ALNAME
      CALL MSGWRT (6)
C
 999  RETURN
      END

      SUBROUTINE TKGMPL (INPTS, IFMOD, IMOD, ISLUN, ISFIND, RANGE2, BLC,
     *   TRC, IERR)
C-----------------------------------------------------------------------
C! plot model fit to slice on the graphics terminal
C# Slice Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2007, 2015-2016
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Given an open TEK device, TKGMPL will draw the model fit to the
C   slice.
C   Inputs:
C      INPTS   I     number of points in the slice
C      IFMOD   I     first 256-integer block containing model data
C      IMOD    I     number of gaussian model data blocks in the file
C      ISLUN   I     logical unit no. of open slice file.
C      ISFIND  I     FTAB index for slice file.
C      RANGE2  R(2)  min and max pixel value allowed for plot.
C      BLC     R(7)  the bottom left corner of the plot.
C      TRC     R(7)  the top right corner of the plot.
C   Output:
C      IERR    I     error code 0= none.
C                       1 = error during graphing. Try finish.
C                       2 = fatal error. Give up.
C-----------------------------------------------------------------------
      INTEGER   INPTS, IFMOD, IMOD, ISLUN, ISFIND, IERR
      REAL      RANGE2(2), BLC(7), TRC(7)
C
      REAL      X, Y, SCALEF, OFFSET, SBLK(256), PARM(12), BASLIN(3),
     *   XCEN
      INTEGER   ISTART, IEND, IRRN, IPOS, INP, ISBLK(256), I, I0, I1,
     *   IC, IMAX, IS, ISL, IWTH, NGAUSS
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /WORK/ ISBLK
      EQUIVALENCE (ISBLK, SBLK)
C-----------------------------------------------------------------------
C                                       Init some variables.
      SCALEF = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN) )
      OFFSET = 40000.0 - SCALEF * CATR(IRRAN+1)
      ISTART = BLC(1) + .5
      IEND = TRC(1) + .5
      XCEN = (ISTART + IEND) / 2.0
C                                       Read data.
      IRRN = IFMOD + IMOD - 1
      CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, SBLK, IERR)
      IF (IERR.NE.0) GO TO 930
C                                       Move data from buffer.
      IS = 25
      I0 = ISBLK(IS)
      I1 = INPTS - ISBLK(IS+1)
      NGAUSS = ISBLK(IS+2)
      DO 10 I = 1,12
         PARM(I) = SBLK(I)
 10      CONTINUE
      CALL RCOPY (3, SBLK(83), BASLIN)
C                                       Plot data points.
      INP = 1
      DO 50 ISL = ISTART,IEND
         X = ISL
C                                       Add up all components
         Y = 0.0
         DO 40 IC = 1,NGAUSS
            IMAX = 3 * IC - 2
            IPOS = IMAX + 1
            IWTH = IPOS + 1
            Y = Y + PARM(IMAX) * EXP (-2.772 * (PARM(IPOS) - X)
     *         ** 2  /  (PARM(IWTH) * PARM(IWTH)))
 40         CONTINUE
         Y = Y + BASLIN(1) + (X-XCEN) * BASLIN(2) +
     *      (X-XCEN) * (X-XCEN) * BASLIN(3)
C
         Y = SCALEF * Y  +  OFFSET
         Y = MIN (Y, RANGE2(2))
         Y = MAX (Y, RANGE2(1))
         CALL TEKVEC (X, Y, INP, IERR)
         IF (IERR.NE.0) GO TO 950
         INP = 2
 50      CONTINUE
C                                       Force alpha mode to allow
C                                       screen to auto-dim
      ISTART = 31
      CALL ZTKBUF (ISTART, 1, IERR)
C                                       Write final TEK buffer.
      CALL TEKFLS (IERR)
      IF (IERR.EQ.0) GO TO 999
      GO TO 950
C                                       Slice read error.
 930  IERR = 1
      WRITE (MSGTXT,1930)
      CALL MSGWRT (6)
      GO TO 999
C                                       TEK write error.
 950  IERR = 2
      WRITE (MSGTXT,1950)
      CALL MSGWRT (7)
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1930 FORMAT ('SLICE FILE READ ERROR.')
 1950 FORMAT ('TEKTRONIX 4012 WRITE ERROR.')
      END

      SUBROUTINE PASENC (IPAS, OPAS)
C-----------------------------------------------------------------------
C! encrypts a 12-character password into 3 Holleriths
C# System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   PASENC encrypts a password string
C   Input:
C      IPAS   C*12   user-typed password (clear characters)
C   Output:
C      OPAS   H(3)   encode password
C   NOTE: the current encryption scheme is very elementary and should be
C   replaced.
C-----------------------------------------------------------------------
      CHARACTER IPAS*12
      HOLLERITH OPAS(3)
      INTEGER   J1, J2, IT, LT, I, NP, IOFF, J, I1, I2, II, BITS(16)
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      NP = 2 ** (NBITCH-2)
      DO 50 I = 1,12
C                                       get character
         J1 = (I-1) / 4 + 1
         J2 = I - 4 * (J1-1)
         I1 = J1 + J2 - 2
         IT = ICHAR (IPAS(I:I))
C                                       swap some bits
         LT = IT / 4
         LT = LT + (IT - 4 * LT) * NP
C                                       get output char position
         IF (I.EQ.1) IOFF = (2 * LT) / NP
         J = MOD (I+IOFF-1, 12) + 1
         J1 = (J-1) / 4 + 1
         J2 = J - 4 * (J1-1)
         J = (I1 + J1 + J2 - 2) / 2
C                                       play with bits
         CALL ZGTBIT (NBITCH, LT, BITS)
         DO 10 II = 1,NBITCH
            I2 = MOD (II+J-1, NBITCH) + 1
            IF (I2.GE.II) GO TO 10
               I1 = BITS(II)
               BITS(II) = BITS(I2)
               BITS(I2) = I1
 10         CONTINUE
         DO 20 II = 1,NBITCH
            I2 = MOD (2*II-J-1+NBITCH, NBITCH) + 1
            IF (I2.GE.II) GO TO 20
               I1 = BITS(II)
               BITS(II) = BITS(I2)
               BITS(I2) = I1
 20         CONTINUE
         DO 30 II = 1,NBITCH
            I2 = MOD (3*II-J-1+NBITCH, NBITCH) + 1
            IF (I2.GE.II) GO TO 30
               I1 = BITS(II)
               BITS(II) = BITS(I2)
               BITS(I2) = I1
 30         CONTINUE
C                                       pack the bits, store
         CALL ZPTBIT (NBITCH, LT, BITS)
         CALL ZPUTCH (LT, OPAS(J1), J2)
 50      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE DATFLG (RPARM, VIS, DROP, IERR)
C-----------------------------------------------------------------------
C! Flags data specified in flagging table
C# Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2000-2001, 2007, 2011, 2014-2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Flags data specified in flagging table
C     Inputs:
C      RPARM(*)   R    Random parameter array
C      VIS(3,*)   R    Visibility array
C     Inputs from include DSEL.INC, DFLG.INC:
C      CURSOU     I    Current source number
C      NUMFLG     I    Number of flagging entries.
C      TMFLST     R    Time of last visibility for which flagging
C                      was checked.
C      FLGSOU(*)  I    Source id numbers to flag, 0=all.
C      FLGANT(*)  I    Antenna numbers to flag, 0=all.
C      FLGBAS(*)  I    Baseline (A1*256+A2) numbers to flag, 0=all.
C      FLGSUB(*)  I    Subarray numbers to flag, 0=all.
C      FLGFQD(*)  I    Freqid numbers to flag, <=0=all.
C                      Following should have defaults filled in.
C      FLGBIF(*)  I    First IF to flag.
C      FLGEIF(*)  I    Highest IF to flag.
C      FLGBCH(*)  I    First channel to flag.
C      FLGECH(*)  I    Highest channel to flag.
C      FLGPOL(4,*)L    Flags for the polarizations, should correspond
C                      to selected polarization types.
C     Output:
C      RPARM(*)   R    Random parameter array
C      VIS(3,*)   R    Visibility array
C      DROP       L    True if data all flagged.
C      IERR       I    Return code, 0=OK, else NXTFLG error number.
C-----------------------------------------------------------------------
      REAL      RPARM(*), VIS(3,*)
      LOGICAL   DROP
      INTEGER   IERR
C
      INTEGER   IFLAG, KBASE, A1, A2, FLGA, SUBA, JIF, JCHAN, JPOLN,
     *   LIMF1, LIMF2, LIMC1, LIMC2, IFADD, INDEX, STADD, IPOLPT, LFQ
      LOGICAL   GOOD
      REAL      TIME, SUM
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
C-----------------------------------------------------------------------
      IERR = 0
      DROP = .FALSE.
C                                       Check if new time
      TIME = RPARM(1+ILOCT)
      IF (TMFLST.LT.TIME) CALL NXTFLG (TIME, .FALSE., IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Check if there are current flags
      IF (NUMFLG.LE.0) GO TO 999
C                                       Loop thru flagging criteria
      IF (ILOCB.GE.0) THEN
         KBASE = RPARM(1+ILOCB) + 0.1
         A1 = KBASE / 256
         A2 = KBASE - 256 * A1
         SUBA = (RPARM(1+ILOCB) - KBASE) * 100.0 + 1.5
      ELSE
         A1 = RPARM(1+ILOCA1) + 0.1
         A2 = RPARM(1+ILOCA2) + 0.1
         SUBA = RPARM(1+ILOCSA) + 0.1
         END IF
      KBASE = 32768 * MIN (A1,A2) + MAX (A1,A2)
      DO 500 IFLAG = 1,NUMFLG
C                                       Check time if needed
         IF (.NOT.TIMORD) THEN
            IF ((TIME.LT.FLGTST(IFLAG)) .OR. (TIME.GT.FLGTND(IFLAG)))
     *         GO TO 500
            END IF
C                                       Check source
         IF ((FLGSOU(IFLAG).NE.CURSOU) .AND. (FLGSOU(IFLAG).NE.0) .AND.
     *      (CURSOU.NE.0)) GO TO 500
C                                       Check antenna
         FLGA = FLGANT(IFLAG)
         IF ((FLGA.NE.0) .AND. (FLGA.NE.A1) .AND. (FLGA.NE.A2))
     *      GO TO 500
C                                       Check baseline
         IF ((FLGBAS(IFLAG).NE.0) .AND. (FLGBAS(IFLAG).NE.KBASE))
     *      GO TO 500
C                                       Check subarray
         IF ((FLGSUB(IFLAG).GT.0) .AND. (FLGSUB(IFLAG).NE.SUBA))
     *      GO TO 500
C                                       Check freqid.
         IF (ILOCFQ.GE.0) THEN
            LFQ = RPARM(1+ILOCFQ) + 0.1
            IF ((FLGFQD(IFLAG).GT.0) .AND. (FLGFQD(IFLAG).NE.LFQ))
     *         GO TO 500
            END IF
C                                       Some data to be flagged
C                                       Set limits
         LIMF1 = FLGBIF(IFLAG)
         LIMF2 = FLGEIF(IFLAG)
         LIMC1 = FLGBCH(IFLAG)
         LIMC2 = FLGECH(IFLAG)
C                                       Loop over polarizations
         IPOLPT = ABS(KCOR0) - 1
         IF (KCOR0.LT.-4) IPOLPT = IPOLPT - 4
         DO 400 JPOLN = 1,KNCOR
            IF (FLGPOL(JPOLN+IPOLPT,IFLAG)) THEN
               STADD = (JPOLN-1) * KNCS + 1
C                                       Loop over IF
               DO 300 JIF = LIMF1,LIMF2
                  INDEX = STADD + (JIF-1) * KNCIF + (LIMC1-1) * KNCF
                  IF (LIMC1.EQ.LIMC2) THEN
C                                       Single channel
                     VIS(3,INDEX) = - ABS (VIS(3,INDEX))
                  ELSE
C                                       Loop over channel
                     DO 200 JCHAN = LIMC1,LIMC2
C                                       Flag
                        VIS(3,INDEX) = - ABS (VIS(3,INDEX))
                        INDEX = INDEX + KNCF
 200                    CONTINUE
                     END IF
 300              CONTINUE
               END IF
 400        CONTINUE
 500     CONTINUE
C                                       Check if data all bad
      GOOD = .FALSE.
C                                       Loop over IF
      DO 530 JIF = BIF,EIF
         IFADD = (JIF-1) * KNCIF + 1
C                                       Loop over polarizations
         DO 520 JPOLN = 1,KNCOR
            INDEX = IFADD + (JPOLN-1) * KNCS + (BCHAN-1) * KNCF
C                                       Single channel
            IF (BCHAN.EQ.ECHAN) THEN
               GOOD = GOOD .OR. (VIS(3,INDEX).GT.0.0)
C                                       Multiple channels
            ELSE
               SUM = 0.0
               DO 510 JCHAN = BCHAN,ECHAN
                  SUM = SUM + MAX (0.0, VIS(3,INDEX))
                  INDEX = INDEX + KNCF
 510              CONTINUE
               GOOD = GOOD .OR. (SUM.GT.0.0)
               END IF
 520        CONTINUE
 530     CONTINUE
      DROP = .NOT.GOOD
C
 999  RETURN
      END

      SUBROUTINE QSEARC (NF, NT, MF, MT, ND, NR, DATA)
C-----------------------------------------------------------------------
C! FPS AP version: VLBI fringe search with FFTs
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FPS AP version
C   A routine to do a gridded fringe search by means of  padded FFTs.
C   The number (size) of the FFTs is NF (MT) + NR (MF).
C    Inputs:
C     NF    I  No. frequency channels.
C     NT    I  No. time points.
C     MF    I  No. points for freq. FFT.
C     MT    I  No. points for time FFT.
C     ND    I  No. delay channels to search.
C     NR    I  No. rate channels to search.
C     DATA  I  Base address of data array (NT,NF)
C    Output: (in AP memory)
C    0 => 1 dim. array index for peak.
C    1 => peak amplitude
C    2 => peak phase.
C        The resulting delay and rate channels should have the
C        following offsets added:  (ND/2, NR/2)
C-----------------------------------------------------------------------
      INTEGER NF, NT, MF, MT, ND, NR, DATA
      INTEGER*2 INF, INT, IMF, IMT, IND, INR, IDATA
C-----------------------------------------------------------------------
C                                        Convert inputs to unsigned I*2
      IF (NF.LT.32768) INF = NF
      IF (NF.GE.32768) INF = NF - 65536
      IF (NT.LT.32768) INT = NT
      IF (NT.GE.32768) INT = NT - 65536
      IF (MF.LT.32768) IMF = MF
      IF (MF.GE.32768) IMF = MF - 65536
      IF (MT.LT.32768) IMT = MT
      IF (MT.GE.32768) IMT = MT - 65536
      IF (ND.LT.32768) IND = ND
      IF (ND.GE.32768) IND = ND - 65536
      IF (NR.LT.32768) INR = NR
      IF (NR.GE.32768) INR = NR - 65536
      IF (DATA.LT.32768) IDATA = DATA
      IF (DATA.GE.32768) IDATA = DATA - 65536
C                                        Call FPS routine.
      CALL SEARCH (INF, INT, IMF, IMT, IND, INR, IDATA)
C
 999  RETURN
      END

C     Developed from AFILE.FOR    M. Wunderlich MPIfR Bonn  10-Mar-97
C     Last change:   MMW  07-may-97
C
LOCAL INCLUDE 'TFILE.INC'
      INTEGER   NUMLIN
      PARAMETER (NUMLIN=20000)
C
      HOLLERITH XINFIL(12), XOUTFL(12), XOPCOD(1)
      CHARACTER INFIL*48, OUTFIL*48, OPCODE*4
      REAL      APARM(10)
      INTEGER   LUN1, LUN2, FIND1, FIND2, BUFF1(256), TOTLIN,
     *   EXPNUM, UVERSN
      CHARACTER LINE(NUMLIN)*512, TIT1*512, TIT2*512
      REAL      TIMIND(NUMLIN)
      INTEGER   BASIND(NUMLIN), AINDEX(NUMLIN)
      COMMON /INPARM/ XINFIL, XOUTFL, XOPCOD, APARM
      COMMON /AFILP/ LUN1, LUN2, FIND1, FIND2, TIMIND, BASIND, BUFF1,
     *   AINDEX, TOTLIN, EXPNUM, UVERSN
      COMMON /CHARPM/ INFIL, OUTFIL, OPCODE
      COMMON /CHDATA/ LINE, TIT1, TIT2
LOCAL END
      PROGRAM TFILE
C-----------------------------------------------------------------------
C! Task to sort and edit a MkIII correlator UNIX-based A-file.
C# Utility UV UV-util VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1997-1998, 2012, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TFILE allows a user to provide a subroutine which performs an
C   operation on a UV data base, writing an output UV data base.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INFILE         INFIL         Input text A-file (UNIX based)
C      OUTFILE        OUTFIL        Output text A-file (ditto)
C      APARM(10)      APARM         A-FILE selection criteria
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'TFILE.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
C
      DATA PRGM /'TFILE '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
      CALL TFILIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE TFILIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   TFILIN gets input parameters for TFILE.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C
C
C
C  The documentation of the format is as follows:
C
C Unix-based A-file format              Documentor CJL, 28 January 1994
C -----------------------               -------------------------------
C
C Below is a description of the A-file format, version 2 and higher.
C Version 2 was introduced for two purposes.  First, deficiencies in the
C old format were fixed.  Various useful quantities were added, and the
C scan time precision was improved to 1 second, allowing trivial
C construction of a unique Unix data file name from the A-file line.
C Second, a mechanism for future support of A-file format evolution was
C included via the version number in field 1.
C
C A ground rule is that the new format is field-oriented, not column-
C oriented. Fields are delimited by spaces.  In general, A-file format
C writing routines will stick to the same columns to facilitate viewing
C of the files, but these columns are NOT fixed, and any software that
C uses these files will not care about the columns.  Many fields,
C however, will normally have fixed widths  (indicated by a definite
C number of characters in the width column below). Extreme values in any
C field cause the field width to expand.  Common to all lines is a
C format version number in the first field.  A non-numeric character
C implies version 1 (the old HP-1000 format).  Future modifications
C to the format will increment this version number.  All unix software
C will support all A-file format versions, including files with mixed
C formats.  In the latter case, however, certain fields will be missing
C in certain lines, and processing of those quantities may be blocked by
C programs that encounter such mixed-format files.
C
C Note that version 2+ or mixed format A-files CANNOT be used on the
C HP-1000 systems.  If you need to ship an A-file back there, for
C reprocessing perhaps, it MUST be a version 1 A-file.  Control over the
C output format from the unix programs is provided.
C
C Below are the formal definitions of the formats for different line
C types, format version number 4.
C
C The contents of the type 0 lines are as follows:
C
C Field # Contents              Width/type      Comments
C ------- --------              ----------      --------
C 1     Format version #        1/i             Non-numeric = version 1
C 2     Root id code            6/c             6-char lower case
C 3     File type (0)           1/i             Root file record
C 4     Extent #                2/i             Should always be zero
C 5     Size                    4/i             # of 256-byte records in
C                                                 file
C 6     Expt serial #           4/i             Part of filename
C 7     Procdate yyddd?hhmmss   12/c            Corel run date,
C                                                 ? is corel version
C 8     Year of scan            2/i             Two-digit year
C 9     Time tag ddd-hhmmss     10/c            Equals scan directory
C                                                 name
C 10    Source name             8/c             Blank padded
C 11    Station list            variable/c      1 character per station
C
C Changes version 1 to 2: Deletion of the archive number (obsolete
C                         under unix), repositioning of the root id code
C                         and addition of seconds precision to the scan.
C                         The FMGR file name is also dropped.
C Changes version 2 to 3: None
C Changes version 3 to 4: Added seconds precision to procdate
C
C
C The contents of the type 1 lines are as follows:
C
C Field # Contents              Width/type      Comments
C ------- --------              ----------      --------
C 1     Format version #        1/i             Non-numeric = version 1
C 2     Root id code            6/c             6-char lower case
C 3     File type (1)           1/i             Corel file record
C 4     Extent #                2/i             Part of filename
C 5     Size                    4/i             # of 256-byte records in
C                                                 file
C 6     Expt serial #           4/i             Part of filename
C 7     Procdate yyddd?hhmmss   12/c            Corel run date,
C                                                 ? is corel version
C 8     Year of scan            2/i             Two-digit year
C 9     Time tag ddd-hhmmss     10/c            Equals scan directory
C                                                 name
C 10    Source name             8/c             Blank-padded
C 11    Baseline/QF             3/c             2-char baseline id and
C                                                 1-char qcode
C                                               Meaning of qcode in
C                                                  corel.doc
C 12    Scheduled duration      4/i             Seconds
C 13    Lags                    4/i             Number of lags in
C                                                 correlation
C 14    Reference drive #       1/i
C 15    Remote drive #          1/i
C 16    frequencies             2/c             E.g. SX
C 17    Reference clock error   7/f             Microsec
C 18    Ref/rem clock diff.     7/f             Microsec
C 19    Status bits             6/octal         See corel.doc for
C                                               details
C
C Changes version 1 to 2: Repositioning of the root id code, addition of
C                         seconds precision to the scan, separating
C                         reference and remote drive numbers into two
C                         fields (in case they go over 9), omission of
C                         the scheduled scan start seconds (now in the
C                         scan field), and omission of correlation
C                         start/stop times and EQTs, which are not
C                         present in the root file, and therefore not
C                         accessible under UNIX.  The FMGR file name
C                         is also dropped.
C Changes version 2 to 3: None
C Changes version 3 to 4: Addition of field 13, and seconds precision
C                         to procdate
C
C
C The contents of the type 2 lines are as follows:
C
C Field #       Contents                Width/type      Comments
C -------       --------                ----------      --------
C 1     Format version #        1/i             Non-numeric = version 1
C 2     Root id code            6/c             6-char lower case
C 3     File type (2)           1/i             General format for
C                                               fringe data
C 4     Extent #                2/i             Part of filename
C 5     Duration                4/i             Nominal duration of this
C                                               datum (sec)
C 6     Length                  4/i             Seconds of data
C                                               represented.
C 7     Offset                  4/i             Offset (sec) of mean
C                                               time of data from
C                                               nominal scan time (field
C                                               11)
C 8     Expt serial #           4/i             Part of filename
C 9     Procdate yyddd?hhmmss   12/c            FRNGE/fourfit processing
C                                               time, char 6 is corel
C                                               version number
C 10    Year of scan            2/i             Two-digit year.
C 11    Time tag ddd-hhmmss     10/c            Nominal start time of
C                                               data record
C 12    Scan offset             3/i             Offset from scan time to
C                                               time tag (sec)
C 13    Source name             8/c             Blank-padded ascii
C                                               string
C 14    Baseline/QF             3/c             2-char baseline id and
C                                               1-char qcode; Meaning of
C                                               qcode defined in fourfit
C 15    Freq/mode/#freq         4/c             e.g. XC08 for X-band
C                                               mode C 8 freqs
C 16    Lags                    4/i             Number of lags in
C                                               correlation
C 17    Amplitude               6/f             In units of 1/10000
C 18    Ampl. SNR               5/f             4 significant digits
C 19    Phase(deg)              5/f             Can be of various type,
C                                               see field 21
C 20    Phase SNR               5/f             4 significant digits
C 21    Data type               2/c             First char specifies
C                                               data origin:
C                                               A = ap by ap data from
C                                               fringex
C                                               C = coherently avgd data
C                                                   from fringex
C                                               I = incoherently avgd
C                                                   data from average
C                                               J = Inc. scan avg from
C                                                   average, dur=seglen
C                                               K = Cofit output (bogus
C                                                   duration)
C                                               S = scan summary from
C                                                   alist
C                                               O = overlapping coh.
C                                                   avg. from fringex
C                                               Second char specifies
C                                               phase type:
C                                               f = residual to
C                                                   corel+fourfit, e.c.
C                                               c = residual to corel
C                                                   only
C                                               t = total phase
C                                                 (geodetic definition)
C                                               e = total earth-centered
C                                                   phase
C 22    Resid SBD               5/f             Microseconds
C 23    Resid MBD               8/f             Microseconds
C 24    MBD ambiguity           6/f             Microseconds
C 25    Resid rate              7/f             Picoseconds/second
C 26    Ref. elevation          4/f             At reference epoch,
C                                               degrees
C 27    Rem. elevation          4/f             At reference epoch,
C                                               degrees
C 28    Ref. azimuth            5/f             At reference epoch,
C                                               degrees
C 29    Rem. azimuth            5/f             At reference epoch,
C                                               degrees
C 30    u (megalambda)          6/f             precision 4 sig. digits
C 31    v (megalambda)          6/f             precision 4 sig. digits
C 32    ESDESP                  6/c             E=ref.tape error rate
C                                               exponent:
C                                                  0=1.0E00  9=1.0E-9
C                                               S=ref.tape slip sync
C                                               rate:
C                                                     0=10%     9=1%
C                                               D=percentage data
C                                               discarded:
C                                                     0=10%     9=1%
C                                               E=rem.tape error rate
C                                               exponent:
C                                                    0=1.0E00  9=1.0E-9
C                                               S=rem.tape slip sync
C                                               rate:
C                                                    0=10%     9=1%
C                                               P=fraction of data
C                                               processed: i.e.
C                                               INTG.TIME/scheduled run
C                                               duration
C 33    Reference epoch         4/c             mmss at which various
C                                               time-dependent
C                                               quantities are
C                                               calculated
C 34    Reference frequency     8/f             Precision 10 KHz
C 35    Total e.c. phase        5/f             Regardless of field 21
C 36    Total drate             11/f            At ref epoch,
C                                               microsec/sec
C 37    Total mbdelay           13/f            At ref epoch, microsec
C 38    Total SBD-MBD           5/f             At ref epoch, microsec
C 39    Search coh. time        3/i             Seconds
C 40    Zero-loss coh. time     3/i             Seconds
C 41    Parent corel extent(s)  variable        up to 4 numbers,
C                                                "a,b,c,d"
C
C
C Changes version 1 to 2:
C     Brand new fields are 1, 21, 26, 27, 28, 29, 30, 31, 34.
C     Modified or enhanced fields are 11, 19, 22, 23, 41.
C     Discarded fields are FMGR file name, reference and remote tape
C        labels, A-file number, phasecal numbers for first and last
C        channels, reference and remote.
C Changes version 2 to 3: Addition of fields 5 and 7.
C Changes version 3 to 4: Addition of fields 12, 16, 20, 39 and 40, and
C     seconds precision to procdate
C
C The above is intended to fulfill data export needs, but is
C insufficient for astrometric purposes.
C
C
C The contents of the type 3 lines are as follows:
C
C Field # Contents              Width/type      Comments
C 1     Format version #        1/i
C 2     Expt serial #           4/i
C 3     File type (3)           1/i             Closure triangle data
C 4     Year of scan            2/i             Two-digit year.
C 5     Time tag ddd-hhmmss     10/c            Nominal start time of data record
C 6     Scan offset             3/i             Offset from scan time to time tag (sec)
C 7     Source name             8/c             Blank-padded ascii string
C 8     Freq/mode               2/c             e.g. XC for X-band mode C
C 9     Lags                    4/i             Number of lags in correlation
C 10    Triangle                3/c             e.g. ABC
C 11    root extension(s)       6-20/c          If more than one, comma separated
C 12    extents                 i,i,i           For baselines AB, BC, CA
C 13    lengths                 i,i,i           For baselines AB, BC, CA
C 14    Duration                4/i             Nominal duration of datum
C 15    Offset                  4/i             Offset from nominal scan time of
C                                               mean time of all contributing data
C 16    Scan quality            1/c             Based on baseline qf's
C 17    Data quality            1/c             Based on data values
C 18    ESDESP                  6/c             Minimum of baseline values
C 19    bispectral amp          9/f             Units of 10**-12
C 20    bispectral snr          7/f
C 21    bispectral phase        5/f             Closure phase (degrees)
C 22    Data type               2/c             Analogous to type 2 field 21,
C                                               meaning yet to be defined
C 23    closure sbd             6/f             Microseconds
C 24    closure mbd             8/f             Microseconds
C 25    closure mbd ambig.      6/f             Microseconds
C 26    closure delay rate      7/f             Picosec/sec
C 27    Elevations              f,f,f           For stations A,B,C
C 28    Azimuths                f,f,f           For stations A,B,C
C 29    Reference epoch         4/c             mmss at which various time-dependent
C                                               quantities are calculated
C 30    Reference frequency     8/f             Precision 10 KHz
C
C
C Changes version 1 to 2: There was no version 1.
C Changes version 2 to 3: Added fields 14, 15, 22.
C Changes version 3 to 4: Added fields 6, 9.
C
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      INTEGER   IERR, NPARM, ICHAR, JTRIM, I, ILINE, IROUND
      INTEGER   PI(100)
      REAL      TIM1, TIM2
      LOGICAL   T, APPEND
      INCLUDE 'TFILE.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T, BUFF1)
      CALL VHDRIN
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 35
      CALL GTPARM (PRGN, NPARM, RQUICK, XINFIL, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (48, 1, XINFIL, INFIL)
      CALL H2CHR (48, 1, XOUTFL, OUTFIL)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      IF ((OPCODE.NE.'SORT') .AND. (OPCODE.NE.'EDIT')) THEN
         WRITE (MSGTXT,1020) OPCODE
         JERR = 1
         GO TO 990
         END IF
      EXPNUM = IROUND(APARM(2))
      IF (EXPNUM.LE.0) EXPNUM = 0
C                                       Open text files
      LUN1 = 10
      LUN2 = 11
      APPEND = .FALSE.
      CALL ZTXOPN ('READ', LUN1, FIND1, INFIL, APPEND, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1010) JERR, INFIL
         GO TO 990
         END IF
      CALL ZTXOPN ('WRIT', LUN2, FIND2, OUTFIL, APPEND, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1010) JERR, OUTFIL
         GO TO 990
         END IF
C                                       Sort the data
      CALL DSORT (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Edit the data
      IF (OPCODE.EQ.'EDIT') THEN
         CALL DEDIT (JERR)
         IF (JERR.NE.0) GO TO 999
         END IF
C                                       Write the final file.
      CALL ZTXIO ('WRIT', LUN2, FIND2, TIT1(:JTRIM(TIT1)), IERR)
      CALL ZTXIO ('WRIT', LUN2, FIND2, TIT2(:JTRIM(TIT2)), IERR)
      ILINE = 0
      TIM1 = 0.0
      TIM2 = 0.0
      DO 800 I = 1, TOTLIN
         IF ((OPCODE.EQ.'EDIT') .AND. (AINDEX(I).EQ.0)) GO TO 800
         ICHAR = JTRIM(LINE(I))
         CALL ZTXIO ('WRIT', LUN2, FIND2, LINE(I)(:ICHAR), IERR)
         ILINE = ILINE + 1
         IF (ILINE.EQ.1) THEN
            CALL UINDEX (LINE(I),PI)
            CALL TIMCRK (LINE(I)(PI(11):), TIM1)
            END IF
         IF (ILINE.GT.1) THEN
            CALL UINDEX (LINE(I),PI)
            CALL TIMCRK (LINE(I)(PI(11):), TIM2)
            IF (TIM2.LT.TIM1) THEN
               WRITE (MSGTXT,1040) ILINE
               GO TO 990
               END IF
            TIM1 = TIM2
            END IF
 800     CONTINUE
      WRITE (MSGTXT,1030) ILINE
      CALL MSGWRT (6)
C
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  CALL ZTXCLS (LUN1, FIND1, IERR)
      CALL ZTXCLS (LUN2, FIND2, IERR)
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AFILIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('AFILIN: ERROR',I3,' OPENING ',A)
 1020 FORMAT ('AFILIN: UNKNOWN OPCODE ',A4,' --- TRY AGAIN')
 1030 FORMAT ('Total number of type 52 lines in output A file = ',I7)
 1040 FORMAT ('AFILIN: line ',I6,' in output file out of time order')
      END
      SUBROUTINE DSORT (IERR)
C-----------------------------------------------------------------------
C  Routine to sort the data by time and baseline. will reject all
C  non type 52 records. It appears that type 52 summaries are the ones
C  we need for our purposes. So routine will first read up to 5000
C  type 52 records into memory, then set up a sorting index based
C  on time and baseline, then use the sorting index to write out the
C  records in the correct order.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'TFILE.INC'
      CHARACTER TEMP*512, TLIN(NUMLIN)*512
      INTEGER   ILINE, KLINE, XBASE(NUMLIN), I, J, K, II, JT, JTRIM,
     *   INDX(NUMLIN), ITIME, NTIM(NUMLIN), NSTART(NUMLIN), NL, OLDI,
     *   IT1, IGRP, NSTOP, PI(100), FTYPE
      REAL      XTIME(NUMLIN), T1
      LOGICAL   EOF, SORT
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                        Read a line and decode the
C                                        time into days
      NL = NUMLIN
      CALL FILL (NL, 0, NTIM)
      CALL FILL (NL, 0, NSTART)
      ILINE = 0
      KLINE = 0
      IERR = 0
      EOF = .FALSE.
      TIT1 = ' '
      TIT2 = ' '
 100  CALL ZTXIO ('READ', LUN1, FIND1, TEMP, IERR)
      IF (IERR.EQ.2) THEN
         EOF = .TRUE.
         IERR = 0
         END IF
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
      IF (EOF) GO TO 200
      JT = JTRIM (TEMP)
      KLINE = KLINE + 1
C                                        Parse line to get pointers
C                                        for data items
      CALL UINDEX (TEMP,PI)
C                                        Ignore comment lines
      IF (TEMP(1:1).EQ.' ') GO TO 100
      IF (TEMP(1:1).EQ.'*') GO TO 100
C                                        Check for old HP-1000 ver.
      IF (TEMP(1:1).EQ.'<') THEN
         WRITE (MSGTXT,1030)
         GO TO 990
         END IF
C                                        Field #1 is version no.
C                                        We do Ver. 4 only in the moment
C                                        In the future one can handle
C                                        several versions via UVERSN
      READ (TEMP(PI(1):),2000) UVERSN
2000  FORMAT (I2)
C
      IF (UVERSN.NE.4) THEN
         WRITE (MSGTXT,1040) UVERSN
         GO TO 990
         END IF
C                                        Field #3 is file type
      READ (TEMP(PI(3):),2010) FTYPE
2010  FORMAT (I2)
C                                        Is it a type 52 ?

C      IF (TEMP(8:8).NE.'2') GO TO 100
      IF (FTYPE.NE.2) GO TO 100
C                                        OK we want this one.
      ILINE = ILINE + 1
      LINE(ILINE) = TEMP
C                                        Field #11 is time tag
C                                        Extract time and encode as
C                                        days
      CALL TIMCRK (TEMP(PI(11):), TIMIND(ILINE))
C                                        Field #14 is baseline + qf
C                                        Extract baseline names and
C                                        encode as A + 256 * B
      CALL BASCRK (TEMP(PI(14):), BASIND(ILINE))
      GO TO 100
C                                        Now we sort by time
 200  DO 210 I = 1, ILINE
         XTIME(I) = TIMIND(I)
         XBASE(I) = BASIND(I)
         INDX(I) = I
         TLIN(I) = LINE(I)
 210     CONTINUE
C
      SORT = .FALSE.
      K = ILINE - 1
      DO 300 II = 1, ILINE
         DO 250 I = 1, K
            IF (TIMIND(I+1).LT.TIMIND(I)) THEN
               J = INDX(I)
               INDX(I) = INDX(I+1)
               INDX(I+1) = J
               T1 = TIMIND(I)
               TIMIND(I) = TIMIND(I+1)
               TIMIND(I+1) = T1
               END IF
 250        CONTINUE
 300     CONTINUE
C                                       reorder in memory
      ITIME = 0
      OLDI = 1
      TOTLIN = ILINE
      DO 450 I = 1, ILINE
         TIMIND(I) = XTIME(INDX(I))
         BASIND(I) = XBASE(INDX(I))
         LINE(I) = TLIN(INDX(I))
         IF (I.GT.1) THEN
            IF ((TIMIND(I).GT.TIMIND(I-1)).OR.(I.EQ.ILINE)) THEN
               ITIME = ITIME+ 1
               NTIM(ITIME) = I - OLDI
               IF (I.EQ.ILINE) NTIM(ITIME) = NTIM(ITIME) + 1
               NSTART(ITIME) = OLDI
               OLDI = I
               END IF
            END IF
 450     CONTINUE
C                                       Now sort by baseline order,
C                                       but must first gather groups
C                                       with the same time.
      DO 700 IGRP = 1, ITIME
         ILINE = NTIM(IGRP)
         K = ILINE + NSTART(IGRP) - 2
         NSTOP = NSTART(IGRP) + ILINE - 1
         DO 500 I = NSTART(IGRP), NSTOP
            XTIME(I) = TIMIND(I)
            XBASE(I) = BASIND(I)
            INDX(I) = I
            TLIN(I) = LINE(I)
 500        CONTINUE
C
         DO 550 II = NSTART(IGRP), NSTOP
            DO 520 I = NSTART(IGRP), K
               IF (BASIND(I+1).LT.BASIND(I)) THEN
                  J = INDX(I)
                  INDX(I) = INDX(I+1)
                  INDX(I+1) = J
                  IT1 = BASIND(I)
                  BASIND(I) = BASIND(I+1)
                  BASIND(I+1) = IT1
                  END IF
 520              CONTINUE
 550        CONTINUE
C                                       reorder in memory
         DO 610 I = NSTART(IGRP), NSTOP
            TIMIND(I) = XTIME(INDX(I))
            BASIND(I) = XBASE(INDX(I))
            LINE(I) = TLIN(INDX(I))
 610        CONTINUE
 700     CONTINUE
      WRITE (MSGTXT,1010) KLINE
      CALL MSGWRT (6)
      WRITE (MSGTXT,1020) TOTLIN
      CALL MSGWRT (6)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DSORT: ERROR ',I3,' READING INPUT A-FILE')
 1010 FORMAT ('Total number of lines in input A file = ',I7)
 1020 FORMAT ('Total number of type-52 lines in input A file = ',I7)
 1030 FORMAT ('DSORT: OLD HP-RTE FORMATS NOT SUPPORTED.')
 1040 FORMAT ('DSORT: VERSION ',I2,' CURRENTLY NOR SUPPORTED.')
      END
      SUBROUTINE DEDIT (IERR)
C-----------------------------------------------------------------------
C  Routine to delete duplicate scans from the MkIII A-file. Upon
C  entering DEDIT the A-file will exist in memory, sorted by time
C  and baseline - so duplicate scans should lie together. This
C  routine will read all duplicate scans and delete those that are
C  unnecessary based on 4 criteria:
C    (1) take the one with the latest processing date
C    (2) take the one with the highest quality factor
C    (3) take the one with the highest signal-to-noise ratio
C    (4) take the one with the most data.
C  Also if EXPNUM > 0 will select scans based on experiment number
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'TFILE.INC'
      CHARACTER TLIN(NUMLIN)*512, QCODE*1, EXPCOD*4,
     *   ALPNUM*36
      INTEGER   ILINE, KLINE, BASE, B1, I, FLINE, QINDEX(500),
     *   NLINE, NL, K, LACC, CORCOD(500), CMAX, YR(500),
     *   DLEN(500), NUMEXP, YMAX,
     *   PI(100)
      REAL      TIME, T1
      REAL  SNR(500), SNRMAX
      DOUBLE PRECISION PTIME(500), TMAX
      LOGICAL   EOF
      INCLUDE 'INCS:DMSG.INC'
      DATA ALPNUM /'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
C-----------------------------------------------------------------------
C                                        Message to user
      IF (EXPNUM.GT.0) THEN
         WRITE (MSGTXT,1140) EXPNUM
         CALL MSGWRT (6)
         END IF
      IF (APARM(1).EQ.1.0) WRITE (MSGTXT,1100)
      IF (APARM(1).EQ.2.0) WRITE (MSGTXT,1110)
      IF (APARM(1).EQ.3.0) WRITE (MSGTXT,1120)
      IF (APARM(1).EQ.4.0) WRITE (MSGTXT,1130)
      CALL MSGWRT (6)
C                                        Read until time and/or
C                                        baseline changes.
      ILINE = 0
      KLINE = 0
      IERR = 0
      NL = NUMLIN
      CALL FILL (NL, 1, AINDEX)
      EOF = .FALSE.
      TIME = -1.0
      BASE = -1
C
 100  CONTINUE
      ILINE = ILINE + 1
      KLINE = KLINE + 1
      IF (ILINE.GT.TOTLIN) GO TO 200
      TLIN(ILINE) = LINE(ILINE)
C
      CALL UINDEX (TLIN(ILINE), PI)
C
      IF (KLINE.EQ.1) THEN
         FLINE = ILINE
         CALL TIMCRK (TLIN(ILINE)(PI(11):), TIME)
         CALL BASCRK (TLIN(ILINE)(PI(14):), BASE)
         END IF
      CALL TIMCRK (TLIN(ILINE)(PI(11):), T1)
      CALL BASCRK (TLIN(ILINE)(PI(14):), B1)
      IF ((T1.GT.TIME) .OR. (B1.NE.BASE)) GO TO 200
C                                        Special case for last line
      IF (ILINE.EQ.TOTLIN) THEN
C                                        Check experiment number
         IF (EXPNUM.GT.0) THEN
            EXPCOD = TLIN(ILINE)(PI(8):)
            READ (EXPCOD,2000) NUMEXP
            IF (NUMEXP.NE.EXPNUM) AINDEX(ILINE) = 0
            END IF
         END IF
      GO TO 100
C                                        Do the editing.
 200  NLINE = KLINE - 1 + FLINE - 1
      KLINE = 0
      ILINE = ILINE - 1
C                                        Check for processing date,
C                                        choose latest
      IF (APARM(1).EQ.1.0) THEN
         K = 0
         LACC = FLINE
         TMAX = -1.0D10
         YMAX = -1
         CMAX = -1
         DO 250 I = FLINE, NLINE
            K = K + 1
            CALL UINDEX (TLIN(I), PI)
            CALL PROCDT (TLIN(I)(PI(9):), YR(K), PTIME(K), CORCOD(K))
            AINDEX(I) = 0
            IF (YR(K).EQ.YMAX) THEN
               IF (PTIME(K).GT.TMAX) THEN
                  TMAX = PTIME(K)
                  LACC = I
                  END IF
               END IF
C
            IF (YR(K).GT.YMAX) THEN
               YMAX = YR(K)
               TMAX = PTIME(K)
               LACC = I
               END IF
C
 250        CONTINUE
         AINDEX(LACC) = 1
         END IF
C                                        Check for quality factor,
C                                        choose highest
      IF (APARM(1).EQ.2.0) THEN
         K = 0
         LACC = FLINE
         YMAX = -1
         DO 300 I = FLINE, NLINE
            K = K + 1
            CALL UINDEX (TLIN(I), PI)
            QCODE = TLIN(I)((PI(14)+2):(PI(14)+2))
            QINDEX(K) = INDEX (ALPNUM,QCODE)
            IF (QINDEX(K).GT.10) QINDEX(K) = 1
            AINDEX(I) = 0
            IF (QINDEX(K).GT.YMAX) THEN
               YMAX = QINDEX(K)
               LACC = I
               END IF
 300        CONTINUE
         AINDEX(LACC) = 1
         END IF
C                                        Check for SNR
C                                        choose highest
      IF (APARM(1).EQ.3.0) THEN
         K = 0
         LACC = FLINE
         SNRMAX = 0.
         DO 350 I = FLINE, NLINE
            K = K + 1
            CALL UINDEX (TLIN(I), PI)
            CALL GETSNR (TLIN(I)(PI(18):), SNR(K))
            AINDEX(I) = 0
            IF (SNR(K).GT.SNRMAX) THEN
               SNRMAX = SNR(K)
               LACC = I
               END IF
 350        CONTINUE
         AINDEX(LACC) = 1
         END IF
C                                        Check for data length,
C                                        choose highest
      IF (APARM(1).EQ.4.0) THEN
         K = 0
         LACC = FLINE
         YMAX = -1
         DO 400 I = FLINE, NLINE
            K = K + 1
            CALL UINDEX (TLIN(I), PI)
            CALL GETLEN (TLIN(I)(PI(6):), DLEN(K))
            AINDEX(I) = 0
            IF (DLEN(K).GT.YMAX) THEN
               YMAX = DLEN(K)
               LACC = I
               END IF
 400        CONTINUE
         AINDEX(LACC) = 1
         END IF
C                                        Check experiment number
      IF (EXPNUM.GT.0) THEN
         DO 710 I = FLINE, NLINE
            CALL UINDEX (TLIN(I), PI)
            EXPCOD = TLIN(I)(PI(8):)
            READ (EXPCOD,2010) NUMEXP
            IF (NUMEXP.NE.EXPNUM) AINDEX(I) = 0
 710        CONTINUE
         END IF
C                                       don't go back if last line has
C                                       been encountered
C
      IF (ILINE.LT.TOTLIN) GO TO 100
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('Editing A-file based on last processing date')
 1110 FORMAT ('Editing A-file based on Quality Factor from FRNGE')
 1120 FORMAT ('Editing A-file based on Signal-to-Noise ratio')
 1130 FORMAT ('Editing A-file based on # seconds of data in scan')
 1140 FORMAT ('Selecting scans from experiment # ',I6)
 2000 FORMAT (I4)
 2010 FORMAT (I4)
      END
      SUBROUTINE TIMCRK (STRING, DAYS)
C-----------------------------------------------------------------------
C   Routine to crack the time from a character string
C   Input:
C     STRING       C*(*)       String containing time
C   Output:
C     DAYS         R           Time in days
C-----------------------------------------------------------------------
      CHARACTER STRING*(*), CTEMP*20
      REAL      DAYS, D, H, M, S
C-----------------------------------------------------------------------
      CTEMP = ' '
      CTEMP(1:3) = STRING(1:3)
      CTEMP(5:6) = STRING(5:6)
      CTEMP(8:9) = STRING(7:8)
      CTEMP(11:12) = STRING(9:10)
      READ (CTEMP,1000) D, H, M, S
1000  FORMAT (I3,I2,I2,I2)
      DAYS = D + (H/24.) + (M/(24.*60.)) + (S/(24.*60.*60.))
      RETURN
      END
      SUBROUTINE BASCRK (STRING, BASLN)
C-----------------------------------------------------------------------
C   Routine to crack the baseline from a character string, codify the
C   letters as numbers. BASLN = A*256 + B
C   Input:
C     STRING       C*(*)       String containing baseline
C   Output:
C     BASLN        I        Baseline number
C-----------------------------------------------------------------------
      CHARACTER STRING*(*), A*1, B*1, ALPHA*26
      INTEGER   BASLN, I, J
      DATA ALPHA /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
C-----------------------------------------------------------------------
      A = STRING(1:1)
      B = STRING(2:2)
      I = INDEX(ALPHA,A)
      J = INDEX(ALPHA,B)
      BASLN = J + 256*I
      RETURN
      END
      SUBROUTINE PROCDT (STRING, YR, TIME, CORCOD)
C-----------------------------------------------------------------------
C   Routine to determine the processing date and COREL version.
C   Input:
C     STRING       C*(*)       String.
C   Output:
C     YR           I           Year of correlation
C     TIME         D           Time of processing (years)
C     CORCOD       I           Corel version (number = letter)
C-----------------------------------------------------------------------
      CHARACTER STRING*(*), ALPHA*26
      REAL      D, H, M
      INTEGER   CORCOD, YR
      DOUBLE PRECISION TIME
      DATA ALPHA /'abcdefghijklmnopqrstuvwxyz'/
C-----------------------------------------------------------------------
      READ (STRING(1:2), '(I2)') YR
      READ (STRING(3:5), '(I3)') D
      IF (STRING(6:6).EQ.' ') CORCOD = 0
      IF (STRING(6:6).NE.' ') CORCOD = INDEX (ALPHA,STRING (6:6))
      READ (STRING(7:8), '(I2)') H
      READ (STRING(9:10), '(I2)') M
      TIME = D + (H/24.) + (M/(24.*60.))
      END
      SUBROUTINE GETSNR (STRING, SNR)
C-----------------------------------------------------------------------
C   Routine to extract the SNR.
C   Input:
C     STRING       C*(*)       String.
C   Output:
C     SNR          I           SNR
C-----------------------------------------------------------------------
      CHARACTER STRING*(*), CTEMP*4
      REAL      SNR
C-----------------------------------------------------------------------
      CTEMP = STRING(1:4)
      READ (CTEMP,1000) SNR
1000  FORMAT (F10.5)
      RETURN
      END
      SUBROUTINE GETLEN (STRING, LEN)
C-----------------------------------------------------------------------
C   Routine to extract the LEN.
C   Input:
C     STRING       C*(*)       String.
C   Output:
C     LEN          I           LEN
C-----------------------------------------------------------------------
      CHARACTER STRING*(*), CTEMP*4
      INTEGER   LEN
C-----------------------------------------------------------------------
      CTEMP = STRING(1:4)
      READ (CTEMP,1000) LEN
1000  FORMAT (I4)
      RETURN
      END
      SUBROUTINE UINDEX (LINE,PI)
C--------------------------------------------------------------------------
C     Utility to parse a line of text containing data fields.
C     Returns pointers to the data items (strings).
C     We assume that the first character in line is non-blank !
C
C     Input:  CHARACTER   LINE*512   A single line of text
C     Output: INTEGER     PI(*)      Pointer to data field
C--------------------------------------------------------------------------
      CHARACTER LINE*512, CTEMP
      INTEGER   PI(*)
      INTEGER   MAXL, I, PTR1, PTR2
C--------------------------------------------------------------------------
C                                      Initialize
      MAXL = 512
      PTR1 = 1
      I    = 0
C                                      Next data item
 50   I = I + 1
      PTR2 = 0
      PI(I) = PTR1
C                                      Read a single char from line
100   CTEMP = LINE (PTR1:)
      PTR1 = PTR1 + 1
      PTR2 = PTR2 + 1
C                                      Blank means end of string
      IF (CTEMP.NE.' ') GO TO 100
C                                      End of line ?
200   IF (PTR1.GE.MAXL) GO TO 300
C                                      There could be contiguos blanks
C                                      between data fields
      CTEMP = LINE (PTR1:)
      PTR1 = PTR1 + 1
C                                      Non-blank means next data item
      IF (CTEMP.EQ.' ') GO TO 200
C                                      Adjust pointer to next data
      PTR1 = PTR1 - 1
      GO TO 50
C                                      Found last data item
300   RETURN
      END

      SUBROUTINE POLSET (IERR)
C-----------------------------------------------------------------------
C! Fills polarization correction table from info in AN table.
C# UV EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2007, 2010, 2012, 2014-2015, 2017-2018,
C;  Copyright (C) 2021-2022, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Fills polarization correction table from info in AN table.
C   Inputs from common
C      STNEPL   R(2,*)   Feed real/elipticity (poln, IF)
C      STNORI   R(2,*)   Feed imag/orientation (poln, IF)
C      STNPST   C*8      Feed solution type:
C                           'APPROX  ' => linear approximation
C                           'ORI-ELP ' => orientation-ellipticity
C                           'X-Y LIN ' => lin. approx. for lin.
C                              polarized (X-Y) data.
C                           'VLBI' => lin. approx for VLBI.
C   Output:
C      IERR    I         Return error code, 0=>OK else error.
C                        1=table too small, 2=multiple subarrays,
C                        5=FREQID incompatibility
C                        10 = unknown polarization parameterization,
C                        otherwise GETANT error.
C   Output to common /CPLINF/:
C      PARTIM  R         Time of current parallactic angles. (-1.0E10)
C      PARSOU  I         Source ID for current parallactic angles. (-10)
C      PREFA   I         Poln. ref antenna 'ORI-' only
C      POLPD   R(if)    'R-L' phase difference 'ORI-' only
C                            Nchan * Nif in line case
C      POLCAL  R(2,*)    Polarization correction
C                        Values in order:
C                        By baseline
C                           By IF (EIF-BIF+1)
C                              A 4x4 complex matrix to be multiplied by
C                                  the observed polarization vector
C                                  (RR,LL,RL,LR) to produce the
C                                  corrected data.
C                       Indexing scheme: an entry defined by ant1<ant2
C                       starts in element:
C         (((ant1-1)*numant-((ant1+1)*ant1)/2 + ant2) - 1) + 1
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER CHSTYP(5)*8, PDSTYP*8
      INTEGER   IIF, IANT1, IANT2, LIMIT, BLNDX, LIMIT2, KK, BLPNT,
     *   LENTRY, II, NUMBER, IALUN, IPDRNO, SUBA, PDKOLS(9), PDNUMV(9),
     *   PDBUFF(512), FREQID, REFANT(2), NWORDS, ICH, KR1, KR2, KL1,
     *   KL2, LUNTMP, KL
      REAL      PHDIFF(MAXCIF), DTEMP(2,MAXCIF), RLMAT(2,16)
      COMPLEX   DR1, DR2, DL1, DL2, BLMAT(4,4)
      LONGINT   PDPTR, POLPTR
      EQUIVALENCE (BLMAT, RLMAT)
      SAVE PHDIFF, DTEMP
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DPDC.INC'
      DATA CHSTYP /'APPROX  ','ORI-ELP','X-Y LIN ', 'VLBI', 'V-H LIN '/
C-----------------------------------------------------------------------
C                                       Initialize parallactic angle
C                                       time, source
      PARTIM = -1.0E10
      PARSOU = -10
C                                       Only 1 subarray
      IF (SUBARR.EQ.0) THEN
         IERR = 2
         MSGTXT = 'ERROR: CAN ONLY DO POLARIZATION CORRECTION FOR 1 '
     *      // 'SUBARRAY'
         GO TO 990
         END IF
C                                       Get antenna info
      CALL GETANT (IUDISK, IUCNO, SUBARR, CATUV, POLCAL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       line or continuum
      IF (MOD(DOPOL,10).LT.6) THEN
         CALL FNDEXT ('PD', CATUV, II)
         IF ((PDVER.GT.II) .OR. (PDVER.LE.0)) PDVER = II
      ELSE
         PDVER = 0
         END IF
C                                       Check FREQID compatibility
      IF ((FQIDAN.GT.0) .AND. (FRQSEL.GT.0) .AND. (FQIDAN.NE.FRQSEL)
     *   .AND. (PDVER.LE.0)) THEN
         MSGTXT = 'WARNING - POTENTIAL FATAL ERROR'
         CALL MSGWRT (8)
         MSGTXT = '  The polarization information in your AN table'
         CALL MSGWRT (8)
         WRITE (MSGTXT,1050) FQIDAN
         CALL MSGWRT (8)
         WRITE (MSGTXT,1060) FRQSEL
         CALL MSGWRT (8)
         IERR = 5
         GO TO 999
         END IF
C                                       get PD data
      IF (PDVER.GT.0) THEN
         IALUN = LUNTMP (1)
         CALL PDINI ('READ', PDBUFF, IUDISK, IUCNO, PDVER, CATUV, IALUN,
     *      IPDRNO, PDKOLS, PDNUMV, PDNUMA, PDNUMP, PDNUMI, PDNUMF,
     *      PDSTYP, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPENING PD TABLE'
            GO TO 990
            END IF
         NWORDS = 2 * PDNUMF * PDNUMI * PDNUMP * PDNUMA + 2048
         NWORDS = (NWORDS - 1) / 1024 + 1
         CALL ZMEMRY ('GET ', 'POLSET', NWORDS, DTERMS, PDTERM, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'FAILED TO GET REQUESTED MEMORY FOR PD FILE'
            GO TO 990
            END IF
         LIMIT = PDBUFF(5)
         KK = 2 * PDNUMF * PDNUMI * PDNUMP
         DO 20 II = 1,LIMIT
            CALL TABPD ('READ', PDBUFF, IPDRNO, PDKOLS, PDNUMV, PDNUMI,
     *         PDNUMF, PDNUMP, IANT1, SUBA, FREQID, REFANT, PHDIFF,
     *         DTEMP, IERR)
            IF (IERR.GT.0) THEN
               WRITE (MSGTXT,1000) IERR, 'READ PD FILE'
               GO TO 990
               END IF
            IF (IERR.EQ.-4) GO TO 20
            IF ((SUBARR.GT.0) .AND. (SUBA.GT.0) .AND.
     *         (SUBA.NE.SUBARR)) GO TO 20
            IF ((FRQSEL.GT.0) .AND. (FREQID.GT.0) .AND.
     *         (FREQID.NE.FRQSEL)) GO TO 20
            PDPTR = 1 + PDTERM + (IANT1-1) * KK
            CALL RCOPY (KK, DTEMP, DTERMS(PDPTR))
            PREFA = REFANT(1)
            IF ((IANT1.EQ.PREFA) .AND. (SOLTYP.EQ.2)) THEN
               KL = PDNUMF * PDNUMI
               CALL RCOPY (KL, PHDIFF, POLPD)
               END IF
 20         CONTINUE
         CALL TABPD ('CLOS', PDBUFF, IPDRNO, PDKOLS, PDNUMV, PDNUMI,
     *      PDNUMF, PDNUMP, IANT1, SUBA, FREQID, REFANT, PHDIFF,
     *      DTEMP, KK)
         STNPST = PDSTYP
      ELSE
         PDNUMF = 1
         END IF
C                                       Determine solution type:
      SOLTYP = 0
      IF (STNPST.EQ.CHSTYP(1)) SOLTYP = 1
      IF (STNPST.EQ.CHSTYP(2)) SOLTYP = 2
      IF (STNPST.EQ.CHSTYP(3)) SOLTYP = 3
      IF (STNPST.EQ.CHSTYP(4)) SOLTYP = 4
      IF (STNPST.EQ.CHSTYP(5)) SOLTYP = 1
C                                       Unknown solution type
      IF (SOLTYP.EQ.0) THEN
         MSGTXT = 'UNKNOWN POLARIZATION PARAMETERIZATION =''' //
     *      STNPST // ''''
         IERR = 10
         CALL MSGWRT (8)
         MSGTXT = 'NO USABLE POLCAL INFORMATION AVAILABLE IN AN TABLE'
         CALL MSGWRT (8)
         MSGTXT = 'PERHAPS DOPOL SHOULD BE FALSE'
         GO TO 990
         END IF
C                                       Get reference antenna, phase
C                                       differences if any from AN
C                                       table. 'ORI-' only
      IF ((SOLTYP.EQ.2) .AND. (PDVER.LE.0)) THEN
         IALUN = LUNTMP (1)
         CALL PDRGET (IUDISK, IUCNO, SUBARR, IALUN, CATUV, EIF,
     *      PREFA, POLPD, PDBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       create memory for POLCAL
      PCLIF = EIF - BIF + 1
      PCLCH = 1
      IF (PDVER.GT.0) PCLCH = ECHANS - BCHANS + 1
      NUMBER = (NSTNS * (NSTNS+1)) / 2
      NWORDS = 32 * PCLIF * PCLCH * NUMBER
      NWORDS = (NWORDS - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', 'POLSET', NWORDS, POLCAL, PPOLCL, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'FAILED TO GET REQUESTED MEMORY FOR POLCAL'
         GO TO 990
         END IF
C                                       Do only continuum 'APPR' here
      IF (SOLTYP.NE.1) GO TO 999
      IERR = 0
      CALL RFILL (32, 0.0, BLMAT)
      DO 30 II = 1,4
         BLMAT(II,II) = CMPLX (1.0, 0.0)
 30      CONTINUE
C                                       Compute correction matrices.
      LENTRY = PCLIF * PCLCH * 32
      LIMIT = NSTNS - 1
      DO 200 IANT1 = 1,LIMIT
         LIMIT2 = IANT1 + 1
         DO 190 IANT2 = LIMIT2,NSTNS
C                                       Set baseline index
            BLNDX = ((IANT1-1)*NSTNS) - (((IANT1-1)*IANT1)/2) + IANT2
C                                       Loop over IF: continuum
            IF (PDVER.LE.0) THEN
               DO 110 IIF = BIF,EIF
C                                       Linear approximation:
                  IF ((STNELP(1,IIF,IANT1).EQ.FBLANK) .OR.
     *               (STNELP(2,IIF,IANT1).EQ.FBLANK) .OR.
     *               (STNELP(1,IIF,IANT2).EQ.FBLANK) .OR.
     *               (STNELP(2,IIF,IANT2).EQ.FBLANK) .OR.
     *               (STNORI(1,IIF,IANT1).EQ.FBLANK) .OR.
     *               (STNORI(2,IIF,IANT1).EQ.FBLANK) .OR.
     *               (STNORI(1,IIF,IANT2).EQ.FBLANK) .OR.
     *               (STNORI(2,IIF,IANT2).EQ.FBLANK)) THEN
                     BLMAT(3,1) = CMPLX (FBLANK, 0.0)
                     BLMAT(3,2) = CMPLX (FBLANK, 0.0)
                     BLMAT(4,1) = CMPLX (FBLANK, 0.0)
                     BLMAT(4,2) = CMPLX (FBLANK, 0.0)
                  ELSE
                     DR1 = CMPLX (STNELP(1,IIF,IANT1),
     *                  STNORI(1,IIF,IANT1))
                     DL1 = CMPLX (STNELP(2,IIF,IANT1),
     *                  STNORI(2,IIF,IANT1))
                     DR2 = CMPLX (STNELP(1,IIF,IANT2),
     *                  STNORI(1,IIF,IANT2))
                     DL2 = CMPLX (STNELP(2,IIF,IANT2),
     *                  STNORI(2,IIF,IANT2))
                     BLMAT(3,1) = -0.5 * (DR1 + CONJG (DL2))
                     BLMAT(3,2) = BLMAT(3,1)
                     BLMAT(4,1) = -0.5 * (DL1 + CONJG (DR2))
                     BLMAT(4,2) = BLMAT(4,1)
                     END IF
                  BLPNT = (LENTRY * (BLNDX-1)) + (IIF-BIF) * 32 + 1
                  POLPTR = PPOLCL + BLPNT
                  CALL RCOPY (32, RLMAT, POLCAL(POLPTR))
 110              CONTINUE
C                                       spectral and IF: line
            ELSE
               DO 130 IIF = BIF,EIF
                  KR1 = (4 * PDNUMF * PDNUMI) * (IANT1 - 1) +
     *               2 * PDNUMF * (IIF - 1) + 2 * (BCHANS -1) + 1
                  KR2 = (4 * PDNUMF * PDNUMI) * (IANT2 - 1) +
     *               2 * PDNUMF * (IIF - 1) + 2 * (BCHANS -1) + 1
                  KL1 = KR1 + (2 * PDNUMF * PDNUMI)
                  KL2 = KR2 + (2 * PDNUMF * PDNUMI)
                  BLPNT = LENTRY * (BLNDX-1) + (IIF-BIF)*32*PCLCH
                  POLPTR = PPOLCL + BLPNT + 1
                  DO 120 ICH = BCHANS,ECHANS
                     IF ((DTERMS(PDTERM+KR1).EQ.FBLANK) .OR.
     *                  (DTERMS(PDTERM+KR1+1).EQ.FBLANK) .OR.
     *                  (DTERMS(PDTERM+KL1).EQ.FBLANK) .OR.
     *                  (DTERMS(PDTERM+KL1+1).EQ.FBLANK) .OR.
     *                  (DTERMS(PDTERM+KR2).EQ.FBLANK) .OR.
     *                  (DTERMS(PDTERM+KR2+1).EQ.FBLANK) .OR.
     *                  (DTERMS(PDTERM+KL2).EQ.FBLANK) .OR.
     *                  (DTERMS(PDTERM+KL2+1).EQ.FBLANK)) THEN
                        BLMAT(3,1) = CMPLX (FBLANK, 0.0)
                        BLMAT(3,2) = CMPLX (FBLANK, 0.0)
                        BLMAT(4,1) = CMPLX (FBLANK, 0.0)
                        BLMAT(4,2) = CMPLX (FBLANK, 0.0)
                     ELSE
                        DR1 = CMPLX (DTERMS(PDTERM+KR1),
     *                     DTERMS(PDTERM+KR1+1))
                        DL1 = CMPLX (DTERMS(PDTERM+KL1),
     *                     DTERMS(PDTERM+KL1+1))
                        DR2 = CMPLX (DTERMS(PDTERM+KR2),
     *                     DTERMS(PDTERM+KR2+1))
                        DL2 = CMPLX (DTERMS(PDTERM+KL2),
     *                     DTERMS(PDTERM+KL2+1))
                        BLMAT(3,1) = -0.5 * (DR1 + CONJG (DL2))
                        BLMAT(3,2) = BLMAT(3,1)
                        BLMAT(4,1) = -0.5 * (DL1 + CONJG (DR2))
                        BLMAT(4,2) = BLMAT(4,1)
                        END IF
                     CALL RCOPY (32, RLMAT, POLCAL(POLPTR))
                     KR1 = KR1 + 2
                     KL1 = KL1 + 2
                     KR2 = KR2 + 2
                     KL2 = KL2 + 2
                     POLPTR = POLPTR + 32
 120                 CONTINUE
 130              CONTINUE
               END IF
 190        CONTINUE
 200     CONTINUE
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('POLSET ERROR',I4,' ON ',A)
 1050 FORMAT ('  was set with FREQID ',I3,' this is being applied')
 1060 FORMAT ('  to FREQID ',I3,' data. Suggest you rerun PCAL')
      END

LOCAL INCLUDE 'MASKS.INC'
      INCLUDE 'INCS:PCLN.INC'
      HOLLERITH XNAMEI(3), XCLASI(2), XNAMEO(3), XCLASO(2), XBXFIL(12)
      REAL      XDISKI, XSEQI, XDISKO, XSEQO, DOBLNK, DONUMB
      COMMON /INPARM/ XNAMEI, XCLASI, XSEQI, XDISKI, XNAMEO, XCLASO,
     *   XSEQO, XDISKO, XBXFIL, DOBLNK, DONUMB
C
      INTEGER   SEQIN, DISKIN, CNOIN, CNOOU,  SEQOU, DISKOU, SCRTCH(256)
      CHARACTER BOXFIL*48, NAMEIN*12, CLASIN*6, NAMEOU*12, CLASOU*6
      COMMON /SETFCP/ SEQIN, DISKIN, CNOIN, SEQOU, DISKOU, CNOOU
      COMMON /SETFCC/ BOXFIL, NAMEIN, CLASIN, NAMEOU, CLASOU
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
LOCAL END
      PROGRAM MASKS
C-----------------------------------------------------------------------
C! read a BOXFILE to make images of the Clean boxes
C# Imaging
C-----------------------------------------------------------------------
C;  Copyright (C) 2020
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MASKS makes images from an input BOXFILE of Clean boxes
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME       XNAMEI/NAMEIN    Name of input UV data.
C      INSEQ        SEQ/SEQIN        Seq. of input UV data.
C      INDISK       DISKIN/IDISK     Disk number of input UV data.
C      BOXFILE      XBXFIL/BOXFIL    BOXFILE output file name.
C      CELLSIZE     CELSIZ           pixel size in image.
C      IMSIZE       XSIZE/IMSIZE     image size, also field size.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PCLN.INC'
      INCLUDE 'MASKS.INC'
      INTEGER   IRET, NFIELD, NBOXES(MAXFLD), WIN(4,MXNBFL)
C-----------------------------------------------------------------------
C                                       init and read BOXFILE
      CALL MASKIN (NFIELD, NBOXES, WIN, IRET)
C                                       make images
      IF (IRET.EQ.0) CALL MASKDO (NFIELD, NBOXES, WIN, IRET)
C
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE MASKIN (NFIELD, NBOXES, WIN, IRET)
C-----------------------------------------------------------------------
C   Input routine - reads BOXFILE returning parameters
C   Output:
C      NFIELD   I        1
C      NBOXES   I(*)     Max box number in field
C      WIN      I(4,*)   Box pixel numbers
C-----------------------------------------------------------------------
      INTEGER   NFIELD, NBOXES(*), WIN(4,*), IRET
C
      INTEGER   NPARMS, IERR, CATOLD(256), IMSIZE(2)
      REAL      S
      CHARACTER PNAM*6, MTYPE*2, BLANK*6, STAT*4
      INCLUDE 'MASKS.INC'
      DATA PNAM /'MASKS'/
      DATA BLANK /' '/
C-----------------------------------------------------------------------
C                                       initialize
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Initialize HITAB
      CALL HIINIT (3)
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       get the input parameters
      NPARMS = 28
      CALL GTPARM (PNAM, NPARMS, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         RQUICK = .FALSE.
         IF (IERR.EQ.1) THEN
            MSGTXT = 'CANNOT FIND INITIATOR IN GTPARM'
            CALL MSGWRT (1)
            GO TO 999
         ELSE
            MSGTXT= 'DISK PROBLEMS IN GTPARM'
            CALL MSGWRT (6)
            GO TO 999
            END IF
         END IF
      IRET = 0
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
C                                       set parameters
      CALL H2CHR (48, 1, XBXFIL, BOXFIL)
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (12, 1, XNAMEO, NAMEOU)
      CALL H2CHR (6, 1, XCLASI, CLASIN)
      CALL H2CHR (6, 1, XCLASO, CLASOU)
      SEQIN = XSEQI + 0.5
      DISKIN = XDISKI + 0.5
      SEQOU = XSEQO + 0.5
      DISKOU = XDISKO + 0.5
C                                       Create new file.
C                                       Get CATBLK from old file.
      CNOIN = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLASIN, SEQIN, MTYPE,
     *   NLUSER, STAT, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET, NAMEIN, CLASIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DISKIN, CNOIN, CATOLD, 'READ', SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING IMAGE HEADER'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 0
C                                       Copy old CATBLK to new.
      CALL COPY (256, CATOLD, CATBLK)
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLASIN, SEQIN, BLANK, NAMEOU, CLASOU, SEQOU)
      CALL CHR2H (12, NAMEOU, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLASOU, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOU
C                                       General header parms
      CATR(KRDMN) = 0.0
      CATR(KRDMX) = 2.0
      IF (DONUMB.GT.0.0) CATR(KRDMX) = 3.0
      IF (DONUMB.LT.-1.0) CATR(KRDMX) = 1.0
      S = FBLANK
      IF (DOBLNK.LE.0.0) S = 0.0
      CATR(KRBLK) = S
C                                       Create output file.
      CNOOU = 1
      CALL MCREAT (DISKOU, CNOOU, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATING OUTPUT IMAGE'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKOU
      FCNO(NCFILE) = CNOOU
      FRW(NCFILE) = 2
      IRET = 0
      SEQOU = CATBLK(KIIMS)
C                                       read boxfile for Clean windows
      NFIELD = 1
      IMSIZE(1) = CATBLK(KINAX)
      IMSIZE(2) = CATBLK(KINAX+1)
      CALL WINDF (WIN, NBOXES, NFIELD, IMSIZE, BOXFIL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING BOXFILE'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MASKIN ERROR',I5,' ON ',A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
      END
      SUBROUTINE MASKDO (NFIELD, NBOXES, WIN, IRET)
C-----------------------------------------------------------------------
C   Makes images
C   Input:
C      NFIELD   I        Max field number
C      NBOXES   I(*)     Max box number in field
C      WIN      I(4,*)   Box pixel numbers
C   Output:
C      IRET     I        Error code
C-----------------------------------------------------------------------
      INTEGER   NFIELD, NBOXES(*), WIN(4,NFIELD,*), IRET
C
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   NX, NY, IY, IFIELD, I, LUN, FIND, IWIN(4), NBY, IBLKOF,
     *   POS, J, JO, HLUN, HBUF(256), DATE(3), TIME(3), NC, IXC, IYC, LF
      CHARACTER OBJ*8, OBS*8, MTYPE*2, CDATE*12, CTIME*8, HILINE*72,
     *   BUN*8, TEL*8, FLDC*4
      REAL      BUFF(MABFSS), X, S, EDGE
      INCLUDE 'MASKS.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA OBJ, OBS, BUN, TEL /'TESTFACE','MASKS','JY/BEAM','AIPS'/
      DATA LUN, IBLKOF, HLUN /16, 1, 17/
C-----------------------------------------------------------------------
      EDGE = 2.0
      IF (DONUMB.LT.-1.0) EDGE = 1.0
      NBY = 2 * MABFSS
      FLDC = '1'
      NC = 1
C                                       General header parms
      S = FBLANK
      IF (DOBLNK.LE.0.0) S = 0.0
      LF = 0
      IF (DONUMB.GT.0) LF = 1
      NX = CATBLK(KINAX)
      NY = CATBLK(KINAX+1)
C                                       loop over fields (images)
      DO 100 IFIELD = 1,NFIELD
C                                       Open new file.
         MTYPE = 'MA'
         CALL MAPOPN ('INIT', DISKOU, NAMEOU, CLASOU, SEQOU, MTYPE,
     *      NLUSER, LUN, FIND, CNOOU, CATBLK, SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN', IFIELD
            GO TO 990
            END IF
C                                       Window for output file
         IWIN(1) = 1
         IWIN(2) = 1
         IWIN(3) = NX
         IWIN(4) = NY
         CALL MINIT ('WRIT', LUN, FIND, NX, NY, IWIN, BUFF, NBY,
     *      IBLKOF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INITIALIZ', IFIELD
            GO TO 990
            END IF
         DO 50 IY = 1,NY
C                                       "write" before data
            CALL MDISK ('WRIT', LUN, FIND, BUFF, POS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRIT', IFIELD
               GO TO 980
               END IF
            CALL RFILL (NX, S, BUFF(POS))
            DO 30 I = 1,NBOXES(IFIELD)
C                                       rectangles
               IF (WIN(1,IFIELD,I).GT.0) THEN
                  IF ((IY.GE.WIN(2,IFIELD,I)) .AND.
     *               (IY.LE.WIN(4,IFIELD,I))) THEN
                     JO = WIN(1,IFIELD,I)
                     J = WIN(3,IFIELD,I) - JO + 1
                     IYC = (WIN(2,IFIELD,I) + WIN(4,IFIELD,I)) / 2
                     IXC = (WIN(1,IFIELD,I) + WIN(3,IFIELD,I)) / 2
                  ELSE
                     J = 0
                     END IF
C                                       circles
               ELSE
                  J = ABS(IY-WIN(4,IFIELD,I))
                  IF (J.LE.WIN(2,IFIELD,I)) THEN
                     X = SQRT (REAL(WIN(2,IFIELD,I))**2 - J*J)
                     IXC = WIN(3,IFIELD,I)
                     IYC = WIN(4,IFIELD,I)
                     J = IXC + X
                     JO = 2 * IXC - J
                     J = J - JO + 1
                  ELSE
                     J = 0
                     END IF
                  END IF
               IF (J.GT.0) THEN
                  JO = JO  + POS - 1
                  CALL RFILL (J, 1.0, BUFF(JO))
                  BUFF(JO) = EDGE
                  BUFF(JO+J-1) = EDGE
                  IF ((WIN(1,IFIELD,I).GT.0) .AND.
     *               ((IY.EQ.WIN(2,IFIELD,I)) .OR.
     *               (IY.EQ.WIN(4,IFIELD,I))))
     *               CALL RFILL (J, EDGE, BUFF(JO))
                  IF (DONUMB.GT.0.0) THEN
                     IF ((ABS(IY-IYC)/LF.LE.3) .AND. (J.GE.7*NC*LF)
     *                  .AND. (JO-POS+1.LE.IXC-(7*NC*LF)/2)) THEN
                        JO = IXC - (7*NC*LF)/2 + POS - 1
                        J = (IY - IYC + 4*LF + 1) / LF
                        CALL CHKCHR (FLDC, NC, LF, J, BUFF(JO))
                     ELSE IF ((ABS(IY-IYC).LE.3) .AND. (J.GE.7*NC)
     *                  .AND. (JO-POS+1.LE.IXC-(7*NC)/2)) THEN
                        JO = IXC - (7*NC)/2 + POS - 1
                        J = (IY - IYC + 4 + 1)
                        CALL CHKCHR (FLDC, NC, 1, J, BUFF(JO))
                        END IF
                     END IF
                  END IF
 30            CONTINUE
 50         CONTINUE
C                                       write last of data
         CALL MDISK ('FINI', LUN, FIND, BUFF, POS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'FINISH', IFIELD
            GO TO 980
            END IF
C                                       Fake up history
         CALL HICREA (HLUN, DISKOU, CNOOU, CATBLK, HBUF, IRET)
C                                       Write time and date on new file
         IF (IRET.EQ.0) THEN
            CALL ZDATE (DATE)
            CALL ZTIME (TIME)
            CALL TIMDAT (TIME, DATE, CTIME, CDATE)
            WRITE (HILINE,1050) TSKNAM, RLSNAM, CDATE, CTIME
            CALL HIADD (HLUN, HILINE, HBUF, IRET)
            END IF
         IF (IRET.EQ.0) CALL HENCOO (TSKNAM, NAMEOU, CLASOU, SEQOU,
     *      DISKOU, HLUN, HBUF, IRET)
         IF (IRET.EQ.0) THEN
            WRITE (HILINE,1055) TSKNAM, IFIELD, BOXFIL(:47)
            CALL HIADD (HLUN, HILINE, HBUF, IRET)
            END IF
         CALL HICLOS (HLUN, .TRUE., HBUF, IRET)
         IRET = 0
C                                       Close image
         CALL MAPCLS ('INIT', DISKOU, CNOOU, LUN, FIND, CATBLK, .TRUE.,
     *      BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOS', IFIELD
            GO TO 990
            END IF
 100     CONTINUE
      NCFILE = NCFILE - 1
      GO TO 999
C
 980  CALL ZCLOSE (LUN, FIND, I)
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I6,1X,A,'ING IMAGE',I4)
 1050 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',A12,2X,A8)
 1055 FORMAT (A6,'FIELD=',I4,' BOXFILE=',A)
      END
      SUBROUTINE CHKCHR (STR, NC, LF, IY, BUFF)
C-----------------------------------------------------------------------
C   CHKCHR inserts characters into the data buffer 1 pixel row at a
C   time
C   Inputs:
C      STR    C*(*)   Character string
C      NC     I       Number of characters in STR
C      LF     I       Repetition factor
C      IY     I       Pixel number vertically within character string
C   Output:
C      BUFF   R(*)    Data buffer
C-----------------------------------------------------------------------
      CHARACTER STR*(*)
      INTEGER   NC, LF, IY
      REAL      BUFF(*)
C
      INTEGER   I, JT, LT, KT, BITS(15), SCRTCH(20), IDX, II, JJ,
     *   MASK, ZAND, TABLE(5,97), TAB2(5,17), TAB3(5,16), TAB4(5,16),
     *   TAB5(5,16), TAB6(5,16), TAB7(5,16), IT, IC, J
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE  (TABLE(1, 1), TAB2),  (TABLE(1,18), TAB3),
     *             (TABLE(1,34), TAB4),  (TABLE(1,50), TAB5),
     *             (TABLE(1,66), TAB6),  (TABLE(1,82), TAB7)
C                                        control chars all ?
C                                        blank !"#$%&'()*+,-./
      DATA TAB2/  32,  64,  69,  72,  48,
     *             0,   0,   0,   0,   0,
     *             0,   0, 121,   0,   0,
     *             0, 112,   0, 112,   0,
     *            20,  62,  20,  62,  20,
     *            18,  42, 127,  42,  36,
     *             2,  36,   8,  18,  32,
     *            54,  73,  85,  34,   5,
     *             0,   0, 112,   0,   0,
     *             0,  28,  34,  65,   0,
     *             0,  65,  34,  28,   0,
     *            20,   8,  62,   8,  20,
     *             8,   8,  62,   8,   8,
     *             0,   1,   6,   0,   0,
     *             0,   8,   8,   8,   0,
     *             0,   0,   1,   0,   0,
     *             2,   4,   8,  16,  32/
C                                        0123456789:;<=>?
      DATA TAB3/  62,  69,  73,  81,  62,
     *             0,  33, 127,   1,   0,
     *            35,  69,  73,  73,  49,
     *            66,  65,  73,  89, 102,
     *            12,  20,  36, 127,   4,
     *           114,  81,  81,  81,  78,
     *            30,  41,  73,  73,  70,
     *            64,  71,  72,  80,  96,
     *            54,  73,  73,  73,  54,
     *            49,  73,  73,  74,  60,
     *             0,   0,  18,   0,   0,
     *             0,   1,  22,   0,   0,
     *             8,  20,  34,  65,   0,
     *            20,  20,  20,  20,   0,
     *            65,  34,  20,   8,   0,
     *            32,  64,  69,  72,  48/
C
C                                       ABCDEFGHIJKLMNO
      DATA TAB4/  18,  37,  37,  37,  30,
     *            31,  36,  68,  36,  31,
     *           127,  73,  73,  73,  34,
     *            62,  65,  65,  65,  34,
     *            65, 127,  65,  65,  62,
     *           127,  73,  73,  73,  65,
     *           127,  72,  72,  64,  64,
     *            62,  65,  65,  69,  39,
     *           127,   8,   8,   8, 127,
     *             0,  65, 127,  65,   0,
     *             2,   1,   1,   1, 126,
     *           127,   8,  20,  34,  65,
     *           127,   1,   1,   1,   1,
     *           127,  32,  24,  32, 127,
     *           127,  16,   8,   4, 127,
     *            62,  65,  65,  65,  62/
C                                        PQRSTUVWXYZ[\]^_
      DATA TAB5/ 127,  72,  72,  72,  48,
     *            62,  65,  69,  66,  61,
     *           127,  72,  76,  74,  49,
     *            50,  73,  73,  73,  38,
     *            64,  64, 127,  64,  64,
     *           126,   1,   1,   1, 126,
     *           112,  12,   3,  12, 112,
     *           126,   1,  14,   1, 126,
     *            99,  20,   8,  20,  99,
     *            96,  16,  15,  16,  96,
     *            67,  69,  73,  81,  97,
     *             0,   0, 127,  65,   0,
     *            32,  16,   8,   4,   2,
     *             0,  65, 127,   0,   0,
     *            16,  32,  64,  32,  16,
     *             1,   1,   1,   1,   1/
C                                        `abcdefghijklmno
      DATA TAB6/   0,  64,  32,  16,  0,
     *            31,  36,  68,  36,  31,
     *           127,  73,  73,  73,  34,
     *            62,  65,  65,  65,  34,
     *            65, 127,  65,  65,  62,
     *           127,  73,  73,  73,  65,
     *           127,  72,  72,  64,  64,
     *            62,  65,  65,  69,  39,
     *           127,   8,   8,   8, 127,
     *            65,  65, 127,  65,  65,
     *             2,   1,   1,   1, 126,
     *           127,   8,  20,  34,  65,
     *           127,   1,   1,   1,   1,
     *           127,  32,  24,  32, 127,
     *           127,  16,   8,   4, 127,
     *            62,  65,  65,  65,  62/
C                                        pqrstuvwxyz{ }~?
      DATA TAB7/ 127,  72,  72,  72,  48,
     *            62,  65,  69,  66,  61,
     *           127,  72,  76,  74,  49,
     *            50,  73,  73,  73,  38,
     *            64,  64, 127,  64,  64,
     *           126,   1,   1,   1, 126,
     *           112,  12,   3,  12, 112,
     *           126,   1,  14,   1, 126,
     *            99,  20,   8,  20,  99,
     *            96,  16,  15,  16,  96,
     *            67,  69,  73,  81,  97,
     *             0,   8,  54,  65,   0,
     *             0,   0, 127,   0,   0,
     *             0,  65,  54,   8,   0,
     *             4,   8,   4,   2,   4,
     *            32,  64,  69,  72,  48/
C-----------------------------------------------------------------------
      IDX = 1
      DO 20 I = 1,NC
C                                       get standard ASCII char
C                                       in highly machine independent
         JT = NBITWD / 8
         CALL ZCLC8 (1, STR(I:I), JT, LT)
         CALL ZI32IL (1, 1, LT, KT)
         IT = NBITWD - (JT-1)*8
         CALL ZGTBIT (IT, KT, BITS)
         CALL ZPTBIT (8, IC, BITS(IT-7))
C                                       all CTRL characters to 1
         IC = MAX (1, IC-30)
         CALL COPY (5, TABLE(1,IC), SCRTCH(IDX))
         IDX = IDX + 5
 20      CONTINUE
C                                       just the selected row
      MASK = 2 ** (IY-1)
      JJ = 1
      IDX = 1
C                                        if mask bit on in char value
C                                        then set to -1 else to 0
      DO 40 J = 1,NC
         IDX = IDX + LF
         DO 35 II = 1,5
            IC = ZAND (MASK, SCRTCH(JJ))
            DO 30 I = 1,LF
               IF ((IC.NE.0) .AND. (BUFF(IDX).NE.FBLANK)) BUFF(IDX) =
     *            3.0 * BUFF(IDX)
               IDX = IDX + 1
 30            CONTINUE
            JJ = JJ + 1
 35         CONTINUE
         IDX = IDX + LF
 40      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE AU6E (BRANCH)
C-----------------------------------------------------------------------
C! verbs to plot slices and models on graphics
C# POPS-appl Slice Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 2000, 2007-2009, 2012, 2014, 2016-2017, 2021, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Plot or replot slice file directly to the TV
C   Verbs:
C      BRANCH   I   6  TVSLICE  : plot slice file.
C                   7  TVASLICE : plot slice file but do not clear
C                                 screen or do labeling.
C                   8  TVMODEL  : plot gaussian model on TEK.
C                   9  TVAMODEL : plot model but do not label or clear.
C                  10  TVRESID  : plot residuals of data, model.
C                  11  TVARESID : plot residuals over current labeling.
C                  12  TVGUESS  : plot initial guess.
C                  13  TVAGUESS : plot initial guess on current graph.
C                  14  TVSET    : set guess parms for all components
C                  15  TV1SET   : set guess parms for 1 component
C                   1  TVCOMPS  : plot individual components
C                   2  TVACOMPS : plot components no label or clear
C   Common:  adverb values
C      INNAME   R(3)     name of primary file.
C      INCLASS  R(2)     class of primary file.
C      INSEQ    R        sequence number of primary file.
C      INDISK   R        disk volume number. 0 means try all.
C      INVER    R        version number of slice file, 0 means try
C                        latest version.
C      LTYPE    R        0=no labeling for plot, 1=standard.
C      PIXRANGE R(2)     the minimum and maximum values allowed for the
C                        plot All other values will be clipped If
C                        PIXRANGE(1) .GE. PIXRANGE(2) then the map max
C                        and min will be used.
C      BDROP    R        number of slice pts to drop from beginning
C                        of slice.
C      EDROP    R        number of slice pts to drop from end of slice.
C      NGAUSS   R        number of the gaussian model to print.
C                           (for TVMODEL, TVAMODEL only).
C      GPOS     R(2,4)   initial guess of position of gaussian
C                        components. (For TVGUESS, TVAGUESS only)
C      GMAX     R(4)     initial guess of max amplitude.
C                           (For TVGUESS, TVAGUESS only)
C      GWIDTH   R(3,4)   initial guess of half width.
C                           (For TVGUESS, TVAGUESS only)
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      CHARACTER NAMEIN*12, CLASIN*6, PRGNAM*6, TYPEIN*2, TEXT(2)*80,
     *   CDUM*1, CHTEMP*2
      REAL      CHR(4), BLC(7), TRC(7), XBLC(7), XTRC(7), RANGE2(2),
     *   XFAC, XOFF, RANGE(2), YGAP, RDUM(2), GM(4), GP(2,4),  GW(3,4),
     *   VAL, ARC, FQFINC
      INTEGER   IMLUN, IVOL, IERR, ISFIND, LABEL, ISLUN, IMFIND, IFMOD,
     *   IMOD, ISLOT, IUSER, IDROP(2), INGAUS, INPTS, ISEQ, ISVER,
     *   NTEXT, IDUM, POTERR, IRXTRA, ISTART, IEND, I, K, ZAND, ITEMP,
     *   IX, IY, IDEPTH(5)
      LOGICAL   T, F, NOSAVE, EXCL, WAIT
      DOUBLE PRECISION FQFREQ
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVS.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DTVC.INC'
      EQUIVALENCE (T, WAIT, EXCL),    (F, NOSAVE)
      DATA IMLUN, ISLUN /16,27/
      DATA F, T /.FALSE.,.TRUE./
      DATA PRGNAM /'AU9B  '/
C-----------------------------------------------------------------------
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.15)) GO TO 999
      IF ((BRANCH.GT.2) .AND. (BRANCH.LE.5)) GO TO 999
      POTERR = 101
      LOCNUM = 1
C                                       get adverbs
      CALL ADVERB ('GMAX', 'R', 4, 0, IDUM, GM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('GPOS', 'R', 8, 0, IDUM, GP, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('GWIDTH', 'R', 12, 0, IDUM, GW, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('NGAUSS', 'I', 1, 0, INGAUS, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      INGAUS = MAX (1, MIN (4, INGAUS))
      CALL ADVERB ('GRCHAN', 'I', 1, 0, IGR, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IGR = MOD (IGR, 10)
C                                       Plotting
      IF (BRANCH.GT.13) GO TO 100
      CALL ADVERB ('INSEQ', 'I', 1, 0, ISEQ, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INDISK', 'I', 1, 0, IVOL, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INVERS', 'I', 1, 0, ISVER, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IUSER = NLUSER
      CALL ADVERB ('LTYPE', 'I', 1, 0, LABEL, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      LABEL = ABS (LABEL)
      I = MOD (LABEL, 100)
      IF ((I.LE.0) .OR. (I.GT.10)) I = 3
      LABEL = (LABEL/100) * 100 + I
      CALL ADVERB ('BDROP', 'I', 1, 0, IDROP(1), RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('EDROP', 'I', 1, 0, IDROP(2), RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IDROP(1) = MAX (0, IDROP(1))
      IDROP(2) = MAX (0, IDROP(2))
      CALL ADVERB ('PIXRANGE', 'R', 2, 0, IDUM, RANGE, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
C                                       Open map file & get header.
      IMOD = 0
      IF (BRANCH.GT.2) THEN
         CALL ADVERB ('IN2VERS', 'I', 1, 0, IMOD, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         END IF
      CALL ADVERB ('INNAME', 'C', 1, 12, IDUM, RDUM, NAMEIN)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INCLASS', 'C', 1, 6, IDUM, RDUM, CLASIN)
      IF (ERRNUM.NE.0) GO TO 980
      TYPEIN = ' '
      CALL MAPOPN ('READ', IVOL, NAMEIN, CLASIN, ISEQ, TYPEIN, IUSER,
     *   IMLUN, IMFIND, ISLOT, CATBLK, ISBLK, IERR)
      IF (IERR.GT.1) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 980
         END IF
C                                       Close map file.
      CALL MAPCLS ('READ', IVOL, ISLOT, IMLUN, IMFIND, CATBLK, NOSAVE,
     *   ISBLK, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'WARNING. ERROR CLOSING MAP FILE'
         CALL MSGWRT (6)
         END IF
C                                       Open TV device.
      POTERR = 49
      CALL TVOPEN (INBUF, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       check TV state
      IF ((TVLIMG(1).NE.TVLIMG(2)) .OR. (TVLIMG(1).NE.TVLIMG(3)) .OR.
     *   (TVLIMG(1).NE.TVLIMG(4))) THEN
         POTERR = 77
         GO TO 970
         END IF
C                                       Open SL extension file.
      CALL OPEXT ('SL', IVOL, ISLOT, ISVER, ISLUN, EXCL, WAIT, ISFIND,
     *   IERR)
      IF (IERR.NE.0) GO TO 970
      IGR = MAX (1, MIN (IGR, NGRAPH-1)) + NGRAY
      CALL YHOLD ('ONNN', IERR)
      CALL YSLECT ('ONNN', IGR, 0, INBUF, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       Read 1st rec of slice file,
C                                       do scaling, init variables.
      CALL TVSLIN (BRANCH, ISLUN, ISFIND, LABEL, IMOD, RANGE, IDROP,
     *   BLC, TRC, XBLC, XTRC, RANGE2, XFAC, XOFF, CHR, YGAP, TEXT,
     *   NTEXT, IFMOD, INPTS, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       Clear screen, Draw borders,
C                                       tics and some annotation.
      IF ((BRANCH.EQ.1) .OR. ((BRANCH.GT.5) .AND. (MOD(BRANCH,2).EQ.0)))
     *   THEN
C                                       Init image catalog.
         CALL YCINIT (IGR, INBUF)
         CALL YZERO (IGR, IERR)
         IF (IERR.NE.0) GO TO 960
C                                       Update image catalog
         CALL YCWRIT (IGR, CATBLK(IICOR), CATBLK, ISBLK, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1040)
            CALL MSGWRT (6)
            END IF
         CALL TVLAB (BLC, TRC, LABEL, YGAP, TEXT, NTEXT, CHR, F, IERR)
         IF (IERR.NE.0) GO TO 960
         END IF
C                                       Plot slice file.
      IF ((BRANCH.EQ.6) .OR. (BRANCH.EQ.7)) THEN
         CALL TVSLPL ('SLIC', ISLUN, ISFIND, RANGE2, BLC, TRC, IFMOD,
     *      IMOD, GM, GP, GW, IERR)
      ELSE IF ((BRANCH.EQ.8) .OR. (BRANCH.EQ.9)) THEN
         CALL TVSLPL ('MODL', ISLUN, ISFIND, RANGE2, BLC, TRC, IFMOD,
     *      IMOD, GM, GP, GW, IERR)
      ELSE IF ((BRANCH.EQ.10) .OR. (BRANCH.EQ.11)) THEN
         CALL TVSLPL ('RESI', ISLUN, ISFIND, RANGE2, BLC, TRC, IFMOD,
     *      IMOD, GM, GP, GW, IERR)
      ELSE IF ((BRANCH.EQ.12) .OR. (BRANCH.EQ.13)) THEN
         CALL TVSLPL ('GUES', ISLUN, ISFIND, RANGE2, BLC, TRC, IFMOD,
     *      INGAUS, GM, GP, GW, IERR)
      ELSE IF ((BRANCH.EQ.1) .OR. (BRANCH.EQ.2)) THEN
         CALL TVSLPL ('COMP', ISLUN, ISFIND, RANGE2, BLC, TRC, IFMOD,
     *      IMOD, GM, GP, GW, IERR)
         END IF
      IF (IERR.EQ.0) POTERR = 0
      CALL YHOLD ('OFFF', IERR)
      GO TO 960
C-----------------------------------------------------------------------
C                                       TV1SET
C                                       TVSET
C                                       set guesses
C-----------------------------------------------------------------------
 100  IF (BRANCH.EQ.14) THEN
         ISTART = 1
         IEND = INGAUS
         CALL RFILL (8, 0.0, GP)
         CALL RFILL (12, 0.0, GW)
         CALL RFILL (4, 0.0, GM)
      ELSE
         IF ((SP.LT.1) .OR. (STACK(SP).EQ.2)) THEN
            ERRNUM = 8
            GO TO 980
            END IF
         ISTART = V(SP) + .01
         IF ((ISTART.GT.INGAUS) .OR. (ISTART.LT.1)) THEN
            WRITE (MSGTXT,1100) ISTART, INGAUS
            CALL MSGWRT (6)
            POTERR = 101
            GO TO 980
            END IF
         IEND = ISTART
         SP = SP - 1
         END IF
C                                       Open TV device.
      POTERR = 49
      CALL TVOPEN (INBUF, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Find catblk
      DO 110 I = 1,NGRAPH-1
         IGR = I + NGRAY
         ITEMP = 2 ** (IGR-1)
         IF (ZAND(TVLIMG(1),ITEMP).NE.0) THEN
            IX = MAXXTV(1) / 2
            IY = MAXXTV(2) / 2
            CALL YCREAD (IGR, IX, IY, CATBLK, IERR)
            IF (IERR.EQ.0) THEN
               CALL H2CHR (2, KHPTYO, CATBLK(KHPTY), CHTEMP)
               IF (CHTEMP.EQ.'SL') GO TO 120
               IF ((CHTEMP.EQ.'MA') .AND. (CATBLK(IIPLT).EQ.5))
     *            GO TO 120
               END IF
            END IF
 110     CONTINUE
      MSGTXT = 'NO SLICE PLOT FOUND'
      CALL MSGWRT (6)
      ERRNUM = 101
      GO TO 970
C                                       SL found!
C                                       Reconstruct original values.
 120  LABEL = CATBLK(IIOTH)
      IDROP(1) = CATBLK(IIOTH+1)
      IDROP(2) = CATBLK(IIOTH+2)
      IRXTRA = IIOTH + 3
      XBLC(1) = CATR(IRXTRA)
      XBLC(2) = CATR(IRXTRA+1)
      XTRC(1) = CATR(IRXTRA+2)
      XTRC(2) = CATR(IRXTRA+3)
      XBLC(3) = CATR(IRXTRA+4)
      XTRC(3) = CATR(IRXTRA+5)
      IRXTRA = IRXTRA + 6
      IRXTRA = IRXTRA/2 + 1
      FQFREQ = CATD(IRXTRA)
      IRXTRA = 2*IRXTRA + 1
      FQFINC = CATR(IRXTRA)
      INPTS = CATBLK(IIWIN+2) - CATBLK(IIWIN) + IDROP(1) + IDROP(2) + 1
      RANGE(1) = CATR(IRRAN)
      RANGE(2) = CATR(IRRAN+1)
      BLC(2) = CATBLK(IIWIN+1)
      TRC(2) = CATBLK(IIWIN+3)
      K = 1
      DO 125 I = 4,7
         XBLC(I) = CATBLK(IIDEP+K)
         XTRC(I) = CATBLK(IIDEP+K)
         K = K + 1
 125     CONTINUE
      CALL COPY (5, CATBLK(IIDEP), IDEPTH)
C                                       Initialize location common.
      CALL SLBINI (IDROP, INPTS, RANGE, BLC, TRC, XBLC, XTRC, FQFREQ,
     *   FQFINC, IDEPTH, LABEL, YGAP, CHR, TEXT, NTEXT)
C                                       get the values
      DO 140 I = ISTART,IEND
C                                       Find arc sec of curs from cent.
         WRITE (MSGTXT,1130) I
         CALL MSGWRT (1)
         CALL TVSLAC (VAL, ARC, IERR)
         IF (IERR.NE.0) GO TO 970
         GP(1,I) = ARC
         GM(I) = VAL
C                                       Get halfwidth.
         WRITE (MSGTXT,1131) I
         CALL MSGWRT (1)
         CALL TVSLAC (VAL, ARC, IERR)
         IF (IERR.NE.0) GO TO 970
         GW(1,I) = 2.0 * ABS (GP(1,I) - ARC)
 140     CONTINUE
      CALL ADVRBS ('GPOS', 'R', 8, 0, IDUM, GP, CDUM)
      IF (ERRNUM.NE.0) GO TO 970
      CALL ADVRBS ('GWIDTH', 'R', 12, 0, IDUM, GW, CDUM)
      IF (ERRNUM.NE.0) GO TO 970
      CALL ADVRBS ('GMAX', 'R', 4, 0, IDUM, GM, CDUM)
      POTERR = 0
      GO TO 970
C                                       Close slice file.
 960  CALL ZCLOSE (ISLUN, ISFIND, IERR)
C                                       Close TV device.
 970  CALL TVCLOS (ISBLK, IERR)
C                                       Errors
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR OPENING MAP FILE. MAPOPN ERR =',I6)
 1040 FORMAT ('TV IMAGE CATALOG ERROR.')
 1100 FORMAT ('COMPONENT',I7,' OUT OF RANGE 1 -',I4)
 1130 FORMAT ('Put cursor at center & height of Gaussian comp',I2,
     *   ' press button')
 1131 FORMAT ('Put cursor at halfwidth of Gaussian component',I3,
     *   ' press button')
      END

      PROGRAM CNTR
C-----------------------------------------------------------------------
C! Generates contour plot files for images
C# Graphics Map-util Plot-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2002-2004, 2006, 2009, 2011, 2014-2015,
C;  Copyright (C) 2021, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CNTR will write commands to a plot file for the execution
C   of a contour plot for a cataloged image file.  The program
C   runs as a detached task initiated from AIPS. First a cataloged
C   file is found using data passed from AIPS.  The list of
C   associated files is searched for PLot files to find the highest
C   version number.  Then a PLot file is created for this map and the
C   catalog header is updated.  Next the graphics commands are
C   written to the plot file.  TELL 'ABOR' and 'QUIT' codes supported.
C   Inputs:   (from AIPS)
C      USERID   R      user number, 0 means use logon user
C                      number, 32000 means any user can be accessed.
C      INNAME   H(3)   name of primary file.
C      INCLASS  H(2)   class of primary file.
C      INSEQ    R      sequence number of primary file.
C      INDISK   R      disk volume number. 0 means try all.
C      BLC      R(7)   bottom left corner of subimage: x, y, z, ...
C      TRC      R(7)   top right hand corner of plotted subimage
C      XYRATIO  R      the ratio between the scale factor to use for the
C                      X axis and the scale factor to use for the Y axis
C      LTYPE    R      the type of axis labeling to use for this plot.
C                          1 = no labels. Make map as big as possible.
C                          2 = no ticks, do rest of labels
C                          3 = RA - DEC coordinates & labels
C                          4 = Center-relative units
C      PLEV     R      the percentage of the peak value to use as the
C                      multiplier for the contour levels.  If 0 use CLEV
C      CLEV     R      The absolute value of the multiplier used for the
C                      contour levels.  Used only if PLEV is zero.
C      LEVS     R(30)  the contour levels.  An out of sequence level
C                      indicates 'end of levels'.  The real value of a
C                      particular level is the LEV value times CLEV or
C                      the value determined by PLEV.
C      DOCIRCLE R      > 0 Plot coord grid rather than just ticks
C      INVERS   R      ST file version number.
C      STFACTOR R      scale star sizes in file for plotting:
C                         0 => no plot of stars.
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C      TVCORN   R(2)   TV pixel to use (both > 0 => pixel scale)
C-----------------------------------------------------------------------
      CHARACTER IGFILE*48, PRGNAM*6, CHTM12*12, CHTM6*6, TYPIN*2,
     *   OPCODE*4, TXTMSG*80
      REAL      BLC(7), LEVS(30), TRC(7), DOCIRC, CH(4), CLEV, DSKIN,
     *   MULT, STMULT, PEAK, PLEV, PRUSER, SEQIN, XYRATO, TLABEL,
     *   YGAP, XINVER, XDOTV, XGRCH, XTVCRN(2), DUM, SUBMIN, SUBMAX
      HOLLERITH NAMIN(3), CLSIN(2)
      INTEGER   I, PLBUF(256), IGLUN, IGFIND, IGSIZE, ILABEL, IMFIND,
     *   IMLUN, IERR, IRETCD, ISEQ, J, INPRMS, ISLOT, ITYPE, IUSER,
     *   IVER, IVOL, IROUND, INVER, IDEPTH(5), GRCHN, TVCHN, TVCORN(2),
     *   BBLC(2), BTRC(2), GR2CHN
      LOGICAL   NOSAVE, QUICK, SAVE, T, DOGRID, DOTV
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DCNT.INC'
      COMMON /INPARM/ PRUSER, NAMIN, CLSIN, SEQIN, DSKIN, BLC, TRC,
     *   XYRATO, TLABEL, PLEV, CLEV, LEVS, DOCIRC, XINVER, STMULT,
     *   XDOTV, XGRCH, XTVCRN
      DATA IMLUN, IGLUN /16, 26/
      DATA PRGNAM /'CNTR  '/
      DATA TYPIN /'  '/
      DATA NOSAVE, SAVE, T /.FALSE.,.TRUE.,.TRUE./
      DATA BBLC, BTRC /4 * 0/
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Get input values from AIPS.
C                                       CHECK THIS WITH INPARM COMMON!
C                                       You HAVE to get this right.
C                                       It was incorrectly set to 65.
      INPRMS = 63
      IRETCD = 0
      CALL GTPARM (PRGNAM, INPRMS, QUICK, PRUSER, PLBUF, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRETCD = 8
 10   IF (QUICK) CALL RELPOP (IRETCD, PLBUF, IERR)
      IF (IRETCD.NE.0) GO TO 995
      IRETCD = 8
      PRUSER = NLUSER
C                                       Hollerith -> Char
      CALL H2CHR (12, 1, NAMIN, CHTM12)
      CALL H2CHR (6, 1, CLSIN, CHTM6)
C
      DOGRID = DOCIRC.GT.0.0
      ISEQ = IROUND (SEQIN)
      IVOL = IROUND (DSKIN)
      ILABEL = IROUND (TLABEL)
      I = MOD (ABS(ILABEL), 100)
      IF ((I.LE.0) .OR. (I.GT.10)) THEN
         IF (ILABEL.GE.0) THEN
            ILABEL = (ILABEL/100)*100 + 3
         ELSE
            ILABEL = (ILABEL/100)*100 - 3
            END IF
         END IF
      TLABEL = ILABEL
      IUSER = NLUSER
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      GR2CHN = GRCHN / 10
      GRCHN = MOD (GRCHN, 10)
      IF (GR2CHN.EQ.0) GR2CHN = MAX (1, GRCHN)
      TVCHN = 1
      TVCORN(1) = IROUND (XTVCRN(1))
      TVCORN(2) = IROUND (XTVCRN(2))
C                                       Levels defaults
      IF ((CLEV.EQ.0.0) .AND. (PLEV.EQ.0.0)) PLEV = 10.0
      IF ((LEVS(1).EQ.0.0) .AND. (LEVS(2).LE.LEVS(1))) THEN
         DO 15 I = 1,10
            LEVS(I) = I-11
            LEVS(I+10) = I
            LEVS(I+20) = 0.
 15         CONTINUE
         END IF
C                                       Open map file & get header.
      OPCODE = 'HDWR'
      IF (DOTV) OPCODE = 'READ'
      CALL MAPOPN (OPCODE, IVOL, CHTM12, CHTM6, ISEQ, TYPIN, IUSER,
     *   IMLUN, IMFIND, ISLOT, CATBLK, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Add extension file to header.
      IVER = 0
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', IVOL, ISLOT, CATBLK, PLBUF, SAVE,
     *      'READ', IVER, IERR)
         IF (IERR.NE.0) GO TO 975
         END IF
C                                       check ST plot parms
      I = 0
      IF (XINVER.LT.0.0) STMULT = 0.0
      IF (STMULT.NE.0.0) CALL FNDEXT ('ST', CATBLK, I)
      IF (I.GT.0) THEN
         J = XINVER + 0.1
         IF (J.LE.0) J = I
         XINVER = J
      ELSE
         XINVER = 0
         STMULT = 0.0
         END IF
      INVER = IROUND (XINVER)
C                                       Get header info.
      PEAK = MAX (ABS(CATR(KRDMX)), ABS(CATR(KRDMN)))
      MULT = CLEV
      IF (PLEV.NE.0.0) MULT = PEAK * PLEV / 100.0
C                                       Build file name.
      CALL ZPHFIL ('PL', IVOL, ISLOT, IVER, IGFILE, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020)
         CALL MSGWRT (7)
         GO TO 970
         END IF
C                                       fill in defaults in PARMS
      DSKIN = IVOL
      CALL RCOPY (5, BLC(3), TRC(3))
C                                       Default XYRATO: ratio of
C                                       incr if related.
      DO 30 I = 1,5
         IDEPTH(I) = BLC(I+2) + 0.01
 30      CONTINUE
      LOCNUM = 1
      IF ((XYRATO.LE.0.01) .OR. (XYRATO.GT.320.0)) THEN
         CALL SETLOC (IDEPTH, T)
         IF ((AXTYP(LOCNUM).EQ.1) .AND. (AXINC(2,LOCNUM).NE.0.0)) XYRATO
     *      = ABS (AXINC(1,LOCNUM) / AXINC(2,LOCNUM))
         IF (((XYRATO.LE.0.04) .OR. (XYRATO.GT.25.)) .AND.
     *      (TRC(1).NE.BLC(1))) XYRATO = (TRC(2)-BLC(2)) /
     *      (TRC(1)-BLC(1))
         IF ((XYRATO.LE.0.04) .OR. (XYRATO.GT.25.)) XYRATO = 1.0
         END IF
C                                       Init graph file.
      IGSIZE = 1
      ITYPE = 2
      CALL GINIT (IVOL, ISLOT, IGFILE, IGSIZE, ITYPE, INPRMS, PRUSER,
     *   DOTV, TVCHN, GRCHN, TVCORN, CATBLK, PLBUF, IGLUN, IGFIND,
     *   IERR)
      IF (GR2CHN.GT.0) GPHTVG(1) = GR2CHN + NGRAY
      IF (IERR.EQ.0) GO TO 35
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (7)
         GO TO 970
C                                       extra border chars - none
 35   CALL RFILL (4, 0.0, CH)
      YGAP = 0.0
C                                       Write axis labeling commands.
      I = 2 * MABFSS
      CALL FXLEVS (IMLUN, IMFIND, CATBLK, BLC, TRC, 0, 0, 0,
     *   MULT, LEVS, SUBMIN, SUBMAX, BUFF, I, IERR)
      IF (IERR.NE.0) GO TO 960
      CALL COMLAB (BLC, TRC, ILABEL, IVER, YGAP, CH, MULT, LEVS, SUBMIN,
     *   SUBMAX, XYRATO, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 960
      CALL CLAB1 (BLC, TRC, CH, ILABEL, XYRATO, DOGRID, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       Draw stars
      CALL SETLOC (IDEPTH, T)
      CALL GLTYPE (4, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 960
      CALL STARPL (STMULT, IVOL, ISLOT, INVER, BLC, TRC, 0, 0, CATBLK,
     *   BLC, 1, PLBUF, IERR)
      IF (IERR.GE.3) GO TO 950
C                                       Draw contours.
      TXTMSG = 'End labeling, start contouring'
      CALL GCOMNT (2, TXTMSG, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GLTYPE (2, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       Init map for read.
      I = 2 * MABFSS
      CALL DBINIT (IMLUN, IMFIND, CATBLK, BLC, TRC, I, BUFF, IERR)
      IF (IERR.NE.0) GO TO 960
      CALL CONDRW (IMLUN, IMFIND, 0, 0, MULT, BLC, TRC, LEVS, 0, BBLC,
     *   BTRC, DUM, PLBUF, IERR)
      IF (IERR.GT.9) GO TO 960
      IF (IERR.NE.0) GO TO 950
C                                       Write sucessful finish message.
      CALL GFINIS (PLBUF, IERR)
      IF (IERR.EQ.0) IRETCD = 0
      IF (IERR.NE.0) GO TO 960
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (IVOL, ISLOT, IVER, PLBUF, IERR)
            WRITE (MSGTXT,1300) IVER
            CALL MSGWRT (2)
            END IF
         GO TO 980
C-----------------------------------------------------------------------
C                                       Graph writing error.
 950  WRITE (MSGTXT,1950)
      CALL MSGWRT (8)
C                                       Try to do finish.
      CALL GFINIS (PLBUF, IERR)
      IF (IERR.NE.0) GO TO 960
         IRETCD = 0
         IF (.NOT.DOTV) CALL HIPLOT (IVOL, ISLOT, IVER, PLBUF, IERR)
         GO TO 980
C                                       Finish not sucessful. Destroy.
 960  CALL ZCLOSE (IGLUN, IGFIND, IERR)
      CALL ZDESTR (IVOL, IGFILE, IERR)
C                                       Do not save updated header.
 970  IRETCD = 16
      IF (.NOT.DOTV) CALL DELEXT ('PL', IVOL, ISLOT, 'READ', CATBLK,
     *   PLBUF, IVER, IERR)
 975  CALL ZCLOSE (IMLUN, IMFIND, IERR)
      GO TO 995
C                                       Close map file.
 980  CALL MAPCLS ('READ', IVOL, ISLOT, IMLUN, IMFIND, CATBLK, NOSAVE,
     *   PLBUF, IERR)
C
 995  CALL DIETSK (IRETCD, QUICK, PLBUF)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR GETTING PARAMETERS FROM AIPS. GTPARM ERR =',I5)
 1020 FORMAT ('COULD NOT BUILD GRAPH FILE NAME')
 1030 FORMAT ('GRAPH FILE INIT ERROR. GINIT ERR =',I5)
 1300 FORMAT ('Successful plot file version',I5,'  created.')
 1950 FORMAT ('ERROR DURING GRAPHING WILL TRY TO FINISH PARTIAL GRAPH')
      END

      SUBROUTINE FLAGUP (OPCODE, LUN, DISK, CNO, VER, BUFFER, IFGRNO,
     *   FGKOLS, FGNUMV, ID, NID, SUBA, FQID, NBASE, ANT1, ANT2, BTIME,
     *   ETIME, BIF, EIF, BCHAN, ECHAN, STOKES, REASON, NWRIT, IRET)
C-----------------------------------------------------------------------
C! Updates the Flag (FG) table.
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2005-2006, 2008, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Updates the flag table (FG).  On OPCODE='FLAG' one or more entries
C   are made indicating ranges of data to be rejected.  On OPCODE='UFLG'
C   existing entries will be deselected (but not removed) if there is
C   ANY overlap in the specifications. If some data is to remain flagged
C   then those portions have to be respecified.  The purpose of
C   'UFLG' is to unflag a set of data with a specified set of criteria
C   including REASON.
C      The FLAG table will be opened on the first call but a final call
C   with OPCODE='CLOS' is required to close the file.
C   Uses current values in /MAPHDR/ CATBLK and the /UVHDR/ common
C   (filled by UVPGET).
C   Inputs:
C      OPCODE   C*4      Operation desired, 'FLAG'=>make entry,
C                        'UFLG'=>deselect some part of previous entries.
C                        'REAS'=>deselect all with this REASON.
C                        'WILD'=>deselect all with this (wild-card
C                                enabled) REASON.
C                        'CLOS'=>close file.
C                        '    ' (or unrecognized) = 'FLAG'
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      VER      I        FG file version
C      LUN      I        Logical unit number to use
C      ID       I(NID)   List of source ID as defined in SOURCE table
C      NID      I        Number of elements in ID
C      SUBA     I        Subarray number.
C      FQID     I        Freqid number
C      NBASE    I        Number of baselines described in ANT1, ANT2
C      ANT1     I(*)     First antenna number in baseline
C      ANT2     I(*)     Second antenna number in baseline
C      ETIME    R        Start time of data to be flagged (Days)
C      BTIME    R        End time of data to be flagged (Days)
C      BIF      I        First IF number to flag. 0=>all
C      EIF      I        Last IF number to flag. 0=>all higher than BIF
C      BCHAN    I        First channel number to flag. 0=>all
C      ECHAN    I        Last channel number to flag. 0=>all higher.
C      STOKES   C*4      Stokes parameter desired
C      REASON   C*24     Reason for flagging blank => ignore for unflag.
C   Input/Output:
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      IFGRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      FGKOLS   I(8)     The column pointer array in order, SOURCE,
C                        SUBARRAY, ANTS, TIMERANG, IFS, CHANS, PFLAGS,
C                        REASON
C      FGNUMV   I(*)     Element count in each column.
C   Output:
C      NWRIT    I        Number of FG records altered
C      IRET     I        Error code, 0=>OK else TABIO error.
C                        Note: -1 => read, but record deselected.
c                        10 => UFLG or REAS with no parameters set
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, STOKES*4, REASON*24
      INTEGER   LUN, DISK, CNO, VER, BUFFER(*), FGKOLS(8), FGNUMV(8),
     *   ID(*), NID, SUBA, NBASE, ANT1(*), ANT2(*), BIF, EIF, BCHAN,
     *   ECHAN, FQID, NWRIT, IRET
      REAL      BTIME, ETIME
C
      CHARACTER TREAS*24
      INTEGER   FIND, ISU, IBAS, IDT, SUBT, ANTS(2), IFS(2), CHANS(2),
     *   IFGRNO, NUMREC, I4, I4REC, FQT, JT, JTRIM, RPAT(24)
      LOGICAL   PFLAGS(4), TFLAGS(4), DOREAS, LDUM, SOME
      REAL      TIMER(2), TEPS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      TEPS = 1.0 / (24.0 * 3600.0 * 10.0)
C                                       Check if 'CLOS'
      IF (OPCODE.EQ.'CLOS') GO TO 900
C                                       Check if 'REAS'
      DOREAS = (OPCODE.EQ.'REAS') .OR. (OPCODE.EQ.'WILD')
      IF (OPCODE.EQ.'WILD') CALL PSFORM (24, REASON, RPAT)
      NWRIT = 0
C                                       See if table open - check FTAB
C                                       Open file
      FIND = BUFFER(82)
      IF ((FIND.LT.0) .OR. (FIND.GT.10000) .OR. (LUN.NE.FTAB(FIND)))
     *   THEN
         CALL FGREFM (DISK, CNO, VER, CATBLK, LUN, IRET)
         CALL FLGINI ('WRIT', BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *      IFGRNO, FGKOLS, FGNUMV, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Mark as unsorted
         BUFFER(43) = 0
         BUFFER(44) = 0
         END IF
C                                       FLAG
      IF ((OPCODE.NE.'UFLG') .AND. (.NOT.DOREAS)) THEN
C                                       Loop over baseline
         DO 120 IBAS = 1,NBASE
C                                       Get polarization flags
            CALL FLGSTK (STOKES, OPCODE, PFLAGS, LDUM, IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Loop over source
            DO 110 ISU = 1,NID
               ANTS(1) = ANT1(IBAS)
               ANTS(2) = ANT2(IBAS)
               TIMER(1) = BTIME
               TIMER(2) = ETIME
               IFS(1) = MAX (0, BIF)
               IFS(2) = MAX (0, EIF)
               CHANS(1) = MAX (0, BCHAN)
               CHANS(2) = MAX (0, ECHAN)
C                                       Flag table entry.
               CALL TABFLG ('WRIT', BUFFER, IFGRNO, FGKOLS, FGNUMV,
     *            ID(ISU), SUBA, FQID, ANTS, TIMER, IFS, CHANS, PFLAGS,
     *            REASON, IRET)
               IF (IRET.NE.0) GO TO 999
               NWRIT = NWRIT + 1
 110           CONTINUE
 120        CONTINUE
C                                       UNFLAG
      ELSE
C                                       did caller specify something
         SOME = (REASON.NE.' ') .OR. (SUBA.GT.0) .OR. (FQID.GT.0) .OR.
     *      (BTIME.GT.0.0) .OR. (ETIME.GT.0.0) .OR. (BIF.GT.0) .OR.
     *      (EIF.GT.0) .OR. (BCHAN.GT.0) .OR. (ECHAN.GT.0)
         IF (.NOT.SOME) THEN
            DO 210 IBAS = 1,NBASE
               SOME = SOME .OR. (ANT1(IBAS).GT.0) .OR. (ANT2(IBAS).GT.0)
 210           CONTINUE
            DO 215 ISU = 1,NID
               SOME = SOME .OR. (ID(ISU).GT.0)
 215           CONTINUE
            END IF
         IF ((DOREAS) .AND. (REASON.EQ.' ')) SOME = .FALSE.
         IF (.NOT.SOME) THEN
            MSGTXT = 'FLAGUP CALLED TO UNFLAG WITH NO PARMS SET'
            CALL MSGWRT (8)
            IRET = 10
            GO TO 999
            END IF
C                                       Find number of entries in table
         NUMREC = BUFFER(5)
C                                       Search table.
         DO 290 I4REC = 1,NUMREC
            I4 = I4REC
            CALL TABFLG ('READ', BUFFER, I4, FGKOLS, FGNUMV, IDT, SUBT,
     *         FQT, ANTS, TIMER, IFS, CHANS, TFLAGS, TREAS, IRET)
            IF (IRET.LT.0) GO TO 290
            IF (IRET.NE.0) GO TO 999
c                                       Make sure blank filled
            JT = JTRIM (TREAS)
            IF (OPCODE.EQ.'REAS') THEN
               IF (TREAS.EQ.REASON) GO TO 250
               GO TO 290
            ELSE IF (OPCODE.EQ.'WILD') THEN
               CALL CHWMAT (24, REASON, RPAT, 1, TREAS, LDUM)
               IF (LDUM) GO TO 250
               GO TO 290
               END IF
C                                       Check invariants
C                                       Subarray
            IF ((SUBT.NE.SUBA) .AND. (SUBA.GE.0)) GO TO 290
C                                       Freq. ID
            IF (FQT.NE.-1) THEN
               IF ((FQT.NE.FQID) .AND. (FQT.GT.0) .AND.
     *            (FQID.GT.0)) GO TO 290
               END IF
C                                       Timerange
            IF ((BTIME.GE.0.0) .AND. (ABS(TIMER(1)-BTIME).GT.TEPS))
     *         GO TO 290
            IF ((ETIME.GE.0.0) .AND. (ABS(TIMER(2)-ETIME).GT.TEPS))
     *         GO TO 290
C                                       IFs
            IF ((BIF.GE.0) .AND. (IFS(1).NE.BIF)) GO TO 290
            IF ((EIF.GE.0) .AND. (IFS(2).NE.EIF)) GO TO 290
C                                       Channels
            IF ((BCHAN.GE.0) .AND. (CHANS(1).NE.BCHAN)) GO TO 290
            IF ((ECHAN.GE.0) .AND. (CHANS(2).NE.ECHAN)) GO TO 290
C                                       REASON
            IF ((REASON.NE.TREAS) .AND. (REASON.NE.' ')) GO TO 290
C                                       Loop over source
            IF (ID(1).GE.0) THEN
               DO 230 ISU = 1,NID
                  IF (IDT.EQ.ID(ISU)) GO TO 235
 230              CONTINUE
               IF ((IDT.GT.0) .OR. (ID(1).GT.0)) GO TO 290
               END IF
C                                       Loop over baseline
 235        DO 240 IBAS = 1,NBASE
C                                       Test baseline dependencies
C                                       Antenna 1
               IF ((ANTS(1).NE.ANT1(IBAS)) .AND. (ANT1(IBAS).GT.0))
     *            GO TO 240
C                                       Antenna 2
               IF ((ANTS(2).NE.ANT2(IBAS)) .AND. (ANT2(IBAS).GT.0))
     *            GO TO 240
C                                       Get polarization flags
               IF (STOKES.EQ.'----') THEN
                  GO TO 250
               ELSE
                  CALL FLGSTK (STOKES, OPCODE, PFLAGS, LDUM, IRET)
C                                       PFLAGS
                  IF ((IRET.EQ.0) .AND. (PFLAGS(1).EQV.TFLAGS(1)) .AND.
     *               (PFLAGS(2).EQV.TFLAGS(2)) .AND.
     *               (PFLAGS(3).EQV.TFLAGS(3)) .AND.
     *               (PFLAGS(4).EQV.TFLAGS(4))) GO TO 250
                  END IF
 240           CONTINUE
C                                       No match
            GO TO 290
C                                       Deselect entry.
 250        I4 = I4REC
            CALL TABFLG ('FLAG', BUFFER, I4, FGKOLS, FGNUMV, IDT, SUBT,
     *         FQT, ANTS, TIMER, IFS, CHANS, TFLAGS, TREAS, IRET)
            IF (IRET.NE.0) GO TO 999
            NWRIT = NWRIT + 1
 290        CONTINUE
         END IF
      GO TO 999
C                                       Close
 900  CALL TABFLG ('CLOS', BUFFER, IFGRNO, FGKOLS, FGNUMV, IDT, SUBA,
     *   FQID, ANTS, TIMER, IFS, CHANS, TFLAGS, TREAS, IRET)
C
 999  RETURN
      END

      SUBROUTINE ZLASIO (OP, LUN, OUTFIL, NCHAR, CBUFF, IERR)
C-----------------------------------------------------------------------
C! open, write to, close and spool a laser printer print/plot file
C# Z Printer Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2002, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Open, write to or close and spool a file for printing a plot on a
C   laser printer.  Does not spool the file if an explicit output
C   file name is given.
C   Inputs:
C      OP       C*4    Operation code: 'OPEN', 'POPN', 'WRIT' or 'CLOS'
C      LUN      I      Logical unit number for the laser printer
C      OUTFIL   C*48   Output file name (used by opcode 'OPEN', 'POPN',
C                      'CLOS')
C      NCHAR    I      Number of characters to print in CBUFF
C                      (used by opcode 'WRIT' only)
C      CBUFF    C*(*)  I/O buffer (used by opcode 'WRIT' only)
C   Output:
C      IERR     I      Error return code: 0 => no error
C                         1 => invalid opcode
C                         2 => trouble translating logical
C                         3 => I/O error
C   Generic version - uses ZFULLN, ZLASOP, ZLASCL
C-----------------------------------------------------------------------
      CHARACTER OP*4, OUTFIL*(*), CBUFF*(*)
      INTEGER   LUN, NCHAR, IERR
C
      CHARACTER FILNAM*256
      INTEGER   FLEN, SYSERR, DELFIL, IOSVAL, ITRIM
      LOGICAL   F, EXISTS
      INCLUDE 'INCS:DMSG.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                       OP = 'OPEN' or 'POPN'
      IERR = 0
      IF ((OP.EQ.'OPEN') .OR. (OP.EQ.'POPN')) THEN
C                                       get a full file name
         CALL ZFULLN (OUTFIL, 'PLOTTER', 'ZLASIO', FILNAM, IERR)
         FLEN = ITRIM (FILNAM)
         IF ((IERR.NE.0) .OR. (FLEN.LE.0)) THEN
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (6)
            IERR = 2
            GO TO 999
            END IF
C                                       Make sure file name does not
C                                       already exist.
         INQUIRE (FILE=FILNAM, EXIST=EXISTS)
         IF (EXISTS) THEN
            IERR = 3
            MSGTXT = 'ZLASIO: plotter file = ' // FILNAM(1:MIN(FLEN,40))
            CALL MSGWRT (6)
            IF (FLEN.GT.40) THEN
               MSGTXT =  FILNAM(41:MIN(FLEN,104))
               CALL MSGWRT (6)
               END IF
            IF (FLEN.GT.104) THEN
               MSGTXT =  FILNAM(105:MIN(FLEN,168))
               CALL MSGWRT (6)
               END IF
            IF (FLEN.GT.168) THEN
               MSGTXT =  FILNAM(169:MIN(FLEN,232))
               CALL MSGWRT (6)
               END IF
            MSGTXT = 'ZLASIO: ALREADY EXISTS'
            CALL MSGWRT (6)
            GO TO 999
            END IF
C                                       Open the file.
         CALL ZLASOP (OP, LUN, FILNAM, IOSVAL)
         IF (IOSVAL.NE.0) THEN
            IERR = 3
            SYSERR = IOSVAL
            WRITE (MSGTXT,1020) SYSERR
            CALL MSGWRT (6)
            MSGTXT = FILNAM(1:MIN (FLEN, 64))
            CALL MSGWRT (6)
            IF (FLEN.GT.64) THEN
               MSGTXT = FILNAM(65:MIN(FLEN,128))
               CALL MSGWRT (6)
               END IF
            IF (FLEN.GT.128) THEN
               MSGTXT = FILNAM(129:MIN(FLEN,192))
               CALL MSGWRT (6)
               END IF
            CALL ZERROR ('OPEN', SYSERR, ' ', -999, F)
         ELSE
            MSGTXT = 'ZLASIO: plotter file = ' // FILNAM(1:MIN(FLEN,40))
            CALL MSGWRT (2)
            IF (FLEN.GT.40) THEN
               MSGTXT = FILNAM(41:MIN(FLEN,104))
               CALL MSGWRT (2)
               END IF
            IF (FLEN.GT.104) THEN
               MSGTXT = FILNAM(105:MIN(FLEN,168))
               CALL MSGWRT (2)
               END IF
            IF (FLEN.GT.168) THEN
               MSGTXT = FILNAM(169:MIN(FLEN,232))
               CALL MSGWRT (2)
               END IF
            END IF
C                                       OP = 'WRIT'
C                                       Dump buffer to the file.
      ELSE IF (OP.EQ.'WRIT') THEN
         WRITE (LUN,1011,IOSTAT=IOSVAL) CBUFF(1:NCHAR)
         IF (IOSVAL.NE.0) THEN
            IERR = 3
            SYSERR = IOSVAL
            WRITE (MSGTXT,1100) SYSERR
            CALL MSGWRT (6)
            CALL ZERROR ('ZLASIO', SYSERR, ' ', -999, F)
            END IF
C                                       OP = 'CLOS'
      ELSE IF (OP.EQ.'CLOS') THEN
C                                       Get file name opened on LUN.
         INQUIRE (UNIT=LUN, NAME=FILNAM, IOSTAT=IOSVAL)
         IF (IOSVAL.NE.0) THEN
            IERR = 3
            SYSERR = IOSVAL
            WRITE (MSGTXT,1200) SYSERR
            CALL MSGWRT (6)
            CALL ZERROR ('ZLASIO', SYSERR, ' ', -999, F)
C                                       Close and print the file.
C                                       if OUTFIL is blank, delete it.
         ELSE
            DELFIL = -1
            IF (OUTFIL.EQ.' ') DELFIL = 1
            CALL ZLASCL (FILNAM, LUN, DELFIL, SYSERR, IERR)
            IF (IERR.NE.0) THEN
               IF (IERR.EQ.2) CALL ZERROR ('ZLASCL', SYSERR, ' ',
     *            -999, F)
               IERR = 3
               END IF
            END IF
C                                       Invalid operation code.
      ELSE
         IERR = 1
         WRITE (MSGTXT,1300) OP
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZLASIO: TROUBLE BUILDING OUTPUT FILE NAME',I5)
 1011 FORMAT (A)
 1020 FORMAT ('ZLASIO: FORTRAN OPEN ERROR = ',I6,' FOR PLOTTER FILE =')
 1100 FORMAT ('ZLASIO: FORTRAN WRITE ERROR = ',I6)
 1200 FORMAT ('ZLASIO: FORTRAN INQUIRE ERROR = ',I6)
 1210 FORMAT ('ZLASIO: FORTRAN CLOSE ERROR = ',I6)
 1300 FORMAT ('ZLASIO: INVALID OPERATION CODE = ',A4)
      END

      PROGRAM DISKU
C-----------------------------------------------------------------------
C! Reports the AIPS disk space utilization.
C# Service System Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999, 2001, 2011, 2014, 2017, 2022-2023,
C;  Copyright (C) 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DISKU reports the AIPS disk space utilization by file type and
C   user number.  It has been made a task since it was too slow as a
C   verb.  On the MODCOMP this task will need to be privileged.
C   Input adverbs:
C      USERID   R  User no. 0 -> LOGIN, 32000 => all.
C      INDISK   R  Disk, 0 = all.
C      XSORT    R  sort type: ' '=none, 'U'=user ID, 'B'=no of blocks
C                  used.
C      DOALL    R  > 0. => print each file type, name, size
C      DETIME   R  list only files older than DETIME days
C-----------------------------------------------------------------------
      INTEGER   MAXDSK
      PARAMETER (MAXDSK=35)
C
      CHARACTER PRGNAM*6, PFILE*48, PTYPE*2, IT*2, TITL(2)*4, SORT*1,
     *   PREFIX(4)*1, NAME*12, CLASS*6, LPNAME*48, TITL1*132, TITL2*132,
     *   LINE*132, SCRTCH*132
      REAL      INDSK, USERID, DOALL, DETIME, DOCRT, XBADD(10)
      HOLLERITH XSORT(1), HBLK(256), XLPNAM(12)
      DOUBLE PRECISION    JD, JD0, MSIZE, ESIZE, XFACT, BLOCKS(4,500),
     *   DBLKS(4,MAXDSK), VAL0, VAL1, MBLOCK(4), MBLKS, DPBLKS
      INTEGER   ICOUNT(4,500), IUSERS(500), IPERM(500), IN, IBLK(256),
     *   IDOUNT(4,MAXDSK), ISCR(256), NWPL, NLPR, IVOL, LVOL, MS, ES,
     *   IBVOL, IEVOL, ICNO, IUSER, INUSER, XLUSER, XLUSE1, XLUSE2,
     *   ICUR, NPTY, IMAX, IFIND, IERR, ICLUN, NNAME, JT, IVER, IMAXV,
     *   INO, IRETCD, IROUND, ISORT, ILAST, IPLUS, I, J, I0, J0, ILUSER,
     *   ITEMP, ITIME(6), HLUN, HIND, IER, IREC, IHREC, BLKS, IP,
     *   DROUND, NPARMS, LUNP, FINDP, NACROS, PAGE, IPCNT, PAGMAX,
     *   IBLKCS(4), NBAD, BADDSK(10)
      LOGICAL   QUICK, T, F, PRIVAT, ISSC, FIRST, LPOPN
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (IBLK, HBLK)
      COMMON /INPARM/ USERID, INDSK, XSORT, DOALL, DETIME, DOCRT,
     *   XLPNAM, XBADD
      DATA T, F /.TRUE.,.FALSE./
      DATA PRGNAM /'DISKU '/
      DATA NNAME, NPTY, ICLUN /5, 19, 15/
      DATA HLUN /16/
      DATA TITL /'User', 'Disk'/
      DATA PREFIX /'k', 'M', 'G', 'T'/
C-----------------------------------------------------------------------
C                                       AIPS inits
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      LPOPN = .FALSE.
      NPARMS = 28
      CALL GTPARM (PRGNAM, NPARMS, QUICK, USERID, ISCR, IERR)
      IRETCD = 0
      IF (IERR.NE.0) IRETCD = 8
      IF ((IERR.NE.0) .OR. (NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   THEN
         IF (DOCRT.NE.0.0) DOCRT = MIN (-1.0, DOCRT)
         END IF
      QUICK = (QUICK) .AND. (DOCRT.LE.0.0)
      IF (QUICK) CALL RELPOP (IRETCD, ISCR, IERR)
      IF (IRETCD.NE.0) GO TO 990
C                                       Sort order as char.
      CALL H2CHR (1, 1, XSORT, SORT)
      CALL H2CHR (48, 1, XLPNAM, LPNAME)
      NBAD = 0
      DO 10 I = 1,10
         J = IROUND (XBADD(I))
         IF (J.GT.0) THEN
            NBAD = NBAD + 1
            BADDSK(NBAD) = J
            END IF
 10      CONTINUE
C                                       structure of catlg records
C                                       IWPC (N20) = 5
      NWPL = 10
      NLPR = 256 / NWPL
C                                       Determine defaults for disk.
      IVOL = IROUND (INDSK)
      IBVOL = 1
      IEVOL = NVOL
C                                       Only one disk.
      IF (IVOL.NE.0) THEN
         IBVOL = IVOL
         IEVOL = IVOL
         END IF
C-----------------------------------------------------------------------
C                                       DISKUSE
C                                       Report disk space, # files
C-----------------------------------------------------------------------
C                                       Open "line printer"
      IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
      IF (DOCRT.NE.0.0) THEN
         CALL LPOPEN (LPNAME, DOCRT, LUNP, FINDP, NACROS, ISCR, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'FAILED TO OPEN PRINTER'
            GO TO 980
            END IF
         LPOPN = .TRUE.
         TITL1 = ' '
         TITL2 = ' '
         IF (DOCRT.GT.0.0) THEN
            PAGMAX = ABS(CRTMAX) - 7
         ELSE
            PAGMAX = PRTMAX - 6
            END IF
      ELSE
         LPOPN = .FALSE.
         NACROS = 64
         END IF
      PAGE = 0
      IPCNT = 998
C                                       user range, time
      IUSER = ABS(USERID) + .5
      IF (IUSER.LE.0) IUSER = NLUSER
      INUSER = 0
      IUSERS(1) = -99
      CALL ZDATE (ITIME(1))
      CALL ZTIME (ITIME(4))
      CALL DAT2JD (ITIME, JD0)
C                                       Private/public catlgs stuff
      XLUSER = NLUSER
      XLUSE1 = XLUSER
      XLUSE2 = XLUSER
      PRIVAT = .FALSE.
      IF ((UCTSIZ.GT.0) .AND. (IUSER.NE.NLUSER)) THEN
         XLUSE1 = IUSER
         XLUSE2 = IUSER
         IF (IUSER.EQ.32000) THEN
            XLUSE1 = 1
            XLUSE2 = USELIM
            PRIVAT = .TRUE.
            CALL FILL (280, 0, DASSGN)
            END IF
         END IF
C                                       Loop for all volumes.
      DO 160 IVOL = IBVOL,IEVOL
C                                       Init volume totals.
         DBLKS(1,IVOL) = 0
         DBLKS(2,IVOL) = 0
         DBLKS(3,IVOL) = 0
         DBLKS(4,IVOL) = 0
         CALL FILL (4, 0, IDOUNT(1,IVOL))
         DO 20 J = 1,NBAD
            IF (IVOL.EQ.BADDSK(J)) GO TO 160
 20         CONTINUE
         DO 159 ILUSER = XLUSE1,XLUSE2
C                                       Open proper catalog file.
            NLUSER = ILUSER
            IF (PRIVAT) MSGSUP = 32000
            LVOL = -IVOL
            CALL CATOPN (LVOL, IFIND, IBLK, IMAX, IERR)
            MSGSUP = 0
            NLUSER = XLUSER
            IF (IERR.NE.0) GO TO 159
C                                       Loop through all cat entries.
            ICUR = 999
            IREC = 2
            FIRST = .TRUE.
            DO 140 ICNO = 1,IMAX
               ICUR = ICUR + NWPL
C                                       Read new buffer.
               IF (ICUR.GE.NLPR*NWPL) THEN
                  CALL ZFIO ('READ', ICLUN, IFIND, IREC, IBLK, IERR)
                  IF (IERR.NE.0) GO TO 145
                  IREC = IREC + 1
                  ICUR = 1
                  END IF
C                                       See if valid entry
               IF (IBLK(ICUR).LE.0) GO TO 140
               IF ((IBLK(ICUR).NE.IUSER) .AND. (IUSER.NE.32000))
     *            GO TO 140
C                                       Check time
               CALL CATIME (2, IBLK(ICUR+2), ITIME)
               CALL DAT2JD (ITIME, JD)
               CALL H2CHR (2, NPTY, HBLK(ICUR+NNAME), PTYPE)
               ISSC = PTYPE.EQ.'SC'
               IF ((.NOT.ISSC) .AND. (JD0-JD.LT.DETIME)) GO TO 140
               IF ((ISSC) .AND. (JD0-JD.LT.3.0) .AND.
     *            (JD0-JD.LT.DETIME)) GO TO 140
C                                       Search user list
               DO 115 I = 1,INUSER
                  IF (IBLK(ICUR).EQ.IUSERS(I)) GO TO 120
 115              CONTINUE
C                                       New user ID, init.
               INUSER = INUSER + 1
               I = INUSER
               CALL FILL (4, 0, ICOUNT(1,I))
               BLOCKS(1,I) = 0.0D0
               BLOCKS(2,I) = 0.0D0
               BLOCKS(3,I) = 0.0D0
               BLOCKS(4,I) = 0.0D0
               IUSERS(I) = IBLK(ICUR)
               IPERM(INUSER) = INUSER
C                                       Get header
 120           IHREC = 1
               NLUSER = ILUSER
               CALL ZPHFIL ('CB', IVOL, ICNO, 1, PFILE, IERR)
               NLUSER = XLUSER
               CALL ZOPEN (HLUN, HIND, IVOL, PFILE, F, F, T, IERR)
               IF (IERR.NE.0) GO TO 140
               CALL ZFIO ('READ', HLUN, HIND, IHREC, CATBLK, IERR)
               CALL ZCLOSE (HLUN, HIND, IER)
               IF (IERR.NE.0) GO TO 140
               MSIZE = 0.0D0
               ESIZE = 0.0D0
C                                       header file size
               NLUSER = ILUSER
               CALL ZEXIST (IVOL, PFILE, BLKS, IERR)
               NLUSER = XLUSER
               DPBLKS = BLKS
               ESIZE = ESIZE + DPBLKS
               JT = 3
               DBLKS(JT,IVOL) = DBLKS(JT,IVOL) + DPBLKS
               BLOCKS(JT,I) = BLOCKS(JT,I) + DPBLKS
               ICOUNT(JT,I) = ICOUNT(JT,I) + 1
               IDOUNT(JT,IVOL) = IDOUNT(JT,IVOL) + 1
C                                       Main file size
               NLUSER = ILUSER
               CALL ZPHFIL (PTYPE, IVOL, ICNO, 1, PFILE, IERR)
               CALL ZEXIST (IVOL, PFILE, BLKS, IERR)
               NLUSER = XLUSER
               DPBLKS = BLKS
               IVER = 1
               IF (IERR.NE.0) IVER = 0
               MSIZE = DPBLKS
C                                       Update values
               JT = 4
               IF (PTYPE.EQ.'UV') JT = 2
               IF (PTYPE.EQ.'MA') JT = 1
               ICOUNT(JT,I) = ICOUNT(JT,I) + IVER
               IDOUNT(JT,IVOL) = IDOUNT(JT,IVOL) + IVER
               BLOCKS(JT,I) = BLOCKS(JT,I) + DPBLKS
               DBLKS(JT,IVOL) = DBLKS(JT,IVOL) + DPBLKS
C                                       Count extension files.
               JT = 3
               CALL FXHDEX (CATBLK)
               DO 135 J = 1,KIEXTN
                  IF (CATBLK(KIVER+J-1).GT.0) THEN
                     IMAXV = MIN (46655, CATBLK(KIVER+J-1))
                     CALL H2CHR (2, 1, CATH(KHEXT+J-1), IT)
C                                       Try all version nos.
                     INO = 0
                     NLUSER = ILUSER
                     DO 130 IVER = 1,IMAXV
                        CALL ZPHFIL (IT, IVOL, ICNO, IVER, PFILE,
     *                     IERR)
                        CALL ZEXIST (IVOL, PFILE, BLKS, IERR)
                        IF (IERR.EQ.0) THEN
                           DPBLKS = BLKS
                           INO = INO + 1
                           ESIZE = ESIZE + DPBLKS
                           DBLKS(JT,IVOL) = DBLKS(JT,IVOL) + DPBLKS
                           BLOCKS(JT,I) = BLOCKS(JT,I) + DPBLKS
                           END IF
 130                    CONTINUE
                     NLUSER = XLUSER
                     ICOUNT(JT,I) = ICOUNT(JT,I) + INO
                     IDOUNT(JT,IVOL) = IDOUNT(JT,IVOL) + INO
                     END IF
 135              CONTINUE
               ESIZE = ESIZE / 1024.0D0
               MSIZE = MSIZE / 1024.0D0
               IF ((DOALL.GT.0.0) .AND. (DOALL.LT.ESIZE+MSIZE)) THEN
                  IF (FIRST) THEN
                     FIRST = .FALSE.
                     IF (NACROS.LT.80) THEN
                        WRITE (TITL1,1135) DOALL, ILUSER, IVOL
                        WRITE (TITL2,1136)
                     ELSE IF (NACROS.LT.100) THEN
                        WRITE (TITL1,1135) DOALL, ILUSER, IVOL
                        WRITE (TITL2,2136)
                     ELSE
                        WRITE (TITL1,1135) DOALL, ILUSER, IVOL
                        WRITE (TITL2,3136)
                        END IF
                     IF (DOCRT.EQ.0.0) THEN
                        MSGTXT = TITL1
                        CALL MSGWRT (3)
                        MSGTXT = TITL2
                        CALL MSGWRT (3)
                     ELSE IF (IPCNT.LT.PAGMAX) THEN
                        LINE = ' '
                        CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *                     TITL2, LINE, IPCNT, PAGE, SCRTCH, IERR)
                        IF (IERR.NE.0) GO TO 960
                        LINE = TITL1
                        CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS,
     *                     TITL1, TITL2, LINE, IPCNT, PAGE, SCRTCH,
     *                     IERR)
                        IF (IERR.NE.0) GO TO 960
                        IF (PAGE.NE.0) THEN
                           LINE = TITL2
                           CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS,
     *                        TITL1, TITL2, LINE, IPCNT, PAGE, SCRTCH,
     *                        IERR)
                           IF (IERR.NE.0) GO TO 960
                           LINE = ' '
                           CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS,
     *                        TITL1, TITL2, LINE, IPCNT, PAGE, SCRTCH,
     *                        IERR)
                           IF (IERR.NE.0) GO TO 960
                           END IF
                     ELSE
                        IPCNT = PAGMAX + 10
                        LINE = ' '
                        CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *                     TITL2, LINE, IPCNT, PAGE, SCRTCH, IERR)
                        IF (IERR.NE.0) GO TO 960
                        IF (DOCRT.EQ.-3) THEN
                           LINE = TITL1
                           CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS,
     *                        TITL1, TITL2, LINE, IPCNT, PAGE, SCRTCH,
     *                        IERR)
                           IF (IERR.NE.0) GO TO 960
                           end if
                        END IF
                     END IF
                  CALL H2CHR (12, KHIMNO, CATH(KHIMN), NAME)
                  CALL H2CHR (6, KHIMCO, CATH(KHIMC), CLASS)
                  ES = DROUND (ESIZE)
                  MS = DROUND (MSIZE)
                  IF (NACROS.LT.80) THEN
                     WRITE (LINE,1137) ICNO, PTYPE, NAME, CLASS,
     *                  CATBLK(KIIMS), MS, ES, ITIME(1), ITIME(2),
     *                  ITIME(3)
                  ELSE IF (NACROS.LT.100) THEN
                     WRITE (LINE,2137) ICNO, PTYPE, NAME, CLASS,
     *                  CATBLK(KIIMS), MSIZE, ESIZE, ITIME(1), ITIME(2),
     *                  ITIME(3)
                  ELSE
                     WRITE (LINE,3137) ICNO, PTYPE, NAME, CLASS,
     *                  CATBLK(KIIMS), MSIZE, ESIZE, ITIME
                     END IF
                  IF (DOCRT.EQ.0.0) THEN
                     MSGTXT = LINE
                     CALL MSGWRT (3)
                  ELSE
                     CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1,
     *                  TITL2, LINE, IPCNT, PAGE, SCRTCH, IERR)
                     IF (IERR.NE.0) GO TO 960
                     END IF
                  END IF
 140           CONTINUE
C                                       Close catalog file.
 145        CALL ZCLOSE (ICLUN, IFIND, IERR)
C                                       Include private CA files
            IF (UCTSIZ.GT.0) THEN
               NLUSER = ILUSER
               CALL ZPHFIL ('CA', IVOL, 0, 0, PFILE, IERR)
               CALL ZEXIST (IVOL, PFILE, BLKS, IERR)
               NLUSER = XLUSER
               IF (IERR.NE.0) GO TO 159
               DPBLKS = BLKS
C                                       Search user list
               DO 150 I = 1,INUSER
                  IF (ILUSER.EQ.IUSERS(I)) GO TO 155
 150              CONTINUE
C                                       New user ID, init.
               INUSER = INUSER + 1
               I = INUSER
               CALL FILL (4, 0, ICOUNT(1,I))
               BLOCKS(1,I) = 0.0D0
               BLOCKS(2,I) = 0.0D0
               BLOCKS(3,I) = 0.0D0
               BLOCKS(4,I) = 0.0D0
               IUSERS(I) = ILUSER
               IPERM(INUSER) = INUSER
C                                       store it
 155           JT = 4
               DBLKS(JT,IVOL) = DBLKS(JT,IVOL) + DPBLKS
               BLOCKS(JT,I) = BLOCKS(JT,I) + DPBLKS
               ICOUNT(JT,I) = ICOUNT(JT,I) + 1
               IDOUNT(JT,IVOL) = IDOUNT(JT,IVOL) + 1
               END IF
 159        CONTINUE
 160     CONTINUE
C                                       Find save files.
      IF (IBVOL.EQ.1) THEN
         JT = 4
         IVOL = 1
         XLUSE1 = 1
         XLUSE2 = USELIM
         IF ((IUSER.GE.1) .AND. (IUSER.LE.USELIM)) THEN
            XLUSE1 = IUSER
            XLUSE2 = IUSER
            END IF
         DO 200 ILUSER = XLUSE1,XLUSE2
C                                       Message file
            NLUSER = ILUSER
            CALL ZPHFIL ('MS', IVOL, ILUSER, 0, PFILE, IERR)
            CALL ZEXIST (IVOL, PFILE, BLKS, IERR)
            NLUSER = XLUSER
            IF (IERR.NE.0) GO TO 168
            DPBLKS = BLKS
C                                       Search user list
            DO 166 I = 1,INUSER
               IF (ILUSER.EQ.IUSERS(I)) GO TO 167
 166           CONTINUE
C                                       New user ID, init.
            INUSER = INUSER + 1
            I = INUSER
            CALL FILL (4, 0, ICOUNT(1,I))
            BLOCKS(1,I) = 0.0D0
            BLOCKS(2,I) = 0.0D0
            BLOCKS(3,I) = 0.0D0
            BLOCKS(4,I) = 0.0D0
            IUSERS(I) = ILUSER
            IPERM(INUSER) = INUSER
C                                       store it
 167        ICOUNT(JT,I) = ICOUNT(JT,I) + 1
            IDOUNT(JT,1) = IDOUNT(JT,1) + 1
            BLOCKS(JT,I) = BLOCKS(JT,I) + DPBLKS
            DBLKS(JT,1) = DBLKS(JT,1) + DPBLKS
C                                       Task save file
 168        DO 178 J = 1,36
               J0 = J - 1
               NLUSER = ILUSER
               CALL ZPHFIL ('TS', IVOL, 400, J0, PFILE, IERR)
               CALL ZEXIST (IVOL, PFILE, BLKS, IERR)
               NLUSER = XLUSER
               DPBLKS = BLKS
C                                       Search user list
               IF (IERR.EQ.0) THEN
                  DO 170 I = 1,INUSER
                     IF (ILUSER.EQ.IUSERS(I)) GO TO 175
 170                 CONTINUE
C                                       New user ID, init.
                  INUSER = INUSER + 1
                  I = INUSER
                  CALL FILL (4, 0, ICOUNT(1,I))
                  BLOCKS(1,I) = 0.0D0
                  BLOCKS(2,I) = 0.0D0
                  BLOCKS(3,I) = 0.0D0
                  BLOCKS(4,I) = 0.0D0
                  IUSERS(I) = ILUSER
                  IPERM(INUSER) = INUSER
C                                       store it
 175              ICOUNT(JT,I) = ICOUNT(JT,I) + 1
                  IDOUNT(JT,1) = IDOUNT(JT,1) + 1
                  BLOCKS(JT,I) = BLOCKS(JT,I) + DPBLKS
                  DBLKS(JT,1) = DBLKS(JT,1) + DPBLKS
                  END IF
 178           CONTINUE
C                                       Get # by brute force
C                                       tasks don't know ME size
            DO 195 J = 1,100
               J0 = J - 1
               NLUSER = ILUSER
               CALL ZPHFIL ('SG', IVOL, ILUSER, J0, PFILE, IERR)
               CALL ZEXIST (IVOL, PFILE, BLKS, IERR)
               NLUSER = XLUSER
               IF ((J.EQ.1) .AND. (IERR.NE.0)) GO TO 200
               IF (IERR.NE.0) GO TO 195
               DPBLKS = BLKS
C                                       Search user list
               IF (J.LE.1) THEN
                  DO 185 I = 1,INUSER
                     IF (ILUSER.EQ.IUSERS(I)) GO TO 190
 185                 CONTINUE
C                                       New user ID, init.
                  INUSER = INUSER + 1
                  I = INUSER
                  CALL FILL (4, 0, ICOUNT(1,I))
                  BLOCKS(1,I) = 0.0D0
                  BLOCKS(2,I) = 0.0D0
                  BLOCKS(3,I) = 0.0D0
                  BLOCKS(4,I) = 0.0D0
                  IUSERS(I) = ILUSER
                  IPERM(INUSER) = INUSER
                  END IF
C                                       store it
 190           ICOUNT(JT,I) = ICOUNT(JT,I) + 1
               IDOUNT(JT,1) = IDOUNT(JT,1) + 1
               BLOCKS(JT,I) = BLOCKS(JT,I) + DPBLKS
               DBLKS(JT,1) = DBLKS(JT,1) + DPBLKS
 195           CONTINUE
 200        CONTINUE
         END IF
C                                       Determine sort type.
      ISORT = 3
      IF (SORT.EQ.'U') ISORT = 1
      IF (SORT.EQ.'B') ISORT = 2
C                                       Sort.
      IF (ISORT.NE.0) THEN
         ILAST = INUSER - 1
         DO 210 I = 1,ILAST
            IPLUS = I + 1
            DO 205 J = IPLUS,INUSER
               I0 = IPERM(I)
               J0 = IPERM(J)
C                                       Sort by user ID.
               IF (ISORT.EQ.1) THEN
                  VAL0 = IUSERS(I0)
                  VAL1 = IUSERS(J0)
C                                       Sort by blocks used.
               ELSE IF (ISORT.EQ.2) THEN
                  VAL0 = BLOCKS(1,J0) + BLOCKS(2,J0) + BLOCKS(3,J0)
     *               + BLOCKS(4,J0)
                  VAL1 = BLOCKS(1,I0) + BLOCKS(2,I0) + BLOCKS(3,I0)
     *               + BLOCKS(4,I0)
C                                       sort by number of files
               ELSE
                  VAL0 = ICOUNT(1,J0) + ICOUNT(2,J0) + ICOUNT(3,J0)
     *               + ICOUNT(4,J0)
                  VAL1 = ICOUNT(1,I0) + ICOUNT(2,I0) + ICOUNT(3,I0)
     *               + ICOUNT(4,I0)
                  END IF
C                                       Out of order switch.
               IF (VAL0.GT.VAL1) THEN
                  ITEMP = IPERM(I)
                  IPERM(I) = IPERM(J)
                  IPERM(J) = ITEMP
                  END IF
 205           CONTINUE
 210        CONTINUE
         END IF
C                                       find extrema
      MBLKS = 0
      CALL DFILL (4, 0.0D0, MBLOCK)
      DO 220 I = 1,INUSER
         IN = IPERM(I)
         DPBLKS = BLOCKS(1,IN) + BLOCKS(2,IN) + BLOCKS(3,IN) +
     *      BLOCKS(4,IN)
         MBLKS = MAX (MBLKS, DPBLKS)
         DO 215 J = 1,4
            MBLOCK(J) = MAX (MBLOCK(J), BLOCKS(J,IN))
 215        CONTINUE
 220     CONTINUE
      DO 230 IVOL = IBVOL,IEVOL
         DPBLKS = DBLKS(1,IVOL) + DBLKS(2,IVOL) + DBLKS(3,IVOL) +
     *      DBLKS(4,IVOL)
         MBLKS = MAX (MBLKS, DPBLKS)
         DO 225 J = 1,4
            MBLOCK(J) = MAX (MBLOCK(J), DBLKS(J,IIVOL))
 225        CONTINUE
 230     CONTINUE
      XFACT = 1.0D0
      IP = 1
 235  IF ((MBLKS.GT.999999999) .OR. (MBLOCK(1).GT.9999999) .OR.
     *   (MBLOCK(2).GT.9999999) .OR. (MBLOCK(3).GT.999999) .OR.
     *   (MBLOCK(4).GT.999999)) THEN
         XFACT = XFACT * 1024.0D0
         IP = IP + 1
         MBLKS = MBLKS / 1024.0D0
         MBLOCK(1) = MBLOCK(1)/1024.0D0
         MBLOCK(2) = MBLOCK(2)/1024.0D0
         MBLOCK(3) = MBLOCK(3)/1024.0D0
         MBLOCK(4) = MBLOCK(4)/1024.0D0
         GO TO 235
         END IF
C                                       Print messages
      IF (NACROS.LT.80) THEN
         WRITE (TITL1,1230) TITL(1)
         WRITE (TITL2,1231) (PREFIX(IP), J = 1,5)
      ELSE
         WRITE (TITL1,2230) TITL(1)
         WRITE (TITL2,2231) (PREFIX(IP), J = 1,5)
         END IF
      IF (DOCRT.EQ.0.0) THEN
         MSGTXT = TITL1
         CALL MSGWRT (5)
         MSGTXT = TITL2
         CALL MSGWRT (5)
      ELSE IF ((PAGE.NE.0) .AND. (IPCNT.LT.PAGMAX)) THEN
         LINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 960
         LINE = TITL1
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 960
         LINE = TITL2
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 960
         LINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 960
      ELSE
         IPCNT = PAGMAX + 10
         LINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 960
         END IF
C                                       User summary
      DO 240 I = 1,INUSER
         IN = IPERM(I)
         DPBLKS = BLOCKS(1,IN) + BLOCKS(2,IN) + BLOCKS(3,IN) +
     *      BLOCKS(4,IN)
         BLKS = DROUND (DPBLKS/XFACT)
         DO 238 J = 1,4
            IBLKCS(J) = DROUND (BLOCKS(J,IN)/XFACT)
 238        CONTINUE
         IF (NACROS.LT.80) THEN
            WRITE (LINE,1232,ERR=239) IUSERS(IN), (ICOUNT(J,IN),
     *         IBLKCS(J), J = 1,4), BLKS
         ELSE
            WRITE (LINE,2232,ERR=239) IUSERS(IN), (ICOUNT(J,IN),
     *         IBLKCS(J), J = 1,4), BLKS
            END IF
 239     IF (DOCRT.EQ.0.0) THEN
            MSGTXT = LINE
            CALL MSGWRT (5)
         ELSE
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 960
            END IF
 240     CONTINUE
C                                       Disk summary.
      IF (NACROS.LT.80) THEN
         WRITE (TITL1,1230) TITL(2)
         WRITE (TITL2,1231) (PREFIX(IP), J = 1,5)
      ELSE
         WRITE (TITL1,2230) TITL(2)
         WRITE (TITL2,2231) (PREFIX(IP), J = 1,5)
         END IF
      IF (DOCRT.EQ.0.0) THEN
         MSGTXT = TITL1
         CALL MSGWRT (5)
         MSGTXT = TITL2
         CALL MSGWRT (5)
      ELSE IF ((PAGE.NE.0) .AND. (IPCNT.LT.PAGMAX)) THEN
         LINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 960
         LINE = TITL1
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 960
         LINE = TITL2
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 960
         LINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 960
      ELSE
         IPCNT = PAGMAX + 10
         LINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 960
         END IF
      DO 245 IVOL = IBVOL,IEVOL
         DPBLKS = DBLKS(1,IVOL) + DBLKS(2,IVOL) + DBLKS(3,IVOL) +
     *      DBLKS(4,IVOL)
         BLKS = DROUND (DPBLKS/XFACT)
         DO 243 J = 1,4
            IBLKCS(J) = DROUND (DBLKS(J,IVOL)/XFACT)
 243        CONTINUE
         IF (NACROS.LT.80) THEN
            WRITE (LINE,1232,ERR=244) IVOL, (IDOUNT(J,IVOL),
     *         IBLKCS(J), J = 1,4), BLKS
         ELSE
            WRITE (LINE,2232,ERR=244) IVOL, (IDOUNT(J,IVOL),
     *         IBLKCS(J), J = 1,4), BLKS
            END IF
 244     IF (DOCRT.EQ.0.0) THEN
            MSGTXT = LINE
            CALL MSGWRT (5)
         ELSE
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 960
            END IF
 245     CONTINUE
      GO TO 990
C
 960  IF (IERR.GT.0) THEN
         MSGTXT = 'ERROR DOING I/O TO PRINT FILE'
      ELSE
         GO TO 990
         END IF
 980  CALL MSGWRT (8)
      IRETCD = IERR
C                                       End AIPS task
 990  IF (LPOPN) CALL LPCLOS (LUNP, FINDP, IPCNT, J)
      CALL DIETSK (IRETCD, QUICK, ISCR)
C
 999  STOP
C-----------------------------------------------------------------------
 1135 FORMAT ('Listing of files >',F10.3,' Mbytes for user',I6,' disk',
     *   I3)
 1136 FORMAT ('Cat # Type Name',9X,'Class   Seq # File Mb',
     *   ' Ext Mb    Last use')
 1137 FORMAT (I5,2X,A2,2X,A12,1X,A6,I7,I8,I7,I6,2('/',I2.2))
 2136 FORMAT (' Cat # Type  Name',10X,'Class    Seq #  File Mbytes',
     *   '  Ext Mbytes     Last use')
 2137 FORMAT (I6,2X,A2,3X,A12,2X,A6,I8,F13.3,F12.3,I7,2('/',I2.2))
 3136 FORMAT ('  Cat #  Type  Name',10X,'Class    Seq #   File Mbytes',
     *   '  Ext Mbytes   Last use date & time')
 3137 FORMAT (I7,3X,A2,3X,A12,2X,A6,I8,F14.3,F12.3,I7,2('/',I2.2),
     *   I4.2,2(':',I2.2))
 1230 FORMAT (A4,4X,'Images',3X,4X,'UV files',1X,2X,'Extensions',
     *   4X,'Other',3X,5X,'Total')
 1231 FORMAT (3X,'#',2(4X,'#  ',A,'bytes'),2(4X,'# ',A,'bytes'),4X,
     *   A,'bytes')
 1232 FORMAT (I4,2(I5,I8),2(I5,I7),I10)
 2230 FORMAT (1X,A4,6X,'Images',5X,6X,'UV files',3X,4X,'Extensions',
     *   5X,'Other',3X,7X,'Total')
 2231 FORMAT (4X,'#',2(6X,'#    ',A,'bytes'),6X,'#   ',A,'bytes',
     *   4X,'# ',A,'bytes',5X,A,'bytes')
 2232 FORMAT (I5,2(I7,I10),I7,I9,I5,I7,I11)
      END

      SUBROUTINE GINITG (IGLO, IGHI, RANGE, BUFF, IERR)
C-----------------------------------------------------------------------
C! writes an initialize-for-grey-scale record into a plot file or TV
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2002, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GINITG will write an "init for gray-scale" command record to the
C   graphics file.  The output record has the form:
C            I     opcode (3)
C            I     lowest pixel value - scaled integer
C            I     highest pixel value - scaled integer
C            I     number of pixels on x axis
C            I     number of pixels on y axis
C            H*2   Function type
C            R(2)  Real image pixel range
C   Inputs:
C      IGLO  I         lowest allowed pixel value
C      IGHI  I         highest allowed pixel value
C   In/Out:
C      BUFF  I(256)    graphics buffer
C   Output:
C      IERR  I         error code: 0 => ok
C                                  1 => disk error
C                                  2 => input error
C-----------------------------------------------------------------------
      INTEGER    IGLO, IGHI, BUFF(256), IERR
      REAL       RANGE(2)
C
      INTEGER    NEED, OPCODE, IER, NPTSX, NPTSY, CMAXTV(2), NXA, NYA
      REAL       CATR(256)
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (GPHCAT, CATR)
      DATA NEED, OPCODE /249, 13/
C-----------------------------------------------------------------------
      IERR = 0
C                                        fill in common
      GPHTLO = IGLO
      GPHTHI = IGHI
      CALL RCOPY (2, RANGE, GPHRNG)
      IF (IGHI.LE.IGLO) THEN
         WRITE (MSGTXT,1000) IGLO, IGHI
         CALL MSGWRT (7)
         IERR = 2
         GO TO 999
         END IF
C                                       plot file
      IF (.NOT.GPHDOT) THEN
C                                        write buffer if needed
         IF (GPHPOS.GE.NEED) THEN
            CALL GPHWRT (BUFF, IER)
            IF (IER.NE.0) THEN
               IERR = 1
               GO TO 999
               END IF
            END IF
C                                        fill in values
         BUFF(GPHPOS+1) = OPCODE
         BUFF(GPHPOS+2) = IGLO
         BUFF(GPHPOS+3) = IGHI
         BUFF(GPHPOS+4) = ABS(GPHX2-GPHX1) + 1.5
         BUFF(GPHPOS+5) = ABS(GPHY2-GPHY1) + 1.5
         CALL CHR2H (2, GPHFUN, 1, BUFF(GPHPOS+6))
         CALL COPY (2, RANGE, BUFF(GPHPOS+7))
         GPHPOS = GPHPOS + 8
C                                       TV
      ELSE
         NPTSX = GPHIX2 - GPHIX1 + 1
         NPTSY = GPHIY2 - GPHIY1 + 1
         CMAXTV(1) = GPHTVW(3) - GPHTVW(1) + 1
         CMAXTV(2) = GPHTVW(4) - GPHTVW(2) + 1
         IF ((NPTSX.GT.MAXXTV(1)) .OR. (NPTSY.GT.MAXXTV(2))) THEN
            WRITE (MSGTXT,1110) NPTSX, NPTSY
            CALL MSGWRT (6)
            IERR = 2
            GO TO 999
            END IF
C                                       set origin
         GPHIX0 = GPHCRN(1)
         GPHIY0 = GPHCRN(2)
C                                       center
         IF ((GPHIX0.LE.0) .OR. (GPHIY0.LE.0)) THEN
            NXA = GPHIX2 - GPHIX1 + GPHCHL + GPHCHR + GPHRX2 - GPHRX1
            NYA = GPHIY2 - GPHIY1 + GPHCHB + GPHCHT + GPHRY2 - GPHRY1
            IF (NXA.GT.CMAXTV(1)) THEN
               GPHTVW(1) = 1
               GPHTVW(3) = MAXXTV(1)
               CMAXTV(1) = MAXXTV(1)
               END IF
            IF (NXA.GT.MAXXTV(1)) THEN
               GPHIX0 = (MAXXTV(1) - NPTSX - GPHRX2 + GPHRX1) / 2 + 1
            ELSE
               GPHIX0 = GPHCHL + (CMAXTV(1) - NXA) / 2 + GPHTVW(1)
               END IF
            IF (NYA.GT.CMAXTV(2)) THEN
               GPHTVW(2) = 1
               GPHTVW(4) = MAXXTV(2)
               CMAXTV(2) = MAXXTV(2)
               END IF
            IF (NYA.GT.MAXXTV(2)) THEN
               GPHIY0 = (MAXXTV(2) - NPTSY - GPHRY2 + GPHRY1) / 2 + 1
            ELSE
               GPHIY0 = GPHCHB + (CMAXTV(2) - NYA) / 2 + GPHTVW(2)
               END IF
            END IF
         GPHSCX = GPHIX2 - GPHIX1
         GPHSCY = GPHIY2 - GPHIY1
C                                        update catalog header for img
         GPHCAT(IIWIN  ) = GPHIX1
         GPHCAT(IIWIN+1) = GPHIY1
         GPHCAT(IIWIN+2) = GPHIX2
         GPHCAT(IIWIN+3) = GPHIY2
         GPHCAT(IICOR  ) = GPHIX0
         GPHCAT(IICOR+1) = GPHIY0
         GPHCAT(IICOR+2) = GPHIX0 + GPHSCX
         GPHCAT(IICOR+3) = GPHIY0 + GPHSCY
         CALL CHR2H (2, GPHFUN, 1, GPHCAT(IITRA))
         CATR(IRRAN) = RANGE(1)
         CATR(IRRAN+1) = RANGE(2)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GINITG: INVALID GRAY RANGE:',2I7)
 1110 FORMAT ('GINITG: NUMBER PIXELS ',2I5,' EXCEEDS TV SIZE')
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QSPDIV (MODL, U, VS, INCVS, INCF, INCS, NCOMP, NVIS,
     *   NF, NS)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Divide Gaussian model  visibility into uv data.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Vector compiler version
C   Divides the model visibility derived from Gaussian components into
C   visibility records.  Arbitrary numbers of frequencies and
C   polarizations can be processed.  The weights of the visibilities
C   are multiplied times  the amplitude of the model visibility.
C   Inputs:
C      MODL  I    Base address of Gaussian components, increment=11
C                 0 = used (model amplitude)
C                 1 = used (PHASE)
C                 2 = used (REAL)
C                 3 = used (IMAG)
C                 4 = -2 * PI * X (radians)
C                 5 = -2 * PI * Y
C                 6 = -2 * PI * Z
C                 7 = R = radius * 3.0462740E-5
C                 8 = 3 * Amplitude
C                 9 = MIN = min arg (0.1 good)
C                10 = used (ARG)
C      U     I    Base address of U's, assumed followed by V, W
C      VS    I    Base address of vis rec. (real, imag, wt)
C      INCVS I    Increment of VS for next visibility
C      INCF  I    Increment of VS for next frequency
C      INCS  I    Increment of VS for next Stokes (RR or LL)
C      NCOMP I    Number of Gaussian components.
C      NVIS  I    Number of visibilities.
C      NF    I    Number of frequencies.
C      NS    I    Number of Stokes (usually 1 or 2)
C    Also uses AP locations 0 and 1 and expects an array
C    beginning in location 2 should be an array of length NF :
C             Freq(0) / Freq(ref) - 1.0
C             Freq(1) / Freq(0)   - 1.0
C                     .
C                     .
C                     .
C            Freq(NF-1) / Freq(NF-2) - 1.0
C   Note: all addresses are 0 relative and needed to be incremented by
C   1 to work in Fortran.
C   Note: the important loops to vectorize are 50,90,100,125 and 130.
C   Calls QRECT.
C-----------------------------------------------------------------------
      INTEGER   MODL, U, VS, INCVS, INCS, INCF, NCOMP, NVIS, NF, NS,
     *   PHASE, REAL, IMAG, X, JVS, F, IU, IVS, IF,
     *   IV, IS, JX, JPHAS, JAMP, ICOMP, LOOP, KAMP,
     *   KREAL, A, JA, AMP, ARG, JARG, R, JR, IMIN, JMIN
      REAL   FREQF, SUMRE, SUMIM, REMOD, IMMOD, WT, WTI, TEMP
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                        Make sure that there is data.
      IF ((NCOMP.LE.0) .OR. (NVIS.LE.0) .OR. (NF.LE.0) .OR.
     *   (NS.LE.0))  GO TO 999
C                                       Setup array addresses
      PHASE = MODL + 1
      REAL = PHASE + 1
      IMAG = REAL + 1
      X = MODL + 4
      R = MODL + 7
      AMP = MODL + 8
      IMIN = MODL + 9
      ARG = MODL + 10
      IU = U
      IVS = VS
C                                       Begin visibility loop
      DO 300 IV = 1,NVIS
C                                       Compute phase and amp argument
C                                       at ref. freq.
         JX = X + 1
         JR = R + 1
         JPHAS = PHASE + 1
         JARG = ARG + 1
         JMIN = IMIN + 1
C@DIR IGNORE RECRDEPS(APCORE)
         DO 50 LOOP = 1,NCOMP
C                                       Phase
            APCORE(JPHAS) = APCORE(JX) * APCORE(IU+1)
     *                    + APCORE(JX+1) * APCORE(IU+2)
     *                    + APCORE(JX+2) * APCORE(IU+3)
C                                       Amplitude
            APCORE(JARG) = APCORE(JR) *
     *         SQRT (APCORE(IU+1)*APCORE(IU+1) +
     *         APCORE(IU+2)*APCORE(IU+2))
C                                       Avoid numerical instability.
            APCORE(JARG) = MAX (APCORE(JARG), APCORE(JMIN))
C                                       Update pointers.
            JPHAS = JPHAS + 11
            JX = JX + 11
            JARG = JARG + 11
            JR = JR + 11
            JMIN = JMIN + 11
 50         CONTINUE
C                                        Get ready for freq. loop.
         JVS = IVS
         F = 2
         FREQF = 1.0
C                                        Begin frequency loop.
         DO 200 IF = 1,NF
C                                       Loop over component
            KREAL = MODL + 2
C                                       Check scaling
            IF (ABS (APCORE(F+1)).GT.1.0E-20) GO TO 110
C                                       Finish amplitudes
               JARG = ARG + 1
               JAMP = MODL + 1
               KAMP = AMP + 1
C@DIR IGNORE RECRDEPS(APCORE)
               DO 90 ICOMP = 1,NCOMP
                  APCORE(JAMP) = APCORE(KAMP) *
     *               (SIN (APCORE(JARG)) / (APCORE(JARG)**3) -
     *                COS (APCORE(JARG)) / (APCORE(JARG)**2))
                  JARG = JARG + 11
                  JAMP = JAMP + 11
                  KAMP = KAMP + 11
 90               CONTINUE
C                                       Convert to polar
               JAMP = MODL
               CALL QRECT (JAMP, 11, KREAL, 11, NCOMP)
               GO TO 130
C                                       Subsequent frequency
 110           FREQF = 1.0 + APCORE(F+1)
C                                       Scale frequency
               JARG = ARG + 1
               JPHAS = PHASE + 1
C@DIR IGNORE RECRDEPS(APCORE)
               DO 120 ICOMP = 1,NCOMP
                  APCORE(JPHAS) = FREQF * APCORE(JPHAS)
                  APCORE(JARG) = FREQF * APCORE(JARG)
                  JPHAS = JPHAS + 11
                  JARG = JARG + 11
 120              CONTINUE
C                                       Finish amplitudes
               JARG = ARG + 1
               JAMP = MODL + 1
               KAMP = AMP + 1
C@DIR IGNORE RECRDEPS(APCORE)
               DO 125 ICOMP = 1,NCOMP
                  APCORE(JAMP) = APCORE(KAMP) *
     *               (SIN (APCORE(JARG)) / (APCORE(JARG)**3) -
     *                COS (APCORE(JARG)) / (APCORE(JARG)**2))
                  JARG = JARG + 11
                  JAMP = JAMP + 11
                  KAMP = KAMP + 11
 125              CONTINUE
C                                       Convert to polar
               JAMP = MODL
               CALL QRECT (JAMP, 11, KREAL, 11, NCOMP)
C                                       Do sum
 130           SUMRE = 0.0
               SUMIM = 0.0
               REAL = MODL + 3
               IMAG = MODL + 4
C@DIR IGNORE RECRDEPS(APCORE)
               DO 140 ICOMP = 1,NCOMP
                  SUMRE = SUMRE + APCORE(REAL)
                  SUMIM = SUMIM + APCORE(IMAG)
                  REAL = REAL + 11
                  IMAG = IMAG + 11
 140              CONTINUE
C                                       Correct visibility
            JA = JVS + 1
C                                        Setup
            WT = (SUMRE * SUMRE + SUMIM * SUMIM)
            WT = MAX (1.0E-15, WT)
            WTI = 1.0 / WT
            REMOD = SUMRE * WTI
            IMMOD = SUMIM * WTI
            WT = SQRT (WT)
C                                       Loop over Stokes' (1 or 2,
C                                       no point in vectorizing)
            DO 150 IS = 1,NS
C                                       Divide model
               TEMP = REMOD * APCORE(JA) + IMMOD * APCORE(JA+1)
               APCORE(JA+1) = REMOD * APCORE(JA+1) - IMMOD * APCORE(JA)
               APCORE(JA) = TEMP
C                                       Modify weight
               APCORE(JA+2) = APCORE(JA+2) * WT
               JA = JA + INCS
 150           CONTINUE
C                                        Update vis pointer.
            JVS = JVS + INCF
            F = F + 1
 200        CONTINUE
C                                        Update pointers.
         IVS = IVS + INCVS
         IU = IU + INCVS
 300     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ZDATE (LDATE)
C-----------------------------------------------------------------------
C! return the local date
C# Z System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Returns local date
C   Output:
C      LDATE   I(3)   local date where
C                        LDATE(1)   year since 0.
C                        LDATE(2)   month (1-12).
C                        LDATE(3)   day   (1-31).
C   Generic version - stub
C-----------------------------------------------------------------------
      INTEGER   LDATE(3)
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      MSGTXT = 'ZDATE - TIME UNKNOWN UNTIL LOCAL DEVELOPMENT IS DONE'
      CALL MSGWRT (8)
C                                       set funny date
      LDATE(1) = 1999
      LDATE(2) = 2
      LDATE(3) = 31
C
 999  RETURN
      END

      PROGRAM BSTRT1
C-----------------------------------------------------------------------
C! BSRT1 starts all AIPS batch queues.
C# Batch Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BSTRT1 starts all AIPS batch queues.  It should be run whenever
C   the system is booted
C-----------------------------------------------------------------------
      CHARACTER ANAME*6, AIPVER*48, PHNAME*48, PRGNAM*6
      INTEGER  BUFFER(256), IP, OUPOPS, IERR, IER, TDLUN, TDIND,
     *   IRETCD, ITEMP, IPTR, PID(4), IREC
      REAL      RBUFF(256), TDL
      LOGICAL   T, F, ACTIVE
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (RBUFF, BUFFER)
      DATA PRGNAM /'BSTRT '/
      DATA TDLUN /13/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       AIPS init
      TSKNAM = PRGNAM
      CALL ZDCHIN (.TRUE.)
      ISBTCH = 32000
      CALL ZMYVER
      CALL ACOUNT (1)
      IF (NBATQS.GT.0) GO TO 10
         WRITE (MSGTXT,1000)
         CALL MSGWRT (8)
         GO TO 990
C                                        start QMNGR
 10   OUPOPS = NINTRN + 2
      CALL BLDTNM ('QMNGR', OUPOPS, ANAME, IERR)
      CALL FILL (4, 0, PID)
      CALL ZTACTQ (ANAME, PID, ACTIVE, IERR)
      IF ((IERR.EQ.0) .AND. (.NOT.ACTIVE)) GO TO 20
         WRITE (MSGTXT,1010) IERR
         IF (ACTIVE) WRITE (MSGTXT,1011) OUPOPS
         CALL MSGWRT (8)
         GO TO 100
C                                        open task data file: use
C                                        the batch guy's NPOPS area
 20   CALL ZPHFIL ('TD', 1, 0, 0, PHNAME, IERR)
      CALL ZOPEN (TDLUN, TDIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (8)
         GO TO 100
C                                        Parms data
 30   CALL FILL (256, 0, BUFFER)
C                                       user, dowait, tv, tk #'s
      BUFFER(1) = NLUSER
      BUFFER(2) = 0
      BUFFER(3) = 0
      BUFFER(4) = 0
      BUFFER(5) = ISBTCH
      BUFFER(6) = 0
      BUFFER(7) = 0
      BUFFER(8) = 0
      IPTR = 11
      RBUFF(IPTR-2) = -1.0
      CALL CHR2H (4, VERNAM, 1, RBUFF(IPTR-1))
C                                      Adverb: init's NPOPS
      RBUFF(IPTR) = NPOPS
      IREC = (OUPOPS-1)*3 + 2
      CALL ZFIO ('WRIT', TDLUN, TDIND, IREC, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 40
 35      WRITE (MSGTXT,1035) IERR
         CALL MSGWRT (8)
         GO TO 45
 40   CALL ZFIO ('READ', TDLUN, TDIND, 1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 35
      ITEMP = (OUPOPS-1)*5 + 1
      CALL CHR2H (6, 'QMNGR ', 1, RBUFF(ITEMP))
      IRETCD = -999
      BUFFER(ITEMP+2) = IRETCD
      BUFFER(ITEMP+3) = 0
      BUFFER(ITEMP+4) = 0
      CALL ZFIO ('WRIT', TDLUN, TDIND, 1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 35
 45   CALL ZCLOSE (TDLUN, TDIND, IER)
      IF (IERR.NE.0) GO TO 100
C                                        activate it finally
      WRITE (MSGTXT,1050) IP, OUPOPS
      CALL MSGWRT (2)
      AIPVER = VERNAM(1:3)
      CALL ZACTV8 ('QMNGR', OUPOPS, AIPVER, PID, IERR)
      IF (IERR.EQ.0) GO TO 60
         WRITE (MSGTXT,1051) IERR
         CALL MSGWRT (8)
         GO TO 100
C                                        suspend until QMNGR ok
 60   TDL = 3.0
      CALL TASKWT (ANAME, OUPOPS, PID, F, TDL, BUFFER, IRETCD, IERR)
C                                       ABORT not resume via TD
      IF ((IRETCD.NE.-999) .AND. (IERR.EQ.0)) GO TO 90
         WRITE (MSGTXT,1075)
         CALL MSGWRT (8)
         GO TO 100
C                                       Okay.
 90   CONTINUE
         WRITE (MSGTXT,1090)
         CALL MSGWRT (2)
 100  CONTINUE
C                                       Close down
 990  CALL ACOUNT (2)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('There are no batch queues to start')
 1010 FORMAT ('ZTACTQ ERROR',I7)
 1011 FORMAT ('Qmngr number',I4,' already running')
 1020 FORMAT ('TASK DATA FILE OPEN ERROR =',I7)
 1035 FORMAT ('TASK DATA FILE I/O ERROR =',I7)
 1050 FORMAT ('Starting queue',I3,' as POPS number',I4)
 1051 FORMAT ('ZACTV8 ERROR =',I7)
 1075 FORMAT ('Qmngr vanished without normal restart')
 1090 FORMAT ('OK')
      END

      SUBROUTINE QROLL (APCORE, NWORD, BUFFER, BUFSZ, IRET)
C-----------------------------------------------------------------------
C! Determines if time to roll AP, if so calls APROLL.
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   QROLL copies the first NWORDs of AP MD memory to a scratch file,
C   gives up the AP, does a task delay for DELAY, grabs an AP and loads
C   the scratch file back into the AP.  If NWORD <= 0, then the AP is
C   not rolled and the AP is given up and then reassigned.
C   NOTE: APROLL is called by QROLL and uses commom /CFILES/ for the
C   scratch file.  NOTE: LUN 8 is used for I/O and a AIPS "map" I/O
C   slot is opened if the AP memory is actually rolled.
C***********************************************************************
C   IMPORTANT NOTE:  QROLL (and APROLL) work properly only for floating
C   point data.  Integer values rolled will not be restored correctly.
C***********************************************************************
C   Inputs: NWORD    I       Number of words of AP memory to save.
C                            If <= 0 the contents of the AP memory are
C                            not saved.
C           BUFFER   R(*)    Work buffer.
C           BUFSZ    I       Size of BUFFER in bytes.
C   Inputs from COMMON /BPROLC/  (set by QINIT)
C           TRUEAP   L       True if a real AP (to be rolled)
C           XTLAST   D       Real time AP assigned (min).
C           DELTIM   D       Time interval between rolls (min).
C           DELAY    R       Time to delay task (seconds).
C   Output: IRET     I       Return error code, 0 => OK
C                               2 => could not reload AP.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   BUFSZ, NWORD, IRET
      REAL      BUFFER(*)
      INTEGER   LUN, ITIME(3)
      DOUBLE PRECISION    XTIME
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DBPR.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN /8/
C-----------------------------------------------------------------------
      IRET = 0
C                                       Check if true AP
      IF (.NOT.TRUEAP) GO TO 999
C                                       Check if time to roll out AP.
         CALL ZTIME (ITIME)
         XTIME = (ITIME(1)) * 60.00 + ITIME(2) + ITIME(3) / 60.0
C                                       Check if crossed midnight.
         IF (XTIME.LT.XTLAST) XTLAST = XTLAST - 1440.
         IF ((XTIME-XTLAST).LT.DELTIM) GO TO 999
C                                       Time to roll.
C                                       Reset last time.
         XTLAST = XTIME
C                                       Roll AP
C                                       Make sure /CFILES/ values OK.
 100     IF (NSCR.LE.0) NSCR = 0
         IF (NSCR.GT.21) NSCR = 0
         CALL APROLL (APCORE, LUN, NWORD, BUFFER, BUFSZ, DELAY, IRET)
         IF (IRET.LE.1) GO TO 110
            WRITE (MSGTXT,1100) IRET
            GO TO 990
 110     IRET = 0
         GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('QROLL: APROLL ERROR',I3)
      END

      PROGRAM CORFQ
C-----------------------------------------------------------------------
C! CORFQ corrects uvw for incorrect frequency.
C# UV VLA
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000, 2002, 2009, 2014
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CORFQ is an AIPS-System task to correct uvw for incorrect frequency
C   Inputs:
C     AIPS Adverb   Prg. Name          Description
C     NAMEIN         NAME          File name of data base to be
C                                   corrected.
C     CLASSIN        CLASS         Input file class.
C     SEQIN          SEQ           Input file sequence number.
C     DISKIN         DISK          Disk volumn on which file resides.
C     FACTOR         FACTOR        Correction for FREQ-uvw
C                                  0.0 => Corrects 2cm problem.
C   Programmer: W. D. Cotton, Sept. 1981.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:ZPBUFSZ.INC'
      CHARACTER PRGM*6, NAME*12, CLASS*6, FILE*48, UTYPE*2
      HOLLERITH XNAME(3), XCLASS(2)
      LOGICAL   RQUICK, T, F, UPDATE, DOSA, DOHEAD
      INTEGER   DISK, SEQ, LUN, FIND, BIND, IROUND,
     *   IPT2, BUFSZ, LUNH, LENBU, LUN2, FIND2, CNO2, USERID, BIND2,
     *   IERR, JERR, IRET, LUNA,
     *   NPARM, IVER, NIO, IPOINT, NKEY, NREC, NCOL, DATP(2,128),
     *   J, LOCS(1), KEYTYP(1)
      INTEGER   VO, BO, XCOUNT, ABUFF(512)
      REAL      XSEQIN, XVIN, BANDW, BUFF(UVBFSS), BUFF2(UVBFSS), XFAC
      DOUBLE PRECISION    FACTOR, VALUES(1)
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PUVD.INC'
      COMMON /INPARM/ XNAME, XCLASS, XSEQIN, XVIN, XFAC
      EQUIVALENCE (ABUFF, BUFF), (DATP, BUFF2)
      DATA LUN, LUN2, LUNH, LUNA /16, 17, 27, 28/
      DATA T, F /.TRUE.,.FALSE./
      DATA VO, BO, LENBU /0, 1, 16/
      DATA PRGM /'CORFQ '/
C-----------------------------------------------------------------------
C                                       Init I/O
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Get input parameters.
      IRET = 0
      NPARM = 8
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAME, BUFF, IERR)
      IF (IERR.EQ.0) GO TO 10
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
            IRET = 8
C                                       Restart AIPS.
 10   IF (RQUICK) CALL RELPOP (IRET, BUFF, IERR)
      IF (IRET.NE.0) GO TO 990
      IRET = 8
C                                       Decode input.
      CALL H2CHR (12, 1, XNAME, NAME)
      CALL H2CHR (6, 1, XCLASS, CLASS)
      USERID = NLUSER
      SEQ = IROUND (XSEQIN)
      DISK = IROUND (XVIN)
      FACTOR = ABS (XFAC)
      DOHEAD = XFAC.GE.0.0
C                                       Open file and get CATBLK.
      UPDATE = F
      UTYPE = 'UV'
      CALL MAPOPN ('HDWR', DISK, NAME, CLASS, SEQ, UTYPE, USERID, LUN2,
     *   FIND2, CNO2, CATBLK, BUFF2, IERR)
      IF (IERR.LE.1) GO TO 30
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (8)
         GO TO 990
C                                       Get info from CATBLK.
 30   CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 910
C                                       Determine FACTOR if default.
      BANDW = CATR(KRCIC+JLOCF)
      IF (BANDW.LE.0.0) BANDW = 50.0E6
      IF (FACTOR.LE.0.0) FACTOR = (FREQ - BANDW) / FREQ
      IF (DOHEAD) CATD(KDCRV+JLOCF) = FREQ * FACTOR
C                                       Initialize writing VIS. file.
      BUFSZ = UVBFSS * 2
      CALL UVINIT ('WRIT', LUN2, FIND2, NVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFF2, BO, BIND2, IERR)
      IPT2 = BIND2
      IF (IERR.EQ.0) GO TO 35
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (8)
         GO TO 910
 35   XCOUNT = 0
C                                       Open for Read.
      IVER = 1
      CALL ZPHFIL ('UV', DISK, CNO2, IVER, FILE, IERR)
      CALL ZOPEN (LUN, FIND, DISK, FILE, T, F, F, IERR)
      IF (IERR.GT.0) GO TO 910
      CALL UVINIT ('READ', LUN, FIND, NVIS, VO, LREC,LENBU, BUFSZ, BUFF,
     *   BO, BIND, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Start looping thru data.
 50   CONTINUE
C                                       Read buffer.
         XCOUNT = XCOUNT + 1
         CALL UVDISK ('READ', LUN, FIND, BUFF, NIO, BIND, IERR)
         IF (IERR.EQ.0) GO TO 60
            WRITE (MSGTXT,1050) IERR, XCOUNT
            CALL MSGWRT (8)
            GO TO 900
 60      IPOINT = BIND
         IF (NIO.LE.0) GO TO 90
C                                       Loop thru buffer.
            DO 70 J = 1,NIO
C                                       Correct uvw
               BUFF(IPOINT+ILOCU) = BUFF(IPOINT+ILOCU) * FACTOR
               BUFF(IPOINT+ILOCV) = BUFF(IPOINT+ILOCV) * FACTOR
               BUFF(IPOINT+ILOCW) = BUFF(IPOINT+ILOCW) * FACTOR
C                                       Copy to output buffer.
               CALL RCOPY (LREC, BUFF(IPOINT), BUFF2(IPT2))
C                                       Update IPOINT
               IPOINT = IPOINT + LREC
               IPT2 = IPT2 + LREC
 70            CONTINUE
C                                       Write output.
            CALL UVDISK ('WRIT', LUN2, FIND2, BUFF2, NIO, BIND2, IERR)
            IF (IERR.EQ.0) GO TO 80
               WRITE (MSGTXT,1070) IERR, XCOUNT
               CALL MSGWRT (8)
               GO TO 900
 80         IPT2 = BIND2
            GO TO 50
 90      CONTINUE
C                                       Flush output.
      NIO = 0
      CALL UVDISK ('FLSH', LUN2, FIND2, BUFF2, NIO, BIND2, IERR)
      IF (IERR.EQ.0) GO TO 100
         WRITE (MSGTXT,1070) IERR, XCOUNT
         CALL MSGWRT (8)
         GO TO 900
C                                       History
 100  CALL HIINIT (2)
      CALL HIOPEN (LUNH, DISK, CNO2, BUFF2, IERR)
      WRITE (MSGTXT,1100) PRGM, FACTOR
      CALL HIADD (LUNH, MSGTXT, BUFF2, IERR)
      CALL HICLOS (LUNH, T, BUFF2, IERR)
      IRET = 0
C                                       Change AN header.
 900  UPDATE = T
      IF (DOHEAD) THEN
         NKEY = 0
         NCOL = MAXANC
         CALL TABINI ('WRIT', 'AN', DISK, CNO2, 1, CATBLK, LUNA, NKEY,
     *      NREC, NCOL, DATP, ABUFF, JERR)
         IF (JERR.NE.0) GO TO 950
C                                       Update frequency
         MSGSUP = 32000
         DOSA = T
         CALL TABKEY ('READ', 'SAFREQ  ', 1, ABUFF, LOCS, VALUES,
     *      KEYTYP, IERR)
C                                       Check that 'FREQ' not used
C                                       instead of 'SAFREQ'
         IF (IERR.GT.0) THEN
            IERR = 0
            MSGSUP = 0
            CALL TABKEY ('READ', 'FREQ    ', 1, ABUFF, LOCS, VALUES,
     *         KEYTYP, IERR)
            IF (IERR.GT.0) THEN
               WRITE (MSGTXT,1200)
               GO TO 990
               END IF
            DOSA = F
         END IF
         VALUES(1) = VALUES(1) * FACTOR
         IF (DOSA) THEN
            CALL TABKEY ('WRIT', 'SAFREQ  ', 1, ABUFF, LOCS, VALUES,
     *         KEYTYP, IERR)
         ELSE
            CALL TABKEY ('WRIT', 'FREQ    ', 1, ABUFF, LOCS, VALUES,
     *         KEYTYP, IERR)
            END IF
         IF (JERR.LE.0) CALL TABIO ('CLOS', 1, XCOUNT, DATP, ABUFF,
     *      IERR)
         END IF
C                                       Close file.
 950  CALL ZCLOSE (LUN, FIND, JERR)
      IF (IERR.EQ.0) GO TO 910
         WRITE (MSGTXT,1900) JERR
         CALL MSGWRT (6)
C
 910  CALL MAPCLS ('WRIT', DISK, CNO2, LUN2, FIND2, CATBLK, UPDATE,
     *   BUFF, JERR)
C
 990  IRET = IERR
      CALL DIETSK (IRET, RQUICK, BUFF)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR:',I3,'GETTING INPUT PARAMETERS')
 1010 FORMAT ('ERROR:',I3,' OPENING UV FILE')
 1030 FORMAT ('ERROR:',I3,' INITILIZING UV FILE')
 1050 FORMAT ('ERROR:',I3,' READING VIS BLOCK ',I10)
 1070 FORMAT ('ERROR:',I3,' WRITING VIS BLOCK ',I10)
 1100 FORMAT (A5,1X,' Factor =',F10.5,' / freq-uvw correction')
 1200 FORMAT ('ERROR:',I3,' FINDING (SA)FREQ IN AN FILE, CHECK IT')
 1900 FORMAT ('ERROR:',I3,' CLOSING UV FILE ')
      END

      SUBROUTINE PLLINE (X, Y, IWRK, N, IRET)
C-----------------------------------------------------------------------
C! plot line beteen points
C# Utility Plot
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 2002, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to draw a line plot for data arrays X,Y
C   The input order of the arrays X and Y is ignored and the points are
C   connected in order of their X values.
C   Input:
C      N       I       Dimension of X, Y
C   Input/Output:
C      X       R(*)    Input array of X-data
C      Y       R(*)    Input array of Y-data
C      IWRK    I(*)    Integer work buffer for sort
C   Output:
C      IRET    I       Return code (0 => ok)
C-----------------------------------------------------------------------
      INTEGER   N, IRET
      REAL      X(N), Y(N)
      INTEGER   IWRK(N)
C
      INCLUDE 'INCS:DPLD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INTEGER I, J, IERR, ITMP
C-----------------------------------------------------------------------
C                                       Intialisation
      IRET = 0
      IF (N.LE.0) GO TO 999
C                                       Sort input arrays
      DO 10 I = 1,N
         IWRK(I) = I
 10      CONTINUE
C
      DO 30 I = 1,N-1
         DO 20 J = I+1,N
            IF (X(IWRK(J)).LT.X(IWRK(I))) THEN
               ITMP = IWRK(I)
               IWRK(I) = IWRK(J)
               IWRK(J) = ITMP
               END IF
 20         CONTINUE
 30      CONTINUE
C                                       line type 2
      CALL GLTYPE (2, PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Go to first point
      CALL PLPGO (X(IWRK(1)), Y(IWRK(1)), IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Draw line segments
      DO 50 I = 2,N
         CALL PLDRW (X(IWRK(I)), Y(IWRK(I)), IERR)
         IF (IERR.NE.0) GO TO 970
 50      CONTINUE
      GO TO 999
C                                       Error in plot internals
 970  IRET = 1
      WRITE (MSGTXT,1970) IERR
C                                       Exit
 999  RETURN
C---------------------------------------------------------------------
 1970 FORMAT ('PLLINE: ERROR',I3,' FROM PLDRW')
      END

      SUBROUTINE QGSP (I, NREG)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Read "S-pad" register
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Simulates the array processor subroutine which reads the
C   contents of a scratch-pad register.  Given an register
C   number, NREG, the register contents are  returned in I.
C   Input:
C      NREG  I  Spad register number
C   Output:
C      I     I  Contents of SPAD register NREG.
C   NOTE: this function will eventually be eliminated.
C-----------------------------------------------------------------------
      INTEGER   I, NREG
C
      INCLUDE 'INCS:DAPM.INC'
C-----------------------------------------------------------------------
      I = SPAD(NREG)
C
 999  RETURN
      END

      SUBROUTINE CITSKP (S, N, I)
C-----------------------------------------------------------------------
C! KEYIN routine: Find next non blank character in a string.
C# Parsing
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1999
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Finds next non blank character in a loose string.
C    Inputs:
C      S(N)  C    String to search
C      N     I    Length of string
C      I     I    First character to search
C    Outputs:
C      I     I    Next non blank character, or N if none found.
C   T.J.PEARSON  1978 MAY 11
C   MODIFIED 1979 FEB 6  (VAX/VMS FORTRAN 4)
C   Modified  1985 June for AIPS and renamed
C-----------------------------------------------------------------------
      CHARACTER S*(*), BLANK*1, TAB*1, CR*1
      INTEGER   I, N
      CHARACTER ZSCHAR
      EXTERNAL  ZSCHAR
      DATA      BLANK /' '/
C-----------------------------------------------------------------------
      TAB = ZSCHAR ('tab')
      CR  = ZSCHAR ('cr')
   10 IF (I.GT.N) GO TO 999
         IF (S(I:I).NE.BLANK .AND. S(I:I).NE.TAB
     *       .AND. S(I:I).NE.CR) GO TO 999
         I = I + 1
         GO TO 10
C
 999  RETURN
      END

      SUBROUTINE ZVTPX2 (FCB, BUFSW, BUFSR, BUFFER, IERR)
C-----------------------------------------------------------------------
C! writes/reads to/from server for the client (virtual tape) machine
C# Tape Z2
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZVTPX2 transfers data between the clent (virtual tape) machine and
C   the server (actual tape) computer
C   Inputs:
C      FCB     I(*)   File descriptor
C      BUFSW   I      Number of data words (each 32 bits) to send beyond
C                     the header.
C   In/out:
C      BUFFER  I(*)   Data buffer: header + data
C   Output:
C      BUFSR   I      Number of data words (each 32 bits) read back
C                     beyond the header
C      IERR    I      Error: 0 => okay
C   Generic version - stub.
C   The header format is, in 32-bit words:
C       1,2    H(2)   Subroutine name
C       3      I      BUFSW
C       4      I      BUFSR
C       5      I      IERR
C   Data begins in the 6th 32-bit word in any format agreed between
C   TPMON and the relevant subroutine.  E.g.,
C      ZTAPE:  header   = 'ZTAPE    ', 3, 0, 0
C              data in  = OPcode, LUN, Count
C              out      = only header word 5 (IERR) used
C      ZTPMIO: header   = 'ZTPMIO  ',  4, 2+n, 0              (read)
C              data in  = 'READ', LUN, Nbytes, Buf#
C              data out = SysError, BytesXfer, buffer(N)
C      ZTPMIO: header   = 'ZTPMIO  ',  4+n, 2, 0              (write)
C              data in  = 'WRIT', LUN, Nbytes, Buf#, buffer(N)
C              data out = SysError, BytesXfer
C              where N = # local words to Xfer Nbytes of data
C                    n = # 32-bit words to Xfer Nbytes of data
C              header word 5 (IERR) also used on output.
C-----------------------------------------------------------------------
      INTEGER   FCB(*), BUFSW, BUFSR, BUFFER(*), IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 8
      MSGTXT = 'ZVTPX2: REQUIRES DEVELOPMENT; GENERIC IS A STUB'
      CALL MSGWRT (8)
C
 999  RETURN
      END

LOCAL INCLUDE 'SPCAL.INC'
C                                                         Include SPCAL
C                                       Local include for SPCAL
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   MAXBUF, MAXCAL, MAXDAT
C                                       Size of local data buffer.
      PARAMETER (MAXBUF=5000000)
C                                       Max. no. visibilities
      PARAMETER (MAXDAT=10000)
C                                       Max. no. calibrators
      PARAMETER (MAXCAL=20)
C                                       Inputs adverbs
      REAL   XSI, XDI, XTIME(8), XBAND, XFREQ, XFQID, XBIF, XANTS(50),
     *   XUVRA(2), XSUBA, XBCHAN, XECHAN, XDOCAL, XGUSE, XBLVER, XFLAG,
     *   XDOBND, XBPVER, XSMOTH(3), XSOLIN, XPRTLV, XREF, XBADD(10),
     *   SOLINT
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XXSOLT(1)
      CHARACTER NAMEIN*12, CLAIN*6, XSOUR(30)*16, XSOLTY*4
      INTEGER FREQID, NCHAN, IPRT, IAREF
      COMMON /XINPUT/ XNAMEI, XCLAIN, XSI, XDI, XXSOUR, XTIME, XBAND,
     *   XFREQ, XFQID, XBIF, XANTS, XUVRA, XSUBA, XBCHAN, XECHAN,
     *   XDOCAL, XGUSE, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH, XSOLIN,
     *   XXSOLT, XPRTLV, XREF, XBADD, SOLINT, IPRT, IAREF, FREQID, NCHAN
      COMMON /CHRCOM/ NAMEIN, CLAIN, XSOUR, XSOLTY
C                                       File/table buffers.
      REAL      BUFF1(UVBFSS), BUFF2(UVBFSS)
      INTEGER   JBUFSZ, IBUFF1(UVBFSS), IBUFF2(UVBFSS)
      EQUIVALENCE (IBUFF1, BUFF1), (IBUFF2, BUFF2)
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
C                                       Catalog header info.
      LOGICAL   SINGLE
      INTEGER   CATIN(256), DISKIN, SEQIN, CNOIN
      COMMON /CINFO/ SINGLE, CATIN, DISKIN, SEQIN, CNOIN
C                                       Local data buffer
      LOGICAL ISXY
      REAL TIME(MAXDAT), PARAN(2,MAXDAT), VISBUF(MAXBUF)
      INTEGER ANTS(2,MAXDAT), NUMDAT
      COMMON /VDATA/ TIME, PARAN, VISBUF, ISXY, NUMDAT, ANTS
C                                                          End SPCAL
LOCAL END
      PROGRAM SPCAL
C-----------------------------------------------------------------------
C! Determines Antenna polarization characteristics
C# UV Calibration AP-appl EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2000, 2003-2004, 2006-2007, 2009, 2015-2016, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SPCAL computes feed polarization parameters for spectral line
C   UV-data and enters them in the AN table.
C   Input adverbs:
C      INNAME          Input UV file name (name)
C      INCLASS         Input UV file name (class)
C      INSEQ           Input UV file name (seq. #)
C      INDISK          Input UV file disk unit #
C                      Data selection (multisource):
C      CALSOUR         Sources to calibrate with
C      TIMERANG        Time range to use.
C      SELBAND         Bandwidth to select (kHz)
C      SELFREQ         Frequency to select (MHz)
C      FREQID          Freq. ID to select.
C      BIF             IF number.
C      ANTENNAS        Antennas to solve for.
C      UVRANGE         UV range in kilolamdba
C      SUBARRAY        Subarray, 0=>all
C      BCHAN           Lowest channel number 0=>all
C      ECHAN           Highest channel number 0=>all
C                      Cal. info for input:
C      FLAGVER         Flag table version
C      DOCALIB         If >0 calibrate data
C      GAINUSE         CAL table to apply.
C      SOLINT          Soln. interval (min) 0=>10.
C      PRTLEV          Print statistics 0=>none
C                      1 = some, 2 = lots. Use 1.
C      REFANT          Reference antenna, 0=none.
C      BADDISK         Disk no. not to use for scratch files.
C---------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'SPCAL.INC'
      DATA PRGM /'SPCAL '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL SPCIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Determine poln. parameters.
      CALL SPCUV (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       History
      CALL SPCHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, IBUFF1)
C
 999  STOP
      END
      SUBROUTINE SPCIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   SPCIN gets input parameters for SPCAL and catalog header information.
C   Inputs:
C      PRGN    C*6     Program name
C   Output:
C      IRET    I         Error code: 0 => ok; <> 0 => error.
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, UTYPE*2
      HOLLERITH CATH(256)
      INTEGER   IERR, NPARM, I, NUMSUB, IROUND, LUN1, NUMAN(513)
      LOGICAL   T, F, TABLE, EXIST, FITASC, MATCH
      REAL      CATR(256), CATINR(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'SPCAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DANT.INC'
      EQUIVALENCE (NUMAN, BUFF2)
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      EQUIVALENCE (CATIN, CATINR)
      DATA LUN1 /28/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      TSKNAM = PRGN
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = 2 * UVBFSS
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
C                                       Get input parameters.
      NPARM = 217
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, IBUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, IBUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSI)
      DISKIN = IROUND (XDI)
      IPRT = XPRTLV + 0.1
      IPRT = MAX (IPRT, 0)
      IAREF = IROUND (XREF)
      SOLINT = XSOLIN / (24.0 * 60.0)
C                                       Default solution
C                                       interval of 10 min.
      IF (SOLINT.LE.0.0) SOLINT = 10.0 / (24.0 * 60.0)
C                                       Convert Hollerith strings.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
 20      CONTINUE
      CALL H2CHR (4, 1, XXSOLT, XSOLTY)
      IF (XSOLTY.NE.'RAPR') XSOLTY = 'ZAPR'
C                                       Get CATBLK from uv file.
      CNOIN = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, IBUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'REST', IBUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1050) IRET
         GO TO 990
         END IF
C                                       Save input header.
      CALL COPY (256, CATBLK, CATUV)
      CALL COPY (256, CATBLK, CATIN)
C                                       See if a multiple source file
      LUNS(1) = 29
      CALL ISTAB ('SU', DISKIN, CNOIN, 1, LUNS, IBUFF1, TABLE, EXIST,
     *   FITASC, IERR)
C                                       Get uv header info.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
      SINGLE = (.NOT.EXIST) .OR. (IERR.NE.0) .OR. (ILOCSU.LT.0)
C                                       Baddisk
      DO 70 I = 1,10
         IBAD(I) = IROUND (XBADD(I))
 70      CONTINUE
C                                       Linearly polarized feeds?
      ISXY = CATD(KDCRV+JLOCS) .LT. -4.0D0
C                                       Check sort order, must be T*
      IF (ISORT(1:1).NE.'T') THEN
         IRET = 4
         WRITE (MSGTXT,1070) ISORT, 'T*'
         GO TO 990
         END IF
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DO 80 I = 1,30
         SOURCS(I) = XSOUR(I)
         CALSOU(I) = ' '
 80      CONTINUE
      CALL RCOPY (8, XTIME, TIMRNG)
      DXTIME = 0.0
      UVRNG(1) = XUVRA(1)
      UVRNG(2) = XUVRA(2)
      STOKES = 'FULL'
      BCHAN = IROUND (XBCHAN)
      BCHAN = MAX (1, MIN (BCHAN, CATBLK(KINAX+JLOCF)))
      ECHAN = IROUND (XECHAN)
      IF (ECHAN.LT.BCHAN) ECHAN = CATBLK(KINAX+JLOCF)
      ECHAN = MAX (1, MIN (ECHAN, CATBLK(KINAX+JLOCF)))
      NCHAN = ECHAN - BCHAN + 1
      IF (JLOCIF.GE.0) THEN
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, CATBLK(KINAX+JLOCIF)))
      ELSE
         BIF = 1
         END IF
      EIF = BIF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN1, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, IRET)
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1060)
         IRET = 1
         GO TO 990
         END IF
      IF (IRET.GT.0) GO TO 999
      FREQID = FRQSEL
C                                       Antennas
      DO 85 I = 1,50
         ANTENS(I) = IROUND (XANTS(I))
 85      CONTINUE
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LE.0) SUBARR = 1
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      BLVER = IROUND (XBLVER)
      FGVER = IROUND (XFLAG)
      CLVER = 0
      CLUSE = IROUND (XGUSE)
      DOPOL = -1
      DOSMTH = 0
      CALL RFILL (3, 0.0, SMOOTH)
      DOACOR = F
      DOFQSL = F
      INITVS = 1
C                                       Find number of subarrays
      CALL FNDEXT ('AN', CATBLK, NUMSUB)
      NUMSUB = MAX (1, NUMSUB)
      IF (NUMSUB.LT.SUBARR) THEN
         WRITE (MSGTXT,1160) SUBARR, NUMSUB
         GO TO 990
         END IF
C                                       Find number of antennas.
      CALL GETNAN (DISKIN, CNOIN, CATBLK, LUN1, IBUFF1, NUMAN, IRET)
      IF (IRET.NE.0) GO TO 999
      NUMANT = NUMAN(2)
      IF (SUBARR .LE. NUMAN(1)) NUMANT = NUMAN(1+SUBARR)
C                                       Number of IFs
      NUMIF = 1
      IF (JLOCIF.GE.0) NUMIF = CATBLK(KINAX+JLOCIF)
C                                       Number of polarizations
      NUMPOL = CATBLK(KINAX+JLOCS)
C                                       Check for full polzn.
      IF (NUMPOL.LT.4) THEN
         WRITE (MSGTXT,1170)
         IRET = 9
         GO TO 990
         ENDIF
C                                       Get antenna info
      CALL GETANT (DISKIN, CNOIN, SUBARR, CATBLK, IBUFF1, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Source selection.
      DOAPPL = F
      SELQUA = -1
      SELCOD = '    '
C      CALL SOUFIL (IRET)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPCIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,' . ',A6,' . ',
     *   I3,' DISK=',I3,' USID=',I4)
 1050 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1060 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
 1070 FORMAT ('SORT ORDER IS ',A2,' NOT ',A2,' AS REQUIRED')
 1160 FORMAT ('SPECIFIED SUBARRAY ',I4,' > MAX. OF ',I4)
 1170 FORMAT ('UV-DATA FILE LACKS ALL FOUR POLZN. PAIRS')
      END
      SUBROUTINE SPCUV (IRET)
C-----------------------------------------------------------------------
C   SPCUV fits model parameters and enters them into the AN table.
C   Output:
C      IRET        I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      HOLLERITH CATINH(256)
      INTEGER   VERTMP, LUNNEW, LUNOLD, I, SOLTYP, NIF, MSGSAV
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'SPCAL.INC'
      COMPLEX DDD(2,MAXANT)
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATIN, CATINH)
      DATA LUNNEW, LUNOLD /27,28/
C-----------------------------------------------------------------------
C                                       Load calibrated data into
C                                       local buffer.
      CALL PCLSEL (IRET)
C                                       Check if any data:
      IF (IRET.NE.0) GO TO 999
C                                       Fit for feed parameters:
C                                       Similarity method
      IF (XSOLTY.EQ.'RAPR') THEN
C                                       Assumes linear polarization
C                                       is a scaled version of total
C                                       intensity in each channel.
         SOLTYP = 4
         CALL RPCALC (IPRT, IAREF, NUMANT, DDD, IRET)
      ELSE
C                                       Assumes circularly polarized
C                                       feeds and moderate linear
C                                       polarization.
         SOLTYP = 4
         CALL ZPCALC (IPRT, IAREF, NUMANT, DDD)
         END IF
      IF (IRET.NE.0) GO TO 999
      XREF = IAREF
C                                       Save feed parameters.
      DO 100 I = 1,NUMANT
         STNELP(1,BIF,I) = REAL (DDD(1,I))
         STNELP(2,BIF,I) = REAL (DDD(2,I))
         STNORI(1,BIF,I) = AIMAG (DDD(1,I))
         STNORI(2,BIF,I) = AIMAG (DDD(2,I))
 100     CONTINUE
C                                       Rewrite An table
C                                       Find number of AN tables:
      CALL FNDEXT ('AN', CATIN, VERTMP)
      IF (VERTMP.GT.0) VERTMP = VERTMP + 1
C                                       Copy to a temporary AN table.
      IF (JLOCIF.GE.0) THEN
         NIF = CATIN(KINAX+JLOCIF)
      ELSE
         NIF = 1
         END IF
      CALL PUTANT (DISKIN, CNOIN, SUBARR, VERTMP, BIF, EIF, NIF,
     *   SOLTYP, CATIN, IBUFF1, IBUFF2, FREQID, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Delete old
      CALL RMEXT (DISKIN, CNOIN, 'AN', SUBARR, CATIN, IBUFF1, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy back.
      MSGSAV = MSGSUP
      MSGSUP = 31999
      CALL TABCOP ('AN', VERTMP, SUBARR, LUNOLD, LUNNEW, DISKIN, DISKIN,
     *   CNOIN, CNOIN, CATIN, IBUFF1, IBUFF2, IRET)
      MSGSUP = MSGSAV
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1610) IRET
         GO TO 990
         END IF
C                                       Delete temporary
      CALL RMEXT (DISKIN, CNOIN, 'AN', VERTMP, CATIN, IBUFF1, IRET)
      IF (IRET.NE.0) GO TO 999
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
1610  FORMAT ('TABCOP ERROR ',I3,' UPDATING AN TABLE')
      END
      SUBROUTINE SPCHIS
C-----------------------------------------------------------------------
C   Routine to copy and update the history file.
C-----------------------------------------------------------------------
      CHARACTER CTIME(2)*12, HILINE*72
      INTEGER   LUN, IERR, I, ITIME(3), DATE(3)
      LOGICAL   T
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'SPCAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN /28/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write history.
      CALL HIINIT (3)
C                                       Open old history.
      CALL HIOPEN (LUN, DISKIN, CNOIN, IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Task message.
      CALL ZDATE (DATE)
      CALL ZTIME (ITIME)
      CALL TIMDAT (ITIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,1000) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Add selection/calibration
C                                       criteria:
C                                       Sources:
      IF (NSOUWD.LE.0) THEN
         WRITE (HILINE,3000) TSKNAM
         CALL HIADD (LUN, HILINE, IBUFF2, IERR)
      ELSE
C                                       Included or excluded ?
         WRITE (HILINE,3001) TSKNAM
         IF (DOSWNT) WRITE (HILINE,3002) TSKNAM
         CALL HIADD (LUN, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       1st and 2nd label.
         IF (.NOT.SINGLE) THEN
            WRITE (HILINE,3003) TSKNAM, XSOUR(1), XSOUR(2)
            CALL HIADD (LUN, HILINE, IBUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
C                                       Rest of sources.
            IF (NSOUWD.GT.2) THEN
               DO 20 I = 3,NSOUWD,2
                  WRITE (HILINE,3004) TSKNAM, XSOUR(I), XSOUR(I+1)
                  CALL HIADD (LUN, HILINE, IBUFF2, IERR)
                  IF (IERR.NE.0) GO TO 190
 20               CONTINUE
               END IF
            END IF
         END IF
C                                       Time range.
      CALL HITIME (TSTART, TEND, LUN, IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Subarray.
      WRITE (HILINE,3013) TSKNAM, SUBARR
      CALL HIADD (LUN, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Flag table.
      WRITE (HILINE,3014) TSKNAM, FGVER
      IF (DOFLAG) CALL HIADD (LUN, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Calibration info.
C                                       Gain tables.
      IF (DOCAL) WRITE (HILINE,3019) TSKNAM, CLUSE
      CALL HIADD (LUN, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Solution interval.
      WRITE (HILINE,2022) TSKNAM, XSOLIN
      CALL HIADD (LUN, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Solution type.
      WRITE (HILINE,2023) TSKNAM, XSOLTY
      CALL HIADD (LUN, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Reference antenna.
      I = XREF + 0.5
      WRITE (HILINE,2024) TSKNAM, I
      CALL HIADD (LUN, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       IF's.
      WRITE (HILINE,2025) TSKNAM, BIF
      CALL HIADD (LUN, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Close history file.
 190   CALL HICLOS (LUN, T, IBUFF2, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* START ',
     *   A12,2X,A8)
 2022 FORMAT (A6,' SOLINT =',F10.3,' /SOLUTION INTERVAL (MIN)')
 2023 FORMAT (A6,' SOLTYPE =''',A4,''' /POLN. SOLUTION TYPE')
 2024 FORMAT (A6,' REFANT =',I4,' / REFERENCE ANTENNA')
 2025 FORMAT (A6,' BIF =',I3,' /IF NUMBER')
 3000 FORMAT (A6,' SOURCES = ''''     /ALL SOURCES SELECTED')
 3001 FORMAT (A6,' /SOURCES EXCLUDED:')
 3002 FORMAT (A6,' /SOURCES INCLUDED:')
 3003 FORMAT (A6,' SOURCES = ''',A16,''',''',A16,'''')
 3004 FORMAT (A6,'          ,''',A16,''',''',A16,'''')
 3013 FORMAT (A6,' SUBARRAY =',I4)
 3014 FORMAT (A6,' FLAGVER =',I3,' /FLAGGING TABLE USED')
 3019 FORMAT (A6,' GAINUSE = ',I3,' /CL TABLE APPLIED')
      END
      SUBROUTINE PCLSEL (IRET)
C-----------------------------------------------------------------------
C   Reads a multi-source uv-data file into common arrays.
C   Output:
C      IRET        I    Termination status; 0=> ok
C-----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'INCS:PUVD.INC'
      LOGICAL   WEOF, WGOOD, WPOLZN(1000), WSTOK(4)
      REAL      TIME2, RPARM(20), VIS(MAXCIF*3), CTIME, WT, SUMWT(1000),
     *   PANGLE(MAXANT)
      INTEGER   NUMBL, NRECSZ, NLSOU, IA1, IA2, JNDX, JBASE, MNDX,
     *   JCHAN, JSTOK, KNDX, NBUFF, LUN1, NDAT, KNDX1, INDX, NFILL,
     *   NFILL2
      INCLUDE 'SPCAL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUN1 /27/
C-----------------------------------------------------------------------
C                                       Pre-average time interval
      NUMBL = (NUMANT * (NUMANT - 1)) / 2
      NRECSZ = 12 * NCHAN
      TIME2 = -999.0
      NLSOU = -10
      NUMDAT = 0
C                                       Open data file.
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Initialise vis. buffer.
      NBUFF = NUMBL * NRECSZ
      CALL RFILL (NBUFF, 0.0, VISBUF)
C                                       Read UV record.
 50   CALL UVGET ('READ', RPARM, VIS, IRET)
      WEOF = IRET .EQ. -1
      IF ((IRET.LT.-1).OR.(IRET.GT.0)) GO TO 999
C                                       Extract UV parameters.
      CTIME = RPARM (ILOCT+1)
      IF (ILOCB.GE.0) THEN
         IA1 = RPARM(ILOCB+1) / 256.0 + 0.1
         IA2 = RPARM(ILOCB+1) - IA1*256 + 0.1
      ELSE
         IA1 = RPARM(ILOCA1+1) + 0.1
         IA2 = RPARM(ILOCA2+1) + 0.1
         END IF
      IF (ILOCSU.GE.0) CURSOU = RPARM(ILOCSU+1) + 0.1
C                                       Normalise
      IF ((CURSOU.NE.NLSOU).OR.(CTIME.GT.TIME2).OR.(WEOF)) THEN
         NDAT = NUMDAT
         DO 200 JBASE = 1,NUMBL
            WGOOD = .FALSE.
            MNDX = NDAT + JBASE
            DO 180 JCHAN = 1,NCHAN
               DO 160 JSTOK = 1,4
                  INDX = (MNDX-1)*NRECSZ+12*(JCHAN-1)+3*(JSTOK-1)+1
                  WT = VISBUF(INDX+2)
                  IF (WT.GT.0) THEN
                     VISBUF(INDX) = VISBUF(INDX) / WT
                     VISBUF(INDX+1) = VISBUF(INDX+1) / WT
                     WGOOD = .TRUE.
                  ELSE
                     VISBUF(INDX+2) = -1.0
                     ENDIF
 160              CONTINUE
 180           CONTINUE
C                                       Do not store null of
C                                       incomplete spectra
C                                       in the common arrays.
            IF (WGOOD.OR.WPOLZN(JBASE)) THEN
               NUMDAT = NUMDAT + 1
               KNDX = (NUMDAT - 1) * NRECSZ + 1
               KNDX1 = (MNDX - 1) * NRECSZ + 1
               CALL RCOPY (NRECSZ, VISBUF(KNDX1), VISBUF(KNDX))
               ANTS(1,NUMDAT) = ANTS(1,MNDX)
               ANTS(2,NUMDAT) = ANTS(2,MNDX)
               PARAN(1,NUMDAT) = PARAN(1,MNDX) / SUMWT(JBASE)
               PARAN(2,NUMDAT) = PARAN(2,MNDX) / SUMWT(JBASE)
               TIME(NUMDAT) = TIME(MNDX) / SUMWT(JBASE)
               ENDIF
 200        CONTINUE
C                                       Set accumulation limits.
         TIME2 = CTIME + SOLINT
C                                       Clear buffers.
         CALL RFILL (NUMBL, 0.0, SUMWT)
         JNDX = NUMDAT * NRECSZ + 1
         NBUFF = NUMBL * NRECSZ
C                                       Check array bounds
         IF ((JNDX+NBUFF-1).GT.MAXBUF) THEN
            IRET = 1
            WRITE (MSGTXT,1230)
            GO TO 990
            END IF
C
         CALL RFILL (NBUFF, 0.0, VISBUF(JNDX))
         DO 220 JBASE = 1,NUMBL
            WPOLZN(JBASE) = .FALSE.
 220        CONTINUE
         NFILL = MIN (NUMBL, MAXDAT - NUMDAT)
         NFILL2 = 2 * NFILL
         CALL RFILL (NFILL, 0.0, TIME(NUMDAT+1))
         CALL RFILL (NFILL2, 0.0, PARAN(1,NUMDAT+1))
         ENDIF
C                                       Accumulate the current record.
      IF (WEOF) GO TO 400
C                                       New Source ?
      IF (CURSOU.NE.NLSOU) THEN
         CALL GETSOU (CURSOU, DISKIN, CNOIN, CATUV, LUN1, IRET)
         IF (IRET.NE.0) GO TO 999
         NLSOU = CURSOU
         ENDIF
C                                       Compute the parallactic angle.
      CALL PARANG (CTIME, PANGLE)
      JBASE = (IA1 - 1) * NUMANT - (IA1 + 1) * IA1 / 2 + IA2
      MNDX = NUMDAT + JBASE
C                                       Check array bounds
      IF (MNDX.GT.MAXDAT) THEN
         IRET = 1
         WRITE (MSGTXT,1230)
         GO TO 990
         END IF
C
      ANTS(1,MNDX) = IA1
      ANTS(2,MNDX) = IA2
      DO 300 JCHAN = 1,NCHAN
         DO 280 JSTOK = 1,4
            WSTOK(JSTOK) = .FALSE.
            JNDX = (MNDX-1)*NRECSZ + 12*(JCHAN-1) + 3*(JSTOK-1) + 1
            INDX = 1 + (JSTOK - 1) * INCS + (JCHAN - 1) * INCF
            WT = VIS(INDX+2)
            IF (WT.GT.0) THEN
               WSTOK(JSTOK) = .TRUE.
               VISBUF(JNDX) = VISBUF(JNDX) + VIS(INDX) * WT
               VISBUF(JNDX+1) = VISBUF(JNDX+1) + VIS(INDX+1) * WT
               VISBUF(JNDX+2) = VISBUF(JNDX+2) + WT
               TIME(MNDX) = TIME(MNDX) + CTIME * WT
               PARAN(1,MNDX) = PARAN(1,MNDX) + PANGLE(IA1) * WT
               PARAN(2,MNDX) = PARAN(2,MNDX) + PANGLE(IA2) * WT
               SUMWT(JBASE) = SUMWT(JBASE) + WT
               ENDIF
 280        CONTINUE
         WPOLZN(JBASE) = WPOLZN(JBASE) .OR.
     *      (WSTOK(1).AND.WSTOK(2).AND.WSTOK(3)) .OR.
     *      (WSTOK(1).AND.WSTOK(2).AND.WSTOK(4))
 300     CONTINUE
C                                       Until EOF ?
 400  CONTINUE
      IF (.NOT.WEOF) GO TO 50
C                                       Close the UV data file.
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C--------------------------------------------------------------------
1230  FORMAT ('BUFFER OVERFLOW; INCREASE SOLUTION INTERVAL')
      END
      SUBROUTINE RPCALC (IPRTLV, IREF, N, D, IRET)
C--------------------------------------------------------------------
C   Calculate the antenna feed solutions.
C   Input parameter:
C      IPRTLV    I       Print level.
C      IREF      I       Reference antenna (0=> minimize rms
C                        antenna values.
C      N         I       Number of antennas.
C   Output parameter.
C      D         CX(2,*) R,L feed solutions for each antenna.
C      IRET      I       Termination status (0=> ok)
C-------------------------------------------------------------------
      INTEGER IREF, IRET, IPRTLV, N
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER NVMAX, NVMAX1
      PARAMETER (NVMAX = 2*MAXANT + 128)
      PARAMETER (NVMAX1 = NVMAX + 1)
      INCLUDE 'SPCAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMPLEX AHA(NVMAX1,NVMAX1), AHB(NVMAX), WORK(NVMAX1),
     *   ZP1, ZP2, ZC(3), ZRR, ZLL, ZRL, ZLR, ZLRC, ZII,
     *   D(2,MAXANT), ZION1, ZION2
      DOUBLE PRECISION BHB, DPANG1, DPANG2, S, EPS,
     *   DXC(NVMAX), DRMS, DTIM
      REAL RTD, WTRL, WTLR, WTRR, WTLL, TEMP, SWT, RMS, AMP, AMPERR,
     *   PHASE, PHASER, E, FR1, FR2, DET(2), XRE, XIM, DOF, SWT2
      INTEGER LDA, NVAR, I, J, K, JCHAN, IA1, IA2, JNDX, I1, I2, I3,
     *   KNVAR, JOB, NVAR1, JPVT(NVMAX1), INFO, KOBS, NRECSZ, IER,
     *   COBS(MAXANT)
C-------------------------------------------------------------------
      IRET = 0
      MSGTXT = 'Determining feed solutions'
      CALL MSGWRT (6)
C                                       Set constants.
      NRECSZ = 12 * NCHAN
      RTD = 45.0 / ATAN (1.0)
      LDA = NVMAX1
      NVAR = 2 * N + NCHAN
C                                       Check array dimensions
      IF (NVAR.GT.NVMAX) THEN
         IRET = 1
         WRITE (MSGTXT,1020) NVAR, NVMAX
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Set up the normal equations.
      DO 20 I = 1,NVAR
         AHB(I) = (0.0, 0.0)
         DO 15 J = 1,NVAR
            AHA(I,J) = (0.0, 0.0)
 15         CONTINUE
 20      CONTINUE
      BHB = 0.0D0
      SWT = 0.0
      SWT2 = 0.0
      KOBS = 0
C                                       Loop over the observations.
      CALL FILL (MAXANT, 0, COBS)
      DO 100 K = 1,NUMDAT
         IA1 = ANTS(1,K)
         IA2 = ANTS(2,K)
         DO 80 JCHAN = 1,NCHAN
            JNDX = (K-1) * NRECSZ + 12*(JCHAN-1) + 1
C                                       Visiblities (RR,LL,RL,LR).
            ZRR = CMPLX (VISBUF(JNDX), VISBUF(JNDX+1))
            ZLL = CMPLX (VISBUF(JNDX+3), VISBUF(JNDX+4))
            ZRL = CMPLX (VISBUF(JNDX+6), VISBUF(JNDX+7))
            ZLR = CMPLX (VISBUF(JNDX+9), VISBUF(JNDX+10))
            WTRR = VISBUF(JNDX+2)
            WTLL = VISBUF(JNDX+5)
            WTRL = VISBUF(JNDX+8)
            WTLR = VISBUF(JNDX+11)
C                                       Form Stokes I.
C                                       Skip this channel if RR or
C                                       LL are missing.
            IF ((WTRR.LE.0.0).OR.(WTLL.LE.0.0)) GO TO 80
            ZII = (WTRR * ZRR + WTLL * ZLL) / (WTRR + WTLL)
C                                       Parallactic angles
            DPANG1 = 2.0D0 * PARAN(1,K)
            DPANG2 = 2.0D0 * PARAN(2,K)
            ZP1 = CMPLX (COS (DPANG1), SIN (DPANG1))
            ZP2 = CMPLX (COS (DPANG2), SIN (DPANG2))
            DTIM = DBLE (TIME(K))
C                                       No Faraday rotation at present.
            FR1 = 0.0
            FR2 = 0.0
            ZION1 = CMPLX (COS (FR1), SIN (FR1))
            ZION2 = CMPLX (COS (FR2), SIN (FR2))
C                                       RL exists ?
            IF (WTRL.GT.0) THEN
               COBS(IA1) = COBS(IA1) + 1
               COBS(IA2) = COBS(IA2) + 1
               I1 = IA1
               I2 = IA2 + N
               I3 = 2 * N + JCHAN
               SWT = SWT + WTRL
               SWT2 = SWT2 + WTRL*WTRL
               KOBS = KOBS + 1
               ZC(1) = ZLL * ZP1 * ZION1
               ZC(2) = ZRR * ZP2 * ZION2
               ZC(3) = ZII
               AHA(I1,I1) = AHA(I1,I1) + WTRL * CONJG(ZC(1)) * ZC(1)
               AHA(I1,I2) = AHA(I1,I2) + WTRL * CONJG(ZC(1)) * ZC(2)
               AHA(I1,I3) = AHA(I1,I3) + WTRL * CONJG(ZC(1)) * ZC(3)
               AHA(I2,I2) = AHA(I2,I2) + WTRL * CONJG(ZC(2)) * ZC(2)
               AHA(I2,I3) = AHA(I2,I3) + WTRL * CONJG(ZC(2)) * ZC(3)
               AHA(I3,I3) = AHA(I3,I3) + WTRL * CONJG(ZC(3)) * ZC(3)
               AHB(I1) = AHB(I1) + WTRL * CONJG(ZC(1)) * ZRL
               AHB(I2) = AHB(I2) + WTRL * CONJG(ZC(2)) * ZRL
               AHB(I3) = AHB(I3) + WTRL * CONJG(ZC(3)) * ZRL
               BHB = BHB + WTRL * (REAL(ZRL)**2 + AIMAG(ZRL)**2)
               ENDIF
C                                       LR exists ?
            IF (WTLR.GT.0) THEN
               COBS(IA1) = COBS(IA1) + 1
               COBS(IA2) = COBS(IA2) + 1
               I1 = IA2
               I2 = IA1 + N
               I3 = 2 * N + JCHAN
               SWT = SWT + WTLR
               SWT2 = SWT2 + WTLR*WTLR
               KOBS = KOBS + 1
               ZC(1) = CONJG (ZLL) * ZP2 * ZION2
               ZC(2) = CONJG (ZRR) * ZP1 * ZION1
               ZC(3) = CONJG (ZII)
               ZLRC = CONJG (ZLR)
               AHA(I1,I1) = AHA(I1,I1) + WTLR * CONJG(ZC(1)) * ZC(1)
               AHA(I1,I2) = AHA(I1,I2) + WTLR * CONJG(ZC(1)) * ZC(2)
               AHA(I1,I3) = AHA(I1,I3) + WTLR * CONJG(ZC(1)) * ZC(3)
               AHA(I2,I2) = AHA(I2,I2) + WTLR * CONJG(ZC(2)) * ZC(2)
               AHA(I2,I3) = AHA(I2,I3) + WTLR * CONJG(ZC(2)) * ZC(3)
               AHA(I3,I3) = AHA(I3,I3) + WTLR * CONJG(ZC(3)) * ZC(3)
               AHB(I1) = AHB(I1) + WTLR * CONJG(ZC(1)) * ZLRC
               AHB(I2) = AHB(I2) + WTLR * CONJG(ZC(2)) * ZLRC
               AHB(I3) = AHB(I3) + WTLR * CONJG(ZC(3)) * ZLRC
               BHB = BHB + WTLR * (REAL(ZLRC)**2 + AIMAG(ZLRC)**2)
               ENDIF
 80         CONTINUE
 100     CONTINUE
C                                       find ref ant
      IF ((IREF.LE.0) .OR. (IREF.GT.N)) THEN
         K = 0
         IREF = 0
         DO 105 I = 1,MAXANT
            IF (COBS(I).GT.K) THEN
               IREF = I
               K = COBS(I)
               END IF
 105        CONTINUE
         WRITE (MSGTXT,1105) IREF
         CALL MSGWRT (4)
         END IF
C                                       Find the average size of the
C                                       nonzero diagonal elements of
C                                       AHA:
      K = 0
      S = 0.0D0
      DO 110 I = 1,NVAR
         IF (REAL (AHA(I,I)).GT.0.0) THEN
            K = K + 1
            S = S + REAL (AHA(I,I))
            END IF
 110     CONTINUE
      IF (K.GT.0) S = S / K
      IF (K.EQ.0) S = 1.0D0
C                                       For any missing antennas or
C                                       missing calibration sources,
C                                       set the corresponding diagonal
C                                       elements of the normal equations
C                                       matrix to the average of the
C                                       nonzero diagonal elements:
      KNVAR = NVAR
      DO 120 I = 1,NVAR
         IF (ABS (AHA(I,I)).EQ.0.0) THEN
            TEMP = S
            AHA(I,I) = CMPLX (TEMP, 0.0)
            KNVAR = KNVAR - 1
            END IF
 120     CONTINUE
C                                       Either constrain the solution
C                                       for the right-hand i.f. of the
C                                       iref'th antenna to zero, or
C                                       modify the normal equations
C                                       matrix so as to approximate the
C                                       least-squares solution of
C                                       minimal Euclidean norm (by
C                                       adding a small positive number
C                                       to the diagonal elements):
      IF (IREF.GE.1.AND.IREF.LE.N) THEN
         AHA(IREF,IREF) = AHA(IREF,IREF) + 10.0 * S
      ELSE
         EPS = 0.0D0
         DO 180 I = 1,NVAR
            AHA(I,I) = (1.0D0 + EPS) * AHA(I,I)
180         CONTINUE
         END IF
C                                       Set up an extra column of AHA so
C                                       that the r.m.s. residual can
C                                       come as a by-product of the
C                                       Cholesky decomposition (see
C                                       p. 8-3 of the  LINPACK guide):
      DO 200 I = 1,NVAR
         AHA(I,NVAR+1) = AHB(I)
 200     CONTINUE
      AHA(NVAR+1,NVAR+1) = BHB
C                                       Get the Cholesky decomposition
C                                       of AHA via a LINPACK routine:
      JOB = 0
      NVAR1 = NVAR + 1
      CALL CCHDC (AHA, LDA, NVAR1, WORK, JPVT, JOB, INFO)
      IF (INFO.LT.NVAR) THEN
         WRITE (MSGTXT,1200)
         CALL MSGWRT (8)
         IER = 1
         DO 220 I = 1,N
            D(1,I) = (0.0 ,0.0)
            D(2,I) = (0.0 ,0.0)
 220        CONTINUE
         GO TO 999
         END IF
C                                       (The weighted sum of squared
C                                       residuals = real(AHA(nvar+1,
C                                       nvar+1))**2) Get the solution,
C                                       via a LINPACK routine:
      CALL CPOSL (AHA, LDA, NVAR, AHB)
C                                       Calculate the standard error
C                                       estimates, via a LINPACK routine
C                                       (the normalized covariance
C                                       matrix then is given by
C                                       AHA * RMS**2).
C                                       When the least-squares solution
C                                       of minimal Euclidean norm is
C                                       computed (i.e., when iref=0)
C                                       standard error estimates for
C                                       the antenna feed parameters are
C                                       not calculated here (they're
C                                       set to 0), but error estimates
C                                       for the calibrator fluxes can be
C                                       calculated:
      IF (KOBS.GT.KNVAR.AND.SWT.GT.0.) THEN
C         RMS = ABS (REAL (AHA(NVAR+1,NVAR+1))) *
C     *      SQRT (REAL (KOBS)/(REAL (KOBS - KNVAR) * SWT * 2.0))
         DOF = SWT**2 / SWT2
         RMS = ABS (REAL (AHA(NVAR+1,NVAR+1))) *
     *      SQRT (1./( (DOF - REAL(KNVAR)) * SWT * 2.0))
         WRITE (MSGTXT,1220) RMS, DOF
         CALL MSGWRT (4)
         JOB = 1
         CALL CPODI (AHA, LDA, NVAR, DET, JOB)
         IF (IREF.NE.0) AHA(IREF,IREF) = (0.0, 0.0)
         END IF
C                                       Now, print the results.
C                                       Then return:
      DO 320 I = 1,N
         D(1,I) = AHB(I)
         WRITE (MSGTXT,1300) I
         CALL MSGWRT (4)
         E = RMS * SQRT (REAL (AHA(I,I)) * SWT)
         AMP = ABS (D(1,I))
         AMPERR = SQRT (2.0) * E
         IF (AMP .EQ. 0.0) THEN
            PHASE = 0.0
            PHASER = 0.0
         ELSE
            PHASE = ATAN2 (AIMAG (D(1,I)), REAL (D(1,I))) * RTD
            PHASER = E / ABS (D(1,I)) * RTD
            END IF
         WRITE (MSGTXT,1301) AMP, AMPERR, PHASE, PHASER
         CALL MSGWRT (4)
C                                       Other hand poln.
         D(2,I) = CONJG (AHB(N+I))
         E = RMS * SQRT (REAL (AHA(N+I,N+I)) * SWT)
         AMP = ABS (D(2,I))
         AMPERR = SQRT (2.0) * E
         IF (AMP .EQ. 0.0) THEN
            PHASE = 0.0
            PHASER = 0.0
         ELSE
            PHASE = ATAN2 (AIMAG (D(2,I)), REAL (D(2,I))) * RTD
            PHASER = E / ABS (D(2,I)) * RTD
            END IF
         WRITE (MSGTXT,1302) AMP, AMPERR, PHASE, PHASER
         CALL MSGWRT (4)
 320     CONTINUE
C                                       Fitted polarization factors
      WRITE (MSGTXT,1320)
      CALL MSGWRT(4)
C
      DO 340 I = 1, NCHAN
         J = 2 * N + I
         E = RMS * SQRT (REAL (AHA(J,J)))
         XRE = REAL (AHB(J))
         XIM = AIMAG (AHB(J))
         WRITE (MSGTXT,1325) I, XRE, XIM, E
         CALL MSGWRT (4)
 340     CONTINUE
C                                       Compute and print residuals.
      IF (IPRTLV.GE.2) THEN
         DO 400 I = 1,N
            J = 4 * (I - 1) + 1
            DXC(J) = REAL (D(1,I))
            DXC(J+1) = AIMAG (D(1,I))
            DXC(J+2) = REAL (D(2,I))
            DXC(J+3) = AIMAG (D(2,I))
 400        CONTINUE
C
         CALL TRURMS (N, DXC, DRMS)
         WRITE (MSGTXT,1501) DRMS
         CALL MSGWRT (6)
         DO 420 J = 1,4*N
            DXC(J) = 0.0D0
 420        CONTINUE
         CALL TRURMS (N, DXC, DRMS)
         WRITE (MSGTXT,1502) DRMS
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('RPCALC: NVMAX TOO SMALL ',2I8)
 1105 FORMAT ('RPCAL: setting reference antenna to',I3)
 1200 FORMAT ('Solution is indeterminate.')
 1220 FORMAT ('RMS residual =',1PE12.3,' DOF =',0PF8.2)
 1300 FORMAT ('Interferometer Element',I4)
 1301 FORMAT ('  R: Amp = ',F8.5,'+/-',F8.5,' Phase(deg) = ',F7.2,
     *   '+/-',F7.2)
 1302 FORMAT ('  L: Amp = ',F8.5,'+/-',F8.5,' Phase(deg) = ',F7.2,
     *   '+/-',F7.2)
 1320 FORMAT ('Fitted polarization factors: solution type RAPR')
 1325 FORMAT ('Chan=',I4,' Q=',F11.5,' U=',F11.5,' (+/-',F11.5,')')
 1501 FORMAT ('True RMS residual =',1PD20.8)
 1502 FORMAT ('Pre-fit RMS =',1PD20.8)
      END
      SUBROUTINE ZPCALC (IPRTLV, IREF, N, D)
C-----------------------------------------------------------------------
C   Calculate the antenna feed solutions.
C   Input parameter:
C      IPRTLV    I       Print level.
C      IREF      I       Reference antenna (0=> minimize rms
C                        antenna values.
C      N         I       Number of antennas.
C   Output parameter.
C      D         CX(2,*) R,L feed solutions for each antenna.
C-----------------------------------------------------------------------
      INTEGER IREF, IPRTLV, N
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER NVMAX, NVMAX1
      PARAMETER (NVMAX = 2*MAXANT)
      PARAMETER (NVMAX1 = 2*MAXANT + 1)
      INCLUDE 'SPCAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMPLEX AHA(NVMAX1,NVMAX1), AHB(NVMAX), WORK(NVMAX1),
     *   ZP1, ZP2, ZC(2), ZRR, ZLL, ZRL, ZLR, ZLRC,
     *   D(2,MAXANT), ZION1, ZION2
      DOUBLE PRECISION BHB, DPANG1, DPANG2, S, EPS,
     *   DXC(NVMAX), DRMS, DTIM
      REAL      RTD, WTRL, WTLR, TEMP, SWT, RMS, AMP, AMPERR, DOF,
     *   PHASE, PHASER, E, FR1, FR2, DET(2), SWT2
      INTEGER   LDA, NVAR, I, J, K, JCHAN, IA1, IA2, JNDX, I1, I2,
     *   KNVAR, JOB, NVAR1, JPVT(NVMAX1), INFO, KOBS, NRECSZ, IER,
     *   COBS(MAXANT)
C-----------------------------------------------------------------------
      MSGTXT = 'Determining feed solutions'
      CALL MSGWRT (6)
C                                       Set constants.
      NRECSZ = 12 * NCHAN
      RTD = 45.0 / ATAN (1.0)
      LDA = NVMAX1
      NVAR = 2 * N
C                                       Set up the normal equations.
      DO 20 I = 1,NVAR
         AHB(I) = (0.0, 0.0)
         DO 15 J = 1,NVAR
            AHA(I,J) = (0.0, 0.0)
 15         CONTINUE
 20      CONTINUE
      BHB = 0.0D0
      SWT = 0.0
      SWT2 = 0.0
      KOBS = 0
C                                       Loop over the observations.
      CALL FILL (MAXANT, 0, COBS)
      DO 100 K = 1,NUMDAT
         IA1 = ANTS(1,K)
         IA2 = ANTS(2,K)
         DO 80 JCHAN = 1,NCHAN
            JNDX = (K-1) * NRECSZ + 12*(JCHAN-1) + 1
C                                       Visiblities (RR,LL,RL,LR).
            ZRR = CMPLX (VISBUF(JNDX), VISBUF(JNDX+1))
            ZLL = CMPLX (VISBUF(JNDX+3), VISBUF(JNDX+4))
            ZRL = CMPLX (VISBUF(JNDX+6), VISBUF(JNDX+7))
            ZLR = CMPLX (VISBUF(JNDX+9), VISBUF(JNDX+10))
            WTRL = VISBUF(JNDX+8)
            WTLR = VISBUF(JNDX+11)
            DPANG1 = 2.0D0 * PARAN(1,K)
            DPANG2 = 2.0D0 * PARAN(2,K)
            ZP1 = CMPLX (COS (DPANG1), SIN (DPANG1))
            ZP2 = CMPLX (COS (DPANG2), SIN (DPANG2))
            DTIM = DBLE (TIME(K))
C                                       No Faraday rotation at present.
            FR1 = 0.0
            FR2 = 0.0
            ZION1 = CMPLX (COS (FR1), SIN (FR1))
            ZION2 = CMPLX (COS (FR2), SIN (FR2))
C                                       RL exists ?
            IF (WTRL.GT.0) THEN
               COBS(IA1) = COBS(IA1) + 1
               COBS(IA2) = COBS(IA2) + 1
               I1 = IA1
               I2 = IA2 + N
               SWT = SWT + WTRL
               SWT2 = SWT2 + WTRL*WTRL
               KOBS = KOBS + 1
               ZC(1) = ZLL * ZP1 * ZION1
               ZC(2) = ZRR * ZP2 * ZION2
               AHA(I1,I1) = AHA(I1,I1) + WTRL * CONJG(ZC(1)) * ZC(1)
               AHA(I1,I2) = AHA(I1,I2) + WTRL * CONJG(ZC(1)) * ZC(2)
               AHA(I2,I2) = AHA(I2,I2) + WTRL * CONJG(ZC(2)) * ZC(2)
               AHB(I1) = AHB(I1) + WTRL * CONJG(ZC(1)) * ZRL
               AHB(I2) = AHB(I2) + WTRL * CONJG(ZC(2)) * ZRL
               BHB = BHB + WTRL * (REAL(ZRL)**2 + AIMAG(ZRL)**2)
               ENDIF
C                                       LR exists ?
            IF (WTLR.GT.0) THEN
               COBS(IA1) = COBS(IA1) + 1
               COBS(IA2) = COBS(IA2) + 1
               I1 = IA2
               I2 = IA1 + N
               SWT = SWT + WTLR
               SWT2 = SWT2 + WTLR*WTLR
               KOBS = KOBS + 1
               ZC(1) = CONJG (ZLL) * ZP2 * ZION2
               ZC(2) = CONJG (ZRR) * ZP1 * ZION1
               ZLRC = CONJG (ZLR)
               AHA(I1,I1) = AHA(I1,I1) + WTLR * CONJG(ZC(1)) * ZC(1)
               AHA(I1,I2) = AHA(I1,I2) + WTLR * CONJG(ZC(1)) * ZC(2)
               AHA(I2,I2) = AHA(I2,I2) + WTLR * CONJG(ZC(2)) * ZC(2)
               AHB(I1) = AHB(I1) + WTLR * CONJG(ZC(1)) * ZLRC
               AHB(I2) = AHB(I2) + WTLR * CONJG(ZC(2)) * ZLRC
               BHB = BHB + WTLR * (REAL(ZLRC)**2 + AIMAG(ZLRC)**2)
               ENDIF
 80         CONTINUE
 100     CONTINUE
C                                       find ref ant
      IF ((IREF.LE.0) .OR. (IREF.GT.N)) THEN
         K = 0
         IREF = 0
         DO 105 I = 1,MAXANT
            IF (COBS(I).GT.K) THEN
               IREF = I
               K = COBS(I)
               END IF
 105        CONTINUE
         WRITE (MSGTXT,1105) IREF
         CALL MSGWRT (4)
         END IF
C                                       Find the average size of the
C                                       nonzero diagonal elements of
C                                       AHA:
      K = 0
      S = 0.0D0
      DO 110 I = 1,NVAR
         IF (REAL (AHA(I,I)).GT.0.0) THEN
            K = K + 1
            S = S + REAL (AHA(I,I))
            END IF
 110     CONTINUE
      IF (K.GT.0) S = S / K
      IF (K.EQ.0) S = 1.0D0
C                                       For any missing antennas or
C                                       missing calibration sources,
C                                       set the corresponding diagonal
C                                       elements of the normal equations
C                                       matrix to the average of the
C                                       nonzero diagonal elements:
      KNVAR = NVAR
      DO 120 I = 1,NVAR
         IF (ABS (AHA(I,I)).EQ.0.0) THEN
            TEMP = S
            AHA(I,I) = CMPLX (TEMP, 0.0)
            KNVAR = KNVAR - 1
            END IF
 120     CONTINUE
C                                       Either constrain the solution
C                                       for the right-hand i.f. of the
C                                       iref'th antenna to zero, or
C                                       modify the normal equations
C                                       matrix so as to approximate the
C                                       least-squares solution of
C                                       minimal Euclidean norm (by
C                                       adding a small positive number
C                                       to the diagonal elements):
      IF (IREF.GE.1.AND.IREF.LE.N) THEN
         AHA(IREF,IREF) = AHA(IREF,IREF) + 10.0 * S
      ELSE
         EPS = 0.0D0
         DO 180 I = 1,NVAR
            AHA(I,I) = (1.0D0 + EPS) * AHA(I,I)
 180        CONTINUE
         END IF
C                                       Set up an extra column of AHA so
C                                       that the r.m.s. residual can
C                                       come as a by-product of the
C                                       Cholesky decomposition (see
C                                       p. 8-3 of the  LINPACK guide):
      DO 200 I = 1,NVAR
         AHA(I,NVAR+1) = AHB(I)
 200     CONTINUE
      AHA(NVAR+1,NVAR+1) = BHB
C                                       Get the Cholesky decomposition
C                                       of AHA via a LINPACK routine:
      JOB = 0
      NVAR1 = NVAR + 1
      CALL CCHDC (AHA, LDA, NVAR1, WORK, JPVT, JOB, INFO)
      IF (INFO.LT.NVAR) THEN
         WRITE (MSGTXT,1200)
         CALL MSGWRT (8)
         IER = 1
         DO 220 I = 1,N
            D(1,I) = (0.0 ,0.0)
            D(2,I) = (0.0 ,0.0)
 220        CONTINUE
         GO TO 999
         END IF
C                                       (The weighted sum of squared
C                                       residuals = real(AHA(nvar+1,
C                                       nvar+1))**2) Get the solution,
C                                       via a LINPACK routine:
      CALL CPOSL (AHA, LDA, NVAR, AHB)
C                                       Calculate the standard error
C                                       estimates, via a LINPACK routine
C                                       (the normalized covariance
C                                       matrix then is given by
C                                       AHA * RMS**2).
C                                       When the least-squares solution
C                                       of minimal Euclidean norm is
C                                       computed (i.e., when iref=0)
C                                       standard error estimates for
C                                       the antenna feed parameters are
C                                       not calculated here (they're
C                                       set to 0), but error estimates
C                                       for the calibrator fluxes can be
C                                       calculated:
      IF (KOBS.GT.KNVAR.AND.SWT.GT.0.) THEN
C         RMS = ABS (REAL (AHA(NVAR+1,NVAR+1))) *
C     *      SQRT (REAL (KOBS)/(REAL (KOBS - KNVAR) * SWT * 2.0))
         DOF = SWT**2 / SWT2
         RMS = ABS (REAL (AHA(NVAR+1,NVAR+1))) *
     *      SQRT (1./( (DOF - REAL(KNVAR)) * SWT * 2.0))
         WRITE (MSGTXT,1220) RMS, DOF
          CALL MSGWRT (4)
         JOB = 1
         CALL CPODI (AHA, LDA, NVAR, DET, JOB)
         IF (IREF.NE.0) AHA(IREF,IREF) = (0.0, 0.0)
         END IF
C                                       Now, print the results.
C                                       Then return:
      DO 320 I = 1,N
         D(1,I) = AHB(I)
         WRITE (MSGTXT,1300) I
         CALL MSGWRT (4)
C                                       STM: AHA is now Inv(AHA) and
C                                       thus need to be scaled by SWT
         E = RMS * SQRT (REAL (AHA(I,I))*SWT)
         AMP = ABS (D(1,I))
         AMPERR = SQRT (2.0) * E
         IF (AMP .EQ. 0.0) THEN
            PHASE = 0.0
            PHASER = 0.0
         ELSE
            PHASE = ATAN2 (AIMAG (D(1,I)), REAL (D(1,I))) * RTD
            PHASER = E / ABS (D(1,I)) * RTD
         END IF
         WRITE (MSGTXT,1301) AMP, AMPERR, PHASE, PHASER
         CALL MSGWRT (4)
C                                       Other hand poln.
         D(2,I) = CONJG (AHB(N+I))
         E = RMS * SQRT (REAL (AHA(N+I,N+I))*SWT)
         AMP = ABS (D(2,I))
         AMPERR = SQRT (2.0) * E
         IF (AMP .EQ. 0.0) THEN
            PHASE = 0.0
            PHASER = 0.0
         ELSE
            PHASE = ATAN2 (AIMAG (D(2,I)), REAL (D(2,I))) * RTD
            PHASER = E / ABS (D(2,I)) * RTD
            END IF
         WRITE (MSGTXT,1302) AMP, AMPERR, PHASE, PHASER
         CALL MSGWRT (4)
 320     CONTINUE
C                                       Compute and print residuals.
      IF (IPRTLV.GE.2) THEN
         DO 400 I = 1,N
            J = 4 * (I - 1) + 1
            DXC(J) = REAL (D(1,I))
            DXC(J+1) = AIMAG (D(1,I))
            DXC(J+2) = REAL (D(2,I))
            DXC(J+3) = AIMAG (D(2,I))
 400        CONTINUE
         CALL TRURMS (N, DXC, DRMS)
         WRITE (MSGTXT,1501) DRMS
         CALL MSGWRT (6)
         DO 420 J = 1,4*N
            DXC(J) = 0.0D0
 420        CONTINUE
         CALL TRURMS (N, DXC, DRMS)
         WRITE (MSGTXT,1502) DRMS
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1105 FORMAT ('ZPCAL: setting reference antenna to',I3)
 1200 FORMAT ('Solution is indeterminate.')
 1220 FORMAT ('RMS residual =',1PE12.3,' DOF =',0PF8.2)
 1300 FORMAT ('Interferometer Element',I4)
 1301 FORMAT ('  R: Amp = ',F8.5,'+/-',F8.5,' Phase(deg) = ',F7.2,
     *   '+/-',F7.2)
 1302 FORMAT ('  L: Amp = ',F8.5,'+/-',F8.5,' Phase(deg) = ',F7.2,
     *   '+/-',F7.2)
 1501 FORMAT ('True RMS residual =',1PD20.8)
 1502 FORMAT ('Pre-fit RMS =',1PD20.8)
      END
      SUBROUTINE TRURMS (N, DXC, DRMS)
C--------------------------------------------------------------------
C   Compute true rms for feed parameters.
C   Input:
C      N       I       No. of feed polzn. terms
C      DXC     CX(N)   Feed polarization terms.
C   Output:
C      DRMS    D       Output rms.
C--------------------------------------------------------------------
      INTEGER N
      DOUBLE PRECISION DXC(N), DRMS
C
      COMPLEX  ZDR1, ZDL1, ZDR2, ZDL2, ZRR, ZLL, ZRL, ZLR, ZDIFF,
     *   ZP1, ZP2, ZION1, ZION2
      DOUBLE PRECISION DCHI, DPANG1, DPANG2, DWTRL, DWTLR,
     *   DCOUNT, DFR1, DFR2, DTIM
      INTEGER J, JCHAN, JNDX, IA1, IA2, J1, J2, NRECSZ
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'SPCAL.INC'
C--------------------------------------------------------------------
      NRECSZ = 12 * NCHAN
      DCHI = 0.0D0
      DCOUNT = 0.0D0
C                                       Loop over all data points.
      DO 500 J = 1,NUMDAT
         IA1 = ANTS(1,J)
         IA2 = ANTS(2,J)
         J1 = (IA1 - 1) * 4
         ZDR1 = CMPLX (DXC(J1+1), DXC(J1+2))
         ZDL1 = CMPLX (DXC(J1+3), DXC(J1+4))
         J2 = (IA2 - 1) * 4
         ZDR2 = CMPLX (DXC(J2+1), DXC(J2+2))
         ZDL2 = CMPLX (DXC(J2+3), DXC(J2+4))
         DPANG1 = 2.0D0 * PARAN(1,J)
         DPANG2 = 2.0D0 * PARAN(2,J)
         ZP1 = CMPLX (COS(DPANG1), SIN(DPANG1))
         ZP2 = CMPLX (COS(DPANG2), SIN(DPANG2))
         DTIM = TIME(J)
C                                       No ionospheric Faraday
C                                       rotation at present.
         DFR1 = 0.0
         DFR2 = 0.0
         ZION1 = CMPLX (COS(DFR1), SIN(DFR1))
         ZION2 = CMPLX (COS(DFR2), SIN(DFR2))
C                                       Loop over each channel.
         DO 480 JCHAN = 1,NCHAN
            JNDX = (J-1) * NRECSZ + 12 * (JCHAN-1) + 1
            ZRR = CMPLX (VISBUF(JNDX), VISBUF(JNDX+1))
            ZLL = CMPLX (VISBUF(JNDX+3), VISBUF(JNDX+4))
            ZRL = CMPLX (VISBUF(JNDX+6), VISBUF(JNDX+7))
            ZLR = CMPLX (VISBUF(JNDX+9), VISBUF(JNDX+10))
C                                       RL exists ?
            DWTRL = VISBUF(JNDX+8)
            IF (DWTRL.GT.0) THEN
               ZDIFF = CONJG (ZDL2) * ZRR * ZP2 * ZION2 +
     *            ZDR1 * ZLL * ZP1 * ZION1 - ZRL
               DCHI = DCHI + (REAL (ZDIFF)) ** 2
               DCHI = DCHI + (AIMAG (ZDIFF)) ** 2
               DCOUNT = DCOUNT + 1.0D0
               ENDIF
C                                       LR exists ?
            DWTLR = VISBUF(JNDX+11)
            IF (DWTLR.GT.0) THEN
               ZDIFF = ZDL1 * ZRR * CONJG (ZP1*ZION1) +
     *            CONJG (ZDR2) * ZLL * CONJG (ZP2*ZION2) - ZLR
               DCHI = DCHI + (REAL (ZDIFF)) ** 2
               DCHI = DCHI + (AIMAG (ZDIFF)) ** 2
               DCOUNT = DCOUNT + 1.0D0
               ENDIF
480         CONTINUE
500      CONTINUE
C                                       Exit
      DRMS = SQRT (DCHI/DCOUNT)
      RETURN
      END
      SUBROUTINE PUTANT (DISK, CNO, INVER, OUTVER, BIF, EIF, NUMIF,
     *   SOLTYP, CATBLK, BUFF1, BUFF2, FREQID, IERR)
C-----------------------------------------------------------------------
C   PUTANT reads an antennas (AN) extension file and copies to an
C   output file adding antenna feed parameters.
C   Inputs:
C      DISK      I      Volume number
C      CNO       I      Catalog slot number
C      INVER     I      Input version number
C      OUTVER    I      Output version number
C      BIF       I      First IF number
C      EIF       I      Highest IF number
C      NUMIF     I      Number of IFs
C      SOLTYP    I      Feed solution type.
C                       1 = linear approximation
C                       2 = orientation, ellipticity
C                       3 = Lin. approx for X-Y feeds
C                       4 = VLBI linear approx.
C      CATBLK(*) I      Catalog header block
C      FREQID    I      FQ ID for which polzn parms being
C                       calculated
C   Input from COMMON (DANS.INC):
C      STNEPL(2,*)R    Feed real/elipticity (poln, IF)
C      STNORI(2,*)R    Feed imag/orientation (poln, IF)
C   Output:
C      BUFF1(*)  I      I/O Buffer
C      BUFF2(*)  I      I/O Buffer
C      IERR      I      Error code, 0=OK, else failed.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER CHPOLT*8, CHSOL(4)*8
      INTEGER   DISK, CNO, CATBLK(256), INVER, OUTVER, BUFF1(*),
     *   BUFF2(*), IERR,  BIF, EIF, NUMIF, SOLTYP, FREQID,
     *   A2NUMV(MAXANC), A2KOLS(MAXANC), IIF, LUN1, LUN2, IANT, INDEX,
     *   KEYTYP, LOCS, IBIF, IEIF, NUMREC, IATUTC
      HOLLERITH HSOLTY(2)
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA CHSOL /'APPROX  ', 'ORI-ELP ','X-Y LIN ', 'VLBI'/
      DATA CHPOLT /'POLTYPE '/
      DATA LUN1, LUN2 /27,28/
C-----------------------------------------------------------------------
C                                      Open AN extension file.
      CALL ANTINI ('READ', BUFF1, DISK, CNO, INVER, CATBLK, LUN1,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, IATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READ'
         GO TO 990
         END IF
C                                       Check FREQID compatibility.
      IF ((ANFQID.GT.0) .AND. (FREQID.GT.0) .AND.
     *   (ANFQID.NE.FREQID)) THEN
         WRITE (MSGTXT,1030)
         CALL MSGWRT (4)
         WRITE (MSGTXT,1040)
         CALL MSGWRT (4)
         WRITE (MSGTXT,1050) ANFQID
         CALL MSGWRT (4)
         WRITE (MSGTXT,1060) FREQID
         CALL MSGWRT (4)
         IERR = 5
         GO TO 999
         END IF
C
      NUMREC = BUFF1(5)
C                                       Check IF limits
      IBIF = BIF
      IEIF = EIF
      IF (IBIF.LE.0) IBIF = 1
      IF (IBIF.GT.NUMIF) IBIF = NUMIF
      IF (IEIF.LE.IBIF) IEIF = IBIF
      IF (IEIF.GT.NUMIF) IEIF = NUMIF
C                                       Open output table
      NOPCAL = 2
      ANTNIF = NUMIF
      ANFQID = FREQID
      CALL ANTINI ('WRIT', BUFF2, DISK, CNO, OUTVER, CATBLK, LUN2,
     *   IANRNO, A2KOLS, A2NUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, IATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'WRIT'
         GO TO 990
         END IF
C                                       Read AN records
      DO 200 IANT = 1,NUMREC
         IANRNO = IANT
         CALL TABAN ('READ', BUFF1, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.LT.0) GO TO 200
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1100) IERR, 'READ'
            GO TO 990
            END IF
C                                       Feed polarizations
         INDEX = 2 * (IBIF-1) + 1
         DO 150 IIF = IBIF,IEIF
            POLCA(INDEX) = STNELP(1,IIF,NOSTA)
            POLCA(INDEX+1) = STNORI(1,IIF,NOSTA)
            POLCB(INDEX) = STNELP(2,IIF,NOSTA)
            POLCB(INDEX+1) = STNORI(2,IIF,NOSTA)
            INDEX = INDEX + 2
 150        CONTINUE
C                                       Write record
         IANRNO = IANT
         CALL TABAN ('WRIT', BUFF2, IANRNO, A2KOLS, A2NUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR, 'WRIT'
            GO TO 990
            END IF
 200     CONTINUE
C                                       Add solution type keyword.
      LOCS = 1
      KEYTYP = 3
      CALL CHR2H (8, CHSOL(SOLTYP), 1, HSOLTY)
      CALL TABKEY ('WRIT', CHPOLT, 1, BUFF2, LOCS, HSOLTY,
     *   KEYTYP, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1200) IERR
         GO TO 990
         END IF
C                                       Close AN extension files
      CALL TABIO ('CLOS', 1, IANRNO, BUFF1, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1210) IERR
         GO TO 990
         END IF
      CALL TABIO ('CLOS', 1, IANRNO, BUFF2, BUFF2, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1210) IERR
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PUTANT: ERROR',I3,' OPEN-FOR-',A4,'ING AN FILE')
 1030 FORMAT ('WARNING:')
 1040 FORMAT ('   The polarization information in your AN table')
 1050 FORMAT ('   was set with FREQID ',I3,' this is being')
 1060 FORMAT ('   overwritten with parameters derived from FREQID ',I3)
 1100 FORMAT ('PUTANT: ERROR',I3,1X,A4,'ING AN FILE')
 1200 FORMAT ('PUTANT: ERROR',I3,' ADDING SOLUTION TYPE KEYWORD')
 1210 FORMAT ('PUTANT: ERROR',I3,' CLOSING AN FILE')
      END
      SUBROUTINE CCHDC (A, LDA, P, WORK, JPVT, JOB, INFO)
C-----------------------------------------------------------------------
      INTEGER LDA,P,JPVT(1),JOB,INFO
      COMPLEX A(LDA,1),WORK(1)
C
C     CCHDC COMPUTES THE CHOLESKY DECOMPOSITION OF A POSITIVE DEFINITE
C     MATRIX.  A PIVOTING OPTION ALLOWS THE USER TO ESTIMATE THE
C     CONDITION OF A POSITIVE DEFINITE MATRIX OR DETERMINE THE RANK
C     OF A POSITIVE SEMIDEFINITE MATRIX.
C
C     ON ENTRY
C
C         A      COMPLEX(LDA,P).
C                A CONTAINS THE MATRIX WHOSE DECOMPOSITION IS TO
C                BE COMPUTED.  ONLT THE UPPER HALF OF A NEED BE STORED.
C                THE LOWER PART OF THE ARRAY A IS NOT REFERENCED.
C
C         LDA    INTEGER.
C                LDA IS THE LEADING DIMENSION OF THE ARRAY A.
C
C         P      INTEGER.
C                P IS THE ORDER OF THE MATRIX.
C
C         WORK   COMPLEX.
C                WORK IS A WORK ARRAY.
C
C         JPVT   INTEGER(P).
C                JPVT CONTAINS INTEGERS THAT CONTROL THE SELECTION
C                OF THE PIVOT ELEMENTS, IF PIVOTING HAS BEEN REQUESTED.
C                EACH DIAGONAL ELEMENT A(K,K)
C                IS PLACED IN ONE OF THREE CLASSES ACCORDING TO THE
C                VALUE OF JPVT(K).
C
C                   IF JPVT(K) .GT. 0, THEN X(K) IS AN INITIAL
C                                      ELEMENT.
C
C                   IF JPVT(K) .EQ. 0, THEN X(K) IS A FREE ELEMENT.
C
C                   IF JPVT(K) .LT. 0, THEN X(K) IS A FINAL ELEMENT.
C
C                BEFORE THE DECOMPOSITION IS COMPUTED, INITIAL ELEMENTS
C                ARE MOVED BY SYMMETRIC ROW AND COLUMN INTERCHANGES TO
C                THE BEGINNING OF THE ARRAY A AND FINAL
C                ELEMENTS TO THE END.  BOTH INITIAL AND FINAL ELEMENTS
C                ARE FROZEN IN PLACE DURING THE COMPUTATION AND ONLY
C                FREE ELEMENTS ARE MOVED.  AT THE K-TH STAGE OF THE
C                REDUCTION, IF A(K,K) IS OCCUPIED BY A FREE ELEMENT
C                IT IS INTERCHANGED WITH THE LARGEST FREE ELEMENT
C                A(L,L) WITH L .GE. K.  JPVT IS NOT REFERENCED IF
C                JOB .EQ. 0.
C
C        JOB     INTEGER.
C                JOB IS AN INTEGER THAT INITIATES COLUMN PIVOTING.
C                IF JOB .EQ. 0, NO PIVOTING IS DONE.
C                IF JOB .NE. 0, PIVOTING IS DONE.
C
C     ON RETURN
C
C         A      A CONTAINS IN ITS UPPER HALF THE CHOLESKY FACTOR
C                OF THE MATRIX A AS IT HAS BEEN PERMUTED BY PIVOTING.
C
C         JPVT   JPVT(J) CONTAINS THE INDEX OF THE DIAGONAL ELEMENT
C                OF A THAT WAS MOVED INTO THE J-TH POSITION,
C                PROVIDED PIVOTING WAS REQUESTED.
C
C         INFO   CONTAINS THE INDEX OF THE LAST POSITIVE DIAGONAL
C                ELEMENT OF THE CHOLESKY FACTOR.
C
C     FOR POSITIVE DEFINITE MATRICES INFO = P IS THE NORMAL RETURN.
C     FOR PIVOTING WITH POSITIVE SEMIDEFINITE MATRICES INFO WILL
C     IN GENERAL BE LESS THAN P.  HOWEVER, INFO MAY BE GREATER THAN
C     THE RANK OF A, SINCE ROUNDING ERROR CAN CAUSE AN OTHERWISE ZERO
C     ELEMENT TO BE POSITIVE. INDEFINITE SYSTEMS WILL ALWAYS CAUSE
C     INFO TO BE LESS THAN P.
C
C     LINPACK. THIS VERSION DATED 03/19/79 .
C     J.J. DONGARRA AND G.W. STEWART, ARGONNE NATIONAL LABORATORY AND
C     UNIVERSITY OF MARYLAND.
C
C
C     BLAS CAXPY,CSWAP
C     FORTRAN SQRT,REAL,CONJG
C
C     INTERNAL VARIABLES
C
      INTEGER PU,PL,PLP1,J,JP,JT,K,KB,KM1,KP1,L,MAXL
      INTEGER ITEMP, N1
      COMPLEX TEMP
      REAL MAXDIA
      LOGICAL SWAPK,NEGK
      DATA N1 /1/
C
      PL = 1
      PU = 0
      INFO = P
      IF (JOB .EQ. 0) GO TO 160
C
C        PIVOTING HAS BEEN REQUESTED. REARRANGE THE
C        THE ELEMENTS ACCORDING TO JPVT.
C
         DO 70 K = 1, P
            SWAPK = JPVT(K) .GT. 0
            NEGK = JPVT(K) .LT. 0
            JPVT(K) = K
            IF (NEGK) JPVT(K) = -JPVT(K)
            IF (.NOT.SWAPK) GO TO 60
               IF (K .EQ. PL) GO TO 50
                  ITEMP = PL-1
                  CALL CSWAP(ITEMP,A(1,K),N1,A(1,PL),N1)
                  TEMP = A(K,K)
                  A(K,K) = A(PL,PL)
                  A(PL,PL) = TEMP
                  A(PL,K) = CONJG(A(PL,K))
                  PLP1 = PL + 1
                  IF (P .LT. PLP1) GO TO 40
                  DO 30 J = PLP1, P
                     IF (J .GE. K) GO TO 10
                        TEMP = CONJG(A(PL,J))
                        A(PL,J) = CONJG(A(J,K))
                        A(J,K) = TEMP
                     GO TO 20
   10                CONTINUE
                     IF (J .EQ. K) GO TO 20
                        TEMP = A(K,J)
                        A(K,J) = A(PL,J)
                        A(PL,J) = TEMP
   20                CONTINUE
   30             CONTINUE
   40             CONTINUE
                  JPVT(K) = JPVT(PL)
                  JPVT(PL) = K
   50          CONTINUE
               PL = PL + 1
   60       CONTINUE
   70    CONTINUE
         PU = P
         IF (P .LT. PL) GO TO 150
         DO 140 KB = PL, P
            K = P - KB + PL
            IF (JPVT(K) .GE. 0) GO TO 130
               JPVT(K) = -JPVT(K)
               IF (PU .EQ. K) GO TO 120
                  ITEMP = K-1
                  CALL CSWAP(ITEMP,A(1,K),N1,A(1,PU),N1)
                  TEMP = A(K,K)
                  A(K,K) = A(PU,PU)
                  A(PU,PU) = TEMP
                  A(K,PU) = CONJG(A(K,PU))
                  KP1 = K + 1
                  IF (P .LT. KP1) GO TO 110
                  DO 100 J = KP1, P
                     IF (J .GE. PU) GO TO 80
                        TEMP = CONJG(A(K,J))
                        A(K,J) = CONJG(A(J,PU))
                        A(J,PU) = TEMP
                     GO TO 90
   80                CONTINUE
                     IF (J .EQ. PU) GO TO 90
                        TEMP = A(K,J)
                        A(K,J) = A(PU,J)
                        A(PU,J) = TEMP
   90                CONTINUE
  100             CONTINUE
  110             CONTINUE
                  JT = JPVT(K)
                  JPVT(K) = JPVT(PU)
                  JPVT(PU) = JT
  120          CONTINUE
               PU = PU - 1
  130       CONTINUE
  140    CONTINUE
  150    CONTINUE
  160 CONTINUE
      DO 270 K = 1, P
C
C        REDUCTION LOOP.
C
         MAXDIA = REAL(A(K,K))
         KP1 = K + 1
         MAXL = K
C
C        DETERMINE THE PIVOT ELEMENT.
C
         IF (K .LT. PL .OR. K .GE. PU) GO TO 190
            DO 180 L = KP1, PU
               IF (REAL(A(L,L)) .LE. MAXDIA) GO TO 170
                  MAXDIA = REAL(A(L,L))
                  MAXL = L
  170          CONTINUE
  180       CONTINUE
  190    CONTINUE
C
C        QUIT IF THE PIVOT ELEMENT IS NOT POSITIVE.
C
         IF (MAXDIA .GT. 0.0E0) GO TO 200
            INFO = K - 1
C     ......EXIT
            GO TO 280
  200    CONTINUE
         IF (K .EQ. MAXL) GO TO 210
C
C           START THE PIVOTING AND UPDATE JPVT.
C
            KM1 = K - 1
            CALL CSWAP(KM1,A(1,K),N1,A(1,MAXL),N1)
            A(MAXL,MAXL) = A(K,K)
            A(K,K) = CMPLX(MAXDIA, 0.0E0)
            JP = JPVT(MAXL)
            JPVT(MAXL) = JPVT(K)
            JPVT(K) = JP
            A(K,MAXL) = CONJG(A(K,MAXL))
  210    CONTINUE
C
C        REDUCTION STEP. PIVOTING IS CONTAINED ACROSS THE ROWS.
C
         WORK(K) = CMPLX(SQRT(REAL(A(K,K))),0.0E0)
         A(K,K) = WORK(K)
         IF (P .LT. KP1) GO TO 260
         DO 250 J = KP1, P
            IF (K .EQ. MAXL) GO TO 240
               IF (J .GE. MAXL) GO TO 220
                  TEMP = CONJG(A(K,J))
                  A(K,J) = CONJG(A(J,MAXL))
                  A(J,MAXL) = TEMP
               GO TO 230
  220          CONTINUE
               IF (J .EQ. MAXL) GO TO 230
                  TEMP = A(K,J)
                  A(K,J) = A(MAXL,J)
                  A(MAXL,J) = TEMP
  230          CONTINUE
  240       CONTINUE
            A(K,J) = A(K,J)/WORK(K)
            WORK(J) = CONJG(A(K,J))
            TEMP = -A(K,J)
            ITEMP = J-K
            CALL CAXPY(ITEMP,TEMP,WORK(KP1),N1,A(KP1,J),N1)
  250    CONTINUE
  260    CONTINUE
  270 CONTINUE
  280 CONTINUE
      RETURN
      END
      SUBROUTINE CPOSL(A,LDA,N,B)
      INTEGER LDA,N
      COMPLEX A(LDA,1),B(1)
C
C     CPOSL SOLVES THE COMPLEX HERMITIAN POSITIVE DEFINITE SYSTEM
C     A * X = B
C     USING THE FACTORS COMPUTED BY CPOCO OR CPOFA.
C
C     ON ENTRY
C
C        A       COMPLEX(LDA, N)
C                THE OUTPUT FROM CPOCO OR CPOFA.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  A .
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX  A .
C
C        B       COMPLEX(N)
C                THE RIGHT HAND SIDE VECTOR.
C
C     ON RETURN
C
C        B       THE SOLUTION VECTOR  X .
C
C     ERROR CONDITION
C
C        A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS
C        A ZERO ON THE DIAGONAL.  TECHNICALLY THIS INDICATES
C        SINGULARITY BUT IT IS USUALLY CAUSED BY IMPROPER SUBROUTINE
C        ARGUMENTS.  IT WILL NOT OCCUR IF THE SUBROUTINES ARE CALLED
C        CORRECTLY AND  INFO .EQ. 0 .
C
C     TO COMPUTE  INVERSE(A) * C  WHERE  C  IS A MATRIX
C     WITH  P  COLUMNS
C           CALL CPOCO(A,LDA,N,RCOND,Z,INFO)
C           IF (RCOND IS TOO SMALL .OR. INFO .NE. 0) GO TO ...
C           DO 10 J = 1, P
C              CALL CPOSL(A,LDA,N,C(1,J))
C        10 CONTINUE
C
C     LINPACK.  THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS CAXPY,CDOTC
C
C     INTERNAL VARIABLES
C
      COMPLEX CDOTC,T
      INTEGER K,KB
      INTEGER ITEMP, N1
      DATA N1 /1/
C
C     SOLVE CTRANS(R)*Y = B
C
      DO 10 K = 1, N
         ITEMP = K-1
         T = CDOTC(ITEMP,A(1,K),N1,B(1),N1)
         B(K) = (B(K) - T)/A(K,K)
   10 CONTINUE
C
C     SOLVE R*X = Y
C
      DO 20 KB = 1, N
         K = N + 1 - KB
         B(K) = B(K)/A(K,K)
         T = -B(K)
         ITEMP = K-1
         CALL CAXPY(ITEMP,T,A(1,K),N1,B(1),N1)
   20 CONTINUE
      RETURN
      END
      SUBROUTINE CPODI(A,LDA,N,DET,JOB)
      INTEGER LDA,N,JOB
      COMPLEX A(LDA,1)
      REAL DET(2)
C
C     CPODI COMPUTES THE DETERMINANT AND INVERSE OF A CERTAIN
C     COMPLEX HERMITIAN POSITIVE DEFINITE MATRIX (SEE BELOW)
C     USING THE FACTORS COMPUTED BY CPOCO, CPOFA OR CQRDC.
C
C     ON ENTRY
C
C        A       COMPLEX(LDA, N)
C                THE OUTPUT  A  FROM CPOCO OR CPOFA
C                OR THE OUTPUT  X  FROM CQRDC.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  A .
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX  A .
C
C        JOB     INTEGER
C                = 11   BOTH DETERMINANT AND INVERSE.
C                = 01   INVERSE ONLY.
C                = 10   DETERMINANT ONLY.
C
C     ON RETURN
C
C        A       IF CPOCO OR CPOFA WAS USED TO FACTOR  A  THEN
C                CPODI PRODUCES THE UPPER HALF OF INVERSE(A) .
C                IF CQRDC WAS USED TO DECOMPOSE  X  THEN
C                CPODI PRODUCES THE UPPER HALF OF INVERSE(CTRANS(X)*X)
C                WHERE CTRANS(X) IS THE CONJUGATE TRANSPOSE.
C                ELEMENTS OF  A  BELOW THE DIAGONAL ARE UNCHANGED.
C                IF THE UNITS DIGIT OF JOB IS ZERO,  A  IS UNCHANGED.
C
C        DET     REAL(2)
C                DETERMINANT OF  A  OR OF  CTRANS(X)*X  IF REQUESTED.
C                OTHERWISE NOT REFERENCED.
C                DETERMINANT = DET(1) * 10.0**DET(2)
C                WITH  1.0 .LE. DET(1) .LT. 10.0
C                OR  DET(1) .EQ. 0.0 .
C
C     ERROR CONDITION
C
C        A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS
C        A ZERO ON THE DIAGONAL AND THE INVERSE IS REQUESTED.
C        IT WILL NOT OCCUR IF THE SUBROUTINES ARE CALLED CORRECTLY
C        AND IF CPOCO OR CPOFA HAS SET INFO .EQ. 0 .
C
C     LINPACK.  THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS CAXPY,CSCAL
C     FORTRAN CONJG,MOD,REAL
C
C     INTERNAL VARIABLES
C
      COMPLEX T
      REAL S
      INTEGER J,JM1,K,KP1, I, ITEMP
C
C     COMPUTE DETERMINANT
C
      IF (JOB/10 .EQ. 0) GO TO 70
         DET(1) = 1.0E0
         DET(2) = 0.0E0
         S = 10.0E0
         DO 50 I = 1, N
            DET(1) = REAL(A(I,I))**2*DET(1)
C        ...EXIT
            IF (DET(1) .EQ. 0.0E0) GO TO 60
   10       IF (DET(1) .GE. 1.0E0) GO TO 20
               DET(1) = S*DET(1)
               DET(2) = DET(2) - 1.0E0
            GO TO 10
   20       CONTINUE
   30       IF (DET(1) .LT. S) GO TO 40
               DET(1) = DET(1)/S
               DET(2) = DET(2) + 1.0E0
            GO TO 30
   40       CONTINUE
   50    CONTINUE
   60    CONTINUE
   70 CONTINUE
C
C     COMPUTE INVERSE(R)
C
      IF (MOD(JOB,10) .EQ. 0) GO TO 140
         DO 100 K = 1, N
            A(K,K) = (1.0E0,0.0E0)/A(K,K)
            T = -A(K,K)
            ITEMP = K-1
            CALL CSCAL(ITEMP,T,A(1,K),1)
            KP1 = K + 1
            IF (N .LT. KP1) GO TO 90
            DO 80 J = KP1, N
               T = A(K,J)
               A(K,J) = (0.0E0,0.0E0)
               CALL CAXPY(K,T,A(1,K),1,A(1,J),1)
   80       CONTINUE
   90       CONTINUE
  100    CONTINUE
C
C        FORM  INVERSE(R) * CTRANS(INVERSE(R))
C
         DO 130 J = 1, N
            JM1 = J - 1
            IF (JM1 .LT. 1) GO TO 120
            DO 110 K = 1, JM1
               T = CONJG(A(K,J))
               CALL CAXPY(K,T,A(1,J),1,A(1,K),1)
  110       CONTINUE
  120       CONTINUE
            T = CONJG(A(J,J))
            CALL CSCAL(J,T,A(1,J),1)
  130    CONTINUE
  140 CONTINUE
      RETURN
      END
      COMPLEX FUNCTION CDOTC(N,CX,INCX,CY,INCY)
C
C     FORMS THE DOT PRODUCT OF TWO VECTORS, CONJUGATING THE FIRST
C     VECTOR.
C     JACK DONGARRA, LINPACK,  3/11/78.
C
      COMPLEX CX(1),CY(1),CTEMP
      INTEGER I,INCX,INCY,IX,IY,N
C
      CTEMP = (0.0,0.0)
      CDOTC = (0.0,0.0)
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        CTEMP = CTEMP + CONJG(CX(IX))*CY(IY)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      CDOTC = CTEMP
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
   20 DO 30 I = 1,N
        CTEMP = CTEMP + CONJG(CX(I))*CY(I)
   30 CONTINUE
      CDOTC = CTEMP
      RETURN
      END

      SUBROUTINE FFT84X (IN, N, X)
C-----------------------------------------------------------------------
C! VMS Pseudo AP routine: FFT routine
C#AP-FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Version of FFT842 using Bob Saults' VAX assembler R8TXX.
C   This program replaces the complex vector  X by its finite discrete,
C   complex Fourier transform if IN = 0.  The inverse transform is
C   calculated for IN=1.  It performs as many base 8 iterations as
C   possible and then finishes with a base 4 iteration or a base 2
C   iteration if needed.
C   Inputs:
C      IN  I      Transform direction; 0=>forward, 1=>reverse.
C      N   I      Number of points in array (must be power of two).
C   Input/Output:
C      X   I(2,N)  Complex array to transform / array transformed
C   Code Modified from:
C   Subroutine FFT842, by Bergland and Dolan
C   Programs for  Digital Signal Processing, IEEE press, 1979.
C   Uses routines R2TX, R4TX, R8TXX.
C-----------------------------------------------------------------------
      REAL       X(2,*), R, FI
      INTEGER    I, J, K, M, N2POW, NTHPO, N, IN, N8POW,
     *   IPASS, NXTLT, LENGT, NXTLT2, INDX(33)
C-----------------------------------------------------------------------
      M = 0
      INDX(1) = 1
      K = 1
C                                       Bit reversal/power array
 10   IF (K.LT.N) THEN
         M = M + 1
         K = K + K
         INDX(M+1) = K
         GO TO 10
         END IF
 20   N2POW = M
      NTHPO = N
      IF (IN.EQ.1) GO TO 40
      DO 30 I = 1,N
         X(2,I) = -X(2,I)
 30      CONTINUE
 40   N8POW = N2POW / 3
      IF (N8POW.EQ.0) GO TO 60
C                                       Radix 8 passes, if any.
      DO 50 IPASS = 1,N8POW
         NXTLT = N2POW - 3*IPASS + 1
         NXTLT = INDX(NXTLT)
         LENGT = 8 * NXTLT
         CALL R8TXX (NXTLT, NTHPO, LENGT, X(1,1), X(1,NXTLT+1),
     *      X(1,2*NXTLT+1), X(1,3*NXTLT+1), X(1,4*NXTLT+1),
     *      X(1,5*NXTLT+1), X(1,6*NXTLT+1),  X(1,7*NXTLT+1))
 50      CONTINUE
C                                       Reset NTHPO for other routines
      NTHPO = 2 * NTHPO
C                                       Is there a factor of 4 left?
 60   IF (N2POW-3*N8POW-1) 90, 70, 80
C                                       Go through the base 2 iteration
 70   CALL R2TX (NTHPO, X(1,1), X(1,2), X(2,1), X(2,2))
      GO TO 90
C                                       Go through the base 4 iteration
 80   CALL R4TX (NTHPO, X(1,1), X(1,2), X(1,3), X(1,4), X(2,1), X(2,2),
     *   X(2,3), X(2,4))
C                                       Bit reversal
 90   I = 0
      DO 110 J = 1,N-2
        K = M - 1
 100    IF (I.GE.INDX(K+1)) THEN
           I = I - INDX(K+1)
           K = K - 1
           GO TO 100
           END IF
        I = I + INDX(K+1)
        IF (I.GT.J) THEN
           R = X(1,I+1)
           X(1,I+1) = X(1,J+1)
           X(1,J+1) = R
           FI = X(2,I+1)
           X(2,I+1) = X(2,J+1)
           X(2,J+1) = FI
           END IF
 110    CONTINUE
      IF (IN.EQ.1) GO TO 150
      DO 140 I = 1,N
         X(2,I) = -X(2,I)
 140     CONTINUE
 150  CONTINUE
 170  RETURN
      END

LOCAL INCLUDE 'BPWAY.INC'
C                                       Local include for BPWAY
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMEO(3), XCLAOU(2), XSOUR(4,30),
     *   XCALC, XOPTYP
      REAL      XSIN, XDISIN, XSOU, XDISOU, XQUAL, XTIME(8), XFQID,
     *   XSUBA, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND,
     *   XBPVER, XSMOTH(3), XBIF, XEIF, XCHNS(4,20), XNORM, FPARM(30),
     *   XCENT, BADD(10)
      REAL      SCRBUF(256), BUFF1(UVBFSS), BUFF2(UVBFSS), MYTIME(2),
     *   BUFF3(UVBFSS), DIFPIX
      INTEGER   SEQIN, DISKIN, SEQOU, DISKOU, JBUFSZ, CATOLD(256),
     *   INCSI, INCFI, INCIFI, NRPRMI, OLDCNO, NEWCNO, NIF, NSTOK,
     *   CHNSEL(3,20,MAXIF), NANT, NCHAN, LIF, NPARM, LBIF, AVGCHN,
     *   XTRCHN, MYSUBA, MYFQID, MYNSOU, MYSOUW(30), COUNT
      LOGICAL   MYDOSW
      CHARACTER NAMEIN*12, CLAIN*6, NAMEOU*12, CLAOU*9, OPTYPE*4
      DOUBLE PRECISION UVSCAL
C                                       XPARM included to save info
C                                       for EXTLIST
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMEO, XCLAOU,
     *   XSOU, XDISOU, XOPTYP, XSOUR, XQUAL, XCALC, XTIME, XFQID, XSUBA,
     *   XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER,
     *   XSMOTH, XBIF, XEIF, XCHNS, XNORM, FPARM, XCENT, BADD
      COMMON /BPWAYP/ CATOLD, UVSCAL, SEQIN, DISKIN, SEQOU, DISKOU,
     *   INCSI, INCFI, INCIFI, NRPRMI, OLDCNO, CHNSEL, NIF, NSTOK, NANT,
     *   NCHAN, LIF, NPARM, LBIF, AVGCHN, XTRCHN, MYSUBA, MYFQID,
     *   MYTIME, MYNSOU, MYSOUW, MYDOSW, NEWCNO, COUNT, DIFPIX
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMEOU, CLAOU, OPTYPE
      COMMON /BUFRS/ SCRBUF, BUFF1, BUFF2, BUFF3, JBUFSZ
C                                       End local include for BPWAY
LOCAL END
LOCAL INCLUDE 'WTABLE.INC'
      INTEGER   WTLUN, WTRNO, WTBUFF(512), WTKOLS(4), WTNUMV(4)
      COMMON /WTCOMM/ WTBUFF, WTKOLS, WTNUMV, WTLUN, WTRNO
LOCAL END
      PROGRAM BPWAY
C-----------------------------------------------------------------------
C! Finds channel-dependent relative weights
C# Utility UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2014-2015, 2018-2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BPWAY does SPLIT/SPLAT while calculating weights based on the rms
C   in the spectram of each IF and polarization.  The usual calibration
C   adverbs STOKES, BCHAN, and ECHAN are suppressed.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C   full set of calibration adverbs
C      ICHANSEL
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, NWORDS, IERR, NBL, NTIME, I, IB(2)
      REAL      B(2)
      LONGINT   PB
      EQUIVALENCE (B, IB)
      INCLUDE 'BPWAY.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'BPWAY '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL BPWAIN (PRGM, IRET)
      IF (IRET.NE.0) THEN
         RQUICK = .FALSE.
         GO TO 990
         END IF
      NBL = (NANT * (NANT+1)) / 2
      NTIME = FPARM(1) + 0.1
      NTIME = (NTIME/2)*2 + 1
      IF (NTIME.LE.0) NTIME = 9
      NTIME = MIN (MAX (3, NTIME), 99)
      FPARM(1) = NTIME
      I = 12
      NWORDS = ((3 * NTIME * NBL) - 1) / 1024 + 1
      NWORDS = MAX (I, NWORDS)
      NWORDS = NWORDS * NCHAN * LIF * NSTOK
      CALL ZMEMRY ('GET ', PRGM, NWORDS, B, PB, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       find rmses and apply
      NWORDS = 1024 * NWORDS
      IF (OPTYPE.EQ.'SORC') THEN
         CALL BPWASU (NCHAN, NTIME, NANT, NBL, LIF, B(1+PB), NWORDS,
     *      IB(1+PB), IRET)
      ELSE
         OPTYPE = 'SCAN'
         CALL BPWANX (NCHAN, NTIME, NANT, NBL, LIF, B(1+PB), NWORDS,
     *      IB(1+PB), IRET)
         END IF
      IF (IRET.NE.0) GO TO 970
C                                       HI copy. added info
      CALL BPWAHI
C                                       free memory
 970  NWORDS = NWORDS / 1024
      CALL ZMEMRY ('FREE', PRGM, NWORDS, B, PB, IERR)
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE BPWAIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   BPWAIN gets input parameters for BPWAY and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      INCLUDE 'BPWAY.INC'
      CHARACTER STAT*4, PTYPE*2, BLANK*6
      INTEGER   IROUND, IERR, INCX, I, LUN, NW(MAXIF), K, K1, K2, J
      LOGICAL   MATCH, MULTI
      REAL      CATR(256), RPARM(20)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128), OFREQ
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      DATA BLANK /' '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
      COUNT = 0
C                                       Get input parameters.
      NPARM = 282
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.NE.1) THEN
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
            END IF
         END IF
C                                       Restart AIPS on failure
      IF (RQUICK) CALL RELPOP (JERR, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
C                                       Crunch input parameters.
      JERR = 5
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMEO, NAMEOU)
      CALL H2CHR (6, 1, XCLAOU, CLAOU)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      SEQOU = IROUND (XSOU)
      DISKOU = IROUND (XDISOU)
      IF (XNORM.EQ.0.0) XNORM = 1.0
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = .FALSE.
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1) = -1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)).EQ.0.0)
     *   TIMRNG(5) = 1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      CALL RFILL (8, 0.0, XTIME)
      XTIME(1) = TSTART
      XTIME(5) = TEND
      MYTIME(1) = TSTART
      MYTIME(2) = TEND
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      MYSUBA = SUBARR
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      OFREQ = FREQ
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
         NIF = 1
      ELSE
         NIF = CATBLK(KINAX+JLOCIF)
         BIF = XBIF + 0.5
         BIF = MAX (1, MIN (NIF, BIF))
         EIF = XEIF + 0.5
         IF (EIF.LT.BIF) EIF = NIF
         EIF = MIN (EIF, NIF)
         END IF
      XBIF = BIF
      XEIF = EIF
      NCHAN = CATBLK(KINAX+JLOCF)
      BCHAN = 1
      ECHAN = NCHAN
      LBIF = BIF
C                                       Freq id
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      MYFQID = FRQSEL
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
      XFQID = FRQSEL
C                                       Channel selection
      I = 60 * MAXIF
      CALL FILL (I, 0, CHNSEL)
      CALL FILL (MAXIF, 0, NW)
      DO 40 J = 1,20
         K = IROUND (XCHNS(2,J))
         IF (K.GT.0) THEN
            K = IROUND (XCHNS(4,J))
            IF ((K.LE.0) .OR. (K.GT.MAXIF)) THEN
               K1 = 1
               K2 = MAXIF
            ELSE
               K1 = K
               K2 = K
               END IF
            DO 25 K = K1,K2
               NW(K) = NW(K) + 1
               DO 20 I = 1,3
                  CHNSEL(I,NW(K),K) = IROUND (XCHNS(I,J))
                  IF (CHNSEL(I,NW(K),K).LT.0) CHNSEL(I,NW(K),K) = 0
 20               CONTINUE
               IF (CHNSEL(3,NW(K),K).EQ.0) CHNSEL(3,NW(K),K) = 1
 25            CONTINUE
            END IF
 40      CONTINUE
C                                       If no channel selection
C                                       use VLA definition of
C                                       channel 0
      BCHAN = NCHAN
      ECHAN = 1
      DO 50 K = 1,MAXIF
         IF (NW(K).LE.0) THEN
            NW(K) = 1
            CHNSEL(1,1,K) = NCHAN / 8 + 1
            CHNSEL(2,1,K) = NCHAN - (NCHAN/8)
            CHNSEL(3,1,K) = 1
            END IF
         DO 45 I = 1,NW(K)
            CHNSEL(1,I,K) = MAX (1, MIN (CHNSEL(1,I,K), NCHAN))
            IF (CHNSEL(2,I,K).LT.CHNSEL(1,I,K))
     *         CHNSEL(2,I,K) = NCHAN
            CHNSEL(2,I,K) = MAX (1, MIN (CHNSEL(2,I,K), NCHAN))
            BCHAN = MIN (BCHAN, CHNSEL(1,I,K))
            ECHAN = MAX (ECHAN, CHNSEL(2,I,K))
 45         CONTINUE
 50      CONTINUE
      CALL FNDEXT ('BP', CATBLK, K1)
      CALL MULSDB (CATBLK, MULTI)
      IF (MULTI) THEN
         CALL FNDEXT ('CL', CATBLK, K2)
      ELSE
         CALL FNDEXT ('SN', CATBLK, K2)
         END IF
      IF ((DOBAND.LE.0) .AND. (K1.GT.0)) THEN
         MSGTXT = 'WARNING: BANDPASS TABLE IS NOT BEING APPLIED'
         CALL MSGWRT (7)
         END IF
      IF ((.NOT.DOCAL) .AND. (K2.GT.0)) THEN
         MSGTXT = 'WARNING: CL/SN TABLES ARE NOT BEING APPLIED'
         CALL MSGWRT (7)
         END IF
C                                       reset to get all channels
      BCHAN = 1
      ECHAN = NCHAN
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, SCRBUF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      LIF = 1
      IF (JLOCIF.GE.0) LIF = CATBLK(KINAX+JLOCIF)
      NSTOK = CATBLK(KINAX+JLOCS)
      MYNSOU = NSOUWD
      MYDOSW = DOSWNT
      CALL COPY (30, SOUWAN, MYSOUW)
      CALL UVGET ('CLOS', RPARM, SCRBUF, IERR)
C                                       get max antenna number
      CALL GETANT (DISKIN, OLDCNO, SUBARR, CATUV, SCRBUF, IERR)
      NANT = NSTNS
C                                       Save file info (w cal adverbs)
      INCX = CATBLK(KINAX)
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
      IF (XCENT.LE.0.0) THEN
         DIFPIX = 0.0
      ELSE
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
         END IF
      UVSCAL = CATD(KDCRV+JLOCF) / OFREQ
C                                       Put new values in CATBLK
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMEOU, CLAOU, SEQOU)
      CALL CHR2H (12, NAMEOU, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOU, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOU
C                                       Create output file.
      NEWCNO = 1
      JERR = 4
      CALL UVCREA (DISKOU, NEWCNO, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKOU
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      CALL UVPGET (IERR)
C                                       copy keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKOU, NEWCNO, IERR)
C                                       parameter check
      IF (FPARM(3).LE.0.0) FPARM(3) = 1.E8
      FPARM(3) = FPARM(3) * FPARM(3)
      I = IROUND (FPARM(4))
      IF ((I.LT.1) .OR. (I.GT.5)) I = 1
      FPARM(4) = I
      IF (FPARM(5).LE.0.0) FPARM(5) = 10.0
      IF (FPARM(6).LE.0.0) THEN
         IF (I.EQ.2) THEN
            FPARM(6) = 3.0 * FPARM(5)
         ELSE IF (I.EQ.3) THEN
            FPARM(6) = 4.0 * FPARM(5)
         ELSE IF (I.EQ.4) THEN
            FPARM(6) = 2.0 * FPARM(5)
         ELSE
            FPARM(6) = 10.0
            END IF
         END IF
      FPARM(5) = FPARM(5) / (24.0 * 60.0)
      FPARM(6) = FPARM(6) / (24.0 * 60.0)
      IF (FPARM(7).LE.0.0) THEN
         FPARM(7) = 1.E8
      ELSE
         FPARM(7) = 1.0 / SQRT (FPARM(7))
         END IF
      IF (FPARM(8).LE.0.0) THEN
         FPARM(8) = 0.01
      ELSE
         FPARM(8) = 1.0 / SQRT (FPARM(8))
         END IF
      JERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPWAIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE CHWANT (NC, NI, CHNSEL, CHFLGS)
C-----------------------------------------------------------------------
C   Makes a mask of the desired channels
C   Inputs:
C      NC       I            Number spectral chans
C      NI       I            Number IFs
C      CHNSEL   I(3,20,*)    Start, stop, incr 20 sets per IF
C   Outputs
C      CHFLGS   I(*,*)       1 => use, 0 => don't use
C-----------------------------------------------------------------------
      INTEGER   NC, NI, CHNSEL(3,20,*), CHFLGS(NC,NI)
C
      INTEGER   I, J, K
C-----------------------------------------------------------------------
      J = NC * NI
      CALL FILL (J, 0, CHFLGS)
      DO 30 K = 1,NI
         DO 20 J = 1,20
            IF ((CHNSEL(1,J,K).GT.0) .AND. (CHNSEL(3,J,K).GT.0) .AND.
     *         (CHNSEL(2,J,K).GE.CHNSEL(1,J,K))) THEN
               DO 10 I = CHNSEL(1,J,K),CHNSEL(2,J,K),CHNSEL(3,J,K)
                  CHFLGS(I,K) = 1
 10               CONTINUE
               END IF
 20         CONTINUE
 30      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE BPWANX (NC, NT, NA, NB, NI, B, NWD, INDEX, IRET)
C-----------------------------------------------------------------------
C   Scan by scan, BPWANX accumulates a buffer of NT times for all
C   baselines, etc.  It then finds the rms over time for each channel,
C   IF, stokes and writes this to a table.  It then sorts, smooths, and
C   resorts the table.  Then it rereads the input file for that scan
C   applying normalized, channel-dependent weights to the output data.
C   Inputs:
C      NC      I      Number spectral channels
C      NT      I      Number times to accumulate
C      NA      I      Number antennas
C      NB      I      Max baseline number
C      NI      I      Max IF in data
C      NWORDS  I      Number woords in INDEX total
C   Output:
C      B       R(*)   Big buffer to accumulate the vis
C      INDEX   I(*)   Equivalenced buffer to B (NB+2,*)
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NC, NT, NA, NB, NI, NWD, INDEX(NB+2,*), IRET
      REAL      B(3,NC,NT,NB,NI,*)
C
      INTEGER   NTMAX
      PARAMETER (NTMAX = 99)
      INCLUDE 'BPWAY.INC'
      INCLUDE 'WTABLE.INC'
      INTEGER   NUMVIS, CATMP(256), CHFLGS(MAXCIF), NW, NVM, NTIMES, I,
     *   TNUM(NTMAX), VISN(2,NTMAX), LSOU, ISOU, NCT, CT, J1, J2, JT,
     *   NRBL(MAXANT,MAXANT), VER, NUMNX, INX, ISONE(MXBASE*NTMAX),
     *   LUNTMP, KOLSNX(MAXNXC), NUMVNX(MAXNXC), RNONX, BUFFNX(512),
     *   LUNX, NXSOUR, NXSUBA, VSTART, VEND, NXFQID, JB, KEY(2,2),
     *   KEYSUB(2,2), NTS, RNXRET, LUNOU, FINDOU, VO, ILENBU, BO, KBIND,
     *   IPTRO, NIOUT, NIOLIM, JA1, JA2, JBL, NCOPY, JI, JP, INDI, INDO,
     *   JF, NWORDS, MAXC, CTLIM, XCOUNT
      LOGICAL   END, FIRST, GOTONE, GETNEW, LDUM
      LONGINT   PSMTH
      REAL      VIS(3,UVBFSS/3), RPARM(20), TB, TE,  TINT, TIME, TEPS,
     *   TIMES(2,NTMAX), TLIMIT, NXDTIM, NXTIME, RMSRMS(3,MAXCIF),
     *   FKEY(2,2), RMSB(3*MAXCIF), BASEN, SMTH(2)
      DOUBLE PRECISION NZERO, NDONE
      CHARACTER PHNAME*48, STEP*22
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (VIS, BUFF1), (RMSRMS, RMSB)
      DATA KEY    /5, 0, 1, 0/
      DATA FKEY   /1.0, 0.0, 1.0, 0.0/
      DATA KEYSUB /4*1/
      DATA VO, BO /0, 1/
C-----------------------------------------------------------------------
      TEPS = 0.1 / (24.0 * 3600.0)
      CTLIM = NWD / (NB+2)
      XCOUNT = 0
C                                       parameters
      NVM = NC * NT
      IF (FPARM(2).LE.0.0) FPARM(2) = 10.
      TLIMIT = 2.01 * FPARM(1) * FPARM(2)
      TLIMIT = TLIMIT / (24. * 3600.)
      TINT = 1.001 * FPARM(2) / (24. * 3600.)
      I = NC * NI * 3
      CALL RFILL (I, 0.0, RMSRMS)
C                                       counters, mask
      NCHAN = CATBLK(KINAX+JLOCF)
      CALL CHWANT (NCHAN, LIF, CHNSEL(1,1,LBIF), CHFLGS)
      NTIMES = 0
      I = MAXANT * MAXANT
      CALL FILL (I, 0, NRBL)
      I = MXBASE * NTMAX
      CALL FILL (I, 0, ISONE)
C                                       NX table
      LUNX = LUNTMP (1)
      VER = 1
      CALL NDXINI ('READ', BUFFNX, DISKIN, OLDCNO, 1, CATOLD, LUNX,
     *   RNONX, KOLSNX, NUMVNX, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING THE INDEX TABLE'
         GO TO 990
         END IF
      NUMNX = BUFFNX(5)
C                                       init NX table on output
      CALL RNXGET (DISKIN, OLDCNO, CATUV)
      CALL RNXINI (DISKOU, NEWCNO, CATBLK, RNXRET)
C                                       output file
      CALL ZPHFIL ('UV', DISKOU, NEWCNO, 1, PHNAME, IRET)
      LUNOU = LUNTMP (0)
      CALL ZOPEN (LUNOU, FINDOU, DISKOU, PHNAME, .TRUE., .FALSE.,
     *   .TRUE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT UV DATA SET'
         GO TO 990
         END IF
C                                       init I/O
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNOU, FINDOU, NVIS, VO, LREC, ILENBU,
     *   JBUFSZ, BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT I/O TO OUTPUT DATA SET'
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       WT table
      DO 900 INX = 1,NUMNX
         CALL TABNDX ('READ', BUFFNX, RNONX, KOLSNX, NUMVNX, NXTIME,
     *      NXDTIM, NXSOUR, NXSUBA, VSTART, VEND, NXFQID, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING THE INDEX TABLE'
            GO TO 990
            END IF
C                                       do we want this scan?
         IF ((MYSUBA.GT.0) .AND. (MYSUBA.NE.NXSUBA)) GO TO 900
         IF ((MYFQID.GT.0) .AND. (MYFQID.NE.NXFQID)) GO TO 900
         TSTART = NXTIME - NXDTIM/2.0 - TEPS
         TEND = NXTIME + NXDTIM/2.0 + TEPS
         IF ((TEND.LT.MYTIME(1)) .OR. (TSTART.GT.MYTIME(2))) GO TO 900
         IF (MYNSOU.GT.0) THEN
            DO 10 I = 1,MYNSOU
               IF (NXSOUR.EQ.MYSOUW(I)) THEN
                  IF (.NOT.MYDOSW) GO TO 900
                  GO TO 15
                  END IF
 10            CONTINUE
            IF (MYDOSW) GO TO 900
            END IF
C                                       yes, set UVGET parms
 15      FRQSEL = NXFQID
         SUBARR = NXSUBA
         CALL RFILL (8, 0.0, TIMRNG)
         TIMRNG(1) = TSTART
         TIMRNG(5) = TEND
         INITVS = VSTART
         TB = -1000.0
         TE = TB
         NW = 3 * NC * NT * NB * NI * NSTOK
         CALL RFILL (NW, 0.0, B)
         LSOU = -1
         CT = 0
         NCT = 0
         FIRST = .TRUE.
         GOTONE = .FALSE.
         STEP = 'Starting'
         WRITE (MSGTXT,1015) STEP, INX
         CALL MSGWRT (2)
         NZERO = 0.0D0
         NDONE = 0.0D0
C                                       WT work table
         WTLUN = LUNTMP (1)
         VER = 1
         CALL WTINI ('WRIT', WTBUFF, DISKIN, OLDCNO, VER, CATOLD, WTLUN,
     *      WTRNO, WTKOLS, WTNUMV, NC, NI, NSTOK, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING THE WT (WORK) TABLE'
            GO TO 990
            END IF
C                                       reset WT table
         WTRNO = 1
         WTBUFF(5) = 0
C                                       defend cat header from UVGET
         CALL COPY (256, CATBLK, CATMP)
C                                       Open and init for read
         CALL UVGET ('INIT', RPARM, VIS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN/INIT INPUT VIS FILE'
            GO TO 990
            END IF
         CALL COPY (256, CATMP, CATBLK)
         NUMVIS = 0
C                                       Loop
C                                       Read vis. record.
 100     CALL UVGET ('READ', RPARM, VIS, IRET)
         END = IRET.LT.0
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING DATA FIRST PASS'
            GO TO 990
C                                       got good data, now what
         ELSE IF (IRET.LE.0) THEN
C                                       in current time
            IF (END) THEN
               TIME = 1.E4
            ELSE
               NUMVIS = NUMVIS + 1
               TIME = RPARM(1+ILOCT)
               END IF
            ISOU = 1
            IF (ILOCSU.GE.0) ISOU = RPARM(1+ILOCSU) + 0.01
            IF (END) ISOU = -1
            IF ((ABS(TB-TIME).LT.TINT) .AND. (ISOU.EQ.LSOU)) THEN
               CALL RWPUTB (NC, NT, NB, NI, CT, RPARM, VIS, B, ISONE,
     *            GETNEW)
               IF (.NOT.GETNEW) THEN
                  GOTONE = .TRUE.
                  VISN(2,CT) = NUMVIS
                  TIMES(1,CT) = MIN (TIMES(1,CT), TIME)
                  TIMES(2,CT) = MAX (TIMES(2,CT), TIME)
                  TB = TIMES(1,CT)
                  END IF
            ELSE
               GETNEW = .TRUE.
               END IF
C                                       need new time bin
            IF (GETNEW) THEN
C                                       just advance time counter
               IF ((NCT.LT.NT) .AND. (ISOU.EQ.LSOU) .AND.
     *            (TIME-TB.LT.TLIMIT)) THEN
                  NCT = NCT + 1
                  TNUM(NCT) = NCT
                  CT = NCT
                  JT = NB * (CT -1) + 1
                  CALL FILL (NB, 0, ISONE(JT))
                  TIMES(1,NCT) = TIME
                  TIMES(2,NCT) = TIME
                  VISN(1,CT) = NUMVIS
                  VISN(2,CT) = NUMVIS
                  CALL RWPUTB (NC, NT, NB, NI, CT, RPARM, VIS, B, ISONE,
     *               LDUM)
                  GOTONE = .TRUE.
                  TB = TIME
C                                       still going, clear 1 or more
               ELSE IF ((ISOU.EQ.LSOU) .AND. (TIME-TB.LT.TLIMIT)) THEN
                  J1 = (NT+1)/2
                  J2 = J1
                  IF (FIRST) J1 = 1
                  FIRST = .FALSE.
                  CALL RWRMSH (NC, NT, NA, NB, NI, NCT, J1, J2, TNUM,
     *               CHFLGS, B, RMSRMS, TIMES, VISN, IRET)
                  IF (IRET.NE.0) GO TO 999
C                                       next
                  CT = TNUM(1)
                  DO 150 JT = 1,NT-1
                     TNUM(JT) = TNUM(JT+1)
 150                 CONTINUE
                  JT = NB * (CT -1) + 1
                  CALL FILL (NB, 0, ISONE(JT))
                  TNUM(NT) = CT
                  TIMES(1,CT) = TIME
                  TIMES(2,CT) = TIME
                  VISN(1,CT) = NUMVIS
                  VISN(2,CT) = NUMVIS
                  CALL RWPUTB (NC, NT, NB, NI, CT, RPARM, VIS, B, ISONE,
     *               LDUM)
                  GOTONE = .TRUE.
                  TB = TIME
C                                       done with this scan
               ELSE
                  IF (GOTONE) THEN
                     J1 = (NT+1)/2
                     J2 = NCT
                     IF (FIRST) J1 = 1
                     CALL RWRMSH (NC, NT, NA, NB, NI, NCT, J1, J2, TNUM,
     *                  CHFLGS, B, RMSRMS, TIMES, VISN, IRET)
                     IF (IRET.NE.0) GO TO 999
                     END IF
                  IF (.NOT.END) THEN
                     CALL RFILL (NW, 0.0, B)
                     FIRST = .TRUE.
                     CT = 1
                     CALL FILL (NB, 0, ISONE)
                     NCT = 1
                     TNUM(1) = 1
                     TIMES(1,CT) = TIME
                     TIMES(2,CT) = TIME
                     VISN(1,CT) = NUMVIS
                     VISN(2,CT) = NUMVIS
                     CALL RWPUTB (NC, NT, NB, NI, CT, RPARM, VIS, B,
     *                  ISONE, LDUM)
                     TB = TIME
                     LSOU = ISOU
                     GOTONE = .TRUE.
                     END IF
                  END IF
               END IF
            IF (.NOT.END) GO TO 100
            END IF
C                                       close uv data set
         CALL UVGET ('CLOS', RPARM, VIS, IRET)
C                                       close WT file and sort
         CALL TABWT ('CLOS', WTBUFF, WTRNO, WTKOLS, WTNUMV, TIMES, VISN,
     *      JB, RMSRMS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING WT TABLE BEFORE SMOOTH'
            GO TO 990
            END IF
         STEP = 'Sorting weights for'
         WRITE (MSGTXT,1015) STEP, INX
         CALL MSGWRT (2)
         KEY(1,1) = 3
         KEY(1,2) = 1
         CALL TABSRT (DISKIN, OLDCNO, 'WT', VER, VER+1, KEY, KEYSUB,
     *      FKEY, BUFF1, CATOLD, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SORTING TO BASELINE-TIME'
            GO TO 990
            END IF
C                                       count, average polarizations
         CALL BPWCNT (VER+1, NC, NI, RMSRMS, MAXC, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'COUNTING WT TABLE'
            GO TO 990
            END IF
C                                       smooth
         STEP = 'Smoothing weights for'
         WRITE (MSGTXT,1015) STEP, INX
         CALL MSGWRT (2)
         J1 = NC * NI * NSTOK
         NWORDS = ((MAXC + 2) * J1 - 1) / 1024 + 1
         CALL ZMEMRY ('GET ', 'BPWANX', NWORDS, SMTH, PSMTH, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY FOR SMOOTHING'
            CALL MSGWRT (8)
            GO TO 990
            END IF
         NTS = (NWORDS * 1024) / J1
         CALL BPSMOO (VER+1, VER+2, J1, NTS, SMTH(1+PSMTH), RMSRMS,
     *      IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SMOOTHING WT TABLE'
            GO TO 990
            END IF
         CALL ZMEMRY ('FREE', 'BPWANX', NWORDS, SMTH, PSMTH, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'UNABLE TO FREE DYNAMIC MEMORY FOR SMOOTHING'
            CALL MSGWRT (8)
            END IF
C                                       sort back
         STEP = 'Re-sorting weights for'
         WRITE (MSGTXT,1015) STEP, INX
         CALL MSGWRT (2)
         KEY(1,1) = 2
         KEY(1,2) = 3
         CALL TABSRT (DISKIN, OLDCNO, 'WT', VER+2, VER, KEY, KEYSUB,
     *      FKEY, BUFF1, CATOLD, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SORTING TO TIME-BASELINE'
            GO TO 990
            END IF
         CALL RMEXT (DISKIN, OLDCNO, 'WT', VER+2, CATOLD, SCRBUF, IRET)
         CALL RMEXT (DISKIN, OLDCNO, 'WT', VER+1, CATOLD, SCRBUF, IRET)
C                                       set UVGET parms for re-read
         FRQSEL = NXFQID
         SUBARR = NXSUBA
         CALL RFILL (8, 0.0, TIMRNG)
         TIMRNG(1) = TSTART
         TIMRNG(5) = TEND
         INITVS = VSTART
         STEP = 'Applying weights for'
         WRITE (MSGTXT,1015) STEP, INX
         CALL MSGWRT (2)
C                                       defend cat header from UVGET
         CALL COPY (256, CATBLK, CATMP)
C                                       Open and init for read
         CALL UVGET ('INIT', RPARM, VIS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN/INIT INPUT VIS FILE'
            GO TO 990
            END IF
         CALL COPY (256, CATMP, CATBLK)
         NUMVIS = 0
C                                       WT work table
         WTLUN = LUNTMP (1)
         VER = 1
         CALL WTINI ('READ', WTBUFF, DISKIN, OLDCNO, VER, CATOLD, WTLUN,
     *      WTRNO, WTKOLS, WTNUMV, NC, NI, NSTOK, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING THE WT (WORK) TABLE'
            GO TO 990
            END IF
C                                       make index of WT file
         CT = 0
         NTS = WTBUFF(5)
         DO 160 I = 1,NTS
            CALL TABWT ('READ', WTBUFF, WTRNO, WTKOLS, WTNUMV, TIMES,
     *         VISN, JB, RMSRMS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING WT FILE TO INDEX'
               GO TO 990
               END IF
            IF ((CT.EQ.0) .OR. ((VISN(1,1).NE.INDEX(1,CT)) .AND.
     *         (VISN(2,1).NE.INDEX(2,CT)))) THEN
               IF (CT.LT.CTLIM) THEN
                  CT = CT + 1
                  CALL FILL (NB+2, 0, INDEX(1,CT))
                  INDEX(1,CT) = VISN(1,1)
                  INDEX(2,CT) = VISN(2,1)
               ELSE
                  WRITE (MSGTXT,1160) CTLIM
                  IRET = 99
                  GO TO 990
                  END IF
               END IF
            INDEX(JB+2,CT) = I
 160        CONTINUE
         CT = 1
C                                       Loop
C                                       Read vis. record.
 200     CALL UVGET ('READ', RPARM, VIS, IRET)
         END = IRET.LT.0
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING DATA FIRST PASS'
            GO TO 990
C                                       got good data
         ELSE IF (IRET.EQ.0) THEN
            NUMVIS = NUMVIS + 1
            IF (ILOCB.GE.0) THEN
               BASEN = RPARM(1+ILOCB)
               JA1 = BASEN / 256. + 0.1
               JA2 = BASEN - JA1*256. + 0.1
            ELSE
               JA1 = RPARM(1+ILOCA1) + 0.1
               JA2 = RPARM(1+ILOCA2) + 0.1
               END IF
            JBL = NANT * (JA1-1) - ((JA1*(JA1-1))/2) + JA2
 205        IF (NUMVIS.GT.INDEX(2,CT)) THEN
               CT = CT + 1
               GO TO 205
               END IF
            WTRNO = INDEX(JBL+2,CT)
            CALL TABWT ('READ', WTBUFF, WTRNO, WTKOLS, WTNUMV, TIMES,
     *         VISN, JB, RMSB, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING WT FILE TO INDEX'
               GO TO 990
               END IF
            NCOPY = 3 * NI * NSTOK * NC
            DO 240 JI = 1,NI
               DO 230 JP = 1,NSTOK
                  INDI = (JI-1) * INCIFI + (JP-1) * INCSI + 1 - INCFI
                  INDO = (JI-1) * NC + (JP - 1) * NC * NI
                  DO 220 JF = 1,NC
                     INDI = INDI + INCFI
                     INDO = INDO + 1
                     IF (VIS(3,INDI).GT.0.0) THEN
                        IF (RMSB(INDO).GT.0.0) THEN
                           IF (FPARM(10).GT.0.0) VIS(3,INDI) = 1.0
                           VIS(3,INDI) = VIS(3,INDI) / (RMSB(INDO) ** 2)
                           NDONE = NDONE + 1.0D0
                        ELSE
                           NZERO = NZERO + 1.0D0
                           END IF
                        END IF
 220                 CONTINUE
 230              CONTINUE
 240           CONTINUE
            RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
            RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
            RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
            XCOUNT = XCOUNT + 1
            CALL RCOPY (NRPARM, RPARM, BUFF2(IPTRO))
            CALL RCOPY (NCOPY, VIS, BUFF2(IPTRO+NRPARM))
            NIOUT = NIOUT + 1
C                                       update NX table
            CALL RNXUPD (BUFF2(IPTRO), RNXRET)
            IPTRO = IPTRO + NCOPY + NRPARM
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNOU, FINDOU, BUFF2, NIOLIM,
     *            KBIND, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT DATA SET'
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
            GO TO 200
            END IF
C                                       close uv data set
         CALL UVGET ('CLOS', RPARM, VIS, IRET)
         IF (NZERO.GT.0.0D0) THEN
            WRITE (MSGTXT,1900) NZERO
            CALL MSGWRT (3)
            END IF
         IF (NDONE.GT.0.0D0) THEN
            WRITE (MSGTXT,1901) NDONE
            CALL MSGWRT (3)
            END IF
         CALL TABWT ('CLOS', WTBUFF, WTRNO, WTKOLS, WTNUMV, TIMES,
     *      VISN, JB, RMSB, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING WT FILE TO INDEX'
            GO TO 990
            END IF
 900     CONTINUE
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNOU, FINDOU, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINISH WRITING THE OUTPUT DATA SET'
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKOU, NEWCNO, LUNOU, CATBLK, IRET)
      CALL ZCLOSE (LUNOU, FINDOU, IRET)
      CALL UVPGET (IRET)
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPWANX: ERROR',I3,' ON ',A)
 1015 FORMAT (A22,' scan',I5)
 1160 FORMAT ('Reached index limit',I10)
 1900 FORMAT (F12.0,' visibility weights unchanged')
 1901 FORMAT (F12.0,' visibility weights changed')
      END
      SUBROUTINE BPWASU (NC, NT, NA, NB, NI, B, NWD, INDEX, IRET)
C-----------------------------------------------------------------------
C   Source by source, BPWASU accumulates a buffer of NT times for all
C   baselines, etc.  It then finds the rms over time for each channel,
C   IF, stokes and writes this to a table.  It then sorts, smooths, and
C   resorts the table.  Then it rereads the input file for that source
C   applying normalized, channel-dependent weights to the output data.
C   Inputs:
C      NC      I      Number spectral channels
C      NT      I      Number times to accumulate
C      NA      I      Number antennas
C      NB      I      Max baseline number
C      NI      I      Max IF in data
C      NWD     I      Number words in INDEX
C   Output:
C      B       R(*)   Big buffer to accumulate the vis
C      INDEX   I(*)   Equivalenced buffer to B (NB+2,*)
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NC, NT, NA, NB, NI, NWD, INDEX(NB+2,*), IRET
      REAL      B(3,NC,NT,NB,NI,*)
C
      INTEGER   NTMAX
      PARAMETER (NTMAX = 99)
      INCLUDE 'BPWAY.INC'
      INCLUDE 'WTABLE.INC'
      INTEGER   NUMVIS, CATMP(256), CHFLGS(MAXCIF), NW, NVM, NTIMES, I,
     *   TNUM(NTMAX), VISN(2,NTMAX), LSOU, ISOU, NCT, CT, J1, J2, JT,
     *   NRBL(MAXANT,MAXANT), VER, NUMSU, ISU, ISONE(MXBASE*NTMAX),
     *   LUNTMP, KOLSSU(MAXSUC), NUMVSU(MAXSUC), RNOSU, BUFFSU(512),
     *   LUSU, SUSOUR, SUSUBA, SUFQID, JB, KEY(2,2), KEYSUB(2,2), NTS,
     *   RNXRET, LUNOU, FINDOU, VO, ILENBU, BO, KBIND, IPTRO, NIOUT,
     *   NIOLIM, JA1, JA2, JBL, NCOPY, JI, JP, INDI, INDO, JF, NWORDS,
     *   MAXC, QUAL, CTLIM, SUNIF, XCOUNT
      LOGICAL   END, FIRST, GOTONE, GETNEW, LDUM, MULTI, ORDER
      LONGINT   PSMTH
      REAL      VIS(3,UVBFSS/3), RPARM(20), TB, TE,  TINT, TIME, TEPS,
     *   TIMES(2,NTMAX), TLIMIT, RMSRMS(3,MAXCIF), PTIME, FKEY(2,2),
     *   RMSB(3*MAXCIF), BASEN, SMTH(2), FLUX(4,MAXIF)
      DOUBLE PRECISION NZERO, NDONE, FREQO(MAXIF), BANDW, RAEPO, DECEPO,
     *   EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL(MAXIF),
     *   LRESTF(MAXIF), PMRA, PMDEC
      CHARACTER PHNAME*48, STEP*22, VELTYP*8, VELDEF*8, SOUNAM*16,
     *   CALCOD*4
      HOLLERITH CATH(256)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (VIS, BUFF1), (RMSRMS, RMSB), (CATH, CATBLK)
      DATA KEY    /5, 0, 1, 0/
      DATA FKEY   /1.0, 0.0, 1.0, 0.0/
      DATA KEYSUB /4*1/
      DATA VO, BO /0, 1/
C-----------------------------------------------------------------------
      TEPS = 0.1 / (24.0 * 3600.0)
      CALL MULSDB (CATOLD, MULTI)
      CTLIM = NWD / (NB+2)
      ORDER = .TRUE.
      PTIME = -1000.
      XCOUNT = 0
C                                       parameters
      NVM = NC * NT
      IF (FPARM(2).LE.0.0) FPARM(2) = 10.
      TLIMIT = 2.01 * FPARM(1) * FPARM(2)
      TLIMIT = TLIMIT / (24. * 3600.)
      TINT = 1.001 * FPARM(2) / (24. * 3600.)
      I = NC * NI * 3
      CALL RFILL (I, 0.0, RMSRMS)
C                                       counters, mask
      NCHAN = CATBLK(KINAX+JLOCF)
      CALL CHWANT (NCHAN, LIF, CHNSEL(1,1,LBIF), CHFLGS)
      NTIMES = 0
      I = MAXANT * MAXANT
      CALL FILL (I, 0, NRBL)
      I = MXBASE * NTMAX
      CALL FILL (I, 0, ISONE)
C                                       SU table
      IF (MULTI) THEN
         LUSU = LUNTMP (1)
         VER = 1
         CALL SOUINI ('READ', BUFFSU, DISKIN, OLDCNO, 1, CATOLD, LUSU,
     *      SUNIF, VELTYP, VELDEF, SUFQID, RNOSU, KOLSSU, NUMVSU, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING THE SOURCE TABLE'
            GO TO 990
            END IF
         NUMSU = BUFFSU(5)
         DO 5 I = 1,30
            SOURCS(I) = ' '
 5          CONTINUE
      ELSE
         NUMSU = 1
         END IF
C                                       init SU table on output
      CALL RNXGET (DISKIN, OLDCNO, CATUV)
      CALL RNXINI (DISKOU, NEWCNO, CATBLK, RNXRET)
C                                       output file
      CALL ZPHFIL ('UV', DISKOU, NEWCNO, 1, PHNAME, IRET)
      LUNOU = LUNTMP (0)
      CALL ZOPEN (LUNOU, FINDOU, DISKOU, PHNAME, .TRUE., .FALSE.,
     *   .TRUE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT UV DATA SET'
         GO TO 990
         END IF
C                                       init I/O
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNOU, FINDOU, NVIS, VO, LREC, ILENBU,
     *   JBUFSZ, BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT I/O TO OUTPUT DATA SET'
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       WT table
      DO 900 ISU = 1,NUMSU
         IF (MULTI) THEN
            CALL TABSOU ('READ', BUFFSU, RNOSU, KOLSSU, NUMVSU, SUSOUR,
     *         SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *         EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF,
     *         PMRA, PMDEC, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING THE SOURCE TABLE'
               GO TO 990
               END IF
C                                       do we want this scan?
            IF (MYNSOU.GT.0) THEN
               DO 10 I = 1,MYNSOU
                  IF (SUSOUR.EQ.MYSOUW(I)) THEN
                     IF (.NOT.MYDOSW) GO TO 900
                     GO TO 15
                     END IF
 10               CONTINUE
               IF (MYDOSW) GO TO 900
               END IF
 15         FRQSEL = SUFQID
            SOURCS(1) = SOUNAM
C                                       single source
         ELSE
            CALL H2CHR (8, 1, CATH(KHOBJ), SOUNAM)
            FRQSEL = MYFQID
            END IF
         SUBARR = MYSUBA
         CALL RFILL (8, 0.0, TIMRNG)
         TIMRNG(1) = MYTIME(1)
         TIMRNG(5) = MYTIME(2)
         INITVS = 1
         TB = -10000
         TE = TB
         NW = 3 * NC * NT * NB * NI * NSTOK
         CALL RFILL (NW, 0.0, B)
         LSOU = -1
         CT = 0
         NCT = 0
         FIRST = .TRUE.
         GOTONE = .FALSE.
         STEP = 'Starting'
         WRITE (MSGTXT,1015) STEP, ISU, SOUNAM
         CALL MSGWRT (2)
         NZERO = 0.0D0
         NDONE = 0.0D0
C                                       WT work table
         WTLUN = LUNTMP (1)
         VER = 1
         CALL WTINI ('WRIT', WTBUFF, DISKIN, OLDCNO, VER, CATOLD, WTLUN,
     *      WTRNO, WTKOLS, WTNUMV, NC, NI, NSTOK, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING THE WT (WORK) TABLE'
            GO TO 990
            END IF
C                                       reset WT table
         WTRNO = 1
         WTBUFF(5) = 0
C                                       defend cat header from UVGET
         CALL COPY (256, CATBLK, CATMP)
C                                       Open and init for read
         CALL UVGET ('INIT', RPARM, VIS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN/INIT INPUT VIS FILE'
            GO TO 990
            END IF
         CALL COPY (256, CATMP, CATBLK)
         NUMVIS = 0
C                                       Loop
C                                       Read vis. record.
 100     CALL UVGET ('READ', RPARM, VIS, IRET)
         END = IRET.LT.0
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING DATA FIRST PASS'
            GO TO 990
C                                       got good data, now what
         ELSE IF (IRET.LE.0) THEN
C                                       in current time
            IF (END) THEN
               TIME = 1.E4
            ELSE
               NUMVIS = NUMVIS + 1
               TIME = RPARM(1+ILOCT)
               END IF
            ISOU = 1
            IF (ILOCSU.GE.0) ISOU = RPARM(1+ILOCSU) + 0.01
            IF (END) ISOU = -1
            IF ((ABS(TB-TIME).LT.TINT) .AND. (ISOU.EQ.LSOU)) THEN
               CALL RWPUTB (NC, NT, NB, NI, CT, RPARM, VIS, B, ISONE,
     *            GETNEW)
               IF (.NOT.GETNEW) THEN
                  GOTONE = .TRUE.
                  VISN(2,CT) = NUMVIS
                  TIMES(1,CT) = MIN (TIMES(1,CT), TIME)
                  TIMES(2,CT) = MAX (TIMES(2,CT), TIME)
                  TB = TIMES(1,CT)
                  END IF
            ELSE
               GETNEW = .TRUE.
               END IF
C                                       need new time bin
            IF (GETNEW) THEN
C                                       just advance time counter
               IF ((NCT.LT.NT) .AND. (ISOU.EQ.LSOU) .AND.
     *            (TIME-TB.LT.TLIMIT)) THEN
                  NCT = NCT + 1
                  TNUM(NCT) = NCT
                  CT = NCT
                  JT = NB * (CT -1) + 1
                  CALL FILL (NB, 0, ISONE(JT))
                  TIMES(1,NCT) = TIME
                  TIMES(2,NCT) = TIME
                  VISN(1,CT) = NUMVIS
                  VISN(2,CT) = NUMVIS
                  CALL RWPUTB (NC, NT, NB, NI, CT, RPARM, VIS, B, ISONE,
     *               LDUM)
                  GOTONE = .TRUE.
                  TB = TIME
C                                       still going, clear 1 or more
               ELSE IF ((ISOU.EQ.LSOU) .AND. (TIME-TB.LT.TLIMIT)) THEN
                  J1 = (NT+1)/2
                  J2 = J1
                  IF (FIRST) J1 = 1
                  FIRST = .FALSE.
                  CALL RWRMSH (NC, NT, NA, NB, NI, NCT, J1, J2, TNUM,
     *               CHFLGS, B, RMSRMS, TIMES, VISN, IRET)
                  IF (IRET.NE.0) GO TO 999
C                                       next
                  CT = TNUM(1)
                  DO 150 JT = 1,NT-1
                     TNUM(JT) = TNUM(JT+1)
 150                 CONTINUE
                  JT = NB * (CT -1) + 1
                  CALL FILL (NB, 0, ISONE(JT))
                  TNUM(NT) = CT
                  TIMES(1,CT) = TIME
                  TIMES(2,CT) = TIME
                  VISN(1,CT) = NUMVIS
                  VISN(2,CT) = NUMVIS
                  CALL RWPUTB (NC, NT, NB, NI, CT, RPARM, VIS, B, ISONE,
     *               LDUM)
                  GOTONE = .TRUE.
                  TB = TIME
C                                       done with this scan
               ELSE
                  IF (GOTONE) THEN
                     J1 = (NT+1)/2
                     J2 = NCT
                     IF (FIRST) J1 = 1
                     CALL RWRMSH (NC, NT, NA, NB, NI, NCT, J1, J2, TNUM,
     *                  CHFLGS, B, RMSRMS, TIMES, VISN, IRET)
                     IF (IRET.NE.0) GO TO 999
                     END IF
                  IF (.NOT.END) THEN
                     CALL RFILL (NW, 0.0, B)
                     FIRST = .TRUE.
                     CT = 1
                     CALL FILL (NB, 0, ISONE)
                     NCT = 1
                     TNUM(1) = 1
                     TIMES(1,CT) = TIME
                     TIMES(2,CT) = TIME
                     VISN(1,CT) = NUMVIS
                     VISN(2,CT) = NUMVIS
                     CALL RWPUTB (NC, NT, NB, NI, CT, RPARM, VIS, B,
     *                  ISONE, LDUM)
                     TB = TIME
                     LSOU = ISOU
                     GOTONE = .TRUE.
                     END IF
                  END IF
               END IF
            IF (.NOT.END) GO TO 100
            END IF
C                                       close uv data set
         CALL UVGET ('CLOS', RPARM, VIS, IRET)
C                                       close WT file and sort
         CALL TABWT ('CLOS', WTBUFF, WTRNO, WTKOLS, WTNUMV, TIMES, VISN,
     *      JB, RMSRMS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING WT TABLE BEFORE SMOOTH'
            GO TO 990
            END IF
         STEP = 'Sorting weights for'
         WRITE (MSGTXT,1015) STEP, ISU, SOUNAM
         CALL MSGWRT (2)
         KEY(1,1) = 3
         KEY(1,2) = 1
         CALL TABSRT (DISKIN, OLDCNO, 'WT', VER, VER+1, KEY, KEYSUB,
     *      FKEY, BUFF1, CATOLD, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SORTING TO BASELINE-TIME'
            GO TO 990
            END IF
C                                       count, average polarizations
         CALL BPWCNT (VER+1, NC, NI, RMSRMS, MAXC, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'COUNTING WT TABLE'
            GO TO 990
            END IF
C                                       smooth
         STEP = 'Smoothing weights for'
         WRITE (MSGTXT,1015) STEP, ISU, SOUNAM
         CALL MSGWRT (2)
         J1 = NC * NI * NSTOK
         NWORDS = ((MAXC + 2) * J1 - 1) / 1024 + 1
         CALL ZMEMRY ('GET ', 'BPWASU', NWORDS, SMTH, PSMTH, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY FOR SMOOTHING'
            CALL MSGWRT (8)
            GO TO 990
            END IF
         NTS = (NWORDS * 1024) / J1
         CALL BPSMOO (VER+1, VER+2, J1, NTS, SMTH(1+PSMTH), RMSRMS,
     *      IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SMOOTHING WT TABLE'
            GO TO 990
            END IF
         CALL ZMEMRY ('FREE', 'BPWASU', NWORDS, SMTH, PSMTH, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'UNABLE TO FREE DYNAMIC MEMORY FOR SMOOTHING'
            CALL MSGWRT (8)
            END IF
C                                       sort back
         STEP = 'Re-sorting weights for'
         WRITE (MSGTXT,1015) STEP, ISU, SOUNAM
         CALL MSGWRT (2)
         KEY(1,1) = 2
         KEY(1,2) = 3
         CALL TABSRT (DISKIN, OLDCNO, 'WT', VER+2, VER, KEY, KEYSUB,
     *      FKEY, BUFF1, CATOLD, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'SORTING TO TIME-BASELINE'
            GO TO 990
            END IF
         CALL RMEXT (DISKIN, OLDCNO, 'WT', VER+2, CATOLD, SCRBUF, IRET)
         CALL RMEXT (DISKIN, OLDCNO, 'WT', VER+1, CATOLD, SCRBUF, IRET)
C                                       set UVGET parms for re-read
         FRQSEL = SUFQID
         SUBARR = SUSUBA
         CALL RFILL (8, 0.0, TIMRNG)
         TIMRNG(1) = TSTART
         TIMRNG(5) = TEND
         INITVS = 1
         STEP = 'Applying weights for'
         WRITE (MSGTXT,1015) STEP, ISU, SOUNAM
         CALL MSGWRT (2)
C                                       defend cat header from UVGET
         CALL COPY (256, CATBLK, CATMP)
C                                       Open and init for read
         CALL UVGET ('INIT', RPARM, VIS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN/INIT INPUT VIS FILE'
            GO TO 990
            END IF
         CALL COPY (256, CATMP, CATBLK)
         NUMVIS = 0
C                                       WT work table
         WTLUN = LUNTMP (1)
         VER = 1
         CALL WTINI ('READ', WTBUFF, DISKIN, OLDCNO, VER, CATOLD, WTLUN,
     *      WTRNO, WTKOLS, WTNUMV, NC, NI, NSTOK, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING THE WT (WORK) TABLE'
            GO TO 990
            END IF
C                                       make index of WT file
         CT = 0
         NTS = WTBUFF(5)
         DO 160 I = 1,NTS
            CALL TABWT ('READ', WTBUFF, WTRNO, WTKOLS, WTNUMV, TIMES,
     *         VISN, JB, RMSRMS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING WT FILE TO INDEX'
               GO TO 990
               END IF
            IF ((CT.EQ.0) .OR. ((VISN(1,1).NE.INDEX(1,CT)) .AND.
     *         (VISN(2,1).NE.INDEX(2,CT)))) THEN
               IF (CT.LT.CTLIM) THEN
                  CT = CT + 1
                  CALL FILL (NB+2, 0, INDEX(1,CT))
                  INDEX(1,CT) = VISN(1,1)
                  INDEX(2,CT) = VISN(2,1)
               ELSE
                  WRITE (MSGTXT,1160) CTLIM
                  IRET = 99
                  GO TO 990
                  END IF
               END IF
            INDEX(JB+2,CT) = I
 160        CONTINUE
         CT = 1
C                                       Loop
C                                       Read vis. record.
 200     CALL UVGET ('READ', RPARM, VIS, IRET)
         END = IRET.LT.0
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING DATA FIRST PASS'
            GO TO 990
C                                       got good data
         ELSE IF (IRET.EQ.0) THEN
            NUMVIS = NUMVIS + 1
            IF (ILOCB.GE.0) THEN
               BASEN = RPARM(1+ILOCB)
               JA1 = BASEN / 256. + 0.1
               JA2 = BASEN - JA1*256. + 0.1
            ELSE
               JA1 = RPARM(1+ILOCA1) + 0.1
               JA2 = RPARM(1+ILOCA2) + 0.1
               END IF
            JBL = NANT * (JA1-1) - ((JA1*(JA1-1))/2) + JA2
 205        IF (NUMVIS.GT.INDEX(2,CT)) THEN
               CT = CT + 1
               GO TO 205
               END IF
            WTRNO = INDEX(JBL+2,CT)
            CALL TABWT ('READ', WTBUFF, WTRNO, WTKOLS, WTNUMV, TIMES,
     *         VISN, JB, RMSB, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING WT FILE TO INDEX'
               GO TO 990
               END IF
            NCOPY = 3 * NI * NSTOK * NC
            DO 240 JI = 1,NI
               DO 230 JP = 1,NSTOK
                  INDI = (JI-1) * INCIFI + (JP-1) * INCSI + 1 - INCFI
                  INDO = (JI-1) * NC + (JP - 1) * NC * NI
                  DO 220 JF = 1,NC
                     INDI = INDI + INCFI
                     INDO = INDO + 1
                     IF (VIS(3,INDI).GT.0.0) THEN
                        IF (RMSB(INDO).GT.0.0) THEN
                           IF (FPARM(10).GT.0.0) VIS(3,INDI) = 1.0
                           VIS(3,INDI) = VIS(3,INDI) / (RMSB(INDO) ** 2)
                           NDONE = NDONE + 1.0D0
                        ELSE
                           NZERO = NZERO + 1.0D0
                           END IF
                        END IF
 220                 CONTINUE
 230              CONTINUE
 240           CONTINUE
            RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
            RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
            RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
            IF (RPARM(1+ILOCT).GE.PTIME) THEN
               PTIME = RPARM(1+ILOCT)
            ELSE
               ORDER = .FALSE.
               END IF
            XCOUNT = XCOUNT + 1
            CALL RCOPY (NRPARM, RPARM, BUFF2(IPTRO))
            CALL RCOPY (NCOPY, VIS, BUFF2(IPTRO+NRPARM))
            NIOUT = NIOUT + 1
C                                       update NX table
            CALL RNXUPD (BUFF2(IPTRO), RNXRET)
            IPTRO = IPTRO + NCOPY + NRPARM
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNOU, FINDOU, BUFF2, NIOLIM,
     *            KBIND, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT DATA SET'
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
            GO TO 200
            END IF
C                                       close uv data set
         CALL UVGET ('CLOS', RPARM, VIS, IRET)
         IF (NZERO.GT.0.0D0) THEN
            WRITE (MSGTXT,1900) NZERO
            CALL MSGWRT (3)
            END IF
         IF (NDONE.GT.0.0D0) THEN
            WRITE (MSGTXT,1901) NDONE
            CALL MSGWRT (3)
            END IF
 900     CONTINUE
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNOU, FINDOU, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINISH WRITING THE OUTPUT DATA SET'
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKOU, NEWCNO, LUNOU, CATBLK, IRET)
      CALL ZCLOSE (LUNOU, FINDOU, IRET)
      CALL UVPGET (IRET)
      IRET = 0
C                                       NX close, order?
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         CALL MSGWRT (8)
         END IF
      IF (.NOT.ORDER) THEN
         MSGTXT = 'WARNING: OUTPUT DATA SET NOT IN TIME ORDER'
         CALL MSGWRT (8)
         CALL CHR2H (2, '  ', 1, CATH(KITYP))
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPWASU: ERROR',I3,' ON ',A)
 1015 FORMAT (A22,' source',I4,2X,A)
 1160 FORMAT ('Reached index limit',I10)
 1900 FORMAT (F12.0,' visibility weights unchanged')
 1901 FORMAT (F12.0,' visibility weights changed')
      END
      SUBROUTINE RWPUTB (NC, NT, NB, NI, CT, RPARM, VIS, B, ISONE,
     *   GETNEW)
C-----------------------------------------------------------------------
C   moves the vis array to the right place in buffer
C   Inputs
C      NC       I      Number spectral channels
C      NT       I      Number times - max
C      NA       I      Number antennas
C      NB       I      Number baselines
C      NI       I      Number IFs
C      CT       I      Current time number
C      RPARM    R(*)   Random parameters: gets baseline number
C      VIS      R(*)   Vis values (3,*)
C   In/out
C      B        R(*)   Data buffer
C      ISONE    I(*)   0 => space available (baseline, time #)
C-----------------------------------------------------------------------
      INTEGER   NC, NT, NB, NI, CT, ISONE(NB,*)
      REAL      RPARM(*), VIS(3,*), B(3,NC,NT,NB,NI,*)
      LOGICAL   GETNEW
C
      INTEGER   JA1, JA2, JBL, JI, JP, JF, INDI
      REAL      BASEN, WT
      INCLUDE 'BPWAY.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
      IF (ILOCB.GE.0) THEN
         BASEN = RPARM(1+ILOCB)
         JA1 = BASEN / 256. + 0.1
         JA2 = BASEN - JA1*256. + 0.1
      ELSE
         JA1 = RPARM(1+ILOCA1) + 0.1
         JA2 = RPARM(1+ILOCA2) + 0.1
         END IF
      JBL = NANT * (JA1-1) - ((JA1*(JA1-1))/2) + JA2
      GETNEW = ISONE(JBL,CT).GT.0
      IF (.NOT.GETNEW) THEN
         ISONE(JBL,CT) = 1
         DO 40 JI = 1,NI
            DO 30 JP = 1,NSTOK
               INDI = (JI-1) * INCIFI + (JP-1) * INCSI + 1 - INCFI
               DO 20 JF = 1,NCHAN
                  INDI = INDI + INCFI
                  B(1,JF,CT,JBL,JI,JP) = VIS(1,INDI)
                  B(2,JF,CT,JBL,JI,JP) = VIS(2,INDI)
                  WT = VIS(3,INDI)
                  IF ((FPARM(10).GT.1.0) .AND. (WT.GT.0.0)) WT = 1.0
                  B(3,JF,CT,JBL,JI,JP) = WT
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE RWRMSH (NC, NT, NA, NB, NI, NCT, J1, J2, TNUM, CHFLGS,
     *   B, RMSRMS, TIMES, VISN, IRET)
C-----------------------------------------------------------------------
C   robust rms in arrays - sum to histograms
C   Inputs
C      NC       I      Number spectral channels
C      NT       I      Number times - max
C      NA       I      Number antennas
C      NB       I      Number baselines
C      NI       I      Number IFs
C      NCT      I      Number times in this call
C      J1       I      Time number to process lower limit
C      J2       I      Time number to process upper limit
C      TNUM     I(*)   Position in B of data
C      CHFLGS   I(*)   > 0 => incl in freq rms (NC,NI)
C      B        R(*)   Data buffer (3,NC,NT,NB,NI,NP)
C   In/out:
C      RMSRMS   D(*)   summing up time RMSes
C      DEVRMS   D(*)   summing up spectral deviations
C-----------------------------------------------------------------------
      INTEGER   NC, NT, NA, NB, NI, NCT, J1, J2, TNUM(*), CHFLGS(NC,NI),
     *   VISN(2,*), IRET
      REAL      B(3,NC,NT,NB,NI,*), RMSRMS(NC,NI,*), TIMES(2,*)
C
      INCLUDE 'BPWAY.INC'
      INCLUDE 'WTABLE.INC'
      INTEGER   JF, JI, JP, JA1, JA2, JT, JB, LR, JX, JLIM, NR, J
      REAL      RMSR, RMSI, V1, V2
      DOUBLE PRECISION WT, SR, SSR, SI, SSI, WR, AVR, AVI, V
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       regular operation
      DO 400 JA1 = 1,NA
         DO 390 JA2 = JA1,NA
            JB = NA * (JA1-1) - (JA1*(JA1-1))/2 + JA2
            JI = NI * NC * NSTOK
            CALL RFILL (JI, 0.0, RMSRMS)
            DO 100 JI = 1,NI
C                                       are there any data
               DO 15 JF = 1,NC
                  DO 14 JP = 1,NSTOK
                     DO 13 JT = 1,NCT
                        WT = B(3,JF,JT,JB,JI,JP)
                        IF (WT.GT.0.0) GO TO 19
 13                     CONTINUE
 14                  CONTINUE
 15               CONTINUE
               GO TO 100
C                                       pre-clip
 19            IF (FPARM(3).LE.1.E14) THEN
                  DO 30 JT = 1,NCT
                     JX = TNUM(JT)
                     DO 25 JF = 1,NC
                        DO 20 JP = 1,NSTOK
                           WT = B(3,JF,JT,JB,JI,JP)
                           IF (WT.GT.0.0) THEN
                              V1 = B(1,JF,JT,JB,JI,JP)
                              V2 = B(2,JF,JT,JB,JI,JP)
                              SR = V1*V1 + V2*V2
                              IF (SR.GT.FPARM(3)) THEN
                                 B(3,JF,JT,JB,JI,JP) =
     *                              -ABS (B(3,JF,JT,JB,JI,JP))
                                 COUNT = COUNT + 1
                                 END IF
                              END IF
 20                        CONTINUE
 25                     CONTINUE
 30                  CONTINUE
                  END IF
C                                       time rms
               JLIM = NC
               JLIM = 0
               DO 80 JF = 1,NC
                  JLIM = JLIM + 1
                  DO 70 JP = 1,NSTOK
                     SR = 0.0D0
                     SSR = 0.0D0
                     WR = 0.0D0
                     LR = 0
                     SI = 0.0D0
                     SSI = 0.0D0
                     NR = 0
                     DO 60 JT = 1,NCT
                        WT = B(3,JF,JT,JB,JI,JP)
                        IF (WT.GT.0.0) THEN
                           V = B(1,JF,JT,JB,JI,JP)
                           SR = SR + V * WT
                           SSR = SSR + V * V * WT
                           WR = WR + WT
                           LR = LR + 1
                           V = B(2,JF,JT,JB,JI,JP)
                           SI = SI + V * WT
                           SSI = SSI + V * V * WT
                           NR = NR + 1
                           END IF
 60                     CONTINUE
                     IF ((WR.GT.0.0D0) .AND. (NR.GT.1)) THEN
                        AVR = SR / WR
                        SSR = SSR / WR
                        RMSR = SSR - AVR * AVR
                        RMSR = SQRT (MAX (0.0, RMSR))
                        AVI = SI / WR
                        SSI = SSI / WR
                        RMSI = SSI - AVI * AVI
                        RMSI = SQRT (MAX (0.0, RMSI))
                        RMSR = SQRT (RMSR*RMSR + RMSI*RMSI)
                        RMSRMS(JF,JI,JP) = RMSR
                        END IF
 70                  CONTINUE
 80               CONTINUE
C                                       Normalize or not
               DO 95 JP = 1,NSTOK
                  SR = 0.0D0
                  WR = 0.0D0
                  DO 85 JF = 1,NC
                     IF ((CHFLGS(JF,JI).GT.0) .AND.
     *                  (RMSRMS(JF,JI,JP).GT.0.0D0)) THEN
                        WR = WR + 1.0D0
                        SR = SR + RMSRMS(JF,JI,JP)
                        END IF
 85                  CONTINUE
                  IF (WR.GT.0.0D0) THEN
                     SR = SR / WR
                     IF (XNORM.LT.0.0) SR = 1.0
                     DO 90 JF = 1,NC
                        V1 = RMSRMS(JF,JI,JP) / SR
                        IF (V1.GT.0.0) RMSRMS(JF,JI,JP) = MIN (FPARM(7),
     *                     MAX (FPARM(8), V1))
 90                     CONTINUE
                     END IF
 95               CONTINUE
 100           CONTINUE
C                                       write to table
            DO 120 J = J1,J2
               JX = TNUM(J)
               CALL TABWT ('WRIT', WTBUFF, WTRNO, WTKOLS, WTNUMV,
     *            TIMES(1,JX), VISN(1,JX), JB, RMSRMS, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITING WT TABLE'
                  CALL MSGWRT (8)
                  GO TO 999
                  END IF
 120           CONTINUE
 390        CONTINUE
 400     CONTINUE
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RWRMSH: ERROR',I5,' ON ',A)
      END
      SUBROUTINE BPWCNT (VER, KCH, KIF, RMSRMS, MAXC, IRET)
C-----------------------------------------------------------------------
C   BPWCNT counts the maximum number of times for any baseline
C   It also averages polarizations as instructed.
C   Inputs:
C      VER      I      WT version
C      KCH      I      Number channels
C      KIF      I      Number IFs
C   Outputs:
C      RMSRMS   R(*)   work buffer
C      MAXC     I      Maximum record count in a baseline
C      IRET     I      Error code
C-----------------------------------------------------------------------
      INTEGER   VER, KCH, KIF, MAXC, IRET
      REAL      RMSRMS(KCH,KIF,*)
C
      INCLUDE 'BPWAY.INC'
      INTEGER   INBUF(512), OUTBUF(512), LUNI, LUNO, LUNTMP, IWTRNO,
     *   WTKOLS(4), WTNUMV(4), VISN(2), JBL, CBL, CCNT, NC, NI, NS,
     *   NREC, IREC, IC, II, IS, NSUM
      REAL      TIMER(2), SUM
      LOGICAL   DOSTOK
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       open read
      LUNI = LUNTMP (1)
      CALL WTINI ('READ', INBUF, DISKIN, OLDCNO, VER, CATOLD, LUNI,
     *   IWTRNO, WTKOLS, WTNUMV, NC, NI, NS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING THE INPUT WT TABLE'
         GO TO 990
         END IF
      NREC = INBUF(5)
      CBL = 0
      CCNT = 0
      MAXC = 0
      DOSTOK = (FPARM(9).GT.0.0) .AND. (NS.GT.1)
C                                       output if do Stokes
      IF (DOSTOK) THEN
         LUNO = LUNTMP (1)
         CALL WTINI ('WRIT', OUTBUF, DISKIN, OLDCNO, VER, CATOLD, LUNO,
     *      IWTRNO, WTKOLS, WTNUMV, NC, NI, NS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING THE OUTPUT WT TABLE'
            GO TO 990
            END IF
         END IF
C                                       loop
      DO 100 IREC = 1,NREC
         IWTRNO = IREC
         CALL TABWT ('READ', INBUF, IWTRNO, WTKOLS, WTNUMV, TIMER, VISN,
     *      JBL, RMSRMS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT WT TABLE'
            GO TO 990
            END IF
C                                       count
         IF (JBL.EQ.CBL) THEN
            CCNT = CCNT + 1
         ELSE
            MAXC = MAX (MAXC, CCNT)
            CCNT = 1
            CBL = JBL
            END IF
C                                       average Stokes?
         IF (DOSTOK) THEN
            DO 50 IC = 1,NC
               DO 40 II = 1,NI
                  SUM = 0.0
                  NSUM = 0
                  DO 20 IS = 1,NS
                     IF (RMSRMS(IC,II,IS).GT.0.0) THEN
                        NSUM = NSUM + 1
                        SUM = SUM + RMSRMS(IC,II,IS)
                        END IF
 20                  CONTINUE
                  IF (NSUM.GT.0) THEN
                     SUM = SUM / NSUM
                     DO 30 IS = 1,NS
                        IF (RMSRMS(IC,II,IS).GT.0.0) RMSRMS(IC,II,IS) =
     *                     SUM
 30                     CONTINUE
                     END IF
 40               CONTINUE
 50            CONTINUE
            IWTRNO = IREC
            CALL TABWT ('WRIT', OUTBUF, IWTRNO, WTKOLS, WTNUMV, TIMER,
     *         VISN, JBL, RMSRMS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'RE-WRITING INPUT WT TABLE'
               GO TO 990
               END IF
            END IF
 100     CONTINUE
C                                       last count
      MAXC = MAX (MAXC, CCNT)
C                                       close files
      CALL TABWT ('CLOS', INBUF, IWTRNO, WTKOLS, WTNUMV, TIMER, VISN,
     *   JBL, RMSRMS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING INPUT WT TABLE'
         GO TO 990
         END IF
      IF (DOSTOK) THEN
         CALL TABWT ('CLOS', OUTBUF, IWTRNO, WTKOLS, WTNUMV, TIMER,
     *      VISN, JBL, RMSRMS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING OUTPUT WT TABLE'
            GO TO 990
            END IF
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPWCNT: ERROR',I5,' ON ',A)
      END
      SUBROUTINE BPSMOO (INVER, OUTVER, ND, NTS, B, RMSRMS, IRET)
C-----------------------------------------------------------------------
C   BPSMOO takes a sorted WT table and smooths it in time, replacing
C   null and good solutions with the smoothed value of the good ones.
C   Inputs:
C      INVER    I      Input table version
C      OUTVER   I      Output table version (not same)
C      ND       I      Number values in data row
C      NTS      I      Maximum number times in buffer B
C   Output:
C      B        R(*)   Work buffer
C      IRET     I      Disk error
C-----------------------------------------------------------------------
      INTEGER   INVER, OUTVER, ND, NTS, IRET
      REAL      B(ND,*), RMSRMS(*)
C
      INCLUDE 'BPWAY.INC'
      INTEGER   INBUF(512), OUTBUF(512), LUNI, LUNO, LUNTMP, IWTRNO,
     *   OWTRNO, WTKOLS(4), WTNUMV(4), NC, NI, NS, VISNUM(2,UVBFSS/2),
     *   JBL, LBL, CBL, NREC, IREC, NVAL, VISN(2), IVAL
      REAL      TIMES(2,UVBFSS/2), TIMER(2)
      LOGICAL   OVER, FULL
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (TIMES, BUFF1), (VISNUM, BUFF3)
C-----------------------------------------------------------------------
      LUNI = LUNTMP (1)
      CALL WTINI ('READ', INBUF, DISKIN, OLDCNO, INVER, CATOLD, LUNI,
     *   IWTRNO, WTKOLS, WTNUMV, NC, NI, NS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING THE INPUT WT TABLE'
         GO TO 990
         END IF
      NREC = INBUF(5)
      LUNO = LUNTMP (1)
      CALL WTINI ('WRIT', OUTBUF, DISKIN, OLDCNO, OUTVER, CATOLD, LUNO,
     *   OWTRNO, WTKOLS, WTNUMV, NC, NI, NS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING THE OUTPUT WT TABLE'
         GO TO 990
         END IF
      LBL = 0
      CBL = 0
      NVAL = 0
      DO 100 IREC = 1,NREC
 10      CALL TABWT ('READ', INBUF, IWTRNO, WTKOLS, WTNUMV, TIMER, VISN,
     *      JBL, RMSRMS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT WT TABLE'
            GO TO 990
            END IF
C                                       add to list
         OVER = .TRUE.
         IF (IREC.EQ.1) CBL = JBL
         IF ((JBL.EQ.CBL) .AND. (NVAL.LT.NTS)) THEN
            NVAL = NVAL + 1
            VISNUM(1,NVAL) = VISN(1)
            VISNUM(2,NVAL) = VISN(2)
            TIMES(1,NVAL) = TIMER(1)
            TIMES(2,NVAL) = TIMER(2)
            CALL RCOPY (ND, RMSRMS, B(1,NVAL))
            OVER = .FALSE.
            END IF
C                                       dump the list
         IF ((OVER) .OR. (IREC.GE.NREC)) THEN
            IVAL = FPARM(4) + 0.1
            FULL = .FALSE.
            IF ((IVAL.EQ.1) .OR. (IVAL.EQ.5)) THEN
               FULL = 2.*(TIMES(NVAL,2)-TIMES(1,1)).LT.FPARM(6)
               END IF
C                                       same answer full scan
            IF (FULL) THEN
               IVAL = 1
               CALL SMOTHR (FPARM(4), ND, IVAL, NVAL, TIMES, B, RMSRMS)
               DO 40 IVAL = 1,NVAL
                  CALL TABWT ('WRIT', OUTBUF, OWTRNO, WTKOLS, WTNUMV,
     *               TIMES(1,IVAL), VISNUM(1,IVAL), CBL, RMSRMS, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT WT TABLE'
                     GO TO 990
                     END IF
 40               CONTINUE
C                                       time variable answer
            ELSE
               DO 50 IVAL = 1,NVAL
                  CALL SMOTHR (FPARM(4), ND, IVAL, NVAL, TIMES, B,
     *               RMSRMS)
                  CALL TABWT ('WRIT', OUTBUF, OWTRNO, WTKOLS, WTNUMV,
     *               TIMES(1,IVAL), VISNUM(1,IVAL), CBL, RMSRMS, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT WT TABLE'
                     GO TO 990
                     END IF
 50               CONTINUE
               END IF
            IF ((JBL.EQ.CBL) .AND. (NVAL.GE.NTS)) THEN
               MSGTXT = 'WARNING: SMOOTHING NOT RIGHT DUE TO MEMORY'
               CALL MSGWRT (7)
               END IF
C                                       re-read last record
C                                       for new baseline
            IF (IREC.LT.NREC) THEN
               CBL = JBL
               NVAL = 0
               IWTRNO = IWTRNO - 1
               GO TO 10
               END IF
            END IF
 100     CONTINUE
C                                       close files
      CALL TABWT ('CLOS', INBUF, IWTRNO, WTKOLS, WTNUMV, TIMER, VISN,
     *   JBL, RMSRMS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING INPUT WT TABLE'
         GO TO 990
         END IF
      CALL TABWT ('CLOS', OUTBUF, OWTRNO, WTKOLS, WTNUMV, TIMES,
     *   VISNUM, CBL, RMSRMS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OUTPUT WT TABLE'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPSMOO: ERROR',I5,' ON ',A)
      END
      SUBROUTINE SMOTHR (FUNC, ND, EV, NV, TS, B, ANS)
C-----------------------------------------------------------------------
C   Applies smoothing
C   Inputs:
C      FUNC   R(3)   Function: type, FWHM, support
C      ND     I      Number channels in data
C      EV     I      The time to evaluate
C      NV     I      The total number of times
C      TS     R(*)   Array of time ranges (2,NV)
C      B      R(*)   The data before smoothing (ND,NV)
C   Outputs:
C      ANS    R(*)   Smoothed result for time EV (ND,2)
C-----------------------------------------------------------------------
      INTEGER   ND, EV, NV
      REAL      FUNC(3), TS(2,*), B(ND,*), ANS(ND,*)
C
      INTEGER   ITYPE, I, J, K, MWF
      REAL      T0, T, S, F, P, MWFBUF(15000), MEDIAN
C-----------------------------------------------------------------------
      ITYPE = FUNC(1) + 0.01
      S = FUNC(3) / 2.0
      I = 2 * ND
      CALL RFILL (I, 0.0, ANS)
      T0 = (TS(1,EV) + TS(2,EV)) / 2.0
C                                       boxcar
      IF (ITYPE.EQ.1) THEN
         DO 120 I = EV,NV
            T = (TS(1,I) + TS(2,I)) / 2.0
            IF (T-T0.LE.S) THEN
               DO 110 J = 1,ND
                  IF (B(J,I).GT.0.0) THEN
                     ANS(J,1) = ANS(J,1) + B(J,I)
                     ANS(J,2) = ANS(J,2) + 1.0
                     END IF
 110              CONTINUE
            ELSE
               GO TO 125
               END IF
 120        CONTINUE
 125     DO 140 K = 1,EV-1
            I = EV - K
            T = (TS(1,I) + TS(2,I)) / 2.0
            IF (T0-T.LE.S) THEN
               DO 130 J = 1,ND
                  IF (B(J,I).GT.0.0) THEN
                     ANS(J,1) = ANS(J,1) + B(J,I)
                     ANS(J,2) = ANS(J,2) + 1.0
                     END IF
 130              CONTINUE
            ELSE
               GO TO 600
               END IF
 140        CONTINUE
C                                       Gaussian
      ELSE IF (ITYPE.EQ.2) THEN
         P =(2.0 * SQRT (LOG(2.0))) /  FUNC(2)
         P = P * P
         DO 220 I = EV,NV
            T = (TS(1,I) + TS(2,I)) / 2.0 - T0
            IF (T.LE.S) THEN
               F = EXP (-T * T * P)
               DO 210 J = 1,ND
                  IF (B(J,I).GT.0.0) THEN
                     ANS(J,1) = ANS(J,1) + F * B(J,I)
                     ANS(J,2) = ANS(J,2) + F
                     END IF
 210              CONTINUE
            ELSE
               GO TO 225
               END IF
 220        CONTINUE
 225     DO 240 K = 1,EV-1
            I = EV - K
            T = T0 - ((TS(1,I) + TS(2,I)) / 2.0)
            IF (T.LE.S) THEN
               F = EXP (-T * T * P)
               DO 230 J = 1,ND
                  IF (B(J,I).GT.0.0) THEN
                     ANS(J,1) = ANS(J,1) + F * B(J,I)
                     ANS(J,2) = ANS(J,2) + F
                     END IF
 230              CONTINUE
            ELSE
               GO TO 600
               END IF
 240        CONTINUE
C                                       Exponential
      ELSE IF (ITYPE.EQ.3) THEN
         P =(2.0 * SQRT (LOG(2.0))) /  FUNC(2)
         DO 320 I = EV,NV
            T = (TS(1,I) + TS(2,I)) / 2.0 - T0
            IF (T.LE.S) THEN
               F = EXP (-T * P)
               DO 310 J = 1,ND
                  IF (B(J,I).GT.0.0) THEN
                     ANS(J,1) = ANS(J,1) + F * B(J,I)
                     ANS(J,2) = ANS(J,2) + F
                     END IF
 310              CONTINUE
            ELSE
               GO TO 325
               END IF
 320        CONTINUE
 325     DO 340 K = 1,EV-1
            I = EV - K
            T = T0 - ((TS(1,I) + TS(2,I)) / 2.0)
            IF (T.LE.S) THEN
               F = EXP (-T * P)
               DO 330 J = 1,ND
                  IF (B(J,I).GT.0.0) THEN
                     ANS(J,1) = ANS(J,1) + F * B(J,I)
                     ANS(J,2) = ANS(J,2) + F
                     END IF
 330              CONTINUE
            ELSE
               GO TO 600
               END IF
 340        CONTINUE
C                                       Linear
      ELSE IF (ITYPE.EQ.4) THEN
         P = 1.0 /  FUNC(2)
         DO 420 I = EV,NV
            T = (TS(1,I) + TS(2,I)) / 2.0 - T0
            IF (T.LE.S) THEN
               F = 1.0 - T * P
               F = MAX (0.0, F)
               DO 410 J = 1,ND
                  IF (B(J,I).GT.0.0) THEN
                     ANS(J,1) = ANS(J,1) + F * B(J,I)
                     ANS(J,2) = ANS(J,2) + F
                     END IF
 410              CONTINUE
            ELSE
               GO TO 425
               END IF
 420        CONTINUE
 425     DO 440 K = 1,EV-1
            I = EV - K
            T = T0 - ((TS(1,I) + TS(2,I)) / 2.0)
            IF (T.LE.S) THEN
               F = 1.0 - T * P
               F = MAX (0.0, F)
               DO 430 J = 1,ND
                  IF (B(J,I).GT.0.0) THEN
                     ANS(J,1) = ANS(J,1) + F * B(J,I)
                     ANS(J,2) = ANS(J,2) + F
                     END IF
 430              CONTINUE
            ELSE
               GO TO 600
               END IF
 440        CONTINUE
C                                       median
      ELSE IF (ITYPE.EQ.5) THEN
         DO 530 J = 1,ND
            MWF = 0
            DO 510 I = EV,NV
               T = (TS(1,I) + TS(2,I)) / 2.0
               IF (T-T0.LE.S) THEN
                  IF (B(J,I).GT.0.0) THEN
                     MWF = MWF + 1
                     MWFBUF(MWF) = B(J,I)
                     END IF
               ELSE
                  GO TO 515
                  END IF
 510           CONTINUE
 515        DO 520 K = 1,EV-1
               I = EV - K
               T = (TS(1,I) + TS(2,I)) / 2.0
               IF (T0-T.LE.S) THEN
                  IF (B(J,I).GT.0.0) THEN
                     MWF = MWF + 1
                     MWFBUF(MWF) = B(J,I)
                     END IF
               ELSE
                  GO TO 525
                  END IF
 520           CONTINUE
 525        IF (MWF.GT.0) THEN
               ANS(J,1) = MEDIAN (MWF, MWFBUF)
            ELSE
               ANS(J,1) = 0.0
               END IF
 530        CONTINUE
         GO TO 999
         END IF
C                                       Normalize
 600  DO 610 J = 1,ND
         IF (ANS(J,2).GT.0.0) ANS(J,1) = ANS(J,1) / ANS(J,2)
 610     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE WTINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IWTRNO, WTKOLS, WTNUMV, NCHAN, NIF, NSTOKE, IRET)
C-----------------------------------------------------------------------
C   WTINI creates and/or opens a WT temporary weight file used only by
C   BPWAY
C   Inputs:
C      OPCODE   C*4      'READ', 'WRIT'
C      BUFFER   I(512)   buffer used for control and I/O
C      DISK     I        disk of data set
C      CNO      I        catalog number
C      VER      I        version
C      CATBLK   I(256)   data set header
C      LUN      I        LUN to use
C   In/out:
C      NCHAN    I        Number spectral channels
C      NIF      I        Number spectral windows (IFs)
C      NSTOKE   I        Number Stokes parameters
C   Outputs:
C      IWTRNO   I        Record number: 1 on read, max + 1 on write
C      WTKOLS   I(4)     Column pointer array
C      WTNUMV   I(4)     Column dimensions
C      IRET     I        Error code
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, IWTRNO,
     *   WTKOLS(4), WTNUMV(4), NCHAN, NIF, NSTOKE, IRET
C
      CHARACTER TITLE(4)*24, UNITS(4)*8, TTITLE*56, KEYW(3)*8
      HOLLERITH HOLTMP(14)
      INTEGER   NKEY, NREC, DATP(128,2), NCOL, NTT, DTYP(4), NDATA, I,
     *   IPOINT, NC, ITRIM, JERR, KLOCS(3), KEYTYP(3), KEYVAL(3),
     *   MSGSAV, IOLTMP(14)
      LOGICAL   DOREAD
      EQUIVALENCE (HOLTMP, IOLTMP)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA NTT /56/
      DATA TTITLE /'AIPS TEMPORARY WEIGHTS WORK TABLE '/
      DATA DTYP /22,24,14,2/
      DATA TITLE /'TIMES', 'VIS NUMS', 'BASELINE', 'RMSES'/
      DATA UNITS /'DAYS', ' ', ' ', 'JY'/
      DATA KEYW /'NO_CHAN', 'NO_IF', 'NO_POL'/
C-----------------------------------------------------------------------
      MSGSAV = MSGSUP
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NDATA = 4
      NREC = 2000
      NCOL = NDATA
      NKEY = 3
      CALL FILL (NDATA, 0, WTKOLS)
      CALL FILL (NDATA, 0, WTNUMV)
C                                       Fill in types, lengths
      IF (.NOT.DOREAD) THEN
         DTYP(4) = 10 * (NCHAN * NIF * NSTOKE) + 2
         DO 10 I = 1,NDATA
            DATP(I,2) = DTYP(I)
            WTNUMV(I) = DTYP(I) / 10
 10         CONTINUE
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'WT', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IRET)
      IF (IRET.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'WTINI', IRET)
         GO TO 990
         END IF
C                                       Get number of scans
      IWTRNO = BUFFER(5) + 1
      IF (DOREAD) IWTRNO = 1
C                                       File created, initialize
      IF (IRET.LT.0) THEN
C                                       Col. labels.
         DO 40 I = 1,NDATA
            CALL CHR2H (24, TITLE(I), 1, HOLTMP)
            CALL TABIO ('WRIT', 3, I, HOLTMP, BUFFER, IRET)
            IF (IRET.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'WTINI', IRET)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, HOLTMP)
            CALL TABIO ('WRIT', 4, I, HOLTMP, BUFFER, IRET)
            IF (IRET.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'WTINI', IRET)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, HOLTMP)
         CALL COPY (14, IOLTMP, BUFFER(101))
C                                       Set keyword values
C                                       No. antennas.
         KLOCS(1) = 1
         KEYTYP(1) = 4
         KEYVAL(1) = NCHAN
C                                       No. polarizations
         KLOCS(2) = 2
         KEYTYP(2) = 4
         KEYVAL(2) = NIF
C                                       No. IFs.
         KLOCS(3) = 3
         KEYTYP(3) = 4
         KEYVAL(3) = NSTOKE
C                                       Only write if just created.
         NKEY = 3
         CALL TABKEY (OPCODE, KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IRET)
         IF ((IRET.GE.1) .AND. (IRET.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'WTINI', IRET)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         MSGSUP = 32000
         NKEY = 3
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IRET)
         MSGSUP = MSGSAV
         IF ((IRET.GE.1) .AND. (IRET.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'WTINI', IRET)
            GO TO 990
            END IF
C                                       Retrieve keyword values
C                                       No. antennas.
         IPOINT = KLOCS(1)
         IF (IPOINT.GT.0) NCHAN = KEYVAL(IPOINT)
C                                       No. IFs per pair.
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) NIF = KEYVAL(IPOINT)
C                                       No. IF pairs.
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) NSTOKE = KEYVAL(IPOINT)
         END IF
C                                      Get array indices
C                                      Cover your ass from FNDCOL -
C                                      close to flush the buffers and
C                                      then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, HOLTMP, BUFFER, IRET)
      IF (IRET.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'WTINI', IRET)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'WT', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IRET)
      IF (IRET.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'WTINI', IRET)
         GO TO 990
         END IF
      CALL FNDCOL (4, TITLE, 24, .TRUE., BUFFER, WTKOLS, JERR)
C                                      Get array indices and no. values
      DO 150 I = 1,4
         IPOINT = WTKOLS(I)
         IF (IPOINT.GT.0) THEN
            WTKOLS(I) = DATP(IPOINT,1)
            WTNUMV(I) = DATP(IPOINT,2) / 10
            IF (WTNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            WTKOLS(I) = -1
            WTNUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      IRET = 0
      GO TO 999
C                                      Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('WTINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('WTINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('WTINI: ERROR INITIALIZING WEIGHTS WORK TABLE FOR ',A4)
      END
      SUBROUTINE TABWT (OPCODE, BUFFER, IWTRNO, WTKOLS, WTNUMV, TIMES,
     *   VISN, BASNUM, RMSES, IRET)
C-----------------------------------------------------------------------
C   TABWT reads and writes WT table records
C   Inputs:
C      OPCODE   C*4      READ, WRIT, CLOS
C      WTKOLS   I(4)     Column pointers
C      WTNUMV   I(4)     Column dimensions
C   In/out:
C      BUFFER   I(512)   Table IO buffer
C      IWTRNO   I        Row to read, write, returned 1 higher
C      TIMES    R(2)     Range of times in row (days)
C      VISN     I(2)     Range of visibility numbers in row
C      BASNUM   I        Baseline number
C      RMSES    R(*)     RMSes (channel, IF, polarization)
C   Output:
C      IRET     I        Error code
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), IWTRNO, WTKOLS(*), WTNUMV(*), VISN(2),
     *   BASNUM, IRET
      REAL      TIMES(2), RMSES(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IPOINT, RECI(MAXCIF+5), NVAL
      REAL      RECORD(MAXCIF+5)
      EQUIVALENCE (RECORD, RECI)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       close
      IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, IWTRNO, RECORD, BUFFER, IRET)
         IF (IRET.GT.0) GO TO 990
C                                       write - fill buffer
      ELSE IF (OPCODE.EQ.'WRIT') THEN
         IPOINT = WTKOLS(1)
         RECORD(IPOINT) = TIMES(1)
         RECORD(IPOINT+1) = TIMES(2)
         IPOINT = WTKOLS(2)
         RECI(IPOINT) = VISN(1)
         RECI(IPOINT+1) = VISN(2)
         IPOINT = WTKOLS(3)
         RECI(IPOINT) = BASNUM
         IPOINT = WTKOLS(4)
         NVAL = WTNUMV(4)
         CALL RCOPY (NVAL, RMSES, RECORD(IPOINT))
C                                       and send
         CALL TABIO (OPCODE, 0, IWTRNO, RECORD, BUFFER, IRET)
         IWTRNO = IWTRNO + 1
         IF (IRET.GT.0) GO TO 990
C                                       read buffer
      ELSE IF (OPCODE.EQ.'READ') THEN
         CALL TABIO (OPCODE, 0, IWTRNO, RECORD, BUFFER, IRET)
         IWTRNO = IWTRNO + 1
         IF (IRET.GT.0) GO TO 990
C                                       and return to caller
         IPOINT = WTKOLS(1)
         TIMES(1) = RECORD(IPOINT)
         TIMES(2) = RECORD(IPOINT+1)
         IPOINT = WTKOLS(2)
         VISN(1) = RECI(IPOINT)
         VISN(2) = RECI(IPOINT+1)
         IPOINT = WTKOLS(3)
         BASNUM = RECI(IPOINT)
         IPOINT = WTKOLS(4)
         NVAL = WTNUMV(4)
         CALL RCOPY (NVAL, RECORD(IPOINT), RMSES)
C                                       bad opcode
      ELSE
         IRET = 8
         MSGTXT = 'TABWT BAD OPCODE = ''' // OPCODE // ''''
         CALL MSGWRT (8)
         END IF
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) IRET
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1990 FORMAT ('TABWT: TABIO ERROR',I3)
      END
      SUBROUTINE BPWAHI
C-----------------------------------------------------------------------
C   BPWAHI copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, SMTYPE(4)*8
      INTEGER   LUNI, HLUN, IERR, I, J, IROUND
      INCLUDE 'BPWAY.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA LUNI, HLUN /28,29/
      DATA SMTYPE /'Boxcar', 'Gaussian', 'Exponent', 'Linear'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUNI, HLUN, DISKIN, DISKOU, OLDCNO, NEWCNO,
     *   CATBLK, BUFF1, SCRBUF, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, HLUN, SCRBUF,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCOO (TSKNAM, NAMEOU, CLAOU, SEQOU, DISKOU, HLUN, SCRBUF,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
C                                       calibration history
      CALL CALHIS (HLUN, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1010) TSKNAM, FPARM(2)
      CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 100
      I = IROUND (FPARM(1))
      WRITE (HILINE,1005) TSKNAM, I
      CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       channel selection
      DO 40 I = BIF,EIF
         DO 30 J = 1,20
            IF (CHNSEL(1,J,I).GT.0) THEN
               WRITE (HILINE,1015) TSKNAM, J, I, CHNSEL(1,J,I),
     *            CHNSEL(2,J,I), CHNSEL(3,J,I)
               CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
               IF (IERR.NE.0) GO TO 100
               END IF
 30         CONTINUE
 40      CONTINUE
C                                       pre-clip
      IF (COUNT.GT.0) THEN
         FPARM(3) = SQRT (FPARM(3))
         WRITE (HILINE,1040) TSKNAM, FPARM(3), COUNT
         CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 100
         END IF
C                                       smoothing
      FPARM(5) = FPARM(5) * (24.0 * 60.0)
      FPARM(6) = FPARM(6) * (24.0 * 60.0)
      I = FPARM(4) + 0.01
      WRITE (HILINE,1045) TSKNAM, FPARM(4), SMTYPE(I)
      CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 100
      IF ((I.GE.2) .AND. (I.LE.4)) THEN
         WRITE (HILINE,1046) TSKNAM, FPARM(5)
         CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
         IF (IERR.NE.0) GO TO 100
         END IF
      WRITE (HILINE,1047) TSKNAM, FPARM(6)
      CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       rms allowed range
      WRITE (HILINE,1052) TSKNAM, XNORM
      CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 100
      FPARM(7) = 1.0 / (FPARM(7) ** 2)
      FPARM(8) = 1.0 / (FPARM(8) ** 2)
      IF (XNORM.GE.0.0) THEN
         WRITE (HILINE,1048) TSKNAM, FPARM(7)
      ELSE
         WRITE (HILINE,1053) TSKNAM, FPARM(7)
         END IF
      CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 100
      IF (XNORM.GE.0.0) THEN
         WRITE (HILINE,1049) TSKNAM, FPARM(8)
      ELSE
         WRITE (HILINE,1054) TSKNAM, FPARM(8)
         END IF
      CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       OPTYPE
      WRITE (HILINE,1050) TSKNAM, OPTYPE
      CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       weight usage
      IF (FPARM(10).GT.1.0) THEN
         WRITE (HILINE,1051) TSKNAM, FPARM(10),
     *      'ignore all input weights'
      ELSE IF (FPARM(10).GT.0.0) THEN
         WRITE (HILINE,1051) TSKNAM, FPARM(10),
     *      'ignore input weights on output'
      ELSE
         WRITE (HILINE,1051) TSKNAM, FPARM(10),
     *      'use input weights'
         END IF
      CALL HIADD (HLUN, HILINE, SCRBUF, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Close HI file
 100  CALL HICLOS (HLUN, .TRUE., SCRBUF, IERR)
C                                       delete the WT table
      MSGTXT = 'Deleting temporary WT table'
      CALL MSGWRT (2)
      CALL RMEXT (DISKIN, OLDCNO, 'WT', 0, CATOLD, SCRBUF, IERR)
C                                       Copy tables
      CALL COPTAB (DISKIN, OLDCNO, DISKOU, NEWCNO, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'BPWAHI: ERROR COPYING TABLES TO OUTPUT UV'
         CALL MSGWRT (6)
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (DISKOU, NEWCNO, DIFPIX, BUFF1, BUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'CENTHI: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Temporary FG version',I4,' moves to output version',I4)
 1005 FORMAT (A6,'FPARM(1)=',I7,' / data samples in time rms')
 1010 FORMAT (A6,'FPARM(2)=',F7.1,' / normal time interval in',
     *   ' time rms')
 1015 FORMAT (A6,'CHANSEL(,',I2,',',I2,') =',I5,',',I5,',',I2)
 1040 FORMAT (A6,'FPARM(3)=',F7.1,' / ',I12,' channels pre-clipped')
 1045 FORMAT (A6,'FPARM(4)=',F3.1,4X,' / ',A,' smoothing function')
 1046 FORMAT (A6,'FPARM(5)=',F7.2,' / smoothing function FWHM',
     *   ' in minutes')
 1047 FORMAT (A6,'FPARM(6)=',F7.2,' / smoothing function support',
     *   ' in minutes')
 1048 FORMAT (A6,'FPARM(7)=',F7.3,' / minimum normalized rms')
 1049 FORMAT (A6,'FPARM(8)=',F7.1,' / maximum normalized rms')
 1050 FORMAT (A6,'OPTYPE=''',A,'''  / data grouping type')
 1051 FORMAT (A6,'FPARM(10)=',F4.1,' / ',A)
 1052 FORMAT (A6,'NORMALIZ=',F4.1,' / normalize the RMSes?')
 1053 FORMAT (A6,'FPARM(7)=',F7.3,' / minimum unnormalized rms')
 1054 FORMAT (A6,'FPARM(8)=',F7.1,' / maximum unnormalized rms')
      END

      SUBROUTINE XGVECT (OP, CHAN, COUNT, XDATA, YDATA, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! Writes connected line segments to the TV for pixel-replicated images
C# Map Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   XGVECT writes a connected sequence of line segments on a TV channel
C   for pixel-replicated image pixels
C   Inputs:
C      OP      C*4     'ONNN' line of ones (max intensity)
C                      'OFFF' line of zeros (min intensity)
C      CHAN    I       channel number (1 to NGRAY+NGRAPH)
C      COUNT   I       number of X,Y pairs ( > 1)
C      XDATA   I(COUNT)      X coordinates X1,X2,...
C      YDATA   I(COUNT)      Y coordinates Y1,Y2,...
C   Output:
C      SCRTCH  I(*)    scratch buffer (size MAXXTV)
C      IERR    I       error code of ZM70XF - 0 => ok;  2 => input error
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   CHAN, COUNT, XDATA(*), YDATA(*), SCRTCH(*), IERR
C
      INTEGER   INT, IC, IMGWIN(4), TVWIN(4), MINC, LENG, LPY, LPX,
     *   IPX, IPY, I, K
      REAL      RPOS(2), LX(100), LY(100), DX, DY
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       check inputs
      IERR = 2
      INT = -99
      IF ((OP.EQ.'ONNN') .AND. (CHAN.LE.NGRAY)) INT = MAXINT
      IF ((OP.EQ.'ONNN') .AND. (CHAN.GT.NGRAY)) INT = 2**NGRAPH - 1
      IF (OP.EQ.'OFFF') INT = 0
C                                       how big is a pixel
      CALL COPY (4, CATBLK(IIWIN), IMGWIN)
      CALL COPY (4, CATBLK(IICOR), TVWIN)
      MINC = (TVWIN(3) - TVWIN(1) + 1.0) / (IMGWIN(3) - IMGWIN(1) + 1.0)
     *   + 0.1
      CALL FILL (MINC, INT, SCRTCH)
      DO 10 IC = 1,COUNT
         LX(IC) = (XDATA(IC) - TVWIN(1)) / MINC
         LX(IC) = LX(IC) + IMGWIN(1)
         LY(IC) = (YDATA(IC) - TVWIN(2)) / MINC
         LY(IC) = IMGWIN(2) + LY(IC)
 10      CONTINUE
C                                       loop over line segments
      DO 100 IC = 1,COUNT-1
         DX = LX(IC+1) - LX(IC)
         DY = LY(IC+1) - LY(IC)
         LENG = MAX (ABS(DX), ABS(DY)) * 10.0 + 0.1
         LENG = MAX (LENG, 1)
         DX = DX / LENG
         DY = DY / LENG
         RPOS(1) = LX(IC) - DX
         RPOS(2) = LY(IC) - DY
         LPY = -1
         LPX = -1
         DO 90 K = 1,LENG
            RPOS(1) = RPOS(1) + DX
            RPOS(2) = RPOS(2) + DY
            IPX = RPOS(1) + 0.5
            IPY = RPOS(2) + 0.5
C                                       fill in pixel
            IF ((IPX.NE.LPX) .OR. (IPY.NE.LPY)) THEN
               LPX = IPX
               LPY = IPY
               IPX = TVWIN(1) + (LPX - IMGWIN(1)) * MINC
               IPY = TVWIN(2) + (LPY - IMGWIN(2)) * MINC - 1
               DO 20 I = 1,MINC
                  IPY = IPY + 1
                  CALL YIMGIO ('WRIT', CHAN, IPX, IPY, 0, MINC, SCRTCH,
     *               IERR)
                  IF (IERR.NE.0) GO TO 990
 20               CONTINUE
               END IF
 90         CONTINUE
 100     CONTINUE
      GO TO 999
C
 990  WRITE (MSGTXT,1990) IERR, IPX, IPY
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1990 FORMAT ('XGVECT YIMGIO ERROR',I4,'AT TV X,Y',2I6)
      END

      SUBROUTINE TVVECT (INT, CHAN, COUNT, XDATA, YDATA, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! draws connected line segments on TV
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TVVECT writes a connected sequence of line segments on a TV channel
C   calling YCNECT
C   Inputs:
C      INT     I          intensity to draw - should be 0-MAXINT in
C                         channels 1-NGRAY, 2**NGRAPH-1 in rest
C      CHAN    I          channel number (1 to NGRAY+NGRAPH)
C      COUNT   I          number of X,Y pairs ( > 1)
C      XDATA   I(COUNT)   X coordinates X1,X2,...
C      YDATA   I(COUNT)   Y coordinates Y1,Y2,...
C   Output:
C      SCRTCH  I(*)    scratch buffer (size MAXXTV)
C      IERR    I       error code of ZM70XF - 0 => ok;  2 => input error
C-----------------------------------------------------------------------
      INTEGER   INT, CHAN, COUNT, XDATA(*), YDATA(*), SCRTCH(*), IERR
C
      INTEGER   IDX, NWORDS, X, Y, X1, Y1, IER, I
      REAL      RX, RY, R, RM
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
C                                       check inputs
      IERR = 2
      IF ((CHAN.LT.1) .OR. (CHAN.GT.NGRAY+NGRAPH)) GO TO 999
      IF (COUNT.LT.2) GO TO 999
      IERR = 0
      RM = 0.0
      DO 10 I = 1,COUNT-1
         RX = XDATA(I+1) - XDATA(I)
         RY = YDATA(I+1) - YDATA(I)
         R = SQRT (RX*RX + RY*RY)
         RM = MAX (RM, R)
 10      CONTINUE
      IDX = RM + 1.0
C                                       init buffer values
      IF ((SCRTCH(1).NE.INT) .OR. (SCRTCH(IDX).NE.INT)) THEN
         DO 15 I = 1,IDX
            SCRTCH(I) = INT
 15         CONTINUE
         END IF
      IDX = 1
      NWORDS = COUNT
C                                       first point in a line
 20   IF (NWORDS.LT.IDX+1) GO TO 999
         X = XDATA(IDX)
         Y = YDATA(IDX)
         IDX = IDX + 1
         IF ((X.GE.1) .AND. (X.LE.MAXXTV(1)) .AND. (Y.GE.1)
     *      .AND. (Y.LE.MAXXTV(2))) GO TO 30
            IERR = 2
            GO TO 20
C                                       second point in a line
 30      IF (NWORDS.LT.IDX) GO TO 999
            X1 = X
            Y1 = Y
            X = XDATA(IDX)
            Y = YDATA(IDX)
            IDX = IDX + 1
            IF ((X.GE.1) .AND. (X.LE.MAXXTV(1)) .AND. (Y.GE.1)
     *         .AND. (Y.LE.MAXXTV(1))) GO TO 40
               IERR = 2
               GO TO 20
C                                       draw a line segment
 40         CALL YCNECT (X1, Y1, X, Y, CHAN, SCRTCH, IER)
            IF (IER.EQ.0) GO TO 30
C
      IERR = MAX (IERR, IER)
C
 999  RETURN
      END

      SUBROUTINE ZI16IL (NVAL, NP, INB, OUTB)
C-----------------------------------------------------------------------
C! convert FITS-standard 16-bit integers to local integers
C# Binary
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Extract 16-bit, 2's complement integers from an input buffer and
C   put them into an output buffer in local integer form.  This must
C   work even when the address of the input and output buffers is the
C   same.
C   Inputs:
C      NVAL   I         Number of 16-bit integers to extract
C      NP     I         Starting position in the input buffer counting
C                       from 1 in units of 16-bit integers
C      INB    I*2(*)    Input buffer
C   Output:
C      OUTB   I(NVAL)   Output buffer
C   UNICOS version.
C-----------------------------------------------------------------------
      INTEGER   NVAL, NP, INB(1), OUTB(1)
C
      INTEGER   IX, IP, IT, NWM, NWF, I, IW, IPACKD, IXBYT
C-----------------------------------------------------------------------
      NWM = NVAL + NP - 1
      NWM = (NWM + 3) / 4
      NWF = (NP + 3) / 4
      IX = NWM * 4 - NP + 1
      DO 20 IW = NWF,NWM
         IP = NWM + NWF - IW
         IPACKD = INB(IP)
         DO 10 I = 1,4
            IT = AND (IPACKD, 177777B)
            IF (AND (IT, 100000B).NE.0)
     *          IT = OR (IT, 17777777 7777777 7700000B)
            IF ((IX.GT.0) .AND. (IX.LE.NVAL)) OUTB(IX) = IT
            IPACKD = SHIFTR (IPACKD, 16)
            IX = IX - 1
 10         CONTINUE
 20      CONTINUE
C                                       Exit.
 999  RETURN
      END

      SUBROUTINE FNDY (YPIX, XVAL, YVAL, IERR)
C-----------------------------------------------------------------------
C! returns Y-axis coordinate value given Y pixel and X coordinate value
C# Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FNDY returns the Y axis coordinate value of a point given the X
C   axis coordinate value and the Y axis pixel position of the point.
C   Needed for rotations and non-linear axes (L-M).
C   Inputs:
C      YPIX   R     Y pixel position
C      XVAL   D     X coordinate value
C   Output:
C      YVAL   D     Y coordinate value
C      IERR   I     0 ok, 1 out of range, 2 bad type, 3 undefined
C   Common:
C      /LOCATI/ pos parms must have been set up by SETLOC
C-----------------------------------------------------------------------
      REAL      YPIX
      DOUBLE PRECISION    YVAL, XVAL
      INTEGER   IERR
C
      DOUBLE PRECISION    R, D, P, RA0, DEC0, DS, DY, DZ, COSR, SINR
      INTEGER   I
      INCLUDE 'INCS:DLOC.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       y not related to x, z
      DY = (YPIX - RPLOC(2,LOCNUM)) * AXINC(2,LOCNUM)
      IF ((AXTYP(LOCNUM).NE.1) .AND. (AXTYP(LOCNUM).NE.3)) THEN
         YVAL = DY + RPVAL(2,LOCNUM)
         IF ((KLOCF(LOCNUM).EQ.1) .AND. (AXFUNC(2,LOCNUM).EQ.1)) YVAL =
     *      RPVAL(2,LOCNUM) + DY / (1.0D0 + AXDENU(LOCNUM) *
     *      (YPIX-RPLOC(2,LOCNUM)))
C                                       related somehow
      ELSE
         I = AXFUNC(KLOCL(LOCNUM)+1,LOCNUM)
         R = ROT(LOCNUM) * COND2R
         COSR = COS (R)
         SINR = SGNROT(LOCNUM) * SIN (R)
C                                       x with y
         IF (AXTYP(LOCNUM).NE.3) THEN
C                                       linear
            IF ((CORTYP(LOCNUM).LE.0) .OR. (I.LE.1)) THEN
               IF (COSR.EQ.0) DY = 0.0
               IF (COSR.NE.0) DY = (DY + (XVAL-RPVAL(1,LOCNUM))*SINR) /
     *            COSR
               YVAL = DY + RPVAL(2,LOCNUM)
C                                       non-linear
            ELSE
               D = COND2R * XVAL
               P = COND2R * DY
               RA0 = COND2R * RPVAL(CORTYP(LOCNUM),LOCNUM)
               DEC0 = COND2R * RPVAL(3-CORTYP(LOCNUM),LOCNUM)
               IF (CORTYP(LOCNUM).EQ.1) THEN
                  CALL DIRDEC (I, P, D, RA0, DEC0, R, DS, YVAL, IERR)
               ELSE IF (CORTYP(LOCNUM).EQ.2) THEN
                  CALL DIRRA (I, P, D, RA0, DEC0, R, DS, YVAL, IERR)
                  END IF
               YVAL = YVAL / COND2R
               END IF
C                                       y with z : rotation first
         ELSE
            DZ = (ZDEPTH(ZAXIS(LOCNUM)-2,LOCNUM) - RPLOC(3,LOCNUM)) *
     *         AXINC(3,LOCNUM)
            P = DY*COSR - DZ*SINR
            DZ = DZ*COSR + DY*SINR
            DY = P
C                                       linear
            IF ((CORTYP(LOCNUM).LE.0) .OR. (I.LE.1)) THEN
               YVAL = DY + RPVAL(2,LOCNUM)
C                                       non-linear
            ELSE
               DY = COND2R * DY
               DZ = COND2R * DZ
               RA0 = COND2R * RPVAL(2,LOCNUM)
               DEC0 = COND2R * RPVAL(3,LOCNUM)
               IF (CORTYP(LOCNUM).EQ.5) THEN
                  CALL NEWPOS (I, RA0, DEC0, DY, DZ, YVAL, DS, IERR)
               ELSE IF (CORTYP(LOCNUM).EQ.6) THEN
                  CALL NEWPOS (I, DEC0, RA0, DZ, DY, DS, YVAL, IERR)
                  END IF
               YVAL = YVAL / COND2R
               END IF
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZTXZAP (LUN, OUTFIL, IERR)
C-----------------------------------------------------------------------
C! delete text file openable via ZTXOPN
C# Z Text
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   delete a text file of the ZTXOPN type.
C   Inputs:
C      LUN      I       Logical unit number - used to temporarily open
C                       the file
C      OUTFIL   C*(*)   Full file name
C   Output:
C      IERR     I       Error return code: 0 => no error
C                          1 => error in inputs
C                          2 => LUN already in use
C                          3 => no room for LUN in FTAB
C                          4 => trouble translating logical
C                          5 => close/delete error
C                          6 => open error
C   Generic version: uses ZTXOPN and Fortran CLOSE
C-----------------------------------------------------------------------
      INTEGER   LUN, IERR
      CHARACTER OUTFIL*(*)
C
      INTEGER   JERR, IOSVAL, I, J, FIND
      LOGICAL   T, F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA T, F /.TRUE. , .FALSE./
C-----------------------------------------------------------------------
C                                       Open the file in normal way
      CALL ZTXOPN ('QWRT', LUN, FIND, OUTFIL, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, OUTFIL
         GO TO 995
         END IF
C                                       Locate file in FTAB.
 20   IERR = 0
      CALL LSERCH ('SRCH', LUN, FIND, F, JERR)
      IF (JERR.EQ.0) GO TO 30
         IERR = 3
         WRITE (MSGTXT,1020) LUN
         GO TO 995
C                                       Close the text file.
 30   CLOSE (UNIT=LUN, STATUS='DELETE', IOSTAT=IOSVAL)
      IF (IOSVAL.EQ.0) GO TO 40
         WRITE (MSGTXT,1030) IOSVAL, LUN
         CALL MSGWRT (7)
         CALL ZERROR ('ZTXZAP', IOSVAL, ' ', -999, .FALSE.)
         IERR = 5
C                                       Clear FTAB entry.
 40   CALL LSERCH ('CLOS', LUN, FIND, F, JERR)
      IF (JERR.EQ.0) THEN
         CALL FSERCH (FIND, I, J, JERR)
         IF (JERR.EQ.0) THEN
            IF (I.EQ.1) DEVNAM(J) = ' '
            IF (I.EQ.2) NONNAM(J) = ' '
            IF (I.EQ.3) MAPNAM(J) = ' '
            END IF
         GO TO 999
      ELSE
         WRITE (MSGTXT,1040) LUN
         END IF
C
 995   CALL MSGWRT (7)
C
 999   RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZTXZAP: ERROR',I5,' OPENING ',A53)
 1020 FORMAT ('ZTXZAP: LUN = ',I2,' ALREADY CLOSED IN FTAB ON SEARCH')
 1030 FORMAT ('ZTXZAP: FORTRAN ERROR ',I6,' ON CLOSE FOR LUN = ',I2)
 1040 FORMAT ('ZTXZAP: LUN = ',I2,' ALREADY CLOSED IN FTAB ON CLOSE')
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER   NPARMS
C                                       NPARMS=no. adverbs passed.
      PARAMETER (NPARMS=10)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                                       NOTE: Uses values in PAOOF.INC
C                                       Adverb names
C                     1         2          3        4         5
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INVERS',
C           6         7        8          9          10
     *   'PRTLEV', 'DOCRT', 'OUTPRINT', 'BCOUNT', 'ECOUNT'/
C                                       Adverb data types (PAOOF.INC)
C                     1      2       3       4       5
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOAINT,
C           6      7      8       9       10
     *   OOAINT, OOARE, OOACAR, OOAINT, OOAINT/
C                                       Adverb dimensions (as 2D)
C                   1     2     3     4     5
      DATA AVDIM /12,1,  6,1,  1,1,  1,1,  1,1,
C         6     7     8     9     10
     *   1,1,  1,1, 48,1,  1,1,  1,1/
LOCAL END
      PROGRAM HFPRT
C-----------------------------------------------------------------------
C! Convert HF table to binary table for geodetic program SOLVE
C# Calibration VLBI OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1999, 2004, 2007, 2009, 2015, 2017, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Paraform AIPS OOP task processing a table.  This version HFPRT
C   converts the HF table into a binary table for input into the
C   geodetic package Solve.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, INTAB*36
      INTEGER  IRET, BUFF1(256)
      DATA PRGM /'HFPRT '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL TABTIN (PRGM, INTAB, IRET)
C                                       Process table
      IF (IRET.EQ.0) CALL TABTAB (INTAB, IRET)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE TABTIN (PRGN, INTAB, IRET)
C-----------------------------------------------------------------------
C   TABTIN gets input parameters for HFPRT and creates the input object.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               1=>  errpr
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6, INTAB*36
C
      INTEGER   NKEY1

C                                       NKEY1=no. adverbs to copy to
C                                       INTAB
      PARAMETER (NKEY1=10)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32
C                                       for reading to EOF, index file
      INTEGER   DIM(3), DUMMY
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to INTAB
C                   1         2          3        4         5
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INVERS',
C           6         7        8           9         10
     *   'PRTLEV', 'DOCRT', 'OUTPRINT', 'BCOUNT', 'ECOUNT'/
C                                       May rename adverbs to INTAB
C                    1       2        3        4       5
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'VER',
C           6         7        8        9         10
     *   'PRTLEV', 'DOCRT', 'PRINT', 'BCOUNT', 'ECOUNT' /
C-----------------------------------------------------------------------
C                                       Startup,  returns "Input" object
C                                       containing POPS adverbs
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create input object
      INTAB = 'Input table'
      CALL CREATE (INTAB, 'TABLE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, INTAB, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Define as HF table
      DIM(1) = 2
      DIM(2) = 1
      DIM(3) = 1
      CALL OPUT (INTAB, 'TBLTYPE', OOACAR, DIM, DUMMY, 'HF', IRET)
      IF (IRET.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE TABTAB (INTAB, IERR)
C-----------------------------------------------------------------------
C   Convert table.
C   Inputs:
C      INTAB   C*   Name of input table object.
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*)
      INTEGER   IERR
C                                       MAXSIZ = max table entry size as
C                                       reals or characters
      INTEGER   MAXSIZ
      PARAMETER (MAXSIZ = 5000)
      INTEGER   IROW, OROW, NROW, ICOL, NCOL, BC, EC, TYPE, DIM(3)
      INTEGER   IDUM, LUN, PRTLEV
      REAL      RVALS(MAXSIZ)
      CHARACTER CVALS*(MAXSIZ*4), CDUMMY*1, OFILE*48
      INTEGER   IVALS(MAXSIZ)
      DOUBLE PRECISION DVALS(MAXSIZ/2)
      COMMON /HFTST/ RVALS
      COMMON /HFTSTC/ CVALS
      EQUIVALENCE  (RVALS(1), DVALS(1), IVALS(1))
C
      INTEGER   OUTLUN, FIND, NC, NLINE, IPAGE, IDOCRT
      REAL      DOCRT
      CHARACTER*132  KLINE, T1, T2, SCRATC
      EQUIVALENCE (DOCRT, IDOCRT)
C                                       Broke common block up into two
C                                       parts: character and numeric.
      COMMON /PRTHFC/ KLINE, T1, T2, SCRATC
      COMMON /PRTHFN/ OUTLUN, FIND, NC, NLINE, IPAGE, DOCRT
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Open input table
      CALL OOPEN (INTAB, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get number of entries
      CALL OGET (INTAB, 'NROW', TYPE, DIM, NROW, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Number of columns
      CALL OGET (INTAB, 'NCOL', TYPE, DIM, NCOL, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get range of rows.
      CALL OGET (INTAB, 'BCOUNT', TYPE, DIM, BC, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      BC = MIN (MAX (BC, 1), NROW)
      CALL OGET (INTAB, 'ECOUNT', TYPE, DIM, EC, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (EC.LE.0) EC = NROW
C                                       Get print level
      CALL OGET (INTAB, 'PRTLEV', TYPE, DIM, PRTLEV, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      BC = MIN (MAX (BC, 1), NROW)
C                                       Get output file name
      CALL OGET (INTAB, 'PRINT', TYPE, DIM, IDUM, OFILE, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'DOCRT', TYPE, DIM, IDOCRT, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open output file
      CALL LPOPEN (OFILE, DOCRT, OUTLUN, FIND, NC, SCRATC, IERR)
      IF (IERR.EQ.0) GO TO 30
      IF (IERR.NE.5) GO TO 999
C                                       File exists
         WRITE (MSGTXT,1020) OFILE
 1020    FORMAT ('Will add on to ', A48)
         CALL MSGWRT(1)
C                                       New file
C                                       Column Headings
 30   IF (PRTLEV.LE.0) THEN
         PRTLEV = 0
         WRITE (T1,1191)
         WRITE (T2,1192)
         KLINE = ' '
      ELSE IF (PRTLEV.EQ.1) THEN
         WRITE (T1,1194)
         WRITE (T2,1195)
         KLINE = ' '
      ELSE
         PRTLEV = 2
         WRITE (T1,1198)
         WRITE (T2,1199)
         KLINE = ' '
         END IF
      IPAGE = 0
      NLINE = 990
C                                       header
      IF (DOCRT.GT.-2.5) THEN
         CALL PRTLIN(OUTLUN, FIND, DOCRT, NC, T1, T2, KLINE, NLINE,
     *      IPAGE, SCRATC, IERR)
         IF (IERR.NE.0) GO TO 900
      ELSE
         CALL PRTLIN(OUTLUN, FIND, DOCRT, NC, T1, T2, T1, NLINE,
     *      IPAGE, SCRATC, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL PRTLIN(OUTLUN, FIND, DOCRT, NC, T1, T2, T2, NLINE,
     *      IPAGE, SCRATC, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
C                                       Loop over selected rows.
      OROW = 0
      DO 100 IROW = BC,EC
         OROW = OROW + 1
         DO 50 ICOL = 1,NCOL
            CALL TABDGT (INTAB, IROW, ICOL, TYPE, DIM, RVALS, CVALS,
     *         IERR)
            IF (IERR.NE.0) GO TO 900
C                                       Conversion Routine
            CALL CNSLV (PRTLEV, IROW, NCOL, ICOL, DIM(1), IERR)
            IF (IERR.NE.0) GO TO 900
 50         CONTINUE
 100     CONTINUE
C                                       Close tables
 900  CALL LPCLOS (LUN, FIND, NLINE, IERR)
      CALL OCLOSE (INTAB, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
C----------------------------------------------------------------------
 1191 FORMAT ('         SUMMARY OF HF FILES')
 1192 FORMAT ('   HF#  SOURCE  BL B Q  yr mo dy hr mn sc')
 1194 FORMAT ('        OBS. TIME                       ',
     *  '               I-------RESIDIALS----------',
     *  'I------------------TOTALS------------------------I')
 1195 FORMAT ('   HF# DY HR MN SC INT  SOURCE  BL B Q NC',
     *  '   AMP    SNR   RATE     SBD     MBD  PHS',
     *  '       RATE           SBD           MBD        PHS')
 1198 FORMAT (' DUMP OF HF FILES')
 1199 FORMAT ('                 ')
      END
      SUBROUTINE CNSLV (PRTLEV, IROW, NCOL, ICOL, INUM, IERR)
C-----------------------------------------------------------------------
C   This subroutine converts the HF data files into a binary form which
C   is written in a binary form for input into the geodetic SOLVE
C   program.  Most of the conversion is done with EQUIVALENCE statments.
C-----------------------------------------------------------------------
C                                       General specifications
      INTEGER   IROW, NCOL, ICOL, INUM, IERR, PRTLEV
C                                       Data arrays
      INTEGER   MAXSIZ
      PARAMETER (MAXSIZ = 5000)
      INTEGER   IVALS(MAXSIZ)
      REAL      RVALS(MAXSIZ)
      DOUBLE PRECISION DVALS(MAXSIZ/2)
      CHARACTER CVALS*(MAXSIZ*4)
      COMMON /HFTST/ RVALS
      COMMON /HFTSTC/ CVALS
      EQUIVALENCE (RVALS(1), DVALS(1), IVALS(1))
      INCLUDE 'INCS:DMSG.INC'
C                                       Record 0 conversions
      INTEGER*2 H0(128), H1(128), H2(128), H3(128), H4(128), H5(128)
      INTEGER*2 IDR(768)
      CHARACTER C1*2
      INTEGER*2 I2(6), I3(6), I4(4), I9(28), I10(56), I12(6)
      INTEGER*2 I5, I6, I7, I8, I11, I13, I14, I15, I16, I17
C
      EQUIVALENCE (IDR(1), H0(1)), (IDR(129), H1(1)),
     .       (IDR(257), H2(1)), (IDR(385), H3(1)),
     .       (IDR(513), H4(1)), (IDR(641), H5(1))
C
      EQUIVALENCE (H0(3),  C1),     (H0(7),  I2(1)),  (H0(13), I3(1)),
     *            (H0(19), I4(1)),  (H0(23), I5),     (H0(24), I6),
     *            (H0(25), I7),     (H0(26), I8),     (H0(27), I9(1)),
     *            (H0(55), I10(1)), (H0(111),I11),    (H0(112),I12(1)),
     *            (H0(118),I13),    (H0(119),I14),    (H0(120),I15),
     *            (H0(121),I16),    (H0(122),I17)
C                                       Record 1,2,3 Conversion
      CHARACTER*2  C33, C34
      CHARACTER*6  C28, C31, C35, C36
      CHARACTER*8  C25, C26, C27, C29, C30, C32, C37, C38
C
      INTEGER*2  I18(28), I19(84)
      INTEGER*2  I20(28), I21(56), I22(28), I23, I24
C
      EQUIVALENCE (H1(7),  I18(1)), (H1(35), I19(1))
      EQUIVALENCE (H2(7),  I20(1)), (H2(35), I21(1)), (H2(91), I22(1)),
     1            (H2(119),I23),    (H2(120),I24)
      EQUIVALENCE (H3(7),  C25),    (H3(11), C26),    (H3(15), C27),
     1            (H3(19), C28),    (H3(22), C29),    (H3(26), C30),
     2            (H3(30), C31),    (H3(33), C32),    (H3(37), C33),
     3            (H3(38), C34),    (H3(39), C35),    (H3(42), C36),
     4            (H3(49), C37),    (H3(53), C38)
C                                       Record 4 Conversion
      DOUBLE PRECISION D39(14), D40, D41, D42, D43, D44, D45, D46,
     1       D47, D48, D49, D50
      EQUIVALENCE (H4(5),  D39(1)), (H4(61), D40),    (H4(65), D41),
     1            (H4(69), D42),    (H4(73), D43),    (H4(77), D44),
     2            (H4(81), D45),    (H4(85), D46),    (H4(89), D47),
     3            (H4(93), D48),    (H4(97), D49),    (H4(101),D50)
C                                       Record 5 Conversion
      REAL  R51(28), R52(2), R53, R54, R55, R56, R57, R58, R59(2),
     1      R60(2), R61, R62(2), R63(6), R64, R65, R66, R67, R68,
     2      R69, R70, R71, R72, R73, R74, R75, R76, R77
      EQUIVALENCE (H5(3),  R51(1)), (H5(59), R52(1)), (H5(63), R53),
     1            (H5(65), R54),    (H5(67), R55),    (H5(69), R56),
     2            (H5(71), R57),    (H5(73), R58),    (H5(75), R59(1)),
     3            (H5(79), R60(1)), (H5(83), R61),    (H5(85), R62(1)),
     4            (H5(89), R63(1)), (H5(101),R64),    (H5(103),R65),
     5            (H5(105),R66),    (H5(107),R67),    (H5(109),R68),
     6            (H5(111),R69),    (H5(113),R70),    (H5(115),R71),
     7            (H5(117),R72),    (H5(119),R73),    (H5(121),R74),
     8            (H5(123),R75),    (H5(125),R76),    (H5(127),R77)
C
      CHARACTER*132  KLINE, T1, T2, SCRATC
      INTEGER   OUTLUN, FIND, NC, NLINE, IPAGE
      REAL      DOCRT
C                                       Broke common block up into two
C                                       parts: character and numeric.
      COMMON /PRTHFC/ KLINE, T1, T2, SCRATC
      COMMON /PRTHFN/ OUTLUN, FIND, NC, NLINE, IPAGE, DOCRT
C-----------------------------------------------------------------------
C                                       Convert HF entries
      IF (ICOL.EQ.1) C1 = CVALS
      IF (ICOL.EQ.2) CALL IMANY (IVALS, INUM, I2)
      IF (ICOL.EQ.3) CALL IMANY (IVALS, INUM, I3)
      IF (ICOL.EQ.4) CALL IMANY (IVALS, INUM, I4)
      IF (ICOL.EQ.5) I5 = IVALS(1)
      IF (ICOL.EQ.6) I6 = IVALS(1)
      IF (ICOL.EQ.7) I7 = IVALS(1)
      IF (ICOL.EQ.8) I8 = IVALS(1)
      IF (ICOL.EQ.9) CALL IMANY (IVALS, INUM, I9)
      IF (ICOL.EQ.10) CALL IMANY (IVALS, INUM, I10)
      IF (ICOL.EQ.11) I11 = IVALS(1)
      IF (ICOL.EQ.12) CALL IMANY (IVALS, INUM, I12)
      IF (ICOL.EQ.13) I13 = IVALS(1)
      IF (ICOL.EQ.14) I14 = IVALS(1)
      IF (ICOL.EQ.15) I15 = IVALS(1)
      IF (ICOL.EQ.16) I16 = IVALS(1)
      IF (ICOL.EQ.17) I17 = IVALS(1)
      IF (ICOL.EQ.18) CALL IMANY (IVALS, INUM, I18)
      IF (ICOL.EQ.19) CALL IMANY (IVALS, INUM, I19)
      IF (ICOL.EQ.20) CALL IMANY (IVALS, INUM, I20)
      IF (ICOL.EQ.21) CALL IMANY (IVALS, INUM, I21)
      IF (ICOL.EQ.22) CALL IMANY (IVALS, INUM, I22)
      IF (ICOL.EQ.23) I23 = IVALS(1)
      IF (ICOL.EQ.24) I24 = IVALS(1)
      IF (ICOL.EQ.25) C25 = CVALS
      IF (ICOL.EQ.26) C26 = CVALS
      IF (ICOL.EQ.27) C27 = CVALS
      IF (ICOL.EQ.28) C28 = CVALS
      IF (ICOL.EQ.29) C29 = CVALS
      IF (ICOL.EQ.30) C30 = CVALS
      IF (ICOL.EQ.31) C31 = CVALS
      IF (ICOL.EQ.32) C32 = CVALS
      IF (ICOL.EQ.33) C33 = CVALS
      IF (ICOL.EQ.34) C34 = CVALS
      IF (ICOL.EQ.35) C35 = CVALS
      IF (ICOL.EQ.36) C36 = CVALS
      IF (ICOL.EQ.37) C37 = CVALS
      IF (ICOL.EQ.38) C38 = CVALS
      IF (ICOL.EQ.39) CALL DMANY(DVALS, INUM, D39)
      IF (ICOL.EQ.40) D40 = DVALS(1)
      IF (ICOL.EQ.41) D41 = DVALS(1)
      IF (ICOL.EQ.42) D42 = DVALS(1)
      IF (ICOL.EQ.43) D43 = DVALS(1)
      IF (ICOL.EQ.44) D44 = DVALS(1)
      IF (ICOL.EQ.45) D45 = DVALS(1)
      IF (ICOL.EQ.46) D46 = DVALS(1)
      IF (ICOL.EQ.47) D47 = DVALS(1)
      IF (ICOL.EQ.48) D48 = DVALS(1)
      IF (ICOL.EQ.49) D49 = DVALS(1)
      IF (ICOL.EQ.50) D50 = DVALS(1)
      IF (ICOL.EQ.51) CALL RMANY(RVALS, INUM, R51)
      IF (ICOL.EQ.52) CALL RMANY(RVALS, INUM, R52)
      IF (ICOL.EQ.53) R53 = RVALS(1)
      IF (ICOL.EQ.54) R54 = RVALS(1)
      IF (ICOL.EQ.55) R55 = RVALS(1)
      IF (ICOL.EQ.56) R56 = RVALS(1)
      IF (ICOL.EQ.57) R57 = RVALS(1)
      IF (ICOL.EQ.58) R58 = RVALS(1)
      IF (ICOL.EQ.59) CALL RMANY(RVALS, INUM, R59)
      IF (ICOL.EQ.60) CALL RMANY(RVALS, INUM, R60)
      IF (ICOL.EQ.61) R61 = RVALS(1)
      IF (ICOL.EQ.62) CALL RMANY(RVALS, INUM, R62)
      IF (ICOL.EQ.63) CALL RMANY(RVALS, INUM, R63)
      IF (ICOL.EQ.64) R64 = RVALS(1)
      IF (ICOL.EQ.65) R65 = RVALS(1)
      IF (ICOL.EQ.66) R66 = RVALS(1)
      IF (ICOL.EQ.67) R67 = RVALS(1)
      IF (ICOL.EQ.68) R68 = RVALS(1)
      IF (ICOL.EQ.69) R69 = RVALS(1)
      IF (ICOL.EQ.70) R70 = RVALS(1)
      IF (ICOL.EQ.71) R71 = RVALS(1)
      IF (ICOL.EQ.72) R72 = RVALS(1)
      IF (ICOL.EQ.73) R73 = RVALS(1)
      IF (ICOL.EQ.74) R74 = RVALS(1)
      IF (ICOL.EQ.75) R75 = RVALS(1)
      IF (ICOL.EQ.76) R76 = RVALS(1)
      IF (ICOL.EQ.77) R77 = RVALS(1)
C                                       Loop for more
      IF (ICOL.GE.NCOL) THEN
C                                       Print out
C                                       Fix year, if necessary
         IF (I2(1).GT.100) I2(1)=I2(1)-1900
C                                       Other changes
         IF (R68.GT.180.0) R68 = R68 - 360.0
         IF (R68.LT.-180.0) R68 = R68 + 360.0
C                                       Begin printout
         IF (PRTLEV.EQ.0) THEN
            WRITE (KLINE,1100) IROW, C25, C1, C34, C33, I2
            CALL PHFPRT (IERR)
         ELSE IF (PRTLEV.EQ.1) THEN
            WRITE (T1(20:25), '(2I3)') I2(1), I2(2)
            WRITE (KLINE,1200) IROW, I2(3), I2(4), I2(5), I2(6),
     *         NINT(R73), C25, C1, C34, C33, I8, R61, NINT(R65),
     *         D48*1.0D6, R64*1.0D3, D47*1.0D3, NINT(R69), D42, D43,
     *         D41, NINT(R68)
            CALL PHFPRT (IERR)
         ELSE IF (PRTLEV.EQ.2) THEN
            CALL READHF (IDR, IERR)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT (I6, 1X, A8, 1X, A2, 1X, A1, 1X, A1, 1X, 6I3)
 1200 FORMAT (I6, 4I3, I4, 1X,A8, 1X,A2, 1X,A1, 1X,A1, I3, E9.2, I4,
     *   F7.2, F8.1, F8.3, I5, F14.9, F14.6, F17.9, I5)
      END
      SUBROUTINE IMANY (IVALS, INUM, IVAL)
C-----------------------------------------------------------------------
C   Variation on COPY.  Note conversion from I*4 to I*2
C-----------------------------------------------------------------------
      INTEGER   INUM, IVALS(*)
      INTEGER*2 IVAL(*)
C
      INTEGER   I
C-----------------------------------------------------------------------
      DO 10 I = 1,INUM
         IVAL(I) = IVALS(I)
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE DMANY (DVALS, INUM, DVAL)
C-----------------------------------------------------------------------
C   Variation on RCOPY for double precision
C-----------------------------------------------------------------------
      INTEGER   INUM
      DOUBLE PRECISION DVALS(*), DVAL(*)
C
      INTEGER   I
C-----------------------------------------------------------------------
      DO 10 I = 1,INUM
         DVAL(I) = DVALS(I)
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE RMANY (RVALS, INUM, RVAL)
C-----------------------------------------------------------------------
C   Variation on RCOPY
C-----------------------------------------------------------------------
      INTEGER   INUM
      REAL      RVALS(*), RVAL(*)
C
      INTEGER   I
C-----------------------------------------------------------------------
      DO 10 I = 1,INUM
         RVAL(I) = RVALS(I)
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE JTIME (JDATE, LPART)
C-----------------------------------------------------------------------
C   Determines the duration time between Jan 1, 1979 and JDATE in the
C   form (YY,MM,DD,HH,MM,SS).  The difference is converted into units of
C   4 seconds and further converted into base 26 number with a=0, b=1,
C   c=2, ..., y=24, z=25.  This conversion is done in subroutine ALSTR.
C-----------------------------------------------------------------------
      INTEGER   JDATE(6)
      CHARACTER LPART*6
C
      INTEGER   ZDATE(6)
      DOUBLE PRECISION JDAY1, JDAY2, JDIFF
      DATA  ZDATE / 79, 1, 1, 0, 0, 0 /
C-----------------------------------------------------------------------
      CALL DAT2JD (ZDATE, JDAY1)
      CALL DAT2JD (JDATE, JDAY2)
      JDIFF = (JDAY2 - JDAY1) * 21600.0D0
C
      CALL ALSTR (JDIFF, LPART)
C
 999  RETURN
      END
      SUBROUTINE ALSTR (JDAY, TSTR)
C-----------------------------------------------------------------------
C   This subroutine converts JDAY into a six digit number to the base
C   26.
C-----------------------------------------------------------------------
      DOUBLE PRECISION JDAY
      CHARACTER TSTR*6
C
      DOUBLE PRECISION TDAY, F26(6)
      INTEGER   I, ITEMP
      CHARACTER FLET*26
      DATA FLET /'abcdefghijklmnopqrstuvwxyz'/
C-----------------------------------------------------------------------
      DO 100 I = 1,6
         F26(7-I) = 26.0 ** (I-1)
 100     CONTINUE
      TDAY = JDAY
      DO 200 I = 1,6
         ITEMP = TDAY / F26(I)
         TSTR(I:I) = FLET(ITEMP+1:ITEMP+1)
         TDAY = TDAY - ITEMP * F26(I)
 200     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE PHFPRT (IERR)
C-----------------------------------------------------------------------
C     Subroutine PHFPRT is the printing command
C-----------------------------------------------------------------------
      INTEGER  IERR
      CHARACTER*132  KLINE, T1, T2, SCRATC
      INTEGER   OUTLUN, FIND, NC, NLINE, IPAGE
      REAL      DOCRT
C                                       Broke common block up into two
C                                       parts: character and numeric.
      COMMON /PRTHFC/ KLINE, T1, T2, SCRATC
      COMMON /PRTHFN/ OUTLUN, FIND, NC, NLINE, IPAGE, DOCRT
C-----------------------------------------------------------------------
      CALL PRTLIN (OUTLUN, FIND, DOCRT, NC, T1, T2, KLINE, NLINE, IPAGE,
     *   SCRATC, IERR)
C
 999  RETURN
      END
      SUBROUTINE READHF (IDM, IERR)
C-----------------------------------------------------------------------
C     Program READHF reads the HF Haystack format
C
C     Is IROW used in this routine?  I don't think so...
C-----------------------------------------------------------------------
      INTEGER   IERR, I
      INTEGER*2 IDR(768), IDM(768)
      INTEGER*2 H0(128), H1(128), H2(128), H3(128), H4(128), H5(128)
      INTEGER*2 CORNO, UTCTG(6), VLBUTC(6), IARCH(4), RECSTP(3),
     .          NOFAP(2,14), RECTRK(2,2,14), CORLVR, UTCMTG(6), DELFLG,
     .          RATFLG, DLTFLG, NDELS, NRATS, NAMBIG, VLB1X(2,14),
     .          CALFRQ(3,2,14), PRCUTC(2,14), ERRATE(2,2,14), CORCD,
     .          IFRERR, AUTOED, NCHAN, INDXNM(2,14)
      INTEGER*2 SOURCE(4), BASE(4,2), VLB1FL(3), TAPID(4,2),
     .          VLB2PG(3), RUNCOD(4), QALCOD, FRQGRP, ORIGFL(3),
     .          TPQCOD(3), OCCPNM(4,2)
      REAL   AMPBFQ(2,14), PHASCL(2), DELRES, DELSIG,
     .       RATRES, RATSIG, COHRCR, TOTPHS, UVFSEC(2), STRELV(2),
     .       INCHMP, URVR(2), SRCHPR(6), SBRES, SNRATO, FLSEDT,
     .       INCOH2, GCPHAS, GCRSPH, STRTSC, STOPSC, DLTEPO,
     .       EFFDUR, SBSIG, QBFACT, DISCRD, TOTPCT
      REAL*8 RFRQ(14), REFREQ, DELOBS, RATOBS, SBDEL, GPAMB,
     .       CLKFST, RFCLKR, DLOBSM, RATBSM, DLEPO1, DLEPO2
      EQUIVALENCE (IDR(2),CORNO),(IDR(3),CORCD),    (IDR(7),UTCTG),
     .       (IDR(13),VLBUTC),  (IDR(19),IARCH),   (IDR(23),RECSTP),
     .       (IDR(26),NCHAN),    (IDR(27),NOFAP),   (IDR(55),RECTRK),
     .       (IDR(111),CORLVR),  (IDR(112),UTCMTG), (IDR(119),DELFLG)
      EQUIVALENCE (IDR(120),RATFLG),(IDR(121),DLTFLG),(IDR(122),NDELS),
     .       (IDR(123),NRATS),   (IDR(124),NAMBIG), (IDR(135),VLB1X),
     .       (IDR(163),CALFRQ),  (IDR(263),PRCUTC), (IDR(291),ERRATE),
     .       (IDR(347),INDXNM),  (IDR(375),IFRERR), (IDR(376),AUTOED)
      EQUIVALENCE  (IDR(391),SOURCE),(IDR(395),BASE),(IDR(403),VLB1FL),
     .       (IDR(406),TAPID),   (IDR(414),VLB2PG),(IDR(417),RUNCOD),
     .       (IDR(421),QALCOD), (IDR(422),FRQGRP), (IDR(423),ORIGFL),
     .       (IDR(426),TPQCOD), (IDR(433),OCCPNM), (IDR(517),RFRQ)
      EQUIVALENCE (IDR(573),REFREQ),(IDR(577),DELOBS),(IDR(581),RATOBS),
     .       (IDR(585),SBDEL),   (IDR(589),GPAMB),  (IDR(593),CLKFST),
     .       (IDR(597),RFCLKR), (IDR(601),DLOBSM),(IDR(605),RATBSM),
     .       (IDR(609),DLEPO1),  (IDR(613),DLEPO2), (IDR(643),AMPBFQ)
      EQUIVALENCE(IDR(699),PHASCL),(IDR(703),DELRES),(IDR(705),DELSIG),
     .       (IDR(707),RATRES),  (IDR(709),RATSIG), (IDR(711),COHRCR),
     .       (IDR(713),TOTPHS), (IDR(715),UVFSEC),(IDR(719),STRELV),
     .       (IDR(723),INCHMP),(IDR(725),URVR),   (IDR(729),SRCHPR)
      EQUIVALENCE (IDR(741),SBRES),(IDR(743),SNRATO),(IDR(745),FLSEDT),
     .       (IDR(747),INCOH2),  (IDR(749),GCPHAS), (IDR(751),GCRSPH),
     .       (IDR(753),STRTSC), (IDR(755),STOPSC), (IDR(757),DLTEPO),
     .       (IDR(759),EFFDUR),  (IDR(761),SBSIG),  (IDR(763),QBFACT),
     .       (IDR(765),DISCRD),  (IDR(767),TOTPCT)
      EQUIVALENCE (IDR(1), H0(1)), (IDR(129), H1(1)),
     .       (IDR(257), H2(1)), (IDR(385), H3(1)),
     .       (IDR(513), H4(1)), (IDR(641), H5(1))
C
      CHARACTER*132  KLINE, T1, T2, SCRATC
      INTEGER   OUTLUN, FIND, NC, NLINE, IPAGE
      REAL      DOCRT
C                                       Broke common block up into two
C                                       parts: character and numeric.
      COMMON /PRTHFC/ KLINE, T1, T2, SCRATC
      COMMON /PRTHFN/ OUTLUN, FIND, NC, NLINE, IPAGE, DOCRT
C-----------------------------------------------------------------------
      DO 20 I = 1, 768
         IDR(I) = IDM(I)
 20      CONTINUE
C
      WRITE (KLINE,2001) CORNO
      CALL PHFPRT (IERR)
      WRITE (KLINE,2002) CORCD
      CALL PHFPRT (IERR)
      WRITE (KLINE,2003) UTCTG
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2004) VLBUTC
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2005) IARCH
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2006) RECSTP
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2007) NCHAN
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2008)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (NOFAP(1,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (NOFAP(2,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2009)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (RECTRK(1,1,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (RECTRK(2,1,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (RECTRK(1,2,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (RECTRK(2,2,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2010) CORLVR
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2011) UTCMTG
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2012) DELFLG
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2013) RATFLG
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2014) DLTFLG
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2015) NDELS
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2016) NRATS
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2017) NAMBIG
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2018)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (VLB1X(1,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (VLB1X(2,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2019)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (CALFRQ(1,1,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (CALFRQ(1,2,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (CALFRQ(2,1,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (CALFRQ(2,2,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (CALFRQ(3,1,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (CALFRQ(3,2,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2020)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (PRCUTC(1,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (PRCUTC(2,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2021)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (ERRATE(1,1,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (ERRATE(2,1,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (ERRATE(1,2,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (ERRATE(2,2,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2022) INDXNM
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (INDXNM(1,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20081) (INDXNM(2,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2023) IFRERR
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2024) AUTOED
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2025) SOURCE
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2026) BASE
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2027) VLB1FL
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2028) TAPID
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2029) VLB2PG
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2030) RUNCOD
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2031) QALCOD
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2032) FRQGRP
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2033) ORIGFL
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2034) TPQCOD
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2035) OCCPNM
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2036)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20361) (RFRQ(I), I = 1,7)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20361) (RFRQ(I), I = 8,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2037) REFREQ
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2038) DELOBS
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2039) RATOBS
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2040) SBDEL
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2041) GPAMB
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2042) CLKFST
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2043) RFCLKR
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2044) DLOBSM
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2045) RATBSM
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2046) DLEPO1
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2047) DLEPO2
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2048)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20481) (AMPBFQ(1,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,20482) (AMPBFQ(2,I), I = 1,14)
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2049) PHASCL
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2050) DELRES
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2051) DELSIG
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2052) RATRES
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2053) RATSIG
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2054) COHRCR
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2055) TOTPHS
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2056) UVFSEC
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2057) STRELV
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2058) INCHMP
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2059) URVR
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2060) SRCHPR
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2061) SBRES
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2062) SNRATO
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2063) FLSEDT
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2064) INCOH2
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2065) GCPHAS
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2066) GCRSPH
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2067) STRTSC
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2068) STOPSC
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2069) DLTEPO
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2070) EFFDUR
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2071) SBSIG
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2072) QBFACT
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2073) DISCRD
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
      WRITE (KLINE,2074) TOTPCT
      IF (IERR.EQ.0) CALL PHFPRT (IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 2001 FORMAT (' corno: baseline number:      ', I4)
 2002 FORMAT (' corcd: baseline code  :      ', 4X, A2)
 2003 FORMAT (' utctg: Y,M,D,H,M,S  UT Epoch for day and rate: ',
     *   I5,5I3)
 2004 FORMAT (' vlb2utc: Y,M,D,H,M,S UT for fringe processing: ',
     *   I5,5I3)
 2005 FORMAT (' iarch: archive ? ', 4I4)
 2006 FORMAT (' recstp: sample rat in kbytes/sec: ', 3I6)
 2007 FORMAT (' nchan: number of channels: ', I6)
 2008 FORMAT (' nofap: acc. periods by sideband/channel: ')
20081 FORMAT (20X, 14I6)
 2009 FORMAT (' rectrk: track table: ')
 2010 FORMAT (' corlvr: correlator version.  772 means IEEE fp:',I5)
 2011 FORMAT (' utcmtg: Y,M,D,H,M,S UT for central epoch: ', I5,5I3)
 2012 FORMAT (' delfig: reference tape drive: ', I6)
 2013 FORMAT (' ratfig: remote tape drive:    ', I6)
 2014 FORMAT (' deltfig: correlator option:   ', I6)
 2015 FORMAT (' ndels: delay rate offset:     ', I6)
 2016 FORMAT (' nrats: ?                      ', I6)
 2017 FORMAT (' nambig: ?                     ', I6)
 2018 FORMAT (' vlb1x:  ? ')
 2019 FORMAT (' calfrq: phasecal (amp, phase, freq)  ')
 2020 FORMAT ( ' prcutc: correlator processing time YMMDD ')
 2021 FORMAT (' errate: error rate (1000*logT)  ')
 2022 FORMAT (' indxnm: correlator index: ')
 2023 FORMAT (' ifrerr: frnge error code? ', I6)
 2024 FORMAT (' autoed: ? ', I6)
 2025 FORMAT (' source: star id                    ', 4A2)
 2026 FORMAT (' base: baseline names               ', 8A2)
 2027 FORMAT (' vlb1fil: correlated data file name ', 3A2)
 2028 FORMAT (' tapid: raw data tape names         ', 8A2)
 2029 FORMAT (' vlb2prg: Fringe ver data YYMMDD:   ', 3A2)
 2030 FORMAT (' runcod: Fringe run code:           ', 4A2)
 2031 FORMAT (' qualcod: quality code              ', A2)
 2032 FORMAT (' frqgrp: frequency group            ', A2)
 2033 FORMAT (' origfil: original file name?       ', 3A2)
 2034 FORMAT (' tapqcod: tape Q code?              ', 3A2)
 2035 FORMAT (' occprn: ref and remote occup code? ', 8A2)
 2036 FORMAT (' rfrq: LO frequencies (MHz)  ')
20361 FORMAT (7D18.9)
 2037 FORMAT (' refreq: reference LO frequency (MHz)  ', D22.14)
 2038 FORMAT (' delobs: observed group delay (usec)   ', D22.14)
 2039 FORMAT (' ratobs: observed delay rate (usec/sec)', D22.14)
 2040 FORMAT (' sbdel: narrow band delay (usec)       ', D22.14)
 2041 FORMAT (' gpamb: group delay ambiguity (usec)   ', D22.14)
 2042 FORMAT (' clkofst: apriori clock (usec)         ', D22.14)
 2043 FORMAT (' rfclker: reference station clock epoch', D22.14)
 2044 FORMAT (' delobsm: observed delay at cen ep     ', D22.14)
 2045 FORMAT (' ratobsm: observed delay rate cen ep   ', D22.14)
 2046 FORMAT (' dlepo1: phase delay at EPO+1 sec      ', D22.14)
 2047 FORMAT (' dlepo2: phase delay at EPO-1 sec      ', D22.14)
 2048 FORMAT (' ampbfrq: observed ampl and phase ')
20481 FORMAT (14(1PE9.2))
20482 FORMAT (14F9.1)
 2049 FORMAT (' phasecl: phase-cal rate by station ',2E17.9)
 2050 FORMAT (' delres: group delay residual       ',E17.9)
 2051 FORMAT (' delsig: group delay error          ',E17.9)
 2052 FORMAT (' ratres: delay rate residual        ',E17.9)
 2053 FORMAT (' ratsig: delay rate error           ',E17.9)
 2054 FORMAT (' cohrcr: coherence percent          ',E17.9)
 2055 FORMAT (' totphas: total obs fringe phase    ',E17.9)
 2056 FORMAT (' uvfasec: fringes/arcsec (ns,ew)    ',2E17.9)
 2057 FORMAT (' starelv: star elevations (deg)     ',2E17.9)
 2058 FORMAT (' incohamp: incoherent fringe ampl   ',E17.9)
 2059 FORMAT (' urvr: UV rate deriv mHz/arcsec     ',2E17.9)
 2060 FORMAT (' srchpar: fringe search parameters  ',6E15.7)
 2061 FORMAT (' sbres: avg sgl band delay (usec)   ',E17.9)
 2062 FORMAT (' snrato: SNR in sigmas              ',E17.9)
 2063 FORMAT (' falsedt: prob of false detection   ',E17.9)
 2064 FORMAT (' incoh2: incoh segment fringe ampl? ',E17.9)
 2065 FORMAT (' gcphas: toTAL phase at earth center',E17.9)
 2066 FORMAT (' gcresphs: res phase at earth cen   ',E17.9)
 2067 FORMAT (' startsc: start time (sec past hour)',E17.9)
 2068 FORMAT (' stopsc: stop time (sec past hour)  ',E17.9)
 2069 FORMAT (' deltepo: epoch offs from centr run ',E17.9)
 2070 FORMAT (' effdur: effective run dur (sec)    ',E17.9)
 2071 FORMAT (' sbsig: sngl ban delay error (usec) ',E17.9)
 2072 FORMAT (' qbfact: ratio of min/max data      ',E17.9)
 2073 FORMAT (' discrd: percent data discarded     ',E17.9)
 2074 FORMAT (' totpcnt: total phase at cent epoch ',E17.9)
      END

      PROGRAM STFND
C-----------------------------------------------------------------------
C! Task to find stars in an image and generate an ST table.
C# EXT-util Map-util Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2006, 2009, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task to find stars in an image and generate an ST table.
C    INPUTS:   (from AIPS)
C              USERID   R   user number, 0 means use logon user
C                       number, 32000 means any user can be accessed.
C              INNAME   R(3)   name of primary file.
C              INCLASS  R(2)   class of primary file.
C              INSEQ    R   sequence number of primary file.
C              INDISK   R    disk volume number. 0 means try all.
C              OUTVERS  R    ST file version number.
C              BLC      R(7)  Bottom corner to search for stars
C              TRC      R(7)  Top    corner to search for stars
C              CPARM    R(10) User parameters
C-----------------------------------------------------------------------
C                                       Max Number Columns, Label Length
      INTEGER MXSTCL, MXSTLB
      PARAMETER (MXSTCL=7, MXSTLB=24)
      CHARACTER PRGNAM*6, NAMIN*12, CLSIN*6, TYPIN*2, STFILE*48,
     *   CHTM12*12, TYPES(2)*8
      HOLLERITH XNAMIN(3), XCLSIN(2)
      REAL      DSKIN, SEQIN, XOUVER, BLC(7), TRC(7), CPARM(10),
     *   rbuf(512)
      INTEGER  I, IWBUFF(256), IMFIND, IMLUN, IERR, IRETCD, ISEQ,
     *   INPRMS, ISLOT, IUSER, IVOL, IROUND, SLUN, J, BUF(512), OUVER,
     *   ICTYPE(MXSTCL), IDIV, IRNO
      LOGICAL   T, F, SAVE, EQUAL, QUICK
      EQUIVALENCE (BUF, RBUF)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /INPARM/ XNAMIN, XCLSIN, SEQIN, DSKIN, XOUVER, BLC, TRC,
     *   CPARM
      DATA IMLUN, SLUN /16,29/
      DATA PRGNAM /'STFND '/
      DATA TYPIN /'  '/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      SAVE = F
C                                       Get input values from AIPS.
      INPRMS = 8+10+14
      IRETCD = 0
      CALL GTPARM (PRGNAM, INPRMS, QUICK, XNAMIN, IWBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRETCD = 8
         END IF
      IF (QUICK) CALL RELPOP (IRETCD, IWBUFF, IERR)
      IF (IRETCD.NE.0) GO TO 990
      IRETCD = 8
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
C
      ISEQ = IROUND (SEQIN)
      IVOL = IROUND (DSKIN)
      IUSER = NLUSER
      OUVER = IROUND (XOUVER)
C                                       Open map file & get header.
      CALL MAPOPN ('HDWR', IVOL, NAMIN, CLSIN, ISEQ, TYPIN, IUSER,
     *   IMLUN, IMFIND, ISLOT, CATBLK, IWBUFF, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Fill in defaults in PARMS
      DSKIN = IVOL
C                                       If sending Pixels
      IF (CPARM(10).LE.-1.0) THEN
C                                       Save Old Types
         CALL H2CHR (4, 1, CATH(KHCTP), TYPES(1))
         CALL H2CHR (4, 1, CATH(KHCTP+2), TYPES(2))
C                                       Tell STOPEN: send pixesl
         CALL CHR2H (4, '    ', 1, CATH(KHCTP))
         CALL CHR2H (4, '    ', 1, CATH(KHCTP+2))
C                                       End if sending pixles
         END IF
C                                       Open/Init Star Table
      CALL STOPEN (SLUN, IDIV, IVOL, ISLOT, OUVER, ICTYPE, BUF, IERR)
C                                       If sending Pixels
      IF (CPARM(10).LE.-1.0) THEN
C                                       Copy Old Types back
         CALL CHR2H (4, TYPES(1), 1, CATH(KHCTP))
         CALL CHR2H (4, TYPES(2), 1, CATH(KHCTP+2))
C                                       End if sending pixles
         END IF
      IRNO = 0
C                                       Read through map find stars
      CALL SENDMA (IMLUN, IMFIND, IRNO, BLC, TRC, CPARM, BUF, IERR)
C                                       CLose table, add history
      CALL STCLOS (IRNO, IVOL, ISLOT, OUVER, BUF, IERR)
C                                       IF no I/O error, jump to end
      IF (IERR.EQ.0) THEN
C                                       Mark ST table as OK
         IRETCD = 0
         GO TO 970
         END IF
C                                       ERRORS: Kill the ST table
      CALL ZCLOSE (SLUN, BUF(82), IERR)
      CALL H2CHR (24, 1, RBUF(17), STFILE)
      CALL ZDESTR (IVOL, STFILE, IERR)
C                                       STOPEN -> TABINI does FXHDEX
      DO 965 I = 1,KIEXTN
         J = I - 1
         CALL H2CHR (2, 1, CATH(KHEXT+J), CHTM12)
         EQUAL = CHTM12(1:2) .EQ. 'ST'
         IF (.NOT.EQUAL) GO TO 965
            IF (OUVER.EQ.CATBLK(KIVER+J)) CATBLK(KIVER+J) =
     *         CATBLK(KIVER+J) - 1
            SAVE = T
            GO TO 970
 965     CONTINUE
 970  CONTINUE
C                                       Close map file.
      CALL MAPCLS ('WRIT', IVOL, ISLOT, IMLUN, IMFIND, CATBLK, T,
     *   IWBUFF, IERR)
C
 990  CALL DIETSK (IRETCD, QUICK, IWBUFF)
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR GETTING PARAMETERS FROM AIPS. GTPARM ERR =',I5)
      END
      SUBROUTINE SENDMA (IMLUN, IMFIND, IRNO, BLC, TRC, CPARM, BUF,
     *   IRET)
C-----------------------------------------------------------------------
C   SENDMA sends image one row at a time to the user supplied
C   routine and then writes the modified data.
C   Input:
C     BLC     R(7)    boundary of region to search for stars
C     TRC     R(7)    boundary of region to search for stars
C     CPARM   R(10)   Star selection critera
C   Input/output:
C     IRNO    I       Number of stars written
C     BUF     I       I/O buffer for ST table
C   Output:
C      IRET   I       Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IMLUN, IMFIND, IRNO, BUF(*), IRET
      REAL      BLC(7), TRC(7), CPARM(10)
C
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   IROUND, NYI, NXI, WINI(4), JBUFSZ, BOI, LIM2, LIM3,
     *   LIM4, LIM5, LIM6, LIM7, I2, I3, I4, I5, I6, I7, IPOS(7),
     *   CORN(7), BOTEMP, IBIND, LIM1, DIDRET
      REAL      BUFF1(MABFSS)
      LOGICAL   T
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
      JBUFSZ = 2 * MABFSS
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Setup for I/O
      NXI = CATBLK(KINAX)
      NYI = CATBLK(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         CORN(7) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            CORN(6) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               CORN(5) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  CORN(4) = I4
                  DO 300 I3 = 1,LIM3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     CORN(3) = I3
C                                       Init. fiile
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1099) IRET
            GO TO 990
            END IF
C                                       Prepare for XYVAL calls
         LOCNUM = 1
         CALL SETLOC (IPOS(3), T)
C                                       Prepare to read map
         BOI = BOTEMP + 1
         CALL MINIT ('READ', IMLUN, IMFIND, NXI, NYI, WINI, BUFF1,
     *      JBUFSZ, BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'READ', IRET
            GO TO 990
            END IF
C                                       For all Rows loop
         DO 220 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
C                                       Read.
            CALL MDISK ('READ', IMLUN, IMFIND, BUFF1, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'READ', IRET
               GO TO 990
               END IF
C                                       Find in stars
            CALL STLOC ( IPOS, LIM1, BUFF1(IBIND), LIM2, CPARM, IRNO,
     *         BUF, IRET)
            DIDRET = IRET
            IF (DIDRET.NE.0) GO TO 750
C                                       End of For all rows loop
 220        CONTINUE
 300     CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Final call to functions
 750  IPOS(1) = -2
      CALL STLOC ( IPOS, LIM1, BUFF1(IBIND), LIM2, CPARM,
     *   IRNO, BUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1180) IRET
         GO TO 990
         END IF
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1099 FORMAT ('SENDMA: COMOFF ERROR',I3)
 1100 FORMAT ('SENDMA: INIT-FOR-',A4,' ERROR',I3)
 1120 FORMAT ('SENDMA: ',A,' ERROR',I3)
 1180 FORMAT ('SENDMA: DIDDLE ERROR',I3)
      END
      SUBROUTINE STLOC (IPOS, NPX, Z, NRW, CPARM, IRNO, BUF, IERR)
C-----------------------------------------------------------------------
C STLOC locates a star candiate on a row of an image.  Star candiates
C from previous rows are merged on the fly.  The stars are located by
C finding a series of pixels with values greater that the threshhold.
C The series is called a "RUN".  After merging, the Merged RUN must have
C an area greater than the area minimum
C   INPUTS:
C     IPOS      I(7)   Pixel Coordinate of first pixel in the row
C     NPX       I      number of pixels on the current row
C     Z         R(NPX) Row of the image
C     NRW       I      Number of rows in the image.
C     CPARM     R(10)  User input parameters
C   I/O
C     BUF       I(*)   I/O Buffer for ST table
C   OUTPUT
C     IERR      I      I/O error number. 0=> OK
C Written by Don Wells
C Modified by Glen Langston  92 May 31
C-----------------------------------------------------------------------
      INTEGER IPOS(7), NRW, NPX, IRNO, BUF(*), IERR
      REAL Z(*), CPARM(10)
C
      CHARACTER STRCHR*24
      INTEGER   MXRUNS
      PARAMETER (MXRUNS=3000)
      INTEGER IXY(3,MXRUNS), ITEM(MXRUNS)
      INTEGER NRL, NITEM, J, I, K, L, INNRL, JA, JAJ, INJ, DELI,
     *   IA, IB, NRLM, IAI, IBI, IAJ, IBJ, M, MXSTAR, STTYPE,
     *   MAXPIX, MAXROW, IROUND
      REAL ZS, ZSUM, XZSUM, AREA, XC, YC, XS(3,MXRUNS), THRESH,
     *   MNAREA, MXAREA, A1, A2, A3, CELLS(2)
      LOGICAL DORADC, ONCE, DBUGIT
      DOUBLE PRECISION P(6), DUMMY
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C                                      Get FBLANK from DDCH
      INCLUDE 'INCS:DDCH.INC'
      SAVE NITEM, NRL, M, MXSTAR, STTYPE, ONCE, DBUGIT, IXY, ITEM,
     *     MAXROW, MAXPIX, MNAREA, MXAREA, THRESH, A1, A2, A3, DORADC,
     *     CELLS, XS
C
      DATA NRL/0/,NITEM/0/,NRLM/0/, ONCE/.FALSE./
C-----------------------------------------------------------------------
C                                      Set start pixel number
      IB = 1
C                                      JA = current row number
      JA = IPOS(2)
C                                      On first row, report parms
      IF (.NOT. ONCE) THEN
C                                       Translate user inputs
         THRESH = CPARM(1)
C                                       If no threshold
         IF (THRESH.EQ.0.0) THEN
C                                       use 95 % of maximum
            THRESH = 0.95 * CATR(KRDMX)
            END IF
C                                       Distance between runs to merge
         M      = CPARM(2)
         IF (M.LT.1) M = 0
C                                       Min star area, no lower limit
         MNAREA = CPARM(3)
C                                       Max star area
         MXAREA = CPARM(4)
C                                       Make max, 1 big star
         IF (MXAREA.EQ.0) MXAREA = NPX*NRW/4.
C                                       Scales for star size, area
         A1     = CPARM(5)
C                                       Total count
         A2     = CPARM(6)
C                                       Size constant
         A3     = CPARM(7)
C                                       default star is sqrt area
         IF (A1.EQ.0.0 .AND. A2.EQ.0.0 .AND. A3.EQ.0.0) A1 = 1.
C                                       Set type of star
         STTYPE = IROUND (CPARM(8))
         STTYPE = MAX (1, MIN (24, STTYPE))
C                                       Limit maximum number of stars
         MXSTAR = ABS (CPARM(9))
         IF (MXSTAR.LE.0) MXSTAR = 100
C                                       Debug hook
         DBUGIT = CPARM(9) .LT. -1
C                                       Translate to RA and Dec?
         DORADC = CPARM(10).GT.-1.0
C                                       conversion from pixels to degrees
         CELLS(1) = ABS (CATR(KRCIC))
         CELLS(2) = ABS (CATR(KRCIC+1))
C                                       Tell User
         WRITE (MSGTXT,1000) NPX, NRW, MXSTAR
         CALL MSGWRT(3)
         WRITE (MSGTXT,1100) THRESH
         CALL MSGWRT(3)
         WRITE (MSGTXT,1110) MNAREA, MXAREA
         CALL MSGWRT(3)
         WRITE (MSGTXT,1130) M
         CALL MSGWRT(3)
         IF (DORADC) THEN
            MSGTXT='STLOC:  Translating Star coordinate to RA and DEC '
         ELSE
            MSGTXT='STLOC:  Returning Star coordinate in Pixels '
            END IF
         CALL MSGWRT(3)
C                                      Init Arrays
         CALL FILL (MXRUNS, 0, ITEM)
         CALL FILL (MXRUNS*3, 0, IXY)
         CALL RFILL (MXRUNS*3, 0.0, XS)
C                                      End initialize once
C                                      Maximum pixel is start + number
         MAXPIX = IB + NPX - 1
C                                      Maximum row is start + number
         MAXROW = JA + NRW - 1
         END IF
C                                      If time to flush last
      IF (IB .LT. 0 .OR. JA .GT. MAXROW) THEN
C                                      Handle case of star on last row
         JA=MAXROW+M+2
         IB=MAXPIX
C                                      jump to flush list
         GO TO 90
      END IF
C                                      Every so often print progress
      IF ((MOD(JA,100).EQ.1).OR.(JA.EQ.MAXROW)) THEN
         WRITE (MSGTXT,1200) JA
         CALL MSGWRT(3)
         END IF
C                                      Loop here for start of a run
      IA = IB
C
 10   IA = IA+1
C                                       While Row not finished
      IF (IA.GT.MAXPIX) GO TO 90
C                                       blanked pixel below threshold
      IF (Z(IA).EQ.FBLANK) GO TO 10
C                                       If pixel less than threshold
      IF (Z(IA).LT.THRESH) GO TO 10
C                                       FOUND A RUN: LOOK FOR ITS END:
      IB=IA
C                                       Do pixel statistics
      ZSUM  = Z(IB)
      XZSUM = IB*Z(IB)
 20   IB=IB+1
C                                       While not end of row loop
         IF (IB.GT.MAXPIX) GO TO 30
C                                       blanked pixels below threshold
         IF (Z(IB).EQ.FBLANK) GO TO 30
C                                       if pixel is below threshold
         IF (Z(IB).LT.THRESH) GO TO 30
         ZSUM  = ZSUM  + Z(IB)
         XZSUM = XZSUM + IB*Z(IB)
C                                       Still in a RUN find next pixel
         GO TO 20
C                                       Found end of a run, save end
 30   IB=IB-1
C                                       PUT NEW RUN AT END OF LIST:
C                                       Increase total list
      NRL=NRL+1
C                                       Check for limits
      IF (NRL.GT.MXRUNS) THEN
         MSGTXT = 'STLOC:  MAXIMUM NUMBER OF STAR CANDIDATES EXCEEDED'
         CALL MSGWRT(8)
         MSGTXT = 'STLOC:  INCREASE THRESHOLD AND/OR AREA LIMITS'
         CALL MSGWRT(8)
         IERR = 1
         GO TO 999
         END IF
C                                       record max number of runs
      NRLM = MAX (NRL,NRLM)
C                                       Record Row, start, stop columns
      IXY(1,NRL) = JA
      IXY(2,NRL) = IA
      IXY(3,NRL) = IB
C                                       Record Sum and X weighted sum
      XS(1,NRL)  = ZSUM
      XS(2,NRL) = XZSUM
      XS(3,NRL) = JA*ZSUM
C                                       Is this part of a previous run
      J=NRL
C                                       Start looking backwards
   40 J=J-1
C                                       While not all previous lists
      IF (J.LT.1) GO TO 80
      JAJ = IXY(1,J)
C                                       If previous row far from current
      IF (JAJ.LT.(JA-M-1)) GO TO 80
C                                       OVERLAP TESTS:
      IAJ = IXY(2,J)
      IBJ = IXY(3,J)
C                                       If previous near by
      IF(((IA-M).LE.IAJ).AND.(IAJ.LE.(IB+M)))GO TO 50
      IF(((IA-M).LE.IBJ).AND.(IBJ.LE.(IB+M)))GO TO 50
      IF(((IAJ-M).LE.IA).AND.(IA.LE.(IBJ+M)))GO TO 50
C                                       Else previous far jump to next
      GO TO 40
C                                       OVERLAP DETECTED, assign an item
   50 INNRL=ITEM(NRL)
C                                       IS ITEM NUMBER ALREADY SET?
      IF (INNRL.EQ.0) THEN
C                                       NO, SO USE NUMBER OF OVERLAPPED RUN:
         ITEM(NRL) = ITEM(J)
C                                       go look for next overlap
         GO TO 40
         END IF
C                                       Else item number set
      INJ=ITEM(J)
C                                       If part of this item, go look
C                                       for an overlap
      IF (INNRL.EQ.INJ) GO TO 40
C-----OOPS, NOT EQUAL, SO THE TWO OBJECT DESCRIPTIONS MUST BE MERGED.
C     SUPPRESS OVERLAPPED OBJECT NUMBER:
C                                       for all runs
      DO 70 I=1,NRL
C                                       if part of old item, make new
         IF (ITEM(I).EQ.INJ) ITEM(I) = ITEM(INNRL)
   70    CONTINUE
C                                       Go look for next overlap
      GO TO 40
C                                       SEARCH COMPLETE
   80 INNRL=ITEM(NRL)
C                                       IS ITEM NUMBER SET?
      IF (INNRL .EQ. 0) THEN
C                                       start a new item
         NITEM = NITEM + 1
         ITEM(NRL) = NITEM
         END IF
C                                       Item finished, go find next
      IA = IB + 1
C                                       go look for start of next run
      GO TO 10
C                                       Jump here on end of row
   90 CONTINUE
C                                       Row is finished. If previous row
      IF (ONCE) THEN
C                                       For all runs loop
         J=NRL+1
C                                       do while not all other objects
  100    J=J-1
C                                       If past begin of run list, exit
         IF (J.LT.1) GO TO 120
C                                       If object not done, get next object
         IF (IXY(1,J).LT.0) GO TO 100
C                                       set row of previous run
         JAJ = IXY(1,J)
C                                       if object close to row, no flag
         IF (JAJ.LT.(JA-1-M)) GO TO 100
C                                       Else near row, flag this item
         INJ=ITEM(J)
C                                       FLAG THE OBJECT # OF RUN J:
            DO 110 I=1,NRL
C                                       Objects are complete when row<0
            IF (IXY(1,I).GT.0) THEN
               IF (ITEM(I).EQ.INJ) IXY(1,I)=-IXY(1,I)
               END IF
  110       CONTINUE
C                                       End of all runs loop
         GO TO 100
C                                       Dump all unflagged objects
  120    J=0
C                                       Start all runs loop
  130    J=J+1
C                                       exit if past end all runs
  140    IF (J.GT.NRL) GO TO 180
C                                       if a flagged run go get next
         IF (IXY(1,J).LT.0) GO TO 130
C                                       Else, unflagged run,
C                                       Set object number to dump
            INJ=ITEM(J)
C                                       If debugging print
            IF (DBUGIT) THEN
               WRITE(MSGTXT,2000) J, NRL, INJ, NITEM
               CALL MSGWRT(5)
               END IF
C                                      Add up the pieces
            AREA=0.
            XC=0.
            YC=0.
            ZS=0.
C                                     for all other runs
            DO 150 I=J,NRL
C                                     If apart of the item
               IF(ITEM(I).EQ.INJ) THEN
C                                     AREA:
                  IAI=IXY(2,I)
                  IBI=IXY(3,I)
                  DELI=(IBI-IAI+1)
                  AREA=AREA+DELI
C                                     ISOPHOTAL FLUX SUMMATION:
                  ZS=ZS+XS(1,I)
C                                     X,Y-CENTROID:
                  XC=XC+XS(2,I)
                  YC=YC+XS(3,I)
                  IF (DBUGIT) THEN
                     WRITE (MSGTXT,2100) I, IXY(1,I), IAI, IBI
                     CALL MSGWRT(5)
                     WRITE (MSGTXT,2200) I, XS(1,I), XS(2,I), XS(3,I)
                     CALL MSGWRT(5)
                     END IF
C                                      End if part of object
                  END IF
C                                      End of for all other runs loop
  150          CONTINUE
C                                      TEST AGAINST AREA THRESHOLD:
C                                      WRITE SUMMARY OF PEAK:
            P(1) = XC/ZS + IPOS(1)
            P(2) = YC/ZS
C                                      Set Star size, area+intensity
            P(3) = A1 * SQRT(ABS(AREA)) * CELLS(1)
            P(3) = P(3) + (A2*ZS) + A3
            P(4) = P(3)
C                                      if star covers enough area
            IF (AREA.GT.MNAREA .AND. AREA.LT.MXAREA) THEN
C                                      Write out a single ST entry
               IF (IRNO .GE. MXSTAR) THEN
                  MSGTXT = 'STLOC: Maximum number of stars exceeded'
                  CALL MSGWRT(8)
                  IERR = IRNO
                  GO TO 999
                  END IF
               IRNO = IRNO + 1
               STRCHR = 'S '
               P(5) = 0.
               P(6) = STTYPE
C                                       If converting to RA and DEC
               IF (DORADC) THEN
                  XC = P(1)
                  YC = P(2)
                  CALL XYVAL ( XC, YC, P(1), P(2), DUMMY, IERR)
C                                       if a bad translation
                  IF (IERR.NE.0) THEN
C                                       return the pixel numbers
                     P(1) = XC
                     P(2) = YC
                     END IF
                  END IF
C                                       Report progress
               IF ((((IRNO-1)/20)*20).EQ.IRNO-1.OR.IRNO.LT.5) THEN
                  WRITE (MSGTXT,1300)  IRNO, P(1), P(2), ZS
                  CALL MSGWRT(3)
                  END IF
               CALL STPUT (IRNO, 0, BUF, P(1), P(2), P(3), P(4),
     *            P(5), P(6), STRCHR, IERR)
C                                       End if enough area
               END IF
C                                       If normal Write, go get next
            IF (IERR.NE.0) THEN
C                                       Else, error write message
               MSGTXT = 'STFND: STPUT I/O ERROR, QUITTING'
               CALL MSGWRT(8)
               GO TO 999
               END IF
C                                      remove this item from runs
            K=J-1
C                                      for all other runs
            DO 170 I=J,NRL
C                                      if not current item
               IF (ITEM(I).NE.INJ.OR.IXY(1,I).LT.0) THEN
C                                      move over current item
                  K=K+1
C                                      compress list, copy parts
                  DO 165 L=1,3
                     IXY(L,K) = IXY(L,I)
                     XS(L,K)  = XS(L,I)
                     IF (K.NE.I) THEN
                        IXY(L,I) = 0
                        XS(L,I)  = 0
                        END IF
  165                CONTINUE
C                                      Transfer item number
                  ITEM(K) = ITEM(I)
C                                      If not same object, init object
                  IF (I.NE.K) ITEM(I) = 0
C                                      End if not part of current item
                  END IF
C
  170       CONTINUE
C                                      Now init parts of lists not used
            IF (K.LT.NRL) THEN
C                                      For all unused pieces
               DO 175 I = K+1, NRL
C                                      For each of three elements
                  DO 172 L=1,3
                     IXY(L,I) = 0
                     XS(L,I)  = 0
 172                 CONTINUE
                  ITEM(I) = 0
 175              CONTINUE
C                                      End if list must be initialed
               END IF
C                                      list compressed, current runs
            NRL=K
C                                      go find next object to write
            GO TO 140
C                                      If any runs left,
  180       IF (NRL.GT.0) THEN
C                                      CLEAR THE FLAGS:
               DO 190 I=1,NRL
                  IF (IXY(1,I).LT.0) IXY(1,I)=-IXY(1,I)
  190             CONTINUE
               END IF
C                                      End if previous rows
            END IF
C                                      Only initialize once
 999  ONCE = .TRUE.
      RETURN
C-----------------------------------------------------------------------
1000  FORMAT ('STLOC:  Searching',I5,' by',I5,' pixel box for up to',I6,
     *   ' stars')
1100  FORMAT ('STLOC:  Star Threshold Level is',1PE10.3)
1110  FORMAT ('STLOC:  Star Area between      ',1PE10.3,' and',
     *   E10.3,' Pixels')
1130  FORMAT ('STLOC:  Merging objects separated by  ',I6,' Pixels')
1200  FORMAT ('STLOC:  Currently finding stars on row',I6)
1300  FORMAT ('STLOC:  Star',I6,' at ',F11.4,',',F11.4,'; Sum =',
     *         1PE10.3)
2000  FORMAT ('DBUGI: Writing RUN',I4,' of',I4,'; ITEM',I4,' of',I4)
2100  FORMAT ('DBUGI: RUN',I4,' ROW',I10,'; COLS',I10,' to',I10)
2200  FORMAT ('DBUGI: RUN',I4,' SUM',1PE10.3,'; X,Y',E10.3,' to',E10.3)
      END

      SUBROUTINE MAPSNC (NAX, NP, KVOL, LUN, IND, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! creates a scratch image file of specified dimensionality
C# Map-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MAPSNC creates a scratch file of correct size to hold an NAX-
C   dimensional map image and opens it.   Uses SCREAT.
C   Inputs:
C      NAX    I         Number of axes
C      NP     I(NAX)    Number of points on each axis
C      KVOL   I         Disk to avoid if possible
C      LUN    I         LUN to use
C   Output:
C      IND    I         FTAB pointer to open file
C      SCRTCH I(512)    Scratch buffer
C      IERR   I         0 => file created, others => failure
C   Common:
C      /CFILES/ file description area - new scratch file entered there
C               in count (NSCR), cat number (SCRCNO), volume (SCRVOL).
C               The routine also uses the bad-disk list IBAD.
C      /MAPHDR/ also used for dummy CATBLK of cataloged scratch
C-----------------------------------------------------------------------
      INTEGER   NAX, NP(*), KVOL, LUN, IND, SCRTCH(512), IERR
C
      CHARACTER PHNAME*48
      INTEGER   ISIZE
      LOGICAL   T
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Map size: sectors/row
      CALL MAPSIZ (NAX, NP, ISIZE)
C                                       Lie to SCREAT
      IF (NSCR.GE.SCRLST-1) THEN
         MSGTXT = 'MAPSNC: SCRATCH FILE LIST OVERFLOWS'
         CALL MSGWRT (8)
         IERR = 9
         GO TO 999
         END IF
      NSCR = NSCR + 1
      IF (NSCR.LE.0) NSCR = 1
      SCRVOL(NSCR) = KVOL
C                                       Do create
      CALL SCREAT (ISIZE, SCRTCH, IERR)
C                                       Undo lie
      NSCR = NSCR - 1
      IF (NSCR.LE.0) GO TO 999
      SCRVOL(NSCR) = SCRVOL(NSCR+1)
      SCRCNO(NSCR) = SCRCNO(NSCR+1)
      IF (IERR.NE.0) GO TO 999
C                                       Do open
      CALL ZPHFIL ('SC', SCRVOL(NSCR), SCRCNO(NSCR), 1, PHNAME, IERR)
      CALL ZOPEN (LUN, IND, SCRVOL(NSCR), PHNAME, T, T, T, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1000)
         CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UNABLE TO OPEN SCRATCH FILE: LUN, IER =',2I7)
      END

      SUBROUTINE BBUILD (IW, IL, IP, IM, BUFFER)
C-----------------------------------------------------------------------
C! reads input lines and adds them to the text file for a batch job
C# Batch
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   BBUILD takes input lines via PREAD and puts them into the batch
C   file which must be open and refenced via the BWTCH common.
C   Process stops when 'ENDBATCH' is found in the data stream.  In
C   addition, if IUNIT = 3 (batch input to interactive), cards with
C   the word RUN are eliminated.
C   Inputs:
C      IW      I       logical rec # - where to put first line
C      IP      I       log rec # of line which points to first line
C      IL      I       log rec # to which last line must point
C      IM      I       initial next avail log. rec #
C   In/out:
C      BUFFER  I(256)  buffer used to write the file.  On input it
C                      contains the log rec pointed at by BWTREC.
C-----------------------------------------------------------------------
      INTEGER   IW, IL, IP, IM, BUFFER(256)
C
      CHARACTER   BATSGN*1, KARAT*1, ENDBTS(2)*8, RUNLTS(2)*4,
     *   PRGNAM*6
      INTEGER   POTERR, IWH, ICOUNT, NXT, LREC, IREC, IERR, NWPL, NLPR,
     *   INCS, LL, J, LASTLR
      INCLUDE 'INCS:DBWT.INC'
      INCLUDE 'INCS:DIO.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      DATA BATSGN, KARAT /'<', '>'/
      DATA ENDBTS /'ENDBATCH','endbatch'/
      DATA RUNLTS /'RUN ','run '/
      DATA PRGNAM /'BBUILD'/
C-----------------------------------------------------------------------
C                                        init things
      POTERR = 49
      ICOUNT = 0
      IWH = IW
      NXT = IM
      IF (IM.EQ.IW) NXT = NXT + 1
      IPT = BATSGN
      NWPL = 2 + (NCHLIN+3)/4
      NLPR = 252 / NWPL
C                                        make rec. referencing first
C                                        be in core
      IF (BWTREC.EQ.IP) GO TO 25
         LREC = (BWTREC-1)/NLPR + 1
         BWTREC = IP
         IREC = (BWTREC-1)/NLPR + 1
         IF (IREC.EQ.LREC) GO TO 25
            CALL ZFIO ('READ', BWTLUN, BWTIND, IREC, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 980
C                                        read next line
 25   CALL PREAD (KARBUF)
         IF (ERRNUM.NE.0) GO TO 980
C                                        look for special strings
         LL = INDEX (KARBUF, ENDBTS(1))
         IF (LL.GT.0) GO TO 50
         LL = INDEX (KARBUF, ENDBTS(2))
         IF (LL.GT.0) GO TO 50
         IF (IUNIT.NE.3) GO TO 30
            LL = INDEX (KARBUF, RUNLTS(1))
            IF (LL.GT.0) GO TO 25
            LL = INDEX (KARBUF, RUNLTS(2))
            IF (LL.GT.0) GO TO 25
C                                        point last to this
 30      J = 5 + NWPL * MOD(BWTREC-1, NLPR)
         BUFFER(J) = IWH
         LREC = (BWTREC-1)/NLPR + 1
         LASTLR = BWTREC
C                                        on to this one
         BWTREC = IWH
         IWH = NXT
         NXT = NXT + 1
         IREC = (BWTREC-1)/NLPR + 1
         IF (IREC.EQ.LREC) GO TO 35
            CALL ZFIO ('WRIT', BWTLUN, BWTIND, LREC, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 980
            IF (IREC.LE.BWTNUM) GO TO 32
               INCS = 20/NLPR + 1
               CALL ZEXPND (BWTLUN, 1, BWTNAM, INCS, IERR)
               IF (IERR.NE.0) GO TO 980
               BWTNUM = BWTNUM + INCS
 32         CALL ZFIO ('READ', BWTLUN, BWTIND, IREC, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 980
 35      J = 5 + NWPL * MOD(BWTREC-1, NLPR)
         BUFFER(J) = IL
         BUFFER(J+1) = LASTLR
         CALL CHR2H (NCHLIN, JBUFF, 1, BUFFER(J+2))
         ICOUNT = ICOUNT + 1
         GO TO 25
C                                        finish up:
 50   IF (ICOUNT.LE.0) GO TO 70
         LASTLR = BWTREC
         LREC = (BWTREC-1)/NLPR + 1
C                                        update back link in old code
         IF (IL.LE.0) GO TO 60
            BWTREC = IL
            IREC = (BWTREC-1)/NLPR + 1
            IF (IREC.EQ.LREC) GO TO 55
               CALL ZFIO ('WRIT', BWTLUN, BWTIND, LREC, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 980
               LREC = IREC
               CALL ZFIO ('READ', BWTLUN, BWTIND, LREC, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 980
 55         J = 5 + NWPL * MOD(BWTREC-1, NLPR)
            BUFFER(J+1) = LASTLR
C                                        update full file pointers
 60      IF (LREC.EQ.1) GO TO 65
            CALL ZFIO ('WRIT', BWTLUN, BWTIND, LREC, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 980
            CALL ZFIO ('READ', BWTLUN, BWTIND, 1, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 980
 65      BUFFER(2) = IWH
         IF (IL.LE.0) BUFFER(3) = BWTREC
         BUFFER(4) = BWTNUM
         CALL ZFIO ('WRIT', BWTLUN, BWTIND, 1, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 980
C                                        message
 70   WRITE (MSGTXT,1070) ICOUNT
      CALL MSGWRT (2)
      GO TO 990
C                                        Errors
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 990  IPT = KARAT
C
 999  RETURN
C-----------------------------------------------------------------------
 1070 FORMAT ('Added',I6,' lines to batch work file')
      END

      SUBROUTINE SYMINV (N, A, IERR)
C-----------------------------------------------------------------------
C! Invert small symmetric real matrix.
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Inverts a symmetric matrix.  The size of internal arrays limits to
C   no larger than 50x50.
C   Inputs:
C      N    I       Order of the matrix
C   Input/Output:
C      A    R(N,N)  On input the symmetric matrix,
C                   On output its inverse
C   Output:
C      IERR I       Error code, 0=OK, 
C                   1=matrix too big, 
C                   2=matrix not symmetric
C                   3=matrix singular. 
C-----------------------------------------------------------------------
      INTEGER   N, IERR
      REAL      A(N,N)
C                                       MAXSIZ = max. matrix order
      INTEGER MAXSIZ
      PARAMETER (MAXSIZ = 50)
      INTEGER   J, K, L, M
      REAL      AB, BIG, P(MAXSIZ), Q(MAXSIZ), R(MAXSIZ)
C-----------------------------------------------------------------------
C                                       Check size
      IF (N.GT.MAXSIZ) THEN
         IERR = 1
         GO TO 999
         END IF
C                                       Make sure symmetric
      DO 10 J = 1,N
         DO 5 K = 1,N
C                                       Not symmetric
            IF (ABS (A(J,K)-A(K,J)).GT.ABS (A(J,K))*1.0E-4) THEN
               IERR = 2
               GO TO 999
               END IF
 5          CONTINUE
 10      CONTINUE
      DO 15 M = 1,N
         R(M) = 1.0
 15      CONTINUE
      DO 200 M = 1,N
         BIG = 0.0
         DO 20 L = 1,N
            AB = ABS (A(L,L))
            IF ((AB.GT.BIG) .AND. (R(L).NE.0)) THEN
               BIG = AB
               K = L
               END IF
 20         CONTINUE
C                                       Inverse indeterminant?
         IF (BIG.EQ.0.0) THEN
            IERR = 3
            GO TO 999
            END IF
         R(K) = 0.0
         Q(K) = 1.0 / A(K,K)
         P(K) = 1.0
         A(K,K) = 0.0
         DO 30 L = 1,K-1
            P(L) = A(L,K)
            IF (R(L).EQ.0.0) THEN
               Q(L) = A(L,K) * Q(K)
            ELSE
               Q(L) = -A(L,K) * Q(K)
               END IF
            A(L,K) = 0.0
 30         CONTINUE
         DO 40 L = K+1,N
            IF (R(L).NE.0.0) THEN
               P(L) = A(K,L)
            ELSE
               P(L) = -A(K,L)
               END IF
            Q(L) = -A(K,L) * Q(K)
            A(K,L) = 0.0
 40         CONTINUE
         DO 60 L = 1,N
            DO 50 K = L,N
               A(L,K) = A(L,K) + P(L)*Q(K)
 50            CONTINUE
 60         CONTINUE
 200     CONTINUE
C                                       Fill in symmetric half
      M = N + 1
      L = N
      DO 80 K = 2,N
         M = M - 1
         L = L - 1
         DO 70 J = 1,L
            A(M,J) = A(J,M)
 70         CONTINUE
 80      CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'CC2IM.INC'
C                                       Local include for CC2IM
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, CCVER, NEWCNO, OLDCNO,
     *   CATOLD(256), JBUFSZ, CCBUFF(512)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2), OLDH(256)
      REAL      XSEQIN, XDISKI, XSEQO, XDISKO, XCCVER, CELL(2), DOCENT,
     *   IMSIZE(2), BUFF1(MABFSS), BUFF2(MABFSS), OLDR(256)
      DOUBLE PRECISION OLDD(128)
      EQUIVALENCE (CATOLD, OLDH, OLDR, OLDD)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XNAMOU, XCLAOU,
     *   XSEQO, XDISKO, XCCVER, CELL, DOCENT, IMSIZE
      COMMON /PARMS/  CATOLD, SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO,
     *   OLDCNO, CCVER, JBUFSZ
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMOUT, CLAOUT
      COMMON /BUFRS/ BUFF1, BUFF2, CCBUFF
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
LOCAL END
      PROGRAM CC2IM
C-----------------------------------------------------------------------
C! converts CC file to image
C# MAP Math
C-----------------------------------------------------------------------
C;  Copyright (C) 2012, 2020
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CC2IM converts a CC file to an image
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLAOUT        Class of the output image.
C                                   Default is input class.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      INVERS         CCVER         CC version number
C      CELLSIZE       CELL(2)       Cell size in asec on input
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, NEED
      REAL      IMAG(2)
      LONGINT   PIMAG
      INCLUDE 'CC2IM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'CC2IM '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL CC2IMI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Dynamic memory make output image
      NEED = CATBLK(KINAX) * CATBLK(KINAX+1) / 1024 + 2
      CALL ZMEMRY ('GET ', PRGM, NEED, IMAG, PIMAG, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET NEEDED DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       fill it in and write it
      CALL CC2IMD (CATBLK(KINAX), CATBLK(KINAX+1), IMAG(1+PIMAG), IRET)
      IF (IRET.EQ.0) CALL CC2IMH
C                                       Close down files, etc.
 990  CALL DIE (IRET, CCBUFF)
C
 999  STOP
      END
      SUBROUTINE CC2IMI (PRGN, IRET)
C-----------------------------------------------------------------------
C   CC2IMI gets input parameters for CC2IM and creates an output file.
C   Inputs:
C      PRGN   C*6    Program name
C   Output:
C      IRET   I      Error code: 0 => ok
C                                4 => user routine detected error.
C                                5 => catalog troubles
C                                8 => can't start
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   IRET
C
      CHARACTER STAT*4, BLANK*6, MTYPE*2
      INTEGER   IERR, NPARM, IROUND
      INCLUDE 'CC2IM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA BLANK /'      '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 20
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, CCBUFF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) THEN
            GO TO 999
         ELSE
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
            END IF
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, CCBUFF, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO = IROUND (XDISKO)
      CCVER = IROUND (XCCVER)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, CCBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, 'READ', CCBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Copy old CATBLK to new.
      CALL COPY (256, CATOLD, CATBLK)
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Get user modification to CATBLK
      IRET = 4
      CALL CC2IMS (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create output file.
      NEWCNO = 1
      IRET = 4
      CALL MCREAT (DISKO, NEWCNO, CCBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CC2IMI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('CC2IMI: ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE CC2IMS (IRET)
C-----------------------------------------------------------------------
C   CC2IMS reads the CC file and determines the size and coordinates
C   of the output image.
C   Common input/output
C      CATBLK   I(256)   Output catalog header, also CATR, CATD
C      CATOLD   I(256)   Input catalog header, also OLDR, OLDD
C   Output:
C      IRET     I        Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   LUN, NCOL, NCOMP, ICCRNO, IROW, IROUND, CCKOLS(MAXCCC),
     *   CCNUMV(MAXCCC), TYPE
      REAL      XMAX, XMIN, YMAX, YMIN, SMAX, X, Y, FLUX, PARMS(3), DX,
     *   DY, Z
      INCLUDE 'CC2IM.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       open CC file
      LUN = 43
      CALL CCMINI ('READ', CCBUFF, DISKIN, OLDCNO, CCVER, CATOLD, LUN,
     *   ICCRNO, CCKOLS, CCNUMV, NCOL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING CC FILE'
         GO TO 990
         END IF
C                                       init
      NCOMP = CCBUFF(5)
      XMAX = -1.E10
      XMIN = -XMAX
      YMAX = XMAX
      YMIN = -YMAX
      SMAX = 0.0
      DO 20 IROW = 1,NCOMP
         CALL TABCCM ('READ', CCBUFF, ICCRNO, CCKOLS, CCNUMV, NCOL, X,
     *      Y, Z, FLUX, TYPE, PARMS, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING CC FILE'
            GO TO 990
         ELSE IF (IRET.EQ.0) THEN
            XMIN = MIN (XMIN, X)
            XMAX = MAX (XMAX, X)
            YMIN = MIN (YMIN, Y)
            YMAX = MAX (YMAX, Y)
            IF (TYPE.GT.0) SMAX = MAX (SMAX, PARMS(1))
            END IF
 20      CONTINUE
      CALL TABCCM ('CLOS', CCBUFF, ICCRNO, CCKOLS, CCNUMV, NCOL, X,
     *   Y, Z, FLUX, TYPE, PARMS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING CC FILE'
         GO TO 990
         END IF
C                                       cell size
      CELL(1) = CELL(1) / 3600.0
      CELL(2) = CELL(2) / 3600.0
      IF (CELL(1).EQ.0.0) CELL(1) = ABS (OLDR(KRCIC))
      IF (CELL(2).EQ.0.0) CELL(2) = ABS (OLDR(KRCIC+1))
      IF (CELL(1).EQ.0.0) CELL(1) = 1.0 / 3600.0
      IF (CELL(2).EQ.0.0) CELL(2) = 1.0 / 3600.0
      XMIN = (XMIN - 4*SMAX) / CELL(1)
      XMAX = (XMAX + 4*SMAX) / CELL(1)
      IF (OLDR(KRCIC).LT.0.0) THEN
         X = XMIN
         XMIN = -XMAX
         XMAX = -X
         END IF
      YMIN = (YMIN - 4*SMAX) / CELL(2)
      YMAX = (YMAX + 4*SMAX) / CELL(2)
      IF (DOCENT.GT.0.0) THEN
         X = MAX (ABS(XMAX), ABS(XMIN))
         XMAX = X
         XMIN = -X
         Y = MAX (ABS(YMAX), ABS(YMIN))
         YMAX = Y
         YMIN = -Y
         END IF
      CATBLK(KINAX) = XMAX - XMIN + 8.5
      DX = MAX (0.0, IMSIZE(1) - CATBLK(KINAX))
      CATBLK(KINAX) = CATBLK(KINAX) + DX + 0.1
      CATR(KRCIC) = -CELL(1)
      CATR(KRCRP) = IROUND (-XMIN + 4.0 + DX/2.0)
      CATBLK(KINAX+1) = YMAX - YMIN + 8.5
      DY = MAX (0.0, IMSIZE(2) - CATBLK(KINAX+1))
      CATBLK(KINAX+1) = CATBLK(KINAX+1) + DY + 0.1
      CATR(KRCIC+1) = CELL(2)
      CATR(KRCRP+1) = IROUND (-YMIN + 5.0 + DY/2.0)
      IF (DOCENT.GT.0.0) THEN
         CATBLK(KINAX) = ((CATBLK(KINAX)+1)/2) * 2
         CATR(KRCRP) = (CATBLK(KINAX)+1) / 2
         CATBLK(KINAX+1) = ((CATBLK(KINAX+1)+1)/2) * 2
         CATR(KRCRP+1) = CATBLK(KINAX+1) / 2 + 1
         END IF
      CALL FILL (5, 1, CATBLK(KINAX+2))
      CALL CHR2H (8, 'JY/PIXEL', 1, CATH(KHBUN))
      CATBLK(KITYP) = 2
      CATBLK(KINIT) = NCOMP
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CC2IMS: ERROR',I4,' ',A)
      END
      SUBROUTINE CC2IMD (NX, NY, IMAG, IRET)
C-----------------------------------------------------------------------
C   CC2IMD fills in the imagr from the Clean components
C   and then writes it to the image file
C   Input:
C      NX     I      X dimension
C      NY     I      Y dimension
C   Output:
C      IMAG   R(*)   Image of CC
C      IRET   I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NX, NY, IRET
      REAL      IMAG (NX,*)
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER IFILE*48, KEYW*8
      LOGICAL   T
      INTEGER   LUNO, INDO, LUN, NCOL, NCOMP, ICCRNO, CCKOLS(MAXCCC),
     *   CCNUMV(MAXCCC), IX, IY, IX1, IX2, IY1, IY2, TYPE, IROW, I,
     *   WINO(4), IBLKOF, OBIND, LOCS, KEYTYP, NCNV
      REAL      X, Y, FLUX, PARMS(3), FMAX, FMIN, SCALES(2), OFFS(2),
     *   FSUM, GSUM, TSUM, SR, CR, AA, BB, CC, AA0, BB0, CC0, D, Z
      INCLUDE 'CC2IM.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUNO /17/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       init for CC models
      SCALES(1) = 1.0 / CATR(KRCIC)
      SCALES(2) = 1.0 / CATR(KRCIC+1)
      OFFS(1) = CATR(KRCRP)
      OFFS(2) = CATR(KRCRP+1)
      I = NX * NY
      CALL RFILL (I, 0.0, IMAG)
C                                       open CC
C                                       open CC file
      LUN = 43
      CALL CCMINI ('READ', CCBUFF, DISKIN, OLDCNO, CCVER, CATOLD, LUN,
     *   ICCRNO, CCKOLS, CCNUMV, NCOL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING CC FILE'
         GO TO 990
         END IF
      NCOMP = CCBUFF(5)
      FSUM = 0.0
      TSUM = 0.0
      AA0 = CATR(KRCIC)*CATR(KRCIC) * 4.0 * LOG (2.0)
      BB0 = CATR(KRCIC+1)*CATR(KRCIC+1) * 4.0 * LOG (2.0)
      CC0 = ABS(CATR(KRCIC)*CATR(KRCIC+1)) * 8.0 * LOG (2.0)
      DO 90 IROW = 1,NCOMP
         CALL TABCCM ('READ', CCBUFF, ICCRNO, CCKOLS, CCNUMV, NCOL, X,
     *      Y, Z, FLUX, TYPE, PARMS, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING CC FILE'
            GO TO 990
         ELSE IF (IRET.EQ.0) THEN
            TSUM = TSUM + FLUX
            X = X * SCALES(1) + OFFS(1)
            Y = Y * SCALES(2) + OFFS(2)
            IX = X + 0.5
            IY = Y + 0.5
            IF ((IX.GT.1) .AND. (IX.LT.NX) .AND. (IY.GT.1) .AND.
     *         (IY.LT.NY)) THEN
               FSUM = FSUM + FLUX
               IF ((TYPE.EQ.0) .OR. ((TYPE.GT.0) .AND.
     *            (PARMS(1)*PARMS(2).EQ.0.0))) THEN
                  IX = X
                  IY = Y
                  X = X - IX
                  Y = Y - IY
                  IMAG(IX,IY) = IMAG(IX,IY) + (1.-X)*(1.-Y) * FLUX
                  IMAG(IX+1,IY) = IMAG(IX+1,IY) + X*(1.-Y) * FLUX
                  IMAG(IX,IY+1) = IMAG(IX,IY+1) + (1.-X)*Y * FLUX
                  IMAG(IX+1,IY+1) = IMAG(IX+1,IY+1) + X*Y * FLUX
               ELSE IF (TYPE.EQ.1) THEN
                  SR = SIN (PARMS(3)*DG2RAD)
                  CR = COS (PARMS(3)*DG2RAD)
                  AA = ((SR/PARMS(1))**2 + (CR/PARMS(2))**2) * AA0
                  BB = ((CR/PARMS(1))**2 + (SR/PARMS(2))**2) * BB0
                  CC = ((1.0/pARMS(2))**2 - (1.0/PARMS(1))**2) * SR * CR
     *               * CC0
                  NCNV = 4.0 * PARMS(1) / MIN (ABS(CATR(KRCIC)),
     *               ABS (CATR(KRCIC+1))) + 0.75
                  NCNV = NCNV / 2
                  IX1 = X + 1.0 - NCNV
                  IX1 = MAX (1, MIN (NX, IX1))
                  IX2 = X + NCNV
                  IX2 = MAX (1, MIN (NX, IX2))
                  IY1 = Y - NCNV
                  IY1 = MAX (1, MIN (NY, IY1))
                  IY2 = Y + NCNV
                  IY2 = MAX (1, MIN (NY, IY2))
                  SR = 0.0
                  DO 20 IY = IY1,IY2
                     DO 10 IX = IX1,IX2
                        D = (IX-X)*(IX-X)*AA + (IY-Y)*(IY-Y)*BB +
     *                     (IX-X)*(IY-Y)*CC
                        SR = SR + EXP (-D)
 10                     CONTINUE
 20                  CONTINUE
                  SR = FLUX / SR
                  DO 40 IY = IY1,IY2
                     DO 30 IX = IX1,IX2
                        D = (IX-X)*(IX-X)*AA + (IY-Y)*(IY-Y)*BB +
     *                     (IX-X)*(IY-Y)*CC
                        IMAG(IX,IY) = IMAG(IX,IY) + SR * EXP (-D)
 30                     CONTINUE
 40                  CONTINUE
                  END IF
               END IF
            END IF
 90      CONTINUE
      CALL TABCCM ('CLOS', CCBUFF, ICCRNO, CCKOLS, CCNUMV, NCOL, X,
     *   Y, Z, FLUX, TYPE, PARMS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING CC FILE'
         CALL MSGWRT (7)
         END IF
C                                       find max/min
      GSUM = 0.0
      FMAX = -1.E10
      FMIN = -FMAX
      DO 190 IY = 1,NY
         DO 180 IX = 1,NX
            FMIN = MIN (FMIN, IMAG(IX,IY))
            FMAX = MAX (FMAX, IMAG(IX,IY))
            GSUM = GSUM + ABS (IMAG(IX,IY))
 180        CONTINUE
 190     CONTINUE
      IF ((FMAX.LE.FMIN) .OR. (GSUM.EQ.0.0)) THEN
         IRET = 8
         MSGTXT = 'NO USEFUL CLEAN COMPONENTS FOUND'
         GO TO 990
         END IF
      WRITE (MSGTXT,1190) FSUM
      CALL MSGWRT (5)
      IF (TSUM.NE.FSUM) THEN
         WRITE (MSGTXT,1191) TSUM
         CALL MSGWRT (5)
         END IF
C                                       Setup for I/O
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OUTPUT IMAGE'
         GO TO 990
         END IF
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NX
      WINO(4) = NY
      IBLKOF = 1
      CALL MINIT ('WRIT', LUNO, INDO, NX, NY, WINO, BUFF2, JBUFSZ,
     *   IBLKOF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT OUTPUT I/O'
         GO TO 990
         END IF
C                                       Loop
      DO 220 IY = 1,NY
         CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT IMAGE'
            GO TO 990
            END IF
         CALL RCOPY (NX, IMAG(1,IY), BUFF2(OBIND))
 220     CONTINUE
      CALL MDISK ('FINI', LUNO, INDO, BUFF2, OBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINISH WRITING OUTPUT'
         GO TO 990
         END IF
C                                       Update CATBLK.
      CATR(KRDMX) = FMAX
      CATR(KRDMN) = FMIN
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', CCBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'UPDATING THE OUTPUT HEADER'
         GO TO 990
         END IF
      CALL ZCLOSE (LUNO, INDO, IRET)
C                                       totsl flux
      KEYW = 'CCFLUX'
      LOCS = 1
      KEYTYP = 2
      CALL CATKEY ('WRIT', DISKO, NEWCNO, KEYW, 1, LOCS, FSUM, KEYTYP,
     *   CCBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'UPDATING CCFLUX KEYWORD IN HEADER'
         IRET = 0
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CC2IMD: ERROR',I3,' ON ',A)
 1190 FORMAT ('Found',1PE12.4,' Jy in components')
 1191 FORMAT ('Total CC flux is different',1PE12.4)
      END
      SUBROUTINE CC2IMH
C-----------------------------------------------------------------------
C   CC2IMH copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, NOTTYP*2
      INTEGER   LUN1, LUN2, IERR
      LOGICAL   T
      INCLUDE 'CC2IM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NOTTYP /'CC'/
C-----------------------------------------------------------------------
C                                       don't copy keywords
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   CCBUFF(257), CCBUFF, IERR)
      IF (IERR.LE.2) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 20
C                                       New history
 10   CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, CCBUFF,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   CCBUFF, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       INVERS
      WRITE (HILINE,2000) TSKNAM, CCVER
      CALL HIADD (LUN2, HILINE, CCBUFF, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       CELLSIZE
      CELL(1) = CELL(1) * 3600.
      CELL(2) = CELL(2) * 3600.
      WRITE (HILINE,2001) TSKNAM, CELL
      CALL HIADD (LUN2, HILINE, CCBUFF, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       Close HI file
 20   CALL HICLOS (LUN2, T, CCBUFF, IERR)
C                                        Copy tables
      CALL ALLTAB (1, NOTTYP, LUN1, LUN2, DISKIN, DISKO, OLDCNO,
     *   NEWCNO, CATBLK, CCBUFF(257), CCBUFF, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', CCBUFF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CC2IMH: ERROR',I3,' COPY/OPEN HISTORY FILE')
 2000 FORMAT (A6,'INVERS =',I5,'     / CC table version')
 2001 FORMAT (A6,'CELLSIZ =',F7.2,',',F7.2)
      END

      SUBROUTINE CORR (APCORE, ISOPT, IN, VAL, WTIN, OUT, IERR)
C-----------------------------------------------------------------------
C! Tim Cornwell routine: Correlate a map with a beam.
C# Math Map AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2008, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CONV calculates the correlation of the map IN1 with the beam
C   and stores the answer in OUT. Note that this is distinct from
C   the convolution. The conjugate of the XFR is taken
C   Programmer =  T.J. Cornwell      January 1991
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   IN, OUT, IDIR, JLIM, FIL, KAP, WTIN, NEED
      REAL      VAL, RMAX, RMIN, RFACT, WREAL, WIMAG, R0
      LOGICAL   ISOPT
      INTEGER   AKOPEN, AKCESS, AKCLOS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DAPM.INC'
      DATA R0 /0.0/
C-----------------------------------------------------------------------
      IERR = 0
      RFACT = REAL(NX) * REAL(NY) * VAL
C                                       Convolve (radio)
      IF (.NOT.ISOPT) THEN
         NEED = 4 * HNX * HNY
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
            MSGTXT = 'CORR: CANNOT GET NEEDED PSEUDO-AP MEMORY AT 1'
            CALL MSGWRT (8)
            GO TO 990
            END IF
         CALL APCONV (APCORE, HNX, HNY, SCRNM(IN), SCRNM(WK2),
     *      SCRNM(WK3), SCRNM(OUT), SCRNM(WTIN), RFACT, BUFSZ(1),
     *      BUFFR1, BUFFR2, BUFFR3, RESMAX, RESMIN, IERR)
         CALL QRLSE
         IF (IERR.NE.0) GO TO 990
         GO TO 999
         END IF
C                                       Convolve (optical)
      CALL SMTOBG (IN, R0, WK1, IERR)
      IF (IERR.NE.0) GO TO 990
      FIL = WK1
C                                        Do FFT to get transform of IMG
      IDIR = 3
      NEED = 2 * NX * NY
      CALL QINIT (APCORE, NEED, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
         MSGTXT = 'CORR: CANNOT GET NEEDED PSEUDO-AP MEMORY AT 2'
         CALL MSGWRT (8)
         GO TO 990
         END IF
      CALL DSKFFT (APCORE, NX, NY, IDIR, T, SCRNM(FIL), SCRNM(WK3),
     *   SCRNM(WK2), BUFSZ(1), BUFFR1, BUFFR2, RMAX, RMIN, IERR)
      IF (IERR.EQ.0) GO TO 115
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 999
 115  CONTINUE
C
      CALL QRLSE
C
      IF (AKOPEN (WTIN, 1, 'READ', BUFFR1) .NE.0) GO TO 990
C
      VMSZ(1,WK2) = NY * 2
      VMSZ(2,WK2) = NX / 2 + 1
      IF (AKOPEN (WK2, 2, 'READ', BUFFR2) .NE.0) GO TO 990
      VMSZ(1,WK1) = NY * 2
      VMSZ(2,WK1) = NX / 2 + 1
      IF (AKOPEN (WK1, 3, 'WRIT', BUFFR3) .NE.0) GO TO 990
C                                       Begin loop thru map.
C                                       Normalise appropriately
      JLIM = NX / 2 + 1
      DO 125 IY = 1,JLIM
         IF (AKCESS (WTIN, BUFFR1) .NE.0) GO TO 990
         IF (AKCESS (WK2, BUFFR2) .NE.0) GO TO 990
         IF (AKCESS (WK1, BUFFR3) .NE.0) GO TO 990
         I1 = BIND(1)
         I2 = BIND(2)
         I3 = BIND(3)
      INCLUDE 'INCS:ZVND.INC'
         DO 120 IX = 1,NY
            WREAL = RFACT * BUFFR1(I1)
            WIMAG = RFACT * BUFFR1(I1+1)
            BUFFR3(I3)   = WREAL * BUFFR2(I2)   + WIMAG * BUFFR2(I2+1)
            BUFFR3(I3+1) = WREAL * BUFFR2(I2+1) - WIMAG * BUFFR2(I2)
            I1 = I1 + 2
            I2 = I2 + 2
            I3 = I3 + 2
 120        CONTINUE
 125     CONTINUE
      IF (AKCLOS (WTIN, BUFFR1) .NE.0) GO TO 990
      IF (AKCLOS (WK2, BUFFR2) .NE.0) GO TO 990
      IF (AKCLOS (WK1, BUFFR3) .NE.0) GO TO 990
C                                        FFT back to map plane
 128  IDIR = -1
C
      CALL QINIT (APCORE, NEED, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
         MSGTXT = 'CORR: CANNOT GET NEEDED PSEUDO-AP MEMORY AT 3'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C
      CALL DSKFFT (APCORE, NX, NY, IDIR, T, SCRNM(WK1), SCRNM(WK3),
     *   SCRNM(WK2), BUFSZ(1), BUFFR1, BUFFR2, RESMAX, RESMIN, IERR)
      IF (IERR.EQ.0) GO TO 130
         WRITE (MSGTXT,1180) IERR
         CALL MSGWRT (8)
         GO TO 999
 130  CONTINUE
C
      CALL QRLSE
C
      VMSZ(1,WK1) = NX
      VMSZ(2,WK1) = NY
      VMSZ(1,WK2) = NX
      VMSZ(2,WK2) = NY
C
      CALL BGTOSM (WK2, OUT, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C
 990  WRITE (MSGTXT,1010)
      CALL MSGWRT (8)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CORR: ERROR ',I3,' IN DSKFFT MAP TO U,V')
 1010 FORMAT ('CORR')
 1180 FORMAT ('CORR: ERROR ',I3,' IN DSKFFT U,V TO MAP')
      END

      SUBROUTINE YCURSE (OP, WAIT, CORR, RPOS, QUAD, BUTTON, IERR)
C-----------------------------------------------------------------------
C! read and control TV cursor
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YCURSE reads cursor positions and controls the blink and visibility
C   of the TV cursor.
C   Inputs:
C      OP      C*4     'READ' read cursor position
C                      'ONNN' place cursor at RPOS & leave on
C                      'OFFF' turn cursor off
C                      'BLNK' reverse sense of cursor blink
C                      'FXIT' fix RPOS for zoom scroll, no IO
C      WAIT    L       wait for event; then return RPOS & BUTTON
C                      (done on all OPs)
C      CORR    L       T => correct RPOS for zoom & scroll
C   In/Out:
C      RPOS    R(2)    X,Y screen pos before  zoom & scroll
C      QUAD    I       TV quadrant to use for scrolls
C                         In: if <1 >4, no scroll
C                         Out: if in=-1, no scroll, else find
C                              quadrant (needs real TV pos)
C   Output:
C      BUTTON  I       event # (0 none, 1-7 low buttons,
C                      8-15 the "quit" button)
C      IERR    I       error code of Z...XF : 0 - ok
C                                             2 - input error
C   Version for no TV at all - stubbed.
C-----------------------------------------------------------------------
      CHARACTER  OP*4
      REAL       RPOS(2)
      INTEGER    BUTTON, IERR, QUAD
      LOGICAL    WAIT, CORR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'YCURSE: THERE IS NO TV CONFIGURED'
      CALL MSGWRT (8)
C
 999  RETURN
      END

      SUBROUTINE ANSEL (DISKIN, CNOIN, DISKOU, CNOOUT, IVER, OVER,
     *   CATUV, CATBLK, LUN1, LUN2, BIF, EIF, FQOFF, DOPOL, BUFF1,
     *   BUFF2, IRET)
C-----------------------------------------------------------------------
C! copies AN table adjusting ref freq and number of IFs
C# subroutine editing UV
C-----------------------------------------------------------------------
C;  Copyright (C) 2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Updates tables for selection by IF etc
C   Inputs:
C      DISKIN   I        Input disk number
C      CNOIN    I        Input catalog number
C      DISKOU   I        Output disk number
C      CNOOUT   I        Output catalog number
C      IVER     I        input version number to copy
C      OVER     I        output version number to write
C      CATUV    I(256)   input header
C      LUN1     I        LUN to use
C      LUN2     I        LUN to use
C      BIF      I        Beginning IF
C      EIF      I        Ending IF
C      FQOFF    D        Frequency offset to apply to header FREQ
C      DOPOL    I        > 0 => pol cal applied, clear values
C   In/out
C      CATBLK   I(256)   Output uv header (AN files added)
C      BUFF1    I(512)   Scratch
C      BUFF2    I(512)   Scratch
C   Output:
C      IRET     I        Return code, 0=>OK
C-----------------------------------------------------------------------
      INTEGER   DISKIN, CNOIN, DISKOU, CNOOUT, IVER, OVER, CATUV(*),
     *   CATBLK(*), LUN1, LUN2, BIF, EIF, dopol, BUFF1(*), BUFF2(*),
     *   IRET
      DOUBLE PRECISION FQOFF
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   I, J, NANT, ANOPEN, JI, JO, MSGSAV, ANKOL2(MAXANC),
     *   ANNUM2(MAXANC), KNUM, MLOC, KTYP, IERR
      HOLLERITH HSOLT(2)
      LOGICAL   REFRMT
      CHARACTER BLANK*8
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANT.INC'
C-----------------------------------------------------------------------
      MSGSAV = MSGSUP
C                                       open input
      ANOPEN = 0
      CALL ANTINI ('READ', BUFF1, DISKIN, CNOIN, IVER, CATUV, LUN1,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN INPUT'
         GO TO 990
         END IF
      ANOPEN = 1
      REFRMT = (FQOFF.NE.0.0D0) .OR. (ANTNIF.NE.EIF-BIF+1)
C                                       adjust and open output
      ANTNIF = EIF - BIF + 1
      SAFREQ = SAFREQ + FQOFF
      CALL ANTINI ('WRIT', BUFF2, DISKOU, CNOOUT, OVER, CATBLK, LUN2,
     *   IANRNO, ANKOL2, ANNUM2, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OUTPUT'
         GO TO 990
         END IF
      ANOPEN = 2
C                                       copy
      NANT = BUFF1(5)
      DO 20 I = 1,NANT
         IANRNO = I
         CALL TABAN ('READ', BUFF1, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ INPUT'
            GO TO 990
            END IF
         JO = 1
         JI = 2 * (BIF-1) + 1
         IF (REFRMT) THEN
            DO 10 J = 1,ANTNIF
               FWHMAN(J) = FWHMAN(J+BIF-1)
               POLCA(JO)   = POLCA(JI)
               POLCA(JO+1) = POLCA(JI+1)
               POLCB(JO)   = POLCB(JI)
               POLCB(JO+1) = POLCB(JI+1)
               JI = JI + 2
               JO = JO + 2
 10            CONTINUE
            END IF
C                                       clear if applied
         IF (DOPOL.GT.0) THEN
            CALL RFILL (2*ANTNIF, 0.0, POLCA)
            CALL RFILL (2*ANTNIF, 0.0, POLCB)
            POLAA = 0.0
            POLAB = 0.0
            END IF
         IANRNO = I
         CALL TABAN ('WRIT', BUFF2, IANRNO, ANKOL2, ANNUM2, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT'
            GO TO 990
            END IF
 20      CONTINUE
C                                       Check polzn solution type
      KNUM = 1
      MLOC = 1
      KTYP = 3
      MSGSUP = 32000
      CALL TABKEY ('READ', 'POLTYPE ', KNUM, BUFF1, MLOC, HSOLT, KTYP,
     *   IERR)
      MSGSUP = MSGSAV
      IF (IERR.EQ.0) THEN
         IF (DOPOL.GT.0) THEN
            BLANK = ' '
            CALL CHR2H (8, BLANK, 1, HSOLT)
            END IF
         CALL TABKEY ('WRIT', 'POLTYPE ', KNUM, BUFF2, MLOC, HSOLT,
     *      KTYP, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         IF (REFRMT) THEN
            WRITE (MSGTXT,1020) 'Reformatted AN', DISKIN, CNOIN, IVER,
     *         DISKOU, CNOOUT, OVER
         ELSE
            WRITE (MSGTXT,1020) 'Copied AN', DISKIN, CNOIN, IVER,
     *         DISKOU, CNOOUT, OVER
            END IF
         CALL MSGWRT (3)
         END IF

C
 990  IF (IRET.NE.0) CALL MSGWRT (8)
      IF (ANOPEN.GT.0) CALL TABAN ('CLOS', BUFF1, IANRNO, ANKOLS,
     *   ANNUMV, ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN,
     *   FWHMAN, POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, I)
      IF (ANOPEN.GT.1) CALL TABAN ('CLOS', BUFF2, IANRNO, ANKOL2,
     *   ANNUM2, ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN,
     *   FWHMAN, POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, I)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ANSEL ERROR:',I5,' ON ',A,' AN TABLE')
 1020 FORMAT (A,' file from vol/cno/vers',I3,I5,I4,' to',I3,I5,I4)
       END

      SUBROUTINE DSCAL (N, DA, DX, INCX)
C-----------------------------------------------------------------------
C! Multiplies a DP vector by a constant.
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C     SCALES A VECTOR BY A CONSTANT.
C     USES UNROLLED LOOPS FOR INCREMENT EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C-----------------------------------------------------------------------
      DOUBLE PRECISION DA, DX(*)
      INTEGER   I, INCX, M, MP1, N, NINCX
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
      IF (INCX.EQ.1)GO TO 20
C
C        CODE FOR INCREMENT NOT EQUAL TO 1
C
      NINCX = N*INCX
      DO 10 I = 1,NINCX,INCX
        DX(I) = DA*DX(I)
   10 CONTINUE
      GO TO 999
C
C        CODE FOR INCREMENT EQUAL TO 1
C
C        CLEAN-UP LOOP
C
   20 M = MOD (N, 5)
      IF (M.EQ.0) GO TO 40
      DO 30 I = 1,M
        DX(I) = DA*DX(I)
   30 CONTINUE
      IF (N.LT.5) GO TO 999
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
        DX(I) = DA*DX(I)
        DX(I + 1) = DA*DX(I + 1)
        DX(I + 2) = DA*DX(I + 2)
        DX(I + 3) = DA*DX(I + 3)
        DX(I + 4) = DA*DX(I + 4)
   50 CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'RSPEC.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQIN, DISKIN, CNOIN, NUMHIS, JBUFSZ, LUNI, INDI,
     *   WIN(4), PVER, GLUN, GFIND, PLBUFF(256), ZINC, LTYPE, NZI,
     *   NPARM, GRCHN, TVCHN, TVCORN(4), LUNP, FINDP, BUFFER(256),
     *   IPCNT, PAGE, NACROS, NGOOD, SEQOU, DISKOU, CNOUT, CATIN(256),
     *   LUNO, INDO, ILABEL, NBOXES, GR2CHN
      LOGICAL   DOTV, FLUXFL, INVERT, OBLANK, DOWEIT, ISFQID
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMEO(3), XCLAOU(2), XLPNAM(12),
     *   XOPTYP, XOPCOD
      CHARACTER NAMEIN*12, CLAIN*6, HISCRD(10)*64, LPNAME*48, TITL1*132,
     *   TITL2*132, LINE*132, SCRTCH*132, OPTYPE*4, NAMEOU*12, CLAOU*6,
     *   OPCODE*4
      REAL      USERID, XSEQIN, XDISKI, BLC(7), TRC(7), XNBOXS,
     *   BOX(4,50), DOINV, DOOUT, XOUTS, XOUTD, PIXR(2), XZINC,
     *   XSMOTH(3), XLTYPE, DOCENT, XDOTV, XGRCH, DOSLIC, XYRATO, XSUM,
     *   BUFF1(MABFSS), RANGE(2), DBUFF(MAXIMG), DOCRT, CBAREA, DSUM,
     *   FSUM, BUFF2(MABFSS), OMAX, OMIN, WEIMAX
      DOUBLE PRECISION FRQS(MAXIMG), PSUM
      COMMON /INPARM/ USERID, XNAMEI, XCLAIN, XSEQIN, XDISKI, BLC, TRC,
     *   XNBOXS, BOX, DOINV, XOPTYP, XOPCOD, DOOUT, XNAMEO, XCLAOU,
     *   XOUTS, XOUTD, PIXR, XZINC, XSMOTH, XLTYPE, DOCENT, XDOTV,
     *   XGRCH, DOCRT, XLPNAM, DOSLIC, XYRATO
      COMMON /CHPARM/ NAMEIN, CLAIN, OPTYPE, OPCODE, NAMEOU, CLAOU,
     *   HISCRD, LPNAME, TITL1, TITL2, LINE, SCRTCH
      COMMON /PARMS/ FRQS, PSUM, CATIN, RANGE, SEQIN, DISKIN, CNOIN,
     *   LUNI, INDI, ZINC, LTYPE, JBUFSZ, NUMHIS, WIN, PVER, GLUN,
     *   GFIND, NZI, NPARM, GRCHN, TVCHN, TVCORN, DOTV, LUNP, FINDP,
     *   IPCNT, PAGE, NACROS, CBAREA, FLUXFL, INVERT, FSUM, DSUM, XSUM,
     *   NGOOD,SEQOU, DISKOU, CNOUT, LUNO, INDO, OMIN, OMAX, OBLANK,
     *   DOWEIT, WEIMAX, ISFQID, ILABEL, NBOXES, GR2CHN
      COMMON /BUFRS/ PLBUFF, BUFF1, BUFF2, DBUFF, BUFFER
LOCAL END
      PROGRAM RSPEC
C-----------------------------------------------------------------------
C! Task to plot the spectrum of rms, write S/N image
C# Map-util Utility Spectral Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 2010-2012, 2014-2017, 2020-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   RSPEC allows a user to specify a region or pixel and then will
C   generate the spectrum of the rms of that region.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      PIXRANGE       PIXR          Range of intensities to plot
C      ZINC           ZINC          Increment on freq axis
C      LTYPE          LTYPE         Type of labelling
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, IERR
      INTEGER I
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'RSPEC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      DATA PRGM /'RSPEC '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL ISPCIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Obtain spectrum
      CALL GETSPC (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       HI, etc for output image
      IF (DOOUT.GT.0.0) CALL RSPECH
      CALL COPY (256, CATIN, CATBLK)
C                                       recalculate RMS to weight and
C                                       calculate maximum weight;
C                                       normalize by this maximum
      IF (DOWEIT) THEN
         WEIMAX = 1.E-10
         DO 25 I = 1,NZI,ZINC
            IF (DBUFF(I) .NE. 0) DBUFF(I) = 1/(DBUFF(I)**2)
            WEIMAX = MAX(WEIMAX, DBUFF(I))
   25       CONTINUE
C
         RANGE(1) = 1.0E20
         RANGE(2) = -1.0E20
         DO 30 I = 1,NZI,ZINC
            IF (DBUFF(I).NE.FBLANK) THEN
               DBUFF(I) = DBUFF(I) / WEIMAX * 100
C                                       min,max for TV
               RANGE(1) = MIN(RANGE(1), DBUFF(I))
               RANGE(2) = MAX(RANGE(2), DBUFF(I))
               END IF
   30       CONTINUE
         END IF
C                                       Obtain spectrum
      IF (DOSLIC.GT.0.0) THEN
         CALL SLISPC (IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
C                                       Plot it
      CALL PLTSCH (IRET)
      CALL PLTSPC (IRET)
C                                       Close printer
      IF (DOCRT.NE.0.0) THEN
         CALL LPCLOS (LUNP, FINDP, IPCNT, IERR)
         IF (IRET.EQ.0) IRET = IERR
         END IF
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE ISPCIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   ISPCIN gets input parameters for RSPEC, creates 'PL' file and
C   sets up scaling etc.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                      4 => user routine detected error.
C                      5 => catalog troubles
C                      8 => can't start
C   Commons:
C      /INPARM/ all input adverbs in order given by INPUTS file
C      /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, MTYPE*2, UNITS*8, CBLANK*8, CTEMP*8
      INTEGER   IROUND, IUSER, DEPTH(5), NFQ, ORDER, I, J
      REAL      TEMP
      DOUBLE PRECISION DTEMP
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'RSPEC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      DATA DEPTH /5*1/
      DATA CBLANK /' '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      TSKNAM = PRGN
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 259
      CALL GTPARM (PRGN, NPARM, RQUICK, USERID, BUFF1, IRET)
      CALL H2CHR (48, 1, XLPNAM, LPNAME)
      IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) THEN
         IF (DOCRT.NE.0.0) DOCRT = MIN (-1.0, DOCRT)
         END IF
      IF (DOCRT.GT.0.0) RQUICK = .FALSE.
      IF ((DOCRT.NE.0.0) .AND. (RQUICK)) RQUICK = LPNAME.NE.' '
      IF (IRET.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IRET.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IRET
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IUSER)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      IF ((OPTYPE.NE.'LOW') .AND. (OPTYPE.NE.'MEDI')) OPTYPE = ' '
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
C
      DOWEIT = OPCODE .EQ. 'WEIT'
      CALL CHR2H (4, OPTYPE, 1, XOPTYP)
      IF (XYRATO.LE.0.0) XYRATO = 1.3
C                                       Crunch input parameters.
      USERID = NLUSER
      IUSER = NLUSER
      SEQIN = IROUND (XSEQIN)
      DISKIN = IROUND (XDISKI)
      INVERT = XZINC.LT.0.0
      ZINC = IROUND (XZINC)
      ZINC = ABS (ZINC)
      IF (ZINC.LE.0) ZINC = 1
      XZINC = ZINC
      IF (INVERT) XZINC = -XZINC
      LTYPE = IROUND (XLTYPE)
      ILABEL = MOD (ABS(LTYPE), 100)
      IF ((ILABEL.EQ.0) .OR. (ILABEL.GT.10)) THEN
         ILABEL = 3
         IF (LTYPE.GE.0) THEN
            LTYPE = (LTYPE/100) * 100 + ILABEL
         ELSE
            LTYPE = (LTYPE/100) * 100 - ILABEL
            END IF
         END IF
      XLTYPE = LTYPE
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      GR2CHN = GRCHN / 10
      GRCHN = MOD (GRCHN, 10)
      IF (GR2CHN.EQ.0) GR2CHN = MAX (1, GRCHN)
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
C                                       Open map file and get
C                                       CATBLK
      LUNI = 16
      MTYPE = 'MA'
      STAT = 'HDWR'
      IF ((DOTV) .AND. (DOSLIC.LE.0.0)) STAT = 'READ'
      CALL MAPOPN (STAT, DISKIN, NAMEIN, CLAIN, SEQIN, MTYPE, IUSER,
     *   LUNI, INDI, CNOIN, CATBLK, BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL COPY (256, CATBLK, CATIN)
      NCFILE = 1
      FVOL(1) = DISKIN
      FCNO(1) = CNOIN
      FRW(1) = 1
      IF (STAT.EQ.'READ') FRW(1) = 0
C                                       Check number of planes
      IF (BLC(3).EQ.TRC(3)) THEN
         TRC(3) = 0
         BLC(3) = 0
         END IF
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IRET)
C                                       BOXes ?
      NBOXES = XNBOXS + 0.1
C                                       make 1
      IF (NBOXES.LE.0) THEN
         NBOXES = 1
         XNBOXS = 1.0
         BOX(1,1) = BLC(1)
         BOX(2,1) = BLC(2)
         BOX(3,1) = TRC(1)
         BOX(4,1) = TRC(2)
C                                       find range
      ELSE
         BLC(2) = CATBLK(KINAX+1)
         TRC(2) = 1.0
         DO 20 I = 1,NBOXES
C                                       circular
            IF (BOX(1,I).LT.0.0) THEN
               TRC(2) = MAX (TRC(2), BOX(4,I)+BOX(2,I))
               BLC(2) = MIN (BLC(2), BOX(4,I)-BOX(2,I))
            ELSE
               TRC(2) = MAX (TRC(2), BOX(4,I))
               BLC(2) = MIN (BLC(2), BOX(2,I))
               END IF
 20         CONTINUE
         END IF
      BLC(1) = 1.0
      TRC(1) = CATBLK(KINAX)
      BLC(2) = 1.0
      TRC(2) = CATBLK(KINAX+1)
C                                       check coordinates
      LOCNUM = 1
      CALL SETLOC (DEPTH, .TRUE.)
      CALL H2CHR (8, 1, CATH(KHBUN), UNITS)
      CALL CHLTOU (8, UNITS)
      TEMP = CATR(KRCIC) * CATR(KRCIC+1)
      CBAREA = 1.1331 * CATR(KRBMJ) * CATR(KRBMN)
      FLUXFL = (AXTYP(LOCNUM).EQ.1) .AND. (UNITS.EQ.'JY/BEAM') .AND.
     *   (TEMP.NE.0.0) .AND. (CBAREA.GT.0.0)
      IF (FLUXFL) THEN
         CBAREA = CBAREA / ABS (TEMP)
      ELSE
         CBAREA = 1.0
         END IF
C                                       Set the I/O windows used by
C                                       MINIT/MDISK
      IF (IRET.EQ.0) THEN
         WIN(1) = IROUND(BLC(1))
         WIN(2) = IROUND(BLC(2))
         WIN(3) = IROUND(TRC(1))
         WIN(4) = IROUND(TRC(2))
         END IF
C                                       Open printer
      IF (DOCRT.NE.0.0) THEN
         PAGE  = 0
         IPCNT = 980
         TITL1 = ' '
         TITL2 = ' '
         LINE  = ' '
         IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
         CALL LPOPEN (LPNAME, DOCRT, LUNP, FINDP, NACROS, BUFFER, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET
            IRET = 1
            GO TO 990
            END IF
         END IF
C                                       FQID axis?
      CALL H2CHR (8, 1, CATH(KHCTP+4), CTEMP)
      ISFQID = CTEMP.EQ.'FQID'
      IF (ISFQID) THEN
         CALL FRQGET (DISKIN, CNOIN, NFQ, ORDER, FRQS, IRET)
         IF ((IRET.NE.0) .OR. (ABS(ORDER).NE.1)) THEN
            MSGTXT = 'FQID AXIS NOT CHANGED TO FREQUENCIES'
            CALL MSGWRT (7)
            ISFQID = .FALSE.
         ELSE
            NZI = TRC(3) - BLC(3) + 1.1
            J = BLC(3) - 0.5
            DO 50 I = 1,NZI
               FRQS(I) = FRQS(I+J)
 50            CONTINUE
            IF (INVERT) THEN
               DO 60 I = 1,NZI/2
                  DTEMP = FRQS(I)
                  FRQS(I) = FRQS(NZI+1-I)
                  FRQS(NZI+1-I) = DTEMP
 60               CONTINUE
               END IF
            END IF
         END IF
C                                       create output image
      IF (DOOUT.GT.0.0) THEN
         OBLANK = .FALSE.
         OMIN = 1.E10
         OMAX = -1.E10
         LUNO = 17
         CALL H2CHR (12, 1, XNAMEO, NAMEOU)
         CALL H2CHR (6, 1, XCLAOU, CLAOU)
         SEQOU = XOUTS + 0.1
         DISKOU = XOUTD + 0.1
C                                       Build new file cat name.
         CALL MAKOUT (NAMEIN, CLAIN, SEQIN, CBLANK, NAMEOU, CLAOU,
     *      SEQOU)
C                                       Set header values needed
C                                       by MCREAT.
         CALL SUBHDR (BLC, TRC, 1.0, 1.0)
         CALL CHR2H (12, NAMEOU, KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, CLAOU, KHIMCO, CATH(KHIMC))
         CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
         CATBLK(KIIMS) = SEQOU
C                                       Create new cataloged file.
         CALL MCREAT (DISKOU, CNOUT, DBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         SEQOU = CATBLK(KIIMS)
C                                       save adverbs
         XOUTS = SEQOU
         XOUTD = DISKOU
         CALL CHR2H (12, NAMEOU, 1, XNAMEO)
         CALL CHR2H (6, CLAOU, 1, XCLAOU)
C                                       Copy any header keywords
         CALL KEYCOP (DISKIN, CNOIN, DISKOU, CNOUT, IRET)
         CALL MAPOPN ('INIT', DISKOU, NAMEOU, CLAOU, SEQOU, MTYPE,
     *      IUSER, LUNO, INDO, CNOUT, CATBLK, BUFF2, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1110) IRET, NAMEOU, CLAOU, SEQOU, DISKOU,
     *         NLUSER
            GO TO 990
            END IF
         NCFILE = 2
         FVOL(2) = DISKOU
         FCNO(2) = CNOUT
         FRW(1) = 2
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ISPCIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1080 FORMAT ('ISPCIN: ERROR ',I3,' OPENING OUTPUT ''PRINT'' DEVICE')
 1100 FORMAT ('ISPCIN: ERROR ',I4,' CREATING OUTPUT IMAGE CUBE')
 1110 FORMAT ('ERROR',I3,' OPENING ',A12,'.',A6,'.',I3,' DISK',
     *   I3,' USID',I5,' OUTPUT')
      END
      SUBROUTINE GETSPC (IRET)
C-----------------------------------------------------------------------
C   GETSPC fills up the plotting buffer with the spectrum to be plotted
C   this is then passed to the plotting routine via common.
C   Output:
C      IRET   I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   NYI, NXI, BOI, LIMO, LIM2, I3, NX, NY, IPOS(7), BOTEMP,
     *   NWORDS, K, OPOS(7), NXO, NYO, WINO(4), IMPIX
      REAL      MAPBUF(2), WRKBUF(2), MSKBUF(2)
      LONGINT   PMAPB, PWORK, PMASK
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'RSPEC.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      K = 2
      IF (OPTYPE.EQ.'LOW') K = 1
C                                       Setup for I/O
      NXI = CATIN(KINAX)
      NYI = CATIN(KINAX+1)
      NZI = TRC(3) - BLC(3) + 1.01
      CALL RFILL (NZI, 0.0, DBUFF)
      DSUM = 0.0
      FSUM = 0.0
      XSUM = 0.0
      PSUM = 0.0D0
      NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
C                                       define work space
      NX = TRC(1) - BLC(1) + 1.01
      NY = TRC(2) - BLC(2) + 1.01
      NWORDS = (NX * NY - 1) / 1024 + 2
      CALL ZMEMRY ('GET ', 'GETSPC', NWORDS, MAPBUF, PMAPB, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET REQUIRED DYNAMIC MEMORY'
         GO TO 990
         END IF
      CALL ZMEMRY ('GET ', 'GETSPC', NWORDS, WRKBUF, PWORK, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET REQUIRED DYNAMIC MEMORY'
         GO TO 990
         END IF
      CALL ZMEMRY ('GET ', 'GETSPC', NWORDS, MSKBUF, PMASK, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET REQUIRED DYNAMIC MEMORY'
         GO TO 990
         END IF
C                                       Setup for looping
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIMO = CATIN(KINAX) - 1
      RANGE(1) = 1.0E20
      RANGE(2) = -1.0E20
C                                       Loop
      IPOS(7) = BLC(7) + 0.01
      IPOS(6) = BLC(6) + 0.01
      IPOS(5) = BLC(5) + 0.01
      IPOS(4) = BLC(4) + 0.01
      CALL FILL (7, 1, OPOS)
      DO 300 I3 = 1,NZI
         IF (INVERT) THEN
            IPOS(3) = BLC(3) + NZI - I3 + 0.1
            OPOS(3) = NZI - I3 + 1
         ELSE
            IPOS(3) = BLC(3) + I3 - 0.9
            OPOS(3) = I3
            END IF
C                                       Init. files, first input.
         CALL COMOFF (CATIN(KIDIM), CATIN(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET
            GO TO 990
            END IF
         BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WIN, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'READ', IRET
            GO TO 990
            END IF
C                                       make mask
         CALL MASKIT (NX, NY, NBOXES, BOX, DOINV, MSKBUF(1+PMASK))
C                                       find rms
         IF (OPTYPE.EQ.'MEDI') THEN
            CALL RSRMSM (NX, NY, LUNI, INDI, BUFF1, MAPBUF(1+PMAPB),
     *         MSKBUF(1+PMASK), WRKBUF(1+PWORK), DBUFF(I3), IMPIX, IRET)
         ELSE
            CALL RSRMS (K, NX, NY, LUNI, INDI, BUFF1, MAPBUF(1+PMAPB),
     *         MSKBUF(1+PMASK), DBUFF(I3), IMPIX, IRET)
            END IF
C                                       check for blanked pixels
         IF (IRET.GT.0) THEN
            MSGTXT = 'RSRMS RETURNS ERROR CODE'
            GO TO 990
         ELSE IF (IRET.LT.0) THEN
            DBUFF(I3) = FBLANK
            IRET = 0
         ELSE
            PSUM = PSUM + IMPIX
            FSUM = FSUM + DBUFF(I3)
            XSUM = XSUM + 1.0
            DSUM = DSUM + DBUFF(I3) * DBUFF(I3)
            RANGE(1) = MIN (DBUFF(I3), RANGE(1))
            RANGE(2) = MAX (DBUFF(I3), RANGE(2))
            END IF
C                                       Init. files, first input.
         IF (DOOUT.GT.0.0) THEN
            CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WIN, BUFF1,
     *         JBUFSZ, BOI, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1100) 'READ', IRET
               GO TO 990
               END IF
            CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), OPOS(3), BOTEMP,
     *         IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET
               GO TO 990
               END IF
            BOI = BOTEMP + 1
            CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO, BUFF2,
     *         JBUFSZ, BOI, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1100) 'WRIT', IRET
               GO TO 990
               END IF
            CALL RSPECO (NX, NY, LUNI, INDI, LUNO, INDO, BUFF1, BUFF2,
     *         MAPBUF(1+PMAPB), DBUFF(I3), OMIN, OMAX, OBLANK, IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
 300     CONTINUE
C                                       Close input map.
      CALL ZCLOSE (LUNI, INDI, I3)
      CALL ZMEMRY ('FREE', 'GETSPC', NWORDS, MAPBUF, PMAPB, I3)
      CALL ZMEMRY ('FREE', 'GETSPC', NWORDS, WRKBUF, PWORK, I3)
      CALL ZMEMRY ('FREE', 'GETSPC', NWORDS, MSKBUF, PMASK, I3)
      IF (DOOUT.GT.0.0) THEN
         CATR(KRDMX) = OMAX
         CATR(KRDMN) = OMIN
         CATR(KRBLK) = 0.0
         IF (OBLANK) CATR(KRBLK) = FBLANK
         CALL CHR2H (8, 'SIG/NOIS', 1, CATH(KHBUN))
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETSPC: COMOFF ERROR',I3)
 1100 FORMAT ('GETSPC: INIT-FOR-',A4,' ERROR',I3)
      END
      SUBROUTINE MASKIT (NX, NY, NBOXES, BOX, DOINV, MASK)
C-----------------------------------------------------------------------
C   Construct mask: 0 blank pixel, 1 keep pixel
C   Inputs:
C      NX      I      Number X points
C      NY      I      Number Y points
C      NBOXES  I      Number boxes
C      BOX     R(4,*) Boxes
C      DOINV   R      > 0 outside areas
C   Output
C      MASK    R(NX,NY)   mask
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NBOXES
      REAL      BOX(4,*), DOINV, MASK(NX,*)
C
      INTEGER   IB, IX1, IX2, IY1, IY2, IROUND, IY, IX
      REAL      VALIN, VALOU, RY, RB, R
C-----------------------------------------------------------------------
      IF (DOINV.GT.0.0) THEN
         VALOU = 1.0
         VALIN = 0.0
      ELSE
         VALOU = 0.0
         VALIN = 1.0
         END IF
      DO 10 IY = 1,NY
         CALL RFILL (NX, VALOU, MASK(1,IY))
 10      CONTINUE
C                                       loop over mask
      DO 50 IY = 1,NY
         DO 40 IX = 1,NX
            DO 30 IB = 1,NBOXES
               IF (BOX(1,IB).GT.0.0) THEN
                  IX1 = IROUND (BOX(1,IB))
                  IY1 = IROUND (BOX(2,IB))
                  IX2 = IROUND (BOX(3,IB))
                  IY2 = IROUND (BOX(4,IB))
                  IF ((IX.GE.IX1) .AND. (IX.LE.IX2) .AND. (IY.GE.IY1)
     *               .AND. (IY.LE.IY2)) THEN
                     MASK(IX,IY) = VALIN
                     END IF
               ELSE
                  RB = BOX(2,IB)**2
                  RY = (IY-BOX(4,IB))**2
                  R = RY + (IX-BOX(3,IB))**2
                  IF (R.LE.RB) THEN
                     MASK(IX,IY) = VALIN
                     END IF
                  END IF
 30            CONTINUE
 40         CONTINUE
 50      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE RSRMS (K, NX, NY, LUN, IND, BUFF, IMAGE, MASK, RMS,
     *   NPIX, IRET)
C-----------------------------------------------------------------------
C   RSRMS deterimes the RMS in an image plane
C   Inputs:
C      K       I      1 => tight fit, 2 => more slack
C      NX      I      Number X points
C      NY      I      Number Y points
C      LUN     I      Open LUN - MINIT already called
C      IND     I      FTAB pointer
C      MASK    R(NX,NY)   mask
C   Output:
C      BUFF    R(*)   I/O buffer
C      IMAGE   R(NX,NY)   image work space
C      RMS     R          RMS
C      NPIX    I          Number pixels considered
C      IRET    I          Error code: 0 good, -1 failed, > 0 I/O error
C-----------------------------------------------------------------------
      INTEGER   K, NX, NY, LUN, IND, NPIX, IRET
      REAL      BUFF(*), IMAGE(NX,NY), MASK(NX,NY), RMS
C
      INTEGER   IX, IY, L, NS, IBIND
      DOUBLE PRECISION SV, SS, V, VMIN, VMAX, VM(10,2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA VM / 6.D0, 5.D0, 4.D0, 3.D0, 2.8D0, 2.6D0, 2.4D0, 2.D0,
     *   1.5D0, 1.5D0, 6.D0, 5.D0, 4.5D0, 4.D0, 3.6D0, 3.2D0, 3.D0,
     *   2.8D0, 2.5D0, 2.5D0/
C-----------------------------------------------------------------------
      IF (K.NE.1) K = 2
C                                       read in the image
      DO 20 IY = 1,NY
         CALL MDISK ('READ', LUN, IND, BUFF, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, IY
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 10 IX = 1,NX
            IF (MASK(IX,IY).EQ.0.0) THEN
               IMAGE(IX,IY) = FBLANK
            ELSE
               NPIX = NPIX + 1
               IMAGE(IX,IY) = BUFF(IBIND+IX-1)
               END IF
 10         CONTINUE
 20      CONTINUE
      VMIN = -1.D10
      VMAX = 1.D10
      DO 80 L = 1,8
         SV = 0.0D0
         SS = 0.0D0
         NS = 0
         DO 70 IY = 1,NY
            DO 60 IX = 1,NX
               IF (IMAGE(IX,IY).NE.FBLANK) THEN
                  V = IMAGE(IX,IY)
                  IF ((V.GE.VMIN) .AND. (V.LE.VMAX)) THEN
                     SV = SV + V
                     SS = SS + V * V
                     NS = NS + 1
                     END IF
                  END IF
 60            CONTINUE
 70         CONTINUE
         IF (NS.LE.1) THEN
            IRET = -1
            GO TO 999
         ELSE
            SV = SV / NS
            SS = SS / NS - SV * SV
            SS = SQRT (MAX (0.0D0, SS))
            VMIN = SV - SS * VM(L,K)
            VMAX = SV + SS * VM(L,K)
            END IF
 80      CONTINUE
      RMS = SS
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MDISK   ERROR',I4,' READING ROW ',I6)
      END
      SUBROUTINE RSRMSM (NX, NY, LUN, IND, BUFF, IMAGE, MASK, WORK, RMS,
     *   NPIX, IRET)
C-----------------------------------------------------------------------
C   RSRMSM deterimes the RMS in an image plane - Wirth median method
C   Inputs:
C      NX      I          Number X points
C      NY      I          Number Y points
C      LUN     I          Open LUN - MINIT already called
C      IND     I          FTAB pointer
C   Output:
C      BUFF    R(*)       I/O buffer
C      IMAGE   R(NX,NY)   image work space
C      RMS     R          RMS
C      NPIX    I          Number pixels considered
C      IRET    I          Error code: 0 good, -1 failed, > 0 I/O error
C-----------------------------------------------------------------------
      INTEGER   NX, NY, LUN, IND, NPIX, IRET
      REAL      BUFF(*), IMAGE(NX,*), MASK(NX,*), WORK(*), RMS
C
      INTEGER   IX, IY, L, IBIND
      REAL      VMED, MEDIAN
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      NPIX = 0
C                                       read in the image
      DO 20 IY = 1,NY
         CALL MDISK ('READ', LUN, IND, BUFF, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, IY
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 10 IX = 1,NX
            IF (MASK(IX,IY).EQ.0.0) THEN
               IMAGE(IX,IY) = FBLANK
            ELSE
               IMAGE(IX,IY) = BUFF(IBIND+IX-1)
               NPIX = NPIX + 1
               END IF
 10         CONTINUE
 20      CONTINUE
C                                       get valid points
      L = 0
      DO 60 IY = 1,NY
         DO 55 IX = 1,NX
            IF (IMAGE(IX,IY).NE.FBLANK) THEN
               L = L + 1
               WORK(L) = IMAGE(IX,IY)
               END IF
 55         CONTINUE
 60      CONTINUE
C                                       all blanked?
      IF (L.LE.0) THEN
         IRET = -1
         GO TO 999
         END IF
C                                       get median
      VMED = MEDIAN (L, WORK)
C                                       convert to difference
      L = 0
      DO 70 IY = 1,NY
         DO 65 IX = 1,NX
            IF (IMAGE(IX,IY).NE.FBLANK) THEN
               L = L + 1
               WORK(L) = ABS (IMAGE(IX,IY) - VMED)
               END IF
 65         CONTINUE
 70      CONTINUE
C                                       get this median
      VMED = MEDIAN (L, WORK)
      RMS = 1.4826 * VMED
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MDISK   ERROR',I4,' READING ROW ',I6)
      END
      SUBROUTINE RSPECO (NX, NY, LUNI, INDI, LUNO, INDO, BUFFI, BUFFO,
     *   IMAGE, RMS, OMIN, OMAX, OBLANK, IRET)
C-----------------------------------------------------------------------
C   RSPECO writes out the image
C   Inputs:
C      NX      I          Number X points
C      NY      I          Number Y points
C      LUN     I          Open LUN - MINIT already called
C      IND     I          FTAB pointer
C      IMAGE   R(NX,NY)   image work space
C      RMS     R          RMS
C   In/out
C      OMIN    R          Min output
C      OMAX    R          Max output
C      OBLANK  L          blanked?
C   Output:
C      BUFF    R(*)       I/O buffer
C      IRET    I          Error code: 0 good, -1 failed, > 0 I/O error
C-----------------------------------------------------------------------
      INTEGER   NX, NY, LUNI, INDI, LUNO, INDO, IRET
      REAL      BUFFI(*), BUFFO(*), IMAGE(*), RMS, OMIN, OMAX
      LOGICAL   OBLANK
C
      INTEGER   IX, IY, L, IBIND
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       read in the image
      L = 1
      DO 10 IY = 1,NY
         CALL MDISK ('READ', LUNI, INDI, BUFFI, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, IY
            CALL MSGWRT (8)
            GO TO 999
            END IF
         CALL RCOPY (NX, BUFFI(IBIND), IMAGE(L))
         L = L + NX
 10      CONTINUE
C                                       write
      L = 1
      DO 30 IY = 1,NY
         CALL MDISK ('WRIT', LUNO, INDO, BUFFO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRIT', IY
            CALL MSGWRT (8)
            GO TO 999
            END IF
         IF ((RMS.NE.FBLANK) .AND. (RMS.GT.0.0)) THEN
            DO 20 IX = 1,NX
               IF (IMAGE(L+IX-1).NE.FBLANK) THEN
                  BUFFO(IBIND+IX-1) = IMAGE(L+IX-1) / RMS
                  OMIN = MIN (OMIN, BUFFO(IBIND+IX-1))
                  OMAX = MAX (OMAX, BUFFO(IBIND+IX-1))
               ELSE
                  OBLANK = .TRUE.
                  BUFFO(IBIND+IX-1) = FBLANK
                  END IF
 20            CONTINUE
         ELSE
            OBLANK = .TRUE.
            CALL RFILL (NX, FBLANK, BUFFO(IBIND))
            END IF
         L = L + NX
 30      CONTINUE
      CALL MDISK ('FINI', LUNO, INDO, BUFFO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINISH', IY
         CALL MSGWRT (8)
         GO TO 999
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MDISK ERROR',I4,1X,A,'ING ROW ',I6)
      END
      SUBROUTINE RSPECH
C-----------------------------------------------------------------------
C   Writes the HI, copies tables, closes output image
C-----------------------------------------------------------------------
      INTEGER   HLUN1, HLUN2, IERR, IB, I
      CHARACTER HILINE*72, NOTTYP*2
      INCLUDE 'RSPEC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA HLUN1, HLUN2 /30,31/
      DATA NOTTYP /'CC'/
C-----------------------------------------------------------------------
      CALL HIINIT (3)
      CALL HISCOP (HLUN1, HLUN2, DISKIN, DISKOU, CNOIN, CNOUT, CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.3) GO TO 100
      IF (IERR.EQ.3) GO TO 90
C                                       RSPEC history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, HLUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 90
      CALL HENCOO (TSKNAM, NAMEOU, CLAOU, SEQOU, DISKOU, HLUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 90
      WRITE (HILINE,1010) TSKNAM, OPTYPE
      CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 90
      WRITE (HILINE,1020) TSKNAM, NBOXES
      CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 90
      DO 25, IB = 1,NBOXES
         WRITE (HILINE,1025) TSKNAM, IB, (BOX(I,IB), I = 1,4)
         CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 90
 25      CONTINUE
      WRITE (HILINE,1030) TSKNAM, DOINV
      CALL HIADD (HLUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 90
C
 90   CALL HICLOS (HLUN2, .TRUE., BUFF2, IERR)
C                                       Copy CC files and others
 100  CALL ALLTAB (1, NOTTYP, HLUN1, HLUN2, DISKIN, DISKOU, CNOIN,
     *   CNOUT, CATBLK, BUFF1, BUFF2, IERR)
      CALL MAPCLS ('INIT', DISKOU, CNOUT, LUNO, INDO, CATBLK, .TRUE.,
     *   BUFF2, IERR)
      NCFILE = NCFILE - 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (A,'OPTYPE = ''',A,''' / rms method')
 1020 FORMAT (A,'NBOXES =',I3,'  / number of areas')
 1025 FORMAT (A,'CLBOX(',I2,')=',4F9.1)
 1030 FORMAT (A,'DOINVERS =',F5.1)
      END
      SUBROUTINE PLTSCH (IRET)
C-----------------------------------------------------------------------
C   counts lines of print
C   Output:
C      IRET   I   Error code: 0 => okay - can change DOCRT to 0
C-----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'RSPEC.INC'
      CHARACTER CTEMP*20
      REAL      X
      INTEGER   I, NCOUNT, TTY(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF ((DOCRT.GE.0.0) .OR. (LPNAME.NE.' ')) GO TO 999
      MSGTXT = 'Checking count of lines for direct output to printer'
      CALL MSGWRT (2)
      NCOUNT = 0
C                                       Header line for printer
      IF (DOCRT.LE.-2.5 .AND. .NOT.DOWEIT) NCOUNT = NCOUNT + 2
C
      DO 30 I = 1,NZI,ZINC
C                                       For printer: fill LINE
         NCOUNT = NCOUNT + 1
 30      CONTINUE
C
      IF (.NOT.DOWEIT) NCOUNT = NCOUNT + 6
C                                       ask if needed
      X = DOCRT
      DOCRT = 0.0
      IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) THEN
         IF (NCOUNT.GT.1000) THEN
            X = 0.0
            IPCNT = -1
            CALL LPCLOS (LUNP, FINDP, IPCNT, I)
            END IF
      ELSE IF (NCOUNT.GT.500) THEN
         TTY(1) = 5
         CALL ZOPEN (TTY(1), TTY(2), 1, SCRTCH, .FALSE., .FALSE.,
     *      .TRUE., IRET)
         MSGTXT = 'PROBLEM OPENING TERMINAL'
         IF (IRET.GT.0) GO TO 990
         WRITE (SCRTCH,1030) NCOUNT
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, IRET)
         MSGTXT = 'PROBLEM DOING IO TO TERMINAL'
         IF (IRET.GT.0) GO TO 990
         SCRTCH = 'Do you really want to print this much??' //
     *      ' Enter Y or y if so'
         CALL INQSTR (TTY, SCRTCH, 1, CTEMP, IRET)
         IF (IRET.GT.0) GO TO 990
         IF ((CTEMP(:1).NE.'y') .AND. (CTEMP(:1).NE.'Y')) THEN
            X = 0.0
            IPCNT = -1
            CALL LPCLOS (LUNP, FINDP, IPCNT, I)
            SCRTCH = 'Good choice - save trees'
         ELSE
            SCRTCH = 'OKAY, printing anyway'
            END IF
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, I)
         CALL ZCLOSE (TTY(1), TTY(2), I)
         END IF
      DOCRT = X
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('Requested print job is',I10,' lines long!')
      END
      SUBROUTINE PLTSPC (IRET)
C-----------------------------------------------------------------------
C   Routine which plots the contents of the DBUFF array, performs all
C   the labelling and closes down the PL file.
C   It will also write these data to the terminal, or the line printer,
C   or to an output file depending on the value of DOCRT. (GvM, 12/92).
C   Output:
C      IRET   I   Error code: 0 => okay
C-----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'RSPEC.INC'
      CHARACTER TEXT(3)*128, CTEMP*20, PLNAME*48, ATIME*8, ADATE*12,
     *   UNIT*8, SPRTXT*80
      REAL      CHOUT(4), PBLC(2), PTRC(2), XYRATI, SCALY, X, Y, OFY,
     *   DX, DY, XBLC(7), XTRC(7), RTEMP(2), YGAP, RANGE2(2), XSEP,
     *   SBUFF(MAXIMG), SMTAB(256), SV, SS, VMIN, VMAX, VM(10), V, FQDI
      INTEGER   DEPTH(5), I, INCHAR, IPTYPE, ID(3), IT(3), NTEXT, J,
     *   ITEMP(2), IDROP(2), NCHAR, IROUND, IERR, ZPIX, L, NS, JTRIM,
     *   IP
      HOLLERITH HTEMP(4)
      DOUBLE PRECISION DTEMP, INCR, RPIX, ZVAL, RVAL, DVAL, FQDD
      LOGICAL   F, T, PENUP, PRINT, DOSMTH
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T, F /.TRUE., .FALSE./
      DATA VM / 6.0, 5.0, 4.0, 3.0, 2.8, 2.6, 2.4, 2.0, 1.3, 1.3/
C-----------------------------------------------------------------------
      PRINT = DOCRT.NE.0.0
      FQDD = 0.0D0
      FQDI = 0.0
C                                       Set up freq smoothing
      CALL SETSM (NZI, 256, XSMOTH, DOSMTH, SMTAB)
      CALL RCOPY (NZI, DBUFF, SBUFF)
      IF (DOSMTH) CALL SMOSP (NZI, XSMOTH, SMTAB, RANGE, DBUFF, SBUFF)
C                                       Add plot file to CATBLK
      PVER = 0
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', DISKIN, CNOIN, CATBLK, BUFF1, T, 'READ',
     *      PVER, IRET)
         IF (IRET.EQ.0) THEN
            WRITE (MSGTXT,1000) PVER
            CALL MSGWRT (6)
            FRW(1) = 0
         ELSE
            WRITE (MSGTXT,1001) IRET
            GO TO 990
            END IF
         END IF
C                                       Generate the plot file name
      CALL ZPHFIL ('PL', DISKIN, CNOIN, PVER, PLNAME, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1005) IRET
         GO TO 990
         END IF
C                                       Open the plot file
      IF (PIXR(1).GE.PIXR(2)) THEN
         PIXR(1) = RANGE(1) - 0.02 * (RANGE(2) - RANGE(1))
         PIXR(2) = RANGE(2) + 0.02 * (RANGE(2) - RANGE(1))
         END IF
C                                       start on labeling as a slice
      XBLC(1) = BLC(3)
      XBLC(2) = BLC(4)
      XBLC(3) = (BLC(1) + TRC(1)) / 2.0
      XBLC(4) = (BLC(2) + TRC(2)) / 2.0
      XBLC(5) = BLC(5)
      XBLC(6) = BLC(6)
      XBLC(7) = BLC(7)
      CALL RCOPY (6, XBLC(2), XTRC(2))
      XTRC(1) = TRC(3)
      IDROP(1) = 0
      IDROP(2) = 0
C                                       swap axes 1,2 with 3,4
      CALL COPY (2, CATBLK(KINAX), ITEMP)
      CALL COPY (2, CATBLK(KINAX+2), CATBLK(KINAX))
      CALL COPY (2, ITEMP, CATBLK(KINAX+2))
      CALL RCOPY (4, CATH(KHCTP), HTEMP)
      CALL RCOPY (4, CATH(KHCTP+4), CATH(KHCTP))
      CALL RCOPY (4, HTEMP, CATH(KHCTP+4))
      CALL H2CHR (8, 1, CATH(KHBUN), UNIT(1:8))
      IF ((FLUXFL) .AND. (OPTYPE.EQ.'FLUX')) UNIT = 'JY'
      CALL CHR2H (8, UNIT, 1, CATH(KHBUN))
      DTEMP = CATD(KDCRV)
      CATD(KDCRV) = CATD(KDCRV+2)
      CATD(KDCRV+2) = DTEMP
      DTEMP = CATD(KDCRV+1)
      CATD(KDCRV+1) = CATD(KDCRV+3)
      CATD(KDCRV+3) = DTEMP
      CALL RCOPY (2, CATR(KRCIC), RTEMP)
      CALL RCOPY (2, CATR(KRCIC+2), CATR(KRCIC))
      CALL RCOPY (2, RTEMP, CATR(KRCIC+2))
      CALL RCOPY (2, CATR(KRCRP), RTEMP)
      CALL RCOPY (2, CATR(KRCRP+2), CATR(KRCRP))
      CALL RCOPY (2, RTEMP, CATR(KRCRP+2))
      CALL RCOPY (2, CATR(KRCRT), RTEMP)
      CALL RCOPY (2, CATR(KRCRT+2), CATR(KRCRT))
      CALL RCOPY (2, RTEMP, CATR(KRCRT+2))
C                                       boxcar smooth issue
      IF (XSMOTH(1).EQ.3.0) THEN
         J = XSMOTH(2) + 0.1
         IF (MOD(J,2).EQ.0) CATR(KRCRP) = CATR(KRCRP) - 0.5 / J
         END IF
      IF (INVERT) THEN
         CATR(KRCIC) = -CATR(KRCIC)
         CATR(KRCRP) = TRC(3) + BLC(3) - CATR(KRCRP)
         END IF
      IF ((ISFQID) .AND. (ILABEL.EQ.3)) THEN
         CATD(KDCRV) = FRQS(1)
         CATR(KRCRP) = BLC(3)
         CATR(KRCIC) = (FRQS(NZI)-FRQS(1)) / (NZI - 1)
         CALL CHR2H (8, 'FREQ    ', 1, CATH(KHCTP))
         END IF
      RVAL  = CATD(KDCRV)
      RPIX  = CATR(KRCRP)
      INCR  = CATR(KRCIC)
C                                       init SL plot
      CATR(IRRAN) = PIXR(1)
      CATR(IRRAN+1) = PIXR(2)
      SCALY = 39999.0 / (PIXR(2) - PIXR(1))
      OFY = 40000.0 - SCALY * PIXR(2)
      RANGE2(1) = SCALY * PIXR(1) + OFY
      RANGE2(2) = SCALY * PIXR(2) + OFY
      PBLC(2) = RANGE2(1)
      PTRC(2) = RANGE2(2)
      LOCNUM = 1
      CALL RFILL (4, 0.0, CHOUT)
      YGAP = 0.0
      CALL SLBINI (IDROP, NZI, PIXR, PBLC, PTRC, XBLC, XTRC, FQDD, FQDI,
     *   DEPTH, LTYPE, YGAP, CHOUT, TEXT, NTEXT)
      PBLC(1) = PBLC(1) * 10 - 5
      PTRC(1) = PTRC(1) * 10 + 5
      RPLOC(1,LOCNUM) = RPLOC(1,LOCNUM) * 10.0
      AXINC(1,LOCNUM) = AXINC(1,LOCNUM) / 10.0
C                                       display window
      CHOUT(2) = CHOUT(2) - NTEXT * 1.333
      NTEXT = 1
      IF (ILABEL.GT.3) NTEXT = 2
      IF (DOSMTH) NTEXT = NTEXT + 1
      IF (ILABEL.GT.6) NTEXT = 0
      CHOUT(2) = CHOUT(2) + NTEXT * 1.333
      IDROP(1) = IROUND (BOX(1,1))
      IDROP(2) = IROUND (BOX(3,1))
      ITEMP(1) = IROUND (BOX(2,1))
      ITEMP(2) = IROUND (BOX(4,1))
      IF (NTEXT.GT.0) THEN
         IF (OPCODE.EQ.'FLUX') THEN
            CTEMP = 'Sum'
         ELSE
            CTEMP = 'Average'
            END IF
         IP = JTRIM (CTEMP)
         IF (DOINV.LE.0.0) THEN
            CTEMP(IP+2:) = 'over'
         ELSE
            CTEMP(IP+2:) = 'outside'
            END IF
         IP = JTRIM (CTEMP)
         J = NTEXT
         IF (DOSMTH) J = J - 1
         IF (IDROP(1).GT.0) THEN
            WRITE (TEXT(J),1008) CTEMP(:IP), IDROP, ITEMP
         ELSE
            WRITE (TEXT(J),1012) CTEMP(:IP), IDROP(2), ITEMP(2),
     *         ITEMP(1)
            END IF
         IF (NBOXES.GT.1) THEN
            IP = JTRIM (TEXT(J)) + 1
            IF (NBOXES.GT.2) THEN
               WRITE (TEXT(J)(IP:),1013) NBOXES-1
            ELSE
               IDROP(1) = IROUND (BOX(1,2))
               IDROP(2) = IROUND (BOX(3,2))
               ITEMP(1) = IROUND (BOX(2,2))
               ITEMP(2) = IROUND (BOX(4,2))
               IF (IDROP(1).GT.0) THEN
                  WRITE (TEXT(J)(IP:),2008) IDROP, ITEMP
               ELSE
                  WRITE (TEXT(J)(IP:),2012) IDROP(2), ITEMP(2), ITEMP(1)
                  END IF
               END IF
            END IF
         CALL REFRMT (TEXT(J), '__', IP)
         IF (DOSMTH) THEN
            WRITE (TEXT(NTEXT),1009) XSMOTH
            END IF
         END IF
C                                       init plot file
      IPTYPE = 34
      CALL GINIT (DISKIN, CNOIN, PLNAME, 0, IPTYPE, NPARM, USERID,
     *   DOTV, TVCHN, GRCHN, TVCORN, CATBLK, PLBUFF, GLUN, GFIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
      IF (GR2CHN.GT.0) GPHTVG(1) = GR2CHN + NGRAY
C                                       init line drawing
      XYRATI = (PTRC(2) - PBLC(2)) / (PTRC(1) - PBLC(1)) * XYRATO
      CALL GINITL (PBLC, PTRC, XYRATI, CHOUT, DEPTH, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GLTYPE (1, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                        Draw the box
      CALL GPOS (PBLC(1), PBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (PTRC(1), PBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (PTRC(1), PTRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (PBLC(1), PTRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (PBLC(1), PBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                       More labeling: x,y coords
      IF ((ILABEL.GT.1) .AND. (ILABEL.LT.7)) THEN
         CALL GPOS (PBLC(1), PTRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 980
         DX = 0.0
         DY = 0.5
         CALL H2CHR (8, 1, CATH(KHOBJ), SPRTXT)
         INCHAR = 12
         IF (SPRTXT.EQ.' ') INCHAR = 1
         IF (NCHLAB(1,LOCNUM).GT.0) THEN
            IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
            SPRTXT(INCHAR:) = SAXLAB(1,LOCNUM)(:NCHLAB(1,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(1,LOCNUM)
            END IF
         IF (NCHLAB(2,LOCNUM).GT.0) THEN
            IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
            SPRTXT(INCHAR:) = SAXLAB(2,LOCNUM)(:NCHLAB(2,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(2,LOCNUM)
            END IF
C                                       image name
         IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
         CALL H2CHR (18, 1, CATH(KHIMN), CTEMP)
         CALL NAMEST (CTEMP, CATBLK(KIIMS), SPRTXT(INCHAR:), NCHAR)
         CALL REFRMT (SPRTXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, SPRTXT, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 980
         TITL1 = SPRTXT
C                                       Date/time, version number
         IF (LTYPE.GT.1) THEN
            CALL GPOS (PBLC(1), PTRC(2), PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 980
            DY = DY + 1.333
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (SPRTXT,1015) PVER, ADATE, ATIME
            CALL REFRMT (SPRTXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, SPRTXT, PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 980
            END IF
C                                       Text at bottom
         IF (NTEXT.GT.0) THEN
            DX = 0.
            DY = -YGAP
            DO 20 I = 1,NTEXT
               CALL GPOS (PBLC(1), PBLC(2), PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 980
               CALL CHTRIM (TEXT(I), 80, TEXT(I), INCHAR)
               CALL GCHAR (INCHAR, 0, DX, DY, TEXT(I), PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 980
               DY = DY - 1.333
 20            CONTINUE
            END IF
         END IF
C                                       Axis labels and ticks
      CALL CLAB1 (PBLC, PTRC, CHOUT, LTYPE, XYRATI, F, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                       Header line for printer
      IF (PRINT) THEN
         LINE(1:)   = 'pixel'
         LINE(10:)  = 'coord.value '
         IF (OPTYPE.EQ.'FLUX') THEN
            LINE(28:) = 'sum over area'
         ELSE
            LINE(28:) = 'avg over area'
            END IF
         IF (DOSMTH) LINE(45:) = '  freq smoothed'
         TITL2 = LINE
C         IF (DOCRT.LE.-2.5) THEN
         IF (DOCRT.LE.-2.5 .AND. .NOT.DOWEIT) THEN
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         TITL1, IPCNT, PAGE, SCRTCH, IRET)
            PRINT = IRET.EQ.0
            IF (PRINT) THEN
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            TITL2, IPCNT, PAGE, SCRTCH, IRET)
               PRINT = IRET.EQ.0
               END IF
            END IF
         END IF
C                                       Plot intensities
      CALL GLTYPE (2, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      PENUP = .TRUE.
      XSEP = 0.0
      IF (DOCENT.GT.0.0) XSEP = ZINC / 2.0
C
      DO 30 I = 1,NZI,ZINC
         IF (SBUFF(I).EQ.FBLANK) THEN
            PENUP = .TRUE.
            CTEMP = '   undefined   '
         ELSE
            Y = MAX (PIXR(1), MIN (PIXR(2), SBUFF(I))) * SCALY + OFY
            X = MAX (PBLC(1), (I-XSEP)*10)
            IF (ISFQID) THEN
               DVAL = (FRQS(I) - RVAL) / INCR + 1.0D0
               X = (DVAL - XSEP) * 10.0
               X = MAX (PBLC(1), X)
               END IF
            IF (PENUP) THEN
               CALL GPOS (X, Y, PLBUFF, IRET)
               PENUP = .FALSE.
            ELSE
               CALL GVEC (X, Y, PLBUFF, IRET)
               END IF
            IF (IRET.NE.0) GO TO 980
            IF (DOCENT.GT.0.0) THEN
               X = MIN (PTRC(1), (I+XSEP)*10)
               IF (ISFQID) THEN
                  IF (I+ZINC.LE.NZI) THEN
                     DTEMP = (FRQS(I+ZINC)-RVAL) / INCR + 1.0D0
                     XSEP = (DTEMP - DVAL) / 2.0D0
                     END IF
                  X = (DVAL + XSEP) * 10.0
                  X = MIN (PTRC(1), X)
                  END IF
               CALL GVEC (X, Y, PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 980
               END IF
            END IF
C                                       For printer: fill LINE
         IF (PRINT) THEN
            ZPIX = NINT (BLC(3) + I - 1)
            ZVAL = (ZPIX - RPIX) * INCR + RVAL
            IF (ISFQID) ZVAL = FRQS(I)
            IF (INVERT) ZPIX = NINT (TRC(3) - I + 1)
C
            IF (DOWEIT) THEN
               WRITE (LINE, 1025) DBUFF(I)
               TITL1 = ' '
               TITL2 = ' '
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            LINE, IPCNT, PAGE, SCRTCH, IRET)
            ELSE
               WRITE (LINE,1020) ZPIX, ZVAL, DBUFF(I), SBUFF(I)
               IF (DBUFF(I).EQ.FBLANK) LINE(26:40) = '  undefined  '
               IF (SBUFF(I).EQ.FBLANK) LINE(43:57) = '  undefined  '
               IF (.NOT.DOSMTH) LINE(43:) = ' '
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            LINE, IPCNT, PAGE, SCRTCH, IRET)
               END IF
            PRINT = IRET.EQ.0
            END IF
 30      CONTINUE
C
      IF (DOWEIT) GO TO 970
C
      IF (XSUM.GT.0.0) THEN
         FSUM = FSUM / XSUM
         DSUM = DSUM / XSUM - FSUM * FSUM
         DSUM = SQRT (MAX (0.0, DSUM))
         PSUM = PSUM / XSUM
         END IF
      VMIN = FSUM - DSUM * VM(1)
      VMAX = FSUM + DSUM * VM(1)
      DO 50 L = 2,10
         SV = 0.
         SS = 0.
         NS = 0
         DO 40 I = 1,NZI
            V = DBUFF(I)
            IF ((V.NE.FBLANK) .AND. (V.GE.VMIN) .AND. (V.LE.VMAX)) THEN
               SV = SV + V
               SS = SS + V * V
               NS = NS + 1
               END IF
 40         CONTINUE
         IF (NS.GT.0) THEN
            SV = SV / NS
            SS = SS / NS - SV * SV
            SS = SQRT (MAX (0.0, SS))
            VMIN = SV - SS * VM(L)
            VMAX = SV + SS * VM(L)
         ELSE
            GO TO 55
            END IF
 50      CONTINUE
 55   IF (PRINT) THEN
         WRITE (LINE,1028) PSUM
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         WRITE (LINE,1029)
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         WRITE (LINE,1030) FSUM
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         WRITE (LINE,1031) DSUM
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         WRITE (LINE,1032) XSUM
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         IF (NS.GT.0) THEN
            WRITE (LINE,1033) SV
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         LINE, IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 970
            WRITE (LINE,1034) SS
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         LINE, IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 970
            WRITE (LINE,1035) NS
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         LINE, IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 970
            END IF
      ELSE
         WRITE (MSGTXT,1028) PSUM
         CALL MSGWRT (5)
         WRITE (MSGTXT,1029)
         CALL MSGWRT (5)
         WRITE (MSGTXT,1030) FSUM
         CALL MSGWRT (5)
         WRITE (MSGTXT,1031) DSUM
         CALL MSGWRT (5)
         WRITE (MSGTXT,1032) XSUM
         CALL MSGWRT (5)
         IF (NS.GT.0) THEN
            WRITE (MSGTXT,1033) SV
            CALL MSGWRT (5)
            WRITE (MSGTXT,1034) SS
            CALL MSGWRT (5)
            WRITE (MSGTXT,1035) NS
            CALL MSGWRT (5)
            END IF
         END IF
C                                       end of WEIGHT
  970 CONTINUE
C                                       Finish up
      CALL GFINIS (PLBUFF, IRET)
      IF (.NOT.DOTV) CALL HIPLOT (DISKIN, CNOIN, PVER, BUFF1, IERR)
      GO TO 999
C                                       Plot error - try partial
 980  WRITE (MSGTXT,1980) IRET
      CALL MSGWRT (7)
      CALL GFINIS (PLBUFF, IERR)
      IF (IERR.EQ.0) THEN
         IRET = 0
      ELSE
         IF (.NOT.DOTV) THEN
            CALL ZCLOSE (GLUN, GFIND, IERR)
            CALL ZDESTR (DISKIN, PLNAME, IERR)
            END IF
         END IF
      IF ((IRET.NE.0) .AND. (.NOT.DOTV)) CALL DELEXT ('PL', DISKIN,
     *   CNOIN, 'READ', CATBLK, PLBUFF, PVER, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Created plot file version ', I4)
 1001 FORMAT ('PLTSPC: MADDEX ERROR ',I3)
 1005 FORMAT ('PLTSPC: ZPHFIL ERROR ',I3)
 1008 FORMAT (A,' area in X:',2I5,'   in Y:',2I5)
 1009 FORMAT ('Freq smoothing parms:',F3.0,F5.2,F5.1)
 1010 FORMAT ('PLTSPC: GINIT ERROR ',I3)
 1012 FORMAT (A,' area centered at',2I5,' radius',I3)
 1013 FORMAT ('__plus',I3,' more boxes')
 2008 FORMAT ('__plus area in X:',2I5,'   in Y:',2I5)
 2012 FORMAT ('__plus area centered at',2I5,' radius',I3)
 1015 FORMAT ('Plot file version',I4,'__created ',A12,A8)
 1020 FORMAT (I5,2X,1PE16.8,2(2X,1PE15.7))
 1025 FORMAT (F10.6)
 1028 FORMAT ('Average # pixels per plane',F12.1)
 1029 FORMAT ('Mean and rms of rmses:')
 1030 FORMAT ('Average of all points     ',1PE15.7)
 1031 FORMAT ('RMS of all points         ',1PE15.7)
 1032 FORMAT ('Number points included    ',F8.0)
 1033 FORMAT ('Robust average of points  ',1PE15.7)
 1034 FORMAT ('Robust rms of points      ',1PE15.7)
 1035 FORMAT ('Number points included    ',I7)
 1980 FORMAT ('ERROR ',I5,' PLOTTING - TRY TO FINISH PARTIAL GRAPH')
      END
      SUBROUTINE SETSM (NCH, MAXSMO, SMOOTH, DOSMTH, SMTAB)
C-----------------------------------------------------------------------
C   SETSM determines the type of spectral smoothing to be applied and
C   sets up the look up table to do it. The actual smoothing is done in
C   routine SMOSP
C   Inputs:
C      NCH      I      Number samples on axis being smoothed
C      MAXSMO   I      Dimension of SMTAB
C      SMOOTH   R(3)   Array containing smoothing parms
C                         SMOOTH(1) = type of function
C                               (2) = width of function in channels
C                               (3) = support of function in channels
C                         Type of function supported are:
C                            0 => no smoothing
C                            1 => hanning
C                            2 => gaussian
C                            3 => boxcar
C                            4 => sin(x)/x
C   Output:
C      DOSMTH   L      T => do smoothing
C-----------------------------------------------------------------------
      INTEGER   NCH, MAXSMO
      REAL      SMOOTH(3), SMTAB(*)
      LOGICAL   DOSMTH
C
      INTEGER   I, N, LSPECT, IROUND, IT, SUPRAD
      REAL      FX, X, W, WIDTHS(4), SUPS(4)
      DATA WIDTHS /4.0, 2.0, 2.0, 3.0/
      DATA SUPS /1.0, 3.0, 1.0, 4.0/
C-----------------------------------------------------------------------
      DOSMTH = .FALSE.
      IT = IROUND (SMOOTH(1))
      IF (IT.LE.0) GO TO 999
      DOSMTH = .TRUE.
C                                       Convolution: parms & tables
      IT = MOD (IT-1, 4) + 1
      SMOOTH(1) = IT
      LSPECT = MAX (12, NCH)
      IF ((SMOOTH(2).LT.0.5) .OR. (SMOOTH(2).GT.LSPECT/3.))
     *   SMOOTH(2) = WIDTHS(IT)
      IF ((SMOOTH(3).GT.4.*SUPS(IT)*SMOOTH(2)) .OR.
     *   (SMOOTH(3).LT.SMOOTH(2)))SMOOTH(3) = SUPS(IT) * SMOOTH(2)
      SUPRAD = SMOOTH(3) / 2.0 + 0.1
      IF (SUPRAD+1.GT.MAXSMO) THEN
         SUPRAD = MAXSMO - 1
         SMOOTH(2) = (2. * SUPRAD) / SUPS(IT)
         END IF
      SMOOTH(3) = 2.0 * SUPRAD + 1.0
      CALL RFILL (MAXSMO, 0.0, SMTAB)
      N = 1 + SUPRAD
      FX = 2.0 / SMOOTH(2)
      SMTAB(1) = 1.0
C                                       Compute look-up tables
      W = SMTAB(1)
C                                       Hanning smooth
      IF (IT.EQ.1) THEN
         DO 20 I = 2,N
            X = I - 1.0
            SMTAB(I) = MAX (0.0, 1.0-FX*X)
            W = W + 2 * SMTAB(I)
 20         CONTINUE
C                                       Gaussian smooth
      ELSE IF (IT.EQ.2) THEN
         FX = -LOG(2.0) * FX * FX
         DO 30 I = 2,N
            X = I - 1.0
            SMTAB(I) = EXP (FX * X * X)
            W = W + 2 * SMTAB(I)
 30         CONTINUE
C                                       Boxcar smooth
      ELSE IF (IT.EQ.3) THEN
         CALL RFILL (N, 1.0, SMTAB)
         W = N
C                                      Sinc smooth
      ELSE IF (IT.EQ.4) THEN
         FX = 3.14159 * FX
         DO 50 I = 2,N
            X = (I - 1.0) * FX
            SMTAB(I) = SIN(X) / X
            W = W + 2 * SMTAB(I)
 50         CONTINUE
         END IF
C                                       Normalize integral
      IF (W.LE.0.0) W = 1.0
      DO 70 I = 1,N
         SMTAB(I) = SMTAB(I) / W
 70      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SMOSP (NCH, SMOOTH, SMTAB, RANGE, SPCI, SPCO)
C-----------------------------------------------------------------------
C   SMOSP convolves an input spectrum with a convolving look up table
C   established in common.
C   Values from commons:
C      SMTAB    R(MAXSMO)   Convolution look-up table
C      SMOOTH   R(3)        (3) = 2*support-radius + 1
C      BCHANS   I           Start channel for smoothing
C      ECHANS   I           Stop channel for smoothing
C      SPCI     R(*)        Spectrum
C   Output:
C      RANGE    R(2)        new intensity range
C      SPCO     R(*)        Spectrum smoothed
C-----------------------------------------------------------------------
      REAL      SMOOTH(3), SMTAB(*), RANGE(2), SPCI(*), SPCO(*)
      INTEGER   NCH
C
      INTEGER   J, J1, J2, L, IFRQ, SUPRL, SUPRH
      REAL      S, W
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      SUPRL = (SMOOTH(3) - 0.9) / 2.0
      SUPRH = (SMOOTH(3) - 0.9) / 2.0
      IF (SMOOTH(1).EQ.3.) THEN
         J = SMOOTH(2) + 0.1
         SUPRL = (J - 1) / 2
         SUPRH = J - 1 - SUPRL
         END IF
      RANGE(1) = 1.E20
      RANGE(2) = -1.E20
C                                       Convolve the data
      DO 30 IFRQ = 1,NCH
         J1 = MAX (IFRQ - SUPRL, 1)
         J2 = MIN (IFRQ + SUPRH, NCH)
         S = 0.0
         W = 0.0
         DO 20 J = J1,J2
            IF (SPCI(J).NE.FBLANK) THEN
               L = ABS(IFRQ-J) + 1
               S = SPCI(J) * SMTAB(L) + S
               W = SMTAB(L) + W
               END IF
 20         CONTINUE
         IF (W.GT.0.0) THEN
            SPCO(IFRQ) = S / W
            RANGE(1) = MIN (RANGE(1), SPCO(IFRQ))
            RANGE(2) = MAX (RANGE(2), SPCO(IFRQ))
         ELSE
            SPCO(IFRQ) = FBLANK
            END IF
 30      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SLISPC (IRET)
C-----------------------------------------------------------------------
C   SLISPC writes the fit spectrum as a SL file
C   Output:
C      IRET   I   > 0 => serious error
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'RSPEC.INC'
      CHARACTER SFILE*48
      INTEGER   ISLDAT(512), IVER, NREC, SLUN, SIND, LREC, IPT, IERR,
     *   LNZI, NG(MAXIMG), NB(MAXIMG), IN, OUT
      REAL      RSLDAT(512), RMIN, RMAX, FQFINC, RTEMP(23)
      DOUBLE PRECISION DSLDAT(256), FR, FW, F
      REAL      LBUFF(MAXIMG), SB(MAXIMG), WT(MAXIMG), W
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (ISLDAT, RSLDAT, DSLDAT), (USERID, RTEMP)
      DATA SLUN /45/
C-----------------------------------------------------------------------
      CALL FNDEXT ('SL', CATBLK, IVER)
      IVER = IVER + 1
      CALL FILL (256, 0, ISLDAT)
      LREC = 256
      LNZI = NZI
      IF (ISFQID) LNZI = 4 * NZI - 3
      NREC = (LNZI - 1) / 256 + 2
C                                       create
      CALL EXTINI ('WRIT', 'SL', DISKIN, CNOIN, IVER, CATBLK, SLUN,
     *   SIND, LREC, NREC, ISLDAT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATE', IVER
         GO TO 995
         END IF
C                                       update record 1
      CALL ZFIO ('READ', SLUN, SIND, 1, ISLDAT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ 1', IVER
         GO TO 990
         END IF
      ISLDAT(57) = LNZI
      ISLDAT(58) = 0
      ISLDAT(59) = ISLDAT(1) + 1
      CALL ZFIO ('WRIT', SLUN, SIND, 1, ISLDAT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE 1', IVER
         GO TO 990
         END IF
C                                       inputs/parms in 2nd record
      CALL FILL (256, 0, ISLDAT)
      CALL CHR2H (6, TSKNAM, 1, RSLDAT(1))
      CALL ZDATE (ISLDAT(4))
      CALL ZTIME (ISLDAT(7))
      ISLDAT(10) = 23
      IF (INVERT) THEN
         RMIN = BLC(3)
         RMAX = TRC(3)
         BLC(3) = RMAX
         TRC(3) = RMIN
         END IF
      CALL RCOPY (23, RTEMP, RSLDAT(11))
      IF (INVERT) THEN
         BLC(3) = RMIN
         TRC(3) = RMAX
         END IF
C                                       local work buffer
      CALL RCOPY (NZI, DBUFF, LBUFF)
C                                       FQID?
      IF (ISFQID) THEN
         DSLDAT(19) = FRQS(1)
         FQFINC = (FRQS(NZI) - FRQS(1)) / (LNZI - 1)
         RSLDAT(36) = FQFINC
         END IF
C                                       FQID interpolate
      IF (ISFQID) THEN
         CALL RFILL (LNZI, 0.0, SB)
         CALL RFILL (LNZI, 0.0, WT)
         CALL FILL (LNZI, 0, NG)
         CALL FILL (LNZI, 0, NB)
         FW = 2.0D0 * FQFINC
C                                       convolve
         DO 30 IN = 1,NZI
            FR = FRQS(IN)
            F = FRQS(1) - FQFINC
            DO 20 OUT = 1,LNZI
               F = F + FQFINC
               W = ((FR - F) / FW) ** 2
               IF (W.LT.10.D0) THEN
                  IF (LBUFF(IN).NE.FBLANK) THEN
                     W = EXP(-W)
                     WT(OUT) = WT(OUT) + W
                     SB(OUT) = SB(OUT) + W * LBUFF(IN)
                     NG(OUT) = NG(OUT) + 1
                  ELSE
                     NB(OUT) = NB(OUT) + 2
                     END IF
                  END IF
 20            CONTINUE
 30         CONTINUE
C                                       average
         DO 40 OUT = 1,LNZI
            IF ((WT(OUT).GT.0.0) .AND. (NB(OUT).LT.NG(OUT))) THEN
               LBUFF(OUT) = SB(OUT) / WT(OUT)
            ELSE
               LBUFF(OUT) = FBLANK
               END IF
 40         CONTINUE
         END IF
C                                       min/max
      RMIN = 1.E12
      RMAX = -RMIN
      DO 50 IPT = 1,LNZI
         IF (DBUFF(IPT).NE.FBLANK) THEN
            RMAX = MAX (RMAX, LBUFF(IPT))
            RMIN = MIN (RMIN, LBUFF(IPT))
            END IF
 50      CONTINUE
      RSLDAT(34) = RMIN
      RSLDAT(35) = RMAX
      CALL ZFIO ('WRIT', SLUN, SIND, 2, ISLDAT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE 2', IVER
         GO TO 990
         END IF
C                                       write the data
      NREC = 2
      IPT = 1
 100  LREC = LNZI + 1 - IPT
      IF (LREC.GT.0) THEN
         LREC = MIN (LREC, 256)
         CALL RCOPY (LREC, LBUFF(IPT), RSLDAT)
         NREC = NREC + 1
         CALL ZFIO ('WRIT', SLUN, SIND, NREC, ISLDAT, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE DATA', IVER
            GO TO 990
            END IF
         IPT = IPT + LREC
         IF (IPT.LE.LNZI) GO TO 100
         END IF
C                                       close
      CALL ZCLOSE (SLUN, SIND, IRET)
C                                       Slice file created message.
      WRITE (MSGTXT,1020) IVER
      CALL MSGWRT (3)
      GO TO 999
C                                       destroy SL file
 990  CALL MSGWRT (8)
      CALL ZCLOSE (SLUN, SIND, IERR)
      CALL ZPHFIL ('SL', DISKIN, CNOIN, IVER, SFILE, IERR)
      CALL ZDESTR (DISKIN, SFILE, IERR)
      CALL DELEXT ('SL', DISKIN, CNOIN, 'WRIT', CATBLK, ISLDAT, IVER,
     *   IERR)
      GO TO 999
C
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' ON ',A,' SL VERS',I5)
 1020 FORMAT ('SLice file version ',I5,' created.')
      END

      SUBROUTINE LINLIM (BLC, TRC, X, Y, IERR)
C-----------------------------------------------------------------------
C! clips X,Y values at edges of rectangular area with interpolation
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   clips X,Y values at BLC, TRC with interpolation --- see also INTEDG
C   Inputs:
C      BLC  R(2)     X,Y lower left corner pixels
C      TRC  R(2)     X,Y upper right corner pixels
C   In/out:
C      X    R(2)     X pixel pair
C      Y    R(2)     Y pixel pair
C   Output:
C      IERR I        0 ok, 1 not in plot at all
C-----------------------------------------------------------------------
      INTEGER   IERR
      REAL      BLC(2), TRC(2), X(2), Y(2)
C
      INTEGER   I, J
      REAL      ALPHA, BETA, XX, YY, XS(2), YS(2)
C-----------------------------------------------------------------------
      IERR = 1
      IF ((X(1).LT.BLC(1)) .AND. (X(2).LT.BLC(1))) GO TO 999
      IF ((Y(1).LT.BLC(2)) .AND. (Y(2).LT.BLC(2))) GO TO 999
      IF ((X(1).GT.TRC(1)) .AND. (X(2).GT.TRC(1))) GO TO 999
      IF ((Y(1).GT.TRC(2)) .AND. (Y(2).GT.TRC(2))) GO TO 999
      IERR = 0
C                                       Loop over points
      XS(1) = X(1)
      XS(2) = X(2)
      YS(1) = Y(1)
      YS(2) = Y(2)
      DO 20 I = 1,2
C                                       Fix point
         IF ((X(I).GE.BLC(1)) .AND. (X(I).LE.TRC(1)) .AND.
     *      (Y(I).GE.BLC(2)) .AND. (Y(I).LE.TRC(2))) GO TO 20
            J = 3 - I
            XX = MAX (BLC(1), MIN (TRC(1), XS(I)))
            YY = MAX (BLC(2), MIN (TRC(2), YS(I)))
            ALPHA = 1.0
            BETA = 1.0
            IF (XS(I).NE.XS(J)) ALPHA = (XX - XS(J)) / (XS(I) - XS(J))
            IF (YS(I).NE.YS(J)) BETA = (YY - YS(J)) / (YS(I) - YS(J))
            ALPHA = MIN (ALPHA, BETA)
            X(I) = XS(J) + ALPHA * (XS(I) - XS(J))
            Y(I) = YS(J) + ALPHA * (YS(I) - YS(J))
 20      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE PRTLIN (OUTLUN, OUTIND, DOCRT, NC, T1, T2, LINE, NLINE,
     *   IPAGE, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! prints line on printer or terminal with page-full handling, headers
C# Printer
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1999, 2004-2005
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PRTLIN handles actual printing on the line printer, disk file, or
C   CRT for tasks.  For the CRT, it also handles page-full user
C   communication.
C   Inputs:
C      OUTLUN  I       LUN for print device (open): 1 => line printer,
C                         3 => text (disk) file, 5 => terminal
C      OUTIND  I       FTAB pointer for print device
C      DOCRT   R       > 0. => use CRT, else line printer or disk
C                      For text-file output only
C                         <= -1.5 -> suppress form-feed characters
C                         <= -2.5 -> suppress all page headers
C      NC      I       Number characters in line
C      T1      C*132   Page title line 1, if ' ' then ignored
C      T2      C*132   Page title line 2, if ' ' then ignored
C      LINE    C*132   Text line, printed even if ' '
C   In/out:
C      NLINE   I       Number lines so far on page
C                         > 1000 => just ask about continuing (DOCRT
C                                   true).  Do not print anything.
C                         =  999 => print new page title(s) and LINE
C                                   but do not ask the user about
C                                   whether he wants to continue
C      IPAGE   I       Current page number
C                         = 0 => start of print job (user not asked on
C                                DOCRT true)
C   Output:
C      SCRTCH  C*(*)   Scratch core > 132
C      IERR    I       Error code: 0 => OK, -1 user asks to quit
C   Hints:
C      (1) First call: set IPAGE = 0, NLINE = (e.g.) 990
C      (2) Thereafter, leave NLINE and IPAGE alone in your code, unless
C      (3) to force a page break, reset NLINE to (e.g.) 990
C   where 990 is an arbitrary number < 999 and > number of lines on the
C   printer page.
C      (4) No special characters are allowed in T1, T2, and LINE
C-----------------------------------------------------------------------
      INTEGER   OUTLUN, OUTIND, NC, NLINE, IPAGE, IERR
      REAL      DOCRT
      CHARACTER SCRTCH*(*), T1*(*), T2*(*), LINE*(*)
C
      CHARACTER TIME*8, DATE*12, CPAGE*2, ONZE*1, SYSN*8, RLSN*9
      INTEGER   IT(6), IAC1, IAC2, IACL, IACT, JTRIM, ITRIM, NCOL, NNC
      LOGICAL   DOLINE
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      SAVE ONZE
      DATA ONZE /' '/
C-----------------------------------------------------------------------
      DOLINE = .TRUE.
      NNC = LEN (LINE)
      NNC = MIN (NNC, NC)
      IACL = JTRIM (LINE(:NNC))
      IACL = MAX (IACL, 1)
C                                       line printer OR disk
      IF (DOCRT.LE.0.0) THEN
         IERR = 0
         IF (NLINE.GT.1000) GO TO 999
C                                       page break
         IF (NLINE.GE.PRTMAX-1) THEN
            CALL WORD (HSTNAM, SYSN)
            RLSN = '(' // RLSNAM(:7) // ')'
            IPAGE = IPAGE + 1
            NLINE = 2
            CALL ZDATE (IT(4))
            CALL ZTIME (IT(1))
            CALL TIMDAT (IT(1), IT(4), TIME, DATE)
            NNC = LEN (T1)
            NNC = MIN (NNC, NC)
            IAC1 = JTRIM (T1(:NNC))
            NNC = LEN (T1)
            NNC = MIN (NNC, NC)
            IAC2 = JTRIM (T2(:NNC))
            IF ((IACL.GT.1) .AND. (LINE(:IACL).EQ.T1(:IAC1)) .AND.
     *         (DOCRT.GT.-2.5)) DOLINE = .FALSE.
            IF ((IACL.GT.1) .AND. (LINE(:IACL).EQ.T2(:IAC2)) .AND.
     *         (DOCRT.GT.-2.5)) DOLINE = .FALSE.
C                                       line printer
            IF (OUTLUN.EQ.1) THEN
C                                       no form feed on first pass
C                                       form feeds on latter passes
               IF (NC.GT.100) THEN
                  WRITE (OUTLUN,1000,ERR=900) ONZE, SYSN, TSKNAM,
     *               RLSN, NLUSER, DATE, TIME, IPAGE
               ELSE
                  WRITE (OUTLUN,1001,ERR=900) ONZE, SYSN, TSKNAM,
     *               RLSN, NLUSER, DATE, TIME, IPAGE
                  END IF
               ONZE = '1'
               IF (IAC1.GT.0) THEN
                  WRITE (OUTLUN,1002,ERR=900) T1(:IAC1)
                  NLINE = NLINE + 1
                  END IF
               IF (IAC2.GT.0) THEN
                  WRITE (OUTLUN,1002,ERR=900) T2(:IAC2)
                  NLINE = NLINE + 1
                  END IF
               IF (NLINE.GT.2) THEN
                  WRITE (OUTLUN,1003,ERR=900)
                  NLINE = NLINE + 1
                  END IF
C                                       text file on disk
            ELSE IF (DOCRT.GT.-2.5) THEN
               IF (DOCRT.GT.-1.5) THEN
                  CALL ZFORMF (CPAGE)
               ELSE
                  CPAGE = ' '
                  END IF
               IF (NC.GT.100) THEN
                  WRITE (SCRTCH,1020,ERR=900) CPAGE, SYSN, TSKNAM,
     *               RLSN, NLUSER, DATE, TIME, IPAGE
               ELSE
                  WRITE (SCRTCH,1021,ERR=900) CPAGE, SYSN, TSKNAM,
     *               RLSN, NLUSER, DATE, TIME, IPAGE
                  END IF
C                                       Use ITRIM to allow form feed
               IACT = ITRIM (SCRTCH(:NC))
               CALL ZTXIO ('WRIT', OUTLUN, OUTIND, SCRTCH(:IACT), IERR)
               IF (IERR.NE.0) GO TO 999
               IF (IAC1.GT.0) THEN
                  CALL ZTXIO ('WRIT', OUTLUN, OUTIND, T1(:IAC1), IERR)
                  IF (IERR.NE.0) GO TO 999
                  NLINE = NLINE + 1
                  END IF
               IF (IAC2.GT.0) THEN
                  CALL ZTXIO ('WRIT', OUTLUN, OUTIND, T2(:IAC2), IERR)
                  IF (IERR.NE.0) GO TO 999
                  NLINE = NLINE + 1
                  END IF
               IF (NLINE.GT.2) THEN
                  SCRTCH(:1)  = ' '
                  CALL ZTXIO ('WRIT', OUTLUN, OUTIND, SCRTCH(:1), IERR)
                  IF (IERR.NE.0) GO TO 999
                  NLINE = NLINE + 1
                  END IF
               END IF
            END IF
         IF (DOLINE) THEN
            NLINE = NLINE + 1
            IF (OUTLUN.EQ.1) THEN
               WRITE (OUTLUN,1002,ERR=900) LINE(:IACL)
            ELSE
               CALL ZTXIO ('WRIT', OUTLUN, OUTIND, LINE(:IACL), IERR)
               END IF
            END IF
C                                       CRT terminal
      ELSE
C                                       page full: continue?
         IF (NLINE.GE.ABS(CRTMAX)-2) THEN
            IF ((NLINE.NE.999) .AND. (IPAGE.NE.0)) THEN
               WRITE (SCRTCH,1100)
               CALL ZTTYIO ('WRIT', OUTLUN, OUTIND, NC, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 999
               CALL ZTTYIO ('READ', OUTLUN, OUTIND, NC, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 999
               IF (SCRTCH(:1).EQ.'Q') IERR = -1
               IF (SCRTCH(:1).EQ.'q') IERR = -1
               IF (IERR.NE.0) GO TO 999
               CALL ZWINC (NCOL)
               IF (NLINE.GT.1000) GO TO 999
               END IF
C                                       Do new page with titles
            CALL WORD (HSTNAM, SYSN)
            RLSN = '(' // RLSNAM(:7) // ')'
            IPAGE = IPAGE + 1
            CALL ZDATE (IT(4))
            CALL ZTIME (IT(1))
            CALL TIMDAT (IT(1), IT(4), TIME, DATE)
            WRITE (SCRTCH,1110) SYSN, TSKNAM, RLSN, NLUSER, DATE, TIME,
     *         IPAGE
            IACT = JTRIM (SCRTCH(:NC))
            CALL ZTTYIO ('WRIT', OUTLUN, OUTIND, IACT, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 999
            NLINE = 1
            NNC = LEN (T1)
            NNC = MIN (NNC, NC)
            IAC1 = JTRIM (T1(:NNC))
            IF (IAC1.GT.0) THEN
               CALL ZTTYIO ('WRIT', OUTLUN, OUTIND, IAC1, T1, IERR)
               IF (IERR.NE.0) GO TO 999
               NLINE = NLINE + 1
               END IF
            NNC = LEN (T1)
            NNC = MIN (NNC, NC)
            IAC2 = JTRIM (T2(:NNC))
            IF (IAC2.GT.0) THEN
               CALL ZTTYIO ('WRIT', OUTLUN, OUTIND, IAC2, T2, IERR)
               IF (IERR.NE.0) GO TO 999
               NLINE = NLINE + 1
               END IF
            IF ((IACL.GT.1) .AND. (LINE(:IACL).EQ.T1(:IAC1))) DOLINE =
     *         .FALSE.
            IF ((IACL.GT.1) .AND. (LINE(:IACL).EQ.T2(:IAC2))) DOLINE =
     *         .FALSE.
            END IF
C                                       actual output
         IF (DOLINE) THEN
            NLINE = NLINE + 1
            CALL ZTTYIO ('WRIT', OUTLUN, OUTIND, IACL, LINE, IERR)
            END IF
         END IF
      GO TO 999
C                                       Write to printer error
 900  IERR = 4
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A1,5X,A8,3X,A5,A9,4X,I4,15X,A12,2X,A8,15X,'Page',I5/)
 1001 FORMAT (A1,1X,A8,2X,A5,A9,3X,I4,5X,A12,1X,A8,4X,'Page',I5/)
 1002 FORMAT (' ',A)
 1003 FORMAT (' ')
 1020 FORMAT (A,5X,A8,3X,A5,A9,4X,I4,15X,A12,2X,A8,15X,'Page',I5)
 1021 FORMAT (A,1X,A8,2X,A5,A9,3X,I4,5X,A12,1X,A8,4X,'Page',I5)
 1100 FORMAT ('Type Q to stop, just hit RETURN to continue')
 1110 FORMAT (1X,A8,2X,A5,A9,3X,I4,5X,A12,1X,A8,4X,'Page',I5)
      END

      DOUBLE PRECISION FUNCTION DPMPAR (I)
C-----------------------------------------------------------------------
C! returns machine precision or smallest or largest magnitude
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   This function provides double precision machine parameters
C   when the appropriate set of data statements is activated (by
C   removing the C from column 1) and all other data statements are
C   rendered inactive. Most of the parameter values were obtained
C   from the corresponding Bell Laboratories port library function.
C   Argonne National Laboratory. Minpack Project. March 1980.
C   Burton S. Garbow, Kenneth E. Hillstrom, Jorge J. More
C   INPUT:  I   I   set to 1, 2, or 3 which selects the desired
C               machine parameter. If the machine has T base B digits
C               and its smallest and largest exponents are EMIN and
C               EMAX, respectively, then these parameters are
C
C         DPMPAR(1) = B**(1 - T), the machine precision,
C
C         DPMPAR(2) = B**(EMIN - 1), the smallest magnitude,
C
C         DPMPAR(3) = B**EMAX*(1 - B**(-T)), the largest magnitude.
C-----------------------------------------------------------------------
      DOUBLE PRECISION    DMACH(3)
      INTEGER   I
C                                       For VAX:
      DATA DMACH /2.7755576D-17,  .2938735877055719D-38,
     *   .1701411834604692D39/
C-----------------------------------------------------------------------
      DPMPAR = DMACH(I)
C
 999  RETURN
      END

      SUBROUTINE SNRESC (DISK, CNO, VER, CATBLK, LUN, IRET)
C-----------------------------------------------------------------------
C! Applies mean gain modulus to an SN table reseting it in header
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1998, 2000, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Applies mean gain modulus to an SN table reseting it from header
C   NOTE: routine uses LUN 45 as a temporary logical unit number.
C   Inputs:
C      DISK            I       Volume number
C      CNO             I       Catalogue number
C      VER             I       Version to check/modify
C      CATBLK(256)     I       Catalogue header
C      LUN             I       LUN to use
C   Output:
C      IRET            I       Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER DISK, CNO, VER, CATBLK(256), LUN, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER KEYWRD*8
      INTEGER   BUFFER(512), ISNRNO, SNKOLS(MAXSNC), SNNUMV(MAXSNC),
     *   NUMANT, NUMPOL, NUMIF, NUMNOD, IP, IPM, NSNROW, I, IIF, SOURID,
     *   ANTNO, SUBA, FREQID, NODENO, REFA(2,MAXIF), KLOCS, KEYTYP,
     *   NUMKEY
      LOGICAL ISAPPL, TABLE, EXIST, FITASC
      REAL    GMMOD, RANOD(25), DECNOD(25), TIMEI, IFR, MBDELY(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF),
     *   RATE(2,MAXIF), WEIGHT(2,MAXIF), DISP(2), DDISP(2)
      DOUBLE PRECISION TIME
      INCLUDE 'INCS:PSNTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       Check existance
      CALL ISTAB ('SN', DISK, CNO, VER, LUN, BUFFER, TABLE, EXIST,
     *   FITASC, IRET)
      IRET = 0
      IF (.NOT.EXIST) GO TO 999
C                                       Open SN file
      CALL SNINI ('WRIT', BUFFER, DISK, CNO, VER, CATBLK, LUN, ISNRNO,
     *   SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, GMMOD, RANOD,
     *   DECNOD, ISAPPL, IRET)
      IF (IRET.EQ.2) THEN
         IRET = 0
         GO TO 999
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN SN FOR READ'
         GO TO 990
         END IF
C                                       No gain modulus to apply
      IF (ABS(GMMOD-1.0).LT.1.E-5) GO TO 900
C                                       Reformat table; should be able
C                                       to read old tables with TABSN.
      WRITE (MSGTXT,1010) VER, GMMOD
      CALL MSGWRT (4)
      GMMOD = 1.0 / GMMOD
C                                       # rows in old table
      NSNROW = BUFFER(5)
      IPM = MIN (2, NUMPOL)
C                                       Loop and copy
      DO 100 I = 1,NSNROW
         ISNRNO = I
         CALL TABSN ('READ', BUFFER, ISNRNO, SNKOLS, SNNUMV, NUMPOL,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
C                                       Deselected record.
         IF (IRET.GT.0) THEN
            GO TO 999
         ELSE IF (IRET.EQ.0) THEN
            DO 30 IIF = 1,NUMIF
               DO 20 IP = 1,IPM
                  IF ((CREAL(IP,IIF).NE.FBLANK) .AND.
     *               (DELAY(IP,IIF).NE.FBLANK)) THEN
                     CREAL(IP,IIF) = CREAL(IP,IIF) * GMMOD
                     CIMAG(IP,IIF) = CIMAG(IP,IIF) * GMMOD
                     END IF
 20               CONTINUE
 30            CONTINUE
C                                       re-write record
            ISNRNO = I
            CALL TABSN ('WRIT', BUFFER, ISNRNO, SNKOLS, SNNUMV, NUMPOL,
     *         TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *         MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *         REFA, IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
 100     CONTINUE
C                                       update GMMOD
      GMMOD = 1.0
      KEYWRD = 'MGMOD'
      NUMKEY = 1
      KLOCS = 1
      KEYTYP = 2
      CALL TABKEY ('WRIT', KEYWRD, NUMKEY, BUFFER, KLOCS, GMMOD, KEYTYP,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'RESETTING MGMOD TO 1.0'
         GO TO 990
         END IF
C                                       close
 900  CALL TABIO ('CLOS', 0, ISNRNO, BUFFER, BUFFER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSE SN FOR READ'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SNRESC: ERROR',I5,' AT ',A)
 1010 FORMAT ('SNRESC: Rescaling SN table',I5,' by mean gain',F7.3)
      END

      SUBROUTINE YOFM (OP, COLOR, VRTRTC, OFM, IERR)
C-----------------------------------------------------------------------
C! read/write all-channel look-up-table ("output function memory")
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YOFM reads/writes full OFM look up tables to TV.
C   Inputs:
C      OP      C*4    'READ' from TV, 'WRIT' to TV
C      COLOR   I      color select bit mask (RGB <-> 421)
C      VRTRTC  L      T => do it only during vertical retrace
C   In/Out:
C      OFM     R(*)   look up table (dimension = OFMINP+1, values 0
C                     through 1 are used, others clipped)
C   Output:
C      IERR    I      error code of Z...XF : 0 => ok, 2 => input error
C   IVAS version: OFM is 8-bits in and out for the IVAS
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   COLOR, IERR
      REAL      OFM(*)
      LOGICAL   VRTRTC
C
      INTEGER   I, ZAND, JB, JERR, LBUF(256)
      REAL      GAMINV, TEMP
      INTEGER   FIVASVPOFM
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
      CALL YVRTR (VRTRTC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       write
      IF (OP.EQ.'WRIT') THEN
         OFM(1) = 0
         JB = 0
         IF (ZAND(COLOR, 1).NE.0) JB = JB + 48
         IF (ZAND(COLOR, 2).NE.0) JB = JB + 12
         IF (ZAND(COLOR, 4).NE.0) JB = JB + 3
         GAMINV = 1.0
         IF (TVGAMA.GT.0.0001) GAMINV = 1.0 / TVGAMA
         DO 10 I = 1,256
             TEMP = MAX (0.0, MIN (1.0, OFM(I)))
             LBUF(I) = (TEMP ** GAMINV) * 255.0 + 0.025
 10          CONTINUE
         JERR = FIVASVPOFM (LBUF, 0, 256, 1, JB)
         IF (JERR.NE.0) GO TO 900
C                                       read
      ELSE
         JB = 1
         IF (ZAND(COLOR, 1).NE.0) JB = 16
         IF (ZAND(COLOR, 2).NE.0) JB = 4
         IF (ZAND(COLOR, 4).NE.0) JB = 1
         JERR = FIVASVPOFM (LBUF, 0, 256, 2, JB)
         IF (JERR.NE.0) GO TO 900
         DO 20 I = 1,256
            LBUF(I) = MOD (LBUF(I), 256)
            IF (LBUF(I).LT.0) LBUF(I) = LBUF(I) + 256
            OFM(I) = MAX (0.0, MIN (1.0, LBUF(I)/255.0)) ** TVGAMA
 20         CONTINUE
         END IF
      GO TO 999
C                                       Error
 900  CALL YDOERR ('YOFM', JERR, IERR)
C
 999  RETURN
      END

      SUBROUTINE HICOPY (LUN1, BUF1, LUN2, BUF2, IERR)
C-----------------------------------------------------------------------
C! copies one history file to the end of a second
C# History
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2017
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   HICOPY copies all of history file 1 adding it to the end of history
C   file 2.  Both files must already be opened by HIOPEN.  No closing
C   is done.
C   Inputs:
C      LUN1  I         input LUN
C      LUN2  I         output LUN
C   In/Out:
C      BUF1  I(256)    input HI work buffer
C      BUF2  I(256)    output HI work buffer
C   Output:
C      IERR  I         error code = 0 => ok
C                                   1 => file not open
C                           other (<100) from HIADD
C                           other (>100) from ZFIO+100
C                           0 returned if input file is empty
C-----------------------------------------------------------------------
      INTEGER   LUN1, BUF1(256), LUN2, BUF2(256), IERR
C
      INTEGER   HPT1, HPT2, IER, MREC, IND, NREC, NC, I
      CHARACTER HILINE*72
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                        locate files
      IERR = 1
      CALL HILOCT ('SRCH', LUN1, HPT1, IER)
      IF (IER.NE.0) GO TO 999
      CALL HILOCT ('SRCH', LUN2, HPT2, IER)
      IF (IER.NE.0) GO TO 999
      IERR = 0
C                                        loop limits
      MREC = HITAB(HPT1+2)
      IND = HITAB(HPT1+1)
      HPT1 = HPT1 + 6
C                                        loop adding MREC lines
      DO 30 I = 1,MREC
         NREC = (I-1) / NHILPR + 1
C                                        read input
         IF (NREC.EQ.HITAB(HPT1)) GO TO 20
            HITAB(HPT1) = NREC
            CALL ZFIO ('READ', LUN1, IND, NREC, BUF1, IERR)
            IF (IERR.NE.0) GO TO 900
C                                        add output
 20      NC = 5 + NHIWPL * MOD (I-1, NHILPR)
         CALL H2CHR (72, 1, BUF1(NC), HILINE)
         CALL HIADD (LUN2, HILINE, BUF2, IERR)
         IF (IERR.NE.0) GO TO 910
 30      CONTINUE
      GO TO 999
C                                        errors
 900  WRITE (MSGTXT,1900) IERR
      IERR = IERR + 100
      GO TO 980
 910  WRITE (MSGTXT,1910) IERR
 980  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('HICOPY READ ERROR',I7)
 1910 FORMAT ('HICOPY ADD ERROR', I7)
      END

      SUBROUTINE AU3B (BRANCH)
C-----------------------------------------------------------------------
C! verbs to rearrange the entries in the catalog file: RECAT, RENUMBER
C# POPS-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004-2005, 2007, 2009-2010, 2012-2013, 2021,
C;  Copyright (C) 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AU3B is a subroutine of the AIPS program to do the verbs:
C   BRANCH = 1  RENUMBER   Move file from 1 cat slot to another
C            2  RECAT      Compress the catalog
C            3  SYSTEM     Send a command to the operating system
C            4  VLA        return list of VLA antennas
C            5  EVLA       return list of EVLA antennas
C            4  VLBA       return list of VLBA antennas
C            4  HSA        return list of HSA antennas
C            8  DELAY      delays aips the specified number seconds
C            9  ADDDISK    add REMHOST's disks to usable set
C           10  REMDISK    drop REMHOST's disks from usable set
C           11  IM2HEAD    IMHEADER of image 2
C           12  Q2HEADER   QHEADER of image 2
C           13  IM3HEAD    IMHEADER of image 3
C           14  Q3HEADER   QHEADER of image 3
C           15  IM4HEAD    IMHEADER of image 4
C           16  Q4HEADER   QHEADER of image 4
C           17  IMOHEAD    IMHEADER of image out
C           18  QOHEADER   QHEADER of image out
C           19  IM5HEAD    IMHEADER of image 5
C           20  Q5HEADER   QHEADER of image 5
C   RENUMBER uses adverbs INNAME, INCLASS, INSEQ, INDISK, SLOT.
C   RECAT uses adverb INDISK.
C   SYSTEM uses SYSOUT and SYSCOM, sets ERROR.
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      CHARACTER LOCNAM*12, LOCCLS*6, LOCTYP*2, STAT*4, PRGNAM*6, CDUM*1,
     *   SYSCOM*72, SYSOUT*72, SYS2C(8)*64, COMMND*1024, VLBA(10)*8,
     *   HSA(4)*8, RHOST*24, KEYWOD(50)*8, KEYCHR*8
      INTEGER   POTERR, LOCSEQ, IVOL, LUSER, ICNO, OCNO, CLUN, IDUM, I,
     *   CIND, CMAX, BUF1(256), BUF2(256), BUF3(256), IBVOL, IEVOL,
     *   IERR, IER, NR, JTRIM, WERSOM, IIP, LSAVE, VER, IABUF(512),
     *   LUNA, J, JJ, SCAT, NUMKEY, LOCS(50), IVALUE(100), KEYTS(50)
      HOLLERITH HVAL, HNAME
      REAL      RDUM, DTIME, VALUE(100)
      LOGICAL   IAMOK, NORMAL, LVALUE(100)
      DOUBLE PRECISION BSC, BZE
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSMS.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DISK.INC'
      EQUIVALENCE (IABUF, BUF2)
      EQUIVALENCE (IVALUE, LVALUE, VALUE)
      COMMON /AIPSCR/ BUF1, BUF2, BUF3
      DATA CLUN, LUNA /15,29/
      DATA PRGNAM /'AU3B  '/
      DATA VLBA /'BR','FD','HN','KP','NL','OV','PT','LA','SC','MK'/
      DATA HSA /'GB','Y','AR','EB'/
C-----------------------------------------------------------------------
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.20)) GO TO 999
      LUSER = NLUSER
      POTERR = 33
      CALL ADVERB ('INDISK', 'I', 1, 0, IVOL, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
C                                       branch to header displays
      IF (BRANCH.GT.10) GO TO 700
C                                       other functions
      GO TO (100, 200, 300, 400, 400, 400, 400, 500, 600, 600), BRANCH
C-----------------------------------------------------------------------
C                                       RENUMBER
C                                       slot change
C-----------------------------------------------------------------------
C                                       find input
 100  LOCTYP = ' '
      CALL ADVERB ('INSEQ', 'I', 1, 0, LOCSEQ, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INNAME', 'C', 1, 12, IDUM, RDUM, LOCNAM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INCLASS', 'C', 1, 6, IDUM, RDUM, LOCCLS)
      IF (ERRNUM.NE.0) GO TO 980
      CALL CATDIR ('SRCH', IVOL, ICNO, LOCNAM, LOCCLS, LOCSEQ, LOCTYP,
     *   LUSER, STAT, BUF1, IERR)
      IF (IERR.EQ.0) GO TO 110
         WRITE (MSGTXT,1100) IERR
         CALL MSGWRT (6)
         GO TO 980
 110  CALL ADVERB ('SLOT', 'I', 1, 0, OCNO, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
C                                       open catalog
      CALL CATOPN (IVOL, CIND, BUF1, CMAX, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       do renumber
      CALL RENUMB (IVOL, CLUN, CIND, CMAX, ICNO, OCNO, BUF1, BUF2, BUF3,
     *   IERR)
C                                       close catalog
      CALL ZCLOSE (CLUN, CIND, IER)
      IF (IERR.NE.0) GO TO 900
      GO TO 999
C-----------------------------------------------------------------------
C                                       RECAT
C                                       compress catalog
C-----------------------------------------------------------------------
 200  NR = 0
      IF ((IVOL.LE.0) .OR. (IVOL.GT.NVOL)) THEN
         IBVOL = 1
         IEVOL = NVOL
      ELSE
         IBVOL = IVOL
         IEVOL = IVOL
         END IF
      DO 230 IVOL = IBVOL,IEVOL
         OCNO = 1
         WERSOM = 0
C                                       open catalog
         IF (.NOT.IAMOK(IVOL,'CA')) GO TO 230
         CALL CATOPN (IVOL, CIND, BUF1, CMAX, IERR)
         IF (IERR.EQ.0) GO TO 210
            WRITE (MSGTXT,1200) IVOL, IERR
            CALL MSGWRT (6)
            GO TO 230
 210     DO 220 ICNO = 1,CMAX
C                                       do renumber
            CALL RENUMB (IVOL, CLUN, CIND, CMAX, ICNO, OCNO, BUF1, BUF2,
     *         BUF3, IERR)
            IF (IERR.EQ.1) GO TO 220
               IF (IERR.EQ.0) THEN
                  IF (ICNO.NE.OCNO) THEN
                     WRITE (MSGTXT,1210) IVOL, ICNO, OCNO
                     CALL MSGWRT (2)
                     WERSOM = -1
                  ELSE
                     IF (WERSOM.GE.0) WERSOM = WERSOM + 1
                     END IF
               ELSE IF (IERR.GT.1) THEN
                  IF (IERR.EQ.2) WRITE (MSGTXT,1211) IVOL, ICNO, OCNO
                  IF (IERR.EQ.3) WRITE (MSGTXT,1212) IVOL, ICNO
                  IF (IERR.EQ.4) WRITE (MSGTXT,1213) IVOL, ICNO, OCNO
                  IF (IERR.EQ.5) WRITE (MSGTXT,1214) IVOL, ICNO, OCNO
                  IF (IERR.EQ.6) WRITE (MSGTXT,1215) IVOL, ICNO, OCNO
                  CALL MSGWRT (6)
                  GO TO 225
                  END IF
               OCNO = OCNO + 1
 220        CONTINUE
C                                       close catalog
 225     CALL ZCLOSE (CLUN, CIND, IERR)
         NR = NR + OCNO - 1
         IF (WERSOM.GT.0) THEN
            WRITE (MSGTXT,1225) IVOL
            CALL MSGWRT (2)
            END IF
 230     CONTINUE
      WRITE (MSGTXT,1230)
      IF (NR.LE.0) CALL MSGWRT (6)
      GO TO 999
C-----------------------------------------------------------------------
C                                       SYSTEM
C                                       send a command to the OS
C-----------------------------------------------------------------------
 300  CALL ADVERB ('SYSOUT', 'C', 1, 72, IDUM, RDUM, SYSOUT)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('SYSCOM', 'C', 1, 72, IDUM, RDUM, SYSCOM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('SYS2COM', 'C', 8, 64, IDUM, RDUM, SYS2C)
      IF (ERRNUM.NE.0) GO TO 980
      IBVOL = JTRIM (SYSCOM)
      COMMND = SYSCOM
      IIP = IBVOL + 1
      DO 310 I = 1,8
         IBVOL = JTRIM (SYS2C(I))
         IF (IBVOL.GT.0) THEN
            COMMND(IIP:) = SYS2C(I)
            IIP = IIP + IBVOL
            END IF
 310     CONTINUE
      I = INDEX (COMMND, ' >')
      IF (I.EQ.0) THEN
         IF (SYSOUT.EQ.' ') SYSOUT = '/dev/tty'
         IEVOL = JTRIM (SYSOUT)
         COMMND(IIP:) = ' >> ' // SYSOUT
         END IF
      IBVOL = JTRIM (COMMND)
      MSGTXT = 'SYSTEM command to be executed is:'
      CALL MSGWRT (3)
      DO 320 I = 1,16
         IEVOL = 1 + (I-1)*64
         MSGTXT = COMMND(IEVOL:IEVOL+63)
         IF (MSGTXT.NE.' ') CALL MSGWRT (3)
 320     CONTINUE
      IEVOL = 0
      CALL ZSHCMD (IBVOL, COMMND, IEVOL, SYSOUT, IERR)
      NR = -1
      IF (IERR.GT.0) NR = 1
      CALL ADVRBS ('ERROR', 'I', 1, 0, NR, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      GO TO 999
C-----------------------------------------------------------------------
C                                       VLA, EVLA, VLBA, hsa
C-----------------------------------------------------------------------
C                                       find input
 400  LOCTYP = 'UV'
      CALL ADVERB ('DOINVERS', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      NORMAL = RDUM.LE.0.0
      CALL ADVERB ('SUBARRAY', 'I', 1, 0, VER, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INSEQ', 'I', 1, 0, LOCSEQ, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INNAME', 'C', 1, 12, IDUM, RDUM, LOCNAM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INCLASS', 'C', 1, 6, IDUM, RDUM, LOCCLS)
      IF (ERRNUM.NE.0) GO TO 980
      CALL CATDIR ('SRCH', IVOL, ICNO, LOCNAM, LOCCLS, LOCSEQ, LOCTYP,
     *   LUSER, STAT, BUF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1100) IERR
         CALL MSGWRT (6)
         GO TO 980
         END IF
      CALL CATIO ('READ', IVOL, ICNO, CATBLK, 'REST', BUF1, IERR)
      IF (IERR.NE.0) THEN
         POTERR = 33
         WRITE (MSGTXT,1400) IERR
         CALL MSGWRT (8)
         GO TO 980
         END IF
C                                        Init AN file.
      POTERR = 45
      IF (VER.LE.0) VER = 1
      CALL ANTINI ('READ', IABUF, IVOL, ICNO, VER, CATBLK, LUNA, IANRNO,
     *   ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE, POLRXY,
     *   UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB, NOPCAL,
     *   ANTNIF, ANFQID, IERR)
      IF (IERR.NE.0) GO TO 980
      NR = IABUF(5)
      LX = 0
      POTERR = 50
      DO 420 I = 1,NR
         IANRNO = I
         CALL TABAN ('READ', IABUF, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA,POLTYB, POLAB, POLCB, IERR)
         IF (IERR.NE.0) GO TO 970
         IF ((ANNAME(6:8).EQ.'OUT') .OR. (ANNAME(5:8).EQ.'OUT '))
     *      GO TO 420
         LX = LX + 1
         X(LX) = NOSTA
         IF (BRANCH.EQ.4) THEN
            IF (NORMAL) THEN
               IF (ANNAME(1:4).NE.'VLA:') LX = LX - 1
            ELSE
               IF (ANNAME(1:4).EQ.'VLA:') LX = LX - 1
               END IF
         ELSE IF (BRANCH.EQ.5) THEN
            IF (NORMAL) THEN
               IF (ANNAME(1:5).NE.'EVLA:') LX = LX - 1
            ELSE
               IF (ANNAME(1:5).EQ.'EVLA:') LX = LX - 1
               END IF
         ELSE IF (BRANCH.EQ.6) THEN
            DO 410 IIP = 1,10
               IF (ANNAME.EQ.VLBA(IIP)) THEN
                  IF (.NOT.NORMAL) LX = LX - 1
                  GO TO 420
                  END IF
 410           CONTINUE
            IF (NORMAL) LX = LX - 1
         ELSE IF (BRANCH.EQ.7) THEN
            DO 415 IIP = 1,4
               IF (ANNAME.EQ.HSA(IIP)) THEN
                  IF (.NOT.NORMAL) LX = LX - 1
                  GO TO 420
                  END IF
 415           CONTINUE
            IF (NORMAL) LX = LX - 1
            END IF
 420     CONTINUE
C                                       list onto stack
      SYTYPE = 12
      LSAVE = L
      CALL LTSTOR
      L = LSAVE
      STACK(SP+1) = 12
      STACK(SP+2) = LX
      STACK(SP+3) = TAG
      STACK(SP+4) = 2
      SP = SP + 4
      POTERR = 0
      GO TO 970
C-----------------------------------------------------------------------
C                                       DELAY
C                                       delay s seconds
C-----------------------------------------------------------------------
 500  DTIME = 0.0
      IF ((SP.GE.1) .AND. (STACK(SP).NE.2)) THEN
         DTIME = V(SP)
         SP = SP - 1
         END IF
      IF (DTIME.LE.0.0) THEN
         CALL ADVERB ('DETIME', 'R', 1, 0, IDUM, DTIME, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         END IF
      WRITE (MSGTXT,1500) DTIME
      IF (DTIME.GE.5) CALL MSGWRT (1)
C                                       doit
      IF (DTIME.GT.0.0) CALL ZDELAY (DTIME, IDUM)
      POTERR = 0
      GO TO 980
C-----------------------------------------------------------------------
C                                       ADDDISK, REMDISK
C                                       add or remove disk assignements
C-----------------------------------------------------------------------
 600  IBVOL = NVOL
      CALL ADVERB ('REMHOST', 'C', 1, 24, IDUM, RDUM, RHOST)
      IF (ERRNUM.NE.0) GO TO 980
      IF (RHOST.EQ.' ') THEN
         MSGTXT = 'REMHOST MUST BE SPECIFIED TO ADD OR REM DISKS'
         CALL MSGWRT (8)
         POTERR = 24
         GO TO 980
         END IF
      J = JTRIM (RHOST)
      DO 610 I = 1,36
         IF (RHOST.EQ.DSKHST(I)) THEN
            IF (BRANCH.EQ.9) THEN
               MSGTXT = RHOST(:J) // ' ALREADY IN DISK LIST'
               CALL MSGWRT (8)
               POTERR = 14
               GO TO 980
            ELSE
               IF (I.GT.MINDSK) GO TO 620
               END IF
            END IF
 610     CONTINUE
      IF (BRANCH.EQ.10) THEN
         MSGTXT = RHOST(:J) // ' NOT ALREADY IN DISK LIST'
         CALL MSGWRT (6)
         POTERR = 0
         GO TO 980
         END IF
C                                       Do it
 620  J = BRANCH - 8
      CALL DSKASS (J, RHOST, IER)
      POTERR = 0
      IF (IER.NE.0) THEN
         POTERR = 50
      ELSE IF (NVOL.NE.IBVOL) THEN
         WRITE (MSGTXT,1620) IBVOL, NVOL
         CALL MSGWRT (2)
         WRITE (MSGTXT,1621) NVOL
         CALL CHR2H (4, 'NVOL', 1, HVAL)
         IF (NVOL.LE.9) THEN
            JJ = 1
            CALL CHR2H (JJ, MSGTXT(2:2), 1, HNAME)
         ELSE
            JJ = 2
            CALL CHR2H (JJ, MSGTXT(1:2), 1, HNAME)
            END IF
         CALL ZCRLOG (4, HVAL, JJ, HNAME, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'RESETTING LOGICAL NVOL FAILS'
            CALL MSGWRT (7)
            END IF
         END IF
      GO TO 980
C-----------------------------------------------------------------------
C                                       IMxHEAD
C                                       QxHEADER
C                                       display  header information
C-----------------------------------------------------------------------
 700  MSGTXT = 'Header for'
      IF (BRANCH.LE.12) THEN
         CALL ADVERB ('IN2NAME', 'C', 1, 12, IDUM, RDUM, LOCNAM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN2CLASS', 'C', 1, 6, IDUM, RDUM, LOCCLS)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN2SEQ', 'I', 1, 0, LOCSEQ, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN2DISK', 'I', 1, 0, IVOL, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         MSGTXT(12:) = 'second input image or data set'
      ELSE IF (BRANCH.LE.14) THEN
         CALL ADVERB ('IN3NAME', 'C', 1, 12, IDUM, RDUM, LOCNAM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN3CLASS', 'C', 1, 6, IDUM, RDUM, LOCCLS)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN3SEQ', 'I', 1, 0, LOCSEQ, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN3DISK', 'I', 1, 0, IVOL, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         MSGTXT(12:) = 'third input image or data set'
      ELSE IF (BRANCH.LE.16) THEN
         CALL ADVERB ('IN4NAME', 'C', 1, 12, IDUM, RDUM, LOCNAM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN4CLASS', 'C', 1, 6, IDUM, RDUM, LOCCLS)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN4SEQ', 'I', 1, 0, LOCSEQ, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN4DISK', 'I', 1, 0, IVOL, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         MSGTXT(12:) = 'fourth input image or data set'
      ELSE IF (BRANCH.LE.18) THEN
         CALL ADVERB ('OUTNAME', 'C', 1, 12, IDUM, RDUM, LOCNAM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('OUTCLASS', 'C', 1, 6, IDUM, RDUM, LOCCLS)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('OUTSEQ', 'I', 1, 0, LOCSEQ, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('OUTDISK', 'I', 1, 0, IVOL, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         MSGTXT(12:) = 'first output image or data set'
      ELSE IF (BRANCH.LE.20) THEN
         CALL ADVERB ('IN5NAME', 'C', 1, 12, IDUM, RDUM, LOCNAM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN5CLASS', 'C', 1, 6, IDUM, RDUM, LOCCLS)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN5SEQ', 'I', 1, 0, LOCSEQ, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('IN5DISK', 'I', 1, 0, IVOL, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         MSGTXT(12:) = 'fifth input image or data set'
         END IF
      CALL MSGWRT (2)
      LOCTYP = ' '
      LUSER = NLUSER
      SCAT = 1
      POTERR = 45
      CALL CATDIR ('SRNH', IVOL, SCAT, LOCNAM, LOCCLS, LOCSEQ,
     *   LOCTYP, LUSER, STAT, BUF1, IERR)
      IF (IERR.NE.0) GO TO 980
C                                        one found: read header
      CALL CATIO ('READ', IVOL, SCAT, CATBLK, 'REST', BUF1, IERR)
      IF ((IERR.GT.0) .AND. (IERR.LT.5)) GO TO 980
C                                       IMxHEAD
      IF (MOD(BRANCH,2).EQ.1) THEN
C                                       read keywords on scaling
         NUMKEY = 2
         KEYWOD(1) = 'ISCALE'
         KEYWOD(2) = 'IZERO'
         CALL CATKEY ('REED', IVOL, SCAT, KEYWOD, NUMKEY, LOCS, VALUE,
     *      KEYTS, BUF1, IERR)
         BSC = 1.0D0
         BZE = 0.0D0
         IF ((IERR.LE.0) .OR. (IERR.GT.20)) THEN
            IF (LOCS(1).GT.0) CALL RCOPY (NWDPDP, VALUE(LOCS(1)), BSC)
            IF (LOCS(2).GT.0) CALL RCOPY (NWDPDP, VALUE(LOCS(2)), BZE)
            END IF
C                                       finally list the header
         CALL LSTHDR (CATBLK, CATH, CATR, CATD, BSC, BZE)
C                                       All other keywords
         NUMKEY = 50
         CALL CATKEY ('ALL ', IVOL, SCAT, KEYWOD, NUMKEY, LOCS, VALUE,
     *      KEYTS, BUF1, IERR)
         IF ((IERR.NE.0) .OR. (NUMKEY.LE.0)) GO TO 999
         DO 720 I = 1,NUMKEY
            J = LOCS(I)
            IF ((KEYWOD(I).NE.'ISCALE') .AND. (KEYWOD(I).NE.'IZERO')
     *         .AND. (J.GT.0)) THEN
               IF (KEYTS(I).EQ.1) THEN
                  CALL RCOPY (NWDPDP, VALUE(J), BSC)
                  WRITE (MSGTXT,1710) KEYWOD(I), BSC
               ELSE IF (KEYTS(I).EQ.2) THEN
                  WRITE (MSGTXT,1711) KEYWOD(I), VALUE(J)
               ELSE IF (KEYTS(I).EQ.3) THEN
                  CALL H2CHR (8, 1, VALUE(J), KEYCHR)
                  WRITE (MSGTXT,1712) KEYWOD(I), KEYCHR
               ELSE IF (KEYTS(I).EQ.4) THEN
                  WRITE (MSGTXT,1713) KEYWOD(I), IVALUE(J)
               ELSE IF (KEYTS(I).EQ.5) THEN
                  WRITE (MSGTXT,1714) KEYWOD(I), LVALUE(J)
               ELSE
                  WRITE (MSGTXT,1715) KEYWOD(I), KEYTS(I)
                  END IF
               CALL MSGWRT (2)
               END IF
 720        CONTINUE
C                                       QxHEADER
      ELSE
         CALL KWIKHD
         END IF
      POTERR = 0
      GO TO 980
C-----------------------------------------------------------------------
C                                       error messages from RENUMB
 900  IF (IERR.EQ.2) WRITE (MSGTXT,1211) IVOL, ICNO, OCNO
      IF (IERR.EQ.3) WRITE (MSGTXT,1212) IVOL, ICNO
      IF (IERR.EQ.4) WRITE (MSGTXT,1213) IVOL, ICNO, OCNO
      IF (IERR.EQ.5) WRITE (MSGTXT,1214) IVOL, ICNO, OCNO
      IF (IERR.EQ.6) WRITE (MSGTXT,1215) IVOL, ICNO, OCNO
      IF (IERR.EQ.1) WRITE (MSGTXT,1216) IVOL, ICNO
      CALL MSGWRT (6)
      GO TO 980
C                                       close an file
 970  CALL TABAN ('CLOS', IABUF, IANRNO, ANKOLS, ANNUMV, ANNAME, STAXYZ,
     *   ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN, POLTYA, POLAA,
     *   POLCA, POLTYB, POLAB, POLCB, IERR)
C                                       AIPS error management.
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('CAN''T FIND REQUESTED INPUT IMAGE.  ERROR =',I5)
 1200 FORMAT ('DISK',I3,' ERROR',I5,' OPENING THE CATALOG FILE')
 1210 FORMAT ('Disk',I3,' in-CNO',I5,' renumbered as CNO',I5)
 1211 FORMAT ('DISK',I3,' IN-CNO',I5,' OUT-CNO',I5,
     *   ' CALLING PARM ERROR')
 1212 FORMAT ('DISK',I3,' IN-CNO',I5,' TOO BUSY')
 1213 FORMAT ('DISK',I3,' IN-CNO',I5,' OUT-CNO',I5,' NOT EMPTY')
 1214 FORMAT ('DISK',I3,' IN-CNO',I5,' OUT-CNO',I5,
     *   ' CATALOG I/O ERROR')
 1215 FORMAT ('DISK',I3,' IN-CNO',I5,' OUT-CNO',I5,
     *   ' RENUMBERING PROBLEM')
 1216 FORMAT ('DISK',I3,' IN-CNO',I5,' SLOT EMPTY')
 1225 FORMAT ('Disk',I3,' No files needed renumbering')
 1230 FORMAT ('NO FILES RENUMBERED')
 1400 FORMAT ('ERROR',I5,' READING IMAGE HEADER FROM MAIN CATALOG')
 1500 FORMAT ('Delaying by',F8.1,' seconds')
 1620 FORMAT ('Number of disks changed from',I3,' to',I3)
 1621 FORMAT (I2)
 1710 FORMAT ('Keyword = ''',A8,'''  value = ',1PD15.8)
 1711 FORMAT ('Keyword = ''',A8,'''  value = ',1PE13.6)
 1712 FORMAT ('Keyword = ''',A8,'''  value = ''',A8,'''')
 1713 FORMAT ('Keyword = ''',A8,'''  value = ',I12)
 1714 FORMAT ('Keyword = ''',A8,'''  value = ',L1)
 1715 FORMAT ('KEYWORD = ''',A8,'''  INVALID KEYTYPE = ',I12)
      END

      SUBROUTINE PSHIFT (DELTAX, POLYN, DEGREE)
C-----------------------------------------------------------------------
C! Shifts the origin of a polynomial function by delta-x
C# EXT-appl VLBI
C-----------------------------------------------------------------------
C;  Copyright (C) 1997-1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Given the coefficients of a polynomial function of x in POLYN
C   such that the function has the value sum(POLYN(i) * x**i), shift
C   the origin of the polynomial to DELTAX.
C
C   Inputs:
C      DELTAX   D              Shift in origin
C      DEGREE   I              Degree of polynomial
C
C   Outputs:
C      POLYN    D(0:DEGREE)    Polynomial coefficients
C
C   DEGREE must lie in the range 0 to 16 inclusive; the upper bound
C   may be increased by changing the parameter MAXPLY and recompiling.
C
C   Algorithm from M. Shaw and J.F. Traub, JACM 21, 161-167 (1974)
C   reported in D.E. Knuth, "The Art of Computer Programming", Vol 2
C   (3rd edn.) p489.
C-----------------------------------------------------------------------
      INTEGER          DEGREE
      DOUBLE PRECISION DELTAX, POLYN(0:DEGREE)
C
C     Local variables:
C
C     MAXPLY    Maximum degree of polynomial
C     POWER     Precomputed powers of DELTAX
C     J         Loop counter
C     I         Loop counter
C
      INTEGER   MAXPLY
      PARAMETER (MAXPLY = 16)
      DOUBLE PRECISION POWER(0:MAXPLY)
      INTEGER   J, K
C-----------------------------------------------------------------------
C
C     Precompute powers of DELTAX (Step S1 in Knuth with x0 = DELTAX):
C
      POWER(0) = 1.0D0
      DO 10 J = 1, DEGREE
         POWER(J) = DELTAX * POWER(J - 1)
   10 CONTINUE
C
C     Set POLYN(j) to POLYN(j) * -DELTAX**j (Step S2 in Knuth):
C
      DO 20 J = 0, DEGREE
         POLYN(J) = POLYN(J) * POWER(J)
   20 CONTINUE
C
C     Compute polynomial of x0(x+1) (Step S3 in Knuth):
C
      DO 40 K = 0, DEGREE
         DO 30 J = DEGREE - 1, K, -1
            POLYN(J) = POLYN(J) + POLYN(J + 1)
   30    CONTINUE
   40 CONTINUE
C
C     Divide through by x0**j (Step S4 in Knuth):
C
      DO 50 J = 0, DEGREE
         POLYN(J) = POLYN(J) / POWER(J)
   50 CONTINUE
C
      END

      SUBROUTINE ZTXOP2 (OPCODE, LUN, FIND, OUTFIL, APPEND, IERR)
C-----------------------------------------------------------------------
C! translate the file name and open a text file
C# Z2 Text
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2002, 2015, 2018
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Translate file name and do actual text file open.
C   Inputs:
C      OPCODE   C*4    Operation code 'READ', 'QRED', 'WRIT', or 'QWRT'
C                         'REWR'. 'QREW'
C      LUN      I      Logical unit number
C      FIND     I      Index in FTAB for LUN
C      OUTFIL   C*(*)  Physical file name - fully qualified already or
C                      with a colon as logical:name
C      APPEND   L      If true append new text to end of old file.
C                         (OPCODE='WRIT' or 'QWRT').
C   Outputs:
C      IERR     I      Error return code: 0 => no error
C                         4 => trouble translating logical
C                         5 => file doesn't exist (READ)
C                         5 => file exists (WRIT no APPEND)
C                         6 => open error
C   Generic version - uses ZFULLN, Fortran INQUIRE and simple OPEN,
C   does APPEND by reading to the EOF.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, OUTFIL*(*)
      INTEGER   LUN, FIND, IERR
      LOGICAL   APPEND
C
      INTEGER   I, FLEN, IOSVAL, ITRIM, J
      LOGICAL   EXISTS, REDING, WRTING
      CHARACTER FILNAM*256, TEMP*80, LSTAT*3
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Translate logical device name.
      I = INDEX (OUTFIL, ':')
      IF (I.GT.0) THEN
         CALL ZFULLN (OUTFIL, ' ', ' ', FILNAM, IERR)
         IF (IERR.NE.0) THEN
            IERR = 4
            GO TO 999
            END IF
      ELSE
         FILNAM = OUTFIL
         END IF
      FLEN = ITRIM (FILNAM)
C                                       Init logicals for read/write
      REDING = (OPCODE.EQ.'READ') .OR. (OPCODE.EQ.'QRED')
      WRTING = (OPCODE.EQ.'WRIT') .OR. (OPCODE.EQ.'QWRT')
C                                       If not doing a quiet operation
      IF (OPCODE(:1).NE.'Q') THEN
         MSGTXT = 'ZTXOP2: using translated file name ='
         CALL MSGWRT (2)
         WRITE (MSGTXT,1001) FILNAM(1:MIN (56, FLEN))
         CALL MSGWRT (2)
         IF (FLEN.GT.56) THEN
            WRITE (MSGTXT,1001) FILNAM(57:FLEN)
            CALL MSGWRT (2)
            END IF
C                                       End if not a quiet operation
         END IF
C                                       See if file exists
      INQUIRE (FILE=FILNAM, EXIST=EXISTS)
      LSTAT = 'NEW'
      IF (EXISTS) LSTAT = 'OLD'
C                                       File should exist (READ)
      IF (REDING .AND. (.NOT.EXISTS)) THEN
         IERR = 5
         MSGTXT = 'ZTXOP2: FILE TO BE READ DOES NOT EXIST'
C                                       File should not exist (WRIT)
C                                       REWR file exists or not ok
      ELSE IF (WRTING .AND. (EXISTS) .AND. (.NOT.APPEND))
     *   THEN
         IERR = 5
         MSGTXT = 'ZTXOP2: FILE TO BE WRITTEN ALREADY EXISTS'
C                                       Else, OK: Open file.
      ELSE
         OPEN (UNIT=LUN, FILE=FILNAM(1:FLEN), STATUS=LSTAT,
     *      IOSTAT=IOSVAL)
         IF (IOSVAL.NE.0) THEN
            IERR = 6
            WRITE (MSGTXT,1020) IOSVAL
C                                       Rewind.
         ELSE
            REWIND (LUN)
C                                       Append to old file
            IF (WRTING .AND. EXISTS .AND. APPEND) THEN
               I = 0
C                                       Read to EOF
 50            READ (LUN,1050,IOSTAT=IOSVAL) TEMP
               IF (IOSVAL.EQ.0) THEN
                  I = I + 1
                  GO TO 50
                  END IF
C                                       IO error if not EOF
               IF (IOSVAL.NE.-1) THEN
                  IERR = 6
                  WRITE (MSGTXT,1051) IOSVAL
                  CLOSE (UNIT=LUN)
                  GO TO 900
                  END IF
C                                       close, rewind
               CLOSE (UNIT=LUN)
               OPEN (UNIT=LUN, FILE=FILNAM(1:FLEN), STATUS=LSTAT,
     *            IOSTAT=IOSVAL)
               REWIND (LUN)
               DO 60 J = 1,I
                  READ (LUN,1050,IOSTAT=IOSVAL) TEMP
C                                       IO error if not EOF
                  IF (IOSVAL.NE.0) THEN
                     IERR = 6
                     WRITE (MSGTXT,1051) IOSVAL
                     CLOSE (UNIT=LUN)
                     GO TO 900
                     END IF
 60               CONTINUE
               END IF
            END IF
         END IF
C                                       Error
 900  IF (IERR.NE.0) CALL MSGWRT (6)
      IF (IERR.EQ.6) THEN
         I = FIND + NMOFF
         FTAB(I+FCBERR) = IOSVAL
         CALL ZERROR ('ZTXOP2', IOSVAL, FILNAM, -999, .FALSE.)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1001 FORMAT ('ZTXOP2: ',A)
 1020 FORMAT ('ZTXOP2: FORTRAN OPEN ERROR = ',I6)
 1050 FORMAT (A)
 1051 FORMAT ('ZTXOP2: FORTRAN ERROR',I5,' WHILE SKIPPING TO END OF',
     *   ' FILE')
      END

      SUBROUTINE ROBUST (A, LEN, AVG, RMS)
C-----------------------------------------------------------------------
C! Find robust mean and rms of a list of values
C# Service
C-----------------------------------------------------------------------
C;  Copyright (C) 2004, 2011
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Finds the robust average and rms of a data list
C   Inputs:
C      A     R(*)   Data array
C      LEN   I      length of array
C   Output:
C      AVG   R      Average
C      RMS   R      RMS
C-----------------------------------------------------------------------
      INTEGER   LEN
      REAL      A(*), AVG, RMS
C
      DOUBLE PRECISION SUM, SUMS, CUT, FACTOR(11), RR, AA
      INTEGER   I, ITER, J
      DATA FACTOR /8.D0, 7.D0, 6.D0, 5.D0, 4.5D0, 4.D0, 4.D0, 3.5D0,
     *   3*3.D0/
C-----------------------------------------------------------------------
      RR = 1.D12
      CUT = RR
      AA = 0.D0
      DO 50 ITER = 1,11
         SUM = 0.D0
         SUMS = 0.D0
         J = 0
         DO 10 I = 1,LEN
            IF (ABS(A(I)-AA).LT.CUT) THEN
               SUM = SUM + A(I)
               SUMS = SUMS + A(I) * A(I)
               J = J + 1
               END IF
 10         CONTINUE
         IF (J.GT.0) THEN
            SUM = SUM / J
            SUMS = SUMS / J - SUM * SUM
            AA = SUM
            RR = SQRT (MAX (0.0D0, SUMS))
         ELSE
            RR = 1.D10
            END IF
         CUT = FACTOR(ITER) * RR
 50      CONTINUE
C                                       return REAL*4
      AVG = AA
      RMS = RR
C
 999  RETURN
      END

LOCAL INCLUDE 'XEDIT.INC'
C                                                            Begin XEDIT
C                                       Local include for XEDIT
      CHARACTER OLDSTR(500)*50, NEWSTR(500)*50, OLDCAL(100)*100,
     *   NEWCAL(100)*250, HOLDIM(100)*20, LOGSTR(100)*20,
     *   LOGREA(100)*25, HOLDCL(200)*6, CHRDCL(500)*6,
     *   HKEEP(100)*6, HKDIM(100)*20, CKEEP(100)*6, CKDIM(100)*20,
     *   COPYRI*200, CMINUS*72
      INTEGER   LOLD(500), LNEW(500), LOLDC(100), LNEWC(100), LLOG(100),
     *   LSRC(100), NCSUB(100), LHOL(200), LCHR(500), HOLARG(5,200),
     *   CHRARG(5,500,2),
     *   NUMSUB, NUMCAL, NUMLOG, NUMHOL, NUMCHR, NHKEEP, NCKEEP,
     *   ICHA, ICHZ, BEGDCL, ENDDCL, BEGFOR, NUMDCL, DCLPOS(3,100),
     *   SCOUNT, CCOUNT
      LOGICAL   DOHOLL(100)
      COMMON /CHRCOM/ OLDSTR, NEWSTR, OLDCAL, NEWCAL, HOLDIM, LOGSTR,
     *   LOGREA, HOLDCL, CHRDCL, HKEEP, HKDIM, CKEEP, CKDIM, COPYRI,
     *   CMINUS
      COMMON /INTCOM/ LOLD, LNEW, LOLDC, LNEWC, LLOG, LSRC, NCSUB,
     *   LHOL, LCHR, HOLARG, CHRARG,
     *   NUMSUB, NUMCAL, NUMLOG, NUMHOL, NUMCHR, NHKEEP, NCKEEP,
     *   ICHA, ICHZ,
     *   BEGDCL, ENDDCL, BEGFOR, NUMDCL, DCLPOS, SCOUNT, CCOUNT,
     *   DOHOLL
C                                                            End XEDIT
LOCAL END
      PROGRAM XEDIT
C-----------------------------------------------------------------------
C! Transforms Fortran source files using a list of instructions
C# Service Text
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Program to make text substitutions to a list of files etc.
C   Reads XEDIT.LIS for a list of files to process, one name
C   per line.; the input files are assumed to have the name "name.FOR"
C   and the new routines  will have the name "name.NEW".
C   Instructions to XEDIT are read from XEDIT.STR  and are of the form:
C   'opcode' 'string1' 'string2'         all on the same line
C    OPCODE = 'copyright' => copyright notice if any.
C          string1 = text of copyright notice; a '@' means a new line
C             with the same indentation as the first. 100 char max.
C          string2 = ''  continuation of string1 but MUST be present,
C             may add an additional 100 characters.
C    OPCODE ='subs' => simple string substitution;  any occurances of
C       the string1 will be replaced by string2.  Each string may be up
C       to 50 characters.
C    OPCODE ='call' => edit subroutine call sequence/array argument:
C       string1 is of the form 'CALL XYZ (,,,arg,)' where arg
C          is an argument name required for a match.  Leading commas
C          indicate the argument number.  If the argument list is not
C          given then no test is made on the number of arguments.  If
C          the list of arguments is given then the number of arguments
C          must match.  Arguments may be of the form !xxxx* where the
C          '!' indicates that the actual argument be different to match
C          and '*' indicates any number of wildcard characters (* may
C          only appear at the end. Include a blank before the initial
C          '(' for call sequences and leave it out for array elements.
C          If string1='continue' then string2 is a continuation of the
C          previous 'call' or 'callh' command.
C          max. = 100 characters
C       string2 is of the form 'buzzbuzz ($01, $02, $03, $05) %'
C          i.e. an occurance of the string $nn will result in argument
C          nn being substituted.  A '@' will force a new line with the
C          same indentation as the previous line.  A substituted line
C          has a maximum of 512 characters.
C          Maximum of 250 characters.
C          The optional % indicates that the rest of the line past the
C          final parenthese parsed is added.
C    OPCODE ='callh (dim)' => like 'call' except for array arguments
C       only and the array is to be declared HOLLERITH.  (dim) is the
C       default dimension.
C    OPCODE ='log' => writes any line in the log file with a substring
C       matching string1.  A "reason" code of up to 10 char is given
C       in string2 must be provided.  String1 has a mamimum of
C       20 characters.
C    OPCODE ='comment' is ignored; string1 and string2 must be present
C       but may contain comments.
C    Each line will be operated on in the sequence described above.
C    When the above processing is done the declaration processor may
C    be invoked:
C    OPCODE ='hollerith' => changes the declarations of local variables
C          which are the specified arguments of specified routines to
C          HOLLERITH.
C          string1 = 'routine name'      6 characters only
C          string2 = '  j  i  0  0  0'  is a list of the argument
C                   numbers which are Hollerith variables.  These are
C                   read with an 5I3 format.
C    OPCODE ='keep hollerith' => specifies a variable name to be
C          declared HOLLERITH if used in a call sequence even it it is
C          not already locally defined.  Limit 50.
C          string1 = 'variable name'     6 characters only
C          string2 = 'dimension'        blank or of form '(5)' 20 char.
C    OPCODE ='character' => changes the declarations of local variables
C          which are the specified arguments of specified routines to
C          CHARACTER.
C          string1 = 'routine name'       6 characters only
C          string2 = ' j1 j2  i1 i2  0  0  0  0  0  0  0'
C                   is a list of the argument numbers which are
C                   CHARACTER variables followed by the number of
C                   characters to be declared.  (j1=arg number,
C                   j2 = max. string size)
C                   These are read with an 10I3 format.
C    OPCODE ='keep character' => specifies a variable name to be
C          declared CHARACTER if used in a call sequence even it it is
C          not already locally defined.  Limit 50.
C          string1 = 'variable name'     6 characters only
C          string2 = 'def. decl. string e.g. "*4"'    20 char limit.
C      If the output line is longer than 72 characters then it will be
C   broken into shorter lines with an attempt at proper indentation.
C   NOTE: The open statements in this routine are appropriate for VMS,
C   More generic versions are commented out and may be substituted for
C   non VMS systems.
C-----------------------------------------------------------------------
      INTEGER   XMODSZ
C                                       XMODSZ=no. pages in module
C                                       buffer.
      PARAMETER (XMODSZ = 4)
      CHARACTER INLINE*100, OUTLIN*1024, INFIL*20, OUTFIL*20, LOGFIL*20,
     *   SUBNAM*20, TSTR*1024, MODNAM*40, MODULE(XMODSZ)*32767,
     *   ARGHOL(500)*6, PRECOM*200
      INTEGER      LOOP, BLNK1, NARGI, NARGO, NSAVE,
     *   I, LSTR, ITRIM, IOERR, LI, LO, IPNT, JPNT, KPNT, JSTR, LCNT,
     *   INDEX, LAST, LMODUL(4), PAGE, IERR, LIMPAG(XMODSZ), LTEMP,
     *   NHARG, NSAVE2, LCOUNT, LPREC, NEXTNQ
      LOGICAL   GOTMOD, MODONE, DUNPRE, PASTCM, FILDUN
      INCLUDE 'XEDIT.INC'
      EXTERNAL NEXTNQ
      DATA LIMPAG /XMODSZ*32000/
C-----------------------------------------------------------------------
C                                       Build description
      LIMPAG(1) = 25000
C                                       Get substitute strings
      CALL SETUP (IERR)
      IF (IERR.NE.0) GO TO 999
      NSAVE = NHKEEP
      NSAVE2 = NUMSUB
C                                       Get list of routines
C                                       VMS
      OPEN (UNIT=5,FILE='XEDIT.LIS',READONLY,STATUS='OLD')
C                                       Other
C      OPEN (UNIT=5,FILE='XEDIT.LIS',STATUS='OLD')
 100     READ(5,1000,END=999) SUBNAM
         IF (SUBNAM.EQ.' ') GO TO 999
C                                       Find first blank or '.'
         BLNK1 = INDEX (SUBNAM,'.')
         IF (BLNK1.LE.0) BLNK1 = INDEX (SUBNAM,' ')
C                                       Form input and output names
         INFIL = SUBNAM(1:BLNK1-1)//'.FOR'
         OUTFIL = SUBNAM(1:BLNK1-1)//'.NEW'
         LOGFIL = SUBNAM(1:BLNK1-1)//'.LOG'
C                                       Open input file
C                                       VMS
         OPEN (UNIT=10,FILE=INFIL,READONLY,IOSTAT=IOERR,STATUS='OLD')
C                                       Other
C         OPEN (UNIT=10,FILE=INFIL,IOSTAT=IOERR,STATUS='OLD')
         IF (IOERR.NE.0) GO TO 890
C                                       Open Output file
C                                       VMS
         OPEN (UNIT=11,FILE=OUTFIL,STATUS='NEW',IOSTAT=IOERR,
     *      FORM='FORMATTED',RECORDSIZE=80,RECORDTYPE='VARIABLE',
     *      BLOCKSIZE=80, CARRIAGECONTROL='LIST',
     *      ACCESS='SEQUENTIAL',ORGANIZATION='SEQUENTIAL')
C                                       Other
C         OPEN (UNIT=11,FILE=OUTFIL,STATUS='NEW',IOSTAT=IOERR,
C     *      FORM='FORMATTED',RECL=80, ACCESS='SEQUENTIAL')
         IF (IOERR.NE.0) GO TO 890
C                                       Open log file
C                                       VMS
         OPEN (UNIT=12,FILE=LOGFIL,STATUS='NEW',IOSTAT=IOERR,
     *      FORM='FORMATTED',RECORDSIZE=132,RECORDTYPE='VARIABLE',
     *      BLOCKSIZE=80, CARRIAGECONTROL='LIST',
     *      ACCESS='SEQUENTIAL',ORGANIZATION='SEQUENTIAL')
C                                       Other
C         OPEN (UNIT=12,FILE=LOGFIL,STATUS='NEW',IOSTAT=IOERR,
C     *      FORM='FORMATTED',RECL=132, ACCESS='SEQUENTIAL')
         IF (IOERR.NE.0) GO TO 890
C                                       Label log
         WRITE (12,1002) INFIL
C-----------------------------------------------------------------------
         SCOUNT = 0
         LCOUNT = 0
         CCOUNT = 0
         GOTMOD = .FALSE.
         MODNAM = 'no name'
         MODONE = .FALSE.
         FILDUN = .FALSE.
         DUNPRE = .FALSE.
         PASTCM = .FALSE.
         LMODUL(1) = 1
         LMODUL(2) = 1
         LMODUL(3) = 1
         LMODUL(4) = 1
         PAGE = 1
         NUMSUB = NSAVE2
C                                       Crunch file
C                                       Read line
 200        CALL GETLIN (OUTLIN, LSTR, IOERR)
            IF (IOERR.EQ.4) GO TO 600
C                                       Get module name
            IF (.NOT.GOTMOD) THEN
               IPNT = INDEX (OUTLIN, 'PROGRAM ')
               IF (IPNT.LE.0) IPNT = INDEX (OUTLIN, 'SUBROUTINE ')
               IF (IPNT.LE.0) IPNT = INDEX (OUTLIN, 'FUNCTION ')
               IF (IPNT.LE.0) IPNT = INDEX (OUTLIN, 'LOCAL INCLUDE')
               IF (IPNT.GT.1) THEN
                  KPNT = INDEX (OUTLIN(1:IPNT+25),'(') - 1
                  IF (KPNT.LE.0) KPNT = LSTR
                  MODNAM = OUTLIN(7:KPNT)
                  NHKEEP = NSAVE
C                                       Annotate log
                  JSTR = ITRIM (MODNAM)
                  WRITE (12,1001) MODNAM(1:JSTR)
                  GOTMOD = .TRUE.
                  END IF
               END IF
C                                       Check for END of module
            KPNT = INDEX (OUTLIN(1:LSTR), ' END')
            IF ((KPNT.GT.0) .AND. (KPNT.EQ.(LSTR-3)) .AND.
     *         (OUTLIN(1:1).NE.'C') .AND.
     *         (ITRIM (OUTLIN(6:KPNT)).EQ.0)) THEN
               GOTMOD = .FALSE.
               MODONE = .TRUE.
               MODNAM ='no name'
               END IF
C                                       Check for precursor comments etc
            IF (PASTCM .AND. (OUTLIN(1:2).NE.'C!') .AND.
     *         (.NOT.DUNPRE)) THEN
               DUNPRE = .TRUE.
C                                       Add to output
               PRECOM(1:5) = 'C!   '
               LPREC = 2
               CALL LINOUT (PRECOM, LPREC, MODULE(PAGE), LMODUL(PAGE))
               PRECOM(1:5) = 'C#   '
               CALL LINOUT (PRECOM, LPREC, MODULE(PAGE), LMODUL(PAGE))
               JSTR = ITRIM (COPYRI)
               IF (JSTR.GT.0) THEN
                  PRECOM(1:JSTR) = COPYRI(1:JSTR)
                  CALL LINOUT (PRECOM, JSTR, MODULE(PAGE), LMODUL(PAGE))
                  END IF
               LPREC = 72
               CALL LINOUT (CMINUS, LPREC, MODULE(PAGE), LMODUL(PAGE))
               END IF
            DUNPRE = DUNPRE .OR. (OUTLIN(1:2).EQ.'C!')
            PASTCM = PASTCM .OR. (OUTLIN(1:30).EQ.CMINUS(1:30))
C                                       Call sequence/array argument
C                                       processing.
            IF ((NUMCAL.GT.0) .AND. (LSTR.GT.10) .AND.
     *         (OUTLIN(1:1).NE.'C') ) THEN
               IF ((INDEX (OUTLIN(7:LSTR), '(').GT.0) .AND.
     *            (INDEX (OUTLIN(6:15), ' FORMAT') .LE.0))
     *               CALL CALLSQ (OUTLIN, LSTR, NHARG, ARGHOL)
               END IF
C                                       Line to MODULE
C                                       See if line break
 400       KPNT = NEXTNQ (OUTLIN(1:LSTR),'@')
C                                       Simple line
            IF ((LSTR.LE.72) .AND. (KPNT.LE.0)) THEN
               LCNT = LMODUL(PAGE)
               MODULE(PAGE)(LCNT:LCNT+LSTR-1) = OUTLIN(1:LSTR)
               MODULE(PAGE)(LCNT+LSTR:LCNT+LSTR) = '@'
               LMODUL(PAGE) = LMODUL(PAGE) + LSTR + 1
C                                       Complex case
            ELSE
               CALL LINOUT (OUTLIN, LSTR, MODULE(PAGE), LMODUL(PAGE))
               END IF
C                                       See if module page full
            IF (LMODUL(PAGE).GT.LIMPAG(PAGE)) THEN
C                                       New page
               PAGE = PAGE + 1
               IF (PAGE.GT.XMODSZ) THEN
                  WRITE(6,1400)
                  END IF
               END IF
            GO TO 610
C                                       End of Module - write
 600        FILDUN = .TRUE.
            MODONE = .TRUE.
            IF ((PAGE.EQ.1) .AND. (LMODUL(1).LE.1)) GO TO 900
C                                       See if module finished
 610        IF (MODONE) THEN
C                                       Log requested lines
               CALL LOGIT (PAGE, MODULE, LMODUL, NUMLOG, LOGSTR, LLOG,
     *            LOGREA)
C                                       Find beginning and end of
C                                       declarations, executable
C                                       Assumes declarations on first
C                                       page.
               CALL FNDDCL (MODULE, LMODUL)
C                                       Declaration processing
               IF ((NUMHOL.GT.0) .OR. (NUMCHR.GT.0)) THEN
                  CALL DCLEDT (PAGE, MODULE, LMODUL, NHARG, ARGHOL)
                  END IF
C                                       Remove dead declarations
               CALL RMDCL (PAGE, MODULE, LMODUL)
C                                       Write module to output file
               CALL PRTMOD (PAGE, MODULE, LMODUL, LCOUNT)
C                                       Clear work arrays
               DO 700 LOOP = 1,PAGE
                  MODULE(LOOP)(1:LMODUL(LOOP)) = '  '
                  LMODUL(LOOP) = 1
 700              CONTINUE
               PAGE = 1
               MODONE = .FALSE.
               NHARG = 0
               END IF
C                                       File done?
            IF (FILDUN) GO TO 900
C                                       Loop for next line
            GO TO 200
C                                       Error opening file
 890     WRITE (6,1890) SUBNAM(1:BLNK1-1)
         GO TO 950
C                                       Finished this file
 900     WRITE (6,1900) SUBNAM(1:BLNK1-1), SCOUNT
         WRITE (6,1901) CCOUNT
         WRITE (6,1902) LCOUNT
         WRITE (12,1900) SUBNAM(1:BLNK1-1), SCOUNT
         WRITE (12,1901) CCOUNT
         WRITE (12,1902) LCOUNT
         CLOSE (UNIT=11,STATUS='KEEP')
         CLOSE (UNIT=12,STATUS='KEEP')
 950     CLOSE (UNIT=10,STATUS='KEEP')
C                                       Do next file.
         GO TO 100
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT (A20)
 1001 FORMAT (//' In module ',A)
 1002 FORMAT (30X,'XEDIT log file for ',A///)
 1120 FORMAT (A)
 1250 FORMAT (A)
 1400 FORMAT (' HELP, You''ve blown my module buffer;',
     *   ' increase the dimension of MODULE.')
 1890 FORMAT (' Error opening file ',A6)
 1900 FORMAT (' Finished with ',A6,', made ',I6,' substitutions')
 1901 FORMAT (' Made ',I6,' call translations')
 1902 FORMAT (' Wrote ',I6, ' output lines.')
      END
      INTEGER FUNCTION ITRIM (STRING)
C-----------------------------------------------------------------------
C   Function to determine length of a string. I.e., it trims trailing
C   blanks. Use with calls like:
C         TRIMMED = GROSS(1:ITRIM(GROSS))
C   DCW, NRAO-CV, 30Nov82.
C   WARNING: this function must be declared INTEGER not INTEGER*2
C-----------------------------------------------------------------------
      CHARACTER STRING*(*)
C-----------------------------------------------------------------------
      ITRIM = LEN (STRING) + 1
C                                       look backwards for non-blank
 10   CONTINUE
         ITRIM = ITRIM - 1
         IF (ITRIM.LT.1) GO TO 999
         IF (STRING(ITRIM:ITRIM).EQ.' ') GO TO 10
C
 999  RETURN
      END
      INTEGER FUNCTION LAST (STRING, CHAR)
C-----------------------------------------------------------------------
C   Function to determine last occurance of a character in a string.
C    Inputs:
C     STRING    C   String to be searched
C     CHAR      C   Character to locate
C-----------------------------------------------------------------------
      CHARACTER STRING*(*), CHAR*1
C-----------------------------------------------------------------------
      LAST = LEN (STRING) + 1
C                                       look backwards for CHAR
 10   CONTINUE
         LAST = LAST - 1
         IF (LAST.LT.1) GO TO 999
         IF (STRING(LAST:LAST).NE.CHAR) GO TO 10
C
 999  RETURN
      END
      SUBROUTINE SETUP (IERR)
C-----------------------------------------------------------------------
C   Function to read editing instructions
C    Output:
C     IERR      I  Error code 0 => OK else failed
C    Output in common:
C     COPYRI    C  Copyright notice if any
C     NUMSUB    I  Number of substitution string pairs.
C     OLDSTR(*) C  Array of substitution search strings
C     LOLD(*)   I  Length of elements in OLDSTR
C     NEWSTR(*) C  Array of substitution replacment strings
C     LNEW(*)   I  Length of elements in NEWSTR
C     NUMCAL    I  Number of call translation string pairs.
C     OLDCAL(*) C  Array of call translation search strings
C     LOLDC(*)  I  Length of elements in OLDCAL
C     NEWCAL(*) C  Array of call translation replacment strings
C     LNEWC(*)  I  Length of elements in NEWCAL
C     LSRC(*)   I  Number of characters in OLDCAL to compare
C     DOHOLL(*) L  If true declare associated OLDCAL array HOLLERITH
C     HOLDIM(*) C  Default declarations for 'calld' varaibles
C     NCSUB(*)  I  Number of parameter substitutions in call processing
C     NUMLOG    I  Number of logging string pairs.
C     LOGSTR(*) C  Array of logging search strings
C     LOGREA(*) C  Reason codes for LOGSTR
C     LLOG(*)   I  Length of elements in LOGSTR
C     NUMHOL    I  Number of Hollerith redeclaration routines
C     HOLDCL(*) C  Array of Hollerith routines
C     LHOL(*)   I  Length of elements in HOLDCL
C     HOLARG()  I  Arguments for Hollerith redeclarations
C     NHKEEP    I  Number of values in HKEEP
C     HKEEP     C  Array of HOLLERITH variables to declare if used.
C     NUMCHR    I  Number of Character redeclaration routines
C     CHRDCL(*) C  Array of Character routines
C     LCHR(*)   I  Length of elements in CHRDCL
C     CHRARG()  I  Arguments for Character redeclarations
C     NCKEEP    I  Number of values in CKEEP
C     CKEEP     C  Array of CHARACTER variables to declare if used.
C     ICHA      I  Value of the letter 'A'
C     ICHZ      I  Value of the letter 'Z'
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER OPCODE*20, STRNG1*100, STRNG2*250
      INTEGER   IPNT, KPNT, ITRIM, J, LCOUNT
      INCLUDE 'XEDIT.INC'
C-----------------------------------------------------------------------
      COPYRI = '          '
      CMINUS = 'C------------------------------------------------------'
      CMINUS(56:72) = '-----------------'
C                                       Letter values
      ICHA = ICHAR ('A')
      ICHZ = ICHAR ('Z')
      NUMSUB = 0
      NUMCAL = 0
      NUMLOG = 0
      NUMHOL = 0
      NUMCHR = 0
      NHKEEP = 0
      NCKEEP = 0
      LCOUNT = 1
C                                       VMS
      OPEN (UNIT=5,FILE='XEDIT.STR',READONLY,STATUS='OLD')
C                                       Other
C      OPEN (UNIT=5,FILE='XEDIT.STR',STATUS='OLD')
 10      READ(5,*,END=50,ERR=900)  OPCODE, STRNG1, STRNG2
         LCOUNT = LCOUNT + 1
C                                       Copyright notice
         IF (OPCODE(1:9).EQ.'copyright') THEN
            COPYRI(1:100) = STRNG1
            IPNT = ITRIM (COPYRI(1:100))
            COPYRI(IPNT+1:IPNT+100) = STRNG2
            END IF
C                                       Simple substitution
         IF (OPCODE(1:4).EQ.'subs') THEN
             NUMSUB = NUMSUB + 1
             OLDSTR(NUMSUB) = STRNG1(1:50)
             NEWSTR(NUMSUB) = STRNG2(1:50)
             LOLD(NUMSUB) = ITRIM (OLDSTR(NUMSUB))
             LNEW(NUMSUB) = ITRIM (NEWSTR(NUMSUB))
             IF (LOLD(NUMSUB).LE.0) GO TO 10
             END IF
C                                       Call translation
         IF (OPCODE(1:4).EQ.'call') THEN
             NUMCAL = NUMCAL + 1
             OLDCAL(NUMCAL) = STRNG1(1:100)
             NEWCAL(NUMCAL) = STRNG2(1:250)
             LOLDC(NUMCAL) = ITRIM (OLDCAL(NUMCAL))
             LNEWC(NUMCAL) = ITRIM (NEWCAL(NUMCAL))
             DOHOLL(NUMCAL) = OPCODE(5:5).EQ.'h'
             HOLDIM(NUMCAL) = OPCODE(6:20)
             IF (LOLDC(NUMCAL).LE.0) GO TO 10
             LSRC(NUMCAL) = INDEX (OLDCAL(NUMCAL)(1:LOLDC(NUMCAL)),
     *          ' (') - 1
C                                       Include '('
             IF (LSRC(NUMCAL).LE.0)
     *          LSRC(NUMCAL) = INDEX (OLDCAL(NUMCAL)(1:LOLDC(NUMCAL)),
     *          '(')
             IF (LSRC(NUMCAL).LE.0) LSRC(NUMCAL) = LOLDC(NUMCAL)
C                                       Number of parameters used
             IPNT = 1
             NCSUB(NUMCAL) = 0
 30             KPNT = INDEX (NEWCAL(NUMCAL)(IPNT:LNEWC(NUMCAL)), '$')
                IF (KPNT.GT.0) THEN
                   NCSUB(NUMCAL) = NCSUB(NUMCAL) + 1
                   IPNT = IPNT + KPNT
                   GO TO 30
                   END IF
             END IF
C                                       Logging strings
         IF (OPCODE(1:3).EQ.'log') THEN
             NUMLOG = NUMLOG + 1
             LOGSTR(NUMLOG) = STRNG1(1:20)
             LOGREA(NUMLOG) = STRNG2(1:25)
             LLOG(NUMLOG) = ITRIM (LOGSTR(NUMLOG))
             IF (LLOG(NUMLOG).LE.0) GO TO 50
             END IF
C                                       Hollerith redeclaration
         IF (OPCODE(1:9).EQ.'hollerith') THEN
            NUMHOL = NUMHOL + 1
            HOLDCL(NUMHOL) = STRNG1(1:6)
            READ (STRNG2,1030) (HOLARG(J,NUMHOL), J=1,5)
            END IF
C                                       Holleriths to declare if used
         IF (OPCODE(1:14).EQ.'keep hollerith') THEN
            NHKEEP = NHKEEP + 1
            HKEEP(NHKEEP) = STRNG1(1:6)
            HKDIM(NHKEEP) = STRNG2(1:20)
            END IF
C                                       Character redeclaration
         IF (OPCODE(1:9).EQ.'character') THEN
            NUMCHR = NUMCHR + 1
            CHRDCL(NUMCHR) = STRNG1(1:6)
            READ (STRNG2,1030) (CHRARG(J,NUMCHR,1),
     *         CHRARG(J,NUMCHR,2), J=1,5)
            END IF
C                                       Characters to declare if used
         IF (OPCODE(1:14).EQ.'keep character') THEN
            NCKEEP = NCKEEP + 1
            CKEEP(NCKEEP) = STRNG1(1:6)
            CKDIM(NCKEEP) = STRNG2(1:20)
            END IF
         GO TO 10
 50   CLOSE (UNIT=5)
      IERR = 0
      GO TO 999
C                                       Error
 900  WRITE (6,1900) LCOUNT
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (10I3)
 1900 FORMAT (' Error reading instructions from XEDIT.STR in command',
     *   I5)
      END
      SUBROUTINE GETLIN (OUTLIN, LSTR, IERR)
C-----------------------------------------------------------------------
C   Read a line from the input file, AIPSify and do string substitutions
C    Input from common:
C     NUMSUB    I  Number of substitution string pairs.
C     OLDSTR(*) C  Array of substitution search strings
C     LOLD(*)   I  Length of elements in OLDSTR
C     NEWSTR(*) C  Array of substitution replacment strings
C     LNEW(*)   I  Length of elements in NEWSTR
C    Input/Output in common:
C     SCOUNT    I  Number of substitutions
C    Output:
C     OUTLIN    C  Output line
C     LSTR      I  Number of valid characters in OUTLIN
C     IERR      I  Error code, 0=OK 1 = Error, 4=EOF
C-----------------------------------------------------------------------
      CHARACTER OUTLIN*(*)
      INTEGER   LSTR, IERR
      CHARACTER INLINE*256, TSTR*1024
      INTEGER   ITRIM, IPNT, JPNT, KPNT, I, LTEMP
      INCLUDE 'XEDIT.INC'
C-----------------------------------------------------------------------
C                                       Read line
      READ (10,1000,ERR=500,END=600) INLINE
      LSTR = ITRIM (INLINE)
C                                       AIPSisfy
      CALL AIPCLN (INLINE, LSTR)
C                                       Copy to OUTLIN
      OUTLIN = INLINE(1:LSTR)
C                                       Make substitutions
      JPNT = 1
      DO 100 I = 1,NUMSUB
 50      KPNT = INDEX (OUTLIN(JPNT:LSTR), OLDSTR(I)(1:LOLD(I)))
         IPNT = KPNT + JPNT - 1
         IF (KPNT.GT.0) THEN
            LTEMP = LNEW(I) + LSTR - IPNT - LOLD(I) + 1
            TSTR(1:LTEMP) = NEWSTR(I)(1:LNEW(I)) //
     *         OUTLIN(IPNT+LOLD(I):LSTR)
            OUTLIN(IPNT:IPNT+LTEMP-1) = TSTR(1:LTEMP)
            SCOUNT = SCOUNT + 1
C                                       Check for another occurance
            JPNT =  IPNT + LNEW(I)
            LSTR = LSTR + LNEW(I) - LOLD(I)
            GO TO 50
         ELSE
            JPNT = 1
            END IF
 100        CONTINUE
      IERR = 0
      GO TO 999
C                                       Read error
 500  IERR = 1
      GO TO 999
C                                       EOF
 600  IERR = 4
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A)
      END
      SUBROUTINE AIPCLN (INLINE, LSTR)
C-----------------------------------------------------------------------
C   Routine to do a few AIPSish things
C    Input/output:
C     INLINE  C  Input line
C     LSTR    I  Length of INLINE
C-----------------------------------------------------------------------
      CHARACTER INLINE*(*)
      INTEGER   LSTR
      CHARACTER TEMP*100, BLANK*5
      INTEGER   IPNT, JSTR, ITRIM, NBLANK
      INCLUDE 'XEDIT.INC'
      DATA BLANK /'     '/
C-----------------------------------------------------------------------
C                                       Continuation character = '*'
      IF ((LSTR.GE.6) .AND. (INLINE(1:1).NE.'C') .AND.
     *   (INLINE(6:6).NE.' ')) INLINE(6:6) = '*'
C                                       Minimal indent on cont.
      IF ((LSTR.GE.6) .AND. (INLINE(1:1).NE.'C') .AND.
     *   (INLINE(6:6).EQ.'*') .AND. (INLINE(7:9).NE.'   ')) THEN
         NBLANK = 1
         IF (INLINE(7:8).NE.'  ') NBLANK = 2
         IF (INLINE(7:7).NE.' ') NBLANK = 3
         TEMP(1:LSTR+3) = INLINE(1:6) // BLANK(1:NBLANK) //
     *      INLINE(7:LSTR)
         LSTR = LSTR + NBLANK
         INLINE(1:LSTR) = TEMP(1:LSTR)
         END IF
C                                       Delimiter line
      IF (INLINE(1:30).EQ.CMINUS(1:30)) THEN
         INLINE = CMINUS
         LSTR = 72
         GO TO 999
         END IF
C                                       Beautify DOUBLE PRECISION lines
C                                       from XLATE.
      IF ((INLINE(1:LSTR).EQ.'      DOUBLE PRECISION') .AND.
     *   (LSTR.LE.25)) THEN
C                                       Find non blank line
 20         READ (10,1000,END=999) TEMP
            JSTR = ITRIM (TEMP)
            IF (JSTR.LT.10) GO TO 20
         INLINE(LSTR+1:LSTR+JSTR-8) = ' ' // TEMP(10:JSTR)
         LSTR = LSTR + JSTR - 8
         END IF
C                                       Convert to upper case.
      CALL CHL2U (INLINE, LSTR)
C                                       Add program name to subs list
      IF (INLINE(6:14).EQ.' PROGRAM ') THEN
         NUMSUB = NUMSUB + 1
         OLDSTR(NUMSUB) = '''' // INLINE(15:16) // ''',''' //
     *      INLINE(17:18) // ''',''' // INLINE(19:19) //
     *      ' '''
         NEWSTR(NUMSUB) = '''' // INLINE(15:19) // ' '''
         LOLD(NUMSUB) = 14
         LNEW(NUMSUB) = 8
C                                       Try with blanks between
         NUMSUB = NUMSUB + 1
         OLDSTR(NUMSUB) = '''' // INLINE(15:16) // ''', ''' //
     *      INLINE(17:18) // ''', ''' // INLINE(19:19) // ' '''
         NEWSTR(NUMSUB) = NEWSTR(NUMSUB-1)
         LOLD(NUMSUB) = 16
         LNEW(NUMSUB) = 8
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A80)
      END
      SUBROUTINE LINOUT (OUTLIN, LSTR, MODULE, LMODUL)
C-----------------------------------------------------------------------
C   Subroutine to copy lines longer than 72 characters to MODULE with a
C   terminal '@';  A '@' character in the input line forces a new line
C   with the same indentation as the original.
C    Input:
C     OUTLIN   C  Output line
C     LSTR     I  Number of characters
C     Input/Output:
C     MODULE   C  Module character string
C     LMODUL   I  Next character position in MODULE
C-----------------------------------------------------------------------
      CHARACTER OUTLIN*(*), MODULE*(*)
      INTEGER   LSTR, LMODUL
      CHARACTER CBLANK*40, TSTR*80, BRKCHR*1, TEMP*4096
      LOGICAL   CPRE, CBODY, FORT, BREAK, QUOTE, MATCH
      INTEGER   INDENT, LOOP, IPNT, BRKPNT, LLSTR, LAST, KPNT, ITRIM,
     *   LIMIT, LTEMP, NEXTNQ
      EXTERNAL NEXTNQ
      DATA CBLANK /'C                                       '/
      DATA BRKCHR /'@'/
C-----------------------------------------------------------------------
      IF (LSTR.LE.0) GO TO 999
      LLSTR = LSTR
C                                       Break in line?
      BRKPNT = NEXTNQ (OUTLIN(1:LLSTR), BRKCHR)
      BREAK = BRKPNT.GT.0
C                                       Decide line type: Body comment
      CBODY = OUTLIN(1:40).EQ.CBLANK
      IF (CBODY) INDENT = 40
C                                       Precursor
      CPRE = (.NOT.CBODY) .AND. (OUTLIN(1:1).EQ.'C')
      IF (CPRE) INDENT = 4
C                                       Fortran line
      FORT = OUTLIN(1:1).NE.'C'
C                                       Fortran line indentation
      IF (FORT) THEN
         INDENT = 6
         DO 20 LOOP = 7,LLSTR
            IF (OUTLIN(LOOP:LOOP).NE.' ') GO TO 30
            INDENT = LOOP
 20         CONTINUE
 30      CONTINUE
         END IF
C                                       Check for break in 1st 72 col
 50   IF (BREAK .AND. (BRKPNT.LE.72)) THEN
         MODULE(LMODUL:LMODUL+BRKPNT-2) = OUTLIN(1:BRKPNT-1)
         MODULE(LMODUL+BRKPNT-1:LMODUL+BRKPNT-1) = '@'
         LMODUL = LMODUL + BRKPNT
C                                       Compress line
C                                       Precursor comment
         IF (CPRE) TEMP(1:LLSTR+4) = 'C   ' //OUTLIN(BRKPNT+1:LLSTR)
C                                       Body comment
         IF (CBODY) TEMP(1:LLSTR+40) = CBLANK //OUTLIN(BRKPNT+1:LLSTR)
C                                       Fortran
         IF (FORT) THEN
            TSTR(1:40) = '                                            '
            TEMP(1:LLSTR+INDENT) =
     *         TSTR(1:INDENT) // OUTLIN(BRKPNT+1:LLSTR)
            END IF
         LLSTR = ITRIM (TEMP(1:LLSTR+INDENT))
         OUTLIN(1:LLSTR) = TEMP(1:LLSTR)
C                                       Another break in line?
         BRKPNT = NEXTNQ (OUTLIN(1:LLSTR), BRKCHR)
         BREAK = BRKPNT.GT.0
         GO TO 50
         END IF
C                                       See what's left
 100   IF (LLSTR.LE.72) THEN
         MODULE(LMODUL:LMODUL+LLSTR-1) = OUTLIN(1:LLSTR)
         MODULE(LMODUL+LLSTR:LMODUL+LLSTR) = '@'
         LMODUL = LMODUL + LLSTR + 1
C                                       Done
         GO TO 999
C                                       Long line
       ELSE
C                                       Find last blank or comma, not
C                                       in quotes.
         QUOTE = INDEX(OUTLIN(1:72),'''') .GT. 0
         IF (QUOTE.AND.FORT) THEN
C                                       Find last unmatched quote
C                                       before col 72
            MATCH = .TRUE.
            KPNT = 6
C                                       Don't leave 1 char orphan
            LIMIT = 72
            IF (LLSTR.EQ.73) LIMIT = 71
            DO 200 LOOP = 7,LIMIT
               IF (OUTLIN(LOOP:LOOP).EQ.'''') THEN
                  MATCH = .NOT.MATCH
                  IF (MATCH) KPNT = LOOP
                  END IF
C                                       Last comma OK
               IF (MATCH .AND. (OUTLIN(LOOP:LOOP).EQ.','))  KPNT = LOOP
C                                       Last blank OK
               IF (MATCH .AND. (OUTLIN(LOOP:LOOP).EQ.' '))  KPNT = LOOP
 200           CONTINUE
            IPNT = KPNT
C                                       No quotes
         ELSE
            IPNT = LAST (OUTLIN(1:72), ' ')
            IF (IPNT.LE.INDENT) IPNT = LAST (OUTLIN(1:72), ',')
            IF (IPNT.LE.INDENT) IPNT = 72
            END IF
C                                       Write this line
         MODULE(LMODUL:LMODUL+IPNT-1) = OUTLIN(1:IPNT)
         MODULE(LMODUL+IPNT:LMODUL+IPNT) = '@'
         LMODUL = LMODUL + IPNT + 1
C                                       Deal with rest of line
         LTEMP = LLSTR - IPNT
C                                       Precursor comment
         IF (CPRE) TEMP(1:LTEMP+4) = 'C   ' // OUTLIN(IPNT+1:LLSTR)
C                                       Body comment
         IF (CBODY) TEMP(1:LTEMP+40) = CBLANK // OUTLIN(IPNT+1:LLSTR)
C                                       Fortran continuation
         IF (FORT) THEN
            TSTR = '     *                                        '
            LTEMP = LTEMP + 3
            TEMP(1:LTEMP+INDENT) = TSTR(1:INDENT+3) //
     *          OUTLIN(IPNT+1:LLSTR)
            END IF
         LLSTR = LTEMP + INDENT
         OUTLIN(1:LLSTR) = TEMP(1:LLSTR)
         END IF
C                                       Another break in line?
      BRKPNT = NEXTNQ (OUTLIN(1:LLSTR), BRKCHR)
      BREAK = BRKPNT.GT.0
C                                       Loop back for more
      GO TO 50
C
 999  RETURN
C-----------------------------------------------------------------------
 1250 FORMAT (A)
      END
      SUBROUTINE CALLSQ (OUTLIN, LSTR, NHARG, ARGHOL)
C-----------------------------------------------------------------------
C   Routine to translate call sequences/array arguments.  May force
C   redeclaring a variable as 'HOLLERITH'
C    Input/Output:
C     OUTLIN   C  Output line, more may be read from file.
C     LSTR     I  The number of valid characters in OUTLIN.
C     NHARG    I  Number of elements in ARGHOL
C     ARGHOL   C  List of variables to redeclare as Hollerith
C    From common
C     CCOUNT   I  Count of translations
C     NHKEEP   I  Number of elements in HKEEP
C     HKEEP    C  List of variables to declare if in ARGHOL.
C-----------------------------------------------------------------------
      CHARACTER OUTLIN*(*), ARGHOL(*)*6
      INTEGER   LSTR, NHARG
      CHARACTER STRING*1024, SPARM(100)*50, MPARM(100)*50, FORM*256,
     *   PSTRIN*2, REST*80, XREST*80, HARG*6, ONECH*1, BLANK*80,
     *   TFORM*256
      INTEGER   LOOP, IPTR, JPTR, ICALL, NPARM, SPLEN(100),  INDENT,
     *   MPLEN(100), NMPARM, LENG, PNUM, ITRIM, OPTR, KPTR, LTEMP,
     *   LREST, LX, NCHK, FCHK, SCHK, POINT, SIZE, OLDPNT, IONECH,
     *   PPTR, QPTR, LLTEMP, LSTCAL, LSTPNT, CNTCHA, JCALL
      LOGICAL   T, F, DOREST, NOT, WILD, MATCH, DOMULT, NOCHG
      INCLUDE 'XEDIT.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA BLANK /'                                        '/
C-----------------------------------------------------------------------
      NOCHG = .TRUE.
      CNTCHA = 0
      OPTR = 0
      POINT = 7
      OLDPNT = 7
C                                       See if Any routines wanted
      DO 20 LOOP = 1,NUMCAL
         IPTR = INDEX (OUTLIN(POINT:LSTR), OLDCAL(LOOP)(1:LSRC(LOOP)))
         ICALL = LOOP
C                                       Validity check
         PPTR = POINT + IPTR +  LSRC(LOOP) - 1
         ONECH = OUTLIN(PPTR:PPTR)
         IONECH = ICHAR (ONECH)
         IF (((IONECH.GE.ICHA) .AND. (IONECH.LE.ICHZ)) .AND.
     *      (OLDCAL(LOOP)(LSRC(LOOP):LSRC(LOOP)).NE.'(')) GO TO 20
         IF (IPTR.GT.0) GO TO 30
 20      CONTINUE
C                                       None wanted
      GO TO 999
C                                       Remember call and pointer
 30   LSTCAL = ICALL
      LSTPNT = POINT
C                                       Find indentation
      IPTR = IPTR + POINT - 1
      INDENT = IPTR - 1
      POINT = IPTR + LSRC(ICALL)
C                                       Don't loop forever
      CNTCHA = CNTCHA + 1
      IF (CNTCHA.GT.100) GO TO 950
C                                       Parse call sequence - may read
C                                       more from input.
 40   SIZE = LSTR - IPTR + 1
      CALL PARSE (T, OUTLIN(IPTR:LSTR), SIZE, NPARM, SPARM, SPLEN,
     *   LREST, REST)
      LSTR =  SIZE + IPTR - 1
C                                       Parse matching sequence if
C                                       necessary.
      IF (LSRC(ICALL).LT.LOLDC(ICALL)) THEN
         CALL PARSE (F, OLDCAL(ICALL), LOLDC(ICALL), NMPARM, MPARM,
     *      MPLEN, LX, XREST)
C                                       Number of call arguments must
C                                       match.
         IF (NPARM.NE.NMPARM) THEN
            IF (NPARM.GE.NMPARM) WRITE (12,1040) OUTLIN(1:LSTR)
C                                       Save REST if any
            IF (LREST.GT.0) THEN
               OUTLIN(LSTR+1:LSTR+LREST) = REST(1:LREST)
               LSTR = LSTR + LREST
               END IF
            GO TO 900
            END IF
C                                       Check if wanted.
         DO 50 LOOP = 1,NMPARM
C                                       Compare arguments given
            IF (MPLEN(LOOP).GT.0) THEN
C                                       .NOT. argument?
               NOT = MPARM(LOOP)(1:1).EQ.'!'
               FCHK = 1
               IF (NOT) FCHK = 2
C                                       Wild cards?
               WILD = MPARM(LOOP)(MPLEN(LOOP):MPLEN(LOOP)).EQ.'*'
               IF (WILD) THEN
                  NCHK = MPLEN(LOOP) - FCHK
                  SCHK = NCHK
               ELSE
                  NCHK = MPLEN(LOOP) - FCHK + 1
                  SCHK = SPLEN(LOOP)
                  END IF
C                                       Match?
               MATCH = MPARM(LOOP)(FCHK:NCHK+FCHK-1) .EQ.
     *             SPARM(LOOP)(1:SCHK)
               IF (NOT) MATCH = .NOT. MATCH
CC                                       No match for numeric values
C               MATCH = MATCH .AND. ((ICHAR (SPARM(LOOP)(1:1)).GE.ICHA)
C     *            .AND. (ICHAR (SPARM(LOOP)(1:1)).LE.ICHZ))
               IF (.NOT.MATCH) GO TO 900
               END IF
 50         CONTINUE
         END IF
C                                       Save pointer for next search
      OLDPNT = POINT
C                                       Translate
      CCOUNT = CCOUNT + 1
      NOCHG = .FALSE.
C                                       Create new output string
      IPTR = 1
      OPTR = INDENT
      FORM = NEWCAL(ICALL)
      STRING(1:INDENT) = OUTLIN(1:INDENT)
      LENG = LNEWC(ICALL)
C                                       If multiple lines can be written
C                                       and there is text preceeding the
C                                       call assume this is an IF() and
C                                       add a THEN... END IF
      DOMULT = .FALSE.
      LTEMP = INDEX (FORM, '@')
      IF (INDENT.GE.6)
     *   DOMULT = ((STRING(6:INDENT).NE.BLANK(6:INDENT)) .AND.
     *   (LTEMP.GT.0))
      IF (DOMULT) THEN
C                                       Add "THEN@   "
         STRING(INDENT+1:INDENT+8) = 'THEN@   '
         OPTR = OPTR + 8
         END IF
 60   IF (DOMULT) THEN
C                                       Add indentation to format
         TFORM = FORM
         PPTR = 1
         QPTR = 1
 70         LTEMP = INDEX (TFORM(PPTR:),'@')
            IF (LTEMP.GT.0) THEN
               LLTEMP = LTEMP + PPTR - 1
               FORM(QPTR:QPTR+LTEMP+2) = TFORM(PPTR:LLTEMP) // '   '
               QPTR = QPTR + LTEMP + 3
               PPTR = LLTEMP + 1
               LENG = LENG + 3
               GO TO 70
               END IF
C                                       Rest of format
            LLTEMP = LNEWC(ICALL) - PPTR + 1
            IF ((LLTEMP+QPTR-1).GT.250) LLTEMP = 250 - QPTR + 1
            FORM(QPTR:+QPTR+LLTEMP-1) = TFORM(PPTR:PPTR+LLTEMP-1)
         END IF
C                                       Rest of line wanted?
      DOREST = F
      IF (FORM(LENG:LENG).EQ.'%') THEN
         DOREST = T
         LENG = LENG - 1
         END IF
C                                       change it
      DO 100 LOOP = 1,1000
C                                       Find next parameter
         KPTR = INDEX (FORM(IPTR:LENG), '$')
         IF (KPTR.LE.0) GO TO 110
C                                       Parameter number
         PSTRIN = FORM(IPTR+KPTR:IPTR+KPTR+2)
         READ (PSTRIN, 1050) PNUM
C                                       glue line together
         LTEMP = KPTR + SPLEN(PNUM) - 1
         STRING(OPTR+1:OPTR+LTEMP) = FORM(IPTR:IPTR+KPTR-2) //
     *      SPARM(PNUM)(1:SPLEN(PNUM))
         IPTR = IPTR + KPTR + 2
         OPTR = OPTR + KPTR + SPLEN(PNUM) - 1
 100     CONTINUE
C                                       End of line
 110  LTEMP = LENG - IPTR + 1
      IF (IPTR.LE.LENG) THEN
         STRING(OPTR+1:OPTR+LTEMP) = FORM(IPTR:LENG)
         OPTR = OPTR + LTEMP
         END IF
C                                       Prepare to search again
      POINT = OPTR
      INDENT = OPTR
C                                       Rest of input line
      IF (DOREST) THEN
         STRING(OPTR+1:OPTR+LREST+1) = REST(1:LREST)
         OPTR = OPTR + LREST
         END IF
C                                       More?
      IF (OLDCAL(ICALL+1)(1:8).EQ.'continue') THEN
         ICALL = ICALL + 1
         FORM = NEWCAL(ICALL)
         LENG = LNEWC(ICALL)
         IPTR = 1
         GO TO 60
         END IF
C                                       If DOMULT add closing "END IF"
      IF (DOMULT) THEN
         STRING(OPTR+1:OPTR+10) = '@   END IF'
         OPTR = OPTR + 10
         END IF
      OUTLIN(1:OPTR) = STRING(1:OPTR)
      LSTR = OPTR
C                                       Declare HOLLERITH
      IF ((DOHOLL(ICALL)) .AND. (OLDCAL(ICALL)(1:5).NE.'CALL ')) THEN
         HARG = '      '
         DO 180 LOOP = 1,6
            ONECH = NEWCAL(ICALL)(LOOP:LOOP)
            IF ((ONECH.EQ.'(') .OR. (ONECH.EQ.' ') .OR. (ONECH.EQ.','))
     *         GO TO 190
            HARG(LOOP:LOOP) = ONECH
 180        CONTINUE
 190     DO 200 LOOP = 1,NHARG
            IF (HARG.EQ.ARGHOL(LOOP)) GO TO 220
 200        CONTINUE
         NHARG = NHARG + 1
         ARGHOL(NHARG) = HARG
C                                       Log need for EQUIVALENCE
         WRITE(12,1200) HARG
C                                       Add to keep it list
 220     DO 240 LOOP = 1,NHKEEP
            IF (HARG.EQ.HKEEP(LOOP)) GO TO 900
 240        CONTINUE
            NHKEEP = NHKEEP + 1
            HKEEP(NHKEEP) = HARG
            HKDIM(NHKEEP) = HOLDIM(ICALL)
            GO TO 900
         END IF
      GO TO 930
C                                       See if more routines wanted
 900  POINT = 7
      JCALL = ICALL
      DO 920 LOOP = JCALL,NUMCAL
         IPTR = 0
         IF ((LOOP.NE.LSTCAL) .OR. (POINT.GT.LSTPNT))
     *      IPTR = INDEX (OUTLIN(POINT:LSTR),
     *         OLDCAL(LOOP)(1:LSRC(LOOP)))
         ICALL = LOOP
         IF (IPTR.GT.0) THEN
C                                       Validity check
            PPTR = POINT + IPTR +  LSRC(LOOP) - 1
            ONECH = OUTLIN(PPTR:PPTR)
            IONECH = ICHAR (ONECH)
            IF (((IONECH.GE.ICHA) .AND. (IONECH.LE.ICHZ)) .AND.
     *         (OLDCAL(LOOP)(LSRC(LOOP):LSRC(LOOP)).NE.'(')) GO TO 920
            GO TO 30
            END IF
 920     CONTINUE
C                                       Move pointer
      OLDPNT = OLDPNT + LSRC(JCALL)
C                                       Try others
 930  POINT = OLDPNT
      IF (POINT.GE.LSTR) GO TO 999
C                                       Don't bother if haven't found
C                                       anything
      IF (NOCHG) GO TO 999
      NOCHG = .TRUE.
      DO 940 LOOP = 1,NUMCAL
         IPTR = 0
         IF ((LOOP.EQ.LSTCAL) .OR. (POINT.NE.LSTPNT))
     *    IPTR = INDEX (OUTLIN(POINT:LSTR), OLDCAL(LOOP)(1:LSRC(LOOP)))
         ICALL = LOOP
C                                       Validity check
         PPTR = POINT + IPTR +  LSRC(LOOP) - 1
         ONECH = OUTLIN(PPTR:PPTR)
         IONECH = ICHAR (ONECH)
         IF (((IONECH.GE.ICHA) .AND. (IONECH.LE.ICHZ)) .AND.
     *      (OLDCAL(LOOP)(LSRC(LOOP):LSRC(LOOP)).NE.'(')) GO TO 940
         IF (IPTR.GT.0) GO TO 30
 940     CONTINUE
      GO TO 999
C                                       Stuck in a loop
 950  CALL LOGER (OUTLIN, LSTR, POINT, 'CALLSQ: Stuck in line:')
      WRITE (6,1950) OUTLIN(1:70)
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT (' Too many arguments       :',A)
 1050 FORMAT (I2)
 1200 FORMAT (' May need to EQUIVALENCE ',A6,' to other data types:')
 1950 FORMAT (' CALLSQ: Got hung up in line:',/1X,A)
      END
      SUBROUTINE PARSE (SOURCE, OUTLIN, LSTR, NPARM, PARM, PLEN,
     *   LREST, REST)
C-----------------------------------------------------------------------
C   Parse a call sequence, may read more lines to complete line.
C   On output OUTLIN contains all that has been read.
C    Input:
C     SOURCE   L  True if from source file, else template.
C    Input/Output:
C     OUTLIN   C  Output line, more may be read from file.
C     LSTR     I  The number of valid characters in OUTLIN.
C    Output:
C     NPARM    I  Number of parameters found
C     PARM(*)  C  Parameters (blanks are removed).
C     PLEN(*)  I  Numbers of characters in the elements of PARM.
C     LREST    I  Number of characters in REST
C     REST     C  Line after portion parsed.
C-----------------------------------------------------------------------
      LOGICAL   SOURCE
      CHARACTER OUTLIN*(*), PARM(*)*50, REST*(*)
      INTEGER   LSTR, NPARM, PLEN(*), LREST
      CHARACTER STRING*1024, LINE*128, TSTR*50, TSTR2*50
      INTEGER   END, IPNT, PLEVEL, LOOP, LENG, JPNT, LOOP2, ITRIM, IPTR,
     *   IP, LTEMP, IERR, LPNT
      LOGICAL   PARTL, START
C-----------------------------------------------------------------------
      STRING = OUTLIN(1:LSTR)
      END = LSTR
      NPARM = 1
      PLEN(NPARM) = 0
      PARM(NPARM) = ' '
      PARTL = .TRUE.
      START = .FALSE.
      JPNT = 0
      LREST = 0
C                                       Start at first '('
 50   IPNT = INDEX (STRING(1:END), '(')
      IF (IPNT.LE.0) GO TO 999
C                                       Don't if "," first
      LPNT = INDEX (STRING(1:END), ',')
      IF ((LPNT.GT.0) .AND. (LPNT.LT.IPNT)) GO TO 999
C                                       Need another line?
      IF ((IPNT.LE.0) .AND. SOURCE) THEN
         IPNT = END + 1
         GO TO 290
         END IF
      IF (IPNT.LE.0) GO TO 500
      START = .TRUE.
      IPNT = IPNT + 1
      PLEVEL = 1
C                                       Find next level 1 ','
 100  PLEN(NPARM) = 0
      PARM(NPARM) = ' '
 110  PARTL = .FALSE.
      DO 200 LOOP = IPNT,END
         JPNT = LOOP
         IF (STRING(LOOP:LOOP).EQ.'(') PLEVEL = PLEVEL + 1
         IF (STRING(LOOP:LOOP).EQ.')') PLEVEL = PLEVEL - 1
C                                       Done?
         IF (PLEVEL.LE.0) GO TO 250
         IF ((STRING(LOOP:LOOP).EQ.',') .AND. (PLEVEL.EQ.1)) GO TO 250
 200     CONTINUE
C                                       Parameter not done
      PARTL = .TRUE.
C                                       Save parameter, partial
 250  IF (PARTL) THEN
         IP = PLEN(NPARM) + 1
         LTEMP = JPNT - IPNT + 1
         PARM(NPARM)(IP:IP+LTEMP) = STRING(IPNT:JPNT)
         PLEN(NPARM) = PLEN(NPARM) + JPNT - IPNT + 1
C                                       Full parameter
      ELSE
         IP = PLEN(NPARM) + 1
         LTEMP = JPNT - IPNT
         PARM(NPARM)(IP:IP+LTEMP) = STRING(IPNT:JPNT-1)
         PLEN(NPARM) = PLEN(NPARM) + JPNT - IPNT
         NPARM = NPARM + 1
         END IF
      IPNT = JPNT + 1
C                                       Done?
      IF (PLEVEL.LE.0) GO TO 500
C                                       Read another line if necessary
 290   IF (SOURCE .AND. (IPNT.GT.END)) THEN
         CALL GETLIN (STRING, END, IERR)
         IF (IERR.NE.0) GO TO 950
C                                       Better be a continuation line
         IF (STRING(6:6).EQ.' ') GO TO 700
C                                       Find first non blank
         DO 300 LOOP = 7,END
            IF (STRING(LOOP:LOOP).NE.' ') THEN
               IPNT = LOOP
               GO TO 310
               END IF
 300        CONTINUE
C                                       Glue new line to OUTLIN
 310     LTEMP = END - IPNT + 2
         OUTLIN(LSTR+1:LSTR+LTEMP) = ' ' // STRING(IPNT:END)
         LSTR = LSTR + END - IPNT + 2
         END IF
C                                       Begining "(" found yet?
      IF (.NOT.START) GO TO 50
      IF ((.NOT.SOURCE) .AND. (IPNT.GT.END)) GO TO 500
C                                       Next parameter
      IF (PARTL) GO TO 110
      IF (.NOT.PARTL) GO TO 100
C                                       Get rest of line
 500  LREST = END - JPNT
      REST(1:LREST) = STRING(JPNT+1:END)
C                                       Compress parameters
      NPARM = NPARM - 1
      DO 600 LOOP = 1,NPARM
         LENG = PLEN(LOOP)
         PLEN(LOOP) = 0
         TSTR = PARM(LOOP)
         TSTR2 = ' '
         IPTR = 0
         DO 550 LOOP2 = 1,LENG
            IF (TSTR(LOOP2:LOOP2).NE.' ') THEN
               IPTR = IPTR + 1
               TSTR2(IPTR:IPTR) = TSTR(LOOP2:LOOP2)
               END IF
 550        CONTINUE
         PARM(LOOP) = TSTR2(1:IPTR)
         PLEN(LOOP) = IPTR
 600     CONTINUE
      GO TO 999
C                                       Problem - not cont. line
 700  WRITE (6,1700) STRING(1:END)
      WRITE (12,1700) STRING(1:END)
C                                       Save rest of line
      REST(LREST+1:LREST+END) = '@' // STRING(7:END)
      LREST = LREST + END - 5
      IF (STRING(1:6).NE.'      ') THEN
         WRITE(6,1701)
         WRITE(12,1701)
         END IF
      NPARM = 0
      GO TO 999
C                                       End of file or error
 950  WRITE (6,1950)
C
 999  RETURN
C-----------------------------------------------------------------------
 1250 FORMAT (A)
 1700 FORMAT (' PARSE: Continuation line expected, found:',/1X,A)
 1701 FORMAT (' PARSE: Label or Comment delimiter lost from line!!!')
 1950 FORMAT (' PARSE: Trouble reading input Fortran file')
      END
      SUBROUTINE LOGIT (PAGE, MODULE, LMODUL, NUMLOG, LOGSTR, LLOG,
     *   LOGREA)
C-----------------------------------------------------------------------
C   Subroutine to enter occurances of the logging strings in the .LOG
C    Inputs:
C     PAGE     I  Number of pages in MODULE
C     MODULE   C  First page of the Module buffer.
C     LMODUL   I  Number of characters in MODULE.
C     NUMLOG   I  Number of elements in LOGSTR
C     LOGSTR(*)C  Strings to log
C     LLOG(*)  I  Length of strings in LOGSTR
C     LOGREA(*)C  Reason strings
C-----------------------------------------------------------------------
      INTEGER   PAGE
      CHARACTER MODULE(PAGE)*(*), LOGSTR(*)*(*), LOGREA(*)*25
      INTEGER   LMODUL(PAGE), LLOG(*), NUMLOG
      CHARACTER ARGSTR*10
      INTEGER   FIRST, LOOP, IPAGE, ILOG, BACK, POINT, IPNT, ITRIM,
     *   LARG, LINEND(2,20), FRONT, END, LAST, HERE, BCKCHK, IUSE,
     *   EEND, N72
      DATA N72 /72/
C-----------------------------------------------------------------------
      IF (NUMLOG.LE.0) GO TO 999
      FIRST = 1
C                                       Loop over pages
      DO 500 IPAGE = 1,PAGE
C                                       Loop over arguments
         DO 400 ILOG = 1,NUMLOG
            POINT = FIRST
C                                       Find occurance
            LARG = LLOG(ILOG)
            IF (LARG.LE.0) GO TO 400
 100           IPNT = INDEX (MODULE(IPAGE)(POINT:LMODUL(IPAGE)),
     *            LOGSTR(ILOG)(1:LARG))
               IF (IPNT.LE.0) GO TO 400
               HERE = POINT + IPNT - 1
               END = INDEX (MODULE(IPAGE)(HERE:HERE+75), '@') +
     *            HERE - 1
C                                       Reset POINT for next search
               POINT = END + 1
C                                       Log it
               CALL LOGER (MODULE(IPAGE), LMODUL(IPAGE), HERE,
     *            LOGREA(ILOG))
 300           GO TO 100
 400        CONTINUE
         FIRST = 1
 500     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE LOGER (MODULE, LMODUL, HERE, LABEL)
C-----------------------------------------------------------------------
C   Subroutine to add anotated lines of source code to the log file.
C    Inputs:
C     MODULE   C  Current page of the Module buffer.
C     LMODUL   I  Number of characters in MODULE.
C     HERE     I  Pointer in statment to be printed
C     LABEL    C  Label for first line of statment
C-----------------------------------------------------------------------
      CHARACTER MODULE*(*), LABEL*(*)
      INTEGER   LMODUL
      CHARACTER BLANK*50
      INTEGER   FIRST, LOOP, BACK, IPNT, LINEND(2,20), FRONT, END,
     *   LAST, HERE, BCKCHK, EEND, LABLEN, IFST, IEND,
     *   N72
      EXTERNAL LAST
      DATA N72 /72/
      DATA BLANK /'                                                  '/
C-----------------------------------------------------------------------
      LABLEN = LEN (LABEL)
C                                       Find end of line
      BACK = 0
      END = INDEX (MODULE(HERE:HERE+300), '@') + HERE - 1
      EEND = END
      BCKCHK = MIN (N72, HERE) - 1
      FRONT = LAST (MODULE(HERE-BCKCHK:HERE), '@') + HERE - BCKCHK - 1
C                                       Backup to first line of
C                                       continuation series.
C                                       Find end
 150     BCKCHK = MIN (N72, HERE) - 1
         FRONT = LAST (MODULE(HERE-BCKCHK:HERE), '@') +
     *      HERE - BCKCHK - 1
C                                       Save ends
         BACK = BACK + 1
         LINEND(1,BACK) = FRONT
         LINEND(2,BACK) = END
         HERE = FRONT - 2
         END = FRONT
C                                       Continuation line? loop
         IF ((MODULE(FRONT+6:FRONT+6).NE.' ') .AND.
     *      (HERE.GT.0)) GO TO 150
C                                       FORMAT?
      IF (MODULE(FRONT+7:FRONT+12).EQ.'FORMAT')
     *   GO TO 999
C                                       Log it.
      DO 250 LOOP = 1,BACK
         IPNT = BACK - LOOP + 1
         FRONT = LINEND(1,IPNT) + 1
         END = LINEND(2,IPNT) - 1
         IEND = END
         IF (IEND.GT.(FRONT+99)) IEND = FRONT + 99
         IF (LOOP.EQ.1) THEN
            WRITE (12,1200,ERR=999) LABEL(1:LABLEN), MODULE(FRONT:IEND)
         ELSE
            WRITE (12,1200,ERR=999) BLANK(1:LABLEN), MODULE(FRONT:IEND)
            END IF
C                                       Do rest of line
 230     IF (IEND.LT.END) THEN
            FRONT = IEND + 1
            IEND = END
            IF (IEND.GT.(FRONT+99)) IEND = FRONT + 99
            WRITE (12,1200,ERR=999) BLANK(1:LABLEN), MODULE(FRONT:IEND)
            GO TO 230
            END IF
 250     CONTINUE
C                                       Do any more continuation lines
 260  IF (END .GE. LMODUL) GO TO 999
      IF ((MODULE(END+2:END+2).NE.'C') .AND.
     *   (MODULE(END+7:END+7).NE.' ')) THEN
         FRONT = END + 2
         END = INDEX (MODULE(FRONT:FRONT+75), '@')
     *      + FRONT - 2
         IEND = END
         IF (IEND.GT.(FRONT+99)) IEND = FRONT + 99
         WRITE (12,1200,ERR=999) BLANK(1:LABLEN), MODULE(FRONT:IEND)
C                                       Do rest of line
 270     IF (IEND.LT.END) THEN
            FRONT = IEND + 1
            IEND = END
            IF (IEND.GT.(FRONT+99)) IEND = FRONT + 99
            WRITE (12,1200,ERR=999) BLANK(1:LABLEN), MODULE(FRONT:IEND)
            GO TO 270
            END IF
         GO TO 260
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1200 FORMAT (1X,A,': ',A)
      END
      SUBROUTINE PRTMOD (PAGE, MODULE, LMODUL, LCOUNT)
C-----------------------------------------------------------------------
C   Routine to write the contents of MODULE on unit 11.  A line break is
C   inserted every '@' character.  Blank lines are removed.
C    Inputs:
C     PAGE       I  Number of pages used in MODULE
C     MODULE(*)  C  Module string (65 kbytes)
C     LMODUL(*)  I  Number of valid characters in MODULE.
C   Input/Output:
C     LCOUNT     I  Line count
C-----------------------------------------------------------------------
      INTEGER   PAGE
      CHARACTER MODULE(PAGE)*(*)
      INTEGER   LMODUL(PAGE), LCOUNT
      INTEGER   START, END, LOOP, IEND, ITRIM, NEXTNQ
      EXTERNAL  ITRIM, NEXTNQ
C-----------------------------------------------------------------------
C                                       Loop over page
      DO 200 LOOP = 1,PAGE
         IF (LMODUL(LOOP).LE.0) GO TO 999
         START = 1
C                                       Loop printing
 100        END = NEXTNQ (MODULE(LOOP)(START:START+200), '@')
C                                       Trap '@' problems
            IF ((END.LE.0) .OR. (END.GT.73)) THEN
C                                       Break at next '@'
               END = INDEX (MODULE(LOOP)(START:START+1000), '@')
               IF (END.LE.0) GO TO 990
               END IF
            END = END + START - 2
            IEND = ITRIM (MODULE(LOOP)(START:END)) + START - 1
            IF (IEND.GE.START) THEN
               WRITE (11,1100,ERR=990) MODULE(LOOP)(START:IEND)
               LCOUNT = LCOUNT + 1
               END IF
            START = END + 2
            IF (START.LT.LMODUL(LOOP)) GO TO 100
 200     CONTINUE
      GO TO 999
C                                       problem
 990  WRITE (6,1990)
      WRITE (12,1990)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT (A)
 1990 FORMAT (' ******* PRTMOD failed; module partially written.')
      END
      SUBROUTINE DCLEDT (PAGE, MODULE, LMODUL, NHARG, ARGHOL)
C-----------------------------------------------------------------------
C   Routine to redeclare Hollerith and Character variables.
C   See SETUP for info in common.
C   Assumes enough room left on  page 1 for the additional declarations.
C    Input/Output:
C     PAGE    I  Number of pages in MODULE
C     MODULE  C  Module string, '@' => line break
C     LMODUL  I  Number of valid characters in MODULE (including '@')
C     NHARG   I  Number of elements in ARGHOL
C     ARGHOL  C  List of variables to redeclare as Hollerith
C   Input from common
C     BEGDCL       I  Pointer to the first character of the declaration
C     ENDDCL       I  Pointer to the last character of the declaration
C     BEGFOR       I  Pointer to the first character of the executable
C     DCLPOS(3,*)  I  Declaration position pointers wrt BEGDCL
C                     First character, last character, type:
C                     1 = INTEGER, 2 = REAL, 3 = HOLLERITH,
C                     4 = CHARACTER, 5 = LOGICAL, 6 = DOUBLE PRECISION,
C                     7 = COMPLEX
C     NUMDCL       I  Number of entries in DCLPOS
C-----------------------------------------------------------------------
      INTEGER   PAGE
      CHARACTER MODULE(PAGE)*(*)
      INTEGER   LMODUL(PAGE)
      CHARACTER STRING*32767
      CHARACTER DCL*4096, ARGHOL(500)*6, ARGCHR(500)*6, HOLUSE(50)*6,
     *   CHRUSE(50)*6, CHRDIM(500)*20
      INTEGER   NHARG, NCARG, NHUSE, NCUSE, SIZE, LDCL, LSTR, NADD
      LOGICAL   T, F
      INCLUDE 'XEDIT.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IF ((NUMHOL.LE.0) .AND. (NUMCHR.LE.0)) GO TO 999
      LDCL = 0
      NCARG = 0
      IF (BEGDCL.GE.ENDDCL) GO TO 999
C                                       Find Character calls
      IF (NUMCHR.GT.0) THEN
         CALL FNDVAR (T, PAGE, MODULE, LMODUL, BEGFOR, NUMCHR, CHRDCL,
     *      NHARG, ARGHOL, CHRARG(1,1,1), CHRARG(1,1,2), NCARG, NCUSE,
     *      ARGCHR, CHRUSE, CHRDIM)
C                                       Find CHARACTERs from DATA
C                                       statments
         CALL DATCHR (MODULE(1), LMODUL(1), BEGFOR, BEGDCL, DCLPOS,
     *      NUMDCL, NCARG, ARGCHR, CHRDIM)
C                                       Find forced declarations
         CALL FNDUSE (PAGE, MODULE, LMODUL, BEGFOR, NCKEEP, CKEEP,
     *      NCARG, ARGCHR)
C                                       Form Character declarations
         SIZE = ENDDCL - BEGDCL + 1
         CALL CHRDL (MODULE(1)(BEGDCL:ENDDCL), SIZE, DCLPOS, NUMDCL,
     *      NUMCHR, CHRARG, NCARG, ARGCHR, CHRDIM, NCKEEP,
     *      CKEEP, CKDIM, MODULE(1)(1:BEGDCL), DCL, LDCL)
C                                       Log warnings about other uses
C                                       Add 'WRITE' to list of allowed
C                                       uses
         NCUSE = NCUSE + 1
         CHRUSE(NCUSE) = 'WRITE'
         CALL DCLWRN (PAGE, ENDDCL, MODULE, LMODUL, NCARG, NCUSE,
     *      ARGCHR, CHRUSE, 'CHARACTER ')
         END IF
C                                       Find Hollerith calls
      IF (NUMHOL.GT.0) THEN
         CALL FNDVAR (F, PAGE, MODULE, LMODUL, BEGFOR, NUMHOL, HOLDCL,
     *      NCARG, ARGCHR, HOLARG, HOLARG, NHARG, NHUSE, ARGHOL,
     *      HOLUSE, CHRDIM)
C                                       Find forced declarations
         CALL FNDUSE (PAGE, MODULE, LMODUL, BEGFOR, NHKEEP, HKEEP,
     *      NHARG, ARGHOL)
C                                       Form Hollerith declarations
         SIZE = ENDDCL - BEGDCL + 1
         CALL HOLDL (MODULE(1)(BEGDCL:ENDDCL), SIZE, DCLPOS, NUMDCL,
     *      NHARG, ARGHOL, NHKEEP, HKEEP, HKDIM, MODULE(1)(1:BEGDCL),
     *      DCL, LDCL)
C                                       Log warnings about other uses
C                                       uses
         CALL DCLWRN (PAGE, ENDDCL, MODULE, LMODUL, NHARG, NHUSE,
     *      ARGHOL, HOLUSE, 'HOLLERITH ')
         END IF
C                                       Make sure '@' at beginning of
C                                       declarations is there.
      MODULE(1)(BEGDCL:BEGDCL) = '@'
      IF ((NHARG.GT.0) .OR. (NCARG.GT.0)) THEN
C                                       Copy precursor
         STRING(1:BEGDCL) = MODULE(1)(1:BEGDCL)
         LSTR = BEGDCL + 1
C                                       Format declarations
         CALL LINOUT (DCL, LDCL, STRING, LSTR)
         NADD = LSTR - BEGDCL - 1
C                                       Copy rest of module
         SIZE = LMODUL(1) - BEGDCL
         STRING(LSTR:LSTR+SIZE-1) = MODULE(1)(BEGDCL+1:LMODUL(1))
         LSTR = LSTR + SIZE - 1
C                                       Copy back
         MODULE(1)(1:LSTR) = STRING(1:LSTR)
         LMODUL(1) = LSTR
C                                       Update pointers
         BEGDCL = BEGDCL + NADD
         ENDDCL = ENDDCL + NADD
         BEGFOR = BEGFOR + NADD
         END IF
 999  RETURN
      END
      SUBROUTINE PARSEC (STRING, NPARM, PARM, PLEN)
C-----------------------------------------------------------------------
C   Parse a call sequence from a character array.
C   '@' is assumed to the the end of line character.
C    Input
C     STRING   C  String to parse.
C    Output:
C     NPARM    I  Number of parameters found
C     PARM(*)  C  Parameters (blanks and subscripts are removed).
C                 Should be 50 characters.
C     PLEN(*)  I  Numbers of characters in the elements of PARM.
C-----------------------------------------------------------------------
      CHARACTER STRING*(*), PARM(*)*50
      INTEGER   NPARM, PLEN(*)
      CHARACTER WORK*80, TSTR*50, TSTR2*50
      INTEGER   END, IPNT, PLEVEL, LOOP, LENG, JPNT, LOOP2, ITRIM,
     *   POINT, IPTR, IP, LTEMP
      LOGICAL   PARTL
C-----------------------------------------------------------------------
      POINT = 1
C                                       Extract rest of current line
      IPNT = INDEX (STRING(POINT:POINT+75), '@')
      WORK = STRING(POINT:POINT+IPNT-2)
      END = IPNT
      POINT = POINT + IPNT
C                                       Start at first '('
      IPNT = INDEX (WORK(1:END), '(')
      NPARM = 1
      IF ((WORK(1:1).EQ.',') .OR. (WORK(1:2).EQ.' ,')) GO TO 500
      IF (IPNT.LE.0) GO TO 500
      PLEVEL = 1
      IPNT = IPNT + 1
C                                       Find next level 1 ','
 100  PLEN(NPARM) = 0
      PARM(NPARM) = ' '
 110  PARTL = .FALSE.
      DO 200 LOOP = IPNT,END
         JPNT = LOOP
         IF (WORK(LOOP:LOOP).EQ.'(') PLEVEL = PLEVEL + 1
         IF (WORK(LOOP:LOOP).EQ.')') PLEVEL = PLEVEL - 1
C                                       Done?
         IF (PLEVEL.LE.0) GO TO 250
         IF ((WORK(LOOP:LOOP).EQ.',') .AND. (PLEVEL.EQ.1)) GO TO 250
 200     CONTINUE
      JPNT = END
C                                       Parameter not done
      PARTL = .TRUE.
C                                       Save parameter, partial
 250  IF (PARTL) THEN
         IP = PLEN(NPARM) + 1
         LTEMP = JPNT - IPNT
         PARM(NPARM)(IP:IP+LTEMP) = WORK(IPNT:JPNT)
         PLEN(NPARM) = PLEN(NPARM) + JPNT - IPNT + 1
C                                       Full parameter
      ELSE
         IP = PLEN(NPARM) + 1
         LTEMP = JPNT - IPNT - 1
         PARM(NPARM)(IP:IP+LTEMP) = WORK(IPNT:JPNT-1)
         PLEN(NPARM) = PLEN(NPARM) + JPNT - IPNT
         NPARM = NPARM + 1
         END IF
      IPNT = JPNT + 1
C                                       Done?
      IF (PLEVEL.LE.0) GO TO 500
C                                       Fetch another line if necessary
      IF (JPNT.GE.END) THEN
         IPNT = INDEX (STRING(POINT+1:POINT+75), '@') + 1
         WORK = STRING(POINT+1:POINT+IPNT-2)
         END = IPNT
         POINT = POINT + IPNT
         IPNT = 7
         END IF
C                                       Next parameter
      IF (PARTL) GO TO 110
      IF (.NOT.PARTL) GO TO 100
C                                       Compress parameters, remove
C                                       parenthese
 500  NPARM = NPARM - 1
      DO 600 LOOP = 1,NPARM
         LENG = PLEN(LOOP)
         PLEN(LOOP) = 0
         TSTR = PARM(LOOP)
         TSTR2 = ' '
         IPTR = 0
         DO 550 LOOP2 = 1,LENG
            IF (TSTR(LOOP2:LOOP2).EQ.'(') GO TO 560
            IF (TSTR(LOOP2:LOOP2).NE.' ') THEN
               IPTR = IPTR + 1
               TSTR2(IPTR:IPTR) = TSTR(LOOP2:LOOP2)
               END IF
 550        CONTINUE
 560     PARM(LOOP) = TSTR2(1:IPTR)
         PLEN(LOOP) = IPTR
 600     CONTINUE
      GO TO 999
C                                       End of file or error
 950  WRITE (6,1950)
C
 999  RETURN
C-----------------------------------------------------------------------
 1250 FORMAT (A)
 1950 FORMAT ('PARSEC: Trouble reading input Fortran file')
      END
      SUBROUTINE FNDDCL (MODULE, LMODUL)
C-----------------------------------------------------------------------
C   Subroutine to find the beginning and end of the declarations and
C   the first line of the executable (NOT DATA).
C    Inputs:
C     MODULE   C  First page of the Module buffer.
C     LMODUL   I  Number of characters in MODULE.
C   Outputs in common:
C     BEGDCL       I  Pointer to the first character of the declaration
C     ENDDCL       I  Pointer to the last character of the declaration
C     BEGFOR       I  Pointer to the first character of the executable
C     DCLPOS(3,*)  I  Declaration position pointers wrt BEGDCL
C                     First character, last character, type:
C                     1 = INTEGER, 2 = REAL, 3 = HOLLERITH,
C                     4 = CHARACTER, 5 = LOGICAL, 6 = DOUBLE PRECISION,
C                     7 = COMPLEX
C     NUMDCL       I  Number of entries in DCLPOS
C-----------------------------------------------------------------------
      CHARACTER MODULE*(*)
      INTEGER   LMODUL
      INTEGER   INT1, REA1, HOL1, CHR1, LOG1, DP1, CPX1, DAT1,
     *   INTEND, REAEND, HOLEND, CHREND, LOGEND, DPEND, CPXEND, DATEND,
     *   POINT, NEXT, PCALL, PEQUAL, LAST, LOOP
      CHARACTER*15 INT, REA, HOL, CHR, LOG, DP, CPX
      CHARACTER DAT*12
      INCLUDE 'XEDIT.INC'
      DATA       INT,             REA,                 HOL
     *   /'@      INTEGER ', '@      REAL    ', '@      HOLLERIT'/
      DATA       CHR,             LOG,                DP
     *   /'@      CHARACTE', '@      LOGICAL ', '@      DOUBLE P'/
      DATA       CPX,              DAT
     *   /'@      COMPLEX ', '@      DATA '/
C-----------------------------------------------------------------------
      NUMDCL = 0
C                                       Find first, last INTEGER
      INT1 = 99999
      INTEND = 0
      POINT = INDEX (MODULE(1:LMODUL), INT)
      IF (POINT.GT.0) THEN
         NEXT = 0
         INT1 = POINT
C                                       Find last INTEGER
 10         POINT = POINT + NEXT + 15
            NUMDCL = NUMDCL + 1
            DCLPOS(1,NUMDCL) = POINT - 15
            DCLPOS(3,NUMDCL) = 1
C                                       Find end of last cont. card
 20            NEXT = INDEX (MODULE(POINT+1:POINT+75), '@') + 1
               POINT = POINT + NEXT - 1
               INTEND = POINT
               DCLPOS(2,NUMDCL) = POINT
               IF (((POINT+1).LT.LMODUL) .AND.
     *             (MODULE(POINT+6:POINT+6).NE.' ') .AND.
     *             (MODULE(POINT+1:POINT+1).NE.'C')) GO TO 20
            NEXT = INDEX (MODULE(POINT:LMODUL), INT)
            IF (NEXT.GT.0) GO TO 10
         END IF
C                                       Find first, last REAL
      REA1 = 99999
      REAEND = 0
      POINT = INDEX (MODULE(1:LMODUL), REA(1:12))
      IF (POINT.GT.0) THEN
         NEXT = 0
         REA1 = POINT
C                                       Find last REAL
 30         POINT = POINT + NEXT + 12
            NUMDCL = NUMDCL + 1
            DCLPOS(1,NUMDCL) = POINT - 12
            DCLPOS(3,NUMDCL) = 2
C                                       Find end of last cont. card
 40            NEXT = INDEX (MODULE(POINT+1:POINT+75), '@') + 1
               POINT = POINT + NEXT - 1
               REAEND = POINT
               DCLPOS(2,NUMDCL) = POINT
               IF (((POINT+1).LT.LMODUL) .AND.
     *             (MODULE(POINT+6:POINT+6).NE.' ') .AND.
     *             (MODULE(POINT+1:POINT+1).NE.'C')) GO TO 40
            NEXT = INDEX (MODULE(POINT:LMODUL), REA(1:12))
            IF (NEXT.GT.0) GO TO 30
         END IF
C                                       Find first, last HOLLERITH
      HOL1 = 99999
      HOLEND = 0
      POINT = INDEX (MODULE(1:LMODUL), HOL)
      IF (POINT.GT.0) THEN
         NEXT = 0
         HOL1 = POINT
C                                       Find last HOLLERITH
 50         POINT = POINT + NEXT + 15
            NUMDCL = NUMDCL + 1
            DCLPOS(1,NUMDCL) = POINT - 15
            DCLPOS(3,NUMDCL) = 3
C                                       Find end of last cont. card
 60            NEXT = INDEX (MODULE(POINT+1:POINT+75), '@') + 1
               POINT = POINT + NEXT - 1
               DCLPOS(2,NUMDCL) = POINT
               HOLEND = POINT
               IF (((POINT+1).LT.LMODUL) .AND.
     *             (MODULE(POINT+6:POINT+6).NE.' ') .AND.
     *             (MODULE(POINT+1:POINT+1).NE.'C')) GO TO 60
            NEXT = INDEX (MODULE(POINT:LMODUL), HOL)
            IF (NEXT.GT.0) GO TO 50
         END IF
C                                       Find first, last CHARACTER
      CHR1 = 99999
      CHREND = 0
      POINT = INDEX (MODULE(1:LMODUL), CHR)
      IF (POINT.GT.0) THEN
         NEXT = 0
         CHR1 = POINT
C                                       Find last CHARACTER
 70         POINT = POINT + NEXT + 15
            NUMDCL = NUMDCL + 1
            DCLPOS(1,NUMDCL) = POINT - 15
            DCLPOS(3,NUMDCL) = 4
C                                       Find end of last cont. card
 80            NEXT = INDEX (MODULE(POINT+1:POINT+75), '@') + 1
               POINT = POINT + NEXT - 1
               DCLPOS(2,NUMDCL) = POINT
               CHREND = POINT
               IF (((POINT+1).LT.LMODUL) .AND.
     *             (MODULE(POINT+6:POINT+6).NE.' ') .AND.
     *             (MODULE(POINT+1:POINT+1).NE.'C')) GO TO 80
            NEXT = INDEX (MODULE(POINT:LMODUL), CHR)
            IF (NEXT.GT.0) GO TO 70
         END IF
C                                       Find first, last LOGICAL
      LOG1 = 99999
      LOGEND = 0
      POINT = INDEX (MODULE(1:LMODUL), LOG)
      IF (POINT.GT.0) THEN
         NEXT = 0
         LOG1 = POINT
C                                       Find last LOGICAL
 90         POINT = POINT + NEXT + 15
            NUMDCL = NUMDCL + 1
            DCLPOS(1,NUMDCL) = POINT - 15
            DCLPOS(3,NUMDCL) = 5
C                                       Find end of last cont. card
 100           NEXT = INDEX (MODULE(POINT+1:POINT+75), '@') + 1
               POINT = POINT + NEXT - 1
               DCLPOS(2,NUMDCL) = POINT
               LOGEND = POINT
               IF (((POINT+1).LT.LMODUL) .AND.
     *             (MODULE(POINT+6:POINT+6).NE.' ') .AND.
     *             (MODULE(POINT+1:POINT+1).NE.'C')) GO TO 100
            NEXT = INDEX (MODULE(POINT:LMODUL), LOG)
            IF (NEXT.GT.0) GO TO 90
         END IF
C                                       Find first,last DOUBLE PRECISION
      DP1 = 99999
      DPEND = 0
      POINT = INDEX (MODULE(1:LMODUL), DP)
      IF (POINT.GT.0) THEN
         NEXT = 0
         DP1 = POINT
C                                       Find last DOUBLE PRECISION
 110        POINT = POINT + NEXT + 15
            NUMDCL = NUMDCL + 1
            DCLPOS(1,NUMDCL) = POINT - 15
            DCLPOS(3,NUMDCL) = 6
C                                       Find end of last cont. card
 120           NEXT = INDEX (MODULE(POINT+1:POINT+75), '@') + 1
               POINT = POINT + NEXT - 1
               DPEND = POINT
               DCLPOS(2,NUMDCL) = POINT
               IF (((POINT+1).LT.LMODUL) .AND.
     *             (MODULE(POINT+6:POINT+6).NE.' ') .AND.
     *             (MODULE(POINT+1:POINT+1).NE.'C')) GO TO 120
            NEXT = INDEX (MODULE(POINT:LMODUL), DP)
            IF (NEXT.GT.0) GO TO 110
         END IF
C                                       Find first, last COMPLEX
      CPX1 = 99999
      CPXEND = 0
      POINT = INDEX (MODULE(1:LMODUL), CPX)
      IF (POINT.GT.0) THEN
         NEXT = 0
         CPX1 = POINT
C                                       Find last COMPLEX
 130        POINT = POINT + NEXT + 15
            NUMDCL = NUMDCL + 1
            DCLPOS(1,NUMDCL) = POINT - 15
            DCLPOS(3,NUMDCL) = 7
C                                       Find end of last cont. card
 140           NEXT = INDEX (MODULE(POINT+1:POINT+75), '@') + 1
               POINT = POINT + NEXT - 1
               CPXEND = POINT
               DCLPOS(2,NUMDCL) = POINT
               IF (((POINT+1).LT.LMODUL) .AND.
     *             (MODULE(POINT+6:POINT+6).NE.' ') .AND.
     *             (MODULE(POINT+1:POINT+1).NE.'C')) GO TO 140
            NEXT = INDEX (MODULE(POINT:LMODUL), CPX)
            IF (NEXT.GT.0) GO TO 130
         END IF
C                                       Set beginning, end of
C                                       declarations
      BEGDCL = MIN (INT1, REA1, HOL1, CHR1, LOG1, DP1, CPX1)
      ENDDCL = MAX (INTEND, REAEND, HOLEND, CHREND, LOGEND, DPEND,
     *   CPXEND)
C                                       Refer DCLPOS to BEGDCL
      DO 150 LOOP = 1,NUMDCL
         DCLPOS(1,LOOP) = DCLPOS(1,LOOP) - BEGDCL + 1
         DCLPOS(2,LOOP) = DCLPOS(2,LOOP) - BEGDCL + 1
 150     CONTINUE
C                                       Find beginning of CODE
C                                       i.e. End of DATA
      DATEND = ENDDCL
      POINT = INDEX (MODULE(1:LMODUL), DAT)
      BEGFOR = ENDDCL + 1
      IF (POINT.GT.0) THEN
         NEXT = 0
C                                       Find last DATA
 200        POINT = POINT + NEXT + 15
            NEXT = INDEX (MODULE(POINT:LMODUL), DAT)
            IF (NEXT.GT.0) GO TO 200
C                                       Find end of last cont. card
 210        NEXT = INDEX (MODULE(POINT+1:POINT+75), '@') + 1
            POINT = POINT + NEXT - 1
            DATEND = POINT
            IF (((POINT+1).LT.LMODUL) .AND.
     *         (MODULE(POINT+6:POINT+6).NE.' ') .AND.
     *         (MODULE(POINT+1:POINT+1).NE.'C')) GO TO 210
         BEGFOR = DATEND + 1
C                                       If no DATA use first call or =
      ELSE
         PCALL = INDEX (MODULE(BEGFOR:LMODUL), ' CALL ') + BEGFOR - 1
         PEQUAL = INDEX (MODULE(BEGFOR:LMODUL), '=') + BEGFOR - 1
         IF (PCALL.LE.(BEGFOR-1)) PCALL = LMODUL
         IF (PEQUAL.LE.(BEGFOR-1)) PEQUAL = LMODUL
         PCALL = MIN (PCALL, PEQUAL)
         BEGFOR = LAST (MODULE(PCALL-72:PCALL), '@') + PCALL - 72
         END IF
 999  RETURN
      END
      SUBROUTINE FNDVAR (ISCHAR, PAGE, MODULE, LMODUL, BEGFOR, NUMVAR,
     *   VARDCL, NCHK, CHECK, VARARG, DEFDIM, NVARG, NVUSE, ARGVAR,
     *   VARUSE, VARDIM)
C-----------------------------------------------------------------------
C   Subroutine to find calls to specified routines and to return a list
C   of specified arguments.
C   Also logs conflicting useage.
C    Inputs:
C     ISCHAR   L  IF true then looking for CHARACTERS
C     PAGE     I  Number of pages in MODULE
C     MODULE   C  First page of the Module buffer.
C     LMODUL   I  Number of characters in MODULE.
C     BEGFOR   I  Start of executable code on first page.
C     NUMVAR   I  Number of elements in VARDCL
C     VARDCL   C  Specified routine names
C     NCHK     I  Number of elements in CHECK
C     CHECK    C  List of arguments declared another type.
C     VARARG() I  List of specified argument numbers
C     DEFDIM() I  Default number of characters.
C   Outputs:
C     NVARG    I  Number of arguments found
C     NVUSE    I  Number of calling routines
C     ARGVAR   C  List of Specified arguments
C     VARUSE   C  List of Specified routines called
C     VARDIM(*)C  List of dimensions to use (character only).
C                 'none' => use local declaration
C-----------------------------------------------------------------------
      INTEGER   PAGE
      LOGICAL   ISCHAR
      CHARACTER MODULE(PAGE)*(*), VARDCL(*)*6, ARGVAR(*)*6,
     *   CHECK(*)*6, VARUSE(*)*6, VARDIM(*)*20
      INTEGER   LMODUL(PAGE), BEGFOR, NUMVAR, VARARG(5,*), NCHK,
     *   NVARG, NVUSE,  DEFDIM(5,*)
      INTEGER   IPAGE, ISUBR, LOOP, FIRST, POINT, ITRIM, SLEN, NPARM,
     *   PLEN(100), IARG, JARG, OFF, LCALLS, START, LSUB, TPNT, ND
      LOGICAL   ISSUB
      CHARACTER PARM(100)*50, CALLS*15, LABEL*30, SUB*10, NEXTC
C-----------------------------------------------------------------------
      IF (NUMVAR.LE.0) GO TO 999
      START = BEGFOR
      NVUSE = 0
C                                       Loop over pages
      DO 500 IPAGE = 1,PAGE
C                                       Loop over Specified routines
         DO 400 ISUBR = 1,NUMVAR
            FIRST = START
            SLEN = ITRIM (VARDCL(ISUBR))
C                                       READ and WRITE no 'CALL';
            IF ((VARDCL(ISUBR)(1:5).EQ.'READ ') .OR.
     *          (VARDCL(ISUBR)(1:6).EQ.'WRITE ')) THEN
               LCALLS = 3 + SLEN
               CALLS(1:LCALLS) = ' ' // VARDCL(ISUBR)(1:SLEN) // ' ('
            ELSE
               LCALLS = 6 + SLEN
               CALLS(1:LCALLS) = ' CALL ' // VARDCL(ISUBR)
               END IF
C                                       See if this is the subroutine
               POINT = 0
               IF (IPAGE.EQ.1) THEN
                  LSUB = SLEN + 4
                  SUB = 'INE ' // VARDCL(ISUBR)
                  POINT = INDEX (MODULE(1)(1:72), SUB(1:LSUB))
C                                       Make sure of name
                  IF (POINT.GT.0) THEN
                     NEXTC = MODULE(1)(POINT+LSUB:POINT+LSUB)
                     IF ((NEXTC.NE.' ') .AND. (NEXTC.NE.'(')) POINT = 0
                     END IF
                  ISSUB = POINT .GT. 0
                  IF (ISSUB) THEN
                     FIRST = 1
                     GO TO 60
                     END IF
                  END IF
C                                       Find call
 50            POINT = INDEX (MODULE(IPAGE)(FIRST:LMODUL(IPAGE)),
     *            CALLS(1:LCALLS))
C                                       Found?
C                                       Verify name
               IF (POINT.GT.0) THEN
                  TPNT = FIRST + POINT + LCALLS - 1
                  NEXTC = MODULE(1)(TPNT:TPNT)
                  IF ((NEXTC.NE.' ') .AND. (NEXTC.NE.'(')) POINT = 0
                  END IF
 60            IF (POINT.GT.0) THEN
                  OFF = POINT
C                                       Save routine name
                  DO 100 LOOP = 1,NVUSE
                     IF (VARDCL(ISUBR).EQ.VARUSE(LOOP)) GO TO 110
 100                 CONTINUE
                  NVUSE = NVUSE + 1
                  VARUSE(NVUSE) = VARDCL(ISUBR)
C                                       Parse arguments
 110              POINT = POINT + FIRST - 1
                  CALL PARSEC (MODULE(IPAGE)(POINT:LMODUL(IPAGE)),
     *               NPARM, PARM, PLEN)
                  IF (NPARM.LE.0) GO TO 250
                  DO 200 IARG = 1,5
                     IF (VARARG(IARG,ISUBR).GT.0) THEN
C                                       Save argument
                        JARG = VARARG(IARG,ISUBR)
C                                       Only valid arguments
                        IF ((JARG.LE.NPARM) .AND. (PARM(JARG)(1:6).NE.
     *                   '      ')) THEN
C                                       Check for conflicts
                        DO 120 LOOP = 1,NCHK
                           IF (PARM(JARG).EQ.CHECK(LOOP)) THEN
                              LABEL = 'Type conflict in use of ' //
     *                           CHECK(LOOP)
                              CALL LOGER (MODULE(IPAGE), LMODUL(IPAGE),
     *                           POINT, LABEL)
                              GO TO 130
                              END IF
 120                       CONTINUE
 130                       DO 150 LOOP = 1,NVARG
                              IF (PARM(JARG)(1:6).EQ.ARGVAR(LOOP))
     *                           GO TO 200
 150                          CONTINUE
                           END IF
                        NVARG = NVARG + 1
                        ARGVAR(NVARG) = PARM(JARG)(1:6)
C                                       Character dimensions
                        IF (ISCHAR) THEN
                           ND = DEFDIM(IARG,ISUBR)
                           VARDIM(NVARG) = '*(*)'
                           IF (ND.EQ.0) VARDIM(NVARG) = 'none'
                           IF ((ND.GE.1) .AND. (ND.LE.9))
     *                        WRITE (VARDIM(NVARG),1150,ERR=200) ND
                           IF ((ND.GE.10) .AND. (ND.LE.99))
     *                        WRITE (VARDIM(NVARG),1151,ERR=200) ND
                           IF ((ND.GE.100) .AND. (ND.LE.999))
     *                        WRITE (VARDIM(NVARG),1152,ERR=200) ND
                           IF ((ND.GE.1000) .AND. (ND.LE.9999))
     *                        WRITE (VARDIM(NVARG),1153,ERR=200) ND
                           IF ((ND.GE.10000) .AND. (ND.LE.99999))
     *                        WRITE (VARDIM(NVARG),1154,ERR=200) ND
                           END IF
                        END IF
 200                 CONTINUE
C                                       See if more
 250              FIRST = FIRST + OFF + SLEN
                  IF (.NOT.ISSUB) GO TO 50
               END IF
 400        CONTINUE
         START = 1
 500     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1150 FORMAT ('*',I1)
 1151 FORMAT ('*',I2)
 1152 FORMAT ('*',I3)
 1153 FORMAT ('*',I4)
 1154 FORMAT ('*',I5)
      END
      SUBROUTINE HOLDL (MODULE, LMODUL, DCLPOS, NUMDCL, NHARG, ARGHOL,
     *   NHKEEP, HKEEP, HKDIM, PRECUR, DCL, LDCL)
C-----------------------------------------------------------------------
C   Subroutine to redeclare locally declared variables as HOLLERITH.
C   Attempts to change comment in precursor comment.
C   Logs Hollerith declarations.
C    Inputs:
C     MODULE   C  First page of the Module buffer.
C     LMODUL   I  Number of characters in MODULE.
C     DCLPOS(3,*)  I  Declaration position pointers rel MODULE.
C                     First character, last character, type:
C                     1 = INTEGER, 2 = REAL, 3 = HOLLERITH,
C                     4 = CHARACTER, 5 = LOGICAL, 6 = DOUBLE PRECISION,
C                     7 = COMPLEX
C     NUMDCL   I  Number of values in DCLPOS
C     NHARG    I  Number of arguments found
C     ARGHOL   C  List of Hollerith arguments, blank filled.
C     NHKEEP   I  Number of values in HKEEP
C     HKEEP    C  Variables to declare if used even if not already
C                 locally declared.
C     HKDIM    C  Dimension string for KEEP arguments.
C     PRECUR   C  Precursor comments
C   Outputs:
C     DCL      C  Declaration string
C     LDCL     I  Length of DCL
C-----------------------------------------------------------------------
      CHARACTER MODULE*(*), ARGHOL(*)*6, DCL*(*), HKEEP(*)*6,
     *   HKDIM(*)*20, PRECUR*(*)
      INTEGER   LMODUL, NHARG, LDCL, DCLPOS(3,*), NUMDCL, NHKEEP
      INTEGER   LOOP, LSTR, IARG, TYPE, POINT, ITRIM, ILEN, LDSTR, TLEN,
     *   START, END, BPNT, IPNT, JPNT, KPNT, ICHA, ICHZ, HERE, IBC, IEC
      CHARACTER STRING*4096, DCLSTR*50, TSTRNG*2048, BC*1, EC*1, SSTR*7
C-----------------------------------------------------------------------
      IF ((NHARG.LE.0) .OR.(NUMDCL.LE.0)) GO TO 999
      ICHA = ICHAR ('A')
      ICHZ = ICHAR ('Z')
C                                       Loop over list building
C                                       declaration string
      LSTR = 0
      DO 500 IARG = 1,NHARG
         ILEN = ITRIM (ARGHOL(IARG))
         IF (ILEN.LE.0) GO TO 500
         HERE = 1
 40      POINT = INDEX (MODULE(HERE:LMODUL), ARGHOL(IARG)(1:ILEN))
         IF (POINT.GT.0) THEN
            POINT = POINT + HERE - 1
            HERE = POINT + ILEN
C                                       Make sure really have variable
            BC = MODULE(POINT-1:POINT-1)
            EC = MODULE(POINT+ILEN:POINT+ILEN)
            IBC = ICHAR (BC)
            IEC = ICHAR (EC)
            IF (((IBC.GE.ICHA).AND.(IBC.LE.ICHZ)) .OR.
     *          ((IEC.GE.ICHA).AND.(IEC.LE.ICHZ))) GO TO 40
C                                       Find type
            TYPE = 3
            DO 100 LOOP = 1,NUMDCL
               IF ((POINT.GE.DCLPOS(1,LOOP)) .AND.
     *             (POINT.LE.DCLPOS(2,LOOP))) THEN
                  TYPE = DCLPOS(3,LOOP)
                  BPNT = DCLPOS(1,LOOP) + 1
                  GO TO 110
                  END IF
 100           CONTINUE
C                                       Not found, try again
            GO TO 40
C                                       Ignore HOLLERITH varaiable
 110        IF ((TYPE.EQ.3) .OR. (TYPE.LE.0) .OR. (TYPE.GT.7)) GO TO 490
C                                       Get declaration/ blank old
            CALL PARSEA (MODULE(POINT:POINT+200), TYPE,
     *         MODULE(BPNT:POINT-1), DCLSTR, LDSTR)
C                                       Form declaration
            TLEN = ILEN + LDSTR
            TSTRNG(1:TLEN) = ARGHOL(IARG)(1:ILEN) // DCLSTR(1:LDSTR)
         ELSE
C                                       See if keep anyway
            DO 200 LOOP = 1,NHKEEP
               TYPE = LOOP
               IF (ARGHOL(IARG).EQ.HKEEP(LOOP)) GO TO 210
 200           CONTINUE
C                                       Bag it
            GO TO 490
C                                       Get declaration
 210        LDSTR = ITRIM (HKDIM(TYPE))
            TLEN = LDSTR + ILEN
            TSTRNG(1:TLEN) = ARGHOL(IARG)(1:ILEN) //
     *         HKDIM(TYPE)(1:LDSTR)
            END IF
C                                       Form declaration string
C                                       First argument
         IF (LSTR.LE.0) THEN
C                                       Need to indent?
            IF (LDCL.LE.0) THEN
               LSTR = 16 + TLEN
               STRING(1:LSTR) = '      HOLLERITH ' // TSTRNG(1:TLEN)
               START = 7
            ELSE
               LSTR = 10 + TLEN
               STRING(1:LSTR) = 'HOLLERITH ' // TSTRNG(1:TLEN)
               START = 1
               END IF
C                                       Add one
         ELSE
            STRING(LSTR+1:LSTR+TLEN+2) = ', ' // TSTRNG(1:TLEN)
            LSTR = LSTR + TLEN + 2
            END IF
C                                       Change precursor comments
 490     SSTR = ' ' // ARGHOL(IARG)
         IPNT = INDEX (PRECUR, SSTR(1:ILEN+1))
         IF (IPNT.GT.0) THEN
            JPNT = INDEX (PRECUR(IPNT:IPNT+75), '@') + IPNT - 1
            KPNT = INDEX (PRECUR(IPNT:JPNT), ' R')
            IF (KPNT.LE.0) KPNT = INDEX (PRECUR(IPNT:JPNT), ' I')
            IF (KPNT.GT.0) THEN
               KPNT = IPNT + KPNT - 1
               EC = PRECUR(KPNT+2:KPNT+2)
               IF ((EC.EQ.' ') .OR. (EC.EQ.'('))
     *            PRECUR(KPNT+1:KPNT+1) = 'H'
               END IF
            END IF
 500     CONTINUE
C                                       Done any?
      IF (LSTR.LE.0) GO TO 999
C                                       Add to DCL
      IF (LDCL.LE.0) THEN
         DCL = STRING(1:LSTR)
         LDCL = LSTR
      ELSE
         DCL(LDCL+1:LDCL+LSTR+1) = '@' // STRING(1:LSTR)
         LDCL = LDCL + LSTR + 1
         END IF
C                                       Log Hollerith Declarations
C                                       Format line
      TLEN = 1
      CALL LINOUT (STRING, LSTR, TSTRNG, TLEN)
C                                       Print in LOG file
      END = INDEX (TSTRNG(START:START+75), '@') + START - 2
      IF (END.GE.START) WRITE (12,1600) TSTRNG(START:END)
      START = END + 2
 600     IF (START.GE.TLEN) GO TO 999
         END = INDEX (TSTRNG(START:START+75), '@') + START - 2
         IF (END.GE.START) WRITE (12,1601) TSTRNG(START:END)
         START = END + 2
         GO TO 600
C
 999  RETURN
C-----------------------------------------------------------------------
 1600 FORMAT (/' New declaration          : ',A)
 1601 FORMAT ( '                          : ',A)
      END
      SUBROUTINE DCLWRN (PAGE, START, MODULE, LMODUL, NARG, NUSE,
     *   ARG, USE, LABEL)
C-----------------------------------------------------------------------
C   Subroutine to log warnings about uses of variables in the list ARG
C   which don't appear on the same line as a value in USE.
C    Inputs:
C     PAGE     I  Number of pages in MODULE
C     START    I  First character to consider on page 1
C     MODULE   C  First page of the Module buffer.
C     LMODUL   I  Number of characters in MODULE.
C     NARG     I  Number of values in ARG
C     NUSE     I  Number of values in USE
C     ARG      C  List of arguments to check, blank filled.
C     USE      C  Subroutine names which should use ARG, blank filled.
C     LABEL    C  Label for log
C-----------------------------------------------------------------------
      INTEGER   PAGE, START, NARG, NUSE
      CHARACTER MODULE(PAGE)*(*), ARG(*)*6, USE(*)*6, LABEL*10
      INTEGER   LMODUL(PAGE)
      CHARACTER ARGSTR*10, OLABEL*25
      INTEGER   FIRST, LOOP, IPAGE, IARG, BACK, POINT, IPNT, ITRIM,
     *   LARG, LINEND(2,20), FRONT, END, LAST, HERE, BCKCHK, IUSE,
     *   LUSE(500), EEND, N72, ICHA, ICHZ, ICHBEG, ICHEND
      DATA N72 /72/
C-----------------------------------------------------------------------
      IF (NARG.LE.0) GO TO 999
C                                       Get values for "A", "Z"
      ICHA = ICHAR ('A')
      ICHZ = ICHAR ('Z')
      FIRST = START
C                                       Fill length array
      DO 20 LOOP = 1,NUSE
         LUSE(LOOP) = ITRIM (USE(LOOP))
 20      CONTINUE
C                                       Loop over pages
      DO 500 IPAGE = 1,PAGE
C                                       Loop over arguments
         DO 400 IARG = 1,NARG
            POINT = FIRST
C                                       Find occurance
            LARG = ITRIM (ARG(IARG))
            IF (LARG.LE.0) GO TO 400
 100           IPNT = INDEX (MODULE(IPAGE)(POINT:LMODUL(IPAGE)),
     *            ARG(IARG)(1:LARG))
               IF (IPNT.LE.0) GO TO 400
C                                       Save argument
               ARGSTR = MODULE(IPAGE)(POINT+IPNT-2:POINT+IPNT+LARG)
               BACK = 0
C                                       Find end of line
               HERE = POINT + IPNT - 1
               END = INDEX (MODULE(IPAGE)(HERE:HERE+75), '@') + HERE - 1
               EEND = END
C                                       Reset POINT for next search
               POINT = END + 1
C                                       Make sure have the variable
               ICHBEG = ICHAR (ARGSTR(1:1))
               ICHEND = ICHAR (ARGSTR(LARG+2:LARG+2))
C                                       Are prev or following letters?
               IF (((ICHBEG.GE.ICHA) .AND. (ICHBEG.LE.ICHZ)) .OR.
     *             ((ICHEND.GE.ICHA) .AND. (ICHEND.LE.ICHZ))) GO TO 100
C                                       READ or WRITE
               IF (ARGSTR(1:7).EQ.' READ (') GO TO 100
               IF (ARGSTR(1:8).EQ.' WRITE (') GO TO 100
C                                       Comment or FORMAT?
               BCKCHK = MIN (N72, HERE) - 1
               FRONT = LAST (MODULE(IPAGE)(HERE-BCKCHK:HERE), '@')
     *            + HERE - BCKCHK - 1
               IF (MODULE(IPAGE)(FRONT+1:FRONT+1).EQ.'C') GO TO 100
C                                       Backup to first line of
C                                       continuation series.
C                                       Find end
 150              BCKCHK = MIN (N72, HERE) - 1
                  FRONT = LAST (MODULE(IPAGE)(HERE-BCKCHK:HERE), '@')
     *               + HERE - BCKCHK - 1
C                                       Save ends
                  BACK = BACK + 1
                  LINEND(1,BACK) = FRONT
                  LINEND(2,BACK) = END
                  HERE = FRONT - 2
                  END = FRONT
C                                       Continuation line? loop
                  IF ((MODULE(IPAGE)(FRONT+6:FRONT+6).NE.' ') .AND.
     *               (HERE.GT.0)) GO TO 150
C                                       FORMAT?
               IF (MODULE(IPAGE)(FRONT+7:FRONT+12).EQ.'FORMAT')
     *            GO TO 300
C                                       Look for approved name
               DO 200 IUSE = 1,NUSE
                  IPNT = INDEX (MODULE(IPAGE)(FRONT+1:EEND-1),
     *               USE(IUSE)(1:LUSE(IUSE)))
                  IF (IPNT.GT.0) GO TO 300
 200              CONTINUE
C                                       None, log it.
               HERE = FRONT + 6
               OLABEL = 'Use of ' // LABEL // ARG(IARG)
               CALL LOGER (MODULE(IPAGE), LMODUL(IPAGE), HERE, OLABEL)
 300           GO TO 100
 400        CONTINUE
         FIRST = 1
 500     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE CHRDL (MODULE, LMODUL, DCLPOS, NUMDCL, NUMCHR, CHRARG,
     *   NCARG, ARGCHR, CHRDIM, NCKEEP, CKEEP, CKDIM, PRECUR, DCL,
     *   LDCL)
C-----------------------------------------------------------------------
C   Subroutine to redeclare locally declared variables as CHARACTER.
C   Logs Character declarations.
C    Inputs:
C     MODULE   C  First page of the Module buffer.
C     LMODUL   I  Number of characters in MODULE.
C     DCLPOS(3,*)  I  Declaration position pointers rel MODULE.
C                     First character, last character, type:
C                     1 = INTEGER, 2 = REAL, 3 = HOLLERITH,
C                     4 = CHARACTER, 5 = LOGICAL, 6 = DOUBLE PRECISION,
C                     7 = COMPLEX
C     NUMDCL   I  Number of values in DCLPOS
C     NUMCHR   I  Number of elements in CHRARG
C     CHRARG   I  (arg,subroutine) argument number
C     NCARG    I  Number of arguments found
C     ARGCHR   C  List of CHARACTER arguments, blank filled.
C     CHRDIM   C  Dimensions for ARGCHR
C     NCKEEP   I  Number of values in CKEEP
C     CKEEP    C  Variables to declare if used even if not already
C                 locally declared.
C     CKDIM    C  Dimensions to use for CKEEP if not otherwise defined.
C     PRECUR   C  Precursor comments
C   Outputs:
C     DCL      C  Declaration string
C     LDCL     I  Length of DCL
C-----------------------------------------------------------------------
      CHARACTER MODULE*(*), ARGCHR(*)*6, CHRDIM(*)*20, CKEEP(*)*6,
     *   CKDIM(*)*20, DCL*(*), PRECUR*(*)
      INTEGER   LMODUL, DCLPOS(3,*), NUMDCL, NUMCHR, CHRARG(5,200,2),
     *   NCARG, NCKEEP, LDCL
      INTEGER   LOOP, LSTR, IARG, TYPE, POINT, ITRIM, ILEN, LDSTR, TLEN,
     *   START, END, NDIG, JPNT, LENDCL, BPNT, IPNT, LPNT, LABLEN,
     *   ICHA, ICHZ, HERE, IBC, IEC, KPNT, JLEN, LDIM, LAST
      CHARACTER STRING*4096, DCLSTR*50, TSTRNG*2048, TEMP*6, LABEL*256,
     *   BC*1, EC*1, SSTR*7, DSTR*20
C-----------------------------------------------------------------------
      IF (NCARG.LE.0) GO TO 999
      ICHA = ICHAR ('A')
      ICHZ = ICHAR ('Z')
      TLEN = 0
C                                       Loop over list building
C                                       declaration string
      LSTR = 0
      DO 500 IARG = 1,NCARG
         LDSTR = 2
         DCLSTR = '*?'
         ILEN = ITRIM (ARGCHR(IARG))
         IF (ILEN.LE.0) GO TO 500
         HERE = 1
 40      POINT = INDEX (MODULE(HERE:LMODUL), ARGCHR(IARG)(1:ILEN))
         IF (POINT.GT.0) THEN
            POINT = POINT + HERE - 1
            HERE = POINT + ILEN
C                                       Make sure really have variable
            BC = MODULE(POINT-1:POINT-1)
            EC = MODULE(POINT+ILEN:POINT+ILEN)
            IBC = ICHAR (BC)
            IEC = ICHAR (EC)
            IF (((IBC.GE.ICHA).AND.(IBC.LE.ICHZ)) .OR.
     *          ((IEC.GE.ICHA).AND.(IEC.LE.ICHZ))) GO TO 40
C                                       Find type
            TYPE = 4
            DO 100 LOOP = 1,NUMDCL
               IF ((POINT.GE.DCLPOS(1,LOOP)) .AND.
     *             (POINT.LE.DCLPOS(2,LOOP))) THEN
                  TYPE = DCLPOS(3,LOOP)
                  BPNT = DCLPOS(1,LOOP) + 1
                  GO TO 110
                  END IF
 100           CONTINUE
C                                       Not found, try again
            GO TO 40
C                                       Ignore CHARACTER varaiable
 110        IF ((TYPE.EQ.4) .OR. (TYPE.LE.0) .OR. (TYPE.GT.7)) GO TO 490
C                                       Blank old declaration
            CALL PARSEA (MODULE(POINT:POINT+200), TYPE,
     *         MODULE(BPNT:POINT-1), DCLSTR, LDSTR)
C                                       Number of characters for type
            DSTR = '*4'
            IF (TYPE.EQ.1) DSTR = '*2'
            IF (TYPE.EQ.6) DSTR = '*8'
C                                       From subroutine declaration?
            LDIM = ITRIM (CHRDIM(IARG))
            IF (CHRDIM(IARG)(1:4) .EQ. 'none') LDIM = 0
            IF (LDIM.GT.0) THEN
               DSTR(1:LDIM) = CHRDIM(IARG)(1:LDIM)
            ELSE
               LDIM = 2
               END IF
C                                       Add *4 etc. (not arrays)
            IF (LDSTR.LE.0) THEN
               DCLSTR(LDSTR+1:LDSTR+LDIM) = DSTR(1:LDIM)
               LDSTR = LDSTR + LDIM
C                                       (arrays add ?)
            ELSE
               DCLSTR(LDSTR+1:LDSTR+LDIM+1) = DSTR(1:LDIM) // '?'
               LDSTR = LDSTR + LDIM + 1
               END IF
         ELSE
C                                       See if keep anyway
            DO 200 LOOP = 1,NCKEEP
               TYPE = LOOP
               IF (ARGCHR(IARG).EQ.CKEEP(LOOP)) THEN
                  LDSTR = ITRIM (CKDIM(LOOP))
                  DCLSTR(1:LDSTR) = CKDIM(LOOP)(1:LDSTR)
                  GO TO 210
                  END IF
 200           CONTINUE
C                                       Bag it
            GO TO 500
            END IF
C                                       Form declaration
 210     TSTRNG(1:ILEN) = ARGCHR(IARG)(1:ILEN)
         TLEN = ILEN + LDSTR
         TSTRNG(ILEN+1:TLEN) = DCLSTR(1:LDSTR)
C                                       Form declaration string
C                                       First argument?
         IF (LSTR.LE.0) THEN
C                                       Need to indent?
            IF (LDCL.LE.0) THEN
               LSTR = 16 + TLEN
               STRING(1:LSTR) = '      CHARACTER ' // TSTRNG(1:TLEN)
               START = 7
            ELSE
               LSTR = 10 + TLEN
               STRING(1:LSTR) = 'CHARACTER ' // TSTRNG(1:TLEN)
               START = 1
               END IF
C                                       Add one
         ELSE
            STRING(LSTR+1:LSTR+TLEN+2) = ', ' // TSTRNG(1:TLEN)
            LSTR = LSTR + TLEN + 2
            END IF
C                                       Change precursor comments
 490     SSTR = ' ' // ARGCHR(IARG)
         IPNT = INDEX (PRECUR, SSTR(1:ILEN+1))
         IF (IPNT.GT.0) THEN
C                                       Get no char.
            LPNT = LAST (TSTRNG(1:TLEN), '*')
            IF (LPNT.LE.0) LPNT = TLEN
            LABLEN = TLEN - LPNT + 1
            LABEL(1:LABLEN) = TSTRNG(LPNT:TLEN)
            JPNT = INDEX (PRECUR(IPNT:IPNT+75), '@') + IPNT - 1
            KPNT = INDEX (PRECUR(IPNT:JPNT), ' R')
            IF (KPNT.LE.0) KPNT = INDEX (PRECUR(IPNT:JPNT), ' I')
            IF (KPNT.LE.0) KPNT = INDEX (PRECUR(IPNT:JPNT), ' C')
            IF (KPNT.GT.0) THEN
               KPNT = IPNT + KPNT - 1
               EC = PRECUR(KPNT+2:KPNT+2)
               IF ((EC.EQ.' ') .OR. (EC.EQ.'('))
     *            PRECUR(KPNT+1:KPNT+LABLEN+1) = 'C' // LABEL(1:LABLEN)
               END IF
            END IF
 500     CONTINUE
C                                       Done any?
      IF (LSTR.LE.0) GO TO 999
C                                       Add to DCL
      IF (LDCL.LE.0) THEN
         DCL = STRING(1:LSTR)
         LDCL = LSTR
      ELSE
         DCL(LDCL+1:LDCL+LSTR+1) = '@' // STRING(1:LSTR)
         LDCL = LDCL + LSTR + 1
         END IF
C                                       Log Character Declarations
C                                       Format line
      TLEN = 1
      CALL LINOUT (STRING, LSTR, TSTRNG, TLEN)
C                                       Print in LOG file
      END = INDEX (TSTRNG(START:START+75), '@') + START - 2
      IF (END.GE.START) WRITE (12,1600) TSTRNG(START:END)
      START = END + 2
 600     IF (START.GE.TLEN) GO TO 999
         END = INDEX (TSTRNG(START:START+75), '@') + START - 2
         IF (END.GE.START) WRITE (12,1601) TSTRNG(START:END)
         START = END + 2
         GO TO 600
C
 999  RETURN
C-----------------------------------------------------------------------
 1110 FORMAT (I6)
 1600 FORMAT (/' New declaration          : ',A)
 1601 FORMAT ( '                          : ',A)
      END
      SUBROUTINE PARSEA (STRING, TYPE, REST, DCLSTR, LDSTR)
C-----------------------------------------------------------------------
C   Parse a declaration from a character array, the old declaration is
C   blanked.
C   '@' is assumed to the the end of line character.
C    Input
C     STRING   C  String to parse, starting with varaible name.
C     TYPE     I  Data type, INTEGER, REAL, HOLLERITH, CHARACTER,
C                 LOGICAL, DOUBLE PRECISION, COMPLEX
C     REST     C  Beginning of line before STRING.
C    Output:
C     DCLSTR   C  Output declaration string
C     LDSTR    I  Number of characters in DCLSTR
C-----------------------------------------------------------------------
      CHARACTER STRING*(*), REST*(*), DCLSTR*(*)
      INTEGER   TYPE, LDSTR
      CHARACTER WORK*1024, TSTR*50, BLANK*50, CHR*1
      INTEGER   END, IPNT, PLEVEL, LOOP, LENG, JPNT, LOOP2, ITRIM,
     *   POINT, KPNT, IVALUE, NDIG, OVALUE, BPOINT, EPNT, START, LAST,
     *   IEND
      LOGICAL   LASTD
      DATA BLANK /'                                                  '/
C-----------------------------------------------------------------------
      POINT = 1
      LDSTR = 0
C                                       Extract rest of current line
      IPNT = INDEX (STRING(POINT:), '@')
      WORK = STRING(POINT:POINT+IPNT-1)
      END = IPNT
      IEND = IPNT
      POINT = POINT + IPNT
C                                       Start at first '(' before ','
      IPNT = INDEX (WORK(1:END), '(')
      KPNT = INDEX (WORK(1:END), ',')
      IF (KPNT.LE.0) KPNT = END + 1
      IF ((IPNT.LE.0) .OR. (KPNT.LT.IPNT)) THEN
C                                       See if last argument
         LASTD = INDEX (WORK(1:END), ',') .LE. 0
         GO TO 900
         END IF
C                                       Blank name
      STRING(1:IPNT) = BLANK(1:IPNT)
      BPOINT = IPNT
      PLEVEL = 1
      LDSTR = 1
      DCLSTR(LDSTR:LDSTR) = WORK(IPNT:IPNT)
C                                       Find next level 0 ','
 100  DO 200 LOOP = IPNT+1,END
         JPNT = LOOP
         IF (WORK(LOOP:LOOP).EQ.'(') PLEVEL = PLEVEL + 1
         IF (WORK(LOOP:LOOP).EQ.')') PLEVEL = PLEVEL - 1
C                                       Done?
         IF ((WORK(LOOP:LOOP).EQ.',') .AND. (PLEVEL.EQ.0)) GO TO 500
         IF ((WORK(LOOP:LOOP).EQ.'@') .AND. (PLEVEL.EQ.0)) GO TO 500
         IF (WORK(LOOP:LOOP) .NE. ' ') THEN
            LDSTR = LDSTR + 1
            DCLSTR(LDSTR:LDSTR) = WORK(LOOP:LOOP)
            END IF
 200     CONTINUE
      JPNT = END
C                                       Not done;
C                                       fetch another line.
      IPNT = INDEX (STRING(POINT+1:POINT+75), '@') + 1
      WORK = STRING(POINT+1:POINT+IPNT-2)
C                                       If not a continuation then done
      IF ((WORK(6:6).EQ.' ') .OR. (WORK(1:1).EQ.'C')) GO TO 500
      END = IPNT
      POINT = POINT + IPNT
C                                       Blank declaration
      EPNT = BPOINT + JPNT - IPNT
      IF (STRING(EPNT:EPNT).EQ.'@') EPNT = EPNT - 1
      STRING(BPOINT:EPNT) = BLANK
      BPOINT = POINT
      IPNT = 6
C                                       Continue on next line
      GO TO 100
C                                       Blank declaration
 500  EPNT = BPOINT + JPNT - IPNT
      IF (STRING(EPNT:EPNT).EQ.'@') EPNT = EPNT - 1
      STRING(BPOINT:EPNT) = BLANK
C                                       If last declaration on line
C                                       remove last comma or whole line.
      LASTD = WORK(JPNT:JPNT) .EQ. '@'
      IF (LASTD) THEN
            LENG = ITRIM (REST)
            IPNT = LAST (REST(1:LENG), ',')
            IF (IPNT.LE.0) THEN
               IPNT =  LAST (REST(1:LENG), '@')
               IF (IPNT.EQ.1) IPNT = 2
               END IF
            REST(IPNT:LENG) = BLANK
         END IF
      IF (TYPE.NE.1) GO TO 950
C                                       Must change INTEGER declarations
C                                       Get first value
C                                       Don't re dimension for now...
C      IPNT = INDEX (DCLSTR, ',')
C      IF (IPNT.LE.0) IPNT = INDEX (DCLSTR, ')')
CC                                       Can't cope?
C      IF (IPNT.LE.0) GO TO 950
C      TSTR(1:8) = '  '
C      NDIG = 0
C      DO 550 LOOP = 1,IPNT-1
C         JPNT = IPNT - LOOP
C         KPNT = 7 - LOOP
C         CHR = DCLSTR(JPNT:JPNT)
C         IF ((CHR.EQ.'1') .OR. (CHR.EQ.'2') .OR. (CHR.EQ.'3') .OR.
C     *   (CHR.EQ.'4') .OR. (CHR.EQ.'5') .OR. (CHR.EQ.'6') .OR.
C     *   (CHR.EQ.'7') .OR. (CHR.EQ.'8') .OR. (CHR.EQ.'9') .OR.
C     *   (CHR.EQ.'0')) THEN
C            TSTR(KPNT:KPNT) = CHR
C            NDIG = NDIG + 1
C            END IF
C 550     CONTINUE
CC                                       Bail out if NDIG .le. 0
C      IF (NDIG.LE.0) GO TO 950
CC                                       Compute number needed changing
CC                                       from 2 to word to 4.
C      READ (TSTR(1:6),1550) OVALUE
C      IVALUE = OVALUE * 2
C      IVALUE = (IVALUE / 4.0) + 0.99
C      WRITE (TSTR(1:6),1550) IVALUE
CC                                       Change declaration  (1) to (*)
C      IF (OVALUE.EQ.1) TSTR(6:6) = '*'
CC                                       Insert new value
C      DCLSTR(2:NDIG+1) = TSTR(7-NDIG:6)
      GO TO 950
C                                       Blank simple name, look for ','
C                                       or '@'
 900  DO 920 LOOP = 1,END
         IF (STRING(LOOP:LOOP).EQ.',') THEN
            STRING(LOOP:LOOP) = ' '
            GO TO 930
            END IF
         IF (STRING(LOOP:LOOP).EQ.'@') GO TO 930
         STRING(LOOP:LOOP) = ' '
 920     CONTINUE
C                                       If last declaration on line
C                                       remove last comma or whole line.
 930  IF (LASTD) THEN
            LENG = ITRIM (REST)
            IPNT = LAST (REST(1:LENG), ',')
            IF (IPNT.LE.0) THEN
               IPNT =  LAST (REST(1:LENG), '@')
               IF (IPNT.EQ.1) IPNT = 2
               END IF
            REST(IPNT:LENG) = BLANK
         END IF
C                                       Beautify (remove excess blanks)
 950  IEND = IEND - 1
      DO 980 LOOP = 2,IEND
         IF (STRING(LOOP-1:LOOP).EQ.'  ') THEN
C                                       Shift
 960        DO 970 LOOP2 = LOOP,IEND-1
               STRING(LOOP2:LOOP2) = STRING(LOOP2+1:LOOP2+1)
 970           CONTINUE
            STRING(IEND:IEND) = ' '
C                                       More blanks?
            IPNT = ITRIM (STRING(LOOP:IEND))
            IF (IPNT.LE.0) GO TO 985
            IF (STRING(LOOP-1:LOOP).EQ.'  ') GO TO 960
            END IF
 980     CONTINUE
C                                       Remove initial blank
 985  IF (STRING(1:1).EQ.' ') THEN
         DO 990 LOOP2 = 1,IEND-1
            STRING(LOOP2:LOOP2) = STRING(LOOP2+1:LOOP2+1)
 990        CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1550 FORMAT (I6)
      END
      SUBROUTINE DATCHR (MODULE, LMODUL, BEGFOR, BEGDCL, DCLPOS, NUMDCL,
     *   NVARG, ARGVAR, CHRDIM)
C-----------------------------------------------------------------------
C   Subroutine to find variables DATAed as character so they can be
C   redeclared.
C    Inputs:
C     MODULE   C  First page of the Module buffer.
C     LMODUL   I  Number of characters in MODULE.
C     BEGFOR   I  Start of executable code on first page.
C     BEGDCL   I  Start of declarations
C     DCLPOS(3,*)  I  Declaration position pointers rel BEGDCL.
C                     First character, last character, type:
C                     1 = INTEGER, 2 = REAL, 3 = HOLLERITH,
C                     4 = CHARACTER, 5 = LOGICAL, 6 = DOUBLE PRECISION,
C                     7 = COMPLEX
C     NUMDCL   I  Number of values in DCLPOS
C   Outputs:
C     NVARG    I  Number of arguments found
C     ARGVAR   C  List of Specified arguments
C     CHRDIM   C  List of dimensions of ARGVAR
C-----------------------------------------------------------------------
      CHARACTER MODULE*(*), ARGVAR(*)*6, CHRDIM(*)*20
      INTEGER   LMODUL, BEGFOR, BEGDCL, NVARG, DCLPOS(3,*), NUMDCL
      INTEGER   LOOP, LOOP2, POINT, IPNT, JPNT, KPNT, START,
     *   DATTYP(100), NUMDAT
      CHARACTER EC*1, DATNAM(100)*6, DATDIM(100)*20
C-----------------------------------------------------------------------
      IF (BEGFOR.LE.DCLPOS(1,1)) GO TO 999
C                                       Look for DATA statment
      START = DCLPOS(2,NUMDCL)
      IPNT = INDEX (MODULE(START:BEGFOR), '@      DATA')
 100     IF (IPNT.GT.0) THEN
            POINT = START + IPNT + 10
            EC = MODULE(POINT:POINT)
C                                       Parse DATA statment
            IF (EC.EQ.' ') THEN
 110           CALL PARDAT (MODULE, POINT, BEGFOR, BEGDCL, NUMDCL,
     *            DCLPOS, NUMDAT, DATNAM, DATTYP, DATDIM)
C                                       Any character?
               DO 200 LOOP = 1,NUMDAT
                  IF (DATTYP(LOOP).EQ.4) THEN
C                                       Save
                     DO 150 LOOP2 = 1,NVARG
                        IF (DATNAM(LOOP).EQ.ARGVAR(LOOP2)) GO TO 200
 150                    CONTINUE
                     NVARG = NVARG + 1
                     ARGVAR(NVARG) = DATNAM(LOOP)
                     CHRDIM(NVARG) = DATDIM(LOOP)
                     END IF
 200              CONTINUE
C                                       More in DATA stmt?
               JPNT = INDEX (MODULE(POINT:LMODUL), ',')
               KPNT = INDEX (MODULE(POINT:LMODUL), '@')
               IF ((JPNT.LT.KPNT) .AND. (JPNT.GT.0)) THEN
                  POINT = POINT + JPNT
                  GO TO 110
                  END IF
               END IF
            START = POINT
            END IF
C                                       More DATA stmts?
         IPNT = 0
         IF (START.LT.BEGFOR)
     *      IPNT = INDEX (MODULE(START:BEGFOR), '@      DATA')
         IF (IPNT.GT.0) GO TO 100
C
 999  RETURN
      END
      SUBROUTINE PARDAT (MODULE, POINT, BEGFOR, BEGDCL, NUMDCL, DCLPOS,
     *   NUMDAT, DATNAM, DATTYP, DATDIM)
C-----------------------------------------------------------------------
C   Parse a DATA statment
C    Input
C     MODULE   C  String to parse.
C     DCLPOS(3,*)  I  Declaration position pointers rel BEGDCL.
C                     First character, last character, type:
C                     1 = INTEGER, 2 = REAL, 3 = HOLLERITH,
C                     4 = CHARACTER, 5 = LOGICAL, 6 = DOUBLE PRECISION,
C                     7 = COMPLEX
C     NUMDCL   I  Number of values in DCLPOS
C     BEGFOR   I  Start of executable code on first page.
C     BEGDCL   I  Start of declarations
C    Input/output:
C     POINT     I  Start character in MODULE for next
C     NUMDAT    I  Number of elements in DATNAM, DATNUM
C     DATNAM(*) C  variable names
C     DATTYP(*) I  Data type of DATA value in order:
C                  INTEGER, REAL, HOLLERITH, CHARACTER,
C                  LOGICAL, DOUBLE PRECISION, COMPLEX
C     DATDIM(*) C  Dimension for DATNAM
C-----------------------------------------------------------------------
      CHARACTER MODULE*(*), DATNAM(*)*6, DATDIM(*)*20
      INTEGER   POINT, BEGFOR, BEGDCL, NUMDCL, DCLPOS(3,*), NUMDAT,
     *   DATTYP(*)
      CHARACTER WORK*80, CHR*1, CHR2*1, BC*1, EC*1, DIMS(7)*50,
     *   VSTRNG*6, GOODCH*5
      INTEGER   END, IPNT, PLEVEL, LOOP, LENG, JPNT, LOOP2, NEXTNQ,
     *   HERE, KPNT, IVALUE, NDIG, OVALUE, BHERE, EPNT, START, LAST,
     *   IEND, ICHA, ICHZ, ICNEXT, LNAME, ICHBC, ICHEC, ISTART, NDIM,
     *   DLEN(7), VALUE, DIM, IP, JP, KP, LP, LIMIT, TYPE, NODAT, NUMDT,
     *   TEMP, TEMP2, NOVAR, NCOPY, DATNUM, NDATA
      LOGICAL   LASTD, GOTCHR, RECOVE
      EXTERNAL NEXTNQ
      DATA GOODCH /'(, *@'/
C-----------------------------------------------------------------------
      ICHA = ICHAR('A')
      ICHZ = ICHAR('Z')
      HERE = POINT
      NUMDT = 0
      NDATA = 0
      IPNT = NEXTNQ (MODULE(HERE:HERE+75), '@')
C                                       Trap end of line
      IF (IPNT.EQ.1) THEN
         HERE = HERE + 7
         IPNT = NEXTNQ (MODULE(HERE:HERE+74), '@')
         END IF
      IF (IPNT.LE.0) IPNT = INDEX (MODULE(HERE:HERE+75), '@')
      WORK = MODULE(HERE:HERE+IPNT-1)
      END = IPNT
      IEND = IPNT
      JPNT = 1
      NUMDAT = 1
      DATNAM(NUMDAT) = '      '
      LNAME = 0
      GOTCHR = .FALSE.
C                                       Find next variable
 50      CHR = WORK(JPNT:JPNT)
C                                       End of name?
         IF ((CHR.EQ.',') .OR. (CHR.EQ.'/')) GO TO 100
C                                       End of line
         IF (CHR.EQ.'@') GO TO 80
         ICNEXT = ICHAR (CHR)
         GOTCHR = GOTCHR .OR. ((ICNEXT.GE.ICHA).AND.(ICNEXT.LE.ICHZ))
         IF (GOTCHR .AND. (CHR.NE.' ') .AND. (LNAME.LE.5)) THEN
            LNAME = LNAME + 1
            DATNAM(NUMDAT)(LNAME:LNAME) = CHR
            END IF
         JPNT = JPNT + 1
C                                       Next character
         IF (JPNT.LE.END) GO TO 50
C                                       Another line
 80      HERE = HERE + END
         IPNT = NEXTNQ (MODULE(HERE+1:HERE+75), '@')
         IF (IPNT.LE.0) IPNT = INDEX (MODULE(HERE+1:HERE+75), '@')
         IPNT = IPNT + 1
         WORK = MODULE(HERE+7:HERE+IPNT-2)
         END = IPNT - 7
         JPNT = 1
         HERE = HERE + 7
         GO TO 50
C                                       Finished variable name, get
C                                       dimension
C                                       Got name?
 100  IF (LNAME.LE.0) GO TO 900
C                                       Find declaration of name
      ISTART = BEGDCL
 110  IPNT = INDEX (MODULE(ISTART:BEGFOR), DATNAM(NUMDAT)(1:LNAME))
      IF (IPNT.GT.0) THEN
C                                       In declaration stmt?
         KPNT = IPNT + ISTART - BEGDCL
         DO 120 LOOP = 1,NUMDCL
            TYPE = DCLPOS(3,LOOP)
            IF ((KPNT.GT.DCLPOS(1,LOOP)) .AND.
     *          (KPNT.LT.DCLPOS(2,LOOP))) GO TO 130
 120        CONTINUE
C                                       Nope, try again
         ISTART = ISTART + IPNT + LNAME
         GO TO 110
C                                       Verify name
 130        IPNT = IPNT + ISTART - 1
            ISTART = IPNT + LNAME
            EC = MODULE(IPNT-1:IPNT-1)
            BC = MODULE(IPNT+LNAME:IPNT+LNAME)
            ICHEC = ICHAR (EC)
            ICHBC = ICHAR (BC)
            IF (((ICHEC.GE.ICHA) .AND. (ICHEC.LE.ICHZ)) .OR.
     *          ((ICHBC.GE.ICHA) .AND. (ICHBC.LE.ICHZ))) GO TO 110
C                                       BC must valid
            IF (INDEX (GOODCH, BC) .LE.0) GO TO 110
            DATDIM(NUMDAT) = 'none'
C                                       Parse dimensions
            IF (BC.EQ.'*') THEN
C                                       Character
               NDIM = 1
               DIMS(1)='1'
               DLEN(1) = 1
            ELSE
C                                       Other types
               CALL PARSEC (MODULE(IPNT+LNAME:BEGFOR), NDIM, DIMS, DLEN)
               END IF
C                                       loop over dimensions
            DIM = 1
            DO 160 LOOP = 1,NDIM
               VSTRNG = '      '
C                                       Check if too long
               IF (DLEN(LOOP).GT.6) GO TO 900
               VSTRNG(6-DLEN(LOOP)+1:6) = DIMS(LOOP)(1:DLEN(LOOP))
C                                       Interprete
               READ (VSTRNG,1000,ERR=900) VALUE
               DIM = DIM * VALUE
 160           CONTINUE
C                                       Save type
            DATTYP(NUMDAT) = TYPE
            NUMDT = NUMDT + DIM
      ELSE
C                                       Not declared locally, bail out
         WRITE (6,1180) DATNAM(NUMDAT)
         WRITE (12,1180) DATNAM(NUMDAT)
         GO TO 900
         END IF
C                                       Done (last char='/')
      IF (CHR.EQ.'/') GO TO 500
      NUMDAT = NUMDAT + 1
      DATNAM(NUMDAT) = '      '
      LNAME = 0
C                                       New line?
      IF (CHR.EQ.'@') GO TO 80
C                                       Next variable
      JPNT = JPNT + 1
      GO TO 50
C                                       Parse values to get types.
 500  HERE = HERE + JPNT - 1
      EPNT = JPNT
      IF (NUMDAT.LE.0) GO TO 999
C                                       NOVAR = no. words declared
         NOVAR = NUMDT
C                                       Now count words DATAed
         NUMDT = 1
C                                       Find '/'
         LP = NEXTNQ (WORK(JPNT:END), '/')
C                                       New line?
         IF (LP.LE.0) GO TO 600
C                                       Find next nonblank
         LIMIT = JPNT + LP
 550     DO 560 LOOP = LIMIT,END
            JPNT = LOOP
            IF (WORK(LOOP:LOOP).NE. ' ') GO TO 570
 560        CONTINUE
C                                       New line
         GO TO 600
C                                       Find next ',', '*' '/' or '@'
 570     IP = NEXTNQ (WORK(JPNT:END), ',')
         IF (IP.LE.0) IP = END + 1
         JP = NEXTNQ (WORK(JPNT:END), '*')
         IF (JP.LE.0) JP = END + 1
         KP = NEXTNQ (WORK(JPNT:END), '@')
         IF (KP.LE.0) KP = END + 1
         LP = NEXTNQ (WORK(JPNT:END), '/')
         IF (LP.EQ.1) GO TO 700
         IF (LP.LE.0) LP = END + 1
C                                       Repeat?
         NODAT = 1
         KPNT = JPNT
         IF ((JP.GT.0) .AND. (JP.LT.MIN (IP, LP))) THEN
            VSTRNG = '      '
            NDIM = JP - 1
            IF (NDIM.LE.0) GO TO 910
            VSTRNG(6-NDIM+1:6) = WORK(JPNT:JPNT+NDIM)
            READ (VSTRNG,1000,ERR=910) NODAT
            KPNT = JPNT + JP
            END IF
C                                       Determine if character
         TYPE = DATTYP(NUMDT)
         IF ((WORK(KPNT:KPNT).EQ.'''') .AND. (WORK(KPNT:KPNT+5).NE.
     *      '''INDE''') .AND. (TYPE.NE.3)) TYPE = 4
C                                       Fill DATTYP
         DATTYP(NUMDT) = TYPE
         NUMDT = NUMDT + 1
         NDATA = NDATA + NODAT
C                                       Next value
         JPNT = JPNT + MIN (IP, LP)
         LIMIT = JPNT
C                                       Done?
         IF (LP.LT.IP) GO TO 700
C                                       End of line?
         IF (JPNT.GE.END) GO TO 600
         GO TO 550
C                                       New line
 600     HERE = HERE + END - EPNT
         IPNT = NEXTNQ (MODULE(HERE+1:HERE+75), '@')
         IF (IPNT.LE.0) IPNT = INDEX (MODULE(HERE+1:HERE+75), '@')
         IPNT = IPNT + 1
         WORK = MODULE(HERE+7:HERE+IPNT-1)
         END = IPNT - 7
         JPNT = 1
         HERE = HERE + 7
         LIMIT = JPNT
         EPNT = 1
         GO TO 550
 700  POINT = HERE + JPNT - EPNT
C                                       Make sure arguments match
      IF (NDATA.NE.NOVAR) THEN
         RECOVE = .FALSE.
         WORK(1:25) = 'Arg-val mismatch'
         GO TO 930
         END IF
      GO TO 999
C                                       can't figure it out - quit.
C                                       Skip to next '/'
 900  IPNT = NEXTNQ (MODULE(HERE:BEGFOR), '/')
      HERE = HERE + IPNT
      RECOVE = .FALSE.
      GO TO 920
C                                       Can I recover ( 1 parameter)
 910  RECOVE = (NUMDAT.EQ.1) .AND. (NUMDT.GT.1)
C                                       Skip to next '/'
 920  IPNT = NEXTNQ (MODULE(HERE+1:BEGFOR), '/') + 1
      HERE = HERE + IPNT
      POINT = HERE
      WORK(1:25) = 'Trouble parsing'
 930  IF (.NOT.RECOVE) THEN
         WRITE (6,1900)
         IPNT = HERE + 500
         CALL LOGER (MODULE, IPNT, HERE, WORK(1:25))
         NUMDAT = 0
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I6)
 1180 FORMAT (' Variable ',A,' DATAed but not declared locally')
 1900 FORMAT (' Trouble parsing DATA statment.')
      END
      INTEGER FUNCTION NEXTNQ (STRING, CHAR)
C-----------------------------------------------------------------------
C   Function to determine next occurance of a character in a string
C   which is not inside quotes. 0 => not found.
C    Inputs:
C     STRING    C   String to be searched
C     CHAR      C   Character to locate
C-----------------------------------------------------------------------
      CHARACTER STRING*(*), CHAR*1
      LOGICAL   QUOTED
      INTEGER   LIMIT, IT
C-----------------------------------------------------------------------
      LIMIT = LEN (STRING)
      QUOTED = .FALSE.
      NEXTNQ = 0
C                                       Is it there at all
      IT = INDEX (STRING(1:LIMIT), CHAR)
      IF (IT.LE.0) GO TO 999
C                                       look for CHAR
 10   CONTINUE
         NEXTNQ = NEXTNQ + 1
         IF (NEXTNQ.GT.LIMIT) GO TO 900
         IF (STRING(NEXTNQ:NEXTNQ).EQ.'''') QUOTED = .NOT.QUOTED
         IF (QUOTED .OR. (STRING(NEXTNQ:NEXTNQ).NE.CHAR)) GO TO 10
      GO TO 999
C                                       Not found
 900  NEXTNQ = 0
C
 999  RETURN
      END
      SUBROUTINE RMDCL (PAGE, MODULE, LMODUL)
C-----------------------------------------------------------------------
C   Routine to remove the declaration of unused variables.
C    Input/Output:
C     PAGE    I  Number of pages in MODULE
C     MODULE  C  Module string, '@' => line break
C     LMODUL  I  Number of valid characters in MODULE (including '@')
C   Input from common
C     BEGDCL       I  Pointer to the first character of the declaration
C     ENDDCL       I  Pointer to the last character of the declaration
C     BEGFOR       I  Pointer to the first character of the executable
C     DCLPOS(3,*)  I  Declaration position pointers wrt BEGDCL
C                     First character, last character, type:
C                     1 = INTEGER, 2 = REAL, 3 = HOLLERITH,
C                     4 = CHARACTER, 5 = LOGICAL, 6 = DOUBLE PRECISION,
C                     7 = COMPLEX
C     NUMDCL       I  Number of entries in DCLPOS
C-----------------------------------------------------------------------
      INTEGER   PAGE
      CHARACTER MODULE(PAGE)*(*)
      INTEGER   LMODUL(PAGE)
      CHARACTER VARNAM*30, CHR*1, BC*1, EC*1, OKCH*13, DCLSTR*100
      INTEGER   LVNAME, START, IPNT, LOOP, LENDCL(7), DCLLOC(3,100),
     *   IDCL, IPAGE, POINT, LIMIT, LIMIT2, ICHR, KPNT, LDSTR, PLEVEL
      INCLUDE 'XEDIT.INC'
      DATA OKCH /' ,(@*)=+-./!:'/
      DATA LENDCL /13,10,15,15,13,22,13/
C-----------------------------------------------------------------------
      IF ((PAGE.LE.0) .OR. (LMODUL(1).LE.0)) GO TO 999
      IF (BEGDCL.GE.ENDDCL) GO TO 999
C                                       Reference declarations to page
      DO 10 LOOP = 1,NUMDCL
         DCLLOC(1,LOOP) = DCLPOS(1,LOOP) + BEGDCL - 1
         DCLLOC(2,LOOP) = DCLPOS(2,LOOP) + BEGDCL - 1
         DCLLOC(3,LOOP) = DCLPOS(3,LOOP)
 10      CONTINUE
      IPAGE = 1
C                                       Loop over declaration statments
      DO 700 IDCL = 1,NUMDCL
C                                       Start position in declaration
C                                       line.
         POINT = DCLLOC(1,IDCL) + LENDCL(DCLLOC(3,IDCL)) + 1
         LIMIT2 = DCLLOC(2,IDCL)
C                                       Find start of next variable
 50         LIMIT = POINT
            IF (POINT.GT.LIMIT2) GO TO 700
            DO 60 LOOP = LIMIT,LIMIT2
               CHR = MODULE(1)(POINT:POINT)
               ICHR = ICHAR (CHR)
C                                       Letter
               IF ((ICHR.GE.ICHA) .AND. (ICHR.LE.ICHZ)) GO TO 100
               POINT = POINT + 1
C                                       new line?
               IF (CHR.EQ.'@') POINT = POINT + 6
C                                       Done with declaration?
               IF (POINT.GT.LIMIT2) GO TO 700
 60            CONTINUE
             GO TO 700
C                                       Find number of characters in
C                                       name.
 100        LVNAME = 0
            VARNAM = '      '
            DO 120 LOOP = 1,30
               CHR = MODULE(1)(POINT+LVNAME:POINT+LVNAME)
               IF (INDEX (OKCH(1:5), CHR).GT.0) GO TO 200
               LVNAME = LVNAME + 1
               VARNAM(LVNAME:LVNAME) = CHR
 120        CONTINUE
C                                       Look for string
C                                       Next dcl if confused.
 200        IF (LVNAME.LE.0) GO TO 700
C                                       Log long names:
            IF (LVNAME.GT.6) THEN
               WRITE (12,1200,ERR=205) VARNAM(1:LVNAME)
               END IF
C                                       Check call sequence
 205        START = 1
 210        IPNT = INDEX (MODULE(1)(START:BEGDCL), VARNAM(1:LVNAME))
            IF  (IPNT.GT.0) THEN
C                                       Verify name
               KPNT = START + IPNT - 1
               BC = MODULE(1)(KPNT-1:KPNT-1)
               EC = MODULE(1)(KPNT+LVNAME:KPNT+LVNAME)
               IF ((INDEX (OKCH, BC).LE.0) .OR. (INDEX (OKCH, EC).LE.0))
     *            THEN
                  START = KPNT + LVNAME
                  GO TO 210
                  END IF
C                                       Found it
                  GO TO 290
               END IF
C                                       Used after declaration?
            START = POINT + LVNAME
            IPAGE = 1
 250        IPNT = INDEX (MODULE(IPAGE)(START:LMODUL(IPAGE)),
     *         VARNAM(1:LVNAME))
C                                       More pages?
            IF ((IPNT.LE.0) .AND. (IPAGE.LT.PAGE)) THEN
                IPAGE = IPAGE + 1
                START = 1
                GO TO 250
                END IF
C                                       Found?
 290        IF (IPNT.GT.0) THEN
C                                       Verify name
               KPNT = START + IPNT - 1
               BC = MODULE(IPAGE)(KPNT-1:KPNT-1)
               EC = MODULE(IPAGE)(KPNT+LVNAME:KPNT+LVNAME)
               IF ((INDEX (OKCH, BC).LE.0) .OR. (INDEX (OKCH, EC).LE.0))
     *            THEN
                  START = KPNT + LVNAME
                  GO TO 250
                  END IF
C                                       Skip rest of declaration
C                                       Find next level 0 ',' or '@'
               LIMIT = POINT
               PLEVEL = 0
               DO 300 LOOP = LIMIT,LIMIT2
                  IF (POINT.GT.LIMIT2) GO TO 700
                  CHR = MODULE(1)(POINT:POINT)
                  IF (CHR.EQ.'(') PLEVEL = PLEVEL + 1
                  IF (CHR.EQ.')') PLEVEL = PLEVEL - 1
                  IF (PLEVEL.EQ.0) THEN
                     IF ((CHR.EQ.',') .OR. (CHR.EQ.'@')) GO TO 50
                     END IF
                  POINT = POINT + 1
C                                       new line?
                  IF (CHR.EQ.'@') POINT = POINT + 6
 300              CONTINUE
C                                       Zap declaration
            ELSE
               CALL PARSEA (MODULE(1)(POINT:LMODUL(1)),
     *            DCLLOC(3,IDCL), MODULE(1)(DCLLOC(1,IDCL):POINT-1),
     *            DCLSTR, LDSTR)
               END IF
            GO TO 50
 700     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1200 FORMAT (' Illegal length variable name: ',A)
      END
      SUBROUTINE FNDUSE (PAGE, MODULE, LMODUL, BEGFOR, NKEEP, KEEP,
     *   NARG, ARG)
C-----------------------------------------------------------------------
C   Routine to find if any variables in the Forced declaration are used.
C    Input
C     PAGE    I  Number of pages in MODULE
C     MODULE  C  Module string, '@' => line break
C     LMODUL  I  Number of valid characters in MODULE (including '@')
C     BEGFOR  I  Pointer to the first character of the executable
C     NKEEP   I  Number of elements in KEEP
C     KEEP()  C  Variable names to force declarations if used.
C   Input/Output:
C     NARG    I  Number of elements in ARG
C     ARG()   C  Variables to declare.
C-----------------------------------------------------------------------
      INTEGER   PAGE
      CHARACTER MODULE(PAGE)*(*), KEEP(*)*6, ARG(*)*6
      INTEGER   LMODUL(PAGE), BEGFOR, NKEEP, NARG
      CHARACTER VARNAM*6, CHR*1, BC*1, EC*1, OKCH*13
      INTEGER   LVNAME, START, IPNT, LOOP, IPAGE, IKEEP, ITRIM, KPNT
      DATA OKCH /' ,(@*)=+-./!:'/
C-----------------------------------------------------------------------
      IF ((PAGE.LE.0) .OR. (LMODUL(1).LE.0)) GO TO 999
      IF (BEGFOR.GE.LMODUL(PAGE)) GO TO 999
C                                       Loop over declaration statments
      DO 700 IKEEP = 1,NKEEP
         VARNAM = KEEP(IKEEP)
         LVNAME = ITRIM (VARNAM)
C                                       Have it already?
         DO 200 LOOP = 1,NARG
            IF (ARG(LOOP).EQ.VARNAM) GO TO 700
 200        CONTINUE
C                                       Look for variable
         START = BEGFOR
         DO 500 IPAGE = 1,PAGE
 100        IPNT = INDEX (MODULE(IPAGE)(START:LMODUL(IPAGE)),
     *         VARNAM(1:LVNAME))
            IF (IPNT.GT.0) THEN
C                                       Verify
               KPNT = START + IPNT - 1
               BC = MODULE(IPAGE)(KPNT-1:KPNT-1)
               EC = MODULE(IPAGE)(KPNT+LVNAME:KPNT+LVNAME)
               IF ((INDEX (OKCH, BC).LE.0) .OR. (INDEX (OKCH, EC).LE.0))
     *            THEN
C                                       Invalid name
                  START = KPNT + LVNAME
C                                       Try again
                  GO TO 100
                  END IF
C                                       Save it
               NARG = NARG + 1
               ARG(NARG) = VARNAM
               END IF
            START = 1
 500        CONTINUE
 700     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE CHL2U (STRING, LSTR)
C-----------------------------------------------------------------------
C   Converts FORTRAN in STRING from lower to upper case.  No
C   translation is done to comment lines except to be sure that the
C   first character is 'C'.  No translation is done to values inside
C   quotes or in inline comments.
C    Input:
C     LSTR     I  Length of STRING
C    Input/Output:
C     STRING   C  String containing a line of Fortran.
C-----------------------------------------------------------------------
      INTEGER   LSTR
      CHARACTER STRING*(*)
      INTEGER   LOWA, UPA, LOOP, ICH
      LOGICAL   QUOTE
      CHARACTER CH*1
C-----------------------------------------------------------------------
C                                       Comment line?
      IF (STRING(1:1).EQ.'c') STRING(1:1) = 'C'
      IF (STRING(1:1).EQ.'*') STRING(1:1) = 'C'
      IF (STRING(1:1).EQ.'C') GO TO 999
C                                       Prepare to translate
      LOWA = ICHAR ('a')
      UPA  = ICHAR ('A')
      QUOTE = .FALSE.
C                                       Translate
      DO 100 LOOP = 1,LSTR
         CH = STRING(LOOP:LOOP)
C                                       Bail out if inline comment
         IF (CH.EQ.'!') GO TO 999
         IF (CH.EQ.'''') QUOTE = .NOT.QUOTE
C                                       Ignore things in quotes
         IF (.NOT.QUOTE) THEN
C                                       Translate
            ICH = ICHAR (CH) - LOWA
            IF ((ICH.GE.0) .AND. (ICH.LE.25)) STRING(LOOP:LOOP) =
     *         CHAR (ICH+UPA)
            END IF
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE UVZRWT( UIN, VIN, BEAM, ZEROSP, TFLUXG, FLUXZ, WEIGHT)
C-----------------------------------------------------------------------
C!  Puts Zero spacing flux and weight into a UV Buffer.
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C UV ZeRo SPace: Puts Zero spacing flux and weight into a UV Buffer.
C Band width synthesis is handled by this routine
C Inputs:
C  UIN        R     Location of UV point in lambda
C  VIN        R     Location of UV point in lambda
C  BEAM       L     True if calculating beam zero spacing value
C  ZEROSP     R(5)  Zero Spacing Flux, major axis, minor axis, angle and
C                   weight
C  TFLUXG     R     Total Gridded Flux already subtracted from UV-data
C Output:
C  FLUXZ      R     Flux for zero spacing for Gaussian at UIN, VIN
C  WEIGHT     R     Weight of Zero Spacing Flux
C  BUFF       R(*)  Visibility record
C-----------------------------------------------------------------------
      REAL      UIN, VIN, ZEROSP(5), TFLUXG, FLUXZ, WEIGHT
      LOGICAL   BEAM
C
      REAL      SINT, COST, THETA, DU, DV
      INTEGER   I
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Always do u=v=0
      FLUXZ = 1.
C                                       if U or V not zero
      IF ((ABS(UIN).GT.0.001) .OR. (ABS(VIN).GT.0.001)) THEN
C                                       Assume Flux is zero
         FLUXZ = 0.0
C                                       Extemded
         IF ((ZEROSP(2).GE.1.0E-6) .AND. (ZEROSP(3).GE.1.0E-6)) THEN
C                                       rotate and covert to radians
            THETA = (90. + ZEROSP(4)) / 57.29577
            SINT  = SIN(THETA)
            COST  = COS(THETA)
C                                       rotate In u and v
            DU = (UIN*COST) - (VIN*SINT)
            DV = (VIN*COST) + (UIN*SINT)
C                                       decrease gaussian weight
            FLUXZ = (DU*ZEROSP(2))**2 + (DV*ZEROSP(3))**2
C                                       convert from FWHM to sigma
C                                       2.3548 = 2 * sqrt(2*ln(2))
C           FLUXZ = FLUXZ*(2.3548**2)
C                                       convert from arcsec to radians
C           FLUXZ = EXP(-FLUXZ/(206264.81**2))
            FLUXZ = EXP (-FLUXZ / (87592.6**2))
            END IF
C                                       end if U not 0 or V not 0
         END IF
C                                       Use input weight,
      WEIGHT = ZEROSP(5)
C                                       Do not use insignificant points
      IF (FLUXZ.LT.1E-3) WEIGHT = 0.0
C                                       if making beam
      IF (BEAM) THEN
C                                       tell once about zero spacing
         IF ((VIN.EQ.0.0) .AND. (UIN.EQ.0.0)) THEN
            WRITE (MSGTXT,1250) ZEROSP(1), ZEROSP(5)
            CALL MSGWRT (3)
C                                       major axis in arc seconds
            IF ((ZEROSP(2).GE.1.0E-6) .AND. (ZEROSP(3).GE.1.0E-6)) THEN
               WRITE (MSGTXT,1260) (ZEROSP(I), I=2,4)
               CALL MSGWRT (3)
               END IF
            END IF
C                                       Tell user about Zero Spacing
C         WRITE (MSGTXT,1240,ERR=999) UIN, VIN, FLUXZ*ZEROSP(1)
C         IF ((WEIGHT.GT.0.0) .AND. (UIN.GE.VIN) .AND.
C     *      (VIN.GE.0.0) .AND. (UIN.GT.0.0)) CALL MSGWRT(2)
C                                       Beam Flux is 1 - gridded flux
         FLUXZ  = (1.0 - TFLUXG)
C                                       else normal map use input flux
      ELSE
         FLUXZ = (ZEROSP(1) - TFLUXG) * FLUXZ
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1240 FORMAT ('UVZRWT: Cell ',1PE10.3,',',E10.3,' lambdas, Flux ',E10.3)
 1250 FORMAT ('UVZRWT: Zero spacing ',1PE10.3,', Weight ',E10.3)
 1260 FORMAT ('UVZRWT: Maj, Min Ax. ',1PE10.3,'",',E10.3,
     *        '", Angle ',0PF6.1,' Deg')
      END

      SUBROUTINE BLINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IBLRNO, BLKOLS, BLNUMV, NUMANT, NUMPOL, NUMIF, IERR)
C-----------------------------------------------------------------------
C! Create/open/init I/O to BL table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2000, 2006, 2009, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes baseline correction (BL) extension tables.
C    Inputs:
C     OPCODE       C*4 Operation code:
C                      'WRIT' = create/init for write or read
C                      'READ' = open for read only
C     BUFFER(512)  I   I/O buffer and related storage, also defines file
C                      if open.
C     DISK         I   Disk to use.
C     CNO          I   Catalog slot number
C     VER          I   BL file version
C     CATBLK(256)  I   Catalog header block.
C     LUN          I   Logical unit number to use
C    Input (create) / output (pre-existing)
C     NUMANT       I    Number of antennas
C     NUMPOL       I    Number of polarizations.
C     NUMIF        I    Number of IFs
C    Output:
C     IBLRNO       I   Next scan number, start of the file if 'READ',
C                      the last+1 if WRITE
C     BLKOLS(MAXBLC) I   The column pointer array in order, TIME, SOURID,
C                      SUBARRAY, ANTENNA1, ANTENNA2, FREQ. ID,
C                      REALM1, IMAGM1, REALA1, IMAGA1,
C                      Following used if 2 polarizations per IF
C                      REALM2, IMAGM2, REALA2, IMAGA2.
C     BLNUMV(MAXBLC) I   Element count in each column.
C     IERR         I   Return error code, 0=>OK, else TABINI or TABIO
C                      error.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, IBLRNO,
     *   BLKOLS(*), BLNUMV(*), NUMANT, NUMPOL, NUMIF, IERR
c
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH HOLTMP(6)
      CHARACTER KEYW(3)*8,  TTITLE*56, TITLE(MAXBLC)*24, UNITS(MAXBLC)*8
      INTEGER   NKEY, NREC, DATP(128,2), NCOL, NTT, DTYP(MAXBLC), NDATA,
     *   KLOCS(3), KEYVAL(3), ITRIM, KEYTYP(3), IPOINT, J, I, NC, JERR,
     *   ITEMP(6)
      LOGICAL   DOREAD, NEWFIL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (ITEMP, HOLTMP)
      DATA NTT /56/
      DATA TTITLE /'AIPS UV DATA FILE BASELINE TABLE              '/
      DATA NDATA /MAXBLC/
      DATA DTYP /12,5*14,8*2/
      DATA TITLE /'TIME                    ',
     *   'SOURCE ID               ', 'SUBARRAY                ',
     *   'ANTENNA1                ', 'ANTENNA2                ',
     *   'FREQ ID                 ',
     *   'REAL M1                 ', 'IMAG M1                 ',
     *   'REAL A1                 ', 'IMAG A1                 ',
     *   'REAL M2                 ', 'IMAG M2                 ',
     *   'REAL A2                 ', 'IMAG A2                 '/
      DATA KEYW /'NO_ANT  ', 'NO_POL  ', 'NO_IF   '/
      DATA UNITS /'DAYS    ', 13*'        '/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
      NREC = 500
      NKEY = 3
C                                       Fill in types
      IF (.NOT.DOREAD) THEN
         NCOL = 6 + NUMPOL * 4
         CALL COPY (NDATA, DTYP, DATP(1,2))
         DO 10 J = 7,NDATA
            DATP(J,2) = DTYP(J) + 10 * NUMIF
 10         CONTINUE
      ELSE
         NCOL = 0
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'BL', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'BLINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
      NKEY = 3
C                                       Get number of scans
      IBLRNO = BUFFER(5) + 1
      IF (DOREAD) IBLRNO = 1
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 40 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'BLINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'BLINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       Set keyword values
C                                       No. antennas.
         KLOCS(1) = 1
         KEYTYP(1) = 4
         KEYVAL(1) = NUMANT
C                                       No. Polarizations
         KLOCS(2) = 2
         KEYTYP(2) = 4
         KEYVAL(2) = NUMPOL
C                                       No. IFs
         KLOCS(3) = 3
         KEYTYP(3) = 4
         KEYVAL(3) = NUMIF
C                                       Only write if just created.
         CALL TABKEY (OPCODE, KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'BLINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'BLINI', IERR)
            GO TO 990
            END IF
C                                       Retrieve keyword values
C                                       No. antennas.
         IPOINT = KLOCS(1)
         IF (IPOINT.GT.0) NUMANT = KEYVAL(IPOINT)
C                                       No. polarizations
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. IFs
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
         END IF
C                                      Get array indices
C                                      Cover your ass from FNDCOL -
C                                      close to flush the buffers and
C                                      then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KEYVAL, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'BLINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'BL', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'BLINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (NDATA, TITLE, 24, .TRUE., BUFFER, BLKOLS, JERR)
C                                       Get array indices
      NCOL = 6 + NUMPOL * 4
      DO 150 I = 1,NCOL
         IPOINT = BLKOLS(I)
         IF (IPOINT.GT.0) THEN
            BLKOLS(I) = DATP(IPOINT,1)
            BLNUMV(I) = DATP(IPOINT,2) / 10
            IF (BLNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            BLKOLS(I) = -1
            BLNUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('BLINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('BLINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('BLINI: ERROR INITIALIZING BASELINE TABLE FOR ',A4)
      END

      SUBROUTINE TABPC (OPCODE, BUFFER, PCROW, PCCOLS, PCNUMV, NUMPOL,
     *   TIME, TIMINT, SOURCE, ANTNUM, SUBARR, FREQID, CABCAL, STATE,
     *   PCFREQ, PCREAL, PCIMAG, PCRATE, IRET)
C-----------------------------------------------------------------------
C! Read, write or close AIPS phase-cal tables opened with PCINI.
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1998, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Read, write or close AIPS phase-cal (PC) tables opened using PCINI.
C
C   Inputs:
C      OPCODE    C*4          Operation code:
C                                'READ' - read a row
C                                'WRIT' - write a row
C                                'CLOS' - close table
C      PCCOLS    I(MAXPCC)    Column pointers from PCINI
C      PCNUMV    I(MAXPCC)    Column dimensions from PCINI
C      NUMPOL    I            Number of polarizations in PC table
C                                (1 or 2)
C
C   Input/output:
C      BUFFER    I(512)       Table I/O block initialized by PCINI
C      PCROW     I            Row to read or write; incremented by one
C                                if the row is read successfully;
C                                ignored on 'CLOS'.
C      TIME      D            Centre-time of PC record in days from
C                                0h on the reference day
C      TIMINT    R            Duration of the time interval covered
C                                by the PC record in days
C      SOURCE    I            Source number (0 if the record applies
C                                to any source)
C      ANTNUM    I            Antenna number to which the record applies
C      SUBARR    I            Subarray number
C      FREQID    I            Frequency group ID number
C      CABCAL    D            Cable calibration delay measurement in
C                                seconds
C      STATE     R(2, 4, MAXIF)
C                             Percentage of time the digitizer spent
C                                in the lowest (1), medium-low (2),
C                                medium-high (3) and highest (4) states
C                                for each IF and polarization
C      PCFREQ    D(2, MAXTON, MAXIF)
C                             Phase tone frequencies for each IF and
C                                polarization
C      PCREAL    R(2, MAXTON, MAXIF)
C                             The real part of each phase cal
C                                measurement in each IF and polarization
C      PCIMAG    R(2, MAXTON, MAXIF)
C                             The imaginary part of each phase cal
C                                measurement in each IF and polarization
C      PCRATE    R(2, MAXTON, MAXIF)
C                             The rate of change of the phase cal phase
C                                in Hz divided by the phase cal
C                                frequency for each tone in each IF
C                                and polarization
C
C   Output:
C      IRET                   Status
C                                0 - operation completed
C                                1 - attempted to read beyond end of
C                                    table
C                                2 - I/O error detected
C                              999 - Invalid call to TABPC
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PTAB.INC'
      INCLUDE 'INCS:PPCV.INC'
C
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), PCROW, PCCOLS(MAXPCC), PCNUMV(MAXPCC),
     *          NUMPOL, SOURCE, ANTNUM, SUBARR, FREQID, IRET
      DOUBLE PRECISION TIME, CABCAL, PCFREQ(2, MAXTON, MAXIF)
      REAL      TIMINT, STATE(2, 4, MAXIF), PCREAL(2, MAXTON, MAXIF),
     *          PCIMAG(2, MAXTON, MAXIF), PCRATE(2, MAXTON, MAXIF)
C
C     Local variables
C
C     IREC      Integer I/O buffer
C     RREC      Single-precision floating-point I/O buffer
C     DREC      Double-precision floating-point I/O buffer
C     NUMIF     Number of IFs in table
C     NUMTON    Number of tones in table
C     I         Loop index
C     J         Loop index
C     K         Loop index
C
      INTEGER   IREC(PCRSIZ)
      REAL      RREC(PCRSIZ)
      DOUBLE PRECISION DREC(PCRSIZ/2)
      EQUIVALENCE (IREC, RREC, DREC)
      INTEGER   NUMIF, NUMTON
      INTEGER   I, J, K
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      NUMIF  = PCNUMV(8) / 4
      NUMTON = PCNUMV(9) / NUMIF
      CALL CHECK ('TABPC ', 1, ((NUMPOL .EQ. 1) .OR. (NUMPOL .EQ. 2)),
     *            IRET)
      IF (IRET .NE. 0) GO TO 999
C
      IF (OPCODE .EQ. 'READ') THEN
         CALL TABIO (OPCODE, TIOROW, PCROW, IREC, BUFFER, IRET)
         IF (IRET.LE.0) THEN
            PCROW  = PCROW + 1
            TIME   = DREC(PCCOLS(1))
            TIMINT = RREC(PCCOLS(2))
            SOURCE = IREC(PCCOLS(3))
            ANTNUM = IREC(PCCOLS(4))
            SUBARR = IREC(PCCOLS(5))
            FREQID = IREC(PCCOLS(6))
            CABCAL = DREC(PCCOLS(7))
            DO 40 I = 1,NUMPOL
               DO 30 K = 1,NUMIF
                  DO 10 J = 1,4
                     STATE(I,J,K) = RREC(PCCOLS(8 + 5 * (I - 1))
     *                  + 4 * (K - 1) + (J - 1))
 10                  CONTINUE
                  DO 20 J = 1,NUMTON
                     PCFREQ(I,J,K) = DREC(PCCOLS(9 + 5 * (I - 1))
     *                  + NUMTON * (K - 1) + (J - 1))
                     PCREAL(I,J,K) = RREC(PCCOLS(10 + 5 * (I - 1))
     *                  + NUMTON * (K - 1) + (J - 1))
                     PCIMAG(I,J,K) = RREC(PCCOLS(11 + 5 * (I - 1))
     *                  + NUMTON * (K - 1) + (J - 1))
                     PCRATE(I,J,K) = RREC(PCCOLS(12 + 5 * (I - 1))
     *                  + NUMTON * (K - 1) + (J - 1))
 20                  CONTINUE
 30               CONTINUE
 40            CONTINUE
         ELSE IF (IRET.EQ.4) THEN
            WRITE (MSGTXT, 9040) PCROW, BUFFER(5)
            CALL MSGWRT (8)
            IRET = 1
         ELSE
            CALL TABERR (OPCODE, 'TABIO ', 'TABPC ', IRET)
            IRET = 2
            END IF
      ELSE IF (OPCODE.EQ.'WRIT') THEN
         DREC(PCCOLS(1)) = TIME
         RREC(PCCOLS(2)) = TIMINT
         IREC(PCCOLS(3)) = SOURCE
         IREC(PCCOLS(4)) = ANTNUM
         IREC(PCCOLS(5)) = SUBARR
         IREC(PCCOLS(6)) = FREQID
         DREC(PCCOLS(7)) = CABCAL
         DO 80 I = 1,NUMPOL
            DO 70 K = 1,NUMIF
               DO 50 J = 1,4
                  RREC(PCCOLS(8 + 5 * (I - 1)) + 4 * (K - 1) + (J - 1))
     *               = STATE(I,J,K)
 50               CONTINUE
               DO 60 J = 1,NUMTON
                  DREC(PCCOLS(9 + 5 * (I - 1))
     *               + NUMTON * (K - 1) + (J - 1)) = PCFREQ(I,J,K)
                  RREC(PCCOLS(10 + 5 * (I - 1))
     *               + NUMTON * (K - 1) + (J - 1)) = PCREAL(I,J,K)
                  RREC(PCCOLS(11 + 5 * (I - 1))
     *               + NUMTON * (K - 1) + (J - 1)) = PCIMAG(I,J,K)
                  RREC(PCCOLS(12 + 5 * (I - 1))
     *               + NUMTON * (K - 1) + (J - 1)) = PCRATE(I,J,K)
 60               CONTINUE
 70            CONTINUE
 80         CONTINUE
         CALL TABIO (OPCODE, TIOROW, PCROW, IREC, BUFFER, IRET)
         IF (IRET.EQ.0) THEN
            PCROW = PCROW + 1
         ELSE
            CALL TABERR (OPCODE, 'TABIO ', 'TABPC ', IRET)
            IRET = 2
            END IF
      ELSE IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, PCROW, IREC, BUFFER, IRET)
         IF (IRET.NE.0) THEN
            CALL TABERR (OPCODE, 'TABIO ', 'TABPC ', IRET)
            IRET = 2
            END IF
      ELSE
         WRITE (MSGTXT, 9080) OPCODE
         CALL MSGWRT (8)
         IRET = 999
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 9040 FORMAT ('TABPC: ATTEMPTED TO READ ROW ', I6, ' ONLY ', I6,
     *   ' PRESENT')
 9080 FORMAT ('TABPC: UNRECOGNIZED OPCODE ''', A, '''')
      END

      SUBROUTINE YHOLD (OP, IERR)
C-----------------------------------------------------------------------
C! Turn command buffering on or off
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YHOLD informs the TV device or server when it may choose to become
C   asynchronous (delaying screen updates until convenient) and when it
C   must become syncronous again (doing each command as it's issued).
C   This function is placed in the hands of the programmer but you are
C   obliged to use it carefully.  Cursor reads and the like will not
C   call YHOLD ('OFFF', IERR) - the only automatic call is in YTVCLS.
C   Inputs:
C      OP     C*4   'ONNN' -> become asynchronous, 'OFFF' -> force
C                   resynchronization and remain synchronous
C   Output:
C      IERR   I     Error return - 0 is normal.
C   Generic version: does absolutely nothing
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
C-----------------------------------------------------------------------
      IERR = 0
C
 999  RETURN
      END

      SUBROUTINE ZDOPRT (IVOL, LUN, NCOPY, PNAME, ISIZE, INBLK, IERR)
C-----------------------------------------------------------------------
C! reads bit file and causes it to be plotted on printer/plotter
C# Z Printer Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Read a bit map such as produced by PRTDRW and convert it into a
C   file that can be spooled to a Versatec printer/plotter.
C   Inputs:
C      IVOL     I      Disk volume containing file, 1,2,3,...
C      LUN      I      Logical unit number
C      NCOPY    I      Number of copies of the plot to make
C      PNAME    C*48   Physical file name (left justified)
C      ISIZE    I      Size of INBLK in words
C   In/Out:
C      INBLK    I(*)   Scratch buffer
C   Output:
C      IERR     I      Error return code: 0 => no error
C                         1 => error assigning plotter
C                         2 => error doing plot
C   VAX VERSION: works only for rev C or higher of the VERSATEC driver.
C   This version spools the plot to the device queue with the logical
C   name VERPLOT.  We use I*2 buffer - ISIZE in AIPS words (4 real
C   bytes each).
C-----------------------------------------------------------------------
      INTEGER   IVOL, LUN, NCOPY, ISIZE, IERR
      INTEGER*2 INBLK(*)
      CHARACTER PNAME*48
C
      INTEGER*2 IOBLK(65), FF, IPLOT, LIST2(8)
      CHARACTER MESSAG*64, CTEMP*1, DEVICQ*64, PLTFIL*13
      REAL      DELAY1, DELAY3
      INTEGER   FORERR, RMSERR, MSGLEN, JERR, SYS$CRELNM, ISIZE2, XLNB,
     *   INPOS, IOPOS, INIBLK, IRRN, IMLINE, ILINE, NBYTES, FIND, I,
     *   II, RBYTES, LIST4(4)
      LOGICAL   EXCL, NOMAP, WAIT, MAP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE '($LNMDEF)'
      EQUIVALENCE (LIST2, LIST4)
      EQUIVALENCE (EXCL, WAIT, MAP)
      DATA FF, IPLOT /'1013'X, '0012'X/
      DATA EXCL, NOMAP /.TRUE.,.FALSE./
      DATA DELAY1, DELAY3 /1.0, 3.0/
C-----------------------------------------------------------------------
C                                       Open the bit map file.
      CALL ZOPEN (LUN, FIND, IVOL, PNAME, MAP, EXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         IERR = 1
         GO TO 995
         END IF
C                                       Find out Queue name for plotter.
      CALL ZTRLOG (7, 'VERPLOT', 64, DEVICQ, XLNB, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010)
         IERR = 1
         GO TO 990
         END IF
C                                       Assign SYS$PRINT to plotter
C                                       device queue.
      LIST2(1) = XLNB
      LIST2(2) = LNM$_STRING
      LIST4(2) = %LOC (DEVICQ)
      LIST4(3) = 0
      LIST4(4) = 0
      JERR = SYS$CRELNM ( , 'LNM$PROCESS_TABLE', 'SYS$PRINT', , LIST4)
      IF (JERR.NE.1) THEN
         WRITE (MSGTXT,1012) JERR
         IERR = 1
         GO TO 990
         END IF
C                                       Initial buffer counters.
      INPOS = 257
      IOPOS = 1
      IRRN = 1
      NBYTES = ((2 * ISIZE) / NBPS) * NBPS
      ILINE = 0
      ISIZE2 = NBYTES
      CALL ZMIO ('READ', LUN, FIND, IRRN, NBYTES, INBLK, 1, IERR)
      IF (IERR.EQ.0) CALL ZWAIT (LUN, FIND, 1, IERR)
      IF (IERR.NE.0) GO TO 110
      IRRN = IRRN + NBYTES / NBPS
      IMLINE = INBLK(1)
      RBYTES = 512 + ((MAXXPR(1)-1) / NBITWD + 1) * IMLINE * 2 - NBYTES
C                                       Open the VERSATEC (spool file)
C                                       Figure out an initial size.
      INIBLK = .58 * IMLINE
C                                       Try for each available disk.
      DO 20 I = 1,NVOL
         II = I - 1
         CALL ZEHEX (II, 1, CTEMP)
         PLTFIL = 'DA0' // CTEMP // ':PLOT.DAT'
         OPEN (UNIT=1, FILE=PLTFIL, STATUS='NEW', FORM='FORMATTED',
     *      ACCESS='SEQUENTIAL', CARRIAGECONTROL='NONE', DISP='PRINT',
     *      RECORDTYPE='VARIABLE', INITIALSIZE=INIBLK, IOSTAT=IERR)
         IF (IERR.EQ.0) GO TO 50
            WRITE (MSGTXT,1015) IERR, I
            CALL MSGWRT (7)
 20      CONTINUE
      MSGTXT = 'CAN''T FIND ROOM - QUITTING'
      GO TO 990
C                                       Begin master loop.
 50   CONTINUE
C                                       read new buff
         IF (INPOS.GT.ISIZE2) THEN
            IF (RBYTES.LE.0) GO TO 100
C                                       Last input buffer.
            IF (RBYTES.LT.NBYTES) THEN
               NBYTES = RBYTES
               ISIZE2 = NBYTES
               END IF
            CALL ZMIO ('READ', LUN, FIND, IRRN, NBYTES, INBLK, 1, IERR)
            IF (IERR.EQ.0) CALL ZWAIT (LUN, FIND, 1, IERR)
            IF (IERR.NE.0) GO TO 110
            RBYTES = RBYTES - NBYTES
            IRRN = IRRN + NBYTES / NBPS
            INPOS = 1
            END IF
C                                       Determine length to copy.
         XLNB = MIN (ISIZE2+1-INPOS, 66-IOPOS)
         CALL ZBYTFL (XLNB, INBLK(INPOS), IOBLK(IOPOS))
         IOPOS = IOPOS + XLNB
         INPOS = INPOS + XLNB
C                                       Write to VERSATEC spool file.
         IF (IOPOS.GT.65) THEN
            WRITE (1,1050,ERR=120) IPLOT, IOBLK
            ILINE = ILINE + 1
            IOPOS = 1
            END IF
         GO TO 100
C                                       Flush last buffer.
 100  IOPOS = IOPOS - 1
      IF (IOPOS.GT.0) WRITE (1,1050,ERR=120) IPLOT, (IOBLK(I),
     *   I = 1,IOPOS)
      GO TO 150
C                                       Error handling.
 110  WRITE (MSGTXT,1110) IERR
      CALL MSGWRT (7)
      GO TO 150
C
 120  CALL ERRSNS (FORERR, RMSERR)
      CALL SYS$GETMSG (%VAL(RMSERR), MSGLEN, MESSAG, %VAL(1), )
      WRITE (MSGTXT,1120)
      CALL MSGWRT (7)
      MSGTXT = MESSAG
      CALL MSGWRT (7)
C                                       Issue final form feed and
C                                       close files.
 150  WRITE (1,1050,ERR=180) FF
      NCOPY = NCOPY - 1
      IF (NCOPY.LE.0) GO TO 180
         DO 170 I = 1,NCOPY
            CLOSE (UNIT=1)
C                                       Give spooler chance to get file.
            CALL ZDELAY (DELAY3, IERR)
C                                       Try a few times to open file.
            DO 160 II = 1,10
               CALL ZDELAY (DELAY1, IERR)
               OPEN (UNIT=1, FILE=PLTFIL, STATUS='OLD', DISP='PRINT',
     *            ACCESS='SEQUENTIAL', FORM='FORMATTED', IOSTAT=IERR,
     *            CARRIAGECONTROL='NONE', RECORDTYPE='VARIABLE')
               IF (IERR.EQ.0) GO TO 170
 160           CONTINUE
            WRITE (MSGTXT,1160)
            CALL MSGWRT (6)
 170        CONTINUE
 180  CLOSE (UNIT=1, DISP='PRINT/DELETE')
      CALL ZCLOSE (LUN,FIND,IERR)
      GO TO 999
C                                       Error close downs
 980  CALL MSGWRT (7)
      CLOSE (UNIT=1, DISP='PRINT/DELETE')
      CALL ZCLOSE (LUN, FIND, IERR)
      GO TO 999
C
 990  CALL MSGWRT (7)
      CALL ZCLOSE (LUN, FIND, IERR)
      GO TO 999
C
 995  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZDOPRT: UNABLE TO OPEN BIT MAP FILE. IERR=',I4)
 1010 FORMAT ('ZDOPRT: NO LOGICAL NAME ''VERPLOT''')
 1012 FORMAT ('ZDOPRT: COULD NOT ASSIGN LOGICAL NAME, IERR=',I8)
 1015 FORMAT ('ZDOPRT: ERR ',I4,' OPENING SPOOL FILE ON DISK',I3,
     *   '. TRYING NEXT DISK')
 1050 FORMAT (66A2)
 1110 FORMAT ('ZDOPRT: ZMIO READ ERROR. IERR=',I4)
 1120 FORMAT ('ZDOPRT: FORTRAN WRITE ERROR TO PLOTTER')
 1160 FORMAT ('ZDOPRT: COULD NOT REOPEN FILE FOR NEXT COPY')
      END

      SUBROUTINE QCLNSU (COMP, AMAP, LMAP, ABEAM, BBEAM)
C-----------------------------------------------------------------------
C! FPS AP version: Barry Clark CLEAN inner loop
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FPS AP version
C   QCLNSU does a CLEAN on the map points in the pseudo AP
C   using the portion of the beam in the pseudo AP.
C    Inputs:
C      COMP  I  Base address of the component vector:
C                 0 => intensity
C                 1 => x in cells
C                 2 => Y in cells
C                 3 => CLEAN loop gain (fractional)
C      AMAP  I  Base address of the map stored as (loc,intensity)
C                 Loc = (2**14)*X+Y (cells)
C                 -1<X<NX  -1<Y<NY
C      LMAP  I  Number of map points
C      ABEAM I  Base address of the piece of the beam.  The Y
C                 dimension varies the fastest: -BY<Y<BY,
C                 X varies slowest -1<X<BX
C      BBEAM I  Base address of beam descriptor vector (BX,BY)
C-----------------------------------------------------------------------
      INTEGER COMP, AMAP, LMAP, ABEAM, BBEAM
      INTEGER*2 ICOMP, IAMAP, ILMAP, IABEAM, IBBEAM
C-----------------------------------------------------------------------
C                                        Convert inputs to unsigned I*2
      IF (COMP.LT.32768) ICOMP = COMP
      IF (COMP.GE.32768) ICOMP = COMP - 65536
      IF (AMAP.LT.32768) IAMAP = AMAP
      IF (AMAP.GE.32768) IAMAP = AMAP - 65536
      IF (LMAP.LT.32768) ILMAP = LMAP
      IF (LMAP.GE.32768) ILMAP = LMAP - 65536
      IF (ABEAM.LT.32768) IABEAM = ABEAM
      IF (ABEAM.GE.32768) IABEAM = ABEAM - 65536
      IF (BBEAM.LT.32768) IBBEAM = BBEAM
      IF (BBEAM.GE.32768) IBBEAM = BBEAM - 65536
C                                        Call FPS routine.
      CALL CLNSUB (ICOMP, IAMAP, ILMAP, IABEAM, IBBEAM)
C
 999  RETURN
      END

LOCAL INCLUDE 'TAMRG.INC'
C                                       Local include for TAMRG
      INTEGER   CATBLK(256), USERID, SEQ, INVER, OUTVER, SCVER(2),
     *   CNO, DISK, EQUKOL(10), SUMKOL(10), MAXVER, INPCMP, OUTCMP
      HOLLERITH XNAME(3), XCLASS(2), XXTYPE
      CHARACTER NAME*12, CLASS*6, XTYPE*2
      REAL      XSEQ, XDISK, XVER, X2VER, APARM(10), BPARM(10),
     *   CPARM(10), DPARM(10), BADD(10)
      COMMON /INPARM/ XNAME, XCLASS, XSEQ, XDISK, XXTYPE, XVER, X2VER,
     *   APARM, BPARM, CPARM, DPARM, BADD, INPCMP, OUTCMP, USERID, SEQ,
     *   INVER, OUTVER, SCVER, DISK, CNO, EQUKOL, SUMKOL, MAXVER
      COMMON /CHRCOM/ NAME, CLASS, XTYPE
      COMMON /MAPHDR/ CATBLK
LOCAL END
      PROGRAM TAMRG
C-----------------------------------------------------------------------
C! Merges entries in a table as specified by user
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2009, 2011
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task TAMRG sorts AIPS tables to bring all rows at the same control
C   values together, then it sums them, and finally it resorts the file
C   into the original order.
C   Inputs:
C      AIPS Adverb   Prg. Name          Description
C      INNAME         NAME          File name.
C      INCLASS        CLASS         File class.
C      INSEQ          SEQ           File sequence number.
C      INDISK         DISK          Disk volume on which file resides.
C      INEXT          INEXT         Extension file type
C      INVER          INVER         Input file version number
C      IN2VER         OUTVER        Output file version number
C      APARM                        Initial sort: Keys & weights
C                                     1,2=> col. & wt pri. key 1.
C                                     3,4=> col. & wt sec. key 1.
C                                     5,6=> col. & wt pri. key 2.
C                                     7,8=> col. & wt sec. key 2.
C                                     APARM(1) = 0 => no sort.
C      BPARM                        Columns which must be equal
C                                     to merge two rows.
C      CPARM                        Allowed error in the equality
C                                     test by column.
C      DPARM                        Columns to sum. 0 => none.
C      BADDISK        IBADD(10)     Disks to avoid for scratch.
C-----------------------------------------------------------------------
      CHARACTER TYPE*2, PHNAME*48
      DOUBLE PRECISION CATD(128)
      INTEGER   KEY(2,4), IRET, TABUFF(512), IERR, KEYSUB(2,2)
      REAL      BUFFER(512), FKEY(2,4), CATR(256)
      INCLUDE 'TAMRG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (CATBLK, CATR, CATD)
      DATA KEYSUB /4*1/
C-----------------------------------------------------------------------
C                                       Set file info, keys, versions
      CALL TAMRGI (TYPE, KEY, FKEY, TABUFF, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Sort: to scratch (1)
      IF (KEY(1,1).NE.0) THEN
         WRITE (MSGTXT,1000) SCVER(1)
         CALL MSGWRT (2)
         CALL TABSRT (DISK, CNO, TYPE, INVER, SCVER(1), KEY, KEYSUB,
     *      FKEY, TABUFF, CATBLK, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
C                                       Merge: scratch(2)
      WRITE (MSGTXT,1010) SCVER(2)
      IF (KEY(1,3).EQ.0) WRITE (MSGTXT,1011) SCVER(2)
      CALL MSGWRT (2)
      CALL TABMRG (DISK, CNO, TYPE, SCVER(1), SCVER(2), EQUKOL, SUMKOL,
     *   CPARM, BUFFER, TABUFF, CATBLK, OUTCMP, IRET)
      IF (IRET.NE.0) GO TO 900
C                                       Sort to output
      IF (KEY(1,3).NE.0) THEN
         WRITE (MSGTXT,1020) OUTVER
         CALL MSGWRT (2)
         CALL ZPHFIL (TYPE, DISK, CNO, OUTVER, PHNAME, IERR)
         CALL ZDESTR (DISK, PHNAME, IERR)
         CALL TABSRT (DISK, CNO, TYPE, SCVER(2), OUTVER, KEY(1,3),
     *      KEYSUB, FKEY(1,3), TABUFF, CATBLK, IRET)
         END IF
C                                       History and clean up
 900  CALL TAMRGH (IRET, TYPE, KEY, FKEY, TABUFF)
C                                       Write end message
 990  CALL DIE (IRET, TABUFF)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('Start sort to scratch version',I4)
 1010 FORMAT ('Start merge to scratch version',I4)
 1011 FORMAT ('Start merge to output version',I4)
 1020 FORMAT ('Start sort to output version',I4)
      END
      SUBROUTINE TAMRGI (TYPE, KEY, FKEY, TABUFF, IRET)
C-----------------------------------------------------------------------
C   TAMRGI performs initialization for TAMRG
C   Output: TYPE    C*2         Extension file type
C           KEY     I(2,4)      In(1,2), out(3,4) sort cols
C           FKEY    R(2,4)      Weights for sort cols
C           TABUFF  I(*)        Scratch
C           IRET    I           Error code: 0 -> okay
C-----------------------------------------------------------------------
      CHARACTER TYPE*2, PRGM*6, PTYPE*2
      INTEGER   KEY(2,4), IRET, TABUFF(*)
      REAL      FKEY(2,4)
      DOUBLE PRECISION    CATD(128)
      INTEGER   NPARM,IROUND, LUN, FIND, JCOL1, IERR, I, NKEY, NCOL,
     *   NREC, DATP(128,2), JCOL2, IRNO
      REAL      CATR(256)
      INCLUDE 'TAMRG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (CATBLK, CATR, CATD)
      DATA PRGM  /'TAMRG '/
      DATA LUN /16/
C-----------------------------------------------------------------------
C                                       Init I/O, parameters
      NPARM = 60
      CALL SETUP (PRGM, NPARM, XNAME, TABUFF, IRET)
      IF (IRET.NE.0) GO TO 990
      USERID = NLUSER
      SEQ = IROUND (XSEQ)
      DISK = IROUND (XDISK)
      INVER = IROUND (XVER)
      OUTVER = IROUND (X2VER)
      CALL H2CHR (12, 1, XNAME, NAME)
      CALL H2CHR (6, 1, XCLASS, CLASS)
      CALL H2CHR (2, 1, XXTYPE, XTYPE)
      IF (XTYPE.EQ.'  ') XTYPE = 'TA'
      TYPE(1:2) = XTYPE(1:2)
C                                       Open file and get CATBLK.
      PTYPE = '  '
      CALL MAPOPN ('WRIT', DISK, NAME, CLASS, SEQ, PTYPE, USERID, LUN,
     *   FIND, CNO, CATBLK, TABUFF, IRET)
      IF (IRET.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (8)
         GO TO 990
C                                       Mark in /CFILES/
 10   NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 1
C                                       Close file, leave marked.
      CALL ZCLOSE (LUN, FIND, IRET)
      IF (IRET.EQ.0) GO TO 20
         WRITE (MSGTXT,1010) IRET
         CALL MSGWRT (8)
         GO TO 990
C                                       BADDISK
 20   DO 25 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 25      CONTINUE
C                                       find version numbers
      CALL FNDEXT (TYPE, CATBLK, MAXVER)
      IF ((INVER.LE.0) .OR. (INVER.GT.MAXVER)) INVER = MAXVER
      IF ((OUTVER.LE.0) .OR. (OUTVER.GT.MAXVER)) OUTVER = MAXVER + 1
      SCVER(1) = MAXVER + 1
      SCVER(2) = MAXVER + 2
C                                       Open table file
      NKEY = 0
      NCOL = 0
      NREC = 0
      CALL TABINI ('READ', TYPE, DISK, CNO, INVER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, TABUFF, IERR)
      IF (IERR.EQ.0) GO TO 30
         WRITE (MSGTXT,1025) IERR, TYPE, INVER
         GO TO 990
C                                       Find columns
 30   CALL FILL (10, 0, EQUKOL)
      CALL FILL (10, 0, SUMKOL)
C                                       insort
      KEY(1,1) = IROUND (APARM(1))
      KEY(2,1) = IROUND (APARM(3))
      KEY(1,2) = IROUND (APARM(5))
      KEY(2,2) = IROUND (APARM(7))
C                                       sort weights: not sum cols
      FKEY(1,1) = APARM(2)
      FKEY(2,1) = APARM(4)
      FKEY(1,2) = APARM(6)
      FKEY(2,2) = APARM(8)
      IF (FKEY(1,1).EQ.0.0) FKEY(1,1) = 1.0
      IF (FKEY(1,2).EQ.0.0) FKEY(1,2) = 1.0
      IF (FKEY(2,1).EQ.0.0) FKEY(2,1) = 1.0
      IF (FKEY(2,2).EQ.0.0) FKEY(2,2) = 1.0
      I = ABS(KEY(1,1))
      IF ((I.GT.0) .AND. (I.LE.NCOL)) GO TO 40
         KEY(1,1) = 0
         SCVER(2) = MAXVER + 1
         SCVER(1) = INVER
C                                       outsort
 40   KEY(1,3) = ABS (TABUFF(43))
      KEY(2,3) = 0
      KEY(1,4) = ABS (TABUFF(44))
      KEY(2,4) = 0
      FKEY(1,3) = 1.0
      FKEY(2,3) = 1.0
      FKEY(1,4) = 1.0
      FKEY(2,4) = 1.0
      IF (TABUFF(43).LT.0) FKEY(1,3) = -1.0
      IF (TABUFF(44).LT.0) FKEY(1,4) = -1.0
      IF (KEY(1,3).GT.256) KEY(1,3) = 256 - KEY(1,3)
      IF (KEY(1,4).GT.256) KEY(1,4) = 256 - KEY(1,4)
      I = ABS (KEY(1,3))
      IF ((I.GT.0) .AND. (I.LE.NCOL)) GO TO 45
         KEY(1,3) = 0
         SCVER(2) = OUTVER
C                                       Merge columns
 45   JCOL1 = 0
      DO 50 I = 1,10
         JCOL2 = IROUND (BPARM(I))
         IF ((JCOL2.LE.0) .OR. (JCOL2.GT.NCOL)) GO TO 55
            JCOL1 = I
            EQUKOL(I) = JCOL2
            IF (CPARM(I).LT.0.0) CPARM(I) = 0.0
 50      CONTINUE
 55   IF (JCOL1.GT.0) GO TO 60
         WRITE (MSGTXT,1055)
         IRET = 4
         GO TO 990
C                                       Sum columns
 60   DO 65 I = 1,10
         JCOL2 = IROUND (DPARM(I))
         IF ((JCOL2.LE.0) .OR. (JCOL2.GT.NCOL)) GO TO 70
            SUMKOL(I) = JCOL2
 65      CONTINUE
C                                       Number input components
 70   INPCMP = TABUFF(5)
C                                       Close the table file
      IRNO = 0
      CALL TABIO ('CLOS', 0, IRNO, DATP, TABUFF, IERR)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR:',I7,' OPENING MAP FILE')
 1010 FORMAT ('ERROR:',I7,' CLOSING MAP FILE')
 1025 FORMAT ('ERROR:',I7,' OPENING ',A2,' FILE VERSION',I3)
 1055 FORMAT ('ERROR: SOME COLUMNS MUST BE REQUIRED TO BE EQUAL')
      END
      SUBROUTINE TAMRGH (IRET, TYPE, KEY, FKEY, TABUFF)
C-----------------------------------------------------------------------
C   TAMRGH cleans up after TAMRG -- deleting scratch extension files and
C   (on error) any other newly created ones.  It then adds information
C   to the history file.
C   Inputs: IRET    I       Error code from previous routines
C   Output: TABUFF  I(*)    Scratch
C-----------------------------------------------------------------------
      CHARACTER   HILINE*72, ATIME*8, ADATE*12, CHTMP*2,
     *   PHNAME*48, TYPE*2, SPEEDS(4)*4, DIR(4)*4
      HOLLERITH CATH(256)
      DOUBLE PRECISION    CATD(128)
      INTEGER   IRET, TABUFF(*), I, EMIN, EMAX, JP, IVER, IERR,
     *   ID(3), IT(3), HLUN, KEY(2,4)
      REAL      CATR(256), FKEY(2,4)
      LOGICAL   T
      INCLUDE 'TAMRG.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      DATA T /.TRUE./
      DATA HLUN /27/
      DATA SPEEDS /'slow','fast','slow','fast'/
      DATA DIR /' In ',' In ','Out ','Out '/
C-----------------------------------------------------------------------
C                                       extension file clean up
      CALL FXHDEX (CATBLK)
      DO 10 I = 1,KIEXTN
         CALL H2CHR (2, 1, CATH(KHEXT+I-1), CHTMP)
         IF (CHTMP.NE.TYPE) GO TO 10
            JP = KIVER + I - 1
            IF (CATBLK(JP).LE.MAXVER) GO TO 10
               EMAX = CATBLK(JP)
               GO TO 20
 10      CONTINUE
      GO TO 100
 20   EMIN = MAXVER + 1
      IF (IRET.EQ.0) EMIN = MAX (EMIN, OUTVER+1)
C                                       delete the extras
      IF (EMIN.GT.EMAX) GO TO 100
         CATBLK(JP) = EMIN - 1
         DO 30 IVER = EMIN,EMAX
            CALL ZPHFIL (TYPE, DISK, CNO, IVER, PHNAME, IERR)
            CALL ZDESTR (DISK, PHNAME, IERR)
            IF (IERR.GT.1) CATBLK(JP) = IVER
 30         CONTINUE
C                                       Update catalog
         CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'REST', TABUFF, IERR)
C                                       Do history
 100  IF (IRET.NE.0) GO TO 999
C                                       Open file
      CALL HIINIT (3)
      CALL HIOPEN (HLUN, DISK, CNO, TABUFF, IERR)
      IF (IERR.EQ.0) GO TO 110
         WRITE (MSGTXT,1100) IERR
         CALL MSGWRT (6)
         GO TO 999
C                                       Version, date, time
 110  CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, ATIME, ADATE)
      WRITE (HILINE,1110) TSKNAM, RLSNAM, ADATE, ATIME
      CALL HIADD (HLUN, HILINE, TABUFF, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Input vers, number
      WRITE (MSGTXT,1111) INPCMP, XTYPE, INVER
      CALL MSGWRT (3)
      WRITE (HILINE,1112) TSKNAM, INPCMP, XTYPE, INVER
      CALL HIADD (HLUN, HILINE, TABUFF, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Output vers, number
      WRITE (MSGTXT,1113) OUTCMP, XTYPE, OUTVER
      CALL MSGWRT (3)
      WRITE (HILINE,1114) TSKNAM, OUTCMP, XTYPE, OUTVER
      CALL HIADD (HLUN, HILINE, TABUFF, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Sorts
 120  DO 125 I = 1,4
         IF (KEY(1,I).EQ.0) GO TO 125
         IF (((I.EQ.2) .OR. (I.EQ.4)) .AND. (KEY(1,I-1).EQ.0)) GO TO 125
            JP = ABS (KEY(1,I))
            IF (KEY(1,I).GT.0) WRITE (HILINE,1120) TSKNAM, DIR(I),
     *         SPEEDS(I), FKEY(1,I), JP
            IF (KEY(1,I).LT.0) WRITE (HILINE,1121) TSKNAM, DIR(I),
     *         SPEEDS(I), FKEY(1,I), JP
            CALL HIADD (HLUN, HILINE, TABUFF, IERR)
            IF (IERR.NE.0) GO TO 200
            IF (KEY(2,I).EQ.0) GO TO 125
               JP = ABS (KEY(2,I))
               IF (KEY(2,I).GT.0) WRITE (HILINE,1122) TSKNAM,
     *            FKEY(2,I), JP
               IF (KEY(2,I).LT.0) WRITE (HILINE,1123) TSKNAM,
     *            FKEY(2,I), JP
               CALL HIADD (HLUN, HILINE, TABUFF, IERR)
               IF (IERR.NE.0) GO TO 200
 125     CONTINUE
C                                       Merge parameters: equals
 130  DO 135 I = 1,10
         IF (EQUKOL(I).LE.0) GO TO 140
            WRITE (HILINE,1130) TSKNAM, EQUKOL(I), CPARM(I)
            CALL HIADD (HLUN, HILINE, TABUFF, IERR)
            IF (IERR.NE.0) GO TO 200
 135     CONTINUE
C                                       Merge parameters: sums
 140  DO 145 I = 1,10
         IF (SUMKOL(I).LE.0) GO TO 200
            WRITE (HILINE,1140) TSKNAM, SUMKOL(I)
            CALL HIADD (HLUN, HILINE, TABUFF, IERR)
            IF (IERR.NE.0) GO TO 200
 145     CONTINUE
C
 200  CALL HICLOS (HLUN, T, TABUFF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ERROR:',I7,' OPENING HISTORY FILE')
 1110 FORMAT (A6,'Release =''',A7,' ''  /********* run ',A12,2X,A8)
 1111 FORMAT ('Read ',I10,' rows from ',A2,' file version',I3)
 1112 FORMAT (A6,'/Read ',I10,' rows from ',A2,' file version',
     *   I3)
 1113 FORMAT ('Wrote',I10,' rows to ',A2,' file version',I3)
 1114 FORMAT (A6,'/Wrote',I10,' rows to ',A2,' file version',
     *   I3)
 1120 FORMAT (A6,'/',A3,'put sort: ',A4,'er ',F9.3,' Val(col.',I3,')')
 1121 FORMAT (A6,'/',A3,'put sort: ',A4,'er ',F9.3,' Absval(col.',I3,
     *   ')')
 1122 FORMAT (A6,'/',15X,'plus ',F9.3,' Val(col.',I3,')')
 1123 FORMAT (A6,'/',15X,'plus ',F9.3,' Absval(col.',I3,')')
 1130 FORMAT (A6,'/Val(col.',I3,') equal within',1PE12.4,' to merge')
 1140 FORMAT (A6,'/Val(col.',I3,') summed when rows merged')
      END

      SUBROUTINE QCFT2I (LEN1, LEN2, WSAVE)
C-----------------------------------------------------------------------
C! Pseudo AP routine: initialize complex-to-complex 2D FFT
C# AP-FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Initialize a workspace for a complex-to-complex FFT of LEN1 by LEN2
C   elements. There are no restrictions on LEN1 and LEN2  save that they
C   be positive and that LEN2 not exceed FFTMAX elements (defined in
C   INCS:PFFT.INC).  WSAVE must have at least FTWMUL * (LEN1 + LEN2) +
C   2 * FTWADD elements where FTWMUL and FTWADD are defined in
C   INC:PFFT.INC.  Use the constants from this include files to
C   dimension the work array since different machines may use different
C   FFT algorithms with different workspace requirements for reasons of
C   efficiency; PFFT.INC will always define the constants appropriately
C   for the machine your program is compiled on.
C
C   Once initialized by QCFT2I, WSAVE may be used in any number of calls to
C   the Fourier transform routine QCFT2D for LEN1 by LEN2 FFTs.
c
C   Input:
C      LEN1        I         Number of rows to be transformed
C      LEN2        I         Number of columns to be transformed
C   Output:
C      WSAVE      R(*)       Initialized workspace for QCFT2D
C-----------------------------------------------------------------------
      INTEGER   LEN1, LEN2
      REAL      WSAVE(*)
C
      INTEGER   IDX2
      INCLUDE 'INCS:PFFT.INC'
C-----------------------------------------------------------------------
C                                       Generic pseudo AP version uses
C                                       adapted FFTPACK routines: WSAVE
C                                       is divided into 2 workspaces for
C                                       1D FFTs.
      IDX2 = FTWMUL * LEN1 + FTWADD + 1
      CALL QCFT1I (LEN1, WSAVE(1))
      CALL QCFT1I (LEN2, WSAVE(IDX2))
C
 999  RETURN
      END

       SUBROUTINE ZDCHIN (DODISK)
C-----------------------------------------------------------------------
C! initialize message, device and Z-routine characteristics commons
C# Z System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Initialize the device characteristics common and the FCB's (file
C   control blocks) in FTAB(*) for the maximum number of different file
C   types that can be open at the same time.  Initialize also other
C   machine-dependent commons and the message common.  Note that the
C   task name is not set here.
C   Inputs:
C      DODISK   L        Get SETPAR-controlled parameters from disk
C   Inputs from common: DMSG.INC
C      TSKNAM   C*6      Task name if known - else ' ' (used in ABORT
C                        handler mostly to separate standalones and
C                        tasks)
C   Output in commons: DDCH.INC DMSG.INC
C      all      ...      All values set to init except TSKNAM
C
C   ZDCHIN starts with hard-coded values.  Then, if DODISK is true,
C   resets those contained in the system parameter file.  The utility
C   program SETPAR is used to alter the system parameter file values.
C
C   Critical system constants (all "words" are local integers, all
C   "bytes" are AIPS-bytes, i.e., 1/2 a local integer and on 64 bit
C   architectures, double precision contructs should be preprocessed
C   into their single precision counterparts):
C
C   Generic version - calls ZDCHI2, ZDCHIC (init C codes).
C   ZABORT call (initialize abort handler) also - uses TSKNAM
C   Modified to incorporate ATNF modifications 93.03.12
C   Modified to handle larger NETSP files 95.10.20
C   Modified to include GNU Copyleft 95.10.20
C-----------------------------------------------------------------------
      LOGICAL   DODISK
C
      INTEGER   ERRTER, SPLUN, SPIND, IERR, JERR, BLKVAL, NFTAB, I,
     *   IOBLK(256), IENT, IVOL, J, NDX, NENT, NETLUN, NGNU, IDATE(3)
      PARAMETER (NGNU = 23)
      CHARACTER PNAME*48, DA0X*4, NETSP(512)*80, TEXT*80,
     *   LINE*72, GPLBRK(2)*35, GPLDAT*16, GPLTXT(2,NGNU)*35,
     *   GPLTX1(2,10)*35, GPLTX2(2,10)*35, GPLTX3(2,NGNU-20)*35
      REAL      ROBLK(256)
      LOGICAL   MAP, EXCL, WAIT, NEOF
      DOUBLE PRECISION DP
      INCLUDE 'INCS:DBBF.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PAPC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      EQUIVALENCE (EXCL, WAIT),       (IOBLK, ROBLK, BBUFR1)
      EQUIVALENCE (GPLTXT(1,1), GPLTX1(1,1))
      EQUIVALENCE (GPLTXT(1,11), GPLTX2(1,1))
      EQUIVALENCE (GPLTXT(1,21), GPLTX3(1,1))
      DATA ERRTER, SPLUN, BLKVAL /6, 27, -32768/
      DATA MAP, EXCL /.FALSE., .TRUE./
      DATA NETLUN /11/
      DATA GPLDAT /'  Copyright (C) '/
      DATA GPLBRK /'-----------------------------------',
     *             '-----------------------------------'/
      DATA GPLTX1 /'  Associated Universities, Inc. Was',
     *             'hington DC, USA.                   ',
     *             '                                   ',
     *             '                                   ',
     *             '  This program is free software; yo',
     *             'u can redistribute it and/or       ',
     *             '  modify it under the terms of the ',
     *             'GNU General Public License as      ',
     *             '  published by the Free Software Fo',
     *             'undation; either version 2 of      ',
     *             '  the License, or (at your option) ',
     *             'any later version.                 ',
     *             '                                   ',
     *             '                                   ',
     *             '  This program is distributed in th',
     *             'e hope that it will be useful,     ',
     *             '  but WITHOUT ANY WARRANTY; without',
     *             ' even the implied warranty of      ',
     *             '  MERCHANTABILITY or FITNESS FOR A ',
     *             'PARTICULAR PURPOSE.  See the       '/
      DATA GPLTX2 /'  GNU General Public License for mo',
     *             're details.                        ',
     *             '                                   ',
     *             '                                   ',
     *             '  You should have received a copy o',
     *             'f the GNU General Public           ',
     *             '  License along with this program; ',
     *             'if not, write to the Free          ',
     *             '  Software Foundation, Inc., 675 Ma',
     *             'ssachusetts Ave, Cambridge,        ',
     *             '  MA 02139, USA.                   ',
     *             '                                   ',
     *             '                                   ',
     *             '                                   ',
     *             '  Correspondence concerning AIPS sh',
     *             'ould be addressed as follows:      ',
     *             '         Internet email: aipsmail@n',
     *             'rao.edu.                           ',
     *             '         Postal address: AIPS Proje',
     *             'ct Office                          '/
      DATA GPLTX3 /'                         National R',
     *             'adio Astronomy Observatory         ',
     *             '                         520 Edgemo',
     *             'nt Road                            ',
     *             '                         Charlottes',
     *             'ville, VA 22903-2475 USA           '/
C-----------------------------------------------------------------------
C                                       Establish abort handling
      CALL ZABORT (TSKNAM, 0)
C                                       Init MS file size
      MSGCNT = -1
      MSGREC = 0
C                                       Assume basic POPS #, manager
      NPOPS = 1
      NLUSER = 1
C                                       Account location unknown
      NACOUN = 0
C                                       No message suppress.
      MSGSUP = 0
C                                       No message kill.
      MSGKIL = 0
C                                       Not batch.
      ISBTCH = 0
C                                       No debug messages
      DBGAIP = 0
C                                       Default version reset by ZMYVER
      VERNAM = 'NEW:'
C                                       Get hard-coded AIPS release
C                                       ID string (i.e., 15MMMYY).
      CALL GETRLS
C                                       # bits per "word" (calculated in
C                                       ZDCHIC).
      NBITWD = 32
C                                       # bits per character.
      NBITCH = 7
C                                       # characters per input line.
      NCHLIN = 80
C                                       # "words" per double precision
C                                       floating-point (substitute
C                                       single precision on 64-bit
C                                       architectures; calculated in
C                                       ZDCHIC).
      NWDPDP = 2
C                                       # "bytes" per disk sector.
      NBPS = 512
C                                       # sectors per disk granule.
      NSPG = 8
C                                       Define FTAB (i.e., file table)
C                                       entries for the different file
C                                       types:
C
C                                       # "bytes" per non-FCB file
C                                       entry (i.e., no file control
C                                       block) in FTAB(*) where:
      NBTB1 = 28
C                                       bytes   contents
C                                       01-02   logical unit number
C                                       03-04   system error code
C                                       05-06   system file descriptor
C                                       07-28   spare (name?)
C                                       error code return
      NFCBER = 0
C                                       file descriptor if needed
      NFCBFD = 1
C
C                                       # "bytes" per non-map (single
C                                       buffered, synchronous I/O) file
C                                       control block in FTAB(*) where:
      NBTB2 = 44
C                                       bytes   contents
C                                       01-02   logical unit number
C                                       03-04   file descriptor
      FCBFD = 0
C                                       05-06   8-bit byte I/O request
      FCBREQ = 1
C                                       07-08   system error code
      FCBERR = 2
C                                       09-10   8-bit bytes transferred
      FCBXFR = 3
C                                       11-14   8-bit byte file size
C                                       15-18   8-bit byte I/O position
      FCBSIZ = 4
C                                       19-44   spare
C                                       VMS uses FCBSP1 for event flag
C                                       FCBSP2/3 for IOstatus block
C                                       Virtual tapes use 1 & 4
      FCBSP1 = 8
      FCBSP2 = 9
      FCBSP3 = 10
      FCBSP4 = 11
C                                       Offset from the beginning of an
C                                       FTAB entry for a non-map file to
C                                       the start of its file control
C                                       block.
      NMOFF = 1
C                                       # elements in FTAB for non-map
C                                       file entries.
      NMFCB = NBTB2 / 2 - NMOFF
C                                       # "bytes" per map (double
C                                       buffered, asynchronous I/O) file
C                                       control block in FTAB(*) where:
      NBTB3 = 116
C                                       bytes   contents (both buffers)
C                                       01-02   logical unit number
C                                       03-32   (used by applications)
C
C                                       The rest is the same as for
C                                       non-map files, only two file
C                                       control blocks (i.e., one for
C                                       each buffer):
C
C                                       bytes   contents (1st buffer)
C                                       33-34   file descriptor
C                                       35-36   8-bit byte I/O request
C                                       37-38   system error code
C                                       39-40   8-bit bytes transferred
C                                       41-42   8-bit byte file size
C                                       49-74   spare
C
C                                       bytes   contents (2nd buffer)
C                                       75-76   file descriptor
C                                       77-78   8-bit byte I/O request
C                                       79-80   system error code
C                                       81-82   8-bit bytes transferred
C                                       83-84   8-bit byte file size
C                                       91-116  spare
C
C                                       Offset from the beginning of an
C                                       FTAB entry for a map file to the
C                                       start of its file control block.
      MOFF = 16
C                                       # elements in FTAB for map file
C                                       entries (per buffer).
      MFCB = (NBTB3 / 2 - MOFF) / 2
C                                       Set /DCHCOM/ variables for the
C                                       maximum # of the different file
C                                       types that can be open at once
C                                       and initialize the required
C                                       range in FTAB(*).
      NTAB1 = 20
      NTAB2 = 20
      NTAB3 = 20
      NFTAB = (NBTB1*NTAB1 + NBTB2*NTAB2 + NBTB3*NTAB3) / 2
      CALL FILL (NFTAB, 0, FTAB)
C                                       Blank pixel indicator value.
      BLANKV = BLKVAL
C                                       Byte flip indicator code:
C                                          1 => bytes flipped
C                                          2 => words flipped (I*4 only)
C                                          3 => both
C                                          (3 for VAXes, 0 almost
C                                          everywhere else).
      BYTFLP = 0
C                                       Floating-point format code
C                                          0 => OTHER
C                                          1 => IEEE
C                                          2 => VAX F
C                                          3 => VAX G
C                                          4 => IBM (not supported yet)
C                                       Single precision
      SPFRMT = 1
C                                       Double precision
      DPFRMT = 1
C                                       # iterations considered a short
C                                       loop (if less than this, branch
C                                       to scalar code).
      NSHORT = 3
C                                       1 => TTY i/o uses carriage cntrl
      TTYCAR = 1
C                                       Initialize values for some
C                                       parameters.  If DODISK, these
C                                       will be reset with values read
C                                       in from the system parameter
C                                       file (the utility program SETPAR
C                                       is used to change values in the
C                                       system parameter file):
C
C                                       # large disks.
      NVOL = 1
C                                       # tape drives.
      NTAPED = 1
C                                       # lines per CRT page.
      CRTMAX = 24
C                                       # lines per printer page.
      PRTMAX = 61
C                                       VERSATEC graphics parameters:
C                                       X, Y dots per page.
      MAXXPR(1) = 2112
      MAXXPR(2) = 1600
C                                       X, Y dots per character.
      CSIZPR(1) = 20
      CSIZPR(2) = 25
C                                       # AIPS interactive streams.
      NINTRN = 2
C                                       # AIPS batch queues.
      NBATQS = 2
C                                       # of TV devices available
C                                       (later becomes assigned TV #).
      NTVDEV = 1
C                                       # graphics devices (later
C                                       becomes assigned TK #).
      NTKDEV = 16
C                                       X dots (and Y dots until we
C                                       change format of CDCH) per
C                                       mm on printer plotter.
      XPRDMM = 7.83
C                                       X dots (and Y dots) per mm on
C                                       Tektronix graphics device.
      XTKDMM = 5.0
C                                       # POPS allowed TV, TK access.
      NTVACC = 35
      NTKACC = 35
C                                       # entries per user-private
C                                       catalog (<= 0 implies only one
C                                       big public catalog)
      UCTSIZ = 100
C                                       AIPS site system name.
      SYSNAM = 'UN-REGISTERED!!!!'
C                                       Maximum user number (46655 max)
      USELIM = 46655
C                                       TIMDEST data limit per disk.
      CALL RFILL (35, 14.0, TIMEDA)
C                                       TIMDEST SAVE/GET files.
      TIMESG = 28.0
C                                       TIMDEST messages in message
C                                       files.
      TIMEMS = 3.0
C                                       TIMDEST scratch files.
      TIMESC = 3.0
C                                       TIMDEST empty catalog files.
      TIMECA = 0.25
C                                       Batch AP weekend no starts.
      TIMEBA(1) = 15.0
      TIMEBA(2) = 16.5
C                                       Batch AP weekday no starts.
      TIMEBA(3) = 13.0
      TIMEBA(4) = 17.0
C                                       AP roll interval (minutes).
      TIMEAP(1) = 5.0
C                                       AP delay formula (minutes) =
C                                       AP(2) + N + AP(3) * (N*N-1)
C                                       where N = NPOPS-1.
      TIMEAP(2) = 5.0
      TIMEAP(3) = 1.0
C                                       Zero spares.
      CALL RFILL (14, 0.0, RFILIT)
C                                       # characters per line-printer
C                                       line (use 132 or 72).
      NCHPRT = 132
C                                       # words in AP (in 1024s)
C                                       or main pseudo-AP area
      KAPWRD = 64
C                                       1024s of secondary pseudo-AP
C                                       memory (192 for Alliant, Convex
C                                       and COS code supported by NRAO).
      KAP2WD = 0
C                                       magic-value blanks
      CALL CHR2H (4, 'INDE', 1, FBLANK)
      CALL CHR2H (8, 'INDE', 1, DBLANK)
C                                       hollerith blank (convenience)
      CALL CHR2H (4, '    ', 1, HBLANK)
C                                       TK device size
      MAXXTK(1) = 1024
      MAXXTK(2) = 780
C                                       TK device character size
      CSIZTK(1) = 14
      CSIZTK(2) = 22
C                                       disk assignments: (n, disk#)
C                                       n = allowed user numbers
C                                           (all zero => everyone,
C                                           -1 => scratch files only)
      CALL FILL (280, 0, DASSGN)
C                                       Printer deletion time (sec)
      PRDELE = 300
C                                       Dummy space holder
      CALL FILL (NDCHD, 0, DCHDUM)
C                                       Zero device descriptor table.
C                                       DEVTAB(LUN) = 0 => disk file
C                                       with file control block in FTAB:
C
C                                       LUN = 4 (batch input)
C                                       LUN = 8 (AP roller)
C                                       LUN = 12 (message file)
C                                       LUN = 13 (task communications)
C                                       LUN = 14 (POPS "memory" file)
C                                       LUN = 15 (catalog files)
C                                       LUN = 16-25 (map files)
C                                       LUN = 26 (graphics file)
C                                       LUN = 27-30 (non-map files)
C                                       LUN = 35-50 (map or non-map)
      CALL FILL (50, 0, DEVTAB)
C                                       DEVTAB(LUN) = odd => file with
C                                       no file control block in FTAB
C                                       (1 => Fortran device, 3 =>
C                                       other, e.g., text file):
C
C                                       LUN = 1 (line printer).
      DEVTAB(1) = 1
C                                       LUN = 3 (reserved).
      DEVTAB(3) = 3
C                                       LUN = 5 (input/output terminal).
      DEVTAB(5) = 1
C                                       LUN = 6 (output terminal).
      DEVTAB(6) = 1
C                                       LUN = 10 (POPS "run" files).
      DEVTAB(10) = 3
C                                       LUN = 11 (POPS "help" files).
      DEVTAB(11) = 3
C                                       DEVTAB(LUN) = 2 => device with
C                                       file control block in FTAB
C                                       (e.g., tape), 4 => TV device.
C
C                                       LUN = 2 (plotter).
      DEVTAB(2) = 1
C                                       LUN = 7 (Tektronix device).
      DEVTAB(7) = 2
C                                       LUN = 9 (TV device).
      DEVTAB(9) = 4
C                                       LUN = 31-36 (6 tape drives)
      DEVTAB(31) = 2
      DEVTAB(32) = 2
      DEVTAB(33) = 2
      DEVTAB(34) = 2
      DEVTAB(35) = 2
      DEVTAB(36) = 2
C                                       clear file names
      DO 11 I = 1,NTAB1
         DEVNAM(I) = ' '
 11      CONTINUE
      DO 12 I = 1,NTAB2
         NONNAM(I) = ' '
 12      CONTINUE
      DO 13 I = 1,NTAB3
         MAPNAM(I) = ' '
 13      CONTINUE
      SYSTYP = ' '
      SYSVER = ' '
      DO 15 I = 1,35
         TPNAME(I) = ' '
 15      CONTINUE
      TPDNAM = ' '
C                                       Call ZDCHI2 to set peculiar
C                                       variables for local system
      CALL ZDCHI2
C                                       Pass selected values to ZDCHIC
C                                       which makes them available to
C                                       routines written in C as
C                                       external variables.
      CALL ZDCHIC (NBITWD, NBITCH, NCHLIN, NWDPDP, BYTFLP, SPFRMT,
     *   DPFRMT, NBPS, NMFCB, MFCB, NFCBER, NFCBFD, FCBFD, FCBREQ,
     *   FCBERR, FCBXFR, FCBSIZ, FCBSP1, FCBSP2, FCBSP3, FCBSP4, NINTRN,
     *   SYSTYP, SYSVER)
C                                       If DODISK, read values from
C                                       system parameter file, otherwise
C                                       go with hard-coded values set as
C                                       above.
      IF (DODISK) THEN
C                                       Build name of system parameter
C                                       file.
         CALL ZPHFIL ('SP', 1, 0, 0, PNAME, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Open system parameter file.
         CALL ZOPEN (SPLUN, SPIND, 1, PNAME, MAP, EXCL, WAIT, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Read first and only record of
C                                       system parameter file.
         CALL ZFIO ('READ', SPLUN, SPIND, 1, IOBLK, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Reset integer parameters.
         NVOL = IOBLK(1)
         NTAPED = IOBLK(2)
         CRTMAX = IOBLK(3)
         PRTMAX = IOBLK(4)
         NBATQS = IOBLK(5)
         MAXXPR(1) = IOBLK(6)
         MAXXPR(2) = IOBLK(7)
         CSIZPR(1) = IOBLK(8)
         CSIZPR(2) = IOBLK(9)
         NINTRN = IOBLK(10)
         KAPWRD = IOBLK(11)
         NTVDEV = IOBLK(12)
         NTKDEV = IOBLK(13)
         NTVACC = MIN (NINTRN, MAX (NTVDEV, IOBLK(64)))
         NTKACC = MIN (NINTRN, MAX (NTKDEV, IOBLK(65)))
         UCTSIZ = IOBLK(66)
         USELIM = IOBLK(67)
         NCHPRT = IOBLK(68)
         KAP2WD = IOBLK(69)
         NSHORT = IOBLK(70)
C                                       Reset DEVTAB array values.
         CALL COPY (50, IOBLK(14), DEVTAB)
C                                       Reset floating-point parameters.
         XPRDMM = ROBLK(71)
         XTKDMM = ROBLK(72)
         CALL H2CHR (20, 1, ROBLK(73), SYSNAM)
         CALL RCOPY (15, ROBLK(78), TIMEDA)
         TIMESG = ROBLK(93)
         TIMEMS = ROBLK(94)
         TIMESC = ROBLK(95)
         TIMECA = ROBLK(96)
         CALL RCOPY (4, ROBLK(97), TIMEBA)
         CALL RCOPY (3, ROBLK(101), TIMEAP)
C                                       set disk table
         CALL COPY (120, IOBLK(104), DASSGN)
C                                       Graphics device
         MAXXTK(1) = IOBLK(224)
         MAXXTK(2) = IOBLK(225)
         CSIZTK(1) = IOBLK(226)
         CSIZTK(2) = IOBLK(227)
         PRDELE = IOBLK(228)
         CALL RCOPY (3, ROBLK(229), QWHRT1)
         CALL RCOPY (3, ROBLK(232), QWHRT2)
         CALL RCOPY (3, ROBLK(235), QWHRT3)
         CALL COPY (NDCHD, IOBLK(257-NDCHD), DCHDUM)
         CALL ACINIT (TSKNAM, SYSNAM, NBPS, PRDELE, IERR)
         IERR = 0
C                                       Close system parameter file.
 970     CALL ZCLOSE (SPLUN, SPIND, JERR)
C                                       Disk error.  Print warning.
 980     IF (IERR.NE.0) THEN
            WRITE (ERRTER,1980)
            WRITE (ERRTER,1981)
            END IF
C                                       MRC 91/May/22:
C                                       Check for NVOL logical.
         CALL ZTRLOG (4, 'NVOL', 80, TEXT, NDX, JERR)
         IF ((JERR.EQ.0) .AND. (TEXT.NE.' ')) THEN
C                                       Dynamic data disk allocation
            NDX = 1
            CALL GETNUM (TEXT, 80, NDX, DP)
            IF ((DP.GE.1D0) .AND. (DP.LE.35D0)) NVOL = NINT (DP)
C                                       Open  network sys. parm. file
            PNAME = 'NET0:NETSP'
            CALL ZTXOPN ('QRED', NETLUN, SPIND, PNAME, .FALSE., IERR)
            IF (IERR.NE.0) THEN
               MSGTXT = 'ZDCHIN: COULDN''T OPEN NETSP FILE, CONTINUING.'
               CALL MSGWRT (6)
               GO TO 995
               END IF
C                                       Read the whole file in.
            NENT = 0
            NEOF = .FALSE.
 981        IF (NEOF) GO TO 982
               CALL ZTXIO ('READ', NETLUN, SPIND, TEXT, IERR)
C                                       End-of-file.
               IF (IERR.EQ.2) THEN
                  IERR = 0
                  NEOF = .TRUE.
               ELSE IF (IERR.NE.0) THEN
                  MSGTXT = 'ZDCHIN: ERROR READING NETSP FILE, ' //
     *               'CONTINUING.'
                  CALL MSGWRT (6)
                  NEOF = .TRUE.
               ELSE IF ((TEXT(1:1).NE.'#') .AND. (TEXT.NE.' ')) THEN
                  NENT = NENT + 1
                  IF (NENT.GT.512) THEN
                     MSGTXT = 'ZDCHIN: TOO MANY ENTRIES IN NETSP;'
     *                   // ' ONLY READING FIRST 512'
                     CALL MSGWRT (6)
                     NEOF = .TRUE.
                  ELSE
                     CALL CHTRIM (TEXT, 80, TEXT, NDX)
                     NETSP(NENT) = TEXT
                     END IF
                  END IF
               GO TO 981
 982        CONTINUE
C                                       Close NETSP.
 984        CALL ZTXCLS (NETLUN, SPIND, IERR)
            DO 988 IVOL = 1,NVOL
C                                       Translate disk logical.
               DA0X = 'DA00'
               CALL ZEHEX (IVOL, 1, DA0X(4:4))
               CALL ZTRLOG (4, DA0X, 80, TEXT, NDX, IERR)
               IF ((IERR.NE.0) .OR. (TEXT.EQ.' ')) THEN
                  MSGTXT = 'ZDCHIN: ERROR TRANSLATING ' // DA0X //
     *               ', CONTINUING.'
                  CALL MSGWRT (6)
                  GO TO 988
                  END IF
C                                       Look for this disk in NETSP.
               CALL CHTRIM (TEXT, 80, TEXT, NDX)
               DO 985 IENT = 1,NENT
                  IF (NETSP(IENT)(1:NDX).EQ.TEXT(1:NDX)) GO TO 986
 985              CONTINUE
               MSGTXT = 'ZDCHIN: NO NETSP ENTRY FOR ' // DA0X // '!'
               CALL MSGWRT (6)
               GO TO 988
C                                       Get TIMDEST value.
 986           NDX = NDX + 1
               CALL GETNUM (NETSP(IENT), 80, NDX, DP)
               TIMEDA(IVOL) = DP
C                                       Get disk access values.
               DO 987 J = 1,8
                  CALL GETNUM (NETSP(IENT), 80, NDX, DP)
                  DASSGN(J,IVOL) = NINT(DP)
 987              CONTINUE
 988           CONTINUE
            END IF
C                                       GNU Copyleft statement must be
C                                       in binaries also
      ELSE
         IERR = 0
         LINE = GPLBRK(1) // GPLBRK(2)
         WRITE (ERRTER,1988) LINE
         CALL ZDATE (IDATE)
C                                       Should work until 2200 :-)
         IF (IDATE(1).LT.200) IDATE(1) = IDATE(1) + 1900
         WRITE (LINE,1300) GPLDAT, IDATE(1)
         WRITE (ERRTER,1988) LINE
         DO 991 J = 1,NGNU
            LINE = GPLTXT(1,J) // GPLTXT(2,J)
            WRITE (ERRTER,1988) LINE
 991        CONTINUE
         LINE = GPLBRK(1) // GPLBRK(2)
         WRITE (ERRTER,1988) LINE
         END IF
C
 995  KAP2WD = MIN (PKPWD2, KAP2WD)
      IF (KAP2WD.LE.0) KAP2WD = PKPWD2
C
 999  RETURN
C-----------------------------------------------------------------------
 1300 FORMAT (1X,A,I4)
 1980 FORMAT (' ZDCHIN: COULD NOT READ PARAMETER FILE')
 1981 FORMAT (' ZDCHIN: (USING MINIMUM SYSTEM CONFIGURATION)')
 1988 FORMAT (1X,A)
      END

      SUBROUTINE BLDSNM (ITASK, IPOPS, NAME, CLASS, IERR)
C-----------------------------------------------------------------------
C! builds a name for a scratch file
C# Utility, Header
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   BLDSNM builds a scratch file name
C   Inputs: ITASK   C*6       Task owning file
C           IPOPS   I         AIPS number of the task
C   Output: NAME    C*12      AIPS logical name
C           CLASS   C*6       AIPS logical class
C           IERR    I         0 => ok, 1 => ITASK > 5 chars
C-----------------------------------------------------------------------
      CHARACTER ITASK*6, NAME*12, CLASS*6
      INTEGER   IPOPS, IERR
C
      CHARACTER CTASK*6, SCNAME*12
      DATA SCNAME /'SCRATCH FILE'/
C-----------------------------------------------------------------------
      NAME = SCNAME
      CALL BLDTNM (ITASK, IPOPS, CTASK, IERR)
      CLASS = CTASK
C
 999  RETURN
      END

      SUBROUTINE ZTPMID (OPER, FIND, FCB, BUFF, NBYTES, IERR)
C-----------------------------------------------------------------------
C! pseudo-tape disk read/write for 2880-bytes records
C# Z2 Tape FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2001
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Low level sequential access, large record, double buffered
C   pseudo-tape disk I/O.  Actual implementation is often via Fortran
C   IO and hence is not actually done with quick return.
C
C   NOTE: This is for TAPIO type operations only, i.e., LRECL=2880,
C         FTAB(FIND+5) = I   logical record number.
C
C   Inputs:
C      OPER     C*4    Operation code "READ" or "WRIT"
C      FIND     I      Index in FTAB to file control block for LUN
C      FCB      I(*)   File control block for open map disk file and
C                      buffer involved
C      NBYTES   I      Number of 8-bit bytes to transfer: 0, 2880 okay
C   In/out:
C      BUFF     I(*)   I/O buffer
C   Output:
C      IERR     I      Error return code: 0 => no error
C                         FCB has syserr for ZTPWAD to return error
C   Generic version: (assumes that an INTEGER is 4 8-bit bytes)
C-----------------------------------------------------------------------
      CHARACTER OPER*4
      INTEGER   FIND, FCB(*), BUFF(720), NBYTES, IERR
C
      INTEGER   LUN, BLKNO, IOSVAL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
C-----------------------------------------------------------------------
      IERR = 0
      IOSVAL = 0
C                                       Record I/O request in the file
C                                       control block.
      FCB(1+FCBREQ) = NBYTES
C                                       Assume I/O transfer count as
C                                       I/O request since there is no
C                                       way to get it from Fortran I/O).
      FCB(1+FCBXFR) = NBYTES
C                                       Zero error status in the file
C                                       control block.
      FCB(1+FCBERR) = 0
C                                       Zero transfer request just
C                                       initializes double buffered I/O.
      IF (NBYTES.LE.0) GO TO 999
C                                       Extract logical record number
C                                       from the "map" file control
C                                       area.
      BLKNO = FTAB(FIND+5)
C                                       Extract the logical unit number
C                                       from FTAB.
      LUN = FTAB(FIND)
C                                       Wrong record length request
      IF (NBYTES.NE.2880) THEN
         IERR = 2
C                                       Read.
      ELSE IF (OPER.EQ.'READ') THEN
         READ (LUN,REC=BLKNO,IOSTAT=IOSVAL) BUFF
         FCB(1+FCBERR) = IOSVAL
C                                       Write.
      ELSE IF (OPER.EQ.'WRIT') THEN
         WRITE (LUN,REC=BLKNO,IOSTAT=IOSVAL) BUFF
         FCB(1+FCBERR) = IOSVAL
C                                       Invalid operation requested.
      ELSE
         IERR = 2
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'BLSUM.INC'
C                                                          Include BLSUM
      INCLUDE 'INCS:PMAD.INC'
C                                       Local include for BLSUM
      REAL      XSEQIN, XDISKI, XSEQ2N, XDIS2I, BLC(7), TRC(7), BCHAN,
     *   DOALIN, DOINVR, PRTLEV, DOCRT, DOSLIC, TVCHAN, RANGE(2), TXINC,
     *   TYINC, XNPLOT, FACTOR, XSYMB, XLTYPE, XYRATO, APARM(10),
     *   BADD(10)
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAM2I(3), XCLA2I(2), XTVFUN,
     *   XLPNAM(12), XOUFIL(12), XOPTYP
      CHARACTER NAMEIN*12, CLAIN*6, NAM2IN*12, CLA2IN*6, TVFUNC*4,
     *   LPNAME*48, OUTFIL*48, AUNITS(2)*8, OPTYPE*4
      DOUBLE PRECISION OLDD(128), CLPD(128), FRQS(MAXIMG)
      REAL      OLDR(256), CLPR(256), XBUFF1(MABFSS), XCEN(4), YCEN(4),
     *   PCEN(4)
      HOLLERITH OLDH(256), CLPH(256)
      INTEGER   BUFF1(MABFSS), CATOLD(256), CATCLP(256), SEQIN, SEQ2IN,
     *   DISKIN, DIS2IN, NEWCNO, OLDCNO, JBUFSZ, NAXSKP, BBLC(7),
     *   BTRC(7), LUNI1, LUNI2, INDI1, INDI2, TTYLUN, TTYIND, XCHRN(7),
     *   PRTLUN, PRTIND, LZOOM(3), PLTLUN, PLTIND, LINMAX, ITYPE,
     *   NPLOTS, LABEL, NPARM, NCTOT, NCPER, ISYM, OFFCH
      LOGICAL   ISFQID
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XNAM2I, XCLA2I,
     *   XSEQ2N, XDIS2I, BLC, TRC, BCHAN, DOALIN, DOINVR, PRTLEV,
     *   DOCRT, XLPNAM, XOUFIL, DOSLIC, TVCHAN, RANGE, XTVFUN, TXINC,
     *   TYINC, XNPLOT, FACTOR, XSYMB, XLTYPE, XYRATO, XOPTYP, APARM,
     *   BADD
      COMMON /BLSCHR/ NAMEIN, CLAIN, NAM2IN, CLA2IN, TVFUNC, LPNAME,
     *   OUTFIL, AUNITS, OPTYPE
      COMMON /PARMS/ FRQS, CATOLD, SEQIN, SEQ2IN, DISKIN, DIS2IN,
     *   NEWCNO, OLDCNO, JBUFSZ, NAXSKP, BBLC, BTRC, LUNI1, LUNI2,
     *   INDI1, INDI2, TTYLUN, TTYIND, XCHRN, PRTLUN, PRTIND, LZOOM,
     *   PLTLUN, PLTIND, LINMAX, ITYPE, ISFQID, NPLOTS, LABEL, NPARM,
     *   NCTOT, NCPER, ISYM, OFFCH, XCEN, YCEN, PCEN
      EQUIVALENCE (XBUFF1, BUFF1)
      COMMON /IMBUF/ BUFF1
      COMMON /MAPHDR/ CATCLP
      EQUIVALENCE (CATOLD, OLDH, OLDR, OLDD)
      EQUIVALENCE (CATCLP, CLPH, CLPR, CLPD)
C                                                          End BLSUM.
LOCAL END
      PROGRAM BLSUM
C-----------------------------------------------------------------------
C! Sums images over blotch regions
C# Map TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998-2000, 2004, 2007-2010, 2012-2015,
C;  Copyright (C) 2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BLSUM sums images over blotch regions.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      IN2NAME                      Name of blotch image: ' ' => #1
C      IN2CLASS
C      IN2SEQ
C      IN2DISK
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      BCHAN          BCHAN         First channel with signal, Plane in
C                                   INNAME to use for blotch iff IN2NAME
C                                   blank.
C      DOALIGN                      How to line up 2 images
C      PRTLEV                       > 0 => print pixel locations
C                                   >= 2 printer plot
C      DOCRT                        >0 => use CRT not line printer
C      OUTPRINT       LPNAME        File to save printer output in
C      TVCHAN                       TV channel to use
C      PIXRANGE                     Min,Max of image intensity
C                                   Max <= Min => entire range
C      FUNCTYPE                     TV load transfer function type
C      TXINC                        X increment in TV loads
C      TYINC                        Y increment in TV loads
C      BADDISK                      Disks to avoid for scratch.
C   Programmer Eric W. Greisen:  March 1984
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, NWORDS, BLITCH(2)
      LONGINT   PBLOT, PSPEC, PWT
      REAL      BLOTCH(2), SPEC(2), WEIGHT(2)
      EQUIVALENCE (BLOTCH, BLITCH)
      INCLUDE 'BLSUM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'BLSUM '/
C-----------------------------------------------------------------------
C                                       Get input parameters, open up
      CALL BLSMIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       get memory for blotch plane
      NWORDS = (XCHRN(1) * XCHRN(2) - 1) / 1024 + 4
      CALL ZMEMRY ('GET ', PRGM, NWORDS, BLOTCH, PBLOT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'CANNOT GET DYNAMIC MEMORY FOR BLOTCH PLANE'
         CALL MSGWRT (8)
         GO TO 990
         END IF
      CALL ZMEMRY ('GET ', PRGM, NWORDS, WEIGHT, PWT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'CANNOT GET DYNAMIC MEMORY FOR WEIGHT PLANE'
         CALL MSGWRT (8)
         GO TO 990
         END IF
      NWORDS = (5 * NCTOT - 1) / 1024 + 4
      CALL ZMEMRY ('GET ', PRGM, NWORDS, SPEC, PSPEC, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'CANNOT GET DYNAMIC MEMORY FOR SPECTRA'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       Call routine that sends data
C                                       to the summing routine
      CALL BLSMTV (XCHRN(1), XCHRN(2), BLITCH(1+PBLOT), NCTOT,
     *   WEIGHT(1+PWT), SPEC(1+PSPEC), SPEC(1+NCTOT+PSPEC), IRET)
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE BLSMIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   BLSMIN gets input parameters for BLSUM and creates an output file
C   IF requested for the residual map.
C   Inputs:  PRGN    C*6      Program name
C   Output:  IRET    I         Error code: 0 => ok
C                                4 => user routine detected error.
C                                5 => catalog troubles
C                                8 => can't start
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   IRET
C
      CHARACTER IFILE*48, STAT*4, MTYPE*2, CTEMP*8
      INTEGER   IERR, IROUND, I, NA(2), NPL, J, K, KA, NX1, NX2, NFQ,
     *   ORDER, NZI
      REAL      EPS, AXV
      DOUBLE PRECISION DAXV
      LOGICAL   T, F, EQUAL
      INCLUDE 'BLSUM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 90
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
         CALL MSGWRT (8)
         END IF
C                                       Using the TV
      IF ((NPOPS.GT.NINTRN) .OR. (NTVDEV.LE.0)) THEN
         MSGTXT = 'THERE IS NO TV ASSIGNED TO YOUR AIPS'
         CALL MSGWRT (8)
         IRET = 8
         END IF
C                                       Restart AIPS
      RQUICK = RQUICK .AND. (DOCRT.LT.0.0)
      IF ((RQUICK) .AND. (IRET.NE.0)) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      DISKIN = IROUND (XDISKI)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAM2I, NAM2IN)
      CALL H2CHR (6, 1, XCLA2I, CLA2IN)
      CALL H2CHR (4, 1, XTVFUN, TVFUNC)
      CALL H2CHR (48, 1, XLPNAM, LPNAME)
      CALL H2CHR (48, 1, XOUFIL, OUTFIL)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      IF ((OPTYPE.NE.'WEIG') .AND. (OPTYPE.NE.'WEI2')) OPTYPE = ' '
      CALL CHR2H (4, OPTYPE, 1, XOPTYP)
      DO 25 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 25      CONTINUE
      NPLOTS = ABS (XNPLOT) + 0.1
      NPLOTS = MAX (0, MIN (4, NPLOTS))
      LABEL = IROUND (XLTYPE)
      IF (MOD (ABS(LABEL),100).EQ.0) THEN
         IF (LABEL.GE.0) THEN
            LABEL = (LABEL/100)*100  + 3
         ELSE
            LABEL = (LABEL/100)*100  - 3
            END IF
         END IF
      IF (FACTOR.EQ.0.0) FACTOR = 1.0
      IF (XYRATO.EQ.0.0) XYRATO = 1.414
      XLTYPE = LABEL
      ISYM = XSYMB + 0.1
      ISYM = MAX (1, MIN (24, ISYM))
      XSYMB = ISYM
      LUNI1 = 16
      LUNI2 = 17
      TTYLUN = 5
      TTYIND = 0
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      STAT = 'READ'
      IF (DOSLIC.GT.0.0) STAT = 'WRIT'
      IF (NPLOTS.GT.0) STAT = 'WRIT'
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING INPUT IMAGE CATBLK'
         GO TO 990
         END IF
      NCFILE = 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      IF (STAT.EQ.'WRIT') FRW(NCFILE) = 1
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATOLD(KIDIM), CATOLD(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Second input file
      IF (NAM2IN.EQ.' ') THEN
         XDIS2I = XDISKI
         XSEQ2N = XSEQIN
         NAM2IN = NAMEIN
         CLA2IN = CLAIN
         END IF
      FRW(2) = -1
      NAXSKP = -1
      EPS = 0.2
      CALL FILL (7, 1, BBLC)
      CALL FILL (7, 1, BTRC)
C                                       Get CATBLK of 2nd old file.
      NEWCNO = 1
      DIS2IN = IROUND (XDIS2I)
      SEQ2IN = IROUND (XSEQ2N)
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DIS2IN, NEWCNO, NAM2IN, CLA2IN, SEQ2IN,
     *   MTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR, NAM2IN, CLA2IN, SEQ2IN, DIS2IN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DIS2IN, NEWCNO, CATCLP, 'READ', BUFF1, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.6) .AND. (IERR.NE.7)) THEN
         WRITE (MSGTXT,1000) IERR, 'READING BLOTCH IMAGE CATBLK'
         GO TO 990
         END IF
      NCFILE = 2
      FVOL(NCFILE) = DIS2IN
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 0
      XDIS2I = DIS2IN
      XSEQ2N = SEQ2IN
      CALL CHR2H (12, NAM2IN, 1, XNAM2I)
      CALL CHR2H (6, CLA2IN, 1, XCLA2I)
C                                       Decide IO pattern
      DO 65 I = 1,2
         NA(I) = 0
         K = KHCTP + (I-1) * 2
         DO 64 J = I,7
            CALL CHCOMP (8, 1, CLPH(K), 1, OLDH(KHCTP+(J-1)*2), EQUAL)
            IF (EQUAL) NA(I) = J
 64         CONTINUE
 65      CONTINUE
      NAXSKP = 0
      IF (DOALIN.LT.-1.5) GO TO 75
      IF ((NA(1).EQ.0) .OR. (NA(2).EQ.0)) GO TO 70
      IF ((NA(1).GT.2) .OR. (NA(2).GT.3)) GO TO 70
      IF (NA(2).LE.NA(1)) GO TO 70
         IF (NA(2).GT.2) NAXSKP = 2
         IF (NA(1).EQ.2) NAXSKP = 1
         GO TO 80
C                                       possible non-alignment
 70   IF (DOALIN.GT.-0.1) THEN
         MSGTXT = 'UNABLE TO ALIGN THE AXES - CHECK TRANSPOSITION'
         GO TO 990
         END IF
 75   NA(1) = 1
      NA(2) = 2
C                                       set corners, check alignment
 80   KA = 0
      IF (NAXSKP.GT.0) KA = 1
      NX1 = CATOLD(KIDIM)
      NX2 = CATCLP(KIDIM)
      DO 90 I = 1,7
         BBLC(I) = 1
         BTRC(I) = 1
         J = I - 1
         IF (CATCLP(KINAX+J).LT.1) CATCLP(KINAX+J) = 1
         IF ((I.LE.NX2) .AND. (I+KA.LE.NX1) .AND.
     *      (CATCLP(KINAX+J).GT.1)) THEN
            IF (I.LE.2) THEN
               K = NA(I) - 1
            ELSE
               K = I + KA - 1
               END IF
            AXV = CLPR(KRCRP+J) - OLDR(KRCRP+K) + BLC(K+1)
            IF (DOALIN.LT.-1.5) AXV = BLC(K+1)
            IF ((DOALIN.GT.-0.1) .AND. (CLPR(KRCIC+J).NE.0.0)) THEN
               DAXV = OLDD(KDCRV+K) + OLDR(KRCIC+K)*(BLC(K+1) -
     *            OLDR(KRCRP+K))
               AXV = (DAXV - CLPD(KDCRV+J)) / CLPR(KRCIC+J) +
     *            CLPR(KRCRP+J)
               END IF
            BBLC(I) = IROUND(AXV)
            BTRC(I) = BBLC(I) + TRC(K+1) - BLC(K+1) + EPS
            IF (BTRC(I).LT.1) GO TO 95
            IF (BBLC(I).GT.CATCLP(KINAX+J)) GO TO 95
C                                       smaller subim needed?
            IF (BBLC(I).LT.1) THEN
               BLC(K+1) = BLC(K+1) + 1 - BBLC(I)
               AXV = AXV + 1 - BBLC(I)
               BBLC(I) = 1
               END IF
            IF (BTRC(I).GT.CATCLP(KINAX+J)) THEN
               TRC(K+1) = TRC(K+1) + CATCLP(KINAX+J) - BTRC(I)
               BTRC(I) = CATCLP(KINAX+J)
               END IF
            IF (BTRC(I).LT.BBLC(I)) GO TO 95
            IF (BLC(K+1).GT.CATOLD(KINAX+K)) GO TO 95
            IF (TRC(K+1).LT.1) GO TO 95
C                                       full alignment check
            IF (DOALIN.GE.0.1) THEN
               IF (ABS(BBLC(I)-AXV).GT.EPS) GO TO 95
               CALL CHCOMP (8, 1, CLPH(KHCTP+J*2), 1, OLDH(KHCTP+K*2),
     *            EQUAL)
               IF (.NOT.EQUAL) GO TO 95
               AXV = EPS * EPS * ABS(OLDR(KRCIC+K))
               IF (ABS(OLDR(KRCIC+K)-CLPR(KRCIC+J)).GT.AXV) GO TO 95
               IF (ABS(OLDR(KRCRT+K)-CLPR(KRCRT+J)).GT.1.0) GO TO 95
               END IF
            END IF
 90      CONTINUE
      GO TO 100
C                                       Failure to align
 95   CONTINUE
         MSGTXT = 'INPUT AND BLOTCH IMAGES DO NOT OVERLAP:' //
     *   ' CHECK HEADERS'
         GO TO 990
C                                       OK : which plane for blotch
 100  NPL = 1
      DO 105 I = 3,NX2
         NPL = NPL * CATCLP(KINAX+I-1)
 105     CONTINUE
      IF (BCHAN.LT.1) BCHAN = 1
      IF (BCHAN.GT.NPL) BCHAN = NPL
      J = BCHAN + 0.01
      CALL FILL (7, 1, XCHRN)
      XCHRN(1) = CATCLP(KINAX)
      XCHRN(2) = CATCLP(KINAX+1)
      IF (J.GT.1) THEN
         DO 120 I = 3,NX2
            XCHRN(I) = MOD (J-1, CATCLP(KINAX+I-1)) + 1
            J = (J - XCHRN(I)) / CATCLP(KINAX+I-1) + 1
 120        CONTINUE
         END IF
C                                       Open files: main image
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI1, INDI1, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT IMAGE FILE'
         GO TO 990
         END IF
C                                       Open blotch image
      CALL ZPHFIL ('MA', DIS2IN, FCNO(2), 1, IFILE, IRET)
      CALL ZOPEN (LUNI2, INDI2, DIS2IN, IFILE, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT BLOTCH FILE'
         GO TO 990
         END IF
C                                       Open plot file
      IF (OUTFIL.NE.' ') THEN
         PLTLUN = 11
         CALL ZTXOPN ('WRIT', PLTLUN, PLTIND, OUTFIL, .FALSE., IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'UNABLE TO OPEN PLOT OUTPUT: TURNING IT OFF'
            CALL MSGWRT (8)
            OUTFIL = ' '
            END IF
         END IF
C                                       Open line printer
      IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
      IF (DOCRT.NE.0.0) THEN
         CALL LPOPEN (LPNAME, DOCRT, PRTLUN, PRTIND, LINMAX, BUFF1,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING LINE PRINTER'
            CALL MSGWRT (8)
            DOCRT = 1.0
            IRET = 0
            END IF
         END IF
C                                       FQID axis?
      I = NAXSKP
      IF (I.EQ.0) I = 3
      CALL H2CHR (8, 1, OLDH(KHCTP+2*(I-1)), CTEMP)
      ISFQID = CTEMP.EQ.'FQID'
      IF (ISFQID) THEN
         CALL FRQGET (DISKIN, OLDCNO, NFQ, ORDER, FRQS, IRET)
         IF ((IRET.NE.0) .OR. (ABS(ORDER).NE.1)) THEN
            MSGTXT = 'FQID AXIS NOT CHANGED TO FREQUENCIES'
            CALL MSGWRT (7)
            ISFQID = .FALSE.
         ELSE
            NZI = TRC(I) - BLC(I) + 1.1
            J = BLC(I) - 0.5
            DO 210 I = 1,NZI
               FRQS(I) = FRQS(I+J)
 210           CONTINUE
            END IF
         END IF
C                                       total number plotted pixels
      IF (NAXSKP.GT.0) THEN
         NCPER = TRC(NAXSKP) - BLC(NAXSKP) + 1.01
      ELSE
         NCPER = TRC(3) - BLC(3) + 1.01
         END IF
      NCTOT = NCPER
      DO 220 I = 4,7
         J = TRC(I) - BLC(I) + 1.01
         NCTOT = NCTOT * MAX (J, 1)
 220     CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BLSMIN: ERROR',I3,1X,A)
 1020 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I2,' USID=',I5)
      END
      SUBROUTINE BLSMTV (NX, NY, BLOTCH, NC, WEIGHT, SPCTRM, SPCTRA,
     *   IRET)
C-----------------------------------------------------------------------
C   BLSMTV sends image one row at a time to the blanking routine and
C   then writes the modified data.  For the TV opcode only.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NX, NY, BLOTCH(NX,NY), NC, IRET
      REAL      SPCTRM(*), WEIGHT(NX,NY), SPCTRA(NC,*)
C
      CHARACTER OFF*4, TITL1*132, TITL2*132, ALINE*132, PSCR*132, ON*4,
     *   CEYE*2, CPLUS*2, CAST*2, JYB*8, LLCHAR(5)*4, MMCHAR(5)*4,
     *   BUNITS*8, CCHAR*4, PLINE*132, CTEMP*18, ATIME*8, ADATE*12,
     *   CUNITS*8, CUNITU*8, BUNITU*8
      INTEGER   ZOR, IBLVAL, OFF3, WINI(4), I, J, K, LIM2, LIM3, LIM4,
     *   LIM5, BOI, LIM6, LIM7, NPOLY, IG, IBIND, MV, LIM1, NVERT(40),
     *   NF, NXF, NYF, NXT, NYT, JBUFS4, IERR, XLO, XHI, YLO, LINC(2),
     *   WINT(4,64), WINX(4), IROUND, TVPLAN, ICHAN, XV(400), YV(400),
     *   WINI2(4), IXL(15), IXU(15), WINBL(4), LLV, LNX, LPOLY, IX, IY,
     *   J1, J2, JG1, JG2, JJ, I1L, I2L, I1U, I2U, IG2, NXI2, NYI2, IS,
     *   I1, I2, I3, I4, I5, I6, I7, IV, NXI, NYI, CORN(7), IS0, BLNUM,
     *   LINCNT, NM, IPAGE, XPIX, NCHAR, ID(3), IT(3), PLAX, ITRIM, YHI,
     *   JX, JY, IPLOTS, BLNUMS(4), WCOUNT
      REAL      XP, YP, XXCHAR, AREAT, CSUM, V, SMIN, SMAX, AREAB,
     *   WSUM, W2SUM, WT
      DOUBLE PRECISION XSUM, YSUM, VSUM, XCENT, YCENT, PSUM, PDIV
      LOGICAL   T, F
      INCLUDE 'BLSUM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      DATA CEYE, CPLUS, CAST /'II', '++', '**'/
      DATA JYB /'JY/BEAM '/
      DATA OFF, ON /'OFFF', 'ONNN'/
      DATA LLCHAR, MMCHAR /'LL  ','RA  ','RA--','GLON','ELON',
     *   'MM  ','DEC ','DEC-','GLAT','ELAT'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open TV
      CALL TVOPEN (BUFF1, IRET)
      IF (IRET.NE.0) GO TO 995
      IPLOTS = 0
C                                       init display
      LINCNT = 999
      IPAGE = 0
      WRITE (TITL1,1010) NAMEIN, CLAIN, SEQIN
      WRITE (TITL2,1011) NAM2IN, CLA2IN, SEQ2IN, (XCHRN(I), I = 3,7)
      IF (DOCRT.LE.-2.5) THEN
         CALL PRTLIN (PRTLUN, PRTIND, DOCRT, LINMAX, TITL1, TITL2,
     *      TITL1, LINCNT, IPAGE, PSCR, IRET)
         IF (IRET.NE.0) GO TO 990
         CALL PRTLIN (PRTLUN, PRTIND, DOCRT, LINMAX, TITL1, TITL2,
     *      TITL2, LINCNT, IPAGE, PSCR, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
      IF (NGRAPH.LE.0) THEN
         IRET = 1
         MSGTXT = 'BLSUM REQUIRES THE TV TO HAVE A GRAPHICS PLANE'
         GO TO 980
         END IF
C                                       Open terminal
      IF (DOCRT.LE.0) THEN
         CALL ZOPEN (TTYLUN, TTYIND, 1, MSGTXT, F, T, T, IRET)
         IF (IRET.NE.0) THEN
            TTYIND = 0
            WRITE (MSGTXT,1000) IRET, 'OPENING USER TERMINAL'
            GO TO 980
            END IF
      ELSE
         TTYLUN = PRTLUN
         TTYIND = PRTIND
         END IF
      JBUFS4 = JBUFSZ
      IBLVAL = 0
      IF (DOINVR.GT.0.0) IBLVAL = 1
C                                       Setup for I/O
      NXI2 = CATCLP(KINAX)
      NYI2 = CATCLP(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
      WINI2(1) = BBLC(1)
      WINI2(2) = BBLC(2)
      WINI2(3) = BTRC(1)
      WINI2(4) = BTRC(2)
C                                       TV windows
      LINC(1) = TXINC + 0.01
      LINC(2) = TYINC + 0.01
      LINC(1) = MAX (1, LINC(1))
      LINC(2) = MAX (1, LINC(2))
      TXINC = LINC(1)
      TYINC = LINC(2)
      NXT = (BTRC(1) - BBLC(1)) / TXINC + 1.0001
      NYT = (BTRC(2) - BBLC(2)) / TYINC + 1.0001
      NXF = (NXT - 1) / MAXXTV(1) + 1
      NYF = (NYT - 1) / MAXXTV(2) + 1
      NF = NXF * NYF
      XP = 0.0
      IF (NXF.GT.1) XP = ((NXT-1)*TXINC + 1 - TXINC*MAXXTV(1)) /
     *   (NXF - 1.0)
      YP = 0.0
      IF (NYF.GT.1) YP = ((NYT-1)*TYINC + 1 - TYINC*MAXXTV(2)) /
     *   (NYF - 1.0)
      K = 0
      DO 15 I = 1,NYF
         DO 10 J = 1,NXF
            K = K + 1
            WINT(1,K) = BBLC(1) + XP * (J-1)
            WINT(2,K) = BBLC(2) + YP * (I-1)
            IF (NXF.GT.1) WINT(3,K) = WINT(1,K) + MAXXTV(1)*LINC(1) - 1
            IF (NXF.EQ.1) WINT(3,K) = WINT(1,K) + BTRC(1) - BBLC(1)
     *         + 0.01
            IF (NYF.GT.1) WINT(4,K) = WINT(2,K) + MAXXTV(2)*LINC(2) - 1
            IF (NYF.EQ.1) WINT(4,K) = BTRC(2) + 0.01
 10         CONTINUE
 15      CONTINUE
      WINX(1) = (MAXXTV(1) - (WINT(3,1)-WINT(1,1)) / LINC(1) + 1) / 2
      WINX(2) = (MAXXTV(2) - (WINT(4,1)-WINT(2,1)) / LINC(2) + 1) / 2
      WINX(3) = WINX(1) + (WINT(3,1) - WINT(1,1)) / LINC(1)
      WINX(4) = WINX(2) + (WINT(4,1) - WINT(2,1)) / LINC(2)
C                                       other TV parms
      ICHAN = TVCHAN + 0.01
      IF ((ICHAN.LT.1) .OR. (ICHAN.GT.NGRAY)) ICHAN = 1
      TVPLAN = 2 ** (ICHAN-1)
      IG = MIN (3, NGRAPH)
      IG2 = MAX (IG-1, 1)
      CALL RNGSET (RANGE, CLPR(KRDMX), CLPR(KRDMN), CLPR(IRRAN))
      CALL CHR2H (2, TVFUNC(1:2), 1, CLPH(IITRA))
      CATCLP(IICNO) = FCNO(2)
      CATCLP(IIVOL) = FVOL(2)
C                                       Init the TV
      JG1 = IG + NGRAY
      JG2 = IG2 + NGRAY
      CALL MOVIST (OFF, TVPLAN, 0, 0, 0, IERR)
      CALL YCINIT (ICHAN, BUFF1)
      CALL YCINIT (JG1, BUFF1)
      CALL YZERO (ICHAN, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL YZERO (JG1, IERR)
      IF (IERR.NE.0) GO TO 900
      IF (JG2.NE.JG1) CALL YZERO (JG2, IERR)
      IF (IERR.NE.0) GO TO 900
      J = NGRAY + NGRAPH
      DO 20 K = 1,J
         CALL YSLECT (OFF, K, 0, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 900
 20      CONTINUE
      CALL YSLECT (ON, JG1, 0, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 900
      IF (JG1.NE.JG2) CALL YSLECT (ON, JG2, 0, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL YSLECT (ON, ICHAN, 0, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 900
      I = 2 ** NGRAY
      I = ZOR (I, TVPLAN)
      CALL YSCROL (I, 0, 0, F, IERR)
      IF (IERR.NE.0) GO TO 900
      TVZOOM(1) = 0
      TVZOOM(2) = MAXXTV(1) / 2
      TVZOOM(3) = MAXXTV(2) / 2
      CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), F, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL COPY (3, TVZOOM, LZOOM)
C                                       Setup for looping
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
      NPOLY = 0
      MV = 0
      CALL FILL (40, 0, NVERT)
      CALL COPY (5, XCHRN(3), CATCLP(IIDEP))
      BLNUM = 0
      APARM(3) = MAX (0.0, APARM(3))
C                                       read blotch image into ram
      WINBL(1) = 1
      WINBL(2) = 1
      WINBL(3) = NXI2
      WINBL(4) = NYI2
      CALL COMOFF (CATCLP(KIDIM), CATCLP(KINAX), XCHRN(3), BOI, IRET)
      BOI = BOI + 1
      CALL MINIT ('READ', LUNI2, INDI2, NXI2, NYI2, WINBL, BUFF1,
     *   JBUFSZ, BOI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1175) IRET
         GO TO 980
         END IF
C                                       loop over rows
      DO 30 IY = 1,NYI2
         CALL MDISK ('READ', LUNI2, INDI2, BUFF1, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1185) IRET
            GO TO 980
            END IF
         CALL RCOPY (NXI2, XBUFF1(IBIND), WEIGHT(1,IY))
 30      CONTINUE
C                                       SUM loop point:
C                                       Find polygons
 50   CALL RFILL (NC, 0.0, SPCTRM)
      XSUM = 0.0D0
      YSUM = 0.0D0
      VSUM = 0.0D0
      PSUM = 0.0D0
      K = NX * NY
      CALL FILL (K, IBLVAL, BLOTCH)
      LINCNT = 999
      BLNUM = BLNUM + 1
      LPOLY = NPOLY
      LLV = MV
      NPOLY = 0
      DO 60 K = 1,NF
         IF (NF.GT.1) THEN
            WRITE (MSGTXT,1051) WINT(1,K), WINT(3,K), WINT(2,K),
     *         WINT(4,K)
            CALL MSGWRT (1)
            END IF
         IF ((NF.GT.1) .OR. (BLNUM.LE.1)) THEN
            CALL TVLOAD (LUNI2, INDI2, ICHAN, LINC, WINX, WINT(1,K),
     *         JBUFS4, XBUFF1, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'LOADING IMAGE ON TV'
               GO TO 980
               END IF
            END IF
         CALL BLSTVF (IG, IG2, TVPLAN, LINC, TTYLUN, TTYIND, LPOLY,
     *      NPOLY, NVERT, XV, YV, LZOOM, BUFF1, IRET)
         IF ((IRET.EQ.99) .AND. (BLNUM.GT.1)) GO TO 800
         IF (IRET.NE.0) GO TO 990
 60      CONTINUE
C                                       new polygons
      IF (NPOLY.GT.0) THEN
C                                       set limits
         NPOLY = NPOLY + LPOLY
         LPOLY = LPOLY + 1
         LLV = LLV + 1
         MV = 0
         DO 65 I = 1,NPOLY
            MV = MV + NVERT(I)
 65         CONTINUE
         I1L = MABFSS
         I2L = MABFSS
         I1U = 1
         I2U = 1
         DO 70 I = LLV,MV
            I1L = MIN (I1L, XV(I))
            I1U = MAX (I1U, XV(I))
            I2L = MIN (I2L, YV(I))
            I2U = MAX (I2U, YV(I))
 70         CONTINUE
         DO 165 IY = 1,NYI2
            LNX = 0
            IF (IY.LE.I2U) CALL BLTLIS (LPOLY, LLV, NPOLY, NVERT, XV,
     *         YV, IY, LNX,IXL, IXU)
            IF ((IY.GE.I2L) .AND. (IY.LE.I2U) .AND. (LNX.GT.0)) THEN
C                                       loop over row
               IF ((PRTLEV.GT.1.05) .AND. (DOCRT.NE.0.0)) THEN
                  J2 = 0
 146              J1 = J2 + 1
                  IF (J1.LE.LNX) THEN
                     J2 = (LINMAX - 21) / 14 - 1
                     J2 = MIN (LNX, J1+J2)
                     IF (DOINVR.LE.0.0) WRITE (ALINE,1146) IY,
     *                  (IXL(I), IXU(I), I=J1,J2)
                     IF (DOINVR.GT.0.0) WRITE (ALINE,1147) IY,
     *                  (IXL(I), IXU(I), I=J1,J2)
                     CALL PRTLIN (PRTLUN, PRTIND, DOCRT, LINMAX, TITL1,
     *                  TITL2, ALINE, LINCNT, IPAGE, PSCR, IRET)
                     IF (IRET.NE.0) GO TO 990
                     GO TO 146
                     END IF
                  END IF
C                                       Inside a blotch?
               DO 160 IX = I1L,I1U
                  DO 150 I = 1,LNX
C                                       Add it in
                     IF ((IX.GE.IXL(I)). AND. (IX.LE.IXU(I))) THEN
                        BLOTCH(IX,IY) = 1 - IBLVAL
                        GO TO 160
                        END IF
 150                 CONTINUE
 160              CONTINUE
               END IF
 165        CONTINUE
C                                       Apply to clip image
C                                       Range sum outside:
         IF (DOINVR.GT.0.0) THEN
            I1L = BBLC(1)
            I2L = BBLC(2)
            I1U = BTRC(1)
            I2U = BTRC(2)
            END IF
         WINBL(1) = I1L
         WINBL(2) = I2L
         WINBL(3) = I1U
         WINBL(4) = I2U
         XPIX = 0
         CSUM = 0.0
         WSUM = 0.0
         W2SUM = 0.0
         WCOUNT = 0
C                                       loop over rows
         DO 210 IY = I2L,I2U
            DO 205 IX = I1L,I1U
               IF (BLOTCH(IX,IY).NE.0) THEN
                  IF (WEIGHT(IX,IY).NE.FBLANK) THEN
                     V = WEIGHT(IX,IY)
                     CSUM = CSUM + V
                     XPIX = XPIX + 1
                     IF (V.GE.APARM(3)) THEN
                        W2SUM = W2SUM + V * V
                        WSUM = WSUM + V
                        WCOUNT = WCOUNT + 1
                        END IF
                     END IF
                  END IF
 205           CONTINUE
 210        CONTINUE
         IF ((OPTYPE.NE.'WEIG') .AND. (OPTYPE.NE.'WEI2')) THEN
            WSUM = 1.0
            W2SUM = 1.0
         ELSE IF (WCOUNT.LE.0) THEN
            MSGTXT = 'NO BLOTCH PIXELS ABOVE WEIGHT CUTOFF'
            CALL MSGWRT (6)
            GO TO 50
         ELSE
            WSUM = WSUM / WCOUNT
            W2SUM = W2SUM / WCOUNT
            END IF
C                                       Output remarks: -> Jy
         CALL H2CHR (8, 1, OLDH(KHBUN), BUNITS)
         CALL H2CHR (8, 1, CLPH(KHBUN), CUNITS)
         CUNITU = CUNITS
         BUNITU = BUNITS
         CALL CHLTOU (8, BUNITU)
         CALL CHLTOU (8, CUNITU)
         J = CATOLD(KIDIM)
         J1 = 0
         J2 = 0
         DO 215 I = 1,J
            CALL H2CHR (4, 1, OLDH(KHCTP+(I-1)*2), CCHAR)
            DO 214 JJ = 1,5
               IF (CCHAR.EQ.LLCHAR(JJ)) J1 = I
               IF (CCHAR.EQ.MMCHAR(JJ)) J2 = I
 214           CONTINUE
 215        CONTINUE
         XXCHAR = 1.0
         IF ((J1.GT.0) .AND. (J2.GT.0)) XXCHAR = ABS (CLPR(KRCIC+J1-1)
     *      * CLPR(KRCIC+J2-1))
         AREAB = 0.0
         IF ((XXCHAR.NE.1.0) .AND. (CUNITU.EQ.JYB) .AND.
     *      (CATCLP(KINIT).GT.0)) AREAB =
     *      1.1331 * CLPR(KRBMJ) * CLPR(KRBMN)
         IF (AREAB.GT.0.0) THEN
            ITYPE = 1
         ELSE
            ITYPE = 2
            AREAB = 1.0
            END IF
         AREAB = AREAB / XXCHAR
         WRITE (MSGTXT,1215) 'Blotch', XPIX
         ALINE = MSGTXT
         IF (DOCRT.LE.0.0) CALL MSGWRT (5)
         IF (DOCRT.NE.0.0) THEN
            CALL PRTLIN (PRTLUN, PRTIND, DOCRT, LINMAX, TITL1, TITL2,
     *         ALINE, LINCNT, IPAGE, PSCR, IRET)
            IF (IRET.GT.0) GO TO 990
            END IF
         IF ((ITYPE.EQ.1) .AND. (CUNITU.EQ.BUNITU)) THEN
            CSUM = CSUM / AREAB
            WRITE (MSGTXT,1216) 'Blotch', CSUM, AREAB
            CUNITS = 'Jy'
            CUNITU = 'JY'
         ELSE
            WRITE (MSGTXT,1217) 'Blotch', CSUM, CUNITS
            END IF
         ALINE = MSGTXT
         IF (DOCRT.LE.0.0) CALL MSGWRT (5)
         IF (DOCRT.NE.0.0) THEN
            CALL PRTLIN (PRTLUN, PRTIND, DOCRT, LINMAX, TITL1, TITL2,
     *         ALINE, LINCNT, IPAGE, PSCR, IRET)
            IF (IRET.GT.0) GO TO 990
            END IF
         IF (OPTYPE(:3).EQ.'WEI') THEN
            IF (OPTYPE.EQ.'WEI2') THEN
               WRITE (MSGTXT,1214) 'Weight', WCOUNT
            ELSE
               WRITE (MSGTXT,1215) 'Weight', WCOUNT
               END IF
            ALINE = MSGTXT
            IF (DOCRT.LE.0.0) CALL MSGWRT (5)
            IF (DOCRT.NE.0.0) THEN
               CALL PRTLIN (PRTLUN, PRTIND, DOCRT, LINMAX, TITL1, TITL2,
     *            ALINE, LINCNT, IPAGE, PSCR, IRET)
               IF (IRET.GT.0) GO TO 990
               END IF
            CSUM = WSUM * WCOUNT
            IF ((ITYPE.EQ.1) .AND. (CUNITU.EQ.BUNITU)) THEN
               CSUM = CSUM / AREAB
               WRITE (MSGTXT,1216) 'Weight', CSUM, AREAB
               CUNITS = 'Jy'
               CUNITU = 'JY'
            ELSE
               WRITE (MSGTXT,1217) 'Weight', CSUM, CUNITS
               END IF
            ALINE = MSGTXT
            IF (DOCRT.LE.0.0) CALL MSGWRT (5)
            IF (DOCRT.NE.0.0) THEN
               CALL PRTLIN (PRTLUN, PRTIND, DOCRT, LINMAX, TITL1, TITL2,
     *            ALINE, LINCNT, IPAGE, PSCR, IRET)
               IF (IRET.GT.0) GO TO 990
               END IF
            END IF
C                                       units
         XXCHAR = 1.0
         IF ((J1.GT.0) .AND. (J2.GT.0)) XXCHAR = ABS (OLDR(KRCIC+J1-1)
     *      * OLDR(KRCIC+J2-1))
         AREAT = 0.0
         IF ((XXCHAR.NE.1.0) .AND. (BUNITU.EQ.JYB) .AND.
     *      (CATOLD(KINIT).GT.0)) AREAT =
     *      1.1331 * OLDR(KRBMJ) * OLDR(KRBMN)
         IF (AREAT.GT.0.0) THEN
            ITYPE = 1
            CUNITS = 'Jy'
            CUNITU = 'JY'
         ELSE
            ITYPE = 2
            AREAT = 1.0
            CUNITS = BUNITS
            CUNITU = BUNITU
            END IF
         AREAT = AREAT / XXCHAR
C                                       PLOTR ouput file
C                                       Title
         IF ((OUTFIL.NE.' ') .AND. (BLNUM.EQ.1)) THEN
            CALL H2CHR (18, 1, OLDH(KHIMN), CTEMP)
            ALINE = 'BLSUM ON'
            CALL NAMEST (CTEMP, CATOLD(KIIMS), ALINE(10:), NCHAR)
            NCHAR = NCHAR + 12
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            ALINE(NCHAR:) = ADATE // ' ' // ATIME
            NCHAR = ITRIM (ALINE)
            CALL ZTXIO ('WRIT', PLTLUN, PLTIND, ALINE(:NCHAR), IRET)
            IF (IRET.NE.0) OUTFIL = ' '
            END IF
C                                       Bottom line 1
         IF ((OUTFIL.NE.' ') .AND. (BLNUM.EQ.1)) THEN
            IF (ITYPE.EQ.1) THEN
               ALINE = 'Flux over selected area(s)'
            ELSE
               ALINE = 'Average brightness over selected area(s)'
               END IF
            NCHAR = ITRIM (ALINE)
            CALL ZTXIO ('WRIT', PLTLUN, PLTIND, ALINE(:NCHAR), IRET)
            IF (IRET.NE.0) OUTFIL = ' '
C                                       Bottom line 2
            ALINE = ' '
            NCHAR = 1
            CALL ZTXIO ('WRIT', PLTLUN, PLTIND, ALINE(:NCHAR), IRET)
            IF (IRET.NE.0) OUTFIL = ' '
C                                       Xaxis
            IF (NAXSKP.EQ.0) THEN
               PLAX = 2
            ELSE
               PLAX = NAXSKP-1
               END IF
            CALL H2CHR (8, 1, OLDH(KHCTP+2*PLAX), ALINE)
            NCHAR = ITRIM (ALINE)
            CALL ZTXIO ('WRIT', PLTLUN, PLTIND, ALINE(:NCHAR), IRET)
            IF (IRET.NE.0) OUTFIL = ' '
C                                       Yaxis
            ALINE = CUNITS
            NCHAR = ITRIM (ALINE)
            CALL ZTXIO ('WRIT', PLTLUN, PLTIND, ALINE(:NCHAR), IRET)
            IF (IRET.NE.0) OUTFIL = ' '
C                                       5 plot type labels
            DO 218 I = 1,5
               WRITE (ALINE,1218) I, I
               NCHAR = 15
               CALL ZTXIO ('WRIT', PLTLUN, PLTIND, ALINE(:NCHAR), IRET)
               IF (IRET.NE.0) OUTFIL = ' '
 218           CONTINUE
            END IF
C                                       prepare parms for main image
         IF (NAXSKP.GT.0) THEN
            OFF3 = BLC(3) + 0.01
            LIM3 = I2U - I2L + 1
            OFF3 = I2L + OFF3 - BBLC(2)
            IV = TRC(NAXSKP) - BLC(NAXSKP) + 1.01
            OFFCH = BLC(NAXSKP) - 0.99
         ELSE
            LIM3 = TRC(3) - BLC(3) + 1.01
            OFF3 = BLC(3) + 0.01
            IV = LIM3
            OFFCH = BLC(3) - 0.99
            END IF
         IS0 = -IV
C                                       read window: X Y V
         IF (NAXSKP.EQ.0) THEN
            WINI(1) = I1L + BLC(1) - BBLC(1) + 0.01
            WINI(2) = I2L + BLC(2) - BBLC(2) + 0.01
            WINI(3) = WINI(1) + I1U - I1L
            WINI(4) = WINI(2) + I2U - I2L
C                                       window V X Y
         ELSE IF (NAXSKP.EQ.1) THEN
            WINI(1) = BLC(1) + 0.01
            WINI(2) = I1L + BLC(2) - BBLC(1) + 0.01
            WINI(3) = TRC(1) + 0.01
            WINI(4) = WINI(2) + I1U - I1L
C                                       window X V Y
         ELSE
            WINI(1) = I1L + BLC(1) - BBLC(1) + 0.01
            WINI(2) = BLC(2) + 0.01
            WINI(3) = WINI(1) + I1U - I1L
            WINI(4) = TRC(2) + 0.01
            END IF
         NXI = CATOLD(KINAX)
         NYI = CATOLD(KINAX+1)
         LIM1 = WINI(3) - WINI(1) + 1
         LIM2 = WINI(4) - WINI(2) + 1
         XLO = 1000000
         XHI = -XLO
         YLO = XLO
         YHI = XHI
C                                       loop to read cube
         DO 700 I7 = 1,LIM7
            CORN(7) = BLC(7) + I7 - 0.99
            DO 600 I6 = 1,LIM6
               CORN(6) = BLC(6) + I6 - 0.99
               DO 500 I5 = 1,LIM5
                  CORN(5) = BLC(5) + I5 - 0.99
                  DO 400 I4 = 1,LIM4
                     CORN(4) = BLC(4) + I4 - 0.99
                     IS0 = IS0 + IV
            DO 390 I3 = 1,LIM3
               CORN(3) = I3 + OFF3 - 1
               IF ((DOCRT.LE.0.0) .AND. (MOD(I3,25).EQ.1)) THEN
                  WRITE (MSGTXT,1310) CORN(3)
                  CALL MSGWRT (1)
                  END IF
C                                       init cube
               CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), CORN(3), BOI,
     *            IRET)
               BOI = BOI + 1
               CALL MINIT ('READ', LUNI1, INDI1, NXI, NYI, WINI, BUFF1,
     *            JBUFSZ, BOI, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1320) IRET
                  GO TO 980
                  END IF
               DO 380 I2 = 1,LIM2
C                                       read cube
                  CALL MDISK ('READ', LUNI1, INDI1, BUFF1, IBIND, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1330) IRET
                     GO TO 980
                     END IF
C                                       V-x-y transpose special
                  IF (NAXSKP.EQ.1) THEN
                     IF (BLOTCH(I2,I3).EQ.1) THEN
                        XLO = MIN (XLO, I2)
                        XHI = MAX (XHI, I2)
                        YLO = MIN (YLO, I3)
                        YHI = MAX (YHI, I3)
                        IF (OPTYPE(:3).NE.'WEI') THEN
                           WT = 1.0
                        ELSE IF ((WEIGHT(I2,I3).GE.APARM(3)) .AND.
     *                     (WEIGHT(I2,I3).NE.FBLANK)) THEN
                           IF (OPTYPE.EQ.'WEI2') THEN
                              WT = (WEIGHT(I2,I3) ** 2) / W2SUM
                           ELSE
                              WT = WEIGHT(I2,I3) / WSUM
                              END IF
                        ELSE
                           WT = 0.0
                           END IF
                        IF (WT.GT.0.0) PSUM = PSUM + 1.0D0
                        DO 350 I1 = 1,LIM1
                           IF (XBUFF1(IBIND+I1-1).NE.FBLANK) THEN
                              V = XBUFF1(IBIND+I1-1) * WT
                              SPCTRM(IS0+I1) = SPCTRM(IS0+I1) + V
                              XSUM = XSUM + JX * V
                              YSUM = YSUM + JY * V
                              VSUM = VSUM + V
                              END IF
 350                       CONTINUE
                        END IF
C                                       Other 2 cases
                  ELSE
                     IF (NAXSKP.EQ.2) THEN
                        IS = I2 + IS0
                        JY = CORN(3)
                        PDIV = 1.0D0 / LIM2
                     ELSE
                        JY = WINI(2) - 1 + I2
                        IS = I3 + IS0
                        PDIV = 1.0D0 / LIM3
                        END IF
                     DO 370 I1 = 1,LIM1
                        JX = WINI(1) - 1 + I1
                        IF ((BLOTCH(JX,JY).EQ.1) .AND.
     *                     (XBUFF1(IBIND+I1-1).NE.FBLANK)) THEN
                           IF (OPTYPE(:3).NE.'WEI') THEN
                              WT = 1.0
                           ELSE IF ((WEIGHT(JX,JY).GE.APARM(3)) .AND.
     *                        (WEIGHT(JX,JY).NE.FBLANK)) THEN
                              IF (OPTYPE.EQ.'WEI2') THEN
                                 WT = (WEIGHT(JX,JY) ** 2) / W2SUM
                              ELSE
                                 WT = WEIGHT(JX,JY) / WSUM
                                 END IF
                           ELSE
                              WT = 0.0
                              END IF
                           IF (WT.GT.0.0) THEN
                              PSUM = PSUM + PDIV
                              XLO = MIN (XLO, I1)
                              XHI = MAX (XHI, I1)
                              IF (NAXSKP.EQ.2) THEN
                                 YLO = MIN (YLO, I3)
                                 YHI = MAX (YHI, I3)
                              ELSE
                                 YLO = MIN (YLO, I2)
                                 YHI = MAX (YHI, I2)
                                 END IF
                              V = XBUFF1(IBIND+I1-1) * WT
                              SPCTRM(IS) = SPCTRM(IS) + V
                              XSUM = XSUM + JX * V
                              YSUM = YSUM + JY * V
                              VSUM = VSUM + V
                              END IF
                           END IF
 370                    CONTINUE
                     END IF
 380              CONTINUE
 390           CONTINUE
 400                 CONTINUE
 500              CONTINUE
 600           CONTINUE
 700        CONTINUE
C                                       display results
         IF (VSUM.EQ.0.0D0) VSUM = 1.0D0
         XCENT = XSUM / VSUM
         YCENT = YSUM / VSUM
         IS0 = IS0 + IV
         LINCNT = 999
         WRITE (ALINE,1700) BLNUM
         IF (DOCRT.NE.0.0) THEN
            CALL PRTLIN (PRTLUN, PRTIND, DOCRT, LINMAX, TITL1, TITL2,
     *         ALINE, LINCNT, IPAGE, PSCR, IRET)
            IF (IRET.GT.0) GO TO 990
            END IF
         IF ((ITYPE.EQ.1) .AND. (CUNITU.EQ.'JY')) THEN
            WRITE (MSGTXT,1226) AREAT
         ELSE
            WRITE (MSGTXT,1227) BUNITS
            CUNITS = BUNITS
            CUNITU = BUNITU
            END IF
         ALINE = MSGTXT
         IF (DOCRT.LE.0.0) CALL MSGWRT (5)
         IF (DOCRT.NE.0.0) THEN
            CALL PRTLIN (PRTLUN, PRTIND, DOCRT, LINMAX, TITL1, TITL2,
     *         ALINE, LINCNT, IPAGE, PSCR, IRET)
            IF (IRET.GT.0) GO TO 990
            END IF
         WRITE (MSGTXT,1705) XCENT, YCENT, PSUM
         ALINE = MSGTXT
         IF (DOCRT.LE.0.0) CALL MSGWRT (5)
         IF (DOCRT.NE.0.0) THEN
            CALL PRTLIN (PRTLUN, PRTIND, DOCRT, LINMAX, TITL1, TITL2,
     *         ALINE, LINCNT, IPAGE, PSCR, IRET)
            IF (IRET.GT.0) GO TO 990
            END IF
C                                       Clean image
         XPIX = MAX (1, XPIX)
         DO 715 I = 1,IS0
            IF (ITYPE.EQ.1) THEN
               SPCTRM(I) = SPCTRM(I) / AREAT
               WRITE (ALINE,1710) I+OFFCH, SPCTRM(I)
            ELSE
               SPCTRM(I) = SPCTRM(I) / XPIX
               WRITE (ALINE,1711) I+OFFCH, SPCTRM(I), BUNITS
               END IF
            IF (DOCRT.NE.0.0) THEN
               CALL PRTLIN (PRTLUN, PRTIND, DOCRT, LINMAX, TITL1,
     *            TITL2, ALINE, LINCNT, IPAGE, PSCR, IRET)
               IF (IRET.GT.0) GO TO 990
               END IF
            IF (OUTFIL.NE.' ') THEN
               V = OLDD(KDCRV+PLAX) + (I-1.0+BLC(PLAX+1) -
     *            OLDR(KRCRP+PLAX)) * OLDR(KRCIC+PLAX)
               WRITE (ALINE,1715) V, SPCTRM(I), BLNUM
               NCHAR = ITRIM (ALINE)
               CALL ZTXIO ('WRIT', PLTLUN, PLTIND, ALINE(:NCHAR), IRET)
               IF (IRET.NE.0) OUTFIL = ' '
               END IF
 715        CONTINUE
         IF (NPLOTS.GT.0) THEN
            IPLOTS = IPLOTS + 1
            CALL RCOPY (NC, SPCTRM, SPCTRA(1,IPLOTS))
            BLNUMS(IPLOTS) = BLNUM
            IF (VSUM.EQ.0.0D0) VSUM = 1.0D0
            XCEN(IPLOTS) = XSUM / VSUM
            YCEN(IPLOTS) = YSUM / VSUM
            PCEN(IPLOTS) = PSUM
            END IF
C                                       units
         AUNITS(2) = CUNITS
         AUNITS(1) = 'PIXELS'
C                                       printer plot
         IF ((PRTLEV.GE.0.99) .AND. (IS0.GT.1)) THEN
            NM = 51
            IF (LINMAX.GE.119) NM = 101
            SMIN = 1.E15
            SMAX = -SMIN
            DO 750 I = 1,IS0
               IF (SPCTRM(I).NE.FBLANK) THEN
                  SMIN = MIN (SMIN, SPCTRM(I))
                  SMAX = MAX (SMAX, SPCTRM(I))
                  END IF
 750           CONTINUE
            IF ((SMIN.GE.0.0) .AND. (SMIN.LE.0.2*SMAX)) SMIN = 0.0
            LINCNT = 990
            WRITE (ALINE,1750) SMIN, SMAX, CUNITS
            IF (DOCRT.NE.0.0) THEN
               CALL PRTLIN (PRTLUN, PRTIND, DOCRT, LINMAX, TITL1, TITL2,
     *            ALINE, LINCNT, IPAGE, PSCR, IRET)
               IF (IRET.GT.0) GO TO 990
               END IF
            END IF
C                                       top bar
         IF ((PRTLEV.GE.0.99) .AND. (IS0.GT.1) .AND. (SMIN.LT.SMAX)
     *      .AND. (DOCRT.NE.0.0)) THEN
            DO 760 I = 1,NM,5
               PLINE(I:I+4) = '+----'
 760           CONTINUE
            WRITE (ALINE,1760) PLINE(1:NM)
            CALL PRTLIN (PRTLUN, PRTIND, DOCRT, LINMAX, TITL1, TITL2,
     *         ALINE, LINCNT, IPAGE, PSCR, IRET)
            IF (IRET.GT.0) GO TO 990
C                                       Plot
            DO 780 I = 1,IS0
               PLINE = ' '
               IF (MOD(I,10).EQ.0) THEN
                  DO 770 J = 1,NM,5
                     PLINE(J:J) = CPLUS
 770                 CONTINUE
                  END IF
               PLINE(1:1) = CEYE
               PLINE(NM:NM) = CEYE
               J = (SPCTRM(I) - SMIN) * (NM-1) / (SMAX - SMIN) + 0.5
               PLINE(J+1:J+1) = CAST
               IF (NM.EQ.51) WRITE (ALINE,1775) I+OFFCH, PLINE(1:NM),
     *            SPCTRM(I)
               IF (NM.EQ.101) WRITE (ALINE,1776) I+OFFCH, PLINE(1:NM),
     *            SPCTRM(I)
               CALL PRTLIN (PRTLUN, PRTIND, DOCRT, LINMAX, TITL1,
     *            TITL2, ALINE, LINCNT, IPAGE, PSCR, IRET)
               IF (IRET.GT.0) GO TO 990
 780           CONTINUE
C                                       bottom bar
            DO 785 I = 1,NM,5
               PLINE(I:I+4) = '+----'
 785           CONTINUE
            WRITE (ALINE,1760) PLINE(1:NM)
            CALL PRTLIN (PRTLUN, PRTIND, DOCRT, LINMAX, TITL1, TITL2,
     *         ALINE, LINCNT, IPAGE, PSCR, IRET)
            IF (IRET.GT.0) GO TO 990
            END IF
C                                       SL file
         IF ((DOSLIC.GT.0.0) .AND. (IS0.GT.1)) THEN
            IF (NAXSKP.EQ.0) THEN
               XLO = XLO + WINI(1) - 1
               XHI = XHI + WINI(1) - 1
               YLO = YLO + WINI(2) - 1
               YHI = YHI + WINI(2) - 1
            ELSE IF (NAXSKP.EQ.1) THEN
               XLO = XLO + WINI(2) - 1
               XHI = XHI + WINI(2) - 1
               YLO = YLO + OFF3 - 1
               YHI = YHI + OFF3 - 1
            ELSE
               XLO = XLO + WINI(1) - 1
               XHI = XHI + WINI(1) - 1
               YLO = YLO + OFF3 - 1
               YHI = YHI + OFF3 - 1
               END IF
            IF (NAXSKP.GT.0) THEN
               XLO = (XLO + XHI) / 2
               XHI = XLO
               YLO = (YLO + YHI) / 2
               YHI = YLO
               END IF
            CALL SLIBLS (IS0, SPCTRM, XLO, XHI, YLO, YHI, IRET)
            IF (IRET.GT.0) GO TO 990
            END IF
C                                       real plot
         IF ((NPLOTS.GT.0) .AND. (IPLOTS.EQ.NPLOTS)) THEN
            CALL PLTBLS (NC, IPLOTS, BLNUMS, SPCTRA, IRET)
            IF (IRET.GT.0) GO TO 990
            IPLOTS = 0
            CALL RFILL (4, 0.0, XCEN)
            CALL RFILL (4, 0.0, YCEN)
            CALL RFILL (4, 0.0, PCEN)
            END IF
C                                       loop for another sum
         GO TO 50
         END IF
C                                       Close files
 800  CALL ZCLOSE (LUNI1, INDI1, IRET)
      CALL ZCLOSE (LUNI2, INDI2, IRET)
      IF ((NPLOTS.GT.0) .AND. (IPLOTS.GT.0)) THEN
         CALL PLTBLS (NC, IPLOTS, BLNUMS, SPCTRA, IRET)
         IF (IRET.GT.0) GO TO 990
         IPLOTS = 0
         END IF
      IRET = 0
      GO TO 990
C                                       TV error
 900  IRET = 8
      WRITE (MSGTXT,1900) IERR
C                                       Error
 980  CALL MSGWRT (8)
C                                       close downs
 990  IF (TTYIND.GT.0) CALL ZCLOSE (TTYLUN, TTYIND, IERR)
      CALL TVCLOS (BUFF1, IERR)
      IF ((DOCRT.LT.0.0) .AND. (PRTIND.GT.0)) CALL LPCLOS (PRTLUN,
     *   PRTIND, LINCNT, IERR)
       IF ((OUTFIL.NE.' ') .OR. (PLTIND.GT.0)) CALL ZTXCLS (PLTLUN,
     *    PLTIND, IERR)
C                                       resume AIPS on error
 995  IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BLSMTV: ERROR',I3,1X,A)
 1010 FORMAT ('Summed image: ',A12,'.',A6,'.',I4)
 1011 FORMAT ('Blotch image: ',A12,'.',A6,'.',I4,' at depth',5I5)
 1051 FORMAT ('Begin subimage xpix =',I5,' -',I5,'  ypix =',I5,' -',I5)
 1146 FORMAT ('Row',I5,' include xpix',7(I5,' -',I5,2X))
 1147 FORMAT ('Row',I5,' exclude xpix',7(I5,' -',I5,2X))
 1175 FORMAT ('BLSMTV: MINIT (BLOTCH READ) ERROR',I3)
 1185 FORMAT ('BLSMTV: READ (BLOTCH) ERROR',I3)
 1214 FORMAT (A,' map summed over',I10,' pixels, using square',
     *   ' of values')
 1215 FORMAT (A,' map summed over',I10,' pixels')
 1216 FORMAT (A,' map flux',1PE13.5,' JY.  beam area',0PF7.2,
     *   ' pixels')
 1217 FORMAT (A,' map sum brightness',1PE13.5,' in ',A)
 1218 FORMAT ('SL',I2,' Blotch number',I2)
 1226 FORMAT ('Target map beam area',0PF7.2,' pixels')
 1227 FORMAT ('Blotch map brightnesses in ',A)
 1310 FORMAT ('Start summing plane',I6)
 1320 FORMAT ('BLSMTV: MINIT (CUBE READ) ERROR',I3)
 1330 FORMAT ('BLSMTV: READ (CUBE) ERROR',I3)
 1700 FORMAT ('Spectrum of blotch area(s)',I5,' :')
 1705 FORMAT ('Intensity weighted centroid',2F9.1,' in',F9.0,
     *   ' pixels')
 1710 FORMAT ('Channel',I5,' total flux',1PE12.4,'  Jy')
 1711 FORMAT ('Channel',I5,' average brightness',1PE12.4,1X,A)
 1715 FORMAT (2(1PE14.6),I4)
 1750 FORMAT ('Plot spectrum from',1PE12.4,' to',1PE12.4,1X,A)
 1760 FORMAT (6X,A)
 1775 FORMAT (I5,1X,A,1X,1PE12.4)
 1776 FORMAT (I5,1X,A,1X,1PE12.4)
 1900 FORMAT ('BLSMTV: TV ERROR CODE',I7)
      END
      SUBROUTINE BLSTVF (IG1, IG2, ICHAN, LINC, TTYLUN, TTYIND,  LPOLY,
     *   NPY, NV, XV, YV, LZOOM, SCRTCH, IRET)
C-----------------------------------------------------------------------
C   BLSTVF does the finding of the desired polygons
C   Inputs: IG1     I          Graphics plane to use: 1 - NGRAPH (new)
C           IG2     I          Graphics plane to use for former ones
C           ICHAN   I          Image plane (bit mask)
C           LINC    I(2)       TV load pixel increments (x,y)
C           TTYLUN  I          LUN of terminal opened for user comm.
C           TTYIND  I          FTAB pointer for terminal
C           LPOLY   I          Previous number of polygons
C   In/out: NPY     I          Number of polygons
C           NV      I(30)      Number of vertices in each polygon
C           XV      I(400)     X pixel position of each vertex wrt the
C                              original image
C           YV      I(400)     Y pixel pos of vertices wrt input image
C   Output: SCRTCH  I(>520)    scratch buffer
C           IRET    I          error code 0 ok, 1 TV, 2 TTY, 99 user
C-----------------------------------------------------------------------
      CHARACTER TEMP*4, ON*4, OFF*4
      INTEGER   IG1, IG2, ICHAN, LINC(2), TTYLUN, TTYIND, LPOLY, NPY,
     *   NV(30), XV(400), YV(400), SCRTCH(*), IRET, LZOOM(3)
      INTEGER   IB, IE, IE0, NPY0, I, J, CATBLK(256), IERR, JERR, IBO,
     *   ITW(3), QUAD, IBUT, ICH, LB, LE, IX(3), IY(3), ICH2, LIE0, LPY,
     *   INPY
      REAL      PPOS(2), RPOS(2), DLIM
      LOGICAL   T, F, DOIT
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMMON /MAPHDR/ CATBLK
      DATA T, F /.TRUE.,.FALSE./
      DATA ON,    OFF
     *   /'ONNN','OFFF'/
C-----------------------------------------------------------------------
      IRET = 1
      INPY = NPY
      NPY0 = NPY + LPOLY
      IE = 0
      IE0 = 0
      LIE0 = 1
C                                       Correct old ones to this subimg
      IF (NPY0.LE.0) GO TO 15
         DO 10 I = 1,NPY0
            IB = IE + 1
            IE = IB + NV(I) - 1
            IF (I.EQ.LPOLY) LIE0 = IE + 1
            DO 9 J = IB,IE
               XV(J) = (XV(J)-CATBLK(IIWIN)) / LINC(1) + CATBLK(IICOR)
               YV(J) = (YV(J)-CATBLK(IIWIN+1)) / LINC(2) +
     *            CATBLK(IICOR+1)
 9             CONTINUE
 10         CONTINUE
         IE0 = IE
C                                       clear graphics
 15   ICH = IG1 + NGRAY
      CALL YZERO (ICH, IERR)
      IF (IERR.NE.0) GO TO 900
      ICH2 = IG2 + NGRAY
      CALL YZERO (ICH2, IERR)
      NPY = INPY
      NPY0 = NPY + LPOLY
      IE = IE0
C                                       reset zoom
      CALL COPY (3, LZOOM, TVZOOM)
      CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), F, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       check window size
      CALL YWINDO ('READ', WINDTV, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       interactive zoom, enhance
      I = LUTOUT + 1
      CALL TVFIDL (ICHAN, I, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL COPY (3, TVZOOM, LZOOM)
C                                       fill current polygons
      IF (LPOLY.GT.0) CALL BLTFIL (LPOLY, NV, XV, YV, IG2, SCRTCH, IERR)
      IF (NPY.GT.0) CALL BLTFIL (NPY, NV(LPOLY+1), XV(LIE0), YV(LIE0),
     *   IG1, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL ZTIME (ITW)
      NPY0 = NPY0 + 1
      LPY = NPY + LPOLY
C                                       Start new polygon
 40   IF (LPY.GE.30) GO TO 800
      NPY = NPY + 1
      LPY = NPY + LPOLY
      IB = IE + 1
      IE = IB
      NV(LPY) = 0
      WRITE (MSGTXT,1040) NPY
      CALL MSGWRT (1)
      WRITE (MSGTXT,1041)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1042)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1043)
      CALL MSGWRT (1)
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
      RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2
C                                       No scroll correction
      QUAD = -1
C                                       ON cursor at desired position
      CALL YCURSE (ON, F, T, RPOS, QUAD, IBUT, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 900
      IF (IERR.EQ.2) CALL YCURSE (ON, F, F, RPOS, QUAD, IBUT, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Cursor read loop
 50   CALL YCURSE ('READ', T, T, RPOS, QUAD, IBUT, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF (.NOT.DOIT) GO TO 50
C                                       No button -> no action
         IF (IBUT.EQ.0) GO TO 50
C                                       Time to quit marking
         IF ((IBUT.LT.4) .OR. (IB.LT.IE)) GO TO 60
            NPY = NPY - 1
            LPY = LPY - 1
            GO TO 200
C                                       Mark new vertex
 60      NV(LPY) = NV(LPY) + 1
         XV(IE) = RPOS(1) + 0.01
         YV(IE) = RPOS(2) + 0.01
         XV(IE) = MAX (CATBLK(IICOR), MIN (CATBLK(IICOR+2), XV(IE)))
         YV(IE) = MAX (CATBLK(IICOR+1), MIN (CATBLK(IICOR+3), YV(IE)))
         IF (IB.EQ.IE) XV(IE+1) = XV(IE)
         IF (IB.EQ.IE) YV(IE+1) = YV(IE)
         I = MAX (IB, IE-1)
         IE = IE + 1
C                                       draw line
         CALL IMVECT (ON, ICH, 2, XV(I), YV(I), SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       done with polygon
         IF ((IBUT.LT.2) .AND. (IE.LT.400)) GO TO 50
            NV(LPY) = NV(LPY) + 1
            XV(IE) = XV(IB)
            YV(IE) = YV(IB)
C                                       draw line
            CALL IMVECT (ON, ICH, 2, XV(IE-1), YV(IE-1), SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
C                                       Respond further to buttons
         IF (IE.GE.400) GO TO 810
         IF (IBUT.LT.4) GO TO 40
C                                       Vertex correction area
         IF (IBUT.GE.8) GO TO 200
C                                       some already set box
C                                       wait for indication which
 100  WRITE (MSGTXT,1100)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1101)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1102)
      CALL MSGWRT (1)
      CALL YCURSE ('READ', T, T, RPOS, QUAD, IBUT, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       check button
      IF (IBUT.GE.8) GO TO 200
C                                       redraw polygons to be safe
 105  IF (IBUT.LT.4) GO TO 120
         LB = 1 + IE0
         DO 110 I = NPY0,LPY
            CALL IMVECT (ON, ICH, NV(I), XV(LB), YV(LB), SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            LB = LB + NV(I)
 110        CONTINUE
         GO TO 40
C                                       Find nearest corner
 120  DLIM = 0.5
 125  LB = 1 + IE0
      DO 135 I = NPY0,LPY
         LE = LB + NV(I) - 1
         DO 130 J = LB,LE
            IF ((ABS(RPOS(1)-XV(J)).LE.DLIM) .AND. (ABS(RPOS(2)
     *         -YV(J)).LE.DLIM)) GO TO 140
 130        CONTINUE
         LB = LE + 1
 135     CONTINUE
      DLIM = DLIM + 1.5
      IF (DLIM.LE.4.0) GO TO 125
      GO TO 100
C                                       Got one
 140  IF (J.EQ.LE) J = LB
      IBO = J
      RPOS(1) = XV(IBO)
      RPOS(2) = YV(IBO)
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      IX(2) = XV(IBO)
      IX(1) = XV(IBO-1)
      IX(3) = XV(IBO+1)
      IF (IBO.EQ.LB) IX(1) = XV(LE-1)
      IY(2) = YV(IBO)
      IY(1) = YV(IBO-1)
      IY(3) = YV(IBO+1)
      IF (IBO.EQ.LB) IY(1) = YV(LE-1)
C                                       Cursor read loop
 150  CALL YCURSE ('READ', F, T, RPOS, QUAD, IBUT, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF (.NOT.DOIT) GO TO 150
C                                       draw new lines
         CALL IMVECT (OFF, ICH, 3, IX, IY, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         IX(2) = RPOS(1) + 0.5
         IY(2) = RPOS(2) + 0.5
         IX(2) = MAX (CATBLK(IICOR), MIN (CATBLK(IICOR+2), IX(2)))
         IY(2) = MAX (CATBLK(IICOR+1), MIN (CATBLK(IICOR+3), IY(2)))
         CALL IMVECT (ON, ICH, 3, IX, IY, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       mark this one
         IF (IBUT.EQ.0) GO TO 150
            XV(IBO) = IX(2)
            YV(IBO) = IY(2)
            IF (IBUT.LT.4) GO TO 100
            IF (IBUT.LT.8) GO TO 105
C                                       DONE: off zoom
 200  TVZOOM(1) = 0
      TVZOOM(2) = MAXXTV(1) / 2
      TVZOOM(3) = MAXXTV(2) / 2
      CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), F, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       fill current polygons
      IF (LPOLY.GT.0) CALL BLTFIL (LPOLY, NV, XV, YV, IG2, SCRTCH, IERR)
      IF (NPY.GT.0) CALL BLTFIL (NPY, NV(LPOLY+1), XV(LIE0), YV(LIE0),
     *   IG1, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       talk to user
      IRET = 2
      WRITE (MSGTXT,1200)
      CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGTXT, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL ZTTYIO ('READ', TTYLUN, TTYIND, 72, MSGTXT, IERR)
      IF (IERR.NE.0) GO TO 900
      READ (MSGTXT,1201) TEMP
      CALL CHLTOU (4, TEMP)
      IRET = 1
      IF (TEMP.EQ.'REDO') GO TO 15
      IRET = 0
      IF ((TEMP.EQ.'QUIT') .OR. (TEMP.EQ.'Q   ')) IRET = 99
C                                       Correct to image pixels
      NPY0 = LPOLY + NPY
      IF (NPY0.LE.0) GO TO 900
         IE = 0
         DO 210 I = 1,NPY0
            IB = IE + 1
            IE = IB + NV(I) - 1
            DO 209 J = IB,IE
               XV(J) = (XV(J)-CATBLK(IICOR)) * LINC(1) + CATBLK(IIWIN)
               YV(J) = (YV(J)-CATBLK(IICOR+1)) * LINC(2) +
     *            CATBLK(IIWIN+1)
               XV(J) = MAX (CATBLK(IIWIN), MIN (CATBLK(IIWIN+2), XV(J)))
               YV(J) = MAX (CATBLK(IIWIN+1), MIN (CATBLK(IIWIN+3),
     *            YV(J)))
 209           CONTINUE
 210        CONTINUE
         GO TO 900
C                                       Overflow problems
 800  WRITE (MSGTXT,1800)
      CALL MSGWRT (7)
      GO TO 900
 810  WRITE (MSGTXT,1810)
      CALL MSGWRT (7)
      GO TO 200
C                                       close down
 900  CALL YCURSE (OFF, F, T, RPOS, QUAD, IBUT, JERR)
      IF (IRET.EQ.0) GO TO 999
         IF (IRET.EQ.1) WRITE (MSGTXT,1900) IERR
         IF (IRET.EQ.2) WRITE (MSGTXT,1901) IERR
         IF (IRET.EQ.99) WRITE (MSGTXT,1902)
         CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('Begin setting region number',I3)
 1041 FORMAT ('Press button A to set intermediate vertex')
 1042 FORMAT ('Press buttons B, C, or D to set final vertex')
 1043 FORMAT ('C => then reset a vertex,  D => then exit')
 1100 FORMAT ('*************  move cursor to vertex to be reset')
 1101 FORMAT ('Then push button A or B to do resetting -- or')
 1102 FORMAT ('Push C to go to next region  or D to exit')
 1200 FORMAT ('Type REDO to do more on this image, QUIT to stop,',
     *   ' hit return to go on')
 1201 FORMAT (A4)
 1800 FORMAT ('Reached limit of 30 polygons')
 1810 FORMAT ('Reached limit of 400 vertices')
 1900 FORMAT ('TV ROUTINE RETURNS ERROR CODE',I7)
 1901 FORMAT ('TERMINAL IO ERROR CODE',I7)
 1902 FORMAT ('Terminating at user''s request')
      END
      SUBROUTINE SLIBLS (IS0, SPCTRM, XLO, XHI, YLO, YHI, IRET)
C-----------------------------------------------------------------------
C   SLIBLS writes a SLice file containing the spectrum found.
C   Inputs:
C      IS0      I      Number of points
C      SPCTRM   R(*)   Data array
C      XLO      I      Lowest X pixel
C      XHI      I      Highest X pixel
C      YLO      I      Lowest Y pixel
C      YHI      I      Highest Y pixel
C   Outputs:
C      IRET     I      Error code
C-----------------------------------------------------------------------
      INTEGER   IS0, XLO, XHI, YLO, YHI, IRET
      REAL      SPCTRM(*)
C
      INCLUDE 'BLSUM.INC'
      CHARACTER SFILE*48
      INTEGER   ISLDAT(512), IVER, NREC, SLUN, SIND, LREC, IPT, IERR,
     *   LS0
      REAL      RSLDAT(512), RMIN, RMAX
      DOUBLE PRECISION DSLDAT(256)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (ISLDAT, RSLDAT, DSLDAT)
      DATA SLUN /45/
C-----------------------------------------------------------------------
      CALL FNDEXT ('SL', CATOLD, IVER)
      IVER = IVER + 1
      CALL FILL (256, 0, ISLDAT)
      LREC = 256
      LS0 = IS0
      IF (ISFQID) LS0 = 4 * IS0 - 3
      NREC = (LS0 - 1) / 256 + 2
C                                       create
      CALL EXTINI ('WRIT', 'SL', DISKIN, OLDCNO, IVER, CATOLD, SLUN,
     *   SIND, LREC, NREC, ISLDAT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATE', IVER
         GO TO 995
         END IF
C                                       update record 1
      CALL ZFIO ('READ', SLUN, SIND, 1, ISLDAT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ 1', IVER
         GO TO 990
         END IF
      ISLDAT(57) = LS0
      ISLDAT(58) = 0
      ISLDAT(59) = ISLDAT(1) + 1
      CALL ZFIO ('WRIT', SLUN, SIND, 1, ISLDAT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE 1', IVER
         GO TO 990
         END IF
C                                       inputs/parms in 2nd record
      CALL FILL (256, 0, ISLDAT)
      CALL CHR2H (6, TSKNAM, 1, RSLDAT(1))
      CALL ZDATE (ISLDAT(4))
      CALL ZTIME (ISLDAT(7))
      ISLDAT(10) = 23
      RSLDAT(11) = NLUSER
      CALL CHR2H (12, NAMEIN, 1, RSLDAT(12))
      CALL CHR2H (6, CLAIN, 1, RSLDAT(15))
      RSLDAT(17) = SEQIN
      RSLDAT(18) = DISKIN
      CALL RCOPY (14, BLC, RSLDAT(19))
      IF (NAXSKP.EQ.0) THEN
         RSLDAT(19) = XLO
         RSLDAT(20) = YLO
         RSLDAT(26) = XHI
         RSLDAT(27) = YHI
      ELSE IF (NAXSKP.EQ.1) THEN
         RSLDAT(20) = XLO
         RSLDAT(21) = YLO
         RSLDAT(27) = XHI
         RSLDAT(28) = YHI
      ELSE
         RSLDAT(19) = XLO
         RSLDAT(21) = YLO
         RSLDAT(26) = XHI
         RSLDAT(28) = YHI
         END IF
C                                       units type
      IF (ITYPE.EQ.1) THEN
         CALL CHR2H (4, 'FLUX', 1, RSLDAT(33))
      ELSE
         CALL CHR2H (4, 'AVER', 1, RSLDAT(33))
         END IF
      IF (ISFQID) THEN
         DSLDAT(19) = FRQS(1)
         RSLDAT(36) = (FRQS(IS0) - FRQS(1)) / (LS0 - 1)
         CALL FQTERP (IS0, SPCTRM, FRQS)
         END IF
C                                       min/max
      RMIN = 1.E12
      RMAX = -RMIN
      DO 10 IPT = 1,LS0
         IF (SPCTRM(IPT).NE.FBLANK) THEN
            RMAX = MAX (RMAX, SPCTRM(IPT))
            RMIN = MIN (RMIN, SPCTRM(IPT))
            END IF
 10      CONTINUE
      RSLDAT(34) = RMIN
      RSLDAT(35) = RMAX
      CALL ZFIO ('WRIT', SLUN, SIND, 2, ISLDAT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE 2', IVER
         GO TO 990
         END IF
C                                       write the data
      NREC = 2
      IPT = 1
 20   LREC = LS0 + 1 - IPT
      IF (LREC.GT.0) THEN
         LREC = MIN (LREC, 256)
         CALL RCOPY (LREC, SPCTRM(IPT), RSLDAT)
         NREC = NREC + 1
         CALL ZFIO ('WRIT', SLUN, SIND, NREC, ISLDAT, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE DATA', IVER
            GO TO 990
            END IF
         IPT = IPT + LREC
         IF (IPT.LE.LS0) GO TO 20
         END IF
C                                       close
      CALL ZCLOSE (SLUN, SIND, IRET)
C                                       Slice file created message.
      WRITE (MSGTXT,1020) IVER
      CALL MSGWRT (3)
      GO TO 999
C                                       destroy SL file
 990  CALL MSGWRT (8)
      CALL ZCLOSE (SLUN, SIND, IERR)
      CALL ZPHFIL ('SL', DISKIN, OLDCNO, IVER, SFILE, IERR)
      CALL ZDESTR (DISKIN, SFILE, IERR)
      CALL DELEXT ('SL', DISKIN, OLDCNO, 'WRIT', CATOLD, ISLDAT, IVER,
     *   IERR)
      GO TO 999
C
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' ON ',A,' SL VERS',I5)
 1020 FORMAT ('SLice file version ',I5,' created.')
      END
      SUBROUTINE FQTERP (IFQN, SLROW, FQFS)
C-----------------------------------------------------------------------
C   Smooths data from irregular grid to regular one
C   Inputs:
C      IFQN    I      Number input FQID points
C      FQFS    D(*)   Frequencies
C   In/out:
C      SLROW   R(*)   In: IFQN values
C                     Out: 4*IFQN-3 values on regular grid
C-----------------------------------------------------------------------
      INTEGER   IFQN
      REAL      SLROW(*)
      DOUBLE PRECISION FQFS(*)
C
      INCLUDE 'INCS:PMAD.INC'
      REAL      SB(MAXIMG), WT(MAXIMG), W
      INTEGER   NG(MAXIMG), NB(MAXIMG), IN, OUT, LNZI
      DOUBLE PRECISION FQFINC, FW, FR, F
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      LNZI = 4 * IFQN - 3
      FQFINC = (FQFS(IFQN) - FQFS(1)) / (LNZI - 1)
      CALL RFILL (LNZI, 0.0, SB)
      CALL RFILL (LNZI, 0.0, WT)
      CALL FILL (LNZI, 0, NG)
      CALL FILL (LNZI, 0, NB)
      FW = 2.5D0 * FQFINC
C                                       convolve
      DO 30 IN = 1,IFQN
         FR = FQFS(IN)
         F = FQFS(1) - FQFINC
         DO 20 OUT = 1,LNZI
            F = F + FQFINC
            W = ((FR - F) / FW) ** 2
            IF (W.LT.10.D0) THEN
               IF (SLROW(IN).NE.FBLANK) THEN
                  W = EXP(-W)
                  WT(OUT) = WT(OUT) + W
                  SB(OUT) = SB(OUT) + W * SLROW(IN)
                  NG(OUT) = NG(OUT) + 1
               ELSE
                  NB(OUT) = NB(OUT) + 2
                  END IF
               END IF
 20         CONTINUE
 30      CONTINUE
C                                       average
      DO 40 OUT = 1,LNZI
         IF ((WT(OUT).GT.0.0) .AND. (NB(OUT).LT.NG(OUT))) THEN
            SLROW(OUT) = SB(OUT) / WT(OUT)
         ELSE
            SLROW(OUT) = FBLANK
            END IF
 40      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE PLTBLS (NC, IPLOTS, BLNUMS, SPCTRA, IRET)
C-----------------------------------------------------------------------
C   PLTBLS makes a plot file containing IPLOTS spectra
C   Inputs:
C      NC       I         Number of points in each spectrum
C      IPLOTS   I         Number of spectra
C      BLNUMS   I(*)      Blotch numbers of these spectra
C      SPCTRA   R(NC,*)   Data to be plotted
C   Outputs:
C      IRET     I         > 0 => error
C-----------------------------------------------------------------------
      INTEGER   NC, IPLOTS, BLNUMS(*), IRET
      REAL      SPCTRA(NC,*)
C
      INCLUDE 'BLSUM.INC'
      INTEGER   I, J, NXPLOT, NYPLOT, IAPARM(5), VER, BUFFER(256), INP,
     *   IPSIZE, PTYPE, TVCHN, GRCHN, TVCORN(2), LUNPL, FINDPL, ID(3),
     *   IT(3), IPLOT, LTYPE, IERR
      REAL      PRANGE(2,4), PBLC(2), PTRC(2), XBLC(2,4), XTRC(2,4), DX,
     *   DY, YYOFF(2), XYOFF(2), XYSCL(2), TR, TI, AMULT(2), XMULT(2),
     *   SIZE, CHOUT(4), X, Y, AX(5), AY(5)
      LOGICAL   DOTV, GOOD, OFF
      CHARACTER SAVPRE(2)*5, PFILE*48, ATIME*8, ADATE*12, TEXT*132
      SAVE BUFFER, CHOUT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       find data scaling
      IF (APARM(2).LE.APARM(1)) THEN
         DO 20 J = 1,IPLOTS
            PRANGE(1,J) = 1.E20
            PRANGE(2,J) = -1.E20
            DO 10 I = 1,NC
               IF (SPCTRA(I,J).NE.FBLANK) THEN
                  PRANGE(1,J) = MIN (PRANGE(1,J), SPCTRA(I,J))
                  PRANGE(2,J) = MAX (PRANGE(2,J), SPCTRA(I,J))
                  END IF
 10            CONTINUE
 20         CONTINUE
         IF (APARM(2).LT.APARM(1)) THEN
            DO 25 J = 2,IPLOTS
               PRANGE(1,1) = MIN (PRANGE(1,1), PRANGE(1,J))
               PRANGE(2,1) = MAX (PRANGE(2,1), PRANGE(2,J))
 25            CONTINUE
            DO 30 J = 2,IPLOTS
               PRANGE(1,J) = PRANGE(1,1)
               PRANGE(2,J) = PRANGE(2,1)
 30            CONTINUE
            END IF
C                                       fixed scale
      ELSE
         DO 40 J = 1,IPLOTS
            PRANGE(1,J) = APARM(1)
            PRANGE(2,J) = APARM(2)
 40         CONTINUE
         END IF
      DO 50 J = 1,IPLOTS
         X = 0.05 * (PRANGE(2,J) - PRANGE(1,J))
         PRANGE(2,J) = PRANGE(2,J) + X
         PRANGE(1,J) = PRANGE(1,J) - X
 50      CONTINUE
C                                       Graph drawing parameters.
      PBLC(1) = 0.0
      PBLC(2) = 0.0
      PTRC(1) = 1000.0
      PTRC(2) = 1000.0
      CALL FILL (5, 1, IAPARM)
C                                       plot layout
      IF (IPLOTS.EQ.1) THEN
         NXPLOT = 1
         NYPLOT = 1
         XBLC(1,1) =PBLC(1)
         XBLC(2,1) = PBLC(2)
         XTRC(1,1) = PTRC(1)
         XTRC(2,1) = PTRC(2)
      ELSE IF (IPLOTS.EQ.4) THEN
         NXPLOT = 2
         NYPLOT = 2
         XBLC(1,1) = PBLC(1)
         XBLC(2,1) = PTRC(2) / NYPLOT
         XTRC(1,1) = PTRC(1) / NXPLOT
         XTRC(2,1) = PTRC(2)
         XBLC(1,2) = PTRC(1) / NXPLOT
         XBLC(2,2) = PTRC(2) / NYPLOT
         XTRC(1,2) = PTRC(1)
         XTRC(2,2) = PTRC(2)
         XBLC(1,3) = PBLC(1)
         XBLC(2,3) = PBLC(2)
         XTRC(1,3) = PTRC(1) / NXPLOT
         XTRC(2,3) = PTRC(2) / NYPLOT
         XBLC(1,4) = PTRC(1) / NXPLOT
         XBLC(2,4) = PBLC(2)
         XTRC(1,4) = PTRC(1)
         XTRC(2,4) = PTRC(2) / NYPLOT
         PRANGE(1,1) = MIN (PRANGE(1,1), PRANGE(1,2))
         PRANGE(2,1) = MAX (PRANGE(2,1), PRANGE(2,2))
         PRANGE(1,2) = PRANGE(1,1)
         PRANGE(2,2) = PRANGE(2,1)
         PRANGE(1,3) = MIN (PRANGE(1,3), PRANGE(1,4))
         PRANGE(2,3) = MAX (PRANGE(2,3), PRANGE(2,4))
         PRANGE(1,4) = PRANGE(1,3)
         PRANGE(2,4) = PRANGE(2,3)
      ELSE IF (IPLOTS.EQ.3) THEN
         IF (XNPLOT.GT.0) THEN
            NXPLOT = 1
            NYPLOT = 3
            XBLC(1,1) = PBLC(1)
            XBLC(2,1) = PTRC(2) - 1000.0 / NYPLOT
            XTRC(1,1) = PTRC(1)
            XTRC(2,1) = PTRC(2)
            XBLC(1,2) = PBLC(1)
            XBLC(2,2) = PBLC(2) + 1000.0 / NYPLOT
            XTRC(1,2) = PTRC(1)
            XTRC(2,2) = PTRC(2) - 1000.0 / NYPLOT
            XBLC(1,3) = PBLC(1)
            XBLC(2,3) = PBLC(2)
            XTRC(1,3) = PTRC(1)
            XTRC(2,3) = PBLC(2) + 1000.0 / NYPLOT
         ELSE
            NXPLOT = 3
            NYPLOT = 1
            XBLC(1,1) = PBLC(1)
            XBLC(2,1) = PBLC(2)
            XTRC(1,1) = PBLC(1) + 1000.0 / NXPLOT
            XTRC(2,1) = PTRC(2)
            XBLC(1,2) = PBLC(1) + 1000.0 / NXPLOT
            XBLC(2,2) = PBLC(2)
            XTRC(1,2) = PTRC(1) - 1000.0 / NXPLOT
            XTRC(2,2) = PTRC(2)
            XBLC(1,3) = PTRC(1) - 1000.0 / NXPLOT
            XBLC(2,3) = PBLC(2)
            XTRC(1,3) = PTRC(1)
            XTRC(2,3) = PTRC(2)
            PRANGE(1,1) = MIN (PRANGE(1,1), PRANGE(1,2))
            PRANGE(2,1) = MAX (PRANGE(2,1), PRANGE(2,2))
            PRANGE(1,1) = MIN (PRANGE(1,1), PRANGE(1,3))
            PRANGE(2,1) = MAX (PRANGE(2,1), PRANGE(2,3))
            PRANGE(1,2) = PRANGE(1,1)
            PRANGE(2,2) = PRANGE(2,1)
            PRANGE(1,3) = PRANGE(1,1)
            PRANGE(2,3) = PRANGE(2,1)
            END IF
C                                       2 panels
      ELSE
         IF (XNPLOT.GT.0) THEN
            NXPLOT = 1
            NYPLOT = 2
            XBLC(1,1) = PBLC(1)
            XBLC(2,1) = PTRC(2) - 1000.0 / NYPLOT
            XTRC(1,1) = PTRC(1)
            XTRC(2,1) = PTRC(2)
            XBLC(1,2) = PBLC(1)
            XBLC(2,2) = PBLC(2)
            XTRC(1,2) = PTRC(1)
            XTRC(2,2) = PTRC(2) - 1000.0 / NYPLOT
         ELSE
            NXPLOT = 2
            NYPLOT = 1
            XBLC(1,1) = PBLC(1)
            XBLC(2,1) = PBLC(2)
            XTRC(1,1) = PBLC(1) + 1000.0 / NXPLOT
            XTRC(2,1) = PTRC(2)
            XBLC(1,2) = PBLC(1) + 1000.0 / NXPLOT
            XBLC(2,2) = PBLC(2)
            XTRC(1,2) = PTRC(1)
            XTRC(2,2) = PTRC(2)
            PRANGE(1,1) = MIN (PRANGE(1,1), PRANGE(1,2))
            PRANGE(2,1) = MAX (PRANGE(2,1), PRANGE(2,2))
            PRANGE(1,2) = PRANGE(1,1)
            PRANGE(2,2) = PRANGE(2,1)
            END IF
         END IF
C                                       loop over plots
      DO 200 IPLOT = 1,IPLOTS
C                                       Offsets for current plot.
         YYOFF(1) = XBLC(1,IPLOT)
         YYOFF(2) = XBLC(2,IPLOT)
         XYOFF(1) = 0.0 + OFFCH
         XYSCL(1) = NC + 1.0 + OFFCH
         XYOFF(2) = PRANGE(1,IPLOT)
         XYSCL(2) = PRANGE(2,IPLOT)
C                                       Set up location common
         LOCNUM = 1
         ROT(LOCNUM) = 0.0
         CORTYP(LOCNUM) = 0
         LABTYP(LOCNUM) = 0
         AXTYP(LOCNUM) = 0
         TR = XYSCL(2) - XYOFF(2)
         TI = TR
         SAVPRE(2) = ' '
         CALL METSCL (LABEL, TR, SAVPRE(2), GOOD)
         AMULT(2) = TR / TI
         SAVPRE(1) = ' '
         AMULT(1) = 1.0
         CPREF(1,LOCNUM) = SAVPRE(1)
         CPREF(2,LOCNUM) = SAVPRE(2)
         XMULT(1) = AMULT(1)
         XMULT(2) = AMULT(2)
         DO 110 I = 1,2
            SIZE = 1000.0 / NXPLOT
            IF (I.EQ.2) SIZE = 1000.0 / NYPLOT
            XYSCL(I) = SIZE / (XYSCL(I) - XYOFF(I))
            TR = SIZE / XYSCL(I)
            RPLOC(I,LOCNUM) = XBLC(I,IPLOT)
            RPVAL(I,LOCNUM) = XYOFF(I) * XMULT(I)
            AXINC(I,LOCNUM) = TR * XMULT(I) /
     *         (XTRC(I,IPLOT) - XBLC(I,IPLOT))
            CTYP(I,LOCNUM) = AUNITS(I)
 110        CONTINUE
C                                       Blank bottom label.
         IF (XBLC(2,IPLOT).GT.100.) THEN
            CPREF(1,LOCNUM) = ' '
            CTYP(1,LOCNUM) = ' '
            END IF
C                                       Blank left label.
         IF (XBLC(1,IPLOT).GT.100.) THEN
            CPREF(2,LOCNUM) = ' '
            CTYP(2,LOCNUM) = ' '
            END IF
C                                       Create plot file
         IF (IPLOT.EQ.1) THEN
C                                       Update catalog header.
            VER = 0
            CALL MADDEX ('PL', DISKIN, OLDCNO, CATOLD, BUFFER, .TRUE.,
     *         'WRIT', VER, IRET)
            IF (IRET.NE.0) GO TO 999
            CALL ZPHFIL ('PL', DISKIN, OLDCNO, VER, PFILE, IRET)
            IPSIZE = 0
            PTYPE = 62
            DOTV = .FALSE.
            CALL RCOPY (4, XCEN, BADD(1))
            CALL RCOPY (4, YCEN, BADD(5))
            CALL RCOPY (4, PCEN, APARM(7))
            BADD(9) = IPLOTS
            CALL GINIT (DISKIN, OLDCNO, PFILE, IPSIZE, PTYPE, NPARM,
     *         XNAMEI, DOTV, TVCHN, GRCHN, TVCORN, CATOLD, BUFFER,
     *         LUNPL, FINDPL, IRET)
            IF (IRET.NE.0) GO TO 960
C                                       Not fully initialized, may make
C                                       INP too large which is okay.
            CALL RFILL (4, 0.5, CHOUT)
            CALL CHNTIC (XBLC, XTRC, INP)
            INP = MAX (INP, 3)
            LTYPE = MOD (ABS (LABEL), 100)
            IF (LTYPE.EQ.2) CHOUT(1) = 2.5
            IF (LTYPE.GT.2) CHOUT(1) = INP + 5.5
            IF (LTYPE.GT.1) CHOUT(2) = 2.0
            IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
            IF ((LABEL.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = CHOUT(4) +
     *         1.333
            CALL GINITL (PBLC, PTRC, XYRATO, CHOUT, IAPARM, BUFFER,
     *         IRET)
            IF (IRET.NE.0) GO TO 970
            WRITE (MSGTXT,1100) VER
            CALL MSGWRT (2)
            END IF
C                                       Draw border
         CALL GLTYPE (1, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL GPOS (XBLC(1,IPLOT), XTRC(2,IPLOT), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL GVEC (XBLC(1,IPLOT), XBLC(2,IPLOT), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL GVEC (XTRC(1,IPLOT), XBLC(2,IPLOT), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL GVEC (XTRC(1,IPLOT), XTRC(2,IPLOT), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL GVEC (XBLC(1,IPLOT), XTRC(2,IPLOT), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         J = NCTOT / NCPER - 1
         DO 120 I = 1,J
            X = NCPER * I + 0.5 + OFFCH
            X = XYSCL(1) * (I - XYOFF(1)) + YYOFF(1)
            CALL GPOS (X, XBLC(2,IPLOT), BUFFER, IRET)
            IF (IRET.NE.0) GO TO 970
            CALL GVEC (X, XTRC(2,IPLOT), BUFFER, IRET)
            IF (IRET.NE.0) GO TO 970
 120        CONTINUE
C                                       blotch number
         CALL GPOS (XTRC(1,IPLOT), XTRC(2,IPLOT), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 999
         WRITE (TEXT,1120) BLNUMS(IPLOT)
         CALL REFRMT (TEXT, '_', I)
         DX = -I - 4.
         DY = -3.5
         CALL GICHAR (1, I, 0, DX, DY, TEXT, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
C                                       centroid
         CALL GPOS (XBLC(1,IPLOT), XTRC(2,IPLOT), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 999
         WRITE (TEXT,1121) XCEN(IPLOT), YCEN(IPLOT)
         CALL REFRMT (TEXT, '_', I)
         DX = 4.
         DY = -3.5
         CALL GICHAR (1, I, 0, DX, DY, TEXT, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL GPOS (XBLC(1,IPLOT), XTRC(2,IPLOT), BUFFER, IRET)
         IF (IRET.NE.0) GO TO 999
         WRITE (TEXT,1122) PCEN(IPLOT)
         CALL REFRMT (TEXT, '_', I)
         DX = 4.
         DY = -5.5
         CALL GICHAR (1, I, 0, DX, DY, TEXT, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
C                                       Top labels: type & name
         IF ((IPLOT.EQ.1) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
C                                       Date/time/version
            IF (LABEL.GT.1) THEN
               DX = 0.0
               DY = 0.5
               CALL GPOS (PBLC(1), PTRC(2), BUFFER, IRET)
               IF (IRET.NE.0) GO TO 970
               CALL ZDATE (ID)
               CALL ZTIME (IT)
               CALL TIMDAT (IT, ID, ATIME, ADATE)
               WRITE (TEXT,1110) VER, ADATE, ATIME
               CALL REFRMT (TEXT, '_', I)
               CALL GCHAR (I, 0, DX, DY, TEXT, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 970
               END IF
            END IF
         CALL CLAB1 (XBLC(1,IPLOT), XTRC(1,IPLOT), CHOUT, LABEL, XYRATO,
     *      .FALSE., BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         DX = 8.0 / SQRT (ABS(XNPLOT))
         DX = DX * ABS(FACTOR)
         IF (DX.LT.2.5) DX = 2.5
         DY = DX
         IF (DX/XYRATO.LT.2.5) THEN
            DY = DY * XYRATO
         ELSE
            DX = DX / XYRATO
            END IF
C                                       plot data
         CALL GLTYPE (4, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         OFF = .TRUE.
         DO 130 I = 1,NC
            IF ((SPCTRA(I,IPLOT).EQ.FBLANK) .OR.
     *         (SPCTRA(I,IPLOT).GT.PRANGE(2,IPLOT)) .OR.
     *         (SPCTRA(I,IPLOT).GT.PRANGE(2,IPLOT))) THEN
               OFF = .TRUE.
            ELSE
               X = XYSCL(1) * (I + OFFCH - XYOFF(1)) + YYOFF(1)
               Y = XYSCL(2) * (SPCTRA(I,IPLOT) - XYOFF(2)) + YYOFF(2)
               IF (OFF) THEN
                  CALL GPOS (X, Y, BUFFER, IRET)
                  IF (FACTOR.GT.0.0) OFF = .FALSE.
               ELSE
                  CALL GVEC (X, Y, BUFFER, IRET)
                  END IF
               IF (IRET.NE.0) GO TO 970
               AX(1) = X
               AY(1) = Y
               AX(2) = AX(1)
               AX(3) = AX(1)
               AX(4) = AX(1) - DX
               AX(5) = AX(1) + DX
               AY(2) = AY(1) + DY
               AY(3) = AY(1) - DY
               AY(4) = AY(1)
               AY(5) = AY(1)
               CALL PNTPLT (ISYM, AX, AY, XBLC(1,IPLOT), XTRC(1,IPLOT),
     *            .FALSE., .FALSE., BUFFER, IRET)
               IF (IRET.NE.0) GO TO 970
               CALL GPOS (X, Y, BUFFER, IRET)
               IF (IRET.NE.0) GO TO 970
               END IF
 130        CONTINUE
 200     CONTINUE
C                                       finish plot
      CALL GFINIS (BUFFER, IRET)
      IF (IRET.GT.0) GO TO 975
      CALL HIPLOT (DISKIN, OLDCNO, VER, BUFFER, IERR)
      IRET = 0
      GO TO 999
C                                       ZPHFIL or GINIT failure.
 960  MSGTXT = 'ERROR DURING GRAPH FILE CREATION'
      CALL MSGWRT (8)
      CALL DELEXT ('PL', DISKIN, OLDCNO, 'WRIT', CATOLD, BUFFER, VER,
     *   IERR)
      GO TO 999
C                                       Try to finish partial graph
 970  MSGTXT = 'ERROR DURING GRAPHING. WILL TRY TO FINISH ' //
     *   'PARTIAL GRAPH'
      CALL MSGWRT (6)
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.GT.0) GO TO 975
      CALL HIPLOT (DISKIN, OLDCNO, VER, BUFFER, IERR)
      GO TO 999
C                                       Destroy the plot file
 975  CALL ZCLOSE (LUNPL, FINDPL, IERR)
      CALL ZDESTR (DISKIN, PFILE, IERR)
      CALL DELEXT ('PL', DISKIN, OLDCNO, 'WRIT', CATOLD, BUFFER, VER,
     *   IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('PLot file version',I4,'  created.')
 1110 FORMAT ('PLot file version',I4,'__created ',A,A)
 1120 FORMAT (I3)
 1121 FORMAT (F10.1,'_',F10.1)
 1122 FORMAT (F10.0,' pixels')
      END

LOCAL INCLUDE 'PRTTP.INC'
      REAL      DOCRT
      CHARACTER PRTEXT*132, TITL1*132, TITL2*132, CBUF*2880, TAPNAM*12,
     *   INFILE*48
      INTEGER   IBUF(4096), NFILES, LTYPE, FDVEC(50), TBIND, PLUN, PIND,
     *   NLINES, INTAPE, IPAGE, IPTLEV, NCR, TAPBUF(29184), BITPIX,
     *   NRECS, IDOEOT, UNKNWN, IEXTRA, NPIECE, XERR, FNRECS, NPV(4)
      LOGICAL   RQUICK, SHORT, VLBA, UVTABL, FILE1, DODISK, VLDISK
      DOUBLE PRECISION BSCALE(2), BZERO(2), BYTES, FBYTES
      HOLLERITH FHVEC(50)
      EQUIVALENCE (FDVEC, FHVEC)
      COMMON /PRTTAP/ BSCALE, BZERO, BYTES, FBYTES, DOCRT, TAPBUF, IBUF,
     *   BITPIX, RQUICK, SHORT, VLBA, NFILES, LTYPE, PLUN, PIND, NLINES,
     *   INTAPE, IPAGE, IPTLEV, NCR, FDVEC, TBIND, NRECS, IDOEOT, FILE1,
     *   UNKNWN, DODISK, UVTABL, IEXTRA, NPIECE, XERR, FNRECS, VLDISK,
     *   NPV
      COMMON /PRTPCH/ PRTEXT, TITL1, TITL2, CBUF, TAPNAM, INFILE
LOCAL END
LOCAL INCLUDE 'VLARCH.INC'
C                                       Commons for VLA archive tapes
C                                       Index info
      CHARACTER PGIDA(2000)*8, DATEA(2000)*8, CORMA(2000)*4
      INTEGER   D10IDA(2000), SUBAA(2000), CHCODA(2000)
      LOGICAL   FULL
      INTEGER   NOPGM, NOREC(2000), NOVIS(2000)
      DOUBLE PRECISION    FREQAA(2000), TIMERA(2,2000)
      COMMON /TAPE/ FREQAA, TIMERA, NOPGM, NOREC, NOVIS, FULL, D10IDA,
     *   SUBAA, CHCODA
      COMMON /VLACH/ PGIDA, CORMA, DATEA
LOCAL END
      PROGRAM PRTTP
C-----------------------------------------------------------------------
C! PRTTP prints a summary of contents of user's tape.
C# Tape Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1999, 2001-2004, 2007, 2009-2010, 2012,
C;  Copyright (C) 2015-2016, 2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PRTTP is an AIPS task to print on the line printer a summary of
C   the contents of a user's tape.  The program recognizes the
C   following formats:
C   (1) VLA visibility data "export" format
C   (2) IBM (Charlottesville) package map format
C   (3) FITS standard array format, including any following standard
C       TABLES format blocks
C   (4) FITS group format (i.e. UV data)
C   (5) VLBA binary FITS format
C   Inputs adverb:
C      INTAPE     R       Tape drive number: < 1 => 1
C      NFILES     R       Number of files to advance from begin of tape
C      PRTLEV     R       Print level control: (FITS only now)
C                           -1 => very brief summary
C                            0 => only summary
C                            1 => summary, non-history
C                            2 => everything
C      DOCRT      R       > 0 => use CRT, else line printer
C-----------------------------------------------------------------------
      INTEGER   IRET, NWD, IERR
      INCLUDE 'PRTTP.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Init things
      CALL PRTPIN (IRET)
      IF (IRET.NE.0) GO TO 995
      UNKNWN = 0
      NWD   = 29184
      NWD = (NWD * NBITWD) / 8
C                                       Loop point: what format?
 10   IF (FNRECS.GT.0) THEN
         IF ((FNRECS.GT.1) .OR. (FBYTES.GT.512.0D0)) THEN
            FBYTES = FBYTES / (1024.0D0 * 1024.0D0)
            WRITE (MSGTXT,1991) FBYTES, FNRECS
            CALL MSGWRT (4)
            CALL PRTPLI (4, IERR)
            END IF
         FNRECS = 0
         FBYTES = 0.0D0
         END IF
C                                       What is next?
      FDVEC(3) = NWD
      CALL PRTPHD (IERR)
      IRET = IERR
      IF ((IERR.EQ.4) .AND. (NFILES.GT.0)) IRET = 0
      IF ((IERR.EQ.6) .AND. (NFILES.GT.0)) IRET = 0
      IF (IERR.NE.0) GO TO 990
C                                       Do the file
         NFILES = NFILES + 1
         IF (DOCRT.LE.0.0) THEN
            WRITE (MSGTXT,1010) NFILES
            CALL MSGWRT (2)
            END IF
         IF (LTYPE.EQ.1) CALL PRTFIT (IRET)
         IF (LTYPE.EQ.2) CALL PRTIBM (IRET)
         IF (LTYPE.EQ.3) CALL PRTEXP (IRET)
         IF (LTYPE.EQ.4) CALL PRTVLA (IRET)
         IF (LTYPE.EQ.5) CALL PRTXXX (IRET)
         IF ((IRET.EQ.0) .AND. (.NOT.DODISK)) GO TO 10
C                                       Close the files
 990  IF (VLDISK) THEN
         CALL FLDKIO ('CLOS', FDVEC, TAPBUF, TBIND, IERR)
      ELSE
         CALL TAPIO ('CLOS', FDVEC, TAPBUF, TBIND, IERR)
         END IF
      IF (UNKNWN.GT.0) THEN
         WRITE (MSGTXT,1990) UNKNWN
         CALL MSGWRT (6)
         CALL PRTPLI (4, IERR)
         END IF
      IF (FNRECS.GT.0) THEN
         IF ((FNRECS.GT.1) .OR. (FBYTES.GT.512.0D0)) THEN
            FBYTES = FBYTES / (1024.0D0 * 1024.0D0)
            WRITE (MSGTXT,1991) FBYTES, FNRECS
            CALL MSGWRT (4)
            CALL PRTPLI (4, IERR)
            END IF
         FNRECS = 0
         FBYTES = 0.0D0
         END IF
      BYTES = BYTES / (1024.0D0 * 1024.0D0)
      WRITE (MSGTXT,1992) BYTES, NRECS
      CALL MSGWRT (4)
      CALL PRTPLI (4, IERR)
      IF (IPTLEV.GT.-3) THEN
         CALL LPCLOS (PLUN, PIND, NLINES, IERR)
      ELSE
         CALL ZTXCLS (PLUN, PIND, IERR)
         END IF
C                                       Close the task
 995  IF (IRET.EQ.-1) IRET = 0
      CALL DIETSK (IRET, RQUICK, IBUF)
C
 999  STOP
C-----------------------------------------------------------------------
 1010 FORMAT ('Begin reading file',I6)
 1990 FORMAT ('WARNING:',I7,' unknown records skipped while reading',
     *   ' tape')
 1991 FORMAT ('This file: read',F10.3,' Megabytes in',I8,
     *   ' logical records')
 1992 FORMAT ('Read at least',F11.3,' Megabytes in',I8,
     *   ' logical records')
      END
      SUBROUTINE PRTPIN (IRET)
C-----------------------------------------------------------------------
C   PRTPIN inits the task PRTTP including calling ZDCHIN and GTPARM,
C   resuming AIPS if requested, opening the printer and tape, and
C   rewinding the tape.  Note that the tape is opened as a "map"
C   file.
C   Output: IRET  I    Return code: 0 => ok, else quit directly
C-----------------------------------------------------------------------
      INTEGER IRET
C
      CHARACTER PRGNAM*6, LPNAME*48
      HOLLERITH XLPNAM(12), XTPNAM(3)
      INTEGER   IERR, IROUND, NP, I, ITRIM, ITEMP(25)
      HOLLERITH  XINFIL(12)
      REAL      TAPEIN, XFILES, PRTLEV, DDCRT, XBFILE, XDOEOT, XPIECE,
     *   XERROR
      INCLUDE 'PRTTP.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /INPARM/ TAPEIN, XFILES, XINFIL, PRTLEV, DDCRT, XLPNAM,
     *   XTPNAM, XBFILE, XDOEOT, XPIECE, XERROR
      DATA PRGNAM /'PRTTP '/
C-----------------------------------------------------------------------
C                                       Init for AIPS
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NP = 35
      CALL GTPARM (PRGNAM, NP, RQUICK, TAPEIN, IBUF, IRET)
      IF ((IRET.NE.0) .OR. (NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   DOCRT = MIN (-1.0, DOCRT)
      IF (IRET.NE.0) THEN
         RQUICK = .TRUE.
         IF (IRET.EQ.1) GO TO 999
         GO TO 20
         END IF
      RQUICK = RQUICK .AND. (DDCRT.LE.0.0)
      CALL H2CHR (48, 1, XINFIL, INFILE)
      DODISK = INFILE.NE.' '
      IF (((NPOPS.LE.NINTRN) .AND. (ISBTCH.NE.32000)) .OR. DODISK)
     *   GO TO 20
         WRITE (MSGTXT,1010)
         CALL MSGWRT (8)
         IRET = 8
         RQUICK = .TRUE.
 20   IF (RQUICK) CALL RELPOP (IRET, IBUF, IERR)
      IF (IRET.NE.0) GO TO 999
C                                       Init parms
      IRET = 8
      IPAGE = 0
      CALL H2CHR (12, 1, XTPNAM, TAPNAM)
      DOCRT = DDCRT
      INTAPE = IROUND (TAPEIN)
      IF (INTAPE.LE.0) INTAPE = 1
      NFILES = IROUND (XFILES)
      IF (NFILES.LE.0) NFILES = 0
      IPTLEV = IROUND (PRTLEV)
      IF (IPTLEV.LE.-3) DOCRT = -1
      NLINES = 900
      NRECS = 0
      BYTES = 0.0D0
      FNRECS = 0
      FBYTES = 0.0D0
      IF (XDOEOT.LT.0.0) XDOEOT = 0.0
      IDOEOT = XDOEOT + 1.9
      NPIECE = IROUND (XPIECE)
      IF (.NOT.DODISK) NPIECE = 1
      XERR = IROUND (XERROR)
C                                       Open tape
C                                       Initialize FDVEC
      CALL FILL (50, 0, FDVEC)
      FDVEC(2) = 2880
      FDVEC(3) = (29184 * NBITWD) / 8
      FDVEC(5) = INTAPE
      CALL CHR2H (48, INFILE, 1, FHVEC(7))
C                                       Disk
      VLDISK = .FALSE.
      IF (DODISK) THEN
         INTAPE = 1
C                                       Try VLA archive first
         FDVEC(1) = 29
         FDVEC(2) = 2048 * 13
         FDVEC(33) = MAX (0, NFILES) + 1
C                                       Open tape
         MSGSUP = 32000
         CALL FLDKIO ('OPRD', FDVEC, TAPBUF, TBIND, IERR)
         MSGSUP = 0
C                                       Check VLA MC Archive
         IF (IERR.EQ.0) THEN
            CALL FLDKIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
            IF (IERR.EQ.0) THEN
               CALL ZI16IL (25, 1, TAPBUF(TBIND), ITEMP)
C                                       ITEMP(1) = block number
C                                       ITEMP(2) = number of blocks
               IF ((ITEMP(1).EQ.1) .AND. (ITEMP(2).GE.1) .AND.
C                                       ITEMP(5) = format (1 only)
     *            (ITEMP(5).EQ.1) .AND.
C                                       ITEMP(6) = format revision no.
     *            (ITEMP(6).GE.3) .AND. (ITEMP(6).LE.50) .AND.
C                                       ITEMP(20) = no. antennas
     *            (ITEMP(20).GE.0) .AND. (ITEMP(20).LE.29)) THEN
                  VLDISK = .TRUE.
                  DODISK = .FALSE.
               ELSE
                  CALL FLDKIO ('CLOS', FDVEC, TAPBUF, TBIND, IERR)
                  END IF
               END IF
            END IF
         IF ((IERR.GT.0) .AND. (IERR.NE.8)) THEN
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       Okay - try FITS
         IF (.NOT.VLDISK) THEN
            FDVEC(1) = 25
            FDVEC(2) = 2880
            FDVEC(5) = INTAPE
            FDVEC(33) = 0
            MSGSUP = 32000
            CALL TAPIO ('OPRD', FDVEC, TAPBUF, TBIND, IERR)
            MSGSUP = 0
            IF (IERR.EQ.0) THEN
               CALL TAPIO ('CLOS', FDVEC, TAPBUF, TBIND, IERR)
            ELSE
               I = ITRIM (INFILE)
               INFILE(I+1:) = '1'
               CALL CHR2H (48, INFILE, 1, FHVEC(7))
               END IF
            END IF
      ELSE
         FDVEC(1) = 129 - INTAPE
         FDVEC(6) = 10
         END IF
      IF (.NOT.VLDISK) THEN
         CALL TAPIO ('OPRD', FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
         END IF
C                                       Rewind the tape
      IF (.NOT.((DODISK) .OR. (VLDISK))) THEN
         IF (NFILES.LE.10000) THEN
            FILE1 = .TRUE.
            I = 1
            CALL ZTAPE ('REWI', FDVEC(1), FDVEC(40), I, IERR)
            IF ((IERR.EQ.0) .AND. (NFILES.GT.0)) THEN
               CALL ZTAPE ('ADVF', FDVEC(1), FDVEC(40), NFILES, IERR)
               FILE1 = .FALSE.
               END IF
C                                       Back to start current file
         ELSE
            FILE1 = .FALSE.
            CALL TAPIO ('BAKF', FDVEC, TAPBUF, TBIND, IERR)
            END IF
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR
            CALL MSGWRT (8)
            GO TO 990
            END IF
         END IF
C                                       Open printer
      IF (NFILES.GT.10000) THEN
         NFILES = XBFILE - 0.99
         IF (NFILES.LT.1) NFILES = 10000
         IF (VLDISK) NFILES = 0
         END IF
      IF (DODISK) NFILES = 0
      CALL H2CHR (48, 1, XLPNAM, LPNAME)
      IF (IPTLEV.GT.-3) THEN
         IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
         CALL LPOPEN (LPNAME, DOCRT, PLUN, PIND, NCR, IBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1040) IERR, 'LPOPEN'
            CALL MSGWRT (8)
            GO TO 990
            END IF
C                                       open text file instead
      ELSE
         IF (LPNAME.EQ.' ') THEN
            LPNAME = 'PRTTPout.txt'
            MSGTXT = 'WARNING: OUTPRINT=''PRTTPout.txt'' USED' //
     *         ' - BLANK NOT ALLOWED'
            CALL MSGWRT (7)
            END IF
         NCR = 132
         PLUN = 3
         CALL ZTXOPN ('WRIT', PLUN, PIND, LPNAME, .TRUE., IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1040) IERR, 'ZTXOPN'
            CALL MSGWRT (8)
            GO TO 990
            END IF
         END IF
      SHORT = NCR.LE.79
      IRET = 0
      GO TO 999
C                                       Close tape on error
 990  CALL TAPIO ('CLOS' ,FDVEC, TAPBUF, TBIND, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I7,' TRYING TO OPEN PSEUDO-TAPE DISK FILE')
 1010 FORMAT ('TAPES NOT ALLOWED IN BATCH JOBS')
 1020 FORMAT ('ERROR',I7,' TRYING TO OPEN TAPE')
 1030 FORMAT ('ERROR',I7,' TRYING TO POSITION TAPE FOR START OF JOB')
 1040 FORMAT ('ERROR',I7,' FROM ',A,' TRYING TO OPEN OUTPUT/PRINTER')
      END
      SUBROUTINE PRTPHD (IERR)
C-----------------------------------------------------------------------
C   PRTPHD reads a tape header.  It tests it for being a FITS header by
C   looking for 'SIMPLE  = '.  If that fails it checks for tape label
C   marks 'VOL1', 'HDR1', etc.  If they are found it advances file and
C   repeats.  If not, it tests for a VLA UV-data export tape by checking
C   the block length word and for the character string 'RUN '.  Failing
C   that it checks for an IBM map header by checking axis dimensions.
C   A set of somewhat arbitrary criteria are used for VLA archive
C   tapes.
C   Outputs:
C   Common  LTYPE I        1 => FITS,  2 => IBM map,  3 => UV export,
C                          4 => VLA archive
C   Variab  IERR  I        error return: 0 => ok
C                          OTHER = return from TAPIO
C                          10 = neither FITS nor DEC nor Export
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      CHARACTER LINE*80, HDRTYP(7)*4
      INTEGER   IEREOF, I(2), IT, JERR, II, ITRY, ITEMP(25), J, IEREOM,
     *   NEOF, IDUM(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'PRTTP.INC'
      DATA IEREOF, IEREOM /4, 6/
      DATA HDRTYP /'VOL1','HDR1','HDR2','EOF1','EOF2','EOV1','EOV2'/
C-----------------------------------------------------------------------
      ITRY = 1
      IF (VLDISK) GO TO 50
 10   FDVEC(2) = 2880
      FDVEC(6) = 10
C                                       suppress messages
C                                       read one record
      FDVEC(31) = 0
      FDVEC(32) = 0
      IF (FILE1) IDOEOT = IDOEOT + 1
      IF (DODISK) IDOEOT = 1
      DO 12 NEOF = 1,IDOEOT
         MSGSUP = 32000
         CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
         MSGSUP = 0
         IF (IERR.NE.4) GO TO 13
         NFILES = NFILES + 1
         WRITE (MSGTXT,1010) NFILES
         CALL MSGWRT (6)
         CALL PRTPLI (4, IERR)
         IF (IERR.NE.0) GO TO 999
         IERR = 4
 12      CONTINUE
 13   IF (FILE1) IDOEOT = IDOEOT - 1
      FILE1 = .FALSE.
      IF ((IERR.NE.0) .AND. (IERR.NE.10)) GO TO 980
      NRECS = NRECS + 1
      BYTES = BYTES + FDVEC(42)
      FNRECS = FNRECS + 1
      FBYTES = FBYTES + FDVEC(42)
C                                       FITS ?
      CALL ZC8CL (80, 1, TAPBUF(TBIND), LINE)
      IF (LINE(1:10).EQ.'SIMPLE  = ') THEN
         LTYPE = 1
         IF (IERR.EQ.10) THEN
            IERR = 0
            LTYPE = -1
         ELSE
            IT = INDEX (LINE, '/')
            IF (IT.LE.0) IT = 80
            DO 15 J = 11,IT
               IF (LINE(J:J).NE.' ') THEN
                  IF (LINE(J:J).NE.'T') GO TO 16
                  GO TO 970
                  END IF
 15            CONTINUE
 16         MSGTXT = 'NON-SIMPLE FITS HEADER: TRY TO PROCEDE ANYWAY'
            CALL MSGWRT (6)
            CALL PRTPLI (4, IERR)
            GO TO 999
            END IF
         GO TO 970
         END IF
      IF (DODISK) THEN
         MSGTXT = 'DISK FILES MUST BE FITS FORMAT'
         CALL MSGWRT (8)
         IERR = 99
         GO TO 999
         END IF
      IERR = 0
C                                       Check for labeled tape
      DO 20 IT = 1,7
         IF (LINE(1:4).EQ.HDRTYP(IT)) GO TO 30
 20      CONTINUE
      GO TO 50
C                                       Tape labels
 30   CONTINUE
         IF (FNRECS.GT.0) THEN
            IF ((FNRECS.GT.1) .OR. (FBYTES.GT.512.0D0)) THEN
               FBYTES = FBYTES / (1024.0D0 * 1024.0D0)
               WRITE (MSGTXT,1991) FBYTES, FNRECS
               CALL MSGWRT (4)
               CALL PRTPLI (4, IERR)
               END IF
            FNRECS = 0
            FBYTES = 0.0D0
            END IF
         NFILES = NFILES + 1
         CALL PRTPLI (1, IERR)
         IF (IERR.NE.0) GO TO 999
         DO 35 II = 1,9
            CALL ZC8CL (80, 1, TAPBUF(TBIND), CBUF)
            WRITE (PRTEXT,1030) ' '
            PRTEXT(25:104) = CBUF(1:80)
            CALL PRTPLI (2, IERR)
            IF (IERR.NE.0) GO TO 999
            MSGSUP = 32000
            CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
            MSGSUP = 0
            NRECS = NRECS + 1
            BYTES = BYTES + FDVEC(42)
            FNRECS = FNRECS + 1
            FBYTES = FBYTES + FDVEC(42)
C                                       Watch for labels!
            IF ((IERR.NE.0) .AND. (IERR.NE.10)) GO TO 40
 35         CONTINUE
         II = 1
         CALL ZTAPE ('ADVF', FDVEC(1), FDVEC(40), II, IERR)
 40      IF (IT.LT.6) THEN
            IF ((IERR.EQ.0) .OR. (IERR.EQ.IEREOF) .OR.
     *         (IERR.EQ.10)) GO TO 10
            GO TO 980
            END IF
C                                       EOVolume label
         MSGTXT = 'End of multi-tape volume found.  Mount next tape'
         IERR = 6
         GO TO 990
C                                       VLA Archive disk already known
 50   IF (VLDISK) THEN
C                                       Close previous
         CALL FLDKIO ('CLOS', FDVEC, TAPBUF, TBIND, IERR)
C                                       Open tape
         FDVEC(33) = MAX (0, NFILES) + 1
         MSGSUP = 32000
         CALL FLDKIO ('OPRD', FDVEC, TAPBUF, TBIND, IERR)
         MSGSUP = 0
         IF (IERR.EQ.8) THEN
            IERR = 6
            GO TO 999
            END IF
         IF (IERR.EQ.0) CALL FLDKIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR, NFILES+1
            GO TO 990
            END IF
         END IF
C                                       Check VLA MC Archive
      CALL ZI16IL (25, 1, TAPBUF(TBIND), ITEMP)
C                                       ITEMP(1) = block number
C                                       ITEMP(2) = number of blocks
      IF ((ITEMP(1).EQ.1) .AND. (ITEMP(2).GE.1) .AND.
C                                       ITEMP(5) = format (1 only)
     *   (ITEMP(5).EQ.1) .AND.
C                                       ITEMP(6) = format revision no.
     *   (ITEMP(6).GE.3) .AND. (ITEMP(6).LE.50) .AND.
C                                       ITEMP(20) = no. antennas
     *   (ITEMP(20).GE.0) .AND. (ITEMP(20).LE.29)) THEN
         LTYPE = 4
         GO TO 995
         END IF
      IF (VLDISK) THEN
         MSGTXT = 'ALL FILES MUST BE VLA EXPORT IF ANY ARE'
         CALL MSGWRT (8)
         IERR = 8
         GO TO 999
         END IF
C                                       Must be an IBM header
C                                       Try for UV export
      LTYPE = 3
      CALL ZI16IL (1, 1, TAPBUF(TBIND), IDUM)
      IT = IDUM(1)
      IT = IT / 2
      IF ((IT.LE.0) .OR. (IT.GT.2004)) GO TO 60
         CALL ZC8CL (4, 9, TAPBUF(TBIND), LINE)
         IF (LINE(:4).EQ.'RUN ') GO TO 995
         IF (LINE(:4).EQ.'DEF ') GO TO 995
C                                       check bound on DEC dims
C                                       on IBM map
 60   LTYPE = 2
      CALL ZI16IL (2, 17, TAPBUF(TBIND), I)
      IF ((I(1).GE.16) .AND. (I(2).GE.16) .AND. (I(1).LE.4096) .AND.
     *   (I(2).LE.4096) .AND. (FDVEC(42).EQ.256)) GO TO 995
         IF (ITRY.GT.1) GO TO 65
            ITRY = ITRY + 1
            CALL TAPIO ('BAKF', FDVEC, TAPBUF, TBIND, IERR)
            IF (IERR.NE.0) GO TO 985
            MSGTXT = 'Format not recognized: retry the tape read'
            CALL MSGWRT (6)
            CALL PRTPLI (4, IERR)
            IF (IERR.NE.0) GO TO 999
            GO TO 10
 65   CONTINUE
         IERR = 0
         LTYPE = 5
         MSGTXT = 'HEADER TYPE NOT RECOGNIZED'
         CALL MSGWRT (6)
         GO TO 995
C                                        errors
 970  IF (LTYPE.EQ.1) GO TO 999
         IF (LTYPE.EQ.-1) THEN
            WRITE (MSGTXT,1970) FDVEC(42)
            CALL MSGWRT (8)
            CALL PRTPLI (4, IERR)
            IF (IERR.EQ.0) IERR = 11
            GO TO 999
         ELSE
            MSGTXT = 'NON-SIMPLE FITS HEADER: TRY TO PROCEDE ANYWAY'
            CALL MSGWRT (6)
            CALL PRTPLI (4, IERR)
            GO TO 999
            END IF
C                                       End of tape
 980  IF (IERR.NE.0) THEN
         II = 1
         IF (IERR.EQ.IEREOF) II = 2
         IF (.NOT.(DODISK .OR. VLDISK)) THEN
            CALL ZTAPE ('BAKF', FDVEC(1), FDVEC(40), II, JERR)
            IF (JERR.NE.0) THEN
               WRITE (MSGTXT,1980) JERR
               GO TO 990
               END IF
            END IF
         IF ((IERR.EQ.IEREOF) .OR. (IERR.EQ.IEREOM)) GO TO 999
         END IF
 985  WRITE (MSGTXT,1985) IERR
 990  CALL MSGWRT (6)
      CALL PRTPLI (4, II)
      GO TO 999
C                                       Back to start of file
 995  IF (.NOT.(DODISK .OR. VLDISK)) CALL TAPIO ('BAKF', FDVEC, TAPBUF,
     *   TBIND, IERR)
C                                       Reset read count
      FDVEC(32) = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('NULL FILE AT FILE NUMBER',I6)
 1030 FORMAT ('Read label file record: ',83X,A1)
 1050 FORMAT ('OPEN/READ VLA DISK ERROR',I3,' FILE',I3)
 1970 FORMAT ('NON-STANDARD FITS RECORD LENGTH',I7,' BYTES READ')
 1980 FORMAT ('ERROR',I6,' POSITIONING TAPE AT THE END-OF-TAPE')
 1985 FORMAT ('HEADER BAKF I/O ERROR = ',I6)
 1991 FORMAT ('This file: read',F10.3,' Megabytes in',I8,
     *   ' logical records')
      END
      SUBROUTINE PRTPLI (ICODE, IERR)
C-----------------------------------------------------------------------
C   PRTPLI handles the actual printing of lines including paging and
C   page headers via common text PRTEXT and
C   Input: ICODE  I    1 => new file header
C                      2 => double space text in PRTEXT
C                      3 => single space text in PRTEXT
C                      4 => error message display
C   Output: IERR  I    0 => continue, > 0 I/O error, -1 => please quit
C-----------------------------------------------------------------------
      INTEGER   ICODE, IERR
C
      CHARACTER BLANKS*132, SCRTCH*132, SPRTXT*132, TITL(5)*8
      INTEGER   I, LCODE, J, ITRIM
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'PRTTP.INC'
      DATA TITL /'FITS FMT', 'IBM MAPS', 'EXPORT  ', 'VLA ARCH',
     *   'UNKNOWN '/
      DATA BLANKS /' '/
C-----------------------------------------------------------------------
      IERR = 0
      IF (IPTLEV.LT.-2) GO TO 999
      IF ((ICODE.LT.1) .OR. (ICODE.GT.4)) GO TO 999
      IF (ICODE.EQ.4) THEN
         IF (DOCRT.GT.0.0) GO TO 999
         IF (MSGTXT.EQ.' ') GO TO 999
         END IF
      J = (NCR - 1) / 4 + 1
C                                       New file
      IF (ICODE.LE.1) THEN
         IF ((DOCRT.GT.0.0) .AND. (NLINES.GT.ABS(CRTMAX)-6))
     *      NLINES = 900
         IF ((DOCRT.LE.0.0) .AND. (NLINES.GT.PRTMAX-8)) NLINES = 900
         WRITE (TITL1,1000) NFILES, TITL(LTYPE), TAPNAM
         WRITE (TITL2,1001) ('- - ', I = 1,J)
C                                       display file break
         IF (NLINES.LT.900) THEN
            IF (DOCRT.GT.-2.5) THEN
               CALL PRTLIN (PLUN, PIND, DOCRT, NCR, TITL1, TITL2,
     *            BLANKS, NLINES, IPAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 999
               WRITE (SPRTXT, 1001) ('****', I = 1,33)
               IF ((DOCRT.LE.0.0) .AND. (IPTLEV.GE.0)) CALL PRTLIN
     *            (PLUN, PIND, DOCRT, NCR, TITL1, TITL2, SPRTXT, NLINES,
     *            IPAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 999
               IF ((DOCRT.LE.0.0) .AND. (IPTLEV.GE.0)) CALL PRTLIN
     *            (PLUN, PIND, DOCRT, NCR, TITL1, TITL2, BLANKS, NLINES,
     *            IPAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 999
               END IF
            CALL PRTLIN (PLUN, PIND, DOCRT, NCR, TITL1, TITL2,
     *         TITL1, NLINES, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 999
            IF (DOCRT.GT.-2.5) THEN
               CALL PRTLIN (PLUN, PIND, DOCRT, NCR, TITL1, TITL2,
     *            BLANKS, NLINES, IPAGE, SCRTCH, IERR)
               END IF
         ELSE IF (DOCRT.LE.-2.5)  THEN
            CALL PRTLIN (PLUN, PIND, DOCRT, NCR, TITL1, TITL2,
     *         TITL1, NLINES, IPAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         GO TO 999
         END IF
C                                       Regular text line
      LCODE = ICODE
      IF ((IPTLEV.LT.0) .AND. (LCODE.NE.4)) LCODE = 3
      IF ((LCODE.NE.3) .AND. (DOCRT.GT.-2.5)) THEN
         CALL PRTLIN (PLUN, PIND, DOCRT, NCR, TITL1, TITL2,
     *      BLANKS, NLINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
      IF (LCODE.EQ.4) PRTEXT = '>>>>> ' // MSGTXT(:ITRIM(MSGTXT)) //
     *   ' <<<<<'
      CALL PRTLIN (PLUN, PIND, DOCRT, NCR, TITL1, TITL2, PRTEXT,
     *   NLINES, IPAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      IF ((LCODE.EQ.4) .AND. (DOCRT.GT.-2.5)) THEN
         CALL PRTLIN (PLUN, PIND, DOCRT, NCR, TITL1, TITL2,
     *      BLANKS, NLINES, IPAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('****   File number',I6,4X,'of type ',A8,4X,'tape',1X,A,
     *   ' ****')
 1001 FORMAT (33A4)
      END
      SUBROUTINE PRTEXP (IERR)
C-----------------------------------------------------------------------
C   Read EXPORT tape, interpret each record type and either skip it,
C   print data, or accumulate number of VIS records.
C   Output: IERR   I     Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER IERR
C
      CHARACTER TYPES(6)*4, CH1*1, CH2*1, SOURCE*8, CTEMP*24, BTEMP*8,
     *   CCTEMP*8, IMTYPE*2, IMNAME*12, IMCLAS*6, OBS*4, DATE*12
      INTEGER   IW(4), ITYPES(2,6), IN, I, I4, IQUAL, IS, ITYP, IWT1,
     *   IWT2, IWT3, IWT4, NWD, RM(2), DM(2), ISEQ, ITEMP(8), JER, NVIS,
     *   TVIS, IRTEMP(2), IDUM(2)
      REAL      R4, DSEC, RSEC, RTEMP(2)
      LOGICAL   FSOUR, FIRST, ENDCOM
      DOUBLE PRECISION    R8, FREQ, RA0, DEC0, F8, XDAT
      INCLUDE 'PRTTP.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (R8, I4, R4, IW(1))
      EQUIVALENCE (IRTEMP, RTEMP)
      DATA TYPES /'RUN ','ANTE','SOUR','VIS ','DEF ','END '/
C-----------------------------------------------------------------------
C                                       set logical flags
      FIRST = .TRUE.
      ENDCOM = .FALSE.
      FSOUR = .TRUE.
      NWD = 0
      IS = 20
      ISEQ = 0
      NVIS = 0
      TVIS = 0
      CALL PRTPLI (1, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       convert chars to mess on tape
      IN = -3
      DO 10 I = 1,6
         IN = IN + 4
         CALL ZCLC8 (4, TYPES(I), IN, IBUF)
 10      CONTINUE
      CALL ZI16IL (12, 1, IBUF, ITYPES)
C                                       Initialize tape reading
      FDVEC(2) = 4008
      FDVEC(6) = 1
      FDVEC(31) = 1
      FDVEC(32) = 0
C
C                                       read logical record loop
C                                       locate logical record
 50   IF (FIRST) GO TO 60
         IW(1) = IBUF(IS-4)
         IW(2) = IBUF(IS-3)
         ITYP = 7
         DO 55 I = 1,6
            IF ((IW(1).EQ.ITYPES(1,I)).AND.(IW(2).EQ.ITYPES(2,I)))
     *         ITYP = I
 55         CONTINUE
         IF (IBUF(IS-6).GT.1) GO TO 56
            WRITE (MSGTXT,1055) IBUF(IS-6)
            IERR = 4
            GO TO 980
 56      IS = IS + IBUF(IS-6)/2
C                                       read tape record ?
 60   IF ((.NOT.FIRST) .AND. (IS.LE.NWD)) GO TO 90
         MSGTXT = ' '
         CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
         CALL PRTPLI (4, JER)
         IF (IERR.EQ.0) GO TO 70
            IF (IERR.NE.4) GO TO 65
               IERR = 0
               IF (ENDCOM) GO TO 995
               WRITE (MSGTXT,1060)
               GO TO 980
 65         CONTINUE
               WRITE (MSGTXT,1065) IERR
               GO TO 980
 70      CALL ZI16IL (1, 1, TAPBUF(TBIND), IDUM)
         IN = IDUM(1)
         IF (JER.NE.0) THEN
            IERR = JER
            GO TO 999
            END IF
         NRECS = NRECS + 1
         BYTES = BYTES + FDVEC(42)
         FNRECS = FNRECS + 1
         FBYTES = FBYTES + FDVEC(42)
         NWD = IN / 2
         IF ((NWD.GT.0) .AND. (NWD.LE.2004)) GO TO 75
            WRITE (MSGTXT,1070) NWD
            GO TO 980
 75      CALL ZI16IL (NWD, 1, TAPBUF(TBIND), IBUF)
         IS = 9
         ENDCOM = .FALSE.
         IF (.NOT.FIRST) GO TO 90
            FIRST = .FALSE.
            GO TO 50
C
C                                       branch to handle record types
 90   GO TO (100, 200, 300, 400, 500, 600, 700), ITYP
C
C                                       RUN records
 100  CONTINUE
         CALL ZILI16 (2, IBUF(IS), 1, IRTEMP)
         CALL ZC8CL (4, 1, IRTEMP, OBS)
         CALL ZR8P4 ('4IB8', IBUF(IS+4), XDAT)
         XDAT = XDAT + 2400000.5D0
         CALL GREG (XDAT, SOURCE)
         CALL DATDAT (SOURCE, DATE)
         WRITE (PRTEXT,1100) OBS, DATE
         CALL PRTPLI (2, IERR)
         GO TO 50
C
C                                       ANTEnna records
 200  CONTINUE
         GO TO 50
C
C                                       SOURce records
 300  CONTINUE
         IF (FSOUR) GO TO 310
            WRITE (PRTEXT,1300) NVIS
            CALL PRTPLI (3, IERR)
            IF (IERR.NE.0) GO TO 999
 310     NVIS = 0
         ISEQ = ISEQ + 1
         FSOUR = .FALSE.
         CALL ZILI16 (4, IBUF(IS), 1, ITEMP)
         CALL ZC8CL (8, 1, ITEMP, CTEMP)
         SOURCE(1:8) = CTEMP(1:8)
         IQUAL = IBUF(IS+4)
         CALL ZR8P4 ('4IB8', IBUF(IS+18), F8)
         RA0 = 360.0D0 * 2D0**(-31) * F8
         CALL  ZR8P4 ('4IB8', IBUF(IS+20), F8)
         DEC0 = 360.0D0 * 2D0**(-31) * F8
         CALL COORDD (1, RA0, CH1, RM, RSEC)
         CALL COORDD (2, DEC0, CH2, DM, DSEC)
         CALL ZR8P4 ('4IB8', IBUF(IS + 22), F8)
         FREQ = F8 * 1D-6
         WRITE (PRTEXT,1310) ISEQ, SOURCE, IQUAL, CH1, RM, RSEC,
     *      CH2, DM, DSEC, FREQ
         CALL FILZCH (2, 31, PRTEXT)
         CALL FILZCH (2, 34, PRTEXT)
         CALL FILZCH (6, 37, PRTEXT)
         CALL FILZCH (2, 45, PRTEXT)
         CALL FILZCH (2, 48, PRTEXT)
         CALL FILZCH (5, 51, PRTEXT)
         CALL PRTPLI (2, IERR)
         IF (IERR.NE.0) GO TO 999
         GO TO 50
C                                       VISibility records
400   CONTINUE
         IWT1 = MAX (0, IBUF(IS+8))
         IWT2 = MAX (0, IBUF(IS+11))
         IWT3 = MAX (0, IBUF(IS+14))
         IWT4 = MAX (0, IBUF(IS+17))
         IF ((IWT1.GT.0) .OR. (IWT2.GT.0) .OR. (IWT3.GT.0) .OR.
     *      (IWT4.GT.0)) THEN
            NVIS = NVIS + 1
            TVIS = TVIS + 1
            END IF
         GO TO 50
C
C                                       DEFinition records
500   CONTINUE
         GO TO 50
C
C                                       END records
600   CONTINUE
         WRITE (PRTEXT,1300) NVIS
         CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
         ENDCOM = .TRUE.
         FSOUR = .TRUE.
         GO TO 50
C
C                                       records of unknown origin
700   CONTINUE
         GO TO 50
C
C                                       error exit
 980  CALL MSGWRT (8)
      CALL PRTPLI (4, I)
C                                       file output only
 995  IF (IPTLEV.LE.-3) THEN
         IMNAME = 'MODCOMP VIS '
         IMCLAS = 'EXPORT'
         IMTYPE = 'EX'
         BTEMP = 'TotalVis'
         WRITE (CCTEMP, 1994) TVIS
         WRITE (PRTEXT,1995) TAPNAM, NFILES, IMTYPE, IMNAME, IMCLAS,
     *      0, BTEMP, CCTEMP
         CALL ZTXIO ('WRIT', PLUN, PIND, PRTEXT(:64), JER)
         IF (JER.NE.0) THEN
            WRITE (MSGTXT,1996) JER
            CALL MSGWRT (8)
            END IF
         IF (IERR.EQ.0) IERR = JER
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1055 FORMAT ('PRTEXP: LOGICAL RECORD LENGTH=',I8,' ERROR')
 1060 FORMAT ('PRTEXP: UNEXPECTED END OF FILE')
 1065 FORMAT ('PRTEXP: TAPIO TROUBLE WITH VIS. TAPE, IERR=',I3)
 1070 FORMAT ('PRTEXP: PHYSICAL RECORD LENGTH=',I9,' ERROR')
 1100 FORMAT (4X,'RUN  observer = ''',A4,'''   date = ',A12)
 1300 FORMAT (I8,' valid vis records')
 1310 FORMAT (I5,4X,'Found ',A8,I4,' :',A1,I2,I3,F7.3,1X,A1,I2,I3,F6.2,
     *   2X,'F=',F10.6,' GHz')
 1994 FORMAT (I8)
 1995 FORMAT (A12,I6,1X,A2,1X,A12,1X,A6,I5,1X,A8,1X,A8)
 1996 FORMAT ('ZTXIO RETURNS ERROR',I5)
      END
      SUBROUTINE PRTIBM (IRET)
C-----------------------------------------------------------------------
C   PRTIBM prints information about each IBM map format image in the
C   current tape file.
C   Output:  IRET  I    Error code: 0 => ok (incl unexpected EOF)
C                       Else serious tape error => quit
C-----------------------------------------------------------------------
      INTEGER IRET
C
      CHARACTER DIRTY(2)*5, DCLASS(8)*4, PRODUC(5)*8, CH1*1, CH2*1,
     *   NAME*8, BTEMP*8, CTEMP*8, IMTYPE*2, IMNAME*12, IMCLAS*6
      INTEGER   IERR, NX, I, ND, DD, IEREOF, MSKCLS, NCLASS, NY, MSQUAL,
     *   MNO, D2NX, D2NY, DFR1, IRA(2), IDEC(2), ZAND, JER, NIMAGE
      REAL      X, Y, ROT, RAS, DECS
      DOUBLE PRECISION    FREQ, C1, RA, DEC, DERA, DEDEC
      HOLLERITH HBUF(10)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'PRTTP.INC'
      EQUIVALENCE (HBUF, IBUF)
      DATA IEREOF, MSKCLS /4,255/
      DATA DFR1, NCLASS, MSQUAL, MNO, D2NX, D2NY /9,7,5,6,17,18/
      DATA DIRTY /'DIRTY','CLEAN'/
      DATA DCLASS /'????','BEAM','IPOL','QPOL','UPOL','VPOL','P   ',
     *   'PA  '/
      DATA PRODUC /'NORMAL  ', 'COMPNTS ', 'RESIDUAL',
     *   'POINTS  ', '????????'/
C-----------------------------------------------------------------------
C                                       Init print, tape to start
      CALL PRTPLI (1, IRET)
      IF (IRET.NE.0) GO TO 999
      IRET = 0
      NIMAGE = 0
C                                       Read loop
C                                       Initialize, read 1 record
 10      FDVEC(2) = 256
         FDVEC(6) = 1
         FDVEC(31) = 0
         FDVEC(32) = 1
         MSGSUP = 32000
         MSGTXT = ' '
         CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
         MSGSUP = 0
         CALL PRTPLI (4, JER)
         IF (IERR.EQ.IEREOF) GO TO 995
         IF (IERR.NE.0) GO TO 980
         IF (JER.NE.0) THEN
            IRET = JER
            GO TO 999
            END IF
         NRECS = NRECS + 1
         BYTES = BYTES + FDVEC(42)
         FNRECS = FNRECS + 1
         FBYTES = FBYTES + FDVEC(42)
         NIMAGE = NIMAGE + 1
C                                       translate header
CCC         CALL ZI16IL (124, 5, TAPBUF(TBIND), IBUF(5))
CCC         CALL ZC8CL (8, 1, TAPBUF(TBIND), CBUF)
         CALL ZI16IL (128, 1, TAPBUF(TBIND), IBUF)
C                                       Source, freq, status
         ND = IBUF(NCLASS)
         DD = 1
         IF (ND.LT.0) DD = 2
         ND = ZAND (ND, MSKCLS)
         ND = ND + 1
         IF ((ND.GT.8) .OR. (ND.LT.1)) ND = 1
         CALL ZR8P4 ('4IB8', IBUF(DFR1), FREQ)
         FREQ = FREQ * 1.0D-3
         CALL H2CHR (8, 1, HBUF, NAME)
         IF (NIMAGE.EQ.1) IMNAME = NAME
         IF (.NOT.SHORT) THEN
            WRITE (PRTEXT,1010) NAME, IBUF(MSQUAL),
     *         IBUF(MNO), DCLASS(ND), DIRTY(DD), FREQ
         ELSE
            WRITE (PRTEXT,1020) NAME, IBUF(MSQUAL),
     *         IBUF(MNO), DCLASS(ND), DIRTY(DD), FREQ
            END IF
         CALL PRTPLI (2, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Img size, max/min
         X = 2.0 ** IBUF(14)
         Y = IBUF(16) * X
         X = IBUF(15) * X
         IF (.NOT.SHORT) THEN
            WRITE (PRTEXT,1011) IBUF(D2NX), IBUF(D2NY), X, Y
            IF (IBUF(67).GT.0) WRITE (PRTEXT,1011) IBUF(D2NX),
     *      IBUF(D2NY), X, Y, IBUF(67)
         ELSE
            WRITE (PRTEXT,1021) IBUF(D2NX), IBUF(D2NY), X, Y
            IF (IBUF(67).GT.0) WRITE (PRTEXT,1021) IBUF(D2NX),
     *         IBUF(D2NY), X, Y, IBUF(67)
            END IF
         CALL PRTPLI (3, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       RA, DEC, increments, rot.
         IF (IPTLEV.LT.0) GO TO 50
         ROT = IBUF(23) / 100.0
         C1 = 360.0D0 / 65536.0D0 / 32768.0D0
         CALL ZR8P4 ('4IB8', IBUF(27), RA)
         CALL ZR8P4 ('4IB8', IBUF(29), DEC)
         CALL ZR8P4 ('4IB8', IBUF(19), DERA)
         CALL ZR8P4 ('4IB8', IBUF(21), DEDEC)
         RA = RA * C1
         DEC = DEC * C1
         DERA = -DERA / 1.0D5
         DEDEC = DEDEC / 1.0D5
         CALL COORDD (1, RA, CH1, IRA, RAS)
         CALL COORDD (2, DEC, CH2, IDEC, DECS)
         IF (.NOT.SHORT) THEN
            WRITE (PRTEXT,1012) CH1, IRA, RAS, CH2, IDEC, DECS,
     *         DERA, DEDEC, ROT
         ELSE
            WRITE (PRTEXT,1022) CH1, IRA, RAS, CH2, IDEC, DECS,
     *         DERA, DEDEC, ROT
            END IF
         CALL PRTPLI (3, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Clean parms
         IF ((DD.NE.2) .OR. (IBUF(40).LE.0)) GO TO 50
            I = IBUF(8)/256
            I = MAX (1, I)
            IF (I.GT.4) I = 5
            ROT = IBUF(39) / 100.0
            CALL ZR8P4 ('4IB8', IBUF(35), DERA)
            DERA = DERA / 1.0D5
            CALL ZR8P4 ('4IB8', IBUF(37), DEDEC)
            DEDEC = DEDEC / 1.0D5
            IF (.NOT.SHORT) THEN
               WRITE (PRTEXT,1013) IBUF(40), DERA,
     *            DEDEC, ROT, PRODUC(I)
            ELSE
               WRITE (PRTEXT,1023) IBUF(40), DERA, DEDEC,
     *            ROT, PRODUC(I)
               END IF
            CALL PRTPLI (3, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Skip over the rows
 50      NX = IBUF(D2NX)
         NY = IBUF(D2NY)
         FDVEC(2) = NX * 2
         FDVEC(31) = 0
         FDVEC(32) = NY
         IF (IERR.NE.0) THEN
            IF (IERR.NE.IEREOF) THEN
               WRITE (MSGTXT,1050) IERR
               GO TO 985
            ELSE
               MSGTXT = 'UNEXPECTED END OF FILE STARTING TO READ '
     *            // 'IBM-MAP DATA'
               GO TO 990
               END IF
            END IF
         DO 70 I = 1,NY
            MSGTXT = ' '
            CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
            CALL PRTPLI (4, JER)
            IF (IERR.NE.0) THEN
               IF (IERR.NE.IEREOF) THEN
                  WRITE (MSGTXT,1060) IERR, I
                  GO TO 985
               ELSE
                  WRITE (MSGTXT,1061) I
                  GO TO 990
                  END IF
               GO TO 985
            ELSE
               NRECS = NRECS + 1
               BYTES = BYTES + FDVEC(42)
               FNRECS = FNRECS + 1
               FBYTES = FBYTES + FDVEC(42)
               END IF
            IF (JER.NE.0) THEN
               IRET = JER
               GO TO 999
               END IF
 70         CONTINUE
         GO TO 10
C
 980  WRITE (MSGTXT,1980) IERR
C
 985  IRET = 8
 990  CALL MSGWRT (8)
      CALL PRTPLI (4, IERR)
C                                       file output only
 995  IF (IPTLEV.LE.-3) THEN
         IMCLAS = 'IBMMAP'
         IMTYPE = 'IM'
         BTEMP = '# IMAGES'
         WRITE (CTEMP, 1994) NIMAGE
         WRITE (PRTEXT,1995) TAPNAM, NFILES, IMTYPE, IMNAME, IMCLAS,
     *      0, BTEMP, CTEMP
         CALL ZTXIO ('WRIT', PLUN, PIND, PRTEXT(:64), JER)
         IF (JER.NE.0) THEN
            WRITE (MSGTXT,1996) JER
            CALL MSGWRT (8)
            END IF
         IF (IRET.EQ.0) IRET = JER
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('Source= ''',A8,'''',I6,3X,'Mapno=',I6,3X,'Class',
     *   1X,A4,1X,A5,3X,'Freq=',F10.3,' MHz')
 1011 FORMAT ('Mapsize=',2I5,6X,'Min,max=',2(1PE13.4),5X,I2,
     *   ' blanking bits')
 1012 FORMAT ('RA=',A1,I2,I3,F7.3,2X,'Dec=',A1,I2,I3,F6.2,4X,
     *   'Cellsize=',2F8.3,4X,'Rotat=',F6.1)
 1013 FORMAT ('CLEAN iter',I6,4X,'Bmaj=',F8.4,' Bmin=',F8.4,' Bpa=',
     *   F6.1,4X,'Product= ',A8)
 1020 FORMAT ('Source= ''',A8,'''',I6,3X,'No=',I6,3X,'Class',
     *   1X,A4,1X,A5,3X,'Freq=',F10.3)
 1021 FORMAT ('Size=',2I5,5X,'Min,max=',2(1PE12.4),5X,I2,' SN bits')
 1022 FORMAT ('RA=',A1,I2,I3,F7.3,' Dec=',A1,I2,I3,F6.2,3X,
     *   'Cells=',2F8.3,3X,'Rot=',F6.1)
 1023 FORMAT ('Niter=',I6,4X,'Bmaj=',F7.3,'  Bmin=',F7.3,'  Bpa=',
     *   F6.1,4X,'Prod= ',A8)
 1050 FORMAT ('ERROR',I7,' STARTING TO READ IBM-MAP DATA')
 1060 FORMAT ('ERROR',I7,' READING IBM-MAP ROW',I5)
 1061 FORMAT ('UNEXPECTED END OF FILE READING IBM-MAP ROW',I5)
 1980 FORMAT ('ERROR',I7,' READING IBM-MAP HEADER')
 1994 FORMAT (I8)
 1995 FORMAT (A12,I6,1X,A2,1X,A12,1X,A6,I5,1X,A8,1X,A8)
 1996 FORMAT ('ZTXIO RETURNS ERROR',I5)
      END
      SUBROUTINE PRTFIT (IRET)
C-----------------------------------------------------------------------
C   PRTFIT prints each card image in a FITS headers.  It parses them
C   to determine the expected number of standard data records.  It
C   then skips over that number of records and counts any further
C   records in the file.
C   Output: IRET   I     Error code: 0 => ok incl unexpected EOF
C                        Other => serious tape error. quit
C-----------------------------------------------------------------------
      INTEGER IRET
C
      CHARACTER PTYPES(20)*8, TABNAM*8, SYM*8, TWORD(5)*8
      INTEGER   PCOUNT, NDIM, INC, NC, JJ, NPNT, ITYP, IEREOF, TABLES,
     *   TABWID, TABCRD, I, IC, IERR, ITAB, NCHAR, IER, GROUP,
     *   GCOUNT, TABCNT, JJ4, JJJ4, NAXIS, JER, II, IPIECE, ITRIM,
     *   USED(300)
      DOUBLE PRECISION    X, PSCAL(20), POFF(20)
      LOGICAL   EQUAL, DOIT, LEND, EOF, ISHIST
      REAL      PCMATX(7,7), CDMATX(7,7), PVMATX(7,7)
      INCLUDE 'PRTTP.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA IEREOF /4/
      DATA TWORD /'END     ', 'TABCOUNT', 'TABWIDTH',
     *   'TABCARDS', 'TABNAME '/
C-----------------------------------------------------------------------
      IPIECE = 1
C                                       open new version
 10   IF ((IPIECE.GT.1) .AND. (DODISK)) THEN
C                                       close old
         CALL TAPIO ('CLOS', FDVEC, TAPBUF, TBIND, IERR)
         I = ITRIM (INFILE)
         IF (IPIECE-1.GT.9) I = I - 1
         IF (IPIECE-1.GT.99) I = I - 1
         IF (IPIECE.LE.9) THEN
            WRITE (INFILE(I:),1010) IPIECE
         ELSE IF (IPIECE.LE.99) THEN
            WRITE (INFILE(I:),1011) IPIECE
         ELSE
            WRITE (INFILE(I:),1012) IPIECE
            END IF
         CALL CHR2H (48, INFILE, 1, FHVEC(7))
         CALL TAPIO ('OPRD', FDVEC, TAPBUF, TBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1015) IRET
            CALL MSGWRT (8)
            GO TO 999
            END IF
         END IF
C                                       Init printer
      CALL PRTPLI (1, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Init parms
      PCOUNT = 0
      NDIM = 0
      GROUP = 0
      GCOUNT = 1
      TABLES = 0
      CALL FILL (4, 0, NPV)
C                                       Init header
      DO 15 I = 1,20
         PSCAL(I) = 0.0D0
         POFF(I) = 0.0D0
         PTYPES(I) = ' '
 15      CONTINUE
      CALL RFILL (49, 0.0, PCMATX)
      CALL RFILL (49, 0.0, PVMATX)
      CALL RFILL (49, 0.0, CDMATX)
      CALL CATINI (CATBLK)
      CALL FILL (300, 0, USED)
      IERR = 0
      NRECS = NRECS - 1
      BYTES = BYTES - FDVEC(42)
      FNRECS = FNRECS - 1
      FBYTES = FBYTES - FDVEC(42)
C                                       Read header loop
      DO 50 JJ = 1,30000000
         IF ((JJ.GT.1) .OR. (IPIECE.GT.1)) THEN
            MSGTXT = ' '
            CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
            CALL PRTPLI (4, JER)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1020) IERR
               IF (IERR.EQ.IEREOF) GO TO 995
               GO TO 990
               END IF
            IF (JER.NE.0) THEN
               IRET = JER
               GO TO 999
               END IF
            END IF
         NRECS = NRECS + 1
         BYTES = BYTES + 2880
         FNRECS = FNRECS + 1
         FBYTES = FBYTES + 2880
         CALL ZC8CL (2880, 1, TAPBUF(TBIND), CBUF)
C                                       Loop over cards in block
         PRTEXT (1:NCR) = ' '
         DO 40 NC = 1,36
C                                       Print the card first
            INC = (NC-1) * 80 + 1
            PRTEXT = CBUF(INC:INC+79)
            ISHIST = PRTEXT(1:8) .EQ. 'HISTORY '
            DOIT = (IPTLEV.GE.2) .OR. ((IPTLEV.EQ.1) .AND.
     *         (.NOT.ISHIST) .AND. (PRTEXT(1:8).NE.' '))
            EQUAL = PRTEXT(1:8) .EQ. 'ORIGIN  '
            LEND = PRTEXT(1:8) .EQ. 'DATE    '
            DOIT = ((DOIT) .OR. (LEND) .OR. (EQUAL)) .AND. (IPTLEV.GE.0)
            IF (DOIT) CALL PRTPLI (3, IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Parse keywords
            IF ((.NOT.ISHIST) .OR. (XERR.LT.2)) THEN
               CALL FPARSE (NC, CBUF, PSCAL, POFF, PTYPES, TABLES, LEND,
     *            GROUP, BITPIX, BSCALE, BZERO, NAXIS, NPV, UVTABL,
     *            USED, IERR)
               IF (LEND) GO TO 60
               IF ((IERR.EQ.1) .AND. ((PRTEXT(:2).EQ.'CD') .OR.
     *            (PRTEXT(:2).EQ.'PC') .OR. (PRTEXT(:2).EQ.'PV')))
     *            CALL PCCARD (GROUP, PRTEXT, PCMATX, CDMATX, PVMATX)
               END IF
 40         CONTINUE
 50      CONTINUE
C                                       END found
C                                       PC -> CROTA
C                                       CD -> CDELT, CROTA
 60   CALL PCHDR (PCMATX, CDMATX, PVMATX)
      PCOUNT = CATBLK(KIPCN)
      GCOUNT = CATBLK(KIGCN)
      NDIM = CATBLK(KIDIM)
      VLBA = (NDIM.EQ.0) .AND. (GROUP.EQ.1) .AND. (GCOUNT.EQ.0) .AND.
     *   (PCOUNT.EQ.0) .AND. (BITPIX.EQ.8)
      IF ((PCOUNT.GT.0) .OR. VLBA .OR. UVTABL) THEN
         CALL CHR2H (2, 'UV', KHPTYO, CATH(KHPTY))
      ELSE
         CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
         END IF
      IF (VLBA) THEN
         NPIECE = 1
         CALL PRTVLB (IRET)
      ELSE IF (UVTABL) THEN
         MSGTXT = 'Reading binary tables for UV data'
         CALL MSGWRT (2)
         IPIECE = NPV(1)
         IF (NPIECE.LE.0) NPIECE = NPV(2)
         NPIECE = MIN (NPIECE, NPV(2))
      ELSE
         NPIECE = 1
         CALL PRTHDR (PSCAL, POFF, PTYPES, IRET)
         END IF
      IF (IRET.NE.0) GO TO 999
C                                       Size of data file
      X = 0.0D0
      IF (NDIM.LT.1) GO TO 120
         X = 1.0D0
         DO 110 I = 1,NDIM
            X = X * CATBLK(KINAX+I-1)
 110        CONTINUE
 120  X = X + PCOUNT
      IF (GCOUNT.GT.1) X = X * GCOUNT
      X = X * ABS(BITPIX) / 8.0D0
      JJ4 = (X - 1.D0) / 2880.0D0 + 1.0D0 + 1.0D-7
      JJJ4 = JJ4
      IF (UVTABL) JJJ4 = 0
C                                       Advance over data
C                                       fast advance for PRTLEV=-4
C                                       and file bigger than ~1 MByte
      IF ((IPTLEV.LE.-4) .AND. (JJ4.GT.400) .AND. (.NOT.DODISK)) THEN
         IF (UVTABL) CALL PRTHDR (PSCAL, POFF, PTYPES, IRET)
         CALL TAPIO ('ADVF', FDVEC, TAPBUF, TBIND, IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.4)) THEN
            WRITE (MSGTXT,1120) IERR
            GO TO 990
            END IF
C                                       Can't count tables
         BYTES = BYTES + JJ4 * 2880.D0
         NRECS = NRECS + JJ4
         FBYTES = FBYTES + JJ4 * 2880.D0
         FNRECS = FNRECS + JJ4
         IEXTRA = 0
         GO TO 250
C                                       Advance by reading data
      ELSE IF ((JJ4.GT.0) .AND. (.NOT.UVTABL)) THEN
 124     I = 0
         JJ = MIN (300000, JJ4)
         IF (IERR.NE.0) GO TO 130
         DO 125 I = 1,JJ
            MSGTXT = ' '
            CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
            CALL PRTPLI (4, JER)
            IF (IERR.NE.0) GO TO 130
            IF (JER.NE.0) THEN
               IRET = JER
               GO TO 999
               END IF
            NRECS = NRECS + 1
            BYTES = BYTES + 2880
            FNRECS = FNRECS + 1
            FBYTES = FBYTES + 2880
 125        CONTINUE
         JJ4 = JJ4 - JJ
         IF (JJ4.GT.0) GO TO 124
         END IF
      GO TO 135
C                                       Error
 130  CONTINUE
         WRITE (MSGTXT,1130) IERR, I
         IF (IERR.NE.IEREOF) GO TO 990
         GO TO 995
C                                       report reading
 135  WRITE (PRTEXT,1135) JJJ4
      IF ((IPTLEV.GE.0) .AND. (.NOT.VLBA)) CALL PRTPLI (2, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       See if we have new fits tables.
      IEXTRA = 0
      PRTEXT(1:NCR) = ' '
      CALL EXTPRT (IPTLEV, EOF, IRET)
      IF (IRET.NE.0) GO TO 999
      IF ((EOF) .AND. (TABLES.LE.0)) GO TO 250
      IEXTRA = 1
C                                       TABLES extensions
      IF (TABLES.LE.0) GO TO 230
      IEXTRA = 0
C                                       Loop over tables
         DO 220 ITAB = 1,TABLES
            TABCNT = 0
            TABWID = 0
            TABCRD = 0
            TABNAM = ' '
            DO 190 JJ = 1,2000
C                                       Loop over header cards
               PRTEXT(1:NCR) = ' '
               DO 180 NC = 1,36
                  INC = (NC-1) * 80 + 1
                  PRTEXT(1:80) = CBUF(INC:INC+79)
                  IF ((NC.EQ.1) .AND. (IPTLEV.GE.1)) CALL PRTPLI (2,
     *               IRET)
                  IF ((NC.NE.1) .AND. (IPTLEV.GE.1)) CALL PRTPLI (3,
     *               IRET)
                  IF (IRET.NE.0) GO TO 999
C                                       Care about keyword?
                  DO 165 IC = 1,5
                     EQUAL = PRTEXT(1:8) .EQ. TWORD(IC)
                     IF (EQUAL) GO TO 170
 165                 CONTINUE
                  GO TO 180
C                                       END card or must parse
 170              IF (IC.EQ.1) GO TO 200
                  NPNT = 1
                  CALL GETSYM (PRTEXT, NPNT, SYM, ITYP)
                  IF (ITYP.EQ.0) GO TO 175
                     WRITE (MSGTXT,1050) JJ, NC
                     CALL MSGWRT (7)
                     CALL PRTPLI (4, IRET)
                     IF (IRET.NE.0) GO TO 999
                     GO TO 180
 175              IF (IC.NE.5) THEN
                     CALL GETNUM (PRTEXT, 80, NPNT, X)
                     IF (X.EQ.DBLANK) GO TO 975
                     IF (IC.EQ.2) TABCNT = X + 0.01
                     IF (IC.EQ.3) TABWID = X + 0.01
                     IF (IC.EQ.4) TABCRD = X + 0.01
                  ELSE
                     CALL GETSTR (PRTEXT, 80, 8, NPNT, TABNAM, NCHAR)
                     END IF
 180              CONTINUE
C                                       Read next table header card.
               MSGTXT = ' '
               CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
               CALL PRTPLI (4, JER)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1150) IERR
                  IF (IERR.EQ.IEREOF) GO TO 995
                  GO TO 990
               ELSE
                  CALL ZC8CL (2880, 1, TAPBUF(TBIND), CBUF)
                  NRECS = NRECS + 1
                  BYTES = BYTES + 2880
                  FNRECS = FNRECS + 1
                  FBYTES = FBYTES + 2880
                  END IF
               IF (JER.NE.0) THEN
                  IRET = JER
                  GO TO 999
                  END IF
 190           CONTINUE
            WRITE (MSGTXT,1190) ITAB
            CALL MSGWRT (8)
            CALL PRTPLI (4, IRET)
            IF (IRET.NE.0) GO TO 999
            GO TO 230
C                                       Read over table data
 200        IF (TABCRD.LE.0) THEN
               WRITE (MSGTXT,1200) ITAB
               CALL MSGWRT (6)
               CALL PRTPLI (4, IRET)
               IF (IRET.NE.0) GO TO 999
               GO TO 230
               END IF
            WRITE (PRTEXT,1205) TABCNT
            PRTEXT(13:20) = TABNAM(1:8)
            IF (IPTLEV.LT.1) CALL PRTPLI (2, IRET)
            IF (IRET.NE.0) GO TO 999
            IF ((TABCNT.LE.0) .OR. (TABWID.LE.0)) GO TO 220
            X = TABCNT
            X = X * TABWID
            X = DINT ((X-1.0D0)/TABCRD) + 1.0D0
            X = X - (36-NC)
            IF (X.LT.1.0D0) GO TO 215
               JJ = (X-1.0D0) / 36.0D0 + 1.0D0
               DO 210 I = 1,JJ
C                                       Read next table
                  MSGTXT = ' '
                  CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
                  CALL PRTPLI (4, JER)
                  IF (IERR.NE.0) THEN
                     WRITE (MSGTXT,1206) IERR, I, ITAB
                     IF (IERR.EQ.IEREOF) GO TO 995
                     GO TO 990
                  ELSE
                     NRECS = NRECS + 1
                     BYTES = BYTES + 2880
                     FNRECS = FNRECS + 1
                     FBYTES = FBYTES + 2880
                     END IF
                  IF (JER.NE.0) THEN
                     IRET = JER
                     GO TO 999
                     END IF
 210              CONTINUE
 215        WRITE (PRTEXT,1215)
            IF (IPTLEV.GE.0) CALL PRTPLI (2, IRET)
            IF (IRET.NE.0) GO TO 999
 220        CONTINUE
C                                       Look for any extra records
 230  MSGSUP = 32000
      DO 240 I = 1,10000000
         IEXTRA = IEXTRA + 1
         UNKNWN = UNKNWN + 1
         MSGTXT = ' '
         CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
         CALL PRTPLI (4, JER)
         IF (IERR.NE.0) GO TO 245
         IF (JER.NE.0) THEN
            IRET = JER
            GO TO 999
            END IF
         NRECS = NRECS + 1
         BYTES = BYTES + 2880
         FNRECS = FNRECS + 1
         FBYTES = FBYTES + 2880
 240     CONTINUE
      MSGSUP = 0
      WRITE (PRTEXT,1240) IEXTRA
      CALL PRTPLI (2, IRET)
      II = 1
      IF (.NOT.DODISK) CALL ZTAPE ('ADVF', FDVEC(1), FDVEC(40), II,
     *   IERR)
      GO TO 250
C                                       error ?
 245  CONTINUE
         IEXTRA = IEXTRA - 1
         UNKNWN = UNKNWN - 1
         IF (IERR.NE.IEREOF) THEN
            MSGSUP = 0
            WRITE (MSGTXT,1245) IERR, IEXTRA
            GO TO 990
            END IF
 250  MSGSUP = 0
      IF (IEXTRA.LE.0) WRITE (PRTEXT,1250)
      IF (IEXTRA.GT.0) WRITE (PRTEXT,1251) IEXTRA
      IF ((IEXTRA.GT.0) .OR. (IPTLEV.GE.0)) CALL PRTPLI (2, IRET)
C                                       loop for more
      IF (IPIECE.LT.NPIECE) THEN
         IF (FNRECS.GT.0) THEN
            IF ((FNRECS.GT.1) .OR. (FBYTES.GT.512.0D0)) THEN
               FBYTES = FBYTES / (1024.0D0 * 1024.0D0)
               WRITE (MSGTXT,1991) FBYTES, FNRECS
               CALL MSGWRT (4)
               CALL PRTPLI (4, IERR)
               END IF
            FNRECS = 0
            FBYTES = 0.0D0
            END IF
         NFILES = NFILES + 1
         IPIECE = IPIECE + 1
         GO TO 10
         END IF
      GO TO 999
C
 975  MSGTXT = 'PRTFIT: NUMBER ERROR PARSING CARD' // PRTEXT
 990  IRET = 8
 995  CALL MSGWRT (8)
      CALL PRTPLI (4, IER)
      IF ((IERR.EQ.IEREOF) .AND. (IRET.NE.8)) THEN
         MSGTXT = 'UNEXPECTED END OF FILE'
         CALL MSGWRT (6)
         CALL PRTPLI (4, IRET)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (I1)
 1011 FORMAT (I2)
 1012 FORMAT (I3)
 1015 FORMAT ('ERROR OPENING NEW DISK FILE:',I7)
 1020 FORMAT ('ERROR',I7,' READING FITS TAPE')
 1050 FORMAT ('Recognized keyword in record',I5,' card',I3,
     *   'IMPROPER TYPE')
 1120 FORMAT ('ERROR ADVANCING TO EOF',I5)
 1130 FORMAT ('ERROR',I7,' TRYING TO READ RECORD',I5,'  OF FITS DATA')
 1135 FORMAT (I7,' records of FITS data read correctly')
 1150 FORMAT ('ERROR',I7,' READING FITS TABLE HEADER')
 1190 FORMAT ('END NOT FOUND FOR FITS TABLE HEADER',I6)
 1200 FORMAT ('FITS TABLE',I7,' ILLEGAL VALUE FOR TABCARDS')
 1205 FORMAT ('Tablename= ''',8X,'''',6X,'Tablesize=',I10)
 1206 FORMAT ('ERROR',I7,' READING RECORD',I4,' IN TABLE',I4)
 1215 FORMAT ('All FITS table records read')
 1240 FORMAT ('MORE THAN',I7,' UNKNOWN RECORDS FOLLOW FITS DATA')
 1245 FORMAT ('ERROR',I7,' AFTER',I7,' RECORDS FOLLOWING THE DATA')
 1250 FORMAT ('End of file read as expected')
 1251 FORMAT (I7,' unknown records follow FITS data')
 1991 FORMAT ('This file: read',F10.3,' Megabytes in',I8,
     *   ' logical records')
      END
      SUBROUTINE EXTPRT (PRTLEV, EOF, IERR)
C-----------------------------------------------------------------------
C   This routine will parse a block from a FITS tape and look for the
C   required cards of a FIT extension header block
C   XTENSION, BITPIX, NAXIS, NAXISn, PCOUNT, GCOUNT.
C   Inputs:
C      PRTLEV       I   Amount of printing.
C   In/Out from common:
C      IBUF(*)      I   a block of fit header data.
C      TBIND        I   Pointer in IBUF
C   Outputs:
C      EOF          L   T means End of file on read.
C      IERR         I   0=ok, 1=messed up. An error message will
C                       be printed.
C-----------------------------------------------------------------------
      CHARACTER STRING*80, SYM*8, EWORD(7)*8, SYMBOL*8, SNAXIS*8,
     *   CHSKIP(3)*4, EXTTYP*16, CVER*1
      INTEGER   PRTLEV, IERR, NAXIS, PCOUNT, GCOUNT, NAXISI(50),
     *   ILINES, INBLK, JJ4, IKEYWD, NPNT, ITABNO, II, JJ, NBY, NBYT,
     *   NCHAR, I, NLEN, TERR, IFOUND, ICARD, K, INC, ITYP, IER, JER,
     *   TFIELD, NFOUND, IDUM(2)
      LOGICAL   END, TABL, EQUAL, EOF
      DOUBLE PRECISION    X, NBITS, AXCNT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'PRTTP.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA CHSKIP /'HIST','COMM','    '/
      DATA EWORD /'XTENSION', 'BITPIX  ',  'NAXIS   ',
     *   'PCOUNT  ', 'GCOUNT  ', 'TFIELDS', 'EXTNAME ' /
      DATA IDUM /2*0/
C-----------------------------------------------------------------------
      NBY = 2880 * 2
      DO 700 K = 1,32000
C                                       Read 1st block.
 10      MSGTXT = ' '
         CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, TERR)
         CALL PRTPLI (4, JER)
         IF (TERR.NE.0) THEN
            IF (TERR.EQ.4) GO TO 940
            WRITE (MSGTXT,1000)
            GO TO 980
            END IF
         IF (JER.NE.0) THEN
            IERR = JER
            GO TO 999
            END IF
         NRECS = NRECS + 1
         BYTES = BYTES + 2880
         FNRECS = FNRECS + 1
         FBYTES = FBYTES + 2880
         CALL ZC8CL (2880, 1, TAPBUF(TBIND), CBUF)
         IF (CBUF(:8).NE.EWORD(1)) THEN
            IF (CBUF(:7).EQ.'TABNAME') GO TO 950
            IF (CBUF(:8).EQ.'SIMPLE  ') THEN
               MSGTXT = 'EXTPRT: NEW FITS FILE FOUND WHILE LOOKING FOR'
     *            // ' TABLE EXTENSION'
               CALL MSGWRT (8)
               GO TO 950
               END IF
            UNKNWN = UNKNWN + 1
            GO TO 10
            END IF
         EOF = .FALSE.
C                                       Look for XTENSION= 'type' card
         ICARD = 1
         IKEYWD = 1
         NPNT = 1
         CALL GTWCRD (ICARD, 1, IDUM, EWORD(IKEYWD), CBUF, NPNT,
     *      PRTEXT, SYMBOL, ITABNO, NFOUND, IFOUND, CVER, END, IERR)
         IF (IERR.NE.0) GO TO 950
         IF (PRTLEV.GE.0) CALL PRTPLI (2, IERR)
         IF (IERR.NE.0) GO TO 999
         NLEN = 16
         CALL GETSTR (PRTEXT, 80, NLEN, NPNT, STRING, NCHAR)
         NBYT = 16
         EXTTYP = ' '
         EXTTYP(1:NCHAR) = STRING(1:NCHAR)
C
         ICARD = ICARD + 1
         IKEYWD = IKEYWD + 1
         NPNT = 1
         CALL SKPBLK (CBUF, ICARD, FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GTWCRD (ICARD, 1, IDUM, EWORD(IKEYWD), CBUF, NPNT,
     *      PRTEXT, SYMBOL, ITABNO, NFOUND, IFOUND, CVER, END, IERR)
         IF (IERR.NE.0) GO TO 970
         IF (PRTLEV.GT.0) CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Get value of BITPIX
         CALL GETNUM (PRTEXT, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 975
         IF (X.GT.0.) BITPIX = X + 0.1
         IF (X.LE.0.) BITPIX = X - 0.1
C                                       Warning-Non standard bits/pixel.
         IF ((BITPIX.NE.8) .AND. (BITPIX.NE.16) .AND. (BITPIX.NE.32))
     *      THEN
            IF ((EXTTYP.NE.'IMAGE') .OR. (BITPIX.NE.-32)) THEN
               WRITE (MSGTXT,1010) BITPIX
               CALL MSGWRT (5)
               CALL PRTPLI (4, IERR)
               IF (IERR.NE.0) GO TO 999
               END IF
            END IF
C                                       Get NAXIS
         BITPIX = ABS (BITPIX)
         ICARD = ICARD + 1
         IKEYWD = IKEYWD + 1
         NPNT = 1
         CALL SKPBLK (CBUF, ICARD, FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GTWCRD (ICARD, 1, IDUM, EWORD(IKEYWD), CBUF, NPNT,
     *      PRTEXT, SYMBOL, ITABNO, NFOUND, IFOUND, CVER, END, IERR)
         IF (IERR.NE.0) GO TO 980
         IF (PRTLEV.GT.0) CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GETNUM (PRTEXT, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 975
         NAXIS = X + .01
C                                       Check for invalid no. of axis
C                                       for our buffer.
         IF (NAXIS.GT.50) GO TO 960
C                                       Find NAXISi
         DO 230 I = 1,NAXIS
            ICARD = ICARD + 1
            NPNT = 1
            CALL SKPBLK (CBUF, ICARD, FDVEC, TAPBUF, TBIND, IERR)
            IF (IERR.NE.0) GO TO 999
            IF (I.LE.10) THEN
               NLEN = 6
               WRITE (STRING,1020) I
            ELSE
               NLEN = 7
               WRITE (STRING,1200) I
               END IF
            SNAXIS = ' '
            SNAXIS(1:NLEN) = STRING(1:NLEN)
            CALL GTWCRD (ICARD, 1, IDUM, SNAXIS, CBUF, NPNT, PRTEXT,
     *         SYMBOL, ITABNO, NFOUND, IFOUND, CVER, END, IERR)
            IF (IERR.NE.0) GO TO 970
            IF (PRTLEV.GT.0) CALL PRTPLI (3, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GETNUM (PRTEXT, 80, NPNT, X)
            IF (X.EQ.DBLANK) GO TO 975
            NAXISI(I) = X + .01
 230        CONTINUE
C                                       PCOUNT
         ICARD = ICARD + 1
         IKEYWD = IKEYWD + 1
         NPNT = 1
         CALL SKPBLK (CBUF, ICARD, FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GTWCRD (ICARD, 1, IDUM, EWORD(IKEYWD), CBUF, NPNT,
     *      PRTEXT, SYMBOL, ITABNO, NFOUND, IFOUND, CVER, END, IERR)
         IF (IERR.NE.0) GO TO 980
         IF (PRTLEV.GT.0) CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GETNUM (PRTEXT, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 975
         PCOUNT = X
C                                       Get GCOUNT
         ICARD = ICARD + 1
         IKEYWD = IKEYWD + 1
         NPNT = 1
         CALL SKPBLK (CBUF, ICARD, FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GTWCRD (ICARD, 1, IDUM, EWORD(IKEYWD), CBUF, NPNT,
     *      PRTEXT, SYMBOL, ITABNO, NFOUND, IFOUND, CVER, END, IERR)
         IF (IERR.NE.0) GO TO 980
         IF (PRTLEV.GT.0) CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GETNUM (PRTEXT, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 975
         GCOUNT = X
C                                       Get TFIELDS
         IF (EXTTYP.NE.'IMAGE') THEN
            ICARD = ICARD + 1
            IKEYWD = IKEYWD + 1
            NPNT = 1
            CALL SKPBLK (CBUF, ICARD, FDVEC, TAPBUF, TBIND, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GTWCRD (ICARD, 1, IDUM, EWORD(IKEYWD), CBUF, NPNT,
     *         PRTEXT, SYMBOL, ITABNO, NFOUND, IFOUND, CVER, END, IERR)
            IF (IERR.NE.0) GO TO 980
            IF (PRTLEV.GT.0) CALL PRTPLI (3, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GETNUM (PRTEXT, 80, NPNT, X)
            IF (X.EQ.DBLANK) GO TO 975
            TFIELD = X
            END IF
C                                       Forget about table name if we
C                                       are printing everything.
         IF (PRTLEV.LE.0) THEN
            TABL = ((EXTTYP(1:8) .EQ. 'TABLE   ') .OR.
     *      (EXTTYP(1:8) .EQ. 'A3DTABLE') .OR.
     *      (EXTTYP(1:8) .EQ. '3DTABLE ') .OR.
     *      (EXTTYP(1:8) .EQ. 'BINTABLE'))
         ELSE
            TABL = .FALSE.
            END IF
C                                       Read until we get an end card
         DO 400 I = 1, 32000
            ICARD = ICARD + 1
C                                       Read another block of data.
            IF (ICARD.GE.37) THEN
               MSGTXT = ' '
               CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, TERR)
               CALL PRTPLI (4, JER)
               IF (TERR.NE.0) THEN
                  IF (TERR.EQ.4) GO TO 940
                  WRITE (MSGTXT,1000)
                  GO TO 980
                  END IF
               IF (JER.NE.0) THEN
                  IERR = JER
                  GO TO 999
                  END IF
               NRECS = NRECS + 1
               BYTES = BYTES + 2880
               FNRECS = FNRECS + 1
               FBYTES = FBYTES + 2880
               ICARD = 1
               CALL ZC8CL (2880, 1, TAPBUF(TBIND), CBUF)
               END IF
C
            INC = (ICARD - 1) * 80 + 1
            PRTEXT(1:80) = CBUF(INC:INC+79)
            EQUAL = PRTEXT(1:4) .EQ. CHSKIP(1)
            IF (.NOT.EQUAL) EQUAL = PRTEXT(1:4) .EQ. CHSKIP(2)
            IF (.NOT.EQUAL) EQUAL = PRTEXT(1:4) .EQ. CHSKIP(3)
            IF (PRTLEV.LE.0) EQUAL = .TRUE.
            IF (PRTLEV.GT.1) EQUAL = .FALSE.
            IF (.NOT.EQUAL) CALL PRTPLI (3, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       Get next symbol.
            NPNT = 1
            CALL GETSYM (PRTEXT, NPNT, SYM, ITYP)
            SYMBOL(1:8) = SYM(1:8)
C                                       Test for END card.
            IF (SYMBOL.EQ.'END     ') GO TO 500
C                                       EXTNAME
            IF (SYMBOL.EQ.'EXTNAME') THEN
C                                       Print name and stop looking.
               IF (TABL) THEN
                  IF (PRTLEV.GE.-1) CALL PRTPLI (3, IERR)
                  IF (IERR.NE.0) GO TO 999
                  TABL = .FALSE.
                  END IF
               IF ((UVTABL) .AND. (PRTEXT(12:18).EQ.'AIPS UV')) THEN
                  CALL PRTUVT (ICARD, TFIELD, NAXIS, NAXISI, IERR)
                  IF (IERR.NE.0) GO TO 999
                  X = NAXISI(1)
                  X = NAXISI(2) * X
                  JJ4 = (X - 1.D0) / 2880.0D0 + 1.0D0 + 1.0D-7
C                                       Advance over data
C                                       fast advance for PRTLEV=-4
C                                       and file bigger than ~1 MByte
                  IF ((IPTLEV.LE.-4) .AND. (JJ4.GT.400) .AND.
     *               (.NOT.DODISK)) THEN
                     CALL TAPIO ('ADVF', FDVEC, TAPBUF, TBIND, IERR)
                     IF ((IERR.NE.0) .AND. (IERR.NE.4)) THEN
                        WRITE (MSGTXT,1120) IERR
                        CALL MSGWRT (8)
                        END IF
C                                       Can't count tables
                     BYTES = BYTES + JJ4 * 2880.D0
                     NRECS = NRECS + JJ4
                     FBYTES = FBYTES + JJ4 * 2880.D0
                     FNRECS = FNRECS + JJ4
                     IEXTRA = 0
                     GO TO 999
                     END IF
                  GO TO 500
                  END IF
               END IF
 400        CONTINUE
C                                       Shouldn't get here.
         WRITE (MSGTXT,1400)
         CALL MSGWRT (6)
         CALL PRTPLI (4, IER)
         GO TO 999
C                                       End card found
C                                       Advance the proper number of
C                                       records.
C                                       Calculate no. of data blocks.
 500     AXCNT = 1
         DO 550 II = 1,NAXIS
            AXCNT = AXCNT * NAXISI(II)
 550        CONTINUE
         AXCNT = AXCNT + PCOUNT
         NBITS = (ABS(BITPIX) / 8) * GCOUNT * AXCNT
         INBLK = (NBITS + 2879.0D0) / 2880.0D0
         JJ4 = 0
 560     JJ = 300000
            IF (INBLK.LT.JJ) JJ = INBLK
            DO 565 I = 1,JJ
               JJ4 = JJ4 + 1
               MSGTXT = ' '
               CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
               CALL PRTPLI (4, JER)
               IF (IERR.NE.0) GO TO 570
               IF (JER.NE.0) THEN
                  IERR = JER
                  GO TO 999
                  END IF
               NRECS = NRECS + 1
               BYTES = BYTES + 2880
               FNRECS = FNRECS + 1
               FBYTES = FBYTES + 2880
 565           CONTINUE
            INBLK = INBLK - JJ
            IF (INBLK.LE.0) GO TO 580
            GO TO 560
C                                       Error
 570     IF (IERR.NE.4) THEN
            WRITE (MSGTXT,1570) IERR, JJ4
         ELSE
            WRITE (MSGTXT,1571) JJ4
            END IF
         CALL MSGWRT (8)
         CALL PRTPLI (4, IER)
         GO TO 999
C                                       Print tape summary.
C                                       Suppress for terse output.
 580     IF (PRTLEV.GE.-1) THEN
            IF (NAXISI(1).GT.0) AXCNT = AXCNT / NAXISI(1)
            ILINES = AXCNT
            WRITE (PRTEXT,1580) ILINES
            CALL PRTPLI (3, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 700     CONTINUE
C                                       End of file.
 940  IERR = 0
      EOF = .TRUE.
      GO TO 999
C                                       Not extension record.
 950  IERR = 0
      GO TO 999
C                                       Invalid number of axis.
 960  WRITE (MSGTXT,1960) NAXIS
      GO TO 980
C                                       Expected keyword not found.
 970  WRITE (MSGTXT,1970) EWORD(IKEYWD), SYMBOL
      GO TO 980
 975  MSGTXT = 'EXTPRT: NUMBER ERROR ON ' // SYMBOL
C                                       Print error message set flag.
 980  CALL MSGWRT (6)
      CALL PRTPLI (2, IERR)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR READING TAPE')
 1010 FORMAT ('WARNING! Nonstandard bits per pixel =',I6)
 1020 FORMAT ('NAXIS',I1)
 1120 FORMAT ('ERROR ADVANCING TO EOF',I5)
 1200 FORMAT ('NAXIS',I2)
 1400 FORMAT ('MORE THAN 32000 HEADER CARDS FOR THIS EXTENSION.')
 1570 FORMAT ('TAPE READ ERROR',I4,' AT BLOCK',I8,' IN EXTENSION DATA')
 1571 FORMAT ('UNEXPECTED END OF FILE AT BLOCK',I8,' IN EXTENSION DATA')
 1580 FORMAT ('Number of extension data lines =',I8)
 1960 FORMAT ('NUMBER OF AXIS TOO LARGE FOR BUFFER =',I6)
 1970 FORMAT ('EXPECTED KEYWORD ',A8,'. FOUND ',A8,'.')
      END
      SUBROUTINE PRTHDR (PSCAL, POFF, PTYPES, IERR)
C-----------------------------------------------------------------------
C   PRTHDR lists the contents of a standard header on the printer.
C   Inputs:
C      PSCAL    D(20)     Random parameter scaling factors
C      POFF     D(20)     Random parameter offsets
C      PTYPES   C(20)*8   Random parameter types
C   Output:
C      IERR     I         not 0 => please quit
C-----------------------------------------------------------------------
      CHARACTER PTYPES(20)*(*)
      DOUBLE PRECISION PSCAL(20), POFF(20)
      INTEGER   IERR
C
      CHARACTER LDATE*12, MDATE*12, VTYA(2)*8, VTYB(3)*4, PRODUC(5)*8,
     *   BTEMP*8, CTEMP*8, BCODE(7)*10, CH1*1, CH2*1, IMTYPE*2,
     *   IMNAME*12, IMCLAS*6, CTYPE*2
      INTEGER   I, J, NAX, HM(2), INC, KPT, DM(2), CLAXIS, CMAXIS, IBS
      REAL      SEC, DEC, BEAMS(3), DSEC, XTEST, YTEST
      DOUBLE PRECISION    BS, BZ, FREQ
      LOGICAL   ISUV, ISFREQ
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'PRTTP.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA VTYA, VTYB /'OPTICAL ','RADIO   ', 'LSR ','SUN ',
     *   'YOU '/
      DATA PRODUC /'NORMAL  ','COMPNTS ','RESIDUAL','POINTS  ',
     *   'DIRTY   '/
      DATA BCODE /'UNKNOWN ','PIXEL 8BIT','SHORT INT ',
     *   'LONG INT','DOUBLE INT','FLOATING','DBL FLOAT'/
C-----------------------------------------------------------------------
C                                       Image name and file name
      CALL H2CHR (8, 1, CATH(KHOBJ), BTEMP)
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), IMNAME)
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), IMCLAS)
      CALL H2CHR (2, KHPTYO, CATH(KHPTY), IMTYPE)
      ISUV = IMTYPE.EQ.'UV'
C                                       file output only
      IF (IPTLEV.LE.-3) THEN
         CALL H2CHR (8, 1, CATH(KHDOB), BTEMP)
         CALL H2CHR (8, 1, CATH(KHDMP), CTEMP)
         WRITE (PRTEXT,1300) TAPNAM, NFILES, IMTYPE, IMNAME, IMCLAS,
     *      CATBLK(KIIMS), BTEMP, CTEMP
         CALL ZTXIO ('WRIT', PLUN, PIND, PRTEXT(:64), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1301) IERR
            CALL MSGWRT (8)
            END IF
         GO TO 999
         END IF
C                                       Terse message.
      IF (IPTLEV.LE.-1) THEN
         WRITE (PRTEXT,1200) BTEMP, IMTYPE, IMNAME, IMCLAS,
     *      CATBLK(KIIMS)
         CALL PRTPLI (3, IERR)
C                                       Decode Observation and map date
         CALL H2CHR (8, 1, CATH(KHDOB), CTEMP)
         CALL DATDAT (CTEMP, LDATE)
         CALL H2CHR (8, 1, CATH(KHDMP), CTEMP)
         CALL DATDAT (CTEMP, MDATE)
C                                       get number of axies
         NAX = CATBLK(KIDIM)
C                                       assume no frequency
         ISFREQ = .FALSE.
C                                       For all axis
         DO 50 I = 1,NAX
            KPT = KHCTP+(I-1)*2
C                                       Iranslate label
            CALL H2CHR (8, 1, CATH(KPT), CTEMP)
C                                       If Frequency
            IF (CTEMP(1:4).EQ.'FREQ') THEN
C                                       Record frequency
               FREQ  = CATD(KDCRV-1+I)
               ISFREQ = .TRUE.
               END IF
C                                       End for all axies
 50         CONTINUE
C                                       If a frequency in header
         IF (ISFREQ) THEN
C                                       Check if visibilities
            IBS = CATBLK(KIGCN)
            J = CATBLK(KIPCN)
            IF (IBS.GT.0 .AND. J.GE.0) THEN
C                                       Write number of vis.
               WRITE (PRTEXT,1041) LDATE, FREQ, IBS
            ELSE
C                                       Else write image size
               WRITE (PRTEXT,1042) LDATE, FREQ,
     *            (CATBLK(I+KINAX-1), I=1,NAX)
               END IF
         ELSE
C                                       Else write image size
            WRITE (PRTEXT,1043) LDATE, (CATBLK(I+KINAX-1), I=1,NAX)
            END IF
         CALL PRTPLI (3, IERR)
         GO TO 999
C                                       End if terse message
         END IF
C                                       short message only
      IF (IPTLEV.LT.0) THEN
         NAX = MIN (CATBLK(KIDIM), KICTPN)
         NAX = NAX + KINAX - 1
C                                       if wide print out
         IF (NCR.GE.120) THEN
            WRITE (PRTEXT,1000) BTEMP, IMTYPE, IMNAME, IMCLAS,
     *         CATBLK(KIIMS), CATR (KRDMN), CATR(KRDMX),
     *         (CATBLK(I), I = KINAX, NAX)
            IF (ISUV) WRITE (PRTEXT,1001) BTEMP, IMTYPE, IMNAME, IMCLAS,
     *         CATBLK(KIIMS), CATBLK(KIPCN), (CATBLK(I), I = KINAX,NAX)
            CALL PRTPLI (3, IERR)
            GO TO 999
         ELSE
C                                       Else Narrow paper
            WRITE (PRTEXT,1010) BTEMP, IMTYPE, IMNAME, IMCLAS,
     *         CATBLK(KIIMS)
            CALL PRTPLI (3, IERR)
            IF (IERR.NE.0) GO TO 999
            WRITE (PRTEXT,1005) CATR(KRDMN), CATR(KRDMX), (CATBLK(I),
     *         I = KINAX,NAX)
            IF (ISUV) WRITE (PRTEXT,1006) CATBLK(KIPCN), (CATBLK(I),
     *         I = KINAX,NAX)
            CALL PRTPLI (3, IERR)
            END IF
C                                       End if short message
         END IF
      WRITE (PRTEXT,1010) BTEMP, IMTYPE, IMNAME, IMCLAS, CATBLK(KIIMS)
      CALL PRTPLI (2, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Telescope and Receiver
      CALL H2CHR (8, 1, CATH(KHTEL), BTEMP)
      CALL H2CHR (8, 1, CATH(KHINS), CTEMP)
      WRITE (PRTEXT,1020) BTEMP, CTEMP
      CALL PRTPLI (3, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Observer and user #
      CALL H2CHR (8, 1, CATH(KHOBS), BTEMP)
      WRITE (PRTEXT,1030) BTEMP, CATBLK(KIIMU)
      CALL PRTPLI (3, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Observation and map date
      CALL H2CHR (8, 1, CATH(KHDOB), CTEMP)
      CALL DATDAT (CTEMP, LDATE)
      CALL H2CHR (8, 1, CATH(KHDMP), CTEMP)
      CALL DATDAT (CTEMP, MDATE)
      WRITE (PRTEXT,1040) LDATE, MDATE
      CALL PRTPLI (3, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Bit information
      I = 1
      IF (BITPIX.EQ.8) I = 2
      IF (BITPIX.EQ.16) I = 3
      IF (BITPIX.EQ.32) I = 4
      IF (BITPIX.EQ.64) I = 5
      IF (BITPIX.EQ.-32) I = 6
      IF (BITPIX.EQ.-64) I = 7
      WRITE (PRTEXT,1050) BCODE(I)
      CALL PRTPLI (3, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Scaling and offset factors
      BS = BSCALE(1)
      BZ = BZERO(1)
      IF (BS.EQ.0.0D0) BS = 1.0D0
      IF ((BS.NE.1.0D0) .OR. (BZ.NE.0.0D0)) THEN
         WRITE (PRTEXT,1060) BS, BZ
         CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Real minimum and maximum
      CALL H2CHR (8, 1, CATH(KHBUN), BTEMP)
      WRITE (PRTEXT,1070) CATR(KRDMX), CATR(KRDMN), BTEMP
      IF ((CATR(KRDMX).NE.0.0) .OR. (CATR(KRDMN).NE.0.0))
     *   CALL PRTPLI (3, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Random axes
      IBS = CATBLK(KIGCN)
      J = CATBLK(KIPCN)
      IF ((IBS.LT.1) .OR. (J.LE.0)) GO TO 90
         CALL H2CHR (2, 1, CATH(KITYP), CTYPE)
         WRITE (PRTEXT,1080) IBS, CTYPE
         CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
         WRITE (PRTEXT,1090)
         CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
         WRITE (PRTEXT,1082)
         CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
         J = MIN (J, 20)
         DO 85 I = 1,J
            WRITE (PRTEXT,1084) PSCAL(I), POFF(I)
            PRTEXT(12:19) = PTYPES(I)
            CALL PRTPLI (3, IERR)
            IF (IERR.NE.0) GO TO 999
 85         CONTINUE
C                                       Set up loop for axes
 90   NAX = CATBLK(KIDIM)
      WRITE (PRTEXT,1090)
      CALL PRTPLI (3, IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (PRTEXT,1091)
      CALL PRTPLI (3, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Loop over axes
      INC = 2
      CLAXIS = -1
      CMAXIS = -1
      DO 150 I = 1,NAX
         KPT = KHCTP+(I-1)*INC
         CALL H2CHR (8, 1, CATH(KPT), BTEMP)
C                                          Check axis type
         IF ((BTEMP(1:4).NE.'LL  ') .AND. (BTEMP(1:4).NE.'RA  ') .AND.
     *      (BTEMP(1:4).NE.'RA--')) GO TO 110
            CALL COORDD (1, CATD(KDCRV-1+I), CH1, HM, SEC)
            DEC = CATR(KRCIC-1+I)*3600.
            CLAXIS = I - 1
            GO TO 130
 110     IF ((BTEMP(1:4).NE.'MM  ') .AND. (BTEMP(1:4).NE.'DEC ') .AND.
     *      (BTEMP(1:4).NE.'DEC-')) GO TO 120
            CALL COORDD (2, CATD(KDCRV-1+I), CH1, HM, SEC)
            DEC = CATR(KRCIC-1+I)*3600.
            CMAXIS = I - 1
            GO TO 130
C                                          No RA or DEC axis
 120     WRITE (PRTEXT,1120) BTEMP, CATBLK(KINAX-1+I), CATD(KDCRV-1+I),
     *      CATR(KRCRP-1+I), CATR(KRCIC-1+I), CATR(KRCRT-1+I)
         CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
         GO TO 150
C                                          RA or DEC axis
 130     WRITE (PRTEXT,1130) BTEMP, CATBLK(KINAX-1+I), CH1, HM, SEC,
     *      CATR(KRCRP-1+I), DEC, CATR(KRCRT-1+I)
         CALL FILZCH (2, 19, PRTEXT)
         CALL FILZCH (2, 22, PRTEXT)
         CALL FILZCH (6, 25, PRTEXT)
         CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
 150     CONTINUE
      WRITE (PRTEXT,1090)
      CALL PRTPLI (3, IERR)
      IF (IERR.NE.0) GO TO 999
C                                          Maptype and iterations
      IF ((CATBLK(KINIT).LE.0) .AND. (CATR(KRBMJ).LE.0.) .AND.
     *   (CATR(KRBMN).LE.0.)) GO TO 170
         I = MAX (1, CATBLK(KITYP))
         IF (I.GT.4) I = 1
         IF (CATBLK(KINIT).LE.0) I = 5
         WRITE (PRTEXT,1160) PRODUC(I), CATBLK(KINIT)
         CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
C                                          Beam Parameters
         BEAMS(1) = CATR(KRBMJ) * 3600.0
         BEAMS(2) = CATR(KRBMN) * 3600.0
         BEAMS(3) = CATR(KRBPA)
         WRITE (PRTEXT,1161) BEAMS
         IF ((BEAMS(1).LT.0.5) .AND. (BEAMS(2).LT.0.5))
     *      WRITE (PRTEXT,1162) BEAMS
         CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Observed RA, Dec
 170  XTEST = 1.0E-8
      IF (CLAXIS.GE.0) XTEST = MAX(ABS(CATR(KRCIC+CLAXIS))/100.,XTEST)
      YTEST = 1.0E-8
      IF (CMAXIS.GE.0) YTEST = MAX(ABS(CATR(KRCIC+CMAXIS))/100.,YTEST)
      IF ((CATD(KDORA).EQ.0.0D0) .AND. (CATD(KDODE).EQ.0.0D0)) GO TO 180
         IF ((CLAXIS.GE.0) .AND. (ABS(CATD(KDORA)-
     *      CATD(KDCRV+CLAXIS)).LT.
     *      XTEST) .AND. (CMAXIS.GE.0) .AND. (ABS(CATD(KDODE)-
     *      CATD(KDCRV+CMAXIS)).LT.YTEST)) GO TO 180
            CALL COORDD (1, CATD(KDORA), CH1, HM, SEC)
            CALL COORDD (2, CATD(KDODE), CH2, DM, DSEC)
            WRITE (PRTEXT,1170) CH1, HM, SEC, CH2, DM, DSEC
            I = 14
            CALL FILZCH (2, I, PRTEXT)
            I = 17
            CALL FILZCH (2, I, PRTEXT)
            I = 20
            CALL FILZCH (6, I, PRTEXT)
            I = 35
            CALL FILZCH (2, I, PRTEXT)
            I = 38
            CALL FILZCH (2, I, PRTEXT)
            I = 41
            CALL FILZCH (6, I, PRTEXT)
            CALL PRTPLI (3, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       Shifts
 180  IF ((CATR(KRXSH).EQ.0.0) .AND. (CATR(KRYSH).EQ.0.0)) GO TO 190
         IF ((ABS(CATR(KRXSH)).LT.XTEST) .AND. (ABS(CATR(KRYSH))
     *      .LT.YTEST)) GO TO 190
         SEC = 3600. * CATR(KRXSH)
         DSEC = 3600. * CATR(KRYSH)
         WRITE (PRTEXT,1180) SEC, DSEC
         CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Alternative axis type
 190  IF (CATBLK(KIALT).EQ.0) GO TO 200
         I = CATBLK(KIALT)/256 + 1
         J = CATBLK(KIALT) - (I-1) * 256
         IF ((I.LT.1) .OR. (I.GT.2) .OR. (J.LT.1) .OR. (J.GT.3))
     *      GO TO 200
            BS = CATD(KDRST) / 1.D6
            WRITE (PRTEXT,1190) BS, VTYA(I), VTYB(J)
            CALL PRTPLI (3, IERR)
            IF (IERR.NE.0) GO TO 999
            WRITE (PRTEXT,1191) CATD(KDARV), CATR(KRARP)
            CALL PRTPLI (3, IERR)
            IF (IERR.NE.0) GO TO 999
C
 200  I = CATBLK(KICCL) + CATBLK(KICBP) + CATBLK(KICPD)
      IF (I.GT.0) THEN
         WRITE (PRTEXT,1195) CATBLK(KICCL), CATBLK(KICBP), CATBLK(KICPD)
         CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF

C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Image=',A8,' (',A2,')','  Name=',A12,'.',A6,'.',I4,
     *   '  Min,max=',2(1PE11.3),'  Size=',2I5,5I4)
 1001 FORMAT ('Image=',A8,'  (',A2,')','   Name=',A12,'.',A6,'.',I4,
     *   '   # parms=',I3,'   Size=',7I3)
 1005 FORMAT ('Min,max=',2(1PE11.3),'  Size=',2I5,5I4)
 1006 FORMAT ('# parms=',I3,'   Size=',7I3)
 1010 FORMAT ('Image=',A8,'  (',A2,')',9X,'Filename=',A12,'.',A6,
     *   '.',I4)
 1020 FORMAT ('Telescope=',A8,11X,'Receiver=',A8)
 1030 FORMAT ('Observer=',A8,12X,'User #=',I5)
 1040 FORMAT ('Observ. date=',A12,4X,'Map date=',A12)
 1041 FORMAT ('Observ. date=',A12,' Freq=',1PE14.7,', # vis=',I10)
 1042 FORMAT ('Observ. date=',A12,' Freq=',1PE14.7,': ',7I6)
 1043 FORMAT ('Observ. date=',A12,': ',7I6)
 1050 FORMAT ('Pixel type: ',A10)
 1060 FORMAT ('Map scale=',1PE15.8,4X,'Map offset=',E15.8)
 1070 FORMAT ('Maximum=',1PE15.8,6X,'Minimum=',E15.8,1X,A8)
 1080 FORMAT ('# visibilities',I10,5X,'Sort order  ',A2)
 1082 FORMAT ('Rand axes: Type',10X,'Pscale',10X,'Pzero')
 1084 FORMAT (20X,2(2X,1PE14.7))
 1090 FORMAT (2('--------------------------------'))
 1091 FORMAT ('Type    Pixels   Coord value     at Pixel ',
     *   '    Coord incr   Rotat')
 1120 FORMAT (A8,I6,2X,1PE14.7,0PF11.2,1PE15.7,0PF8.2)
 1130 FORMAT (A8,I6,3X,A1,I2,I3,F7.3,F11.2,F15.4,F8.2)
 1160 FORMAT ('Map type=',A8,12X,'Number of iterations=',I8)
 1161 FORMAT ('Conv size=',F7.2,' X',F7.2,3X,'Position angle=',F7.2)
 1162 FORMAT ('Conv size=',F8.5,' X',F8.5,3X,'Position angle=',F7.2)
 1170 FORMAT ('Observed RA ',A1,I2,I3,F7.3,4X,'Dec ',A1,I2,I3,F6.2)
 1180 FORMAT ('Phase shifted in X',F9.3,2X,'in Y',F9.3)
 1190 FORMAT ('Rest freq',F11.3,9X,'Vel type: ',A7,' wrt ',A4)
 1191 FORMAT ('Alt ref. value',1PE13.5,2X,'wrt pixel',0PF8.2)
 1195 FORMAT ('Cals applied:',I5,' DOCAL',I4,' DOBAND',I4,' DOPOL')
 1200 FORMAT ('Image=',A8,' (',A2,')',' Name=',A12,'.',A6,'.',I4)
 1300 FORMAT (A12,I6,1X,A2,1X,A12,1X,A6,I5,1X,A8,1X,A8)
 1301 FORMAT ('ZTXIO RETURNS ERROR',I5)
      END
      SUBROUTINE PRTUVT (ICARD, NCOLS, ND, NAXI, IRET)
C-----------------------------------------------------------------------
C   PRTUVT lists the contents of a UV binary table file header on the
C   printer.  It assumes that it needs to read all tape records
C   containing the table header and leaves the CATBLK set for and the
C   tape positioned at the binary data for skipping by the calling
C   routine.
C   Input:
C      ICARD   I      Buffer card number of last processed card image
C      NCOLS   I      Number of columns in table
C      ND      I      number of axes
C      NAXI    I(7)   Number points each axis
C   Output:
C      IRET    I      not 0 => please quit
C-----------------------------------------------------------------------
      INTEGER   ICARD, NCOLS, ND, NAXI(7), IRET
C
      INTEGER   MXTBKW
      PARAMETER (MXTBKW = 200)
      CHARACTER PTYPES(20)*8, DIMCRD*80, CHNCOL*3, KEYWRD(MXTBKW)*8,
     *   KEYCHR(MXTBKW)*8, IMNAME*18, SORT*2, DATMAP*8
      INTEGER   PCOUNT, NDIM, INC, NC, JJ, IEREOF, TABLES, I, GROUP,
     *   GCOUNT, JER, DIMSAV(2), J, OP, IERR, NC1, NUMKEY, NP,
     *   KEYTYP(MXTBKW), KEYV(2*MXTBKW), IMSEQ
      DOUBLE PRECISION    X, PSCAL(20), POFF(20), KEYVAL(MXTBKW)
      LOGICAL   EQUAL, DOIT, LEND
      INCLUDE 'PRTTP.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DTHD.INC'
      INCLUDE 'INCS:DBHD.INC'
      EQUIVALENCE (KEYVAL, KEYV)
      DATA IEREOF /4/
C-----------------------------------------------------------------------
      CALL H2CHR (18, KHIMNO, CATH(KHIMN), IMNAME)
      CALL H2CHR (2, 1, CATH(KITYP), SORT)
      CALL H2CHR (8, 1, CATH(KHDMP), DATMAP)
      IMSEQ = CATBLK(KIIMS)
C                                       Init parms
      WRITE (DIMCRD,1000) NCOLS
      IF (NCOLS.LT.10) THEN
         CHNCOL = DIMCRD(3:3)
      ELSE IF (NCOLS.LT.100) THEN
         CHNCOL = DIMCRD(2:3)
      ELSE
         CHNCOL = DIMCRD(1:3)
         END IF
      PCOUNT = 0
      NDIM = 0
      GROUP = 0
      GCOUNT = 1
      TABLES = 0
      NC1 = ICARD + 1
C                                       Init header
      DO 15 I = 1,20
         PSCAL(I) = 0.0D0
         POFF(I) = 0.0D0
         PTYPES(I) = ' '
 15      CONTINUE
      CALL SETDEF
      CALL CATINI (CATBLK)
      CATBLK(KIDIM) = ND
      CALL COPY (ND, NAXI, CATBLK(KINAX))
      IRET = 0
C                                       Read header loop
      DO 50 JJ = 1,30000000
         MSGTXT = ' '
         IF (JJ.NE.1) THEN
            CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
            CALL PRTPLI (4, IRET)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1020) IERR
               IF (IERR.EQ.IEREOF) GO TO 995
               GO TO 990
               END IF
            IF (IRET.NE.0) GO TO 999
            NC1 = 1
            NRECS = NRECS + 1
            BYTES = BYTES + 2880
            FNRECS = FNRECS + 1
            FBYTES = FBYTES + 2880
            CALL ZC8CL (2880, 1, TAPBUF(TBIND), CBUF)
            END IF
C                                       Loop over cards in block
         PRTEXT (1:NCR) = ' '
         DO 40 NC = NC1,36
C                                       Print the card first
            INC = (NC-1) * 80 + 1
            PRTEXT (1:80) = CBUF(INC:INC+79)
            IF (PRTEXT(:4).EQ.'TDIM') DIMCRD = PRTEXT(:80)
            IF (PRTEXT(:7).EQ.'TFIELDS') THEN
               OP = 11
               CALL GETNUM (PRTEXT, 80, OP, X)
               IF (X.NE.DBLANK) NCOLS = X + 0.5D0
               END IF
            EQUAL = PRTEXT(1:8).EQ.'HISTORY '
            DOIT = (IPTLEV.GE.2) .OR. ((IPTLEV.EQ.1) .AND.
     *         (.NOT.EQUAL) .AND. (PRTEXT(1:4).NE.'    '))
            EQUAL = PRTEXT(1:8).EQ.'ORIGIN  '
            LEND = PRTEXT(1:8).EQ.'DATE    '
            DOIT = ((DOIT) .OR. (LEND) .OR. (EQUAL)) .AND. (IPTLEV.GE.0)
            IF ((PRTEXT(:8).EQ.'EXTNAME ') .AND. (IPTLEV.GE.-1)) DOIT =
     *         .TRUE.
            IF (DOIT) CALL PRTPLI (3, IRET)
            IF (IRET.NE.0) GO TO 999
            LEND = PRTEXT(:8).EQ.'END'
            IF (LEND) GO TO 55
            CALL TPARSE (NC, NUMKEY, KEYWRD, KEYVAL, KEYCHR, KEYTYP,
     *         CBUF, IERR)
 40         CONTINUE
 50      CONTINUE
C                                       END found
 55   DIMSAV(1) = CATBLK(KINAX)
      DIMSAV(2) = CATBLK(KINAX+1)
C                                       Piecewise UV file
      IF ((NPV(1).GT.0) .AND. (NPV(2).GT.0)) THEN
         WRITE (PRTEXT,1055) NPV(1), NPV(2)
         CALL PRTPLI (2, IERR)
         IF (IERR.NE.0) GO TO 999
         WRITE (PRTEXT,1056) NPV(3), NPV(4)
         CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       build header
      CATBLK(KIDIM) = MAXIS
      NP = 1
      DO 60 I = 1,CATBLK(KIDIM)
         NP = NP * MAXISI(I)
         CATBLK(KINAX+I-1) = MAXISI(I)
         CATR(KRCIC+I-1) = CDELT(I)
         CATR(KRCRP+I-1) = CRPIX(I)
         CATR(KRCRT+I-1) = CROTA(I)
         CATD(KDCRV+I-1) = CRVAL(I)
         CALL CHR2H (8, CTYPE(I), 1, CATH(KHCTP+2*(I-1)))
 60      CONTINUE
      CATD(KDORA) = OBSRA
      CATD(KDODE) = OBSDEC
      CALL CHR2H (8, DATOBS, 1, CATH(KHDOB))
      CALL CHR2H (8, DATMAP, 1, CATH(KHDMP))
      CALL CHR2H (8, TELESC, 1, CATH(KHTEL))
      CALL CHR2H (8, OBSRVR, 1, CATH(KHOBS))
      CALL CHR2H (8, BUNIT, 1, CATH(KHBUN))
      CALL CHR2H (8, OBJECT, 1, CATH(KHOBJ))
      CALL CHR2H (18, IMNAME, KHIMNO, CATH(KHIMN))
      CATBLK(KIIMS) = IMSEQ
      CALL CHR2H (2, 'UV', KHPTYO, CATH(KHPTY))
      CALL CHR2H (2, SORT, 1, CATH(KITYP))
      CATR(KREPO) = CEPOCH
      CATBLK(KIGCN) = MAX (NPV(4), DIMSAV(2))
      CATBLK(KIPCN) = NCOLS - 1
      J = 0
      DO 65 I = 1,NCOLS
         IF (TTYPE(I)(:8).NE.'VISIBILI') THEN
            CALL CHR2H (8, TTYPE(I), 1, CATH(KHPTP+J))
            J = J + 2
            END IF
 65      CONTINUE
      CALL PRTHDR (TSCAL, TZERO, TTYPE, IRET)
      CATBLK(KIDIM) = 2
      CATBLK(KINAX) = DIMSAV(1)
      CATBLK(KINAX+1) = DIMSAV(2)
      GO TO 999
C
 990  IRET = 8
 995  CALL MSGWRT (8)
      CALL PRTPLI (4, JER)
      IF ((IERR.EQ.IEREOF) .AND. (IRET.NE.8)) THEN
         MSGTXT = 'UNEXPECTED END OF FILE'
         CALL MSGWRT (6)
         CALL PRTPLI (4, IRET)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I3)
 1020 FORMAT ('ERROR',I7,' READING FITS TAPE')
 1055 FORMAT ('Piece',I3,' of',I3,' in the full data set')
 1056 FORMAT ('Visibilities',I9,' through',I9,' from original')
      END
      SUBROUTINE PRTVLB (IERR)
C-----------------------------------------------------------------------
C   PRTVLB lists the contents of a VLBA binary table file header
C   on the printer.
C   Output:
C      IERR     I         not 0 => please quit
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      CHARACTER LDATE*12, MDATE*12, BTEMP*8, CTEMP*8, BCODE(7)*10,
     *   IMTYPE*2, IMNAME*12, IMCLAS*6
      INTEGER   I
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'PRTTP.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA BCODE /'UNKNOWN ','PIXEL 8BIT','SHORT INT ',
     *   'LONG INT','DOUBLE INT','FLOATING','DBL FLOAT'/
C-----------------------------------------------------------------------
      MSGTXT = 'Data in VLBA binary tables format'
      CALL MSGWRT (3)
      WRITE (PRTEXT,1000)
      CALL PRTPLI (3, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       file output only
      IF (IPTLEV.LE.-3) THEN
         IMNAME = 'VLBA FORMAT'
         IMCLAS = 'TABLES'
         IMTYPE = 'UV'
         CALL H2CHR (8, 1, CATH(KHDOB), BTEMP)
         CALL H2CHR (8, 1, CATH(KHDMP), CTEMP)
         WRITE (PRTEXT,1300) TAPNAM, NFILES, IMTYPE, IMNAME, IMCLAS,
     *      CATBLK(KIIMS), BTEMP, CTEMP
         CALL ZTXIO ('WRIT', PLUN, PIND, PRTEXT(:64), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1301) IERR
            CALL MSGWRT (8)
            END IF
C                                       Terse message.
      ELSE IF (IPTLEV.LE.-1) THEN
C                                       Decode Observation and map date
         CALL H2CHR (8, 1, CATH(KHDOB), CTEMP)
         CALL DATDAT (CTEMP, LDATE)
         CALL H2CHR (8, 1, CATH(KHDMP), CTEMP)
         CALL DATDAT (CTEMP, MDATE)
         WRITE (PRTEXT,1010) LDATE, MDATE
         CALL PRTPLI (3, IERR)
C                                       Telescope and Observer
      ELSE
         CALL H2CHR (8, 1, CATH(KHTEL), BTEMP)
         CALL H2CHR (8, 1, CATH(KHOBS), CTEMP)
         WRITE (PRTEXT,1020) BTEMP, CTEMP
         CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Observation and map date
         CALL H2CHR (8, 1, CATH(KHDOB), CTEMP)
         CALL DATDAT (CTEMP, LDATE)
         CALL H2CHR (8, 1, CATH(KHDMP), CTEMP)
         CALL DATDAT (CTEMP, MDATE)
         WRITE (PRTEXT,1010) LDATE, MDATE
         CALL PRTPLI (3, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Bit information
         I = 1
         IF (BITPIX.EQ.8) I = 2
         IF (BITPIX.EQ.16) I = 3
         IF (BITPIX.EQ.32) I = 4
         IF (BITPIX.EQ.64) I = 5
         IF (BITPIX.EQ.-32) I = 6
         IF (BITPIX.EQ.-64) I = 7
         WRITE (PRTEXT,1030) BCODE(I)
         CALL PRTPLI (3, IERR)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VLBA Binary FITS file base header')
 1010 FORMAT ('Observ. date=',A12,4X,'Map date=',A12)
 1020 FORMAT ('Telescope=',A8,11X,'Observer=',A8)
 1030 FORMAT ('Pixel type: ',A10)
 1300 FORMAT (A12,I6,1X,A2,1X,A12,1X,A6,I5,1X,A8,1X,A8)
 1301 FORMAT ('ZTXIO RETURNS ERROR',I5)
      END
      SUBROUTINE PRTVLA (IRET)
C-----------------------------------------------------------------------
C   Index VLA archive format (post Jan88)
C   Output:
C      IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER IRET
C
      CHARACTER PGID*8, DATE*8, CORM*4, BTEMP*8, CTEMP*8, IMTYPE*2,
     *   IMNAME*12, IMCLAS*6
      INTEGER   LIMIT, D10ID, MCBLK, MCNBLK, NANT, SUBA, CHCODE, LOOP,
     *   PECNT, JER, LRWORD
      DOUBLE PRECISION    FREQA, TIME
      LOGICAL   F, FIRST
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'PRTTP.INC'
      INCLUDE 'VLARCH.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                       Set up FDVEC
      FDVEC(2) = 26624
      FDVEC(6) = 1
      FDVEC(31) = 0
      FDVEC(32) = 0
      PECNT = 0
      FULL = F
      FIRST = .TRUE.
C                                       Initialize
      CALL INDEXR (1, PGID, FREQA, TIME, D10ID, NANT, SUBA, CHCODE,
     *   CORM, DATE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       read first tape record
 100     MSGSUP = 1000
         MSGTXT = ' '
         IF (VLDISK) THEN
            IF (.NOT.FIRST) CALL FLDKIO ('READ', FDVEC, TAPBUF, TBIND,
     *         IRET)
            FIRST = .FALSE.
         ELSE
            CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IRET)
            END IF
         MSGSUP = 0
         IF (IRET.EQ.10) IRET = 0
C                                       Trap parity errors
         IF (IRET.EQ.3) THEN
            PECNT = PECNT + 1
            IF (PECNT.GT.100) GO TO 300
            GO TO 100
            END IF
         CALL PRTPLI (4, JER)
         IF (IRET.NE.0) GO TO 300
         IF (JER.NE.0) THEN
            IRET = JER
            GO TO 999
            END IF
         NRECS = NRECS + 1
         BYTES = BYTES + FDVEC(42)
         FNRECS = FNRECS + 1
         FBYTES = FBYTES + FDVEC(42)
C                                       Crack header
         CALL HEDCRK (TAPBUF(TBIND), PGID, FREQA, TIME, D10ID, NANT,
     *      SUBA, CHCODE, CORM, DATE, MCBLK, MCNBLK)
C                                       Accumulate info
         IF (MCBLK.EQ.1) THEN
            IF (VLDISK) THEN
               CALL ZI32IL (1, 2, TAPBUF(TBIND), LRWORD)
               LRWORD = 2 * LRWORD + 4 * MCNBLK
               LRWORD = (LRWORD-1) / 2048 + 1
               IF (LRWORD.GE.13) THEN
                  FDVEC(43) = LRWORD - 13
               ELSE
                  FTAB(FDVEC(40)+5) = FTAB(FDVEC(40)+5) + LRWORD - 13
                  IF (MCNBLK.NE.1) THEN
                     MSGTXT = 'PROBLEM IN CORRECTING RECORD ' //
     *                  'POSITION ON DISK'
                     CALL MSGWRT (9)
                     END IF
                  END IF
               END IF
            CALL INDEXR (2, PGID, FREQA, TIME, D10ID, NANT, SUBA,
     *         CHCODE, CORM, DATE, IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
C                                       Skip over rest of log. record
         LIMIT = MCNBLK - MCBLK
         DO 200 LOOP = 1,LIMIT
            MSGSUP = 1000
            MSGTXT = ' '
            IF (VLDISK) THEN
               CALL FLDKIO ('READ', FDVEC, TAPBUF, TBIND, IRET)
            ELSE
               CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IRET)
               END IF
            MSGSUP = 0
            IF (IRET.EQ.10) IRET = 0
C                                       Trap parity error
            IF (IRET.EQ.3) THEN
               PECNT = PECNT + 1
               IF (PECNT.GT.100) GO TO 300
               IRET = 0
               END IF
            CALL PRTPLI (4, JER)
            IF (IRET.NE.0) GO TO 300
            IF (JER.NE.0) THEN
               IRET = JER
               GO TO 999
               END IF
            NRECS = NRECS + 1
            BYTES = BYTES + FDVEC(42)
            FNRECS = FNRECS + 1
            FBYTES = FBYTES + FDVEC(42)
 200        CONTINUE
         GO TO 100
C                                       Give results
 300  IF (NOPGM.GE.1) THEN
         CALL INDEXR (3, PGID, FREQA, TIME, D10ID, NANT, SUBA, CHCODE,
     *      CORM, DATE, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Parity errors
      IF (PECNT.GT.0) THEN
         WRITE (PRTEXT,1992) PECNT
         CALL PRTPLI (2, IRET)
         END IF
C                                       file output only
      IF (IPTLEV.LE.-3) THEN
         IMNAME = 'VLA ARCHIVE '
         IMCLAS = 'DATA  '
         IMTYPE = 'AR'
         BTEMP = PGID
         CTEMP = DATE
         WRITE (PRTEXT,1995) TAPNAM, NFILES, IMTYPE, IMNAME, IMCLAS,
     *      NOPGM, BTEMP, CTEMP
         CALL ZTXIO ('WRIT', PLUN, PIND, PRTEXT(:64), JER)
         IF (JER.NE.0) THEN
            WRITE (MSGTXT,1996) JER
            CALL MSGWRT (8)
            END IF
         IF (IRET.EQ.0) IRET = JER
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1992 FORMAT ('Encountered ',I8, ' tape parity errors')
 1995 FORMAT (A12,I6,1X,A2,1X,A12,1X,A6,I5,1X,A8,1X,A8)
 1996 FORMAT ('ZTXIO RETURNS ERROR',I5)
      END
      SUBROUTINE HEDCRK (BUFFER, PGID, FREQA, TIME, D10ID, NANT, SUBA,
     *   CHCODE, CORM, DATE, MCBLK, MCNBLK)
C-----------------------------------------------------------------------
C   Routine to interprete header for VLA archive data.
C   Input:
C      BUFFER   I(*)   Buffer containing header.
C   Output:
C      PGID     C*8    Observing program name
C      FREQA    D      IF A Center frequency (GHz)
C      TIME     D      Time (radians) IAT of geometry calculations.
C      D10ID    I      Dec 10 Id number
C      NANT     I      Number of antennas
C      SUBA     I      Subarray number
C      CHCODE   I      Channel code.
C      CORM     C*4    Correlator mode.
C      DATE     C*8    Date as 'dd/mm/yy' packed.
C      MCBLK    I      Block No. (better be 1)
C      MCNBLK   I      Number of tape blocks in logical record.
C-----------------------------------------------------------------
      CHARACTER DATE*8, PGID*8, CORM*4
      INTEGER   BUFFER(*), D10ID, NANT, SUBA, CHCODE, MCBLK, MCNBLK
      DOUBLE PRECISION    FREQA, TIME
C
      INTEGER   NDATA, INDEX, MCSUBA, MJDATE, IDUM(2)
      DOUBLE PRECISION    R8(2), XDATE
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Block numbers
      NDATA = 1
      INDEX = 1
      CALL ZI16IL (NDATA, INDEX, BUFFER, IDUM)
      MCBLK = IDUM(1)
      INDEX = 2
      CALL ZI16IL (NDATA, INDEX, BUFFER, IDUM)
      MCNBLK = IDUM(1)
C                                       Validity check
      IF (MCBLK.NE.1) GO TO 999
C                                       Number of antennas
      INDEX = 20
      CALL ZI16IL (NDATA, INDEX, BUFFER, IDUM)
      NANT = IDUM(1)
C                                       Subarray area pointer
      INDEX = 8
      CALL ZI32IL (NDATA, INDEX, BUFFER, MCSUBA)
C                                       Program ID
      NDATA = 6
      INDEX = (MCSUBA + 11) * 2 + 5
      CALL ZC8CL (NDATA, INDEX, BUFFER, PGID)
C                                       Dec 10 user number
      NDATA = 1
      INDEX = MCSUBA + 17
      CALL ZI16IL (NDATA, INDEX, BUFFER, IDUM)
      D10ID = IDUM(1)
C                                       Subarray
      NDATA = 1
      INDEX = MCSUBA + 3
      CALL ZI16IL (NDATA, INDEX, BUFFER, IDUM)
      SUBA = IDUM(1)
C                                       Channel code
      NDATA = 1
      INDEX = MCSUBA + 21
      CALL ZI16IL (NDATA, INDEX, BUFFER, IDUM)
      CHCODE = IDUM(1)
C                                       Correlator mode
      NDATA = 4
      INDEX = (MCSUBA + 157) * 2 + 5
      CALL ZC8CL (NDATA, INDEX, BUFFER, CORM)
C                                       Date
      NDATA = 1
      INDEX = 4
      CALL ZI32IL (NDATA, INDEX, BUFFER, MJDATE)
      XDATE = MJDATE + 2400000.5D0
      CALL GREG (XDATE, DATE)
C                                       Frequency
      NDATA = 8
      INDEX = (MCSUBA + 56) * 2 + 5
      CALL ZBYMOV (NDATA, INDEX, BUFFER, 1, R8)
      NDATA = 4
      CALL ZBYTFL (NDATA, R8, R8)
      NDATA = 1
      CALL ZDM2DL (NDATA, R8, FREQA)
C                                       Time
      NDATA = 8
      INDEX = (MCSUBA + 72) * 2 + 5
      CALL ZBYMOV (NDATA, INDEX, BUFFER, 1, R8)
      NDATA = 4
      CALL ZBYTFL (NDATA, R8, R8)
      NDATA = 1
      CALL ZDM2DL (NDATA, R8, TIME)
C
 999  RETURN
      END
      SUBROUTINE INDEXR (IOP, PGID, FREQA, TIME, D10ID, NANT, SUBA,
     *   CHCODE, CORM, DATE, IERR)
C-----------------------------------------------------------------------
C   Routine to do accounting for VLA archive data
C   Input:
C      IOP      I        Op code, 1=init, 2=accumulate, 3=summarize
C      PGID     C*8      Observing program name
C      FREQA    D        IF A Center frequency (GHz)
C      TIME     D        Time (radians) IAT of geometry calculations.
C      D10ID    I        Dec 10 Id number
C      NANT     I        Number of antennas
C      SUBA     I        Subarray number
C      CHCODE   I        Channel code.
C      CORM     C*4      Correlator mode.
C      DATE     C*8      Date as 'dd/mm/yy' packed.
C   Input/Output values in common /TAPE/:
C      NOPGM    I        Number of entries
C      NOREC    I(*)     Number of records per entry
C      NOVIS    I(*)     Approx. number of vis per entry
C      D10IDA   I(*)     Dec 10 IDs
C      SUBAA    I(*)     Subarray numbers
C      CHCODA   I(*)     Channel codes
C      CORMA    C*4(*)   Correlator modes
C      DATEA    C*8(*)   Date as 'dd/mm/yy'
C      PGIDA    C*8(*)   Program names
C      FREQAA   D(*)     IF A Frequency (GHz)
C      TIMERA   D(2,*)   Timerange (Radians)
C   Output:
C      IERR     I        Return error code 0=>OK
C-----------------------------------------------------------------------
      INTEGER   IOP, D10ID, NANT, SUBA, CHCODE, IERR
      CHARACTER PGID*8, CORM*4, DATE*8
      DOUBLE PRECISION    FREQA, TIME
C
      CHARACTER CH1*1, CH2*1, PGEXP*8
      INTEGER   LOOP, THEPGM, HM1(2), HM2(2)
      LOGICAL   EQUAL
      REAL      SEC1, SEC2
      DOUBLE PRECISION    TT(2)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'PRTTP.INC'
      INCLUDE 'VLARCH.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Initialize
      IF (IOP.EQ.1) THEN
         NOPGM = 0
         DO 100 LOOP = 1,2000
            FREQAA(LOOP) = 0.0D0
            TIMERA(1,LOOP) = 0.0D0
            TIMERA(2,LOOP) = 0.0D0
            PGIDA(LOOP) = ' '
            DATEA(LOOP) = ' '
            CORMA(LOOP) = ' '
            NOREC(LOOP) = 0
            NOVIS(LOOP) = 0
            SUBAA(LOOP) = 0
            CHCODA(LOOP) = 0
 100        CONTINUE
         GO TO 999
         END IF
C                                       Make entry
      IF (IOP.EQ.2) THEN
C                                       See if already have
         DO 200 LOOP = 1,NOPGM
C                                       Program name
            EQUAL = PGID(1:6) .EQ. PGIDA(LOOP)
            IF (.NOT.EQUAL) GO TO 200
C                                       Frequency (10%)
            IF (ABS (FREQA-FREQAA(LOOP)) .GT. (0.1*FREQA)) GO TO 200
C                                       Dec 10 ID
            IF (D10ID.NE.D10IDA(LOOP)) GO TO 200
C                                       Subarray
            IF (SUBA.NE.SUBAA(LOOP)) GO TO 200
C                                       Channel code
            IF (CHCODE.NE.CHCODA(LOOP)) GO TO 200
C                                       Correlator mode
            IF (CORM.NE.CORMA(LOOP)) GO TO 200
C                                       Match
            THEPGM = LOOP
            GO TO 300
 200        CONTINUE
C                                       New entry
C                                       Make sure there is room
         IF (NOPGM.GE.2000) THEN
            IF (.NOT.FULL) THEN
               WRITE (MSGTXT,1200)
               CALL MSGWRT (6)
               CALL PRTPLI (4, IERR)
               FULL = .TRUE.
               GO TO 999
            ELSE
               GO TO 999
               END IF
            END IF
         NOPGM = NOPGM + 1
         PGIDA(NOPGM)(1:6) = PGID(1:6)
         FREQAA(NOPGM) = FREQA
         D10IDA(NOPGM) = D10ID
         SUBAA(NOPGM) = SUBA
         CHCODA(NOPGM) = CHCODE
         CORMA(NOPGM) = CORM
         DATEA(NOPGM) = DATE
         TIMERA(1,NOPGM) = TIME
         TIMERA(2,NOPGM) = TIME
         NOREC(NOPGM) = 1
         NOVIS(NOPGM) = (NANT * NANT) / 2
         GO TO 999
C                                       Old entry
 300     TIMERA(2,THEPGM) = TIME
         NOREC(THEPGM) = NOREC(THEPGM) + 1
         NOVIS(THEPGM) = NOVIS(THEPGM) + (NANT * NANT) / 2
         GO TO 999
         END IF
C                                       Give results
      IF (IOP.EQ.3) THEN
C                                       Print heading
         CALL PRTPLI (1, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Tell user how to read
         WRITE (PRTEXT,1301)
         CALL PRTPLI (2, IERR)
         IF (IERR.NE.0) GO TO 999
         DO 400 LOOP = 1,NOPGM
            PGEXP(1:6) = PGIDA(LOOP)(1:6)
            WRITE (PRTEXT,1302)  PGEXP, D10IDA(LOOP), FREQAA(LOOP)
            CALL PRTPLI (2, IERR)
            IF (IERR.NE.0) GO TO 999
            WRITE (PRTEXT,1303) SUBAA(LOOP), CHCODA(LOOP),
     *         CORMA(LOOP)
            CALL PRTPLI (3, IERR)
            IF (IERR.NE.0) GO TO 999
            TT(1) = TIMERA(1,LOOP) * 57.29577951
            TT(2) = TIMERA(2,LOOP) * 57.29577951
            CALL COORDD (1, TT(1), CH1, HM1, SEC1)
            CALL COORDD (1, TT(2), CH2, HM2, SEC2)
            WRITE (PRTEXT,1304) DATEA(LOOP), CH1, HM1, SEC1,
     *         CH2, HM2, SEC2
            CALL PRTPLI (3, IERR)
            IF (IERR.NE.0) GO TO 999
            WRITE (PRTEXT,1305) NOREC(LOOP), NOVIS(LOOP)
            CALL PRTPLI (3, IERR)
            IF (IERR.NE.0) GO TO 999
 400        CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1200 FORMAT ('WARNING: EXCEEDED LIMIT OF 2000 ENTRIES')
 1301 FORMAT ('Read this data with AIPS task FILLM')
 1302 FORMAT (' Obs. program = ',A6,' Obs. ID =',I4,
     *   ', Freq(Ghz) =', F10.5)
 1303 FORMAT (' Subarray =',I2,' Channel code =',I7,
     *   ' Correlator mode = ',A4)
 1304 FORMAT (' Timerange = ',A8,' at ',A1,2I3,F5.1,' to ',A1,2I3,F5.1)
 1305 FORMAT (I6,' VLA archive records, approximately ',I10,' vis.')
      END
      SUBROUTINE PRTXXX (IRET)
C-----------------------------------------------------------------------
C   PRTXXX prints information about files of unknown type.  Basically
C   all it can do is report physical record lengths and counts.
C   Output:
C      IRET   I   Error code: 0 => okay,
C                   > 0 I/O error
C                   < 0 requested to quit by user
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER BTEMP*8, CTEMP*8, IMTYPE*2, IMNAME*12, IMCLAS*6
      INTEGER   NBYTES, IBYTES, LBYTES, IREC, LREC, LUN, FIND, I, IERR,
     *   IEREOF, JER
      INCLUDE 'PRTTP.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA IEREOF /4/
C-----------------------------------------------------------------------
C                                       Init printer
      CALL PRTPLI (1, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Init parms
      NBYTES = 29184
      NBYTES = (NBYTES * NBITWD) / 8
      NBYTES = MIN (32767, NBYTES)
      LBYTES = 0
      LREC = 0
      LUN = FDVEC(1)
      FIND = FDVEC(40)
C                                       loop forever almost
      DO 100 IREC = 1,100000000
         MSGTXT = ' '
         CALL ZTPMIO ('READ', LUN, FIND, NBYTES, TAPBUF, 1, IRET)
         IF (IRET.EQ.0) CALL ZTPWAT (LUN, FIND, 1, IBYTES, IRET)
         IF (IRET.NE.0) IBYTES = -1
         CALL PRTPLI (4, JER)
         IERR = 0
         IF (IBYTES.NE.LBYTES) THEN
            IF (LREC.GT.0) THEN
               I = IREC - 1
               WRITE (PRTEXT,1000) LREC, I, LBYTES
               CALL PRTPLI (3, IERR)
               END IF
            LREC = IREC
            LBYTES = IBYTES
            END IF
         IF (IRET.NE.0) THEN
            IF (IRET.EQ.IEREOF) THEN
                WRITE (PRTEXT,1010) IREC
                CALL PRTPLI (2, IERR)
                IRET = IERR
                GO TO 110
             ELSE
                WRITE (MSGTXT,1015) IRET, IREC
                CALL MSGWRT (7)
                CALL PRTPLI (4, IERR)
                END IF
             END IF
         IF (IRET.EQ.0) IRET = IERR
         IF (IRET.EQ.0) IRET = JER
         IF (IRET.NE.0) GO TO 999
 100     CONTINUE
C                                       file output only
 110  IF (IPTLEV.LE.-3) THEN
         IMNAME = 'UNKNOWN TYPE'
         IMCLAS = 'FORMAT'
         IMTYPE = '??'
         BTEMP = 'EOF AT'
         WRITE (CTEMP, 1110) IREC
         WRITE (PRTEXT,1300) TAPNAM, NFILES, IMTYPE, IMNAME, IMCLAS,
     *      LBYTES, BTEMP, CTEMP
         CALL ZTXIO ('WRIT', PLUN, PIND, PRTEXT(:64), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1301) IERR
            CALL MSGWRT (8)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('   Record',I9,' through',I9,' length',I6,' bytes')
 1010 FORMAT ('   End-of-file at record',I9)
 1015 FORMAT ('PRTXXX: TAPE ERROR CODE',I2,' AT RECORD',I9)
 1110 FORMAT (I8)
 1300 FORMAT (A12,I6,1X,A2,1X,A12,1X,A6,I5,1X,A8,1X,A8)
 1301 FORMAT ('ZTXIO RETURNS ERROR',I5)
      END
      SUBROUTINE FLDKIO (OP, FDVEC, BUFF, IBIND, IERR)
C-----------------------------------------------------------------------
C   FLDKIO is for reading disk files for FILLM
C   NOTE: FLDKIO WORKS IN REAL (8-BIT) BYTES, NOT THE AIPS HALF-INTEGER
C   "BYTES".
C   Usage notes:
C     1) Zero fill FDVEC before filling in relevant values.
C     2) Opening the file.  If FLDKIO determines that the file is not
C        open it will do so.  Once the file is open the file descriptor
C        vector FDVEC must be used in each call.
C     3) Initialization.  FLDKIO initializes the I/O using the values in
C        FDVEC when it opens the file.
C        If OP='OPRD' the file is opened but I/O is not initialized;
C        this allows positioning tapes before the actual I/O starts.
C     5) Closing the file.  The file may be closed with a call with
C        opcode 'CLOS'.
C   31 <= LUN <= 30 + NTAPED will generate an error.
C   Disks: any other LUN, for VLA blocking (n * 2048)
C          FLDKIO requires that FDVEC(2) = 2048, FDVEC(31) = 0 on input
C          FLDKIO sets FDVEC(6) = 1
C          The desired file name must be in FDVEC(7-30) packed string
C          WITHOUT THE FILE NUMBER which will be appended
C   Inputs:
C      OP     C*4     Operation code: 'READ','CLOS', 'OPRD'
C   Input/Output:
C      FDVEC  I(50)   File descriptor vector.
C                     1 = LUN to use, set before first call.
C                         129-NTAPED to 128 => tape => error
C                     2 = Logical record length in bytes (8-bit)
C                     3 = Buffer size in 8-bit bytes I
C                     4 =
C                     5 =
C                     6 =
C                  7-30 = File name for disk files (24 char. packed)
C                    31 =
C                    32 =
C                    33 = Desired file number
C                 34-39   Reserved for future use
C                The following are used by FLDKIO:
C                    40 = FTAB pointer
C                    41 =
C                    42 = LBYTES - number of bytes read
C                    43 = Number of 2048's left to read
C                 44-50 = reserved for future use
C      BUFF   R(*)   Buffer for I/O must be large enough for the largest
C                    transfer rounded up to the next larger number of
C                    disk blocks.
C   Outputs:
C      IBIND  I      The location in BUFF of the start of the next
C                    record. Note: IBIND points to the address in the
C                    I   array irregardless of the actual data type.
C      IERR   I      Error return: 0 => ok
C                             2 => input error
C                             3 => i/o error on initialize
C                             4 => end of file
C                             5 => beginning of medium
C                             6 => end of medium
C                             7 => Buffer too small
C                             8 => error opening file.
C                            10 => data record shorter than 1 logical
C   Usage notes: For map i/o the first 16 words in each FTAB entry
C   contain a user table to handle double buffer i/o,  the rest
C   contain system-dependent I/O tables.
C   FTAB user table   entries, with offsets from the FIND pointer are:
C      FTAB + 0 =>  LUN using this entry
C             1 =>
C             2 =>  Number of 8-bit bytes in a logical record
C             3 =>  Number of disk logical records in each transfer (1)
C             4 =>
C             5 =>  Block offset on disk file for next operation I
C             6 =>
C           7-8 =>
C             9 =>  I/O opcode 0=read, 1=write
C            10 =>  1 => tape, 2 => disk
C            11 =>
C            12 =>
C            13 =>  1 => I/O active, else inactive (not initialized).
C            14 =>  number bytes last read/write to buffer 1
C            15 =>  number bytes last read/write to buffer 2
C   To suppress messages about logical and physical record lengths
C   being inconsistent, set MSGSUP to 1000 or greater.
C-----------------------------------------------------------------------
      INTEGER   FDVEC(50), BUFF(*), IBIND, IERR
      CHARACTER OP*4
C
      CHARACTER PHNAME*48, STRNG*8
      LOGICAL   DISK, DOREAD
      INTEGER   JERR, IND, JBUF, MBYTE, I, J, NUMMSG, LBYTES, I4TEMP,
     *   BUFSZ4, RECNO, BUFPNT, NBYPWD, ITRIM, IFILE, FCBOFF, MCB(2),
     *   LRW
      HOLLERITH FHVEC(50)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
C
      SAVE NUMMSG
C-----------------------------------------------------------------------
      IERR = 2
      IBIND = 1
      CALL RCOPY (50, FDVEC, FHVEC)
C                                       Initial parameters
      IND = FDVEC(40)
      NBYPWD = NBITWD / 8
C                                       See if tape or disk.
C??                                     BETTER TEST HERE
      DISK = (FDVEC(1).LT.129-NTAPED) .OR. (FDVEC(1).GT.128)
      IF (DISK) THEN
         IF (FDVEC(2).NE.13*2048) GO TO 985
         IF (FDVEC(31).NE.0) GO TO 985
         FDVEC(6) = 1
      ELSE
         MSGTXT = 'FLDKIO: ONLY DOES FILLM DISK I/O'
         GO TO 990
         END IF
      BUFSZ4 = FDVEC(3)
C??                                     CHECK HERE ON DEVTAB VALUE
      IF (MOD (DEVTAB(FDVEC(1)),2).EQ.1) GO TO 999
C                                       Test OPcode
      DOREAD = (OP.EQ.'OPRD') .OR. (OP.EQ.'READ')
      IF ((OP.NE.'READ') .AND. (OP.NE.'CLOS') .AND. (OP.NE.'OPRD')) THEN
         WRITE (MSGTXT,1000) OP
         GO TO 990
         END IF
C                                       Check if CLOSE
      IERR = 0
      IF (OP.EQ.'CLOS') GO TO 900
C                                       Check if Open but I/O inactive
      IF (((IND.GT.0) .AND. (FDVEC(1).EQ.FTAB(IND))) .AND.
     *   (FTAB(IND+13).EQ.1)) GO TO 500
C                                       Open
      IF ((IND.LE.0) .OR. (FDVEC(1).NE.FTAB(IND))) THEN
         PHNAME = ' '
         CALL H2CHR (48, 1, FHVEC(7), PHNAME)
         I = ITRIM (PHNAME)
         IFILE = MAX (1, FDVEC(33))
         WRITE (STRNG,1005) IFILE
         CALL CHTRIM (STRNG, 6, STRNG, J)
         PHNAME(I+1:) = STRNG(:J)
         MSGTXT = 'Opening ' // PHNAME
         IF (MSGSUP.NE.32000) CALL MSGWRT (3)
         CALL ZTPOPN (FDVEC(1), IND, FDVEC(5), PHNAME, 'READ', JERR)
C                                       Save number of blocks in file
         IF (JERR.NE.0) THEN
            IERR = 8
            WRITE (MSGTXT,1010) JERR
            FDVEC(40) = 0
            GO TO 990
            END IF
         FDVEC(40) = IND
         END IF
C                                       Init previously inactive I/O
      FDVEC(42) = 0
      FDVEC(43) = 0
      NUMMSG = -2
C                                       Fill values in FTAB
C                                       No. logical rec. done
      FTAB(IND+12) = 0
C                                       LUN
      FTAB(IND) = FDVEC(1)
C                                       Number of bytes in a logical
C                                       record.
      FTAB(IND+2) = FDVEC(2)
C                                       Number of disk blocks per op.
      FTAB(IND+3) = 1
      FTAB(IND+13) = 0
C                                       Buffer size check
      FTAB(IND+4) = -1
C                                       Buffer too small
      IF (BUFSZ4.LT.13*2048) THEN
         IERR = 7
         I4TEMP = 13 * 2048
         WRITE (MSGTXT,1100) BUFSZ4, I4TEMP
         GO TO 990
         END IF
C                                       Next disk block
      RECNO = 1
      FTAB(IND+5) = RECNO
C                                       Opcode
      FTAB(IND+9) = 0
C                                       Medium type
      FTAB(IND+10) = 2
C                                       Set buffer pointer
      BUFPNT = 1
C                                       Check limited no. records
      FDVEC(41) = -1
C                                       Set I/O active flag
      FTAB(IND+13) = 1
C                                       Done if OP='OPxx'
      IF (OP(1:2).EQ.'OP') GO TO 999
C                                       READ
 500  JBUF = 1
      J = MIN (13, FDVEC(43))
      IF (J.LE.0) J = 13
      MBYTE = 2048 * J
      FTAB(IND+14) = MBYTE
      RECNO = FTAB(IND+5)
      FCBOFF = IND + MOFF
      CALL ZDKMID ('READ', RECNO, FTAB(FCBOFF), BUFF, MBYTE, IERR)
      IF (IERR.EQ.4) GO TO 998
      IF (IERR.NE.0) GO TO 980
C                                       Update block counter
      FTAB(IND+5) = RECNO + J
      FDVEC(43) = FDVEC(43) - J
C                                       Set pointers etc.
      IBIND = 1
      JBUF = 1
      CALL ZTPWAT (FTAB(IND), IND, JBUF, LBYTES, IERR)
      IF (IERR.EQ.4) GO TO 998
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1500) IERR, OP
         GO TO 990
         END IF
C                                       Check bytes read
      FDVEC(42) = LBYTES
      IF (LBYTES.NE.MBYTE) THEN
         I = LBYTES / 2048
         IF (I*2048.NE.LBYTES) GO TO 970
         CALL ZI16IL (2, 1, BUFF, MCB)
         CALL ZI32IL (1, 2, BUFF, LRW)
         LRW = 2 * LRW + 4 * MCB(2)
         LRW = (LRW - 1) / 2048 + 1
         IF ((MCB(1).NE.1) .OR. (LRW.GT.I)) GO TO 970
         IERR = 10
         END IF
      GO TO 999
C-----------------------------------------------------------------------
C                                       Close
 900  IERR = 8
      FDVEC(42) = 0
      IF ((IND.LE.0) .OR. (FTAB(IND).NE.FDVEC(1))) GO TO 999
      IERR = 0
C                                       Turn off things
      FTAB(IND+4) = 0
      FTAB(IND+12) = 0
      FTAB(IND+11) = 0
      FDVEC(40) = 0
C                                       Close file
      CALL ZTPCLS (FTAB(IND), IND, JERR)
      IF (IERR.EQ.0) IERR = JERR
      IF (IERR.NE.0) GO TO 980
      GO TO 998
C                                       I/O error
 970  WRITE (MSGTXT,1970) LBYTES
      IERR = 4
      GO TO 990
 980  WRITE (MSGTXT,1980) IERR, OP
      GO TO 990
C                                       disk IO error
 985  WRITE (MSGTXT,1985) FDVEC(2), FDVEC(31)
C                                       error messages
 990  CALL MSGWRT (6)
C                                       Mark I/O inactive
 998  FTAB(IND+13) = 0
C                                       Don't wait after error
      FTAB(IND+4) = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FLDKIO: OPCODE ',A4,' INVALID')
 1005 FORMAT (I6)
 1010 FORMAT ('FLDKIO: ERROR ',I3,' OPENING FILE')
 1100 FORMAT ('FLDKIO: BUFFER SIZE=',I6,' TOO SMALL, NEED',I6)
 1500 FORMAT ('FLDKIO: ERROR ',I3,2X,A4,'ING FILE')
 1970 FORMAT ('FLDKIO: LBYTES=',I8,' BUT IERR = 0')
 1980 FORMAT ('FLDKIO: ERROR',I3,' DOING I/O WITH OPCODE = ',A4)
 1985 FORMAT ('FLDKIO: INPUT BYTES, LENGTH TYPE=',I7,I3,
     *     ' SHOULD BE  2048, 0')
      END
      SUBROUTINE TPARSE (ICARD, NUMKEY, KEYWRD, KEYVAL, KEYCHR, KEYTYP,
     *   FITBLK, IERR)
C-----------------------------------------------------------------------
C   Parses a table FITS header line.
C   Inputs:
C      ICARD    I        The card number (1-36) in block to interpret
C      FITBLK   C*2880   A block of FITS header data.
C   In/Out:
C      NUMKEY   I        on first input the max. number of keywords,
C                        output the number of arbitrary keyword/value
C                        pairs found.
C      KEYWRD   C(*)*8   Keywords
C      KEYVAL   D(*)     List of arbitrary numeric/logical values:
C                           KEYVAL(n) => Value in D.
C                           logicals coded as -1.0=>F, 1.0=>T.
C      KEYCHR   C(*)*8   List of character keyword values values.
C      KEYTYP   I(*)     Keyword type codes.
C   Outputs:
C      IERR     I        error code 0=ok. 1=error.  -1 too many columns
C   Commons:
C      /EXTHDR/    Extension file values.
C      /THDR/      Header values for a tables extension file.
C-----------------------------------------------------------------------
      CHARACTER KEYWRD(*)*8, KEYCHR(*)*8, FITBLK*(*)
      INTEGER   ICARD, NUMKEY, KEYTYP(*), IERR
      DOUBLE PRECISION KEYVAL(*)
C
      INTEGER   NN
      PARAMETER (NN=35)
      CHARACTER SYMBOL*8, STR*80, TWORD(NN)*8, CARD*80, CVER*1
      DOUBLE PRECISION X
      INTEGER   TLIMIT(NN), N, TABNO, NBYT, MAXKEY, NPNT, NCHAR,
     *   KTYPE, COUNT, JERR, NRCX, ISL, JTRIM, IAX, KBP, NPNTS
      LOGICAL   END, WARN
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DEHD.INC'
      INCLUDE 'INCS:DTHD.INC'
      INCLUDE 'INCS:DBHD.INC'
      SAVE MAXKEY
C                                       Special keywords
      DATA TWORD /   'TFIELDS ', 'EXTNAME ', 'EXTVER  ', 'EXTLEVEL',
     *   'TTYPE   ', 'TBCOL   ', 'TFORM   ', 'TUNIT   ', 'TSCAL   ',
     *   'TZERO   ', 'TNULL   ', 'AUTHOR  ', 'REFERENC', 'NMATRIX ',
     *   'DATE-OBS', 'TELESCOP', 'OBSERVER', 'MAXIS   ', 'CTYPE   ',
     *   'CDELT   ', 'CRPIX   ', 'CRVAL   ', 'TMATX   ', 'TDIM    ',
     *   'xCTYP   ', 'xCRVL   ', 'xCDLT   ', 'xCRPX   ', 'xCROT   ',
     *   'BUNIT   ', 'EPOCH   ', 'EQUINOX ', 'OBSRA   ', 'OBSDEC  ',
     *   'OBJECT  '/
      DATA TLIMIT / 4*0, 7*99, 6*0, 6*99, 99, -99, -99, -99, -99, -99,
     *   6*0/
C-----------------------------------------------------------------------
      IF (NUMKEY.LT.0) THEN
         MAXKEY = -NUMKEY
         NUMKEY = 0
         END IF
C                                       parse the card
      CALL GTWCRD (ICARD, NN, TLIMIT, TWORD, FITBLK, NPNT, CARD,
     *   SYMBOL, TABNO, N, IAX, CVER, END, JERR)
      IF (END) GO TO 990
      NPNTS = NPNT
C                                       Unrecognized Keyword =
      IF (JERR.EQ.1) THEN
C                                       Check keyword limit
         IF (NUMKEY.LT.MAXKEY) THEN
            CALL GETKEY (SYMBOL, CARD, NPNT, NUMKEY, KEYWRD, KEYVAL,
     *         KEYCHR, KEYTYP, JERR)
C                                       Invalid code
            IF ((KEYTYP(NUMKEY).LE.0) .OR. (KEYTYP(NUMKEY).GT.6)) THEN
               MSGTXT = 'TPARSE: KEYWORD ' // SYMBOL //
     *            ' OF INDETERMINATE DATA TYPE'
               CALL MSGWRT (6)
               NUMKEY = NUMKEY - 1
               END IF
C                                       Blew keyword limit
         ELSE
            IF (WARN) THEN
               WRITE (MSGTXT,1000) MAXKEY
               CALL MSGWRT (6)
               WARN = .FALSE.
               END IF
            END IF
C                                       Not normal KEYWORD=value card.
      ELSE IF ((JERR.NE.0) .OR. (CVER.NE.' ')) THEN
C                                       Process selected SINGLDSH
C                                       keywords.
         IF (CARD(1:8).EQ.'SINGLDSH') THEN
            CALL SDTCRD (ICARD, FITBLK, MAXKEY, NUMKEY, KEYWRD,
     *         KEYVAL, KEYCHR, KEYTYP, WARN, NRCX)
C                                       Table type 'SD'
            ITYPE = 'SD'
            END IF
C                                       Decode special table keyword.
C                                       Number of fields.
      ELSE IF (TABNO.EQ.1) THEN
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         ITNCOL = X + .5
         IF (ITNCOL.GT.127) THEN
            WRITE (MSGTXT,1010) ITNCOL
            CALL MSGWRT (7)
            MSGTXT = 'WILL KEEP ONLY THE FIRST 127 COLUMNS'
            CALL MSGWRT (7)
            ITNCOL = 127
            END IF
C                                       Extension name.
      ELSE IF (TABNO.EQ.2) THEN
         NBYT = 24
         CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
         EXTNAM = STR(1:NCHAR)
C                                       If standard AIPS table type
C                                       then EXTNAM is of the form
C                                       'AIPS XX' where XX is the
C                                       table type.
         IF ((EXTNAM(1:5).NE.'AIPS ').AND.(EXTNAM(1:4).NE.'VLA ')) THEN
            ITYPE = 'UK'
         ELSE
            ITYPE = STR(6:7)
            END IF
C                                       Extension version.
      ELSE IF (TABNO.EQ.3) THEN
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         EXTVER = X + .01
C                                       Extension level.
      ELSE IF (TABNO.EQ.4) THEN
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         EXTLEV = X + .01
C                                       Field type.
      ELSE IF (TABNO.EQ.5) THEN
         NBYT = 24
         CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
         TTYPE(N) = STR(1:NCHAR)
C                                       Starting column.
      ELSE IF (TABNO.EQ.6) THEN
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         TBCOL(N) = X + .5
C                                       Field format.
      ELSE IF (TABNO.EQ.7) THEN
         NBYT = 8
         CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
         TFORM(N) = STR(1:NCHAR)
C                                       Decode format.
C                                       3-D table
         CALL TABF3D (TFORM(N), COUNT, KTYPE, JERR)
         TFCODE(N) = KTYPE + 10 * COUNT
C                                       Field units.
      ELSE IF (TABNO.EQ.8) THEN
         NBYT = 8
         CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
         TUNIT(N) = STR(1:NCHAR)
C                                       Field scale.
      ELSE IF (TABNO.EQ.9) THEN
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         TSCAL(N) = X
C                                       Field offset.
      ELSE IF (TABNO.EQ.10) THEN
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         TZERO(N) = X
C                                       Field null value.
      ELSE IF (TABNO.EQ.11) THEN
         NBYT = 8
         CALL GETSTR (CARD, 24, NBYT, NPNT, STR, NCHAR)
         TNULL(N) = STR(1:NCHAR)
C                                       AUTHOR or REFERENC (Ignore)
      ELSE IF ((TABNO.EQ.12) .OR. (TABNO.EQ.13)) THEN
C                                       # of matrices (VLBA)
      ELSE IF (TABNO.EQ.14) THEN
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         NMATRX = X + .01
C                                       Date of observation (VLBA)
      ELSE IF (TABNO.EQ.15) THEN
         NBYT = 24
         CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
         CALL DATFST ('F2L', STR)
         NCHAR = JTRIM (STR)
         DATOBS = STR(:NCHAR)
C                                       Telescope (VLBA)
      ELSE IF (TABNO.EQ.16) THEN
         NBYT = 24
         CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
         TELESC = STR(1:NCHAR)
C                                       Observer (VLBA)
      ELSE IF (TABNO.EQ.17) THEN
         NBYT = 24
         CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
         OBSRVR = STR(1:NCHAR)
C                                       # axes in data matrix (VLBA)
      ELSE IF (TABNO.EQ.18) THEN
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         IF (N.EQ.0) THEN
            MAXIS = X + .01
         ELSE
            MAXISI(N) = X + .01
            END IF
C                                       Axis type. (VLBA)
      ELSE IF (TABNO.EQ.19) THEN
         NBYT = 24
         CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
         CTYPE(N) = STR(1:NCHAR)
C                                       Axis increment (VLBA)
      ELSE IF (TABNO.EQ.20) THEN
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         CDELT(N) = X
C                                       Axis ref. pixel (VLBA)
      ELSE IF (TABNO.EQ.21) THEN
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         CRPIX(N) = X
C                                       Value at ref pixel (VLBA)
      ELSE IF (TABNO.EQ.22) THEN
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         CRVAL(N) = X
C                                       Column which is a data matrix
      ELSE IF (TABNO.EQ.23) THEN
         CALL GETLG (CARD, 80, NPNT, ISL)
         IF (ISL.EQ.0) TMATX(N) = .FALSE.
         IF (ISL.EQ.1) TMATX(N) = .TRUE.
C                                       TDIMnn card - get axes
      ELSE IF (TABNO.EQ.24) THEN
         IF (TTYPE(N)(:8).NE.'VISIBILI') THEN
            WRITE (MSGTXT,1240) N, TTYPE(N)
            CALL MSGWRT (6)
            END IF
         TMATX(N) = .TRUE.
         NBYT = 80
         CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
C                                       parse out dimensions
         N = 0
         KBP = 2
 40      IF (STR(KBP:KBP).NE.')') THEN
            N = N + 1
            CALL GETINT (STR, NCHAR, KBP, MAXISI(N))
            IF (MAXISI(N).GT.0) GO TO 40
            N = N - 1
            END IF
         MAXIS = N
C                                       coord type
      ELSE IF (TABNO.EQ.25) THEN
         IF ((.NOT.TMATX(N)) .OR. (IAX.GT.MAXIS)) GO TO 780
         NBYT = 24
         CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
         CTYPE(IAX) = STR(1:NCHAR)
C                                       coord ref value
      ELSE IF (TABNO.EQ.26) THEN
         IF ((.NOT.TMATX(N)) .OR. (IAX.GT.MAXIS)) GO TO 780
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         CRVAL(IAX) = X
C                                       coord increment
      ELSE IF (TABNO.EQ.27) THEN
         IF ((.NOT.TMATX(N)) .OR. (IAX.GT.MAXIS)) GO TO 780
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         CDELT(IAX) = X
C                                       coord ref pix
      ELSE IF (TABNO.EQ.28) THEN
         IF ((.NOT.TMATX(N)) .OR. (IAX.GT.MAXIS)) GO TO 780
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         CRPIX(IAX) = X
C                                       coord rotation
      ELSE IF (TABNO.EQ.29) THEN
         IF ((.NOT.TMATX(N)) .OR. (IAX.GT.MAXIS)) GO TO 780
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         CROTA(IAX) = X
C                                       BUNIT
      ELSE IF (TABNO.EQ.30) THEN
         NBYT = 24
         CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
         BUNIT = STR(1:NCHAR)
C                                       EPOCH/EQUINOX
      ELSE IF ((TABNO.EQ.31) .OR. (TABNO.EQ.32)) THEN
         CALL GETNUM (CARD, 80, NPNT, X)
C                                       special parse for EQUINOX
         IF (X.EQ.DBLANK) THEN
            NPNT = NPNTS
            CALL GETSTR (CARD, 80, 68, NPNT, STR, NCHAR)
            IF (INDEX(STR,'1950').GT.0) THEN
               X = 1950.0D0
            ELSE IF (INDEX(STR,'2000').GT.0) THEN
               X = 2000.0D0
               END IF
            END IF
         IF (X.EQ.DBLANK) GO TO 790
         CEPOCH = X + 0.01
C                                       observed RA
      ELSE IF (TABNO.EQ.33) THEN
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         OBSRA = X
C                                       observed Declination
      ELSE IF (TABNO.EQ.34) THEN
         CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 790
         OBSDEC = X
C                                       OBJECT
      ELSE IF (TABNO.EQ.35) THEN
         NBYT = 24
         CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
         OBJECT = STR(1:NCHAR)
         END IF
      GO TO 990
C                                       axis coords not right
 780  IF (.NOT.TMATX(N)) THEN
         WRITE (MSGTXT,1780) N, SYMBOL
      ELSE
         WRITE (MSGTXT,1781) IAX, MAXIS
         END IF
      CALL MSGWRT (7)
      GO TO 990
C                                       BAD VALUE
 790  MSGTXT = 'TPARSE: NUMBER OUT OF RANGE ON ' // SYMBOL
      CALL MSGWRT (6)
C                                       Set common number of keywords
 990  ITANKY = NUMKEY
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TPARSE: BLEW NO. OF KEYWORD LIMIT OF ',I5,' IGNORE REST')
 1010 FORMAT ('TPARSE:',I5,' COLUMNS EXCEEDS AIPS LIMIT OF 127')
 1240 FORMAT ('TPARSE: COLUMN',I3,' TYPE ',A8,' NOT VISIBILI')
 1780 FORMAT ('TPARSE: COLUMN',I3,' NOT DIMENSIONS FOR COORD ',A)
 1781 FORMAT ('TPARSE: COORDINATE AXIS',I4,' LARGER THAN MAX',I3)
      END

      SUBROUTINE QSORT (APCORE, REC, K1, K2, L, N, W1, W2)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Sort records.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Do a two key sort of a list of records into ascending order of the
C   keys.
C   Inputs:
C      REC  I Base address of record array
C      K1   I Index of first (slowest) sort key
C      K2   I Index of second (faster) sort key
C      L    I Length of a record
C      N    I Number of records.
C      W1   I Base address of REAL work array of length 2*N
C      W2   I Base address of INTEGER work array of length N
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   REC, K1, K2, L, N, W1, W2
C
      INCLUDE 'INCS:DAPC.INC'
      LONGINT   IREC, IW1, IW2
      INTEGER   NP2, IERR
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Addresses 1-rel
      IREC = REC + PSAPOF
      IW1 = W1 + PSAPOF
      IW2 = W2 + PSAPOF
      NP2 = N + 2
C                                       Try Quick Sort
      CALL QOSORT (APCORE(IREC), N, NP2, K1, K2, L, APCORE(IW1),
     *   APCORE(IW2), IERR)
      IF (IERR.NE.0) CALL QLSORT (APCORE(IREC), N, K1, K2, L)
C
 999  RETURN
      END

LOCAL INCLUDE 'AVER.INC'
C                                       Local include for AVER
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   CATBLK(256), CATIN(256), SEQIN, SEQOUT, DISKIN, DISKO,
     *   NUMHIS, JBUFSZ
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      REAL      XSIN, XDISIN, XSOUT, XDISO, YINC, XCENT, BUFF1(UVBFSS),
     *   BUFF2(UVBFSS), DIFPIX
      CHARACTER HISCRD(10)*64
      DOUBLE PRECISION UVSCAL
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ, NUMHIS
      COMMON /OLDHDR/ CATIN
      COMMON /INPTS/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XCLAOU,
     *   XSOUT, XDISO, YINC, XCENT
      COMMON /AVERP/ UVSCAL, SEQIN, SEQOUT, DISKIN, DISKO, DIFPIX
      COMMON /CHRCOM/ HISCRD, NAMEIN, CLAIN, NAMOUT, CLAOUT
      COMMON /MAPHDR/ CATBLK
LOCAL END
      PROGRAM AVER
C-----------------------------------------------------------------------
C! Time average 'BT' sorted uv data.
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2000, 2008-2009, 2014-2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AVER averages a uv data set to a maximum time given by YINC.
C   Data must initially be in baseline-time ('BT') order.
C   Weights are summed and other values are averaged without weighting.
C   Inputs:
C   AIPS adverb  Prg. name.          Description.
C   INNAME         NAMEIN        Name of input UV data.
C   INCLASS        CLAIN         Class of input UV data.
C   INSEQ          SEQIN         Seq. of input UV data.
C   INDISK         DISKIN        Disk number of input VU data.
C   OUTNAME        NAMOUT        Name of the output uv file.
C   OUTCLASS       CLAOUT        Class of the output uv file.
C   OUTSEQ         SEQOUT        Seq. number of output uv data.
C   OUTDISK        DISKO         Disk number of the output file.
C   YINC           YINC          Integration time (sec) min=0.2
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'AVER.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'AVER  '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL AVERIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Average data.
      CALL AVERUV (IRET)
      IF (IRET.EQ.0) CALL AVERHI
C                                       close down
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE AVERIN (PRGM, JERR)
C-----------------------------------------------------------------------
C   AVERIN gets input parameters for AVER and creates an output file
C   if necessary.
C   Inputs:  PRGM   C*6      Task name
C   Output:  JERR   I        Error code: quit if > 0.
C-----------------------------------------------------------------------
      CHARACTER STAT*4, PRGM*6, BLANK*6, UTYPE*2
      HOLLERITH CATH(256)
      INTEGER   OLDCNO, IROUND, JERR, NPARM, IERR, INCX
      REAL      CATR(256)
      LOGICAL   T
      DOUBLE PRECISION CATD(128)
      INCLUDE 'AVER.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATR, CATBLK, CATH, CATD)
      DATA BLANK /'      '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Initialize I/O
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 16
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      WRITE (MSGTXT,4000)
      CALL MSGWRT (2)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
      YINC = MAX (10.0, YINC) / 86400.0
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Copy old CATBLK
      CALL COPY (256, CATBLK, CATIN)
C                                       Disallow packed uv data
      IF (CATBLK(KINAX).EQ.1) THEN
         JERR = 9
         MSGTXT = 'ERROR: I cannot process packed UV data, use SPLIT'
         GO TO 990
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Check if sort order 'BT'
      IF (ISORT.NE.'BT') THEN
         WRITE (MSGTXT,1050) ISORT
         JERR = 5
         GO TO 990
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
      IF (JLOCF.LT.0) XCENT = -1.0
      IF (XCENT.LE.0.0) THEN
         UVSCAL = 1.0D0
         DIFPIX = 0.0
      ELSE
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
         UVSCAL = CATD(KDCRV+JLOCF) / FREQ
         END IF
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
      IF (IERR.EQ.0) GO TO 70
         IF (IERR.EQ.2) GO TO 60
            WRITE (MSGTXT,1055) IERR
            GO TO 990
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
 60      IF ((CCNO.EQ.OLDCNO) .AND. (DISKO.EQ.DISKIN)) GO TO 65
            WRITE (MSGTXT,1060)
            GO TO 990
C                                       Recover existing CATBLK
 65      CONTINUE
            FRW(NCFILE+1) = 2
            CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', BUFF1,
     *         IERR)
            IF (IERR.EQ.0) GO TO 70
               WRITE (MSGTXT,1065) IERR
               CALL MSGWRT (6)
 70   NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                        Put input file in READ
      UTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      SEQOUT = CATBLK(KIIMS)
      JERR = 0
C                                       copy keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AVERIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',I3,
     *   ' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('SORT ORDER ',A2,' NOT BT AS REQUIRED')
 1055 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('AVERIN: ERROR',I3,' UPDATING NEW CATBLK')
 4000 FORMAT ('You are using a non-standard program')
      END
      SUBROUTINE AVERUV (IRET)
C-----------------------------------------------------------------------
C   AVERUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET, INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, LRECO,
     *   ILENBU, KBIND, IBIND, NIOUT, NIOLIM, I, VO, BO, NUMVIS, XCOUNT,
     *   IA1, IA2
      REAL      BASEL
      CHARACTER IFILE*48, OFILE*48
      LOGICAL   T, F
      INCLUDE 'AVER.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA VO, BO /0, 1/
      DATA LUNI, LUNO /16,17/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.LE.0) GO TO 10
         WRITE (MSGTXT,1000) IRET
         GO TO 990
C                                       Open vis file for write
 10   CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.LE.0) GO TO 20
         WRITE (MSGTXT,1010) IRET
         GO TO 990
C                                       Init vis file for write
C                                       LRECO = length of output rec.
 20   LRECO = LREC
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) IRET
         GO TO 990
 30   IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.EQ.0) GO TO 40
         WRITE (MSGTXT,1030) IRET
         GO TO 990
 40   NUMVIS = 0
      XCOUNT = 0
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.EQ.0) GO TO 110
            WRITE (MSGTXT,1100) IRET
            GO TO 990
 110     IPTRI = IBIND
         DO 190 I = 1,INIO
            NUMVIS = NUMVIS + 1
            IF (ILOCB.GE.0) THEN
               BASEL = BUFF1(IPTRI+ILOCB)
               IA1 = BASEL / 256. + 0.1
               IA2 = BASEL - IA1*256. + 0.1
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               END IF
            BUFF1(IPTRI+ILOCU) = BUFF1(IPTRI+ILOCU) * UVSCAL
            BUFF1(IPTRI+ILOCV) = BUFF1(IPTRI+ILOCV) * UVSCAL
            BUFF1(IPTRI+ILOCW) = BUFF1(IPTRI+ILOCW) * UVSCAL
C                                      Average
            CALL AVERDO (NUMVIS, BUFF1(IPTRI+ILOCU),
     *         BUFF1(IPTRI+ILOCV), BUFF1(IPTRI+ILOCW),
     *         BUFF1(IPTRI+ILOCT), BUFF1(IPTRI+NRPARM),
     *         BUFF1(IPTRI), IRET)
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
C                                       Copy to output.
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1
               CALL RCOPY (LREC, BUFF1(IPTRI), BUFF2(IPTRO))
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               END IF
            IPTRI = IPTRI + LREC
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
         IF (INIO.GT.0) GO TO 100
C                                       Final call to AVERDO.
      NUMVIS = -1
      CALL AVERDO (NUMVIS, BUFF2(IPTRO+ILOCU), BUFF2(IPTRO+ILOCV),
     *   BUFF2(IPTRO+ILOCW), BUFF2(IPTRO+ILOCT), BUFF2(IPTRO+NRPARM),
     *   BUFF2(IPTRO), IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
      ELSE IF (IRET.EQ.0) THEN
         XCOUNT = XCOUNT + 1
         IF (ILOCB.GE.0) THEN
            BUFF2(IPTRO+ILOCB) = BASEL
         ELSE
            BUFF2(IPTRO+ILOCA1) = IA1
            BUFF2(IPTRO+ILOCA2) = IA2
            END IF
         IPTRO = IPTRO + LRECO
         NIOUT = NIOUT + 1
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AVERUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1010 FORMAT ('AVERUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1020 FORMAT ('AVERUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('AVERUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('AVERUV: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('AVERUV: AVERDO ERROR',I3)
 1150 FORMAT ('AVERUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE AVERHI
C-----------------------------------------------------------------------
C   AVERHI copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP(1)*2, LABEL*8, HILINE*72
      INTEGER   LUN1, LUN2, IERR, I, NONOT
      LOGICAL   T
      INCLUDE 'AVER.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN1, LUN2, T /27,28, .TRUE./
      DATA NONOT, NOTTYP /1,'NX'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.LE.2) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 20
C                                       New history
 10   CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
C                                      Add any user supplied history.
      IF (NUMHIS.LE.0) GO TO 20
         WRITE (LABEL,1010) TSKNAM
         DO 15 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 20
 15         CONTINUE
C                                       Close HI file
 20   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO, FCNO(2),
     *   FCNO(1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (6)
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (DISKO, FCNO(1), DIFPIX, BUFF1, BUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'AVERHI: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST', BUFF1,
     *   IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AVERHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,' /')
 1020 FORMAT ('AVERHI: ERROR',I3,' COPYING TABLES')
      END
      SUBROUTINE AVERDO (NUMVIS, U, V, W, T, VIS, RPARM, IRET)
C-----------------------------------------------------------------------
C   AVERDO averages a uv data set in time.
C   Inputs:
C      NUMVIS     I    Visibility number, -1 => final call, no data
C                      passed but allows any operations to be completed.
C                      Data sent back will be wirtten to output file.
C      U          R    U in wavelengths
C      V          R    V in wavelengths
C      W          R    W in wavelengths
C      T          R    Time in days since 0 IAT on the first day for
C                      which there is data.
C      RPARM(*)   I    Random parameter array which includes U,V,W etc
C                      but also any other random parameters.
C      VIS(3,*)   R    Vis data in order real, imaginary, weight (Jy)
C   Inputs from COMMON
C      NRPARM     I    # random parameters.
C      NCOR       I    # correlators
C      CATBLK(256)I    Catalog header record.
C   Output:
C      RPARM      R    Modified random parameter array. NB U,V,W, time
C                      and baseline should not be modified in RPARM
C      VIS        R    Visibilities
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C   Output in COMMON
C      NUMHIS     I    # history entries (max. 10)
C      HISCRD(NUMHIS) C*64   History records
C      CATBLK     I    Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IRET
      REAL      U, V, W, T, VIS(3,*), RPARM(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   LUNSS, JERR, INDEX, IDAY, IWT(1024), IIWT, MCOR, NMCOR,
     *   I, J, XCOUNT, ANVER, IA1CUR, IA2CUR, ISUCUR, JA1, JA2, JSUB
      REAL      VBUFF(4*MAXCIF), TEMP, CATR(128), TCHK, CT, TLAST, UT,
     *   VT, WT, TT, USUM, VSUM, WSUM, TSUM, DIV
      DOUBLE PRECISION CATD(128), X8
      INCLUDE 'AVER.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATBLK, CATR, CATD)
      SAVE IA1CUR, IA2CUR, ISUCUR, TCHK, TLAST, USUM, VSUM, WSUM, TSUM,
     *   VBUFF, IIWT
      DATA LUNSS /27/
C-----------------------------------------------------------------------
      IRET = -1
C                                        Initial call
      IF (NUMVIS.LT.1) GO TO 300
      IF (NUMVIS.EQ.1) THEN
         XCOUNT = 0
C                                        Get IAT - UTC
         ANVER = 1
         CALL ANTINI ('READ', VBUFF, FVOL(NCFILE), FCNO(NCFILE), ANVER,
     *      CATIN, LUNSS, IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0,
     *      DEGPDY, SAFREQ, RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS,
     *      ANAME, XYZHAN, TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, JERR)

         IF (JERR.EQ.0) CALL TABAN ('CLOS', VBUFF, IANRNO, ANKOLS,
     *      ANNUMV, ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF,
     *      DIAMAN, FWHMAN, POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB,
     *      JERR)
         CT = T - DATUTC
         TCHK = CT
         IDAY = CT
         X8 = (CT-IDAY) / YINC
         TLAST = IDAY + DINT (X8) * YINC + YINC
C                                        First vis., copy to buffer.
         MCOR = (LREC - NRPARM) / 3
         NMCOR = (LREC - NRPARM)
C                                        Zero sums.
         USUM = 0.0
         VSUM = 0.0
         WSUM = 0.0
         TSUM = 0.0
         CALL RFILL (NMCOR, 0.0, VBUFF)
         CALL FILL (MCOR, 0, IWT)
         IIWT = 0
         IF (ILOCB.GE.0) THEN
            UT = RPARM(ILOCB+1)
            IA1CUR = UT / 256.0 + 0.1
            IA2CUR = UT - 256 * IA1CUR + 0.1
            ISUCUR = (UT - 256 * IA1CUR - IA2CUR) * 100.0 + 1.1
         ELSE
            IA1CUR = RPARM(ILOCA1+1) + 0.1
            IA2CUR = RPARM(ILOCA2+1) + 0.1
            ISUCUR = RPARM(ILOCSA+1) + 0.1
            END IF
C                                        Check that LREC not too big
         IF (LREC.GT.3100) THEN
            WRITE (MSGTXT,1110)
            CALL MSGWRT (8)
            IRET = 8
            GO TO 999
            END IF
         END IF
C                                        Next datum.
      IF (NUMVIS.GE.1) THEN
         IF (ILOCB.GE.0) THEN
            UT = RPARM(ILOCB+1)
            JA1 = UT / 256.0 + 0.1
            JA2 = UT - 256 * JA1 + 0.1
            JSUB = (UT - 256 * JA1 - JA2) * 100.0 + 1.1
         ELSE
            JA1 = RPARM(ILOCA1+1) + 0.1
            JA2 = RPARM(ILOCA2+1) + 0.1
            JSUB = RPARM(ILOCSA+1) + 0.1
            END IF
         UT = U
         VT = V
         WT = W
         TT = T
         CT = T - DATUTC
C                                        Check time and baseline.
         IF ((CT.GT.TLAST) .OR. (JA1.NE.IA1CUR). OR. (JA2.NE.IA2CUR)
     *      .OR. (JSUB.NE.ISUCUR) .OR. (CT.LT.TCHK)) GO TO 250
C                                        Sum
            USUM = USUM + UT
            VSUM = VSUM + VT
            WSUM = WSUM + WT
            TSUM = TSUM + TT
            IIWT = IIWT + 1
            DO 220 I = 1,MCOR
               INDEX = (I-1) * 3 + 1
C                                        Check weight.
               IF (VIS(3,I).LE.0.0) GO TO 220
                  VBUFF(INDEX) = VBUFF(INDEX) + VIS(1,I)
                  VBUFF(INDEX+1) = VBUFF(INDEX+1) + VIS(2,I)
                  VBUFF(INDEX+2) = VBUFF(INDEX+2) + VIS(3,I)
                  IWT(I) = IWT(I) + 1
 220           CONTINUE
            TCHK = CT
            GO TO 999
C                                        "New" integration - write.
 250     CONTINUE
            XCOUNT = XCOUNT + 1
            DO 270 I = 1,MCOR
               DO 260 J = 1,3
                  INDEX = (I-1) * 3 + J
                  TEMP = VIS(J,I)
                  IF (VIS(3,I).LE.0.0) TEMP = 0.0
                  DIV = 1.0
                  IF (J.NE.3) DIV = 1.0 / MAX (1, IWT(I))
                  VIS(J,I) = VBUFF(INDEX) * DIV
                  IF ((J.EQ.3) .AND. (VIS(J,I).LE.0.0)) VIS(J,I) = -1.0
                  VBUFF(INDEX) = TEMP
 260              CONTINUE
               IWT(I) = 0
               IF (TEMP.GT.0.0) IWT(I) = 1
 270           CONTINUE
            U = USUM / MAX (1, IIWT)
            V = VSUM / MAX (1, IIWT)
            W = WSUM / MAX (1, IIWT)
            T = TSUM / MAX (1, IIWT)
            IIWT = 1
            USUM = UT
            VSUM = VT
            WSUM = WT
            TSUM = TT
            IF (ILOCB.GT.0) THEN
               RPARM(ILOCB+1) = 256*IA1CUR + IA2CUR + (ISUCUR-1)/100.0
            ELSE
               RPARM(ILOCA1+1) = IA1CUR
               RPARM(ILOCA2+1) = IA2CUR
               RPARM(ILOCSA+1) = ISUCUR
               END IF
            IA1CUR = JA1
            IA2CUR = JA2
            ISUCUR = JSUB
            IDAY = CT
            X8 = (CT-IDAY) / YINC
            TLAST = IDAY + DINT(X8) * YINC + YINC
            TCHK = CT
            IRET = 0
            GO TO 999
         END IF
C     Last datum.
 300  CONTINUE
         XCOUNT = XCOUNT + 1
         DO 320 I = 1,MCOR
            DO 310 J = 1,3
               INDEX = (I-1) * 3 + J
               DIV = 1.0
               IF (J.NE.3) DIV = 1.0 / MAX (1, IWT(I))
               VIS(J,I) = VBUFF(INDEX) * DIV
               IF ((J.EQ.3) .AND. (VIS(J,I).LE.0.0)) VIS(J,I) = -1.0
 310           CONTINUE
 320        CONTINUE
         U = USUM / MAX (1, IIWT)
         V = VSUM / MAX (1, IIWT)
         W = WSUM / MAX (1, IIWT)
         T = TSUM / MAX (1, IIWT)
C                                        Write no. written to history.
         NUMHIS = 2
         YINC = YINC * 86400.0
         WRITE (HISCRD(1),1998) YINC
         WRITE (HISCRD(2),1999) XCOUNT
         WRITE (MSGTXT,1999) XCOUNT
         CALL MSGWRT (5)
         IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1110 FORMAT ('RECORD LENGTH=',I5,' GREATER THAN 1000')
 1998 FORMAT ('Average time=',F7.2,' sec.')
 1999 FORMAT (I10,' Visibility records written')
      END

C Program CLFIX
C Last mods 24 May 1999, D. Gordon, GSFC
C******************************************************************************
C
LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER   NPARMS
C                                       NPARMS=no. adverbs passed.
      PARAMETER (NPARMS=10)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
C
LOCAL INCLUDE 'INPUTDATA.INC'
C                                     DATA statments defining input parameters.
C                                       NOTE: Uses values in PAOOF.INC
C                                       Adverb names
C                      1        2         3           4        5
      DATA AVNAME /'USERID', 'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           6          7         8         9       10
     *   'INVERS', 'OUTVERS', 'INFILE', 'APARM', 'DPARM' /
C                                       Adverb data types (PAOOF.INC)
C                     1       2      3       4        5       6
      DATA AVTYPE /OOAINT, OOACAR, OOACAR, OOAINT, OOAINT, OOAINT,
C           7       8      9     10
     *   OOAINT, OOACAR, OOARE, OOARE /
C                                       Adverb dimensions (as 2D)
C                   1    2    3    4    5    6    7     8     9    10
      DATA AVDIM /1,1, 12,1, 6,1, 1,1, 1,1, 1,1, 1,1, 48,1, 10,1, 10,1/
LOCAL END
      PROGRAM CLFIX
C-----------------------------------------------------------------------
C! Add IM and MC table quantities to CL table
C# Task VLBI Calibration Utility OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 1999
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Stuff clock offsets and atmospheres from MC table into CL table, and
C   recompute model delay coefficients from IM table at CL table time
C   and replace in CL table.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, INTAB*36, UVDATA*36, OUTTAB*36
      INTEGER  IRET, BUFF1(256)
      DATA PRGM /'CLFIX '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL CLFXIN (PRGM, INTAB, UVDATA, OUTTAB, IRET)
      IF (IRET.NE.0)  GO TO 990
C                                       Process table
      CALL CLPROC (INTAB, UVDATA, OUTTAB, IRET)
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
 999  STOP
      END
C
      SUBROUTINE CLFXIN (PRGN, INTAB, UVDATA, OUTTAB, IRET)
C-----------------------------------------------------------------------
C   CLFXIN gets input parameters for CLFIX and creates the input and
C   output objects
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      INTAB   C*   Name of input CL table object.
C      UVDATA  C*   Name of input uv data
C      OUTTAB  C*   Name of output table object.
C      IRET    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS file
C
C   Inputs from INTAB:
C
C-----------------------------------------------------------------------
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INPUTDATA.INC'
C
      INTEGER  IRET
      CHARACTER PRGN*6, INTAB*36, UVDATA*36, OUTTAB*36
      REAL      APARM(10), DPARM(10)
      COMMON /APRM/ APARM, DPARM
      INTEGER   DIM(3), TYPE, VER2, DUMMY, FDUM(16), DIMN(3)
C
      INTEGER DISKIN, SEQIN, OLDCNO, NUSER, LUN
      CHARACTER NAMEIN*12, CLAIN*6
      COMMON /IMSTUF/ DISKIN, SEQIN, OLDCNO, NUSER, LUN, NAMEIN, CLAIN
C
      INTEGER   NKEY1, NKEY2, NKEY3
C                                       NKEY1=no. adverbs to copy to INTAB
      PARAMETER (NKEY1=9)
C                                       NKEY2=no. adverbs to copy to UVDATA
      PARAMETER (NKEY2=6)
C                                       NKEY3=no. adverbs to copy to OUTTAB
      PARAMETER (NKEY3=6)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *          OUTK2(NKEY2)*32, INK3(NKEY3)*8, OUTK3(NKEY3)*32,
     *          CDUMMY*1, CCDUM*1
C                                       Adverbs to copy to INTAB
C                    1         2          3        4         5
      DATA INK1 /'USERID', 'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           6         7         8        9
     *   'INVERS', 'INFILE', 'APARM', 'DPARM'/
C                                       May rename adverbs to INTAB
C                    1         2       3         4      5       6
      DATA OUTK1 /'USERID', 'NAME', 'CLASS', 'IMSEQ', 'DISK', 'VER',
C           7        8        9
     *   'IFILE', 'APARM', 'DPARM'/
C
C                                       Adverbs to copy to OUTTAB
C                    1         2          3        4         5
      DATA INK2 /'USERID', 'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           6
     *   'OUTVERS'/
C                                       May rename adverbs to OUTTAB
C                    1         2       3        4      5       6
      DATA OUTK2 /'USERID', 'NAME', 'CLASS', 'IMSEQ', 'DISK', 'VER'/
C
C                                       Adverbs to copy to UVDATA
C                    1        2        3       4         5       6
      DATA INK3 /'USERID','INNAME','INCLASS','INSEQ','INDISK','INVERS'/
C                                       May rename adverbs to UVDATA
C                    1         2       3         4      5       6
      DATA OUTK3 /'USERID', 'NAME', 'CLASS', 'IMSEQ', 'DISK', 'CLUSE'/
C
C-----------------------------------------------------------------------
C                     Startup, returns "Input" object containing POPS adverbs
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C
C  Set input CL table version number
      CALL OGET ('Input', 'INVERS', TYPE, DIM, VER2, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create input object
      INTAB = 'Input table'
      CALL CREATE (INTAB, 'TABLE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, INTAB, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Table type
      DIM(1) = 2
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (INTAB, 'TBLTYPE', OOACAR, DIM, DUMMY, 'CL', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create Output Object
      OUTTAB = 'Output table'
      CALL CREATE (OUTTAB, 'TABLE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, OUTTAB, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Table type
      DIM(1) = 2
      CALL OPUT (OUTTAB, 'TBLTYPE', OOACAR, DIM, DUMMY, 'CL', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create UV data OBJECT
      UVDATA = 'Input uv data'
      CALL CREATE (UVDATA, 'UVDATA', IRET)
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY3, INK3, OUTK3, UVDATA, IRET)
      IF (IRET.NE.0) GO TO 999
C
      DIM(1) = 1
C                                       Get APARM array
      CALL OGET (INTAB, 'APARM', TYPE, DIMN, APARM, CCDUM, IRET)
      IF(IRET.NE.0) GO TO 999
C                                       Get DPARM array
      CALL OGET (INTAB, 'DPARM', TYPE, DIMN, DPARM, CCDUM, IRET)
      IF(IRET.NE.0) GO TO 999
C       Set defaults
       IF (DPARM(1).LT.0) DPARM(1) = 0
       IF (DPARM(1).GT.2) DPARM(1) = 0
C
C   Get stuff so we can read the IM and MC tables.
      CALL OGET (INTAB, 'NAME',  TYPE, DIM, FDUM, NAMEIN, IRET)
      CALL OGET (INTAB, 'CLASS', TYPE, DIM, FDUM, CLAIN,  IRET)
      CALL OGET (INTAB, 'IMSEQ', TYPE, DIM, SEQIN, CCDUM, IRET)
      CALL OGET (INTAB, 'DISK',  TYPE, DIM, DISKIN, CCDUM, IRET)
      CALL OGET (INTAB, 'USERID',  TYPE, DIM, NUSER, CCDUM, IRET)
C
 999  RETURN
      END
C-------------------------------------------------------------------------
      BLOCK DATA CLFILE
C
      DOUBLE PRECISION IMTIM(3000)
      REAL IMTINT
      INTEGER IMSRC(3000), IMSUB(3000), IMROW(3000,20), IMKNT
     *        ,MCROW(3000,20)
      COMMON /IMMAP/ IMTIM, IMSRC, IMSUB, IMROW, MCROW, IMTINT, IMKNT
C
      DATA IMTIM /3000*0.D0/
      DATA IMSRC /3000*0/
      DATA IMSUB /3000*0/
      DATA IMROW /60000*0/
      DATA MCROW /60000*0/
C
      END
C-----------------------------------------------------------------------
      SUBROUTINE CLPROC (INTAB, UVDATA, OUTTAB, IERR)
C-----------------------------------------------------------------------
C   Inputs:
C      INTAB   C*?   Name of input table object.
C      UVDATA  C*?   Name of input uv data
C      OUTTAB  C*?   Name of output table object.
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DIMV.INC'
      INCLUDE 'INCS:DGLB.INC'
C
      CHARACTER INTAB*(*), UVDATA*(*), OUTTAB*(*)
      INTEGER   TYPE, DIM(3), ANTMAX, NPOLN, NROW, CURROW, NTERMS,
     *   NUMIF, IERR
C     INTEGER J, K
      REAL GMMOD
      CHARACTER  CDUMMY*1
      REAL      APARM(10), DPARM(10)
      COMMON /APRM/ APARM, DPARM
      DOUBLE PRECISION IMTIM(3000)
      REAL IMTINT
      INTEGER IMSRC(3000), IMSUB(3000), IMROW(3000,20), IMKNT
     *        ,MCROW(3000,20)
      COMMON /IMMAP/ IMTIM, IMSRC, IMSUB, IMROW, MCROW, IMTINT, IMKNT
      INTEGER DISKIN, SEQIN, OLDCNO, NUSER, LUN
      CHARACTER NAMEIN*12, CLAIN*6, UTYPE*2, STAT*4
      REAL BUFF2(26112)
      COMMON /IMSTUF/ DISKIN, SEQIN, OLDCNO, NUSER, LUN, NAMEIN, CLAIN
C-----------------------------------------------------------------------
C
C  Open input CL table
      CALL OCLINI (INTAB, 'READ', CURROW, ANTMAX, NPOLN, NUMIF, NTERMS,
     *   GMMOD, IERR)
      IF (IERR.NE.0) GO TO 999
C  Get number of CL table entries
      CALL OGET (INTAB, 'NROW', TYPE, DIM, NROW, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C
C  Get stuff for the IM table
        OLDCNO = 1
        UTYPE = 'UV'
        CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *            UTYPE, NUSER, STAT, BUFF2, IERR)
C       PRINT *, ' CATDIR: IERR = ', IERR
C   Get CATBLK
        CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF2, IERR)
C
C   Create/open output table
      CALL OCLINI (OUTTAB, 'WRIT', CURROW, ANTMAX, NPOLN, NUMIF, NTERMS,
     *   GMMOD, IERR)
      IF (IERR.NE.0) THEN
       PRINT *, 'Output table error = ', IERR
       GO TO 999
      ENDIF
C
C***********************************************************************
C       OPEN(UNIT=10, FILE='/tmp/test.climmc',
C    *       STATUS='UNKNOWN',ACCESS='APPEND')
C***********************************************************************
C
C   Read through IM table
       CALL IMSORT (IERR)
C
C   Read thru MC table for clock offsets and atmosphere corrections
       IF (DPARM(1) .LE. 1) THEN
         CALL MCSORT (UVDATA, IERR)
       ENDIF
C
C************************************************************************
C        DO 701 J = 1, IMKNT
C         WRITE(10, 710) J, IMTIM(J), IMSRC(J), (IMROW(J,K), K=1,12),
C    *                   (MCROW(J,K), K=1,12)
C701     CONTINUE
C710      FORMAT (I6,F9.6,I3,12I6,/,18X,12I6)
C710      FORMAT (I6,F9.6,I3,20I6,/,18X,20I6)
C        CLOSE (10)
C************************************************************************
C
C  Read thru CL table
      CALL CLGET (INTAB, OUTTAB, NROW, NTERMS, NPOLN, ANTMAX, NUMIF,
     *            IERR)
C
C   Close tables
 800  CONTINUE
      CALL OCLOSE (INTAB, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OCLOSE (OUTTAB, IERR)
C     IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
C
C-------------------------------------------------------------------------
      SUBROUTINE IMSORT (IERR)
C-----------------------------------------------------------------------
C   Read through the IM table and save row numbers for matching with the
C    CL table.
C
C   Output:
C      IERR    I    Return code, -1 => data all processed, 0=>OK, else failed.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DIMV.INC'
      INCLUDE 'INCS:DGLB.INC'
C
      INTEGER NROW, IERR, SOURID, ANTNO, SUBA, K, JROW, NUM
C     DOUBLE PRECISION GEODLY(9)
      REAL TIMEI
C
      DOUBLE PRECISION IMTIM(3000)
      REAL IMTINT
      INTEGER IMSRC(3000), IMSUB(3000), IMROW(3000,20), IMKNT
     *        ,MCROW(3000,20)
      COMMON /IMMAP/ IMTIM, IMSRC, IMSUB, IMROW, MCROW, IMTINT, IMKNT
C
      INTEGER BUFFIM(1024)
      INTEGER NTERM, INVER, IRET
      INTEGER DISKIN, SEQIN, OLDCNO, NUSER, LUN
      CHARACTER NAMEIN*12, CLAIN*6
      COMMON /IMSTUF/ DISKIN, SEQIN, OLDCNO, NUSER, LUN, NAMEIN, CLAIN
C-----------------------------------------------------------------------
       IMKNT = 0
       NUM = 0
       NTERM = 6
       INVER = 1
       LUN = 38
C  Initialize IM table
       CALL IMINI ('READ', BUFFIM, DISKIN, OLDCNO, INVER, CATBLK, LUN,
     *      IRET)
        NROW = BUFFIM(5)
C
      DO 1000 JROW = 1, NROW
C    Read data for this row
           IIMRNO = JROW
         CALL IMTAB ('READ', BUFFIM, NOBAND, IRET )
          IF(IRET.NE.0) THEN
           PRINT *, ' IMSORT/IMTAB: IRET, JROW ', IRET, JROW
           GO TO 997
          ENDIF
           TIMEI = TINT
           SOURID = ISRC
           ANTNO = NOSTA
           SUBA = IARRAY
C   Check for valid source
          IF (SOURID .LE. 0) GO TO 1000
C
C   Determine if this is a new time, new source, new subarray
      IF (IMKNT .NE. 0) THEN
       DO 23 K = 1,IMKNT
C       See if this is a new or an old scan
        IF ( (DABS(TIME - IMTIM(K)) .LT. 1.D-12) .AND.
     *      (SOURID .EQ. IMSRC(K)) )  THEN
C        Old scan, add info to the correct line in IMMAP common block
          IMROW(K,ANTNO) = JROW
C          Set negative if Subarray numbers don't match!
          IF (SUBA .NE. IMSUB(K) ) IMROW(K,ANTNO) = -IMROW(K,ANTNO)
          NUM = NUM + 1
          GO TO 1000
        ENDIF
 23    CONTINUE
      ENDIF
C
C   If we get here, this must be a new scan (new time/source).
            IMKNT = IMKNT + 1
            NUM = NUM + 1
            IMTIM(IMKNT) = TIME
            IMSRC(IMKNT) = SOURID
            IMSUB(IMKNT) = SUBA
            IMROW(IMKNT,ANTNO) = JROW
            IF (IMKNT .EQ. 1) IMTINT = TIMEI
C
 1000  CONTINUE
C
  997  CONTINUE
        CALL TABIO('CLOS',1,IIMRNO,BUFFIM,BUFFIM,IRET)
C
 999  RETURN
      END
C
C-----------------------------------------------------------------------
      SUBROUTINE MCSORT (UVDATA, IERR)
C-----------------------------------------------------------------------
C   Read through the MC table. Match MC records with a corresponding IM
C    record (same time, source, antenna number. If there is no match it
C    should not be needed (???), so we move on to the next MC record.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DIMV.INC'
      INCLUDE 'INCS:DGLB.INC'
C
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:PAOOF.INC'
C     INCLUDE 'INCS:DMSG.INC'
C     INCLUDE 'INCS:DCAT.INC'
      INTEGER   TBKOLS(128,MAXIO), TBNUMV(128,MAXIO)
      COMMON /TBSTUF/ TBKOLS, TBNUMV
C     INTEGER MCCOLS(21)
C     EQUIVALENCE ( TBKOLS(1,1),MCCOLS(1) )
C
      CHARACTER UVDATA*(*)
      INTEGER NROW, IERR, IRNO, RESULT(512), J, K, SRC, IANT, I1, M
      REAL    RES4(512)
      DOUBLE PRECISION RES8(256), TIME1, TDIF
      EQUIVALENCE (RESULT, RES4, RES8)
      DOUBLE PRECISION IMTIM(3000)
      REAL IMTINT
      INTEGER IMSRC(3000), IMSUB(3000), IMROW(3000,20), IMKNT
     *        ,MCROW(3000,20)
      COMMON /IMMAP/ IMTIM, IMSRC, IMSUB, IMROW, MCROW, IMTINT, IMKNT
      INTEGER BUFFIM(512)
      INTEGER INVER, IRET
      INTEGER DISKIN, SEQIN, OLDCNO, NUSER, LUN
      CHARACTER NAMEIN*12, CLAIN*6
      COMMON /IMSTUF/ DISKIN, SEQIN, OLDCNO, NUSER, LUN, NAMEIN, CLAIN
      COMMON /I1MC/I1
C
      CHARACTER TABLE*32,  OBSCD*8, RDATE*8, TAPER*8
      INTEGER   MCROE, NSTOKE, NUMIF, NCHAN, NUMPOL, FFTSIZ,
     *          OVRSMP, ZEROPD
      REAL      RFREQ, CHANBW, REFPX
C
      DOUBLE PRECISION ATMO, DATMO, KLOK, DKLOK
C
C-----------------------------------------------------------------------
C     Values of interest in the MC table:
C       Source number  =  RESULT(?)
C       Antenna number =  RESULT(?)
C         Position of source and antenna not constant
C       Table Time     =  RES8(1)
C       Atmosphere     =  RES8(2)
C       Atmos. Rate    =  RES8(3)
C       Clock Offset   =  RES8(6)
C       Clock Rate     =  RES8(7)
C-----------------------------------------------------------------------
       INVER = 1
       I1 = 0
C  Initialize MC table
       LUN = 37
       CALL TABINI ('READ', 'MC', DISKIN, OLDCNO, INVER, CATBLK, LUN,
     *      NKEY, NREC, NCOL, DATP, BUFFIM, IRET)
       IF(IRET .NE. 0) THEN
        PRINT *, ' MCSORT/TABINI error = ', IRET
        RETURN
       ENDIF
C                          !! Undefined
       NROW = BUFFIM(5)
C       PRINT *, ' NROW = ', NROW
C##    CALL TABIO('CLOS',1,IRNO,BUFFIM,BUFFIM,IRET)
C
C
C##    TABLE = 'MC table'
C##    CALL UV2TAB (UVDATA,TABLE,'MC',1,IERR)
C##     IF(IERR .NE. 0) THEN
C##      print *, ' MCSORT/UV2TAB error = ', IERR
C##      RETURN
C##     ENDIF
C##   CALL OMCINI (TABLE, 'READ', MCROE, OBSCD, RDATE, NSTOKE,
C##  *   STOKE1, NUMIF,  NCHAN, RFREQ, CHANBW, REFPX, NUMPOL, FFTSIZ,
C##  *   OVRSMP, ZEROPD, TAPER, IERR)
C##     IF(IERR .NE. 0) THEN
C##      print *, ' MCSORT/OMCINI error = ', IERR
C##     ENDIF
C
C##    write(6,453)  ( TBKOLS(J,1), J=1,128)
C453   format(/,'TBKOLS:',/, 11(12I10,/))
C
C****************************************************
C      WRITE (10,604) BUFFIM
C604   FORMAT (//,52(10I8,/),//)
C      I1 = BUFFIM(8) - 4
C****************************************************
C
C
       DO 30 J = 1, NROW
C#     DO 30 J = 1, 0
        IRNO = J
        CALL TABIO ('READ', 0, IRNO, RESULT, BUFFIM, IRET)
       IF(IRET .NE. 0) RETURN
C
C#     print *,'J, RESULT ', J, RESULT
C#     print *,'J, RES8   ', J, RES8
C
C  Find location of source and antenna in RESULT array
C    There must be a formula for this, but its too obscure to figure out.
         IF (J.EQ.1) THEN
          DO 35 M = 22,50
            IF( (RESULT(M) .GT. 0) .AND. (RESULT(M) .LE. 200)
     *        .AND. (RESULT(M+1).GE.0) .AND. (RESULT(M+1).LE.20) ) THEN
             I1 = M
             PRINT *, ' I1 = ', I1
             GO TO 36
            ENDIF
  35      CONTINUE
          IF(I1 .EQ. 0) THEN
           PRINT *,' Unable to find station and source in MC table '
           RETURN
          ENDIF
         ENDIF
C
  36    CONTINUE
C
        TIME1 = RES8(1)
        SRC   = RESULT(I1)
        IANT  = RESULT(I1+1)
        ATMO   = RES8(2)
        DATMO  = RES8(3)
        KLOK   = RES8(6)
        DKLOK  = RES8(7)
C
C       SRC  = RESULT(15)
C       IANT = RESULT(48)
C       SRC  = RESULT(33)
C       SRC  = RESULT(25)
C       IANT = RESULT(34)
C       IANT = RESULT(26)
C
C#      TIME1 = RES8(TBKOLS(1,1))
C#      SRC  = RESULT(TBKOLS(2,1))
C#      IANT = RESULT(TBKOLS(3,1))
C#      ATMO   = RES8(TBKOLS(6,1))
C#      DATMO  = RES8(TBKOLS(7,1))
C#      KLOK   = RES8(TBKOLS(10,1))
C#      DKLOK  = RES8(TBKOLS(11,1))
C
C*********************************
C       IF (J .LE. 20)
C    *   print *,'Time,Src,Ant,Atm,Klok', TIME1, SRC, IANT, ATMO,
C    *                                    DATMO, KLOK, DKLOK
C
C    *   print *, 'J, Time, Src, Iant ', J, TIME1, SRC, IANT
C       WRITE(10,601) J, RESULT(33),RESULT(34),RES8(1),RES8(2),RES8(6)
C       WRITE(10,602) J, (RESULT(K), K=17,50)
C601    FORMAT(3I5,F10.7,2E18.10)
C602    FORMAT(I4,2X,34(I3,1X))
C*********************************
C
C  Search through IM table array for a match.
         DO 200 K = 1, IMKNT
          TDIF = TIME1 - IMTIM(K)
          IF ( (DABS(TDIF) .LE. 1.E-9) .AND. (SRC .EQ. IMSRC(K)) ) THEN
C    Set slot number equal to the MC table record number
            MCROW(K,IANT) = J
C           IF (IMROW(K,IANT) .EQ. 0) WRITE(6,1042) TIME1, SRC, IANT
 1042        FORMAT('MC/IM table mismatch (Time, source, antenna): ',
     *              F10.6,2I3)
           GO TO 30
          ENDIF
  200    CONTINUE
C
   30  CONTINUE
C
  997  CONTINUE
C
        CALL TABIO('CLOS',1,IRNO,BUFFIM,BUFFIM,IRET)
C
 999  RETURN
      END
C
C-----------------------------------------------------------------------
      SUBROUTINE CLGET (INTAB, OUTTAB, NROW, NTERMS, NPOLN, ANTMAX,
     *                  NUMIF, IERR)
C-----------------------------------------------------------------------
C   Read through the CL table and add clocks, atmospheres, and delay
C    polynomial coefficientss from the MC and IM tables
C
C   Inputs:
C      INTAB   C*?  Input CL table object, should be open.
C      OUTTAB  C*?  Output CL table object, should be open.
C      NROW    I    Total number of rows in input CL table.
C      NTERMS  I    Number of terms in delay polynomial (6).
C      NPOLN   I    Number of polarizations (1 or 2)
C
C   Input/output:
C      ANTMAX  I    Maximum antenna number
C   Output:
C
C      IERR    I    Return code, -1 => data all processed, 0=>OK,
C                   else failed.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DIMV.INC'
      INCLUDE 'INCS:DGLB.INC'
C
      CHARACTER INTAB*(*), OUTTAB*(*)
      INTEGER NROW, NTERMS, NPOLN, NUMIF, ANTMAX, IERR, NTERM, KROW
      DOUBLE PRECISION  GEODLY(9), DIF, RSTRT, SAVDIF
      REAL  TIMEI, DOPOFF(MAXIF), ATMOS, DATMOS, MBDELY(2),
     *   CLOCK(2), DCLOCK(2), DISP(2), DDISP(2), CREAL(2,MAXIF),
     *   CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF), WEIGHT(2,MAXIF)
      INTEGER SOURCL, CLANT, SUBA, FREQID, REFA(2,MAXIF),
     *    K, JROW, IROW, ISTR, IMREC, MCREC, JREC, J, KK, JK, MCSAVE,
     *    SAVEJ
      DOUBLE PRECISION CTIME, GTIME, MTIME, GDELA(6), ATMO, DATMO, KLOK,
     *   DKLOK, XDIF, A0, A1, A2, A3, A4, A5, T1, T2, T3, T4, T5, TM1
      REAL DIFMIN
      REAL  APARM(10), DPARM(10)
       DOUBLE PRECISION GEODL2(9), DIFF6(6), XX, TMPTIM
       REAL ATMO2, DATMO2, CLOC2(2), DCLOC2(2), DIFF4(4)
       INTEGER IPRNT
      COMMON /APRM/ APARM, DPARM
C
      DOUBLE PRECISION IMTIM(3000)
      REAL IMTINT
      INTEGER IMSRC(3000), IMSUB(3000), IMROW(3000,20), IMKNT
     *        ,MCROW(3000,20)
      COMMON /IMMAP/ IMTIM, IMSRC, IMSUB, IMROW, MCROW, IMTINT, IMKNT
C
C-----------------------------------------------------------------------
       NTERM = 6
       KROW = 0
C      OPEN(UNIT=10, FILE='/tmp/test.clfix', STATUS='UNKNOWN',
C    *      ACCESS='APPEND')
C
      DO 1000 JROW = 1, NROW
C Read CL data for this row
         IROW = JROW
         CALL OTABCL (INTAB, 'READ', IROW, NPOLN, NUMIF, CTIME ,
     *      TIMEI, SOURCL, CLANT, SUBA, FREQID, IFR, GEODLY, DOPOFF,
     *      ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP, DDISP, CREAL,
     *      CIMAG, DELAY, RATE, WEIGHT, REFA, IERR)
C
C     Test stuff
        DO J=1,6
         GEODL2(J) = 0.0D0
          DIFF6(J) = 0.0D0
        END DO
        DO J=1,4
          DIFF4(J) = 0.0D0
        END DO
          ATMO2 = 0.0
         DATMO2 = 0.0
          CLOC2(1) = 0.0
          CLOC2(2) = 0.0
         DCLOC2(1) = 0.0
         DCLOC2(2) = 0.0
C
C  Find corresponding IM and MC table records
C
C   IM time MUST be at the two-minute tick BEFORE the CL time. MC time
C    should be the same, but it's not as critical (i.e. we can interpolate).
        ISTR  = CTIME  * 720
        RSTRT = ISTR / 720.D0
C
        SAVDIF = 999.D0
        SAVEJ = 0
        JREC = 0
        MCREC = 0
C
        DO 60 J = 1, IMKNT
          DIF = DABS (IMTIM(J) - RSTRT)
              IF(DIF.LT.SAVDIF) THEN
                SAVDIF = DIF
                SAVEJ  = J
              ENDIF
          IF ( (DIF .LE. 1.D-10) .AND. (SOURCL .EQ. IMSRC(J)) ) THEN
C   Found correct time/source row number in IMROW (and MCROW) array
            JREC = J
            GO TO 100
          ENDIF
  60    CONTINUE
C
C  No match found if we get here
C    Should we proceed or quit?
C            -Quit-
         WRITE(6,1010) CTIME, SOURCL
C#       IF(DPARM(1) .EQ. 2.) GO TO 310
C#       IF(GEODLY(1) .EQ. 0.D0 .AND. GEODLY(2) .EQ. 0.D0) GO TO 310
C#       GO TO 300
         IF(DPARM(1) .EQ. 2.) GO TO 300
         IF(GEODLY(1) .EQ. 0.D0 .AND. GEODLY(2) .EQ. 0.D0) GO TO 300
C            -Proceed-
           JREC = SAVEJ
           GO TO 140
C
 1010    FORMAT('!! No IM time for (time, source) !! ',F10.6,I3)
C
 100    CONTINUE
C*******************************************
         IF (DPARM(1).EQ.1. .OR. DPARM(1).EQ.2.) THEN
C  If redoing delay model coefficients from IM table:
          IMREC = ABS (IMROW(JREC,CLANT))
          IF (IMREC .GT. 0) THEN
C       read IM record
            CALL GETIM(IMREC, RSTRT, CLANT, SOURCL, GTIME, GDELA )
C  Correct the roundoff error in the IM time (error found by Dan Lebach)
C   99MAY24
C                                                Save original time
             TMPTIM = GTIME
C                                                Fix time at the 2-minute mark
             GTIME = DNINT(GTIME*720.D0)/720.D0
C                                                Save difference (seconds) for
C                                                later examination
             TMPTIM = (GTIME-TMPTIM)*86400.D0
C
C  Shift coefficients to CL table time
C    Simplify first:
            A0 = GDELA(1)
            A1 = GDELA(2)
C              skip if these are zero
C???         IF(A0 .EQ. 0.D0 .AND. A1. EQ. 0.D0) GO TO 140
            A2 = GDELA(3)
            A3 = GDELA(4)
            A4 = GDELA(5)
            A5 = GDELA(6)
            T1 = (CTIME - GTIME) * 86400.D0
            T2 = T1**2
            T3 = T1**3
            T4 = T1**4
            T5 = T1**5
C      WRITE (6,1020) (GEODLY(K), K=1,6)
 1020  FORMAT('Before: ',6E15.8)
C    Now shift coeficients:
            GEODL2(1) = A0 + A1*T1 + A2*T2 + A3*T3 + A4*T4 + A5*T5
            GEODL2(2) = A1 + 2.D0*A2*T1 + 3.D0*A3*T2 + 4.D0*A4*T3 +
     *                  5.D0*A5*T4
            GEODL2(3) = A2 + 3.D0*A3*T1 + 6.D0*A4*T2 + 10.D0*A5*T3
            GEODL2(4) = A3 +4.D0*A4*T1 + 10.D0*A5*T2
            GEODL2(5) = A4 + 5.D0*A5*T1
            GEODL2(6) = A5
C      WRITE (6,1021) (GEODL2(K), K=1,6)
 1021  FORMAT('After:  ',6E15.8)
C
C   More test stuff
          IPRNT = 0
          XX = 1.0D-12
        DO J=1,6
         DIFF6(J) = DABS(GEODLY(J) - GEODL2(J))
          XX = XX/10.D0
         IF (DIFF6(J) .GE. XX) IPRNT = IPRNT+1
        END DO
C
          ENDIF
         ENDIF
C
  140 CONTINUE
C*******************************************
         IF (DPARM(1).EQ.0. .OR. DPARM(1).EQ.1.) THEN
C  First double check that we have a source match
           IF(SOURCL .EQ. IMSRC(JREC)) THEN
             MCREC = ABS (MCROW(JREC,CLANT))
           ELSE
             MCREC = 0
           ENDIF
C
           IF (MCREC .GT. 0) THEN
C    Easy case
             CALL GTMC(MCREC, CLANT, SOURCL, MTIME, ATMO, DATMO,
     *            KLOK, DKLOK)
             GO TO 200
           ENDIF
C
           IF (MCREC .EQ. 0) THEN
C    Not so easy case, no match at optimum time
C
             K = 0
             KK = 0
  150        CONTINUE
             K = K + 1
             JK = K
             DO 160 J = 1, 2
               JK = -JK
C
C   Make sure we're not beyond the table bounds
               IF((JREC+JK) .LT. 1 .OR. (JREC+JK) .GT. IMKNT) THEN
                IF((JREC-JK) .LT. 1 .OR. (JREC-JK) .GT. IMKNT) THEN
                 IF(KK.NE.0) THEN
                   MCREC = MCSAVE
                   CALL GTMC(MCREC,CLANT,SOURCL, MTIME,ATMO,DATMO,
     *                  KLOK,DKLOK)
                   ATMO = 0.0D0
                   DATMO = 0.0D0
C             print *,' MC table - beyond match! '
                   GO TO 200
                 ELSE
                   GO TO 300
                 ENDIF
                ENDIF
                GO TO 160
               ENDIF
C
C   Antenna match earlier or later
               IF (MCROW((JREC+JK),CLANT) .NE. 0) THEN
                IF (SOURCL .EQ. IMSRC(JREC+JK)) THEN
C   Source match also
                   MCREC = ABS(MCROW((JREC+JK),CLANT))
                   CALL GTMC(MCREC,CLANT,SOURCL, MTIME,ATMO,DATMO,
     *                  KLOK,DKLOK)
                   XDIF = DABS (MTIME - IMTIM(JREC))
                   DIFMIN = XDIF * 1440.
                  IF(DIFMIN .GT. 8.) THEN
C    Probably a different scan - don't interpolate atmosphere
                    ATMO = 0.0D0
                    DATMO = 0.0D0
                  ENDIF
                   GO TO 200
                ELSE
C   Source mismatch, save first occurrance in case we never get a match
                   KK = KK+1
                  IF (KK.EQ.1) THEN
                    MCSAVE = ABS(MCROW((JREC+JK),CLANT))
                  ENDIF
                ENDIF
               ENDIF
C
  160        CONTINUE
C
                 XDIF = DABS (IMTIM(JREC+JK) - IMTIM(JREC))
                 DIFMIN = XDIF * 1440.
C   If getting far from CL time, stop looking once we have a clock offset
                 IF(DIFMIN .GT. 20. .AND. KK.GE.1) THEN
                  MCREC = MCSAVE
                  CALL GTMC(MCREC,CLANT,SOURCL, MTIME,ATMO,DATMO,
     *                       KLOK,DKLOK)
                  ATMO = 0.0D0
                  DATMO = 0.0D0
                  GO TO 200
                 ENDIF
             GO TO 150
C
           ENDIF
C
         ENDIF
C
  200   CONTINUE
C   Interpolate clocks and atms to CL table time
C    Time shift, in seconds
           TM1 = (CTIME  - MTIME) * 86400.D0
            ATMO2    = ATMO + TM1*DATMO
           DATMO2    = DATMO
            CLOC2(1) = KLOK + TM1 * DKLOK
           DCLOC2(1) = DKLOK
C        WRITE(6,1022) CTIME, MTIME, ATMO, DATMO, KLOK, DKLOK
C        WRITE(6,1023) TM1, ATMO2, DATMO2, CLOC2(1), DCLOC2(1)
 1022    FORMAT('CTIME, etc ',2F10.5,4E18.8)
 1023    FORMAT('TM1, etc  ', F20.5,4E18.8)
C
 300     CONTINUE
C
C  Even more test stuff
          DIFF4(1) = ABS( ATMOS -  ATMO2)
          DIFF4(2) = ABS(DATMOS - DATMO2)
          DIFF4(3) = ABS( CLOCK(1) -  CLOC2(1))
          DIFF4(4) = ABS(DCLOCK(1) - DCLOC2(1))
C           DO J=1,4
C            IF (DIFF4(J) .GT. 0.0) IPRNT = IPRNT+1
C           ENDDO
           IF (DIFF4(1) .GE. 1.0E-11) IPRNT = IPRNT+1
           IF (DIFF4(2) .GE. 1.0E-12) IPRNT = IPRNT+1
           IF (DIFF4(3) .GE. 1.0E-8 ) IPRNT = IPRNT+1
           IF (DIFF4(4) .GE. 1.0E-9 ) IPRNT = IPRNT+1
C
C          IF(IPRNT .GT. 1) THEN
C           WRITE(10,1087) JROW,CLANT,SOURCL,CTIME,TMPTIM,DIFF6,DIFF4
C           WRITE(6,1087)  JROW,CLANT,SOURCL,CTIME,TMPTIM,DIFF6,DIFF4
 1087       FORMAT(I6,I3,I3,F6.3,E10.2,1X,6E10.2,2X,4E10.2)
C          ENDIF
C
C  Write output record for this row
C
         KROW = JROW
C        KROW = KROW + 1
         CALL OTABCL (OUTTAB, 'WRIT', KROW, NPOLN, NUMIF, CTIME,
     *      TIMEI, SOURCL, CLANT, SUBA, FREQID, IFR, GEODL2, DOPOFF,
     *      ATMO2, DATMO2, MBDELY, CLOC2, DCLOC2, DISP, DDISP, CREAL,
     *      CIMAG, DELAY, RATE, WEIGHT, REFA, IERR)
           IF(IERR.NE.0) THEN
             PRINT *,'JROW,KROW,OTABCL error = ',JROW,KROW,IERR
             RETURN
           ENDIF
C
 310     CONTINUE
C
 1000 CONTINUE
C
C       CLOSE(10)
C
        RETURN
        END
C-----------------------------------------------------------------------------
      SUBROUTINE GETIM(IMREC, RSTRT, CLANT, SOURCL, GTIME, GDELA )
C-----------------------------------------------------------------------------
C   Reads the requested IM record.
C
C     Inputs:
C      IMREC    I   Requested record number in the IM table
C      RSTRT    D   IM time should match this time.
C      CLANT    I   Antenna should match this number (from CL table).
C      SOURCL   I   Source should match this number (from CL table).
C
C     Outputs:
C      GTIME    D   IM table time
C      GDELA(6) D   The six polynomial coeffiecients from the IM table.
C-----------------------------------------------------------------------------
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DIMV.INC'
      INCLUDE 'INCS:DGLB.INC'
C
      INTEGER IMREC, SOURIM, IMANT, I, CLANT, SOURCL
      DOUBLE PRECISION GTIME, GDELA(6), RSTRT
      DOUBLE PRECISION IMTIM(3000)
      REAL IMTINT
      INTEGER IMSRC(3000), IMSUB(3000), IMROW(3000,20), IMKNT
     *        ,MCROW(3000,20)
      COMMON /IMMAP/ IMTIM, IMSRC, IMSUB, IMROW, MCROW, IMTINT, IMKNT
      INTEGER BUFFIM(1024)
      INTEGER NTERM, INVER, IRET
      INTEGER DISKIN, SEQIN, OLDCNO, NUSER, LUN
      CHARACTER NAMEIN*12, CLAIN*6
      COMMON /IMSTUF/ DISKIN, SEQIN, OLDCNO, NUSER, LUN, NAMEIN, CLAIN
C
       INVER = 1
       NTERM = 6
C
       LUN = 38
        CALL IMINI ('READ', BUFFIM, DISKIN, OLDCNO, INVER, CATBLK, LUN,
     *       IRET)
C
           IIMRNO = IMREC
         CALL IMTAB ('READ', BUFFIM, NOBAND, IRET )
          IF(IRET.NE.0) THEN
           PRINT *, ' GETIM/IMTAB: IRET, IMREC ', IRET, IMREC
           GO TO 997
          ENDIF
C
           GTIME = TIME
           SOURIM = ISRC
           IMANT = NOSTA
C  Double check the match
         IF(DABS(RSTRT-GTIME) .GT. 1.D-9)
     *     PRINT *,'GETIM time mismatch: RSTRT, GTIME = ', RSTRT, GTIME
         IF(IMANT .NE. CLANT)
     *     PRINT *,'GETIM Antenna mismatch: IMANT, CLANT ', IMANT, CLANT
         IF(SOURIM .NE. SOURCL)
     *    PRINT *,'GETIM Source mismatch: SOURIM, SOURCL ',SOURIM,SOURCL
C  Geometric delay terms (the correlator model).
         DO 52 I = 1, 6
          GDELA(I) = GDELA1(I)
 52      CONTINUE
C
        CALL TABIO('CLOS',1,IIMRNO,BUFFIM,BUFFIM,IRET)
C
 997    CONTINUE
        RETURN
        END
C
C*****************************************************************************
      SUBROUTINE GTMC (MCREC, CLANT, SOURCL, MTIME, ATMO, DATMO,
     *           KLOK, DKLOK)
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DIMV.INC'
      INCLUDE 'INCS:DGLB.INC'
C
C
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:PAOOF.INC'
C     INCLUDE 'INCS:DMSG.INC'
C     INCLUDE 'INCS:DCAT.INC'
      INTEGER   TBKOLS(128,MAXIO), TBNUMV(128,MAXIO)
      COMMON /TBSTUF/ TBKOLS, TBNUMV
C     INTEGER MCCOLS(21)
C     EQUIVALENCE ( TBKOLS(1,1),MCCOLS(1) )
C
      INTEGER IRNO, RESULT(512), MCREC, JFRST, CLANT, SOURCL, I1
      REAL RES4(512)
      DOUBLE PRECISION RES8(256), MTIME, ATMO, DATMO, KLOK, DKLOK
      EQUIVALENCE (RESULT, RES4, RES8)
      INTEGER SOURMC, MCANT
C
      DOUBLE PRECISION IMTIM(3000)
      REAL IMTINT
      INTEGER IMSRC(3000), IMSUB(3000), IMROW(3000,20), IMKNT
     *        ,MCROW(3000,20)
      COMMON /IMMAP/ IMTIM, IMSRC, IMSUB, IMROW, MCROW, IMTINT, IMKNT
      INTEGER BUFFIM(512), NTERM, INVER, IRET
      INTEGER DISKIN, SEQIN, OLDCNO, NUSER, LUN
      CHARACTER NAMEIN*12, CLAIN*6
      COMMON /IMSTUF/ DISKIN, SEQIN, OLDCNO, NUSER, LUN, NAMEIN, CLAIN
      COMMON /I1MC/I1
      DATA JFRST /0/
C-----------------------------------------------------------------------
       INVER = 1
       NTERM = 6
       LUN = 37
C
C  Initialize MC table
       CALL TABINI ('READ', 'MC', DISKIN, OLDCNO, INVER, CATBLK, LUN,
     *      NKEY, NREC, NCOL, DATP, BUFFIM, IRET)
       IF(IRET .NE. 0) RETURN
C
C       I1 = BUFFIM(8) - 4
C
        IRNO = MCREC
        CALL TABIO ('READ', 0, IRNO, RESULT, BUFFIM, IRET)
       IF(IRET .NE. 0) RETURN
C
        SOURMC = RESULT(I1)
        MCANT  = RESULT(I1+1)
C
C       SOURMC = RESULT(TBKOLS(2,1))
C       MCANT  = RESULT(TBKOLS(3,1))
C
         IF (MCANT .NE. CLANT)
     *     PRINT *,'GTMC Antenna mismatch: MCANT, CLANT ', MCANT, CLANT
        MTIME  = RES8(1)
        ATMO   = RES8(2)
        DATMO  = RES8(3)
        KLOK   = RES8(6)
        DKLOK  = RES8(7)
C
C       MTIME  = RES8(TBKOLS(1,1))
C       ATMO   = RES8(TBKOLS(6,1))
C       DATMO  = RES8(TBKOLS(7,1))
C       KLOK   = RES8(TBKOLS(10,1))
C       DKLOK  = RES8(TBKOLS(11,1))
C
        CALL TABIO('CLOS',1,IRNO,BUFFIM,BUFFIM,IRET)
C
        RETURN
        END

      SUBROUTINE COLOR2 (NLEVS, ICOLR, NBRK, GAMMA, APARM, BUFFER, IERR)
C-----------------------------------------------------------------------
C! 2-colors: wedge from high to 0, 2nd wedge from there to high
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2020-2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   COLORL creates a continuous coloring from blue thru green to red.
C   Inputs:
C      NLEVS   I      # of intensities (usually 256 or 1024)
C      ICOLR   I      initial color R,G,B = 1,2,3
C                     < 0 => go RBG order instead
C      NBRK    I      break point between low color and high
C      GAMMA   R      gamma correction power
C      APARM   R(10)  Fiddle parameters: (1) fractional overlap of 2
C                       (2,3) peak, fractional overlap middle color
C   Output:
C      BUFFER  R(*)   scratch buffer
C      IERR    I      error code of ZM70XF: 0 - ok
C-----------------------------------------------------------------------
      INTEGER   NLEVS, ICOLR, NBRK, IERR
      REAL      GAMMA, APARM(10), BUFFER(*)
C
      INTEGER   NMX, NBR, KOLOR, NEND(2), ICI, INC, JERR
      REAL      GAMINV, SLOPE(2), OFFSET(2), FO, FP, TF
      LOGICAL   WASYNC
      INCLUDE 'INCS:DTVC.INC'
C-----------------------------------------------------------------------
      GAMINV = GAMMA
      IF (GAMINV.LE.0.0) GAMINV = 1.0
      GAMINV = 1.0 / GAMINV
      IF (NLEVS.GT.OFMINP+1) NLEVS = OFMINP + 1
      NMX = MAX (3, NLEVS)
      NBR = MAX (2, MIN (NMX-1, NBRK))
      TF = REAL (NBR) / REAL(NLEVS)
      NEND(1) = NMX
      NEND(2) = NMX
      ICI = ABS (ICOLR)
      INC = -1
      IF (ICOLR.LT.0) INC = 1
      IF ((ICI.LT.1) .OR. (ICI.GT.3)) ICI = 3
      WASYNC = ISYNCH.EQ.0
      IF (WASYNC) CALL YHOLD ('ONNN', JERR)
C                                        first color (blue ICI=3)
      KOLOR = 2 ** (3-ICI)
      SLOPE(1) = 1.0 / (1.0-NBR-APARM(1)*(NMX-NBR))
      OFFSET(1) = 1.0
      CALL ILNCLR (KOLOR, 1, NEND, SLOPE, OFFSET, GAMINV, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 990
C                                        second color (green ICI->2)
      ICI = ICI + INC
      IF (ICI.EQ.4) ICI = 1
      IF (ICI.EQ.0) ICI = 3
      KOLOR = 2 ** (3-ICI)
C                                       off
      IF ((APARM(2).LE.0.0) .OR. (APARM(3).LE.0.0)) THEN
         SLOPE(1) = 0.0
         OFFSET(1) = 0.0
         CALL ILNCLR (KOLOR, 1, NEND, SLOPE, OFFSET, GAMINV, BUFFER,
     *      IERR)
C                                       enabled
      ELSE
         NEND(1) = NBR
         TF = NBR - (NBR-1)*APARM(3)
         SLOPE(1) = APARM(2) / (NBR-TF)
         OFFSET(1) = -SLOPE(1) * (TF - 1.0)
         TF = NBR + (NMX-NBR)*APARM(3)
         SLOPE(2) = -APARM(2) / (TF - NBR)
         OFFSET(2) = -SLOPE(2) * (TF-1.0)
         CALL ILNCLR (KOLOR, 2, NEND, SLOPE, OFFSET, GAMINV, BUFFER,
     *      IERR)
         NEND(1) = NMX
         END IF
      IF (IERR.NE.0) GO TO 990
C                                        third color (red ICI->1)
      ICI = ICI + INC
      IF (ICI.EQ.4) ICI = 1
      IF (ICI.EQ.0) ICI = 3
      KOLOR = 2 ** (3-ICI)
      TF = APARM(1) * (NBR - 1)
      SLOPE(1) = 1.0 / (NMX-NBR-TF)
      OFFSET(1) = -(NBR-TF-1.0) * SLOPE(1)
      CALL ILNCLR (KOLOR, 1, NEND, SLOPE, OFFSET, GAMINV, BUFFER, IERR)
C
 990  IF (WASYNC) CALL YHOLD ('OFFF', JERR)
C
 999  RETURN
      END

      PROGRAM BDEPO
C-----------------------------------------------------------------------
C! Predicts beam depolarization from rotation measure images
C# Map Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2008-2009, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BDEPO predicts beam depolarization from Rotation Measure gradient
C   images (created by NINER say).
C       Inputs:
C 1         USERID               Owner of the image
C 2-4       INNAME(3)            First RM gradient image name
C 5-6       INCLASS(2)           First RM gradient image class
C 7         INSEQ                First RM gradient image seq. no.
C 8         INDISK               First RM gradient image disk no.
C 9-11      I2NNAME(3)           Second RM gradient image name
C 12-13     IN2CLASS(2)          Second RM gradient image class
C 14        IN2SEQ               Second RM gradient image seq. no.
C 15        IN2DISK              Second RM gradient image disk no.
C 16-22     BLC(7)               Input image(s) BLC
C 23-29     TRC(7)               Input image(s) TRC
C 30-32     OUTNAME(3)           Output image name
C 33-34     OUTCLASS(2)          Output image class
C 35        OUTSEQ               Output image seq. no.
C 36        OUTDISK              Output image disk no.
C 37-46     CPARM(10)            Frequencies between which to compute
C                                depolarization in CPARM(1:2)
C                                Multiplicative factors for gradient
C   images
C                                in CPARM(3) and CPARM(4)
C     Neil Killeen, Feb 1987
C-----------------------------------------------------------------------
      INTEGER   NPARMS
      PARAMETER (NPARMS = 46)
      CHARACTER RGANAM*36, RGBNAM*36, PDPNAM*36
      REAL      RPARM(NPARMS), FR1, FR2, GRFACA, GRFACB
      INTEGER   IERR, IER, RGASLO, PDPSLO, LUNRGA, LUNRGB, LUNPDP,
     *   BLC(2), TRC(2)
      LOGICAL   OPENB
      DATA IER, LUNRGA, LUNRGB, LUNPDP /0, 17, 18, 19/
C-----------------------------------------------------------------------
C                                       start up task, get AIPS
C                                       parameters
      CALL START (RPARM, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       open image files
      CALL OPENIM (RPARM, LUNRGA, LUNRGB, LUNPDP, RGANAM, RGBNAM,
     *   PDPNAM, OPENB, BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       write output image
      CALL OUTPUT (RPARM, LUNRGA, LUNRGB, LUNPDP, OPENB, RGASLO,
     *   PDPSLO, FR1, FR2, GRFACA, GRFACB, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       close files
      CALL CLOSUP (OPENB, LUNRGA, LUNRGB, LUNPDP)
C                                       write history
      CALL DEPOHI (OPENB, RGANAM, RGBNAM, PDPNAM, RGASLO, PDPSLO,
     *   BLC, TRC, FR1, FR2, GRFACA, GRFACB)
      CALL CLENUP
      GO TO 990
C                                       error return
 900  IER = 1
      CALL CLENUP
C                                       normal return
 990  CALL TSKEND (IER)
C-----------------------------------------------------------------------
      STOP
      END
      SUBROUTINE START (RPARM, IERR)
C-----------------------------------------------------------------------
C     Start up task, get input parameters and write initial message
C     OUTPUT:
C       RPARM   R      array containing AIPS parameters
C       IERR    I      error status, 0=> OK
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      REAL      RPARM(*)
      INTEGER   NPARMS, IERR
      INCLUDE 'INCS:DMSG.INC'
      DATA PRGNAM /'BDEPO '/
C-----------------------------------------------------------------------
C                                       start up TASK, get AIPS
C                                       parameters except USERID
      NPARMS = 45
      CALL TSKBEG (PRGNAM, NPARMS, RPARM(2), IERR)
      IF (IERR.EQ.0) THEN
         WRITE (MSGTXT,1000)
         CALL MSGWRT(8)
      ELSE
         WRITE (MSGTXT,2000) IERR
         CALL MSGWRT (8)
         END IF
      RPARM(1) = NLUSER
C
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('You are using a non-linear program')
 2000 FORMAT ('START: COULD NOT GET INPUTS, IERR=', I4)
      END
      SUBROUTINE OPENIM (RPARM, LUNRGA, LUNRGB, LUNPDP, RGANAM, RGBNAM,
     *   PDPNAM, OPENB, BLC, TRC, IERR)
C-----------------------------------------------------------------------
C   Open the input image(s) and create and open the output image.
C     Input:
C         RPARM     R       array of AIPS input parameters
C         LUNRGA    I       logical unit number for first (x) RM
C                            gradient image
C         LUNRGB    I       logical unit number for second (y) RM
C                           gradient image
C         LUNPDP    I       logical unit number for output DPR image
C     Output:
C         RGANAM    C*36    Namestring for first RM gradient image
C         RGBNAM    C*36    Namestring for second RM gradient image
C         PDPNAM    C*36    Namestring for output DPR image
C         OPENB     L       .true. if second RM image opened
C         BLC,TRC   I       Window on input images, defaults filled in
C         IERR      I       error status, 0=> OK
C-----------------------------------------------------------------------
      CHARACTER RGANAM*36, RGBNAM*36, PDPNAM*36
      REAL      RPARM(*)
      INTEGER   LUNRGA, LUNRGB, LUNPDP, IERR, BLC(*), TRC(*)
      LOGICAL   OPENB
C-----------------------------------------------------------------------
C                                        open input image(s)
      CALL OPENIN (RPARM, LUNRGA, LUNRGB, RGANAM, RGBNAM, OPENB, IERR)
C                                        open output AIPS image
      IF (IERR.EQ.0) CALL OPENOU (RPARM, LUNPDP, PDPNAM, BLC, TRC, IERR)
C
      RETURN
      END
      SUBROUTINE OPENIN (RPARM, LUNRGA, LUNRGB, RGANAM, RGBNAM,
     *   OPENB, IERR)
C-----------------------------------------------------------------------
C   Set up the input namestring(s), open and window the input image(s)
C   and get the header(s).   Make some simple checks about
C   compatability between the images if both are opened.
C     Input:
C         RPARM     R       array of AIPS input parameters
C         LUNRGA    I       logical unit number for first (x) RM
C                           gradient image
C         LUNRGB    I       logical unit number for second (y) RM
C                           gradient image
C     Output:
C         RGANAM    C*36    Namestring for first RM gradient image
C         RGBNAM    C*36    Namestring for second RM gradient image
C         OPENB     L       .true. if second RM image opened
C         IERR      I       error status, 0=> OK
C RPARM PARAMETERS:
C       Inputs:
C 1         USERID               Owner of the image
C 2-4       INNAME(3)            First RM gradient image name
C 5-6       INCLASS(2)           First RM gradient image class
C 7         INSEQ                First RM gradient image seq. no.
C 8         INDISK               First RM gradient image disk no.
C 9-11      I2NNAME(3)           Second RM gradient image name
C 12-13     IN2CLASS(2)          Second RM gradient image class
C 14        IN2SEQ               Second RM gradient image seq. no.
C 15        IN2DISK              Second RM gradient image disk no.
C 16-22     BLC(7)               Input image(s) BLC
C 23-29     TRC(7)               Input image(s) TRC
C
C-----------------------------------------------------------------------
      REAL      RPARM(*)
      CHARACTER RGANAM*36, RGBNAM*36
      INTEGER   LUNRGA, LUNRGB, IERR
      LOGICAL   OPENB
C-----------------------------------------------------------------------
C                                              first RM gradient image
      CALL OPENFI (RPARM, LUNRGA, RGANAM, IERR)
C                                              optional second RM
C                                       gradient image
      IF (IERR.EQ.0) CALL OPENSE (RPARM, LUNRGB, RGBNAM, OPENB, IERR)
C
      RETURN
      END
      SUBROUTINE OPENFI (RPARM, LUNRGA, RGANAM, IERR)
C-----------------------------------------------------------------------
C     For the the first input RM gradient image, set up the input
C   namestring,
C     open and window the image and get the header.
C     Input:
C         RPARM     R       array of AIPS input parameters
C         LUNRGA    I       logical unit number for first (x) RM
C                           gradient image
C     Output:
C         RGANAM    R       Namestring for first RM gradient image
C         IERR      I       error status, 0=> OK
C
C RPARM PARAMETERS:
C
C       INPUTS:
C 1         USERID               Owner of the image
C 2-4       INNAME(3)            First RM gradient image name
C 5-6       INCLASS(2)           First RM gradient image class
C 7         INSEQ                First RM gradient image seq. no.
C 8         INDISK               First RM gradient image disk no.
C 16-22     BLC(7)               Input image(s) BLC
C 23-29     TRC(7)               Input image(s) TRC
C
C-----------------------------------------------------------------------
      CHARACTER RGANAM*36
      HOLLERITH MAP(1)
      DOUBLE PRECISION HRGA8(128), DUM1(128), DUM2(128)
      REAL   RPARM(*)
      INTEGER   LUNRGA, HRGA2(256), IERR
      INCLUDE 'INCS:DMSG.INC'
      COMMON /HEADS/ HRGA8, DUM1, DUM2
      EQUIVALENCE (HRGA2, HRGA8)
C-----------------------------------------------------------------------
C                                           set up namestring
      CALL CHR2H (4, 'MA  ', 1, MAP)
      CALL H2WAWA (RPARM(2), RPARM(5), RPARM(7), MAP, RPARM(8),
     *   RPARM(1), RGANAM)
C                                           open file
      CALL OPENCF (LUNRGA, RGANAM, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 900
         END IF
C                                           get header
      CALL GETHDR (LUNRGA, HRGA2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,2000) IERR
         GO TO 900
         END IF
C                                           set up window
      CALL MAPWIN (LUNRGA, RPARM(16), RPARM(23), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,3000) IERR
         GO TO 900
         END IF
      GO TO 990
C
 900  CALL MSGWRT (8)
C
 990  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OPENFI: ERROR OPENING FIRST GRADIENT IMAGE, IERR=', I3)
 2000 FORMAT ('OPENFI: ERROR GETTING FIRST GRADIENT IMAGE HEADER,',
     *   ' IERR=', I4)
 3000 FORMAT ('OPENFI: ERROR WINDOWING FIRST GRADIENT IMAGE, IERR=',
     *     I3)
      END
      SUBROUTINE OPENSE (RPARM, LUNRGB, RGBNAM, OPENB, IERR)
C-----------------------------------------------------------------------
C     For the optional second RM gradient image, set up the input
C   namestring,
C     open and window the image and get the header.  Make some simple
C   checks
C     about compatability between the input images if both are opened.
C     Input:
C         RPARM     R       array of AIPS input parameters
C         LUNRGB    I       logical unit number for second (y) RM
C                           gradient image
C     Output:
C         RGBNAM    C*36    Namestring for second RM gradient image
C         OPENB     L       .true. if second RM image opened
C         IERR      I       error status, 0=> OK
C RPARM PARAMETERS:
C       INPUTS:
C 1         USERID               Owner of the image
C 9-11      I2NNAME(3)           Second RM gradient image name
C 12-13     IN2CLASS(2)          Second RM gradient image class
C 14        IN2SEQ               Second RM gradient image seq. no.
C 15        IN2DISK              Second RM gradient image disk no.
C 16-22     BLC(7)               Input image(s) BLC
C 23-29     TRC(7)               Input image(s) TRC
C-----------------------------------------------------------------------
      CHARACTER RGBNAM*36
      HOLLERITH MAP(1)
      DOUBLE PRECISION  DUM1(128), HRGB8(128), DUM2(128)
      REAL   RPARM(*)
      INTEGER   LUNRGB, HRGB2(256), IERR
      LOGICAL   OPENB
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /HEADS/ DUM1, HRGB8, DUM2
      EQUIVALENCE (HRGB2, HRGB8)
C-----------------------------------------------------------------------
C                                       set up name string
      IF (RPARM(9).NE.HBLANK) THEN
         CALL CHR2H (4, 'MA  ', 1, MAP)
         CALL H2WAWA (RPARM(9), RPARM(12), RPARM(14), MAP, RPARM(15),
     *      RPARM(1), RGBNAM)
C                                        open file
        CALL OPENCF (LUNRGB, RGBNAM, IERR)
        IF (IERR.NE.0) THEN
           WRITE (MSGTXT,1000) IERR
           GO TO 900
           END IF
C                                        get header
        CALL GETHDR (LUNRGB, HRGB2, IERR)
        IF (IERR.NE.0) THEN
           WRITE (MSGTXT,2000) IERR
           GO TO 900
           END IF
C                                        set up window
        CALL MAPWIN (LUNRGB, RPARM(16), RPARM(23), IERR)
        IF (IERR.NE.0) THEN
           WRITE (MSGTXT,3000) IERR
           GO TO 900
           END IF
C
         CALL IMACOM (IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,4000) IERR
            GO TO 900
            END IF
         OPENB = .TRUE.
      ELSE
         OPENB = .FALSE.
         END IF
      GO TO 990
C
 900  CALL MSGWRT (8)
 990  RETURN
C
C-----------------------------------------------------------------------
 1000 FORMAT ('OPENSE: ERROR OPENING SECOND GRADIENT IMAGE, IERR=', I3)
 2000 FORMAT ('OPENSE: ERROR GETTING SECOND GRADIENT IMAGE HEADER,',
     *        ' IERR=', I3)
 3000 FORMAT ('OPENSE: ERROR WINDOWING SECOND GRADIENT IMAGE, IERR=',
     *        I3)
 4000 FORMAT ('OPENSE: RM GRADIENT IMAGES NOT COMPATABLE, IERR=', I3)
      END
      SUBROUTINE IMACOM (IERR)
C-----------------------------------------------------------------------
C     Make some simple compatability checks between the two input images
C     Output:
C          IERR    I       0 => OK
C-----------------------------------------------------------------------
      DOUBLE PRECISION HRGA8(128), HRGB8(128), DUM(128)
      REAL   PIXRAT, PIXDIF, HRGA4(256), HRGB4(256)
      INTEGER   HRGA2(256), HRGB2(256), IERR
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      COMMON /HEADS/ HRGA8, HRGB8, DUM
      EQUIVALENCE (HRGA2, HRGA4, HRGA8), (HRGB2, HRGB4, HRGB8)
C-----------------------------------------------------------------------
C                                         input images must have square
C                                       pixels
      IERR = 0
      PIXRAT = ABS (HRGA4(KRCIC) / HRGA4(KRCIC+1))
      PIXDIF = ABS (PIXRAT - 1.0)
      IF (PIXDIF.GT.1.0E-5) THEN
         WRITE (MSGTXT,1000)
         IERR = 1
         GO TO 900
         END IF
C
      PIXRAT = ABS(HRGB4(KRCIC) / HRGB4(KRCIC+1))
      PIXDIF = ABS(PIXRAT - 1.0)
      IF (PIXDIF.GT.1.0E-5) THEN
         WRITE (MSGTXT,2000)
         IERR = 1
         GO TO 900
         END IF
C                                       try and make sure increments are
C                                       the same.
      PIXRAT = ABS(HRGA4(KRCIC) / HRGB4(KRCIC))
      PIXDIF = ABS(PIXRAT - 1.0)
      IF (PIXDIF.GT.1.0E-5) THEN
         WRITE (MSGTXT,3000)
         IERR = 2
         GO TO 900
         END IF
C
      PIXRAT = ABS (HRGA4(KRCIC+1) / HRGB4(KRCIC+1))
      PIXDIF = ABS(PIXRAT - 1.0)
      IF (PIXDIF.GT.1.0E-5) THEN
         WRITE (MSGTXT,4000)
         IERR = 2
         GO TO 900
         END IF
C                                               check image sizes
      IF ( (HRGA2(KINAX) .NE. HRGB2(KINAX)) .OR.
     *     (HRGA2(KINAX+1) .NE. HRGB2(KINAX+1))  ) THEN
          WRITE (MSGTXT,5000)
          IERR = 3
          GO TO 900
         END IF
      GO TO 990
 900  CALL MSGWRT (8)
C
 990  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('IMACOM: PIXELS ARE NOT SQUARE IN FIRST GRADIENT IMAGE')
 2000 FORMAT ('IMACOM: PIXELS ARE NOT SQUARE IN SECOND GRADIENT IMAGE')
 3000 FORMAT ('IMACOM: GRADIENT IMAGE X-AXIS INCREMENTS ARE NOT EQUAL')
 4000 FORMAT ('IMACOM: GRADIENT IMAGE Y-AXIS INCREMENTS ARE NOT EQUAL')
 5000 FORMAT ('IMACOM: GRADIENT IMAGE DIMENSIONS ARE NOT EQUAL')
      END
      SUBROUTINE OPENOU (RPARM, LUNPDP, PDPNAM, BLC, TRC, IERR)
C-----------------------------------------------------------------------
C     Create and open output image
C     Inputs:
C         RPARM     R       array of AIPS input parameters
C         LUNPDP    I       logical unit number for predicted DPR image
C     Outputs:
C         PDPNAM    R       Namestring for predicted DPR image
C         BLC       I       BLC of input image
C         TRC       I       TRC of input image
C         IERR      I       error status, 0=> OK
C
C  RPARM PARAMETERS:
C
C 1         USERID               Owner of the image
C 2-4       INNAME(3)            First RM gradient image name
C 5-6       INCLASS(2)           First RM gradient image class
C 7         INSEQ                First RM gradient image seq. no.
C 8         INDISK               First RM gradient image disk no.
C 30-32     OUTNAME(3)           Output image name
C 33-34     OUTCLASS(2)          Output image class
C 35        OUTSEQ               Output image seq. no.
C 36        OUTDISK              Output image disk no.
C
C-----------------------------------------------------------------------
      CHARACTER DEFNAM*36, PDPNAM*36, BDEP*6
      HOLLERITH MAP(1), HTEMP(2)
      DOUBLE PRECISION HRGA8(128), HPDP8(128), DUM(128)
      REAL   RPARM(*)
      INTEGER   LUNPDP, IERR, HRGA2(256), HPDP2(256), BLC(*), TRC(*)
      INCLUDE 'INCS:DMSG.INC'
      COMMON /HEADS/ HRGA8, DUM, HPDP8
      EQUIVALENCE (HRGA2, HRGA8), (HPDP2, HPDP8)
      DATA BDEP /'BDEPO '/
C-----------------------------------------------------------------------
      CALL HEADER (RPARM, BLC, TRC)
C                                       default output namestring
      CALL CHR2H (4, 'MA  ', 1, MAP)
      CALL CHR2H (6, BDEP, 1, HTEMP)
      CALL H2WAWA (RPARM(2), HTEMP, RPARM(7), MAP, RPARM(8),
     *   RPARM(1), DEFNAM)
C                                        output namestring
      CALL H2WAWA (RPARM(30), RPARM(33), RPARM(35), MAP, RPARM(36),
     *   RPARM(1), PDPNAM)
C                                        create file
      CALL MAPCR (DEFNAM, PDPNAM, HPDP2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 900
         END IF
C                                         open file
      CALL OPENCF (LUNPDP, PDPNAM, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,2000) IERR
         GO TO 900
         END IF
      GO TO 990
 900  CALL MSGWRT (8)
C
 990  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OPENOU: COULD NOT CREATE OUTPUT IMAGE, IERR=', I3)
 2000 FORMAT ('OPENOU: COULD NOT OPEN OUTPUT IMAGE, IERR=',  I3)
      END
      SUBROUTINE HEADER (RPARM, BLC, TRC)
C-----------------------------------------------------------------------
C  Make the output image header from the first RM gradient image
C     Input:
C         RPARM     R       array of AIPS input parameters
C     Ouput:
C         BLC       I       BLC of input image
C         TRC       I       TRC of input image
C  RPARM PARAMETERS:
C 16-22     BLC(7)           Input image(s) BLC
C 23-29     TRC(7)           Input image(s) TRC
C-----------------------------------------------------------------------
      CHARACTER UNITS*8
      HOLLERITH HPDPH(256)
      DOUBLE PRECISION HRGA8(128), HPDP8(128), DUM8(128)
      REAL   RPARM(*), HRGA4(256), HPDP4(256)
      INTEGER   BLC(*), TRC(*), HRGA2(256), HPDP2(256), NCOLS, NROWS,
     *   I, IROUND
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMMON /HEADS/ HRGA8, DUM8, HPDP8
      EQUIVALENCE (HRGA2,  HRGA4, HRGA8) , (HPDP2, HPDP4, HPDP8, HPDPH)
      DATA UNITS /'RATIO   '/
C-----------------------------------------------------------------------
C                                       work out output image
C                                       dimensions
      BLC(1) = IROUND (RPARM(16))
      BLC(2) = IROUND (RPARM(17))
      TRC(1) = IROUND (RPARM(23))
      TRC(2) = IROUND (RPARM(24))
C                                       fill in window defaults
      IF (BLC(1).EQ.0) BLC(1) = 1
      IF (BLC(2).EQ.0) BLC(2) = 1
      IF (TRC(1).EQ.0) TRC(1) = HRGA2(KINAX)
      IF (TRC(2).EQ.0) TRC(2) = HRGA2(KINAX+1)
C                                       copy header
      DO 100 I = 1, 128
         HPDP8(I) = HRGA8(I)
 100     CONTINUE
      NCOLS = TRC(1) - BLC(1) + 1
      NROWS = TRC(2) - BLC(2) + 1
C                                        fill new header values
      CALL CHR2H (8, UNITS, 1, HPDPH(KHBUN))
      HPDP4(KRCRP) = HPDP4(KRCRP) - BLC(1) + 1
      HPDP4(KRCRP+1) = HPDP4(KRCRP+1) - BLC(2) + 1
      HPDP4(KRBLK) = 0.0
      HPDP2(KIDIM) = 2
      HPDP2(KINAX) = NCOLS
      HPDP2(KINAX+1) = NROWS
      HPDP2(KINAX+2) = 1
C
      RETURN
      END
      SUBROUTINE OUTPUT (RPARM, LUNRGA, LUNRGB, LUNPDP, OPENB, RGASLO,
     *   PDPSLO, FR1, FR2, GRFACA, GRFACB, IERR)
C-----------------------------------------------------------------------
C     Compute the predicted beam depolarization from the RM gradient
C   images(s) and frequencies and write the output image.
C     Input:
C         RPARM    R       AIPS parameters
C         LUNRGA   I       LUN for first RM gradient image
C         LUNRGB   I       LUN for second (optional) RM gradient image
C         LUNPDP   I       LUN for predicted DPR image
C         OPENB    L      .true. if second gradient image opened
C     Output:
C         RGASLO   I       Catalog slot of first gradient image
C         PDPSLO   I       Catalog slot of output image
C         FR1      R       Lower frequency (Hz)
C         FR2      R       Higher frequency (Hz)
C         GRFACA   R       Multiplicative factor for first gradient
C                          image
C         GRFACB   R       Multiplicative factor for second gradient
C                          image
C         IERR     I       0 => all OK
C
C-----------------------------------------------------------------------
      REAL   RPARM(*), FR1, FR2, GRFACA, GRFACB, DMIN, DMAX, NBLANK,
     *   RGADAT(2048), RGBDAT(2048), PDPDAT(2048), DPFACS(5)
      INTEGER   NCOLS, NROWS, LUNRGA, LUNRGB, LUNPDP, IERR, J,
     *   PDPSLO, RGASLO
      LOGICAL   OPENB
      INTEGER   IFIL, OFIL
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA NBLANK, DMIN, DMAX / 0.0, +1.0E30, -1.0E30/
C-----------------------------------------------------------------------
C                                       extract pars from inputs and
C                                       header
      CALL EXTPAR (RPARM, OPENB, FR1, FR2, GRFACA, GRFACB, NCOLS,
     *    NROWS, DPFACS, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       find input file
      DO 10 IFIL = 1,EFIL
         IF (FILTAB(1,IFIL).EQ.LUNRGA) GO TO 15
 10      CONTINUE
      GO TO 90
C                                       find output file
 15   DO 20 OFIL = 1,EFIL
         IF (FILTAB(1,OFIL).EQ.LUNPDP) GO TO 30
 20      CONTINUE
      GO TO 90
C                                       copy most keywords
 30   CALL KEYPCP (FILTAB(POVOL,IFIL), FILTAB(POCAT,IFIL),
     *   FILTAB(POVOL,OFIL), FILTAB(POCAT,OFIL), 0, ' ', IERR)
C                                        loop over image
 90   DO 100 J = 1, NROWS
C                                        read in line(s) of data
         CALL READIN (OPENB, LUNRGA, LUNRGB, RGADAT, RGBDAT, IERR)
         IF (IERR.NE.0) THEN
           WRITE (MSGTXT,1000) J, IERR
           GO TO 900
           END IF
C                                         calculate current output DPR
C                                       line
        CALL LOOPIN (OPENB, NCOLS, RGADAT, RGBDAT, GRFACA, GRFACB,
     *     DPFACS, PDPDAT, DMIN, DMAX, NBLANK)
C                                         write line to output image
        CALL MAPIO ('WRIT', LUNPDP, PDPDAT, IERR)
        IF (IERR.NE.0) THEN
           WRITE (MSGTXT,2000) J, IERR
           GO TO 900
           END IF
 100     CONTINUE
C                                       update header min and max and
C                                       get slots
      CALL CATUP (LUNRGA, LUNPDP, NBLANK, DMIN, DMAX, RGASLO, PDPSLO,
     *   IERR)
      GO TO 990
 900  CALL MSGWRT (8)
C
 990  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OUTPUT: I/O ERROR READING GRADIENT IMAGE(S) AT LINE ',
     *   I4, ' IERR=', I3)
 2000 FORMAT ('OUTPUT: I/O ERROR WRITING DPR IMAGE AT LINE = ', I4,
     *   ' IERR=', I3)
      END
      SUBROUTINE EXTPAR (RPARM, OPENB, FR1, FR2, GRFACA, GRFACB, NCOLS,
     *   NROWS, DPFACS, IERR)
C-----------------------------------------------------------------------
C   Extract parameters from the AIPS inputs, from the header and then
C   calculate some factors for the depolarization calculation
C     Input:
C        RPARM    R      AIPS input parameters
C        OPENB    L      .true. if second gradient image opened
C     Output:
C        FR1      R      Lower frequency, Hz
C        FR2      R      Higher frequency, Hz
C        GRFACA   R      Factor by which first gradient image pixels are
C                        to be multiplied by.
C        GRFACB   R      Factor by which second gradient image pixels
C                        are to be multiplied by.
C        NCOLS    I      Number of columns in output image
C        NROWS    I      Number of rows in output image
C        DPFACS   R      5 element array of factors for depolarization
C        IERR     I      0 => OK
C-----------------------------------------------------------------------
      REAL   RPARM(*), FR1, FR2, GRFACA, GRFACB, DPFACS(*), BMAJ, BMIN,
     *   BPA
      INTEGER   NCOLS, NROWS, IERR
      LOGICAL   OPENB
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                        extract inputs parameters
      CALL EXTINP (RPARM, OPENB, FR1, FR2, GRFACA, GRFACB, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000)
         GO TO 900
         END IF
C                                        extract some parameters from
C                                       header
      CALL EXTHED (NCOLS, NROWS, BMAJ, BMIN, BPA, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,2000)
         GO TO 900
         END IF
C                                       work out factors for beam
C                                       depolarization
      CALL DPFAC (FR1, FR2, BMAJ, BMIN, BPA, OPENB, DPFACS)
      GO TO 990
 900  CALL MSGWRT (8)
C
 990  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('EXTPAR: ERROR EXTRACTING PARAMETERS FROM AIPS INPUTS')
 2000 FORMAT ('EXTPAR: ERROR EXTRACTING PARAMETERS FROM HEADER')
      END
      SUBROUTINE EXTINP (RPARM, OPENB, FR1, FR2, GRFACA, GRFACB, IERR)
C-----------------------------------------------------------------------
C     Extract the frequencies and gradient scale factors out of the AIPS
C     input parameters
C     Inputs:
C        RPARM    R      AIPS input parameters
C        OPENB    L      .true. if second gradient inage opened
C     Outputs:
C        FR1      R      Lower frequency, Hz
C        FR2      R      Higher frequency, Hz
C        GRFACA   R      Factor by which first gradient image pixels are
C                        to be multiplied by.   This defaults to the
C                        factor
C                        1 / (8 * sqrt(2)) which is appropriate to a
C                        gradient image produced by NINER with the
C                        operator 'SOBL' when there is no second
C                        gradient image,  else 1.0
C        GRFACB   R      Factor by which second gradient image pixels
C                        are to be multiplied by.   Defaults to 1.0
C        IERR     I      0 => OK
C AIPS Inputs:
C
C 37-46     CPARM(10)            Frequencies between which to compute
C                                depolarization in CPARM(1:2)
C                                Multiplicative factors for gradient
C                                images in CPARM(3) and CPARM(4)
C-----------------------------------------------------------------------
      REAL   RPARM(*), FR1, FR2, GRFACA, GRFACB, T1, T2
      INTEGER   IERR
      LOGICAL   OPENB
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                              frequencies
      T1 = RPARM(37)
      T2 = RPARM(38)
      IF (T1.GT.0.0 .AND. T2.GT.0.0) THEN
         FR1 = MIN (T1, T2)
         FR2 = MAX (T1, T2)
         IERR = 0
      ELSE
         WRITE (MSGTXT,1000)
         CALL MSGWRT (8)
         IERR = 1
         GO TO 900
         END IF
C                                              gradient scale factors
      IF (.NOT.OPENB) THEN
         IF (RPARM(39).NE.0.0) THEN
           GRFACA = RPARM(39)
           WRITE (MSGTXT,2000) GRFACA
         ELSE
           GRFACA = 1.0 / (8.0 * SQRT(2.0))
           WRITE (MSGTXT,2000) GRFACA
           CALL MSGWRT (8)
           WRITE (MSGTXT,3000)
           END IF
         CALL MSGWRT (8)
      ELSE
         IF (RPARM(39).NE.0.0) THEN
           GRFACA = RPARM(39)
           WRITE (MSGTXT,2000) GRFACA
         ELSE
            GRFACA = 1.0
            WRITE (MSGTXT,2000) GRFACA
            END IF
         CALL MSGWRT (8)
C
         IF (RPARM(40).NE.0.0) THEN
            GRFACB = RPARM(40)
         ELSE
            GRFACB = 1.0
            END IF
         WRITE (MSGTXT,4000) GRFACB
         CALL MSGWRT (8)
         END IF
C
 900  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('EXTINP: FREQUENCIES MUST BE > 0')
 2000 FORMAT ('EXTINP:  First gradient image factor = ', 1PE12.5)
 3000 FORMAT ('EXTINP:  This is appropriate to a niner ''SOBL'' image')
 4000 FORMAT ('EXTINP: Second gradient image factor = ', 1PE12.5)
      END
      SUBROUTINE EXTHED (NCOLS, NROWS, BMAJ, BMIN, BPA, IERR)
C-----------------------------------------------------------------------
C     Extract some header values from depolarization ratio image
C     Outputs:
C        NCOLS     I       number of columns
C        NROWS     I       number of rows
C        BMAJ      R       beam major axis in pixels
C        BMIN      R       beam minor axis in pixels
C        BPA       R       beam position angle (degrees)
C        IERR      I       0 => OK, else no beam
C-----------------------------------------------------------------------
      DOUBLE PRECISION DUM1(128), DUM2(128), HPDP8(128)
      REAL   BMAJ, BMIN, BPA, HPDP4(256), XINC, YINC
      INTEGER   HPDP2(256), NCOLS, NROWS, IERR
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMMON /HEADS/ DUM1, DUM2, HPDP8
      EQUIVALENCE (HPDP2, HPDP4, HPDP8)
C-----------------------------------------------------------------------
C                                       dimensions and increments
      NCOLS = HPDP2(KINAX)
      NROWS = HPDP2(KINAX+1)
      XINC = HPDP4(KRCIC)
      YINC = HPDP4(KRCIC+1)
C                                       extract beam in pixels
      BMAJ = HPDP4(KRBMJ)
      BMIN = HPDP4(KRBMN)
      BPA  = HPDP4(KRBPA)
C
      IF (BMAJ.GT.0.0 .AND. BMIN.GT.0.0) THEN
         BMAJ = BMAJ / XINC
         BMIN = BMIN / YINC
         IERR = 0
      ELSE
         WRITE (MSGTXT,1000)
         CALL MSGWRT (8)
         IERR = 1
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('EXTHED: NO BEAM IN HEADER, WE ARE GOING TO STOP')
      END
      SUBROUTINE DPFAC (FR1, FR2, BMAJ, BMIN, BPA, OPENB, FAC)
C-----------------------------------------------------------------------
C     Compute factors for the beam depolarization calculation.
C      Inputs:
C         FR1      R      Lower frequency Hz
C         FR2      R      Higher frequency Hz
C         BMAJ     R      Beam major axis in pixels
C         BMIN     R      Beam minor axis in pixels
C         BPA      R      Beam position angle (degrees), positive N-E
C         OPENB    L      .true. if second gradient image opened
C      Outputs:
C         FAC(1:4) R      used if two input images
C         FAC(5)   R      used if one input image
C-----------------------------------------------------------------------
      REAL   FAC(*), ALPHA, BETA, GAMMA, FR1, FR2, BMAJ, BMIN, BPA,
     *   LAM1, LAM2, LIGHT, LAMFAC, THETA, R180, A, B, ASQ, BSQ,
     *   BMAJSQ, BMINSQ, BMMSQ, LOGFAC, GAMMSQ, RATFAC
      LOGICAL   OPENB
      DATA LIGHT, R180 /3.0E8, 180.0/
C-----------------------------------------------------------------------
C                                        work out wavelengths in metres
      LAM1 = LIGHT / FR1
      LAM2 = LIGHT / FR2
      LAMFAC = LAM1**4 - LAM2**4
C                                        theta = angle between + x-axis
C                                       and beam
C                                        major axis, positive
C                                       c-clockwise, 0-180
      BPA = MOD (BPA, R180)
      IF (BPA.LT.0.0) BPA = BPA + 180.0
      THETA = BPA + 90.0
      THETA = MOD (THETA, R180)
C                                        angle factors
      A = COS (THETA * 1.7453293E-2)
      ASQ = A * A
      B = SIN (THETA * 1.7453293E-2)
      BSQ = B * B
C                                        beam factors
      BMAJSQ = BMAJ * BMAJ
      BMINSQ = BMIN * BMIN
      BMMSQ = BMAJSQ * BMINSQ
      ALPHA = (ASQ*BMINSQ + BSQ*BMAJSQ) / BMMSQ
      BETA  = (ASQ*BMAJSQ + BSQ*BMINSQ) / BMMSQ
      GAMMA = A * B * (BMAJSQ - BMINSQ) / BMMSQ
      GAMMSQ = GAMMA * GAMMA
      LOGFAC = 4.0 * LOG (2.0)
C                                         depolarization factors
      IF (OPENB) THEN
         FAC(1) = -LAMFAC / (LOGFAC * ALPHA)
         FAC(2) = ALPHA
         FAC(3) = GAMMA
         FAC(4) = (ALPHA * BETA - GAMMSQ)
      ELSE
         RATFAC = (ALPHA + GAMMA)**2 / (ALPHA * BETA - GAMMSQ)
         FAC(5) = -LAMFAC * (1.0 + RATFAC) / (LOGFAC * ALPHA)
         END IF
C
 999  RETURN
      END
      SUBROUTINE READIN (OPENB, LUNRGA, LUNRGB, RGADAT, RGBDAT, IERR)
C-----------------------------------------------------------------------
C     Read in a line from the input image(s)
C     Inputs:
C       OPENB     L        .true. if secons RM gradient image open
C       LUNRGA    I        LUN for first input image
C       LUNRGB    I        LUN for second input image
C     Outputs:
C       RGADAT    R        Array containing first image data
C       RGBDAT    R        Array containing second image data
C       IERR      I        0 => OK, else i/o error
C-----------------------------------------------------------------------
      REAL   RGADAT(*), RGBDAT(*)
      INTEGER   LUNRGA, LUNRGB, IERR
      LOGICAL   OPENB
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       read line from first
C                                       input image
      CALL MAPIO ('READ', LUNRGA, RGADAT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000)
         GO TO 900
         END IF
C                                              read line from second
C                                       input image
      IF (OPENB) THEN
         CALL MAPIO ('READ', LUNRGB, RGBDAT, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,2000)
            GO TO 900
            END IF
         END IF
      GO TO 990
 900  CALL MSGWRT (8)
C
 990  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('READIN: ERROR READING FROM FIRST GRADIENT IMAGE')
 2000 FORMAT ('READIN: ERROR READING FROM SECOND GRADIENT IMAGE')
      END
      SUBROUTINE LOOPIN (OPENB, NCOLS, RGADAT, RGBDAT, GRFACA, GRFACB,
     *   DPFACS, PDPDAT, DMIN, DMAX, NBLANK)
C-----------------------------------------------------------------------
C     Do the inner loop over the columns on the current row and
C     calculate the beam depolarization
C     Inputs:
C       OPENB      L       .true. if second RM image open
C       NCOLS      I       number of columns in output image
C       RGADAT     R       first RM image line of data
C       RGBDAT     R       second RM image line of data
C       GRFACA     R       scale factor for first RM image
C       GRFACB     R       scale factor for second RM image
C       DPFACS     R       5 element array of factors for depolarization
C     Outputs:
C       PDPDAT     R       output line of data
C       DMIN       R       updated data minimum
C       DMAX       R       updated data maximum
C     Input/Outputs:
C       NBLANK     R       cumulative no. of blanks
C-----------------------------------------------------------------------
      REAL   RGADAT(*), RGBDAT(*), PDPDAT(*), DPFACS(*), GRFACA, GRFACB,
     *   DMIN, DMAX, NBLANK, INDEF
      INTEGER   NCOLS, I
      LOGICAL   OPENB
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      INDEF = FBLANK
C                                           only one input image
      IF (.NOT.OPENB) THEN
         DO 100, I = 1, NCOLS
            IF (RGADAT(I).NE.INDEF) THEN
               CALL DPMM (OPENB, GRFACA, GRFACB, DPFACS, RGADAT(I),
     *                    RGBDAT(I), PDPDAT(I), DMIN, DMAX)
            ELSE
               PDPDAT(I) = INDEF
               NBLANK = NBLANK + 1.0
               END IF
 100        CONTINUE
      ELSE
C                                           two input images
         DO 200, I = 1, NCOLS
            IF (RGADAT(I).NE.INDEF .AND. RGBDAT(I).NE.INDEF) THEN
               CALL DPMM (OPENB, GRFACA, GRFACB, DPFACS, RGADAT(I),
     *                    RGBDAT(I), PDPDAT(I), DMIN, DMAX)
            ELSE
               PDPDAT(I) = INDEF
               NBLANK = NBLANK + 1.0
               END IF
 200        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE DPMM (OPENB, GRFACA, GRFACB, FACS, RGADAT, RGBDAT,
     *   PDPDAT, DMIN, DMAX)
C-----------------------------------------------------------------------
C     Find the predicted beam depolarization ratio and update the new
C   data minimum and maximum.
C
C     Inputs:
C       OPENB      L        .true. if second RM image open
C       GRFACA     R        Multiplicative factor for first RM gradient
C                           image
C       GRFACB     R        Multiplicative factor for second RM
C                           gradient image
C       FACS(1:4)  R        Factors used if second gradient image open
C       FACS(5)    R        Factor used if only first gradient image
C                           open
C       RGADAT     R        First gradient image pixel value
C       RGBDAT     R        Second gradient image pixel value
C     Outputs:
C       PDPDAT     R        Predicted beam depolarization ratio
C       DMIN       R        Updated data minimum
C       DMAX       R        Updated data maximum
C-----------------------------------------------------------------------
      REAL   GRFACA, GRFACB, FACS(*), RGADAT, RGBDAT, PDPDAT, DMIN,
     *   DMAX, WORK1, WORK2
      LOGICAL   OPENB
C-----------------------------------------------------------------------
C                                       compute DPR for 1 and 2 input
C                                       images
      IF (.NOT.OPENB) THEN
        PDPDAT = EXP ( (GRFACA * RGADAT)**2 * FACS(5) )
      ELSE
        WORK1 = FACS(2) * GRFACB * RGBDAT / (GRFACA * RGADAT)
        WORK2 = 1.0 + ( (WORK1 + FACS(3))**2 / FACS(4) )
        PDPDAT = EXP ( FACS(1) * (GRFACA * RGADAT)**2 * WORK2)
        END IF
C                                        update data min and max
      DMAX = MAX (DMAX, PDPDAT)
      DMIN = MIN (DMIN, PDPDAT)
C
 999  RETURN
      END
      SUBROUTINE CATUP (LUNRGA, LUNPDP, NBLANK, DMIN, DMAX, RGASLO,
     *   PDPSLO, IERR)
C-----------------------------------------------------------------------
C     Update catalog block and get cat slots.
C     Inputs:
C       LUNRGA   I       Logical unit number of input image
C       LUNPDP   I       Logical unit number of output image
C       NBLANK   R       Number of output pixels that are blanked
C       DMIN     R       Data minimum of output image
C       DMAX     R       Data maximum of output image
C    Outputs:
C       RGASLO   I       Cat slot of input image
C       PDPSLO   I       Cat slot of output image
C       IERR     I       Error status, 0 => OK
C-----------------------------------------------------------------------
      DOUBLE PRECISION HRGA8(128), HPDP8(128), DUM(128)
      REAL   HPDP4(256), DMIN, DMAX, NBLANK
      INTEGER   IERR, HPDP2(256), I, LUNPDP, PDPSLO, PDPVOL, IBUFF(256),
     *   RGASLO, LUNRGA
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DITB.INC'
      COMMON /HEADS/ HRGA8, DUM, HPDP8
      EQUIVALENCE (HPDP2, HPDP4, HPDP8)
C-----------------------------------------------------------------------
C                                          find cat slot of input image
      IERR = 0
      DO 100 I = 1,EFIL
         IF (FILTAB(POLUN, I).EQ.LUNRGA) THEN
            RGASLO = FILTAB(POCAT, I)
            GO TO 200
         ELSE IF (I.EQ.EFIL) THEN
            WRITE (MSGTXT,1000)
            CALL MSGWRT (8)
            IERR = 1
            GO TO 990
            END IF
 100     CONTINUE
C                                           find cat slot of output
C                                       image
 200  DO 300 I = 1,EFIL
         IF (FILTAB(POLUN, I).EQ.LUNPDP) THEN
            PDPSLO = FILTAB(POCAT, I)
            PDPVOL = FILTAB(POVOL, I)
            GO TO 400
         ELSE IF (I.EQ.EFIL) THEN
            WRITE (MSGTXT,2000)
            CALL MSGWRT (8)
            IERR = 1
            GO TO 990
            END IF
 300     CONTINUE
C                                               update disk header file
 400  HPDP4(KRDMN) = DMIN
      HPDP4(KRDMX) = DMAX
      IF (NBLANK.GT.0.0) HPDP4(KRBLK) = INDEF
      CALL CATIO ('UPDT', PDPVOL, PDPSLO, HPDP2, 'REST', IBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,3000) IERR
         CALL MSGWRT (8)
         END IF
C
 990  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CATUP: ERROR FINDING CAT SLOT OF FIRST INPUT IMAGE')
 2000 FORMAT ('CATUP: ERROR FINDING CAT SLOT OF OUTPUT IMAGE')
 3000 FORMAT ('CATUP: ERROR UPDATING CATALOGUE BLOCK, IERR=', I3)
      END
      SUBROUTINE CLOSUP (OPENB, LUNRGA, LUNRGB, LUNPDP)
C-----------------------------------------------------------------------
C     Close all open files
C     Inputs:
C       OPENB     L        .true. if second gradient image open
C       LUNRGA    I        LUN for first RM gradient image
C       LUNRGB    I        LUN for second RM gradient image
C       LUNPDP    I        LUN for predicted DPR image
C-----------------------------------------------------------------------
      INTEGER   LUNRGA, LUNRGB, LUNPDP
      LOGICAL   OPENB
C-----------------------------------------------------------------------
      CALL FILCLS (LUNRGA)
      IF (OPENB) CALL FILCLS (LUNRGB)
      CALL FILCLS (LUNPDP)
C
 999  RETURN
      END
      SUBROUTINE DEPOHI (OPENB, RGANAM, RGBNAM, PDPNAM, RGASLO,
     *   PDPSLO, BLC, TRC, FR1, FR2, GRFACA, GRFACB)
C-----------------------------------------------------------------------
C     Write the history file.  Only the history file from the first RM
C     gradient image is copied, as the other should be almost identical.
C    Inputs:
C        OPENB          L     .true. if second gradient inage open
C        RGANAM         C*36  RM gradient image namestring
C        RGBNAM         C*36  RM gradient image namestring
C        PDPNAM         C*36  Predicted DPR image namestring
C        RGASLO         I     Slot number for input image
C        PDPSLO         I     Slot number for output image
C        BLC,TRC        I     Input image window
C        FR1,FR2        R     Frequencies for DPR
C        GRFACA         R     Multiplicative factor for first gradient
C                             image
C        GRFACB         R     Multiplicative factor for second gradient
C                             image
C-----------------------------------------------------------------------
      CHARACTER   PRGNAM*6, RGANAM*36, RGBNAM*36, PDPNAM*36, HILINE*72,
     *   RANAME*12, RACLAS*6, RATYPE*2, RBNAME*12, RBCLAS*6, RBTYPE*2,
     *   DPNAME*12, DPCLAS*6, DPTYPE*2
      REAL   FR1, FR2, GRFACA, GRFACB
      INTEGER   RGASLO, PDPSLO, RGAVOL, RGBVOL, PDPVOL, IBUFF1(256),
     *   IBUFF2(256), RGASEQ, RGBSEQ, PDPSEQ, HPDP2(256), USID,
     *   IERR, NHISTF, LUNDPH, LUNRMH, BLC(*), TRC(*)
      LOGICAL   OPENB
      LOGICAL   T
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      COMMON /MAPHDR/ HPDP2
      DATA PRGNAM, LUNDPH, LUNRMH /'BDEPO ', 27, 28/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       init HI
      NHISTF = 2
      CALL HIINIT (NHISTF)
C                                       work out some disks and
C                                       sequence nos.
      CALL WAWA2A (RGANAM, RANAME, RACLAS, RGASEQ, RATYPE, RGAVOL, USID)
      CALL WAWA2A (RGBNAM, RBNAME, RBCLAS, RGBSEQ, RBTYPE, RGBVOL, USID)
      CALL WAWA2A (PDPNAM, DPNAME, DPCLAS, PDPSEQ, DPTYPE, PDPVOL, USID)
C                                        get cat block of output image
      CALL CATIO ('READ', PDPVOL, PDPSLO, HPDP2, 'REST', IBUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 900
         END IF
C                                        copy old history file to new
      CALL HISCOP (LUNRMH, LUNDPH, RGAVOL, PDPVOL, RGASLO, PDPSLO,
     *   HPDP2, IBUFF1, IBUFF2, IERR)
      IF (IERR.GE.3) THEN
         WRITE (MSGTXT,2000) IERR
         GO TO 900
      END IF
C                                       add first RM gradient image
C                                       name
      CALL HENCO1 (PRGNAM, RANAME, RACLAS, RGASEQ, RGAVOL,
     *   LUNDPH, IBUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,3000) IERR
         GO TO 900
         END IF
C                                       add second RM gradient image
C                                       name
      IF (OPENB) THEN
         CALL HENCO1 (PRGNAM, RBNAME, RBCLAS, RGBSEQ, RGBVOL,
     *      LUNDPH, IBUFF2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,3500) IERR
            GO TO 900
            END IF
         END IF
C                                        add predicted DPR image name
      CALL HENCOO (PRGNAM, DPNAME, DPCLAS, PDPSEQ, PDPVOL,
     *   LUNDPH, IBUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,4000) IERR
         GO TO 900
         END IF
C                                        add input window
      WRITE (HILINE,5000) PRGNAM, BLC(1), BLC(2), TRC(1), TRC(2)
      CALL HIADD (LUNDPH, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,6000) IERR
         GO TO 900
         END IF
C                                        add frequencies
      WRITE (HILINE,7000) PRGNAM, FR1, FR2
      CALL HIADD (LUNDPH, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,8000) IERR
         GO TO 900
         END IF
C                                        add gradient factors
      WRITE (HILINE,9000) PRGNAM, GRFACA
      CALL HIADD (LUNDPH, HILINE, IBUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,9500) IERR
         GO TO 900
         END IF
C
      IF (OPENB) THEN
         WRITE (HILINE,9600) PRGNAM, GRFACB
         CALL HIADD (LUNDPH, HILINE, IBUFF2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,9700) IERR
            GO TO 900
            END IF
         END IF
C                                        close history
      CALL HICLOS (LUNDPH, T, IBUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,9800) IERR
         GO TO 900
         END IF
      GO TO 990
 900  CALL MSGWRT (8)
C
 990  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DEPOHI: COULD NOT GET CATALOG BLOCK, IERR=', I3)
 2000 FORMAT ('DEPOHI: SERIOUS ERROR COPYING OLD HISTORY, IERR=', I3)
 3000 FORMAT ('DEPOHI: COULD NOT ADD FIRST RM GRADIENT IMAGE, IERR=',
     *        I3)
 3500 FORMAT ('DEPOHI: COULD NOT ADD SECOND RM GRADIENT IMAGE, IERR=',
     *        I3)
 4000 FORMAT ('DEPOHI: COULD NOT ADD PREDICTED DPR IMAGE, IERR=', I3)
 5000 FORMAT (A6, 'BLC = ', I4, ',', I4, '   TRC = ', I4, ',', I4)
 6000 FORMAT ('DEPOHI: COULD NOT ADD INPUT WINDOW, IERR=', I3)
 7000 FORMAT (A6, 'FREQ1 = ', 1PE12.5, '   FREQ2 = ', 1PE12.5)
 8000 FORMAT ('DEPOHI: COULD NOT ADD FREQUENCIES, IERR=', I3)
 9000 FORMAT (A6, '/ First rm gradient factor = ', 1PE12.5)
 9500 FORMAT ('DEPOHI: COULD NOT ADD FIRST GRADIENT FACTOR, IERR=',I3)
 9600 FORMAT (A6, '/ Second rm gradient factor = ', 1PE12.5)
 9700 FORMAT ('DEPOHI: COULD NOT ADD SECOND GRADIENT FACTOR, IERR=',
     *         I3)
 9800 FORMAT ('DEPOHI: COULD NOT CLOSE HISTORY FILE, IERR=', I3)
      END

      SUBROUTINE QMAXV (A, I, C, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Find max. value element of a vector.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Find maximum value of a vector and address of the maximum.
C    Inputs:
C     A  I    Source vector base address
C     I  I    A address increment
C     C  I    Destination  base address
C             C(0) = Max (A(mI))  m = 0 to N-1
C             C(1) = address. also in SPAD 15.
C     N  I    Element count
C   CRI version.
C-----------------------------------------------------------------------
      INTEGER   A, I, C, N, JA, JC, II
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Addresses 1-rel
      JA = A + 1
      JC = C + 1
C                                       Find maximum.
      II = ISMAX (N, APCORE(JA), I)
C                                       Save result
      SPAD(15) = II-1
      APCORE(JC) = APCORE (JA+II-1)
      APCORI(JC+1) = II-1
C
 999  RETURN
      END

      SUBROUTINE NAMEST (NAME, SEQ, STRING, NCHAR)
C-----------------------------------------------------------------------
C! packs image name in string with leading and trailing blanks removed
C# Header Utility Character
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   NAMEST packs the image name as name.class.seq with leading and
C   trailing blanks removed.
C   Inputs:
C      NAME    C*18     Name & class need 18 chars
C      SEQ     I        Image sequence number
C   Output:
C      STRING  C(*)     Output string
C      NCHAR   I        Total # chars in STRING
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), STRING*(*)
      INTEGER   SEQ, NCHAR
C
      INTEGER   OUP, INC, J1, J2, JM
      CHARACTER SUBSTR*12
C-----------------------------------------------------------------------
      OUP = 1
      JM = LEN (STRING)
      J1 = LEN (NAME)
C                                       Name
      J2 = MIN (J1, 12)
      SUBSTR = NAME(1:J2)
      CALL CHTRIM (SUBSTR, J2, SUBSTR, INC)
      STRING = SUBSTR(1:INC)
      OUP = OUP + INC
      IF (OUP.GT.JM) GO TO 999
      STRING(OUP:OUP) = '.'
      OUP = OUP + 1
      IF (OUP.GT.JM) GO TO 999
C                                       Class
      J2 = J2 + 1
      J1 = MIN (J1, 18)
      IF (J1.GT.J2) THEN
         SUBSTR = NAME(J2:J1)
         J2 = J1 - J2 + 1
         CALL CHTRIM (SUBSTR, J2, SUBSTR, INC)
         STRING(OUP:) = SUBSTR(1:INC)
         OUP = OUP + INC
         IF (OUP.GT.JM) GO TO 999
         END IF
      STRING(OUP:OUP) = '.'
      OUP = OUP + 1
      IF (OUP.GT.JM) GO TO 999
C                                       Sequence
      WRITE (SUBSTR,1000) SEQ
      CALL CHTRIM (SUBSTR, 6, SUBSTR, INC)
      NCHAR = MIN (OUP+INC-1, JM)
      STRING(OUP:) = SUBSTR(1:INC)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I6)
      END

LOCAL INCLUDE 'GREYS.INC'
      INCLUDE 'INCS:DCNT.INC'
      INCLUDE 'INCS:PTVC.INC'
      CHARACTER NAMIN(4)*12, CLSIN(4)*6, IGFILE*48, OFMFIL*48,
     *   INFILE*48, GPHFNS(3)*2, PREFIX*5, UNITS*8, SOURCE*8
      HOLLERITH XNAMIN(3), XCLSIN(2), XNAMI2(3), XCLSI2(2), XNAMI3(3),
     *   XCLSI3(2), XNAMI4(3), XCLSI4(2), XFUN(1), XOFMF(12), XINFIL(12)
      REAL      XDCONT, INCOLR, SEQIN, DSKIN, SEQIN2, DSKIN2, SEQIN3,
     *   DSKIN3, SEQIN4, DSKIN4, XBLC(7), XTRC(7), XYRATO, RANGE(2),
     *   APARM(10), TLABEL, DOGRID, PLEV, CLEV, LEVS(30), DOWDGE,
     *   DOPROF, DPARM(10), DOCIRC, XSTVER, STMULT, XHPBP, SLST, SLEND,
     *   XNBOX, BOX(4,50), XDOTV, XGRCH, XTVCH, DODARK, XDKLIN,
     *   XTVCRN(2)
      LOGICAL   DOCONT, CSAME, DOTV, DOOFM, DOCOLR, BMBLNK
      DOUBLE PRECISION    GFAC, GOFF
      REAL      MULT, WRANGE(2), ROFM(TVMLOU), GOFM(TVMLOU),
     *   BOFM(TVMLOU), BLC(7,4), TRC(7,4), RANGES(2,3), SUBMIN, SUBMAX,
     *   XXPROF(8192), YYPROF(8192), PXMULT
      INTEGER   IMLUN(4), IMFIND(4), IGLUN, IGFIND, IVOL(4), CNO(4),
     *   ILPVAL, IHPVAL, ILABEL, IVER, INPRMS, IXWDGE, IYWDGE, STVER,
     *   IPOINT, ISLST, ISLEND, NBOX, GRCHN, TVCHN, TVCORN(2), ISEQ(4),
     *   BMCORN, NOFM, IXPROF, IYPROF, NYPROF(8192)
      COMMON /INPARM/ XDCONT, INCOLR, XNAMIN, XCLSIN, SEQIN, DSKIN,
     *   XNAMI2, XCLSI2, SEQIN2, DSKIN2, XNAMI3, XCLSI3, SEQIN3, DSKIN3,
     *   XNAMI4, XCLSI4, SEQIN4, DSKIN4, XBLC, XTRC, XYRATO, RANGE,
     *   XFUN, APARM, TLABEL, DOGRID, PLEV, CLEV, LEVS, DOWDGE, DOPROF,
     *   DPARM, DOCIRC, XSTVER, STMULT, XHPBP, SLST, SLEND, XNBOX, BOX,
     *   XDOTV, XGRCH, XTVCH, DODARK, XDKLIN, XTVCRN, XOFMF, XINFIL
      COMMON /CHARPM/ NAMIN, CLSIN, IGFILE, OFMFIL, INFILE, GPHFNS,
     *   PREFIX, UNITS, SOURCE
      COMMON /GREYPR/ GFAC, GOFF, MULT, WRANGE, DOCONT, CSAME, IMLUN,
     *   IMFIND, IGLUN, IGFIND, IVOL, CNO, ILPVAL, IHPVAL, ILABEL,
     *   IVER, INPRMS, IXWDGE, IYWDGE, STVER, IPOINT, ISLST, ISLEND,
     *   NBOX, DOTV, GRCHN, TVCHN, TVCORN, DOOFM, DOCOLR, ROFM, GOFM,
     *   BOFM, BLC, TRC, RANGES, ISEQ, BMCORN, BMBLNK, NOFM, SUBMIN,
     *   SUBMAX, IXPROF, IYPROF, XXPROF, YYPROF, NYPROF, PXMULT
C                                       Header blocks etc
      INTEGER   PCATI(256,4)
      REAL      PCATR(256,4)
      HOLLERITH PCATH(256,4)
      DOUBLE PRECISION PCATD(128,4)
      REAL      RBLK(MABFSS,4)
      INTEGER   IBLK(MABFSS,4)
      COMMON /MAPHDR/ PCATI
      INCLUDE 'INCS:DCNT.INC'
      EQUIVALENCE (PCATI, PCATR, PCATH, PCATD)
      EQUIVALENCE (IBLK, RBLK, IBUFF)
LOCAL END
      PROGRAM GREYS
C-----------------------------------------------------------------------
C! Generates grey scale plotfile with optional superimposed contours
C# Graphics Map-util Plot-appl EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2002-2004, 2006-2008, 2011-2012,
C;  Copyright (C) 2014-2017, 2019, 2021-2022, 2024-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GREYS will write commands to a plot file for the execution
C   of a grey scale plot for the first cataloged image file.  The 2nd
C   catalog image, if specified, will be represented as contours
C   superimposed on the grey scale. Null file name implies no contours.
C   The program runs as a detached task initiated from AIPS. First a
C   cataloged file is found using data passed from AIPS.  The list of
C   associated files is searched for PLot files to find the highest
C   version number.  Then a PLot file is created for this map and the
C   catalog header is updated.  Next the graphics commands are
C   written to the plot file.
C   INPUTS:   (from AIPS)
C      XDCONT   R      >= 0 => want contours.  Must also specify
C                      IN2NAME, IN2CLASS, IN2SEQ, and/or IN2DISK
C      USERID   R      user number, 0 means use logon user number,
C                      32000 means any user can be accessed.
C      INNAME   R(3)   name of grey scale image.
C      INCLASS  R(2)   class of grey scale image.
C      INSEQ    R      sequence number of grey scale image.
C      INDISK   R      disk volume number. 0 means try all.
C      IN2NAME  R(3)   name of contour image.
C      IN2CLASS R(2)   class of contour image.
C      IN2SEQ   R      sequence number of contour image.
C      IN2DISK  R      disk volume number. 0 means try all.
C      BLC      R(7)   the coordinate in the input file to become the
C                      left hand coordinate (1,1) of the contour plot.
C                      BLC(1) is the X coordinate and BLC(2) is the Y
C                      coordinate.  The first coordinate in the input
C                      image is (1,1).
C      TRC      R(7)   the coordinate in the input file to become the
C                      top right hand corner of the plot.
C      XYRATIO  R      the ratio between the scale factor to use for the
C                      X axis and the scale factor to use for the Y axis
C      PIXRANGE R(2)   the maximum and minimum values allowed for the
C                      map.  All other values will be clipped.  If
C                      IRANGE(1) .GE. IRANGE(2) then the map max and
C                      min will be used.
C      LTYPE    R      the type of axis labeling to use for this plot
C                          1 = none
C                          2 = leave out ticks and tick labels
C                          3 = RA - DEC coordinates & labels
C                          4 = Center relative
C                          5 = Subimage center-relative
C                          6 = pixel count
C      DOALIGN  R      >= 0 => contour image must align w grey
C      PLEV     R      the percentage of the peak value to use as the
C                      multiplier for the contour levels.  If zero use
C                      CLEV below.
C      CLEV     R      The absolute value of the multiplier used for the
C                      contour levels.  This value is used only if PLEV
C                      is zero.
C      LEVS     R(30)  the contour levels.  An out of sequence level
C                      indicates 'end of levels'.  The real value of a
C                      particular level is the LEV value times CLEV or
C                      the value determined by PLEV.
C      DOWEDGE  R      0 < DOWEDGE <= 1 -> grey wedge along top
C                      1 < DOWEDGE -> grey wedge along right edge
C      DOCIRCLE R      > 0 Plot coord grid rather than just ticks
C      STVERS   R      ST file version number.
C      STFACTOR R      scale star sizes in file for plotting:
C                         0 => no plot of stars.
C      IN2VERS  R      Start SL file version number to begin plotting
C                      locations of slices
C      IN3VERS  R      End SL file version number
C      NBOXES   R      Number of BOX regions to mark on plot
C      BOX      R(4,50)  Pixel ranges of BOXes to be plotted (need not
C                      fit fully in the plot area).
C      DOTV     R      > 0 => TV, else plot file
C      TVCHAN   R      grey-scale channel to use (0 => 1)
C      GRCHAN   R      graphics channel to use
C      TVCORN   R(2)   TV pixel to use (both > 0 => pixel scale)
C-----------------------------------------------------------------------
      REAL      X, TEMP, Y, CH(4), VMUL, NBLC(2), NTRC(2), ATRC(2),
     *   ABLC(2), DUM(2), PBLC(2), PTRC(2), JTRC(2), QTRC(2), QBLC(2)
      INTEGER   IROUND, PLBUF(256), IANGLE, IBLCX, IBLCY, IERR, INPIXS,
     *   IPOS, IRETCD, IROW, ITRCX, ITRCY, ICOL, ISNCUT, INPIXT, I, ICL,
     *   IDEPTH(5), JPOS, KPOS, IC(3), J, BBLC(2), BTRC(2), BXOFF, NP,
     *   BXSIZ, JCOL, JLABEL
      LOGICAL   DOGR, T
      CHARACTER TXTMSG*80
      INCLUDE 'GREYS.INC'
      REAL      XLROW(MABFSS)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA IANGLE /0/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
      JBUFSZ = 2 * MABFSS
      INPRMS = 342
      ISNCUT = 0
      CALL GRYPRM (IRETCD, PLBUF)
      IF (IRETCD.NE.0) GO TO 999
C                                       Open files, set parms
      CALL GRYINI (CH, PLBUF, IRETCD)
      IF (IRETCD.NE.0) GO TO 995
      IRETCD = 8
C                                       Init grey scale for dB read
      IBLCX = IROUND (BLC(1,1))
      IBLCY = IROUND (BLC(2,1))
      ITRCX = IROUND (TRC(1,1))
      ITRCY = IROUND (TRC(2,1))
      INPIXS = ITRCX - IBLCX + 1
      INPIXT = INPIXS + IXWDGE
C                                       Write axis labeling commands.
      CALL GLAB (CH, NBLC, NTRC, ABLC, ATRC, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      IF (BMBLNK) THEN
         CALL PLTBSZ (BMCORN, BLC, TRC, PCATR, BBLC, BTRC)
      ELSE
         BBLC(1) = 0
         BBLC(2) = 0
         BTRC(1) = 0
         BTRC(2) = 0
         END IF
      TXTMSG = 'Start grey scale'
      CALL GCOMNT (2, TXTmsg, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
C                                       Start of grey scale
C                                       Top step wedge
      IF (IYWDGE.GT.0) THEN
         ICL = 1
         VMUL = (WRANGE(2) - WRANGE(1)) / (INPIXT - 1)
         DO 10 ICOL = 1,INPIXS
            XLROW(ICOL) = (ICOL - 1.) * VMUL + WRANGE(1)
 10         CONTINUE
         CALL GSCALE (GPHFUN, RANGE, INPIXS, 1, XLROW, ILROW)
         IF (INCOLR.GT.0.0) THEN
            CALL FILL (INPIXT, GPHTLO, IBBUFF)
            CALL FILL (INPIXT, GPHTLO, IBLROW)
         ELSE IF (DOOFM) THEN
            CALL G3SCAL (INPIXT, ILROW, NOFM, ROFM, GOFM, BOFM, ILROW,
     *         IBBUFF, IBLROW)
            END IF
         DO 15 IROW = 1,IYWDGE
            X = IBLCX
            Y = ITRCY + IROW
            CALL GPOS (X, Y, PLBUF, IERR)
            IF (IERR.NE.0) GO TO 950
            IF (INCOLR.GT.0.0) THEN
               IF (IROW.LE.IYWDGE/3) THEN
                  CALL G3COLR (INPIXT, IANGLE, ILROW, IBBUFF, IBLROW,
     *               PLBUF, IERR)
               ELSE IF (IROW.LE.(2*IYWDGE)/3) THEN
                  IF (ICL.NE.2) THEN
                     CALL GSCALE (GPHFNS(2), RANGES(1,2), INPIXS, 1,
     *                  XLROW, ILROW)
                     ICL = 2
                     END IF
                  CALL G3COLR (INPIXT, IANGLE, IBBUFF, ILROW, IBLROW,
     *               PLBUF, IERR)
               ELSE
                  IF (ICL.NE.3) THEN
                     CALL GSCALE (GPHFNS(3), RANGES(1,3), INPIXS, 1,
     *                  XLROW, ILROW)
                     ICL = 3
                     END IF
                  CALL G3COLR (INPIXT, IANGLE, IBBUFF, IBLROW, ILROW,
     *               PLBUF, IERR)
                  END IF
            ELSE IF (DOCOLR) THEN
               CALL G3COLR (INPIXT, IANGLE, ILROW, IBBUFF, IBLROW,
     *            PLBUF, IERR)
            ELSE
               CALL GRAYPX (INPIXT, IANGLE, ILROW, PLBUF, IERR)
               END IF
            IF (IERR.NE.0) GO TO 950
 15         CONTINUE
         END IF
C                                       init I/O
      BXOFF = BBLC(1) - IBLCX
      BXSIZ = BTRC(1) - BBLC(1) + 1
      CALL DBINIT (IMLUN(1), IMFIND(1), PCATI(1,1), BLC(1,1), TRC(1,1),
     *   JBUFSZ, RBLK(1,1), IERR)
      IF ((IERR.EQ.0) .AND. (INCOLR.GT.0.0)) THEN
         CALL DBINIT (IMLUN(3), IMFIND(3), PCATI(1,3), BLC(1,3),
     *      TRC(1,3), JBUFSZ, RBLK(1,3), IERR)
         IF (IERR.EQ.0) CALL DBINIT (IMLUN(4), IMFIND(4), PCATI(1,4),
     *      BLC(1,4), TRC(1,4), JBUFSZ, RBLK(1,4), IERR)
         END IF
      IF (IERR.NE.0) GO TO 950
C                                       Loop over all rows.
      DO 50 IROW = IBLCY,ITRCY
C                                       Read proper row.
         CALL MDISK ('READ', IMLUN(1), IMFIND(1), RBLK(1,1), IPOS, IERR)
         IF (IYPROF.GT.0) THEN
            DO 20 ICOL = 1,INPIXS
               JCOL = IPOS + ICOL - 1
               IF (RBLK(JCOL,1).NE.FBLANK) THEN
                  YYPROF(ICOL) = YYPROF(ICOL) + RBLK(JCOL,1)
                  NYPROF(ICOL) = NYPROF(ICOL) + 1
                  END IF
 20            CONTINUE
            END IF
         IF (IXPROF.GT.0) THEN
            NP = 0
            X = 0
            DO 30 ICOL = 1,INPIXS
               JCOL = IPOS + ICOL - 1
               IF (RBLK(JCOL,1).NE.FBLANK) THEN
                  X = X + RBLK(JCOL,1)
                  NP = NP + 1
                  END IF
 30            CONTINUE
            IF (NP.GT.0) XXPROF(IROW-IBLCY+1) = X / NP
            END IF
         IF ((IERR.EQ.0) .AND. (INCOLR.GT.0.0)) THEN
            CALL MDISK ('READ', IMLUN(3), IMFIND(3), RBLK(1,3), JPOS,
     *         IERR)
            IF (IERR.EQ.0) CALL MDISK ('READ', IMLUN(4), IMFIND(4),
     *         RBLK(1,4), KPOS, IERR)
            END IF
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1015) IERR
            CALL MSGWRT (7)
            GO TO 950
            END IF
         IF ((IROW.GE.BBLC(2)) .AND. (IROW.LE.BTRC(2))) THEN
            CALL RFILL (BXSIZ, FBLANK, RBLK(IPOS+BXOFF,1))
            IF (INCOLR.GT.0.0) THEN
               CALL RFILL (BXSIZ, FBLANK, RBLK(JPOS+BXOFF,3))
               CALL RFILL (BXSIZ, FBLANK, RBLK(KPOS+BXOFF,4))
               END IF
            END IF
C                                       Position.
         X = IBLCX
         Y = IROW
         CALL GPOS (X, Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GSCALE (GPHFNS(1), RANGES(1,1), INPIXS, 1, RBLK(IPOS,1),
     *      IBLK(IPOS,1))
         IF (INCOLR.GT.0.0) THEN
            CALL GSCALE (GPHFNS(2), RANGES(1,2), INPIXS, 1,
     *         RBLK(JPOS,3), IBLK(JPOS,3))
            CALL GSCALE (GPHFNS(3), RANGES(1,3), INPIXS, 1,
     *         RBLK(KPOS,4), IBLK(KPOS,4))
         ELSE IF (DOOFM) THEN
            JPOS = IPOS
            KPOS = IPOS
            CALL G3SCAL (INPIXS, IBLK(IPOS,1), NOFM, ROFM, GOFM, BOFM,
     *         IBLK(IPOS,1), IBLK(JPOS,3), IBLK(KPOS,4))
               END IF
         IF (DOCOLR) THEN
            CALL G3COLR (INPIXS, IANGLE, IBLK(IPOS,1), IBLK(JPOS,3),
     *         IBLK(KPOS,4), PLBUF, IERR)
         ELSE
            CALL GRAYPX (INPIXS, IANGLE, IBLK(IPOS,1), PLBUF, IERR)
            END IF
         IF (IERR.NE.0) GO TO 950
 50      CONTINUE
      IF (IYPROF.GT.0) THEN
         DO 55 ICOL = 1,INPIXS
            IF (NYPROF(ICOL).GT.1) YYPROF(ICOL) = YYPROF(ICOL) /
     *         NYPROF(ICOL)
 55         CONTINUE
         END IF
C                                       add wedge to right
      IF (IXWDGE.GT.0) THEN
         VMUL = (WRANGE(2) - WRANGE(1)) / (TRC(2,1) - BLC(2,1))
         J = IXWDGE / 3
         CALL FILL (IXWDGE, GPHTLO, IBUFF)
         CALL FILL (IXWDGE, GPHTLO, IBBUFF)
         CALL FILL (IXWDGE, GPHTLO, IBLROW)
         DO 60 IROW = IBLCY,ITRCY
            X = IBLCX + INPIXS
            Y = IROW
            CALL GPOS (X, Y, PLBUF, IERR)
            IF (IERR.NE.0) GO TO 950
            DUM(1) = (IROW - IBLCY) * VMUL + WRANGE(1)
            CALL GSCALE (GPHFNS(1), RANGE, 1, 1, DUM, IC(1))
            IF (DOOFM) CALL G3SCAL (1, IC(1), NOFM, ROFM, GOFM, BOFM,
     *         IC(1), IC(2), IC(3))
            IF (INCOLR.GT.0.0) THEN
               CALL GSCALE (GPHFNS(2), RANGES(1,2), 1, 1, DUM, IC(2))
               CALL GSCALE (GPHFNS(3), RANGES(1,3), 1, 1, DUM, IC(3))
               CALL FILL (J, IC(1), IBUFF(1))
               CALL FILL (J, IC(2), IBBUFF(1+J))
               CALL FILL (J, IC(3), IBLROW(1+J+J))
               CALL G3COLR (IXWDGE, IANGLE, IBUFF, IBBUFF, IBLROW,
     *            PLBUF, IERR)
            ELSE IF (DOCOLR) THEN
               CALL FILL (IXWDGE, IC(1), IBUFF)
               CALL FILL (IXWDGE, IC(2), IBBUFF)
               CALL FILL (IXWDGE, IC(3), IBLROW)
               CALL G3COLR (IXWDGE, IANGLE, IBUFF, IBBUFF, IBLROW,
     *            PLBUF, IERR)
            ELSE
               CALL FILL (IXWDGE, IC(1), IBUFF)
               CALL GRAYPX (IXWDGE, IANGLE, IBUFF, PLBUF, IERR)
               END IF
            IF (IERR.NE.0) GO TO 950
 60         CONTINUE
         END IF
C                                       Draw borders.
      TXTMSG = 'Start labeling'
      CALL GCOMNT (-1, TXTMSG, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GLTYPE (1, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GPOS (ABLC(1), ABLC(2), PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GVEC (ATRC(1), ABLC(2), PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GVEC (ATRC(1), ATRC(2), PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GVEC (ABLC(1), ATRC(2), PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GVEC (ABLC(1), ABLC(2), PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
C                                       Line off the wedge.
      IF (IXWDGE.NE.0) THEN
         CALL GPOS(ATRC(1), ABLC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         TEMP = ATRC(1) + IXWDGE
         CALL GVEC (TEMP, ABLC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GVEC (TEMP, ATRC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GVEC (ATRC(1), ATRC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
      IF (IYWDGE.NE.0) THEN
         TEMP = ATRC(2) + IYWDGE
         CALL GPOS (ABLC(1), ATRC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GVEC (ABLC(1), TEMP, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GVEC (ATRC(1), TEMP, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GVEC (ATRC(1), ATRC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
      IF (IXPROF.GT.0) THEN
         PTRC(1) = ATRC(1) + IXWDGE + IXPROF
         PBLC(1) = ATRC(1) + IXWDGE
         PBLC(2) = ABLC(2)
         PTRC(2) = ATRC(2)
         CALL GPOS (PBLC(1), PBLC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GVEC (PTRC(1), PBLC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GVEC (PTRC(1), PTRC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GVEC (PBLC(1), PTRC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
      IF (IYPROF.GT.0) THEN
         QBLC(1) = ABLC(1)
         QTRC(1) = ATRC(1)
         QTRC(2) = ATRC(2) + IYWDGE + IYPROF
         QBLC(2) = ATRC(2) + IYWDGE
         CALL GPOS (ABLC(1), QBLC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GVEC (ABLC(1), QTRC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GVEC (ATRC(1), QTRC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GVEC (ATRC(1), QBLC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
C                                       Axis labels, ticks
      DOGR = DOCIRC.GT.0.0
      CALL CLAB1 (ABLC, ATRC, CH, ILABEL, XYRATO, DOGR, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      JLABEL = ILABEL
      CALL RCOPY (2, NTRC, JTRC)
      IF (IXWDGE.GT.0) THEN
         IF (IXPROF.GT.0) THEN
            ILABEL = 2
            NTRC(1) = ATRC(1) + IXWDGE
         END IF
      ELSE IF (IYWDGE.GT.0) THEN
         IF (IYPROF.GT.0) THEN
            ILABEL = 2
            NTRC(2) = ATRC(2) + IYWDGE
            END IF
         NTRC(1) = ATRC(1)
         END IF
      CALL GTIC (ILABEL, BLC, TRC, NTRC, ATRC, WRANGE, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      ILABEL = JLABEL
      CALL RCOPY (2, JTRC, NTRC)
      IF (IXPROF.GT.0) THEN
         CALL PROFIT (1, PBLC, PTRC, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
      IF (IYPROF.GT.0) THEN
         CALL PROFIT (2, QBLC, QTRC, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         END IF
C                                       Draw stars
C                                       Much advantage from grey image
C                                       being the main plot image
      CALL FNDEXT ('ST', PCATI, I)
      IF ((STMULT.NE.0.0) .AND. (I.GT.0)) THEN
         DO 65 I = 1,5
            IDEPTH(I) = IROUND(BLC(I+2,1))
 65      CONTINUE
         CALL SETLOC (IDEPTH, T)
         CALL GLTYPE (4, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL STARPL (STMULT, IVOL, CNO, STVER, ABLC, ATRC, IMLUN,
     *      IMFIND, PCATI, BLC, 1, PLBUF, IERR)
         IF (IERR.GE.3) GO TO 950
         END IF
C                                       Draw slices
      IF (ISLST.GT.0 .AND. ISLEND.GT.0) THEN
         CALL GLTYPE (4, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL SLICPL (CNO(1), IVOL(1), ABLC, ATRC, ISLST, ISLEND, PLBUF,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1060)
            CALL MSGWRT (8)
            END IF
         END IF
C                                       Draw boxes
      IF (NBOX.GE.1) THEN
         CALL GLTYPE (4, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL BOXPL (ABLC, ATRC, NBOX, BOX, PLBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1061)
            CALL MSGWRT (8)
            END IF
         END IF
C                                       Draw boxes
      IF (INFILE.NE.' ') THEN
         CALL GLTYPE (4, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL LAYOUT (ABLC, ATRC, PCATR, INFILE, PLBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1061)
            CALL MSGWRT (8)
            END IF
         END IF
C                                       Do contours
      IF (DOCONT) THEN
         TXTMSG = 'Start contouring'
         CALL GCOMNT (2, TXTMSG, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GLTYPE (2, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
C                                        Init map for contours
         CALL DBINIT (IMLUN(2), IMFIND(2), PCATI(1,2), BLC(1,2),
     *      TRC(1,2), JBUFSZ, RBLK(1,1), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1063)
            CALL MSGWRT (8)
            GO TO 950
            END IF
         CALL DBINIT (IMLUN(1), IMFIND(1), PCATI(1,1), BLC(1,1),
     *      TRC(1,1), JBUFSZ, RBLK(1,2), IERR)
         IF (IERR.NE.0) GO TO 950
C                                       Draw contours.
         CALL CONDRW (IMLUN(2), IMFIND(2), IMLUN(1), IMFIND(1), MULT,
     *      BLC, TRC, LEVS, 0, BBLC, BTRC, DUM, PLBUF, IERR)
         IF (IERR.GT.9) GO TO 960
         IF (IERR.NE.0) GO TO 950
         END IF
C                                       beam
      IF (BMCORN.GT.0) THEN
         I = LOCNUM
         LOCNUM = 3
         TXTMSG = 'Start contouring beam'
         CALL GCOMNT (-1, TXTMSG, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GLTYPE (1, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL PLTBEM (BMCORN, BLC, TRC, PCATR, PLBUF, IERR)
         IF (IERR.GT.0) GO TO 960
         LOCNUM = I
         END IF
C                                       Finish up plot file
      CALL GFINIS (PLBUF, IERR)
C                                       Write sucessful finish message.
      IF (IERR.NE.0) GO TO 960
         IF (.NOT.DOTV) CALL HIPLOT (IVOL, CNO, IVER, PLBUF, IERR)
         IRETCD = 0
         WRITE (MSGTXT,1080) IVER
         CALL MSGWRT (2)
         GO TO 995
C-----------------------------------------------------------------------
C                                       Graph writing error.
 950  WRITE (MSGTXT,1950)
      CALL MSGWRT (8)
C                                       Try to do finish.
      CALL GFINIS (PLBUF, IERR)
      IF (IERR.NE.0) GO TO 960
         IF (.NOT.DOTV) CALL HIPLOT (IVOL, CNO, IVER, PLBUF, IERR)
         IRETCD = 0
         GO TO 995
C                                       Finish not sucessful. Destroy.
 960  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (IGLUN, IGFIND, IERR)
         CALL ZDESTR (IVOL, IGFILE, IERR)
         IF (IVER.GT.0) CALL DELEXT ('PL', IVOL(1), CNO(1), 'READ',
     *      PCATI(1,1), PLBUF, IVER, IERR)
         END IF
C                                       Close map file.
 995  CALL DIE (IRETCD, PLBUF)
C
 999  STOP
C-----------------------------------------------------------------------
 1015 FORMAT ('MREAD ERROR =',I5)
 1060 FORMAT ('ERROR OVERLAYING SLICES')
 1061 FORMAT ('ERROR OVERLAYING BOXES')
 1063 FORMAT ('ERROR INITING MAP FOR CONTOURING')
 1080 FORMAT ('Successful plot file version',I5,'  created.')
 1950 FORMAT ('Error during graphing will try to finish partial graph')
      END
      SUBROUTINE PROFIT (ITYP, PBLC, PTRC, PLBUF, IERR)
C-----------------------------------------------------------------------
C   Plots the profiles
C   Inputs
C      ITYP    I      1. Right hand side; 2 top
C      PBLC    R(2)   BLC of profile
C      PTRC    R(2)   TRC of profile
C   In/out
C      PLBUF   I(*)   Plot buffer
C   Output
C      IRET    I      Error code
C-----------------------------------------------------------------------
      REAL      PBLC(2), PTRC(2)
      INTEGER   ITYP, PLBUF(*), IERR
C
      INTEGER   I, NPTS, INX, IROUND, J, K, JTRIM
      REAL      X, Y, RX, RN, PN, PX, SCALE, DX, DY, DT, Y1, Y2, X1, X2
      CHARACTER STRING*8, COMNT*48, CHTMP*8
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'GREYS.INC'
C-----------------------------------------------------------------------
      RX = -1.E10
      RN = -RX
      IF (ITYP.EQ.1) THEN
         J = PTRC(2)
         K = PBLC(2) + 1
         NPTS = J - K + 1
         DO 10 I = 1,NPTS
            RN = MIN (RN, XXPROF(I))
            RX = MAX (RX, XXPROF(I))
 10         CONTINUE
         IF (DPARM(6).GT.DPARM(5)) THEN
            RN = DPARM(5)
            RX = DPARM(6)
            END IF
      ELSE
         J = PTRC(1)
         K = PBLC(1) + 1
         NPTS = J - K + 1
         DO 20 I = 1,NPTS
            RN = MIN (RN, YYPROF(I))
            RX = MAX (RX, YYPROF(I))
 20         CONTINUE
         IF (DPARM(4).GT.DPARM(3)) THEN
            RN = DPARM(3)
            RX = DPARM(4)
            END IF
         END IF
      X = (RX - RN) * 0.08
      PN = RN - X
      PX = RX + X
      RX = RX * PXMULT
      RN = RN * PXMULT
      IF (ITYP.EQ.1) THEN
         COMNT = 'Plotting profile vs Y summed in X'
         CALL GCOMNT (2, COMNT, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GLTYPE (4, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         SCALE = (PTRC(1) - PBLC(1)) / (PX - PN)
         DT = (PTRC(2) - PBLC(2)) * 0.025
         Y = PTRC(2)
         X = PBLC(1) + ((RN/PXMULT) - PN) * SCALE
         X1 = X
         CALL GPOS (X, PBLC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GVEC (X, PBLC(2)+DT, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GPOS (X, Y-DT, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GVEC (X, Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         IF (RX.GT.100.) THEN
            I = IROUND (RN)
            WRITE (STRING,1020) I
         ELSE IF (RX.GT.10.0) THEN
            WRITE (STRING,1021) RN
         ELSE
            WRITE (STRING,1022) RN
            END IF
         CALL REFRMT (STRING, ' ', INX)
         CALL GPOS (X, Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         DY = 0.5
         DX = 0.0
         CALL GCHAR (INX, 0, DX, DY, STRING, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GPOS (X, PBLC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         DY = -1.5
         DX = -INX/2.0
         CALL GCHAR (INX, 0, DX, DY, STRING, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         X = PBLC(1) + ((RX/PXMULT) - PN) * SCALE
         X2 = X
         CALL GPOS (X, PBLC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GVEC (X, PBLC(2)+DT, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GPOS (X, Y-DT, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GVEC (X, Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         IF (RX.GT.100.) THEN
            I = IROUND (RX)
            WRITE (STRING,1020) I
         ELSE IF (RX.GT.10.0) THEN
            WRITE (STRING,1021) RX
         ELSE
            WRITE (STRING,1022) RX
            END IF
         CALL REFRMT (STRING, ' ', INX)
         CALL GPOS (X, Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         DY = 0.5
         DX = -INX/2.0
         CALL GCHAR (INX, 0, DX, DY, STRING, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GPOS (X, PBLC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         DY = -1.5
         DX = -INX/2.0
         CALL GCHAR (INX, 0, DX, DY, STRING, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         DO 40 I = 1,NPTS
            Y = PBLC(2) + I
            X = PBLC(1) + (XXPROF(I) - PN) * SCALE
            X = MAX (MIN(X, X2), X1)
            IF (I.EQ.1) THEN
               CALL GPOS (X, Y, PLBUF, IERR)
            ELSE
               CALL GVEC (X, Y, PLBUF, IERR)
               END IF
            IF (IERR.NE.0) GO TO 990
 40         CONTINUE
         CALL GLTYPE (1, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
      ELSE
         COMNT = 'Plotting profile vs X summed in Y'
         CALL GCOMNT (2, COMNT, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GLTYPE (4, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         SCALE = (PTRC(2) - PBLC(2)) / (PX - PN)
         DT = (PTRC(1) - PBLC(1)) * 0.025
         X = PBLC(1)
         Y = PBLC(2) + ((RN/PXMULT) - PN) * SCALE
         Y1 = Y
         CALL GPOS (PTRC(1), Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GVEC (PTRC(1)-DT, Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GPOS (X+DT, Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GVEC (X, Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         IF (RX.GT.100.) THEN
            I = IROUND (RN)
            WRITE (STRING,1020) I
         ELSE IF (RX.GT.10.0) THEN
            WRITE (STRING,1021) RN
         ELSE
            WRITE (STRING,1022) RN
            END IF
         CALL REFRMT (STRING, ' ', INX)
         CALL GPOS (X, Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         DY = -0.5
         DX = -INX - 1
         CALL GCHAR (INX, 0, DX, DY, STRING, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GPOS (PTRC(1), Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         DY = -0.5
         DX = 1.0
         CALL GCHAR (INX, 0, DX, DY, STRING, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         Y = PBLC(2) + ((RX/PXMULT) - PN) * SCALE
         Y2 = Y
         CALL GPOS (PTRC(1), Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GVEC (PTRC(1)-DT, Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GPOS (X+DT, Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GVEC (X, Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         IF (RX.GT.100.) THEN
            I = IROUND (RX)
            WRITE (STRING,1020) I
         ELSE IF (RX.GT.10.0) THEN
            WRITE (STRING,1021) RX
         ELSE
            WRITE (STRING,1022) RX
            END IF
         CALL REFRMT (STRING, ' ', INX)
         CALL GPOS (X, Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         DY = -0.5
         DX = -INX - 1
         CALL GCHAR (INX, 0, DX, DY, STRING, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GPOS (PTRC(1), Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         DY = -0.5
         DX = 1.0
         CALL GCHAR (INX, 0, DX, DY, STRING, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GPOS (PTRC(1), Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         DY = -2.0
         INX = JTRIM (PREFIX)
         CALL GCHAR (INX, 0, DX, DY, PREFIX, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL GPOS (PTRC(1), Y, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL H2CHR (8, 1, PCATH(KHBUN,1), CHTMP)
         INX = JTRIM (CHTMP)
         DY = DY - 1.333
         CALL GCHAR (INX, 0, DX, DY, CHTMP, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         DO 50 I = 1,NPTS
            X = PBLC(1) + I
            Y = PBLC(2) + (YYPROF(I) - PN) * SCALE
            Y = MAX (MIN (Y, Y2), Y1)
            IF (I.EQ.1) THEN
               CALL GPOS (X, Y, PLBUF, IERR)
            ELSE
               CALL GVEC (X, Y, PLBUF, IERR)
               END IF
            IF (IERR.NE.0) GO TO 990
 50         CONTINUE
         CALL GLTYPE (1, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
      GO TO 999
C
 990  WRITE (MSGTXT,1990) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT (I8)
 1021 FORMAT (F8.1)
 1022 FORMAT (F8.2)
 1990 FORMAT ('PROFIT ERROR',I4,' PLOTTING PROFILE')
      END
      SUBROUTINE GRYPRM (IRETCD, PLBUF)
C-----------------------------------------------------------------------
C   Routine to get parameters for grey scale task
C   INPUTS
C       PLBUF  I(256)    Work buffer
C   OUTPUTS
C       QUICK   L         .TRUE. => AIPS already restarted
C       IRETCD  I         Return code 0=> OK, else just go to STOP
C   Task parameters are returned in common /INPARM/
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   PLBUF(*), IRETCD
C
      INTEGER   IERR, IROUND
      INCLUDE 'GREYS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA PRGNAM /'GREYS '/
C-----------------------------------------------------------------------
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = MABFSS * 2
      NCFILE = 0
      NSCR = 0
C                                       Get input values from AIPS.
      CALL GTPARM (PRGNAM, INPRMS, RQUICK, XDCONT, PLBUF, IRETCD)
      IF (IRETCD.NE.0) RQUICK = .TRUE.
      IF (IRETCD.EQ.1) GO TO 999
      IF (RQUICK) CALL RELPOP (IRETCD, PLBUF, IERR)
      IF (IRETCD.NE.0) GO TO 999
C                                       AIPS Holleriths ->
C                                       characters
      CALL H2CHR (12, 1, XNAMIN, NAMIN(1))
      CALL H2CHR (6, 1, XCLSIN, CLSIN(1))
      CALL H2CHR (12, 1, XNAMI2, NAMIN(2))
      CALL H2CHR (6, 1, XCLSI2, CLSIN(2))
      CALL H2CHR (12, 1, XNAMI3, NAMIN(3))
      CALL H2CHR (6, 1, XCLSI3, CLSIN(3))
      CALL H2CHR (12, 1, XNAMI4, NAMIN(4))
      CALL H2CHR (6, 1, XCLSI4, CLSIN(4))
      CALL H2CHR (48, 1, XOFMF, OFMFIL)
      CALL H2CHR (48, 1, XINFIL, INFILE)
      ISEQ(1) = IROUND (SEQIN)
      ISEQ(2) = IROUND (SEQIN2)
      ISEQ(3) = IROUND (SEQIN3)
      ISEQ(4) = IROUND (SEQIN4)
      IVOL(1) = IROUND (DSKIN)
      IVOL(2) = IROUND (DSKIN2)
      IVOL(3) = IROUND (DSKIN3)
      IVOL(4) = IROUND (DSKIN4)
C                                       Plot beam corners
      BMCORN = IROUND (XHPBP)
      BMBLNK = BMCORN.LT.0.0
      BMCORN = ABS (BMCORN)
      IF (BMCORN.GT.20) BMCORN = 1
      IF (MOD(BMCORN,5).EQ.0) BMCORN = BMCORN - 4
C                                       Do contours?: request &
C                                       not all of name null
      DOCONT = XDCONT.GT.0.0
      IF (DOCONT) THEN
         IF ((NAMIN(2).EQ.' ') .AND. (CLSIN(2).EQ.' ') .AND.
     *      (ISEQ(2).LT.1) .AND. ((IVOL(2).LT.1) .OR.
     *      (IVOL(2).GT.NVOL))) THEN
            DOCONT = .FALSE.
            XDCONT = -1.0
C                                       Name defaults
         ELSE
            IF (NAMIN(2).EQ.' ') NAMIN(2) = NAMIN(1)
            IF (CLSIN(2).EQ.' ') CLSIN(2) = CLSIN(1)
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE GRYINI (CH, PLBUF, IRET)
C-----------------------------------------------------------------------
C   GRYINI performs the initialization of parameters and the creation
C   of the plot file.  It also opens the files.
C   Output:
C      CH       R(4)     Number chars outside plot - special here
C      PLBUF   I(256)   Plot buffer
C      IRET     I        0 => proceed, 1 => quit
C-----------------------------------------------------------------------
      REAL       CH(4)
      INTEGER    PLBUF(*), IRET
C
      CHARACTER TYPE*2, OPCODE*4, RGB*8, FUNCS(8)*2
      REAL      X, PEAK,  RANGE2(2), WRANG2(2)
      INTEGER   IROUND, IERR, IGSIZE, ITYPE, IUSER, I, J, IFUN, LTYPE
      LOGICAL   T
      INCLUDE 'GREYS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA T /.TRUE./
      DATA RGB /'RGB'/
      DATA FUNCS /'LN','LG','L2','SQ','NE','NG','N2','NQ'/
C-----------------------------------------------------------------------
      CALL RFILL (8192, 0.0, XXPROF)
      CALL RFILL (8192, 0.0, YYPROF)
      CALL FILL (8192, 0, NYPROF)
      IMLUN(1) = 16
      IMLUN(2) = 17
      IMLUN(3) = 18
      IMLUN(4) = 19
      IGLUN = 26
      ILABEL = IROUND (TLABEL)
      LTYPE = MOD (ABS(ILABEL), 100)
      IF (LTYPE.LE.0) LTYPE = 3
      LTYPE = MOD (LTYPE-1,10) + 1
      IF (ILABEL.GT.0) THEN
         ILABEL = (ILABEL/100)*100 + LTYPE
      ELSE
         ILABEL = (ILABEL/100)*100 - LTYPE
         END IF
      TLABEL = ILABEL
      IUSER = NLUSER
      ISLST = IROUND (SLST)
      ISLEND = IROUND (SLEND)
      IF ((ISLST.LT.0) .OR. (ISLEND.LT.0)) THEN
         ISLST = 0
         ISLEND = 0
         END IF
      NBOX = IROUND (XNBOX)
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = XTVCH + 0.01
      TVCORN(1) = IROUND (XTVCRN(1))
      TVCORN(2) = IROUND (XTVCRN(2))
      IRET = 8
C                                       Open grey scale map file
      TYPE = 'MA'
      OPCODE = 'HDWR'
      IF (DOTV) OPCODE = 'READ'
      IVER = 0
      DO 10 I = 1,4
         IF ((I.EQ.1) .OR. ((I.EQ.2) .AND. (DOCONT)) .OR. ((I.GT.2)
     *      .AND. (INCOLR.GT.0.0))) THEN
            CALL MAPOPN (OPCODE, IVOL(I), NAMIN(I), CLSIN(I), ISEQ(I),
     *         TYPE, IUSER, IMLUN(I), IMFIND(I), CNO(I), PCATI(1,I),
     *         PLBUF, IERR)
            OPCODE = 'READ'
            IF (IERR.NE.0) GO TO 995
            NCFILE = NCFILE + 1
            FVOL(NCFILE) = IVOL(I)
            FCNO(NCFILE) = CNO(I)
            FRW(NCFILE) = 0
C                                       Add extension file to header.
            IF ((I.EQ.1) .AND. (.NOT.DOTV)) THEN
               CALL MADDEX ('PL', IVOL, CNO, PCATI(1,1), PLBUF, .TRUE.,
     *            'READ', IVER, IERR)
               IF (IERR.NE.0) GO TO 999
               END IF
C                                       check for RGBC
            IF ((I.EQ.1) .AND. (INCOLR.GT.0.0)) THEN
               CALL AXEFND (8, RGB, PCATI(KIDIM,1), PCATH(KHCTP,1), J,
     *            IERR)
               IF ((IERR.EQ.0) .AND. (J.EQ.2) .AND.
     *            (PCATI(KINAX+2,1).GE.3)) THEN
                  NAMIN(3) = NAMIN(1)
                  CLSIN(3) = CLSIN(1)
                  ISEQ(3) = ISEQ(1)
                  IVOL(3) = IVOL(1)
                  NAMIN(4) = NAMIN(1)
                  CLSIN(4) = CLSIN(1)
                  ISEQ(4) = ISEQ(1)
                  IVOL(4) = IVOL(1)
                  INCOLR = 2.0
               ELSE
                  IF (((NAMIN(3).EQ.' ') .AND. (CLSIN(3).EQ.' ')) .OR.
     *               ((NAMIN(4).EQ.' ') .AND. (CLSIN(4).EQ.' '))) THEN
                     MSGTXT = 'DOCOLR REQUESTED, BUT RGB AXIS NOT' //
     *                  ' 3RD AXIS'
                     CALL MSGWRT (7)
                     INCOLR = -1.0
                  ELSE
                     INCOLR = 1.0
                     END IF
                  END IF
               END IF
            END IF
 10      CONTINUE
C                                       return adverbs
      SEQIN = ISEQ(1)
      SEQIN2 = ISEQ(2)
      SEQIN3 = ISEQ(3)
      SEQIN4 = ISEQ(4)
      DSKIN = IVOL(1)
      DSKIN2 = IVOL(2)
      DSKIN3 = IVOL(3)
      DSKIN4 = IVOL(4)
      CALL CHR2H (12, NAMIN(1), 1, XNAMIN)
      CALL CHR2H (12, NAMIN(2), 1, XNAMI2)
      CALL CHR2H (12, NAMIN(3), 1, XNAMI3)
      CALL CHR2H (12, NAMIN(4), 1, XNAMI4)
      CALL CHR2H (6, CLSIN(1), 1, XCLSIN)
      CALL CHR2H (6, CLSIN(2), 1, XCLSI2)
      CALL CHR2H (6, CLSIN(3), 1, XCLSI3)
      CALL CHR2H (6, CLSIN(4), 1, XCLSI4)
C                                       check ST plot parms
      I = 0
      IF (XSTVER.LT.0.0) STMULT = 0.0
      IF (STMULT.NE.0.0) CALL FNDEXT ('ST', PCATI(1,1), I)
      IF (I.GT.0) THEN
         J = XSTVER + 0.1
         IF (J.LE.0) J = I
         XSTVER = J
      ELSE
         XSTVER = 0
         STMULT = 0.0
         END IF
      STVER = IROUND (XSTVER)
      IF (STVER.LT.0) STMULT = 0.0
C                                       Check slices present if
C                                       requested
      IF (ISLST.GT.0) THEN
         CALL SLCHK (ISLST, ISLEND, IERR)
         IF (IERR.NE.0) THEN
            ISLST = 0
            ISLEND = 0
            END IF
         END IF
C                                       Check windows
      CALL ALIGN (IERR)
      IF (IERR.NE.0) GO TO 995
      I = IROUND (DOPROF)
      IF ((I.EQ.1) .OR. (I.EQ.3)) THEN
         IF (DPARM(1).LE.0.0) THEN
            DPARM(1) = 0.1
         ELSE IF (DPARM(1).GT.1.0) THEN
            DPARM(1) = DPARM(1) / 100.0
            END IF
         IYPROF = (TRC(2,1)-BLC(2,1)+1.0) * DPARM(1)
      ELSE
         IYPROF = 0
         END IF
      IF ((I.EQ.2) .OR. (I.EQ.3)) THEN
         IF (DPARM(2).LE.0.0) THEN
            DPARM(2) = 0.1
         ELSE IF (DPARM(2).GT.1.0) THEN
            DPARM(2) = DPARM(2) / 100.0
            END IF
         IXPROF = (TRC(1,1)-BLC(1,1)+1.0) * DPARM(2)
      ELSE
         IXPROF = 0
         END IF
C                                       Get grey scale header info.
      IXWDGE = 0
      IYWDGE = 0
      IF (DOWDGE.GT.0.0) THEN
         IF ((DOWDGE.LT.1.5) .OR. ((DOWDGE.GE.2.5) .AND.
     *      (DOWDGE.LT.3.5))) THEN
            IYWDGE = MAX (1.0, (TRC(2,1)-BLC(2,1))/20.0) + 2.5
         ELSE
            IXWDGE = MAX (1.0, (TRC(1,1)-BLC(1,1))/20.) + 2.5
            END IF
         IF (INCOLR.GT.0.0) THEN
            IXWDGE = ((IXWDGE+2)/3) * 3
            IYWDGE = ((IYWDGE+2)/3) * 3
            END IF
         END IF
C                                       Build file name.
      CALL ZPHFIL ('PL', IVOL, CNO, IVER, IGFILE, IERR)
      CALL RCOPY (7, BLC(1,1), XBLC)
      CALL RCOPY (7, TRC(1,1), XTRC)
C                                       Grey scale range
      WRANGE(1) = 0.0
      WRANGE(2) = 0.0
      CALL RNGSET (RANGE, PCATR(KRDMX,1), PCATR(KRDMN,1), RANGE2)
      CALL RNGSET (WRANGE, PCATR(KRDMX,1), PCATR(KRDMN,1), WRANG2)
      GFAC = 2.0D0 ** MIN (30, NBITWD)  -  4.0D0
      IF (DOWDGE.LT.2.5) CALL RCOPY (2, RANGE2, WRANG2)
      GFAC = (WRANG2(2)-WRANG2(1)) / GFAC
      GOFF = (WRANG2(2)+WRANG2(1)) / 2.0D0
      RANGE2(2) = (RANGE2(2) - GOFF) / GFAC
      RANGE2(1) = (RANGE2(1) - GOFF) / GFAC
      IHPVAL = IROUND (RANGE2(2))
      ILPVAL = IROUND (RANGE2(1))
      RANGE(1) = (ILPVAL * GFAC + GOFF)
      RANGE(2) = (IHPVAL * GFAC + GOFF)
      WRANG2(2) = (WRANG2(2) - GOFF) / GFAC
      WRANG2(1) = (WRANG2(1) - GOFF) / GFAC
      J = IROUND (WRANG2(2))
      I = IROUND (WRANG2(1))
      WRANGE(1) = (I * GFAC + GOFF)
      WRANGE(2) = (J * GFAC + GOFF)
      RANGES(1,1) = RANGE(1)
      RANGES(2,1) = RANGE(2)
      IF (INCOLR.EQ.2.0) THEN
         IF (APARM(2).LE.APARM(1)) THEN
            RANGES(1,2) = RANGE(1)
            RANGES(2,2) = RANGE(2)
         ELSE
            CALL RNGSET (APARM(1), PCATR(KRDMX,1), PCATR(KRDMN,1),
     *         RANGES(1,2))
            END IF
         IF (APARM(4).LE.APARM(3)) THEN
            RANGES(1,3) = RANGE(1)
            RANGES(2,3) = RANGE(2)
         ELSE
            CALL RNGSET (APARM(3), PCATR(KRDMX,1), PCATR(KRDMN,1),
     *         RANGES(1,3))
            END IF
      ELSE IF (INCOLR.NE.1.0) THEN
         RANGES(1,2) = RANGE(1)
         RANGES(2,2) = RANGE(2)
         RANGES(1,3) = RANGE(1)
         RANGES(2,3) = RANGE(2)
      ELSE
         CALL RNGSET (APARM(1), PCATR(KRDMX,3), PCATR(KRDMN,3),
     *      RANGES(1,2))
         CALL RNGSET (APARM(3), PCATR(KRDMX,4), PCATR(KRDMN,4),
     *      RANGES(1,3))
         END IF
      CALL RCOPY (4, RANGES(1,2), APARM)
C                                       Default XYRATO: ratio of
C                                       incr if related.
      DO 60 I = 1,5
         PLBUF(I) = IROUND (BLC(I+2,1))
 60      CONTINUE
      LOCNUM = 3
      CALL SETLOC (PLBUF, T)
      LOCNUM = 2
      CALL SETLOC (PLBUF, T)
      LOCNUM = 1
      CALL SETLOC (PLBUF, T)
      IF ((XYRATO.LE.0.01) .OR. (XYRATO.GT.320.0)) THEN
         IF ((AXTYP(LOCNUM).EQ.1) .AND. (AXINC(2,LOCNUM).NE.0.0)) XYRATO
     *      = ABS (AXINC(1,LOCNUM) / AXINC(2,LOCNUM))
         IF (((XYRATO.LE.0.04) .OR. (XYRATO.GT.25.)) .AND.
     *      (TRC(1,1).NE.BLC(1,1))) XYRATO = (TRC(2,1)-BLC(2,1)) /
     *      (TRC(1,1)-BLC(1,1))
         IF ((XYRATO.LE.0.04) .OR. (XYRATO.GT.25.)) XYRATO = 1.0
         END IF
C                                       Determine approx file size.
      IGSIZE = 0
      X = (TRC(1,1)-BLC(1,1)+4+IXWDGE) * (TRC(2,1)-BLC(2,1)+1+IYWDGE) /
     *   256.0  +  5.0
      IF (X.GT.84.) IGSIZE = 1
      IF (X.GT.420.) IGSIZE = 2
      ITYPE = 27
C                                       Determine borders for dif labs.
C                                       extra border chars if necessary
      CALL RFILL (4, 0.0, CH)
      LTYPE = MOD (ABS(ILABEL),100)
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CH(2) = 1.333
C                                       Doing contours
      IF (DOCONT) THEN
C                                       Levels defaults
         PEAK = MAX (ABS(PCATR(KRDMX,2)), ABS(PCATR(KRDMN,2)))
         MULT = CLEV
         IF ((CLEV.EQ.0.0) .AND. (PLEV.EQ.0.0)) PLEV = 10.0
         IF (PLEV.NE.0.0) MULT = PEAK * PLEV / 100.0
         CLEV = MULT
         IF ((LEVS(1).EQ.0.0) .AND. (LEVS(2).LE.LEVS(1))) THEN
            DO 70 I = 1,10
               LEVS(I) = I - 11.
               LEVS(I+10) = I
               LEVS(I+20) = 0.0
 70            CONTINUE
            END IF
         IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
            CH(2) = 1.333
            IF (.NOT.CSAME) CH(4) = 1.333
            END IF
         END IF
C                                       grey scale function for extlist
      CALL H2CHR (2, 1, XFUN, GPHFUN)
      IFUN = 0
      DO 80 I = 1,8
         IF (GPHFUN.EQ.FUNCS(I)) IFUN = I
 80      CONTINUE
      IF (IFUN.LE.0) THEN
         IFUN = 1
         GPHFUN = FUNCS(IFUN)
         CALL CHR2H (2, GPHFUN, 1, XFUN)
         END IF
      GPHFNS(1) = GPHFUN
      I = APARM(5) + 0.1
      IF ((I.LE.0) .OR. (I.GT.8)) I = IFUN
      APARM(5) = I
      GPHFNS(2) = FUNCS(I)
      I = APARM(6) + 0.1
      IF ((I.LE.0) .OR. (I.GT.8)) I = IFUN
      APARM(6) = I
      GPHFNS(3) = FUNCS(I)
C                                        Write parms to PL file
      IF ((XDKLIN.LE.0.0) .OR. (XDKLIN.GT.1.0)) XDKLIN = 0.33
      IF (INCOLR.GT.0.0) OFMFIL = ' '
      CALL GINIT (IVOL, CNO, IGFILE, IGSIZE, ITYPE, INPRMS, XDCONT,
     *   DOTV, TVCHN, GRCHN, TVCORN, PCATI, PLBUF, IGLUN, IGFIND,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1100) IERR
         GO TO 990
         END IF
      IF (DOTV) GPHDOD = (DODARK.GT.0.0)
      GPHCUT = XDKLIN
      CALL GETOFM (OFMFIL, GPHDOT, GPHTVC, DOOFM, DOCOLR, ROFM, GOFM,
     *   BOFM, NOFM, IERR)
      IF (IERR.NE.0) THEN
         DOOFM = .FALSE.
         IERR = 0
         END IF
      IF (.NOT.DOOFM) DOCOLR = .FALSE.
      IF (INCOLR.GT.0.0) DOCOLR = .TRUE.
      IF (.NOT.DOOFM) OFMFIL = ' '
      CALL CHR2H (48, OFMFIL, 1, XOFMF)
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (7)
 995  IF (IVER.GT.0) CALL DELEXT ('PL', IVOL(1), CNO(1), 'READ',
     *   PCATI(1,1), PLBUF, IVER, I)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('GRAPH FILE INIT ERROR. GINIT ERR =',I5)
      END
      SUBROUTINE GLAB (CH, NBLC, NTRC, ABLC, ATRC, PLBUF, IERR)
C-----------------------------------------------------------------------
C   GLAB is an axis labelling routine for use with grey scale plots.
C   Optional contour labels.
C   In/out:
C      CH      R(4)     character spacing around plot.
C      NBLC    R(2)     BLC including wedge, extra space
C      NTRC    R(2)     TRC including wedge, extra space
C      ABLC    R(2)     BLC including edge of pixels
C      ATRC    R(2)     TRC including edge of pixels
C      PLBUF  I(256)   the updated graphics output buffer.
C   Output:
C      IERR    I        error indicator:  0 = No error.
C-----------------------------------------------------------------------
      REAL      NBLC(2), NTRC(2), CH(4), ATRC(2), ABLC(2)
      INTEGER   PLBUF(256), IERR
C
      CHARACTER SPRTXT*100, ATIME*8, ADATE*12, CHTMP*8, NAMSTR*18,
     *   CORTXT(2)*80, LTEXT(5)*80, CHTEMP*20
      DOUBLE PRECISION    ZV(3)
      REAL      DCX, DCY, BJUNK(2), YGAP, TEMP
      INTEGER   IDEPTH(5), NTEXT, I, IANGL, INCHAR, IT(3), ID(3), ITEMP,
     *   CATEMP(256), NL, IXL, IROUND, I1, I2, LTYPE, JTRIM, J
      LOGICAL   SLICE, T, LFLAG
      INCLUDE 'GREYS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DGPH.INC'
      DATA SLICE, T /.FALSE., .TRUE./
C-----------------------------------------------------------------------
      NBLC(1) = BLC(1,1) - 0.7
      NBLC(2) = BLC(2,1) - 0.7
      NTRC(1) = TRC(1,1) + 0.7 + IXWDGE + IXPROF
      NTRC(2) = TRC(2,1) + 0.7 + IYWDGE + IYPROF
      ABLC(1) = NBLC(1)
      ABLC(2) = NBLC(2)
      ATRC(1) = NTRC(1)
      ATRC(2) = NTRC(2)
      IF (IXWDGE+IXPROF.GT.0) ATRC(1) = TRC(1,1) + 0.5
      IF (IYWDGE+IYPROF.GT.0) ATRC(2) = TRC(2,1) + 0.5
C
      IDEPTH(1) = BLC(3,1) + .01
      IDEPTH(2) = BLC(4,1) + .01
      IDEPTH(3) = BLC(5,1) + .01
      IDEPTH(4) = BLC(6,1) + .01
      IDEPTH(5) = BLC(7,1) + .01
      CALL H2CHR (8, 1, PCATH(KHBUN,1), UNITS)
C                                       Init for line drawing.
      LOCNUM = 1
      CALL LABINI (BLC, TRC, IDEPTH, CH, ILABEL, SLICE, YGAP, CORTXT,
     *   NTEXT)
C                                       wedge labeling
      LTYPE = MOD (ABS(ILABEL),100)
      IF (LTYPE.GE.3) THEN
         IF ((IXWDGE.GT.0) .AND. (IXPROF.LE.0)) THEN
            CALL GTICNT (ILABEL, WRANGE, I)
            IF (I.GT.0) CH(3) = CH(3) + 0.5 + I
         ELSE IF (IYPROF.GT.0) THEN
            J = JTRIM (UNITS)
            CH(3) = MAX (CH(3), 1.5+J)
            END IF
         IF ((IYWDGE.GT.0) .AND. (IYPROF.LE.0)) CH(4) = CH(4) + 1.333
         END IF
C                                       Prepare LEVS lines
      NL = 0
      IF ((LTYPE.LT.7) .AND. (DOCONT)) THEN
         I = 2 * MABFSS
         CALL FXLEVS (IMLUN(2), IMFIND(2), PCATI(1,2), BLC, TRC, 0, 0,
     *      0, MULT, LEVS, SUBMIN, SUBMAX, RBLK(1,2), I, IERR)
         IF (IERR.NE.0) GO TO 999
         NL = NL + 1
         IF ((MULT.GT.999.) .OR. (MULT.LT.0.01)) THEN
            WRITE (LTEXT(NL),1120) MULT
         ELSE
            WRITE (CHTEMP,1121) MULT
            IF (CHTEMP(9:10).EQ. ' -') CHTEMP(9:10) = '-0'
            IF (CHTEMP(9:10).EQ. '  ') CHTEMP(9:10) = ' 0'
            I2 = 15
            IF ((I2.GT.11) .AND. (CHTEMP(I2:I2).EQ.'0')) I2 = I2 - 1
            IF ((I2.GT.11) .AND. (CHTEMP(I2:I2).EQ.'0')) I2 = I2 - 1
            IF ((I2.GT.11) .AND. (CHTEMP(I2:I2).EQ.'0')) I2 = I2 - 1
            IF ((I2.GT.11) .AND. (CHTEMP(I2:I2).EQ.'0')) I2 = I2 - 1
            IF (I2.EQ.11) I2 = 10
            CHTEMP(I2+1:) = ' '
            CALL CHTRIM (CHTEMP, 20, CHTEMP, IXL)
            LTEXT(NL)(:IXL+7) = 'Levs = ' // CHTEMP(:IXL)
            END IF
         I = JTRIM (LTEXT(NL))
         LTEXT(NL)(I+1:) = ' * ('
         INCHAR = I + 5
         DO 10 I = 1,30
            I2 = 12
            IXL = IROUND (LEVS(I))
            IF (ABS(IXL-LEVS(I)).GT.0.0001) THEN
               IF ((LEVS(I).GE.-99.90) .AND. (LEVS(I).LE.999.90))
     *            I2 = 13
               IF ((LEVS(I).GE.-9.990) .AND. (LEVS(I).LE.99.990))
     *            I2 = 14
               IF ((LEVS(I).GE.-0.9990) .AND. (LEVS(I).LE.9.9990))
     *            I2 = 15
               DCX = 10.0 ** (I2-12)
               IXL = IROUND (LEVS(I) * DCX)
               TEMP = IXL / DCX
            ELSE
               TEMP = IXL
               END IF
            WRITE (CHTEMP,1122,ERR=5) TEMP
 5          IF (CHTEMP(10:11).EQ. ' -') CHTEMP(10:11) = '-0'
            IF (CHTEMP(10:11).EQ. '  ') CHTEMP(10:11) = ' 0'
            IF ((I2.GT.12) .AND. (CHTEMP(I2:I2).EQ.'0')) I2 = I2 - 1
            IF ((I2.GT.12) .AND. (CHTEMP(I2:I2).EQ.'0')) I2 = I2 - 1
            IF ((I2.GT.12) .AND. (CHTEMP(I2:I2).EQ.'0')) I2 = I2 - 1
            IF (I2.EQ.12) I2 = 11
            CHTEMP(I2+1:) = ' '
            CALL CHTRIM (CHTEMP, 20, CHTEMP, IXL)
            LTEXT(NL)(INCHAR:) = CHTEMP(:IXL) // ', '
            INCHAR = INCHAR + 2 + IXL
C                                       Print out this line.
            IF (I.EQ.30) GO TO 15
            IF (LEVS(I+1).LE.LEVS(I)) GO TO 15
            IF (INCHAR.GE.70) THEN
               INCHAR = 1
               NL = NL + 1
               END IF
 10         CONTINUE
 15      INCHAR = INCHAR - 2
         LTEXT(NL)(INCHAR:INCHAR) = ')'
         CH(2) = CH(2) + (NL + 1) * 1.333
         END IF
C                                       Init for plotting
      CALL GINITL (NBLC, NTRC, XYRATO, CH, IDEPTH, PLBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       repeat GINIT kills this
      GPHFUN = GPHFNS(1)
C                                       Init for grey scale.
      IF (DOCOLR) THEN
         CALL GINITC (ILPVAL, IHPVAL, RANGES, PLBUF, IERR)
      ELSE
         CALL GINITG (ILPVAL, IHPVAL, RANGE, PLBUF, IERR)
         END IF
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Extra lines (center rels)
      CALL GLTYPE (1, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 980
      IF (LTYPE.EQ.1) GO TO 999
      IF ((NTEXT.GT.0) .AND. (LTYPE.LT.7)) THEN
         DCX = 0.0
         IANGL = 0
         DO 25 I = 1,NTEXT
            CALL GPOS (NBLC(1), NBLC(2), PLBUF, IERR)
            IF (IERR.NE.0) GO TO 980
            DCY = -YGAP
            CALL CHTRIM (CORTXT(I), 80, CORTXT(I), INCHAR)
            CALL GCHAR (INCHAR, IANGL, DCX, DCY, CORTXT(I), PLBUF,
     *         IERR)
            IF (IERR.NE.0) GO TO 980
            YGAP = YGAP + 1.333
 25         CONTINUE
         END IF
C                                       Source name, stokes, freq.
C                                       for grey scale image
      IF (LTYPE.LT.7) THEN
         CALL GPOS (NBLC(1), NTRC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         DCX = 0.0
         DCY = 0.5
         IF ((LTYPE.GE.3) .AND. (IYWDGE.GT.0) .AND. (IYPROF.LE.0))
     *      DCY = 1.833
         SPRTXT = ' '
         INCHAR = 1
         IF ((DOCONT) .AND. (.NOT.CSAME)) THEN
            DCY = DCY + 1.333
            INCHAR = 7
            SPRTXT(1:5) = 'GREY:'
            END IF
         IANGL = 0
         CALL H2CHR (8, 1, PCATH(KHOBJ,1), SOURCE)
         IF (SOURCE.NE.' ') THEN
            SPRTXT(INCHAR:INCHAR+7) = SOURCE(1:8)
            INCHAR = INCHAR + 10
            END IF
         IF (NCHLAB(1,LOCNUM).GT.0) THEN
            IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
            SPRTXT(INCHAR:) = SAXLAB(1,LOCNUM)(:NCHLAB(1,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(1,LOCNUM)
            END IF
         IF (NCHLAB(2,LOCNUM).GT.0) THEN
            IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
            SPRTXT(INCHAR:) = SAXLAB(2,LOCNUM)(:NCHLAB(2,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(2,LOCNUM)
            END IF
C                                       image name
         IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
         CALL H2CHR (12, KHIMNO, PCATH(KHIMN,1), NAMSTR(1:12))
         CALL H2CHR (6, KHIMCO, PCATH(KHIMC,1), NAMSTR(13:18))
         CALL NAMEST (NAMSTR, PCATI(KIIMS,1), SPRTXT(INCHAR:), ITEMP)
         CALL REFRMT (SPRTXT, '_', INCHAR)
         CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPRTXT, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Date/time version
         IF (ILABEL.GE.0) THEN
            CALL GPOS (NBLC(1), NTRC(2), PLBUF, IERR)
            IF (IERR.NE.0) GO TO 980
            DCY = DCY + 1.333
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (SPRTXT,1030) IVER, ADATE, ATIME
            CALL REFRMT (SPRTXT, '_', INCHAR)
            CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPRTXT, PLBUF, IERR)
            IF (IERR.NE.0) GO TO 980
            END IF
C                                       Peak flux for grey scale
         DCX = 0.0
         DCY = -YGAP
         YGAP = YGAP + 1.333
         IANGL = 0
         CALL GPOS (NBLC(1), NBLC(2), PLBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         TEMP = RANGE(2) - RANGE(1)
         CALL METSCL (ILABEL, TEMP, PREFIX, LFLAG)
         IF (LFLAG) THEN
            INCHAR = 55
            WRITE (SPRTXT,1040) RANGE, UNITS
            PXMULT = 1.0
         ELSE
            PXMULT = TEMP / (RANGE(2)-RANGE(1))
            BJUNK(1) = PXMULT * RANGE(1)
            BJUNK(2) = PXMULT * RANGE(2)
            TEMP = MAX (ABS(BJUNK(1)), ABS(BJUNK(2)))
            J = JTRIM (PREFIX)
            IF (TEMP.LT.9.99) THEN
               WRITE (SPRTXT,1041) BJUNK, PREFIX(:J), UNITS
               I1 = 25
               I2 = 33
            ELSE IF (TEMP.LT.99.9) THEN
               WRITE (SPRTXT,1042) BJUNK, PREFIX(:J), UNITS
               I1 = 26
               I2 = 34
            ELSE IF (TEMP.LT.9999.) THEN
               WRITE (SPRTXT,1043) BJUNK, PREFIX(:J), UNITS
               I1 = 27
               I2 = 35
            ELSE IF (TEMP.LT.9999999.) THEN
               WRITE (SPRTXT,1044) BJUNK, PREFIX(:J), UNITS
               I1 = 30
               I2 = 40
            ELSE
               WRITE (SPRTXT,1040) RANGE, UNITS
               I1 = -1
               END IF
            IF (I1.GT.0) THEN
               IF (SPRTXT(I1:I1+1).EQ. ' -') SPRTXT(I1:I1+1) = '-0'
               IF (SPRTXT(I1:I1+1).EQ. '  ') SPRTXT(I1:I1+1) = ' 0'
               IF (SPRTXT(I2:I2+1).EQ. ' -') SPRTXT(I2:I2+1) = '-0'
               IF (SPRTXT(I2:I2+1).EQ. '  ') SPRTXT(I2:I2+1) = ' 0'
               END IF
            END IF
         CALL REFRMT (SPRTXT, '_', INCHAR)
         CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPRTXT, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         END IF
C                                       With Contours
      IF (DOCONT) THEN
         IF (.NOT.CSAME) THEN
            CALL COPY (256, PCATI(1,1), CATEMP)
            CALL COPY (256, PCATI(1,2), PCATI)
            IDEPTH(1) = BLC(3,2) + .01
            IDEPTH(2) = BLC(4,2) + .01
            IDEPTH(3) = BLC(5,2) + .01
            IDEPTH(4) = BLC(6,2) + .01
            IDEPTH(5) = BLC(7,2) + .01
            LOCNUM = 2
            CALL SETLOC (IDEPTH, T)
            CALL COPY (256, CATEMP, PCATI)
            IF ((AXTYP(LOCNUM).EQ.2) .OR. (AXTYP(LOCNUM).EQ.3)) THEN
               DCX = (BLC(1,2) + TRC(1,2)) / 2.0
               DCY = (BLC(2,2) + TRC(2,2)) / 2.0
               CALL XYVAL (DCX, DCY, ZV(1), ZV(2), ZV(3), IERR)
               CALL AXSTRN (CTYP(3,LOCNUM), ZV(3), KLOCA(LOCNUM),
     *            NCHLAB(1,LOCNUM), SAXLAB(1,LOCNUM))
               END IF
C                                       Source name, stokes, freq.
C                                       for contour image
            IF (LTYPE.LT.7) THEN
               CALL GPOS (NBLC(1), NTRC(2), PLBUF, IERR)
               IF (IERR.NE.0) GO TO 980
               DCX = 0.0
               DCY = 0.5
               IF ((LTYPE.GE.2) .AND. (IYWDGE.GT.0)) DCY = 1.833
               IANGL = 0
               SPRTXT = 'CONT: '
               INCHAR = 7
               CALL H2CHR (8, 1, PCATH(KHOBJ,2), SOURCE)
               IF (SOURCE.NE.' ') THEN
                  SPRTXT(INCHAR:) = SOURCE(1:8)
                  INCHAR = INCHAR + 10
                  END IF
               IF (NCHLAB(1,LOCNUM).GT.0) THEN
                  IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
                  SPRTXT(INCHAR:) = SAXLAB(1,LOCNUM)(:NCHLAB(1,LOCNUM))
                  INCHAR = INCHAR + 3 + NCHLAB(1,LOCNUM)
                  END IF
               IF (NCHLAB(2,LOCNUM).GT.0) THEN
                  IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
                  SPRTXT(INCHAR:) = SAXLAB(2,LOCNUM)(:NCHLAB(2,LOCNUM))
                  INCHAR = INCHAR + 3 + NCHLAB(2,LOCNUM)
                  END IF
C                                       image name
               IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
               CALL H2CHR (12, KHIMNO, PCATH(KHIMN,2), NAMSTR(1:12))
               CALL H2CHR (6, KHIMCO, PCATH(KHIMC,2), NAMSTR(13:18))
               CALL NAMEST (NAMSTR, PCATI(KIIMS,2), SPRTXT(INCHAR:),
     *            ITEMP)
               CALL REFRMT (SPRTXT, '_', INCHAR)
               CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPRTXT, PLBUF,
     *            IERR)
               IF (IERR.NE.0) GO TO 980
               END IF
            END IF
         LOCNUM = 1
C                                        Peak contour flux
         IF (LTYPE.LT.7) THEN
            DCX = 0.0
            DCY = -YGAP
            YGAP = YGAP + 1.333
            IANGL = 0
            CALL GPOS (NBLC(1), NBLC(2), PLBUF, IERR)
            IF (IERR.NE.0) GO TO 980
            TEMP = PCATR(KRDMX,2)
            IF (ABS(TEMP).LT.ABS(PCATR(KRDMN,2))) TEMP = PCATR(KRDMN,2)
            CALL H2CHR (8, 1, PCATH(KHBUN,2), UNITS)
            WRITE (SPRTXT,1110) SUBMIN, SUBMAX, UNITS
            CALL REFRMT (SPRTXT, '_', INCHAR)
            CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPRTXT, PLBUF, IERR)
            IF (IERR.NE.0) GO TO 980
C                                       Write levels.
            DCX = 0.0
            DCY = DCY - 1.333
            IANGL = 0
            DO 130 I = 1,NL
               CALL GPOS (NBLC(1), NBLC(2), PLBUF, IERR)
               IF (IERR.NE.0) GO TO 980
               CALL REFRMT (LTEXT(I), ' ', INCHAR)
               CALL GCHAR (INCHAR, IANGL, DCX, DCY, LTEXT(I), PLBUF,
     *            IERR)
               IF (IERR.NE.0) GO TO 980
               DCY = DCY - 1.333
 130           CONTINUE
            END IF
         END IF
      GO TO 999
C                                       Graph drawing error.
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GRAPH FILE INITIALIZATION ERROR. GINITL ERR =',I5)
 1010 FORMAT ('GREY SCALE INITIALIZATION ERROR. GINITG ERR =',I5)
 1030 FORMAT ('Plot file version',I4,'__created ',A12,A8)
 1040 FORMAT ('Grey scale brightness range=',2(1PE12.4),1X,A8)
 1041 FORMAT ('Grey scale brightness range=',2F8.3,1X,A,1X,A8)
 1042 FORMAT ('Grey scale brightness range=',2F8.2,1X,A,1X,A8)
 1043 FORMAT ('Grey scale brightness range=',2F8.1,1X,A,1X,A8)
 1044 FORMAT ('Grey scale brightness range=',2F10.0,1X,A,1X,A8)
 1110 FORMAT ('Contour brightness extrema =',2(1PE12.4),1X,A8)
 1120 FORMAT ('Levs =',1PE11.3)
 1121 FORMAT (F15.4)
 1122 FORMAT (F15.3)
 1980 FORMAT ('GRAPH LABEL WRITING ERROR. IERR =',I5)
      END
      SUBROUTINE SLCHK (IS1, IS2, IERR)
C-----------------------------------------------------------------------
C   Make sure there are slices to draw, and that the start and end slice
C   numbers are sensible
C   Input:
C      IS1   I    Start slice
C      IS2   I    End slice
C   Output:
C      IERR    I    0 => OK
C-----------------------------------------------------------------------
      INTEGER IS1, IS2, IERR, SLMAX
C
      INCLUDE 'GREYS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL FNDEXT ('SL', PCATI, SLMAX)
      IF (SLMAX.LE.0) THEN
         IERR = 1
         WRITE (MSGTXT,1000)
         CALL MSGWRT (8)
      ELSE
         IF (IS2.LT.IS1) THEN
            WRITE (MSGTXT, 2000)
            CALL MSGWRT (8)
            IERR = 2
         ELSE IF ((IS1.GT.SLMAX) .OR. (IS2.GT.SLMAX)) THEN
            WRITE (MSGTXT, 2000)
            CALL MSGWRT (8)
            IERR = 2
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SLCHK: THERE ARE NO SLICES ASSOCIATED WITH THIS IMAGE')
 2000 FORMAT ('SLCHK: INVALID START AND END SLICE NUMBERS')
      END
      SUBROUTINE SLICPL (CNO, IVOL, BLC, TRC, ISLST, ISLEND, PLBUF,
     *   IERR)
C-----------------------------------------------------------------------
C   Draw slices on plot
C   Inputs:
C      CNO      I        Catalogue slot of image
C      IVOL     I        Disk number of image
C      BLC      R(2)     BLC of contour plot
C      TRC      R(2)     TRC of contour plot
C      ISLST    I        Start slice version
C      ISLEND   I        End slice version
C   In/out:
C      PLBUF    I(256)   Work area for graphics i/o
C   Output:
C      IERR     I        Error code: > 0 => plot error
C-----------------------------------------------------------------------
      INTEGER   CNO, IVOL, ISLST, ISLEND, PLBUF(256), IERR
      REAL      BLC(2), TRC(2)
C
      REAL      SBLK4(128), SLBLC(2), SLTRC(2)
      INTEGER   JERR, LUN, ISFIND, SBLK2(256), I, NPL
      LOGICAL   EXCL, WAIT
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (SBLK2, SBLK4)
      DATA LUN /27/
      DATA WAIT, EXCL /.TRUE., .TRUE./
C-----------------------------------------------------------------------
C                                           loop over slice files
      NPL = 0
      DO 100 I = ISLST,ISLEND
C                                           open slice file
         CALL OPEXT ('SL', IVOL, CNO, I, LUN, EXCL, WAIT, ISFIND,
     *      JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1000) I, JERR
            CALL MSGWRT (8)
            GO TO 100
            END IF
C                                           find slice BLC and TRC
         CALL ZFIO ('READ', LUN, ISFIND, 2, SBLK2, JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1010) I, JERR
            CALL MSGWRT (8)
            GO TO 90
            END IF
         SLBLC(1) = SBLK4(19)
         SLBLC(2) = SBLK4(20)
         SLTRC(1) = SBLK4(26)
         SLTRC(2) = SBLK4(27)
C                                           plot slice
         CALL LINEPL (BLC, TRC, SLBLC, SLTRC, PLBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) I
            CALL MSGWRT (8)
            GO TO 90
            END IF
         NPL = NPL + 1
C                                           close slice file
 90      CALL ZCLOSE (LUN, ISFIND, JERR)
         IF (JERR.NE.0) THEN
            WRITE (MSGTXT,1090) I, JERR
            CALL MSGWRT (8)
            GO TO 990
            END IF
 100     CONTINUE
C
 990  WRITE (MSGTXT,1990) NPL
      CALL MSGWRT (3)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SLICPL: ERROR OPENING SLICE FILE #', I3, ' IERR=', I3)
 1010 FORMAT ('SLICPL: ERROR READING REC. 2 OF SLICE #', I3,
     *        ' IERR=', I3)
 1020 FORMAT ('SLICPL: ERROR PLOTTING SLICE #', I3)
 1090 FORMAT ('SLICPL: ERROR CLOSING SLICE #', I3, ' IERR=', I3)
 1990 FORMAT ('SLICPL: Successfully plotted ', I3, ' slices')
      END
      SUBROUTINE LINEPL (BLC, TRC, P1, P2, PLBUF, IERR)
C-----------------------------------------------------------------------
C   Draw a line segment
C   Inputs:
C      BLC      R(2)     BLC of image being contoured
C      TRC      R(2)     TRC of image being contoured
C      P1       R(2)     Location (X,Y pixels) of line end 1
C      P2       R(2)     Location (X,Y pixels) of line end 2
C   In/out:
C      PLBUF   I(256)   i/o buffer
C   Outputs:
C      IERR     I      0 => OK
C-----------------------------------------------------------------------
      REAL      P1(2), P2(2), BLC(2), TRC(2)
      INTEGER   IERR, PLBUF(256)
C
      REAL      CPX(2), CPY(2)
      INTEGER   I
C-----------------------------------------------------------------------
      CPX(1) = P1(1)
      CPY(1) = P1(2)
      CPX(2) = P2(1)
      CPY(2) = P2(2)
      CALL LINLIM (BLC, TRC, CPX, CPY, I)
      IERR = 0
      IF (I.EQ.0) THEN
         CALL GPOS (CPX(1), CPY(1), PLBUF, IERR)
         IF (IERR.EQ.0) CALL GVEC (CPX(2), CPY(2), PLBUF, IERR)
         END IF
C
 999  RETURN
      END
      SUBROUTINE BOXPL (BLC, TRC, NBOX, BOX, PLBUF, IERR)
C-----------------------------------------------------------------------
C   Plot the boxes
C   Input:
C      BLC      R(2)      BLC of image being contoured
C      TRC      R(2)      TRC of image being contoured
C      NBOX     I         Number of boxes
C      BOX      R(4,50)   Boxes
C   In/out:
C      PLBUF   I(256)    i/o buffer
C   Output:
C      IERR     I         0 => OK
C-----------------------------------------------------------------------
      REAL      BLC(2), TRC(2), BOX(4,50)
      INTEGER   PLBUF(256), IERR, NBOX
C
      REAL      BBLC(2), BTRC(2)
      INTEGER   I, NPL
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (NBOX.GT.50) NBOX = 50
      NPL = 0
      DO 10 I = 1,NBOX
         IF ((BOX(3,I).LT.BLC(1)) .AND. (BOX(4,I).LT.BLC(2))) GO TO 10
         IF ((BOX(1,I).GT.TRC(1)) .AND. (BOX(2,I).GT.TRC(2))) GO TO 10
C                                       Bottom
         BBLC(1) = BOX(1,I)
         BBLC(2) = BOX(2,I)
         BTRC(1) = BOX(3,I)
         BTRC(2) = BOX(2,I)
         CALL LINEPL (BLC, TRC, BBLC, BTRC, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 20
C                                       Left
         BTRC(1) = BOX(1,I)
         BTRC(2) = BOX(4,I)
         CALL LINEPL (BLC, TRC, BBLC, BTRC, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 20
C                                       Top
         BBLC(1) = BOX(3,I)
         BBLC(2) = BOX(4,I)
         CALL LINEPL (BLC, TRC, BTRC, BBLC, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 20
C                                       Right
         BTRC(1) = BOX(3,I)
         BTRC(2) = BOX(2,I)
         CALL LINEPL (BLC, TRC, BBLC, BTRC, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 20
         NPL = NPL + 1
 10      CONTINUE
C
 20   WRITE (MSGTXT,1020) NPL
      IF (NPL.GT.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('BOXPL: Successfully plotted ', I3, ' boxes')
      END
      SUBROUTINE ALIGN (IRET)
C-----------------------------------------------------------------------
C   ALIGN checks the alignment of the images
C   Output:
C      IRET   I   Error code: o okay, else die
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   NXX, I, J, IROUND, IPT, IP, LP
      REAL      X
      LOGICAL   REDUCE
      CHARACTER CHTMP*8, CHTMP1*8
      DOUBLE PRECISION DX
      INCLUDE 'GREYS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       basic window setting
      CALL RCOPY (7, XBLC, BLC(1,1))
      CALL RCOPY (7, XTRC, TRC(1,1))
      CALL WINDOW (PCATI(KIDIM,1), PCATI(KINAX,1), BLC(1,1),
     *   TRC(1,1), IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (5, BLC(3,1), TRC(3,1))
      CALL RCOPY (5, BLC(3,1), TRC(3,2))
      CALL RCOPY (5, BLC(3,1), TRC(3,3))
      CALL RCOPY (5, BLC(3,1), TRC(3,4))
      CALL RCOPY (5, BLC(3,1), BLC(3,2))
      CALL RCOPY (5, BLC(3,1), BLC(3,3))
      CALL RCOPY (5, BLC(3,1), BLC(3,4))
C                                       check
C                                       alignment
      DO 40 IP = 2,4
         IF (((IP.EQ.2) .AND. (DOCONT)) .OR. ((IP.GT.2) .AND.
     *      (INCOLR.GT.0.0))) THEN
C                                       Set Map X,Y corners
            DO 25 I = 1,2
               J = KRCRP + I - 1
               BLC(I,IP) = PCATR(J,IP) - PCATR(J,1) + BLC(I,1)
               TRC(I,IP) = PCATR(J,IP) - PCATR(J,1) + TRC(I,1)
               IF (DOGRID.LT.-1.5) BLC(I,IP) = BLC(I,1)
               IF (DOGRID.LT.-1.5) TRC(I,IP) = TRC(I,1)
               J = I - 1
               IF (DOGRID.GT.-0.1) THEN
                  DX = PCATD(KDCRV+J,1) + (BLC(I,1) - PCATR(KRCRP+J,1))
     *               * PCATR(KRCIC+J,1)
                  IF (PCATR(KRCIC+J,IP).EQ.0.0) GO TO 45
                  X = (DX - PCATD(KDCRV+J,IP)) / PCATR(KRCIC+J,IP) +
     *               PCATR(KRCRP+J,IP)
                  BLC(I,IP) = IROUND (X)
                  IF ((DOGRID.GE.0.1) .AND. (ABS(X-BLC(I,IP)).GT.0.2))
     *               GO TO 45
                  TRC(I,IP) = BLC(I,IP) + TRC(I,1) - BLC(I,1)
                  END IF
C                                       smaller subimage needed?
               IF (BLC(I,IP).LT.1.0) THEN
                  DO 10 LP = 1,IP
                     BLC(I,LP) = BLC(I,LP) + 1.0 - BLC(I,IP)
 10                  CONTINUE
                  REDUCE = .TRUE.
                  END IF
               IF (TRC(I,IP).GT.PCATI(KINAX+J,IP)) THEN
                  DO 15 LP = 1,IP
                     TRC(I,LP) = TRC(I,LP) + PCATI(KINAX+J,LP) -
     *                  TRC(I,IP)
 15                  CONTINUE
                  REDUCE = .TRUE.
                  END IF
               DO 20 LP = 1,IP
                  IF ((LP.NE.2) .OR. (DOCONT)) THEN
                     IF (BLC(I,LP).GE.TRC(I,LP)) GO TO 45
                     END IF
 20               CONTINUE
 25            CONTINUE
C                                       Check true coincidence
            IF (DOGRID.GE.0.1) THEN
               DO 30 I = 1,NXX
                  J = I - 1
                  IPT = KHCTP + J*2
                  CALL H2CHR (8, 1, PCATH(IPT,1), CHTMP)
                  CALL H2CHR (8, 1, PCATH(IPT,IP), CHTMP1)
                  IF (CHTMP.NE.CHTMP1) GO TO 45
                  X = 0.2 * 0.2 * ABS (PCATR(KRCIC+J,1))
                  IF (ABS(PCATR(KRCIC+J,1)-PCATR(KRCIC+J,IP)).GT.X)
     *               GO TO 45
                  IF (ABS(PCATR(KRCRT+J,1)-PCATR(KRCRT+J,IP)).GT.1.)
     *               GO TO 45
 30               CONTINUE
               END IF
            END IF
C                                       get axes 3-5 okay
         CALL WINDOW (PCATI(KIDIM,IP), PCATI(KINAX,IP), BLC(1,IP),
     *      TRC(1,IP), IRET)
         IF (IRET.NE.0) GO TO 999
 40      CONTINUE
      IF (REDUCE) THEN
         MSGTXT = 'Input maps coincident on reduced subimage only'
         CALL MSGWRT (6)
         END IF
C                                       RGB AXIS
      IF (INCOLR.EQ.2.0) THEN
         BLC(3,1) = (1.0D0 - PCATD(KDCRV+2,1)) / PCATR(KRCIC+2,1) +
     *      PCATR(KRCRP+2,1)
         BLC(3,3) = (2.0D0 - PCATD(KDCRV+2,1)) / PCATR(KRCIC+2,1) +
     *      PCATR(KRCRP+2,1)
         BLC(3,4) = (3.0D0 - PCATD(KDCRV+2,1)) / PCATR(KRCIC+2,1) +
     *      PCATR(KRCRP+2,1)
         TRC(3,1) = BLC(3,1)
         TRC(3,3) = BLC(3,3)
         TRC(3,4) = BLC(3,4)
         END IF
      GO TO 999
C                                        Maps not coincident
 45   WRITE (MSGTXT,1045) I
      CALL MSGWRT (7)
      IRET = I
C
 999  RETURN
C-----------------------------------------------------------------------
 1045 FORMAT ('INPUT MAPS ARE NOT COINCIDENT: AXIS',I2)
      END
      SUBROUTINE LAYOUT (BLC, TRC, PCATR, INFILE, PLBUF, IERR)
C-----------------------------------------------------------------------
C   Plot the boxes
C   Input:
C      BLC      R(2)     BLC of image being contoured
C      TRC      R(2)     TRC of image being contoured
C      PCATR    R(256)   Image header
C      LAYOUT   C*48     In file name
C   In/out:
C      PLBUF   I(256)   i/o buffer
C   Output:
C      IERR     I        0 => OK
C-----------------------------------------------------------------------
      REAL      BLC(2), TRC(2), PCATR(256)
      INTEGER   PLBUF(256), IERR
      CHARACTER INFILE*(*)
C
      INTEGER   JTRIM, MSGSAV, INC, LUN, FIND, KBPLIM, KBP, NC, I, NP,
     *   J, IP, VLNPL(6,2), VLNUM
      CHARACTER LFILE*64, LINE*80
      DOUBLE PRECISION D, THETA, DTHETA
      REAL      R1, R2, X(5), Y(5), DX, DY, PX0, PY0, P1(2), P2(2),
     *   VLRPL(2,6,2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUN /3/
      DATA VLNPL /12,16,24,40,40,40, 20,20,40,40,40,40/
      DATA VLRPL /1.983,3.683, 3.683,5.563, 5.563,7.391, 7.391,9.144,
     *   9.144,10.87, 10.87,12.5,
     *   1.676,3.518, 3.518,5.423, 5.423,7.277, 7.277,9.081,
     *   9.081,10.808, 10.808,12.500/
C-----------------------------------------------------------------------
      IERR = 0
      IF ((PCATR(KRCIC).EQ.0.0) .OR. (PCATR(KRCIC+1).EQ.0.0)) GO TO 999
      PX0 = PCATR(KRCRP)
      PY0 = PCATR(KRCRP+1)
      DX = 1.0 / PCATR(KRCIC)
      DY = 1.0 / PCATR(KRCIC+1)
      MSGSAV = MSGSUP
      VLNUM = 0
      IF (INFILE.EQ.'VLA') VLNUM = 1
      IF (INFILE.EQ.'VLBA') VLNUM = 2
C                                       open layout file
      IF (VLNUM.LE.0) THEN
         INC = JTRIM (INFILE)
         LFILE = INFILE(:INC) // '.layout'
         MSGSUP = 32000
         CALL ZTXOPN ('QRED', LUN, FIND, LFILE, .FALSE., IERR)
         MSGSUP = MSGSAV
         IF (IERR.EQ.0) THEN
            CALL ZTXCLS (LUN, FIND, IERR)
            CALL ZTXOPN ('READ', LUN, FIND, LFILE, .FALSE., IERR)
            END IF
C                                       panel layout
         IF (IERR.EQ.0) THEN
C                                       read number of cards
            CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'READ LAYOUT LINE 1'
               GO TO 990
               END IF
            KBPLIM = JTRIM (LINE)
            KBP = 1
            CALL GETNUM (LINE, KBPLIM, KBP, D)
            IF (D.EQ.DBLANK) GO TO 980
            NC = D
            DO 40 J = 1,NC
               CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ LAYOUT DATA LINE'
                  GO TO 990
                  END IF
               KBPLIM = JTRIM (LINE)
               KBP = 1
               CALL GETNUM (LINE, KBPLIM, KBP, D)
               IF (D.EQ.DBLANK) GO TO 980
               NP = D
               CALL GETNUM (LINE, KBPLIM, KBP, D)
               IF (D.EQ.DBLANK) GO TO 980
               R1 = D
               CALL GETNUM (LINE, KBPLIM, KBP, D)
               IF (D.EQ.DBLANK) GO TO 980
               R2 = D
               DTHETA = 360.0D0 / NP * DG2RAD
               THETA = 0.0
               DO 30 IP = 1,NP
                  X(1) = R1 * SIN (THETA)
                  X(2) = R2 * SIN (THETA)
                  X(3) = R2 * SIN (THETA+DTHETA)
                  X(4) = R1 * SIN (THETA+DTHETA)
                  X(5) = X(1)
                  Y(1) = R1 * COS (THETA)
                  Y(2) = R2 * COS (THETA)
                  Y(3) = R2 * COS (THETA+DTHETA)
                  Y(4) = R1 * COS (THETA+DTHETA)
                  Y(5) = Y(1)
                  DO 20 I = 1,4
                     P1(1) = PX0 + DX * X(I)
                     P2(1) = PX0 + DX * X(I+1)
                     P1(2) = PY0 - DY * Y(I)
                     P2(2) = PY0 - DY * Y(I+1)
                     CALL LINEPL (BLC, TRC, P1, P2, PLBUF, IERR)
 20                  CONTINUE
                  THETA = THETA + DTHETA
 30               CONTINUE
 40            CONTINUE
            CALL ZTXCLS (LUN, FIND, IERR)
            END IF
C                                       bolts file
C                                       open layout file
         LFILE = INFILE(:INC) // '.bolts'
         MSGSUP = 32000
         CALL ZTXOPN ('QRED', LUN, FIND, LFILE, .FALSE., IERR)
         MSGSUP = MSGSAV
         IF (IERR.EQ.0) THEN
            CALL ZTXCLS (LUN, FIND, IERR)
            CALL ZTXOPN ('READ', LUN, FIND, LFILE, .FALSE., IERR)
            END IF
C                                       panel layout
         IF (IERR.NE.0) THEN
            IERR = 0
C                                       read number of cards
         ELSE
            CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'READ BOLT LINE 1'
               GO TO 990
               END IF
            KBPLIM = JTRIM (LINE)
            KBP = 1
            CALL GETNUM (LINE, KBPLIM, KBP, D)
            IF (D.EQ.DBLANK) GO TO 980
            NC = D
            CALL GETNUM (LINE, KBPLIM, KBP, D)
            IF (D.EQ.DBLANK) GO TO 980
            R2 = D
            IF (R2.LE.0.0) R2 = 0.25
            DO 140 J = 1,NC
               CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ BOLT DATA LINE'
                  GO TO 990
                  END IF
               KBPLIM = JTRIM (LINE)
               KBP = 1
               CALL GETNUM (LINE, KBPLIM, KBP, D)
               IF (D.EQ.DBLANK) GO TO 980
               R1 = D
               CALL GETNUM (LINE, KBPLIM, KBP, D)
               IF (D.EQ.DBLANK) GO TO 980
               NP = D
               CALL GETNUM (LINE, KBPLIM, KBP, D)
               IF (D.EQ.DBLANK) GO TO 980
               THETA = D * DG2RAD
               DTHETA = 360.0D0 / NP * DG2RAD
               DO 130 IP = 1,NP
                  X(1) = R1 * SIN (THETA)
                  Y(1) = R1 * COS (THETA)
                  X(2) = R2 * SIN (THETA + PI/4.0D0)
                  Y(2) = R2 * COS (THETA + PI/4.0D0)
                  P1(1) = PX0 + DX * (X(1) + X(2))
                  P1(2) = PY0 + DY * (Y(1) + Y(2))
                  P2(1) = PX0 + DX * (X(1) - X(2))
                  P2(2) = PY0 + DY * (Y(1) - Y(2))
                  CALL LINEPL (BLC, TRC, P1, P2, PLBUF, IERR)
                  P1(1) = PX0 + DX * (X(1) - Y(2))
                  P1(2) = PY0 + DY * (Y(1) + X(2))
                  P2(1) = PX0 + DX * (X(1) + Y(2))
                  P2(2) = PY0 + DY * (Y(1) - X(2))
                  CALL LINEPL (BLC, TRC, P1, P2, PLBUF, IERR)
                  THETA = THETA + DTHETA
 130              CONTINUE
 140           CONTINUE
            CALL ZTXCLS (LUN, FIND, IERR)
            END IF
C                                       known arrays
      ELSE
         NC = 6
         DO 240 J = 1,NC
            NP = VLNPL(J,VLNUM)
            THETA = 0.0
            DTHETA = 360.0D0 / NP * DG2RAD
            R1 = VLRPL(1,J,VLNUM)
            R2 = VLRPL(2,J,VLNUM)
            DO 230 IP = 1,NP
               X(1) = R1 * SIN (THETA)
               X(2) = R2 * SIN (THETA)
               X(3) = R2 * SIN (THETA+DTHETA)
               X(4) = R1 * SIN (THETA+DTHETA)
               X(5) = X(1)
               Y(1) = R1 * COS (THETA)
               Y(2) = R2 * COS (THETA)
               Y(3) = R2 * COS (THETA+DTHETA)
               Y(4) = R1 * COS (THETA+DTHETA)
               Y(5) = Y(1)
               DO 220 I = 1,4
                  P1(1) = PX0 + DX * X(I)
                  P2(1) = PX0 + DX * X(I+1)
                  P1(2) = PY0 - DY * Y(I)
                  P2(2) = PY0 - DY * Y(I+1)
                  CALL LINEPL (BLC, TRC, P1, P2, PLBUF, IERR)
 220              CONTINUE
               THETA = THETA + DTHETA
 230           CONTINUE
 240        CONTINUE
         END IF
      GO TO 999
C                                       bad value
 980  IERR = 2
      MSGTXT = 'ILLEGAL VALUE READ'
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('LAYOUT ERROR',I3,' ON ',A)
      END

      SUBROUTINE MCSEL (DISKI, CNOI, DISKO, CNOO, VER, CATIN, CATOUT,
     *   LUNI, LUNO, BPOL, EPOL, BIF, EIF, FREQID, TB, TE, NSOU, SOUIND,
     *   AN, NA, ISUB, JSUB, BUFFER, OBUFF, IRET)
C-----------------------------------------------------------------------
C! Copies an MC table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1998, 2007, 2011
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Copies a subset of IFs in a MC table, can also modify the FQ ID
C   Inputs:
C      DISKI    I        Input volume number
C      CNOI     I        Input catalog number
C      DISKO    I        Output volume number
C      CNOO     I        Output catalog number
C      VER      I        Version to check/modify
C      CATIN    I(256)   Input catalog header
C      CATOUT   I(256)   Output catalog header
C      LUNI     I        LUN to use
C      LUNO     I        LUN to use
C      BPOL     I        First polarization to copy
C      EPOL     I        Last polarization to copy
C      BIF      I        Start IF number
C      EIF      I        End IF number
C      IFQID    I        FQ ID to select (set to 1 on output)
C                           if <= 0 then output value unchanged.
C      TB       D        Beginning time in days
C      TE       D        Ending time in days
C      NSOU     I        Number of selected sources
C      SOUIND   I(*)     Array of sources indexes selected
C      AN       I(*)     Array of selected antennas
C      NA       I        Number of selected antennas
C      ISUB     I        Selected subarray (= 0 any)
C      JSUB     I        Output subarray number (< 0 => NO CHANGE)
C   Input/Output:
C      BUFFER   I(*)     Work buffer
C      OBUFF    I(*)     Work buffer
C   Output:
C      IRET     I        Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER DISKI, CNOI, DISKO, CNOO, VER, CATIN(256), CATOUT(256),
     *   LUNI, LUNO, BPOL, EPOL,  BIF, EIF, FREQID, NSOU, SOUIND(*),
     *   AN(*), NA, ISUB, JSUB, BUFFER(*), OBUFF(*), IRET
      DOUBLE PRECISION TB, TE
C
      INCLUDE 'INCS:PUVD.INC'
      DOUBLE PRECISION TIME, ATMOS, DATMOS, GDELAY, GRATE, CLOCK(2),
     *   RFREQ, DCLOCK(2)
      REAL      LOOFF(2,MAXIF), DLOOFF(2,MAXIF), DISP(2), DDISP(2),
     *   CHANBW, REFPIX, DELTAT
      INTEGER   NUMIF, SOURID, ANTNO, SUBA, FQID, IMCRNO, MCKOLI(21),
     *   MCNUMI(21), MCKOLO(21), MCNUMO(21), NSTOKE, STOKE1, NCHAN,
     *   NUMPOL, FFTSIZ, OVRSMP, ZEROPD, OMCRNO, LBPOL, NEWPOL, LBIF
      CHARACTER OBSCOD*8, RDATE*8, TAPER*8
      INTEGER   JIF, IIF, IPOL, NMCROW, I, NEWNIF, K, OVER
      LOGICAL   GOTIT, REFMT
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Open IM file
      CALL MCINI ('READ', BUFFER, DISKI, CNOI, VER, CATIN, LUNI, IMCRNO,
     *   MCKOLI, MCNUMI, OBSCOD, RDATE, NSTOKE, STOKE1, NUMIF, NCHAN,
     *   RFREQ, CHANBW, REFPIX, NUMPOL, FFTSIZ, OVRSMP, ZEROPD, TAPER,
     *   DELTAT, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
      LBPOL = MAX (1, BPOL)
      NEWPOL = MIN (2, MIN (NUMPOL, EPOL)) - LBPOL + 1
      IF (NEWPOL.LE.0) THEN
         NEWPOL = NUMPOL
         LBPOL = 1
         END IF
C                                       New no. of IF's
      LBIF = MAX (1, BIF)
      NEWNIF = MIN (NUMIF, EIF) - LBIF + 1
      IF (NEWNIF.LE.0) THEN
         NEWNIF = NUMIF
         LBIF = 1
         END IF
      REFMT = (NEWNIF.NE.NUMIF) .OR. (NEWPOL.NE.NUMPOL)
C                                       Numbers of rows in old table
      NMCROW = BUFFER(5)
C                                       Open up new IM table
      OVER = VER
      CALL MCINI ('WRIT', OBUFF, DISKO, CNOO, OVER, CATOUT, LUNO,
     *   OMCRNO, MCKOLO, MCNUMO, OBSCOD, RDATE, NSTOKE, STOKE1, NEWNIF,
     *   NCHAN, RFREQ, CHANBW, REFPIX, NEWPOL, FFTSIZ, OVRSMP, ZEROPD,
     *   TAPER, DELTAT, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 100 I = 1,NMCROW
         CALL MCTAB ('READ', BUFFER, IMCRNO, MCKOLI, MCNUMI, NUMPOL,
     *      NUMIF, TIME, SOURID, ANTNO, SUBA, FQID, ATMOS, DATMOS,
     *      GDELAY, GRATE, CLOCK, DCLOCK, LOOFF, DLOOFF, DISP, DDISP,
     *      IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ', I
            GO TO 990
            END IF
C                                       Time selection
         IF ((TIME.LT.TB) .OR. (TIME.GT.TE)) IRET = -1
C                                       FQ selection
         IF ((FQID.GT.0) .AND. (FREQID.GT.0) .AND. (FQID.NE.FREQID))
     *      IRET = -1
C                                       subarray selection
         IF ((SUBA.GT.0) .AND. (ISUB.GT.0) .AND. (ISUB.NE.SUBA))
     *      IRET = -1
C                                       Sources selection
         IF ((NSOU.GT.0) .AND. (SOURID.GT.0)) THEN
            GOTIT = .FALSE.
            DO 20 K = 1,NSOU
               GOTIT = GOTIT .OR. (SOURID.EQ.SOUIND(K))
 20            CONTINUE
            IF (.NOT.GOTIT) IRET = -1
            END IF
C                                       Antennas selection
         IF ((NA.GT.0) .AND. (ANTNO.GT.0)) THEN
            GOTIT = .FALSE.
            DO 30 K = 1,NA
               GOTIT = GOTIT .OR. (ANTNO.EQ.AN(K))
 30            CONTINUE
            IF (.NOT.GOTIT) IRET = -1
            END IF
C                                       Is this record selected ?
         IF (IRET.LT.0) THEN
            REFMT = .TRUE.
C                                       Re-number IF's
         ELSE
            DO 50 JIF = 1,NEWNIF
               IIF = JIF + BIF - 1
               DO 40 IPOL = 1,NEWPOL
                  K = IPOL + LBPOL - 1
                  LOOFF(IPOL,JIF) = LOOFF(K,IIF)
                  DLOOFF(IPOL,JIF) = DLOOFF(K,IIF)
 40               CONTINUE
 50            CONTINUE
C
            IF (FREQID.GT.0) FQID = 1
            IF (JSUB.GE.0) SUBA = JSUB
            CALL MCTAB ('WRIT', OBUFF, OMCRNO, MCKOLO, MCNUMO, NEWPOL,
     *         NEWNIF, TIME, SOURID, ANTNO, SUBA, FQID, ATMOS, DATMOS,
     *         GDELAY, GRATE, CLOCK, DCLOCK, LOOFF, DLOOFF, DISP, DDISP,
     *         IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRIT', OMCRNO
               GO TO 990
               END IF
            END IF
 100     CONTINUE
      IRET = 0
C                                       Close both tables
      CALL TABIO ('CLOS', 0, IMCRNO, BUFFER, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OMCRNO, OBUFF, OBUFF, IRET)
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         IF (REFMT) THEN
            WRITE (MSGTXT,1100) 'Reformatted MC', DISKI, CNOI, VER,
     *         DISKO, CNOO, OVER
         ELSE
            WRITE (MSGTXT,1100) 'Copied MC', DISKI, CNOI, VER, DISKO,
     *         CNOO, OVER
            END IF
         CALL MSGWRT (3)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MCSEL: ERROR ',I3,1X,A,'ING TABLE ROW',I8)
 1010 FORMAT ('MCSEL: ERROR ',I3,' INITING OLD TABLE')
 1020 FORMAT ('MCSEL: ERROR ',I3,' INITING NEW TABLE')
 1100 FORMAT (A,' file from vol/cno/vers',I3,I5,I4,' to',I3,I5,I4)
      END

LOCAL INCLUDE 'DESCM.INC'
C                                       Local include for DESCM
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   SEQIN, SEQ2, SEQOUT, DISKIN, DISK2, DISKO, NUMHIS,
     *   JBUFSZ
      REAL      XSIN, XDISIN, XSOUT, XDISO, XBITER, XNIT, XINC,
     *   BUFF1(UVBFSS), BUFF2(UVBFSS)
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      CHARACTER HISCRD(10)*64, NAMEIN*12, CLAIN*12, NAMOUT*12, CLAOUT*6
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XCLAOU,
     *   XSOUT, XDISO, XBITER, XNIT, XINC, SEQIN, SEQ2, SEQOUT, DISKIN,
     *   DISK2, DISKO, NUMHIS
      COMMON /CHRCOM/ HISCRD, NAMEIN, CLAIN, NAMOUT, CLAOUT
LOCAL END
      PROGRAM DESCM
C-----------------------------------------------------------------------
C! Descimate a uv data file
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2000, 2008, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DESCM descimates a uv data set, copies every XINC th point to
C   the output file.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      BITER          XBITER        First visibility to copy.
C      NITER          XNIT          Last visibility to consider.
C      XINC           XINC          Copy every XINC th point.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'DESCM.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'DESCM '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file.
      CALL DESCIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Descimate
      CALL DESCUV (IRET)
      IF (IRET.EQ.0) CALL DESCHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE DESCIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   DESCIN gets input parameters for DESCM and creates an output file
C   if necessary.
C   Inputs:  PRGN    C*6       Program name
C   Output:  JERR    I         Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in DESCM for more details.
C-----------------------------------------------------------------------
      CHARACTER   STAT*4, PRGN*6, BLANK*6, UTYPE*2
      INTEGER   JERR, IROUND, NPARM, IERR, BITER, NITER, I4TEMP, OLDCNO
      LOGICAL   T
      INCLUDE 'DESCM.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK /' '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 17
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Convert integers
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Set defaults
      IF (XBITER.LE.0.0) XBITER = 1.0
      IF (XNIT.LE.0.0) XNIT = NVIS
      IF (XINC.LE.0.0) XINC = 1.0
C                                       Change file size
      BITER = XBITER + 0.1
      NITER = XNIT + 0.1
      I4TEMP = (NITER-BITER+1) / XINC + 1000
      IF (I4TEMP.LT.CATBLK(KIGCN)) CATBLK(KIGCN) = I4TEMP
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         ELSE IF ((CCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
C                                       Recover existing CATBLK
         ELSE
            FRW(NCFILE+1) = 2
            CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', BUFF1,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1065) IERR
               CALL MSGWRT (6)
               END IF
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                        Put input file in READ
      UTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DESCIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('DESCIN: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE DESCUV (IRET)
C-----------------------------------------------------------------------
C   DESCUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER PHNAME*48
      INTEGER   IRET, INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO,
     *   LRECO, ILENBU, KBIND, NIOUT, NIOLIM, IBIND, I, VO, BO, NUMVIS,
     *   XCOUNT, NITER, BITER, NUMBER, VOI
      LOGICAL   T, F
      INCLUDE 'DESCM.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNI, LUNO /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, PHNAME, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, PHNAME, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, PHNAME, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, PHNAME, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
C                                       LRECO = length of output rec.
      LRECO = LREC
      ILENBU = 0
      NITER = XNIT + 0.1
      BITER = XBITER + 0.1
      NUMBER = NITER - BITER + 1
      CALL UVINIT ('WRIT', LUNO, INDO, NUMBER, VO, LRECO, ILENBU,
     *   JBUFSZ, BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      VOI = BITER - 1
      CALL UVINIT ('READ', LUNI, INDI, NUMBER, VOI, LREC, ILENBU,
     *   JBUFSZ, BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       Loop
C                                       Read vis. record.
 100  CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
      ELSE IF (INIO.GT.0) THEN
         IPTRI = IBIND
         DO 190 I = 1,INIO
            NUMVIS = NUMVIS + 1
C                                      Call user routine.
            CALL DESCDO (NUMVIS, IRET)
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
C                                       Copy to output.
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1
               CALL RCOPY (LREC, BUFF1(IPTRI), BUFF2(IPTRO))
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               END IF
C                                       OK, but no output please
            IPTRI = IPTRI + LREC
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
         GO TO 100
         END IF
C                                       Final call to DESCDO.
         NUMVIS = -1
         CALL DESCDO (NUMVIS, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
            END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DESCUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1010 FORMAT ('DESCUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1020 FORMAT ('DESCUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('DESCUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('DESCUV: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('DESCUV: DESCDO ERROR',I3)
 1150 FORMAT ('DESCUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE DESCHI
C-----------------------------------------------------------------------
C   DESCHI copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP(1)*2, LABEL*8, HILINE*72
      INTEGER   LUN1, LUN2, IERR, NONOT, I
      LOGICAL   T
      INCLUDE 'DESCM.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NONOT, NOTTYP /1,'NX'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 20
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       Write input parms.
C                                       BITER
      WRITE (HILINE,2001) TSKNAM, XBITER
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       NITER
      WRITE (HILINE,2002) TSKNAM, XNIT
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       XINC
      WRITE (HILINE,2003) TSKNAM, XINC
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                      Add any user supplied history.
      IF (NUMHIS.GT.0) THEN
         WRITE (LABEL,1010) TSKNAM
         DO 15 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 20
 15         CONTINUE
         END IF
C                                       Close HI file
 20   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO,
     *   FCNO(2), FCNO(1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1019)
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST', BUFF1,
     *   IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DESCHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,' /')
 1019 FORMAT ('FUGHIS: ERROR COPYING TABLES')
 2001 FORMAT (A6,' BITER =',F15.0,' /First visibility')
 2002 FORMAT (A6,' NITER =',F15.0,' /Last visibility')
 2003 FORMAT (A6,' XINC =',F10.0,' /Vis. increment')
      END
      SUBROUTINE DESCDO (NUMVIS, IRET)
C-----------------------------------------------------------------------
C   This routine decides if a data point meets the selection criterion
C   Inputs:
C      NUMVIS     I    Visibility number, -1 => final call, no data
C                      passed but allows any operations to be completed.
C   Inputs from COMMON
C      XINC       R    Number of points to skip
C   Output:
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C   Output in COMMON
C      NUMHIS     I    # history entries (max. 10)
C      HISCRD(NUMHIS) C   History records
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IRET
C
      INTEGER   COUNT, YI, YT
      INCLUDE 'DESCM.INC'
      INCLUDE 'INCS:DMSG.INC'
      SAVE COUNT, YI
C-----------------------------------------------------------------------
C                                       First call
      IF (NUMVIS.EQ.1) THEN
         COUNT = 0
         YI = XINC + 0.01
         END IF
C                                       Subsequent calls.
      IF (NUMVIS.GT.0) THEN
         YT = NUMVIS
         IRET = -1
         IF (((YT/YI)*YI).EQ.YT) IRET = 0
         IF (IRET.EQ.0) COUNT = COUNT + 1
C                                       Last call
      ELSE
         IRET = 0
         WRITE (HISCRD(1),2000) COUNT
         NUMHIS = 1
         WRITE (MSGTXT,2000) COUNT
         CALL MSGWRT (5)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 2000 FORMAT (I10,' Vis. copied')
      END

      PROGRAM PP
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2004, 2012, 2020-2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Program to preprocess AIPS standard Fortran files into files for the
C   local Fortran compiler.  It assumes that the files are assigned to
C   the logical names PPINFIL and PPOUTFIL.  At present, PP does:
C         (1) Locate INCLUDE statements and insert the text
C         (2) Substitue REAL for HOLLERITH declarations
C         (3) Carry and insert LOCAL INCLUDE sections from the
C             beginning of the file to the places specified
C         (4) Allow a 2nd level of include
C         (5) Ignore includes if already included once in this routine
C   PP is deliberately "dumb", requiring the INCLUDE, SUBROUTINE, and
C   various FUNCTION statements to begin in column 7.
C   Version for UNIX
C-----------------------------------------------------------------------
      INTEGER   MXNLIN, MXINCN, MXINCL
      PARAMETER (MXNLIN = 3000)
      PARAMETER (MXINCN = 30)
      PARAMETER (MXINCL = 300)
C
      CHARACTER INCBUF(MXNLIN)*72, INCNAM(MXINCN)*20, ALRINC(MXINCL)*20,
     *   STDINC(10)*20, STDUPL(5)*20, LINT*10
      INTEGER   ILN(MXNLIN), ILB(MXINCN), ILE(MXINCN), ILT(MXINCN),
     *   NALR, NLI, NSTD, NSTDUP, NLIN, ADDRSZ
      COMMON /PPCHAR/ INCBUF, INCNAM, ALRINC, STDINC, STDUPL, LINT
      COMMON /PPARMS/ ILN, ILB, ILE, ILT, NALR, NLI, NSTD, NSTDUP, NLIN
C
      CHARACTER INLINE*72, OUTLIN*72, INFIL*20, TFIL*20, MSG*80,
     *   LOGNAM*8, ARCH*8
      INTEGER   I1, I2, IL, INDEX, ITRIM, IRET, I, IERR, J1, J2, ILEN,
     *   LLEN, XLEN, XLNB
      LOGICAL   KEEP, ALLOW
C-----------------------------------------------------------------------
C                                       special data initialization
C                                       allow these multiple times
      NSTDUP = 2
      STDUPL(1) = 'ZVD.INC'
      STDUPL(2) = 'ZVND.INC'
C                                       suck these to memory asap
      NSTD = 5
      STDINC(1) = 'DMSG.INC'
      STDINC(2) = 'DDCH.INC'
      STDINC(3) = 'DFIL.INC'
      STDINC(4) = 'DUVH.INC'
      STDINC(5) = 'DHDR.INC'
      IRET = 8
      DO 5 I = 1,MXINCN
         ILB(I) = 0
         ILE(I) = 0
         ILT(I) = 0
 5       CONTINUE
      NLI = 0
      NLIN = 0
      NALR = 0
C                                       how big is an address variable
      CALL ZADRSZ (ADDRSZ)
C                                       get $ARCH
      LOGNAM = 'ARCH:'
      LLEN = LEN (LOGNAM)
      XLEN = LEN (ARCH)
      CALL ZTRLOG (LLEN, LOGNAM, XLEN, ARCH, XLNB, IERR)
      IF (IERR.EQ.0) THEN
         ARCH = ' '
         END IF
      IF ((ARCH(:2).EQ.'HP') .OR. (ADDRSZ.LE.4)) THEN
         LINT = 'INTEGER'
      ELSE
         LINT = 'INTEGER*8'
         END IF
C                                       Open the input file
      CALL PPOPEN (15, 'PPINFIL:', 'READ', IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Open the output file
      CALL PPOPEN (16, 'PPOUTFIL:', 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 910
C                                       main file read loop
 10   CONTINUE
         READ (15,1010,END=800,ERR=920) INLINE
         ILEN = ITRIM (INLINE)
         IF (ILEN.EQ.0) GO TO 10
C                                       Substitute for HOLLERITH
C                                       Allow for lowercase too (ATNF)
         IF (INLINE(7:16).EQ.'hollerith ') INLINE(7:16) = 'REAL     '
         IF (INLINE(7:16).EQ.'HOLLERITH ') INLINE(7:16) = 'REAL     '
         IF (INLINE(7:16).EQ.'longint   ') INLINE(7:16) = LINT
         IF (INLINE(7:16).EQ.'LONGINT   ') INLINE(7:16) = LINT
C                                       Write all but INCLUDEs
C                                       ATNF only: uppercase includes.
C        IF (INLINE(7:13).EQ.'include') CALL UPCASE (INLINE)
C                                       Check for start of subroutine
         IF (INLINE(:6).EQ.' ') THEN
            IF (INLINE(7:16).EQ.'BLOCK DATA') NALR = 0
            IF (INLINE(7:16).EQ.'SUBROUTINE') NALR = 0
            IF (INLINE(7:14).EQ.'FUNCTION') NALR = 0
            IF (INLINE(7:19).EQ.'REAL FUNCTION') NALR = 0
            IF (INLINE(7:22).EQ.'INTEGER FUNCTION') NALR = 0
            IF (INLINE(7:22).EQ.'LOGICAL FUNCTION') NALR = 0
            IF (INLINE(7:31).EQ.'DOUBLE PRECISION FUNCTION') NALR = 0
            END IF
C                                       Simple write out of line
         IF ((INLINE(7:13).NE.'INCLUDE') .OR. (INLINE(:1).EQ.'C')
     *      .OR. (INLINE(7:17).EQ.'INCLUDE ''($')) THEN
            WRITE (16,1010,ERR=930) INLINE(:ILEN)
            GO TO 10
            END IF
C                                       Include: dig out name
 15      OUTLIN = INLINE(14:72)
         I1 = INDEX (OUTLIN, '''')
         I1 = I1 + 1
         I2 = INDEX (OUTLIN(I1:72), '''')
C                                       problem with INCL statement
         IF (I2.LE.0) THEN
            MSG = 'WARNING - PROBLEM PARSING INCLUDE CARD:'
            WRITE (6,1000) MSG(1:ITRIM(MSG))
            MSG = INLINE(:ILEN)
            WRITE (6,1000) MSG(1:ITRIM(MSG))
            WRITE (16,1010,ERR=930) INLINE(:ILEN)
            GO TO 10
            END IF
         I2 = I2 + I1 - 2
         INFIL = OUTLIN(I1:I2)
C                                       LOCAL INCL declaration?
 20      IF (INLINE(1:6).EQ.'LOCAL ') THEN
C                                       No logical names allowed
            IF (INDEX(INFIL,':').GT.0) THEN
               MSG = 'LOGICAL NOT ALLOWED IN LOCAL INCLUDE NAME:'
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               MSG = INFIL
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               GO TO 965
               END IF
C                                       No repeat declarations
            DO 25 I = 1,NLI
               IF (INFIL.EQ.INCNAM(I)) THEN
                  MSG = 'LOCAL INCLUDE NAME ALREADY DEFINED:'
                  WRITE (6,1000) MSG(1:ITRIM(MSG))
                  MSG = INFIL
                  WRITE (6,1000) MSG(1:ITRIM(MSG))
                  GO TO 965
                  END IF
 25            CONTINUE
            IF (NLI.EQ.MXINCN) THEN
               WRITE (6,1025) MXINCN
               MSG = INFIL
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               GO TO 965
               END IF
            NLI = NLI + 1
            ILB(NLI) = NLIN + 1
            ILT(NLI) = 1
            INCNAM(NLI) = INFIL
C                                       read Local Inc loop
 30         CONTINUE
               READ (15,1010,END=800,ERR=920) INLINE
               ILEN = ITRIM (INLINE)
               IF ((ILEN.GT.0) .AND. (INLINE(:2).NE.'C;')) THEN
C                                       end of local include?
                  IF (INLINE(1:6).EQ.'LOCAL ' .OR.
     *               INLINE(1:6).EQ.'local ') THEN
                     ILE(NLI) = NLIN
                     IF ((INLINE(7:13).EQ.'INCLUDE') .AND.
     *                  (INLINE(1:1).NE.'C') .AND.
     *                  (INLINE(7:17).NE.'INCLUDE ''($')) GO TO 15
                     GO TO 10
                     END IF
                  IF (NLIN.EQ.MXNLIN) THEN
                     WRITE (6,1030) MXNLIN
                     MSG = INFIL
                     WRITE (6,1000) MSG(1:ITRIM(MSG))
                     GO TO 965
                     END IF
                  NLIN = NLIN + 1
                  IF ((INLINE(7:16).EQ.'hollerith ') .OR.
     *               (INLINE(7:16).EQ.'HOLLERITH '))
     *               INLINE(7:16) = 'REAL '
                  IF ((INLINE(7:16).EQ.'longint   ') .OR.
     *               (INLINE(7:16).EQ.'LONGINT   '))
     *               INLINE(7:16) = LINT
                  INCBUF(NLIN) = INLINE
                  ILN(NLIN) = ILEN
                  END IF
               GO TO 30
C                                       Include something
         ELSE
            I1 = INDEX (INFIL, ':')
            I1 = I1 + 1
            TFIL = INFIL(I1:20)
C                                       Already included?
            IF (NALR.GT.0) THEN
               DO 35 I = 1,NALR
                  IF (TFIL.EQ.ALRINC(I)) THEN
                     INLINE(:1) = 'C'
                     INLINE(7:13) = 'SKIPPED'
                     WRITE (16,1010,ERR=930) INLINE(1:ILEN)
                     GO TO 10
                     END IF
 35               CONTINUE
               END IF
C                                       Duplication allowed?
            ALLOW = .FALSE.
            DO 36 I = 1,NSTDUP
               IF (TFIL.EQ.STDUPL(I)) ALLOW = .TRUE.
 36            CONTINUE
            IF (.NOT.ALLOW) THEN
               IF (NALR.GE.MXINCL) THEN
                  WRITE (6,1035) MXINCL
                  MSG = INFIL
                  WRITE (6,1000) MSG(1:ITRIM(MSG))
                  GO TO 965
                  END IF
               NALR = NALR + 1
               ALRINC(NALR) = TFIL
               END IF
C                                       is it in local list?
            I2 = 0
            DO 40 I = 1,NLI
               IF (TFIL.EQ.INCNAM(I)) I2 = I
 40            CONTINUE
C                                       Yes - dump local from memory
            IF (I2.GT.0) THEN
C                                       warn if logical name
               IF ((I1.NE.1) .AND. (ILT(I2).NE.2)) THEN
                  MSG = 'WARNING - SUBSTITUTED LOCAL INCLUDE FOR:'
                  WRITE (6,1000) MSG(1:ITRIM(MSG))
                  MSG = INFIL
                  WRITE (6,1000) MSG(1:ITRIM(MSG))
                  END IF
C                                       write INCL line as Comment
               INLINE(1:1) = 'C'
               WRITE (16,1010,ERR=930) INLINE(1:ILEN)
               J1 = ILB(I2)
               J2 = ILE(I2)
               DO 50 I = J1,J2
                  IL = ILN(I)
                  CALL OUT2 (IL, INCBUF(I), IERR)
                  IF (IERR.NE.0) GO TO 930
 50               CONTINUE
C                                       No - get external file
            ELSE
               IF (INFIL(1:5).NE.'INCS:') THEN
                  MSG = 'WARNING - NON-STANDARD INCLUDE USED:'
                  WRITE (6,1000) MSG(1:ITRIM(MSG))
                  MSG = INFIL
                  WRITE (6,1000) MSG(1:ITRIM(MSG))
                  END IF
C                                       write INCL line as Comment
               INLINE(1:1) = 'C'
               WRITE (16,1010,ERR=930) INLINE(1:ILEN)
C                                       open INCL file
               CALL PPOPEN (17, INFIL, 'READ', IERR)
               IF (IERR.NE.0) GO TO 940
               KEEP = .FALSE.
               DO 55 I = 1,NSTD
                  IF (STDINC(I).EQ.TFIL) KEEP = .TRUE.
 55               CONTINUE
               IF (NLI.GE.MXINCN-1) KEEP = .FALSE.
               IF (NLIN.GE.MXNLIN-150) KEEP = .FALSE.
               IF (KEEP) THEN
                  NLI = NLI + 1
                  ILB(NLI) = NLIN + 1
                  ILT(NLI) = 2
                  INCNAM(NLI) = TFIL
                  END IF
C                                       read INCL file loop
 60            CONTINUE
                  READ (17,1010,END=65,ERR=950) OUTLIN
                  ILEN = ITRIM (OUTLIN)
                  IF ((ILEN.GT.0) .AND. (OUTLIN(:2).NE.'C;')) THEN
                     IF ((OUTLIN(7:16).EQ.'hollerith ') .OR.
     *                  (OUTLIN(7:16).EQ.'HOLLERITH '))
     *                   OUTLIN(7:16) = 'REAL'
                     IF ((OUTLIN(7:16).EQ.'longint   ') .OR.
     *                  (OUTLIN(7:16).EQ.'LONGINT   '))
     *                   OUTLIN(7:16) = LINT
                     IF (KEEP) THEN
                        NLIN = NLIN + 1
                        INCBUF(NLIN) = OUTLIN
                        ILN(NLIN) = ILEN
                        END IF
                     CALL OUT2 (ILEN, OUTLIN, IERR)
                     IF (IERR.NE.0) GO TO 955
                     END IF
                  GO TO 60
 65            CLOSE (UNIT=17)
               IF (KEEP) ILE(NLI) = NLIN
               END IF
C                                       return to read loop
            GO TO 10
            END IF
C                                       write the line
C                                       normal EOF
 800  IRET = 1
      GO TO 965
C                                       Errors:
C                                       open input
 900  MSG = 'CAN''T OPEN THE INPUT FILE'
      WRITE (6,1000) MSG(1:ITRIM(MSG))
      GO TO 999
C                                       open output
 910  MSG = 'CAN''T OPEN THE OUTPUT FILE'
      WRITE (6,1000) MSG(1:ITRIM(MSG))
      GO TO 970
C                                       read input
 920  MSG = 'CAN''T READ THE INPUT FILE'
      WRITE (6,1000) MSG(1:ITRIM(MSG))
      GO TO 965
C                                       write output
 930  MSG = 'CAN''T WRITE THE OUTPUT FILE'
      WRITE (6,1000) MSG(1:ITRIM(MSG))
      GO TO 965
C                                       open incl
 940  MSG = 'CAN''T OPEN INCL FILE ' // INFIL
      WRITE (6,1000) MSG(1:ITRIM(MSG))
      GO TO 965
C                                       Read incl
 950  MSG = 'CAN''T READ INCL FILE ' // INFIL
      WRITE (6,1000) MSG(1:ITRIM(MSG))
      GO TO 960
C                                       write output in incl section
 955  MSG = 'CAN''T WRITE INCLUDE TO THE OUTPUT FILE'
      WRITE (6,1000) MSG(1:ITRIM(MSG))
C                                       closes
 960  CLOSE (UNIT=17,STATUS='KEEP')
 965  CLOSE (UNIT=16,STATUS='KEEP')
 970  CLOSE (UNIT=15,STATUS='KEEP')
      GO TO 999
C
 999  IF (IRET.GT.1) CALL ZEXIT (IRET)
      STOP
C-----------------------------------------------------------------------
 1000 FORMAT (' PP(    ): ',A)
 1010 FORMAT (A)
 1025 FORMAT (' PP LOCAL INCLUDE NAME LIST TOO LONG (>',I2,') AT:')
 1030 FORMAT (' PP LOCAL INCLUDE LIST TOO LONG (>',I5,
     *   ' LINES) AT NAME:')
 1035 FORMAT (' PP TOO MANY (>',I4,') INCLUDES AT NAME:')
      END
      SUBROUTINE OUT2 (ILEN, OUTLIN, IERR)
C-----------------------------------------------------------------------
C   writes out the specified line except if it's an INCLUDE.  In that
C   case it does the full (2nd-level) include.  This is only called when
C   we are already writing out an INCLUDE at first level.
C-----------------------------------------------------------------------
      INTEGER   ILEN, IERR
      CHARACTER OUTLIN*(*)
C
      INTEGER   MXNLIN, MXINCN, MXINCL
      PARAMETER (MXNLIN = 3000)
      PARAMETER (MXINCN = 30)
      PARAMETER (MXINCL = 300)
C
      CHARACTER INCBUF(MXNLIN)*72, INCNAM(MXINCN)*20, ALRINC(MXINCL)*20,
     *   STDINC(10)*20, STDUPL(5)*20, LINT*10
      INTEGER   ILN(MXNLIN), ILB(MXINCN), ILE(MXINCN), ILT(MXINCN),
     *   NALR, NLI, NSTD, NSTDUP, NLIN
      COMMON /PPCHAR/ INCBUF, INCNAM, ALRINC, STDINC, STDUPL, LINT
      COMMON /PPARMS/ ILN, ILB, ILE, ILT, NALR, NLI, NSTD, NSTDUP, NLIN
C
      CHARACTER INLINE*72, INFIL*20, TFIL*20, TMPLIN*72, MSG*72
      INTEGER   I1, I2, IL, INDEX, ITRIM, I, J1, J2
      LOGICAL   KEEP, ALLOW
C-----------------------------------------------------------------------
      IERR = 0
C                                       simple output
      IF ((OUTLIN(7:13).NE.'INCLUDE') .OR. (OUTLIN(:1).EQ.'C')
     *      .OR. (INLINE(7:17).EQ.'INCLUDE ''($')) THEN
         IF (ILEN.GT.0) WRITE (16,1010,ERR=930) OUTLIN(:ILEN)
C                                       a 2nd-level include
      ELSE
         INLINE = OUTLIN
C                                       Not local INCLUDE declaration
         IF (INLINE(:5).EQ.'LOCAL') THEN
            MSG = 'LOCAL INCLUDE DECLARATION NOT ALLOWED IN AN INCLUDE'
            WRITE (6,1000) MSG(1:ITRIM(MSG))
            GO TO 990
            END IF
C                                       get include name
         TMPLIN = INLINE(14:72)
         I1 = INDEX (TMPLIN, '''')
         I1 = I1 + 1
         I2 = INDEX (TMPLIN(I1:72), '''')
         IF (I2.LE.0) THEN
            MSG = 'PROBLEM PARSING INCLUDE CARD:'
            WRITE (6,1000) MSG(1:ITRIM(MSG))
            MSG = INLINE(1:ILEN)
            WRITE (6,1000) MSG(1:ITRIM(MSG))
            GO TO 990
            END IF
         I2 = I2 + I1 - 2
         INFIL = TMPLIN(I1:I2)
         I1 = INDEX (INFIL, ':')
         I1 = I1 + 1
         TFIL = INFIL(I1:20)
C                                       Already included?
         IF (NALR.GT.0) THEN
            DO 10 I = 1,NALR
               IF (TFIL.EQ.ALRINC(I)) THEN
                  INLINE(:1) = 'C'
                  INLINE(7:13) = 'SKIPPED'
                  WRITE (16,1010,ERR=930) INLINE(1:ILEN)
                  GO TO 999
                  END IF
 10            CONTINUE
            END IF
C                                       Duplication allowed?
         ALLOW = .FALSE.
         DO 15 I = 1,NSTDUP
            IF (TFIL.EQ.STDUPL(I)) ALLOW = .TRUE.
 15         CONTINUE
         IF (.NOT.ALLOW) THEN
            IF (NALR.GE.MXINCL) THEN
               MSG = 'MAX NUMBER OF INCLUDES EXCEEDED AT'
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               MSG = INLINE(1:ILEN)
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               IERR = 2
               GO TO 999
               END IF
            NALR = NALR + 1
            ALRINC(NALR) = TFIL
            END IF
C                                       is it in local list?
         I2 = 0
         DO 20 I = 1,NLI
            IF (TFIL.EQ.INCNAM(I)) I2 = I
 20         CONTINUE
C                                       Yes - dump local from memory
         IF (I2.GT.0) THEN
C                                       warn if logical name
            IF ((I1.NE.1) .AND. (ILT(I2).NE.2)) THEN
               MSG = 'SUBSTITUTED LOCAL INCLUDE FOR:'
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               MSG = INFIL
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               END IF
C                                       write INCL line as Comment
            INLINE(1:1) = 'C'
            WRITE (16,1010,ERR=930) INLINE(1:ILEN)
            J1 = ILB(I2)
            J2 = ILE(I2)
            DO 30 I = J1,J2
               IL = ILN(I)
               CALL OUT3 (IL, INCBUF(I), IERR)
               IF (IERR.NE.0) GO TO 930
 30            CONTINUE
C                                       No - get external file
         ELSE
            IF (INFIL(1:5).NE.'INCS:') THEN
               MSG = 'WARNING - NON-STANDARD INCLUDE USED:'
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               MSG = INFIL
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               END IF
C                                       write INCL line as Comment
            INLINE(1:1) = 'C'
            WRITE (16,1010,ERR=930) INLINE(1:ILEN)
C                                       open INCL file
            CALL PPOPEN (18, INFIL, 'READ', IERR)
            IF (IERR.NE.0) THEN
               MSG = 'CAN''T OPEN INCLUDE FILE ' // INFIL
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               GO TO 999
               END IF
            KEEP = .FALSE.
            DO 35 I = 1,NSTD
               IF (STDINC(I).EQ.TFIL) KEEP = .TRUE.
 35            CONTINUE
            IF (NLI.GE.MXINCN-1) KEEP = .FALSE.
            IF (NLIN.GE.MXNLIN-150) KEEP = .FALSE.
            IF (KEEP) THEN
               NLI = NLI + 1
               ILB(NLI) = NLIN + 1
               ILT(NLI) = 2
               INCNAM(NLI) = TFIL
               END IF
C                                       read INCL file loop
 40         CONTINUE
               READ (18,1010,END=50,ERR=950) INLINE
               ILEN = ITRIM (INLINE)
               IF ((ILEN.GT.0) .AND. (INLINE(:2).NE.'C;')) THEN
                  IF ((INLINE(7:16).EQ.'hollerith ') .OR.
     *               (INLINE(7:16).EQ.'HOLLERITH '))
     *               INLINE(7:16) = 'REAL'
                  IF ((INLINE(7:16).EQ.'longint   ') .OR.
     *               (INLINE(7:16).EQ.'LONGINT   '))
     *               INLINE(7:16) = LINT
                  IF (KEEP) THEN
                     NLIN = NLIN + 1
                     INCBUF(NLIN) = INLINE
                     ILN(NLIN) = ILEN
                     END IF
                  CALL OUT3 (ILEN, INLINE, IERR)
                  IF (IERR.NE.0) GO TO 955
                  END IF
               GO TO 40
 50         CLOSE (UNIT=18)
            IF (KEEP) ILE(NLI) = NLIN
            END IF
         END IF
      GO TO 999
C                                       errors
 930  IERR = 1
      MSG = 'ERROR WRITING INCLUDED LINE TO OUTPUT'
      GO TO 995
 950  IERR = 3
      MSG = 'ERROR READING 2ND-LEVEL INCLUDE FILE'
      CLOSE (UNIT=18)
      GO TO 995
 955  MSG = 'ERROR WRITING 2ND-LEVEL INCLUDE LINE TO OUTPUT'
      CLOSE (UNIT=18)
      GO TO 995
C
 990  MSG = 'CONTINUING ANYWAY'
 995  WRITE (6,1000) MSG(1:ITRIM(MSG))
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (' PP(OUT2): ',A)
 1010 FORMAT (A)
      END
      SUBROUTINE OUT3 (ILEN, OUTLIN, IERR)
C-----------------------------------------------------------------------
C   writes out the specified line except if it's an INCLUDE.  In that
C   case it does the full (3rd-level) include.  This is only called when
C   we are already writing out an INCLUDE at second level.
C-----------------------------------------------------------------------
      INTEGER   ILEN, IERR
      CHARACTER OUTLIN*(*)
C
      INTEGER   MXNLIN, MXINCN, MXINCL
      PARAMETER (MXNLIN = 3000)
      PARAMETER (MXINCN = 30)
      PARAMETER (MXINCL = 300)
C
      CHARACTER INCBUF(MXNLIN)*72, INCNAM(MXINCN)*20, ALRINC(MXINCL)*20,
     *   STDINC(10)*20, STDUPL(5)*20, LINT*10
      INTEGER   ILN(MXNLIN), ILB(MXINCN), ILE(MXINCN), ILT(MXINCN),
     *   NALR, NLI, NSTD, NSTDUP, NLIN
      COMMON /PPCHAR/ INCBUF, INCNAM, ALRINC, STDINC, STDUPL, LINT
      COMMON /PPARMS/ ILN, ILB, ILE, ILT, NALR, NLI, NSTD, NSTDUP, NLIN
C
      CHARACTER INLINE*72, INFIL*20, TFIL*20, TMPLIN*72, MSG*72
      INTEGER   I1, I2, IL, INDEX, ITRIM, I, J1, J2
      LOGICAL   KEEP, ALLOW
C-----------------------------------------------------------------------
      IERR = 0
C                                       simple output
      IF ((OUTLIN(7:13).NE.'INCLUDE') .OR. (OUTLIN(:1).EQ.'C')
     *      .OR. (INLINE(7:17).EQ.'INCLUDE ''($')) THEN
         IF (ILEN.GT.0) WRITE (16,1010,ERR=930) OUTLIN(:ILEN)
C                                       a 2nd-level include
      ELSE
         INLINE = OUTLIN
C                                       Not local INCLUDE declaration
         IF (INLINE(:5).EQ.'LOCAL') THEN
            MSG = 'LOCAL INCLUDE DECLARATION NOT ALLOWED IN AN INCLUDE'
            WRITE (6,1000) MSG(1:ITRIM(MSG))
            GO TO 990
            END IF
C                                       get include name
         TMPLIN = INLINE(14:72)
         I1 = INDEX (TMPLIN, '''')
         I1 = I1 + 1
         I2 = INDEX (TMPLIN(I1:72), '''')
         IF (I2.LE.0) THEN
            MSG = 'PROBLEM PARSING INCLUDE CARD:'
            WRITE (6,1000) MSG(1:ITRIM(MSG))
            MSG = INLINE(1:ILEN)
            WRITE (6,1000) MSG(1:ITRIM(MSG))
            GO TO 990
            END IF
         I2 = I2 + I1 - 2
         INFIL = TMPLIN(I1:I2)
            I1 = INDEX (INFIL, ':')
            I1 = I1 + 1
            TFIL = INFIL(I1:20)
C                                       Already included?
         IF (NALR.GT.0) THEN
            DO 10 I = 1,NALR
               IF (TFIL.EQ.ALRINC(I)) THEN
                  INLINE(:1) = 'C'
                  INLINE(7:13) = 'SKIPPED'
                  WRITE (16,1010,ERR=930) INLINE(1:ILEN)
                  GO TO 999
                  END IF
 10            CONTINUE
            END IF
C                                       Duplication allowed?
         ALLOW = .FALSE.
         DO 15 I = 1,NSTDUP
            IF (TFIL.EQ.STDUPL(I)) ALLOW = .TRUE.
 15         CONTINUE
         IF (.NOT.ALLOW) THEN
            IF (NALR.GE.MXINCL) THEN
               MSG = 'MAX NUMBER OF INCLUDES EXCEEDED AT'
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               MSG = INLINE(1:ILEN)
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               IERR = 2
               GO TO 999
               END IF
            NALR = NALR + 1
            ALRINC(NALR) = TFIL
            END IF
C                                       is it in local list?
         I2 = 0
         DO 20 I = 1,NLI
            IF (TFIL.EQ.INCNAM(I)) I2 = I
 20         CONTINUE
C                                       Yes - dump local from memory
         IF (I2.GT.0) THEN
C                                       warn if logical name
            IF ((I1.NE.1) .AND. (ILT(I2).NE.2)) THEN
               MSG = 'SUBSTITUTED LOCAL INCLUDE FOR:'
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               MSG = INFIL
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               END IF
C                                       write INCL line as Comment
            INLINE(1:1) = 'C'
            WRITE (16,1010,ERR=930) INLINE(1:ILEN)
            J1 = ILB(I2)
            J2 = ILE(I2)
            DO 30 I = J1,J2
               IL = ILN(I)
               WRITE (16,1010,ERR=930) INCBUF(I)(1:IL)
 30            CONTINUE
C                                       No - get external file
         ELSE
            IF (INFIL(1:5).NE.'INCS:') THEN
               MSG = 'WARNING - NON-STANDARD INCLUDE USED:'
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               MSG = INFIL
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               END IF
C                                       write INCL line as Comment
            INLINE(1:1) = 'C'
            WRITE (16,1010,ERR=930) INLINE(1:ILEN)
C                                       open INCL file
            CALL PPOPEN (19, INFIL, 'READ', IERR)
            IF (IERR.NE.0) THEN
               MSG = 'CAN''T OPEN INCLUDE FILE ' // INFIL
               WRITE (6,1000) MSG(1:ITRIM(MSG))
               GO TO 999
               END IF
            KEEP = .FALSE.
            DO 35 I = 1,NSTD
               IF (STDINC(I).EQ.TFIL) KEEP = .TRUE.
 35            CONTINUE
            IF (NLI.GE.MXINCN-1) KEEP = .FALSE.
            IF (NLIN.GE.MXNLIN-150) KEEP = .FALSE.
            IF (KEEP) THEN
               NLI = NLI + 1
               ILB(NLI) = NLIN + 1
               ILT(NLI) = 2
               INCNAM(NLI) = TFIL
               END IF
C                                       read INCL file loop
 40         CONTINUE
               READ (19,1010,END=50,ERR=950) INLINE
               ILEN = ITRIM (INLINE)
               IF ((ILEN.GT.0) .AND. (INLINE(:2).NE.'C;')) THEN
                  IF ((INLINE(7:16).EQ.'hollerith ') .OR.
     *               (INLINE(7:16).EQ.'HOLLERITH '))
     *               INLINE(7:16) = 'REAL'
                  IF ((INLINE(7:16).EQ.'longint   ') .OR.
     *               (INLINE(7:16).EQ.'LONGINT   '))
     *               INLINE(7:16) = LINT
                  IF (KEEP) THEN
                     NLIN = NLIN + 1
                     INCBUF(NLIN) = INLINE
                     ILN(NLIN) = ILEN
                     END IF
                  WRITE (16,1010,ERR=955) INLINE(1:ILEN)
                  END IF
               GO TO 40
 50         CLOSE (UNIT=19)
            IF (KEEP) ILE(NLI) = NLIN
            END IF
         END IF
      GO TO 999
C                                       errors
 930  IERR = 1
      MSG = 'ERROR WRITING INCLUDED LINE TO OUTPUT'
      GO TO 995
 950  IERR = 3
      MSG = 'ERROR READING 3rd-LEVEL INCLUDE FILE'
      CLOSE (UNIT=19)
      GO TO 995
 955  IERR = 1
      MSG = 'ERROR WRITING 3rd-LEVEL INCLUDE LINE TO OUTPUT'
      CLOSE (UNIT=19)
      GO TO 995
C
 990  MSG = 'CONTINUING ANYWAY'
 995  WRITE (6,1000) MSG(1:ITRIM(MSG))
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (' PP(OUT3): ',A)
 1010 FORMAT (A)
      END
      INTEGER FUNCTION ITRIM (STRING)
C-----------------------------------------------------------------------
C   Function to determine length of a string. I.e., it trims trailing
C   blanks. Use with calls like:
C         TRIMMED = GROSS(1:ITRIM(GROSS))
C-----------------------------------------------------------------------
      CHARACTER STRING*(*)
C-----------------------------------------------------------------------
      ITRIM = LEN (STRING) + 1
C                                       look backwards for non-blank
 10   CONTINUE
         ITRIM = ITRIM - 1
         IF (ITRIM.LT.1) GO TO 999
         IF (STRING(ITRIM:ITRIM).EQ.' ') GO TO 10
C
 999  RETURN
      END
      SUBROUTINE PPOPEN (LUN, FNAME, OPER, IERR)
C-----------------------------------------------------------------------
C   Opens files for pre-processor program PP
C   Inputs:
C      LUN    I       Desired logical unit number
C      FNAME  C*(*)   File name (logical:fname)
C      OPER   C*4     READ or WRIT.
C   Output:
C      IERR   I       Error code: 0 => okay
C                        2 => input error
C-----------------------------------------------------------------------
      INTEGER   LUN, IERR
      CHARACTER FNAME*(*), OPER*4
C
      CHARACTER DIREC*128, PATH*256, FILE*128
      INTEGER   ITRIM, I, J, IL, JERR
C-----------------------------------------------------------------------
      IERR = 2
      IF ((OPER.NE.'READ') .AND. (OPER.NE.'WRIT')) GO TO 999
      IF ((LUN.LT.10) .OR. (LUN.GT.50)) GO TO 999
      IL = ITRIM (FNAME)
      I = INDEX (FNAME, ' ')
      IF (I.LE.0) I = IL + 1
      IF ((IL.LE.0) .OR. (I.LE.IL)) GO TO 999
C                                       Build file name
      J = INDEX (FNAME(1:IL), ':')
C                                       No logical
      IF (J.LE.1) THEN
         PATH = FNAME(J+1:IL)
C                                       Translate logical
      ELSE
         DIREC = FNAME(1:J-1)
         FILE = ' '
         IF (J+1.LE.IL) FILE = FNAME(J+1:IL)
         I = ITRIM (DIREC)
         IL = ITRIM (FILE)
         IF (DIREC(1:I).EQ.'INCS') THEN
            CALL ZPPINC (IL, FILE, 256, PATH, JERR)
         ELSE
            CALL ZPPTRA (I, DIREC, IL, FILE, 256, PATH, JERR)
            END IF
         J = ITRIM (PATH)
         IF ((JERR.NE.0) .OR. (J.LE.0)) THEN
            WRITE (6,1000) DIREC(1:I)
            IERR = 1
            GO TO 999
            END IF
         END IF
C                                       Do open
      CALL ZPPOPN (LUN, PATH, OPER, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (' PPOPEN: CAN''T TRANSLATE LOGICAL = ',A)
      END
      SUBROUTINE ZPPINC (IL, INCFIL, IM, XLATED, IERR)
C-----------------------------------------------------------------------
C   ZPPINC finds the area containing the include file INCFIL and returns
C   the directory area to that file.  It must foillow the search tree
C   concept and take the lowest occurence for the local machine.
C   Inputs:
C      IL       I       Length of INCFIL
C      INCFIL   C*(*)   Include file name (e.g. DDCH.INC)
C      IM       I       Maximum length of output strinG
C   Output:
C      XLATED   C*IM    Translated file name
C      IERR     I       Error code: 1 => file not found
C                          3 directory tree error
C   UNIX version
C-----------------------------------------------------------------------
      INTEGER   IL, IM, IERR
      CHARACTER INCFIL*(*), XLATED*(*)
C
      INTEGER   NDIREC, I, J, K, LLEN, XLEN, XLNB, ITRIM
      LOGICAL   EXISTS
      CHARACTER LOGNAM*48, TEMP*128, DIREC(8)*128, PATH*128
C-----------------------------------------------------------------------
      IERR = 0
      LOGNAM = 'INCS:'
      LLEN = LEN (LOGNAM)
      XLEN = LEN (XLATED)
      CALL ZTRLOG (LLEN, LOGNAM, XLEN, XLATED, XLNB, IERR)
      IF (IERR.EQ.0) THEN
         NDIREC = 0
 10      I = INDEX (XLATED, ' ')
         IF (I.GT.1) THEN
            NDIREC = NDIREC + 1
            DIREC(NDIREC) = XLATED (:I)
            TEMP = XLATED(I+1:)
            XLATED = TEMP
            GO TO 10
            END IF
         IERR = 1
         DO 20 I = 1, NDIREC
            EXISTS = .FALSE.
            J = ITRIM (DIREC(I))
            PATH = DIREC(I)(1:J) // '/' // INCFIL
            K = ITRIM (PATH)
            INQUIRE (FILE=PATH(1:K), EXIST=EXISTS)
            IF (EXISTS) THEN
               XLATED = PATH(1:K)
               IERR = 0
               GO TO 999
               END IF
 20         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE ZPPTRA (ID, DIREC, IF, FILE, IM, XLATED, IERR)
C-----------------------------------------------------------------------
C   ZPPTRA finds the translation of the logical symbol DIREC and returns
C   it as the full directory name.
C   Inputs:
C      ID       I       Length of DIREC
C      DIREC    C*(*)   logical name
C      IF       I       Length of FILE
C      FILE     C*(*)   File name in DIREC
C      IM       I       Maximum length of output string
C   Output:
C      XLATED   C*IM    Translated file name - full path file name
C      IERR     I       Error code: 1 => file not found
C                          3 directory tree error
C   UNIX version
C-----------------------------------------------------------------------
      INTEGER   ID, IF, IM, IERR
      CHARACTER DIREC*(*), FILE*(*), XLATED*(*)
C
      INTEGER   I, LLEN, XLEN, XLNB, ITRIM
      CHARACTER LOGNAM*48
C-----------------------------------------------------------------------
      IERR = 0
      I = ITRIM (DIREC(1:ID))
      LOGNAM = DIREC(1:I) // ':'
      LLEN = LEN (LOGNAM)
      XLEN = LEN (XLATED)
      CALL ZTRLOG (LLEN, LOGNAM, XLEN, XLATED, XLNB, IERR)
      IF ((IERR.EQ.0) .AND. (IF.GT.0)) XLATED(XLNB+1:) = '/' //
     *   FILE(:IF)
C
 999  RETURN
      END
      SUBROUTINE ZPPOPN (LUN, PATH, OPER, IERR)
C-----------------------------------------------------------------------
C   ZPPOPN opens the requested file
C   Inputs:
C      LUN    I       Logical unit number
C      PATH   C*(*)   Full file name
C      OPER   C*4     READ or WRIT
C   Output:
C      IERR     I       Error code: 1 => file not found
C                          3 directory tree error
C   UNIX version
C-----------------------------------------------------------------------
      INTEGER   LUN, IERR
      CHARACTER PATH*(*), OPER*4
C
      INTEGER   I, ITRIM
C-----------------------------------------------------------------------
      I = ITRIM (PATH)
C                                       Read
      IF (OPER.EQ.'READ') THEN
         IERR = 1
         OPEN (UNIT=LUN, FILE=PATH(1:I), STATUS='OLD', ERR=900)
      ELSE IF (OPER.EQ.'WRIT') THEN
         IERR = 3
         OPEN (UNIT=LUN, FILE=PATH(1:I), ERR=900)
         REWIND (LUN)
      ELSE
         IERR = 2
         END IF
      IF (IERR.NE.2) IERR = 0
      GO TO 999
C                                       Error
 900  WRITE (6,*) ' ZPPOPN: ERROR ON PATH = ',PATH(1:I)
C
 999  RETURN
      END
      SUBROUTINE ZTRLOG (LLEN, LOGNAM, XLEN, XLATED, XLNB, IERR)
C-----------------------------------------------------------------------
C  Translate a logical name (i.e., environment variable).
C  Inputs:
C     LLEN     I          Length of LOGNAM (1-relative)
C     LOGNAM   C*(LLEN)   Logical name
C     XLEN     I          Length of XLATED (1-relative)
C  Output:
C     XLATED   C*(XLEN)   Translation (blank filled)
C     XLNB     I          Position of last non-blank in XLATED
C                         (1-relative)
C     IERR     I          Error return code: 0 => no error
C                             1 => error
C  Generic version - calls ZTRLO2 with HOLLERITHs
C-----------------------------------------------------------------------
      INTEGER   LLEN, XLEN, XLNB, IERR
      CHARACTER LOGNAM*(*), XLATED*(*)
C
      REAL      HOGNAM(64), HLATED(64), HBLANK(1)
C-----------------------------------------------------------------------
       CALL CHR2H (4, '    ', 1, HBLANK)
       CALL RFILL (64, HBLANK(1), HOGNAM)
       CALL RFILL (64, HBLANK(1), HLATED)
       XLATED = ' '
       CALL CHR2H (LLEN, LOGNAM, 1, HOGNAM)
       CALL ZTRLO2 (LLEN, HOGNAM, XLEN, HLATED, XLNB, IERR)
       IF (XLNB.GT.0) CALL H2CHR (XLNB, 1, HLATED, XLATED)
C
 999  RETURN
      END
      SUBROUTINE RFILL (NREAL, CONST, AOUT)
C-----------------------------------------------------------------------
C   RFILL fills a real array with a constant
C   Inputs:
C      NREAL   I          Number of real variables to fill
C      CONST   R          Input constant
C   Output:
C      AOUT    R(NREAL)   Output array
C-----------------------------------------------------------------------
      REAL      CONST, AOUT(*)
      INTEGER   NREAL
C
      INTEGER   I
C-----------------------------------------------------------------------
      IF (NREAL.GT.0) THEN
         DO 10 I = 1,NREAL
            AOUT(I) = CONST
 10         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE CHR2H (NCH, ISTR, OUTPNT, OSTR)
C-----------------------------------------------------------------------
C   Convert a Fortran CHARACTER variable to an AIPS HOLLERITH string.
C   IF NCH > LEN (ISTR) then blank fill the rest.
C   Inputs:
C      NCH     I      Number of characters
C      ISTR    C*(*)  Input CHARACTER string
C      OUTPNT  I      Start position in output string
C   Output:
C      OSTR    H(*)   Output AIPS string
C-----------------------------------------------------------------------
      INTEGER   NCH, OUTPNT
      CHARACTER ISTR*(*)
      REAL      OSTR(*)
C
      INTEGER   NA, I, J1, J2, IT, NLEN
C-----------------------------------------------------------------------
      NLEN = LEN (ISTR)
      IF (NCH.LE.0) GO TO 999
         NA = MAX (1, OUTPNT)
         DO 10 I = 1,NCH
            J1 = (NA-1) / 4 + 1
            J2 = MOD (NA-1, 4) + 1
            IF (I.LE.NLEN) THEN
               IT = ICHAR (ISTR(I:I))
            ELSE
               IT = ICHAR (' ')
               END IF
            CALL ZPUTCH (IT, OSTR(J1), J2)
            NA = NA + 1
 10         CONTINUE
C
 999  RETURN
      END
      SUBROUTINE H2CHR (NCH, INPNT, ISTR, OSTR)
C-----------------------------------------------------------------------
C   Convert an AIPS HOLLERITH string to a Fortran CHARACTER variable.
C   Blank fills the full ISTR variable.
C   Inputs:
C      NCH    I       Number of characters
C      INPNT  I       Start position in input string
C      ISTR   H(*)    Input AIPS string
C   Output:
C      OSTR   C*(*)   Output CHARACTER string
C-----------------------------------------------------------------------
      INTEGER   NCH, INPNT
      REAL       ISTR(*)
      CHARACTER OSTR*(*)
C
      INTEGER   NA, I, J1, J2, IT, NLEN
C-----------------------------------------------------------------------
      NLEN = LEN (OSTR)
      OSTR = ' '
      IF (NCH.LE.0) GO TO 999
         NA = MAX (1, INPNT)
         NLEN = MIN (NLEN, NCH)
         DO 10 I = 1,NLEN
            J1 = (NA-1) / 4 + 1
            J2 = MOD (NA-1, 4) + 1
            CALL ZGETCH (IT, ISTR(J1), J2)
            OSTR(I:I) = CHAR (IT)
            NA = NA + 1
 10         CONTINUE
C
 999  RETURN
      END

      PROGRAM TASRT
C-----------------------------------------------------------------------
C! Sorts extention tables to a user specified order
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2009, 2011, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task TASRT Sorts AIPS extension tables.
C   Inputs:
C      AIPS Adverb   Prg. Name          Description
C      INNAME         NAME          File name.
C      INCLASS        CLASS         File class.
C      INSEQ          SEQ           File sequence number.
C      INDISK         DISK          Disk volumn on which file resides.
C      INEXT          TYPE          Table type (e.g. 'CC')
C      INVER          INVER         Input file version number
C      IN2VER         OUTVER        Output file version number
C      CPARM          KEY,FKEY      Keys & weights.
C                                   1,2=> col. & wt pri. key 1.
C                                   3,4=> col. & wt sec. key 1.
C                                   5,6=> col. & wt pri. key 2.
C                                   7,8=> col. & wt sec. key 2.
C      BADDISK        IBADD(10)     Disks to aviod for scratch.
C-----------------------------------------------------------------------
      CHARACTER NAME*12, CLASS*6, PTYPE*2, PRGM*6, TYPE*2
      HOLLERITH XNAME(3), XCLASS(2), XTYP(1)
      INTEGER   DISK, SEQ, USERID, INVER, OUTVER, KEY(2,2), NPARM, LUN,
     *   FIND, CNO,IROUND, IRET, TABUFF(512), I, CATBLK(256),
     *   BUFFER(256), KEYSUB(2,2)
      REAL   FKEY(2,2), CATR(256), XSEQ, XDISK, XVER, X2VER, CPARM(10),
     *   BADD(10)
      DOUBLE PRECISION    CATD(128)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      COMMON /INPARM/ XNAME, XCLASS, XSEQ, XDISK, XTYP, XVER, X2VER,
     *   CPARM, BADD
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK, CATR, CATD)
      DATA PRGM  /'TASRT '/
      DATA LUN /16/
      DATA KEYSUB /4*1/
C-----------------------------------------------------------------------
C                                       Init I/O, parameters
      NPARM = 30
      CALL SETUP (PRGM, NPARM, XNAME, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Set file info
      USERID = NLUSER
      SEQ = IROUND (XSEQ)
      DISK = IROUND (XDISK)
      CALL H2CHR (12, 1, XNAME, NAME)
      CALL H2CHR (6, 1, XCLASS, CLASS)
      CALL H2CHR (2, 1, XTYP, TYPE)
      PTYPE = '  '
      INVER = IROUND (XVER)
      OUTVER = IROUND (X2VER)
C                                       Open file and get CATBLK.
      CALL MAPOPN ('WRIT', DISK, NAME, CLASS, SEQ, PTYPE, USERID, LUN,
     *   FIND, CNO, CATBLK, BUFFER, IRET)
      IF (IRET.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (8)
         GO TO 990
C                                       Mark in /CFILES/
 10   NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 1
C                                       Close file, leave marked.
      CALL ZCLOSE (LUN, FIND, IRET)
      IF (IRET.EQ.0) GO TO 20
         WRITE (MSGTXT,1010) IRET
         CALL MSGWRT (6)
         GO TO 990
C                                       Get KEY and FKEY
 20   KEY(1,1) = IROUND (CPARM(1))
      KEY(2,1) = IROUND (CPARM(3))
      KEY(1,2) = IROUND (CPARM(5))
      KEY(2,2) = IROUND (CPARM(7))
      FKEY(1,1) = CPARM(2)
      FKEY(2,1) = CPARM(4)
      FKEY(1,2) = CPARM(6)
      FKEY(2,2) = CPARM(8)
C                                       BADDISK
      DO 50 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 50      CONTINUE
C                                       Sort
      CALL TABSRT (DISK, CNO, TYPE, INVER, OUTVER, KEY, KEYSUB, FKEY,
     *   TABUFF, CATBLK, IRET)
C                                       Write end message
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR:',I7,' OPENING FILE')
 1010 FORMAT ('ERROR:',I7,' CLOSING FILE')
      END

      SUBROUTINE ZSSSXF (OP, DAT, NBYTES, BUFFER, NSBYTE, IERR)
C-----------------------------------------------------------------------
C! write/read to/from the SUN-Screen-Server (TV) device
C# TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2011, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZSSSXF sends and receives data for the SunScreen Server via the
C   routine ZSSSX2.C.  The Fortran is to attach to the fortran common
C   FTAB and convert between local integer and 16-bit integer.
C   Inputs:
C      OP       I      XAS operation code number (see SSS.TXT)
C      DAT      I(4)   Basic data set
C      NBYTES   I      Number additional 8-bit bytes in BUFFER to send
C                      to XAS
C   In/out:
C      BUFFER   I(*)   Data buffer (n.b. treated as byte stream here -
C                      the data must be in FITS standard forms)
C   Output:
C      NSBYTE   I      Number 8-bit bytes of data returned from SSS in
C                      BUFFER
C      IERR     I      Error code: 0 => okay
C-----------------------------------------------------------------------
      INTEGER   OP, OPSWAP, DAT(4), NBYTES, BUFFER(*), NSBYTE, IERR
C
      INTEGER   DAT2(4), DATS(2), MOP(2)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (TVBROK.EQ.0) THEN
         CALL ZILI16 (4, DAT, 1, DAT2)
         MOP(1) = OP
         CALL ZILI16 (1, MOP, 1, DATS)
         OPSWAP = DATS(1)
         CALL ZSSSX2 (FTAB(TVIND+NMOFF), OP, OPSWAP, DAT2, NBYTES,
     *      BUFFER, NSBYTE, IERR)
         IF (IERR.EQ.333) TVBROK = IERR
         IF (IERR.EQ.444) TVBROK = IERR
C                                       TV connection NOT open
      ELSE IF (TVBROK.LT.0) THEN
         MSGTXT = 'TV CONNECTION not open'
C        CALL MSGWRT (6)
C                                       TV connection already broken
      ELSE
         MSGTXT = 'TV CONNECTION PREVIOUSLY BROKEN'
C        CALL MSGWRT (6)
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'FFT.INC'
      INCLUDE 'INCS:PMAD.INC'
C                                       Local include for FFT
      INTEGER   NX, NY, LUNMPR, LUNMPI, LUNWK1, WK1VOL, WK2VOL, JBUFSZ,
     *   SEQINR, SEQINI, SEQOUT, DISKR, DISKI, DISKO, CNOINR, CNOINI,
     *   CNOUTR, CNOUTI, IDIR, CATRE(256), CATIM(256), NINOUT, NWRK,
     *   ICENX, ICENY, NZ, ONEPLN
      LOGICAL   DOCMPX
      HOLLERITH XNAMER(3), XCLASR(2), XNAMEI(3), XCLASI(2), XNAMOU(3),
     *   XOPCOD(1)
      CHARACTER NAMER*12, CLASSR*6, NAMEI*12, CLASSI*6, NAMOUT*12,
     *   OPCODE*4
      REAL      XSR, XSI, XSO, XDR, XDI, XDO, BADD(10), XCEN, YCEN,
     *   BUFF1(MABFSL), BUFF2(MABFSL), BUFF3(MABFSL), BMUL(2*MAXIMG+20)
      CHARACTER WK1FIL*48, WK2FIL*48
      COMMON /FFTCOM/ CATRE, CATIM, XCEN, YCEN, DOCMPX, NX, NY, LUNMPR,
     *   LUNMPI, LUNWK1, WK1VOL, WK2VOL, JBUFSZ, ICENX, ICENY, CNOINR,
     *   CNOINI, CNOUTR, CNOUTI, NINOUT, NWRK, IDIR, NZ, ONEPLN
      COMMON /FFTCHR/ WK1FIL, WK2FIL, NAMER, CLASSR, NAMEI, CLASSI,
     *   NAMOUT, OPCODE
      COMMON /BUFRS/ BUFF1, BUFF2, BUFF3, BMUL
      COMMON /INPUTS/ XNAMER, XCLASR, XSR, XDR, XNAMEI, XCLASI, XSI,
     *   XDI, XNAMOU, XSO, XDO, XOPCOD, BADD, SEQINR, SEQINI, SEQOUT,
     *   DISKR, DISKI, DISKO
C                                                          End FFT
LOCAL END
      PROGRAM FFT
C-----------------------------------------------------------------------
C! Fourier transforms an image
C# Map AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2002, 2006, 2008, 2015, 2019-2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FFT fourier transforms a complex image and returns a complex image.
C   The imaginary part of the input may be set to zero using OPCODE
C   but if both parts are given they are in different files.  The
C   output is in two separate files whose CLASS indicates whether
C   they are the real or imaginary part and whether they are in the
C   UV or map plane.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMER        Name of input image.
C      INCLASS        CLASSR        Class of real part of input image.
C      INSEQ          SEQINR        Seq. of real part of input image.
C      INDISK         DISKR         Disk number of real part.
C      IN2NAME        NAMEI         Name of imag. part of input image.
C      IN2CLASS       CLASSI        Class of imag. part of input image.
C      IN2SEQ         SEQINI        Seq. no. of imag. part.
C      IN2DISK        DISKI         Vol. no. of imag. part.
C      OUTNAME        NAMOUT        Name of the output image.
C                                   Default is INNAME
C                                   CLASS='UVREAL','UVIMAG' or
C                                   'MAREAL','MAIMAG'
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      OPCODE         IDIR,DOCMPX   OPCODE:
C                                   'UVRE'  Real uv => CMPLX map
C                                   'UVCX'  CMPLX uv => CMPLX map
C                                   'MARE'  Real map => CMPLX uv
C                                   'MACX'  CMPLX map => CMPLX uv.
C                                   Default = 'MARE'
C      BADDISK(10)    IBAD(10)      Disks to avoid for scratch files
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, CATBLK(256)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'FFT.INC'
      INCLUDE 'INCS:DLOC.INC'
      COMMON /MAPHDR/ CATBLK
      DATA PRGM /'FFT   '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL FFTINI (PRGM, IRET)
C                                       Float input file(s).
      IF (IRET.EQ.0) CALL FILES (IRET)
C                                       Transform image.
      IF (IRET.EQ.0) CALL DOFFT (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Write history
      CALL FFTHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE FFTINI (PRGN, JERR)
C-----------------------------------------------------------------------
C   FFTINI gets input parameters for FFT and creates an output file
C   if necessary.
C   Inputs:  PRGN    C*6       Program name
C   Output:  JERR    I         Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPUTS/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in FFT for more details.
C-----------------------------------------------------------------------
      INTEGER   NOPS
      PARAMETER (NOPS=6)
C
      CHARACTER STAT*4, PRGN*6, CLASS*6, MTYPE*2, OPS(NOPS)*4,
     *   CLASR(2)*6, CLASI(2)*6, UU*4, VV*4, XX*4, YY*4, JY*8, JYPBM*8,
     *   CHTM12*12, CHTYP(4)*8
      HOLLERITH CATH(256), CATREH(256), CATIMH(256)
      INTEGER   JERR
      INTEGER   CATBLK(256), JDIR(NOPS), II, NPARM, IDEPTH(5), I, J,
     *   IROUND, IERR, NAX
      LOGICAL   T, EQUAL, DCPX(NOPS), NOSWAP
      REAL      CATR(256), CATRER(256), CATIMR(256), XREF1, XREF2, TEMP,
     *   CHCIC(4)
      DOUBLE PRECISION CATD(128), CHCRV(2)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'FFT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:PSTD.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATR, CATD, CATH, CATBLK)
      EQUIVALENCE (CATRE, CATRER, CATREH), (CATIM, CATIMR, CATIMH)
      DATA JDIR /-1, -1, 1, 1, -1, -1/
      DATA OPS /'UVRE','UVCX','MARE','MACX','UVIR','UVIX'/
      DATA CLASR /'MAREAL', 'UVREAL'/
      DATA CLASI /'MAIMAG', 'UVIMAG'/
      DATA DCPX /.FALSE.,.TRUE.,.FALSE.,.TRUE., .FALSE., .TRUE./
      DATA UU, VV, XX, YY /'UU--','VV--','XX--','YY--'/
      DATA JY, JYPBM /'JY      ', 'JY/BEAM '/
      DATA IDEPTH /5 * 1/
      DATA T, NOSWAP /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE., BUFF1)
      CALL VHDRIN
      JBUFSZ = 2  * MABFSL
      LUNMPR = 16
      LUNMPI = 17
      LUNWK1 = 18
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 30
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMER, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = T
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQINR = IROUND (XSR)
      SEQOUT = IROUND (XSO)
      SEQINI = IROUND (XSI)
      DISKR = IROUND (XDR)
      DISKI = IROUND (XDI)
      DISKO = IROUND (XDO)
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMER, NAMER)
      CALL H2CHR (6, 1, XCLASR, CLASSR)
      CALL H2CHR (12, 1, XNAMEI, NAMEI)
      CALL H2CHR (6, 1, XCLASI, CLASSI)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
C                                       Determine transform type.
      II = -1
      IF (OPCODE.EQ.' ') II = 3
      DO 20 I = 1,NOPS
         IF (OPCODE(1:4).EQ.OPS(I)(1:4)) II = I
 20      CONTINUE
C                                        Check OPCODE
      IF (II.LE.0) THEN
         WRITE (MSGTXT,1020) OPCODE
         GO TO 990
         END IF
      IDIR = JDIR(II)
      DOCMPX = DCPX(II)
      OPCODE = OPS(II)
      DO 35 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 35      CONTINUE
C                                       Get CATBLK from old file.
      CNOINR = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKR, CNOINR, NAMER, CLASSR, SEQINR, MTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMER, CLASSR, SEQINR, DISKR,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKR, CNOINR, CATBLK, 'READ', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKR
      FCNO(NCFILE) = CNOINR
      FRW(NCFILE) = 0
C                                       Blanked image - barf
      IF (ABS (CATR(KRBLK)).GT.0.001) THEN
         IERR = 6
         WRITE (MSGTXT,1046)
         GO TO 990
         END IF
C                                       Save coor. ref pixels.
      XREF1 = CATR(KRCRP)
      XREF2 = CATR(KRCRP+1)
C                                       Find Imag. file.
      CNOINI = 1
      MTYPE = 'MA'
      IF (DOCMPX) THEN
         CALL CATDIR ('SRCH', DISKI, CNOINI, NAMEI, CLASSI, SEQINI,
     *      MTYPE, NLUSER, STAT, BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR, NAMEI, CLASSI, SEQINI, DISKI,
     *         NLUSER
            JERR = 1
            GO TO 990
            END IF
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMER, CLASSR, SEQINR, '      ', NAMOUT, CLASS,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CATBLK(KIIMS) = SEQOUT
C                                       Redo headers
      LOCNUM = 1
      CALL SETLOC (IDEPTH, NOSWAP)
      CALL H2CHR (8, 1, CATH(KHCTP), CHTYP(1))
      CALL H2CHR (8, 1, CATH(KHCTP+2), CHTYP(2))
      CALL H2CHR (8, 1, CATH(KHCTP+2*NAX-4), CHTYP(3))
      CALL H2CHR (8, 1, CATH(KHCTP+2*NAX-2), CHTYP(4))
C                                       UVIMG output
      IF (OPCODE(:3).EQ.'UVI') THEN
C                                       Save old X,Y axis parms
         J = 0
         NAX = CATBLK(KIDIM)
         CALL RCOPY (2, CATR(KRCIC), CHCIC(1))
         CALL RCOPY (2, CATR(KRCIC+NAX-2), CHCIC(3))
         CHCRV(1) = CATD(KDCRV) + (1-CATR(KRCRP)) * CATR(KRCIC)
         CHCRV(2) = CATD(KDCRV+1) + (1-CATR(KRCRP+1)) * CATR(KRCIC+1)
         CALL H2CHR (8, 1, CATH(KHBUN), CHTM12)
         CALL CHLTOU (8, CHTM12)
         IF ((CHTM12.EQ.'UNCALIB') .OR. (CHTM12.EQ.'JY'))
     *      CALL CHR2H (8, 'JY/BEAM ', 1 , CATH(KHBUN))
         IF (CHTYP(3)(:2).EQ.'RA') THEN
            IF (CHTYP(1)(:1).EQ.'V') THEN
               CATD(KDCRV) = CATD(KDCRV+NAX-2)
               CALL CHR2H (8, 'RA---SIN', 1, CATH(KHCTP))
               CATD(KDCRV+1) = CATD(KDCRV+NAX-1)
               CALL CHR2H (8, 'DEC--SIN', 1, CATH(KHCTP+2))
            ELSE
               CATD(KDCRV+1) = CATD(KDCRV+NAX-2)
               CALL CHR2H (8, 'RA---SIN', 1, CATH(KHCTP+2))
               CATD(KDCRV) = CATD(KDCRV+NAX-1)
               CALL CHR2H (8, 'DEC--SIN', 1, CATH(KHCTP))
               END IF
         ELSE
            IF (CHTYP(1)(:1).EQ.'V') THEN
               CATD(KDCRV) = CATD(KDCRV+NAX-1)
               CALL CHR2H (8, 'RA---SIN', 1, CATH(KHCTP))
               CATD(KDCRV+1) = CATD(KDCRV+NAX-2)
               CALL CHR2H (8, 'DEC--SIN', 1, CATH(KHCTP+2))
            ELSE
               CATD(KDCRV+1) = CATD(KDCRV+NAX-1)
               CALL CHR2H (8, 'RA---SIN', 1, CATH(KHCTP+2))
               CATD(KDCRV) = CATD(KDCRV+NAX-2)
               CALL CHR2H (8, 'DEC--SIN', 1, CATH(KHCTP))
               END IF
            END IF
         CATR(KRCRP) = (CATBLK(KINAX+1) / 2.0) + 1.0
         CATR(KRCRP+1) = (CATBLK(KINAX) / 2.0) + 1.0
         TEMP = CATR(KRCIC)
         IF (CATR(KRCIC+1).NE.0.0) CATR(KRCIC) = -RAD2DG /
     *     (CATBLK(KINAX+1) * CATR(KRCIC+1))
         IF (CATR(KRCIC+1).EQ.0.0) CATR(KRCIC) = 0.0
         IF (TEMP.NE.0.0) CATR(KRCIC+1) = -RAD2DG / (CATBLK(KINAX)*TEMP)
         IF (TEMP.EQ.0.0) CATR(KRCIC+1) = 0.0
         I = CATBLK(KINAX)
         CATBLK(KINAX) = CATBLK(KINAX+1)
         CATBLK(KINAX+1) = I
         CATR(KRCRT) = 0.0
         CATR(KRCRT+1) = 0.0
         CALL CHR2H (8, CHTYP(1), 1, CATH(KHCTP+2*NAX-4))
         CATR(KRCIC+NAX-2) = CHCIC(1)
         CATD(KDCRV+NAX-2) = CHCRV(1)
         CALL CHR2H (8, CHTYP(2), 1, CATH(KHCTP+2*NAX-2))
         CATR(KRCIC+NAX-1) = CHCIC(2)
         CATD(KDCRV+NAX-1) = CHCRV(2)
         GO TO 80
         END IF
C                                       MAP to UV
      IF (IDIR.NE.1) GO TO 70
         IF (CATBLK(KIDIM).GT.KICTPN-2) THEN
            WRITE (MSGTXT,1050)
            CALL MSGWRT (6)
            END IF
         IF (AXTYP(LOCNUM).NE.1) THEN
            WRITE (MSGTXT,1051)
            CALL MSGWRT (6)
            END IF
C                                       Save old X,Y axis parms
         J = 0
 55      I = CATBLK(KIDIM)
         IF (I.LE.KICTPN-1) THEN
            CATBLK(KIDIM) = CATBLK(KIDIM) + 1
            CATD(KDCRV+I) = CATD(KDCRV+J)
            CATR(KRCRP+I) = CATR(KRCRP+J)
            CATR(KRCRT+I) = CATR(KRCRT+J)
            CATR(KRCIC+I) = CATR(KRCIC+J)
            CATBLK(KINAX+I) = 1
            CALL CHCOPY (8, 1, CATH(KHCTP+J*2), 1, CATH(KHCTP+I*2))
            J = J + 1
            IF (J.LE.1) GO TO 55
            END IF
C                                       Make new X,Y transposed
         CALL H2CHR (4, 1, CATH(KHBUN), CHTM12)
         CALL CHLTOU (8, CHTM12)
         EQUAL = JYPBM(1:8) .EQ. CHTM12(1:8)
         IF (EQUAL) CALL CHR2H (8, JY, 1, CATH(KHBUN))
         CALL H2CHR (8, 1, CATH(KHCTP), CHTM12(1:8))
         CALL CHCOPY (8, 1, CATH(KHCTP+2), 1, CATH(KHCTP))
         CALL CHR2H (8, CHTM12(1:8), 1, CATH(KHCTP+2))
         CALL CHR2H (1, UU, 1, CATH(KHCTP+2))
         CALL CHR2H (1, VV, 1, CATH(KHCTP))
         IF ((AXTYP(LOCNUM).GT.0) .AND. (AXTYP(LOCNUM).LT.4)) THEN
            IF (KLOCL(LOCNUM).LE.1) CALL CHR2H (4, UU, 1,
     *         CATH(KHCTP+(1-KLOCL(LOCNUM))*2))
            IF (KLOCM(LOCNUM).LE.1) CALL CHR2H (4, VV, 1,
     *         CATH(KHCTP+(1-KLOCM(LOCNUM))*2))
            IF ((KLOCL(LOCNUM).LE.1) .AND. (KLOCM(LOCNUM).GT.1)) CALL
     *         CHR2H (1, VV(1:1), 1, CATH(KHCTP+KLOCL(LOCNUM)*2))
            IF ((KLOCM(LOCNUM).LE.1) .AND. (KLOCL(LOCNUM).GT.1)) CALL
     *         CHR2H (1, UU(1:1), 1, CATH(KHCTP+KLOCM(LOCNUM)*2))
            END IF
 65      CATD(KDCRV) = 0.0D0
         CATD(KDCRV+1) = 0.0D0
         CATR(KRCRP) = (CATBLK(KINAX+1) / 2.0) + 1.0
         CATR(KRCRP+1) = (CATBLK(KINAX) / 2.0) + 1.0
         TEMP = CATR(KRCIC)
         IF (CATR(KRCIC+1).NE.0.0) CATR(KRCIC) = 1.0 / (CATBLK(KINAX+1)
     *      * CATR(KRCIC+1))
         IF (CATR(KRCIC+1).EQ.0.0) CATR(KRCIC) = 0.0
         IF (TEMP.NE.0.0) CATR(KRCIC+1) = 1.0 / (CATBLK(KINAX) * TEMP)
         IF (TEMP.EQ.0.0) CATR(KRCIC+1) = 0.0
         I = CATBLK(KINAX)
         CATBLK(KINAX) = CATBLK(KINAX+1)
         CATBLK(KINAX+1) = I
         CATR(KRCRT) = 0.0
         CATR(KRCRT+1) = 0.0
         IF (IDIR.EQ.1) THEN
            IF (KLOCM(LOCNUM).LE.1) CATR(KRCIC+1-KLOCM(LOCNUM)) =
     *         CATR(KRCIC+1-KLOCM(LOCNUM)) / COND2R
            IF (KLOCL(LOCNUM).LE.1) CATR(KRCIC+1-KLOCL(LOCNUM)) =
     *         CATR(KRCIC+1-KLOCL(LOCNUM)) / COND2R
            END IF
         GO TO 80
C                                       UV to MAP
 70      CALL H2CHR (4, 1, CATH(KHBUN), CHTM12)
         EQUAL = 'JY  ' .EQ. CHTM12(1:4)
         IF (EQUAL) CALL CHR2H (8, JYPBM, 1, CATH(KHBUN))
         J = CATBLK(KIDIM)
         CALL CHCOMP (4, 5, CATH(KHCTP+(J-1)*2), 5, CATH(KHCTP+2),
     *      EQUAL)
         IF (EQUAL) CALL CHCOMP (4, 5, CATH(KHCTP+(J-2)*2), 5,
     *      CATH(KHCTP+2), EQUAL)
         IF ((J.GE.4) .AND. (EQUAL) .AND. (CATBLK(KINAX+J-1).EQ.1)
     *      .AND. (CATBLK(KINAX+J-2).EQ.1)) GO TO 75
            WRITE (MSGTXT,1070)
            CALL MSGWRT (6)
            CALL H2CHR (8, 1, CATH(KHCTP), CHTM12(1:1+8-1))
            CALL CHCOPY (8, 1, CATH(KHCTP+2), 1, CATH(KHCTP))
            CALL CHR2H (8, CHTM12(1:8), 1, CATH(KHCTP+2))
            CALL CHR2H (1, YY, 1, CATH(KHCTP+2))
            CALL CHR2H (1, XX, 1, CATH(KHCTP))
            GO TO 65
C                                       Get from previous FFT
 75      CONTINUE
            CATBLK(KIDIM) = CATBLK(KIDIM) - 2
            I = CATBLK(KIDIM)
            CATD(KDCRV) = CATD(KDCRV+I)
            CATD(KDCRV+1) = CATD(KDCRV+I+1)
            CATR(KRCRP) = CATR(KRCRP+I)
            CATR(KRCRP+1) = CATR(KRCRP+I+1)
            CATR(KRCRT) = CATR(KRCRT+I)
            CATR(KRCRT+1) = CATR(KRCRT+I+1)
            CATR(KRCIC) = CATR(KRCIC+I)
            CATR(KRCIC+1) = CATR(KRCIC+I+1)
            CALL CHCOPY (8, 1, CATH(KHCTP+I*2), 1, CATH(KHCTP))
            CALL CHCOPY (8, 1, CATH(KHCTP+(I+1)*2), 1, CATH(KHCTP+2))
            I = CATBLK(KINAX)
            CATBLK(KINAX) = CATBLK(KINAX+1)
            CATBLK(KINAX+1) = I
C                                       Copy CATBLKs.
 80   CALL COPY (256, CATBLK, CATRE)
      CALL COPY (256, CATBLK, CATIM)
C                                       Put class in CATBLKs.
      IF (IDIR.EQ.-1) THEN
         CALL CHR2H (6, CLASR(1), KHIMCO, CATREH(KHIMC))
         CALL CHR2H (6, CLASI(1), KHIMCO, CATIMH(KHIMC))
      ELSE
         CALL CHR2H (6, CLASR(2), KHIMCO, CATREH(KHIMC))
         CALL CHR2H (6, CLASI(2), KHIMCO, CATIMH(KHIMC))
         END IF
C                                       Copy real header to CATBLK.
      CALL COPY (256, CATRE, CATBLK)
C                                       Create real output file.
      CNOUTR = 1
      JERR = 4
      CALL MCREAT (DISKO, CNOUTR, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1080) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CNOUTR
      FRW(NCFILE) = 2
      SEQOUT = CATBLK(KIIMS)
      CALL COPY (256, CATBLK, CATRE)
C                                       copy keywords
      CALL KEYPCP (DISKR, CNOINR, DISKO, CNOUTR, 0, ' ', IERR)
C                                       Create Imag. output file.
      CALL COPY (256, CATIM, CATBLK)
      CNOUTI = 1
      CALL MCREAT (DISKO, CNOUTI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1080) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CNOUTI
      FRW(NCFILE) = 2
      CALL COPY (256, CATBLK, CATIM)
C                                       copy keywords
      CALL KEYPCP (DISKR, CNOINR, DISKO, CNOUTI, 0, ' ', IERR)
      JERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FFTINI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1020 FORMAT ('UNKNOWN OPCODE =',A4)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,' . ',A6,' . ',
     *   I3,' DISK=',I3,' USID=',I4)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1046 FORMAT ('I CANNOT COPE WITH BLANKED IMAGES - USE ZERO BLANKING')
 1050 FORMAT ('WARNING: CAN''T SAVE OLD X-Y AXES IN HEADER')
 1051 FORMAT ('WARNING: NON-ANGLE X OR Y AXIS - OUTPUT UNITS',
     *   ' UNCERTAIN')
 1070 FORMAT ('WARNING: CAN''T RECOVER PREVIOUS X-Y AXES - OUTPUT',
     *   ' UNCERTAIN')
 1080 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE FILES (IERR)
C-----------------------------------------------------------------------
C  FILES reads and floats the input image and if an imaginary image
C  is to be used it is floated.  Both parts are rotated to the center
C  at the edges convention for the FFT.
C   Output:
C   IERR        I    Return error code. 0 => OK, error otherwise.
C-----------------------------------------------------------------------
      INTEGER    CATBLK(256), IERR, CAT2(256), MX, MY, NAX, NP(3),
     *   ISIZE, MZ, DEP(5), IX, IY
      DOUBLE PRECISION CATD(128), CAT2D(128)
      REAL      CATR(256), CAT2R(256), CATRER(256), XSPA, YSPA
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'FFT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK, CATR, CATD), (CAT2, CAT2R, CAT2D, BUFF2)
      EQUIVALENCE (CATRE, CATRER)
      DATA DEP /2,1,1,1,1/
C-----------------------------------------------------------------------
      MX = 0
      MY = 0
      MZ = 1
C                                      Check if imag. image to
C                                      be used.
      IF (DOCMPX) THEN
C                                       Read imag. header.
C                                       Copy CATBLK and mark READ.
         CALL CATIO ('READ', DISKI, CNOINI, CAT2, 'READ', BUFF3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKI
         FCNO(NCFILE) = CNOINI
         FRW(NCFILE) = 0
C                                       Determine imag. NX and NY
         MX = CAT2(KINAX)
         MY = CAT2(KINAX+1)
         IF (CAT2(KIDIM).GE.3) MZ = MZ * MAX (1, CAT2(KINAX+2))
         IF (CAT2(KIDIM).GE.4) MZ = MZ * MAX (1, CAT2(KINAX+3))
         IF (CAT2(KIDIM).GE.5) MZ = MZ * MAX (1, CAT2(KINAX+4))
         IF (CAT2(KIDIM).GE.6) MZ = MZ * MAX (1, CAT2(KINAX+5))
         IF (CAT2(KIDIM).GE.7) MZ = MZ * MAX (1, CAT2(KINAX+6))
         XSPA = CAT2R(KRCIC)
         YSPA = CAT2R(KRCIC+1)
C                                       Blanked image - barf
         IF (ABS (CAT2R(KRBLK)).GT.0.001) THEN
            IERR = 6
            WRITE (MSGTXT,1018)
            GO TO 990
            END IF
         END IF
C                                       Recover REAL CATBLK
      CALL CATIO ('READ', DISKR, CNOINR, CATBLK, 'REST', BUFF3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       Determine map rotation.
      NX = CATBLK(KINAX)
      NY = CATBLK(KINAX+1)
      NZ = 1
      IF (CATBLK(KIDIM).GE.3) NZ = NZ * MAX (1, CATBLK(KINAX+2))
      IF (CATBLK(KIDIM).GE.4) NZ = NZ * MAX (1, CATBLK(KINAX+3))
      IF (CATBLK(KIDIM).GE.5) NZ = NZ * MAX (1, CATBLK(KINAX+4))
      IF (CATBLK(KIDIM).GE.6) NZ = NZ * MAX (1, CATBLK(KINAX+5))
      IF (CATBLK(KIDIM).GE.7) NZ = NZ * MAX (1, CATBLK(KINAX+6))
      XCEN = CATR(KRCRP) - CATRER(KRCRP+1)
      YCEN = CATR(KRCRP+1) - CATRER(KRCRP)
      ICENX = 0
      ICENY = 0
C                                       Make sure NX,NY same as
C                                       for Imag. part.
      IF (((NX.NE.MX) .OR. (NY.NE.MY) .OR. (CATR(KRCIC).NE.XSPA) .OR.
     *   (CATR(KRCIC+1).NE.YSPA) .OR. (NZ.NE.MZ)) .AND.
     *   (DOCMPX)) THEN
         IERR = 1
         WRITE (MSGTXT,1030)
         CALL MSGWRT (8)
         WRITE (MSGTXT,1031) NX, NY, NZ, MX, MY, MZ
         GO TO 990
         END IF
C                                       Check NX, NY
      CALL POWER2 (NX, IX)
      CALL POWER2 (NY, IY)
      IF ((NX.NE.IX) .OR. (NX.LT.32) .OR. (NX.GT.MAXIMG) .OR. (NY.NE.IY)
     *   .OR. (NY.LT.32) .OR. (NY.GT.MAXIMG)) THEN
         WRITE (MSGTXT,1035) NX, NY
         IERR = 1
         GO TO 990
         END IF
      NAX = 3
      NP(1) = NX
      NP(2) = NY
      NP(3) = NZ
      IF (NZ.GT.1) THEN
         CALL COMOFF (NAX, NP, DEP, ONEPLN, IERR)
      ELSE
         ONEPLN = 0
         END IF
C                                       Create scratch files.
C                                       Work file 1
      NAX = 2
      NP(1) = NX * 2
      NP(2) = NY
      CALL MAPSIZ (NAX, NP, ISIZE)
      CALL SCREAT (ISIZE, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
C                                       Update from COMMON /FILES/
      WK1VOL = SCRVOL(NSCR)
      CALL ZPHFIL ('SC', WK1VOL, SCRCNO(NSCR), 1, WK1FIL, IERR)
      NINOUT = NSCR
      LUNS(NINOUT) = LUNMPR
C                                       Work file No. 2.
      CALL SCREAT (ISIZE, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
C                                       Update from COMMON /FILES/
      WK2VOL = SCRVOL(NSCR)
      CALL ZPHFIL ('SC', WK2VOL, SCRCNO(NSCR), 1, WK2FIL, IERR)
      NWRK = NSCR
      LUNS(NWRK) = LUNMPI
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('FILES: CANNOT READ IMAG. CATBLK, ERROR',I3)
 1018 FORMAT ('I CANNOT COPE WITH BLANKED IMAGES - USE ZERO BLANKING')
 1020 FORMAT ('FILES: CANNOT REREAD REAL CATBLK, ERROR',I3)
 1030 FORMAT ('FILES: UNEQUAL DIMENSIONS IN TWO MAPS')
 1031 FORMAT ('       REAL=',3I5,' IMAG=',3I5)
 1035 FORMAT ('ILLEGAL NX, NY=',2I6)
 1060 FORMAT ('FILES: ERROR',I3,' CREATING WORK SCRATCH FILE')
      END
      SUBROUTINE DOFFT (IRET)
C-----------------------------------------------------------------------
C   DOFFT merges two input maps, does the FFT and then splits output
C   into real and imaginary parts.  Inputs assumed in input catalogd
C   files and the output will be to catalogd output files.
C   Output:
C   IRET   I    Return code, 0 => OK, otherwise error.
C   Max. and min. are also put in the map header.
C-----------------------------------------------------------------------
      INTEGER   IRET, KAP, IZ, BO, NEED
      LOGICAL   F
      REAL      DUM1, DUM2
      DOUBLE PRECISION APCORE(2)
      INCLUDE 'INCS:DAPM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'FFT.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                       Merge files.
      DO 100 IZ = 1,NZ
         BO = 1 + ONEPLN * (IZ - 1)
         CALL FMERG (BO, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Do FFT.
C                                       should be enough
         NEED = 4 * NX * NY + 4 * (NX + NY)
         NEED = NEED / 1024
         MSGSUP = 32000
         CALL QINIT (APCORE, NEED, 0, KAP)
         MSGSUP = 0
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            NEED = 2 * NX * NY + 2 * (NX + NY)
            NEED = NEED / 1024
            NEED = MIN (32 * 1024, NEED)
            MSGSUP = 32000
            CALL QINIT (APCORE, NEED, 0, KAP)
            MSGSUP = 0
            IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
               NEED = 5120
               CALL QINIT (APCORE, NEED, 0, KAP)
               IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
                  MSGTXT = 'DOFFT: FAILED TO GET ANY AP MEMORY'
                  CALL MSGWRT (8)
                  IRET = 10
                  GO TO 999
                  END IF
               END IF
            END IF
            CALL DSKFFT (APCORE, NY, NX, IDIR, F, NINOUT, NWRK, NINOUT,
     *         JBUFSZ, BUFF1, BUFF2, DUM1, DUM2, IRET)
         CALL QRLSE
         IF (IRET.NE.0) GO TO 999
C                                       Split and rotate output.
         CALL SPLIT (BO, IRET)
         IF (IRET.NE.0) GO TO 999
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE FMERG (BI, IRET)
C-----------------------------------------------------------------------
C   FMERG merges real and imaginary files MPR and MPI and converts
C   them into a complex file in WK1.
C   Output:
C   IRET   I    Return code, 0=>OK, otherwise error.
C-----------------------------------------------------------------------
      INCLUDE 'FFT.INC'
C
      CHARACTER NAM(3)*4, FNAME*48
      INTEGER   BI, FIND1, FIND2, FIND3, BIND1, BIND2, BIND3, BO,
     *   WIN(4), MX, MY, JJ, IRET, J, I, NX2, NY2, IH, I1, I2, ILIM
      LOGICAL   T, F, DOMUL
      REAL      TWOPI, TEMP
      COMPLEX   XMUL(MAXIMG+10), YMUL, TMUL, CONJG, CMPLX
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (XMUL, BMUL)
      DATA T, F /.TRUE.,.FALSE./
      DATA NAM /'REAL','IMAG','WORK'/
      DATA TWOPI /6.283185308/
C-----------------------------------------------------------------------
      BO = 1
      CALL FILL (4, 0, WIN)
C                                        Open and init REAL
      CALL ZPHFIL ('MA', DISKR, CNOINR, 1, FNAME, IRET)
      CALL ZOPEN (LUNMPR, FIND1, DISKR, FNAME, T, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ', NAM(1)
         GO TO 990
         END IF
      MX = NX * 2
      MY = NY
      NX2 = NX / 2
      NY2 = NY / 2
      CALL MINIT ('READ', LUNMPR, FIND1, NX, NY, WIN, BUFF1, JBUFSZ, BI,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, 'READ', NAM(1)
         GO TO 990
         END IF
C                                        Zero Imag. buffer.
      CALL RFILL (MX, 0.0, BUFF2)
      BIND2 = 1
C                                        Check if read imag.
      IF (DOCMPX) THEN
C                                        Open and init MPI
         CALL ZPHFIL ('MA', DISKI, CNOINI, 1, FNAME, IRET)
         CALL ZOPEN (LUNMPI, FIND2, DISKI, FNAME, T, F, T, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ', NAM(2)
            GO TO 990
            END IF
         CALL MINIT ('READ', LUNMPI, FIND2, NX, NY, WIN, BUFF2, JBUFSZ,
     *      BI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'READ', NAM(2)
            GO TO 990
            END IF
         END IF
C                                        Phase shift terms
      DOMUL = (IDIR.NE.1) .AND. ((XCEN.NE.0.0) .OR. (YCEN.NE.0.0))
      IF (DOMUL) THEN
         TEMP = TWOPI * XCEN / NX
         ILIM = NX / 2 + 1
C                                       Note: following loop uses
C                                       XMUL(NX+1)
         DO 30 I = 1,ILIM
            XMUL(I) = CMPLX (COS((I-1)*TEMP), SIN((I-1)*TEMP))
            XMUL(NX+2-I) = CONJG (XMUL(I))
 30         CONTINUE
C                                       Oops, one too many
         XMUL(ILIM) = CONJG (XMUL(ILIM))
         TEMP = TWOPI * YCEN / NY
         END IF
C                                        Open and init WK1
      CALL ZOPEN (LUNWK1, FIND3, WK1VOL, WK1FIL, T, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRIT', NAM(3)
         GO TO 990
         END IF
      WIN(1) = 1
      WIN(3) = MX
      WIN(2) = NY2 + 1
      WIN(4) = NY
C                                        Loop over file half.
      DO 150 IH = 1,2
         CALL MINIT ('WRIT', LUNWK1, FIND3, MX, MY, WIN, BUFF3, JBUFSZ,
     *      BO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'WRIT', NAM(3)
            GO TO 990
            END IF
C                                        Loop, forming complex.
         DO 140 I = 1, NY2
C                                        Read real
            CALL MDISK ('READ', LUNMPR, FIND1, BUFF1, BIND1, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1060) IRET, 'READ', NAM(1)
               GO TO 990
               END IF
C                                        Read imag if needed
            IF (DOCMPX) THEN
               CALL MDISK ('READ', LUNMPI, FIND2, BUFF2, BIND2, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1060) IRET, 'READ', NAM(2)
                  GO TO 990
                  END IF
               END IF
C                                        Write WK1
            CALL MDISK ('WRIT', LUNWK1, FIND3, BUFF3, BIND3, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1060) IRET, 'WRIT', NAM(3)
               GO TO 990
               END IF
C                                        Merge 1st half row.
            IF (.NOT.DOMUL) THEN
               DO 100 J = 1, NX2
                  JJ = BIND3 + 2 * J - 2 + NX
                  I1 = BIND1 + J - 1
                  I2 = BIND2 + J - 1
                  BUFF3(JJ) = BUFF1(I1)
                  BUFF3(JJ+1) = BUFF2(I2)
 100              CONTINUE
C                                        Do second half.
               DO 110 J = 1, NX2
                  JJ = BIND3 + 2 * J - 2
                  I1 = BIND1 + J - 1 + NX2
                  I2 = BIND2 + J - 1 + NX2
                  BUFF3(JJ) = BUFF1(I1)
                  BUFF3(JJ+1) = BUFF2(I2)
 110              CONTINUE
            ELSE
C                                        With shift
               J = WIN(2) + I - 2
               IF (IH.EQ.1) J = J - NY
               YMUL = CMPLX (COS(J*TEMP), SIN(J*TEMP))
               DO 130 J = 1,NX2
                  JJ = BIND3 + 2 * J - 2 + NX
                  I1 = BIND1 + J - 1
                  I2 = BIND2 + J - 1
                  TMUL = YMUL * XMUL(J+NX2) * CMPLX (BUFF1(I1),
     *               BUFF2(I2))
                  BUFF3(JJ) = REAL(TMUL)
                  BUFF3(JJ+1) = AIMAG(TMUL)
 130              CONTINUE
C                                        Do second half.
               DO 135 J = 1,NX2
                  JJ = BIND3 + 2 * J - 2
                  I1 = BIND1 + J - 1 + NX2
                  I2 = BIND2 + J - 1 + NX2
                  TMUL = YMUL * XMUL(J) * CMPLX (BUFF1(I1),
     *               BUFF2(I2))
                  BUFF3(JJ) = REAL(TMUL)
                  BUFF3(JJ+1) = AIMAG(TMUL)
 135              CONTINUE
               END IF
 140        CONTINUE
C                                        Flush buffer.
         CALL MDISK ('FINI', LUNWK1, FIND3, BUFF3, BIND3, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1060) IRET, 'FINI', NAM(3)
            GO TO 990
            END IF
C                                        Prepare for second half.
         WIN(2) = 1
         WIN(4) = NY2
 150     CONTINUE
C                                        Close files.
      CALL ZCLOSE (LUNMPR, FIND1, IRET)
      IF (DOCMPX) CALL ZCLOSE (LUNMPI, FIND2, IRET)
      CALL ZCLOSE (LUNWK1, FIND3, IRET)
      IRET = 0
      GO TO 999
C                                        Error.
 990  CALL MSGWRT (8)
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FMERG: ERROR',I3,' OPEN FOR ',A4,1X,A4,' FILE')
 1010 FORMAT ('FMERG: ERROR',I3,' INIT FOR ',A4,1X,A4,' FILE')
 1060 FORMAT ('FMERG: ERROR',I3,1X,A4,'ING ',A4,' FILE')
      END
      SUBROUTINE SPLIT (BI, IRET)
C-----------------------------------------------------------------------
C   SPLIT takes a complex rotated (center at corners) image WK1
C   and puts the real and imaginary parts in the correct order in
C   output files. The values of MAX and MIN are placed in the headers.
C   Output:
C   IRET    I     Return error code., 0 =>OK otherwise error.
C-----------------------------------------------------------------------
      INCLUDE 'FFT.INC'
C
      CHARACTER NAM(3)*4, FNAME*48
      INTEGER   BI, FIND1, FIND2, FIND3, BIND1, BIND2, BIND3, BO,
     *   WIN(4), MX, MY, NX2, NY2, IRET, IERR, J, II, I, I2, I3, IROW,
     *   IH, ILIM
      LOGICAL   T, F, DOMUL
      REAL      RMAX, RMIN, IMAX, IMIN, CATRER(256), CATIMR(256), TEMP,
     *   TWOPI
      COMPLEX   XMUL(MAXIMG+10), YMUL, TMUL, CONJG, CMPLX
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (XMUL,BMUL),  (CATIMR,CATIM), (CATRER,CATRE)
      DATA T, F /.TRUE.,.FALSE./
      DATA NAM /'WORK','REAL','IMAG'/
      DATA TWOPI /6.283185308/
C-----------------------------------------------------------------------
      CALL FILL (4, 0, WIN)
      BO = 1
C                                        Initialize extrema.
      RMAX = -1.0E6
      RMIN = 1.0E6
      IMAX = -1.0E6
      IMIN = 1.0E6
C                                        Open work file.
      CALL ZOPEN (LUNWK1, FIND1, WK1VOL, WK1FIL, T, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN', NAM(1)
         GO TO 990
         END IF
C                                        Open real file.
      CALL ZPHFIL ('MA', DISKO, CNOUTR, 1, FNAME, IRET)
      CALL ZOPEN (LUNMPR, FIND2, DISKO, FNAME, T, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN', NAM(2)
         GO TO 990
         END IF
C                                        Init real file.
      CALL MINIT ('WRIT', LUNMPR, FIND2, NY, NX, WIN, BUFF2, JBUFSZ, BI,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT', NAM(2)
         GO TO 990
         END IF
C                                        Open imag. file
      CALL ZPHFIL ('MA', DISKO, CNOUTI, 1, FNAME, IRET)
      CALL ZOPEN (LUNMPI, FIND3, DISKO, FNAME, T, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN', NAM(3)
         GO TO 990
         END IF
C                                        Init imag. file.
      CALL MINIT ('WRIT', LUNMPI, FIND3, NY, NX, WIN, BUFF3, JBUFSZ, BI,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT', NAM(3)
         GO TO 990
         END IF
C                                        Phase shift
      DOMUL = (IDIR.EQ.1) .AND. ((XCEN.NE.0.0) .OR. (YCEN.NE.0.))
      IF (DOMUL) THEN
         TEMP = TWOPI * YCEN / NY
         ILIM = NY / 2 + 1
C                                       Note: following loop uses
C                                       XMUL(NY+1)
         DO 60 I = 1,ILIM
            XMUL(I) = CMPLX (COS((I-1)*TEMP), SIN((I-1)*TEMP))
            XMUL(NY+2-I) = CONJG (XMUL(I))
 60         CONTINUE
C                                       Oops, one too many
         XMUL(ILIM) = CONJG (XMUL(ILIM))
         TEMP = TWOPI * XCEN / NX
         END IF
C                                        Prepare to init input.
      MX = NX
      MY = NY * 2
      NX2 = NX / 2
      NY2 = NY / 2
      WIN(1) = 1
      WIN(3) = MY
      WIN(2) = NX2 + 1
      WIN(4) = NX
C                                       Begin loop over two halves.
      DO 250 IH = 1,2
C                                       Inint input file.
         CALL MINIT ('READ', LUNWK1, FIND1, MY, MX, WIN, BUFF1, JBUFSZ,
     *      BO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT', NAM(1)
            GO TO 990
            END IF
C                                       Loop over rows in this half.
         DO 200 IROW = 1,NX2
C                                       Read row.
            CALL MDISK ('READ', LUNWK1, FIND1, BUFF1, BIND1, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ', NAM(1)
               GO TO 990
               END IF
C                                       Write real.
            CALL MDISK ('WRIT', LUNMPR, FIND2, BUFF2, BIND2, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRIT', NAM(2)
               GO TO 990
               END IF
C                                       Write imag.
            CALL MDISK ('WRIT', LUNMPI, FIND3, BUFF3, BIND3, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRIT', NAM(3)
               GO TO 990
               END IF
C                                       Split row - first half.
            IF (.NOT.DOMUL) THEN
               DO 140 I = 1,NY2
                  II = BIND1 + I * 2 - 2 + NY
                  I2 = BIND2 + I - 1
                  I3 = BIND3 + I - 1
                  BUFF2(I2) = BUFF1(II)
                  BUFF3(I3) = BUFF1(II+1)
C                                         Find extrema.
                  RMAX = MAX (RMAX, BUFF2(I2))
                  RMIN = MIN (RMIN, BUFF2(I2))
                  IMAX = MAX (IMAX, BUFF3(I3))
                  IMIN = MIN (IMIN, BUFF3(I3))
 140              CONTINUE
C                                         Second half.
               DO 150 I = 1,NY2
                  II = BIND1 + I * 2 - 2
                  I2 = BIND2 + I - 1 + NY2
                  I3 = BIND3 + I - 1 + NY2
                  BUFF2(I2) = BUFF1(II)
                  BUFF3(I3) = BUFF1(II+1)
C                                         Find extrema.
                  RMAX = MAX (RMAX, BUFF2(I2))
                  RMIN = MIN (RMIN, BUFF2(I2))
                  IMAX = MAX (IMAX, BUFF3(I3))
                  IMIN = MIN (IMIN, BUFF3(I3))
 150              CONTINUE
            ELSE
C                                        With shift
               J = WIN(2) + IROW - 2
               IF (IH.EQ.1) J = J - NX
               YMUL = CMPLX (COS(J*TEMP), SIN(J*TEMP))
               DO 170 I = 1,NY2
                  II = BIND1 + I * 2 - 2 + NY
                  I2 = BIND2 + I - 1
                  I3 = BIND3 + I - 1
                  TMUL = YMUL * XMUL(I+NY2) * CMPLX (BUFF1(II),
     *               BUFF1(II+1))
                  BUFF2(I2) = REAL(TMUL)
                  BUFF3(I3) = AIMAG(TMUL)
C                                         Find extrema.
                  RMAX = MAX (RMAX, BUFF2(I2))
                  RMIN = MIN (RMIN, BUFF2(I2))
                  IMAX = MAX (IMAX, BUFF3(I3))
                  IMIN = MIN (IMIN, BUFF3(I3))
 170              CONTINUE
C                                         Second half.
               DO 180 I = 1,NY2
                  II = BIND1 + I * 2 - 2
                  I2 = BIND2 + I - 1 + NY2
                  I3 = BIND3 + I - 1 + NY2
                  TMUL = YMUL * XMUL(I) * CMPLX (BUFF1(II),
     *               BUFF1(II+1))
                  BUFF2(I2) = REAL(TMUL)
                  BUFF3(I3) = AIMAG(TMUL)
C                                         Find extrema.
                  RMAX = MAX (RMAX, BUFF2(I2))
                  RMIN = MIN (RMIN, BUFF2(I2))
                  IMAX = MAX (IMAX, BUFF3(I3))
                  IMIN = MIN (IMIN, BUFF3(I3))
 180              CONTINUE
               END IF
 200        CONTINUE
C                                         Prepare for 2nd half plane.
         WIN(2) = 1
         WIN(4) = NX2
 250     CONTINUE
C                                         Flush buffers.
      CALL MDISK ('FINI', LUNMPR, FIND2, BUFF2, BIND2, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINI', NAM(2)
         GO TO 990
         END IF
      CALL MDISK ('FINI', LUNMPI, FIND3, BUFF3, BIND3, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINI', NAM(3)
         GO TO 990
         END IF
C                                         Close files.
      CALL ZCLOSE (LUNWK1, FIND1, IERR)
      CALL ZCLOSE (LUNMPR, FIND2, IERR)
      CALL ZCLOSE (LUNMPI, FIND3, IERR)
      IRET = 0
C                                         Fill extrema in headers.
      CATRER(KRDMX) = RMAX
      CATRER(KRDMN) = RMIN
      CATIMR(KRDMX) = IMAX
      CATIMR(KRDMN) = IMIN
      GO TO 999
C                                        Error.
 990  CALL MSGWRT(8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPLIT: ERROR',I3,1X,A4,'ING ',A4,' FILE')
      END
      SUBROUTINE FFTHIS
C-----------------------------------------------------------------------
C   FFTHIS copies and updates history file.
C-----------------------------------------------------------------------
      INTEGER   CATBLK(256), LUN1, LUN2, IERR, IPTR, ITEMP, IER
      CHARACTER HILINE*72
      LOGICAL   T, F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'FFT.INC'
      COMMON /MAPHDR/ CATBLK
      DATA LUN1, LUN2 /27,28/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKR, DISKO, CNOINR, CNOUTR, CATRE,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 20
         END IF
C                                       Copy second input history.
      IF (DOCMPX) THEN
         WRITE (HILINE,1010) TSKNAM
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         CALL HIOPEN (LUN1, DISKI, CNOINI, BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1005) IERR
            CALL MSGWRT (6)
            GO TO 10
            END IF
         CALL HILOCT ('SRCH', LUN2, IPTR, IERR)
         ITEMP = HITAB(IPTR+2)
         CALL HICOPY (LUN1, BUFF1, LUN2, BUFF2, IERR)
         CALL HICLOS (LUN1, F, BUFF1, IER)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1011) IERR
            CALL MSGWRT (6)
            IF (IERR.LT.100) GO TO 20
            HITAB(IPTR+2) = ITEMP
            END IF
         END IF
C                                       New history
 10   CALL HENCO1 (TSKNAM, NAMER, CLASSR, SEQINR, DISKR, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
      IF (DOCMPX) CALL HENCO2 (TSKNAM, NAMEI, CLASSI, SEQINI, DISKI,
     *   LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCOO (TSKNAM, NAMOUT, '      ', SEQOUT, DISKO, LUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       Add OPCODE
      WRITE (HILINE,2000) TSKNAM, OPCODE
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
C                                       Close HI file
 20   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, CNOUTR, CATRE, 'REST', BUFF1,
     *   IERR)
C                                        Copy history to imag. file.
      CALL HISCOP (LUN1, LUN2, DISKO, DISKO, CNOUTR, CNOUTI, CATIM,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         END IF
C                                        Close history file.
      CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Update imag CATBLK.
      CALL CATIO ('UPDT', DISKO, CNOUTI, CATIM, 'REST', BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FFTHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1005 FORMAT ('FFTHIS UNABLE TO OPEN IMAG. HISTORY FILE')
 1010 FORMAT (A6,'/************** Imaginary image history')
 1011 FORMAT ('FFTHIS: ERROR',I3,' COPYING IMAG. HISTORY')
 2000 FORMAT (A6,' OPCODE =',A4,' /Requested operation')
      END

      PROGRAM STARC
C-----------------------------------------------------------------------
C! Task converts RUN file of source flux,position and size into CC ext.
C# EXT-util Map-util Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   STARC will convert a RUN file containing the positions and
C   uncertainties of points into a ST extension file attached to an
C   AIPS image.  The ST file will be in standard tables format.
C    INPUTS:   (from AIPS)
C              USERID   R   user number, 0 means use logon user
C                       number, 32000 means any user can be accessed.
C              INNAME   R(3)   name of primary file.
C              INCLASS  R(2)   class of primary file.
C              INSEQ    R   sequence number of primary file.
C              INDISK   R    disk volume number. 0 means try all.
C              OUTVERS  R    CC file version number.
C              INFILE   C*48   Input RUN file name
C-----------------------------------------------------------------------
      CHARACTER KARBUF*80, PRGNAM*6, HILINE*72, NAMIN*12, CLSIN*6,
     *   INFILE*48, TYPIN*2, ATIME*8, ADATE*12, STFILE*48, M*1,
     *   SBUF*80, ATYPE(18)*4, NTYPE(7)*8, CHTM12*12
      HOLLERITH XNAMIN(3), XCLSIN(2), XINFIL(12)
      DOUBLE PRECISION XPOS(2:3), DDX, DEGRAD
      REAL      DSKIN, PRUSER, SEQIN, XOUVER, RECORD(7)
      INTEGER  I, IWBUFF(256), IMFIND, IREC, IMLUN, IERR, IRETCD, ISEQ,
     *   INPRMS, ISLOT, IUSER, IVOL, MAGIC, IROUND, RLUN, SLUN, IS,
     *   HLUN, IT(3), ID(3), J, K, BUF(512), NKEY, NREC, NCOL, RIND,
     *   OUVER, ICTYPE(2:3), ICOL, KBPTR, IER, IRNO, DEPTH(5)
      LOGICAL   T, F, SAVE, EQUAL, QUICK, NEWVER
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /INPARM/ PRUSER, XNAMIN, XCLSIN, SEQIN, DSKIN, XOUVER,
     *   XINFIL
      DATA MAGIC, IMLUN, RLUN, SLUN, HLUN /32000, 16,10,28,29/
      DATA DEPTH /5 * 1/
      DATA PRGNAM /'STARC '/
      DATA TYPIN /'  '/
      DATA T, F /.TRUE.,.FALSE./
      DATA ATYPE /'TIME','FREQ','LAMB','VELO','FELO','    ','DIST',
     *   'ANGL','ELON','ELAT', 'GLON','GLAT','RA  ','RA--','LL  ',
     *   'DEC ','DEC-','MM  '/
      DATA NTYPE /'SECONDS ', 'HERTZ   ', 'METERS  ',
     *   'METR/SEC', 'METR/SEC', 'PIXELS  ', 'DEGREES '/
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE., IWBUFF)
      CALL VHDRIN
      SAVE = F
C                                       Get input values from AIPS.
      INPRMS = 21
      IRETCD = 0
      CALL GTPARM (PRGNAM, INPRMS, QUICK, PRUSER, IWBUFF, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRETCD = 8
 10   IF (QUICK) CALL RELPOP (IRETCD, IWBUFF, IERR)
      IF (IRETCD.NE.0) GO TO 990
      IRETCD = 8
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
      CALL H2CHR (48, 1, XINFIL, INFILE)
C
      ISEQ = IROUND (SEQIN)
      IVOL = IROUND (DSKIN)
      IUSER = IROUND (PRUSER)
      IF (IUSER.EQ.0) IUSER = NLUSER
      IF (IUSER.EQ.MAGIC) IUSER = 0
      OUVER = IROUND (XOUVER)
C                                       Open map file & get header.
      CALL MAPOPN ('HDWR', IVOL, NAMIN, CLSIN, ISEQ, TYPIN, IUSER,
     *   IMLUN, IMFIND, ISLOT, CATBLK, IWBUFF, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Fill in defaults in PARMS
      DSKIN = IVOL
      PRUSER = IUSER
      DEGRAD = ATAN (1.0D0) / 45.0D0
C                                       Get coordinate info
      LOCNUM = 1
      CALL SETLOC (CATBLK, DEPTH)
      RECORD(7) = 1.
C                                       Open text file.
      CALL ZTXOPN ('READ', RLUN, RIND, INFILE, F, IERR)
      IF (IERR.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (8)
         GO TO 980
C                                       Create/open ST file
 30   NCOL = 7
      NKEY = 1
      NREC = 50
C                                       create/open
      CALL CCINI (SLUN, NCOL, IVOL, ISLOT, OUVER, CATBLK, BUF, IERR)
      NEWVER = IERR.EQ.-1
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1030) IERR, OUVER
         CALL MSGWRT (8)
         GO TO 970
      ENDIF
C                                       Figure out coords
      DO 55 I = 1,2
         ICTYPE(I+1) = 1
         J = (I-1) * 2 + KHCTP
         DO 50 K = 1,18
            CALL H2CHR (4, 1, CATH(J), CHTM12)
            EQUAL = CHTM12(1:4) .EQ. ATYPE(K)(1:4)
            IF (.NOT.EQUAL) GO TO 50
               IF (K.GT.12) ICTYPE(I+1) = 2
               IF (K.GT.15) ICTYPE(I+1) = 3
               J = I + 2
               GO TO 55
 50         CONTINUE
 55      CONTINUE
C                                       Read record loop
      DO 190 IREC = 1,99999
         CALL ZTXIO ('READ', RLUN, RIND, SBUF, IERR)
         IF (IERR.NE.0) THEN
            IF (IERR.EQ.2) GO TO 200
            WRITE (MSGTXT,1100) IERR
            CALL MSGWRT (8)
            GO TO 960
         ENDIF
         IRNO = IRNO + 1
C                                       Parse the input line
         KARBUF(1:80) = SBUF(1:80)
         KBPTR = 0
         DO 140 ICOL = 1, 6
            IS = 1
            J = 1
C                                       Find next non-blank
 115        KBPTR = KBPTR + 1
C                                       End of card
C                                       Positions missing
            IF (KBPTR.GT.80) THEN
               IF (ICOL.LE.3) THEN
                  WRITE (MSGTXT,1115) IRNO
                  CALL MSGWRT (7)
                  IRNO = IRNO - 1
                  GO TO 190
C                                       Sizes missing -> 1 pixel
               ELSE IF ((ICOL.GE.4) .AND. (ICOL.LE.5)) THEN
                  RECORD(ICOL) = ABS(CATR(KRCIC+ICOL-4))
C                                       Position angle missing
               ELSE
                  RECORD(ICOL) = 0.
                  END IF
               END IF
            M = KARBUF(KBPTR:KBPTR)
C                                       Squash blanks
            IF (M.EQ.' ') GO TO 115
C                                       Declination leading sign
            IF ((J.EQ.1) .AND. (ICTYPE(ICOL).EQ.3)) THEN
               J = J + 1
               IF (M .EQ. '+') THEN
                  GO TO 115
               ELSE IF (M .EQ. '-') THEN
                  IS = -1
                  GO TO 115
                  END IF
               END IF
C                                       So get the number
            CALL GETNUM (KARBUF, 80, KBPTR, DDX)
C                                       Flux or PA in degrees
            IF ((ICOL.EQ.1) .OR. (ICOL.EQ.6)) THEN
               RECORD(ICOL) = DDX
C                                       BMAX OR BMIN
            ELSE IF ((ICOL.EQ.4) .OR. (ICOL.EQ.5)) THEN
C                                       Convert to degrees
               RECORD(ICOL) = ABS(DDX/3600.)
C                                       Position
            ELSE
C                                       Not RA or DEC
               IF (ICTYPE(ICOL).EQ.1) THEN
                  XPOS(ICOL) = DDX
C                                       RA -> degrees
               ELSE IF (ICTYPE(ICOL).EQ.2) THEN
                  IF (J.EQ.1) XPOS(ICOL) = DDX
                  IF (J.EQ.2) XPOS(ICOL) = XPOS(ICOL) + DDX / 60.0D0
                  IF (J.EQ.3) XPOS(ICOL) = XPOS(ICOL) + DDX / 3600.0D0
                  J = J + 1
                  IF (J.LE.3) GO TO 115
                  XPOS(ICOL) = XPOS(ICOL) * 15.0D0
                  IF (XPOS(ICOL)-CATD(KDCRV+ICOL-1).GT.180.0D0) THEN
                     XPOS(ICOL) = XPOS(ICOL) - 360.0D0
                  ELSE IF (XPOS(ICOL)-CATD(KDCRV+ICOL-1) .LT.-180.0D0)
     *               THEN
                     XPOS(ICOL) = XPOS(ICOL) + 360.0D0
                     END IF
C                                       DEC -> degrees
               ELSE IF (ICTYPE(ICOL) .EQ. 3) THEN
                  IF (J.EQ.2) XPOS(ICOL) = DDX
                  IF (J.EQ.3) XPOS(ICOL) = XPOS(ICOL) + DDX / 60.0D0
                  IF (J.EQ.4) XPOS(ICOL) = XPOS(ICOL) + DDX / 3600.0D0
                  J = J + 1
                  IF (J.LE.4) GO TO 115
                  XPOS(ICOL) = XPOS(ICOL) * IS
                  END IF
               END IF
 140        CONTINUE
         CALL XYPIX (XPOS(2), XPOS(3), RECORD(2), RECORD(3), IERR)
         RECORD(2) = (RECORD(2) - RPLOC(1,LOCNUM)) * AXINC(1,LOCNUM)
         RECORD(3) = (RECORD(3) - RPLOC(2,LOCNUM)) * AXINC(2,LOCNUM)
         CALL TABIO ('WRIT', 0, IRNO, RECORD, BUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1150) IERR
            CALL MSGWRT (8)
            GO TO 960
            END IF
 190     CONTINUE
C                                       Normal EOF
 200  CALL TABIO ('CLOS', 0, IRNO, XPOS, BUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1150) IERR
         CALL MSGWRT (8)
         GO TO 960
         END IF
      WRITE (MSGTXT,1210) IRNO, OUVER
      CALL MSGWRT (4)
      IRETCD = 0
C                                       Add to history file
      CALL HIINIT (3)
      CALL HIOPEN (HLUN, IVOL, ISLOT, IWBUFF, IER)
      IF (IER.NE.0) GO TO 970
C                                       Prepare text and add to file
      CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, ATIME, ADATE)
      WRITE (SBUF,1211,ERR=215) TSKNAM, OUVER, IRNO, ADATE, ATIME
 215  HILINE = SBUF
      CALL HIADD (HLUN, HILINE, IWBUFF, IER)
      CALL HICLOS (HLUN, T, IWBUFF, IER)
      GO TO 970
C                                       ERRORS:
C                                       Kill the ST file
 960  CALL ZCLOSE (SLUN, BUF(82), IERR)
      CALL H2CHR (24, 1, BUF(17), STFILE)
      CALL ZDESTR (IVOL, STFILE, IERR)
      DO 965 I = 1,KIEXTN
         J = I - 1
         CALL H2CHR (2, 1, CATH(KHEXT+J), CHTM12)
         EQUAL = CHTM12(1:2) .EQ. 'ST'
         IF (.NOT.EQUAL) GO TO 965
            IF (OUVER.EQ.CATBLK(KIVER+J)) CATBLK(KIVER+J) =
     *         CATBLK(KIVER+J) - 1
            SAVE = T
            GO TO 970
 965     CONTINUE
C                                       Close the text file
 970  CALL ZTXCLS (RLUN, RIND, IERR)
C                                       Close map file.
 980  CALL MAPCLS ('WRIT', IVOL, ISLOT, IMLUN, IMFIND, CATBLK, SAVE,
     *   IWBUFF, IERR)
C
 990  CALL DIETSK (IRETCD, QUICK, IWBUFF)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR GETTING PARAMETERS FROM AIPS. GTPARM ERR =',I5)
 1020 FORMAT ('ERROR',I4,' OPENING TEXT FILE')
 1030 FORMAT ('ERROR',I4,' CREATING/OPENING CC FILE VERSION',I4)
 1100 FORMAT ('ERROR',I4,' READING TEXT FILE')
 1115 FORMAT ('ERROR PARSING LINE',I6,': LINE IGNORED')
 1150 FORMAT ('ERROR',I4,' WRITING CC FILE')
 1210 FORMAT ('Wrote',I6,' lines in CC file version',I4)
 1211 FORMAT (A6,' Version=',I3,' Lines=',I5,
     *   '  / CC file created ',A,A)
      END

      CHARACTER FUNCTION ZSCHAR (CNAME)
C-----------------------------------------------------------------------
C! Return special characters
C# Z Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C Returns the special character denoted by CNAME or the closest
C equivalent if that character is not supported on this system.
C The possible values for CNAME are:
C
C     backslash
C     alert
C     form-feed
C     new-line
C     cr
C     tab
C     vt
C
C 'alert' is the character that causes the terminal to beep, 'cr'
C is the carriage return character, 'tab' is the horizontal tab
C character and 'vt' is the vertical tab character. The backslash
C character is regarded as special because FORTRAN compilers often
C have problems dealing with it under Unix.
C
C Inputs:
C    CNAME      C*(*)    The name of the character to be returned.
C                        This must be given in full and must be
C                        either upper or lower-case (but not a
C                        mixture of the two.
C
C Returned value
C    ZSCHAR     C*1      The character corresponding to CNAME if
C                        the value of CNAME appears in the list
C                        given above or the question mark
C                        character ('?') if not.
C
C This version is for machines using ASCII encoding and European
C variants.
C-----------------------------------------------------------------------
      CHARACTER CNAME*(*)
C-----------------------------------------------------------------------
      IF ((CNAME.EQ.'backslash').OR.(CNAME.EQ.'BACKSLASH')) THEN
         ZSCHAR = CHAR (92)
      ELSE IF ((CNAME.EQ.'alert').OR.(CNAME.EQ.'ALERT')) THEN
         ZSCHAR = CHAR (7)
      ELSE IF ((CNAME.EQ.'form-feed').OR.(CNAME.EQ.'FORM-FEED')) THEN
         ZSCHAR = CHAR (11)
      ELSE IF ((CNAME.EQ.'new-line').OR.(CNAME.EQ.'NEW-LINE')) THEN
         ZSCHAR = CHAR (10)
      ELSE IF ((CNAME.EQ.'cr').OR.(CNAME.EQ.'CR')) THEN
         ZSCHAR = CHAR (13)
      ELSE IF ((CNAME.EQ.'tab').OR.(CNAME.EQ.'TAB')) THEN
         ZSCHAR = CHAR (9)
      ELSE IF ((CNAME.EQ.'vt').OR.(CNAME.EQ.'VT')) THEN
         ZSCHAR = CHAR (11)
      ELSE
         ZSCHAR = '?'
         END IF
      RETURN
      END

      PROGRAM VTESS
C-----------------------------------------------------------------------
C! Maximum entropy deconvolution.
C# Map AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1999, 2002-2003, 2006-2008, 2012, 2015, 2019,
C;  Copyright (C) 2021-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   VTESS deconvolves an image by maximising the "entropy" of the image.
C   Details of the algorithm are described in "A simple Maximum Entropy
C   Deconvolution Algorithm" in A+A (1985), Cornwell, T.J., Evans, K.F.
C     This version performs tesselation of images, and allows asymmetric
C   beams. It also does convolutions the quick way. An output CLEAN-type
C   image is formed if BMAJ > 0.0.
C
C   INPUTS:
C   AIPS name    Prog. name     Description
C   INNAME       NAME(1)        Dirty image name (name)
C   INCLASS      CLASS(1)       Dirty image name (class)
C   INSEQ        SEQ(1)         Dirty image name (sequence number)
C   INDISK       VOL(1)         Dirty image name (disk number)
C   IN2NAME      NAME(2)        Beam image name (name)
C   IN2CLASS     CLASS(2)       Beam image name (class)
C   IN2SEQ       SEQ(2)         Beam image name (sequence number)
C   IN2DISK      VOL(2)         Beam image name (disk number)
C   IN3NAME      NAME(4)        Default image name (name)
C   IN3CLASS     CLASS(4)       Default image name (class)
C   IN3SEQ       SEQ(4)         Default image name (sequence number)
C   IN3DISK      VOL(4)         Default image name (disk number)
C   OUTNAME      NAME(3)        Output image name (name)
C   OUTCLASS     CLASS(3)       Output image name (class)
C   OUTSEQ       SEQ(3)         Output image name (sequence number)
C   OUTDISK      VOL(3)         Output image name (disk number)
C   OUT2NAME     NAME(5)        Restored image name (name)
C   OUT2CLAS     CLASS(5)       Restored image name (class)
C   OUT2SEQ      SEQ(5)         Restored image name (sequence number)
C   OUT2DISK     VOL(5)         Restored image name (disk number)
C   NMAPS        NFIELD         Number of fields to deconvolve
C   NITER        NITER          Maximum number of iterations
C   NOISE        FRES           Required rms noise (Jy/beam)
C   FLUX         FLUX           Zero spacing flux (Jy)
C   BLC          BLC            Bottom left-hand corner of image
C   TRC          TRC            Top right-hand corner of image
C   DOTV         ITV            TV display of image?
C   PRTLEV       LNGOUT         Extended print-out?
C   PBSIZE       BMSIZE         Primary beam size (arcsec) for each
C                                  input map
C   BMAJ         BMAJ           Major axis (arcsec) of convolving beam
C   BMIN         BMIN           Minor axis (arcsec) of convolving beam
C   BPA          BPA            PA (degrees) of convolving beam
C   BADDISK      IBAD           List of disks on which not to put
C                                  scratch files
C   Programmer = T. J. Cornwell                         December 1987
C-----------------------------------------------------------------------
      HOLLERITH CATH(256)
      INTEGER   TVPASS, IRET, LUN2, LUN1, IOCNT(2), USID, VOL(5),
     *   SEQ(5), CATBLK(256), TTIME(3), IFIELD, ITER, ITV, FIL, KAP,
     *   LOCS(2), VALUES(24), KEYTYP(2)
      LOGICAL   FINISH, OLD, CNVRGE
      REAL      CATR(256), DEFLEV, SCLF1, OSCLF, CPUTIM, FILMAX, FILMIN,
     *   TOL, ANGEF, FSMALL, VALUER(24)
      DOUBLE PRECISION APCORE(2)
      CHARACTER HILINE*72, NAME(5)*12, CLASS(5)*6, KWORDS(2)*8
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DAPM.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (VALUES, VALUER)
      EQUIVALENCE (CATR(1), CATH(1), CATBLK(1))
      DATA FSMALL /1E-8/
C                                           Tolerance for solution
      DATA TOL/0.05/
      DATA KWORDS /'ALPHA   ', 'BETA    '/
C-----------------------------------------------------------------------
C
C *********************************************************************
C
C                        INITIALIZATION PHASE
C
C *********************************************************************
C
C                                       Initialize common constants
      T = .TRUE.
      F = .FALSE.
      MAP = .TRUE.
      EXCL = .TRUE.
      WAIT = .TRUE.
      IERR = 0
      IRET = 0
      LUN1 = 16
      LUN2 = 17
      ITER = 0
      NCFILE = 0
      FINISH = .FALSE.
      SCLF = 1.0
C                                       Get input values.
      CALL GETIN (USID, NAME, VOL, CLASS, SEQ, ITV, IRET)
C                                       Check for restart of AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFFR1, IERR)
      IF (IRET.NE.0) GO TO 990
C                                       Get map files and create
C                                       output files if required.
C                                       Sets AP size for later too
      CALL FILES (APCORE, USID, NAME, VOL, CLASS, SEQ, OLD, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (OLD) THEN
         IF (CHAN.EQ.1) THEN
            VMSTR = CATBLK(KINIT)
         ELSE
            VMSTR = 0
            ALPINI = 0.0
            BETINI = 0.0
            END IF
         IF (VMSTR.GT.0) ITER = VMSTR
         WRITE (MSGTXT,1000) VMSTR
         CALL MSGWRT (4)
         END IF
C                                       Write inputs to history and
C                                       log files.
      CALL VMHIS (NAME, VOL, CLASS, SEQ, OLD, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Initialize images
      IF (.NOT.DEFEXT) THEN
         DEFLEV = ABS(TFLUX) / RWNXY
         IF (DEFLEV.EQ.0.0) DEFLEV = FRES(1) / RVAR(1)
         CALL FLAT (DEFLEV, DEF, IERR)
         IF (IERR.NE.0) GO TO 990
         DEFMAX = DEFLEV
         DEFMIN = DEFLEV
      ELSE
C                                       Clip neg. from image.
         CALL COPMAP (DEF, DEF, FSMALL, DEFMAX, DEFMIN, IERR)
         IF (ITV.GT.0) THEN
            CALL QINIT (APCORE, 0, 0, KAP)
            IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
               MSGTXT = 'UNABLE TO GET AP MEMORY FOR TV DISPLAY'
               CALL MSGWRT (8)
               IERR = 10
               GO TO 990
               END IF
            WRITE (MSGTXT,1010)
            CALL MSGWRT (4)
            TVPASS = -1
            CALL DISPTV (DEF, DEFMAX, DEFMIN, TVPASS)
            CALL QRLSE
            END IF
         END IF
C
      IF (.NOT.OLD) THEN
         CALL COPMAP (DEF, IMG, FSMALL, IMGMAX, IMGMIN, IERR)
         IF (IERR.NE.0) GO TO 990
      ELSE
         CALL BGTOSM (VMOUT, IMG, IERR)
         CALL COPMAP (IMG, IMG, FSMALL, IMGMAX, IMGMIN, IERR)
         IF (IERR.NE.0) GO TO 990
         IF (IMGMAX.LE.FSMALL) THEN
            CALL COPMAP (DEF, IMG, FSMALL, IMGMAX, IMGMIN, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
         END IF
      IMGMIN = MAX(IMGMIN, FSMALL)
C                                       Calculate residuals of image
      CALL CALRES (APCORE, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Set initial values of
C                                       Lagrange multipliers
      ALPHA = 0.0
      IF (ALPINI.GT.0.0) ALPHA = ALPINI
      BETA =  0.0
      IF ((BETINI.NE.0.0).AND.(TFLUX.GT.0.0)) BETA  = BETINI
      TVPASS = 1
C                                       Stop if default image fits OK
      IF (FITRMS.LT.(1+TOL)) THEN
         WRITE (MSGTXT,1200) FITRMS
         CALL MSGWRT (4)
         IF (DOSTOP) THEN
            CNVRGE=.TRUE.
            DOSTOP=.TRUE.
            FINISH = .TRUE.
            GO TO 200
            END IF
         END IF
C                                       Find first changes to ALPHA,
C                                       BETA
      CALL CHALBT (APCORE, RES, IMG, DEF, IERR)
      IF (IERR.NE.0) GO TO 990
C                                        Output useful info
      WRITE (MSGTXT,1001)
      CALL MSGWRT (4)
      IF (LNGOUT) THEN
         WRITE (MSGTXT,1035) GRDJSQ
         CALL MSGWRT (4)
         WRITE (MSGTXT,1037) GRDHSQ,GRDESQ,GRDFSQ
         CALL MSGWRT (4)
         WRITE (MSGTXT,1038) GRDHE,GRDHF,GRDEF
         CALL MSGWRT (4)
         ANGEF = 57.2957*ACOS (GRDEF / SQRT (GRDESQ*GRDFSQ))
         WRITE (MSGTXT,1039) ANGEF
         CALL MSGWRT (4)
         WRITE (MSGTXT,1040) RNPPB,SCLF
         CALL MSGWRT (4)
         WRITE (MSGTXT,1050) RL0
         CALL MSGWRT (4)
         WRITE (MSGTXT,1060) ALPHA,BETA
         CALL MSGWRT (4)
         DO 104 IFIELD=1,NFIELD
            WRITE (MSGTXT,2006) IFIELD, FFIT(IFIELD)
            CALL MSGWRT (4)
 104     CONTINUE
      ELSE
         WRITE (MSGTXT,1070) EPSSTR,RL0,RNPPB
         CALL MSGWRT (4)
         END IF
      WRITE (MSGTXT,1080) FLUX,FITRMS
      CALL MSGWRT (4)
      WRITE (MSGTXT,1090) IMGMAX,IMGMIN
      CALL MSGWRT (4)
C
C
C *********************************************************************
C
C                        ITERATION PHASE
C
C *********************************************************************
C
C
 100  CONTINUE
C                                       Check TELL file
         CALL VTTELL (ITER, FINISH, ITV, TVPASS, IRET)
         IF (IRET.NE.0) GO TO 990
         ITER = ITER + 1
         IF (ITER.GE.VMLIM) FINISH = T
         CALL ZCPU (CPUTIM, IOCNT)
         CALL ZTIME (TTIME)
         WRITE (MSGTXT,1020) ITER, TTIME(1), TTIME(2), TTIME(3),
     *     CPUTIM
         CALL MSGWRT (4)
C                                       Calculate step
         CALL CALSTP (APCORE, RES, IMG, DEF, DEL, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Take step
         CALL STEP (IMG, DEL, 0.1*IMGMIN+FSMALL, SCLF, IERR)
         IF (IERR.NE.0) GO TO 990
         OSCLF = SCLF
C                                       Recalculate residuals
      CALL CALRES (APCORE, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Check TELL file
      CALL VTTELL (ITER, FINISH, ITV, TVPASS, IRET)
      IF (IRET.NE.0) GO TO 990
C                                        Find gradJ dot step to
C                                        determine optimum step length
      CALL DOTGRD (APCORE, RES, IMG, DEF, DEL, IERR)
      IF (IERR.NE.0) GO TO 990
C                                         Rescale
      RNPPB = RNPPB * (1.0/MAX(0.5,MIN(2.0,EPSSTR)) + 1.0) / 2
C                                        Step back to new place
      IF ((EPSSTR.NE.0.0).AND.(ABS(EPSSTR-1.0).GT.GAIN)) THEN
         SCLF = 1.0
         IF (RL0.GT.0.0) SCLF = EPSSTR*OSCLF
         SCLF1 = SCLF - OSCLF
         CALL STEP (IMG, DEL, 0.1*IMGMIN+FSMALL, SCLF1, IERR)
         IF (IERR.NE.0) GO TO 990
C                                        Find residuals of new image
         CALL CALRES (APCORE, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                        Find Current gradient
      CALL CHALBT (APCORE, RES, IMG, DEF, IERR)
      IF (IERR.NE.0) GO TO 990
C                                         Output useful info
      IF (LNGOUT) THEN
         WRITE (MSGTXT,1030) EPSSTR, RJ0, RJ1
         CALL MSGWRT (4)
         WRITE (MSGTXT,1035) GRDJSQ
         CALL MSGWRT (4)
         WRITE (MSGTXT,1037) GRDHSQ, GRDESQ, GRDFSQ
         CALL MSGWRT (4)
         WRITE (MSGTXT,1038) GRDHE,GRDHF,GRDEF
         CALL MSGWRT (4)
         ANGEF = 57.2957 * ACOS (GRDEF / SQRT (GRDESQ*GRDFSQ))
         WRITE (MSGTXT,1039) ANGEF
         CALL MSGWRT (4)
         WRITE (MSGTXT,1040) RNPPB, SCLF
         CALL MSGWRT (4)
         WRITE (MSGTXT,1050) RL0
         CALL MSGWRT (4)
         WRITE (MSGTXT,1060) ALPHA, BETA
         CALL MSGWRT (4)
         DO 204 IFIELD=1,NFIELD
            WRITE (MSGTXT,2006) IFIELD, FFIT(IFIELD)
            CALL MSGWRT (4)
 204        CONTINUE
      ELSE
         WRITE (MSGTXT,1070) EPSSTR, RL0, RNPPB
         CALL MSGWRT (4)
         END IF
      WRITE (MSGTXT,1080) FLUX, FITRMS
      CALL MSGWRT (4)
      WRITE (MSGTXT,1090) IMGMAX, IMGMIN
      CALL MSGWRT (4)
C                                        If appropiate suggest stopping
         CNVRGE = (FITRMS.LT.(1.0+TOL)) .AND.
     *      (ITER.NE.1) .AND. (ITER.NE.VMSTR) .AND. (RL0.LT.TOL)
         IF (TFLUX.GT.0.0) CNVRGE = CNVRGE .AND.
     *      (ABS(FLUX-TFLUX).LT.TOL*TFLUX)
C         IF (RL0.LE.0.0) DOSTOP = T
         IF (CNVRGE) THEN
            IF (DOSTOP) THEN
               FINISH = T
            ELSE
               GAIN = RL0
               END IF
            END IF
C                                       Display current VTESS map.
         IF (ITV.GT.0) THEN
            FIL = IMG
            FILMAX = IMGMAX
            FILMIN = IMGMIN
            IF (ITV.EQ.2) FIL = RES
            IF (ITV.EQ.2) FILMAX = RESMAX
            IF (ITV.EQ.2) FILMIN = RESMIN
            CALL QINIT (APCORE, 0, 0, KAP)
            IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
               MSGTXT = 'UNABLE TO GET AP MEMORY FOR TV DISPLAY'
               CALL MSGWRT (8)
               IERR = 10
               GO TO 990
               END IF
            IF (FINISH) TVPASS = -2
            CALL DISPTV (FIL, FILMAX, FILMIN, TVPASS)
            IF (TVPASS.EQ.32700)  FINISH = T
            TVPASS = 2
            CALL QRLSE
            END IF
C                                       Output Current VTESS map
 200     CONTINUE
         CALL CATIO ('READ', VOL(3), SCRCNO(SCRNM(VMOUT)), CATBLK,
     *      'REST', BUFFR3, IERR)
         IF ((IERR.NE.0) .AND. (IERR.LT.5)) THEN
            WRITE (MSGTXT,1120) IERR
            CALL MSGWRT (4)
            IERR = 0
            END IF
         CATBLK(KINIT) = ITER
         CATR(KRDMX) = IMGMAX
         CATR(KRDMN) = 0.0
         CATBLK(KITYP) = 4
C                                       Update VTESS catalog header
         CALL CATIO ('UPDT', VOL(3), SCRCNO(SCRNM(VMOUT)), CATBLK,
     *      'REST', BUFFR3, IERR)
         IF ((IERR.NE.0) .AND. (IERR.LT.5)) THEN
            WRITE (MSGTXT,1120) IERR
            CALL MSGWRT (4)
            IERR = 0
            END IF
C                                       Write into output file.
      CALL SMTOBG (IMG, 0.0, VMOUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Write ALPHA, BETA
      LOCS(1) = 1
      LOCS(2) = 2
      KEYTYP(1) = 2
      KEYTYP(2) = 2
      CALL RCOPY (1, ALPHA, VALUER(LOCS(1)))
      CALL RCOPY (1, BETA, VALUER(LOCS(2)))
      CALL CATKEY ('WRIT', VOL(3), SCRCNO(SCRNM(VMOUT)),
     1   KWORDS, 2, LOCS, VALUES, KEYTYP, BUFFR1, IERR)
C                                       If more VTESS required, loop
      IF (.NOT.FINISH) GO TO 100
C
C
C *********************************************************************
C
C                        FINISHING UP
C
C *********************************************************************
C
C                                       Diagnose result
      IF ((FITRMS.LT.(1.0+TOL)).AND.
     *    (((TFLUX.GT.0.0).AND.(ABS(TFLUX-FLUX).LT.TOL*FLUX)).OR.
     *    (TFLUX.LE.0.0))) THEN
         WRITE (MSGTXT,1340)
         CALL MSGWRT (4)
         IF (RL0.LT.TOL) THEN
            WRITE (MSGTXT,1320) RL0, TOL
            CALL MSGWRT (4)
            WRITE (MSGTXT,1300)
            CALL MSGWRT (4)
         ELSE
            WRITE (MSGTXT,1330) RL0, TOL
            CALL MSGWRT (4)
            WRITE (MSGTXT,1310)
            CALL MSGWRT (4)
            END IF
      ELSE
         WRITE (MSGTXT,1350)
         CALL MSGWRT (4)
         WRITE (MSGTXT,1310)
         CALL MSGWRT (4)
         END IF
C
      IF (.NOT.LNGOUT) THEN
         DO 304 IFIELD=1,NFIELD
            WRITE (MSGTXT,2006) IFIELD, FFIT(IFIELD)
            CALL MSGWRT (4)
 304        CONTINUE
            END IF
C
C                                       Put stuff in history file
      CALL HIOPEN (LUN1, VOL(3), SCRCNO(SCRNM(VMOUT)), BUFFR1, IERR)
      IF (IERR.NE.0) GO TO 260
      WRITE (HILINE,1130) TSKNAM, FITRMS
      CALL HIADD (LUN1, HILINE, BUFFR1, IERR)
      IF (IERR.NE.0) GO TO 260
      WRITE (HILINE,1140) TSKNAM, FLUX
      CALL HIADD (LUN1, HILINE, BUFFR1, IERR)
      IF (IERR.NE.0) GO TO 260
      WRITE (HILINE,1150) TSKNAM, RL0
      CALL HIADD (LUN1, HILINE, BUFFR1, IERR)
      IF (IERR.NE.0) GO TO 260
      WRITE (HILINE,1160) TSKNAM, ITER
      CALL HIADD (LUN1, HILINE, BUFFR1, IERR)
      IF (IERR.NE.0) GO TO 260
      WRITE (HILINE,1170) TSKNAM, ALPHA
      CALL HIADD (LUN1, HILINE, BUFFR1, IERR)
      IF (IERR.NE.0) GO TO 260
      WRITE (HILINE,1180) TSKNAM, BETA
      CALL HIADD (LUN1, HILINE, BUFFR1, IERR)
      IF (IERR.NE.0) GO TO 260
      WRITE (HILINE,1190) TSKNAM, RNPPB
      CALL HIADD (LUN1, HILINE, BUFFR1, IERR)
      IF (IERR.NE.0) GO TO 260
C
 260  CALL HICLOS (LUN1, T, BUFFR1, IERR)
C
      IF (BMAJ.GT.0.0) THEN
         CALL MAKCVM (APCORE, IMG, DEL, IERR)
         CALL CATIO ('READ', VOL(5), SCRCNO(SCRNM(CVMOUT)), CATBLK,
     *      'REST', BUFFR3, IERR)
         CALL SMTOBG (DEL, 0.0, CVMOUT, IERR)
         CALL KEYPCP (VOL(3), SCRCNO(SCRNM(VMOUT)), VOL(5),
     *       SCRCNO(SCRNM(CVMOUT)), 0, ' ', IERR)
         CALL HISCOP (LUN2, LUN1, VOL(3), VOL(5), SCRCNO(SCRNM(VMOUT)),
     *       SCRCNO(SCRNM(CVMOUT)), CATBLK, BUFFR1, BUFFR2, IERR)
C                                       HISCOP does not close copied
C                                       history file; add HICLOS.
         CALL HICLOS (LUN1, T, BUFFR1, IERR)
C                                       Update header
         IF ((IERR.NE.0) .AND. (IERR.LT.5)) THEN
            WRITE (MSGTXT,1120) IERR
            CALL MSGWRT (4)
            IERR = 0
            END IF
         CATBLK(KINIT) = ITER
         CATR(KRDMX) = RESMAX
         CATR(KRDMN) = RESMIN
         CATR(KRBMJ) = BMAJ/3600.0
         CATR(KRBMN) = BMIN/3600.0
         CATR(KRBPA) = BPA
         CATBLK(KITYP) = 1
C                                       Update catalog header
         CALL CATIO ('UPDT', VOL(5), SCRCNO(SCRNM(CVMOUT)), CATBLK,
     *      'REST', BUFFR3, IERR)
         IF ((IERR.NE.0) .AND. (IERR.LT.5)) THEN
            WRITE (MSGTXT,1120) IERR
            CALL MSGWRT (4)
            IERR = 0
            END IF
         END IF
C                                        Finished.
 990  IRET = IERR
      CALL DIE (IRET, BUFFR1)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('Restarting VTESS after',I6,' iterations')
 1001 FORMAT ('Initial conditions :')
 1010 FORMAT ('Displaying default image')
 1020 FORMAT ('Iteration:',I6,'  at ',I2,':',I2,':',I2,
     *   '    CPU time : ',F10.2)
 1030 FORMAT ('  Step length,J0,J1:',3(1X,1PE11.3))
 1035 FORMAT ('  Grad. J     : ',1PE11.3)
 1037 FORMAT ('  Grad. H,E,F    : ',3(1X,1PE11.3))
 1038 FORMAT ('  Grad. HE,HF,EF : ',3(1X,1PE11.3))
 1039 FORMAT ('  Angle between Grad E and Grad F = ',F7.2,' degrees')
 1040 FORMAT ('  Npoints : ',1PE11.3,' SCLF : ',1PE11.3)
 1050 FORMAT ('  Gradient : ',1PE11.3)
 1060 FORMAT ('  Alpha : ',1PE12.3,' , Beta  : ',1PE12.3)
 1070 FORMAT ('  Step, Gradient, Npoints : ',F8.3,1X,F9.5,1X,F8.2)
 1080 FORMAT ('  Flux, error achieved : ',1PE11.3,' Jy,',
     *         1PE11.3,' sigma')
 1090 FORMAT ('  Image max,min   : ',2(1PE11.3,1X),' Jy/pixel')
 2006 FORMAT ('  Field',I5,' : Error = ',1PE11.3,' sigma')
 1120 FORMAT ('ERROR',I3,' UPDATING VTESS HEADER ')
 1130 FORMAT (A6,'/ Rms residual =',1PE12.4,' sigma')
 1140 FORMAT (A6,'/ Total flux = ',1PE12.4,' Jy')
 1150 FORMAT (A6,'/ Gradient =',1PE11.3)
 1160 FORMAT (A6,'/ Number of iterations =',I6)
 1170 FORMAT (A6,'/ Final alpha = ',1PE12.4)
 1180 FORMAT (A6,'/ Final beta  = ',1PE12.4)
 1190 FORMAT (A6,'/ Final npoints = ',1PE12.4)
 1200 FORMAT ('  Initial image fits data : error = ',1PE12.4,
     *   ' sigma')
 1300 FORMAT ('*** Good solution obtained ***')
 1310 FORMAT ('*** NO SOLUTION OBTAINED: REVISE INPUTS AND',
     *   ' TRY AGAIN ***')
 1320 FORMAT ('*** Final gradient = ',F7.4,' < ',F7.4,' ***')
 1330 FORMAT ('*** Final gradient = ',F7.4,' > ',F7.4,' ***')
 1340 FORMAT ('*** Reached target flux and fit ***')
 1350 FORMAT ('*** FAILED TO REACH TARGET FLUX AND FIT ***')
      END
      SUBROUTINE CALSTP (APCORE, IN1, IN2, IN3, OUT, IERR)
C-----------------------------------------------------------------------
C   CALSTP finds the gradient search direction by using the Newton-
C   Raphson method. The part of the Hessian due to the beam sidelobes
C   is neglected.
C   Programmer =  T.J. Cornwell      December 1987
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   IN1, IN2, IN3, OUT, IFIELD, KAP
      REAL      LENGTH, RTEMP(7), GGC
      INTEGER   APBASE, APRES, APIMG, APDEF, APSTP, APGRDS, APALP,
     *   NELEM
      INTEGER   AKOPEN, AKCESS, AKCLOS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DAPM.INC'
C-----------------------------------------------------------------------
      IERR = 0
      GGC = 0.0
      DO 10 IFIELD = 1,NFIELD
         GGC = GGC + 2*ALPHA*RNPPB*(RVAR(IFIELD)/FRES(IFIELD))**2
 10      CONTINUE
C                                      Load AP with useful constants
      CALL QINIT (APCORE, 0, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
         MSGTXT = 'CALSTP: UNABLE TO GET AP MEMORY BACK'
         CALL MSGWRT (8)
         IERR = 10
         GO TO 990
         END IF
C
      APBASE = 0
      APALP = APBASE
      APGRDS = APBASE + 4
      APRES = APBASE + 16
C
      RTEMP(1) = - ALPHA
      RTEMP(2) = - BETA
      RTEMP(3) = GGC
      RTEMP(4) = 1.0
      CALL QPUT (APCORE, RTEMP, APALP, 4, 2)
C                                      Clear accumulators in AP
      CALL QVCLR (APCORE, APGRDS, 1, 7)
C                                      Calculate addresses
      NELEM = XEND - XBEG + 1
      APIMG = APRES + NELEM
      APDEF = APIMG + NELEM
      APSTP = APDEF + NELEM
C
      IF (AKOPEN (IN1,1,'READ',BUFFR1).NE.0) GO TO 990
      IF (AKOPEN (IN2,2,'READ',BUFFR2).NE.0) GO TO 990
      IF (AKOPEN (IN3,3,'READ',BUFFR3).NE.0) GO TO 990
      IF (AKOPEN (OUT,4,'WRIT',BUFFR4).NE.0) GO TO 990
C                                       Loop through map
      DO 200 IY = 1,HNY
         IF (AKCESS (OUT,BUFFR4).NE.0) GO TO 990
C                                        Do calculations
         IF ((IY.LT.YBEG) .OR. (IY.GT.YEND)) GO TO 200
            IF (AKCESS (IN1,BUFFR1).NE.0) GO TO 990
            IF (AKCESS (IN2,BUFFR2).NE.0) GO TO 990
            IF (AKCESS (IN3,BUFFR3).NE.0) GO TO 990
            I1 = BIND(1)
            I2 = BIND(2)
            I3 = BIND(3)
            I4 = BIND(4) + XBEG - 1
C
         CALL QPUT (APCORE, BUFFR1(I1), APRES, NELEM, 2)
         CALL QPUT (APCORE, BUFFR2(I2), APIMG, NELEM, 2)
         CALL QPUT (APCORE, BUFFR3(I3), APDEF, NELEM, 2)
         CALL QWD
         CALL QMENT (APCORE, APBASE, 1, APIMG, APDEF, APRES,
     *      APSTP, NELEM)
         CALL QWR
         CALL QGET (APCORE, BUFFR4(I4), APSTP, NELEM, 2)
         CALL QWD
 200     CONTINUE
C
      IF (AKCLOS (IN1,BUFFR1).NE.0) GO TO 990
      IF (AKCLOS (IN2,BUFFR2).NE.0) GO TO 990
      IF (AKCLOS (IN3,BUFFR3).NE.0) GO TO 990
      IF (AKCLOS (OUT,BUFFR4).NE.0) GO TO 990
C                                      Get results
      CALL QGET (APCORE, RTEMP, APGRDS, 7, 2)
      CALL QWD
C
      GRDHSQ = RTEMP(1)
      GRDESQ = RTEMP(2)
      GRDFSQ = RTEMP(3)
      GRDHE  = RTEMP(4)
      GRDHF  = RTEMP(5)
      GRDEF  = RTEMP(6)
      FLUX   = RTEMP(7)
C
      CALL QRLSE
C
      IF (GRDHSQ.LT.1E-10) GRDHSQ = 0.0
      LENGTH = GRDHSQ + ALPHA**2*GRDESQ + BETA**2*GRDFSQ
      IF (LENGTH.LE.0.0) THEN
         LENGTH = GRDFSQ
         END IF
      GRDJSQ = GRDHSQ + ALPHA**2*GRDESQ + BETA**2*GRDFSQ
     *   - 2.0*ALPHA*GRDHE - 2.0*BETA*GRDHF + 2.0*ALPHA*BETA*GRDEF
C
      RL0 = 0.0
      IF (GRDJSQ.LE.1E-8) GRDJSQ = 0.0
      IF ((GRDFSQ.GT.0.0).AND.(GRDJSQ.GT.0.0)) RL0 = GRDJSQ/LENGTH
      IF (ALPHA.EQ.0.0) RL0 = 0.0
      RJ0 = GRDJSQ
      SCLF = 1.0
      IF (RL0.GT.0.0) SCLF = MIN (1.0, GAIN/RL0)
      GO TO 999
C
 990  WRITE (MSGTXT,1000)
      CALL MSGWRT (8)
      IERR = 1
C
 999  CONTINUE
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CALSTP')
      END
      SUBROUTINE CHALBT (APCORE, IN1, IN2, IN3, IERR)
C-----------------------------------------------------------------------
C   CHALBT calculate the norms and cross norms of the gradient vectors
C   in order to calculate how much to change ALPHA and BETA
C   Programmer =  T.J. Cornwell      December 1987
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   IN1, IN2, IN3, IFIELD, KAP
      REAL      B2M4AC, LENGTH, RTEMP(7), DET, GGC, DELE, DELF
      INTEGER   APBASE, APRES, APIMG, APDEF, APSTP, APGRDS, APALP,
     *   NELEM
      INTEGER   AKOPEN, AKCESS, AKCLOS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DAPM.INC'
C-----------------------------------------------------------------------
      IERR = 0
C
      GGC = 0.0
      DO 10 IFIELD = 1,NFIELD
         GGC = GGC + 2*ALPHA*RNPPB*(RVAR(IFIELD)/FRES(IFIELD))**2
 10      CONTINUE
C                                      Load AP with useful constants
      CALL QINIT (APCORE, 0, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
         MSGTXT = 'CHALBT: UNABLE TO GET AP MEMORY BACK'
         CALL MSGWRT (8)
         IERR = 10
         GO TO 990
         END IF
C
      APBASE = 0
      APALP = APBASE
      APGRDS = APBASE + 4
      APRES = APBASE + 16
      RTEMP(1) = - ALPHA
      RTEMP(2) = - BETA
      RTEMP(3) = GGC
      RTEMP(4) = 1.0
      CALL QPUT (APCORE, RTEMP, APALP, 4, 2)
C                                      Clear accumulators in AP
      CALL QVCLR (APCORE, APGRDS, 1, 7)
C                                      Calculate addresses
      NELEM = XEND - XBEG + 1
      APIMG = APRES + NELEM
      APDEF = APIMG + NELEM
      APSTP = APDEF + NELEM
C
      IF (AKOPEN (IN1,1,'READ',BUFFR1).NE.0) GO TO 990
      IF (AKOPEN (IN2,2,'READ',BUFFR2).NE.0) GO TO 990
      IF (AKOPEN (IN3,3,'READ',BUFFR3).NE.0) GO TO 990
C                                       Loop through map
      DO 200 IY = YBEG, YEND
         IF (AKCESS (IN1,BUFFR1).NE.0) GO TO 990
         IF (AKCESS (IN2,BUFFR2).NE.0) GO TO 990
         IF (AKCESS (IN3,BUFFR3).NE.0) GO TO 990
C                                        Do calculations
         I1 = BIND(1)
         I2 = BIND(2)
         I3 = BIND(3)
C                                        Load data into AP
         CALL QPUT (APCORE, BUFFR1(I1), APRES, NELEM, 2)
         CALL QPUT (APCORE, BUFFR2(I2), APIMG, NELEM, 2)
         CALL QPUT (APCORE, BUFFR3(I3), APDEF, NELEM, 2)
C                                        Wait for transfer
         CALL QWD
C                                        Call MEM Q-Routine
         CALL QMENT (APCORE, APBASE, 1, APIMG, APDEF, APRES, APSTP,
     *      NELEM)
C                                        Wait for calculation
         CALL QWR
C
 200     CONTINUE
C
      IF (AKCLOS (IN1,BUFFR1).NE.0) GO TO 990
      IF (AKCLOS (IN2,BUFFR2).NE.0) GO TO 990
      IF (AKCLOS (IN3,BUFFR3).NE.0) GO TO 990
C                                      Get results
      CALL QGET (APCORE, RTEMP, APGRDS, 7, 2)
      CALL QWD
C
      GRDHSQ = RTEMP(1)
      GRDESQ = RTEMP(2)
      GRDFSQ = RTEMP(3)
      GRDHE  = RTEMP(4)
      GRDHF  = RTEMP(5)
      GRDEF  = RTEMP(6)
      FLUX   = RTEMP(7)
C
      CALL QRLSE
C
      IF (GRDHSQ.LT.1E-10) GRDHSQ = 0.0
      GRDJE = GRDHE - ALPHA*GRDESQ - BETA*GRDEF
      GRDJF = GRDHF - ALPHA*GRDEF  - BETA*GRDFSQ
      LENGTH = GRDHSQ + ALPHA**2*GRDESQ + BETA**2*GRDFSQ
      IF (LENGTH.LE.0.0) THEN
         LENGTH = GRDFSQ
         END IF
      GRDJSQ = GRDHSQ + ALPHA**2*GRDESQ + BETA**2*GRDFSQ
     *   - 2.0*ALPHA*GRDHE - 2.0*BETA*GRDHF + 2.0*ALPHA*BETA*GRDEF
      RL0 = 0.0
      IF ((LENGTH.GT.0.0) .AND. (GRDJSQ.GT.0.0)) RL0 = GRDJSQ/LENGTH
      IF (ALPHA.EQ.0.0) RL0 = 0.0
      IF (RL0.GT.GAIN) GO TO 300
         DELAMX = 0.0
         DELBMX = 0.0
         DELAMN = 0.0
         DELBMN = 0.0
         B2M4AC = GRDJE**2 - (GRDJSQ-GAIN*LENGTH)*GRDESQ
         IF (B2M4AC.LT.0.0) GO TO 277
            DELAMX = (GRDJE+SQRT(B2M4AC))/(GRDESQ)
            DELAMN = (GRDJE-SQRT(B2M4AC))/(GRDESQ)
            B2M4AC = GRDJF**2 - (GRDJSQ-GAIN*LENGTH)*GRDFSQ
            IF (B2M4AC.LT.0.0) GO TO 277
               DELBMX = (GRDJF+SQRT(B2M4AC))/(GRDFSQ)
               DELBMN = (GRDJF-SQRT(B2M4AC))/(GRDFSQ)
 277  IF (TFLUX.LE.0.0) THEN
         DELE = NFIELD*RWNXY*(FITRMS**2 - 1.0)/RNPPB + GRDJE
         DELALP = DELE/GRDESQ
         DELALP = MAX(DELAMN, MIN(DELAMX, DELALP))
         ALPHA = MAX (0.0, ALPHA + DELALP)
      ELSE
         DET = GRDESQ*GRDFSQ - GRDEF**2
         DELE = NFIELD*RWNXY*(FITRMS**2 - 1.0)/RNPPB + GRDJE
         DELF = FLUX - TFLUX + GRDJF
         DELALP = (GRDFSQ * DELE - GRDEF * DELF) / DET
         DELBET = (GRDESQ * DELF - GRDEF * DELE) / DET
         DELALP = MAX(DELAMN, MIN(DELAMX, DELALP))
         ALPHA = MAX( 0.0, ALPHA + DELALP)
         DELBET = MAX(DELBMN, MIN(DELBMX, DELBET))
         BETA = BETA + DELBET
         END IF
      GO TO 999
C
 300  CONTINUE
C                                      Doing poorly : choose
C                                      ALPHA and BETA to minimise
C                                      the gradient
      IF (TFLUX.LE.0.0) THEN
         ALPHA = GRDHE/GRDESQ
         BETA = 0.0
      ELSE
         DET = GRDESQ*GRDFSQ - GRDEF**2
         ALPHA = (GRDFSQ*GRDHE - GRDEF*GRDHF)/DET
         BETA  = (GRDESQ*GRDHF - GRDEF*GRDHE)/DET
         END IF
      ALPHA = MAX(ALPHA, 0.0)
      GO TO 999
C
 990  WRITE (MSGTXT,1000)
      CALL MSGWRT (8)
      IERR = 1
C
 999  CONTINUE
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CHALBT')
      END
      SUBROUTINE DOTGRD (APCORE, IN1, IN2, IN3, IN4, IERR)
C-----------------------------------------------------------------------
C   DOTGRD calculates the dot product between the current gradJ and
C   the step and uses it to calculate the optimum step length (EPSSTR)
C   Programmer =  T.J. Cornwell      December 1987
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   IN1, IN2, IN3, IN4, IFIELD, KAP
      INTEGER   APBASE, APRES, APIMG, APDEF, APSTP, APGRDS, APALP,
     *   NELEM
      REAL      RTEMP(8), GGC
      INTEGER   AKOPEN, AKCESS, AKCLOS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DAPM.INC'
C-----------------------------------------------------------------------
C
      IERR = 0
      GGC = 0.0
      DO 10 IFIELD = 1,NFIELD
         GGC = GGC + 2*ALPHA*RNPPB*(RVAR(IFIELD)/FRES(IFIELD))**2
 10      CONTINUE
C                                      Load AP with useful constants
      CALL QINIT (APCORE, 0, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
         MSGTXT = 'DO2GRT: UNABLE TO GET AP MEMORY BACK'
         CALL MSGWRT (8)
         IERR = 10
         GO TO 990
         END IF
C
      APBASE = 0
      APALP = APBASE
      APGRDS = APBASE + 4
      APRES = APBASE + 16
C
      RTEMP(1) = - ALPHA
      RTEMP(2) = - BETA
      RTEMP(3) = GGC
      RTEMP(4) = 1.0
      CALL QPUT (APCORE, RTEMP, APALP, 4, 2)
C                                      Clear accumulators in AP
      CALL QVCLR (APCORE, APGRDS, 1, 8)
C                                      Calculate addresses
      NELEM = XEND - XBEG + 1
      APIMG = APRES + NELEM
      APDEF = APIMG + NELEM
      APSTP = APDEF + NELEM
C
      IF (AKOPEN (IN1,1,'READ',BUFFR1).NE.0) GO TO 990
      IF (AKOPEN (IN2,2,'READ',BUFFR2).NE.0) GO TO 990
      IF (AKOPEN (IN3,3,'READ',BUFFR3).NE.0) GO TO 990
      IF (AKOPEN (IN4,4,'READ',BUFFR4).NE.0) GO TO 990
C                                       Loop through map
      DO 200 IY = YBEG, YEND
C                                       Read in a row
         IF (AKCESS (IN1,BUFFR1).NE.0) GO TO 990
         IF (AKCESS (IN2,BUFFR2).NE.0) GO TO 990
         IF (AKCESS (IN3,BUFFR3).NE.0) GO TO 990
         IF (AKCESS (IN4,BUFFR4).NE.0) GO TO 990
C                                        Do calculations
         I1 = BIND(1)
         I2 = BIND(2)
         I3 = BIND(3)
         I4 = BIND(4)
C
         CALL QPUT (APCORE, BUFFR1(I1), APRES, NELEM, 2)
         CALL QPUT (APCORE, BUFFR2(I2), APIMG, NELEM, 2)
         CALL QPUT (APCORE, BUFFR3(I3), APDEF, NELEM, 2)
         CALL QPUT (APCORE, BUFFR4(I4), APSTP, NELEM, 2)
         CALL QWD
         CALL QMENT (APCORE, APBASE, -1, APIMG, APDEF, APRES, APSTP,
     *      NELEM)
         CALL QWR
 200     CONTINUE
C
      IF (AKCLOS (IN1,BUFFR1).NE.0) GO TO 990
      IF (AKCLOS (IN2,BUFFR2).NE.0) GO TO 990
      IF (AKCLOS (IN3,BUFFR3).NE.0) GO TO 990
      IF (AKCLOS (IN4,BUFFR4).NE.0) GO TO 990
C
C                                      Get results
      CALL QGET (APCORE, RTEMP, APGRDS, 8, 2)
      CALL QWD
C
      RJ1    = RTEMP(8)
C
      CALL QRLSE
C
      EPSSTR = 0.0
      IF (RJ1.NE.RJ0) EPSSTR = RJ0 / (RJ0-RJ1)
      IF (RL0.GT.0.0) THEN
         IF (SCLF.NE.0.0) THEN
            EPSSTR = MIN (EPSSTR, GAIN/(SCLF*RL0))
         ELSE
            EPSSTR = MIN (1.0, EPSSTR)
            END IF
         END IF
      GO TO 999
C
 990  WRITE (MSGTXT,1000)
      CALL MSGWRT (8)
      IERR = 1
C
 999  CONTINUE
      RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DOTGRD')
      END
      SUBROUTINE FILES (APCORE, USID, NAME, VOL, CLASS, SEQ, OLD, IERR)
C-----------------------------------------------------------------------
C   FILES reads and floats the beam and the dirty map, opens the
C   default map, creates/opens the VTESS map, and creates the scratch
C   files. The dirty map, default map, and VM map are copied into small
C   scratch files.
C   Programmer =  T.J. Cornwell      December 1987
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      CHARACTER NAME(5)*12, CLASS(5)*6,  STAT*4, MAPUNT*8, CMPUNT*8,
     *   MTYPE*2, AXTYPE*8, STOKES(4)*1, KWORDS(2)*8
      INTEGER   USID, CATBLK(256), CNO, VOL(5), SEQ(5), OLDIM,
     *   OLDNAX(7), IDEPTH(5), CATDEF(256), CATIMG(256), IDEL, JDEL, I,
     *   IAXIS, IROUND, LUN1, LUN2, FIL, CORN(7), ISIZE, SAXIS, LF,
     *   WIN(4), XOFF, YOFF, IFIELD, KAP, IDIR, JERR, ITMP, LOCS(2),
     *   VALUES(24), KEYTYP(2), NEED, MNAX(2), NOMAT
      LOGICAL   OLD
      DOUBLE PRECISION CATD(128), OLDCRV(7), FREQ, MCRV(2)
      HOLLERITH CATH(256)
      REAL      CATR(128), XBUF1(1), RMAX, RMIN, XCEN, YCEN, INDEF,
     *   MCIC(2), MCRP(2), MEPS, VALUER(24), RTEMP(1)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:PSTD.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK, CATR, CATD, CATH)
      EQUIVALENCE (BUFFR1, XBUF1),   (VALUES, VALUER)
      DATA IDEPTH /5*1/
      DATA MAPUNT /'JY/PIXEL'/
      DATA CORN /7*1/
      DATA CMPUNT /'JY/BEAM '/
      DATA STOKES /'I', 'Q', 'U', 'V'/
      DATA KWORDS /'ALPHA   ', 'BETA    '/
C-----------------------------------------------------------------------
      INDEF = FBLANK
C
      IERR = 0
      NCFILE = 0
      LUN1 = 16
      LUN2 = 17
      NOMAT = 0
C                                       Read beam.
C                                       Get catalog slot for first BEAM.
      CNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', VOL(2), CNO, NAME(2), CLASS(2), SEQ(2),
     *   MTYPE, USID, STAT, BUFFR3, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, NAME(2), CLASS(2), SEQ(2), VOL(2),
     *      USID
         GO TO 990
         END IF
C                                       Copy CATBLK
      CALL CATIO ('READ', VOL(2), CNO, CATBLK, 'REST', BUFFR1(1), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         GO TO 990
         END IF
C                                       Determine NX and NY
      NX = CATBLK(KINAX)
      NY = CATBLK(KINAX+1)
C                                       Get cell size in arcseconds
      CELLX = CATR(KRCIC)*3600.0
      CELLY = CATR(KRCIC+1)*3600.0
C                                       set array name
      CALL H2CHR (8, 1, CATH(KHTEL), ANAME)
C                                       Set up windows
      IF ((BLC(1).LE.0) .OR. (BLC(1).GE.NX)) BLC(1) = 1 + NX/4
      IDEL = NX/2-1
      IF (TRC(1).GT.BLC(1)) IDEL = TRC(1)-BLC(1)
      TRC(1) = BLC(1) + IDEL
      IF ((BLC(2).LE.0) .OR. (BLC(2).GE.NY)) BLC(2) = 1 + NY/4
      JDEL = NY/2-1
      IF (TRC(2).GT.BLC(2)) JDEL = TRC(2) - BLC(2)
      TRC(2) = BLC(2) + JDEL
      XBEG = 1 + NX/4 - (TRC(1)-BLC(1)+1)/2
      YBEG = 1 + NY/4 - (TRC(2)-BLC(2)+1)/2
      XEND = XBEG + (TRC(1)-BLC(1))
      YEND = YBEG + (TRC(2)-BLC(2))
C
      RWNXY = REAL(TRC(1)-BLC(1)+1) * REAL(TRC(2)-BLC(2)+1)
C
      DO 10 I = 1,NUMFIL
         VMSZ(1,I) = NX / 2
         VMSZ(2,I) = NY / 2
 10      CONTINUE
C
      DO 20 IFIELD=1,NFIELD
         VMSZ(1,DAT(IFIELD)) = NX
         VMSZ(2,DAT(IFIELD)) = NY
         VMSZ(1,WT(IFIELD)) = NY * 2
         VMSZ(2,WT(IFIELD)) = NX / 2 + 1
  20     CONTINUE
C
      VMSZ(1,WK1) = NY * 2
      VMSZ(2,WK1) = NX / 2 + 1
      VMSZ(1,WK2) = NY * 2
      VMSZ(2,WK2) = NX / 2 + 1
      VMSZ(1,WK3) = NY * 2
      VMSZ(2,WK3) = NX / 2 + 1
      VMSZ(1,VMOUT) = NX
      VMSZ(2,VMOUT) = NY
      VMSZ(1,CVMOUT) = NX
      VMSZ(2,CVMOUT) = NY
      HNX = NX/2
      HNY = NY/2
C                                       Create scratch files.
      NSCR = 0
      DO 30 FIL = 1,NUMSCR
         CALL MAPSIZ (2, VMSZ(1,FIL), ISIZE)
         CALL SCREAT (ISIZE, BUFFR1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR, FIL
            GO TO 990
            END IF
         SCRNM(FIL) = NSCR
         VMVOL(FIL) = SCRVOL(NSCR)
         CALL ZPHFIL ('SC', SCRVOL(NSCR), SCRCNO(NSCR), 1, VMFILE(FIL),
     *      IERR)
 30      CONTINUE
C
      SCRNM(VMOUT)  = NSCR + 1
      SCRNM(CVMOUT) = NSCR + 2
C                                       Loop through input beams
      DO 50 IFIELD = 1,NFIELD
         CNO = 1
         ITMP = SEQ(2) + IFIELD - 1
         MTYPE = 'MA'
         CALL CATDIR ('SRCH', VOL(2), CNO, NAME(2), CLASS(2), ITMP,
     *      MTYPE, USID, STAT, BUFFR3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, NAME(2), CLASS(2), ITMP, VOL(2),
     *         USID
            GO TO 990
            END IF
C                                       Copy CATBLK
         CALL CATIO ('READ', VOL(2), CNO, CATBLK, 'READ', BUFFR3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
C                                       Mark file 'READ' in /CFILES/
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = VOL(2)
         FCNO(NCFILE) = CNO
         FRW(NCFILE) = 0
C                                       Use WK1 file for temp BEAM.
         VMSZ(1,WK1) = NX
         VMSZ(2,WK1) = NY
         VMSZ(1,WK2) = NX
         VMSZ(2,WK2) = NY
C                                       If interferometric data then
C                                       shift beam. I do not like this
C                                       but crazy handling of beams
C                                       in AIPS should be changed
C                                       sometime.
C         IF (BMSIZE(IFIELD).GE.0) THEN
         CALL PEAKFN (LUN1, VOL(2), CNO, IDEPTH, CATBLK, BUFFR3,
     *      BUFSZ(3), XCEN, YCEN, IERR)
         IF (IERR.NE.0) GO TO 990
         XCEN = XCEN - NX/2 - 1
         YCEN = YCEN - NY/2 - 1
         ICENX = IROUND (XCEN)
         ICENY = IROUND (YCEN)
         XOFF = ICENX
         YOFF = ICENY
C         ELSE
C            XOFF = 0
C            YOFF = 0
C            END IF
C                                       Read into scratch file for FFT
         CHAN = MIN (CHAN, CATBLK(KINAX+2))
         CORN(3) = CHAN
C
         WIN(1) = 1
         WIN(2) = 1
         WIN(3) = NX
         WIN(4) = NY
C
         CALL PLNGET (VOL(2), CNO, CORN, WIN, XOFF, YOFF, SCRNM(WK1),
     *      VMSZ(1,WK1), VMSZ(2,WK1), BUFFR1, BUFFR2, BUFSZ(1),
     *      BUFSZ(2), LUN1, LUN2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1035) IERR
            GO TO 990
            END IF
C                                       If required fit beam
C
         IF ((IFIELD.EQ.1).AND.(BMAJ.EQ.0.0)) THEN
            CALL BMSHP(WK1, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
C                                       Calculate transfer function. Use
C                                       full transform to allow
C                                       asymmetric PSFs
         NEED = 4 * NY * (NX/2 + 1)
         NEED = NEED / 1024
         MSGSUP = 32000
         CALL QINIT (APCORE, NEED, 0, KAP)
         MSGSUP = 0
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            NEED = (NY * (NX/2 + 1)) / 2
            NEED = NEED / 1024
            NEED = MIN (16 * 1024, NEED) + 4
            CALL QINIT (APCORE, NEED, 0, KAP)
            IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
               MSGTXT = 'FILES: CANNOT GET NEEDED MEMORY'
               IERR = 8
               GO TO 990
               END IF
            END IF
         IDIR = 3
         CALL DSKFFT (APCORE, NX, NY, IDIR, T, SCRNM(WK1), SCRNM(WK3),
     *     SCRNM(WT(IFIELD)), BUFSZ(1), BUFFR1, BUFFR2, RMAX,
     *     RMIN, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1220) IERR
            GO TO 990
            END IF
         CALL QRLSE
C                                       Find volume of beam
         CALL FNDVAR (IFIELD, WT(IFIELD), IERR)
         IF (IERR.NE.0) GO TO 999
 50      CONTINUE
C                                       End of beam loop
C
C                                       Loop over dirty maps
C                                       Get catalog slot number for
C                                       the dirty map and CATBLK.
      DO 60 IFIELD = 1,NFIELD
         CNO = 1
         ITMP = SEQ(1) + IFIELD - 1
         MTYPE = 'MA'
         CALL CATDIR ('SRCH', VOL(1), CNO, NAME(1), CLASS(1), ITMP,
     *      MTYPE, USID, STAT, BUFFR3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, NAME(1), CLASS(1), ITMP, VOL(1),
     *         USID
            GO TO 990
            END IF
C                                       Get CATBLK for dirty map.
         CALL CATIO ('READ', VOL(1), CNO, CATBLK, 'READ', BUFFR3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1090) IERR
            GO TO 990
            END IF
C                                       Check STOKES parameter
         IAXIS = KHCTP
         DO 65 I = 1, 7
            CALL H2CHR (8, 1, CATH(IAXIS), AXTYPE)
            IF (AXTYPE.EQ.'STOKES  ') SAXIS = I
            IAXIS = IAXIS + 2
 65         CONTINUE
         IAXIS = KDCRV + SAXIS - 1
         I = NINT (CATD(IAXIS))
         IF ((I .GE. 2) .AND. (I .LE. 4)) THEN
            WRITE (MSGTXT, 1065) STOKES(I)
            CALL MSGWRT(4)
            END IF
C                                       Mark map READ in /CFILES/
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = VOL(1)
         FCNO(NCFILE) = CNO
         FRW(NCFILE) = 0
C                                       Warn if "VTESS"
         IF (CATBLK(KINIT).GT.0) THEN
            WRITE (MSGTXT,1100)
            CALL MSGWRT (4)
            END IF
C                                       Find type of telescope
C                                       Default type = Gaussian
C                                       VLA if in header
C                                       Single dish if BMSIZE(IFIELD) <0
         IF (BMSIZE(IFIELD).LT.0.0) THEN
            BEAMTP(IFIELD) = 0
         ELSE IF (BMSIZE(IFIELD).GT.0.0) THEN
            BEAMTP(IFIELD) = 1
         ELSE
            CALL AXEFND (4, 'FREQ', CATBLK(KIDIM), CATH(KHCTP), LF,
     *         IERR)
            IF (IERR.EQ.0) THEN
               FREQ = CATD(KDCRV+LF)
            ELSE
               FREQ = 0.0D0
               END IF
            BEAMTP(IFIELD) = 2
            IF (FREQ.NE.0.) THEN
               BMSIZE(IFIELD) = VELITE / FREQ
            ELSE
               BMSIZE(IFIELD) = 0.0
               END IF
            END IF
C                                       Find pointing center
         IDEPTH(1) = CHAN
         LOCNUM = 1
         CALL SETLOC (IDEPTH, F)
         CALL XYPIX (CATD(KDORA), CATD(KDODE), RCENX(IFIELD),
     *      RCENY(IFIELD), JERR)
         IF (JERR.NE.0) THEN
            RCENX(IFIELD) = CATR(KRCRP)
            RCENY(IFIELD) = CATR(KRCRP+1)
            END IF
C
         VMVOL(DAT(IFIELD)) = VOL(1)
         SCRNM(DAT(IFIELD)) = SCRNM(CVMOUT) + IFIELD
         SCRCNO(SCRNM(DAT(IFIELD))) = CNO
         CALL ZPHFIL ('MA', VOL(1), CNO, 1, VMFILE(DAT(IFIELD)), IERR)
C                                       Set up block offsets for reading
         CORN(3) = CHAN
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORN(3),
     *      VMBO(DAT(IFIELD)), IERR)
         VMBO(DAT(IFIELD)) = VMBO(DAT(IFIELD)) + 1
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1040) IERR
            GO TO 990
            END IF
C                                       save coordinates
         IF (IFIELD.EQ.1) THEN
            MCRV(1) = CATD(KDCRV)
            MCIC(1) = CATR(KRCIC)
            MCRP(1) = CATR(KRCRP)
            MNAX(1) = CATBLK(KINAX)
            MCRV(2) = CATD(KDCRV+1)
            MCIC(2) = CATR(KRCIC+1)
            MCRP(2) = CATR(KRCRP+1)
            MNAX(2) = CATBLK(KINAX+1)
            MEPS = 0.01 * MAX (ABS(MCIC(1)), ABS(MCIC(2)))
C                                       test
         ELSE
            IF ((ABS(MCRV(1)-CATD(KDCRV)).GT.MEPS) .OR.
     *         (ABS(MCRV(2)-CATD(KDCRV+1)).GT.MEPS) .OR.
     *         (ABS(MCIC(1)-CATR(KRCIC)).GT.0.01*MEPS) .OR.
     *         (ABS(MCIC(2)-CATR(KRCIC+1)).GT.0.01*MEPS) .OR.
     *         (ABS(MCRP(1)-CATR(KRCRP)).GT.0.1) .OR.
     *         (ABS(MCRP(2)-CATR(KRCRP+1)).GT.0.1) .OR.
     *         (MNAX(1)-CATBLK(KINAX).NE.0) .OR.
     *         (MNAX(2)-CATBLK(KINAX+1).NE.0)) THEN
               WRITE (MSGTXT,1050) IFIELD
               CALL MSGWRT (7)
               NOMAT = NOMAT + 1
               END IF
            END IF
 60      CONTINUE
      IF (NOMAT.GT.0) THEN
         WRITE (MSGTXT,1060) NOMAT
         IERR =  NOMAT
         GO TO 990
         END IF
C                                       End of loop over dirty maps
C
C                                       Make sure NX,NY same as
C                                       for the beam.
      IF ((NX.NE.CATBLK(KINAX)) .OR. (NY.NE.CATBLK(KINAX+1)))
     *   THEN
         IERR = 1
         WRITE (MSGTXT,1105)
         CALL MSGWRT (8)
         WRITE (MSGTXT,1106) NX,NY,CATBLK(KINAX),CATBLK(KINAX+1)
         GO TO 990
         END IF
C                                       Create VM file if necessary
C                                       Put NAME in CATBLK
      IF (NAME(3).NE.' ') CALL CHR2H (12, NAME(3), KHIMNO, CATH(KHIMN))
C                                       Put VM class into CATBLK
      CALL CHR2H (6, CLASS(3), KHIMCO, CATH(KHIMC))
C                                        Put in units of map
      CALL CHR2H (8, MAPUNT, 1, CATH(KHBUN))
C                                       Update sequence.
      CATBLK(KIIMS) = SEQ(3)
      CATR(KRDMX) =  0.0
      CATR(KRDMN) =  0.0
C                                       Create output VM map file.
      CALL MCREAT (VOL(3), CNO, BUFFR1, IERR)
      OLD = .FALSE.
      IF (IERR.NE.0) THEN
         OLD = .TRUE.
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1190) IERR
            GO TO 990
         ELSE
C                                       Existing file: check it out
            OLDIM = CATBLK(KIDIM)
            DO 70 I = 1,7
               OLDNAX(I) = CATBLK(KINAX+I-1)
               OLDCRV(I) = CATD(KDCRV+I-1)
 70            CONTINUE
            CALL CATIO ('READ', VOL(3), CNO, CATBLK, 'REST', BUFFR3,
     *         IERR)
            IMGMAX = CATR(KRDMX)
            IMGMIN = CATR(KRDMN)
            CALL CATIO ('WRIT', VOL(3), CNO, CATBLK, 'WRIT', BUFFR3,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1210) IERR
               CALL MSGWRT (8)
               END IF
           END IF
         END IF
C
      CORN(3) = CHAN
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORN(3), VMBO(VMOUT),
     *   IERR)
      VMBO(VMOUT) = VMBO(VMOUT) + 1
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1045) IERR
         GO TO 990
         END IF
C                                       Actual seq #
      SEQ(3) = CATBLK(KIIMS)
C                                        Get old ALPHA,BETA
      ALPINI = 0.0
      BETINI = 0.0
      CALL CATKEY ('REED', VOL(3), CNO, KWORDS, 2, LOCS, VALUES,
     1   KEYTYP, BUFFR1, IERR)
      IF(IERR.EQ.0) THEN
         IF(LOCS(1).GE.0) THEN
            CALL RCOPY (1, VALUER(LOCS(1)), RTEMP)
            ALPINI= RTEMP(1)
            END IF
         IF(LOCS(2).GE.0) THEN
            CALL RCOPY (1, VALUER(LOCS(2)), RTEMP)
            BETINI = RTEMP(1)
            END IF
      ELSE
         IERR=0
         END IF
C                                        Mark for READ in /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = VOL(3)
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 1
C                                       Fill output file into common
      VMVOL(VMOUT) = VOL(3)
      SCRCNO(SCRNM(VMOUT)) = CNO
      CALL ZPHFIL ('MA', VOL(3), CNO, 1, VMFILE(VMOUT), IERR)
C                                       Now make or get second output
C                                       image
      IF (BMAJ.GE.0.0) THEN
         CALL COPY (256, CATBLK, CATIMG)
C                                       Create file if necessary
C                                       Put NAME in CATBLK
         CALL CHR2H (12, NAME(5), KHIMNO, CATH(KHIMN))
C                                       Put class into CATBLK
         CALL CHR2H (6, CLASS(5), KHIMCO, CATH(KHIMC))
C                                       Update sequence.
         CATBLK(KIIMS) = SEQ(5)
C                                        Put in units of map
         CALL CHR2H (8, CMPUNT, 1, CATH(KHBUN))
C
         IF (BLANKD) THEN
            CATR(KRBLK) = INDEF
         ELSE
            CATR(KRBLK) = 0.0
            END IF
         CATR(KRDMX) = -1E10
         CATR(KRDMN) =  1E10
C                                       Create second output map file.
         CALL MCREAT (VOL(5), CNO, BUFFR1, IERR)
         IF (IERR.NE.0) THEN
            IF (IERR.EQ.2) THEN
C                                       Existing file: check it out
               OLDIM = CATBLK(KIDIM)
               DO 120 I = 1,7
                  OLDNAX(I) = CATBLK(KINAX+I-1)
                  OLDCRV(I) = CATD(KDCRV+I-1)
 120           CONTINUE
               CALL CATIO ('READ', VOL(5), CNO, CATBLK, 'REST', BUFFR3,
     *            IERR)
               IF (OLDIM.NE.CATBLK(KIDIM)) GO TO 130
               DO 140 I = 1,2
                  IF (OLDNAX(I).NE.CATBLK(KINAX+I-1)) GO TO 130
                  IF (OLDCRV(I).NE.CATD(KDCRV+I-1)) GO TO 130
 140              CONTINUE
C                                       mark WRITE
               CALL CATIO ('WRIT', VOL(5), CNO, CATBLK, 'WRIT', BUFFR3,
     *            IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1210) IERR
                  CALL MSGWRT (8)
                  END IF
               GO TO 150
 130           CONTINUE
               IERR = 8
               WRITE (MSGTXT,1515)
               GO TO 990
            ELSE
               WRITE (MSGTXT,1190) IERR
               GO TO 990
               END IF
            END IF
C                                       Actual seq #
 150     SEQ(5) = CATBLK(KIIMS)
C
         CORN(3) = CHAN
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORN(3),
     *      VMBO(CVMOUT), IERR)
         VMBO(CVMOUT) = VMBO(CVMOUT) + 1
C                                        Mark for WRIT in /CFILES/
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = VOL(5)
         FCNO(NCFILE) = CNO
         FRW(NCFILE) = 1
C                                       Fill output file into common
         VMVOL(CVMOUT) = VOL(5)
         SCRCNO(SCRNM(CVMOUT)) = CNO
         CALL ZPHFIL ('MA', VOL(5), CNO, 1, VMFILE(CVMOUT), IERR)
         CALL COPY (256, CATIMG, CATBLK)
         END IF
C                                       GET Default level file
C                                       if it exists
      IF (DEFEXT) THEN
         CALL COPY (256, CATBLK, CATIMG)
         CNO = 1
         MTYPE = 'MA'
         CALL CATDIR ('SRCH', VOL(4), CNO, NAME(4), CLASS(4),
     *      SEQ(4), MTYPE, USID, STAT, BUFFR3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, NAME(4), CLASS(4), SEQ(4), VOL(4),
     *         USID
            GO TO 990
            END IF
         CALL CATIO ('READ', VOL(4), CNO, CATDEF, 'READ', BUFFR3, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1090) IERR
            GO TO 990
            END IF
C
         CORN(3) = 1
         WIN(1) = BLC(1)
         WIN(2) = BLC(2)
         WIN(3) = TRC(1)
         WIN(4) = TRC(2)
         CALL PLNGET (VOL(4), CNO, CORN, WIN, XOFF, YOFF, SCRNM(DEF),
     *      VMSZ(1,DEF), VMSZ(2,DEF), BUFFR1, BUFFR2, BUFSZ(1),
     *      BUFSZ(2), LUN1, LUN2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1045) IERR
            GO TO 990
            END IF
         DEFMAX = CATR(KRDMX)
         DEFMIN = CATR(KRDMN)
C                                       Add to /CFILES/, Mark READ
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = VOL(4)
         FCNO(NCFILE) = CNO
         FRW(NCFILE) = 0
C
         CALL COPY (256, CATIMG, CATBLK)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FILES: ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,
     *   ' DISK=',I3,' USID=',I4)
 1010 FORMAT ('FILES: CANNOT COPY BEAM CATBLK, ERROR',I3)
 1020 FORMAT ('FILES: ERROR',I3,' CREATING SCRATCH FILE ',I2)
 1035 FORMAT ('FILES: CANNOT COPY DIRTY BEAM, ERROR ',I3)
 1040 FORMAT ('FILES: CANNOT COPY DIRTY MAP, ERROR ',I3)
 1045 FORMAT ('FILES: CANNOT COPY VTESS MAP, ERROR ',I3)
 1050 FORMAT ('FILES: FIELD',I5,' DOES NOT MATCH GEOMETRY OF FIELD 1')
 1060 FORMAT ('FILES:',I5,' FIELDS DO NOT MATCH: USE HGEOM')
 1065 FORMAT ('WARNING: VTESSING A ',A1,' MAP')
 1090 FORMAT ('FILES: CANNOT COPY MAP CATBLK, ERROR',I3)
 1100 FORMAT ('WARNING: MAY BE VTESSING A VTESS MAP')
 1105 FORMAT ('FILES: UNEQUAL DIMENSIONS IN DIRTY AND BEAM MAPS')
 1106 FORMAT ('       BEAM =',2I5,' DIRTY =',2I5)
 1190 FORMAT ('FILES: COULD NOT CREATE VTESS MAP FILE, ERROR ',I3)
 1210 FORMAT ('FILES: CANNOT UPDATE VTESS CATBLK, ERROR',I3)
 1220 FORMAT ('FILES: ERROR ',I3, ' IN DSKFFT, BEAM TO U,V')
 1515 FORMAT ('OLD RESTORED MAP NOT COMPATIBLE WITH DIRTY MAP')
      END
      SUBROUTINE GETIN (USID, NAME, VOL, CLASS, SEQ, ITV, IERR)
C-----------------------------------------------------------------------
C   GETIN gets the input parameters for the program from AIPS
C   initializes the parameters, and sets up the file system.
C   Programmer =  T.J. Cornwell      December 1987
C-----------------------------------------------------------------------
      INCLUDE 'INCS:DTESS.INC'
C
      CHARACTER PRGNAM*6, NAME(5)*12, CLASS(5)*6, MTYPE*2
      HOLLERITH XNAM1(3), XNAM2(3), XNAM3(3), XNAM4(3), XNAM5(3),
     *   XCLAS1(2), XCLAS2(2), XCLAS3(2), XCLAS4(2), XCLAS5(2)
      INTEGER   USID, SEQ(5), VOL(5), I, LUN1, ITV
      INTEGER   NPARMS, CATBLK(256), IND, CNO
      INTEGER   IROUND
      REAL      XSEQ1, XSEQ2, XSEQ3, XSEQ4, XSEQ5, XVOL1, XVOL2, XVOL3,
     *   XVOL4, XVOL5, XNITER, XERROR(64), XFLUX, XGAIN, XNPPB, XNFIEL,
     *   XBLC(7), XTRC(7), XLNGO, XDOTV, XBMAJ, XBMIN, XBPA, XBMSIZ(64),
     *   XAPM(7), XBAD(10)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /MAPHDR/ CATBLK
      COMMON /INPARM/ XNAM1, XCLAS1, XSEQ1, XVOL1,
     *   XNAM2, XCLAS2, XSEQ2, XVOL2,
     *   XNAM4, XCLAS4, XSEQ4, XVOL4,
     *   XNAM3, XCLAS3, XSEQ3, XVOL3,
     *   XNAM5, XCLAS5, XSEQ5, XVOL5,
     *   XNFIEL, XNITER, XERROR, XFLUX,
     *   XBLC, XTRC, XDOTV, XLNGO, XBMSIZ, XBMAJ, XBMIN, XBPA, XAPM,
     *   XBAD
      DATA PRGNAM /'VTESS'/
C-----------------------------------------------------------------------
C
      IERR = 0
      LUN1 = 16
C                                        Initialize common parameters.
C                                        global areas
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL HIINIT (5)
      BLC(1) = 0
      BLC(2) = 0
      TRC(1) = 0
      TRC(2) = 0
      VMLIM = 5
      VMSTR = 0
      GAIN = 0.30
      SCLF = 1.0
      EPSSTR = 1.0
      FLUX = 0.0
C                                      Fill array of scratch buffer sizes
      CALL FILL (6, XBUFSZ*2, BUFSZ)
C
      BPS = NBPS
C                                       Get AIPS adverbs.
      NPARMS = 5*7 + 2*1 + 64 + 1 + 2*7 + 2*1 + 64 + 3*1 + 7 + 10
      CALL GTPARM (PRGNAM, NPARMS, RQUICK, XNAM1, BUFFR1, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         RQUICK = .FALSE.
         GO TO 999
C                                       Convert characters
 10   CALL H2CHR (12, 1, XNAM1, NAME(1))
      CALL H2CHR (6, 1, XCLAS1, CLASS(1))
      CALL H2CHR (12, 1, XNAM2, NAME(2))
      CALL H2CHR (6, 1, XCLAS2, CLASS(2))
      CALL H2CHR (12, 1, XNAM3, NAME(3))
      CALL H2CHR (6, 1, XCLAS3, CLASS(3))
      CALL H2CHR (12, 1, XNAM4, NAME(4))
      CALL H2CHR (6, 1, XCLAS4, CLASS(4))
      CALL H2CHR (12, 1, XNAM5, NAME(5))
      CALL H2CHR (6, 1, XCLAS5, CLASS(5))
C                                       get actual dirty map name
      VOL(1) = IROUND (XVOL1)
      SEQ(1) = IROUND (XSEQ1)
      USID = NLUSER
      MTYPE = 'MA'
      CALL MAPOPN ('READ', VOL, NAME(1), CLASS(1), SEQ, MTYPE, USID,
     *   LUN1, IND, CNO, CATBLK, BUFFR1, IERR)
      DRTCNO = CNO
      IF (IERR.EQ.0) GO TO 20
         WRITE (MSGTXT,1010) IERR,'READ'
         CALL MSGWRT (8)
         GO TO 999
 20   CALL MAPCLS ('READ', VOL, CNO, LUN1, IND, CATBLK, F, BUFFR1,
     *   IERR)
      IF (IERR.EQ.0) GO TO 25
         WRITE (MSGTXT,1020) IERR, 'READ'
         CALL MSGWRT (6)
 25   IERR = 0
C                                       Default name for Beam and VM
C                                       maps is Dirty map name.
      IF (NAME(2) .EQ. ' ') NAME(2) = NAME(1)
      IF (NAME(3) .EQ. ' ') NAME(3) = NAME(1)
      IF (NAME(5) .EQ. ' ') NAME(5) = NAME(1)
C                                       Copy CLASSes or default.
      IF (CLASS(2) .EQ. ' ') THEN
         CLASS(2) = 'IBEAM '
         IF (CLASS(1).EQ.'RMAP  ') CLASS(2) = 'RBEAM '
         IF (CLASS(1).EQ.'LMAP  ') CLASS(2) = 'LBEAM '
         END IF
C
      IF (CLASS(3).EQ.' ') THEN
         IF (INDEX (CLASS(1), 'MAP') .EQ. 2) THEN
            CLASS(3)(1:1) = CLASS(1)(1:1)
            CLASS(3)(2:)  = 'VT   '
         ELSE
            CLASS(3) = 'VT    '
            END IF
         END IF
C
      IF (CLASS(5).EQ.' ') THEN
         IF (INDEX (CLASS(1), 'MAP') .EQ. 2) THEN
            CLASS(5)(1:1) = CLASS(1)(1:1)
            CLASS(5)(2:)  = 'VTC  '
         ELSE
            CLASS(5) = 'VTC   '
            END IF
         END IF
C                                       Def. Level file must be
C                                       specified completely
      DEFEXT = .FALSE.
      IF (NAME(4).EQ.' ') GO TO 45
         IF (CLASS(4).EQ.' ') GO TO 45
            VOL(4) = IROUND (XVOL4)
            IF (VOL(4).EQ.0) GO TO 45
               SEQ(4) = IROUND (XSEQ4)
               IF (SEQ(4).EQ.0) GO TO 45
                  DEFEXT = .TRUE.
C                                       Get volume numbers
 45   VOL(2) = IROUND (XVOL2)
      VOL(3) = IROUND (XVOL3)
      VOL(5) = IROUND (XVOL5)
C                                       Get sequence numbers
      SEQ(2) = IROUND (XSEQ2)
      SEQ(3) = IROUND (XSEQ3)
      SEQ(5) = IROUND (XSEQ5)
      IF (SEQ(2).LE.0) SEQ(2) = SEQ(1)
C
      DO 70 I = 1,10
         IBAD(I) = IROUND (XBAD(I))
 70      CONTINUE
C                                       Get UTESS information
      BLC(1) = IROUND (MIN (XBLC(1), XTRC(1)))
      BLC(2) = IROUND (MIN (XBLC(2), XTRC(2)))
      TRC(1) = IROUND (MAX (XBLC(1), XTRC(1)))
      TRC(2) = IROUND (MAX (XBLC(2), XTRC(2)))
      CHAN = MAX (1.0, XBLC(3)+0.1)
C
      NFIELD = MIN (NINT (XNFIEL), MATFLD)
      IF (NFIELD.LT.1) NFIELD = 1
C
      TFLUX = XFLUX
      XNPPB = (XBAD(9) - IBAD(9))*1000
      RNPPB = MAX (XNPPB, 0.0)
      IF (XNPPB.EQ.0.0) RNPPB = 1.0
      XGAIN = XBAD(10) - IBAD(10)
      IF (XGAIN.NE.0.0) GAIN = XGAIN
      DOSTOP = XNITER.LT.0.0
      IF (XNITER.NE.0.0) VMLIM = ABS(XNITER) + 0.1
      ITV = XDOTV
      BMAJ = XBMAJ
      BMIN = XBMIN
      BPA = XBPA
      BLANKD = F
      DO 666 I = 1,NFIELD
         IF (I.LE.64) THEN
            FRES(I) = XERROR(I)
            BMSIZE(I) = XBMSIZ(I)
         ELSE
            FRES(I) = XERROR(64)
            BMSIZE(I) = XBMSIZ(64)
            END IF
         IF (BMSIZE(I).GE.0.0) BLANKD = T
C                                       NOISE must be specified
         IF (FRES(I).GT.0.0) GO TO 666
            IERR = 8
            WRITE(MSGTXT,1005) I
            CALL MSGWRT (8)
            GO TO 999
 666     CONTINUE
C                                       cutoff for primary beam
      IF (XAPM(1).LE.0.0) XAPM(1) = 0.07
      CALL RCOPY (7, XAPM, PBPARM)
C                                       Get bad disks.
      LNGOUT = .FALSE.
      IF (XLNGO.GT.0.0) LNGOUT = .TRUE.
C                                       Check if TV allowed
      IF (NTVDEV.LE.0) ITV = 0
C
C                                       UTESS common areas
      DO 778 I = 1,NFIELD
         WT(I) = I
 778     CONTINUE
      DEF = WT(NFIELD) + 1
      IMG = WT(NFIELD) + 2
      DEL = WT(NFIELD) + 3
      RES = WT(NFIELD) + 4
      SCR = WT(NFIELD) + 5
      WK1 = WT(NFIELD) + 6
      WK2 = WT(NFIELD) + 7
      WK3 = WT(NFIELD) + 8
      PRS = WT(NFIELD) + 9
      NUMSCR = PRS
C
      DO 779 I = 1,NFIELD
         DAT(I) = NUMSCR + I
 779     CONTINUE
      VMOUT = DAT(NFIELD) + 1
      CVMOUT = VMOUT + 1
      NUMFIL = CVMOUT
C                                       Output files go in common.
      WRITE (MSGTXT,1200) NUMSCR
      CALL MSGWRT (4)
      DO 125 I = 1,NUMFIL
         VMBO(I) = 1
 125     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1005 FORMAT ('GETIN: NOISE has to be specified for field #',I2)
 1010 FORMAT ('GETIN: ERROR',I3,' OPENING DIRTY MAP FILE FOR ',A4)
 1020 FORMAT ('GETIN: ERROR',I3,' CLOSING DIRTY MAP FILE FOR ',A4)
 1200 FORMAT ('Creating ',I3,' scratch files')
      END
      SUBROUTINE VMHIS (NAME, VOL, CLASS, SEQ, OLD, IERR)
C-----------------------------------------------------------------------
C   VMHIS copies the dirty map history if the VM map does not
C   already have a history file.  Then the inputs to VM with
C   the default values are added to the history file.
C   Programmer =  T.J. Cornwell      December 1987
C-----------------------------------------------------------------------
      CHARACTER NAME(5)*12, CLASS(5)*6, BEAMNM(2)*8, HILINE*72, ATIME*8,
     *   ADATE*12
      INTEGER   VOL(5), SEQ(5), CATBLK(256), LUN1, LUN2, ITMDAT(6),
     *   IFIELD
      LOGICAL   OLD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /MAPHDR/ CATBLK
      DATA BEAMNM /'Gaussian','VLA     '/
C-----------------------------------------------------------------------
      IERR = 0
      LUN1 = 16
      LUN2 = 17
C                                       Open old file: no copy old HI
      IF (.NOT.OLD) GO TO 20
         CALL HIOPEN (LUN1, VMVOL(VMOUT), SCRCNO(SCRNM(VMOUT)),
     *    BUFFR2, IERR)
         IF (IERR.EQ.5) GO TO 20
         IF (IERR.NE.0) GO TO 10
            CALL ZDATE (ITMDAT(1))
            CALL ZTIME (ITMDAT(4))
            CALL TIMDAT (ITMDAT(4), ITMDAT(1), ATIME, ADATE)
            WRITE (HILINE,1000) TSKNAM, RLSNAM, ADATE, ATIME
            CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
            IF (IERR.NE.0) GO TO 50
            GO TO 30
 10      CONTINUE
            WRITE (MSGTXT,1010) IERR
            CALL MSGWRT (6)
            GO TO 60
C                                       Copy/open history files.
 20   CONTINUE
         CALL KEYPCP (VOL(1), SCRCNO(SCRNM(DAT(1))), VOL(3),
     *       SCRCNO(SCRNM(VMOUT)), 0, ' ', IERR)
         CALL HISCOP (LUN2, LUN1, VOL(1), VOL(3), SCRCNO(SCRNM(DAT(1))),
     *       SCRCNO(SCRNM(VMOUT)), CATBLK, BUFFR1, BUFFR2, IERR)
         IF (IERR.EQ.0) GO TO 30
C                                       Check if old file not exist
 30   WRITE (MSGTXT,2000) NAME(1),CLASS(1),SEQ(1),VOL(1)
      CALL MSGWRT (3)
      CALL HENCO1 (TSKNAM, NAME(1), CLASS(1), SEQ(1), VOL(1),
     *   LUN1, BUFFR2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       Dirty beam name.
      WRITE (MSGTXT,2001) NAME(2),CLASS(2),SEQ(2),VOL(2)
      CALL MSGWRT (3)
      CALL HENCO2 (TSKNAM, NAME(2), CLASS(2), SEQ(2), VOL(2),
     *   LUN1, BUFFR2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       VM map name.
      WRITE (MSGTXT,2002) NAME(3), CLASS(3), SEQ(3), VOL(3)
      CALL MSGWRT (3)
      CALL HENCOO (TSKNAM, NAME(3), CLASS(3), SEQ(3), VOL(3),
     *   LUN1, BUFFR2, IERR)
      IF (IERR.NE.0) GO TO 50
C                                      Restored map name.
      IF (BMAJ.GT.0.0) THEN
         WRITE (MSGTXT,2032) NAME(5), CLASS(5), SEQ(5), VOL(5)
         CALL MSGWRT (3)
         CALL HENCOO (TSKNAM, NAME(5), CLASS(5), SEQ(5), VOL(5),
     *      LUN1, BUFFR2, IERR)
         IF (IERR.NE.0) GO TO 50
         END IF
C                                       DEF LEVEL map name.
      IF (.NOT.DEFEXT) GO TO 45
         WRITE (MSGTXT,2222) NAME(4), CLASS(4), SEQ(4), VOL(4)
         CALL MSGWRT (3)
         CALL HENCO3 (TSKNAM, NAME(4), CLASS(4), SEQ(4), VOL(4),
     *      LUN1, BUFFR2, IERR)
         IF (IERR.NE.0) GO TO 50
C                                       Maximum number of Iterations.
 45   WRITE (HILINE,2003) TSKNAM, VMLIM
      CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (2)
      IF (IERR.NE.0) GO TO 50
C                                       Start iteration.
      WRITE (HILINE,2004) TSKNAM, VMSTR
      IF (VMSTR.GT.0) CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
      IF (VMSTR.GT.0) MSGTXT = HILINE
      IF (VMSTR.GT.0) CALL MSGWRT (2)
      IF (IERR.NE.0) GO TO 50
C                                       Total FLUX
      WRITE (HILINE,2007) TSKNAM, TFLUX
      CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (2)
      IF (IERR.NE.0) GO TO 50
C                                       Boxes
      WRITE (HILINE,2009) TSKNAM, BLC(1), BLC(2)
      CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (2)
      IF (IERR.NE.0) GO TO 50
C                                       Boxes
      WRITE (HILINE,2010) TSKNAM, TRC(1),TRC(2)
      CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (2)
      IF (IERR.NE.0) GO TO 50
C                                       Pointing centers
      DO 777 IFIELD = 1,NFIELD
         WRITE (HILINE,2023) TSKNAM, IFIELD, IFIELD,
     *      RCENX(IFIELD), RCENY(IFIELD)
            CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
         MSGTXT = HILINE
         CALL MSGWRT (2)
         IF (IERR.NE.0) GO TO 50
  777    CONTINUE
C                                       Noise level
      DO 779 IFIELD = 1,NFIELD
         WRITE (HILINE,2006) TSKNAM, IFIELD, FRES(IFIELD)
         CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
         MSGTXT = HILINE
         CALL MSGWRT (2)
         IF (IERR.NE.0) GO TO 50
  779    CONTINUE
C                                       Pointing centers
      DO 780 IFIELD = 1,NFIELD
         IF (BEAMTP(IFIELD).EQ.0) THEN
            WRITE (HILINE,2026) TSKNAM, IFIELD
            CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
            MSGTXT = HILINE
            CALL MSGWRT (2)
            IF (IERR.NE.0) GO TO 50
            IF (BMSIZE(IFIELD).LE.0.0) THEN
               WRITE (HILINE,2027) TSKNAM, IFIELD
               CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
               MSGTXT = HILINE
               CALL MSGWRT (2)
               IF (IERR.NE.0) GO TO 50
               END IF
         ELSE
            WRITE (HILINE,2028) TSKNAM, IFIELD
            CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
            MSGTXT = HILINE
            CALL MSGWRT (2)
            IF (IERR.NE.0) GO TO 50
            IF (BMSIZE(IFIELD).LE.0.0) THEN
               WRITE (HILINE,2027) TSKNAM, IFIELD
               CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
               MSGTXT = HILINE
               CALL MSGWRT (2)
               IF (IERR.NE.0) GO TO 50
            ELSE
               WRITE (HILINE,2025) TSKNAM, IFIELD,
     *            BEAMNM(BEAMTP(IFIELD))
               CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
               MSGTXT = HILINE
               CALL MSGWRT (2)
               IF (IERR.NE.0) GO TO 50
               IF (BEAMTP(IFIELD).EQ.1) THEN
                  WRITE (HILINE,2024) TSKNAM, IFIELD, BMSIZE(IFIELD)
               ELSE
                  WRITE (HILINE,2022) TSKNAM, IFIELD, BMSIZE(IFIELD)
                  END IF
               CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
               MSGTXT = HILINE
               CALL MSGWRT (2)
               IF (IERR.NE.0) GO TO 50
               END IF
            END IF
  780    CONTINUE
C                                       Q per field
      DO 781 IFIELD = 1,NFIELD
         WRITE (HILINE,2008) TSKNAM, IFIELD, RVAR(IFIELD)
         CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
         MSGTXT = HILINE
         CALL MSGWRT (2)
         IF (IERR.NE.0) GO TO 50
  781    CONTINUE
C                                       CHAN
      WRITE (HILINE,2177) TSKNAM, CHAN
      CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
      MSGTXT = HILINE
      CALL MSGWRT (2)
      IF (IERR.NE.0) GO TO 50
C                                       BMAJ, BMIN, BPA
      IF (BMAJ.GT.0.0) THEN
         WRITE (HILINE,2178) TSKNAM, BMAJ
         CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
         MSGTXT = HILINE
         CALL MSGWRT (2)
         IF (IERR.NE.0) GO TO 50
         WRITE (HILINE,2179) TSKNAM, BMIN
         CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
         MSGTXT = HILINE
         CALL MSGWRT (2)
         IF (IERR.NE.0) GO TO 50
         WRITE (HILINE,2180) TSKNAM, BPA
         CALL HIADD (LUN1, HILINE, BUFFR2, IERR)
         MSGTXT = HILINE
         CALL MSGWRT (2)
         IF (IERR.NE.0) GO TO 50
         END IF
C
      GO TO 60
C                                       Error has occured.
 50   WRITE (MSGTXT,1050) IERR
      CALL MSGWRT (6)
C                                       Close history files.
 60   CALL HICLOS (LUN1, T, BUFFR2, IERR)
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /******** Restart ',
     *   A12,1X,A8)
 1010 FORMAT ('UNABLE TO OPEN OLD VTESS-MAP HISTORY FILE')
 1050 FORMAT ('VMHIS: ERROR',I3,' WRITING HISTORY FILE')
 2000 FORMAT ('Dirty map =    ''',A12,''' . ''',A6,
     *   ''' . ',2I4)
 2001 FORMAT ('Beam map =     ''',A12,''' . ''',A6,
     *   ''' . ',2I4)
 2002 FORMAT ('Vtess map =    ''',A12,''' . ''',A6,
     *   ''' . ',2I4)
 2032 FORMAT ('Restored map = ''',A12,''' . ''',A6,
     *   ''' . ',2I4)
 2222 FORMAT ('Default map =  ''',A12,''' . ''',A6,
     *   ''' . ',2I4)
 2003 FORMAT (A6,'NITER =',I7,' /Max. no. VTESS iterations')
 2004 FORMAT (A6,'BITER =',I7,' /No. of previous VTESS iteration')
 2007 FORMAT (A6,'FLUX = ',F8.3,' /Required total flux')
 2009 FORMAT (A6,'BLC = ',2(I5,1X),' /Bottom left corner')
 2010 FORMAT (A6,'TRC = ',2(I5,1X),' /Top   right corner')
 2177 FORMAT (A6,'BLC(3) = ',I6,' /Channel number')
 2022 FORMAT (A6,'/Field',I5,' VLA lambda=',F7.4,' m for primary beam')
 2023 FORMAT (A6,'PBCENX(',I4,'), PBCENY(',I4,') = ',F7.2,',',
     *   F7.2,' /Pixels')
 2024 FORMAT (A6,'PBSIZE(',I4,') = ',F8.1,'/ Arcseconds')
 2025 FORMAT (A6,'/Field',I5,' : Primary beam = ',A8)
 2026 FORMAT (A6,'/Field',I5,' : Single aperture data (?)')
 2028 FORMAT (A6,'/Field',I5,' : Interferometer  data')
 2027 FORMAT (A6,'/Field',I5,' : No primary beam correction')
 2006 FORMAT (A6,'NOISE(',I4,') = ',1PE11.3,'/ Jy/beam')
 2008 FORMAT (A6,'NPOINTS(',I4,') = ',1PE11.3,'/ Pixels/beam')
 2178 FORMAT (A6,'BMAJ = ',1PE11.3,' / Beam major axis (asec)')
 2179 FORMAT (A6,'BMIN = ',1PE11.3,' / Beam minor axis (asec)')
 2180 FORMAT (A6,'BPA  = ',1PE11.3,' / Beam p.a. (degrees)')
      END
      SUBROUTINE DISPTV (IN, TMAX, TMIN, TVPASS)
C-----------------------------------------------------------------------
C   DISPTV displays the FILE IN on the TV
C   Inputs:
C      TVPASS  I  code: ABS=1 => clear screen, else don't
C                          <0 => don't question the user about
C                                quitting
C   Output:
C      TVPASS  I  code: 32700 => user wants to quit
C   Programmer =  T.J. Cornwell      December 1987
C-----------------------------------------------------------------------
      CHARACTER IBLANK*2
      INTEGER   IN, TVPASS, JROW(1), WIN(4), FND, ICH, INC(2), IQ, IB,
     *   CATBLK(256), CATITM(256), I, LUN, IWIN(4)
      REAL      XBUFF(1), CATR(256), TD, RPOS(2)
      REAL      TMIN, TMAX
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK, CATR)
      EQUIVALENCE (JROW(1), BUFFR2),    (BUFFR1, XBUFF(1))
      DATA IBLANK /'  '/
C-----------------------------------------------------------------------
      LUN = 24
      IF (TMIN.GE.TMAX) THEN
         WRITE (MSGTXT,1000)
         CALL MSGWRT (4)
         GO TO 999
         END IF
      ICH = 1
      CALL TVOPEN (BUFFR1, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (ABS (TVPASS).EQ.1) THEN
         CALL TVSET (ICH, BUFFR1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            CALL MSGWRT (6)
            GO TO 998
            END IF
         END IF
C
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = VMSZ(1,IN)
      WIN(4) = VMSZ(2,IN)
      INC(1) = VMSZ(1,IN) / MAXXTV(1) + 1
      INC(2) = VMSZ(2,IN) / MAXXTV(2) + 1
      INC(1) = MAX (INC(1), INC(2))
      INC(2) = MAX (INC(1), INC(2))
      DO 70 I = 1,2
         WIN(I+2) = WIN(I+2) - MOD (WIN(I+2)-WIN(I), INC(I))
         IWIN(I) = (MAXXTV(I) - (WIN(I+2)- WIN(I))/INC(I) + 1)/2
         IF (IWIN(I).LT.1) THEN
            IWIN(I) = 1
            WIN(I)  = (WIN(I+2) + WIN(I) - MAXXTV(I)*INC(I) + 1)/2
            IWIN(I+2) = MAXXTV(I)
            WIN(I+2) = WIN(I) + (IWIN(I+2) - IWIN(I)) * INC(I)
         ELSE
            IWIN(I+2) = IWIN(I) + (WIN(I+2) - WIN(I)) / INC(I)
            IF (IWIN(I+2).GT.MAXXTV(I)) THEN
               IWIN(I+2) = MAXXTV(I)
               WIN(I+2) = WIN(I) + (IWIN(I+2) - IWIN(I)) * INC(I)
               END IF
            END IF
 70      CONTINUE
      WRITE (MSGTXT,1070) TMIN, TMAX, INC(1)
      CALL MSGWRT (2)
      CALL COPY (256, CATBLK, CATITM)
C                                       Prepare to read map.
      CALL ZOPEN (LUN, FND, VMVOL(IN), VMFILE(IN), MAP, EXCL, WAIT,
     *   IERR)
      IF (IERR.NE.0) GO TO 998
      CALL FILL (5, 1, CATBLK(IIDEP))
      CATBLK(KINAX) = VMSZ(1,IN)
      CATBLK(KINAX+1) = VMSZ(2,IN)
      CATR(IRRAN) = TMIN
      CATR(IRRAN+1) = TMAX
      CALL TVLOAD (LUN, FND, ICH, INC, IWIN, WIN, BUFSZ(1), XBUFF, IERR)
      CALL COPY (256, CATITM, CATBLK)
      CALL ZCLOSE (LUN, FND, I)
      IERR = MAX (I, IERR)
      IF (IERR.NE.0) GO TO 998
C                                       Ask user to quit?
      IF (TVPASS.LT.0) GO TO 998
         MSGTXT = 'Hit button D within 15 seconds to stop cleaning now'
         CALL MSGWRT (1)
         MSGTXT = 'Hit buttons A, B, or C to continue sooner'
         CALL MSGWRT (1)
         RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2.0
         RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2.0
         TD = 0.2
         CALL YCURSE ('ONNN', F, F, RPOS, IQ, IB, IERR)
         IF (IERR.NE.0) GO TO 998
         DO 130 I = 1,75
            CALL ZDELAY (TD, IERR)
            CALL YCURSE ('READ', F, F, RPOS, IQ, IB, IERR)
            IF (IB.GT.7) GO TO 140
            IF (IB.GT.0) GO TO 135
            IF (IERR.NE.0) GO TO 150
 130        CONTINUE
 135     MSGTXT = 'Continuing'
         CALL MSGWRT (1)
         GO TO 150
C                                       Wants to quit
 140     TVPASS = 32700
         MSGTXT = 'TV Button D hit: have done enough I guess'
         CALL MSGWRT (3)
C                                       Off cursor
 150     CALL YCURSE ('OFFF', F, F, RPOS, IQ, IB, IERR)
C
 998  CALL TVCLOS (BUFFR1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MIN GREATER OR EQUAL TO MAX')
 1010 FORMAT ('IMCLEAR ERROR =',I6)
 1070 FORMAT ('Loading TV from',1PE10.3,' to',1PE10.3,' every',I2,
     *   ' pixel')
      END

      SUBROUTINE QGRDMI (APCORE, A, B, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Combined complex vector in gridding uv data.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   QGRDMI combines two complex vectors (A and B) to form conjugate
C   rows in a grid file to be FFTed; such that when the file is FFTed,
C   the resulting real portion is the Fourier transform of A and the
C   imaginary portion is the Fourier transform of B. (A and B assumed
C   to be symmetric).
C            A => A + iB
C            B => Conjg(A) + i * Conjg(B)
C   Inputs:
C      A   I  First complex vector base address (increment=2)
C      B   I  Second complex vector base address.
C      N   I  Element count.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   A, B, N
C
      LONGINT   JA, JB
      INTEGER   II
      DOUBLE PRECISION AR, AI, BR
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Addresses to 1-rel.
      JA = A + PSAPOF
      JB = B + PSAPOF
C                                       Loop
      INCLUDE 'INCS:ZVND.INC'
      DO 100 II = 1,N
         AR = APCORE(JA)
         AI = APCORE(JA+1)
         BR = APCORE(JB)
         APCORE(JA) = AR - APCORE(JB+1)
         APCORE(JA+1) = AI + APCORE(JB)
         APCORE(JB) = AR + APCORE(JB+1)
         APCORE(JB+1) = BR - AI
         JA = JA + 2
         JB = JB + 2
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE TAUORB (R, OMEGAF, V, OMEGVF, INCLIN, OMEGA, DELTA,
     *   ALPHA, TAU, RATE, DTAUDR, DTAUOF, DTAUDI, DTAUOM, DRATDV,
     *   DRATOF, DRATDI, DRATOM)
C----------------------------------------------------------------------
C! Delay and rate for an orbiting antenna, including error terms
C# Math Coordinates UV Calibration
C----------------------------------------------------------------------
C;  Copyright (C) 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------

C----------------------------------------------------------------------
C   Subroutine to compute delay and rate for an orbiting antenna
C   and their partial derivates wrt a transformed set of orb. parm.
C   Inputs:
C      R          D    Geocentric distance to the antenna (m)
C      OMEGAF     D    Angle in the orbit plane from the ascending node
C                      to the anten. as seen from the geocenter (rad)
C      V          D    Speed of the orbiting antenna (m/s)
C      OMEGVF     D    Angle in the orbit plane from the ascending node
C                      to the antenna velocity vector (rad)
C      INCLIN     D    Orbit plane inclination (rad)
C      OMEGA      D    Right ascension of the ascending mode (rad)
C      DELTA      D    Source declination (rad)
C      ALPHA      D    Source right ascension (rad)
C   Output:
C      TAU        D    Projection of the geocentric antenna vector
C                      in the source direction (m)
C      RATE       D    Time rate of change of TAU (m/s)
C      DTAUDR     D    Partial derivative DTAU/DR (dimensionless)
C      DTAUOF     D    Partial derivative DTAU/DOMEGAF  (m/arcsec)
C      DTAUDI     D    Partial derivative DTAU/DINCLIN, (m/arcsec)
C      DTAUOM     D    Partial derivative DTAU/DOMEGA, (m/arcsec)
C      DRATDV     D    Partial derivative DRATE/DV (m/sec/m/sec)
C      DRATOF     D    Partial derivative DRATE/DOMEGAF (m/sec/arcsec)
C      DRATDI     D    Partial derivative DRATE/DINCLIN (m/sec/arcsec)
C      DRATOM     D    Partial derivative DRATE/DOMEGA (m/sec/arcsec)
C----------------------------------------------------------------------
      DOUBLE PRECISION R, OMEGAF, V, OMEGVF, INCLIN, OMEGA, DELTA,
     *   ALPHA, TAU, RATE, DTAUDR, DTAUOF, DTAUDI, DTAUOM, DRATDV,
     *   DRATOF, DRATDI, DRATOM, OMAL
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      OMAL = OMEGA - ALPHA
C                                       Delay in m
      TAU = R * ( COS(DELTA) * (COS(OMEGAF) * COS(OMAL) - COS(INCLIN) *
     *   SIN(OMEGAF) * SIN(OMAL)) + SIN(INCLIN) * SIN(OMEGAF) *
     *   SIN(DELTA))
C                                       Partial derivative DTAU/DR,
C                                       m/m
      DTAUDR = COS(DELTA) * (COS(OMEGAF) * COS(OMAL) - COS(INCLIN) *
     *   SIN(OMEGAF) * SIN(OMAL)) + SIN(INCLIN) * SIN(OMEGAF) *
     *   SIN(DELTA)
C                                       Partial derivative
C                                       DTAU/DOMEGAF, m/arcsec
      DTAUOF = R * (COS(DELTA) * (-SIN(OMEGAF) * COS(OMAL) -
     *   COS(INCLIN) * COS(OMEGAF) * SIN(OMAL)) + SIN(INCLIN) *
     *   COS(OMEGAF) * SIN(DELTA)) * AS2RAD
C                                       Partial derivative
C                                       DTAU/DINCLIN, m/arcsec
      DTAUDI = R * ( COS(DELTA) * SIN(INCLIN) * SIN(OMEGAF) * SIN(OMAL)
     *   + COS(INCLIN) * SIN(OMEGAF) *SIN(DELTA)) * AS2RAD
C                                       Partial derivative
C                                       DTAU/DOMEGA, m/arcsec
      DTAUOM = -R * COS(DELTA) * (COS(OMEGAF) * SIN(OMAL) + COS(INCLIN)
     *   * SIN(OMEGAF) * COS(OMAL)) * AS2RAD
C
C                                       Rate in m/sec
      RATE = V * ( COS(DELTA) * (COS(OMEGVF) * COS(OMAL) - COS(INCLIN) *
     *   SIN(OMEGVF) * SIN(OMAL)) + SIN(INCLIN) * SIN(OMEGVF) *
     *   SIN(DELTA))
C                                       Partial derivative DRAT/DV,
C                                       m/sec/m/sec
      DRATDV = COS(DELTA) * (COS(OMEGVF) * COS(OMAL) - COS(INCLIN) *
     *   SIN(OMEGVF) * SIN(OMAL)) + SIN(INCLIN) * SIN(OMEGVF) *
     *   SIN(DELTA)
C                                       Partial derivative
C                                       DRAT/DOMEGVF, m/sec/arcsec
      DRATOF = V * (COS(DELTA) * (-SIN(OMEGVF) * COS(OMAL) -
     *   COS(INCLIN) * COS(OMEGVF) * SIN(OMAL)) + SIN(INCLIN) *
     *   COS(OMEGVF) * SIN(DELTA)) * AS2RAD
C                                       Partial derivative
C                                       DRAT/DINCLIN, m/arcsec
      DRATDI = V * ( COS(DELTA) * SIN(INCLIN) * SIN(OMEGVF) * SIN(OMAL)
     *   + COS(INCLIN) * SIN(OMEGVF) *SIN(DELTA)) * AS2RAD
C                                       Partial derivative
C                                       DRAT/DOMEGA, m/arcsec
      DRATOM = -V * COS(DELTA) * (COS(OMEGVF) * SIN(OMAL) + COS(INCLIN)
     *   * SIN(OMEGVF) * COS(OMAL)) * AS2RAD
C
 999  RETURN
      END

LOCAL INCLUDE 'TVCPS.INC'
C                                                        Include TVCPS.
C                                       Local include for TVCPS.
C                                       Dimensions of work arrays.
C                                        MAXROW = maximum row size in
C                                                 pixels
C                                        MAXPLN = maximum number of
C                                                 grey-scale planes
C                                        MXGPLN = maximum number of
C                                                 graphics planes
C                                        MAXLUT = maximum number of
C                                                 entries in an LUT
C                                        MAXOFM = maximum number of
C                                                 entries in an OFM
      INCLUDE 'INCS:PMAD.INC'
      INCLUDE 'INCS:PTVC.INC'
      INTEGER MAXROW, MAXPLN, MXGPLN, MAXLUT, MAXOFM, COLOUR
      PARAMETER (MAXROW = (MAXIMG))
      PARAMETER (MAXPLN = 16)
      PARAMETER (MXGPLN = 8)
      PARAMETER (MAXLUT = (TVMLUT)+1)
      PARAMETER (MAXOFM = (TVMOFM)+1)
C                                       WIDTH = width of output media
C                                               in points
C                                       HEIGHT = height of output media
C                                                in points
C                                       MARGIN = margin to leave at edge
C                                                of output media in
C                                                points
C                                       AGAMMA = gamma corrections for
C                                                red, green and blue
C                                                channels
C                                       ASPPT = the number of arcseconds
C                                               per printers point (set
C                                               from ASPMM); if zero
C                                               or negative then the
C                                               plot will be scaled to
C                                               fit the page.
C                                       BLC = Botton-left corner of
C                                             image if reading from
C                                             disk.
C                                       TRC = Top-right hand corner of
C                                             image if reading from
C                                             disk.
C                                       DX = column increment when
C                                            reading from disk.
C                                       DY = row increment when reading
C                                            from disk.
C                                       CATBLK = image header
C                                       IPLANE = the plane containing
C                                                the selected disk
C                                                image (if any).

      REAL      WIDTH, HEIGHT, MARGIN, AGAMMA(3), ASPPT, BLC(7), TRC(7),
     *   RGBC(3)
      INTEGER   IPLANE, COPIES
C                                       OUTPRT = name of output file
C                                       REASON = text to add to AOC
C                                                admin. info.
      CHARACTER OUTPRT*48, REASON*40
C                                       EPSF = true if writing
C                                              encapsulated PostScript
C                                       COLOUR = true if writing a
C                                                colour image.
C                                       DOLAB = true if a label
C                                               containing the AIPS
C                                               user number is
C                                               required.
C                                       DOINV = true if the grey-
C                                               scale should be
C                                               inverted.
C                                       DODISK = true if reading image
C                                                data from disk.
      LOGICAL   EPSF, DOLAB, DOINV, DODISK, ROTATE, DOROT, ISON(MAXPLN)
C                                       LUT for image file.
      INTEGER   PSLUN
      PARAMETER (PSLUN = 10)
C
      INTEGER   LUTDAT(MAXLUT,3,MAXPLN), TVWIND(4), CATBLK(256,MAXPLN)
      INTEGER   RBITS(MAXPLN), GBITS(MAXPLN), BBITS(MAXPLN), DX, DY,
     *   LGRAPH
      REAL      OFMDAT(MAXOFM,3)
      INTEGER   GPMASK(MXGPLN)
C
      COMMON /PSDATA/ CATBLK, AGAMMA, WIDTH, HEIGHT, MARGIN, EPSF,
     *   COLOUR, DOLAB, DOINV, DODISK, ASPPT, BLC, TRC, DX, DY, IPLANE,
     *   ROTATE, DOROT, COPIES, ISON, LGRAPH, RGBC
      COMMON /CHPARM/ OUTPRT, REASON
      COMMON /TVDATA/ LUTDAT, OFMDAT, TVWIND, RBITS, GBITS, BBITS,
     *   GPMASK
C                                                           End TVCPS.
LOCAL END
      PROGRAM TVCPS
C-----------------------------------------------------------------------
C! Copies a TV image to a PostScript file.
C# TV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2000, 2002-2003, 2005, 2007-2008,
C;  Copyright (C) 2015, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TVCPS reads the current contents of an AIPS TV and writes them
C   to a PostScript file.
C-----------------------------------------------------------------------
      INTEGER   IRET, WBUFF(256)
C
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'TVCPS.INC'
C-----------------------------------------------------------------------
C                                       Initialize AIPS commons and
C                                       read and check input adverbs:
      CALL TVPSIN (IRET)
C
C                                       Open output file and TV device:
      IF (IRET.EQ.0) CALL PSINIT (IRET)
C                                       Copy screen image to output
C                                       file:
      IF (IRET.EQ.0) CALL CPSCRN (IRET)
C                                       Close output file and TV
C                                       device:
      IF (IRET.EQ.0) CALL PSFIN (IRET)
C                                       Terminate task:
      CALL DIE (IRET, WBUFF)
C
 999  STOP
      END
      SUBROUTINE TVPSIN (IRET)
C-----------------------------------------------------------------------
C   Initialize AIPS commons and read and check input adverbs.  Restart
C   AIPS if the DOWAIT adverb is true.
C   Output parameters:
C      IRET     I      Return status.
C                       0 -> success
C                       1 -> failed to read adverbs
C                       2 -> failed to restart AIPS
C                       3 -> bad input adverb
C   Output in /PSDATA/ (TVCPS.INC):
C      WIDTH    R      Media width in points
C      HEIGHT   R      Media width in points
C      MARGIN   R      Margin to leave around image in points
C      EPSF     L      Generate EPSF?
C      COLOUR   I      Colour image?
C   Output in /CHPARM/ (TVCPS.INC)
C      OUTPRT   C*48  Name of the image file or blank (if blank
C                      image file will not be saved).
C   Output in /TVDATA/ (TVCPS.INC)
C      GPMASK   I(MXGPLN)   GPMASK(I) is true if graphics plane (I)
C                           should be in the output image.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   SCRTCH(256), NPARM, JRET, IROUND, I
      CHARACTER PRGM*6
      REAL      APARM(10), ASPMM, XDOINV, XDOTV, XBLC(7), XTRC(7),
     *   XXINC, XYINC, XCOPYS, RGBCOL(3)
      HOLLERITH XOUTPR(12), XCODE, XREASN(6)
C
      PARAMETER (NPARM = 12 +1 +10 +1 +1 +1 +1 +7 +7 +1 +1 +6 +3)
      PARAMETER (PRGM = 'TVCPS ')
C                                        UNITS = units of APARM(1:3)
C                                         0 = inches
C                                         1 = cm
C                                         2 = points
C                                         anything else = inches
      INTEGER   UNITS
C                                        SCALE = scaling factors for
C                                                UNITS
      REAL   SCALE(0:2)
C
      CHARACTER OPCODE*4
C
      COMMON /ADVERB/ XOUTPR, XCOPYS, APARM, XCODE, ASPMM, XDOINV,
     *   RGBCOL, XDOTV, XBLC, XTRC, XXINC, XYINC, XREASN
C
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'TVCPS.INC'
      DATA SCALE /72.0, 28.35, 1.0/
C-----------------------------------------------------------------------
C                                       Initialize device
C                                       characteristics common:
      CALL ZDCHIN (.TRUE.)
C                                       Initialize catalogue pointer
C                                       common:
      CALL VHDRIN
C                                       Initialize files common:
      NSCR = 0
      NCFILE = 0
C                                       Assume success:
      IRET = 0
C                                       Get input adverbs:
      CALL GTPARM (PRGM, NPARM, RQUICK, XOUTPR, SCRTCH, JRET)
      IF (JRET.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1000) JRET
         CALL MSGWRT (8)
         END IF
C
      IF (RQUICK) THEN
C                                       Restart AIPS:
         CALL RELPOP (IRET, SCRTCH, JRET)
         IF (JRET.NE.0) THEN
            IRET = 2
            WRITE (MSGTXT,1001) JRET
            CALL MSGWRT (8)
            END IF
         END IF
C                                       Unpack input parameters:
      IF (IRET.EQ.0) THEN
         IF (APARM(6).EQ.0.0) APARM(6) = APARM(5)
         IF (APARM(7).EQ.0.0) APARM(7) = APARM(5)
         AGAMMA(1) = APARM(5)
         AGAMMA(2) = APARM(6)
         AGAMMA(3) = APARM(7)
         CALL H2CHR (48, 1, XOUTPR, OUTPRT)
         COPIES = XCOPYS + 0.01
         IF ((COPIES.LE.0) .OR. (OUTPRT.NE.' ')) COPIES = 1
         UNITS = NINT (APARM(4))
         IF ((UNITS.LT.0).OR.(UNITS.GT.2)) UNITS = 0
         IF (APARM(1).LE.0.0) THEN
            WIDTH = 8.5 * SCALE(0)
         ELSE
            WIDTH = APARM(1) * SCALE(UNITS)
            END IF
         IF (APARM(2).LE.0.0) THEN
            HEIGHT = 11.0 * SCALE(0)
         ELSE
            HEIGHT = APARM(2) * SCALE(UNITS)
            END IF
         IF (APARM(3).LE.0.0) THEN
            MARGIN = 0.5 * SCALE(0)
         ELSE
            MARGIN = APARM(3) * SCALE(UNITS)
            END IF
         MARGIN = MIN (MARGIN, WIDTH/3)
         MARGIN = MIN (MARGIN, HEIGHT/3)
         LGRAPH = APARM(8) + 0.01
         CALL H2CHR (4, 1, XCODE, OPCODE)
         IF ((OPCODE.EQ.'GREY') .OR. (OPCODE.EQ.'GRAY') .OR.
     *      (OPCODE.EQ.'B/W ')) THEN
            COLOUR = 0
         ELSE
            COLOUR = 1
            IF ((OPCODE.EQ.'COLB') .AND. (XDOINV.LE.0.0)) COLOUR = 2
            END IF
         EPSF = .TRUE.
         ASPPT = 10.0 * ASPMM / SCALE(1)
C                                       Numeric user label, inverse
         CALL H2CHR (24, 1, XREASN, REASON)
         REASON(25:) = ' '
         DOLAB = REASON.NE.' '
         DOINV = XDOINV.GT.0.0
         DOROT = APARM(9).LE.0.0
         IF ((APARM(10).GT.0.0) .AND. (COLOUR.GT.0)) COLOUR = COLOUR + 2
C                                       Disk or TV image
         DODISK = XDOTV.LT.-1.0
         CALL RCOPY (7, XBLC, BLC)
         CALL RCOPY (7, XTRC, TRC)
         DX = IROUND (XXINC)
         DY = IROUND (XYINC)
         DO 10 I = 1,3
            RGBC(I) = MAX (0.0, MIN (1.0, RGBCOL(I)))
 10         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FAILED TO READ ADVERBS: GTPARM ERROR ', I7)
 1001 FORMAT ('FAILED TO RESTART AIPS: RELPOP ERROR ', I2)
      END
      SUBROUTINE PSINIT (IRET)
C-----------------------------------------------------------------------
C   Open the TV, read the TV parameters, open the image file and write
C   the image file header.
C   Output:
C      IRET      I      Return status
C                          0 -> success
C                          1 -> could not open TV
C                          2 -> internal array too small
C                          3 -> could not read current window
C                          4 -> could not read LUTs
C                          5 -> could not read OFMs
C                          6 -> could not read active planes
C                          7 -> could not open PostScript file
C                          8 -> error locating disk image
C   Outputs in /TVDATA/ (TVCPS.INC)
C      TVWIND    I(4)   Current BLC (elements 1 and 2) and TRC
C                       (elements 3 and 4) of current TV viewport
C                       or, for disk, the image BLC (1,2) and the number
C                       of pixels (+BLC) after DX, DY in (3,4)
C      LUTDAT    I(MAXLUT, 3, MAXPLN)
C                       Red (,1,), green (,2,), and blue (,3,)
C                       LUTs for each grey-scale plane.
C      OFMDAT    R(MAXOFM, 3)
C                       Red (,1), green (,2) and blue (,3) OFMs.
C      RBITS     I(MAXPLN)
C      GBITS     I(MAXPLN)
C      BBITS     I(MAXPLN)
C                       Red, green and blue plane bit masks.
C-----------------------------------------------------------------------
      INTEGER   IRET, SCRTCH(256)
C
      INTEGER   JRET, BBOX(2,2), IPL, ICHAN, XSPLT, YSPLT, RCHANS(4),
     *   GCHANS(4), BCHANS(4), LSC, I, IWIN(4), MAG
      REAL      IGAMMA, CATR(256), DELTAX, DELTAY
      LOGICAL   UNIQUE
      EQUIVALENCE (CATBLK, CATR)
      INCLUDE   'INCS:DDCH.INC'
      INCLUDE   'INCS:DHDR.INC'
      INCLUDE   'INCS:DMSG.INC'
      INCLUDE   'INCS:DTVC.INC'
      INCLUDE   'TVCPS.INC'
C-----------------------------------------------------------------------
C                                       Assume success:
      IRET = 0
C                                       Open the TV device:
      CALL TVOPEN (SCRTCH, JRET)
      IF (JRET.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1000) JRET
         GO TO 990
         END IF
C                                       Check that the internal arrays
C                                       are large enough for this
C                                       TV device:
      IF (NGRAY.GT.MAXPLN) THEN
         IRET = 2
         WRITE (MSGTXT,1001) MAXPLN
         GO TO 990
         END IF
      IF (NGRAPH.GT.MXGPLN) THEN
         IRET = 2
         WRITE (MSGTXT,1002) MXGPLN
         GO TO 990
         END IF
      IF ((MAXINT+1).GT.MAXLUT) THEN
         IRET = 2
         WRITE (MSGTXT,1003) MAXLUT
         GO TO 990
         END IF
      IF ((OFMINP+1).GT.MAXOFM) THEN
         IRET = 2
         WRITE (MSGTXT,1004) MAXOFM
         GO TO 990
         END IF
C                                       Read current TV window:
      CALL YWINDO ('READ', TVWIND, JRET)
      IF (JRET.NE.0) THEN
         IRET = 3
         WRITE (MSGTXT,1005) JRET
         GO TO 990
         END IF
C                                       Check that the line buffer
C                                       is large enough to hold one
C                                       row from the current window:
      IF ((TVWIND(3)-TVWIND(1)+1).GT.MAXROW) THEN
         IRET = 2
         WRITE (MSGTXT,1006) MAXROW
         GO TO 990
         END IF
C                                       Read look-up table for each
C                                       grey-scale plane:
      DO 10 IPL = 1,NGRAY
         ICHAN = 2 ** (IPL-1)
         CALL YLUT ('READ', ICHAN, 4, .TRUE., LUTDAT(1,1,IPL), JRET)
         IF (JRET.NE.0) THEN
            IRET = 4
            WRITE (MSGTXT,1007) JRET
            GO TO 990
            END IF
         CALL YLUT ('READ', ICHAN, 2, .TRUE., LUTDAT(1,2,IPL), JRET)
         IF (JRET.NE.0) THEN
            IRET = 4
            WRITE (MSGTXT,1007) JRET
            GO TO 990
            END IF
         CALL YLUT ('READ', ICHAN, 1, .TRUE., LUTDAT(1,3,IPL), JRET)
         IF (JRET.NE.0) THEN
            IRET = 4
            WRITE (MSGTXT,1007) JRET
            GO TO 990
            END IF
 10      CONTINUE
C                                       set gamma corrections
      IGAMMA = TVGAMA
      IF ((AGAMMA(1).GT.0.1) .AND. (AGAMMA(1).LE.10.)) THEN
         TVGAMA = IGAMMA / AGAMMA(1)
      ELSE IF (AGAMMA(1).GE.0.0) THEN
         TVGAMA = 1.0
      ELSE
         TVGAMA = IGAMMA
         END IF
      AGAMMA(1) = TVGAMA
C                                       Read OFMs:
      CALL YOFM ('READ', 4, .TRUE., OFMDAT(1, 1), JRET)
      IF (JRET.NE.0) THEN
         IRET = 5
         WRITE (MSGTXT,1010) JRET
         GO TO 990
         END IF
      IF ((AGAMMA(2).GT.0.1) .AND. (AGAMMA(2).LE.10.)) THEN
         TVGAMA = IGAMMA / AGAMMA(2)
      ELSE IF (AGAMMA(2).GE.0.0) THEN
         TVGAMA = 1.0
      ELSE
         TVGAMA = IGAMMA
         END IF
      AGAMMA(2) = TVGAMA
      CALL YOFM ('READ', 2, .TRUE., OFMDAT(1, 2), JRET)
      IF (JRET.NE.0) THEN
         IRET = 5
         WRITE (MSGTXT,1010) JRET
         GO TO 990
         END IF
      IF ((AGAMMA(3).GT.0.1) .AND. (AGAMMA(3).LE.10.)) THEN
         TVGAMA = IGAMMA / AGAMMA(3)
      ELSE IF (AGAMMA(3).GE.0.0) THEN
         TVGAMA = 1.0
      ELSE
         TVGAMA = IGAMMA
         END IF
      AGAMMA(3) = TVGAMA
      CALL YOFM ('READ', 1, .TRUE., OFMDAT(1, 3), JRET)
      IF (JRET.NE.0) THEN
         IRET = 5
         WRITE (MSGTXT,1010) JRET
         GO TO 990
         END IF
      TVGAMA = IGAMMA
C                                       Find out which grey-scale
C                                       planes are enabled.
      CALL YSPLIT ('READ', XSPLT, YSPLT, RCHANS, GCHANS, BCHANS, .TRUE.,
     *   JRET)
      IF (JRET.NE.0) THEN
         IRET = 6
         WRITE (MSGTXT,1011) JRET
         GO TO 990
         END IF
      CALL ZGTBIT (NGRAY, RCHANS(1), RBITS)
      CALL ZGTBIT (NGRAY, GCHANS(1), GBITS)
      CALL ZGTBIT (NGRAY, BCHANS(1), BBITS)
C                                       which graphics planes
      I = TVLIMG(1) / (2 ** NGRAY)
      CALL ZGTBIT (NGRAPH, I, GPMASK)
C                                       which scroll
      LSC = 0
      DO 20 IPL = 1,NGRAY
         I = NGRAY + 1 - IPL
         ISON(I) = (RBITS(I).NE.0) .OR. (GBITS(I).NE.0) .OR.
     *      (BBITS(I).NE.0)
         IF (ISON(I)) LSC = I
         IF (RBITS(I).EQ.0) CALL FILL (MAXINT+1, 0, LUTDAT(1,1,I))
         IF (GBITS(I).EQ.0) CALL FILL (MAXINT+1, 0, LUTDAT(1,2,I))
         IF (BBITS(I).EQ.0) CALL FILL (MAXINT+1, 0, LUTDAT(1,3,I))
 20      CONTINUE
      IF (LSC.EQ.0) LSC = NGRAY + 1
C                                       zoom correction
      CALL COPY (4, TVWIND, IWIN)
      IF (TVZOOM(1).NE.0) THEN
         MAG = 1 + TVZOOM(1)
         IF (MXZOOM.GT.0) MAG = 2 ** TVZOOM(1)
         IWIN(1) = IWIN(1) - (MAG-1)/2
         IWIN(1) = (IWIN(1) - TVZOOM(2)) / MAG + TVZOOM(2)
         IWIN(3) = IWIN(3) - (MAG-1)/2
         IWIN(3) = (IWIN(3) - TVZOOM(2)) / MAG + TVZOOM(2)
         IWIN(2) = IWIN(2) + 1 - (MAG-1)/2
         IWIN(2) = (IWIN(2) - TVZOOM(3)) / MAG + TVZOOM(3)
         IWIN(4) = IWIN(4) + 1 - (MAG-1)/2
         IWIN(4) = (IWIN(4) - TVZOOM(3)) / MAG + TVZOOM(3)
         END IF
      IF (LSC.LE.NGRAY) THEN
         TVWIND(1) = IWIN(1) - TVSCRX(LSC)
         TVWIND(3) = IWIN(3) - TVSCRX(LSC)
         TVWIND(2) = IWIN(2) - TVSCRY(LSC)
         TVWIND(4) = IWIN(4) - TVSCRY(LSC)
      ELSE
         TVWIND(1) = IWIN(1) - TVSCGX
         TVWIND(3) = IWIN(3) - TVSCGX
         TVWIND(2) = IWIN(2) - TVSCGY
         TVWIND(4) = IWIN(4) - TVSCGY
         END IF
      IF (TVWIND(1).LT.1) THEN
         TVWIND(1) = TVWIND(1) + MAXXTV(1)
         TVWIND(3) = TVWIND(3) + MAXXTV(1)
         END IF
      IF (TVWIND(1).GT.MAXXTV(1)) THEN
         TVWIND(1) = TVWIND(1) - MAXXTV(1)
         TVWIND(3) = TVWIND(3) - MAXXTV(1)
         END IF
      IF (TVWIND(2).LT.1) THEN
         TVWIND(2) = TVWIND(2) + MAXXTV(2)
         TVWIND(4) = TVWIND(4) + MAXXTV(2)
         END IF
      IF (TVWIND(2).GT.MAXXTV(2)) THEN
         TVWIND(2) = TVWIND(2) - MAXXTV(2)
         TVWIND(4) = TVWIND(4) - MAXXTV(2)
         END IF
C                                       Get disk header parms
      IF (DODISK) THEN
         CALL IMFIND (ISON, BLC, TRC, DX, DY, TVWIND, DODISK, IPLANE,
     *      CATBLK, JRET)
         IF (JRET.NE.0) THEN
            IRET = 8
            WRITE (MSGTXT, 1012) JRET
            GO TO 990
            END IF
         END IF
      IF ((.NOT.DODISK) .AND. (ASPPT.GT.0.0)) THEN
C                                       Also need CATBLK for explicit
C                                       scaling.
         CALL TVFIND (NGRAY, 'MA', IPLANE, UNIQUE, CATBLK, SCRTCH,
     *         JRET)
         IF (JRET.NE.0) THEN
            IRET = 8
            WRITE (MSGTXT, 1012) JRET
            GO TO 990
            END IF
C                                       Figure out the TXINC and TYINC
C                                       used when the map was loaded:
         DELTAX = (CATBLK(IIWIN+2,1) - CATBLK(IIWIN+0,1) + 1.0)
     *      / (CATBLK(IICOR+2,1) - CATBLK(IICOR + 0,1) + 1.0)
         DELTAY = (CATBLK(IIWIN+3,1) - CATBLK(IIWIN+1,1) + 1.0)
     *      / (CATBLK(IICOR+3,1) - CATBLK(IICOR + 1,1) + 1.0)
C                                       Negative DX or DY indicates
C                                       dilation as with the TXINC and
C                                       TYINC adverbs.
         IF (DELTAX.GT.1) THEN
            DX = NINT (DELTAX)
         ELSE
            DX = -NINT (1.0/DELTAX)
            END IF
         IF (DELTAY.GT.1) THEN
            DY = NINT (DELTAY)
         ELSE
            DY = -NINT (1.0/DELTAY)
            END IF
         END IF
C                                       Calculate bounding box:
      CALL CALCBB (ASPPT, CATR, DX, DY, TVWIND, WIDTH, HEIGHT, MARGIN,
     *   DOLAB, DOROT, BBOX, ROTATE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Open PostScript file and write
C                                       prologue:
      CALL PSPLOG (PSLUN, OUTPRT, EPSF, BBOX, COLOUR, DOLAB, ROTATE,
     *   JRET)
      IF (JRET.NE.0) THEN
         IRET = 7
         WRITE (MSGTXT,1013) JRET
         GO TO 990
         END IF
C                                        Begin output page:
      CALL PSPSET (PSLUN, COLOUR, TVWIND, BBOX, DOLAB, REASON, ROTATE,
     *   JRET)
      IF (JRET.NE.0) THEN
         IRET = 7
         WRITE (MSGTXT,1014) JRET
         END IF
C
 990  IF (IRET.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CANNOT OPEN TV: TVOPEN ERROR ',I3)
 1001 FORMAT ('TOO MANY GREY-SCALE PLANES FOR TVCPS (> ',I2,')')
 1002 FORMAT ('TOO MANY GRAPHICS PLANES FOR TVCPS (> ',I2,')')
 1003 FORMAT ('LUTS TOO LARGE FOR TVCPS (> ',I4,' ENTRIES)')
 1004 FORMAT ('OFMS TOO LARGE FOR TVCPS (> ',I4,' ENTRIES)')
 1005 FORMAT ('COULD NOT READ WINDOW: YWINDO ERROR ',I2)
 1006 FORMAT ('TV WINDOW TOO WIDE (> ',I5,' PIXELS)')
 1007 FORMAT ('CANNOT READ LUT: YLUT ERROR ',I2)
 1010 FORMAT ('CANNOT READ OFM: YOFM ERROR ',I2)
 1011 FORMAT ('CANNOT READ PLANE MASK: YSPLIT ERROR ',I2)
 1012 FORMAT ('CANNOT FIND TV IMAGE CATBLK, ERROR ',I2)
 1013 FORMAT ('CANNOT OPEN OUTPUT FILE: PSPLOG ERROR ',I2)
 1014 FORMAT ('CANNOT WRITE PAGE SETUP: PSPSET ERROR ',I2)
      END
      SUBROUTINE CPSCRN (IRET)
C-----------------------------------------------------------------------
C   Copy the image on the screen to the output file.
C   Output:
C      IRET   I   Return status 0 -> success
C                    1 -> cannot read TV
C                    2 -> error writing file
C                    3 -> cannot read image file
C   The colours of graphics planes that are set for a given pixel are
C   combined by a bitwise exclusive-or operation on graphics channels 1
C   through 4.  If none of these channels is on (and requested) at a
C   pixel, the color of the lowest of graphics channels 5-8 that is on
C   and requested at that pixel is the color used.  Only if no requested
C   graphics channel is on at that pixel is the image (grey-scale) value
C   used.  The array GCOLOR holds a lookup table for the graphics
C   colours indexed by the bitmask of all requested planes with bits
C   set.  For example, if graphics planes 1 and 4 are requested and both
C   are set at a particular pixel location the red component of the
C   colour at that pixel will be GCOLOR(1, 2 ** (4 - 1) + 2 ** (1 - 1) +
C   1) which will contain the exclusive-or of the red components of the
C   colours of planes 1 and 4.  If planes 1,4,5,6 are requested, but
C   only planes 5 and 6 are on at that pixel, then the color of graphics
C   plane 5 is used.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   JRET, I, J, IROW, WWIDTH, WHT, PIXELS, OLINES, DELBLK,
     *   ITRIM, WIN(4), BUFSZ, LR, LG, LB, NPIX, ZEOR, L, IPL, IW,
     *   BITS(32), LCOLOR(3), LGR, MGR, LROW, NP(2), IX0(2), NW, IX1(2)
      REAL      RED, GREEN, BLUE
      LOGICAL   T
C                                       PSBUFF = PostScript buffer
      CHARACTER PSBUFF*80, PHNAME*48
C                                       Scaling factor from OFM output
C                                       to film recorder input.
      REAL      SCALE
      PARAMETER (SCALE = 255.0)
      INCLUDE 'TVCPS.INC'
      INTEGER   ROUT(MAXROW), GOUT(MAXROW), BOUT(MAXROW),
     *   GCOLOR(3,2**MXGPLN), GROW(MAXROW), BCOLOR(3,MXGPLN),
     *   LUN(MAXPLN), IND(MAXPLN), ININD(MAXPLN), ROW(MAXROW,MAXPLN)
      REAL      TEMP, BUFF(MABFSS,MAXPLN), CATR(256,MAXPLN)
      HOLLERITH CATH(256,MAXPLN)
      CHARACTER TRANFN(MAXPLN)*2
      INCLUDE   'INCS:DDCH.INC'
      INCLUDE   'INCS:DMSG.INC'
      INCLUDE   'INCS:DTVC.INC'
      INCLUDE   'INCS:DHDR.INC'
      EQUIVALENCE (CATBLK, CATR, CATH)
      DATA T /.TRUE./
C-----------------------------------------------------------------------
      IRET = 0
      BUFSZ = MABFSS * 2
C                                       Calculate window width and
C                                       height:
      WWIDTH = TVWIND(3) - TVWIND(1) + 1
      WHT = TVWIND(4) - TVWIND(2) + 1
C                                       Calculate number of pixels:
      PIXELS = WWIDTH * WHT
C                                       Calculate number of lines of
C                                       output (if we tell the
C                                       PostScript interpreter the
C                                       number of lines of data it
C                                       can avoid parsing the data):
      IF (COLOUR.GT.0) THEN
         OLINES = (PIXELS + 11) / 12 + 1
      ELSE
         OLINES = (PIXELS + 35) / 36 + 1
         END IF
C                                       Write out PostScript
C                                       operators:
      WRITE (PSBUFF,5000) WWIDTH, WHT, WWIDTH, WHT
      CALL ZLASIO ('WRIT', PSLUN, ' ', ITRIM(PSBUFF), PSBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      PSBUFF = '{currentfile picst readhexstring pop}'
      CALL ZLASIO ('WRIT', PSLUN, ' ', ITRIM(PSBUFF), PSBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (COLOUR.GT.0) THEN
         PSBUFF = 'false 3'
         IF (COLOUR.GT.2) PSBUFF = 'false 4'
         CALL ZLASIO ('WRIT', PSLUN, ' ', ITRIM(PSBUFF), PSBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      WRITE (PSBUFF,5001) OLINES
      CALL ZLASIO ('WRIT', PSLUN, ' ', ITRIM(PSBUFF), PSBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (COLOUR.GT.0) THEN
         PSBUFF = 'colorimage'
      ELSE
         PSBUFF = 'image'
         END IF
      CALL ZLASIO ('WRIT', PSLUN, ' ', ITRIM(PSBUFF), PSBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Image from the TV
      IF (.NOT.DODISK) THEN
         NW = 1
         IX0(1) = TVWIND(1)
         IX1(1) = 1
         NP(1) = TVWIND(3) - TVWIND(1) + 1
         IF (TVWIND(3).GT.MAXXTV(1)) THEN
            NW = 2
            NP(1) = MAXXTV(1) - IX0(1) + 1
            IX0(2) = 1
            IX1(2) = 1 + NP(1)
            NP(2) = TVWIND(3) - MAXXTV(1)
            END IF
C                                       Set graphics plane colours:
         DO 10 I = 1,NGRAPH
            CALL YGRAFX ('READ', I, RED, GREEN, BLUE, JRET)
            IF (JRET.NE.0) THEN
               IRET = 1
               WRITE (MSGTXT,1000) JRET
               GO TO 990
               END IF
            BCOLOR(1,I) = SCALE * RED
            BCOLOR(2,I) = SCALE * GREEN
            BCOLOR(3,I) = SCALE * BLUE
 10         CONTINUE
C                                       Do ex-or colors
         LGR = 2**NGRAPH
         MGR = 3 * LGR
         CALL FILL (MGR, 0, GCOLOR)
         MGR = NGRAPH
         IF (NGRAPH.EQ.8) MGR = 4
         DO 13 I = 1,LGR
            J = I - 1
            CALL ZGTBIT (NGRAPH, J, BITS)
            LCOLOR(1) = 0
            LCOLOR(2) = 0
            LCOLOR(3) = 0
C                                       limit to planes 1-4 for XAS
            DO 12 J = 1,MGR
               IF (BITS(J).EQ.1) THEN
                  LCOLOR(1) = ZEOR (LCOLOR(1), BCOLOR(1,J))
                  LCOLOR(2) = ZEOR (LCOLOR(2), BCOLOR(2,J))
                  LCOLOR(3) = ZEOR (LCOLOR(3), BCOLOR(3,J))
                  END IF
 12            CONTINUE
            TEMP = (LCOLOR(1) / SCALE) ** AGAMMA(1)
            TEMP = MAX (0.0, MIN (1.0, TEMP))
            GCOLOR(1,I) = SCALE * TEMP + 0.5
            TEMP = (LCOLOR(2) / SCALE) ** AGAMMA(2)
            TEMP = MAX (0.0, MIN (1.0, TEMP))
            GCOLOR(2,I) = SCALE * TEMP + 0.5
            TEMP = (LCOLOR(3) / SCALE) ** AGAMMA(3)
            TEMP = MAX (0.0, MIN (1.0, TEMP))
            GCOLOR(3,I) = SCALE * TEMP + 0.5
 13         CONTINUE
C                                       other colors planes 5-8
         IF (MGR.NE.NGRAPH) THEN
            DO 15 I = 17,LGR,16
               J = I - 1
               CALL ZGTBIT (NGRAPH, J, BITS)
               DO 14 J = 5,8
                  IF (BITS(13-J).EQ.1) THEN
                     LCOLOR(1) = BCOLOR(1,13-J)
                     LCOLOR(2) = BCOLOR(2,13-J)
                     LCOLOR(3) = BCOLOR(3,13-J)
                     END IF
 14               CONTINUE
               TEMP = (LCOLOR(1) / SCALE) ** AGAMMA(1)
               TEMP = MAX (0.0, MIN (1.0, TEMP))
               GCOLOR(1,I) = SCALE * TEMP + 0.5
               TEMP = (LCOLOR(2) / SCALE) ** AGAMMA(2)
               TEMP = MAX (0.0, MIN (1.0, TEMP))
               GCOLOR(2,I) = SCALE * TEMP + 0.5
               TEMP = (LCOLOR(3) / SCALE) ** AGAMMA(3)
               TEMP = MAX (0.0, MIN (1.0, TEMP))
               GCOLOR(3,I) = SCALE * TEMP + 0.5
 15            CONTINUE
            END IF
C                                       force label color
         IF (LGRAPH.GT.0) THEN
            I = 2 ** (LGRAPH-1) + 1
            IF ((COLOUR.EQ.2) .AND. (.NOT.DOINV)) THEN
               CALL FILL (3, 1, GCOLOR(1,I))
            ELSE
               CALL FILL (3, 255, GCOLOR(1,I))
               END IF
            END IF
C                                       Adjust to bright white or black
C                                       if producing a greyscale image.
         IF (COLOUR.LE.0) THEN
            J = SCALE/2
            DO 18 I = 1,LGR
               IF ((GCOLOR(1,I).GT.J) .OR. (GCOLOR(2,I).GT.J) .OR.
     *            (GCOLOR(3,I).GT.J)) THEN
                  GCOLOR(1,I) = SCALE
                  GCOLOR(2,I) = SCALE
                  GCOLOR(3,I) = SCALE
                  END IF
 18            CONTINUE
            END IF
C                                       Read each row in the window:
         DO 100 IROW = TVWIND(2),TVWIND(4)
            LROW = IROW
            IF (LROW.LT.1) LROW = LROW + MAXXTV(2)
            IF (LROW.GT.MAXXTV(2)) LROW = LROW - MAXXTV(2)
C                                       Clear accumulators:
            DO 20 I = 1,WWIDTH
               ROUT(I) = 0
               GOUT(I) = 0
               BOUT(I) = 0
               GROW(I) = 0
 20            CONTINUE
C                                       Read grey-scale planes:
C                                       (Inner loop should vectorize.)
C                                       (Outer loop may be
C                                       parallelized.)
            DO 40 I = 1,NGRAY
               IF (ISON(I)) THEN
                  DO 25 IW = 1,NW
                     CALL YIMGIO ('READ', I, IX0(IW), LROW, 0, NP(IW),
     *                  ROW(IX1(IW),1), JRET)
                     IF (JRET.NE.0) THEN
                        IRET = 1
                        WRITE (MSGTXT,1020) JRET
                        GO TO 990
                        END IF
 25                  CONTINUE
                  DO 30 J = 1,WWIDTH
                     ROUT(J) = ROUT(J) + LUTDAT(ROW(J,1)+1,1,I)
                     GOUT(J) = GOUT(J) + LUTDAT(ROW(J,1)+1,2,I)
                     BOUT(J) = BOUT(J) + LUTDAT(ROW(J,1)+1,3,I)
 30                  CONTINUE
                  END IF
 40            CONTINUE
C                                       Apply OFM (vectorizable):
            DO 50 I = 1,WWIDTH
               ROUT(I) = NINT (SCALE * OFMDAT(ROUT(I)+1, 1))
               GOUT(I) = NINT (SCALE * OFMDAT(GOUT(I)+1, 2))
               BOUT(I) = NINT (SCALE * OFMDAT(BOUT(I)+1, 3))
 50            CONTINUE
C                                       Add in requested graphics
C                                       overlays:
            DO 60 I = 1,NGRAPH
               IF (GPMASK(I).GT.0) THEN
                  DO 52 IW = 1,NW
                     CALL YIMGIO ('READ', I+NGRAY, IX0(IW), LROW, 0,
     *                  NP(IW), ROW(IX1(IW),1), JRET)
                     IF (JRET.NE.0) THEN
                        IRET = 1
                        WRITE (MSGTXT,1020) JRET
                        GO TO 990
                        END IF
 52                  CONTINUE
                  L = 2 ** (I-1)
                  DO 55 J = 1,WWIDTH
                     GROW(J) = GROW(J) + ROW(J,1) * L
 55                  CONTINUE
                  END IF
 60            CONTINUE
            DO 70 J = 1,WWIDTH
               IF (GROW(J).NE.0) THEN
                  ROUT(J) = GCOLOR(1,GROW(J)+1)
                  GOUT(J) = GCOLOR(2,GROW(J)+1)
                  BOUT(J) = GCOLOR(3,GROW(J)+1)
                  END IF
 70            CONTINUE
C                                       Write out the finished row:
            CALL WRLINE ('WRIT', PSLUN, COLOUR, ROUT, GOUT, BOUT,
     *         WWIDTH, DOINV, RGBC, JRET)
            IF (JRET.NE.0) THEN
               IRET = 2
               WRITE (MSGTXT,1070) JRET
               GO TO 990
               END IF
 100        CONTINUE
C                                       Image from disk
      ELSE
         WIN(1) = BLC(1) + 0.0001
         WIN(2) = BLC(2) + 0.0001
         WIN(3) = TRC(1) + 0.0001
         WIN(4) = TRC(2) + 0.0001
         NPIX = 1 + WIN(3) - WIN(1)
         WWIDTH = 1 + (WIN(3) - WIN(1)) / DX
         DO 105 IPL = 1,NGRAY
            IF (ISON(IPL)) THEN
               CALL COMOFF (CATBLK(KIDIM,IPL), CATBLK(KINAX,IPL),
     *            CATBLK(IIDEP,IPL), DELBLK, JRET)
               DELBLK = DELBLK + 1
               CALL H2CHR (2, 1, CATH(IITRA,IPL), TRANFN(IPL))
               CALL ZPHFIL ('MA', CATBLK(IIVOL,IPL), CATBLK(IICNO,IPL),
     *            1, PHNAME, JRET)
               LUN(IPL) = 28 + IPL
               CALL ZOPEN (LUN(IPL), IND(IPL), CATBLK(IIVOL,IPL),
     *            PHNAME, T, T, T, JRET)
               IF (JRET.NE.0) THEN
                  WRITE (MSGTXT,1105) JRET, 'OPEN'
                  GO TO 980
                  END IF
               CALL MINIT ('READ', LUN(IPL), IND(IPL),
     *            CATBLK(KINAX,IPL), CATBLK(KINAX+1,IPL), WIN,
     *            BUFF(1,IPL), BUFSZ, DELBLK, JRET)
               IF (JRET.NE.0) THEN
                  WRITE (MSGTXT,1105) JRET, 'INIT'
                  GO TO 980
                  END IF
               END IF
 105        CONTINUE
         DO 130 J = WIN(2),WIN(4)
            DO 110 IPL = 1,NGRAY
               IF (ISON(IPL)) THEN
                  CALL MDISK ('READ', LUN(IPL), IND(IPL), BUFF(1,IPL),
     *               ININD(IPL), JRET)
                  IF (JRET.NE.0) THEN
                     WRITE (MSGTXT,1105) JRET, 'READ'
                     GO TO 980
                     END IF
                  IF (MOD(J-WIN(2),DY).EQ.0) CALL ISCALE (TRANFN(IPL),
     *               MAXINT, CATR(IRRAN,IPL), NPIX, DX,
     *               BUFF(ININD(IPL),IPL), ROW(1,IPL))
                  END IF
 110           CONTINUE
            IF (MOD(J-WIN(2),DY).EQ.0) THEN
               DO 120 I = 1,WWIDTH
                  LR = 0
                  LG = 0
                  LB = 0
                  DO 115 IPL = 1,NGRAY
                     IF (ISON(IPL)) THEN
                        LR = LR + LUTDAT(ROW(I,IPL)+1,1,IPL)
                        LG = LG + LUTDAT(ROW(I,IPL)+1,2,IPL)
                        LB = LB + LUTDAT(ROW(I,IPL)+1,3,IPL)
                        END IF
 115                 CONTINUE
                  ROUT(I) = NINT (SCALE * OFMDAT(LR+1, 1))
                  GOUT(I) = NINT (SCALE * OFMDAT(LG+1, 2))
                  BOUT(I) = NINT (SCALE * OFMDAT(LB+1, 3))
 120              CONTINUE
C                                       Write out the finished row:
               CALL WRLINE ('WRIT', PSLUN, COLOUR, ROUT, GOUT, BOUT,
     *            WWIDTH, DOINV, RGBC, JRET)
               IF (JRET.NE.0) THEN
                  IRET = 2
                  WRITE (MSGTXT,1070) JRET
                  GO TO 990
                  END IF
               END IF
 130        CONTINUE
         END IF
C                                       Flush image data:
      CALL WRLINE ('FLSH', PSLUN, COLOUR, ROUT, GOUT, BOUT, WWIDTH,
     *   DOINV, RGBC, JRET)
      IF (JRET.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1070) JRET
         GO TO 990
         END IF
      PSBUFF = '%%EndData'
      CALL ZLASIO ('WRIT', PSLUN, ' ', ITRIM(PSBUFF), PSBUFF, IRET)
      GO TO 999
C
 980  IRET = 3
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CANNOT READ TV: YGRAFX ERROR ',I4)
 1020 FORMAT ('CANNOT READ TV: YIMGIO ERROR ',I2)
 1070 FORMAT ('CANNOT WRITE OUTPUT: WRLINE ERROR ',I2)
 1105 FORMAT ('ERROR',I5,' ',A,'ING DISK FILE')
 5000 FORMAT (I4,1X,I4,' 8 [',I4,' 0 0 ',I4,' 0 0 ]')
 5001 FORMAT ('%%BeginData: ',I10,' decimal lines')
      END
      SUBROUTINE PSFIN (IRET)
C-----------------------------------------------------------------------
C   Close the output file and TV device.
C
C   Output:
C      IRET        I         Return status
C                              0 -> success
C                              1 -> could not close TV
C                              2 -> could not close output file
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   JRET, SCRTCH(256), I
      CHARACTER PSBUFF*80
C
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'TVCPS.INC'
C
      INTEGER   ITRIM
      EXTERNAL  ITRIM
C-----------------------------------------------------------------------
C                                       Close TV:
      CALL TVCLOS (SCRTCH, JRET)
      IF (JRET.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1000) JRET
         CALL MSGWRT (8)
         END IF
C                                       Finish off the PostScript file
      PSBUFF = 'pgsave restore'
      CALL ZLASIO('WRIT', PSLUN, OUTPRT, ITRIM(PSBUFF), PSBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (COPIES.GT.1) THEN
         PSBUFF = 'copypage'
         DO 20 I = 2,COPIES
            CALL ZLASIO('WRIT', PSLUN, OUTPRT, ITRIM(PSBUFF), PSBUFF,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
 20         CONTINUE
         END IF
      PSBUFF = 'showpage'
      CALL ZLASIO('WRIT', PSLUN, OUTPRT, ITRIM(PSBUFF), PSBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      PSBUFF = 'userdict /eop-hook known {eop-hook} if'
      CALL ZLASIO('WRIT', PSLUN, OUTPRT, ITRIM(PSBUFF), PSBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      PSBUFF = '%%Trailer'
      CALL ZLASIO('WRIT', PSLUN, OUTPRT, ITRIM(PSBUFF), PSBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      PSBUFF = 'userdict /end-hook known {end-hook} if'
      CALL ZLASIO('WRIT', PSLUN, OUTPRT, ITRIM(PSBUFF), PSBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      PSBUFF = '%%EOF'
      CALL ZLASIO('WRIT', PSLUN, OUTPRT, ITRIM(PSBUFF), PSBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL ZLASIO('CLOS', PSLUN, OUTPRT, ITRIM(PSBUFF), PSBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CAN NOT CLOSE TV: TVCLOS ERROR ', I3)
      END
      SUBROUTINE IMFIND (ISON, BLC, TRC, DX, DY, TVWIND, DODISK, IPLANE,
     *   CATBLK, IRET)
C-----------------------------------------------------------------------
C   find which image is on and get its catalog block (with the TV load
C   modifications).
C   Input/Outputs:
C      ISON     L(*)       Which planes are on
C      BLC      R(7)       BLC of image window
C      TRC      R(7)       TRC of image window
C      DX       I          Increment in X pixels
C      DY       I          Increment in Y pixels
C      TVWIND   I(4)       Returns 1,1,nx,ny to give display size IF
C                          DODISK is returned true.
C   Outputs:
C      DODISK   L          Returns False if TV image has no disk file
C      IPLANE   I          TV plane to use for image LUTs
C      CATBLK   I(256,*)   Image header
C      IRET     I          Error code: 0 okay
C                            1 - can't find an image
C                            2 - requested window bad
C-----------------------------------------------------------------------
      LOGICAL   ISON(*)
      REAL      BLC(7), TRC(7)
      INTEGER   DX, DY, TVWIND(4), IPLANE, CATBLK(256,*), IRET
      LOGICAL   DODISK
C
      INTEGER   IX, IY, INBUF(256), JRET, TSTCAT(256), MSGSAV, I, IPL,
     *   IERR
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       find the image header(s)
      DODISK = .FALSE.
      IPLANE = 1000
      DO 20 IPL = 1,NGRAY
         IF (ISON(IPL)) THEN
            IX = (TVWIND(1) + TVWIND(3)) / 2
            IY = (TVWIND(2) + TVWIND(4)) / 2
            CALL YCREAD (IPL, IX, IY, CATBLK(1,IPL), IERR)
            IF (IERR.NE.0) ISON(IPL) = .FALSE.
            END IF
         IF (ISON(IPL)) THEN
C                                       test the image catalog
            IF ((CATBLK(IIVOL,IPL).GT.0) .AND.
     *         (CATBLK(IIVOL,IPL).LE.NVOL)) THEN
               MSGSAV = MSGSUP
               MSGSUP = 32000
               CALL CATIO ('READ', CATBLK(IIVOL,IPL), CATBLK(IICNO,IPL),
     *            TSTCAT, 'REST', INBUF, JRET)
               MSGSUP = MSGSAV
C                                       test header
               IX = 112
               IF ((JRET.EQ.0) .OR. (JRET.GT.5)) THEN
                  DO 10 I = 1,112
                     IF (TSTCAT(I).EQ.CATBLK(I,IPL)) IX = IX - 1
 10                  CONTINUE
                  IF (IX.GT.0) THEN
                     MSGTXT = 'Disk header does not match image catalog'
     *                  // ' header - USING TV IMAGE'
                     CALL MSGWRT (6)
                     ISON(IPL) = .FALSE.
                     END IF
               ELSE
                  MSGTXT = 'Unable to read specified disk header' //
     *               ' - USING TV IMAGE'
                  CALL MSGWRT (6)
                  ISON(IPL) = .FALSE.
                  END IF
C                                       wasn't on disk, use TV
            ELSE
               MSGTXT = 'REQUESTED IMAGE DOES NOT COME FROM DISK' //
     *            ' - USING TV IMAGE'
               CALL MSGWRT (6)
               ISON(IPL) = .FALSE.
               END IF
            END IF
         IF (ISON(IPL)) THEN
            DODISK = .TRUE.
            IPLANE = MIN (IPLANE, IPL)
            END IF
 20      CONTINUE
C                                       set windows for disk file
      IF (DODISK) THEN
         CALL WINDOW (CATBLK(KIDIM,IPLANE), CATBLK(KINAX,IPLANE), BLC,
     *      TRC, JRET)
         IF (JRET.NE.0) THEN
            IRET = 2
            GO TO 999
            END IF
         CALL RCOPY (5, BLC(3), TRC(3))
         DX = MAX (1, DX)
         DY = MAX (1, DY)
         TVWIND(1) = 1
         TVWIND(2) = 1
         TVWIND(3) = (TRC(1) - BLC(1)) / DX + 1.001
         TVWIND(4) = (TRC(2) - BLC(2)) / DY + 1.001
C                                       compare multiple images
         DO 50 IPL = 1,NGRAY
            IF ((ISON(IPL)) .AND. (IPL.NE.IPLANE)) THEN
               IF ((CATBLK(KINAX,IPL).NE.CATBLK(KINAX,IPLANE)) .OR.
     *            (CATBLK(KINAX+1,IPL).NE.CATBLK(KINAX+1,IPLANE))) THEN
                  MSGTXT = 'IMAGES ARE NOT OF SAME SIZE'
                  CALL MSGWRT (8)
                  DODISK = .FALSE.
                  END IF
               END IF
 50         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE CALCBB (ASPPT, CATR, DX, DY, TVWIND, WIDTH, HEIGHT,
     *   MARGIN, DOLAB, DOROT, BBOX, ROTATE, IRET)
C-----------------------------------------------------------------------
C   Calculate the largest centered bounding box that will hold a scaled
C   image of the current TV window with a mimimum margin of MARGIN on
C   each side while preserving the TV aspect ratio.
C
C   Inputs:
C      ASPPT    R        Requested scale in arcsec per pt; if negative
C                        scale to fit page.
C      CATBLK   R(256)   Header for image
C      DX       I        X-axis pixel increment
C      DY       I        Y-axis pixel increment
C      TVWIND   I(4)     Current TV window (from YWINDO)
C      WIDTH    R        Width of output media (points)
C      HEIGHT   R        Height of output media (points)
C      MARGIN   R        Minimum margin (points)
C      DOLAB    L        Should space be reserved for a label.
C
C   Outputs:
C      BBOX     I(2, 2)  BLC and TRC of bounding box (points)
C      IRET     I        Return status: 0 => box OK
C                                       1 => box won't fit page
C-----------------------------------------------------------------------
      INTEGER   DX, DY, TVWIND(4), BBOX(2, 2), IRET
      REAL      ASPPT, CATR(256), WIDTH, HEIGHT, MARGIN, XSZ, YSZ
      LOGICAL   DOLAB, ROTATE, DOROT
C                                        ASPECT = TV aspect ratio
      REAL      ASPECT
C                                        MAXWID = maximum image width
C                                        MAXHT  = maximum image height
      REAL      MAXWID, MAXHT, PCH
C                                        SCALE  = scaling factor
      REAL      SCALE
C                                       XINC = X-axis arcsec/pixel
C                                       YINC = Y-axis arcsec/pixel
      REAL      XINC, YINC
C
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      MAXWID = WIDTH - 2.0 * MARGIN
      MAXHT  = HEIGHT - 2.0 * MARGIN
C                                        Reserve space for a label, if
C                                        required:
      PCH = 0
      IF (DOLAB) PCH = 25
C
      IF (ASPPT.GT.0.0) THEN
C                                       Explicit scaling.
C
C                                       Assume first two axes of image
C                                       are the x and y axes:
         XINC = ABS (CATR(KRCIC)) * 3600.0
         YINC = ABS (CATR(KRCIC + 1)) * 3600.0
C                                       Compensate for sampling:
         IF (DX.GT.0) THEN
            XINC = XINC * DX
         ELSE
            XINC = -XINC / DX
            END IF
         IF (DY.GT.0) THEN
            YINC = YINC * DX
         ELSE
            YINC = -YINC / DX
            END IF
C                                       Check that image will fit page:
         XSZ = XINC * (TVWIND(3) - TVWIND(1)) / ASPPT
         YSZ = YINC * (TVWIND(4) - TVWIND(2)) / ASPPT
         IF ((XSZ.GT.MAXWID) .OR. (YSZ.GT.MAXHT-PCH)) THEN
            IF ((XSZ.GT.MAXHT) .OR. (YSZ.GT.MAXWID-PCH) .OR.
     *         (.NOT.DOROT)) THEN
               MSGTXT = 'IMAGE WILL NOT FIT ON PAGE - REDUCE ASPMM'
               IRET = 1
               CALL MSGWRT (10)
               GO TO 999
C                                       Only rotated fits
            ELSE
               ROTATE = .TRUE.
C                                       Calculate BLC of bounding box:
               BBOX(1,1) = INT ((WIDTH - YSZ) / 2.0)
               BBOX(2,1) = INT ((HEIGHT - XSZ) / 2.0)
               END IF
C                                       Normal positioning
         ELSE
            ROTATE = .FALSE.
C                                       Calculate BLC of bounding box:
            BBOX(1,1) = INT ((WIDTH - XSZ) / 2.0)
            BBOX(2,1) = INT ((HEIGHT - YSZ) / 2.0)
            END IF
      ELSE
C                                       Scale to fit page:
         XSZ = TVWIND(3) - TVWIND(1) + 1
         YSZ = TVWIND(4) - TVWIND(2) + 1
C                                        Calculate scaling factor:
         SCALE = MAXWID / XSZ
         IF (YSZ*SCALE.GT.MAXHT-PCH) SCALE = (MAXHT-PCH) / YSZ
         ASPECT = (MAXWID-PCH) / YSZ
         IF (XSZ*ASPECT.GT.MAXHT) ASPECT = MAXHT / XSZ
C                                        Calculate BLC of bounding box:
         IF ((ASPECT.GT.SCALE) .AND. (DOROT)) THEN
            ROTATE = .TRUE.
            BBOX(1,1) = INT ((WIDTH - ASPECT*YSZ) / 2.0)
            BBOX(2,1) = INT ((HEIGHT - ASPECT*XSZ) / 2.0)
         ELSE
            ROTATE = .FALSE.
            BBOX(1,1) = INT ((WIDTH - SCALE*XSZ) / 2.0)
            BBOX(2,1) = INT ((HEIGHT - SCALE*YSZ) / 2.0)
            END IF
         END IF
C                                        Calculate TRC of bounding box:
      BBOX(1,2) = INT (WIDTH - BBOX(1,1))
      BBOX(2,2) = INT (HEIGHT - BBOX(2,1))
C                                        Adjust vertical positioning
C                                        for label.
      IF (DOLAB) THEN
         IF (ROTATE) THEN
            BBOX(1,1) = BBOX(1,1) - 12.5
            BBOX(1,2) = BBOX(1,2) - 12.5
         ELSE
            BBOX(2,1) = BBOX(2,1) + 12.5
            BBOX(2,2) = BBOX(2,2) + 12.5
            END IF
         END IF
C
  999 RETURN
      END
      SUBROUTINE PSPLOG (LUN, OUTFIL, ENCAP, BBOX, COLOUR, DOLAB,
     *   ROTATE, IRET)
C-----------------------------------------------------------------------
C   Open a print file with name OUTFIL on logical unit number LUN and
C   write a PostScript prologue to it. The prologue conforms to version
C   3.0 of the PostScript document structuring conventions.
C
C   Inputs:
C      LUN       I           Logical unit number
C      OUTFIL    C*48        File name
C      ENCAP     L           True if and only if writing encapsulated
C                             PostScript
C      BBOX      I(2,2)      BLC and TRC or bounding box in points
C      COLOUR    I           True if and only if the document will use
C                             CMYK extensions (eg. colorimage)
C      DOLAB     L           True if and only if a label is to be
C                             added to the plot.
C
C   Outputs:
C      IRET      I           Status code: 0 => OK
C-----------------------------------------------------------------------
      INTEGER   LUN, BBOX(2,2), COLOUR, IRET
      CHARACTER OUTFIL*48
      LOGICAL   ENCAP, DOLAB, ROTATE
C                                        CBUFF = line buffer
      CHARACTER CBUFF*80
C                                        DATE = current date (year,
C                                               month and day)
C                                        TIME = current time (hours,
C                                               minutes and seconds)
      INTEGER   DATE(3), TIME(3)
C                                        NEWBOX = bounding box after
C                                                 allowing for a
C                                                 label.
      INTEGER   NEWBOX(2, 2)
C
      INTEGER   I, J
C
      INTEGER   ITRIM
      EXTERNAL  ITRIM
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                        Open the output file:
      CALL ZLASIO ('OPEN', LUN, OUTFIL, 0, CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                        Write %!PS-Adobe comment:
      CBUFF = '%!PS-Adobe-3.0'
      IF (ENCAP) CBUFF = '%!PS-Adobe-3.0 EPSF-3.0'
      CALL ZLASIO ('WRIT', LUN, OUTFIL, ITRIM(CBUFF), CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                        If a label will be added
C                                        note that the Helvetica
C                                        font will be needed:
      IF (DOLAB) THEN
         CBUFF = '%%DocumentNeededResources: font Helvetica'
         CALL ZLASIO ('WRIT', LUN, OUTFIL, ITRIM(CBUFF), CBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                        Write bounding box comment:
      DO 20 I = 1,2
         DO 10 J = 1,2
            NEWBOX(I,J) = BBOX(I,J) + 5 * (2*J-3)
   10       CONTINUE
   20    CONTINUE
      IF (DOLAB) THEN
         IF (ROTATE) THEN
            NEWBOX(1,2) = NEWBOX(1,2) + 25
         ELSE
            NEWBOX(2,1) = NEWBOX(2,1) - 25
            END IF
         END IF
      WRITE (CBUFF, 1000) NEWBOX
      CALL ZLASIO ('WRIT', LUN, OUTFIL, ITRIM(CBUFF), CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                        Write creator comment:
      CBUFF = '%%Creator: AIPS task TVCPS'
      CALL ZLASIO ('WRIT', LUN, OUTFIL, ITRIM(CBUFF), CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                        Write creation date comment:
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      WRITE (CBUFF, 1001) DATE, TIME
      CALL ZLASIO ('WRIT', LUN, OUTFIL, ITRIM(CBUFF), CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                        Write document data comment:
      CBUFF = '%%DocumentData: Clean7Bit'
      CALL ZLASIO ('WRIT', LUN, OUTFIL, ITRIM(CBUFF), CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                        Write extensions comment (if
C:                                       required):
      IF (COLOUR.GT.0) THEN
         CBUFF = '%%Extensions: CMYK'
         CALL ZLASIO ('WRIT', LUN, OUTFIL, ITRIM(CBUFF), CBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         CBUFF = '%%Requirements: color'
         CALL ZLASIO ('WRIT', LUN, OUTFIL, ITRIM(CBUFF), CBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                        Write for comment:
      WRITE (CBUFF, 1002) NLUSER
      CALL ZLASIO ('WRIT', LUN, OUTFIL, ITRIM(CBUFF), CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                        Write pages comment:
      CBUFF = '%%Pages: 1'
      CALL ZLASIO ('WRIT', LUN, OUTFIL, ITRIM(CBUFF), CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                        If a label is required then
C                                        the label font must be
C                                        included in the document
C                                        setup.
      IF (DOLAB) THEN
         CBUFF = '%%BeginSetup'
         CALL ZLASIO ('WRIT', LUN, OUTFIL, ITRIM(CBUFF), CBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         CBUFF = '%%IncludeResource: font Helvetica'
         CALL ZLASIO ('WRIT', LUN, OUTFIL, ITRIM(CBUFF), CBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         CBUFF = '%%EndSetup'
         CALL ZLASIO ('WRIT', LUN, OUTFIL, ITRIM(CBUFF), CBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                        Finish header section:
      CBUFF = '%%EndComments'
      CALL ZLASIO ('WRIT', LUN, OUTFIL, ITRIM(CBUFF), CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                        Write a null prologue:
      CBUFF = '%%EndProlog'
      CALL ZLASIO ('WRIT', LUN, OUTFIL, ITRIM(CBUFF), CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C
      IRET = 0
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('%%BoundingBox: ', 4I5)
 1001 FORMAT ('%%CreationDate: ', I4.4, '-', I2.2, '-', I2.2, 'T',
     *   I2.2, ':', I2.2, ':', I2.2)
 1002 FORMAT ('%%For: AIPS user number ', I4)
      END
      SUBROUTINE PSPSET (LUN, COLOUR, TVWIND, BBOX, DOLAB, REASON,
     *   ROTATE, IRET)
C-----------------------------------------------------------------------
C   Begin new page and write out everything except for the sctual
C   image.
C   Inputs:
C      LUN      I        LUN of open printer file
C      COLOUR   I        true if producing RGB output
C      TVWIND   I(4)     TV window (from YWINDO)
C      BBOX     I(2,2)   Bounding box for image
C      DOLAB    L        True if a label should be added.
C      REASON   C*40     Character label to put on plot
C   Output
C      IERR     I        Status: 0 => OK
C                                non-zero => ZLASIO error
C-----------------------------------------------------------------------
      INTEGER   LUN, TVWIND(4), BBOX(2,2), IRET, COLOUR
      LOGICAL   DOLAB, ROTATE
      CHARACTER REASON*(*)
C
C                                        CBUFF = character buffer
      CHARACTER CBUFF*80
C                                        FSIZE = font size for label
C                                                in points
      INTEGER   FSIZE, ITRIM, I
C                                        LWIDTH = width of the label
C                                                 in points for 20pt
C                                                 Helvetica
      REAL      LWIDTH, XWIDTH
      PARAMETER (LWIDTH = 155.0)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                        Start page:
      CBUFF = '%%Page 1 1'
      CALL ZLASIO ('WRIT', LUN, ' ', ITRIM(CBUFF), CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      CBUFF = 'userdict /start-hook known {start-hook} if'
      CALL ZLASIO ('WRIT', LUN, ' ', ITRIM(CBUFF), CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      CBUFF = 'userdict /bop-hook known {bop-hook} if'
      CALL ZLASIO ('WRIT', LUN, ' ', ITRIM(CBUFF), CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                        Save state:
      CBUFF = '/pgsave save def                       % save state'
      CALL ZLASIO ('WRIT', LUN, ' ', ITRIM(CBUFF), CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Rotation
      IF (ROTATE) THEN
         CBUFF = ' 90 rotate '
         CALL ZLASIO ('WRIT', LUN, ' ', ITRIM(CBUFF), CBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         WRITE (CBUFF,1004) 0, -BBOX(1,2)-BBOX(1,1)
         CALL ZLASIO ('WRIT', LUN, ' ', ITRIM(CBUFF), CBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       If outputting a label,
C                                       calculate the font size, and
C                                       draw the label in black
      IF (DOLAB) THEN
         I = ITRIM (REASON)
         XWIDTH = (I * LWIDTH) / 14
         FSIZE = INT (20.0 * (BBOX(1,2) - BBOX(1,1)) / XWIDTH)
         FSIZE = MAX (1, MIN (20, FSIZE))
         WRITE (CBUFF,1000) FSIZE
         CALL ZLASIO ('WRIT', LUN, ' ', ITRIM(CBUFF), CBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         IF (ROTATE) THEN
            WRITE (CBUFF,1001) BBOX(2,1) + 2, BBOX(1,1) - 23
         ELSE
            WRITE (CBUFF,1001) BBOX(1,1) + 2, BBOX(2,1) - 23
            END IF
         CALL ZLASIO ('WRIT', LUN, ' ', ITRIM(CBUFF), CBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         WRITE (CBUFF,1002) REASON(1:I)
         CALL ZLASIO ('WRIT', LUN, ' ', ITRIM(CBUFF), CBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                        Define a string capable of
C                                        holding one line of the image
      IF (COLOUR.GT.2) THEN
         I = 4
      ELSE IF (COLOUR.GT.0) THEN
         I = 3
      ELSE
         I = 1
         END IF
      WRITE (CBUFF,1003) I * (TVWIND(3) - TVWIND(1) + 1)
      CALL ZLASIO ('WRIT', LUN, ' ', ITRIM(CBUFF), CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                        Set up a transformation matrix
C                                        that maps the unit square to
C                                        the bounding box
      IF (ROTATE) THEN
         WRITE (CBUFF,1004) BBOX(2,1), BBOX(1,1)
      ELSE
         WRITE (CBUFF,1004) BBOX(1,1), BBOX(2,1)
         END IF
      CALL ZLASIO ('WRIT', LUN, ' ', ITRIM(CBUFF), CBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (ROTATE) THEN
         WRITE (CBUFF,1005) BBOX(2,2)-BBOX(2,1), BBOX(1,2)-BBOX(1,1)
      ELSE
         WRITE (CBUFF,1005) BBOX(1,2)-BBOX(1,1), BBOX(2,2)-BBOX(2,1)
         END IF
      CALL ZLASIO ('WRIT', LUN, ' ', ITRIM(CBUFF), CBUFF, IRET)
C
  999 RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('/Helvetica findfont ', I2, ' scalefont setfont')
 1001 FORMAT (I4, ' ', I4, ' moveto')
 1002 FORMAT ('(',A,') show')
 1003 FORMAT ('/picst ', I6, ' string def')
 1004 FORMAT (I8, I8, ' translate')
 1005 FORMAT (I8, I8, ' scale')
      END
      SUBROUTINE WRLINE (OPCODE, LUN, COLOUR, RED, GREEN, BLUE, WIDTH,
     *   DOINV, RGBC, IRET)
C-----------------------------------------------------------------------
C   Write a line of image data to a PostScript file.  The data are
C   encoded in hexadecimal with 72 characters per output line.  If
C   COLOUR is false then only the red component is written.
C
C   Note that one pixel requires 2 output bytes for greyscale and 6
C   output bytes for colour so line breaks always occur on pixel
C   boundaries.
C   Inputs:
C      OPCODE    C*4           'WRIT' - write a line of data
C                              'FLSH' - flush buffer
C      LUN       I             LUN of open PostScript file
C      COLOUR    I             True if writing an RGB image
C      RED       I(*)          Red values (0-255)
C      GREEN     I(*)          Green values (0-255)
C      BLUE      I(*)          Blue values (0-255)
C      WIDTH     I             Number of pixels in row
C      DOINV     L             Invert all numbers
C   Output:
C      IRET      I             Status: 0 => OK
C                                      anything else =>  error
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   COLOUR, LUN, RED(*), BLUE(*), GREEN(*), WIDTH, IRET
      LOGICAL   DOINV
      REAL      RGBC(3)
C                                        BUFF = output buffer
C                                        MARK = next space in buffer
      CHARACTER BUFF*72
      INTEGER   MARK, PMARK
      SAVE      BUFF, MARK
C
      INTEGER   PIX, LC
      REAL      TEMP, GAMMA
C
      INCLUDE 'INCS:DMSG.INC'
C
      DATA      MARK /1/
      DATA      GAMMA /12.0/
C-----------------------------------------------------------------------
C                                        Flush buffer
      IF (OPCODE.EQ.'FLSH') THEN
         CALL ZLASIO ('WRIT', LUN, ' ', MARK-1, BUFF, IRET)
         MARK = 1
         IF (IRET.NE.0) GO TO 999
      ELSE IF (OPCODE.EQ.'WRIT') THEN
         IF (COLOUR.GT.0) THEN
            IF (((DOINV) .AND. (COLOUR.LT.3)) .OR. ((.NOT.DOINV) .AND.
     *         (COLOUR.GT.2))) THEN
               DO 10 PIX = 1,WIDTH
                  RED(PIX) = 255 - RED(PIX)
                  GREEN(PIX) = 255 - GREEN(PIX)
                  BLUE(PIX) = 255 - BLUE(PIX)
 10               CONTINUE
               END IF
            DO 15 PIX = 1,WIDTH
               IF (RED(PIX)+GREEN(PIX)+BLUE(PIX).EQ.0) THEN
                  RED(PIX) = RGBC(1) * 255.0 + 0.5
                  GREEN(PIX) = RGBC(2) * 255.0 + 0.5
                  BLUE(PIX) = RGBC(3) * 255.0 + 0.5
                  END IF
 15            CONTINUE
            DO 20 PIX = 1,WIDTH
C                                        Flush buffer
               IF (MARK.EQ.73) THEN
                  CALL ZLASIO ('WRIT', LUN, ' ', 72, BUFF, IRET)
                  MARK = 1
                  IF (IRET.NE.0) GO TO 999
                  END IF
               PMARK = MARK
               IF (COLOUR.GT.2) THEN
                  LC = MIN (RED(PIX), GREEN(PIX))
                  LC = MIN (LC, BLUE(PIX))
                  TEMP = MAX (0.0, MIN (1.0, LC/255.0))
                  LC = 255 * (TEMP ** GAMMA)
C                  RED(PIX) = MAX (0, RED(PIX)-LC)
C                  GREEN(PIX) = MAX (0, GREEN(PIX)-LC)
C                  BLUE(PIX) = MAX (0, BLUE(PIX)-LC)
                  END IF
               CALL ZHEX (RED(PIX), 2, BUFF(MARK:MARK+1))
               MARK = MARK + 2
               CALL ZHEX (GREEN(PIX), 2, BUFF(MARK:MARK+1))
               MARK = MARK + 2
               CALL ZHEX (BLUE(PIX), 2, BUFF(MARK:MARK+1))
               MARK = MARK + 2
               IF ((COLOUR.EQ.2) .AND.
     *            (BUFF(PMARK:PMARK+5).EQ.'000000'))
     *            BUFF(PMARK:PMARK+5) = 'FFFFFF'
               IF ((COLOUR.EQ.4) .AND.
     *            (BUFF(PMARK:PMARK+5).EQ.'FFFFFF'))
     *            BUFF(PMARK:PMARK+5) = '000000'
               IF (COLOUR.GT.2) THEN
                  CALL ZHEX (LC, 2, BUFF(MARK:MARK+1))
                  MARK = MARK + 2
                  IF (BUFF(PMARK:PMARK+5).EQ.'FFFFFF')
     *               BUFF(PMARK+6:PMARK+7) = 'FF'
                  IF (BUFF(PMARK:PMARK+5).EQ.'FEFEFE')
     *               BUFF(PMARK+6:PMARK+7) = 'FE'
                  END IF
 20            CONTINUE
         ELSE
            IF (DOINV) THEN
               DO 30 PIX = 1,WIDTH
                  RED(PIX) = 255 - RED(PIX)
 30               CONTINUE
               END IF
            DO 40 PIX = 1,WIDTH
C                                        Flush buffer
               IF (MARK.EQ.73) THEN
                  CALL ZLASIO ('WRIT', LUN, ' ', 72, BUFF, IRET)
                  MARK = 1
                  IF (IRET.NE.0) GO TO 999
                  END IF
               CALL ZHEX (RED(PIX), 2, BUFF(MARK:MARK+1))
               MARK = MARK + 2
 40            CONTINUE
            END IF
      ELSE
         IRET = 1
         MSGTXT = 'WRLINE: UNRECOGNIZED OPCODE ''' // OPCODE // ''''
         CALL MSGWRT (8)
         GO TO 999
         END IF
C
      IRET = 0
C
  999 RETURN
      END

      SUBROUTINE YTVOP2 (LUN, IND, IERR)
C-----------------------------------------------------------------------
C! open actual TV device (called by YTVOPN)
C# TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YTVOP2 performs a system "OPEN" on the TV device.  It is a Y
C   routine in order to call the appropriate Z routine only.
C   Inputs:
C      LUN    I   Logical unit number to use
C   Output:
C      IND    I   Pointer to FTAB entry for open device
C      IERR   I   Error code: 0 => ok
C                    1 = LUN already in use
C                    2 = file not found
C                    3 = volume not found
C                    4 = excl requested but not available
C                    5 = no room for lun
C                    6 = other open errors
C   IIS M70 version.
C-----------------------------------------------------------------------
      INTEGER   LUN, IND, IERR
C-----------------------------------------------------------------------
      CALL ZM70OP (LUN, IND, IERR)
C
 999  RETURN
      END

LOCAL INCLUDE 'INPUT.INC'
      INCLUDE 'INCS:PCLN.INC'
C                                       Declarations for inputs
      INTEGER   NPARMS
C                                       NPARMS=no. adverbs passed.
      PARAMETER (NPARMS=22)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
      INCLUDE 'INCS:PAOOF.INC'
C                                       Adverb names
C                     1         2          3        4         5      6
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'BLC', 'TRC',
C           7          8           9         10         11
     *   'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK', 'INVERS',
C           12         13          14        15         16        17
     *   'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK', 'OPTYPE', 'BCOMP',
C           18      19      20      21     22
     *   'ECOMP','BMAJ', 'BMIN', 'BPA', 'FACTOR'/
C                                       Adverb data types (PAOOF.INC)
C                     1       2       3       4       5       6
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOAINT, OOAINT,
C           7       8       9       10      11      12      13      14
     *   OOACAR, OOACAR, OOAINT, OOAINT, OOAINT, OOACAR, OOACAR, OOAINT,
C           15      16      17      18      19     20     21     22
     *   OOAINT, OOACAR, OOAINT, OOAINT, OOARE, OOARE, OOARE, OOARE /
C                                       Adverb dimensions (as 2D)
C                   1    2    3    4    5    6    7    8    9     10
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 7,1, 7,1, 12,1, 6,1, 1,1, 1,1,
C         11    12   13   14   15   16   17   18   19   20   21   22
     *   1,1, 12,1, 6,1, 1,1, 1,1, 4,1, 1,1, 1,1, 1,1, 1,1, 1,1, 1,1 /
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(4)
      LOGICAL   LDUM(4)
      REAL      RDUM(4)
      DOUBLE PRECISION DDUM(2)
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
      COMMON /CCRESG/ DDUM
LOCAL END
      PROGRAM CCRES
C-----------------------------------------------------------------------
C! Remove and/or restore Clean components
C# Utility OOP Imaging
C-----------------------------------------------------------------------
C;  Copyright (C) 2005, 2007-2010, 2012-2013, 2015, 2017, 2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, IMGIN*32, IMG2IN*32, IMGOUT*32, INTAB*32,
     *   OPTYPE*4
      INTEGER   IRET, BUFF1(256), NCCS, NWORDS, NC
      LONGINT   IOFF
      REAL      CCDATA(2)
      DATA PRGM /'CCRES '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL CRESIN (PRGM, IMGIN, IMG2IN, IMGOUT, INTAB, OPTYPE, NCCS,
     *   IRET)
C                                       Process table
      IF (IRET.EQ.0) THEN
         NC = 3
         IF (OPTYPE(2:4).EQ.'GAU') NC = 6
         NWORDS = (NCCS * NC - 1) / 1024 + 1
         CALL ZMEMRY ('GET', 'CCRES', NWORDS, CCDATA, IOFF, IRET)
         END IF
      IF (IRET.EQ.0) CALL CRESDO (IMGIN, IMGOUT, INTAB, NCCS, NC,
     *   CCDATA(1+IOFF), IRET)
C                                       History
      IF (IRET.EQ.0) CALL CRESHI (IMGIN, INTAB, IMGOUT, NCCS)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE CRESIN (PRGN, IMGIN, IMG2IN, IMGOUT, INTAB, OPTYPE,
     *   NCCS, IRET)
C-----------------------------------------------------------------------
C   CRESIN gets input parameters for CCRES and creates the input and
C   output objects
C   Inputs:
C      PRGN     C*6   Program name
C   Output:
C      IMGIN    C     Name of input image
C      IMG2IN   C     Name of image with CC file
C      IMGOUT   C     Name of output image
C      INTAB    C     Name of the input table object
C      OUTTAB   C     Names of the output table objects
C      OPTYPE   C*4   Operation type
C      NCCS     I     Number rows in CC to actually be used
C      IRET     I     Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS file
C-----------------------------------------------------------------------
      CHARACTER PRGN*6, IMGIN*(*), IMG2IN*(*), IMGOUT*(*), INTAB*(*),
     *   OPTYPE*4
      INTEGER   NCCS, IRET
C
      INCLUDE 'INPUT.INC'
      INTEGER   NKEY1, NKEY2, NKEY3
      PARAMETER (NKEY1=10)
      PARAMETER (NKEY2=4)
      PARAMETER (NKEY3=7)
C
      INTEGER   DIM(3), TYPE, BC, EC, P1, P2, BLC(7), TRC(7), NROWS,
     *   INS, IND
      REAL      B1(3), B2(3), B(3), RFACT, FACTOR
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32, INK3(NKEY3)*8, OUTK3(NKEY3)*32,
     *   CDUMMY*1, INN*12, INC*6
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to IMGIN
C                   1         2          3        4         5      6
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'BLC', 'TRC',
C           7          8           9         10
     *   'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK'/
C                                       May rename adverbs to IMGIN
C                    1       2        3        4       5      6
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'BLC', 'TRC',
C           7          8           9         10
     *   'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK'/
C                                       Adverbs to copy to IMG2IN
C                   1          2           3         4
      DATA INK2 /'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK'/
C                                       May rename adverbs to IMG2IN
C                    1       2        3        4
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK'/
C                                       Adverbs to copy to INTAB
C                   1          2           3         4
      DATA INK3 /'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK',
C            5         6        7
     *    'INVERS', 'BCOMP', 'ECOMP'/
C                                       May rename adverbs to INTAB
C                    1       2        3        4       5      6
      DATA OUTK3 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'VER', 'BCOMP',
C           7
     *   'ECOMP'/
C-----------------------------------------------------------------------
C                                       Startup,  returns "Input" object
C                                       containing POPS adverbs
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create input image object
      IMGIN = 'Input image'
      CALL CREATE (IMGIN, 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, IMGIN, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       get beam from header
      CALL IMGOPN (IMGIN, 'READ', IRET)
      IF (IRET.NE.0) GO TO 995
      CALL IMGET (IMGIN, 'BEAM.PRODUCT', TYPE, DIM, IDUM, CDUMMY, IRET)
      P1 = IDUM(1)
      IF (IRET.NE.0) GO TO 995
      CALL IMGET (IMGIN, 'BEAM.BMAJ', TYPE, DIM, IDUM, CDUMMY, IRET)
      B1(1) = RDUM(1)
      IF (IRET.NE.0) GO TO 995
      CALL IMGET (IMGIN, 'BEAM.BMIN', TYPE, DIM, IDUM, CDUMMY, IRET)
       B1(2) = RDUM(1)
      IF (IRET.NE.0) GO TO 995
      CALL IMGET (IMGIN, 'BEAM.BPA', TYPE, DIM, IDUM, CDUMMY, IRET)
      B1(3) = RDUM(1)
      IF (IRET.NE.0) GO TO 995
      CALL IMGET (IMGIN, 'BLC', TYPE, DIM, BLC, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 995
      CALL IMGET (IMGIN, 'TRC', TYPE, DIM, TRC, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       image header
      CALL OBHGET (IMGIN, CATBLK, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL IMGCLO (IMGIN, IRET)
      IF (IRET.NE.0) GO TO 995
      CALL COPY (5, BLC(3), TRC(3))
      CALL IMPUT (IMGIN, 'TRC', TYPE, DIM, TRC, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       default output class
      CALL OGET ('Input', 'OUTCLASS', TYPE, DIM, IDUM, INC, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (INC.EQ.' ') THEN
         INC = TSKNAM
         CALL OPUT (IMGIN, 'OUTCLASS', TYPE, DIM, IDUM, INC, IRET)
         IF (IRET.NE.0) GO TO 995
         CALL OPUT ('Input', 'OUTCLASS', TYPE, DIM, IDUM, INC, IRET)
         IF (IRET.NE.0) GO TO 995
         END IF
C                                       Defaults for 2nd image
      CALL OGET ('Input', 'IN2NAME', TYPE, DIM, IDUM, INN, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (INN.EQ.' ') THEN
         CALL OGET (IMGIN, 'NAME', TYPE, DIM, IDUM, INN, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT ('Input', 'IN2NAME', TYPE, DIM, IDUM, INN, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      CALL OGET ('Input', 'IN2CLASS', TYPE, DIM, IDUM, INC, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (INC.EQ.' ') THEN
         CALL OGET (IMGIN, 'CLASS', TYPE, DIM, IDUM, INC, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT ('Input', 'IN2CLASS', TYPE, DIM, IDUM, INC, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      CALL OGET ('Input', 'IN2SEQ', TYPE, DIM, IDUM, CDUMMY, IRET)
      INS = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      IF (INS.LE.0) THEN
         CALL OGET (IMGIN, 'IMSEQ', TYPE, DIM, IDUM, CDUMMY, IRET)
         INS = IDUM(1)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT ('Input', 'IN2SEQ', TYPE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      CALL OGET ('Input', 'IN2DISK', TYPE, DIM, IDUM, CDUMMY, IRET)
      IND = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      IF (IND.LE.0) THEN
         CALL OGET (IMGIN, 'DISK', TYPE, DIM, IDUM, CDUMMY, IRET)
         IND = IDUM(1)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT ('Input', 'IN2DISK', TYPE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Create input CC image object
      IMG2IN = 'Input CC image'
      CALL CREATE (IMG2IN, 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, IMG2IN, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       get beam from header
      CALL IMGOPN (IMG2IN, 'READ', IRET)
      IF (IRET.NE.0) GO TO 990
      CALL IMGET (IMG2IN, 'BEAM.PRODUCT', TYPE, DIM, IDUM, CDUMMY, IRET)
      P2 = IDUM(1)
      IF (IRET.NE.0) GO TO 990
      CALL IMGET (IMG2IN, 'BEAM.BMAJ', TYPE, DIM, IDUM, CDUMMY, IRET)
      B2(1) = RDUM(1)
      IF (IRET.NE.0) GO TO 990
      CALL IMGET (IMG2IN, 'BEAM.BMIN', TYPE, DIM, IDUM, CDUMMY, IRET)
      B2(2) = RDUM(1)
      IF (IRET.NE.0) GO TO 990
      CALL IMGET (IMG2IN, 'BEAM.BPA', TYPE, DIM, IDUM, CDUMMY, IRET)
      B2(3) = RDUM(1)
      IF (IRET.NE.0) GO TO 990
      CALL IMGCLO (IMG2IN, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Create output object
      IMGOUT = 'Output image'
      CALL IMGCLN (IMGIN, IMGOUT, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create input table object
      INTAB = 'Input table'
      CALL CREATE (INTAB, 'TABLE', IRET)
      IF (IRET.NE.0) GO TO 985
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY3, INK3, OUTK3, INTAB, IRET)
      IF (IRET.NE.0) GO TO 985
C                                       Table type
      DIM(1) = 2
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (INTAB, 'TBLTYPE', OOACAR, DIM, IDUM, 'CC', IRET)
      IF (IRET.NE.0) GO TO 985
C                                       Open input table
      CALL OOPEN (INTAB, 'READ', IRET)
      IF (IRET.NE.0) GO TO 985
C                                       Get number of entries
      CALL OGET (INTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IRET)
      NROWS = IDUM(1)
      IF (IRET.NE.0) GO TO 985
      CALL OCLOSE (INTAB, IRET)
      IF (IRET.NE.0) GO TO 985
C                                       User adverbs - range CCs
      CALL OGET ('Input', 'FACTOR', TYPE, DIM, IDUM, CDUMMY, IRET)
      FACTOR = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'BCOMP', TYPE, DIM, IDUM, CDUMMY, IRET)
      BC = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'ECOMP', TYPE, DIM, IDUM, CDUMMY, IRET)
      EC = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      IF ((BC.LT.1) .OR. (BC.GT.NROWS)) BC = 1
      IF ((EC.LT.BC) .OR. (EC.GT.NROWS)) EC = NROWS
      NCCS = EC - BC + 1
      IDUM(1) = BC
      CALL OPUT ('Input', 'BCOMP', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (INTAB, 'BCOMP', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = EC
      CALL OPUT ('Input', 'ECOMP', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (INTAB, 'ECOMP', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       User adverbs - beam, type
      CALL OGET ('Input', 'OPTYPE', TYPE, DIM, IDUM, OPTYPE, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'BMAJ', TYPE, DIM, IDUM, CDUMMY, IRET)
      B(1) = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      B(1) = B(1) / 3600.0
      CALL OGET ('Input', 'BMIN', TYPE, DIM, IDUM, CDUMMY, IRET)
      B(2) = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      B(2) = B(2) / 3600.0
      CALL OGET ('Input', 'BPA', TYPE, DIM, IDUM, CDUMMY, IRET)
      B(3) = RDUM(1)
      IF (IRET.NE.0) GO TO 999
C                                       test and set defaults
      IF ((OPTYPE.NE.'SUB') .AND. (OPTYPE.NE.'ADD') .AND.
     *   (OPTYPE.NE.'S+A') .AND. (OPTYPE.NE.'SGAU') .AND.
     *   (OPTYPE.NE.'AGAU') .AND. (OPTYPE.NE.'ADDP') .AND.
     *   (OPTYPE.NE.'S+AP')) THEN
         IF (P1.EQ.1) OPTYPE = 'SUB '
         IF (P1.EQ.3) OPTYPE = 'ADD '
         END IF
      IF ((OPTYPE.EQ.'SUB ') .OR. (OPTYPE.EQ.'ADD ')) THEN
         IF ((B(1).LE.0.0) .AND. (B(2).LE.0.0)) THEN
            B(1) = B2(1)
            B(2) = B2(2)
            B(3) = B2(3)
            END IF
         IF (B(1).LE.0.0) B(1) = B2(1)
         IF (B(2).LE.0.0) B(2) = B2(2)
      ELSE IF ((OPTYPE.EQ.'SGAU') .OR. (OPTYPE.EQ.'AGAU') .OR.
     *      (OPTYPE.EQ.'ADDP') .OR. (OPTYPE.EQ.'S+AP')) THEN
         CALL RFILL (3, 0.0, B)
      ELSE IF (OPTYPE.EQ.'S+A') THEN
         IF ((B(1).LE.0.0) .OR. (B(2).LE.0.0)) THEN
            MSGTXT = 'BEAM VALUES TO ADD MUST BE SPECIFIED WITH ''S+A'''
            CALL MSGWRT (8)
            IRET = 8
            GO TO 999
            END IF
      ELSE
         MSGTXT = 'OPTYPE=''' // OPTYPE // ' NOT RECOGNIZED'
         CALL MSGWRT (8)
         IRET = 8
         GO TO 999
         END IF
C                                       residual factor
      RFACT = 1.0
      IF (FACTOR.EQ.0.0) FACTOR = 1.0
      IF (FACTOR.GT.0.0) THEN
         IF (B1(1)*B1(2).NE.0.0) THEN
            RFACT = ABS (B(1)*B(2)) / ABS (B1(1)*B1(2))
            IF (RFACT.EQ.0.0) RFACT = ABS (CATR(KRCIC) * CATR(KRCIC+1))
     *         / (1.1331 * ABS (B1(1) * B1(2)))
            END IF
         RFACT = RFACT * FACTOR
         END IF
      TYPE = OOARE
      DIM(1) = 1
      DIM(2) = 1
      RDUM(1) = RFACT
      CALL OPUT (INTAB, 'RFACTOR', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      RDUM(1) = FACTOR
      CALL OPUT ('Input', 'FACTOR', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      RDUM(1) = B(1)
      CALL OPUT ('Input', 'BMAJ', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      RDUM(1) = B(2)
      CALL OPUT ('Input', 'BMIN', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      RDUM(1) = B(3)
      CALL OPUT ('Input', 'BPA', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      TYPE = OOACAR
      DIM(1) = 4
      CALL OPUT ('Input', 'OPTYPE', TYPE, DIM, IDUM, OPTYPE, IRET)
      GO TO 999
C                                       errors
 985  MSGTXT = 'ERROR WITH ' // INTAB
      CALL MSGWRT (8)
      GO TO 999
 990  MSGTXT = 'ERROR WITH ' // IMG2IN
      CALL MSGWRT (8)
      GO TO 999
 995  MSGTXT = 'ERROR WITH ' // IMGIN
      CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE CRESDO (IMGIN, IMGOUT, INTAB, NCCS, NC, CCD, IERR)
C-----------------------------------------------------------------------
C   Select components.
C   Inputs:
C      INTAB   C*      Name of input table object
C      OUTTAB  C*      Names of output table objects
C      NOTAB   I       Number of output table objects
C      MAXCC   I       Number of rows of CC data to read
C      NC      I       Other dimension of CCD
C   Output:
C      CCD     R(*)    Work buffer
C      ICD     I(*)    Work buffer - integer equiv to CCD
C      IERR    I       Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER IMGIN*(*), IMGOUT*(*), INTAB*(*)
      INTEGER   NCCS, NC, IERR
      REAL      CCD(NC,*)
C
      INTEGER   XPOSI, YPOSI, FLUXI, WIDI
      PARAMETER (XPOSI=1, YPOSI=2, FLUXI=3, WIDI=4)
      INCLUDE 'INCS:PMAD.INC'
C
      INTEGER   IROW, NROW, BC, EC, TYPE, DIM(7), NCC, I, NCNV, NCOL,
     *   IY, IX, BLC(7), TRC(7), IY1, IY2, IX1, IX2, NAXIS(7), NNY, NNX,
     *   CCROW, CCNCOL
      REAL      ROW(MABFSS), BMAJ, BMIN, BPA, X, Y, D, BMAJ2, BMIN2,
     *   BPA2, AA, BB, CC, AA2, BB2, CC2, FACT, XYI(7), XYO(7),
     *   CELLSG(2), CRP(2), MAPR, RFACT, DSUM, DSUM2
      LOGICAL   POINT
      CHARACTER CDUMMY*1, OPTYPE*4
      INCLUDE 'GFORT'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA XYI, XYO /7*1.0, 7*1.0/
C-----------------------------------------------------------------------
      I = NC * NCCS
      CALL RFILL (I, 0.0, CCD)
C                                       Open input table
      CALL OCCINI (INTAB, 'READ', CCROW, CCNCOL, IERR)
      IF (IERR.NE.0) GO TO 999
      IF ((CCNCOL.EQ.4) .OR. (CCNCOL.EQ.8)) THEN
         MSGTXT = 'WARNING: 3D TABLES MAY NOT WORK PROPERLY'
         CALL MSGWRT (7)
         END IF
C                                       Get number of entries
      CALL OGET (INTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IERR)
      NROW = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'NCOL', TYPE, DIM, IDUM, CDUMMY, IERR)
      NCOL = IDUM(1)
      IF (IERR.NE.0) GO TO 999
C                                       Get range of rows.
      CALL OGET (INTAB, 'BCOMP', TYPE, DIM, IDUM, CDUMMY, IERR)
      BC = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'ECOMP', TYPE, DIM, IDUM, CDUMMY, IERR)
      EC = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'RFACTOR', TYPE, DIM, IDUM, CDUMMY, IERR)
      RFACT = RDUM(1)
      IF (IERR.NE.0) GO TO 999
C                                       image header
      CALL OBHGET (INTAB, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Clean beam from header
      BMAJ2 = CATR(KRBMJ)
      BMIN2 = CATR(KRBMN)
      BPA2 = CATR(KRBPA)
      CRP(1) = CATR(KRCRP)
      CRP(2) = CATR(KRCRP+1)
      CELLSG(1) = CATR(KRCIC)
      CELLSG(2) = CATR(KRCIC+1)
C                                       computing beam, type
      CALL OGET ('Input', 'BMAJ', TYPE, DIM, IDUM, CDUMMY, IERR)
      BMAJ = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET ('Input', 'BMIN', TYPE, DIM, IDUM, CDUMMY, IERR)
      BMIN = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET ('Input', 'BPA', TYPE, DIM, IDUM, CDUMMY, IERR)
      BPA = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET ('Input', 'OPTYPE', TYPE, DIM, IDUM, OPTYPE, IERR)
      IF (IERR.NE.0) GO TO 999
      POINT = OPTYPE(4:4).EQ.'P'
      FACT = 1.0
      IF (OPTYPE(1:1).EQ.'S') FACT = -1.0
      IF (OPTYPE(:3).EQ.'S+A') FACT = 1.0
C                                       read in CC file
      NCC = 0
      DO 10 IROW = BC,EC
         NCC = NCC + 1
         CALL CCTGET (INTAB, IROW, NCOL, CCD(XPOSI,NCC), CCD(YPOSI,NCC),
     *      CCD(FLUXI,NCC), CCD(WIDI,NCC), IERR)
         IF (IERR.GT.0) GO TO 999
C                                       Flagged?
         IF (IERR.LT.0) THEN
            NCC = NCC - 1
C                                       convert to output pixel
         ELSE
            XYI(1) = CCD(XPOSI,NCC) / CELLSG(1) + CRP(1)
            XYI(2) = CCD(YPOSI,NCC) / CELLSG(2) + CRP(2)
            CALL PSNCVT (INTAB, XYI, IMGOUT, XYO, IERR)
            IF (IERR.NE.0) THEN
                NCC = NCC - 1
            ELSE
               CCD(XPOSI,NCC) = XYO(1)
               CCD(YPOSI,NCC) = XYO(2)
               END IF
            END IF
 10      CONTINUE
C                                       Close Input CC
      CALL OCLOSE (INTAB, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       open images
      CALL IMGOPN (IMGIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL IMGOPN (IMGOUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ARROPN (IMGIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ARROPN (IMGOUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBHGET (IMGOUT, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      MAPR = CATR(KRCRT+1)
      CELLSG(1) = CATR(KRCIC)
      CELLSG(2) = CATR(KRCIC+1)
      CALL ARRWIN (IMGIN, BLC, TRC, NAXIS, IERR)
      IF (IERR.NE.0) GO TO 999
      NNX = TRC(1) - BLC(1) + 1
      NNY = TRC(2) - BLC(2) + 1
C                                       Gaus parameters
      IF (OPTYPE(2:4).NE.'GAU') THEN
         IF (.NOT.POINT) CALL CBPARS (BMAJ, BMIN, BPA, CELLSG, MAPR, AA,
     *      BB, CC, NCNV)
         IF (OPTYPE(:3).EQ.'S+A') THEN
            CALL CBPARS (BMAJ2, BMIN2, BPA2, CELLSG, MAPR, AA2, BB2,
     *         CC2, IROW)
            NCNV = MAX (NCNV, IROW)
            END IF
C                                       what does Gaussian add up to?
         DSUM = 0.0
         DSUM2 = 0.0
         X = NCNV+1
         Y = NCNV+1
         IX1 = X - NCNV
         IX2 = X + NCNV
         IY1 = Y - NCNV
         IY2 = Y + NCNV
         DO 30 IY = IY1,IY2
            DO 20 IX = IX1,IX2
               IF (.NOT.POINT) THEN
                  D = (IX-X)*(IX-X)*AA + (IY-Y)*(IY-Y)*BB +
     *               (IX-X)*(IY-Y)*CC
                  DSUM = DSUM + EXP(-D)
                  END IF
               IF (OPTYPE(:3).EQ.'S+A') THEN
                  D = (IX-X)*(IX-X)*AA2 + (IY-Y)*(IY-Y)*BB2 +
     *               (IX-X)*(IY-Y)*CC2
                  DSUM2 = DSUM2 + EXP (-D)
                  END IF
 20            CONTINUE
 30         CONTINUE
         IF (POINT) THEN
            DSUM = 1.0
         ELSE
            DSUM = 1.1331 * BMAJ * BMIN / (DSUM * CELLSG(1)*CELLSG(2))
            END IF
         DSUM2 = 1.1331 * BMAJ2 * BMIN2 / (DSUM2 * CELLSG(1)*CELLSG(2))
         DSUM = ABS (DSUM)
         DSUM2 = ABS (DSUM2)
      ELSE
         DSUM = 1.0
         END IF
      FACT = FACT * DSUM
C                                       loop through image
      DO 70 IY = 1,NNY
         CALL ARREAD (IMGIN, DIM, ROW, IERR)
         IF (IERR.NE.0) GO TO 995
         IY1 = IY - NCNV
         IY2 = IY + NCNV
C                                       subtract to make residual
         IF ((OPTYPE.EQ.'SUB') .OR. (OPTYPE(:3).EQ.'S+A') .OR.
     *      (OPTYPE.EQ.'SGAU')) THEN
C                                       loop through comps
            DO 40 I = 1,NCC
               IF (OPTYPE(2:4).EQ.'GAU') THEN
                  CALL CBPARS (CCD(4,I), CCD(5,I), CCD(6,I), CELLSG,
     *               MAPR,AA, BB, CC, NCNV)
                  IY1 = IY - NCNV
                  IY2 = IY + NCNV
                  END IF
               IF ((CCD(YPOSI,I).GE.IY1) .AND. (CCD(YPOSI,I).LE.IY2)
     *            .AND. (CCD(XPOSI,I).GE.1-NCNV) .AND.
     *            (CCD(XPOSI,I).LE.NNX+NCNV)) THEN
                  X = CCD(XPOSI,I)
                  Y = CCD(YPOSI,I)
                  IX1 = X - NCNV
                  IX2 = X + NCNV
                  IX1 = MAX (1, IX1)
                  IX2 = MIN (NNX, IX2)
                  DO 35 IX = IX1,IX2
                     IF (ROW(IX).NE.FBLANK) THEN
                        IF (OPTYPE(:3).EQ.'S+A') THEN
                           D = (IX-X)*(IX-X)*AA2 + (IY-Y)*(IY-Y)*BB2 +
     *                        (IX-X)*(IY-Y)*CC2
                           ROW(IX) = ROW(IX) - DSUM2 * CCD(FLUXI,I) *
     *                        EXP (-D)
                        ELSE
                           D = (IX-X)*(IX-X)*AA + (IY-Y)*(IY-Y)*BB +
     *                        (IX-X)*(IY-Y)*CC
                           ROW(IX) = ROW(IX) + FACT * CCD(FLUXI,I) *
     *                        EXP (-D)
                           END IF
                        END IF
 35                  CONTINUE
                  END IF
 40            CONTINUE
            END IF
C                                       scale residual
         IF (RFACT.NE.1.0) THEN
            DO 50 IX = 1,NNX
               IF (ROW(IX).NE.FBLANK) ROW(IX) = ROW(IX) * RFACT
 50            CONTINUE
            END IF
C                                       add to make image
         IF ((OPTYPE(:3).EQ.'ADD') .OR. (OPTYPE(:3).EQ.'S+A') .OR.
     *      (OPTYPE.EQ.'AGAU')) THEN
C                                       loop through comps
            DO 60 I = 1,NCC
               IF (OPTYPE(2:4).EQ.'GAU') THEN
                  CALL CBPARS (CCD(4,I), CCD(5,I), CCD(6,I), CELLSG,
     *               MAPR,AA, BB, CC, NCNV)
                  IY1 = IY - NCNV
                  IY2 = IY + NCNV
                  END IF
               IF ((CCD(YPOSI,I).GE.IY1) .AND. (CCD(YPOSI,I).LE.IY2))
     *            THEN
                  X = CCD(XPOSI,I)
                  Y = CCD(YPOSI,I)
                  IX1 = X - NCNV
                  IX2 = X + NCNV
                  IX1 = MAX (1, IX1)
                  IX2 = MIN (NNX, IX2)
                  DO 55 IX = IX1,IX2
                     IF (ROW(IX).NE.FBLANK) THEN
                        IF (POINT) THEN
                           IF ((ABS(IX-X).LT.0.5) .AND.
     *                        (ABS(IY-Y).LT.0.5)) ROW(IX) = ROW(IX) +
     *                        FACT * CCD(FLUXI,I)
                        ELSE
                           D = (IX-X)*(IX-X)*AA + (IY-Y)*(IY-Y)*BB +
     *                        (IX-X)*(IY-Y)*CC
                           ROW(IX) = ROW(IX) + FACT * CCD(FLUXI,I) *
     *                        EXP (-D)
                           END IF
                        END IF
 55                  CONTINUE
                  END IF
 60            CONTINUE
            END IF
         CALL ARRWRI (IMGOUT, DIM, ROW, IERR)
         IF (IERR.NE.0) GO TO 995
 70      CONTINUE
      CALL ARRCLO (IMGIN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ARRCLO (IMGOUT, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL IMGCLO (IMGIN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL IMGCLO (IMGOUT, IERR)
      IF (IERR.NE.0) GO TO 999
      GO TO 999
C
 995  WRITE (MSGTXT,1995) IERR, IY
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1995 FORMAT ('ERROR',I5,' AT ROW',I6)
      END
      SUBROUTINE CRESHI (IMGIN, INTAB, IMGOUT, NCCS)
C-----------------------------------------------------------------------
C   Routine to write history file to output table object.  This assumes
C   that a previous history exists and merely adds the information from
C   the current task.
C   Inputs:
C      IMGIN    C*?   Input image
C      INTAB    C*?   Input table object
C      IMGOUT   C*?   Output table object
C      NCCS     I     Number clean comps
C-----------------------------------------------------------------------
      CHARACTER IMGIN*(*), INTAB*(*), IMGOUT*(*)
      INTEGER   NCCS
C
      INTEGER   NADV
      PARAMETER (NADV=19)
      CHARACTER LIST(NADV)*8
C
      INTEGER   IERR, I, TYPE, DIM(7), P1, CCVER
      CHARACTER LINE*72, OPTYPE*4, FUNC(2)*10, CDUMMY*1, OUTTAB*32,
     *   CUNIT*8
      REAL      BMAJ, BMIN, BPA, BMAJH, BMINH, BPAH, RFACT, FACTOR
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PAOOF.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'BLC', 'TRC',
     *   'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK', 'INVERS',
     *   'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK', 'OPTYPE', 'BCOMP',
     *   'ECOMP', 'FACTOR'/
      DATA FUNC /'added','subtracted'/
C-----------------------------------------------------------------------
C                                       Add task label to history
      CALL OHCOPY (IMGIN, IMGOUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy adverb values.
      CALL OHLIST ('Input', LIST, NADV, IMGOUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       units conversion
      CALL OGET ('Input', 'BMAJ', TYPE, DIM, IDUM, CDUMMY, IERR)
      BMAJ = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET ('Input', 'BMIN', TYPE, DIM, IDUM, CDUMMY, IERR)
      BMIN = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET ('Input', 'BPA', TYPE, DIM, IDUM, CDUMMY, IERR)
      BPA = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET ('Input', 'OPTYPE', TYPE, DIM, IDUM, OPTYPE, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET ('Input', 'FACTOR', TYPE, DIM, IDUM, CDUMMY, IERR)
      FACTOR = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'RFACTOR', TYPE, DIM, IDUM, CDUMMY, IERR)
      RFACT = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      IF (FACTOR.GT.0.0) RFACT = RFACT / FACTOR
      IF (RFACT.NE.1.0) THEN
         WRITE (LINE,1010) RFACT
         CALL OHWRIT (LINE, IMGOUT, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
      I = 1
      IF (OPTYPE.EQ.'SUB') I = 2
      BMAJ = BMAJ * 3600.0
      BMIN = BMIN * 3600.0
      IF (OPTYPE(2:4).NE.'GAU') THEN
         WRITE (LINE,1000) 'BMAJ    ', BMAJ, FUNC(I)
         CALL OHWRIT (LINE, IMGOUT, IERR)
         IF (IERR.NE.0) GO TO 990
         WRITE (LINE,1000) 'BMIN    ', BMIN, FUNC(I)
         CALL OHWRIT (LINE, IMGOUT, IERR)
         IF (IERR.NE.0) GO TO 990
         WRITE (LINE,1001) 'BPA     ', BPA, FUNC(I)
         CALL OHWRIT (LINE, IMGOUT, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       image CB needed
      IF (OPTYPE.EQ.'S+A') THEN
C                                       Open input table
         CALL OOPEN (INTAB, 'READ', IERR)
         IF (IERR.NE.0) GO TO 999
C                                       image header
         CALL OBHGET (INTAB, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Clean beam from header
         BMAJH = CATR(KRBMJ) * 3600.0
         BMINH = CATR(KRBMN) * 3600.0
         BPAH = CATR(KRBPA)
         I = 2
         WRITE (LINE,1000) 'BMAJH   ', BMAJH, FUNC(I)
         CALL OHWRIT (LINE, IMGOUT, IERR)
         IF (IERR.NE.0) GO TO 990
         WRITE (LINE,1000) 'BMINH   ', BMINH, FUNC(I)
         CALL OHWRIT (LINE, IMGOUT, IERR)
         IF (IERR.NE.0) GO TO 990
         WRITE (LINE,1001) 'BPAH    ', BPAH, FUNC(I)
         CALL OHWRIT (LINE, IMGOUT, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       fix up header
      CALL IMGOPN (IMGOUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 999
      P1 = 1
      IF ((OPTYPE.EQ.'SGAU') .OR. (OPTYPE.EQ.'SUB ')) P1 = 3
      IF ((OPTYPE.EQ.'ADDP') .OR. (OPTYPE.EQ.'S+AP')) P1 = 4
      DIM(1) = 1
      DIM(2) = 1
      IDUM(1) = P1
      CALL IMPUT (IMGOUT, 'BEAM.PRODUCT', OOAINT, DIM, IDUM, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
      IDUM(1) = NCCS
      CALL IMPUT (IMGOUT, 'BEAM.NITER', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      BMAJ = BMAJ / 3600.
      BMIN = BMIN / 3600.
      RDUM(1) = BMAJ
      CALL IMPUT (IMGOUT, 'BEAM.BMAJ', OOARE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      RDUM(1) = BMIN
      CALL IMPUT (IMGOUT, 'BEAM.BMIN', OOARE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      RDUM(1) = BPA
      CALL IMPUT (IMGOUT, 'BEAM.BPA', OOARE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (OPTYPE(4:4).EQ.'P') THEN
         CUNIT = 'JY/PIXEL'
         DIM(1) = 8
         CALL IMPUT (IMGOUT, 'BUNIT', OOACAR, DIM, IDUM, CUNIT, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
      CALL IMGCLO (IMGOUT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       copy rest tables
      DIM(1) = 2
      CUNIT = 'CC'
      CALL IMPUT (IMGIN, 'DROPTABS', OOACAR, DIM, IDUM, CUNIT, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL IMCALT (IMGIN, IMGOUT, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE COPYING OTHER TABLES'
         CALL MSGWRT (6)
         END IF
      IERR = 0
C                                       copy CC table
      OUTTAB = 'Output table'
      CCVER = 1
      CALL IM2TAB (IMGOUT, OUTTAB, 'CC', CCVER, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TBLCOP (INTAB, OUTTAB, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TABDES (OUTTAB, IERR)
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // IMGOUT
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A8,'= ',F10.6,5X,'/ ',A)
 1001 FORMAT (A8,'= ',F7.2,8X,'/ ',A)
 1010 FORMAT ('BMFACTOR=',F8.3,3X,'/ scale factor for new units')
      END
      SUBROUTINE CCTGET (NAME, ROW, NC, X, Y, FLUX, W, IERR)
C-----------------------------------------------------------------------
C   Get row from CC (CLEAN component) table object.
C   Inputs:
C      NAME    C*?  CC table object name.
C      ROW     I    Row number
C      NC      I    Number of columns
C   Output:
C      X       R      X coordinate
C      Y       R      Y coordinate
C      FLUX    R      Component flux density.
C      W       R(4)   Width and pa, Type
C      IERR    I      Return error code, 0=>OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   ROW, NC, IERR
      REAL      X, Y, FLUX, W(4)
C
      INTEGER   CCTYPE, CCRNO
      REAL      Z
C-----------------------------------------------------------------------
C                                       Read
      CCRNO = ROW
      CALL OTABCC (NAME, 'READ', CCRNO, NC, X, Y, Z, FLUX, CCTYPE, W,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
      W(4) = CCTYPE
C
 999  RETURN
      END
      SUBROUTINE CBPARS (BMAJ, BMIN, BPA, CELLSG, MROT, AA, BB, CC, NC)
C-----------------------------------------------------------------------
C   CBPARS converts the beam parameters and cell size to simple
C   computing parameters and range of rows/columns
C   Inputes
C      BMAJ     R      Major axis
C      BMIN     R      Minor axis
C      BPA      R      Position angle
C      CELLSG   R(2)   X, Y cells size
C      MROT     R      Map rotation
C   Outputs
C      AA       R
C      BB       R
C      CC       R
C      NC       I      Range in cells to use
C-----------------------------------------------------------------------
      REAL      BMAJ, BMIN, BPA, CELLSG(2), MROT, AA, BB, CC
      INTEGER   NC
C
      REAL      SR, CR
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      SR = SIN ((BPA+MROT) * DG2RAD)
      CR = COS ((BPA+MROT) * DG2RAD)
      AA = ((CR/BMIN)**2 + (SR/BMAJ)**2) * (CELLSG(1)**2) * 4.0 *
     *   LOG(2.0)
      BB = ((SR/BMIN)**2 + (CR/BMAJ)**2) * (CELLSG(2)**2) * 4.0 *
     *   LOG(2.0)
      CC = ((1.0/BMIN)**2 - (1.0/BMAJ)**2) * SR * CR * 8.0 * LOG(2.0) *
     *   ABS(CELLSG(1)*CELLSG(2))
      NC = 4.0 * BMAJ / MIN (ABS(CELLSG(1)), ABS(CELLSG(2))) + 0.75
      NC = NC / 2
C
 999  RETURN
      END

      SUBROUTINE FMAX (A, NX, NY, ISGN, IX, S)
C-----------------------------------------------------------------------
C! returns position and value of maximum in a two-dimensional array
C#
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Find the position and value of the maximum in an array
C   Inputs:
C      A      R(16,16)  Input array
C      NX     I         X-dimension of A
C      NY     I         Y-dimension of A
C      ISGN   I         If >0 look for max of A
C                       If <= 0 look for max of ABS(A)
C   Outputs:
C      IX     I(2)      X and y coordinates of max
C      S      R         Value of max
C-----------------------------------------------------------------------
      INTEGER    NX, NY, ISGN, IX(2)
      REAL       A(16,16), S
C
      INTEGER    I, J, X, Y
      REAL       TEMP, STEMP, SMAX
      LOGICAL    SABS
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      SABS = ISGN.LE.0
      X = 0
      Y = 0
      SMAX = -1.E10
      DO 20 I = 1,NX
         DO 10 J = 1,NY
            TEMP = A(I,J)
            IF (TEMP.EQ.FBLANK) GO TO 10
               STEMP = TEMP
               IF (SABS) TEMP = ABS (TEMP)
               IF (TEMP.LE.SMAX) GO TO 10
                  SMAX = TEMP
                  X = I
                  Y = J
                  S = STEMP
 10         CONTINUE
 20      CONTINUE
      IX(1) = X
      IX(2) = Y
C
 999  RETURN
      END

      SUBROUTINE BDN (DATJUL, EQUIN, DNS, DELPSI, SPSI, SEPS, NR)
C-----------------------------------------------------------------------
C! Computes Besselian day numbers of Julian date.
C# Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  Given are the Julian date of observation and the mean equinox
C  of the position.  The program computes the Besselian day numbers
C  A,B,C,D, and E, total nutation in longitude, DELPSI, short period
C  nutation in longitude, SPSI, and short period nutation in
C  obliquity, SEPS.
C   Inputs:
C      DATJUL   D      Julian date of observation
C      EQUIN    D      mean equinox of the position
C      NR       L      T => NUT4, else NUT2 ???
C   Outputs:
C      DNS      D(*)   Besselian day numbers A,B,C,D, and E
C      DELPSI   D      total nutation in longitude
C      SPSI     D      short period nutation in longitude
C      SEPS     D      short period nutation in obliquity
C-----------------------------------------------------------------------
      DOUBLE PRECISION DATJUL, EQUIN, DNS(*), DELPSI, SPSI, SEPS
      LOGICAL   NR
C
      DOUBLE PRECISION EPS, CK3, T, DJULA, TAU, EPSLON, DELEPS, BESSC,
     *   BESSD
      DATA CK3 /.0027379093D0/
C-----------------------------------------------------------------------
      T = (EQUIN - 1967D0) / 100D0
      DJULA = (EQUIN - 1967D0) * 365.242195D0 + 2439491.541D0
      TAU = CK3 * (DATJUL- DJULA)
      EPSLON = EPS(DATJUL)
      IF (NR) THEN
         CALL NUT4 (DATJUL, DELPSI, DELEPS, SPSI, SEPS)
      ELSE
         CALL NUT2 (DATJUL, DELPSI, DELEPS, SPSI, SEPS)
         END IF
      DNS(1)= (9.7161995D-5 - 4.1209D-8 * T) * TAU + SIN(EPSLON) *
     *   DELPSI
      DNS(2) = -DELEPS
      DNS(5) = DELPSI * (2.226D-3 - 3.73D-4 * T)
      CALL CD (DATJUL, BESSC, BESSD)
      DNS(3) = BESSC / 206264.8062D0
      DNS(4) = BESSD / 206264.8062D0
C
 999  RETURN
      END

      SUBROUTINE YISJMP (GOADDR, IERR)
C-----------------------------------------------------------------------
C! cause microprocessor jump toaddress in NRAO-ISU device
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YISJMP is a special Y routine for the NRAO Image Storage Unit -
C   a device interposed between the host CPU and the IIS Model 70 TV.
C   YISJMP causes the microprocessor to jump to a specified address.
C   Inputs:
C      GOADDR   I   Desired micro processor address
C   Output:
C      IERR     I   Error code of Z...XF: 0 okay, 2 input error
C   IIS Model 70 version - ISU present.
C-----------------------------------------------------------------------
      INTEGER   GOADDR, IERR
C
      INTEGER   ISUOPC, HEADER(8), BUFF
      DATA ISUOPC /7/
C-----------------------------------------------------------------------
C                                       Build header
      HEADER(1) = 3
      HEADER(2) = 0
      HEADER(3) = ISUOPC
      HEADER(4) = 0
      HEADER(5) = 0
      HEADER(6) = 0
      HEADER(7) = 0
      HEADER(8) = GOADDR
C                                       Do I/O
      CALL ZM70XF ('WRIT', 0, HEADER, BUFF, IERR)
C
 999  RETURN
      END

      SUBROUTINE GETCOL (IRNO, ICOL, DATP, LRNO, BUFFER, RTYPE, RESULT,
     *   ROWB, IERR)
C-----------------------------------------------------------------------
C! returns value and type found at specified column and row in a table
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GETCOL returns the value and value type found in an open table file
C   at the specified logical column and row.
C   Inputs:
C      IRNO    I         Table row number: n.b. I
C      ICOL    I         Table column number
C      DATP    I(256)    Pointer array returned by TABINI
C   In/out:
C      LRNO    I         Last read row number: set to 0 if ROWB is
C                        meaningless on input.  In/output value < 0 =>
C                        row abs(LRNO) flagged.
C      BUFFER  I(512)    Control area set up by TABINI, used in TABIO
C      ROWB    I(*)      Buffer to hold one full row: used on input if
C                        LRNO = IRNO
C   Output:
C      RTYPE   I         10 * length + Type of column:
C                        1 -> D,  2 -> R,  4 -> I,  5 -> L*?,  6 -> I.
C                        Characters unpacked hollerith, bits packed.
C      RESULT  ?(*)      Value of column: use D, R, H, I equivalenced
C                        arrays, note: may be an array; if length = 0,
C                        then no value and RESULT is unchanged.
C      IERR    I         Error code: 0 => OK.
C                          -1 => OK, but row is flagged
C                           1 file not open,  2 input error
C                           3 I/O error,      4 read past EOF
C                           5 bad data type
C-----------------------------------------------------------------------
      INTEGER   IRNO, ICOL, DATP(256), LRNO, BUFFER(512), RTYPE,
     *   RESULT(*), ROWB(*), IERR
C
      INTEGER   IPTR, IL, LENGTH
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       check
      IERR = 2
      IF (IRNO.LE.0) GO TO 999
      IF ((ICOL.LE.0) .OR. (ICOL.GT.BUFFER(10))) GO TO 999
      IERR = 0
C                                       get row
      IF (IRNO.NE.ABS(LRNO)) THEN
         CALL TABIO ('READ', 0, IRNO, ROWB, BUFFER, IERR)
         IF (IERR.GT.0) GO TO 999
         LRNO = IRNO
         IF (IERR.LT.0) LRNO = -IRNO
      ELSE
         IF (LRNO.LT.0) IERR = -1
         END IF
C                                       get type, I   address, length
      LENGTH = DATP(128+ICOL) / 10
      RTYPE = DATP(128+ICOL) - LENGTH * 10
C                                       For zero length return
      IF (LENGTH.LE.0) GO TO 999
      IPTR = DATP(ICOL)
C                                       bad  type
      IF ((RTYPE.LT.1) .OR. (RTYPE.GT.7)) THEN
         IERR = 5
         GO TO 999
         END IF
C                                       double precision
      IF (RTYPE.EQ.1) THEN
         IL = NWDPDP
         IPTR = (IPTR - 1) * IL + 1
         IL = IL * LENGTH
C                                       Characters
      ELSE IF (RTYPE.EQ.3) THEN
         IL = (LENGTH-1) / 4 + 1
C                                       Bit
      ELSE IF (RTYPE.EQ.7) THEN
         IL = (LENGTH - 1) / NBITWD + 1
C                                       integer, floating
      ELSE
         IL = LENGTH
         END IF
C                                       copy answer
      CALL COPY (IL, ROWB(IPTR), RESULT)
      RTYPE = RTYPE + 10 * LENGTH
C
 999  RETURN
      END

      SUBROUTINE WORD (LINE, AWORD)
C-----------------------------------------------------------------------
C! Gets the first word from input line
C# Printer Character
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   gets the first word (delimited by blanks or , . : ; ' ")
C   Input:
C      LINE    C*(*)   Input text - no special characters
C   Output:
C      AWORD   C*(*)   Output word
C-----------------------------------------------------------------------
      CHARACTER LINE*(*), AWORD*(*)
C
      INTEGER   NDELIM
      PARAMETER (NDELIM = 7)
      INTEGER   JTRIM, IL, IW, I1, I2, I, N
      CHARACTER DELIMI(7)*1
      DATA DELIMI /' ', '.', ',', ':', ';', '"', ''''/
C-----------------------------------------------------------------------
      AWORD = ' '
      IL = JTRIM (LINE)
      IW = LEN (AWORD)
C                                       something to check
      I1 = 0
      IF (IL.GT.0) THEN
         DO 20 I = 1,IL
            DO 15 N = 1,NDELIM
               IF (LINE(I:I).EQ.DELIMI(N)) GO TO 20
 15            CONTINUE
            I1 = I
            GO TO 25
 20         CONTINUE
C                                       not all delimiters
 25      I2 = 0
         IF (I1.GT.0) THEN
            IL = MIN (IL, I1-1+IW)
            DO 40 I = I1,IL
               DO 35 N = 1,NDELIM
                  IF (LINE(I:I).EQ.DELIMI(N)) GO TO 45
 35               CONTINUE
               I2 = I
 40            CONTINUE
C                                       return word
 45         AWORD = LINE(I1:I2)
            END IF
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'SLFIT.INC'
C                                       Local include for SLFIT
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   IDOPOS(4), IDOMAX(4), IDOWTH(4), ITTER, IDROP(2), IVOL,
     *   ISLOT, IVER, JJC
      REAL      GM(48), SLPOS(MAXIMG), RANGE(2), XCEN
      LOGICAL   QUICK, SPECTR
      DOUBLE PRECISION DATA(MAXIMG)
      COMMON /GDATA/ DATA, SLPOS, QUICK, IDOPOS, IDOMAX, IDOWTH, ITTER,
     *   IDROP, IVOL, ISLOT, IVER, SPECTR, GM, RANGE, JJC, XCEN
LOCAL END
      PROGRAM SLFIT
C-----------------------------------------------------------------------
C! Task to fit up to 4 gaussians to portions of a slice (SL) file
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000, 2005, 2007, 2009, 2011-2016, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SLFIT fits up to 4 gaussian components to portions of a slice file
C   INPUTS:   (from AIPS)
C      INNAME    R(3)     name of image file.
C      INCLASS   R(2)     class of image file.
C      INSEQ     R        sequence number of image file.
C      INDISK    R        disk volume number. 0 means try all.
C      INVERS    R        version number of slice file, 0 means try
C                            latest version.
C      BDROP     R        # Slice points not fitted on left
C      EDROP     R        # Slice points not fitted on right
C      NGAUSS    R        # of gaussian components in fitted curve.
C      GPOS      R(2,4)   position of gaussian components. Only
C                            GPOS(1,*) used in 1D fitting.  Units are
C                            those printed by TKSLICE with label type of
C                            LTYPE.
C      GMAX      R(4)     maximum value of gaussian components in
C                            units printed by TKSLICE.
C      GWIDTH    R(3,4)   width of gaussian components in units
C                            printed by TKSLICE.  Only GWIDTH(1,*) used
C      LTYPE     R        labeling type used when selecting units for
C                            initial guess. 1, 2, 3 RA/dec
C                            4=center rel., 5=subslice center-rel
C      DOPOS     R(2,4)   < 0 (false) means hold position constant.
C      DOMAX     R(4)     < 0 (false) means hold position constant.
C      DOWIDTH   R(3,4)   < 0 (false) means hold position constant.
C-----------------------------------------------------------------------
C                                       Subroutine being passed
      INCLUDE 'INCS:PMAD.INC'
      EXTERNAL  GFUNC
C
      INTEGER   INPTS, INPARM, ISLHDR(256), IPVT(15), ISFIND, ISLUN,
     *   IERR, INFO, NPTS, NPARM, WSIZE
      DOUBLE PRECISION PARMS(15), FJAC(15,15), WORK(MAXIMG+200),
     *   FVEC(MAXIMG), TOL
      INCLUDE 'SLFIT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      DATA ISLUN /27/
C-----------------------------------------------------------------------
C                                       Get map header, open slice file
C                                       set location common. Read
C                                       slice header. Convert to more
C                                       reasonable units for GPOS, etc.
      CALL GAUINI (ISLUN, ISFIND, NPARM, ISLHDR, NPTS, PARMS,
     *   TOL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Fit gaussians using initial
C                                       guess.
      INPTS = NPTS
      INPARM = NPARM + JJC
      WSIZE = MAXIMG+200
      CALL LMSTR1 (GFUNC, INPTS, INPARM, PARMS, FVEC, FJAC, 15,
     *   TOL, INFO, IPVT, WORK, WSIZE)
C                                       Put answers in proper form.
C                                       Update slice header, save info
C                                       at the end of the slice file.
C                                       Calculate error.
C                                       Print results. Close down.
      CALL GAUFIN (ISLUN, ISFIND, INFO, NPARM, ISLHDR, PARMS, IPVT,
     *   FJAC, FVEC)
C
 999  STOP
      END
      SUBROUTINE GAUINI (ISLUN, ISFIND, NPARM, ISLHDR, NPTS, PARMS,
     *   TOL, IERR)
C-----------------------------------------------------------------------
C   GAUINI will initialize the location common for gaussian fitting
C   and convert the position, max, width from physical (user input)
C   units to slice points.
C   INPUTS:  ISLUN   I   logical unit number of open slice file.
C   OUTPUTS: ISFIND  I   FTAB indicator of the slice file.
C            NPARM   I   number of parameters in the fitted curve
C                    (3 * no. of gaussian components).
C            ISLHDR  I(256)   slice extension file header.
C            NPTS    I   no. of slice data points to be fitted.
C            PARMS   D(15)   parameters for fitted curve.  Max, pos,
C                    width, max, ...
C            TOL     D   tolerance parameter for fitting.
C            IERR    I   error code. 0=ok.
C  COMMON    /GDATA/ DATA D(8192)   contains the slice data points.
C                    IDOPOS I(4)   -1 means hold position constant.
C                    IDOMAX I(4)   -1 means hold max amp constant.
C                    IDOWTH I(4)   -1 means hold half width constant.
C                    ITTER  I   no. of iterations initialized to zero.
C                    IDROP I(2)   no. of slice points dropped from
C                    beginning and end of slice.
C-----------------------------------------------------------------------
      INTEGER   ISLUN, ISFIND, NPARM, ISLHDR(*), NPTS, IERR
      DOUBLE PRECISION PARMS(15), TOL
C
      CHARACTER PRGNAM*6, INNAM*12, INCLS*6, INTYP*2, TEXT(2)*80,
     *   JY*8, OPTYPE*4
      HOLLERITH XINNAM(3), XINCLS(2)
      DOUBLE PRECISION XVAL, YVAL, DFBLK(128), FQFREQ, SCALEF, OFFSET
      REAL      INSEQ, INDSK, INVER, BDROP, EDROP, NGAUSS, XPOS(2,4),
     *   XMAX(4), XWIDTH(3,4), LTYPE, DOPOS(2,4), DOMAX(4), DOWTH(3,4),
     *   BLC(2), TRC(2), CH(4), FBLK(256), RBLK(256), GPOS(2,4),
     *   GMAX(4), GWIDTH(3,4), XPIX, YGAP, YPIX, FQFINC, ORDER
      INTEGER  IDEPTH(5), IFBLK(256), ILABEL, INGAUS, IS, IXBLC, IXTRC,
     *   NTEXT, I, IERR2, IMFIND, IMLUN, INPRMS, IPOS, IRETCD, ISEQ,
     *   IUSER, J, NRPBLK, NRPFP, IRRN, IROUND, IBLK(256)
      LOGICAL   NOSAVE, NOEXCL, WAIT, ISOLD
      INCLUDE 'SLFIT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      COMMON /INPUT/ XINNAM, XINCLS, INSEQ, INDSK, INVER, BDROP, EDROP,
     *   NGAUSS, LTYPE, ORDER, XMAX, XPOS, XWIDTH, DOMAX, DOPOS, DOWTH
      EQUIVALENCE (NOEXCL, NOSAVE)
      EQUIVALENCE (IFBLK, FBLK, DFBLK)
      EQUIVALENCE (RBLK, IBLK)
      DATA PRGNAM /'SLFIT '/
      DATA NOSAVE, WAIT /.FALSE.,.TRUE./
      DATA IMLUN /17/
      DATA JY /'JY'/
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE., CATBLK)
      CALL VHDRIN
C                                       Get input values from AIPS.
C                                       Fixed PPM 1996.09.30: was 59
      INPRMS = 61
      IRETCD = 0
      CALL GTPARM (PRGNAM, INPRMS, QUICK, XINNAM, CATBLK, IERR)
      QUICK = .FALSE.
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRETCD = 8
         END IF
      IF (IRETCD.NE.0) GO TO 990
      IRETCD = 8
      CALL RCOPY (48, XMAX, GM)
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XINNAM, INNAM)
      CALL H2CHR (6, 1, XINCLS, INCLS)
      INTYP = ' '
C                                       Convert R   to I.
      ISEQ = INSEQ + 0.5
      IUSER = NLUSER
      IDROP(1) = BDROP + 0.5
      IDROP(2) = EDROP + 0.5
      INGAUS = NGAUSS + 0.5
      IVER = INVER + 0.5
      IVOL = INDSK + 0.5
      ILABEL = IROUND (LTYPE)
      I = MOD (ABS(ILABEL), 100)
      IF (I.LT.2) THEN
         I = 3
         IF (ILABEL.LT.0) THEN
            ILABEL = (ILABEL/100)*100 - I
         ELSE
            ILABEL = (ILABEL/100)*100 + I
            END IF
         END IF
      DO 20 I = 1,4
         IDOPOS(I) = 1
         IDOMAX(I) = 1
         IDOWTH(I) = 1
         IF (DOPOS(1,I).LE.0.0) IDOPOS(I) = -1
         IF (DOMAX(I).LE.0.0) IDOMAX(I) = -1
         IF (DOWTH(1,I).LE.0.0) IDOWTH(I) = -1
 20      CONTINUE
C                                       Check inputs
      JJC = IROUND (ORDER) + 1
      JJC = MAX (0, MIN (3, JJC))
      IF (INGAUS.LT.1) INGAUS = 1
      IF (INGAUS.GT.4) INGAUS = 4
      DO 30 I = 1,INGAUS
         IF (XWIDTH(1,I).EQ.0) GO TO 985
 30      CONTINUE
C                                       Open image, get header, close.
      CALL MAPOPN ('READ', IVOL, INNAM, INCLS, ISEQ, INTYP, IUSER,
     *   IMLUN, IMFIND, ISLOT, CATBLK, DATA, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL MAPCLS ('READ', IVOL, ISLOT, IMLUN, IMFIND, CATBLK, NOSAVE,
     *   DATA, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Open slice extension file.
      NRPFP = 256
      CALL OPEXT ('SL', IVOL, ISLOT, IVER, ISLUN, NOEXCL, WAIT,
     *   ISFIND, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Read slice header.
      IRRN = 1
      CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, ISLHDR, IERR)
      IF (IERR.NE.0) GO TO 980
      NPARM = 3 * INGAUS
      NPTS = ISLHDR(57) - IDROP(1) - IDROP(2)
C                                       No of points too small.
      IF (NPTS.LT.NPARM+JJC) THEN
         WRITE (MSGTXT,1030) NPTS, IDROP
         CALL MSGWRT (5)
         IDROP(1) = 0
         IDROP(2) = 0
         NPTS = ISLHDR(57)
         END IF
      XCEN = (IDROP(1) + 1.0 + ISLHDR(57) - IDROP(2)) / 2.0
C                                       # points too large
      IF (NPTS.GT.8192) THEN
         MSGTXT = 'CAN ONLY FIT A 8192-POINT PORTION OF A SLICE'
         CALL MSGWRT (8)
         GO TO 980
         END IF
C                                       Read SLICE inputs stuff.
      IRRN = 2
      CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, IFBLK, IERR)
      IF (IERR.NE.0) GO TO 980
      IS = 11
      IXBLC = IS + 8
      IXTRC = IS + 15
      RANGE(1) = FBLK(34)
      RANGE(2) = FBLK(35)
      CALL H2CHR (4, 1, FBLK(33), OPTYPE)
      IF ((OPTYPE.EQ.'AVER') .OR. (OPTYPE.EQ.'FLUX') .OR.
     *   (OPTYPE.EQ.'LGFL') .OR. (OPTYPE.EQ.'LNFL') .OR.
     *   (OPTYPE.EQ.'ADER') .OR. (OPTYPE.EQ.'FDER') .OR.
     *   (OPTYPE.EQ.'LGAV') .OR. (OPTYPE.EQ.'LNAV')) THEN
         ISOLD = .FALSE.
      ELSE
         ISOLD = .TRUE.
         END IF
C                                       old - force FQ to zero on disk
      IF (ISOLD) THEN
         FQFINC = 0.0
         FQFREQ = 0.0D0
         FBLK(36) = 0.0
         DFBLK(19) = 0.0D0
         IRRN = 2
         CALL ZFIO ('WRIT', ISLUN, ISFIND, IRRN, IFBLK, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       new pick up FQ if any
      ELSE
         FQFINC = FBLK(36)
         FQFREQ = DFBLK(19)
         END IF
      IF (OPTYPE.EQ.'FLUX') CALL CHR2H (8, JY, 1, CATH(KHBUN))
      IF (OPTYPE.EQ.'LGFL') CALL CHR2H (8, 'LOG10 JY', 1, CATH(KHBUN))
      IF (OPTYPE.EQ.'LNFL') CALL CHR2H (8, 'LN (JY)', 1, CATH(KHBUN))
      IF (OPTYPE.EQ.'FDER') CALL CHR2H (8, 'dJY / dx', 1, CATH(KHBUN))
      BLC(2) = 1.0
      TRC(2) = 40000.0
C                                       Initialize location common.
      LOCNUM = 1
      SPECTR = ABS(FBLK(IXBLC+2)-FBLK(IXTRC+2)).GE.1.0
      CALL SLBINI (IDROP, ISLHDR(57), RANGE, BLC, TRC, FBLK(IXBLC),
     *   FBLK(IXTRC), FQFREQ, FQFINC, IDEPTH, ILABEL, YGAP, CH, TEXT,
     *   NTEXT)
C                                       Convert to slice pt. units.
      SCALEF = (RANGE(2)-RANGE(1)) / 39999.0D0
      OFFSET = RANGE(1) - SCALEF
C                                       Spectral slice (ISPEC, BLSUM)
      IF (SPECTR) THEN
         DO 40 I = 1,INGAUS
C                                       Position and maximum.
            XVAL = XPOS(1,I) - RPVAL(1,LOCNUM)
            YVAL = XMAX(I) - RPVAL(2,LOCNUM)
            XPIX = XVAL / AXINC(1,LOCNUM) + RPLOC(1,LOCNUM)
            YPIX = YVAL / AXINC(2,LOCNUM) + RPLOC(2,LOCNUM)
            GPOS(1,I) = XPIX
            GMAX(I) = SCALEF * YPIX  +  OFFSET
C                                       Half width.
            XVAL = XPOS(1,I) - (XWIDTH(1,I) / 2.0) - RPVAL(1,LOCNUM)
            XPIX = XVAL / AXINC(1,LOCNUM) + RPLOC(1,LOCNUM)
            GWIDTH(1,I) = 2.0 * ABS (GPOS(1,I) - XPIX)
 40         CONTINUE
C                                       slice on 1st 2 axes
      ELSE
         DO 50 I = 1,INGAUS
C                                       Position and maximum.
            XVAL = XPOS(1,I)
            YVAL = XMAX(I)
            CALL XYPIX (XVAL, YVAL, XPIX, YPIX, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1040) IERR, I
               CALL MSGWRT (8)
               GO TO 980
               END IF
            XVAL = XPOS(1,I) - (XWIDTH(1,I) / 2.0)
            GPOS(1,I) = XPIX
            GMAX(I) = SCALEF * YPIX  +  OFFSET
C                                       Half width.
            CALL XYPIX (XVAL, YVAL, XPIX, YPIX, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1042) IERR, I
               CALL MSGWRT (8)
               GO TO 980
               END IF
            GWIDTH(1,I) = 2.0 * ABS (GPOS(1,I) - XPIX)
 50         CONTINUE
         END IF
C                                       Calc no. REALs per IO block.
      NRPBLK = 256
C                                       Load 1st record.
      IPOS = MOD (IDROP(1), NRPBLK) + 1
      IRRN = IDROP(1) / NRPBLK  +  3
      CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, IBLK, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Calculate actual slice values.
      I = 0
      DO 70 J = 1,NPTS
C                                       Read new buffer of slice values
         IF (IPOS.GT.NRPBLK) THEN
            IRRN = IRRN + 1
            CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, IBLK, IERR)
            IF (IERR.NE.0) GO TO 980
            IPOS = 1
            END IF
C                                       Move data into array
         IF (RBLK(IPOS).NE.FBLANK) THEN
            I = I + 1
            DATA(I) = RBLK(IPOS)
            SLPOS(I) = J
            END IF
         IPOS = IPOS + 1
 70      CONTINUE
      NPTS = I
C                                       Convert parms to right form.
      J = 1
      CALL DFILL (15, 0.0D0, PARMS)
      DO 80 I = 1,INGAUS
         PARMS(J) = GMAX(I)
         PARMS(J+1) = GPOS(1,I)
         PARMS(J+2) = GWIDTH(1,I)
         J = J + 3
 80      CONTINUE
C                                       Calculate other parameters
C                                       needed by LMSTR1.
      TOL = 1.0D-5
      ITTER = 0
      GO TO 999
C                                       Error after slice file opened.
 980  CALL ZCLOSE (ISLUN, ISFIND, IERR2)
      GO TO 990
C                                       Zero half widths not allowed.
 985  WRITE (MSGTXT,1985) INGAUS
      CALL MSGWRT (6)
C                                       Error before slice file opened.
 990  MSGTXT = 'FATAL ERROR IN SLFIT'
      CALL MSGWRT (6)
C                                       Close down procedure.
C                                        Normal ending
      CALL DIETSK (IRETCD, QUICK, IFBLK)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TROUBLE GETTING PARMS FROM AIPS. IERR=',I5)
 1030 FORMAT ('Ignoring BDROP, EDROP',2I6,' too big for no. pts.',I6)
 1040 FORMAT ('ERROR',I3,' FINDING PIXEL POSITION OF COMPONENT',I3,
     *   ' PEAK')
 1042 FORMAT ('ERROR',I3,' FINDING PIXEL POSITION OF COMPONENT',I3,
     *   ' HALF POINT')
 1985 FORMAT ('Zero half width for component',I3)
      END
      SUBROUTINE GFUNC (M, N, PARMS, FVEC, FJROW, IFLAG)
C-----------------------------------------------------------------------
C   This routine is called by the Argonne package to calculate the
C   difference between the current fit and the actual data OR the
C   Jacobian for this difference.
C     INPUTS:  M        I Number of data points in slice (adj. array.
C                       dim.).
C              N        I No. of parameters (adj. array. dim.
C                       NGAUSS * 3)
C              PARMS    D(N)   parameters of gaussian components,
C                       GMAX(1), GPOS(1), GWIDTH(1), GMAX(2), ...
C              IFLAG    I   1=calculate difference for current guess.
C                           2=calculate jacobian for current guess.
C    COMMON:   GDATA
C              DATA     R(?)   Origional slice data points.
C              IDOPOS   I(4)   -1 means hold corresponding position
C                       parameter constant.
C              IDOMAX   I(4)   -1 means hold corresponding maximum
C                       amplitude parameter constant.
C              IDOWTH   I(4)   -1 means hold corresponding half
C                       width parameter constant.
C              ITTER    I   number of calls to evaluate FVEC.
C    OUTPUTS:  FVEC     D(M)   Slice data points minus data points
C                       evaluated for current guess.
C              FJROW    D(N)   Row (IFLAG - 1) of Jacobian.
C-----------------------------------------------------------------------
      INTEGER   N, M, IFLAG
      DOUBLE PRECISION PARMS(N), FVEC(M), FJROW(N)
C
      DOUBLE PRECISION AMP, POS, SIG, EFACT, RES2, TSIG2, X
      INTEGER   IGAUSS, IDATA, IAMP, IPOS, ISIG, K, NGAUS
      INCLUDE 'SLFIT.INC'
C-----------------------------------------------------------------------
C                                       Determine difference between
C                                       data and current fit.
      NGAUS = N - JJC
      IF (IFLAG.LE.1) THEN
         ITTER = ITTER + 1
         DO 20 IDATA = 1,M
            FVEC(IDATA) = DATA(IDATA)
            DO 15 IGAUSS = 3,NGAUS,3
               IAMP = IGAUSS-2
               IPOS = IGAUSS-1
               ISIG = IGAUSS
               AMP = PARMS(IAMP)
               POS = PARMS(IPOS)
               SIG = PARMS(ISIG)
               X = SLPOS(IDATA) + IDROP(1)
               RES2 = 2.772D0 * (X - POS)**2
               TSIG2 = SIG**2
               EFACT = EXP (-1.D0 * RES2 / TSIG2)
               FVEC(IDATA) = FVEC(IDATA) - AMP*EFACT
   15          CONTINUE
            IF (JJC.GE.1) FVEC(IDATA) = FVEC(IDATA) - PARMS(NGAUS+1)
            IF (JJC.GE.2) FVEC(IDATA) = FVEC(IDATA) - PARMS(NGAUS+2) *
     *         (IDATA - XCEN)
            IF (JJC.GE.3) FVEC(IDATA) = FVEC(IDATA) - PARMS(NGAUS+3) *
     *         (IDATA - XCEN) * (IDATA - XCEN)
   20       CONTINUE
C                                       Calculate Jacobian.
      ELSE
         IDATA = IFLAG - 1
         K = 0
         DO 110 IGAUSS = 3,NGAUS,3
            K = K + 1
            IAMP = IGAUSS-2
            IPOS = IGAUSS-1
            ISIG = IGAUSS
            AMP = PARMS(IAMP)
            POS = PARMS(IPOS)
            SIG = PARMS(ISIG)
            X = SLPOS(IDATA) + IDROP(1)
            RES2 = 2.772 * (X - POS)**2
            TSIG2 = SIG**2
            EFACT = EXP (-1.D0 * RES2 / TSIG2)
            FJROW(IAMP) = 0.0D0
            IF (IDOMAX(K).GE.0) FJROW(IAMP) = -EFACT
            FJROW(IPOS) = 0.0D0
            IF (IDOPOS(K).GE.0) FJROW(IPOS) = -5.544D0 * AMP * EFACT *
     *         (X - POS) / (SIG*SIG)
            FJROW(ISIG) = 0.0D0
            IF (IDOWTH(K).GE.0) FJROW(ISIG) = -2.D0 * AMP * EFACT *
     *         RES2 / (SIG ** 3)
 110        CONTINUE
         IF (JJC.GE.1) FJROW(NGAUS+1) = -1.0
         IF (JJC.GE.2) FJROW(NGAUS+2) = -(IDATA - XCEN)
         IF (JJC.GE.3) FJROW(NGAUS+3) = -(IDATA - XCEN) * (IDATA - XCEN)
         END IF
C
 999  RETURN
      END
      SUBROUTINE GAUFIN (ISLUN, ISIND, INFO, NPARM, ISLHDR, PARMS,
     *   IPVT, FJAC, FVEC)
C-----------------------------------------------------------------------
C   GAUFIN will write the final fitted slice pt units into the slice
C   file, then the answers will be converted into physical units for
C   printing.
C   INPUTS: ISLUN   I   logical unit number of a slice file opened
C                       with EXTINI.
C           ISIND   I   FTAB index of the slice file.
C           NGAUSS  I   No. of gaussian components in fitted curve.
C           ISLHDR  I(256)   standard extension file header.
C           PARMS   D(15)   fitted parameters in slice pt. units.
C           IPVT    I(15)    info from LMSTR1 for error computation.
C           FJAC    D(15,15)   info from LMSTR1 for error computation.
C           FVEC    D(8192)
C   COMMON /GDATA/  IDROP   I(2)   slice points at beginning and end of
C                   the slice file that were not fitted.
C                   IDOPOS  I(4)   1's mean position for component held
C                   constant.
C                   IDOMAX  I(4)   1's mean max for component held
C                   constant.
C                   IDOWTH  I(4)   1;s mean halfwidths held constant.
C                   ITTER   I   no. of function evaluations.
C-----------------------------------------------------------------------
      INTEGER   ISLUN, ISIND, INFO, NPARM, ISLHDR(*), IPVT(15)
      DOUBLE PRECISION PARMS(15), FJAC(15,15), FVEC(*)
C
      DOUBLE PRECISION EPARMS(15), SCALEF, XVAL, YVAL, ZVAL, FNORM,
     *   ENORM, WORK(15), TOL, OFFSET, XPIX, YPIX, TEMP, SFJAC(15,15),
     *   RMS
      REAL      XPOS(4), XMAX(4), XWTH(4), RBLK(256), EPOS(4), EMAX(4),
     *   EWTH(4), XP, YP
      INTEGER   IBLK(256), IERR, IS, NEXP, NPTS, NGAUSS, I, IRETCD, J,
     *   INPTS, INPARM, IRRN, IPNAME(12)
      CHARACTER MUNITS*8, PNAME*48, REASON*30
      HOLLERITH HPNAME(12)
      EQUIVALENCE (IPNAME, HPNAME)
      INCLUDE 'SLFIT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      EQUIVALENCE (RBLK, IBLK)
C-----------------------------------------------------------------------
      IRETCD = 8
      CALL H2CHR (8, 1, CATH(KHBUN), MUNITS)
C                                       Get errors.
      NPTS = ISLHDR(57) - IDROP(1) - IDROP(2)
      NGAUSS = NPARM / 3
      INPTS = NPTS
      FNORM = ENORM (INPTS, FVEC)
      INPARM = NPARM + JJC
      CALL DPCOPY (225, FJAC, SFJAC)
      CALL GETERR (IPVT, SFJAC, EPARMS, INPARM, NPTS, 15, FNORM, WORK,
     *   TOL)
C                                       real rms
      RMS = 0.0D0
      J = 0
      DO 10 I = 1,NPTS
         IF (DATA(I).NE.FBLANK) THEN
            RMS = RMS + FVEC(I) * FVEC(I)
            J = J + 1
            END IF
 10      CONTINUE
      RMS = SQRT (RMS / J)
C                                       Move answers into the buffer.
      CALL FILL (256, 0, IBLK)
      DO 20 I = 1,NPARM
         RBLK(I) = PARMS(I)
         RBLK(I+12) = EPARMS(I)
 20      CONTINUE
      IF (JJC.GT.0) THEN
         RBLK(83) = PARMS(NPARM+1)
         RBLK(84) = PARMS(NPARM+2)
         RBLK(85) = PARMS(NPARM+3)
         RBLK(86) = EPARMS(NPARM+1)
         RBLK(87) = EPARMS(NPARM+2)
         RBLK(88) = EPARMS(NPARM+3)
         END IF
C                                       Move user parms into buffer
      IS = 25
      IBLK(IS) = IDROP(1)
      IBLK(IS+1) = IDROP(2)
      IBLK(IS+2) = NGAUSS
      CALL ZDATE (IBLK(IS+3))
      CALL ZTIME (IBLK(IS+6))
      CALL COPY (4, IDOPOS, IBLK(IS+9))
      CALL COPY (4, IDOMAX, IBLK(IS+13))
      CALL COPY (4, IDOWTH, IBLK(IS+17))
      RBLK(IS+21) = RMS
      WRITE (MSGTXT,1010) RMS
      CALL MSGWRT (5)
C                                       Save in next avail block.
C                                       (first block + no of slices)
      IRRN = ISLHDR(59) + ISLHDR(58)
C                                       Expand file, update header.
      IF (IRRN.GT.ISLHDR(3)) THEN
         NEXP = 1
         CALL ZPHFIL ('SL', IVOL, ISLOT, IVER, PNAME, IERR)
         CALL ZEXPND (ISLUN, ISLHDR(29), PNAME, NEXP, IERR)
         REASON = 'EXPANDING SL FILE'
         IF (IERR.NE.0) GO TO 980
         CALL CHR2H (48, PNAME, 1, HPNAME)
         CALL COPY (12, IPNAME, ISLHDR(17))
         ISLHDR(3) = ISLHDR(3) + NEXP
         END IF
C                                       Update slice specific header
C                                       info.
      ISLHDR(58) = ISLHDR(58) + 1
      CALL ZFIO ('WRIT', ISLUN, ISIND, 1, ISLHDR, IERR)
      IF (IERR.NE.0) GO TO 980
      WRITE (MSGTXT,1030) ISLHDR(58)
      CALL MSGWRT (5)
C                                       Convert answers to more
C                                       meaningful units.
      SCALEF = 39999.0D0 / (RANGE(2) - RANGE(1))
      OFFSET = 1.0D0 - SCALEF * RANGE(1)
      J = 1
      CALL RFILL (4, 0.0, EMAX)
      CALL RFILL (4, 0.0, EPOS)
      CALL RFILL (4, 0.0, EWTH)
      REASON = ' '
C                                       spectral (ISPEC, BLSUM)
      IF (SPECTR) THEN
         DO 30 I = 1,NGAUSS
            XPIX = PARMS(J+1)
            YPIX = SCALEF * PARMS(J)  +  OFFSET
            XVAL = RPVAL(1,LOCNUM) + (XPIX - RPLOC(1,LOCNUM)) *
     *         AXINC(1,LOCNUM)
            YVAL = RPVAL(2,LOCNUM) + (YPIX - RPLOC(2,LOCNUM)) *
     *         AXINC(2,LOCNUM)
            XPOS(I) = XVAL
            XMAX(I) = YVAL
            IF (PARMS(J).NE.0.0) EMAX(I) = EPARMS(J) * (YVAL / PARMS(J))
            TEMP = XPIX
C                                       Halfwidth.
            XPIX = PARMS(J+1) - PARMS(J+2) / 2.0
            XVAL = RPVAL(1,LOCNUM) + (XPIX - RPLOC(1,LOCNUM)) *
     *         AXINC(1,LOCNUM)
            XWTH(I) = 2.0 * ABS (XPOS(I) - XVAL)
            IF (TEMP-XPIX.NE.0.0) THEN
               EPOS(I) = EPARMS(J+1) * ABS ((XPOS(I)-XVAL)/(TEMP-XPIX))
               EWTH(I) = EPARMS(J+2) * ABS ((XPOS(I)-XVAL)/(TEMP-XPIX))
               END IF
            J = J + 3
 30         CONTINUE
C                                       XY slice (SLICE)
      ELSE
         DO 40 I = 1,NGAUSS
            XP = PARMS(J+1)
            YP = SCALEF * PARMS(J)  +  OFFSET
            CALL XYVAL (XP, YP, XVAL, YVAL, ZVAL, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1031) IERR, I
               CALL MSGWRT (6)
               GO TO 980
               END IF
            XPOS(I) = XVAL
            XMAX(I) = YVAL
            IF (PARMS(J).NE.0.0) EMAX(I) = EPARMS(J) * (YVAL / PARMS(J))
            TEMP = PARMS(J+1)
C                                       Halfwidth.
            XPIX = PARMS(J+1) - PARMS(J+2) / 2.0
            XP = XPIX
            CALL XYVAL (XP, YP, XVAL, YVAL, ZVAL, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1033) IERR, I
               CALL MSGWRT (6)
               GO TO 980
               END IF
            XWTH(I) = 2.0 * ABS (XPOS(I) - XVAL)
            IF (TEMP-XPIX.NE.0.0) THEN
               EPOS(I) = EPARMS(J+1) * ABS ((XPOS(I)-XVAL)/(TEMP-XPIX))
               EWTH(I) = EPARMS(J+2) * ABS ((XPOS(I)-XVAL)/(TEMP-XPIX))
               END IF
            J = J + 3
 40         CONTINUE
         END IF
C                                       store scaled values
      J = 50
      DO 45 I = 1,NGAUSS
         RBLK(J+1) = XMAX(I)
         RBLK(J+2) = EMAX(I)
         RBLK(J+3) = XPOS(I)
         RBLK(J+4) = EPOS(I)
         RBLK(J+5) = XWTH(I)
         RBLK(J+6) = EWTH(I)
         J = J + 6
 45      CONTINUE
      PNAME = CPREF(2,LOCNUM) // CTYP(2,LOCNUM)
      CALL CHR2H (16, PNAME, 1, RBLK(75))
      PNAME = CPREF(1,LOCNUM) // CTYP(1,LOCNUM)
      CALL CHR2H (16, PNAME, 1, RBLK(79))
C                                       Write model record.
      CALL ZFIO ('WRIT', ISLUN, ISIND, IRRN, IBLK, IERR)
      REASON = 'WRITING SL FILE'
      IF (IERR.NE.0) GO TO 980
C                                       print results.
      WRITE (MSGTXT,1040) INFO, ITTER
      CALL MSGWRT (3)
      MSGTXT = 'Results in SLice units'
      CALL MSGWRT (5)
      MSGTXT = 'Cmp  Parameter    Value       Error'
      CALL MSGWRT (5)
      J = 1
      DO 50 I = 1,NGAUSS
         WRITE (MSGTXT,1110) I, 'Peak    ', PARMS(J), EPARMS(J), MUNITS
         CALL MSGWRT (5)
         WRITE (MSGTXT,1110) I, 'Position', PARMS(J+1), EPARMS(J+1),
     *      'SL points'
         CALL MSGWRT (5)
         WRITE (MSGTXT,1110) I, 'Fullwhm ', PARMS(J+2), EPARMS(J+2),
     *      'SL points'
         CALL MSGWRT (5)
         J = J + 3
 50      CONTINUE
      IF (JJC.GE.1) THEN
         WRITE (MSGTXT,1111) 'Constant', PARMS(J), EPARMS(J), MUNITS
         CALL MSGWRT (5)
         J = J + 1
         END IF
      IF (JJC.GE.2) THEN
         WRITE (MSGTXT,1111) 'Slope   ', PARMS(J), EPARMS(J),
     *      '/channel'
         CALL MSGWRT (5)
         J = J + 1
         END IF
      IF (JJC.GE.3) THEN
         WRITE (MSGTXT,1111) 'Curvature', PARMS(J), EPARMS(J),
     *      '/channel^2'
         CALL MSGWRT (5)
         J = J + 1
         END IF
      MSGTXT = 'Results in physical units'
      CALL MSGWRT (5)
      MSGTXT = 'Cmp  Parameter    Value         Error '
      CALL MSGWRT (5)
      J = 1
      DO 60 I = 1,NGAUSS
         PNAME = CPREF(2,LOCNUM) // CTYP(2,LOCNUM)
         CALL CHTRIM (PNAME, 25, PNAME, IS)
         WRITE (MSGTXT,1110) I, 'Peak    ', XMAX(I), EMAX(I), PNAME(:IS)
         CALL MSGWRT (5)
         PNAME = CPREF(1,LOCNUM) // CTYP(1,LOCNUM)
         CALL CHTRIM (PNAME, 25, PNAME, IS)
         WRITE (MSGTXT,1110) I, 'Position', XPOS(I), EPOS(I), PNAME(:IS)
         CALL MSGWRT (5)
         WRITE (MSGTXT,1110) I, 'Fullwhm ', XWTH(I), EWTH(I), PNAME(:IS)
         CALL MSGWRT (5)
         J = J + 3
 60      CONTINUE
      IRETCD = 0
      GO TO 990
C                                       Fatal error.
 980  WRITE (MSGTXT,1980) REASON
      CALL MSGWRT (6)
C                                       Close down procedure.
 990  CALL ZCLOSE (ISLUN, ISIND, IERR)
C                                       return answers
      IF (.NOT.QUICK) THEN
         DO 995 I = 1,NGAUSS
            GM(I) = XMAX(I)
            GM(24+I) = EMAX(I)
            GM(3+2*I) = XPOS(I)
            GM(27+2*I) = EPOS(I)
            GM(10+3*I) = XWTH(I)
            GM(34+3*I) = EWTH(I)
 995        CONTINUE
         CALL PTPARM (48, GM, IBLK, IERR)
         END IF
      CALL DIETSK (IRETCD, QUICK, IBLK)
      STOP
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('Solution RMS =',1PE12.4)
 1030 FORMAT ('Successful slice model version',I4,' saved.')
 1031 FORMAT ('ERROR',I3,' FINDING COORDINATES OF COMPONENT',I3,' PEAK')
 1033 FORMAT ('ERROR',I3,' FINDING COORDINATES OF COMPONENT',I3,
     *   ' HALF POINT')
 1040 FORMAT ('Info, function evaluations =',2I8)
 1110 FORMAT (I3,2X,A8,2X,1PE14.6,1PE12.4,2X,A)
 1111 FORMAT (' BL',2X,A8,2X,1PE14.6,1PE12.4,2X,A)
 1980 FORMAT ('FATAL ERROR',1X,A)
      END
      SUBROUTINE GETERR (IPVT, FJAC, PARERR, MPARMS, NDATA, MDATA,
     *   FNORM, WA, TOL)
C-----------------------------------------------------------------------
C   This subroutine for GAUSS calculates the errors on the fitted
C   parameters.
C   Inputs:
C      IPVT    I(MPARMS)   Defines a permutation matrix P such that
C                       JAC*P = Q*R, where JAC is the final calculated
C                       Jacobian, Q is
C                   orthogonal (not stored), and R is upper triangular
C                   with diagonal elements of nonincreasing magnitude.
C                   column J of P is column IPVT(J) of the identity
C                   matrix. (See FJAC below).
C           FJAC    D(MDATA,MPARMS)   The upper MPARMS by MPARMS sub-
C                   matrix of FJAC contains an upper triangular matrix
C                   R with diagonal elements of nonincreasing magnitude
C                   such that
C
C                    T     T           T
C                   P *(JAC *JAC)*P = R *R,
C
C                   where P is a permutation matrix and JAC is the final
C                   calculated Jacobian. Column J of P is column IPVT(J)
C                   (see above) of the identity matrix.
C           MPARMS  I Number of parameters in fitted function (adj.
C                   array dim.).
C           NDATA   I   Number of data points fitted.
C           MDATA   I Maximum no. of data points allowed for in
C                   FJAC (adj. array dim.).
C           FNORM   D   Euclidian norm of solution vector.
C           WA      D(MPARMS)   work array.
C  OUTPUT:  PARERR  D(MPARMS)   error in fitted parameters.
C           TOL     D   tolerance used in call to LMDER1.
C-----------------------------------------------------------------------
      INTEGER   MDATA, MPARMS, NDATA, IPVT(MPARMS)
      DOUBLE PRECISION FJAC(MDATA,MPARMS), PARERR(MPARMS), FNORM,
     *   WA(MPARMS), TOL
C
      INTEGER   IPARMS, J, NPARMS
      DOUBLE PRECISION EPSILN
C-----------------------------------------------------------------------
C                                       Calculate error following
C                                       Argonne write up
      NPARMS = MPARMS
C                                       Is this right ??????
      EPSILN = FNORM / SQRT(REAL(NDATA-NPARMS))
      IPARMS = NPARMS
      CALL COVAR (IPARMS, FJAC, MDATA, IPVT, TOL, WA)
      DO 10 J = 1,NPARMS
         PARERR(J) = EPSILN * SQRT(FJAC(J,J))
 10      CONTINUE
C
      RETURN
      END

      SUBROUTINE EXTCOP (TYPE, INVER, OUTVER, LUNOLD, LUNNEW, VOLOLD,
     *   VOLNEW, CNOOLD, CNONEW, CATNEW, BUFF1, BUFF2, BUFF3, IRET)
C-----------------------------------------------------------------------
C! copies extension file of the EXTINI/EXTIO variety
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   EXTCOP copies an extension file(s) of the EXTINI-EXTIO variety.
C   Inputs:
C      TYPE    C*2     Extension file type eg 'CC','AN'
C      INVER   I       Version number to copy, 0=>copy all.
C      OUTVER  I       Version number on output file, if more than one
C                      copied (INVER=0) this will be the # of the first
C                      file.  If OUTVER=0 the EXTINI defaults are used.
C      LUNOLD  I       LUN for old file
C      LUNNEW  I       LUN for new file
C      VOLOLD  I       Disk number for old file.
C      VOLNEW  I       Disk number for new file.
C      CNOOLD  I       Catalog slot number for old file
C      CNONEW  I       Catalog slot number for new file
C      CATNEW  I(256)  Catalog header for new file.
C   In/out:
C      BUFF1   I(>512) Work buffer: 256 words + n * 256 words (enough
C                      to hold at least one logical record)
C      BUFF2   I(>512) Work buffer: as BUFF1
C      BUFF3   I(*)    Buffer large enough to hold one logical record
C   Output:
C      IRET    I     Return error code  0 => ok
C                                       1 => files the same, no copy
C                                       2 => no input files exist
C                                       3 => failed
C                                       4 => no output files created
C-----------------------------------------------------------------------
      CHARACTER TYPE*2
      INTEGER   INVER, OUTVER, LUNOLD, LUNNEW, VOLOLD, VOLNEW, CNOOLD,
     *   CNONEW, CATNEW(256), BUFF1(512), BUFF2(512), BUFF3(256), IRET
C
      INTEGER   IERR, LREC, NREC, FINDO, FINDN, I, IVERI, IVERO, J,
     *   LIM, NVER, COUNT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                        Set initial version numbers.
      COUNT = 0
      IVERI = MAX (1, INVER)
      IVERO = OUTVER
C                                        Check if files the same
      IRET = 1
      IF ((VOLOLD.EQ.VOLNEW) .AND. (CNOOLD.EQ.CNONEW)) GO TO 999
      IRET = 3
C                                        Get old CATBLK in BUFF2.
      CALL CATIO ('READ', VOLOLD, CNOOLD, BUFF2, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         GO TO 980
         END IF
C                                        Find # TYPE ext. files.
      CALL FNDEXT (TYPE, BUFF2, NVER)
C                                        No old ext. files
      IF (NVER.LE.0) THEN
         IRET = 2
         GO TO 999
         END IF
C                                        Old ext. files exist.
      LIM = MAX (1, NVER)
C                                        Check if only one file to be
C                                        copied.
      IF (INVER.GT.0) LIM = 1
C                                        Loop copying files.
      DO 100 J = 1,LIM
         NREC = 10
         LREC = 1
C                                        Init. old EXT. file.
         CALL EXTINI ('READ', TYPE, VOLOLD, CNOOLD, IVERI, BUFF2,
     *      LUNOLD, FINDO, LREC, NREC, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 75
         NREC = BUFF1(4)
         LREC = MAX (1, LREC)
C                                        Suppress error messages.
         MSGSUP = 32000
C                                        Copy header to new file.
         CALL COPY (256, BUFF1, BUFF2)
C                                        Init. new EXT. file.
         CALL EXTINI ('WRIT', TYPE, VOLNEW, CNONEW, IVERO, CATNEW,
     *      LUNNEW, FINDN, LREC, NREC, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 70
         COUNT = COUNT + 1
         IF (NREC.LE.0) GO TO 60
C                                        Loop copying file.
            DO 50 I = 1,NREC
               CALL EXTIO ('READ', LUNOLD, FINDO, I, BUFF3, BUFF1, IERR)
               IF (IERR.NE.0) GO TO 60
               CALL EXTIO ('WRIT', LUNNEW, FINDN, I, BUFF3, BUFF2, IERR)
               IF (IERR.NE.0) GO TO 60
 50            CONTINUE
C                                        Close up.
 60      CALL EXTIO ('CLOS', LUNNEW, FINDN, J, BUFF3, BUFF2, IERR)
 70      CALL EXTIO ('CLOS', LUNOLD, FINDO, J, BUFF3, BUFF1, IERR)
 75      IVERI = IVERI + 1
         IVERO = IVERO + 1
C                                        Get old CATBLK in BUFF2.
         IF (J.EQ.LIM) GO TO 100
            CALL CATIO ('READ', VOLOLD, CNOOLD, BUFF2, 'REST', BUFF3,
     *         IERR)
            IF (IERR.EQ.0) GO TO 100
               WRITE (MSGTXT,1010) IERR
               GO TO 980
 100     CONTINUE
      IRET = 0
      IF (COUNT.EQ.0) IRET = 4
      GO TO 995
C
 980  CALL MSGWRT (8)
C
 995  MSGSUP = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('EXTCOP: ERROR',I3,' READING OLD CATBLK')
      END

      subroutine d2ibm(n,src,out)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
      integer*4 src(*),out(*)
      integer*4 i,x
      integer*4 s,frachi,fraclo,expon
      integer*4 itemp
      integer*4 dmaxhi
      integer*4 dmaxlo
      integer*4 z7fffffff
      integer*4 z80000000
      integer*4 z7f000000
      integer*4 z0000000f
      integer*4 z00100000
      integer*4 z000fffff
      integer*4 z00ffffff
      integer*4 z7ff00000
      integer*4 zf0000000
      integer*4 z00000003
      integer*4 z01000000
      integer*4 z0f000000
      data dmaxhi   /z7fffffff/
      data dmaxlo   /zffffffff/
      data z7fffffff/z7fffffff/
      data z80000000/z80000000/
      data z7f000000/z7f000000/
      data z0000000f/z0000000f/
      data z00100000/z00100000/
      data z000fffff/z000fffff/
      data z00ffffff/z00ffffff/
      data z7ff00000/z7ff00000/
      data zf0000000/zf0000000/
      data z00000003/z00000003/
      data z01000000/z01000000/
      data z0f000000/z0f000000/
cibmvec: ignore recrdeps
      do 100 i=1,n*2-1,2
        x = src(i)
        if (iand(x,z7fffffff).eq.0) then
          out(i) = src(i)
          out(i+1) = src(i+1)
        else
          s = iand(x,z80000000)
          expon = ishft(iand(x,z7ff00000),-20) - 1023
          frachi = iand(x,z000fffff)
          fraclo = src(i+1)
          frachi = ior(ishft(frachi,4),
     &                 ishft(iand(fraclo,zf0000000),-28))
          fraclo = ishft(fraclo,4)
          frachi = ior(frachi,z01000000)
          if (expon.ge.0) then
            itemp = iand(expon,z00000003)
            frachi = ior(ishft(frachi,itemp),
     &                   ishft(iand(fraclo,zf0000000),itemp-32))
            fraclo = ishft(fraclo,itemp)
            expon = ishft(expon,-2)            ! divide by 4
          else
            itemp = -iand(-expon,z00000003)
            fraclo = ior(ishft(fraclo,itemp),
     &                   ishft(iand(frachi,z0000000f),32+itemp))
            frachi = ishft(frachi,itemp)
            expon = -ishft(-expon,-2)          ! divide by 4
          endif
          if (iand(frachi,z0f000000).ne.0) then
            fraclo = ior(ishft(fraclo,-4),
     &               ishft(iand(frachi,z0000000f),28))
            frachi = ishft(frachi,-4)
            expon=expon + 1
          endif
          expon = expon + 64
          if (expon.gt.127) then  ! exponent overflow--set to 370 max
            out(i) = ior(s,dmaxhi)
            out(i+1) = dmaxlo
          else if (expon.le.0) then ! exponent underflow--set to zero
            out(i) = s
            out(i+1) = 0
          else ! put number in output array
            out(i) = ior(s,ior(ishft(expon,24),frachi))
            out(i+1) = fraclo
          end if
        endif
100   continue
      return
      end

      SUBROUTINE UVFAIP (XCNAME, DATFIL, GAINFL, FIRST, LAST, IFNUMB,
     *   OUTFIL, IERR)
C-----------------------------------------------------------------------
C! fortran for UVF task as an AIPS task
C# SingleDish
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Start up routine for UVF as an AIPS task
C   Output:
C      IERR             Error code: 0 AIPS started us,
C                          > 0 AIPS started us with bad data
C                          < 0 AIPS did not start us
C-----------------------------------------------------------------------
      INTEGER   FIRST, LAST, IERR
      REAL      IFNUMB
      HOLLERITH DATFIL(64), GAINFL(64), OUTFIL(64), XCNAME(2)
C
      CHARACTER PRGNAM*6, UFIL*48, SCRTCH*256, CZERO*4, CNAME*6
      HOLLERITH XDTFIL(12), XGNFIL(12), XOUFIL(12), XZERO
      REAL      XFIRST, XLAST, XIFNUM
      INTEGER   BUFFER(256), JTRIM, IROUND, IRET, I, NPARM
      LOGICAL   RQUICK
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /INPARM/ XDTFIL, XGNFIL, XFIRST, XLAST, XIFNUM, XOUFIL
      COMMON /UVFCOM/ RQUICK
      DATA PRGNAM /'UVF  '/
C-----------------------------------------------------------------------
C                                       AIPS init
      NPOPS = 1
      MSGCNT = -1
      NLUSER = 1
      TSKNAM = PRGNAM
      CALL ZDCHIN (.TRUE.)
      NPARM = 39
      IRET = 0
      XZERO = 0
      CALL H2CHR (4, 1, XZERO, CZERO)
      CALL H2CHR (6, 1, XCNAME, CNAME)
      I = JTRIM (CNAME)
C                                       Are we a task?
C      MSGSUP = 32000
      CALL UVFGTP (PRGNAM, CNAME, NPARM, RQUICK, XDTFIL, BUFFER, IERR)
      MSGSUP = 0
      IF (IERR.EQ.0) THEN
         FIRST = IROUND (XFIRST)
         FIRST = MAX (1, FIRST)
         LAST = IROUND (XLAST)
         IF (LAST.LE.0) LAST = 1000
         IFNUMB = XIFNUM / 100.0
         IF (IFNUMB.EQ.0.0) IFNUMB = 0.01
         CALL H2CHR (48, 1, XDTFIL, UFIL)
         CALL ZFULLN (UFIL, ' ', ' ', SCRTCH, IRET)
         IF (IRET.EQ.0) THEN
            I = JTRIM (SCRTCH)
            SCRTCH(I+1:I+4) = CZERO
            CALL CHR2H (256, SCRTCH, 1, DATFIL)
            CALL H2CHR (48, 1, XGNFIL, UFIL)
            CALL ZFULLN (UFIL, ' ', ' ', SCRTCH, IRET)
            END IF
         IF (IRET.EQ.0) THEN
            I = JTRIM (SCRTCH)
            SCRTCH(I+1:I+4) = CZERO
            CALL CHR2H (256, SCRTCH, 1, GAINFL)
            CALL H2CHR (48, 1, XOUFIL, UFIL)
            CALL ZFULLN (UFIL, ' ', ' ', SCRTCH, IRET)
            END IF
         IF (IRET.EQ.0) THEN
            I = JTRIM (SCRTCH)
            SCRTCH(I+1:I+4) = CZERO
            CALL CHR2H (256, SCRTCH, 1, OUTFIL)
            END IF
         IERR = IRET
         IF (RQUICK) CALL RELPOP (IRET, BUFFER, I)
      ELSE
         IERR = - ABS (IERR)
         END IF
C
 999  RETURN
      END
      SUBROUTINE UVFGTP (NAME, CNAME, NPARMS, RQUICK, RPARM, SCRTCH,
     *   IERR)
C-----------------------------------------------------------------------
C! starts tasks, getting parameters and task ID number, does accounting
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   GTPARM obtains the activator task number, obtains the transmitted
C   parameters, initializes the message common, and outputs the message
C   'task NAME begins'.  It also handles startup accounting.
C   Inputs:
C      NAME    C*6        Task name
C      CNAME   C*6        Real task name passed through
C      NPARMS  I          Number of real variables wanted
C   Outputs:
C      RQUICK  L          T => release POPs as soon as possible
C                         F => wait until you have finished
C      RPARM   R(NPARMS)  Parameters received
C      SCRTCH  I(256)     Scratch buffer
C      IERR    I          Error code: 0 -> ok
C                                     1 -> initiator not found
C                                     2 -> disk troubles
C                                     3 -> initiator zeroed
C-----------------------------------------------------------------------
      CHARACTER NAME*6, CNAME*6
      INTEGER   NPARMS, SCRTCH(256), IERR
      REAL      RPARM(*)
      LOGICAL   RQUICK
C
      INTEGER   FINDTD, ISCR, I, IER, J, LUNTD, NBL, JBL
      REAL      RSCR
      LOGICAL   T, F
      CHARACTER PHNAME*48, PTYPE*2, TNAME*6
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (RSCR, ISCR)
      DATA LUNTD, PTYPE /13, 'TD'/
      DATA T, F /.TRUE.,.FALSE./
      DATA NBL /3/
C-----------------------------------------------------------------------
C                                       set initial values
      IERR = 0
      MSGCNT = -1
      TSKNAM = NAME
      NPOPS = 1
      NLUSER = 1
      MSGSUP = 0
C                                       open task data file
      CALL ZPHFIL (PTYPE, 1, 0, 0, PHNAME, IER)
      CALL ZOPEN (LUNTD, FINDTD, 1, PHNAME, F, T, T, IER)
      IF (IER.EQ.0) GO TO 10
         IERR = 2
         GO TO 999
C                                       read directory record
 10   CALL ZFIO ('READ', LUNTD, FINDTD, 1, SCRTCH, IER)
      IF (IER.NE.0) GO TO 980
C                                       locate initiator
      CALL UVFWHO (NAME, CNAME, NPOPS, IER)
      J = 5 * (NPOPS-1)
      IF (IER.NE.0) GO TO 20
         CALL H2CHR (6, 1, SCRTCH(J+1), TNAME)
         IF (NAME.EQ.TNAME) GO TO 30
 20   IERR = 1
      IF ((SCRTCH(J+1).EQ.0) .AND. (SCRTCH(J+2).EQ.0)) IERR = 3
      GO TO 990
C                                       Clear task name from file
 30   SCRTCH(J+1) = 0
      SCRTCH(J+2) = 0
      CALL ZFIO ('WRIT', LUNTD, FINDTD, 1, SCRTCH, IER)
C                                       set values, read pars
      JBL = NBL*(NPOPS-1) + 2
      CALL ZFIO ('READ', LUNTD, FINDTD, JBL, SCRTCH, IER)
      IF (IER.NE.0) GO TO 980
C                                       User number
      NLUSER = SCRTCH(1)
C                                       Get TV and TK assignments
      NTVDEV = SCRTCH(2)
      NTKDEV = SCRTCH(3)
C                                       Get Message Kill parameter
      MSGKIL = SCRTCH(4)
C                                       Is this batch job
      ISBTCH = SCRTCH(5)
C                                       Is debug needed?
      DBGAIP = SCRTCH(6)
C                                       quick return
      J = 9
      ISCR = SCRTCH(J)
      RQUICK = RSCR.LE.0.0
      IF (NPOPS.GT.NINTRN+1) ISBTCH = 32000
      RQUICK = RQUICK .AND. (NPOPS.LE.NINTRN) .AND. (ISBTCH.NE.32000)
C                                       Get version ID
      J = J + 1
      CALL H2CHR (4, 1, SCRTCH(J), VERNAM)
C                                       any machine-dependent parms
      CALL ZSETUP
C                                       Get task parms
      IF (NPARMS.LE.0) GO TO 60
         DO 50 I = 1,NPARMS
            J = J + 1
            IF (J.LE.256) GO TO 45
               J = 1
               JBL = JBL + 1
               CALL ZFIO ('READ', LUNTD, FINDTD, JBL, SCRTCH, IER)
               IF (IER.NE.0) GO TO 980
 45         ISCR = SCRTCH(J)
            RPARM(I) = RSCR
 50         CONTINUE
C                                       close file
 60   CALL ZCLOSE (LUNTD, FINDTD, IER)
C                                       Start accounting
      CALL ACOUNT (1)
C                                       message: start
      WRITE (MSGTXT,1060) TSKNAM, RLSNAM
      CALL MSGWRT (5)
      GO TO 999
C                                       Errors
 980  IERR = 2
 990  CALL ZCLOSE (LUNTD, FINDTD, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1060 FORMAT ('Task ',A6,' (release of ',A7,') begins')
      END
      SUBROUTINE UVFWHO (INAME, CNAME, INUM, IERR)
C-----------------------------------------------------------------------
C! given root task name, gets actual task name and finds NPOPS number
C# System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   WHOAMI obtains the actual task name, compares it to the root task
C   name, and determines the POPS number.
C   Inputs:
C      INAME  C*6   Root task name
C      CNAME  C*6   actual name   SPECIAL VERSION IS HANDED THIS
C   Output:
C      INUM   I     POPS number
C      IERR   I     Error code: 0 => ok
C                      1 => illegal root
C                      2 => roots don't match
C                      3 => INUM out of range, illegal
C                      4 => other
C-----------------------------------------------------------------------
      CHARACTER INAME*6
      INTEGER   INUM, IERR
C
      INTEGER   IP
C      INTEGER   IT
      CHARACTER CNAME*6, CTEST*1
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Legal root?
      DO 10 IP = 1,6
         IF (INAME(IP:IP).EQ.' ') GO TO 20
 10      CONTINUE
      IERR = 1
      GO TO 999
C                                       Get real name
 20   IERR = 4
C      CALL ZGNAME (CNAME, IT)
C      IF (IT.NE.0) GO TO 999
C                                       Roots match?
      IP = IP - 1
      IERR = 2
      IF (IP.LT.1) GO TO 999
      IF (CNAME(1:IP).NE.INAME(1:IP)) GO TO 999
C                                       Get number
      IP = IP + 1
      CTEST = CNAME(IP:IP)
      IP = NINTRN
      IF (NBATQS.GT.0) IP = NINTRN + 1 + NBATQS
      CALL ZHEX10 (CTEST, INUM, IERR)
      IF ((INUM.LT.1) .OR. (INUM.GT.IP) .OR. (IERR.NE.0)) IERR = 3
C
 999  RETURN
      END
      SUBROUTINE UVFEND (IRET)
C-----------------------------------------------------------------------
C   Does the AIPS close down messages
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   BUFFER(256)
      LOGICAL   RQUICK
      COMMON /UVFCOM/ RQUICK
C-----------------------------------------------------------------------
      CALL DIETSK (IRET, RQUICK, BUFFER)
C
 999  RETURN
      END

      SUBROUTINE TBTIME (START, STOP, IERR)
C-----------------------------------------------------------------------
C! find start/stop times of a uv data set
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2016
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   determines the start and stop times of a TB-sorted uv data set.  It
C   reads the index table if there is one or it reads the first and last
C   vis points.  It is similar to INDXIN and initializes INDEX file.
C   Inputs from common /SELCAL/
C      NSOUWD       I    Number of sources included or excluded; if
C                        0 all sources are included.
C      DOSWNT       L    If .TRUE. then sources in SOUWAN are included
C                        If .FALSE. then excluded.
C      SOUWAN(30)   I    The source numbers of sources included or
C                        excluded.
C      TIMRNG(8)    R    Start day, hour, min, sec, end day, hour,
C                        min,sec. 0's => all
C   Output:
C      START        R    Start time (days)
C      STOP         R    Stop time in days
C      IERR         I    Return code, 0=>OK, otherwise INDEX file
C                        exists but cannot be read.
C   Output to common /SELCAL/:
C      INXRNO       I    Current INDEX file record number.
C                        If .LT. 0 then there is no index file.
C      NINDEX       I    Number of entries in the index table
C      FSTVIS       I    First visibility number of current scan.
C      LSTVIS       I    Last visibility number of current scan.
C      CURSOU       I    Current source number.
C      NXKOLS(MAXNXC) I   The column pointer array in order, TIME,
C                         TIME INTERVAL, SOURCE ID, SUBARRAY, START VIS,
C                         END VIS., FREQID
C      NXNUMV(MAXNXC) I   Element count in each column.
C      NXBUFF(*)    I    TABIO buffer for INDEX table.
C   Usage notes:
C      Requires - UVPGET to have been called
C               - SOUFIL to have been called (multi-source)
C               - uv header in common /MAPHDR/ (I think)
C-----------------------------------------------------------------------
      REAL      START, STOP
      INTEGER   IERR
C
      INTEGER   JERR, J, NXIDSO, NXSUBA, NIO, INDEXT, IUBIND, I, NXSTA,
     *   NXEND, NREAD, BO, FRSRED, FREQID
      LOGICAL   T, F, MATCH, TABLE, EXIST, FITASC
      REAL      NXTIME, NXDTIM, T1, T2
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA BO /1/
C-----------------------------------------------------------------------
C                                       Timerange
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)).EQ.0.0)
     *   TIMRNG(1) = -1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)).EQ.0.0)
     *   TIMRNG(5) = 1.0E6
C                                       Set time range.
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
C                                       Initialize output
      INXRNO = -1
      FSTVIS = 1
      LSTVIS = CATUV(KIGCN)
      CURSOU = 0
      IXLUN = 30
C                                       See if NX file exists.
      CALL ISTAB ('NX', IUDISK, IUCNO, 1, IXLUN, NXBUFF, TABLE, EXIST,
     *   FITASC, JERR)
      IF ((JERR.NE.0) .OR. (.NOT.TABLE) .OR. (.NOT.EXIST)) GO TO 800
C                                       Open NX table
      CALL NDXINI ('READ', NXBUFF, IUDISK, IUCNO, 1, CATUV, IXLUN,
     *   INXRNO, NXKOLS, NXNUMV, JERR)
      IF (JERR.GT.0) THEN
         IERR = 1
         WRITE (MSGTXT,1000) 'OPEN', JERR
         GO TO 990
         END IF
C                                       Get number of scans
      NINDEX = NXBUFF(5)
C                                       Check if empty
      IF (NINDEX.LE.0) GO TO 800
      T2 = 1.E8
C                                       Locate first selected scan.
C                                       Loop through records
      DO 60 I = 1,NINDEX
         INXRNO = I
         IERR = 1
C                                       Read record.
         CALL TABNDX ('READ', NXBUFF, INXRNO, NXKOLS, NXNUMV,
     *      NXTIME, NXDTIM, NXIDSO, NXSUBA, NXSTA, NXEND, FREQID,
     *      IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) 'READ', IERR
            GO TO 990
            END IF
         IERR = 0
C                                       Check time range.
         IF (TSTART.GT.(NXTIME+NXDTIM/2.0)) GO TO 60
C                                       Check freq id
         IF ((FREQID.NE.FRQSEL) .AND. (FRQSEL.GT.0)) GO TO 60
C                                       Set values
         FSTVIS = NXSTA
         LSTVIS = NXEND
         IF (FSTVIS.LT.1) FSTVIS = 1
         IF (LSTVIS.LT.1) LSTVIS = 1
         CURSOU = NXIDSO
C                                       See if all sources selected.
         IF (NSOUWD.LE.0) GO TO 100
C                                       Search source lists
         MATCH = F
         DO 40 J = 1,NSOUWD
            MATCH = NXIDSO.EQ.SOUWAN(J)
            IF (MATCH) GO TO 50
 40         CONTINUE
C                                       See if found match
 50      IF ((MATCH.AND.DOSWNT) .OR. ((.NOT.MATCH).AND.(.NOT.DOSWNT)))
     *    GO TO 100
 60      CONTINUE
C                                       No valid data
      IERR = 5
      MSGTXT = 'TBTIME: NO DATA FOUND MEETING SELECTION CRITERIA'
      GO TO 990
C                                       return start time
 100  START = NXTIME - 0.51 * NXDTIM
      T1 = NXTIME
      IF (TSTART.GT.START) START = TSTART
      STOP = NXTIME + 0.51 * NXDTIM
      IF (STOP.GT.TEND) STOP = TEND
      INDEXT = I + 1
C                                       Get last included one
      IF (INDEXT.LE.NINDEX) THEN
         DO 160 I = INDEXT,NINDEX
            INXRNO = I
            IERR = 1
C                                       Read record.
            CALL TABNDX ('READ', NXBUFF, INXRNO, NXKOLS, NXNUMV,
     *         NXTIME, NXDTIM, NXIDSO, NXSUBA, NXSTA, NXEND, FREQID,
     *         IERR)
            IF (IERR.GT.0) THEN
               WRITE (MSGTXT,1000) 'READ', IERR
               GO TO 990
               END IF
            T2 = MIN (T2, NXTIME)
            IERR = 0
C                                       Check time range.
            IF ((NXTIME-NXDTIM/2.).GT.TEND) GO TO 160
C                                       Freq id
            IF ((FREQID.NE.FRQSEL) .AND. (FRQSEL.GT.0)) GO TO 160
C                                       See if all sources selected.
            IF (NSOUWD.LE.0) GO TO 150
C                                       Search source lists
            MATCH = F
            DO 130 J = 1,NSOUWD
               MATCH = NXIDSO.EQ.SOUWAN(J)
               IF (MATCH) GO TO 140
 130           CONTINUE
C                                       See if found match
 140        IF (((MATCH) .AND. (.NOT.DOSWNT)) .OR. ((.NOT.MATCH) .AND.
     *         (DOSWNT))) GO TO 160
C                                       matches: save value
 150        STOP = NXTIME + 0.51 * NXDTIM
            IF (STOP.GT.TEND) STOP = TEND
 160        CONTINUE
         END IF
      CALL TABIO ('CLOS', 0, INXRNO, UBUFF, NXBUFF, IERR)
      IF (T2.LT.T1) THEN
         MSGTXT = 'TIMES OUT OF ORDER'
         IERR = 10
         GO TO 990
         END IF
      GO TO 999
C                                       No INDEX file
 800  INXRNO = -1
      FSTVIS = 1
      LSTVIS = CATUV(KIGCN)
      CURSOU = 0
      NINDEX = 0
      NXBUFF(5) = NINDEX
C                                       open uv file
      IULUN = 25
C                                       Open UV file
      CALL ZPHFIL ('UV', IUDISK, IUCNO, 1, UFILE, IERR)
      CALL ZOPEN (IULUN, IUFIND, IUDISK, UFILE, T, F, T, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1800) 'OPEN', IERR
         GO TO 990
         END IF
C                                       Init I/O to uvfile
      NREAD = 1
      LRECIN = LREC
      UBUFSZ = UVBFSL * 2
C                                       read first vis
      FRSRED = FSTVIS - 1
      CALL UVINIT ('READ', IULUN, IUFIND, NREAD, FRSRED, LRECIN, 1,
     *   UBUFSZ, UBUFF, BO, IUBIND, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1810) 'INIT FIRST', IERR
         GO TO 980
         END IF
      CALL UVDISK ('READ', IULUN, IUFIND, UBUFF, NIO, IUBIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1810) 'READ FIRST', IERR
         GO TO 980
         END IF
      T1 = UBUFF(IUBIND+ILOCT)
      START = T1
      IF (START.LT.TSTART) START = TSTART
C                                       read last vis
      FRSRED = LSTVIS - 1
      CALL UVINIT ('READ', IULUN, IUFIND, NREAD, FRSRED, LRECIN, 1,
     *   UBUFSZ, UBUFF, BO, IUBIND, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1810) 'INIT LAST', IERR
         GO TO 980
         END IF
      CALL UVDISK ('READ', IULUN, IUFIND, UBUFF, NIO, IUBIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1810) 'READ LAST', IERR
         GO TO 980
         END IF
      T2 = UBUFF(IUBIND+ILOCT)
      STOP = T2
      IF (STOP.GT.TEND) STOP = TEND
      IF (T2.LT.T1) THEN
         MSGTXT = 'TIMES OUT OF ORDER'
         IERR = 10
      ELSE
         GO TO 985
         END IF
C                                       Errors
 980  CALL MSGWRT (8)
 985  CALL ZCLOSE (IULUN, IUFIND, JERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TBTIME: ERROR',I3,' ',A,'ING INDEX TABLE')
 1800 FORMAT ('TBTIME: UNABLE TO ',A,' INPUT UV FILE, ERROR',I5)
 1810 FORMAT ('TBTIME: UNABLE TO ',A,' INPUT VISIBILITY RECORD, ERROR',
     *   I5)
      END

LOCAL INCLUDE 'ACIMG.INC'
C                                       Local include for ACIMG
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
C
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMEO(3), XCLAOU(2), XSOUR(4,30),
     *   XCALC, XSTOK
      REAL      XSIN, XDISIN, XSOU, XDISOU, XANT(50), TIMER(8),
     *   BPARM(10), XQUAL, XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF,
     *   XBCHAN, XECHAN, XCHAVG, XDOCAL, XGUSE, XDOPOL, XPDVER,
     *   XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH(3), BADD(10)
      DOUBLE PRECISION FOFF(MAXIF), DXC, DYC, DZC, RAS, DECS, OFREQ,
     *   FREQS(16384)
      REAL      BUFF1(UVBFSS), TBEG, TFIN, FRPIX, TAVG, FINC(MAXIF)
      CHARACTER NAMEIN*12, CLAIN*6, NAMEOU*12, CLAOU*6
      INTEGER   SEQIN, DISKIN, SEQOU, DISKOU, LUNI, INDI, JBUFSZ,
     *   NPARMS, NCHAVG, FREQID, KNCS, KNCF, KNCIF, CATOLD(256),
     *   IANT1, IANT2
      LOGICAL   ISFREQ
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMEO, XCLAOU,
     *   XSOU, XDISOU, XANT, TIMER, XSTOK, BPARM, XSOUR, XQUAL, XCALC,
     *   XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF, XBCHAN, XECHAN, XCHAVG,
     *   XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER,
     *   XSMOTH, BADD
      COMMON /BUFRS/ BUFF1, JBUFSZ
      COMMON /FTPCOM/ FOFF, CATOLD, FREQS, OFREQ, DXC, DYC, DZC, RAS,
     *   DECS, FINC, TBEG, TFIN, TAVG, FRPIX, ISFREQ, SEQIN, DISKIN,
     *   LUNI, INDI, NPARMS, FREQID, KNCS, KNCF, KNCIF, SEQOU, DISKOU,
     *   NCHAVG, IANT1, IANT2
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMEOU, CLAOU
C                                                          End ACIMG.
LOCAL END
      PROGRAM ACIMG
C-----------------------------------------------------------------------
C! images autocorrelation data as a function of time and frequency
C# UV Analysis
C-----------------------------------------------------------------------
C;  Copyright (C) 2020-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ACIMG creates an image file to display the DFT of the visibilities
C   for an arbitrary position in the sky.  Plots resulting flux on
C   frequency and time axes.
C   NOTE 1: ACIMG wants the first key of the sort order of the UV data
C           base to be TIME.
C   Inputs:
C     INNAME         NAMEIN        Name of input UV data.
C     INCLASS        CLAIN         Class of input UV data.
C     INSEQ          SEQIN         Seq. of input UV data.
C     INDISK         DISKIN        Disk number of input VU data.
C     ANTENNAS       XANT          antennas included
C     BPARM......Control parameters:
C        2 = averaging interval in sec
C        3 = write weight image
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   NX, NY, NZ, NWORDS, IRET
      REAL      IMAGE(2), ERROR(2), WEIGHT(2)
      LONGINT   PIMAGE, PERROR, PWEIGH
      INCLUDE 'ACIMG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'ACIMG '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL ACIMGI (PRGM, NX, NY, NZ, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       allocate image
      NWORDS = (NX * NY * NZ - 1) / 1024 + 4
      CALL ZMEMRY ('GET ', PRGM, NWORDS, IMAGE, PIMAGE, IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', PRGM, NWORDS, ERROR, PERROR,
     *   IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', PRGM, NWORDS, WEIGHT, PWEIGH,
     *   IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'FAILED TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 995
         END IF
C                                       Do DFT's
      CALL ACIMGC (NX, NY, NZ, IMAGE(1+PIMAGE), ERROR(1+PERROR),
     *   WEIGHT(1+PWEIGH), IRET)
      IF (IRET.NE.0) GO TO 995
C                                       output
      CALL ACIMGO (NX, NY, NZ, IMAGE(1+PIMAGE), ERROR(1+PERROR), IRET)
C                                       Close down
 995  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE ACIMGI (PRGM, NX, NY, NZ, JERR)
C-----------------------------------------------------------------------
C   ACIMGI gets input parameters for ACIMG .
C   Inputs:
C      PRGM    C*6    Program name
C   Output:
C      NX      I      Number spectral channels
C      NY      I      Number of times
C      NZ      I      Number of antennas
C      JERR    I      Error code: 0 => ok, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   NX, NY, NZ, JERR
C
      INCLUDE 'ACIMG.INC'
      CHARACTER BNDCOD(MAXIF)*8, CSTOK(12)*4
      INTEGER   OLDCNO, IUSER, I, IERR, IROUND, FQVER, NIF, CHBUFF(512),
     *   ISBAND(MAXIF), LUNCH, LF, LC, IC
      REAL      CATR(256), RPARM(20)
      LOGICAL   T
      DOUBLE PRECISION CATD(128), DFREQ, DFREQS
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (CATBLK, CATR, CATD)
      DATA T /.TRUE./
      DATA CSTOK /'RR', 'LL', 'RL', 'LR', 'VV', 'HH', 'VH', 'HV', 'I',
     *   'Q', 'U', 'V'/
C-----------------------------------------------------------------------
C                                       Init IO et al.
      CALL ZDCHIN (T, BUFF1)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARMS = 235
      CALL GTPARM (PRGM, NPARMS, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         JERR = 8
         RQUICK = .TRUE.
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR, 'GETTING USER ADVERB VALUES'
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      IUSER = NLUSER
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      SEQOU = IROUND (XSOU)
      DISKOU = IROUND (XDISOU)
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMEO, NAMEOU)
      CALL H2CHR (6, 1, XCLAOU, CLAOU)
      CALL H2CHR (4, 1, XSTOK, STOKES)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      DO 5 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 5       CONTINUE
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      NCHAVG = XCHAVG + 0.1
      NCHAVG = MAX (1, NCHAVG)
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = .FALSE.
      CALL RCOPY (8, TIMER, TIMRNG)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
      BCHAN = XBCHAN
      ECHAN = XECHAN
      BIF = XBIF
      EIF = XEIF
      DO 15 I = 1,50
         ANTENS(I) = IROUND (XANT(I))
 15      CONTINUE
      CALL ANTFND (ANTENS, NANTSL, DOAWNT)
      DOACOR = .TRUE.
      DOXCOR = .FALSE.
C                                       Get CATBLK from UVGET
      CALL UVGET ('INIT', RPARM, BUFF1, IERR)
      IF (IERR.LT.0) THEN
         MSGTXT = 'INITIAL UVGET RETURNS NO DATA FOUND'
         GO TO 980
      ELSE IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INITIAL UVGET CALL'
         GO TO 980
         END IF
C                                       save adverbs
      XSIN = IUSEQ
      XDISIN = IUDISK
      CALL CHR2H (12, UNAME, 1, XNAMEI)
      CALL CHR2H (6, UCLAS, 1, XCLAIN)
      OLDCNO = IUCNO
      NCHAVG = MIN (NCHAVG, ECHAN-BCHAN+1)
      NX = (ECHAN - BCHAN + 1) / NCHAVG
      ECHAN = BCHAN - 1 + NX * NCHAVG
      NX = NX * (EIF - BIF + 1)
      XBCHAN = BCHAN
      XECHAN = ECHAN
      XBIF = BIF
      XEIF = EIF
      XSUBA = SUBARR
      CALL UVGET ('CLOS', RPARM, BUFF1, IERR)
      IF (NCFILE.LE.0) THEN
         NCFILE = 1
         FVOL(NCFILE) = IUDISK
         FCNO(NCFILE) = IUCNO
         FRW(NCFILE) = 0
         END IF
      CALL COPY (256, CATUV, CATBLK)
      CALL COPY (256, CATUV, CATOLD)
C                                       Get start/stop times
      CALL TBTIME (TBEG, TFIN, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FINDING START AND STOP TIMES'
         GO TO 980
         END IF
C                                       set bin count, T averaging
      IF (BPARM(2).LE.0.001) BPARM(2) = 60.0
      TAVG = BPARM(2) / 86400.
      NY = (TFIN - TBEG) / TAVG + 1.5
C                                       number antennas
      IF ((NANTSL.GT.0) .AND. (DOAWNT)) THEN
         IANT1 = MAXANT
         IANT2 = 0
         DO 20 I = 1,NANTSL
            IANT1 = MIN (IANT1, ANTENS(I))
            IANT2 = MAX (IANT2, ANTENS(I))
 20         CONTINUE
      ELSE
         CALL GETANT (IUDISK, IUCNO, SUBARR, CATUV, BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READING ANTENNA INFORMATION'
            GO TO 980
            END IF
         IANT1 = 1
         IANT2 = NSTNS
         END IF
      NZ = IANT2 - IANT1 + 1
      RAS = RA
      DECS = DEC
C                                       Sort order OK ?
      IF (ISORT(:1).NE.'T') THEN
         MSGTXT = 'FIRST KEY OF SORT ORDER MUST BE TIME !!'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 999
         END IF
C                                       Frequency and bandwidth
      IF (JLOCIF.LT.0) THEN
         FOFF(1) = 0.0D0
         FINC(1) = CATR(KRCIC+JLOCF)
      ELSE
         FQVER = 1
         LUNCH = 87
         CALL CHNDAT ('READ',  CHBUFF, DISKIN, OLDCNO, FQVER, CATBLK,
     *      LUNCH, NIF, FOFF, ISBAND, FINC, BNDCOD, FREQID, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR
            CALL MSGWRT (7)
            JERR = 1
            GO TO 999
            END IF
         END IF
      OFREQ = CATD(KDCRV+JLOCF)
      FRPIX = CATR(KRCRP+JLOCF)
C                                       compute frequency array
      IC = 0
      ISFREQ = .TRUE.
      DO 40 LF = BIF,EIF
         DO 30 LC = BCHAN,ECHAN,NCHAVG
            IC = IC + 1
            FREQS(IC) = FOFF(LF) + FINC(LF) * (LC + (NCHAVG-1.0)/2.0 -
     *         FRPIX)
            IF (IC.EQ.2) THEN
               DFREQ = FREQS(2) - FREQS(1)
               DFREQS = ABS(DFREQ) / 100.0D0
            ELSE IF (IC.GT.2) THEN
               IF (ABS(FREQS(IC)-FREQS(IC-1)-DFREQ).GT.DFREQS)
     *            ISFREQ = .FALSE.
               END IF
 30         CONTINUE
 40      CONTINUE
      IF (ISFREQ) THEN
         MSGTXT = 'Freqencies on a fixed grid, will use FREQ axis'
      ELSE
         MSGTXT = 'Frequencies not all on same grid, FQ axis needed'
         END IF
      CALL MSGWRT (2)
C                                       Update catalog header.
      FRW(NCFILE) = 0
      JERR = 0
C                                       Check correlator display
      DO 50 I = 1,12
         IF (STOKES.EQ.CSTOK(I)) THEN
            BPARM(1) = I
            GO TO 999
            END IF
 50      CONTINUE
C                                       Stokes unavailable
      WRITE (MSGTXT,1900) STOKES
      JERR = 1
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ACIMGI: ERROR',I3,' ON ',A)
 1050 FORMAT ('ERROR',I5,' READING FREQUENCIES WITH CHNDAT')
 1900 FORMAT ('REQUESTED STOKES PARAMETER ''',A,''' NOT ALLOWED')
      END
      SUBROUTINE ACIMGC (NX, NY, NZ, IMAGE, ERROR, WEIGHT, IRET)
C-----------------------------------------------------------------------
C   ACIMGC accumlates the flux density for each averaging interval as
C   well as an estimate of the error. Also sets scaling for later use.
C   Inputs:
C      NX      I      X pixels in image
C      NY      I      Number of times
C      NZ      I      Number of antennas
C   Output:
C      IMAGE   R(*)   DFT image
C      ERROR   R(*)   Error estimate
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, IRET
      REAL      IMAGE(NX,NY,*), ERROR(NX,NY,*), WEIGHT(NX,NY,*)
C
      INCLUDE 'ACIMG.INC'
      INTEGER   FLAG, NUMVIS, XUMVIS, I, IA1, IA2, IA, IY
      REAL      VIS(UVBFSS), RPARM(20)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C                                       Set up binning
      I = NX * NY * NZ
      CALL RFILL (I, 0.0, IMAGE)
      CALL RFILL (I, 0.0, ERROR)
      CALL RFILL (I, 0.0, WEIGHT)
C                                       Init vis file for read.
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT UV IO'
         GO TO 990
         END IF
      NUMVIS = 0
      XUMVIS = 0
      KNCS = INCS
      KNCF = INCF
      KNCIF = INCIF
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING UV DATA'
         GO TO 990
      ELSE IF (IRET.EQ.0) THEN
C                                       Is this a valid point ?
         CALL WANTED (RPARM, VIS, FLAG)
C                                       there is data
         IF (FLAG.EQ.0) THEN
            IY = (RPARM(1+ILOCT) - TBEG) / TAVG + 0.001
            IF ((IY.GE.1) .AND. (IY.LE.NY)) THEN
               IF (ILOCB.GE.0) THEN
                  IA1 = INT (RPARM(ILOCB+1)) / 256
                  IA2 = MOD (INT (RPARM(ILOCB+1)), 256)
               ELSE
                  IA1 = RPARM(ILOCA1+1) + 0.1
                  IA2 = RPARM(ILOCA2+1) + 0.1
                  END IF
C                                       Good point
               IF ((IA1.EQ.IA2) .AND. (IA1.GE.IANT1) .AND.
     *            (IA2.LE.IANT2)) THEN
                  IA = IA1 - IANT1 + 1
                  CALL DOIMG (FLAG, VIS, NX, NY, NZ, IY, IA, IMAGE,
     *               ERROR, WEIGHT, IRET)
                  XUMVIS = XUMVIS + 1
                  END IF
               END IF
            END IF
         GO TO 100
         END IF
C                                       Any valid points
      IF (XUMVIS.LE.1) THEN
         IRET = 4
         WRITE (MSGTXT,1200) XUMVIS
         GO TO 990
      ELSE
         WRITE (MSGTXT,1201) XUMVIS
         CALL MSGWRT (3)
         END IF
      FLAG = 2
      CALL DOIMG (FLAG, VIS, NX, NY, NZ, IY, IA, IMAGE, ERROR, WEIGHT,
     *   IRET)
C                                       close UV data
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ACIMGC: ERROR',I3,' ON ',A)
 1200 FORMAT ('FOUND',I5,' POINTS: NOT VERY INTERESTING')
 1201 FORMAT ('Found',I10,' data samples')
      END
      SUBROUTINE WANTED (RPBUF, VIS, FLAG)
C-----------------------------------------------------------------------
C   WANTED determines whether the current visibility sample is valid
C   and selected via the selection parameters.
C   Inputs:
C      RPBUF   R(*)   Random parameters
C      VIS     R(*)   Visibilities
C   Outputs:
C      FLAG    I      0 => data selected as good
C                     1    data NO GOOD
C-----------------------------------------------------------------------
      REAL      RPBUF(*), VIS(*)
      INTEGER   FLAG
C
      INTEGER   LAD, IIF, ICH, IROUND
      LOGICAL   GOOD, ANY
      INCLUDE 'ACIMG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
      FLAG = 1
C                                       Check FREQID
      IF (ILOCFQ.GE.0) THEN
         IIF = IROUND (RPBUF(1+ILOCFQ))
         IF ((FREQID.GT.0) .AND. (IIF.GT.0) .AND. (IIF.NE.FREQID))
     *      GO TO 999
         END IF
C                                       Are data flagged?
      ANY = .FALSE.
      DO 20 IIF = BIF,EIF
         DO 10 ICH = BCHAN,ECHAN
            LAD = 1 + (IIF-BIF)*KNCIF + (ICH-BCHAN)*KNCF
            GOOD = VIS(LAD+2).GT.0.0
            ANY = ANY .OR. GOOD
 10         CONTINUE
 20      CONTINUE
      IF (.NOT.ANY) GO TO 999
      FLAG = 0
C
 999  RETURN
      END
      SUBROUTINE DOIMG (FLAG, VIS, NX, NY, NZ, IY, IA, IMAGE, ERROR,
     *   WEIGHT, IRET)
C-----------------------------------------------------------------------
C   DODFT computes the DFT for a given set of visibilities with the
C   proper sky offset applied.
C   Inputs:
C      FLAG     I      If 0, continue summing DFT
C                      If 2, wrap it up, clear
C      VIS      R(*)   one visibility record - data
C      NX       I      Number of frequencies
C      NY       I      Number of times
C      NZ       I      Number of antennas
C      IY       I      row number in images
C      IA       I      plane number
C   In/out
C      IMAGE    R(*)   image
C      ERROR    R(*)   error
C      WEIGHT   R(*)   weight
C   Outputs:
C      IRET     I      0 => operation sucessful
C                      1 => trouble
C                      -1 => no data to average
C-----------------------------------------------------------------------
      INTEGER   FLAG, NX, NY, NZ, IY, IA, IRET
      REAL      VIS(*), IMAGE(NX,NY,*), ERROR(NX,NY,*), WEIGHT(NX,NY,*)
C
      REAL      TR, SMN, WT, DELS
      INTEGER   IIF, ICH, TAMP, LAD, IX, LCH, LY, LZ
      INCLUDE 'ACIMG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       loop over IF and channel
      IF (FLAG.EQ.0) THEN
         IX = 0
         DO 50 IIF = BIF,EIF
            DO 40 ICH = BCHAN,ECHAN,NCHAVG
               IX = IX + 1
               DO 30 LCH = ICH,ICH+NCHAVG-1
                  LAD = 1 + (LCH-BCHAN)*KNCF + (IIF-BIF)*KNCIF
C                                       Find visibilities and weights
                  IF (VIS(LAD+2).GT.0.0) THEN
                     TR = VIS(LAD)
                     WT = VIS(LAD+2)
C                                       sum it up
                     IMAGE(IX,IY,IA) = IMAGE(IX,IY,IA) + WT * TR
                     ERROR(IX,IY,IA) = ERROR(IX,IY,IA) + WT * TR * TR
                     WEIGHT(IX,IY,IA) = WEIGHT(IX,IY,IA) + WT
                     END IF
 30               CONTINUE
 40            CONTINUE
 50         CONTINUE
C                                      Finish up full image
      ELSE
         IRET = -1
         DO 90 LZ = 1,NZ
            DO 80 LY = 1,NY
               DO 70 IX = 1,NX
                  IF (WEIGHT(IX,LY,LZ).GT.0.0) THEN
                     SMN = IMAGE(IX,LY,LZ) / WEIGHT(IX,LY,LZ)
                     DELS = ERROR(IX,LY,LZ) / WEIGHT(IX,LY,LZ) - SMN*SMN
                     DELS = SQRT (MAX (0.0, DELS))
                     IMAGE(IX,LY,LZ) = SMN
                     ERROR(IX,LY,LZ) = DELS / SQRT (MAX (1.0, TAMP-1.))
                     IRET = 0
                  ELSE
                     IMAGE(IX,LY,LZ) = FBLANK
                     ERROR(IX,LY,LZ) = FBLANK
                     END IF
 70               CONTINUE
 80            CONTINUE
 90         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE ACIMGO (NX, NY, NZ, IMAGE, ERROR, IRET)
C-----------------------------------------------------------------------
C   ACIMGO constructs an image header and writes out the waterfall
C   image and possibly the error as well
C   Inputs:
C      NX      I      Number of frequencies
C      NY      I      Number of times
C      NZ      I      Number of antennas
C      IMAGE   R(*)   Image(NX,NY,NZ)
C      ERROR   R(*)   Error(NX,NY,NZ)
C   Outputs:
C      IRET    I      Error condition
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, IRET
      REAL      IMAGE(NX,NY,*), ERROR(NX,NY,*)
C
      INCLUDE 'ACIMG.INC'
      INTEGER   IX, IY, IZ, I, J, SLOT, LUNO, INDO, BIND, WIN(4), BOI,
     *   IDEPTH(5)
      REAL      BMIN, BMAX, CATOR(256), CATR(256)
      LOGICAL   WASBLK
      DOUBLE PRECISION CATOD(128), CATD(128)
      HOLLERITH CATOH(256), CATH(256)
      CHARACTER PHNAME*48
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      EQUIVALENCE (CATOLD, CATOD, CATOR, CATOH)
      DATA LUNO /39/
C-----------------------------------------------------------------------
C                                       make up a header
      CALL COPY (256, CATOLD, CATBLK)
      CALL UVPGET (IRET)
C
      CALL CHR2H (8, 'JY      ', 1, CATH(KHBUN))
C                                       random parameters
      J = KHPTP
      I = 2 * KIPTPN
      CALL RFILL (I, HBLANK, CATH(J))
C                                       axis parameters
      DO 20 I = 1,KICTPN
         J = I - 1
         CALL RFILL (2, HBLANK, CATH(KHCTP+2*J))
         CATR(KRCIC+J) = 1.0
         CATR(KRCRP+J) = 1.0
         CATBLK(KINAX+J) = 1
 20      CONTINUE
      CATBLK(KIGCN) = 0
      CATBLK(KIPCN) = 0
C                                       extensions
      CALL CATCLR (CATBLK)
C                                       now details
      CATBLK(KINAX) = NX
      IF (ISFREQ) THEN
         CATBLK(KIDIM) = 4
         CALL CHR2H (8, 'FREQ    ', 1, CATH(KHCTP))
         CATD(KDCRV) = OFREQ + FREQS(1)
         CATR(KRCIC) = FREQS(2) - FREQS(1)
      ELSE
         CATBLK(KIDIM) = 5
         CALL CHR2H (8, 'FQID    ', 1, CATH(KHCTP))
         CATD(KDCRV) = 1.0D0
         CALL CHR2H (8, 'FREQ    ', 1, CATH(KHCTP+8))
         CATBLK(KINAX+4) = 1
         CATD(KDCRV+4) = OFREQ
         CATR(KRCIC+4) = FINC(1)
         END IF
      CALL CHR2H (8, 'TIME    ', 1, CATH(KHCTP+2))
      CATBLK(KINAX+1) = NY
      CATD(KDCRV+1) = TBEG + TAVG/2.0
      CATR(KRCIC+1) = TAVG
      CALL CHR2H (8, 'ANTENNA ', 1, CATH(KHCTP+4))
      CATBLK(KINAX+2) = NZ
      CATD(KDCRV+2) = IANT1
      CALL CHR2H (8, 'STOKES  ', 1, CATH(KHCTP+6))
      CATBLK(KINAX+3) = 1
      J = BPARM(1) + 0.1
      IF (J.LE.8) THEN
         CATD(KDCRV+3) = -J
         CATR(KRCIC+3) = -1.0
      ELSE
         CATD(KDCRV+3) = J - 8
         CATR(KRCIC+3) = 1.0
         END IF
      IF ((JLOCR.GE.0) .AND. (JLOCD.GE.0) .AND. (RAS.NE.0.0D0) .AND.
     *   (DECS.NE.0.0D0)) THEN
         J = CATBLK(KIDIM)
         CATBLK(KIDIM) = J + 2
         CALL CHR2H (8, 'RA---SIN', 1, CATH(KHCTP+2*J))
         CALL CHR2H (8, 'DEC--SIN', 1, CATH(KHCTP+2*J+2))
         CATR(KRCIC+J) = 0.0
         CATR(KRCIC+J+1) = 0.0
         CATD(KDCRV+J) = RAS
         CATD(KDCRV+J+1) = DECS
         END IF
      IF (NAMEOU.EQ.' ') NAMEOU = NAMEIN
      IF (CLAOU.EQ.' ') CLAOU = TSKNAM
      CALL CHR2H (12, NAMEOU, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOU, KHIMCO, CATH(KHIMN))
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHIMN))
      CATBLK(KIIMS) = SEQOU
      CALL MCREAT (DISKOU, SLOT, BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATE OUTPUT IMAGE FILE'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKOU
      FCNO(NCFILE) = SLOT
      FRW(NCFILE) = 2
C                                       start IO
      CALL ZPHFIL ('MA', DISKOU, SLOT, 1, PHNAME, IRET)
      CALL ZOPEN (LUNO, INDO, DISKOU, PHNAME, .TRUE., .TRUE., .TRUE.,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT IMAGE'
         GO TO 990
         END IF
      WASBLK = .FALSE.
      BMIN = 1.E10
      BMAX = -BMIN
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NX
      WIN(4) = NY
      CALL FILL (5, 1, IDEPTH)
      DO 50 IZ = 1,NZ
         IDEPTH(1) = IZ
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH, BOI, IRET)
         BOI = BOI + 1
         CALL MINIT ('WRIT', LUNO, INDO, NX, NY, WIN, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT I/O TO OUTPUT IMAGE'
            GO TO 990
            END IF
         DO 40 IY = 1,NY
            CALL MDISK ('WRIT', LUNO, INDO, BUFF1, BIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT IMAGE'
               GO TO 990
               END IF
            DO 30 IX = 1,NX
               IF (IMAGE(IX,IY,IZ).EQ.FBLANK) THEN
                  WASBLK = .TRUE.
               ELSE
                  BMIN = MIN (BMIN, IMAGE(IX,IY,IZ))
                  BMAX = MAX (BMAX, IMAGE(IX,IY,IZ))
                  END IF
               BUFF1(BIND+IX-1) = IMAGE(IX,IY,IZ)
 30            CONTINUE
 40         CONTINUE
         CALL MDISK ('FINI', LUNO, INDO, BUFF1, BIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'FINISH WRITING OUTPUT IMAGE'
            GO TO 990
            END IF
 50      CONTINUE
      CALL ZCLOSE (LUNO, INDO, IRET)
      CATR(KRDMX) = BMAX
      CATR(KRDMN) = BMIN
      CATR(KRBLK) = 0.0
      IF (WASBLK) CATR(KRBLK) = FBLANK
C                                       history
      CALL ACIMGH (NX, DISKOU, SLOT, IUCNO, IRET)
C                                       error image
      IF (BPARM(3).GT.0.0) THEN
         CLAOU = 'AC err'
         CALL CHR2H (6, CLAOU, KHIMCO, CATH(KHIMN))
         CATBLK(KIIMS) = SEQOU
         CALL MCREAT (DISKOU, SLOT, BUFF1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATE ERROR IMAGE FILE'
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKOU
         FCNO(NCFILE) = SLOT
         FRW(NCFILE) = 2
C                                       start IO
         CALL ZPHFIL ('MA', DISKOU, SLOT, 1, PHNAME, IRET)
         CALL ZOPEN (LUNO, INDO, DISKOU, PHNAME, .TRUE., .TRUE., .TRUE.,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING ERROR IMAGE'
            GO TO 990
            END IF
         WASBLK = .FALSE.
         BMIN = 1.E10
         BMAX = -BMIN
         WIN(1) = 1
         WIN(2) = 1
         WIN(3) = NX
         WIN(4) = NY
         DO 90 IZ = 1,NZ
            IDEPTH(1) = IZ
            CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH, BOI,
     *         IRET)
            BOI = BOI + 1
            CALL MINIT ('WRIT', LUNO, INDO, NX, NY, WIN, BUFF1, JBUFSZ,
     *         BOI, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'INIT I/O TO ERROR IMAGE'
               GO TO 990
               END IF
            DO 80 IY = 1,NY
               CALL MDISK ('WRIT', LUNO, INDO, BUFF1, BIND, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITING ERROR IMAGE'
                  GO TO 990
                  END IF
               DO 70 IX = 1,NX
                  IF (ERROR(IX,IY,IZ).EQ.FBLANK) THEN
                     WASBLK = .TRUE.
                  ELSE
                     BMIN = MIN (BMIN, ERROR(IX,IY,IZ))
                     BMAX = MAX (BMAX, ERROR(IX,IY,IZ))
                     END IF
                  BUFF1(BIND+IX-1) = ERROR(IX,IY,IZ)
 70               CONTINUE
 80            CONTINUE
            CALL MDISK ('FINI', LUNO, INDO, BUFF1, BIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'FINISH WRITING ERROR IMAGE'
               GO TO 990
               END IF
 90         CONTINUE
         CALL ZCLOSE (LUNO, INDO, IRET)
         CATR(KRDMX) = BMAX
         CATR(KRDMN) = BMIN
         CATR(KRBLK) = 0.0
         IF (WASBLK) CATR(KRBLK) = FBLANK
C                                       history
         CALL ACIMGH (NX, DISKOU, SLOT, IUCNO, IRET)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ACIMGO: ERROR',I4,' ON ',A)
      END
      SUBROUTINE ACIMGH (NX, DISK, CNO, INCNO, IRET)
C-----------------------------------------------------------------------
C   writes history to ACIMG
C   Inputs:
C      DISK   I   Disk number
C      CNO    I   Catalog number of output image
C   Output
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   NX, DISK, CNO, INCNO, IRET
C
      INCLUDE 'ACIMG.INC'
      INTEGER   LUN1, LUN2, IBUFF(256), OBUFF(256), I, VER, NI,
     *   FQID, IFSIDE, LF, LC
      CHARACTER HILINE*72, CLASS*6, BNDCOD*8
      DOUBLE PRECISION IFFREQ
      REAL      IFCHW, IFTBW
      HOLLERITH CATH(256)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (CATBLK, CATH)
      DATA LUN1, LUN2 / 45,46/
C-----------------------------------------------------------------------
C                                       Initialize HITAB
      CALL HIINIT (3)
C                                       Create and copy history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISK, INCNO, CNO, CATBLK, IBUFF,
     *   OBUFF, IRET)
      IF (IRET.GT.3) GO TO 999
      IF (IRET.EQ.3) GO TO 100
C                                       Add SUBIM history.
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, OBUFF,
     *   IRET)
      IF (IRET.NE.0) GO TO 100
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), CLASS)
      CALL HENCOO (TSKNAM, NAMEOU, CLASS, CATBLK(KIIMS), DISK, LUN2,
     *   OBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       NCHAVG
      WRITE (HILINE,2001) TSKNAM, NCHAVG
      CALL HIADD (LUN2, HILINE, OBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       cal adverbs
      CALL CALHIS (LUN2, OBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       close
 100  CALL HICLOS (LUN2, .TRUE., OBUFF, I)
C                                       write FQ table
      IF (.NOT.ISFREQ) THEN
         VER = 1
         NI = 1
         CALL FQINI ('WRIT', FQBUFF, DISK, CNO, VER, CATBLK, LUN1,
     *      IFQRNO, FQKOLS, FQNUMV, NI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATING FQ TABLE'
            CALL MSGWRT (8)
            GO TO 200
            END IF
C                                       write
         IFSIDE = 1
         I = 0
         BNDCOD = ' '
         DO 120 LF = BIF,EIF
            DO 110 LC = BCHAN,ECHAN,NCHAVG
               I = I + 1
               IFQRNO = I
               IFFREQ = FREQS(I)
               FQID = I
               IFCHW = FINC(LF)*NCHAVG
               IFTBW = FINC(LF)*NCHAVG
               CALL TABFQ ('WRIT', FQBUFF, IFQRNO, FQKOLS, FQNUMV, NI,
     *            FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITING FQ TABLE'
                  CALL MSGWRT (8)
                  GO TO 200
                  END IF
 110           CONTINUE
 120        CONTINUE
         CALL TABFQ ('CLOS', FQBUFF, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *      FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, I)
         END IF
C
 200  CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'CLWR', IBUFF, I)
      IF (I.NE.0) THEN
         WRITE (MSGTXT,1000) I, 'ON UPDATE HEADER WITH CATIO'
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ACIMGH: ERROR',I4,' ON ',A)
 2001 FORMAT (A6,'NCHAVG=',I4,18X,'/ channels averaged')
      END

      SUBROUTINE ACINIT (ACTNAM, ACNPFR, ACNBPS, ACDELE, IERR)
C-----------------------------------------------------------------------
C! initialize accounting, and other, information
C# Service System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   This program makes the accounting initializations needed for a
C   stand-alone task using the AIPS data files, I/O system, message
C   logging, etc.
C-----------------------------------------------------------------------
      CHARACTER PRHSH1*12, PRHSH2*8, PRTEMP*80, ACNPFR*20, ACTNAM*6,
     *          PEN*4
      INTEGER   I, ACNBPS, XLNB, Q3(3), Q4(3), Q5(3), Q6(3), ACDELE,
     *          IERR, IPOL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (QWHRT1, Q3), (QWHRT2, Q4)
C-----------------------------------------------------------------------
      PRHSH1 = ' '
      PRHSH2 = ' '
      PRHSH1(3:3)='T'
      PRHSH2(1:1)='H'
      PRHSH1(2:2)='I'
      PRHSH1(1:1)='S'
      PRHSH2(4:4)=PRHSH1(3:3)
      PRHSH2(3:3)=PRHSH1(1:1)
      PRHSH2(2:2)='O'
      PRHSH1(4:4)='E'
      CALL ZTRLOG (4, PRHSH1, 80, PRTEMP, XLNB, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1992)
         GO TO 990
         END IF
      PRHSH1 = PRTEMP(1:12)
      CALL PASENC(PRHSH1, Q5)
      PRTEMP=' '
      CALL ZTRLOG (4, PRHSH2, 80, PRTEMP, XLNB, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1992)
         GO TO 990
         END IF
      PRHSH1 = PRTEMP(1:12)
      CALL PASENC(PRHSH1, Q6)
      IERR=0
      DO 100 I = 1,3
         IF (Q3(I).NE.Q5(I)) IERR=1
         IF (Q4(I).NE.Q6(I)) IERR=2
 100     CONTINUE
      IPOL = 0
      IF (QWHRT3(2).EQ.QWHRT3(1)) QWHRT3(2) = 0
      IF (QWHRT3(3).EQ.QWHRT3(1)) QWHRT3(3) = 0
      IF (QWHRT3(3).EQ.QWHRT3(2)) QWHRT3(3) = 0
      DO 200 I = 1,3
         CALL H2CHR(4, 1, QWHRT3(I), PEN)
         IF (PEN.EQ.RLSNAM(4:7)) IPOL = I
 200     CONTINUE
      IF (IPOL.EQ.0) IERR = 3
      IF (IERR.EQ.0) GOTO 999
 990  ACNPFR(6:6) = 'G'
      ACNPFR(2:2) = 'N'
      ACNPFR(1:1) = 'U'
      ACNPFR(4:4) = 'R'
      ACNPFR(5:5) = 'E'
      ACNPFR(13:13) = 'D'
      ACNPFR(7:7) = 'I'
      ACNPFR(8:8) = 'S'
      ACNPFR(9:9) = 'T'
      ACNPFR(3:3) = '-'
      ACNPFR(10:10) = ACNPFR(5:5)
      ACNPFR(12:12) = ACNPFR(5:5)
      ACNPFR(11:11) = ACNPFR(4:4)
      DO 991 I = 14,20
         ACNPFR(I:I) = '!'
 991  CONTINUE
 999  RETURN
C-----------------------------------------------------------------------
 1992 FORMAT ('ACINIT: Problems initializing Accounting information')
      END

      SUBROUTINE ZSTAI2 (IPOPS, IUSER, SCRTCH)
C-----------------------------------------------------------------------
C! does any system cleanup needed at the end of interactive AIPS session
C# Z2 System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZSTAI2 performs any operations needed to normalize the local
C   operating system at the conclusion of an interactive AIPS session.
C   Inputs:
C      IPOPS    I        POPS number of current AIPS
C      IUSER    I        User number of current AIPS
C   Outputs:
C      SCRTCH   I(256)   Scratch buffer
C   Generic version  - null routine, created to allow there to be a C
C   routine below ZSTAIP.
C-----------------------------------------------------------------------
      INTEGER   IPOPS, IUSER, SCRTCH(256)
C
C-----------------------------------------------------------------------
C                                       Nothing to do
C
 999  RETURN
      END

LOCAL INCLUDE 'UVFLG.INC'
C                                       Local include for UVFLG
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   XMXFLG, MXSOU
C                                       XMXFLG = max number of flags
      PARAMETER (XMXFLG = 40000, MXSOU = XSTBSZ)
      INTEGER   SEQ, DISK, LUN2, FIND2, FGVER, IERANT, NFLAG,
     *   FANT1(XMXFLG), FANT2(XMXFLG), FIFLIM(2,XMXFLG),
     *   FCHLIM(2,XMXFLG), FSUBA(XMXFLG), NID, ID(MXSOU), MXFLAG,
     *   NUMAN(513), CNOIN, BUFSZ, FRQSEL, FFQID(XMXFLG), NMESS, NOMIF,
     *   WFLAG, NECHO, KUAL, IBUFF(UVBFSS), IBUFF2(UVBFSS), CFLAG(4)
      LOGICAL   FFLAGS(4,XMXFLG), FSET, USEMSK, TABLE, MATCH, MULTI,
     *   ISCOMP, KFGRNO, ELEVAT, PULCAL, SHADOW, SUNDIS
      INTEGER   FCOUNT(XMXFLG), GCOUNT(XMXFLG)
      HOLLERITH XNAME(3), XCLASS(2), XINFIL(12), XXSOUR(4,30), XCALC(1),
     *   XSTOKE(1), XOPCOD(1), XREAS(6)
      CHARACTER NAME*12, CLASS*6, INFILE*48, XSOUR(30)*16, STOKES*4,
     *   OPCODE*4, REASON*24, REESON(XMXFLG)*24, CALKOD*4
      REAL      XSEQIN, XVIN, XQUAL, XSUBAR, XBAND, XFREQ, XFQID,
     *   TIMER(8), XBCHAN, XECHAN, XBIF, XEIF, XANTS(50), XBASE(50),
     *   XFGVER, APARM(10), DOHIST, BUFF(UVBFSS), BUFF2(UVBFSS),
     *   FLAGT1(XMXFLG), FLAGT2(XMXFLG), SELBAN
      DOUBLE PRECISION SELFRQ, JD0
      EQUIVALENCE (BUFF, IBUFF), (BUFF2, IBUFF2)
      INCLUDE 'INCS:DCAT.INC'
C
      COMMON /FLAGS/ FLAGT1, FLAGT2, FCOUNT, GCOUNT, FFLAGS, FSET,
     *   USEMSK, TABLE, KFGRNO, NOMIF, FANT1, FANT2, FIFLIM, FCHLIM,
     *   FSUBA, FFQID, NFLAG, MXFLAG, NID, ID, NUMAN, NMESS, IERANT,
     *   WFLAG, ELEVAT, PULCAL, SHADOW, SUNDIS, NECHO, KUAL, CFLAG
      COMMON /BUFRS/ BUFF, BUFF2, BUFSZ
      COMMON /INPARM/ XNAME, XCLASS, XSEQIN, XVIN, XINFIL, XXSOUR,
     *   XCALC, XQUAL, XSUBAR, XBAND, XFREQ, XFQID, TIMER, XBCHAN,
     *   XECHAN, XBIF, XEIF, XANTS, XBASE, XSTOKE, XFGVER, APARM,
     *   XOPCOD, XREAS, DOHIST
      COMMON /CHRCOM/ NAME, CLASS, INFILE, XSOUR, STOKES, OPCODE,
     *   REASON, REESON, CALKOD
      COMMON /FQCRAP/ JD0, SELFRQ, SELBAN, MATCH, SEQ, DISK, CNOIN,
     *   LUN2, FIND2, FGVER, FRQSEL, MULTI, ISCOMP
LOCAL END
      PROGRAM UVFLG
C-----------------------------------------------------------------------
C! Flag selected uv data
C# UV Calibration Editing
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2001, 2003, 2006-2012, 2014-2016, 2019,
C;  Copyright (C) 2021-2022, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task UVFLG flags selected portions of a uv data base.
C   Data either flagged directly or an entry is made in the flagging
C   table.
C   Inputs:
C      AIPS Adverb  Prg. Name      Description
C      INNAME       NAME        File name of data base to be flagged
C      INCLASS      CLASS       Input file class.
C      INSEQ        SEQ         Input file sequence number.
C      INDISK       DISK        Disk volumn on which file resides.
C      IN2NAME      NAME2       Name of run file with flag info.
C      SOURCES      XSOUR(4,30) Names of sources specified.
C      SUBARRAY     FSUBA       Subarray number
C      SELBAND      SELBAN      Bandwidth in FQ table
C      SELFREQ      SELFRQ      Freq in FQ table
C      FREQID       FFQID      Freq ID to flag
C      TIMERANG     TIMER(8)    Time range
C      BCHAN        BCHAN       First frequency channel
C      ECHAN        ECHAN       Last frequency channel
C      BIF          BIF         First IF
C      EIF          EIF         Last IF
C      ANTENNAS     ANTS(30)    Antenna specified
C      BASELINE     BASE(30)    Baselines
C      STOKES       STOK        Stokes parameter.'R','L','RL'
C      FLAGVER      FGVER       Flag file version.
C      OPCODE       OPCO        'FLAG' or 'UNFL' or 'REAS'
C      REASON       REAS(6)     Reason to flag data.
C   Revised to read tables from the RUN area, April 1984.
C   Revised to use flagging tables June 1985.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'UVFLG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA PRGM /'UVFLG '/
C-----------------------------------------------------------------------
C                                       Get inputs.
      CALL UVFGIN (PRGM, IRET)
      IF (IRET.GT.0) GO TO 990
C                                       Write history
      CALL UVFGHS
C                                       Close down
 990  CALL DIE (IRET, FLAGT1)
C
 999  STOP
      END
      SUBROUTINE UVFGIN (PRGM, IRET)
C-----------------------------------------------------------------------
C   UVFGIN does the startup bookeeping and reads the flagging table
C   from the specified text file if necessary.
C   Input:
C   PRGM       C*6  Task name.
C   Output:
C     IRET         I    Return error code, 0=> OK, otherwise failed.
C   Output to common /FLAGS/:
C     TABLE        L   If TRUE then flagging info put in FG table .
C     NFLAG        I   Number of flagging criteria in common.
C     FANT1(*)     I   First antenna of pair, 0=>all
C     FANT2(*)     I   Second antenna of pair, 0=>all
C     FFLAGS(4,*)  L   Correlator/polarization flags.
C     FLAGT1(*)    R   Start time (days since reference day in CATBLK)
C     FLAGT2(*)    R   End time.
C     FVS1(*)      I   First vis. to consider flagging
C     FVS2(*)      I   Last vis. to consider flagging
C     FLGIF(*)     I   Correlator flag 0=>flag R&L,1=>R,2=>L
C                      -1=>unflag R, -2=> L, -3 => both.
C     FIFLIM(2,*)  I   First and last IFs selected 0=all
C     FCHLIM(2,*)  I   First and last channels selected 0=all
C     FSUBA(*)     I   Subarray to flag
C     FFQID(*)     I   FQ ID to flag
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, UTYPE*2
C                                       Max. no. of time intervals on
C                                       any given baseline for elev.
C                                       flagging.
      INTEGER   MXTIM
      PARAMETER (MXTIM = 10)
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NPARM, I, IERR, IRET, NSOUR, IROUND, LUN, II, LUNAN,
     *   XA1(MXBASE), XA2(MXBASE), NBASE, MAXBAS, KBCH, KECH, KBIF,
     *   KEIF, NOCHAN, NOIF, IFGRNO, LUNFQ, SUBA, FQD, NTIM, IFGVER, K,
     *   FGBUFF(512), LFLAG
      REAL      T1(MXTIM), T2(MXTIM), STARTD, STOPD, ELEVTH,
     *   ELEVTL, FACTOR, SHMIN, CTMIN
      LOGICAL   T, F, CORR, WSBLNK, FGOPEN, NOSPEC
      INCLUDE 'UVFLG.INC'
      INTEGER   FGKOLS(MAXFGC), FGNUMV(MAXFGC)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUN, LUNAN, LUNFQ /27, 30, 40/
      DATA MAXBAS /MXBASE/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IRET = 0
      TABLE = F
      NMESS = 0
C                                       Init I/O
      CALL ZDCHIN (T)
      CALL VHDRIN
      BUFSZ = UVBFSS * 2
      LUN2 = 17
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      MXFLAG = XMXFLG
      NFLAG = 0
      WFLAG = 0
      CALL FILL (4, 0, CFLAG)
C                                       Get input parameters.
      NPARM = 277
      IRET = 0
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAME, IBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'GETTING INPUT PARAMETERS'
         RQUICK = F
         IRET = 8
         GO TO 990
         END IF
C                                       Decode input.
      SEQ = XSEQIN + 0.1
      DISK = XVIN + 0.1
C                                       Characters
      CALL H2CHR (12, 1, XNAME, NAME)
      CALL H2CHR (6, 1, XCLASS, CLASS)
      CALL H2CHR (48, 1, XINFIL, INFILE)
      CALL H2CHR (4, 1, XSTOKE, STOKES)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      CALL H2CHR (24, 1, XREAS, REASON)
      CALL H2CHR (4, 1, XCALC, CALKOD)
      KUAL = IROUND (XQUAL)
      IF ((OPCODE.NE.'UFLG') .AND. (OPCODE.NE.'REAS') .AND.
     *   (OPCODE.NE.'WILD')) OPCODE = 'FLAG'
C                                       Test for flag mask.
      IF (STOKES.EQ.'CROS') STOKES = '0011'
      IF ((STOKES(1:1).EQ.'0') .OR. (STOKES(1:1).EQ.'1'))
     *   USEMSK = .TRUE.
      NECHO = IROUND (APARM(7))
      IF (NECHO.EQ.0) NECHO = 100
C
      WSBLNK = T
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
         IF (XSOUR(I).NE.' ') WSBLNK = F
 20      CONTINUE
C                                       Open file and get CATBLK.
C                                       open file non-excl to allow
C                                       a second open as well:
      UTYPE = 'UV'
      CALL MAPOPN ('HDWR', DISK, NAME, CLASS, SEQ, UTYPE, NLUSER, LUN2,
     *   FIND2, CNOIN, CATBLK, IBUFF, IERR)
      IF (IERR.GT.1) THEN
         WRITE (MSGTXT,1000) IERR, 'FINDING UV FILE'
         RQUICK = F
         IRET = 8
         GO TO 990
         END IF
C                                       Mark in /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 1
C                                       Restart AIPS.
      IF (RQUICK) CALL RELPOP (IRET, IBUFF, IERR)
      IF (IRET.NE.0) GO TO 990
      IRET = 8
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Get info from CATBLK.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Check if multi source file
      CALL MULSDB (CATBLK, MULTI)
C                                       Write table
      CALL FNDEXT ('FG', CATBLK, IFGVER)
      FGVER = XFGVER + 0.1
      IF (FGVER.LE.0) FGVER = MAX (1, IFGVER)
C                                       Get number(s) of antennas.
C                                       Since GETNAN will return
C                                       a reasonable default -
C                                       ignore error code.
      CALL GETNAN (DISK, CNOIN, CATBLK, LUNAN, IBUFF, NUMAN, IERANT)
C                                       Also get antenna names &
C                                       numbers
      SUBA = IROUND(XSUBAR)
      IF (SUBA.EQ.0) SUBA = 1
      IF (IERANT.EQ.0) THEN
         CALL GETANT (DISK, CNOIN, SUBA, CATBLK, IBUFF, IERANT)
         IF (IERANT.NE.0) THEN
            WRITE (MSGTXT,1000) IERANT, 'READING ANTENNA TABLE'
            IRET = 7
            GO TO 990
            END IF
         END IF
C                                       If multi-source get numbers.
C                                       Set max. no sources named.
      NSOUR = 30
      ELEVAT = (APARM(2).GT.0.0) .AND. (APARM(2).GT.APARM(1))
      IF ((ELEVAT) .AND. (APARM(1).EQ.0.0)) APARM(1) = -90.0
      IF ((.NOT.ELEVAT) .AND. (APARM(1).NE.0.0)) THEN
         MSGTXT = 'APARM(1)-APARM(2) IMPROPER ELEVATION RANGE'
         IRET = 5
         GO TO 990
         END IF
C                                       shadowing
      SHADOW = APARM(5).GT.0.0
C                                       factor of wanted suppression of
C                                       spurios fringes near fringe
C                                       rateequled zero
C
      FACTOR = APARM(3)
      PULCAL = FACTOR.GE.1
      SUNDIS = APARM(8).GT.0.0
      NOSPEC = .NOT.(SUNDIS .OR. PULCAL .OR. SHADOW .OR. ELEVAT)
C                                       Set max. no. sources sel.
      NID = 1
      ID(1) = 0
      IF (MULTI) THEN
C                                       ALLSOU gives the full list
C                                       of source IDs if XSOUR=BLANK.
C                                       This is needed for the elev.
C                                       calculations.
         IF ((.NOT.NOSPEC) .AND. WSBLNK) THEN
            CALL ALLSOU (DISK, CNOIN, CATBLK, CALKOD, KUAL, IBUFF, ID,
     *         NID, IRET)
            IF (IRET.NE.0) GO TO 999
         ELSE IF ((OPCODE.EQ.'UFLG') .AND. (XSOUR(1).EQ.'-')) THEN
            NID = 1
            ID(1) = -1
         ELSE
            NID = MXSOU
            CALL SOURNU (XSOUR, KUAL, CALKOD, NSOUR, DISK, CNOIN, NID,
     *         IBUFF, ID, IRET)
            IF (IRET.LT.0) THEN
               MSGTXT = 'SOURCE(S) NOT FOUND IN SU TABLE'
               IRET = 5
            ELSE IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING SOURCE TABLE'
               END IF
            IF (IRET.NE.0) GO TO 990
            IF (NID.EQ.0) NID = 1
            END IF
         END IF
C                                       Flag with INFILE
      IF (INFILE(1:20).NE.' ') THEN
         IF (IERANT.NE.0) THEN
            MSGTXT = 'TEXT FILE FLAGGING REQUIRES AN ANTENNA TABLE'
            CALL MSGWRT (7)
            IRET = 7
            GO TO 990
         ELSE
            CALL UVFTRD (INFILE, IRET)
            END IF
C                                       flag with adverbs
      ELSE
C                                       Freq id
         IF (XBAND.GT.0.0) SELBAN = XBAND
         IF (XFREQ.GT.0.0) SELFRQ = XFREQ
         FRQSEL = IROUND (XFQID)
         IF (FRQSEL.LT.0) FRQSEL = -1
         IF (FRQSEL.GE.0) THEN
            CALL FQMATC (DISK, CNOIN, CATBLK, LUNFQ, SELBAN, SELFRQ,
     *         MATCH, FRQSEL, IRET)
            IF (.NOT.MATCH) THEN
               WRITE (MSGTXT,1070)
               IRET = 1
               GO TO 990
               END IF
            IF (IRET.GT.0) GO TO 999
            END IF
C                                       Set flagging info from ADVERBS.
         FCOUNT(1) = 0
         GCOUNT(1) = 0
         FSUBA(1) = IROUND (XSUBAR)
         FFQID(1) = FRQSEL
C                                       Timerange
         FLAGT1(1) = TIMER(1) + TIMER(2)/24. +
     *      TIMER(3)/(24.*60.) + TIMER(4)/(24.*60.*60.)
         FLAGT2(1) = TIMER(5) + TIMER(6)/24. +
     *      TIMER(7)/(24.*60.) + TIMER(8)/(24.*60.*60.)
C                                       If both zero flag all times
         IF (FLAGT2(1).GE.0.0) THEN
            IF (FLAGT2(1).EQ.0.0) FLAGT2(1) = FLAGT1(1)
            IF ((FLAGT1(1).EQ.0.0) .AND. (FLAGT2(1).EQ.0.0))
     *         FLAGT2(1) = 9999.
            END IF
C                                       Tweak range a bit.
         IF (FLAGT1(1).EQ.FLAGT2(1)) THEN
            FLAGT1(1) = FLAGT1(1) - 1.0 / 172800.
            FLAGT2(1) = FLAGT2(1) + 1.0 / 172800.
            END IF
C                                       Check that start before finish.
         IF (FLAGT1(1).GT.FLAGT2(1)) THEN
            MSGTXT = 'ERROR: TIME1 > TIME2'
            IRET = 8
            GO TO 990
            END IF
C                                       IF, channel limits
         KBCH = IROUND (XBCHAN)
         NOCHAN = CATBLK(KINAX+JLOCF)
C                                       Check that KBCH < NOCHAN.
         IF ((KBCH.GT.NOCHAN) .AND. (.NOT.ELEVAT) .AND. (.NOT.SHADOW))
     *      THEN
            WRITE (MSGTXT,1240) KBCH, NOCHAN
            IRET = 1
            GO TO 990
            END IF
         IF ((OPCODE.NE.'UFLG') .OR. (KBCH.GE.0)) KBCH =
     *      MAX (1, MIN (KBCH, NOCHAN))
         KECH = IROUND (XECHAN)
         IF (OPCODE.NE.'UFLG') KECH = MAX (0, KECH)
         IF ((KECH.GT.0) .AND. (KECH.LT.KBCH)) GO TO 910
         IF (JLOCIF.GE.0) THEN
            NOIF = CATBLK(KINAX+JLOCIF)
            KBIF = IROUND (XBIF)
C                                       Check that (startIF) < NOIF.
            IF ((KBIF.GT.NOIF) .AND. (.NOT.ELEVAT) .AND. (.NOT.SHADOW))
     *         THEN
               WRITE (MSGTXT,1220) KBIF, NOIF
               IRET = 1
               GO TO 990
               END IF
            KEIF = IROUND (XEIF)
            IF (OPCODE.NE.'UFLG') THEN
               KBIF = MAX (1, MIN (KBIF, CATBLK(KINAX+JLOCIF)))
               IF ((KEIF.GT.0) .AND. (KEIF.LT.KBIF)) GO TO 900
               IF (KBIF.GT.KEIF) KEIF = CATBLK(KINAX+JLOCIF)
               KEIF = MAX (1, MIN (KEIF, CATBLK(KINAX+JLOCIF)))
            ELSE
               IF (KBIF.GE.0) KBIF = MAX (1, MIN (KBIF,
     *            CATBLK(KINAX+JLOCIF)))
               IF ((KEIF.GT.0) .AND. (KEIF.LT.KBIF)) GO TO 900
               IF ((KBIF.GT.KEIF) .AND. (KEIF.GE.0)) KEIF =
     *            CATBLK(KINAX+JLOCIF)
               IF (KEIF.GE.0) KEIF = MAX (1, MIN (KEIF,
     *            CATBLK(KINAX+JLOCIF)))
               END IF
         ELSE
            NOIF = 1
            KBIF = 1
            KEIF = 1
            END IF
         NOMIF = NOIF
C                                       Convert to baseline numbers.
         NBASE = MAXBAS
         CALL AN10RS (NUMAN, FSUBA(1), XANTS, XBASE, NBASE, XA1, XA2)
C                                       Timerange
C                                       Determine start/stop of data
         CALL UVTIME (DISK, CNOIN, CATBLK, STARTD, STOPD, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'FINDING START/STOP TIMES'
            GO TO 990
            END IF
C                                       Flag data on elevation/PC with
C                                       the specified timerange
         IF ((FLAGT1(1).NE.0.0) .OR. (FLAGT2(1).NE.9999.0)) THEN
            STARTD = MAX (STARTD, FLAGT1(1))
            STOPD = MIN (STOPD, FLAGT2(1))
            END IF
C                                       Flagging on elevation
         FGOPEN = .FALSE.
         IF (ELEVAT) THEN
            LFLAG = WFLAG
            ELEVTL = APARM(1)
            ELEVTH = APARM(2)
            FQD = -1
            IF (OPCODE.NE.'UFLG') OPCODE = 'FLAG'
            CALL FLAGEL (LUN, FGBUFF, IFGRNO, FGKOLS, FGNUMV, FSUBA(1),
     *         STARTD, STOPD, FQD, FGOPEN, ELEVTL, ELEVTH, IRET)
            IF (IRET.GT.0) GO TO 999
            LFLAG = WFLAG - LFLAG
            WRITE (MSGTXT,1100) LFLAG, 'Elevation'
            CALL MSGWRT (4)
            CFLAG(1) = LFLAG
            END IF
C                                       Flagging on shadowing
         IF (SHADOW) THEN
            LFLAG = WFLAG
            FQD = -1
            IF (OPCODE.NE.'UFLG') OPCODE = 'FLAG'
            SHMIN = APARM(5) * CATD(KDCRV+JLOCF) / VELITE
            CTMIN = APARM(6) * CATD(KDCRV+JLOCF) / VELITE
            CALL FLAGSH (LUN, FGBUFF, IFGRNO, FGKOLS, FGNUMV, FSUBA(1),
     *         STARTD, STOPD, FQD, FGOPEN, SHMIN, CTMIN, IRET)
            IF (IRET.GT.0) GO TO 999
            LFLAG = WFLAG - LFLAG
            WRITE (MSGTXT,1100) LFLAG, 'Shadowing'
            CALL MSGWRT (4)
            CFLAG(3) = LFLAG
            END IF
C                                       PCAL tones
         IF (PULCAL) THEN
            LFLAG = WFLAG
            IF (OPCODE.NE.'UFLG') OPCODE = 'FLAG'
            CALL FLGPCL (LUN, FGBUFF, IFGRNO, FGKOLS, FGNUMV, FACTOR,
     *         SUBA, WSBLNK, STARTD, STOPD, KBIF, KEIF, KBCH, KECH,
     *         FGOPEN, IRET)
            IF (IRET.GT.0) GO TO 999
            LFLAG = WFLAG - LFLAG
            WRITE (MSGTXT,1100) LFLAG, 'PCAL tones'
            CALL MSGWRT (4)
            CFLAG(2) = LFLAG
            END IF
C                                       Sun distance
         IF (SUNDIS) THEN
            LFLAG = WFLAG
            IF (OPCODE.NE.'UFLG') OPCODE = 'FLAG'
            CALL FLGSUN (LUN, FGBUFF, IFGRNO, FGKOLS, FGNUMV, SUBA,
     *         STARTD, STOPD, APARM(8), FGOPEN, IRET)
            IF (IRET.GT.0) GO TO 999
            LFLAG = WFLAG - LFLAG
            WRITE (MSGTXT,1100) LFLAG, 'Sun distance'
            CALL MSGWRT (4)
            CFLAG(4) = LFLAG
            END IF
C
         IF (NOSPEC) THEN
            CALL FLAGUP (OPCODE, LUN, DISK, CNOIN, FGVER, FGBUFF,
     *         IFGRNO, FGKOLS, FGNUMV, ID, NID, FSUBA(1), FFQID(1),
     *         NBASE, XA1, XA2, FLAGT1(1), FLAGT2(1), KBIF, KEIF, KBCH,
     *         KECH, STOKES, REASON, WFLAG, IRET)
            IF (IRET.GT.0) GO TO 999
            FGOPEN = .TRUE.
            END IF
C                                       Close FG table
         IF (FGOPEN) THEN
            CALL FLAGUP ('CLOS', LUN, DISK, CNOIN, FGVER, FGBUFF,
     *         IFGRNO, FGKOLS, FGNUMV, ID, NID, FSUBA(1), FFQID(1),
     *         NBASE, XA1, XA2, FLAGT1(1), FLAGT2(1), KBIF, KEIF, KBCH,
     *         KECH, STOKES, REASON, I, IRET)
            IF (WFLAG.LE.0) THEN
               WRITE (MSGTXT,1211) FGVER
               CALL MSGWRT (7)
            ELSE
               WRITE (MSGTXT,1210) WFLAG, FGVER
               CALL MSGWRT (4)
               END IF
C                                       Nothing was added to the FG
C                                       table
         ELSE
            WRITE (MSGTXT,1215) FGVER
            CALL MSGWRT (7)
            END IF
C                                       Fill /FLAGS/ common,
C                                       Applying channel range?
         IF ((WFLAG.GT.0) .AND. (.NOT.ELEVAT) .AND. (.NOT.PULCAL)
     *      .AND. (.NOT.SHADOW) .AND. (.NOT.SUNDIS)) THEN
            IF (KECH.LT.KBCH) KECH = CATBLK(KINAX+JLOCF)
            KECH = MAX (1, MIN (KECH, CATBLK(KINAX+JLOCF)))
C                                       loop over baseline.
            DO 300 I = 1,NBASE
C                                       use input timerange only
               T1(1) = FLAGT1(1)
               T2(1) = FLAGT2(1)
               NTIM = 1
C                                       Loop over all timeranges to
C                                       be flagged for this baseline.
               DO 280 K = 1,NTIM
                  IF (NFLAG.GE.MXFLAG) THEN
                     WRITE (MSGTXT,1200) MXFLAG
                     CALL MSGWRT (6)
                     IRET = -1
                     GO TO 999
                     END IF
                  NFLAG = NFLAG + 1
                  FCOUNT(NFLAG) = 0
                  GCOUNT(NFLAG) = 0
                  FANT1(NFLAG) = MIN (XA1(I), XA2(I))
                  FANT2(NFLAG) = MAX (XA1(I), XA2(I))
                  REESON(NFLAG) = REASON
                  CORR = T
C                                       Antenna flagging
                  IF (FANT1(NFLAG).EQ.0) THEN
                     CORR = F
                     FANT1(NFLAG) = FANT2(NFLAG)
                     FANT2(NFLAG) = 0
                     END IF
C                                       Make sure FANT1.LE.FANT2
                  IF (CORR) THEN
                     IF (FANT1(NFLAG).GE.FANT2(NFLAG)) THEN
                        II = FANT1(NFLAG)
                        FANT1(NFLAG) = FANT2(NFLAG)
                        FANT2(NFLAG) = II
                        END IF
                     END IF
C                                       Timerange
                  FLAGT1(NFLAG) = T1(K)
                  FLAGT2(NFLAG) = T2(K)
C                                       Channel and IF limits
                  FCHLIM(1,NFLAG) = KBCH
                  FCHLIM(2,NFLAG) = KECH
                  FIFLIM(1,NFLAG) = KBIF
                  FIFLIM(2,NFLAG) = KEIF
                  FSUBA(NFLAG) = IROUND (XSUBAR)
                  FFQID(NFLAG) = FRQSEL
C                                       Get flagging parms
                  IF (STOKES.EQ.'----') THEN
                     CALL FLGSTK ('    ', OPCODE, FFLAGS(1,NFLAG), FSET,
     *                  IRET)
                  ELSE
                     CALL FLGSTK (STOKES, OPCODE, FFLAGS(1,NFLAG), FSET,
     *                  IRET)
                     END IF
                  IF (IRET.NE.0) GO TO 999
 280              CONTINUE
 300           CONTINUE
            END IF
         END IF
      GO TO 999
C                                       adverb error
 900  WRITE (MSGTXT,1900) KBIF, KEIF
      IRET = 10
      GO TO 990
 910  WRITE (MSGTXT,1910) KBCH, KECH
      IRET = 10
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVFGIN ERROR',I4,' ON ',A)
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
 1100 FORMAT ('Generated',I6,' flag records because of 'A)
 1200 FORMAT ('WARNING: USING ONLY FIRST ',I5,' ENTRIES FROM TABLE')
 1210 FORMAT ('Wrote ',I8,' flags to flag table version',I3)
 1211 FORMAT ('WARNING: DID NOT WRITE/CHANGE ANY RECORDS IN FG VERSION',
     *   I4)
 1215 FORMAT ('NOTHING WAS ADDED TO FG TABLE ',I3)
 1220 FORMAT ('UVFGIN: Beginning IF=',I2,' bigger than number of IF=',
     *   I2)
 1240 FORMAT ('UVFGIN: Beginning CH=',I3,' bigger than number of CH=',
     *   I3)
 1900 FORMAT ('UVFGIN: SPECIFIED IFS',2I4,' IMPROPER')
 1910 FORMAT ('UVFGIN: SPECIFIED CHANNELS',2I7,' IMPROPER')
      END
      SUBROUTINE UVFGHS
C-----------------------------------------------------------------------
C   UVFGHS writes the flagging information in the history file
C-----------------------------------------------------------------------
C
      CHARACTER HILINE*72, CTIME*8, CDATE*12
      INTEGER   IFLAG, IRET, LUNH, DATE(3), TIME(3), J, JTRIM
      LOGICAL   T
      INCLUDE 'UVFLG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      DATA T /.TRUE./
      DATA LUNH /27/
C-----------------------------------------------------------------------
C                                       Open history file
      CALL HIINIT (2)
      CALL HIOPEN (LUNH, DISK, FCNO(1), IBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Write time and date on old file
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME, CDATE)
      WRITE (HILINE,1000) TSKNAM, RLSNAM, CDATE, CTIME
      CALL HIADD (LUNH, HILINE, IBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       opcode
      WRITE (HILINE,1004) TSKNAM, OPCODE
      CALL HIADD (LUNH, HILINE, IBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       Text file name.
      IF (INFILE(1:20).NE.' ') THEN
         WRITE (HILINE,1005) TSKNAM, INFILE
         CALL HIADD (LUNH, HILINE, IBUFF, IRET)
         IF (IRET.NE.0) GO TO 100
         END IF
C                                       elevation
      IF (ELEVAT) THEN
         WRITE (HILINE,1010) TSKNAM, APARM(1), APARM(2)
         CALL HIADD (LUNH, HILINE, IBUFF, IRET)
         IF (IRET.NE.0) GO TO 100
         WRITE (HILINE,1014) TSKNAM, CFLAG(1), 'Elevation'
         CALL HIADD (LUNH, HILINE, IBUFF, IRET)
         IF (IRET.NE.0) GO TO 100
         END IF
      IF (PULCAL) THEN
         WRITE (HILINE,1011) TSKNAM, APARM(3)
         CALL HIADD (LUNH, HILINE, IBUFF, IRET)
         IF (IRET.NE.0) GO TO 100
         WRITE (HILINE,1014) TSKNAM, CFLAG(2), 'Pulse cal tones'
         CALL HIADD (LUNH, HILINE, IBUFF, IRET)
         IF (IRET.NE.0) GO TO 100
         END IF
      IF (SHADOW) THEN
         WRITE (HILINE,1012) TSKNAM, APARM(5), APARM(6)
         CALL HIADD (LUNH, HILINE, IBUFF, IRET)
         IF (IRET.NE.0) GO TO 100
         WRITE (HILINE,1014) TSKNAM, CFLAG(3), 'Shadowing'
         CALL HIADD (LUNH, HILINE, IBUFF, IRET)
         IF (IRET.NE.0) GO TO 100
         END IF
      IF (SUNDIS) THEN
         WRITE (HILINE,1013) TSKNAM, APARM(8)
         CALL HIADD (LUNH, HILINE, IBUFF, IRET)
         IF (IRET.NE.0) GO TO 100
         WRITE (HILINE,1014) TSKNAM, CFLAG(4), 'Sun distance'
         CALL HIADD (LUNH, HILINE, IBUFF, IRET)
         IF (IRET.NE.0) GO TO 100
         END IF
C                                       Loop thru flags.
      IF (DOHIST.GT.0.0) THEN
         DO 50 IFLAG = 1,NFLAG
C                                       Spectral channel & IF
            IF ((IFLAG.EQ.1) .OR. (FCHLIM(1,IFLAG).NE.FCHLIM(1,IFLAG-1))
     *         .OR. (FCHLIM(2,IFLAG).NE.FCHLIM(2,IFLAG-1)) .OR.
     *         (FIFLIM(1,IFLAG).NE.FIFLIM(1,IFLAG-1)) .OR.
     *         (FIFLIM(2,IFLAG).NE.FIFLIM(2,IFLAG-1))) THEN
               WRITE (HILINE,1015) TSKNAM, IFLAG, FCHLIM(1,IFLAG),
     *            FCHLIM(2,IFLAG), FIFLIM(1,IFLAG), FIFLIM(2,IFLAG)
               CALL HIADD (LUNH, HILINE, IBUFF, IRET)
               IF (IRET.NE.0) GO TO 100
               END IF
C                                       Get time in user units.
            IF ((IFLAG.EQ.1) .OR. (FLAGT1(IFLAG).NE.FLAGT1(IFLAG-1))
     *         .OR. (FLAGT2(IFLAG).NE.FLAGT2(IFLAG-1))) THEN
               CALL FGTIME (IFLAG, FLAGT1(IFLAG), FLAGT2(IFLAG), LUNH,
     *            IBUFF, IRET)
               IF (IRET.NE.0) GO TO 100
               END IF
C                                       Time and Flags
C                                       Trap antenna based flaging.
            IF ((IFLAG.EQ.1) .OR. (FANT1(IFLAG).NE.FANT1(IFLAG-1))
     *         .OR. (FANT2(IFLAG).NE.FANT2(IFLAG-1))) THEN
               IF (FANT2(IFLAG).EQ.0) THEN
                  WRITE (HILINE,1021) TSKNAM, IFLAG, FANT1(IFLAG),
     *               FFLAGS(1,IFLAG), FFLAGS(2,IFLAG),
     *               FFLAGS(3,IFLAG), FFLAGS(4,IFLAG)
               ELSE
                  WRITE (HILINE,1020) TSKNAM, IFLAG, FANT1(IFLAG),
     *               FANT2(IFLAG), FFLAGS(1,IFLAG), FFLAGS(2,IFLAG),
     *               FFLAGS(3,IFLAG), FFLAGS(4,IFLAG)
                  END IF
               CALL HIADD (LUNH, HILINE, IBUFF, IRET)
               IF (IRET.NE.0) GO TO 100
               END IF
C                                       reason
            J = JTRIM (REESON(IFLAG))
            IF ((IFLAG.EQ.1) .OR. (REESON(IFLAG).NE.REESON(IFLAG-1)))
     *         THEN
               IF (REESON(IFLAG).NE.' ') THEN
                  WRITE (HILINE,1025) TSKNAM, IFLAG, REESON(IFLAG)
                  CALL HIADD (LUNH, HILINE, IBUFF, IRET)
                  IF (IRET.NE.0) GO TO 100
                  END IF
               END IF
 50         CONTINUE
         END IF
      WRITE (HILINE,1030) TSKNAM, FGVER
      CALL HIADD (LUNH, HILINE, IBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
      WRITE (HILINE,1031) TSKNAM, WFLAG
      CALL HIADD (LUNH, HILINE, IBUFF, IRET)
      IF (IRET.NE.0) GO TO 100
C
 100  CALL HICLOS (LUNH, T, IBUFF, IRET)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',A12,2X,A8)
 1004 FORMAT (A6,'OPCODE = ''',A,'''  / operation performed by UVFLG')
 1005 FORMAT (A6,'INFILE= ''',A,'''')
 1010 FORMAT (A6,'ELRANGE=',F6.1,' ,',F6.1,'  / flag elevation range')
 1011 FORMAT (A6,'PCSUPFAC=',F8.3,'  / Pulse cal suppression factor')
 1012 FORMAT (A6,'MINBASLN=',F6.1,' ,',F6.1,'  / min baseline',
     *   ' shadow, crosstalk')
 1013 FORMAT (A6,'MINDIST=',F6.1,6X,'/ min Sun distance degrees')
 1014 FORMAT (A6,'/ Generated',I6,' flags for ',A)
 1015 FORMAT (A6,'/',I4,' BCHAN    =',I5,' ECHAN =',I5,'  BIF =',I3,
     *   ' EIF =',I3)
 1020 FORMAT (A6,'/',I4,' BASELINE =',I3,' -',I3,'  FLAGS = ',4L1)
 1021 FORMAT (A6,'/',I4,' BASELINE =',I3,' -  *  FLAGS = ',4L1)
 1025 FORMAT (A6,'/',I4,' REASON   =''',A,'''')
 1030 FORMAT (A6,'OUTFGVER=',I5,'  / output FG table version')
 1031 FORMAT (A6,'NFLAG =',I9,'   / number flag commands written')
      END
      SUBROUTINE FGTIME (IFLAG, TIME1, TIME2, HLUN, HBUFF, IERR)
C-----------------------------------------------------------------------
C   FGTIME interprets a timerange to the history file.
C   Inputs:
C      IFLAG   I        Flag number
C      TIME1   R        Start time in days: <= 0 => beginning
C      TIME2   R        Stop time in days: >= 1.0e4 => to end
C      HLUN    I        LUN of open history file
C   In/out:
C      HBUFF   I(256)   History writing buffer
C   Output:
C      IERR    I        Error code of HIADD : 0 => okay
C-----------------------------------------------------------------------
      REAL      TIME1, TIME2
      INTEGER   IFLAG, HLUN, HBUFF(256), IERR
C
      REAL      T1, T2
      INTEGER   IT1(3), IT2(3)
      CHARACTER HILINE*72
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       convert times
      IF (TIME1.GT.0.0) THEN
         T1 = TIME1
         IT1(1) = T1
         T1 = 24.0 * (T1 - IT1(1))
         IT1(2) = T1
         T1 = 60.0 * (T1 - IT1(2))
         IT1(3) = T1
         T1 = 60.0 * (T1 - IT1(3))
         END IF
      IF (TIME2.LT.1.0E4) THEN
         T2 = TIME2
         IT2(1) = T2
         T2 = 24.0 * (T2 - IT2(1))
         IT2(2) = T2
         T2 = 60.0 * (T2 - IT2(2))
         IT2(3) = T2
         T2 = 60.0 * (T2 - IT2(3))
         END IF
C                                       Man-readable form
      IF (TIME1.LE.0.0) THEN
         IF (TIME2.GE.9998.) THEN
            WRITE (HILINE,1000) TSKNAM, IFLAG
         ELSE
            WRITE (HILINE,1010) TSKNAM, IFLAG, IT2, T2
            IF (HILINE(48:48).EQ.' ') HILINE(48:48) = '0'
            IF (HILINE(49:49).EQ.' ') HILINE(49:49) = '0'
            END IF
      ELSE
         IF (TIME2.GE.9998.) THEN
            WRITE (HILINE,1020) TSKNAM, IFLAG, IT1, T1
            IF (HILINE(35:35).EQ.' ') HILINE(35:35) = '0'
            IF (HILINE(36:36).EQ.' ') HILINE(36:36) = '0'
         ELSE
            WRITE (HILINE,1030) TSKNAM, IFLAG, IT1, T1, IT2, T2
            IF (HILINE(35:35).EQ.' ') HILINE(35:35) = '0'
            IF (HILINE(36:36).EQ.' ') HILINE(36:36) = '0'
            IF (HILINE(55:55).EQ.' ') HILINE(55:55) = '0'
            IF (HILINE(56:56).EQ.' ') HILINE(56:56) = '0'
            END IF
         END IF
      CALL HIADD (HLUN, HILINE, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'/',I4,' TIMERANG = beginning to end')
 1010 FORMAT (A6,'/',I4,' TIMERANG = beginning to',I5,'/',2(I2.2,':'),
     *   F5.2)
 1020 FORMAT (A6,'/',I4,' TIMERANG =',I5,'/',2(I2.2,':'),F5.2,' to end')
 1030 FORMAT (A6,'/',I4,' TIMERANG =',I5,'/',2(I2.2,':'),F5.2,' to',
     *   I5,'/',2(I2.2,':'),F5.2)
      END
      SUBROUTINE UVFTRD (FILE, IRET)
C-----------------------------------------------------------------------
C   UVFTRD reads a text file in containing flagging information using
C   KEYIN.
C   same meaning as the CPARM array passed from AIPS;
C   Values are placed in common /FLAGS/ and/or written to the flagging
C   file.
C    Inputs:
C      FILE     C*48 Name of text file
C    Output: IRET     I    Return code, 0=>OK otherwise failed.
C-----------------------------------------------------------------------
      CHARACTER FILE*48
      INTEGER   IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NUMK
      PARAMETER (NUMK=185)
C
      CHARACTER  KEYS(NUMK)*8, ENDMRK*8, VALCH(NUMK)*8, CHSOUR*8,
     *   CHSUBA*8, CHTIME*8, CHBCH*8, CHECH*8, CHBIF*8, CHEIF*8,
     *   CHANT*8, CHBASE*8, CHSTOK*8, CHOPCO*8, CHREA*8, CHTMOF*8,
     *   CHFQID*8, OBSDAT*8, ANTNAM*8, STANAM(MAXANT)*8, CHTMR*8,
     *   CHBFRQ*8, CHEFRQ*8
      LOGICAL   T, F, WARN
      INTEGER   LUN, FIND, MODE, I, N, NUMKEY, IFGRNO, OFSOUR, OFSUBA,
     *   OFTIME, OFBCH, OFECH, OFBIF, OFEIF, OFANT, OFBASE, OFSTOK,
     *   OFOPCO, OFREA, OTMOF, OFQID, IDUM1, IDUM2(2), IDUM3(2), LIM2,
     *   IDATE(3), DAYN, STRLEN, STALEN(MAXANT), ODTMR, OFBFRQ, OFEFRQ
      DOUBLE PRECISION VALUE(NUMK)
      REAL      TIMOFF, RDAYN, DTMR
      INCLUDE 'UVFLG.INC'
      INTEGER   FGKOLS(MAXFGC), FGNUMV(MAXFGC)
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA LUN  /10/
      DATA ENDMRK /'/       '/
C                                       Set KEYWORDS (ADVERBS)
      DATA    CHSOUR,     CHSUBA,     CHTIME
     *   /'SOURCES ', 'SUBARRAY', 'TIMERANG'/
      DATA   CHBCH,     CHECH,      CHBIF,    CHEIF
     *   /'BCHAN   ', 'ECHAN   ', 'BIF     ', 'EIF     '/
      DATA     CHANT,     CHBASE,     CHSTOK,    CHOPCO
     *   /'ANT?????', 'BAS?????', 'STOKES  ', 'OPCODE  '/
      DATA CHREA ,     CHTMOF,    CHBFRQ,   CHEFRQ
     *   /'REASON  ', 'TIMEOFF', 'BFREQ', 'EFREQ'/
      DATA CHFQID,     CHTMR
     *   /'FREQID  ', 'DTIMRANG'/
C                                       Set pointers in KEYIN arrays
      DATA NUMKEY /183/
      DATA  OFSOUR, OFSUBA, OFTIME, OFBCH, OFECH, OFBIF, OFEIF
     *   /    1,      61,     62,     70,   71,     72,    73/
      DATA OFANT, OFBASE, OFSTOK, OFOPCO, OFREA, OTMOF, OFQID, ODTMR
     *   /  74,    124,     174,   175,    176,    179,  180,  181/
      DATA OFBFRQ, OFEFRQ
     *   / 182,     183/
C-----------------------------------------------------------------------
      CALL H2CHR (8, 1, CATH(KHDOB), OBSDAT)
      CALL DATEST (OBSDAT, IDATE)
      CALL DAYNUM (IDATE(1), IDATE(3), IDATE(2), DAYN)
      RDAYN = DAYN
C                                       Setup Antenna lists
      DO 10 I = 1,NSTNS
         CALL CHTRIM (STNNAM(I), 8, STANAM(I), STALEN(I))
 10      CONTINUE
C                                       Fill KEYWORD arrays.
      LIM2 = OFSUBA - 1
      DO 20 I = OFSOUR,LIM2,2
         KEYS(I) = CHSOUR
         KEYS(I+1) = '        '
 20      CONTINUE
      KEYS(OFSUBA) = CHSUBA
      KEYS(OFQID) = CHFQID
      LIM2 =  OFBCH - 1
      DO 30 I = OFTIME,LIM2
         KEYS(I) = CHTIME
 30      CONTINUE
      KEYS(OFBCH) = CHBCH
      KEYS(OFECH) = CHECH
      KEYS(OFBIF) = CHBIF
      KEYS(OFEIF) = CHEIF
      LIM2 = OFBASE - 1
      DO 40 I = OFANT,LIM2
         KEYS(I) = CHANT
         VALUE(I) = 0.0D0
         VALCH(I) = ' '
 40      CONTINUE
      LIM2 = OFSTOK - 1
      DO 50 I = OFBASE,LIM2
         KEYS(I) = CHBASE
         VALUE(I) = 0.0D0
         VALCH(I) = ' '
 50      CONTINUE
      KEYS(OFSTOK) = CHSTOK
      KEYS(OFOPCO) = CHOPCO
      KEYS(OFREA) = CHREA
      KEYS(OFREA+1) = '        '
      KEYS(OFREA+2) = '        '
      KEYS(OTMOF) = CHTMOF
      KEYS(ODTMR) = CHTMR
      KEYS(OFBFRQ) = CHBFRQ
      KEYS(OFEFRQ) = CHEFRQ
      VALUE(OFSUBA) = 0.0D0
      VALUE(OFQID) = -1.0D0
      VALUE(OFBCH) = 0.0D0
      VALUE(OFECH) = 0.0D0
      VALUE(OFBIF) = 0.0D0
      VALUE(OFEIF) = 0.0D0
      VALUE(OTMOF) = 0.0D0
      VALUE(ODTMR) = 0.0D0
      VALUE(OFBFRQ) = 0.0D0
      VALUE(OFEFRQ) = 0.0D0
      TIMOFF = VALUE(OTMOF)
      DTMR = VALUE(ODTMR)
      IRET = 0
      NFLAG = 0
C                                       Set KEYIN mode to read list.
      MODE = 0
      WARN = T
C                                       Open edit file
      CALL ZTXOPN ('READ', LUN, FIND, FILE, F, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1050) IRET
         GO TO 990
         END IF
C                                       Loop over flagging entries
 510     N = NUMKEY
C                                       Zero entries
         LIM2 = OFSUBA - 1
         DO 520 I = 1,N
            VALCH(I) = ' '
 520        CONTINUE
         DO 530 I = 1,N
            VALUE(I) = 0.0D0
 530        CONTINUE
C                                       Init FQ ID
         VALUE(OFQID) = -1.0D0
C                                       Read entry
         CALL KEYIN (KEYS, VALUE, VALCH, N, ENDMRK, MODE, LUN, FIND,
     *      IRET)
C                                       Check for read error.
         IF (IRET.LE.1) GO TO 560
            WRITE (MSGTXT,1510) IRET
            GO TO 990
C                                       Check for end
 560     IF (IRET.EQ.1) GO TO 700
C                                       Save IAT correction
         IF (VALUE(OTMOF).NE.0.0D0) TIMOFF = VALUE(OTMOF)
C                                       Save TIMERANG correction
         IF (VALUE(ODTMR).NE.0.0D0) DTMR = VALUE(ODTMR)
         RDAYN = DAYN
         IF (VALCH(OFANT).EQ.' ') RDAYN = 0.0
C                                       Correct times to IAT
         VALUE(OFTIME+3) = VALUE(OFTIME+3) + TIMOFF - DTMR
         VALUE(OFTIME+7) = VALUE(OFTIME+7) + TIMOFF + DTMR
         VALUE(OFTIME)   = VALUE(OFTIME) - RDAYN
         VALUE(OFTIME+4) = VALUE(OFTIME+4) - RDAYN
C
         IF (VALCH(OFANT)(1:1).NE.' ') THEN
C                                       Determine antenna numbers
C                                       from antenna names.
            CALL CHLTOU (8, VALCH(OFANT))
            CALL CHTRIM (VALCH(OFANT), 8, ANTNAM, STRLEN)
            DO 600 I = 1, NSTNS
C              SRCHLN = MIN (STRLEN, STALEN(I))
               IF (ANTNAM.EQ.STANAM(I)) THEN
                  VALUE(OFANT) = TELNO(I)
                  GO TO 610
                  END IF
  600          CONTINUE
            GO TO 510
C                                       Determine baseline numbers
C                                       from baseline names.
  610       IF (VALCH(OFBASE)(1:1).NE.' ') THEN
               CALL CHLTOU (8, VALCH(OFBASE))
               CALL CHTRIM (VALCH(OFBASE), 8, ANTNAM, STRLEN)
               DO 620 I = 1, NSTNS
C                 SRCHLN = MIN (STRLEN, STALEN(I))
                  IF (ANTNAM.EQ.STANAM(I)) THEN
                     VALUE(OFBASE) = TELNO(I)
                     GO TO 650
                     END IF
  620             CONTINUE
               GO TO 510
               END IF
            END IF
C                                       Write table or fill common
  650    CALL UVFTAB (VALUE, VALCH, IBUFF, IFGRNO, FGKOLS, FGNUMV,
     *      OFSOUR, OFSUBA, OFQID, OFTIME, OFBCH, OFECH, OFBIF, OFEIF,
     *      OFANT, OFBASE, OFSTOK, OFOPCO, OFREA, OFBFRQ, RDAYN, IRET)
         IF (IRET.GT.0) GO TO 999
C                                       Get next record.
         IF (IRET.LE.0) GO TO 510
C                                       All done, close text file.
 700  CALL ZTXCLS (LUN, FIND, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Close FG file.
      CALL FLAGUP ('CLOS', LUN, DISK, CNOIN, FGVER, IBUFF, IFGRNO,
     *   FGKOLS, FGNUMV, ID, NID, FSUBA(1), FFQID(1), IDUM1, IDUM2,
     *   IDUM3, FLAGT1(1), FLAGT2(1), FIFLIM(1,1), FIFLIM(2,1),
     *   FCHLIM(1,1), FCHLIM(2,1), STOKES, REASON, I, IRET)
      IF (IRET.GT.0) GO TO 999
C                                       Make sure got some.
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('ERROR',I3,' OPENING EDIT TABLE')
 1510 FORMAT ('ERROR',I3,' READING EDIT TABLE')
      END
      SUBROUTINE UVFTAB (VALUE, VALCH, BUFFER, IFGRNO, FGKOLS, FGNUMV,
     *   OFSOUR, OFSUBA, OFQID, OFTIME, OFBCH, OFECH, OFBIF, OFEIF,
     *   OFANT, OFBASE, OFSTOK, OFOPCO, OFREA, OFBFRQ, RDAYN, IRET)
C-----------------------------------------------------------------------
C   Gets flagging info from KEYIN array and writes to FG file via FLAGUP
C   or squirrels it away in the common /FLAGS/.
C   NOTE: Uses LUN 29 for I/O to FG file.  File must be closed after
C   last call to UVFTAB with a CLOSE call to FLAGUP.
C   Input:
C     VALUE(*)     D   Numeric value array returned from KEYIN.
C     VALCH(*)     C*8 Character array returned from KEYIN.
C     OFSOUR       I   Offset in VALCH of source name (30*16 char, 2 el)
C     OFSUBA       I   Offset in VALUE of subarray no. 0=>all.
C     OFQID        I   Offset in VALUE of freq. id no. <=0 => all.
C     OFTIME       I   Offset in VALUE of TIMERANGE (8 reals)
C     OFBCH        I   Offset in VALUE of BCHAN (1 integer)
C     OFECH        I   Offset in VALUE of ECHAN (1 integer)
C     OFBIF        I   Offset in VALUE of BIF (1 integer)
C     OFEIF        I   Offset in VALUE of EIF (1 integer)
C     OFANT        I   Offset in VALUE of ANTENNA array (50 reals)
C     OFBAS        I   Offset in VALUE of BASELINE array (50 reals)
C     OFSTOK       I   Offset in VALCH of Stokes parm. 4 char.
C     OFOPCO       I   Offset in VALCH of OPCODE 4 char.
C     OFREA        I   Offset in VALCH of REASON (24 char. 3 el.)
C     OFBFRQ       I   Offset in VALCH of BFREQ/EFREQ (2 reals)
C     RDAYN        R   Day #: for error reporting purposes only.
C   Input from common
C     DISK         I   Disk to use.
C     CNOIN        I   Catalog slot number
C     FGVER        I   FG file version
C     CATBLK(256)  I   Catalog header block.
C     NUMAN(513)   I   (1) = No. subarrays, following elements are
C                       the number of antennas in each subarray.
C   Input/Output:
C     BUFFER(512)  I   I/O buffer and related storage, also defines file
C                      if open.
C     IFGRNO       I   Next scan number, start of the file if 'READ',
C                      the last+1 if WRITE
C     FGKOLS(*)    I   The column pointer array in order, SOURCE,
C                      SUBARRAY, ANTS, TIMERANG, IFS, CHANS, PFLAGS,
C                      REASON
C     FGNUMV(*)    I   Element count in each column.
C   Input/output from COMMON /FLAGS/
C     NFLAG        I   Number of flagging criteria in common.
C   Output:
C     IRET         I   Error code, 0=>OK else TABIO error.
C   Output to common /FLAGS/:
C     FANT1(*)     I   First antenna of pair, 0=>all
C     FANT2(*)     I   Second antenna of pair, 0=>all
C     FFLAGS(4,*)  L   Correlator/polarization flags.
C     FLAGT1(*)    R   Start time (days since reference day in CATBLK)
C     FLAGT2(*)    R   End time.
C     FVS1(*)      I   First vis. to consider flagging
C     FVS2(*)      I   Last vis. to consider flagging
C     FLGIF(*)     I   Correlator flag 0=>flag R&L,1=>R,2=>L
C                      -1=>unflag R, -2=> L, -3 => both.
C     FIFLIM(2,*)  I   First and last IFs selected 0=all
C     FCHLIM(2,*)  I   First and last channels selected 0=all
C     FSUBA(*)     I   Subarray to flag
C     FFQID(*)     I   FQ ID to flag
C-----------------------------------------------------------------------
      DOUBLE PRECISION VALUE(*)
      CHARACTER VALCH(*)*8
      INTEGER   BUFFER(*), IFGRNO, FGKOLS(*), FGNUMV(*), OFSOUR, OFSUBA,
     *   OFQID, OFTIME, OFBCH, OFECH, OFBIF, OFEIF, OFANT, OFBASE,
     *   OFSTOK, OFOPCO, OFREA, OFBFRQ, IRET
      REAL      RDAYN
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER XOPCO*4, XSTOK*4, XEASON*24, XOURCE(30)*16
      INTEGER   LUN, NFL, KSUBA, KBCH(MAXIF), KECH(MAXIF), KBIF(MAXIF),
     *   KEIF(MAXIF), I, JOFF, NSOUR, XA1(MXBASE), XA2(MXBASE), NBASE,
     *   MAXBAS, NOCHAN, NOIF, KFQID, LUNFQ, IROUND, TIM1(4), TIM2(4),
     *   NFRQS, J
      REAL      XNTENN(50), XASELN(50), XT1, XT2, RTEMP, YT1, YT2,
     *   SEC1, SEC2
      INCLUDE 'UVFLG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA LUN /29/
      DATA MAXBAS /MXBASE/
C-----------------------------------------------------------------------
C                                       Crunch numbers from VALUE
C                                       SOURCES
      DO 20 I = 1,30
         JOFF = OFSOUR + (I-1) * 2
         XOURCE(I) = VALCH(JOFF) // VALCH(JOFF+1)
 20      CONTINUE
C                                       Look up IDs
      NSOUR = 30
      IF (MULTI) THEN
         NID = MXSOU
         CALL SOURNU (XOURCE, KUAL, CALKOD, NSOUR, DISK, CNOIN, NID,
     *      IBUFF2, ID, IRET)
         IF (IRET.LT.0) THEN
            MSGTXT = 'SOURCE(S) NOT FOUND IN SU TABLE'
            CALL MSGWRT (7)
            IRET = 5
            END IF
         IF (IRET.NE.0) GO TO 999
         IF (NID.EQ.0) NID = 1
      ELSE
         NID = 1
         ID(1) = 0
         END IF
C                                       Subarray
      KSUBA = VALUE(OFSUBA) + 0.1
      RTEMP = VALUE(OFQID)
      KFQID = IROUND (RTEMP)
      IF (KFQID.LT.0) KFQID = -1
      IF (KFQID.GE.0) THEN
         LUNFQ = 40
         CALL FQMATC (DISK, CNOIN, CATBLK, LUNFQ, SELBAN, SELFRQ,
     *      MATCH, KFQID, IRET)
         IF (.NOT.MATCH) THEN
            WRITE (MSGTXT,1080)
            IRET = 1
            GO TO 990
            END IF
         IF (IRET.GT.0) GO TO 999
         END IF
C                                       Timerange
      XT1 = VALUE(OFTIME) + VALUE(OFTIME+1) / 24. +
     *   VALUE(OFTIME+2) / (24. * 60.) + VALUE(OFTIME+3) / (24.*60.*60.)
      XT2 = VALUE(OFTIME+4) + VALUE(OFTIME+5) / 24. +
     *   VALUE(OFTIME+6) / (24. * 60.) + VALUE(OFTIME+7) / (24.*60.*60.)
C                                       If both 0 flag all.
      IF (ABS(XT2).LE.1.0E-5) XT2 = XT1
      IF ((ABS(XT1).LE.1.0E-5) .AND. (ABS(XT2).LE.1.0E-5)) XT2 = 9999.
      IF ((ABS(XT1+RDAYN).LE.1.0E-5) .AND. (ABS(XT2+RDAYN).LE.1.0E-5))
     *   THEN
         XT1 = 0.0
         XT2 = 9999
         RDAYN = 0
         END IF
C                                       Tweak range a bit (0.5 sec).
      IF (ABS(XT2-XT1).LT.1.E-6) THEN
         XT1 = XT1 - 1.0 / 172800.
         XT2 = XT2 + 1.0 / 172800.
         END IF
C                                       Check that start before finish.
      IF (XT1.GT.XT2) THEN
         WRITE (MSGTXT,1020)
         CALL MSGWRT (6)
         YT1 = RDAYN + XT1 + 1.0 / 172800.
         YT2 = RDAYN + XT2 - 1.0 / 172800.
         GO TO 990
         END IF
C                                       Channel and IF limits
      NFRQS = 1
      KBCH(1)  = VALUE(OFBCH) + 0.1
      KECH(1)  = VALUE(OFECH) + 0.1
      KBIF(1)  = VALUE(OFBIF) + 0.1
      KEIF(1)  = VALUE(OFEIF) + 0.1
      IF ((VALUE(OFBFRQ).GT.0.0D0) .AND. (VALUE(OFBFRQ+1).GT.0.0D0))
     *   THEN
         CALL FNDFRS (KFQID, VALUE(OFBFRQ), KBCH, KECH, KBIF, KEIF,
     *      NFRQS, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Make sure agree with CATBLK
      ELSE
         NOCHAN = CATBLK(KINAX+JLOCF)
         NOIF = 1
         IF (JLOCIF.GT.1) NOIF = CATBLK(KINAX+JLOCIF)
         KBCH(1) = MAX (KBCH(1), 1)
         KBCH(1) = MIN (KBCH(1), NOCHAN)
C                                       Applying channel range?
         KBIF(1) = MAX (KBIF(1), 1)
         KBIF(1) = MIN (KBIF(1), NOIF)
         IF (KEIF(1).LE.0) KEIF(1) = NOIF
         KEIF(1) = MIN (KEIF(1), NOIF)
         END IF
C                                       Antenna and baseline arrays.
      DO 50 I = 1,50
         XNTENN(I) = VALUE(OFANT+I-1)
         XASELN(I) = VALUE(OFBASE+I-1)
 50      CONTINUE
C                                       Convert to baseline numbers.
      NBASE = MAXBAS
      CALL AN10RS (NUMAN, KSUBA, XNTENN, XASELN, NBASE, XA1, XA2)
C                                       Stokes parameter
      XSTOK = VALCH(OFSTOK)(1:4)
C                                       OPCODE
      XOPCO = VALCH(OFOPCO)(1:4)
C                                       Find reason why.
      XEASON = VALCH(OFREA) // VALCH(OFREA+1) // VALCH(OFREA+2)
C                                       Now the secret is out - hide it
C                                       on disk where no one will ever
C                                       see it again.
      DO 60 J = 1,NFRQS
         CALL FLAGUP (XOPCO, LUN, DISK, CNOIN, FGVER, BUFFER, IFGRNO,
     *      FGKOLS, FGNUMV, ID, NID, KSUBA, KFQID, NBASE, XA1, XA2, XT1,
     *      XT2, KBIF(J), KEIF(J), KBCH(J), KECH(J), XSTOK, XEASON, NFL,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
 60      CONTINUE
      WFLAG = WFLAG + NFL
C                                       Fill /FLAGS/ common,
C                                       loop over frequencies
      DO 100 J = 1,NFRQS
C                                       loop over baseline.
         DO 90 I = 1,NBASE
            IF (NFLAG.GE.MXFLAG) THEN
               WRITE (MSGTXT,1070) MXFLAG
               CALL MSGWRT (6)
               IRET = -1
               GO TO 999
               END IF
            NFLAG = NFLAG + 1
            REESON(NFLAG) = XEASON
            FANT1(NFLAG) = MIN (XA1(I), XA2(I))
            FANT2(NFLAG) = MAX (XA1(I), XA2(I))
            IF (FANT1(NFLAG).EQ.0) THEN
              FANT1(NFLAG) = FANT2(NFLAG)
              FANT2(NFLAG) = 0
              END IF
            FLAGT1(NFLAG) = XT1
            FLAGT2(NFLAG) = XT2
            FIFLIM(1,NFLAG) = KBIF(J)
            FIFLIM(2,NFLAG) = KEIF(J)
            FCHLIM(1,NFLAG) = KBCH(J)
            FCHLIM(2,NFLAG) = KECH(J)
            FSUBA(NFLAG) = KSUBA
            FFQID(NFLAG) = KFQID
C                                       Get flagging parms
            CALL FLGSTK (XSTOK, XOPCO, FFLAGS(1,NFLAG), FSET, IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Let us not keep the
C                                       **** "REASON WHY" ****
C                                       a secret, tell the world!!!
            IF ((NMESS.EQ.NECHO+1) .AND. (NECHO.GT.0)) THEN
               MSGTXT = 'Too many reasons, will suppress printing'
               CALL MSGWRT (6)
               END IF
            IF ((NMESS.EQ.0) .AND. (NECHO.GT.0)) THEN
               WRITE (MSGTXT,1030)
               CALL MSGWRT (4)
               END IF
            IF (NMESS.LE.NECHO) THEN
               YT1 = RDAYN + XT1 + 1.0 / 172800.
               YT2 = RDAYN + XT2 - 1.0 / 172800.
               CALL TODHMS (YT1, TIM1)
               CALL TODHMS (YT2, TIM2)
               SEC1 = VALUE(OFTIME+3)
               SEC2 = VALUE(OFTIME+7)
               WRITE (MSGTXT,1031) FANT1(NFLAG), FANT2(NFLAG), KBIF(J),
     *            KEIF(J), TIM1(1), TIM1(2), TIM1(3), SEC1, TIM2(1),
     *            TIM2(2), TIM2(3), SEC2, XEASON
               IF (MSGTXT(22:22).EQ.' ') MSGTXT(22:22) = '0'
               IF (MSGTXT(36:36).EQ.' ') MSGTXT(36:36) = '0'
               CALL MSGWRT (4)
               END IF
            NMESS = NMESS + 1
 90         CONTINUE
 100     CONTINUE
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('ERROR: TIME1 > TIME2')
 1030 FORMAT (' ANTs  IFs ',4X,'Time1',9X,'Time2',6X,'Reason')
 1031 FORMAT (I2,2I3,'-',I2,2(I3.2,'/',I2.2,':',I2.2,':',F4.1),1X,A)
 1070 FORMAT ('WARNING: ONLY FIRST ',I5,' ENTRIES HAVE BEEN USED')
 1080 FORMAT ('UVFTAB:NO MATCH TO FQID IN DATA - CHECK VALUE IN TABLE')
      END
      SUBROUTINE FNDFRS (KFQID, VALUEF, KBCH, KECH, KBIF, KEIF, NFRQS,
     *   IRET)
C-----------------------------------------------------------------------
C   FNDFRQ finds the combinations of BCHAN, ECHAN BIF, EIF that match
C   the requested frequencies
C   Inputs:
C      KFQID    I      Frequency ID number
C      VALUEF   D(2)   Begin and end frequencies
C   In/out
C      KBCH     I(*)   Begin channel : must be zero on input
C      KECH     I(*)   End channel
C      KBIF     I(*)   Begin IF
C      KEIF     I(*)   End IF
C   Output:
C      NFRQS    I      Number of frequencies found: 0 is not an error
C      IRET     I      error
C-----------------------------------------------------------------------
      INTEGER   KFQID, KBCH(*), KECH(*), KBIF(*), KEIF(*), NFRQS, IRET
      DOUBLE PRECISION VALUEF(2)
C
      INCLUDE 'UVFLG.INC'
      INTEGER   VER, LUN, NIF, CURFQ, IFQ, NCHAN, I, IROUND
      REAL      RTEMP
      DOUBLE PRECISION FLIMIT(2,MAXIF)
      SAVE CURFQ, FLIMIT, NIF, NCHAN
      INCLUDE 'INCS:DCHND.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA CURFQ /-1000/
C-----------------------------------------------------------------------
C                                       get frequencies
      IFQ = MAX (1, KFQID)
      IF (CURFQ.NE.IFQ) THEN
         NCHAN = CATBLK(KINAX+JLOCF)
         CALL FNDEXT ('FQ', CATBLK, VER)
         FQCHND = IFQ
         LUN = 55
         CALL CHNDAT ('READ', IBUFF, DISK, CNOIN, VER, CATBLK, LUN, NIF,
     *      FOFF, ISBAND, FINC, BNDCOD, FQCHND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING FREQUENCY TABLE'
            GO TO 990
            END IF
         CURFQ = FQCHND
         DO 10 I = 1,NIF
            FLIMIT(1,I) = CATD(KDCRV+JLOCF) + FOFF(I) +
     *         FINC(I) * (0.5 - CATR(KRCRP+JLOCF))
            FLIMIT(2,I) = CATD(KDCRV+JLOCF) + FOFF(I) +
     *         FINC(I) * (NCHAN + 0.5 - CATR(KRCRP+JLOCF))
 10         CONTINUE
         END IF
C                                       check for overuse
      IF ((KBIF(1).GT.0) .OR. (KEIF(1).GT.0) .OR. (KBCH(1).GT.0) .OR.
     *   (KECH(1).GT.0)) THEN
         MSGTXT = 'BFREQ & EFREQ WERE SPECIFIED BUT ALSO'
         CALL MSGWRT (7)
         WRITE (MSGTXT,1010) KBIF(1), KEIF(1), KBCH(1), KECH(1)
         IRET = -1
         GO TO 990
         END IF
      IRET = 0
C                                       take a look
      NFRQS = 0
      VALUEF(1) = VALUEF(1) * 1.D6
      VALUEF(2) = VALUEF(2) * 1.D6
      DO 50 I = 1,NIF
         IF (FINC(I).GT.0.0) THEN
            IF ((VALUEF(1).LE.FLIMIT(2,I)) .AND.
     *         (VALUEF(2).GE.FLIMIT(1,I))) THEN
               NFRQS = NFRQS + 1
               KBIF(NFRQS) = I
               KEIF(NFRQS) = I
               IF (VALUEF(1).LT.FLIMIT(1,I)) THEN
                  KBCH(NFRQS) = 1
               ELSE
                  RTEMP = NCHAN * (VALUEF(1) - FLIMIT(1,I)) /
     *               (FLIMIT(2,I) - FLIMIT(1,I)) + 0.5
                  KBCH(NFRQS) = IROUND (RTEMP)
                  END IF
               IF (VALUEF(2).GE.FLIMIT(2,I)) THEN
                  KECH(NFRQS) = NCHAN
               ELSE
                  RTEMP = NCHAN * (VALUEF(2) - FLIMIT(1,I)) /
     *               (FLIMIT(2,I) - FLIMIT(1,I)) + 0.5
                  KECH(NFRQS) = IROUND (RTEMP)
                  END IF
               KBCH(NFRQS) = MAX (1, MIN (NCHAN, KBCH(NFRQS)))
               KECH(NFRQS) = MAX (1, MIN (NCHAN, KECH(NFRQS)))
               END IF
         ELSE
            IF ((VALUEF(1).LE.FLIMIT(1,I)) .AND.
     *         (VALUEF(2).GE.FLIMIT(2,I))) THEN
               NFRQS = NFRQS + 1
               KBIF(NFRQS) = I
               KEIF(NFRQS) = I
               IF (VALUEF(1).LT.FLIMIT(2,I)) THEN
                  KBCH(NFRQS) = NCHAN
               ELSE
                  RTEMP = NCHAN + 0.5 - NCHAN * (VALUEF(1)-FLIMIT(2,I))
     *               / (FLIMIT(1,I) - FLIMIT(2,I))
                  KBCH(NFRQS) = IROUND (RTEMP)
                  END IF
               IF (VALUEF(2).GE.FLIMIT(1,I)) THEN
                  KECH(NFRQS) = 1
               ELSE
                  RTEMP = NCHAN + 0.5 - NCHAN * (VALUEF(2)-FLIMIT(2,I))
     *               / (FLIMIT(1,I) - FLIMIT(2,I))
                  KECH(NFRQS) = IROUND (RTEMP)
                  END IF
               KBCH(NFRQS) = MAX (1, MIN (NCHAN, KBCH(NFRQS)))
               KECH(NFRQS) = MAX (1, MIN (NCHAN, KECH(NFRQS)))
               END IF
            END IF
 50      CONTINUE
C
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FNDFRS ERROR',I4,' ON ',A)
 1010 FORMAT ('BIF=',I3,' EIF=',I3,' BCHAN=',I7,' ECHAN=',I7)
      END
      SUBROUTINE ALLSOU (DISK, CNO, CAT, CALKOD, KUAL, BUFFER, ID, NID,
     *   IRET)
C-----------------------------------------------------------------------
C   all source identifiers in the SU table matching calcode and qual
C   Inputs:
C      DISK      I       Disk number of the data set.
C      CNO       I       Catalog slot number of data set.
C      CAT       I(256)  Catalog header.
C   Input/Output:
C      BUFFER    I(512)  Work buffer, used for I/O and manipulating
C                        source lists, should be at least min (512,NID)
C   Output:
C      ID        I(*)    Source ID numbers of selected sources,
C      NID       I       Number of elements returned in ID.
C      IRET      I       Return code. 0 => OK; else failed.
C   Usage notes:
C       This routine uses AIPS LUN 27 which will be closed on normal
C       return. Version 1 of the source table is assumed.
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, CAT(256), KUAL, BUFFER(*), ID(*), NID, IRET
      CHARACTER CALKOD*4
C
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4
      INTEGER   VER, LUN, IDKOL, SUKOL, IDSOU, SQUAL, NUMIF, ISURNO,
     *   NUMREC, I4, SUFQID
      LOGICAL   EQUAL
      DOUBLE PRECISION    BANDW, RAEPO, DECEPO, EPOCH, RAAPP, DECAPP,
     *   PMRA, PMDEC, RAOBS, DECOBS
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   SUKOLS(MAXSUC), SUNUMV(MAXSUC)
      REAL      FLUX(4,MAXIF)
      DOUBLE PRECISION LSRVEL(MAXIF), FREQO(MAXIF), RESTFQ(MAXIF)
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (IDKOL, SUKOLS(1)),   (SUKOL, SUKOLS(2))
      DATA VER, LUN /1, 27/
C-----------------------------------------------------------------------
C                                       Setup
      NID = 0
      IRET = 0
C                                       Initialize SOURCE table.
      CALL SOUINI ('READ', BUFFER, DISK, CNO, VER, CAT, LUN, NUMIF,
     *   VELTYP, VELDEF, SUFQID, ISURNO, SUKOLS, SUNUMV, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING SOURCE TABLE'
         GO TO 990
         END IF
C                                       Get number of entries
      NUMREC = BUFFER(5)
      NID = 0
C                                       Loop through source records.
      DO 500 ISURNO = 1,NUMREC
C                                       Read record
         I4 = ISURNO
         CALL TABSOU ('READ', BUFFER, I4, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, SQUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA,
     *      PMDEC, IRET)
C                                       See is source record turned off
         IF (IRET.LT.0) GO TO 500
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING SOURCE TABLE'
            GO TO 990
            END IF
C                                       is qualifier OK, too?
         EQUAL = ((KUAL.LT.0) .OR. (KUAL.EQ.SQUAL))
C                                       calcode
         IF (CALKOD.NE.' ') EQUAL = EQUAL .AND. ((CALKOD.EQ.CALCOD) .OR.
     *      ((CALKOD.EQ.'*') .AND. (CALCOD.NE.' ')) .OR.
     *      ((CALKOD.EQ.'-CAL') .AND. (CALCOD.EQ.' ')))
         IF (EQUAL) THEN
            NID = NID + 1
            ID(NID) = IDSOU
            END IF
500      CONTINUE
C                                       Close Source table
      CALL TABIO ('CLOS', 0, I4, BUFFER, BUFFER, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ALLSOU: ERROR ',I3,' ON ',A)
      END
      SUBROUTINE FLAGEL (FGLUN, FGBUFF, IFGRNO, FGKOLS, FGNUMV,
     *   SUBA, STARTD, STOPD, FQID, FGOPEN, ELEVTL, ELEVTH, IRET)
C-----------------------------------------------------------------------
C   Updates the flag table (FG) to flag all data at the given
C   interval of elevation.
C   Inputs:
C      FGLUN    I        Logical unit number to use
C      SUBA     I        Subarray number.
C      STARTD   R        Start of the data (days)
C      STOPD    R        Stop  of the data (days)
C      FQID     I        Freqid number
C      ELEVTL   R        Lower elevation threshold (degrees)
C      ELEVTH   R        Upper elevation threshold (degrees)
C   Input from common:
C      OPCODE   C*4      Operation desired, 'FLAG'=> make entry,
C                        'UFLG' => deselect selected prev. entries.
C      STOKES   C*4      Stokes parameter desired
C      DISK     I        Disk to use.
C      CNOIN    I        Catalog slot number
C      FGVER    I        FG file version
C      XANTS    R(50)    List of antennas
C   Input/Output:
C      FGBUFF   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      IFGRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      FGKOLS   I(8)     The column pointer array in order, SOURCE,
C                        SUBARRAY, ANTS, TIMERANG, IFS, CHANS, PFLAGS,
C                        REASON
C      FGNUMV   I(*)     Element count in each column.
C   Output:
C      FGOPEN   L        FG table was open
C      IRET     I        Error code, 0=>OK else TABIO error.
C                        Note: -1 => read, but record deselected.
C-----------------------------------------------------------------------
      INTEGER   FGLUN, FGBUFF(*), IFGRNO, FGKOLS(*), FGNUMV(*), SUBA,
     *   FQID, IRET
      REAL      STARTD, STOPD, ELEVTL, ELEVTH
      LOGICAL   FGOPEN
C
      CHARACTER FILE*48
      CHARACTER LREAS*24
      INTEGER   SOUID, OLDSOU, IA1, IA2, IROUND, SID, XCOUNT, IVER,
     *   FIND, BIND, VO, BO, LENBU, NMCOR, NIO,IPOINT, J, ISUBA, LUNSS,
     *   LUNUV, LANT, JSUB, JSUB1, JSUB2, LFQID, NFL, VCOUNT, IDUM(2),
     *   LD1(2), LD2(2)
      LOGICAL   T, F, PLANET
      REAL      TIME, TIMOLD, BLTEMP, HA, EL1, AZ, TIMST, TIMEN, TINT,
     *   TDIF
      DOUBLE PRECISION TIMED, DRA, DDEC
      INCLUDE 'UVFLG.INC'
      INCLUDE 'INCS:PUVD.INC'
      REAL      TBEG(MAXANT), TEND(MAXANT)
      LOGICAL   ANTOK(MAXANT), ANTREV
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA LUNSS /25/
      DATA LUNUV, BO, VO /16, 1, 0/
C-----------------------------------------------------------------------
      TINT = 0.09/24.0/3.6E3
      TDIF = TINT
      LREAS = 'ELEVATION RANGE EXCLUDED'
      IF (REASON.NE.' ') LREAS = REASON
      CALL FNDEXT ('AN', CATBLK, ISUBA)
      IF ((SUBA.GT.0) .AND. (SUBA.LE.ISUBA)) THEN
         JSUB1 = SUBA
         JSUB2 = SUBA
      ELSE
         JSUB1 = 1
         JSUB2 = ISUBA
         END IF
C                                       Check ANTENNAS
      CALL LFILL (MAXANT, .FALSE., ANTOK)
      ANTREV = .FALSE.
      IA2 = 0
      DO 10 J = 1,50
         IA1 = IROUND (XANTS(J))
         IF (IA1.LT.0) THEN
            ANTREV = .TRUE.
            IA1 = -1
            END IF
         IF (IA1.GT.0) THEN
            ANTOK(IA1) = .TRUE.
            IA2 = J
         ELSE
            GO TO 15
            END IF
 10      CONTINUE
 15   IF (IA2.EQ.0) THEN
         CALL LFILL (MAXANT, .TRUE., ANTOK)
      ELSE IF (ANTREV) THEN
         DO 20 J = 1,MAXANT
            ANTOK(J) = .NOT.ANTOK(J)
 20         CONTINUE
         END IF
C                                       Open for Read.
      LENBU = 450
      LENBU = 0
      LFQID = 1
      IVER = 1
      CALL ZPHFIL ('UV', DISK, FCNO(1), IVER, FILE, IRET)
      CALL ZOPEN (LUNUV, FIND, DISK, FILE, T, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING UV FILE'
         GO TO 990
         END IF
      DO 200 JSUB = JSUB1,JSUB2
C                                       get antenna info this subarray
         CALL GETANT (DISK, CNOIN, SUBA, CATBLK, IBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'GETTING ANTENNAS FOR IF', JSUB
            GO TO 990
            END IF
         CALL JULDAY (RDATE, JD0)
         CALL UVINIT ('READ', LUNUV, FIND, NVIS, VO, LREC, LENBU, BUFSZ,
     *      BUFF, BO, BIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT READ UV FILE'
            GO TO 990
            END IF
         XCOUNT = 0
         VCOUNT = 0
         NMCOR = LREC - NRPARM
C                                       initialize the begin of flag
C                                       intervals
         CALL RFILL (MAXANT, -1000.0, TBEG)
         TIMOLD = -1.E6
         OLDSOU = -1
C                                       Start looping thru data.
C                                       Read buffer.
 50      XCOUNT = XCOUNT + 1
         CALL UVDISK ('READ', LUNUV, FIND, BUFF, NIO, BIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'READING UV BLOCK', XCOUNT
            GO TO 990
            END IF
         IPOINT = BIND
C                                       Loop through the data
         DO 100 J = 1,NIO
            VCOUNT = VCOUNT + 1
            IF (MOD(VCOUNT,100000).EQ.0) THEN
               WRITE (MSGTXT,1055) VCOUNT
               CALL MSGWRT (2)
               END IF
C                                       Decode time.
            TIME = BUFF(IPOINT+ILOCT)
C                                       Determine FQ ID
            IF (ILOCFQ.GT.-1) LFQID = IROUND (BUFF(IPOINT+ILOCFQ))
C                                       Determine subarray
            IF (ILOCB.GE.0) THEN
               BLTEMP = BUFF(IPOINT+ILOCB)
               IA1 = BLTEMP / 256. + 0.1
               BLTEMP = BLTEMP - IA1 * 256
               IA2 = BLTEMP + 0.1
               ISUBA = 100.0 * (BLTEMP - IA2) + 1.5
            ELSE
               IA1 = BUFF(IPOINT+ILOCA1) + 0.1
               IA1 = BUFF(IPOINT+ILOCA2) + 0.1
               ISUBA = BUFF(IPOINT+ILOCSA) + 0.1
               END IF
C                                       check time range, etc
            IF ((TIME.GE.STARTD) .AND. (TIME.LE.STOPD+1.16D-4) .AND.
     *         ((ISUBA.LE.0) .OR. (ISUBA.EQ.JSUB)) .AND.
     *         ((FQID.LE.0) .OR. (LFQID.EQ.FQID))) THEN
C                                       get source
               SOUID = 0
               IF (ILOCSU.GT.-1) SOUID = BUFF(IPOINT+ILOCSU)
C                                       Clear pending time intervals
               IF (SOUID.NE.OLDSOU) THEN
                  DO 60 LANT = 1,NSTNS
                     IF (TBEG(LANT).GT.-999.0) THEN
                        TIMST = TBEG(LANT)
                        TIMEN = TEND(LANT)
                        IDUM(1) = OLDSOU
                        LD1(1) = LANT
                        LD2(1) = 0
                        CALL FLAGUP (OPCODE, FGLUN, DISK, CNOIN, FGVER,
     *                     FGBUFF, IFGRNO, FGKOLS, FGNUMV, IDUM, 1,
     *                     JSUB, FQID, 1, LD1, LD2, TIMST, TIMEN, 1, 0,
     *                     1, 0, STOKES, LREAS, NFL, IRET)
                        IF (IRET.NE.0) GO TO 999
                        TBEG(LANT) = -1000.0
                        FGOPEN = .TRUE.
                        WFLAG = WFLAG + NFL
                        END IF
 60                  CONTINUE
C                                       Check sources
                  IF (ID(1).GT.0) THEN
                     DO 70 SID = 1,NID
                        IF (SOUID.EQ.ID(SID)) GO TO 75
 70                     CONTINUE
                     GO TO 90
                     END IF
                  END IF
C                                       skip times closer 0.1sec
 75            IF (TIME-TIMOLD.GT.TDIF) THEN
                  CALL FNDCOO (0, JD0, SOUID, DISK, CNOIN, CATBLK,
     *               LUNSS, TIME, DRA, DDEC, PLANET, IRET)
                  IF (IRET.GT.0) GO TO 999
                  OLDSOU = SOUID
                  TIMOLD = TIME
C                                       Start estimating of the flag
C                                       intervals for all antennas
C                                       for the given source
                  DO 80 LANT = 1,NSTNS
C                                       TIMED double precision
                     TIMED = TIME
                     CALL COOELV (LANT, TIMED, DRA, DDEC, HA, EL1, AZ)
                     IF (EL1.LT.-90) GO TO 80
                     EL1 = EL1 * RAD2DG
C                                       flag this point
                     IF ((EL1.GT.ELEVTL) .AND. (EL1.LT.ELEVTH) .AND.
     *                  (ANTOK(LANT))) THEN
                        IF (TBEG(LANT).LT.-999.0) TBEG(LANT) = TIME-TINT
                        TEND(LANT) = TIME + TINT
C                                       Do not flag this point
                     ELSE
C                                       But flag pending
                        IF (TBEG(LANT).GT.-999.0) THEN
                           TIMST = TBEG(LANT)
                           TIMEN = TEND(LANT)
                           IDUM(1) = OLDSOU
                           LD1(1) = LANT
                           LD2(1) = 0
                           CALL FLAGUP (OPCODE, FGLUN, DISK, CNOIN,
     *                        FGVER, FGBUFF, IFGRNO, FGKOLS, FGNUMV,
     *                        IDUM, 1, JSUB, FQID, 1, LD1, LD2, TIMST,
     *                        TIMEN, 1, 0, 1, 0, STOKES, LREAS, NFL,
     *                        IRET)
                           IF (IRET.NE.0) GO TO 999
                           TBEG(LANT) = -1000.0
                           FGOPEN = .TRUE.
                           WFLAG = WFLAG + NFL
                           END IF
                        END IF
 80                  CONTINUE
                  END IF
               END IF
C                                       Update IPOINT
 90         IPOINT = IPOINT + LREC
 100        CONTINUE
         IF (NIO.GT.0) GO TO 50
C                                       Clear pending time intervals
         DO 110 LANT = 1,NSTNS
            IF (TBEG(LANT).GT.-999.0) THEN
               TIMST = TBEG(LANT)
               TIMEN = TEND(LANT)
               IDUM(1) = OLDSOU
               LD1(1) = LANT
               LD2(1) = 0
               CALL FLAGUP (OPCODE, FGLUN, DISK, CNOIN, FGVER, FGBUFF,
     *            IFGRNO, FGKOLS, FGNUMV, IDUM, 1, JSUB, FQID, 1,
     *            LD1, LD2, TIMST, TIMEN, 1, 0, 1, 0, STOKES, LREAS,
     *            NFL, IRET)
               IF (IRET.NE.0) GO TO 999
               TBEG(LANT) = -1000.0
               FGOPEN = .TRUE.
               WFLAG = WFLAG + NFL
               END IF
 110        CONTINUE
 200     CONTINUE
C                                       Close file.
      CALL ZCLOSE (LUNUV, FIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING UV FILE'
         CALL MSGWRT (6)
         END IF
      IRET = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FLAGEL: ERROR:',I4,' ON',A)
 1010 FORMAT ('FLAGEL ERROR:',I4,' ON ',A,I4)
 1055 FORMAT ('FLAGEL: at vis record',I10)
      END
      SUBROUTINE FLGPCL (LUN, FGBUFF, IFGRNO, FGKOLS, FGNUMV, FACTOR,
     *   SUBA, WSBLNK, STARTD, STOPD, BIF, EIF, BCHAN, ECHAN, FGOPEN,
     *   IRET)
C-----------------------------------------------------------------------
C   Updates the flag table (FG) to flag all data in the vicinity of
C   zero fringe rate.
C   Inputs:
C      LUN      I        Logical unit number to use
C      FACTOR   R        Suppression of PCCAL
C      SUBA     I        Subarray number.
C      WSBLNK   L        True if all selected sources are blank
C      STARTD   R        Selected start time, days
C      STOPD    R        Selected stop time, days
C      BIF      I        First IF number to flag. 0=>all
C      EIF      I        Last IF number to flag. 0=>all higher than BIF
C      BCHAN    I        First channel number to flag. 0=>all
C      ECHAN    I        Last channel number to flag. 0=>all higher.
C   Input from common:
C      OPCODE   C*4      Operation desired, 'FLAG'=> make entry,
C                        'UFLG' => deselect selected prev. entries.
C      XANTS    R(*)     List of selected ANTENNA
C      XBASE    R(*)     List of selected BASELINE
C      STOKES   C*4      Stokes parameter desired
C      DISK     I        Disk to use.
C      CNOIN    I        Catalog slot number
C      FGVER      I      FG file version
C      NXANT    I        Number of selected antennas
C      TELN     I(*)     Array of selected antennas
C      FRQSEL   I        Freqid number
C   Input/Output:
C      FGBUFF   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      IFGRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      FGKOLS   I(8)     The column pointer array in order, SOURCE,
C                        SUBARRAY, ANTS, TIMERANG, IFS, CHANS, PFLAGS,
C                        REASON
C      FGNUMV   I(8)     Element count in each column.
C   Output:
C      FGOPEN   L        FG table was open
C      IRET     I        Error code, 0=>OK else TABIO error.
C                        Note: -1 => read, but record deselected.
C-----------------------------------------------------------------------
      INTEGER   LUN, FGBUFF(*), IFGRNO, FGKOLS(*), FGNUMV(*), SUBA,
     *   BIF, EIF, BCHAN, ECHAN, IRET
      REAL      FACTOR, STARTD, STOPD
      LOGICAL   WSBLNK, FGOPEN
      CHARACTER PCREAS*24
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NXVER, BUFFNX(512), LUNI, INXRNO, NXKOLS(MAXNXC),
     *   NXNUMV(MAXNXC), NUMBNX, ISUB, VSTART, VEND, FRID, SID, IDUM(2),
     *   INDSOU, AN1(MXBASE), AN2(MXBASE), NNBASE, IBASE, IK, ANTEM1,
     *   ANTEM2, ANTE(MXBASE), ANT1, ANT2, LUNSS, MAXBAS, I, K, NT0,
     *   IROUND, NSELIF, IFQ, KIF, BIFF, EIFF, IERR, IDAY, IHOUR, IMIN,
     *   NFL, ID1(2), ID2(2), FQD
      EQUIVALENCE (ANT1, ID1), (ANT2, ID2)
C                                       FQ table start
      INTEGER   LUNF, IFQRNI, NFQID, NUMIF, FQFID(MAXFQC),
     *   IFSIDE(MAXIF), FQID, FQVER, MXFQID, MXFQIF, NROW, IND
      REAL      FQKOLS(MAXFQC), FQNUMV(MAXFQC), IFCHW(MAXIF),
     *   IFTBW(MAXIF), HOUR, MINUT, SEC
      PARAMETER (MXFQIF = MAXIF*MAXFQC)
      DOUBLE PRECISION IFFREQ(MAXIF), DFIF(MXFQIF)
      CHARACTER BNDCOD(MAXIF)*8
C                                       FQ table end
      REAL      RTIME, DTIME, TST, TEN, FR, BXY, DELTAT, DAYTIM,
     *   TLEFT, TRIGHT, TMED, XY, X, Y, ALFAB, S0, T0, TSTINI, TENINI
      DOUBLE PRECISION  XANTE(100), YANTE(100), U, V, HA, Z
      LOGICAL TABL, EXIST, FITASC, OURS, OURST, OUT
      INCLUDE 'UVFLG.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUNI, LUNSS, LUNF /16, 25, 28/
      DATA MAXBAS /MXBASE/
C-----------------------------------------------------------------------
C                                       print out the Factor of
C                                       suppression
      WRITE (MSGTXT,1100) FACTOR
      CALL MSGWRT (4)
C                                       Block to read FQ table to find
C                                       correction to the frequency for
C                                       each IF and finally calculate
C                                       lambdas
      MXFQID = MAXFQC
      IRET = 0
      FQVER = 1
C                                       Open FQ table
      CALL FQINI ('READ', BUFFNX, DISK, CNOIN, FQVER, CATBLK, LUNF,
     *   IFQRNI, FQKOLS, FQNUMV, NUMIF, IRET)
      IF (IRET.EQ.0) THEN
         NROW = BUFFNX(5)
         DO 30 I = 1, NROW
            CALL TABFQ ('READ', BUFFNX, IFQRNI, FQKOLS, FQNUMV, NUMIF,
     *         FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING FQ TABLE'
               GO TO 990
               END IF
C                                       take DFREQ for all available
C                                       IFs and FQIDs
            IF (FRQSEL.LE.0) THEN
               NFQID = NROW
               FQFID(I) = FQID
               DO 10 K = 1, NUMIF
                  IND = K + (I - 1) * NUMIF
                  DFIF(IND) = IFFREQ(K)
 10               CONTINUE
C                                       take DFREQ only for selected
C                                       FQID for all available IFs
            ELSE
               NFQID = 1
               IF (FRQSEL.EQ.FQID) THEN
                  FQFID(1) = FQID
                  DO 20 K = 1, NUMIF
                     IND = K
                     DFIF(IND) = IFFREQ(K)
 20                  CONTINUE
                  GO TO 35
                  END IF
               END IF
 30         CONTINUE
C                                       given FRQSEL is not found at
C                                       the FQ table
         IF (FRQSEL.GT.0) THEN
            WRITE (MSGTXT,1030) FRQSEL
            GO TO 990
            END IF
C                                       close FQ table
 35      CALL TABIO ('CLOS', 0, IFQRNI, BUFFNX, BUFFNX, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING FQ TABLE'
            GO TO 990
            END IF
      ELSE
         NFQID = MXFQID
         DO 45 I = 1, MXFQID
            DO 40 K = 1, NOMIF
               IND = K + (I - 1) * NOMIF
               DFIF(IND) = 0
 40            CONTINUE
 45         CONTINUE
         END IF
C                                       number of selected IFs
      NSELIF = EIF - BIF + 1
C                                       frequency from AN table header
      FR = SAFREQ
      S0 = GSTIAT
      DAYTIM = 1.0 / 1.002738
      PCREAS = 'small fringe rate'
      IF (REASON(1:1).NE.' ') PCREAS=REASON

C                                       Determine actual number of
C                                       baseline and list of the first
C                                       and second antennas
C                                       Convert to baseline numbers.
      NNBASE = MAXBAS
      CALL AN10RS (NUMAN, FSUBA(1), XANTS, XBASE, NNBASE, AN1, AN2)
C                                       Use STNRAD, STNLON, STNLAT
C                                       (output of GETANT in DANS.INC)
C                                       They and only they (not STNY)
C                                       are treated for different
C                                       coordinate system of VLA, VLBA,
C                                       ATCA. STNLON is to EAST.
      DO 50 K = 1, NSTNS
         ANTEM1 = TELNO(K)
         XY = STNRAD(ANTEM1) * COS(STNLAT(ANTEM1))
         XANTE(ANTEM1) = XY * COS(STNLON(ANTEM1))
C                                       transform to Left hand
         YANTE(ANTEM1) = -XY * SIN(STNLON(ANTEM1))
 50      CONTINUE
C                                       XLONG is west longtitute
      IF ((NNBASE.EQ.1).AND.(AN1(1).EQ.0).AND.(AN2(1).EQ.0)) THEN
C                                       all baseline are selected
C                                       ANTENNAS=0, BASELINE=0
C                                       Case #1 at AN10RS
         NNBASE = 0
         DO 70 I = 1, NSTNS
C                                       skip antennas with zeros
C                                       coordinates
C                                       such a behavior of STNY,
C                                       STNZ is a GETANT feature
            IF ((STNX(I).LE.1.D2) .AND. (STNY(I).LE.1.D2) .AND.
     *         (STNZ(I).LT.1.D2)) GO TO 70
            DO 60 K = I+1,NSTNS
C                                       skip antennas with zeros
C                                       coordinates
               IF ((STNX(K).LT.1.D2) .AND. (STNY(K).LE.1.D2) .AND.
     *            (STNZ(K).LT.1.D2)) GO TO 60
               NNBASE = NNBASE + 1
               AN1(NNBASE) = TELNO(I)
               AN2(NNBASE) = TELNO(K)
 60            CONTINUE
 70        CONTINUE
      ELSE
C
         IF ((AN1(1) .NE. 0) .AND. (AN2(1).EQ.0)) THEN
C                                       Baselines ANTENNAS with any
C                                       antennas or BASELINE with
C                                       any antennas selected
C                                       ANTENNAS.EQ.0 and BASELINE.GT.0
C                                  .OR. ANTENNAS.GT.0 and BASELINE.EQ.0
C                                       Case #2 at AN10RS
            DO 90 I = 1,NNBASE
               ANTE(I) = AN1(I)
 90            CONTINUE
            IBASE = 0
            DO 130 I = 1, NNBASE
               ANTEM1 = ANTE(I)
               DO 120 K = 1,NSTNS
                  ANTEM2 = TELNO(K)
C                                       skip antennas with zeros
C                                       coordinates
                  IF (((STNX(ANTEM1).LT.1.D2) .AND.
     *               (STNY(ANTEM1).LT.1.D2) .AND.
     *               (STNZ(ANTEM1).LT.1.D2)) .OR.
     *               ((STNX(ANTEM2).LT.1.D2) .AND.
     *               (STNY(ANTEM2).LT.1.D2) .AND.
     *               (STNZ(ANTEM2).LT.1.D2))) GO TO 120
C                                       skip identical antennas
                  IF (ANTE(I).EQ.TELNO(K)) GO TO 120
C
                  DO 110 IK = 1, I-1
C                                       skip identical baseline
                     IF (ANTE(IK).EQ.TELNO(K)) GO TO 120
 110                 CONTINUE
                  IBASE = IBASE + 1
                  AN1(IBASE) = ANTE(I)
                  AN2(IBASE) = TELNO(K)
 120              CONTINUE
 130           CONTINUE
            NNBASE = IBASE
         ELSE
C
            IF ((AN1(1) .NE. 0) .AND. (AN2(1) .NE. 0)) THEN
C                                       Baselines ANTENNAS with
C                                       BASELINE are selected.
C                                       Both ANTENNAS and BASELINE are
C                                       not zero
C                                       Case #3,#4, and #5 at AN10RS
               IBASE = 0
               DO 140 I = 1, NNBASE
                  ANTEM1 = AN1(I)
                  ANTEM2 = AN2(I)
C                                       skip identical antennas
                  IF (ANTEM1.EQ.ANTEM2) GO TO 140
C                                       skip antennas with zeros
C                                       coordinates
                  IF (((STNX(ANTEM1).LT.1.D2) .AND.
     *               (STNY(ANTEM1).LT.1.D2) .AND.
     *               (STNZ(ANTEM1).LT.1.D2)) .OR.
     *               ((STNX(ANTEM2).LT.1.D2) .AND.
     *               (STNY(ANTEM2).LT.1.D2) .AND.
     *               (STNZ(ANTEM2).LT.1.D2))) GO TO 140
                  IBASE = IBASE + 1
                  AN1(IBASE) = ANTEM1
                  AN2(IBASE) = ANTEM2
 140              CONTINUE
               NNBASE = IBASE
               END IF
            END IF
         END IF
C                                       arrange the second antenna
C                                       number is bigger than the
C                                       first one
      DO 150 I = 1,NNBASE
         ANTEM1 = AN1(I)
         ANTEM2 = AN2(I)
         IF (ANTEM1.GT.ANTEM2) THEN
            AN1(I) = ANTEM2
            AN2(I) = ANTEM1
            END IF
 150     CONTINUE
C                                       check if NX table exists
      NXVER = 1
      CALL ISTAB ('NX', DISK, CNOIN, NXVER, LUNI, BUFFNX, TABL,
     *   EXIST, FITASC, IERR)
      IF (.NOT.EXIST) THEN
         IRET = 1
         WRITE (MSGTXT,1400)
         GO TO 990
         END IF
C                                       Open NX table
      CALL NDXINI ('READ', BUFFNX, DISK, CNOIN, NXVER, CATBLK,
     *   LUNI, INXRNO, NXKOLS, NXNUMV, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING NX TABLE'
         GO TO 990
         END IF
C                                       How many entries in NX table
      NUMBNX = BUFFNX(5)

      DO 250 I = 1, NUMBNX
C                                       read the NX table line
         CALL TABNDX ('READ', BUFFNX, INXRNO, NXKOLS, NXNUMV, RTIME,
     *      DTIME, INDSOU, ISUB, VSTART, VEND, FRID, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING NX TABLE'
            GO TO 990
            END IF
C                                       find the sequent number of FRID
C                                       in FQ table
         DO 160 IFQ = 1, NFQID
            FQD = FQFID(IFQ)
            IF (FQD.EQ.FRID) GO TO 165
 160        CONTINUE
         GO TO 250
C                                       Check subarray
 165     OURS = (SUBA.LE.0) .OR. (SUBA.EQ.ISUB)
         IF (.NOT. OURS) GO TO 250
C                                       Check sources
         OURST = .FALSE.
         DO 190 SID = 1, NID
            IF (INDSOU.EQ.ID(SID)) THEN
               CALL GETSOU (INDSOU, DISK, CNOIN, CATBLK, LUNSS, IRET)
               DO 170 K = 1,30
C                                       compare with the list of
C                                       selected soutces
                  IF (WSBLNK .OR. (XSOUR(K).EQ.SNAME)) THEN
                     OURST = .TRUE.
                     GO TO 210
                     END IF
 170              CONTINUE
               END IF
 190        CONTINUE
C
 210     IF (.NOT.OURST) GO TO 250
C                                       start preparing times and
C                                       antennas for flagging
         TST = RTIME - DTIME*0.5
         TEN = RTIME + DTIME*0.5
         OUT = (TST.GT.STOPD) .OR. (TEN.LT.STARTD)
C                                       the source was not observed at
C                                       the selected timerange
         IF (OUT) THEN
            GO TO 250
C                                       store TST, TEN for the given
C                                       scan (source)
         ELSE
            TSTINI = MAX(TST, STARTD)
            TENINI = MIN(TEN, STOPD)
            END IF
C                                       restore TST, TEN for the given
C                                       scan (source)
         DO 230 IBASE = 1,NNBASE
            TST = TSTINI
            TEN = TENINI
            ANT1 = AN1(IBASE)
            ANT2 = AN2(IBASE)
            X = XANTE(ANT2) - XANTE(ANT1)
            Y = YANTE(ANT2) - YANTE(ANT1)
            IF (X.NE.0) THEN
               ALFAB = ATAN2 (Y, X)
            ELSE
               ALFAB = PI / 2
               END IF
C                                       T0 in days
            T0 = (ALFAB - S0 + RAAPP) * DAYTIM / TWOPI
C                                       Remove possible integer
C                                       difference in T0
            TMED = (TST + TEN) / 2.0
C            NT0 = IROUND((TMED - T0) / DAYTIM)
C                                       Fringe rate zeros (as U)
C                                       repeat with period of DAYTIM/2
C                                       not DAYTIM
            NT0 = IROUND((TMED - T0) / (DAYTIM/2))
C           T0 = T0 + NT0 * DAYTIM
            T0 = T0 + NT0 * (DAYTIM/2)
C
            DO 220 KIF = 1,NSELIF
C                                       restore TST, TEN for the given
C                                       scan (source)
               TST = TSTINI
               TEN = TENINI
               BIFF = KIF + BIF -1
               EIFF = BIFF
               IND = BIFF + (IFQ - 1) * NUMIF
C                                       the frequency FR is the sum of
C                                       1. SAFREQ is AN table header
C                                       2. FREQO correction for the
C                                          given source from SU table
C                                       3. DFIF correction for the given
C                                          FREQID and IF from FQ table
               FR = SAFREQ + FREQO(BIFF) + DFIF(IND)
C                                       Baseline projection on equator
C                                       in lambdas
               BXY = SQRT (X*X + Y*Y) * FR / VELITE
C                                       DELTAT time interval of small
C                                       fringe rate
               DELTAT = FACTOR * DAYTIM /
     *            (TWOPI * SQRT (BXY * COS(DECAPP)))
               TLEFT = T0 - (DELTAT/2)
               TRIGHT = T0 + (DELTAT/2)
               OUT = (TST.GT.TRIGHT) .OR. (TEN.LT.TLEFT)
C                                       the interval of small fringe
C                                       rate is out of the given source
C                                       time, or we are not going
C                                       flagging the small fringe
C                                       problem
               IF (OUT) THEN
                  GO TO 220
               ELSE
                  TST = MAX(TST, TLEFT)
                  TEN = MIN(TEN, TRIGHT)
C                                       print flaged time intervals
C                                       for the given IF
                  IF (APARM(4).GT.0) THEN
                     IF (KIF.EQ.1) THEN
C                                       print the source, baseline,
C                                       time and U,V of expected zero
C                                       fringe rate only for the IF=1
                        Z = STNRAD(ANT2)*SIN(STNLAT(ANT2)) -
     *                     STNRAD(ANT1)*SIN(STNLAT(ANT1))
                        HA = (T0 *TWOPI/DAYTIM) + S0 - RAAPP
                        U = (-X * SIN(HA) + Y * COS(HA))* SAFREQ /
     *                     VELITE/1000
                        V = ((X * COS(HA) + Y * SIN(HA)) *SIN(DECAPP)
     *                     -Z*COS(DECAPP)) * SAFREQ / VELITE/1000
                        IDAY = T0
                        HOUR = (T0 - IDAY) * 24
                        IHOUR = HOUR
                        MINUT = (HOUR - IHOUR) * 60
                        IMIN = MINUT
                        SEC = (MINUT - IMIN) * 60
                        WRITE (MSGTXT,1800) SNAME, ANT1, ANT2, IDAY,
     *                     IHOUR, IMIN, SEC, U, V
                        CALL MSGWRT (4)
                        END IF
C
                     IDAY = TST
                     HOUR = (TST - IDAY) * 24
                     IHOUR = HOUR
                     MINUT = (HOUR - IHOUR) * 60
                     IMIN = MINUT
                     SEC = (MINUT - IMIN) * 60
                     WRITE (MSGTXT,1900) BIFF, IDAY, IHOUR, IMIN, SEC
                     IDAY = TEN
                     HOUR = (TEN - IDAY) * 24
                     IHOUR = HOUR
                     MINUT = (HOUR - IHOUR) * 60
                     IMIN = MINUT
                     SEC = (MINUT - IMIN) * 60
                     WRITE (MSGTXT(35:80),1950) IDAY, IHOUR, IMIN, SEC
                     CALL MSGWRT (4)
                     END IF
C                                       put flag line into FG table
                  IDUM(1) = INDSOU
                  CALL FLAGUP (OPCODE, LUN, DISK, CNOIN, FGVER, FGBUFF,
     *               IFGRNO, FGKOLS, FGNUMV, IDUM, 1, SUBA, FQD, 1, ID1,
     *               ID2, TST, TEN, BIFF, EIFF, BCHAN, ECHAN, STOKES,
     *               PCREAS, NFL, IRET)
C                                       Yes, the flag table was open
                  FGOPEN = .TRUE.
                  IF (IRET.GT.0) GO TO 999
                  WFLAG = WFLAG + NFL
                  END IF
 220           CONTINUE
 230        CONTINUE
 250     CONTINUE
C                                       close NX table
      CALL TABIO ('CLOS', 0, INXRNO, BUFFNX, BUFFNX, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING NX TABLE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FLGPCL ERROR',I4,' ON 'A)
 1100 FORMAT ('Suppression factor = ', F4.1)
 1030 FORMAT ('FLGPCL:  FQID', I3, ' is not found in the FQ table')
 1400 FORMAT ('There is no NX table. Run INDXR to get it')
 1800 FORMAT ( A8, I2, ' -', I2, 2X, I1, '/',I2, ':' ,I2, ':', F4.1,
     *   ' U= ', F10.2, ' V= ', F10.2)
 1900 FORMAT ( 10X, 'IF = ', I2, ' | ', I1, '/', I2, ':' ,
     *   I2, ':', F4.1)
 1950 FORMAT ( '- ', I1, '/',I2, ':' ,I2, ':', F4.1)
      END
      SUBROUTINE FLGSUN (LUN, FGBUFF, IFGRNO, FGKOLS, FGNUMV, SUBA,
     *   STARTD, STOPD, DISTNC, FGOPEN, IRET)
C-----------------------------------------------------------------------
C   Updates the flag table (FG) to flag all data in the vicinity of
C   zero fringe rate.
C   Inputs:
C      LUN      I        Logical unit number to use
C      SUBA     I        Subarray number.
C      STARTD   R        Selected start time, days
C      STOPD    R        Selected stop time, days
C      DISTNC   R        Minimum okay Sun distance degrees
C   Input from common:
C      OPCODE   C*4      Operation desired, 'FLAG'=> make entry,
C                        'UFLG' => deselect selected prev. entries.
C      DISK     I        Disk to use.
C      CNOIN    I        Catalog slot number
C      FGVER      I      FG file version
C   Input/Output:
C      FGBUFF   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      IFGRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      FGKOLS   I(8)     The column pointer array in order, SOURCE,
C                        SUBARRAY, ANTS, TIMERANG, IFS, CHANS, PFLAGS,
C                        REASON
C      FGNUMV   I(8)     Element count in each column.
C   Output:
C      FGOPEN   L        FG table was open
C      IRET     I        Error code, 0=>OK else TABIO error.
C                        Note: -1 => read, but record deselected.
C-----------------------------------------------------------------------
      INTEGER   LUN, FGBUFF(*), IFGRNO, FGKOLS(8), FGNUMV(8), SUBA, IRET
      REAL      STARTD, STOPD, DISTNC
      LOGICAL   FGOPEN
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   I, NXVER, BUFFNX(512), LUNI, INXRNO, NXKOLS(MAXNXC),
     *   NXNUMV(MAXNXC), NUMBNX, NXSOUR, ISUB, VSTART, VEND, FRID,
     *   TIME(4), OBSDAY(6), IERR, NFL, SID, IDUM(2), LUNSS, XA1(2),
     *   XA2(2)
      REAL      RTIME, DTIME, BTIME, ETIME
      LOGICAL   EXIST, FITASC, TABL, PLANET
      DOUBLE PRECISION SSEP, DRA, DDEC
      CHARACTER OBSDAT*8, SUREAS*24
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'UVFLG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUNI, LUNSS /32, 25/
      DATA XA1, XA2 /4*0/
C-----------------------------------------------------------------------
C                                       check if NX table exists
      NXVER = 1
      CALL ISTAB ('NX', DISK, CNOIN, NXVER, LUNI, BUFFNX, TABL,
     *   EXIST, FITASC, IERR)
      IF (.NOT.EXIST) THEN
         IRET = 1
         MSGTXT = 'NX TABLE REQUIRED BY SUN DISTANCE FLAGGING'
         GO TO 990
         END IF
C                                       Open NX table
      CALL NDXINI ('READ', BUFFNX, DISK, CNOIN, NXVER, CATBLK,
     *   LUNI, INXRNO, NXKOLS, NXNUMV, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT NX TABLE'
         GO TO 990
         END IF
C                                       How many entries in NX table
      NUMBNX = BUFFNX(5)
      CALL H2CHR (8, 1, CATH(KHDOB), OBSDAT)
      CALL JULDAY (OBSDAT, JD0)
      DO 250 I = 1,NUMBNX
C                                       read the NX table line
         INXRNO = I
         CALL TABNDX ('READ', BUFFNX, INXRNO, NXKOLS, NXNUMV, RTIME,
     *      DTIME, NXSOUR, ISUB, VSTART, VEND, FRID, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING NX TABLE'
            GO TO 990
            END IF
         IF ((RTIME.LT.STARTD) .OR. ((SUBA.NE.0) .AND. (SUBA.NE.ISUB)))
     *      GO TO 250
         IF (RTIME.GT.STOPD) GO TO 300
C                                       To Days Hours Minutes Secs
         READ (OBSDAT,1010) OBSDAY(1), OBSDAY(2), OBSDAY(3)
         CALL TODHMS (RTIME, TIME(1))
         CALL COPY (3, TIME(2), OBSDAY(4))
         OBSDAY(3) = OBSDAY(3) + TIME(1)
C                                       Check sources
         IF (ID(1).GT.0) THEN
            DO 20 SID = 1,NID
               IF (NXSOUR.EQ.ID(SID)) GO TO 30
 20            CONTINUE
            GO TO 250
            END IF
 30      CALL FNDCOO (0, JD0, NXSOUR, DISK, CNOIN, CATBLK, LUNSS,
     *      RTIME, DRA, DDEC, PLANET, IRET)
         IF (IRET.GT.0) GO TO 999
         CALL SUNANG (OBSDAY, DRA*RAD2DG, DDEC*RAD2DG, SSEP)
C                                       put flag line into FG table
         IF (SSEP.LT.DISTNC) THEN
            IDUM(1) = NXSOUR
            BTIME = RTIME - DTIME
            ETIME = RTIME + DTIME
            WRITE (SUREAS,1030) SSEP
            CALL FLAGUP (OPCODE, LUN, DISK, CNOIN, FGVER, FGBUFF,
     *         IFGRNO, FGKOLS, FGNUMV, IDUM, 1, SUBA, FRID, 1, XA1, XA2,
     *         BTIME, ETIME, 0, 0, 0, 0, '1111', SUREAS, NFL, IRET)
C                                       Yes, the flag table was open
            FGOPEN = .TRUE.
            IF (IRET.GT.0) GO TO 999
            WFLAG = WFLAG + NFL
            END IF
 250     CONTINUE
C                                       close NX table
 300  CALL TABIO ('CLOS', 0, INXRNO, BUFFNX, BUFFNX, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING NX TABLE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FLGSUN: ERROR',I4,' ON ',A)
 1010 FORMAT (I4,2I2)
 1030 FORMAT ('UVFLG SUN ANGLE',F6.1)
      END
      SUBROUTINE SUNANG (OBSDAY, RA0, DEC0, SEPN)
C-----------------------------------------------------------------------
C   compute Sun angle to source
C   Inputes:
C      OBSDAY   I(6)   Date of observation: YYY, MM, DD, HH, MM, SS
C      RA0      D      Right Ascension degrees
C      DEC0     D      Declination degrees
C   Output
C      SEPN     D      Separation in degrees
C-----------------------------------------------------------------------
      INTEGER   OBSDAY(6)
      DOUBLE PRECISION RA0, DEC0, SEPN
C
      INCLUDE 'INCS:PSTD.INC'
      DOUBLE PRECISION SUNRA, SUNDEC, SINDEC, COSDEC, SINSUN,
     *   COSSUN, SRA
C-----------------------------------------------------------------------
      SINDEC = SIN (DEC0*DG2RAD)
      COSDEC = COS (DEC0*DG2RAD)
      SRA = RA0 * DG2RAD
      CALL SUNPOS (OBSDAY, SUNRA, SUNDEC)
      SINSUN = SIN (SUNDEC)
      COSSUN = COS (SUNDEC)
      SEPN = SINSUN * SINDEC + COSSUN * COSDEC * COS(SUNRA - SRA)
      IF (SEPN.GT.1.0D0) THEN
         SEPN = 0.0D0
      ELSE
         SEPN = RAD2DG * ACOS (SEPN)
         END IF
C
 999  RETURN
      END
      SUBROUTINE SUNPOS (OBSDAY, SUNRA, SUNDEC)
C-----------------------------------------------------------------------
C   Routine to find sun position.  this is crude, and only accurate to
C   some 10's of arcsec, but should be good enough for what we need
C   here.  I used the algorithm from Meeus, chapter 24, pp151-153.
C   Inputs:
C      OBSDAY   I(6)   Date,time: YYYY, MM, DD, HH, MM, SS
C   Outputs:
C      SUNRA    D      Sun RA in radians
C      SUNDEC   D      Sun Dec in radians
C-----------------------------------------------------------------------
      DOUBLE PRECISION SUNRA, SUNDEC
      INTEGER   OBSDAY(6)

      DOUBLE PRECISION JD, T, L0, M, E, C, SUNLON, V, R, OMEGA,
     *   LAMBDA, SL2000, EPS, EPS0
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      CALL DAT2JD (OBSDAY, JD)
C                                       eqn 24.1
      T = (JD - 2451545.0D0) / 36525.0D0
C                                       eqn 24.2
      L0 = 2.8046645D2 + 3.600076983D4 * T + 3.032D-4 * T * T
 10   IF (L0.LT.0.0D0) THEN
         L0 = L0 + 360.0D0
         GO TO 10
         END IF
 20   IF (L0.GT.360.0D0) THEN
         L0 = L0 - 360.0D0
         GO TO 20
         END IF
C                                       eqn 24.3
      M = 3.575291D2 + 3.59990503D4 * T - 1.559D-4 * T * T -
     *    4.8D-7 * T * T * T
 30   IF (M.LT.0.0D0) THEN
         M = M + 360.0D0
         GO TO 30
         END IF
 40   IF (M.GT.360.0D0) THEN
         M = M - 360.0D0
         GO TO 40
         END IF
C                                       eqn 24.4
      E = 1.6708617D-2 - 4.2037D-5 * T - 1.236D-7 * T * T
      M = M * PI / 180.0D0
      C = SIN (M) * (1.9146D0 - 4.871D-3 * T - 1.4D-5 * T * T) +
     *    SIN (2.0D0*M) * (1.9993D-2 - 1.01D-4 * T) +
     *    SIN (3.0D0*M) * 2.9D-4
      SUNLON = L0 + C
      V = M + C * PI / 180.0D0
C                                       eqn 24.5
      R = 1.000001018 * (1 - E * E) / (1 + E * COS (V))
      OMEGA = 1.2504D2 - 1.934136D3 * T
C                                       we want apparent positions,
C                                       though the difference should be
C                                       small...
C     LAMBDA = SUNLON - 5.69D-3 - 4.78D-3 * SIN (OMEGA * PI / 180.0D0)
      SL2000 = SUNLON - 1.397D-2 * (OBSDAY(1) - 2000.0D0)
      LAMBDA = SL2000 - 5.69D-3 - 4.78D-3 * SIN (OMEGA * PI / 180.0D0)
      EPS0 = 23.0D0 + 26.0D0 / 60.0D0 +
     *   (21.448D0 - 46.815D0 * T - 5.9D-4 * T * T +
     *   1.813D-3 * T * T * T) / 3600.0D0
      EPS = EPS0 + 2.56D-3 * COS (OMEGA * DG2RAD)
      EPS = EPS * DG2RAD
      LAMBDA = LAMBDA * DG2RAD
C                                       eqn 24.6
      SUNRA = ATAN2 (COS (EPS) * SIN (LAMBDA), COS (LAMBDA))
      IF (SUNRA.LT.0.0) SUNRA = SUNRA + 2.0D0 * PI
C                                       eqn 24.7
      SUNDEC = DASIN (SIN (EPS) * SIN (LAMBDA))
C
 999  RETURN
      END
      SUBROUTINE FLAGSH (FGLUN, FGBUFF, IFGRNO, FGKOLS, FGNUMV, SUBA,
     *   STARTD, STOPD, FQID, FGOPEN, SHMIN, CTMIN, IRET)
C-----------------------------------------------------------------------
C   Updates the flag table (FG) to flag all shadowed data
C   Inputs:
C      FGLUN    I        Logical unit number to use
C      SUBA     I        Subarray number.
C      STARTD   R        Start of the data (days)
C      STOPD    R        Stop  of the data (days)
C      FQID     I        Freqid number
C      SHMIN    R        Min baseline in lambda at ref freq shadowing
C      CTMIN    R        Min baseline in lambda for cross talk
C   Input from common:
C      OPCODE   C*4      Operation desired, 'FLAG'=> make entry,
C                        'UFLG' => deselect selected prev. entries.
C      STOKES   C*4      Stokes parameter desired
C      DISK     I        Disk to use.
C      CNOIN    I        Catalog slot number
C      FGVER    I        FG file version
C      XANTS    R(50)    List of antennas
C   Input/Output:
C      FGBUFF   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      IFGRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      FGKOLS   I(8)     The column pointer array in order, SOURCE,
C                        SUBARRAY, ANTS, TIMERANG, IFS, CHANS, PFLAGS,
C                        REASON
C      FGNUMV   I(*)     Element count in each column.
C   Output:
C      FGOPEN   L        FG table was open
C      IRET     I        Error code, 0=>OK else TABIO error.
C                        Note: -1 => read, but record deselected.
C-----------------------------------------------------------------------
      INTEGER   FGLUN, FGBUFF(*), IFGRNO, FGKOLS(*), FGNUMV(*), SUBA,
     *   FQID, IRET
      REAL      STARTD, STOPD, SHMIN, CTMIN
      LOGICAL   FGOPEN
C
      CHARACTER LREAS1*24, LREAS2*24
      INTEGER   SOUID, OLDSOU, IA1, IA2, IROUND, SID, XCOUNT, IVER,
     *   VO, BO, LENBU, NMCOR, ISUBA, LUNSS, LUNUV, LANT, JSUB, JSUB1,
     *   JSUB2, LFQID, NFL, NB, LA1, LA2, VCOUNT, CATSAV(256), IDUM(2),
     *   LD1(2), LD2(2)
      LOGICAL   T, F
      REAL      TIME, TIMOLD, BLTEMP, TIMST, TIMEN, TINT, TDIF,
     *   RPARM(20)
      DOUBLE PRECISION DRA, DDEC
      INCLUDE 'UVFLG.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXB
      PARAMETER (MAXB = MAXANT*MAXANT)
      REAL      TBEG(MAXANT), TEND(MAXANT), TBB(MAXB), TBE(MAXB)
      LOGICAL   ANTBAD(MAXANT), BASBAD(MAXB), PLANET
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA LUNSS /25/
      DATA LUNUV, BO, VO /16, 1, 0/
C-----------------------------------------------------------------------
      TINT = 0.09/24.0/3.6E3
      TDIF = TINT
      LREAS1 = 'antenna shadowing'
      LREAS2 = 'possible cross-talk'
      IF (REASON.NE.' ') LREAS1 = REASON
      CALL FNDEXT ('AN', CATBLK, ISUBA)
      IF ((SUBA.GT.0) .AND. (SUBA.LE.ISUBA)) THEN
         JSUB1 = SUBA
         JSUB2 = SUBA
      ELSE
         JSUB1 = 1
         JSUB2 = ISUBA
         END IF
C                                       Open for Read.
      LENBU = 450
      LENBU = 0
      LFQID = 1
      IVER = 1
      CALL CATDIR ('CSTA', DISK, FCNO(1), NAME, CLASS, SEQ, 'UV',
     *   NLUSER, 'CLWR', BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CHANGING STATUS WITH CLWR'
         GO TO 990
         END IF
      DO 200 JSUB = JSUB1,JSUB2
         WRITE (MSGTXT,1010) JSUB
         CALL MSGWRT (2)
         CALL SEDSEL (NAME, CLASS, SEQ, DISK, JSUB)
C                                       get antenna info this subarray
         CALL GETANT (DISK, CNOIN, JSUB, CATBLK, IBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING ANTENNA INFO', JSUB
            GO TO 990
            END IF
         CALL JULDAY (RDATE, JD0)
C                                       protect header
         CALL COPY (256, CATBLK, CATSAV)
         CALL UVGET ('INIT', RPARM, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1001) IRET, 'OPEN FOR READ', JSUB
            CALL MSGWRT (6)
            GO TO 200
            END IF
         CALL COPY (256, CATSAV, CATBLK)
         CALL CATDIR ('CSTA', DISK, FCNO(1), NAME, CLASS, SEQ, 'UV',
     *      NLUSER, 'CLRD', BUFF, IRET)
         XCOUNT = 0
         VCOUNT = 0
         NMCOR = LREC - NRPARM
         NB = NSTNS * NSTNS
C                                       initialize the begin of flag
C                                       intervals
         CALL RFILL (MAXANT, -1000.0, TBEG)
         CALL RFILL (MAXB, -1000.0, TBB)
         CALL LFILL (NSTNS, .FALSE., ANTBAD)
         CALL LFILL (MAXB, .FALSE., BASBAD)
         TIMOLD = -1.E6
         OLDSOU = -1
C                                       Start looping thru data.
C                                       Read buffer.
 50      XCOUNT = XCOUNT + 1
         CALL UVGET ('READ', RPARM, BUFF, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING DATA', JSUB
            GO TO 990
         ELSE IF (IRET.EQ.0) THEN
            VCOUNT = VCOUNT + 1
            IF (MOD(VCOUNT,100000).EQ.0) THEN
               WRITE (MSGTXT,1055) VCOUNT
               CALL MSGWRT (2)
               END IF
C                                       Decode time.
            TIME = RPARM(1+ILOCT)
C                                       Determine FQ ID
            IF (ILOCFQ.GT.-1) LFQID = IROUND (RPARM(1+ILOCFQ))
C                                       Determine subarray
            IF (ILOCB.GE.0) THEN
               BLTEMP = RPARM(1+ILOCB)
               IA1 = BLTEMP / 256. + 0.1
               BLTEMP = BLTEMP - IA1 * 256
               IA2 = BLTEMP + 0.1
               ISUBA = 100.0 * (BLTEMP - IA2) + 1.5
            ELSE
               IA1 = RPARM(1+ILOCA1) + 0.1
               IA2 = RPARM(1+ILOCA2) + 0.1
               ISUBA = RPARM(1+ILOCSA) + 0.1
               END IF
C                                       check time range, etc
            IF ((TIME.GE.STARTD) .AND. (TIME.LE.STOPD+1.16D-4) .AND.
     *         ((ISUBA.LE.0) .OR. (ISUBA.EQ.JSUB)) .AND.
     *         ((FQID.LE.0) .OR. (LFQID.EQ.FQID))) THEN
C                                       get source
               SOUID = 0
               IF (ILOCSU.GT.-1) SOUID = RPARM(1+ILOCSU)
C                                       Clear pending time intervals
               IF (SOUID.NE.OLDSOU) THEN
                  DO 60 LANT = 1,NSTNS
                     IF (TBEG(LANT).GT.-999.0) THEN
                        TIMST = TBEG(LANT)
                        TIMEN = TEND(LANT)
                        IDUM(1) = OLDSOU
                        LD1(1) = LANT
                        LD2(1) = 0
                        CALL FLAGUP (OPCODE, FGLUN, DISK, CNOIN, FGVER,
     *                     FGBUFF, IFGRNO, FGKOLS, FGNUMV, IDUM, 1,
     *                     JSUB, FQID, 1, LD1, LD2, TIMST, TIMEN, 1, 0,
     *                     1, 0, STOKES, LREAS1, NFL, IRET)
                        IF (IRET.NE.0) GO TO 999
                        TBEG(LANT) = -1000.0
                        FGOPEN = .TRUE.
                        WFLAG = WFLAG + NFL
                        END IF
 60                  CONTINUE
                  DO 65 LANT = 1,NB
                     IF (TBB(LANT).GT.-999.0) THEN
                        TIMST = TBB(LANT)
                        TIMEN = TBE(LANT)
                        LA1 = (LANT-1) / NSTNS + 1
                        LA2 = LANT - NSTNS * (LA1-1)
                        IDUM(1) = OLDSOU
                        LD1(1) = LA1
                        LD2(1) = LA2
                        CALL FLAGUP (OPCODE, FGLUN, DISK, CNOIN, FGVER,
     *                     FGBUFF, IFGRNO, FGKOLS, FGNUMV, IDUM, 1,
     *                     JSUB, FQID, 1, LD1, LD2, TIMST, TIMEN, 1, 0,
     *                     1, 0, STOKES, LREAS2, NFL, IRET)
                        IF (IRET.NE.0) GO TO 999
                        TBB(LANT) = -1000.0
                        FGOPEN = .TRUE.
                        WFLAG = WFLAG + NFL
                        END IF
 65                  CONTINUE
C                                       Check sources
                  IF (ID(1).GT.0) THEN
                     DO 70 SID = 1,NID
                        IF (SOUID.EQ.ID(SID)) GO TO 75
 70                     CONTINUE
                     GO TO 50
                     END IF
                  END IF
C                                       new time interval
C                                       stuff old into time arrays
 75            IF ((TIME-TIMOLD.GT.TDIF) .OR. (OLDSOU.NE.SOUID)) THEN
C                                       pick up the source coordinates
C                                       only when a new source appears
                  CALL FNDCOO (0, JD0, SOUID, DISK, CNOIN, CATBLK,
     *               LUNSS, TIME, DRA, DDEC, PLANET, IRET)
                  IF (IRET.GT.0) GO TO 999
                  OLDSOU = SOUID
                  TIMOLD = TIME
C                                       is this point good or no?
                  CALL ISSHAD (RPARM, JSUB, SHMIN, CTMIN, DRA, DDEC,
     *               ANTBAD, BASBAD)
                  DO 80 LANT = 1,NSTNS
C                                       interval bad
                     IF (ANTBAD(LANT)) THEN
                        IF (TBEG(LANT).LT.-999.0) TBEG(LANT) =
     *                     TIMOLD - TINT
                        TEND(LANT) = TIMOLD + TINT
                        ANTBAD(LANT) = .FALSE.
C                                       interval now good, was not
                     ELSE IF (TBEG(LANT).GT.-999.0) THEN
                        TIMST = TBEG(LANT)
                        TIMEN = TEND(LANT)
                        IDUM(1) = OLDSOU
                        LD1(1) = LANT
                        LD2(1) = 0
                        CALL FLAGUP (OPCODE, FGLUN, DISK, CNOIN, FGVER,
     *                     FGBUFF, IFGRNO, FGKOLS, FGNUMV, IDUM, 1,
     *                     JSUB, FQID, 1, LD1, LD2, TIMST, TIMEN, 1, 0,
     *                     1, 0, STOKES, LREAS1, NFL, IRET)
                        IF (IRET.NE.0) GO TO 999
                        TBEG(LANT) = -1000.0
                        FGOPEN = .TRUE.
                        WFLAG = WFLAG + NFL
                        END IF
 80                  CONTINUE
                  DO 85 LANT = 1,NB
C                                       interval bad
                     IF (BASBAD(LANT)) THEN
                        IF (TBB(LANT).LT.-999.0) TBB(LANT) =
     *                     TIMOLD - TINT
                        TBE(LANT) = TIMOLD + TINT
                        BASBAD(LANT) = .FALSE.
C                                       interval now good, was not
                     ELSE IF (TBB(LANT).GT.-999.0) THEN
                        TIMST = TBB(LANT)
                        TIMEN = TBE(LANT)
                        LA1 = (LANT-1) / NSTNS + 1
                        LA2 = LANT - NSTNS * (LA1-1)
                        IDUM(1) = OLDSOU
                        LD1(1) = LA1
                        LD2(1) = LA2
                        CALL FLAGUP (OPCODE, FGLUN, DISK, CNOIN, FGVER,
     *                     FGBUFF, IFGRNO, FGKOLS, FGNUMV, IDUM, 1,
     *                     JSUB, FQID, 1, LD1, LD2, TIMST, TIMEN, 1, 0,
     *                     1, 0, STOKES, LREAS2, NFL, IRET)
                        IF (IRET.NE.0) GO TO 999
                        TBB(LANT) = -1000.0
                        FGOPEN = .TRUE.
                        WFLAG = WFLAG + NFL
                        END IF
 85                  CONTINUE
                  END IF
               END IF
            GO TO 50
         ELSE
            CALL CATDIR ('CSTA', DISK, FCNO(1), NAME, CLASS, SEQ, 'UV',
     *         NLUSER, 'READ', BUFF, IRET)
            CALL UVGET ('CLOS', RPARM, BUFF, IRET)
            END IF
C                                       Clear pending time intervals
         DO 110 LANT = 1,NSTNS
            IF (TBEG(LANT).GT.-999.0) THEN
               TIMST = TBEG(LANT)
               TIMEN = TEND(LANT)
               IDUM(1) = OLDSOU
               LD1(1) = LANT
               LD2(1) = 0
               CALL FLAGUP (OPCODE, FGLUN, DISK, CNOIN, FGVER, FGBUFF,
     *            IFGRNO, FGKOLS, FGNUMV, IDUM, 1, JSUB, FQID, 1,
     *            LD1, LD2, TIMST, TIMEN, 1, 0, 1, 0, STOKES, LREAS1,
     *            NFL, IRET)
               IF (IRET.NE.0) GO TO 999
               TBEG(LANT) = -1000.0
               FGOPEN = .TRUE.
               WFLAG = WFLAG + NFL
               END IF
 110        CONTINUE
         DO 120 LANT = 1,NB
            IF (TBB(LANT).GT.-999.0) THEN
               TIMST = TBB(LANT)
               TIMEN = TBE(LANT)
               LA1 = (LANT-1) / NSTNS + 1
               LA2 = LANT - NSTNS * (LA1-1)
               IDUM(1) = OLDSOU
               LD1(1) = LA1
               LD2(1) = LA2
               CALL FLAGUP (OPCODE, FGLUN, DISK, CNOIN, FGVER, FGBUFF,
     *            IFGRNO, FGKOLS, FGNUMV, IDUM, 1, JSUB, FQID, 1, LD1,
     *            LD2, TIMST, TIMEN, 1, 0, 1, 0, STOKES, LREAS2, NFL,
     *            IRET)
               IF (IRET.NE.0) GO TO 999
               TBB(LANT) = -1000.0
               FGOPEN = .TRUE.
               WFLAG = WFLAG + NFL
               END IF
 120        CONTINUE
 200     CONTINUE
      CALL CATDIR ('CSTA', DISK, FCNO(1), NAME, CLASS, SEQ, 'UV',
     *   NLUSER, 'WRIT', BUFF, IRET)
      IRET = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FLAGSH ERROR',I4,' ON ',A,I4)
 1010 FORMAT ('Begin flagging due to shadowing in subarray',I3)
 1001 FORMAT ('ERROR',I4,' SUBARRAY',I2,' ON ',A)
 1055 FORMAT ('FLAGSH: at vis record',I10)
      END
      SUBROUTINE SEDSEL (NAME, CLASS, SEQ, DISK, JSUB)
C-----------------------------------------------------------------------
C   puts parameters in DSEL.INC (many conflicts with local common)
C   Inputs:
C      NAME     C*12   File name
C      CLASS    C*6    File class
C      SEQ      I      File seq number
C      DISK     I      File disk number
C      JSUB     I      Subbary
C-----------------------------------------------------------------------
      CHARACTER NAME*12, CLASS*6
      INTEGER   SEQ, DISK, JSUB
C
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
C                                       Info for UVGET:
      CALL SELINI
      UNAME = NAME
      UCLAS = CLASS
      UDISK = DISK
      USEQ = SEQ
      SUBARR = JSUB
C
 999  RETURN
      END
      SUBROUTINE ISSHAD (RPARM, ISUB, SHMIN, CTMIN, DRA, DDEC, ANTBAD,
     *   BASBAD)
C-----------------------------------------------------------------------
C   Finds shadowed data.  If an antenna is shadowed by any other antenna
C   it is flagged.
C   Inputs:
C      RPARM    R(*)   Random parameters - uses time
C      ISUB     I      Subarray number
C      SHMIN    R      Min baseline allowed shadowing
C      CTMIN    R      Min baseline allowed cross talk
C      DRA      D      Apparent RA
C      DDEC     D      Apparent Dec
C   Outputs:
C      ANTBAD   L(*)   T => antenna shadowed
C      BASBAD   L(*)   T => baseline cross talk
C-----------------------------------------------------------------------
      REAL      RPARM(*), SHMIN, CTMIN
      DOUBLE PRECISION DRA, DDEC
      LOGICAL   ANTBAD(*), BASBAD(*)
      INTEGER   ISUB
C
      INTEGER   IA1, IA2, LSUB, IBL
      REAL      UV2
      DOUBLE PRECISION X(2), Y(2), Z(2), BX, BY, BZ, B1, B2, GH, U, V,
     *   W, JDREF, GMST, GAST, RATE, HAI, GSEC, HTR, ARRLON
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DMSG.INC'
      SAVE LSUB, JDREF
      DATA LSUB /-1/
      DATA GSEC /1.0027375D0/
C-----------------------------------------------------------------------
      IF (LSUB.NE.ISUB) THEN
         LSUB = ISUB
         CALL JULDAY (RDATE, JDREF)
         END IF
      HTR = PI / 12.D0
      CALL GSTROT (JDREF, GMST, GAST, RATE)
      GAST = GAST * (24.D0/360.D0)
      GAST = GAST + (((RPARM(1+ILOCT)-(LSUB-1)*5)*24.D0) * GSEC)
      GAST = MOD (GAST, 24.D0)
      CALL LFILL (NSTNS, .FALSE., ANTBAD)
C                                              Calculate array longitude
C                                              Array BX= ARRAYC(1)
C                                              Array BY= ARRAYC(2)
C                                              Array BZ= ARRAYC(3)
      ARRLON = 0.0D0
      IF ((ABS(ARRAYC(1)).GT.1.D2) .AND. (ABS(ARRAYC(2)).GT.1.D2) .AND.
     *      (ABS(ARRAYC(3)).GT.1.D2))
     *      ARRLON = ATAN2 (ARRAYC(2), ARRAYC(1))
      DO 100 IA1 = 1,NSTNS-1
         X(1) = STNX(IA1)
         Y(1) = STNY(IA1)
         Z(1) = STNZ(IA1)
         DO 90 IA2 = IA1+1,NSTNS
            IBL = (IA1-1) * NSTNS + IA2
            BASBAD(IBL) = .FALSE.
            X(2) = STNX(IA2)
            Y(2) = STNY(IA2)
            Z(2) = STNZ(IA2)
            IF (((X(1).GT.1.D2) .OR. (Y(1).GT.1.0D2) .OR.
     *         (Z(1).GT.1.0D2)) .AND. ((X(2).GT.1.0D2) .OR.
     *         (Y(2).GT.1.0D2) .OR. (Z(2).GT.1.0D2))) THEN
               CALL BASLIN (2, X, Y, Z, CATD(KDCRV+JLOCF), ARRLON,
     *            BX, BY, BZ, B1, B2, GH)
               HAI = GAST*HTR - DRA - GH
               U = B2 * SIN(HAI)
               V = B1 * COS(DDEC) - B2 * SIN(DDEC) * COS(HAI)
               W = B1 * SIN(DDEC) + B2 * COS(DDEC) * COS(HAI)
               UV2 = SQRT (U*U + V*V)
               IF (UV2.LT.SHMIN) THEN
                  IF (W.GT.0.0) THEN
                     ANTBAD(IA2) = .TRUE.
                  ELSE
                     ANTBAD(IA1) = .TRUE.
                     END IF
               ELSE IF (UV2.LT.CTMIN) THEN
                  BASBAD(IBL) = .TRUE.
                  END IF
               END IF
 90         CONTINUE
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SOURNU (SOURCE, KUAL, CALKOD, NSOUR, DISK, CNO, NID,
     *   BUFFER, ID, IRET)
C-----------------------------------------------------------------------
C   Determines the source numbers of a list of source names from the
C   source table associated with a specified catalog entry.
C   Inputs:
C      SOURCE  C*16(*)   List of source names.
C                        If the first character of any source names
C                        begins with a "-", all sources EXCEPT those
C                        named will be returned ( the "-" will be
C                        ignored in determining the source name).
C                        Blank source names are ignored.  Names should
C                        be left justified, blank filled
C      KUAL      I       SOURCE qualifier, .lt. 0 => any.
C      CALKOD    C*4     restrict to matching this calcode.
C      NSOUR     I       Number of entries in SOURCE, may include
C                        blank names.
C      DISK      I       Disk number of the data set.
C      CNO       I       Catalog slot number of data set.
C   Input/Output:
C      NID       I       On input the maximum number of elements to be
C                        filled in ID; on output, the number of elements
C                        in ID. 0 => all selected.
C      BUFFER    I(512)  Work buffer, used for I/O and manipulating
C                        source lists, should be at least min (512,NID)
C   Output:
C      ID        I(*)    Source ID numbers of selected sources,
C                        If ID(1)=0 then all sources are selected.
C      IRET      I       Return code. 0 => OK; else failed.
C                           -1 => source/qual specified and not found
C                                 no message is generated
C   Usage notes:
C       This routine uses AIPS LUN 27 which will be closed on normal
C   return.   Version 1 of the source table is assumed.
C   LOCAL VERSION INCLUDES CALKOD
C-----------------------------------------------------------------------
      CHARACTER SOURCE(*)*16, CALKOD*4
      INTEGER   KUAL, NSOUR, DISK, CNO, NID, BUFFER(*), ID(*), IRET
C
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4
      INTEGER   CAT(256), VER, LUN, IDKOL, SUKOL, I, IDSOU, SQUAL, J,
     *   MAXID, NUMIF, ISURNO, NUMREC, I4, SUFQID
      LOGICAL   EQUAL, DESEL, ALLSEL, GOTIT, ALLBLN
      DOUBLE PRECISION    BANDW, RAEPO, DECEPO, EPOCH, RAAPP, DECAPP,
     *   PMRA, PMDEC, RAOBS, DECOBS
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   SUKOLS(MAXSUC), SUNUMV(MAXSUC)
      REAL      FLUX(4,MAXIF)
      DOUBLE PRECISION LSRVEL(MAXIF), FREQO(MAXIF), RESTFQ(MAXIF)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (IDKOL, SUKOLS(1)),   (SUKOL, SUKOLS(2))
      DATA VER, LUN /1, 27/
C-----------------------------------------------------------------------
C                                       Setup
      MAXID = NID
      NID = 0
      IRET = 0
C                                       Check if sources deselected or
C                                       if all sources are selected.
      DESEL = .FALSE.
      ALLSEL = .TRUE.
      ALLBLN = .TRUE.
      DO 10 I = 1,NSOUR
C                                       Check deselection
         DESEL = DESEL .OR. ((SOURCE(I)(1:1).EQ.'-') .AND.
     *      (SOURCE(I)(2:).NE.' '))
C                                       Check if all blank (GvM, 1/93)
         ALLBLN = ALLBLN .AND. (SOURCE(I).EQ.' ')
C                                       Check if all blank, no qual
         ALLSEL = ALLSEL .AND. (SOURCE(I).EQ.' ') .AND. (KUAL.LT.0)
     *      .AND. (CALKOD.EQ.' ')
 10      CONTINUE
C                                       Check all selected case.
      ID(1) = 0
      IF (ALLSEL) GO TO 999
C                                       Get catalog header.
      CALL CATIO ('READ', DISK, CNO, CAT, 'REST', BUFFER, IRET)
      IF ((IRET.GT.0) .AND. (IRET.LT.5)) THEN
         WRITE (MSGTXT,1000) IRET, 'READING HEADER'
         GO TO 990
         END IF
C                                       Initialize SOURCE table.
      CALL SOUINI ('READ', BUFFER, DISK, CNO, VER, CAT, LUN, NUMIF,
     *   VELTYP, VELDEF, SUFQID, ISURNO, SUKOLS, SUNUMV, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INITING SOURCE TABLE'
         GO TO 990
         END IF
C                                       Get number of entries
      NUMREC = BUFFER(5)
C                                       Loop through source records.
      DO 500 ISURNO = 1,NUMREC
C                                       Read record
         I4 = ISURNO
         CALL TABSOU ('READ', BUFFER, I4, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, SQUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA,
     *      PMDEC, IRET)
C                                       See is source record turned off
         IF (IRET.LT.0) GO TO 500
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING SOURCE TABLE'
            GO TO 990
            END IF
C                                       Check if in list SOURCE.
         GOTIT = .FALSE.
         DO 300 J = 1,NSOUR
C                                       Sources selected.
            IF (.NOT.DESEL) THEN
               EQUAL = (SOURCE(J).EQ.SOUNAM) .OR. ALLBLN
C                                       is qualifier OK, too?
               EQUAL = EQUAL .AND. ((KUAL.LT.0) .OR.
     *            (KUAL.EQ.SQUAL))
C                                       calcode
               IF (CALKOD.NE.' ') EQUAL = EQUAL .AND.
     *            ((CALKOD.EQ.CALCOD) .OR.
     *            ((CALKOD.EQ.'*') .AND. (CALCOD.NE.' ')) .OR.
     *            ((CALKOD.EQ.'-CAL') .AND. (CALCOD.EQ.' ')))
               IF (EQUAL) THEN
                  IF ((NID+1).GT.MAXID) GO TO 310
                  NID = NID + 1
                  ID(NID) = IDSOU
                  GO TO 320
                  END IF
C                                       Deselected
            ELSE
C                                       Check for leading "-"
               IF (SOURCE(J)(1:1).EQ.'-') THEN
                  EQUAL = SOURCE(J)(2:16).EQ.SOUNAM(1:15)
               ELSE
                  EQUAL = SOURCE(J).EQ.SOUNAM
                  END IF
C                                       Check QUAL
               EQUAL = EQUAL .AND. ((KUAL.LT.0) .OR.
     *            (KUAL.EQ.SQUAL))
C                                       calcode
               IF (CALKOD.NE.' ') EQUAL = EQUAL .AND.
     *            ((CALKOD.EQ.CALCOD) .OR.
     *            ((CALKOD.EQ.'*') .AND. (CALCOD.NE.' ')) .OR.
     *            ((CALKOD.EQ.'-CAL') .AND. (CALCOD.EQ.' ')))
               GOTIT = GOTIT .OR. EQUAL
               END IF
 300        CONTINUE
C                                       Source not deselected
         IF (DESEL .AND. (.NOT.GOTIT)) THEN
            IF ((NID+1).GT.MAXID) GO TO 310
            NID = NID + 1
            ID(NID) = IDSOU
            ID(NID) = IDSOU
            END IF
         GO TO 320
C                                       Too many sources selected
 310     CONTINUE
            WRITE (MSGTXT,1300) MAXID
            IRET = 5
            GO TO 990
 320     CONTINUE
 500     CONTINUE
C                                       Close Source table
      CALL TABIO ('CLOS', 0, I4, BUFFER, BUFFER, IRET)
      IF (NID.EQ.0) IRET = -1
      GO TO 999
C                                       Error
 990  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SOURNU: ERROR ',I4,' IN ',A)
 1300 FORMAT ('SOURNU: MORE SOURCES SELECTED THAN MAX (',I5,')')
      END

      SUBROUTINE DIETSK (IRET, RQUICK, IBUF)
C-----------------------------------------------------------------------
C! closes a task: restarting AIPS, settling the accounting, issuing msg
C# System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2005
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DIETSK must be called at the end of each task as the last real
C   statement before the final RETURNs and STOP statement.  It issues a
C   closing message, terminates the accounting, and, if RQUICK is false,
C   restarts the initiating AIPS program.
C   Inputs:
C      IRET     I         0 => ok, else bad end
C      RQUICK   L         T => initiator already resumed
C   Output:
C      IBUF     I(256)    Scratch buffer
C-----------------------------------------------------------------------
      INTEGER   IRET, IBUF(256)
      LOGICAL   RQUICK
C
      INTEGER   IERR
      LONGINT   LTEMP
      CHARACTER OPT*4
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Message
      IF (IRET.NE.0) THEN
         MSGTXT = 'Purports to die of UNNATURAL causes'
      ELSE
         MSGTXT = 'Appears to have ended successfully'
         END IF
      CALL MSGWRT (3)
C                                       Clean out TC
      CALL GTTELL (-1, OPT, IBUF, IBUF, IERR)
C                                       clean out dynamic memory
      CALL ZMEMRY ('QUIT', TSKNAM, IERR, IERR, LTEMP, IERR)
C                                       Close accounting
      CALL ACOUNT (2)
C                                       Resume AIPS
      IF (.NOT.RQUICK) CALL RELPOP (IRET, IBUF, IERR)
C                                       System close downs ?
      CALL ZDIE
C
 999  RETURN
      END

      SUBROUTINE MP2SKY (PIX, X, IERR)
C-----------------------------------------------------------------------
C! calls SETLOC, XYVAL to convert image pixel to physical coordinates
C# Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   MP2SKY converts map pixel locations to sky coordinates using
C   subroutine XYVAL.  This routine just sets up the commons.
C   Inputs:
C      PIX     R(2)     x,y pixel values
C   Output:
C      X       D(3)     x,y (& possibly z) coordinate values
C      IERR    I        0 ok, 1 out of range, 2 bad type, 3 undefined
C   Commons:
C      /MAPHDR/   standard catalog block: uses IIDEP so this routine
C                 is mostly useful with things from Image catalog
C      /LOCATI/   values needed by XYVAL: built here via SETLOC
C-----------------------------------------------------------------------
      REAL      PIX(2)
      DOUBLE PRECISION X(3)
      INTEGER   IERR
C
      INTEGER   S2H(256)
      LOGICAL   SWAP
      INCLUDE 'INCS:DHDR.INC'
      COMMON /MAPHDR/ S2H
      DATA SWAP /.TRUE./
C-----------------------------------------------------------------------
C                                       set common values
      CALL SETLOC (S2H(IIDEP), SWAP)
C                                       do conversion
      CALL XYVAL (PIX(1), PIX(2), X(1), X(2), X(3), IERR)
C
 999  RETURN
      END

      SUBROUTINE ZV20C2 (FCB, IERR)
C-----------------------------------------------------------------------
C! close Comtal Vision 1/20 TV device
C# Z2 TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZV20C2 closes Comtal Vision 1/20 TV device called by ZV20CL which
C   does the FTAB stuff.
C   In/out
C      FCB    I(*)   File control block
C   Output:
C      IERR   I      error code: 0 -> no error
C                       1 -> Deaccess or Deassign error
C   Generic version - stub.
C   VMS version done by Andy Lubenow, Jan. 1985
C   A.L. version opened TVLUN to logical TVDEVn and never did anything
C   with it except close it.  He then passed a channel assignment around
C   in a special COMMON.  I think he did this to avoid AIPS' FTAB etc.
C   He hard-coded the device name as ZBA0: - use this as TVDEV1. (Eric)
C-----------------------------------------------------------------------
      INTEGER   FCB(*), IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'ZV20C2 REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (9)
C
 999  RETURN
      END

      SUBROUTINE MAKMAP (APCORE, IFIELD, DISKI, CNOSCI, DISKO, CNOSCO,
     *   SCRGRD, SCRWRK, CHANUV, CHANIM, DOCREA, DOINIT, DOBEAM, DOSEL,
     *   DOGCOR, CHINC, JBUFSZ, BUFFER, IRET)
C-----------------------------------------------------------------------
C! Makes image or beam from uv data set.
C# AP-util AP-fft UV Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-2000, 2006-2009, 2012, 2014-2015, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MAKMAP makes an image or a dirty beam given a uv data set.  The data
C   may either calibrated or uncalibrated (raw) data and calibration
C   and various selection criteria may be (optionally) applied. The
C   weights of the data must be set before entering this routine.
C      The visibilities are convolved onto the grid using the convolving
C   function specified by CTYPX,CTYPY,XPARM,YPARM.  The defaults for
C   these values are filled in by a call to GRDFLT.  The gridded data
C   are phase rotated so that the map center comes out at location
C   ICNTRX,ICNTRY.  If requested, a uv taper is applied to the
C   visibility weights before gridding.  If necessary, a three dimension
C   phase reference position  shift is done in AP1GRD.
C      If more than one channels are to be gridded together, GR3DUV
C   as many channels at a time as is possible with the available memory.
C   This bandwidth synthesis (BS) process may use the SCRWRK file.
C   For bandwidth synthesis both the CNOSCO and SCRWRK files should be
C   big enough for an extra m rows, where m is the half width of the
C   X convolving function.
C   Zero spacing flux densities are gridded if provided.
C      The final image will be normalized and (optionally) corrected for
C   the effects of the gridding convolution function.
C
C   Input uv data file in UV file CNOSCI, DISKI
C   Output image file in image file CNOSCO, DISKO
C   Inputs:
C      IFIELD      I     Field number to map, if 0 then make a beam.
C      DISKI       I     Input file disk number for cataloged files,
C                        .LE. 0 => /CFILES/ scratch file.
C      CNOSCI      I     Input file catalog slot number or /CFILES/
C                        scratch file number.
C      DISKO       I     Output file disk number for cataloged files,
C                        .LE. 0 => /CFILES/ scratch file.
C      CNOSCO      I     Output file catalog slot number or /CFILES/
C                        scratch file number.  If DOCREA is FALSE and
C                        DISKO=0 and CNOSCO=0 a scratch file is created.
C      SCRGRD      I     Grid scratch file number, will be set if the
C                        file is created, (DOINIT=TRUE)
C      SCRWRK      I     Work scratch file number, will be set if the
C                        file is created, (DOINIT=TRUE)
C      CHANUV      I     Channel number to grid.  If DOSEL=TRUE
C                        then this is 1-rel wrt the selected data.
C      CHANIM      I     Channel number of output image.
C      DOCREA      L     If TRUE, Create/catalog output image file.
C      DOINIT      L     If TRUE, initialize scratch files, set defaults
C                        for convolving functions.  Should be TRUE on
C                        first call, and FALSE there after.
C      DOBEAM      L     If TRUE, grid the beam before gridding the
C                        field.  See usage notes.
C      DOSEL       L     If true, data need to be reformatted to a
C                        single Stokes type.  If TRUE, the cataloged
C                        file NAME, CLASS etc should be filled into
C                        UNAME, UCLAS, UDISK, USEQ in common /SELCAL/
C      DOGCOR      L     If TRUE, correct image for gridding convolution
C                        correction function.  (Normally .TRUE.)
C      JBUFSZ      I     Size in bytes of buffers. Dimension of BUFFER
C                        must be at least 4096 R.
C   From commons: (Includes DGDS and DMPR)
C      MFIELD       I    The number of fields which are going to to be
C                        imaged (excluding any beam). MUST be filled in.
C      FLDSZ(2,*)   I    Dimension of map in RA, Dec (cells) of each
C                        field.  MUST be completely filled in before the
C                        DOINIT=TRUE call if the output file (either
C                        image or scratch) is to be created or zeroed
C                        if the files already exist.
C      DOUNIF       L    If TRUE, apply Uniform weighting. Should be
C                        TRUE on only the first call, otherwise it will
C                        be applied again.
C      WTPOWR       R    Power to take weights to.  Set to 1.0 to avoid
C                        application regardless of DOUNIF value.
C      NCHAVG       I    Number of channels to grid together for
C                        bandwidth synthesis.
C      CTYPX,CTYPY  I    Convolving function types for RA and Dec
C      XPARM(10)    R    Convolving function parameters for RA
C                        XPARM(1) = support half width.
C      YPARM(10)    R    Convolving function parameters for Dec.
C      UVRNG(2)     R    Minimum and maximum baseline lengths in
C                        1000's wavelengths. 0's => all
C      XSHIFT(16)   R    Shift in X (after rotation) in asec.
C                        in projected coordinates. 1 per field.
C      YSHIFT(16)   R    Shift in Y (after rotation) in asec.
C                        in projected coordinates. 1 per field.
C      STOKES       C*4  Stokes types wanted.
C                        'I','Q','U','V','R','L'
C      DOZERO       L    If true then do zero spacing flux.
C      ZEROSP(5)    R    Zero spacing flux, 1=>flux density (Jy)
C                        5 => weight to use.
C                        polarization.
C      TFLUXG       R    The total flux density removed from the data,
C                        this will be subtracted from the zero spacing
C                        flux before gridding.
C      DOTAPE       L    True if taper requested.
C      TAPERU,TAPERV R   TAPER ( to 30%) in u and v (kilolamda)
C                        Non-zero means to do a weighting pass
C   The following must be provided if DUNIF is TRUE.
C      UNFBOX       I    Half width of unif. wt. counting box size.
C      NXUNF,NYUNF  I    Dimension (cells) of the map in RA and Dec
C                        to be used to set uniform weighting.
C      NBXFUN       I    Function used when UNFBOX > 0.
C      ROBUST       R    Robustness parameter in uniform weighting.
C   The following must be provided if DOSEL is FALSE( common /MAPHDR/):
C     CATBLK(256)   I    Catalog header for uv data input file.
C                        (used on DOINIT=TRUE call and weighting)
C   The following must be provided if DOCREA is TRUE (includes DMPR,
C    DGDS)
C      MNAME           C*12 Output image name.
C      MCLASS          C*6  Output image class.
C                           (If more than 1 field the last 2 char
C                           are used to encode the field number)
C      MDISK           I    Desired image file output disk
C      MSEQ            I    Desired image file output sequence no.
C   The following must be provided if the output file is to be created;
C   either by setting DOCREA=TRUE or DISKO=CNOSCO=0.
C      FLDSZ(2,*)      I    Dimension of map in RA, Dec (cells)
C      NXBEM,NYBEM     I    Dimension (cells) of beam.
C      CELLSG(2)       R    The cell spacing in X and Y in arcseconds.
C      XSHIFT(*)       R    Shift in X (after rotation) in asec.
C                           in projected coordinates. 1 per field.
C      YSHIFT(*)       R    Shift in Y (after rotation) in asec.
C                           in projected coordinates. 1 per field.
C      ICNTRX,ICNTRY(*) I   The center pixel in X and Y for each
C                           field. 0 values cause the default.
C   The following must be provided if DOCREA is FALSE and output
C   files already exist. (Includes DGDS).
C      CCDISK(16)   I    Disk numbers of the output images.
C                        (Must be zeroed if not filled in.)
C      CCCNO(16)    I    Catalog slot numbers of output images.
C                        (Must be zeroed if not filled in.)
C   The following must be provided if DOSEL is true.
C   (Includes DSEL.INC)
C      UNAME        C*12 AIPS name of input file.
C      UCLAS        C*6  AIPS class of input file.
C      UDISK        R    AIPS disk of input file.
C      USEQ         R    AIPS sequence of input file.
C      FGVER        I    FLAG file version number, if .le. 0 then
C                        NO flagging is applied.
C      SOURCS(1)   C*16  Name of desired source.
C      TIMRNG(8)    R    Start day, hour, min, sec, end day, hour,
C                        min,sec. 0 => all
C      STOKES       C*4  Stokes types wanted.
C                        'I','Q','U','V','R','L'
C      BCHAN        I    First channel number selected, 1 rel. to first
C                        channel in data base. 0 => all
C      ECHAN        I    Last channel selected. 0=>all
C      BIF          I    First IF number selected, 1 rel. to first
C                        IF in data base. 0 => all
C      EIF          I    Last IF selected. 0=>all
C      FRQSEL       I    FQ id selected.
C      DOCAL        L    If true apply calibration, else not.
C   The following must be provided if DOCAL is TRUE.
C      ANTENS(50)   I    List of antennas selected, 0=>all,
C                        any negative => all except those specified
C      GAUSE        I    GAIN (CL or SN) file version number to use.
C   Output:
C      DISKI       I     UV data file disk if data reformatted.
C      CNOSCI      I     Reformatted uv data scratch file number
C                        to be used in subsequent calls.
C      DISKO       I     Output image file disk number if output file.
C                        created and/or cataloged (DOCREA=TRUE
C                        or input DISKO=0 and CNOSCO=0).
C      CNOSCO      I     Output image file catalog slot number
C                        or scratch file number if output file created.
C      SCRGRD      I     Grid scratch file number, will be set if the
C                        file is created, (DOINIT=TRUE)
C      SCRWRK      I     Work scratch file number, will be set if the
C                        file is created, (DOINIT=TRUE)
C      DOSEL       L     Set to FALSE if data reformatted.
C      DOBEAM      L     Set to DO3DIM.
C      DOINIT      L     Set to FALSE.
C      BUFFER(*)   R     Working buffer
C      IRET        I     Return error code. 0=>OK, error otherwise.
C   Output in Common:
C      DOUNIF       L    Set to FALSE if uniform weighting applied.
C      MNAME       C*12  Output image name. (defaults applied)
C      MCLASS      C*6   Output image class (defaults applied)
C      MDISK       I     Desired image file output disk
C                        (defaults applied)
C      MSEQ        I     Desired image file output sequence no.
C                        (defaults applied)
C      FLDMAX(*)   R     Maximum pixel value in field.
C      FLDMIN(*)   R     Minimum pixel value in field.
C   The following are filled in if a output file is created:
C      CCDISK(16)  I     Disk numbers of the output images.
C      CCCNO(16)   I     Catalog slot numbers of output images.
C   Useage Notes:
C    1) The input uvdata file is, with one exception, assumed to be
C     accurately described by the contents of CATR and the common
C     /UVHDR/ (include DUVH).  The exception is that the u, v and
C     w may refer to a different frequency.  The reference frequency for
C     the u,v and w terms is taken from the input CATBLK in the DOINIT
C     TRUE call unless the data is reformatted (DOSEL=TRUE).
C     In this latter case this frequency is obtained from UVGET call.
C     If DOSEL = TRUE the input value of CATBLK is ignored.
C    2) Information about the output image is obtained from the
C     catalog header for the relevant file.  If MAKMAP makes the
C     output file this information is filled in.  If MAKMAP does not
C     make the output image file then this information must be filled
C     in before hand.  Routine IMCREA will help do this.  Note: even
C     scratch files are cataloged and thus have a catalog header.
C     If MAKMAP does not create the output files, CCDISK(IFIELD) and
C     CCCNO(IFIELD) should give their disk and catalog slot number
C     before the call to MAKMAP.
C    3) only one polarization can be processed and the input data
C     to the gridding routine is assumed to be in the desired Stokes
C     type (i.e. I, Q, U, V etc.).
C        If DOSEL = TRUE the input data will be selected, calibrated
C     and reformatted as specified in common (include DSEL).
C     Only Stokes types I,Q,U,V,R,L should be used.
C        Multiple channels may be gridded together a la bandwidth
C     synthesis by specifying NCHAVG > 1. One channel of several
C     channels may be gridded specified by CHANUV.
C    4) If DOSEL=FALSE on the first call (i.e. the data is not
C     reformatted),  the random parameters in the data should include,
C     in order, u, v, w, weight (optional), time (optional) and baseline
C     (optional).  While the last are optional and not used, the last
C     words of random parameters are used as work space and, if they
C     are missing, u, v, and w may be clobbered.  The weights are
C     required but may be passed either as random parameters or as
C     part of the regular data array, CATR should tell which.
C     If DOSEL=TRUE is used these conditions will be satisfied.
C    5) The necessary image normalization constant for proper
C     normalization of the FFTed image is produced only by gridding the
C     beam.  If a beam is to be made, it should be done first; in this
C     case DOBEAM should be FALSE in all calls.  If a beam is not
C     desired then the first call to MAKMAP should have DOBEAM TRUE and
C     FALSE on subsequent calls.  Note MAKMAP sets DOBEAM to FALSE.
C     NOTE WELL: TO GET PROPER BEAM IMAGES CALL MAKMAP WITH IFIELD<0 TO
C     MAKE ALL BEAMS FIRST AND THEN USE DOBEAM FALSE.  DOBEAM TRUE gets
C     the weighting needed but not a proper beam image.
C    6) Much of the control information used by MAKMAP is passed to and
C     stored in commons.  The calling routine should have the following
C     includes:
C     DHDR.INC, DUVH.INC, DFIL.INC, DMPR.INC, DGDS.INC, DSEL.INC
C     NOTE: care should be taken that the contents of these commons
C     not be clobbered by overlaying.
C    7) If calibration is applied then up to 8 map and 3 non map files
C     will be open at once; this should be reflected in the call to
C     ZDCHIN and the dimension of FTAB in the main routine of the
C     calling program.  MAKMAP may use AIPS LUNs 16, 17, 18, 19,
C     20, 21, 22, 23, 24, 25, 28, 29, 30.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   IFIELD, DISKI, CNOSCI, DISKO, CNOSCO, SCRGRD, SCRWRK,
     *   CHANUV, CHANIM, JBUFSZ, IRET, CHINC
      LOGICAL   DOCREA, DOINIT, DOBEAM, DOSEL, DOGCOR
      REAL      BUFFER(*)
C
      CHARACTER PREMAX*5, PREMIN*5, KEYW*8
      INTEGER   J, NP(7), TVOL, TCNO, SAX(7), PLARR(5), NAX, IERR, NIF,
     *   LLUN(3), IBPOIN, KBUFSZ, LBUFSZ, NNX, NNY, KAP, SIZE, IVER,
     *   OVER, LUN1, LUN2, QVER, LUNQ, BUFFQ(256), CATQ(256), JERR, I,
     *   LOCS, KEYTYP, MSGSAV, LFIELD, MBUFSZ, NEED
      LOGICAL   HERM, LERR, T, F, TABLE, FQEXIS, FITASC
      REAL   DUM1, DUM2, XFMAX, XFMIN, YFMAX, YFMIN, CATR(256)
      DOUBLE PRECISION CATD(128), XRA, XDEC, NOISR, SUMWTI
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   ISB(MAXIF)
      DOUBLE PRECISION FQOFF(MAXIF), FQQFF
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMPR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DAPM.INC'
      REAL FINC(MAXIF), EBUFF(4*MABFSS)
      EQUIVALENCE (CATBLK, CATR, CATD)
      SAVE CATQ, EBUFF
      DATA T, F, HERM /.TRUE.,.FALSE.,.TRUE./
      DATA LLUN /16,17,18/
C-----------------------------------------------------------------------
      IRET = 0
      NGRDAT = T
      LUNQ = 49
      QVER = 1
      LFIELD = MAX (1, ABS(IFIELD))
C                                       Get u,v,w frequency from old
C                                       CATBLK in case the data is not
C                                       reformatted.
      IF (DOINIT) THEN
C                                       Just to be sure - call VHDRIN
         CALL VHDRIN
         FREQUV = CATD(KDCRV+JLOCF)
         END IF
C                                       Reformat uv data.
      IF (DOSEL) THEN
C                                       Remove the IF table, if it
C                                       exists
         TVOL = DISKI
         TCNO = CNOSCI
         IF ((TVOL.LE.0) .AND. (CNOSCI.LE.0)) GO TO 10
         IF (TVOL.LE.0) THEN
            TVOL = SCRVOL(CNOSCI)
            TCNO = SCRCNO(CNOSCI)
            END IF
         CALL ISTAB ('FQ', TVOL, TCNO, QVER, LUNQ, BUFFQ, TABLE, FQEXIS,
     *      FITASC, JERR)
         IF (FQEXIS) CALL RMEXT (TVOL, TCNO, 'FQ', QVER, CATQ, BUFFQ,
     *      JERR)
C                                       Open input uv file.
 10      DOSEL = F
         CALL UVGET ('INIT', BUFFER, BUFFER(NRPARM+1), IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Freq. of u,v,w
         FREQUV = UVFREQ
         CALL CALCOP (DISKI, CNOSCI, BUFFER, JBUFSZ, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Copy relevant portion of IF
C                                       table.
         IVER = 1
         OVER = 1
         LUN1 = LLUN(1)
         LUN2 = LLUN(2)
         IF (DISKI.LE.0) THEN
            TVOL = SCRVOL(CNOSCI)
            TCNO = SCRCNO(CNOSCI)
         ELSE
            TVOL = DISKI
            TCNO = CNOSCI
            END IF
C                                       Read old IF table
         CALL CHNDAT ('READ', BUFFER, IUDISK, IUCNO, IVER, CATUV, LUN1,
     *      NIF, FQOFF, ISB, FINC, BNDCOD, FRQSEL, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1003) IRET
            GO TO 990
            END IF
C                                       Update info for fixing FREQG(*)
         NIF = EIF - BIF + 1
         FQQFF = FQOFF(BIF)
         DO 20 J = BIF,EIF
            FQOFF(J) = FQOFF(J) - FQQFF
 20         CONTINUE
C                                       Write new FQ table
         CALL CHNDAT ('WRIT', BUFFER, TVOL, TCNO, OVER, CATBLK, LUN1,
     *      NIF, FQOFF(BIF), ISB(BIF), FINC(BIF), BNDCOD(BIF), FRQSEL,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1004) IRET
            GO TO 990
            END IF
C                                       Save CATBLK
         CALL COPY (256, CATBLK, CATQ)
C                                       Copy uv Catalog header
         CALL COPY (256, CATBLK, SCRBLK)
C                                       Init Frequency Table
         CALL FRQTAB (TVOL, TCNO, LUN1, CATBLK, FRQSEL, BUFFER, IRET)
         END IF
C                                       Get max. - min. baselines.
      BLMIN = UVRNG(1)
      BLMAX = UVRNG(2)
C                                       Buffer pointers, sizes etc;
C                                       use POLCAL from UVGET commons
      KBUFSZ = MABFSS * 2 * 2
      IBPOIN = 2 * MABFSS + 1
      LBUFSZ = MIN (KBUFSZ, JBUFSZ)
      MBUFSZ = MIN (2*KBUFSZ, JBUFSZ)
C                                       Initialize scratch files.
      IF (DOINIT) THEN
         CALL SETGRD (SCRGRD, SCRWRK, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Set defaults for convolving fn.
         CALL GRDFLT (CTYPX, CTYPY, XPARM, YPARM)
C                                       Copy uv Catalog header
         CALL COPY (256, CATBLK, SCRBLK)
C                                       Initialize DHDR.INC common
         CALL UVPGET (IERR)
         DOINIT = F
         END IF
C                                       Check  NCHAVG
      NCHAVG = MAX(1, NCHAVG)
C                                       Create output image file.
      IF (DOCREA) THEN
         CALL IMCREA (IFIELD, T, DISKO, CNOSCO, CHINC, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Save in common
         IF (IFIELD.GT.0) THEN
            CCCNO(IFIELD) = CNOSCO
            CCDISK(IFIELD) = DISKO
         ELSE
            CNOBEM(LFIELD) = CNOSCO
            BEMVOL(LFIELD) = DISKO
            END IF
         END IF
C                                       Create output scratch file.
      IF ((DISKO.LE.0).AND.(CNOSCO.LE.0)) THEN
         IF (IFIELD.LE.0) THEN
            NP(1) = NXBEM(LFIELD)
            NP(2) = NYBEM(LFIELD)
         ELSE
            NP(1) = FLDSZ(1,IFIELD)
            NP(2) = FLDSZ(2,IFIELD) + 2.1 + YPARM(1) * 2
            END IF
C                                       Determine file size
         CALL MAPSIZ (2, NP, SIZE)
C                                       Form catalog header.
         CALL IMCREA (IFIELD, F, DISKO, CNOSCO, CHINC, BUFFER, IRET)
C                                       Make GRID (SCRGRD) file.
         CALL SCREAT (SIZE, BUFFER, IRET)
         CNOSCO = NSCR
         IF (IFIELD.GT.0) THEN
            CCCNO(IFIELD) = SCRCNO(NSCR)
            CCDISK(IFIELD) = SCRVOL(NSCR)
         ELSE
            CNOBEM(LFIELD) = SCRCNO(NSCR)
            BEMVOL(LFIELD) = SCRVOL(NSCR)
            END IF
         IF (IRET.NE.0) THEN
            IF (IRET.EQ.1) MSGTXT ='TOO LITTLE DISK SPACE FOR ' //
     *         'IMAGE SCRATCH FILE'
            IF (IRET.GT.1) MSGTXT ='TROUBLE CREATING IMAGE SCRATCH FILE'
            GO TO 990
            END IF
         END IF
C                                       Set block offsets.
      CALL FILL (5, 1, PLARR)
      PLARR(1) = CHANIM
      NAX = 2
      IF (CHANIM.GT.1) NAX = 3
C                                       Beam block offset.
      IF (IFIELD.LE.0) THEN
         SAX(1) = NXBEM(LFIELD)
         SAX(2) = NYBEM(LFIELD)
         CALL COMOFF (NAX, SAX, PLARR, BOBEM(LFIELD), IERR)
         BOBEM(LFIELD) = BOBEM(LFIELD) + 1
C                                       Map block offset.
      ELSE
         SAX(1) = FLDSZ(1,IFIELD)
         SAX(2) = FLDSZ(2,IFIELD)
         CALL COMOFF (NAX, SAX, PLARR, BORES(IFIELD), IERR)
         BORES(IFIELD) = BORES(IFIELD) + 1
         END IF
C                                       Gridding parameters.
      CALL ROTFND (SCRBLK, UVROT, LERR)
      MAPROT = UVROT
C                                       Image:
      IF (IFIELD.GT.0) THEN
C                                       Field offsets.
         CALL XYSHFT (RA, DEC, XSHIFT(IFIELD), YSHIFT(IFIELD), MAPROT,
     *      XRA, XDEC)
C                                       set shift terms for field cent.
C                                       -NCP projection
         IF (TYPUVD.EQ.1) THEN
            CALL SHINCP (RA, DEC, MAPROT, XRA, XDEC, DXCG(IFIELD),
     *         DYCG(IFIELD), DZCG(IFIELD))
C                                       -SIN projection
         ELSE
            CALL SHISIN (RA, DEC, MAPROT, XRA, XDEC, DXCG(IFIELD),
     *         DYCG(IFIELD), DZCG(IFIELD))
            END IF
C                                       Scaling from lambda to cells
         SCLUG(IFIELD) = 1.0 / (RAD2AS / (FLDSZ(1,IFIELD) *
     *      ABS (CELLSG(1))))
C                                       Flip sign on v to make maps come
C                                       out upside down.
         SCLVG(IFIELD) = - 1.0 / (RAD2AS / (FLDSZ(2,IFIELD)*CELLSG(2)))
         SCLWG(IFIELD) = 1.0
C                                       cellsize -> FLDVU
         XFLD(IFIELD) = ABS (CELLSG(1)) * FLDSZ(1,IFIELD)
         YFLD(IFIELD) = CELLSG(2) * FLDSZ(2,IFIELD)
C                                       Map center.
         ICNTRX(IFIELD) = FLDSZ(1,IFIELD) / 2
         ICNTRY(IFIELD) = FLDSZ(2,IFIELD) / 2 + 1
C                                       Beam:
      ELSE
C                                       Scaling from lambda to cells
         SCLUG(1) = 1.0 / (RAD2AS / (FLDSZ(1,LFIELD) *
     *      ABS (CELLSG(1))))
C                                       Flip sign on v to make maps come
C                                       out upside down.
         SCLVG(1) = - 1.0 / (RAD2AS / (FLDSZ(2,LFIELD)*CELLSG(2)))
         SCLWG(1) = 1.0
         END IF
C                                       First channel.
      CHUV1 = CHANUV
C                                       Input UV data NOISE ratio
      IF (DISKI.LE.0) THEN
         TVOL = SCRVOL(CNOSCI)
         TCNO = SCRCNO(CNOSCI)
      ELSE
         TVOL = DISKI
         TCNO = CNOSCI
         END IF
      MSGSAV = MSGSUP
      MSGSUP = 32000
      KEYW = 'WTNOISE'
      I = 1
      CALL CATKEY ('REED', TVOL, TCNO, KEYW, I, LOCS, NOISR, KEYTYP,
     *   BUFFER, IERR)
      IF (IERR.NE.0) NOISR = -1.0D0
      KEYW = 'SUMWTIN'
      I = 1
      CALL CATKEY ('REED', TVOL, TCNO, KEYW, I, LOCS, SUMWTI, KEYTYP,
     *   BUFFER, IERR)
      IF (IERR.NE.0) SUMWTI = -1.0D0
      MSGSUP = MSGSAV
C                                       Grid beam if necessary
      IF ((DOBEAM) .AND. (IFIELD.GT.0)) THEN
         I = -LFIELD
         CALL GR3DUV (APCORE, I, DISKI, CNOSCI, SCRGRD, SCRBLK, MBUFSZ,
     *      FRQSEL, EBUFF, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 999
         DOBEAM = ONEBEM
         END IF
C                                       Make grid.
      CALL GR3DUV (APCORE, IFIELD, DISKI, CNOSCI, SCRGRD, SCRBLK,
     *   MBUFSZ, FRQSEL, EBUFF, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       FFT
      IF (IFIELD.LE.0) THEN
         NNX = NXBEM(LFIELD)
         NNY = NYBEM(LFIELD)
      ELSE
         NNX = FLDSZ(1,IFIELD)
         NNY = FLDSZ(2,IFIELD)
         END IF
      NEED = 2 * NNY * (NNX/2 + 1)
      NEED = NEED / 1024
      CALL QINIT (APCORE, NEED, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
         IRET = 10
         MSGTXT = 'MAKMAP: DID NOT GET ANY AP MEMORY'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL DSKFFT (APCORE, NNX, NNY, -1, HERM, SCRGRD, SCRWRK, SCRGRD,
     *   KBUFSZ, EBUFF, EBUFF(IBPOIN), DUM1, DUM2, IRET)
      CALL QRLSE
      IF (IRET.NE.0) GO TO 999
C                                       gridding correct/histogram
      CALL GRDCOR (APCORE, IFIELD, DOGCOR, 0, SCRGRD, DISKO, CNOSCO,
     *   YFMAX, YFMIN, LBUFSZ, EBUFF, EBUFF(IBPOIN), BUFFER, IRET)
C                                       Max, min messages.
      IF (IFIELD.GT.0) THEN
         FLDMAX(IFIELD) = YFMAX
         FLDMIN(IFIELD) = YFMIN
         END IF
      XFMAX = YFMAX
      XFMIN = YFMIN
      CALL METSCA (XFMAX, PREMAX, LERR)
      CALL METSCA (XFMIN, PREMIN, LERR)
      IF (IFIELD.LE.0) THEN
         WRITE (MSGTXT,1000) LFIELD, XFMIN, PREMIN, XFMAX, PREMAX
      ELSE
         WRITE (MSGTXT,1001) IFIELD, XFMIN, PREMIN, XFMAX, PREMAX
         END IF
      CALL MSGWRT (4)
C                                       Update CATBLK.
      IRET = 0
      IF (IFIELD.LE.0) THEN
         TVOL = BEMVOL(LFIELD)
         TCNO = CNOBEM(LFIELD)
      ELSE
         TVOL = CCDISK(IFIELD)
         TCNO = CCCNO(IFIELD)
         END IF
      CALL CATIO ('READ', TVOL, TCNO, CATBLK, 'REST', BUFFER, IRET)
      IF ((IRET.NE.0) .AND. (IRET.LE.4)) THEN
         WRITE (MSGTXT,1002) IRET, IFIELD
         CALL MSGWRT (6)
         IRET = 0
         GO TO 60
         END IF
C                                       Reset extrema if necessary
      IF ((CHANIM.EQ.1) .OR. (CATBLK(KINAX+2).EQ.1)) THEN
         CATR(KRDMX) = YFMAX
         CATR(KRDMN) = YFMIN
      ELSE
         CATR(KRDMX) = MAX (CATR(KRDMX), YFMAX)
         CATR(KRDMN) = MIN (CATR(KRDMN), YFMIN)
         END IF
C                                       Fix up image header.
      CALL IMHCOR (IFIELD, CHINC)
C                                       Rewrite header
      CALL CATIO ('UPDT', TVOL, TCNO, CATBLK, 'REST', BUFFER, IRET)
      IF ((IRET.GT.0) .AND. (IRET.LE.4)) THEN
         WRITE (MSGTXT,1050) IRET, IFIELD
         CALL MSGWRT (6)
         IRET = 0
         END IF
C                                       put NOISR in MA header
      IF (NOISR.GE.1.0) THEN
         KEYW = 'WTNOISE'
         I = 1
         LOCS = 1
         KEYTYP = 1
         CALL CATKEY ('WRIT', TVOL, TCNO, KEYW, I, LOCS, NOISR, KEYTYP,
     *      BUFFER, IERR)
         END IF
C                                       put SUMWTIN in MA header
      IF (SUMWTI.GT.0.0) THEN
         KEYW = 'SUMWTIN'
         I = 1
         LOCS = 1
         KEYTYP = 1
         CALL CATKEY ('WRIT', TVOL, TCNO, KEYW, I, LOCS, SUMWTI, KEYTYP,
     *      BUFFER, IERR)
         END IF
C                                       Remove any destroy-on-failure
C                                       flags
 60   DO 90 J=1,NCFILE
         IF ((CNOSCO.EQ.FCNO(J)) .AND. (FVOL(J).EQ.DISKO)) FRW(J) = 1
 90      CONTINUE
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Field',I5,' Beam min = ',F6.1,1X,A5,'Jy, max = ',F6.1,1X,
     *   A5,'Jy')
 1001 FORMAT ('Field',I5,' min = ',F6.1,1X,A5,'Jy',',max = ',F6.1,1X,
     *   A5,'Jy')
 1002 FORMAT ('MAKMAP: ERROR',I3,' READING CATBLK FIELD',I4)
 1003 FORMAT ('MAKMAP: ERROR',I5,' READING OLD IF TABLE')
 1004 FORMAT ('MAKMAP: ERROR',I5,' WRITING NEW IF TABLE')
 1050 FORMAT ('MAKMAP: ERROR',I3,' UPDATING CATBLK FIELD',I4)
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCLN.INC'
      INTEGER   NPARMS, NKEYT
      PARAMETER (NPARMS=97)
C                                       NKEYT = no adverbs for TELL
      PARAMETER (NKEYT=16)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS), TELDIM(2,NKEYT),
     *   TELTYP(NKEYT)
      CHARACTER AVNAME(NPARMS)*8, TELK(NKEYT)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                     1         2          3        4
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           5          6       7          8           9          10
     *   'SRCNAME', 'QUAL', 'CALCODE', 'TIMERANG', 'SELBAND', 'SELFREQ',
C           11        12          13          14          15
     *   'FREQID', 'SUBARRAY', 'ANTENNAS', 'BASELINE', 'DOCALIB',
C           16         17       18       19       20         21
     *   'GAINUSE', 'DOPOL', 'PDVER', 'BLVER', 'FLAGVER', 'DOBAND',
C           22       23        24        25       26       27
     *   'BPVER', 'SMOOTH', 'STOKES', 'BCHAN', 'ECHAN', 'CHANNEL',
C           28       29       30     31     32         33         34
     *   'NCHAV', 'CHINC', 'BIF', 'EIF', 'OUTNAME', 'OUTDISK', 'OUTSEQ',
C           35        36         37          38        39
     *   'OUTVER', 'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK',
C           40          41        42        43          44
     *   'CELLSIZE', 'IMSIZE', 'NFIELD', 'DO3DIMAG', 'FLDSIZE',
C           45          46          47         48         49
     *   'RASHIFT',  'DECSHIFT', 'UVTAPER', 'UVRANGE', 'GUARD',
C           50        51        52        53        54        55
     *   'ROTATE', 'ZEROSP', 'UVWTFN', 'UVSIZE', 'ROBUST', 'UVBOX',
C           56        57       58       59       60
     *   'UVBXFN', 'XTYPE', 'YTYPE', 'XPARM', 'YPARM',
C           61       62       63         64        65       66
     *   'NITER', 'BCOMP', 'ALLOKAY', 'NBOXES', 'CLBOX', 'BOXFILE',
C           67          68      69      70          7 1     72      73
     *   'OBOXFILE', 'GAIN', 'FLUX', 'MINPATCH', 'BMAJ', 'BMIN', 'BPA',
C           74         75         76          77      78        79
     *   'OVERLAP', 'ONEBEAM', 'OVRSWTCH', 'PHAT', 'FACTOR', 'CMETHOD',
C           80          81         82        83        84
     *   'IMAGRPRM', 'IM2PARM', 'NGAUSS', 'WGAUSS', 'FGAUSS',
C           85          86         87          88        89
     *   'MAXPIXEL', 'IN3NAME', 'IN3CLASS', 'IN3SEQ', 'IN3DISK',
C           90         91          92        93         94       95
     *   'IN4NAME', 'IN4CLASS', 'IN4SEQ', 'IN4DISK', 'FQTOL', 'DOTV',
C           96       97
     *   'LTYPE', 'BADDISK'/
C                    1       2       3       4
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT,
C          5       6       7       8      9      10
     *   OOACAR, OOAINT, OOACAR, OOARE, OOARE, OOARE,
C          11      12      13     14     15
     *   OOAINT, OOAINT, OOARE, OOARE, OOARE,
C          16      17      18      19      20     21
     *   OOAINT, OOAINT, OOAINT, OOAINT, OOAINT, OOAINT,
C          22      23      24     25      26      27
     *   OOAINT, OOARE, OOACAR, OOAINT, OOAINT, OOAINT,
C          28      29      30      31      32      33      34
     *   OOAINT, OOAINT, OOAINT, OOAINT, OOACAR, OOAINT, OOAINT,
C          35      36      37      38      39
     *   OOAINT, OOACAR, OOACAR, OOAINT, OOAINT,
C          40     41      42      43      44
     *   OOARE, OOAINT, OOAINT, OOALOG, OOAINT,
C          45     46     47     48     49
     *   OOARE, OOARE, OOARE, OOARE, OOARE,
C          50     51     52      53      54     55
     *   OOARE, OOARE, OOACAR, OOAINT, OOARE, OOAINT,
C          56      57      58      59     60
     *   OOAINT, OOAINT, OOAINT, OOARE, OOARE,
C          61      62      63      54      65      66
     *   OOAINT, OOAINT, OOAINT, OOAINT, OOAINT, OOACAR,
C          67      68     69     70      71     72     73
     *   OOACAR, OOARE, OOARE, OOAINT, OOARE, OOARE, OOARE,
C          74      75      76     77     78     79
     *   OOAINT, OOALOG, OOARE, OOARE, OOARE, OOACAR,
C          80     81      82      83     84
     *   OOARE, OOARE,  OOAINT, OOARE, OOARE,
C          85      86      87      88      89
     *   OOAINT, OOACAR, OOACAR, OOAINT, OOAINT,
C          90      91      92      93       94     95
     *   OOACAR, OOACAR, OOAINT, OOAINT,  OOARE, OOAINT,
C          96      97
     *   OOAINT, OOAINT/
C                   1     2     3     4
      DATA AVDIM /12,1,  6,1,  1,1,  1,1,
C          5      6     7     8     9     10
     *   16,1,  1,1,  4,1,  8,1,  1,1,  1,1,
C          11   12     13     14     15
     *   1,1,  1,1,  50,1,  50,1,   1,1,
C         16    17    18    19    20    21
     *   1,1,  1,1,  1,1,  1,1,  1,1,  1,1,
C         22    23    24    25    26    27
     *   1,1,  3,1,  4,1,  1,1,  1,1,  1,1,
C         28    29    30    31    32    33    34
     *   1,1,  1,1,  1,1,  1,1, 12,1,  1,1,  1,1,
C         35    36    37    38    39
     *   1,1, 12,1,  6,1,  1,1,  1,1,
C         40    41    42    43    44
     *   2,1,  2,1,  1,1,  1,1,  2,MAXAFL,
C              45         46    47    48    49
     *    MAXAFL,1, MAXAFL,1,  2,1,  2,1,  2,1,
C         50   51    52    53    54    55
     *   1,1,  5,1, 2,1,  2,1,  1,1,  1,1,
C         56    57     58     59    60
     *   1,1,  1,1,  1,1,  10,1,  10,1,
C         61         62    63    64    65          66
     *   1,1,  MAXAFL,1,  1,1,  1,1,  4,MXCLBX,  48,1,
C          67   68    69    70    71    72    73
     *   48,1, 1,1,  1,1,  1,1,  1,1,  1,1,  1,1,
C         74    75    76    77    78    79
     *   1,1,  1,1,  1,1,  1,1,  1,1,  4,1,
C          80    81   82     83    84
     *   20,1, 40,1, 1,1,  10,1, 10,1,
C         85    86    87    88    89
     *   1,1, 12,1,  6,1,  1,1,  1,1,
C          90   91    92    93    94    95
     *   12,1, 6,1,  1,1,  1,1,  1,1,  1,1,
C         96    97
     *   1,1, 10,1/
C                                       Adverbs to get via TELL
C                   1        2       3       4           5
      DATA TELK /'NITER', 'OBOXFILE', 'GAIN', 'FLUX', 'MINPATCH',
C           6       7       8      9           10        11
     *   'BMAJ', 'BMIN', 'BPA', 'OVRSWTCH', 'FACTOR', 'CMETHOD',
C           12          13         14          15      16
     *   'IMAGRPRM', 'IM2PARM', 'FGAUSS', 'MAXPIXEL', 'DOTV'/
      DATA TELTYP / OOAINT, OOACAR, OOARE, OOARE, OOAINT,
     *   OOARE, OOARE, OOARE, OOARE, OOARE, OOACAR,
     *   OOARE, OOARE, OOARE, OOAINT, OOAINT/
      DATA TELDIM / 1,1, 48,1, 1,1, 1,1, 1,1,
     *   1,1, 1,1, 1,1, 1,1, 1,1, 4,1,
     *   20,1, 40,1, 10,1, 1,1, 1,1/
LOCAL END
LOCAL INCLUDE 'IMAGRW.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NWEGHT
      REAL      WEGHTS(MAXCIF)
      COMMON /WEIGHT/ WEGHTS, NWEGHT
LOCAL END
LOCAL INCLUDE 'IMAGWIN.INC'
      INCLUDE 'INCS:PUVD.INC'
      LONGINT   WINP
      LOGICAL   REWIN
      INTEGER   WINM, WINW, WIN(2), NBOXES(MAXFLD)
      COMMON /IMAWIN/ WINP, REWIN, WINM, WINW, NBOXES, WIN
LOCAL END
LOCAL INCLUDE 'GFORT'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IDUM(MAXFLD)
      LOGICAL   LDUM(MAXFLD)
      REAL      RDUM(MAXFLD)
      DOUBLE PRECISION DDUM(MAXCIF)
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
      COMMON /IMAGRG/ DDUM
LOCAL END
      PROGRAM IMAGR
C-----------------------------------------------------------------------
C! Wide field and/or widefrequency  CLEANing/imaging task.
C# Task AP Imaging OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2003, 2005-2015, 2017-2019, 2022-2023, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Barry Clark and SDI CLEAN
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, CLEAN*32, UVDATA*32
      INTEGER   IRET, BUFF1(256), NSUBA, SUBA(100)
      INCLUDE 'IMAGWIN.INC'
      INCLUDE 'IMAGRW.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'IMAGR'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL IMALIN (PRGM, CLEAN, UVDATA, NSUBA, SUBA, IRET)
C                                       CLEAN
      IF (IRET.EQ.0) CALL IMLEAN (CLEAN, UVDATA, NSUBA, SUBA, IRET)
C                                       History
      IF (IRET.LE.0) CALL IMAHIS (CLEAN, UVDATA)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE IMALIN (PRGN, CLEAN, UVDATA, NSUBA, SUBA, IRET)
C-----------------------------------------------------------------------
C   IMALIN gets input parameters for IMAGR and creates the CLEAN object.
C   Inputs:
C      PRGN    C*6    Program name
C   Output:
C      CLEAN   C*32   Name of CLEAN object (contains output objects)
C      UVDATA  C*32   Name of input uv data.
C      NSUBA   I      Number of subarrays to process
C      SUBA    I(*)   List of subarrays to process
C      IRET    I      Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   NSUBA, SUBA(*), IRET
      CHARACTER PRGN*6, CLEAN*(*), UVDATA*(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   NKEY1, NKEY2, NKEY3, NKEY4, NKEY5, NKEY6, MXSTAR
C                                       NKEY1=no. adverbs to copy to
C                                       CLEAN object
      PARAMETER (NKEY1=20)
C                                       NKEY2 = no. adverb for UVDATA
      PARAMETER (NKEY2=37)
C                                       NKEY3 = no. adverb for UVWORK
      PARAMETER (NKEY3=8)
C                                       NKEY4 = no. adverbs for BEAM
      PARAMETER (NKEY4=4)
C                                       NKEY5 = no. adverbs for CLEANO
      PARAMETER (NKEY5=15)
C                                       NKEY6 = no. adverbs for SPIX
      PARAMETER (NKEY6=4)
C                                       max size of Stars
      PARAMETER (MXSTAR = 100)
C
      INCLUDE 'INPUT.INC'
      INTEGER   DIM(7), TYPE, J, BCHAN, ECHAN, NAXIS(7), I, IMSI(2),
     *   IMSIZE(2,MAXFLD), NPTWO, FLDSIZ(2,MAXFLD), NXFLD, NYFLD,
     *   BFIELD, NXBEM(MAXFLD), K, NYBEM(MAXFLD), MAXNX, MAXNY, MINNX,
     *   MINNY, NITER, EDGEX, EDGEY, NFIELD, CHINC, NCHAV, BMSIZ(2),
     *   BIF, EIF, IFINDX, FQINDX, II, BMSSZ(2), IROUND, IS, NX, NY,
     *   JLOCD, JLOCR, SRCIDX, BSUM, TSEQ, TDISK, BCOMP(MAXFLD), MFIELD,
     *   NUMRES, OVRLAP, CLBOX(4,50), ALLOK, LIMTIM(2), NWORDS, LSUB1,
     *   LSUB2, UNWIN(16*MAXFLD), UNBOXS(MAXFLD), JTRIM, NSTAR,
     *   TVGRCS(3), IDATE(3), ITIME(3), XDOTV
      LONGINT   KP
      LOGICAL   NOREST, DOSCAL, DO3DIM, INTROK, WASZER, ONEBEM, FILTRS,
     *   DOSMOO
      REAL      BMAJ, BMIN, BPA, IMPARM(20), TAPER(2,20), RASH(MAXFLD),
     *   DECSH(MAXFLD), CELLS(2), DU, DV, UMAX, VMAX, GUARDB(2), GUAU,
     *   GUAV, UVTAPR(2), UTFACT(2), CROTAU(7), ROTATE, COMRES(10),
     *   FACTOR, XDOCAL, TMPRES(10), FLXRES(10), TMPFLX(10), MNFLUX,
     *   IM2PRM(40), AUTOBX(6), HDRBM(3), IGNORE(MAXFLD),
     *   STPARM(4,MXSTAR), INVERT(3)
      DOUBLE PRECISION CRVAL(7), STPOS(2,MXSTAR)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32, INK3(NKEY3)*8, OUTK3(NKEY3)*32, INK4(NKEY4)*8,
     *   OUTK4(NKEY4)*32, INK5(NKEY5)*8, OUTK5(NKEY5)*32, INK6(NKEY6)*8,
     *   OUTK6(NKEY6)*32, TELOBJ*32, CLEANO(MAXFLD)*32, BEAM(MAXFLD)*32,
     *   UVWORK*32, SPIX*32, STOKES*4, CLASS*6, CLTYPE*2, CHTYPE*4,
     *   CLNTYP*8, CNAME*8, KEYW*8, TINAME*12, TONAME*12, CDUMMY*1,
     *   BOXFIL*48, UVTYPE*2, TCLASS*6, OBXFIL*48, INK6B(NKEY6)*8,
     *   SPIXC*32, ANTAB*32, SRCNAM*16, SOURCS(30)*16
      INCLUDE 'IMAGWIN.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'IMAGRW.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to CLEAN object
C                   1       2       3       4        5
      DATA INK1 /'GAIN', 'FLUX', 'PHAT', 'NITER', 'ONEBEAM',
C           6       7       8      9         10
     *   'BMAJ', 'BMIN', 'BPA', 'FACTOR', 'MINPATCH',
C           11        12          13          14      15
     *   'OUTVER', 'IMAGRPRM', 'MAXPIXEL', 'DOTV', 'DO3DIMAG',
C           16         17          18        19          20
     *   'OVERLAP', 'OBOXFILE', 'ALLOKAY','OVRSWTCH', 'LTYPE'/
C                                       Rename
C                    1       2          3       4        5
      DATA OUTK1 /'GAIN', 'MINFLUX', 'PHAT', 'NITER', 'ONEBEAM',
C           6            7            8           9         10
     *   'BEAM.BMAJ', 'BEAM.BMIN', 'BEAM.BPA', 'FACTOR', 'MINPATCH',
C           11         12        13         14         15
     *   'VERSION', 'IMPARM', 'MAXNRES', 'TVFIELD', 'DO3DIMAG',
C           16         17          18         19          20
     *   'OVERLAP', 'OBOXFILE', 'ALLOKAY', 'OVRSWTCH', 'LTYPE'/
C                                       Adverbs for UVDATA object
C                                       leave out UVWTFN to do all in
C                                       better places
      DATA INK2 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'CHINC',
     *   'CMETHOD', 'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK',
     *   'NCHAV', 'ROTATE', 'BCHAN', 'ECHAN', 'BIF', 'EIF',
     *   'STOKES', 'GAINUSE', 'ANTENNAS', 'BASELINE',
     *   'FLAGVER', 'TIMERANG', 'UVRANGE',
     *   'QUAL', 'SELBAND',
     *   'SELFREQ', 'FREQID', 'CALCODE',
     *   'SUBARRAY', 'DOPOL', 'BLVER',
     *   'DOBAND', 'BPVER', 'SMOOTH', 'PDVER', 'ZEROSP', 'FQTOL'/
C                                       Rename
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'CHINC',
     *   'MODMETH', 'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK',
     *   'NCHAV', 'ROTATE',
     *   'CALEDIT.BCHAN', 'CALEDIT.ECHAN', 'CALEDIT.BIF', 'CALEDIT.EIF',
     *   'CALEDIT.STOKES', 'CALEDIT.CLUSE', 'ANTENNAS', 'BASELINE',
     *   'CALEDIT.FGVER', 'CALEDIT.TIMRNG', 'CALEDIT.UVRNG',
     *   'CALEDIT.SELQUA', 'CALEDIT.SELBAN',
     *   'CALEDIT.SELFRQ', 'CALEDIT.FRQSEL', 'CALEDIT.SELCOD',
     *   'CALEDIT.SUBARR', 'CALEDIT.DOPOL', 'CALEDIT.BLVER',
     *   'CALEDIT.DOBAND', 'CALEDIT.BPVER', 'CALEDIT.SMOOTH',
     *   'CALEDIT.PDVER', 'ZEROSP', 'FQTOL'/
C                                       Adverbs for UVWORK object
C                    1        2         3
      DATA INK3 /'CHINC', 'CMETHOD', 'GUARD', 'IN2NAME', 'IN2CLASS',
     *   'IN2SEQ', 'IN2DISK', 'FQTOL'/
C                                       Rename
C                    1         2          3
      DATA OUTK3 /'CHINC', 'MODMETH', 'GUARDBND', 'NAME', 'CLASS',
     *   'IMSEQ', 'DISK', 'FQTOL'/
C                                       Adverbs for BEAM image object
C                    1          2          3         4
      DATA INK4 /'OUTNAME', 'OUTSEQ', 'OUTDISK', 'CELLSIZE'/
C                                       Rename
C                    1       2       3         4
      DATA OUTK4 /'NAME', 'IMSEQ', 'DISK', 'CELLSIZE'/
C                                       Adverbs for CLEANO image object
C                    1         2         3          4
      DATA INK5 /'OUTNAME', 'OUTSEQ', 'OUTDISK', 'CELLSIZE',
C           5        6        7        8        9         10
     *   'XTYPE', 'YTYPE', 'XPARM', 'YPARM', 'UVWTFN', 'ONEBEAM',
C           11       12        13        14        15
     *   'UVBOX', 'UVSIZE', 'ROBUST', 'UVBXFN', 'DO3DIMAG'/
C                                       Rename
C                    1       2        3       4
      DATA OUTK5 /'NAME', 'IMSEQ', 'DISK', 'CELLSIZE',
C           5        6        7        8        9         10
     *   'CTYPX', 'CTYPY', 'XPARM', 'YPARM', 'UVWTFN', 'ONEBEAM',
C           11       12        13        14        15
     *   'UVBOX', 'UVSIZE', 'ROBUST', 'UVBXFN', 'DO3DIMAG'/
C                                       Adverbs for SPIX image object
C                    1          2          3         4
      DATA INK6 /'IN3NAME', 'IN3CLASS', 'IN3SEQ', 'IN3DISK'/
      DATA INK6B /'IN4NAME', 'IN4CLASS', 'IN4SEQ', 'IN4DISK'/
C                                       Rename
C                    1       2          3        4
      DATA OUTK6 /'NAME', 'CLASS', 'IMSEQ', 'DISK'/
      DATA SOURCS /30*' '/
C-----------------------------------------------------------------------
C                                       Startup - as interactive
      CALL AV2INT (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) THEN
         RQUICK = .FALSE.
         GO TO 999
         END IF
C                                       DOTV = RQUICK false
      CALL OGET ('Input', 'DOTV', TYPE, DIM, IDUM, CDUMMY, IRET)
      XDOTV = IDUM(1)
      IF (IRET.NE.0) THEN
         RQUICK = .FALSE.
         GO TO 999
         END IF
      IF (XDOTV.GT.0) RQUICK = .FALSE.
C                                       Default NFIELD=1
      CALL OGET ('Input', 'NFIELD', TYPE, DIM, IDUM, CDUMMY, IRET)
      NFIELD = IDUM(1)
      IF (IRET.NE.0) THEN
         RQUICK = .FALSE.
         GO TO 999
         END IF
      IF (NFIELD.LE.0) THEN
         NFIELD = 1
         IDUM(1) = NFIELD
         CALL OPUT ('Input', 'NFIELD', OOAINT, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) THEN
            RQUICK = .FALSE.
            GO TO 999
            END IF
         END IF
      CALL OGET ('Input', 'NGAUSS', TYPE, DIM, IDUM, CDUMMY, IRET)
      NUMRES = IDUM(1)
      IF (IRET.NE.0) THEN
         RQUICK = .FALSE.
         GO TO 999
         END IF
      CALL OGET ('Input', 'ONEBEAM', TYPE, DIM, IDUM, CDUMMY, IRET)
      ONEBEM = LDUM(1)
      IF (IRET.NE.0) THEN
         RQUICK = .FALSE.
         GO TO 999
         END IF
      IF (NFIELD.EQ.1) THEN
         ONEBEM = .TRUE.
         LDUM(1) = ONEBEM
         CALL OPUT ('Input', 'ONEBEAM', TYPE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) THEN
            RQUICK = .FALSE.
            GO TO 999
            END IF
         END IF
      CALL OGET ('Input', 'FLUX', TYPE, DIM, IDUM, CDUMMY, IRET)
      MNFLUX = RDUM(1)
      IF (IRET.NE.0) THEN
         RQUICK = .FALSE.
         GO TO 999
         END IF
      IF (NUMRES.LE.0) THEN
         NUMRES = 1
         CALL RFILL (10, 0.0, COMRES)
         CALL RFILL (10, MNFLUX, FLXRES)
         IDUM(1) = NUMRES
         CALL OPUT ('Input', 'NGAUSS', OOAINT, DIM, IDUM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) THEN
            RQUICK = .FALSE.
            GO TO 999
            END IF
         DIM(1) = 10
         CALL RFILL (10, 0.0, RDUM)
         CALL OPUT ('Input', 'WGAUSS', OOARE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) THEN
            RQUICK = .FALSE.
            GO TO 999
            END IF
         CALL OPUT ('Input', 'FGAUSS', OOARE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) THEN
            RQUICK = .FALSE.
            GO TO 999
            END IF
      ELSE
         CALL OGET ('Input', 'WGAUSS', TYPE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) THEN
            RQUICK = .FALSE.
            GO TO 999
            END IF
         CALL RCOPY (DIM(1), RDUM, COMRES)
         CALL OGET ('Input', 'FGAUSS', TYPE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) THEN
            RQUICK = .FALSE.
            GO TO 999
            END IF
         CALL RCOPY (DIM(1), RDUM, FLXRES)
C                                       check order: 0 first
         K = 0
         DO 5 I = 1,NUMRES
            IF (COMRES(I).LE.0.0) THEN
               IF (K.EQ.0) THEN
                  K = I
               ELSE
                  MSGTXT = 'WARNING: 2nd 0-width resolution dropped'
                  CALL MSGWRT (6)
                  END IF
               END IF
 5          CONTINUE
         WASZER = K.NE.0
         IF (WASZER) THEN
            CALL RCOPY (10, COMRES, TMPRES)
            CALL RCOPY (10, FLXRES, TMPFLX)
            K = 1
            CALL RFILL (10, 0.0, COMRES)
            CALL RFILL (10, MNFLUX, FLXRES)
            DO 10 I = 1,NUMRES
               IF (TMPRES(I).EQ.0.0) THEN
                  FLXRES(1) = TMPFLX(I)
                  IF (FLXRES(1).EQ.0.0) FLXRES(1) = MNFLUX
               ELSE IF (TMPRES(I).GT.0.0) THEN
                  DO 8 J = 1,K
                     IF (TMPRES(I).EQ.COMRES(J)) GO TO 10
 8                   CONTINUE
                  K = K + 1
                  COMRES(K) = TMPRES(I)
                  FLXRES(K) = TMPFLX(I)
                  IF (FLXRES(K).EQ.0.0) FLXRES(K) = MNFLUX
                  END IF
 10            CONTINUE
            CALL RCOPY (DIM(1), COMRES, RDUM)
            CALL OPUT ('Input', 'WGAUSS', TYPE, DIM, IDUM, CDUMMY, IRET)
            IF (IRET.NE.0) THEN
               RQUICK = .FALSE.
               GO TO 999
               END IF
            CALL RCOPY (DIM(1), FLXRES, RDUM)
            CALL OPUT ('Input', 'FGAUSS', TYPE, DIM, IDUM, CDUMMY, IRET)
            IF (IRET.NE.0) THEN
               RQUICK = .FALSE.
               GO TO 999
               END IF
            IF (K.NE.NUMRES) THEN
               WRITE (MSGTXT,1010) K
               CALL MSGWRT (6)
               NUMRES = K
               DIM(1) = 1
               IDUM(1) = NUMRES
               CALL OPUT ('Input', 'NGAUSS', OOAINT, DIM, IDUM, CDUMMY,
     *            IRET)
               IF (IRET.NE.0) THEN
                  RQUICK = .FALSE.
                  GO TO 999
                  END IF
               END IF
         ELSE
            MSGTXT = 'WARNING: NO ZERO-SIZE RESOLUTION'
            CALL MSGWRT (6)
            END IF
         DO 15 I = 1,10
            COMRES(I) = MAX (0.0, COMRES(I)) / 3600.0
 15         CONTINUE
         END IF
C                                       compute tapers to use
      CALL OGET ('Input', 'UVTAPER', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, UVTAPR)
      UVTAPR(1) = MAX (0.0, UVTAPR(1))
      UVTAPR(2) = MAX (0.0, UVTAPR(2))
      FACTOR = SQRT (-4.0 * LOG (2.0) * LOG (0.3)) * 180.0 / (PI * PI *
     *   1000.0)
      J = 0
      DO 20 I = 1,NUMRES
         IF (COMRES(I).LE.0) THEN
            TAPER(1,I) = 0.0
            TAPER(2,I) = 0.0
            J = J + 1
         ELSE
            TAPER(1,I) = FACTOR / COMRES(I)
            TAPER(2,I) = TAPER(1,I)
            END IF
 20      CONTINUE
      IF (J.LE.0) THEN
         MSGTXT = 'WARNING: NO FIELD WITH POINT SOURCE MODEL'
         CALL MSGWRT (6)
      ELSE IF (J.GT.1) THEN
         IRET = 8
         MSGTXT = 'ERROR: MORE THAN ONE FIELD WITH POINT SOURCE MODEL'
         CALL MSGWRT (8)
         RQUICK = .FALSE.
         GO TO 999
         END IF
C                                       check max field number
      MFIELD = NFIELD * NUMRES
      IF (MFIELD.GT.MAXFLD) THEN
         MSGTXT = 'TOO MANY FIELDS * RESOLUTIONS REQUESTED'
         IRET = 8
         CALL MSGWRT (8)
         RQUICK = .FALSE.
         GO TO 999
         END IF
C                                       Resume if MFIELD < MAXAFL
      IF (MFIELD.GT.MAXAFL) RQUICK = .FALSE.
      IF (RQUICK) CALL RELPOP (0, SBUFF, IRET)
C                                       Declare 'PARANGLE' a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'PARANGLE'
      CALL OBVHKW (CNAME, KEYW, OOARE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Declare 'ZENANGLE' a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'ZENANGLE'
      CALL OBVHKW (CNAME, KEYW, OOARE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       BADDISK
      CALL OGET ('Input', 'BADDISK', TYPE, DIM, IBAD, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       CLEANing?
      CALL OGET ('Input', 'NITER', TYPE, DIM, IDUM, CDUMMY, IRET)
      NITER = IDUM(1)
      IF (IRET.NE.0) GO TO 999
C                                       ALLOKAY testing
      CALL OGET ('Input', 'ALLOKAY', TYPE, DIM, IDUM, CDUMMY, IRET)
      ALLOK = IDUM(1)
      IF (IRET.NE.0) GO TO 999
C                                       Default output Name = input
      CALL OGET ('Input', 'INNAME', TYPE, DIM, IDUM, TINAME, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'OUTNAME', TYPE, DIM, IDUM, TONAME, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (TONAME.EQ.' ') THEN
         TONAME = TINAME
         CALL OPUT ('Input', 'OUTNAME', TYPE, DIM, IDUM, TONAME, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      IF (ALLOK.GE.2) THEN
         CALL OGET ('Input', 'IN2NAME', TYPE, DIM, IDUM, TINAME, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OGET ('Input', 'IN2CLASS', TYPE, DIM, IDUM, TCLASS, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OGET ('Input', 'IN2SEQ', TYPE, DIM, IDUM, CDUMMY, IRET)
         TSEQ = IDUM(1)
         IF (IRET.NE.0) GO TO 999
         CALL OGET ('Input', 'IN2DISK', TYPE, DIM, IDUM, CDUMMY, IRET)
         TDISK = IDUM(1)
         IF (IRET.NE.0) GO TO 999
         IF ((TINAME.EQ.' ') .OR. (TCLASS.EQ.' ') .OR. (TSEQ.LE.0) .OR.
     *      (TDISK.LE.0)) ALLOK = 1
         END IF
      IF (ALLOK.GE.1) THEN
         CALL OGET ('Input', 'OUTSEQ', TYPE, DIM, IDUM, CDUMMY, IRET)
         TSEQ = IDUM(1)
         IF (IRET.NE.0) GO TO 999
         CALL OGET ('Input', 'OUTDISK', TYPE, DIM, IDUM, CDUMMY, IRET)
         TDISK = IDUM(1)
         IF (IRET.NE.0) GO TO 999
         IF ((TSEQ.LE.0) .OR. (TDISK.LE.0)) ALLOK = 0
         END IF
      DIM(1) = 1
      DIM(2) = 1
      IDUM(1) = ALLOK
      CALL OPUT ('Input', 'ALLOKAY', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       3D imaging # beams
      CALL OGET ('Input', 'DO3DIMAG', TYPE, DIM, IDUM, CDUMMY, IRET)
      DO3DIM = LDUM(1)
      IF (IRET.NE.0) GO TO 999
C                                       Check multi-res
      IF (NUMRES.GT.1) THEN
         CALL OGET ('Input', 'OVERLAP', TYPE, DIM, IDUM, CDUMMY, IRET)
         OVRLAP = IDUM(1)
         IF (IRET.NE.0) GO TO 999
         IF (OVRLAP.LE.1) THEN
            MSGTXT = 'OVERLAP CHANGED TO 2 FOR MULTI-FIELD CLEAN'
            CALL MSGWRT (7)
            OVRLAP = 2
            IDUM(1) = 2
            CALL OPUT ('Input', 'OVERLAP', TYPE, DIM, IDUM, CDUMMY,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
         END IF
C                                       Create CLEAN object
      CLEAN = 'CLEAN process object'
      CALL CREATE (CLEAN, 'CLEAN', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       OBOXFILE special usage
      CALL OGET ('Input', 'OBOXFILE', TYPE, DIM, IDUM, OBXFIL, IRET)
      IF (IRET.NE.0) GO TO 999
      I = JTRIM (OBXFIL)
      IF ((I.GT.0) .AND. (OBXFIL(I:I).EQ.':')) THEN
         CALL ZDATE (IDATE)
         CALL ZTIME (ITIME)
         WRITE (OBXFIL(I+1:),1050) IDATE, ITIME
         CALL OPUT ('Input', 'OBOXFILE', TYPE, DIM, IDUM, OBXFIL, IRET)
         IF (IRET.NE.0) GO TO 999
         I = JTRIM (OBXFIL)
         WRITE (MSGTXT,1051) OBXFIL(:I)
         CALL MSGWRT (2)
         END IF
C                                       Copy adverbs to object
      CALL FILL (MAXFLD, 0, BCOMP)
      CALL OGET ('Input', 'BCOMP', TYPE, DIM, BCOMP, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, CLEAN, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       temporary OBOXFILE
      IF (OBXFIL.EQ.' ') THEN
         CALL ZDATE (IDATE)
         CALL ZTIME (ITIME)
         WRITE (OBXFIL,1052) IDATE, ITIME
         DIM(1) = 48
         DIM(2) = 1
         CALL OPUT (CLEAN, 'OBOXFILE', OOACAR, DIM, IDUM, OBXFIL, IRET)
         IF (IRET.NE.0) GO TO 999
         I = JTRIM (OBXFIL)
         WRITE (MSGTXT,1053) OBXFIL(:I)
         CALL MSGWRT (2)
         END IF
      IF (MFIELD.GT.MAXAFL) THEN
         CALL ISUM (MAXAFL, BCOMP, BSUM)
         BSUM = BSUM / MAXAFL
         CALL FILL (MAXFLD-MAXAFL, BSUM, BCOMP(MAXAFL+1))
         END IF
      DIM(1) = 1
      INTROK = .NOT.RQUICK
      LDUM(1) = INTROK
      CALL OPUT (CLEAN, 'INTACTOK', OOALOG, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = NUMRES
      CALL OPUT (CLEAN, 'NUMRES', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      TVGRCS(1) = 5
      TVGRCS(2) = 7
      TVGRCS(3) = 6
      DIM(1) = 3
      CALL OPUT (CLEAN,'TVGRCHAN', OOAINT, DIM, TVGRCS, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Convert BMAJ, BMIN to degrees
      CALL OGET ('Input', 'BMAJ', TYPE, DIM, IDUM, CDUMMY, IRET)
      BMAJ = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      BMAJ = BMAJ / 3600.0
      RDUM(1) = BMAJ
      CALL OPUT (CLEAN, 'BEAM.BMAJ', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'BMIN', TYPE, DIM, IDUM, CDUMMY, IRET)
      BMIN = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      BMIN = BMIN / 3600.0
      RDUM(1) = BMIN
      CALL OPUT (CLEAN, 'BEAM.BMIN', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Set CLEAN type
      CLNTYP = 'UV'
      DIM(1) = LEN (CLNTYP)
      DIM(2) = 1
      CALL OPUT (CLEAN, 'CLEANTYP', OOACAR, DIM, IDUM, CLNTYP, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Set default stokes.
      CALL OGET ('Input', 'STOKES', TYPE, DIM, IDUM, STOKES, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (STOKES.EQ.' ') STOKES = 'I'
      CALL OPUT ('Input', 'STOKES', TYPE, DIM, IDUM, STOKES, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create other objects
C                                       UVDATA
      UVDATA = 'Input UVdata'
      CALL CREATE (UVDATA, 'UVDATA', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, UVDATA, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'SRCNAME', TYPE, DIM, IDUM, SRCNAM, IRET)
      IF (IRET.NE.0) GO TO 999
      SOURCS(1) = SRCNAM
      DIM(2) = 30
      CALL OPUT (UVDATA, 'CALEDIT.SOURCS', TYPE, DIM, IDUM, SOURCS,
     *   IRET)
      IF (IRET.NE.0) GO TO 999

C                                       DOCALIB
      CALL OGET ('Input', 'DOCALIB', TYPE, DIM, IDUM, CDUMMY, IRET)
      XDOCAL = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      LDUM(1) = XDOCAL.GT.0.0
      CALL OPUT (UVDATA, 'CALEDIT.DOCAL', OOALOG, DIM, IDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      LDUM(1) = (XDOCAL.GT.0.0) .AND. (XDOCAL.LE.99.0)
      CALL OPUT (UVDATA, 'CALEDIT.DOWTCL', OOALOG, DIM, IDUM, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Get IF channel selection
      CALL SECSLT (UVDATA, BIF, EIF, BCHAN, ECHAN, STOKES, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       All Stokes, IF, channels
      CALL SECSAV (UVDATA, 1, 0, 1, 0, '    ', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       all subarrays
      CALL SECGET (UVDATA, 'SUBARR', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL COPY (DIM(1), IDUM, SUBA)
C                                       check out requested subarrays
      IF (SUBA(1).GT.0) THEN
         NSUBA = 1
      ELSE
         ANTAB = 'AN table for UVTAVG'
         LSUB1 = 1
         CALL UV2TAB (UVDATA, ANTAB, 'AN', LSUB1, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       How many antennas files
         CALL TBLHIV (ANTAB, LSUB2, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OUVDES (ANTAB, IRET)
         IF (IRET.NE.0) GO TO 999
         LSUB1 = 1
         LSUB2 = MAX (1, LSUB2)
         IF (LSUB2.GT.1) THEN
            NSUBA = 0
            DO 30 I = 1,LSUB2
               IDUM(1) = I
               CALL SECPUT (UVDATA, 'SUBARR', TYPE, DIM, IDUM, CDUMMY,
     *            IRET)
               IF (IRET.NE.0) GO TO 999
               MSGSUP = 32000
               CALL OOPEN (UVDATA, 'READ', IRET)
               MSGSUP = 0
               IF (IRET.EQ.0) THEN
                  NSUBA = NSUBA + 1
                  SUBA(NSUBA) = I
                  CALL OCLOSE (UVDATA, IRET)
                  IF (IRET.NE.0) GO TO 999
                  END IF
 30            CONTINUE
            IF (NSUBA.LE.0) THEN
               IRET = 8
               MSGTXT = 'NO SUBARRAYS WITH DATA WERE FOUND'
               CALL MSGWRT (8)
               GO TO 999
               END IF
            I = SUBA(1)
         ELSE
            NSUBA = 1
            I = 1
            END IF
         IDUM(1) = I
         CALL SECPUT (UVDATA, 'SUBARR', TYPE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Open UVDATA to be sure it is OK.
      CALL OOPEN (UVDATA, 'READ', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Check data type
      CALL UVDGET (UVDATA, 'TYPEUVD', TYPE, DIM, IDUM, UVTYPE, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (UVTYPE(:1).NE.'U') THEN
         MSGTXT = 'I DO NOT WORK FOR UV DATA OF TYPE ''' // UVTYPE //
     *      ''''
         IRET = 9
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       East-West not 3D
      IF ((UVTYPE.NE.'UV') .AND. (DO3DIM)) THEN
         IF ((NUMRES.LE.0) .AND. (MFIELD.LE.MAXAFL)) DO3DIM = .FALSE.
         DIM(1) = 1
         DIM(2) = 1
         LDUM(1) = DO3DIM
         CALL OPUT ('Input', 'DO3DIMAG', OOALOG, DIM, IDUM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT (CLEAN, 'DO3DIMAG', OOALOG, DIM, IDUM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         IF (DO3DIM) THEN
            MSGTXT = 'Warning: using DO3DIM true for NCP data'
            CALL MSGWRT (7)
            END IF
         END IF
      CALL OCLOSE (UVDATA, IRET)
      IF (IRET.NE.0) GO TO 999
      BFIELD = MFIELD
C                                       Reset Selection
      CALL SECSAV (UVDATA, BIF, EIF, BCHAN, ECHAN, STOKES, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       check that only one source made
C                                       into the selected UV data file.
      CALL UVDFND (UVDATA, 1, 'SOURCE', SRCIDX, IRET)
C                                       The OOP system should have masked
C                                       the source random parameter if
C                                       this is a single source file or
C                                       only one source was selected.
C                                       If IRET is zero then a SOURCE
C                                       random parameter was found.
      IF (IRET.EQ.0) THEN
         MSGTXT = '**  ONE and ONLY ONE source must be specified'
         CALL MSGWRT (6)
         MSGTXT = '**  Use SPLIT & DBCON to image multiple sources'
         CALL MSGWRT (6)
         IRET = 16
         GO TO 999
         END IF
C                                       UVWORK
      UVWORK = 'UVdata work object'
      CALL CREATE (UVWORK, 'UVDATA', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY3, INK3, OUTK3, UVWORK, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       BEAM
      DO 40 I = 1,BFIELD
         WRITE (BEAM(I),1002) I
         IF ((.NOT.ONEBEM) .OR. (MOD(I,NFIELD).EQ.1) .OR. (NFIELD.EQ.1))
     *      THEN
            CALL CREATE (BEAM(I), 'IMAGE', IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
            CALL IN2OBJ ('Input', NKEY4, INK4, OUTK4, BEAM(I), IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Classes derived from Stokes
            CLTYPE = 'BM'
            IF (I.LE.999) THEN
               WRITE (CLASS,1040) STOKES(1:1), CLTYPE, I
            ELSE
               WRITE (CLASS,1041) STOKES(1:1), CLTYPE(1:1), I
               END IF
            DIM(1) = 6
            CALL OPUT (BEAM(I), 'CLASS', OOACAR, DIM, IDUM, CLASS,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
 40      CONTINUE
C                                       CLEAN
      J = 1
      CALL RFILL (3, 0.0, HDRBM)
      DO 50 I = 1,MFIELD
         WRITE (CLEANO(I),1000) I
         CALL CREATE (CLEANO(I), 'IMAGE', IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
         CALL IN2OBJ ('Input', NKEY5, INK5, OUTK5, CLEANO(I), IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Class from stokes
         IF (NITER.GT.0) THEN
            CLTYPE = 'CL'
         ELSE
            CLTYPE = 'IM'
            END IF
         IF (I.LE.999) THEN
            WRITE (CLASS,1040) STOKES(1:1), CLTYPE, I
         ELSE
            WRITE (CLASS,1041) STOKES(1:1), CLTYPE(1:1), I
            END IF
         DIM(1) = LEN (CLASS)
         DIM(2) = 1
         CALL OPUT (CLEANO(I), 'CLASS', OOACAR, DIM, IDUM, CLASS, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Model component diameter
         DIM(1) = 1
         RDUM(1) = COMRES(J)
         CALL OPUT (CLEANO(I), 'COMPDIAM', OOARE, DIM, IDUM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         RDUM(1) = FLXRES(J)
         CALL OPUT (CLEANO(I), 'MINFLUX', OOARE, DIM, IDUM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         IDUM(1) = NUMRES
         CALL OPUT (CLEANO(I), 'NUMRES', OOAINT, DIM, IDUM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
C                                       taper
         DIM(1) = 2
         CALL RCOPY (2, UVTAPR, RDUM)
         CALL OPUT (CLEANO(I), 'WTTAPER', OOARE, DIM, IDUM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         CALL RCOPY (2, TAPER(1,J), RDUM)
         CALL OPUT (CLEANO(I), 'UVTAPER', OOARE, DIM, IDUM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
C                                       header beam
         DIM(1) = 3
         CALL RCOPY (3, HDRBM, RDUM)
         CALL OPUT (CLEANO(I), 'HDRBEAM', OOARE, DIM, IDUM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
C                                       increment resolution number
         IF (MOD(I,NFIELD).EQ.0) J = J + 1
 50      CONTINUE
C                                       Attach Images etc. to CLEAN
C                                       BEAM image
      DIM(1) = LEN (BEAM(1))
      DIM(2) = BFIELD
      DIM(3) = 1
      CALL OPUT (CLEAN, 'DIRTBEAM', OOACAR, DIM, IDUM, BEAM, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       CLEAN image(s)
      DIM(1) = LEN (CLEANO(1))
      DIM(2) = MFIELD
      CALL OPUT (CLEAN, 'CLEANI', OOACAR, DIM, IDUM, CLEANO, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Number of fields
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      IDUM(1) = MFIELD
      CALL OPUT (CLEAN, 'NIMAGES', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       UVWORK
      DIM(1) = LEN (UVWORK)
      DIM(2) = 1
      CALL OPUT (CLEAN, 'UVDATA', OOACAR, DIM, IDUM, UVWORK, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Process other info
C                                       Field size
      CALL FILL (2*MAXFLD, 0, FLDSIZ)
      CALL OGET ('Input', 'FLDSIZE', TYPE, DIM, FLDSIZ, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Min. image sizes
      CALL FILL (2*MAXFLD, 0, IMSIZE)
      CALL OGET ('Input', 'IMSIZE', TYPE, DIM, IMSI, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RFILL (MAXFLD, 0.0, RASH)
      CALL OGET ('Input', 'RASHIFT', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, RASH)
      CALL RFILL (MAXFLD, 0.0, DECSH)
      CALL OGET ('Input', 'DECSHIFT', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, DECSH)
C                                       BOXFILE option for field
C                                       parameters
      CALL OGET ('Input', 'BOXFILE', TYPE, DIM, IDUM, BOXFIL, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (BOXFIL.NE.' ') THEN
C                                       Need coords and rotation
         CALL OUVGET (UVDATA, 'ROTATE', TYPE, DIM, IDUM, CDUMMY, IRET)
         ROTATE = RDUM(1)
         IF (IRET.NE.0) GO TO 999
         CALL UVDGET (UVDATA, 'CRVAL', TYPE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL DPCOPY (DIM(1), DDUM, CRVAL)
         CALL UVDGET (UVDATA, 'CROTA', TYPE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL RCOPY (DIM(1), RDUM, CROTAU)
         CALL UVDFND (UVDATA, 2, 'RA', JLOCR, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL UVDFND (UVDATA, 2, 'DEC', JLOCD, IRET)
         IF (IRET.NE.0) GO TO 999
         ROTATE = ROTATE + CROTAU(JLOCD)
         CALL FIELDF (BOXFIL, NFIELD, MFIELD, CRVAL(JLOCR),
     *      CRVAL(JLOCD), ROTATE, FLDSIZ, RASH, DECSH, BCOMP, IRET)
         IF (IRET.GT.0) THEN
            MSGTXT = 'IMALIN: Error in defining field parms from file'
            CALL MSGWRT (7)
            GO TO 999
            END IF
         END IF
C                                       put back in objects
      DO 60 I = 2,NUMRES
         J = (I-1) * NFIELD + 1
         CALL RCOPY (NFIELD, RASH(1), RASH(J))
         CALL RCOPY (NFIELD, DECSH(1), DECSH(J))
         CALL COPY (2*NFIELD, FLDSIZ(1,1), FLDSIZ(1,J))
 60      CONTINUE
      DIM(1) = MAXAFL
      DIM(2) = 1
      CALL RCOPY (MAXAFL, RASH, RDUM)
      CALL OPUT ('Input', 'RASHIFT', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (MAXAFL, DECSH, RDUM)
      CALL OPUT ('Input', 'DECSHIFT', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL COPY (MAXAFL, BCOMP, IDUM)
      CALL OPUT ('Input', 'BCOMP', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = MAXFLD
      CALL COPY (MAXFLD, BCOMP, IDUM)
      CALL OPUT (CLEAN, 'BCOMP', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (MAXFLD, RASH, RDUM)
      CALL OPUT (CLEANO(1), 'RASHIFT', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (MAXFLD, DECSH, RDUM)
      CALL OPUT (CLEANO(1), 'DECSHIFT', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       No images smaller than 64
C                                       and must be power of 2
      IMSI(1) = MAX (IMSI(1), 64)
      IMSI(2) = MAX (IMSI(2), 64)
      IMSI(1) = NPTWO (IMSI(1))
      IMSI(2) = NPTWO (IMSI(2))
      MAXNX = 0
      MAXNY = 0
      MINNX = MAXIMG
      MINNY = MAXIMG
      DO 70 I = 1,MAXFLD
         IF ((FLDSIZ(1,I).LT.0) .AND. (FLDSIZ(2,I).LT.0)) THEN
            FLDSIZ(1,I) = -1
            FLDSIZ(2,I) = -1
            NXFLD = 0
            NYFLD = 0
         ELSE
            IF (FLDSIZ(1,I).LE.0) FLDSIZ(1,I) = IMSI(1) - 10
            IF (FLDSIZ(2,I).LE.0) FLDSIZ(2,I) = IMSI(2) - 10
C                                       Next largest power of two
            NXFLD = NPTWO (FLDSIZ(1,I))
            NYFLD = NPTWO (FLDSIZ(2,I))
            END IF
         IMSIZE(1,I) = MAX (IMSI(1), NXFLD)
         IMSIZE(2,I) = MAX (IMSI(2), NYFLD)
         MAXNX = MAX (MAXNX, IMSIZE(1,I))
         MAXNY = MAX (MAXNY, IMSIZE(2,I))
         MINNX = MIN (MINNX, IMSIZE(1,I))
         MINNY = MIN (MINNY, IMSIZE(2,I))
 70      CONTINUE
      DIM(1) = 2
      DIM(2) = MAXAFL
      CALL OPUT ('Input', 'FLDSIZE', OOAINT, DIM, FLDSIZ, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(2) = MAXFLD
      CALL OPUT (CLEANO(1), 'IMSIZE', OOAINT, DIM, IMSIZE, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(2) = 1
      DO 80 I = 2,MFIELD
         CALL OPUT (CLEANO(I), 'IMSIZE', OOAINT, DIM, IMSIZE(1,I),
     *      CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
 80      CONTINUE
C                                       Beam size
      CALL OGET ('Input', 'NITER', TYPE, DIM, IDUM, CDUMMY, IRET)
      NITER = IDUM(1)
      IF (IRET.NE.0) GO TO 999
C                                       Control information.
      CALL OGET ('Input', 'IMAGRPRM', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, IMPARM)
      CALL OGET ('Input', 'IM2PARM', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, IM2PRM)
C                                       time limits
      LIMTIM(1) = IROUND (IM2PRM(8))
      LIMTIM(2) = IROUND (IM2PRM(9))
      DIM(1) = 2
      DIM(2) = 1
      CALL OPUT (CLEAN, 'TVTIMLIM', OOAINT, DIM, LIMTIM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       auto boxing
      AUTOBX(1) = IROUND (IM2PRM(1))
      AUTOBX(2) = IM2PRM(2)
      AUTOBX(3) = IM2PRM(3)
      AUTOBX(4) = IM2PRM(4)
      AUTOBX(5) = IROUND (IM2PRM(5))
      AUTOBX(6) = IROUND (IM2PRM(6))
      AUTOBX(1) = MIN (50.0, AUTOBX(1))
      IF (AUTOBX(2).LE.1.5) AUTOBX(2) = 3.
      IF (AUTOBX(3).LT.AUTOBX(2)) AUTOBX(3) = AUTOBX(2) + 2.
      IF (AUTOBX(4).LT.0.01) AUTOBX(4) = 0.1
      IF (AUTOBX(4).GT.0.90) AUTOBX(4) = 0.1
      IF (AUTOBX(5).LT.-1.0) AUTOBX(5) = 1.0
      IF (AUTOBX(5).GT.6.0) AUTOBX(5) = 6.0
      IF (AUTOBX(6).LT.1.0) AUTOBX(6) = 5.0
      IF (AUTOBX(6).GT.IMSIZE(1,1)/20.0) AUTOBX(6) = 5.0
      IM2PRM(1) = AUTOBX(1)
      IM2PRM(2) = AUTOBX(2)
      IM2PRM(3) = AUTOBX(3)
      IM2PRM(4) = AUTOBX(4)
      IM2PRM(5) = AUTOBX(5)
      IM2PRM(6) = AUTOBX(6)
      IF (IM2PRM(7).EQ.0.0) THEN
         IF (AUTOBX(1).GT.0.5) THEN
            IM2PRM(7) = 1.0
         ELSE
            IM2PRM(7) = -1.0
            END IF
      ELSE IF (IM2PRM(7).GT.0.0) THEN
         IM2PRM(7) = 1.0
      ELSE
         IM2PRM(7) = -1.0
         END IF
      REWIN = IM2PRM(7).GT.0.0
C                                       inverse taper
      INVERT(1) = IM2PRM(16)
      INVERT(2) = IM2PRM(17)
      INVERT(3) = IM2PRM(18)
      IF ((INVERT(1).LE.0.0) .OR. (INVERT(1).GE.1.0) .OR.
     *   (INVERT(2).LE.0.0)) THEN
         CALL RFILL (3, 0.0, INVERT)
      ELSE IF (INVERT(3).LE.0.0) THEN
         INVERT(3) = INVERT(2)
         END IF
C                                       set beam size
      DIM(1) = 2
      DIM(2) = 1
      DO 85 I = 1,BFIELD
         IF ((.NOT.ONEBEM) .OR. (MOD(I,NFIELD).EQ.1) .OR. (NFIELD.EQ.1))
     *      THEN
            IF (ONEBEM) THEN
               NX = MAXNX
               NY = MAXNY
            ELSE
               NX = IMSIZE(1,I)
               NY = IMSIZE(2,I)
               END IF
C                                       If not cleaning beam = field
            IF (NITER.LE.0) THEN
               NXBEM(I) = NX
               NYBEM(I) = NY
C                                       else large or smaller
            ELSE IF (IMPARM(10).LT.0.2) THEN
               NXBEM(I) = MIN (NX*2, 2048)
               NYBEM(I) = MIN (NY*2, 2048)
            ELSE IF (IMPARM(10).GT.1.5) THEN
               NXBEM(I) = MIN (NX*2, MAXIMG)
               NYBEM(I) = MIN (NY*2, MAXIMG)
            ELSE IF (IMPARM(10).GT.0.75) THEN
               NXBEM(I) = MIN (NX, 4096)
               NYBEM(I) = MIN (NY, 4096)
            ELSE IF (IMPARM(10).GT.0.37) THEN
               NXBEM(I) = MIN (NX/2, 2048)
               NYBEM(I) = MIN (NY/2, 2048)
            ELSE
               NXBEM(I) = MIN (NX/4, 2048)
               NYBEM(I) = MIN (NY/4, 2048)
               END IF
            BMSIZ(1) = NXBEM(I)
            BMSIZ(2) = NYBEM(I)
            CALL OPUT (BEAM(I), 'IMSIZE', OOAINT, DIM, BMSIZ, CDUMMY,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
 85      CONTINUE
C                                       Define the clean boxes
C                                       Create clean windows
      WINM = MIN (MXNBOX, MXNBFL/MFIELD)
      WINW = 4 * MFIELD * WINM
      NWORDS = (WINW - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', 'IMAGR', NWORDS, WIN, WINP, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Start with program inputs
      CALL FILL (NFIELD, 1, NBOXES)
      CALL FILL (WINW, 0, WIN(1+WINP))
      CALL OGET ('Input', 'NBOXES', TYPE, DIM, IDUM, CDUMMY, IRET)
      NBOXES(1) = IDUM(1)
      IF (IRET.NE.0) GO TO 999
C                                       Window
      CALL OGET ('Input', 'CLBOX', TYPE, DIM, CLBOX, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (NBOXES(1).GT.0) THEN
         IS = 2
         DO 87 K = 1,NBOXES(1)
            KP = (K-1) * MFIELD * 4 + 1 + WINP
            CALL COPY (4, CLBOX(1,K), WIN(KP))
 87         CONTINUE
      ELSE
         NBOXES(1) = 1
         IS = 1
         END IF
C                                       Fill in higher windows
C                                       or all if NBOXES <= 0
      DO 90 I = IS,NFIELD
         KP = 4 * (I-1) + WINP
C                                       Only if there are boxes
         IF (FLDSIZ(1,I).LT.0) THEN
            WIN(1+KP) = 5
            WIN(2+KP) = 5
            WIN(3+KP) = IMSIZE(1,I) - 5
            WIN(4+KP) = IMSIZE(2,I) - 5
C                                       fill window from IMSIZE and
C                                       FLDSIZE
         ELSE
            EDGEX = IMSIZE(1,I) - FLDSIZ(1,I)
            EDGEY = IMSIZE(2,I) - FLDSIZ(2,I)
            WIN(1+KP) = EDGEX / 2
            WIN(2+KP) = EDGEY / 2
            WIN(3+KP) = IMSIZE(1,I) - EDGEX / 2
            WIN(4+KP) = IMSIZE(2,I) - EDGEY / 2
            END IF
         IF (AUTOBX(1).GT.0) NBOXES(I) = 0
 90      CONTINUE
C                                       BOXFILE option?
      IF (BOXFIL(1:1).NE.' ') THEN
         CALL WINDF (WIN(1+WINP), NBOXES, MFIELD, IMSIZE, BOXFIL, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'IMALIN: Error in defining clean boxes from file'
            CALL MSGWRT(7)
            GO TO 999
            END IF
         END IF
      DO 100 I = 1,NFIELD
         IF (NBOXES(I).GT.0) THEN
            J = I
            DO 95 II = 2,NUMRES
               J = J + NFIELD
               IF (NBOXES(J).LE.0) THEN
                  NBOXES(J) = NBOXES(I)
                  DO 94 K = 1,NBOXES(I)
                     KP = (K-1)*MFIELD*4 + WINP - 3
                     CALL COPY (4, WIN(KP+4*I), WIN(KP+4*J))
 94                  CONTINUE
                  END IF
 95            CONTINUE
            END IF
 100     CONTINUE
C                                       BOXFILE option?
      IF (BOXFIL(1:1).NE.' ') THEN
         CALL UWINDF (UNWIN, UNBOXS, MFIELD, IMSIZE, BOXFIL, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'IMALIN: Error in defining clean boxes from file'
            CALL MSGWRT(7)
            GO TO 999
            END IF
         END IF
      DO 110 I = 1,NFIELD
         IF (UNBOXS(I).GT.0) THEN
            J = I
            DO 105 II = 2,NUMRES
               J = J + NFIELD
               IF (UNBOXS(J).LE.0) THEN
                  UNBOXS(J) = UNBOXS(I)
                  DO 104 K = 1,UNBOXS(I)
                     KP = (K-1)*MFIELD*4 - 3
                     CALL COPY (4, UNWIN(KP+4*I), UNWIN(KP+4*J))
 104                 CONTINUE
                  END IF
 105           CONTINUE
            END IF
 110     CONTINUE
C                                       ignore too
      CALL RFILL (MFIELD, 1.0, IGNORE)
      IF (BOXFIL(1:1).NE.' ') THEN
         CALL IGNORF (BOXFIL, MFIELD, IGNORE, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'IMALIN: Error in defining clean boxes from file'
            CALL MSGWRT(7)
            GO TO 999
            END IF
         END IF
C                                       put parms back
      DIM(1) = MFIELD
      DIM(2) = 1
      CALL RCOPY (MFIELD, IGNORE, RDUM)
      CALL OPUT (CLEAN, 'IGNORE', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (CLEAN, 'NBOXES', OOAINT, DIM, NBOXES, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 4 * MFIELD
      DIM(2) = WINW / DIM(1)
      CALL OPUT (CLEAN, 'WINDOW', OOAINT, DIM, WIN(1+WINP), CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = MFIELD
      DIM(2) = 1
      CALL OPUT (CLEAN, 'UNBOXES', OOAINT, DIM, UNBOXS, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 4 * MFIELD
      DIM(2) = (4 * MAXFLD) / MFIELD
      DIM(2) = MIN (DIM(2), MXNBOX)
      CALL OPUT (CLEAN, 'UNWINDOW', OOAINT, DIM, UNWIN, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Restore?
      CALL OGET ('Input', 'BMAJ', TYPE, DIM, IDUM, CDUMMY, IRET)
      BMAJ = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'BMIN', TYPE, DIM, IDUM, CDUMMY, IRET)
      BMIN = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'BPA', TYPE, DIM, IDUM, CDUMMY, IRET)
      BPA = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      NOREST = BMAJ .LT. 0.0
      DIM(1) = 1
      LDUM(1) = NOREST
      CALL OPUT (CLEAN, 'NORESTORE', OOALOG, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IF ((.NOT.NOREST) .AND. (WASZER)) THEN
         IDUM(1) = NFIELD
         CALL OPUT (CLEAN, 'NFLDRSTR', OOAINT, DIM, IDUM, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Channel stuff
C                                       Default BCHAN, ECHAN
      CALL OGET ('Input', 'BCHAN', TYPE, DIM, IDUM, CDUMMY, IRET)
      BCHAN = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'ECHAN', TYPE, DIM, IDUM, CDUMMY, IRET)
      ECHAN = IDUM(1)
      IF (IRET.NE.0) GO TO 999
C                                       Find size of freq. axis.
      CALL UVDFND (UVDATA, 2, 'FREQ', FQINDX, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET (UVDATA, 'UV_DESC.NAXIS', TYPE, DIM, NAXIS, CDUMMY,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      BCHAN = MAX (BCHAN, 1)
      BCHAN = MIN (BCHAN, NAXIS(FQINDX))
      IF (ECHAN.LT.BCHAN) ECHAN = NAXIS(FQINDX)
      ECHAN = MIN (ECHAN, NAXIS(FQINDX))
      NWEGHT = NAXIS(FQINDX)
C                                       Save in Inputs for history
      DIM(1) = 1
      IDUM(1) = BCHAN
      CALL OPUT (CLEAN, 'BCHAN', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL SECPUT (UVDATA, 'BCHAN', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT ('Input', 'BCHAN', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = ECHAN
      CALL OPUT (CLEAN, 'ECHAN', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL SECPUT (UVDATA, 'ECHAN', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT ('Input', 'ECHAN', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       IF numbers
      CALL UVDFND (UVDATA, 2, 'IF  ', IFINDX, IRET)
      IRET = 0
      IF (IFINDX.GT.0) THEN
         CALL OGET ('Input', 'BIF', TYPE, DIM, IDUM, CDUMMY, IRET)
         BIF = IDUM(1)
         IF (IRET.NE.0) GO TO 999
         CALL OGET ('Input', 'EIF', TYPE, DIM, IDUM, CDUMMY, IRET)
         EIF = IDUM(1)
         IF (IRET.NE.0) GO TO 999
         BIF = MAX (1, BIF)
         BIF = MIN (BIF, NAXIS(IFINDX))
         IF (EIF.LT.BIF) EIF = NAXIS(IFINDX)
         EIF = MIN (EIF, NAXIS(IFINDX))
      ELSE
         BIF = 1
         EIF = 1
         END IF
C                                       Save in Inputs for history
      DIM(1) = 1
      IDUM(1) = BIF
      CALL OPUT ('Input', 'BIF', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL SECPUT (UVDATA, 'BIF', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = EIF
      CALL OPUT ('Input', 'EIF', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL SECPUT (UVDATA, 'EIF', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Line or continuum
      CALL OGET ('Input', 'CHINC', TYPE, DIM, IDUM, CDUMMY, IRET)
      CHINC = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'NCHAV', TYPE, DIM, IDUM, CDUMMY, IRET)
      NCHAV = IDUM(1)
      IF (IRET.NE.0) GO TO 999
      CHINC = MAX (1, CHINC)
      NCHAV = MAX (1, NCHAV)
      IF ((NCHAV.LE.ECHAN-BCHAN) .AND. ((ECHAN-BCHAN)/CHINC.GT.0)) THEN
         CHTYPE = 'LINE'
         IF ((ECHAN-BCHAN)/CHINC+1.GT.46655) THEN
            MSGTXT = 'CAN ONLY DO 46655 CHANNELS AT A TIME IN LINE'
            CALL MSGWRT (8)
            IRET = 5
            GO TO 999
            END IF
      ELSE
         CHTYPE = 'SUM '
         NCHAV = ECHAN - BCHAN + 1
         NCHAV = MAX (1, NCHAV)
         CHINC = NCHAV
         END IF
C                                       Save value
      IDUM(1) = NCHAV
      CALL OPUT ('Input', 'NCHAV', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (UVDATA, 'NCHAV', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = CHINC
      CALL OPUT ('Input', 'CHINC', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (UVDATA, 'CHINC', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OPUT (UVWORK, 'CHINC', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy UV descriptors to BEAM
      DIM(1) = LEN (CHTYPE)
      DIM(2) = 1
      DO 190 I = 1,BFIELD
         IF ((.NOT.ONEBEM) .OR. (MOD(I,NFIELD).EQ.1) .OR. (NFIELD.EQ.1))
     *      THEN
            CALL OPUT (BEAM(I), 'CHTYPE', OOACAR, DIM, IDUM, CHTYPE,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
            CALL U2IDES (UVDATA, BEAM(I), .FALSE., IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
 190     CONTINUE
C                                       Copy UV descriptors to Images
      DO 200 I = 1,MFIELD
         CALL OPUT (CLEANO(I), 'CHTYPE', OOACAR, DIM, IDUM, CHTYPE,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         CALL U2IDES (UVDATA, CLEANO(I), .FALSE., IRET)
         IF (IRET.NE.0) GO TO 999
 200     CONTINUE
C                                       SDI Clean allowed
      DIM(1) = 1
      DIM(2) = 1
      RDUM(1) = IMPARM(4)
      CALL OPUT (CLEAN, 'SDIGAIN', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       CC filter allowed
      FILTRS = IMPARM(9).LT.0.0
      IMPARM(9) = ABS (IMPARM(9))
      IF (IMPARM(9).LT.1.1) IMPARM(9) = 3.1
      DIM(1) = 2
      DIM(2) = 1
      CALL RCOPY (2, IMPARM(8), RDUM)
      CALL OPUT (CLEAN, 'CCFILTER', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 1
      LDUM(1) = FILTRS
      CALL OPUT (CLEAN, 'CCFILTRS', OOALOG, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Scale residuals?
      DOSMOO = (BMAJ.GT.0.0) .AND. (BMIN.GT.0.0) .AND.
     *   (IMPARM(5).EQ.0.0)
      IF (DOSMOO) THEN
         MSGTXT = '*************************************************'
         CALL MSGWRT (5)
         MSGTXT = 'WARNING: new function smooths and scales residual'
         CALL MSGWRT (5)
         MSGTXT = '  to correct from fit beam to user-specified beam'
         CALL MSGWRT (5)
         MSGTXT = '*************************************************'
         CALL MSGWRT (5)
         END IF
      DOSCAL = IMPARM(5).GT.0.0
      DIM(1) = 1
      LDUM(1) = DOSCAL
      CALL OPUT (CLEAN, 'SCALERES', OOALOG, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      LDUM(1) = DOSMOO
      CALL OPUT (CLEAN, 'SMOOTHES', OOALOG, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      BMSSZ(1) = IROUND (IMPARM(6))
      BMSSZ(2) = IROUND (IMPARM(7))
      IF (BMSSZ(1).LE.0) BMSSZ(1) = 5
      IF (BMSSZ(2).LE.0) BMSSZ(2) = 5
      DIM(1) = 2
      CALL OPUT (CLEAN, 'BMSCLSZ', OOAINT, DIM, BMSSZ, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       auto box into objects
      DIM(1) = 40
      DIM(2) = 1
      CALL RCOPY (40, IM2PRM, RDUM)
      CALL OPUT ('Input', 'IM2PARM', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 6
      CALL RCOPY (6, AUTOBX, RDUM)
      CALL OPUT (CLEAN, 'AUTOBOX', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 3
      CALL RCOPY (3, INVERT, RDUM)
      CALL OPUT (CLEANO(1), 'INVERTAP', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Guard band in uv grids.
      CALL OGET ('Input', 'CELLSIZE', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, CELLS)
C                                       UV Cellsize for smallest image
      DU = RAD2AS / (MINNX * ABS (CELLS(1)))
      DV = RAD2AS / (MINNY * CELLS(2))
C                                       Set limits.
      UMAX = (MINNX/2-1.0) * DU
      VMAX = (MINNY/2-1.0) * DV
C                                       Add maximum of user specified
C                                       guardband or 7 cells.
      CALL OGET ('Input', 'GUARD', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, GUARDB)
C                                       default guard band widths
      UTFACT(1) = 1.0
      IF (UVTAPR(1).GT.0.0) UTFACT(1) =  EXP (LOG(0.3) *
     *   ((UMAX*0.7) / (1000. * UVTAPR(1)))**2)
      UTFACT(1) = 0.3 * SQRT (UTFACT(1))
      GUAU = 7.0 * DU
      IF (GUARDB(1).LT.-0.001) THEN
         GUARDB(1) = GUAU / UMAX
      ELSE IF ((GUARDB(1).LE.0.001) .OR. (GUARDB(1).GT.0.9)) THEN
         GUARDB(1) = UTFACT(1)
         END IF
      GUAU = MAX (GUAU, GUARDB(1)*UMAX)
      UTFACT(2) = 1.0
      IF (UVTAPR(2).GT.0.0) UTFACT(2) =  EXP (LOG(0.3) *
     *   ((VMAX*0.7) / (1000. * UVTAPR(2)))**2)
      UTFACT(2) = 0.3 * SQRT (UTFACT(2))
      GUAV = 7.0 * DV
      IF (GUARDB(2).LT.-0.001) THEN
         GUARDB(2) = GUAV / VMAX
      ELSE IF ((GUARDB(2).LE.0.001) .OR. (GUARDB(2).GT.0.9)) THEN
         GUARDB(2) = UTFACT(2)
         END IF
      GUAV = MAX (GUAV, GUARDB(2)*VMAX)
      GUARDB(1) = GUAU / UMAX
      GUARDB(2) = GUAV / VMAX
      CALL RCOPY (DIM(1), GUARDB, RDUM)
      CALL OUVPUT (UVDATA, 'GUARDBND', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), UTFACT, RDUM)
      CALL OUVPUT (UVDATA, 'GUARDEF', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), CELLS, RDUM)
      CALL OUVPUT(UVDATA, 'CELLSIZE', TYPE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      UMAX = UMAX - GUAU
      VMAX = VMAX - GUAV
      DIM(1) = 1
      DIM(2) = 1
      RDUM(1) = UMAX
      CALL OUVPUT (UVDATA, 'UMAX', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      RDUM(1) = VMAX
      CALL OUVPUT (UVDATA, 'VMAX', OOARE, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Put in TELL adverb list
      TELOBJ = 'IMAGR Tell object'
      DIM(1) = LEN (TELOBJ)
      DIM(2) = 1
      CALL OPUT (CLEAN, 'TELLNAME', OOACAR, DIM, IDUM, TELOBJ, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 8
      DIM(2) = NKEYT
      DIM(3) = 1
      CALL OPUT (CLEAN, 'TELADVRB', OOACAR, DIM, IDUM, TELK, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 2
      CALL COPY (2*NKEYT, TELDIM, IDUM)
      CALL OPUT (CLEAN, 'TELLDIMS', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = NKEYT
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (CLEAN, 'TELLTYPE', OOAINT, DIM, TELTYP, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       BOXFILE option for weights
      I = NWEGHT * (EIF-BIF+1)
      CALL RFILL (I, 1.0, WEGHTS)
      IF (BOXFIL.NE.'  ') THEN
         CALL WTBOXF (BOXFIL, BIF, EIF, NWEGHT, WEGHTS, IRET)
         IF (IRET.GT.0) THEN
            MSGTXT = 'FAILED READING BOXFILE FOR WEIGHTS'
            CALL MSGWRT (8)
            END IF
         END IF
C                                       Boxfile option for Stars
      NSTAR = 0
      IF (BOXFIL(1:1).NE.' ') THEN
         CALL STBOXF (BOXFIL, NSTAR, STPOS, STPARM, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'FAILED READING BOXFILE FOR STAR POSITIONS'
            CALL MSGWRT (8)
            END IF
         END IF
      IF (NSTAR.GT.0) THEN
         DIM(1) = 1
         DIM(2) = 1
         IDUM(1) = NSTAR
         CALL OPUT (CLEAN, 'NSTARS', OOAINT, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         DIM(1) = 2
         DIM(2) = NSTAR
         CALL DPCOPY (2*NSTAR, STPOS, DDUM)
         CALL OPUT (CLEAN, 'STARPOSN', OOADP, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         DIM(1) = 4
         CALL RCOPY (4*NSTAR, STPARM, RDUM)

         CALL OPUT (CLEAN, 'STARPARM', OOARE, DIM, IDUM, CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 999
         WRITE (MSGTXT,1200) NSTAR
         CALL MSGWRT (2)
         END IF
C                                       Copy BOXFILE to OBOXFILE
      IF (IRET.EQ.0) CALL CPBOXF (BOXFIL, OBXFIL, IRET)
C                                       spectral index image
      IF (IMPARM(17).GT.0.0) THEN
         CALL OGET ('Input', 'IN3NAME', TYPE, DIM, IDUM, TINAME, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OGET ('Input', 'IN3CLASS', TYPE, DIM, IDUM, TCLASS, IRET)
         IF (IRET.NE.0) GO TO 999
         IF ((TINAME.NE.' ') .AND. (TCLASS.NE.' ')) THEN
            SPIX = 'Spectral index image'
            CALL CREATE (SPIX, 'IMAGE', IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
            CALL IN2OBJ ('Input', NKEY6, INK6, OUTK6, SPIX, IRET)
            IF (IRET.NE.0) GO TO 999
            DIM(1) = 1
            DIM(2) = 1
            IMPARM(17) = IMPARM(17) - 0.5
            RDUM(1) = IMPARM(17)
            CALL OPUT (SPIX, 'SPIXRADIUS', OOARE, DIM, IDUM, CDUMMY,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Open SPIX to be sure it is OK
            CALL OOPEN (SPIX, 'READ', IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OCLOSE (SPIX, IRET)
            IF (IRET.NE.0) GO TO 999
            DIM(1) = LEN (SPIX)
            DIM(2) = 1
            DIM(3) = 1
            CALL OPUT (UVDATA, 'SPIXIMAGE', OOACAR, DIM, IDUM, SPIX,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OPUT (UVWORK, 'SPIXIMAGE', OOACAR, DIM, IDUM, SPIX,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
C                                       curvature?
            CALL OGET ('Input', 'IN4NAME', TYPE, DIM, IDUM, TINAME,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
            CALL OGET ('Input', 'IN4CLASS', TYPE, DIM, IDUM, TCLASS,
     *         IRET)
            IF (IRET.NE.0) GO TO 999
            IF ((TINAME.NE.' ') .AND. (TCLASS.NE.' ')) THEN
               SPIXC = 'Spectral index curvature image'
               CALL CREATE (SPIXC, 'IMAGE', IRET)
               IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
               CALL IN2OBJ ('Input', NKEY6, INK6B, OUTK6, SPIXC, IRET)
               IF (IRET.NE.0) GO TO 999
C                                       Open SPIXC to be sure it is OK
               CALL OOPEN (SPIXC, 'READ', IRET)
               IF (IRET.NE.0) GO TO 999
               CALL OCLOSE (SPIXC, IRET)
               IF (IRET.NE.0) GO TO 999
               DIM(1) = LEN (SPIXC)
               DIM(2) = 1
               DIM(3) = 1
               CALL OPUT (UVDATA, 'SPIXCURV', OOACAR, DIM, IDUM, SPIXC,
     *            IRET)
               IF (IRET.NE.0) GO TO 999
               CALL OPUT (UVWORK, 'SPIXCURV', OOACAR, DIM, IDUM, SPIXC,
     *            IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLEAN field number ',I4.4)
 1002 FORMAT ('BEAM field number ',I4.4)
 1010 FORMAT ('Number scales reset to',I2,' dropping duplicates')
 1040 FORMAT (A1,A2,I3.3)
 1041 FORMAT (A1,A1,I4.4)
 1050 FORMAT ('OBOXfile',I4,2I2.2,'.',3I2.2)
 1051 FORMAT ('Using OBOXFILE = ''',A,'''')
 1052 FORMAT ('HOME:OBOXtemp',I4,2I2.2,'.',3I2.2)
 1053 FORMAT ('Using temporary OBOXFILE = ''',A,'''')
 1200 FORMAT ('Will plot',I4,' star positions')
      END
      INTEGER FUNCTION NPTWO (N)
C-----------------------------------------------------------------------
C   Function to determine the next highest power of two for an integer.
C   Input:
C      N       I  Integer
C   Output:
C      NPTWO   I  Next highest power of two
C-----------------------------------------------------------------------
      INTEGER   N
C
      INTEGER   IPOW
      REAL      POW
C-----------------------------------------------------------------------
      POW = LOG (1.0*N) / LOG (2.0) + 0.99999
      IPOW = POW
      NPTWO = 2 ** IPOW
C
 999  RETURN
      END
      SUBROUTINE IMLEAN (CLEAN, UVDATA, NSUBA, SUBA, IERR)
C-----------------------------------------------------------------------
C   Does CLEAN, looping over channels
C   Inputs:
C      CLEAN   C*?   Name of CLEAN process object
C      UVDATA  C*?   Name of UV data input object
C      NSUBA   I     size of SUBA
C      SUBA    I(*)  Requested subarray(s)
C   Output:
C      IERR    I     Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER CLEAN*(*), UVDATA*(*)
      INTEGER   NSUBA, SUBA(*), IERR
C
      DOUBLE PRECISION APCORE(2)
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ICHAN, BCHAN, ECHAN, CHINC, CHANN, TYPE, DIM(7), NCHAV,
     *   I, NFIELD, JCHAN, LCHAN, NIF, BIF, EIF, NCHAVG, LECHAN, NUMCH,
     *   JERR, UVWSEQ, BCOMP(MAXFLD), ALLOK, NVIS, J, JJ, II, NGOOD,
     *   UVWDSK, UVWCNO, BLIMIC, IROUND, MMM, CHINCG, NCLNO, TCAT(256),
     *   SCRTCH(256)
      LOGICAL   DOPBFM, DOWARN, DOMAX, KEEP, LDUMMY, EXIST, WASBAD
      REAL      IMPARM(20), SPINDX, FSCAL, PBFSIZ, AVGTIM(2), PANGL,
     *   ZANGL, CCFILT(2), WTMUL(MAXCIF), IM2PRM(40), BLIMIT(3)
      DOUBLE PRECISION PBFREQ(MAXCIF), UVFREQ, AVFREQ
      CHARACTER UVWORK*32, CLEANO(MAXFLD)*32, CHTYPE*4, FTTYPE*4,
     *   CDUMMY*1, UVWNAM*12, UVWCLS*6, INDATA*32, NAMCTY*20
      HOLLERITH TCATH(256)
      EQUIVALENCE (TCAT, TCATH)
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'GFORT'
      INCLUDE 'IMAGRW.INC'
      INCLUDE 'IMAGWIN.INC'
C-----------------------------------------------------------------------
      AVFREQ = 0.0D0
C                                       Uv work object
      CALL OGET (CLEAN, 'UVDATA', TYPE, DIM, IDUM, UVWORK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       work file init name parms
      CALL OGET (UVDATA, 'OUTNAME', TYPE, DIM, IDUM, UVWNAM, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (UVDATA, 'OUTCLASS', TYPE, DIM, IDUM, UVWCLS, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (UVDATA, 'OUTSEQ', TYPE, DIM, IDUM, CDUMMY, IERR)
      UVWSEQ = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      KEEP = (UVWNAM.NE.' ') .OR. (UVWCLS.NE.' ') .OR. (UVWSEQ.NE.0)
      IF (UVWSEQ.GT.0) THEN
         IF (UVWCLS.EQ.' ') THEN
            UVWCLS = TSKNAM
            DIM(1) = 6
            DIM(2) = 1
            CALL OPUT (UVWORK, 'CLASS', OOACAR, DIM, IDUM, UVWCLS,
     *         IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         IF (UVWNAM.EQ.' ') THEN
            CALL OGET (UVDATA, 'NAME', TYPE, DIM, IDUM, UVWNAM, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL OPUT (UVWORK, 'NAME', TYPE, DIM, IDUM, UVWNAM, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         CALL OGET (UVWORK, 'DISK', TYPE, DIM, IDUM, CDUMMY, IERR)
         UVWDSK = IDUM(1)
         IF (IERR.NE.0) GO TO 999
         END IF
C
      AVGTIM(1) = -999.
      AVGTIM(2) = -999.
      NGOOD = 0
C                                       Control information.
C                                       3D imaging # beams
      CALL OGET (CLEAN, 'IMPARM', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, IMPARM)
      PBFSIZ = IMPARM(1)
      DOPBFM = PBFSIZ.GT.0.0
      SPINDX = IMPARM(2)
      FSCAL = IMPARM(3)
C                                       CLEAN image object
      CALL OGET (CLEAN, 'CLEANI', TYPE, DIM, IDUM, CLEANO, IERR)
      IF (IERR.NE.0) GO TO 999
      NCLNO = DIM(2)
C                                       Line or continuum
      CALL OGET (CLEANO(1), 'CHTYPE', TYPE, DIM, IDUM, CHTYPE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Find number of channels
      CALL OGET (CLEAN, 'BCHAN', TYPE, DIM, IDUM, CDUMMY, IERR)
      BCHAN = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (CLEAN, 'ECHAN', TYPE, DIM, IDUM, CDUMMY, IERR)
      ECHAN = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      BCHAN = MAX (1, BCHAN)
      ECHAN = MAX (BCHAN, ECHAN)
      CALL OGET ('Input', 'CHINC', TYPE, DIM, IDUM, CDUMMY, IERR)
      CHINC = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CHINC = MAX (1, CHINC)
      CALL OGET ('Input', 'CHANNEL', TYPE, DIM, IDUM, CDUMMY, IERR)
      CHANN = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CHANN = MAX (BCHAN, CHANN)
      CALL OGET ('Input', 'NCHAV', TYPE, DIM, IDUM, CDUMMY, IERR)
      NCHAV = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      NCHAV = MAX (1, NCHAV)
      NUMCH = (ECHAN - BCHAN + 1 - NCHAV) / CHINC + 1
      LECHAN = BCHAN + CHINC*NUMCH - 1
      CALL OGET ('Input', 'BIF', TYPE, DIM, IDUM, CDUMMY, IERR)
      BIF = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET ('Input', 'EIF', TYPE, DIM, IDUM, CDUMMY, IERR)
      EIF = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      NIF = MAX (1, EIF - BIF + 1)
      IF ((CHTYPE.NE.'LINE') .AND. (NCHAV.GT.CHINC)) CHINC = NCHAV
      IDUM(1) = CHANN
      CALL OPUT (UVDATA, 'CALEDIT.BCHAN', OOAINT, DIM, IDUM, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
      JCHAN = CHANN + (ECHAN - BCHAN)
      JCHAN = MIN (ECHAN, CHANN+NCHAV-1)
      IDUM(1) = JCHAN
      CALL OPUT (UVDATA, 'CALEDIT.ECHAN', OOAINT, DIM, IDUM, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C                                       baseline - averaging
      CALL OGET ('Input', 'IM2PARM', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, IM2PRM)
      IF (IM2PRM(12).GT.0.0) THEN
         BLIMIT(1) = IM2PRM(11)
         IF (BLIMIT(1).LE.1.0) BLIMIT(1) = 1.E9
         BLIMIT(1) = BLIMIT(1) / (24.0 * 3600.0)
         BLIMIT(2) = 268.5 / IM2PRM(12)
         BLIMIT(3) = IROUND (IM2PRM(13))
C                                       program to find
         IF (ABS(BLIMIT(3)-1.0).LT.0.1) THEN
            CALL FINDAV (UVDATA, NSUBA, SUBA, BLIMIT, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL OGET (UVDATA, 'CHINC', TYPE, DIM, IDUM, CDUMMY, IERR)
            CHINC = IDUM(1)
            IF (IERR.NE.0) GO TO 999
            END IF
         BLIMIT(3) = MAX (1.0, BLIMIT(3))
      ELSE
         BLIMIT(1) = 1000.0
         BLIMIT(2) = -1.0
         BLIMIT(3) = 1.0
         END IF
      DIM(1) = 1
      DIM(2) = 1
      BLIMIC = BLIMIT(3) + 0.1
      IDUM(1) = BLIMIC
      CALL OPUT (UVDATA, 'AVERAGEF', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      NCHAVG = NCHAV * NIF / BLIMIC
C                                       Force create of UVWORK
      CALL OGET (CLEAN, 'ALLOKAY', TYPE, DIM, IDUM, CDUMMY, IERR)
      ALLOK = IDUM(1)
      IF (IERR.NE.0) GO TO 999
C                                       does UV work file exist
      IF (UVWSEQ.GT.0) THEN
         CALL OBFEXS (UVWORK, EXIST, IERR)
C                                       seq 0 always new
      ELSE
         EXIST = .FALSE.
         END IF
C                                       it is expected to
      IF (ALLOK.GE.2) THEN
         IF (IERR.NE.0) GO TO 990
         IF (.NOT.EXIST) ALLOK = 1
C                                       we do not care
      ELSE IF (EXIST) THEN
         IF (UVWDSK.LE.0) THEN
            CALL FNDSKC (UVWORK, UVWDSK, UVWCNO, IERR)
            IF (IERR.NE.0) GO TO 999
            DIM(1) = 1
            DIM(2) = 1
            IDUM(1) = UVWDSK
            CALL OPUT (UVWORK, 'DISK', OOAINT, DIM, IDUM, CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 999
         ELSE IF (UVWCNO.LE.0) THEN
            CALL FNDSKC (UVWORK, UVWDSK, UVWCNO, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
C                                       find out more
         CALL CATIO ('READ', UVWDSK, UVWCNO, TCAT, 'REST', SCRTCH, IERR)
         IF ((IERR.GT.0) .AND. (IERR.LT.4)) GO TO 999
         CALL FNAGET (UVWORK, 'NAMCLSTY', TYPE, DIM, IDUM, NAMCTY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         WASBAD = (NAMCTY(19:20).NE.'UV')
         WASBAD = WASBAD .OR. (TCAT(KINAX).NE.3) .OR.
     *      (TCAT(KINAX+1).NE.1)
         CALL H2CHR (8, 1, TCATH(KHCTP), NAMCTY)
         WASBAD = WASBAD .OR. (NAMCTY(:8).NE.'COMPLEX')
         CALL H2CHR (8, 1, TCATH(KHCTP+2), NAMCTY)
         WASBAD = WASBAD .OR. (NAMCTY(:8).NE.'STOKES')
         CALL H2CHR (8, 1, TCATH(KHCTP+4), NAMCTY)
         WASBAD = WASBAD .OR. (NAMCTY(:8).NE.'FREQ')
         IF (WASBAD) THEN
            IERR = 10
            MSGTXT = 'IN2NAME ET AL DO NOT SPECIFY VALID WORK FILE'
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       okay to delete
         MSGTXT = 'Deleting old work file'
         CALL MSGWRT (2)
         CALL OUVZAP (UVWORK, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
      IF (ALLOK.GE.1) THEN
         CALL OBFEXS (CLEANO(1), EXIST, IERR)
         IF (IERR.NE.0) GO TO 990
         IF (.NOT.EXIST) ALLOK = 0
         END IF
      IF (ALLOK.LT.2) THEN
         CALL OCLONE (UVDATA, UVWORK, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       UVWORK, beams already done
      CALL OGET (CLEAN, 'CCFILTER', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, CCFILT)
      IF (CCFILT(1).EQ.0.0) THEN
         INDATA = ' '
      ELSE
         INDATA = 'Input non-residual UV data'
         END IF
      DOWARN = .TRUE.
C                                       averaging is done in UVWORK
      MMM = 1
      DIM(1) = 1
      DIM(2) = 1
      IDUM(1) = MMM
      CALL OPUT (UVWORK, 'AVERAGEF', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CHINCG = MAX (1, CHINC / BLIMIC)
      IDUM(1) = CHINCG
      CALL OPUT (UVWORK, 'CHINC', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       How many fields?
      CALL OGET (CLEAN, 'NIMAGES', TYPE, DIM, IDUM, CDUMMY, IERR)
      NFIELD = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OGET (CLEAN, 'BCOMP', TYPE, DIM, BCOMP, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Loop over channel
      IF (CHANN+CHINC.GT.LECHAN) REWIN = .FALSE.
      DO 600 ICHAN = CHANN,LECHAN,CHINC
         DOMAX = ICHAN+CHINC.GT.LECHAN
C                                       reset Clean windows?
         IF (REWIN) THEN
            DIM(1) = NFIELD
            DIM(2) = 1
            CALL OPUT (CLEAN, 'NBOXES', OOAINT, DIM, NBOXES, CDUMMY,
     *         IERR)
            IF (IERR.NE.0) GO TO 999
            DIM(1) = 4 * NFIELD
            DIM(2) = WINW / DIM(1)
            CALL OPUT (CLEAN, 'WINDOW', OOAINT, DIM, WIN(1+WINP),
     *         CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
C                                       Copy uv data to work object, set
C                                       channel.
         DIM(1) = 1
         DIM(2) = 1
         DIM(3) = 0
         IDUM(1) = ICHAN
         CALL OPUT (UVDATA, 'CALEDIT.BCHAN', OOAINT, DIM, IDUM, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 990
         JCHAN = ICHAN + NCHAV - 1
         IDUM(1) = JCHAN
         CALL OPUT (UVDATA, 'CALEDIT.ECHAN', OOAINT, DIM, IDUM, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Move weights
         II = 0
         DO 20 I = BIF,EIF
            DO 10 J = ICHAN,JCHAN
               JJ = J + (I-BIF) * NWEGHT
               II = II + 1
               WTMUL(II) = WEGHTS(JJ)
 10            CONTINUE
 20         CONTINUE
C                                       Progress message
         WRITE (MSGTXT,1000) ICHAN, JCHAN, NIF
         CALL MSGWRT (4)
C                                       Select/correct
         LDUMMY = ALLOK.GE.2
         CALL IMACPY (UVDATA, UVWORK, CLEANO, NFIELD, SPINDX, FSCAL,
     *      BLIMIT, DOWARN, NSUBA, SUBA, WTMUL, AVGTIM, AVFREQ, LDUMMY,
     *      IERR)
         IF (IERR.EQ.-1) THEN
            WASBAD = DOMAX
            JCHAN = (ICHAN - CHANN) / CHINC + 1
            CALL IMABLK (JCHAN, NFIELD, CLEANO, IERR)
            IERR = 0
            GO TO 600
            END IF
         IF (IERR.NE.0) GO TO 990
         CALL CHKINP (IERR)
         IF ((AVFREQ.GT.0.0D0) .AND. (CHTYPE.NE.'LINE')) THEN
            DIM(1) = 1
            DDUM(1) = AVFREQ
            DO 21 I = 1,NFIELD
               CALL OPUT (CLEANO(I), 'AVERFREQ', OOADP, DIM, IDUM,
     *            CDUMMY, IERR)
               IF (IERR.NE.0) GO TO 990
 21            CONTINUE
            END IF
         NGOOD = NGOOD + 1
         DOWARN = .FALSE.
         DIM(1) = 1
         DIM(2) = 1
         IDUM(1) = NCHAVG
         CALL OPUT (CLEANO(1), 'NCHAV', OOAINT, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
         IF ((ALLOK.GE.2) .AND. (.NOT.LDUMMY)) ALLOK = 0
         IDUM(1) = ALLOK
         CALL OPUT (CLEAN, 'ALLOKAY', OOAINT, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Unsubtracted copy
         IF ((ALLOK.LE.1) .AND. (INDATA.NE.' ')) INDATA = '-'
         DIM(1) = LEN (INDATA)
         DIM(2) = 1
         CALL OPUT (CLEAN, 'INDATA', OOACAR, DIM, IDUM, INDATA, IERR)
         IF (IERR.NE.0) GO TO 999
         IF ((INDATA.NE.' ') .AND. (INDATA.NE.'-')) THEN
            CALL CREATE (INDATA, 'UVDATA', IERR)
            IF (IERR.NE.0) GO TO 990
            IF (ALLOK.GE.2) THEN
               MSGTXT = 'Copy of initial data for filtering:'
               CALL MSGWRT (2)
               LDUMMY = .FALSE.
               NVIS = 0
               CALL OUVSCR (INDATA, UVDATA, NVIS, LDUMMY, IERR)
               IF (IERR.NE.0) GO TO 990
               IF (AVGTIM(1).EQ.0.0) AVGTIM(1) = -999.
               LDUMMY = .FALSE.
               CALL IMACPY (UVDATA, INDATA, CLEANO, NFIELD, SPINDX,
     *            FSCAL, BLIMIT, DOWARN, NSUBA, SUBA, WTMUL, AVGTIM,
     *            AVFREQ, LDUMMY, IERR)
               IF (IERR.NE.0) GO TO 990
C                                       Copy of work file
            ELSE
               CALL UVRSCR (UVWORK, INDATA, .FALSE., IERR)
               IF (IERR.NE.0) GO TO 990
               END IF
            END IF
C                                       Special options
C                                       Primary beam corrections
C                                       Freq array
         CALL UVFRQS (UVDATA, UVFREQ, PBFREQ, IERR)
         IF (IERR.NE.0) GO TO 990
         DIM(1) = 1
         DIM(2) = 1
         LDUM(1) = DOPBFM
         CALL OPUT (UVWORK, 'DOPBFM', OOALOG, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
         RDUM(1) = PBFSIZ
         CALL OPUT (UVWORK, 'PBFSIZ', OOARE, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
         DIM(1) = NCHAVG
         CALL DPCOPY (NCHAVG, PBFREQ, DDUM)
         CALL OPUT (UVWORK, 'PBFREQ', OOADP, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       DFT or FFT
         FTTYPE = 'FFT'
         DIM(1) = LEN (FTTYPE)
         CALL OPUT (CLEANO(1), 'FTTYPE', OOACAR, DIM, IDUM, FTTYPE,
     *      IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Uniform weighting
C                                       Set channel in CLEAN
         DIM(1) = 1
         LCHAN = (ICHAN - BCHAN) / CHINC + 1
         IDUM(1) = LCHAN
         CALL OPUT (CLEAN, 'CHANNEL', OOAINT, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
         IDUM(1) = 1
         CALL OPUT (CLEAN, 'UVCHAN', OOAINT, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
         IDUM(1) = NCHAVG
         CALL OPUT (CLEAN, 'NCHAV', OOAINT, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Set CC version, (line only)
         IF (CHTYPE.EQ.'LINE') THEN
            IDUM(1) = LCHAN
            CALL OPUT (CLEAN, 'VERSION', OOAINT, DIM, IDUM, CDUMMY,
     *         IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
         DIM(1) = MAXFLD
         CALL OPUT (CLEAN, 'BCOMP', OOAINT, DIM, BCOMP, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Uniform weight/beam mod
         IF (ALLOK.LT.2) THEN
            CALL OUNFWT (APCORE, UVWORK, CLEANO(1), IERR)
         ELSE IF ((INDATA.NE.' ') .AND. (INDATA.NE.'-')) THEN
            MSGTXT = 'Weight initial data for filtering:'
            CALL MSGWRT (2)
            CALL OUNFWT (APCORE, INDATA, CLEANO(1), IERR)
            END IF
         IF (IERR.NE.0) GO TO 990
C                                       Open CLEAN
         IF (ICHAN.EQ.BCHAN) THEN
            CALL OOPEN (CLEAN, 'DEST', IERR)
         ELSE
            CALL OOPEN (CLEAN, 'WRIT', IERR)
            END IF
         IF (IERR.NE.0) GO TO 990
C                                       Clean
         CALL CLNUV (APCORE, CLEAN, DOMAX, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       next not ok for sure
         ALLOK = 0
         DIM(1) = 1
         DIM(2) = 1
         IDUM(1) = ALLOK
         CALL OPUT (CLEAN, 'ALLOKAY', OOAINT, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Close CLEAN
         CALL OCLOSE (CLEAN, IERR)
         IF (IERR.NE.0) GO TO 990
 600     CONTINUE
C                                       Any good?
      IF (NGOOD.LE.0) THEN
         MSGTXT = 'NO DATA FOUND'
         IERR = 7
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       ow many fields?
      CALL OGET (CLEAN, 'NIMAGES', TYPE, DIM, IDUM, CDUMMY, IERR)
      NFIELD = IDUM(1)
      IF (IERR.NE.0) GO TO 990
C                                       max/min if last bad
      IF (WASBAD) CALL IMAMXN (NFIELD, CLEANO, IERR)
C                                       Observing geometry
C                                       Get average time
      IF (AVGTIM(1).LT.0.0) THEN
         MSGTXT = 'Finding the parallactic and zenith angles'
         CALL MSGWRT (2)
         CALL IMTAV (UVDATA, AVGTIM, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       Get parallactic, zenith angles
      IF ((AVGTIM(1).GT.0.0) .AND. (AVGTIM(2).LT.0.01)) THEN
         CALL IMPARG (UVDATA, AVGTIM(1), PANGL, ZANGL, JERR)
         IF (JERR.NE.0) GO TO 990
C                                       Save observing geometry on CLEAN
C                                       images
         DO 700 I = 1,NFIELD
            DIM(1) = 1
            DIM(2) = 1
            RDUM(1) = PANGL
            CALL OPUT (CLEANO(I), 'PARANGLE', OOARE, DIM, IDUM, CDUMMY,
     *         JERR)
            IF (JERR.NE.0) GO TO 990
            RDUM(1) = ZANGL
            CALL OPUT (CLEANO(I), 'ZENANGLE', OOARE, DIM, IDUM, CDUMMY,
     *         JERR)
            IF (JERR.NE.0) GO TO 990
 700        CONTINUE
         END IF
C                                       dispose of UVWORK
 990  IF (KEEP) THEN
         CALL OUVDES (UVWORK, JERR)
      ELSE
         MSGTXT = 'Deleting UV work file:'
         CALL MSGWRT (3)
         CALL OUVZAP (UVWORK, JERR)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Beginning channel',I5,' through',I5,' with',I3,' IFs')
      END
      SUBROUTINE CHKINP (IRET)
C-----------------------------------------------------------------------
C   CHLINP puts the calibration adverbs back in Inputs for history
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      CHARACTER CDUMMY*1
      INTEGER   DIM(7)
C-----------------------------------------------------------------------
      DIM(1) = 1
      DIM(2) = 1
      CALL FILL (5, 0, DIM(3))
      IDUM(1) = PDVER
      CALL OPUT ('Input', 'PDVER', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = BPVER
      CALL OPUT ('Input', 'BLVER', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = BPVER
      CALL OPUT ('Input', 'BPVER', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = FGVER
      CALL OPUT ('Input', 'FLAGVER', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
      IDUM(1) = CLUSE
      CALL OPUT ('Input', 'GAINUSE', OOAINT, DIM, IDUM, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE IMACPY (UVIN, UVOUT, CLEANO, NFIELD, SPINDX, FSCAL,
     *   BLIMIT, DOWARN, NSUBA, SUBA, WTMUL, AVGTIM, AVFREQ, ALLOK,
     *   IERR)
C-----------------------------------------------------------------------
C   Copies one uv data object to another with application of any
C   calibration editing, and selection criteria.
C   Data are scaled in frequency to remove a  spectral index of SPINDX
C   and corrected to the reference frequency.  Also, u, v and w are
C   scaled by FSCAL.
C   Inputs:
C      UVIN    C*?  Name of input uvdata object.  All specified
C                   selection, editing and calibration are applied.
C      UVOUT   C*?  Name of output uvdata object.  May be UVIN.
C      CLEANO  C*?  Name of Clean object - get #fields, do3d, shifts
C      NFIELD  I    Number of fields
C      DOWARN  L    Do warning messages about data selection?
C      WTMUL   R(*) Weight multipliers
C   Inputs attached to UVIN
C      UMAX    R    Maximum acceptable U in wavelengths (default all)
C      VMAX    R    Maximum acceptable V in wavelengths (default all)
C   In/out:
C      AVGTIM  R(2) Average time: computed if input(1) < 0, (2) rms
C      ALLOK   L    Output already written (in: user, out: checked)
C   Output:
C      IERR    I    Error code: 0 => ok, -1 => no data this channel
C-----------------------------------------------------------------------
      CHARACTER UVIN*(*), UVOUT*(*), CLEANO(*)*(*)
      REAL      SPINDX, BLIMIT(3), FSCAL, WTMUL(*), AVGTIM(2)
      INTEGER   NFIELD, NSUBA, SUBA(*), IERR
      LOGICAL   DOWARN, ALLOK
      DOUBLE PRECISION AVFREQ
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   COUNT, TYPE, DIM(7), NCOR, NAXIS(7), NSTOKS, I, J,
     *   K, INDEX, JLOCS, INDXU, INDXV, INDXW, MSGSAV, TCOUNT, JLOCD,
     *   LST, LERR, TACNT, JLOCT, NANT, NBAS, IANT(50), IBAS(50), INDXB,
     *   IA1, IA2, NRPARM, NDATA, NWORDS, MAXAN, ACOUNT, LSUB, MAXA,
     *   BLIMIC, INDXA1, INDXA2, INDXSA, IBAVG(2)
      CHARACTER SORD*2, CDUMMY*1, CNAME*8, KEYW*8, STOKES*4, TABLE*32,
     *   UVTYPE*2, ANTAB*32
      REAL      RP(50), VS(3,MAXCIF), FS(MAXCIF), FST, UMAX, VMAX,
     *   AUMAX, BUMAX, AVMAX, BVMAX, GUARDB(2), UTFACT(2), UU, VV,
     *   CELLS(2), ROTATE, CROTAU(7), CROT, SROT, ZEROSP(5),
     *   RASH(MAXFLD), DECSH(MAXFLD), XANT(50), XBASE(50), BAVG(2),
     *   CRPIX(7), CDELT(7), CLIMIT(2)
      DOUBLE PRECISION UVFREQ, DSUM, AVGFRQ, FRMULT, GSTIA0, DEGPDY,
     *   SUMR, SUMI, TIME, GST0, ROTRAT, SUMII, SUMRR, SUMC, SUMN, SUMT
      LOGICAL   EXIST, DOSCLU, DOROT, DOAVG, IS3D, DESEL, REQBAS, FIRST
      LONGINT   PBAVG
      EQUIVALENCE (BAVG, IBAVG)
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      LSUB = SUBA(1)
      DOAVG = AVGTIM(1).LT.0.0
      BLIMIC = BLIMIT(3) + 0.1
      CLIMIT(1) = BLIMIT(1)
      CLIMIT(2) = BLIMIT(2)
C                                       Get time information from AN
C                                       table.
      IF (DOAVG) THEN
         TABLE = 'Temporary AN table for IMACPY'
         CALL UV2TAB (UVIN, TABLE, 'AN', 1, IERR)
         IF (IERR.EQ.0) CALL TABOPN (TABLE, 'READ', IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'FAILS to get AN table data for parallactic' //
     *         ' and zenith angles'
            CALL MSGWRT (6)
            AVGTIM(1) = 0.
            AVGTIM(2) = 999.
            DOAVG = .FALSE.
            CALL TABDES (TABLE, IERR)
         ELSE
            CALL TABGET (TABLE, 'KEY.GSTIA0', TYPE, DIM, IDUM, CDUMMY,
     *         IERR)
            GSTIA0 = DDUM(1)
            IF (IERR.NE.0) GO TO 995
            CALL TABGET (TABLE, 'KEY.DEGPDY', TYPE, DIM, IDUM, CDUMMY,
     *         IERR)
            DEGPDY = DDUM(1)
            IF (IERR.NE.0) GO TO 995
            CALL TABCLO (TABLE, IERR)
            IF (IERR.NE.0) GO TO 995
C                                       Delete object
            CALL TABDES (TABLE, IERR)
            IF (IERR.NE.0) GO TO 995
C                                       Convert units to radians
            GST0 = GSTIA0 * DG2RAD
            ROTRAT = DEGPDY * DG2RAD
            END IF
         END IF
C                                       open core memory
      CALL APOBJ ('OPEN', 'IMACPY', IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Check data type
      CALL UVDGET (UVIN, 'TYPEUVD', TYPE, DIM, IDUM, UVTYPE, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (UVTYPE(:1).NE.'U') THEN
         MSGTXT = 'I DO NOT WORK FOR UV DATA OF TYPE ''' // UVTYPE //
     *      ''''
         IERR = 8
         GO TO 980
         END IF
C                                       Open input.
C      CALL OUVOPN (UVIN, 'READ', IERR)
C      IF (IERR.NE.0) GO TO 990
C                                       Create output if necessary
      CALL OBFEXS (UVOUT, EXIST, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (.NOT.EXIST) THEN
         ALLOK = .FALSE.
         CALL OUVCLN (UVIN, UVOUT, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       U,V limits
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL OUVGET (UVIN, 'UMAX', TYPE, DIM, IDUM, CDUMMY, IERR)
      UMAX = RDUM(1)
      MSGSUP = MSGSAV
C                                       Default = all
      IF (IERR.EQ.1) THEN
         UMAX = 1.0E30
         IERR = 0
         END IF
      IF (IERR.NE.0) GO TO 980
      MSGSUP = 32000
      CALL OUVGET (UVIN, 'VMAX', TYPE, DIM, IDUM, CDUMMY, IERR)
      VMAX = RDUM(1)
      MSGSUP = MSGSAV
C                                       Default = all
      IF (IERR.EQ.1) THEN
         VMAX = 1.0E30
         IERR = 0
         END IF
      IF (IERR.NE.0) GO TO 980
C                                       Stokes
      MSGSUP = 32000
      CALL OUVGET (UVIN, 'STOKES', TYPE, DIM, IDUM, STOKES, IERR)
C                                       Default = none
      IF (IERR.EQ.1) THEN
         STOKES = 'I'
         IERR = 0
         END IF
      IF (IERR.NE.0) GO TO 980
      LST = 1
      IF (STOKES(1:1).EQ.'Q') LST = 2
      IF (STOKES(1:1).EQ.'U') LST = 3
      IF (STOKES(1:1).EQ.'V') LST = 4
C                                       Zero spacing flux
      MSGSUP = 32000
      CALL OUVGET (UVIN, 'ZEROSP', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.EQ.0) CALL RCOPY (DIM(1), RDUM, ZEROSP)
      MSGSUP = MSGSAV
C                                       Default = none
      IF (IERR.EQ.1) THEN
         CALL RFILL (5, 0.0, ZEROSP)
         IERR = 0
         END IF
      IF (IERR.NE.0) GO TO 980
C                                       Actual guardband
      MSGSUP = 32000
      CALL OUVGET (UVIN, 'GUARDBND', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.EQ.0) CALL RCOPY (DIM(1), RDUM, GUARDB)
      MSGSUP = MSGSAV
      IF (IERR.EQ.1) THEN
         GUARDB(1) = 0.0
         GUARDB(2) = 0.0
         IERR = 0
         END IF
      IF (IERR.NE.0) GO TO 980
C                                       Default guardband
      MSGSUP = 32000
      CALL OUVGET (UVIN, 'GUARDEF', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.EQ.0) CALL RCOPY (DIM(1), RDUM, UTFACT)
      MSGSUP = MSGSAV
      IF (IERR.EQ.1) THEN
         UTFACT(1) = 0.0
         UTFACT(2) = 0.0
         IERR = 0
         END IF
      IF (IERR.NE.0) GO TO 980
C                                       Intended cellsize
      MSGSUP = 32000
      CALL OUVGET (UVIN, 'CELLSIZE', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.EQ.0) CALL RCOPY (DIM(1), RDUM, CELLS)
      MSGSUP = MSGSAV
      IF (IERR.EQ.1) THEN
         CELLS(1) = 1.0
         CELLS(2) = 1.0
         IERR = 0
         END IF
      IF (IERR.NE.0) GO TO 980
C                                       Additional rotation
      MSGSUP = 32000
      CALL OUVGET (UVIN, 'ROTATE', TYPE, DIM, IDUM, CDUMMY, IERR)
      ROTATE = RDUM(1)
      MSGSUP = MSGSAV
      IF (IERR.EQ.1) THEN
         ROTATE = 0.0
         IERR = 0
         END IF
      IF (IERR.NE.0) GO TO 980
      DOROT = ROTATE.NE.0.0
C                                       3D Images?
      CALL OGET (CLEANO, 'DO3DIMAG', TYPE, DIM, IDUM, CDUMMY, IERR)
      IS3D = LDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OGET (CLEANO, 'RASHIFT', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL RCOPY (DIM(1), RDUM, RASH)
      CALL OGET (CLEANO, 'DECSHIFT', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL RCOPY (DIM(1), RDUM, DECSH)
      CALL IMC3DI (IS3D, ROTATE, NFIELD, RASH, DECSH, UMATS)
C                                       NCORR
      CALL UVDGET (UVIN, 'NCORR', TYPE, DIM, IDUM, CDUMMY, IERR)
      NCOR = IDUM(1)
      IF (IERR.NE.0) GO TO 990
C                                       CROTA
      IF (DOROT) THEN
         CALL UVDGET (UVIN, 'CROTA', TYPE, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL RCOPY (DIM(1), RDUM, CROTAU)
         CALL UVDFND (UVIN, 2, 'DEC', JLOCD, IERR)
         IF (IERR.NE.0) GO TO 990
         CROTAU(JLOCD) = CROTAU(JLOCD) + ROTATE
         ROTATE = -ROTATE / 57.29578
         CROT = COS (ROTATE)
         SROT = SIN (ROTATE)
         END IF
C                                       Frequency info
      DOSCLU = FSCAL.GT.0.0
C                                       Uv data pointers
C                                       Which random parameter
      IF (DOAVG) THEN
         CALL UVDFND (UVIN, 1, 'TIME', JLOCT, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'IMACPY:TROUBLE FINDING RANDOM PARAMETER TIME'
            CALL MSGWRT (7)
            GO TO 990
            END IF
         SUMR = 0.0D0
         SUMI = 0.0D0
         SUMRR = 0.0D0
         SUMII = 0.0D0
         TACNT = 0
         END IF
      SUMC = 0.0D0
      SUMN = 0.0D0
      SUMT = 0.0D0
      CALL UVDFND (UVIN, 2, 'STOKES', JLOCS, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL UVDFND (UVIN, 1, 'BASELINE', INDXB, IERR)
      IF (IERR.NE.0) THEN
         INDXB = -1
         CALL UVDFND (UVIN, 1, 'ANTENNA1', INDXA1, IERR)
         IF (IERR.EQ.0) CALL UVDFND (UVIN, 1, 'ANTENNA2', INDXA2, IERR)
         IF (IERR.EQ.0) CALL UVDFND (UVIN, 1, 'SUBARRAY', INDXSA, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'TROUBLE FINDING RANDOM PARAMETER BASELINE'
            GO TO 980
            END IF
         END IF
      CALL UVDGET (UVIN, 'NRPARM', TYPE, DIM, IDUM, CDUMMY, IERR)
      NRPARM = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      NDATA = NRPARM + 3 * (NCOR / BLIMIC)
      CALL UVDFND (UVIN, 1, 'UU-L', INDXU, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE FINDING RANDOM PARAMETER UU-L'
         GO TO 980
         END IF
      CALL UVDFND (UVIN, 1, 'VV-L', INDXV, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE FINDING RANDOM PARAMETER VV-L'
         GO TO 980
         END IF
      CALL UVDFND (UVIN, 1, 'WW-L', INDXW, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE FINDING RANDOM PARAMETER WW-L'
         GO TO 980
         END IF
C                                       UV axis descriptor
C                                       NAXIS
      CALL UVDGET (UVIN, 'NAXIS', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL COPY (DIM(1), IDUM, NAXIS)
C                                       Number of polarizations
      NSTOKS = NAXIS(JLOCS)
C                                       antenna/baseline selection
      CALL OGET (UVIN, 'ANTENNAS', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.EQ.0) CALL RCOPY (DIM(1), RDUM, XANT)
      IF (IERR.NE.0) THEN
         CALL RFILL (50, 0.0, XANT)
         IERR = 0
         END IF
      CALL OGET (UVIN, 'BASELINE', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.EQ.0) CALL RCOPY (DIM(1), RDUM, XBASE)
      IF (IERR.NE.0) THEN
         CALL RFILL (50, 0.0, XBASE)
         IERR = 0
         END IF
C                                       Initialize baseline selection.
      CALL SETANT (50, XANT, XBASE, NANT, NBAS, IANT, IBAS, DESEL)
C                                       Freq array - no average
      UVFREQ = -1000.0D0
      CALL UVFRQS (UVIN, UVFREQ, FREQG, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Average frequency
      COUNT = 0
      DSUM = 0.0D0
      K = 0
      FRMULT = 0.0D0
      DO 30 I = 1,NCOR,NSTOKS
         K = K + 1
         DSUM = DSUM + FREQG(K)
         FRMULT = MAX (FRMULT, FREQG(K))
         COUNT = COUNT + 1
 30      CONTINUE
      FRMULT = FRMULT / UVFREQ
      AVGFRQ = DSUM / COUNT
C                                       Frequency scaling: Stokes is
C                                       always before IF and Freq.
      INDEX = 0
      K = 0
      DO 50 I = 1,NCOR,NSTOKS
         K = K + 1
         FST = (AVGFRQ / FREQG(K)) ** SPINDX
         DO 40 J = 1,NSTOKS
            INDEX = INDEX + 1
            FS(INDEX) = FST
 40         CONTINUE
 50      CONTINUE
C                                       Declare 'MAXBLINE' a header
C                                       keyword for the UVDATA class.
      CNAME = 'UVDATA'
      KEYW = 'MAXBLINE'
      CALL OBVHKW (CNAME, KEYW, OOARE, IERR)
      IF (IERR.NE.0) GO TO 990
      KEYW = 'MAXABSU '
      CALL OBVHKW (CNAME, KEYW, OOARE, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Initialize visibility count
      COUNT = 0
      TCOUNT = 0
      ACOUNT = 0
      AUMAX = 0.0
      AVMAX = 0.0
      BVMAX = 0.0
      UMAX = UMAX / FRMULT
      VMAX = VMAX / FRMULT
C                                       need MAXAN, memory for averaging
      IF ((CLIMIT(2).GT.0.0) .AND. (.NOT.ALLOK)) THEN
C                                       scale for freq, square
         CLIMIT(2) = (CLIMIT(2) / FRMULT) ** 2
         MAXAN = 0
         DO 60 LSUB = 1,NSUBA
            ANTAB = 'AN table for UVTAVG'
            CALL UV2TAB (UVIN, ANTAB, 'AN', SUBA(LSUB), IERR)
            IF (IERR.NE.0) GO TO 990
C                                       How many antennas?
            CALL ANTNO (ANTAB, SUBA(LSUB), MAXA, IERR)
            IF (IERR.NE.0) GO TO 990
            MAXAN = MAX (MAXAN, MAXA)
            CALL OUVDES (ANTAB, IERR)
            IF (IERR.NE.0) GO TO 990
 60         CONTINUE
         NWORDS = (((MAXAN * (MAXAN-1)) / 2) * NDATA - 1) / 1024 + 2
         CALL ZMEMRY ('GET ', 'IMACPY', NWORDS, IBAVG, PBAVG, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'FAILED TO GET MEMORY FOR BASELINE-BASED AVERAGE'
            CALL MSGWRT (7)
            GO TO 990
            END IF
         CALL IMBAVG ('INIT', NRPARM, NDATA, MAXAN, UVOUT, IA1, IA2,
     *      RP, VS, BLIMIC, CLIMIT, BAVG(1+PBAVG), COUNT, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       Check output in ALLOK
      IF ((ALLOK) .OR. (SUBA(1).GT.1)) THEN
         MSGSUP = 32000
         CALL OUVOPN (UVOUT, 'READ', IERR)
         MSGSUP = MSGSAV
         IF (IERR.EQ.0) THEN
            CALL UVDGET (UVOUT, 'GCOUNT', TYPE, DIM, IDUM, CDUMMY, IERR)
            COUNT = IDUM(1)
            IF (IERR.NE.0) GO TO 990
            IF (COUNT.LE.0) ALLOK = .FALSE.
C                                       Get current max u
            MSGSUP = 32000
            CALL OUVGET (UVOUT, 'MAXBLINE', TYPE, DIM, IDUM, CDUMMY,
     *         IERR)
            BUMAX = RDUM(1)
            MSGSUP = MSGSAV
            IF (IERR.EQ.1) THEN
               BUMAX = 0.0
               IERR = 0
               END IF
            IF (IERR.NE.0) GO TO 990
         ELSE
            ALLOK = .FALSE.
            END IF
         MSGSUP = 32000
         CALL OUVCLO (UVOUT, IERR)
         MSGSUP = MSGSAV
         END IF
      IF ((.NOT.ALLOK) .AND. (SUBA(1).LE.1)) BUMAX = 0.0
      DOAVG = DOAVG .AND. (.NOT.ALLOK)
      IF ((AVGTIM(1).LT.0.0) .AND. (.NOT.DOAVG)) THEN
         AVGTIM(1) = 0.0
         AVGTIM(2) = 0.0
         END IF
C                                       loop over subarrays
      IF (.NOT.ALLOK) THEN
         FIRST = .TRUE.
C                                       ??????????????
         DO 200 LSUB = 1,NSUBA
C
            DIM(1) = 1
            DIM(2) = 1
            IDUM(1) = SUBA(LSUB)
            CALL SECPUT (UVIN, 'SUBARR', OOAINT, DIM, IDUM, CDUMMY,
     *         IERR)
            IF (IERR.NE.0) GO TO 990
C                                       Open input.
            CALL OUVOPN (UVIN, 'READ', IERR)
            IF (IERR.NE.0) GO TO 990
C                                       Open output
            IF (FIRST) THEN
               CALL OUVOPN (UVOUT, 'WRIT', IERR)
               IF (IERR.NE.0) GO TO 990
               IF (BLIMIC.GT.1) THEN
                  CALL UVDGET (UVOUT, 'CRPIX', TYPE, DIM, IDUM, CDUMMY,
     *               IERR)
                  IF (IERR.NE.0) GO TO 990
                  CALL RCOPY (DIM(1), RDUM, CRPIX)
                  CALL UVDGET (UVOUT, 'CDELT', TYPE, DIM, IDUM, CDUMMY,
     *               IERR)
                  IF (IERR.NE.0) GO TO 990
                  CALL RCOPY (DIM(1), RDUM, CDELT)
                  END IF
C                                       Copy UVDESC
               CALL UVDSCP (UVIN, UVOUT, IERR)
               IF (IERR.NE.0) GO TO 990
               IF (BLIMIC.GT.1) THEN
                  CALL RCOPY (DIM(1), CRPIX, RDUM)
                  CALL UVDPUT (UVOUT, 'CRPIX', TYPE, DIM, IDUM, CDUMMY,
     *               IERR)
                  IF (IERR.NE.0) GO TO 990
                  CALL RCOPY (DIM(1), CDELT, RDUM)
                  CALL UVDPUT (UVOUT, 'CDELT', TYPE, DIM, IDUM, CDUMMY,
     *               IERR)
                  IF (IERR.NE.0) GO TO 990
                  END IF
               FIRST = .FALSE.
               END IF
C                                       Loop thru data
 100        CALL UVREAD (UVIN, RP, VS, IERR)
            IF (IERR.GT.0) GO TO 990
            IF (IERR.EQ.0) THEN
C                                       Want this one?
               IF (INDXB.GT.0) THEN
                  IA2 = RP(INDXB) + 0.001
                  IA1 = IA2 / 256
                  IA2 = MOD (IA2, 256)
               ELSE
                  IA1 = RP(INDXA1) + 0.1
                  IA2 = RP(INDXA2) + 0.1
                  END IF
               IF (.NOT.REQBAS (IA1, IA2, DESEL, IANT, NANT, IBAS,
     *            NBAS)) GO TO 100
C                                       adjust u,v,w
               IF (DOROT) THEN
                  UU = RP(INDXU)
                  VV = RP(INDXV)
                  RP(INDXU) = CROT * UU - SROT * VV
                  RP(INDXV) = CROT * VV + SROT * UU
                  END IF
               CALL IMC3DM (RP(INDXU), NFIELD, UMATS, UU, VV)
               AUMAX = MAX (UU, AUMAX)
               AVMAX = MAX (VV, AVMAX)
               TCOUNT = TCOUNT + 1
               IF ((UU.LE.UMAX) .AND. (VV.LE.VMAX)) THEN
                  BUMAX = MAX (UU, BUMAX)
                  BVMAX = MAX (VV, BVMAX)
C                                       Scale u, v, w
                  IF (DOSCLU) THEN
                     RP(INDXU) = RP(INDXU) * FSCAL
                     RP(INDXV) = RP(INDXV) * FSCAL
                     RP(INDXW) = RP(INDXW) * FSCAL
                     END IF
C                                       Scale vis
                  SUMT = SUMT + 1.0D0
                  DO 110 I = 1,NCOR
                     IF (VS(3,I).GT.0.0) THEN
                        VS(1,I) = VS(1,I) * FS(I)
                        VS(2,I) = VS(2,I) * FS(I)
                        VS(3,I) = VS(3,I) * WTMUL(I)
                        K = (I-1)/NSTOKS + 1
                        SUMC = SUMC + FREQG(K)
                        SUMN = SUMN + 1.0D0
                        END IF
 110                 CONTINUE
                  COUNT = COUNT + 1
                  IF (CLIMIT(2).LE.0.0) THEN
                     CALL UVWRIT (UVOUT, RP, VS, IERR)
                  ELSE
                     CALL IMBAVG ('ADD', NRPARM, NDATA, MAXAN, UVOUT,
     *                  IA1, IA2, RP, VS, BLIMIC, CLIMIT, BAVG(1+PBAVG),
     *                  ACOUNT, IERR)
                     END IF
                  IF (IERR.GT.0) GO TO 990
C                                       average the time
                  IF (DOAVG) THEN
C                                       Convert time to GST(radians)
                     TIME = RP(JLOCT) * ROTRAT + GST0
C                                       Sum as sine and cosine
                     TACNT = TACNT + 1
                     SUMR = SUMR + COS (TIME)
                     SUMI = SUMI + SIN (TIME)
                     SUMRR = SUMRR + (COS (TIME)) ** 2
                     SUMII = SUMII + (SIN (TIME)) ** 2
                     END IF
                  END IF
               GO TO 100
               END IF
            IERR = 0
            IF (LSUB.LT.NSUBA) CALL OUVCLO (UVIN, IERR)
 200        CONTINUE
C                                       finish/free averaging memory
         IF (CLIMIT(2).GT.0.0) THEN
            CALL IMBAVG ('CLOS', NRPARM, NDATA, MAXAN, UVOUT, IA1, IA2,
     *         RP, VS, BLIMIC, CLIMIT, BAVG(1+PBAVG), ACOUNT, IERR)
            IF (IERR.NE.0) GO TO 990
            CALL ZMEMRY ('FREE', 'IMACPY', NWORDS, IBAVG, PBAVG, IERR)
            END IF
C                                       Better be some data
         IF (COUNT.LE.0) THEN
            CALL OUVCLO (UVIN, IERR)
            CALL OUVCLO (UVOUT, IERR)
            IERR = -1
            MSGTXT = 'IMACPY: NO DATA SELECTED'
            GO TO 980
            END IF
C                                       add the zero spacing
         IF ((ZEROSP(1).GT.0.0) .AND. (ZEROSP(5).GT.0.0)) THEN
            RP(INDXU) = 0.
            RP(INDXV) = 0.
            RP(INDXW) = 0.
            DO 210 I = 1,NCOR
               VS(1,I) = ZEROSP(LST)
               VS(2,I) = 0.0
               VS(3,I) = ZEROSP(5)
 210           CONTINUE
            TCOUNT = TCOUNT + 1
            COUNT = COUNT + 1
            IF (CLIMIT(2).GT.0.0) ACOUNT = ACOUNT + 1
            CALL UVWRIT (UVOUT, RP, VS, IERR)
            IF (IERR.GT.0) GO TO 990
            WRITE (MSGTXT,1210) ZEROSP(LST), ZEROSP(5), STOKES
            CALL MSGWRT (4)
            END IF
C                                       Set amount of output data
         DIM(1) = 1
         DIM(2) = 1
         RDUM(1) = BUMAX
         CALL OUVPUT (UVOUT, 'MAXBLINE', OOARE, DIM, IDUM, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 990
         CALL OUVPUT (UVOUT, 'MAXABSU ', OOARE, DIM, IDUM, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 990
C                                       rotation
         IF (DOROT) THEN
            ROTATE = 0.0
            RDUM(1) = 0.0
            CALL OUVPUT (UVOUT, 'ROTATE', OOARE, DIM, IDUM, CDUMMY,
     *         IERR)
            IF (IERR.NE.0) GO TO 990
            DIM(1) = 7
            CALL RCOPY (7, CROTAU, RDUM)
            CALL UVDPUT (UVOUT, 'CROTA', OOARE, DIM, IDUM, CDUMMY,
     *         IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
C                                       actual average frequency
         IF (SUMN.GT.0.0D0) THEN
            AVFREQ = SUMC / SUMN
C                                       if spectral index used, must
C                                       use that ref freq
            IF (SPINDX.NE.0.0) THEN
               AVFREQ = AVGFRQ
            ELSE IF (SUMN.LT.SUMT*NCOR) THEN
               WRITE (MSGTXT,1215) SUMN, SUMT*NCOR
               CALL MSGWRT (3)
               WRITE (MSGTXT,1216) AVFREQ / 1.D6
               CALL MSGWRT (3)
               END IF
            END IF
C                                       average time
         IF (DOAVG) THEN
C                                       Average as cosine and sine to
C                                       deal with periodic nature of GST
            IF (TACNT.GT.0) THEN
               SUMI = SUMI / TACNT
               SUMR = SUMR / TACNT
               AVGTIM(1) = ATAN2 (SUMI, SUMR+1.0D-20)
               SUMR = SUMR * SUMR
               SUMI = SUMI * SUMI
               SUMRR = SUMRR / TACNT - SUMR
               SUMII = SUMII / TACNT - SUMI
               AVGTIM(2) = (SUMI*SUMRR + SUMR*SUMII) / (SUMR + SUMI)
            ELSE
               MSGTXT = 'IMACPY: NO VISIBILITIES'
               IERR = 5
               GO TO 980
               END IF
C                                       Convert time back to solar
            AVGTIM(1) = (AVGTIM(1) - GST0)
            IF (AVGTIM(1).LE.0.0) AVGTIM(1) = AVGTIM(1) + TWOPI
            IF (AVGTIM(1).LE.0.0) AVGTIM(1) = AVGTIM(1) + TWOPI
            IF (AVGTIM(1).LE.0.0) AVGTIM(1) = AVGTIM(1) + TWOPI
            IF (AVGTIM(1).LE.0.0) AVGTIM(1) = AVGTIM(1) + TWOPI
            AVGTIM(1) = AVGTIM(1) / ROTRAT
            AVGTIM(2) = SQRT (AVGTIM(2)) / ROTRAT
            END IF
C                                       Warnings ?
         IF (DOWARN) THEN
            IF (TCOUNT.GT.COUNT) THEN
               WRITE (MSGTXT,1220) COUNT, TCOUNT
               CALL MSGWRT (6)
               END IF
            IF (ACOUNT.GT.0) THEN
               WRITE (MSGTXT,1221) COUNT, ACOUNT
               CALL MSGWRT (3)
            ELSE
               WRITE (MSGTXT,1222) COUNT
               CALL MSGWRT (3)
               END IF
C                                       data outside grid?
            UMAX = UMAX * FRMULT
            VMAX = VMAX * FRMULT
            AUMAX = AUMAX * FRMULT
            AVMAX = AVMAX * FRMULT
            BVMAX = BVMAX * FRMULT
            IF ((AUMAX.GT.UMAX) .OR. (AVMAX.GT.VMAX)) THEN
               MSGTXT = '**** WARNING data discarded outside usable'
     *            // ' part of UV plane ****'
               CALL MSGWRT (6)
               IF (AUMAX.GT.UMAX) THEN
                  UU = UMAX/AUMAX * ABS(CELLS(1))
                  WRITE (MSGTXT,1230) 'U', AUMAX, UMAX
                  CALL MSGWRT (6)
                  WRITE (MSGTXT,1231) UU, ABS(CELLS(1))
                  CALL MSGWRT (6)
                  WRITE (MSGTXT,1232) 'U', GUARDB(1)
                  CALL MSGWRT (6)
                  END IF
               IF (AVMAX.GT.VMAX) THEN
                  VV = VMAX/AVMAX * ABS(CELLS(2))
                  WRITE (MSGTXT,1230) 'V', AVMAX, VMAX
                  CALL MSGWRT (6)
                  WRITE (MSGTXT,1231) VV, CELLS(2)
                  CALL MSGWRT (6)
                  WRITE (MSGTXT,1232) 'V', GUARDB(2)
                  CALL MSGWRT (6)
                  END IF
               END IF
            IF ((BUMAX.GT.UMAX*(1.-1.2*UTFACT(1))/(1.0-GUARDB(1))) .OR.
     *         (BVMAX.GT.VMAX*(1.-1.2*UTFACT(2))/(1.0-GUARDB(2)))) THEN
               MSGTXT = '**** WARNING data included out of inner'
     *            // ' portion of UV plane ****'
               CALL MSGWRT (6)
               MSGTXT = '**** Watch for high-frequency & other poor ' //
     *            'cleaning effects ****'
               CALL MSGWRT (6)
               END IF
            END IF
C                                       Set amount of output data
         DIM(1) = 1
         DIM(2) = 1
         IDUM(1) = COUNT
         CALL UVDPUT (UVOUT, 'GCOUNT', OOAINT, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Sort order the same as input if
C                                       subarray 1, else undefined
         CALL UVDGET (UVIN, 'SORTORD', TYPE, DIM, IDUM, SORD, IERR)
         IF (IERR.NE.0) GO TO 990
         IF (NSUBA.GT.1) SORD = '  '
         IF ((DOROT) .AND. (SORD.NE.'TB') .AND. (SORD.NE.'BT'))
     *      SORD = '??'
         CALL UVDPUT (UVOUT, 'SORTORD', TYPE, DIM, IDUM, SORD, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Copy relevant tables
         MSGSUP = 31999
         CALL UVDTCO (UVIN, UVOUT, IERR)
         MSGSUP = MSGSAV
         IF (IERR.NE.0) GO TO 990
C                                       Close files, update disk
         CALL OUVCLO (UVOUT, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Mark output as valid
         DIM(1) = 1
         LDUM(1) = .TRUE.
         CALL FSTPUT (UVOUT, 'VALID', OOALOG, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL APOBJ ('CLOSE', 'IMACPY', LERR)
C                                       Close input
         DIM(1) = 1
         DIM(2) = 1
         I = MAX (1, SUBA(1))
         IDUM(1) = I
         CALL SECPUT (UVIN, 'SUBARR', OOAINT, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 990
         CALL OUVCLO (UVIN, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
      GO TO 999
C                                       Error
 980  CALL MSGWRT (7)
 990  CALL APOBJ ('CLOSE', 'IMACPY', LERR)
 995  MSGTXT = 'IMACPY: ERROR COPYING ' // UVIN
      CALL MSGWRT (7)
      MSGTXT = 'TO ' // UVOUT
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1210 FORMAT ('IMACPY: append zero spacing',F10.4,' weight',F7.1,
     *   ' Stokes ',A4)
 1215 FORMAT ('IMACPY: found',F13.0,' of',F13.0,' possible channels')
 1216 FORMAT ('IMACPY: average frequency is then',F11.3,' MHz')
 1220 FORMAT ('IMACPY: Only',I9,' samples of',I9,' fell on UV grid')
 1221 FORMAT ('IMACPY: Averaging',I9,' samples makes',I9,
     *   ' to be imaged')
 1222 FORMAT ('IMACPY: Copied',I9,' visibilities to be imaged')
 1230 FORMAT ('**** Actual ',A,'max',1PE11.4,' exceeds limit',1PE11.4,
     *   8X,'****')
 1231 FORMAT ('**** Use cellsize <',F10.5,' not',F10.5,
     *   ' to get all data ****')
 1232 FORMAT ('**** using a ',A,' guard band of',F7.3,' of a radius',
     *   13X,'****')
      END
      SUBROUTINE IMC3DI (DO3D, ROTATE, NFIELD, RASH, DECSH, UMATS)
C-----------------------------------------------------------------------
C   Routine to prepare re-projection matrices for uvw
C   Input:
C      DO3D     L      Use 3D or in-plane math
C      ROTATE   R      Rotation in degrees
C      NFIELD   I      Number of fields
C      RASH     R(*)   RA shift parameters
C      DECSH    R(*)   Dec shift parameters
C   Input from DUVH.INC: RA and DEC
C   Output:
C      UMATS    R(3,3,*)  uvw re-projection matrices
C-----------------------------------------------------------------------
      LOGICAL   DO3D
      INTEGER   NFIELD
      REAL      ROTATE, RASH(*), DECSH(*), UMATS(3,3,*)
C
      INTEGER   LFIELD
      REAL      PMAT(3,3)
      DOUBLE PRECISION XRA, XDEC
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
      DO 20 LFIELD = 1,NFIELD
         CALL XYSHFT (RA, DEC, RASH(LFIELD), DECSH(LFIELD), ROTATE,
     *      XRA, XDEC)
         IF (DO3D)  THEN
            CALL PRJMAT (RA, DEC, ROTATE, XRA, XDEC, ROTATE,
     *         UMATS(1,1,LFIELD), PMAT)
C                                       EXPERIMENTAL ????
         ELSE
            CALL P2DMAT (RA, DEC, ROTATE, XRA, XDEC, ROTATE,
     *         UMATS(1,1,LFIELD), PMAT)
            END IF
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE IMC3DM (UVW, NFIELD, UMATS, UU, VV)
C-----------------------------------------------------------------------
C   Routine to find max abs U and V over all re-projections
C   Input:
C      UVW      R(3)      u,v,w allready rotated if needed
C      NFIELD   I         Number of fields
C      UMATS    R(3,3,*)  uvw re-projection matrices
C   Output
C      UU       R         Max (abs(u))
C      VV       R         Max (abs(v))
C-----------------------------------------------------------------------
      INTEGER   NFIELD
      REAL      UVW(3), UMATS(3,3,*), UU, VV
C
      INTEGER   LFIELD
      REAL      PRJU(3)
C-----------------------------------------------------------------------
      UU = ABS (UVW(1))
      VV = ABS (UVW(2))
      DO 20 LFIELD = 1,NFIELD
         CALL PRJMUL (1, UVW, UMATS(1,1,LFIELD), PRJU)
         UU = MAX (UU, ABS(PRJU(1)))
         VV = MAX (VV, ABS(PRJU(2)))
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE WTBOXF (BOXFIL, BIF, EIF, NWEGHT, WEGHTS, IRET)
C-----------------------------------------------------------------------
C   WTBOXF reads the BOXFILE for W cards to set weights
C   Input:
C      BOXFIL   C*(*)   Box file name
C      BIF      I       First IF included
C      EIF      I       Last IF included
C      NWEGHT   I       Number of spectral channels
C   Output:
C      WEGHTS   R(*)    Weight multipliers (NWEGHT, BIF:EIF)
C      IRET     I       Error code
C-----------------------------------------------------------------------
      CHARACTER BOXFIL*(*)
      INTEGER   BIF, EIF, NWEGHT, IRET
      REAL      WEGHTS(*)
C
      INTEGER   LUN, I, J, FIND, IPARM(2), KBP, I1, I2, J1, J2, K
      REAL      WT
      CHARACTER LINE*132
      DOUBLE PRECISION X
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                        Open clean box file
      LUN = 11
      CALL ZTXOPN ('QRED', LUN, FIND, BOXFIL, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN'
         CALL MSGWRT (6)
         GO TO 999
         END IF
      DO 50 K = 1,100000
         CALL ZTXIO ('READ', LUN, FIND, LINE, IRET)
         IF (IRET.EQ.2) GO TO 60
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ'
            CALL MSGWRT (6)
            GO TO 999
            END IF
C                                       A weight line
         CALL CHTRIM (LINE, 132, LINE, J)
         IF ((LINE(:1).EQ.'W') .OR. (LINE(:1).EQ.'w'))  THEN
            KBP = 2
            DO 10 J = 1,3
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) THEN
                  IF (J.EQ.1) GO TO 50
                  WRITE (MSGTXT,1020) K, J
                  CALL MSGWRT (6)
                  IRET = 1
                  GO TO 999
               ELSE IF (J.EQ.1) THEN
                  WT = X
               ELSE
                  IF (X.GE.0.0D0) THEN
                     IPARM(J-1) = X + 0.50D0
                  ELSE
                     IPARM(J-1) = X - 0.50D0
                     END IF
                  END IF
 10            CONTINUE
            IF (IPARM(1).LE.NWEGHT) THEN
               IF (IPARM(1).LE.0) THEN
                  J1 = 1
                  J2 = NWEGHT
               ELSE
                  J1 = IPARM(1)
                  J2 = J1
                  END IF
               IF (IPARM(2).EQ.0) THEN
                  I1 = BIF
                  I2 = EIF
               ELSE
                  I1 = IPARM(2)
                  I2 = I1
                  END IF
               DO 30 I = I1,I2
                  IF ((I.GE.BIF) .AND. (I.LE.EIF)) THEN
                     DO 20 J = J1,J2
                        WEGHTS(J+(I-BIF)*NWEGHT) = WT
 20                     CONTINUE
                     END IF
 30               CONTINUE
               END IF
            END IF
 50      CONTINUE
C
 60   CALL ZTXCLS (LUN, FIND, IRET)
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('WTBOXF: ERROR',I4,1X,A,'ING THE CLEAN BOXES TEXT FILE')
 1020 FORMAT ('WTBOXF: PARSING ERROR ON LINE',I4,' FIELD',I2)
      END
      SUBROUTINE IGNORF (BOXFIL, MFIELD, IGNORE, IRET)
C-----------------------------------------------------------------------
C   IGNORF reads the BOXFILE for I cards to set fields to be ignored
C   Input:
C      BOXFIL   C*(*)   Box file name
C      MFIELD   I       maximum field number
C   Output:
C      IGNORE   R(*)    = -2.0 if field to be ignored
C      IRET     I       Error code
C-----------------------------------------------------------------------
      CHARACTER BOXFIL*(*)
      INTEGER   MFIELD, IRET
      REAL      IGNORE(*)
C
      INTEGER   LUN, I, J, FIND, IPARM(2), KBP, K
      CHARACTER LINE*132
      DOUBLE PRECISION X
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                        Open clean box file
      LUN = 11
      CALL ZTXOPN ('QRED', LUN, FIND, BOXFIL, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN'
         CALL MSGWRT (6)
         GO TO 999
         END IF
      DO 50 K = 1,100000
         CALL ZTXIO ('READ', LUN, FIND, LINE, IRET)
         IF (IRET.EQ.2) GO TO 60
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ'
            CALL MSGWRT (6)
            GO TO 999
            END IF
C                                       A weight line
         CALL CHTRIM (LINE, 132, LINE, J)
         IF ((LINE(:1).EQ.'I') .OR. (LINE(:1).EQ.'i'))  THEN
            KBP = 2
            DO 10 J = 1,2
               CALL GETNUM (LINE, 132, KBP, X)
               IF (X.EQ.DBLANK) THEN
                  IPARM(J) = 0
               ELSE
                  IPARM(J) = X + 0.5D0
                  END IF
 10            CONTINUE
            IF ((IPARM(1).GT.0) .AND. (IPARM(1).LE.MFIELD)) THEN
               IF (IPARM(2).EQ.0) IPARM(2) = IPARM(1)
               IF (IPARM(2).GT.MFIELD) IPARM(2) = MFIELD
               DO 20 I = IPARM(1),IPARM(2)
                  IGNORE(I) = -2.0
 20               CONTINUE
               END IF
            END IF
 50      CONTINUE
C
 60   CALL ZTXCLS (LUN, FIND, IRET)
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('IGNORF: ERROR',I4,1X,A,'ING THE CLEAN BOXES TEXT FILE')
      END
      SUBROUTINE CPBOXF (BOXFIL, OBXFIL, IRET)
C-----------------------------------------------------------------------
C   Copy BOXFILE to OBOXFILE but only if OBOXFILE is a new file
C   Inputs:
C      BOXFIL   C*48    Input boxfile
C      OBXFIL   C*48    Output boxfile
C   Output:
C      IRET     I       Error code
C-----------------------------------------------------------------------
      CHARACTER BOXFIL*(*), OBXFIL*(*)
      INTEGER   IRET
C
      INTEGER   LUN1, LUN2, IND1, IND2, JTRIM, MSGSAV, K, I
      CHARACTER LINE*132
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF ((BOXFIL.NE.' ') .AND. (OBXFIL.NE.' ') .AND.
     *   (BOXFIL.NE.OBXFIL)) THEN
         MSGSAV = MSGSUP
         MSGSUP = 32000
         LUN1 = 3
         LUN2 = 11
         CALL ZTXOPN ('QWRT', LUN2, IND2, OBXFIL, .FALSE., IRET)
         MSGSUP = MSGSAV
C                                       file already exists
         IF (IRET.EQ.5) THEN
            IRET = 0
            MSGTXT = 'OBOXFILE already exists, BOXFILE not copied to'
     *         // ' it'
            CALL MSGWRT (3)
C                                       other error
         ELSE IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OUTPUT'
            GO TO 990
C                                       do copy
         ELSE
            CALL ZTXOPN ('QRED', LUN1, IND1, BOXFIL, .FALSE., IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'OPEN INPUT'
               GO TO 990
               END IF
            DO 50 K = 1,100000
               CALL ZTXIO ('READ', LUN1, IND1, LINE, IRET)
               IF (IRET.EQ.2) GO TO 60
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'READ'
                  GO TO 990
                  END IF
               I = JTRIM (LINE)
               CALL ZTXIO ('WRIT', LUN2, IND2, LINE(:I), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRIT'
                  GO TO 990
                  END IF
 50            CONTINUE
C                                       close them up
 60         CALL ZTXCLS (LUN1, IND1, IRET)
            CALL ZTXCLS (LUN2, IND2, IRET)
            K = K - 1
            WRITE (MSGTXT,1060) K
            CALL MSGWRT (3)
            IRET = 0
            END IF
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CPBOXF: ERROR',I5,' DOING ',A)
 1060 FORMAT ('CPBOXF: copied',I6,' lines from BOXFILE to OBOXFILE')
      END
      SUBROUTINE IMAHIS (CLEAN, UVDATA)
C-----------------------------------------------------------------------
C   Routine to write history file to output CLEAN image object.
C   Inputs:
C      CLEAN   C*?  CLEAN process object
C      UVDATA  C*?  Input UV data
C-----------------------------------------------------------------------
      CHARACTER CLEAN*(*), UVDATA*32
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCLN.INC'
      INTEGER   NADV0, NADV1
      PARAMETER (NADV0=63, NADV1=14)
      CHARACTER CLEANO(MAXFLD)*32, BEAM(MAXFLD)*32, LIST(NADV0)*8,
     *   CDUMMY*1, CLIST(NADV1)*8, LINE*72, SPIX*32, CFLD*4, CBOX*5,
     *   OBXFIL*48
      INTEGER   IERR, TYPE, DIM(7), NFIELD, I, BP, IFLD(2,MAXFLD),
     *   IMSIZE(2,MAXFLD), J, NCMP, MSGSAV, BFIELD, NUMRES, NADV, CP
      LONGINT   KP
      REAL      RASH(MAXFLD), DECSH(MAXFLD), FFL, TFL, IMPARM(20),
     *   ROBUST, RESMAX
      LOGICAL   NOCLEN, DO3DIM, ONEBEM
      INCLUDE 'IMAGWIN.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'SRCNAME', 'QUAL',
     *   'CALCODE', 'TIMERANG', 'SELBAND', 'SELFREQ', 'FREQID',
     *   'SUBARRAY', 'ANTENNAS', 'BASELINE', 'DOCALIB', 'GAINUSE',
     *   'DOPOL', 'PDVER', 'BLVER', 'FLAGVER', 'DOBAND', 'BPVER',
     *   'SMOOTH', 'STOKES', 'BCHAN', 'ECHAN', 'CHANNEL', 'NCHAV',
     *   'CHINC', 'BIF', 'EIF', 'OUTNAME','OUTSEQ', 'OUTVER',
     *   'CELLSIZE', 'NFIELD', 'UVTAPER', 'UVRANGE', 'GUARD', 'ROTATE',
     *   'ZEROSP','UVWTFN', 'UVSIZE', 'UVBOX', 'UVBXFN', 'XTYPE',
     *   'YTYPE', 'XPARM', 'YPARM', 'OVERLAP', 'NGAUSS', 'WGAUSS',
     *   'FGAUSS', 'FQTOL', 'BOXFILE', 'OBOXFILE', 'IN3NAME',
     *   'IN3CLASS', 'IN3SEQ', 'IN3DISK', 'IN4NAME', 'IN4CLASS',
     *   'IN4SEQ', 'IN4DISK'/
      DATA CLIST /'NITER', 'BCOMP', 'GAIN', 'FLUX', 'MINPATCH', 'BMAJ',
     *   'BMIN', 'BPA', 'PHAT', 'FACTOR', 'CMETHOD', 'IMAGRPRM',
     *   'IM2PARM', 'MAXPIXEL'/
C-----------------------------------------------------------------------
C                                       remove temp OBOXFILE ?
      MSGSAV = MSGSUP
      CALL OGET (CLEAN, 'OBOXFILE', TYPE, DIM, IDUM, OBXFIL, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (OBXFIL(:13).EQ.'HOME:OBOXtemp') THEN
         I = 3
         CALL ZTXZAP (I, OBXFIL, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'IMAHIS FAILED TO DELETE TEMPORARY OBOXFILE'
            CALL MSGWRT (7)
            IERR = 0
            END IF
         END IF

C                                       How many fields, all resolutions
      CALL OGET (CLEAN, 'NIMAGES', TYPE, DIM, IDUM, CDUMMY, IERR)
      NFIELD = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OGET ('Input', 'NGAUSS', TYPE, DIM, IDUM, CDUMMY, IERR)
      NUMRES = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      NUMRES = MAX (1, NUMRES)
C                                       CLEAN names
      CALL OGET (CLEAN, 'CLEANI', TYPE, DIM, IDUM, CLEANO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       3D imaging # beams
      CALL OGET (CLEAN, 'DO3DIMAG', TYPE, DIM, IDUM, CDUMMY, IERR)
      DO3DIM = LDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (CLEAN, 'ONEBEAM', TYPE, DIM, IDUM, CDUMMY, IERR)
      ONEBEM = LDUM(1)
      IF (IERR.NE.0) GO TO 999
      BFIELD = NFIELD
C                                       Get image-dep parms
      CALL OGET (CLEANO(1), 'IMSIZE', TYPE, DIM, IMSIZE, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OGET ('Input', 'FLDSIZE', TYPE, DIM, IFLD, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL OGET (CLEANO(1), 'RASHIFT', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL RCOPY (DIM(1), RDUM, RASH)
      CALL OGET (CLEANO(1), 'DECSHIFT', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL RCOPY (DIM(1), RDUM, DECSH)
      IF (.NOT.REWIN) THEN
         CALL OGET (CLEAN, 'NBOXES', TYPE, DIM, IDUM, CDUMMY, IERR)
         NBOXES = IDUM(1)
         IF (IERR.NE.0) GO TO 995
         CALL OGET (CLEAN, 'WINDOW', TYPE, DIM, WIN(1+WINP), CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 995
         END IF
      MSGSUP = 32000
      CALL OGET (CLEAN, 'TFLUX', TYPE, DIM, IDUM, CDUMMY, IERR)
      TFL =- RDUM(1)
      MSGSUP = MSGSAV
      NOCLEN = IERR.EQ.1
      IF (NOCLEN) IERR = 0
      IF (IERR.NE.0) GO TO 995
      CALL OGET (CLEAN, 'IMPARM', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL RCOPY (DIM(1), RDUM, IMPARM)
C                                       SPIX?
      MSGSUP = 32000
      CALL OGET (UVDATA, 'SPIXIMAGE', TYPE, DIM, IDUM, SPIX, IERR)
      IF (IERR.EQ.1) THEN
         IERR = 0
         SPIX = ' '
         END IF
      NADV = NADV0
      IF (SPIX.EQ.' ') NADV = NADV - 8
C                                       Loop over cleans
      DO 100 I = 1,NFIELD
         WRITE (CFLD,2000) I
         CP = 1
         IF (I.LT.1000) CP = 2
         IF (I.LT.100) CP = 3
         IF (I.LT.10) CP = 4
C                                       Copy old history
         CALL OHCOPY (UVDATA, CLEANO(I), IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Copy base adverb values.
         CALL OHLIST ('Input', LIST, NADV, CLEANO(I), IERR)
         IF (IERR.NE.0) GO TO 990
C                                       ROBUST = 0 meaningful
         CALL OGET (CLEANO(I), 'ROBUST', TYPE, DIM, IDUM, CDUMMY, IERR)
         ROBUST = RDUM(1)
         IF (IERR.NE.0) GO TO 995
         WRITE (LINE,1010) ROBUST
         CALL OHWRIT (LINE, CLEANO(I), IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Copy cleaning adverbs
         CALL OHLIST ('Input', CLIST, NADV1, CLEANO(I), IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Field-dependent parms
         WRITE (LINE,1000) CFLD(CP:), IMSIZE(1,I), IMSIZE(2,I)
         CALL OHWRIT (LINE, CLEANO(I), IERR)
         IF (IERR.NE.0) GO TO 990
         WRITE (LINE,1001) CFLD(CP:), IFLD(1,I), IFLD(2,I)
         CALL OHWRIT (LINE, CLEANO(I), IERR)
         IF (IERR.NE.0) GO TO 990
         WRITE (LINE,1002) CFLD(CP:), RASH(I)
         CALL OHWRIT (LINE, CLEANO(I), IERR)
         IF (IERR.NE.0) GO TO 990
         WRITE (LINE,1003) CFLD(CP:), DECSH(I)
         CALL OHWRIT (LINE, CLEANO(I), IERR)
         IF (IERR.NE.0) GO TO 990
         IF (NBOXES(I).GT.0) THEN
            WRITE (LINE,1004) CFLD(CP:), NBOXES(I)
            CALL OHWRIT (LINE, CLEANO(I), IERR)
            IF (IERR.NE.0) GO TO 990
            BP = 1
            IF (NBOXES(I).LT.10000) BP = 2
            IF (NBOXES(I).LT.1000) BP = 3
            IF (NBOXES(I).LT.100) BP = 4
            IF (NBOXES(I).LT.10) BP = 5
            DO 20 J = 1,NBOXES(I)
               WRITE (CBOX,2001) J
               KP = ((J - 1) * NFIELD + I - 1) * 4 + WINP
               WRITE (LINE,1005) CBOX(BP:), CFLD(CP:), WIN(1+KP),
     *            WIN(2+KP), WIN(3+KP), WIN(4+KP)
               CALL OHWRIT (LINE, CLEANO(I), IERR)
               IF (IERR.NE.0) GO TO 990
 20            CONTINUE
            END IF
         IF (.NOT.NOCLEN) THEN
            MSGSUP = 32000
            CALL OGET (CLEANO(I), 'FIELDRES', TYPE, DIM, IDUM, CDUMMY,
     *         IERR)
            RESMAX = RDUM(1)
            MSGSUP = MSGSAV
            IF (IERR.EQ.1) THEN
               IERR = 0
               RESMAX = -1.0
               END IF
            IF (IERR.NE.0) GO TO 990
            MSGSUP = 32000
            CALL OGET (CLEANO(I), 'BEAM.NITER', TYPE, DIM, IDUM, CDUMMY,
     *         IERR)
            NCMP = IDUM(1)
            MSGSUP = MSGSAV
            IF (IERR.EQ.1) THEN
               IERR = 0
               NCMP = 0
               END IF
            IF (IERR.NE.0) GO TO 990
            MSGSUP = 32000
            CALL OGET (CLEANO(I), 'CFLUX', TYPE, DIM, IDUM, CDUMMY,
     *         IERR)
            FFL = RDUM(1)
            MSGSUP = MSGSAV
            IF (IERR.EQ.1) THEN
               IERR = 0
               FFL = 0.0
               END IF
            IF (IERR.NE.0) GO TO 990
            WRITE (LINE,1007) TFL
            CALL OHWRIT (LINE, CLEANO(I), IERR)
            IF (IERR.NE.0) GO TO 990
            WRITE (LINE,1006) CFLD(CP:), NCMP
            CALL OHWRIT (LINE, CLEANO(I), IERR)
            IF (IERR.NE.0) GO TO 990
            WRITE (LINE,1008) CFLD(CP:), FFL
            CALL OHWRIT (LINE, CLEANO(I), IERR)
            IF (IERR.NE.0) GO TO 990
            WRITE (LINE,1009) CFLD(CP:), RESMAX
            CALL OHWRIT (LINE, CLEANO(I), IERR)
            IF (IERR.NE.0) GO TO 990
            IF (NUMRES.GT.1) THEN
               DO 30 J = 11,16
                  WRITE (LINE,1020) J, IMPARM(J)
                  IF (J.EQ.16) WRITE (LINE,1021) J, IMPARM(J)
                  CALL OHWRIT (LINE, CLEANO(I), IERR)
                  IF (IERR.NE.0) GO TO 990
 30               CONTINUE
               END IF
            IF (IMPARM(19).GT.0.0) THEN
               WRITE (LINE,1030) IMPARM(19)
               CALL OHWRIT (LINE, CLEANO(I), IERR)
               IF (IERR.NE.0) GO TO 990
               END IF
            END IF
 100     CONTINUE
      CALL ZMEMRY ('FREE', 'IMAGR', WINW, WIN(1), WINP, IERR)
C                                       Beam
      CALL OGET (CLEAN, 'DIRTBEAM', TYPE, DIM, IDUM, BEAM, IERR)
      IF (IERR.NE.0) GO TO 990
      DO 120 I = 1,BFIELD
         IF ((.NOT.ONEBEM) .OR. (MOD(I,NFIELD).EQ.1) .OR. (NFIELD.EQ.1))
     *      THEN
            CALL OGET (BEAM(I), 'IMSIZE', TYPE, DIM, IMSIZE, CDUMMY,
     *         IERR)
            IF (IERR.NE.0) GO TO 980
C                                       Old history
            CALL OHCOPY (UVDATA, BEAM(I), IERR)
            IF (IERR.NE.0) GO TO 980
C                                       copy base adverb values only
            CALL OHLIST ('Input', LIST, NADV0, BEAM(I), IERR)
            IF (IERR.NE.0) GO TO 980
C                                       ROBUST = 0 meaningful
            WRITE (LINE,1010) ROBUST
            CALL OHWRIT (LINE, BEAM(I), IERR)
            IF (IERR.NE.0) GO TO 980
C                                       Copy cleaning adverbs
            CALL OHLIST ('Input', CLIST, NADV1, BEAM(I), IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
 120     CONTINUE
      GO TO 999
C                                       Error
 980  MSGTXT = 'ERROR WRITING HISTORY FOR ' // BEAM(I)
      CALL MSGWRT (6)
      GO TO 999
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // CLEANO(I)
      CALL MSGWRT (6)
      GO TO 999
 995  MSGTXT = 'ERROR WRITING HISTORY FOR ' // CLEAN
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('IMSIZE(*,',A,')  = ',I5,' ,',I6)
 1001 FORMAT ('FLDSIZE(*,',A,') = ',I5,' ,',I6)
 1002 FORMAT ('RASHIFT(',A,')   = ',1PE12.5)
 1003 FORMAT ('DECSHIFT(',A,')  = ',1PE12.5)
 1004 FORMAT ('NBOXES(',A,')    = ',I2)
 1005 FORMAT ('WIN(*,',A,',',A,') =',3(I5,','),I5)
 1006 FORMAT ('NCOMP(',A,') =',I8)
 1007 FORMAT ('TFLUX = ',1PE12.5,9X,'/ Total cleaned flux')
 1008 FORMAT ('CFLUX(',A,') = ',1PE12.5,5X,'/ Cleaned flux in field')
 1009 FORMAT ('RESMAX(',A,') = ',1PE12.5,4X,
     *   '/ Peak residual in field windows')
 1010 FORMAT ('ROBUST =',F8.3,' / Weighting robustness parm')
 1020 FORMAT ('IMAGRPRM(',I2,') =',F8.5,' / MRClean control')
 1021 FORMAT ('IMAGRPRM(',I2,') =',F8.0,' / MRClean control')
 1030 FORMAT ('IMAGRPRM(19) =',F6.4,' / Dynamic range limit')
 2000 FORMAT (I4)
 2001 FORMAT (I5)
      END
      SUBROUTINE IMAMXN (MFIELD, CNAME, IRET)
C-----------------------------------------------------------------------
C   IMAMXN checks and sets the max min in the image header for the full
C   image.
C   Input
C      MFIELD     I         Number of fields present.
C      CNAME     C(*)*32   Names of associated clean (residual) images.
C   Output to common:
C   Output:
C      IRET       I    Return error code, 0=>OK, otherwise failed.
C-----------------------------------------------------------------------
      INTEGER   MFIELD, IRET
      CHARACTER CNAME(*)*(*)
C
      INTEGER   IFIELD, BLC(7), TRC(7), DIM(7), TYPE, LOOP7, LOOP6,
     *   LOOP5, LOOP4, LOOP3, LOOP2, LOOP1, LROW, NAXIS(7)
      CHARACTER CDUMMY*1
      INCLUDE 'INCS:PMAD.INC'
      REAL      DATMAX, DATMIN, VALUE, ROW(MABFSS)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
C-----------------------------------------------------------------------
      MSGTXT = 'Checking image max/min'
      CALL MSGWRT (3)
C                                       Loop over fields.
      DO 800 IFIELD = 1,MFIELD
C                                       Set window for residual/restored
         CALL ARDGET (CNAME(IFIELD), 'BLC', TYPE, DIM, BLC, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 995
         CALL ARDGET (CNAME(IFIELD), 'TRC', TYPE, DIM, TRC, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 995
         BLC(1) = 1
         BLC(2) = 1
         BLC(3) = 1
         TRC(1) = 0
         TRC(2) = 0
         TRC(3) = 0
         CALL ARDPUT (CNAME(IFIELD), 'BLC', OOAINT, DIM, BLC, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 995
         CALL ARDPUT (CNAME(IFIELD), 'TRC', OOAINT, DIM, TRC, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 995
C                                       Open array and get I/O stream
         CALL ARROPN (CNAME(IFIELD), 'READ', IRET)
         IF (IRET.NE.0) GO TO 995
C                                       Window
         CALL ARRWIN (CNAME(IFIELD), BLC, TRC, NAXIS, IRET)
         IF (IRET.NE.0) GO TO 995
         DATMAX = -1.0E25
         DATMIN = 1.0E25
C                                       Loop over array
         LROW = TRC(1) - BLC(1) + 1
         DO 700 LOOP7 = BLC(7),TRC(7)
            DO 600 LOOP6 = BLC(6),TRC(6)
               DO 500 LOOP5 = BLC(5),TRC(5)
                  DO 400 LOOP4 = BLC(4),TRC(4)
                     DO 300 LOOP3 = BLC(3),TRC(3)
                        DO 200 LOOP2 = BLC(2),TRC(2)
C                                       read row
         CALL ARREAD (CNAME(IFIELD), DIM, ROW, IRET)
         IF (IRET.GT.0) GO TO 995
C                                       Do statistics
         DO 120 LOOP1 = 1,LROW
            VALUE = ROW(LOOP1)
            IF (VALUE.NE.FBLANK) THEN
               DATMAX = MAX (DATMAX, VALUE)
               DATMIN = MIN (DATMIN, VALUE)
               END IF
 120        CONTINUE
 200                       CONTINUE
 300                    CONTINUE
 400                 CONTINUE
 500              CONTINUE
 600           CONTINUE
 700        CONTINUE
C                                       Close file
         CALL ARRCLO (CNAME(IFIELD), IRET)
         IF (IRET.NE.0) GO TO 995
C                                       Save values in ARRAY_STAT
         DIM(1) = 1
         DIM(2) = 1
         DIM(3) = 0
         RDUM(1) = DATMAX
         CALL ARSPUT (CNAME(IFIELD), 'DATAMAX', OOARE, DIM, IDUM,
     *      CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 995
         RDUM(1) = DATMIN
         CALL ARSPUT (CNAME(IFIELD), 'DATAMIN', OOARE, DIM, IDUM,
     *      CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 995
C                                       force max/min to disk
         CALL IMGOPN (CNAME(IFIELD), 'WRIT', IRET)
         IF (IRET.NE.0) GO TO 995
         RDUM(1) = DATMAX
         CALL IMPUT (CNAME(IFIELD), 'DATAMAX', OOARE, DIM, IDUM,
     *      CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 995
         RDUM(1) = DATMIN
         CALL IMPUT (CNAME(IFIELD), 'DATAMIN', OOARE, DIM, IDUM,
     *      CDUMMY, IRET)
         IF (IRET.NE.0) GO TO 995
         CALL IMGCLO (CNAME(IFIELD), IRET)
         IF (IRET.NE.0) GO TO 995
 800     CONTINUE
      IRET = 0
      GO TO 999
C                                       Error
 995  MSGTXT = 'IMAMXN: ERROR DETERMING STAT. FOR ' // CNAME(IFIELD)
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE IMABLK (JCHAN, MFIELD, CNAME, IRET)
C-----------------------------------------------------------------------
C   IMABLK blanks a channel for all fields
C   Input
C      JCHAN    I         channel
C      MFIELD   I         Number of fields present.
C      CNAME    C(*)*32   Names of associated clean (residual) images.
C   Output to common:
C   Output:
C      IRET     I         Return error code, 0=>OK, otherwise failed.
C-----------------------------------------------------------------------
      INTEGER   JCHAN, MFIELD, IRET
      CHARACTER CNAME(*)*(*)
C
      INTEGER   IFIELD, BLC(7), TRC(7), DIM(7), TYPE, LOOP7, LOOP6,
     *   LOOP5, LOOP4, LOOP3, LOOP2, LROW, NAXIS(7)
      CHARACTER CDUMMY*1
      INCLUDE 'INCS:PMAD.INC'
      REAL      ROW(MABFSS)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCRE.INC'
      INCLUDE 'INCS:PAOOF.INC'
C-----------------------------------------------------------------------
      WRITE (MSGTXT,1000) JCHAN
      CALL MSGWRT (3)
C                                       Loop over fields.
      DO 800 IFIELD = 1,MFIELD
C                                       Set window for residual/restored
         CALL ARDGET (CNAME(IFIELD), 'BLC', TYPE, DIM, BLC, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 995
         CALL ARDGET (CNAME(IFIELD), 'TRC', TYPE, DIM, TRC, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 995
         BLC(1) = 1
         BLC(2) = 1
         BLC(3) = JCHAN
         TRC(1) = 0
         TRC(2) = 0
         TRC(3) = JCHAN
         CALL ARDPUT (CNAME(IFIELD), 'BLC', OOAINT, DIM, BLC, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 995
         CALL ARDPUT (CNAME(IFIELD), 'TRC', OOAINT, DIM, TRC, CDUMMY,
     *      IRET)
         IF (IRET.NE.0) GO TO 995
C                                       Open array and get I/O stream
         CALL ARROPN (CNAME(IFIELD), 'WRIT', IRET)
         IF (IRET.NE.0) GO TO 995
C                                       Window
         CALL ARRWIN (CNAME(IFIELD), BLC, TRC, NAXIS, IRET)
         IF (IRET.NE.0) GO TO 995
C                                       Loop over array
         LROW = TRC(1) - BLC(1) + 1
         CALL RFILL (LROW, FBLANK, ROW)
         DIM(1) = LROW
         DIM(2) = 0
         DIM(3) = 0
         DO 700 LOOP7 = BLC(7),TRC(7)
            DO 600 LOOP6 = BLC(6),TRC(6)
               DO 500 LOOP5 = BLC(5),TRC(5)
                  DO 400 LOOP4 = BLC(4),TRC(4)
                     DO 300 LOOP3 = BLC(3),TRC(3)
                        DO 200 LOOP2 = BLC(2),TRC(2)
C                                       write row
                           CALL ARRWRI (CNAME(IFIELD), DIM, ROW, IRET)
                           IF (IRET.GT.0) GO TO 995
 200                       CONTINUE
 300                    CONTINUE
 400                 CONTINUE
 500              CONTINUE
 600           CONTINUE
 700        CONTINUE
C                                       Close file
         CALL ARRCLO (CNAME(IFIELD), IRET)
         IF (IRET.NE.0) GO TO 995
 800     CONTINUE
      IRET = 0
      GO TO 999
C                                       Error
 995  MSGTXT = 'IMABLK: ERROR BLANKING ' // CNAME(IFIELD)
      CALL MSGWRT (7)
C                                       if image does not exist
C                                       make sure filled with zeros
      QCREAT = -1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Blanking channel',I5,' image plane')
      END
      SUBROUTINE IMBAVG (OPER, NRPARM, NDATA, MAXAN, UVOUT, IA1, IA2,
     *   RP, VIS, BLIMIC, BLIMIT, BAVG, COUNT, IERR)
C-----------------------------------------------------------------------
C   IMBAVG averages data on a baseline-dependent time basis
C   Inputs:
C      OPER     C*4      Operation: INIT, ADD, CLOS
C      NRPARM   I        Number random parameters
C      NDATA    I        NRPARM + 3*(NCOR/BLIMIC)
C      MAXAN    I        Maximum antenna number
C      UVOUT    C*(*)    Output object
C      IA1      I        Lower antenna number
C      IA2      I        Higher antenna number
C      RP       R(*)     Random parameters
C      VIS      R(3,*)   Visibility data
C      BLIMIC   I        Number of channels to average together
C      BLIMIT   R(2)     Max time since start in days, Max BL squared
C                        separation allowed in average
C   In/Out:
C      BAVG     R(NDATA,*)   Summing/storage array
C      COUNT    I        Number records written
C   Output:
C      IERR     I        Error code
C-----------------------------------------------------------------------
      CHARACTER OPER*(*), UVOUT*(*)
      INTEGER   NRPARM, NDATA, MAXAN, IA1, IA2, BLIMIC, COUNT, IERR
      REAL      RP(*), VIS(3,*), BLIMIT(2), BAVG(NDATA,*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NCOR, INDXU, INDXV, INDXW, INDXT, IBL, BCOUNT(MXBASE),
     *   NBL, I, J, JCOR
      REAL      U, V, R, UV(2,MXBASE), STIME(MXBASE)
      INCLUDE 'INCS:DMSG.INC'
      SAVE      NCOR, INDXU, INDXV, INDXW, INDXT, BCOUNT, UV, STIME,
     *   JCOR
C-----------------------------------------------------------------------
C                                       init
      IF (OPER.EQ.'INIT') THEN
         IBL = (MAXAN * (MAXAN - 1)) / 2
         CALL FILL (IBL, 0, BCOUNT)
         IBL = IBL * NDATA
         CALL RFILL (IBL, 0.0, BAVG)
         CALL UVDFND (UVOUT, 1, 'UU-L', INDXU, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'IMBAVG: TROUBLE FINDING RANDOM PARAMETER UU-L'
            GO TO 980
            END IF
         CALL UVDFND (UVOUT, 1, 'VV-L', INDXV, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'IMBAVG: TROUBLE FINDING RANDOM PARAMETER VV-L'
            GO TO 980
            END IF
         CALL UVDFND (UVOUT, 1, 'WW-L', INDXW, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'IMBAVG: TROUBLE FINDING RANDOM PARAMETER WW-L'
            GO TO 980
            END IF
         CALL UVDFND (UVOUT, 1, 'TIME', INDXT, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'IMBAVG: TROUBLE FINDING RANDOM PARAMETER TIME'
            GO TO 980
            END IF
         BLIMIC = MAX (1, BLIMIC)
         NCOR = ((NDATA - NRPARM) * BLIMIC) / 3
         JCOR = NCOR / BLIMIC
C                                       close
      ELSE IF (OPER.EQ.'CLOS') THEN
         NBL = (MAXAN * (MAXAN - 1)) / 2
         DO 100 IBL = 1,NBL
            IF (BCOUNT(IBL).GT.0) THEN
               CALL RCOPY (NRPARM, BAVG(1,IBL), RP)
               RP(INDXU) = RP(INDXU) / BCOUNT(IBL)
               RP(INDXV) = RP(INDXV) / BCOUNT(IBL)
               RP(INDXW) = RP(INDXW) / BCOUNT(IBL)
               RP(INDXT) = RP(INDXT) / BCOUNT(IBL)
               CALL RCOPY (3*JCOR, BAVG(NRPARM+1,IBL), VIS)
               DO 20 J = 1,JCOR
                  IF (VIS(3,J).GT.0.0) THEN
                     VIS(1,J) = VIS(1,J) / VIS(3,J)
                     VIS(2,J) = VIS(2,J) / VIS(3,J)
                     END IF
 20               CONTINUE
               COUNT = COUNT + 1
               CALL UVWRIT (UVOUT, RP, VIS, IERR)
               IF (IERR.NE.0) THEN
                  MSGTXT = 'IMBAVG: TROUBLE FINISHING OUTPUT'
                  GO TO 980
                  END IF
               END IF
 100        CONTINUE
C                                       add in
      ELSE
         IBL = IA1 * (MAXAN-1) - MAXAN - ((IA1 * (IA1-1)) / 2) + IA2
C                                       allowed to average in?
         IF (BCOUNT(IBL).GT.0) THEN
            U = UV(1,IBL) - RP(INDXU)
            V = UV(2,IBL) - RP(INDXV)
            R = U*U + V*V
C                                       no
            IF ((ABS(STIME(IBL)-RP(INDXT)).GT.BLIMIT(1)) .OR.
     *         (R.GT.BLIMIT(2))) THEN
               BAVG(INDXU,IBL) = BAVG(INDXU,IBL) / BCOUNT(IBL)
               BAVG(INDXV,IBL) = BAVG(INDXV,IBL) / BCOUNT(IBL)
               BAVG(INDXW,IBL) = BAVG(INDXW,IBL) / BCOUNT(IBL)
               BAVG(INDXT,IBL) = BAVG(INDXT,IBL) / BCOUNT(IBL)
               I = NRPARM
               COUNT = COUNT + 1
               DO 120 J = 1,JCOR
                  IF (BAVG(I+3,IBL).GT.0.0) THEN
                     BAVG(I+1,IBL) = BAVG(I+1,IBL) / BAVG(I+3,IBL)
                     BAVG(I+2,IBL) = BAVG(I+2,IBL) / BAVG(I+3,IBL)
                     END IF
                  I = I + 3
 120              CONTINUE
               CALL UVWRIT (UVOUT, BAVG(1,IBL), BAVG(NRPARM+1,IBL),
     *            IERR)
               IF (IERR.NE.0) THEN
                  MSGTXT = 'IMBAVG: TROUBLE WRITING INTERMEDIATE RECORD'
                  GO TO 980
                  END IF
               BCOUNT(IBL) = 0
               END IF
            END IF
C                                       insert new record
         IF (BCOUNT(IBL).LE.0) THEN
            BCOUNT(IBL) = 1
            STIME(IBL) = RP(INDXT)
            UV(1,IBL) = RP(INDXU)
            UV(2,IBL) = RP(INDXV)
            CALL RCOPY (NRPARM, RP, BAVG(1,IBL))
            I = NRPARM
            CALL RFILL (3*JCOR, 0.0, BAVG(I+1,IBL))
C                                       but average channels
            DO 140 J = 1,NCOR
               IF (VIS(3,J).GT.0) THEN
                  BAVG(I+1,IBL) = BAVG(I+1,IBL) + VIS(1,J) * VIS(3,J)
                  BAVG(I+2,IBL) = BAVG(I+2,IBL) + VIS(2,J) * VIS(3,J)
                  BAVG(I+3,IBL) = BAVG(I+3,IBL) + VIS(3,J)
                  END IF
               IF (MOD(J,BLIMIC).EQ.0) I = I + 3
 140           CONTINUE
C                                       average in
         ELSE
            BCOUNT(IBL) = BCOUNT(IBL) + 1
            BAVG(INDXU,IBL) = BAVG(INDXU,IBL) + RP(INDXU)
            BAVG(INDXV,IBL) = BAVG(INDXV,IBL) + RP(INDXV)
            BAVG(INDXW,IBL) = BAVG(INDXW,IBL) + RP(INDXW)
            BAVG(INDXT,IBL) = BAVG(INDXT,IBL) + RP(INDXT)
            I = NRPARM
            DO 160 J = 1,NCOR
               IF (VIS(3,J).GT.0.0) THEN
                  BAVG(I+1,IBL) = BAVG(I+1,IBL) + VIS(1,J) * VIS(3,J)
                  BAVG(I+2,IBL) = BAVG(I+2,IBL) + VIS(2,J) * VIS(3,J)
                  BAVG(I+3,IBL) = BAVG(I+3,IBL) + VIS(3,J)
                  END IF
               IF (MOD(J,BLIMIC).EQ.0) I = I + 3
 160           CONTINUE
            IERR = 0
            END IF
         END IF
C
      GO TO 999
C
 980  CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE FINDAV (UVDATA, NSUBA, SUBA, BLIMIT, IERR)
C-----------------------------------------------------------------------
C   FINDAV finds the number of channels that may be averaged
C   Inputs:
C      UVDATA   C*(*)   Data set object name
C      NSUBA    I       Number of SUBA
C      SUBA     I(*)    Subarrays to use
C      BLIMIT   R(3)    (1) ignored, (2) uv max change
C   Outputs:
C      BLIMIT   R(3)    (1,2) unchanged, (3) number of channels to avg
C      IERR     I       Error code
C-----------------------------------------------------------------------
      CHARACTER UVDATA*(*)
      REAL      BLIMIT(3)
      INTEGER   NSUBA, SUBA(*), IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   LSUB, BCHAN, ECHAN, NCHAN, TYPE, DIM(7), BIF, EIF, NIF,
     *   I, II, J, ANROW, NUMORB, NOPCAL, NUMIF, ANFQID, IROW, NROW,
     *   NOSTA, MNTSTA
      CHARACTER ANTAB*32, CDUMMY, ANAME*8, TIMSYS*8, RDATE*8, XYZHAN*8,
     *   TFRAME*8, ANNAME*8, POLTYA*2, POLTYB*2
      DOUBLE PRECISION AX(MAXANT), AY(MAXANT), AZ(MAXANT), UVFREQ,
     *   FREQS(MAXCIF), FMAX, FNEXT, FINC, ARRAYC(3), GSTIA0, DEGPDY,
     *   SAFREQ, STAXYZ(3), ORBPRM(6), R, RMAX
      REAL      POLRXY(2), UT1UTC, DATUTC, STAXOF, DIAMAN,
     *   FWHMAN(MAXIF), POLAA, POLCA(MAXIF), POLAB, POLCB(MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
C-----------------------------------------------------------------------
C                                       channels
      CALL OGET (UVDATA, 'BCHAN', TYPE, DIM, IDUM, CDUMMY, IERR)
      BCHAN = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OGET (UVDATA, 'ECHAN', TYPE, DIM, IDUM, CDUMMY, IERR)
      ECHAN = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      NCHAN = ECHAN - BCHAN + 1
      CALL OGET (UVDATA, 'BIF', TYPE, DIM, IDUM, CDUMMY, IERR)
      BIF = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL OGET (UVDATA, 'EIF', TYPE, DIM, IDUM, CDUMMY, IERR)
      EIF = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      NIF = EIF - BIF + 1
C                                       frequencies
      UVFREQ = -1000.0D0
      CALL UVFRQS (UVDATA, UVFREQ, FREQS, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       find highest and next highest
      FMAX = 0.0
      II = NCHAN * NIF
      DO 10 I = 1,II
         IF (FREQS(I).GT.FMAX) THEN
            FNEXT = FMAX
            FMAX = FREQS(I)
            END IF
 10      CONTINUE
      FINC = FMAX - FNEXT
C                                       get antennas 1 subarray at at
C                                       time
      RMAX = 0.0D0
      DO 100 LSUB = 1,NSUBA
         CALL UV2TAB (UVDATA, ANTAB, 'AN', SUBA(LSUB), IERR)
         IF (IERR.NE.0) GO TO 990
         CALL OANINI (ANTAB, 'READ', ANROW, ARRAYC, GSTIA0, DEGPDY,
     *      SAFREQ, RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME,
     *      XYZHAN, TFRAME, NUMORB, NOPCAL, NUMIF, ANFQID, IERR)
         CALL TABGET (ANTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IERR)
         NROW = IDUM(1)
         IF (IERR.NE.0) GO TO 990
         II = 0
         DO 20 IROW = 1,NROW
            CALL OTABAN (ANTAB, 'READ', ANROW, ANNAME, STAXYZ, ORBPRM,
     *         NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN, POLTYA, POLAA,
     *         POLCA, POLTYB, POLAB, POLCB, IERR)
            IF (IERR.NE.0) GO TO 990
            IF ((STAXYZ(1).NE.0.0D0) .OR. (STAXYZ(2).NE.0.0D0) .OR.
     *         (STAXYZ(3).NE.0.0D0)) THEN
               II = II + 1
               AX(II) = STAXYZ(1)
               AY(II) = STAXYZ(2)
               AZ(II) = STAXYZ(3)
               END IF
 20         CONTINUE
         CALL OTABAN (ANTAB, 'CLOS', ANROW, ANNAME, STAXYZ, ORBPRM,
     *      NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN, POLTYA, POLAA,
     *      POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.NE.0) GO TO 990
         NROW = II
         DO 40 J = 1,NROW-1
            DO 30 I = J+1,NROW
               R = (AX(I)-AX(J))**2 + (AY(I)-AY(J))**2 +
     *            (AZ(I)-AZ(J))**2
               IF (R.GT.RMAX) RMAX = R
 30            CONTINUE
 40         CONTINUE
 100     CONTINUE
      RMAX = SQRT (RMAX)
C
      R = BLIMIT(2) * VELITE / (RMAX * FINC)
      WRITE (MSGTXT,1100) R
      CALL MSGWRT (4)
      J = R + 0.0001D0
      J = MIN (J, NCHAN)
      IF (J.GT.1) THEN
         IF ((NCHAN/J)*J.NE.NCHAN) THEN
            I = NCHAN/J
            II = ECHAN
            ECHAN = I * J + BCHAN - 1
            WRITE (MSGTXT,1105) II, ECHAN
            CALL MSGWRT (6)
            DIM(1) = 1
            DIM(2) = 1
            IDUM(1) = ECHAN
            CALL OPUT (UVDATA, 'ECHAN', OOAINT, DIM, IDUM, CDUMMY, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
         END IF
      BLIMIT(3) = J
      GO TO 999
C
 990  WRITE (MSGTXT,1990) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('FINDAV: recommends averaging every',F7.2,' channels')
 1105 FORMAT ('FINDAV: changing ECHAN from',I6,' to',I6)
 1990 FORMAT ('FINDAV: ERROR',I5,' FINDING MAXIMUM BASELINE =>',
     *   ' CHANNEL AVERAGING')
      END
      SUBROUTINE UWINDF (UNWIN, UNBOXS, NFIELD, IMSIZE, BOXFIL, IERR)
C-----------------------------------------------------------------------
C   Fills the UNWIN array with unclean box definitions taken from BOXFIL
C   Inputs:
C      BOXFIL   C*48        User provided file name containing box defs
C      NFIELD   I           Number of fields defined
C   In/Out:
C      UNWIN    I(4,*,*)    clean boxes - defaulted on in (4,FIELD,BOX)
C      UNBOXS   I*(*)       Array containing number of boxes/field
C   Outputs:
C      IERR     I           Error return code:
C                              0 => no error
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCLN.INC'
      CHARACTER BOXFIL*48
      INTEGER   NFIELD, UNWIN(4,NFIELD,*), UNBOXS(*)
      INTEGER   IMSIZE(2,*), IERR
C
      INTEGER   LUN, I, J, ISUBF(MXNBOX), IFIELD, FIND, IPARM(5), KBP,
     *   I1, I2, IDD, LIMIT
      CHARACTER LINE*132
      DOUBLE PRECISION X
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      LIMIT = MIN (MXNBOX, (4*MAXFLD) / MAX(1,NFIELD))
C                                        Open clean box file
      LUN = 11
      CALL ZTXOPN ('READ', LUN, FIND, BOXFIL, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN'
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                        Enter box parameters from file
      CALL FILL (MXNBOX, 0, ISUBF)
      IDD = 0
      DO 50 I = 1,100000
         CALL ZTXIO ('READ', LUN, FIND, LINE, IERR)
         IF (IERR.EQ.2) GO TO 60
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPEN'
            CALL MSGWRT (6)
            GO TO 999
            END IF
C                                       check for comments
         CALL CHTRIM (LINE, 132, LINE, J)
         IF ((LINE(:1).NE.'u') .AND. (LINE(:1).NE.'U')) GO TO 50
C                                       parse for 5 integers
C                                       field, blc, trc
         KBP = 2
         CALL FILL (5, 0, IPARM)
         DO 30 J = 1,5
            CALL GETNUM (LINE, 132, KBP, X)
            IF (X.EQ.DBLANK) THEN
               IF (J.EQ.1) GO TO 50
               WRITE (MSGTXT,1020) I, J
               CALL MSGWRT (6)
               IERR = 1
               GO TO 999
            ELSE
               IF (X.GE.0.0D0) THEN
                  IPARM(J) = X + 0.50D0
               ELSE
                  IPARM(J) = X - 0.50D0
                  END IF
               END IF
 30         CONTINUE
         IFIELD = IPARM(1)
         IF ((IFIELD.GE.1) .AND. (IFIELD.LE.NFIELD)) THEN
            IDD = IDD + 1
            ISUBF(IFIELD) = MAX (ISUBF(IFIELD),0) + 1
            IF (ISUBF(IFIELD).LE.LIMIT) THEN
               J = ISUBF(IFIELD)
C                                       circular
               IF (IPARM(2).LT.0) THEN
                  UNWIN(1,IFIELD,J) = -1
                  UNWIN(3,IFIELD,J) = MAX (1+IPARM(3), MIN (IPARM(4),
     *               IMSIZE(1,IFIELD)-IPARM(3)))
                  UNWIN(4,IFIELD,J) = MAX (1+IPARM(3), MIN (IPARM(5),
     *               IMSIZE(2,IFIELD)-IPARM(3)))
                  UNWIN(2,IFIELD,J) = IPARM(3)
C                                       rectangular
               ELSE IF (IPARM(2).GT.0) THEN
                  UNWIN(1,IFIELD,J) = MAX (1, MIN (IPARM(2),
     *               IMSIZE(1,IFIELD)))
                  UNWIN(3,IFIELD,J) = MAX (1, MIN (IPARM(4),
     *               IMSIZE(1,IFIELD)))
                  IF (UNWIN(3,IFIELD,J).LT.UNWIN(1,IFIELD,J)) THEN
                     I1 = UNWIN(3,IFIELD,J)
                     UNWIN(3,IFIELD,J) = UNWIN(1,IFIELD,J)
                     UNWIN(1,IFIELD,J) = I1
                     END IF
                  UNWIN(2,IFIELD,J) = MAX (1, MIN (IPARM(3),
     *               IMSIZE(2,IFIELD)))
                  UNWIN(4,IFIELD,J) = MAX (1, MIN (IPARM(5),
     *               IMSIZE(2,IFIELD)))
                  IF (UNWIN(4,IFIELD,J).LT.UNWIN(2,IFIELD,J)) THEN
                     I1 = UNWIN(4,IFIELD,J)
                     UNWIN(4,IFIELD,J) = UNWIN(2,IFIELD,J)
                     UNWIN(2,IFIELD,J) = I1
                     END IF
C                                       no boxes this field
               ELSE
                  IF (ISUBF(IFIELD).GT.1) THEN
                     WRITE (MSGTXT,1030) IFIELD
                     CALL MSGWRT (6)
                  ELSE
                     ISUBF(IFIELD) = -1
                     END IF
                  END IF
               END IF
            END IF
 50      CONTINUE
 60   DO 70 I = 1,NFIELD
         IF (ISUBF(I).LT.0) UNBOXS(I) = 0
         IF (ISUBF(I).GT.0) UNBOXS(I) = MIN (LIMIT, ISUBF(I))
         IF (ISUBF(I).GT.LIMIT) THEN
            WRITE (MSGTXT,1060) I, LIMIT, ISUBF(I)
            CALL MSGWRT (6)
            END IF
 70      CONTINUE
      CALL ZTXCLS (LUN, FIND, I)
      IERR = 0
C
      IF (IDD.GT.0) THEN
         MSGTXT = 'UWINDF: Number of UNClean boxes/field read' //
     *      ' as follows:'
         CALL MSGWRT (3)
         DO 80 J = 1,NFIELD,4
            I1 = J
            I2 = MIN (NFIELD, I1+3)
            WRITE (MSGTXT,1070) ('Fld', I, UNBOXS(I), I = I1,I2)
            CALL MSGWRT (3)
 80         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UWINDF: ERROR',I4,1X,A,'ING THE CLEAN BOXES TEXT FILE')
 1020 FORMAT ('UWINDF: PARSING ERROR ON LINE',I4,' FIELD',I5)
 1030 FORMAT ('UWINDF: FIELD',I5,' ZERO BOXES CODE IGNORED DUE TO',
     *   ' REAL BOXES READ')
 1060 FORMAT ('WARNING: FIELD',I5,' USED FIRST',I5,' OF',I6,
     *   ' BOXES IN FILE')
 1070 FORMAT (4(A3,I5.2,':',I5,2X))
      END

      SUBROUTINE TICINC (LAXIS, BLC, TRC, XYRATO, YX, DEGC, DEG, INOI,
     *   TICX, TICY, TICL, PT5SEC, ITRY, IERR)
C-----------------------------------------------------------------------
C! determines tick mark lengths and increments for CTICS, ...
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999-2003, 2012-2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TICINC figures out the tick mark lengths and increments.
C   Inputs:
C      LAXIS   I        1 => horizontal,  2 => vertical full plots
C                       3 => horiz subplot 4 => vertical subplot
C                       5 => top horizontal 6 => right vertical
C      BLC     R(2)     X and Y pixels to form bottom left hand
C                       corner of the graph.
C      TRC     R(2)     X and Y pixels to form the top right hand
C                       corner of the graph.
C      XYRATO  R        X to Y scaling factor
C   In/Out:
C      YX      D        3: plot x axis at y = YX; 4: plot y axis
C                       at x = YX - out range => BLC(1,2) value
C      DEG     D        Tick increment: input if LAXIS>4, else out
C   Outputs:
C      DEGC    D        Value at first tick
C      INOI    I        Number of ticks
C      TICX    D        Tick length in x units (if LAXIS < 5)
C      TICY    D        Tick length in y units (if LAXIS < 5)
C      TICL    R        Tick length in pixels. (if LAXIS < 5)
C      PT5SEC  D        value used in rounding coordinate values
C      ITRY    I        subscript in coordinate incr array
C      IERR    I        error code: 0 => ok
C                                  -1 => can't find an increment
C                                   1 => bad LAXIS
C                                   3 => tic algorithm fails
C-----------------------------------------------------------------------
      DOUBLE PRECISION YX, DEGC, DEG, TICX, TICY, PT5SEC
      REAL      BLC(2), TRC(2), XYRATO, TICL
      INTEGER   LAXIS, INOI, ITRY, IERR
C
      INTEGER   FINE
      PARAMETER (FINE=24)
C
      DOUBLE PRECISION DEGL, DEGU, DBX, DIV, DIFF, DTX, DX, DBY, DTY,
     *   DY, DZ, XINTER(35), DTZ, XINTR1(35), XINTR2(35), XINTR3(35),
     *   XINTR(35,3), XMAX, XMIN, YMAX, YMIN
      REAL      FRACT, PXT, PYT, X, Y
      INTEGER   IAXIS, AXISTP, IXT, IXTNO, I, ISGN, COOTYP, JERR, JJ, J
      LOGICAL   TRUBLE
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGPH.INC'
      EQUIVALENCE (XINTR(1,1), XINTR1(1))
      EQUIVALENCE (XINTR(1,2), XINTR2(1))
      EQUIVALENCE (XINTR(1,3), XINTR3(1))
C
      SAVE ISGN, AXISTP
C
      DATA XINTR1 /0.000001D0, 0.000002D0, 0.000005D0, 0.00001D0,
     *   0.00002D0, 0.00005D0, 0.0001D0, 0.0002D0, 0.0005D0, 0.001D0,
     *   0.002D0, 0.005D0, 0.01D0, 0.02D0, 0.05D0, 0.1D0, 0.2D0, 0.5D0,
     *   1.D0, 2.D0, 5.D0, 10.D0, 20.D0, 50.D0, 100.D0, 200.D0, 500.D0,
     *   1000.D0, 2000.D0, 5000.D0, 10000.D0, 20000.D0, 50000.D0,
     *   100000.D0, 100000.D0/
      DATA XINTR2 /0.000001D0, 0.000002D0, 0.000005D0, 0.00001D0,
     *   0.00002D0, 0.00005D0, 0.0001D0, 0.0002D0, 0.0005D0, 0.001D0,
     *   0.002D0, 0.005D0, 0.01D0, 0.02D0, 0.05D0, 0.1D0, 0.2D0, 0.5D0,
     *   1.D0, 2.D0, 5.D0, 15.D0, 30.D0, 60.D0, 120.D0, 300.D0, 600.D0,
     *   1800.D0, 3600.D0, 7200.D0, 18000.D0, 36000.D0, 72000.D0,
     *   180000.D0, 360000.D0/
      DATA XINTR3 /0.000001D0, 0.000002D0, 0.000005D0, 0.00001D0,
     *   0.00002D0, 0.00005D0, 0.0001D0, 0.0002D0, 0.0005D0, 0.001D0,
     *   0.002D0, 0.005D0, 0.01D0, 0.02D0, 0.05D0, 0.1D0, 0.2D0, 0.5D0,
     *   1.D0, 2.D0, 5.D0, 15.D0, 30.D0, 60.D0, 120.D0, 300.D0, 600.D0,
     *   1800.D0, 3600.D0, 7200.D0, 14400.D0, 28800.D0, 86400.D0,
     *   172800.D0, 345600.0D0/
C-----------------------------------------------------------------------
      CALL CHECKL ('TICINC')
      IAXIS = LAXIS
      TRUBLE = .FALSE.
      IF (LAXIS.GT.2) IAXIS = IAXIS - 2
      IF (LAXIS.GT.4) GO TO 200
C                                       Find value at BLC.
C                                       Determine axis type.
      IF (IAXIS.EQ.2) THEN
C                                       vertical
         YMAX = -1.E10
         YMIN = 1.E10
         FRACT = 1.0
         IF (GPHY1.NE.GPHY2) FRACT = ABS ((TRC(2) - BLC(2)) /
     *      (GPHY2 - GPHY1))
         FRACT = MAX (0.05, MIN (1.0, FRACT))
         TICY = 0.0
         DO 10 I = 1,FINE
            PXT = BLC(1) + (I-1.0)*(TRC(1)-BLC(1))/(FINE - 1.0)
            DO 5 J = 1,FINE
               PYT = BLC(2) + (J-1.0)*(TRC(2)-BLC(2))/(FINE - 1.0)
               CALL XYVAL (PXT, PYT, DX, DY, DZ, IERR)
               IF (IERR.EQ.0) THEN
                  YMAX = MAX (YMAX, DY)
                  YMIN = MIN (YMIN, DY)
                  END IF
 5             CONTINUE
 10         CONTINUE
         IF (YMAX.LT.YMIN) THEN
            IERR = 4
            GO TO 970
            END IF
         TICX = ABS ((TRC(1)-BLC(1) + (TRC(2)-BLC(2))/XYRATO) / 80.0)
         IF (TICX.LE.0.05) TICX = 3 * TICX
         TICL = TICX * 1.2
         TICX = ABS (AXINC(1,LOCNUM) * TICX)
         IF (AXINC(2,LOCNUM).GT.0) THEN
            ISGN = 1
            DEGU = YMAX
            DEGL = YMIN
         ELSE
            ISGN = -1
            DEGU = YMIN
            DEGL = YMAX
            END IF
         IXTNO = 28.0 * FRACT + 0.5
         IXTNO = MIN (11, MAX (4, IXTNO))
         AXISTP = LABTYP(LOCNUM) / 10
         IF ((MOD(AXISTP,2).EQ.1) .AND. (ABS(DEGU-DEGL).GT.340.)) IXTNO
     *      = 2 * IXTNO
         IF (LAXIS.GE.3) THEN
            CALL XYVAL (TRC(1), BLC(2), DX, DY, DZ, JERR)
            IF (JERR.NE.0) GO TO 30
            CALL XYVAL (BLC(1), BLC(2), DBX, DBY, DZ, JERR)
            IF (JERR.NE.0) GO TO 30
            IF ((DBX.GT.DX) .AND. ((YX.GT.DBX) .OR. (YX.LT.DX)))
     *         YX = DBX
            IF ((DBX.LT.DX) .AND. ((YX.LT.DBX) .OR. (YX.GT.DX)))
     *         YX = DBX
            END IF
C                                       horizontal
      ELSE
         XMAX = -1.E10
         XMIN = 1.E10
         TICX = 0.0
         DO 20 I = 1,FINE
            PXT = BLC(1) + (I-1.0)*(TRC(1)-BLC(1))/(FINE - 1.0)
            DO 15 J = 1,FINE
               PYT = BLC(2) + (J-1.0)*(TRC(2)-BLC(2))/(FINE - 1.0)
               CALL XYVAL (PXT, PYT, DX, DY, DZ, IERR)
               IF (IERR.EQ.0) THEN
                  XMAX = MAX (XMAX, DX)
                  XMIN = MIN (XMIN, DX)
                  END IF
 15             CONTINUE
 20         CONTINUE
         IF (XMAX.LT.XMIN) THEN
            IERR = 4
            GO TO 970
            END IF
         FRACT = 1.0
         IF (GPHX1.NE.GPHX2) FRACT = ABS ((TRC(1) - BLC(1)) /
     *      (GPHX2 - GPHX1))
         FRACT = MAX (0.05, MIN (1.0, FRACT))
         TICY = ABS (((TRC(1)-BLC(1))*XYRATO + TRC(2)-BLC(2)) / 80.0)
         IF (TICY.LE.0.05) TICY = 3.0 * TICY
         TICL = TICY * 1.2
         TICY = ABS (AXINC(2,LOCNUM) * TICY)
         IF (AXINC(1,LOCNUM).GT.0.0) THEN
            ISGN = -1
            DEGU = XMIN
            DEGL = XMAX
         ELSE
            ISGN = 1
            DEGU = XMAX
            DEGL = XMIN
            END IF
         IXTNO = 17.0 * FRACT + 0.5
         IXTNO = MIN (10, MAX (4, IXTNO))
         AXISTP = MOD (LABTYP(LOCNUM), 10)
         IF ((MOD(AXISTP,2).EQ.1) .AND. (ABS(DEGU-DEGL).GT.340.)) IXTNO
     *      = 2 * IXTNO
         IF (LAXIS.GE.3) THEN
            CALL XYVAL (BLC(1), TRC(2), DX, DY, DZ, JERR)
            IF (JERR.NE.0) GO TO 30
            CALL XYVAL (BLC(1), BLC(2), DBX, DBY, DZ, JERR)
            IF (JERR.NE.0) GO TO 30
            IF ((DBY.GT.DY) .AND. ((YX.GT.DBY) .OR. (YX.LT.DY)))
     *         YX = DBY
            IF ((DBY.LT.DY) .AND. ((YX.LT.DBY) .OR. (YX.GT.DY)))
     *         YX = DBY
            END IF
         END IF
C                                       Determine possible tic intervls
 30   CALL TICCOR (TICX, TICY)
      COOTYP = 2
      IF ((AXISTP.EQ.5) .OR. (AXISTP.GE.7)) COOTYP = 1
      DIV = 240.0D0
      IF (COOTYP.EQ.2) DIV = 3600.0D0
C                                       not RA or DEC types
      IF (AXISTP.EQ.0) THEN
         DIV = 1.0D0
         JJ = 1
      ELSE IF (COOTYP.EQ.2) THEN
         DIV = 3600.0D0
         JJ = 2
      ELSE
         DIV = 240.0D0
         JJ = 3
         END IF
      PT5SEC = .5D0 / DIV
      DO 100 I = 1,35
         XINTER(I) = XINTR(I,JJ) / DIV
 100     CONTINUE
C                                       Try different values.
 120  IXT = 2
 125  DO 130 ITRY = 1,35
         DEG = ISGN * XINTER(ITRY)
         DEGC = DINT(DEGU/DEG) * DEG
         IF (ISGN * DEGU.LT.0.0) DEGC = DEGC - DEG
         DIFF = ISGN * (DEGC - DEGL)
         IF (ABS(DIFF / XINTER(ITRY)).GT.32000.0) GO TO 130
            INOI = (DIFF / XINTER(ITRY)) + 1
            IF ((INOI.GT.IXT) .AND. (INOI.LE.IXTNO)) GO TO 140
 130     CONTINUE
      IF (IXT.NE.0) THEN
         IXT = 0
         IXTNO = IXTNO + 2
         GO TO 125
C                                       Tic mark algorithm failed.
      ELSE
         WRITE (MSGTXT,1130)
         CALL MSGWRT (6)
         IERR = -1
         GO TO 999
         END IF
C                                       check number of actual ticks
 140  JJ = ABS (MIN (DEGL,DEGU)) / XINTER(ITRY)
      IXT = ABS (MAX (DEGL,DEGU)) / XINTER(ITRY)
      IF (MIN(DEGL,DEGU).GT.0) THEN
         JJ = JJ + 1
      ELSE
         JJ = -JJ
         END IF
      IF (MAX(DEGL,DEGU).LT.0) IXT = -IXT - 1
      INOI = IXT - JJ + 1
      IF ((INOI.LE.1) .AND. (ITRY.GT.1)) THEN
         ITRY = ITRY - 1
         GO TO 140
         END IF
      DEG = ISGN * XINTER(ITRY)
      DEGC = DINT(DEGU/DEG) * DEG
      IF (ISGN * DEGU.LT.0.0) DEGC = DEGC - DEG
C                                       extend ? when bail out comp.
      IF (.NOT.TRUBLE) GO TO 190
      IF (LAXIS.GT.2) GO TO 190
 150  DY = DEGC + DEG
         DX = DY
         IF (LAXIS.EQ.2) CALL FNDX (BLC(1), DY, DX, JERR)
         IF (LAXIS.EQ.1) CALL FNDY (BLC(2), DX, DY, JERR)
         IF (JERR.NE.0) GO TO 160
         CALL XYPIX (DX, DY, X, Y, JERR)
         IF (JERR.NE.0) GO TO 160
         IF ((X.LT.BLC(1)-0.01) .OR. (X.GT.TRC(1)+0.01)) GO TO 160
         IF ((Y.LT.BLC(2)-0.01) .OR. (Y.GT.TRC(2)+0.01)) GO TO 160
            DEGC = DEGC + DEG
            INOI = INOI + 1
            GO TO 150
 160  DY = DEGC - INOI * DEG
         DX = DY
         IF (LAXIS.EQ.2) CALL FNDX (BLC(1), DY, DX, JERR)
         IF (LAXIS.EQ.1) CALL FNDY (BLC(2), DX, DY, JERR)
         IF (JERR.NE.0) GO TO 170
         CALL XYPIX (DX, DY, X, Y, JERR)
         IF (JERR.NE.0) GO TO 170
         IF ((X.LT.BLC(1)-0.01) .OR. (X.GT.TRC(1)+0.01)) GO TO 170
         IF ((Y.LT.BLC(2)-0.01) .OR. (Y.GT.TRC(2)+0.01)) GO TO 170
            INOI = INOI + 1
            GO TO 160
C                                       change increment?
 170  IF (INOI.LE.IXTNO) GO TO 190
         DEGU = DEGC
         DEGL = DEGC - DEG * (INOI-1)
         ITRY = ITRY + 1
         DEG = ISGN * XINTER(ITRY)
         DEGC = DINT(DEGU/DEG) * DEG
         IF (ISGN * DEGU.LT.0.0) DEGC = DEGC - DEG
         DIFF = ISGN * (DEGC - DEGL)
         INOI = (DIFF / XINTER(ITRY)) + 1
C                                       round off
 190  IF (AXISTP.GT.0) THEN
         IF (ITRY.LT.19) THEN
            PT5SEC = 0.0D0
         ELSE IF (ITRY.GT.28) THEN
            PT5SEC = XINTER(28)
         ELSE IF (ITRY.GT.23) THEN
            PT5SEC = XINTER(23)
         ELSE
            PT5SEC = XINTER(18)
            END IF
         END IF
      IERR = 0
      GO TO 999
C                                       Draw tics for other side.
C                                       Same intervals but not
C                                       necessarily same values.
 200  IF (LAXIS.EQ.5) GO TO 210
         IF (LAXIS.NE.6) GO TO 990
         CALL XYVAL (TRC(1), TRC(2), DBX, DBY, DZ, IERR)
         IF (IERR.EQ.0) CALL XYVAL (TRC(1), BLC(2), DX, DY, DZ, IERR)
         IF (IERR.EQ.0) GO TO 205
            PXT = (BLC(1) + TRC(1)) / 2.0
            CALL XYVAL (PXT, TRC(2), DBX, DBY, DZ, IERR)
            IF (IERR.EQ.0) CALL XYVAL (PXT, BLC(2), DX, DY, DZ, IERR)
            IF (IERR.EQ.0) GO TO 205
               PYT = (BLC(2) + TRC(2)) / 2.0
               CALL XYVAL (PXT, PYT, DX, DY, DZ, IERR)
               IF (IERR.NE.0) GO TO 970
               PYT = PYT + (TRC(2) - BLC(2)) / 10.0
               CALL XYVAL (PXT, PYT, DTX, DTY, DTZ, IERR)
               IF (IERR.NE.0) GO TO 970
               DBY = DY + 5.0D0 * (DTY - DY)
               DY = DY - 5.0D0 * (DTY - DY)
               TRUBLE = .TRUE.
 205     DEGL = DY
         DEGU = DBY
         GO TO 220
C                                       horizontal
 210  CONTINUE
         CALL XYVAL (TRC(1), TRC(2), DBX, DBY, DZ, IERR)
         IF (IERR.EQ.0) CALL XYVAL (BLC(1), TRC(2), DX, DY, DZ, IERR)
         IF (IERR.EQ.0) GO TO 215
            PYT = (BLC(2) + TRC(2)) / 2.0
            CALL XYVAL (TRC(1), PYT, DBX, DBY, DZ, IERR)
            IF (IERR.EQ.0) CALL XYVAL (BLC(1), PYT, DX, DY, DZ, IERR)
            IF (IERR.EQ.0) GO TO 215
               PXT = (BLC(1) + TRC(1)) / 2.0
               CALL XYVAL (PXT, PYT, DX, DY, DZ, IERR)
               IF (IERR.NE.0) GO TO 970
               PXT = PXT + (TRC(1) - BLC(1)) / 10.0
               CALL XYVAL (PXT, PYT, DTX, DTY, DTZ, IERR)
               IF (IERR.NE.0) GO TO 970
               DBX = DX + 5.0D0 * (DTX - DX)
               DX = DX - 5.0D0 * (DTX - DX)
               TRUBLE = .TRUE.
 215     DEGU = DX
         DEGL = DBX
 220  DEGC = DINT(DEGU/DEG) * DEG
      IF (ISGN * DEGU.LT.0.0) DEGC = DEGC - DEG
      DIFF = ISGN * (DEGC - DEGL)
      IF ((DIFF.LT.0.0D0) .AND. (AXISTP.GT.0)) DIFF = DIFF + 360.0
      INOI = (DIFF/ABS(DEG)) + 1
      IERR =0
      GO TO 999
C                                       Total position failure
 970  IERR = 3
      WRITE (MSGTXT,1970)
      CALL MSGWRT (7)
      GO TO 999
C                                       Invalid axis type.
 990  WRITE (MSGTXT,1990)
      CALL MSGWRT (8)
      IERR = 1
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1130 FORMAT ('TICINC: TIC MARK ALGORITHM FAILED! CONTINUING.')
 1970 FORMAT ('TICINC: POSITION ROUTINES FAIL ON THIS IMAGE')
 1990 FORMAT ('TICINC: INVALID AXIS TYPE.')
      END

      SUBROUTINE ALSASK (ALIST, KEYWRD, TYPE, DIM, IERR)
C-----------------------------------------------------------------------
C! Inquire about an entry in an Associative list (ALIST)
C# Utility 
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Public
C   Inquire about an entry in an Associative list (ALIST)
C   See ALSINI for details of the package.
C   Note the AIPS datatypes are defined as parameters in the INCLUDE
C   'INCS:PAOOF.INC': OOADP = double precision, OOARE = real, 
C   OOACAR = character, OOAINT = integer, and OOALOG = logical.
C   Inputs:
C      ALIST  I(*)  ALIST array
C      KEYWRD C*16  Keyword
C   Outputs:
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of value, an axis dimension of zero
C                    means that that dimension and higher are undefined.
C      IERR    I     Error code, 0=OK.  1=> didn't find.
C-----------------------------------------------------------------------
      INTEGER   ALIST(*), TYPE, DIM(*), IERR
      CHARACTER KEYWRD*(*)
C
      INTEGER   KEYPNT, NDIM, DATOFF
      CHARACTER ALNAME*32
      INCLUDE 'INCS:PALIST.INC'
C-----------------------------------------------------------------------
      IERR = 0
      NDIM = ALIST(ALSNDM)
      DATOFF = ALIST(ALSDAT)
C                                       Validity test
      IF (ALIST(ALSCHK).NE.ALSCVL) THEN
         MSGTXT = 'ALSASK: DAMAGED OR UNINITIALIZED ALIST'
         IERR = 6
         GO TO 990
         END IF
C                                       See if keyword is in the list
      CALL ALSKEY (ALIST, KEYWRD, KEYPNT, IERR)
      IF (IERR.NE.0) THEN
C                                       Didn't find
         IERR = 1
         GO TO 999
         END IF
C                                       Type
      TYPE = ALIST(KEYPNT+ALSTYP)
C                                       Dimensions
      CALL COPY (NDIM, ALIST(KEYPNT+ALSDIM), DIM)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
      MSGTXT = 'KEYWORD =' // KEYWRD
      CALL MSGWRT (6)
      CALL H2CHR (32, 1, ALIST(ALSNAM), ALNAME)
      MSGTXT = 'PROBLEM WITH ALIST: ' // ALNAME
      CALL MSGWRT (6)
C
 999  RETURN
      END

      SUBROUTINE TABOB (OPCODE, BUFFER, IOBRNO, OBKOLS, OBNUMV,
     *   IANTOB, ISUBOB, DTIMOB, DXYZOB, DVELOB, ANGLOB, ECLPOB,
     *   ORIOB, IERR)
C----------------------------------------------------------------------
C! I/O to spacecraft orbit tables (following init. by OBINI)
C# EXT-appl
C----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2007, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C----------------------------------------------------------------------
C   Does I/O to spacecraft orbit tables. Usually used after setup
C   by OBINI.
C   Inputs:
C      OPCODE       C*4         Operation code:
C                               'READ' = read entry from table
C                               'WRIT' = write entry in table
C                               'CLOS' = close file, flush on write
C      BUFFER       I(*)        I/O buffer and related storage, also
C                               defines file if open. Should have
C                               been returned by OBINI.
C      OBKOLS       I(MAXOBC)   The column pointer array in order:
C                               ANTENNA NO, SUBARRAY, TIME,
C                               ORBXYZ, VELXYZ, SUN ANGLE, ECLIPSE,
C                               ORIENTATION
C      OBNUMV       I(MAXOBC)   Element count in each column
C   Input/output:
C      IOBRNO       I           Next row to read or write
C      IANTOB       I           Antenna number
C      ISUBOB       I           Subarray number
C      DTIMOB       D           Time (days wrt reference day)
C      DXYZOB       D(3)        Spacecraft position (x, y, z)
C      DVELOB       D(3)        Spacecraft velocity (vx, vy, vz)
C      ANGLOB       R(3)        Sun angle (deg)
C      ECLPOB       R(4)        Eclipse times (days wrt ref. day)
C      ORIOB        R           Orientation (deg)
C   Output:
C      IERR         I           Return code (0=>ok; else error)
C                               Note: -1 => read by not selected
C----------------------------------------------------------------------
      INCLUDE 'INCS:POBV.INC'
      CHARACTER OPCODE*4
      DOUBLE PRECISION DXYZOB(3), DVELOB(3), DTIMOB
      REAL      ANGLOB(3), ECLPOB(4), ORIOB
      INTEGER   BUFFER(512), IOBRNO, OBKOLS(MAXOBC), OBNUMV(MAXOBC),
     *   IANTOB, ISUBOB, IERR
C
      INCLUDE 'INCS:DMSG.INC'
      LOGICAL   DOREAD, DOCLOS
      DOUBLE PRECISION RECD(MXDPOB)
      REAL      RECORD(MXSPOB)
      INTEGER   RECI(MXSPOB)
      EQUIVALENCE (RECD, RECORD, RECI)
C----------------------------------------------------------------------
C                                       Initialization
      IERR = 0
C                                       Check OPCODE
      DOREAD = (OPCODE.EQ.'READ')
      DOCLOS = (OPCODE.EQ.'CLOS')
C                                       Branch for CLOS
      IF (DOCLOS) GO TO 800
C                                       If write fill RECORD
      IF (.NOT.DOREAD) THEN
C                                       Antenna number
         RECI(OBKOLS(OBIANT)) = IANTOB
C                                       Subarray number
         RECI(OBKOLS(OBISUB)) = ISUBOB
C                                       Time
         RECD(OBKOLS(OBDTIM)) = DTIMOB
C                                       Spacecraft position, velocity
C                                       and sun angle.
         CALL DPCOPY (OBNUMV(OBDPOS), DXYZOB, RECD(OBKOLS(OBDPOS)))
         CALL DPCOPY (OBNUMV(OBDVEL), DVELOB, RECD(OBKOLS(OBDVEL)))
         CALL RCOPY (OBNUMV(OBRANG), ANGLOB, RECORD(OBKOLS(OBRANG)))
C                                       Eclipse tags
         CALL RCOPY (OBNUMV(OBRECL), ECLPOB, RECORD(OBKOLS(OBRECL)))
C                                       Spacecraft orientation
         RECORD(OBKOLS(OBRORI)) = ORIOB
         END IF
C                                       Process record
200   CALL TABIO (OPCODE, 0, IOBRNO, RECORD, BUFFER, IERR)
      IOBRNO = IOBRNO + 1
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABIO', 'TABOB', IERR)
         GO TO 999
         END IF
C                                       If READ pick data from record
      IF (DOREAD) THEN
C                                       Antenna number
         IANTOB = RECI(OBKOLS(OBIANT))
C                                       Subarray number
         ISUBOB = RECI(OBKOLS(OBISUB))
C                                       Time
         DTIMOB = RECD(OBKOLS(OBDTIM))
C                                       Spacecraft position, velocity
C                                       and sun angle
         CALL DPCOPY (OBNUMV(OBDPOS), RECD(OBKOLS(OBDPOS)), DXYZOB)
         CALL DPCOPY (OBNUMV(OBDVEL), RECD(OBKOLS(OBDVEL)), DVELOB)
         CALL RCOPY (OBNUMV(OBRANG), RECORD(OBKOLS(OBRANG)), ANGLOB)
C                                       Eclipse tags
         CALL RCOPY (OBNUMV(OBRECL), RECORD(OBKOLS(OBRECL)), ECLPOB)
C                                       Spacecraft orientation
         ORIOB = RECORD(OBKOLS(OBRORI))
         END IF
      GO TO 999
C                                       Close
800   CALL TABIO ('CLOS', 0, IOBRNO, RECORD, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'TABOB', IERR)
         GO TO 999
         END IF
      GO TO 999
C                                       Exit
999   RETURN
      END

C   History Utility module
C-----------------------------------------------------------------------
C! Object Oriented AIPS Fortran history utility routines
C# History Utility Object-Oriented
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2008, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This module contains routines which can be used to manipulate
C   histories associated with objects that are disk resident.
C   Available functions are:
C
C   OHCOPY (in, out, iret)
C      Copies the history from object in the object out.  iret=0
C      indicates success. - also KEYCOP
C   OHWRIT (entry, out, iret)
C      Writes up to 66 characters from character string entry to the
C      history associated with object out.  Task name is prepended.
C   OHLIST (in, list, nlist, out, iret)
C      Writes the names and values of the members of object in specified
C      by the first nlist elements in the character string array list to
C      the history associated with object out.  iret=0 indicates
C      success.
C   OHTIME (out, iret)
C      Adds task name and time and date stamp to history associated with
C      object out.  iret=0 indicates success.  Assures that a history
C      file exists.
C-----------------------------------------------------------------------
      SUBROUTINE OHCOPY (IN, OUT, IRET)
C-----------------------------------------------------------------------
C   Copies the history from object in the object out.
C   If the underlying files are the same then no copy is made.
C   Inputs:
C      IN     C*?  Input object name.
C      OUT    C*?  Output object name.
C   Output:
C      IRET   I    Return code, 0=OK else an error occurred.
C-----------------------------------------------------------------------
      CHARACTER IN*(*), OUT*(*)
      INTEGER   IRET
C
      INTEGER   DISKI, DISKO, CNOI, CNOO, LUNI, LUNO, BUFNOI, BUFNOO,
     *   CAT(256), IERR, MSGSAV
      LOGICAL   NOCOPY
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Open objects and get info.
      CALL OBOPEN (IN, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Which buffer
      CALL OBINFO (IN, BUFNOI, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       DISK, CNO
      CALL OBDSKC (IN, DISKI, CNOI, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       LUN
      CALL OBLUN (LUNI, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Output
      CALL OBOPEN (OUT, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Which buffer
      CALL OBINFO (OUT, BUFNOO, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       DISK, CNO
      CALL OBDSKC (OUT, DISKO, CNOO, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       LUN
      CALL OBLUN (LUNO, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Sync header
      CALL OBCSYN (OUT, IERR)
      IF (IRET.NE.0) GO TO 990
C                                       Catalog header
      CALL OBHGET (OUT, CAT, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Initialize history routines
      CALL HIINIT (3)
C                                       Don't do copy it the two have
C                                       the same underlying files.
      NOCOPY = (DISKI.EQ.DISKO) .AND. (CNOI.EQ.CNOO)
C                                       Don't copy if output file exists
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL HIOPEN (LUNO, DISKO, CNOO, OBUFFR(1,BUFNOO), IERR)
      NOCOPY = NOCOPY .OR. (IERR.EQ.0)
      IF (IERR.EQ.0) CALL HICLOS (LUNO, .FALSE., OBUFFR(1,BUFNOO), IERR)
      MSGSUP = MSGSAV
C                                       Don't copy if input file doesn't
C                                       exist
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL HIOPEN (LUNI, DISKI, CNOI, OBUFFR(1,BUFNOI), IERR)
      NOCOPY = NOCOPY .OR. (IERR.NE.0)
      IF (IERR.EQ.0) CALL HICLOS (LUNI, .FALSE., OBUFFR(1,BUFNOI), IERR)
      MSGSUP = MSGSAV
C                                       Copy history
      IF (.NOT.NOCOPY) THEN
C                                       copy keywords too
         CALL KEYPCP (DISKI, CNOI, DISKO, CNOO, 0, ' ', IRET)
         IRET = 0
C                                       now copy HI
         CALL HISCOP (LUNI, LUNO, DISKI, DISKO, CNOI, CNOO, CAT,
     *      OBUFFR(1,BUFNOI), OBUFFR(1,BUFNOO), IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Close
         CALL HICLOS (LUNO, .TRUE., OBUFFR(1,BUFNOO), IRET)
         IF (IERR.NE.0) IRET = IERR
C                                       Update Catalog header
         CALL OBHPUT (OUT, CAT, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
C                                       Free LUNs
      CALL OBLUFR (LUNI)
      CALL OBLUFR (LUNO)
C                                       Close objects
      CALL OBCLOS (IN, IRET)
      IF (IRET.NE.0) GO TO 990
      CALL OBCLOS (OUT, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Put time label if no copy was
C                                       made.
      IF (NOCOPY) THEN
         CALL OHTIME (OUT, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR COPYING HISTORY'
      CALL  MSGWRT (6)
C
 999  RETURN
      END
      SUBROUTINE OHWRIT (ENTRY, OUT, IRET)
C-----------------------------------------------------------------------
C   Writes up to 65-72 characters from character string entry to the
C   history associated ith object out.  Task name is prepended if it is
C   not at the start of ENTRY.
C   Inputs:
C      ENTRY  C*?   Text of history entry; comments should begin with a
C                   "/" .  Up to 65-72 characters used.
C      OUT    C*?   Output object name.
C   Output:
C      IRET   I     Return code, 0=OK else an error occurred.
C-----------------------------------------------------------------------
      CHARACTER ENTRY*(*), OUT*(*)
      INTEGER   IRET
C
      INTEGER   DISKO, CNOO, LUNO, BUFNOO, IERR
      CHARACTER HILINE*72
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Output
      CALL OBOPEN (OUT, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Which buffer
      CALL OBINFO (OUT, BUFNOO, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       DISK, CNO
      CALL OBDSKC (OUT, DISKO, CNOO, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       LUN
      CALL OBLUN (LUNO, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Initialize history routines
      CALL HIINIT (3)
C                                       Copy history
      CALL HIOPEN (LUNO, DISKO, CNOO, OBUFFR(1,BUFNOO), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Add entry
      IF (TSKNAM.EQ.ENTRY(:6)) THEN
         HILINE = ENTRY
      ELSE IF (TSKNAM(6:6).EQ.' ') THEN
         HILINE = TSKNAM // ENTRY
      ELSE
         HILINE = TSKNAM // ' ' // ENTRY
         END IF
      CALL HIADD (LUNO, HILINE, OBUFFR(1,BUFNOO), IERR)
C                                       Close
      CALL HICLOS (LUNO, .TRUE., OBUFFR(1,BUFNOO), IRET)
      IF (IERR.NE.0) IRET = IERR
C                                       Free LUN
      CALL OBLUFR (LUNO)
C                                       Close objects
      CALL OBCLOS (OUT, IRET)
      IF (IRET.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // OUT
      CALL  MSGWRT (6)
C
 999  RETURN
      END
      SUBROUTINE OHLIST (IN, LIST, NLIST, OUT, IRET)
C-----------------------------------------------------------------------
C   Writes the names and values of the members of object in specified
C   by the first nlist elements in the character string array list to
C   the history associated with object out.
C   Inputs:
C      IN     C*?     Input object name.
C      LIST   C(?)*?  List of members of input object IN to copy to
C                     history of object OUT.
C      NLIST  I       Number of elements in LIST
C      OUT    C*?     Output object name.
C   Output:
C      IRET   I       Return code, 0=OK else an error occurred.
C-----------------------------------------------------------------------
      INTEGER   NLIST, IRET
      CHARACTER IN*(*), LIST(NLIST)*(*), OUT*(*)
C
      INTEGER   DISKO, CNOO, LUNO, BUFNOO, TYPE, DIM(7), I, ND1, ND2,
     *   ID1, ID2, IVAL(500), L, LC, INDEX, IC1, IC2, IERR, ITRIM, ILVAL
      REAL      RVAL(500)
      LOGICAL   BLNKED, LVAL(500)
      DOUBLE PRECISION DVAL(250)
      CHARACTER HILINE*72, LINE*120, CVAL*1000, CS*72
      EQUIVALENCE (IVAL, LVAL, RVAL, DVAL)
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Output
      CALL OBOPEN (OUT, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Which buffer
      CALL OBINFO (OUT, BUFNOO, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       DISK, CNO
      CALL OBDSKC (OUT, DISKO, CNOO, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       LUN
      CALL OBLUN (LUNO, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Initialize history routines
      CALL HIINIT (3)
C                                       Copy history
      CALL HIOPEN (LUNO, DISKO, CNOO, OBUFFR(1,BUFNOO), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Add entries
      DO 100 I = 1,NLIST
C                                       Fetch entry
         CALL OGET (IN, LIST(I), TYPE, DIM, IVAL, CVAL, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       Member name length
         L = ITRIM (LIST(I))
C                                       Get dimensionality
         ND1 = MAX (1, DIM(1))
         ND2 = MAX (1, DIM(2))
C                                       Characters are slightly
C                                       different.
         IF (TYPE.EQ.OOACAR) THEN
            ND1 = MAX (1, DIM(2))
            ND2 = MAX (1, DIM(3))
            END IF
         DO 50 ID2 = 1,ND2
            DO 40 ID1 = 1,ND1
               LINE = ' '
               INDEX = ID1 + (ID2-1) * ND1
C                                       Process by data type
C                                       Double precision
               IF (TYPE.EQ.OOADP) THEN
C                                       Don't write zeros.
                  BLNKED = ABS (DVAL(INDEX)) .LT. 1.0E-30
C                                       Get proper dimensionality
                  IF (ND2.GT.1) THEN
                     WRITE (LINE,1000) LIST(I)(1:L), ID1, ID2,
     *                  DVAL(INDEX)
                  ELSE IF (ND1.GT.1) THEN
                     WRITE (LINE,1001) LIST(I)(1:L), ID1, DVAL(INDEX)
                  ELSE
                     WRITE (LINE,1002) LIST(I)(1:L), DVAL(INDEX)
                     END IF
C                                       Real
               ELSE IF (TYPE.EQ.OOARE) THEN
C                                       Don't write zeros.
                  BLNKED = ABS (RVAL(INDEX)) .LT. 1.0E-30
C                                       Get proper dimensionality
                  IF (ND2.GT.1) THEN
                     WRITE (LINE,1003) LIST(I)(1:L), ID1, ID2,
     *                  RVAL(INDEX)
                  ELSE IF (ND1.GT.1) THEN
                     WRITE (LINE,1004) LIST(I)(1:L), ID1, RVAL(INDEX)
                  ELSE
                     WRITE (LINE,1005) LIST(I)(1:L), RVAL(INDEX)
                     END IF
C                                       Character
               ELSE IF (TYPE.EQ.OOACAR) THEN
                  IC1 = 1 + (INDEX-1) * DIM(1)
                  IC2 = IC1 + DIM(1) - 1
                  CS = CVAL(IC1:IC2)
C                                       Do not write blanks
                  BLNKED = CS .EQ. ' '
                  LC = ITRIM (CS)
C                                       Get proper dimensionality
                  IF (ND2.GT.1) THEN
                     WRITE (LINE,1006) LIST(I)(1:L), ID1, ID2, CS(1:LC)
                  ELSE IF (ND1.GT.1) THEN
                     WRITE (LINE,1007) LIST(I)(1:L), ID1, CS(1:LC)
                  ELSE
                     WRITE (LINE,1008) LIST(I)(1:L), CS(1:LC)
                     END IF
C                                       Integer
               ELSE IF (TYPE.EQ.OOAINT) THEN
C                                       Do not write zeros.
                  BLNKED = IVAL(INDEX) .EQ. 0
C                                       Get proper dimensionality
                  IF (ND2.GT.1) THEN
                     WRITE (LINE,1009) LIST(I)(1:L), ID1, ID2,
     *                  IVAL(INDEX)
                  ELSE IF (ND1.GT.1) THEN
                     WRITE (LINE,1010) LIST(I)(1:L), ID1, IVAL(INDEX)
                  ELSE
                     WRITE (LINE,1011) LIST(I)(1:L), IVAL(INDEX)
                     END IF
C                                       Logical
               ELSE IF (TYPE.EQ.OOALOG) THEN
                  BLNKED = .FALSE.
C                                       Convert to POPS true/false
                  IF (LVAL(INDEX)) THEN
                     ILVAL = 1
                  ELSE
                     ILVAL = -1
                     END IF
C                                       Get proper dimensionality
                  IF (ND2.GT.1) THEN
                     WRITE (LINE,1009) LIST(I)(1:L), ID1, ID2,
     *                  ILVAL
                  ELSE IF (ND1.GT.1) THEN
                     WRITE (LINE,1010) LIST(I)(1:L), ID1, ILVAL
                  ELSE
                     WRITE (LINE,1011) LIST(I)(1:L), ILVAL
                     END IF
C                                       Unknown skip
               ELSE
                  BLNKED = .TRUE.
                  END IF
               IF (.NOT.BLNKED) THEN
                  IF (TSKNAM(6:6).EQ.' ') THEN
                     HILINE = TSKNAM // LINE(:66)
                  ELSE
                     HILINE = TSKNAM // ' ' // LINE(:65)
                     END IF
                  CALL HIADD (LUNO, HILINE, OBUFFR(1,BUFNOO), IERR)
                  IF (IERR.NE.0) GO TO 200
                  END IF
 40            CONTINUE
 50         CONTINUE
 100     CONTINUE
C                                       Close
 200  CALL HICLOS (LUNO, .TRUE., OBUFFR(1,BUFNOO), IRET)
      IF (IERR.NE.0) IRET = IERR
C                                       Free LUN
      CALL OBLUFR (LUNO)
C                                       Close objects
      CALL OBCLOS (OUT, IRET)
      IF (IRET.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // OUT
      CALL  MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A,'(',I3,',',I3,') =', 1PD20.10)
 1001 FORMAT (A,'(',I3,') =', 1PD20.10)
 1002 FORMAT (A,' =', 1PD20.10)
 1003 FORMAT (A,'(',I3,',',I3,') =', 1PE12.5)
 1004 FORMAT (A,'(',I3,') =', 1PE12.5)
 1005 FORMAT (A,' =', 1PE12.5)
 1006 FORMAT (A,'(',I3,',',I3,') =''',A,'''')
 1007 FORMAT (A,'(',I3,') =''',A,'''')
 1008 FORMAT (A,' =''',A,'''')
 1009 FORMAT (A,'(',I3,',',I3,') =', I8)
 1010 FORMAT (A,'(',I3,') =', I8)
 1011 FORMAT (A,' =', I8)
      END
      SUBROUTINE OHTIME (OUT, IRET)
C-----------------------------------------------------------------------
C   Adds task name and time and date stamp to history associated with
C   object out.  Assures that a history file exists.
C   Inputs:
C      OUT    C*?   Output object name.
C   Output:
C      IRET   I     Return code, 0=OK else an error occurred.
C-----------------------------------------------------------------------
      CHARACTER OUT*(*)
      INTEGER   IRET
C
      INTEGER   DISKO, CNOO, LUNO, BUFNOO, IERR, CAT(256), MSGSAV,
     *   TIME(3), DATE(3)
      CHARACTER HILINE*72, CTIME*8, CDATE*12
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Output
      CALL OBOPEN (OUT, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Which buffer
      CALL OBINFO (OUT, BUFNOO, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       DISK, CNO
      CALL OBDSKC (OUT, DISKO, CNOO, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       LUN
      CALL OBLUN (LUNO, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Sync header
      CALL OBCSYN (OUT, IERR)
      IF (IRET.NE.0) GO TO 990
C                                       Catalog header
      CALL OBHGET (OUT, CAT, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Initialize history routines
      CALL HIINIT (3)
C                                       Open/create history - suppress
C                                       warning messages.
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL HICREA (LUNO, DISKO, CNOO, CAT, OBUFFR(1,BUFNOO), IRET)
      MSGSUP = MSGSAV
      IF (IRET.NE.0) GO TO 990
C                                       Write time and date
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME, CDATE)
      WRITE (HILINE,1100) TSKNAM, RLSNAM, CDATE, CTIME
      CALL HIADD (LUNO, HILINE, OBUFFR(1,BUFNOO), IERR)
C                                       Close
      CALL HICLOS (LUNO, .TRUE., OBUFFR(1,BUFNOO), IRET)
      IF (IERR.NE.0) IRET = IERR
C                                       Save catalog header in case HI
C                                       file created.
      CALL OBHPUT (OUT, CAT, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Free LUN
      CALL OBLUFR (LUNO)
C                                       Close objects
      CALL OBCLOS (OUT, IRET)
      IF (IRET.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // OUT
      CALL  MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',A12,2X,A8)
      END

      SUBROUTINE ICSORT (A, LEN, N, KEY1, KEY2, IERR)
C-----------------------------------------------------------------------
C! Two key in memory sort by one of several methods
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2008-2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ICSORT does an incore two key sort of data into descending order.
C   The method used depends on LEN and the success of a previously
C   attempted method.
C   Input:
C      LEN     I          Length of record in words.
C      N       I          Number of records.
C      KEY1    I          Location of slower varying key in record
C      KEY2    I          Location of faster varying key in record
C   In/out:
C      A       R(LEN,N)   Data array to be sorted.
C   Output:
C      IERR    I          Return code: 0 = OK
C                            1 = Bad input
C                            2 = exceeds internal buffer
C-----------------------------------------------------------------------
      INTEGER   LEN, N, KEY1, KEY2, IERR
      REAL      A(LEN,N)
C
      INTEGER   JERR, IP(204802), NP2
      REAL      WK(2,204802)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Check that input OK.
      IERR = 0
      IF ((LEN.LE.0) .OR. (N.LE.0) .OR. (KEY1.GT.LEN) .OR.
     *   (KEY2.GT.LEN)) IERR = 1
      IF ((KEY1.LT.0) .OR. (KEY2.LT.0)) IERR = 1
      IF (N.GT.204800) IERR = 2
      IF (IERR.NE.0) GO TO 999
C                                       If N = 1 return
      IF (N.LE.1) GO TO 999
      NP2 = N + 2
C                                       Check if long record, if so
C                                       use min. switch method.
C                                       Try quick sort
      IF (LEN.GT.2048) GO TO 100
         CALL OSORT (A, N, NP2, KEY1, KEY2, LEN, WK, IP, JERR)
         IF (JERR.EQ.0) GO TO 999
            WRITE (MSGTXT,1000) JERR
            CALL MSGWRT (6)
C                                       Try shell sort
            CALL SHSORT (A, N, KEY1, KEY2, LEN, JERR)
            IF (JERR.EQ.0) GO TO 999
               WRITE (MSGTXT,1001) JERR
               CALL MSGWRT (6)
C                                       Long record sort.
 100     CALL LSORT (A, N, KEY1, KEY2, LEN)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ICSORT: QUICK SORT ERROR',I3,' TRY SHELL SORT')
 1001 FORMAT ('ICSORT: SHELL SORT ERROR',I3,' TRY LONG SORT')
      END

      SUBROUTINE UVCREA (IVOL, CNO, WBUFF, IERR)
C-----------------------------------------------------------------------
C! create and catalog a uv data base file
C# UV-util Catalog
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Subroutine to create a uv file using the parameters in a CATBLK.
C   The file will be cataloged and marked with WRITE status.  The image
C   name parameters must be filled in except that the physical type is
C   converted to 'UV'.  The OUTSEQ default is applied (0 => highest
C   matching+1).  The name must be unique ignoring the physical type.
C   The extension file areas of the CATBLK are cleared and the
C   "DATE-MAP" string is filled in.
C   In/Outs:
C      IVOL      I        Volume # on which to put file.  0 => any
C                         on output is volume used (IERR = 0)
C   Outputs:
C      WBUFF     I(256)   Working buffer
C      CNO       I        Catalog slot number
C      IERR      I        Error code; 0 => o.k.
C                                     1 => couldnt create,no room
C                                     2 => no create, duplicate name
C                                     3 => no room in catalog
C                                     4 => i/o problem on catalog
C                                     5 => Other Create errors
C                                     6 => No catalog file on disk
C                                     7 => no create, duplicate name on
C                                          another disk (IVOL > 0)
C   COMMON: /MAPHDR/ catalog block used a lot, final seq # on output
C-----------------------------------------------------------------------
      INTEGER   IVOL, CNO, WBUFF(256), IERR
C
      CHARACTER STAT*4, CTEXT*8, PNAME*48, NAME*12, CLASS*6,
     *   TYPTMP*2
      INTEGER   IER, SEQNO, SNO, J, I, ID(3), ITEMP, LREC, ASIZE, SIZE
      LOGICAL   T, LVOL, IAMOK
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DDRC.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Expand name and class.
      SEQNO = CATBLK(KIIMS)
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), NAME)
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), CLASS)
      CALL CHR2H (2, 'UV', KHPTYO, CATH(KHPTY))
      LVOL = IVOL.LE.0
      IF (LVOL) IVOL = NVOL
C                                       Check for default seqno
      IF (SEQNO.GT.0) GO TO 10
         SNO = 0
         ITEMP = 0
         CNO = 1
         TYPTMP = ' '
         CALL CATDIR ('SRCH', ITEMP, CNO, NAME, CLASS, SNO, TYPTMP,
     *      CATBLK(KIIMU), STAT, WBUFF, IER)
         IF ((IER.GT.0) .AND. (IER.NE.5)) GO TO 25
         SEQNO = SNO + 1
         IF (IER.EQ.5) SEQNO = 1
C                                       Is user name unique?
 10   IERR = 0
      IF (DSKLOK(IVOL).EQ.1) THEN
         IF (LVOL) THEN
            IVOL = IVOL - 1
            IF (IVOL.GT.0) GO TO 10
            END IF
         IERR = 5
         MSGTXT = 'UVCREA: CANNOT CREATE ON READ-ONLY FILE SYSTEM'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      SNO = SEQNO
      CNO = 1
      TYPTMP = ' '
      ITEMP = 0
      CALL CATDIR ('SRNN', ITEMP, CNO, NAME, CLASS, SNO, TYPTMP,
     *   CATBLK(KIIMU), STAT, WBUFF, IER)
      IF (IER.EQ.5) GO TO 20
      IF (IER.NE.0) GO TO 15
         IF ((IVOL.LE.0) .OR. (IVOL.EQ.ITEMP)) THEN
            IERR = 2
            WRITE (MSGTXT,1010) NAME, CLASS, SNO
            CALL MSGWRT (7)
            GO TO 999
         ELSE
            IERR = 7
            WRITE (MSGTXT,1011) NAME, CLASS, SNO, ITEMP
            END IF
         GO TO 980
C                                       missing catalog
 15   IF (IER.NE.1) GO TO 25
         IERR = 6
         IF (LVOL) GO TO 975
         IERR = 0
C                                       Allowed?
 20   IF (.NOT.IAMOK(IVOL,'UV')) THEN
         IERR = 1
         IF ((LVOL) .AND. (IVOL.GT.1)) GO TO 975
         WRITE (MSGTXT,1020) NAME, CLASS, SNO, IVOL
         GO TO 980
         END IF
C                                       create catalog slot
      CNO = 1
      CATBLK(KIIMS) = SNO
      TYPTMP = 'UV'
      CALL CATDIR ('OPEN', IVOL, CNO, NAME, CLASS, SNO, TYPTMP,
     *   CATBLK(KIIMU), STAT, WBUFF, IER)
      IF (IER.EQ.0) GO TO 30
C                                       missing catalog
         IF (IER.NE.1) GO TO 22
            IERR = 6
            GO TO 975
C                                       No room in catalog
 22      IF (IER.NE.5) GO TO 25
            WRITE (MSGTXT,1022) IVOL
            IERR = 3
            GO TO 980
C                                       I/O error in catalog
 25      CONTINUE
            WRITE (MSGTXT,1025) IER
            IERR = 4
            GO TO 980
C                                       Clear extension file area
 30   CALL CATCLR (CATBLK)
C                                       Update DATE-MAP area
      CALL ZDATE (ID)
      WRITE (CTEXT,1030) ID(1), ID(2), ID(3)
      CALL CHR2H (8, CTEXT, 1, CATH(KHDMP))
C                                       Put header into catalog
      CALL CATIO ('UPDT', IVOL, CNO, CATBLK, 'REST', WBUFF, IER)
      IF (IER.EQ.0) GO TO 40
         IERR = 4
         WRITE (MSGTXT,1031) IER
         CALL MSGWRT (8)
         GO TO 970
C                                       Generate physical name
 40   CALL ZPHFIL ('UV', IVOL, CNO, 1, PNAME, IER)
C                                       Figure out how big
      LREC = 1
      J = CATBLK(KIDIM)
      DO 45 I = 1,J
         LREC = LREC * CATBLK(KINAX+I-1)
 45      CONTINUE
      LREC = LREC + CATBLK(KIPCN)
      CALL UVSIZE (LREC, CATBLK(KIGCN), SIZE)
C                                      Create the file
      CALL ZCREAT (IVOL, PNAME, SIZE, T, ASIZE, IER)
      IF (IER.EQ.0) THEN
         WRITE (MSGTXT,1040) NAME, CLASS, SNO, IVOL, CNO
         CALL MSGWRT (2)
         GO TO 999
      ELSE
         IERR = 1
         IF ((IER.NE.3) .AND. (IER.NE.5)) IERR = 5
         IF ((.NOT.LVOL) .OR. (IERR.NE.1) .OR. (IVOL.LE.1)) THEN
            WRITE (MSGTXT,1050) IER, NAME, CLASS, SNO
            IF (IER.EQ.3) WRITE (MSGTXT,1051) NAME, CLASS, SNO
            IF (IER.EQ.5) WRITE (MSGTXT,1020) NAME, CLASS, SNO, IVOL
            CALL MSGWRT (8)
            END IF
         END IF
C                                       Errors:
C                                       Clear write status.
 970  TYPTMP = 'UV'
      CALL CATDIR ('CSTA', IVOL, CNO, NAME, CLASS, SNO, TYPTMP,
     *   CATBLK(KIIMU), 'CLWR', WBUFF, IER)
C                                       Clear catalog block
      TYPTMP = 'UV'
      CALL CATDIR ('CLOS', IVOL, CNO, NAME, CLASS, SNO, TYPTMP,
     *   CATBLK(KIIMU), STAT, WBUFF, IER)
 975  IF ((.NOT.LVOL) .OR. ((IERR.NE.1) .AND. (IERR.NE.6))) GO TO 999
         IVOL = IVOL - 1
         IF (IVOL.GT.0) GO TO 10
         GO TO 999
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('UVCREA: DUPLICATE NAME ',A12,'.',A6,'.',I4)
 1011 FORMAT ('MCREAT: DUPLICATE NAME ',A12,'.',A6,'.',I4,
     *   ' BUT ON DISK',I3)
 1020 FORMAT ('UVCREA: ',A12,'.',A6,'.',I4,' PROHIBITED ON DISK',I3)
 1022 FORMAT ('UVCREA: CATALOG FULL ON VOL ',I1)
 1025 FORMAT ('UVCREA: CATDIR IO ERROR=',I7)
 1030 FORMAT (I4.4,2I2.2)
 1031 FORMAT ('UVCREA: CATIO I/O ERROR=',I7)
 1040 FORMAT ('Create ',A12,'.',A6,'.',I4,' (UV)  on disk',I3,
     *   '  cno',I5)
 1050 FORMAT ('ZCREAT ERROR',I6,' FOR ',A12,'.',A6,'.',I4)
 1051 FORMAT ('UVCREA: NO ROOM FOR ',A12,'.',A6,'.',I4)
      END

      SUBROUTINE QPTFAZ (APCORE, X, INC, U, REAL, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: zCompute phase in model visibilities.
C# AP-appl  UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Used to compute phases.   It does the following:
C         APCORE(REAL+m*INC) = APCORE(X+m*INC) * APCORE(U) +
C                            APCORE(X+1+m*INC) * APCORE(U+1) +
C                            APCORE(X+2+m*INC) * APCORE(U+2)
C         for m = 0 to N - 1
C   Inputs:
C      X     I  Base address of X,Y,Z array
C      INC   I  Increment of X and REAL
C      U     I  Base address of U,V,W array
C      REAL  I  Base address of phase array
C      N     I  Element count.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   X, INC, U, REAL, N
C
      LONGINT   JX, JU, JREAL
      INTEGER   LOOP
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                        Setup
      JX = X + PSAPOF
      JU = U + PSAPOF
      JREAL = REAL + PSAPOF
C                                       Loop
      INCLUDE 'INCS:ZVND.INC'
      DO 100 LOOP = 1,N
         APCORE(JREAL) = APCORE(JX) * APCORE(JU)
     *                 + APCORE(JX+1) * APCORE(JU+1)
     *                 + APCORE(JX+2) * APCORE(JU+2)
C                                       Update pointers.
         JREAL = JREAL + INC
         JX = JX + INC
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE UVPROT (OPCODE, IODISK, ICNOSC, INLUN, INDSK, MFIELD,
     *   UMATS, CCROT, SSROT, NVISIN, LRECIN, ILENBU, BUFSZ, BUFFER,
     *   NIO, IOPTR, MAXBLN, DISKO, CNOOUT, IRET)
C-----------------------------------------------------------------------
C! Prepares UV file for read/write, computes maximum U on read
C# UV Util
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 2000, 2008-2010, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVPROT gets either the maximum U from an open database even if the
C   BLMAX parameter is set applying 3D or regular rotation.
C   It does not read the data set if MAXABSU appears in the header as a
C   keyword.  This should only be set for temporary files by imaging
C   tasks that have determined the max (abs (u)) over all rotations and
C   reprojections.
C   Inputs:
C      OPCODE   C*4     Opcode 'READ' or 'WRIT'
C      IODISK   I       Input/Output file disk number for cataloged
C                       files, (.LE. 0 => /CFILES/ scratch file.)
C      ICNOSC   I       Input file catalog slot number or /CFILES/
C                       scratch file number.
C      INLUN    I       Logical Unit for I/O
C      INDSK    I       Aips Disk number of UV data
C      MFIELD   I       Number of fields to check
C      UMATS    R(3,3,*)  3D rotation matrix
C      CCROT    R       Cos of rotation
C      SSROT    R       Sin of rotation
C   Input/Output:
C      NVISIN   I       Number of visibilities
C      LRECIN   I       Number of values in a visibility record.
C      ILENBU   I       Number of visibilities per call to UVDISK.
C                       Determines block size for tape I/O
C                       0 => decide (see note above)
C      BUFSZ    I       Size in bytes of the buffer.
C      BUFFER   R(*)    Buffer
C      NIO      I       No. visibilities read/write.
C                       Max. no. vis. for next write.
C      IOPTR    I       Pointer to start of data in buffer
C      MAXBLN   R       Maximum baseline in database (wavelengths)
C   Output:
C      IRET     I       Return code, 0 => ok, otherwise not.
C-----------------------------------------------------------------------
      CHARACTER*4 OPCODE
      INTEGER     IODISK, ICNOSC, INLUN, INDSK, NVISIN, LRECIN,
     *   ILENBU, BUFSZ, NIO, IOPTR, MFIELD, CNOOUT, DISKO, IRET
      REAL        BUFFER(*), MAXBLN, UMATS(3,3,*), CCROT, SSROT
C
      CHARACTER   NAME*48
      INTEGER     VO, BO, VOL, LOCS(2), IERR, CATBUF(256), I, INPTR,
     *   CNO, KEYTYP(2), IFIELD, VOLO, CNOO
      LOGICAL     T, F, DOROT
      REAL        UU, MAXINU, UVWROT(3), VALUES(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DUVH.INC'
      SAVE VO, BO, T, F
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      DOROT = (ABS (SSROT).GT.1.0E-10) .OR. (ABS (CCROT-1.0).GT.1.0E-4)
C                                       use scratch file list
      IF (IODISK.LE.0) THEN
         VOL = SCRVOL(ICNOSC)
         CNO = SCRCNO(ICNOSC)
         CALL ZPHFIL ('SC', VOL, CNO, 1, NAME, IRET)
C                                       using an actual file name
      ELSE
         VOL = IODISK
         CNO = ICNOSC
         CALL ZPHFIL ('UV', VOL, CNO, 1, NAME, IRET)
         END IF
      IF (DISKO.LE.0) THEN
         VOLO = SCRVOL(CNOOUT)
         CNOO = SCRCNO(CNOOUT)
      ELSE
         VOLO = DISKO
         CNOO = CNOOUT
         END IF
      CALL ZOPEN (INLUN, INDSK, VOL, NAME, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) 'OPEN', IRET
         GO TO 995
         END IF
C                                       reading old, or writing new ?
      IF (OPCODE(1:4).EQ.'READ') THEN
C                                       Init UV file read.
         CALL UVINIT ('READ', INLUN, INDSK, NVISIN, VO, LRECIN, ILENBU,
     *      BUFSZ, BUFFER, BO, IOPTR, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) 'INIT', IRET
            GO TO 995
            END IF
C                                       Get Max U from header
         CALL CATKEY ('REED', VOL, CNO, 'MAXABSU ', 1, LOCS, VALUES,
     *      KEYTYP, CATBUF, IERR)
C                                       copy value from buffer
         MAXBLN = 0.0
         IF ((IERR.EQ.0) .AND. (LOCS(1).GT.0))
     *      CALL RCOPY (1, VALUES(LOCS(1)), MAXBLN)
C                                       Else MAXBLINE not set, find it
C                                       Recompute MAXBLINE
         IF (MAXBLN.LE.0.0) THEN
            MAXBLN = 0.0
            MAXINU = 0.0
C                                       Get current Max U from header
            CALL CATKEY ('REED', VOL, CNO, 'MAXBLINE', 1, LOCS, VALUES,
     *         KEYTYP, CATBUF, IERR)
C                                       copy value from buffer
            IF ((IERR.EQ.0) .AND. (LOCS(1).GT.0)) CALL RCOPY (1,
     *         VALUES(LOCS(1)), MAXBLN)
C                                       Loop Reading until all read
 20         CALL UVDISK ('READ', INLUN, INDSK, BUFFER, NIO, IOPTR, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) 'READ', IRET
               GO TO 995
               END IF
            INPTR = IOPTR
C                                       Jump out on end of data
            IF (NIO.GT.0) THEN
               DO 30 I = 1,NIO
                  UU = ABS (BUFFER(INPTR+ILOCU))
                  MAXINU = MAX (MAXINU, UU)
                  DO 25 IFIELD = 1,MFIELD
                     CALL PRJMUL (1, BUFFER(INPTR+ILOCU),
     *                  UMATS(1,1,IFIELD), UVWROT)
                     UU = ABS (UVWROT(1))
                     MAXBLN = MAX (MAXBLN, UU)
 25                  CONTINUE
                  INPTR = INPTR + LRECIN
 30               CONTINUE
C                                       End of buffer, go get next
               GO TO 20
               END IF
C                                       Tell User Max baseline found
            WRITE (MSGTXT,1050) MAXINU
            CALL MSGWRT (3)
            WRITE (MSGTXT,1051) MAXBLN
            CALL MSGWRT (3)
            IF (MAXBLN.LE.0.9*MAXINU) MAXBLN = MAXINU
C                                       Re-Init UV file read.
            CALL UVINIT ('READ', INLUN, INDSK, NVISIN, VO, LRECIN,
     *         ILENBU, BUFSZ, BUFFER, BO, IOPTR, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) 'INIT', IRET
               GO TO 995
               END IF
            END IF
C                                       Read first visibility record
         CALL UVDISK ('READ', INLUN, INDSK, BUFFER, NIO, IOPTR, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) 'READ', IRET
            GO TO 995
            END IF
C                                       if max is set, record
         IF (MAXBLN.GT.0) THEN
            LOCS(1) = 1
            CALL RCOPY (1, MAXBLN, VALUES(1))
            KEYTYP(1) = 2
            KEYTYP(2) = 0
C                                       Record Max Baseline in header
            CALL CATKEY ('WRIT', VOL, CNO, 'MAXBLINE', 1, LOCS,
     *         VALUES, KEYTYP, CATBUF, IERR)
            CALL CATKEY ('WRIT', VOL, CNO, 'MAXABSU', 1, LOCS,
     *         VALUES, KEYTYP, CATBUF, IERR)
            IF ((VOL.NE.VOLO) .OR. (CNO.NE.CNOO)) THEN
               CALL CATKEY ('WRIT', VOLO, CNOO, 'MAXBLINE', 1, LOCS,
     *            VALUES, KEYTYP, CATBUF, IERR)
               CALL CATKEY ('WRIT', VOLO, CNOO, 'MAXABSU', 1, LOCS,
     *            VALUES, KEYTYP, CATBUF, IERR)
               END IF
            END IF
C                                       else init for write
      ELSE
         CALL UVINIT ('WRIT', INLUN, INDSK, NVISIN, VO, LRECIN, ILENBU,
     *      BUFSZ, BUFFER, BO, IOPTR, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) 'INIT', IRET
            GO TO 995
            END IF
         END IF
      GO TO 999
C                                       Error
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVPROT: TROUBLE ',A,'ING UV DATA FILE,  IER=',I5)
 1050 FORMAT ('UVPROT: Maximum input   U Baseline is ',1PE12.5,
     *   ' lambda')
 1051 FORMAT ('UVPROT: Maximum rotated U Baseline is ',1PE12.5,
     *   ' lambda')
      END

      PROGRAM PRTSD
C-----------------------------------------------------------------------
C! Prints selected single dish format data.
C# Singledish Printer Terminal Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999-2000, 2004, 2007, 2009, 2015-2016,
C;  Copyright (C) 2018, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task PRTSD lists a selected portion of a catalogd uv data base.
C   Single dish version.
C   Inputs:
C      AIPS Adverb   Prg. Name          Description
C      INNAME         NAME          File name to be listed.
C      INCLASS        CLASS         File class to be listed.
C      INSEQ          SEQ           File sequence number.
C      INDISK         DISK          Disk volumn on which file resides.
C      CHANNEL        NCH           Spectral channel.
C      BIF            BIF           IF number
C      TIMERANG       XTIME         1-4: start time D, H, M, S
C                                   5-8: stop time D, H, M, S
C      ANTENNAS       XANTS         beams.
C      BCOUNT         VO            Visibility number to start list
C      NCOUNT         XNIT          Number of components to list
C                                   default: 1 Page.
C      XINC           INC           Increment for vis.
C      UVRANGE        UVRANG        Range of UV in 1000's wavelengths
C      DOCRT          DOCRT         If true (>0) write to terminal.
C      OUTPRINT       LPNAME        File name to keep printer output in
C      DOCELL         DOOFF         If true give offset not value.
C-----------------------------------------------------------------------
      CHARACTER CHSCAN*8, CHSAMP*8, PRGM*6, TITL1*132, TITL2*132,
     *   LINE*132, SCRTCH*132, LPNAME*48, TYPLAB(4)*12, JSTOKE(4,3)*2,
     *   TCHAR(2)*4, CHOFFS*4, CHSIGR*1, CHSIGD*1, NAME*12, CLASS*6,
     *   ISTOKE(7)*2, LLCH*4, MMCH*4, TSIGN*1
      HOLLERITH CATH(256), XNAME(3), XCLASS(2), XLPNAM(12)
      LOGICAL   T, NORMAL, DOOFF, ISPROJ, AZEL, RADEC
      INTEGER   DISK, SEQ, USERID, FINDP, PAGE, HM(2), DD(2), IPCNT,
     *   LUNP, ITT(3), IWT(7), NCH, ICH(7), IRAS, IDECS, IOPC, IROUND,
     *   NPARM, IRET, IERR, INC, I, NUMCH, LIMIT2, ICH1, ICH2,NNCH, II,
     *   JJ, INDEX, L, JCOR, K, KK, KKK, NUMCHM, NACROS,OTYPE, IBEM,
     *   IVOFF, WTOFF, SAMPLE, ILOCSC, ILOCSM, PCOUNT,RECCNT, FIRST,
     *   LAST, SCAN, I4TEMP, JTRIM, IA1, IA2, NCOUNT, TTY(2)
      REAL      RSEC, DSEC, XSEQ, XSTR, XNIT, XINC, XTIME(8),
     *   BUFF(12300), XNCH, CATR(256), XAMP, YAMP, UVSCAL, XREAL(7),
     *   DOCRT, XDISK, TEMP, XBIF, XANT(50), XSUBA, XDOCAL, XGUSE,
     *   XFLAG, XDOCEL, BADD(10), XDAY, SECNDS, XWT, NWT, WTSC, WEIGHT
      DOUBLE PRECISION    CATD(128), XRA, XDEC
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      COMMON /INPARM/ XNAME, XCLASS, XSEQ, XDISK, XNCH, XBIF, XTIME,
     *   XANT, XSUBA, XDOCAL, XGUSE, XFLAG, XSTR, XNIT, XINC, DOCRT,
     *   XLPNAM, XDOCEL, BADD
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      DATA TYPLAB /'Unprojected ', 'Unprojected ', 'Projected   ',
     *   'Rel. Az-El'/
      DATA T /.TRUE./
      DATA JSTOKE /'X ','Y ','??','??', 'R ','L ','??','??',
     *   'I ','Q ','U ','V '/
      DATA PRGM /'PRTSD '/
      DATA CHSCAN, CHSAMP /'SCAN','SAMP'/
      DATA TCHAR, CHOFFS  /'FLUX','WT  ', 'OFFS'/
C-----------------------------------------------------------------------
C                                       Init I/O
      TSKNAM = PRGM
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL SELINI
C                                       Get input parameters.
      NPARM = 98
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAME, BUFF, IRET)
      IF (IRET.EQ.0) GO TO 10
         IF (IRET.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IRET
            CALL MSGWRT (8)
C                                       Restart AIPS.
 10   IF ((IRET.NE.0) .OR. (NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   DOCRT = MIN (-1.0, DOCRT)
      CALL H2CHR (48, 1, XLPNAM, LPNAME)
      IF (DOCRT.GT.0.0) RQUICK = .FALSE.
      IF (RQUICK) RQUICK = LPNAME.NE.' '
      IF (RQUICK) CALL RELPOP (IRET, BUFF, IERR)
      IF (IRET.NE.0) GO TO 990
      IRET = 8
C                                       Decode input.
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      USERID = NLUSER
      SEQ = XSEQ + 0.1
      DISK = XDISK + 0.1
      NCH = XNCH + 0.1
      IF (NCH.LE.0) NCH = 1
      BIF = XBIF + 0.1
      IF (BIF.LE.0) BIF = 1
      IF (XSTR.LT.1.0) XSTR = 1.0
      FIRST = XSTR + 0.1
      INC = XINC + 0.1
      INC = MAX (1, INC)
      IF (XNIT.LT.1.0) THEN
         XNIT = PRTMAX - 10
         IF (DOCRT.GT.0.0) XNIT = 30000
      ELSE
         IF (DOCRT.LE.0.0) XNIT = MIN (2000., XNIT)
         END IF
      I4TEMP = IROUND (XNIT)
      LAST = FIRST + (I4TEMP - 1) * INC
      CALL H2CHR (12, 1, XNAME, NAME)
      CALL H2CHR (6, 1, XCLASS, CLASS)
C                                       See if offset wanted
      DOOFF = XDOCEL.GT.0.0
C                                       Setup for SDGET
      UNAME = NAME
      UCLAS = CLASS
      UDISK = DISK
      USEQ = SEQ
      CALL RCOPY (8, XTIME, TIMRNG)
      BCHAN = 1
      ECHAN = 0
      EIF = BIF
      DOCAL = XDOCAL.GT.0.0
      DO 15 I = 1,50
         ANTENS(I) = IROUND (XANT(I))
 15      CONTINUE
      SUBARR = IROUND (XSUBA)
      FGVER = IROUND (XFLAG)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
C                                       Open file and get CATBLK and
C                                       initialize reading data file.
      INITVS = FIRST
      CALL SDGET ('INIT', BUFF, BUFF, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Get info from CATBLK.
      MSGSUP = 32000
      CALL UVPGET (IERR)
      MSGSUP = 0
      NORMAL = IERR.EQ.0
      ISPROJ = TYPUVD.EQ.2
      IERR = 0
      UVSCAL = 1.0 / FREQ
      IF (NORMAL) UVSCAL = 1.0
      IOPC = 1
      IF (ISPROJ) IOPC = 2
      IF (.NOT.NORMAL) ILOCB = 2
      IBEM = 0
      SAMPLE = 0
      SCAN = 0
C                                       BS or regular SD data?
      AZEL = TYPUVD.EQ.3
      IF (AZEL) IOPC = 2
C                                       SCAN pointer
      CALL AXEFND (4, CHSCAN, CATBLK(KIPCN), CATH(KHPTP), ILOCSC, IERR)
      IF (IERR.NE.0) ILOCSC = -1
C                                       SAMPLE pointer
      CALL AXEFND (4, CHSAMP, CATBLK(KIPCN), CATH(KHPTP), ILOCSM, IERR)
      IF (IERR.NE.0) ILOCSM = -1
      IERR = 0
C                                       Visibility offset
      IVOFF = NRPARM
      IF (JLOCIF.LE.0) BIF = 1
      IF (JLOCIF.GT.0) IVOFF = NRPARM + (BIF-1) * INCIF
      WTOFF = 2
C                                       See if printing offset
      IF (DOOFF) THEN
         IVOFF = IVOFF + 1
         WTOFF = 1
         TCHAR(1) = CHOFFS
         END IF
C                                       Write header on unit 1
      IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
      CALL LPOPEN (LPNAME, DOCRT, LUNP, FINDP, NACROS, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         CALL MSGWRT (8)
         GO TO 920
         END IF
C                                       Check spectral channel.
      IF (CATBLK(KINAX+JLOCF).LE.1) NCH = 1
      FREQ = FREQ + (NCH-CATR(KRCRP+JLOCF)) * CATR(KRCIC+JLOCF)
      IF (NCH.LE.CATBLK(KINAX+JLOCF)) GO TO 30
         WRITE (MSGTXT,1025) NCH,CATBLK(KINAX+JLOCF)
         CALL MSGWRT (8)
         GO TO 990
C                                        Determine no. channels to do
 30   NUMCHM = CATBLK(KINAX+JLOCF) - NCH + 1
      NUMCH = (NACROS - 54) / (13 * NCOR)
      NUMCH = MIN (NUMCH, NUMCHM)
      NUMCH = MIN (NUMCH, 6)
      OTYPE = 1
      IF (NUMCH.GE.1) GO TO 35
         NUMCH = 1
         IF (NACROS.LE.80) OTYPE = 2
         IF (NACROS.LE.72) OTYPE = 3
 35   ICH1 = NCH
      ICH2 = NCH + NUMCH - 1
      LIMIT2 = NCOR * NUMCH
      NNCH = NCH - 1
      DO 40 II = 1,LIMIT2,NCOR
         NNCH = NNCH + 1
         DO 39 JJ = 1,NCOR
            INDEX = II + JJ - 1
            ICH(INDEX) = NNCH
            TEMP = CATD(KDCRV+JLOCS) + (JJ - CATR(KRCRP+JLOCS)) *
     *         CATR(KRCIC+JLOCS)
            I = IROUND (TEMP)
            IF (I.LT.-4) THEN
               L = 1
               I = -(I + 4)
            ELSE IF (I.LT.0) THEN
               L = 2
               I = ABS(I)
            ELSE
               L = 3
               END IF
            ISTOKE(INDEX) = JSTOKE(I,L)
 39         CONTINUE
 40      CONTINUE
C                                       Convert coordinates.
      CALL H2CHR (4, 1, CATH(KHCTP+JLOCR*2), LLCH)
      CALL H2CHR (4, 1, CATH(KHCTP+JLOCD*2), MMCH)
      RADEC = (LLCH(:2).EQ.'RA') .AND. (MMCH(:3).EQ.'DEC')
      IF (RADEC) THEN
         CALL COORDD (1, RA, CHSIGR, HM, RSEC)
      ELSE
         IOPC = 2
         CALL COORDD (2, RA, CHSIGR, HM, RSEC)
         END IF
      CALL COORDD (2, DEC, CHSIGD, DD, DSEC)
C                                       read through data to determine
C                                       scaling
      PCOUNT = 0
      RECCNT = FIRST - 1
      XAMP = 0.0
      XWT = 0.0
      NWT = 1.0E10
      MSGTXT = 'Finding extrema to set data formats'
      CALL MSGWRT (1)
      LUNP = 0
      FINDP = 0
      NCOUNT = 8
      IF (DOCAL) NCOUNT = NCOUNT + 1
      IF (DOFLAG) NCOUNT = NCOUNT + 1
      IF (DOCRT.GT.-2.5) NCOUNT = NCOUNT + 1
C                                       Start looping thru data.
 50   CALL SDGET ('READ', BUFF, BUFF(1+NRPARM), IERR)
      IF (IERR.GT.0) THEN
         GO TO 900
      ELSE IF (IERR.LT.0) THEN
         IERR = 0
      ELSE
         RECCNT = RECCNT + 1
         IF (RECCNT.LT.FIRST) GO TO 50
         IF (RECCNT.GT.LAST) GO TO 900
         IF (MOD(RECCNT-FIRST, INC).NE.0) GO TO 50
C                                       Get vis.
         NCOUNT = NCOUNT + 1
         K = 0
         YAMP = 0.0
         DO 65 KK = ICH1,ICH2
            DO 60 KKK = 1,NCOR
               K = K + 1
               INDEX = 1 + (KK-1)*INCF + (KKK-1)*INCS + IVOFF
               XREAL(K) = BUFF(INDEX)
               XAMP = MAX (XAMP, XREAL(K))
               YAMP = MIN (YAMP, XREAL(K))
               WEIGHT = ABS (BUFF(INDEX+WTOFF))
               XWT = MAX (XWT, WEIGHT)
               IF (WEIGHT.GT.0.0) NWT = MIN (NWT, WEIGHT)
 60            CONTINUE
 65         CONTINUE
         XAMP = MAX (XAMP, -10.0*YAMP)
         PCOUNT = PCOUNT + 1
         IF (PCOUNT.LT.XNIT) GO TO 50
         END IF
C                                       check count
      IF ((DOCRT.LE.0.0) .AND. (LPNAME.EQ.' ')) THEN
         IF ((NPOPS.GT.NINTRN) .OR.(ISBTCH.EQ.32000)) THEN
            IF (NCOUNT.GT.1000) IERR = -1
         ELSE IF (NCOUNT.GT.500) THEN
            TTY(1) = 5
            CALL ZOPEN (TTY(1), TTY(2), 1, SCRTCH, .FALSE., .FALSE.,
     *         .TRUE., IERR)
            MSGTXT = 'PROBLEM OPENING TERMINAL'
            IF (IERR.GT.0) GO TO 890
            WRITE (SCRTCH,1045) NCOUNT
            CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, IERR)
            MSGTXT = 'PROBLEM DOING IO TO TERMINAL'
            IF (IERR.GT.0) GO TO 890
            SCRTCH = 'Do you really want to print this much??' //
     *         ' Enter Y or y if so'
            CALL INQSTR (TTY, SCRTCH, 1, LLCH, IERR)
            IF (IERR.GT.0) GO TO 890
            IF ((LLCH(:1).NE.'y') .AND. (LLCH(:1).NE.'Y')) THEN
               SCRTCH = 'Good choice - save trees'
               IERR = -1
            ELSE
               SCRTCH = 'OKAY, printing anyway'
               END IF
            CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, I)
            CALL ZCLOSE (TTY(1), TTY(2), I)
            END IF
         END IF
      IF (IERR.NE.0) GO TO 900
C                                       Restart I/O
      CALL SDGET ('CLOS', BUFF, BUFF, IERR)
      IF (IERR.EQ.0) CALL SDGET ('INIT', BUFF, BUFF, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       UVPGET was called again
      FREQ = FREQ + (NCH-CATR(KRCRP+JLOCF)) * CATR(KRCIC+JLOCF)
      FREQ = FREQ * 1.0E-9
C                                       weight scaling, range
      IF (XWT.LE.0.0) THEN
         XWT = 1.0
         NWT = 1.0
         END IF
      TEMP = LOG10 (XWT/0.9995)
      I = TEMP + 98.0
      I =  100 - I
      WTSC = 10.0 ** I
      IF ((NWT.GE.10.0) .AND. (XWT.LT.999.5)) WTSC = 1.0
      IF ((NWT.GE.1.0) .AND. (XWT.LT.99.5)) WTSC = 10.0
      TEMP = NWT * WTSC
      IF (TEMP.LT.1.0) THEN
         MSGTXT = 'Full dynamic range of weights cannot be printed'
         CALL MSGWRT (6)
         END IF
      IPCNT = 998
      PAGE = 0
C                                      Leading information
      I = JTRIM (ISORT)
      I = JTRIM (SOURCE)
      TITL1 = ' '
      TITL2 = ' '
      IF (DOCRT.GT.-2.5) THEN
         IF (NACROS.LE.90) THEN
            WRITE (LINE,1050) NAME, CLASS, SEQ, DISK, USERID, ICH1,
     *         ICH2, BIF
         ELSE
            WRITE (LINE,1051) NAME, CLASS, SEQ, DISK, USERID, ICH1,
     *         ICH2, BIF
            END IF
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1055) SOURCE, LLCH, CHSIGR, HM, RSEC, MMCH, CHSIGD,
     *      DD, DSEC
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (LINE,1056) FREQ, NCOR, NVIS, ISORT
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         LINE = TYPLAB(TYPUVD+1) // 'Single dish format data'
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       Calibration and editing
         IF (DOCAL) THEN
            WRITE (LINE,1060) CLUSE
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         IF (DOFLAG) THEN
            WRITE (LINE,1061) FGVER
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         IF (WTSC.NE.1.0) THEN
            WRITE (LINE,1062) WTSC
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
         LINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
C                                       Page titles
      IF (OTYPE.EQ.1) THEN
         WRITE (TITL1,1065) SOURCE, FREQ, ISORT, (ICH(JCOR),
     *      ISTOKE(JCOR), JCOR = 1,LIMIT2)
         IF (AZEL) THEN
            WRITE (TITL2,1066) (TCHAR(1), TCHAR(2), JCOR = 1,LIMIT2)
         ELSE IF (RADEC) THEN
            WRITE (TITL2,1067) (TCHAR(1), TCHAR(2), JCOR = 1,LIMIT2)
         ELSE
            WRITE (TITL2,1068) LLCH, MMCH, (TCHAR(1), TCHAR(2),
     *         JCOR = 1,LIMIT2)
            END IF
      ELSE IF (OTYPE.EQ.2) THEN
         WRITE (TITL1,1070) SOURCE, FREQ, ISORT, (ICH(JCOR),
     *      ISTOKE(JCOR), JCOR = 1,LIMIT2)
         IF (AZEL) THEN
            WRITE (TITL2,1071) (TCHAR(1), TCHAR(2), JCOR = 1,LIMIT2)
         ELSE IF (RADEC) THEN
            WRITE (TITL2,1072) (TCHAR(1), TCHAR(2), JCOR = 1,LIMIT2)
         ELSE
            WRITE (TITL2,1073) LLCH, MMCH, (TCHAR(1), TCHAR(2),
     *         JCOR = 1,LIMIT2)
            END IF
      ELSE IF (OTYPE.EQ.3) THEN
         WRITE (TITL1,1075) SOURCE, FREQ, (ICH(JCOR), ISTOKE(JCOR),
     *      JCOR = 1,LIMIT2)
         IF (AZEL) THEN
            WRITE (TITL2,1076) (TCHAR(1), TCHAR(2), JCOR = 1,LIMIT2)
         ELSE IF (RADEC) THEN
            WRITE (TITL2,1077) (TCHAR(1), TCHAR(2), JCOR = 1,LIMIT2)
         ELSE
            WRITE (TITL2,1078) LLCH, MMCH, (TCHAR(1), TCHAR(2),
     *         JCOR = 1,LIMIT2)
            END IF
         END IF
      CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, TITL1,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, TITL2,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
      IF (DOCRT.GT.-2.5) THEN
         LINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      PCOUNT = 0
      RECCNT = FIRST - 1
C                                       Start looping thru data.
 110  CALL SDGET ('READ', BUFF, BUFF(1+NRPARM), IERR)
      IF (IERR.GT.0) THEN
         GO TO 900
      ELSE IF (IERR.LT.0) THEN
         IERR = 0
      ELSE
         RECCNT = RECCNT + 1
         IF (RECCNT.LT.FIRST) GO TO 110
         IF (RECCNT.GT.LAST) GO TO 900
         IF (MOD(RECCNT-FIRST, INC).NE.0) GO TO 110
C                                       Decode time.
         XDAY = BUFF(1+ILOCT)
         CALL TFDHMS (XDAY, 1, TSIGN, ITT, SECNDS)
         IF (ITT(1).GT.9999) ITT(1) = 9999
C                                       Convert RA, Dec.
         XRA = BUFF(1+ILOCU) * UVSCAL
         XDEC = BUFF(1+ILOCV) * UVSCAL
         CALL COORDD (IOPC, XRA, CHSIGR, HM, RSEC)
         CALL COORDD (2, XDEC, CHSIGD, DD, DSEC)
         IRAS = IROUND (RSEC)
         IDECS = IROUND (DSEC)
         IF (IRAS.EQ.60) THEN
            IRAS = 0
            HM(2) = HM(2) + 1
            END IF
         IF (HM(2).EQ.60) THEN
            HM(2) = 0
            HM(1) = HM(1) + 1
            END IF
         IF (IDECS.EQ.60) THEN
            IDECS = 0
            DD(2) = DD(2) + 1
            END IF
         IF (DD(2).EQ.60) THEN
            DD(1) = DD(1) + 1
            DD(2) = 0
            END IF
C                                       Beam
         IF (ILOCB.GE.0) THEN
            IBEM = BUFF(1+ILOCB) - 255.5
            IA1 = BUFF(1+ILOCB) + 0.2
            IA2 = MOD (IA1, 256)
            IA1 = IA1 / 256
         ELSE IF (ILOCA1.GE.0) THEN
            IA1 = BUFF(1+ILOCA1) + 0.1
            IA2 = BUFF(1+ILOCA2) + 0.1
            IBEM = 256 * IA1 + IA2 - 256
            END IF
         IF (IA1.EQ.IA2) IBEM = IA1
C                                       Scan, sample
         IF (ILOCSC.GE.0) SCAN = BUFF(1+ILOCSC) + 0.5
         IF (ILOCSM.GE.0) SAMPLE = BUFF(1+ILOCSM) + 0.5
         IF (SCAN.GT.99999) SCAN = 99999
         IF (SAMPLE.GT.9999) SAMPLE = 9999
C                                       Get vis.
         K = 0
         DO 125 KK = ICH1,ICH2
            DO 120 KKK = 1,NCOR
               K = K + 1
               INDEX = 1 + (KK-1)*INCF + (KKK-1)*INCS + IVOFF
               XREAL(K) = BUFF(INDEX)
               IWT(K) = IROUND (BUFF(INDEX+WTOFF)*WTSC)
               IWT(K) = MAX (-999, MIN (999, IWT(K)))
 120           CONTINUE
 125        CONTINUE
C                                       Write VIS data.
         IF (XAMP.LE.999.9) THEN
            IF (OTYPE.EQ.1) WRITE (LINE,1120,ERR=140) SCAN, SAMPLE,
     *         ITT, SECNDS, IBEM, CHSIGR, HM, IRAS, CHSIGD, DD, IDECS,
     *         (XREAL(K), IWT(K), K = 1,LIMIT2)
            IF (OTYPE.EQ.2) WRITE (LINE,1121,ERR=140) SCAN, SAMPLE,
     *         IBEM, CHSIGR, HM, IRAS, CHSIGD, DD, IDECS, (XREAL(K),
     *         IWT(K), K = 1,LIMIT2)
            IF (OTYPE.EQ.3) WRITE (LINE,1122,ERR=140) CHSIGR, HM,
     *         IRAS, CHSIGD, DD, IDECS, (XREAL(K), IWT(K),
     *         K = 1,LIMIT2)
         ELSE
            IF (OTYPE.EQ.1) WRITE (LINE,1130,ERR=140) SCAN, SAMPLE,
     *         ITT, SECNDS, IBEM, CHSIGR, HM, IRAS, CHSIGD, DD, IDECS,
     *         (XREAL(K), IWT(K), K = 1,LIMIT2)
            IF (OTYPE.EQ.2) WRITE (LINE,1131,ERR=140) SCAN, SAMPLE,
     *         IBEM, CHSIGR, HM, IRAS, CHSIGD, DD, IDECS, (XREAL(K),
     *         IWT(K), K = 1,LIMIT2)
            IF (OTYPE.EQ.3) WRITE (LINE,1132,ERR=140) CHSIGR, HM,
     *         IRAS, CHSIGD, DD, IDECS, (XREAL(K), IWT(K),
     *         K = 1,LIMIT2)
            END IF
 140     IF (OTYPE.EQ.1) CALL FILZCH (2, 22, LINE)
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         PCOUNT = PCOUNT + 1
         IF (PCOUNT.LT.XNIT) GO TO 110
         END IF
      GO TO 900
C
 890  CALL MSGWRT (8)
C                                       Close files.
 900  IF (IERR.LE.0) IRET = 0
      IF (LUNP.GT.0) CALL LPCLOS (LUNP, FINDP, IPCNT, IERR)
C
 920  CALL SDGET ('CLOS', BUFF, BUFF, IERR)
C                                        Write end message
 990  CALL DIETSK (IRET, RQUICK, BUFF)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR:',I7,'GETTING INPUT PARAMETERS')
 1025 FORMAT ('CHANNEL',I5,' .GT. MAX =',I5)
 1040 FORMAT ('UNABLE TO OPEN OUTPUT DEVICE: ERROR=',I7)
 1045 FORMAT ('Requested print job is',I10,' lines long!')
 1050 FORMAT (A12,'.',A6,'.',I4,' vol=',I2,' user=',I5,' Channels=',I4,
     *   '-',I4,' IF=',I3)
 1051 FORMAT ('File = ',A12,'.',A6,'.',I4,' vol =',I2,'  userid =',I5,
     *   2X,'Channels =',I5,' to ',I5,' IF=',I3)
 1055 FORMAT ('Source= ',A8,3X,A4,' = ',A1,I2.2,I3.2,F6.2,3X,A4,' = ',
     *   A1,I2.2,I3.2,F5.1)
 1056 FORMAT ('Freq=',F13.9,' GHz   ncor=',I3,'   No. vis=',I10,
     *   '   Sort order= ',A2)
 1060 FORMAT ('Applying CS table ',I3)
 1061 FORMAT ('Applying FG table ',I3)
 1062 FORMAT ('Weights have been multiplied by',F12.4)
 1065 FORMAT (A,8X,'Freq=',F13.9,4X,'Sort=',A2,7X,
     *   6(3X,I4,2X,A2,2X))
 1066 FORMAT ('  Scan/#  ',8X,'IAT',6X,'Beam ',6X,'Az',8X,'El',4X,
     *   6(4X,A4,3X,A2))
 1067 FORMAT ('  Scan/#  ',8X,'IAT',6X,'Beam ',6X,'RA',8X,'Dec',3X,
     *   6(4X,A4,3X,A2))
 1068 FORMAT ('  Scan/#  ',8X,'IAT',6X,'Beam ',6X,A,6X,A,2X,
     *   6(4X,A4,3X,A2))
 1070 FORMAT (A,4X,F13.9,2X,A2,6X,5(3X,I4,2X,A2,2X))
 1071 FORMAT ('  Scan/#  ','Beam ',5X,'Az',7X,'El',4X,4(4X,A4,3X,A2))
 1072 FORMAT ('  Scan/#  ','Beam ',5X,'RA',7X,'Dec',3X,4(4X,A4,3X,A2))
 1073 FORMAT ('  Scan/#  ','Beam ',5X,A,5X,A,2X,4(4X,A4,3X,A2))
 1075 FORMAT (A,F12.8,4(3X,I4,2X,A2,2X))
 1076 FORMAT (5X,'Az',7X,'El',4X,4(4X,A4,3X,A2))
 1077 FORMAT (5X,'RA',7X,'Dec',3X,4(4X,A4,3X,A2))
 1078 FORMAT (5X,A,5X,A,2X,4(4X,A4,3X,A2))
 1120 FORMAT (I5,'/',I4.4,I4,'/',2(I2.2,':'),F4.1,I6,1X,
     *   2(2X,A1,I2.2,2I3.2),6(F9.4,I4))
 1121 FORMAT (I5,'/',I4.4,I4,1X,2(1X,A1,I2.2,2I3.2),6(F9.4,I4))
 1122 FORMAT (2(1X,A1,I2.2,2I3.2),6(F9.4,I4))
 1130 FORMAT (I5,'/',I4.4,I4,'/',2(I2.2,':'),F4.1,I6,1X,
     *   2(2X,A1,I2.2,2I3.2),6(F9.2,I4))
 1131 FORMAT (I5,'/',I4.4,I4,1X,2(1X,A1,I2.2,2I3.2),6(F9.2,I4))
 1132 FORMAT (2(1X,A1,I2.2,2I3.2),6(F9.2,I4))
      END

      SUBROUTINE QGRD2 (UV, VIS, WT, GRID, CONX, CONY, NO2, M, LROW)
C-----------------------------------------------------------------------
C! FPS AP version: Convolves UV data onto a grid
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FPS AP version
C   Convolves linear polarization visibility data
C   into a grid.  It accumulates two independent visibility
C   channels with the convolution function and weighting.
C   Data is ignored if weight non-positive or the datum
C   is too far off the edge of the grid.
C    Inputs:
C     UV    I   Location of (u,v) values in cells.
C     VIS   I   Location of (complex) visibilities.
C                 Expects Re1, Im1, Re2, Im2
C     WT    I   Weight for data. Assumes any tapering
C                 has already been done.
C     GRID  I   base address of gridded data.
C                 Order assumed to be the following
C                 for each of the M rows:
C                  1) 2 * LROW visibilities
C                  2) 2 * LROW visibilities, Vis 2
C     CONX  I   base address of X convolving fn.
C     CONY  I   base address of Y convolving fn.
C     NO2   I   INT( (# cells used on a row) / 2 )
C     M     I   number of rows kept in the AP.
C     LROW  I   length of a row ( max. X).
C      In the above, X refers to rows and y to columns
C      in the gridded data, NOT on the sky.  The total
C      numbers of rows and cells used on a row should
C      be odd.
C     All AP memory I/O values are assumed floating.
C     It is assumed that all values of v correspond to row M/2.
C-----------------------------------------------------------------------
      INTEGER UV, VIS, WT, GRID, CONX, CONY,  NO2, M, LROW
      INTEGER*2 IUV, IVIS, IWT, IGRID, ICONX, ICONY, INO2, IM, ILROW
C-----------------------------------------------------------------------
C                                        Convert inputs to unsigned I*2
      IF (UV.LT.32768) IUV = UV
      IF (UV.GE.32768) IUV = UV - 65536
      IF (VIS.LT.32768) IVIS = VIS
      IF (VIS.GE.32768) IVIS = VIS - 65536
      IF (WT.LT.32768) IWT = WT
      IF (WT.GE.32768) IWT = WT - 65536
      IF (GRID.LT.32768) IGRID = GRID
      IF (GRID.GE.32768) IGRID = GRID - 65536
      IF (CONX.LT.32768) ICONX = CONX
      IF (CONX.GE.32768) ICONX = CONX - 65536
      IF (CONY.LT.32768) ICONY = CONY
      IF (CONY.GE.32768) ICONY = CONY - 65536
      IF (NO2.LT.32768) INO2 = NO2
      IF (NO2.GE.32768) INO2 = NO2 - 65536
      IF (M.LT.32768) IM = M
      IF (M.GE.32768) IM = M - 65536
      IF (LROW.LT.32768) ILROW = LROW
      IF (LROW.GE.32768) ILROW = LROW - 65536
C                                        Call FPS routine.
      CALL APGRD2 (IUV, IVIS, IWT, IGRID, ICONX, ICONY, INO2, IM, ILROW)
C
 999  RETURN
      END

       SUBROUTINE AU7A (BRANCH)
C-----------------------------------------------------------------------
C! verbs to put/get header values, to put values into images or tables
C# POPS-appl Map-appl Header  Ext-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 1999-2000, 2005-2006, 2009, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AU7A verbs:
C   Inputs:
C      BRANCH  I  =1 ADDBEAM  adds beam parameters to header
C                 =2 PUTHEAD  puts keyword-indicated value in header
C                 =3 GETHEAD  gets keyword-indicated value from header
C                 =4 PUTVALUE puts a value into an image
C                 =5 GETTHEAD reads a value from a table header
C                 =6 PUTTHEAD puts a value into a table header
C                 =7 TABGET   Read an entry from a table
C                 =8 TABPUT   Write an entry to a table
C                 =9 ACTNOISE a puthead of PIXSTD as keyword ACTNOISE
C                 =10 EGETHEAD is GETHEAD but returns ERROR not error
C   Common: (though adverbs in common)
C      INNAME   H*12  Image name.  If blank, the first match consistent
C                     with the other parameters is used.
C      INCLASS  H*6   Image class.  If blank, the first match is used.
C      INSEQ    R     Image sequence number. If zero, the first match
C                     consistent with the other parameters is used.
C      INDISK   R     the catalog resides on this disk.  If zero, all
C                     disk volumes are searched until a match is found.
C   (ADDBEAM only)
C      BMAJ     R     Beam major axis in arc sec.
C      BMIN     R     Beam minor axis in arc sec.
C      BPA      R     Beam position angle in arc sec.
C   (GETHEAD, PUTHEAD, GETTHEAD, PUTTHEAD, TABGET, TABPUT)
C      KEYWORD  H*8   FITS keyword corresponding to a header value
C      KEYVALUE R(2)  Numeric value out/in
C      KEYSTRNG H*16  String value out/in
C   (GETTHEAD, PUTTHEAD, TABGET, TABPUT)
C      INEXT     H*2  Table type (e.g. AN, SU)
C      INVER     R    the version number of the table.
C      XKEYTY    H*4  Keyword data type ('D','R','I','C','L')
C   (PUTVALUE, TABGET, TABPUT only)
C      PIXXY    R(7)  Pixel position.
C      PIXVAL   R     Pixel value.
C      OPCODE   R     'BLNK' put blanked pixel value instead.
C   (ACTNOISE)
C      PIXSTD   R     Actual rms of image
C      PIXAVG   R     Actual zero level of image
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      INTEGER   NWPUT, NWGET
      PARAMETER (NWPUT = 76)
      PARAMETER (NWGET = 92)
C
      CHARACTER LOCNAM*12, LOCCLS*6, LOCTYP*2, STATUS*4, PRGNAM*6,
     *   HILINE*72, PHNAME*48, XVER(2)*4, CDUM*1, K1(NWPUT)*8,
     *   K2(NWGET-NWPUT)*8, KWORD(NWGET)*8, THEWRD*8, STVALU*16, OPER*4,
     *   DATYPE*4
      INTEGER   POTERR, IUSER, IVOL, LOCSEQ, ISLOT, IBUFF2(256), IERR,
     *   IHLUN, IERH, NBYT, KT, IP, IPOFF, I, IK, KPNTR(62), KBP, J,
     *   KTYPE(NWGET), POINT(NWGET), IKL(10), IC, NC, NMAX, IPIX(7),
     *   DLUN, DIND, NBUFF, NSPR, NRPS, IPOS, IBLKOF, NSPPL, NPLANE,
     *   ITRIM, ITEMP, IDUM(2), LBRANC
      REAL     OLDVAL, RBUFF(512), AVALUE(2), RDUM(2), KEYVAL(2), PIXV,
     *   PIXA, RD(2), RPOFF(2), RTEMP(2)
      DOUBLE PRECISION D
      LOGICAL   SAVE, EQUAL, T, LTEMP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /AIPSCR/ RBUFF, IBUFF2
      EQUIVALENCE (KWORD(1), K1(1)),    (KWORD(NWPUT+1), K2(1))
      EQUIVALENCE (KPNTR(1), KHOBJ)
      EQUIVALENCE (D, RD), (IPOFF, RPOFF(1)), (LTEMP, RTEMP(1))
      DATA XVER /'old ','new '/
      DATA DLUN /16/
      DATA IHLUN, SAVE, T /27, .TRUE.,.TRUE./
      DATA PRGNAM /'AU7A  '/
C                                       PUT and GET keywords
      DATA K1 /'OBJECT  ','TELESCOP','INSTRUME','OBSERVER','DATE-OBS',
     *   'DATE-MAP', 'BUNIT   ', 'CTYPE1  ', 'CTYPE2  ', 'CTYPE3  ',
     *   'CTYPE4  ', 'CTYPE5  ', 'CTYPE6  ', 'CTYPE7  ', 'CRVAL1  ',
     *   'CRVAL2  ', 'CRVAL3  ', 'CRVAL4  ', 'CRVAL5  ', 'CRVAL6  ',
     *   'CRVAL7  ', 'CDELT1  ', 'CDELT2  ', 'CDELT3  ', 'CDELT4  ',
     *   'CDELT5  ', 'CDELT6  ', 'CDELT7  ', 'CRPIX1  ', 'CRPIX2  ',
     *   'CRPIX3  ', 'CRPIX4  ', 'CRPIX5  ', 'CRPIX6  ', 'CRPIX7  ',
     *   'CROTA1  ', 'CROTA2  ', 'CROTA3  ', 'CROTA4  ', 'CROTA5  ',
     *   'CROTA6  ', 'CROTA7  ', 'EPOCH   ', 'DATAMAX ', 'DATAMIN ',
     *   'PRODUCT ', 'NITER   ', 'BMAJ    ', 'BMIN    ', 'BPA     ',
     *   'VELREF  ', 'ALTRVAL ', 'ALTRPIX ', 'OBSRA   ', 'OBSDEC  ',
     *   'RESTFREQ', 'XSHIFT  ', 'YSHIFT  ', 'PTYPE1  ', 'PTYPE2  ',
     *   'PTYPE3  ', 'PTYPE4  ', 'PTYPE5  ', 'PTYPE6  ', 'PTYPE7  ',
     *   'PTYPE8  ', 'PTYPE9  ', 'PTYPE10 ', 'PTYPE11 ', 'PTYPE12 ',
     *   'PTYPE13 ', 'PTYPE14 ', 'SORTORD ', 'IMGTYPE ', 'XPOFF   ',
     *   'YPOFF   '/
C                                       Keywords for GET only
      DATA K2 /'BLANK   ','IMNAME  ','IMCLASS ','IMSEQ   ', 'GCOUNT  ',
     *   'PCOUNT  ', 'NAXIS   ', 'NAXIS1  ', 'NAXIS2  ', 'NAXIS3  ',
     *   'NAXIS4  ', 'NAXIS5  ', 'NAXIS6  ', 'NAXIS7  ', 'USERNO  ',
     *   'IMTYPE  '/
C                                       number of chars + 10 *
C                                       2=Number
C                                       3=String
      DATA KTYPE /       36,38,38,38,38, 38,35,36,36,36, 36,36,36,36,26,
     *   26,26,26,26,26, 26,26,26,26,26, 26,26,26,26,26, 26,26,26,26,26,
     *   26,26,26,26,26, 26,26,25,27,27, 27,25,24,24,23, 26,27,27,25,26,
     *   28,26,26,36,36, 36,36,36,36,36, 36,36,37,37,37, 37,37,37,27,25,
     *   25,
     *   25,36,37,25,26, 26,25,26,26,26, 26,26,26,26,26, 36/
C                                       10000*nbytes + 100*offset +
C                                       position of pointer in common
      DATA POINT / 80001, 80002, 80003, 80004, 80005, 80006,
     *   80007, 80009, 80109, 80209, 80309, 80409, 80509, 80609,
     *   80029, 80129, 80229, 80329, 80429, 80529, 80629, 40010, 40110,
     *   40210, 40310, 40410, 40510, 40610, 40011, 40111, 40211, 40311,
     *   40411, 40511, 40611, 40012, 40112, 40212, 40312, 40412, 40512,
     *   40612, 40013, 40014, 40015, 20044, 20035, 40020, 40021, 40022,
     *   20045, 80033, 40023, 80030, 80031, 80032, 40024, 40025, 80008,
     *   80108, 80208, 80308, 80408, 80508, 80608, 80708, 80808, 80908,
     *   81008, 81108, 81208, 81308, 20044, 20058, 40059, 40060,
     *   40016,120017, 60218, 20042, 20034, 20039, 20040, 20041,
     *   20141, 20241, 20341, 20441, 20541, 20641, 20043, 20919/
C-----------------------------------------------------------------------
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.10)) GO TO 999
      LBRANC = BRANCH
C                                       Set initial values.
      POTERR = 0
      CALL ADVERB ('INDISK', 'I', 1, 0, IDUM, RDUM, CDUM)
      IVOL = IDUM(1)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INSEQ', 'I', 1, 0, IDUM, RDUM, CDUM)
      LOCSEQ = IDUM(1)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INNAME', 'C', 1, 12, IDUM, RDUM, LOCNAM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('INCLASS', 'C', 1, 6, IDUM, RDUM, LOCCLS)
      IF (ERRNUM.NE.0) GO TO 980
      IUSER = NLUSER
      ISLOT = 1
      LOCTYP = ' '
      IF (LBRANC.EQ.4) LOCTYP = 'MA'
      CALL CATDIR ('SRNH', IVOL, ISLOT, LOCNAM, LOCCLS, LOCSEQ, LOCTYP,
     *   IUSER, STATUS, IBUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020)
         CALL MSGWRT (8)
         POTERR = 101
         GO TO 980
         END IF
C                                       Choose function.
      GO TO (100, 200, 200, 400, 500, 500, 550, 550, 200, 200), LBRANC
C-----------------------------------------------------------------------
C                                       ADDBEAM
C                                       add beam parameters to header
C-----------------------------------------------------------------------
 100  CALL CATIO ('READ', IVOL, ISLOT, CATBLK, 'WRIT', IBUFF2, IERR)
      IF (IERR.EQ.0) GO TO 110
         WRITE (MSGTXT,1100) IERR
         IF (IERR.EQ.5) WRITE (MSGTXT,1101)
         POTERR = 33
         GO TO 970
C                                       Open history
 110  CALL HIOPEN (IHLUN, IVOL, ISLOT, IBUFF2, IERH)
      IERR = IERH
C                                       Old beam to HI
      IF ((CATR(KRBMJ).GT.0.) .OR. (CATR(KRBMN).GT.0.) .OR.
     *   (CATR(KRBPA).NE.0.)) THEN
         WRITE (HILINE,1110) CATR(KRBMJ), CATR(KRBMN), CATR(KRBPA),
     *      XVER(1)
         IF (IERH.EQ.0) CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
         END IF
C                                       New beam to HI
      CALL ADVERB ('BMAJ', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CATR(KRBMJ) = RDUM(1) / 3600.0
      CALL ADVERB ('BMIN', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CATR(KRBMN) = RDUM(1) / 3600.0
      CALL ADVERB ('BPA', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CATR(KRBPA) = RDUM(1)
      WRITE (HILINE,1110) CATR(KRBMJ), CATR(KRBMN), CATR(KRBPA),
     *   XVER(2)
      IF (IERH.EQ.0) CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
C                                       Close history file.
      IF (IERR.EQ.0) CALL HICLOS (IHLUN, SAVE, IBUFF2, IERR)
C                                       Save header
      CALL CATIO ('UPDT', IVOL, ISLOT, CATBLK, 'CLWR', IBUFF2, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.9)) POTERR = 33
      IF (POTERR.EQ.0) GO TO 980
         WRITE (MSGTXT,1120) IERR
         GO TO 970
C-----------------------------------------------------------------------
C                                       PUTHEAD, GETHEAD
C                                       Change a header value
C-----------------------------------------------------------------------
C                                       Find keyword in lists
 200  IF (LBRANC.NE.9) THEN
         CALL ADVERB ('KEYWORD', 'C', 1, 8, IDUM, RDUM, THEWRD)
         IF (ERRNUM.NE.0) GO TO 980
C                                       KEYTYPE
         CALL ADVERB ('KEYTYPE', 'C', 1, 4, IDUM, RDUM, DATYPE)
         IF (ERRNUM.NE.0) GO TO 980
C                                       KEYSTRING
         CALL ADVERB ('KEYSTRNG', 'C', 1, 16, IDUM, RDUM, STVALU)
         IF (ERRNUM.NE.0) GO TO 980
C                                       Insert keyword in header
         CALL ADVERB ('KEYVALUE', 'R', 2, 0, IDUM, KEYVAL, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         IF (BRANCH.EQ.10) THEN
            LBRANC = 3
            RDUM(1) = -1.0
            CALL ADVRBS ('ERROR', 'R', 1, 0, IDUM, RDUM, CDUM)
            IF (ERRNUM.NE.0) GO TO 980
            END IF
C                                       ACTNOISE
      ELSE
         LBRANC = 2
         THEWRD = 'ACTNOISE'
         DATYPE = 'R'
         STVALU = ' '
         KEYVAL(2) = 0
         CALL ADVERB ('PIXSTD', 'R', 1, 0, IDUM, KEYVAL, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         CALL ADVERB ('PIXAVG', 'R', 1, 0, IDUM, RDUM, CDUM)
         PIXA = RDUM(1)
         IF (ERRNUM.NE.0) GO TO 980
         END IF
      NC = ITRIM (THEWRD)
      IP = 0
      NMAX = NWPUT
      IF (LBRANC.EQ.3) THEN
         NMAX = NWGET
         IF ((THEWRD(:6).EQ.'EXTVER') .OR. (THEWRD(:6).EQ.'EXTYPE'))
     *      GO TO 315
         END IF
      IF (NC.GT.0) THEN
         DO 205 IK = 1,NWGET
            IC = MOD (KTYPE(IK), 10)
            IF (NC.LE.IC) THEN
               IF (THEWRD(1:NC).EQ.KWORD(IK)(1:NC)) THEN
C                                       Found match
                  IF (IC.EQ.NC) THEN
                     GO TO 215
C                                       Header keyword name longer than
C                                       KEYWORD - save up to 10 possible
C                                       matches.
                  ELSE
                     IP = IP + 1
                     IKL(IP) = IK
                     IF (IP.EQ.10) GO TO 210
                     END IF
                  END IF
               END IF
 205        CONTINUE
         END IF
 210  IK = IKL(1)
C                                       One match
      IF (IP.EQ.1) GO TO 215
C                                       No match write as header
C                                       keyword/value pair
      IF ((IP.LE.0) .AND. (LBRANC.EQ.2)) THEN
         CALL PUTKEY (IVOL, ISLOT, THEWRD, DATYPE, KEYVAL, STVALU(:8),
     *      IERR)
         IF (IERR.NE.0) THEN
            POTERR = 33
            GO TO 980
            END IF
         IF (BRANCH.EQ.9) THEN
            THEWRD = 'ACTMEAN'
            KEYVAL(1) = PIXA
            CALL PUTKEY (IVOL, ISLOT, THEWRD, DATYPE, KEYVAL,
     *         STVALU(:8), IERR)
            IF (IERR.NE.0) THEN
               POTERR = 33
               GO TO 980
               END IF
            END IF
         GO TO 980
         END IF
C                                       Multiple possible matches
      IF (IP.GT.1) THEN
C                                       Tell possibilities
         J = MIN (5, IP)
         WRITE (MSGTXT,1210) (KWORD(IKL(I)), I = 1,J)
         CALL MSGWRT (8)
         IF (J.LT.IP) THEN
            WRITE (MSGTXT,1210) (KWORD(IKL(I)), I = 6,IP)
            CALL MSGWRT (8)
            END IF
C                                       Bail out
            POTERR = 101
            GO TO 980
         END IF
 213  IF (LBRANC.EQ.3) GO TO 300
 214  IF (BRANCH.NE.10) THEN
         WRITE (MSGTXT,1213) THEWRD
         IF (IP.EQ.1) WRITE (MSGTXT,1214) THEWRD
         CALL MSGWRT (8)
         POTERR = 101
      ELSE
         POTERR = 0
         RDUM(1) = 1.0
         CALL ADVRBS ('ERROR', 'R', 1, 0, IDUM, RDUM, CDUM)
         END IF
      GO TO 980
C                                       Read Catblk, set status
 215  THEWRD = KWORD(IK)
      IF (LBRANC.EQ.3) GO TO 315
C                                       Ok for PUT ?
      IF (IK.LE.NWPUT) GO TO 218
         IF (KWORD(IK).EQ.'USERNO') THEN
            KT = KEYVAL(1) + 0.001
            IF (KT.EQ.NLUSER) GO TO 218
            END IF
C                                       No
         GO TO 213
 218  CALL CATIO ('READ', IVOL, ISLOT, CATBLK, 'WRIT', IBUFF2, IERR)
      IF (IERR.EQ.0) GO TO 220
         WRITE (MSGTXT,1100) IERR
         IF (IERR.EQ.5) WRITE (MSGTXT,1101)
         POTERR = 33
         GO TO 970
C                                       Set pointers
 220  NBYT = POINT(IK) / 10000
      KT = KTYPE(IK) / 10
      IP = POINT(IK) - 10000 * NBYT
      IPOFF = IP / 100
      IP = IP - 100 * IPOFF
      IP = KPNTR(IP)
C                                       Open history
      CALL HIOPEN (IHLUN, IVOL, ISLOT, IBUFF2, IERH)
      IERR = IERH
C                                       Old, new values to HI
C                                       Regular strings
      IF (KT.NE.3) GO TO 230
         IPOFF = IPOFF * ((NBYT+3) / 4)
         CALL H2CHR (NBYT, 1, CATH(IP+IPOFF), STVALU)
         WRITE (HILINE,1220) THEWRD, STVALU(1:NBYT), XVER(1)
         IF (IERH.EQ.0) CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
         I = MIN (NBYT, 8)
         CALL ADVERB ('KEYSTRNG', 'C', 1, 16, IDUM, RDUM, STVALU)
         IF (ERRNUM.NE.0) GO TO 980
         WRITE (HILINE,1220) THEWRD, STVALU(1:NBYT), XVER(2)
         IF (IERH.EQ.0) CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
         CALL CHR2H (I, STVALU(1:I), 1, CATH(IP+IPOFF))
         GO TO 250
C                                       Numeric parameters
 230  CALL POPSRD ('R2D', KEYVAL, D)
      IF (NBYT.NE.2) GO TO 235
         I = D + SIGN (0.5D0, D)
         WRITE (HILINE,1230) THEWRD, CATBLK(IP+IPOFF), XVER(1)
         IF (IERH.EQ.0) CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
         CATBLK(IP+IPOFF) = I
         WRITE (HILINE,1230) THEWRD, CATBLK(IP+IPOFF), XVER(2)
         IF (IERH.EQ.0) CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
         GO TO 250
 235  IF (NBYT.NE.4) GO TO 240
         WRITE (HILINE,1235) THEWRD, CATR(IP+IPOFF), XVER(1)
         IF (IERH.EQ.0) CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
         CATR(IP+IPOFF) = D
         WRITE (HILINE,1235) THEWRD, CATR(IP+IPOFF), XVER(2)
         IF (IERH.EQ.0) CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
         GO TO 250
 240  IF (NBYT.NE.8) GO TO 250
         WRITE (HILINE,1240) THEWRD, CATD(IP+IPOFF), XVER(1)
         IF (IERH.EQ.0) CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
         CATD(IP+IPOFF) = D
         WRITE (HILINE,1240) THEWRD, CATD(IP+IPOFF), XVER(2)
         IF (IERH.EQ.0) CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
         GO TO 250
C                                       Close history file.
 250  IF (IERR.EQ.0) CALL HICLOS (IHLUN, SAVE, IBUFF2, IERH)
C                                       Save header
      CALL CATIO ('UPDT', IVOL, ISLOT, CATBLK, 'CLWR', IBUFF2, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.9)) POTERR = 33
      IF (POTERR.EQ.0) GO TO 980
         WRITE (MSGTXT,1120) IERR
         GO TO 970
C-----------------------------------------------------------------------
C                                       GETHEAD
C                                       Read header value
C-----------------------------------------------------------------------
C                                       Look for keyword in CB keywords
 300  ITEMP = 1
      IF (BRANCH.EQ.10) MSGSUP = 32000
      CALL CATKEY ('READ', IVOL, ISLOT, THEWRD, ITEMP, IPOFF, AVALUE,
     *   IK, IBUFF2, IERR)
      MSGSUP = 0
      IF (IERR.NE.0) GO TO 214
      IF (IK.EQ.1) THEN
         CALL RCOPY (NWDPDP, AVALUE, RD)
         CALL POPSRD ('D2R', KEYVAL, D)
         CALL ADVRBS ('KEYVALUE', 'R', 2, 0, IDUM, KEYVAL, CDUM)
      ELSE IF (IK.EQ.2) THEN
         KEYVAL(1) = AVALUE(1)
         KEYVAL(2) = 0.
         CALL ADVRBS ('KEYVALUE', 'R', 2, 0, IDUM, KEYVAL, CDUM)
      ELSE IF (IK.EQ.3) THEN
         STVALU = ' '
         CALL H2CHR (8, 1, AVALUE, STVALU)
         CALL ADVRBS ('KEYSTRNG', 'C', 1, 16, IDUM, RDUM, STVALU)
      ELSE IF (IK.EQ.4) THEN
         CALL RCOPY (1, AVALUE, RPOFF)
         KEYVAL(1) = IPOFF
         KEYVAL(2) = 0.
         CALL ADVRBS ('KEYVALUE', 'R', 2, 0, IDUM, KEYVAL, CDUM)
      ELSE IF (IK.EQ.5) THEN
         CALL RCOPY (1, AVALUE, RTEMP)
         KEYVAL(1) = -1.0
         IF (LTEMP) KEYVAL(1) = 1.0
         KEYVAL(2) = 0.
         CALL ADVRBS ('KEYVALUE', 'R', 2, 0, IDUM, KEYVAL, CDUM)
         END IF
      IF (ERRNUM.NE.0) GO TO 980
      GO TO 999
C                                       Read Catblk, set status
 315  CALL CATIO ('READ', IVOL, ISLOT, CATBLK, 'READ', IBUFF2, IERR)
      IF ((IERR.NE.0) .AND. ((IERR.LT.6) .OR. (IERR.GT.9))) THEN
         WRITE (MSGTXT,1100) IERR
         IF (IERR.EQ.5) WRITE (MSGTXT,1101)
         POTERR = 33
         GO TO 970
         END IF
C                                       Set pointers
      CALL FXHDEX (CATBLK)
      IF ((THEWRD(:6).EQ.'EXTVER') .OR. (THEWRD(:6).EQ.'EXTYPE')) THEN
         KBP = 1
         CALL GETNUM (THEWRD(7:8), 2, KBP, D)
         IF (ERRNUM.NE.0) GO TO 980
         IPOFF = D - 0.99
         POTERR = 27
         IF ((IPOFF.LT.0) .OR. (IPOFF.GE.KIEXTN)) GO TO 970
         POTERR = 0
         NBYT = 2
         IF (THEWRD(:6).EQ.'EXTVER') THEN
            KT = 2
            IP = KIVER
         ELSE IF (THEWRD(:6).EQ.'EXTYPE') THEN
            KT = 3
            IP = KHEXT
            END IF
      ELSE
         NBYT = POINT(IK) / 10000
         KT = KTYPE(IK) / 10
         IP = POINT(IK) - 10000 * NBYT
         IPOFF = IP / 100
         IP = IP - 100 * IPOFF
         IP = KPNTR(IP)
         END IF
C                                       Strings
      IF (KT.EQ.3) THEN
         STVALU = ' '
C                                       IMCLASS, IMTYPE
         IF ((KWORD(IK).EQ.'IMCLASS') .OR. (KWORD(IK).EQ.'IMTYPE')) THEN
            IPOFF = NBYT * IPOFF + 1
            CALL H2CHR (NBYT, IPOFF, CATH(IP), STVALU)
         ELSE
            IPOFF = IPOFF * ((NBYT+3) / 4)
            CALL H2CHR (NBYT, 1, CATH(IP+IPOFF), STVALU)
            END IF
         CALL ADVRBS ('KEYSTRNG', 'C', 1, 16, IDUM, RDUM, STVALU)
C                                       Numeric parameters
      ELSE
         IF (NBYT.EQ.2) D = CATBLK(IP+IPOFF)
         IF (NBYT.EQ.4) D = CATR(IP+IPOFF)
         IF (NBYT.EQ.8) D = CATD(IP+IPOFF)
         CALL POPSRD ('D2R', KEYVAL, D)
         CALL ADVRBS ('KEYVALUE', 'R', 2, 0, IDUM, KEYVAL, CDUM)
         END IF
      IF (ERRNUM.NE.0) GO TO 980
C                                       Clear status
      CALL CATDIR ('CSTA', IVOL, ISLOT, LOCNAM, LOCCLS, LOCSEQ, LOCTYP,
     *   IUSER, 'CLRD', IBUFF2, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.9)) POTERR = 33
      GO TO 980
C-----------------------------------------------------------------------
C                                       PUTVALUE
C                                       add pixel value to image
C-----------------------------------------------------------------------
C                                       open map file
 400  CALL CATIO ('READ', IVOL, ISLOT, CATBLK, 'WRIT', IBUFF2, IERR)
      IF (IERR.EQ.0) GO TO 410
         WRITE (MSGTXT,1100) IERR
         IF (IERR.EQ.5) WRITE (MSGTXT,1101)
         POTERR = 33
         GO TO 970
C                                       Check pixel position
 410  CALL ADVERB ('PIXXY', 'I', 7, 0, IPIX, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      DO 420 I = 1,KICTPN
         IF ((CATBLK(KIDIM).GE.I) .AND. (CATBLK(KINAX+I-1).GT.1))
     *      THEN
            IF ((IPIX(I).LT.1) .OR. (IPIX(I).GT.CATBLK(KINAX+I-1))) THEN
               POTERR = 32
               WRITE (MSGTXT,1415)
               GO TO 490
               END IF
         ELSE
            IPIX(I) = 1
            END IF
 420     CONTINUE
C                                       Open map file
      CALL ZPHFIL ('MA', IVOL, ISLOT, 1, PHNAME, IERR)
      CALL ZOPEN (DLUN, DIND, IVOL, PHNAME, T, T, T, IERR)
      IF (IERR.EQ.0) GO TO 425
         POTERR = 50
         WRITE (MSGTXT,1420) IERR
         GO TO 490
C                                       Read old pixel value
 425  NBUFF = 2 * CATBLK(KINAX)
      NRPS = NBPS / NBUFF
      IF (NRPS.LT.1) NRPS = 1
      NSPR = (NBUFF - 1) / NBPS + 1
      NSPPL = (CATBLK(KINAX+1) - 1) / NRPS + 1
      NSPPL = NSPR * NSPPL
      NPLANE = 0
      I = CATBLK(KIDIM)
      IF (I.LE.2) GO TO 435
      NPLANE = IPIX(I) - 1
 430  I = I - 1
      IF (I.LE.2) GO TO 435
         NPLANE = NPLANE * CATBLK(KINAX+I-1) + IPIX(I) - 1
         GO TO 430
 435  IPOS = ((IPIX(1)-1) * 2) / NBPS
      IBLKOF = NSPPL * NPLANE + ((IPIX(2)-1)/NRPS) * NSPR + 1 + IPOS
      IPOS = IPIX(1) - IPOS * NBPS / 2 +
     *   CATBLK(KINAX) * MOD (IPIX(2)-1, NRPS)
      CALL ZMIO ('READ', DLUN, DIND, IBLKOF, NBPS, RBUFF, 1, IERR)
      IF (IERR.EQ.0) CALL ZWAIT (DLUN, DIND, 1, IERR)
      IF (IERR.NE.0) GO TO 480
      OLDVAL = RBUFF(IPOS)
      CALL ADVERB ('PIXVAL', 'R', 1, 0, IDUM, RDUM, CDUM)
      PIXV = RDUM(1)
      IF (ERRNUM.NE.0) GO TO 980
      RBUFF(IPOS) = PIXV
      CALL ADVERB ('OPCODE', 'C', 1, 4, IDUM, RDUM, STATUS)
      IF (ERRNUM.NE.0) GO TO 980
      EQUAL = STATUS.EQ.'BLNK'
      IF (EQUAL) RBUFF(IPOS) = FBLANK
      CALL ZMIO ('WRIT', DLUN, DIND, IBLKOF, NBPS, RBUFF, 1, IERR)
      IF (IERR.EQ.0) CALL ZWAIT (DLUN, DIND, 1, IERR)
      IF (IERR.NE.0) GO TO 480
      CALL ZCLOSE (DLUN, DIND, IERR)
C                                       Update header?
      IF ((EQUAL) .AND. (CATR(KRBLK).EQ.FBLANK)) GO TO 460
      IF ((.NOT.EQUAL) .AND. (PIXV.GE.CATR(KRDMN)) .AND.
     *   (PIXV.LE.CATR(KRDMX))) GO TO 460
         IF (EQUAL) CATR(KRBLK) = FBLANK
         IF ((.NOT.EQUAL) .AND. (PIXV.LT.CATR(KRDMN))) CATR(KRDMN) =
     *      PIXV
         IF ((.NOT.EQUAL) .AND. (PIXV.GT.CATR(KRDMX))) CATR(KRDMX) =
     *      PIXV
         CALL CATIO ('UPDT', IVOL, ISLOT, CATBLK, 'REST', IBUFF2, IERR)
         IF (IERR.EQ.0) GO TO 460
            WRITE (MSGTXT,1425) IERR
            CALL MSGWRT (8)
C                                       Open history
 460  CALL ADVERB ('DOHIST', 'R', 1, 0, IDUM,  RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IF (RDUM(1).LT.-1.5) GO TO 495
         CALL HIOPEN (IHLUN, IVOL, ISLOT, IBUFF2, IERH)
         IF (IERH.NE.0) GO TO 470
            J = CATBLK(KIDIM)
            WRITE (HILINE,1460) IPIX
            CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
            IF (IERH.NE.0) GO TO 470
            IF (OLDVAL.NE.FBLANK) WRITE (HILINE,1461) XVER(1), OLDVAL
            IF (OLDVAL.EQ.FBLANK) WRITE (HILINE,1462) XVER(1)
            CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
            IF (IERH.NE.0) GO TO 470
            IF (.NOT.EQUAL) WRITE (HILINE,1461) XVER(2), PIXV
            IF (EQUAL) WRITE (HILINE,1462) XVER(2)
            CALL HIADD (IHLUN, HILINE, IBUFF2, IERH)
 470     CALL HICLOS (IHLUN, SAVE, IBUFF2, IERH)
         GO TO 495
C                                       Map IO error
 480  WRITE (MSGTXT,1480) IERR
      CALL MSGWRT (8)
      CALL ZCLOSE (DLUN, DIND, IERR)
      IERR = 0
      GO TO 495
C                                       error
 490  CALL MSGWRT (8)
C                                       Clear status
 495  CALL CATDIR ('CSTA', IVOL, ISLOT, LOCNAM, LOCCLS, LOCSEQ, LOCTYP,
     *   IUSER, 'CLWR', IBUFF2, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.9)) POTERR = 33
      GO TO 980
C-----------------------------------------------------------------------
C                                       GETTHEAD, PUTTHEAD
C                                       Read/write table keyword value
C                                       pairs.
C-----------------------------------------------------------------------
 500  OPER = 'READ'
      IF (LBRANC.EQ.6) OPER = 'WRIT'
      CALL TBHEAD (OPER, IVOL, ISLOT, IERR)
      GO TO 980
C-----------------------------------------------------------------------
C                                       TABGET, TABPUT
C                                       Read/write table entries.
C-----------------------------------------------------------------------
 550  OPER = 'READ'
      IF (LBRANC.EQ.8) OPER = 'WRIT'
      CALL TBDATA (OPER, IVOL, ISLOT, IERR)
      GO TO 980
C-----------------------------------------------------------------------
C                                       Print error.
 970  CALL MSGWRT (8)
C                                       AIPS error management.
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.EQ.0) GO TO 999
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('CATALOG ENTRY NOT FOUND')
 1100 FORMAT ('CATALOG READ ERROR',I5)
 1101 FORMAT ('MAP TOO BUSY')
 1110 FORMAT ('ADDBEAM BMAJ=',1PE13.5,' BMIN=',1PE13.5,' BPA=',0PF8.3,
     *   ' / ',A3)
 1120 FORMAT ('CATALOG WRITE ERROR',I5)
 1210 FORMAT ('COULD BE:',5(2X,A8))
 1213 FORMAT ('KEYWORD =''',A8,''' NOT RECOGNIZED')
 1214 FORMAT ('KEYWORD =''',A8,''' ALLOWED ONLY FOR GETHEAD')
 1220 FORMAT ('PUTHEAD ',A8,' =''',A,'''',9X,'/ ',A3)
 1230 FORMAT ('PUTHEAD ',A8,' =',I9,10X,'/ ',A3)
 1235 FORMAT ('PUTHEAD ',A8,' =',1PE13.5,6X,'/ ',A3)
 1240 FORMAT ('PUTHEAD ',A8,' =',1PE17.9,2X,'/ ',A3)
 1415 FORMAT ('PIXXY OUT OF RANGE OR NOT ON PIXEL')
 1420 FORMAT ('ERROR',I5,' OPENING IMAGE FILE')
 1425 FORMAT ('UNABLE TO UPDATE HEADER FOR IMAGE CHANGES: ERROR',I5)
 1460 FORMAT ('PUTVALUE PIXXY=',I7,6(',',I6))
 1461 FORMAT ('PUTVALUE / ',A3,' value=',1PE14.6)
 1462 FORMAT ('PUTVALUE / ',A3,' value blanked')
 1480 FORMAT ('ERROR',I5,' DOING IMAGE IO')
      END

      SUBROUTINE COORDT (ITI, ITO, LONGI, LATI, EPOK, LONGO, LATO, IERR)
C-----------------------------------------------------------------------
C! translates between celestial, galactic, and eccliptic coordinates
C# Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   COORDT translates between types of coordinates:
C   Inputs: ITI    I     Input type (1 Ra, Dec; 2 gal, 3 ecliptic)
C           ITO    I     Output type
C           LONGI  D     Input longitude
C           LATI   D     Input latitude
C           EPOK   R     Epoch of positions (used very simply with
C                        ecliptic coords only)
C                        1950 or 2000 assumed in Galactic conversions!!!
C   Output: LONGO  D     Output longitude
C           LATI   D     Output latitude
C           IERR   I     error: 0 ok, 1 input error, 2 conversion fails
C-----------------------------------------------------------------------
      INTEGER   ITI, ITO, IERR
      REAL      EPOK
      DOUBLE PRECISION    LONGI, LATI, LONGO, LATO
C                                           define PI/180 and 2PI
      DOUBLE PRECISION DEGRAD, CIRC
      PARAMETER (DEGRAD=1.745329251994329576D-2, 
     *   CIRC = 6.2831853071795865788D0)
      DOUBLE PRECISION RAGP, DECGP, LONCP, DEC, RA, DT,
     *   GLAT, GLON, ELAT, ELON, RAGP0, DECGP0, LONCP0, DEPS0(4), EPS
      DATA DEPS0 /23.452294D0, -0.0130125D0, -1.64D-6, 5.03D-7/
C-----------------------------------------------------------------------
      IERR = 1
      IF ((ITI.LT.1) .OR. (ITI.GT.3)) GO TO 999
      IF ((ITO.LT.1) .OR. (ITO.GT.3)) GO TO 999
      IERR = 0
C                                       null cases
      LONGO = LONGI
      LATO = LATI
      IF (ITI.EQ.ITO) GO TO 999
      DT = 0.0D0
      IF ((ITI.EQ.3) .OR. (ITO.EQ.3)) DT = (EPOK - 1900.0) / 100.0
      EPS = DEPS0(1) + DT * (DEPS0(2) + DT*(DEPS0(3) + DT*DEPS0(4)))
      EPS = EPS * DEGRAD
C                                       Get galactic coords for Epoch
      CALL GALPOL( EPOK, RAGP0, DECGP0, LONCP0)
      RAGP  =  RAGP0 * DEGRAD
      DECGP =  DECGP0 * DEGRAD
      LONCP = LONCP0 * DEGRAD
      GO TO (100, 200, 300), ITI
C                                       Ra, Dec in
 100  DEC = LATI * DEGRAD
      RA = LONGI * DEGRAD
C                                       Galactic out
 110  IF (ITO.EQ.3) GO TO 150
         GLAT = ASIN (SIN(DEC)*SIN(DECGP) + COS(DEC)*COS(DECGP)*
     *      COS(RA-RAGP))
         GLON = LONCP + ATAN2 (COS(DEC)*SIN(RAGP-RA), SIN(DEC)*
     *      COS(DECGP) - COS(DEC)*SIN(DECGP)*COS(RA-RAGP))
         IF (GLON.GE.CIRC) GLON = GLON - CIRC
         IF (GLON.LT.0.0D0) GLON = GLON + CIRC
         LATO = GLAT / DEGRAD
         LONGO = GLON / DEGRAD
         GO TO 999
C                                       Ecliptic out
 150  CONTINUE
         ELAT = ASIN (SIN(DEC)*COS(EPS) - COS(DEC)*SIN(EPS)*
     *      SIN(RA))
         ELON = ATAN2 (SIN(DEC)*SIN(EPS) -
     *      COS(DEC)*COS(EPS)*SIN(RA), COS(DEC)*COS(RA))
         IF (ELON.GE.CIRC) ELON = ELON - CIRC
         IF (ELON.LT.0.0D0) ELON = ELON + CIRC
         LATO = ELAT / DEGRAD
         LONGO = ELON / DEGRAD
         GO TO 999
C                                       Galactic in
 200  GLAT = LATI * DEGRAD
      GLON = LONGI * DEGRAD
      DEC = ASIN (SIN(GLAT)*SIN(DECGP) + COS(GLAT)*COS(DECGP)*
     *   COS(GLON-LONCP))
      RA = RAGP + ATAN2 (COS(GLAT)*SIN(LONCP-GLON), SIN(GLAT)*
     *   COS(DECGP) - COS(GLAT)*SIN(DECGP)*COS(GLON-LONCP))
C                                       Ra, Dec out
 210  IF (ITO.EQ.3) GO TO 150
         IF (RA.GE.CIRC) RA = RA - CIRC
         IF (RA.LT.0.0D0) RA = RA + CIRC
         LONGO = RA / DEGRAD
         LATO = DEC / DEGRAD
         GO TO 999
C                                       Ecliptic in
 300  ELAT = LATI * DEGRAD
      ELON = LONGI * DEGRAD
      DEC = ASIN (SIN(ELAT)*COS(EPS) +
     *   COS(ELAT)*SIN(EPS)*SIN(ELON))
      RA = ATAN2 (COS(ELAT)*COS(EPS)*SIN(ELON) -
     *   SIN(ELAT)*SIN(EPS), COS(ELAT)*COS(ELON))
C                                       Ra, Dec out
      IF (ITO.EQ.2) GO TO 110
      GO TO 210
C
 999  RETURN
      END

      SUBROUTINE BPREFM (DISK, CNO, VER, CATBLK, LUN, IRET)
C-----------------------------------------------------------------------
C! Checks existence of BP table, changes format if necessary
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to change the format of the BP table from one containing
C   13/10 columns to the 14/11 columns needed by the addition of the
C   FREQID column.
C   As of Sept 1, 1994 the IFFREQ column has become the CHN_SHIFT
C   column in order to deal with VLBA bandpasses. BPREFM will
C   change the column labels and if the values in the new column
C   are > 100.0 will set them to zero.
C   As of 25 November, 1997 it also takes a single LL polarization data
C   set and converts the 2 polarization BP table into a 1 pol table.
C   NOTE: routine uses LUN 45 as a temporary logical unit number.
C
C   Inputs:
C      DISK            I       Volume number
C      CNO             I       Catalogue number
C      VER             I       Version to check/modify
C      CATBLK(256)     I       Catalogue header
C      LUN             I       LUN to use
C   Output:
C      IRET            I       Error, 0 => OK
C
C   Note, routine will leave no trace of its operation, i.e. BP table
C   will be closed on output and will have same number as one specified.
C   Difference will be only that number of columns has changed if that
C   is required.
C-----------------------------------------------------------------------
      INTEGER DISK, CNO, VER, CATBLK(256), LUN, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER CTEMP*12, UTYPE*2, STAT*4, KEYCOL*24, LBTYPE*8
      INTEGER   BUFFER(512), OBUFF(512), IBPRNO, BPKOLS(MAXBPC),
     *   BPNUMV(MAXBPC),  NUMANT, NUMPOL, NUMIF, NUMFRQ, BCHAN, OVER,
     *   OLUN, OKOLS(MAXBPC), ONUMV(MAXBPC), NBPROW, I, SOURID, ANTNO,
     *   SUBA, FREQID, REFANT(2), OBPRNO, MSGSAV, IDUM, NKEY, LKEY,
     *   KOLS, IIF, NUMSHF, CATI(256), NCOR, TCOR0, NUMPO, NUMV, NUMP,
     *   KLOCS
      REAL      TIMEI, BNDPAS(2,MAXCIF), WEIGHT(2*MAXIF), BANDW, LOWSHF,
     *   DELSHF, CATR(256)
      DOUBLE PRECISION TIME, IFFREQ(MAXIF), CATD(128)
      HOLLERITH CATH(256)
      LOGICAL CHSTAT, LORDER, DOSTOK, DOIFFR, DOOLD
      SAVE BNDPAS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (BUFFER, CATI, CATR, CATH, CATD)
      DATA OLUN /45/
C-----------------------------------------------------------------------
C                                       Check STOKES parms
      CALL COPY (256, CATBLK, CATI)
      CALL AXEFND (8, 'STOKES  ', CATI(KIDIM), CATH(KHCTP), KLOCS, I)
      NCOR = CATI(KINAX+KLOCS)
      TIME = CATD(KDCRV+KLOCS) + (1.0-CATR(KRCRP+KLOCS)) *
     *   CATR(KRCIC+KLOCS)
      IF (TIME.GT.0.0D0) TCOR0 = TIME + 0.5D0
      IF (TIME.LE.0.0D0) TCOR0 = TIME - 0.5D0
      DOSTOK = (TCOR0.EQ.-2) .AND. (NCOR.EQ.1)
C                                       Open BP file
      CALL BPINI ('READ', BUFFER, DISK, CNO, VER, CATBLK, LUN, IBPRNO,
     *   BPKOLS, BPNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ, BCHAN, NUMSHF,
     *   LOWSHF, DELSHF, LBTYPE, IRET)
      IF (IRET.EQ.2) THEN
         IRET = 0
         GO TO 999
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
      DOSTOK = DOSTOK .AND. (NUMPOL.EQ.2)
C                                       Is the IFFREQ column still
C                                       present?
      NKEY = 1
      KEYCOL = 'IF FREQ'
      LKEY = 7
      LORDER = .TRUE.
      CALL FNDCOL (NKEY, KEYCOL, LKEY, LORDER, BUFFER, KOLS, IRET)
      DOIFFR = KOLS.GT.0
C                                       column number => format!
      IF (.NOT.DOIFFR) THEN
C                                       Is it new format?
         IF ((BUFFER(10).EQ.8+3*NUMPOL) .OR. (BUFFER(10).EQ.8+4*NUMPOL))
     *      THEN
            DOOLD = .FALSE.
C                                       Check is old format
         ELSE IF (BUFFER(10).NE.7+3*NUMPOL) THEN
            WRITE (MSGTXT,1000) BUFFER(10)
            IRET = 1
            GO TO 990
         ELSE
            DOOLD = .TRUE.
            END IF
         END IF
      IF ((.NOT.DOOLD) .AND. (.NOT.DOIFFR) .AND. (.NOT.DOSTOK)) THEN
         CALL TABIO ('CLOS', 0, IBPRNO, BUFFER, BUFFER, IRET)
         GO TO 999
         END IF
C                                       Determine status of file
      UTYPE = 'UV'
      CHSTAT = .FALSE.
      CALL CATDIR ('INFO', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE, IDUM,
     *   STAT, OBUFF, IRET)
C                                       Change status
      IF (STAT.EQ.'READ') THEN
         STAT = 'CLRD'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'CLRD'
            GO TO 990
            END IF
         STAT = 'WRIT'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'WRIT'
            GO TO 990
            END IF
         CHSTAT = .TRUE.
         END IF
C                                       # rows in old table
      NBPROW = BUFFER(5)
C                                       Open up new BP table
      OVER = 0
      NUMPO = NUMPOL
      IF (DOSTOK) NUMPO = 1
      CALL BPINI ('WRIT', OBUFF, DISK, CNO, OVER, CATBLK, OLUN, OBPRNO,
     *   OKOLS, ONUMV, NUMANT, NUMPO, NUMIF, NUMFRQ, BCHAN, NUMSHF,
     *   LOWSHF, DELSHF, LBTYPE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Loop and copy
      NUMP = NUMPO * NUMIF * NUMFRQ + 1
      NUMV = (NUMP - 1) * 2
      DO 100 I = 1,NBPROW
         CALL TABBP ('READ', BUFFER, IBPRNO, BPKOLS, BPNUMV, NUMIF,
     *      NUMFRQ, NUMPOL, TIME, TIMEI, SOURID, SUBA, ANTNO, BANDW,
     *      IFFREQ, FREQID, REFANT, WEIGHT, BNDPAS, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1020) IRET
            GO TO 990
            END IF
C                                       Reset IFFREQ column if needed
         IF ((DOOLD) .OR. (DOIFFR)) THEN
            DO 10 IIF = 1,NUMIF
               IF (IFFREQ(IIF).GT.100.D0) IFFREQ(IIF) = 0.D0
 10            CONTINUE
            END IF
C                                       move pol 2 to pol 1
         IF (DOSTOK) THEN
            CALL RCOPY (NUMV, BNDPAS(1,NUMP), BNDPAS(1,1))
            CALL RCOPY (NUMIF, WEIGHT(NUMIF+1), WEIGHT(1))
            REFANT(1) = REFANT(2)
            END IF
C                                       write to new file
         CALL TABBP ('WRIT', OBUFF, OBPRNO, OKOLS, ONUMV, NUMIF, NUMFRQ,
     *      NUMPO, TIME, TIMEI, SOURID, SUBA, ANTNO, BANDW, IFFREQ,
     *      FREQID, REFANT, WEIGHT, BNDPAS, IRET)
         IF (IRET.GT.0) GO TO 999
 100     CONTINUE
C                                       Close both tables
      CALL TABIO ('CLOS', 0, IBPRNO, BUFFER, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OBPRNO, OBUFF, OBUFF, IRET)
C                                       Delete the original file
      CALL RMEXT (DISK, CNO, 'BP', VER, CATBLK, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy new file to place
C                                       occupied by old one
      MSGSAV = MSGSUP
      MSGSUP = 31999
      CALL TABCOP ('BP', OVER, VER, OLUN, LUN, DISK, DISK, CNO, CNO,
     *   CATBLK, OBUFF, BUFFER, IRET)
      MSGSUP = MSGSAV
      IF (IRET.NE.0) GO TO 999
C                                       Delete the now defunct
C                                       original output file
      CALL RMEXT (DISK, CNO, 'BP', OVER, CATBLK, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Check if changed status
      IF (CHSTAT) THEN
         STAT = 'CLWR'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'CLWR'
            GO TO 990
            END IF
         STAT = 'READ'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'READ'
            GO TO 990
            END IF
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPREFM: UNKNOWN BP FORMAT, # COLS = ',I3)
 1010 FORMAT ('BPREFM: ERROR ',I3,' RETURNED FROM BPINI')
 1020 FORMAT ('BPREFM: ERROR ',I3,' READING OLD FORMAT BP TABLE')
 1080 FORMAT ('BPREFM: ERROR ',I3,' CHANGING ',A4,' STATUS')
      END

      SUBROUTINE APIO (APCORE, OPCODE, FLIST, APLOC, BUFFER, IRET)
C-----------------------------------------------------------------------
C! Copies image-like data between disk and "AP memory".
C# AP-util IO-util Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2015, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   APIO transfers image-like data between disk files and the array
C   processor.  The file open and close and initialization logic are
C   all contained in this routine.  Information about the file and the
C   the desired properties of the I/O are contained in the array FLIST.
C   APIO can access either cataloged 'MA' type files or scratch files
C   using the /CFILES/ common system.
C   APIO can handle arbitrary row lengths with any size buffer larger
C   than one disk block.  This is done by breaking up the logical
C   records.  NOTE: it is important that data read with APIO have been
C   written by APIO using the same buffer if the buffer is shorter than
C   the row size.  The problem is that APIO will break up logical
C   records if they are  longer than the buffer size and MDISK may leave
C   blank space on the disk if the shorter logical record does not fill
C   a  disk sector.
C    Useage notes:
C     1) Opening the file.  If APIO determines that the file is not open
C        it will do so.  The file can be either a cataloged file or a
C        scratch file using the /CFILES/ common system.  If the
C        catalog slot number given in FLIST is 0 or less the file is
C        assumed to be a scratch file.  File open assumes that the file
C        type is 'MA' (if cataloged), file is opened patiently without
C        exclusive use.
C     2) Initialization.  APIO initializes the I/O using the values in
C        FLIST when it opens the file.  It may be initialized again at
C        any time using OPCODE 'INIT'.  Also switching between 'READ'
C        and 'WRIT' will force flushing the buffer ('WRIT') and
C        initialization.  Any initialization when the current operation
C        is 'WRIT' will cause the buffer to be flushed.
C     3) Closing the file.  The file may be closed with a call with
C        opcode 'CLOS'.  If the file is being written and a 'CLOS' call
C        is issued, APIO will flush the buffer.  This means that if APIO
C        is being used to write to a disk it MUST be called with
C        OPCODE='CLOS','READ', or 'INIT' to flush the buffer.
C        NOTE: All pending AP operations MUST be complete before calling
C        APIO with opcode 'CLOS'.
C     4) AP timing calls.  APIO calls APWD before getting data from or
C        sending data to the AP but does not call APWR.  The calling
C        routine should call APWR as appropriate.
C    Inputs:
C       OPCODE   C*4  Code for the desired operation.
C                     'INIT' forces the initialization of the I/O.
C                     'READ' reads a logical record from the disk and
C                            sends it to the specified AP location.
C                     'WRIT' Gets data from the AP and writes it to
C                            disk.
C                     'CLOS' Closes the file and flushes the buffer if
C                            necessary.
C       FLIST(22) I   An array containing information about the file
C                     and the I/O. Parts are to be filled in by the
C                     calling routine and are for use by APIO.
C                       1 = LUN, must be filled in,
C                       2 = disk number for catalogs files or
C                           /CFILES/ number for scratch files.
C                       3 = catalog slot number for cataloged files,
C                           .LE. 0 indicates that the file is a scratch
C                           file.
C                       4 = Unused
C                       5 = Length of a logical record (row) in pixels.
C                       6 = Number of rows in a plane.
C                       7 = value to be added to 1 for the block offset.
C                       9-12 = the window desired in the image, 0 =>
C                           all of image.  The logical records must fit
C                           in the buffer and be smaller than BUFSZ
C                           bytes to subimage rows.
C                       13 = Buffer size in bytes.
C           Used by APIO:
C                       14 = FTAB pointer
C                       15 = Number of MDISK calls per logical record.
C                       16 = Current OPCODE,
C                            0 = none, INIT on next call
C                            1 = READ
C                            2 = WRITE
C                       17 = actual length of logical row.
C                       18-22 = Spare.
C       APLOC      I   Base address in AP for data.
C       BUFFER(*)  R   Working buffer.
C    Output:
C       IRET       I   Return code, 0 => OK or
C                                   1 = Bad OPCODE,
C                                   2 = Attempt to window too large
C                                       a file.
C                                   3 = Buffer too small (<NBPS bytes)
C                                   MDISK error codes + 10, or
C                                   MINI3 error codes + 20, or
C                                   ZOPEN error codes + 30.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      CHARACTER OPCODE*4
      INTEGER   FLIST(22), APLOC, IRET
      REAL      BUFFER(*)
C
      CHARACTER CODES(4)*4, FNAME*48
      INTEGER   IERR, NCODE, ICODE, I, FIND, IVOL, ISCR, BIND, BO,
     *   IFACT, INDEX, WIN(4), BUFSZ, IL, NIOBIG, BIGNX, BIGNY
      LOGICAL   T, F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      SAVE NIOBIG, BIGNX, BIGNY
      DATA NCODE, CODES /4, 'READ','WRIT','INIT','CLOS'/
      DATA T,F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IRET = 0
C                                       Determine OPcode
      ICODE = 0
      DO 10 I = 1,NCODE
         IF (OPCODE.EQ.CODES(I)) ICODE = I
 10      CONTINUE
C                                       Check for error.
C                                       Unknown OPcode.
      IF (ICODE.LE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1010) OPCODE
         GO TO 995
         END IF
C                                       Get FTAB pointer for file
      FIND = FLIST(14)
C                                       Check index is valid
      IF ((FIND.GT.0) .AND. (FIND.LE.20480)) THEN
C                                       index is valid, is file open?
         IF (FLIST(1).EQ.FTAB(FIND)) GO TO 100
         END IF
C-----------------------------------------------------------------------
C                                       File not open - Open it
C                                       If OPCODE='CLOS' return.
      IF (ICODE.EQ.4) GO TO 999
C                                       Reset FLIST
         CALL FILL (8, 0, FLIST(14))
C                                       Determine if cat. or scratch.
         IF (FLIST(3).GT.0) THEN
C                                       Cataloged - make name.
            IVOL = FLIST(2)
            CALL ZPHFIL ('MA', IVOL, FLIST(3), 1, FNAME, IERR)
C                                       Open file.
            CALL ZOPEN (FLIST(1), FLIST(14), IVOL, FNAME, T, F, T,
     *         IERR)
            FIND = FLIST(14)
C                                       Check for error
            IF (IERR.NE.0) THEN
               IRET = IERR + 30
               WRITE (MSGTXT,1020) IERR
               GO TO 995
               END IF
         ELSE
C                                       /CFILES/ SCRATCH file - OPEN
            ISCR = FLIST(2)
            CALL ZPHFIL ('SC', SCRVOL(ISCR), SCRCNO(ISCR), 1, FNAME,
     *         IERR)
            CALL ZOPEN (FLIST(1), FLIST(14), SCRVOL(ISCR), FNAME, T, F,
     *         T, IERR)
            FIND = FLIST(14)
C                                       Check for error
            IF (IERR.NE.0) THEN
               IRET = IERR + 30
               WRITE (MSGTXT,1020) IERR
               GO TO 995
               END IF
            END IF
C-----------------------------------------------------------------------
C                                       Flush Buffer if necessary.
C                                       Check if opcode changed.
 100  IF (ICODE.EQ.FLIST(16)) GO TO 500
C                                       Check if currently not WRIT.
      IF (FLIST(16).EQ.2) THEN
C                                       Make sure data in buffer
         IF (ICODE.NE.4) CALL QWD
C                                       Flush buffer
         CALL MDISK ('FINI', FLIST, FIND, BUFFER, BIND, IERR)
C                                       Check for error.
         IF (IERR.NE.0) THEN
            IRET = 10 + IERR
            WRITE (MSGTXT,1100) IERR
            GO TO 995
            END IF
         END IF
C                                       Check if CLOSE requested.
      IF (ICODE.EQ.4) GO TO 800
C-----------------------------------------------------------------------
C                                       Initialize file.
C                                       Reset FLIST
      CALL FILL (7, 0, FLIST(15))
C                                       If OPCODE='INIT' return and wait
C                                       for READ or WRIT request to do
C                                       the call to  MINIT.
      IF (ICODE.EQ.3) GO TO 999
C                                       Check buffer size
      IF (FLIST(13).LE.NBPS) THEN
C                                       Buffer too small
         IRET = 3
         WRITE (MSGTXT,1200) FLIST(13)
         GO TO 995
         END IF
      BUFSZ = FLIST(13)
      NIOBIG = (FLIST(5) / (1.0 * BUFSZ)) * 2 + 0.999
      NIOBIG = MAX (1, NIOBIG)
      BIGNY = FLIST(6) * NIOBIG
      BIGNX = FLIST(5) / NIOBIG
C                                       Put values in FLIST
      FLIST(15) = NIOBIG
      FLIST(17) = BIGNX
C                                       Set window
      CALL COPY (4, FLIST(9), WIN)
C                                       Check if NIOBIG > 1
      IF (NIOBIG.GT.1) THEN
C                                       If 0 leave as is.
         IF (WIN(1).GT.0) THEN
C                                       Cannot select columns but can
C                                       select rows.
            IF ((FLIST(9).GT.1) .OR. (FLIST(11).LT.FLIST(5))) THEN
C                                       Problem - this is not possible.
               IRET = 2
               WRITE (MSGTXT,1210)
               GO TO 995
               END IF
C                                       Select rows
            WIN(2) = WIN(2) * NIOBIG
            WIN(3) = WIN(3) / NIOBIG
            WIN(4) = WIN(4) * NIOBIG
            IF (WIN(2).LT.WIN(4)) WIN(2) = WIN(2) - (NIOBIG - 1)
            IF (WIN(4).LT.WIN(2)) WIN(4) = WIN(4) - (NIOBIG - 1)
            END IF
         END IF
C                                       Initialize I/O - set BO.
      BO = FLIST(7) + 1
      CALL MINIT (CODES(ICODE), FLIST, FIND, BIGNX, BIGNY, WIN,
     *   BUFFER, FLIST(13), BO, IERR)
C                                       Check for errors
      IF (IERR.NE.0) THEN
         IRET = 20 + IERR
         WRITE (MSGTXT,1230) IERR, CODES(ICODE)
         GO TO 995
         END IF
C-----------------------------------------------------------------------
C                                       Do I/O and transfer to/for AP.
C                                       Do transfers
 500  INDEX = APLOC
      NIOBIG = FLIST(15)
      IFACT = 1
C                                       Setup for big, backwards loops.
      IF ((NIOBIG.GT.1) .AND. (FLIST(12).LT.FLIST(10))) THEN
         IFACT = -1
         BIGNX = FLIST(17)
         INDEX = INDEX + (NIOBIG - 1) * BIGNX
         END IF
C                                       Loop for big transfers.
      DO 540 IL = 1,NIOBIG
         CALL MDISK (CODES(ICODE), FLIST, FIND, BUFFER, BIND, IERR)
         IF (IERR.NE.0) THEN
            IRET = 10 + IERR
            WRITE (MSGTXT,1500) IERR, CODES(ICODE)
            GO TO 995
            END IF
         IF (IL.GT.1) INDEX = INDEX + (IFACT * BIGNX)
         CALL QWD
C                                       READ - put into AP
         IF (ICODE.EQ.1) CALL QPUT (APCORE, BUFFER(BIND), INDEX, BIGNX,
     *      2)
C                                       Write - get from AP
         IF (ICODE.EQ.2) CALL QGET (APCORE, BUFFER(BIND), INDEX, BIGNX,
     *      2)
 540     CONTINUE
C                                       Save OPCODE in FLIST
      FLIST(16) = ICODE
      GO TO 999
C-----------------------------------------------------------------------
C                                       Close
 800  CALL ZCLOSE (FLIST, FIND, IERR)
C                                       Check for error
      IF (IERR.NE.0) THEN
         IRET = IERR + 10
         WRITE (MSGTXT,1800) IERR
         GO TO 995
         END IF
C                                       Reset FLIST
      CALL FILL (8, 0, FLIST(14))
      GO TO 999
C                                       An error occured.
 995  CALL MSGWRT (8)
C                                       Return
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('APIO: UNKNOWN OPCODE ',A4)
 1020 FORMAT ('APIO: ZOPEN ERROR',I3)
 1100 FORMAT ('APIO: MDISK ERROR',I3,' FLUSHING BUFFER')
 1200 FORMAT ('APIO: BUFFER SIZE TOO SMALL =',I7)
 1210 FORMAT ('APIO: MUST SPLIT LOG. RECORD - CANNOT WINDOW ROWS')
 1230 FORMAT ('APIO: MINIT ERROR',I3,' ON ',A4)
 1500 FORMAT ('APIO: MDISK ERROR',I3,' ON ',A4)
 1800 FORMAT ('APIO: ZCLOSE ERROR',I3)
      END

      SUBROUTINE CTREFM (DISK, CNO, VER, NEWVER, CATBLK, LUN1, LUN2,
     *   IROWF, TIMER, IRET)
C----------------------------------------------------------------------
C! Converts input VLBA CT table (ver 2) to version 3 used by AIPS
C# EXT-appl
C----------------------------------------------------------------------
C;  Copyright (C) 2005, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C----------------------------------------------------------------------
C   Converts input VLBA CT table to version 3 used by AIPS
C   Inputs:
C      DISK     I      Volume number
C      CNO      I      Catalog slot number
C      VER      I      Version # of table in old format
C      NEWVER   I      Version # of output table; may equal VER
C      CATBLK   I(256) Catalog header block
C      LUN1     I      LUN for table I/O
C      LUN2     I      LUN for table I/O
C      TIMER    D(2)   Obs time range column added
C   Output:
C      IROWF    I      Start row in output table
C      IRET     I      Return code (0=>ok; else error)
C----------------------------------------------------------------------
      DOUBLE PRECISION TIMER(2)
      INTEGER   DISK, CNO, VER, NEWVER, CATBLK(256), LUN1, LUN2, IROWF,
     *   IRET
C
      INCLUDE 'INCS:DCTV.INC'
      CHARACTER UT1TYP*1, WOBTYP*1
      DOUBLE PRECISION TIME, UT1UTC, IATUTC, A1IAT, WOBXY(2), DPSI,
     *   DDPSI, DEPS, DDEPS, TRANGE(2)
C
      LOGICAL   WTABLE, WEXIST, WFITS, WSTAT
      CHARACTER LTYPE*2, LTEMP*12, LSTAT*4
      INTEGER   JBUFF1(512), JBUFF2(512), I, J, IOUTVR, CTKOL1(MAXCTC),
     *   CTKOL2(MAXCTC), CTNUM1(MAXCTC), CTNUM2(MAXCTC), IDUMMY,
     *   NROW, IERR, IREV, CTRNO1, CTRNO2, IRNO
      INCLUDE 'INCS:DMSG.INC'
C----------------------------------------------------------------------
      IRET = 0
C                                       Check for valid input table
      CALL ISTAB ('CT', DISK, CNO, VER, LUN1, JBUFF1, WTABLE, WEXIST,
     *   WFITS, IERR)
      IF (.NOT.WEXIST) GO TO 999
C                                       Read input table keywords
      CALL CTINI ('READ', JBUFF1, DISK, CNO, VER, CATBLK, LUN1, CTRNO1,
     *   CTKOL1, CTNUM1, IERR)
      IF (IERR.GT.0) THEN
         IRET = 4
         CALL TABERR ('READ', 'CTINI', 'CTREFM', IERR)
         GO TO 999
         END IF
C                                       Revision number
      IREV = CTTABV
      CALL TABIO ('CLOS', 0, 0, JBUFF1, JBUFF1, IERR)
C                                       Only convert v.2 -> v.3
      IF (IREV.GT.2) GO TO 999
C                                       Copy input file
      IOUTVR = 0
      I = MSGSUP
      MSGSUP = 31999
      CALL TABCOP ('CT', VER, IOUTVR, LUN1, LUN2, DISK, DISK, CNO,
     *   CNO, CATBLK, JBUFF1, JBUFF2, IERR)
      MSGSUP = I
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1010) IERR
         GO TO 990
         END IF
C                                       Delete old version
      CALL RMEXT (DISK, CNO, 'CT', VER, CATBLK, JBUFF1, IERR)
      IF (IERR.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       Update CATBLK
      CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'REST', JBUFF1, IERR)
C                                       Determine file status
      LTYPE = 'UV'
      WSTAT = .FALSE.
      CALL CATDIR ('INFO', DISK, CNO, LTEMP, LTEMP, IDUMMY, LTYPE,
     *   IDUMMY, LSTAT, JBUFF1, IERR)
C                                       Change status
      IF (LSTAT.NE.'WRIT') THEN
         CALL STATCH (LSTAT, 'WRIT', DISK, CNO, LTYPE, JBUFF1, IERR)
         IF (IERR.NE.0) THEN
            IRET = 3
            WRITE (MSGTXT,1080) IERR
            GO TO 990
            END IF
         WSTAT = .TRUE.
         END IF
C                                       Open input table
      CALL CTINI ('READ', JBUFF1, DISK, CNO, IOUTVR, CATBLK, LUN1,
     *   CTRNO1, CTKOL1, CTNUM1, IERR)
      IF (IERR.GT.0) THEN
         IRET = 4
         CALL TABERR ('READ', 'CTINI', 'CTREFM', IERR)
         GO TO 999
         END IF
C                                       # rows in output table
      NROW = JBUFF1(5)
C                                       Create output table
      CALL CTINI ('WRIT', JBUFF2, DISK, CNO, NEWVER, CATBLK, LUN2,
     *   CTRNO2, CTKOL2, CTNUM2, IERR)
      IF (IERR.GT.0) THEN
         IRET = 6
         CALL TABERR ('WRIT', 'CTINI', 'CTREFM', IERR)
         GO TO 999
         END IF
      IROWF = CTRNO2
C                                       Loop and translate each row
      DO 30 J = 1,NROW
         IRNO = J
         CALL TABCT ('READ', JBUFF1, IRNO, CTKOL1, CTNUM1, TIME, UT1UTC,
     *      IATUTC, A1IAT, UT1TYP, WOBXY, WOBTYP, DPSI, DDPSI, DEPS,
     *      DDEPS, TRANGE, IERR)
         IF (IERR.GT.0) THEN
            IRET = 7
            CALL TABERR ('READ', 'TABCT', 'CTREFM', IERR)
            GO TO 999
            END IF
         TRANGE(1) = TIMER(1)
         TRANGE(2) = TIMER(2)
C                                       Write output row
         CALL TABCT ('WRIT', JBUFF2, CTRNO2, CTKOL2, CTNUM2, TIME,
     *      UT1UTC, IATUTC, A1IAT, UT1TYP, WOBXY, WOBTYP, DPSI, DDPSI,
     *      DEPS, DDEPS, TRANGE, IERR)
         IF (IERR.GT.0) THEN
            IRET = 7
            CALL TABERR ('WRIT', 'TABCT', 'CTREFM', IERR)
            GO TO 999
            END IF
30       CONTINUE
C                                       Close tables
      CALL TABIO ('CLOS', 0, IRNO, JBUFF1, JBUFF1, IERR)
      CALL TABIO ('CLOS', 0, CTRNO2, JBUFF2, JBUFF2, IERR)
C                                       Delete copy
      CALL RMEXT (DISK, CNO, 'CT', IOUTVR, CATBLK, JBUFF1, IERR)
      IF (IERR.NE.0) THEN
         IRET = 9
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       Check if changed status
C                                       Change status
      IF (WSTAT) THEN
         CALL STATCH ('WRIT', LSTAT, DISK, CNO, LTYPE, JBUFF1, IERR)
         IF (IERR.NE.0) THEN
            IRET = 10
            WRITE (MSGTXT,1400) IERR
            GO TO 990
            END IF
         END IF
C                                       Update CATBLK
      CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'REST', JBUFF1, IERR)
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C
999   RETURN
C----------------------------------------------------------------------
1010  FORMAT ('CTREFM: ERROR',I3,' COPYING OLD TABLE')
1020  FORMAT ('CTREFM: ERROR',I3,' DELETING OLD TABLE')
1080  FORMAT ('CTREFM: ERROR',I3,' CHANGING CLRD STATUS')
1400  FORMAT ('CTREFM: ERROR',I3,' CHANGING CLWR STATUS')
      END

      SUBROUTINE LINTER (NP, IP, INB, OUTB)
C-----------------------------------------------------------------------
C! does linear interpolation of a 1-D INTEGER array
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   LINTER interpolates an INTEGER array.  Designed for TVLOD so the
C   value 0 is regarded as "blanked"
C   Inputs:
C      NP    I      Number pixels in input array
C      IP    I      Interpolation factor (1 => copy)
C      INB   I(*)   In buffer
C   Output:
C      OUTB  I(*)   Out buffer (# pts = (NP-1)*IP +1 )
C-----------------------------------------------------------------------
      INTEGER   NP, IP, INB(*), OUTB(*)
C
      INTEGER   I, J, L
      REAL      X, Y
C-----------------------------------------------------------------------
      IF (NP.LE.0) GO TO 999
C                                       Null interpolation
      IF (IP.LT.2) THEN
         DO 10 I = 1,NP
            OUTB(I) = INB(I)
 10         CONTINUE
C                                       Real interpolation
      ELSE
         J = 1
         X = 1.0 / IP
         DO 30 I = 1,NP
            OUTB(J) = INB(I)
            IF (I.EQ.NP) GO TO 999
            J = J + 1
            Y = X * (INB(I+1) - INB(I))
            IF ((INB(I+1).EQ.0) .OR. (INB(I).EQ.0)) THEN
               DO 15 L = 2,IP
                  OUTB(J) = 0
                  J = J + 1
 15               CONTINUE
            ELSE
               DO 20 L = 2,IP
                  OUTB(J) = INB(I) + (L-1) * Y + 0.4999
                  J = J + 1
 20               CONTINUE
               END IF
 30         CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE GNFSMO (TIMSMO, DISK, CNO, VER, LUN, BUFF, IERR)
C-----------------------------------------------------------------------
C! Boxcar smooths and ASCAL solution (GA) file.
C# EXT-appl UV Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GNFSMO does a boxcar smoothing of gain amplitudes of a ASCAL
C   solution file (GA) with a time window specified for each antenna.
C   Input:
C      TIMSMO(30) R    Smoothing times (hrs) for each antenna.
C      DISK       I    Disk number on which the gain file resides.
C      CNO        I    Cat. slot number of GA file.
C      VER        I    GA file version number.
C      LUN        I    LUN to use.
C      BUFF(768)  I    Work buffer.
C   From COMMON /UVHDR/
C      JLOCF      I    Pointer in header to frequency.
C      JLOCS      I    Pointer in header to stokes.
C   Output:
C      IERR       I    Return error code. 0=>OK. otherwise error.
C   NOTE:  /UVHDR/ should be filled with a call to UVPGET on the uv data
C   header.  Also /HDRVAL/ should be filled with a call to VHDRIN.
C-----------------------------------------------------------------------
      INTEGER   BUFF(768), DISK, CNO, VER, IERR, I, NANT, NIF,
     *   CATBLK(256), NUMSLN(2000), IANT, IF, IFLG(4), BFLG(48),
     *   SPARGA(228), JLREC, LUN, NREC, IND, IBITWD, INEXT, KV,
     *   NSOLN, LIMSLN, ISOLN, NBIT, NWORD, IREF, NUMAN(51), NEXT
      REAL      TIME(2000), AMP(2000), CATR(256),
     *   T1, T2, GARI(2,28,2), AMPL, FACTOR, TIMSMO(30),
     *   SCALE, AMPSMO(2000)
      COMPLEX   GAIN(28,2)
      LOGICAL   FLAGS(32)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      COMMON /GAREC/ GAIN, IFLG, BFLG, KV, T1, T2, IREF, SPARGA
      EQUIVALENCE (CATBLK, CATR, TIME),     (GAIN, GARI)
      DATA JLREC, LIMSLN /512,2000/
C-----------------------------------------------------------------------
C                                       Get CATBLK
      CALL CATIO ('READ', DISK, CNO, CATBLK, 'REST', AMP, IERR)
      IF (.NOT. ((IERR.GE.1) .AND. (IERR.LE.3))) GO TO 50
         WRITE (MSGTXT,1000) IERR
         GO TO 990
C                                       Get number of IFs.
 50   NIF = 2
      IF (CATBLK(KINAX+JLOCS).LT.2) NIF = 1
C                                       Read antenna header to set NANT.
C                                       Use GETNAN to get number of
C                                       antennas in subarray 1.
      CALL GETNAN (DISK, CNO, CATBLK, LUN, BUFF, NUMAN, IERR)
      NANT = NUMAN(2)
C                                       On error assume 28 antennas.
      IF (IERR.NE.0) NANT = 28
C                                       Open gain file.
      CALL EXTINI ('WRIT', 'GA', DISK, CNO, VER, CATBLK, LUN, IND,
     *   JLREC, NREC, BUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get number of solutions.
      NSOLN = BUFF(4)
C                                       Loop thru Ifs.
      DO 220 IF = 1,NIF
C                                       Loop thru antennas.
         DO 210 IANT = 1,NANT
C                                       Check if smoothing wanted.
            SCALE = TIMSMO(IANT) * 3600.
C                                       If smoothing time .lt. 1 sec
C                                       skip smoothing this antenna.
            IF (SCALE.LT.(1.0/3600.0)) GO TO 210
C                                       Read gains.
            NEXT = 1
            DO 100 ISOLN = 1,NSOLN
C                                       Read.
               CALL EXTIO ('READ', LUN, IND, ISOLN, GAIN, BUFF, IERR)
               IF (IERR.NE.0) GO TO 999
C                                       Check ANT/IF flag
               NBIT = IANT + (IF-1) * 28 - 1
               NWORD = NBIT / NBITWD + 1
               NBIT = MOD (NBIT, NBITWD) + 1
C                                       Crunch bits.
               IBITWD = NBITWD
               CALL LG2BIT (IBITWD, FLAGS, IFLG(NWORD), -1)
C                                       Data good.
               IF (FLAGS(NBIT)) GO TO 100
                  NUMSLN(NEXT) = ISOLN
                  TIME(NEXT) = 0.5 * (T1 + T2)
                  AMP(NEXT) = SQRT ((GARI(1,IANT,IF)**2) +
     *               (GARI(2,IANT,IF)**2))
                  NEXT = NEXT + 1
C                                       Too many visibilities
                  IF (NEXT.LE.LIMSLN) GO TO 100
                     WRITE (MSGTXT,1050) NEXT, LIMSLN, IANT, IF
                     CALL MSGWRT (6)
                     GO TO 110
 100           CONTINUE
 110        NEXT = NEXT - 1
C                                       See if data obtained.
            IF (NEXT.LE.0) GO TO 210
C                                       Call smoother.
               INEXT = NEXT
               CALL BOXSMO (SCALE, TIME, AMP, INEXT, AMPSMO)
C                                       Update gain files.
               DO 200 I = 1,NEXT
                  ISOLN = NUMSLN(I)
C                                       Read.
                  CALL EXTIO ('READ', LUN, IND, ISOLN, GAIN, BUFF,
     *               IERR)
                  IF (IERR.NE.0) GO TO 999
C                                       Get amplitude.
                  AMPL = SQRT ((GARI(1,IANT,IF)**2) +
     *               (GARI(2,IANT,IF)**2))
                  FACTOR = AMPSMO(I) / AMPL
C                                       Correct gain.
                  GAIN(IANT,IF) = GAIN(IANT,IF) * FACTOR
C                                       Write back.
                  CALL EXTIO ('WRIT', LUN, IND, ISOLN, GAIN, BUFF, IERR)
                  IF (IERR.NE.0) GO TO 999
 200              CONTINUE
 210        CONTINUE
 220     CONTINUE
C                                       Close GA file.
      CALL EXTIO ('CLOS', LUN, IND, I, GAIN, BUFF, IERR)
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GNFSMO: ERROR',I5,' READING CATBLK')
 1050 FORMAT ('GNFSMO: TOO MANY GAINS=',I5,',MAX=',I5,',ANT=',I3,
     *   ',IF=',I2)
      END

      SUBROUTINE PRJMAT (RA, DEC, UROTAT, XRA, XDEC, MROTAT, UMAT, PMAT)
C-----------------------------------------------------------------------
C! Returns phase and uv re-projection matrices: SIN projection
C# Map Header coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 1999, 2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Returns re-projection matrices to convert initial ref point (u,v,w)
C   and (X,Y,Z) (phase shift terms) to those at a new tangent point
C   Note that these implement the -SIN projection.  They are not needed
C   for -NCP which should not use 3D imaging.
C   Input:
C      RA       D        Initial RA in degrees
C      DEC      D        Initial Declination in degrees
C      UROTAT   R        UV rotation in degrees
C      XRA      D        RA of shifted point in degrees
C      XDEC     D        Declination of shifted point in degrees
C      MROTAT   R        Rotation in degrees at new tangent point
C   Output
C      UMAT     R(3,3)   uvw -> uvw prime matrix
C      PMAT     R(3,3)   xyz -> xyz prime matrix
C-----------------------------------------------------------------------
      DOUBLE PRECISION RA, DEC, XRA, XDEC
      REAL      UROTAT, MROTAT, UMAT(3,3), PMAT(3,3)
C
      INTEGER   I, J, K
      DOUBLE PRECISION RM(3,3), SA, CA, SD, CD, SD0, CD0, T(3,3), R,
     *   X(3,3)
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                       sin's and cos's
      SA = SIN (DG2RAD * (XRA-RA))
      CA = COS (DG2RAD * (XRA-RA))
      SD = SIN (DG2RAD * XDEC)
      CD = COS (DG2RAD * XDEC)
      SD0 = SIN (DG2RAD * DEC)
      CD0 = COS (DG2RAD * DEC)
C                                       rotation matrix
      CALL DFILL (9, 0.0D0, RM)
      RM(3,3) = 1.0
C                                       Map +
      R = DG2RAD * MROTAT
      RM(1,1) = COS (R)
      RM(2,2) = RM(1,1)
      RM(1,2) = -SIN (R)
      RM(2,1) = SIN (R)
C                                       Forward matrix
      X(1,1) = CA
      X(1,2) = -SD * SA
      X(1,3) = CD * SA
      X(2,1) = SD0 * SA
      X(2,2) = CD * CD0 + SD * SD0 * CA
      X(2,3) = SD * CD0 - CD * SD0 * CA
      X(3,1) = -CD0 * SA
      X(3,2) = CD * SD0 - SD * CD0 * CA
      X(3,3) = SD * SD0 + CD * CD0 * CA
C                                       multiply
      DO 20 I = 1,3
         DO 15 J = 1,3
            T(I,J) = 0.0
            DO 10 K = 1,3
               T(I,J) = T(I,J) + X(I,K) * RM(K,J)
 10            CONTINUE
 15         CONTINUE
 20      CONTINUE
C                                       uv -
      R = DG2RAD * UROTAT
      RM(1,1) = COS (R)
      RM(2,2) = RM(1,1)
      RM(1,2) = SIN (R)
      RM(2,1) = -SIN (R)
C                                       multiply
      DO 40 I = 1,3
         DO 35 J = 1,3
            R = 0.0
            DO 30 K = 1,3
               R = R + RM(I,K) * T(K,J)
 30            CONTINUE
            UMAT(I,J) = R
 35         CONTINUE
 40      CONTINUE
C                                       uv +
      R = DG2RAD * UROTAT
      RM(1,1) = COS (R)
      RM(2,2) = RM(1,1)
      RM(1,2) = -SIN (R)
      RM(2,1) = SIN (R)
C                                       Backward matrix
      X(1,1) = CA
      X(1,2) = SD0 * SA
      X(1,3) = -CD0 * SA
      X(2,1) = -SD * SA
      X(2,2) = CD * CD0 + SD * SD0 * CA
      X(2,3) = SD0 * CD - CD0 * SD * CA
      X(3,1) = CD * SA
      X(3,2) = CD0 * SD - SD0 * CD * CA
      X(3,3) = SD * SD0 + CD * CD0 * CA
C                                       multiply
      DO 60 I = 1,3
         DO 55 J = 1,3
            T(I,J) = 0.0
            DO 50 K = 1,3
               T(I,J) = T(I,J) + X(I,K) * RM(K,J)
 50            CONTINUE
 55         CONTINUE
 60      CONTINUE
C                                       Map -
      R = DG2RAD * MROTAT
      RM(1,1) = COS (R)
      RM(2,2) = RM(1,1)
      RM(1,2) = SIN (R)
      RM(2,1) = -SIN (R)
C                                       multiply
      DO 80 I = 1,3
         DO 75 J = 1,3
            R = 0.0
            DO 70 K = 1,3
               R = R + RM(I,K) * T(K,J)
 70            CONTINUE
            PMAT(I,J) = R
 75         CONTINUE
 80      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE DTMATC (LSOURC, IANT, ISUBA, IFQID, JSOU, JANT, JSUBA,
     *   JFQID)
C-----------------------------------------------------------------------
C! Match (src, ant, suba, fqid) in simulated data arrays
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1996-1997, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Match (src, ant, suba, fqid) in simulated data arrays
C   Input:
C      LSOURC   C*16   Source name
C      IANT     I      Antenna number
C      ISUBA    I      Subarray number
C      IFQID    I      Frequency id.
C   Output:
C      JSOU     I      Source index
C      JANT     I      Antenna index
C      JSUBA    I      Subarray index
C      JFQID    I      Freq. id. index
C---------------------------------------------------------------------
      CHARACTER LSOURC*16
      INTEGER IANT, ISUBA, IFQID, JSOU, JANT, JSUBA, JFQID
C
      INTEGER J
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DTPM.INC'
C----------------------------------------------------------------------
C                                       Match source name in SU
C                                       table list
      JSOU = 0
      DO 50 J = 1, NDTSID
         IF (LSOURC.EQ.LDTSOU(J)) JSOU = J
50       CONTINUE
C                                       Match subarray number in list
C                                       of AN tables
      JSUBA = 0
      DO 100 J = 1, NDTSUB
         IF (ISUBA.EQ.IDTSUB(J)) JSUBA = J
100      CONTINUE
C                                       Match antenna number
      JANT = 0
      DO 150 J = 1, NDTANT(JSUBA)
         IF (IANT.EQ.IDTANO(J,JSUBA)) JANT = J
150      CONTINUE
C                                       Match frequency id.
      JFQID = 0
      DO 200 J = 1, NDTFQD
         IF (IFQID.EQ.IDTFQD(J)) JFQID = J
200      CONTINUE
C                                       Exit
999   RETURN
      END

      SUBROUTINE NDXINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   INXRNO, NXKOLS, NXNUMV, IERR)
C-----------------------------------------------------------------------
C! Create/open/init index (NX) table
C# EXT-util Calibration UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2000, 2006, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes INDEX extention tables.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'WRIT' = create/init for write or read
C                        'READ' = open for read only
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      LUN      I        Logical unit number to use
C   In/out:
C      VER      I        NX file version
C      CATBLK   I(256)   Catalog header block.
C   Output:
C      INXRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      NXKOLS   I(MAXNXC)   The column pointer array in order, TIME,
C                        TIME INTERVAL, SOURCE ID, SUBARRAY, START VIS,
C                        END VIS, FREQID.
C      NXNUMV   I(MAXNXC)   Element count in each column.
C      IERR     I        Return error code, 0=>OK, else TABINI or TABIO
C                        error.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, INXRNO,
     *   NXKOLS(*), NXNUMV(*), IERR
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER TITLE(MAXNXC)*24, UNITS(MAXNXC)*8, TTITLE*56
      HOLLERITH HOLTMP(6)
      INTEGER   NKEY, NREC, DATP(128,2), NCOL, NTT, DTYP(MAXNXC), NDATA,
     *   I, IPOINT, NC, ITRIM, JERR, ITEMP(6)
      LOGICAL   DOREAD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (HOLTMP, ITEMP)
      DATA NTT /56/
      DATA TTITLE /'AIPS UV DATA FILE SCAN INDEX TABLE '/
      DATA DTYP /12,12,14,14,14,14,14/
      DATA TITLE /'TIME                    ',
     *   'TIME INTERVAL           ',
     *   'SOURCE ID               ',
     *   'SUBARRAY                ', 'START VIS               ',
     *   'END VIS                 ',
     *   'FREQ ID                 '/
      DATA UNITS /'DAYS    ', 'DAYS    ', 5*'        '/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NDATA = MAXNXC
      NREC = 20
      NCOL = NDATA
      NKEY = 0
      CALL FILL (NDATA, 0, NXKOLS)
      CALL FILL (NDATA, 0, NXNUMV)
C                                       Fill in types, lengths
      IF (.NOT.DOREAD) THEN
         DO 10 I = 1,NDATA
            DATP(I,2) = DTYP(I)
            NXNUMV(I) = DTYP(I) / 10
 10         CONTINUE
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'NX', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'NDXINI', IERR)
         GO TO 990
         END IF
C                                       Get number of scans
      INXRNO = BUFFER(5) + 1
      IF (DOREAD) INXRNO = 1
C                                       File created, initialize
      IF (IERR.LT.0) THEN
C                                       Col. labels.
         DO 40 I = 1,NDATA
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'NDXINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'NDXINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
         END IF
C                                      Get array indices
C                                      Cover your ass from FNDCOL -
C                                      close to flush the buffers and
C                                      then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, BUFFER, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'NDXINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'NX', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'NDXINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (MAXNXC, TITLE, 24, .TRUE., BUFFER, NXKOLS, JERR)
C                                      Get array indices and no. values
      DO 150 I = 1,MAXNXC
         IPOINT = NXKOLS(I)
         IF (IPOINT.GT.0) THEN
            NXKOLS(I) = DATP(IPOINT,1)
            NXNUMV(I) = DATP(IPOINT,2) / 10
            IF (NXNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
         ELSE
            NXKOLS(I) = -1
            NXNUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            CALL MSGWRT (6)
            END IF
 150     CONTINUE
      IERR = 0
      GO TO 999
C                                      Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('NDXINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('NDXINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('NDXINI: ERROR INITIALIZING SCAN INDEX TABLE FOR ',A4)
      END

      SUBROUTINE AU6C (BRANCH)
C-----------------------------------------------------------------------
C! verb to alter zoom and enhance image in standard way: TVFIDDLE
C# TV-appl POPS-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2008-2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AU6C does an interactive run with button A selecting alternately
C   TVTRANSF and TVPSEUDO (color contour type 2 only), button B
C   incrementing the zoom and C decrementing the zoom.
C   BRANCH =  2 :  TVFIDDLE            Does only interactive part
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      INCLUDE 'INCS:PTVC.INC'
      CHARACTER PRGNAM*6, CDUM*1
      INTEGER   POTERR, ICHAN, IERR, INBUF(4096), NLEVS, JERR, LCHAN,
     *   ZAND, ZOR, INCHAN, LUTBUF(TVMLUT)
      REAL      RDUM
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (LUTBUF, INBUF)
      COMMON /AIPSCR/ INBUF
      DATA PRGNAM /'AU6C '/
C-----------------------------------------------------------------------
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.2)) GO TO 999
      CALL TVOPEN (INBUF, JERR)
      POTERR = 101
      IF (JERR.NE.0) GO TO 980
C                                       check TV state
      IF ((TVLIMG(1).NE.TVLIMG(2)) .OR. (TVLIMG(1).NE.TVLIMG(3)) .OR.
     *   (TVLIMG(1).NE.TVLIMG(4))) THEN
         POTERR = 77
         GO TO 960
         END IF
C
      POTERR = 49
      CALL ADVERB ('TVCHAN', 'I', 1, 0, ICHAN, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 960
      IF ((ICHAN.LE.0) .OR. (ICHAN.GT.NGRAY)) ICHAN = 1
      INCHAN = ICHAN
      ICHAN = 2 ** (ICHAN-1)
      CALL ADVERB ('TVLEVS', 'I', 1, 0, NLEVS, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 960
      IF (NLEVS.LT.10) NLEVS = LUTOUT + 1
      IF (NLEVS.LE.LUTOUT) NLEVS = LUTOUT + 1
      IF (NLEVS.GT.OFMINP) NLEVS = OFMINP + 1
C
      GO TO (100, 200), BRANCH
C-----------------------------------------------------------------------
C                                       TVALL
C                                       clear, load, fiddle
C                                       replaced by procedure!
C-----------------------------------------------------------------------
 100  CONTINUE
C-----------------------------------------------------------------------
C                                       TVFIDDLE
C                                       Interactive section
C-----------------------------------------------------------------------
C                                       set channel number
 200  LCHAN = ZOR (TVLIMG(1), TVLIMG(2))
      LCHAN = ZOR (LCHAN, TVLIMG(3))
      LCHAN = ZOR (LCHAN, TVLIMG(4))
      LCHAN = ZAND (LCHAN, ICHAN)
      IF (LCHAN.GT.0) GO TO 210
         IERR = 1
         POTERR = 101
         WRITE (MSGTXT,1200) INCHAN
         CALL MSGWRT (7)
         GO TO 960
C                                       Do it
 210  CALL TVFIDL (LCHAN, NLEVS, INBUF, IERR)
      GO TO 960
C                                       Close down
 960  CALL TVCLOS (INBUF, JERR)
      IF (IERR.EQ.0) GO TO 999
C                                       AIPS error handling
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.GT.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1200 FORMAT ('REQUESTED CHANNEL',I7,' NOT ON')
      END

      SUBROUTINE YCRCTL (OP, ON, X, Y, LINKX, LINKY, RBLINK, BUTTON,
     *   VRTRTC, IERR)
C-----------------------------------------------------------------------
C! controls the TV cursor visibility, position; reads trackball buttons
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YCRCTL reads/writes the cursor/trackball control register of TV
C   Inputs:
C      OP      C*4   'READ' from TV or 'WRIT' to TV
C      VRTRTC  L     T => do on vertical retrace only
C   In/out:
C      ON      L     T => cursor visible, F => off
C      X       I     X position cursor center (1-512, 1 => LHS)
C      Y       I     Y position cursor center (1-512, 1 => bot)
C      LINKX   L     T => trackball moves cursor in X
C      LINKY   L     T => trackball moves cursor in Y
C      RBLINK  I     rate of cursor blink: 0-3 no-fast blink
C   Output:
C      BUTTON  I     button value (0 - 15)
C      IERR    I     error code of Z...XF : 0 => ok
C                                           2 => input error
C   DeAnza version
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   X, Y, RBLINK, BUTTON, IERR
      LOGICAL   ON, LINKX, LINKY, VRTRTC
C
      INTEGER   I, CURON, CUROFF, BLON, BLOFF, WORK
      LOGICAL   T
      INCLUDE 'INCS:YDEA.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA T /.TRUE./
C                               Note!!  CURON is specified
C                               here for programmable cursor #1.
C                               For standard full screen
C                               cross cursor use Z0030.
      DATA CURON, CUROFF, BLON, BLOFF /16384,0, 4096,0/
C-----------------------------------------------------------------------
C                                        write: check input
      IF (OP.EQ.'WRIT') THEN
         IERR = 2
         IF ((X.LT.1) .OR. (X.GT.MAXXTV(1))) GO TO 999
         IF ((Y.LT.1) .OR. (Y.GT.MAXXTV(2))) GO TO 999
C                                       zero cursor soft registers
         CALL FILL (7, 0, YBUFF(CURREG))
C                                       Set position words
         YBUFF(CURX1) = X - 1
         YBUFF(CURY1) = Y - 1
C                                       Set control word
         IF (ON) THEN
            YBUFF(CURCON) = CURON
         ELSE
            YBUFF(CURCON) = CUROFF
            END IF
C                                       Set blink rate
         I = MAX (0, MIN (3, RBLINK))
C
         IF (I.EQ.0) THEN
            YBUFF(CURBLI) = BLOFF
         ELSE
            I = 3 * (4 - I)
            YBUFF(CURBLI) = BLON + I
            END IF
C                                       Load cursor register
         CALL ZDEAXF ('LCR ', YBUFF(CURREG), CRBYTE, 0, 0, T, IERR)
C                                       return answers
      ELSE
         CALL ZDEAXF ('RCR ', YBUFF(CURREG), CRBYTE, 0, 0, T, IERR)
C                                       translate x,y
         X = MOD (YBUFF(CURX1), MAXXTV(1)) + 1
         Y = MOD (YBUFF(CURY1), MAXXTV(2)) + 1
C                                       calculate blink
         RBLINK =  YBUFF(CURBLI)
         IF (RBLINK.NE.0)  RBLINK = 4 - MOD (RBLINK, 16)/3
C                                        read button register
C                                        use button pushed bit to
C                                        prevent double hits
         CALL ZDEAXF ('RPR ', WORK, 2, 0, 0, T, IERR)
         BUTTON = MOD (WORK, 64)
         WORK = (WORK - BUTTON) / 64
         IF (MOD(WORK,2).NE.1) BUTTON = 0
         ON = YBUFF(CURCON).NE.0
         END IF
C
 999  RETURN
      END

      SUBROUTINE L1 (M, N, M2, N2, A, B, TOLER, X, E, S)
C-----------------------------------------------------------------------
C! Compute L1 solution to an overdetermined system of linear equations
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C     This subroutine uses a modification of the simplex method
C  of linear programming to calculate an L1 solution to an
C  overdetermined system of linear equations.
C  Description of parameters:
C     M...Number of equations (adj. array dim.).
C     N...Number of unknowns (adj. array dim.; M>=N).
C     M2...Set equal to M+2 for adjustable dimensions
C     N2...Set equal to N+2 for adjustable dimensions
C     A...Two dimensional real array of size M2xN2.
C         On entry, the coefficients of the matrix must be
C         stored in the first M rows and N columns of A.
C         These values are destroyed by the subroutine.
C     B...One dimensional real array of size M.  On entry, B
C         must contain the right-hand side of the equations.
C         These values are destroyed by the subroutine.
C     TOLER...A small positive tolerance.  Empirical evidence
C         suggests TOLER=10**(-2*d/3), where d represents the
C         number of decimal digits of accuracy available.
C     X...One dimensional real array of size N.  On exit, this
C         array contains a solution to the L1 problem.
C     E...One dimensional real array of size M.  On exit, this
C         array contains the residuals in the equations.
C     S...Integer array of size M used for workspace.
C  On exit, the array A contains the following information:
C     A(M+1,N+1) -- the minimum sum of the absolute values of
C                   the residuals
C     A(M+1,N+2) -- the rank of the matrix of coefficients
C     A(M+2,N+1) -- exit code with values:
C                      0 => optimal solution which is probably
C                           non-unique
C                      1 => unique optimal solution
C                      2 => calculations terminated prematurely
C                           due to rounding errors
C     A(M+2,N+2) -- number of simplex iterations performed
C   Adapted from CACM Algorithm #478.   F. Schwab -- Dec. 1981
C-----------------------------------------------------------------------
      INTEGER M, N, M2, N2
      DOUBLE PRECISION SUM
      REAL      MN, MX, A(M2,2), X(N), E(M), B(M)
      INTEGER   OUT, S(M), M1, N1, J, I, KOUNT, KR, KL,
     *   IN, K, L
      REAL   TOLER, ZERO, ONE, TWO, BIG, D, PIVOT
      LOGICAL   STAGE, TEST, T, F
      DATA T , F /.TRUE. , .FALSE./
      DATA ZERO, ONE , TWO /0.0E0 , 1.0E0 , 2.0E0/
C  BIG must be set equal to any very large real constant.
      DATA BIG /1.0E38/
C-----------------------------------------------------------------------
C                                       Initialization:
      M1 = M + 1
      N1 = N + 1
      DO 10 J = 1,N
         A(M2,J) = J
         X(J) = ZERO
 10      CONTINUE
      DO 40 I = 1,M
         A(I,2) = N + I
         A(I,1) = B(I)
         IF (B(I).GE.ZERO) GO TO 30
         DO 20 J = 1,N2
            A(I,J) = -A(I,J)
 20         CONTINUE
 30      E(I) = ZERO
 40      CONTINUE
C                                       Compute the marginal costs:
      DO 60 J = 1,N1
         SUM = 0D0
         DO 50 I = 1,M
            SUM = SUM + A(I,J)
 50         CONTINUE
         A(M1,J) = SUM
 60      CONTINUE
C                                       Stage I. Determine the vector to
C                                       enter the basis:
      STAGE = T
      KOUNT = 0
      KR = 1
      KL = 1
 70   MX = -ONE
      DO 80 J = KR,N
         IF (ABS(A(M2,J)).GT.N) GO TO 80
            D = ABS(A(M1,J))
            IF (D.LE.MX) GO TO 80
               MX = D
               IN = J
 80      CONTINUE
      IF (A(M1,IN).GE.ZERO) GO TO 100
         DO 90 I = 1,M2
            A(I,IN) = -A(I,IN)
 90         CONTINUE
C                                       Determine the vector to leave
C                                       the basis:
 100  K = 0
      DO 110 I = KL,M
         D = A(I,IN)
         IF (D.LE.TOLER) GO TO 110
            K = K + 1
            B(K) = A(I,1) / D
            S(K) = I
            TEST = T
 110     CONTINUE
 120  IF (K.GT.0) GO TO 130
         TEST = F
         GO TO 150
 130  MN = BIG
      DO 140 I = 1,K
         IF (B(I).GE.MN) GO TO 140
            J = I
            MN = B(I)
            OUT = S(I)
 140     CONTINUE
      B(J) = B(K)
      S(J) = S(K)
      K = K - 1
C  Check for linear dependence in Stage I:
 150  IF ((TEST) .OR. (.NOT.STAGE)) GO TO 170
         DO 160 I = 1,M2
            D = A(I,KR)
            A(I,KR) = A(I,IN)
            A(I,IN) = D
 160        CONTINUE
         KR = KR + 1
         GO TO 260
 170  IF (TEST) GO TO 180
         A(M2,1) = TWO
         GO TO 350
 180  PIVOT = A(OUT,IN)
      IF (A(M1,IN)-PIVOT-PIVOT.LE.TOLER) GO TO 200
         DO 190 J = KR,N1
            D = A(OUT,J)
            A(M1,J) = A(M1,J) - D - D
            A(OUT,J) = -D
 190        CONTINUE
         A(OUT,2) = -A(OUT,2)
         GO TO 120
C                                       Pivot on A(OUT,IN):
 200  DO 210 J = KR,N1
         IF (J.EQ.IN) GO TO 210
            A(OUT,J) = A(OUT,J)/PIVOT
 210     CONTINUE
      DO 230 I = 1,M1
         IF (I.EQ.OUT) GO TO 230
            D = A(I,IN)
            DO 220 J = KR,N1
               IF (J.EQ.IN) GO TO 220
               A(I,J) = A(I,J) - D * A(OUT,J)
 220           CONTINUE
 230     CONTINUE
      DO 240 I = 1,M1
         IF (I.EQ.OUT) GO TO 240
            A(I,IN) = -A(I,IN) / PIVOT
 240     CONTINUE
      A(OUT,IN) = ONE / PIVOT
      D = A(OUT,2)
      A(OUT,2) = A(M2,IN)
      A(M2,IN) = D
      KOUNT = KOUNT + 1
C                                       Interchange rows in Stage I:
      IF (.NOT.STAGE) GO TO 270
         KL = KL + 1
         DO 250 J = KR,N2
            D = A(OUT,J)
            A(OUT,J) = A(KOUNT,J)
            A(KOUNT,J) = D
 250        CONTINUE
 260     IF (KOUNT+KR.NE.N1) GO TO 70
C                                       *** Stage II.   ***
         STAGE = F
C  Determine the vector to enter the basis:
 270  MX = -BIG
      DO 290 J = KR,N
         D = A(M1,J)
         IF (D.GE.ZERO) GO TO 280
            IF (D.GT.-TWO) GO TO 290
               D = -D - TWO
 280     IF (D.LE.MX) GO TO 290
            MX = D
            IN = J
 290     CONTINUE
      IF (MX.LE.TOLER) GO TO 310
         IF (A(M1,IN).GT.ZERO) GO TO 100
            DO 300 I = 1,M2
               A(I,IN) = -A(I,IN)
 300           CONTINUE
            A(M1,IN) = A(M1,IN)-TWO
            GO TO 100
C  Prepare output:
 310  L = KL - 1
      DO 330 I = 1,L
         IF (A(I,1).GE.ZERO) GO TO 330
            DO 320 J = KR,N2
               A(I,J) = -A(I,J)
 320           CONTINUE
 330     CONTINUE
      A(M2,1) = ZERO
      IF (KR.NE.1) GO TO 350
      DO 340 J = 1,N
         D = ABS(A(M1,J))
         IF ((D.LE.TOLER) .OR. (TWO-D.LE.TOLER)) GO TO 350
 340     CONTINUE
      A(M2,1) = ONE
 350  DO 380 I = 1,M
         K = A(I,2)
         D = A(I,1)
         IF (K.GT.0) GO TO 360
            K = -K
            D = -D
 360     IF (I.GE.KL) GO TO 370
            X(K) = D
            GO TO 380
 370     CONTINUE
            K = K - N
            E(K) = D
 380     CONTINUE
      A(M2,2) = KOUNT
      A(M1,2) = N1 - KR
      SUM = 0.D0
      DO 390 I = KL,M
         SUM = SUM + A(I,1)
 390     CONTINUE
      A(M1,1) = SUM
C
 999  RETURN
      END

      PROGRAM SNCOP
C-----------------------------------------------------------------------
C! Task to copy SN table averaging input IFs
C# EXT-util Utility Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2009, 2012, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  SNCOP copies AIPS an SN extension tables file averaging IFs.
C  Adverbs:
C    INNAME      Input image name (name)
C    INCLASS     Input image name (class)
C    INSEQ       Input image name (seq. #)
C    INDISK      Input image disk unit #
C    INVERS      Input table file version no.
C    OUTNAME     Output image name (name)
C    OUTCLASS    Output image name (class)
C    OUTSEQ      Output image name (seq. #)
C    OUTDISK     Output image disk unit #.
C    DPARM       List of IFs to average
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER NAMEIN*12, CLAIN*6, FTYPE*2, STAT*4, NAMOUT*12,
     *   CLAOUT*6, XEXT*2, PRGM*6, TABTYP*2, ATIME*8, ADATE*12,
     *   HILINE*72
      HOLLERITH XNAMIN(3), XCLAIN(2), XNMOUT(3), XCLOUT(2)
      INTEGER  IRET, SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO, I,
     *   CATOLD(256), BUFF1(512), BUFF2(512), IERR, IVER, OVER, LUN1,
     *   LUN2, NPARM, IROUND,  NTAB, NOLDT, TIME(3), DATE(3), NIF, J,
     *   IF2AVG(MAXIF), I1, I2, NBOX
      LOGICAL   EXIST, TABLE, FITASC
      REAL      XSEQIN, XDISKI, XIVER, XSEQO, XDISKO, XBOX(2,20)
      LOGICAL   T, SAME
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      COMMON /INPARM/ XNAMIN, XCLAIN, XSEQIN, XDISKI, XIVER, XNMOUT,
     *   XCLOUT, XSEQO, XDISKO, XBOX
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA PRGM /'SNCOP '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 55
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMIN, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMIN, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNMOUT, NAMOUT)
      CALL H2CHR (6, 1, XCLOUT, CLAOUT)
      XEXT = 'SN'
C                                       Crunch input parameters.
      SEQIN  = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO  = IROUND (XDISKO)
      IVER   = IROUND (XIVER)
      OVER = 0
      TABTYP = XEXT
C                                       Prevent write to disk # 0 !
      IF (DISKO.EQ.0) DISKO = DISKIN
C                                       Default output = input.
      IF (NAMOUT.EQ.' ') NAMOUT = NAMEIN
      IF (CLAOUT.EQ.' ') CLAOUT = CLAIN
      IF (SEQOUT.LE.0) SEQOUT = SEQIN
C                                       Find input
      OLDCNO = 1
      FTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, FTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Find output
      NEWCNO = 1
      FTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKO, NEWCNO, NAMOUT, CLAOUT, SEQOUT, FTYPE,
     *    NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, NAMOUT, CLAOUT, SEQOUT, DISKO,
     *      NLUSER
         GO TO 990
         END IF
      SAME = (DISKIN.EQ.DISKO) .AND. (OLDCNO.EQ.NEWCNO)
      STAT = 'READ'
      IF (SAME) STAT = 'REST'
C                                       Read old CATBLK and mark 'READ'
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, STAT, BUFF1, IERR)
      IF ((IERR.GT.0) .AND. (IERR.LT.5)) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
      CALL COPY (256, CATBLK, CATOLD)
      CALL UVPGET (IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UVPGET FAILS ON INPUT UV DATA SET'
         GO TO 990
         END IF
      IF (JLOCIF.GE.0) THEN
         NIF = CATBLK (KINAX+JLOCIF)
      ELSE
         NIF = 1
         END IF
      IF (.NOT.SAME) THEN
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKIN
         FCNO(NCFILE) = OLDCNO
         FRW(NCFILE) = 0
         END IF
C                                       Read new CATBLK and mark 'WRIT'
      CALL CATIO ('READ', DISKO, NEWCNO, CATBLK, 'WRIT', BUFF1, IERR)
      IF ((IERR.GT.0) .AND. (IERR.LT.5)) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 1
C                                       Check number of tables
      CALL FNDEXT (TABTYP, CATOLD, NOLDT)
C                                       use highest version when IVER = 0
      IF (IVER.LE.0) IVER = NOLDT
      XIVER = IVER
      NTAB = 1
C                                       Is it a table
      CALL ISTAB (TABTYP, DISKIN, OLDCNO, IVER, LUN1, BUFF1, TABLE,
     *   EXIST, FITASC, IERR)
      IF (IERR.NE.0) THEN
         IRET = 5
         WRITE (MSGTXT,1030) IERR
         GO TO 990
         END IF
      IF (.NOT.EXIST) THEN
         IRET = 5
         WRITE (MSGTXT,1031) TABTYP, IVER
         GO TO 990
         END IF
C                                       which IFs to average
      NBOX = 0
      CALL FILL (MAXIF, 0, IF2AVG)
      DO 50 J = 1,20
         I1 = IROUND (XBOX(1,J))
         I2 = IROUND (XBOX(2,J))
         IF ((I1.GT.0) .AND. (I2.GE.I1)) THEN
            DO 40 I = I1,I2
               IF2AVG(I) = 1
 40            CONTINUE
            NBOX = NBOX + 1
         ELSE
            GO TO 60
            END IF
 50      CONTINUE
 60   IF (NBOX.EQ.0) THEN
         NBOX = 1
         XBOX(1,1) = 1.0
         XBOX(2,1) = NIF
         CALL FILL (NIF, 1, IF2AVG)
         END IF
      CALL UVPGET (IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UVPGET FAILS ON OUTPUT UV DATA SET'
         GO TO 990
         END IF
      IF (JLOCIF.GE.0) THEN
         NIF = CATBLK (KINAX+JLOCIF)
      ELSE
         NIF = 1
         END IF
C                                       Copy table
      CALL SNCOPY (IVER, LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO,
     *   CATOLD, CATBLK, IF2AVG, NIF, OVER, BUFF1, BUFF2, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Add history to output
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN1, DISKO, NEWCNO, BUFF1, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1090) IERR
         CALL MSGWRT (6)
         GO TO 150
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
      WRITE (HILINE,1100) TSKNAM, RLSNAM, ADATE, ATIME
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
C                                       Input file
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN1, BUFF1,
     *   IERR)
      IF (IERR.NE.0) GO TO 150
C                                       Type and version
      WRITE (HILINE,2000) TSKNAM, TABTYP, IVER, OVER
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
      MSGTXT = HILINE(7:)
      CALL MSGWRT (3)
      DO 70 J = 1,NBOX
         I1 = IROUND (XBOX(1,J))
         I2 = IROUND (XBOX(2,J))
         WRITE (HILINE,2010) TSKNAM, J, I1, I2
         CALL HIADD (LUN1, HILINE, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 150
         MSGTXT = HILINE(7:)
         CALL MSGWRT (3)
 70      CONTINUE
      WRITE (HILINE,2020) TSKNAM, NIF
      CALL HIADD (LUN1, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
      MSGTXT = HILINE(7:)
      CALL MSGWRT (3)
C                                       Close HI file
 150  CALL HICLOS (LUN1, T, BUFF1, IERR)
      GO TO 995
C                                       Error
 990  CALL MSGWRT (8)
C                                       Close down files, etc
 995  CALL DIE (IRET, BUFF1)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' GETING INPUT PARAMETERS')
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1020 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1030 FORMAT ('ISTAB ERROR ',I3,' CHECKING FILE')
 1031 FORMAT ('Extension file ',A2,' version',I5,' missing')
 1086 FORMAT ('TBLCOP ERROR ',I4,' COPYING EXT FILE ',A2,I5)
 1090 FORMAT ('ERROR',I3,' OPENING HISTORY FILE')
 1100 FORMAT (A6,'Release =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 2000 FORMAT (A6,'INEXT=''',A2,''' INVERS=',I4,' OUTVERS=', I4)
 2010 FORMAT (A6,'IF2AVG(',I2,') =',I3,' ,',I3,' / IFs averaged')
 2020 FORMAT (A6,'NIFOUT =',I3,' / Number output IFs')
      END
      SUBROUTINE SNCOPY (INVER, LUNOLD, LUNNEW, VOLOLD, VOLNEW, CNOOLD,
     *   CNONEW, CATOLD, CATNEW, IF2AVG, NIFO, OUTVER, BUFOLD, BUFNEW,
     *   IRET)
C-----------------------------------------------------------------------
C   SNCOPY copies an SN table averaging specified IFs.
C   Inputs:
C      INVER    I       Version number to copy, 0 => copy all.
C      LUNOLD   I       LUN for old file
C      LUNNEW   I       LUN for new file
C      VOLOLD   I       Disk number for old file.
C      VOLNEW   I       Disk number for new file.
C      CNOOLD   I       Catalog slot number for old file
C      CNONEW   I       Catalog slot number for new file
C      IF2FLG   I(*)    > 0 => include this IF in average
C      NIFO     I       Number of IFs out
C   In/out:
C      CATNEW   I(256)  Catalog header for new file.
C   Output:
C      OUTVER   I       Version number on output file, if more than one
C                       copied (INVER=0) this will be the number of the
C                       first file.  If OUTVER = 0, it will be taken as
C                       1 higher than the previous highest version.
C      BUFOLD   I(512)  Work buffer
C      BUFNEW   I(512)  Work buffer
C      IRET     I       Return error code  0 => ok
C                          1 => files the same, no copy.
C                          2 => no input files exist
C                          3 => failed
C                          4 => no output files created.
C                          5 => failed to update CATNEW
C                          6 => output file exists
C   Inputs from MSG common:
C      MSGSUP   I       If 31990 < MSGSUP < 32000, the file copied
C                       message is suppressed.
C-----------------------------------------------------------------------
      INTEGER   INVER, OUTVER, LUNOLD, LUNNEW, VOLOLD, VOLNEW, CNOOLD,
     *   CNONEW, BUFOLD(512), BUFNEW(512), CATOLD(256), CATNEW(256),
     *   NIFO, IF2AVG(*), IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   I, NREC, SNKOLS(MAXSNC), SNNUMV(MAXSNC), SNKOLO(MAXSNC),
     *   SNNUMO(MAXSNC), ISNRNO, OSNRNO, NUMANT, NUMPOL, NUMIF, NUMNOD,
     *   SOURID, ANTNO, SUBA, FREQID, NODENO, REFA(2,MAXIF), NAVG1,
     *   NAVG2, REF1, REF2, IREC
      LOGICAL   ISAPPL
      DOUBLE PRECISION TIME
      REAL      TIMEI, IFR, MBDELY(2), CREAL(2,MAXIF), CIMAG(2,MAXIF),
     *   DELAY(2,MAXIF), RATE(2,MAXIF), WEIGHT(2,MAXIF), GMMOD,
     *   RANOD(25), DECNOD(25), DAVG(2,5), DISP(2), DDISP(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       OPEN INPUT
      CALL SNINI ('READ', BUFOLD, VOLOLD, CNOOLD, INVER, CATOLD, LUNOLD,
     *   ISNRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT SN TABLE'
         GO TO 990
         END IF
C                                       create output
      OUTVER = 0
      CALL SNINI ('WRIT', BUFNEW, VOLNEW, CNONEW, OUTVER, CATNEW,
     *   LUNNEW, OSNRNO, SNKOLO, SNNUMO, NUMANT, NUMPOL, NIFO, NUMNOD,
     *   GMMOD, RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT SN TABLE'
         GO TO 990
         END IF
      NREC = BUFOLD(5)
C                                       read/write loop
      DO 50 IREC = 1,NREC
         ISNRNO = IREC
         CALL TABSN ('READ', BUFOLD, ISNRNO, SNKOLS, SNNUMV, NUMPOL,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT SN TABLE'
            GO TO 990
            END IF
         NAVG1 = 0
         NAVG2 = 0
         REF1 = MAXANT
         REF2 = MAXANT
         CALL RFILL (10, 0.0, DAVG)
         DO 20 I = 1,NUMIF
            IF (IF2AVG(I).GT.0) THEN
               IF ((CREAL(1,I).NE.FBLANK) .AND. (CIMAG(1,I).NE.FBLANK)
     *            .AND. (DELAY(1,I).NE.FBLANK) .AND.
     *            (RATE(1,I).NE.FBLANK) .AND. (WEIGHT(1,I).GT.0.0)) THEN
                  DAVG(1,1) = DAVG(1,1) + CREAL(1,I)
                  DAVG(1,2) = DAVG(1,2) + CIMAG(1,I)
                  DAVG(1,3) = DAVG(1,3) + DELAY(1,I)
                  DAVG(1,4) = DAVG(1,4) + RATE(1,I)
                  DAVG(1,5) = DAVG(1,5) + WEIGHT(1,I)
                  NAVG1 = NAVG1 + 1
                  IF (REFA(1,I).GT.0) REF1 = MIN (REF1, REFA(1,I))
                  END IF
               IF ((CREAL(2,I).NE.FBLANK) .AND. (CIMAG(2,I).NE.FBLANK)
     *            .AND. (DELAY(2,I).NE.FBLANK) .AND.
     *            (RATE(2,I).NE.FBLANK) .AND. (WEIGHT(2,I).GT.0.0)) THEN
                  DAVG(2,1) = DAVG(2,1) + CREAL(2,I)
                  DAVG(2,2) = DAVG(2,2) + CIMAG(2,I)
                  DAVG(2,3) = DAVG(2,3) + DELAY(2,I)
                  DAVG(2,4) = DAVG(2,4) + RATE(2,I)
                  DAVG(2,5) = DAVG(2,5) + WEIGHT(2,I)
                  NAVG2 = NAVG2 + 1
                  IF (REFA(2,I).GT.0) REF2 = MIN (REF2, REFA(2,I))
                  END IF
               END IF
 20         CONTINUE
         DO 30 I = 1,5
            IF (NAVG1.GT.0) THEN
               DAVG(1,I) = DAVG(1,I) / NAVG1
            ELSE
               REF1 = 0
               DAVG(1,I) = FBLANK
               END IF
            IF (NAVG2.GT.0) THEN
               DAVG(2,I) = DAVG(2,I) / NAVG2
            ELSE
               REF2 = 0
               DAVG(2,I) = FBLANK
               END IF
 30         CONTINUE
         DO 40 I = 1,NIFO
            CREAL(1,I) = DAVG(1,1)
            CIMAG(1,I) = DAVG(1,2)
            DELAY(1,I) = DAVG(1,3)
            RATE(1,I) = DAVG(1,4)
            WEIGHT(1,I) = DAVG(1,5)
            REFA(1,I) = REF1
            CREAL(2,I) = DAVG(2,1)
            CIMAG(2,I) = DAVG(2,2)
            DELAY(2,I) = DAVG(2,3)
            RATE(2,I) = DAVG(2,4)
            WEIGHT(2,I) = DAVG(2,5)
            REFA(2,I) = REF2
 40         CONTINUE
         OSNRNO = IREC
         CALL TABSN ('WRIT', BUFNEW, OSNRNO, SNKOLO, SNNUMO, NUMPOL,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT SN TABLE'
            GO TO 990
            END IF
 50      CONTINUE
      CALL TABSN ('CLOS', BUFOLD, ISNRNO, SNKOLS, SNNUMV, NUMPOL,
     *   TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *   MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING INPUT SN TABLE'
         CALL MSGWRT (8)
         END IF
      CALL TABSN ('CLOS', BUFNEW, OSNRNO, SNKOLO, SNNUMO, NUMPOL,
     *   TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *   MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OUTPUT SN TABLE'
         GO TO 990
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SNCOPY ERROR',I4,' DOING ',A)
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QMULCL (COMP, FLDECS, ABEAM, BBEAM, NCOMP)
C-----------------------------------------------------------------------
C! Pseudo AP routine: High level Clark CLEAN routine
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   Calls B. Clark's QCLNSU routine multiple times to
C   accumulate a number of CLEAN components in one AP call.
C   Inputs:
C      COMP  I   Base address of component vector 4 words per comp.:
C                1 = component intensity.
C                2 = x location (cells)
C                3 = y location (cells)
C                4 = field number
C                NOTE: this vector is the output of this routine.
C      FLDESC I  Field descriptor vector base address.
C                0 = Number of fields (REAL value)
C                 for each field:
C                0 = Start address of residuals (REAL value) (AMAP)
C                   (X,Y,intensity)
C                1 = Number of points in the map. (REAL value) (LMAP)
C                2 = Current max. flux density (loc = FCOMP)
C                3 = X position of current max.
C                4 = Y position of current max.
C                5 = CLEAN gain
C      ABEAM  I  Base address of the square (folded) beam patch.
C                The Y direction is most rapid variable:-BY<Y<BY,
C                X varies less rapidly, -1<X<BX
C      BBEAM  I  Beam description vector (BX,BY).
C                In the current QCLNSU BX must equal BY.
C      NCOMP  I  Number of components to CLEAN.
C-----------------------------------------------------------------------
      INTEGER   COMP, FLDECS, AMAP, LMAP, ABEAM, BBEAM, NCOMP, CCOMP,
     *   NFIELD, JNCOMP, JFDV, ILOOP, JAMAP, JNDEX, LOOP, JLMAP, JCOMP,
     *   I, IFIELD, JFDVT, JLOOP, JFIELD, IFIX, SAVLOC, IMAX
      REAL      AXMAX, XMAX, XLOC, X, Y, ARG
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                       Addresses to 1-rel etc.
      JFDV = FLDECS + 1
      JCOMP = COMP + 1
      NFIELD = APCORE(JFDV) + 0.3
C                                       Find maxima in fields
      DO 300 ILOOP = 1,NFIELD
C                                        Find largest mag. residual
         JNDEX = JFDV + (ILOOP-1) * 6 + 1
         JAMAP = APCORE(JNDEX) + 3.3
         JLMAP = APCORE(JNDEX+1) + 0.3
         JFDVT = JNDEX + 2
C                                        Loop thru residuals
         IF (JLMAP.LE.0) GO TO 210
C                                        Use ESSL routine to find
C                                        ABS maximum.
         IMAX = ISAMAX(JLMAP,APCORE(JAMAP),3)
         SAVLOC = JAMAP + (IMAX - 1) * 3
 210     CONTINUE
C                                        Save location
         APCORE(JFDVT) = APCORE(SAVLOC)
         APCORE(JFDVT+1) = APCORE(SAVLOC-2)
         APCORE(JFDVT+2) = APCORE(SAVLOC-1)
 300     CONTINUE
C                                       Loop
      DO 600 JLOOP = 1,NCOMP
C                                       Find field with max.
         JFDVT = JFDV + 3
C                                       Use ESSL routine to find
C                                       ABS maximum.
         IFIELD = ISAMAX(NFIELD,APCORE(JFDVT),6)
         JFIELD = JFDVT + (IFIELD - 1) * 6
C                                       Copy result to output vector
         APCORE(JCOMP) = APCORE(JFIELD)
         APCORE(JCOMP+1) = APCORE(JFIELD+1)
         APCORE(JCOMP+2) = APCORE(JFIELD+2)
         APCORE(JCOMP+3) = IFIELD
C                                       Get AMAP, LMAP for QCLNSU
C                                       (positions in FDV)
         AMAP = APCORE(JFIELD-2) + 0.3
         LMAP = APCORE(JFIELD-1) + 0.3
         CCOMP = JFIELD - 1
C                                       Subtract / find max.
         CALL QCLNSU (CCOMP, AMAP, LMAP, ABEAM, BBEAM)
C                                       Update JCOMP
         JCOMP = JCOMP + 4
 600     CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'CANPL.INC'
      REAL      SEQIN, DSKIN, VERSN, ASPMM, COPIES, XXPEN, DPARM(10),
     *   TRANFN(6), SCALEX, SCALEY, AMASK(256), RNRAND
      HOLLERITH XNAMIN(3), XCLSIN(2), XOUTFL(12), XOPTYP, XTRANF(6)
      CHARACTER NAMIN*12, CLSIN*6, OUTFIL*48, OPTYPE*4, CTRANF*2,
     *   CANBUF*80
      INTEGER GOPR, ITRN, CANPOS, CANSIZ, IXL, IYL, IX0, IY0, MAXCAN(2),
     *   MXD, MYD, MRAND(100), NRAND, PRAND, QRAND, JRAND
      COMMON /INPARM/ XNAMIN, XCLSIN, SEQIN, DSKIN, VERSN, ASPMM,
     *   COPIES, XXPEN, XOUTFL, XOPTYP, XTRANF, DPARM, TRANFN, GOPR,
     *   ITRN
      COMMON /CHPARM/ NAMIN, CLSIN, OUTFIL, OPTYPE, CTRANF
C                                       IMPORTANT NOTE:
C                                       the variables in canpl are not
C                                       what they appear: DPARM here
C                                       starts with AIPS DPARM(3);
C                                       TRANFN includes several adverbs
C                                       plus the first two words of
C                                       DPARM.
      COMMON /CANPCL/ CANPOS, CANSIZ, IXL, IYL, IX0, IY0, SCALEX,
     *   SCALEY, MAXCAN, MXD, MYD, AMASK
      COMMON /CANPCH/ CANBUF
      COMMON /RANDMM/ RNRAND, MRAND, NRAND, PRAND, QRAND, JRAND
LOCAL END
      PROGRAM CANPL
C-----------------------------------------------------------------------
C! Task to pass plot (PL) files to a Canon LBP-8 laser printer
C# Plot-appl Plot-util Printer
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2009, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CANPL is a program for the AIPS graphics package.  The program runs
C   as a detached task initiated from AIPS.  First a cataloged file is
C   found using data passed from AIPS.  The list of associated files is
C   searched for a plot file corresponding to the version number.  The
C   graphics commands are converted to character strings appropriate to
C   the Canon device and written to a file which "prints" at the end.
C
C   Inputs:  (from AIPS)
C      INNAME  R(3)   Name of primary file.
C      INCLASS R(2)   Class of primary file
C      INSEQ   R      Sequence number of primary file.
C      INDISK  R      Disk volume number. 0 means try all.
C      INVERS  R      Extension file version number. 0 ->
C                     use the highest version number.
C      ASPMM   R      Arc sec per millimeter. 0 -> self scale.
C      COPIES  R      Number of copies desired.
C      LPEN    R      Pen width in dots.  0 => 3.
C      OUTFILE R(12)  Output file name
C      OPTYPE  R      'NONE' ignore grey scale commands
C                     'MBIT' use sine pattern to build a font
C                     'BITS' use sine pattern to determine each dot
C                     'QRAN' use random numbers to build character font
C                     'MRAN' as 'QRAN' but with 78 levels not 26
C                     'RAND' use random numbers to determine each dot
C      FUNCTYPE  R    Convert after clipping by 'NE' negative linear,
C                     'LG' log, 'NG' negative log, 'PL' power law,
C                     'NL' negative power law.
C      FACTOR  R      Power law index for use with 'PL' or 'NL'
C                     FUNCTYPE's.
C      AXVAL   R(2)   Inflection point for transition from 1/FACTOR
C                     to FACTOR power law (0,0) => only use FACTOR
C      DPARM  R(10)   (1,2) Min, max clipping range 0 <= min<max <= 1.
C                           before FUNCTYPE, then
C                     (3,4) rescale G = DPARM(3)*G + DPARM(4) and
C                           clip again to 0 to 1.
C                  Parms for bit opcodes only:
C                     (5) <=0 -> Ignore rest of DPARM, use Gaus
C                         1 -> use DPARM for gaussian 'BIT ' mask
C                         2 -> ignore rest of DPARM, use sine
C                         3 -> use DPARM for sine wave 'BIT ' mask
C                     (6) width of mask (dots)
C                     (7) width of Gaussian, sine 0 => 1
C                     (8) x-shift of Gaus/sin in mask
C                     (9) y-shift of Gaus/sin in mask
C                     (10) number of grey-scale levels
C   Note: the adverbs are declared internally somewhat differently.
C   FACTOR, AXVAL -> TRANFN(2-4)
C   DPARM(1,2) -> TRANFN(5,6) and DPARM(3,10) -> DPARM(1,8).  the other
C   two positions in DPARM are declared however and used internally.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   BUFFER(256), LUN, FIND, IRET, IERR
      LOGICAL   QUICK
      INCLUDE 'CANPL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGNAM /'CANPL '/
      DATA LUN /26/
C-----------------------------------------------------------------------
C                                       Initialize the io parameters.
      CALL CANINI (PRGNAM, LUN, FIND, QUICK, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Write to graph file.
      CALL CANDRW (LUN, FIND, BUFFER, IRET)
      IF (IRET.EQ.0) GO TO 990
         WRITE (MSGTXT,1000)
         CALL MSGWRT (8)
         GO TO 990
C                                       Close graph file.
 990  CALL ZCLOSE (LUN, FIND, IERR)
 995  CALL DIETSK (IRET, QUICK, BUFFER)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR WRITING TO CANON DEVICE')
      END
      SUBROUTINE CANINI (PRGNAM, LUN, FIND, QUICK, BUFFER, IRET)
C-----------------------------------------------------------------------
C   CANINI does the initialization for CANPL, getting parameters,
C   locating the plot file, and opening it.
C   Inputs: PRGNAM   C*6      Task name
C           LUN      I        LUN to use for plot file
C   Output: FIND     I        FTAB pointer for plot file
C           QUICK    L        Quick return desired or not.
C           BUFFER   I(256)   Plot buffer
C           IRET     I        Error code: not 0 => quit.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   LUN, FIND
      LOGICAL   QUICK
      INTEGER   BUFFER(256), IRET
C
      CHARACTER TYPIN*2, STATUS*4, GFILE*48, OKOPS(6)*4, OKTRN(5)*2
      INTEGER  CATERR, IERR, NPARMS, SLOT, IVER, I, IVOL, ISEQ, USER,
     *   IROUND, NOPS, NTRN
      LOGICAL   NOMAP, NOEXCL, WAIT, EQUAL
      INCLUDE 'CANPL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA NOPS, OKOPS /6, 'NONE','MBIT','BITS','QRAN','MRAN','RAND'/
      DATA NTRN, OKTRN /5, 'NE','LG','NG','PL','NL'/
      DATA NOMAP, NOEXCL, WAIT /.FALSE.,.FALSE.,.TRUE./
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE., BUFFER)
      CALL VHDRIN
C                                       Get input values from AIPS.
      NPARMS = 38
      CALL GTPARM (PRGNAM, NPARMS, QUICK, XNAMIN, BUFFER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (8)
         END IF
      IF (QUICK) CALL RELPOP (IRET, BUFFER, IERR)
      IF (IRET.NE.0) GO TO 999
C                                       Force number of grey-scale
C                                       levels to be between 2 and 78
C                                       inclusive:
      IF ((DPARM(8) .LT. 2.0) .OR. (DPARM(8) .GT .78.0)) DPARM(8) = 78.0
C                                       Set DPARMs not set by GTPARM
      DPARM(9) = 1.
      DPARM(10) = 1.
C                                       Hollerith -> character
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
      CALL H2CHR (48, 1, XOUTFL, OUTFIL)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      CALL H2CHR (2, 1, XTRANF(1), CTRANF)
      DO 12 I = 1, 6
         TRANFN(I) = XTRANF(I)
 12      CONTINUE
C                                       Clip power law, inflec. point
      IF ((TRANFN(2).LT.0.001) .OR. (TRANFN(2).GT.999.)) TRANFN(2) = 1.0
      IF ((TRANFN(3).LT.0.001) .OR. (TRANFN(3).GT.0.999) .OR.
     *   (TRANFN(4).LT.0.001) .OR. (TRANFN(4).GT.0.999)) THEN
         TRANFN(3) = 0.5
         TRANFN(4) = 0.5
         END IF
C                                       Get OPcode for grey conversion
      GOPR = 0
      DO 20 I = 1,NOPS
         IF (OPTYPE.EQ.OKOPS(I)) GOPR = I
 20      CONTINUE
      IF (GOPR.EQ.0) GOPR = 2
C                                       Fix number of grey-scale levels
C                                       for OPcode QRAN:
      IF ((GOPR .EQ. 4) .AND. (DPARM(8) .GT. 26.0)) DPARM(8) = 26.0
C                                       Transfer function: type, clips
      ITRN = 0
      DO 25 I = 1,NTRN
         EQUAL = OKTRN(I) .EQ. CTRANF
         IF (EQUAL) ITRN = I
 25      CONTINUE
      ITRN = ITRN + 1
      IF ((TRANFN(5).LE.0.0) .OR. (TRANFN(5).GE.0.999)) TRANFN(5) = 0.0
      IF ((TRANFN(6).GT.1.0) .OR. (TRANFN(6).LE.TRANFN(5))) TRANFN(6) =
     *   1.0
      IF ((DPARM(1).LE.0.01) .OR. (DPARM(1).GE.100.)) DPARM(1) = 1.0
      IF (ABS(DPARM(2)).GT.0.9) DPARM(2) = 0.0
C                                       Get map header.
      ISEQ = IROUND (SEQIN)
      IVOL = IROUND (DSKIN)
      USER = NLUSER
      IVER = IROUND (VERSN)
      SLOT = 1
      TYPIN = ' '
      CALL CATDIR ('SRCH', IVOL, SLOT, NAMIN, CLSIN, ISEQ, TYPIN, USER,
     *   STATUS, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 995
         END IF
C                                       Read catalog header.
      CALL CATIO ('READ', IVOL, SLOT, CATBLK, 'REST', BUFFER, CATERR)
      IF ((CATERR.EQ.0) .OR. (CATERR.EQ.6)) GO TO 50
 45      WRITE (MSGTXT,1045) CATERR
         GO TO 995
C                                        Find plot file:
C                                        if PL & IVER=0, then main file
 50   EQUAL = TYPIN .EQ. 'PL'
      IF ((EQUAL) .AND. (CATERR.EQ.6)) GO TO 45
      IF ((EQUAL) .AND. (IVER.EQ.0)) IVER = CATBLK(KIIMS)
C                                        else take IVER as given or
C                                        as max version #
      IF (IVER.LE.0) CALL FNDEXT ('PL', CATBLK, IVER)
C                                       PLot file not found.
      IF (IVER.LE.0) THEN
         WRITE (MSGTXT,1060)
         GO TO 995
         END IF
C                                       Save parms
      SEQIN = ISEQ
      DSKIN = IVOL
      VERSN = IVER
C                                       Build file name.
      CALL ZPHFIL ('PL', IVOL, SLOT, IVER, GFILE, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Open graphics file.
      CALL ZOPEN (LUN, FIND, IVOL, GFILE, NOMAP, NOEXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1070)
         GO TO 995
         END IF
      GO TO 999
C                                       Error
 995  CALL MSGWRT (8)
      IF (IRET.EQ.0) IRET = 4
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('COULD NOT GET INPUTS FROM AIPS. GTPARM ERR =',I5)
 1020 FORMAT ('CATALOG ENTRY NOT FOUND. CATDIR ERR =',I5)
 1045 FORMAT ('ERROR READING CATALOG HEADER. CATIO ERR =',I5)
 1060 FORMAT ('PLOT FILE NOT IN CATALOG')
 1070 FORMAT ('PLOT FILE NOT FOUND')
      END
      SUBROUTINE CANDRW (LUN, FIND, BUFFER, IERR)
C-----------------------------------------------------------------------
C   This routine will execute the commands in a graph file for the
C   Canon.
C   INPUTS:  LUN     I   logical unit number of an open graph file.
C            FIND    I   pointer to the FTAB info of the graph file.
C            BUFFER  I(256)   buffer to use for I/O.
C            IERR    I   error code. 0 = ok.
C-----------------------------------------------------------------------
      INTEGER LUN, FIND, BUFFER(256), IERR
C
      CHARACTER CHBUF*200
      REAL   DX, DY, SCALEF, X, XYRATO, Y, RX1, RX2, TOTPIX, VALUE, RY1,
     *   RY2, AX, AY, XPXSEP, YPXSEP, YCADMM, UASPMM, XYDIFF, YASPMM,
     *   DELTA, XCADMM, RCALEX, RCALEY, GRSCAL, GROFF, NOWPIX, TEMPV
      INTEGER   ITYPE, QY, LXA, GRYERR, CSIZCA(2), NNCHAR, LYA, IANGL,
     *   ICHB, ICHL, ICHR, ICHT, INCRRN, IOPOS, IX, IX1, IY, IY1, NXA,
     *   NYA, OPCODE, CANLUN, I, IERRC, IX2, IY2, NCHAR, IROUND, LLPEN,
     *   IGRLO, IGRHI, NPTSX, NPTSY, NXDPP, NYDPP, IPER, IPER2, N, NPIX,
     *   IERRCH, ILAND, IORRN, CHLAND(2), IXCUR, IYCUR
      CHARACTER*1 CHAR, CSI, ESC, GRAVE, IS1, IS2, X23, X31
      LOGICAL   DOLAND, DOGREY, T
      INCLUDE 'CANPL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA CANLUN, T /7, .TRUE./
      DATA CHLAND /0,1/
C
C                                       The following character
C                                       variables are used for some
C                                       non-printing control characters.
C                                       The intrinsic Fortran77 function
C                                       CHAR returns the ASCII code for
C                                       the integer argument
C
      CSI =    CHAR (155)
      GRAVE =  CHAR (96)
      ESC =    CHAR (27)
      IS1 =    CHAR (31)
      IS2 =    CHAR (30)
      X23 =    CHAR (35)
      X31 =    CHAR (49)
C
C-----------------------------------------------------------------------
C                                       Initialize all values (units
C                                       are 1/300 inches).
C                                       MAXCAN is the paper size (10 x
C                                       7.5 inches; CSIZCA contains the
C                                       conversion factor from plot file
C                                       units for the frame and XCADMM
C                                       is
C                                       1 mm in 1/300 inches.
C
C                                       **** CSIZCA must be changed if
C                                       **** if the font is changed.
      MAXCAN(1) = 10. * 300
      MAXCAN(2) = 7.5 * 300
      CSIZCA(1) = 30
      CSIZCA(2) = 45
      XCADMM = 11.81
C                                       Initially, assume same scaling
C                                       for
C                                       both axes.
      YCADMM = XCADMM
      IERR = 0
      IERRC = 0
      IERRCH = 0
      GRYERR = 0
      DOGREY = .FALSE.
      IOPOS = 9999
      IORRN = 1
      CANPOS = 0
      CANSIZ = 80
      CANBUF = ' '
C                                       Open CANON file
      CALL ZLASIO ('OPEN', CANLUN, OUTFIL, NNCHAR, CANBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       determine where plot starts
      CALL ZFIO ('READ', LUN, FIND, 1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 980
      IORRN = (BUFFER(10) + 9) / 256 + 1
C                                       next plot command
C                                       Read record.
 50   IF (IOPOS.LE.256) GO TO 60
 55      IORRN = IORRN + 1
         CALL ZFIO ('READ', LUN, FIND, IORRN, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 980
         IOPOS = 1
C                                       Transfer based on opcode.
 60   OPCODE = BUFFER(IOPOS)
      IF ((OPCODE.GT.0) .AND. (OPCODE.LE.8)) GO TO (100, 200,
     *   300, 400, 500, 600, 700, 800), OPCODE
      IF (OPCODE.EQ.0) GO TO 55
C                                       End of file.
      IF (OPCODE.NE.32767) GO TO 970
         GO TO 990
C                                       Opcode 1, initialize.
C                                       Put map type in image header.
 100  ITYPE = BUFFER(IOPOS+5)
      IOPOS = IOPOS + 6
      GO TO 50
C                                       Opcode 2, line drawing init.
 200  XYRATO = BUFFER(IOPOS+1) / 100.0
      SCALEF = BUFFER(IOPOS+2)
      IX1    = BUFFER(IOPOS+3)
      IY1    = BUFFER(IOPOS+4)
      IX2    = BUFFER(IOPOS+5)
      IY2    = BUFFER(IOPOS+6)
      RX1    = BUFFER(IOPOS+7)/1000.0 + IX1
      RY1    = BUFFER(IOPOS+8)/1000.0 + IY1
      RX2    = BUFFER(IOPOS+9)/1000.0 + IX2
      RY2    = BUFFER(IOPOS+10)/1000.0 + IY2
C                                       Left, bottom, right and top of
C                                       frame
      ICHL   = (BUFFER(IOPOS+11)/10.0) * CSIZCA(1)  +  0.5
      ICHB   = (BUFFER(IOPOS+12)/10.0) * CSIZCA(2)  +  0.5
      ICHR   = (BUFFER(IOPOS+13)/10.0) * CSIZCA(1)  +  0.5
      ICHT   = (BUFFER(IOPOS+14)/10.0) * CSIZCA(2) +  0.5
      IOPOS = IOPOS + 15
C                                       Find number of pixels inside
C                                       border
      NYA = MAXCAN(2) - ICHT - ICHB - 1
      NXA = MAXCAN(1) - ICHL - ICHR - 1
      LYA = MAXCAN(1) - ICHT - ICHB - 1
      LXA = MAXCAN(2) - ICHL - ICHR - 1
      IF ((NXA.GT.0) .AND. (NYA.GT.0)) GO TO 205
         WRITE (MSGTXT,1200) NXA, NYA
         CALL MSGWRT (7)
         GO TO 990
C                                       Compute scaling: sizes
 205  AX = ABS(IX2 - IX1) * XYRATO
      AY = ABS(IY2 - IY1)
      X = ABS(RX2-RX1) * XYRATO
      Y = ABS(RY2-RY1)
      IF ((X.GT.0) .AND. (Y.GT.0)) GO TO 210
         WRITE (MSGTXT,1205) X, Y
         CALL MSGWRT (7)
         GO TO 990
C                                       Factors: landscape mode
C                                       (short axis y)
 210  IF ((X/Y).GT.FLOAT(NXA)/FLOAT(NYA)) GO TO 215
         SCALEY = NYA/SCALEF * AY/Y
         SCALEX = SCALEY * AX/AY
         GO TO 220
 215  CONTINUE
         SCALEX = NXA/SCALEF * AX/X
         SCALEY = SCALEX * AY/AX
C                                       Factors: portrait mode
 220  IF ((X/Y).GT.FLOAT(LXA)/FLOAT(LYA)) GO TO 223
         RCALEY = LYA/SCALEF * AY/Y
         RCALEX = RCALEY * AX/AY
         GO TO 225
 223  CONTINUE
         RCALEX = LXA/SCALEF * AX/X
         RCALEY = RCALEX * AY/AX
C                                       Use portrait
 225  DOLAND =  SCALEX*SCALEY.GE.RCALEX*RCALEY
      ILAND = 2
      IF (DOLAND) GO TO 230
         ILAND = 1
         SCALEX = RCALEX
         SCALEY = RCALEY
         I = MAXCAN(2)
         MAXCAN(2) = MAXCAN(1)
         MAXCAN(1) = I
C                                       Mm / arc sec scaling
 230  LOCNUM = 1
      AXTYP(LOCNUM) = 0
      UASPMM = ASPMM
      IF ((ITYPE.NE.2) .AND. (ITYPE.NE.3) .AND. (ITYPE.NE.6)) GO TO 235
         CALL SETLOC (BUFFER(IOPOS), T)
         IF (AXTYP(LOCNUM).NE.1) GO TO 235
            XPXSEP = AXINC(1,LOCNUM) * 3600.0 / XYRATO
            YPXSEP = XPXSEP
            CALL SCALMM (AX, AY, XPXSEP, YPXSEP, SCALEF, XCADMM,
     *         YCADMM, ASPMM, SCALEX, SCALEY)
            GO TO 240
C                                       Scale it down ?
 235  IF ((ASPMM.LE.0.02) .OR. (ASPMM.GT.0.98)) GO TO 240
         AXTYP(LOCNUM) = -10
         WRITE (MSGTXT,1235) ASPMM
         CALL MSGWRT (4)
         SCALEX = SCALEX * ASPMM
         SCALEY = SCALEY * ASPMM
C                                        Center
 240  NXA = SCALEX*SCALEF*X/AX + ICHL + ICHR
      IX0 = ICHL + MAX(0,MAXCAN(1)-NXA)/2 + 1
      NYA = SCALEY*SCALEF*Y/AY + ICHB + ICHT
      IY0 = ICHB + MAX(0,MAXCAN(2)-NYA)/2 + 1
      IOPOS = IOPOS + 5
      IF (BUFFER(IOPOS).NE.3) GO TO 350
      DOGREY = .TRUE.
C                                       Opcode 3, grey scale init.
 300  IF ((GOPR.GT.1) .AND. (DOGREY)) GO TO 305
         IOPOS = IOPOS + 5
         WRITE (MSGTXT,1300)
         IF (.NOT.DOGREY) CALL MSGWRT (7)
         DOGREY = .FALSE.
         GO TO 350
C                                       parms pick up
 305  IGRLO = BUFFER(IOPOS+1)
      IGRHI = BUFFER(IOPOS+2)
      NPTSX = BUFFER(IOPOS+3)
      NPTSY = BUFFER(IOPOS+4)
      IOPOS = IOPOS + 5
      IF ((IGRLO.LT.IGRHI) .AND. (NPTSX.GT.0) .AND. (NPTSY.GT.0)
     *   .AND. (NPTSX.LT.MAXCAN(1)-ICHL-ICHR)) GO TO 310
         WRITE (MSGTXT,1305) IGRLO, IGRHI, NPTSX, NPTSY
         CALL MSGWRT (7)
         DOGREY = .FALSE.
         GO TO 350
C                                       Change to RAND if small
 310  TOTPIX = REAL(NPTSX) * REAL(NPTSY)
      IF ((GOPR.EQ.3) .OR. (GOPR.EQ.6) .OR. (TOTPIX.GT.100)) GO TO 320
         WRITE (MSGTXT,1310)
         CALL MSGWRT (3)
         GOPR = 1
         DOGREY = .FALSE.
C                                       dots per pixel
 320  NXDPP = (NXA - ICHL - ICHR) * XYRATO / X  + 0.05
      NYDPP = (NYA - ICHT - ICHB) / Y  + 0.05
      IF (NXDPP*X/XYRATO.GT.MAXCAN(1)-ICHL-ICHR) NXDPP = NXDPP - 1
      IF (NYDPP*Y.GT.MAXCAN(2)-ICHB-ICHT) NYDPP = NYDPP - 1
      CALL FIXDPP (GOPR, NXDPP, NYDPP, DPARM)
      NXDPP = MAX (1, NXDPP)
      NYDPP = MAX (1, NYDPP)
      IF ((NXDPP.GE.4) .AND. (NYDPP.GE.4)) GO TO 325
         IF (NXDPP*NYDPP.GE.10) GO TO 325
         IF ((GOPR.NE.2) .AND. (GOPR.NE.4) .AND. (GOPR.NE.5)) GO TO 325
            WRITE (MSGTXT,1320)
            IF (GOPR.EQ.2) WRITE (MSGTXT,1321)
            CALL MSGWRT (7)
            DOGREY = .FALSE.
            GOPR = 1
C                                       reset scales
 325  SCALEX = NXDPP * (AX / XYRATO) / SCALEF
      SCALEY = NYDPP * AY / SCALEF
      NXA = ICHL + ICHR + NXDPP * X / XYRATO
      NYA = ICHB + ICHT + NYDPP * Y
      IX0 = ICHL + MAX (0, MAXCAN(1) - NXA) / 2
      IY0 = ICHB + MAX (0, MAXCAN(2) - NYA) / 2
      GRSCAL = 0.998 / (REAL(IGRHI) - REAL(IGRLO))
      GROFF = IGRLO - 0.001 / GRSCAL + TRANFN(5) / GRSCAL
      GRSCAL = GRSCAL / (TRANFN(6) - TRANFN(5))
C                                       Offset for negative coords
 350  IX0 = IX0 - (RX1-IX1) * XYRATO * SCALEX * SCALEF / AX
      IY0 = IY0 - (RY1-IY1) * SCALEY * SCALEF / AY
C                                       Display arcsec / mm info
      IF (AXTYP(LOCNUM).NE.1) GO TO 370
         ASPMM = ABS (AX * AXINC(1,LOCNUM) * 3600.0 * XCADMM)
     *      / (SCALEX * SCALEF * XYRATO)
         YASPMM = ABS (AY * AXINC(2,LOCNUM) * 3600.0 * YCADMM)
     *      / (SCALEY * SCALEF)
         XYDIFF = ABS (ASPMM - YASPMM)
         DELTA = .025 * ASPMM
C                                       X and Y ASPMM about the same.
         IF (XYDIFF.GT.DELTA) GO TO 355
            WRITE (MSGTXT,1350) ASPMM
            CALL MSGWRT (4)
            GO TO 360
C                                       Using different X and Y ASPMM
 355     CONTINUE
            WRITE (MSGTXT,1355) ASPMM
            CALL MSGWRT (4)
            WRITE (MSGTXT,1356) YASPMM
            CALL MSGWRT (4)
C
 360     IF ((UASPMM.LE.0.0) .OR. (UASPMM.GE.ASPMM)) GO TO 370
            WRITE (MSGTXT,1360)
            CALL MSGWRT (2)
C                                       Switch to ISO mode and reset
 370  WRITE (CHBUF,2370) ESC, ESC, ESC, CSI
      NNCHAR = 10
      CALL ZLASIO ('WRIT', CANLUN, OUTFIL, NNCHAR, CHBUF, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       page format = cassette size
C                                       landscape/portrait
      WRITE (CHBUF,2371) CSI, CHLAND(ILAND)
      NNCHAR = 3
      CALL ZLASIO ('WRIT', CANLUN, OUTFIL, NNCHAR, CHBUF, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       Copies
      NNCHAR = IROUND (COPIES)
      IF (NNCHAR.LE.0) NNCHAR = 1
      WRITE (CHBUF,2373) CSI, NNCHAR
      NNCHAR = 4
      CALL ZLASIO ('WRIT', CANLUN, OUTFIL, NNCHAR, CHBUF, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       And more stuff, as done by DVI!
      WRITE (CHBUF,2374) CSI, CSI, CSI, CSI
      NNCHAR = 26
      CALL ZLASIO ('WRIT', CANLUN, OUTFIL, NNCHAR, CHBUF, IERR)
      IF (IERR. NE. 0) GO TO 960
C                                       Init grey scale generation
      IF (.NOT.DOGREY) GO TO 380
         CALL CANGRY (1, CANLUN, NXDPP, NYDPP, IX, IY, DOLAND,
     *      VALUE, CHBUF, IERR)
         IF (IERR.EQ.0) GO TO 375
            WRITE (MSGTXT,1370) IERR
            CALL MSGWRT (7)
            DOGREY = .FALSE.
            GO TO 50
C                                       Init variables for progress
C                                       report.
 375     TOTPIX = REAL(NPTSX) * REAL(NPTSY)
         NOWPIX = 0.0
         IPER = 0
         WRITE (MSGTXT,1375)
         CALL MSGWRT (1)
C                                       on vector graphics, pen width
 380  LLPEN = IROUND (XXPEN)
      IF (LLPEN.LT.1) LLPEN = 2
      IF (LLPEN.GT.4) LLPEN = 4
      WRITE (CHBUF,2375) CSI, IS2, X23, X31, IS2, IS2,
     *                             CHAR(LLPEN+32), IS2
      NNCHAR = 22
      CALL FILZCH (NNCHAR, 1, CHBUF)
      CALL CANIO (CANLUN, NNCHAR, CHBUF, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       Check that scalefactors are OK
      CALL CNTPLT (LUN, FIND, IOPOS, IORRN, IX0, SCALEX, CSIZCA(1),
     *   ICHL, NXA, MAXCAN(1), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 980
      GO TO 50
C                                       Opcode 4, position cursor.
 400  IX = BUFFER(IOPOS+1)
      IY = BUFFER(IOPOS+2)
      IOPOS = IOPOS + 3
      CALL CANVEC (IX, IY, IXCUR, IYCUR, 1, CANLUN, IERR)
      IF (IERR.EQ.0) GO TO 50
      IF (IERR.NE.10) GO TO 960
         IERRC = IERRC + 1
         GO TO 50
C                                       Opcode 5, draw vector.
 500  IX = BUFFER(IOPOS+1)
      IY = BUFFER(IOPOS+2)
      IOPOS = IOPOS + 3
      CALL CANVEC (IX, IY, IXCUR, IYCUR, 2, CANLUN, IERR)
      IF (IERR.EQ.0) GO TO 50
      IF (IERR.NE.10) GO TO 960
         IERRC = IERRC + 1
         GO TO 50
C                                       Opcode 6, write characters.
 600  NCHAR = BUFFER(IOPOS+1)
      IANGL = BUFFER(IOPOS+2)
      DX    = BUFFER(IOPOS+3)/100.0
      DY    = BUFFER(IOPOS+4)/100.0
      IX = IXL + DX * CSIZCA(1)
      IY = IYL + DY * CSIZCA(2)
      QY = IY + 0.25 * CSIZCA(2)
C                                       horizontal
      IF (IANGL.EQ.1) GO TO 610
C                                       Move cursor
         CALL CANVEC (IX, QY, IXCUR, IYCUR, 3, CANLUN, IERR)
         IF (IERR.EQ.10) IERRCH = IERRCH + 1
         IF (IERR.EQ.10) GO TO 630
         IF (IERR.NE.0) GO TO 960
C                                       Switch to ISO text mode
         CALL CANTXT (IXCUR, IYCUR, CANLUN, IERR)
         IF (IERR.NE.0) GO TO 960
C                                       select text font
         WRITE (CHBUF,2376) ESC
         NNCHAR = 3
         CALL CANIO (CANLUN, NNCHAR, CHBUF, IERR)
         IF (IERR .NE. 0) GO TO 960
C                                       Copy characters to buffer
         CALL H2CHR (NCHAR, 1, BUFFER(IOPOS+5), CHBUF)
         NNCHAR = NCHAR
         CALL CANIO (CANLUN, NNCHAR, CHBUF, IERR)
         IF (IERR.NE.0) GO TO 960
C                                       Switch to vector graphics
         WRITE (CHBUF,2375) CSI, IS2, X23, X31, IS2, IS2,
     *                          CHAR(LLPEN+32), IS2
         NNCHAR = 22
         CALL FILZCH (NNCHAR, 1, CHBUF)
         CALL CANIO (CANLUN, NNCHAR, CHBUF, IERR)
         IF (IERR.NE.0) GO TO 960
         GO TO 630
C                                       vertical
 610  CONTINUE
         DO 620 I = 1,NCHAR
C                               Move cursor
            CALL CANVEC (IX, QY, IXCUR, IYCUR, 3, CANLUN, IERR)
            IF (IERR.EQ.10) IERRCH = IERRCH + 1
            IF (IERR.EQ.10) GO TO 630
            IF (IERR.NE.0) GO TO 960
C                                       Switch to ISO text mode
            CALL CANTXT (IXCUR, IYCUR, CANLUN, IERR)
            IF (IERR.NE.0) GO TO 960
C                                       select text font
            WRITE (CHBUF,2376) ESC
            NNCHAR = 3
            CALL CANIO (CANLUN, NNCHAR, CHBUF, IERR)
            IF (IERR .NE. 0) GO TO 960
C                                       Copy characters one at a time
            CALL H2CHR (1, I, BUFFER(IOPOS+5), CHBUF)
            NNCHAR=1
            CALL CANIO (CANLUN, NNCHAR, CHBUF, IERR)
            IF (IERR.NE.0) GO TO 960
C                                       Change vertical position
C                                       for next character
            QY = QY - CSIZCA(2)
C                                       Switch to vector graphics
            WRITE (CHBUF,2375) CSI, IS2, X23, X31, IS2, IS2,
     *                             CHAR(LLPEN+32), IS2
            NNCHAR = 22
            CALL FILZCH (NNCHAR, 1, CHBUF)
            CALL CANIO (CANLUN, NNCHAR, CHBUF, IERR)
            IF (IERR.NE.0) GO TO 960
 620        CONTINUE
 630  IOPOS = IOPOS + 5 + ((NCHAR+3)/4)
      GO TO 50
C                                       Opcode 7, write grey scale.
 700  IF (DOGREY) GO TO 710
         GRYERR = GRYERR + 1
C                                       Update IO position. Read
C                                       proper RRN if necessary.
         IOPOS = IOPOS + 3 + BUFFER(IOPOS+1)
         IF (IOPOS.LE.256) GO TO 60
            INCRRN = (IOPOS-1)/256
            IORRN = IORRN + INCRRN
            IOPOS = IOPOS - 256*INCRRN
            CALL ZFIO ('READ', LUN, FIND, IORRN, BUFFER, IERR)
            IF (IERR.EQ.0) GO TO 60
            GO TO 980
C                                       Get grey values from record(s).
 710  NPIX = BUFFER(IOPOS+1)
      IANGL = BUFFER(IOPOS+2)
      IOPOS = IOPOS + 3
      IF (NPIX.LE.0) GO TO 50
      IX = IXL - NXDPP/2
      IY = IYL + NYDPP/2
C                                       Set bits for each pixel.
      DO 790 N = 1,NPIX
C                                       Need another buffer of G values
         IF (IOPOS.LE.256) GO TO 720
            IORRN = IORRN + 1
            CALL ZFIO ('READ', LUN, FIND, IORRN, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 980
            IOPOS = 1
C
 720     VALUE = (BUFFER(IOPOS) - GROFF) * GRSCAL
         VALUE = MAX (0.001, MIN (0.999, VALUE))
         IF ((ITRN.EQ.2) .OR. (ITRN.EQ.4) .OR. (ITRN.EQ.6))
     *      VALUE = 1.000 - VALUE
         IF ((ITRN.EQ.3) .OR. (ITRN.EQ.4))
     *      VALUE = LOG (30.0*VALUE + 1.0) / LOG (30.42) - .007
         IF ((ITRN.NE.5) .AND. (ITRN.NE.6)) GO TO 722
            TEMPV = VALUE
            IF (TEMPV.LT.TRANFN(3))
     *         VALUE = TRANFN(4) * (VALUE / TRANFN(3)) ** (1./TRANFN(2))
            IF (TEMPV.GE.TRANFN(3))
     *         VALUE = TRANFN(4) + (1.-TRANFN(4)) *
     *                  ((VALUE-TRANFN(3))/(1.-TRANFN(3))) ** TRANFN(2)
 722     CONTINUE
         VALUE = DPARM(1) * VALUE + DPARM(2)
         VALUE = MAX (0.0, MIN (1.0, VALUE))
C                                       position for pixel
         IF ((IANGL.EQ.0) .AND. (N.GT.1)) GO TO 725
            CALL CANVEC (IX, IY, IXCUR, IYCUR, 3, CANLUN, IERR)
            IF (IERR.EQ.10) GO TO 730
            IF (IERR.NE.0) GO TO 960
C                                       do it
 725     CALL CANGRY (2, CANLUN, NXDPP, NYDPP, IX, IY, DOLAND,
     *      VALUE, CHBUF, IERR)
         IF (IERR.NE.0) GO TO 960
C                                       reset position
 730     IF (IANGL.EQ.0) IX = IX + NXDPP
         IF (IANGL.EQ.1) IY = IY + NYDPP
         IF (IANGL.EQ.2) IX = IX - NXDPP
         IF (IANGL.EQ.3) IY = IY - NYDPP
         IOPOS = IOPOS + 1
C                                       on graphics
         IF ((IANGL.EQ.0) .AND. (N.LT.NPIX)) GO TO 790
            WRITE (CHBUF,2375) CSI, IS2, X23, X31, IS2, IS2,
     *                             CHAR(LLPEN+32), IS2
            NNCHAR = 22
            CALL FILZCH (NNCHAR, 1, CHBUF)
            CALL CANIO (CANLUN, NNCHAR, CHBUF, IERR)
            IF (IERR.NE.0) GO TO 960
 790     CONTINUE
      NOWPIX = NOWPIX + NPIX
      IPER2 = INT(5.0 * NOWPIX / TOTPIX)
C                                       Write progress report.
      IF (IPER2.EQ.IPER) GO TO 50
         IPER = 20*IPER2
         WRITE (MSGTXT,1790) IPER
         IPER = IPER2
         CALL MSGWRT (1)
         GO TO 50
C                                       Opcode 8, put misc info in
C                                       image catalog.
 800  IOPOS = IOPOS + 2 + BUFFER(IOPOS+1)
      GO TO 50
C                                       Write error.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      GO TO 990
C                                       Invalid opcode.
 970  WRITE (MSGTXT,1970) OPCODE
      CALL MSGWRT (8)
      GO TO 990
C                                       Disk error.
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (8)
C                                       End picture
 990  WRITE (CHBUF,2990) IS2, IS2
      NNCHAR = 5
      CALL FILZCH (NNCHAR, 1, CHBUF)
      CALL CANIO (CANLUN, NNCHAR, CHBUF, IERR)
      IF (IERR.NE.0) GO TO 993
      IF (CANPOS.GT.0) CALL ZLASIO ('WRIT', CANLUN, OUTFIL, CANPOS,
     *    CANBUF, IERR)
C                                       and quit
      IF (IERR.EQ.0) CALL ZLASIO ('CLOS', CANLUN, OUTFIL, 0, CANBUF,
     *   IERR)
 993  IF (GRYERR.EQ.0) GO TO 995
         WRITE (MSGTXT,1993) GRYERR
         CALL MSGWRT (3)
 995  IF ((IERRC.LE.0) .AND. (IERRCH.LE.0)) GO TO 999
         WRITE (MSGTXT,1995) IERRC
         IF (IERRC.GT.0) CALL MSGWRT (3)
         WRITE (MSGTXT,1996) IERRCH
         IF (IERRCH.GT.0) CALL MSGWRT (3)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CANDRW: ERROR',I4,' OPENING CANON FILE/DEVICE')
 1200 FORMAT ('CANDRW: ERR FROM GINITL ARGS. NXA, NYA=',2I6)
 1205 FORMAT ('CANDRW: ERR FROM GINITL ARGS. X,Y=',2E10.3)
 1235 FORMAT ('Plot reduced in size by factor',F6.3)
 1300 FORMAT ('CANDRW: init grey scale out of order, ignored')
 1305 FORMAT ('CANDRW: BAD PARMS FROM GINITG:',4I7)
 1310 FORMAT ('FEWER THAN 157 PIXELS, USE BITS OR RAND')
 1320 FORMAT ('PIXELS TOO SMALL FOR QRAN OR MRAN, USE RAND')
 1321 FORMAT ('PIXELS TOO SMALL FOR MBIT, USE BITS')
 1350 FORMAT ('Using',1PE12.5,' arc sec per mm')
 1355 FORMAT ('Using',1PE12.5,' arc sec per mm for x axis')
 1356 FORMAT ('Using',1PE12.5,' arc sec per mm for y axis')
 1360 FORMAT ('Which overrides user ASPMM to fit plot on screen')
 1370 FORMAT ('CANDRW: ERROR',I5,' INITIALIZING GREY SCALE')
 1375 FORMAT ('Grey scale initialization complete')
 1790 FORMAT (I3,' %  of grey scale pixels plotted')
 1960 FORMAT ('CANDRW: CANON WRITE ERROR')
 1970 FORMAT ('CANDRW: INVALID OPCODE',I5,' IN GRAPH FILE')
 1980 FORMAT ('CANDRW: DISK IO RELATED ERROR',I3)
 1993 FORMAT ('CANDRW: ',I5,' GREY SCALE OPCODES IGNORED')
 1995 FORMAT (I8,' vectors truncated at edges')
 1996 FORMAT (I4,' character strings omitted at edges')
C                               select ISO mode (ESC ;)
C                               hard reset (ESC c)
C                               select ISO mode again (ESC ;)
C                               Full paint memory mode (CSI 2 & z)
 2370 FORMAT (A1,';',A1,'c',A1,';',A1,'2&z')
C                               Page format is cassette size
C                               CSI 0 p for portrait,
C                               CSI 1 p for landscape
 2371 FORMAT (A1,I1,'p')
C                               Number of copies (CSI no. v)
 2373 FORMAT (A1,I2,'v')
C                               Some stuff that dvicn does
 2374 FORMAT (A1,'11h',A1,'7 I',A1,'?2h',A1,'?1;3;4;5;6;7l')
C                               Enter vector mode (CSI 0 & })
C                               Begin picture (# name IS2)
C                               Scaling in 1/300" (! 0 X23 X31 IS2)
C                               Begin picture body ($ IS2)
C                               Set pen width (F 1 number IS2)
C                               number = -1,-2,-3,-4
 2375 FORMAT (A1,'0&}#CANPL',A1,'!0',3A1,'$',A1,'F1',2A1)
C                               Select ISO/ASCII character set
 2376 FORMAT( A1, '(B')
C                               End picture (% IS2)
C                               Return to text (} p IS2)
 2990 FORMAT ('%',A1,'}p',A1)
      END
      SUBROUTINE CANGRY (IOP, CANLUN, NX, NY, IX, IY, DOLAND, VALUE,
     *   CHBUF, IERR)
C-----------------------------------------------------------------------
C   CANGRY performs (IOP=1) the grey scale initialization needed for the
C   given operation: GOPR = 4,5 compute random character set and
C   download to the Canon, GOPR = 6 initialize random number generator,
C   GOPR = 2,3 prepare sine/Gaussian array for masking and on 2 download
C   a character set.  On IOP=2, it writes the pixel to the device as a
C   character (GOPR = 2,4,5) or as a dot matrix.
C   Inputs: IOP     I        = 1 -> INIT, = 2 -> do it.
C           CANLUN  I        LUN for open CANON print file.
C           NX      I        Number dots per pixel in X
C           NY      I        Number dots per pixel in Y
C           IX      I        Current dot position of pixel in X.
C           IY      I        Current dot position of pixel in Y.
C           DOLAND  L        T => landscape mode, else portrait
C           VALUE   R        Grey scale pixel value (0. to 1.)
C   Output: CHBUF   C*80     Scratch buffer
C           IERR    I        Error code: 0 -> ok, 1 -> input error,
C                               2 -> I/O error
C   Inputs in COMMON:
C           DPARM   R(10)    DPARM(8) = number of grey-scale levels
C           GOPR    I        Grey-scale type: 2 MBIT, 3 BITS, 4 QRAN,
C                            5 MRAN, 6 RAND
C-----------------------------------------------------------------------
      INTEGER   IOP, CANLUN, NX, NY, IX, IY
      LOGICAL   DOLAND
      REAL      VALUE
      CHARACTER CHBUF*80
      INTEGER   IERR
C
      INTEGER   ITJ(8), I, J, NNCHAR, INX, INY, NC, I1, I2, IT, IL, IC,
     *   JJ, IOFF, ILY, LLLY, WIDTH, QUANT, YFIX, FPITCH, FHT,
     *   CWIDTH, CHT, NLAND, NLEVEL, NBYTES
      REAL     TV, SX, SY, AM, ADX, ADY, CNX, CNY, CAX, CAY, CBX, CBY
      CHARACTER*1 CSI, ESC, X31, IS2, NXTCHR
      CHARACTER*26 ALPHA(3)
      INCLUDE 'CANPL.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA ITJ /128, 64, 32, 16, 8, 4, 2, 1/
      DATA ALPHA /'ABCDEFGHIJKLMNOPQRSTUVWXYZ',
     *            'abcdefghijklmnopqrstuvwxyz',
     *            '1234567890!@#$%&*()-+=<>,.'/
C-----------------------------------------------------------------------
      CSI = CHAR(155)
      ESC = CHAR(27)
      X31 = CHAR(49)
      IS2 = CHAR(30)
C                                       Test inputs
      IERR = 1
      IF ((IOP.NE.1) .AND. (IOP.NE.2)) GO TO 999
      IF ((GOPR.LT.2) .OR. (GOPR.GT.6)) GO TO 999
      IERR = 0
C                                       Initialization
      NLEVEL = NINT(DPARM(8))
      IF (IOP.EQ.2) GO TO 500
         MXD = DPARM(9) + 0.01
         MYD = DPARM(10) + 0.01
         IF (MXD.LE.0) MXD = 1
         IF (MYD.LE.0) MYD = 1
C                                       'QRAN', 'MRAN', 'MBIT', 'BITS'
         IF (GOPR.EQ.6) GO TO 100
C                                       Get BIT mask
            IF ((GOPR.EQ.4) .OR. (GOPR.EQ.5)) GO TO 20
               INX = MXD / 2 + 1
               SX = 6.283185 * DPARM(5) / MXD
               INY = MYD / 2 + 1
               SY = 6.283185 * DPARM(5) / MYD
               AM = 0.0
               ADX = DPARM(5) / (MXD/4.0) ** 2
               ADY = DPARM(5) / (MYD/4.0) ** 2
               CNX = INX - DPARM(6)
               CNY = INY - DPARM(7)
               CAX = MXD + 1 - DPARM(6)
               CAY = MYD + 1 - DPARM(7)
               CBX = 1 - DPARM(6)
               CBY = 1 - DPARM(7)
               I1 = 0
               DO 15 I = 1,MYD
                  TV = COS (SY * (I-CNY))
                  ILY = I1 + 1
                  DO 10 J = 1,MXD
                     I1 = I1 + 1
                     AMASK(I1) = 0.50 * (TV * COS (SX*(J-CNX))
     *                  + 1.0)
                     IF (DPARM(3).GT.1.5) GO TO 10
                        AMASK(I1) =
     *                     EXP (-ADX*((J-CNX)**2) - ADY*((I-CBY)**2))
     *                   + EXP (-ADX*((J-CAX)**2) - ADY*((I-CNY)**2))
     *                   + EXP (-ADX*((J-CNX)**2) - ADY*((I-CAY)**2))
     *                   + EXP (-ADX*((J-CBX)**2) - ADY*((I-CNY)**2))
                        AM = MAX (AM, AMASK(I1))
 10                  CONTINUE
 15               CONTINUE
               IF (DPARM(3).GT.1.5) GO TO 19
                  I1 = 0
                  DO 18 I = 1,MYD
                     ILY = I1 + 1
                     DO 17 J = 1,MXD
                        I1 = I1 + 1
                        AMASK(I1) = 1.0 - AMASK(I1) / AM
 17                     CONTINUE
 18                  CONTINUE
 19            CONTINUE
               I1 = 0
               DO 192 I = 1,MYD
                  DO 191 J = 1,MXD
                     I1 = I1 + 1
                     AMASK(I1) = 0.998 * AMASK(I1) + 0.001
 191              CONTINUE
 192           CONTINUE
               IF (GOPR.EQ.3) GO TO 999
C                                       get sizes
 20         INX = NX
            INY = NY
            IF (.NOT.DOLAND) GO TO 25
               INX = NY
               INY = NX
 25         NC = ((INX+7) / 8)
C                                       memory requirements
C                                       (Assume text font is less
C                                        than 100k)
            I2 = ((NC * INY + 4) * 78. + 1023.) / 1024.
            IF (I2.LE.1000) GO TO 30
               GOPR = 1
               WRITE (MSGTXT,1025)
               CALL MSGWRT (6)
               GO TO 100
C                                       init random numbers
 30         CALL RANDIN (IERR)
            IF (IERR.NE.0) GO TO 999
C                                       compute a character set
C                                       first, do the rather complicated
C                                       coding to set up font
C                                       number bytes per char, * chars
            NBYTES = (NC * INY + 4)
            NBYTES = NBYTES * 78
C                                       landscape or portrait
            IF (DOLAND) THEN
               NLAND = 1
            ELSE
               NLAND = 0
            END IF
C                                       font pitch and height
            FPITCH = INT(3750.0 / REAL(NC)) + 1
            FHT = 100 * INY
C                                       cell width and height
            CWIDTH = NC * 8
            CHT = INY
C                                       send it to the file
            WRITE (CHBUF,1030) CSI, NBYTES, NLAND, FPITCH,
     *                               FHT, CWIDTH, CHT
            NNCHAR = 58
            CALL FILZCH(NNCHAR, 1, CHBUF)
            CALL CANIO (CANLUN, NNCHAR, CHBUF, IERR)
            IF (IERR.NE.0) GO TO 995
C                                       define characters
            DO 75 I = 1,26
               DO 70 J = 1,3
C                                       character, pitch, width
C                                       and offset
                  NXTCHR = ALPHA(J)(I:I)
                  WRITE (CHBUF,1031) NXTCHR, CHAR(CWIDTH),
     *                                     CHAR(CWIDTH), CHAR(0)
                  NNCHAR = 4
                  CALL FILZCH (NNCHAR, 1, CHBUF)
                  CALL CANIO (CANLUN, NNCHAR, CHBUF, IERR)
                  IF (IERR.NE.0) GO TO 995
C                                       Value of char
                  VALUE = 0.001 + 0.998 * (I-1) / (NLEVEL - 1)
                  IF ((GOPR.EQ.2) .OR. (GOPR.EQ.5)) VALUE = 0.001
     *               + 0.998 * ((J-1)*26+I-1) / (NLEVEL - 1)
                  IF (VALUE .GT. 0.999) VALUE = 0.999
                  IOFF = -1
                  DO 65 IL = 1,INY
                     I1 = 0
                     ILY = MOD (IL+IOFF, MYD) * MXD + 1
                     DO 60 IC = 1,NC
                        CANPOS = CANPOS + 1
                        IF (CANPOS.LE.CANSIZ) GO TO 35
                           CALL ZLASIO ('WRIT', CANLUN, OUTFIL, CANSIZ,
     *                        CANBUF, IERR)
                           IF (IERR.NE.0) GO TO 995
                           CANPOS = 1
 35                     IT = 0
C                                       Random functions
                        IF (GOPR.EQ.2) GO TO 45
                           DO 40 JJ = 1,8
                              I1 = I1 + 1
                              IF (I1.GT.INX) GO TO 55
                                 CALL RANDUM (TV)
                                 IF (VALUE.GT.TV) IT = IT + ITJ(JJ)
 40                           CONTINUE
                           GO TO 55
C                                       Starlink function
 45                     CONTINUE
                           DO 50 JJ = 1,8
                              I1 = I1 + 1
                              IF (I1.GT.INX) GO TO 55
                                 I2 = ILY + MOD (I1+IOFF, MXD)
                                 IF (VALUE.GT.AMASK(I2)) IT = IT +
     *                              ITJ(JJ)
 50                           CONTINUE
C ???                   ENCODE(80,1040,CHBUF) CHAR(IT)
 55                     WRITE (CHBUF,1040) CHAR(IT)
                        CALL FILZCH(1, 1, CHBUF)
                        CANBUF(CANPOS:CANPOS+1-1) = CHBUF(1:1+1-1)
 60                     CONTINUE
 65                  CONTINUE
 70               CONTINUE
 75            CONTINUE
            GO TO 999
C                                       'RAND'
 100     IF (GOPR.NE.6) GO TO 999
C                                       init random numbers
            CALL RANDIN (IERR)
            GO TO 999
C-----------------------------------------------------------------------
C                                       Do it: grey to Canon
 500  CONTINUE
C                                       All character forms
         IF ((GOPR.EQ.3) .OR. (GOPR.EQ.6)) GO TO 600
C                                       random case
            IF (GOPR.NE.4) GO TO 510
               CALL RANDUM (TV)
               J = 1
               IF (TV.GT.0.3333) J = 2
               IF (TV.GT.0.6666) J = 3
C                                       get character
               I = 25.0 * VALUE + 1.50
               IF (I.LE.0) I = 1
               IF (I.GT.26) I = 26
               GO TO 520
C                                       Finer levels
 510        CONTINUE
               I = (NLEVEL - 1) * VALUE + 1.50
               IF (I.LE.0) I = 1
               IF (I.GT.78) I = 78
               J = (I-1) / 26 + 1
               I = I - (J-1)*26
C                                       Switch to Text mode at start
C                                       of current scan line
 520        WRITE (CHBUF,1040) '}'
            CALL FILZCH(1, 1, CHBUF)
            CALL CANIO(CANLUN, 1, CHBUF, IERR)
            WRITE (CHBUF,1040) 'p'
            CALL FILZCH(1, 1, CHBUF)
            CALL CANIO(CANLUN, 1, CHBUF, IERR)
            CALL CANINT(CANLUN,CHBUF,IX,IERR)
            CALL CANINT(CANLUN,CHBUF,(MAXCAN(2)-(IY-INY)),IERR)
            WRITE (CHBUF,1040) IS2
            CALL FILZCH(1, 1, CHBUF)
            CALL CANIO(CANLUN, 1, CHBUF, IERR)
C                                        select grey-scale font
            WRITE (CHBUF,1038) ESC
            NNCHAR = 5
            CALL FILZCH(NNCHAR, 1, CHBUF)
            CALL CANIO(CANLUN, NNCHAR, CHBUF, IERR)
C                                         and send character
            NXTCHR = ALPHA(J)(I:I)
            WRITE (CHBUF,1040) NXTCHR
            CALL FILZCH(1, 1, CHBUF)
            CALL CANIO(CANLUN, 1, CHBUF, IERR)
C                                          return to vector graphics
            WRITE (CHBUF,1044) CSI
            CALL FILZCH(4,1,CHBUF)
            CALL CANIO(CANLUN,4,CHBUF,IERR)
            GO TO 999
C-----------------------------------------------------------------------
C                                       'RAND', 'SIN ' : each dot
 600     IF ((GOPR.NE.3) .AND. (GOPR.NE.6)) GO TO 999
C         I = INT( (VALUE - 0.001) * (NLEVEL-1) / 0.998)
C         VALUE = 0.001 + (REAL(I) / (NLEVEL-1) * 0.998)
C                                       This may not be correct for
C                                       landscape mode - try it
            INX = NX
            INY = NY
            IF (.NOT.DOLAND) GO TO 610
C               INX = NY
C               INY = NX
 610        NC = ((INX + 7) / 8)
            LLLY = MYD * 1000 - IY
C                                       Send random bits until full
            DO 650 I = 1,INY
               YFIX = MAXCAN(2) - (IY + I - INY)
C                                       Switch to Text mode at start
C                                       of current scan line
               WRITE (CHBUF,1040) '}'
               CALL FILZCH(1, 1, CHBUF)
               CALL CANIO(CANLUN, 1, CHBUF, IERR)
               WRITE (CHBUF,1040) 'p'
               CALL FILZCH(1, 1, CHBUF)
               CALL CANIO(CANLUN, 1, CHBUF, IERR)
               CALL CANINT(CANLUN,CHBUF,IX,IERR)
               CALL CANINT(CANLUN,CHBUF,YFIX,IERR)
               WRITE (CHBUF,1040) IS2
               CALL FILZCH(1, 1, CHBUF)
               CALL CANIO(CANLUN, 1, CHBUF, IERR)
C                                        Send image draw command
C                                        using binary data
C                                        <CSI><quant>;<width>.r
               WIDTH = NC
               QUANT = NC
               IF (WIDTH .LE. 9) THEN
                  WRITE (CHBUF,1041) CSI,QUANT,WIDTH
                  NNCHAR = 6
               ELSE
                  WRITE (CHBUF,1043) CSI,QUANT,WIDTH
                  NNCHAR = 8
               END IF
               CALL FILZCH(NNCHAR,1,CHBUF)
               CALL CANIO(CANLUN, NNCHAR, CHBUF, IERR)
               I1 = 0
               ILY = LLLY + I - 2
               ILY = MOD (ILY, MYD) * MXD + 1
               IL = IX - 2
               DO 645 J = 1,NC
                  CANPOS = CANPOS + 1
                  IF (CANPOS.LE.CANSIZ) GO TO 620
                     CALL ZLASIO ('WRIT', CANLUN, OUTFIL, CANSIZ,
     *                  CANBUF, IERR)
                     IF (IERR.NE.0) GO TO 995
                     CANPOS = 1
 620              IT = 0
C                                       Random case
                  IF (GOPR.EQ.3) GO TO 630
                     DO 625 I2 = 1,8
                        I1 = I1 + 1
                        IF (I1.GT.INX) GO TO 640
                           CALL RANDUM (TV)
                           IF (VALUE.GE.TV) IT = IT + ITJ(I2)
 625                    CONTINUE
                     GO TO 640
C                                       Starlink case
 630              CONTINUE
                     DO 635 I2 = 1,8
                        I1 = I1 + 1
                        IF (I1.GT.INX) GO TO 640
                           IC = ILY + MOD (IL+I1, MXD)
                           IF (VALUE.GT.AMASK(IC)) IT = IT + ITJ(I2)
 635                    CONTINUE
 640              WRITE (CHBUF,1040) CHAR(IT)
                  CALL FILZCH(1, 1, CHBUF)
                  CANBUF(CANPOS:CANPOS+1-1) = CHBUF(1:1+1-1)
 645              CONTINUE
C                                       return to vector graphics
               WRITE (CHBUF,1044) CSI
               CALL FILZCH(4,1,CHBUF)
               CALL CANIO(CANLUN,4,CHBUF,IERR)
 650        CONTINUE
            GO TO 999
C                                       I/O error
 995  WRITE (MSGTXT,1995) IERR
      IERR = 2
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1025 FORMAT ('CANGRY: SWITCH TO DOT-BY-DOT - TOO MUCH CORE NEEDED IN',
     *   ' QUICK MODES')
 1030 FORMAT (A1,I5.5,';78;0;',I1,';3998;2;',I5.5,';',
     *        I5.5,';0;0;254;',I2.2,';',I2.2,';1;1;1;0;0.p')
 1031 FORMAT (4A1)
 1038 FORMAT (A1,'(/)>')
 1040 FORMAT (A1)
 1041 FORMAT (A1,I1,';',I1,'.r')
 1043 FORMAT (A1,I2,';',I2,'.r')
 1044 FORMAT (A1,'0&}')
 1995 FORMAT ('CANGRY: CANON WRITE ERROR',I5)
      END
      SUBROUTINE CANTXT (IXCUR, IYCUR, CANLUN, IERR)
C-----------------------------------------------------------------------
C   This routine exits from vector graphics leaving the cursor
C   at position (IXCUR, IYCUR)
C
C   Inputs:   IXCUR    I   X coordinate value.
C             IYCUR    I   Y coordinate value.
C             CANLUN   I   Unit for CANON print file
C   Output:   IERR     I   Error code: 0 => ok
C                                    10 => vector truncated
C                                    else I/O error
C-----------------------------------------------------------------------
      INTEGER   IXCUR, IYCUR, CANLUN, IERR
C
      CHARACTER CANCOM*16
      CHARACTER*1 CHAR, IS2, CSI, ESC
C-----------------------------------------------------------------------
C                                       Get character values of
C                                       hex codes used by the CANON
      IS2 = CHAR(30)
      CSI = CHAR(155)
      ESC = CHAR(27)
C
      WRITE (CANCOM,1005) IS2
      CALL FILZCH (4, 1, CANCOM)
      CALL CANIO (CANLUN, 4, CANCOM, IERR)
      CALL CANINT(CANLUN,CANCOM,IXCUR,IERR)
      CALL CANINT(CANLUN,CANCOM,IYCUR,IERR)
      WRITE (CANCOM,1010) IS2
      CALL FILZCH (1, 1, CANCOM)
      CALL CANIO (CANLUN, 1, CANCOM, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
C                               End picture (% IS2)
C                               Return to text (} p point IS2)
C                               point is the position at which
C                               the text should be placed. This
C                               position is an integer parameter
C                               which must be encoded by routine
C                               CANINT
 1005 FORMAT ('%',A1,'}p')
 1010 FORMAT (A1)
      END
      SUBROUTINE CANINT (CANLUN, CANCOM, INT, IERR)
C-----------------------------------------------------------------------
C  CANINT outputs an integer parameter to the Canon in vector graphics
C  mode. An integer with an absolute value of less than 16 is output as
C  a single byte, an integer with an absolute value greater than 16 but
C  less than 1024 is output as two bytes and an integer with an absolute
C  value greater than 1024 is output as three bytes. The encoding rules
C  are given on pp 117-120 of volume II of the Canon LBP-8 Programmer's
C  Manual.
C
C  Inputs:  CANLUN    I       LUN for Canon printer
C           CANCOM    C*16    Output buffer
C           INT       I       The number to be output
C  Outputs: IERR      I       CANIO status
C  Common:  CANBUF
C           CANPOS
C-----------------------------------------------------------------------
      INTEGER   CANLUN
      CHARACTER CANCOM*16
      INTEGER   INT, IERR
C
      INTEGER   REM, BIT, SIGN
C-----------------------------------------------------------------------
C                                   Get sign and absolute value of input
C                                   number
      SIGN=ISIGN(1,INT)
      INT=ABS(INT)
      IF(INT.GE.1024) THEN
         BIT=INT/1024
         REM=INT-1024*BIT
         BIT=BIT+64
         WRITE (CANCOM,1010) CHAR(BIT)
         CALL CANIO (CANLUN, 1, CANCOM, IERR)
         IF(IERR.NE.0) GO TO 999
      ELSE
         REM=INT
         END IF
      IF(INT.GE.16) THEN
         BIT=REM/16
         REM=REM-16*BIT
         BIT=BIT+64
         WRITE (CANCOM,1010) CHAR(BIT)
         CALL CANIO (CANLUN, 1, CANCOM, IERR)
         IF(IERR.NE.0) GO TO 999
      ELSE
         REM=INT
         END IF
      IF(SIGN.LT.0) THEN
         BIT=REM+32
      ELSE
         BIT=REM+48
         END IF
      WRITE (CANCOM,1010) CHAR(BIT)
      CALL CANIO (CANLUN, 1, CANCOM, IERR)
      IF(IERR.NE.0) GO TO 999
999   RETURN
C-----------------------------------------------------------------------
1010  FORMAT(A1)
      END
      SUBROUTINE CANIO (CANLUN, N, QBUF, IERR)
C-----------------------------------------------------------------------
C   CANIO moves characters to the buffer and if needed causes an I/O
C   to occur to the CANON "print" file.
C   Inputs: CANLUN   I        LUN of file
C           N        I        Number of new characters
C           QBUF     C*(*)    Character string
C   Output: IERR     I        Error code: 0 -> ok, else I/O error
C-----------------------------------------------------------------------
      INTEGER   CANLUN, N
      CHARACTER QBUF*(*)
      INTEGER   IERR
C
      INTEGER   J, J0, J1
      INCLUDE 'CANPL.INC'
C-----------------------------------------------------------------------
      IERR = 0
      J0 = N
      J1 = 1
C                                       Do an I/O (or two or three...)
 10   IF (CANPOS+J0.LE.CANSIZ) GO TO 30
         J = CANSIZ - CANPOS
         CANPOS = CANPOS + 1
         CANBUF(CANPOS:CANPOS+J-1) = QBUF(J1:J1+J-1)
         CANPOS = CANPOS + J - 1
         J0 = J0 - J
         J1 = J1 + J
         CALL ZLASIO ('WRIT', CANLUN, OUTFIL, CANPOS, CANBUF, IERR)
         IF (IERR.NE.0) GO TO 999
         CANPOS = 0
         GO TO 10
C                                       Just move characters
 30   CONTINUE
         CANPOS = CANPOS + 1
         CANBUF(CANPOS:CANPOS+J0-1) = QBUF(J1:J1+J0-1)
         CANPOS = CANPOS + J0 - 1
C
 999  RETURN
      END
      SUBROUTINE FIXDPP (GOPR, NXDPP, NYDPP, DPARM)
C-----------------------------------------------------------------------
C   FIXDPP attempts to fix up the dots/pixel and mask size to be
C   compatible
C   Inputs: GOPR    I        Type of grey scale
C   In/out: NXDPP   I        Dots/pixel in X: (in) request (out) used
C           NYDPP   I        Dots/pixel in Y: (in) request (out) used
C           DPARM   R(10)    (3) default mask size (in)
C                            (6) use this X mask size (out)
C                            (7) use this Y mask size (out)
C-----------------------------------------------------------------------
      INTEGER   GOPR, NXDPP, NYDPP
      REAL      DPARM(10)
C
      INTEGER   N(2), M, I, J, IROUND, LM, LJ, L, MD(2)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       BITS Parameters
      M = 8
      IF ((GOPR.NE.2) .AND. (GOPR.NE.3)) GO TO 100
         I = IROUND (DPARM(3))
         IF (I.LE.0) I = 0
         IF (I.GT.3) I = 0
         DPARM(3) = I
         IF ((I.EQ.1) .OR. (I.EQ.3)) GO TO 20
            DPARM(5) = 1.0
            DPARM(4) = 8.0
            DPARM(6) = 10.0
            DPARM(7) = 10.0
            M = 8
            GO TO 100
 20      CONTINUE
            IF (DPARM(5).LT.0.01) DPARM(5) = 1.0
            M = ABS (DPARM(4)) + 0.01
            IF (M.LE.4) M = 8
            IF (M.GT.16) M = 16
            IF (DPARM(4).GT.-0.5) DPARM(4) = M
            IF (DPARM(4).LE.-0.5) DPARM(4) = -M
C                                       Not pixel masked
 100  IF (GOPR.EQ.2) GO TO 110
         IF (NYDPP.EQ.NXDPP+1) NYDPP = NXDPP
         IF (NXDPP.EQ.NYDPP+1) NXDPP = NYDPP
         DPARM(9) = M
         DPARM(10) = M
         IF (GOPR.EQ.3) GO TO 150
         GO TO 999
C                                       Pixel masked
 110  CONTINUE
         N(1) = NXDPP
         N(2) = NYDPP
         DO 140 I = 1,2
            DPARM(8+I) = M
            IF ((DPARM(4).LT.0) .AND. (N(I).LT.M)) GO TO 140
            LJ = M
C                                       Program chooses mask
            IF (DPARM(4).LT.0) GO TO 135
               IF (N(I).LT.7) GO TO 140
               IF (N(I).GT.13) GO TO 120
                  DPARM(8+I) = N(I)
                  GO TO 140
 120           LM = N(I)
               LJ = 1
               DO 130 J = 7,13
                  L = N(I) - (N(I)/J) * J
                  IF (L.GE.LM) GO TO 130
                     LM = L
                     LJ = J
 130              CONTINUE
 135        DPARM(8+I) = LJ
            N(I) = (N(I)/LJ) * LJ
 140        CONTINUE
         NXDPP = N(1)
         NYDPP = N(2)
C                                       Default shifts
 150  IF (ABS(DPARM(6)).GT.0.9) DPARM(6) = 0.25 * DPARM(9) / 8.0
      IF (ABS(DPARM(7)).GT.0.9) DPARM(7) = 0.133 * DPARM(10) / 8.0
      MD(1) = DPARM(9) + 0.01
      MD(2) = DPARM(10) + 0.01
      WRITE (MSGTXT,1150) NXDPP, NYDPP, MD
      CALL MSGWRT (2)
      IF (DPARM(3).LT.1.5) WRITE (MSGTXT,1151) DPARM(5), DPARM(6),
     *   DPARM(7)
      IF (DPARM(3).GE.1.5) WRITE (MSGTXT,1152) DPARM(5), DPARM(6),
     *   DPARM(7)
      CALL MSGWRT (2)
C
 999  RETURN
C-----------------------------------------------------------------------
 1150 FORMAT ('Using x,y dots/pix, dot/mask',4I5)
 1151 FORMAT ('      Scale, x-, y-shift  =',3F9.5,' Gaussian')
 1152 FORMAT ('      Scale, x-, y-shift  =',3F9.5,' sine')
      END
      SUBROUTINE CNTPLT (LUN, FIND, IOPOS, IRRN, IX0, SCALEX, CSIZEX,
     *   ICHL, NXA, MAXX, BUFFER, IERR)
C-----------------------------------------------------------------------
C   CNTPLT reads a few records from the plot file to see if some
C   character string or other command will cause the plot to overflow
C   in the X direction (on the right).  It will correct IX0 if possible.
C   Inputs:
C      LUN     I        LUN of open plot file
C      FIND    I        FTAB pointer for plot file
C      IOPOS   I        Position in BUFFER of next command
C      IRRN    I        Record number now in BUFFER.
C      SCALEX  R        X scaling factor
C      CSIZEX  I        Size of character in X
C      ICHL    I        Number chars to left of plot (dots)
C      NXA     I        Number dots in X plot expected
C      MAXX    I        Max X value allowed (1 is min)
C      BUFFER  I(256)   I/O buffer with plot file record IRRN
C   In/out:
C      IX0     I        X bias position
C   Output:
C      IERR    I        Error code from ZFIO
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IOPOS, IRRN, IX0, CSIZEX, MAXX, BUFFER(256),
     *   NXA, ICHL, IERR
      REAL      SCALEX
C
      REAL      DX
      INTEGER   XMAX, XMIN, X, LOPOS, I, IX, NCHAR, IANGL, LX, LRRN
C-----------------------------------------------------------------------
C                                       Init
      X = 0
      XMAX = IX0 + NXA - ICHL
      XMIN = IX0 - ICHL
      LOPOS = IOPOS
      LRRN = IRRN
      IERR = 0
C                                       Read record from disk
 50   IF (LOPOS.LE.256) GO TO 60
 55      LRRN = LRRN + 1
         IF (LRRN.GT.IRRN+4) GO TO 900
         CALL ZFIO ('READ', LUN, FIND, LRRN, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
         LOPOS = 1
C                                       Branch to type log record
 60   I = BUFFER(LOPOS)
      IF (I.EQ.0) GO TO 55
      IF ((I.LT.0) .OR. (I.GT.8)) GO TO 900
      GO TO (100, 200, 300, 400, 500, 600, 700, 800), I
C                                       Init
 100  LOPOS = LOPOS + 6
      GO TO 50
C                                       Init line drawing
 200  LOPOS = LOPOS + 20
      GO TO 50
C                                       Init grey scale
 300  LOPOS = LOPOS + 5
      GO TO 50
C                                       Vector position
 400  CONTINUE
C                                       Vector draw
 500  IX = BUFFER(LOPOS+1)
      LOPOS = LOPOS + 3
      X = IX * SCALEX + IX0 + 0.5
      XMIN = MIN (XMIN, X)
      XMAX = MAX (XMAX, X)
      GO TO 50
C                                       Characters
 600  NCHAR = BUFFER(LOPOS+1)
      IANGL = BUFFER(LOPOS+2)
      DX = BUFFER(LOPOS+3) / 100.0
      LX = X + DX * CSIZEX
      IF (IANGL.EQ.0) IX = LX + NCHAR * CSIZEX
      IF (IANGL.NE.0) IX = LX + CSIZEX
      IF (IANGL.EQ.2) LX = LX - (NCHAR-1) * CSIZEX
      XMIN = MIN (XMIN, IX, LX)
      XMAX = MAX (XMAX, LX, IX)
      LOPOS = LOPOS + 5 + ((NCHAR+3)/4)
      GO TO 50
C                                       Do grey scale (quit here)
 700  GO TO 900
C                                       Misc info
 800  LOPOS = LOPOS + 2 + BUFFER(LOPOS+1)
      GO TO 50
C                                       Recover record
 900  IF (LRRN.EQ.IRRN) GO TO 910
         LRRN = IRRN
         CALL ZFIO ('READ', LUN, FIND, LRRN, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Reset origin
 910  I = XMAX - MAXX
      IF (I.LE.0) GO TO 999
         X = XMIN - IX0
         IX0 = IX0 - I - (XMIN-I-1)/2
         IX0 = MAX (2, IX0)
         X = X + IX0
         IF (X.LT.2) IX0 = IX0 + 2 - X
C
 999  RETURN
      END
      SUBROUTINE CANVEC (IX, IY, IXCUR, IYCUR, IN, CANLUN, IERR)
C-----------------------------------------------------------------------
C   This routine moves the cursor position from (IXL,IYL) to (IX,IY).
C   If requested, a vector will be drawn between these points.
C   The input coordinates will be scaled or not according to the input
C   value of IN. The properly scaled cursor coordinates are returned
C   as IXCUR, IYCUR
C
C   INPUTS:   IX    I   X coordinate value.
C             IY    I   Y coordinate value.
C             IN    I   control value:
C                           1 = Scale IX and IY. (IX,IY) are the new
C                               cursor coordinates.
C                           2 = Scale IX and IY. (IX,IY) are the new
C                               cursor coordinates. Draw a vector
C                               between the previous coordinates, which
C                               have been stored as (IXL,IYL), and the
C                               new coordinates.
C                           3 = Do not scale IX and IY. (IX,IY) are
C                               the new cursor coordinates.
C                           4 = Do not scale IX and IY. (IX,IY) are
C                               the new cursor coordinates.Draw a vector
C                               between the previous coordinates, which
C                               have been stored as (IXL,IYL), and the
C                               new coordinates.
C   Output:   IXCUR   I   Scaled cursor x-coordinate
C             IYCUR   I   Scaled cursor y-coordinate
C             IERR    I   Error code: 0 => ok
C                                    10 => vector truncated
C                                    else I/O error
C   Common:   CANBUF
C             CANPOS
C             IXL
C             IYL
C-----------------------------------------------------------------------
      INTEGER   IX, IY, IN, IXCUR, IYCUR, IERR
C
      CHARACTER CANCOM*16
      INTEGER   CANLUN, IXN, IYN, X1, Y1, X2, Y2, QY1, QY2, INC
      LOGICAL   ISERR
      REAL      ALPHA, BETA
      CHARACTER*1 CHAR, X31, IS2
      INCLUDE 'CANPL.INC'
C-----------------------------------------------------------------------
C                                       Get character values of
C                                       hex codes used by the CANON
      X31 = CHAR(49)
      IS2 = CHAR(30)
C
      ISERR = .FALSE.
C                                       Set last X and Y.
      IXN = IX
      IYN = IY
C                                       If IN = 1 or 2 do scaling.
      IF (IN.GT.2) GO TO 10
         IXN = IX*SCALEX + IX0 + .5
         IYN = IY*SCALEY + IY0 + .5
C                                       Draw vector
 10   INC = 1
C                                       If IN = 1 or 3, do not draw
C                                       vector
      IF ((IN.NE.1) .AND. (IN.NE.3)) INC = 2
C                                       Check start point
         X1 = MAX (1, MIN (MAXCAN(1), IXL))
         Y1 = MAX (1, MIN (MAXCAN(2), IYL))
         IF ((X1.EQ.IXL) .AND. (Y1.EQ.IYL)) GO TO 30
            ALPHA = 1.0
            IF (IXN.NE.IXL) ALPHA = REAL (X1-IXN) / REAL (IXL-IXN)
            BETA = 1.0
            IF (IYN.NE.IYL) BETA = REAL (Y1-IYN) / REAL (IYL-IYN)
            ALPHA = MIN (ALPHA, BETA)
            X1 = IXN + ALPHA * (IXL-IXN) + 0.5
            Y1 = IYN + ALPHA * (IYL-IYN) + 0.5
C                                       Check end point
 30      X2 = MAX (1, MIN (MAXCAN(1), IXN))
         Y2 = MAX (1, MIN (MAXCAN(2), IYN))
         IF ((X2.EQ.IXN) .AND. (Y2.EQ.IYN)) GO TO 40
            IF ((IXN.LT.1) .AND. (IXL.LT.1)) GO TO 90
            IF ((IYN.LT.1) .AND. (IYL.LT.1)) GO TO 90
            IF ((IXN.GT.MAXCAN(1)) .AND. (IXL.GT.MAXCAN(1))) GO TO 90
            IF ((IYN.GT.MAXCAN(2)) .AND. (IYL.GT.MAXCAN(2))) GO TO 90
            ISERR = .TRUE.
            ALPHA = 1.0
            IF (IXN.NE.IXL) ALPHA = REAL(X2-IXL)/REAL(IXN-IXL)
            BETA = 1.0
            IF (IYN.NE.IYL) BETA = REAL(Y2-IYL)/REAL(IYN-IYL)
            ALPHA = MIN (ALPHA, BETA)
            X2 = IXL + ALPHA * (IXN-IXL) + 0.5
            Y2 = IYL + ALPHA * (IYN-IYL) + 0.5
 40      CONTINUE
C                               If requested, draw vector from
C                               (X1, QY1) to (X2,QY2)
         QY1 = MAXCAN(2) - Y1
         QY2 = MAXCAN(2) - Y2
C                               Send polyline to CANON
C                               (<3/1> X1 QY1 (X2-X1) (QY2-QY1) IS2)
C                               The 4 integer coordinates are encoded
C                               in an extremely odd CANON-specific
C                               manner in a variable number of ASCII
C                               characters. The routine CANINT does
C                               the encoding and sends the result to
C                               the output buffer
         IF (INC.EQ.2) THEN
            WRITE (CANCOM,1010) X31
            CALL FILZCH (1, 1, CANCOM)
            CALL CANIO (CANLUN, 1, CANCOM, IERR)
            CALL CANINT (CANLUN,CANCOM,X1,IERR)
            CALL CANINT (CANLUN,CANCOM,QY1,IERR)
            CALL CANINT (CANLUN,CANCOM,X2-X1,IERR)
            CALL CANINT (CANLUN,CANCOM,QY2-QY1,IERR)
            WRITE (CANCOM,1010) IS2
            CALL FILZCH (1, 1, CANCOM)
            CALL CANIO (CANLUN, 1, CANCOM, IERR)
            END IF
C                                         Save new position
 90   IXL = IXN
      IYL = IYN
      IXCUR = X2
      IYCUR = QY2
      IF ((IERR.EQ.0) .AND. (ISERR)) IERR = 10
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (A1)
      END

LOCAL INCLUDE 'PZEMAN.INC'
      INTEGER   MAXGAU, MAXPRM, MAXLIS, NPLIM, NMXIMG
      PARAMETER (MAXGAU=32)
      PARAMETER (MAXPRM=1+MAXGAU)
      PARAMETER (MAXLIS=1000)
      PARAMETER (NPLIM=4096)
      PARAMETER (NMXIMG=2)
LOCAL END
      SUBROUTINE TABZE (OPCODE, BUFFER, IZERNO, ZEKOLS, ZENUMV, YZPIX,
     *   IPEAK, RMS, RESULT, NGA, XGAUSV, XGAUSB, IRET)
C-----------------------------------------------------------------------
C! Fits Zeeman models to spectra: IO to ZE table of ZEMAN
C# Map Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 2013-2015, 2017, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to ZEMAN Gaussian fit (ZE) extension tables.
C   Usually used after setup by ZEINI.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'READ' = read entry from table.
C                        'WRIT' = write entry in table.
C                        'CLOS' = close file, flush on write
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open. Should have been returned by
C                        ZEINI or TABINI.
C      IZERNO   I        Next entry number to read or write.
C      ZEKOLS   I(MAXZEC) The column pointer array in order,
C                        pixel(2), peak I value, V rms, gain, err gain,
C                        B field(*), Err B field(*), # Gauss, amp(*),
C                        center(*), width(*), baseline(2),
C      ZENUMV   I(MAXZEC) Element count in each column.
C   Input/output: (written to or read from ZE file)
C      YZPIX    I(2)     Y , Z pixel number
C      IPEAK    R        Peak flux in the spectrum I polarization
C      RMS      R        Residual V rms
C      RESULT   R(*)     Gain, field, and errors
C      NGA      I        actual number Gaussians fit
C      XGAUSV   R(*)     Gauss 1 peak, center, width, Gauss 2, Gauss 3,
C                        Gauss 4
C   Output:
C      IZERNO   I        Next solution number.
C      IRET     I        Error code, 0=>OK else TABIO error.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PZEMAN.INC'
      INTEGER   MAXZEC, XZERSZ
      PARAMETER (MAXZEC = 12)
      PARAMETER (XZERSZ = 9+5*MAXGAU)
C
      CHARACTER OPCODE*4
      INTEGER   BUFFER(*), IZERNO, ZEKOLS(MAXZEC), ZENUMV(MAXZEC),
     *   YZPIX(2), NGA, IRET
      REAL      IPEAK, RMS, RESULT(MAXPRM*2), XGAUSV(3*MAXGAU),
     *   XGAUSB(2)
C
      INTEGER   RECI(XZERSZ), KOLS(MAXZEC), PIXKOL, PEKKOL, RMSKOL,
     *   GAIKOL, EGAKOL, FLDKOL, EFLKOL, NGAKOL, AMPKOL, CENKOL, WIDKOL,
     *   BLKOL, NDATA, INDX, LNDX, LOOP
      REAL      RECR(XZERSZ)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (KOLS(1), PIXKOL), (KOLS(2), PEKKOL),
     *   (KOLS(3), RMSKOL), (KOLS(4), GAIKOL), (KOLS(5), EGAKOL),
     *   (KOLS(6), FLDKOL), (KOLS(7), EFLKOL), (KOLS(8), NGAKOL),
     *   (KOLS(9), AMPKOL), (KOLS(10), CENKOL), (KOLS(11), WIDKOL),
     *   (KOLS(12), BLKOL)
      EQUIVALENCE (RECR, RECI)
C-----------------------------------------------------------------------
C                                       Close
      IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, IZERNO, RECR, BUFFER, IRET)
         IF (IRET.GT.0) GO TO 980
         GO TO 999
         END IF
C                                       Set pointers
      NDATA = MAXZEC
      CALL COPY (NDATA, ZEKOLS, KOLS)
C                                       If write fill RECR
      IF (OPCODE.NE.'READ') THEN
         RECI(PIXKOL) = YZPIX(1)
         RECI(PIXKOL+1) = YZPIX(2)
         RECR(PEKKOL) = IPEAK
         IF (ZENUMV(3).GT.0) RECR(RMSKOL) = RMS
C                                       split out results
         INDX = 1
         LNDX = INDX + ZENUMV(6) + 1
         RECR(GAIKOL) = RESULT(INDX)
         RECR(EGAKOL) = RESULT(LNDX)
         DO 10 LOOP = 0,ZENUMV(6)-1
            INDX = INDX + 1
            LNDX = LNDX + 1
            RECR(FLDKOL+LOOP) = RESULT(INDX)
            RECR(EFLKOL+LOOP) = RESULT(LNDX)
 10         CONTINUE
         RECI(NGAKOL) = NGA
         INDX = 1
         DO 20 LOOP = 0,ZENUMV(9)-1
            RECR(AMPKOL+LOOP) = XGAUSV(INDX)
            RECR(CENKOL+LOOP) = XGAUSV(INDX+1)
            RECR(WIDKOL+LOOP) = XGAUSV(INDX+2)
            INDX = INDX + 3
 20         CONTINUE
         IF (ZENUMV(12).GT.0) THEN
            RECR(BLKOL) = XGAUSB(1)
            RECR(BLKOL+1) = XGAUSB(2)
            END IF
         END IF
C                                       Process record.
 60   CALL TABIO (OPCODE, 0, IZERNO, RECR, BUFFER, IRET)
      IZERNO = IZERNO + 1
      IF (IRET.GT.0) GO TO 980
      IF (IRET.LT.0) GO TO 60
C                                       If READ pick data from RECR.
      IF (OPCODE.EQ.'READ') THEN
         CALL COPY (2, RECI(PIXKOL), YZPIX)
         IPEAK = RECR(PEKKOL)
         RMS = 0.0
         IF (ZENUMV(3).GT.0) RMS = RECR(RMSKOL)
         INDX = 1
         LNDX = INDX + ZENUMV(9) + 1
         RESULT(INDX) = RECR(GAIKOL)
         RESULT(LNDX) = RECR(EGAKOL)
         DO 70 LOOP = 0,ZENUMV(6)-1
            INDX = INDX + 1
            LNDX = LNDX + 1
            RESULT(INDX) = RECR(FLDKOL+LOOP)
            RESULT(LNDX) = RECR(EFLKOL+LOOP)
 70         CONTINUE

         NGA = RECI(NGAKOL)
         INDX = 1
         DO 80 LOOP = 0,ZENUMV(9)-1
            XGAUSV(INDX)   = RECR(AMPKOL+LOOP)
            XGAUSV(INDX+1) = RECR(CENKOL+LOOP)
            XGAUSV(INDX+2) = RECR(WIDKOL+LOOP)
            INDX = INDX + 3
 80         CONTINUE
         IF (ZENUMV(12).GT.0) THEN
            XGAUSB(1) = RECR(BLKOL)
            XGAUSB(2) = RECR(BLKOL+1)
         ELSE
            XGAUSB(1) = 0.0
            XGAUSB(2) = 0.0
            END IF
         END IF
      GO TO 999
C                                       Error
 980  WRITE (MSGTXT,1980) IRET
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('TABZE: TABIO ERROR',I3)
      END

      FUNCTION IKEY (LKEY, LPARS, NPARS)
C-----------------------------------------------------------------------
C! Routine to search array LPARS for keyword LKEY
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to search array LPARS for string LKEY
C   Inputs:
C      LKEY    C*8     String to search for
C      LPARS   C*8(*)  Array to be searched
C      NPARS   I       Length of LPARS
C   Outputs:
C      IKEY    I       Index in LPARS; 0 if not found.
C-----------------------------------------------------------------------
      INTEGER IKEY, NPARS
      CHARACTER*8 LKEY, LPARS(NPARS)
C
      INCLUDE 'INCS:DMSG.INC'
      INTEGER I
C-----------------------------------------------------------------------
      I = 1
C                                       While (I < N) and (Not Found) do
20    IF ((I.GT.NPARS).OR.(LKEY.EQ.LPARS(I))) GO TO 50
         I = I + 1
         GO TO 20
C
50    IF (I.GT.NPARS) THEN
         WRITE (MSGTXT,1000) LKEY
         CALL MSGWRT (8)
         I = 1
         END IF
C                                       Exit
      IKEY = I
      RETURN
C----------------------------------------------------------------------
1000  FORMAT ('FATAL ERROR: CONTACT AIPS ADMIN; LKEY=',A8)
      END

      SUBROUTINE SUBHDR (BLC, TRC, XINC, YINC)
C-----------------------------------------------------------------------
C! changes input to output header correcting for subimaging
C# Map-util Header
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   SUBHDR corrects the header for subimaging: changes number of points
C   on the axes, the reference pixels, and the alternate axis (freq vs
C   velocity) reference pixel.  It corrects the first two axes for use
C   of pixel increments - namely the reference pixel and the axis incr.
C   Inputs:
C      BLC    R(7)        Bottom left corner to use
C      TRC    R(7)        Top right corner to use
C      XINC   R           Pixel increment on first axis
C      YINC   R           Pixel increment on second axis
C   Common:
C      /MAPHDR/ CATBLK     map header (in/out)
C-----------------------------------------------------------------------
      REAL      BLC(7), TRC(7), XINC, YINC
C
      CHARACTER FCHARS(3)*4, CHTEMP*4
      HOLLERITH CATH(256)
      REAL      CATR(256), AINC(7)
      INTEGER   IPL, IPH, CATBLK(256), NAX, I, J
      DOUBLE PRECISION    CATD(128)
      INCLUDE 'INCS:DHDR.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK, CATH, CATR, CATD)
      DATA FCHARS /'FREQ','VELO','FELO'/
C-----------------------------------------------------------------------
C                                       Regular axis parameters
      NAX = CATBLK(KIDIM)
      CALL RFILL (7, 1.0, AINC)
      IF (XINC.GT.0.001) AINC(1) = XINC
      IF (YINC.GT.0.001) AINC(2) = YINC
      DO 10 I = 1,NAX
         IPL = BLC(I) + 0.01
         IPH = TRC(I) + 0.01
         CATBLK(KINAX+I-1) = (IPH - IPL) / AINC(I) + 1
         CATR(KRCRP+I-1) = (CATR(KRCRP+I-1) - IPL) / AINC(I) + 1.
         CATR(KRCIC+I-1) = CATR(KRCIC+I-1) * AINC(I)
 10      CONTINUE
C                                       Alternate axis
      IF (CATBLK(KIALT).EQ.0) GO TO 999
         DO 25 I = 1,NAX
            IPL = KHCTP + (I-1) * 2
            CALL H2CHR (4, 1, CATH(IPL), CHTEMP)
            DO 20 J = 1,3
               IF (FCHARS(J).EQ.CHTEMP) GO TO 30
 20            CONTINUE
 25         CONTINUE
         GO TO 999
C                                       Found one
 30      CONTINUE
            IPL = BLC(I) + 0.01
            CATR(KRARP) = (CATR(KRARP) - IPL) / AINC(I) + 1.0
C
 999  RETURN
      END

      SUBROUTINE YCNECT (X1, Y1, X2, Y2, IC, BUFFER, IERR)
C-----------------------------------------------------------------------
C! write line segment between 2 points on TV
C# Y0 TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YCNECT writes a line segment on the TV.  This version will work on
C   all TVs.  It is called a Y routine to allow the use of hardware
C   vector generators on those TVs equiped with them.
C   Inputs:
C      X1      I      start X position
C      Y1      I      start Y position
C      X2      I      end X position
C      Y2      I      end Y position
C      IC      I      Channel (1 to NGRAY+NGRAPH)
C      BUFFER  I(*)   Buffer contains desired intensity (size > max
C                     horizontal or vertical line, e.g., 1280)
C   Output:
C      IERR    I      error code : 0 => ok
C-----------------------------------------------------------------------
      INTEGER    X1, Y1, X2, Y2, IC, BUFFER(*), IERR
C
      REAL       POS, POSINC
      LOGICAL    T, F
      INTEGER    SS, ES, SL, EL, DELTAX, DELTAY, STEP, IANGL, LINE,
     *   LENGTH, SAMPLE, IX, IY, IROUND
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IERR = 2
      IF ((TVXMOD.LE.0) .AND. (TVYMOD.LE.0)) GO TO 999
C                                       test
      IF ((X1.LT.1) .OR. (X1.GT.MAXXTV(1))) GO TO 900
      IF ((Y1.LT.1) .OR. (Y1.GT.MAXXTV(2))) GO TO 900
      IF ((X2.LT.1) .OR. (X2.GT.MAXXTV(1))) GO TO 900
      IF ((Y2.LT.1) .OR. (Y2.GT.MAXXTV(2))) GO TO 900
      IF ((IC.LT.1) .OR. (IC.GT.NGRAY+NGRAPH)) GO TO 900
C                                       doit
      SS = X1
      ES = X2
      SL = Y1
      EL = Y2
      STEP = 1
      DELTAX = ABS(ES-SS) + 1
      DELTAY = ABS(EL-SL) + 1
C                                        Horizontal lines
      IF (TVXMOD.LE.0) GO TO 50
      IF ((DELTAY.GT.DELTAX) .AND. (TVYMOD.GT.0)) GO TO 50
C                                        check order
         IF (SS.LE.ES) GO TO 10
            SS = X2
            ES = X1
            SL = Y2
            EL = Y1
 10      IF (SL.GT.EL) STEP = -1
         POSINC = REAL(DELTAX) / REAL(DELTAY)
         IF (SS.EQ.ES) POSINC = 0.0
         POS = REAL(SS)
         IANGL = 0
         IF (TVXMOD.EQ.2) IANGL = 2
C                                        manual DO loop
         LINE = SL
 20      CONTINUE
            IX = IROUND (POS)
            POS = POS + POSINC
            LENGTH = IROUND (POS) - IX
            LENGTH = MAX (1, LENGTH)
            IF (TVXMOD.EQ.2) IX = IX + LENGTH - 1
            CALL YIMGIO ('WRIT', IC, IX, LINE, IANGL, LENGTH, BUFFER,
     *         IERR)
            IF (IERR.NE.0) GO TO 999
            LINE = LINE + STEP
            IF (((STEP.LT.0) .AND. (LINE.GE.EL)) .OR. ((STEP.GT.0) .AND.
     *         (LINE.LE.EL))) GO TO 20
         GO TO 999
C                                        Vertical lines
 50   CONTINUE
         IF (SL.LE.EL) GO TO 60
            SS = X2
            ES = X1
            SL = Y2
            EL = Y1
 60      IF (SS.GT.ES) STEP = -1
         POSINC = REAL(DELTAY) / REAL(DELTAX)
         IF (SL.EQ.EL) POSINC = 0.0
         POS = REAL(SL)
         IANGL = 1
         IF (TVYMOD.EQ.2) IANGL = 3
C                                        manual DO loop
         SAMPLE = SS
 70      CONTINUE
            IY = IROUND (POS)
            POS = POS + POSINC
            LENGTH = IROUND (POS) - IY
            LENGTH = MAX (1, LENGTH)
            IF (TVYMOD.EQ.2) IY = IY + LENGTH - 1
            CALL YIMGIO ('WRIT', IC, SAMPLE, IY, IANGL, LENGTH, BUFFER,
     *         IERR)
            IF (IERR.NE.0) GO TO 999
            SAMPLE = SAMPLE + STEP
            IF (((SAMPLE.GE.ES) .AND. (STEP.LT.0)) .OR. ((SAMPLE.LE.ES)
     *         .AND. (STEP.GT.0))) GO TO 70
         GO TO 999
C                                       error
 900  WRITE (MSGTXT,1900) IC, X1, X2, Y1, Y2
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('YCNECT: BAD CHAN, X1,X2,Y1,Y2:',5I7)
      END

      SUBROUTINE SUSEL (DISKI, CNOI, DISKO, CNOO, VER, CATIN, CATOUT,
     *   LUNI, LUNO, BIF, EIF, IFQID, BUFFER, OBUFF, IRET)
C-----------------------------------------------------------------------
C! Copies a subset of IFs in an SU table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1999, 2007, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Copies a subset of IFs in an SU table.
C   Inputs:
C      DISKI           I       Input volume number
C      CNOI            I       Input catalog number
C      DISKO           I       Output volume number
C      CNOO            I       Output catalog number
C      VER             I       Version to check/modify
C      CATIN(256)      I       Input catalog header
C      CATOUT(256)     I       Output catalog header
C      LUNI            I       LUN to use
C      LUNO            I       LUN to use
C      BIF             I       Start IF number
C      EIF             I       End IF number
C      IFQID           I       FQ ID to select
C   Input/Output:
C      BUFFER          I(*)    Work buffer
C      OBUFF           I(*)    Work buffer
C   Output:
C      IRET            I       Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER   DISKI, CNOI, DISKO, CNOO, VER, CATIN(256),
     *   CATOUT(256), LUNI, LUNO, BIF, EIF, IFQID, BUFFER(*),
     *   OBUFF(*), IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4
      INTEGER   ISURNO, SUKOLS(MAXSUC), SUNUMV(MAXSUC), NUMIF,
     *   OKOLS(MAXSUC), ONUMV(MAXSUC), NSUROW, I, IIF, JIF, OSURNO,
     *   NEWNIF, IDSOU, QUAL, SUFQID, OVER
      LOGICAL   REFMT
      REAL      FLUX(4,MAXIF)
      DOUBLE PRECISION    FREQO(MAXIF), BANDW, RAEPO, DECEPO, EPOCH,
     *   RAAPP, DECAPP, LSRVEL(MAXIF), LRESTF(MAXIF), PMRA, PMDEC,
     *   RAOBS, DECOBS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       Open SU file
      CALL SOUINI ('READ', BUFFER, DISKI, CNOI, VER, CATIN, LUNI,
     *  NUMIF, VELTYP, VELDEF, SUFQID, ISURNO, SUKOLS, SUNUMV, IRET)
      IF (IRET.EQ.2) THEN
         IRET = 0
         GO TO 999
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       New no. of IFs
      NEWNIF = MAX (MIN (NUMIF, EIF) - BIF + 1, 0)
      REFMT = NEWNIF.NE.NUMIF
C                                       # rows in old table
      NSUROW = BUFFER(5)
C                                       Open up new SU table
      OVER = VER
      IF (SUFQID.EQ.-999) SUFQID = -1
C                                       Check selected FQ ID
      IF ((SUFQID.EQ.IFQID).AND.(IFQID.GT.0)) SUFQID = 1
      IF ((SUFQID.NE.IFQID).AND.(IFQID.GT.0)) SUFQID = -1
C
      CALL SOUINI ('WRIT', OBUFF, DISKO, CNOO, OVER, CATOUT, LUNO,
     *  NEWNIF, VELTYP, VELDEF, SUFQID, OSURNO, OKOLS, ONUMV, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 100 I = 1, NSUROW
         CALL TABSOU ('READ', BUFFER, ISURNO, SUKOLS, SUNUMV,
     *      IDSOU, SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO,
     *      DECEPO, EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF,
     *      PMRA, PMDEC, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1020) IRET
            GO TO 990
            END IF
         REFMT = REFMT .OR. (IRET.LT.0)
C                                       De-selected record
         IF ((IRET.EQ.0) .AND. (NEWNIF.GT.0)) THEN
C                                       Select IFs
            DO 90 JIF = 1, NEWNIF
               IIF = JIF + BIF - 1
               FREQO(JIF) = FREQO(IIF)
               LSRVEL(JIF) = LSRVEL(IIF)
               LRESTF(JIF) = LRESTF(IIF)
               FLUX(1,JIF) = FLUX(1,IIF)
               FLUX(2,JIF) = FLUX(2,IIF)
               FLUX(3,JIF) = FLUX(3,IIF)
               FLUX(4,JIF) = FLUX(4,IIF)
 90            CONTINUE
C                                       Write new one
            CALL TABSOU ('WRIT', OBUFF, OSURNO, OKOLS, ONUMV, IDSOU,
     *         SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *         EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF,
     *         PMRA, PMDEC, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1020) IRET
               GO TO 990
               END IF
            END IF
 100     CONTINUE
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ISURNO, BUFFER, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OSURNO, OBUFF, OBUFF, IRET)
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         IF (REFMT) THEN
            WRITE (MSGTXT,1100) 'Reformatted SU', DISKI, CNOI, VER,
     *         DISKO, CNOO, OVER
         ELSE
            WRITE (MSGTXT,1100) 'Copied SU', DISKI, CNOI, VER, DISKO,
     *         CNOO, OVER
            END IF
         CALL MSGWRT (3)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SUSEL: ERROR ',I3,' RETURNED FROM SOUINI')
 1020 FORMAT ('SUSEL: ERROR ',I3,' RETURNED FROM TABSOU')
 1100 FORMAT (A,' file from vol/cno/vers',I3,I5,I4,' to',I3,I5,I4)
      END

      SUBROUTINE DELEXT (TYPE, IVOL, SLOT, STAT, BUFF1, BUFF2, IVER,
     *   IERR)
C-----------------------------------------------------------------------
C! removes an extension file from the header in the catalog file
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DELEXT will delete an extension file from the catalog header.  This
C   consists of decreasing the version number by 1 if the requested
C   version is now the highest one in the header.  The header block is
C   read from the catalog, revised, and replaced.  The initial
C   catalog status is cleared or preserved.
C   Inputs:
C      TYPE    C*2      extension file type, example PL, HI.
C      IVOL    I        disk volume number 1-9.
C      SLOT    I        the catalog slot number of the primary file
C                       with which the extension file is associated.
C                       This value can be found using CATDIR.
C      STAT    C*4      Current file status: READ or WRIT to be cleared
C                       RDRD or WRWR => current status to remain
C      BUFF1   I(256)   work buffer for I/0.
C      BUFF2   I(256)   second work buffer for I/O.
C      IVER    I        version to delete ( 0 => highest);
C   Output:
C      IERR    I        error code. 0 = OK
C                                   1 = CATIO read error.
C                                   2 = CATIO write error.
C                                   3 = No extension file of type TYPE
C                                   4 = error in STAT
C                                   5 = IVER > highest in header
C                                   6 = READ status not left properly
C-----------------------------------------------------------------------
      CHARACTER TYPE*2, STAT*4
      INTEGER   IVOL, IERR, IVER, SLOT, BUFF1(256), BUFF2(256)
C
      INTEGER   IER, I, I20, VER, NEXTF
      CHARACTER CHTEMP*2
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       check STAT
      IERR = 4
      IF ((STAT.NE.'READ') .AND. (STAT.NE.'WRIT') .AND. (STAT.NE.'RDRD')
     *   .AND. (STAT.NE.'WRWR')) GO TO 999
C                                       read catalog block
      IERR = 1
      VER = 0
C                                       on 'READ', remove read status
      IF ((STAT.NE.'READ') .AND. (STAT.NE.'RDRD')) GO TO 10
         CALL CATDIR ('CSTA', IVOL, SLOT, ' ', ' ', 0, ' ', 0,
     *      'CLRD', BUFF2, IER)
         CALL CATIO ('READ', IVOL, SLOT, BUFF1, 'WRIT', BUFF2, IER)
         IF (IER.EQ.0) GO TO 15
            WRITE (MSGTXT,1000) IER
            IF (IER.EQ.5) WRITE (MSGTXT,1001)
            GO TO 980
C                                       on WRIT: just read it now
 10   CONTINUE
         CALL CATIO ('READ', IVOL, SLOT, BUFF1, 'REST', BUFF2, IER)
         IF ((IER.EQ.0) .OR. (IER.EQ.6)) GO TO 15
            WRITE (MSGTXT,1000) IER
            GO TO 980
C                                       Find extension TYPE, update ver
 15   IERR = 0
      CALL FXHDEX (BUFF1)
      NEXTF = KHEXT + KIEXTN - 1
      DO 20 I = KHEXT,NEXTF
         I20 = KIVER + I - KHEXT
         IF (BUFF1(I20).EQ.0) GO TO 20
            CALL H2CHR (2, 1, BUFF1(I), CHTEMP)
            IF (CHTEMP.NE.TYPE) GO TO 20
               VER = BUFF1(I20)
               GO TO 30
 20      CONTINUE
C                                       File of this type not found.
      IERR = 3
      WRITE (MSGTXT,1020) TYPE
      GO TO 980
C                                       Bad version number
 30   IF (IVER.LE.VER) GO TO 40
         IERR = 5
         WRITE (MSGTXT,1030) IVER
         GO TO 980
C                                       Decrement version #
 40   IF ((IVER.LE.0) .OR. (IVER.EQ.VER)) BUFF1(I20) = BUFF1(I20) - 1
C                                       Write or update header.
      IF (STAT.NE.'WRWR') THEN
         CALL CATIO ('UPDT', IVOL, SLOT, BUFF1, 'CLWR', BUFF2, IER)
      ELSE
         CALL CATIO ('UPDT', IVOL, SLOT, BUFF1, 'REST', BUFF2, IER)
         END IF
      IF ((IER.EQ.0) .OR. (IER.EQ.10)) GO TO 50
         IERR = 2
         WRITE (MSGTXT,1040) IER
         GO TO 980
C                                       restore 'READ' status
 50   IF (STAT.NE.'RDRD') GO TO 999
         CALL CATDIR ('CSTA', IVOL, SLOT, ' ', ' ', 0, ' ', 0, 'READ',
     *      BUFF2, IER)
         IF ((IER.EQ.0) .OR. (IER.EQ.9)) GO TO 999
            IERR = 6
            WRITE (MSGTXT,1050) IER
            CALL MSGWRT (8)
            GO TO 999
C                                       error print, clear catalog
 980  CALL MSGWRT (8)
      CALL CATDIR ('CSTA', IVOL, SLOT, ' ', ' ', 0, ' ', 0, 'CLWR',
     *   BUFF2, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DELEXT: CATIO READ ERROR OR TOO BUSY',I5)
 1001 FORMAT ('DELEXT CAN''T REMOVE EXTENSION FROM HEADER, FILE TOO',
     *   ' BUSY')
 1020 FORMAT ('DELEXT: NO EXTENSION FILE OF TYPE ',A2)
 1030 FORMAT ('DELEXT: EXTENSION VERSION',I5,' NOT IN HEADER')
 1040 FORMAT ('DELEXT: CATIO WRITE ERROR',I5)
 1050 FORMAT ('DELEXT: UNABLE TO RESTORE READ STATUS, ERROR',I5)
      END

      SUBROUTINE STRTKN (STRING, TOKENS, NTOK)
C-----------------------------------------------------------------------
C! split a string into tokens
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1996
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Split string into tokens.  A token is a string of consecutive
C   non-blank characters that is separated from neighbouring tokens by
C   one or more blank characters.
C
C   This routine may be used to extract fields from a line read from a
C   text file that does not used fixed widths for its fields.
C
C   It is the caller's responsibility to dimension TOKENS so as to
C   be large enough to hold the largest expected output.  This is not
C   checked.
C
C   Inputs:
C      STRING    C*(*)      String to be split
C
C   Output:
C      TOKENS    C(*)*(*)   Tokenized version of STRING
C      NTOK      I          The number of tokens in the string
C-----------------------------------------------------------------------
      CHARACTER STRING*(*), TOKENS(*)*(*)
      INTEGER   NTOK
C
      INTEGER   I, J
C------------------------------------------------------------------------
      NTOK = 0
      I = 1
      J = 1
   10 IF (I .LE. LEN (STRING)) THEN
C
C        Find next token:
C
   20    IF (I .LE. LEN (STRING)) THEN
            IF (STRING(I:I) .EQ. ' ') THEN
               I = I + 1
               GO TO 20
            END IF
         END IF
         IF (I .LE. LEN (STRING)) THEN
C
C           Find the end of the token:
C
            J = I + 1
   30       IF (J .LE. LEN (STRING)) THEN
               IF (STRING(J:J) .NE. ' ') THEN
                  J = J + 1
                  GO TO 30
               END IF
            END IF
C
            NTOK = NTOK + 1
            TOKENS(NTOK) = STRING(I: J - 1)
            I = J + 1
         END IF
         GO TO 10
      END IF
      END

      SUBROUTINE AVERT (TB, TE, IBLCOD, NBL, BUFFER, TAU, TAUMIN,
     *   TAUMAX, IRET)
C-----------------------------------------------------------------------
C! Search a uv-file to determine integration times on each baseline
C# UV IO-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2001, 2011, 2013, 2015, 2026
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Search a uv-file to determine integration times on each baseline
C   Uses UVGET which must have all essential parameters set in DSEL.INC
C   This uses FG, NX etc to access desired data quickly.
C   Uses UVGET so adverbs must be set - will temporarily use SUBARR=1
C   if needed.
C   Inputs:
C      TB       R      The beginning of selected time interval (days)
C      TE       R      The end of selected time interval (days)
C      IBLCOD   I(*)   Desired baselines (32768 * ant_1 + ant_2)
C                      if < 1000, will take any baselines
C      NBL      I      Element count in IBLCOD - must be > 0
C   Input/output:
C      BUFFER   R(*)   I/O buffer for uv-file access
C   Output:
C      TAU      R(*)   Array of pre-average times (sec). Same
C                         order as IBLCOD.
C      TAUMIN   R      Minimum integration time found (sec).
C      TAUMAX   R      Maximum integration time found (sec).
C      IRET     I      Error code: -1 => no int time parameter
C                         0 okay, > 0 I/O error
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      REAL      TB, TE, BUFFER(*), TAU(*), TAUMIN, TAUMAX
      INTEGER   IBLCOD(*), NBL, IRET
C
      LOGICAL   WFOUND
      REAL      TIMCUR, TINT, RPARM(20)
      INTEGER   JBL, I, IBL, IERR, LSUB, NCOUNT, IANT1, IANT2
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
C----------------------------------------------------------------------
C                                        Initialization
      CALL RFILL (MXBASE, 0.0, TAU)
      TAUMIN = 1.0E20
      TAUMAX = 0.0
C                                        Exit if no integration time
C                                        random parameter.
      IRET = -1
      IF (ILOCIT.LT.0) GO TO 999
      NCOUNT = 0
C
C                                       Init vis file for read
      LSUB = SUBARR
      IF (SUBARR.EQ.0) SUBARR = 1
      CALL UVGET ('INIT', RPARM, BUFFER, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INIT DATA FOR READ'
         GO TO 990
      ELSE IF (IRET.LT.0) THEN
         MSGTXT = 'NO DATA FOUND: CHECK ADVERB VALUES'
         IRET = 10
         GO TO 990
         END IF
C
      WFOUND = .FALSE.
C                                       Loop, reading uv_records
 100  CALL UVGET ('READ', RPARM, BUFFER, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING UV DATA'
         GO TO 990
      ELSE IF ((IRET.LT.0) .AND. (NCOUNT.LE.0)) THEN
         MSGTXT = 'NO DATA FOUND: CHECK ADVERB VALUES'
         IRET = 10
         GO TO 990
      ELSE IF (IRET.EQ.0) THEN
         NCOUNT = NCOUNT + 1
C                                       Extract time, baseline,
C                                       integration time and subarray
         TIMCUR = RPARM(1+ILOCT)
         IF (ILOCB.GE.0) THEN
            JBL = RPARM(1+ILOCB) + 0.1
            IANT1 = JBL / 256
            IANT2 = JBL - 256*IANT1
         ELSE
            IANT1 = RPARM(1+ILOCA1) + 0.1
            IANT2 = RPARM(1+ILOCA2) + 0.1
            END IF
         JBL = 32768 * IANT1 + IANT2
         TINT = RPARM(1+ILOCIT)
C                                       Check time range (assume
C                                       TB sort order) and subarray
         IF ((TIMCUR.GE.TB) .AND. (TIMCUR.LE.TE)) THEN
C                                       Match baseline code.
            IBL = 0
            DO 120 I = 1,NBL
               IF (JBL.EQ.IBLCOD(I)) IBL = I
               IF ((IBLCOD(I).LT.1000) .AND. (TAU(I).EQ.0.0)) THEN
                  IF ((IBLCOD(I).EQ.IANT1) .OR. (IBLCOD(I).EQ.IANT2))
     *               IBL = I
                  END IF
120            CONTINUE
C                                       Update pre-average times
            IF (IBL.NE.0) THEN
C                                       Assume constant in time.
               IF (TAU(IBL).EQ.0.0) THEN
                  TAU(IBL) = TINT
                  TAUMIN = MIN (TAUMIN, TINT)
                  TAUMAX = MAX (TAUMAX, TINT)
C                                       All baselines found ?
                  WFOUND = .TRUE.
                  DO 140 I = 1,NBL
                     IF (TAU(I).EQ.0.0) WFOUND = .FALSE.
140                  CONTINUE
                  END IF
               END IF
            END IF
C                                       Read next record
         IF ((TIMCUR.LT.TE) .AND. (.NOT.WFOUND)) GO TO 100
         END IF
      GO TO 995
C                                        Error
 990  CALL MSGWRT (8)
C                                       Close uv file.
 995  CALL UVGET ('CLOS', RPARM, BUFFER, IERR)
      SUBARR = LSUB
      IRET = MAX (0, IRET)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AVERT: ERROR',I4,' ON ',A)
      END

      SUBROUTINE VISDFT (APCORE, OPCODE, CHANEL, NCHAN, DISKI, CNOSCI,
     *   DISKO, CNOSCO, IFIELD, DOSUM, DOMSG, CATR, JBUFSZ, BUFF1,
     *   BUFF2, IBUFF, IRET)
C-----------------------------------------------------------------------
C! Compute DFT of model and subtract/divide from/into uv data.
C# AP-appl UV Map Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999-2001, 2003, 2006-2009, 2011-2015,
C;  Copyright (C) 2018-2020, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   VISDFT subtracts/divides CLEAN components from/into ungridded
C   visibility data by a DFT model computation.  Only model components
C   of a single type are processed.  Point components will be taken as
C   Gaussians or Spheres as needed if some of the fields are extended
C   and some not.
C   All un subtracted data processed in one call.
C   Inputs:
C      OPCODE   C*4      Opcode 'SUB ', or 'DIV '
C      CHANEL   I        Frequency channel: used if MODMAX=0
C      NCHAN    I        Number of frequency channels.: ditto
C      DISKI    I        Input file disk number for cataloged files,
C                        .LE. 0 => /CFILES/ scratch file.
C      CNOSCI   I        Input file catalog slot number or /CFILES/
C                        scratch file number.
C      DISKO    I        Output file disk number for cataloged files,
C                        .LE. 0 => /CFILES/ scratch file.
C      IFIELD   I        Field to do (0 -> all): used if MODMAX=0
C      DOSUM    L        If true sum the flux in each field
C      DOMSG    L        If true give percent done messages.
C      CATR     R(256)   UV data catalog header record.
C      JBUFSZ   I        Size of BUFF1,2, IBUFF in AIPS bytes, each
C                        must be at least 4096 words.
C   Inputs: from commons
C      MODMAX   I        DMOD.INC - if set, this controls facets/chans
C      MFIELD   I        Number of fields
C      NCLNG    I(16)    Number of components per field. -
C                        changed if flux limit hit
C      NSUBG    I(16)    The next component to subtract.
C      CCDISK   I(16)    Disk numbers of the clean images.
C      CCCNO    I(16)    Catalog slot numbers of clean images.
C      CCVER    I(*)     CC file version number for each field.
C      NGRDAT   L        If FALSE get map size, scaling etc. parms
C                        from the model map cat. header. If TRUE
C                        then the values filled in by GRDAT must
C                        already be filled into the common.
C      LREC     I        Length in words of vis record.
C      NVIS     I        Number of vis. records
C      NONEG    L        Stop reading comps. from a file past the first
C                        negative component.
C      LIMFLX   R        Stop if abs(flux) < LIMFLX
C      DOPTMD   L        Use the point model specified by PTFLX, PTRAOF,
C                        PTDCOF
C      PTFLX    R        Point model flux density (Jy) (I pol. only)
C      PTRAOF   R        Point model RA offset from uv phase center
C                        (asec)
C      PTDCOF   R        Point model Dec. offset from uv phase center
C      PARMOD   R(6)     Model parameters for non point models; used
C                        only if DOPTMOD is true.
C                        1=> model type, 0=point, 1=gaussian, 3=sphere
C                        Gaussian: (2)=major axis(asec), (3)=minor axis
C                                  (4)=PA (degrees)
C                        Sphere: (2)=radius (asec).
C      KSTOK    I        (DGDS.INC) If a point model is specified a
C                        value of 2 indicates a Q pol model, 3 U and
C                        4 V pol.AC
C      FACGRD   R(2)     (1) Value to multiply Clean fluxes
C                        (2) > 0 normal, 0 model with flagging,
C                            < 0 model weights all -> 1.0
C   In/out:
C      CNOSCO   I        IN: output file catalog slot number or /CFILES/
C                        scratch file number. Will create a scratch file
C                        if CNOSCO and DISKO .le. 0.
C                        Out: file /CFILES/ number if created.
C   Output:
C      BUFF1    R(*)     I/O buffers.
C      BUFF2    R(*)     I/O buffers.
C      IBUFF    I(*)     I/O Buffer.
C      IRET     I        Return code, 0 => ok, otherwise not.
C                            8 => model types not compatible/illegal
C                            9 => Buffers too small to load AP.
C                           10 => Too many components for division.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      CHARACTER OPCODE*4
      INTEGER   CHANEL, NCHAN, DISKI, CNOSCI, DISKO, CNOSCO, IFIELD,
     *   JBUFSZ, IBUFF(*), IRET
      LOGICAL   DOSUM, DOMSG
      REAL      BUFF1(*), BUFF2(*), CATR(256)
C
      CHARACTER NAME*48, MDTYP(4)*8, ERRTXT*40, UMET*4
      INTEGER   JNCOMP, CCOUNT, XNCOMP, MXCMP, CURCMP, JT, JJ, II, KK,
     *   NCOMP, J, MCOMP, VO, BO, ISIZE, INIO, MMCOMP, NNCOR, IDATA, UV,
     *   LLREC, IAPBUF, IAPCC0, IAPCT, LMCOMP, IAPTMP, VIS, WRK, LLNMOD,
     *   MCHAN, JNCS, JNCF, KAP, SFLAG, APSIZ, MXCC, INIO2, LUNC, VOL,
     *   INDEX, NIOUT, KBIND, LENBU, LENMOD, JLREC, JNREC, FINDI,
     *   FINDO, I, LUNI, LUNO, ITIME(3), IBIND, LFIELD, LMOD(4), NKEY,
     *   IPCLST, IPCDNE, NCALL, NTIMES, MODTYP, LRPARM, LF1, LF2, NEED,
     *   MSGSAV, LCHAN, I1, I2, FLD1, FLD2, CHN1, CHN2, UCOUNT, UTARG,
     *   KLNBL2(256), IS, ISS, JBIND, SCRTCH(256)
      REAL      XXOFF, YYOFF, ZZOFF, FACT2(4), CPA, SPA, XMAJ, XMIN,
     *   ABFACG, XYZ(3), XP(3), UMAT(3,3), PMAT(3,3), UUU(2)
      DOUBLE PRECISION XTLST, PCTOT, PCLST, XRA, XDEC, XPR, YPR, CONST,
     *   CONST2
      LOGICAL   T, F, DIVIDE, WESET, DO3D
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMOD.INC'
      LOGICAL   DONE(MAXFLD), ONZE
      INTEGER   IAPCC, MFR, NFR, LFR, MMCMP(MAXMOD), CCNUMV(MAXCCC),
     *   CCKOLS(MAXCCC), CCNCOL, CCRNO, CCTYPE
      DOUBLE PRECISION FFRAC
      REAL      FBUFF(MAXCIF), XX, YY, ZZ, PARMS(3), FLUX
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMPR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      PARAMETER (CONST = DG2RAD * TWOPI)
      SAVE ONZE, FBUFF
      DATA LMOD /4, 7, 7, 6/
      DATA MDTYP /'Point   ', 'Gaussian', 'Unknown ', 'Sphere  '/
      DATA VO, BO, MXCC /0, 1, 1024/
      DATA LUNI, LUNO, LUNC /22,23,29/
      DATA T, F /.TRUE.,.FALSE./, ONZE/.FALSE./
C-----------------------------------------------------------------------
      UMET = 'DFT'
      CALL FILL (MAXMOD, 0, MMCMP)
C                                       CONST2 converts FWHM(deg) to
C                                       coefficients for u*u, v*v, u*v
      CONST2 = DG2RAD * (PI / 1.17741022D0) * SQRT (0.5D0)
C                                       Check if divide.
      DIVIDE = OPCODE.EQ.'DIV '
C                                       Tell kind of operation.
      IF (DIVIDE) THEN
         MSGTXT = 'VISDFT: Begin DFT component division'
      ELSE
         MSGTXT = 'VISDFT: Begin DFT component subtraction'
         END IF
      CALL MSGWRT (2)
      NNCOR = 1
C                                       Get un-compressed UV increments
      CALL UVINCS (INCS, INCF, INCIF, NRPARM, LREC, JNCS, JNCF, LRPARM,
     *   LLREC)
      LFIELD = 0
      CCOUNT = 0
      IF (IFIELD.LE.0) THEN
         LF1 = 1
         LF2 = MFIELD
      ELSE
         LF1 = IFIELD
         LF2 = IFIELD
         END IF
      WESET = (MODMAX.LE.0) .AND. (.NOT.DOPTMD)
      MCHAN = NCHAN
      IF (WESET) THEN
         MODMAX = LF2 - LF1 + 1
         DO 5 I = 1,MODMAX
            MODFLD(I) = I + LF1 - 1
            MODCHN(I) = CHANEL
            MODNCH(I) = NCHAN
            MODCCV(I) = ABS(CCVER(MODFLD(I)))
            MODCCB(I) = NSUBG(MODFLD(I))
 5          CONTINUE
         FLD1 = LF1
         FLD2 = LF2
         CHN1 = CHANEL
         CHN2 = CHANEL + NCHAN - 1
      ELSE IF (MODMAX.GT.0) THEN
         MCHAN = 0
         FLD1 = 100000
         FLD2 = 0
         CHN1 = FLD1
         CHN2 = 0
         DO 6 I = 1,MODMAX
            MCHAN = MAX (MCHAN, MODNCH(I))
            FLD1 = MIN (FLD1, MODFLD(I))
            FLD2 = MAX (FLD2, MODFLD(I))
            CHN1 = MIN (CHN1, MODCHN(I))
            CHN2 = MAX (CHN2, MODCHN(I)+MODNCH(I)-1)
 6          CONTINUE
         END IF
      IF (MODMAX.GT.0) THEN
CCCC   DEBUG
C         MCHAN = (CHN2 - CHN1 + 1) / 64
C         CALL FILL (64, MCHAN, MODNCH)
C         DO 77 I = 2,64
C            MODCHN(I) = MODCHN(I-1) + MCHAN
C 77         CONTINUE
CCC    DEBUG
         WRITE (MSGTXT,1006) FLD1, FLD2, CHN1, CHN2, MODMAX
         CALL REFRMT (MSGTXT, ' ', I)
         CALL MSGWRT (2)
         END IF
C                                       Decide component type.
C                                       From model passed
      IF (DOPTMD) THEN
         MODTYP = PARMOD(1) + 0.5
         IF (MODTYP.EQ.2) MODTYP = 3
         XNCOMP = 1
         MODMAX = 1
         MODFLD(1) = LF1
         MODCHN(1) = CHANEL
         MODNCH(1) = NCHAN
         MODCCV(1) = 0
         MODCCB(1) = 1
         MMCMP(1) = 1
         WESET = .TRUE.
C                                       From CC table, field 1
      ELSE
         LFIELD = LF1
C                                       Get field info. if nec.
         IF (.NOT.NGRDAT) THEN
            CALL GRDAT (F, LFIELD, CATR, IBUFF(2049), IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
C                                       If NGRDAT read CLEAN CATBLK.
         IF (NGRDAT) THEN
            ERRTXT = 'READING CLEAN CATBLK'
            CALL CATIO ('READ', CCDISK(LFIELD), CCCNO(LFIELD), KLNBLK,
     *         'REST', SCRTCH, IRET)
            IF ((IRET.GT.0) .AND. (IRET.LT.5)) GO TO 990
            END IF
C                                       For point model
         MODTYP = 0
         XNCOMP = 0
C                                       check all CC files
         MFR = 0
         LFR = 0
         DO 10 I = 1,MODMAX
            IF (MODCHN(I).NE.LFR) THEN
               MFR = MFR + 1
               LFR = MODCHN(I)
               END IF
            LFIELD = MODFLD(I)
            JLREC = 0
            NKEY = 0
C                                       Make sure this header applies
C                                       to this image
            CALL CATIO ('READ', CCDISK(LFIELD), CCCNO(LFIELD), KLNBL2,
     *         'REST', SCRTCH, IRET)
            IF ((IRET.NE.0) .AND. (IRET.LT.5)) THEN
               ERRTXT =  'READ HEADER WITH CATIO'
               GO TO 990
               END IF
C                                       Tabini can update header on disk
            ERRTXT = 'OPENING CLEAN COMPS FILE'
            CALL CCMINI ('READ', IBUFF, CCDISK(LFIELD), CCCNO(LFIELD),
     *         MODCCV(I), KLNBL2, LUNC, CCRNO, CCKOLS, CCNUMV, CCNCOL,
     *         IRET)
            IF (IRET.GT.1) GO TO 990
            IF (NCLNG(LFIELD).LE.0) NCLNG(LFIELD) = IBUFF(5)
            JNREC = IBUFF(5)
            DONE(I) = F
            XNCOMP = XNCOMP + NCLNG(LFIELD) - MODCCB(I) + 1
            MMCMP(MFR) = MMCMP(MFR) + NCLNG(LFIELD) - MODCCB(I) + 1
C                                       More complex models
C                                       Find columns (physical)
            IF ((CCNCOL.GT.4) .AND. (NCLNG(LFIELD).GE.MODCCB(I)))
     *         THEN
C                                       Read 1st record
               CALL TABCCM ('READ', IBUFF, CCRNO, CCKOLS, CCNUMV,
     *            CCNCOL, XX, YY, ZZ, FLUX, CCTYPE, PARMS, IRET)
               IF (IRET.GT.0) THEN
                  WRITE (MSGTXT,1090) IRET, CCRNO
                  GO TO 995
                  END IF
               IF (LFIELD.EQ.LF1) MODTYP = CCTYPE
               IF (MODTYP.NE.CCTYPE) THEN
                  IF ((MODTYP.EQ.0) .OR. (CCTYPE.EQ.0)) THEN
                     MSGTXT = 'VISDFT: will treat points as extended'
                     CALL MSGWRT(6)
                     MODTYP = MAX (MODTYP, CCTYPE)
                  ELSE
                     WRITE (MSGTXT,1000) MODTYP, CCTYPE
                     IRET = 8
                     GO TO 995
                     END IF
                  END IF
               END IF
C                                       Close CLEAN components file.
            CALL TABCCM ('CLOS', IBUFF, CCRNO, CCKOLS, CCNUMV,
     *         CCNCOL, XX, YY, ZZ, FLUX, CCTYPE, PARMS, IRET)
 10         CONTINUE
         END IF
C                                       Bad model type.
      IF ((MODTYP.NE.0) .AND. (MODTYP.NE.1) .AND. (MODTYP.NE.3)) THEN
         IRET = 8
         WRITE (MSGTXT,1002) MODTYP
         GO TO 995
         END IF
C                                       Check for point model.
      LFIELD = LF1 - 1
C                                       Tell model type once
      IF (.NOT.ONZE) THEN
C                                       Tell model type
         MSGTXT = 'VISDFT: Model components of type '//MDTYP(MODTYP+1)
         CALL MSGWRT (2)
C                                       Check Buffer size
         IF ((XNCOMP.GT.10) .AND. (JBUFSZ/2.LT.4096)) THEN
            MSGTXT = 'VISDFT: SCRATCH BUFFER TOO SMALL FOR CCs!'
            CALL MSGWRT (8)
            IRET = 9
            GO TO 999
            END IF
         END IF
C                                       Set model length
      LENMOD = LMOD(MODTYP+1)
C                                       Determine size of uv I/O and
C                                       the number of CC that will fit.
      LENBU = ((JBUFSZ-2*NBPS) / 2) / (LLREC*2)
C                                       How much data fits in AP?
      JT = 15 + LENBU * LLREC
      IF (MXCC.GT.JT) JT = MXCC
      NEED = JT + MCHAN + (XNCOMP+2)*LENMOD
      NEED = NEED / 1024
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL QINIT (APCORE, NEED, 0, KAP)
      MSGSUP = MSGSAV
      IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
         NEED = JT + MCHAN + (XNCOMP/10+2)*LENMOD
         NEED = NEED / 1024
         NEED = MIN (32*1024, NEED) + 2
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
             IRET = 8
             MSGTXT = 'VISDFT CANNOT GET NEEDED MEMORY'
             GO TO 995
             END IF
          END IF
      APSIZ = PSAPNW * 1024
      CALL QRLSE
      MXCMP = (APSIZ - JT - MCHAN)  / LENMOD
      MXCMP = MXCMP - 2
C                                       Set AP pointers.
C                                       UV=UV pointer, VIS=vis pointer
C                                       IAPCC0=CLEAN components pointer.
      IDATA = 12 + MCHAN
      UV = IDATA + ILOCU
      IAPCC0 = 15 + LENBU * LLREC + MCHAN
      IAPCC0 = MAX (IAPCC0, MXCC)

      LLNMOD = LENMOD
C                                       Compute number of passes.
      NTIMES = (1.0 * XNCOMP) / MXCMP + 0.99999
      NTIMES = MAX (NTIMES, 1)
C                                       Only one pass allowed for
C                                       division.  No can do.
      IF (NTIMES.GT.1) THEN
         IF (DIVIDE) THEN
            ERRTXT = 'TOO MANY COMPONENTS FOR DIVISION'
            IRET = 10
            GO TO 990
         ELSE IF (.NOT.WESET) THEN
            ERRTXT = 'EXTERNAL FACET LIST WILL NOT FIT'
            IRET = 10
            GO TO 990
            END IF
         END IF
C                                       Fix for Division scaling
      ABFACG = 1.0
      IF (DIVIDE) ABFACG = ABS(FACGRD(1))
C                                       Open uv files.
C                                       Set input file name.
      IF (DISKI.LE.0) THEN
         VOL = SCRVOL(CNOSCI)
         CALL ZPHFIL ('SC', VOL, SCRCNO(CNOSCI), 1, NAME, IRET)
      ELSE
         VOL = DISKI
         CALL ZPHFIL ('UV', VOL, CNOSCI, 1, NAME, IRET)
         END IF
C                                       Open input file.
      ERRTXT = 'OPEN-FOR-READ VIS FILE'
      CALL ZOPEN (LUNI, FINDI, VOL, NAME, T, F, T, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Create scratch file if necessary
      IF ((DISKO.LE.0) .AND. (CNOSCO.EQ.0)) THEN
         CALL UVSIZE (LREC, NVIS, ISIZE)
         ERRTXT = 'CREATING SCRATCH FILE'
         CALL SCREAT (ISIZE, BUFF2, IRET)
         CNOSCO = NSCR
         IF (IRET.GT.0) THEN
            IF (IRET.EQ.1) ERRTXT = 'NO SPACE FOR SCRATCH FILE'
            GO TO 990
            END IF
C                                       End if creating scratch file
         END IF
C                                       Open vis file for write.
      IF (DISKO.LE.0) THEN
         VOL = SCRVOL(CNOSCO)
         CALL ZPHFIL ('SC', VOL, SCRCNO(CNOSCO), 1, NAME, IRET)
      ELSE
         VOL = DISKO
         CALL ZPHFIL ('UV', VOL, CNOSCO, 1, NAME, IRET)
         END IF
      ERRTXT = 'OPEN-FOR-WRITE VIS FILE'
      CALL ZOPEN (LUNO, FINDO, VOL, NAME, T, F, T, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Loop, subtracting Max Component
C                                       In AP each pass
      I1 = 1
      DO 500 NCALL = 1,NTIMES
         I2 = I1 - 1
C                                       Setup for % done messages.
         PCTOT = NVIS
         PCLST = PCTOT * (NCALL - 1)
         IPCLST = (100. / NTIMES ) * (NCALL - 1)
C                                       Set AP loc for next CC load
         IAPCT = IAPCC0
C                                       Determine. no. this pass.
         MMCOMP = 0
         NCOMP = MIN (MXCMP, XNCOMP)
C                                       Grab AP.
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
            IRET = 10
            MSGTXT = 'VISDFT: BIZARRE FAILURE TO GET AP MEMORY'
            GO TO 995
            END IF
C                                       Initialize REAL time clock for
C                                       AP roller.
         CALL ZTIME (ITIME)
         XTLST = (ITIME(1) * 60.00) + ITIME(2) + (ITIME(3) / 60.0)
C                                       If Not single component model.
         IF (.NOT.DOPTMD) THEN
C                                       Find next FIELD.
C                                       Loop back here for next field.
 70         I2 = I2 + 1
C                                       See if done.
            IF (I2.GT.MODMAX) GO TO 150
            IF (DONE(I2)) GO TO 70
            LFIELD = MODFLD(I2)
C                                       See if there are CCs.
            IF ((MODCCB(I2).GT.NCLNG(LFIELD))) GO TO 70
C                                       Get field info. if nec.
            IF (.NOT.NGRDAT) THEN
               CALL GRDAT (F, LFIELD, CATR, IBUFF(2049), IRET)
               IF (IRET.NE.0) GO TO 999
               END IF
C                                       If NGRDAT read CLEAN CATBLK.
            IF (NGRDAT) THEN
               ERRTXT = 'READING CLEAN CATBLK'
               CALL CATIO ('READ', CCDISK(LFIELD), CCCNO(LFIELD),
     *            KLNBLK, 'REST', SCRTCH, IRET)
               IF ((IRET.GT.0) .AND. (IRET.LT.5)) GO TO 990
               END IF
C                                       Set field center offsets.
            XXOFF = DXCG(LFIELD) * CCROT + DYCG(LFIELD) * SSROT
            YYOFF = DYCG(LFIELD) * CCROT - DXCG(LFIELD) * SSROT
            ZZOFF = DZCG(LFIELD)
            CALL XYSHFT (RA, DEC, XSHIFT(LFIELD), YSHIFT(LFIELD),
     *         MAPROT, XRA, XDEC)
            IF (DO3DIM) THEN
               CALL PRJMAT (RA, DEC, UVROT, XRA, XDEC, MAPROT, UMAT,
     *            PMAT)
            ELSE
               CALL P2DMAT (RA, DEC, UVROT, XRA, XDEC, MAPROT, UMAT,
     *            PMAT)
               END IF
C                                       Load CLEAN components into AP.
C                                       Open components file.
            NKEY = 0
            ERRTXT = 'OPENING CLEAN COMPS FILE'
            CALL CCMINI ('READ', IBUFF, CCDISK(LFIELD), CCCNO(LFIELD),
     *         MODCCV(I2), KLNBLK, LUNC, CCRNO, CCKOLS, CCNUMV, CCNCOL,
     *         IRET)
            IF (IRET.GT.1) GO TO 990
            JNREC = IBUFF(5)
            CCRNO = MODCCB(I2)
            DO3D = CCNUMV(4).GT.0
            IF ((.NOT.ONZE) .AND. (DO3D)) THEN
               MSGTXT = 'VISDFT: using 3D Clean Component file'
               CALL MSGWRT (2)
               END IF
            ONZE = .TRUE.
C                                       Make sure that there are some
            IF (IBUFF(5).LE.0) GO TO 140
            IF (NCLNG(LFIELD).LE.0) NCLNG(LFIELD) = IBUFF(5)
C                                       Loop loading components.
            IAPBUF = 10
            CURCMP = MMCOMP + 1
C                                       Check next component
            IF (CCRNO.GT.NCLNG(LFIELD)) GO TO 140
            DO 130 J = CURCMP,NCOMP,MXCC
               JT = J - 1
               JNCOMP = 0
               MCOMP = NCOMP - J + 1
               IF (MCOMP.GT.MXCC) MCOMP = MXCC
               IF (MCOMP.GT.(NCLNG(LFIELD)-MODCCB(I2)+1))
     *            MCOMP = NCLNG(LFIELD) - MODCCB(I2) + 1
               DO 110 I = 1,MCOMP
C                                       Check if finished field
                  IF (CCRNO.GT.NCLNG(LFIELD)) GO TO 120
                  CALL TABCCM ('READ', IBUFF, CCRNO, CCKOLS, CCNUMV,
     *               CCNCOL, XX, YY, ZZ, FLUX, CCTYPE, PARMS, IRET)
                  IF (IRET.GT.0) THEN
                     WRITE (MSGTXT,1090) IRET, CCRNO
                     GO TO 995
                     END IF
C                                        Check that point comp.
                  JT = JT + 1
                  IF ((CCTYPE.NE.MODTYP) .AND. (CCTYPE.NE.0)) THEN
                     WRITE (MSGTXT,1070) LFIELD, CCRNO-1
                     CALL MSGWRT (6)
                     END IF
                  IF (((CCTYPE.EQ.MODTYP) .OR. (CCTYPE.EQ.0)) .AND.
     *               (IRET.EQ.0)) THEN
C                                       Check negative component limit
                     DONE(I2) = (NONEG.AND.(FLUX.LE.0.0))
     *                  .OR. (ABS(FLUX).LT.LIMFLX)
                     IF (DONE(I2)) THEN
                        NCLNG(LFIELD) = CCRNO - 1
                        GO TO 120
                        END IF
C                                       If req. sum flux
                     IF (DOSUM) THEN
                        FLUXG(LFIELD) = FLUXG(LFIELD) + FLUX
                        TFLUXG = TFLUXG + FLUX
                        END IF
                     JNCOMP = JNCOMP + 1
                     CCOUNT = CCOUNT + 1
                     IF (DO3D) THEN
                        BUFF1(JNCOMP) = XX * CONST
                        BUFF1(1024+JNCOMP) = YY * CONST
                        BUFF1(2048+JNCOMP) = ZZ * CONST
                     ELSE
                        XP(1) = (XX + XPOFF(LFIELD)) * CONST
                        XP(2) = (YY + YPOFF(LFIELD)) * CONST
                        XP(3) = 0.0
                        CALL PRJMUL (2, XP, UMAT, XYZ)
                        BUFF1(JNCOMP) = XYZ(1) + XXOFF
                        BUFF1(1024+JNCOMP) = XYZ(2) + YYOFF
                        BUFF1(2048+JNCOMP) = XYZ(3) + ZZOFF
                        END IF
C                                       Handle scaling for division
                     BUFF1(3072+JNCOMP) = ABFACG * FLUX
C                                       Gaussian
                     IF (MODTYP.EQ.1) THEN
C                                       Convert to convenient
C                                       coefficients.
                        IF (CCTYPE.EQ.0) THEN
                           BUFF2(JNCOMP) = 0.0
                           BUFF2(1024+JNCOMP) = 0.0
                           BUFF2(2048+JNCOMP) = 0.0
                        ELSE
                           CPA = COS (DG2RAD*PARMS(3))
                           SPA = SIN (DG2RAD*PARMS(3))
                           XMAJ = PARMS(1) * CONST2
                           XMIN = pARMS(2) * CONST2
                           BUFF2(JNCOMP) = - (((CPA * XMAJ)**2) +
     *                        (SPA * XMIN)**2)
                           BUFF2(1024+JNCOMP) = - (((SPA * XMAJ)**2)
     *                        + (CPA * XMIN)**2)
                           BUFF2(2048+JNCOMP) = - 2.0 * CPA * SPA *
     *                        (XMAJ*XMAJ - XMIN*XMIN)
                           END IF
C                                       Sphere
                     ELSE IF (MODTYP.EQ.3) THEN
                        BUFF1(3072+JNCOMP) = 3.0 * BUFF1(3072+JNCOMP)
                        IF (CCTYPE.EQ.0) THEN
                           BUFF2(JNCOMP) = 0.0
                        ELSE
                           BUFF2(JNCOMP) = PARMS(1) * 0.109662271
                           END IF
                        BUFF2(1024+JNCOMP) = 0.1
                        END IF
                     END IF
 110              CONTINUE
C                                       Load components
 120           IF (JNCOMP.GT.0) THEN
                  LMCOMP = JNCOMP
                  MMCOMP = MMCOMP + LMCOMP
C                                       Load into AP
                  IAPBUF = 10
C                                       x component
                  CALL QPUT (APCORE, BUFF1, IAPBUF, LMCOMP, 2)
                  IAPTMP = IAPCT + 1
                  CALL QWD
                  CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD, LMCOMP)
                  CALL QWR
C                                       y component
                  CALL QPUT (APCORE, BUFF1(1025), IAPBUF, LMCOMP, 2)
                  IAPTMP = IAPCT + 2
                  CALL QWD
                  CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD, LMCOMP)
                  CALL QWR
C                                       z component
                  CALL QPUT (APCORE, BUFF1(2049), IAPBUF, LMCOMP, 2)
                  IAPTMP = IAPCT + 3
                  CALL QWD
                  CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD, LMCOMP)
                  CALL QWR
C                                       Flux density
                  CALL QPUT (APCORE, BUFF1(3073), IAPBUF, LMCOMP, 2)
                  CALL QWD
                  CALL QVMOV (APCORE, IAPBUF, 1, IAPCT, LLNMOD, LMCOMP)
                  CALL QWR
C                                       Gaussian
                  IF (MODTYP.EQ.1) THEN
C                                       Coef 1.
                     CALL QPUT (APCORE, BUFF2, IAPBUF, LMCOMP, 2)
                     IAPTMP = IAPCT + 4
                     CALL QWD
                     CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD,
     *                  LMCOMP)
                     CALL QWR
C                                       Coef 2.
                     CALL QPUT (APCORE, BUFF2(1025), IAPBUF, LMCOMP, 2)
                     IAPTMP = IAPCT + 5
                     CALL QWD
                     CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD,
     *                  LMCOMP)
                     CALL QWR
C                                       Coef 3.
                     CALL QPUT (APCORE, BUFF2(2049), IAPBUF, LMCOMP, 2)
                     IAPTMP = IAPCT + 6
                     CALL QWD
                     CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD,
     *                  LMCOMP)
                     CALL QWR
                     END IF
C                                       Sphere
                  IF (MODTYP.EQ.3) THEN
C                                       Radius
                     CALL QPUT (APCORE, BUFF2, IAPBUF, LMCOMP, 2)
                     IAPTMP = IAPCT + 4
                     CALL QWD
                     CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD,
     *                  LMCOMP)
                     CALL QWR
C                                       Minimum argument
                     CALL QPUT (APCORE, BUFF2(1025), IAPBUF, LMCOMP, 2)
                     IAPTMP = IAPCT + 5
                     CALL QWD
                     CALL QVMOV (APCORE, IAPBUF, 1, IAPTMP, LLNMOD,
     *                  LMCOMP)
                     CALL QWR
                     END IF
                  IAPCT = IAPCT + (LLNMOD * LMCOMP)
                  END IF
C                                       Check if finished field.
               IF ((CCRNO.GT.NCLNG(LFIELD)) .OR. DONE(I2))
     *            GO TO 140
 130           CONTINUE
C                                       Close CLEAN components file.
 140        CALL TABCCM ('CLOS', IBUFF, CCRNO, CCKOLS, CCNUMV,
     *         CCNCOL, XX, YY, ZZ, FLUX, CCTYPE, PARMS, IRET)
C                                       Update field sub. count.
            NSUBG(LFIELD) = CCRNO
C                                       Check if need another field.
            IF (JT.LT.NCOMP) GO TO 70
C                                      Check no. comps.
 150        IF ((MMCOMP.EQ.0) .AND. (NCALL.EQ.1)) THEN
               ERRTXT = 'NO POINT COMPONENTS FOUND'
               IRET = 1
               GO TO 990
               END IF
C                                       No comps on later pass is OK
            IF (MMCOMP.LE.0) GO TO 510
C                                       Load correlator factors
            CALL GETCTL (CATR, FACT2, IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Else, single component model.
         ELSE
            I2 = 1
            CALL RFILL (LENMOD, 0.0, BUFF1)
            BUFF1(2) = PTRAOF * CONST / 3600.D0
            BUFF1(3) = PTDCOF * CONST / 3600.D0
C                                       single comp uses W term
            XPR = PTRAOF / 206264.81D0
            YPR = PTDCOF / 206264.81D0
            BUFF1(4) = -(SQRT (1.0D0 - XPR*XPR - YPR*YPR) - 1.0D0) *
     *         206264.81D0 * CONST / 3600.D0
C                                       Point
            IF (MODTYP.EQ.0) BUFF1(1) = PTFLX
C                                       Gaussian
            IF (MODTYP.EQ.1) THEN
C                                       Convert to convenient
C                                       coefficients.
               CPA = COS (DG2RAD * PARMOD(4))
               SPA = SIN (DG2RAD * PARMOD(4))
               XMAJ = PARMOD(2) * CONST2 * 2.77777778E-4
               XMIN = PARMOD(3) * CONST2 * 2.77777778E-4
               BUFF1(5) = -(((CPA * XMAJ)**2) + (SPA * XMIN)**2)
               BUFF1(6) = -(((SPA * XMAJ)**2) + (CPA * XMIN)**2)
               BUFF1(7) = -2.0 *  CPA * SPA * (XMAJ*XMAJ - XMIN*XMIN)
               BUFF1(1) = PTFLX
               END IF
C                                       Uniform sphere
            IF (MODTYP.EQ.3) THEN
               BUFF1(5) = PARMOD(2) * 0.109662271 * 2.7777778E-4
               BUFF1(1) = PTFLX * 3.0
               BUFF1(6) = 0.1
               END IF
            MMCOMP = 1
            IAPCC = IAPCC0
            CALL QPUT (APCORE, BUFF1, IAPCC, LLNMOD, 2)
            IAPCT = IAPCC + LLNMOD
C                                       Set Stokes for point model
            FACT2(1) = 1.0
            FACT2(2) = 1.0
            IF (DOALL4) THEN
               FACT2(3) = 1.0
               FACT2(4) = 1.0
            ELSE
               FACT2(3) = 0.0
               FACT2(4) = 0.0
               END IF

            VOFF = 0
C                                       RR,LL etc.
            IF (ICOR0.LT.0) THEN
C                                       Q?
               IF (KSTOK.EQ.2) THEN
                  FACT2(1) = 1.0
                  FACT2(2) = 1.0
                  VOFF = (3 - ABS (ICOR0)) * INCS
               ELSE IF (KSTOK.EQ.3) THEN
                  FACT2(1) = 1.0
                  FACT2(2) = -1.0
                  VOFF = (3 - ABS (ICOR0)) * INCS
               ELSE IF (KSTOK.EQ.4) THEN
                  FACT2(1) = 1.0
                  FACT2(2) = -1.0
                  VOFF = 0
                  END IF
C                                       True Stokes
            ELSE
               IF ((KSTOK.GE.2) .AND. (KSTOK.LE.4)) THEN
                  FACT2(1) = 1.0
                  FACT2(2) = 0.0
                  VOFF = (KSTOK - ICOR0) * INCS
                  END IF
               END IF
            NSTOK = 1
            IF ((CATR(KRCIC+JLOCS).LT.0.0) .AND. (NCOR.GE.2)) THEN
               NSTOK = 2
               IF (DOALL4) NSTOK = NCOR
C                                       TEMPORARY
               NSTOK = NCOR
               END IF
            IF ((NSTOK.EQ.2) .AND. (ABS (ICOR0).EQ.2)) NSTOK = 1
C                                       End if not single comp. model
            END IF
C                                       Correct for FACGRD
         NNCOR = NSTOK
         FACT2(1) = FACT2(1) * FACGRD(1)
         FACT2(2) = FACT2(2) * FACGRD(1)
         FACT2(3) = FACT2(3) * FACGRD(1)
         FACT2(4) = FACT2(4) * FACGRD(1)
         WRK = MCHAN + 2
C                                       replace flag only for subtract
C                                       where DOALL4 always false
         UUU(1) = -1.0
         IF (FACGRD(2).LE.0.0) UUU(1) = 1.0
         CALL QPUT (APCORE, UUU, WRK+NNCOR, 1, 2)
         CALL QPUT (APCORE, FACT2, WRK, NNCOR, 2)
         SFLAG = 1
C                                       Set flag for UPOL and RL,LR data
         IF ((KSTOK.EQ.3) .AND. (ICOR0.LT.0)) SFLAG = -1
C                                       Set vis pointer
         VIS = IDATA + LRPARM + (CHANEL-1) * JNCF + (VOFF/INCS)*JNCS
         CALL QWAIT
C                                       Init for read & write
C                                       visibility file
C                                       Init vis file for write
         ERRTXT = 'INIT-FOR-READ VIS FILE'
         CALL UVINIT ('READ', LUNI, FINDI, NVIS, VO, LREC, LENBU,
     *      JBUFSZ, BUFF1, BO, IBIND, IRET)
         IF (IRET.NE.0) GO TO 990
         UTARG = 1
         UCOUNT = 0
C                                       Init vis file for read.
         ERRTXT = 'INIT-FOR-WRITE VIS FILE'
         CALL UVINIT ('WRIT', LUNO, FINDO, NVIS, VO, LREC, LENBU,
     *      JBUFSZ, BUFF2, BO, KBIND, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Subtract model from vis data.
C                                       Loop:  Read vis. record.
 200        CONTINUE
            ERRTXT = 'READING VIS FILE'
            CALL UVDISK ('READ', LUNI, FINDI, BUFF1, INIO2, IBIND, IRET)
            INIO = INIO2
            IF (IRET.NE.0) GO TO 990
C                                       Exit if no more data
            IF (INIO.LE.0) GO TO 300
            UCOUNT = UCOUNT + INIO
            IF (UCOUNT.GT.UTARG) THEN
               WRITE (MSGTXT,1200) UTARG
               CALL MSGWRT (2)
               UTARG = UTARG + 200000
               END IF
C                                       MODL - zero input buffer
C                                       on 1st time through
            IF ((FACGRD(2).LE.0.0) .AND. (NCALL.EQ.1)) THEN
               JBIND = IBIND
               DO 209 J = 1,INIO
                  DO 208 I = I1,I2
                     KK = JBIND + NRPARM - 1 + (MODCHN(I)-1) * INCF
                     JJ = MODNCH(I) * INCF
C                                       compressed
                     IF (LREC.LT.LLREC) THEN
                        DO 202 II = 1,JJ,INCF
                           DO 201 IS = 1,NSTOK
                              BUFF1(KK+II+IS-1) = 0
 201                       CONTINUE
 202                     CONTINUE
                     ELSE
                        DO 204 II = 1,JJ,INCF
                           DO 203 IS = 1,NSTOK
                              ISS = II + (IS-1) * INCS
                              BUFF1(KK+ISS) = 0.0
                              BUFF1(KK+ISS+1) = 0.0
                              IF (FACGRD(2).LT.0.0) BUFF1(KK+ISS+1) = 1.
 203                          CONTINUE
 204                       CONTINUE
                        END IF
 208                 CONTINUE
                  JBIND = JBIND + LREC
 209              CONTINUE
               END IF
C                                       Uncompress Vis and put in AP
            CALL BUFPUT (APCORE, INIO, NRPARM, LREC, LLREC, IDATA,
     *         BUFF1(IBIND), IBUFF(1))
C                                       Loop over frequency groups
            LFR = 0
            NFR = 0
            IAPCC = IAPCC0
C            DO 220 I = I1,I1+63
            DO 220 I = I1,I2
               IF (MODCHN(I).NE.LFR) THEN
                  NFR = NFR + 1
                  LFR = MODCHN(I)
                  IF (NFR.GT.1) IAPCC = IAPCC + MMCMP(NFR-1) * LENMOD
                  MMCOMP = MMCMP(NFR)
                  LCHAN = MODNCH(I)
                  VIS = IDATA + LRPARM + (LFR-1)*JNCF + (VOFF/INCS)*JNCS
C                                       Fill frequency table
C                                       Double array to force accuracy
                  FFRAC = (FREQG(LFR) / FREQ) - 1.0D0
                  FBUFF(1) = FFRAC
                  IF (LCHAN.GT.1) THEN
                     DO 210 J = 2,LCHAN
                        INDEX = LFR + J - 1
                        FFRAC = (FREQG(INDEX) / FREQ) - 1.0D0
                        FBUFF(J) = FFRAC
 210                    CONTINUE
                     END IF
                  CALL QWD
                  CALL QPUT (APCORE, FBUFF, 2, MCHAN, 2)
                  CALL QWAIT
C                                       Do the arithmetic: divide
                  IF (DIVIDE) THEN
C                                       Point
                     IF (MODTYP.EQ.0) CALL QPTDIV (APCORE, IAPCC, UV,
     *                  VIS, LLREC, JNCF, JNCS, MMCOMP, INIO, LCHAN,
     *                  NNCOR)
C                                       Gaussian
                     IF (MODTYP.EQ.1) CALL QGADIV (APCORE, IAPCC, UV,
     *                  VIS, LLREC, JNCF, JNCS, MMCOMP, INIO, LCHAN,
     *                  NNCOR)
C                                       Sphere
                     IF (MODTYP.EQ.3) CALL QSPDIV (APCORE, IAPCC, UV,
     *                  VIS, LLREC, JNCF, JNCS, MMCOMP, INIO, LCHAN,
     *                  NNCOR)
C                                       Subtract
                  ELSE
C                                       Point
                     IF (MODTYP.EQ.0) CALL QXXPTS (APCORE, IAPCC, UV,
     *                  VIS, LLREC, JNCF, JNCS, MMCOMP, INIO, LCHAN,
     *                  MCHAN, NNCOR, SFLAG)
C                                       Gaussian
                     IF (MODTYP.EQ.1) CALL QGASUB (APCORE, IAPCC, UV,
     *                  VIS, LLREC, JNCF, JNCS, MMCOMP, INIO, LCHAN,
     *                  MCHAN, NNCOR, SFLAG)
C                                       Sphere
                     IF (MODTYP.EQ.3) CALL QSPSUB (APCORE, IAPCC, UV,
     *                  VIS, LLREC, JNCF, JNCS, MMCOMP, INIO, LCHAN,
     *                  MCHAN, NNCOR, SFLAG)
                     END IF
                  END IF
 220           CONTINUE
            CALL QWR
C                                       Get UVs from AP (maybe pack UV)
            CALL BUFGET (APCORE, INIO, NRPARM, LREC, LLREC, IDATA,
     *         BUFF2(KBIND), IBUFF(1))
C                                       Write vis record.
            NIOUT = INIO
            ERRTXT = 'WRITING VIS FILE'
            CALL UVDISK ('WRIT', LUNO, FINDO, BUFF2, NIOUT, KBIND, IRET)
            IF (IRET.NE.0) GO TO 990
C                                       Check if time for % done
C                                       message.
            PCLST = PCLST + NIOUT
            IPCDNE = (100.0 / NTIMES) * (PCLST / PCTOT) + 0.5
            IPCDNE = IPCDNE - MOD (IPCDNE, 10)
C                                       Write % done message.
            IF ((IPCDNE.GT.IPCLST) .AND. (DOMSG)) THEN
               WRITE (MSGTXT,1240) IPCDNE
               IF (IPCDNE.LE.100) CALL MSGWRT (2)
               IPCLST = IPCDNE
               END IF
C                                       Check if time for AP roller
            CALL QROLL (APCORE, IAPCT, IBUFF, JBUFSZ, IRET)
            IF (IRET.NE.0) GO TO 999
            GO TO 200
C                                       Finish write
 300     CALL QRLSE
         NIOUT = 0
         ERRTXT = 'FLUSHING VIS FILE'
         CALL UVDISK ('FLSH', LUNO, FINDO, BUFF2, NIOUT, KBIND, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Update no. comp. left.
         XNCOMP = XNCOMP - MXCMP
C                                       Check if done.
         IF (XNCOMP.LE.0.01) GO TO 510
C                                       Input now output.
C                                       Close old input
         CALL ZCLOSE (LUNI, FINDI, IRET)
C                                       Set new input file name.
         IF (DISKO.LE.0) THEN
            VOL = SCRVOL(CNOSCO)
            CALL ZPHFIL ('SC', VOL, SCRCNO(CNOSCO), 1, NAME, IRET)
         ELSE
            VOL = DISKO
            CALL ZPHFIL ('UV', VOL, CNOSCO, 1, NAME, IRET)
            END IF
C                                       Open new input file.
         ERRTXT = 'OPEN-FOR-READ VIS FILE'
         CALL ZOPEN (LUNI, FINDI, VOL, NAME, T, F, T, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Open vis file for write.
C                                       Set output file name.
C                                       End big loop, N Comps per pass
         I1 = I2 + 1
 500     CONTINUE
C                                       Close files
 510  CALL ZCLOSE (LUNI, FINDI, IRET)
      CALL ZCLOSE (LUNO, FINDO, IRET)
      IF (WESET) MODMAX = 0
      IRET = 0
      GO TO 999
C                                       Error
 990  WRITE(MSGTXT,1990,ERR=999) IRET, ERRTXT
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VISDFT: MODEL TYPES =',I2,I2,' INCOMPATIBLE')
 1002 FORMAT ('VISDFT: ILLEGAL MODEL TYPE =',I3)
 1006 FORMAT ('VISDFT: fields',I5,' -',I5,' chns',I5,' -',I5,' in',I5,
     *   ' CC models')
 1070 FORMAT ('VISDFT WRONG MODTYP AT FIELD, COMP',I5,I9)
 1090 FORMAT ('VISDFT: ERROR',I5,' READING CLEAN COMPS REC',I5)
 1200 FORMAT ('VISDFT at visibility number',I12)
 1240 FORMAT ('Model computation is ',I5,' percent complete')
 1990 FORMAT ('VISDFT: ERROR',I5,' ',A)
      END

      SUBROUTINE EQUIV (YES)
C-----------------------------------------------------------------------
C! checks whether two variables are logically equivalent
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2007, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   EQUIV checks whether 2 variables are logically equivalent.
C   Scalars are equivalent if they are = within 1.e-6 of the larger
C   (numeric) or if the strings are the same neglecting trailing
C   blanks.  Arrays are equivalent to scalars if each element of the
C   array is equivalent to the scalar.  Arrays are equivalent to
C   arrays if they are equivalent element by element.
C   Output:
C      YES    L       T => they are equivalent
C   Commons:
C      alters K array;
C             SP in /POPS/;
C             SYTYPE and TAG in /SMSTUF/
C-----------------------------------------------------------------------
      LOGICAL   YES
C
      CHARACTER PRGNAM*6, CT*1
      LOGICAL   EQUAL
      INTEGER   POTERR, ICSIZE, ISIZE, IOFF, ITAG, ITYPE, J, M, NCSIZE,
     *   NSIZE, IACT, NOFF, NACT, ICWORD, NCWORD
      REAL      XXX, Y, Z, EPS
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DSMS.INC'
      DATA PRGNAM /'EQUIV '/
      DATA EPS /1.E-6/
C-----------------------------------------------------------------------
      YES = .FALSE.
C                                       find type of assignment
      POTERR = 7
      IF (SP.LT.2) GO TO 980
C                                       numeric scalars
      IF ((STACK(SP-1).EQ.2) .OR. (STACK(SP).EQ.2)) GO TO 10
         XXX = V(SP-1)
         Y = V(SP)
         SP = SP - 2
         Z = MAX (ABS(XXX), ABS(Y)) * EPS
         IF (Z.EQ.0.) Z = EPS
         IF (ABS(XXX-Y).LE.Z) GO TO 970
         GO TO 999
C                                       Something is a vector
 10   IF (SP.LT.5) GO TO 980
      IF ((STACK(SP).EQ.2) .AND. (STACK(SP-4).EQ.2)) GO TO 30
C                                       other is scalar
C                                       LHS scalar
      IF (STACK(SP).EQ.2) THEN
         SYTYPE = STACK(SP-3)
         TAG = STACK(SP-1)
         NSIZE = STACK(SP-2)
         Y = V(SP-4)
C                                       RHS scalar
      ELSE
         SYTYPE = STACK(SP-4)
         TAG = STACK(SP-2)
         NSIZE = STACK(SP-3)
         Y = V(SP)
         END IF
      SP = SP - 5
      POTERR = 23
      IF ((SYTYPE.NE.2) .AND. (SYTYPE.NE.12)) GO TO 980
      IF (SYTYPE.EQ.2) NSIZE = K(NSIZE)
      M = TAG + NSIZE - 1
      DO 25  J = TAG,M
         XXX = C(J)
         Z = MAX (ABS(XXX), ABS(Y)) * EPS
         IF (Z.EQ.0.0) Z = EPS
         IF (ABS(XXX-Y).GE.Z) GO TO 999
 25      CONTINUE
      GO TO 970
C                                       Both structures
 30   IF (SP.LT.8) GO TO 980
      ITAG = STACK(SP-1)
      ISIZE = STACK(SP-2)
      ITYPE = STACK(SP-3)
      TAG = STACK(SP-5)
      NSIZE = STACK(SP-6)
      SYTYPE = STACK(SP-7)
      POTERR = 8
      IF ((SYTYPE.EQ.2) .AND. (ITYPE.NE.2) .AND. (ITYPE.NE.12))
     *   GO TO 980
      IF ((SYTYPE.EQ.12) .AND. (ITYPE.NE.2) .AND. (ITYPE.NE.12))
     *   GO TO 980
      IF ((SYTYPE.NE.2) .AND. (SYTYPE.NE.12) .AND. (ITYPE.EQ.2))
     *   GO TO 980
      IF ((SYTYPE.NE.2) .AND. (SYTYPE.NE.12) .AND. (ITYPE.EQ.12))
     *   GO TO 980
      SP = SP - 8
C                                       Real vector = vector
      IF ((SYTYPE.NE.2) .AND. (SYTYPE.NE.12)) GO TO 40
         IF (ITYPE.EQ.2) ISIZE = K(ISIZE)
         IF (SYTYPE.EQ.2) NSIZE = K(NSIZE)
         IF (ISIZE.NE.NSIZE) GO TO 980
         M = TAG + NSIZE - 1
         DO 35 J = TAG,M
            XXX = C(J)
            Y = C(J-TAG+ITAG)
            Z = MAX (ABS(XXX), ABS(Y))
            IF (ABS(XXX-Y).GT.EPS*Z) GO TO 999
 35         CONTINUE
         GO TO 970
C                                       Characters
 40   ICSIZE = ISIZE
      IF (ITYPE.EQ.7) ICSIZE = K(ISIZE+3)
      IF (ITYPE.EQ.9) ICSIZE = MOD (ISIZE, 1024)
      NCSIZE = NSIZE
      IF (SYTYPE.EQ.7) NCSIZE = K(NSIZE+3)
      IF (SYTYPE.EQ.9) NCSIZE = MOD (NSIZE, 1024)
      IOFF = 1
      IF (ITYPE.EQ.9) IOFF = ISIZE / 1024
      NOFF = 1
      IF (SYTYPE.EQ.9) NOFF = NSIZE / 1024
      IF ((ICSIZE.EQ.0) .AND. (NCSIZE.EQ.0)) GO TO 970
      IF ((ICSIZE.LE.0) .OR. (NCSIZE.LE.0)) GO TO 999
      IF ((IOFF.LE.0) .OR. (NOFF.LE.0)) GO TO 980
C                                       both scalar strings
      IF ((ITYPE.EQ.7) .AND. (K(ISIZE+1).GT.1)) GO TO 50
      IF ((SYTYPE.EQ.7) .AND. (K(NSIZE+1).GT.1)) GO TO 70
C                                       # actual chars
         CALL SPFIL (CH(ITAG), ICSIZE, IACT)
         CALL SPFIL (CH(TAG), NCSIZE, NACT)
         ICSIZE = MIN (ICSIZE, IACT)
         NCSIZE = MIN (NCSIZE, NACT)
C                                       both blank?
         IF ((ICSIZE-IOFF.GE.0) .OR. (NCSIZE-NOFF.GE.0)) GO TO 45
            CALL H2CHR (1, IOFF, CH(ITAG), CT)
            YES = CT.EQ.' '
            IF (YES) THEN
               CALL H2CHR (1, NOFF, CH(TAG), CT)
               YES = CT.EQ.' '
               END IF
            GO TO 999
C                                       compare
 45      CONTINUE
            IF (NCSIZE-NOFF.NE.ICSIZE-IOFF) GO TO 999
            M = ICSIZE - IOFF + 1
            CALL CHCOMP (M, NOFF, CH(TAG), IOFF, CH(ITAG), YES)
            GO TO 999
C                                        TAG scalar, ITAG array
 50   IF ((SYTYPE.EQ.7) .AND. (K(NSIZE+1).GT.1)) GO TO 90
         IF (ICSIZE.LE.0) GO TO 980
         ICWORD = (ICSIZE + 3) / 4
         M = K(ISIZE) / ICWORD
         CALL SPFIL (CH(TAG), NCSIZE, NACT)
         NCSIZE = MIN (NCSIZE, NACT)
C                                       scalar is blank
         IF (NCSIZE-NOFF.GE.0) GO TO 60
            CALL H2CHR (1, NOFF, CH(TAG), CT)
            IF (CT.NE.' ') GO TO 999
            DO 55 J = 1,M
               CALL SPFIL (CH(ITAG), ICSIZE, IACT)
               IF (MIN(ICSIZE,IACT)-IOFF.GE.0) GO TO 999
               CALL H2CHR (1, IOFF, CH(ITAG), CT)
               IF (CT.NE.' ') GO TO 999
               ITAG = ITAG + ICWORD
 55            CONTINUE
            GO TO 970
C                                       scalar not blank
 60      CONTINUE
            NACT = NCSIZE - NOFF + 1
            DO 65 J = 1,M
               CALL SPFIL (C(ITAG), ICSIZE, IACT)
               IACT = MIN (ICSIZE, IACT)
               IF (IACT-IOFF.NE.NCSIZE-NOFF) GO TO 999
               CALL CHCOMP (NACT, IOFF, CH(ITAG), NOFF, CH(TAG), EQUAL)
               IF (.NOT.EQUAL) GO TO 999
               ITAG = ITAG + ICWORD
 65            CONTINUE
            GO TO 970
C                                        ITAG scalar, TAG array
 70   CONTINUE
         IF (NCSIZE.LE.0) GO TO 980
         NCWORD = (NCSIZE+3) / 4
         M = K(NSIZE) / NCWORD
         CALL SPFIL (CH(ITAG), ICSIZE, IACT)
         ICSIZE = MIN (ICSIZE, IACT)
C                                       scalar is blank
         IF (ICSIZE-IOFF.GE.0) GO TO 80
            CALL H2CHR (1, IOFF, CH(ITAG), CT)
            IF (CT.NE.' ') GO TO 999
            DO 75 J = 1,M
               CALL SPFIL (CH(TAG), NCSIZE, NACT)
               IF (MIN(NCSIZE,NACT)-NOFF.GE.0) GO TO 999
               CALL H2CHR (1, NOFF, CH(TAG), CT)
               IF (CT.NE.' ') GO TO 999
               TAG = TAG + NCWORD
 75            CONTINUE
            GO TO 970
C                                       scalar not blank
 80      CONTINUE
            IACT = ICSIZE - IOFF + 1
            DO 85 J = 1,M
               CALL SPFIL (C(TAG), NCSIZE, NACT)
               NACT = MIN (NCSIZE, NACT)
               IF (NACT-NOFF.NE.ICSIZE-IOFF) GO TO 999
               CALL CHCOMP (IACT, IOFF, CH(ITAG), NOFF, CH(TAG), EQUAL)
               IF (.NOT.EQUAL) GO TO 999
               TAG = TAG + NCWORD
 85            CONTINUE
            GO TO 970
C                                       both arrays
 90   CONTINUE
         IF ((NCSIZE.LE.0) .OR. (ICSIZE.LE.0)) GO TO 980
         NCWORD = (NCSIZE+3) / 4
         ICWORD = (ICSIZE + 3) / 4
         NSIZE = K(NSIZE) / NCWORD
         ISIZE = K(ISIZE) / ICWORD
         IF ((NSIZE.LE.0) .OR. (ISIZE.LE.0)) GO TO 980
         IF (ISIZE.NE.NSIZE) GO TO 999
         DO 105 J = 1,NSIZE
            CALL SPFIL (CH(ITAG), ICSIZE, IACT)
            CALL SPFIL (CH(TAG), NCSIZE, NACT)
            NACT = MIN (NCSIZE, NACT)
            IACT = MIN (ICSIZE, IACT)
            IF ((NACT-NOFF.GE.0) .OR. (IACT-IOFF.GE.0)) GO TO 95
               CALL H2CHR (1, IOFF, CH(ITAG), CT)
               EQUAL = CT.EQ.' '
               IF (EQUAL) THEN
                  CALL H2CHR (1, NOFF, CH(TAG), CT)
                  EQUAL = CT.EQ.' '
                  END IF
               GO TO 100
 95         CONTINUE
               IF (NACT-NOFF.NE.IACT-IOFF) GO TO 999
                  M = IACT - IOFF + 1
                  CALL CHCOMP (M, IOFF, CH(ITAG), NOFF, CH(TAG), EQUAL)
 100        IF (.NOT.EQUAL) GO TO 999
               ITAG = ITAG + ICWORD
               TAG  = TAG + NCWORD
 105        CONTINUE
         GO TO 970
C                                       They are equiv
 970  YES = .TRUE.
      GO TO 999
C                                        error return
 980  ERRNUM = POTERR
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
      END

LOCAL INCLUDE 'ACLIP.INC'
C                                       Local include for ACLIP
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   SEQIN, CNOIN, DISKIN, JBUFSZ, LRECC, NBDCOR, NRPRMI,
     *   INCSI, INCFI, INCIFI, FGVERI, FGVERO, LBCHAN, LECHAN, CTYP(4),
     *   INTY, OUTY, NANT, NIF, NPOLN, NPOLI, VISINC, VISMSG,
     *   SCRTCH(512)
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XXCALC, XXSTOK
      CHARACTER NAMEIN*12, CLAIN*6, XCALCO*4, XSOUR(300)*16, REASON*24
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XBCHAN, XECHAN, XBIF, XEIF, XSUBA, XDOCAL, XGUSE, XDOPOL,
     *   XPDVER, XBLVER, XFLAG, XFGOUT, XDOBND, XBPVER, XSMOTH(3),
     *   XANT(50), APARM(10), XBADD(10),
     *   BUFF1(UVBFSS), CMIN(4), CMAX(4)
      LOGICAL   DOUVCM, TESTIT(4), FLAGXX, FLAGP(4,4), DOALL
      INTEGER   NSOU
      COMMON /BUFRS/ BUFF1, JBUFSZ
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XXSOUR, XQUAL,
     *   XXCALC, XXSTOK, XTIME, XBAND, XFREQ, XFQID, XBCHAN, XECHAN,
     *   XBIF, XEIF, XSUBA, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER,
     *   XFLAG, XFGOUT, XDOBND, XBPVER, XSMOTH, XANT, APARM, XBADD
      COMMON /INFO/ FGVERO, NSOU, SEQIN, DISKIN, CNOIN, LRECC, DOUVCM,
     *   NRPRMI, INCSI, INCFI, INCIFI, NBDCOR, LBCHAN, LECHAN, TESTIT,
     *   CMIN, CMAX, CTYP, FLAGXX, INTY, OUTY, FLAGP, NANT, NIF, NPOLN,
     *   DOALL, NPOLI, FGVERI, VISINC, VISMSG, SCRTCH
      COMMON /CHRCOM/ NAMEIN, CLAIN, XCALCO, XSOUR, REASON
      INTEGER   FLGIT(4,4)
      LOGICAL   LFLAG(4,4)
      COMMON /RICKIT/ FLGIT, LFLAG
LOCAL END
      PROGRAM ACLIP
C-----------------------------------------------------------------------
C! Applies calibration and/or editing and flags multisource uv data.
C# task editing UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1999-2007, 2009-2012, 2014-2016, 2019, 2021-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Loops over sources in a multi-source line uv data set applying
C   calibration and editing.  It then compares amplitudes to allowed
C   ranges and makes entries in an FG table for excess values.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input UV data.
C      SOURCES        SOURCS        Source list.
C      QUAL           SELQUA
C      CALCODE        XCALCO
C      TIMERANG       XTIME         Time range of the data to check.
C      SELBAND        SELBAN
C      SELFREQ        SELFRQ
C      FREQID         FRQSEL
C      BCHAN          LBCHAN        Examine LBCHAN-LECHAN
C      ECHAN          LECHAN        Examine LBCHAN-LECHAN
C      BIF            BIF           First IF to copy. 0=>all.
C      EIF            EIF           Highest IF to copy. 0=> highest.
C      SUBARRAY       SUBARR        Subarray number to copy. 0=> all.
C      DOCALIB        DOCAL         If true (>0), calibrate the data.
C      GAINUSE        CLUSE         Version of the Cal. table to use.
C      FLAGVER        FGVER         Version of the FG table to use.
C      DOBAND         DOBAND        If true correct data for bandpass
C      BPVER          BPVER         The BP table to apply
C      BADDISK        IBAD          Disks to avoid for scratch files.
C-----------------------------------------------------------------------
      INCLUDE 'ACLIP.INC'
      INCLUDE 'INCS:DSEL.INC'
C
      CHARACTER PRGM*6
      LOGICAL   DOWANT
      INTEGER   NUMSOU, IRET, I, SULIST(XSTBSZ), MALL(2), MBAD(2),
     *   MSOM(2), NWORDS
      LONGINT   OFFALL, OFFBAD, OFFSOM
C     INTEGER   MALL(MAXANT,4*MAXIF),
C    *   MBAD(MAXANT,4*MAXIF), MSOM(MAXANT,4*MAXIF)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'ACLIP '/
C-----------------------------------------------------------------------
C                                       Get input parameters.
      CALL CLPMIN (PRGM, DOWANT, NUMSOU, SULIST, IRET)
C                                       Allocate memory
      NWORDS = NANT * 4 * NIF
      NWORDS = (NWORDS - 1) / 1024 + 1
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, MALL, OFFALL,
     *   IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, MBAD, OFFBAD,
     *   IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, MSOM, OFFSOM,
     *   IRET)
      IF (IRET.EQ.0) THEN
         NWORDS = 1024 * NWORDS
         CALL FILL (NWORDS, 0, MALL(1+OFFALL))
         CALL FILL (NWORDS, 0, MBAD(1+OFFBAD))
         CALL FILL (NWORDS, 0, MSOM(1+OFFSOM))
         END IF
C                                       Loop over sources.
      IF (IRET.EQ.0) CALL CLPMUV (NANT, 4, NIF, MALL(1+OFFALL),
     *   MBAD(1+OFFBAD), MSOM(1+OFFSOM), DOWANT, NUMSOU, SULIST, IRET)
C                                       report results
      IF (IRET.EQ.0) CALL REPORT (NANT, 4, NIF, MALL(1+OFFALL),
     *   MBAD(1+OFFBAD), MSOM(1+OFFSOM))
C                                       Report deeds to History file
      IF (IRET.EQ.0) CALL CLPMHI
C                                       Done: Close down files, etc.
      CALL ZMEMRY ('FRAL', TSKNAM, NWORDS, MSOM, OFFSOM, I)
C
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE CLPMIN (PRGN, DOWANT, NUMSOU, SULIST, JERR)
C-----------------------------------------------------------------------
C   CLPMIN gets input parameters for ACLIP, finds input file and
C   prepares the list of sources.  All selection criteria except
C   for the source name are filled into the commons in C/DSEL.INC.
C   Inputs:  PRGN    C*6   Program name
C   Output:
C     DOWANT       L    If true sources listed are selected
C     NUMSOU       I    Number of sources to process, 0=>all
C     SULIST(*)    I    Source number list.
C     JERR         I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => cannot start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      LOGICAL   DOWANT
      INTEGER   NUMSOU, SULIST(*), JERR
C
      HOLLERITH CATH(256)
      CHARACTER STAT*4, UTYPE*2, ATIME*8, ADATE*12
      INTEGER   NPARM, IROUND, IERR, I, LUN, TIME(3), DATE(3), NVER,
     *   NUMAN(513), J, JJ
      REAL      CATR(256)
      LOGICAL   MATCH
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ACLIP.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATR, CATBLK, CATH)
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 228
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRTCH, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XXCALC, XCALCO)
      CALL H2CHR (4, 1, XXSTOK, STOKES)
C                                       Sources
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), SOURCS(I))
 20      CONTINUE
C                                       Save the time range
      CALL RCOPY (8, XTIME, TIMRNG)
C                                       BADDISK
      DO 30 I = 1,10
         IBAD(I) = IROUND (XBADD(I))
 30      CONTINUE
C                                       Set flagging reason
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
      REASON = TSKNAM // ADATE // ' ' // ATIME(:5)
C                                       Get CATBLK for input file.
      CNOIN = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       OK, get the header now
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'REST', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1035) IERR
         GO TO 990
         END IF
C                                       OK, file available
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 0
C                                       Save input header
      CALL COPY (256, CATBLK, CATUV)
C                                       Get uv header pointers.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INTY = ICOR0
      NPOLI = CATBLK(KINAX+JLOCS)
      VISINC = CATBLK(KIGCN) / 20
      VISMSG = CATBLK(KIGCN) / 10
      VISINC = MAX (10000, MIN (50000,VISINC))
      VISMSG = (VISMSG / VISINC) * VISINC
      IF (VISMSG.LT.VISINC) VISMSG = 100 * VISINC
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
C                                       Set BCHAN and ECHAN to all
      BCHAN = 1
      ECHAN = CATBLK(KINAX+JLOCF)
C                                       Set examine range differently
      LBCHAN = IROUND (XBCHAN)
      LBCHAN = MAX (BCHAN, MIN (ECHAN, LBCHAN))
      LECHAN = IROUND (XECHAN)
      IF ((LECHAN.LT.LBCHAN) .OR. (LECHAN.GT.ECHAN)) LECHAN = ECHAN
C                                       Check wanted IFs
      IF (JLOCIF.GE.0) THEN
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, CATBLK(KINAX+JLOCIF)))
         EIF = IROUND (XEIF)
         IF (BIF.GT.EIF) EIF = CATBLK(KINAX+JLOCIF)
         EIF = MAX (1, MIN (EIF, CATBLK(KINAX+JLOCIF)))
         DOALL = (BIF.EQ.1) .AND. (EIF.EQ.CATBLK(KINAX+JLOCIF))
      ELSE
         BIF = 1
         EIF = 1
         DOALL = .TRUE.
         END IF
      NIF = EIF - BIF + 1
C                                       Setup calibration choices
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOPOL = IROUND (XDOPOL)
      IF ((DOPOL.EQ.0) .AND. (XDOPOL.GT.0.0)) DOPOL = 1
      PDVER = IROUND (XPDVER)
      BLVER = IROUND (XBLVER)
      DOUVCM = .FALSE.
      DO 40 I = 1,50
         ANTENS(I) = IROUND (XANT(I))
 40      CONTINUE
      IF (STOKES.EQ.' ') THEN
         IF (NCOR.EQ.4) THEN
            STOKES = 'FULL'
         ELSE IF (NCOR.EQ.3) THEN
            STOKES = 'HALF'
         ELSE IF (NCOR.EQ.2) THEN
            STOKES = 'HALF'
         ELSE
            IF (ICOR0.EQ.-1) STOKES = 'RR'
            IF (ICOR0.EQ.-2) STOKES = 'LL'
            IF (ICOR0.EQ.-5) STOKES = 'VV'
            IF (ICOR0.EQ.-6) STOKES = 'HH'
            END IF
      ELSE
         DOALL = .FALSE.
         END IF
      SUBARR = IROUND (XSUBA)
C                                       set flag versions
      CALL FNDEXT ('FG', CATBLK, I)
      FGVER = IROUND (XFLAG)
      IF ((FGVER.EQ.0) .OR. (FGVER.GT.I)) FGVER = I
      FGVERO = IROUND (XFGOUT)
      IF ((FGVERO.LE.0) .OR. (FGVERO.GT.I)) FGVERO = I + 1
      FGVERI = FGVER
      IF (FGVERO.LE.I) FGVERI = -ABS (FGVERI)
C                                       cal parameters
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
C                                       Do only auto-correlations
      DOXCOR = .FALSE.
      DOACOR = .TRUE.
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'No match to SELBAND/SELFREQ adverbs - check inputs'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       Choice of qualifiers and calcode
      SELQUA = IROUND (XQUAL)
      SELCOD = XCALCO
C                                       Get source list
      IUDISK = FVOL(1)
      IUCNO = FCNO(1)
      IXLUN = 28
      CALL SOUFIL (JERR)
      IF (JERR.NE.0) GO TO 999
      DOWANT = DOSWNT
      NUMSOU = NSOUWD
      CALL COPY (30, SOUWAN, SULIST)
C                                       Reset values in /SELCAL/
C                                       Empty names of sources done
      DO 90 I = 1,30
         SOURCS(I) = ' '
         XSOUR(I) = ' '
 90      CONTINUE
      NSOUWD = 0
C                                       Max antenna number
      NANT = MAXANT
      CALL FNDEXT ('AN', CATBLK, NVER)
      IF (NVER.GT.0) THEN
         CALL GETNAN (DISKIN, CNOIN, CATBLK, LUN, SCRTCH, NUMAN, JERR)
         IF ((NVER.GT.0) .AND. (JERR.EQ.0)) THEN
            JJ = NUMAN(1)
            NANT = 0
            DO 80 J = 1,JJ
               NANT = MAX (NANT, NUMAN(J+1))
 80            CONTINUE
            END IF
         END IF
C                                        Default clip levels
      IF (APARM(1).EQ.0.0) APARM(1) = 1.0E6
      IF (APARM(2).EQ.0.0) APARM(2) = 1.0E6
      IF (APARM(3).EQ.0.0) APARM(3) = -1.0E6
      IF (APARM(4).EQ.0.0) APARM(4) = -1.0E6
      IF (APARM(5).LE.0.0) APARM(5) = -1.0E12
      IF (APARM(6).LE.0.0) APARM(6) = 1.0E12
      IF (APARM(7).LT.0.0) APARM(7) = 0.0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLPMIN: error',I3,' obtaining input parameters')
 1030 FORMAT ('Error',I3,' finding ',A12,'.',A6,'.',I4,' disk =',
     *   I3,' user=',I5)
 1035 FORMAT ('Error',I3,' obtaining CATBLK ')
      END
      SUBROUTINE CLPMUV (NA, NP, NI, MALL, MBAD, MSOM, DOWANT, NUMSOU,
     *   SULIST, IRET)
C-----------------------------------------------------------------------
C   CLPMUV uses UVGET to obtain data as single source files and CLPMOP
C   to loop through a source at a time to check for bad data
C   Input:
C      NA       I      Number of antennas
C      NP       I      Number of polarizations
C      NI       I      Number of IFs
C      DOWANT   L      If true sources listed are selected
C      NUMSOU   I      Number of sources to process, 0=>all
C      SULIST   I(*)   Source number list.
C   Output:
C      MALL     I(*)   Counts samples by baseline etc
C      MBAD     I(*)   Counts full bad spectra by baseline
C      MSOM     I(*)   Counts partly bad spectra by baseline
C      IRET     I      Return code, 0 => OK, otherwise abort.
C   Auxiliary:
C     FGVERO    I      Version number of new flag table (reset later)
C-----------------------------------------------------------------------
      LOGICAL   DOWANT
      INTEGER   NA, NP, NI, MALL(NA,NP,NI), MBAD(NA,NP,NI),
     *   MSOM(NA,NP,NI), NUMSOU, SULIST(*), IRET
C
      INCLUDE 'ACLIP.INC'
      CHARACTER VELTYP*8, VELDEF*8, CALCOD*4
      LOGICAL   DOAVG, DOAPPT, NOSUB, SINGLE, TABLE, EXIST, FITASC,
     *   FIRST, SAVCAL
      INTEGER   NUMVIS, SOUCUR, MAXSOU, SLOOP, DPOSAV, LRECU, NRPRIN,
     *   IERR, SUKOLS(MAXSUC), SUNUMV(MAXSUC), SBUFF(512), I, SLUN,
     *   IDSOU, QUAL, INOGRP, SUB, NUMSUB, LIMS1, LIMS2, SUBTMP, SAVBND,
     *   SUFQID, INCX, ICOR, IROUND, J
      REAL      RPARM(20), VIS(20), CATR(256), OLDRP, TEMP
      DOUBLE PRECISION  BANDW, RAEPO, DECEPO, EPOCH, RAAPP, DECAPP,
     *   RAOBS, DECOBS, PMRA, PMDEC, CATD(128), OLDFRQ
      DOUBLE PRECISION   LSRVEL(MAXIF), FREQO(MAXIF), RESTFQ(MAXIF)
      REAL     FLUX(4,MAXIF)
      HOLLERITH CATH(256)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATBLK, CATH, CATR, CATD)
C-----------------------------------------------------------------------
      DOAPPT = DOAPPL
      DOAVG = .FALSE.
      NOSUB = .FALSE.
      OLDRP = CATR(KRCRP+JLOCF)
      FIRST = .TRUE.
C                                       Zero visibility count
      NUMVIS = 0
C                                       Zero number of processed sources
      NSOU = 0
C                                       Get input reference frequency
      OLDFRQ = CATD(KDCRV+JLOCF)
C                                       Find number of subarrays
      CALL FNDEXT ('AN', CATUV, NUMSUB)
      NUMSUB = MAX (1, NUMSUB)
      SUBARR = MIN (SUBARR, NUMSUB)
      IF (SUBARR.GT.0) THEN
         LIMS1 = SUBARR
         LIMS2 = SUBARR
      ELSE
         LIMS1 = 1
         LIMS2 = NUMSUB
         END IF
      SUBTMP = SUBARR
C                                       Check if single source file
      SLUN = 27
      CALL MULSDB (CATUV, SINGLE)
      IF (SINGLE) THEN
         CALL ISTAB ('SU', FVOL(1), FCNO(1), 1, SLUN, SBUFF, TABLE,
     *      EXIST, FITASC, IERR)
         SINGLE = EXIST .AND. TABLE .AND. (IERR.EQ.0)
         END IF
      SINGLE = .NOT.SINGLE
C                                       Allow single-source now
      IF (SINGLE) THEN
         IDSOU = 1
         CALL H2CHR (8, 1, CATH(KHOBJ), SOURCS(1))
         MAXSOU = 1
C                                       Open source table
      ELSE
         CALL SOUINI ('READ', SBUFF, FVOL(1), FCNO(1), 1, CATUV, SLUN,
     *      INOGRP, VELTYP, VELDEF, SUFQID, SOUCUR, SUKOLS, SUNUMV,
     *      IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'Error opening the source table'
            GO TO 990
            END IF
C                                       Report number of sources
         MAXSOU = SBUFF(5)
         WRITE (MSGTXT,1000) MAXSOU
         CALL MSGWRT (2)
         END IF
C                                       Loop here over sources
      DO 200 SLOOP = 1,MAXSOU
C                                       Save SLOOP from TABSOU
         SOUCUR = SLOOP
C                                       Read source table
         IF (.NOT.SINGLE) THEN
            CALL TABSOU ('READ', SBUFF, SOUCUR, SUKOLS, SUNUMV, IDSOU,
     *         SOURCS, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *         EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ,
     *         PMRA, PMDEC, IRET)
            IF (IRET.NE.0) THEN
               MSGTXT = 'Error reading the source table'
               GO TO 990
               END IF
C                                       Restore SOUCUR
            SOUCUR = SLOOP
C                                       See if this source is wanted.
            IF (NUMSOU.GT.0) THEN
               DO 110 I = 1,NUMSOU
                  IF (IDSOU.EQ.SULIST(I)) THEN
                     IF (DOWANT) GO TO 120
                     GO TO 200
                     END IF
 110              CONTINUE
               IF (DOWANT) GO TO 200
               END IF
            END IF
C                                       Setup header for calibrated
C                                       single-source file, save input
C                                       header
 120     SUBARR = SUBTMP
         DPOSAV = DOPOL
         DOPOL = 0
         SAVBND = DOBAND
         DOBAND = 0
         SAVCAL = DOCAL
         DOCAL = .FALSE.
C                                       is there any subarray with
C                                       data for this source?
         DO 125 SUB = LIMS1,LIMS2
            SUBARR = SUB
            MSGSUP = 31000
            CALL UVGET ('INIT', RPARM, VIS, IERR)
            MSGSUP = 0
            IF (IERR.GT.0) GO TO 190
            IF (IERR.EQ.0) GO TO 126
            CALL UVGET ('CLOS', RPARM, VIS, IERR)
 125        CONTINUE
         WRITE (MSGTXT,1125) IDSOU, SOURCS(1)
         CALL MSGWRT (6)
         IERR = 0
         GO TO 200
C                                       Initialize reading data
C                                       Report source it is working on
 126     WRITE (MSGTXT,1126) IDSOU, SOURCS(1)
         CALL MSGWRT (2)
C                                       Save this source name
         NSOU = NSOU + 1
         XSOUR(NSOU) = SOURCS(1)
C                                       Initialize single-source header
         OUTY = ICOR0
         DOPOL = DPOSAV
         DOAPPL = .FALSE.
         DOBAND = SAVBND
         DOCAL = SAVCAL
         CLVER = CLUSE
C                                       For all stokes correlators
         IF (FIRST) THEN
            FLAGXX = .TRUE.
            IF (APARM(8).GT.0.0) FLAGXX = .FALSE.
            NPOLN = NCOR
            CALL FILL (16, 0, FLGIT)
            DO 130 I = 1,NPOLN
               TEMP = CATD(KDCRV+JLOCS) + (I-CATR(KRCRP+JLOCS)) *
     *            CATR(KRCIC+JLOCS)
               ICOR = IROUND (TEMP)
               CTYP(I) = 0
C                                       Stokes type, I
               IF (ICOR.EQ.1) THEN
                  CTYP(I) = 1
                  FLGIT(1,I) = 1
                  IF (INTY.LT.0) FLGIT(2,I) = 1
                  IF (FLAGXX) CALL FILL (3, 1, FLGIT(2,I))
C                                       Stokes type, Q, U
               ELSE IF ((ICOR.GE.2) .AND. (ICOR.LE.3)) THEN
                  CTYP(I) = 2
                  IF (INTY.GT.0) THEN
                     FLGIT(ICOR,I) = 1
                  ELSE
                     FLGIT(3,I) = 1
                     FLGIT(4,I) = 1
                     END IF
C                                       Stokes V
               ELSE IF (ICOR.EQ.4) THEN
                  CTYP(2) = 2
                  IF (INTY.GT.0) THEN
                     FLGIT(ICOR,I) = 1
                  ELSE
                     FLGIT(1,I) = 1
                     FLGIT(2,I) = 1
                     END IF
C                                       Stokes type  RR or LL
               ELSE IF ((ICOR.EQ.-1) .OR. (ICOR.EQ.-2)) THEN
                  CTYP(I) = 1
                  IF (INTY.GT.0) THEN
                     FLGIT(1,I) = 1
                     FLGIT(4,I) = 1
                  ELSE
                     FLGIT(-ICOR,I) = 1
                     IF (FLAGXX) CALL FILL (2, 1, FLGIT(3,I))
                     END IF
C                                       Stokes type  RL or LR
               ELSE IF ((ICOR.EQ.-3) .OR. (ICOR.EQ.-4)) THEN
                  CTYP(I) = 2
                  IF (INTY.GT.0) THEN
                     FLGIT(2,I) = 1
                     FLGIT(3,I) = 1
                  ELSE
                     FLGIT(-ICOR,I) = 1
                     END IF
C                                       Stokes type  VV or HH
               ELSE IF ((ICOR.EQ.-5) .OR. (ICOR.EQ.-6)) THEN
                  CTYP(I) = 1
                  IF (INTY.GT.0) THEN
                     FLGIT(1,I) = 1
                     FLGIT(4,I) = 1
                  ELSE
                     FLGIT(-ICOR-4,I) = 1
                     IF (FLAGXX) CALL FILL (2, 1, FLGIT(3,I))
                     END IF
C                                       Stokes type  VH or HV
               ELSE IF ((ICOR.EQ.-7) .OR. (ICOR.EQ.-8)) THEN
                  CTYP(I) = 2
                  IF (INTY.GT.0) THEN
                     FLGIT(2,I) = 1
                     FLGIT(3,I) = 1
                  ELSE
                     FLGIT(-ICOR-4,I) = 1
                     END IF
                  END IF
               CMAX(I) = 1.E6
               IF (CTYP(I).NE.0) CMAX(I) = APARM(CTYP(I))
               CMIN(I) = -1.E6
               IF (CTYP(I).NE.0) CMIN(I) = APARM(CTYP(I)+2)
               TESTIT(I) = (CMIN(I).GT.-1.E6) .OR. (CMAX(I).LT.1.E6)
     *            .OR. (APARM(5).GT.0.0) .OR. (APARM(6).LT.1.E12)
 130           CONTINUE
            DO 136 J = 1,4
               DO 135 I = 1,4
                  LFLAG(I,J) = FLGIT(I,J).NE.0
 135              CONTINUE
 136           CONTINUE
            FIRST = .FALSE.
            END IF
C                                       Close again - only need header
C                                       for sum of subarrays.
         CALL UVGET ('CLOS', RPARM, VIS, IERR)
         IF (IERR.GT.0) GO TO 190
C                                       Get values of data increments
         INCX = CATBLK(KINAX)
         NRPRMI = NRPARM
         INCSI = INCS / INCX
         INCFI = INCF / INCX
         INCIFI = INCIF / INCX
C                                       Make sure there is data
         IF (CATBLK(KIGCN).LE.0) GO TO 190
C                                       Loop over subarrays.
         DO 150 SUB = LIMS1, LIMS2
            SUBARR = SUB
C                                       Initialize reading data
            CALL UVGET ('INIT', RPARM, VIS, IERR)
            IF (IERR.GT.0) GO TO 190
            IF (IERR.EQ.0) THEN
               LRECU = LREC
               NRPRIN = NRPARM
C                                       Loop through data
               CALL CLPMOP (NUMVIS, NA, NP, NI, MALL, MBAD, MSOM, LRECU,
     *            NRPRIN, FVOL(1), FCNO(1), IDSOU, IERR)
               IF (IERR.NE.0) GO TO 190
            ELSE
               CALL UVGET ('CLOS', RPARM, VIS, IERR)
               END IF
            IERR = 0
 150        CONTINUE
         GO TO 200
C                                       Error, close input then die
 190     CALL UVGET ('CLOS', RPARM, VIS, IERR)
         MSGTXT = 'PROBLEM WITH SOURCE: ' // SOURCS(1)
         IRET = 1
         GO TO 990
C
 200     CONTINUE
C                                       Last call to CLPMOP
      CALL CLPMOP (-1, NA, NP, NI, MALL, MBAD, MSOM, LRECU, NRPRIN,
     *   FVOL(1), FCNO(1), IDSOU, IERR)
C                                       Close source table
      IF (.NOT.SINGLE) CALL TABIO ('CLOS', 1, SOUCUR, SBUFF, SBUFF,
     *   IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (1X, I3, ' sources in this file')
 1125 FORMAT ('No data for source number', I3,' name ',A)
 1126 FORMAT ('Working on source number', I3,' name ',A)
      END
      SUBROUTINE CLPMOP (NUMVIS, NA, NP, NI, MALL, MBAD, MSOM, LRECU,
     *   NRPRIN, INDISK, INNUM, IDSOUR, IRET)
C-----------------------------------------------------------------------
C   CLPMOP calls CLIPF to do clipping and raise the flags which are
C   entered upon return from CLIPF
C   Input:
C      NUMVIS   I      Number of visibilities previously processed
C      NA       I      Number of antennas
C      NP       I      Number of polarizations
C      NI       I      Number of IFs
C      LRECU    I      length of uncompressed vis record
C      NRPRIN   I      # random parms in uncompressed vis record
C   Input from common:
C      INCF     I      Increment in freq. of data from UVGET
C      INCIF    I      Increment in IF of data from UVGET
C      INCS     I      Increment in Stokes of data from UVGET
C      JLOCF    I      Offset of freq. of data from UVGET
C      JLOCIF   I      Offset of IF of data from UVGET
C      JLOCS    I      Offset of Stokes of data from UVGET
C   Output:
C      MALL     I(*)   Counts samples by baseline etc
C      MBAD     I(*)   Counts full bad spectra by baseline
C      MSOM     I(*)   Counts partly bad spectra by baseline
C      IRET     I      Return error code, 0=>OK, otherwise error.
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, NA, NP, NI, MALL(NA,NP,NI), MBAD(NA,NP,NI),
     *   MSOM(NA,NP,NI), LRECU, NRPRIN, INDISK, INNUM, IDSOUR, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   FLGKEY(MAXCIF), VCOUNT, LUN, NOPOL, I, JNCIF, JNCS, J,
     *   K, NUMFRQ, LRECO, LENBU, IA1, IA2, INCX, INNUMS, FGBUFL(512),
     *   LFGRNO, JJ, L, JB, JE, IB0, IB1, JX
      LOGICAL   PFLAGS(4), GOODDT, FLAGED, FLAGDO, GOODC(4), BADC(4),
     *   DOSOME
      REAL      CATR(256), BASEN, BTIME, ETIME
      DOUBLE PRECISION CATD(128)
      INCLUDE 'ACLIP.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      EQUIVALENCE (CATBLK, CATR, CATD)
      COMMON /FLAGS/ FLGKEY
      DATA LUN /48/
C-----------------------------------------------------------------------
      IRET = 0
      VCOUNT = 0
      FLAGED = .FALSE.
      INNUMS = INNUM
C                                       If done, just return
      IF (NUMVIS.EQ.-1) GO TO 999
C                                       Set output increments
      JNCIF = INCIF
      JNCS = INCS
C                                       Set lengths of input axes.
      NUMFRQ = ECHAN - BCHAN + 1
      NUMIF = 1
      IF (JLOCIF.GT.0) NUMIF = CATBLK(KINAX+JLOCIF)
      NOPOL = CATBLK(KINAX+JLOCS)
      LRECO = LRECU
      LENBU = 1
      INCX = CATBLK(KINAX)
C                                       Loop through data
      DO 100 I = 1,NVIS
C                                       Get a record
         CALL UVGET ('READ', BUFF1, BUFF1(1+NRPRIN), IRET)
C                                       Escape loop if no more data
C                                       for this source (IRET = -1)
         IF (IRET.EQ.-1) GO TO 110
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT, 1000) IRET, I
            GO TO 990
            END IF
         VCOUNT = VCOUNT + 1
C                                       Call CLIPF now
         IF (ILOCB.GE.0) THEN
            BASEN = BUFF1(1+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
         ELSE
            IA1 = BUFF1(1+ILOCA1) + 0.1
            IA2 = BUFF1(1+ILOCA2) + 0.1
            END IF
C                                      Working on visibility number
C                                      NUMVIS
         NUMVIS = NUMVIS + 1
C                                      Call filtering routine
         CALL CLIPF (NUMVIS, IA1, NA, NP, NI, MALL, MBAD, MSOM,
     *      BUFF1(1+NRPRIN), INCX, IRET)
C                                       See if flagging is necessary
         FLAGDO = .FALSE.
         JJ = ECHAN * NUMIF * NOPOL
         DO 10 J = 1,JJ
            IF (FLGKEY(J).LT.0) FLAGDO = .TRUE.
 10         CONTINUE
C                                       Need to flag, set it as true
         IF (FLAGDO) THEN
            FLAGED = .TRUE.
C                                       Get the time, set interval
            BTIME = BUFF1(1+ILOCT) - 1.E-6
            ETIME = BUFF1(1+ILOCT) + 1.E-6
C                                       Now set flagging
            GOODDT = .FALSE.
            DO 20 J = 1,JJ
               IF (FLGKEY(J).GT.0) GOODDT = .TRUE.
 20            CONTINUE
C                                       No good data, flag whole record
            IF ((.NOT.GOODDT) .AND. (DOALL)) THEN
               CALL LFILL (4, .TRUE., PFLAGS)
               CALL FLAGIT ('FLAG', LUN, INDISK, INNUM, FGVERI, FGVERO,
     *            LFGRNO, FGKOLS, FGNUMV, IDSOUR, SUBARR, FRQSEL, IA1,
     *            IA2, BTIME, ETIME, 1, 0, 1, 0, PFLAGS, REASON,
     *            APARM(10), CATUV, FGBUFL, IRET)
               IF (IRET.NE.0) GO TO 80
C                                       There are some good ones
            ELSE
               DO 70 J = 1,NUMIF
                  JX = J + BIF - 1
                  FLAGDO = .FALSE.
                  GOODDT = .FALSE.
                  DOSOME = .FALSE.
                  DO 35 K = 1,NOPOL
                     GOODC(K) = .FALSE.
                     BADC(K) = .FALSE.
                     JJ = ECHAN * NOPOL * (J-1) + ECHAN * (K-1)
                     DO 25 L = 1,ECHAN
                        IF (FLGKEY(JJ+L).GT.0) GOODC(K) = .TRUE.
                        IF (FLGKEY(JJ+L).LT.0) BADC(K) = .TRUE.
                        IF ((GOODC(K)) .AND. (BADC(K))) GO TO 30
 25                     CONTINUE
 30                  IF (BADC(K)) FLAGDO = .TRUE.
                     IF (GOODC(K)) GOODDT = .TRUE.
                     PFLAGS(K) = .NOT.GOODC(K)
                     DOSOME = DOSOME .OR. PFLAGS(K)
 35                  CONTINUE
C                                       SOME bad this IF
                  IF (FLAGDO) THEN
                     DO 60 K = 1,NOPOL
C                                       all bad corr
                        IF ((BADC(K)) .AND. (.NOT.GOODC(K))) THEN
                           CALL LCOPY (4, LFLAG(1,K), PFLAGS)
                           CALL FLAGIT ('FLAG', LUN, INDISK, INNUM,
     *                        FGVERI, FGVERO, LFGRNO, FGKOLS, FGNUMV,
     *                        IDSOUR, SUBARR, FRQSEL, IA1, IA2, BTIME,
     *                        ETIME, JX, JX, 1, 0, PFLAGS, REASON,
     *                        APARM(10), CATUV, FGBUFL, IRET)
                           IF (IRET.NE.0) GO TO 80
C                                       some were bad
                        ELSE IF ((GOODC(K)) .AND. (BADC(K))) THEN
                           CALL LCOPY (4, LFLAG(1,K), PFLAGS)
                           JE = 0
 40                        JB = JE + 1
                           IF (JB.LE.ECHAN) THEN
                              IB0 = 1000000
                              IB1 = 1000000
                              JE = 0
                              JJ = ECHAN * (NOPOL * (J-1) + (K-1))
                              DO 45 L = JB,ECHAN
                                 IF (FLGKEY(JJ+L).EQ.0) THEN
                                    IB0 = MIN (IB0, L)
                                    JE = L
                                 ELSE IF (FLGKEY(JJ+L).LT.0) THEN
                                    IB0 = MIN (IB0, L)
                                    IB1 = MIN (IB1, L)
                                    JE = L
                                 ELSE
                                    IF (IB1.LT.ECHAN) GO TO 50
                                    IB0 = 1000000
                                    END IF
 45                              CONTINUE
 50                           IF (IB1.LE.JE) THEN
                                 JB = IB0
                                 CALL FLAGIT ('FLAG', LUN, INDISK,
     *                              INNUM, FGVERI, FGVERO, LFGRNO,
     *                              FGKOLS, FGNUMV, IDSOUR, SUBARR,
     *                              FRQSEL, IA1, IA2, BTIME, ETIME, JX,
     *                              JX, JB, JE, PFLAGS, REASON,
     *                              APARM(10), CATUV, FGBUFL, IRET)
                                 IF (IRET.NE.0) GO TO 80
                                 GO TO 40
                                 END IF
                              END IF
                           END IF
 60                     CONTINUE
                     END IF
 70               CONTINUE
               END IF
C                                       Report flagging problems
 80         IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1080) IRET
               GO TO 990
               END IF
            END IF
 100     CONTINUE
C
 110  WRITE (MSGTXT,1110) VCOUNT
      CALL MSGWRT (2)
      IRET = 0
C                                       Close the flagging table if used
      IF (FLAGED) CALL FLAGIT ('CLOS', LUN, INDISK, INNUM, FGVERI,
     *   FGVERO, LFGRNO, FGKOLS, FGNUMV, IDSOUR, SUBARR, FRQSEL, IA1,
     *   IA2, BTIME, ETIME, J, J, 1, 0, PFLAGS, REASON, APARM(10),
     *   CATUV, FGBUFL, IRET)
C                                       Close input file
      CALL UVGET ('CLOS', BUFF1, BUFF1(1+NRPRIN), IRET)
C                                       Restore INNUM
      INNUM = INNUMS
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLPMOP: Error obtaining data',I3,' VIS NUM',I10)
 1080 FORMAT ('CLPMOP: Error flagging', I3)
 1110 FORMAT (I10,' visibilities processed for this source')
      END
      SUBROUTINE REPORT (NA, NP, NI, MALL, MBAD, MSOM)
C-----------------------------------------------------------------------
C   Print the reports
C   Inputs:
C      NA      I      Number of antennas
C      NP      I      Number of polarizations
C      NI      I      Number of IFs
C      MALL    I(*)   Counts samples by baseline etc
C      MBAD    I(*)   Counts full bad spectra by baseline
C      MSOM    I(*)   Counts partly bad spectra by baseline
C-----------------------------------------------------------------------
      INTEGER   NA, NP, NI, MALL(NA,NP,NI), MBAD(NA,NP,NI),
     *   MSOM(NA,NP,NI)
C
      INTEGER   I, J, K, L, TOTALA, TOTALB, MMAX, MXA, I1, I2, TOTALS
      INCLUDE 'ACLIP.INC'
      INCLUDE 'INCS:DSEL.INC'
      INTEGER   MAUX(MAXANT)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       First add the totals
      DO 90 L = 1,NI
         DO 80 K = 1,NPOLI
            TOTALA = 0
            TOTALB = 0
            TOTALS = 0
            MMAX = 0
            MXA = 0
            DO 20 I = 1,NA
               IF (MALL(I,K,L).GT.0) THEN
                  MXA = MAX (MXA, I)
                  TOTALA = TOTALA + MALL(I,K,L)
                  IF (MALL(I,K,L).GT.MMAX) MMAX = MALL(I,K,L)
                  END IF
               TOTALB = TOTALB + MBAD(I,K,L)
               TOTALS = TOTALS + MSOM(I,K,L)
 20            CONTINUE
C                                       Now report on all visibilities
            IF ((TOTALA.GT.0) .AND. (TOTALB+TOTALS.GT.0)) THEN
               I = L + BIF - 1
               IF (ECHAN.LE.0) THEN
                  WRITE (MSGTXT,1020) TOTALB, TOTALA, K, I
                  CALL MSGWRT (4)
               ELSE
                  WRITE (MSGTXT,1021) TOTALB, TOTALA, K, I
                  CALL MSGWRT (4)
                  WRITE (MSGTXT,1022) TOTALS, TOTALA, K, I
                  CALL MSGWRT (4)
                  END IF
               WRITE (MSGTXT,1025) MMAX
               CALL MSGWRT (4)
               I1 = 1
 25            I2 = MIN (I1+30, MXA)
               IF (I2.GE.I1) THEN
                  DO 30 J= I1,I2
                     MAUX(J) = NINT ((10. * MALL(J,K,L)) / MMAX)
 30                  CONTINUE
                  WRITE (MSGTXT,1035) (MAUX(J), J = I1,I2)
                  CALL MSGWRT (4)
                  I1 = I2 + 1
                  GO TO 25
                  END IF
               END IF
C                                       Now report percentage flagged
            IF ((TOTALA.GT.0) .AND. (TOTALB.GT.0)) THEN
               MSGTXT = 'Visibilities flagged (percent):'
               IF (ECHAN.GT.1) MSGTXT = 'Visibility spectra fully'
     *            // ' flagged (percent):'
               CALL MSGWRT (4)
               I1 = 1
 45            I2 = MIN (I1+30, MXA)
               IF (I2.GE.I1) THEN
                  DO 50 J = I1,I2
                     MAUX(J) = 0
                     IF (MALL(J,K,L).GT.0) THEN
                        MAUX(J) = NINT ((100. * MBAD(J,K,L)) /
     *                     MALL(J,K,L))
                     ELSE
                        MAUX(J) = 0
                        END IF
 50                  CONTINUE
                  WRITE (MSGTXT,1035) (MAUX(J), J = I1,I2)
                  CALL MSGWRT (4)
                  I1 = I2 + 1
                  GO TO 45
                  END IF
               END IF
            IF ((TOTALA.GT.0) .AND. (TOTALS.GT.0)) THEN
               MSGTXT = 'Visibility spectra partly flagged (percent):'
               CALL MSGWRT (4)
               I1 = 1
 65            I2 = MIN (I1+30, MXA)
               IF (I2.GE.I1) THEN
                  DO 70 J = I1,I2
                     MAUX(J) = 0
                     IF (MALL(J,K,L).GT.0) THEN
                        MAUX(J) = NINT ((100. * MSOM(J,K,L)) /
     *                     MALL(J,K,L))
                     ELSE
                        MAUX(J) = 0
                        END IF
 70                  CONTINUE
                  WRITE (MSGTXT,1035) (MAUX(J), J = I1,I2)
                  CALL MSGWRT (4)
                  I1 = I2 + 1
                  GO TO 65
                  END IF
               END IF
 80         CONTINUE
 90      CONTINUE
C                                       Report flagged correlators
      WRITE (MSGTXT,1090) NBDCOR
      CALL MSGWRT (4)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('Flagged',I8,' of',I10,' correlators for corr,IF',I2,I3)
 1021 FORMAT ('Fully flagged ',I8,' of',I10,' spectra for corr,IF',
     *   I2,I3)
 1022 FORMAT ('Partly flagged',I8,' of',I10,' spectra for corr,IF',
     *   I2,I3)
 1025 FORMAT ('Visibilities per baseline (tens of percent of', I9 ,'):')
 1035 FORMAT (1X,31(I2))
 1090 FORMAT ('Flagged',I10,' correlators')
      END
      SUBROUTINE CLPMHI
C-----------------------------------------------------------------------
C   CLPMHI appends to the history file.
C-----------------------------------------------------------------------
      CHARACTER ATIME*8, ADATE*12, HILINE*72
      INTEGER   LUN, IERR, TIME(3), DATE(3), HBUFF(256), I
      INCLUDE 'ACLIP.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA LUN /28/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN, DISKIN, CNOIN, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
      WRITE (HILINE,1000) TSKNAM, ADATE, ATIME
      CALL HIADD (LUN, HILINE, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       cal adverbs
      CALL CALHIS (LUN, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Flag table out
      WRITE (HILINE,1113) TSKNAM, FGVERO
      CALL HIADD (LUN, HILINE, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Range of parallel
      IF ((APARM(1).LT.1.E6) .OR. (APARM(3).GT.-1.E6)) THEN
         WRITE (HILINE,1120) TSKNAM, 'P', APARM(3), APARM(1), 'parallel'
         CALL HIADD (LUN, HILINE, HBUFF, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      IF ((APARM(2).LT.1.E6) .OR. (APARM(4).GT.-1.E6)) THEN
         WRITE (HILINE,1120) TSKNAM, 'C', APARM(4), APARM(2), 'crossed'
         CALL HIADD (LUN, HILINE, HBUFF, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      IF (APARM(5).GT.0.0) THEN
         WRITE (HILINE,1121) TSKNAM, APARM(5)
         CALL HIADD (LUN, HILINE, HBUFF, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      IF (APARM(6).LT.1.E12) THEN
         WRITE (HILINE,1122) TSKNAM, APARM(6)
         CALL HIADD (LUN, HILINE, HBUFF, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      I = APARM(7) + 0.1
      IF (I.GT.0) THEN
         WRITE (HILINE,1123) TSKNAM, I
         CALL HIADD (LUN, HILINE, HBUFF, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
C                                      Number of flagged correlators
      WRITE (HILINE,1125) TSKNAM, NBDCOR
      CALL HIADD (LUN, HILINE, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Close HI file
 900  CALL HICLOS (LUN, .TRUE., HBUFF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'/********* Start ',A12,2X,A8)
 1113 FORMAT (A6,'FLAGVERO =',I4,' / Flagging table written')
 1120 FORMAT (A6,A1,'RANGE=',2(1PE14.6),' / range of okay',A,'-hand')
 1121 FORMAT (A6,'WTMIN=',1PE14.6,' / weights below WTMIN were flagged')
 1122 FORMAT (A6,'WTMAX=',1PE14.6,' / weights above WTMAX were flagged')
 1123 FORMAT (A6,'EXTEND=',I3,'   / flags extended +- in channels')
 1125 FORMAT (A6,'/ Correlators flagged:', I8)
      END
      SUBROUTINE CLIPF (NUMVIS, IA1, NA, NP, NI, MALL, MBAD, MSOM, VIS,
     *   INCX, IRET)
C-----------------------------------------------------------------------
C   Routine to examine data for bad amplitudes and weights.
C   Inputs:
C      NUMVIS   I        Visibility number
C      IA1      I        First antenna number
C      NA       I        Number of antennas
C      NP       I        Number of polarizations
C      NI       I        Number of IFs
C      VIS      R(INCX,*)  Visibilities in order real, imaginary, weight
C                        (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                        NOTE: INCX may be any value .GE. 2
C   Inputs from COMMON:
C      BCHAN    I        Lowest channel number.
C      ECHAN    I        Highest channel number.
C      INCSI    I        Input Stokes increment in vis.
C      INCFI    I        Input frequency increment in vis.
C      INCIFI   I        Input IF increment in vis.
C      CATBLK   I        Catalog header block
C   Output:
C      MALL     I(*)     Counts samples by baseline etc
C      MBAD     I(*)     Counts full bad spectra by baseline
C      MSOM     I(*)     Counts partly bad spectra by baseline
C      FLGKEY   I(*)     Flagging decisions
C      IRET     I        Return code   0 => OK
C   Auxiliary variables for info
C      MALL     I        Nant x Nant x 4*Nif matrix for IF1 with all
C                        visibilities
C      MBAD     I        Nant x Nant x 4*Nif matrix for IF1 with all
C                        visibilities
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IA1, NA, NP, NI, MALL(NA,NP,NI), MBAD(NA,NP,NI),
     *   MSOM(NA,NP,NI), INCX, IRET
      REAL      VIS(INCX,*)
C
      INCLUDE 'ACLIP.INC'
      INTEGER   CINDEX, FLGKEY(MAXCIF), LOOP, INDEX, OFF, IS, IIF, I,
     *   NFLAG, NCL, NGOOD, NBAD, JS, LS, APARM7, LL1, LL2
      REAL      AMP
      LOGICAL   GOODDT(4,MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      COMMON /FLAGS/ FLGKEY
      SAVE NCL
C-----------------------------------------------------------------------
C                                       Set up on first call
      APARM7 = APARM(7) + 0.1
      IF (NUMVIS.EQ.1) THEN
         NBDCOR = 0
C                                       Zero channel info array
         IF (APARM(9).GT.0.0) THEN
            NCL = APARM(9) + 0.5
            NCL = MAX (1, NCL)
         ELSE
            NCL = -1
            END IF
         END IF
C                                       process data
      IRET = 0
      IF (NUMVIS.GT.0) THEN
         IF (MOD(NUMVIS-1,VISMSG).EQ.0) THEN
            WRITE (MSGTXT,1000) NUMVIS
            CALL MSGWRT (2)
         ELSE IF (MOD(NUMVIS-1,VISINC).EQ.0) THEN
            WRITE (MSGTXT,1000) NUMVIS
            CALL MSGWRT (1)
            END IF
         I = NPOLN * NIF * ECHAN
         CALL FILL (I, 0, FLGKEY)
C                                       Mark good correlators
         DO 20 IIF = 1,NIF
            DO 15 IS = 1,NPOLN
               GOODDT(IS,IIF) = .FALSE.
C                                       Offset in Stokes and IF
               OFF = (IS - 1) * INCSI + (IIF - 1) * INCIFI
C                                       Set index for info counters
               CINDEX = ECHAN * NPOLN * (IIF - 1) + ECHAN * (IS - 1)
C                                       Index for this channel, IF
               INDEX = OFF + 1
C                                       Check data
               DO 10 LOOP = BCHAN,ECHAN
                  IF (VIS(3,INDEX).GT.0.0) THEN
                     FLGKEY(CINDEX+LOOP) = 1
                     GOODDT(IS,IIF) = .TRUE.
                     END IF
                  INDEX = INDEX + INCFI
 10               CONTINUE
 15            CONTINUE
 20         CONTINUE
C                                       Now check amplitudes
         DO 40 IIF = 1,NIF
            DO 35 IS = 1,NPOLN
               NFLAG = 0
               IF (TESTIT(IS)) THEN
C                                       Offset in Stokes and IF
                  OFF = (IS - 1) * INCSI + (IIF - 1) * INCIFI
C                                       Set index for info counters
                  CINDEX = ECHAN * NPOLN * (IIF - 1) + ECHAN * (IS - 1)
C                                       Index for this channel, IF
                  INDEX = OFF + 1 + INCFI * (LBCHAN-BCHAN)
C                                       Check data
                  DO 30 LOOP = LBCHAN,LECHAN
                     IF (VIS(3,INDEX).GT.0.0) THEN
                        IF (CTYP(IS).EQ.1) THEN
                           AMP = VIS(1,INDEX)
                        ELSE
                           AMP = SQRT (VIS(1,INDEX)**2 +
     *                        VIS(2,INDEX)**2)
                           END IF
                        IF ((AMP.LT.CMIN(IS)) .OR. (AMP.GT.CMAX(IS))
     *                     .OR. (VIS(3,INDEX).LT.APARM(5)) .OR.
     *                     (VIS(3,INDEX).GT.APARM(6))) THEN
                           LL1 = MAX (LOOP-APARM7, BCHAN)
                           LL2 = MIN (LOOP+APARM7, ECHAN)
                           LL2 = LL2 - LL1 + 1
                           CALL FILL (LL2, -1, FLGKEY(CINDEX+LL1))
                           NFLAG = NFLAG + 1
                           END IF
                        END IF
                     INDEX = INDEX + INCFI
 30                  CONTINUE
                  IF ((NCL.GT.0) .AND. (NFLAG.GE.NCL)) CALL FILL (ECHAN,
     *               -1, FLGKEY(CINDEX+1))
                  END IF
 35            CONTINUE
 40         CONTINUE
C                                       Now cross check
         IF (APARM(8).LE.0.0) THEN
            DO 60 IIF = 1,NIF
               DO 55 IS = 1,NPOLN
                  IF ((TESTIT(IS)) .AND. (CTYP(IS).EQ.1)) THEN
C                                       Set index for info counters
                     CINDEX = ECHAN * NPOLN * (IIF - 1) +
     *                  ECHAN * (IS - 1)
                     DO 50 JS = 1,NPOLN
                        IF (CTYP(JS).EQ.2) THEN
C                                       Check data
                           INDEX = ECHAN * NPOLN * (IIF - 1) +
     *                        ECHAN * (JS - 1)
                           NFLAG = 0
                           DO 45 LOOP = BCHAN,ECHAN
                              IF (FLGKEY(CINDEX+LOOP).EQ.-1)
     *                           FLGKEY(INDEX+LOOP) = -1
                              IF (FLGKEY(INDEX+LOOP).EQ.-1)
     *                           NFLAG = NFLAG + 1
 45                           CONTINUE
                           IF ((NCL.GT.0) .AND. (NFLAG.GE.NCL))
     *                        CALL FILL (ECHAN, -1, FLGKEY(INDEX+1))
                           END IF
 50                     CONTINUE
                     END IF
 55               CONTINUE
 60            CONTINUE
            END IF
C                                       Now COUNT
         DO 80 IIF = 1,NIF
            DO 75 IS = 1,NPOLN
               NGOOD = 0
               NBAD = 0
               NFLAG = 0
               IF (GOODDT(IS,IIF)) THEN
C                                       Set index for info counters
                  CINDEX = ECHAN * NPOLN * (IIF - 1) + ECHAN * (IS - 1)
C                                       Check flags
                  DO 70 LOOP = BCHAN,ECHAN
                     IF (FLGKEY(CINDEX+LOOP).EQ.1) THEN
                        NGOOD = NGOOD + 1
                     ELSE IF (FLGKEY(CINDEX+LOOP).EQ.-1) THEN
                        NFLAG = NFLAG + 1
                        NBDCOR = NBDCOR + 1
                     ELSE
                        NBAD = NBAD + 1
                        END IF
 70                  CONTINUE
                  DO 71 LS = 1,4
                     MALL(IA1,LS,IIF) = MALL(IA1,LS,IIF) + FLGIT(LS,IS)
                     IF (NGOOD.LE.0) MBAD(IA1,LS,IIF) = MBAD(IA1,LS,IIF)
     *                  + FLGIT(LS,IS)
                     IF ((NGOOD.GT.0) .AND. (NFLAG.GT.0))
     *                  MSOM(IA1,LS,IIF) = MSOM(IA1,LS,IIF)
     *                  + FLGIT(LS,IS)
 71                  CONTINUE
                  END IF
 75            CONTINUE
 80         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Working on visibility record ', I8)
      END
      SUBROUTINE FLAGIT (OPCODE, LUN, DISK, CNO, VERI, VER, LFGRNO,
     *   FGKOLS, FGNUMV, ID, SUBA, FQID, ANT1, ANT2, BTIME, ETIME, BIF,
     *   EIF, BCHAN, ECHAN, PFLAGS, REASON, DOIFS, CATUV, BUFF, IRET)
C-----------------------------------------------------------------------
C   Updates the Flag (FG) table. Adapted from FLAGUP
C   One entry is made indicating a visibility to be rejected.
C   The FLAG table will be opened on the first call but a final call
C   with OPCODE='CLOS' is required to close the file.
C   Inputs:
C      OPCODE   C*4      Operation desired, 'CLOS'=>close file
C                        Anything else = 'FLAG'
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      VERI     I        Input version number
C      VER      I        FG file version
C      LUN      I        Logical unit number to use
C      ID       I(NID)   List of source ID as defined in SOURCE table
C      NID      I        Number of elements in ID
C      SUBA     I        Subarray number.
C      FQID     I        Freqid number
C      ANT1     I        First antenna number in baseline
C      ANT2     I        Second antenna number in baseline
C      BTIME    R        Start time of data to be flagged (Days)
C      ETIME    R        End time of data to be flagged (Days)
C      BIF      I        First IF number to flag. 0=>all
C      EIF      I        Last IF number to flag. 0=>all higher than IFS(1)
C      BCHAN    I        First channel number to flag. 0=>all
C      ECHAN    I        Last channel number to flag. 0=>all higher.
C      PFLAGS   L(4)     Correlator flags
C      REASON   C*24     Reason for flagging blank => ignore for unflag.
C      DOIFS    R        > 0 flag all IFs
C   Input/Output:
C      CATUV    I(256)   Header for disk file to get FG table
C      BUFF     I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      LFGRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      FGKOLS   I(*)     The column pointer array in order, SOURCE,
C                        SUBARRAY, ANTS, TIMERANG, IFS, CHANS, PFLAGS,
C                        REASON
C      FGNUMV   I(*)     Element count in each column.
C   Output:
C      IRET     I        Error code, 0=>OK else TABIO error.
C                        Note: -1 => read, but record deselected.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, REASON*24
      INTEGER   LUN, DISK, CNO, VERI, VER, LFGRNO, FGKOLS(*), FGNUMV(*),
     *   ID, SUBA, FQID, ANT1, ANT2, BIF, EIF, BCHAN, ECHAN, CATUV(256),
     *   BUFF(*), IRET
      REAL      BTIME, ETIME, DOIFS
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER TREAS*24, CTEMP*12
      INTEGER   IDT, SUBT, ANTS(2), IFS(2), CHANS(2), IDUM, FIND, I,
     *   BUFF2(512), LUN2, IFGKOL(MAXFGC), IFGNUM(MAXFGC), NROW, IFQ,
     *   IFGRNO
      LOGICAL   PFLAGS(4), TFLAGS(4), FIRST
      REAL      TIMER(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      SAVE FIRST
      DATA FIRST /.TRUE./
C-----------------------------------------------------------------------
C                                       See if table open - check FTAB
      IF (OPCODE.NE.'CLOS') THEN
         FIND = BUFF(82)
C                                       Open file
         IF ((FIND.LT.0) .OR. (FIND.GT.10000) .OR. (LUN.NE.FTAB(FIND)))
     *      THEN
            CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV',
     *         IDUM, 'CLRD', BUFF, IRET)
            CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV',
     *         IDUM, 'WRIT', BUFF, IRET)
C
            CALL FLGINI ('WRIT', BUFF, DISK, CNO, VER, CATUV, LUN,
     *         LFGRNO, FGKOLS, FGNUMV, IRET)
C                                       Report on the need for flagging
            WRITE (MSGTXT,1000) VER
            IF (.NOT.FIRST) WRITE (MSGTXT,1001) VER
            CALL MSGWRT (2)
            IF (IRET.NE.0) GO TO 999
C                                       Copy the old file
            IF ((FIRST) .AND. (VERI.GT.0)) THEN
               LUN2 = LUN + 1
               CALL FLGINI ('READ', BUFF2, DISK, CNO, VERI, CATUV, LUN2,
     *            IFGRNO, IFGKOL, IFGNUM, IRET)
               IF (IRET.NE.0) GO TO 999
               NROW = BUFF2(5)
               WRITE (MSGTXT,1002) NROW, VERI, VER
               CALL MSGWRT (2)
               DO 20 I = 1,NROW
                  CALL TABFLG ('READ', BUFF2, IFGRNO, IFGKOL, IFGNUM,
     *               IDT, SUBT, IFQ, ANTS, TIMER, IFS, CHANS, TFLAGS,
     *               TREAS, IRET)
                  IF (IRET.GT.0) GO TO 999
                  IF (IRET.EQ.0) THEN
                     CALL TABFLG ('WRIT', BUFF, LFGRNO, FGKOLS, FGNUMV,
     *                  IDT, SUBT, IFQ, ANTS, TIMER, IFS, CHANS, TFLAGS,
     *                  TREAS, IRET)
                     IF (IRET.NE.0) GO TO 999
                     END IF
 20               CONTINUE
               CALL TABIO ('CLOS', 0, IFGRNO, BUFF2, BUFF2, I)
               END IF
            FIRST = .FALSE.
C                                       Mark as unsorted
            BUFF(43) = 0
            BUFF(44) = 0
            END IF
C                                       Set up for flagging
         ANTS(1) = ANT1
         ANTS(2) = ANT2
         TIMER(1) = BTIME
         TIMER(2) = ETIME
         IF (DOIFS.LE.0.0) THEN
            IFS(1) = BIF
            IFS(2) = EIF
         ELSE
            IFS(1) = 1
            IFS(2) = 0
            END IF
         CHANS(1) = BCHAN
         CHANS(2) = ECHAN
C                                       Flag table entry.
         CALL TABFLG ('WRIT', BUFF, LFGRNO, FGKOLS, FGNUMV, ID, SUBA,
     *      FQID, ANTS, TIMER, IFS, CHANS, PFLAGS, REASON, IRET)
C                                       Close
      ELSE
         CALL TABFLG ('CLOS', BUFF, LFGRNO, FGKOLS, FGNUMV, IDT, SUBT,
     *      FQID, ANTS, TIMER, IFS, CHANS, TFLAGS, TREAS, IRET)
C                                       Clear write status
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV', IDUM,
     *      'CLWR', BUFF, IRET)
C                                       Reset status to read
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV', IDUM,
     *      'READ', BUFF, IRET)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Found some bad data, will write flags to table FG', I4)
 1001 FORMAT ('Found some bad data, will add   flags to table FG', I4)
 1002 FORMAT ('Copy',I8,' rows from FG vers',I3,' to',I3)
      END

LOCAL INCLUDE 'BPWGT.INC'
C                                       Local include for BPWGT
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4,30), XCALC(1), XNAMOU(3),
     *   XCLAOU(2), XXSTOK(1)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XSUBA, XBIF, XEIF, XBCHAN, XECHAN, XDOCAL, XGUSE, XDOPOL,
     *   XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH(3), XDOAC, XSOUT,
     *   XDISO, XWGTIT, XCENT, BADD(10),
     *   SCRBUF(256), BUFF2(UVBFSS), DIFPIX
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, JBUFSZ, ILOCWT, NWGTIT,
     *   CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO,
     *   LRECO, NRPRMI, NRPRMO, OLDCNO, NEWCNO
      LOGICAL   ISCOMP
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XXSTOK, XTIME, XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF, XBCHAN,
     *   XECHAN, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND,
     *   XBPVER, XSMOTH, XDOAC, XNAMOU, XCLAOU, XSOUT, XDISO, XWGTIT,
     *   XCENT, BADD
      COMMON /BPWGTP/ CATOLD, SEQIN, SEQOUT, DISKIN, DISKO, ILOCWT,
     *   INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECO, NRPRMI,
     *   NRPRMO, ISCOMP, OLDCNO, NEWCNO, DIFPIX
      COMMON /WGTIT/ NWGTIT
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT
      COMMON /BUFRS/ SCRBUF, BUFF2, JBUFSZ
C                                       End local include for BPWGT
LOCAL END
      PROGRAM BPWGT
C-----------------------------------------------------------------------
C! Calibrate data and modify channel weights by the bandpass correction
C# Utility UV UV-util VLA VLB Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2013-2014, 2018, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BPWGT copies the UV data set applying calibration and modifying the
C   weights by the bandpass correction on a channel-by-channel basis.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C   full set of calibration adverbs
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'BPWGT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'BPWGT '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL BPWTIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL BPWTUV (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL BPWTHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE BPWTIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   BPWTIN gets input parameters for BPWGT and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in BPWGT for more details.
C
C   To change the adverb list sent to this task change:
C   1)  the inputs file.
C   2)  the contents of COMMON /INPARM/.  Remember all adverbs are sent
C       as R, INNAME etc. are 12 char. 3 words;
C       INCLASS etc. are 6 char., 2 words.
C       Values will be filled into COMMON /INPARM/ in the order
C       specified in the inputs file.
C   3)  If the first adverb is not INNAME (NAMEIN) then replace
C       NAMEIN in the call to GTPARM with the name of the first
C       adverb.
C   4)  Change the value of NPARM sent to GTPARM to the number of
C       R words desired.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, NFREQ, LUN
      LOGICAL   MATCH
      REAL      CATR(256), RPARM(20)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'BPWGT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      DATA BLANK  /' '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 177
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (4, 1, XXSTOK, STOKES)
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = XDOAC.GT.0.0
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      IF (DOBAND.LE.0) THEN
         MSGTXT = 'YOU MUST APPLY A BANPASS CORRECTION'
         JERR = 10
         GO TO 990
         END IF
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
      NWGTIT = IROUND (XWGTIT)
      NWGTIT = MAX (0, MIN (2, NWGTIT))
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NFREQ = CATBLK(KINAX+JLOCF)
      BCHAN = IROUND (XBCHAN)
      ECHAN = IROUND (XECHAN)
      IF ((BCHAN.LE.0) .OR. (BCHAN.GT.NFREQ)) BCHAN = 1
      IF ((ECHAN.LE.0) .OR. (ECHAN.GT.NFREQ)) ECHAN = NFREQ
      IF (BCHAN.GT.ECHAN) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, SCRBUF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, SCRBUF, IERR)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
      IF (JLOCF.LT.0) XCENT = -1.
      IF (XCENT.GT.0.0) THEN
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
      ELSE
         DIFPIX = 0.0
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       read compressed => write compr.
      IF (ISCOMP) THEN
         CATBLK(KINAX) = 1
         I = CATBLK(KIPCN)
         CALL CHR2H (8, 'WEIGHT  ', 1, CATH(KHPTP+2*I))
         CALL CHR2H (8, 'SCALE   ', 1, CATH(KHPTP+2*I+2))
         CATBLK(KIPCN) = I + 2
         ILOCWT = I
         END IF
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((CCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', SCRBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
      NEWCNO = CCNO
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', SCRBUF, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       Copy any header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPWTIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('BPWTIN: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE BPWTUV (IRET)
C-----------------------------------------------------------------------
C   BPWTUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48
      INTEGER   IPTRO, LUNO, INDO, ILENBU, KBIND, NIOUT, NIOLIM, BO, VO,
     *   NUMVIS, XCOUNT, NCORO, NCOPY, CATMP(256), RNXRET
      LOGICAL   T, F
      INCLUDE 'BPWGT.INC'
      REAL      VIS(UVBFSS), RESULT(UVBFSS), RPARM(20)
      DOUBLE PRECISION UVSCAL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA LUNO /17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Number of visibilities in input
C                                       and output files.
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       defend cat header from UVGET
      CALL COPY (256, CATBLK, CATMP)
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL COPY (256, CATMP, CATBLK)
      CALL UVPGET (IRET)
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
      NUMVIS = 0
      XCOUNT = 0
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
      IF ((FREQ.GT.0.0D0) .AND. (UVFREQ.GT.0.0D0)) THEN
         UVSCAL = FREQ / UVFREQ
      ELSE
         UVSCAL = 1.0D0
         END IF
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over buffer
      ELSE IF (IRET.EQ.0) THEN
         NUMVIS = NUMVIS + 1
         RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
         RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
         RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
C                                       call user routine
         CALL DIDDLE (NUMVIS, VIS, RESULT, IRET)
C                                       Error (fatal)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
C                                       Copy to output.
         ELSE IF (IRET.EQ.0) THEN
            XCOUNT = XCOUNT + 1.0D0
            CALL RCOPY (NRPRMI, RPARM, BUFF2(IPTRO))
C                                       update NX table
            CALL RNXUPD (RPARM, RNXRET)
C                                       Compressed
            IF (ISCOMP) THEN
               CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *            BUFF2(IPTRO+NRPRMO))
            ELSE
               CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
               END IF
            IPTRO = IPTRO + LRECO
            NIOUT = NIOUT + 1
            END IF
C                                       Write vis record.
         IF (NIOUT.GE.NIOLIM) THEN
            CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1150) IRET
               GO TO 990
               END IF
            IPTRO = KBIND
            NIOUT = 0
            END IF
C                                       Read next buffer.
         GO TO 100
         END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
C                                       close NX table
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPWTUV: ERROR',I3,' OPEN/INIT INPUT VIS FILE')
 1010 FORMAT ('BPWTUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('BPWTUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1100 FORMAT ('BPWTUV: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('BPWTUV: DIDDLE ERROR',I3)
 1150 FORMAT ('BPWTUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE BPWTHI
C-----------------------------------------------------------------------
C   BPWTHI copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      INTEGER   LUN1, LUN2, IERR
C
      CHARACTER HICARD*72
      INTEGER   BUFF1(512)
      INCLUDE 'BPWGT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1, LUN2 /27,28/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   SCRBUF, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 100
C                                       calibration history
      CALL CALHIS (LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HICARD,1010) TSKNAM, NWGTIT
      CALL HIADD (LUN2, HICARD, BUFF2, IERR)
C                                       Close HI file
 100  CALL HICLOS (LUN2, .TRUE., BUFF2, IERR)
C                                       Copy tables
      CALL COPTAB (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'BPWTHI: ERROR COPYING TABLES TO OUTPUT UV'
         CALL MSGWRT (6)
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (DISKO, NEWCNO, DIFPIX, BUFF1, BUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'BPWTHI: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                       Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRBUF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BPWTHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,'WEIGHTIT =',I2,'   / weight = bp**(0.5 ** weightit')
      END
      SUBROUTINE DIDDLE (NUMVIS, VIS, RESULT, IRET)
C-----------------------------------------------------------------------
C   This moves VIS to RESULT only.  The real work is done in the local
C   version of DATBND.
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      VIS     R(3,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C   Inputs from COMMON:
C      NCOR       I       # correlators
C      CATBLK     I(256)  Catalog header record. See Going Aips for
C                         details.
C      NRPRMI     I    Input number of random parameters.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
C      LRECO      I    Output file record length
C      NRPRMO     I    Output number of random parameters.
C      INCSO      I    Output Stokes' increment in vis.
C      INCFO      I    Output frequency increment in vis.
C      INCIFO     I    Output IF increment in vis.
C   Output:
C      RESULT     R(3,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IRET
      REAL      VIS(3,*), RESULT(3,*)
C
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXO, INDEXI
      INCLUDE 'BPWGT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.GT.0) THEN
C                                       pointers to traverse the data
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
         DO 40 JIF = 1,NIF
            DO 30 JF = 1,NF
               DO 20 JS = 1,NS
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *               (JS-1) * INCSO + 1
                  RESULT(1,INDEXO) = VIS(1,INDEXI)
                  RESULT(2,INDEXO) = VIS(2,INDEXI)
                  RESULT(3,INDEXO) = VIS(3,INDEXI)
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
C                                       last call - no vis
      ELSE
         END IF
C
 999  RETURN
      END
      SUBROUTINE DATBND (TIME, IA1, IA2, VIS, IERR)
C-----------------------------------------------------------------------
C   Routine which applies the bandpass correction.
C   ********** special version applies BP to weights only *************
C   Inputs:
C      TIME     R        Time of visibility data (in days)
C      IA1      I        Antenna number 1
C      IA2      I        Antenna number 2
C   Inputs from common:
C      BPBUFF   R(*)     Large array containing bandpass spectra for
C                        all antennas
C      ANTPNT   LI(2,2)  Pointer giving the start address of the
C                        specified antennas BP spectra within BPBUFF
C      DOBAND   I        Method of BP application
C   In/Outputs:
C      VIS      R(*)     Array of visibility data (corrected on out)
C   Output:
C      IERR     I        If > 0, error returned from BPGET
C   Output to common:
C      CNTREC  I(2,3)  Record counts:
C                        (1&2,1) Previously flagged (partly, fully)
C                        (1&2,2) Flagged due to gains (part, full)
C                        (1&2,3) Good selected (part, full)
C   NOTE: This routine applies the bandpass correction for formulae:
C      (1) Cross-power:   Scorr   =  (1/Sant_1) * (1/Sant_2) * Sobs
C      (2) Total-power:   Scorr   =  (Son / Soff) - 1.0
C-----------------------------------------------------------------------
      REAL      TIME, VIS(*)
      INTEGER   IA1, IA2, IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   INCPX, IFRQ, IIF, IOFF, DINDX, CHOFF, NCOR, KLOCS, JERR,
     *   TCOR0, IPOL, JPOL1(4), JPOL2(4), LRECS, LUNSRC, IFLAG(2),
     *   JFLAG(2), IROUND, KLOCF, ITMP, JTMP, NMAX, LBCH, LECH, CH1,
     *   CH2, NCHS(4)
      LONGINT   I1OFF, I2OFF, L1OFF, L2OFF, I1D, I2D, L1D, L2D
      REAL      GR1, GI1, AMP12, AMP22, REAL1, IMAG1, REAL2, IMAG2,
     *   RTMP, BPARR1(6), BPARR2(6), AMPS(4), TVR, TVI, POW
      HOLLERITH CATH(256)
      LOGICAL   FLAGD1, FLAGDA, IQUV, CORRP, T, F, WAUTO, FLAGD0,
     *   FAILED, FIRST
      DOUBLE PRECISION CATD(128), SHIFT1(MAXIF), SHIFT2(MAXIF), RATE,
     *   TFRQ, DPOLYN(MAXCHA)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DBPC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DCVL.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      INTEGER   NWGTIT
      COMMON /WGTIT/ NWGTIT
      SAVE FIRST
      EQUIVALENCE (CATH, CATD, CATUV)
      DATA T, F, FIRST /.TRUE., .FALSE., .TRUE./
C-----------------------------------------------------------------------
      IF (FIRST) THEN
         MSGTXT = 'Using special version of DATBND'
         CALL MSGWRT (2)
         FIRST = .FALSE.
         END IF
      POW = 0.5 ** NWGTIT
C                                       Check sizes
      IF ((NIFBP.GT.MAXIF) .OR. (NCHNBP.GT.MAXCHA) .OR.
     *   (NPOLBP*NIFBP*NCHNBP.GT.MAXCIF)) THEN
         IERR = 1
         MSGTXT = 'DATBND:VISIBILITIES TOO BIG FOR BUFFERS'
         GO TO 990
         END IF
      IF (BCHANS.LE.0) BCHANS = BCHAN
      IF (ECHANS.LE.0) ECHANS = ECHAN
C                                       Average amplitude range
      ITMP = CATUV(KINAX+KLOCFY)
      IF (ISVLA) THEN
         CH1 = (ITMP+1)/8 + 1
         CH2 = ITMP - ((ITMP+1)/8)
      ELSE
         CH1 = 1
         CH2 = ITMP
         END IF
      CALL FILL (4, 0, NCHS)
      CALL RFILL (4, 0.0, AMPS)
      IF (DOWTCL) THEN
         LBCH = MIN (CH1, BCHANS)
         LECH = MAX (CH2, ECHANS)
      ELSE
         LBCH = BCHANS
         LECH = ECHANS
         END IF
C                                       Determine shift needed from BP
C                                       table
      CALL DFILL (MAXIF, 0.0D0, SHIFT1)
      CALL DFILL (MAXIF, 0.0D0, SHIFT2)
C
      IF (ISVLBA) THEN
         CALL AXEFND (8, 'FREQ    ', CATUV(KIDIM), CATH(KHCTP), KLOCF,
     *      JERR)
         IF ((RAEPO.EQ.0.D0) .AND. (DECEPO.EQ.0.D0)) THEN
            LUNSRC = 49
            CALL GETSOU (CURSOU, IUDISK, IUCNO, CATUV, LUNSRC, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1040) IERR
               GO TO 990
               END IF
            END IF
         DO 20 IIF = 1,CNNIF
            TFRQ = CATD(KDCRV+KLOCF) + CFOFF(IIF) + FREQO(IIF)
            CALL DETRAT (TIME, RAEPO, DECEPO, ANTX(IA1), ANTY(IA1),
     *         ANTZ(IA1), TFRQ, RATE)
            SHIFT1(IIF) = RATE / CFINC(IIF)
            IF (IA2.NE.IA1) THEN
               CALL DETRAT (TIME, RAEPO, DECEPO, ANTX(IA2), ANTY(IA2),
     *            ANTZ(IA2), TFRQ, RATE)
               SHIFT2(IIF) = RATE / CFINC(IIF)
               END IF
 20         CONTINUE
         END IF
C                                       Get the bandpass spectra
      CALL BPGET (TIME, IA1, IA2, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
      FAILED = IERR.LT.0
      IERR = 0
C                                       Check STOKES parms
      CALL AXEFND (8, 'STOKES  ', CATUV(KIDIM), CATH(KHCTP), KLOCS,
     *   JERR)
      NCOR = CATUV(KINAX+KLOCS)
      IF (CATD(KDCRV+KLOCS).GT.0.0D0) TCOR0 = CATD(KDCRV+KLOCS) + 0.5D0
      IF (CATD(KDCRV+KLOCS).LT.0.0D0) TCOR0 = CATD(KDCRV+KLOCS) - 0.5D0
      IQUV = TCOR0.GE.1
      CORRP = (TCOR0.LE.-1) .AND. (TCOR0.GT.-5)
C                                       Set visibility increment
      INCPX = CATUV(KINAX)
C                                       Compressed data expanded
      IF (INCPX.EQ.1) INCPX = 3
C                                       Set up base pointers
      I1OFF = ANTPNT(1,1)
      I2OFF = ANTPNT(2,1)
      L1OFF = ANTPNT(1,1) + PVLBUF - PBPBUF
      L2OFF = ANTPNT(2,1) + PVLBUF - PBPBUF
C                                       polarization pointers
      DO 30 IPOL = 1,NCOR
         IF (CORRP) THEN
C                                       RR or LL
            IF (IPOL.LE.2) THEN
               JPOL1(IPOL) = IPOL
               JPOL2(IPOL) = IPOL
C                                       RL
            ELSE IF (IPOL.EQ.3) THEN
               JPOL1(IPOL) = 1
               JPOL2(IPOL) = 2
C                                       LR
            ELSE IF (IPOL.EQ.4) THEN
               JPOL1(IPOL) = 2
               JPOL2(IPOL) = 1
               END IF
C                                       For IQUV always use Stokes I
C                                       bandpass
         ELSE IF (IQUV) THEN
            JPOL1(IPOL) = 1
            JPOL2(IPOL) = 1
            END IF
 30      CONTINUE
C                                       Flag on total failure
      IF (FAILED) THEN
         FLAGD1 = T
         FLAGDA = T
         DO 45 IIF = BIF,EIF
            IOFF = (IIF-1) * KNCIF
            DO 40 IFRQ = BCHANS,ECHANS
               DO 35 IPOL = 1,NCOR
C                                       Index for weight
                  DINDX = ((IOFF + (IPOL-1) * KNCS) +
     *               (IFRQ-1) * KNCF) * INCPX + 3
                  VIS(DINDX) = -1.0
 35               CONTINUE
 40            CONTINUE
 45         CONTINUE
C                                       Shift the bandpasses to the
C                                       appropriate value. First set
C                                       flagged channels.
      ELSE
         FLAGD1 = F
         FLAGDA = T
         IFLAG(1) = 0
         IFLAG(2) = 0
         JFLAG(1) = NCHNBP + 1
         JFLAG(2) = NCHNBP + 1
         IF (ISVLBA) THEN
            IFLAG(1) = IROUND (AVDELI(IA1,1)) + 1
            JFLAG(1) = NCHNBP - IFLAG(1) + 1
            IF (ABS (SHIFT1(1)).GT.0.0) THEN
               RTMP = ABS (SHIFT1(1))
               ITMP = 1 + IROUND (RTMP)
               IFLAG(1) = MAX(IFLAG(1), ITMP)
               JTMP = NCHNBP - IFLAG(1) + 1
               JFLAG(1) = MIN(JFLAG(1), JTMP)
               END IF
            IF (IA1.NE.IA2) THEN
               IFLAG(2) = IROUND(AVDELI(IA2,1)) + 1
               JFLAG(2) = NCHNBP - IFLAG(2) + 1
               IF (ABS (SHIFT2(1)).GT.0.0) THEN
                  RTMP = ABS (SHIFT2(1))
                  ITMP = 1 + IROUND (RTMP)
                  IFLAG(2) = MAX(IFLAG(2), ITMP)
                  JTMP = NCHNBP - IFLAG(2) + 1
                  JFLAG(2) = MIN(JFLAG(2), JTMP)
                  END IF
               END IF
            END IF
C                                       Case BP entry type of:
C                                       1: Polynomial BP
         IF (WPOLY) THEN
            WAUTO = (IA1.EQ.IA2)
            DO 60 IPOL = 1,NPOLBP
               DO 50 IIF = 1,NIFBP
                  I1D = I1OFF + (IIF-1) * KSNCIF + (IPOL-1) * KSNCS
                  I2D = I2OFF + (IIF-1) * KSNCIF + (IPOL-1) * KSNCS
                  L1D = L1OFF + (IIF-1) * KSNCIF + (IPOL-1) * KSNCS
                  L2D = L2OFF + (IIF-1) * KSNCIF + (IPOL-1) * KSNCS
                  CALL BPCOEF (LTYPBP, BPBUF(I1D), BPBUF(I1D+1),
     *               KSNCF, KSNCF, NCHNBP, FBLANK, SHIFT1(IIF),
     *               VLBUF(L1D), VLBUF(L1D+1), KSNCF, KSNCF,
     *               1, NCHNBP, 1.0, FLOAT(NCHNBP), 0, WAUTO,
     *               DPOLYN, MAXCHA, NMAX, .FALSE., IERR)
                  IF (IERR.NE.0) GO TO 999
                  IF (.NOT.WAUTO) CALL BPCOEF (LTYPBP, BPBUF(I2D),
     *               BPBUF(I2D+1), KSNCF, KSNCF, NCHNBP, FBLANK,
     *               SHIFT2(IIF), VLBUF(L2D), VLBUF(L2D+1), KSNCF,
     *               KSNCF, 1, NCHNBP, 1.0, FLOAT(NCHNBP), 0, WAUTO,
     *               DPOLYN, MAXCHA, NMAX, .FALSE., IERR)
                  IF (IERR.NE.0) GO TO 999
 50               CONTINUE
 60            CONTINUE
C                                       2: Standard BP entry:
         ELSE IF (ISVLBA) THEN
            LRECS = NIFBP * NPOLBP * NCHNBP * 2
            IF ((ABS(SHIFT1(1) - CURSHF(IA1))) .GT. 0.1) THEN
               CALL RCOPY (LRECS, BPBUF(I1OFF), VLBUF(L1OFF))
               CURSHF(IA1) = SHIFT1(1)
               CALL BPSHFT (VLBUF(L1OFF), NPOLBP, NIFBP, NCHNBP,
     *            KSNCS, KSNCIF, KSNCF, SHIFT1, NUMSHF)
               END IF
            IF (IA1.NE.IA2) THEN
               IF ((ABS(SHIFT2(1) - CURSHF(IA2))) .GT. 0.1) THEN
                  CALL RCOPY (LRECS, BPBUF(I2OFF), VLBUF(L2OFF))
                  CURSHF(IA2) = SHIFT2(1)
                  CALL BPSHFT (VLBUF(L2OFF), NPOLBP, NIFBP, NCHNBP,
     *               KSNCS, KSNCIF, KSNCF, SHIFT2, NUMSHF)
                  END IF
               END IF
            END IF
C                                       Endcase (BP_entry type)
C
C                                       Additional offset to cope
C                                       with the possibility that
C                                       BCHAN and BCHNBP differ
         CHOFF = 1 - BCHNBP
C                                       Check bandpass and data match
         IF (BCHNBP.GT.BCHAN) THEN
            WRITE (MSGTXT,1010) BCHAN
            CALL MSGWRT (7)
            WRITE (MSGTXT,1020) BCHNBP
            CALL MSGWRT (7)
            WRITE (MSGTXT,1030)
            IERR = 5
            GO TO 990
            END IF
         DO 150 IIF = BIF,EIF
            IOFF = (IIF-1) * KNCIF
            DO 120 IFRQ = LBCH,LECH
C                                       Generate the correction arrays
               DO 100 IPOL = 1,NPOLBP
                  I1D = I1OFF + (IFRQ-1+CHOFF) * KSNCF +
     *               (IIF-1) * KSNCIF + (IPOL-1) * KSNCS
                  L1D = I1D - I1OFF + L1OFF
                  DINDX = IPOL * 3 - 2
                  BPARR1(DINDX+2) = 1.0
                  BPARR2(DINDX+2) = 1.0
C                                       cross power
                  I2D = I2OFF + (IFRQ-1+CHOFF) * KSNCF +
     *               (IIF-1) * KSNCIF + (IPOL-1) * KSNCS
                  L2D = I2D - I2OFF + L2OFF
                  IF (ISVLBA .OR. WPOLY) THEN
                     AMP12 = (VLBUF(L1D)   * VLBUF(L1D) +
     *                  VLBUF(L1D+1) * VLBUF(L1D+1))
                     AMP22 = (VLBUF(L2D)   * VLBUF(L2D) +
     *                  VLBUF(L2D+1) * VLBUF(L2D+1))
                     IF (IFRQ.LE.IFLAG(1)) VLBUF(L1D) = FBLANK
                     IF (IFRQ.LE.IFLAG(2)) VLBUF(L2D) = FBLANK
                     IF (IFRQ.GE.JFLAG(1)) VLBUF(L1D) = FBLANK
                     IF (IFRQ.GE.JFLAG(2)) VLBUF(L2D) = FBLANK
                     FLAGD0 = F
                     IF ((AMP12.LE.0.0) .OR. (VLBUF(L1D).EQ.FBLANK)
     *                  .OR. (VLBUF(L1D+1).EQ.FBLANK)) THEN
                        BPARR1(DINDX+2) = -1.0
                        AMP12 = 1.0
                        FLAGD0 = T
                        END IF
                     IF ((AMP22.LE.0.0) .OR. (VLBUF(L2D).EQ.FBLANK)
     *                  .OR. (VLBUF(L2D+1).EQ.FBLANK)) THEN
                        BPARR2(DINDX+2) = -1.0
                        AMP22 = 1.0
                        FLAGD0 = T
                        END IF
                     IF (FLAGD0) THEN
                        FLAGD1 = T
                     ELSE
                        FLAGDA = F
                        END IF
                     BPARR1(DINDX) = VLBUF(L1D)   / AMP12
                     BPARR1(DINDX+1) = VLBUF(L1D+1) / AMP12
                     BPARR2(DINDX) = VLBUF(L2D)   / AMP22
                     BPARR2(DINDX+1) = VLBUF(L2D+1) / AMP22
                  ELSE
                     AMP12 = (BPBUF(I1D)   * BPBUF(I1D) +
     *                  BPBUF(I1D+1) * BPBUF(I1D+1))
                     AMP22 = (BPBUF(I2D)   * BPBUF(I2D) +
     *                  BPBUF(I2D+1) * BPBUF(I2D+1))
                     FLAGD0 = F
                     IF ((AMP12.LE.0.0) .OR. (BPBUF(I1D).EQ.FBLANK)
     *                  .OR. (BPBUF(I1D+1).EQ.FBLANK)) THEN
                        BPARR1(DINDX+2) = -1.0
                        AMP12 = 1.0
                        FLAGD0 = T
                        END IF
                     IF ((AMP22.LE.0.0) .OR. (BPBUF(I2D).EQ.FBLANK)
     *                  .OR. (BPBUF(I2D+1).EQ.FBLANK)) THEN
                        BPARR2(DINDX+2) = -1.0
                        AMP22 = 1.0
                        FLAGD0 = T
                        END IF
                     IF (FLAGD0) THEN
                        FLAGD1 = T
                     ELSE
                        FLAGDA = F
                        END IF
                     BPARR1(DINDX) = BPBUF(I1D)   / AMP12
                     BPARR1(DINDX+1) = BPBUF(I1D+1) / AMP12
                     BPARR2(DINDX) = BPBUF(I2D)   / AMP22
                     BPARR2(DINDX+1) = BPBUF(I2D+1) / AMP22
                     END IF
 100              CONTINUE
C                                       Apply the correction
               DO 110 IPOL = 1,NCOR
C                                       Index for visibility
                  DINDX = ((IOFF + (IPOL-1) * KNCS) +
     *               (IFRQ-1) * KNCF) * INCPX + 1
                  I1D = 3*JPOL1(IPOL) - 2
                  I2D = 3*JPOL2(IPOL) - 2
C                                       Do the correction
                  REAL1 = BPARR1(I1D)
                  IMAG1 = BPARR1(I1D+1)
                  REAL2 = BPARR2(I2D)
                  IMAG2 = BPARR2(I2D+1)
                  GR1 = (REAL1*REAL2 + IMAG1*IMAG2)
                  GI1 = (REAL2*IMAG1 - REAL1*IMAG2)
C                                       scale visibilities
                  TVR = GR1 * VIS(DINDX) + GI1 * VIS(DINDX+1)
                  TVI = GR1 * VIS(DINDX+1) - GI1 * VIS(DINDX)
                  VIS(DINDX) = TVR
                  VIS(DINDX+1) = TVI
C                                       weights
                  IF ((BPARR1(I1D+2).LE.0.0) .OR.
     *               (BPARR2(I2D+2).LE.0.0)) THEN
                     VIS(DINDX+2) = -1.0
                  ELSE
                     RTMP = (GR1 * GR1 + GI1 * GI1) ** POW
                     IF (RTMP.LE.0.0) THEN
                        VIS(DINDX+2) = -1.0
                     ELSE
                        VIS(DINDX+2) = VIS(DINDX+2) / RTMP
                        END IF
                     END IF
 110              CONTINUE
 120           CONTINUE
 150        CONTINUE
         END IF
C                                       Update error counts
      IF (FLAGD1) THEN
         IF (FLAGDA) THEN
            CNTREC(2,2) = CNTREC(2,2) + 1
         ELSE
            CNTREC(1,2) = CNTREC(1,2) + 1
            END IF
         END IF
      GO TO 999
C
 990  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DATBND: ERROR ',I3,' RETURNED FROM BPGET')
 1010 FORMAT ('DATBND: START CHANNEL IN DATA = ',I3)
 1020 FORMAT ('DATBND: START CHANNEL IN BP TABLE = ',I3)
 1030 FORMAT ('DATBND: CANNOT DO BANDPASS CORRECTION - RESET BP TABLE')
 1040 FORMAT ('DATBND: ERROR ',I2,' DETERMINING SOURCE POSITION')
      END

LOCAL INCLUDE 'XG2PL.INC'
      HOLLERITH XINAM1(3), XINAM2(3), XINCL1(2), XINCL2(2), XOUTXT(12),
     *   CATH2(256)
      REAL      XINSE1, XINSE2, XINDS1, XINDS2, XINVR1, XINVR2,
     *   APARM(10), BPARM(10), CPARM(10), XYRATO, XLTYPE, XDOTV, XGRCH
      COMMON /INPARM/ XINAM1, XINCL1, XINSE1, XINDS1, XINAM2, XINCL2,
     *   XINSE2, XINDS2, XINVR1, XINVR2, APARM, BPARM, CPARM, XOUTXT,
     *   XYRATO, XLTYPE, XDOTV, XGRCH
      INTEGER   INSEQ1, INSEQ2, INDSK1, INDSK2, INCNO1, INCNO2, INVER1,
     *   INVER2, LABEL, GRCHN, TVCHN, CAT2(256), SCRTCH(256), NPARMS,
     *   LX, LY, IDX, IDY, IX1, IX2, IY1, IY2, ABSORB, NGAUSS
      LOGICAL   DOVPOL, PLOTV, PLOTI, DOTV
      DOUBLE PRECISION CATD2(128)
      EQUIVALENCE (CATD2, CATH2, CAT2)
      CHARACTER INAME1*12, INAME2*12, INCLS1*6, INCLS2*6, OUTEXT*48
      COMMON /XGPRMS/ CATD2, SCRTCH, INSEQ1, INSEQ2, INDSK1, INDSK2,
     *   INCNO1, INCNO2, INVER1, INVER2, LABEL, DOVPOL, PLOTV, PLOTI,
     *   DOTV, GRCHN, TVCHN, NPARMS, LX, LY, IDX, IDY, IX1, IX2, IY1,
     *   IY2, ABSORB, NGAUSS
      COMMON /CHPRMS/ INAME1, INAME2, INCLS1, INCLS2, OUTEXT
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
LOCAL END
LOCAL INCLUDE 'XGTABLE.INC'
      INTEGER   MAXGAU, MAXPX
      PARAMETER (MAXGAU=32)
      PARAMETER (MAXPX=100)
C
      INTEGER   IBLC(2), ITRC(2), JBLC(2), JTRC(2), XGBUFF(512),
     *   ZEBUFF(512), XGKOLS(12), XGNUMV(12), ZEKOLS(12), ZENUMV(12),
     *   DOGAUS, PRTPIX(2,MAXPX), NUMPX, MAXGGA, MAXVGA
      REAL      XBAR, PRTGV(2+3*MAXGAU,2,MAXPX), REFPIX, REFINC,
     *    PRTZV(1+MAXGAU,2,MAXPX), XGRMS, ZERMS
      DOUBLE PRECISION VOFF, REFVAL
      CHARACTER REFTYP*8
      COMMON /XGTABP/ VOFF, REFVAL, REFPIX, REFINC, XBAR, PRTGV, PRTZV,
     *   PRTPIX, XGBUFF, ZEBUFF, XGKOLS, XGNUMV, ZEKOLS, ZENUMV, IBLC,
     *   ITRC, JBLC, JTRC, DOGAUS, NUMPX, MAXGGA, MAXVGA, XGRMS, ZERMS
      COMMON /XGTABC/ REFTYP
LOCAL END
LOCAL INCLUDE 'XGPLOT.INC'
      INTEGER   PLBUFF(256), PLUN, PIND, TVCORN(2)
      REAL      BLC(2), TRC(2), LINT
      COMMON /XGPLOT/ PLBUFF, PLUN, PIND, BLC, TRC, LINT, TVCORN
LOCAL END
      PROGRAM XG2PL
C-----------------------------------------------------------------------
C! Task to create a plot (PL) file from XGAUS/AGAUS/ZEMAN/ZAMAN results
C# Plot-util EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2015-2017, 2022, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   XG2PL create a plot file of XGAUS/ZEMAN results
C   Inputs:   (from AIPS)
C      INNAME     H(3)   name of primary file.Ipol
C      INCLASS    H(2)   class of primary file.Ipol
C      INSEQ      R      sequence number of primary file. Ipol
C      INDISK     R      disk volume number. 0 means try all.Ipol
C      IN2NAME    H(3)   name of Vpol file.Ipol
C      IN2CLASS   H(2)   class of Vpol file.Ipol
C      IN2SEQ     R      sequence number of Vpol file. Ipol
C      IN2DISK    R      disk volume number. 0 means try all.Ipol
C      INVERS     R      version number of XG file, 0 means latest
C      IN2VERS    R      version number of ZE file, 0 latest
C      APARM      R(10)  Choose pixel, scaling, spectral BLC/TRC,
C                           average box
C      BPARM      R(10)  Choose what to plot
C      CPARM      R(10)  Plot controls
C      OUTTEXT    H(12)  Output text of data
C      XYRATIO    R      X/Y plot ratio
C      LTYPE      R      1=no labeling 2 no ticks, 3 RA/dec
C                        4=center rel., 5=subslice center-rel
C      DOTV       R      > 0 => TV, else plot file
C      GRCHAN     R      graphics channel to use
C-----------------------------------------------------------------------
      INTEGER   IRET, NCHAN, NWORDS, NP
      CHARACTER PRGNAM*6
      REAL      DBUFF(2), VBUFF(2), RBUFF(2), SBUFF(2), WBUFF(2),
     *   XBUFF(2)
      LONGINT   PDBUFF, PVBUFF, PRBUFF, PSBUFF, PWBUFF, PXBUFF
C      REAL      DBUFF(10000), VBUFF(10000), RBUFF(10000), SBUFF(10000),
C     *   WBUFF(10000), XBUFF(10000)
      INCLUDE 'XG2PL.INC'
      INCLUDE 'XGTABLE.INC'
      DATA PRGNAM /'XG2PL'/
C-----------------------------------------------------------------------
C                                       Init
      CALL XG2PLI (PRGNAM, NCHAN, IRET)
C                                       allocate memory
      IF (IRET.EQ.0) THEN
         NP = 5 + MAXGAU
         NWORDS = (NP * NCHAN - 1) / 1024 + 4
         CALL ZMEMRY ('GET ', TSKNAM, NWORDS, DBUFF, PDBUFF, IRET)
         IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, VBUFF,
     *      PVBUFF, IRET)
         IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, RBUFF,
     *      PRBUFF, IRET)
         IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, SBUFF,
     *      PSBUFF, IRET)
         IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, WBUFF,
     *      PWBUFF, IRET)
         IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, XBUFF,
     *      PXBUFF, IRET)
         END IF
C                                       get data
      IF (IRET.EQ.0) CALL XG2PLG (NCHAN, NP, DBUFF(1+PDBUFF),
     *   VBUFF(1+PVBUFF), RBUFF(1+PRBUFF), SBUFF(1+PSBUFF),
     *   WBUFF(1+PWBUFF), XBUFF(1+PXBUFF), IRET)
C      IF (IRET.EQ.0) CALL XG2PLG (NCHAN, NP, DBUFF,
C     *   VBUFF, RBUFF, SBUFF,
C     *   WBUFF, XBUFF, IRET)
C                                       plot data
      IF (IRET.EQ.0) CALL XG2PLP (NCHAN, NP, DBUFF(1+PDBUFF),
     *   VBUFF(1+PVBUFF), IRET)
C      IF (IRET.EQ.0) CALL XG2PLP (NCHAN, NP, DBUFF,
C     *   VBUFF, IRET)
C                                       print data
      IF (IRET.EQ.0) CALL XG2PLH (NCHAN, NP, DBUFF(1+PDBUFF),
     *   VBUFF(1+PVBUFF), IRET)
C      IF (IRET.EQ.0) CALL XG2PLH (NCHAN, NP, DBUFF,
C     *   VBUFF, IRET)
c
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE XG2PLI (PRGNAM, NCHAN, IRET)
C-----------------------------------------------------------------------
C   Inits this task
C   Input:
C      PRGNAM   C*6   Task name
C   Outputs:
C      NCHAN    I     Number spectral channels
C      IRET     I     Error code: 0 okay
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*(*)
      INTEGER   NCHAN, IRET
C
      INTEGER   I, IDUM, LUN, LUNTMP, LTYPE, IZERNO, IXGRNO, IROUND,
     *   ZABSOR
      REAL      DUM, ZEFPIX, ZEFINC
      DOUBLE PRECISION ZEFVAL
      CHARACTER MTYPE*2, STAT*4, ZEFTYP*8
      INCLUDE 'XG2PL.INC'
      INCLUDE 'XGTABLE.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      NSCR = 0
      NCFILE = 0
C                                       Get input values from AIPS.
      NPARMS = 62
      CALL GTPARM (PRGNAM, NPARMS, RQUICK, XINAM1, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (8)
         END IF
      IF (RQUICK) CALL RELPOP (IRET, scrtch, I)
      IF (IRET.NE.0) GO TO 999
C                                       Hollerith -> char.
      CALL H2CHR (48, 1 , XOUTXT, OUTEXT)
      CALL H2CHR (12, 1, XINAM1, INAME1)
      CALL H2CHR (6, 1, XINCL1, INCLS1)
      INSEQ1 = IROUND (XINSE1)
      INDSK1 = IROUND (XINDS1)
      CALL H2CHR (12, 1, XINAM2, INAME2)
      CALL H2CHR (6, 1, XINCL2, INCLS2)
      INSEQ2 = IROUND (XINSE2)
      INDSK2 = IROUND (XINDS2)
      INVER1 = IROUND (XINVR1)
      INVER2 = IROUND (XINVR2)
      LABEL = IROUND (XLTYPE)
      LTYPE = MOD (ABS(LABEL), 100)
      IF ((LTYPE.EQ.0) .OR. (LTYPE.GT.10)) THEN
         LTYPE = 3
         IF (LABEL.GE.0) THEN
            LABEL = (LABEL/100)*100 + LTYPE
         ELSE
            LABEL = (LABEL/100)*100 - LTYPE
            END IF
         END IF
      XLTYPE = LABEL
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = 1
C                                       Zeman image
      DOVPOL = (INAME2.NE.' ') .AND. (INCLS2.NE.' ')
      IF (.NOT.DOVPOL) THEN
         BPARM(6) = 0.0
         BPARM(7) = 0.0
         BPARM(8) = 0.0
         BPARM(9) = 0.0
         INAME2 = ' '
         INCLS2 = ' '
         INSEQ2 = 0
         INDSK2 = 0
         INVER2 = 0
      ELSE
         INCNO2 = 1
         MTYPE = 'MA'
         CALL CATDIR ('SRCH', INDSK2, INCNO2, INAME2, INCLS2, INSEQ2,
     *      MTYPE, NLUSER, STAT, SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1030) IRET, INAME2, INCLS2, INSEQ2, INDSK2,
     *         NLUSER
            GO TO 990
            END IF
C                                       Read CATBLK and mark 'READ'.
         CALL CATIO ('READ', INDSK2, INCNO2, CATBLK, 'READ', SCRTCH,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING VPOL HEADER'
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = INDSK2
         FCNO(NCFILE) = INCNO2
         FRW(NCFILE) = 0
         CALL COPY (256, CATBLK, CAT2)
C                                       Open ZE table
         CALL FNDEXT ('ZE', CATBLK, I)
         IF ((INVER2.LE.0) .OR. (INVER2.GT.I)) INVER2 = I
         IF (INVER2.LE.0) THEN
             BPARM(7) = 0.0
             BPARM(8) = 0.0
             BPARM(9) = 0.0
             JBLC(1) = 1
             JBLC(2) = 1
             JTRC(1) = CATBLK(KINAX+1)
             JTRC(2) = CATBLK(KINAX+2)
         ELSE
            LUN = LUNTMP (1)
            CALL ZEINI ('READ', ZEBUFF, INDSK2, INCNO2, INVER2, CATBLK,
     *         LUN, IZERNO, ZEKOLS, ZENUMV, JBLC, JTRC, DOGAUS, DUM,
     *         IDUM, ZEFVAL, ZEFPIX, ZEFINC, ZEFTYP, ZABSOR, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'OPENING REQUESTED ZE TABLE'
               GO TO 990
               END IF
            END IF
         END IF
      CALL CHR2H (12, INAME2, 1, XINAM2)
      CALL CHR2H (6, INCLS2, 1, XINCL2)
      XINSE2 = INSEQ2
      XINDS2 = INDSK2
      XINVR2 = INVER2
C                                       IPOL
      INCNO1 = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', INDSK1, INCNO1, INAME1, INCLS1, INSEQ1,
     *   MTYPE, NLUSER, STAT, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET, INAME1, INCLS1, INSEQ1, INDSK1,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      STAT = 'WRIT'
      IF (DOTV) STAT = 'READ'
      CALL CATIO ('READ', INDSK1, INCNO1, CATBLK, STAT, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING IPOL HEADER'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = INDSK1
      FCNO(NCFILE) = INCNO1
      FRW(NCFILE) = 1
      IF (DOTV) FRW(NCFILE) = 0
C                                       Open ZE table
      CALL FNDEXT ('XG', CATBLK, I)
      IF ((INVER1.LE.0) .OR. (INVER1.GT.I)) INVER1 = I
      IF (INVER1.LE.0) THEN
         BPARM(2) = 0.0
         BPARM(3) = 0.0
         BPARM(4) = 0.0
         IBLC(1) = 1
         IBLC(2) = 1
         ITRC(1) = CATBLK(KINAX+1)
         ITRC(2) = CATBLK(KINAX+2)
         REFPIX = CATR(KRCRP)
         ABSORB = -1
      ELSE
         LUN = LUNTMP (1)
         CALL XGINI ('READ', XGBUFF, INDSK1, INCNO1, INVER1, CATBLK,
     *      LUN, IXGRNO, XGKOLS, XGNUMV, NGAUSS, IBLC, ITRC, IDUM, IDUM,
     *      DUM, VOFF, IDUM, REFVAL, REFPIX, REFINC, REFTYP, ABSORB,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING REQUESTED XG TABLE'
            GO TO 990
            END IF
         IF (INVER2.GT.0) THEN
            IF ((REFVAL.NE.ZEFVAL) .OR. (REFPIX.NE.ZEFPIX) .OR.
     *         (REFINC.NE.ZEFINC) .OR. (REFTYP.NE.ZEFTYP)) THEN
               MSGTXT = 'WARNING: ZE FILE COORDINATES DO NOT MATCH' //
     *            ' XG FILE COORDINATES'
               CALL MSGWRT (7)
               END IF
            IF ((ZABSOR.GT.0) .AND. (ABSORB.LE.0)) THEN
               IRET = 10
               MSGTXT = 'V MODEL ABSORPTION, I MODEL EMISSION'
               GO TO 990
            ELSE IF ((ZABSOR.LE.0) .AND. (ABSORB.GT.0)) THEN
               IRET = 10
               MSGTXT = 'I MODEL ABSORPTION, V MODEL EMISSION'
               GO TO 990
               END IF
            END IF
         END IF
      IF (INVER2.GT.0) ABSORB = ZABSOR
      NCHAN = CATBLK(KINAX)
      XINVR1 = INVER1
C                                       channels to do
      IF (CPARM(1).LT.1.0) CPARM(1) = 1.0
      IF (CPARM(1).GT.NCHAN) CPARM(1) = 1.0
      IF (CPARM(2).LE.CPARM(1)) CPARM(2) = NCHAN
      IF (CPARM(2).GT.NCHAN) CPARM(2) = NCHAN
      IF ((CPARM(3).LE.0.05) .OR. (CPARM(3).GT.0.95)) CPARM(3) = 0.5
C                                       pixels to do
      LX = IROUND (APARM(1))
      LY = IROUND (APARM(2))
      IDX = IROUND (APARM(7))
      IDY = IROUND (APARM(8))
      IDY = MAX (0, IDY)
      IF (IDX.GE.0) THEN
         IX1 = MAX (IBLC(1), LX-IDX)
         IX2 = MIN (ITRC(1), LX+IDX)
      ELSE
         IX1 = MAX (IBLC(1), LX-IDY)
         IX2 = MIN (ITRC(1), LX+IDY)
         END IF
      IY1 = MAX (IBLC(2), LY-IDY)
      IY2 = MIN (ITRC(2), LY+IDY)
      IF ((LX.LT.IBLC(1)) .OR. (LX.GT.ITRC(1)) .OR. (LY.LT.IBLC(2)) .OR.
     *   (LY.GT.ITRC(2))) THEN
         IRET = 10
         MSGTXT = 'REQUESTED CENTER PIXEL NOT IN THE IPOL XG TABLE'
         GO TO 990
         END IF
      IF (DOVPOL) THEN
         IF ((LX.LT.JBLC(1)) .OR. (LX.GT.JTRC(1)) .OR. (LY.LT.JBLC(2))
     *      .OR. (LY.GT.JTRC(2))) THEN
            IRET = 10
            MSGTXT = 'REQUESTED CENTER PIXEL NOT IN THE VPOL ZE TABLE'
            GO TO 990
            END IF
         END IF
      XBAR = -REFPIX
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XG2PLI ERROR',I4,' ON ',A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I2,' USID=',I5)
      END
      SUBROUTINE XG2PLG (NCHAN, NP, DBUFF, VBUFF, RBUFF, SBUFF, WBUFF,
     *   XBUFF, IRET)
C-----------------------------------------------------------------------
C   XG2PLG gets the data and models as much as it can for the desired
C   pixel
C   Inputs:
C      NCHAN   I      Number spectral channels
C      NP      I      Number of parameters
C   Output
C      DBUFF   R(*)   Ipol data, model, residual, model comps
C      VBUFF   R(*)   Vpol data, model, residual, model comps
C      RBUFF   R(*)   scratch
C      SBUFF   R(*)   scratch
C      WBUFF   R(*)   scratch
C      XBUFF   R(*)   scratch
C      IRET    I      Error code
C-----------------------------------------------------------------------
      INTEGER   NCHAN, NP, IRET
      REAL      DBUFF(NCHAN,*), VBUFF(NCHAN,*), RBUFF(NCHAN,*),
     *   SBUFF(NCHAN,*), WBUFF(NCHAN,*), XBUFF(NCHAN,*)
C
      INCLUDE 'XG2PL.INC'
      INCLUDE 'XGTABLE.INC'
      INTEGER   IX, IY, IC, IP, NG, NV
      REAL      DR, XS, ZS
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      IRET = -1
      MAXGGA = 0
      MAXVGA = 0
C                                       single pixel
      IF ((APARM(7).EQ.0.0) .AND. (APARM(8).EQ.0.0)) THEN
         NUMPX = 1
         PRTPIX(1,NUMPX) = LX
         PRTPIX(2,NUMPX) = LY
         CALL XG2DAT (LX, LY, NCHAN, DBUFF, VBUFF, NG, NV, XGRMS, ZERMS,
     *      IRET)
         IF (IRET.GT.0) GO TO 999
C                                       average over AREA
      ELSE
         IX = NCHAN * NP
         CALL RFILL (IX, 0.0, WBUFF)
         CALL RFILL (IX, 0.0, XBUFF)
         CALL RFILL (IX, 0.0, DBUFF)
         CALL RFILL (IX, 0.0, VBUFF)
         DR = -1
         NUMPX = 0
         XS = 0.0
         ZS = 0.0
         DO 50 IY = IY1,IY2
            DO 40 IX = IX1,IX2
               IF (IDX.LT.0) THEN
                  DR = (IX-LX)*(IX-LX) + (IY-LY)*(IY-LY)
                  DR = SQRT (DR)
                  END IF
               IF (DR.LE.IDY) THEN
                  IF (NUMPX.LT.MAXPX) NUMPX = NUMPX + 1
                  PRTPIX(1,NUMPX) = IX
                  PRTPIX(2,NUMPX) = IY
                  CALL XG2DAT (IX, IY, NCHAN, RBUFF, SBUFF, NG, NV,
     *               XGRMS, ZERMS, IRET)
                  IF (IRET.NE.0) GO TO 999
                  XS = XS + XGRMS
                  ZS = ZS + ZERMS
                  IF (APARM(9).GT.0.0) THEN
                     NG = MAX (1, NG)
                     NV = MAX (1, NV)
                     END IF
                  DO 30 IP = 1,NP
                     DO 20 IC = 1,NCHAN
                        IF ((RBUFF(IC,IP).NE.FBLANK) .AND. (NG.GT.0))
     *                     THEN
                           WBUFF(IC,IP) = WBUFF(IC,IP) + 1.0
                           DBUFF(IC,IP) = DBUFF(IC,IP) + RBUFF(IC,IP)
                           END IF
                        IF ((SBUFF(IC,IP).NE.FBLANK) .AND. (NV.GT.0))
     *                     THEN
                           XBUFF(IC,IP) = XBUFF(IC,IP) + 1.0
                           VBUFF(IC,IP) = VBUFF(IC,IP) + SBUFF(IC,IP)
                           END IF
 20                     CONTINUE
 30                  CONTINUE
                  END IF
 40            CONTINUE
 50         CONTINUE
         XGRMS = XS / NUMPX
         ZERMS = ZS / NUMPX
         DO 70 IP = 1,NP
            DO 60 IC = 1,NCHAN
               IF (WBUFF(IC,IP).GT.0.0) THEN
                  DBUFF(IC,IP) = DBUFF(IC,IP) / WBUFF(IC,IP)
                  IRET = 0
               ELSE
                  DBUFF(IC,IP) = FBLANK
                  END IF
               IF (XBUFF(IC,IP).GT.0.0) THEN
                  VBUFF(IC,IP) = VBUFF(IC,IP) / XBUFF(IC,IP)
                  IRET = 0
               ELSE
                  VBUFF(IC,IP) = FBLANK
                  END IF
 60            CONTINUE
 70         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE XG2DAT (MX, MY, NCHAN, DBUFF, VBUFF, NG, NV, XRMS,
     *   ZRMS, IRET)
C-----------------------------------------------------------------------
C   Gets the data for 1 pixel
C   Inputs:
C      MX      I      X pixel (actually Y in cubes)
C      MY      I      Y pixel (actually Z in cubes)
C      NCHAN   I      Number spectral channels
C   Outputs:
C      DBUFF   R(*)   Ipol data, model, residual, components
C      VBUFF   R(*)   Vpol data, model, residual, components
C      NG      I      Number gaussians in model
C      NV      I      number comps in V model
C      IRET    I      Error
C-----------------------------------------------------------------------
      INTEGER   MX, MY, NCHAN, NG, NV, IRET
      REAL      DBUFF(NCHAN,*), VBUFF(NCHAN,*), XRMS, ZRMS
C
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'XG2PL.INC'
      INCLUDE 'XGTABLE.INC'
      INTEGER   LUN, IND, IDEPTH(5), WIN(4), IBIND, JBUFSZ, I, NP, BOI,
     *   YZPIX(2), J, K, IRNO
      REAL      BUFF1(UVBFSS), VPEAK, AMP, POS, SIG, DR, X, XGAUSB(2),
     *   XGAUSV(3,MAXGAU), VANS(1+MAXGAU,2), TAU, CONT, RCONT,
     *   RESULT(4+6*MAXGAU)
      LOGICAL   DOTAU
      CHARACTER PHNAME*48
      DOUBLE PRECISION HALFAC
      INCLUDE 'INCS:DHDR.INC'
      DATA HALFAC /2.77258872D0/
C-----------------------------------------------------------------------
      NP = 5 + MAXGAU
      I = NP * NCHAN
      CALL RFILL (I, FBLANK, DBUFF)
      CALL RFILL (I, FBLANK, VBUFF)
      DOTAU = (ABSORB.GT.0) .AND. (CPARM(7).GT.0.0)
C                                       read Ipol spectrum
      WIN(1) = 1
      WIN(2) = MX
      WIN(3) = NCHAN
      WIN(4) = MX
      IDEPTH(1) = MY
      IDEPTH(2) = 1
      IDEPTH(3) = 1
      IDEPTH(4) = 1
      IDEPTH(5) = 1
      JBUFSZ = 2 * UVBFSS
      LUN = 33
      CALL ZPHFIL ('MA', INDSK1, INCNO1, 1, PHNAME, IRET)
      CALL ZOPEN (LUN, IND, INDSK1, PHNAME, .TRUE., .FALSE., .TRUE.,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN IPOL IMAGE'
         GO TO 990
         END IF
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH, BOI, IRET)
      BOI = BOI + 1
      CALL MINIT ('READ', LUN, IND, CATBLK(KINAX), CATBLK(KINAX+1),
     *   WIN, BUFF1, JBUFSZ, BOI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT IO TO IPOL IMAGE'
         GO TO 990
         END IF
      CALL MDISK ('READ', LUN, IND, BUFF1, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ IPOL IMAGE'
         GO TO 990
         END IF
      CALL ZCLOSE (LUN, IND, IRET)
      CALL RCOPY (NCHAN, BUFF1(IBIND), DBUFF(1,1))
C                                       read Vpol spectrum
      IF (DOVPOL) THEN
         CALL ZPHFIL ('MA', INDSK2, INCNO2, 1, PHNAME, IRET)
         CALL ZOPEN (LUN, IND, INDSK2, PHNAME, .TRUE., .FALSE., .TRUE.,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN VPOL IMAGE'
            GO TO 990
            END IF
         CALL COMOFF (CAT2(KIDIM), CAT2(KINAX), IDEPTH, BOI, IRET)
         BOI = BOI + 1
         CALL MINIT ('READ', LUN, IND, CAT2(KINAX), CAT2(KINAX+1),
     *      WIN, BUFF1, JBUFSZ, BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT IO TO VPOL IMAGE'
            GO TO 990
            END IF
         CALL MDISK ('READ', LUN, IND, BUFF1, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ VPOL IMAGE'
            GO TO 990
            END IF
         CALL ZCLOSE (LUN, IND, IRET)
         CALL RCOPY (NCHAN, BUFF1(IBIND), VBUFF(1,1))
         END IF
C                                       Ipol model
      IF (INVER1.GT.0) THEN
         J = 2 * 3 * MAXGAU
         CALL RFILL (J, FBLANK, PRTGV(1,1,NUMPX))
         IRNO = (ITRC(1)-IBLC(1)+1) * (MY - IBLC(2)) + MX - IBLC(1)+1
         CALL TABXG ('READ', XGBUFF, IRNO, XGKOLS, XGNUMV, YZPIX, NG,
     *      VPEAK, XRMS, RESULT, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ XG TABLE'
            GO TO 990
            END IF
         J = 2 + 3*NGAUSS
         CALL RCOPY (J, RESULT(1), PRTGV(1,1,NUMPX))
         CALL RCOPY (J, RESULT(1+J), PRTGV(1,2,NUMPX))
C                                       check consistent
         IF ((YZPIX(1).NE.MX) .OR. (YZPIX(2).NE.MY)) THEN
            WRITE (MSGTXT,1010) YZPIX, 'XG', MX, MY
            IRET = 10
            GO TO 990
            END IF
         CALL RFILL (NCHAN, 0.0, DBUFF(1,2))
         CALL RFILL (NCHAN, 0.0, DBUFF(1,4))
         MAXGGA = MAX (MAXGGA, NG)
C                                       baseline
         IF (PRTGV(1,1,NUMPX).NE.FBLANK) THEN
C                                       save continuum in absorb case
            DO 20 I = 1,NCHAN
               DBUFF(I,4) = PRTGV(1,1,NUMPX)
               IF (PRTGV(2,1,NUMPX).NE.FBLANK) DBUFF(I,4) = DBUFF(I,4) +
     *            PRTGV(2,1,NUMPX)*(I+XBAR)
 20            CONTINUE
            IF (.NOT.DOTAU) THEN
               CALL RCOPY (NCHAN, DBUFF(1,4), DBUFF(1,2))
            ELSE
               DO 25 I = 1,NCHAN
                  IF ((DBUFF(I,1).NE.FBLANK) .AND. (DBUFF(I,1).GT.0.0))
     *               DBUFF(I,1) = LOG (DBUFF(I,4) / DBUFF(I,1))
 25               CONTINUE
               END IF
         ELSE IF (ABSORB.GT.0) THEN
            IRET = -1
            GO TO 999
            END IF
C                                       Gaussians
         DO 40 I = 1,NCHAN
            TAU = 0.0
            DO 30 J = 1,NGAUSS
               K = 3 + 3 * (J-1)
               IF ((PRTGV(K,1,NUMPX).NE.FBLANK) .AND.
     *            (PRTGV(K+1,1,NUMPX).NE.FBLANK).AND.
     *            (PRTGV(K+2,1,NUMPX).NE.FBLANK)) THEN
                  AMP = PRTGV(K,1,NUMPX)
                  POS = PRTGV(K+1,1,NUMPX)
                  SIG = PRTGV(K+2,1,NUMPX)
                  DR = I + XBAR
                  DR = (DR - POS) / SIG
                  DR = HALFAC * DR * DR
                  IF (DR.LT.14.0) THEN
                     IF (ABSORB.LE.0) THEN
                        DBUFF(I,5+J) = AMP * EXP(-DR)
                        DBUFF(I,2) = DBUFF(I,2) + DBUFF(I,5+J)
                     ELSE
                        DR = AMP * EXP (-DR)
                        TAU = TAU + DR
                        IF (DOTAU) THEN
                           DBUFF(I,5+J) = DR
                        ELSE
                           DBUFF(I,5+J) = DBUFF(I,4) * EXP(-DR)
                           END IF
                        END IF
                     END IF
                  END IF
 30            CONTINUE
            IF (ABSORB.GT.0) THEN
               DBUFF(I,5) = DBUFF(I,4) * EXP (-TAU)
               IF (DOTAU) THEN
                  DBUFF(I,2) = TAU
               ELSE
                  DBUFF(I,2) = DBUFF(I,4) * EXP (-TAU)
                  END IF
               END IF
 40         CONTINUE
C                                       residual
         DO 50 I = 1,NCHAN
            IF ((DBUFF(I,1).NE.FBLANK) .AND. (DBUFF(I,2).NE.FBLANK))
     *         DBUFF(I,3) = DBUFF(I,1) - DBUFF(I,2)
 50         CONTINUE
         END IF
C                                       Vpol model
      IF ((DOVPOL) .AND. (INVER2.GT.0) .AND.
     *   ((DOGAUS.LE.0) .OR. (INVER1.GT.0))) THEN
         J = (1 * MAXGAU) * 2
         CALL RFILL (J, FBLANK, PRTZV(1,1,NUMPX))
         IRNO = (JTRC(1)-JBLC(1)+1) * (MY - JBLC(2)) + MX - JBLC(1)+1
         CALL TABZE ('READ', ZEBUFF, IRNO, ZEKOLS, ZENUMV, YZPIX,
     *      VPEAK, ZRMS, VANS, NV, XGAUSV, XGAUSB, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ XG TABLE'
            GO TO 990
            END IF
C                                       check consistent
         IF ((YZPIX(1).NE.MX) .OR. (YZPIX(2).NE.MY)) THEN
            WRITE (MSGTXT,1010) YZPIX, 'XG', MX, MY
            IRET = 10
            GO TO 990
            END IF
         J = MAX (2, 1+NV)
         CALL RCOPY (J, VANS(1,1), PRTZV(1,1,NUMPX))
         CALL RCOPY (J, VANS(1,2), PRTZV(1,2,NUMPX))
         MAXVGA = MAX (MAXVGA, NV)
         IF (VANS(1,1).NE.FBLANK) THEN
            IF (DOTAU) THEN
               K = 5
            ELSE
               K = 1
               END IF
            IF (ABSORB.EQ.2) THEN
               DO 55 I = 1,NCHAN
                  VBUFF(I,2) = VANS(1,1) * (DBUFF(I,K) - DBUFF(I,4))
 55               CONTINUE
            ELSE
               DO 60 I = 1,NCHAN
                  VBUFF(I,2) = VANS(1,1) * DBUFF(I,K)
 60               CONTINUE
               END IF
         ELSE
            CALL RFILL (NCHAN, 0.0, VBUFF(1,2))
            END IF
C                                       2-sided slope
         IF (DOGAUS.LT.0) THEN
            IF ((DBUFF(1,1).NE.FBLANK) .AND. (DBUFF(2,1).NE.FBLANK)
     *         .AND. (VANS(2,1).NE.FBLANK)) THEN
               VBUFF(1,5) = VANS(2,1) * (DBUFF(2,1)-DBUFF(1,1)) / 2.0
               VBUFF(1,2) = VBUFF(1,2) + VBUFF(1,5)
               IF (VANS(1,1).NE.FBLANK) VBUFF(1,5) = VBUFF(1,5) +
     *            VANS(1,1) * DBUFF(1,1)
               END IF
            IF ((DBUFF(NCHAN-1,1).NE.FBLANK) .AND. (VANS(2,1).NE.FBLANK)
     *         .AND. (DBUFF(NCHAN,1).NE.FBLANK)) THEN
               VBUFF(NCHAN,5) = VANS(2,1) * (DBUFF(NCHAN,1) -
     *            DBUFF(NCHAN-1,1)) / 2.0
               VBUFF(NCHAN,2) = VBUFF(NCHAN,2) + VBUFF(NCHAN,5)
               IF (VANS(1,1).NE.FBLANK) VBUFF(NCHAN,5) = VBUFF(NCHAN,5)
     *            + VANS(1,1) * DBUFF(NCHAN,1)
               END IF
            DO 70 I = 2,NCHAN-1
               IF ((DBUFF(I-1,1).NE.FBLANK) .AND. (VANS(2,1).NE.FBLANK)
     *            .AND. (DBUFF(I+1,1).NE.FBLANK)) THEN
                  VBUFF(I,5) = VANS(2,1) * (DBUFF(I+1,1) -
     *               DBUFF(I-1,1)) / 4.0
                  VBUFF(I,2) = VBUFF(I,2) + VBUFF(I,5)
                  IF (VANS(1,1).NE.FBLANK) VBUFF(I,5) = VBUFF(I,5) +
     *               VANS(1,1) * DBUFF(I,1)
                  END IF
 70            CONTINUE
C                                       one-sided
         ELSE IF (DOGAUS.EQ.0) THEN
            IF ((DBUFF(1,1).NE.FBLANK) .AND. (DBUFF(2,1).NE.FBLANK)
     *         .AND. (VANS(2,1).NE.FBLANK)) THEN
               VBUFF(1,5) = VANS(2,1) * (DBUFF(2,1)-DBUFF(1,1)) / 2.0
               VBUFF(1,2) = VBUFF(1,2) + VBUFF(1,5)
               IF (VANS(1,1).NE.FBLANK) VBUFF(1,5) = VBUFF(1,5) +
     *            VANS(1,1) * DBUFF(1,1)
               END IF
            IF ((DBUFF(NCHAN-1,1).NE.FBLANK) .AND. (VANS(2,1).NE.FBLANK)
     *         .AND. (DBUFF(NCHAN,1).NE.FBLANK)) THEN
               VBUFF(NCHAN,5) = VANS(2,1) * (DBUFF(NCHAN,1) -
     *            DBUFF(NCHAN-1,1)) / 2.0
               VBUFF(NCHAN,2) = VBUFF(NCHAN,2) + VBUFF(NCHAN,5)
               IF (VANS(1,1).NE.FBLANK) VBUFF(NCHAN,5) = VBUFF(NCHAN,5)
     *            + VANS(1,1) * DBUFF(NCHAN,1)
               END IF
            DO 80 I = 2,NCHAN-1
               IF ((DBUFF(I,1).NE.FBLANK) .AND. (VANS(2,1).NE.FBLANK)
     *            .AND. (DBUFF(I+1,1).NE.FBLANK)) THEN
                  VBUFF(I,5) = VANS(2,1) * (DBUFF(I+1,1)-DBUFF(I,1))/2.0
                  VBUFF(I,2) = VBUFF(I,2) + VBUFF(I,5)
                  IF (VANS(1,1).NE.FBLANK) VBUFF(I,5) = VBUFF(I,5) +
     *               VANS(1,1) * DBUFF(I,1)
                  END IF
 80            CONTINUE
C                                       Gaussians emission
         ELSE IF (ABSORB.LE.0) THEN
            DO 90 J = 1,NV
               IF ((XGAUSV(1,J).NE.FBLANK) .AND. (XGAUSV(3,J).NE.0.0)
     *            .AND. (VANS(1+J,1).NE.FBLANK)) THEN
                  AMP = XGAUSV(1,J)
                  POS = XGAUSV(2,J)
                  SIG = ABS (XGAUSV(3,J))
                  DO 85 I = 1,NCHAN
                     X = I + XBAR
                     DR = (X - POS) / SIG
                     DR = HALFAC * DR * DR
                     IF (DR.LT.14.0) THEN
                        DR = AMP *  EXP (-DR)
                        VBUFF(I,5+J) = -DR * VANS(1+J,1) * HALFAC *
     *                     (X - POS) / (SIG * SIG)
                        VBUFF(I,2) = VBUFF(I,2) + VBUFF(I,5+J)
                        IF (VANS(1,1).NE.FBLANK) VBUFF(I,5+J) =
     *                     VBUFF(I,5+J) + VANS(1,1) * DBUFF(I,1)
                        END IF
 85                  CONTINUE
                  END IF
 90            CONTINUE
C                                       gaussians absorption
         ELSE
            DO 110 I = 1,NCHAN
               TAU = 0.0
               IF (I.EQ.75) THEN
                  MSGTXT = 'WE ARE HERE'
                  END IF
               DO 95 J = 1,NV
                  IF ((XGAUSV(1,J).NE.FBLANK) .AND. (XGAUSV(3,J).NE.0.0)
     *               .AND. (VANS(1+J,1).NE.FBLANK)) THEN
                     AMP = XGAUSV(1,J)
                     POS = XGAUSV(2,J)
                     SIG = ABS (XGAUSV(3,J))
                     X = I + XBAR
                     DR = (X - POS) / SIG
                     DR = HALFAC * DR * DR
                     IF (DR.LT.14.0) THEN
                        DR = AMP *  EXP (-DR)
                        TAU = TAU + DR
                        END IF
                     END IF
 95               CONTINUE
               CONT = XGAUSB(1)
               IF (XGAUSB(2).NE.FBLANK) CONT = CONT + X * XGAUSB(2)
               RCONT = CONT
               CONT = CONT * EXP (-TAU)
               DO 105 J = 1,NV
                  IF ((XGAUSV(1,J).NE.FBLANK) .AND. (XGAUSV(3,J).NE.0.0)
     *               .AND. (VANS(1+J,1).NE.FBLANK)) THEN
                     AMP = XGAUSV(1,J)
                     POS = XGAUSV(2,J)
                     SIG = ABS (XGAUSV(3,J))
                     X = I + XBAR
                     DR = (X - POS) / SIG
                     DR = HALFAC * DR * DR
                     IF (DR.LT.14.0) THEN
                        DR = AMP *  EXP (-DR)
                        VBUFF(I,5+J) = CONT * DR * VANS(1+J,1) * HALFAC
     *                     * (X - POS) / (SIG * SIG)
                        VBUFF(I,2) = VBUFF(I,2) + VBUFF(I,5+J)
                        IF (VANS(1,1).NE.FBLANK) THEN
                           IF (ABSORB.EQ.2) THEN
                              VBUFF(I,5+J) = VBUFF(I,5+J) + VANS(1,1) *
     *                           (CONT - RCONT)
                           ELSE
                              VBUFF(I,5+J) = VBUFF(I,5+J) + VANS(1,1) *
     *                           CONT
                              END IF
                           END IF
                        END IF
                     END IF
 105              CONTINUE
 110           CONTINUE
            END IF
         DO 120 I = 1,NCHAN
            IF ((VBUFF(I,1).NE.FBLANK) .AND. (VBUFF(I,2).NE.FBLANK))
     *         VBUFF(I,3) = VBUFF(I,1) - VBUFF(I,2)
120         CONTINUE
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XG2DAT ERROR',I4,' ON ',A)
 1010 FORMAT ('XG2DAT FOUND PIXEL',2I6,' IN ',A2,' TABLE, WANTED',2I6)
      END
      SUBROUTINE XG2PLP (NCHAN, NP, DBUFF, VBUFF, IRET)
C-----------------------------------------------------------------------
C   XG2PLP does the requested plots
C   Inputs:
C      NCHAN   I      Number spectral channels
C      NP      I      Number parameters
C      DBUFF   R(*)   Ipol data
C      VBUFF   R(*)   Vpol data
C   Outputs:
C      IRET    I      Error code
C-----------------------------------------------------------------------
      INTEGER   NCHAN, NP, IRET
      REAL      DBUFF(NCHAN,*), VBUFF(NCHAN,*)
C
      INCLUDE 'XG2PL.INC'
      INCLUDE 'XGTABLE.INC'
      INCLUDE 'XGPLOT.INC'
      INTEGER   I, J, K, PVER, IERR, IDEPTH(5), IPSIZE, ITYPE, LTYPE,
     *   INP, JTRIM, INCHAR, IT(3), ID(3), BC, EC, NC, DOTAU
      LOGICAL   DOBOTH, GOOD, DOWN
      REAL      IMAX, IMIN, VMAX, VMIN, XYSCL(3), XYOFF(3), CHOUT(4),
     *   TEMP, TI, TR, X, Y, DX, DY, XX, XBLC(2), XTRC(2), YMIN, XXMIN
      CHARACTER PFILE*48, COMMNT*48, PTYPES(4)*10, TEXT*128, CTEMP*18,
     *   TIME*8, DATE*12
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA IDEPTH /5*1/
      DATA PTYPES /'data', 'model', 'residual', 'components'/
C-----------------------------------------------------------------------
      DOTAU = 0
      IF (ABSORB.GT.0) DOTAU = 1
      IF ((ABSORB.GT.0) .AND. (CPARM(7).GT.0.0)) DOTAU = 2
      PLOTI = (BPARM(1).GT.0.0) .OR. (BPARM(2).GT.0.0) .OR.
     *   (BPARM(3).GT.0.0) .OR. (BPARM(4).GT.0.0)
      PLOTV = (BPARM(6).GT.0.0) .OR. (BPARM(7).GT.0.0) .OR.
     *   (BPARM(8).GT.0.0) .OR. (BPARM(9).GT.0.0)
      DOBOTH = PLOTI .AND. PLOTV
      IF ((.NOT.PLOTI) .AND. (.NOT.PLOTV)) THEN
         IRET = 0
         MSGTXT = 'NO PLOTS REQUESTED'
         CALL MSGWRT (7)
         GO TO 999
         END IF
      BC = CPARM(1) + 0.1
      EC = CPARM(2) + 0.1
      NC = EC - BC + 1
C                                       scaling
      IF ((PLOTI) .AND. (APARM(4).LE.APARM(3))) THEN
         IMAX = -1.E10
         IMIN = 1.E10
         DO 20 I = BC,EC
            DO 15 J = 1,NP
               IF ((J.NE.4) .AND. (J.NE.5)) THEN
                  K = MIN (4, J)
                  IF (BPARM(K).GT.0.0) THEN
                     IF (DBUFF(I,J).NE.FBLANK) THEN
                        IMAX = MAX (IMAX, DBUFF(I,J))
                        IMIN = MIN (IMIN, DBUFF(I,J))
                        END IF
                     END IF
                  END IF
 15            CONTINUE
 20         CONTINUE
         APARM(4) = IMAX
         APARM(3) = IMIN
      ELSE IF (PLOTI) THEN
         IMAX = APARM(4)
         IMIN = APARM(3)
      ELSE
         APARM(4) = 1.0
         APARM(3) = -1.0
         END IF
      IF ((PLOTV) .AND. (APARM(6).LE.APARM(5))) THEN
         VMAX = -1.E10
         VMIN = 1.E10
         DO 30 I = BC,EC
            DO 25 J = 1,NP
               IF ((J.NE.4) .AND. (J.NE.5)) THEN
                  K = MIN (4, J) + 5
                  IF (BPARM(K).GT.0.0) THEN
                     IF (VBUFF(I,J).NE.FBLANK) THEN
                        VMAX = MAX (VMAX, VBUFF(I,J))
                        VMIN = MIN (VMIN, VBUFF(I,J))
                        END IF
                     END IF
                  END IF
 25            CONTINUE
 30         CONTINUE
         APARM(6) = VMAX
         APARM(5) = VMIN
      ELSE IF (PLOTV) THEN
         VMAX = APARM(6)
         VMIN = APARM(5)
      ELSE
         APARM(6) = 1.0
         APARM(5) = -1.0
         END IF
C                                       Add PLot file to header
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', INDSK1, INCNO1, CATBLK, SCRTCH, .TRUE.,
     *      'READ', PVER, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'ADDING PL FILE TO HEADER'
            CALL MSGWRT (8)
            GO TO 999
            END IF
         FRW(NCFILE) = 0
         END IF
C                                       Create plot file
      CALL ZPHFIL ('PL', INDSK1, INCNO1, PVER, PFILE, IRET)
      IPSIZE = 0
      ITYPE = 48
      TVCORN(1) = 0
      TVCORN(2) = 0
      CALL GINIT (INDSK1, INCNO1, PFILE, IPSIZE, ITYPE, NPARMS, XINAM1,
     *   DOTV, TVCHN, GRCHN, TVCORN, CATBLK, PLBUFF, PLUN, PIND, IRET)
      IF (IRET.NE.0) GO TO 980
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
C                                       Set up location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      DO 40 I = 1,3
         IF (I.EQ.1) THEN
            XYOFF(I) = BC
            XYSCL(I) = EC
         ELSE
            XYSCL(I) = APARM(2*I)
            XYOFF(I) = APARM(2*I-1)
            END IF
         TEMP = 0.03 * (XYSCL(I) - XYOFF(I))
         XYSCL(I) = XYSCL(I) + TEMP
         XYOFF(I) = XYOFF(I) - TEMP
         IF (XYSCL(I).EQ.XYOFF(I)) GO TO 999
         XYSCL(I) = 1000. / (XYSCL(I)-XYOFF(I))
 40      CONTINUE
      IF (.NOT.PLOTI) THEN
         LINT = 1000.0
         XYSCL(2) = XYSCL(3)
         XYOFF(2) = XYOFF(3)
      ELSE IF (.NOT.PLOTV) THEN
         LINT = 0.0
      ELSE
         LINT = 1000.0 * CPARM(3)
         XYSCL(2) = XYSCL(2) * (1.0 - CPARM(3))
         XYSCL(3) = XYSCL(3) * CPARM(3)
         END IF
C                                       characters to left
      XBLC(1) = BLC(1)
      XTRC(1) = TRC(1)
      INCHAR = 0
      IF ((PLOTI) .AND. (PLOTV)) THEN
C                                       axis labeling: lower plot
         XBLC(2) = BLC(2)
         XTRC(2) = LINT
         J = 1
         DO 45 I = 1,2
            TR = (XTRC(I)-XBLC(I)) / XYSCL(J)
            TI = TR
            IF ((I.EQ.1) .AND. (CPARM(5).GT.0.0)) THEN
               RPLOC(I,LOCNUM) = XTRC(I)
               AXINC(I,LOCNUM) = TR / (XBLC(I) - XTRC(I))
            ELSE
               RPLOC(I,LOCNUM) = XBLC(I)
               AXINC(I,LOCNUM) = TR / (XTRC(I) - XBLC(I))
               END IF
            RPVAL(I,LOCNUM) = XYOFF(J)
            CALL METSCL (LABEL, TR, CPREF(I,LOCNUM), GOOD)
            RPVAL(I,LOCNUM) = RPVAL(I,LOCNUM) * TR / TI
            AXINC(I,LOCNUM) = AXINC(I,LOCNUM) * TR / TI
            J = J + 2
 45         CONTINUE
         CALL CHNTIC (XBLC, XTRC, INCHAR)
         END IF
C                                       axis labeling: upper plot
      IF (PLOTI) THEN
         XBLC(2) = LINT
         XTRC(2) = TRC(2)
      ELSE
         XBLC(2) = BLC(2)
         XTRC(2) = TRC(2)
         END IF
      DO 50 I = 1,2
         TR = (XTRC(I)-XBLC(I)) / XYSCL(I)
         TI = TR
         IF ((I.EQ.1) .AND. (CPARM(5).GT.0.0)) THEN
            RPLOC(I,LOCNUM) = XTRC(I)
            AXINC(I,LOCNUM) = TR / (XBLC(I) - XTRC(I))
         ELSE
            RPLOC(I,LOCNUM) = XBLC(I)
            AXINC(I,LOCNUM) = TR / (XTRC(I) - XBLC(I))
            END IF
         RPVAL(I,LOCNUM) = XYOFF(I)
         CALL METSCL (LABEL, TR, CPREF(I,LOCNUM), GOOD)
         RPVAL(I,LOCNUM) = RPVAL(I,LOCNUM) * TR / TI
         AXINC(I,LOCNUM) = AXINC(I,LOCNUM) * TR / TI
 50      CONTINUE
      CALL CHNTIC (XBLC, XTRC, INP)
      INP = MAX (INP, INCHAR)
C                                       Count characters around
      CALL RFILL (4, 0.5, CHOUT)
      LTYPE = MOD (ABS (LABEL), 100)
      IF (LTYPE.EQ.2) CHOUT(1) = 2.5
      IF ((LTYPE.GT.2) .AND. (INP.GT.0)) CHOUT(1) = 4.0 + INP
      IF (LTYPE.GT.1) CHOUT(2) = 2.0
      IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         CHOUT(4) = 3.333
         IF (DOVPOL) CHOUT(4) = CHOUT(4) + 1.333
         IF (LABEL.GT.1) CHOUT(4) = CHOUT(4) + 1.333
         END IF
C                                       default XYRATIO
      IF (XYRATO.LT.0.01) THEN
         IF (DOTV) THEN
            XXMIN = WINDTV(3) - WINDTV(1) + 1 - CSIZTV(1) * (CHOUT(1)
     *         + CHOUT(3))
            YMIN = WINDTV(4) - WINDTV(2) + 1 - CSIZTV(2) * (CHOUT(2)
     *         + CHOUT(4))
            XYRATO = 1.0
            IF (YMIN.GT.0.0) XYRATO = XXMIN / YMIN
         ELSE
            XYRATO = 1.0
            END IF
         END IF
C                                       Init for line drawing.
      CALL GINITL (BLC, TRC, XYRATO, CHOUT, IDEPTH, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GLTYPE (1, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Draw border
      CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), BLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), BLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (TRC(1), TRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL GVEC (BLC(1), TRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
      IF (DOBOTH) THEN
         CALL GPOS (BLC(1), LINT, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL GVEC (TRC(1), LINT, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
         END IF
C                                       extra labels
      DX = 0.0
      IF ((LABEL.GT.1) .AND. (LTYPE.LT.7)) THEN
         DY = 0.5 + 2 * 1.333
         IF (DOVPOL) DY = DY + 1.333
         CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, TIME, DATE)
         WRITE (TEXT,1050) PVER, DATE, TIME
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
         END IF
C                                       Top labels: type & name
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DY = 0.5 + 1.333
         IF (DOVPOL) DY = DY + 1.333
         CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
         INP = 21
         WRITE (TEXT,1051) 'XG', INVER1
         TEXT(INP-1:INP-1) = '_'
         CALL H2CHR (18, 1, CATH(KHIMN), CTEMP)
         CALL NAMEST (CTEMP, INSEQ1, TEXT(INP:), INCHAR)
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
         IF (DOVPOL) THEN
            DY = DY - 1.333
            CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 970
            INP = 21
            WRITE (TEXT,1051) 'ZE', INVER2
            TEXT(INP-1:INP-1) = '_'
            CALL H2CHR (18, 1, CATH2(KHIMN), CTEMP)
            CALL NAMEST (CTEMP, INSEQ2, TEXT(INP:), INCHAR)
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 970
            END IF
         DY = DY - 1.333
         CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
         IF ((IDX.EQ.0) .AND. (IDY.EQ.0)) THEN
            WRITE (TEXT,1060) LX, LY
         ELSE IF (IDX.LT.0) THEN
            WRITE (TEXT,1061) LX, LY, IDY
         ELSE
            WRITE (TEXT,1062) IX1, IX2, IY1, IY2
            END IF
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 970
         END IF
C                                       axis labeling
      K = CPARM(4) + 1.1
      CALL XG2LAB (K, PLOTI, PLOTV, BLC, TRC, LINT, BC, EC, XYSCL,
     *   XYOFF, CHOUT, LABEL, XYRATO, DOTAU, XGRMS, ZERMS, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Plot I
      IF (PLOTI) THEN
         DO 140 J = 1,NP
            IF ((J.EQ.4) .OR. (J.EQ.5)) GO TO 140
            K = MIN (4, J)
            IF (BPARM(K).GT.0.0) THEN
               CALL GLTYPE (K, PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 970
               COMMNT = 'Plot Ipol ' // PTYPES(K)
               INP = JTRIM (COMMNT)
               CALL GCOMNT (-1, COMMNT(:INP), PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 970
               DOWN = .FALSE.
               DO 120 I = BC,EC
                  IF (DBUFF(I,J).NE.FBLANK) THEN
                     Y = XYSCL(2) * (DBUFF(I,J) - XYOFF(2)) + LINT
                     IF ((Y.GE.LINT) .AND. (Y.LE.TRC(2))) THEN
                        IF ((J.EQ.1) .AND. (CPARM(6).LE.0.0)) THEN
                           XX = I - 0.5 - XYOFF(1)
                           IF (CPARM(5).GT.0.0) XX = EC + BC - I + 0.5 -
     *                        XYOFF(1)
                           X = XYSCL(1) * XX
                           IF (DOWN) THEN
                              CALL GVEC (X, Y, PLBUFF, IRET)
                           ELSE
                              CALL GPOS (X, Y, PLBUFF, IRET)
                              DOWN = .TRUE.
                              END IF
                           IF (IRET.NE.0) GO TO 970
                           XX = I + 0.5 - XYOFF(1)
                           IF (CPARM(5).GT.0.0) XX = EC + BC - I - 0.5 -
     *                        XYOFF(1)
                           X = XYSCL(1) * XX
                           CALL GVEC (X, Y, PLBUFF, IRET)
                           IF (IRET.NE.0) GO TO 970
                        ELSE
                           XX = I - XYOFF(1)
                           IF (CPARM(5).GT.0.0) XX = EC + BC - I -
     *                        XYOFF(1)
                           X = XYSCL(1) * XX
                           IF (DOWN) THEN
                              CALL GVEC (X, Y, PLBUFF, IRET)
                           ELSE
                              CALL GPOS (X, Y, PLBUFF, IRET)
                              DOWN = .TRUE.
                              END IF
                           IF (IRET.NE.0) GO TO 970
                           END IF
                     ELSE
                        DOWN = .FALSE.
                        END IF
                  ELSE
                     DOWN = .FALSE.
                     END IF
 120              CONTINUE
               END IF
 140        CONTINUE
         END IF
      IF (PLOTV) THEN
         DO 190 J = 1,NP
            IF ((J.EQ.4) .OR. (J.EQ.5)) GO TO 190
            K = MIN (4, J)
            IF (BPARM(K+5).GT.0.0) THEN
               CALL GLTYPE (K, PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 970
               COMMNT = 'Plot Vpol ' // PTYPES(K)
               INP = JTRIM (COMMNT)
               CALL GCOMNT (-1, COMMNT(:INP), PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 970
               DOWN = .FALSE.
               DO 170 I = BC,EC
                  IF (VBUFF(I,J).NE.FBLANK) THEN
                     Y = XYSCL(3) * (VBUFF(I,J) - XYOFF(3))
                     IF ((Y.GE.BLC(2)) .AND. (Y.LE.LINT)) THEN
                        IF ((J.EQ.1) .AND. (CPARM(6).LE.0.0)) THEN
                           XX = I - 0.5 - XYOFF(1)
                           IF (CPARM(5).GT.0.0) XX = EC + BC - I + 0.5 -
     *                        XYOFF(1)
                           X = XYSCL(1) * XX
                           IF (DOWN) THEN
                              CALL GVEC (X, Y, PLBUFF, IRET)
                           ELSE
                              CALL GPOS (X, Y, PLBUFF, IRET)
                              DOWN = .TRUE.
                              END IF
                           IF (IRET.NE.0) GO TO 970
                           XX = I + 0.5 - XYOFF(1)
                           IF (CPARM(5).GT.0.0) XX = EC + BC - I - 0.5 -
     *                        XYOFF(1)
                           X = XYSCL(1) * XX
                           CALL GVEC (X, Y, PLBUFF, IRET)
                           IF (IRET.NE.0) GO TO 970
                        ELSE
                           XX = I - XYOFF(1)
                           IF (CPARM(5).GT.0.0) XX = EC + BC - I -
     *                        XYOFF(1)
                           X = XYSCL(1) * XX
                           IF (DOWN) THEN
                              CALL GVEC (X, Y, PLBUFF, IRET)
                           ELSE
                              CALL GPOS (X, Y, PLBUFF, IRET)
                              DOWN = .TRUE.
                              END IF
                           IF (IRET.NE.0) GO TO 970
                           END IF
                     ELSE
                        DOWN = .FALSE.
                        END IF
                  ELSE
                     DOWN = .FALSE.
                     END IF
 170              CONTINUE
               END IF
 190        CONTINUE
         END IF
C                                       finish plot
      CALL GFINIS (PLBUFF, IRET)
      IF (IRET.EQ.0) GO TO 990
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      CALL GFINIS (PLBUFF, I)
      IF (I.EQ.0) GO TO 990
C                                       Destroy the plot file
 980  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (PLUN, PIND, IERR)
         CALL ZDESTR (INDSK1, PFILE, IERR)
         CALL DELEXT ('PL', INDSK1, INCNO1, 'READ', CATBLK, SCRTCH,
     *      PVER, IERR)
         END IF
      GO TO 999
C
 990  IF (.NOT.DOTV) THEN
         WRITE (MSGTXT,1993) PVER
         CALL MSGWRT (2)
         CALL HIPLOT (INDSK1, INCNO1, PVER, SCRTCH, I)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XG2PLP ERROR',I4,' ON ',A)
 1050 FORMAT ('Plot file version',I4,'__created ',A12,A8)
 1051 FORMAT ('Ext ',A2,'__Vers',I4)
 1060 FORMAT ('Single pixel at X =_',I6,'__Y =_',I6)
 1061 FORMAT ('Circle centered on X =_',I6,'__Y =_',I6,'__radius =_',
     *   I4)
 1062 FORMAT ('Rectangle X =_',I6,' - ',I6,'___Y =_',I6,' - ',I6)
 1970 FORMAT ('XG2PLP Error during graphing. will try to finish',
     *   ' partial graph')
 1993 FORMAT ('Plot file version',I5,'  created.')
      END
      SUBROUTINE XG2LAB (ITYP, PLOTI, PLOTV, BLC, TRC, LINT, BC, EC,
     *   XYSCL, XYOFF, CHOUT, LABEL, XYRATO, DOTAU, XGRMS, ZERMS,
     *   PLBUFF, IRET)
C-----------------------------------------------------------------------
C   XG2LAB handles the labeling
C   Inputs:
C      ITYP     I      2 freq, 3 velocity, else channels
C      PLOTI    L      Plot Ipol
C      PLOTV    L      Plot VPOL
C      BLC      R(2)   BLC of full plot area
C      TRC      R(2)   TRC of full plot area
C      LINT     R      Division between I and V
C      BC       I      First channel to plot
C      EC       I      Last channel to plot
C      XYSCL    R(3)   Plot scaling (for X = channels, I, V)
C      XYOFF    R(3)   Plot zero point
C      CHOUT    R(4)   Number characters left, bottom, right, top
C      LABEL    I      label type
C      XYRATO   R      X/Y ratio
C      DOTAU    I      =2 Ipol is optical depth, =1 absorption
C      XGRMS    R      Ipol average rms
C      ZERMS    R      Ipol average rms
C   In/out
C      PLBUFF   I(*)   Plot buffer
C   Output
C      IRET     I      Error code
C-----------------------------------------------------------------------
      LOGICAL   PLOTI, PLOTV
      REAL      BLC(2), TRC(2), LINT, XYSCL(3), XYOFF(3), CHOUT(4),
     *   XYRATO, XGRMS, ZERMS
      INTEGER   ITYP, BC, EC, LABEL, DOTAU, PLBUFF(*), IRET
C
      INTEGER   I, J, K
      REAL      INLOC(2), ININC(2), XBLC(2), XTRC(2), TI, TR, INSCL,
     *   INOFF, TEMP, DX, DY
      DOUBLE PRECISION INVAL(2), BVAL, EVAL, REFNU, DELNU, REFV, REFAP,
     *   VSIGN, DELV
      CHARACTER INPREF(2)*5, INTYP(2)*20, AXTYPE*20, SPREF*5, STYPE*20,
     *   VELREF(3)*4, POLAR*4, RMSTR*16
      LOGICAL   REVERS, GOOD
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA VELREF /'-LSR','-HEL','-OBS'/
C-----------------------------------------------------------------------
C                                       save inputs
      CTYP(1,LOCNUM) = 'Channels'
      INLOC(1) = RPLOC(1,LOCNUM)
      ININC(1) = AXINC(1,LOCNUM)
      INVAL(1) = RPVAL(1,LOCNUM)
      INPREF(1) = CPREF(1,LOCNUM)
      INTYP(1) = CTYP(1,LOCNUM)
      INLOC(2) = RPLOC(2,LOCNUM)
      ININC(2) = AXINC(2,LOCNUM)
      INVAL(2) = RPVAL(2,LOCNUM)
      INPREF(2) = CPREF(2,LOCNUM)
      INTYP(2) = CTYP(2,LOCNUM)
      INSCL = XYSCL(1)
      INOFF = XYOFF(1)
      REVERS = ININC(1).LT.0
C                                       get freq
      CALL H2CHR (8, 1, CATH(KHCTP), AXTYPE)
      IF (ITYP.EQ.2) THEN
         IF (AXTYPE(:4).EQ.'FREQ') THEN
            BVAL = CATD(KDCRV) + (BC - CATR(KRCRP)) * CATR(KRCIC)
            EVAL = CATD(KDCRV) + (EC - CATR(KRCRP)) * CATR(KRCIC)
         ELSE IF ((AXTYPE(2:4).EQ.'ELO') .AND. (CATBLK(KIALT).GT.0)
     *      .AND. (CATD(KDRST).GT.1.E6)) THEN
            REFNU = CATD(KDARV)
            REFAP = CATR(KRARP)
            VSIGN = 1.0D0
            IF (AXTYPE(:1).EQ.'V') VSIGN = -1.0D0
            DELNU = -CATR(KRCIC) * CATD(KDARV) / (VELITE + VSIGN *
     *         CATD(KDCRV) + CATR(KRCIC) * (CATR(KRCRP) - CATR(KRARP)))
            BVAL = REFNU + (BC - REFAP) * DELNU
            EVAL = REFNU + (EC - REFAP) * DELNU
            AXTYPE = 'FREQ'
         ELSE
            MSGTXT = 'CANNOT FIND FREQUENCY - REVERT TO CHANNELS'
            CALL MSGWRT (7)
            ITYP = 1
            END IF
C                                       get velocity
      ELSE IF (ITYP.EQ.3) THEN
         IF (AXTYPE(2:4).EQ.'ELO') THEN
            BVAL = CATD(KDCRV) + (BC - CATR(KRCRP)) * CATR(KRCIC)
            EVAL = CATD(KDCRV) + (EC - CATR(KRCRP)) * CATR(KRCIC)
         ELSE IF ((AXTYPE(:4).EQ.'FREQ') .AND. (CATBLK(KIALT).GT.0)
     *      .AND. (CATD(KDRST).GT.1.E6)) THEN
            REFV = CATD(KDARV)
            REFAP = CATR(KRARP)
            DELNU = CATR(KRCIC)
            REFNU = CATD(KDCRV)
            J = CATBLK(KIALT)/256 + 2
            IF (J.EQ.3) THEN
               VSIGN = -1.0D0
               AXTYPE = 'VELO'
            ELSE
               VSIGN = 1.0D0
               AXTYPE = 'FELO'
               END IF
            DELV = -DELNU * (VELITE + VSIGN*REFV) /
     *         (REFNU + DELNU * (REFAP - CATR(KRCRP)))
            J = MOD (CATBLK(KIALT), 256)
            AXTYPE(5:8) = VELREF(J)
            BVAL = REFV + (BC - REFAP) * DELV
            EVAL = REFV + (EC - REFAP) * DELV
         ELSE
            MSGTXT = 'CANNOT FIND VELOCITY - REVERT TO CHANNELS'
            CALL MSGWRT (7)
            ITYP = 1
            END IF
         END IF
      SPREF = ' '
      STYPE = 'Channels'
      IF ((ITYP.EQ.2) .OR. (ITYP.EQ.3)) THEN
         I = 1
         XYOFF(I) = BVAL
         XYSCL(I) = EVAL
         TEMP = 0.03 * (XYSCL(I) - XYOFF(I))
         XYSCL(I) = XYSCL(I) + TEMP
         XYOFF(I) = XYOFF(I) - TEMP
         XYSCL(I) = 1000.0 / (XYSCL(I) - XYOFF(I))
         TR = 1000.0 / XYSCL(I)
         TI = TR
         IF (REVERS) THEN
            RPLOC(I,LOCNUM) = TRC(I)
            AXINC(I,LOCNUM) = TR / (BLC(I) - TRC(I))
         ELSE
            RPLOC(I,LOCNUM) = BLC(I)
            AXINC(I,LOCNUM) = TR / (TRC(I) - BLC(I))
            END IF
         RPVAL(I,LOCNUM) = XYOFF(I)
         CALL METSCL (LABEL, TR, CPREF(I,LOCNUM), GOOD)
         RPVAL(I,LOCNUM) = RPVAL(I,LOCNUM) * TR / TI
         AXINC(I,LOCNUM) = AXINC(I,LOCNUM) * TR / TI
         SPREF = CPREF(I,LOCNUM)
         STYPE = AXTYPE
         END IF
C                                       channels
      IF ((.NOT.PLOTI) .OR. (.NOT.PLOTV)) THEN
         CTYP(1,LOCNUM) = STYPE
         CTYP(2,LOCNUM) = ' Jy/beam'
         IF ((PLOTI) .AND. (DOTAU.EQ.2)) CTYP(2,LOCNUM) =
     *      'Optical Depth'
         CALL CLAB1 (BLC, TRC, CHOUT, LABEL, XYRATO, .FALSE., PLBUFF,
     *      IRET)
         IF (IRET.NE.0) GO TO 900
         DY = -6.
         IF (PLOTI) THEN
            POLAR = 'Ipol'
            CALL XTVRMS (XGRMS, RMSTR, K)
            IF (DOTAU.EQ.1) DY = -9.
         ELSE
            POLAR = 'VPOL'
            CALL XTVRMS (ZERMS, RMSTR, K)
            END IF
         CALL GPOS (TRC(1), TRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 900
         DX = -9.0
         CALL GICHAR (1, 4, 0, DX, DY, POLAR, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 900
         DX = 5.0
         CALL GICHAR (1, K, 0, DX, DY, RMSTR(:K), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       two plots - upper
      ELSE
         XBLC(1) = BLC(1)
         XTRC(1) = TRC(1)
         XBLC(2) = LINT
         XTRC(2) = TRC(2)
         TR = (1000.0 - LINT) / XYSCL(2)
         TI = TR
         RPLOC(2,LOCNUM) = XBLC(2)
         RPVAL(2,LOCNUM) = XYOFF(2)
         AXINC(2,LOCNUM) = TR / (XTRC(2) - XBLC(2))
         CALL METSCL (LABEL, TR, CPREF(2,LOCNUM), GOOD)
         RPVAL(2,LOCNUM) = RPVAL(2,LOCNUM) * TR / TI
         AXINC(2,LOCNUM) = AXINC(2,LOCNUM) * TR / TI
         CPREF(1,LOCNUM) = ' '
         CTYP(1,LOCNUM) = ' '
         CTYP(2,LOCNUM) = ' Jy/beam'
         IF (DOTAU.EQ.2) CTYP(2,LOCNUM) = 'Optical Depth'
         CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XYRATO, .FALSE.,
     *      PLBUFF,IRET)
         IF (IRET.NE.0) GO TO 900
         CALL GPOS (XTRC(1), XTRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 900
         DX = -9.0
         DY = -6.0
         IF (DOTAU.EQ.1) DY = -8.0
         POLAR = 'Ipol'
         CALL GICHAR (1, 4, 0, DX, DY, POLAR, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL XTVRMS (XGRMS, RMSTR, K)
         CALL GPOS (BLC(1), TRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 900
         DX = 5.0
         CALL GICHAR (1, K, 0, DX, DY, RMSTR(:K), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       two plots - lower
         XBLC(1) = BLC(1)
         XTRC(1) = TRC(1)
         XBLC(2) = BLC(2)
         XTRC(2) = LINT
         TR = LINT / XYSCL(3)
         TI = TR
         RPLOC(2,LOCNUM) = XBLC(2)
         RPVAL(2,LOCNUM) = XYOFF(3)
         AXINC(2,LOCNUM) = TR / (XTRC(2) - XBLC(2))
         CALL METSCL (LABEL, TR, CPREF(2,LOCNUM), GOOD)
         RPVAL(2,LOCNUM) = RPVAL(2,LOCNUM) * TR / TI
         AXINC(2,LOCNUM) = AXINC(2,LOCNUM) * TR / TI
         CPREF(1,LOCNUM) = SPREF
         CTYP(1,LOCNUM) = STYPE
         CTYP(2,LOCNUM) = ' Jy/beam'
         CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XYRATO, .FALSE.,
     *      PLBUFF,IRET)
         IF (IRET.NE.0) GO TO 900
         CALL GPOS (XTRC(1), XTRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 900
         DX = -9.0
         DY = -6.0
         POLAR = 'Vpol'
         CALL GICHAR (1, 4, 0, DX, DY, POLAR, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL XTVRMS (ZERMS, RMSTR, K)
         CALL GPOS (XBLC(1), XTRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 900
         DX = 5.0
         DY = -6.0
         CALL GICHAR (1, K, 0, DX, DY, RMSTR(:K), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       restore LOC common
 900  RPLOC(1,LOCNUM) = INLOC(1)
      AXINC(1,LOCNUM) = ININC(1)
      RPVAL(1,LOCNUM) = INVAL(1)
      CPREF(1,LOCNUM) = INPREF(1)
      CTYP(1,LOCNUM) =  INTYP(1)
      RPLOC(2,LOCNUM) = INLOC(2)
      AXINC(2,LOCNUM) = ININC(2)
      RPVAL(2,LOCNUM) = INVAL(2)
      CPREF(2,LOCNUM) = INPREF(2)
      CTYP(2,LOCNUM) =  INTYP(2)
      XYSCL(1) = INSCL
      XYOFF(1) = INOFF
C
 999  RETURN
      END
      SUBROUTINE XTVRMS (RMS, STRING, K)
C-----------------------------------------------------------------------
C   XTVRMS formats the RMS string
C   Inputs:
C      RMS      R      Value to be formatted
C   Outputs
C      STRING   C(*)   String
C      K        I      Length to use
C-----------------------------------------------------------------------
      REAL      RMS
      CHARACTER STRING*(*)
      INTEGER   K
C
      INTEGER   L
C-----------------------------------------------------------------------
      IF (RMS.GT.99.9) THEN
         L = RMS + 0.5
         WRITE (STRING,1001) L
      ELSE IF (RMS.GT.9.99) THEN
         WRITE (STRING,1002) RMS
      ELSE IF (RMS.GT.0.999) THEN
         WRITE (STRING,1003) RMS
      ELSE IF (RMS.GT.0.0999) THEN
         WRITE (STRING,1004) RMS
      ELSE IF (RMS.GT.0.00999) THEN
         WRITE (STRING,1005) RMS
      ELSE
         WRITE (STRING,1006) RMS
      END IF
      IF (RMS.EQ.0.0) THEN
         STRING = ' '
         K = 9
      ELSE
         CALL REFRMT (STRING, '_', K)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1001 FORMAT ('RMS',I12)
 1002 FORMAT ('RMS',F12.2)
 1003 FORMAT ('RMS',F12.3)
 1004 FORMAT ('RMS',F12.4)
 1005 FORMAT ('RMS',F12.5)
 1006 FORMAT ('RMS',F12.6)
      END
      SUBROUTINE XG2PLH (NCHAN, NP, DBUFF, VBUFF, IRET)
C-----------------------------------------------------------------------
C   XG2PLH does the OUTEXT printout if requested
C   Inputs:
C      NCHAN   I      Number spectral channels
C      NP      I      Number parameters
C      DBUFF   R(*)   Ipol data
C      VBUFF   R(*)   Vpol data
C   Outputs:
C      IRET    I      Error code
C-----------------------------------------------------------------------
      INTEGER   NCHAN, NP, IRET
      REAL      DBUFF(NCHAN,*), VBUFF(NCHAN,*)
C
      INCLUDE 'XG2PL.INC'
      INCLUDE 'XGTABLE.INC'
      INTEGER   I, J, MP, TXLUN, TXIND, K, JTRIM, L, ITYP
      DOUBLE PRECISION DAX, DSCALE, REFV, REFP, REFI, REFDI, VSIGN
      LOGICAL   SIMPLE
      REAL      PMAX, PSCALE
      CHARACTER OLINE*512, AXIS*8, PRAXIS*8, VELREF(6)*4
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA VELREF /'-LSR','-HEL','-OBS','-OPT','-RAD', ' '/
C-----------------------------------------------------------------------
      IRET = 0
      IF (OUTEXT.EQ.' ') GO TO 999
C                                       open output
      TXLUN = 3
      CALL ZTXOPN ('WRIT', TXLUN, TXIND, OUTEXT, .TRUE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT TEXT FILE'
         GO TO 990
         END IF
C                                       Ipol printout
C                                       find max column
      MP = 0
      PMAX = 0.0
      DO 20 I = 1,NCHAN
         DO 10 J = MP+1,NP
            IF (DBUFF(I,J).NE.FBLANK) MP = J
 10         CONTINUE
 20      CONTINUE
      DO 25 I = 1,NUMPX
         DO 24 J = 3,2+3*MAXGAU,3
            IF (PRTGV(J,1,I).NE.FBLANK) THEN
               PMAX =  MAX (PMAX, ABS(PRTGV(J,1,I)))
               PMAX =  MAX (PMAX, ABS(PRTGV(J,2,I)))
               END IF
 24         CONTINUE
 25      CONTINUE
      PSCALE = 1.0
      IF (PMAX.GT.9999.) PSCALE = 0.001
      IF (PMAX.LT.9.99) PSCALE = 1000.0
      IF (PMAX.LT.0.00999) PSCALE = 1000000.0
C                                       header
      WRITE (OLINE,2000) 'I', INAME1, INCLS1, INSEQ1
      K = JTRIM (OLINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:K), IRET)
      IF (IRET.NE.0) GO TO 980
C                                       area
      IF ((IDX.EQ.0) .AND. (IDY.EQ.0)) THEN
         WRITE (OLINE,2001) LX, LY
      ELSE IF (IDX.LT.0) THEN
         WRITE (OLINE,2002) IDY, LX, LY
      ELSE
         WRITE (OLINE,2003) IX1, IY1, IX2, IY2
         END IF
      K = JTRIM (OLINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:K), IRET)
      IF (IRET.NE.0) GO TO 980
      IF (PSCALE.NE.1.0) THEN
         WRITE (OLINE,2004) PSCALE
         K = JTRIM (OLINE)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:K), IRET)
         IF (IRET.NE.0) GO TO 980
         END IF
      OLINE = ' '
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:1), IRET)
      IF (IRET.NE.0) GO TO 980
C                                       component values
      WRITE (OLINE,2010) ('   Peak    Center     FWHM   ', K = 1,MP-5)
      K = JTRIM (OLINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:K), IRET)
      IF (IRET.NE.0) GO TO 980
      WRITE (OLINE,2011) ('  Jy/beam  channels channels ', K = 1,MP-5)
      K = JTRIM (OLINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:K), IRET)
      IF (IRET.NE.0) GO TO 980
      OLINE = ' '
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:1), IRET)
      IF (IRET.NE.0) GO TO 980
C                                       component
      DO 50 I = 1,NUMPX
         WRITE (OLINE,2012) PRTPIX(1,I), PRTPIX(2,I),
     *      PRTGV(1,1,I)*PSCALE, PRTGV(2,1,I)*PSCALE
         IF (PRTGV(1,1,I).EQ.FBLANK) OLINE(11:) =
     *      '   INDEF     INDEF  '
         L = 33
         K = 2
         DO 30 J = 1,MP-5
            IF (PRTGV(K+1,1,I).NE.FBLANK) THEN
               WRITE (OLINE(L:),2013) PRTGV(K+1,1,I)*PSCALE
            ELSE
               OLINE(L:) = '   INDEF '
               END IF
            L = L + 10
            IF (PRTGV(K+2,1,I).NE.FBLANK) THEN
               WRITE (OLINE(L:),2013) PRTGV(K+2,1,I)
            ELSE
               OLINE(L:) = '   INDEF '
               END IF
            L = L + 10
            IF (PRTGV(K+3,1,I).NE.FBLANK) THEN
               WRITE (OLINE(L:),2014) PRTGV(K+3,1,I)
            ELSE
               OLINE(L:) = '  INDEF'
               END IF
            L = L + 9
            K = K + 3
 30         CONTINUE
         CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:L), IRET)
         IF (IRET.NE.0) GO TO 980
C                                       error
         WRITE (OLINE,2015) PRTGV(1,2,I)*PSCALE, PRTGV(2,2,I)*PSCALE
         IF (PRTGV(1,1,I).EQ.FBLANK) OLINE(11:) = ' '
         L = 33
         K = 2
         DO 40 J = 1,MP-5
            IF (PRTGV(K+1,1,I).NE.FBLANK) THEN
               WRITE (OLINE(L:),2016) PRTGV(K+1,2,I)*PSCALE
            ELSE
               OLINE(L:) = ' '
               END IF
            L = L + 10
            IF (PRTGV(K+2,1,I).NE.FBLANK) THEN
               WRITE (OLINE(L:),2016) PRTGV(K+2,2,I)
            ELSE
               OLINE(L:) = ' '
               END IF
            L = L + 10
            IF (PRTGV(K+3,1,I).NE.FBLANK) THEN
               WRITE (OLINE(L:),2017) PRTGV(K+3,2,I)
            ELSE
               OLINE(L:) = ' '
               END IF
            L = L + 9
            K = K + 3
 40         CONTINUE
         IF (OLINE.NE.' ') THEN
            CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:L), IRET)
            IF (IRET.NE.0) GO TO 980
            END IF
 50      CONTINUE
C                                       coordinate computation
      DSCALE = 1.0D0
      ITYP = CPARM(4) + 1.1
      IF (ITYP.EQ.1) ITYP = 2
      REFV = CATD(KDCRV)
      REFP = CATR(KRCRP)
      REFI = CATR(KRCIC)
      SIMPLE = .TRUE.
      CALL H2CHR (8, 1, CATH(KHCTP), AXIS)
      PRAXIS = AXIS
C                                       want frequency label
      IF (ITYP.EQ.2) THEN
         DSCALE = 1.D-6
         IF (AXIS(2:4).EQ.'ELO') THEN
            PRAXIS = '  FREQ'
            REFV = CATD(KDARV)
            REFP = CATR(KRARP)
            VSIGN = 1.0D0
            IF (AXIS(:1).EQ.'V') VSIGN = -1.0D0
            REFI= -CATR(KRCIC) * CATD(KDARV) / (VELITE + VSIGN *
     *         CATD(KDCRV) + CATR(KRCIC) * (CATR(KRCRP) - CATR(KRARP)))
            END IF
C                                       want velocity
      ELSE IF (ITYP.EQ.3) THEN
         DSCALE = 1.D-3
         IF (AXIS(:4).EQ.'FREQ') THEN
            REFV = CATD(KDARV)
            REFP = CATR(KRARP)
            VSIGN = 1.0
            REFI = -REFI * (VELITE + VSIGN*REFV) / (CATD(KDCRV) +
     *         CATR(KRCIC) * (REFP - CATR(KRCRP)))
            SIMPLE = .FALSE.
            REFDI = CATR(KRCIC) / (CATD(KDCRV) +
     *         CATR(KRCIC) * (REFP - CATR(KRCRP)))
            I = CATBLK(KIALT) / 256 + 2
            J = MOD (CATBLK(KIALT), 256)
            IF ((J.LE.0) .OR. (J.GT.6)) J = 6
            IF (I.EQ.3) THEN
               PRAXIS = 'VELO' // VELREF(J)
            ELSE
               PRAXIS = 'FELO' // VELREF(J)
               END IF
         ELSE IF (AXIS(1:1).EQ.'F') THEN
            SIMPLE = .FALSE.
            REFDI =  -CATR(KRCIC) * CATD(KDARV) / (VELITE + VSIGN *
     *         CATD(KDCRV) + CATR(KRCIC) * (CATR(KRCRP) - CATR(KRARP)))
            REFDI = REFDI / (CATD(KDARV) + REFDI *
     *         (CATR(KRCRP)-CATR(KRARP)))
            END IF
         END IF
C                                      spectra title
      OLINE = ' '
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:1), IRET)
      IF (IRET.NE.0) GO TO 980
      WRITE (OLINE,2020) PRAXIS, ('Component', K, K = 1,MP-5)
      K = JTRIM (OLINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:K), IRET)
      IF (IRET.NE.0) GO TO 980
      OLINE = ' '
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:1), IRET)
      IF (IRET.NE.0) GO TO 980
C                                       Loop over I
      DO 70 I = 1,NCHAN
         IF (SIMPLE) THEN
            DAX = (REFV + (I - REFP) * REFI) * DSCALE
         ELSE
            DAX = REFV + REFI * (I - REFP) / (1 + (I-REFP) * REFDI)
            DAX = DAX * DSCALE
            END IF
         WRITE (OLINE,2030) I, DAX
         K = 18
         DO 60 J = 1,MP
            IF ((J.LE.3) .OR. (J.GE.6)) THEN
               IF (DBUFF(I,J).NE.FBLANK) THEN
                  WRITE (OLINE(K:K+10),2031) DBUFF(I,J)*PSCALE
               ELSE
                  OLINE(K:K+10) = '     INDEF '
                  END IF
               K = K + 11
               END IF
 60         CONTINUE
         K = JTRIM (OLINE)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:K), IRET)
         IF (IRET.NE.0) GO TO 980
 70      CONTINUE
C                                       Vpol printout
      IF (.NOT.DOVPOL) GO TO 980
C                                       find max column
      MP = 0
      DO 120 I = 1,NCHAN
         DO 110 J = MP+1,NP
            IF (VBUFF(I,J).NE.FBLANK) MP = J
 110        CONTINUE
 120     CONTINUE
C                                       spectra header
      OLINE = ' '
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:1), IRET)
      IF (IRET.NE.0) GO TO 980
      WRITE (OLINE,2000) 'V', INAME2, INCLS2, INSEQ2
      K = JTRIM (OLINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:K), IRET)
      IF (IRET.NE.0) GO TO 980
C                                       area
      IF ((IDX.EQ.0) .AND. (IDY.EQ.0)) THEN
         WRITE (OLINE,2001) LX, LY
      ELSE IF (IDX.LT.0) THEN
         WRITE (OLINE,2002) IDY, LX, LY
      ELSE
         WRITE (OLINE,2003) IX1, IY1, IX2, IY2
         END IF
      K = JTRIM (OLINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:K), IRET)
      IF (IRET.NE.0) GO TO 980
C                                       component values
      OLINE = ' '
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:1), IRET)
      IF (IRET.NE.0) GO TO 980
      WRITE (OLINE,2110) ('     Field      ', K = 1,MP-3)
      K = JTRIM (OLINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:K), IRET)
      IF (IRET.NE.0) GO TO 980
      WRITE (OLINE,2111) ('    channels    ', K = 1,MP-3)
      K = JTRIM (OLINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:K), IRET)
      IF (IRET.NE.0) GO TO 980
      OLINE = ' '
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:1), IRET)
      IF (IRET.NE.0) GO TO 980
      DO 150 I = 1,NUMPX
C                                       component
         WRITE (OLINE,2112) PRTPIX(1,I), PRTPIX(2,I), PRTZV(1,1,I),
     *      PRTZV(1,2,I)
         IF (PRTGV(1,1,I).EQ.FBLANK) OLINE(11:) =
     *      '   INDEF   INDEF    '
         L = 29
         K = 2
         DO 130 J = 1,MAX(1,MP-3)
            IF (PRTZV(K,1,I).NE.FBLANK) THEN
               WRITE (OLINE(L:),2113) PRTZV(K,1,I), PRTZV(K,2,I)
            ELSE
               OLINE(L:) = '  INDEF (      )'
               END IF
            L = L + 16
            K = K + 1
 130        CONTINUE
         CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:L), IRET)
         IF (IRET.NE.0) GO TO 980
 150     CONTINUE
      OLINE = ' '
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:1), IRET)
      IF (IRET.NE.0) GO TO 980
C                                       title
      CALL H2CHR (8, 1, CATH(KHCTP), AXIS)
      WRITE (OLINE,2020) AXIS, ('Component', K, K = 1,MP-3)
      K = JTRIM (OLINE)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:K), IRET)
      IF (IRET.NE.0) GO TO 980
      OLINE = ' '
      CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:1), IRET)
      IF (IRET.NE.0) GO TO 980
C                                       Loop over V
      DSCALE = 1.0D0
      IF (AXIS(:4).EQ.'FREQ') DSCALE = 1.0D-6
      IF (AXIS(2:4).EQ.'ELO') DSCALE = 1.0D-3
      DO 170 I = 1,NCHAN
         DAX = (CATD(KDCRV) + (I - CATR(KRCRP)) * CATR(KRCIC)) * DSCALE
         WRITE (OLINE,2030) I, DAX
         K = 18
         DO 160 J = 1,MP
            IF (VBUFF(I,J).NE.FBLANK) THEN
               WRITE (OLINE(K:K+10),2031) VBUFF(I,J)
            ELSE
               OLINE(K:K+10) = '     INDEF '
               END IF
            K = K + 11
 160        CONTINUE
         K = JTRIM (OLINE)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, OLINE(:K), IRET)
         IF (IRET.NE.0) GO TO 980
 170     CONTINUE
C                                       close
 980  CALL ZTXCLS (TXLUN, TXIND, I)
      IF (I.NE.0) THEN
         WRITE (MSGTXT,1000) I, 'CLOSE TEXT  FILE'
         CALL MSGWRT (7)
         END IF
      WRITE (MSGTXT,1000) IRET, 'WRITING TEXT FILE'
C
 990  IF (IRET.NE.0) CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XG2PLH ERROR',I4,' ON ',A)
 2000 FORMAT (2X,A,'-polarization data for ',A12,'.',A6,'.',I6)
 2001 FORMAT (6X,'Single pixel X,Y =',2I6)
 2002 FORMAT (6X,'Circle of radius',I3,' pixels centered on X,Y=',2I6)
 2003 FORMAT (6X,'Rectangle X,Y BLC=',2I6,'  TRC=',2I6)
 2004 FORMAT (6X,'Values multiplied by',F12.3)
 2010 FORMAT ('   Pixel  ',6X,'Baseline',9X,8A)
 2011 FORMAT ('   X    Y   Jy/beam   Jy/b/chan',8A)
 2012 FORMAT (2I5,2F10.3)
 2013 FORMAT (F8.2)
 2014 FORMAT (F7.2)
 2015 FORMAT (11X,2('(',F8.3,')'))
 2016 FORMAT ('(',F7.3,')')
 2017 FORMAT ('(',F6.3,')')
 2020 FORMAT ('Channel',1X,A8,2X,'Image data','  Model sum',
     *   ' Data-model',8(1X,A9,I1))
 2030 FORMAT (I5,F11.4)
 2031 FORMAT (F11.2)
 2110 FORMAT ('   Pixel  ',7X,'Gain',6X,8A)
 2111 FORMAT ('   X    Y',18X,8A)
 2112 FORMAT (2I5,F9.4,' (',F6.4,')')
 2113 FORMAT (F7.3,' (',F6.3,')')
      END

      SUBROUTINE DGETSD (RPARM, VIS, TIMLST, IERR)
C-----------------------------------------------------------------------
C! Reads, selects single dish data, calibrates and edits.
C# Calibration Sdish
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2000-2001, 2007, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Single dish calibration routine.
C   Reads next selected data record. Applies calibration and editing.
C   Inputs from common /SELCAL/:
C      INXRNO       I    Current INDEX file record number.
C                        If .LT. 0 then there is no index file.
C      NINDEX       I    Number of entriex in the index table
C      NXKOLS(6)    I    Pointer array for index records.
C      SUBARR       I    Subarray number desired, 0=>any.
C      TRANSL       L    If true, translate data to requested stokes.
C      JADR(2,*)    I    If TRANSL is .false. then the following are
C                        used:
C                        JADR(1,1) = input file INCS
C                        JADR(1,2) = input file INCF
C                        JADR(1,3) = input file INCIF
C                        JADR(1,4) = input file no. stokes' pixel
C      TSTART       R    Start time in days.
C      TEND         R    End time in days.
C      NPRMIN       I    No. random parameters in the input data
C      NRPARM       I    No. random parameters in output data.
C   Input/output:
C      TIMLST       R    Time of last record
C   Output:
C      RPARM(*)   R    Random parameter array
C      VIS(3,*)   R    Visibility array
C      IERR       I    Return code, 0=OK, else UVDISK error number.
C   Output to common /SELCAL/:
C      FSTVIS       I    First visibility number of current scan.
C      LSTVIS       I    Last visibility number of current scan.
C-----------------------------------------------------------------------
      INTEGER   IERR
      REAL      RPARM(*), VIS(3,*), TIMLST
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NUMAX, NIO, BIND, IBUFF(1024), IA1, IA2, IRET, J, BO, I,
     *   TIMKOL, INTKOL, SOUKOL, SUBKOL, FRSKOL, LSTKOL, RECI(MAXNXC),
     *   IUBIND, CURSUB, NREAD, FRSRED, LIMT, IBASE
      LOGICAL   DROP, F, SLCTD
      REAL      RECORD(MAXNXC), TIME, BASEN
      INTEGER   TBUFSZ
      PARAMETER (TBUFSZ = MAXCIF * 3)
      REAL      TBUFF(TBUFSZ)
      SAVE TBUFF
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      EQUIVALENCE (RECORD, RECI)
      EQUIVALENCE (IBUFF, NXBUFF)
      EQUIVALENCE (NXKOLS, TIMKOL), (NXKOLS(2), INTKOL),
     *   (NXKOLS(3), SOUKOL), (NXKOLS(4), SUBKOL), (NXKOLS(5), FRSKOL),
     *   (NXKOLS(6), LSTKOL)
      DATA F /.FALSE./
      DATA BO /1/
C-----------------------------------------------------------------------
      TIME = -1.0E10
C                                       Read next record.
 100  CALL UVDISK ('READ', IULUN, IUFIND, UBUFF, NIO, BIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1100) IERR
         GO TO 990
         END IF
C                                       Check for end of scan
      IF (NIO.LE.0) GO TO 200
C                                       Check timerange
      TIME = UBUFF(BIND+ILOCT)
      IF (TIME.LT.TSTART) GO TO 100
C                                       Be sure not to go backwards in
C                                       time due to multiple subarrays
C                                       if applying calibration
      IF (((DOCAL) .OR. (DOFLAG)) .AND. (TIMORD)) THEN
         IF (TIME.LT.TIMLST) GO TO 100
         TIMLST = TIME
         IF (TIME.GT.TEND) GO TO 200
         END IF
      IF (TIME.GT.TEND) GO TO 100
C                                       Set beam
      IF (ILOCB.GE.0) THEN
         BASEN = UBUFF(BIND+ILOCB)
         IBASE = BASEN + 0.1
         IA1 = BASEN / 256.0 + 0.1
         IA2 = BASEN - 256 * IA1 + 0.1
         CURSUB = 1.5 + 100.0 * (BASEN - IBASE)
      ELSE IF ((ILOCA1.GE.0) .AND. (ILOCA2.GE.0) .AND. (ILOCSA.GE.0))
     *   THEN
         IA1 = UBUFF(BIND+ILOCA1) + 0.1
         IA2 = UBUFF(BIND+ILOCA2) + 0.1
         CURSUB = UBUFF(BIND+ILOCSA) + 0.1
      ELSE
         IA1 = 1
         IA2 = 1
         CURSUB = 1
         END IF
C                                       Selected beam?
      IF (.NOT.SLCTD (IA2, ANTENS, NANTSL, DOAWNT)) GO TO 100
C                                       Check subarray
      IF ((SUBARR.GT.0) .AND. (CURSUB.NE.SUBARR)) GO TO 100
C                                       Copy to output
      CALL RCOPY (NRPARM, UBUFF(BIND), RPARM)
C                                       Uncompress if needed to TBUFF
      J = LRECIN - NPRMIN
      IF (ISCMP) THEN
         NUMAX = 3
         CALL ZUVXPN (J, UBUFF(BIND+NPRMIN), UBUFF(BIND+KLOCWT), TBUFF)
      ELSE
         NUMAX = CATUV(KINAX)
         CALL RCOPY (J, UBUFF(BIND+NPRMIN), TBUFF)
         END IF
C                                       Do flagging
      DROP = F
      IF (DOFLAG) THEN
         CALL DATFLG (RPARM, TBUFF, DROP, IERR)
         IF (IERR.NE.0) GO TO 999
         IF (DROP) GO TO 100
         END IF
C                                       Calibrate
      IF (DOCAL) THEN
         CALL DCALSD (IA2, TIME, UBUFF(BIND+ILOCU), UBUFF(BIND+ILOCV),
     *      TBUFF, DROP, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Get data in correct Stokes form.
      IF (.NOT.(DOFLAG .AND. DROP)) THEN
         CALL DGGET (TBUFF, NUMAX, TRANSL, MVIS, JADR,SELFAC, ALLWT,
     *      VIS, DROP)
         END IF
C                                       Check if data all flagged
      IF (DOFLAG .AND. DROP) GO TO 100
      GO TO 999
C                                       New scan.
C                                       Find next in INDEX file.
 200  IERR = 4
C                                       Check if INDEX file used.
      IF (INXRNO.LE.0) GO TO 999
      IF (INXRNO.GT.NINDEX) GO TO 999
C                                       See if time range exhausted.
      IF (TIME.GT.TEND) GO TO 999
C                                       Loop through records
      LIMT = INXRNO
      DO 260 I = LIMT,NINDEX
         INXRNO = I
         IERR = 1
C                                       Read record.
         CALL TABIO ('READ', 0, INXRNO, RECORD, IBUFF, IRET)
C                                       Check if flagged
         IF (IRET.LT.0) GO TO 260
C                                       Check error
         IF (IRET.GT.0) GO TO 999
         IERR = 0
C                                       Check time range.
         IF (TSTART.GT.(RECORD(TIMKOL)+RECORD(INTKOL))) GO TO 260
C                                       Check subarray
         IF ((SUBARR.GT.0) .AND. (RECI(SUBKOL).NE.SUBARR) .AND.
     *      (RECI(SUBKOL).GT.0)) GO TO 260
C                                       Set values
            FSTVIS = RECI(FRSKOL)
            LSTVIS = RECI(LSTKOL)
            GO TO 300
 260     CONTINUE
C                                       No more data selected.
      IERR = 4
      GO TO 999
C                                       Init I/O to uvfile
 300  INXRNO = INXRNO + 1
      NREAD = LSTVIS - FSTVIS + 1
      FRSRED = FSTVIS - 1
      CALL UVINIT ('READ', IULUN, IUFIND, NREAD, FRSRED, LRECIN, 1,
     *   UBUFSZ, UBUFF, BO, IUBIND, IERR)
      IF (IERR.LE.0) GO TO 100
         WRITE (MSGTXT,1300) IERR
         GO TO 990
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('DGETSD: ERROR',I3,' READING SD DATA')
 1300 FORMAT ('DGETSD: ERROR',I3,' INITIALIZING I/O TO SD DATA')
      END

      SUBROUTINE CLAB1 (BLC, TRC, CH, ILTYPE, XYR, DOGRID, IBUFF, IERR)
C-----------------------------------------------------------------------
C! puts axis labels in plot file and calls CTICS to draw and label ticks
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2002-2003, 2012, 2014, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CLAB1 controls some axis drawing and labeling functions: labels each
C   axis with RA/DEC or the 8-char type, calls CTICS to draw tics & tick
C   labels
C   Inputs:
C      BLC      R(2)    X, Y pixels to form bottom left hand corner
C      TRC      R(2)    X, Y pixels to form the top right hand corner
C      CH       R(4)    left, bot, right, top : total character offsets
C      ILTYPE   I       label type: 1 none, 2 no ticks, 3 RA/DEC
C                          4 center relative
C      XYR      R       The ratio of the distance between X axis pixels
C                       and the distance between Y axis pixels on plot
C      DOGRID   L       T => full coord grid, else ticks
C   In/out:
C      IBUFF    I(256)  the updated graphics output buffer.
C      IERR     I       error indicator: 0 = No error.
C   If AXTYPE(i,LOCNUM)='NO TICKS' then CTICS is not called.
C-----------------------------------------------------------------------
      REAL      BLC(2), TRC(2), CH(4), XYR
      INTEGER   ILTYPE, IBUFF(256), IERR
      LOGICAL   DOGRID
C
      REAL      X, X0, X1, Y, Y0, Y1, DCX, DCY
      INTEGER   I, IANGL, IERR2, INCHAR, LTYPE, NLABEL(9), IROUND, IE,
     *   IEPO
      DOUBLE PRECISION  ZERO
      CHARACTER SPRTXT*30, PLABEL(9)*16, CPT(2)*5, CTY(2)*20, SUBR*6,
     *   ELABEL(2)*8, NOTICK*8
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA ZERO /0.0D0/
      DATA NLABEL /14, 13, 14, 13, 15, 11, 12, 10, 11/
      DATA PLABEL /'Ecliptic Long.  ', 'Ecliptic Lat.   ',
     *   'Galactic Long.  ', 'Galactic Lat.   ', 'Right Ascension ',
     *   'Declination     ', 'Time (hours)    ', 'HA (hours)     ',
     *   'LST (hours)     '/
      DATA ELABEL /' (B1950)', ' (J2000)'/
      DATA NOTICK /'NO TICKS'/
C-----------------------------------------------------------------------
      CALL CHECKL ('CLAB1')
      LTYPE = MOD (ABS (ILTYPE), 100)
      IF (LTYPE.EQ.1) GO TO 999
      IEPO = IROUND (REPOCH(LOCNUM))
      IF (IEPO.EQ.1950) THEN
         IE = 1
      ELSEIF (IEPO.EQ.2000) THEN
         IE = 2
      ELSE
         IE = 0
         END IF
C                                       Initial values.
      X0 = BLC(1)
      X1 = TRC(1)
      Y0 = BLC(2)
      Y1 = TRC(2)
C                                       vertical axes
      IF (((CPREF(2,LOCNUM).NE.' ') .OR. (CTYP(2,LOCNUM).NE.' ')) .AND.
     *   (CPREF(2,LOCNUM).NE.'-1') .AND. (CTYP(2,LOCNUM).NE.NOTICK))
     *   THEN
         I = LABTYP(LOCNUM) / 10
         IF (I.GT.9) I = 0
         Y = (Y1-Y0)/2.0 + Y0
         CALL GPOS (X0, Y, IBUFF, IERR)
         SUBR = 'GPOS'
         IF (IERR.NE.0) GO TO 980
         IF (I.GT.0) THEN
            SPRTXT = PLABEL(I)
            INCHAR = NLABEL(I)
            IF ((IE.GT.0) .AND. ((I.EQ.5) .OR. (I.EQ.6))) THEN
               SPRTXT(INCHAR+1:) = ELABEL(IE)
               INCHAR = INCHAR + 8
               END IF
         ELSE
            SPRTXT = CPREF(2,LOCNUM) // ' ' // CTYP(2,LOCNUM)
            CALL CHTRIM (SPRTXT, 25, SPRTXT, INCHAR)
            CALL REFRMT (SPRTXT, '_', INCHAR)
            END IF
         IANGL = 1
         DCX = -CH(1) + 1.0
         DCY = INCHAR / 2.0 - 1.0
         CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPRTXT, IBUFF, IERR)
         SUBR = 'GCHAR'
         IF (IERR.NE.0) GO TO 980
         END IF
C                                       horizontal axes
      IF (((CPREF(1,LOCNUM).NE.' ') .OR. (CTYP(1,LOCNUM).NE.' ')) .AND.
     *   (CPREF(1,LOCNUM).NE.'-1') .AND. (CTYP(1,LOCNUM).NE.NOTICK))
     *   THEN
         I = MOD (LABTYP(LOCNUM), 10)
         IF (I.GT.9) I = 0
         X = (X1-X0)/2.0 + X0
         CALL GPOS (X, Y0, IBUFF, IERR)
         SUBR = 'GPOS'
         IF (IERR.NE.0) GO TO 980
         IF (I.GT.0) THEN
            SPRTXT = PLABEL(I)
            INCHAR = NLABEL(I)
            IF ((IE.GT.0) .AND. ((I.EQ.5) .OR. (I.EQ.6))) THEN
               SPRTXT(INCHAR+1:) = ELABEL(IE)
               INCHAR = INCHAR + 8
               END IF
         ELSE
            SPRTXT = CPREF(1,LOCNUM) // ' ' // CTYP(1,LOCNUM)
            CALL CHTRIM (SPRTXT, 25, SPRTXT, INCHAR)
            CALL REFRMT (SPRTXT, '_', INCHAR)
            END IF
         IANGL = 0
         DCX = -INCHAR / 2.0
         DCY = -2.83
         IF (LTYPE.EQ.2) DCY = -1.5
         CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPRTXT, IBUFF, IERR)
         SUBR = 'GCHAR'
         IF (IERR.NE.0) GO TO 980
         END IF
C                                       do ticks
      CPT(1) = CPREF(1,LOCNUM)
      CPT(2) = CPREF(2,LOCNUM)
      CTY(1) = CTYP(1,LOCNUM)
      CTY(2) = CTYP(2,LOCNUM)
      IF (LTYPE.EQ.2) THEN
         CPREF(1,LOCNUM) = ' '
         CPREF(2,LOCNUM) = ' '
         CTYP(1,LOCNUM) = ' '
         CTYP(2,LOCNUM) = ' '
         END IF
      IF (CTY(1).NE.NOTICK) THEN
         CALL CTICS (1, BLC, TRC, XYR, ZERO, DOGRID, IBUFF, IERR2)
         IF (IERR2.EQ.2) THEN
            IERR = 2
            GO TO 999
            END IF
         END IF
      IF (CTY(2).NE.NOTICK) THEN
         CALL CTICS (2, BLC, TRC, XYR, ZERO, DOGRID, IBUFF, IERR2)
         IF (IERR2.EQ.2) THEN
            IERR = 2
            GO TO 999
            END IF
         END IF
      IF (LTYPE.EQ.2) THEN
         CPREF(1,LOCNUM) = CPT(1)
         CPREF(2,LOCNUM) = CPT(2)
         CTYP(1,LOCNUM) = CTY(1)
         CTYP(2,LOCNUM) = CTY(2)
         END IF
      GO TO 999
C                                       Graph drawing error.
 980  WRITE (MSGTXT,1980) IERR, SUBR
      CALL MSGWRT (7)
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('CLAB1: GRAPH LABEL WRITING ERROR',I5,' FROM ',A)
      END

      SUBROUTINE ALSDMP (ALIST)
C-----------------------------------------------------------------------
C! Dump Associative list (ALIST)
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Public function.
C   Simple minded dump of ALIST to MSGWRT.  Only does first two
C   dimensions.
C   See ALSINI for details of the package.
C   Inputs:
C      ALIST  I(*)  ALIST array
C   Outputs:
C-----------------------------------------------------------------------
      INTEGER   ALIST(*)
C
      CHARACTER ALNAME*32, KEYWRD*16, CTEMP*132
      INTEGER   TYPE, I1, I2, ADDR, INDEX, CINDEX, ITRIM, NCHAR,
     *   NDIM, DATOFF, DIM1, DIM2, LKEY, MAXL
      DOUBLE PRECISION DTEMP
      REAL      RTEMP
      LOGICAL   LTEMP
      INCLUDE 'INCS:PALIST.INC'
C-----------------------------------------------------------------------
      NDIM = ALIST(ALSNDM)
      DATOFF = ALIST(ALSDAT)
C                                       Validity test
      IF (ALIST(ALSCHK).NE.ALSCVL) THEN
         MSGTXT = 'ALSDMP: DAMAGED OR UNINITIALIZED ALIST'
         GO TO 990
         END IF
C                                       Name
      CALL H2CHR (32, 1, ALIST(ALSNAM), ALNAME)
      MSGTXT = 'ALSDMP: Dump of ALIST ' // ALNAME
      CALL MSGWRT (3)
C                                       Size
      WRITE (MSGTXT,1000) ALIST(ALSIZE)
      CALL MSGWRT (3)
C                                       Number used
      WRITE (MSGTXT,1001) ALIST(ALSEND)
      CALL MSGWRT (3)
C                                       Max. dimensionality
      WRITE (MSGTXT,1002) ALIST(ALSNDM)
      CALL MSGWRT (3)
      IF (ALIST(ALSNDM).GT.2) THEN
         MSGTXT = 'Note: Only first two dimensions dumped'
         CALL MSGWRT (3)
         END IF
C                                       Loop throught ALIST
      ADDR = ALIST(ALSBEG)
      IF (ADDR.EQ.ALIST(ALSEND)) THEN
C                                       Empty ALIST
         MSGTXT = 'ALIST is empty'
         CALL MSGWRT (3)
         GO TO 999
         END IF
C                                       Loop over entries
 50      CALL H2CHR (16, 1, ALIST(ADDR+ALSKWD), KEYWRD)
         LKEY = ITRIM (KEYWRD)
         DIM1 = MAX (1, ALIST(ADDR+ALSDIM))
         IF (NDIM.GT.1) THEN
            DIM2 = MAX (1, ALIST(ADDR+ALSDIM+1))
         ELSE
            DIM2 = 1
            END IF
         TYPE = ALIST(ADDR+ALSTYP)
         INDEX = ADDR + DATOFF
         CINDEX = 1
C                                       Characters special
         NCHAR = DIM1
         IF (TYPE.EQ.3) DIM1 = 1
         DO 200 I2 = 1,DIM2
            DO 100 I1 = 1,DIM1
C                                       By type
C                                       Double precision
               IF (TYPE.EQ.1) THEN
                  CALL DPCOPY (1, ALIST(INDEX), DTEMP)
                  WRITE (MSGTXT,1050,ERR=90) KEYWRD(1:LKEY), I1, I2,
     *               DTEMP
                  INDEX = INDEX + NWDPDP
C                                       Single precision
               ELSE IF (TYPE.EQ.2) THEN
                  CALL RCOPY (1, ALIST(INDEX), RTEMP)
                  WRITE (MSGTXT,1051,ERR=90) KEYWRD(1:LKEY), I1, I2,
     *               RTEMP
                  INDEX = INDEX + 1
C                                       Character
               ELSE IF (TYPE.EQ.3) THEN
                  CALL H2CHR (NCHAR, CINDEX, ALIST(INDEX), CTEMP)
                  MAXL = 80 - 16 - LKEY
                  MAXL = MIN (ITRIM(CTEMP), MAXL)
                  WRITE (MSGTXT,1052,ERR=90) KEYWRD(1:LKEY), I2,
     *               CTEMP(1:MAXL)
                  CINDEX = CINDEX + ALIST(ADDR+ALSDIM)
C                                       Integer
               ELSE IF (TYPE.EQ.4) THEN
                  WRITE (MSGTXT,1053,ERR=90) KEYWRD(1:LKEY), I1, I2,
     *               ALIST(INDEX)
                  INDEX = INDEX + 1
C                                       Logical
               ELSE IF (TYPE.EQ.5) THEN
                  CALL LCOPY (1, ALIST(INDEX), LTEMP)
                  WRITE (MSGTXT,1054,ERR=90) KEYWRD(1:LKEY), I1, I2,
     *               LTEMP
                  INDEX = INDEX + 1
C                                       Bad type
               ELSE
                  WRITE (MSGTXT,2000) TYPE
                  GO TO 990
                  END IF
 90            CALL MSGWRT (3)
 100           CONTINUE
 200        CONTINUE
C                                       End of list?
         ADDR = ALIST(ADDR)
         IF ((ADDR.GT.0) .AND. (ADDR.LT.ALIST(ALSIZE)) .AND.
     *      (ALIST(ADDR).GT.ADDR)) GO TO 50
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
      MSGTXT = 'PROBLEM DUMPING ALIST: ' // ALNAME
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ALSDMP: Number of words = ', I9)
 1001 FORMAT ('ALSDMP: Number of words used= ', I9)
 1002 FORMAT ('ALSDMP: Maximum dimensionality = ', I3)
 1050 FORMAT ('ALSDMP: ', A, '(',I3,',',I3,') =', 1PD25.15)
 1051 FORMAT ('ALSDMP: ', A, '(',I3,',',I3,') =', 1PE16.8)
 1052 FORMAT ('ALSDMP: ', A, '(',I3,') = ', A)
 1053 FORMAT ('ALSDMP: ', A, '(',I3,',',I3,') =', I12)
 1054 FORMAT ('ALSDMP: ', A, '(',I3,',',I3,') =', L1)
 2000 FORMAT ('ALSDMP: BAD DATA TYPE = ', I7)
      END

      SUBROUTINE METSCD (X, PREFIX, PFLAG)
C-----------------------------------------------------------------------
C! scale a value to the range 1-999 and provide a metric prefix to match
C# Utility Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Scale the DOUBLE value X to a value 0.99995 - 999.95 and pick a
C   standard metric prefix to match.  If X is too large or small to
C   scale, leave it unchanged and set PFLAG to TRUE.  Note that this
C   result should be displayed with formats F6.1, F7.2, etc.  DO NOT
C   use format Fn.0 with n < 6 - an overflow could occur.
C   Use METSCA for single precision floats.
C   In/Out:
C      X       D     input value
C   Outputs:
C      PREFIX  C*5   4 character/word (<= 5 chars total) metric prefix
C      PFLAG   L     if .FALSE. scaling worked;
C                    if .TRUE. X has been left unchanged
C-----------------------------------------------------------------------
      CHARACTER PREFIX*5
      DOUBLE PRECISION X
      LOGICAL   PFLAG
C                                       Declare max prefix number,blank
      INTEGER   MXPREF, NF
      PARAMETER (MXPREF=17,NF=9)
      CHARACTER PLIST(MXPREF)*5
      DOUBLE PRECISION Y
      INTEGER   I
      DATA PLIST /'Yocto', 'Zepto', 'Atto ', 'Femto', 'Pico ', 'Nano ',
     *   'Micro', 'Milli', '     ', 'Kilo ', 'Mega ', 'Giga ', 'Tera ',
     *   'Peta ', 'Exa  ', 'Zetta', 'Yotta'/
C-----------------------------------------------------------------------
C                                       check for zero
      PFLAG = .FALSE.
      PREFIX = PLIST(NF)
      IF (X.NE.0.0D0) THEN
C                                       get log10 in 3's, check rng
         Y = NF + (LOG10 (ABS (X)) / 3.0)
         PFLAG = ((Y.LT.1.0) .OR. (Y.GT.MXPREF))
C                                       do scaling, check
         IF (.NOT.PFLAG) THEN
            I = Y
            X = X * (10.0D0 ** (3*(NF-I)))
            IF (X.GT.999.949D0) THEN
               X = X / 1000.0D0
               I = I + 1
               END IF
            PFLAG = ((I.LT.1) .OR. (I.GT.MXPREF))
            IF (PFLAG) GO TO 999
C                                       set prefix
            PREFIX = PLIST(MAX(1,MIN(I,MXPREF)))
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE J2B (R2000, D2000, BEPOCH, R1950, D1950,
     *   DR1950, DD1950)
C-------------------------------------------------------------------
C! Convert J2000 to B1950 positions of the source
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to convert a J2000.0 FK5 source  position to B1950.0 FK4
C   assuming zero proper motion and parallax (double precision)
C
C   This routine converts the source  positions from the IAU 1976,
C   FK5, Fricke system to the Bessel-Newcomb, FK4 system.
C
C   Inputs:
C      R2000,D2000      D    J2000.0 FK5 RA, Dec (radians)
C      BEPOCH           D    Besselian epoch (e.g. 1979.3D0, 1950.0D0)
C
C   Outputs
C      R1950,D1950      D    B1950.0 FK4 RA,Dec (rad) at epoch BEPOCH
C      DR1950,DD1950    D    B1950.0 FK4 RA,Dec (rad) proper motions
C                            (rad/trop.yr)
C
C   Notes:
C
C   1)  The proper motion in RA is dRA/dt rather than cos(Dec)*dRA/dt.
C
C   2)  Conversion from Julian epoch 2000.0 to Besselian epoch 1950.0
C       only is provided for.  Conversions involving other epochs will
C       require use of the appropriate precession routines before and
C       after this routine is called.
C
C   3)  Unlike in the sla_FK524 routine, the FK5 proper motions, the
C       parallax and the radial velocity are presumed zero.
C
C   4)  It is the intention that FK5 should be a close approximation
C       to an inertial frame, so that distant objects have zero proper
C       motion;  such objects have (in general) non-zero proper motion
C       in FK4, and this routine returns those fictitious proper
C       motions.
C
C   5)  The position returned by this routine is in the B1950
C       reference frame but at Besselian epoch BEPOCH.  For
C       comparison with catalogues the BEPOCH argument will
C       frequently be 1950D0.
C
C   Called:  F52F4, PM
C
C   This subroutine is a modified verion of the SLALIB routine FK54Z
C   written by P.T.Wallace   Starlink   10 April 1990,
C   Rutherford Appleton Laboratory
C-------------------------------------------------------------------
      DOUBLE PRECISION R2000, D2000, BEPOCH, R1950, D1950, DR1950,
     *   DD1950
      DOUBLE PRECISION R,D,PX,RV
C
C                                       FK5 equinox J2000 (any epoch) to
C                                       FK4 equinox B1950 epoch B1950
      CALL F52F4(R2000, D2000, 0D0, 0D0, 0D0, 0D0, R, D, DR1950,
     *   DD1950, PX, RV)
C                                       Fictitious proper motion to
C                                       epoch BEPOCH
      CALL PM(R, D, DR1950, DD1950, 0D0, 0D0, 1950D0,BEPOCH,
     *            R1950,D1950)

      END
C
C
      SUBROUTINE F52F4 (R2000, D2000, DR2000, DD2000, P2000, V2000,
     *   R1950, D1950, DR1950, DD1950, P1950, V1950)
C-------------------------------------------------------------------
C
C   Routine to Convert J2000.0 FK5 source data to B1950.0 FK4
C   (double precision)
C
C   This routine converts source positions from the new, IAU 1976, FK5,
C   Fricke system, to the old, Bessel-Newcomb, FK4 system.  The precepts
C   of Smith et al (Ref 1) are followed, using the implementation
C   by Yallop et al (Ref 2) of a matrix method due to Standish.
C   Kinoshita's development of Andoyer's post-Newcomb precession is
C   used.  The numerical constants from Seidelmann et al (Ref 3) are
C   used canonically.
C
C   Inputs:  (all J2000.0,FK5)
C      R2000,D2000     D    J2000.0 RA,Dec (rad)
C      DR2000,DD2000   D    J2000.0 proper motions (rad/Jul.yr)
C      P2000           D    parallax (arcsec)
C      V2000           D    radial velocity
C                           (km/s, positive => moving away)
C   Outputs:  (all B1950.0,FK4)
C      R1950,D1950     D    B1950.0 RA,Dec (rad)
C      DR1950,DD1950   D    B1950.0 proper motions (rad/trop.yr)
C      P1950           D    parallax (arcsec)
C      V1950           D    radial velocity
C                           (km/s, positive => moving away)
C   Notes:
C
C   1)  The proper motions in RA are dRA/dt rather than
C       cos(Dec)C dRA/dt, and are per year rather than per century.
C
C   2)  Note that conversion from Julian epoch 2000.0 to Besselian
C       epoch 1950.0 only is provided for.  Conversions involving
C       other epochs will require use of the appropriate precession,
C       proper motion, and E-terms routines before and/or after
C       F52F4 is called.
C
C   3)  In the FK4 catalogue the proper motions of stars within
C       10 degrees of the poles do not embody the differential
C       E-term effect and should, strictly speaking, be handled
C       in a different manner from stars outside these regions.
C       However, given the general lack of homogeneity of the star
C       data available for routine astrometry, the difficulties of
C       handling positions that may have been determined from
C       astrometric fields spanning the polar and non-polar regions,
C       the likelihood that the differential E-terms effect was not
C       taken into account when allowing for proper motion in past
C       astrometry, and the undesirability of a discontinuity in
C       the algorithm, the decision has been made in this routine to
C       include the effect of differential E-terms on the proper
C       motions for all stars, whether polar or not.  At epoch 2000,
C       and measuring on the sky rather than in terms of dRA, the
C       errors resulting from this simplification are less than
C       1 milliarcsecond in position and 1 milliarcsecond per
C       century in proper motion.
C
C   References:
C
C      1  Smith, C.A. et al, 1989.  "The transformation of astrometric
C         catalog systems to the equinox J2000.0".  Astron.J. 97, 265.
C
C      2  Yallop, B.D. et al, 1989.  "Transformation of mean star places
C         from FK4 B1950.0 to FK5 J2000.0 using matrices in 6-space".
C         Astron.J. 97, 274.
C
C      3  Seidelmann, P.K. (ed), 1992.  "Explanatory Supplement to
C         the Astronomical Almanac", ISBN 0-935702-68-7.
C
C   This subroutine is a modified verion of the SLALIB routine FK524
C   written by P.T.Wallace   Starlink  19 December 1993,
C   Rutherford Appleton Laboratory
C-------------------------------------------------------------------
      DOUBLE PRECISION R2000, D2000, DR2000, DD2000, P2000, V2000,
     *                 R1950, D1950, DR1950, DD1950, P1950, V1950
C                                       Miscellaneous
      DOUBLE PRECISION R, D, UR, UD, PX, RV
      DOUBLE PRECISION SR, CR, SD, CD, X, Y, Z, W
      DOUBLE PRECISION V1(6), V2(6)
      DOUBLE PRECISION XD, YD, ZD
      DOUBLE PRECISION RXYZ, WD, RXYSQ, RXY
      INTEGER I, J
C                                       2Pi
      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925287D0)
C                                       Radians per year to arcsec per
C                                       century
      DOUBLE PRECISION PMF
      PARAMETER (PMF = 100D0*60D0*60D0*360D0/D2PI)
C                                       Small number to avoid arithmetic
C                                       problems
      DOUBLE PRECISION TINY
      PARAMETER (TINY=1D-30)
C                                       CANONICAL CONSTANTS  (see
C                                       references)
C                                       Km per sec to AU per tropical
C                                       century
C                                       86400 * 36524.2198782 /
C                                       149597870 = 21.095
      DOUBLE PRECISION VF
      PARAMETER (VF=21.095D0)

C   Constant vector and matrix (by columns)
      DOUBLE PRECISION A(6), EMI(6,6)
      DATA A/ -1.62557D-6,  -0.31919D-6, -0.13843D-6,
     *        +1.245D-3,    -1.580D-3,   -0.659D-3/
C
      DATA (EMI(I,1),I=1,6) / +0.9999256795D0,
     *                        -0.0111814828D0,
     *                        -0.0048590040D0,
     *                        -0.000551D0,
     *                        -0.238560D0,
     *                        +0.435730D0 /

      DATA (EMI(I,2),I=1,6) / +0.0111814828D0,
     *                        +0.9999374849D0,
     *                        -0.0000271557D0,
     *                        +0.238509D0,
     *                        -0.002667D0,
     *                        -0.008541D0 /

      DATA (EMI(I,3),I=1,6) / +0.0048590039D0,
     *                        -0.0000271771D0,
     *                        +0.9999881946D0,
     *                        -0.435614D0,
     *                        +0.012254D0,
     *                        +0.002117D0 /

      DATA (EMI(I,4),I=1,6) / -0.00000242389840D0,
     *                        +0.00000002710544D0,
     *                        +0.00000001177742D0,
     *                        +0.99990432D0,
     *                        -0.01118145D0,
     *                        -0.00485852D0 /

      DATA (EMI(I,5),I=1,6) / -0.00000002710544D0,
     *                        -0.00000242392702D0,
     *                        +0.00000000006585D0,
     *                        +0.01118145D0,
     *                        +0.99991613D0,
     *                        -0.00002716D0 /

      DATA (EMI(I,6),I=1,6) / -0.00000001177742D0,
     *                        +0.00000000006585D0,
     *                        -0.00000242404995D0,
     *                        +0.00485852D0,
     *                        -0.00002717D0,
     *                        +0.99996684D0 /
C-------------------------------------------------------------------


C                                       Pick up J2000 data (units
C                                       radians and arcsec/JC)
      R = R2000
      D = D2000
      UR = DR2000*PMF
      UD = DD2000*PMF
      PX = P2000
      RV = V2000

C                                       Spherical to Cartesian
      SR = SIN(R)
      CR = COS(R)
      SD = SIN(D)
      CD = COS(D)

      X = CR*CD
      Y = SR*CD
      Z =   SD

      W = VF*RV*PX

      V1(1) = X
      V1(2) = Y
      V1(3) = Z

      V1(4) = -UR*Y - CR*SD*UD + W*X
      V1(5) = UR*X - SR*SD*UD + W*Y
      V1(6) = CD*UD + W*Z

C                                       Convert position+velocity vector
C                                       to BN system
      DO 20 I = 1, 6
         W = 0D0
         DO 10 J =1, 6
            W = W + EMI(I,J)*V1(J)
   10       CONTINUE
         V2(I) = W
   20    CONTINUE

C                                       Position vector components and
C                                       magnitude
      X = V2(1)
      Y = V2(2)
      Z = V2(3)
      RXYZ = SQRT(X*X + Y*Y + Z*Z)

C                                       Apply E-terms to position
      W = X*A(1) + Y*A(2) + Z*A(3)
      X = X + A(1)*RXYZ - W*X
      Y = Y + A(2)*RXYZ - W*Y
      Z = Z + A(3)*RXYZ - W*Z

C                                       Recompute magnitude
      RXYZ = SQRT(X*X + Y*Y + Z*Z)

C                                       Apply E-terms to both position
C                                       and velocity
      X = V2(1)
      Y = V2(2)
      Z = V2(3)
      W = X*A(1) + Y*A(2) + Z*A(3)
      WD = X*A(4) + Y*A(5) + Z*A(6)
      X = X + A(1)*RXYZ - W*X
      Y = Y + A(2)*RXYZ - W*Y
      Z = Z + A(3)*RXYZ - W*Z
      XD = V2(4) + A(4)*RXYZ - WD*X
      YD = V2(5) + A(5)*RXYZ - WD*Y
      ZD = V2(6) + A(6)*RXYZ - WD*Z

C                                       Convert to spherical
      RXYSQ = X*X + Y*Y
      RXY = SQRT(RXYSQ)

      IF (X.EQ.0D0 .AND. Y.EQ.0D0) THEN
         R = 0D0
      ELSE
         R = ATAN2(Y,X)
         IF (R.LT.0.0D0) R = R + D2PI
         END IF
      D = ATAN2(Z,RXY)

      IF (RXY .GT. TINY) THEN
         UR = (X*YD - Y*XD)/RXYSQ
         UD = (ZD*RXYSQ - Z*(X*XD + Y*YD))/((RXYSQ + Z*Z)*RXY)
         END IF

C   Radial velocity and parallax
      IF (PX .GT. TINY) THEN
         RV = (X*XD + Y*YD + Z*ZD)/(PX*VF*RXYZ)
         PX = PX/RXYZ
         END IF

C                                       Return results
      R1950 = R
      D1950 = D
      DR1950 = UR/PMF
      DD1950 = UD/PMF
      P1950 = PX
      V1950 = RV
C
      END
C
C
      SUBROUTINE PM (R0, D0, PR, PD, PX, RV, EP0, EP1, R1, D1)
C
C  Apply corrections for proper motion to a star RA,Dec
C  (double precision)
C
C  References:
C     1984 Astronomical Almanac, pp B39-B41.
C     (also Lederle & Schwan, Astron. Astrophys. 134,
C      1-6, 1984)
C
C  Inputs:
C     R0,D0    D     RA,Dec at epoch EP0 (rad)
C     PR,PD    D     proper motions:  RA,Dec changes per year of epoch
C     PX       D     parallax (arcsec)
C     RV       D     radial velocity (km/sec, +ve if receding)
C     EP0      D     start epoch in years (e.g. Julian epoch)
C     EP1      D     end epoch in years (same system as EP0)
C
C  Outputs:
C     R1,D1    D     RA,Dec at epoch EP1 (rad)
C
C  Note:
C     The proper motions in RA are dRA/dt rather than
C     cos(Dec)*dRA/dt, and are in the same coordinate
C     system as R0,D0.
C
C   This subroutine is a modified verion of the SLALIB routine PM
C   written by P.T.Wallace   Starlink  12 April 1990,
C   Rutherford Appleton Laboratory
C-------------------------------------------------------------------
      DOUBLE PRECISION R0,D0,PR,PD,PX,RV,EP0,EP1,R1,D1

C  Km/s to AU/year multiplied by arc seconds to radians
      DOUBLE PRECISION VFR
      PARAMETER (VFR=0.21094502D0*0.4848136811095359949D-05)

      INTEGER I
      DOUBLE PRECISION W,EM(3),T,P(3)
      DOUBLE PRECISION X, Y, Z, R
      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925286766559D0)
C  Spherical to Cartesian
C      CALL sla_DCS2C(R0,D0,P)
      P(1) = COS(R0)*COS(D0)
      P(2) = SIN(R0)*COS(D0)
      P(3) = SIN(D0)
C  Space motion (radians per year)
      W = VFR*RV*PX
      EM(1) = -PR*P(2)-PD*COS(R0)*SIN(D0)+W*P(1)
      EM(2) =  PR*P(1)-PD*SIN(R0)*SIN(D0)+W*P(2)
      EM(3) =         PD*COS(D0)        +W*P(3)

C  Apply the motion
      T = EP1-EP0
      DO 10 I = 1,3
         P(I) = P(I)+T*EM(I)
   10    CONTINUE

C  Cartesian to spherical
C      CALL sla_DCC2S(P,R1,D1)
      X = P(1)
      Y = P(2)
      Z = P(3)
      R = SQRT(X*X+Y*Y)

      IF (R.EQ.0D0) THEN
         R1 = 0D0
      ELSE
         R1 = ATAN2(Y,X)
         END IF

      IF (Z.EQ.0D0) THEN
         D1 = 0D0
      ELSE
         D1 = ATAN2(Z,R)
         END IF
C      R1=sla_DRANRM(R1)
      R1 = MOD(R1,D2PI)
      IF (R1.LT.0D0) R1 = R1 + D2PI
C
      END

      SUBROUTINE QGASUB (APCORE, MODL, U, VS, INCVS, INCF, INCS, NCOMP,
     *   NVIS, NF, MF, NS, FLAG)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Subtract Gaus. model vis. from uv data.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2000, 2006-2007, 2012, 2018-2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Vector compiler version
C   Subtracts the model visibility derived from Gaussian components from
C   visibility records.  Arbitrary numbers of frequencies and
C   polarizations can be processed.
C   Inputs:
C      MODL   I  Base address of Gaussian components, increment = 7
C                0 = Amplitude
C                1 = -2 * PI * X (radians)
C                2 = -2 * PI * Y
C                3 = -2 * PI * Z
C                4 = A = -0.5*((COS(PA)*SIG(MAJ))**2 +
C                        (SIN(PA)*SIG(MIN))**2)
C                5 = B = -0.5*((SIN(PA)*SIG(MAJ))**2 +
C                        (COS(PA)*SIG(MIN))**2)
C                6 = C = -(SIN(PA)*COS(PA)*
C                         (SIG(MAJ)**2 - SIG(MIN)**2)
C      U     I  Base address of Us, assumed followed by V, W
C      VS    I  Base address of vis rec. (real, imag, wt)
C      INCVS I  Increment of VS for next visibility
C      INCF  I  Increment of VS for next frequency
C      INCS  I  Increment of VS for next Stokes (RR or LL)
C      NCOMP I  Number of Gaussian components.
C      NVIS  I  Number of visibilities.
C      NF    I  Number of frequencies.
C      MF    I  Max number freq (address of UUU)
C      NS    I  Number of Stokes (usually 1 or 2)
C      FLAG  I  If FLAG < 0 multiply model vis by i (SQRT(-1))
C   Also uses AP locations 0 and 1 and expects an array of length NS
C   beginning in location 2+NF composed of the correlator factors.
C   Beginning in location 2 should be an array of length NF :
C              Freq(0) / Freq(ref) - 1.0
C              Freq(1) / Freq(ref) - 1.0
C                      .
C                      .
C                      .
C              Freq(NF-1) / Freq(ref) - 1.0
C   Note: all addresses are 0 relative and needed to be incremented by
C   1 to work in Fortran.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   MODL, U, VS, INCVS, INCS, INCF, NCOMP, NVIS, NF, MF, NS,
     *   FLAG
C
      INTEGER   X, JVS, IVS, IF, IV, IS, ICOMP, A, AMP
      LONGINT   IU, F, JX, JA, JAMP, S
      DOUBLE PRECISION FREQF, SUMRE, SUMIM, REMOD, IMMOD, FREQ2, PHS,
     *   AMPL, UU, VV, UV, SCALE
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                        Make sure that there is data.
      IF ((NCOMP.LE.0) .OR. (NVIS.LE.0) .OR. (NF.LE.0) .OR.
     *   (NS.LE.0))  GO TO 999
C                                       Setup array addresses
      X = MODL + 1
      A = MODL + 4
      AMP = MODL
      IU = U + PSAPOF - 1
      IVS = VS
      S = MF + 1 + PSAPOF
      SCALE = APCORE(S+1+NS)
C                                       Begin visibility loop
C$OMP PARALLEL DO PRIVATE (IV, JVS, F, S, IF, SUMRE, SUMIM, JX, JAMP,
C$OMP+              FREQF, ICOMP, PHS, REMOD, IMMOD, IS, FREQ2, UU,
C$OMP+              VV, UV, JA, IVS, IU, AMPL), SHARE(APCORE)
      DO 300 IV = 1,NVIS
C                                       Get ready for freq. loop
         JVS = IVS
         F = 1 + PSAPOF
         UU = APCORE(IU+1) * APCORE(IU+1)
         VV = APCORE(IU+2) * APCORE(IU+2)
         UV = APCORE(IU+1) * APCORE(IU+2)
C                                       Begin frequency loop
         DO 200 IF = 1,NF
            IF (ABS (APCORE(F+1)).GT.1.0D-20) THEN
               FREQF = 1.0D0 + APCORE(F+1)
            ELSE
               FREQF = 1.0D0
               END IF
            FREQ2 = FREQF * FREQF
C                                       Loop over component
            SUMRE = 0.0D0
            SUMIM = 0.0D0
            JX = X + PSAPOF
            JA = A + PSAPOF
            JAMP = AMP + PSAPOF
            DO 100 ICOMP = 1,NCOMP
               PHS = FREQF * (APCORE(JX) * APCORE(IU+1)
     *                      + APCORE(JX+1) * APCORE(IU+2)
     *                      + APCORE(JX+2) * APCORE(IU+3))
               AMPL = FREQ2 * (APCORE(JA) * VV
     *            + APCORE(JA+1) * UU + APCORE(JA+2) * UV)
               AMPL = APCORE(JAMP) * EXP (AMPL)
               SUMRE = SUMRE + AMPL * COS(PHS)
               SUMIM = SUMIM + AMPL * SIN(PHS)
               JX = JX + 7
               JA = JA + 7
               JAMP = JAMP + 7
 100           CONTINUE
C                                       Correct visibility
            JA = JVS + PSAPOF
C                                        Setup
            IF (FLAG.LT.0) THEN
               REMOD = -SUMIM * SCALE
               IMMOD = SUMRE * SCALE
            ELSE
               REMOD = SUMRE * SCALE
               IMMOD = SUMIM * SCALE
               END IF
C                                       Loop over Stokes (1 or 2,
C                                       no point in vectorizing)
C                                       model uses +
C                                       Subtract model from data
            DO 160 IS = 1,NS
               APCORE(JA) = APCORE(JA) + REMOD * APCORE(S+IS)
               APCORE(JA+1) = APCORE(JA+1) + IMMOD * APCORE(S+IS)
               JA = JA + INCS
 160           CONTINUE
C                                        Update vis pointer
            JVS = JVS + INCF
            F = F + 1
 200        CONTINUE
C                                        Update pointers
         IVS = IVS + INCVS
         IU = IU + INCVS
 300     CONTINUE
C$OMP END PARALLEL DO
C
 999  RETURN
      END

      SUBROUTINE OPACTY (IBAND, TSURF, TDEW, PRESS, WT, MJD, AVGIAT,
     *   NH2O, OPAC)
C-----------------------------------------------------------------------
C! Calculate opacity averaging surface weather opacity and seasonal
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2002, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to calculate estimates of opacity
C   Input:
C      IBAND    I   VLA band, 1->4, 2->P, ..., 8->Q
C      TSURF    R   Surface ambient temp (C)
C      TDEW     R   Surface dewpoint temp (C)
C      PRESS    R   Surface pressure in millibars
C      WT       R   Weight to give weather (0 -> 1), 1-WT given seasonal
C      MJD      I   Current Modified Julian day
C      AVGIAT   D   Average IAT after MJD
C   Output:
C      NH2O     R   H2O column density  (requires WT > 0)
C      OPAC     R   Zenith opacity
C   Function to calculate day of year from month, day, year from Meeus'
C   book on Astronomical Algorithms.
C-----------------------------------------------------------------------
      INTEGER   IBAND, MJD
      REAL      TSURF, TDEW, PRESS, WT, NH2O, OPAC
      DOUBLE PRECISION AVGIAT
C
      REAL      KK, MVAP, WATDEN, VAPH, CONST, WOPAC, SOPAC
      PARAMETER (KK = 1.380658E-23)
      PARAMETER (MVAP = 18 * 1.6749286E-27)
      PARAMETER (WATDEN = 1000.0)
C                                       VAPH is the scale height of H2O
C                                       vapor
      PARAMETER (VAPH = 1500.0)
      PARAMETER (CONST = 1.0E5*MVAP*VAPH/(WATDEN*KK))
      REAL      PVAP, C(3,10), MDOY, D(3,10)
      INTEGER   IDATE(6), DOY, MONTH, DAY, YEAR, K2
      LOGICAL   ISLEAP, FIRST
      EQUIVALENCE (YEAR, IDATE(1)), (MONTH, IDATE(2)), (DAY, IDATE(3))
      INCLUDE 'INCS:DMSG.INC'
      SAVE FIRST
      DATA FIRST /.TRUE./
C                                       4-band
      DATA C /  0.0,  0.0,  0.0,
C                                       P-band
     *          0.0,  0.0,  0.0,
C                                       L-band
     *          1.0,  0.0,  0.0,
C                                       S-band
     *          1.0,  0.0,  0.0,
C                                       C-band
     *          1.0,  0.0,  0.0,
C                                       X-band
     *          1.0,  0.0,  0.0,
C                                       U-band
     *          1.19, 0.0578, -2.486E-4,
C                                       K-band
     *          1.77, 0.9060, -1.385E-4,
C                                       A-band   copy U for now
     *          1.19, 0.0578, -2.486E-4,
C                                       Q-band
     *          5.86, 0.1712,  9.201E-4 /
C                                       4-band
      DATA D /  0.0,  0.0,  0.0,
C                                       P-band
     *          0.0,  0.0,  0.0,
C                                       L-band
     *          1.0,  0.0,  0.0,
C                                       S-band
     *          1.0,  0.0,  0.0,
C                                       C-band
     *          1.0,  0.0,  0.0,
C                                       X-band
     *          1.0,  0.0,  0.0,
C                                       U-band
     *          2.19, -0.0085, 2.010E-5,
C                                       K-band
     *         22.12, -0.1783, 4.402E-4,
C                                       A-band   copy U for now
     *          2.19, -0.0085, 2.010E-5,
C                                       Q-band
     *          9.70, -0.0357, 9.402E-5 /
C-----------------------------------------------------------------------
      IF (IBAND.EQ.9) THEN
         MSGTXT = 'OPACTY: HAS A BAND BEEN MEASURED YET?  USING U BAND'
         IF (FIRST) CALL MSGWRT (7)
         FIRST = .FALSE.
      ELSE
         FIRST = .TRUE.
         END IF
C                                       weather opacity
      IF (WT.GT.0.0) THEN
         CALL SATPRS (TDEW, PRESS, PVAP)
         NH2O = CONST * PVAP / (TSURF + 273.15)
         WOPAC = (C(1,IBAND) + C(2,IBAND)*NH2O + C(3,IBAND)*NH2O*NH2O) /
     *      100.0
      ELSE
         WOPAC = 0.0
         END IF
C                                       seasonal opacity
      IF (WT.LT.1.0) THEN
         CALL JD2DAT (MJD+2400000.5D0, IDATE)
         ISLEAP = (MOD(YEAR,4).EQ.0) .AND. ((MOD(YEAR,100).NE.0) .OR.
     *      (MOD(YEAR,400).EQ.0))
         IF (ISLEAP) THEN
            K2 = 1
         ELSE
            K2 = 2
            END IF
         DOY = ((275 * MONTH) / 9) - K2 * ((MONTH + 9) / 12) + DAY - 30
         MDOY = DOY
         IF (MDOY.GE.200.0) MDOY = MDOY - 365.0
         MDOY = MDOY + 165.0
         MDOY = MDOY + AVGIAT/24.0
         SOPAC = (D(1,IBAND) + D(2,IBAND)*MDOY + D(3,IBAND)*MDOY*MDOY) /
     *      100.0
      ELSE
         SOPAC = 0.0
         END IF
      OPAC = MAX (0.0, MIN (1.0, WT)) * WOPAC +
     *   MAX (0.0, MIN (1.0, 1.0-WT)) * SOPAC
C
 999  RETURN
      END

      SUBROUTINE YCRCTL (OP, ON, X, Y, LINKX, LINKY, RBLINK, BUTTON,
     *   VRTRTC, IERR)
C-----------------------------------------------------------------------
C! controls the TV cursor visibility, position; reads trackball buttons
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YCRCTL reads/writes the cursor/trackball control register of TV
C   Inputs:
C      OP      C*4   'READ' from TV or 'WRIT' to TV
C      VRTRTC  L     T => do on vertical retrace only
C   In/out:
C      ON      L     T => cursor visible, F => off
C      X       I     X position cursor center (1-512, 1 => LHS)
C      Y       I     Y position cursor center (1-512, 1 => bot)
C      LINKX   L     T => trackball moves cursor in X
C      LINKY   L     T => trackball moves cursor in Y
C      RBLINK  I     rate of cursor blink: 0-3 no-fast blink
C   Output:
C      BUTTON  I     button value (0 - 15)
C      IERR    I     error code of Z...XF : 0 => ok
C                                           2 => input error
C   IIS M75 version: 15 buttons -> 15 distinct values, but are
C   converted to just 4 to match the IIS M70.
C   M75 button    real value         output value
C     F1              1                  1 (M70 button A)
C     F2              2                  2 (M70 button B)
C     F3              3                  4 (M70 button C)
C     A1              4                  1 (M70 button A)
C     B1              5                  2 (M70 button B)
C     C1              6                  4 (M70 button C)
C     D1              7                  8 (M70 button D)
C     A2              4                  1 (M70 button A)
C     B2              5                  2 (M70 button B)
C     C2              6                  4 (M70 button C)
C     D2              7                  8 (M70 button D)
C     A3              4                  1 (M70 button A)
C     B3              5                  2 (M70 button B)
C     C3              6                  4 (M70 button C)
C     D3              7                  8 (M70 button D)
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   X, Y, RBLINK, BUTTON, IERR
      LOGICAL   ON, LINKX, LINKY, VRTRTC
C
      INTEGER   BUFFER(3), HEADER(8), UNIT, BUFSIZ, BITS(16), NB, I, IV
      LOGICAL   COMAND
      DATA UNIT, COMAND, BUFSIZ /10,.TRUE.,3/
C-----------------------------------------------------------------------
C                                       WRIT: build control word
      IF (OP.EQ.'WRIT') THEN
         IERR = 2
         IF ((X.LT.1) .OR. (X.GT.512)) GO TO 999
         IF ((Y.LT.1) .OR. (Y.GT.512)) GO TO 999
         BUFFER(2) = MOD (X-33, 512)
         BUFFER(3) = MOD (480-Y, 512)
         CALL FILL (16, 0, BITS)
         IF (ON    ) BITS(1) = 1
         IF (LINKX ) BITS(2) = 1
         IF (LINKY ) BITS(3) = 1
         I = MAX (0, MIN (3, RBLINK))
         IF (I.NE.0) I = 4 - I
         CALL ZGTBIT (2, I, BITS(4))
         CALL ZPTBIT (16, BUFFER(1), BITS)
         END IF
C                                       Header & IO
      CALL YMKHDR (OP, UNIT, COMAND, BUFSIZ, 0, 0, 0, 0, VRTRTC, HEADER)
      NB = 2 * BUFSIZ
      CALL ZM70XF (OP, NB, HEADER, BUFFER, IERR)
C                                       Return answers
      IF ((IERR.EQ.0) .AND. (OP.NE.'WRIT')) THEN
         CALL ZGTBIT (16, BUFFER(1), BITS)
         ON     = BITS(1).EQ.1
         LINKX  = BITS(2).EQ.1
         LINKY  = BITS(3).EQ.1
         CALL ZPTBIT (4, IV, BITS(9))
         IF (IV.EQ.0) BUTTON = 0
         IF ((IV.GE.1) .AND. (IV.LE.3)) BUTTON = 2 ** (IV - 1)
         IF (IV.GE.4) BUTTON = 2 ** MOD (IV, 4)
         CALL ZPTBIT (2, RBLINK, BITS(4))
         IF (RBLINK.NE.0) RBLINK = 4 - RBLINK
C                                       Use button pushed bit to
C                                       prevent double hits
         IF (BITS(15).NE.1) BUTTON = 0
         X = MOD (BUFFER(2)+32, 512) + 1
         Y = 512 - MOD (BUFFER(3)+32, 512)
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'PRTUV.INC'
C                                       Local include for PRTUV
      INTEGER MMXSOU
C                                       MMXSOU=Max. no. source
      PARAMETER (MMXSOU=5000)
      INCLUDE 'INCS:ZPBUFSZ.INC'
C
      HOLLERITH XNAME(3), XCLAS(2), XSOUR(4,30), XLPNAM(12)
      REAL      XSEQ, XDISK, XNCH, XBIF, XSTR, XNIT, XINC, UVRANG(2),
     *   CPARM(10), DPARM(10), DOCRT, BTIME, ETIME, BUFF(UVBFSS),
     *   BUFF2(UVBFSS), DOEBAR
      LOGICAL   MULTI, DOSWNT, SCAL, DORAND, DOAMPH
      INTEGER   DISK, CNO, SEQ, USERID, LUNP, FINDP, LUN, FIND, PAGE,
     *   IPCNT, SOUWAN(MMXSOU), NSOUWD, NACROS, BIF, VO, INC, NCH, ANT1,
     *   ANT2, NUMCH, NUMCHM, NUMIF, OTYPE, HM(2), DD(2), BUFSZ, ISUB,
     *   NVORNG, VORNG(2,1000), NCORP
      REAL      RSEC, DSEC, XAMP, UVM, XWT, NWT, MAXW, MINW, MAXA,
     *   MAXUVW
      CHARACTER NAME*12, CLASS*6, SAUCE(30)*16, TITL1*132, TITL2*132,
     *   SCRTCH*132, LINE*132, LPNAME*48, CHSIG1*1, CHSIG2*1
      COMMON /INPARM/ XNAME, XCLAS, XSEQ, XDISK, XSOUR, XNCH, XBIF,
     *   XSTR, XNIT, XINC, UVRANG, CPARM, DPARM, DOCRT, XLPNAM, DOEBAR
      COMMON /PRTUIP/ RSEC, DSEC, BTIME, ETIME, MULTI, DOSWNT, DISK,
     *   CNO, SEQ, USERID, LUNP, FINDP, LUN, FIND, PAGE, IPCNT, SOUWAN,
     *   NSOUWD, NACROS, BIF, VO, INC, NCH, ANT1, ANT2, NUMCH, NUMCHM,
     *   NUMIF, OTYPE, HM, DD, XAMP, UVM, XWT, NWT, ISUB, SCAL, MAXW,
     *   MINW, MAXA, MAXUVW, DORAND, DOAMPH, NVORNG, VORNG, NCORP
      COMMON /PRUUBF/ BUFSZ, BUFF, BUFF2
      COMMON /PRTUCS/ NAME, CLASS, SAUCE, TITL1, TITL2, SCRTCH, LINE,
     *   LPNAME, CHSIG1, CHSIG2
LOCAL END
      PROGRAM PRTUV
C-----------------------------------------------------------------------
C! Lists selected portion of a catalogued uv data base.
C# UV UV-util VLA VLB Printer
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998-2001, 2004, 2007, 2009-2013,
C;  Copyright (C) 2015-2017, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task PRTUV lists a selected portion of a catalogd uv data base.
C   Inputs:
C      AIPS Adverb   Prg. Name          Description
C      USERID         USERID        User number.
C      INNAME         NAME          File name to be listed.
C      INCLASS        CLASS         File class to be listed.
C      INSEQ          SEQ           File sequence number.
C      INDISK         DISK          Disk volumn on which file resides.
C      SOURCES        SAUCE         List of up to 30 sources to be
C                                   listed
C      CHANNEL        NCH           Spectral channel.
C      BIF            BIF           If number
C      BPRINT         VO            Visibility number to start list
C      NPRINT         XNIT          Number of components to list
C                                   default: 1 Page.
C      XINC           INC           Increment for vis.
C      UVRANGE        UVRANG        Range of UV in 1000's wavelengths
C      CPARM          CPARM         1-4: start time D, H, M, S
C                                   5-8: stop time D, H, M, S
C                                   9  : 100*ant1 + ant2
C                                   10 : Multiply amps by this.
C      DOCRT          DOCRT         > 0 => use CRT, else line printer
C      OUTPRINT       LPNAME        File name to keep printer output
C   Programmer: W. D. Cotton, Jan. 1981.  EWG (Aug 1984), PJD (Aug 1989)
C   Modified for R   uv data base July 1981.
C   CPARM(10) added by RCW Dec 1992.
C   Modified to print 1/sqrt(wt) for weight  RCW  16apr92
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PRTUV.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'PRTUV '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL PRTUIN (PRGM, IRET)
C                                       count lines
      IF (IRET.EQ.0) CALL PRTUCH (IRET)
C                                       Print it
      IF ((IRET.EQ.0) .AND. (SCAL)) CALL PRTUSC (IRET)
C                                       Print it
      IF (IRET.EQ.0) CALL PRTUDO (IRET)
C
      IRET = MAX (0, IRET)
      CALL DIE (IRET, BUFF)
C
 999  STOP
      END
      SUBROUTINE PRTUIN (PRGM, IRET)
C-----------------------------------------------------------------------
C   Startup routine for PRTUV.  Gets input parameters and converts them
C   to the internal forms.  Looks up the sources to be used.
C   Input:
C      PRGM     C*6    Task name
C   Output:
C      IRET     I      Return code, 1=OK, else failed
C   Output in comon:
C      NAME     C*12   Input file name
C      CLASS    C*6    Input file class
C      SEQ      I      Input file sequence no.
C      DISK     I      Input file disk no.
C      CNO      I      Input file catalog slot no.
C      USERID   I      User ID number.
C      LPNAME   C*48   Output file name
C      SAUCE    C(*)*16 Source names
C      NACROS   I      No. columns in output.
C      NCH      I      Start channel number
C      BIF      I      IF number
C      VO       I      First vis to consider.
C      INC      I      Increment between vis.
C      BTIME    R      Start time (days)
C      ETIME    R      End time (days)
C      ANT1     I      First antenna selected.
C      ANT2     I      Second antenna selected.
C      MULTI    L      True if a multi-source file.
C      NUMCHM   I      Possible number of channels
C      NUMCH    I      Number of channels to print
C      OTYPE    I      Output listing type (length)
C      SOURCE   C*8    Source name
C      HM       I(2)   Source RA h, m
C      RSEC     R      Source RA, s
C      CHSIG1   C*1    RA sign (' ')
C      DD       I(2)   Source Dec h, m
C      DSEC     R      Source Dec, s
C      CHSIG2   C*1    Dec sign (' ')
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
C
      INTEGER   NPARM, I, SULUN, MAXSOU, IERR, IROUND, VER, IFQ, NIF
      CHARACTER UTYPE*2, LLCH*4, MMCH*4
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PRTUV.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DCHND.INC'
      DATA SULUN /17/
C-----------------------------------------------------------------------
      IRET = 5
C                                       Init I/O
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Initialize CFIL.INC

      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 168
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAME, BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'GETTING INPUT PARAMETERS'
         IF (IRET.EQ.1) GO TO 990
         END IF
C                                       Restart AIPS.
      CALL H2CHR (48, 1, XLPNAM, LPNAME)
      IF ((IRET.NE.0) .OR. (NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   DOCRT = MIN (-1.0, DOCRT)
      IF (DOCRT.GT.0.0) RQUICK = .FALSE.
      IF (RQUICK) RQUICK = LPNAME.NE.' '
      IF (RQUICK) CALL RELPOP (IRET, BUFF, IERR)
      IRET = IERR
      IF (IRET.NE.0) GO TO 999
      IRET = 8
C                                       Process ADVERB parameters
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAME, NAME)
      CALL H2CHR (6, 1, XCLAS, CLASS)
      DO 15 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SAUCE(I))
 15      CONTINUE
C                                       Decode input.
      USERID = NLUSER
      SEQ = IROUND (XSEQ)
      DISK = IROUND (XDISK)
      NCH = 1
      IF (XNCH.GT.0) NCH = IROUND (XNCH)
      BIF = 1
      IF (XBIF.GT.0.1) BIF = IROUND (XBIF)
      IF (XSTR.LT.1.0) XSTR = 1.0
      VO = XSTR - 0.99
      INC = IROUND (XINC)
      INC = MAX (1, INC)
      IF (XNIT.LT.1.0) THEN
         XNIT = PRTMAX - 10.
         IF ((DOCRT.GT.0.0).OR.(LPNAME(1:1).NE.' ')) XNIT = 30000.
      ELSE IF ((DOCRT.LE.0.0).AND.(LPNAME(1:1).EQ.' ')) THEN
         XNIT = MIN (2000.0, XNIT)
         END IF
      UVRANG(1) = MAX (0.0, UVRANG(1))
      UVRANG(2) = MAX (0.0, UVRANG(2))
      IF (UVRANG(2).LE.UVRANG(1)+0.05) UVRANG(2) = 1.E10
      UVRANG(1) = UVRANG(1) ** 2
      UVRANG(2) = UVRANG(2) ** 2
      BTIME = ((CPARM(4)/60. + CPARM(3)) / 60. + CPARM(2)) / 24.
     *   + CPARM(1)
      ETIME = ((CPARM(8)/60. + CPARM(7)) / 60. + CPARM(6)) / 24.
     *   + CPARM(5)
      IF (ETIME.LE.BTIME) ETIME = 1.E9
C                                       Print Amp, Phas or Re, Im
      DOAMPH = DPARM(7).LT.0.01
C                                       antenna and subarray limits
      ANT1 = CPARM(9) / 100.0 + 0.001
      ANT2 = (CPARM(9) - 100.0 * ANT1) + 0.001
      ISUB = 100.0 * (CPARM(9) - 100*ANT1 - ANT2) + 0.01
      IF(CPARM(10).EQ.0.0) CPARM(10) = 1.0
      IF (ANT1.GE.ANT2) THEN
         I = ANT1
         ANT1 = ANT2
         ANT2 = I
         END IF
      IF ((ANT1.GT.0) .AND. (ANT2.GT.0)) THEN
         WRITE (MSGTXT,1015) ANT1, ANT2
         CALL MSGWRT (4)
      ELSE IF (ANT2.GT.0) THEN
         WRITE (MSGTXT,1016) ANT2
         CALL MSGWRT (4)
         END IF
      IF (ISUB.GT.0) THEN
         WRITE (MSGTXT,1017) ISUB
         CALL MSGWRT (4)
         END IF
C                                       scal or not scal
      SCAL = DPARM(1).LT.0
      IF (.NOT.SCAL) THEN
         MAXW = DPARM(2)
         IF (MAXW.LE.0) MAXW = 9.9
         MINW = DPARM(3)
         IF (MINW.LE.0) MINW = 0.11
         MAXA = DPARM(4)
         IF (MAXA.LE.0) MAXA = 99
         MAXUVW = DPARM(5)
         IF (MAXUVW.LE.0) MAXUVW = 10000
         END IF
C                                       Print regular or random
C                                       parameters?
      DORAND = DPARM(6).GT.0.01
C                                       Open file and get CATBLK.
      UTYPE = 'UV'
      LUN = 16
      CALL MAPOPN ('READ', DISK, NAME, CLASS, SEQ, UTYPE, USERID, LUN,
     *   FIND, CNO, CATBLK, BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Mark in CFIL.INC
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 0
C                                       Get info from CATBLK.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 990
      IF (XSTR.GT.NVIS) THEN
         VO = XSTR + 0.1
         WRITE (MSGTXT,1021) VO, NVIS
         IRET = 1
         GO TO 990
         END IF
      NVORNG = 1
      VORNG(1,1) = VO + 1
      VORNG(2,1) = NVIS
C                                       Fill array of source numbers
      NSOUWD = 1
      CALL MULSDB (CATBLK, MULTI)
      IF (MULTI) THEN
         MAXSOU = MMXSOU
         CALL SOULIS (SAUCE, DISK, CNO, SULUN, MAXSOU, NSOUWD, DOSWNT,
     *      SOUWAN, IRET)
C                                       Error check
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1011) IRET
            GO TO 990
            END IF
C                                       Make sure not too many sources.
         IF (NSOUWD.GT.MMXSOU) THEN
            WRITE (MSGTXT,1010) NSOUWD, MMXSOU
            IRET = 5
            GO TO 990
            END IF
         END IF
C                                       Check spectral channel, IF.
      NUMIF = 1
      IF (JLOCIF.GT.0) NUMIF = CATBLK(KINAX+JLOCIF)
      IF ((NCH.GT.CATBLK(KINAX+JLOCF)) .OR. (BIF.GT.NUMIF)) THEN
         IF (NCH.GT.CATBLK(KINAX+JLOCF)) WRITE (MSGTXT,1025) NCH,
     *      CATBLK(KINAX+JLOCF)
         IF (BIF.GT.NUMIF) WRITE (MSGTXT,1026) BIF, NUMIF
         IRET = 6
         GO TO 990
         END IF
C
      CALL FNDEXT ('FQ', CATBLK, VER)
      IFQ = 1
      NIF = NUMIF
      CALL CHNDAT ('READ', BUFF, DISK, CNO, VER, CATBLK, LUN, NIF, FOFF,
     *   ISBAND, FINC, BNDCOD, IFQ, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING FREQUENCY TABLE'
         GO TO 990
         END IF

      IF (CATBLK(KINAX+JLOCF).LE.1) NCH = 1
      FREQ = FREQ + FOFF(BIF) + (NCH-CATR(KRCRP+JLOCF)) * FINC(BIF)
C                                       Open output device
      IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
      CALL LPOPEN (LPNAME, DOCRT, LUNP, FINDP, NACROS, BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1040) IRET
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Determine no. channels to do
C                                       and output type
      NUMCHM = CATBLK(KINAX+JLOCF) - NCH + 1
      NCORP = NCOR
      IF (DOAMPH) THEN
         NUMCH = (NACROS - 55) / (19 * NCOR)
      ELSE
         NUMCH = (NACROS - 55) / (23 * NCOR)
         END IF
      IF (NUMCH.GE.1) THEN
         OTYPE = 1
         NUMCH = MIN (NUMCH, NUMCHM)
         IF (DOAMPH) THEN
            IF (19*NCOR*NUMCH+55.LT.NACROS-3) OTYPE = 2
         ELSE
            IF (23*NCOR*NUMCH+55.LT.NACROS-3) OTYPE = 2
            END IF
      ELSE
         IF (DOAMPH) THEN
            NUMCH = (NACROS - 41) / (15 * NCOR)
         ELSE
            NUMCH = (NACROS - 41) / (19 * NCOR)
            END IF
         IF (NUMCH.GE.1) THEN
            OTYPE = 3
         ELSE
            IF (DOAMPH) THEN
               NUMCH = (NACROS - 24) / (14 * NCOR)
            ELSE
               NUMCH = (NACROS - 24) / (17 * NCOR)
               END IF
            IF (NUMCH.GE.1) THEN
               OTYPE = 4
            ELSE
 20            IF (DOAMPH) THEN
                  NUMCH = (NACROS - 14) / (14 * NCORP)
               ELSE
                  NUMCH = (NACROS - 14) / (17 * NCORP)
                  END IF
               IF (NUMCH.LE.0) THEN
                  NCORP = NCORP - 1
                  GO TO 20
                  END IF
               OTYPE = 5
               END IF
            END IF
         END IF
      NUMCH = MIN (NUMCH, NUMCHM)
C                                       Convert coordinates.
      IF (NSOUWD.GT.1) THEN
         SOURCE = 'Several '
         RA = 0.0D0
         DEC = 0.0D0
         END IF
      IF ((NSOUWD.EQ.1) .AND. (MULTI) .AND. (DOSWNT)) THEN
         CALL GETSOU (SOUWAN(1), DISK, CNO, CATBLK, SULUN, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1990) IRET, SOUWAN(1)
            GO TO 990
            END IF
         SOURCE = SNAME
         RA = RAEPO * RAD2DG
         DEC = DECEPO * RAD2DG
         END IF
C                                       use start time
      CALL FNDEXT ('NX', CATBLK, I)
      IF ((I.GT.0) .AND. ((BTIME.GT.0.0) .OR. (SAUCE(1).NE.' ')))
     *   CALL FINDVO (1000, DISK, CNO, CATBLK, ISUB, 0, NSOUWD, SOUWAN,
     *   BTIME, ETIME, NVORNG, VORNG)
C                                       RA, Dec for labels
      CALL H2CHR (4, 1, CATH(KHCTP+JLOCR*2), LLCH)
      CALL H2CHR (4, 1, CATH(KHCTP+JLOCD*2), MMCH)
      IF (LLCH(:2).EQ.'RA') THEN
         CALL COORDD (1, RA, CHSIG1, HM, RSEC)
      ELSE
         CALL COORDD (2, RA, CHSIG1, HM, RSEC)
         END IF
      CALL COORDD (2, DEC, CHSIG2, DD, DSEC)
      FREQ = FREQ * 1.0E-9
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR:',I7,' ON ',A)
 1010 FORMAT ('ERROR:',I7,' OBTAINING DATA FOR SOURCE #',I5)
 1011 FORMAT ('ERROR:',I7,'READING SOURCE TABLE')
 1015 FORMAT ('Displays limited to baseline',I3.2,' -',I3.2)
 1016 FORMAT ('Displays limited to all baselines to antenna',I3.2)
 1017 FORMAT ('Displays limited to subarray',I3.2)
 1020 FORMAT ('ERROR:',I7,' OPENING UV FILE')
 1021 FORMAT ('BPRINT',I9,' GREATER THAN NVIS',I9)
 1025 FORMAT ('CHANNEL',I5,' > MAX =',I5)
 1026 FORMAT ('IF',I5,' > MAX =',I5)
 1040 FORMAT ('ERROR',I5,' OPENING OUTPUT DEVICE')
 1990 FORMAT ('ERROR:',I7,' OBTAINING DATA FOR SOURCE #',I5)
      END
      SUBROUTINE SOULIS (SOURCS, IUDISK, IUCNO, IXLUN, MAXSOU, NSOUWD,
     *   DOSWNT, SOUWAN, IERR)
C-----------------------------------------------------------------------
C   Fills in array of source numbers to be included or excluded.
C   Inputs:
C      SOURCS(30)   C*16 Names of up to 30 sources, *=>all
C                        First character of name '-' => all except those
C                        specified.
C      IUDISK       I    Disk no on which data resides
C      IUCNO        I    Catalogue number
C      IXLUN        I    LUN to use for SU table access
C      MAXSOU       I    Maximum number of sources.
C   Output:
C      NSOUWD       I    Number of sources included or excluded; if
C                        0 all sources are included.
C      DOSWNT       L    If .TRUE. then sources in SOUWAN are included
C                        If .FALSE. then excluded.
C      SOUWAN(*)    I    The source numbers of sources included or
C                        excluded.
C      IERR         I    Return code, 0=>OK, otherwise source file
C                        exists but cannot be read.
C                        1=TABIO problem, 2=no sources or calibrators
C-----------------------------------------------------------------------
      CHARACTER  SOURCS(30)*16, SELCOD*4
      INTEGER    IUDISK, IUCNO, IXLUN, MAXSOU, NSOUWD, SOUWAN(*), IERR
      LOGICAL    DOSWNT
C
      CHARACTER  VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4, TMPNAM*16
      INTEGER    JERR, IBUFF(1024), IDSOU, QUAL, INOGRP, J,
     *   K, NSOU, SELQUA, UBUFF(1024)
      LOGICAL   T, F, EQUAL, TABLE, EXIST, FITASC, ALLSOU,
     *   DESLT, DOCALC, DOQUAL, ANYCC, NOCAL, DOAPPL
      INTEGER   NSOURC, I, ISURNO, BADCNT, SUFQID
      DOUBLE PRECISION    BANDW, RAEPO, DECEPO, EPOCH, RAAPP, DECAPP,
     *   PMRA, PMDEC, RAOBS, DECOBS
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   SUKOLS(MAXSUC), SUNUMV(MAXSUC)
      REAL      FLUX(4,MAXIF)
      DOUBLE PRECISION    LSRVEL(MAXIF), FREQO(MAXIF), RESTFQ(MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Defaults for now
      SELQUA = -1
      SELCOD = '*   '
C                                       Setup for CALCODE and qualifier
C                                       selection.
      DOQUAL = SELQUA.NE.-1
      ANYCC = SELCOD.EQ.'*   '
      DOCALC = (SELCOD.NE.' ') .AND. (SELCOD.NE.'* ') .AND.
     *   (SELCOD.NE.'-CAL')
      NOCAL = SELCOD.EQ.'-CAL'
C                                       See if SU file exists.
      CALL ISTAB ('SU', IUDISK, IUCNO, 1, IXLUN, IBUFF, TABLE, EXIST,
     *   FITASC, JERR)
      IF ((JERR.NE.0) .OR. (.NOT.TABLE) .OR. (.NOT.EXIST)) GO TO 800
C                                       Open SU table
      CALL SOUINI ('READ', IBUFF, IUDISK, IUCNO, 1, CATBLK, IXLUN,
     *   INOGRP, VELTYP, VELDEF, SUFQID, ISURNO, SUKOLS, SUNUMV,
     *   JERR)
      IF (JERR.LE.0) GO TO 20
         WRITE (MSGTXT,1000) JERR
         GO TO 990
C                                       Get number of sources.
 20   NSOURC = IBUFF(5)
C                                       Check if empty
      IF (NSOURC.LE.0) GO TO 800
      DOSWNT = T
      NSOUWD = 0
      ALLSOU = F
      NSOU = 0
C                                       Check if source excluded
C                                       or if all are included
      DO 30 J = 1,30
C                                       Sources
         ALLSOU = ALLSOU .OR. (SOURCS(J)(1:1).EQ.'*')
         DESLT = SOURCS(J)(1:1).EQ.'-'
         IF (DESLT) DOSWNT = F
C                                       Find number of sources
         EQUAL = SOURCS(J).EQ.'                '
         IF (.NOT.EQUAL) NSOU = J
C                                       Remove any minus sign
         IF (DESLT) THEN
            TMPNAM = SOURCS(J)(2:16)
            SOURCS(J) = TMPNAM
            END IF
 30      CONTINUE
C                                       Make sure need to look at table
      ALLSOU = ALLSOU .OR. (NSOU.LE.0)
      IF ((ALLSOU) .AND.
     *   (.NOT.(DOCALC.OR.ANYCC.OR.NOCAL.OR.DOQUAL))) GO TO 900
      IF (NSOU.LE.1) NSOU = 1
      BADCNT = 0
C                                       Sources
      DOAPPL = F
       IF (ALLSOU .AND.
     *   ((.NOT.((.NOT.DOAPPL).AND.(DOCALC.OR.ANYCC.OR.NOCAL)))
     *   .AND. (.NOT.DOQUAL))) GO TO 900
       IF (NSOU.LE.1) NSOU = 1
C                                       Loop through records
      DO 100 I = 1,NSOURC
         IERR = 1
C                                       Read record
         CALL TABSOU ('READ', IBUFF, ISURNO, SUKOLS, SUNUMV, IDSOU,
     *      SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA,
     *      PMDEC, JERR)
C                                       Check error
         IF (JERR.GT.0) THEN
            WRITE (MSGTXT,1020) JERR
            GO TO 990
            END IF
         IERR = 0
C                                       Search lists
         DO 80 J = 1,NSOU
            IF (.NOT.ALLSOU) THEN
C                                       Source list
               IF (SOURCS(J).NE.SOUNAM) GO TO 80
               END IF
C                                       Check qualifier
            IF (DOQUAL .AND. (QUAL.NE.SELQUA)) GO TO 80
C                                       Redundancy check
            IF (NSOUWD.GE.1) THEN
               DO 40 K = 1,NSOUWD
                  IF (SOUWAN(K).EQ.IDSOU) GO TO 80
 40               CONTINUE
               END IF
C                                       Add source
            IF (NSOUWD.LT.MAXSOU) THEN
               NSOUWD = NSOUWD + 1
               SOUWAN(NSOUWD) = IDSOU
C                                       Overflowed array
            ELSE
               BADCNT = BADCNT + 1
               END IF
 80         CONTINUE
 100     CONTINUE
      IF (BADCNT.GT.0) THEN
         WRITE (MSGTXT,1100) BADCNT, MAXSOU
         CALL MSGWRT (6)
         END IF
C                                       No sources found
      IF (NSOUWD.LE.0) THEN
         IERR = 2
         WRITE (MSGTXT,1101)
         GO TO 990
         END IF
      GO TO 900
C                                       No SOURCE file
 800  NSOUWD = 0
C                                       Close file
 900  IF (JERR.LE.0) CALL TABIO ('CLOS', 0, I, UBUFF, IBUFF, JERR)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SOULIS: ERROR',I3,' OPENING SOURCE TABLE')
 1020 FORMAT ('SOULIS: ERROR',I3,' READING SOURCE TABLE')
 1100 FORMAT ('SOULIS: ',I5,' MORE SOURCES SELECTED THAN ',I6,
     *   ' ALLOWED')
 1101 FORMAT ('SOULIS: ALL SOURCES REJECTED BY SELECTION CRITERIA')
      END
      SUBROUTINE PRTUSC (IRET)
C-----------------------------------------------------------------------
C   Determines ranges of u,v,w, amplitudes, weights
C   Output:
C      IRET     I      Return code, 1=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   LIMIT2, ICH1, ICH2, KK, IROUND, INDEX, J, K, KKK, I,
     *   IPOINT, NMCOR, ILOCWT, ISKIP, JLAST, IA1, IA2, BO, XCOUNT,
     *   PCOUNT, LVIS, NIO, NNCH, SOUID, LENBU, OLDSOU, BIND, KNCS,
     *   KNCF, KNCIF, ISU, IVORNG
      LOGICAL   ISCMP, WANTED, ISCROS(4)
      REAL      AMP(6), R, UVN, WEIGHT, YAMP, U, V, W, XX, YY, XDAY,
     *   TEMP
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PRTUV.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
      IRET = 5
C                                       init the range parameters
      XAMP = 0.0
      UVM = 0.0
      XWT = 0.0
      NWT = 1.E10
      MSGTXT = 'Finding the scaling parameters to set formats'
      CALL MSGWRT (1)
C                                       Set pointers, counters
      LIMIT2 = NCORP * NUMCH
      ICH1 = NCH
      ICH2 = NCH + NUMCH - 1
      NNCH = NCH - 1
      DO 10 J = 1,NCOR
         TEMP = CATD(KDCRV+JLOCS) + (J - CATR(KRCRP+JLOCS)) *
     *      CATR(KRCIC+JLOCS)
         I = IROUND(TEMP)
         IF (I.LE.-5) I = I + 4
         ISCROS(J) = (I.EQ.-3) .OR. (I.EQ.-4)
 10      CONTINUE
C                                       "WEIGHT" pointer for compressed
C                                       data.
      ISCMP = CATBLK(KINAX).EQ.1
      IF (ISCMP) THEN
         KNCS = INCS * 3
         KNCF = INCF * 3
         KNCIF = INCIF * 3
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            GO TO 990
            END IF
      ELSE
         KNCS = INCS
         KNCF = INCF
         KNCIF = INCIF
         ILOCWT = 0
         END IF
      OLDSOU = -1
      BUFSZ = UVBFSS * 2
      IVORNG = 0
C                                       Initialize reading VIS. file.
 60   IVORNG = IVORNG + 1
      VO = VORNG(1,IVORNG) - 1
      LENBU = 0
      BO = 1
      LVIS = VORNG(2,IVORNG) - VO
      CALL UVINIT ('READ', LUN, FIND, LVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFF, BO, BIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1090) IRET
         CALL MSGWRT (8)
         GO TO 960
         END IF
      XCOUNT = VO
      XCOUNT = XCOUNT - INC + 1
      PCOUNT = 0
      ISKIP = 1
      SOUID = 1
      NMCOR = (LREC - NRPARM) / CATBLK(KINAX)
C                                       Start looping thru data.
 100  CONTINUE
C                                       Read buffer.
         CALL UVDISK ('READ', LUN, FIND, BUFF, NIO, BIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            CALL MSGWRT (8)
            GO TO 960
            END IF
         IPOINT = BIND + (ISKIP-1) * LREC
         IF (NIO.LE.0) THEN
            IF (IVORNG.GE.NVORNG) GO TO 960
            GO TO 60
            END IF
C                                       Loop thru buffer.
         IF (ISKIP.GT.NIO) GO TO 170
            DO 160 J = ISKIP,NIO,INC
C                                       Update counters and check
C                                       If finished.
               XCOUNT = XCOUNT + INC
               IF (XCOUNT.GT.VORNG(2,IVORNG)) THEN
                  IF (IVORNG.GE.NVORNG) GO TO 960
                  GO TO 60
                  END IF
C                                       If time, decode it.
               IF (ILOCT.GE.0) THEN
                  XDAY = BUFF(IPOINT+ILOCT)
C                                       If time check requested,
C                                       valid time and time in range
                  IF ((ISORT(:1).EQ.'T') .AND. (XDAY.GT.ETIME))
     *               GO TO 960
                  IF ((XDAY.LT.BTIME) .OR. (XDAY.GT.ETIME)) GO TO 150
               ELSE
                  XDAY = 0.
                  END IF
C                                       Determine antennas.
               IF (ILOCB.GE.0) THEN
                  IA1 = BUFF(IPOINT+ILOCB) / 256. + 0.1
                  IA2 = BUFF(IPOINT+ILOCB) - IA1*256. + 0.1
                  ISU = 100.0 * (BUFF(IPOINT+ILOCB) - IA1*256 - IA2)+1.5
               ELSE
                  IA1 = BUFF(IPOINT+ILOCA1) + 0.1
                  IA2 = BUFF(IPOINT+ILOCA2) + 0.1
                  ISU = BUFF(IPOINT+ILOCSA) + 0.1
                  END IF
               IF ((ISUB.GT.0) .AND. (ISUB.NE.ISU)) GO TO 150
               IF ((ANT1.GT.0) .AND. ((ANT1.NE.IA1) .OR.
     *            (ANT1.NE.IA2))) GO TO 150
               IF ((ANT1.LE.0) .AND. (ANT2.GT.0) .AND. (ANT2.NE.IA1)
     *            .AND. (ANT2.NE.IA2)) GO TO 150
C                                       Check source
               IF (MULTI) SOUID = IROUND (BUFF(IPOINT+ILOCSU))
               CALL SOURS (.FALSE., SOUID, OLDSOU, WANTED, IRET)
               IF (IRET.NE.0) THEN
                  MSGTXT = 'ERROR PROCESSING NEW SOURCE'
                  CALL MSGWRT (8)
                  GO TO 990
                  END IF
               IF (.NOT.WANTED) GO TO 150
C                                       Convert uvw to kilo lamda.
               U = BUFF(IPOINT+ILOCU) * 0.001
               V = BUFF(IPOINT+ILOCV) * 0.001
               W = BUFF(IPOINT+ILOCW) * 0.001
               R = U * U + V * V
               IF ((R.LT.UVRANG(1)) .OR. (R.GT.UVRANG(2))) GO TO 150
               UVM = MAX (UVM, U)
               UVM = MAX (UVM, V)
               UVM = MAX (UVM, W)
               UVN = U
               UVN = MIN (UVN, V)
               UVN = MIN (UVN, W)
               UVM = MAX (UVM, -10.0*UVN)
C                                       Get vis.
C                                       Unpack compressed data
               IF (ISCMP) CALL ZUVXPN (NMCOR, BUFF(IPOINT+NRPARM),
     *            BUFF(IPOINT+ILOCWT), BUFF2)
               K = 0
               YAMP = 0.0
               DO 120 KK = ICH1,ICH2
                  DO 110 KKK = 1,NCOR
                     K = K + 1
C                                       Compressed
                     IF (ISCMP) THEN
                        INDEX = 1 + (KK-1)*KNCF + (KKK-1)*KNCS +
     *                     (BIF-1)*KNCIF
                        XX = BUFF2(INDEX)
                        YY = BUFF2(INDEX+1)
                        WEIGHT = BUFF2(INDEX+2)
C                                       Expanded
                     ELSE
                        INDEX = IPOINT + NRPARM + (KK-1)*KNCF +
     *                     (KKK-1)*KNCS + (BIF-1)*KNCIF
                        XX = BUFF(INDEX)
                        YY = BUFF(INDEX+1)
                        WEIGHT = BUFF(INDEX+2)
                        END IF
                     IF (WEIGHT.NE.0.0) THEN
                        XWT = MAX (XWT, ABS(WEIGHT))
                        NWT = MIN (NWT, ABS(WEIGHT))
                        END IF
                     IF ((IA1.NE.IA2) .OR. (ISCROS(KKK))) THEN
                        AMP(K) = SQRT (XX*XX+YY*YY) * CPARM(10)
                     ELSE
                        AMP(K) = XX * CPARM(10)
                        END IF
                     XAMP = MAX (XAMP, AMP(K))
                     YAMP = MIN (YAMP, AMP(K))
 110                 CONTINUE
 120              CONTINUE
C                                       Write VIS data: CRT
               XAMP = MAX (XAMP, -10.0*YAMP)
               PCOUNT = PCOUNT + 1
               IF (PCOUNT.GE.XNIT) GO TO 960
C                                       Update IPOINT
 150           IPOINT = IPOINT + LREC * MIN (LENBU, INC)
               JLAST = J
 160           CONTINUE
 170     ISKIP = ISKIP - NIO
         IF (ISKIP+NIO.LE.NIO) ISKIP = INC - (NIO-JLAST)
         GO TO 100
C                                       Close files.
 960  IF (IRET.LE.0) IRET = 0
C
      GO TO 999
C                                        Write end message
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1090 FORMAT ('ERROR:',I7,' INITIALIZING UV FILE')
 1100 FORMAT ('ERROR:',I7,' READING VIS ')
      END
      SUBROUTINE PRTUCH (IRET)
C-----------------------------------------------------------------------
C   Counts lines of print
C   Output:
C      IRET     I      Return code, 1=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   LIMIT2, ICH1, ICH2, IROUND, I, J, IPOINT, NMCOR, ISKIP,
     *   JLAST, IA1, IA2, BO, XCOUNT, PCOUNT, LVIS, NIO, NNCH, SOUID,
     *   LENBU, OLDSOU, BIND, JTRIM, ISU, IFQ, NCOUNT, TTY(2), IERR,
     *   IVORNG
      CHARACTER STR*4
      LOGICAL   F, WANTED
      REAL      R, U, V, W
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PRTUV.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      IRET = 0
      IF ((DOCRT.GT.0.0) .OR. (LPNAME.NE.' ')) GO TO 999
      MSGTXT = 'Checking count of lines for direct output to printer'
      CALL MSGWRT (2)
      IF (.NOT.SCAL) THEN
         XAMP = MAXA
         XWT = MAXW
         NWT = MINW
         UVM = MAXUVW
         END IF
      IRET = 5
C                                       Set pointers, counters
      LIMIT2 = NCORP * NUMCH
      ICH1 = NCH
      ICH2 = NCH + NUMCH - 1
      NNCH = NCH - 1
C                                       first page
      NCOUNT = 0
      J = JTRIM (ISORT)
      PAGE = 0
      IPCNT = 998
      TITL1 = ' '
      TITL2 = ' '
      IF (DOCRT.GT.-2.5) THEN
         IF (((OTYPE.GE.1) .AND. (OTYPE.LE.3)) .AND. ((BIF.GT.1) .OR.
     *      (NCH.GT.1))) THEN
            NCOUNT = NCOUNT + 1
            END IF
         NCOUNT = NCOUNT + 1
         NCOUNT = NCOUNT + 4
         END IF
      IVORNG = 0
      BO = 1
      BUFSZ = UVBFSS  * 2
      PCOUNT = 0
      PAGE = 1
      SOUID = 1
      NMCOR = (LREC - NRPARM) / CATBLK(KINAX)
      IFQ = 0
C                                       Initialize reading VIS. file.
 60   IVORNG = IVORNG + 1
      VO = VORNG(1,IVORNG) - 1
      LENBU = 0
      LVIS = VORNG(2,IVORNG) - VO
      OLDSOU = -1
      CALL UVINIT ('READ', LUN, FIND, LVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFF, BO, BIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1090) IRET
         CALL MSGWRT (8)
         GO TO 960
         END IF
      XCOUNT = VO
      XCOUNT = XCOUNT - INC + 1
      ISKIP = 1
C                                       Start looping thru data.
 100  CONTINUE
C                                       Read buffer.
         CALL UVDISK ('READ', LUN, FIND, BUFF, NIO, BIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            CALL MSGWRT (8)
            GO TO 960
            END IF
         IPOINT = BIND + (ISKIP-1) * LREC
         IF (NIO.LE.0) THEN
            IF (IVORNG.GE.NVORNG) GO TO 900
            GO TO 60
            END IF
C                                       Loop thru buffer.
         IF (ISKIP.GT.NIO) GO TO 170
            DO 160 J = ISKIP,NIO,INC
C                                       Update counters and check
C                                       If finished.
               XCOUNT = XCOUNT + INC
               IF (XCOUNT.GT.VORNG(2,IVORNG)) THEN
                  IF (IVORNG.GE.NVORNG) GO TO 900
                  GO TO 60
                  END IF
C                                       Determine antennas.
               IF (ILOCB.GE.0) THEN
                  IA1 = BUFF(IPOINT+ILOCB) / 256. + 0.1
                  IA2 = BUFF(IPOINT+ILOCB) - IA1*256. + 0.1
                  ISU = 100.0 * (BUFF(IPOINT+ILOCB) - IA1*256 - IA2)+1.5
               ELSE
                  IA1 = BUFF(IPOINT+ILOCA1) + 0.1
                  IA2 = BUFF(IPOINT+ILOCA2) + 0.1
                  ISU = BUFF(IPOINT+ILOCSA) + 0.1
                  END IF
               IF ((ISUB.GT.0) .AND. (ISUB.NE.ISU)) GO TO 150
               IF ((ANT1.GT.0) .AND. ((ANT1.NE.IA1) .OR.
     *            (ANT2.NE.IA2))) GO TO 150
               IF ((ANT1.LE.0) .AND. (ANT2.GT.0) .AND. (ANT2.NE.IA1)
     *            .AND. (ANT2.NE.IA2)) GO TO 150
C                                       Check source
               IF (MULTI) SOUID = IROUND (BUFF(IPOINT+ILOCSU))
               CALL SOURS (.TRUE., SOUID, OLDSOU, WANTED, IRET)
               IF (IRET.NE.0) THEN
                  MSGTXT = 'ERROR PROCESSING NEW SOURCE'
                  CALL MSGWRT (8)
                  GO TO 960
                  END IF
               IF (.NOT.WANTED) GO TO 150
               IF (ILOCFQ.GE.0) IFQ = BUFF(IPOINT+ILOCFQ) + 0.1
C                                       Convert uvw to kilo lamda.
               U = BUFF(IPOINT+ILOCU) * 0.001
               V = BUFF(IPOINT+ILOCV) * 0.001
               W = BUFF(IPOINT+ILOCW) * 0.001
               R = U * U + V * V
               IF ((R.LT.UVRANG(1)) .OR. (R.GT.UVRANG(2))) GO TO 150
C                                       Write VIS data
               NCOUNT = NCOUNT + 1
               PCOUNT = PCOUNT + 1
               IF (PCOUNT.GE.XNIT) GO TO 900
C                                       Update IPOINT
 150           IPOINT = IPOINT + LREC * MIN (LENBU, INC)
               JLAST = J
 160           CONTINUE
 170     ISKIP = ISKIP - NIO
         IF (ISKIP+NIO.LE.NIO) ISKIP = INC - (NIO-JLAST)
         GO TO 100
C                                       check count
 900  IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) THEN
         IF (NCOUNT.GT.1000) THEN
            IRET = -1
            PCOUNT = -1
            CALL LPCLOS (LUNP, FINDP, PCOUNT, IERR)
            END IF
      ELSE IF (NCOUNT.GT.500) THEN
         IPCNT = 0
         TTY(1) = 5
         CALL ZOPEN (TTY(1), TTY(2), 1, SCRTCH, .FALSE., .FALSE.,
     *      .TRUE., IRET)
         MSGTXT = 'PROBLEM OPENING TERMINAL'
         IF (IRET.GT.0) GO TO 950
         WRITE (SCRTCH,1900) NCOUNT
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, IRET)
         MSGTXT = 'PROBLEM DOING IO TO TERMINAL'
         IF (IRET.GT.0) GO TO 950
         SCRTCH = 'Do you really want to print this much??' //
     *      ' Enter Y or y if so'
         CALL INQSTR (TTY, SCRTCH, 1, STR, IRET)
         IF (IRET.GT.0) GO TO 950
         IF ((STR(:1).NE.'y') .AND. (STR(:1).NE.'Y')) THEN
            PCOUNT = -1
            CALL LPCLOS (LUNP, FINDP, PCOUNT, IERR)
            IRET = -1
            SCRTCH = 'Good choice - save trees'
         ELSE
            SCRTCH = 'OKAY, printing anyway'
            END IF
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, I)
         CALL ZCLOSE (TTY(1), TTY(2), I)
         END IF
      GO TO 999
C                                       CRT error
 950  CALL MSGWRT (8)
C                                       Close files.
 960  IF (IRET.GT.0) CALL LPCLOS (LUNP, FINDP, IPCNT, I)
      IF (IRET.LE.0) IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1090 FORMAT ('ERROR:',I7,' INITIALIZING UV FILE')
 1100 FORMAT ('ERROR:',I7,' READING VIS ')
 1900 FORMAT ('Requested print job is',I10,' lines long!')
      END
      SUBROUTINE PRTUDO (IRET)
C-----------------------------------------------------------------------
C   Prints selected portions of uv data file.
C   Output:
C      IRET     I      Return code, 1=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER  MAXRP
      PARAMETER (MAXRP = 15)
      CHARACTER RLIST(18)*8, REXIST(15)*8, R4CHAR(15)*8, OUTRAN(15)*8
      INTEGER   PRMTRN(MAXRP), NPRM, ANOTA(15), LOCLIS(15),
     *   LOCSEL(15), NPASEL, KINT, KREAL, RANINT(15), NLOC, ILOCSC,
     *   ILFIND, IERR, IVORNG
      REAL   RANREA(15)
      INTEGER   LIMIT2, ICH1, ICH2, II, JJ, KK, IROUND, INDEX, I, J, L,
     *   K, KKK, IPOINT, NMCOR, ILOCWT, ISKIP, JLAST, ICH(6), IA1, IA2,
     *   BO, XCOUNT, PCOUNT, LVIS, PHASE(6), IWT(6), NIO, NNCH, SOUID,
     *   LENBU, OLDSOU, ITT(4), JCOR, BIND, KNCS, KNCF, KNCIF, JTRIM,
     *   WTFM, ISU, IFQ, IU, IV, IW, JTT(3), NC, KRNC, KINC
      CHARACTER ISTOKE(6)*2, JSTOKE(4,3)*2, LLCH*4, MMCH*4, TCHAR*24,
     *   WCHAR*2
      LOGICAL   F, ISCMP, WANTED, ISCROS(4)
      REAL      AMP(6), R, WEIGHT, TEMP, TPHS, U, V, W, XX, YY, RWT(6),
     *   XDAY, WTSC, RTT
C
      REAL      RE(6), IM(6)
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PRTUV.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA F /.FALSE./
      DATA JSTOKE /'VV','HH','VH','HV','RR','LL','RL','LR',
     *   'I ','Q ','U ','V '/
      DATA RLIST /'UU-L    ','VV-L    ','WW-L    ','TIME1   ',
     *   'BASELINE','SOURCE  ','FREQSEL ','INTTIM  ',
     *   'GATEID  ','CORR-ID ','FILTER  ','DATE    ',
     *   'WEIGHT  ','SCALE   ','REMOVED', 'SUBARRAY', 'AMTENNA1',
     *   'ANTENNA2'/
C-----------------------------------------------------------------------
C                                       LOCLIS for the undetermined
C                                       ILOCs are put zero
      LOCLIS(1) = ILOCU
      LOCLIS(2) = ILOCV
      LOCLIS(3) = ILOCW
      LOCLIS(4) = ILOCT
      LOCLIS(5) = ILOCB
      LOCLIS(6) = ILOCSU
      LOCLIS(7) = ILOCFQ
      LOCLIS(8) = ILOCIT
      LOCLIS(9) = 100
      LOCLIS(10) = ILOCID
      LOCLIS(11) = 100
      LOCLIS(12) = 100
      LOCLIS(13) = 100
      LOCLIS(14) = 100
      LOCLIS(15) = 100
      IF (.NOT.SCAL) THEN
         XAMP = MAXA
         XWT = MAXW
         NWT = MINW
         UVM = MAXUVW
         END IF
      IRET = 5
C                                       Set pointers, counters
      LIMIT2 = NCORP * NUMCH
      ICH1 = NCH
      ICH2 = NCH + NUMCH - 1
      NNCH = NCH - 1
C                                       "WEIGHT" pointer for compressed
C                                       data.
      ISCMP = CATBLK(KINAX).EQ.1
      IF (ISCMP) THEN
         KNCS = INCS * 3
         KNCF = INCF * 3
         KNCIF = INCIF * 3
         CALL AXEFND (8, 'SCALE   ', CATBLK(KIPCN), CATH(KHPTP), ILOCSC,
     *      IERR)
         IF (IERR .EQ. 0) LOCLIS(14) = ILOCSC
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      IRET)
         IF (IRET .EQ. 0) LOCLIS(13) = ILOCWT
         IF (IRET.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            GO TO 990
            END IF
      ELSE
         KNCS = INCS
         KNCF = INCF
         KNCIF = INCIF
         ILOCWT = 0
         END IF
C                                       Stokes labels
      DO 15 II = 1,4,NCOR
         NNCH = NNCH + 1
         DO 10 JJ = 1,NCOR
            INDEX = II + JJ - 1
            IF (INDEX.GT.6) GO TO 16
            ICH(INDEX) = NNCH
            TEMP = CATD(KDCRV+JLOCS) + (JJ - CATR(KRCRP+JLOCS)) *
     *         CATR(KRCIC+JLOCS)
            I = IROUND(TEMP)
            IF (I.LE.-5) THEN
               L = 1
               I = I + 4
            ELSE IF (I.LT.0) THEN
               L = 2
            ELSE
               L = 3
               END IF
            ISCROS(JJ) = (I.EQ.-3) .OR. (I.EQ.-4)
            I = ABS(I)
            ISTOKE(INDEX) = JSTOKE(I,L)
 10         CONTINUE
 15      CONTINUE
C                                       RA-Dec labels
 16   CALL H2CHR (4, 1, CATH(KHCTP+JLOCR*2), LLCH)
      CALL H2CHR (4, 1, CATH(KHCTP+JLOCD*2), MMCH)
      WCHAR = 'Wt'
      IF (DOEBAR.GT.0.0) WCHAR = 'Si'
      IF (DOAMPH) THEN
         IF ((OTYPE.EQ.1) .OR. (OTYPE.EQ.2)) THEN
            TCHAR = '    Amp Phas'
            IF (XAMP.LE.99.9) TCHAR = '   Amp  Phas'
            TCHAR(18-WTFM:) = WCHAR
         ELSE IF (OTYPE.EQ.3) THEN
            TCHAR = '    Amp Phas ' // WCHAR
            IF (XAMP.LE.99.9) TCHAR = '   Amp  Phas ' // WCHAR
         ELSE
            TCHAR = '   Amp Phas ' // WCHAR
            IF (XAMP.LE.99.9) TCHAR = '  Amp  Phas ' // WCHAR
            END IF
      ELSE
         IF ((OTYPE.EQ.1) .OR. (OTYPE.EQ.2)) THEN
            TCHAR = '     Re      Im'
            IF (XAMP.LE.99.9) TCHAR = '   Re      Im'
            TCHAR(22-WTFM:) = WCHAR
         ELSE IF (OTYPE.EQ.3) THEN
            TCHAR = '     Re      Im  ' // WCHAR
            IF (XAMP.LE.99.9) TCHAR = '   Re      Im    ' // WCHAR
         ELSE
            TCHAR = '    Re     Im  ' // WCHAR
            IF (XAMP.LE.99.9) TCHAR = '  Re     Im    ' // WCHAR
            END IF
         END IF
      IF (XWT.LE.0.0) THEN
         XWT = 1.0
         NWT = 1.0
         END IF
      IF (DOEBAR.GT.0) THEN
         TEMP = 1.0 / SQRT (XWT)
         XWT = 1.0 / SQRT (NWT)
         NWT = TEMP
         END IF
C                                       weight scaling
      TEMP = LOG10 (XWT/0.995)
      I = TEMP + 99.0
      I =  100 - I
      WTSC = 10.0 ** I
      IF (OTYPE.LT.3) THEN
         TEMP = XWT / NWT
         IF (TEMP.GT.100000.0) THEN
            MSGTXT = 'Full dynamic range of weights cannot be printed'
            CALL MSGWRT (6)
            END IF
         WTFM = 3
         IF ((XWT.LT.9.99995) .AND. (NWT.GE.0.0001)) THEN
            WTSC = 1.0
            WTFM = 4
            IF (XWT.LT.0.09995) WTSC = 10.0
         ELSE IF ((XWT.LT.99.9995) .AND. (NWT.GE.0.001)) THEN
            WTSC = 1.0
            WTFM = 3
         ELSE IF ((XWT.LT.999.995) .AND. (NWT.GE.0.01)) THEN
            WTSC = 1.0
            WTFM = 2
         ELSE IF ((XWT.LT.9999.95) .AND. (NWT.GE.0.1)) THEN
            WTSC = 1.0
            WTFM = 1
            END IF
      ELSE
         TEMP = XWT / NWT
         IF (TEMP.GT.99.50) THEN
            MSGTXT = 'Full dynamic range of weights cannot be printed'
            CALL MSGWRT (6)
            END IF
         END IF
C                                       Write header
C                                       first page
      J = JTRIM (ISORT)
      PAGE = 0
      IPCNT = 998
      TITL1 = ' '
      TITL2 = ' '
      IF (DOCRT.GT.-2.5) THEN
         IF (NACROS.GE.90) THEN
            WRITE (LINE,1050) NAME, CLASS, SEQ, DISK, USERID, ICH1, ICH2
         ELSE
            WRITE (LINE,1051) NAME, CLASS, SEQ, DISK, USERID, ICH1, ICH2
            END IF
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 950
         WRITE (LINE,1055) SOURCE, LLCH, CHSIG1, HM, RSEC, MMCH, CHSIG2,
     *      DD, DSEC, BIF
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 950
         WRITE (LINE,1056) FREQ, NCOR, NVIS, ISORT
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 950
         IF (((OTYPE.GE.1) .AND. (OTYPE.LE.3)) .AND. ((BIF.GT.1) .OR.
     *      (NCH.GT.1))) THEN
            LINE = 'NOTE: U,V and W are in wavelengths at the reference'
     *         // ' frequency'
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 950
            END IF
         IF (WTSC.NE.1.0) THEN
            WRITE (LINE,1057) WTSC
            IF (DOEBAR.GT.0.0) LINE(:7) = 'Sigmas '
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 950
            END IF
         LINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 950
         END IF
C                                       Page titles
      IF (.NOT.DORAND) THEN
         IF (DOAMPH) THEN
            IF (OTYPE.EQ.1) THEN
               WRITE (TITL1,1060) SOURCE, FREQ, ISORT, (ICH(JCOR),
     *            ISTOKE(JCOR), JCOR = 1,LIMIT2)
               WRITE (TITL2,1070) (TCHAR(:19), JCOR = 1,LIMIT2)
            ELSE IF (OTYPE.EQ.2) THEN
               WRITE (TITL1,1061) SOURCE, FREQ, ISORT, (ICH(JCOR),
     *            ISTOKE(JCOR), JCOR = 1,LIMIT2)
               WRITE (TITL2,1071) (TCHAR(:19), JCOR = 1,LIMIT2)
            ELSE IF (OTYPE.EQ.3) THEN
               WRITE (TITL1,1062) SOURCE, FREQ, ISORT, (ICH(JCOR),
     *            ISTOKE(JCOR), JCOR = 1,LIMIT2)
               WRITE (TITL2,1072) (TCHAR(:15), JCOR = 1,LIMIT2)
            ELSE IF (OTYPE.EQ.4) THEN
               WRITE (TITL1,1063) SOURCE, FREQ, ISORT, (ICH(JCOR),
     *            ISTOKE(JCOR), JCOR = 1,LIMIT2)
               WRITE (TITL2,1073) (TCHAR(:14), JCOR = 1,LIMIT2)
            ELSE IF (OTYPE.EQ.5) THEN
               WRITE (TITL1,1064) SOURCE, ISORT, (ICH(JCOR),
     *            ISTOKE(JCOR), JCOR = 1,LIMIT2)
               WRITE (TITL2,1074) (TCHAR(:14), JCOR = 1,LIMIT2)
               END IF
         ELSE
            IF (OTYPE.EQ.1) THEN
               WRITE (TITL1,3060) SOURCE, FREQ, ISORT, (ICH(JCOR),
     *            ISTOKE(JCOR), JCOR = 1,LIMIT2)
               WRITE (TITL2,1070) (TCHAR(:23), JCOR = 1,LIMIT2)
            ELSE IF (OTYPE.EQ.2) THEN
               WRITE (TITL1,3061) SOURCE, FREQ, ISORT, (ICH(JCOR),
     *            ISTOKE(JCOR), JCOR = 1,LIMIT2)
               WRITE (TITL2,1071) (TCHAR(:23), JCOR = 1,LIMIT2)
            ELSE IF (OTYPE.EQ.3) THEN
               WRITE (TITL1,3062) SOURCE, FREQ, ISORT, (ICH(JCOR),
     *            ISTOKE(JCOR), JCOR = 1,LIMIT2)
               WRITE (TITL2,1072) (TCHAR(:19), JCOR = 1,LIMIT2)
            ELSE IF (OTYPE.EQ.4) THEN
               WRITE (TITL1,3063) SOURCE, FREQ, ISORT, (ICH(JCOR),
     *            ISTOKE(JCOR), JCOR = 1,LIMIT2)
               WRITE (TITL2,1073) (TCHAR(:17), JCOR = 1,LIMIT2)
            ELSE IF (OTYPE.EQ.5) THEN
               WRITE (TITL1,3064) SOURCE, ISORT, (ICH(JCOR),
     *            ISTOKE(JCOR), JCOR = 1,LIMIT2)
               WRITE (TITL2,1074) (TCHAR(:17), JCOR = 1,LIMIT2)
               END IF
            END IF
C                                       title of the random parameters
      ELSE
C                                       list of the random parameters
         CALL LISRAN (OUTRAN, ANOTA)
C                                       remove REMOVEDs
         CALL PRMSET (CATBLK, PRMTRN)
         NPRM = CATBLK(KIPCN)
C                                       restructure RPARM
C                                       form the real  group
         KREAL = 0
         DO 25 K = 1,NPRM
            REXIST(K) = OUTRAN(PRMTRN(K))
            IF (ANOTA(PRMTRN(K)).EQ.1) THEN
               KREAL = KREAL + 1
               NLOC = 0
               DO 20 J = 1,18
                  NC = 8
                  IF (K.LE.3) NC = 4
                  IF (REXIST(K)(:NC).EQ.RLIST(J)(:NC)) NLOC = J
 20               CONTINUE
               IF (NLOC.EQ.0) THEN
                  LOCSEL(KREAL) = 100
               ELSE IF (LOCLIS(NLOC).EQ.100) THEN
                  CALL AXEFND (8, REXIST(K), CATBLK(KIPCN), CATH(KHPTP),
     *               ILFIND, IERR)
                  IF (IERR.EQ.0) LOCSEL(KREAL) = ILFIND
                  IF (IERR.NE.0) LOCSEL(KREAL) = 100
               ELSE
                  LOCSEL(KREAL) = LOCLIS(NLOC)
                  END IF
               R4CHAR(KREAL) = REXIST(K)
               IF (LOCSEL(KREAL).EQ.100) KREAL = KREAL -1
               END IF
 25         CONTINUE
C                                       form the integer group
         KK = KREAL
         DO 35 K = 1,NPRM
            REXIST(K) = OUTRAN(PRMTRN(K))
            IF (ANOTA(PRMTRN(K)).EQ.0) THEN
               KK = KK + 1
               NLOC = 0
               DO 30 J = 1,15
                  IF (REXIST(K).EQ.RLIST(J)) NLOC = J
 30               CONTINUE
               IF (NLOC.EQ.0) THEN
                  LOCSEL(KK) = 100
               ELSE IF (LOCLIS(NLOC).EQ.100) THEN
                  CALL AXEFND (8, REXIST(K), CATBLK(KIPCN), CATH(KHPTP),
     *               ILFIND, IERR)
                  IF (IERR.EQ.0) LOCSEL(KK) = ILFIND
                  IF (IERR.NE.0) LOCSEL(KK) = 100
               ELSE
                  LOCSEL(KK) = LOCLIS(NLOC)
                  END IF
               R4CHAR(KK) = REXIST(K)
               IF (LOCSEL(KK).EQ.100) KK = KK - 1
               END IF
 35         CONTINUE
C                                       titles
         NPASEL = KK
         KINT = KK - KREAL
         KRNC = 10
         KINC = 5
 40      KK = (NACROS - 36 - KRNC*KREAL - KINC*KINT)
         IF (KK.GT.2*KREAL+KINT) THEN
            KRNC = KRNC + 2
            KINC = KINC + 1
            GO TO 40
         ELSE IF (KK.GT.NPASEL) THEN
            KRNC = KRNC + 1
            KINC = KINC + 1
            GO TO 40
         ELSE IF (KK.GT.KREAL) THEN
            KRNC = KRNC + 1
            END IF
         KRNC = MIN (15, KRNC)
         KINC = MIN (10, KINC)
         TITL1 = ' '
         WRITE (TITL2,2070)
         KK = 36
         DO 45 K = 1,KREAL
            KK = KK + KRNC - 8
            TITL2(KK:) = R4CHAR(K)
            KK = KK + 8
 45         CONTINUE
         J = MIN (8, KINC-1)
         DO 50 K = KREAL+1,NPASEL
            KK = KK + KINC
            TITL2(KK-J:) = R4CHAR(K)(:J)
 50         CONTINUE
         END IF
      IVORNG = 0
      BO = 1
      BUFSZ = UVBFSS  * 2
      PCOUNT = 0
      PAGE = 1
      SOUID = 1
      NMCOR = (LREC - NRPARM) / CATBLK(KINAX)
      IFQ = 0
C                                       Initialize reading VIS. file.
 60   IVORNG = IVORNG + 1
      VO = VORNG(1,IVORNG) - 1
      LENBU = 0
      LVIS = VORNG(2,IVORNG) - VO
      OLDSOU = -1
      CALL UVINIT ('READ', LUN, FIND, LVIS, VO, LREC, LENBU, BUFSZ,
     *   BUFF, BO, BIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1090) IRET
         CALL MSGWRT (8)
         GO TO 960
         END IF
      XCOUNT = VO
      XCOUNT = XCOUNT - INC + 1
      ISKIP = 1
C                                       Start looping thru data.
 100  CONTINUE
C                                       Read buffer.
         CALL UVDISK ('READ', LUN, FIND, BUFF, NIO, BIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            CALL MSGWRT (8)
            GO TO 960
            END IF
         IPOINT = BIND + (ISKIP-1) * LREC
         IF (NIO.LE.0) THEN
            IF (IVORNG.GE.NVORNG) GO TO 960
            GO TO 60
            END IF
C                                       Loop thru buffer.
         IF (ISKIP.GT.NIO) GO TO 170
            DO 160 J = ISKIP,NIO,INC
C                                       Update counters and check
C                                       If finished.
               XCOUNT = XCOUNT + INC
               IF (XCOUNT.GT.VORNG(2,IVORNG)) THEN
                  IF (IVORNG.GE.NVORNG) GO TO 960
                  GO TO 60
                  END IF
C                                       If time, decode it.
               IF (ILOCT.GE.0) THEN
                  XDAY = BUFF(IPOINT+ILOCT)
C                                       If time check requested,
C                                       valid time and time in range
                  IF ((ISORT(:1).EQ.'T') .AND. (XDAY.GT.ETIME))
     *               GO TO 960
                  IF ((XDAY.LT.BTIME) .OR. (XDAY.GT.ETIME)) GO TO 150
               ELSE
                  XDAY = 0.
                  END IF
               CALL TODHMS (XDAY, ITT)
               IF (DORAND) THEN
                  CALL T2DHMS (XDAY, 3, JTT, RTT)
               ELSE
                  CALL T2DHMS (XDAY, 2, JTT, RTT)
                  END IF
C                                       Determine antennas.
               IF (ILOCB.GE.0) THEN
                  IA1 = BUFF(IPOINT+ILOCB) / 256. + 0.1
                  IA2 = BUFF(IPOINT+ILOCB) - IA1*256. + 0.1
                  ISU = 100.0 * (BUFF(IPOINT+ILOCB) - IA1*256 - IA2)+1.5
               ELSE
                  IA1 = BUFF(IPOINT+ILOCA1) + 0.1
                  IA2 = BUFF(IPOINT+ILOCA2) + 0.1
                  ISU = BUFF(IPOINT+ILOCSA) + 0.1
                  END IF
               IF ((ISUB.GT.0) .AND. (ISUB.NE.ISU)) GO TO 150
               IF ((ANT1.GT.0) .AND. ((ANT1.NE.IA1) .OR.
     *            (ANT2.NE.IA2))) GO TO 150
               IF ((ANT1.LE.0) .AND. (ANT2.GT.0) .AND. (ANT2.NE.IA1)
     *            .AND. (ANT2.NE.IA2)) GO TO 150
C                                       Check source
               IF (MULTI) SOUID = IROUND (BUFF(IPOINT+ILOCSU))
               CALL SOURS (.TRUE., SOUID, OLDSOU, WANTED, IRET)
               IF (IRET.NE.0) THEN
                  MSGTXT = 'ERROR PROCESSING NEW SOURCE'
                  CALL MSGWRT (8)
                  GO TO 990
                  END IF
               IF (.NOT.WANTED) GO TO 150
               IF (ILOCFQ.GE.0) IFQ = BUFF(IPOINT+ILOCFQ) + 0.1
C                                       Convert uvw to kilo lamda.
               U = BUFF(IPOINT+ILOCU) * 0.001
               V = BUFF(IPOINT+ILOCV) * 0.001
               W = BUFF(IPOINT+ILOCW) * 0.001
               R = U * U + V * V
               IF ((R.LT.UVRANG(1)) .OR. (R.GT.UVRANG(2))) GO TO 150
               IU = IROUND (U)
               IV = IROUND (V)
               IW = IROUND (W)
C                                       Get vis.
C                                       Unpack compressed data
               IF (ISCMP) CALL ZUVXPN (NMCOR, BUFF(IPOINT+NRPARM),
     *            BUFF(IPOINT+ILOCWT), BUFF2)
               K = 0
               DO 120 KK = ICH1,ICH2
                  DO 110 KKK = 1,NCOR
                     K = K + 1
C                                       Compressed
                     IF (ISCMP) THEN
                        INDEX = 1 + (KK-1)*KNCF + (KKK-1)*KNCS +
     *                     (BIF-1)*KNCIF
                        XX = BUFF2(INDEX)
                        YY = BUFF2(INDEX+1)
                        WEIGHT = BUFF2(INDEX+2)
C                                       Expanded
                     ELSE
                        INDEX = IPOINT + NRPARM + (KK-1)*KNCF +
     *                     (KKK-1)*KNCS + (BIF-1)*KNCIF
                        XX = BUFF(INDEX)
                        YY = BUFF(INDEX+1)
                        WEIGHT = BUFF(INDEX+2)
                        END IF
                     TPHS = WEIGHT * WTSC
C                                       For the long printout, set
C                                       weight to the 'sigma'.
C                                       For integer printouts, this
C                                       may cause problems so wait.
                     RWT(K) = TPHS
                     IF ((DOEBAR.GT.0) .AND. (WEIGHT.NE.0.0)) THEN
                        RWT(K) = WTSC / SQRT (ABS(WEIGHT))
                        IF (WEIGHT.LT.0.0) RWT(K) = -RWT(K)
                        END IF
                     IWT(K) = IROUND (RWT(K))
                     IF (IWT(K).EQ.0) THEN
                        IF (TPHS.LT.0.0) IWT(K) = -1
                        IF (TPHS.GT.0.0) IWT(K) = 1
                        END IF
                     IF ((IA1.NE.IA2) .OR. (ISCROS(KKK))) THEN
                        AMP(K) = SQRT (XX*XX+YY*YY) * CPARM(10)
                        TPHS = 57.296 * ATAN2 (YY, XX+1.0E-20)
                        PHASE(K) = IROUND (TPHS)
                     ELSE
                        AMP(K) = XX * CPARM(10)
                        PHASE(K) = 0.0
                        END IF
C
                     RE(K) = XX * CPARM(10)
                     IM(K) = YY * CPARM(10)
 110                 CONTINUE
 120              CONTINUE
C                                       print random parameters
               IF (DORAND) THEN
                  DO 125 K = 1,NPASEL
                     IF (K.LE.KREAL) THEN
                        RANREA(K) = BUFF(IPOINT+LOCSEL(K))
                     ELSE
                        RANINT(K-KREAL) = BUFF(IPOINT+LOCSEL(K))
                        END IF
 125                 CONTINUE
                  WRITE (LINE,2120) XCOUNT, JTT(1), JTT(2), JTT(3), RTT,
     *               IA1, IA2, ISU
                  IF (LINE(18:18).EQ.' ') LINE(18:18) = '0'
                  IF (KRNC.EQ.10) THEN
                     WRITE (LINE(36:),2121) (RANREA(K), K = 1,KREAL)
                  ELSE IF (KRNC.EQ.11) THEN
                     WRITE (LINE(36:),2122) (RANREA(K), K = 1,KREAL)
                  ELSE IF (KRNC.EQ.12) THEN
                     WRITE (LINE(36:),2123) (RANREA(K), K = 1,KREAL)
                  ELSE IF (KRNC.EQ.13) THEN
                     WRITE (LINE(36:),2124) (RANREA(K), K = 1,KREAL)
                  ELSE IF (KRNC.EQ.14) THEN
                     WRITE (LINE(36:),2125) (RANREA(K), K = 1,KREAL)
                  ELSE IF (KRNC.EQ.15) THEN
                     WRITE (LINE(36:),2126) (RANREA(K), K = 1,KREAL)
                     END IF
                  IF (KINC.EQ.5) THEN
                     WRITE (SCRTCH,2131) (RANINT(K), K = 1,KINT)
                  ELSE IF (KINC.EQ.6) THEN
                     WRITE (SCRTCH,2132) (RANINT(K), K = 1,KINT)
                  ELSE IF (KINC.EQ.7) THEN
                     WRITE (SCRTCH,2133) (RANINT(K), K = 1,KINT)
                  ELSE IF (KINC.EQ.8) THEN
                     WRITE (SCRTCH,2134) (RANINT(K), K = 1,KINT)
                  ELSE IF (KINC.EQ.9) THEN
                     WRITE (SCRTCH,2135) (RANINT(K), K = 1,KINT)
                  ELSE IF (KINC.EQ.10) THEN
                     WRITE (SCRTCH,2136) (RANINT(K), K = 1,KINT)
                     END IF
                  LINE(36+KRNC*KREAL:) = SCRTCH(1:KINC*KINT)
C                                       Write VIS data: CRT
C                                       low UVW, low flux
               ELSE IF ((UVM.LE.999.98) .OR. (OTYPE.GE.4)) THEN
C
                  IF (OTYPE.EQ.1) THEN
                     IF (WTFM.EQ.1) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1131,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, U, V, W, (AMP(K),
     *                           PHASE(K),RWT(K), K = 1,LIMIT2)
                           ELSE
                              WRITE (LINE,3131,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, U, V, W, (RE(K),
     *                           IM(K),RWT(K), K = 1,LIMIT2)
                              END IF

                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1136,ERR=140) XCOUNT, ITT,
     *                           IA1 ,IA2, ISU, IFQ, U, V, W, (AMP(K),
     *                           PHASE(K),RWT(K), K = 1,LIMIT2)
                           ELSE
                              WRITE (LINE,3136,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, U, V, W, (RE(K),
     *                           IM(K),RWT(K), K = 1,LIMIT2)
                              END IF
                           END IF
                     ELSE IF (WTFM.EQ.2) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1132,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, U, V, W, (AMP(K),
     *                           PHASE(K),RWT(K), K = 1,LIMIT2)
                           ELSE
                              WRITE (LINE,3132,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, U, V, W, (RE(K),
     *                           IM(K),RWT(K), K = 1,LIMIT2)
                              END IF
                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1137,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, U, V, W, (AMP(K),
     *                           PHASE(K),RWT(K), K = 1,LIMIT2)
                           ELSE
                              WRITE (LINE,3137,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, U, V, W, (RE(K),
     *                           IM(K),RWT(K), K = 1,LIMIT2)
                              END IF
                           END IF
                     ELSE IF (WTFM.EQ.3) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1133,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, U, V, W, (AMP(K),
     *                           PHASE(K),RWT(K), K = 1,LIMIT2)
                           ELSE
                              WRITE (LINE,3133,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, U, V, W, (RE(K),
     *                           IM(K),RWT(K), K = 1,LIMIT2)
                              END IF
                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1138,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, U, V, W, (AMP(K),
     *                           PHASE(K),RWT(K), K = 1,LIMIT2)
                           ELSE
                              WRITE (LINE,3138,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, U, V, W, (RE(K),
     *                           IM(K),RWT(K), K = 1,LIMIT2)
                              END IF
                           END IF
                     ELSE IF (WTFM.EQ.4) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1134,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, U, V, W, (AMP(K),
     *                           PHASE(K),RWT(K), K = 1,LIMIT2)
                           ELSE
                              WRITE (LINE,3134,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, U, V, W, (RE(K),
     *                           IM(K),RWT(K), K = 1,LIMIT2)
                              END IF
                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1139,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, U, V, W, (AMP(K),
     *                           PHASE(K),RWT(K), K = 1,LIMIT2)
                           ELSE
                              WRITE (LINE,3139,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, U, V, W, (RE(K),
     *                           IM(K),RWT(K), K = 1,LIMIT2)
                              END IF
                           END IF
                        END IF
                  ELSE IF (OTYPE.EQ.2) THEN
                     IF (WTFM.EQ.1) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1141,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3141,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1146,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3146,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                           END IF
                     ELSE IF (WTFM.EQ.2) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1142,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3142,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1147,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3147,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                           END IF
                     ELSE IF (WTFM.EQ.3) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1143,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3143,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1148,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3148,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                           END IF
                     ELSE IF (WTFM.EQ.4) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1144,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3144,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1149,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3149,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, U, V, W,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                           END IF
                        END IF
                     IF (LINE(18:18).EQ.' ') LINE(18:18) = '0'
                     IF (LINE(19:19).EQ.' ') LINE(19:19) = '0'
                  ELSE IF (OTYPE.EQ.3) THEN
                     IF (XAMP.LE.99.9) THEN
                        IF (DOAMPH) THEN
                           WRITE (LINE,1150,ERR=140) XCOUNT, ITT, IA1,
     *                        IA2,U, V, (AMP(K), PHASE(K), IWT(K),K = 1
     *                        ,LIMIT2)
                        ELSE
                           WRITE (LINE,3150,ERR=140) XCOUNT, ITT, IA1,
     *                        IA2,U, V, (RE(K), IM(K), IWT(K),K = 1
     *                        ,LIMIT2)
                           END IF
                     ELSE
                        IF (DOAMPH) THEN
                           WRITE (LINE,1155,ERR=140) XCOUNT, ITT, IA1,
     *                        IA2,U, V, (AMP(K), PHASE(K), IWT(K),K = 1
     *                        ,LIMIT2)
                        ELSE
                           WRITE (LINE,3155,ERR=140) XCOUNT, ITT, IA1,
     *                        IA2,U, V, (RE(K), IM(K), IWT(K),K = 1
     *                        ,LIMIT2)
                           END IF
                        END IF
                  ELSE IF (OTYPE.EQ.4) THEN
                     IF (XAMP.LE.99.9) THEN
                        IF (DOAMPH) THEN
                           WRITE (LINE,1151,ERR=140) XCOUNT, ITT, IA1,
     *                        IA2, (AMP(K), PHASE(K), IWT(K),
     *                        K = 1,LIMIT2)
                        ELSE
                           WRITE (LINE,3151,ERR=140) XCOUNT, ITT, IA1,
     *                        IA2, (RE(K), IM(K), IWT(K), K = 1,LIMIT2)
                           END IF
                     ELSE
                        IF (DOAMPH) THEN
                           WRITE (LINE,1156,ERR=140) XCOUNT, ITT, IA1,
     *                        IA2, (AMP(K), PHASE(K), IWT(K),
     *                        K = 1,LIMIT2)
                        ELSE
                           WRITE (LINE,3156,ERR=140) XCOUNT, ITT, IA1,
     *                        IA2, (RE(K), IM(K), IWT(K), K = 1,LIMIT2)
                           END IF
                        END IF
                  ELSE IF (OTYPE.EQ.5) THEN
                     IF (XAMP.LE.99.9) THEN
                        IF (DOAMPH) THEN
                           WRITE (LINE,1152,ERR=140) ITT(2), ITT(3),
     *                        ITT(4), IA1, IA2, (AMP(K), PHASE(K),
     *                        IWT(K), K = 1,LIMIT2)
                        ELSE
                           WRITE (LINE,3152,ERR=140) ITT(2), ITT(3),
     *                        ITT(4), IA1, IA2, (RE(K), IM(K),
     *                        IWT(K), K = 1,LIMIT2)
                           END IF
                     ELSE
                        IF (DOAMPH) THEN
                           WRITE (LINE,1157,ERR=140) ITT(2), ITT(3),
     *                        ITT(4), IA1, IA2, (AMP(K), PHASE(K),
     *                        IWT(K), K = 1,LIMIT2)
                        ELSE
                           WRITE (LINE,3157,ERR=140) ITT(2), ITT(3),
     *                        ITT(4), IA1, IA2, (RE(K), IM(K),
     *                        IWT(K), K = 1,LIMIT2)
                           END IF
                        END IF
                     END IF
C                                       High UVW, low flux
               ELSE
                  IF (OTYPE.EQ.1) THEN
                     IF (WTFM.EQ.1) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1161,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3161,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1166,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3166,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                                 END IF
                           END IF
                     ELSE IF (WTFM.EQ.2) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1162,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3162,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1167,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3167,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                           END IF
                     ELSE IF (WTFM.EQ.3) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1163,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3163,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
C
                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1168,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3168,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                           END IF
                     ELSE IF (WTFM.EQ.4) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1164,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3164,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1169,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3169,ERR=140) XCOUNT, ITT,
     *                           IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                           END IF
                        END IF
                  ELSE IF (OTYPE.EQ.2) THEN
                     IF (WTFM.EQ.1) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1171,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3171,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1176,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3176,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                           END IF
                     ELSE IF (WTFM.EQ.2) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1172,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3172,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1177,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3177,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                           END IF
C
                     ELSE IF (WTFM.EQ.3) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1173,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3173,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1178,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3178,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                           END IF
                     ELSE IF (WTFM.EQ.4) THEN
                        IF (XAMP.LE.99.9) THEN
                           IF (DOAMPH) THEN
                              WRITE (LINE,1174,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3174,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                        ELSE
                           IF (DOAMPH) THEN
                              WRITE (LINE,1179,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (AMP(K), PHASE(K), RWT(K), K=1,LIMIT2)
                           ELSE
                              WRITE (LINE,3179,ERR=140) XCOUNT, JTT,
     *                           RTT, IA1, IA2, ISU, IFQ, IU, IV, IW,
     *                           (RE(K), IM(K), RWT(K), K = 1,LIMIT2)
                              END IF
                           END IF
                        END IF
                     IF (LINE(18:18).EQ.' ') LINE(18:18) = '0'
                     IF (LINE(19:19).EQ.' ') LINE(19:19) = '0'
                  ELSE IF (OTYPE.EQ.3) THEN
                     IF (XAMP.LE.99.9) THEN
                        IF (DOAMPH) THEN
                           WRITE (LINE,1180,ERR=140) XCOUNT, ITT, IA1,
     *                        IA2, IU, IV, (AMP(K), PHASE(K), IWT(K),
     *                        K = 1,LIMIT2)
                        ELSE
                           WRITE (LINE,3180,ERR=140) XCOUNT, ITT, IA1,
     *                        IA2, IU, IV, (RE(K), IM(K), IWT(K),
     *                        K = 1,LIMIT2)
                           END IF
                     ELSE
                        IF (DOAMPH) THEN
                           WRITE (LINE,1185,ERR=140) XCOUNT, ITT, IA1,
     *                        IA2, IU, IV, (AMP(K), PHASE(K), IWT(K),
     *                        K = 1,LIMIT2)
                        ELSE
                           WRITE (LINE,3185,ERR=140) XCOUNT, ITT, IA1,
     *                        IA2, IU, IV, (RE(K), IM(K), IWT(K),
     *                        K = 1,LIMIT2)
                           END IF
                        END IF
                     END IF
                  END IF
C                                       Write VIS data
 140           CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            LINE, IPCNT, PAGE, SCRTCH, IRET)
               IF (IRET.NE.0) GO TO 960
               PCOUNT = PCOUNT + 1
               IF (PCOUNT.GE.XNIT) GO TO 960
C                                       Update IPOINT
 150           IPOINT = IPOINT + LREC * MIN (LENBU, INC)
               JLAST = J
 160           CONTINUE
 170     ISKIP = ISKIP - NIO
         IF (ISKIP+NIO.LE.NIO) ISKIP = INC - (NIO-JLAST)
         GO TO 100
C                                       CRT error
 950  CONTINUE
         WRITE (MSGTXT,1950) IRET
         CALL MSGWRT (8)
C                                       Close files.
 960  IF (IRET.LE.0) IRET = 0
      CALL LPCLOS (LUNP, FINDP, IPCNT, IRET)
C
      CALL MAPCLS ('READ', DISK, CNO, LUN, FIND, CATBLK, F, BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1980) IRET
         GO TO 990
         END IF
      NCFILE = NCFILE - 1
      GO TO 999
C                                        Write end message
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('File = ',A12,'.',A6,'.',I4,'   Vol =',I2,4X,'Userid =',
     *   I5,5X,'Channels =',I5,' to ',I5)
 1051 FORMAT (A12,'.',A6,'.',I4,'  Vol=',I2,'  User=',I5,'  Channels=',
     *   I4,' to ',I4)
 1055 FORMAT ('Source= ',A8,3X,A4,' = ',A1,I2.2,I3.2,F6.2,3X,A4,' = ',
     *   A1,I2.2,I3.2,F5.1,' IF =',I3)
 1056 FORMAT ('Freq=',F13.9,' GHz   Ncor=',I3,'   No. vis=',I10,
     *   '   Sort order= ',A2)
 1057 FORMAT ('Weights have been multiplied by',1PE9.1)
 1060 FORMAT ('Source= ',A8,4X,'Freq= ',F13.9,4X,'Sort= ',A2,4X,
     *   5(4X,I4,3X,A2,6X))
 1061 FORMAT ('Source= ',A8,6X,'Freq= ',F13.9,5X,'Sort= ',A2,4X,
     *   5(4X,I4,3X,A2,6X))
 1062 FORMAT (A8,4X,'Freq=',F13.9,4X,'Sort= ',A2,5(3X,I4,1X,A2,5X))
 1063 FORMAT (A8,F13.9,1X,A2,4(3X,I4,1X,A2,4X))
 1064 FORMAT (A8,2X,A2,2X,4(3X,I4,1X,A2,4X))
 1070 FORMAT ('  Vis #',5X,'IAT',6X,'Ant  Su Fq U(klam) V(klam) ',
     *   'W(klam)',5A)
 1071 FORMAT ('  Vis #',6X,'IAT',8X,'Ant  Su Fq U(klam) V(klam) ',
     *   'W(klam)',5A)
 1072 FORMAT ('  Vis #',5X,'IAT',6X,'Ant  U(klam) V(klam)',5A)
 1073 FORMAT (' Vis #',5X,'IAT',6X,'Ant ',4A)
 1074 FORMAT (2X,'IAT',5X,'Ant ',4A)
 1090 FORMAT ('ERROR:',I7,' INITIALIZING UV FILE')
 1100 FORMAT ('ERROR:',I7,' READING VIS ')
 1131 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,I4,F7.1))
 1132 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,I4,F7.2))
 1133 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,I4,F7.3))
 1134 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,I4,F7.4))
 1136 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,I4,F7.1))
 1137 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,I4,F7.2))
 1138 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,I4,F7.3))
 1139 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,I4,F7.4))
 1141 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,I4,F7.1))
 1142 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,I4,F7.2))
 1143 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,I4,F7.3))
 1144 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,I4,F7.4))
 1146 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,I4,F7.1))
 1147 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,I4,F7.2))
 1148 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,I4,F7.3))
 1149 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,I4,F7.4))
 1150 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F8.2,5(F8.3,I4,I3))
 1151 FORMAT (I6,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,4(F7.3,I4,I3))
 1152 FORMAT (I2.2,2(':',I2.2),I3,'-',I2,4(F7.3,I4,I3))
 1155 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F8.2,5(F8.1,I4,I3))
 1156 FORMAT (I6,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,4(F7.1,I4,I3))
 1157 FORMAT (I2.2,2(':',I2.2),I3,'-',I2,4(F7.1,I4,I3))
 1161 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.3,I4,F7.1))
 1162 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.3,I4,F7.2))
 1163 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.3,I4,F7.3))
 1164 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.3,I4,F7.4))
 1166 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.1,I4,F7.1))
 1167 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.1,I4,F7.2))
 1168 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.1,I4,F7.3))
 1169 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.1,I4,F7.4))
 1171 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.3,I4,F7.1))
 1172 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.3,I4,F7.2))
 1173 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.3,I4,F7.3))
 1174 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.3,I4,F7.4))
 1176 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.1,I4,F7.1))
 1177 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.1,I4,F7.2))
 1178 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.1,I4,F7.3))
 1179 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.1,I4,F7.4))
 1180 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I8,5(F8.3,I4,I3))
 1185 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I8,5(F8.1,I4,I3))
 2070 FORMAT ('  Vis #',7X,'IAT',8X,'Base Suba')
 2120 FORMAT (I7,I3,'/',2(I2.2,':'),F6.3,I3,'-',I2,2X,I3)
 2121 FORMAT (10(1PE10.2))
 2122 FORMAT (10(1PE11.3))
 2123 FORMAT (10(1PE12.4))
 2124 FORMAT (10(1PE13.5))
 2125 FORMAT (10(1PE14.6))
 2126 FORMAT (10(1PE15.7))
 2131 FORMAT (10I5)
 2132 FORMAT (10I6)
 2133 FORMAT (10I7)
 2134 FORMAT (10I8)
 2135 FORMAT (10I9)
 2136 FORMAT (10I10)
 3060 FORMAT ('Source= ',A8,4X,'Freq= ',F13.9,4X,'Sort= ',A2,4X,
     *   5(5X,I4,5X,A2,7X))
 3061 FORMAT ('Source= ',A8,6X,'Freq= ',F13.9,5X,'Sort= ',A2,4X,
     *   5(5X,I4,5X,A2,7X))
 3062 FORMAT (A8,4X,'Freq=',F13.9,4X,'Sort= ',A2,5(4X,I4,3X,A2,6X))
 3063 FORMAT (A8,F13.9,1X,A2,4(4X,I4,2X,A2,5X))
 3064 FORMAT (A8,2X,A2,2X,4(4X,I4,2X,A2,5X))
 3131 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,F8.3,F7.1))
 3132 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,F8.3,F7.2))
 3133 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,F8.3,F7.3))
 3134 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,F8.3,F7.4))
 3136 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,F8.1,F7.1))
 3137 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,F8.1,F7.2))
 3138 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,F8.1,F7.3))
 3139 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,F8.1,F7.4))
 3141 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,F8.3,F7.1))
 3142 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,F8.3,F7.2))
 3143 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,F8.3,F7.3))
 3144 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.3,F8.3,F7.4))
 3146 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,F8.1,F7.1))
 3147 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,F8.1,F7.2))
 3148 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,F8.1,F7.3))
 3149 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3F8.2,
     *   4(F8.1,F8.1,F7.4))
 3150 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F8.2,
     *   5(F8.3,F8.3,I3))
 3151 FORMAT (I6,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,4(F7.3,F7.3,I3))
 3152 FORMAT (I2.2,2(':',I2.2),I3,'-',I2,4(F7.3,F7.3,I3))
 3155 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2F8.2,
     *   5(F8.1,F8.1,I3))
 3156 FORMAT (I6,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,4(F7.1,F7.1,I3))
 3157 FORMAT (I2.2,2(':',I2.2),I3,'-',I2,4(F7.1,F7.1,I3))
 3161 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.3,F8.3,F7.1))
 3162 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.3,F8.3,F7.2))
 3163 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.3,F8.3,F7.3))
 3164 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.3,F8.3,F7.4))
 3166 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.1,F8.1,F7.1))
 3167 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.1,F8.1,F7.2))
 3168 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.1,F8.1,F7.3))
 3169 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I3,3I8,
     *   5(F8.1,F8.1,F7.4))
 3171 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.3,F8.3,F7.1))
 3172 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.3,F8.3,F7.2))
 3173 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.3,F8.3,F7.3))
 3174 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.3,F8.3,F7.4))
 3176 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.1,F8.1,F7.1))
 3177 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.1,F8.1,F7.2))
 3178 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.1,F8.1,F7.3))
 3179 FORMAT (I7,I3,'/',2(I2.2,':'),F5.2,I3,'-',I2,2I3,3I8,
     *   5(F8.1,F8.1,F7.4))
 3180 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I8,5(F8.3,F8.3,I3))
 3185 FORMAT (I7,I3,'/',I2.2,2(':',I2.2),I3,'-',I2,2I8,5(F8.1,F8.1,I3))
 1950 FORMAT ('ERROR',I5,' DOING I/O TO TERMINAL OR PRINTER')
 1980 FORMAT ('ERROR:',I7,' CLOSING UV FILE ')
      END
      SUBROUTINE SOURS (DOPRT, SOUID, OLDSOU, WANTED, IERR)
C-----------------------------------------------------------------------
C   Process the next source number adding header info if the source
C   changes. Calls GETSOU to fill in commons with source info using
C   GETSOU.
C   Input:
C      DOPRT   L      Do display?
C      SOUID   I      Source ID number
C   Input from common:
C      MULTI   L      If true then this is a multi source file.
C      DISK    I      Input file disk number.
C      CNO     I      Input file catalog slot number
C      NSOUWD  I      Number of source numbers to check in SOUWAN
C      SOUWAN  I(*)   List of source numbers desired.
C      LUNP    I      LUN for output.
C      FINDP   I      FTAB pointer for output.
C      DOCRT   R      Requested output type and width.
C      NACROS  I      Actual output width.
C      OTYPE   I      Output width type.
C   Input/output:
C      OLDSOU  I      Last source number, -1 on input => first call.
C   Input/output from common:
C      TITL1   C*132  First title line
C      TITL2   C*132  Second title line
C      IPCNT   I      Line count on page
C      PAGE    I      Page number
C   Output:
C      WANTED  L      If true this source is wanted.
C      IERR    I      Return error code, 0=>OK else failed
C   Output in common:C      SNAME   C*8    Source name (DUVH.INC)
C      All values in DSOU.INC
C-----------------------------------------------------------------------
      LOGICAL   DOPRT, WANTED
      INTEGER   SOUID, OLDSOU, IERR
C
      INTEGER   ISU, SULUN
      INCLUDE 'PRTUV.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA SULUN /17/
C-----------------------------------------------------------------------
      IERR = 0
      WANTED = .TRUE.
C                                       If same source as last skip.
      IF (SOUID.EQ.OLDSOU) GO TO 999
      IF (MULTI) THEN
C                                       Wanted?
         WANTED = .FALSE.
         DO 20 ISU = 1,NSOUWD
            IF (SOUID.EQ.SOUWAN(ISU)) WANTED = .TRUE.
 20         CONTINUE
C                                       Source selected?
         IF (.NOT.DOSWNT) WANTED = .NOT.WANTED
         IF (.NOT.WANTED) GO TO 999
C                                       Get new source info
         CALL GETSOU (SOUID, DISK, CNO, CATBLK, SULUN, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR, SOUID
            GO TO 990
            END IF
         SOURCE = SNAME
         END IF
C                                       Change source name in TITL1
      IF (DOPRT) THEN
         IF (OTYPE.LT.3) THEN
            TITL1(9:16) = SOURCE(1:8)
         ELSE
            TITL1(1:8) = SOURCE(1:8)
            END IF
C                                       First call - print titles
         IF (OLDSOU.EQ.-1) THEN
C
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         TITL1, IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 950
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         TITL2, IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 950
            END IF
C                                       Blank line for first or new
C                                       source
         IF (((OLDSOU.EQ.-1) .OR. (SOUID.NE.OLDSOU)) .AND.
     *     (DOCRT.GT.-2.5)) THEN
            LINE = ' '
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 950
            END IF
C                                       Title for subsequent new source.
         IF ((OLDSOU.NE.-1) .AND. (SOUID.NE.OLDSOU))  THEN
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         TITL1, IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 950
            IF (DOCRT.GT.-2.5) THEN
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            TITL2, IPCNT, PAGE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 950
               END IF
            END IF
         END IF
C                                       Save old source number
      OLDSOU = SOUID
      GO TO 999
C                                       Error writing output
 950  WRITE (MSGTXT,1950) IERR
C                                       Error
 990  IF (IERR.GT.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('ERROR:',I7,' OBTAINING DATA FOR SOURCE #',I5)
 1950 FORMAT ('ERROR',I5,' DOING I/O TO TERMINAL OR PRINTER')
      END
      SUBROUTINE T2DHMS (TIMEIN, NDIG, TIME, RTIME)
C-----------------------------------------------------------------------
C   Convert from Time to Days Hours Minutes Seconds format
C   Input:
C      TIMEIN   R       Input:  Time
C      NDIG     I       Number digits in seconds display
C   Output:
C      TIME     I*(3)   Output Time in Days Hours Minutes
C      RTIME    R       SECONDS
C-----------------------------------------------------------------------
      REAL     TIMEIN, RTIME
      INTEGER  NDIG, TIME(3)
C
      REAL     T
      INTEGER  I, J
C-----------------------------------------------------------------------
      T = TIMEIN
      IF (TIMEIN.LT.0.0) T = -T
C
      TIME(1) = T
      T = (T - TIME(1)) * 24.0
      TIME(2) = T
      T = (T - TIME(2)) * 60.0
      TIME(3) = T
      T = (T - TIME(3)) * 60.0
      RTIME   = T
      J = 10 ** NDIG
      J = MAX (1, J)
      I = J*T + 0.5
C                                       Now Remove 60 seconds
      IF (I.GE.J*60) THEN
         RTIME = RTIME - 60.0
         TIME(3) = TIME(3) + 1
         END IF
C                                       Now Remove 60 minutes
      IF (TIME(3).GE.60) THEN
         TIME(3) = TIME(3) - 60
         TIME(2) = TIME(2) + 1
         END IF
C                                       Now Remove 24 hours
      IF (TIME(2).GE.24) THEN
         TIME(2) = TIME(2) - 24
         TIME(1) = TIME(1) + 1
         END IF
C                                       Sign
      IF (TIMEIN.LT.0.0) TIME(1) = -TIME(1)
C
 999  RETURN
      END
      SUBROUTINE PRMSET (CATBLK, TRN)
C-----------------------------------------------------------------------
C   Drops REMOVED from random parameter list and makes list of output
C   indices
C   In/Out:
C      CATBLK   I(256)   Catalog header - input random parms can have
C                        REMOVED  - output does not (and # changed)
C   Output:
C      TRN      I(14)    output parm(j) = input parm(trn(j))
C-----------------------------------------------------------------------
      INTEGER   CATBLK(256), TRN(*)
C
      INTEGER   NPI, NPO, I, IPTYP(2)
      HOLLERITH HPTYP(2)
      CHARACTER TYPE*8

      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      NPO = 0
      NPI = CATBLK(KIPCN)
      DO 20 I = 1,NPI
         CALL COPY (2, CATBLK(KHPTP+2*I-2), IPTYP)
         CALL H2CHR (8, 1, HPTYP, TYPE)
         IF (TYPE.NE.'REMOVED') THEN
            NPO = NPO + 1
            TRN(NPO) = I
            CALL COPY (2, IPTYP, CATBLK(KHPTP+2*NPO-2))
            END IF
 20      CONTINUE
      CATBLK(KIPCN) = NPO
C
 999  RETURN
      END
      SUBROUTINE LISRAN (OUTRAN, ANOTA)
C-----------------------------------------------------------------------
C   Returns the list of the random parameters and relevant array
C   of logicals - whether the parameter is (is not) averaged
C   Input from common:
C      NRPARM   I        Number of random parameters
C      CATBLK   I(256)   Header
C   Outputs:
C      OUTRAN   C(*)*8   Array of random parameters
C      ANOTA    I(*)     type of the parameter
C                        0 => integer
C                        1 => real
C                        2 => omit (time baseline)
C                        -1=> not recognized
C-----------------------------------------------------------------------
      INTEGER   ANOTA(*)
      CHARACTER OUTRAN(*)*8
C
      INTEGER   NUMPAR
      PARAMETER (NUMPAR = 18)
C
      INTEGER   IPARM, INDPAR, NRPRIN, I, J
      CHARACTER CTEMP*8, NAMPAR(NUMPAR)*8
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA NAMPAR / 'UU-L    ', 'VV-L    ', 'WW-L    ', 'TIME1   ',
     *   'BASELINE', 'SOURCE  ', 'FREQSEL ', 'INTTIM  ', 'GATEID  ',
     *   'CORR-ID ', 'FILTER  ', 'DATE    ', 'WEIGHT  ', 'SCALE   ',
     *   'REMOVED ', 'SUBARRAY', 'ANTENNA1', 'ANTENNA2'/
C-----------------------------------------------------------------------
      NRPRIN = NRPARM
      NRPRIN = MIN (NRPRIN, KIPTPN)
      DO 40 IPARM = 1,NRPRIN
         ANOTA(IPARM) = -1
         INDPAR = KHPTP + 2 * (IPARM - 1)
         CALL H2CHR (8, 1, CATH(INDPAR), CTEMP)
         OUTRAN(IPARM) = CTEMP
         DO 20 I = 1,NUMPAR
            J = 8
            IF (I.LT.4) J = 4
            IF (CTEMP(:J).EQ.NAMPAR(I)(:J)) THEN
               ANOTA(IPARM) = 0
               IF ((I.LE.3) .OR. (I.EQ.8) .OR. (I.EQ.13) .OR.
     *            (I.EQ.14)) ANOTA(IPARM) = 1
               IF ((I.GE.4) .AND. (I.LE.5)) ANOTA(IPARM) = 2
               END IF
 20         CONTINUE
         IF (ANOTA(IPARM).LT.0) THEN
            WRITE (MSGTXT,1000) OUTRAN(IPARM)
            CALL MSGWRT (6)
            END IF
 40      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('WARNING: ',A,' NOT RECOGNIZED')
      END

      SUBROUTINE TABIO (OPCODE, IRCODE, IRNO, RECORD, BUFFER, IERR)
C-----------------------------------------------------------------------
C! reads/writes tables extension files
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TABIO does random access I/O to Tables extension files.  Mixed
C   reads and writes are allowed if TABINI was called 'WRIT'.  Writes
C   are limited by the size of the structure (i.e. # columns for units
C   and titles) or to the current maximum logical record plus one.
C   Files opened for WRITe are updated and compressed on CLOS.
C   Inputs:
C      OPCODE   C*4      Opcode 'READ','CLOS'
C                           'WRIT' : write data as selected
C                           'FLAG' : write data as de-selected
C      IRCODE   I        Type of information
C                           0 => Table row
C                           1 => DATPTR/DATYPE record
C                           2 => data selection string
C                           3 => title
C                           4 => units
C                           5 => keyword/value pair
C      IRNO     I        Logical record number. 0 => next (can work
C                        with row data and latest IRCODE > 0 only)
C                           IRNO is row number (IRCODE = 0)
C                           IRNO is ignored (IRCODE = 1)
C                           IRNO is string number (IRCODE = 2)
C                           IRNO is column number (IRCODE = 3)
C                           IRNO is column number (IRCODE = 4)
C                           IRNO is keyword number (IRCODE = 5)
C      RECORD   I(*)     Array containing record to be written
C      BUFFER   I(*)     Work buffer = 256 word + enough 256 word
C                        blocks for at least one full logical record.
C                        Must be the same one given TABINI.
C   Output:
C      RECORD   I(*)     Array containing record read.
C      BUFFER   I(*)     buffer.
C      IERR     I        Return error code 0 => OK
C                            -1 => on READ: row read is flagged
C                             1 => file not open
C                             2 => input error
C                             3 => I/O error
C                             4 => attempt to read past end of data
C                                  or write past end of data + 1
C                             5 => error on expanding the file
C   IMPORTANT NOTE:  the contents of BUFFER should not be changed
C   except by TABIO between the time TABINI is called until the file
C   is closed.  The exception is that the user portion of the header
C   record is available.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   IRCODE, IRNO, RECORD(*), BUFFER(*), IERR
C
      INTEGER   TRNO, LRNO, LLRNO, MRNO, XRNO, ISIZE, IOP, IADD, NLPR,
     *   IOFF, I, LIMIT, INDEX, IER, NWORD, SCRTCH(256)
      CHARACTER PHNAME*48, CTEST*4, OP*4
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Test OP, record codes
      IERR = 2
      IF ((IRCODE.LT.0) .OR. (IRCODE.GT.5)) GO TO 970
      IOP = 0
      IF (OPCODE.EQ.'CLOS') GO TO 200
      IF (OPCODE.EQ.'READ') IOP = 1
      IF (OPCODE.EQ.'WRIT') IOP = 2
      IF (OPCODE.EQ.'FLAG') IOP = 3
      IF (IOP.EQ.0) GO TO 970
      IF ((IOP.GT.1) .AND. (BUFFER(71).LE.1)) GO TO 970
C                                       Get logical record number
      TRNO = BUFFER(75)
      LRNO = IRNO - 1
      IF ((LRNO.LT.0) .AND. (IRCODE.EQ.0)) LRNO = TRNO
      IF ((LRNO.LT.0) .AND. (IRCODE.EQ.BUFFER(80))) LRNO = BUFFER(79)
      LRNO = LRNO + 1
      LLRNO = LRNO
C                                       logical -> physical col #
      IF ((IRCODE.EQ.3) .OR. (IRCODE.EQ.4)) LRNO = BUFFER(128+LRNO)
      MRNO = 1
      IF ((LRNO.LE.0) .AND. (IRCODE.NE.1)) GO TO 980
C                                       Get maximum allowed rec #
      IADD = 0
      IF (IOP.GT.1) IADD = 1
      MRNO = BUFFER(10)
      IF (IRCODE.EQ.0) MRNO = BUFFER(5) + IADD
      IF (IRCODE.EQ.2) MRNO = MIN (BUFFER(61) + IADD, 8)
      IF (IRCODE.EQ.5) MRNO = MIN (BUFFER(53) + IADD, BUFFER(52))
      IF ((LRNO.GT.MRNO) .AND. (IRCODE.NE.1)) GO TO 980
C                                       Set physical record #, offset
      IF (IRCODE.EQ.0) THEN
         NLPR = BUFFER(9)
         IF (NLPR.GT.0) THEN
            MRNO = BUFFER(50) + (LRNO - 1) / NLPR
            IOFF = (LRNO - 1) - (MRNO - BUFFER(50)) * NLPR
            IOFF = IOFF * BUFFER(72) + 1
         ELSE
            MRNO = BUFFER(50) - (LRNO - 1) * NLPR
            IOFF = 1
            END IF
      ELSE IF (IRCODE.EQ.1) THEN
         MRNO = 2
         IOFF = 1
      ELSE IF (IRCODE.EQ.2) THEN
         NLPR = BUFFER(62)
         IF (LRNO.LE.BUFFER(61)) NLPR = BUFFER(62+LRNO)
         MRNO = BUFFER(46)
         IOFF = NLPR
         IF (IOFF.GT.256) THEN
            MRNO = MRNO + 1
            IOFF = IOFF - 256
            END IF
      ELSE
         I = 6
         IF (IRCODE.EQ.4) I = 2
         IF (IRCODE.EQ.5) I = 5
         NLPR = 256 / I
         MRNO = BUFFER(44+IRCODE) + (LRNO - 1) / NLPR
         IOFF = (LRNO - 1) - ((LRNO-1)/NLPR) * NLPR
         IOFF = IOFF * I + 1
         END IF
C                                       Large row - immediate I/O
      IF ((IRCODE.EQ.0) .AND. (BUFFER(9).LT.0)) THEN
         LIMIT = -BUFFER(9)
         IERR = 0
C                                       File open for write; expand
C                                       if necessary.
         IF (BUFFER(71).EQ.2) THEN
C                                       expand file
            IF ((MRNO+LIMIT-1.GT.BUFFER(1)) .OR. (LRNO.GT.BUFFER(3)))
     *         THEN
               IADD = LIMIT * BUFFER(42)
               CALL H2CHR (48, 1, BUFFER(17), PHNAME)
               CALL ZEXPND (BUFFER(81), BUFFER(32), PHNAME, IADD, IER)
               IF (IER.NE.0) THEN
                  WRITE (MSGTXT,1050) IER
                  IERR = 5
                  GO TO 995
                  END IF
C                                       Update header info
               BUFFER(1) = BUFFER(1) + IADD
               BUFFER(3) = BUFFER(3) - IADD / BUFFER(9)
               END IF
            END IF
C                                       Read or write the large
C                                       table record directly.
C                                       Write table record.
         IF (IOP.GE.2) THEN
            TRNO = MRNO
            INDEX = 1
            NWORD = BUFFER(72) - 1
            OP = 'WRIT'
            DO 10 I = 1,LIMIT
               IF (I.LT.LIMIT) THEN
                  CALL ZFIO ('WRIT', BUFFER(81), BUFFER(82), TRNO,
     *               RECORD(INDEX), IER)
C                                       insert flagging
               ELSE
                  CALL COPY (NWORD, RECORD(INDEX), SCRTCH)
                  IF (IOP.EQ.2) SCRTCH(1+NWORD) = 1
                  IF (IOP.EQ.3) SCRTCH(1+NWORD) = -1
                  CALL ZFIO ('WRIT', BUFFER(81), BUFFER(82), TRNO,
     *               SCRTCH, IER)
                  END IF
               IF (IER.NE.0) GO TO 990
               TRNO = TRNO + 1
               INDEX = INDEX + 256
               NWORD = NWORD - 256
 10            CONTINUE
            BUFFER(5) = MAX (BUFFER(5), LRNO)
C                                       Read table record.
         ELSE
            TRNO = MRNO
            INDEX = 1
            NWORD = BUFFER(72) - 1
            OP = 'READ'
            DO 20 I = 1,LIMIT
               IF (I.LT.LIMIT) THEN
                  CALL ZFIO ('READ', BUFFER(81), BUFFER(82), TRNO,
     *               RECORD(INDEX), IER)
C                                       insert flagging
               ELSE
                  CALL ZFIO ('READ', BUFFER(81), BUFFER(82), TRNO,
     *               SCRTCH, IER)
                  CALL COPY (NWORD, SCRTCH, RECORD(INDEX))
                  IF (SCRTCH(1+NWORD).LE.0) IERR = -1
                  END IF
               IF (IER.NE.0) GO TO 990
               TRNO = TRNO + 1
               INDEX = INDEX + 256
               NWORD = NWORD - 256
 20            CONTINUE
            END IF
         BUFFER(73) = MRNO
         BUFFER(75) = LLRNO
         GO TO 999
         END IF
C                                       New physical record
      IF (BUFFER(77).EQ.0) THEN
         TRNO = BUFFER(73)
      ELSE
         TRNO = BUFFER(78)
         END IF
      IF ((IRCODE.NE.BUFFER(77)) .OR. (MRNO.NE.TRNO)) THEN
C                                       write old one
         IF (BUFFER(71).EQ.2) THEN
            IF ((TRNO.GT.0) .AND. (BUFFER(77).GE.0) .AND.
     *         (BUFFER(77).LE.5)) THEN
               OP = 'WRIT'
               CALL ZFIO ('WRIT', BUFFER(81), BUFFER(82), TRNO,
     *            BUFFER(257), IER)
               IF (IER.NE.0) GO TO 990
               END IF
C                                       Expand if needed
            IF ((IRCODE.EQ.0) .AND. ((MRNO.GT.BUFFER(1)) .OR.
     *         (LRNO.GT.BUFFER(3)))) THEN
               IADD = BUFFER(42) / BUFFER(9) + 1
               CALL H2CHR (48, 1, BUFFER(17), PHNAME)
               CALL ZEXPND (BUFFER(81), BUFFER(32), PHNAME, IADD, IER)
               IF (IER.NE.0) THEN
                  WRITE (MSGTXT,1050) IER
                  IERR = 5
                  GO TO 995
                  END IF
C                                       Update header info
               BUFFER(1) = BUFFER(1) + IADD
               BUFFER(3) = BUFFER(3) + IADD * BUFFER(9)
               END IF
            END IF
C                                       read new record
         OP = 'READ'
         TRNO = MRNO
         CALL ZFIO ('READ', BUFFER(81), BUFFER(82), TRNO, BUFFER(257),
     *      IER)
         IF (IER.NE.0) GO TO 990
         END IF
C                                       Update record pointers
 100  BUFFER(77) = IRCODE
      IF (IRCODE.EQ.0) THEN
         BUFFER(73) = MRNO
         BUFFER(75) = LLRNO
      ELSE
         BUFFER(78) = MRNO
         BUFFER(79) = LLRNO
         BUFFER(80) = IRCODE
         END IF
      IERR = 0
C                                       Move data RESULT <-> BUFFER
      IF (IRCODE.EQ.0) THEN
         IOFF = 256 + IOFF
         NWORD = BUFFER(72) - 1
         IF (IOP.GE.2) THEN
            CALL COPY (NWORD, RECORD, BUFFER(IOFF))
            IF (IOP.EQ.2) BUFFER(IOFF+NWORD) = 1
            IF (IOP.EQ.3) BUFFER(IOFF+NWORD) = -1
            TRNO = BUFFER(5)
            IF (LRNO.GT.TRNO) BUFFER(5) = LRNO
         ELSE
            CALL COPY (NWORD, BUFFER(IOFF), RECORD)
            IF (BUFFER(IOFF+NWORD).LE.0) IERR = -1
            END IF
C                                       Special records:
      ELSE IF (IRCODE.NE.2) THEN
         NWORD = 256
         IF (IRCODE.EQ.3) NWORD = 6
         IF (IRCODE.EQ.4) NWORD = 2
         IF (IRCODE.EQ.5) NWORD = 5
         IOFF = 256 + IOFF
         IF (IOP.EQ.1) THEN
            CALL COPY (NWORD, BUFFER(IOFF), RECORD)
         ELSE
            CALL COPY (NWORD, RECORD, BUFFER(IOFF))
            IF ((IRCODE.EQ.5) .AND. (LRNO.GT.BUFFER(53))) BUFFER(53) =
     *         LRNO
            END IF
         GO TO 999
C                                       Read data selection strings
      ELSE IF (IOP.EQ.1) THEN
         IOFF = 256 + IOFF
         NWORD = BUFFER(63+LRNO) - BUFFER(62+LRNO)
         IF (LRNO.EQ.8) NWORD = BUFFER(62) - BUFFER(70)
         I = MIN (NWORD, 513 - IOFF)
         CALL COPY (I, BUFFER(IOFF), RECORD)
         I = NWORD - I
         IF (I.GT.0) THEN
            TRNO = BUFFER(46) + 1
            OP = 'READ'
            CALL ZFIO ('READ', BUFFER(81), BUFFER(82), TRNO,
     *         BUFFER(257), IER)
            IF (IER.NE.0) GO TO 990
            BUFFER(78) = TRNO
            CALL COPY (I, BUFFER(257), RECORD)
            RECORD(NWORD+1) = 0
            END IF
C                                       write data selection strings
      ELSE
         NWORD = 0
         DO 135 I = 1,100
            IF (RECORD(I).EQ.0) GO TO 140
               CALL H2CHR (4, 1, RECORD(I), CTEST)
               IF (CTEST.NE.' ') NWORD = I
 135        CONTINUE
 140     I = NWORD + BUFFER(62+LRNO)
         IF (I.GT.513) I = 513
         BUFFER(62) = I
         IF (LRNO.LT.8) BUFFER(63+LRNO) = I
         IOFF = 256 + IOFF
         NWORD = BUFFER(62) - BUFFER(62+LRNO)
         IF (NWORD.LE.0) BUFFER(61) = BUFFER(61) - 1
         I = MIN (513-IOFF, NWORD)
         IF (I.GT.0) CALL COPY (I, RECORD, BUFFER(IOFF))
         IOFF = I + 1
         I = NWORD - I
         IF (I.GT.0) THEN
            TRNO = BUFFER(78)
            OP = 'WRIT'
            CALL ZFIO ('WRIT', BUFFER(81), BUFFER(82), TRNO,
     *         BUFFER(257), IER)
            IF (IER.NE.0) GO TO 990
            CALL RFILL (256, HBLANK, BUFFER(257))
            CALL COPY (I, RECORD(IOFF), BUFFER(257))
            BUFFER(78) = BUFFER(46) + 1
            END IF
         END IF
      GO TO 999
C                                       CLOSe: update on WRITes
 200  IF (BUFFER(71).GE.2) THEN
C                                       reset to no-op
         BUFFER(71) = 0
         OP = 'WRIT'
         CALL ZFIO ('WRIT', BUFFER(81), BUFFER(82), 1, BUFFER, IER)
         IF (IER.NE.0) GO TO 990
         IF (BUFFER(77).NE.0) THEN
            LIMIT = 1
            TRNO = BUFFER(78)
         ELSE
            LIMIT = -BUFFER(9)
            LIMIT = MAX (1, LIMIT)
            TRNO = BUFFER(73)
            END IF
         IF (TRNO.GT.0) THEN
            DO 210 I = 1,LIMIT
               INDEX = I*256 + 1
               CALL ZFIO ('WRIT', BUFFER(81), BUFFER(82), TRNO,
     *            BUFFER(INDEX), IER)
               IF (IER.NE.0) GO TO 990
               TRNO = TRNO + 1
 210           CONTINUE
            END IF
C                                       Does file need a compress?
 220     MRNO = BUFFER(3)
         LRNO = BUFFER(5)
         IF (LRNO.LE.0) GO TO 290
         IF (BUFFER(9).GT.0) THEN
            TRNO = (MRNO - LRNO) / BUFFER(9)
         ELSE
            TRNO = MRNO - LRNO
            END IF
C                                       Yes: do it
         IF (TRNO.GT.6) THEN
            IF (BUFFER(9).GT.0) THEN
               TRNO = (LRNO-1) / BUFFER(9) + 1
            ELSE
               TRNO = -LRNO * BUFFER(9)
               END IF
            ISIZE = TRNO + BUFFER(50) - 1
            CALL H2CHR (48, 1, BUFFER(17), PHNAME)
            CALL ZCMPRS (BUFFER(32), PHNAME, BUFFER(81), ISIZE, IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,1220) IER
               CALL MSGWRT (8)
               GO TO 290
               END IF
C                                       Update header, to disk
            XRNO = ISIZE
            BUFFER(1) = XRNO
            TRNO = XRNO - BUFFER(50) + 1
            IF (BUFFER(9).GT.0) THEN
               TRNO = TRNO * BUFFER(9)
            ELSE
               TRNO = -TRNO / BUFFER(9)
               END IF
            BUFFER(3) = TRNO
            TRNO = 1
            CALL ZFIO ('WRIT', BUFFER(81), BUFFER(82), 1, BUFFER, IER)
            IF (IER.NE.0) GO TO 990
            END IF
         END IF
C                                       actual close
 290  CALL ZCLOSE (BUFFER(81), BUFFER(82), IER)
      IERR = 0
      GO TO 999
C                                       Errors: bad codes
 970  WRITE (MSGTXT,1970) IRCODE, OPCODE
      GO TO 995
C                                       bad record number
 980  WRITE (MSGTXT,1980) LRNO, MRNO
      GO TO 995
C                                       I/O errors
 990  WRITE (MSGTXT,1990) IER, OP, TRNO
      IERR = 3
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('TABIO: ERROR',I5,' EXPANDING TABLE FILE')
 1220 FORMAT ('TABIO: ERROR',I5,' COMPRESSING TABLE FILE ON CLOSE')
 1970 FORMAT ('TABIO: BAD CODES - TYPE, OP =',I7,2X,A4)
 1980 FORMAT ('TABIO: BAD LRNO=',I12,' LIMIT',I12)
 1990 FORMAT ('TABIO: I/O ERROR',I5,' ON ',A4,' PHYS REC',I12)
      END

LOCAL INCLUDE 'PCLPLT.INC'
C                                       Parameter include for CLPLT
      INTEGER   MAXTRP, MAXCC
C                                       MAXTRP = max. no. triples
      PARAMETER (MAXTRP=1000)
C                                       MAXCC = max. no. model
C                                       components.
      PARAMETER (MAXCC = 200000)
      INTEGER   MAXSAT
      PARAMETER (MAXSAT = 5*6)
LOCAL END
LOCAL INCLUDE 'CLPLT.INC'
C                                       Local include for CLPLT
      INCLUDE 'PCLPLT.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:DMSG.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAM2I(3), XCLA2I(2), XXSTOK(1),
     *   XXSOUR(4), XXCALC(1), XOPCOD(1), XOUTXT(12)
      CHARACTER NAMEIN*12, CLAIN*6, NAM2IN*12, CLA2IN*6, XSTOK*4,
     *   STANAM(MAXANT)*8, XSOUR*16, XCALCO*4, OPCODE*4, OUTEXT*48,
     *   TITL1*132, TITL2*132
      REAL      USERID, XSIN, XDISIN, XS2IN, XDI2IN, XBCHAN, XECHAN,
     *   XBIF, XEIF, XINC, UVRANG(2), XTIME(8), XANT(50), YTYPE,
     *   BPARM(10), XINV2, XCOMP(MAXAFL), XFLUX, XNMAP, XNPNTS, XSUBA,
     *   XDOTV, XGRCH, XQUAL, PHSMIN, XBAND, XFREQ, XFQID, XDOCAL,
     *   XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER,
     *   XSMOTH(3), XSOLIN, XSYM, XFACT, XLABEL, XYRATO, DOCRT, BADD(10)
      REAL      BUFF1(UVBFSS), CCPOS(3,MAXCC), SFLUX(MAXCC),
     *   GAUSA(MAXCC), GAUSB(MAXCC), GAUSC(MAXCC), CHOUT(4), IATUTC,
     *   UT1XXX, INISCL(4)
      INTEGER   JBUFSZ, NUMCC, NANT, NSRC, IDN(30), OLDCNO, LUNP, FINDP,
     *   IPCNT, PAGE, NACROS, CATKEP(256), OBUFF(1024)
      LOGICAL   DOGAUS, DOSPHE, DOTV, MULTI
      REAL      TBEG, TFIN, XYSCL(2), XYOFF(2), XYVALS(MAXANT,MAXANT),
     *   XYCLOS(2,MAXTRP), TIMMIN, TIMMAX, UVSCAL
      INTEGER   IAW1, IAW2, INC, SEQIN, DISKIN, LUNI, INDI, LABEL,
     *   TYPEAX(2), NCH, IBIF, VER2, TESTEM(2), LTYPE,
     *   OKDAT(MAXANT,MAXANT), ANTS(50), ISUB, GRCHN, TVCHN, TVCORN(4),
     *   GOODCL(MAXTRP), CHNSEL(3,10), IORBIT(MAXANT), DOMODL, NPARMS
      LOGICAL   SCALEM(2), NOUVR, FLOTEM, DROPEM, DOERRB, DECICL, INDECL
C
      DOUBLE PRECISION XB(MAXANT), YB(MAXANT), ZB(MAXANT),
     *   ORBITA(MAXSAT), JDREF, AFREQ, GST0, ARRLON, OBSRA, OBSDEC
C                                       WARNING: many of these commons
C                                       are declared locally with
C                                       variables of different names!!!
      COMMON /INPARM/ USERID, XNAMEI, XCLAIN, XSIN, XDISIN,
     *   XNAM2I, XCLA2I, XS2IN, XDI2IN, XINV2, XCOMP, XFLUX, XNMAP,
     *   XNPNTS, XXSOUR, XQUAL, XXCALC, XBAND, XFREQ, XFQID, XBCHAN,
     *   XECHAN, XBIF, XEIF, XINC, UVRANG, XTIME, XXSTOK, XANT, XDOCAL,
     *   XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH,
     *   XSUBA, YTYPE, XSOLIN, XOPCOD, PHSMIN, BPARM, XSYM, XFACT,
     *   XLABEL, XDOTV, XGRCH, XYRATO, DOCRT, XOUTXT, BADD
      COMMON /BUFRS/ BUFF1, OBUFF, JBUFSZ
      COMMON /VBPCOM/ CATKEP, TBEG, TFIN, XYSCL, XYOFF, XYVALS, XYCLOS,
     *   TIMMIN, TIMMAX, SCALEM, NOUVR, FLOTEM, DROPEM, IAW1, IAW2, INC,
     *   SEQIN, DISKIN, LUNI, INDI, TYPEAX, NCH, IBIF, VER2, TESTEM,
     *   OKDAT, ANTS, ISUB, LABEL, CHOUT, LTYPE, GRCHN, TVCHN, TVCORN,
     *   NSRC, IDN, OLDCNO, GOODCL, CHNSEL, DOTV, DOERRB, MULTI, DECICL,
     *   INDECL, UVSCAL, DOMODL, INISCL, LUNP,FINDP, IPCNT, PAGE,
     *   NACROS, NPARMS
C
      COMMON /CANIN/ XB, YB, ZB, ORBITA, JDREF, AFREQ, GST0, ARRLON,
     *   OBSRA, OBSDEC, IATUTC, UT1XXX, NANT, IORBIT
      COMMON /COMPS/ CCPOS, SFLUX, GAUSA, GAUSB, GAUSC, DOGAUS, DOSPHE,
     *   NUMCC
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAM2IN, CLA2IN, XSTOK, STANAM,
     *   XSOUR, XCALCO, OPCODE, OUTEXT, TITL1, TITL2
LOCAL END
LOCAL INCLUDE 'CLAVER.INC'
      LOGICAL   GOTDAT
      INTEGER   COUNT(3,MAXTRP), COUNT1(3,MAXTRP), COUNTC(MAXTRP),
     *   CNTTIM, IVSCNT
      REAL      SUMTIM, WORK(4,3,MAXTRP), WORKC(4,MAXTRP),
     *   GAMP(3,MAXTRP), GERR(3,MAXTRP), TLAST, DTUTC, UVW(3,3,MAXTRP)
      COMMON /CLAVG/ COUNT, COUNT1, COUNTC, WORK, WORKC, GAMP, GERR,
     *   UVW, TLAST, DTUTC, IVSCNT, GOTDAT, CNTTIM, SUMTIM
LOCAL END
      PROGRAM CLPLT
C-----------------------------------------------------------------------
C! Plots selected uv data and model values.
C# UV Plot-appl VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2012, 2014-2016, 2018, 2020, 2022-2023, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CLPLT plots uv data . A 'PL' extension file is made which can
C   be displayed in the usual ways .
C   Inputs:
C     USERID                       UV data file owner # ignored
C     INNAME         NAMEIN        Name of input UV data.
C     INCLASS        CLAIN         Class of input UV data.
C     INSEQ          SEQIN         Seq. of input UV data.
C     INDISK         DISKIN        Disk number of input UV data.
C     IN2NAME        NAM2IN        CLEAN components file name.
C     IN2CLASS       CLA2IN        CLEAN components file class.
C     IN2SEQ         XS2IN         CLEAN components file sequence no.
C     IN2DISK        XDI2IN        CLEAN components file disk no.
C     IN2VERS        XINV2         CLEAN components file version no.
C     NMAPS          XNMAPS        Number of fields
C     NCOMP          XCOMP         Array of number of clean components;
C                                  one for each field.
C     BCHAN          BCHAN         Start channel for averaging
C     ECHAN          ECHAN         End channel for averaging
C     BIF            BIF           Start IF number for averaging
C     EIF            EIF           End IF number for averaging
C     XINC.......Skip this number of vis. records between plotting.
C     UVRANGE....Range of UV projected spacings to include (Klambda)
C     TIMERANG...Selection parameters:
C        1 = Start IAT day (day 0 = first day in data base)
C        2 = Start IAT hour
C        3 = Start IAT minute
C        4 = Start IAT second
C        5 = Stop IAT day (day 0 = first day in data base)
C        6 = Stop IAT hour
C        7 = Stop IAT minute
C        8 = Stop IAT second
C     STOKES....Stokes' type
C     ANTENNAS..Antenna numbers
C     YTYPE.....If > 0, plot error bars
C     BPARM......Control parameters:
C        1 = type of X-axis (where  1 = amplitude (Jy), 2 = phase
C           (degrees), 3 = u,v distance (klambda), 4 = u,v p.a.
C           (degrees, clockwise from v-axis), 5 = time (iat days),
C           6 = u, 7 = v, 8 = w (all in klambda), 9 = real part (Jy),
C           10 = imaginary part(Jy), and 11 = folded G.S.T.(hours),
C           12 = time (IAT hms), 13 = source no.,
C           14 = freqid, 15 = int. time, 16 = weight) 0 => 12
C        2 = type of Y-axis
C        3 = Do not autoscale if non-zero, use following values:
C        4 = Minimum of X-axis,
C        5 = Maximum of X-axis,
C        6 = Minimum of Y-axis.
C        7 = Maximum of Y-axis,
C        8 = Maximum number of plots per page (min 1)
C        9 = Interferometer type (where 0 = VLBI, 1 = VLA,
C            2 = MERLIN, 3 = WSRT)
C       10 > 0  => plot missing baselines (if there's a model)
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, MAXPLT
      INCLUDE 'CLPLT.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'CLPLT '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL VBPIN (PRGM, MAXPLT, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Scaling
      CALL SCALCL (IRET)
      IF (IRET.NE.0) GO TO 995
C
      CALL CLPLOT (MAXPLT, IRET)
      IRET = MAX (0, IRET)
C                                       Close down
 995  CALL DIE (IRET, OBUFF)
C
 999  STOP
      END
      SUBROUTINE VBPIN (PRGM, MAXPLT, JERR)
C-----------------------------------------------------------------------
C   VBPIN gets input parameters for CLPLT .
C   Inputs:  PRGM   C*6       Program name
C   Output:  JERR   I         Error code: 0 => ok, else quit
C            MAXPLT I         Maximum number of plots per page.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, UTYPE*2, STAT*4, ALSTOK(12)*4
      INTEGER  JERR, MAXPLT, IERR, LIM1, IUSER, I, VER, L, J, MXANT,
     *   MXTRI, IROUND, LUN
      REAL      CATR(256), EPS
      LOGICAL   DOMDL, MATCH, TRYMOD
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'CLPLT.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      EQUIVALENCE (CATR, CATBLK)
      DATA MXANT /MAXANT/
      DATA MXTRI /MAXTRP/
      DATA ALSTOK /'I','Q','U','V','RR','LL','RL','LR','VV','HH','VH',
     *   'HV'/
C-----------------------------------------------------------------------
C                                       Init IO et al.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      CALL SELINI
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
      LUNP = 0
      FINDP = 0
C                                       Get input parameters.
      NPARMS = 149 + MAXAFL
      CALL GTPARM (PRGM, NPARMS, RQUICK, USERID, OBUFF, IERR)
      XSUBA = MAX (XSUBA, 1.0)
      IF (IERR.NE.0) THEN
         JERR = 8
         RQUICK = .TRUE.
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, OBUFF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      EPS = 0.1
      USERID = NLUSER
      IUSER = NLUSER
      IF (XINC.LT.1.0) XINC = 1.0
      INC = XINC + EPS
      SEQIN = XSIN + EPS
      DISKIN = XDISIN + EPS
      ISUB = IROUND (XSUBA)
      IF (ISUB.NE.-1) ISUB = MAX (1, ISUB)
      ISUB = MAX (0, ISUB)
      SUBARR = ISUB
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
C                                       Check SOLINT
      IF (XSOLIN.EQ.0.0) THEN
         XSOLIN = 5.0
         WRITE (MSGTXT,1020)
         CALL MSGWRT (3)
         END IF
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAM2I, NAM2IN)
      CALL H2CHR (6, 1, XCLA2I, CLA2IN)
      CALL H2CHR (4, 1, XXSTOK, XSTOK)
      CALL H2CHR (4, 1, XXCALC, XCALCO)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      CALL H2CHR (48, 1, XOUTXT, OUTEXT)
      DO 10 I = 1,12
         IF (XSTOK.EQ.ALSTOK(I)) GO TO 15
 10      CONTINUE
      XSTOK = 'I'
 15   STOKES = XSTOK
      CALL CHR2H (4, XSTOK, 1, XXSTOK)
      IF (OPCODE.NE.'INDE') OPCODE = 'CLOS'
      TRYMOD = ((NAM2IN(1:4).NE.' ') .OR. (CLA2IN.NE.' '))
      IF (OUTEXT.EQ.' ') THEN
         DOCRT = 0.0
      ELSE IF (DOCRT.GT.0.0) THEN
         DOCRT = -1.0
         END IF
C                                       Timerange
      TBEG = XTIME(1) + (XTIME(2)+(XTIME(3)+XTIME(4)/60.)/60.)/24.
      TFIN = XTIME(5) + (XTIME(6)+(XTIME(7)+XTIME(8)/60.)/60.)/24.
C                                       Test time, UV ranges
      IF (TFIN.LE.TBEG) TFIN = 1.0E10
      IF (UVRANG(2).LE.UVRANG(1)) UVRANG(2) = 1.0E10
      NOUVR = ABS (UVRANG(2) - UVRANG(1)) .LT. 0.01
      UVRANG(1) = UVRANG(1) * 1.0E3
      UVRANG(2) = UVRANG(2) * 1.0E3
C                                       Test type of plot
      IF (BPARM(1).NE.2.0) BPARM(1) = 3
      BPARM(2) = 1.0
      IF (BPARM(1).EQ.3) THEN
         BPARM(4) = BPARM(4) * 1.0E3
         BPARM(5) = BPARM(5) * 1.0E3
         END IF
      XYSCL(1) = -1.0E10
      XYSCL(2) = XYSCL(1)
      XYOFF(1) = 1.E10
      XYOFF(2) = XYOFF(1)
      LIM1 = MXANT - 1
      DO 37 I = 1,LIM1
         L = I+1
         DO 36 J = L,MXANT
            XYVALS(I,J) = XYSCL(2)
            XYVALS(J,I) = XYOFF(2)
            OKDAT(I,J) = 1
            OKDAT(J,I) = 1
 36         CONTINUE
 37      CONTINUE
      DECICL = .FALSE.
      DO 38 I = 1, MXTRI
         XYCLOS(1,I) = XYSCL(2)
         XYCLOS(2,I) = XYOFF(2)
 38      CONTINUE
C                                       Check for independent
C                                       closure phases
      INDECL = .FALSE.
      IF (OPCODE.EQ.'INDE') THEN
         INDECL = .TRUE.
         DO 40 I = 1,50
            IF (XANT(I).NE.0.0) INDECL = .FALSE.
 40         CONTINUE
         IF (.NOT.INDECL) THEN
            WRITE (MSGTXT,1080)
            CALL MSGWRT (6)
            WRITE (MSGTXT,1090)
            JERR = 1
            GO TO 990
            END IF
         OPCODE = 'CLOS'
         END IF
C                                       Autoscale ?
      SCALEM(1) = (BPARM(3).LE.0.0) .OR. (BPARM(4).EQ.BPARM(5))
      SCALEM(2) = (BPARM(3).LE.0.0) .OR. (BPARM(6).EQ.BPARM(7))
      DROPEM = (BPARM(9).LE.0.0)
      TESTEM(1) = 1
      IF (BPARM(4).GT.BPARM(5)) TESTEM(1) = -1
      IF ((BPARM(3).EQ.0.0) .OR. (BPARM(4).EQ.BPARM(5))) TESTEM(1) = 0
      TESTEM(2) = 1
      IF (BPARM(6).GT.BPARM(7)) TESTEM(2) = -1
      IF ((BPARM(3).EQ.0.0) .OR. (BPARM(6).EQ.BPARM(7))) TESTEM(2) = 0
      FLOTEM = (BPARM(3).EQ.0.0) .AND. (TESTEM(2).EQ.0)
      CALL RCOPY (4, BPARM(4), INISCL)
C                                       TV and label parms
      XNPNTS = MAX (200., MIN (1000., XNPNTS))
      DOERRB = YTYPE.GT.0.0
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
      LABEL = IROUND (XLABEL)
      LTYPE = MOD (ABS(LABEL), 100)
      IF ((LTYPE.EQ.0) .OR. (LTYPE.GT.10)) LTYPE = 3
      IF (LTYPE.GT.7) LTYPE = 7
      IF ((LTYPE.GE.4) .AND. (LTYPE.LE.6)) LTYPE = 3
      IF (LABEL.LT.0) THEN
         LABEL = (LABEL/100)*100 - LTYPE
      ELSE
         LABEL = (LABEL/100)*100 + LTYPE
         END IF
      XLABEL = LABEL
C                                       Get CATBLK from file.
      LUNI = 16
      UTYPE = 'UV'
      OLDCNO = 1
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   IUSER, STAT, OBUFF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1030) JERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      IUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', OBUFF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 1
      XSIN = SEQIN
      XDISIN = DISKIN
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      CALL COPY (256, CATBLK, CATKEP)
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      IUDISK = UDISK
      IUCNO = OLDCNO
      NSRC = 0
      CALL H2CHR (16, 1, XXSOUR, SOURCS(1))
      IF (SOURCS(1)(1:4).NE.'    ') NSRC = NSRC + 1
      SELQUA = IROUND (XQUAL)
      SELCOD = XCALCO
      CALL RCOPY (8, XTIME, TIMRNG)
      CALL RCOPY (2, UVRANG, UVRNG)
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOPOL = IROUND (XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      BLVER = IROUND (XBLVER)
      FGVER = IROUND (XFLAG)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BPVER = IROUND (XBPVER)
      DOBAND = IROUND (XDOBND)
C                                       Spectral smoothing
      CALL RCOPY (3, XSMOTH, SMOOTH)
C                                       Multi-source
      CALL MULSDB (CATBLK, MULTI)
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1070)
         JERR = 1
         CALL MSGWRT (6)
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       Test channel #
      BCHAN = IROUND (XBCHAN)
      BCHAN = MAX (1, MIN (BCHAN, CATBLK(KINAX+JLOCF)))
      ECHAN = IROUND (XECHAN)
      IF (ECHAN.LT.BCHAN) ECHAN = CATBLK(KINAX+JLOCF)
      ECHAN = MAX (1, MIN (ECHAN, CATBLK(KINAX+JLOCF)))
      IF (ECHAN.GT.BCHAN) THEN
         WRITE (MSGTXT,1040) BCHAN, ECHAN
         CALL MSGWRT (2)
         END IF
      CALL FILL (30, 0, CHNSEL)
      CHNSEL(1,1) = 1
      CHNSEL(2,1) = CATBLK(KINAX+JLOCF)
      XBCHAN = BCHAN
      XECHAN = ECHAN
C                                       IF number
      IF (JLOCIF.GE.0) THEN
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, CATBLK(KINAX+JLOCIF)))
         EIF = IROUND (XEIF)
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         EIF = MAX (1, MIN (EIF, CATBLK(KINAX+JLOCIF)))
      ELSE
         BIF = 1
         EIF = 1
         END IF
      IF (EIF.GT.BIF) THEN
         WRITE (MSGTXT,1050) BIF, EIF
         CALL MSGWRT (2)
         END IF
      XBIF = BIF
      XEIF = EIF
      IBIF = BIF
C                                       Save results in input Parms
      TYPEAX(1) = BPARM(1) + EPS
      TYPEAX(2) = BPARM(2) + EPS
      DOMDL = .TRUE.
      DOMODL = IROUND (XNMAP)
C                                       Block model when can't handle
      IF (DOMODL.LT.0) THEN
         DOMODL = 1
      ELSE IF (DOMODL.GT.0) THEN
         DOMODL = 2
      ELSE
         DOMDL = .FALSE.
         END IF
      IF (DOMDL .AND. MULTI .AND. (NSRC.NE.1)) THEN
         IF (TRYMOD) THEN
            WRITE (MSGTXT,1110)
            CALL MSGWRT (6)
            WRITE (MSGTXT,1120)
            CALL MSGWRT (6)
            WRITE (MSGTXT,1130)
            CALL MSGWRT (6)
            DOMDL = .FALSE.
            END IF
         END IF
      IF (.NOT. DOMDL) THEN
         DROPEM = .TRUE.
         NUMCC = 0
         END IF
C                                       Maximum number of plots per page
      MAXPLT = 3
      IF (BPARM(8).GE.0.95) MAXPLT = BPARM(8) + EPS
      BPARM(8) = MAXPLT
C                                       Get antenna info.
      VER = XSUBA + 0.01
      CALL ANTIN (VER, BCHAN, IBIF, DISKIN, OLDCNO, FRQSEL, JERR)
      IF (JERR.NE.0) GO TO 999
      XSUBA = VER
C                                       Get CLEAN components.
      VER2 = XINV2 + 0.01
      IF (DOMDL) THEN
         IF (MULTI .AND. TRYMOD) THEN
            MSGTXT = 'WARNING: You are attempting to plot a' //
     *         ' model against'
            CALL MSGWRT (6)
            MSGTXT = '         multi-source data, make sure' //
     *         ' you select the'
            CALL MSGWRT (6)
            MSGTXT = '         correct source and CC file.'
            CALL MSGWRT (6)
            CALL SOURNU (SOURCS, SELQUA, 1, DISKIN, OLDCNO, NSRC,
     *         BUFF1, IDN, JERR)
            IF (JERR.LT.0) THEN
               MSGTXT = 'REQUESTED SOURCE NOT FOUND'
               CALL MSGWRT (7)
               JERR = 5
               END IF
            IF (JERR.NE.0) GO TO 999
            CALL GETSOU (IDN(1), DISKIN, OLDCNO, CATBLK, LUN, JERR)
            RA = RAEPO * RAD2DG
            DEC = DECEPO * RAD2DG
            END IF
         CALL REEDIN (VER2, JERR)
         END IF
      IF (NUMCC.LE.0) THEN
         DROPEM = .TRUE.
         DOMODL = 0
         END IF
      XINV2 = VER2
      GO TO 999
C
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VBPIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1020 FORMAT ('VBPIN: SOLINT was 0, resetting to 5 minutes')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1040 FORMAT ('Averaging from channel ',I4,'-',I4)
 1050 FORMAT ('Averaging from IF ',I4,'-',I4)
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
 1080 FORMAT ('Trying to plot indep. cl. phases, but TRIANGLE is ',
     *   'non - zero')
 1090 FORMAT ('Set TRIANGLE adverb array to 0')
 1110 FORMAT ('You may be trying to plot a model without specifying')
 1120 FORMAT ('a sourcename - I do not allow that and am switching')
 1130 FORMAT ('that option off.')
      END
      SUBROUTINE SCALCL (IRET)
C-----------------------------------------------------------------------
C   SCALCL determines the necessary triangle-based scalings from the
C   data.
C   IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INCLUDE 'CLPLT.INC'
      INTEGER   IRET, I, MXTRI, NUMVIS, XUMVIS, NUMTRP, CNT(3),
     *   CPTRIP(3,MAXTRP), TIME(8), NPOSS(MAXTRP), NCLOSE(MAXTRP), J, K,
     *   SCANUM, I1, I2, I3, ITRIPL, NEGANT, KIKANT(50), IROUND, INEG,
     *   KPLOT, IDOM
      REAL      RPARM(20), DT, SCANV(MAXTRP), CLERR(MAXTRP), TDAYS,
     *   SCANM(MAXTRP)
      LOGICAL   NOSCAL, KEEP, DOALCL, NUSCAN
      DOUBLE PRECISION GSEC, GMST, GAST, RATE
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA MXTRI /MAXTRP/
      DATA GSEC /1.0027375D0/
C-----------------------------------------------------------------------
      NOSCAL = (.NOT.SCALEM(1)) .AND. (.NOT.SCALEM(2))
      IRET = 0
      IF ((NOSCAL) .AND. (.NOT.DROPEM)) GO TO 999
      DOALCL = .TRUE.
      NEGANT = 0
      J = IROUND (XANT(1))
      IF (J.LT.0) NEGANT = 1
      IDOM = 0
      IF (DOMODL.EQ.2) IDOM = 2
      DO 10 I = 1,50
         J = IROUND (XANT(I))
         IF (J.NE.0) THEN
            IF (NEGANT.GT.0) THEN
               KIKANT(NEGANT) = ABS(J)
               NEGANT = NEGANT + 1
            ELSE
               IF (J.GT.0) DOALCL = .FALSE.
               END IF
            END IF
 10      CONTINUE
      NEGANT = MAX (0, NEGANT-1)
C                                        Determine the number of
C                                        triplets to be plotted.
      IF (.NOT.DOALCL) THEN
         CALL CLOSET (XANT, NUMTRP, CPTRIP, IRET)
         IF (IRET.NE.0) GO TO 999
C                                        All independent
      ELSE IF (INDECL) THEN
         CALL INDCLT (NANT, NUMTRP, CPTRIP, IRET)
         IF (IRET.NE.0) GO TO 999
C                                        Else plot them all
      ELSE
         I1 = NANT - 2
         I2 = NANT - 1
         I3 = NANT
         ITRIPL = 0
         DO 50 I = 1, I1
            DO 40 J = 2, I2
               IF (J.EQ.I) GO TO 40
               DO 30 K = 3, I3
                  IF ((K.EQ.J) .OR. (K.EQ.I)) GO TO 30
                  IF ((I.GT.J) .OR. (I.GT.K) .OR. (J.GT.K))
     *               GO TO 30
                  DO 20 INEG = 1, NEGANT
                     IF ((I.EQ.KIKANT(INEG)) .OR.
     *                  (J.EQ.KIKANT(INEG)) .OR.
     *                  (K.EQ.KIKANT(INEG))) GO TO 30
 20                  CONTINUE
                  IF (ITRIPL.LT.MXTRI) THEN
                     ITRIPL = ITRIPL + 1
                     CPTRIP(1,ITRIPL) = I
                     CPTRIP(2,ITRIPL) = J
                     CPTRIP(3,ITRIPL) = K
                     END IF
 30               CONTINUE
 40            CONTINUE
 50         CONTINUE
         NUMTRP = ITRIPL
         END IF
C
      IF (NUMTRP.GT.MXTRI) NUMTRP = MXTRI
      DO 60 I = 1,MXTRI
         NPOSS(I) = 0
         NCLOSE(I) = 0
         GOODCL(I) = 0
 60      CONTINUE
C                                       Init vis file for read.
      CALL UVGET ('INIT', RPARM, BUFF1, IRET)
      IF (IRET.EQ.-1) GO TO 200
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      UVSCAL = FREQ / UVFREQ
      NUMVIS = 0
      XUMVIS = 0
      TIMMIN = 1.0E10
      TIMMAX = -1.0E10
      DO 80 I = 1, MXTRI
         XYCLOS(1,I) = 1.0E10
         XYCLOS(2,I) = -1.0E10
 80      CONTINUE
C                                       Loop
      DT = XSOLIN / 1440.0
      IF (BPARM(1).EQ.2.0) THEN
         CALL GSTROT (JDREF, GMST, GAST, RATE)
         GAST = GAST * (24.D0/360.D0)
         GAST = MOD (GAST, 24.D0)
         END IF
C
 100  CONTINUE
C                                       Read vis. record and form
C                                       closure phase
         CALL CLOSAV (NUMVIS, NUMTRP, CPTRIP, DT, SCANV, CLERR, CNT,
     *      DOERRB, TIME, TDAYS, NUSCAN, SCANUM, RPARM, UVSCAL, BUFF1,
     *      NPOSS, NCLOSE, IDOM, SCANM, IRET)
         IF (IRET.EQ.-2) GO TO 100
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1100) IRET
            IRET = 4
            GO TO 990
            END IF
         IF (BPARM(1).EQ.2.0) THEN
            TDAYS = TDAYS * 24.0
            TDAYS = GAST + TDAYS * GSEC
            TDAYS = MOD (TDAYS, 24.0)
            TDAYS = TDAYS / 24.0
            END IF
         TIMMIN = MIN (TDAYS,TIMMIN)
         TIMMAX = MAX (TDAYS,TIMMAX)
C                                       Pick up some points
         NUMVIS = NUMVIS + 1
         KEEP = MOD(NUMVIS,INC) .EQ. 0
         IF (.NOT. KEEP) GO TO 100
C                                       Find scales
         IF (.NOT.NOSCAL) THEN
            DO 120 J = 1, NUMTRP
               IF (CLERR(J).EQ.FBLANK) CLERR(J) = 0.0
               IF (SCANV(J).NE.FBLANK) THEN
                  XYCLOS(1,J) = MIN (XYCLOS(1,J),SCANV(J)-CLERR(J))
                  XYCLOS(2,J) = MAX (XYCLOS(2,J),SCANV(J)+CLERR(J))
                  IF (DOMODL.EQ.2) THEN
                     XYCLOS(1,J) = MIN (XYCLOS(1,J),SCANM(J))
                     XYCLOS(2,J) = MAX (XYCLOS(2,J),SCANM(J))
                     END IF
                  END IF
 120           CONTINUE
            END IF
         XUMVIS = XUMVIS + 1
         IF (IRET.EQ.0) GO TO 100
C                                       Any points found
 200  IF (NOSCAL) GO TO 220
      IF (XUMVIS.LT.1) THEN
         IRET = 4
         WRITE (MSGTXT,1200) XUMVIS
         GO TO 990
         END IF
C
 220  IRET = 0
      CALL UVGET ('CLOS', RPARM, BUFF1, IRET)
      CALL COPY (256, CATKEP, CATBLK)
      XYOFF(1) = TIMMIN - 2 * ABS(DT) - 0.025 * (TIMMAX - TIMMIN)
      XYSCL(1) = TIMMAX + 2 * ABS(DT) + 0.025 * (TIMMAX - TIMMIN)
      CALL COPY (MXTRI, NCLOSE, GOODCL)
      DECICL = .TRUE.
      KPLOT = 0
      DO 250 I = 1,NUMTRP
         IF (GOODCL(I).GT.0) KPLOT = KPLOT + 1
 250     CONTINUE
      IF (INDECL) THEN
         WRITE (MSGTXT,1110) KPLOT
      ELSE
         WRITE (MSGTXT,1120) KPLOT
         END IF
      CALL MSGWRT (6)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SCALCL: ERROR',I3,' INIT VIS FILE')
 1100 FORMAT ('SCALCL: ERROR',I3,' READING VIS FILE')
 1110 FORMAT (I5,' closure triangles contain data, all independent')
 1120 FORMAT (I5,' closure triangles contain data, ',
     *   'may be not all independent')
 1200 FORMAT ('FOUND',I4,' POINTS: NOT ENOUGH TO SELF-SCALE')
      END
      SUBROUTINE CLPLOT (MAXPLT, IRET)
C-----------------------------------------------------------------------
C   CLPLOT plots the closure phases thru calls to PLOTCL.
C   Inputs:
C      MAXPLT    I    The maximum number of plots per page.
C   Outputs:
C      IRET      I     Error code, 0=>OK otherwise failed.
C-----------------------------------------------------------------------
      INCLUDE 'CLPLT.INC'
      INTEGER   MAXPLT, IRET, IPLOT, NUMTRP, CPTRIP(3,MAXTRP), I, J, K,
     *   I1, I2, I3, ITRIPL, MXTRI, NEGANT, KIKANT(50), IROUND, INEG,
     *   PLOTBF(256)
      REAL      DMS, DMO
      LOGICAL   DOALCL, CLOSED
      DATA MXTRI /MAXTRP/
C-----------------------------------------------------------------------
      IRET = 0
      IPLOT = 0
      DMS = XYSCL(2)
      DMO = XYOFF(2)
      DOALCL = .TRUE.
      NEGANT = 0
      J = IROUND (XANT(1))
      IF (J.LT.0) NEGANT = 1
      DO 10 I = 1,50
         J = IROUND (XANT(I))
         IF (J.NE.0) THEN
            IF (NEGANT.GT.0) THEN
               KIKANT(NEGANT) = ABS(J)
               NEGANT = NEGANT + 1
            ELSE
               IF (J.GT.0) DOALCL = .FALSE.
               END IF
            END IF
 10      CONTINUE
      NEGANT = MAX (0, NEGANT-1)
C                                        Determine the number of
C                                        triplets to be plotted.
      IF (.NOT.DOALCL) THEN
         CALL CLOSET (XANT, NUMTRP, CPTRIP, IRET)
         IF (IRET.NE.0) GO TO 999
C                                        All independent
      ELSE IF (INDECL) THEN
         CALL INDCLT (NANT, NUMTRP, CPTRIP, IRET)
         IF (IRET.NE.0) GO TO 999
C                                        Else plot them all
      ELSE
         I1 = NANT - 2
         I2 = NANT - 1
         I3 = NANT
         ITRIPL = 0
         DO 50 I = 1, I1
            DO 40 J = 2, I2
               IF (J.EQ.I) GO TO 40
               DO 30 K = 3, I3
                  IF ((K.EQ.J) .OR. (K.EQ.I)) GO TO 30
                  IF ((I.GT.J) .OR. (I.GT.K) .OR. (J.GT.K)) GO TO 30
                  DO 20 INEG = 1, NEGANT
                     IF ((I.EQ.KIKANT(INEG)) .OR.
     *                  (J.EQ.KIKANT(INEG)) .OR.
     *                  (K.EQ.KIKANT(INEG))) GO TO 30
 20                  CONTINUE
                  IF (ITRIPL.LT.MXTRI) THEN
                     ITRIPL = ITRIPL + 1
                     CPTRIP(1,ITRIPL) = I
                     CPTRIP(2,ITRIPL) = J
                     CPTRIP(3,ITRIPL) = K
                     END IF
 30               CONTINUE
 40            CONTINUE
 50         CONTINUE
         NUMTRP = ITRIPL
         IF (NUMTRP.GT.MXTRI) NUMTRP = MXTRI
         END IF
C                                       eliminate empty triplets
      J = 0
      DO 60 I = 1,NUMTRP
         IF ((GOODCL(I).GT.0) .AND. ((ABS(XYCLOS(1,I)).GE.PHSMIN)
     *      .OR. (ABS(XYCLOS(2,I)).GE.PHSMIN))) THEN
            J = J + 1
            GOODCL(J) = GOODCL(I)
            XYCLOS(1,J) = XYCLOS(1,I)
            XYCLOS(2,J) = XYCLOS(2,I)
            CALL COPY (3, CPTRIP(1,I), CPTRIP(1,J))
            END IF
 60      CONTINUE
      NUMTRP = J
 70   IF (MAXPLT.GT.1) THEN
         J = (NUMTRP-1)/MAXPLT + 1
         I = (NUMTRP-1)/(MAXPLT-1) + 1
         IF (I.EQ.J) THEN
            MAXPLT = MAXPLT - 1
            GO TO 70
            END IF
         END IF
C                                       Loop print over the triplets.
      DO 90 I = 1,NUMTRP
         IF (DOCRT.LT.0.0) THEN
            IF ((GOODCL(I).GT.0) .AND. ((ABS(XYCLOS(1,I)).GE.PHSMIN)
     *         .OR. (ABS(XYCLOS(2,I)).GE.PHSMIN))) THEN
               IPLOT = MOD (IPLOT, MAXPLT) + 1
               IF (I.EQ.NUMTRP) IPLOT = -IPLOT
               CALL PRTCL (IPLOT, DMS, DMO, I, CPTRIP(1,I), IRET)
               IF (IRET.GT.0) GO TO 900
               END IF
            END IF
 90      CONTINUE
C                                       Loop over the triplets.
      IPLOT = 0
      DO 100 I = 1,NUMTRP
         IF ((GOODCL(I).GT.0) .AND. ((ABS(XYCLOS(1,I)).GE.PHSMIN)
     *      .OR. (ABS(XYCLOS(2,I)).GE.PHSMIN))) THEN
            IPLOT = MOD (IPLOT, MAXPLT) + 1
            IF (I.EQ.NUMTRP) IPLOT = -IPLOT
            CALL PLOTCL (IPLOT, MAXPLT, DMS, DMO, I, CPTRIP(1,I),
     *         CLOSED, PLOTBF, IRET)
            IF (IRET.NE.0) GO TO 900
            END IF
 100     CONTINUE
C
 900  IF (.NOT.CLOSED) CALL GFINIS (PLOTBF, IRET)
      IF (LUNP.GT.0) CALL LPCLOS (LUNP, FINDP, IPCNT, I)
      GO TO 999
C
 999  RETURN
      END
      SUBROUTINE PRTCL (IPLOT, DMS, DMO, PLTTRP, CPTRIP, IRET)
C-----------------------------------------------------------------------
C   PRTCL print closures one panel at a time.
C   Input:
C      IPLOT    I    Plot number on current page. If negative then this
C                    the last plot.
C      PLTTRP   I    The number of the triplet being plotted
C      CPTRIP   I(3) The 3 antennas of the triplet
C   In/out:           (Changed to user value on .not.scalem(2))
C      DMS      I    Scaling parameter for max y range
C      DMO      I    Low value parm for max y range
C   Output:
C      IRET     I    Return code, 0 => OK, otherwise abort.
C                          1 => failed to add to catalog
C                          2 => failed to create
C                          3 => graph file write error
C                          4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   MAXMOD
      PARAMETER (MAXMOD = 1000)
C
      INCLUDE 'CLPLT.INC'
      CHARACTER TEXT*132, AUNITS(3)*20, POLLAB*5, SCRTCH*132, LINE*132,
     *   TEXT2*12
      HOLLERITH CATH(256)
      INTEGER   IRET, IPLOT, IERR, INP, IARRW, IMODEL, NUMVIS, NUMTRP,
     *   CPTRIP(3), TIME(8), NPOSS(MAXTRP), NCLOSE(MAXTRP), PLTTRP,
     *   TRIANG(3,MAXTRP), SCRBUF(256), ITT(4), CNT(3), SCANUM, I
      REAL      CATR(256), RPARM(20), DMS, DMO, TDAYS, DT,
     *   SCANV(MAXTRP), CLERR(MAXTRP), SCANM(1)
      DOUBLE PRECISION DTORAD, GSEC, GMST, GAST, RATE
      LOGICAL   T, CATUP, KEEP, NUSCAN, DONE, FIRST
      INCLUDE 'CLAVER.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DGPH.INC'
      EQUIVALENCE (CATUV, CATR, CATH)
      DATA AUNITS /'Degrees ', 'GST days', 'IAT hours'/
      DATA GSEC /1.0027375D0/
C-----------------------------------------------------------------------
      FIRST = .FALSE.
      IF ((DOCRT.NE.0.0) .AND. (LUNP.EQ.0)) THEN
         PAGE = 0
         IPCNT = 999
         CALL LPOPEN (OUTEXT, DOCRT, LUNP, FINDP, NACROS, SCRBUF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET
            CALL MSGWRT (8)
            DOCRT = 0.0
            GO TO 999
            END IF
         FIRST = .TRUE.
         END IF
C                                       reset antenna list
      CALL FILL (MAXANT, 0, ANTENS)
      CALL COPY (3, CPTRIP, ANTENS)
      DONE = .FALSE.
      TITL1 = ' '
      TITL2 = ' '
      IF ((DOCRT.NE.0.0) .AND. (FIRST)) THEN
         IF (DOCRT.GT.-2.5) THEN
            IPCNT = 998
            WRITE (LINE,1001) NAMEIN, CLAIN, SEQIN, DISKIN, NLUSER
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 990
            LINE = ' '
            IF (DOCRT.NE.0.0) THEN
               CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *            LINE, IPCNT, PAGE, SCRTCH, IRET)
               IF (IRET.NE.0) GO TO 990
               END IF
            END IF
         END IF
      WRITE (TITL1,1005)
      IF (.NOT.DOERRB) TITL1(51:) = ' '
      TITL2 = ' '
      TITL2(44:) = 'Degrees'
      IF (DOERRB) TITL2(54:) = 'Degrees'
      IF (FIRST) THEN
         LINE = TITL1
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         LINE = TITL2
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
      ELSE
         IPCNT = 998
         END IF
C                                       Write triangle name on plot.
      IF (.NOT.FIRST) THEN
         LINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *      LINE, IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
      FIRST = .FALSE.
      TEXT = STANAM(CPTRIP(1))(1:8) // '-' //
     *   STANAM(CPTRIP(2))(1:8) // '-' // STANAM(CPTRIP(3))(1:8)
      CALL DEFRMT (TEXT, ' ', INP)
      WRITE (TEXT2,1110) CPTRIP
      CALL DEFRMT (TEXT2, ' ', I)
      LINE = TEXT(:INP) // '   ' // TEXT2(:I)
      CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *   LINE, IPCNT, PAGE, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 990
      CALL UVGET ('INIT', RPARM, BUFF1, IERR)
      CALL RFILL (20, 0.0, RPARM)
      RPARM(1) = FBLANK
      XSTOK = STOKES
      IBIF = BIF
      IF (IERR.EQ.-1) GO TO 200
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         CALL MSGWRT (8)
         IRET = 4
         GO TO 999
         END IF
      UVSCAL = FREQ / UVFREQ
      DTORAD = 3.14159265358979326D0 / 180.0D0
      CATUP = T
      IARRW = ISUB
      IMODEL = 0
      IRET = 1
C                                       User sets the scales
      DT = XSOLIN / 1440.0
C                                       Determine STOKES label
      POLLAB = XSTOK
      IRET = 3
      CATUP = T
C                                       Only label Y axis once.
      NUMVIS = 0
C                                       Set up for closure phases
      NUMTRP = 1
      TRIANG(1,1) = CPTRIP(1)
      TRIANG(2,1) = CPTRIP(2)
      TRIANG(3,1) = CPTRIP(3)
      NPOSS(1) = 0
      NCLOSE(1) = 0
C                                       GST plotting?
      IF (BPARM(1).EQ.2.0) THEN
         CALL GSTROT (JDREF, GMST, GAST, RATE)
         GAST = GAST * (24.D0/360.D0)
         GAST = MOD (GAST, 24.D0)
         END IF
C                                       LOOP
 100  CONTINUE
C                                       Read vis. record and form
C                                       closure phase
         CALL CLOSAV (NUMVIS, NUMTRP, TRIANG, DT, SCANV, CLERR, CNT,
     *      DOERRB, TIME, TDAYS, NUSCAN, SCANUM, RPARM, UVSCAL, BUFF1,
     *      NPOSS, NCLOSE, DOMODL, SCANM, IERR)
         IF (IERR.EQ.-2) GO TO 100
         DONE = IERR.LT.0
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1100) IERR
            CALL MSGWRT (8)
            IRET = 4
            GO TO 999
            END IF
C
         NUMVIS = NUMVIS + 1
         KEEP = MOD(NUMVIS,INC) .EQ. 0
         IF ((.NOT.KEEP) .AND. (.NOT.DONE)) GO TO 100
C                                       Get and scale X, Y
         IF (BPARM(1).EQ.2.0) THEN
            TDAYS = TDAYS * 24.0
            TDAYS = GAST + TDAYS * GSEC
            TDAYS = MOD (TDAYS, 24.0)
            TDAYS = TDAYS / 24.0
            END IF
         IF (DOCRT.NE.0.0) THEN
            CALL TODHMS (TDAYS, ITT)
            IF ((SCANV(1).NE.FBLANK) .AND. (CLERR(1).NE.FBLANK)) THEN
               WRITE (LINE,1110) CPTRIP, ITT, CNT, SCANV(1), CLERR(1)
            ELSE IF (SCANV(1).NE.FBLANK) THEN
               WRITE (LINE,1111) CPTRIP, ITT, CNT, SCANV(1)
            ELSE
               WRITE (LINE,1112) CPTRIP, ITT, CNT
               END IF
            IF (.NOT.DOERRB) LINE(51:) = ' '
            CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *         LINE, IPCNT, PAGE, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 990
            END IF
         IF (.NOT.DONE) GO TO 100
C                                       plot the current bits of model
 200  CALL UVGET ('CLOS', RPARM, BUFF1, IERR)
      IRET = MIN (IERR, 0)
      GO TO 999
C
 990  DOCRT = 0.0
      IRET = MAX (0, IRET)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I4,' OPENING OUTPUT TEXT FILE')
 1001 FORMAT (A12,'.',A6,'.',I4,'  Vol=',I2,'  User=',I5)
 1005 FORMAT ('Triangle',8X,'Time',3X,8X,'Counts',3X,2X,'Cl phase',
     *   2X,'Cl error')
 1050 FORMAT ('PRTCL: ERROR',I3,' INIT VIS FILE')
 1100 FORMAT ('PRTCL: ERROR',I3,' READING VIS FILE')
 1110 FORMAT (2(I2.2,'-'),I2.2,3X,I3,'/',2(I2.2,':'),I2.2,2X,3I5,2F10.3)
 1111 FORMAT (2(I2.2,'-'),I2.2,3X,I3,'/',2(I2.2,':'),I2.2,2X,3I5,F10.3,
     *   6X,'INDE')
 1112 FORMAT (2(I2.2,'-'),I2.2,3X,I3,'/',2(I2.2,':'),I2.2,2X,3I5,
     *   2(6X,'INDE'))
      END
      SUBROUTINE PLOTCL (IPLOT, MAXPLT, DMS, DMO, PLTTRP, CPTRIP,
     *   CLOSED, BUFFER, IRET)
C-----------------------------------------------------------------------
C   PLOTCL plots closures one panel at a time.
C   Input:
C      IPLOT    I    Plot number on current page. If negative then this
C                    the last plot.
C      MAXPLT   I    The number of plots per page.
C      PLTTRP   I    The number of the triplet being plotted
C      CPTRIP   I(3) The 3 antennas of the triplet
C   In/out:           (Changed to user value on .not.scalem(2))
C      DMS      I    Scaling parameter for max y range
C      DMO      I    Low value parm for max y range
C      BUFFER   I(*) Plot buffer
C   Output:
C      CLOSED   L    Plot file has been closed
C      IRET     I    Return code, 0 => OK, otherwise abort.
C                          1 => failed to add to catalog
C                          2 => failed to create
C                          3 => graph file write error
C                          4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   MAXMOD
      PARAMETER (MAXMOD = 1000)
C
      INCLUDE 'CLPLT.INC'
      CHARACTER TEXT*132, PFILE*48, ATIME*8, CHTMP*18, UTYPE*2,
     *   ADATE*12, CTEMP*12, STAT*4, AUNITS(3)*20, CHTYPE(3)*8,
     *   POLLAB*5, CPSAVE*5
      HOLLERITH CATH(256)
      INTEGER   IRET, IPLOT, MAXPLT, I, IDUM, BUFFER(256), VER, IERR,
     *   ITYPE, IPSIZE, LUNPL, FINDPL, IAPARM(8), INCHAR, INP, J, IARRW,
     *   IAXLAB, IAPLOT, IT(3), ID(3), IMODEL, SVAXTP(2), NGOOD, NNOFIT,
     *   NUMVIS, NUMTRP, CPTRIP(3), TIME(8), NPOSS(MAXTRP),
     *   NCLOSE(MAXTRP), PLTTRP, TRIANG(3,MAXTRP), ISYM,
     *   CNT(3), SCANUM
      REAL      BLC(2), TRC(2), DX, DY, TR, TI, XY(2), CATR(256), SIZE,
     *   GGERR, RPARM(20), XTRC(2), XBLC(2), TLC(2), PLTINC, YYOFF(2),
     *   XYZ(2), DMS, DMO, XMULT(2), XMIN, XMAX, YMIN, YMAX, XTEMP,
     *   TDAYS, DT, SCANV(MAXTRP), CLERR(MAXTRP), AX(5), AY(5),
     *   SCANM(1), MODEL(2,MAXMOD), DYFAC
      DOUBLE PRECISION    TRA, TDEC, DTORAD, GSEC, GMST, GAST, RATE
      LOGICAL   T, F, GOOD, CATUP, KEEP, CHSTAT, NUSCAN, CLOSED, DO3C,
     *   DONE, FIRST
      INCLUDE 'CLAVER.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DGPH.INC'
      EQUIVALENCE (CATUV, CATR, CATH)
      SAVE CPSAVE
      DATA LUNPL /26/
      DATA T, F /.TRUE.,.FALSE./
      DATA AUNITS /'Degrees ', 'GST days', 'IAT hours'/
      DATA CHTYPE /'Phase', 'GST', 'Time'/
      DATA GSEC /1.0027375D0/
C-----------------------------------------------------------------------
      FIRST = .FALSE.
      CLOSED = F
      ISYM = XSYM + 0.5
      IF ((ISYM.LE.0) .OR. (ISYM.GT.24)) ISYM = 23
      IF (XFACT.LT.0.01) XFACT = 1.0
      DO3C = .FALSE.
C                                       reset antenna list
      CALL FILL (MAXANT, 0, ANTENS)
      CALL COPY (3, CPTRIP, ANTENS)
      DONE = .FALSE.
C                                       Init vis file for read.
      CALL UVGET ('INIT', RPARM, BUFF1, IERR)
      CALL RFILL (20, 0.0, RPARM)
      RPARM(1) = FBLANK
      XSTOK = STOKES
      IBIF = BIF
      IF (IERR.EQ.-1) GO TO 220
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         CALL MSGWRT (8)
         IRET = 4
         GO TO 970
         END IF
      UVSCAL = FREQ / UVFREQ
      DTORAD = 3.14159265358979326D0 / 180.0D0
      NGOOD = 0
      NNOFIT = 0
      CATUP = T
      IARRW = ISUB
      IMODEL = 0
C                                       Determine status of file
      IF (.NOT.DOTV) THEN
         UTYPE = 'UV'
         CALL CATDIR ('INFO', DISKIN, OLDCNO, CTEMP, CTEMP, IDUM,
     *      UTYPE, IDUM, STAT, OBUFF, IRET)
C                                       Change status
         CHSTAT = (STAT.NE.'WRIT')
         IF (CHSTAT) CALL STATCH (STAT, 'WRIT', DISKIN, OLDCNO, UTYPE,
     *      OBUFF, IRET)
         END IF
      IRET = 1
C                                       User sets the scales
      DT = XSOLIN / 1440.0
      PLTINC = 1000. / MAXPLT
      XYOFF(1) = TIMMIN
      XYSCL(1) = TIMMAX
      IF (XYCLOS(2,PLTTRP).GT.165.) XYCLOS(2,PLTTRP) = 180.
      IF (XYCLOS(1,PLTTRP).LT.-165.) XYCLOS(1,PLTTRP) = -180.
      XYOFF(2) = XYCLOS(1,PLTTRP)
      XYSCL(2) = XYCLOS(2,PLTTRP)
      IF ((XYOFF(2).GT.1000.0) .OR. (XYSCL(2).LT.-1000.0)) THEN
         XYOFF(2) = -180.0
         XYSCL(2) = 180.0
         END IF
      DO 10 I = 1,2
         IF (.NOT.SCALEM(I)) THEN
            XYSCL(I) = INISCL(2*I)
            XYOFF(I) = INISCL(2*I-1)
            END IF
C                                                  only 1 sample
         IF (XYSCL(I).EQ.XYOFF(I)) THEN
            IF (I.EQ.1) THEN
               DX = 0.5/2880.0
               XYOFF(I) = XYOFF(I) - DX
               XYSCL(I) = XYSCL(I) + DX
            ELSE
               XYOFF(I) = XYOFF(I) - 0.5
               XYSCL(I) = XYSCL(I) + 0.5
               END IF
            END IF
         DX = XYSCL(I) - XYOFF(I)
         IF (I.EQ.1) THEN
            XYOFF(I) = XYOFF(I) - ABS(DT)/3.0 - 0.025 * DX
            XYSCL(I) = XYSCL(I) + ABS(DT)/3.0 + 0.025 * DX
            SIZE = 1000.
         ELSE
            XYOFF(I) = XYOFF(I) - MAX (0.2, 0.025 * DX)
            XYSCL(I) = XYSCL(I) + MAX (0.2, 0.025 * DX) + 0.05*DX
            SIZE = PLTINC
            END IF
         XYSCL(I) = SIZE / (XYSCL(I) - XYOFF(I))
         IF (I.GT.1) THEN
            DMS = XYSCL(I)
            DMO = XYOFF(I)
            END IF
 10      CONTINUE
C                                       Fill in last of actual parms
      BPARM(5) = 1000.0 / XYSCL(1) + XYOFF(1)
      BPARM(7) = PLTINC / XYSCL(2) + XYOFF(2)
      BPARM(4) = XYOFF(1)
      BPARM(6) = XYOFF(2)
      IF (FLOTEM) BPARM(6) = 0.0
      IF (FLOTEM) BPARM(7) = 0.0
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      CALL FILL (5, 1, IAPARM)
C                                       Set window for current plot.
      XBLC(1) = BLC(1)
      XBLC(2) = 1000.0 - ABS (IPLOT) * PLTINC
      XTRC(1) = TRC(1)
      XTRC(2) = XBLC(2) + PLTINC - 1.0
      TLC(1) = XBLC(1)
      TLC(2) = XTRC(2)
C                                       Offsets for current plot.
      YYOFF(1) = XBLC(1)
      YYOFF(2) = XBLC(2)
C                                       Set up location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      IF (TYPEAX(1).EQ.3) LABTYP(LOCNUM) = 7
      CALL COPY (2, TYPEAX, SVAXTP)
      AXTYP(LOCNUM) = 0
      IF (IPLOT.EQ.1) THEN
         TR = PLTINC / DMS
         TI = TR
         CPREF(2,LOCNUM) = ' '
         CALL METSCL (LABEL, TR, CPREF(2,LOCNUM), GOOD)
         CPSAVE = CPREF(2,LOCNUM)
         XMULT(2) = TR / TI
      ELSE
         CPREF(2,LOCNUM) = CPSAVE
         END IF
      TR = 1000. / XYSCL(1)
      TI = TR
      CPREF(1,LOCNUM) = ' '
      IF (TYPEAX(1).NE.3) THEN
         CALL METSCL (LABEL, TR, CPREF(1,LOCNUM), GOOD)
         XMULT(1) = TR / TI
      ELSE
         XMULT(1) = 360.0
         END IF
      DO 50 I = 1,2
         SIZE = 1000.0
         IF (I.EQ.2) SIZE = PLTINC
         TR = SIZE / XYSCL(I)
         RPLOC(I,LOCNUM) = XBLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I) * XMULT(I)
         AXINC(I,LOCNUM) = TR * XMULT(I) / (XTRC(I) - XBLC(I))
         CTYP(I,LOCNUM) = AUNITS(TYPEAX(I))
 50      CONTINUE
C                                       Determine STOKES label
      POLLAB = XSTOK
C                                       Create plot file
      IF (ABS (IPLOT).EQ.1) THEN
C                                       Update catalog header.
         VER = 0
         IF (.NOT.DOTV) THEN
            CALL MADDEX ('PL', DISKIN, OLDCNO, CATUV, BUFFER, CATUP,
     *         'WRIT', VER, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         CALL ZPHFIL ('PL', DISKIN, OLDCNO, VER, PFILE, IERR)
         IF (IERR.NE.0) GO TO 960
         IPSIZE = 0
         ITYPE = 22
         CALL GINIT (DISKIN, OLDCNO, PFILE, IPSIZE, ITYPE, NPARMS,
     *      USERID, DOTV, TVCHN, GRCHN, TVCORN, CATUV, BUFFER, LUNPL,
     *      FINDPL, IERR)
         IRET = 2
         IF (IERR.NE.0) GO TO 960
         CALL RFILL (4, 0.5, CHOUT)
C                                       Not fully initialized, may make
C                                       INP too large which is okay.
         CALL CHNTIC (XBLC, XTRC, INP)
         INP = MAX (INP, 3)
         IF (LTYPE.EQ.2) CHOUT(1) = 2.5
         IF (LTYPE.GT.2) CHOUT(1) = INP + 4
         IF (LTYPE.GT.1) CHOUT(2) = 2.0
         IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
         IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = 3.333
         IF ((LABEL.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = CHOUT(4) +
     *      1.333
C                                       default XYRATIO
         IF (XYRATO.LT.0.01) THEN
            IF (DOTV) THEN
               XMIN = WINDTV(3) - WINDTV(1) + 1 - CSIZTV(1) * (CHOUT(1)
     *            + CHOUT(3))
               YMIN = WINDTV(4) - WINDTV(2) + 1 - CSIZTV(2) * (CHOUT(2)
     *            + CHOUT(4))
               XYRATO = 1.0
               IF (YMIN.GT.0.0) XYRATO = XMIN / YMIN
            ELSE
               XYRATO = 1.0
               END IF
            END IF
C                                       Init for line drawing.
         IRET = 3
         CALL GINITL (BLC, TRC, XYRATO, CHOUT, IAPARM, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         IF (.NOT.DOTV) THEN
            WRITE (MSGTXT,1010) VER
            CALL MSGWRT (2)
            END IF
         END IF
      IRET = 3
      CATUP = T
C                                       Set max and min of axis
      XMAX = TRC(1) / XYSCL(1) + XYOFF(1)
      XMIN = BLC(1) / XYSCL(1) + XYOFF(1)
      YMAX = PLTINC / XYSCL(2) + XYOFF(2)
      YMIN = BLC(2) / XYSCL(2) + XYOFF(2)
C                                       Draw border
      CALL GLTYPE (1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Top labels: type & name
      IF ((ABS(IPLOT).EQ.1) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
C                                       Data information
         DX = 0.0
         DY = 0.5
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         WRITE (TEXT,1040) BIF, EIF, BCHAN, ECHAN, POLLAB, VER2
         CALL REFRMT (TEXT, ' ', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Plot type and file
         DY = DY + 1.333
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         TEXT = 'Closure Phase _vs_ ' // CHTYPE(TYPEAX(1))(:8) //
     *      ' for_'
         CHTMP = NAMEIN // CLAIN
         CALL NAMEST (CHTMP, CATUV(KIIMS), TEXT(37:), INCHAR)
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Date/time/version
         IF (LABEL.GT.1) THEN
            DY = DY + 1.333
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (TEXT,1030) VER, ADATE, ATIME
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
         END IF
C                                       Blank bottom label.
      IF ((IPLOT.GE.0) .AND. (ABS (IPLOT).NE.MAXPLT)) THEN
         CPREF(1,LOCNUM) = ' '
         CTYP(1,LOCNUM) = ' '
         END IF
C                                       Only label Y axis once.
      IAXLAB = MAXPLT / 2 + 1
      IAPLOT = ABS (IPLOT)
      IF ((IAPLOT.NE.IAXLAB) .AND. ((IPLOT.GE.0) .OR.
     *   (IAPLOT.GT.IAXLAB))) CPREF(2,LOCNUM) = '-1'
C                                       Put on labels and ticks
      CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XYRATO, F, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      NUMVIS = 0
C                                       Set up for closure phases
      NUMTRP = 1
      TRIANG(1,1) = CPTRIP(1)
      TRIANG(2,1) = CPTRIP(2)
      TRIANG(3,1) = CPTRIP(3)
      NPOSS(1) = 0
      NCLOSE(1) = 0
      DX = 5.0 * XFACT
      DY = 5.0 * XFACT
      IF (DX/XYRATO.LT.2.5) THEN
         DY = DY * XYRATO
         DYFAC = XYRATO
      ELSE
         DX = DX / XYRATO
         DYFAC = 1.0
         END IF
C                                       GST plotting?
      IF (BPARM(1).EQ.2.0) THEN
         CALL GSTROT (JDREF, GMST, GAST, RATE)
         GAST = GAST * (24.D0/360.D0)
         GAST = MOD (GAST, 24.D0)
         END IF
C                                       Loop
      CALL GLTYPE (4, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
 100  CONTINUE
C                                       Read vis. record and form
C                                       closure phase
         CALL CLOSAV (NUMVIS, NUMTRP, TRIANG, DT, SCANV, CLERR, CNT,
     *      DOERRB, TIME, TDAYS, NUSCAN, SCANUM, RPARM, UVSCAL, BUFF1,
     *      NPOSS, NCLOSE, DOMODL, SCANM, IERR)
         IF (IERR.EQ.-2) GO TO 100
         DONE = IERR.LT.0
C         IF (IERR.LT.0) THEN
C            DONE = .TRUE.
C            GO TO 200
C            END IF
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1100) IERR
            CALL MSGWRT (8)
            IRET = 4
            GO TO 970
            END IF
C
         NUMVIS = NUMVIS + 1
         KEEP = MOD(NUMVIS,INC) .EQ. 0
         IF ((.NOT.KEEP) .AND. (.NOT.DONE)) GO TO 100
C                                       Get and scale X, Y
         IF (BPARM(1).EQ.2.0) THEN
            TDAYS = TDAYS * 24.0
            TDAYS = GAST + TDAYS * GSEC
            TDAYS = MOD (TDAYS, 24.0)
            TDAYS = TDAYS / 24.0
            END IF
         IF (SCANV(1).EQ.FBLANK) THEN
            IF (.NOT.DONE) GO TO 100
            GO TO 200
            END IF
         XYZ(1) = TDAYS
         XYZ(2) = SCANV(1)
         IF (CLERR(1).EQ.FBLANK) CLERR(1) = 0.0
         IF (DOERRB) GGERR = CLERR(1) * XYSCL(2)
         DO 120 J = 1,2
            XY(J) = XYSCL(J) * (XYZ(J)-XYOFF(J)) + YYOFF(J)
            IF ((XY(J).LT.XBLC(J)) .OR. (XY(J).GT.XTRC(J))) THEN
               NNOFIT = NNOFIT + 1
               IF (.NOT.DONE) GO TO 100
               GO TO 200
               END IF
 120        CONTINUE
         NGOOD = NGOOD + 1
C                                       Mark the point
         AX(1) = XY(1)
         AY(1) = XY(2)
         AX(2) = AX(1)
         AX(3) = AX(1)
         AX(4) = AX(1) - DX
         AX(5) = AX(1) + DX
C                                       fix 'up' of the vertical dash
C                                       to max in unaverage points
         XTEMP = XY(2) + DY
         IF (XTEMP.GT.XTRC(2)) XTEMP = XTRC(2)
         IF (XTEMP.LT.XBLC(2)) XTEMP = XBLC(2)
         AY(2) = XTEMP
         AY(5) = AY(1)
C                                       fix 'down' of the vertical dash
C                                       to min in unaverage points
         XTEMP = XY(2) - DY
         IF (XTEMP.GT.XTRC(2)) XTEMP = XTRC(2)
         IF (XTEMP.LT.XBLC(2)) XTEMP = XBLC(2)
         AY(3) = XTEMP
         AY(4) = AY(1)
         CALL PNTPLT (ISYM, AX, AY, XBLC, XTRC, .FALSE., DO3C,
     *      BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         IF (DOERRB) THEN
            CALL GLTYPE (3, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            AY(2) = AY(1) + GGERR
            AY(1) = AY(1) - GGERR
            CALL GPOS (AX(1), AY(1), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL GVEC (AX(1), AY(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL GLTYPE (4, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
         IF (DOMODL.EQ.2) THEN
            IMODEL = IMODEL + 1
            MODEL(1,IMODEL) = TDAYS
            MODEL(2,IMODEL) = SCANM(1)
            END IF
         IF ((IMODEL.LE.MAXMOD) .AND. (.NOT.DONE)) GO TO 100
C                                       plot the current bits of model
 200  IF (IMODEL.GT.0) THEN
         CALL GLTYPE (3, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         GOOD = .FALSE.
         DO 210 I = 1,IMODEL
            DO 205 J = 1,2
               XY(J) = XYSCL(J) * (MODEL(J,I)-XYOFF(J)) + YYOFF(J)
 205           CONTINUE
            IF ((XY(1).GE.XBLC(1)) .AND. (XY(1).LE.XTRC(1)) .AND.
     *         (XY(2).GE.XBLC(2)) .AND. (XY(2).LE.XTRC(2))) THEN
               IF (IMODEL.EQ.1) THEN
                  CALL GPOS (XY(1)-DX, XY(2)+DY, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  CALL GVEC (XY(1)+DX, XY(2)-DY, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  CALL GPOS (XY(1)+DX, XY(2)+DY, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  CALL GVEC (XY(1)-DX, XY(2)-DY, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
               ELSE
                  IF ((I.GT.1) .AND.
     *               (ABS(MODEL(2,I)-MODEL(2,I-1)).GT.240.))
     *               GOOD = .FALSE.
                  IF (GOOD) THEN
                     CALL GVEC (XY(1), XY(2), BUFFER, IERR)
                     IF (IERR.NE.0) GO TO 970
                  ELSE
                     CALL GPOS (XY(1), XY(2), BUFFER, IERR)
                     IF (IERR.NE.0) GO TO 970
                     END IF
                  END IF
               GOOD = .TRUE.
            ELSE
               GOOD = .FALSE.
               END IF
 210        CONTINUE
         IF (.NOT.DONE) THEN
            MODEL(1,1) = MODEL(1,IMODEL)
            MODEL(2,1) = MODEL(2,IMODEL)
            IMODEL = 1
            CALL GLTYPE (4, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            GO TO 100
            END IF
         END IF
C                                     Write triangle name on plot.
      TEXT = STANAM(CPTRIP(1))(1:8) // '-' // STANAM(CPTRIP(2))(1:8) //
     *   '-' // STANAM(CPTRIP(3))(1:8)
      CALL DEFRMT (TEXT, ' ', INP)
      DX = 1.5
      DY = -1.5
      CALL GLTYPE (1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GPOS (TLC(1), TLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GICHAR (1, INP, 0, DX, DY, TEXT, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      WRITE (TEXT,1210) CPTRIP
      CALL DEFRMT (TEXT,' ', INP)
      DX = -1.5 - INP
      CALL GPOS (XTRC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GICHAR (1, INP, 0, DX, DY, TEXT, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Check if changed status
 220  IF (CHSTAT) CALL STATCH ('WRIT', STAT, DISKIN, OLDCNO, UTYPE,
     *   OBUFF, IRET)
      CALL UVGET ('CLOS', RPARM, BUFF1, IERR)
C                                       Plot model
      IF (DOMODL.EQ.1) THEN
         TRA = RA
         TDEC = DEC
         IF ((TRA.EQ.0.0D0) .AND. (TDEC.EQ.0.0D0)) THEN
            TRA = OBSRA
            TDEC = OBSDEC
            END IF
         I = XNPNTS + 0.1
         I = MIN (1000, MAX (200, I))
         CALL VBMDL (TRA, TDEC, XMIN, XMAX, YMIN, YMAX, YYOFF, TLC,
     *      TYPEAX(1), TYPEAX(2), CPTRIP, I, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
      CALL COPY (2, SVAXTP, TYPEAX)
C                                       Done: finish plot
      WRITE (MSGTXT,1200) NGOOD, CPTRIP(1), CPTRIP(2), CPTRIP(3)
      CALL MSGWRT (2)
      WRITE (MSGTXT,1201) NNOFIT, CPTRIP(1), CPTRIP(2), CPTRIP(3)
      IF (NNOFIT.GE.1) CALL MSGWRT (2)
      IF ((IPLOT.GT.0) .AND. (ABS (IPLOT).LT.MAXPLT)) GO TO 230
         GPHPAG = IPLOT.GT.0
         CALL GFINIS (BUFFER, IERR)
         IF (IERR.GT.0) GO TO 975
         CLOSED = T
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, OLDCNO, VER, BUFFER, IERR)
            IERR = 0
            END IF
 230  IF (IERR.GT.0) GO TO 975
         IRET = MIN (IERR, 0)
         GO TO 999
C                                       ZPHFIL or GINIT failure.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      IF (.NOT.DOTV) THEN
         CALL DELEXT ('PL', DISKIN, OLDCNO, 'WRIT', CATUV, BUFFER,
     *      VER, IERR)
         END IF
      GO TO 999
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      WRITE (MSGTXT,1200) NGOOD, CPTRIP(1), CPTRIP(2), CPTRIP(3)
      CALL MSGWRT (2)
      WRITE (MSGTXT,1201) NNOFIT, CPTRIP(1), CPTRIP(2), CPTRIP(3)
      IF (NNOFIT.GE.1) CALL MSGWRT (2)
      GPHPAG = IPLOT.GT.0
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.GT.0) GO TO 975
      CLOSED = T
      IF (.NOT.DOTV) THEN
         CALL HIPLOT (DISKIN, OLDCNO, VER, BUFFER, IERR)
         IERR = 0
         END IF
      GO TO 999
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         CALL DELEXT ('PL', DISKIN, OLDCNO, 'WRIT', CATUV, BUFFER,
     *      VER, IERR)
         END IF
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------

 1010  FORMAT ('PLot file version',I4,'  created.')
 1030 FORMAT ('PLot file version',I4,'__created ',A,A)
 1040 FORMAT ('IF',I3,'-',I2,' CH',I5,'-',I4,' STK ',A5,' CC ver ',I3)
 1050 FORMAT ('PLOTCL: ERROR',I3,' INIT VIS FILE')
 1100 FORMAT ('PLOTCL: ERROR',I3,' READING VIS FILE')
 1200 FORMAT ('PLOTCL: ',I9,' points plotted: triangle ',
     *   I2,'-',I2,'-',I2)
 1201 FORMAT ('PLOTCL: ',I9,' points did not fit: triangle ',
     *   I2,'-',I2,'-',I2)
 1210 FORMAT (I6,'-',I6,'-',I6)
 1960 FORMAT ('PLOTCL: ERROR DURING GRAPH FILE CREATION')
 1970 FORMAT ('PLOTCL: ERROR DURING GRAPHING. WILL TRY TO FINISH ',
     *   'PARTIAL GRAPH')
      END
      SUBROUTINE CLOSET (XANT, NUMTRP, CPTRIP, IRET)
C-----------------------------------------------------------------------
C   Routine to set up the list of antennas (ANTENS) for UVGET that
C   includes all antennas mentioned in XANT.
C   Input:
C      XANT(*)            R    Antenna array
C   Output:
C      NUMTRP             I    The number of triplets selected.
C      CPTRIP(3,*)        I    The antenna numbers in each triplet.
C                              numbers of each baseline selected.
C      IRET               I    Return code, 0=OK, else failed
C   Output in Common:
C      ANTENS(*)          I    Selected antenna numbers
C-----------------------------------------------------------------------
      REAL      XANT (*)
      INTEGER   NUMTRP, CPTRIP(3,*), IRET
C
      INTEGER   I, A1, A2, A3, NEXT, NA
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PCLPLT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Set antenna list.
      CALL FILL (MAXANT, 0, ANTENS)
      NEXT = 0
C                                       Find triplets requested
      NUMTRP = 0
      NA = MIN (50, MAXANT)
      DO 20 I = 1,NA,3
         IF ((XANT(I).GT.0.0) .AND. (NUMTRP.LT.MAXTRP)) THEN
            A1 = XANT(I) + 0.5
            A2 = XANT(I+1) + 0.5
            A3 = XANT(I+2) + 0.5
C                                       Check validity
            IF ((A1.GT.0).AND.(A2.GT.0).AND.(A3.GT.0) .AND.
     *         (A1.NE.A2).AND.(A1.NE.A3).AND.(A2.NE.A3)) THEN
C                                       List antennas in ascending order
               NUMTRP = NUMTRP + 1
               CPTRIP(1,NUMTRP) = MIN (A1, A2, A3)
               CPTRIP(3,NUMTRP) = MAX (A1, A2, A3)
               IF ((A1.GT.CPTRIP(1,NUMTRP)) .AND.
     *            (A1.LT.CPTRIP(3,NUMTRP))) CPTRIP(2,NUMTRP) = A1
               IF ((A2.GT.CPTRIP(1,NUMTRP)) .AND.
     *            (A2.LT.CPTRIP(3,NUMTRP))) CPTRIP(2,NUMTRP) = A2
               IF ((A3.GT.CPTRIP(1,NUMTRP)) .AND.
     *            (A3.LT.CPTRIP(3,NUMTRP))) CPTRIP(2,NUMTRP) = A3
C                                       Selected antennas:
               NEXT = NEXT + 1
               ANTENS(NEXT) = A1
               NEXT = NEXT + 1
               ANTENS(NEXT) = A2
               NEXT = NEXT + 1
               ANTENS(NEXT) = A3
               END IF
            END IF
 20      CONTINUE
C                                       Remove duplicate antennas
      CALL IMERGE (NEXT, ANTENS, NEXT)
C                                       Make sure some triplets were
C                                       specified.
      IF (NUMTRP.LE.0) THEN
         MSGTXT = 'NO TRIPLETS SPECIFIED!'
         IRET = 5
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE CLAVER (OP, NUMTRP, CPTRIP, T1, DT, DOERRB, DOMODL,
     *   RPARM, VIS)
C-----------------------------------------------------------------------
C   Adds a sample in to, or zeros, the summing arrays
C-----------------------------------------------------------------------
      CHARACTER OP*(*)
      INTEGER   NUMTRP, CPTRIP(3,*), DOMODL
      LOGICAL   DOERRB
      REAL      T1, DT, RPARM(*), VIS(3,*)
C
      INTEGER   I, IVIS, KVIS, JA1, JA2, IDAY, STTRIP, ITRIP, IBASE
      REAL      CT, TEMP
      DOUBLE PRECISION X8
      INCLUDE 'PCLPLT.INC'
      INCLUDE 'CLAVER.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANT.INC'
C-----------------------------------------------------------------------
C                                       zero
      IF (OP.EQ.'ZERO') THEN
         TLAST = -1.0
         DTUTC = DATUTC / 86400.0
         IVSCNT = 0
         I = 3 * MAXTRP
         CALL FILL (I, 0, COUNT)
         CALL FILL (I, 0, COUNT1)
         CALL FILL (MAXTRP, 0, COUNTC)
         CALL RFILL (I, 0.0, GAMP)
         CALL RFILL (I, 0.0, GERR)
         I = 4 * 3 * MAXTRP
         CALL RFILL (I, 0.0, WORK)
         I = 3 * 3 * MAXTRP
         CALL RFILL (I, 0.0, UVW)
         I = 4 * MAXTRP
         CALL RFILL (I, 0.0, WORKC)
         CNTTIM = 0
         SUMTIM = 0.0
C                                       add one vis into arrays:
      ELSE
         KVIS = (LREC-NRPARM) / 3
C                                       Set up first time boundary
         CT = RPARM(ILOCT+1) - DTUTC
         IVSCNT = IVSCNT + 1
         IF (IVSCNT.EQ.1) THEN
            IDAY = CT
            X8 = (CT - IDAY) / ABS (DT)
            TLAST = IDAY + DINT (X8) * ABS (DT) + ABS (DT)
            END IF
C                                       Antenna numbers
         IF (ILOCB.GE.0) THEN
            JA1 = RPARM(ILOCB+1) / 256. + 0.1
            JA2 = RPARM(ILOCB+1) - JA1 * 256 + 0.1
         ELSE
            JA1 = RPARM(ILOCA1+1) + 0.1
            JA2 = RPARM(ILOCA2+1) + 0.1
            END IF
         STTRIP = 1
C                                       Return to here to look for
C                                       further triplets involving this
C                                       baseline.
C                                       Find triplet and member
 105     DO 110 I = STTRIP,NUMTRP
            ITRIP = I
            IBASE = 1
            IF ((JA1.EQ.CPTRIP(1,I).AND.(JA2.EQ.CPTRIP(2,I)))) GO TO 120
            IBASE = 2
            IF ((JA1.EQ.CPTRIP(1,I).AND.(JA2.EQ.CPTRIP(3,I)))) GO TO 120
            IBASE = 3
            IF ((JA1.EQ.CPTRIP(2,I).AND.(JA2.EQ.CPTRIP(3,I)))) GO TO 120
 110        CONTINUE
C                                       Not wanted
         GO TO 999
C                                       wanted
 120     GOTDAT = .TRUE.
         STTRIP = ITRIP + 1
C                                       Time
         SUMTIM = SUMTIM + RPARM(ILOCT+1)
         IF (T1.GT.1.0E9) T1 = RPARM(ILOCT+1)
         CNTTIM = CNTTIM + 1
C                                       Vector average:
      INCLUDE 'INCS:ZVD.INC'
         DO 130 IVIS = 1,KVIS
            IF (VIS(3,IVIS).GT.0.0) THEN
               COUNT(IBASE,ITRIP) = COUNT(IBASE,ITRIP) + 1
               COUNT1(IBASE,ITRIP) = COUNT1(IBASE,ITRIP) + 1
               WORK(1,IBASE,ITRIP) = WORK(1,IBASE,ITRIP) + VIS(1,IVIS)
               WORK(2,IBASE,ITRIP) = WORK(2,IBASE,ITRIP) + VIS(2,IVIS)
               IF (DOERRB) THEN
                  WORK(3,IBASE,ITRIP) = WORK(3,IBASE,ITRIP) +
     *               VIS(1,IVIS)**2
                  WORK(4,IBASE,ITRIP) = WORK(4,IBASE,ITRIP) +
     *               VIS(2,IVIS)**2
                  END IF
               IF (DOMODL.EQ.2) THEN
                  UVW(1,IBASE,ITRIP) = UVW(1,IBASE,ITRIP) +
     *               RPARM(1+ILOCU)
                  UVW(2,IBASE,ITRIP) = UVW(2,IBASE,ITRIP) +
     *               RPARM(1+ILOCV)
                  UVW(3,IBASE,ITRIP) = UVW(3,IBASE,ITRIP) +
     *               RPARM(1+ILOCW)
                  END IF
               END IF
 130        CONTINUE
C                                       averaging closure phases
         IF (DT.LT.0.0) THEN
C                                       completed a triangle
            IF ((COUNT1(1,ITRIP).GT.0) .AND. (COUNT1(2,ITRIP).GT.0)
     *         .AND. (COUNT1(3,ITRIP).GT.0)) THEN
               TEMP = ATAN2 (WORK(2,1,ITRIP), WORK(1,1,ITRIP)+1.0E-20) -
     *            ATAN2 (WORK(2,2,ITRIP), WORK(1,2,ITRIP)+1.0E-20) +
     *            ATAN2 (WORK(2,3,ITRIP), WORK(1,3,ITRIP)+1.0E-20)
               WORKC(1,ITRIP) = WORKC(1,ITRIP) + COS (TEMP)
               WORKC(2,ITRIP) = WORKC(2,ITRIP) + SIN (TEMP)
               WORKC(3,ITRIP) = WORKC(3,ITRIP) + COS (TEMP) ** 2
               WORKC(4,ITRIP) = WORKC(4,ITRIP) + SIN (TEMP) ** 2
               COUNTC(ITRIP) = COUNTC(ITRIP) + 1
               CALL RFILL (12, 0.0, WORK(1,1,ITRIP))
               CALL FILL (3, 0, COUNT1(1,ITRIP))
               END IF
            END IF
C                                       This baseline may be involved in
C                                       more triplets.
         GO TO 105
C
         END IF
C
 999  RETURN
      END
      SUBROUTINE CLOSAV (NUMVIS, NUMTRP, CPTRIP, DT, SCANV, CLERR,
     *   CNT, DOERRB, TIME, T1, NUSCAN, SCANUM, RPARM, UVSCAL, VIS,
     *   NPOSS, NCLOSE, DOMODL, MODELV, IERR)
C-----------------------------------------------------------------------
C   Reads a uv data base and returns averages of closure phases for
C   selected triplets.  The triplets are specified in array CPTRIP.
C   Needs to be initialized by a call to UVGET.
C   Inputs:
C     NUMVIS     I    Current visibility number
C     NUMTRP     I    The number of triplets selected
C     CPTRIP     I(3,*) The antenna numbers involved in the triplets.
C     DT         R    Averaging time in days
C     DOERRB     L    If true calculate the closure phase error
C     UVSCAL     R    Scale factor for uv data
C   Input/Output:
C     RPARM      R(*) Random parameter array, first record of call.
C                     (1) = 'INDE' => don't use.
C     VIS        R(3,*) Visibility array, first record of call.
C     NPOSS      I(*) Number of visibility points for which closure
C                     phases may be possible.
C     NCLOSE     I(*) Number of visibility points for which closure
C                     phases are formed.
C   Outputs:
C     SCANV      R(*) The closure phase values for the selected
C                     triplets, corresponds to CPTRIP.
C                     Undefined values will contain 'INDE'.
C     CLERR      R(*) The formal error associated with the closure
C                     phase, calculated as CLERR = SQRT (err(12)**2
C                     + err(13)**2 + err(23)**2)
C     TIME(8)    I    Time range, start, stop; days, hours, min, sec.
C                     Unless NUSCAN only first 4 values are set.
C     TDAYS      R    Time of current record in days
C     NUSCAN     L    True IF the first record in a new scan.
C     IERR       I    Return code, 0 => OK, -1 => out of data,
C                     > 0 => failed.
C   Output to common in DSOU.INC
C     SNAME      C*16 Source name
C     QUAL       I    Source qualifier.
C     CALCOD     C*4  Calibrator code
C     FLUX(4,IF) R    Total flux density I, Q, U, V pol, (Jy) each IF
C     FREQO(IF)  D    Frequency offset (Hz)
C   Note:   If the end of data is encountered (IERR=-1) then UVGET is
C   called with OPCODE='CLOS'.
C-----------------------------------------------------------------------
      INTEGER   NUMTRP, CNT(3), CPTRIP(3,*), TIME(8), SCANUM, NPOSS(*),
     *   NUMVIS, NCLOSE(*), DOMODL, IERR
      LOGICAL   NUSCAN, DOERRB
      REAL      RPARM(*), UVSCAL, VIS(3,*), DT, SCANV(*), CLERR(*),
     *   TDAYS, MODELV(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PCLPLT.INC'
      LOGICAL   GOOD1, DONE
      INTEGER   I, SUNUM, JERR, ISLUN, KVIS, ICP, IDAY, J, K
      REAL      T1, CP, CT, RAV, IAV, RS, IS, AMPS, SS(3)
      DOUBLE PRECISION X8
      INCLUDE 'CLAVER.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA ISLUN /26/
C-----------------------------------------------------------------------
      IF (NUMVIS.EQ.0) CALL CLAVER ('ZERO', NUMTRP, CPTRIP, T1, DT,
     *   DOERRB, DOMODL, RPARM, VIS)
C                                       Save scan number (0= no index)
      NUSCAN = SCANUM.NE.INXRNO
      SCANUM = INXRNO
C                                       Initialize time
      T1 = 1.0E10
      KVIS = (LREC-NRPARM) / 3
C                                       Loop reading data
 100  CONTINUE
         CALL UVGET ('READ', RPARM, VIS, IERR)
         IF (IERR.GT.0) GO TO 999
         DONE = IERR.EQ.-1
         IF (IERR.EQ.-1) GO TO 200
         CT = RPARM(ILOCT+1) - DTUTC
C                                       scale u,v,w
         IF (UVSCAL.NE.1.0) THEN
            RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
            RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
            RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
            END IF
C                                       Set up first time boundary
         IF (IVSCNT.EQ.0) THEN
            IDAY = CT
            X8 = (CT - IDAY) / ABS (DT)
            TLAST = IDAY + DINT (X8) * ABS (DT) + ABS (DT)
            END IF
C                                       Check if avg. or scan done
         IF ((INXRNO.LE.SCANUM) .AND. (CT.LE.TLAST)) THEN
            CALL CLAVER ('AVER', NUMTRP, CPTRIP, T1, DT, DOERRB, DOMODL,
     *         RPARM, VIS)
            IF (GOTDAT) SUNUM = CURSOU
            GO TO 100
            END IF
C                                       Integration done:
C                                       Go through sums
 200  GOOD1 = .FALSE.
      IF (GOTDAT) THEN
C                                       Vector averaging
         CP = TWOPI
         DO 210 I = 1,NUMTRP
            NPOSS(I) = NPOSS(I) + 1
            IF (I.EQ.1) CALL COPY (3, COUNT, CNT)
            IF ((COUNT(1,I).GT.0) .AND. (COUNT(2,I).GT.0) .AND.
     *         (COUNT(3,I).GT.0)) THEN
               IF (DT.GT.0.0) THEN
                  SCANV(I) = ATAN2 (WORK(2,1,I), WORK(1,1,I)+1.0E-20) -
     *               ATAN2 (WORK(2,2,I), WORK(1,2,I)+1.0E-20) +
     *               ATAN2 (WORK(2,3,I), WORK(1,3,I)+1.0E-20)
                  IF (DOERRB) THEN
                     DO 202 K = 1,3
                        RAV = WORK(1,K,I) / COUNT(K,I)
                        IAV = WORK(2,K,I) / COUNT(K,I)
                        RS  = WORK(3,K,I) / COUNT(K,I) - RAV**2
                        IS  = WORK(4,K,I) / COUNT(K,I) - IAV**2
                        RS = MAX (0.0, RS)
                        IS = MAX (0.0, IS)
                        AMPS = RAV**2 + IAV**2
                        SS(K) = ((IAV**2)*RS + (RAV**2)*IS) / AMPS**2 /
     *                     MAX (1, COUNT(K,I)-1)
 202                    CONTINUE
                     CLERR(I)= SQRT (SS(1) + SS(2) + SS(3))
                     END IF
               ELSE
                  SCANV(I) = ATAN2 (WORKC(2,I), WORKC(1,I)+1.0E-20)
                  IF (DOERRB) THEN
                     RAV = WORKC(1,I) / COUNTC(I)
                     IAV = WORKC(2,I) / COUNTC(I)
                     RS = WORKC(3,I) / COUNTC(I) - RAV*RAV
                     IS = WORKC(4,I) / COUNTC(I) - IAV*IAV
                     RS = MAX (0.0, RS)
                     IS = MAX (0.0, IS)
                     AMPS = RAV**2 + IAV**2
                     CLERR(I) = SQRT (((IAV**2)*RS + (RAV**2)*IS) /
     *                  AMPS**2)
                     END IF
                  END IF
               IF (DOMODL.EQ.2) THEN
                  DO 205 K = 1,3
                     DO 204 J = 1,3
                        UVW(J,K,I) = UVW(J,K,I) / COUNT(K,I)
 204                    CONTINUE
 205                 CONTINUE
                  CALL MODPTS (UVW(1,1,I), MODELV(I))
                  END IF
               GOOD1 = .TRUE.
               NCLOSE(I) = NCLOSE(I) + 1
            ELSE
               SCANV(I) = FBLANK
               CLERR(I) = FBLANK
               END IF
 210        CONTINUE
         END IF
C                                       have some results
      IF (GOOD1) THEN
C                                       Force range of values= +/- pi
C                                       rad.
         DO 230 I = 1,NUMTRP
            IF (SCANV(I).NE.FBLANK) THEN
               CP = SCANV(I) / TWOPI
               ICP = CP
               CP = (CP - ICP) * TWOPI
               IF (CP.GT.PI) CP = CP - TWOPI
               IF (CP.LT.-PI) CP = CP + TWOPI
               SCANV(I) = CP
               SCANV(I) = SCANV(I) * RAD2DG
               IF (DOERRB) THEN
                  IF (CLERR(I).NE.FBLANK) CLERR(I) = CLERR(I) * RAD2DG
                  END IF
               END IF
 230        CONTINUE
C                                       Get source info
         IF (NUSCAN) THEN
            CALL GETSOU (SUNUM, IUDISK, IUCNO, CATUV, ISLUN, JERR)
C                                       Didn't find source
            IF (JERR.EQ.11) THEN
               WRITE (MSGTXT,1750) SUNUM
               CALL MSGWRT (8)
               JERR = 0
               END IF
            IF (JERR.GT.0) THEN
               IERR = JERR
               WRITE (MSGTXT,1700) JERR
               GO TO 990
               END IF
            END IF
C                                       Time
         T1 = 0
         IF (CNTTIM.GT.0) T1 = SUMTIM / CNTTIM
         TDAYS = T1
         CALL TODHMS (T1, TIME)
         END IF
C                                       save current sample
      IF ((IERR.EQ.0) .OR. (DONE)) THEN
         CALL CLAVER ('ZERO', NUMTRP, CPTRIP, T1, DT, DOERRB, DOMODL,
     *      RPARM, VIS)
         CALL CLAVER ('AVER', NUMTRP, CPTRIP, T1, DT, DOERRB, DOMODL,
     *      RPARM, VIS)
         END IF
C                                       End of data, calling routine
C                                       will close.
      IF (.NOT.GOOD1) THEN
         IF ((IERR.EQ.0) .AND. (SCANUM.GE.INXRNO)) GO TO 100
         IF (IERR.EQ.0) IERR = -2
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1700 FORMAT ('CLOSAV: ERROR',I3,' READING SOURCE TABLE')
 1750 FORMAT ('CLOSAV: SOURCE ',I3,' NOT IN SU TABLE')
      END
      SUBROUTINE INDCLT (NANT, NUMTRP, CPTRIP, IRET)
C-----------------------------------------------------------------------
C   Routine to set up the list of antennas (ANTENS) for UVGET that
C   includes all antennas mentioned in XANT.
C   Input:
C      NANT               I    Number of antennas in array, more
C                              importantly gives us the maximum
C                              antennas number
C   Output:
C      NUMTRP             I    The number of triplets selected.
C      CPTRIP(3,*)        I    The antenna numbers in each triplet.
C                              numbers of each baseline selected.
C      IRET               I    Return code, 0=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   NANT, NUMTRP, CPTRIP(3,*), IRET
C
      INTEGER   I, J, A1, A2, NUMIND
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       What we should get
      NUMIND = (NANT-1) * (NANT-2) / 2
C                                       Set antenna list.
      CALL FILL (MAXANT, 0, ANTENS)
C                                       To determine the # of
C                                       independent triangles use
C                                       following algorithm:
C                                       for j = 3, nant
C                                         tria = 1, 2, j
C                                                2, 3, j
C                                                3, 4, j
C                                                   .
C                                                   .
C                                             j-2, j-1, j
C
      NUMTRP = 0
      DO 100 J = 3, NANT
         A1 = 1
         DO 50 I = 1, NANT
            IF (A1.LT.(J-1)) THEN
               A2 = A1 + 1
               NUMTRP = NUMTRP + 1
               CPTRIP(1,NUMTRP) = A1
               CPTRIP(2,NUMTRP) = A2
               CPTRIP(3,NUMTRP) = J
               END IF
            A1 = A1 + 1
 50         CONTINUE
 100     CONTINUE
C
      DO 200 I = 1, NANT
         ANTENS(I) = I
 200     CONTINUE
C                                       Make sure some triplets were
C                                       specified.
      IF (NUMTRP.LE.0) THEN
         MSGTXT = 'NO TRIPLETS SPECIFIED!'
         IRET = 5
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE MODSET (XMIN, XMAX, MPLO, NPLO, DRA, DDEC, CPTRIP,
     *   NPTS, XDATA, YDATA, IERR)
C-----------------------------------------------------------------------
C   Subroutine to set up model values for a given set of clean
C   components and for a given pair of antennas, or closure triangle
C
C   Inputs: XMIN,XMAX R    min and max values of the X-axis
C           MPLO      I    type of X-axis: 1 --> phase
C                              2 --> GAST
C                              3 --> time (iat days)
C          NPLO      I     Type of Y-axis in the same manner
C          DRA,DDEC  D     Ra and Dec of the source at the epoch of
C                          observation (in degrees, and as D).
C          CPTRIP(3) I     if plotting closure phases, defines the
C                          3 antennas of the triplet
C   Input from common /COMPS/
C      CCPOS(3,MAXCC) R     Distance from ref. X,Y,Z pixel in turns.
C      SFLUX(MAXCC)   R     Flux in pixel XX, YY in Jansky
C      GAUSA(MAXCC)   R     Gaussian coefficient for u*u
C      GAUSB(MAXCC)   R     Gaussian coefficient for u*v
C      GAUSC(MAXCC)   R     Gaussian coefficient for v*v
C      NUMCC          I     Number of pixels actually processed.
C   This subroutine gets information from common /CANIN/ set up by
C   subroutine ANTIN
C-----------------------------------------------------------------------
      REAL      XMIN, XMAX, XDATA(*), YDATA(2,*)
      INTEGER   MPLO, NPLO, NPTS, IERR
      DOUBLE PRECISION DRA, DDEC
C
      DOUBLE PRECISION    U(3), V(3), W(3), PI, TWOPI, DTR, HTR, FREP,
     *   BX(3), BY(3), BZ(3), B1(3), B2(3), GH(3), GMST, GAST, RA,
     *   DEC, GSEC, AA, RATE, XLB(3), YLB(3), ZLB(3)
      REAL      XXPOS, XDEL, XREL, HAI, CSUM, SSUM, TEMP, AMODL,
     *   FAZ, ARG, FTEMP, CLOMOD(3)
      INTEGER   I, K, CPTRIP(3), IBAS
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'CLPLT.INC'
      DATA GSEC /1.0027375D0/
C-----------------------------------------------------------------------
      IF ((MPLO.LT.1) .OR. (MPLO.GT.3)) GO TO 990
C                                       program constants
      PI = 3.14159265358979D0
      TWOPI = 2.D0 * PI
      DTR = PI / 180.D0
      HTR = PI / 12.D0
      U(1) = 0.0D0
      V(1) = 0.0D0
      W(1) = 0.0D0
      GAST = 0.0D0
      IERR = 1
      RA = DRA * DTR
      DEC = DDEC * DTR
      FREP = AFREQ
      DO 10 I = 1,3
         XLB(I) = XB(CPTRIP(I))
         YLB(I) = YB(CPTRIP(I))
         ZLB(I) = ZB(CPTRIP(I))
 10      CONTINUE

C                                     divide X-axis into 200 pixels
      XDEL = (XMAX - XMIN) / NPTS
      XXPOS = XMIN - XDEL
C                                     if this is a IAT-plot:
C                                     compute GST at first time
C                                     interval
      IF ((MPLO.EQ.2) .OR. (MPLO.EQ.3)) THEN
         CALL GSTROT (JDREF, GMST, GAST, RATE)
         GAST = GAST * (24.D0/360.D0)
         GAST = GAST + ((XMIN*24.D0) * GSEC)
         GAST = MOD (GAST, 24.D0)
         END IF
C                                     determine baseline parms
      CALL BASLIN (3, XLB, YLB, ZLB, FREP, ARRLON, BX, BY, BZ,
     *   B1, B2, GH)
C
      XREL = XDEL
      IF (MPLO.EQ.3) XDEL = XDEL * 24.0
      GAST = GAST - GSEC*XDEL
      ARG = -10.0
C                                       closure plots here
      DO 700 I = 1,NPTS
         YDATA(1,I) = FBLANK
         YDATA(2,I) = FBLANK
         XXPOS = XXPOS + XREL
         XDATA(I) = XXPOS
C                                       IAT in days
         IF (MPLO.EQ.3) THEN
            GAST = GAST + GSEC*XDEL
         ELSE IF (MPLO.EQ.2) THEN
            GAST = XDATA(I) * 24.D0
         ELSE
            GO TO 710
            END IF
C                                       Now need to compute model on
C                                       3 baselines and combine to
C                                       form closure model.
C                                       u,v,w from HA
         DO 600 IBAS = 1,3
            HAI = GAST*HTR - RA - GH(IBAS)
            U(IBAS) = B2(IBAS) * SIN(HAI)
            V(IBAS) = B1(IBAS) * COS(DEC) -
     *          B2(IBAS) * SIN(DEC) * COS(HAI)
            W(IBAS) = B1(IBAS) * SIN(DEC) +
     *          B2(IBAS) * COS(DEC) * COS(HAI)
C
            CSUM = 0.0
            SSUM = 0.0
C                                       calculate model sin/cos amps.
C                                       Spherical model
C                                       Trap very unresolved - needed to
C                                       prevent serious precision loss.
            IF (DOSPHE) THEN
               DO 510 K = 1,NUMCC
                  AA = GAUSA(K) * SQRT (U(IBAS)*U(IBAS) +
     *                V(IBAS)*V(IBAS))
                  IF (AA.LT.6.28D-2) AA = 6.28D-2
                  FTEMP = 3.0D0 * SFLUX(K) *
     *               ((SIN(AA) / (AA*AA*AA)) - (COS(AA) / (AA*AA)))
                  TEMP = U(IBAS) * CCPOS(1,K) + V(IBAS) * CCPOS(2,K) +
     *               W(IBAS) * CCPOS(3,K)
                  SSUM = SSUM + FTEMP * SIN (TEMP)
                  CSUM = CSUM + FTEMP * COS (TEMP)
 510              CONTINUE
C                                       Gaussian
            ELSE IF (DOGAUS) THEN
               DO 520 K = 1,NUMCC
                  ARG = U(IBAS)*U(IBAS)*GAUSA(K) +
     *               U(IBAS)*V(IBAS)*GAUSB(K) +
     *               V(IBAS)*V(IBAS)*GAUSC(K)
                  IF (ARG.GT.-8.0) THEN
                     FTEMP = SFLUX(K) * EXP(ARG)
                     TEMP = U(IBAS) * CCPOS(1,K) + V(IBAS) * CCPOS(2,K)
     *                  + W(IBAS) * CCPOS(3,K)
                     SSUM = SSUM + FTEMP * SIN (TEMP)
                     CSUM = CSUM + FTEMP * COS (TEMP)
                     END IF
 520              CONTINUE
C                                       CC's
            ELSE
               DO 550 K = 1,NUMCC
                  FTEMP = SFLUX(K)
                  TEMP = U(IBAS) * CCPOS(1,K) + V(IBAS) * CCPOS(2,K) +
     *               W(IBAS) * CCPOS(3,K)
                  SSUM = SSUM + FTEMP * SIN (TEMP)
                  CSUM = CSUM + FTEMP * COS (TEMP)
 550              CONTINUE
               END IF
C                                       Finished computing model
            AMODL = SQRT (SSUM*SSUM + CSUM*CSUM)
            IF ((NPLO.EQ.1) .AND. (AMODL.GT.1.0E-10)) THEN
               FAZ = ATAN2 (SSUM, CSUM) / DTR
 560           IF (FAZ.GT.180.0E0) FAZ = FAZ - 360.0E0
               IF (FAZ.LT.-180.0E0) FAZ = FAZ + 360.0E0
               IF (FAZ.GT.180.0E0) GO TO 560
               IF (FAZ.LT.-180.0E0) GO TO 560
               CLOMOD(IBAS) = FAZ
               END IF
 600        CONTINUE
         FAZ = CLOMOD(1) - CLOMOD(2) + CLOMOD(3)
 620     IF (FAZ.GT.180.0E0) FAZ = FAZ - 360.0E0
         IF (FAZ.LT.-180.0E0) FAZ = FAZ + 360.0E0
         IF (FAZ.GT.180.0E0) GO TO 620
         IF (FAZ.LT.-180.0E0) GO TO 620
         YDATA(1,I) = FAZ
 700     CONTINUE
 710     IERR = 0
      GO TO 999
C                                       bad X-axis type
 990  WRITE (MSGTXT,1990) MPLO
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1990 FORMAT ('MODSET: BAD X-AXIS CODE =',I6)
      END
      SUBROUTINE MODORB (XMIN, XMAX, MPLO, DRA, DDEC, CPTRIP,
     *   NPTS, XDATA, YDATA, IERR)
C-----------------------------------------------------------------------
C   Subroutine to set up model values for a given set of clean
C   components and for a given pair of antennas, or closure triangle
C   if one or both antennas is at an orbit of Earth satalite.
C
C   Inputs:
C      XMIN,XMAX      R    min and max values of the X-axis
C      MPLO           I    type of X-axis: 12 --> time (hms)
C                                          otherwise not plot
C      DRA,DDEC       D     Ra and Dec of the source at the epoch of
C                           observation (in degrees, and as D).
C      CPTRIP(3)      I     if plotting closure phases, defines the
C                           3 antennas of the triplet
C   Input from common /COMPS/
C      CCPOS(3,MAXCC) R     Distance from ref. X,Y,Z pixel in turns.
C      SFLUX(MAXCC)   R     Flux in pixel XX, YY in Jansky
C      GAUSA(MAXCC)   R     Gaussian coefficient for u*u
C      GAUSB(MAXCC)   R     Gaussian coefficient for u*v
C      GAUSC(MAXCC)   R     Gaussian coefficient for v*v
C      NUMCC          I     Number of pixels actually processed.
C   Input from common /CANIN/
C      XB, YB, ZB     D(*)  Array of ground antennas cartesian
C                           coordinates in a system tied with Earth
C
C      IORBIT         I(*)  Array of satalites number.
C                           =0 if ground based
C      ORBITA         D(IP + (IS-1)*6)  Parameters of the orbits
C                           1. Semimajor (m)
C                           2. Eccentricity
C                           3. Inclination of orbit plane, degrees
C                           4. RA of ascending node, degrees
C                           5. An angle in orbit plane from
C                              ascending node to peregee, degrees

C                           6. The mean anomaly at the reference
C                              time, degrees
C   Output:
C
C   This subroutine gets information from common /CANIN/ set up by
C   subroutine ANTIN
C-----------------------------------------------------------------------
      DOUBLE PRECISION    U(3), V(3), W(3), HAI, TIME, GMST, GAST, RA,
     *   X1, Y1, Z1, X2, Y2, Z2, X3, Y3, Z3, BAX(3), BAY(3), BAZ(3),
     *   DEC, DRA, DDEC, GSEC, AA, RATE, CLOMOD(3), ORBIT1(6),
     *   ORBIT2(6), ORBIT3(6), VX, VY, VZ
      REAL      XXPOS, XDEL, CSUM, SSUM, TEMP, AMODL, FAZ, ARG, XMIN,
     *   XMAX, XDATA(*), YDATA(2,*), FTEMP
      INTEGER   MPLO, I, K, IERR, NUV, CPTRIP(3), NPTS
      INTEGER IORB1, IORB2, IORB3, IT1, IT2, IT3, IBAS
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'CLPLT.INC'
      DATA GSEC /1.0027375D0/
C-----------------------------------------------------------------------
      IERR = 1
      IT1 = CPTRIP(1)
      IT2 = CPTRIP(2)
      IT3 = CPTRIP(3)
      IORB1 = IORBIT(IT1)
      IORB2 = IORBIT(IT2)
      IORB3 = IORBIT(IT3)
      ORBIT1(1) = ORBITA(1 + (IORB1-1)*6)
      ORBIT1(2) = ORBITA(2 + (IORB1-1)*6)
      ORBIT1(3) = ORBITA(3 + (IORB1-1)*6)
      ORBIT1(4) = ORBITA(4 + (IORB1-1)*6)
      ORBIT1(5) = ORBITA(5 + (IORB1-1)*6)
      ORBIT1(6) = ORBITA(6 + (IORB1-1)*6)
      ORBIT2(1) = ORBITA(1 + (IORB2-1)*6)
      ORBIT2(2) = ORBITA(2 + (IORB2-1)*6)
      ORBIT2(3) = ORBITA(3 + (IORB2-1)*6)
      ORBIT2(4) = ORBITA(4 + (IORB2-1)*6)
      ORBIT2(5) = ORBITA(5 + (IORB2-1)*6)
      ORBIT2(6) = ORBITA(6 + (IORB2-1)*6)
      ORBIT3(1) = ORBITA(1 + (IORB3-1)*6)
      ORBIT3(2) = ORBITA(2 + (IORB3-1)*6)
      ORBIT3(3) = ORBITA(3 + (IORB3-1)*6)
      ORBIT3(4) = ORBITA(4 + (IORB3-1)*6)
      ORBIT3(5) = ORBITA(5 + (IORB3-1)*6)
      ORBIT3(6) = ORBITA(6 + (IORB3-1)*6)
      X1 = XB(IT1)
      Y1 = YB(IT1)
      Z1 = ZB(IT1)
      X2 = XB(IT2)
      Y2 = YB(IT2)
      Z2 = ZB(IT2)
      X3 = XB(IT3)
      Y3 = YB(IT3)
      Z3 = ZB(IT3)
C                                       X can be only time;
      IF (MPLO.NE.3) GO TO 990
C
      RA = DRA * DG2RAD
      DEC = DDEC * DG2RAD
C                                       divide X-axis into 200 pixels
C                                       XMAX, XMIN, XDEL - in days
      XDEL = (XMAX - XMIN) / NPTS
      XXPOS = XMIN - XDEL
C                                       compute GST at first time
C                                       interval
      CALL GSTROT (JDREF, GMST, GAST, RATE)
      GAST = (GAST + 360.D0*XMIN*GSEC)
      GAST = MOD (GAST, 360.D0)
C                                       GAST in degrees at the beginning
C                                       of plot
C
      TIME = XMIN - XDEL
C                                       Time at the beginning of plot
C                                       relatively reference time in days
      GAST = GAST - 360.0D0*XDEL*GSEC
C
      DO 200 I = 1,NPTS
         YDATA(1,I) = FBLANK
         YDATA(2,I) = FBLANK
         XXPOS = XXPOS + XDEL
         XDATA(I) = XXPOS
         NUV = 1
         TIME = TIME + XDEL
C                                       reference time at the current
C                                       point, in days
         GAST = GAST + 360.0D0*XDEL*GSEC
C                                       GAST in degrees at the current
C                                       time
         HAI = GAST * DG2RAD
C                                       find the baseline cartesian
C                                       coordinates: X-RA, Z-North
C                                       baseline 1-2
         CALL BACOOR (IORB1, IORB2, ORBIT1, ORBIT2, X1, Y1, Z1,
     *      X2, Y2, Z2, HAI, TIME, BAX(1), BAY(1), BAZ(1), VX, VY, VZ)
C                                       baseline 1-3
         CALL BACOOR (IORB1, IORB3, ORBIT1, ORBIT3, X1, Y1, Z1,
     *      X3, Y3, Z3, HAI, TIME, BAX(2), BAY(2), BAZ(2), VX, VY, VZ)
C                                       baseline 2-3
         CALL BACOOR (IORB2, IORB3, ORBIT2, ORBIT3, X2, Y2, Z2,
     *      X3, Y3, Z3, HAI, TIME, BAX(3), BAY(3), BAZ(3), VX, VY, VZ)
C                                       Now need to compute model on
C                                       3 baselines and combine to
C                                       form closure model.
C                                       u,v,w from HA
         DO 160 IBAS = 1, 3
C                                       U, V, W in meters
            U(IBAS) = BAX(IBAS)*SIN(RA) - BAY(IBAS)*COS(RA)
            V(IBAS) = BAX(IBAS)*COS(RA)*SIN(DEC) +
     *         BAY(IBAS)*SIN(RA)*SIN(DEC) - BAZ(IBAS)*COS(DEC)
            W(IBAS) = BAX(IBAS)*COS(RA)*COS(DEC) + BAY(IBAS)*SIN(RA)
     *         *COS(DEC) + BAZ(IBAS)*SIN(DEC)
C                                       U, V, W in wavelength
            U(IBAS) = U(IBAS)* ( AFREQ / VELITE)
            V(IBAS) = V(IBAS)* ( AFREQ / VELITE)
            W(IBAS) = W(IBAS)* ( AFREQ / VELITE)

            CSUM = 0.0
            SSUM = 0.0
C                                       calculate model sin/cos amps.
C                                       Spherical model
C                                       Trap very unresolved - needed to
C                                       prevent serious precision loss.
            IF (DOSPHE) THEN
               DO 110 K = 1,NUMCC
                  AA = GAUSA(K) * SQRT (U(IBAS)*U(IBAS) +
     *                V(IBAS)*V(IBAS))
                  IF (AA.LT.6.28D-2) AA = 6.28D-2
                  FTEMP = 3.0D0 * SFLUX(K) *
     *               ((SIN(AA) / (AA*AA*AA)) - (COS(AA) / (AA*AA)))
                  TEMP = U(IBAS) * CCPOS(1,K) + V(IBAS) * CCPOS(2,K) +
     *               W(IBAS) * CCPOS(3,K)
                  SSUM = SSUM + FTEMP * SIN (TEMP)
                  CSUM = CSUM + FTEMP * COS (TEMP)
 110              CONTINUE
C
            ELSE IF (DOGAUS) THEN
C                                       Gaussian
               DO 120 K = 1,NUMCC
                  ARG = U(IBAS)*U(IBAS)*GAUSA(K) +
     *               U(IBAS)*V(IBAS)*GAUSB(K) +
     *               V(IBAS)*V(IBAS)*GAUSC(K)
                  IF (ARG.LE.-8.0) GO TO 120
                     FTEMP = SFLUX(K) * EXP(ARG)
                     TEMP = U(IBAS) * CCPOS(1,K) + V(IBAS) * CCPOS(2,K)
     *                  + W(IBAS) * CCPOS(3,K)
                     SSUM = SSUM + FTEMP * SIN (TEMP)
                     CSUM = CSUM + FTEMP * COS (TEMP)
 120              CONTINUE
C                                       CC's
            ELSE
               DO 130 K = 1,NUMCC
                  FTEMP = SFLUX(K)
                  TEMP = U(IBAS) * CCPOS(1,K) + V(IBAS) * CCPOS(2,K) +
     *               W(IBAS) * CCPOS(3,K)
                  SSUM = SSUM + FTEMP * SIN (TEMP)
                  CSUM = CSUM + FTEMP * COS (TEMP)
 130              CONTINUE
               END IF
C                                       Finished computing model
            AMODL = SQRT (SSUM*SSUM + CSUM*CSUM)
            IF (AMODL .GT. 1.0E-10) THEN
               FAZ = ATAN2 (SSUM, CSUM) / DG2RAD
 140           IF (FAZ.GT.180.0E0) FAZ = FAZ - 360.0E0
               IF (FAZ.LT.-180.0E0) FAZ = FAZ + 360.0E0
               IF (FAZ.GT.180.0E0) GO TO 140
               IF (FAZ.LT.-180.0E0) GO TO 140
               CLOMOD(IBAS) = FAZ
            ELSE
               CLOMOD(IBAS) = 0.0
               END IF
 160        CONTINUE
         FAZ = CLOMOD(1) - CLOMOD(2) + CLOMOD(3)
 180     IF (FAZ.GT.180.0E0) FAZ = FAZ - 360.0E0
         IF (FAZ.LT.-180.0E0) FAZ = FAZ + 360.0E0
         IF (FAZ.GT.180.0E0) GO TO 180
         IF (FAZ.LT.-180.0E0) GO TO 180
         YDATA(1,I) = FAZ
 200     CONTINUE
         IERR = 0
      GO TO 999
C                                       bad X-axis type
 990  WRITE (MSGTXT,1100)
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('MODORB: In orbit case I can plot only X-time')
      END
      SUBROUTINE VBMDL (RA, DEC, XMIN, XMAX, YMIN, YMAX, YYOFF, TLC,
     *   MPLO, NPLO, CPTRIP, NPTS, BUFFER, IERR)
C-----------------------------------------------------------------------
C   Main subroutine for plotting of a model:  If there is no model
C   (NUMCC .le. 0) VBMDL writes the baseline name and returns with
C   IERR=0.
C   Inputs:
C      RA,DEC            D     Ra and dec of the source in radians
C      XMIN,XMAX         R     Min and max of X-axis
C      YMIN,YMAX         R     Min and max of Y-axis
C      XYSCL(2)          R     Scaling factors
C      XYOFF(2)          R     Offset in plot
C      YYOFF(2)          R     Offset of the current plot.
C      TLC(2)            R     X, Y of top left corner of plot.
C      MPLO              I     Type of X-axis plot
C      NPLO              I     Type of Y-axis plot
C      CPTRIP(3)         I     Closure phase triplet plotted
C      NPTS              I     Number samples in model: 200 - 1000
C      IERR              I     Standard AIPS error code.
C-----------------------------------------------------------------------
      CHARACTER TEXT*132, MINUS*4
      INTEGER   MPLO, NPLO, IERR, NPTS, BUFFER(*), INP, INCHAR,
     *   CPTRIP(3), IT1, IT2, IT3
      LOGICAL   DOMDL
      REAL      XMIN, XMAX, YMIN, YMAX, YYOFF(2), TLC(2)
      DOUBLE PRECISION    RA, DEC
      REAL      XDATA(1000), YDATA(2,1000), XXXX(10), DX, DY
      INCLUDE 'CLPLT.INC'
      COMMON /CPLOTU/ XXXX
      DATA MINUS /'----'/
C-----------------------------------------------------------------------
      IF (OPCODE.NE.'CLOS') THEN
C                                     Write baseline name on plot.
         TEXT = ' '
         INCHAR = 8
         INP = 1
         TEXT(INP:INP+7) = STANAM(IAW1)(1:8)
         CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
         INCHAR = INP + 9
         INP = INP + 1
         TEXT(INP:INP) = MINUS(1:1)
         INP = INP + 1
         TEXT(INP:INP+7) = STANAM(IAW2)(1:8)
         CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
         DX = 1.5
         DY = -1.5
         CALL GPOS (TLC(1), TLC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                     Check if model exists.
      DOMDL = (NPLO.EQ.1)
      IF ((NUMCC.LE.0) .OR. (.NOT.DOMDL)) GO TO 999
C                                       Are all antennas ground?
      IT1 = CPTRIP(1)
      IT2 = CPTRIP(2)
      IT3 = CPTRIP(3)
C                                       setup model if one or both
C                                       antennas are in orbit
      IF ((IORBIT(IT1).GT.0) .OR. (IORBIT(IT2).GT.0)
     *   .OR. (IORBIT(IT3).GT.0)) THEN
         CALL MODORB (XMIN, XMAX, MPLO, RA, DEC, CPTRIP,
     *      NPTS, XDATA, YDATA, IERR)
C                                       setup model if both antennas are
C                                       on Earth
      ELSE
         CALL MODSET (XMIN, XMAX, MPLO, NPLO, RA, DEC, CPTRIP,
     *      NPTS, XDATA, YDATA, IERR)
         END IF
      IF (IERR.NE.0) GO TO 999
C                                     setup plotting common
      CALL PLTSET (XMIN, XMAX, YMIN, YMAX, XYSCL, XYOFF, YYOFF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                     plot model
      CALL GLTYPE (2, BUFFER, IERR)
      IF (IERR.EQ.0) CALL MODPLT (NPLO, NPTS, XDATA, YDATA, BUFFER,
     *   IERR)
C
 999  RETURN
      END
      SUBROUTINE ANTIN (VER, NNCH, IIBIF, DISKI, CNOIN, FREQID, IERR)
C-----------------------------------------------------------------------
C   Selects station information and gets freq,and ref. date out of the
C   header for a given baseline.
C   Inputs:
C      VER           I    Antenna array number (AN file ver.)
C      NNCH          I    Frequency channel.
C      IIBIF         I    IF number.
C      DISKI         I    Vol number
C      CNOIN         I    CNO
C      FREQID        I    Selected FREQID
C   Outputs in common:
C      XB,YB,ZB(*)   D    Cartesian coordinates for ground based
C                         stations in meters.
C      IORBIT        I(*)  Array of satalites number.
C                           =0 if ground based
C      ORBITA        D(IP + (IS-1)*6)  Parameters of the orbits
C                           IP - parameters number;  IS - satalite #
C                           1. Semimajor (m)
C                           2. Eccentricity
C                           3. Inclination of orbit plane, degrees
C                           4. RA of ascending node, degrees
C                           5. An angle in orbit plane from
C                              ascending node to peregee, degrees
C                           6. The mean anomaly at the reference
C                              time, degrees
C      STANAM(*)     C*8  Names of stations
C      JDREF         D    Julian day# for the referens date.
C      AFREQ         D    Frequency of channel NNCH, IF IIBIF in Hz.
C      GST0          D    Greenwich sidereal time at UT=0 at ref.d
C      IATUTC        R    IAT-UTC in seconds.
C      UT1XXX        R    UT1-UTC in seconds.
C   Programmer: L.B.Baath   Onsala Space Observatory  30 october 1982
C               L.R. Kogan  NRAO, Socorro added orbital antennas
C-----------------------------------------------------------------------
      INTEGER   IERR, IA, LUNA, CNOIN, IABUF(512), VER, NIF, FREQID,
     *   NNCH, IIBIF, DISKI, IORB, I, IORPRM, NUMREC
      INCLUDE 'CLPLT.INC'
      CHARACTER STNAME*8, BNDCOD(MAXIF)*8
      INTEGER   ISBAND(MAXIF)
      REAL      FINC(MAXIF)
      DOUBLE PRECISION FOFF(MAXIF), DX, DY, DZ
      LOGICAL   DOORB
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                     open antenna file
      LUNA = 28
      CALL ANTINI ('READ', IABUF, DISKI, CNOIN, VER, CATBLK, LUNA,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GST0, DEGPDY, AFREQ, RDATE,
     *   POLRXY, UT1XXX, IATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 999
C                                     check for bad freq value
 10   IF ( AFREQ.EQ.0.0D0 ) AFREQ = CATD(KDCRV+JLOCF)
      CALL JULDAY (RDATE, JDREF)
      DX = ARRAYC(1)
      DY = ARRAYC(2)
      DZ = ARRAYC(3)
      OBSRA = RA
      OBSDEC = DEC
      NUMREC = IABUF(5)
      ARRLON = 0.0D0
      IF ((DX.NE.0.0D0) .OR. (DY.NE.0.0D0)) ARRLON = ATAN2 (DY, DX)
C                                       Get antenna info.
C                                       IORB is an orbital antenna
C                                       number
      IORB = 0
      NANT = 0
      DO 30 IA = 1,NUMREC
         IANRNO = IA
         CALL TABAN ('READ', IABUF, IANRNO, ANKOLS, ANNUMV, STNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR .NE. 0) THEN
            WRITE (MSGTXT,1010) IA, IERR
            CALL MSGWRT (8)
            END IF
         NANT = MAX (NANT, NOSTA)
         IORBIT(NOSTA) = 0
         DOORB = MNTSTA .EQ. 2
         IF (DOORB) THEN
            IORB = IORB + 1
            IORBIT(NOSTA) = IORB
            DO 25 I = 1,6
               IORPRM = I + (IORB-1)*6
               ORBITA(IORPRM) = ORBPRM(I)
   25          CONTINUE
         ELSE
            XB(NOSTA) = STAXYZ(1)
            YB(NOSTA) = STAXYZ(2)
            ZB(NOSTA) = STAXYZ(3)
            END IF
         STANAM(NOSTA) = STNAME
 30      CONTINUE
C                                     close antenna file
      CALL TABIO ('CLOS', 1, IANRNO, IABUF, IABUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (8)
         END IF
C                                       Get frequency info for correct
C                                       FREQID/IF combination from
C                                       FQ or CH table
      VER = 1
      CALL CHNDAT ('READ', IABUF, DISKI, CNOIN, VER, CATBLK, LUNA,
     *   NIF, FOFF, ISBAND, FINC, BNDCOD, FREQID, IERR)
C                                       Correct freq. for channel NNCH
      AFREQ = AFREQ + FOFF(IIBIF) +
     *         (NNCH - CATR(KRCRP+JLOCF)) * FINC(IIBIF)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ANTIN: ERROR IN OPEN AN-FILE IERR = ',I6)
 1010 FORMAT ('ANTIN: ERROR IN FINDING STATION',I3,' IERR=',I3)
 1030 FORMAT ('ANTIN: ERROR IN CLOSING AN-FILE IERR = ',I6)
      END
      SUBROUTINE REEDIN (VER, IERR)
C-----------------------------------------------------------------------
C   Reads in up to MAXCC components from file CC.
C   If no file is found NUMCC is set to zero and the routine return
C   IERR = 0.
C   Will accept either points or gaussians.
C   Inputs:
C      VER           I     CLEAN components file version no.
C   Outputs:  In common /COMPS/
C      CCPOS(3,MAXCC) R     Distance from ref. X,Y,Z pixel in turns.
C      SFLUX(MAXCC)   R     Flux in pixel XX, YY in Jansky
C      GAUSA(MAXCC)   R     Gaussian coefficient for u*u
C      GAUSB(MAXCC)   R     Gaussian coefficient for u*v
C      GAUSC(MAXCC)   R     Gaussian coefficient for v*v
C      NUMCC          I     Number of pixels actually processed.
C-----------------------------------------------------------------------
      INTEGER   VER, IERR
C
      HOLLERITH CATCLH(256)
      INTEGER   LIMIT, I, NCOUNT, IROUND
      INTEGER   IABUF(512), DISK2, SEQ2, IUSER, LUNB, IBUFF1(512),
     *  CATCLN(256), IMAP, NMAP, MODEL, METHOD
      REAL      ABUF(256), CATCLR(256), EPS, XTEMPC, TA, TB, AM, AN,
     *   XYZ(3), XP(3), UMAT(3,3), PMAT(3,3), XXOFF, YYOFF, ZZOFF
      DOUBLE PRECISION    CATCLD(128), A8BUF(128), XRA, XDEC
      LOGICAL   T, F, WASOME, DO3D
      INCLUDE 'CLPLT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INTEGER   BITER(MAXFLD), NITER(MAXFLD), CCKOLS(MAXCCC),
     *   CCNUMV(MAXCCC), CCRNO, CCNCOL, CCTYPE
      REAL      XX, YY, ZZ, FLUX, PARMS(3)
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DMPR.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (CATCLN, CATCLR, CATCLH, CATCLD)
      EQUIVALENCE (IABUF, ABUF, A8BUF)
      EQUIVALENCE (IBUFF1, BUFF1)
      DATA T, F /.TRUE.,.FALSE./
      DATA LUNB /18/
      DATA BITER /MAXFLD * 0/
C-----------------------------------------------------------------------
      EPS = 0.1
      DISK2 = XDI2IN + EPS
      IUSER = USERID
      SEQ2 = XS2IN + EPS
      NMAP = IROUND (XNMAP)
      NMAP = ABS (NMAP)
      NUMCC = 0
      IF ((NAM2IN.EQ.' ') .AND. (CLA2IN.EQ.' ')) GO TO 200
      IF (NMAP.EQ.0) GO TO 200
      NCOUNT = 0
      LIMFLX = XFLUX
      NONEG = F
      WASOME = F
      DO 10 IMAP = 1,NMAP
         IF (IMAP.LE.MAXAFL) THEN
            NITER(IMAP) = ABS(XCOMP(IMAP)) + 0.1
            IF (XCOMP(IMAP).LE.-0.5) NONEG = T
            IF (NITER(IMAP).GT.0) WASOME = T
         ELSE
            NITER(IMAP) = 0
            IF (WASOME) NITER(IMAP) = 1000000000
            END IF
 10      CONTINUE
      MODEL = 1
      METHOD = -1
      CALL SETGDS (DISKIN, OLDCNO, NAM2IN, CLA2IN, SEQ2, DISK2, NMAP,
     *   VER, NITER, BITER, MODEL, METHOD, CCPOS, IABUF, I, IERR)
C                                      If not found => no model plot.
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
      FACGRD(1) = 1.0
      CALL FACSET (DISKIN, OLDCNO, IBIF, IDN(1), 1, 1.0, IERR)
      IF (IERR.NE.0) GO TO 999
      DO 120 IMAP = 1,NMAP
C                                       Read catalog block
         CALL CATIO ('READ', CCDISK(IMAP), CCCNO(IMAP), CATCLN, 'REST',
     *      IABUF, IERR)
         IF (IERR.NE.0) GO TO 120
         IF (IMAP.EQ.1) THEN
            XS2IN = CATCLN(KIIMS)
            XDI2IN = CCDISK(1)
            CALL H2CHR (12, KHIMNO, CATCLH(KHIMN), NAM2IN)
            CALL H2CHR (6, KHIMCO, CATCLH(KHIMC), NAM2IN)
            CALL CHR2H (12, NAM2IN, 1, XNAM2I)
            CALL CHR2H (6, CLA2IN, 1, XCLA2I)
            END IF
C                                       set rest parameters
         CALL GRDAT (.FALSE., IMAP, CATR, IABUF, IERR)
         IF (IERR.NE.0) GO TO 120
C                                       Set field center offsets.
         XXOFF = DXCG(IMAP) * CCROT + DYCG(IMAP) * SSROT
         YYOFF = DYCG(IMAP) * CCROT - DXCG(IMAP) * SSROT
         ZZOFF = DZCG(IMAP)
         IF (DO3DIM) THEN
            CALL XYSHFT (RA, DEC, XSHIFT(IMAP), YSHIFT(IMAP),
     *         MAPROT, XRA, XDEC)
            CALL PRJMAT (RA, DEC, UVROT, XRA, XDEC, MAPROT, UMAT,
     *         PMAT)
            END IF
C                                       Get model.
C                                       Open CLEAN component file.
         CALL CCMINI ('READ', IBUFF1, CCDISK(IMAP), CCCNO(IMAP), VER,
     *      CATCLN, LUNB, CCRNO, CCKOLS, CCNUMV, CCNCOL, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR
            GO TO 990
            END IF
         DO3D = CCNUMV(4).GT.0
C                                       Get number of components
         LIMIT = NITER(IMAP)
         IF (LIMIT.LE.0) GO TO 100
         DOGAUS = F
         DOSPHE = F
         DO 90 I = 1,LIMIT
            CCRNO = I
            CALL TABCCM ('READ', IBUFF1, CCRNO, CCKOLS, CCNUMV, CCNCOL,
     *         XX, YY, ZZ, FLUX, CCTYPE, PARMS, IERR)
            IF (IERR.LT.0) GO TO 90
            IF (IERR.GT.0) THEN
               WRITE (MSGTXT,1030) IERR, I
               GO TO 990
               END IF
            IF (ABS(FLUX).LT.LIMFLX) GO TO 100
            IF ((NONEG) .AND. (FLUX.LT.0.0)) GO TO 100
C                                       Deal with component.
            NCOUNT = NCOUNT + 1
            IF (NCOUNT.GT.MAXCC) GO TO 100
C                                       No need to shift the components
C                                       since this already done in the
C                                       CLEANing task.
            IF (.NOT.DO3D) THEN
               XP(1) = (XX + XPOFF(IMAP)) * DG2RAD * TWOPI
               XP(2) = (YY + YPOFF(IMAP)) * DG2RAD * TWOPI
               IF (DO3DIM) THEN
                  XP(3) = 0.0
                  CALL PRJMUL (2, XP, UMAT, XYZ)
               ELSE
                  XYZ(1) = CCROT * XP(1) + SSROT * XP(2)
                  XYZ(2) = CCROT * XP(2) - SSROT * XP(1)
                  XYZ(3) = 0.0
                  END IF
               CCPOS(1,NCOUNT) = XYZ(1) + XXOFF
               CCPOS(2,NCOUNT) = XYZ(2) + YYOFF
               CCPOS(3,NCOUNT) = XYZ(3) + ZZOFF
            ELSE
               CCPOS(1,NCOUNT) = XX * DG2RAD * TWOPI
               CCPOS(2,NCOUNT) = YY * DG2RAD * TWOPI
               CCPOS(3,NCOUNT) = ZZ * DG2RAD * TWOPI
               END IF
            SFLUX(NCOUNT) = FLUX * FACGRD(1)
            GAUSA(NCOUNT) = 0
            GAUSB(NCOUNT) = 0
            GAUSC(NCOUNT) = 0
C                                       See if gaussian
            IF (MOD(CCTYPE,2).EQ.1) THEN
C                                       Convert to radians
               GAUSA(NCOUNT) = PARMS(1) * DG2RAD
               GAUSB(NCOUNT) = PARMS(2) * DG2RAD
               GAUSC(NCOUNT) = PARMS(3) * DG2RAD
               DOGAUS = CCTYPE.EQ.1
               DOSPHE = CCTYPE.EQ.3
               END IF
 90         CONTINUE
C                                       Close CLNFIL.
 100     CALL TABCCM ('CLOS', IBUFF1, CCRNO, CCKOLS, CCNUMV, CCNCOL,
     *      XX, YY, ZZ, FLUX, CCTYPE, PARMS, IERR)
         IF (IERR .NE. 0) THEN
            WRITE (MSGTXT,1060) IERR
            GO TO 990
            END IF
         IF (NCOUNT.GT.MAXCC) GO TO 130
 120     CONTINUE
      NUMCC = NCOUNT
      GO TO 140
 130  NUMCC = MAXCC
C                                       Convert gaussian parameters
 140  CALL UNSETG (IBUFF1)
      IF ((NUMCC.GT.0) .AND. (DOGAUS)) THEN
         DO 150 I = 1,NUMCC
            XTEMPC = GAUSC(I)
            AM = COS ((XTEMPC+UVROT-MAPROT)*DG2RAD)
            AN = SIN ((XTEMPC+UVROT-MAPROT)*DG2RAD)
            TA = GAUSA(I) * PI / 1.1774
            TB = GAUSB(I) * PI / 1.1774
            GAUSA(I) = -(TA*TA*AM*AM + TB*TB*AN*AN)
            GAUSB(I) = -((TB*TB-TA*TA) * AN*AM)
            GAUSC(I) = -(TA*TA*AN*AN + TB*TB*AM*AM)
 150        CONTINUE
         END IF
C                                       Convert sphere parameters
      IF ((NUMCC.GT.0) .AND. (DOSPHE)) THEN
         DO 170 I = 1,NUMCC
            GAUSA(I) = GAUSA(I) * TWOPI
 170        CONTINUE
         END IF
C
 200  IERR = 0
C      XCOMP = NCOUNT
C      IF ((NITER.LE.0) .OR. (NUMCC.LE.0)) XCOMP = 0.0
      GO TO 999
C                                        Error.
 990  CALL MSGWRT (8)
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('REEDIN: ERROR',I3,' OPENING CC FILES')
 1030 FORMAT ('REEDIN: READ ERROR',I3,' RECORD ',I5)
 1060 FORMAT ('REEDIN: ERROR',I3,' CLOSING FILE ')
      END
      SUBROUTINE MODPTS (UVW, PDATA)
C-----------------------------------------------------------------------
C   Subroutine to return 1 model value for a given set of clean
C   components and for a single data sample on 3 baselines
C   Inputs:
C      IVW     R(3,3)   U,V,W of 3 baselines
C   Input from common /COMPS/
C      CCPOS(3,MAXCC) R     Distance from ref. X-pixel in turns.
C      SFLUX(MAXCC)   R     Flux in pixel XX, YY in Jansky
C      GAUSA(MAXCC)   R     Gaussian coefficient for u*u
C      GAUSB(MAXCC)   R     Gaussian coefficient for u*v
C      GAUSC(MAXCC)   R     Gaussian coefficient for v*v
C      NUMCC          I     Number of pixels actually processed.
C   Output:
C      PDATA          R     Closure phase of model
C   This subroutine gets information from common /CANIN/ set up by
C   subroutine ANTIN
C-----------------------------------------------------------------------
      REAL      UVW(3,3), PDATA
C
      DOUBLE PRECISION AA
      REAL      CSUM, SSUM, TEMP, AMODL, FAZ(3), ARG, FTEMP
      INTEGER   K, I
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'CLPLT.INC'
C-----------------------------------------------------------------------
      DO 100 I = 1,3
         CSUM = 0.0
         SSUM = 0.0
C                                       calculate model sin/cos amps.
C                                       Spherical model
C                                       Trap very unresolved - needed to
C                                       prevent serious precision loss.
         IF (DOSPHE) THEN
            DO 25 K = 1,NUMCC
               AA = GAUSA(K) * SQRT (UVW(1,I)*UVW(1,I) +
     *            UVW(2,I)*UVW(2,I))
               IF (AA.LT.6.28D-2) AA = 6.28D-2
               FTEMP = 3.0D0 * SFLUX(K) *
     *            ((SIN(AA) / (AA*AA*AA)) - (COS(AA) / (AA*AA)))
               TEMP = UVW(1,I) * CCPOS(1,K) + UVW(2,I) * CCPOS(2,K) +
     *            UVW(3,I) * CCPOS(3,K)
               SSUM = SSUM + FTEMP * SIN (TEMP)
               CSUM = CSUM + FTEMP * COS (TEMP)
 25            CONTINUE
C                                       Gaussian
         ELSE IF (DOGAUS) THEN
            DO 30 K = 1,NUMCC
               ARG = UVW(1,I) * UVW(1,I) * GAUSA(K) +
     *            UVW(1,I) * UVW(2,I) * GAUSB(K) +
     *            UVW(2,I) * UVW(2,I) * GAUSC(K)
               IF (ARG.GT.-8.0) THEN
                  FTEMP = SFLUX(K) * EXP(ARG)
                  TEMP = UVW(1,I) * CCPOS(1,K) + UVW(2,I) * CCPOS(2,K) +
     *               UVW(3,I) * CCPOS(3,K)
                  SSUM = SSUM + FTEMP * SIN (TEMP)
                  CSUM = CSUM + FTEMP * COS (TEMP)
                  END IF
 30            CONTINUE
C                                       Point
         ELSE
            DO 35 K = 1,NUMCC
               FTEMP = SFLUX(K)
               TEMP = UVW(1,I) * CCPOS(1,K) + UVW(2,I) * CCPOS(2,K) +
     *            UVW(3,I) * CCPOS(3,K)
               SSUM = SSUM + FTEMP * SIN (TEMP)
               CSUM = CSUM + FTEMP * COS (TEMP)
 35            CONTINUE
            END IF
C                                       Finished computing model
         AMODL = SQRT (SSUM*SSUM + CSUM*CSUM)
         FAZ(I) = FBLANK
         IF (AMODL.GT.1.E-10) THEN
            FAZ(I) = ATAN2 (SSUM, CSUM) / DG2RAD
 40         IF (FAZ(I).GT.180.0) FAZ(I) = FAZ(I) - 360.0
               IF (FAZ(I).LT.-180.0) FAZ(I) = FAZ(I) + 360.0
               IF (FAZ(I).GT.180.0) GO TO 40
               IF (FAZ(I).LT.-180.0) GO TO 40
            END IF
 100     CONTINUE
C                                       combine
      IF ((FAZ(1).EQ.FBLANK) .OR. (FAZ(2).EQ.FBLANK) .OR.
     *   (FAZ(3).EQ.FBLANK)) THEN
         PDATA = FBLANK
      ELSE
         PDATA = FAZ(1) - FAZ(2) + FAZ(3)
         IF (PDATA.GT.180.0) PDATA = PDATA - 360.0
         IF (PDATA.GT.180.0) PDATA = PDATA - 360.0
         IF (PDATA.LT.-180.0) PDATA = PDATA + 360.0
         IF (PDATA.LT.-180.0) PDATA = PDATA + 360.0
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZRENAM (IVOL, OLDNAM, NEWNAM, IERR)
C-----------------------------------------------------------------------
C! rename a disk file
C# Z IO-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Rename a disk file.
C   Inputs:
C      IVOL     I      Disk volume containing files, 1,2,3,...
C      OLDNAM   C*48   Old physical file name
C      NEWNAM   C*48   New physical file name
C   Output:
C      IERR     I      Error return code: 0 => ok
C                         2 => old file not found
C                         3 => volume not found
C                         4 => old file busy
C                         6 => new file name already exists
C                         7 => other
C   UNICOS version.
C-----------------------------------------------------------------------
      INTEGER   IVOL, IERR
      CHARACTER OLDNAM*48, NEWNAM*48
C
      HOLLERITH OLD(12), NEW(12)
      INTEGER   SYSERR
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C      CALL CHR2H (48, OLDNAM, 1, OLD)
C      CALL CHR2H (48, NEWNAM, 1, NEW)
C                                       Rename the file.
      CALL ZRENA2 (OLDNAM, NEWNAM, SYSERR, IERR)
      IF (IERR.NE.0) THEN
C                                       File not found.
         IF (IERR.EQ.2) THEN
            WRITE (MSGTXT,1002) OLDNAM(1:24), IERR
C                                       Invalid device name(s).
         ELSE IF (IERR.EQ.3) THEN
            WRITE (MSGTXT,1003) OLDNAM(1:4), NEWNAM(1:4), IERR
C                                       File in use.
         ELSE IF (IERR.EQ.4) THEN
            WRITE (MSGTXT,1004) OLDNAM(1:24), IERR
C                                       New file name already exists.
         ELSE IF (IERR.EQ.6) THEN
            WRITE (MSGTXT,1006) NEWNAM(1:24), IERR
C                                       Other ZRENA2 error.
         ELSE
            WRITE (MSGTXT,1007) OLDNAM(1:24), NEWNAM(1:24), IERR
            CALL MSGWRT (6)
            CALL ZERROR ('ZRENA2', SYSERR, OLDNAM, -999, .FALSE.)
            GO TO 999
            END IF
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1002 FORMAT ('ZRENAM: FILE ',A24,' NOT FOUND. IERR=',I4)
 1003 FORMAT ('ZRENAM: NO SUCH LOGICAL DEVICE = ',A4,' OR ',A4,
     *   '. IERR=',I4)
 1004 FORMAT ('ZRENAM: FILE ',A24,' IN USE. IERR=',I4)
 1006 FORMAT ('ZRENAM: ',A24,' ALREADY EXISTS. IERR=',I4)
 1007 FORMAT ('ZRENAM: ',A24,1X,A24,' IERR=',I4)
      END

      SUBROUTINE TABHF (OPCODE, BUFFER, IHFRNO, HFKOLS, HFNUMV,
     *   CC1, IC2, IC3, IC4, IC5, IC6, IC7, IC8, IC9, IC10, IC11, IC12,
     *   IC13, IC14, IC15, IC16, IC17, IC18, IC19, IC20, IC21, IC22,
     *   IC23, IC24, CC25, CC26, CC27, CC28, CC29, CC30, CC31, CC32,
     *   CC33, CC34, CC35, CC36, CC37, CC38, DC39, DC40, DC41, DC42,
     *   DC43, DC44, DC45, DC46, DC47, DC48, DC49, DC50, RC51, RC52,
     *   RC53, RC54, RC55, RC56, RC57, RC58, RC59, RC60, RC61, RC62,
     *   RC63, RC64, RC65, RC66, RC67, RC68, RC69, RC70, RC71, RC72,
     *   RC73, RC74, RC75, RC76, RC77,
     *   IERR)
C-----------------------------------------------------------------------
C! Does I/O to Haystack MkIII FRNGE tables (HF)
C# EXT-util VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to MkIII FRNGE (VLBI fringe fitting) tables. Usually used
C   after setup by HFINI.
C    Inputs:
C     OPCODE   C*4     Operation code:
C                      'READ' = read entry from table.
C                      'WRIT' = write entry in table.
C                      'CLOS' = close file, flush on write
C     BUFFER   I(1024) I/O buffer and related storage, also defines file
C                      if open. Should have been returned by TABINI or
C                      TABINI.
C     IHFRNO   I       Next scan number to read or write.
C     HFKOLS   I(*)    The column pointer array in order
C     HFNUMV   I(*)    Element count in each column.
C    Input/output: (written to or read from HF file)
C       CC1   C*2   Baseline code
C       IC2   I(6)  UTC time tag (YMDHMS) EPOCH for delay and rate
C       IC3   I(6)  UTC of FRNGE processing (YMDHMS)
C       IC4   I(4)  ARCHIV
C       IC5   I     Sample rate in kbits/sec
C       IC6   I     no. frames per parameter period
C       IC7   I     Pass number
C       IC8   I     #U/L sideband pairs included in this processing
C                   (i.e. # of discrete LO frequencies)
C       IC9   I(28) #Accumulation periods by sideband by channel
C       IC10  I(56) (2,2,14)  Track # table in order of:
C                      Station #
C                      Refer/partn Sideband
C                      Channel #
C       IC11  I     COREL version #
C       IC12  I(6)  UTC time tag (YMDHMS)  EPOCH for "central" EPOCH
C       IC13  I     LU of printout (for FRNGP)
C       IC14  I     Ref. tape drive number
C       IC15  I     Rem. tape drive number
C       IC16  I     Special options NAME(211)
C       IC17  I     Integer value of PARAM(250) [=999 for special PCAL
C                   by AP]
C       IC18  I(28) CORELXTNT(2,14)  COREL extent# from which each track
C                   is taken.
C       IC19  I(84) CALBYFRQ(3,2,14) Phase-cal amp, phase and freq by
C                   station and channel normalized as follows:
C                      AMP 0 to 10000(in voltage) -1=manual cal
C                      PHS -18000 to +18000
C                      frq  kHz
C       IC20  I(28) PROCUTC(2,14) COREL processing UT (YDDD) by sideband
C                   and channel.
C       IC21  I(56) ERRORATE(2,2,14) Tape error rate by station,
C                   sideband and channel encoded as:
C                      1000*LOGT(error rate)
C                      (=-32000 if no errors)
C       IC22  I(28) INDEX(2,14) COREL index #s by sideband and FRNGE CH#
C       IC23  I     FRNGE error code 0=OK NE.0 Don't use
C       IC24  I     SBDOFFST flag 1=this run had sideband fixup
C       CC25  C*8   STAR ID, Radio source name
C       CC26  C*8   First antenna name of baseline
C       CC27  C*8   Second antenna of baseline
C       CC28  C*6   CORELFILE COREL correlation output file name
C       CC29  C*8   first raw-data tape ID label
C       CC30  C*8   second raw-data tape ID label
C       CC31  C*6   VLB2PRG FRNGE program version YYMMDD
C       CC32  C*8   RUN CODE  Run code, e.g. "329-1300"
C       CC33  C*1   FRNGE quality code 0=no good, 1=very poor, 9=very
C                   good, A=has FRNGE error code=1,B=2 etc.
C       CC34  C*2   Frequency group code
C       CC35  C*6   Original COREL file name
C       CC36  C*6   Tape Q code
C       CC37  C*8   Ref station occupation code
C       CC38  C*8   Rem station occupation code
C       DC39  D(14) RFREQ(14) LO frequencies (MHz) by channel
C       DC40  D     REF FREQ RF freq (MHz) to which phase is referred
C       DC41  D     DEL OBSV Observed group delay in microseconds
C                   equals single band delay if only one freq.
C                   processed.  DELOBSV=T2=T1, T1=time of arrival at
C                   site 1 (reference site) as measured by the site
C                   clock at site 1, T2=time of signal arrival at site 2
C                   as measured by site clock at site 2.  The signal in
C                   question is the one which arrives at site 1 at a UTC
C                   time equal to that given as the UTC epoch.
C       DC42  D     RAT OBSV  Observed delay rate (usec/sec) corrected
C                   for the phase cal rate.
C       DC43  D     NB DELAY Narrow-band group-delay (usec)
C       DC44  D     DGPD group delay ambig. (usec)
C       DC45  D     BTE0 Apriori clock (usec)
C       DC46  D     EPOCH0  ref. st. clock epoch (usec)
C       DC47  D     DEL OBSVM observed delay at central epoch
C       DC48  D     RAT OBSVM observed delay rate at central epoch
C       DC49  D     DLY2 phase delay at EPO+1 sec
C       DC50  D     DLY3 phase delay at EPO-1 sec.
C       RC51  R(28) AMBYFRQ(2,14) Amp and phase by channel 1=100%
C                   phase=-180 to 180 deg. residual to COREL and
C                   uncorrected for PCAL rate.
C       RC52  R(2)  Phase cal rate by station (usec/sec)
C       RC53  R     DELRESID Delay residual to COREL a priori.
C       RC54  R     DELSIGMA Calculated delay error (usec)
C       RC55  R     RATRESID Delay-rate residual to COREL a priori
C                   (usec/sec) corrected for phase cal rates.
C       RC56  R     RATSIGMA Calculate delay-rate error (usec/sec)
C       RC57  R     COHERCOR Coherent multi-freq correlation
C                   coefficient. (1=100% correlation)
C       RC58  R     TOTPHASE Total observed fringe phase (deg)
C       RC59  R(2)  UVF/ASEC Fringes per asec in N-S and E-W
C       RC60  R(2)  STARELEV Calculated star elevations run reference
C                   time by station (deg).
C       RC61  R     AAMP FRNGE amplitude fro incoherent addition of
C                   frequency channels.
C       RC62  R(2)  URVRSEC Rate derivatives mHz/sec arc
C       RC63  R(6)  SRCHPAR Search parameters
C       RC64  R     DEPSBRES Single band delay residual (usec)
C       RC65  R     SNR Signal to noise ratio in sigma.
C       RC66  R     PROB Probability of a false detection.
C       RC67  R     INCOH Incoherent segmented fringe amp. in units of
C                   10,000.
C       RC68  R     EARP total phase refered to an epoch at time the
C                   signal reaches the center of teh earth.
C       RC69  R     REARP Residual phase corrected to earth centered
C                   epoch
C       RC70  R     START Start time in seconds past hour
C       RC71  R     STOP Stop time in seconds past hour
C       RC72  R     EPD Epoch offset from center of run in sec.
C       RC73  R     DUR Effective run duration in seconds.
C       RC74  R     DELSS Single-band delay error in microsec.
C       RC75  R     QB Ratio of min to max data accepted in %
C       RC76  R     DISCD % data discarded
C       RC77  R     TOTPM Total phase at central epoch
C    Output:
C       IHFRNO I      Next row number.
C       IERR   I      Error code, 0=>OK else TABIO error.
C                    Note: -1=> read but record deselected.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4,
     *   CC1*2, CC25*8, CC26*8, CC27*8, CC28*6, CC29*8, CC30*8, CC31*6,
     *   CC32*8, CC33*1, CC34*2, CC35*6, CC36*6, CC37*8, CC38*8
      INTEGER   BUFFER(*), IHFRNO, HFKOLS(*), HFNUMV(*), IERR,
     *   IC2(6), IC3(6), IC4(4), IC5, IC6, IC7, IC8, IC9(28), IC10(56),
     *   IC11, IC12(6), IC13, IC14, IC15, IC16, IC17, IC18(28),
     *   IC19(84), IC20(28), IC21(56), IC22(28), IC23, IC24
      REAL      RC51(28), RC52(2), RC53, RC54, RC55, RC56, RC57, RC58,
     *   RC59(2), RC60(2), RC61, RC62(2), RC63(6), RC64, RC65, RC66,
     *   RC67, RC68, RC69, RC70, RC71, RC72, RC73, RC74, RC75, RC76,
     *   RC77
      DOUBLE PRECISION DC39(14), DC40, DC41, DC42, DC43, DC44, DC45,
     *   DC46, DC47, DC48, DC49, DC50
C
      INCLUDE 'INCS:PUVD.INC'
C                                       MAXHFC = no. col. in table
      INTEGER   MAXHFC
      PARAMETER (MAXHFC = 77)
      INTEGER   RECI(512), NCOPY
      LOGICAL   DOREAD, DOCLOS
      REAL      RECORD(512)
      HOLLERITH RECH(512)
      DOUBLE PRECISION RECD(256)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (RECD, RECORD, RECI, RECH)
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
      DOCLOS = OPCODE.EQ.'CLOS'
C                                       Branch for CLOS
      IF (DOCLOS) GO TO 800
C                                       If write fill RECORD
      IF (.NOT.DOREAD) THEN
         CALL CHR2H (2, CC1, 1, RECH(HFKOLS(1)))
         CALL COPY (HFNUMV(2), IC2(1), RECI(HFKOLS(2)))
         CALL COPY (HFNUMV(3), IC3(1), RECI(HFKOLS(3)))
         CALL COPY (HFNUMV(4), IC4(1), RECI(HFKOLS(4)))
         CALL COPY (HFNUMV(5), IC5, RECI(HFKOLS(5)))
         CALL COPY (HFNUMV(6), IC6, RECI(HFKOLS(6)))
         CALL COPY (HFNUMV(7), IC7, RECI(HFKOLS(7)))
         CALL COPY (HFNUMV(8), IC8, RECI(HFKOLS(8)))
         CALL COPY (HFNUMV(9), IC9(1), RECI(HFKOLS(9)))
         CALL COPY (HFNUMV(10), IC10(1), RECI(HFKOLS(10)))
         CALL COPY (HFNUMV(11), IC11, RECI(HFKOLS(11)))
         CALL COPY (HFNUMV(12), IC12(1), RECI(HFKOLS(12)))
         CALL COPY (HFNUMV(13), IC13, RECI(HFKOLS(13)))
         CALL COPY (HFNUMV(14), IC14, RECI(HFKOLS(14)))
         CALL COPY (HFNUMV(15), IC15, RECI(HFKOLS(15)))
         CALL COPY (HFNUMV(16), IC16, RECI(HFKOLS(16)))
         CALL COPY (HFNUMV(17), IC17, RECI(HFKOLS(17)))
         CALL COPY (HFNUMV(18), IC18(1), RECI(HFKOLS(18)))
         CALL COPY (HFNUMV(19), IC19(1), RECI(HFKOLS(19)))
         CALL COPY (HFNUMV(20), IC20(1), RECI(HFKOLS(20)))
         CALL COPY (HFNUMV(21), IC21(1), RECI(HFKOLS(21)))
         CALL COPY (HFNUMV(22), IC22(2), RECI(HFKOLS(22)))
         CALL COPY (HFNUMV(23), IC23, RECI(HFKOLS(23)))
         CALL COPY (HFNUMV(24), IC24, RECI(HFKOLS(24)))
         CALL CHR2H (HFNUMV(25), CC25, 1, RECH(HFKOLS(25)))
         CALL CHR2H (HFNUMV(26), CC26, 1, RECH(HFKOLS(26)))
         CALL CHR2H (HFNUMV(27), CC27, 1, RECH(HFKOLS(27)))
         CALL CHR2H (HFNUMV(28), CC28, 1, RECH(HFKOLS(28)))
         CALL CHR2H (HFNUMV(29), CC29, 1, RECH(HFKOLS(29)))
         CALL CHR2H (HFNUMV(30), CC30, 1, RECH(HFKOLS(30)))
         CALL CHR2H (HFNUMV(31), CC31, 1, RECH(HFKOLS(31)))
         CALL CHR2H (HFNUMV(32), CC32, 1, RECH(HFKOLS(32)))
         CALL CHR2H (HFNUMV(33), CC33, 1, RECH(HFKOLS(33)))
         CALL CHR2H (HFNUMV(34), CC34, 1, RECH(HFKOLS(34)))
         CALL CHR2H (HFNUMV(35), CC35, 1, RECH(HFKOLS(35)))
         CALL CHR2H (HFNUMV(36), CC36, 1, RECH(HFKOLS(36)))
         CALL CHR2H (HFNUMV(37), CC37, 1, RECH(HFKOLS(37)))
         CALL CHR2H (HFNUMV(38), CC38, 1, RECH(HFKOLS(38)))
         NCOPY = HFNUMV(39)
         CALL DPCOPY (NCOPY, DC39(1), RECD(HFKOLS(39)))
         NCOPY = HFNUMV(40)
         CALL DPCOPY (NCOPY, DC40, RECD(HFKOLS(40)))
         NCOPY = HFNUMV(41)
         CALL DPCOPY (NCOPY, DC41, RECD(HFKOLS(41)))
         NCOPY = HFNUMV(42)
         CALL DPCOPY (NCOPY, DC42, RECD(HFKOLS(42)))
         NCOPY = HFNUMV(43)
         CALL DPCOPY (NCOPY, DC43, RECD(HFKOLS(43)))
         NCOPY = HFNUMV(44)
         CALL DPCOPY (NCOPY, DC44, RECD(HFKOLS(44)))
         NCOPY = HFNUMV(45)
         CALL DPCOPY (NCOPY, DC45, RECD(HFKOLS(45)))
         NCOPY = HFNUMV(46)
         CALL DPCOPY (NCOPY, DC46, RECD(HFKOLS(46)))
         NCOPY = HFNUMV(47)
         CALL DPCOPY (NCOPY, DC47, RECD(HFKOLS(47)))
         NCOPY = HFNUMV(48)
         CALL DPCOPY (NCOPY, DC48, RECD(HFKOLS(48)))
         NCOPY = HFNUMV(49)
         CALL DPCOPY (NCOPY, DC49, RECD(HFKOLS(49)))
         NCOPY = HFNUMV(50)
         CALL DPCOPY (NCOPY, DC50, RECD(HFKOLS(50)))
         CALL RCOPY (HFNUMV(51), RC51(1), RECORD(HFKOLS(51)))
         CALL RCOPY (HFNUMV(52), RC52(1), RECORD(HFKOLS(52)))
         CALL RCOPY (HFNUMV(53), RC53, RECORD(HFKOLS(53)))
         CALL RCOPY (HFNUMV(54), RC54, RECORD(HFKOLS(54)))
         CALL RCOPY (HFNUMV(55), RC55, RECORD(HFKOLS(55)))
         CALL RCOPY (HFNUMV(56), RC56, RECORD(HFKOLS(56)))
         CALL RCOPY (HFNUMV(57), RC57, RECORD(HFKOLS(57)))
         CALL RCOPY (HFNUMV(58), RC58, RECORD(HFKOLS(58)))
         CALL RCOPY (HFNUMV(59), RC59(1), RECORD(HFKOLS(59)))
         CALL RCOPY (HFNUMV(60), RC60(1), RECORD(HFKOLS(60)))
         CALL RCOPY (HFNUMV(61), RC61, RECORD(HFKOLS(61)))
         CALL RCOPY (HFNUMV(62), RC62(1), RECORD(HFKOLS(62)))
         CALL RCOPY (HFNUMV(63), RC63(1), RECORD(HFKOLS(63)))
         CALL RCOPY (HFNUMV(64), RC64, RECORD(HFKOLS(64)))
         CALL RCOPY (HFNUMV(65), RC65, RECORD(HFKOLS(65)))
         CALL RCOPY (HFNUMV(66), RC66, RECORD(HFKOLS(66)))
         CALL RCOPY (HFNUMV(67), RC67, RECORD(HFKOLS(67)))
         CALL RCOPY (HFNUMV(68), RC68, RECORD(HFKOLS(68)))
         CALL RCOPY (HFNUMV(69), RC69, RECORD(HFKOLS(69)))
         CALL RCOPY (HFNUMV(70), RC70, RECORD(HFKOLS(70)))
         CALL RCOPY (HFNUMV(71), RC71, RECORD(HFKOLS(71)))
         CALL RCOPY (HFNUMV(72), RC72, RECORD(HFKOLS(72)))
         CALL RCOPY (HFNUMV(73), RC73, RECORD(HFKOLS(73)))
         CALL RCOPY (HFNUMV(74), RC74, RECORD(HFKOLS(74)))
         CALL RCOPY (HFNUMV(75), RC75, RECORD(HFKOLS(75)))
         CALL RCOPY (HFNUMV(76), RC76, RECORD(HFKOLS(76)))
         CALL RCOPY (HFNUMV(77), RC77, RECORD(HFKOLS(77)))
         END IF
C                                       Process record.
      CALL TABIO (OPCODE, 0, IHFRNO, RECORD, BUFFER, IERR)
      IHFRNO = IHFRNO + 1
      IF (IERR.GT.0) GO TO 990
C                                       If READ pick data from RECORD.
      IF (DOREAD) THEN
         CALL H2CHR (2, 1, RECH(HFKOLS(1)), CC1)
         CALL COPY (HFNUMV(2), RECI(HFKOLS(2)), IC2(1))
         CALL COPY (HFNUMV(3), RECI(HFKOLS(3)), IC3(1))
         CALL COPY (HFNUMV(4), RECI(HFKOLS(4)), IC4(1))
         CALL COPY (HFNUMV(5), RECI(HFKOLS(5)), IC5)
         CALL COPY (HFNUMV(6), RECI(HFKOLS(6)), IC6)
         CALL COPY (HFNUMV(7), RECI(HFKOLS(7)), IC7)
         CALL COPY (HFNUMV(8), RECI(HFKOLS(8)), IC8)
         CALL COPY (HFNUMV(9), RECI(HFKOLS(9)), IC9(1))
         CALL COPY (HFNUMV(10), RECI(HFKOLS(10)), IC10(1))
         CALL COPY (HFNUMV(11), RECI(HFKOLS(11)), IC11)
         CALL COPY (HFNUMV(12), RECI(HFKOLS(12)), IC12(1))
         CALL COPY (HFNUMV(13), RECI(HFKOLS(13)), IC13)
         CALL COPY (HFNUMV(14), RECI(HFKOLS(14)), IC14)
         CALL COPY (HFNUMV(15), RECI(HFKOLS(15)), IC15)
         CALL COPY (HFNUMV(16), RECI(HFKOLS(16)), IC16)
         CALL COPY (HFNUMV(17), RECI(HFKOLS(17)), IC17)
         CALL COPY (HFNUMV(18), RECI(HFKOLS(18)), IC18(1))
         CALL COPY (HFNUMV(19), RECI(HFKOLS(19)), IC19(1))
         CALL COPY (HFNUMV(20), RECI(HFKOLS(20)), IC20(1))
         CALL COPY (HFNUMV(21), RECI(HFKOLS(21)), IC21(1))
         CALL COPY (HFNUMV(22), RECI(HFKOLS(22)), IC22(1))
         CALL COPY (HFNUMV(23), RECI(HFKOLS(23)), IC23)
         CALL COPY (HFNUMV(24), RECI(HFKOLS(24)), IC24)
         CALL H2CHR (HFNUMV(25), 1, RECH(HFKOLS(25)), CC25)
         CALL H2CHR (HFNUMV(26), 1, RECH(HFKOLS(26)), CC26)
         CALL H2CHR (HFNUMV(27), 1, RECH(HFKOLS(27)), CC27)
         CALL H2CHR (HFNUMV(28), 1, RECH(HFKOLS(28)), CC28)
         CALL H2CHR (HFNUMV(29), 1, RECH(HFKOLS(29)), CC29)
         CALL H2CHR (HFNUMV(30), 1, RECH(HFKOLS(30)), CC30)
         CALL H2CHR (HFNUMV(31), 1, RECH(HFKOLS(31)), CC31)
         CALL H2CHR (HFNUMV(32), 1, RECH(HFKOLS(32)), CC32)
         CALL H2CHR (HFNUMV(33), 1, RECH(HFKOLS(33)), CC33)
         CALL H2CHR (HFNUMV(34), 1, RECH(HFKOLS(34)), CC34)
         CALL H2CHR (HFNUMV(35), 1, RECH(HFKOLS(35)), CC35)
         CALL H2CHR (HFNUMV(36), 1, RECH(HFKOLS(36)), CC36)
         CALL H2CHR (HFNUMV(37), 1, RECH(HFKOLS(37)), CC37)
         CALL H2CHR (HFNUMV(38), 1, RECH(HFKOLS(38)), CC38)
         NCOPY = HFNUMV(39)
         CALL DPCOPY (NCOPY, RECD(HFKOLS(39)), DC39(1))
         NCOPY = HFNUMV(40)
         CALL DPCOPY (NCOPY, RECD(HFKOLS(40)), DC40)
         NCOPY = HFNUMV(41)
         CALL DPCOPY (NCOPY, RECD(HFKOLS(41)), DC41)
         NCOPY = HFNUMV(42)
         CALL DPCOPY (NCOPY, RECD(HFKOLS(42)), DC42)
         NCOPY = HFNUMV(43)
         CALL DPCOPY (NCOPY, RECD(HFKOLS(43)), DC43)
         NCOPY = HFNUMV(44)
         CALL DPCOPY (NCOPY, RECD(HFKOLS(44)), DC44)
         NCOPY = HFNUMV(45)
         CALL DPCOPY (NCOPY, RECD(HFKOLS(45)), DC45)
         NCOPY = HFNUMV(46)
         CALL DPCOPY (NCOPY, RECD(HFKOLS(46)), DC46)
         NCOPY = HFNUMV(47)
         CALL DPCOPY (NCOPY, RECD(HFKOLS(47)), DC47)
         NCOPY = HFNUMV(48)
         CALL DPCOPY (NCOPY, RECD(HFKOLS(48)), DC48)
         NCOPY = HFNUMV(49)
         CALL DPCOPY (NCOPY, RECD(HFKOLS(49)), DC49)
         NCOPY = HFNUMV(50)
         CALL DPCOPY (NCOPY, RECD(HFKOLS(50)), DC50)
         CALL RCOPY (HFNUMV(51), RECORD(HFKOLS(51)), RC51(1))
         CALL RCOPY (HFNUMV(52), RECORD(HFKOLS(52)), RC52(1))
         CALL RCOPY (HFNUMV(53), RECORD(HFKOLS(53)), RC53)
         CALL RCOPY (HFNUMV(54), RECORD(HFKOLS(54)), RC54)
         CALL RCOPY (HFNUMV(55), RECORD(HFKOLS(55)), RC55)
         CALL RCOPY (HFNUMV(56), RECORD(HFKOLS(56)), RC56)
         CALL RCOPY (HFNUMV(57), RECORD(HFKOLS(57)), RC57)
         CALL RCOPY (HFNUMV(58), RECORD(HFKOLS(58)), RC58)
         CALL RCOPY (HFNUMV(59), RECORD(HFKOLS(59)), RC59(1))
         CALL RCOPY (HFNUMV(60), RECORD(HFKOLS(60)), RC60(1))
         CALL RCOPY (HFNUMV(61), RECORD(HFKOLS(61)), RC61)
         CALL RCOPY (HFNUMV(62), RECORD(HFKOLS(62)), RC62(1))
         CALL RCOPY (HFNUMV(63), RECORD(HFKOLS(63)), RC63(1))
         CALL RCOPY (HFNUMV(64), RECORD(HFKOLS(64)), RC64)
         CALL RCOPY (HFNUMV(65), RECORD(HFKOLS(65)), RC65)
         CALL RCOPY (HFNUMV(66), RECORD(HFKOLS(66)), RC66)
         CALL RCOPY (HFNUMV(67), RECORD(HFKOLS(67)), RC67)
         CALL RCOPY (HFNUMV(68), RECORD(HFKOLS(68)), RC68)
         CALL RCOPY (HFNUMV(69), RECORD(HFKOLS(69)), RC69)
         CALL RCOPY (HFNUMV(70), RECORD(HFKOLS(70)), RC70)
         CALL RCOPY (HFNUMV(71), RECORD(HFKOLS(71)), RC71)
         CALL RCOPY (HFNUMV(72), RECORD(HFKOLS(72)), RC72)
         CALL RCOPY (HFNUMV(73), RECORD(HFKOLS(73)), RC73)
         CALL RCOPY (HFNUMV(74), RECORD(HFKOLS(74)), RC74)
         CALL RCOPY (HFNUMV(75), RECORD(HFKOLS(75)), RC75)
         CALL RCOPY (HFNUMV(76), RECORD(HFKOLS(76)), RC76)
         CALL RCOPY (HFNUMV(77), RECORD(HFKOLS(77)), RC77)
         END IF
      GO TO 999
C                                       Close
 800  CALL TABIO ('CLOS', 0, IHFRNO, RECORD, BUFFER, IERR)
      IF (IERR.GT.0) GO TO 990
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1800) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1800 FORMAT ('TABHF: TABIO ERROR',I3)
      END

      SUBROUTINE ZMSGOP (LUN, FIND, IVOL, PNAME, IERR)
C-----------------------------------------------------------------------
C! open a message file or message terminal
C# Z IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Open a message file (much like ZOPEN, but does not call MSGWRT to
C   avoid recursion).  Non-map, exclusive, patient assumed on open.
C   Inputs:
C      LUN      I      Logical unit number
C      IVOL     I      Disk volume containing file, 1,2,3,...
C      PNAME    C*48   Physical file name
C   Output:
C      FIND     I      Index in FTAB to file control block for LUN
C      IERR     I      Error return code: 0 => no error
C                         1 => LUN already in use
C                         2 => file not found
C                         3 => volume not found
C                         4 => exclusive use denied
C                         5 => no room for LUN in FTAB
C                         6 => other open errors
C   UNICOS version - calls ZDAOPN, ZTTOPN, ZMSGER.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IVOL, IERR
      CHARACTER PNAME*48
C
      INTEGER   JERR, ERRLUN, ERRTER, FCBOFF, IMAP, IEXCL, DELMAX,
     *   DELCNT, DLMAX2, DLCNT2, IOSVAL, I, J
      REAL      TDELAY
      HOLLERITH ANAME(12)
      LOGICAL   F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA F /.FALSE./
      DATA ERRLUN, ERRTER, TDELAY, DELMAX, DLMAX2 /12, 6, 1.0, 30, 60/
C-----------------------------------------------------------------------
C                                       Set integer map, exclusive use
      IMAP = 0
      IEXCL = 1
C                                       Valid LUN?
      IERR = 6
      IF ((LUN.EQ.ERRLUN) .OR. (LUN.EQ.ERRTER)) GO TO 10
         WRITE (ERRTER,1000) LUN
         GO TO 999
C                                       Allocate area in FTAB for LUN.
 10   IF (LUN.EQ.ERRLUN) THEN
         CALL LSERCH ('OPEN', LUN, FIND, F, JERR)
         IF (JERR.EQ.0) GO TO 20
C                                       LUN already in use.
            IF (JERR.EQ.2) THEN
               IERR = 1
               WRITE (ERRTER,1011) LUN
C                                       No room in FTAB for LUN.
            ELSE IF (JERR.EQ.3) THEN
               IERR = 5
               WRITE (ERRTER,1012) LUN
C                                       Other error
            ELSE
               WRITE (ERRTER,1010) JERR, LUN
               END IF
            GO TO 999
C                                       Okay, so far.
 20      IERR = 0
         DELCNT = 0
         DLCNT2 = 0
         FCBOFF = FIND + NMOFF
C                                       Volume (disk) number in range?
         IF ((IVOL.GT.0) .AND. (IVOL.LE.NVOL)) GO TO 30
            IERR = 3
            WRITE (ERRTER,1020) IVOL
            GO TO 900
C                                       Open disk message file.
C 30      CALL CHR2H (48, PNAME, 1, ANAME)
 30      CALL ZDAOPN (FTAB(FCBOFF), PNAME, IMAP, IEXCL, IERR)
         IF (IERR.NE.0) THEN
C                                       File not found?
            IF (IERR.EQ.2) THEN
               WRITE (ERRTER,1030) PNAME(1:24)
C                                       Volume not found?
            ELSE IF (IERR.EQ.3) THEN
               WRITE(ERRTER,1031) IVOL, PNAME(1:24)
C                                       File busy?
            ELSE IF (IERR.EQ.4) THEN
C                                       Wait and try again every TDELAY
C                                       seconds up to DELMAX*DLMAX2
C                                       times.  Issue a message every
C                                       DLMAX2 wait.
               DELCNT = DELCNT + 1
               IF (DELCNT.LE.DELMAX) THEN
                  CALL ZDELAY (TDELAY, IERR)
               ELSE
                  DLCNT2 = DLCNT2 + 1
                  IF (DLCNT2.GT.DLMAX2) GO TO 33
                     DELCNT = 0
                     WRITE (6,1032) PNAME(1:24)
                  END IF
               GO TO 30
C
 33            WRITE (6,1033) PNAME(1:24)
               GO TO 900
C                                       Other open error.
 34         ELSE
               CALL ZMSGER ('ZDAOPN', FTAB(FCBOFF+FCBERR), PNAME,
     *            FTAB(FCBOFF), F)
               END IF
            GO TO 900
            END IF
C                                       Open message termimal here.
      ELSE
         CALL ZTTOPN (LUN, FIND, IERR)
         IF (IERR.NE.0) THEN
            IF (FTAB(FIND+1+NFCBER).GT.0) CALL ZMSGER ('ZTTOPN',
     *         FTAB(FIND+1+NFCBER), ' ', -999, .FALSE.)
            WRITE (ERRTER,1040,IOSTAT=IOSVAL) IERR, LUN
            IERR = 6
            END IF
         END IF
C                                       Clear FTAB entry for LUN.
 900  IF (IERR.NE.0) THEN
         CALL LSERCH ('CLOS', LUN, FIND, F, JERR)
C                                       or add file name to lists
      ELSE
         CALL FSERCH (FIND, I, J, JERR)
         IF (JERR.EQ.0) THEN
            IF (I.EQ.1) DEVNAM(J) = PNAME
            IF (I.EQ.2) NONNAM(J) = PNAME
            IF (I.EQ.3) MAPNAM(J) = PNAME
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (' ZMSGOP: INVALID LUN = ',I2)
 1010 FORMAT (' ZMSGOP: LSERCH ERROR ',I2,' ON OPEN, LUN = ',I2)
 1011 FORMAT (' ZMSGOP: LUN = ',I2,' ALREADY OPENED IN FTAB')
 1012 FORMAT (' ZMSGOP: NO ROOM IN FTAB FOR LUN = ',I2)
 1020 FORMAT (' ZMSGOP: VOLUME NUMBER = ',I6,' OUT OF RANGE')
 1030 FORMAT (' ZMSGOP: FILE ',A24,' NOT FOUND')
 1031 FORMAT (' ZMSGOP: VOLUME ',I2,' FOR FILE ',A24,' NOT FOUND')
 1032 FORMAT (' ZMSGOP: STILL WAITING FOR FILE ',A24)
 1033 FORMAT (' ZMSGOP: FILE ',A24,' NOT AVAILABLE')
 1040 FORMAT (' ZMSGOP: ZTTOPN RETURNS ERROR = ',I3,' FOR LUN = ',I3)
      END

LOCAL INCLUDE 'MWFLT.INC'
C                                       Local include for MWFLT
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO,
     *   CATOLD(256), CATBLK(256), JBUFSZ, ICODE, SCRTCH(512)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, OPCODE*4
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2), XOPCOD(1)
      REAL      XSEQIN, XDISKI, XSEQO, XDISKO, BLC(7), TRC(7),
     *   CPARM(10), DPARM(10), BUFF1(MABFSS), BUFF2(MABFSS)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XNAMOU, XCLAOU,
     *   XSEQO, XDISKO, BLC, TRC, XOPCOD, CPARM, DPARM
      COMMON /PARMS/ SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO,
     *   CATOLD, JBUFSZ, ICODE
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, OPCODE
      COMMON /BUFRS/ BUFF1, BUFF2, SCRTCH
      COMMON /MAPHDR/ CATBLK
LOCAL END
      PROGRAM MWFLT
C-----------------------------------------------------------------------
C! Does median window filtering of an image.
C# Map Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000-2001, 2004, 2006, 2008, 2010, 2015,
C;  Copyright (C) 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   MWFLT applies a nonlinear lowpass filter to an image.  Three such
C   filters are currently available.  The first one is the "mode"
C   filter, which is formed by a combination of the box filter and the
C   median window filter in an attempt to approximate the mode of the
C   skewed distribution of pixel values due to the presence of positive
C   sources above the background image.  The second option is to
C   deliver the median window result alone.  The median calculation
C   uses a two-dimensional merge sort algorithm.  The third option is
C   the alpha-trimmed mean filter, which is the mean of the distribution
C   after a specified percent of the outlying pixels have been removed.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLAOUT        Class of the output image.
C                                   Default is input class.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      OPCODE         OPCODE        Option MW, ALPHA,
C      CPARM(10)      CPARM         User specified array.
C      DPARM(10)      DPARM         User specified array.
C   Written  by: Thad A. Polk & Donald C. Wells
C   Modified by: Glen Langston
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGM*6
      INCLUDE 'MWFLT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'MWFLT '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL MWFIN (PRGM, IRET)
C                                       Filter inage.
      IF (IRET.EQ.0) CALL MWSEND (IRET)
C                                       History
      IF (IRET.EQ.0) CALL MWFHIS
C                                       Close down files, etc.
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE MWFIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   MWFIN gets input parameters for MWFLT and creates an output file.
C   Inputs:  PRGN    C*6       Program name
C   Output:  IRET    I         Error code: 0 => ok
C                                4 => user routine detected error.
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER  STAT*4, PRGN*6, BLANK*6, MTYPE*2, ATYPES(7)*8
      HOLLERITH CATH(256)
      INTEGER   IRET
      INTEGER   IERR, NPARM, IROUND, ITEMP
      REAL      CATR(256)
      DOUBLE PRECISION    CATD(128)
      INCLUDE 'MWFLT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATR, CATH, CATBLK, CATD)
      DATA BLANK /'      '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 49
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO = IROUND (XDISKO)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, 'READ', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Copy old CATBLK to new.
      CALL COPY (256, CATOLD, CATBLK)
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATOLD(KIDIM), CATOLD(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       check window
      ITEMP = IROUND (CPARM(1))
      IF (ITEMP.LE.0) ITEMP = 5
      IF (MOD (ITEMP,2).EQ.0) ITEMP = ITEMP + 1
      CPARM(1) = ITEMP
      ITEMP = IROUND (CPARM(2))
      IF (OPCODE.NE.'ROW') THEN
         IF (ITEMP.LE.0) ITEMP = 5
         IF (MOD (ITEMP,2).EQ.0) ITEMP = ITEMP + 1
         CPARM(2) = ITEMP
      ELSE
         IF ((ITEMP.LE.0) .OR. (ITEMP.GT.CPARM(1))) ITEMP =
     *      (CPARM(1) + 1.0) / 2.0 + 0.01
         CPARM(2) = ITEMP
         END IF
      IF ((CPARM(3).LT.0.0) .OR. (CPARM(3).GT.0.5)) CPARM(3) = 0.25
C                                       default: median sky sub.
      IF (DPARM(1).EQ.0.0 .AND. DPARM(2).EQ.0) THEN
         DPARM(1) = 1.
         DPARM(2) = -1.
      ELSE IF (OPCODE.NE.'NRML') THEN
         IF (DPARM(2).EQ.0.0) DPARM(2) = 1.0
         END IF
C                                       if coordinate increment is 1
      IF (ABS(CATR(KRCIC)) .EQ. 1.0) THEN
C                                       "/mm * mm/inch / 400 dots/inch
         CATR(KRCIC) = -(67.2 * 25.4 / 400.0) / 3600.
         END IF
C                                       if coordinate increment is 1
      IF (ABS(CATR(KRCIC+1)) .EQ. 1.0) THEN
C                                       "/mm * mm/inch / 400 dots/inch
         CATR(KRCIC+1) = (67.2 * 25.4 / 400.0) / 3600.
         END IF
C                                       Get user modification to CATBLK
      IRET = 4
      CALL MWINIT (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Check if axis types blank
C                                       Ra axis
      CALL H2CHR (8, 1, CATH(KHCTP), ATYPES(1))
C                                       If blank
      IF (ATYPES(1) .EQ.'        ') THEN
C                                       Reset to arc projection
         CALL CHR2H (8, 'RA---ARC', 1, CATH(KHCTP))
         END IF
C                                       Dec axis
      CALL H2CHR (8, 1, CATH(KHCTP+2), ATYPES(2))
C                                       If blank
      IF (ATYPES(2) .EQ.'        ') THEN
C                                       Reset to arc projection
         CALL CHR2H (8, 'DEC--ARC', 1, CATH(KHCTP+2))
         END IF
C                                       Create output file.
      NEWCNO = 1
      IRET = 4
      CALL MCREAT (DISKO, NEWCNO, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MWFIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('MWFIN: ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE MWSEND (IRET)
C-----------------------------------------------------------------------
C   MWSEND sends image one row at a time to the user supplied
C   routine and then writes the modified data.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C                                    9 => Image row too long
C-----------------------------------------------------------------------
      CHARACTER IFILE*48
      INTEGER   IRET, IROUND, LUNI, LUNO, NYI, NXI,
     *   WINI(4), NXO, NYO, WINO(4), BOI,
     *   BOO, LIM2, LIM3, LIM4, LIM5, LIM6, LIM7, I1, I2,
     *   I3, I4, I5, I6, I7, IPOS(7), CORN(7), BOTEMP, KOFF,
     *   LIMO, LIMIT, IBIND, OBIND, INDI, INDO, LIM1
      INTEGER   DIDRET, OUTCNT
      REAL      OUTMAX, OUTMIN, CATR(256), OLDR(256)
      DOUBLE PRECISION    OLDD(128), CATD(128)
      LOGICAL   T, F, BLNKD
      INCLUDE 'MWFLT.INC'
      REAL    RDATA(MAXIMG)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATBLK, CATR, CATD),         (CATOLD, OLDR, OLDD)
      SAVE IPOS
      DATA LUNI, LUNO /16,17/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Setup for I/O
      NXI = CATOLD(KINAX)
      NYI = CATOLD(KINAX+1)
      NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      OUTMAX = -1.0E20
      OUTMIN = 1.0E20
      BLNKD = F
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
C                                       If too big, tell user
      IF (LIM1.GT.MAXIMG) THEN
         MSGTXT = 'MWSEND: IMAGE BIGGER THAN ARRAY !!!!'
         CALL MSGWRT(8)
         MSGTXT = 'MWSEND: CHOOSE A SMALLER SUB-IMAGE !'
         IRET = 9
         GO TO 990
         END IF
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
      KOFF = 0
      CORN(7) = 1
      LIMO = CATBLK(KINAX) - 1
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         CORN(7+KOFF) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            CORN(6+KOFF) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               CORN(5+KOFF) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  CORN(4+KOFF) = I4
                  DO 300 I3 = 1,LIM3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     CORN(3+KOFF) = I3
C                                       Init. files, first input.
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1099) IRET
            GO TO 990
            END IF
         BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'READ', IRET
            GO TO 990
            END IF
C                                       Init output file.
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORN(3), BOTEMP,
     *      IRET)
         BOO = BOTEMP + 1
         CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO, BUFF2, JBUFSZ,
     *      BOO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'WRIT', IRET
            GO TO 990
            END IF
         DIDRET = 1
         OUTCNT = LIM2
C                                       For all rows loop
         DO 220 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
C                                       Read.
            CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'READ', IRET
               GO TO 990
               END IF
C                                       Copy data to array
            CALL RCOPY (LIM1, BUFF1(IBIND), RDATA(1))
C                                       Write.
C                                       Check for deferred output.
            IF (DIDRET.GE.0) THEN
               CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IRET)
               OBIND = OBIND - 1
               OUTCNT = OUTCNT - 1
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1120) 'WRIT', IRET
                  GO TO 990
                  END IF
C                                       End IF time to write
               END IF
C                                       Call FILTER.
            IF (DIDRET.GE.0) OBIND = OBIND + 1
C                                       Do quick row median ?
            IF (OPCODE.EQ.'ROW ') THEN
               CALL ROWMED (IPOS, RDATA, BUFF2(OBIND), IRET)
C                                       Else do area filter
            ELSE
               CALL FILTER (IPOS, RDATA, BUFF2(OBIND), IRET)
               END IF
            DIDRET = IRET
            IF (DIDRET.GT.0) THEN
               WRITE (MSGTXT,1180) IRET
               GO TO 990
C                                       do some output now
            ELSE IF (DIDRET.EQ.0) THEN
C                                       Check max, min, blanking.
               LIMIT = OBIND + LIMO
C                                       for all columns in out row
               DO 200 I1 = OBIND,LIMIT
                  IF (BUFF2(I1).NE.FBLANK) THEN
                     OUTMAX = MAX (OUTMAX, BUFF2(I1))
                     OUTMIN = MIN (OUTMIN, BUFF2(I1))
                  ELSE
                     BLNKD = .TRUE.
                     END IF
 200              CONTINUE
               END IF
 220        CONTINUE
C                                       Read out any remaining rows
C                                       from FILTER.
         IF (OUTCNT.GT.0) THEN
            DO 260 I2 = 1,OUTCNT
               IPOS(1) = -1
C                                       Check if write requested.
               CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IRET)
               OBIND = OBIND - 1
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1120) 'WRIT', IRET
                  GO TO 990
                  END IF
C                                       Call FILTER
               OBIND = OBIND + 1
C                                       Do quick row median ?
               IF (OPCODE.NE.'ROW ') THEN
C                                       Else do area filter
                  CALL FILTER (IPOS, RDATA, BUFF2(OBIND), IRET)
                  END IF
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1180) IRET
                  GO TO 990
                  END IF
C                                       Check max, min, blanking.
               LIMIT = OBIND + LIMO
               DO 250 I1 = OBIND,LIMIT
                  IF (BUFF2(I1).NE.FBLANK) THEN
                     OUTMAX = MAX (OUTMAX, BUFF2(I1))
                     OUTMIN = MIN (OUTMIN, BUFF2(I1))
                  ELSE
                     BLNKD = .TRUE.
                     END IF
 250              CONTINUE
 260           CONTINUE
            END IF
C                                       Flush buffer.
         CALL MDISK ('FINI', LUNO, INDO, BUFF2, OBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1120) 'FINI', IRET
            GO TO 990
            END IF
C                                       Update CATBLK.
         CATR(KRDMX) = OUTMAX
         CATR(KRDMN) = OUTMIN
         CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRTCH,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1260) IRET
            GO TO 990
            END IF
 300     CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Mark blanking in CATBLK.
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
C                                       Close input map.
      CALL ZCLOSE (LUNI, INDI, IRET)
C                                       Final call to functions
      IPOS(1) = -2
C                                       Do quick row median ?
      IF (OPCODE.EQ.'ROW ') THEN
         CALL ROWMED (IPOS, RDATA, BUFF2, IRET)
      ELSE
C                                       Else do area filter
         CALL FILTER (IPOS, RDATA, BUFF2, IRET)
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1180) IRET
         GO TO 990
         END IF
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MWSEND: ERROR',I3,' OPENING INPUT FILE')
 1020 FORMAT ('MWSEND: ERROR',I5,' OPENING OUTPUT FILE')
 1099 FORMAT ('MWSEND: COMOF3 ERROR',I3)
 1100 FORMAT ('MWSEND: INIT-FOR-',A4,' ERROR',I3)
 1120 FORMAT ('MWSEND: ',A4,' ERROR',I3)
 1180 FORMAT ('MWSEND: FILTER ERROR',I3)
 1260 FORMAT ('MWSEND: CATIO ERROR',I3,' UPDATING CATBLK')
      END
      SUBROUTINE MWFHIS
C-----------------------------------------------------------------------
C   MWFHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, NOTTYP*2
      INTEGER   LUN1, LUN2, IERR, I
      LOGICAL   T
      INCLUDE 'MWFLT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NOTTYP /'CC'/
C-----------------------------------------------------------------------
C                                       copy most header keywords
      CALL KEYPCP (DISKIN, OLDCNO, DISKO, NEWCNO, 0, ' ', IERR)
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   SCRTCH(257), SCRTCH, IERR)
      IF (IERR.LE.2) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 20
C                                       New history
 10   CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, SCRTCH,
     *   IERR)
      IF (IERR.NE.0) GO TO 20
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       BLC
      WRITE (HILINE,2000) TSKNAM, BLC
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       TRC
      WRITE (HILINE,2001) TSKNAM, TRC
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       OPCODE
      WRITE (HILINE,2002) TSKNAM, OPCODE
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
C                                       window
      I = CPARM(1) + 0.01
      WRITE (HILINE,2003) TSKNAM, I
      CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 20
      I = CPARM(2) + 0.01
      IF (OPCODE.NE.'ROW') THEN
         WRITE (HILINE,2004) TSKNAM, I
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 20
      ELSE
         WRITE (HILINE,2005) TSKNAM, I
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 20
         END IF
      IF ((OPCODE.EQ.'ALFA') .OR. (OPCODE.EQ.'NRML')) THEN
         WRITE (HILINE,2006) TSKNAM, CPARM(3)
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 20
         END IF
      IF (OPCODE.NE.'NRML') THEN
         WRITE (HILINE,2007) TSKNAM, DPARM(1)
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 20
         WRITE (HILINE,2008) TSKNAM, DPARM(2)
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 20
      ELSE
         WRITE (HILINE,2009) TSKNAM, DPARM(1)
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 20
         WRITE (HILINE,2010) TSKNAM, DPARM(2)
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 20
         WRITE (HILINE,2011) TSKNAM, DPARM(3)
         CALL HIADD (LUN2, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 20
         END IF
C                                       Close HI file
 20   CALL HICLOS (LUN2, T, SCRTCH, IERR)
C                                        Copy tables
      CALL ALLTAB (1, NOTTYP, LUN1, LUN2, DISKIN, DISKO, OLDCNO,
     *   NEWCNO, CATBLK, SCRTCH(257), SCRTCH, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MWFHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 2000 FORMAT (A6,'BLC =',6(F6.0,','),F6.0)
 2001 FORMAT (A6,'TRC =',6(F6.0,','),F6.0)
 2002 FORMAT (A6,'OPCODE = ''',A4,'''')
 2003 FORMAT (A6,'CPARM(1) =',I4,'  / MW window width')
 2004 FORMAT (A6,'CPARM(2) =',I4,'  / MW window height')
 2005 FORMAT (A6,'CPARM(2) =',I4,'  / Row pixel level')
 2006 FORMAT (A6,'CPARM(3) =',F5.2,'  / Window cutoff fraction')
 2007 FORMAT (A6,'DPARM(1) =',F5.2,'  / Output=dparm(1)*input +')
 2008 FORMAT (A6,'DPARM(2) =',F5.2,'  / dparm(2)*filter_value')
 2009 FORMAT (A6,'DPARM(1) =',F9.4,'  / Maximum rms out')
 2010 FORMAT (A6,'DPARM(2) =',F9.4,'  / Minumum rms out')
 2011 FORMAT (A6,'DPARM(3) =',F5.2,'  / Weight sqrt(background)')
      END
      SUBROUTINE MWINIT (IRET)
C-----------------------------------------------------------------------
C   MWINIT is a routine in which the user performs several operations
C   associated with beginning the task.  The following functions are
C   performed in MWINIT:
C       1) Modifying the catalog header block to represent the
C   output file.
C       2) Checking the input image and input parameters.
C   A returned value of IRET .NE. 0 will cause the task to terminate.
C       3) Setting default values of some of the input parameters
C   (OUTNAME, OUTCLASS, OUTSEQ, OUTDISK, TRC and BLC defaults are
C   set elsewhere).  As currently set the default OPCODE is the
C   first value in the array CODES which is set in a data statment.
C
C    Input:
C     CATBLK(256)    I     Output catalog header, also CATR, CATD
C     CATOLD(256)    I     Input catalog header, also OLDR, OLDD
C    Output:
C     CATBLK(256)    I     Modified output catalog header.
C     IRET           I     Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NCODE
C                                       # and value of OPCODEs
      PARAMETER (NCODE=7)
      CHARACTER FCHARS(3)*4, CHTMP*4, CODES(NCODE)*4
      HOLLERITH CATH(256)
      INTEGER   LIMIT, I, FIRSTI, FIRSTO, IRET, INDEX
      REAL      CATR(256), OLDR(256)
      DOUBLE PRECISION    CATD(128), OLDD(128)
      INCLUDE 'MWFLT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE  (CATBLK, CATR, CATD, CATH),   (CATOLD, OLDR, OLDD)
      DATA FCHARS /'FREQ','VELO','FELO'/
      DATA CODES /'MW','MAX','MIN','ALFA','NRML','MODE','ROW'/
C-----------------------------------------------------------------------
C                                       Set default OPCODE
      DO 10 I = 1,NCODE
         ICODE = I
         IF (OPCODE.EQ.CODES(I)) GO TO 50
 10      CONTINUE
C                                       Default OPCODE is first.
      OPCODE = CODES(1)
      ICODE = 1
C                                       Set axes in output CATBLK.
 50   FIRSTI = -1
      FIRSTO = -1
      LIMIT = CATOLD(KIDIM)
C                                       Copy/update axis values
      DO 80 I = 1,LIMIT
         CATBLK(KINAX+I-1) = TRC(I) - BLC(I) + 1.01
         CATR(KRCRP+I-1) = CATR(KRCRP+I-1) - BLC(I) + 1.0
         CATR(KRCIC+I-1) = CATR(KRCIC+I-1)
         CATD(KDCRV+I-1) = CATD(KDCRV+I-1)
         INDEX = KHCTP + (I-1) * 2
         CALL CHCOPY (8, 1, OLDR(INDEX), 1, CATH(INDEX))
         IF (CATBLK(KIALT).EQ.0) GO TO 80
            CALL H2CHR (4, 1, CATH(INDEX), CHTMP)
            IF ((CHTMP.EQ.FCHARS(1)) .OR. (CHTMP.EQ.FCHARS(2)) .OR.
     *         (CHTMP.EQ.FCHARS(3))) CATR(KRARP) = CATR(KRARP) -
     *         BLC(I) + 1.0
 80      CONTINUE
C                                       Put other checks here.
C                                       Finished.
      IRET = 0
C
 999  RETURN
      END
      SUBROUTINE FILTER (IPOS, RDATA, RESULT, IRET)
C-----------------------------------------------------------------------
C   This subroutine performs selected filtering operations on an
C   image one row at a time (1st dimension).
C       Input RDATA are Real with blanking if necessary; output values
C   are R   which may also be blanked.  The calling routine keeps track
C   of max., min. and the occurence of blanking.
C   NOTE: blanked values are denoted by the value of the common variable
C   FBLANK.
C       FILTER accumulates a scrolling buffer by returning a negative
C   value of IRET.  This tells the calling routine to defer writing the
C   next row.  When rows are deferred an equal number of calls to
C   FILTER will be made with no input data; this allows reading out any
C   rows left in FILTERs internal buffers.  Such a "no input call" is
C   indicated by a value of IPOS(1) of -1.  The writing of the returned
C   values of these "no input calls" is NOT deferred.
C
C       When IRET .GT. 0 the output file will be destroyed.
C
C       The current contents of CATBLK will be written back to the
C   catalog after the last call to FILTER.
C
C   Inputs:
C      IPOS(7)   I    BLC (input image) of first value in RDATA
C                     IPOS(1) = -1 => no input data this call.
C                     IPOS(2) = -2 => last call (no input data).
C      RDATA(*)   R    Input row, magic value blanked.
C   Values from commons:
C      ICODE     I    Opcode number from list in MWINIT.
C      FBLANK    R    Value of blanked pixel.
C      CPARM(10) R    Input adverb array.
C      DPARM(10) R    Input adverb array.
C      CATBLK    I    Output catalog header
C      CATOLD    I    Input catalog header (also OLDR)
C   Output:
C      RESULT(*) R    Output row.
C      IRET      I    Return code   0 => OK
C                               >0 => error, terminate.
C   Output in COMMON
C     CATBLK     I    Catalog header block
C-----------------------------------------------------------------------
C                                       Formal parameters:
      INTEGER   IRET, IPOS(7)
      REAL      RDATA(*), RESULT(*)
C                                       Local variables:
      INCLUDE 'MWFLT.INC'
      INTEGER   MWLIM, MWLIM2, MWLIMS
      PARAMETER (MWLIM2 = 101)
      PARAMETER (MWLIM = 2 * MWLIM2 - 1)
      PARAMETER (MWLIMS = MWLIM * MWLIM)
      INTEGER   CSIZE(MAXIMG), NA, NB, NC, RIGHT, NEWSIZ, IBLC1, INC,
     *   NBUFF(MWLIM,MAXIMG), NTEMP(MWLIM), COUNT(MWLIMS,2), LROW,
     *   MWX, MWY, MW2X, MW2Y, KA, KC, KT, I, K, I2, IC, N
      LOGICAL   FIRST, PRNTD
      REAL      BUFF(MWLIM,MAXIMG), CUT1L, CUT2L, CUT1, CUT2,
     *   TEMP(MWLIM), AC(MWLIMS,2), OUTPUT(MAXIMG),
     *   OLDATA(MAXIMG,MWLIM2), OLDR(128), SIGOUT, INIT, SIGIN, DATAMN,
     *   DATAMX
      SAVE LROW, IBLC1, MWX, MWY, MW2X, MW2Y, I2, KA, KC, DATAMN,
     *   DATAMX, CUT1L, CUT2L, COUNT, CSIZE, NBUFF, PRNTD, FIRST
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (CATOLD, OLDR)
C-----------------------------------------------------------------------
      IRET = 0
C                                       Check if last call (no input
C                                       data).
      IF (IPOS(1).LE.-2) GO TO 900
C                                       Check if first call per plane.
      IF (IPOS(2).LE.BLC(2)) THEN
C                                       First call per plane.
C                                       Initialize variables.
         LROW = (TRC(1) - BLC(1) + 1.01)
         IBLC1 = BLC(2) + 0.1
         MWX   = CPARM(1)
         MWY   = CPARM(2)
         INC = 1.E6 / (MWX * MWY * (TRC(1) - BLC(1) + 1)) + 0.5
         INC = MAX (1, INC) * 10
C                                       Invalid input, die.
         IF ((MWX.GT.MWLIM) .OR. (MWX.LE.0) .OR. (MWY.GT.MWLIM) .OR.
     *      (MWY.LE.0) .OR. (MOD(MWX,2).NE.1) .OR. (MOD(MWY,2).NE.1))
     *      THEN
            WRITE (MSGTXT,1000) MWLIM
            CALL MSGWRT (8)
            IRET = 1
            GO TO 900
            END IF
         MW2X  = MWX  / 2
         MW2Y  = MWY  / 2
         I2    = LROW + MW2X
         KA    = 1
         KC    = 2
         DATAMN = OLDR(KRDMN)
         DATAMX = OLDR(KRDMX)
         CUT1L = DATAMN
         CUT2L = DATAMX
         DO 20 I = 1,MWLIM
            COUNT(I,1) = 0
            COUNT(I,2) = 0
 20         CONTINUE
         DO 30 I = 1,LROW
            CSIZE(I) = 0
            NBUFF(1,I) = 0
 30         CONTINUE
         DO 40 I = 1,MW2Y
            CALL RFILL (LROW, FBLANK, OLDATA(1,I+1))
 40         CONTINUE
         PRNTD = .FALSE.
         FIRST = .TRUE.
C                                       End If first call
         END IF
C                                       Print out row number every
C                                        tenth row if appropriate:
      IF ((MOD(IPOS(2),INC).NE.0) .OR. (IPOS(2).LT.IBLC1) .OR.
     *   (IPOS(2).GT.TRC(2)) .OR. (CPARM(4).LE.0.0) .OR. (PRNTD))
     *   GO TO 110
         WRITE (MSGTXT,1010) IPOS(2)
         CALL MSGWRT (4)
         IF (IPOS(2).EQ.TRC(2)) PRNTD = .TRUE.
C                                       Copy each data vector into
C                                        the vector below it:
 110  DO 120 I = 1,MW2Y
         CALL RCOPY (LROW, OLDATA(1,I+1), OLDATA(1,I))
 120     CONTINUE
C                                       Check if no input data:
      IF (IPOS(1).LT.0) THEN
C                                       No input, copy blanks into
C                                       buffer array
         CALL RFILL (LROW, FBLANK, OLDATA(1,MW2Y+1))
      ELSE
C                                       Copy data into buffer array
         CALL RCOPY (LROW, RDATA, OLDATA(1,MW2Y+1))
         END IF
C                                       Merge the new pixels with
C                                        the old column lists:
      DO 160 I = 1,LROW
         NB = 1
         IF ((RDATA(I).EQ.FBLANK) .OR. (IPOS(1).EQ.-1)) NB = 0
         CALL MWMERG (MWY, CSIZE(I), BUFF(1,I), NBUFF(1,I), NB,
     *      RDATA(I), NEWSIZ, TEMP(1), NTEMP(1))
         DO 150 K= 1,NEWSIZ
            BUFF(K,I) = TEMP(K)
            NBUFF(K,I) = NTEMP(K)
 150        CONTINUE
         CSIZE(I) = NEWSIZ
 160     CONTINUE
C                                       If col position in range
      IF (IPOS(2).GE.IBLC1+MW2Y) THEN
         CUT1 = CUT1L
         CUT2 = CUT2L
         NC   = 0
C                                       Loop to move window along row:
         DO 220 I= 1,I2
            IC = I - MW2X
C                                       Swap merge buffers:
            KT = KA
            KA = KC
            NA = NC
            KC = KT
            NC = 0
            NB = 0
            IF (I.LE.LROW) NB = CSIZE(I)
            RIGHT = MIN (I, LROW)
C                                       Merge next column into window:
            CALL MWMERG (MWX, NA, AC(1,KA), COUNT(1,KA), NB,
     *         BUFF(1,RIGHT), NC, AC(1,KC),COUNT(1,KC))
C                                       Get appropriate result from
C                                        window:
            IF (IC.GE.1) THEN
               N = 1
               IF ((IC.EQ.1) .AND. (IPOS(2).EQ.IBLC1+MW2Y)) N = 5
               DO 170 K = 1,N
                  CALL GTMODE (NC, AC(1,KC), CUT1, CUT2, OUTPUT(IC),
     *               SIGIN, IRET, FIRST)
                  FIRST = .FALSE.
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1020) IRET
                     CALL MSGWRT (8)
                     GO TO 999
                     END IF
 170              CONTINUE
C                                       If Normalized
               IF (OPCODE.EQ.'NRML') THEN
                  SIGOUT = (DPARM(1) - DPARM(2))
     *               * ABS(OUTPUT(IC)) / DATAMX + DPARM(2)
C                                       scale background
                  INIT = DPARM(3) * SQRT (ABS(OUTPUT(IC)/DATAMX))
                  IF (OUTPUT(IC).LT.0.0) INIT = -INIT
                  IF (SIGIN.EQ.0.0) THEN
                     SIGOUT = 1.0
                     SIGIN = 1.0
                     END IF
                     RESULT(IC) =((OLDATA(IC, 1)-OUTPUT(IC)) *
     *                  SIGOUT/SIGIN) + INIT
               ELSE
C                                       Else Median Mode or ALPHA
C                                       Factor Median or Mode
                  RESULT(IC) = DPARM(2) * OUTPUT(IC)
C                                       If not blanked, add data back
                  IF ((IPOS(2).GE.IBLC1+MW2Y) .AND.
     *                 (RESULT(IC).NE.FBLANK))
     *            RESULT(IC) = RESULT(IC) + DPARM(1)*OLDATA(IC, 1)
C                                       End if Normalized
                  END IF
            ELSE
                CUT1L = CUT1
                CUT2L = CUT2
                END IF
 220        CONTINUE
C
C                                       Defer call - set IRET to -1
      ELSE
         IRET = -1
         END IF
C                                       Last call - do history etc.
 900  CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('WINDOW DIMENSION MUST BE ODD AND BETWEEN 1 AND',I3)
 1010 FORMAT ('Currently on row number', I6)
 1020 FORMAT ('ERROR GETTING RESULT FROM GTMODE, IRET=',I5)
      END
      SUBROUTINE MWMERG (MW, NA, A, IA, NB, B, NC, C, IC)
C-----------------------------------------------------------------------
C Merges two sorted lists of pixel values into a combined sorted list.
C Input:
C    MW    = height of the column (limit on value of "counts")
C    NA    = length of previously merge-sorted array A().
C    A()   = previously merge-sorted pixel values (ascending order).
C    IA()  = integer "counts" associated with A().
C    NB    = length of the array of input pixel values.
C    B()   = input pixels (FP) sorted into ascending order.
C    NC    = length of array C() which receives A() merged with B().
C Output:
C    C()   = merged output array, will be in ascending order.
C    IC()  = integer counts associated with C().
C
C The values which have been through the process too many times are
C discarded. A() and B() are the input
C lists, and C() is the output. NA, NB, AND NC are the number of
C elements in the lists (NC is computed by this routine and need not be
C initialized). The A() list is the old input, and the B() list is new
C items. The process should start up by adding a B() list to an empty
C A() list (i.e., one with NA=0). The B() list should contain floating
C point numbers in ascending order. Both NA=0 and NB=0 are legal, and
C NC=0 is quite possible.
C      Arrays IA() and IC() carry "counts" which are associated with
C the corresponding elements of A() and C(). Counts from IA() are
C incremented as they and their values in A() are copied to IC() and
C C(), except that when they exceed MW the count and value are
C discarded (not copied into IC() and C()). When a B() list item enters
C the process its count is set to 1. The counts remember how many cycles
C ago each item entered the merge sorting process. This is the mechanism
C by which we determine when the pixel associated with a given item
C moves out of the median window.
C-----------------------------------------------------------------------
C                                       Formal parameters:
      INTEGER   MW, NA, IA(1), NB, NC, IC(1)
      REAL      A(1), B(1), C(1)
C                                       Local variables:
      INTEGER   I, J, K, IAI
      REAL      AI, BJ
C-----------------------------------------------------------------------
      I = 0
      J = 0
      K = 0
C                                       Initialize AI and IAI if A()
C                                        is not empty:
 10   CONTINUE
         I = I + 1
         IF (I.GT.NA) GO TO 70
         IAI = IA(I)
         IAI = IAI + 1
         IF (IAI.GT.MW) GO TO 10
      AI = A(I)
C                                       Main merge loop:
 20   CONTINUE
         J = J + 1
         IF (J.GT.NB) GO TO 80
         BJ = B(J)
C                                       Basic comparison of A(I)
C                                        with B(J):
 30      CONTINUE
            K = K + 1
            IF (BJ.LT.AI) GO TO 50
C                                       A(I) is smaller:
               C(K)  = AI
               IC(K) = IAI
 40            CONTINUE
                  I = I + 1
                  IF (I.GT.NA) GO TO 60
                  IAI = IA(I)
                  IAI = IAI + 1
                  IF (IAI.GT.MW) GO TO 40
               AI = A(I)
               GO TO 30
C                                       Else, B(J) is smaller:
 50         CONTINUE
               C(K)  = BJ
               IC(K) = 1
               GO TO 20
C                                       A() is empty, copy rest of B()
C                                        to C():
 60   CONTINUE
         K     = K + 1
         C(K)  = BJ
         IC(K) = 1
 70      CONTINUE
         J = J + 1
         IF (J.GT.NB) GO TO 100
         BJ = B(J)
         GO TO 60
C                                       B() is empty, copy rest of A()
C                                        to C():
 80   CONTINUE
         K     = K + 1
         C(K)  = AI
         IC(K) = IAI
 90      CONTINUE
            I = I + 1
            IF (I.GT.NA) GO TO 100
            IAI = IA(I)
            IAI = IAI + 1
            IF (IAI.GT.MW) GO TO 90
         AI = A(I)
         GO TO 80
C                                       That's all, folks:
 100  CONTINUE
      NC = K
      RETURN
      END
      SUBROUTINE GTMODE (NC, C, CUT1, CUT2, ZOUT, ZSIG, IRET, FIRST)
C-----------------------------------------------------------------------
C   Get the mode and median of a sorted list of numbers.
C   Input:
C      NC      = number elements in the sorted list of pixel values C().
C      C()     = list of pixel values from the window, ascending order.
C      CUT1    = current lower chauvenet cutoff (input and output).
C      CUT2    =    "    upper    "        "    (  "    "    "   ).
C   Output:
C      ZOUT    = mode (or median) of the distribution (output variable)
C      ZSIG    = r.m.s. of the distribution (output variable).
C      IRET    = Return code.
C      FIRST   = Indicates whether this is the first call.
C
C numbers C(), with numbers less than CUT1 or greater than CUT2 ignored.
C The mean and sigma are calculated so that the estimates of CUT1 and
C CUT2 can be updated (they will be generally be used again by the next
C call to this routine). IRET is the return code.  A value of IRET that
C is equal to zero implies that everything is fine while a positive
C value indicates an error and the output file will be destroyed.
C      NOTE: Variables S and SS are declared as REAL*8 because
C they are used in the formula which differences the sum of the
C values and the sum of the squares of the values in order to
C compute the r.m.s. of the distribution. This calculation
C should carry extra bits in its mantissa to preserve precision.
C      GTMODE uses the "3 and 2 rule" to estimate the mode of a
C distribution. This technique is only an approximation, and its
C efficiency as an estimator is rather poor. Its virtue is that the
C approximation is rather good for the kinds of distributions we
C usually encounter, so that its output has small bias compared to
C almost all other estimators. Obviously we need to devise a more
C efficient algorithm which could be substituted inside GTMODE.
C-----------------------------------------------------------------------
C                                       The formal parameters:
      INTEGER   NC, IRET
      LOGICAL   FIRST
      REAL      C(*), CUT1, CUT2, ZOUT, ZSIG
C                                       Local variables:
      INTEGER   ICZ, NZ, OLDNZ, I, NLOOP, OUT
      REAL      Z, W, ZBAR, ZMED, ZMODE, CUT, R
      DOUBLE PRECISION    S, SS
      INCLUDE 'MWFLT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      ZSIG = 1.0E6
      NLOOP = 0
      IF ((OLDNZ.EQ.0).OR.FIRST) OLDNZ = 1
C                                       Check the arguments:
      IF (((OPCODE.NE.'ALFA').AND.(OPCODE.NE.'NRML')).OR.
     *    ((CPARM(3).GE.0).AND.(CPARM(3).LE.0.5))) GO TO 2
             WRITE (MSGTXT,1010)
             CALL MSGWRT (8)
             IRET = 1
             GO TO 90
 2    CONTINUE
      IF (NC.NE.0) GO TO 3
         ZOUT = FBLANK
         GO TO 90
 3    IF (NC.NE.1) GO TO 4
         ZOUT = C(1)
         GO TO 90
 4    CONTINUE
      IF ((OPCODE.NE.'ALFA').AND.(OPCODE.NE.'NRML')) GO TO 5
         OUT  = NINT(NC*CPARM(3))
         CUT1 = C(OUT+1)
         CUT2 = C(NC-OUT-1)
 5    CONTINUE
      IF (CUT1.LE.CUT2) GO TO 6
         WRITE (MSGTXT,1000)
         CALL MSGWRT (8)
         IRET = 1
         GO TO 90
 6    CONTINUE
      IF (ICODE.GT.3) GO TO 10
C                                       Set up median filter:
         ICZ = 0
         NZ  = NC
         GO TO 50
C                                       Apply rejection cuts,
C                                        accumulate sums:
 10   CONTINUE
      S  = 0.0D00
      SS = 0.0D00
      ICZ= -1
      NZ = 0
      DO 20 I = 1, NC
         Z = C(I)
         IF (Z.LT.CUT1) GO TO 20
         IF (Z.GT.CUT2) GO TO 30
            IF (ICZ.EQ.-1) ICZ = I - 1
            S  = S  + Z
            SS = SS + (Z * Z)
            NZ = NZ + 1
 20      CONTINUE
 30   CONTINUE
C                                       If insufficient data in sample,
C                                        relax rejection cuts:
      IF ((NZ.GT.MIN ((0.3 * NC), 20.0)).AND.
     *    (((OLDNZ-NZ)/OLDNZ.LT.0.1).OR.FIRST)) GO TO 40
         CUT   = (CUT2 - CUT1) * 0.1
         IF (CUT.GT.0.0) GO TO 35
            NLOOP = NLOOP + 1
            CUT1 = C(1)
            CUT2 = C(NC)
            IF (NLOOP.LT.2) GO TO 10
               GO TO 40
 35      CONTINUE
         CUT1  = CUT1 - CUT
         CUT2  = CUT2 + CUT
         GO TO 10
 40   CONTINUE
C                                       Compute mean and r.m.s.:
      W    = NZ
      ZBAR = (S / W)
      IF (OPCODE.NE.'ALFA') GO TO 45
         ZOUT = ZBAR
         GO TO 90
 45   CONTINUE
      IF (NZ.GT.1) ZSIG = SQRT (ABS((SS / W) - (ZBAR * ZBAR)))
C                                       Compute median:
 50   CONTINUE
      I    = ICZ + (NZ / 2)
      ZMED = C(I+1)
      IF (MOD (NZ, 2).EQ.0) ZMED = 0.5 * (C(I) + ZMED)
C                                       If median window filter:
      IF (ICODE.EQ.1) THEN
         ZOUT = ZMED
C                                       max
      ELSE IF (ICODE.EQ.2) THEN
         ZOUT = C(NC)
C                                       min
      ELSE IF (ICODE.EQ.3) THEN
         ZOUT = C(1)
C                                       Use 3-and-2 approximation
C                                       to estimate mode:
      ELSE
         ZMODE = (3.0 * ZMED) - (2.0 * ZBAR)
C                                       Update rejection cuts to be
C                                        used for next GTMODE execution:
         R    = LOG10 (W)
         R    = ((-0.1042 * R) + 1.1695) * R + 0.8895
         R    = MAX (R, 2.0)
         CUT  = (R * ZSIG) + (0.5 * ABS (ZBAR - ZMODE))
         CUT1 = ZMODE - CUT
         CUT2 = ZMODE + CUT
         ZOUT = ZMODE
         OLDNZ = NZ
         END IF
C                                       That's all, folks:
 90   CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('THE LOWER CUTOFF IS GREATER THAN THE UPPER.')
 1010 FORMAT ('CPARM(3) MUST BE BETWEEN 0 AND 0.5')
      END
      SUBROUTINE ROWMED (IPOS, RDATA, RESULT, IRET)
C-----------------------------------------------------------------------
C   ROWMED finds the median value of a region of pixels on a row
C   Inputs:
C      IPOS   I(7)    BLC (input image) of first value in RDATA
C                     IPOS(1) = -1 => no input data this call.
C                     IPOS(2) = -2 => last call (no input data).
C      RDATA   R(*)    Input row, magic value blanked.
C   Values from commons:
C      ICODE   I      Opcode number from list in NEWHED.
C      FBLANK  R      Value of blanked pixel.
C      CPARM   R(10)  Input adverb array.
C      CATBLK  I      Output catalog header (also CATR, CATD)
C      CATOLD  I      Input catalog header (also OLD4, OLD8)
C      DROP1   L      True if one output value per call.
C   Output:
C      RESULT  R(*)   Output row.
C      IRET    I      Return code   0 => OK
C                                  >0 => error, terminate.
C   Output in COMMON:
C     NUMHIS  I          # history entries (max. 10)
C     HISCRD  C(NUMHIS)  History records
C     CATBLK  I          Catalog header block
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), IRET
      REAL      RDATA(*), RESULT(*)
C
      INTEGER   SKY, HLFWID, ICOL, LROW, JSTRT, JEND, WIDTH, IDELT
      INTEGER   CURWID, ISKY, JCOL, KCOL, BSATUR, ESATUR, NSAT
      REAL      FWIDTH, FMEDIA, SATUR, LSTMED, SATFAC, SATVAL, MEDFAC
      LOGICAL   ONZE, DOSATR
      SAVE SKY, ISKY, HLFWID, LROW, WIDTH, IDELT, ONZE, DOSATR,
     *     SATUR, SATVAL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'MWFLT.INC'
      REAL     SLIST(MAXIMG)
      DATA     ONZE/.FALSE./
C----------------------------------------------------------------------
      IRET = 0
      LSTMED = 0
C                                       Check if last call
      IF (IPOS(1).LE.-2) GO TO 999
C                                       Check if first call per plane.
      IF (IPOS(2).LE.1 .OR. .NOT.ONZE) THEN
C                                       First call per plane.
C                                       Set length of a row
         LROW = CATBLK(KINAX)
C                                       Get median full width
         WIDTH = CPARM(1)
         IF (WIDTH.LT.1) WIDTH = MAX(LROW / 15, 2)
C                                       Set median half width
         HLFWID=WIDTH/2
C                                       Make Width Odd
         WIDTH=(2*HLFWID)+1
         FWIDTH = 1./FLOAT(WIDTH)
C                                       Get Median selection value
         SKY = CPARM(2)
         IF (SKY.LT.1 .OR. SKY.GT.WIDTH) SKY = HLFWID+1
C                                       Tell User
         WRITE(MSGTXT,1000) WIDTH, SKY
         CALL MSGWRT(3)
C                                       Invert meaning of SKY
         SKY = WIDTH + 1 - SKY
C                                       NO less than smallest
         SKY = MAX (SKY, 1)
C                                       If not skipping pixels
         IF (CPARM(5).LT.2. .OR. CPARM(5).GT.LROW) THEN
            IDELT = 1
         ELSE
            IDELT = CPARM(5)
            WRITE (MSGTXT, 1050) IDELT
            CALL MSGWRT(3)
            END IF
C                                       If handling saturation
         SATUR  = CPARM(6)
         SATVAL = CPARM(7)
C                                       If staturation test
         IF (ABS(SATUR).GT.0.000001) THEN
            DOSATR = .TRUE.
            WRITE (MSGTXT,1070) SATUR, SATVAL
            CALL MSGWRT(3)
         ELSE
            DOSATR = .FALSE.
            END IF
C                                       Scale factor for median
         IF (DPARM(1).EQ.0.0) DPARM(1) = 1.0
         IF (DPARM(2).EQ.0.0) DPARM(2) = 1.0
         MEDFAC = DPARM(2)/DPARM(1)
C                                       Init Only Once
         ONZE = .TRUE.
C                                       End if first call
         END IF
C                                       Rescale output
      DO 50 ICOL = 1, LROW
         RDATA(ICOL) = RDATA(ICOL) * DPARM(1)
 50      CONTINUE
C                                       If saturation adjustment
      IF (DOSATR) THEN
C                                       Zero start count
         BSATUR = 0
C                                       Do Row Saturation
         DO 100 ICOL = 1, LROW
C                                       If staturated
            IF (RDATA(ICOL).GE.SATUR .AND. ICOL .LT. LROW) THEN
C                                       If starting a count
               IF (BSATUR .EQ. 0) BSATUR = ICOL
C                                       Continuuing a count
               ESATUR = ICOL
            ELSE
C                                       Else not staturated
C                                       If counting pixels
               IF (BSATUR .GT. 0) THEN
C                                       Number of staturated pixels
                  NSAT = ESATUR - BSATUR + 1
C                                       For all staturated pixels
                  DO 120 JCOL = 1, NSAT
C                                       factor Add to pixel
                     IF (JCOL.GT.NSAT/2) THEN
                        SATFAC = FLOAT(NSAT-JCOL)/2.
                     ELSE
                        SATFAC = FLOAT(JCOL-1)/2.
                        END IF
                     KCOL   = JCOL+BSATUR-1
                     RDATA(KCOL) = RDATA(KCOL) + (SATFAC * SATVAL)
 120                 CONTINUE
C                                       Mark end of count
                  BSATUR = 0
C                                       End if was counting saturations
                  END IF
               END IF
C                                       End for all pixels loop
 100        CONTINUE
C                                       End if doing saturation test
         END IF
C                                       For all pixels in row
      DO 200 ICOL = 1, LROW, IDELT
C
         JSTRT = MAX(1, ICOL-HLFWID)
         JEND  = MIN(LROW, ICOL+HLFWID)
C                                       Count pixels used
         CURWID = 0
C                                       Copy only pixels needed
         DO 150 JCOL = ICOL-HLFWID, JEND, IDELT
            IF (JCOL.GE.1) THEN
C                                       If not saturated
               IF (RDATA(JCOL).LT.SATUR.OR.(.NOT.DOSATR)) THEN
C                                       Count pixels to sort
                  CURWID = CURWID + 1
                  SLIST(CURWID) = RDATA(JCOL)
                  END IF
               END IF
 150        CONTINUE
C                                       Not all pixels available
         ISKY = SKY * FLOAT(CURWID) * FWIDTH
         ISKY = MAX (ISKY, 1)
C                                       If Pixels in median
         IF (CURWID.GT.0) THEN
C                                       Sort into decending order
            CALL RSORT(CURWID, SLIST)
C                                       Scale Median
            FMEDIA = MEDFAC*SLIST(ISKY)
         ELSE
C                                       Else use previous median
            FMEDIA = LSTMED
            END IF
C                                       Copy set range of values
         DO 160 JCOL = ICOL, ICOL+IDELT-1
C                                       Add scaled median
            RESULT(JCOL) = RDATA(JCOL) + FMEDIA
 160        CONTINUE
C                                       Record Last values
         LSTMED = FMEDIA
C                                       End all columns in row
 200     CONTINUE
C                                       Report Progress
      WRITE (MSGTXT,1100) IPOS(2), LROW
      IF (MOD(IPOS(2)-1,100).EQ.0) CALL MSGWRT(3)
C
 999  RETURN
C-----------------------------------------------------------------------
1000  FORMAT ('ROWMED: Filter Width is',I8,', Median is #',I8,
     * 'th Pixel')
1050  FORMAT ('ROWMED: Using only every ',I8,'th Pixel ')
1070  FORMAT ('ROWMED: Correcting Saturation exceeding',F12.5,
     *  ': with value ',F12.5)
1100  FORMAT ('ROWMED: On row ',I8,', Row Length is',I8,' Pixels')
      END

      PROGRAM CCNTR
C-----------------------------------------------------------------------
C! Generates contour plot files for images, overplots CC points
C# Graphics Map-util Plot-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2002-2004, 2006, 2009, 2012,
C;  Copyright (C) 2014-2015, 2020-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CCNTR will write commands to a plot file for the execution of a
C   contour plot for a cataloged image file.  The program runs as a
C   detached task initiated from AIPS. First a cataloged file is found
C   using data passed from AIPS.  The list of associated files is
C   searched for PLot files to find the highest version number.  Then a
C   PLot file is created for this map and the catalog header is updated.
C   Next the graphics commands are written to the plot file.  TELL
C   'ABOR' and 'QUIT' codes supported.  Differs from CNTR in that it
C   will overplot samples from a CC file.
C   Inputs:   (from AIPS)
C      USERID   R      user number, 0 means use logon user
C                      number, 32000 means any user can be accessed.
C      INNAME   H(3)   name of primary file.
C      INCLASS  H(2)   class of primary file.
C      INSEQ    R      sequence number of primary file.
C      INDISK   R      disk volume number. 0 means try all.
C      BLC      R(7)   bottom left corner of subimage: x, y, z, ...
C      TRC      R(7)   top right hand corner of plotted subimage
C      XYRATIO  R      the ratio between the scale factor to use for the
C                      X axis and the scale factor to use for the Y axis
C      LTYPE    R      the type of axis labeling to use for this plot.
C                          1 = no labels. Make map as big as possible.
C                          2 = no ticks, do rest of labels
C                          3 = RA - DEC coordinates & labels
C                          4 = Center-relative units
C      PLEV     R      the percentage of the peak value to use as the
C                      multiplier for the contour levels.  If 0 use CLEV
C      CLEV     R      The absolute value of the multiplier used for the
C                      contour levels.  Used only if PLEV is zero.
C      LEVS     R(30)  the contour levels.  An out of sequence level
C                      indicates 'end of levels'.  The real value of a
C                      particular level is the LEV value times CLEV or
C                      the value determined by PLEV.
C      DOCIRCLE R      > 0 Plot coord grid rather than just ticks
C      INVERS   R      ST file version number.
C      STFACTOR R      scale star sizes in file for plotting:
C                         0 => no plot of stars.
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C      TVCORN   R(2)   TV pixel to use (both > 0 => pixel scale)
C-----------------------------------------------------------------------
      CHARACTER IGFILE*48, PRGNAM*6, CHTM12*12, CHTM6*6, TYPIN*2,
     *  INEXTD*2, OPCODE*4, TXTMSG*80
      REAL      BLC(7), LEVS(30), TRC(7), DOCIRC, CH(4), CLEV, DSKIN,
     *   MULT, STMULT, PEAK, PLEV, PRUSER, SEQIN, XYRATO, TLABEL, YGAP,
     *   XINVER, XCTYPE(4), XDOTV, XGRCH, XTVCRN(2), PIXR(2),
     *   FCUT, FSCALE, SUBMIN, SUBMAX
      HOLLERITH NAMIN(3), CLSIN(2), XEXTD(1)
      INTEGER   I, PLBUF(256), IGLUN, IGFIND, IGSIZE, ILABEL, IMFIND,
     *   IMLUN, IERR, IRETCD, ISEQ, J, INPRMS, ISLOT, ITYPE, IUSER,
     *   IVER, IVOL, IROUND, INVER, CTYPE, GRCHN, TVCHN, TVCORN(2), NCC,
     *   IDEPTH(5), BBLC(2), BTRC(2), DUM
      LOGICAL   NOSAVE, QUICK, SAVE, T, DOGRID, DOTV
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DCNT.INC'
      COMMON /INPARM/ PRUSER, NAMIN, CLSIN, SEQIN, DSKIN, BLC, TRC,
     *   XYRATO, TLABEL, PLEV, CLEV, LEVS, DOCIRC, XEXTD, XINVER,
     *   XCTYPE, FCUT, FSCALE, STMULT, XDOTV, XGRCH, XTVCRN
      DATA IMLUN, IGLUN /16, 26/
      DATA PRGNAM /'CCNTR '/
      DATA TYPIN /'  '/
      DATA NOSAVE, SAVE, T /.FALSE.,.TRUE.,.TRUE./
      DATA BBLC, BTRC /4 * 0/
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Get input values from AIPS.
      INPRMS = 70
      IRETCD = 0
      CALL GTPARM (PRGNAM, INPRMS, QUICK, PRUSER, PLBUF, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRETCD = 8
 10   IF (QUICK) CALL RELPOP (IRETCD, PLBUF, IERR)
      IF (IRETCD.NE.0) GO TO 995
      IRETCD = 8
      PRUSER = NLUSER
C                                       Hollerith -> Char
      CALL H2CHR (12, 1, NAMIN, CHTM12)
      CALL H2CHR (6, 1, CLSIN, CHTM6)
      CALL H2CHR (2, 1, XEXTD, INEXTD)
C
      DOGRID = DOCIRC.GT.0.0
      ISEQ = IROUND (SEQIN)
      IVOL = IROUND (DSKIN)
      ILABEL = IROUND (TLABEL)
      I = MOD (ABS(ILABEL), 100)
      IF ((I.LE.0) .OR. (I.GT.10)) THEN
         IF (ILABEL.GE.0) THEN
            ILABEL = (ILABEL/100)*100 + 3
         ELSE
            ILABEL = (ILABEL/100)*100 - 3
            END IF
         END IF
      TLABEL = ILABEL
      IUSER = NLUSER
      CTYPE = IROUND (XCTYPE(1))
      CTYPE = MAX (1, CTYPE)
      IF (CTYPE.GT.24) CTYPE = 1
      XCTYPE(1) = CTYPE
      NCC = IROUND (XCTYPE(2))
      PIXR(1) = XCTYPE(3)
      PIXR(2) = XCTYPE(4)
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = 1
      TVCORN(1) = IROUND (XTVCRN(1))
      TVCORN(2) = IROUND (XTVCRN(2))
      FCUT = MAX (0.0, FCUT)
C                                       Levels defaults
      IF ((CLEV.EQ.0.0) .AND. (PLEV.EQ.0.0)) PLEV = 10.0
      IF ((LEVS(1).NE.0.0) .OR. (LEVS(2).GT.LEVS(1))) GO TO 20
         DO 15 I = 1,10
            LEVS(I) = I-11
            LEVS(I+10) = I
            LEVS(I+20) = 0.
 15         CONTINUE
C                                       Open map file & get header.
 20   OPCODE = 'HDWR'
      IF (DOTV) OPCODE = 'READ'
      CALL MAPOPN (OPCODE, IVOL, CHTM12, CHTM6, ISEQ, TYPIN, IUSER,
     *   IMLUN, IMFIND, ISLOT, CATBLK, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Add extension file to header.
      IVER = 0
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', IVOL, ISLOT, CATBLK, PLBUF, SAVE, 'READ',
     *      IVER, IERR)
         IF (IERR.NE.0) GO TO 975
         END IF
C                                       Get header info.
      PEAK = MAX (ABS(CATR(KRDMX)), ABS(CATR(KRDMN)))
      MULT = CLEV
      IF (PLEV.NE.0.0) MULT = PEAK * PLEV / 100.0
      IF (MULT.LE.0.0) THEN
         MULT = PEAK / 10.0
         CLEV = MULT
         END IF
C                                       Build file name.
      CALL ZPHFIL ('PL', IVOL, ISLOT, IVER, IGFILE, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020)
         CALL MSGWRT (7)
         GO TO 970
         END IF
C                                       fill in defaults in PARMS
      DSKIN = IVOL
      CALL RCOPY (5, BLC(3), TRC(3))
C                                       Default XYRATO: ratio of
C                                       incr if related.
      LOCNUM = 1
      DO 31 I = 1,5
         IDEPTH(I) = BLC(I+2) + 0.01
 31      CONTINUE
      IF ((XYRATO.GT.0.01) .AND. (XYRATO.LE.320.0)) GO TO 32
         CALL SETLOC (IDEPTH, T)
         IF ((AXTYP(LOCNUM).EQ.1) .AND. (AXINC(2,LOCNUM).NE.0.0)) XYRATO
     *      = ABS (AXINC(1,LOCNUM) / AXINC(2,LOCNUM))
         IF (((XYRATO.LE.0.04) .OR. (XYRATO.GT.25.)) .AND.
     *      (TRC(1).NE.BLC(1))) XYRATO = (TRC(2)-BLC(2)) /
     *      (TRC(1)-BLC(1))
         IF ((XYRATO.LE.0.04) .OR. (XYRATO.GT.25.)) XYRATO = 1.0
C                                       Init graph file.
 32   IGSIZE = 1
      ITYPE = 37
      CALL GINIT (IVOL, ISLOT, IGFILE, IGSIZE, ITYPE, INPRMS, PRUSER,
     *   DOTV, TVCHN, GRCHN, TVCORN, CATBLK, PLBUF, IGLUN, IGFIND,
     *   IERR)
      IF (IERR.EQ.0) GO TO 35
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (7)
         GO TO 970
C                                       extra border chars
 35   CALL RFILL (4, 0.0, CH)
      YGAP = 0.0
C                                       Write axis labeling commands.
      I = 2 * MABFSS
      CALL FXLEVS (IMLUN, IMFIND, CATBLK, BLC, TRC, 0, 0, 0,
     *   MULT, LEVS, SUBMIN, SUBMAX, BUFF, I, IERR)
      IF (IERR.NE.0) GO TO 960
      CALL COMLAB (BLC, TRC, ILABEL, IVER, YGAP, CH, MULT, LEVS, SUBMIN,
     *   SUBMAX, XYRATO, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 960
      CALL CLAB1 (BLC, TRC, CH, ILABEL, XYRATO, DOGRID, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       Draw stars
C                                       check ST or CC plot parms
      I = 0
      IF ((STMULT.GE.0.0) .AND. (STMULT.LT.0.1)) STMULT = 1.0
      IF ((STMULT.LT.0.0) .AND. (STMULT.GT.-0.1)) STMULT = -1.0
      IF (INEXTD.EQ.'ST') THEN
         CALL FNDEXT ('ST', CATBLK, I)
      ELSE IF ((INEXTD.EQ.'CC') .OR. (INEXTD.EQ.'MF')) THEN
         CALL FNDEXT (INEXTD, CATBLK, I)
         END IF
      IF (I.GT.0) THEN
         J = XINVER + 0.1
         IF (J.LE.0) J = I
         XINVER = J
         INVER = IROUND (XINVER)
         CALL SETLOC (IDEPTH, .TRUE.)
         CALL GLTYPE (4, PLBUF, IERR)
         IF (IERR.NE.0) GO TO 960
         IF (INEXTD.EQ.'ST') THEN
            CALL STARPL (STMULT, IVOL, ISLOT, INVER, BLC, TRC, 0, 0,
     *         CATBLK, BLC, 1, PLBUF, IERR)
            IF (IERR.GE.3) GO TO 950
         ELSE IF ((INEXTD.EQ.'CC') .OR. (INEXTD.EQ.'MF')) THEN
            TXTMSG = 'Start drawing Clean components'
            CALL GCOMNT (2, TXTMSG, PLBUF, IERR)
            IF (IERR.NE.0) GO TO 950
            CALL CCMFPL (INEXTD, STMULT, CTYPE, IVOL, ISLOT, INVER, NCC,
     *         PIXR, BLC, TRC, FCUT, FSCALE, PLBUF, IERR)
            IF (IERR.GE.3) GO TO 950
            END IF
         END IF
      WRITE (MSGTXT,1050)
      CALL MSGWRT (1)
C                                       Draw contours.
C                                       Init map for read.
      I = 2 * MABFSS
      CALL DBINIT (IMLUN, IMFIND, CATBLK, BLC, TRC, I, BUFF, IERR)
      IF (IERR.NE.0) GO TO 960
      TXTMSG = 'Start contouring'
      CALL GCOMNT (2, TXTMSG, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GLTYPE (2, PLBUF, IERR)
      IF (IERR.NE.0) GO TO 960
      CALL CONDRW (IMLUN, IMFIND, 0, 0, MULT, BLC, TRC, LEVS, 0, BBLC,
     *   BTRC, DUM, PLBUF, IERR)
      IF (IERR.GT.9) GO TO 960
      IF (IERR.NE.0) GO TO 950
C                                       Write sucessful finish message.
      CALL GFINIS (PLBUF, IERR)
      IF (IERR.EQ.0) IRETCD = 0
      IF (IERR.NE.0) GO TO 960
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (IVOL, ISLOT, IVER, PLBUF, IERR)
            WRITE (MSGTXT,1300) IVER
            CALL MSGWRT (2)
            END IF
         GO TO 980
C-----------------------------------------------------------------------
C                                       Graph writing error.
 950  WRITE (MSGTXT,1950)
      CALL MSGWRT (8)
C                                       Try to do finish.
      CALL GFINIS (PLBUF, IERR)
      IF (IERR.NE.0) GO TO 960
         IRETCD = 0
         IF (.NOT.DOTV) CALL HIPLOT (IVOL, ISLOT, IVER, PLBUF, IERR)
         GO TO 980
C                                       Finish not sucessful. Destroy.
 960  CALL ZCLOSE (IGLUN, IGFIND, IERR)
      CALL ZDESTR (IVOL, IGFILE, IERR)
C                                       Do not save updated header.
 970  IRETCD = 16
      CALL DELEXT ('PL', IVOL, ISLOT, 'READ', CATBLK, PLBUF, IVER,
     *   IERR)
 975  CALL ZCLOSE (IMLUN, IMFIND, IERR)
      GO TO 995
C                                       Close map file.
 980  CALL MAPCLS ('READ', IVOL, ISLOT, IMLUN, IMFIND, CATBLK, NOSAVE,
     *   PLBUF, IERR)
C
 995  CALL DIETSK (IRETCD, QUICK, PLBUF)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR GETTING PARAMETERS FROM AIPS. GTPARM ERR =',I5)
 1020 FORMAT ('COULD NOT BUILD GRAPH FILE NAME')
 1030 FORMAT ('GRAPH FILE INIT ERROR. GINIT ERR =',I5)
 1050 FORMAT ('End labeling, start contouring')
 1300 FORMAT ('Successful plot file version',I5,'  created.')
 1950 FORMAT ('ERROR DURING GRAPHING WILL TRY TO FINISH PARTIAL GRAPH')
      END
      SUBROUTINE CCMFPL (INEXTD, FACTOR, CTYPE, IVOL, CNO, VERS, NCC,
     *   PIXR, BLC, TRC, FCUT, FSCALE, PLBUF, IERR)
C-----------------------------------------------------------------------
C   CCMFPL plots CC positions in a plot file as given by an CC
C   extension file of version VERS.
C   Inputs:
C      INEXTD   C*2      'CC' or 'MF' - file type
C      FACTOR   R        Star scaling factor: <= 0 => no plot.
C      CTYPE    I        Symbol type
C      IVOL     I        File disk number
C      CNO      I        File catalog number
C      VERS     I        Desired ST file version number: 0 => high
C      NCC      I        Maximum number CC components
C      PIXR     R(2)     CC value range to scale symbol choice
C      BLC      R(2)     Plot lower left corner (pixels)
C      TRC      R(2)     Plot upper right corner (pixels)
C      FCUT     R        Only plot > FCUT in abs value
C      FSCALE   R        Scale relative to this flux if > 0
C   In/Out:
C      PLBUF    I(256)   Plot IO buffer
C   Output:
C      IERR    I         Error code: 0 => okay
C                                -1 => there was no ST file
C                                +1 => logical error in ST file
C                                +2 => IO error in ST file
C                                +3 => IO error in plotting
C   Common:
C      /MAPHDR/ CATBLK input   Image header having the ST file
C-----------------------------------------------------------------------
      CHARACTER INEXTD*2
      REAL      FACTOR, PIXR(2), BLC(2), TRC(2), FCUT, FSCALE
      INTEGER   CTYPE, IVOL, CNO, VERS, NCC, PLBUF(256), IERR
C
C                                       Max Numb Columns, Label length
      INTEGER   MXLINE
      PARAMETER (MXLINE=72)
      CHARACTER CCNUM*10
      HOLLERITH CATH(256)
      INTEGER   IOBUF(768), CATBLK(256), IV, I, NKEY, NCOL, NREC,
     *   TABLUN, IER, NPL, NST, IST, STTYPE, NCHAR, ICTYPE,
     *   FCOL, PCOL, WCOL
      REAL      CATR(256), AX(5), AY(5), RECORD(50), BMAJ, BMIN, BPA,
     *   TX, TY, DX, DY, XPOS, YPOS, XP(3), YP(3), BMJS, BMJC, BMNS,
     *   BMNC, F
      DOUBLE PRECISION XX(3), YY(3), ZZ(3)
      LOGICAL   DOPNT, DOPIXR
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:PSTD.INC'
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK, CATH, CATR)
      DATA TABLUN /27/
C-----------------------------------------------------------------------
      IERR = 0
      IF (FACTOR.EQ.0.0) GO TO 999
      STTYPE = MAX (1, CTYPE)
      IF (STTYPE.GT.24) STTYPE = 1
      DOPIXR = PIXR(2).GT.PIXR(1)
      ICTYPE = STTYPE
C                                       Is there a CC or MF file
      IERR = -1
      CALL FNDEXT (INEXTD, CATBLK, I)
      IF (I.LE.0) GO TO 999
      IV = VERS
      IF ((IV.LE.0) .OR. (IV.GT.I)) IV = I
C                                       Open CC or MF table file
      NKEY = 0
      NCOL = 0
      NREC = 0
      CALL TABINI ('READ', INEXTD, IVOL, CNO, IV, CATBLK, TABLUN, NKEY,
     *   NREC, NCOL, IOBUF(513), IOBUF, IERR)
      IF (IERR.EQ.0) GO TO 20
         WRITE (MSGTXT,1000) IERR, IV
         GO TO 990
 20   NST = IOBUF(5)
      IF (NCC.GT.0) NST = MIN (NST, NCC)
      DOPNT = NCOL.LT.7
      IF (INEXTD.EQ.'CC') THEN
         FCOL = 1
         PCOL = 2
         WCOL = 4
         IF ((NCOL.EQ.4) .OR. (NCOL.EQ.8)) THEN
            WCOL = 5
            MSGTXT =
     *         'WARNING: 3D CC table may not align properly on image'
            CALL MSGWRT (7)
            END IF
      ELSE
         CALL FNDCOL (1, 'I FLUX', 6, .FALSE., IOBUF, FCOL, IERR)
         CALL FNDCOL (1, 'DELTAX', 6, .FALSE., IOBUF, PCOL, IERR)
         CALL FNDCOL (1, 'MAJOR AX', 8, .FALSE., IOBUF, WCOL, IERR)
         IF ((FCOL.NE.3) .OR. (PCOL.NE.4) .OR. (WCOL.NE.6)) THEN
            WRITE (MSGTXT,4000) FCOL, PCOL, WCOL
 4000       FORMAT ('FNDCOL RESULTS: F, P, W = ',3I4)
            CALL MSGWRT (6)
            END IF
         END IF
C                                       I guess we can do it now
      NPL = 0
      DO 100 IST = 1,NST
         CALL TABIO ('READ', 0, IST, RECORD, IOBUF, IERR)
         IF (IERR.GT.0) THEN
            GO TO 975
C                                       row not flagged
         ELSE IF (IERR.EQ.0) THEN
            F = RECORD(FCOL)
            IF (ABS(F).LT.FCUT) GO TO 100
            IF (DOPIXR) THEN
               ICTYPE = STTYPE * (F - PIXR(1)) /
     *            (PIXR(2) - PIXR(1)) + 0.5
               ICTYPE = MAX (1, MIN (ICTYPE, STTYPE))
               END IF
            XPOS = RPLOC(1,LOCNUM) + RECORD(PCOL)/AXINC(1,LOCNUM)
            YPOS = RPLOC(2,LOCNUM) + RECORD(PCOL+1)/AXINC(2,LOCNUM)
C                                       If star not in plot, get next
            IF ((BLC(1).GT.XPOS) .OR. (BLC(2).GT.YPOS) .OR.
     *         (TRC(1).LT.XPOS) .OR. (TRC(2).LT.YPOS)) GO TO 100
C                                       Object dimensions
            IF (DOPNT) THEN
               BMAJ = ABS (FACTOR)
               BMIN = ABS (FACTOR)
               IF (FSCALE.GT.0.0) THEN
                  BMAJ = BMAJ * F / FSCALE
                  BMIN = BMIN * F / FSCALE
                  END IF
               BPA  = 0.0
               BMJS = 0.0
               BMNS = 0.0
               BMJC = BMAJ
               BMNC = BMIN
C                                        Correct BPA for coord rotation
            ELSE
               CALL XYVAL (XPOS, YPOS, XX(1), YY(1), ZZ(1), IERR)
               IF (IERR.NE.0) GO TO 100
               IF (CORTYP(LOCNUM).EQ.1) THEN
                  XX(2) = XX(1) + RECORD(WCOL) * SIN
     *               (DG2RAD*RECORD(WCOL+2)) / COS (DG2RAD * YY(1))
                  YY(2) = YY(1) + RECORD(WCOL) * COS
     *               (DG2RAD*RECORD(WCOL+2))
                  XX(3) = XX(1) - RECORD(WCOL+1) * COS
     *               (DG2RAD*RECORD(WCOL+2)) / COS (DG2RAD * YY(1))
                  YY(3) = YY(1) + RECORD(WCOL+1) * SIN
     *               (DG2RAD*RECORD(WCOL+2))
               ELSE IF (CORTYP(LOCNUM).EQ.2) THEN
                  YY(2) = YY(1) + RECORD(WCOL) * SIN
     *               (DG2RAD*RECORD(WCOL+2)) / COS (DG2RAD * XX(1))
                  XX(2) = XX(1) + RECORD(WCOL) * COS
     *               (DG2RAD*RECORD(WCOL+2))
                  YY(3) = YY(1) - RECORD(WCOL+1) * COS
     *               (DG2RAD*RECORD(WCOL+2)) / COS (DG2RAD * XX(1))
                  XX(3) = XX(1) + RECORD(WCOL+1) * SIN
     *               (DG2RAD*RECORD(WCOL+2))
               ELSE
                  XX(2) = XX(1) + RECORD(WCOL) * SIN
     *               (DG2RAD*RECORD(WCOL+2))
                  YY(2) = YY(1) + RECORD(WCOL) * COS
     *               (DG2RAD*RECORD(WCOL+2))
                  XX(3) = XX(1) - RECORD(WCOL+1) * COS
     *               (DG2RAD*RECORD(WCOL+2))
                  YY(3) = YY(1) + RECORD(WCOL+1) * SIN
     *               (DG2RAD*RECORD(WCOL+2))
                  END IF
               CALL XYPIX (XX(2), YY(2), XP(2), YP(2), IERR)
               IF (IERR.NE.0) GO TO 100
               CALL XYPIX (XX(3), YY(3), XP(3), YP(3), IERR)
               IF (IERR.NE.0) GO TO 100
               IF (FSCALE.LE.0.0) THEN
                  F = ABS (FACTOR)
               ELSE
                  F = F * ABS (FACTOR) / FSCALE
                  END IF
               BMJS = (XPOS - XP(2)) * 0.5 * F
               BMJC = (YP(2) - YPOS) * 0.5 * F
               BMNC = (XP(3) - XPOS) * 0.5 * F
               BMNS = (YP(3) - YPOS) * 0.5 * F
               END IF
C                                        If the label is requested
            AX(1) = XPOS
            AX(2) = XPOS - BMJS
            AX(3) = XPOS + BMJS
            AX(4) = XPOS + BMNC
            AX(5) = XPOS - BMNC
            AY(1) = YPOS
            AY(2) = YPOS + BMJC
            AY(3) = YPOS - BMJC
            AY(4) = YPOS + BMNS
            AY(5) = YPOS - BMNS
            IF (FACTOR.LT.0.0) THEN
               WRITE (CCNUM,1020) IST
               CALL CHTRIM (CCNUM, 10, CCNUM, NCHAR)
C                                        a box or no mark: TRC
               IF ((ICTYPE.GE.4) .OR. (ICTYPE.LT.0)) THEN
                  TX = XPOS
                  TY = YPOS
                  DY = -0.5
C                                        Else right edge of mark
               ELSE
                  TX = XPOS
                  TY = AY(3)
                  DY = -1.1
                  END IF
               DX = -NCHAR / 2.0
C                                       If label starts in the plot
C                                       Move and Put Text on plot
               IF ((BLC(1).LE.TX) .AND. (BLC(2).LE.TY) .AND.
     *            (TRC(1).GE.TX) .AND. (TRC(2).GE.TY)) THEN
                  CALL GPOS (TX, TY, PLBUF, IER)
                  CALL GCHAR (NCHAR, 0, DX, DY, CCNUM, PLBUF, IERR)
                  END IF
               END IF
C                                       generic point plotter
            CALL PNTPLT (ICTYPE, AX, AY, BLC, TRC, .FALSE., .FALSE.,
     *         PLBUF, IERR)
            IF (IERR.NE.0) THEN
               MSGTXT = 'PNTPLT ERROR'
               CALL MSGWRT (8)
               GO TO 985
               END IF
            NPL = NPL + 1
            END IF
 100     CONTINUE
      IERR = 0
      WRITE (MSGTXT,1100) NPL, INEXTD, IV
      CALL MSGWRT (2)
      GO TO 985
C                                       Error print and close
 975  WRITE (MSGTXT,1975) IERR, INEXTD
      IERR = 2
      CALL MSGWRT (8)
 985  CALL TABIO ('CLOS', 0, IST, RECORD, IOBUF, IER)
      GO TO 999
C                                       Error print
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' OPENING CC FILE VERSION',I4)
 1020 FORMAT (I10)
 1100 FORMAT ('Plotted',I8,' positions from ',A,' table version',I4)
 1975 FORMAT ('IO ERROR',I5,' IN ',A,' TABLE FILE')
      END

      SUBROUTINE PASWRD (BUF, IRET)
C-----------------------------------------------------------------------
C! prompts for and checks password if the user has a non-blank PW entry
C# System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2002, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PASWRD interogates the password file for the existence of a non-
C   blank password for user NLUSER.  If there is one, it prompts the
C   user for the password and reads the answer (via ZPASWD) and then
C   compares it to the one stored on disk.
C   Outputs:
C      BUF   I(256)    Scratch buffer
C      IRET  I         Error code: 0 => you may continue
C                               1 => I/O error
C                               2 => input error
C                               3 => password fault
C-----------------------------------------------------------------------
      INTEGER   BUF(256), IRET
C
      CHARACTER BLANK*12, PHNAME*48, UPASS*12
      HOLLERITH APASS(3), TPASS(3)
      INTEGER   NLPR, LUN, IND, IERR, IER, I, J, IREC
      LOGICAL   T, F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN /15/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IRET = 2
      IF ((NLUSER.LT.1) .OR. (NLUSER.GT.USELIM)) GO TO 999
C                                       Find encoded password
      J = 3
      NLPR = 256 / J
      IREC = (NLUSER - 1) / NLPR + 1
      IRET = 1
      CALL ZPHFIL ('PW', 1, 0, 0, PHNAME, IERR)
      CALL ZOPEN (LUN, IND, 1, PHNAME, F, F, T, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZFIO ('READ', LUN, IND, IREC, BUF, IERR)
      CALL ZCLOSE (LUN, IND, IER)
      IF (IERR.NE.0) GO TO 999
      I = NLUSER - (IREC-1) * NLPR
      I = (I - 1) * J + 1
      CALL COPY (J, BUF(I), APASS)
C                                       is it blank?
      BLANK = ' '
      CALL PASENC (BLANK, TPASS)
      IRET = 0
      IF (TPASS(1).NE.APASS(1)) GO TO 20
      IF (TPASS(2).NE.APASS(2)) GO TO 20
      IF (TPASS(3).EQ.APASS(3)) GO TO 999
C                                       NO: read a password
 20   IRET = 1
      CALL ZPASWD (UPASS, BUF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL PASENC (UPASS, TPASS)
      IRET = 0
      IF (TPASS(1).NE.APASS(1)) GO TO 30
      IF (TPASS(2).NE.APASS(2)) GO TO 30
      IF (TPASS(3).EQ.APASS(3)) GO TO 999
C                                       Bad password: try again
 30   WRITE (MSGTXT,1030)
      CALL MSGWRT (2)
      IRET = 1
      CALL ZPASWD (UPASS, BUF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL PASENC (UPASS, TPASS)
      IRET = 0
      IF (TPASS(1).NE.APASS(1)) GO TO 40
      IF (TPASS(2).NE.APASS(2)) GO TO 40
      IF (TPASS(3).EQ.APASS(3)) GO TO 999
C                                       Bad password: quit
 40   WRITE (MSGTXT,1040)
      CALL MSGWRT (9)
      IRET = 3
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('PASSWORD DOES NOT MATCH --- TRY AGAIN')
 1040 FORMAT ('PASSWORD DOES NOT MATCH --- QUITTING')
      END

      SUBROUTINE QPHSRO (A, I, B, J, PHAS0, DELPHS, N)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Add phase gradient to a complex array.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Adds a phase gradient to a complex array:
C        B(j) = A(j)*EXP(-i*(PHAS0+j*DELPHS)) for j = 0,N-1
C    Inputs:
C     A       I    Source vector base address.
C     I       I    Increment of A
C     B       I    Destination base address.
C     J       I    Increment of B
C     PHAS0   I    Address of complex unit vector with
C                  phase PHAS0
C     DELPHS  I    Address of complex unit vector with
C                  phase DELPHS
C     N       I    Element count
C   Useage notes:
C      This routine uses work vector, WKVECA
C   CRI version.
C-----------------------------------------------------------------------
      INTEGER   A, I, B, J, PHAS0, DELPHS, N, LOOP, JA, JB, JC
      REAL     TEMP, TEMPR, TEMPI, PHASE, DPHASE, TWOPI
      INCLUDE 'INCS:DAPC.INC'
      DATA TWOPI /6.283185308/
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Get phase and delta phase
      PHASE = ATAN2 (APCORE(PHAS0+2), APCORE(PHAS0+1)+1.0E-30)
      DPHASE = ATAN2 (APCORE(DELPHS+2), APCORE(DELPHS+1)+1.0E-30)
C                                       Make phase ramp
      JA = 1
      DO 20 LOOP = 1,N
         TEMP = MOD ((PHASE + (LOOP-1) * DPHASE), TWOPI)
         WKVECA(JA+1) = SIN (TEMP)
         WKVECA(JA) = COS (TEMP)
         JA = JA + 2
 20      CONTINUE
C                                       Addresses 1-rel
      JA = A + 1
      JB = B + 1
      JC = 1
C                                        (complex) multiply WKVECA*JA
      INCLUDE 'INCS:ZVND.INC'
      DO 100 LOOP = 1,N
         TEMPR = APCORE(JA)*WKVECA(JC) - APCORE(JA+1)*WKVECA(JC+1)
         TEMPI = APCORE(JA)*WKVECA(JC+1) + APCORE(JA+1)*WKVECA(JC)
         APCORE(JB) = TEMPR
         APCORE(JB+1) = TEMPI
C                                        Update indices.
         JA = JA + I
         JB = JB + J
         JC = JC + 2
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE CQSEL (DISKI, CNOI, DISKO, CNOO, VER, CATIN, CATOUT,
     *   LUNI, LUNO, BIF, EIF, IFQID, ISUB, JSUB, BUFFER, OBUFF, IRET)
C-----------------------------------------------------------------------
C! Copies and renumbers the IFs in a CQ table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Copies and renumbers the IFs in an CQ table, can also modify the
C   FQ ID.
C   Inputs:
C      DISKI           I       Input volume number
C      CNOI            I       Input catalog number
C      DISKO           I       Output volume number
C      CNOO            I       Output catalog number
C      VER             I       Version to check/modify
C      CATIN(256)      I       Input catalog header
C      CATOUT(256)     I       Output catalog header
C      LUNI            I       LUN to use
C      LUNO            I       LUN to use
C      BIF             I       Start IF number
C      EIF             I       End IF number
C      IFQID           I       FQ ID to select (set to 1 on output)
C                              if <= 0 then output value unchanged.
C      ISUB     I        Selected subarray (= 0 any)
C      JSUB     I        Output subarray number (< 0 => NO CHANGE)
C   Input/Output:
C      BUFFER          I(*)    Work buffer
C      OBUFF           I(*)    Work buffer
C   Output:
C      IRET            I       Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER DISKI, CNOI, DISKO, CNOO, VER, CATIN(256), CATOUT(256),
     *   LUNI, LUNO, BIF, EIF, IFQID, ISUB, JSUB, BUFFER(*), OBUFF(*),
     *   IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCQV.INC'
      LOGICAL   REFMT
      CHARACTER LTAPCQ(MAXIF)*8
      DOUBLE PRECISION DFRQCQ(MAXIF), DCBWCQ(MAXIF)
      REAL TAVGCQ(MAXIF)
      INTEGER ICQRNO, CQKOLS(MAXCQC), CQNUMV(MAXCQC), NROW, OCQRNO,
     *   OCQKOL(MAXCQC), OCQNUM(MAXCQC), I, NOIFCQ, IFQDCQ, ISUBCQ,
     *   NFFTCQ(MAXIF), NCHCQ(MAXIF), NSAVCQ(MAXIF), NOVSCQ(MAXIF),
     *   NZPDCQ(MAXIF), NBITCQ(MAXIF), IFLTCQ(MAXIF), IOVLCQ(MAXIF),
     *   NIFO, OVER
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Open CQ table
      CALL CQINI ('READ', BUFFER, DISKI, CNOI, VER, CATIN, LUNI,
     *   ICQRNO, CQKOLS, CQNUMV, NOIFCQ, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       # rows in old table
      NROW = BUFFER(5)
C                                       Open new CQ table
      NIFO = EIF - BIF + 1
      REFMT = NIFO.NE.NOIFCQ
      OVER = VER
      CALL CQINI ('WRIT', OBUFF, DISKO, CNOO, OVER, CATOUT, LUNO,
     *   OCQRNO, OCQKOL, OCQNUM, NIFO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 100 I = 1, NROW
         CALL TABCQ ('READ', BUFFER, ICQRNO, CQKOLS, CQNUMV, NOIFCQ,
     *      IFQDCQ, ISUBCQ, NFFTCQ, NCHCQ, NSAVCQ, DFRQCQ, DCBWCQ,
     *      LTAPCQ, NOVSCQ, NZPDCQ, IFLTCQ, TAVGCQ, NBITCQ, IOVLCQ,
     *      IRET)
C                                       check FQ, suba
         IF (IRET.EQ.0) THEN
            IF ((IFQID.GT.0) .AND. (IFQID.NE.IFQDCQ) .AND.
     *         (IFQDCQ.GT.0)) IRET = -1
            IF ((ISUBCQ.GT.0) .AND. (ISUB.GT.0) .AND. (ISUB.NE.ISUBCQ))
     *         IRET = -1
            END IF
C                                       error
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1020) IRET
            GO TO 990
C                                       flagged
         ELSE IF (IRET.LT.0) THEN
            REFMT = .TRUE.
C                                       Write if selected
         ELSE
C                                       Set output FQ_ID to 1
            IF (IFQID.GT.0) IFQDCQ = 1
            IF (JSUB.GE.0) ISUBCQ = JSUB
            CALL TABCQ ('WRIT', OBUFF, OCQRNO, OCQKOL, OCQNUM, NIFO,
     *         IFQDCQ, ISUBCQ, NFFTCQ(BIF), NCHCQ(BIF), NSAVCQ(BIF),
     *         DFRQCQ(BIF), DCBWCQ(BIF), LTAPCQ(BIF), NOVSCQ(BIF),
     *         NZPDCQ(BIF), IFLTCQ(BIF), TAVGCQ(BIF), NBITCQ(BIF),
     *         IOVLCQ(BIF), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1020) IRET
               GO TO 990
               END IF
            END IF
 100     CONTINUE
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ICQRNO, BUFFER, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OCQRNO, OBUFF, OBUFF, IRET)
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         IF (REFMT) THEN
            WRITE (MSGTXT,1100) 'Reformatted CQ', DISKI, CNOI, VER,
     *         DISKO, CNOO, OVER
         ELSE
            WRITE (MSGTXT,1100) 'Copied CQ', DISKI, CNOI, VER, DISKO,
     *         CNOO, OVER
            END IF
         CALL MSGWRT (3)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('CQSEL: ERROR ',I3,' RETURNED FROM CQINI')
 1020 FORMAT ('CQSEL: ERROR ',I3,' RETURNED FROM TABCQ')
 1100 FORMAT (A,' file from vol/cno/vers',I3,I5,I4,' to',I3,I5,I4)
      END

LOCAL INCLUDE 'GLENS.INC'
C                                       Local include for LENS
      INTEGER   MAXMAP
      PARAMETER (MAXMAP=512)
      INCLUDE 'INCS:PMAD.INC'
C
      INTEGER   SEQOUT, DISKO, NEWCNO, NUMHIS, JBUFSZ, ICODE, LUNIN,
     *   FINDIN
      CHARACTER HISCRD(10)*64, SOURCE*8, NAMOUT*12, CLAOUT*6
      HOLLERITH XSOURC(2), XNAMOU(3), XCLAOU(2)
      REAL      XMSIZE(2), XSEQO, XDISKO, APARM(10), BPARM(10),
     *          CPARM(10), DPARM(10), BUFFER(MABFSS)
C                                       Program commons
      COMMON /INPARM/ XSOURC, XMSIZE,
     *   XNAMOU, XCLAOU, XSEQO, XDISKO, APARM, BPARM, CPARM, DPARM
      COMMON /PARMS/ SEQOUT, DISKO, NEWCNO,
     *   JBUFSZ, ICODE, LUNIN, FINDIN, NUMHIS
      COMMON /BUFRS/ BUFFER
      COMMON /CHRCOM/ HISCRD, SOURCE, NAMOUT, CLAOUT
LOCAL END
LOCAL INCLUDE 'EPSLN.INC'
C                                       Local include of small values
      REAL      EPSLN, EPSLN2, MAXMAG
      PARAMETER (EPSLN=1.0E-3, EPSLN2=EPSLN*EPSLN, MAXMAG=0.01)
LOCAL END
      PROGRAM GLENS
C-----------------------------------------------------------------------
C! GLENS Simulates a gravitational lens acting on a 3 component source
C# Map-Experimental
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Gravitational LENS modeling program
C   GLENS Creats a jacobian or source plane function for an elliptical
C   galaxy lens model with paramters b, epsilon, theta
C   and core radius S.
C   A circular source model can be created with CPARM(7,8 and 9)
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      SOURCE         SOURCE        Object name.
C      IMSIZE         XMSIZE        Image size in pixels.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLAOUT        Class of the output image.
C                                   Default is input class.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      APARM(10)      APARM         Source Model (First Component)
C                                   1:XS1      2:YS1
C                                   3:MAJAX1;  4;MINAX1
C                                   5:TH1 (Degrees);  6:INTENS1A
C                                   7:INTENS1B
C      BPARM(10)      BPARM         Source Model (Second Component)
C                                   1:XS2      2:YS2
C                                   3:MAJAX2;  4;MINAX2
C                                   5:TH2;  6:INTENS2A
C                                   7:INTENS2B
C      CPARM(10)      CPARM         Source Model (Third Component)
C                                   1:XS3      2:YS3
C                                   3:MAJAX3;  4;MINAX3
C                                   5:TH3;  6:INTENS3A
C                                   7:INTENS3B
C      DPARM(10)      DPARM         Lens Model
C                                   1:X0;      2:Y0
C                                   3:Theta;   4:B
C                                   5:Epsilon; 6:S
C                                   7:Alpha
C                                   8:Model Type 0=1=> Blandford
C                                     2=> Point Mass
C                                     3=> Narayan Galaxy
C                                     4=> King Model
C                                     5=> de Vaucouleurs
C                                   9:Include Source model >0 yes
C                                     Magnifcation in image plane < 0
C                                   10:>0 Source Plane, else Image Plane
C   Programmer Glen Langston, June 1989
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'GLENS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'GLENS '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL CANIN (PRGM, IRET)
C                                       Call routine that sends data
C                                       to the user routine.
      IF (IRET.EQ.0) CALL SENDMA (IRET)
C                                       History
      IF (IRET.EQ.0) CALL CANHIS
C                                       Close down files, etc.
      CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE CANIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   CANIN gets input parameters for LENS and creates an output file.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                     4 => user routine detected error.
C                     5 => catalog troubles
C                     8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in LENS for more details.
C
C   To change the adverb list sent to this task change:
C   1)  the inputs file.
C   2)  the contents of COMMON /INPARM/.  Remember all adverbs are sent
C       as R,    OUTNAME etc. are 12 char. 3 words;
C       OUTCLASS etc. are 6 char., 2 words.
C       Values will be filled into COMMON /INPARM/ in the order
C       specified in the inputs file.
C   3)  If the first adverb is not FILEIN then replace
C       XFILEI in the call to GTPARM with the name of the first
C       adverb.
C   4)  Change the value of NPARM sent to GTPARM to the number of
C       R   words desired.
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      CHARACTER BLANK*6, DEFNAM*12, OLDNAM*12, LENSTY(7)*12
      INTEGER   IERR, NPARM, IROUND, NX, NY
      LOGICAL   T, F
      REAL      CELLS(2)
      DOUBLE PRECISION REFVAL(2)
      INCLUDE 'GLENS.INC'
      INCLUDE 'EPSLN.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA BLANK /'      '/
      DATA T, F /.TRUE.,.FALSE./
      DATA DEFNAM /'GRAVITY LENS'/
      DATA LENSTY /'IMAGE  PLANE','SOURCE PLANE','BLANDFORD   ',
     *             'POINT MASS  ','NARAYAN     ','KING GALAXY ',
     *             'DEVAUCOULEUR'/
      DATA CELLS/2.777777E-4,2.777777E-4/, REFVAL/0.0,0.0/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Init CATBLK.
      CALL FILL (256, 0, CATBLK)
C                                       Get input parameters.
      NPARM = 51
      CALL GTPARM (PRGN, NPARM, RQUICK, XSOURC, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
            END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFFER, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQOUT = IROUND (XSEQO)
      DISKO = IROUND (XDISKO)
C                                       Characters
      CALL H2CHR (8,  1, XSOURC, SOURCE)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6,  1, XCLAOU, CLAOUT)
      IF (SOURCE.EQ.'        ') SOURCE = 'Einstein'
C                                       Create new file.
C                                       def. name is lens model
      OLDNAM = LENSTY(3)
      IF (DPARM(8).EQ.3) OLDNAM = LENSTY(5)
      IF (DPARM(8).EQ.4) OLDNAM = LENSTY(6)
      IF (DPARM(8).EQ.5) OLDNAM = LENSTY(7)
C                                       Allow only point or blandford
      IF (DPARM(8).GE.2) THEN
C                                       Point lens
         DPARM(8) = 2
         OLDNAM = LENSTY(4)
      ELSE
C                                       Else Blandford lens
         DPARM(8) = 1
         OLDNAM = LENSTY(3)
         END IF
C                                       If Source or Image plane
      IF (DPARM(10).GT.EPSLN) OLDNAM = LENSTY(2)
C                                       DPARM(10)<=0 => IMAGE plane
      IF (DPARM(10).LT.-EPSLN) OLDNAM = LENSTY(1)

      CALL MAKOUT (OLDNAM, BLANK, 0, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
      CATBLK(KIIMS) = SEQOUT
C                                       init map size
      IF (XMSIZE(1) .LE. 0) XMSIZE(1) = MAXMAP/4
      IF (XMSIZE(2) .LE. 0) XMSIZE(2) = MAXMAP/4
C                                       Make map size even
      NX = (IROUND( XMSIZE(1))+1)/2
      NY = (IROUND( XMSIZE(2))+1)/2
C                                       Limit to valid values
      XMSIZE(1) = MIN( MAX ( NX*2, 1), MAXMAP)
      XMSIZE(2) = MIN( MAX ( NY*2, 1), MAXMAP)
C                                       If making both image and source
C                                       Make twice as big
      IF (DPARM(10).EQ.0) XMSIZE(1) = 2 * XMSIZE(1)
C                                       Get user modification to CATBLK
      IRET = 4
C                                       Set map header defaults
      CALL NEWHED ('RA---SIN','DEC--SIN','Magnify ', SOURCE,
     *   REFVAL, XMSIZE, CELLS, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create output file.
      NEWCNO = 1
      IRET = 4
      CALL MCREAT (DISKO, NEWCNO, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
C                                       Set obs. date=current date.
      CATH(KHDOB) = CATH(KHDMP)
      CATH(KHDOB+1) = CATH(KHDMP+1)
      GO TO 999

 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CANIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1060 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE SENDMA (IRET)
C-----------------------------------------------------------------------
C   SENDMA accepts an image one row at a time from the user supplied
C   routine.
C   Output:
C      IRET   I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   LUNO, BOTEMP, NXO, NYO, WINO(4), BOO, LIM2, LIM3, LIM4,
     *   LIM5, LIM6, LIM7, I1, I2, I3, I4, I5, I6, I7, IPOS(7), LIMO,
     *   LIMIT, OBIND, LUN1, LUN2, INDO, LIM1
      REAL      OUTMAX, OUTMIN
      CHARACTER IFILE*48, REST*4
      LOGICAL   T, F, BLNKD
      INCLUDE 'GLENS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNO, LUN1, LUN2 /16,17,18/, OBIND/1/
      DATA REST /'REST'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Create scratch file.
C                                       Open vis file for write
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Setup for I/O
      NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      OUTMAX = -1.0E20
      OUTMIN = 1.0E20
      BLNKD = F
C                                       Setup for looping
      LIM1 = MAX (1, CATBLK(KINAX))
      LIM2 = MAX (1, CATBLK(KINAX+1))
      LIM3 = MAX (1, CATBLK(KINAX+2))
      LIM4 = MAX (1, CATBLK(KINAX+3))
      LIM5 = MAX (1, CATBLK(KINAX+4))
      LIM6 = MAX (1, CATBLK(KINAX+5))
      LIM7 = MAX (1, CATBLK(KINAX+6))
      IPOS(1) = 1
      LIMO = CATBLK(KINAX) - 1
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = I4
                  DO 300 I3 = 1,LIM3
      IPOS(3) = I3
C                                       Init output file.
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IPOS(3), BOTEMP, IRET)
      BOO = BOTEMP + 1
      CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO, BUFFER, JBUFSZ,
     *   BOO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) 'WRIT', IRET
         GO TO 990
         END IF
      DO 250 I2 = 1,LIM2
         IPOS(2) = I2
C                                       Write.
         CALL MDISK ('WRIT', LUNO, INDO, BUFFER, OBIND, IRET)
         OBIND = OBIND - 1
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1120) 'WRIT', IRET
            GO TO 990
            END IF
C                                       Call MAKMAP
         OBIND = OBIND + 1
         CALL MAKMAP (IPOS, BUFFER(OBIND), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1180) IRET
            GO TO 990
            END IF
C                                       Check max, min, blanking.
         LIMIT = OBIND + LIMO
         DO 200 I1 = OBIND,LIMIT
            BLNKD = BLNKD .OR. (BUFFER(I1).EQ.FBLANK)
            IF (BUFFER(I1).EQ.FBLANK) GO TO 200
               OUTMAX = MAX (OUTMAX, BUFFER(I1))
               OUTMIN = MIN (OUTMIN, BUFFER(I1))
 200           CONTINUE
 250     CONTINUE
C                                       Dump plane to output.
C                                       Flush buffer.
      CALL MDISK ('FINI', LUNO, INDO, BUFFER, OBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1120) 'FINI', IRET
         GO TO 990
         END IF
C                                       Update CATBLK.
      CATR(KRDMX) = OUTMAX
      CATR(KRDMN) = OUTMIN
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, REST, BUFFER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1260) IRET
         GO TO 990
         END IF
 300  CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Mark blanking in CATBLK.
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
C                                       Final call to MAKMAP
      IPOS(1) = -1
      CALL MAKMAP (IPOS, BUFFER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1180) IRET
         GO TO 990
         END IF
C                                       Close files
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('SENDMA: ERROR',I3,' OPENING SCRATCH FILE')
 1100 FORMAT ('SENDMA: INIT-FOR-',A4,' ERROR',I3)
 1120 FORMAT ('SENDMA: ',A4,' ERROR',I3)
 1180 FORMAT ('SENDMA: MAKMAP ERROR',I3)
 1260 FORMAT ('SENDMA: CATIO ERROR',I3,' UPDATING CATBLK')
      END
      SUBROUTINE CANHIS
C-----------------------------------------------------------------------
C   CANHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER ATIME*8, ADATE*12, HILINE*72, LABEL*8, REST*4
      INTEGER   LUN, IERR, I, TIME(3), DATE(3)
      LOGICAL   T, F
      INCLUDE 'GLENS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN /27/, REST /'REST'/, T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Create/open hist. file.
      CALL HICREA (LUN, DISKO, NEWCNO, CATBLK, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Get current date/time.
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
C                                       Write first record.
      WRITE (HILINE,1010) TSKNAM, NLUSER, ADATE, ATIME
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       New history
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN,
     *   BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       SOURCE
      WRITE (HILINE,2000) TSKNAM, SOURCE
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       IMSIZE
      WRITE (HILINE,2001) TSKNAM, XMSIZE
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Lens Model parameters
      WRITE (HILINE,2002) TSKNAM, DPARM(1), DPARM(2), DPARM(3)
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Area
      WRITE (HILINE,2003) TSKNAM, DPARM(4), DPARM(6),DPARM(5)
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Lens Model
      HILINE = 'GLENS  Blandford LENS '
      IF (DPARM(8) .GE. 2) HILINE = 'GLENS  Point LENS '
C     IF (DPARM(8) .EQ. 3) HILINE = 'GLENS  Narayan LENS '
C     IF (DPARM(8) .EQ. 4) HILINE = 'GLENS  King LENS '
C     IF (DPARM(8) .EQ. 5) HILINE = 'GLENS  De Vaucouleurs LENS '
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Source
      WRITE (HILINE,2013) TSKNAM, APARM(1), APARM(2), APARM(6)
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Source
      WRITE (HILINE,2014) TSKNAM, APARM(3), APARM(4), APARM(5)-90.
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       If second component
      IF (BPARM(3) .GT. 0) THEN
         WRITE (HILINE,2013) TSKNAM, BPARM(1), BPARM(2), BPARM(6)
         CALL HIADD (LUN, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       Source
         WRITE (HILINE,2014) TSKNAM, BPARM(3), BPARM(4), BPARM(5)-90.
         CALL HIADD (LUN, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       If third component
      IF (CPARM(3) .GT. 0) THEN
         WRITE (HILINE,2013) TSKNAM, CPARM(1), CPARM(2), CPARM(6)
         CALL HIADD (LUN, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       Source
         WRITE (HILINE,2014) TSKNAM, CPARM(3), CPARM(4), CPARM(5)-90.
         CALL HIADD (LUN, HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       AIPS release
      WRITE (HILINE,2004) TSKNAM, RLSNAM
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any user supplied history.
      IF (NUMHIS.GT.0) THEN
         WRITE (LABEL,1011) TSKNAM
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
         END IF
C                                       Close HI file
 200  CALL HICLOS (LUN, T, BUFFER, IERR)
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, REST, BUFFER,
     *   IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CANHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,'/ Image created by user',I5,' at ',A12,2X,A8)
 1011 FORMAT (A6,'/')
 2000 FORMAT (A6,' Source = ''',A8,'''')
 2001 FORMAT (A6,' Imsize = ',2F8.0)
 2002 FORMAT (A6,' X0, Y0 = ( ',F10.5,',',F10.5,'); Theta  = ',F10.5)
 2003 FORMAT (A6,' B0, S0 = ( ',F10.5,',',F10.5,'); Eccen. = ',F10.5)
 2004 FORMAT (A6,' RELEASE = ''',A7,' ''')
 2013 FORMAT (A6,' XS, YS = ( ',F10.5,',',F10.5,'); Intens = ',F10.5)
 2014 FORMAT (A6,' MAJ,MIN= ( ',F10.5,',',F10.5,'); Theta  = ',F10.5)
      END
      SUBROUTINE NEWHED (AXIS1, AXIS2, UNITS, SOURCE, REFVAL, XMSIZE,
     *   CELLS, IRET)
C-----------------------------------------------------------------------
C   NEWHED is a routine in which the user performs several operations
C   associated with beginning the task.  For many purposes simply
C   changing some of the values in the DATA statments will be all that
C   is necessary.  The following functions are/can be preformed
C   in NEWHED:
C       1) Creating the catalog header block to represent the
C   output file.  The MINIMUM information required here is that
C   required to define the size of the output file; ie.
C      CATBLK(KIDIM)= the number of axes,
C      CATBLK(KINAX+i) = the dimension of each axis, and
C      CATBLK(KIBPX) => 2 = real*4 pixel values.
C   Other changes can be made either here or in MAKMAP; the
C   catalog block will be updated when the history file is
C   written.
C    Input:
C     AXIS1     C*8     Units of first axis
C     AXIS2     C*8     Units of second axis
C     UNITS     C*8     Character string describing the map untis
C     SOURCE    C*8     Eight character Source Name
C     REFVAL    D*2     Reference Value in Degrees
C     XMSIZE    R*2     Map size in pixels
C     CELLS     R*2     Pixel size in Degrees
C    Input via Common:
C     CATBLK    I(256)  Output catalog header, also CATR, CATD
C                       The OUTNAME, OUTCLASS, OUTSEQ are entered
C                       elsewhere.
C    Output:
C     CATBLK    I(256)  Modified output catalog header.
C     IRET      I       Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER AXIS1*8, AXIS2*8, UNITS*8, SOURCE*8
      INTEGER   IRET
      REAL XMSIZE(2), CELLS(2)
      DOUBLE PRECISION REFVAL(2)
C
      CHARACTER BLANK*8, ATYPES(7)*8
      INTEGER   I, NAXIS, IROUND, NCODE, INDEX
C      INCLUDE 'GLENS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA  BLANK /'        '/
C                                       User definable values
      DATA NCODE /0/
C                                       NUMBER OF AXES AND TYPES.
C                                       (SET FOR TWO AXES = RA, DEC.)
      DATA NAXIS  /2/
      DATA ATYPES /'RA---SIN', 'DEC--SIN',
     *   'STOKES  ', 'FREQ    ', 3*'       '/
C-----------------------------------------------------------------------
C                                       set Axis Values
      ATYPES(1) = AXIS1
      ATYPES(2) = AXIS2
C                                       SET OUTPUT UNITS.
      CALL CHR2H (8, UNITS, 1, CATH(KHBUN))
C                                       FILL AXIS ARRAYS.
      DO 30 I = 1,KICTPN
C                                       INIT DIMENSION
         CATBLK(KINAX+I-1) = 1
C                                       INIT. INCREMENT.
         CATR(KRCIC+I-1) = 0.0
C                                       INIT. REF PIXEL.
         CATR(KRCRP+I-1) = 1.0
C                                       INIT. REF VALUE.
         CATD(KDCRV+I-1) = 0.0
C                                       FILL AXIS TYPE FROM
C                                       ATYPES OR BLANK.
         INDEX = KHCTP + (I-1) * 2
         CALL CHR2H (8, BLANK, 1, CATH(INDEX))
         IF (I.LE.NAXIS)
     *      CALL CHR2H (8, ATYPES(I), 1, CATH(INDEX))
C                                       blank random axies.
         INDEX = KHPTP + (I-1) * 2
         CALL CHR2H (8, BLANK, 1, CATH(INDEX))
 30      CONTINUE
C                                       init. ref value.
      CATD(KDCRV)   = REFVAL(1)
      CATD(KDCRV+1) = REFVAL(2)
C                                       init map size
      CATBLK(KINAX)   = MAX( IROUND( XMSIZE(1)), 1)
      CATBLK(KINAX+1) = MAX( IROUND( XMSIZE(2)), 1)
C                                       reinit ref pixel
      CATR(KRCRP)   = CATBLK(KINAX)  /2.
      CATR(KRCRP+1) = CATBLK(KINAX+1)/2.
C                                       Assume CELLSIZE in degrees.
C                                       NOTE: Ra decreases with
C                                       grid number.
      CATR(KRCIC) = - CELLS(1)
      CATR(KRCIC+1) = CELLS(2)
C                                       Fill other character strings.
C                                       Object.
      CALL CHR2H (8, SOURCE, 1, CATH(KHOBJ))
C                                       Observation date.
      CALL CHR2H (8, BLANK, 1, CATH(KHDOB))
C                                       Telescope.
      CALL CHR2H (8, BLANK, 1, CATH(KHTEL))
C                                       Receiver
      CALL CHR2H (8, BLANK, 1, CATH(KHINS))
C                                       Observer's name.
      CALL CHR2H (8, BLANK, 1, CATH(KHOBS))
C                                       Set number of axes.
      CATBLK(KIDIM) = NAXIS
      CATBLK(KIPCN) = 0
C                                       User ID
      CATBLK(KIIMU) = NLUSER
C                                       Miscellaneous items.
C                                       Epoch.
      CATR(KREPO) = 0.0
C                                       Convolving beam
      CATR(KRBMJ) = 0.0
      CATR(KRBMN) = 0.0
      CATR(KRBPA) = 0.0
C                                       Max. min.
      CATR(KRDMX) = 0.0
      CATR(KRDMN) = 0.0
C                                       Put other checks here.
C                                       Finished.
      IRET = 0
C
 999  RETURN
      END
      SUBROUTINE MAKMAP (IPOS, RESULT, IRET)
C-----------------------------------------------------------------------
C  Returns Lens Model image.
C  Inputs:
C   IPOS(7)   I    BLC (input image) of first value in DATA
C  Values from commons:
C   ICODE     I    Opcode number from list in NEWHED.
C   FBLANK    R    Value of blanked pixel.
C   CPARM(10) R    Input adverb array.
C   DPARM(10) R    Input adverb array.
C   CATBLK    I    Output catalog header (also CATR, CATD)
C  Output:
C   RESULT(*) R    Output row.
C   IRET      I    Return code   0 => OK
C                               >0 => error, terminate.
C
C  Output in COMMON
C  NUMHIS     I    # history entries (max. 10)
C  HISCRD(16,NUMHIS) R   History records
C  CATBLK     I    Catalog header block
C
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), IRET
      REAL      RESULT(*)
C
      INCLUDE 'GLENS.INC'
      REAL      IMAGES(MAXMAP,MAXMAP),QUASAR(MAXMAP,MAXMAP)
      INCLUDE 'EPSLN.INC'
      INTEGER   BLAND, POINT, NARAYA, KING, DEVAUC
      PARAMETER (BLAND=1, POINT=2, NARAYA=3, KING=4, DEVAUC=5)
      INTEGER   NX, NY, I, J, SRCPLN, LTYPE, NXO2, NYO2,
     *   CNTMSG, IXS, IYS, X, Y
      REAL   TH0, X0, Y0, S0, EP0, B0, B2, XI, YI, XS, YS,
     *   S2, MAGI, MAGS, DR2, COSTH, SINTH, XPRM, YPRM, DX, DY
      REAL   X2SRC, Y2SRC, MAJB, MINB, RMAJB, RMINB, INTSB, INTSB2,
     *       X3SRC, Y3SRC, MAJC, MINC, RMAJC, RMINC, INTSC, INTSC2,
     *       X1SRC, Y1SRC, MAJA, MINA, RMAJA, RMINA, INTSA, INTSA2,
     *       COS1TH, SIN1TH, COS2TH, SIN2TH, COS3TH, SIN3TH
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      SAVE IMAGES, QUASAR
      DATA CNTMSG/0/
C-----------------------------------------------------------------------
      IRET = 0
C                                       Check if last call
      IF (IPOS(1).LT.0) GO TO 999
C                                       fill array on first execution
      IF (IPOS(2) .LE. 1) THEN
         SRCPLN   = DPARM(10)
C                                       Get image size
         NX = CATBLK(KINAX)
         NY = CATBLK(KINAX+1)
C                                       If making both Source and Image
         IF (SRCPLN.EQ.0) NX = NX / 2.
C                                       IF zero, make an intersting lens
         IF (DPARM(1).EQ.0 .AND. DPARM(2).EQ.0 .AND.
     *       DPARM(4).EQ.0 .AND. DPARM(5).EQ.0 ) THEN
C                                       Lens in middle
            DPARM(1) = NX/2
            DPARM(2) = NY/2
C                                       orientation=30 deg. and radius
            DPARM(3) = 30.
            DPARM(4) = MAX(10., NX/5.)
C                                       make it slightly eccentric
            DPARM(5) = .1
C                                       add source
            DPARM(9) = 1
            END IF
C                                       get lens coordinate
         X0       = DPARM(1)
         Y0       = DPARM(2)
C                                       lens must not be on edge
         IF (X0.LT.1 .OR. X0 .GE. NX) X0 = NX/2
         IF (Y0.LT.1 .OR. Y0 .GE. NY) Y0 = NY/2
         DPARM(1) = X0
         DPARM(2) = Y0
C                                       Rotation
         TH0      = DPARM(3)
         COSTH    = COS(TH0*0.01745)
         SINTH    = SIN(TH0*0.01745)
C                                       Einstein ring size (pixels)
         B0       = DPARM(4)
         B2       = B0*B0
         EP0      = DPARM(5)
         S0       = DPARM(6)
C                                       lens type
         LTYPE    = DPARM(8)
C                                       Limit lens models
         LTYPE    = MAX ( BLAND, MIN(LTYPE, POINT))
C                                       core radius nonzero for devauc
         IF (LTYPE.EQ.DEVAUC .AND. S0 .LE. 0.) S0 = 1.
         S2       = S0*S0
C                                       read in source location
         X1SRC    = APARM(1)
         Y1SRC    = APARM(2)
C                                       if out of range put in center
         IF (X1SRC.LT.1 .OR. X1SRC .GE. NX) X1SRC = NX/2
         IF (Y1SRC.LT.1 .OR. Y1SRC .GE. NY) Y1SRC = NY/2
         APARM(1) = X1SRC
         APARM(2) = Y1SRC
C                                       major and minor axies
         MAJA = ABS(APARM(3))
         MINA = ABS(APARM(4))
C                                       Always have an A component
         IF (MAJA.LE.0) THEN
C                                       Make an interesting default
            MAJA = MAX(3,NX/40)
            Y1SRC = Y1SRC + (2.*MAJA)
            APARM(6) = 10
            END IF
C                                       If an A component
         IF (MINA .LE. 0.  .OR. MINA .GT. NX/2) MINA = MAJA
         IF (MAJA .GT. 0. .AND. MAJA .LT. NX/2) THEN
C                                       calc useful axis parameters
            RMAJA = 1./(MAJA*MAJA)
            RMINA = 1./(MINA*MINA)
C                                       first component orientation
C                                       orient to Clockwise from N
            APARM(5) = APARM(5) + 90.
            COS1TH = COS(APARM(5)*0.01745)
            SIN1TH = SIN(APARM(5)*0.01745)
            INTSA  = APARM(6)
            INTSA2 = APARM(7)
         ELSE
C                                       else no source component
            MAJA = 0
            END IF
C                                       reset for history file
         APARM(3) = MAJA
         APARM(4) = MINA
C                                       second source comp.
         X2SRC = BPARM(1)
         Y2SRC = BPARM(2)
C                                       major axis radius
         MAJB = ABS(BPARM(3))
         MINB = ABS(BPARM(4))
         IF (MINB .LE. 0. .OR. MINB .GE. NX/2) MINB = MAJB
C                                       if out of range, skip
         IF (MAJB .GT. 0. .AND. MAJB .LT. NX/2) THEN
            RMAJB = 1./(BPARM(3)*BPARM(3))
            RMINB = 1./(BPARM(4)*BPARM(4))
C                                       orient to Clockwise from N
            BPARM(5) = BPARM(5) + 90.
            COS2TH = COS(BPARM(5)*0.01745)
            SIN2TH = SIN(BPARM(5)*0.01745)
            INTSB  = BPARM(6)
            INTSB2 = BPARM(7)
         ELSE
C                                       else no second component
            MAJB = 0
            END IF
         BPARM(3) = MAJB
         BPARM(4) = MINB
C                                       third source comp.
         X3SRC = CPARM(1)
         Y3SRC = CPARM(2)
C                                       major axis radius
         MAJC = CPARM(3)
         MINC = CPARM(4)
         IF (MINC .LE. 0 .OR. MINC .GE. NX/2) MINC = MAJC
C                                       if out of range, skip
         IF (MAJC .GT. 0 .AND. MAJC .LT. NX/2) THEN
            RMAJC = 1./(CPARM(3)*CPARM(3))
            RMINC = 1./(CPARM(4)*CPARM(4))
C                                       orient to Clockwise from N
            CPARM(5) = CPARM(5) + 90.
            COS3TH = COS(CPARM(5)*0.01745)
            SIN3TH = SIN(CPARM(5)*0.01745)
            INTSC  = CPARM(6)
            INTSC2 = CPARM(7)
         ELSE
C                                       else no third component
            MAJC = 0
            END IF
         CPARM(3) = MAJC
         CPARM(4) = MINC
C                                       init image and source plane
         CALL INITAR ( NX, NY, QUASAR, IMAGES)
         NXO2 = NX/2
         NYO2 = NY/2
C                                       for all rows,  calculate
         DO 40 J = -NYO2,NY+NYO2
C                                       translate to galaxy centered
C                                       location in image plane
            YI = J - Y0
C                                       for all columns
            DO 30 I = -NXO2,NX+NXO2
C                                       translate to galaxy centered
C                                       location in image plane
               XI = I - X0
C                                       Determine Lens model
C                                       Point Mass model ?
               IF (LTYPE .EQ. POINT) THEN
C                                       Calculate magnification
                  CALL POINTL(XI, YI, B2, XS, YS, MAGI)
               ELSE
C                                       Else not spherically symetric
C                                       rotate to coords of galaxy
                  XPRM = (XI*COSTH) - (YI*SINTH)
                  YPRM = (XI*SINTH) + (YI*COSTH)
C                                       Blandford model ?
C                                       Calc jacobian of Bland Lens
                  IF (LTYPE .EQ. BLAND) THEN
                     CALL BLANDL (XPRM, YPRM, B0, EP0, S2,
     *                  XS, YS, MAGI)
C                                       Else, Devaucaleurs lens
C                                       de Vaucouleurs model
                  ELSE
                     CALL DEVLEN (XPRM, YPRM, B0, S0, XS, YS, MAGI)
                     END IF
C                                       rotate source pos back
                  XPRM =  (XS*COSTH) + (YS*SINTH)
                  YS   = (-XS*SINTH) + (YS*COSTH)
                  XS   = XPRM
C                                       end if point lens
                  END IF
C                                       absolute value of mag.
               IF (DPARM(7).LE.0.) MAGI = ABS(MAGI)
C                                       keep magnification
               MAGS = MAGI
C                                       translate to map coords
C                                       in source plane
               XS = XS + X0
               YS = YS + Y0
C                                       If mapping source plane mag.
               IF (SRCPLN.GE.0) THEN
C                                       convert to coord to integer
                  IXS = XS
                  IYS = YS
C                                       limit to valid coords
                  IF (IXS.GT.1 .AND. IXS.LE.NX-1 .AND.
     *                IYS.GT.1 .AND. IYS.LE.NY-1) THEN
C                                       for a few pixels around
                     DO 100 X = IXS-1, IXS+1
                        DO 99 Y = IYS-1, IYS+1
C                                       keep smallest abs magnitude
                           IF (ABS(MAGS) .LT. ABS(QUASAR(X,Y)))
     *                        QUASAR(X,Y) = MAGS
C                                       end for all near pixels
 99                        CONTINUE
 100                    CONTINUE
C                                       end if coord in valid range
                     END IF
C                                       end if mapping source plane
                  END IF
C                                       if image plane map
               IF (I.GT.0 .AND. I.LE.NX .AND.
     *             J.GT.0 .AND. J.LE.NY .AND. SRCPLN .LE. 0) THEN
C                                       if mapping all magnification
                  IF (DPARM(9) .LT. 0. .OR. DPARM(9) .GT. 10.0) THEN
C                                       if greater magification
                     IF (ABS(MAGS) .LT. ABS(IMAGES(I,J)) .OR.
     *                   0.0       .EQ.     IMAGES(I,J) ) THEN
C                                       if not infinite magnifcation
                        IF (ABS(MAGS).LT. MAXMAG) MAGS = MAXMAG
                        IMAGES(I,J)  = 1.0/MAGS
                        END IF
                     END IF
C                                       add sources
C                                       if first component valid
                  IF (MAJA .GT. 0) THEN
                     DX = XS - X1SRC
                     DY = YS - Y1SRC
C                                       distance from source
                     CALL INELPS(DX,DY,RMAJA,RMINA,COS1TH,SIN1TH,DR2)
C                                       if in source, add flux to image
                     IF (DR2 .LE. 1.) THEN
                        IMAGES(I,J) = INTSA+(INTSA2*EXP(-3.*DR2))
                        END IF
C                                       end if first component
                     END IF
C                                       second source if valid
                  IF (MAJB .GT. 0) THEN
                     DX = XS - X2SRC
                     DY = YS - Y2SRC
C                                       distance from source
                     CALL INELPS(DX,DY,RMAJB,RMINB,COS2TH,SIN2TH,DR2)
C                                       if in source, add flux to image
                     IF (DR2 .LE. 1.) THEN
                        IMAGES(I,J) = INTSB+(INTSB2*EXP(-3.*DR2))
                        END IF
C                                       end if second source
                     END IF
C                                       third source if valid
                  IF (MAJC .GT. 0) THEN
                     DX = XS - X3SRC
                     DY = YS - Y3SRC
C                                       distance from source
                     CALL INELPS(DX,DY,RMAJC,RMINC,COS3TH,SIN3TH,DR2)
C                                       if in source, add flux to image
                     IF (DR2 .LE. 1.) THEN
                        IMAGES(I,J) = INTSC+(INTSC2*EXP(-3.*DR2))
                        END IF
C                                       end if third component
                     END IF
C                                       end if mapping source or image
                  END IF
C                                       end for all rows loop
 30            CONTINUE
 40         CONTINUE
C                                       Fix initalization
         CALL REIARS( NX, NY, QUASAR)
C                                       insert source if requested
         IF (DPARM(9).GT. 0) THEN
C                                       add each of the 3 components
            CALL ADDSRC ( NX, NY, APARM, QUASAR, IMAGES)
            CALL ADDSRC ( NX, NY, BPARM, QUASAR, IMAGES)
            CALL ADDSRC ( NX, NY, CPARM, QUASAR, IMAGES)
            MSGTXT = 'Adding Un-lensed source to map(s)'
            CALL MSGWRT(2)
            END IF
C                                       End if First execution
         END IF
C                                       Subsequent calls.
C                                       Read a row from stored arrays
      J = MIN( MAX( 1, IPOS(2)), MAXMAP)
C                                       get length of row to transfer
      NX = CATBLK(KINAX)
C                                       if outputing only source
      IF (SRCPLN .LT. 0) THEN
C                                       transfer a row
         DO 300 I = 1, NX
            RESULT(I) = IMAGES(I,J)
 300        CONTINUE
      ELSE
         IF (SRCPLN .GT. 0) THEN
C                                       transfer a row
            DO 400 I = 1, NX
               RESULT(I) = QUASAR(I,J)
 400           CONTINUE
         ELSE
C                                       Only half NX is filled
            NXO2 = MIN( MAX( 1, NX/2), MAXMAP)
C                                       output both source and image
            DO 500 I = 1, NXO2
               RESULT(I) = QUASAR(I,J)
               RESULT(NXO2 + I) = IMAGES(I,J)
               IF (RESULT(I) .GT. 1.E6 .AND. CNTMSG.LT.10) THEN
                  WRITE(MSGTXT,1000) 'SOURCE',I,J,QUASAR(I,J)
                  CALL MSGWRT(4)
                  CNTMSG = CNTMSG + 1
                  END IF
               IF (RESULT(NXO2 + I) .GT. 1.E6 .AND. CNTMSG.LT.10) THEN
                  WRITE(MSGTXT,1000) 'IMAGE ',I,J,IMAGES(I,J)
                  CALL MSGWRT(4)
                  CNTMSG = CNTMSG + 1
                  END IF
 500        CONTINUE
         END IF
      END IF
C                                       Finished
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT('ERROR IN ',A,' ARRAY(',I4,',',I4,')=',1PE12.3)
      END
      SUBROUTINE ADDSRC (NX, NY, ZPARM, QUASAR, IMAGES)
C-----------------------------------------------------------------------
C   Initializes the SOURCE and IMAGE ARRAYS
C   Input:
C    NX,NY    I   array sizes
C    ZPARM    R   position of source
C   Output
C    QUASAR and IMAGES
C             R   Source Plane and Image plane Jacobian arrays.
C-----------------------------------------------------------------------
      INTEGER   NX, NY
      REAL      ZPARM(10)
      INCLUDE 'GLENS.INC'
      REAL      IMAGES(MAXMAP,MAXMAP), QUASAR(MAXMAP,MAXMAP)
      INTEGER   I,J
      REAL      XSRC, YSRC, MAJ, MIN, TH, INTS, INTS2
      REAL      DR2, DX, DY, COSTH, SINTH, RMAJ2, RMIN2
C-----------------------------------------------------------------------
C                                       get source parameters, X,Y
      XSRC  = ZPARM(1)
      YSRC  = ZPARM(2)
C                                       size and angle
      MAJ   = ZPARM(3)
      MIN   = ZPARM(4)
      TH    = ZPARM(5)
C                                       two component source intensity
      INTS  = ZPARM(6)
      INTS2 = ZPARM(7)
C                                       if too big, skip
      IF (MAJ .LE. 0 .OR. MAJ .GE. NX/2) GO TO 999
      IF (MIN .LE. 0 .OR. MIN .GE. NX/2) MIN = MAJ
C                                       reciprocal axis squared
      RMAJ2 = 1./(MAJ*MAJ)
      RMIN2 = 1./(MIN*MIN)
C                                       convert to radians
      COSTH = COS(TH*0.01745)
      SINTH = SIN(TH*0.01745)
C                                       for all rows
      DO 44 J = 1,NY
         DY  = J-YSRC
C                                       for all columns
         DO 43 I = 1,NX
            DX  = I-XSRC
            CALL INELPS(DX,DY,RMAJ2,RMIN2,COSTH,SINTH,DR2)
C                                       if within source
            IF (DR2 .LE. 1.0) THEN
C                                       mark source with flux
               IMAGES(I,J) = INTS+((1.-DR2)*INTS2)
               QUASAR(I,J) = INTS+((1.-DR2)*INTS2)
               END IF
  43        CONTINUE
  44  CONTINUE
 999  RETURN
C-----------------------------------------------------------------------
      END
      SUBROUTINE INELPS( DX, DY, RMAJ2, RMIN2, COSTH, SINTH, DR2)
C-----------------------------------------------------------------------
C  Determine squared distance DR2 from delta position DX, DY
C  for an ellipse with major and minor axies and a rotation.
C  Input
C   DX,DY         R   Delta: Coord - Center of ellipse
C   RMAJ2, RMIN2  R   reciprocal squared major and minor axies
C   COSTH, SINTH  R   Cos and Sin of ellipse rotation angle
C Output
C   DR2           R   distance from ellipse center, > 1 means outside
C
C  A point is inside an ellipse, when
C           2         2
C     (DX/A)  + (DY/B)   < 1.
C-----------------------------------------------------------------------
      REAL   DX,DY, RMAJ2, RMIN2, COSTH, SINTH
      REAL   DR2, DXPRM, DYPRM
C-----------------------------------------------------------------------
C                                            rotate x coord
      DXPRM = (DX*COSTH) - (DY*SINTH)
      DR2 = DXPRM*DXPRM*RMAJ2
C                                            if already outside, skip
      IF (DR2 .LE. 1.) THEN
C                                            rotate y coord
         DYPRM = (DX*SINTH) + (DY*COSTH)
C                                            calc distance squared
         DR2 = DR2 + (DYPRM*DYPRM*RMIN2)
         END IF
      RETURN
C-----------------------------------------------------------------------
      END
      SUBROUTINE INITAR (NX,NY,QUASAR,IMAGES)
C-----------------------------------------------------------------------
C   Initializes the SOURCE and IMAGE ARRAYS
C   Input:
C    NX,NY    I   array sizes
C   Output
C    QUASAR and IMAGES
C             R   Source Plane and Image plane Jacobian arrays.
C-----------------------------------------------------------------------
      INTEGER   NX, NY
      INTEGER   I,J
      INCLUDE 'GLENS.INC'
      REAL   IMAGES(MAXMAP,MAXMAP),QUASAR(MAXMAP,MAXMAP)
C-----------------------------------------------------------------------
C                                            for all rows
      DO 4 J = 1,NY
C                                            for all columns
         DO 3 I = 1,NX
C                                            initialize
            QUASAR(I,J) = 100.
            IMAGES(I,J) = 0.
  3      CONTINUE
  4   CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE REIARS (NX,NY,QUASAR)
C-----------------------------------------------------------------------
C   REInitializes the SOURCE AR, Replaceing large value with 0.
C   Input:
C    NX,NY    I   array sizes.
C   Output
C    QUASAR   R   Source Plane array.
C-----------------------------------------------------------------------
      INTEGER   NX, NY
      INTEGER   I,J
      INCLUDE 'GLENS.INC'
      INCLUDE 'EPSLN.INC'
      REAL   QUASAR(MAXMAP,MAXMAP)
C-----------------------------------------------------------------------
C                                       for all columns
      DO 4 J = 1,NY
C                                       for all rows
         DO 3 I = 1,NX
C                                       if source array not set
            IF (QUASAR(I,J) .EQ. 100.) THEN
C                                       reset to no magnification
               QUASAR(I,J) = 0.
            ELSE
C                                       else if mag. not infinite
               IF (ABS(QUASAR(I,J)) .GT. MAXMAG) THEN
C                                       calc mag from inverse mag
                  QUASAR(I,J) = 1.0/QUASAR(I,J)
               ELSE
C                                       else limit magnification
                  QUASAR(I,J) = 1.0/MAXMAG
                  END IF
C                                       end if mag set
               END IF
C                                       end for all rows
  3      CONTINUE
  4   CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE BLANDL (XI, YI, B0, EP0, S2, XS, YS, MAG)
C-----------------------------------------------------------------------
C   Calculates the jacobian of the Kochanek, Blandford galaxy model.
C   Graitational lens magnification.
C   Input:
C    XI,YI    R   coordinate of Image point for calculation
C    B0       R   Einstein Ring size in pixels
C    EP0      R   projected eccentricity of the galaxy
C    S2       R   core size parameter SQUARED
C Output
C    XS,YS    R   coordinates of source plane
C    Mag      R   Reciprocal Magnifation of flux falling at location X,Y
C-----------------------------------------------------------------------
      REAL      XI, YI, B0, EP0, S2, MAG, XS, YS
      REAL      X2, Y2, X2A
      REAL      PHI, PHI2, B0PHI, B0PHI3
      INCLUDE 'EPSLN.INC'
C --------------------------------------------------------------
      Y2 = YI*YI
      X2 = XI*XI
C                                        Do not allow x=y=0
      X2A = X2
      IF (X2+Y2 .EQ. 0.0) X2A = 1.0
C                                        Calculate the radius
      PHI2 = S2 + ((1.-EP0)*X2A) + ((1.+EP0)*Y2)
C                                        Avoid div 0
      IF (PHI2.GE.EPSLN2) THEN
         PHI = SQRT(PHI2)
      ELSE
         PHI = EPSLN
      END IF
C                                        Usefull powers of PHI
      B0PHI  = B0/PHI
      B0PHI3 = B0PHI/(PHI*PHI)
C                                        Spherical Approx
      MAG = 1. - B0PHI
C                                        independent of S0
      MAG = MAG + (B0PHI3*EP0 *( (Y2-X2A)+(EP0*(X2A+Y2)) ))
C                                        dependent on S2
      MAG = MAG - (B0PHI3*S2 *( 1.-(B0PHI*(1.-(EP0*EP0))) ))
C                                            determin source location
      XS = XI - (XI*B0PHI*(1.-EP0))
      YS = YI - (YI*B0PHI*(1.+EP0))
999   RETURN
      END
      SUBROUTINE DEVLEN (XI, YI, B0, S0, XS, YS, MAG)
C-----------------------------------------------------------------------
C   Calculates the magnification of a de Vauccouleurs galaxy model.
C   Graitational lens magnification.
C   Input:
C    XI,YI    R   coordinate of image point for calculation
C    B0       R   galaxy mass in pixels
C    S0       R   core size parameter
C Output
C    XS,YS    R   coordinates of source
C    Mag      R   Magnifation of flux falling at location X,Y
C-----------------------------------------------------------------------
      REAL      XI, YI, B0, S0, MAG, XS, YS
      REAL      X2, Y2, X2A, R, R2, R4
      REAL      ETA, MASS
      INCLUDE 'EPSLN.INC'
C --------------------------------------------------------------
      Y2 = YI*YI
      X2 = XI*XI
C                                        Do not allow x=y=0
      X2A = X2
      IF (X2+Y2 .EQ. 0.0) X2A = 1.0
C                                        Calculate the radius
      R2 = X2A + Y2
C                                        Avoid div 0
      IF (R2.GE.EPSLN2) THEN
         R = SQRT(R2)
      ELSE
         R = EPSLN
      END IF
C                                        Usefull powers of R
      R2 = R*R
      R4 = R2*R2
      ETA = SQRT(SQRT(R/S0))
C234567                                  Spherical Approx
       MASS = B0*B0*(1. - EXP(-ETA)*
     *             (1. + ETA*(1. + 0.5*ETA*
     *               (1. + 0.333333*ETA*
     *                 (1. + 0.25*ETA*
     *                   (1. + 0.2*ETA*
     *                     (1. + 0.1666666*ETA*(1. + 0.1428*ETA)
     *           ) ) ) ) ) )  )
C                                        Spherical Approx
      MAG = (R4 - (MASS*MASS))/R4
C                                            determin source location
      XS = XI - (XI*MASS/R2)
      YS = YI - (YI*MASS/R2)
999   RETURN
      END
      SUBROUTINE POINTL (XI, YI, B2, XS, YS, MAG)
C-----------------------------------------------------------------------
C   Calculates the jacobian of the point mass lens model.
C   Graitational lens magnification.
C   Input:
C    XI,YI    R   coordinate of point in IMAGE plane for calculation
C                 Coordinate system is centered on the lens
C    B2       R   Einstein Ring size squared in pixels
C Output
C    XS,YS    R   coordinate of point in SOURCE Plane
C    Mag      R   Reciprocal Magnifation of flux at location X,Y
C For the sphically symetric point lens, all images are deflected
C radially.  The source X and Y location are calculated from the
C ratio of radial positions.  RS/RI = (RI2 - B2)/RI2
C-----------------------------------------------------------------------
      REAL      XI, YI, B2, XS, YS, MAG
      REAL      X2, Y2, RI2, RI4, X2A, RATIO
      INCLUDE 'EPSLN.INC'
C --------------------------------------------------------------
      X2 = XI*XI
      Y2 = YI*YI
C                                        Do not allow x=y=0
      X2A = X2
      IF (X2 .EQ. 0.0 .AND. Y2 .EQ. 0.0) X2A = 1.0
C                                        Calculate the radius
      RI2 = X2A + Y2
C                                        Guard against div 0
      IF (RI2.LT.EPSLN2) RI2 = EPSLN2
      RI4 = RI2*RI2
C                                        Source plane positions
C Delta Theta = b2/r;  cos phi = x/r;  delta X = Delta Theta * Cos phi
C
      RATIO = (RI2 - B2) / RI2
      XS  = XI * RATIO
      YS  = YI * RATIO
C                                        The inverse magnifcation is
C                                        calculated from image radius
      MAG = (RI4 - (B2*B2))/RI4
      RETURN
      END
      SUBROUTINE NARAYN (XI, YI, B0, RCORE3, XS, YS, MAG)
C-----------------------------------------------------------------------
C   Calculates the jacobian of the narayan elliptical lens model.
C   Graitational lens magnification.
C   Input:
C    XI,YI    R   coordinate of image point for calculation
C    B0       R   Einstein Ring size squared in pixels
C Output
C    Mag      R   Magnifation of flux falling at location X,Y
C-----------------------------------------------------------------------
      REAL      XI, YI, B0, XS, YS, MAG, RCORE3
      REAL      X2, Y2, R, R2, X2A, RCORE, RADLF
      INCLUDE 'EPSLN.INC'
C --------------------------------------------------------------
      X2 = XI*XI
      Y2 = YI*YI
C                                        Do not allow x=y=0
      X2A = X2
      IF (X2 .EQ. 0.0 .AND. Y2 .EQ. 0.0) X2A = 1.0
C                                        Calculate the radius
      R2 = X2A + Y2
      R = 0.
      IF (R2.GE.0.) R = SQRT(R2)
C                                        Guard against div 0
      IF (R.LT.EPSLN) R = EPSLN
      R2 = R*R
      RCORE = B0
C
      RCORE = B0
C                                        outside core Radius ?
      IF (R .GT. RCORE) THEN
C                                        Spherical Approx
         RADLF = (-1.0/R) + (0.375*B0/R2)
      ELSE
         RADLF = (-.75/RCORE) + (0.125*R2/RCORE3)
      END IF
      MAG = RADLF * B0
C                                            determin source location
      XS = XI - (XI*MAG)
      YS = YI - (YI*MAG)
999   RETURN
      END

      SUBROUTINE QINIT (I1, I2, I3)
C-----------------------------------------------------------------------
C! FPS AP version: Initialize AP, waits for higher priority tasks.
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FPS AP version
C   APINIT with a delay for all jobs other than NPOPS = 1
C   if there are any AP tasks of lower NPOPS value currently running.
C   Inputs:
C      I1   I   Dummy
C      I2   I   Dummy
C   Output:
C      I3   I   AP assigned. (Positive indicates a real AP, i.e. to be
C               rolled)
C   Output to common /BPROLC/
C           TRUEAP   L  True if a real AP (to be rolled)
C           XTLAST   R  Real time AP assigned (min).
C           DELTIM   R  Time interval between rolls (min).
C           DELAY    R  Time to delay task (seconds).
C-----------------------------------------------------------------------
      INTEGER   I1, I2, I3
C
      INTEGER*2 J1, J2, J3
      INTEGER   ICOUNT, IERR, LP, I, J, MCNT(15), MAXCNT, ITIME(3),
     *   PID(4), II, JJ3
      CHARACTER ANAME*6
      LOGICAL  ACTIVE
      INCLUDE 'INCS:DAPT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DBPR.INC'
      INCLUDE 'INCS:VAPT.INC'
C-----------------------------------------------------------------------
C                                       release AP just in case we own
      CALL APRLSE
C                                       true AP no 2nd memory
      KAP2WD = 0
C                                       delay for FPS init cycle time
      DELAY = 1.05
      CALL ZDELAY (DELAY, IERR)
C                                       check priority
      DELAY = 10.0
      LP = NPOPS - 1
C                                       Check for higher priority jobs
      IF (LP.LE.0) GO TO 50
         IF (TIMEAP(2).LE.1.) TIMEAP(2) = 1.0
         IF (TIMEAP(3).LT.0.0) TIMEAP(3) = 0.0
         DO 10 II = 1,LP
            I = NPOPS - II
            MCNT(II) = 6. * (TIMEAP(2)*I + TIMEAP(3)*(I*I - 1)) + 0.1
            IF (II.EQ.NINTRN+1) MCNT(II) = 0
 10         CONTINUE
         MAXCNT = MCNT(1)
         DO 30 ICOUNT = 1,MAXCNT
            DO 20 I = 1,LP
               IF (MCNT(I).LE.0) GO TO 20
                  DO 15 J = 1,NAPNAM
                     CALL BLDTNM (APTASK(J), I, ANAME, IERR)
                     CALL FILL (4, 0, PID)
                     CALL ZTACTQ (ANAME, PID, ACTIVE, IERR)
                     IF (ACTIVE) GO TO 25
 15                  CONTINUE
 20            CONTINUE
C                                       none: go do it
            GO TO 50
C                                       delay and try again
 25         CALL ZDELAY (DELAY, IERR)
            DO 30 I = 1,LP
               MCNT(I) = MCNT(I) - 1
 30            CONTINUE
 35         CONTINUE
C                                       Ask system for device
 50   J1 = 0
      J2 = 0
      CALL APINIT (J1, J2, J3)
      JJ3 = J3
C                                       Check for multiple AP request.
      IF (JJ3.EQ.-3) GO TO 60
      IF (JJ3.LT.0) GO TO 50
C                                       Got it apparently
 60   I3 = ABS (JJ3)
      IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   CALL ZPRIO ('UPPP',IERR)
C                                       Fill values into /BPROLC/
      TRUEAP = .TRUE.
C                                       Delay time = 10*NPOPS sec.
      DELAY = 2.0 * NPOPS + 8.0
C                                       Time between rolls = 5 min.
      DELTIM = TIMEAP(1)
      IF (DELTIM.LT.1.0) DELTIM = 1.0
      IF (DELTIM.GT.60.0) DELTIM = 60.0
C                                       Set time.
      CALL ZTIME (ITIME)
      XTLAST = (ITIME(1)) * 60.0 + ITIME(2) + ITIME(3) / 60.0
C
 999  RETURN
      END

      INTEGER FUNCTION AKOPEN (FIL, BNUM, ATYP, BUFFER)
C-----------------------------------------------------------------------
C! Tim Cornwell I/O routine to open files.
C# IO-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   AKOPEN opens and initializes a scratch file using ZOPEN and MINIT
C   On READing the windows are set so that only the required data is
C   passed. On WRITing, the entire image is windowed.
C   Programmer =  T.J. Cornwell                            December 1987
C-----------------------------------------------------------------------
      CHARACTER ATYP*4
      INTEGER   FIL, BNUM, LUN, IARG, IERR
      REAL      BUFFER(*)
      INTEGER   WINR(4), WINW(4)
      LOGICAL   MAP, EXCL, WAIT
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA MAP, EXCL, WAIT /.TRUE.,.FALSE.,.TRUE./
C-----------------------------------------------------------------------
C                                       Buffer sizes
      BUFSZ(1) = 2 * XBUFSZ
      BUFSZ(2) = 2 * XBUFSZ
      BUFSZ(3) = 2 * XBUFSZ
      BUFSZ(4) = 2 * XBUFSZ
      BUFSZ(5) = 2 * XBUFSZ
      BUFSZ(6) = 2 * XBUFSZ
      ACCTYP(FIL) = ATYP
      BUFNUM(FIL) = BNUM
      IARG = BUFNUM(FIL)
      LUN = BUFNUM(FIL) + 15
      AKOPEN = 0
      CALL ZOPEN (LUN, FIND(IARG), VMVOL(FIL), VMFILE(FIL), MAP,
     *   EXCL, WAIT, IERR)
      IF (IERR.EQ.0) GO TO 100
         WRITE (MSGTXT,1000) IERR,FIL
         CALL MSGWRT (8)
         AKOPEN = IERR
         GO TO 999
 100  IF (ACCTYP(FIL).NE.'READ') GO TO 110
C                                       Reading whole image file
         IF ((VMSZ(1,FIL).EQ.NX).AND.(VMSZ(2,FIL).EQ.NY)) THEN
            WINR(1) = BLC(1)
            WINR(2) = BLC(2)
            WINR(3) = TRC(1)
            WINR(4) = TRC(2)
C                                       Reading half image file
         ELSE IF ((VMSZ(1,FIL).EQ.HNX).AND.(VMSZ(2,FIL).EQ.HNY)) THEN
            WINR(1) = XBEG
            WINR(2) = YBEG
            WINR(3) = XEND
            WINR(4) = YEND
C                                       Reading FT image file
         ELSE IF ((VMSZ(1,FIL).EQ.2*NY).AND.
     1            (VMSZ(2,FIL).EQ.NX/2+1)) THEN
            WINR(1) = 1
            WINR(2) = 1
            WINR(3) = VMSZ(1,FIL)
            WINR(4) = VMSZ(2,FIL)
         ELSE
C                                       Unknown image: cannot window
            IERR = 20
            GO TO 130
         END IF
         CALL MINIT ('READ', LUN, FIND(IARG), VMSZ(1,FIL), VMSZ(2,FIL),
     *      WINR, BUFFER, BUFSZ(IARG), VMBO(FIL), IERR)
         GO TO 130
 110  IF (ACCTYP(FIL).NE.'WRIT') GO TO 120
         WINW(1) = 1
         WINW(2) = 1
         WINW(3) = VMSZ(1,FIL)
         WINW(4) = VMSZ(2,FIL)
         CALL MINIT ('WRIT', LUN, FIND(IARG), VMSZ(1,FIL), VMSZ(2,FIL),
     *      WINW, BUFFER, BUFSZ(IARG), VMBO(FIL), IERR)
         GO TO 130
 120  IERR = 10
 130  IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1010) IERR, FIL
         CALL MSGWRT (8)
         AKOPEN = IERR
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR ',I3,' OPENING FILE ',I2,' IN OPEN ROUTINE:')
 1010 FORMAT ('ERROR ',I3,' INITIALIZING FILE ',I2,' IN OPEN ROUTINE:')
      END

      SUBROUTINE OFMGAM (IG, N, OFM, RPOS, GAMMA, BUFFER, IERR)
C-----------------------------------------------------------------------
C! verb to try values of TV gamma correction and store for AIPS Manager
C# TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000, 2009, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   interactive display of various gamma values, allowing saving of a
C   new TV Gamma correction exponent for AIPS Managers
C   Inputs:
C      IG       I        Graphics channel to use
C      N        I        First dimension of oFM
C      OFM      R(N,3)   Initial OFM - does not change here.
C   Output:
C      RPOS     R(2)     Final cursor position
C      GAMMA    R        Final gamma
C      BUFFER   R(*)     Scratch buffer
C      IERR     I        Error code suitable for pOPS
C-----------------------------------------------------------------------
      INTEGER   IG, N, IERR
      REAL      OFM(N,3), RPOS(2), GAMMA, BUFFER(*)
C
      INTEGER   QUAD, ITW(3), IBUT, NEDGE, NPIX, NROW, MAG, IX0, IY0,
     *   POTERR, NLEVS
      REAL      OGAMMA, PPOS(2)
      LOGICAL   F, DOIT
      CHARACTER STRING*20
C
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
C                                        Common TV parms
      QUAD = -1
      GAMMA = 0.0
      POTERR = 49
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      CALL ZTIME (ITW)
      NLEVS = OFMINP + 1
      CALL IMANOT ('INIT', IG, IX0, IY0, 0, 0, STRING(1:6), BUFFER,
     *   IERR)
      IF (IERR.NE.0) GO TO 980
C                                        Instructions
      MSGTXT = 'Cursor Y sets Gamma correction'
      CALL MSGWRT (1)
      MSGTXT = 'Hit button A or B to reset original Gamma and continue'
      CALL MSGWRT (1)
      MSGTXT = 'Hit button C to save Gamma and exit'
      CALL MSGWRT (1)
      MSGTXT = 'Hit button D to just exit'
      CALL MSGWRT (1)
C                                       get old values
      OGAMMA = TVGAMA
C                                       set up graphics display
      NEDGE = (2 * MAXXTV(1)) / 512
      IF (NEDGE.LT.2) NEDGE = 2
      NPIX = 6 * CSIZTV(1) + 2 * NEDGE
      NROW = CSIZTV(2) + 2 * NEDGE
      MAG = 1 + TVZOOM(1)
      IF (MXZOOM.GT.0) MAG = 2 ** TVZOOM(1)
      IX0 = WINDTV(1) - (MAG-1)/2
      IY0 = WINDTV(4) - MAG*NROW + 1 - (MAG-1)/2
      IF (MAG.GT.1) IY0 = IY0 + MAG
      IX0 = (IX0 - TVZOOM(2))/MAG + TVZOOM(2)
      IY0 = (IY0 - TVZOOM(3))/MAG + TVZOOM(3)
      IX0 = MAX (1, IX0)
      IY0 = MAX (1, IY0)
      IF (IX0+NPIX-1.GT.MAXXTV(1)) IX0 = MAXXTV(1) - NPIX + 1
      IF (IY0+NROW-1.GT.MAXXTV(2)) IY0 = MAXXTV(2) - NROW + 1
C                                       set to top row of text
C                                       with scroll correction
      IX0 = IX0 + NEDGE - TVSCGX
      IY0 = IY0 + NEDGE - TVSCGY
      IX0 = MAX (NEDGE, IX0)
      IY0 = MAX (NEDGE, IY0)
      IF (IX0+NPIX-1.GT.MAXXTV(1)) IX0 = 1
      IF (IY0+NROW-1.GT.MAXXTV(2)) IY0 = MAXXTV(2) - NROW + 1
C                                       turn on cursor
 20   RPOS(1) = (WINDTV(3) + WINDTV(1)) / 2.0
         RPOS(2) = (1./4. - 0.01) * (WINDTV(4) - WINDTV(2) + 1.0)
     *      + WINDTV(2) - 1.0
         CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       read loop
 30      CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IERR)
            IF (IERR.NE.0) GO TO 980
            CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
C                                       set a gamma
            IF (DOIT) THEN
               GAMMA =  OGAMMA * 4.0 * ((RPOS(2) - WINDTV(2) + 1.) /
     *            (WINDTV(4) - WINDTV(2) + 1.0) + 0.01)
               IF (IBUT.GE.8) THEN
                  TVGAMA = OGAMMA
               ELSE
                  TVGAMA = GAMMA
                  END IF
               CALL OFMIO ('WRIT', N, NLEVS, F, OFM, IERR)
               IF (IERR.NE.0) GO TO 980
               WRITE (STRING,1030) TVGAMA
               CALL IMANOT ('WRIT', IG, IX0, IY0, 0, 0, STRING(1:6),
     *            BUFFER, IERR)
               IF (IERR.NE.0) GO TO 980
               END IF
C                                       loop or quit
            IF (IBUT.EQ.0) GO TO 30
         IF (IBUT.LE.3) GO TO 20
      POTERR = 0
      IF (IBUT.LT.8) THEN
         WRITE (MSGTXT,1040) TVGAMA
         CALL MSGWRT (4)
         END IF
C                                        close down
C                                        messages on TV error
 980  IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1980) IERR
         CALL MSGWRT (7)
         END IF
C                                       POPS error management
      IERR = POTERR
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (F6.3)
 1040 FORMAT ('TV gamma correction exponent set to',F7.3)
 1980 FORMAT ('TV ACTION ERROR CODE',I5,' RETURNED')
      END

      SUBROUTINE SNDY (NSCR, SCRVOL, SCRFIL)
C-----------------------------------------------------------------------
C! closes all files, then deletes all scratch files
C# IO-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   SNDY closes all possible files.  It then destroys the specified
C   (scratch) files.
C   Inputs:
C      NSCR     I            Number of scratch files to be destroyed
C      SCRVOL   I(NSCR)      Scratch file disk numbers
C      SCRFIL   C*48(NSCR)   Scratch file physical names.
C   Programmer = W. D. Cotton, August 1980.
C-----------------------------------------------------------------------
      CHARACTER  SCRFIL(*)*48
      INTEGER   NSCR, SCRVOL(*)
C
      INTEGER   IERR, IFIND, LUNMSG, I, J
      LOGICAL   T, F
      INCLUDE 'INCS:DMSG.INC'
      DATA T, F /.TRUE., .FALSE./
      DATA LUNMSG /12/
C-----------------------------------------------------------------------
C                                       Close all files in FTAB.
      J = LUNMSG + 1
      DO 20 I = J,50
         CALL LSERCH ('SRCH', I, IFIND, F, IERR)
         IF (IERR.NE.0) CALL LSERCH ('SRCH', I, IFIND, T, IERR)
         IF (IERR.EQ.0) CALL ZCLOSE (I, IFIND, IERR)
   20    CONTINUE
      J = LUNMSG - 1
      DO 40 I = 1,J
         CALL LSERCH ('SRCH', I, IFIND, F, IERR)
         IF (IERR.NE.0) CALL LSERCH ('SRCH', I, IFIND, T, IERR)
         IF (IERR.EQ.0) CALL ZCLOSE (I, IFIND, IERR)
   40    CONTINUE
C                                       Destroy scratch files.
      IF (NSCR.LE.0) GO TO 999
         DO 50 I = 1,NSCR
            CALL ZDESTR (SCRVOL(I), SCRFIL(I), IERR)
            IF (IERR.EQ.0) GO TO 50
               WRITE (MSGTXT,1050) IERR, SCRFIL(I)
               CALL MSGWRT (8)
 50         CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT('SNDY: ERROR',I3,' COULD NOT DESTROY FILE ',A40)
      END

      SUBROUTINE ATMFAZ (EL, HA, LAT, DEC, R, T, PRES, PPWVR, TLAP, HTP,
     *   WS, DELAY, RATE)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Computes neutral model atmosphere group delay and rate CORRECTIONS.
C   Uses the Cfa-2.2 dry maping function (Davis et al. 1985, Radio
C   Science, 20, pp 1593-1607).
C   The "dry" zenith delay is also from Davis et. al.
C   The "wet" terms are a adaptation of a routine by J. Moran
C   incorporating a more realistic temperature profile.
C    Inputs:
C     EL     R  Elevation of source (radians).
C     HA     R  Hour angle of source (radians)
C     LAT    D  latitude of observation.
C     DEC    D  App. declination of source (rad)
C     R      D  Distance of observation from center of earth (m).
C     T      R  Surface temperature (deg C)
C     PRES   R  Total surface pressure (mbar) (not sea level).
C     PPWVR  R  Partial presure of water vapor at surface (mbar).
C     TLAP   R  Tropospheric temperature lapse rate (K/km). (negative)
C     HTP    R  Height of the tropopause (km)
C     WS     R  Scale height of water vapor (km)
C    Output:
C     DELAY  R  Model group delay (seconds)
C     RATE   R  Model time derivative of DELAY (sec/sec)
C-----------------------------------------------------------------------
      REAL EL, HA, T, PRES, PPWVR, TLAP, HTP, WS, DELAY, RATE
      DOUBLE PRECISION LAT, DEC, R
      REAL ZDRY, H, A, B, C, K1, K2, K3, DELDT, MFN, DMFN, SUM1,
     *   SUM2, STEP, TERM, TH, FACT(41), PWET, FWET, DEN, FFF, CEL, RT,
     *   TK, CESET
      INTEGER NUMINT, LOOP
C                                       Coef. for Simpson's rule
C                                       integration
      DATA FACT /1.0,4.0,2.0,4.0,2.0,4.0,2.0,4.0,2.0,4.0,2.0,4.0,2.0,
     *   4.0,2.0,4.0,2.0,4.0,2.0,4.0,2.0,4.0,2.0,4.0,2.0,4.0,2.0,4.0,
     *   2.0,4.0,2.0,4.0,2.0,4.0,2.0,4.0,2.0,4.0,2.0,4.0,1.0/
C-----------------------------------------------------------------------
C                                       Height above geoid (km)
      H = 0.001 * (R - 6.378137E6 * (0.99827073 +
     *   0.001676438 * COS (2.0 * LAT) - 0.000003519 * COS (4.0 * LAT) +
     *   8.0E-9 * COS (6.0 * LAT)))
C                                       "Dry" zenith delay (m)
      ZDRY = 2.2768E-3 * PRES / (1.0 - 0.00266 * COS (2.0 * LAT) -
     *   0.00028 * H)
C                                       Cfa-2.2 mapping function.
      A = 0.001185 * (1.0 + 0.6071E-4 * (PRES - 1000.0)
     *   - 0.1471E-3 * PPWVR
     *   + 0.3072E-2 * (T - 20.0)
     *   + 0.1965E-1 * (TLAP + 6.5)
     *   - 0.5645E-2 * (HTP - 11.231))
      B = 0.001144 * (1.0 + 0.1164E-4 * (PRES - 1000.0)
     *   + 0.2795E-3 * PPWVR
     *   + 0.3109E-2 * (T - 20.0)
     *   + 0.3038E-1 * (TLAP + 6.5)
     *   - 0.1217E-1 * (HTP - 11.231))
      C = -0.0090
C                                       Time derivative of el (Hz)
      IF (EL.LT.1.56) THEN
         DELDT = -7.29211E-5 * SIN (HA) * COS (LAT) * COS (DEC) /
     *      SQRT (1.0 - (SIN (EL)**2))
      ELSE
C                                       At zenith
         DELDT = 0.0
         END IF
      K3 = 1.0 / (SIN (EL) + C)
      K2 = 1.0 / (TAN (EL) + B * K3)
      K1 = 1.0 / (SIN (EL) + A * K2)
      MFN = K1
      DMFN = -K1 * K1 * (COS (EL) - A * K2 * K2 *
     *   ((1.0 / (COS (EL)**2)) - B * K3 * K3 * COS (EL))) * DELDT
C                                       Delay (sec)
      DELAY = MFN * ZDRY * 3.33564E-9
C                                       Rate (sec/sec)
      RATE = DMFN * ZDRY * 3.33564E-9
C                                       "Wet" zenith delay
C                                       Numerical integration
      NUMINT = 41
      STEP = WS * 0.1
C                                       First term
C                                       Cosine elevation angle
      CEL = COS (EL)
C                                       Distance from earth center (km)
      RT = R * 0.001
      TK = T + 273.16
      SUM1 = 0.0
      SUM2 = 0.0
      DO 100 LOOP = 2,NUMINT
         H = (LOOP-1) * STEP
C                                       Temperature
         IF (H.LE.HTP) THEN
C                                       Troposphere
            TH = TK + TLAP * H
         ELSE
C                                       Isothermal stratosphere
            TH = TK + TLAP * HTP
            END IF
         TERM = EXP (-H/WS) / TH
         FFF = (RT / (RT + H))**2
         DEN = SQRT (1.0D0 - FFF * CEL * CEL)
         SUM1 = SUM1 + FACT(LOOP) * TERM / DEN
         SUM2 = SUM2 + FACT(LOOP) * TERM * FFF / (DEN**3)
 100     CONTINUE
C                                       Wet terms (sec, sec/sec)
      CESET = -COS (EL) * SIN(EL) * DELDT
      FFF = (PPWVR * 1720.0E-6 * 217.0 / TK) * (STEP * 0.33333333)
     *   *  3.33564E-6
      PWET = SUM1 * FFF
      FWET = SUM2 * FFF * CESET
C                                       Add "wet" terms
      DELAY = DELAY + PWET
      RATE = RATE + FWET
C                                       Convert to corrections
      DELAY = - DELAY
      RATE = - RATE
C
 999  RETURN
      END

      SUBROUTINE QGETIN (APCORE, HOST, J, AP, L, N, TYPE)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Move data from pseudo-AP to host w increments
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Transfer data from pseudo-AP core to normal core with an increment
C   Inputs:
C      J      I  Increment in host memory: 0 -> 1
C      AP     I  Target area in AP; 0-relative
C      L      I  Increment in AP memory: 0 -> 1
C      N      I  Number of elements returned
C      TYPE   I  Data type:
C                 1     data is I   in host
C                 else  data is R   in host
C   Output:
C      HOST   R/I(*)  Data array in "host"
C   NOTE WELL: the data in the AP is DOUBLE PRECISION and INTEGER*8
C   DO NOT LIE ABOUT THE TYPE YOU WANT OR YOU WILL GET BAD VALUES
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   J, AP, L, N, TYPE
      REAL      HOST(*)
C
      INTEGER   I, IL, JI, IJ
      LONGINT   JAP
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
      IF (TYPE.GT.2) GO TO 999
      IF (N.LE.0) GO TO 999
C                                       Integer data
      IF (TYPE.EQ.1) THEN
         CALL QGETI2 (APCORE, HOST, J, AP, L, N)
C                                       Real data
      ELSE
         IL = L
         IF (IL.EQ.0) IL = 1
         IJ = J

         IF (IJ.EQ.0) IJ = 1
         JI = 1
         JAP = AP + PSAPOF
         DO 10 I = 1,N
            HOST(JI) = APCORE(JAP)
            JI = JI + IJ
            JAP = JAP + IL
 10         CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE PRMUPD
C-----------------------------------------------------------------------
C! Updates some parameters to represent true state of scratch file
C# UV Modeling AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C Routine to update a few crucial parameters to represent the true
C state of a scratch file in the model division routines, these are 
C changed since the scratch file (which should never be compressed),
C is larger then the input file in order to hold the FFT of the model
C alongside the data.
C-----------------------------------------------------------------------
      INTEGER IT1, IT2, IT3, IERR
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      IT1 = LREC
      IT2 = NRPARM
      IT3 = CATBLK(KINAX)
      CATBLK(KINAX) = 3
      CALL UVPGET (IERR)
      CATBLK(KINAX) = IT3
      LREC = IT1
      NRPARM = IT2
      RETURN
      END

      SUBROUTINE ZBKLD3 (IERR)
C-----------------------------------------------------------------------
C! clean up system things for BAKLD ending
C# Z Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Routine to clean up host environment after executing task BAKLD.
C   Output:
C      IERR   I   Error code: 0 => okay
C                    1 => can't open command file
C   VMS version
C   It is conceivable that VMS would not want to delete the command file
C   while it is still being executed by "DCL".  In such a case, a
C   separate execution of ZSHCMD could be used.  Because we use a
C   command file, ZBKLD3 could do other commands too.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INTEGER   ITRIM, ITEMP, JERR, IL
      CHARACTER COMMND*40, TEMP*60, HTEMP*1, TEXT*128
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DBKL.INC'
C-----------------------------------------------------------------------
      IERR = 0
      OPEN (ZLUN2, FILE=ZBKNAM, STATUS='OLD', ERR=900)
C                                       generate command file:
      REWIND ZLUN2
C                                       delete our DA00 subdirectory
C                                       plus BAKLD scratches;
C                                       also delete THIS command file!
      CALL ZEHEX (NPOPS, 1, HTEMP)
      TEMP = ZDA00(1:(LZDA00-1)) // '.' // TKNAME // ']*.*;*'
      ITEMP = ITRIM (TEMP)
      TEXT = '$ IF F$SEARCH("' // TEMP(:ITEMP) // '").NES."" THEN -'
      JERR = ITRIM (TEXT)
      WRITE (ZLUN2,1000,ERR=900) TEXT(1:JERR)
      TEXT = '$   DELETE' // DBLOG // TEMP(1:ITEMP)
      JERR = ITRIM (TEXT)
      WRITE (ZLUN2,1000,ERR=900) TEXT(1:JERR)
      TEXT = '$ DELETE' // DBLOG // ZDA00(1:LZDA00) // TKNAME //
     *   '.*;*'
      JERR = ITRIM (TEXT)
      WRITE (ZLUN2,1000,ERR=900) TEXT(1:JERR)
      CLOSE (ZLUN2)
      COMMND = '@' // ZBKNAM
      IL = ITRIM (COMMND)
      CALL ZSHCMD (IL, COMMND, 8, 'TASK_OUT', IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (8)
         MSGTXT = 'ZBKLD3: ' // COMMND
         GO TO 990
         END IF
      GO TO 999
C                                       can't open, fatal error:
 900  MSGTXT = 'ZBKLD3: CANNOT OPEN/WRITE ' // ZBKNAM
      IERR = 1
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A)
 1010 FORMAT ('ZBKLD3: ZSHCMD ERROR',I7,'  COMMAND=')
      END

      SUBROUTINE YZOOMC (MAG, XZOOM, YZOOM, VRTRTC, IERR)
C-----------------------------------------------------------------------
C! set the TV zoom magnification and center
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YZOOM writes (ONLY!!!!) the zoom control registers of the TV
C   Inputs:
C      MAG     I     0-3 for magnification 1,2,4,8 times, resp.
C      XZOOM   I     X center of expansion (1-512, 1 => LHS)
C      YZOOM   I     Y center of expansion (1-512, 1 => bot)
C      VRTRTC  L     Do on vertical retrace only?
C   Output:
C      IERR    I     error code of Z...XF: 0 -> ok, 2 -> input error
C   YZOOMC updates the /TVDEV/ common TVZOOM parameter
C   Modified NOV-83 by Jaffe for DeAnza code
C-----------------------------------------------------------------------
      INTEGER   MAG, XZOOM, YZOOM, IERR
      LOGICAL   VRTRTC
C
      INCLUDE 'INCS:YDEA.INC'
      INTEGER   SCMASK, IMAG, JMAG, IX, IY, ZREG(2), SHIFT, ITEMP, I,
     *   KOFF, ISCX, ISCY, ITEMP2, ZAND
      LOGICAL   WAIT, UPDATE
      INCLUDE 'INCS:DTVC.INC'
      DATA WAIT /.TRUE./
C     DATA SHIFT, SCMASK /Z0020, Z03FF/
      DATA SHIFT, SCMASK /32,    1023/
C-----------------------------------------------------------------------
      IERR = 2
      IF ((MAG.LT.0) .OR. (MAG.GT.IABS(MXZOOM))) GO TO 999
      IF ((XZOOM.LT.1) .OR. (XZOOM.GT.MAXXTV(1))) GO TO 999
      IF ((YZOOM.LT.1) .OR. (YZOOM.GT.MAXXTV(2))) GO TO 999
C                                       set zoom factor
      IMAG = MAG + 1
      IF (MXZOOM.GT.0) IMAG = 2 ** MAG
      JMAG = SHIFT * (IMAG - 1)
C                                       Put zoom in upper byte
      DO 10 I = 1,2
         ZREG(I) = 0
         CALL ZPUTCH (JMAG, ZREG(I), 2)
 10      CONTINUE
C                                       calculate scroll equivalent
      IX = REAL(XZOOM-1) * REAL(IMAG-1) /REAL(IMAG)
      IY = (REAL(YZOOM-1) * REAL(IMAG-1) + REAL(MAXXTV(2) - 1))
     *   / REAL(IMAG)
C                                       Loop over channels
      IERR = 0
      ITEMP2 = NGRAY + 1
      DO 20 I = 1,ITEMP2
         UPDATE = .FALSE.
         KOFF = 4 * (I-1)
         ITEMP = IX - TVSCRX(I)
         ISCX = ZREG(1) + ZAND (ITEMP, SCMASK)
         ITEMP = IY - TVSCRY(I)
         ISCY = ZREG(2) + ZAND (ITEMP, SCMASK)
C                                       Do I need to change anything?
         CALL YTCOMP (YBUFF(KOFF + XSCZ), ISCX, UPDATE)
         CALL YTCOMP (YBUFF(KOFF + YSCZ), ISCY, UPDATE)
C                                       If so, do it.
         IF (UPDATE) THEN
            ITEMP = I - 1
            CALL ZDEAXF ('LMC ', YBUFF(KOFF+MEMREG), MRBYTE, ITEMP, 0,
     *         WAIT, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 20      CONTINUE
C                                       update common /TVCHAR/
      TVZOOM(1) = MAG
      TVZOOM(2) = XZOOM
      TVZOOM(3) = YZOOM
C
 999  RETURN
      END

LOCAL INCLUDE 'FLGIT.INC'
C                                       Local include for FLGIT
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   SEQIN, CNOIN, DISKIN, JBUFSZ, DISKOU, FITWTS(MAXCIF),
     *   NBDCOR, INCSI, INCFI, INCIFI, MAXWIN, AVGWIN, CATBO(256),
     *   SEQOUT, CNOOUT, NNCNT(10), NIF, CHNSEL(3,20,MAXIF), NCHAN,
     *   FGVERI, FGVERO, NFGWRI, VISINC, VISMSG, SCRTCH(256)
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XXCALC, XCLAOU(2),
     *   XNAMEO(3), XOPCOD
      CHARACTER NAMEIN*12, CLAIN*6, XCALCO*4, XSOUR(30)*16, NAMEOU*12,
     *   CLAOUT*6, OPCODE*4
      REAL      XSIN, XDISIN, XSOUT, XDISOU, XQUAL, XFGOUT, XTIME(8),
     *   XBAND, XFREQ, XFQID, XBCHAN, XECHAN, XBIF, XEIF, XSUBA, XDOCAL,
     *   XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER,
     *   XSMOTH(3), APARM(10), BPARM(10), XCHNS(4,20), XORD, XBADD(10),
     *   BUFF1(UVBFSS), BUFF2(UVBFSS), FINC(MAXIF)
      LOGICAL   ISCOMP, SELIF, DOOUT
      INTEGER   NSOU, ISBAND(MAXIF), NORDER, NANT, NPOLN
      DOUBLE PRECISION TIME1, TIME2, FQOFF, FOFF(MAXIF)
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMEO, XCLAOU,
     *   XSOUT, XDISOU, XFGOUT, XXSOUR, XQUAL, XXCALC, XTIME, XBAND,
     *   XFREQ, XFQID, XBCHAN, XECHAN, XBIF, XEIF, XSUBA, XDOCAL, XGUSE,
     *   XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH, XOPCOD,
     *   APARM, BPARM, XCHNS, XORD, XBADD
      COMMON /INFO/ CATBO, TIME1, TIME2, FQOFF, FOFF, FINC, ISBAND,
     *   NSOU, SEQIN, DISKIN, CNOIN, INCSI, INCFI, INCIFI, ISCOMP,
     *   NBDCOR, SEQOUT, CNOOUT, DISKOU, SELIF, NNCNT, MAXWIN, AVGWIN,
     *   NORDER, NIF, NCHAN, NANT, NPOLN, CHNSEL, DOOUT, FGVERI, FGVERO,
     *   NFGWRI, VISINC, VISMSG, SCRTCH
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAMEOU, CLAOUT, XCALCO, XSOUR,
     *   OPCODE
      COMMON /WEIGHT/ FITWTS
LOCAL END
      PROGRAM FLGIT
C-----------------------------------------------------------------------
C! Applies calibration and/or editing and flags multisource uv data.
C# task editing UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1997-2000, 2002-2012, 2015-2016, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   It reads a UV data set in time order applying calibration and
C   editing.  It then fits a baseline to selected channels, examines the
C   rms in those channels after the fit and flags channels with
C   excessive signals.  The flagged data are then written to a new file.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input UV data.
C      SOURCES        SOURCS        Source list.
C      QUAL           SELQUA
C      CALCODE        XCALCO
C      TIMERANG       XTIME         Time range of the data to check.
C      SELBAND        SELBAN
C      SELFREQ        SELFRQ
C      FREQID         FRQSEL
C      BCHAN          BCHAN         First channel in output
C      ECHAN          ECHAN         Last channel in output.
C      BIF            BIF           First IF to copy. 0=>all.
C      EIF            EIF           Highest IF to copy. 0=> highest.
C      SUBARRAY       SUBARR        Subarray number to copy. 0=> all.
C      DOCALIB        DOCAL         If true (>0), calibrate the data.
C      GAINUSE        CLUSE         Version of the Cal. table to use.
C      FLAGVER        FGVER         Version of the FG table to use.
C      DOBAND         DOBAND        If true correct data for bandpass
C      BPVER          BPVER         The BP table to apply
C      FLUX           RMS           Max deviation for unity weight
C      BADDISK        IBAD          Disks to avoid for scratch files.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, I, MALL(2), MBAD(2), MCBAD(2), NWORDS, MCHAN(2)
      LONGINT   OFFALL, OFFBAD, OFCBAD, OFFCHN
C     INTEGER   MCHAN(4*MAXCIF), MALL(MAXANT,MAXANT,4*MAXIF),
C    *   MBAD(MAXANT,MAXANT,4*MAXIF), MCBAD(MAXANT,MAXANT,4*MAXIF)
      INCLUDE 'FLGIT.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'FLGIT '/
C-----------------------------------------------------------------------
C                                       Get input parameters.
      CALL FLGIIN (PRGM, IRET)
C                                       Allocate memory
      NWORDS = (NANT * NANT * NPOLN * NIF - 1) / 1024 + 1
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, MALL, OFFALL,
     *   IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, MBAD, OFFBAD,
     *   IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, MCBAD, OFCBAD,
     *   IRET)
C                                       Zero info matrices
      IF (IRET.EQ.0) THEN
         NWORDS = 1024 * NWORDS
         CALL FILL (NWORDS, 0, MALL(1+OFFALL))
         CALL FILL (NWORDS, 0, MBAD(1+OFFBAD))
         CALL FILL (NWORDS, 0, MCBAD(1+OFCBAD))
         END IF
C                                       Zero channel info array
      NWORDS = (NPOLN * NCHAN * NIF) / 1024 + 1
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, MCHAN, OFFCHN,
     *   IRET)
      IF (IRET.EQ.0) CALL FILL (1024*NWORDS, 0, MCHAN(1+OFFCHN))
C                                       Loop over sources.
      IF (IRET.EQ.0) CALL FLGIUV (NANT, NPOLN, NCHAN, NIF,
     *   MALL(1+OFFALL), MBAD(1+OFFBAD), MCBAD(1+OFCBAD),
     *   MCHAN(1+OFFCHN), IRET)
C                                       report results
      IF (IRET.EQ.0) CALL REPORT (NANT, NPOLN, NCHAN, NIF,
     *   MALL(1+OFFALL), MBAD(1+OFFBAD), MCBAD(1+OFCBAD),
     *   MCHAN(1+OFFCHN))
C                                       Report deeds to History file
      IRET = MAX (IRET, 0)
      IF (IRET.EQ.0) CALL FLGIHI
C                                       Done: Close down files, etc.
      CALL ZMEMRY ('FRAL', TSKNAM, NWORDS, MCBAD, OFCBAD, I)
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE FLGIIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   FLGIIN gets input parameters for FLGIT, finds input file and
C   prepares the list of sources.  All selection criteria except
C   for the source name are filled into the commons in C/DSEL.INC.
C   Inputs:  PRGN    C*6   Program name
C   Output:
C     JERR         I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   IRET
C
      HOLLERITH CATH(256)
      CHARACTER STAT*4, UTYPE*2
      INTEGER   NPARM, IROUND, IERR, I, LUN, J, JJ
      REAL      CATR(256)
      LOGICAL   MATCH
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'FLGIT.INC'
      INTEGER   NW(MAXIF), K, K1, K2, IOFF, NUMAN(513), NVER
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATR, CATBLK, CATH)
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
      CALL FILL (10, 0, NNCNT)
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
C                                       Get input parameters.
      NPARM = 276
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
C
      IRET = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      SEQOUT = IROUND (XSOUT)
      DISKOU = IROUND (XDISOU)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMEO, NAMEOU)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (4, 1, XXCALC, XCALCO)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      DOOUT = XFGOUT.LT.0.0
      NORDER = XORD + 0.1
      NORDER = MAX (0, MIN (1, NORDER))
C                                       Sources
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), SOURCS(I))
         XSOUR(I) = SOURCS(I)
 20      CONTINUE
C                                       Save the time range
      CALL RCOPY (8, XTIME, TIMRNG)
C                                       BADDISK
      DO 30 I = 1,10
         IBAD(I) = IROUND (XBADD(I))
 30      CONTINUE
C                                       Get CATBLK for input file.
      CNOIN = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       OK, get the header now
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'REST', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1035) IERR
         GO TO 990
         END IF
C                                       OK, file available
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 0
C                                       Save input header
      CALL COPY (256, CATBLK, CATUV)
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Get uv header pointers.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
      FQOFF = 0.0D0
      NPOLN = CATBLK(KINAX+JLOCS)
      VISINC = CATBLK(KIGCN) / 20
      VISMSG = CATBLK(KIGCN) / 10
      VISINC = MAX (10000, MIN (50000,VISINC))
      VISMSG = (VISMSG / VISINC) * VISINC
      IF (VISMSG.LT.VISINC) VISMSG = 100 * VISINC
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
C                                       Set BCHAN and ECHAN
      JJ = CATBLK(KINAX+JLOCF)
      BCHAN = XBCHAN + 0.1
      BCHAN = MAX (1, BCHAN)
      ECHAN = XECHAN + 0.1
      IF (ECHAN.LT.BCHAN) ECHAN = JJ
      ECHAN = MIN (ECHAN, JJ)
      NCHAN = ECHAN - BCHAN + 1
      BPARM(1) = MAX (0.0, BPARM(1))
      IF (BPARM(2).LT.0.5) BPARM(2) = JJ
C                                       Check wanted IFs
      IF (JLOCIF.GE.0) THEN
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, CATBLK(KINAX+JLOCIF)))
         EIF = IROUND (XEIF)
         IF (BIF.GT.EIF) EIF = CATBLK(KINAX+JLOCIF)
         EIF = MAX (1, MIN (EIF, CATBLK(KINAX+JLOCIF)))
      ELSE
         BIF = 1
         EIF = 1
         END IF
      SELIF = (BIF.GT.1) .OR. (EIF.LT.CATBLK(KINAX+JLOCIF)) .OR.
     *   (FRQSEL.GT.0)
      NIF = EIF - BIF + 1
C                                       ICHANSEL
      I = NCHAN * NIF
      CALL FILL (I, 0, FITWTS)
      CALL FILL (MAXIF, 0, NW)
      I = 60 * MAXIF
      CALL FILL (I, 0, CHNSEL)
      DO 40 J = 1,20
         K = IROUND (XCHNS(2,J))
         IF (K.LE.0) GO TO 45
         K = IROUND (XCHNS(4,J))
         IF ((K.LE.0) .OR. (K.GT.NIF)) THEN
            K1 = BIF
            K2 = EIF
         ELSE
            K1 = K
            K2 = K
            END IF
         DO 35 K = K1,K2
            NW(K) = NW(K) + 1
            CHNSEL(1,NW(K),K) = MAX (0, IROUND (XCHNS(1,J)))
            CHNSEL(2,NW(K),K) = MAX (0, IROUND (XCHNS(2,J)))
            CHNSEL(3,NW(K),K) = MAX (1, IROUND (XCHNS(3,J)))
 35         CONTINUE
 40      CONTINUE
C                                       If no channel selection
C                                       use 1 - NCHAN
 45    DO 60 K = BIF,EIF
          IOFF = (K - BIF) * NCHAN + 1 - BCHAN
          IF (NW(K).LE.0) THEN
             NW(K) = 1
             CHNSEL(1,1,K) = BCHAN
             CHNSEL(2,1,K) = ECHAN
             CHNSEL(3,1,K) = 1
             END IF
          DO 55 I = 1,NW(K)
             CHNSEL(1,I,K) = MAX (BCHAN, MIN (CHNSEL(1,I,K), ECHAN))
             IF (CHNSEL(2,I,K).LT.CHNSEL(1,I,K)) CHNSEL(2,I,K) = ECHAN
             CHNSEL(2,I,K) = MAX (BCHAN, MIN (CHNSEL(2,I,K), ECHAN))
             DO 50 J = CHNSEL(1,I,K),CHNSEL(2,I,K),CHNSEL(3,I,K)
                FITWTS(J+IOFF) = 1
 50            CONTINUE
 55         CONTINUE
 60      CONTINUE
C                                       Write weights to message file
      DO 70 K = BIF,EIF
         IOFF = (K-BIF)*NCHAN
         DO 65 I = BCHAN,ECHAN,20
            K1 = I + IOFF - BCHAN + 1
            K2 = MIN (I+19, ECHAN) - BCHAN + 1 + IOFF
            WRITE (MSGTXT,1060) K, I, (FITWTS(J), J = K1,K2)
            CALL MSGWRT (4)
 65         CONTINUE
 70      CONTINUE
C                                       Setup calibration choices
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOPOL = IROUND (XDOPOL)
      IF ((DOPOL.EQ.0) .AND. (XDOPOL.GT.0.0)) DOPOL = 1
      PDVER = IROUND (XPDVER)
      BLVER = IROUND (XBLVER)
      CALL FILL (50, 0, ANTENS)
      SUBARR = IROUND (XSUBA)
C                                       set flag versions
      CALL FNDEXT ('FG', CATBLK, I)
      FGVER = IROUND (XFLAG)
      IF ((FGVER.LT.0) .OR. (FGVER.GT.I)) FGVER = -1
      IF (FGVER.EQ.0) FGVER = I
      IF (DOOUT) THEN
         FGVERO = -1
         FGVERI = -1
      ELSE
         FGVERO = IROUND (XFGOUT)
         IF ((FGVERO.EQ.0) .OR. (FGVERO.GT.I)) FGVERO = I + 1
         FGVERI = FGVER
         IF (FGVERO.LE.I) FGVERI = -ABS (FGVERI)
         END IF
      NFGWRI = 0
C                                       cal parameters
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
C                                       Do only cross-correlations
      DOACOR = .FALSE.
      DOXCOR = .TRUE.
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, IRET)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'No match to SELBAND/SELFREQ adverbs - check inputs'
         IRET = 1
         GO TO 990
         END IF
      IF (IRET.GT.0) GO TO 999
C                                       Choice of qualifiers and calcode
      SELQUA = IROUND (XQUAL)
      SELCOD = XCALCO
C                                       Get source list
      IUDISK = FVOL(1)
      IUCNO = FCNO(1)
      IXLUN = 28
      CALL SOUFIL (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Max antenna number
      NANT = MAXANT
      CALL FNDEXT ('AN', CATBLK, NVER)
      IF (NVER.GT.0) THEN
         CALL GETNAN (DISKIN, CNOIN, CATBLK, LUN, BUFF1, NUMAN, IRET)
         IF ((NVER.GT.0) .AND. (IRET.EQ.0)) THEN
            JJ = NUMAN(1)
            NANT = 0
            DO 80 J = 1,JJ
               NANT = MAX (NANT, NUMAN(J+1))
 80            CONTINUE
            END IF
         END IF
C                                        Local parameters
      IF (APARM(1).LE.0.0) APARM(1) = 1.0E10
      IF (APARM(2).LE.0.0) APARM(2) = 1.0E10
      IF (APARM(3).LE.0.0) APARM(3) = 1.0E10
      IF (APARM(4).LE.0.0) APARM(4) = 6.0
      IF (APARM(5).LE.0.0) APARM(5) = 5.0
      MAXWIN = APARM(7) + 0.5
      IF (MAXWIN.LT.3) MAXWIN = 5
      AVGWIN = APARM(8) + 0.5
      AVGWIN = MAX (1, MIN (AVGWIN, MAXWIN-2))
      APARM(7) = MAXWIN
      APARM(8) = AVGWIN
      WRITE (MSGTXT,1100) APARM(1)
      CALL MSGWRT (4)
      WRITE (MSGTXT,1101) APARM(6)
      CALL MSGWRT (4)
      WRITE (MSGTXT,1102) APARM(2)
      CALL MSGWRT (4)
      WRITE (MSGTXT,1103) APARM(3)
      CALL MSGWRT (4)
      IF (OPCODE.NE.'MWFL') THEN
         WRITE (MSGTXT,1104) APARM(4)
         CALL MSGWRT (4)
         WRITE (MSGTXT,1105) APARM(5)
         CALL MSGWRT (4)
      ELSE
         WRITE (MSGTXT,1110) AVGWIN, MAXWIN
         CALL MSGWRT (4)
         END IF
      APARM(1) = APARM(1) * APARM(1)
      APARM(2) = APARM(2) * APARM(2)
      APARM(3) = APARM(3) * APARM(3)
      APARM(6) = APARM(6) * APARM(6)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FLGIIN: error',I3,' obtaining input parameters')
 1030 FORMAT ('Error',I3,' finding ',A12,'.',A6,'.',I4,' disk =',
     *   I3,' user=',I5)
 1035 FORMAT ('Error',I3,' obtaining CATBLK ')
 1060 FORMAT ('Weights (',I3,'/',I5,') ',20I2)
 1100 FORMAT ('Clipping threshold for all channels = ',1PE12.3,' Jy')
 1101 FORMAT ('Clipping threshold for VPOL all chn = ',1PE12.3,' Jy')
 1102 FORMAT ('Flagging threshold for unit weight  = ',1PE12.3,' Jy')
 1103 FORMAT ('Flagging threshold for signal chans = ',1PE12.3,' Jy')
 1104 FORMAT ('Flagging residual flux              > ',F12.3,' *RMS')
 1105 FORMAT ('Flagging residual Real/Imaginary    > ',F12.3,' *RMS')
 1110 FORMAT ('Average',I3,' channels to form median in window of',I3,
     *   ' channels')
      END
      SUBROUTINE FLGIUV (NA, NP, NC, NI, MALL, MBAD, MCBAD, MCHAN, IRET)
C-----------------------------------------------------------------------
C   FLGIUV reads data through the calibration package, removes the
C   spectral baseline, flags bad channels, and writes out the data.
C   Inputs:
C      NA      I      Number of antennas
C      NP      I      Number of polarizations
C      NC      I      Number of channels
C      NI      I      Number of IFs
C   Output:
C      MALL    I(*)   Counts samples by baseline etc
C      MBAD    I(*)   Counts full bad spectra by baseline
C      MCBAD   I(*)   Counts bad channels by baseline
C      MCHAN   I(*)   Counts flags by channel
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NA, NP, NC, NI, MALL(NA,NA,NP,NI), MBAD(NA,NA,NP,NI),
     *   MCBAD(NA,NA,NP,NI), MCHAN(NC,NP,NI), IRET
C
      INCLUDE 'FLGIT.INC'
      CHARACTER PHNAME*48, CPARM*8, REASON*24, ATIME*8, ADATE*12
      HOLLERITH CATH(256)
      INTEGER   I, NRPRIN, VO, BO, INCX, NUMVIS, VCOUNT, KBIND, LUNO,
     *   LRECO, IA1, IA2, ILOCWT, INDO, OCOUNT, IPTRO, NCOPY,
     *   ILENBU, NIOUT, NIOLIM, ISUB, ISUB1,ISUB2, NXVER, NXLUN, NNIF,
     *   RNXRET, WASBAD(MAXCIF), LFGRNO, BUFFLG(512), FGKOLS(MAXFGC),
     *   FGNUMV(MAXFGC), LUN, DATE(3), TIME(3)
      REAL      RPARM(20), CATR(256), BASEN, UVWSC
      DOUBLE PRECISION  CATD(128)
      LOGICAL   T, F
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      DATA LUNO, LUN /48, 49/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Set flagging reason
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
      REASON = TSKNAM // ADATE // ' ' // ATIME(:5)
C                                       Initialize calibration
      NUMVIS = 0
      OCOUNT = 0
      CALL FNDEXT ('AN', CATBLK, ISUB)
      ISUB = MAX (1, ISUB)
      IF (ISUB.EQ.1) THEN
         ISUB1 = 1
         ISUB2 = 1
      ELSE IF ((SUBARR.LT.1) .OR. (SUBARR.GT.ISUB)) THEN
         ISUB1 = 1
         ISUB2 = ISUB
      ELSE
         ISUB1 = SUBARR
         ISUB2 = SUBARR
         END IF
      NXVER = 1
      NXLUN = 28
      CALL CHNDAT ('READ', NXBUFF, DISKIN, CNOIN, NXVER, CATUV, NXLUN,
     *   NNIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'PROBLEM FINDING FREQUENCIES'
         CALL MSGWRT (6)
         GO TO 999
         END IF
      DO 100 ISUB = ISUB1,ISUB2
         WRITE (MSGTXT,1010) ISUB
         CALL MSGWRT (2)
         SUBARR = ISUB
         CALL UVGET ('INIT', RPARM, BUFF1, IRET)
         IF (IRET.GT.0) GO TO 999
         UVWSC = FREQ / UVFREQ
C                                       Get values of data increments
C                                       from the calibration package
         IF (ISUB.EQ.ISUB1) THEN
            INCX = CATBLK(KINAX)
            INCSI = INCS / INCX
            INCFI = INCF / INCX
            INCIFI = INCIF / INCX
            NRPRIN = NRPARM
            END IF
C                                       create output file name
         IF ((ISUB.EQ.ISUB1) .AND. (DOOUT)) THEN
            CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMEOU, CLAOUT,
     *         SEQOUT)
            CALL CHR2H (12, NAMEOU, KHIMNO, CATH(KHIMN))
            CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
            CATBLK(KIIMS) = SEQOUT
C                                       fix header for compress
            IF (ISCOMP) THEN
               IA1 = 0
               IA2 = 0
               DO 10 I = 1,NRPARM
                  CALL H2CHR (8, 1, CATH(KHPTP+2*I-2), CPARM)
                  IF (CPARM.EQ.'REMOVED') THEN
                     IF (IA1.EQ.0) THEN
                        IA1 = I
                     ELSE IF (IA2.NE.IA1+1) THEN
                        IA2 = I
                        END IF
                     END IF
 10               CONTINUE
C                                       replace REMOVEDs
               IF (IA2.EQ.IA1+1) THEN
                  ILOCWT = IA1 - 1
C                                       Increase number
               ELSE
                  ILOCWT = NRPARM
                  CATBLK(KIPCN) = NRPARM + 2
                  END IF
               CALL CHR2H (8, 'WEIGHT  ', 1, CATH(KHPTP+2*ILOCWT))
               CALL CHR2H (8, 'SCALE   ', 1, CATH(KHPTP+2*ILOCWT+2))
               CATBLK(KINAX) = 1
               CALL UVPGET (IRET)
               END IF
C                                       no sort if >1 subarray
            IF (ISUB2.GT.ISUB1) CALL CHR2H (2, '  ', 1, CATH(KITYP))
C                                       Create output file.
            CNOOUT = 1
            FRW(NCFILE+1) = 3
            CALL UVCREA (DISKOU, CNOOUT, BUFF1, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'CREATE OUTPUT'
               GO TO 990
               END IF
            NCFILE = NCFILE + 1
            FVOL(NCFILE) = DISKOU
            FCNO(NCFILE) = CNOOUT
            FRW(NCFILE) = FRW(NCFILE) - 1
            SEQOUT = CATBLK(KIIMS)
C                                       copy keywords
            CALL KEYCOP (DISKIN, CNOIN, DISKOU, CNOOUT, IRET)
C                                       Copy new CATBLK
            CALL COPY (256, CATBLK, CATBO)
            CALL ZPHFIL ('UV', DISKOU, CNOOUT, 1, PHNAME, IRET)
            CALL ZOPEN (LUNO, INDO, DISKOU, PHNAME, T, F, F, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'OPEN OUTPUT'
               GO TO 990
               END IF
C                                       Init vis file for write
            ILENBU = 0
            LRECO = LREC
            CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU,
     *         JBUFSZ,BUFF2, BO, KBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'INIT OUTPUT'
               GO TO 990
               END IF
            IPTRO = KBIND
            NIOUT = 0
            NIOLIM = ILENBU
C                                       Make sure there is data
            VCOUNT = 0
            NCOPY = LREC - NRPARM
C                                       Set lengths of input axes.
            NUMIF = 1
            IF (JLOCIF.GT.0) NUMIF = CATBLK(KINAX+JLOCIF)
C                                       make an index table
            CALL RNXGET (DISKIN, CNOIN, CATUV)
            CALL RNXINI (DISKOU, CNOOUT, CATBLK, RNXRET)
            END IF
C                                       Get a record
 50      CONTINUE
            CALL UVGET ('READ', RPARM, BUFF1, IRET)
C                                       Escape loop if no more data
C                                       for this source (IRET = -1)
            IF (IRET.EQ.-1) GO TO 90
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ INPUT'
               GO TO 990
               END IF
            VCOUNT = VCOUNT + 1
C                                       Call FLAGIT now
            IF (ILOCB.GE.0) THEN
               BASEN = RPARM(1+ILOCB)
               IA1 = BASEN / 256. + 0.1
               IA2 = BASEN - IA1*256. + 0.1
            ELSE
               IA1 = RPARM(1+ILOCA1) + 0.1
               IA2 = RPARM(1+ILOCA2) + 0.1
               END IF
C                                      Working on visibility number
C                                      NUMVIS
            NUMVIS = NUMVIS + 1
C                                      Call filtering routine
            IF (OPCODE.EQ.'MWFL') THEN
               CALL FLAGMW (NUMVIS, IA1, IA2, NA, NP, NC, NI, MALL,
     *            MBAD, MCBAD, MCHAN, BUFF1, RPARM, WASBAD, IRET)
            ELSE
               CALL FLAGIT (NUMVIS, IA1, IA2, NA, NP, NC, NI, MALL,
     *            MBAD, MCBAD, MCHAN, BUFF1, RPARM, WASBAD, IRET)
               END IF
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'FILTER SPECTRUM'
               GO TO 990
            ELSE IF ((IRET.EQ.0) .AND. (DOOUT)) THEN
               OCOUNT = OCOUNT + 1
               RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVWSC
               RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVWSC
               RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVWSC
               CALL RCOPY (NRPRIN, RPARM, BUFF2(IPTRO))
C                                       update NX table
               CALL RNXUPD (RPARM, RNXRET)
C                                       Compressed
               IF (ISCOMP) THEN
                  CALL ZUVPAK (NCOPY, BUFF1, BUFF2(IPTRO+ILOCWT),
     *               BUFF2(IPTRO+NRPARM))
               ELSE
                  CALL RCOPY (NCOPY, BUFF1, BUFF2(IPTRO+NRPARM))
                  END IF
               IPTRO = IPTRO + LREC
               NIOUT = NIOUT + 1
C                                       Write vis record.
               IF (NIOUT.GE.NIOLIM) THEN
                  CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *               IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'WRITE OUTPUT'
                     GO TO 990
                     END IF
                  IPTRO = KBIND
                  NIOUT = 0
                  END IF
            ELSE
               IF (IRET.EQ.0) OCOUNT = OCOUNT + 1
               IF (.NOT.DOOUT) THEN
                  CALL MAKEFG (LUN, LFGRNO, FGKOLS, FGNUMV, IA1, IA2,
     *               ISUB, REASON, BUFF1, RPARM, WASBAD, BUFFLG, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1000) IRET, 'WRITE FG TABLE'
                     GO TO 990
                     END IF
                  END IF
               END IF
            GO TO 50
C
 90      IF (DOOUT) THEN
            WRITE (MSGTXT,1110) VCOUNT, OCOUNT, 'written'
            CALL REFRMT (MSGTXT, '_', I)
            CALL MSGWRT (2)
         ELSE
            IRET = -99
            CALL MAKEFG (LUN, LFGRNO, FGKOLS, FGNUMV, IA1, IA2, ISUB,
     *         REASON, BUFF1, RPARM, WASBAD, BUFFLG, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'CLOSE FG TABLE'
               GO TO 990
               END IF
            WRITE (MSGTXT,1110) VCOUNT, OCOUNT, 'not completely flagged'
            CALL REFRMT (MSGTXT, '_', I)
            CALL MSGWRT (2)
            END IF
C                                       Close input file
         CALL UVGET ('CLOS', RPARM, BUFF1, IRET)
C                                       Finish write
         IF (DOOUT) THEN
            NIOUT = - NIOUT
            CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'FLUSH OUTPUT'
               GO TO 990
               END IF
            END IF
 100     CONTINUE
C                                       Compress output file.
      IRET = 0
      IF (DOOUT) THEN
         NVIS = OCOUNT
         CALL UCMPRS (NVIS, DISKOU, CNOOUT, LUNO, CATBLK, IRET)
C                                       close NX table
         IRET = 0
         CALL RNXCLS (RNXRET)
         IF (RNXRET.NE.0) THEN
            MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
            GO TO 990
            END IF
         I = NNCNT(1) + NNCNT(2) + NNCNT(3) + NNCNT(4) + NNCNT(5) +
     *      NNCNT(6) + NNCNT(9) + NNCNT(10)
         IF (I.LE.0) THEN
            MSGTXT = 'NO NEW DATA FLAGS FOUNDP'
            CALL MSGWRT (7)
            IRET = -99
            END IF
      ELSE IF (NFGWRI.LE.0) THEN
         MSGTXT = 'NO NEW FLAGS FOUND: NO FG TABLE WRITTEN'
         CALL MSGWRT (7)
         IRET = -99
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FLGIUV: ERROR',I5,' ON ',A,' FILE')
 1010 FORMAT ('Begin processing subarray',I4)
 1110 FORMAT (I10,' visibilities processed',I10,1X,A)
      END
      SUBROUTINE REPORT (NA, NP, NC, NI, MALL, MBAD, MCBAD, MCHAN)
C-----------------------------------------------------------------------
C   Print the reports
C   Inputs:
C      NA      I      Number of antennas
C      NP      I      Number of polarizations
C      NC      I      Number of channels
C      NI      I      Number of IFs
C      MALL    I(*)   Counts samples by baseline etc
C      MBAD    I(*)   Counts full bad spectra by baseline
C      MCBAD   I(*)   Counts bad channels by baseline
C      MCHAN   I(*)   Counts flags by channel
C-----------------------------------------------------------------------
      INTEGER   NA, NP, NC, NI, MALL(NA,NA,NP,NI), MBAD(NA,NA,NP,NI),
     *   MCBAD(NA,NA,NP,NI), MCHAN(NP,NC,NI)
C
      INTEGER   I, J, K, L, TOTALA, TOTALB, MMAX, MXA, I1, I2
      INCLUDE 'FLGIT.INC'
      INCLUDE 'INCS:DSEL.INC'
      INTEGER   MAUX(MAXANT)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       Report the news
      MSGTXT = 'Most of the following reports the sum of the incoming'
      CALL MSGWRT (2)
      MSGTXT = 'flags and those generated this time by FLGIT'
      CALL MSGWRT (2)
C                                       First add the totals
      DO 90 L = 1,NI
         DO 80 K = 1,NP
            TOTALA = 0
            TOTALB = 0
            MMAX = 0
            MXA = 0
            DO 20 I = 1,NA
               DO 10 J = 1,NA
                  IF (MALL(I,J,K,L).GT.0) THEN
                     MXA = MAX (MXA, I)
                     MXA = MAX (MXA, J)
                     TOTALA = TOTALA + MALL(I,J,K,L)
                     IF (MALL(I,J,K,L).GT.MMAX) MMAX = MALL(I,J,K,L)
                     END IF
                  TOTALB = TOTALB + MBAD(I,J,K,L)
 10               CONTINUE
 20            CONTINUE
C                                       Now report on all visibilities
            IF (TOTALA.GT.0) THEN
               I = L + BIF - 1
               WRITE (MSGTXT,1020) TOTALB, TOTALA, K, I
               CALL MSGWRT (4)
               WRITE(MSGTXT,1021) MMAX
               CALL MSGWRT (4)
               I1 = 1
 25            I2 = MIN (I1+27, MXA)
               IF (I2.GE.I1) THEN
                  WRITE (MSGTXT,1025) (J, J = I1,I2)
                  CALL MSGWRT (4)
                  DO 35 I= 1,MXA
                     DO 30 J= I1,I2
                        MAUX(J) = NINT ((10. * MALL(I,J,K,L)) / MMAX)
 30                     CONTINUE
                     WRITE (MSGTXT,1035) I, (MAUX(J), J = I1,I2)
                     CALL MSGWRT (4)
 35                  CONTINUE
                  I1 = I2 + 1
                  GO TO 25
                  END IF
C                                       Now report percentage flagged
               IF (TOTALB.GT.0) THEN
                  MSGTXT = 'Full spectra now flagged (percent):'
                  CALL MSGWRT (4)
                  I1 = 1
 40               I2 = MIN (I1+27, MXA)
                  IF (I2.GE.I1) THEN
                     WRITE (MSGTXT,1025) (J, J = I1,I2)
                     CALL MSGWRT (4)
                     DO 50 I = 1,MXA
                        DO 45 J = I1,I2
                           MAUX(J) = 0
                           IF (MALL(I,J,K,L).GT.0) THEN
                              MAUX(J) = NINT ((100. * MBAD(I,J,K,L)) /
     *                           MALL(I,J,K,L))
                           ELSE
                              MAUX(J) = 0
                              END IF
 45                        CONTINUE
                        WRITE (MSGTXT,1035) I, (MAUX(J), J = I1,I2)
                        CALL MSGWRT (4)
 50                     CONTINUE
                     I1 = I2 + 1
                     GO TO 40
                     END IF
                  END IF
C                                       Now report percentage flagged
               MSGTXT = 'Channels now flagged (percent):'
               CALL MSGWRT (4)
               I1 = 1
 55            I2 = MIN (I1+27, MXA)
               IF (I2.GE.I1) THEN
                  WRITE (MSGTXT,1025) (J, J = I1,I2)
                  CALL MSGWRT (4)
                  DO 65 I = 1,MXA
                     DO 60 J = I1,I2
                        MAUX(J) = 0
                        IF (MALL(I,J,K,L).GT.0) THEN
                           MAUX(J) = NINT ((100. * MCBAD(I,J,K,L)) /
     *                        (NCHAN * MALL(I,J,K,L)))
                        ELSE
                           MAUX(J) = 0
                           END IF
 60                     CONTINUE
                     WRITE (MSGTXT,1035) I, (MAUX(J), J = I1,I2)
                     CALL MSGWRT (4)
 65                  CONTINUE
                  I1 = I2 + 1
                  GO TO 55
                  END IF
C                                       Now report on channel triggers
               DO 70 I = 1,NCHAN
                  IF (MCHAN(I,K,L).GT.0) THEN
                     WRITE (MSGTXT,1060) I, MCHAN(I,K,L)
                     CALL MSGWRT (4)
                     END IF
 70               CONTINUE
               END IF
 80         CONTINUE
 90      CONTINUE
C                                       Report flagged correlators
      WRITE (MSGTXT,1090) NBDCOR
      CALL MSGWRT (4)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT (I8,' of',I10,' full spectra are now flagged for corr,IF',
     *   I2,I3)
 1021 FORMAT ('Visibilities per baseline (tens of percent of',I9,'):')
 1025 FORMAT (7X,28(I2))
 1035 FORMAT ('Ant',I3,1X,28(I2))
 1060 FORMAT ('Channel',I5,':',I9,' new flags')
 1090 FORMAT (I10,' full spectra are now flagged')
      END
      SUBROUTINE FLGIHI
C-----------------------------------------------------------------------
C   FLGIHI appends to the history file.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72
      INTEGER   LUN1, LUN2, IERR, I, NNS, J, K
      REAL      FRAC
      INCLUDE 'FLGIT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA LUN1, LUN2 /28, 29/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      IF (DOOUT) THEN
         CALL HISCOP (LUN1, LUN2, DISKIN, DISKOU, CNOIN, CNOOUT, CATBLK,
     *      BUFF1, BUFF2, IERR)
         IF (IERR.GT.2) THEN
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (6)
            GO TO 200
            END IF
C                                       FG table instead
      ELSE
         CALL HIOPEN (LUN2, DISKIN, CNOIN, BUFF2, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (6)
            GO TO 200
            END IF
         END IF
C                                       cal adverbs
      CALL CALHIS (LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Weights used
      DO 30 K = BIF,EIF
         DO 20 I = 1,20
            IF ((CHNSEL(1,I,K).GT.0) .AND.
     *         (CHNSEL(2,I,K).GE.CHNSEL(1,I,K))) THEN
               WRITE(HILINE,1120) TSKNAM, I, (CHNSEL(J,I,K), J = 1,3), K
               CALL HIADD (LUN2, HILINE, BUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
               END IF
 20         CONTINUE
 30      CONTINUE
C                                       method
      IF (OPCODE.NE.'MWFL') THEN
         HILINE = TSKNAM // '/ linear baseline fit over above channels'
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         WRITE (HILINE,1124) TSKNAM, NORDER
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
      ELSE
         WRITE (HILINE,1125) TSKNAM, MAXWIN
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         WRITE (HILINE,1126) TSKNAM, AVGWIN
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         END IF
C                                       FG table written
      IF (.NOT.DOOUT) THEN
         WRITE (HILINE,1127) TSKNAM, FGVERO
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         WRITE (HILINE,1128) TSKNAM, NFGWRI
         MSGTXT = HILINE(7:)
         CALL MSGWRT (3)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         END IF
C                                       fraction flagged
      NNS = NNCNT(9)
      NNCNT(6) = 2 * NNCNT(6)
      DO 125 I = 1,7
         NNS = NNS + NNCNT(I)
 125     CONTINUE
      NNCNT(8) = NNCNT(8) + NNS
      NNCNT(8) = MAX (1, NNCNT(8))
      FRAC = REAL (NNS) / REAL (NNCNT(8))
C                                       Threshold
      APARM(1) = SQRT (APARM(1))
      IF (APARM(1).LT.1.0E8) THEN
         WRITE (HILINE,1131) TSKNAM, NNCNT(1), APARM(1)
         MSGTXT = HILINE(9:)
         CALL MSGWRT (3)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         END IF
      APARM(6) = SQRT (APARM(6))
      IF (APARM(1).LT.1.0E8) THEN
         WRITE (HILINE,1132) TSKNAM, NNCNT(6), APARM(6)
         MSGTXT = HILINE(9:)
         CALL MSGWRT (3)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         END IF
      APARM(2) = SQRT (APARM(2))
      IF (APARM(2).LT.1.0E8) THEN
         WRITE (HILINE,1133) TSKNAM, NNCNT(2), APARM(2)
         MSGTXT = HILINE(9:)
         CALL MSGWRT (3)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         END IF
      APARM(3) = SQRT (APARM(3))
      IF (APARM(3).LT.1.0E8) THEN
         WRITE (HILINE,1134) TSKNAM, NNCNT(3), APARM(3)
         MSGTXT = HILINE(9:)
         CALL MSGWRT (3)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         END IF
      IF (OPCODE.NE.'MWFL') THEN
         WRITE (HILINE,1140) TSKNAM, NNCNT(4), APARM(4)
         MSGTXT = HILINE(9:)
         CALL MSGWRT (3)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         WRITE (HILINE,1141) TSKNAM, NNCNT(5), APARM(5)
         MSGTXT = HILINE(9:)
         CALL MSGWRT (3)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         END IF
      IF (APARM(9).GT.0.0) THEN
         WRITE (HILINE,1142) TSKNAM, NNCNT(9), APARM(9)
         MSGTXT = HILINE(9:)
         CALL MSGWRT (3)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         END IF
      WRITE (HILINE,1143) TSKNAM, NNCNT(7)
      MSGTXT = HILINE(9:)
      CALL MSGWRT (3)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
      IF (NNCNT(10).GT.0) THEN
         K = BPARM(2) + 0.1
         WRITE (HILINE,1145) TSKNAM, NNCNT(10), K
         MSGTXT = HILINE(9:)
         CALL MSGWRT (3)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         END IF
      WRITE (HILINE,1144) TSKNAM, FRAC
      MSGTXT = HILINE(9:)
      CALL MSGWRT (3)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                      Number of flagged correlators
      WRITE (HILINE,1146) TSKNAM, NBDCOR
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
C                                       Close HI file
 190  CALL HICLOS (LUN2, .TRUE., BUFF2, IERR)
C                                       Copy tables
 200  IF (DOOUT) CALL COPTAB (DISKIN, CNOIN, DISKOU, CNOOUT, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FLGIHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1120 FORMAT (A6,'CHNSEL(',I2.2,') =',I5,':',I5,' BY',I3,
     *   '  / fit region IF=',I3)
 1124 FORMAT (A6,'ORDER =',I2,6X,'/ order of polynomial fit')
 1125 FORMAT (A6,'MAXWIN =',I5,'  / channels max in median window')
 1126 FORMAT (A6,'AVGWIN =',I5,'  / channels averaged about median')
 1127 FORMAT (A6,'OUTFGVER=',I4,'  / output flag table version')
 1128 FORMAT (A6,'NFGREC=',I10,'  / flag table records written')
 1131 FORMAT (A6,'/ Flagged',I10,
     *   ' channels for input flux > clip level',1PE10.3)
 1132 FORMAT (A6,'/ Flagged',I10,
     *   ' channels for VPOL flux > clip level ',1PE10.3)
 1133 FORMAT (A6,'/ Flagged',I10,
     *   ' channels for residual fit flux >    ',1PE10.3)
 1134 FORMAT (A6,'/ Flagged',I10,
     *   ' channels for residual signal flux > ',1PE10.3)
 1140 FORMAT (A6,'/ Flagged',I10,
     *   ' channels for residual flux >',F6.2,'*RMS(f)')
 1141 FORMAT (A6,'/ Flagged',I10,
     *   ' channels for residual Re/Im >',F6.2,'*RMS(R/I)')
 1142 FORMAT (A6,'/ Flagged',I10,
     *   ' channels for U baseline   >',F8.1,' lambda')
 1143 FORMAT (A6,'/ Flagged',I10,
     *   ' channels previously or in calibration')
 1144 FORMAT (A6,'/ ',F6.4,' of the channels are now flagged')
 1145 FORMAT (A6,'/ Flagged',I10,' full spectra because >=',I4,
     *   ' channels flagged')
 1146 FORMAT (A6,'/ Full spectra flagged:', I8)
      END
      SUBROUTINE FLAGIT (NUMVIS, IA1, IA2, NA, NP, NC, NI, MALL, MBAD,
     *   MCBAD, MCHAN, VIS, RPARM, WASBAD, IRET)
C-----------------------------------------------------------------------
C   Routine to fit straight line to chosen channels, subtract and check
C   residual values.  *** IT FITS TO REAL AND IMAGINARY COMPONENTS ***
C   Inputs:
C      NUMVIS   I        Visibility number
C      IA1      I        First antenna number
C      IA2      I        Second antenna number
C      NA       I        Number of antennas
C      NP       I        Number of polarizations
C      NC       I        Number of channels
C      NI       I        Number of IFs
C      VIS      R(3,*)   Visibilities in order real, imaginary, weight
C                        (Jy, Jy, unitless).  Weight <= 0 => flagged.
C      RPARM    R(*)     Random parameter array
C   Inputs from COMMON:
C      BCHAN    I        Lowest channel number.
C      ECHAN    I        Highest channel number.
C      INCSI    I        Input Stokes' increment in vis.
C      INCFI    I        Input frequency increment in vis.
C      INCIFI   I        Input IF increment in vis.
C      CATBLK   I        Catalog header block
C      FITWTS   I(*)     Weights for fitting
C   Output:
C      MALL     I(*)     Counts samples by baseline etc
C      MBAD     I(*)     Counts full bad spectra by baseline
C      MCBAD    I(*)     Counts bad channels by baseline
C      MCHAN    I(*)     Counts flags by channel
C      WASBAD   I(*)     =1 if bad on input, -1 if not, matches VIS
C      IRET     I        Return code   0 => OK
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IA1, IA2, NA, NP, NC, NI, MALL(NA,NA,NP,NI),
     *   MBAD(NA,NA,NP,NI), MCBAD(NA,NA,NP,NI), MCHAN(NC,NP,NI),
     *   WASBAD(*), IRET
      REAL      VIS(3,*), RPARM(*)
C
      INCLUDE 'FLGIT.INC'
      INTEGER   LOOP, INDEX, OFF, IS, IIF, FITNUM, FLOOP, NRMS, NGOOD,
     *   IOFF, BPARM1, LL1, LL2, LBAD, LL, LI
      REAL      RESULT(2), FITRE(MAXCHA), FITIM(MAXCHA), FITCHA(MAXCHA),
     *   AR, BR, AI, BI, AMPLIT, AVGR, AVGI, VR, VI, FMS, FMS2, RMS,
     *   RMS2, IMS, CATUVR(256)
      LOGICAL   GOODDT, WILFLG, PTEST
      DOUBLE PRECISION FZ, FI, FRQMUL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (CATUVR, CATUV)
C-----------------------------------------------------------------------
      BPARM1 = BPARM(1) + 0.1
C                                       Set up on first call
      IF (NUMVIS.EQ.1) THEN
         NBDCOR = 0
         CALL FILL (9, 0, NNCNT)
         END IF
C                                       process data
      IRET = -1
      IF (NUMVIS.GT.0) THEN
         IF (MOD(NUMVIS-1,VISMSG).EQ.0) THEN
            WRITE (MSGTXT,1000) NUMVIS
            CALL MSGWRT (2)
         ELSE IF (MOD(NUMVIS-1,VISINC).EQ.0) THEN
            WRITE (MSGTXT,1000) NUMVIS
            CALL MSGWRT (1)
            END IF
C                                       Loop over IF, Stokes
         DO 90 IIF = 1,NIF
            IOFF = (IIF - 1) * NCHAN
            FZ = FOFF(IIF) / UVFREQ + 1.0D0
            FI = FINC(IIF) / UVFREQ
            DO 80 IS = 1,NPOLN
               NGOOD = 0
               FLOOP = 0
               PTEST = (IS.EQ.1) .AND. (NPOLN.GT.1) .AND.
     *            (APARM(6).GT.0.0)
C                                       Offset in Stokes and IF
               OFF = (IS - 1) * INCSI + (IIF - 1) * INCIFI
C                                       Index for this channel, IF
               INDEX = OFF + 1
               GOODDT = .FALSE.
               DO 5 LOOP = 1,NCHAN
                  IF (VIS(3,INDEX).GT.0.0) THEN
                     WASBAD(INDEX) = -1
                     GOODDT = .TRUE.
                  ELSE
                     WASBAD(INDEX) = 1
                     NNCNT(7) = NNCNT(7) + 1
                     END IF
                  INDEX = INDEX + INCFI
 5                CONTINUE
               INDEX = OFF + 1
               DO 10 LOOP = 1,NCHAN
                  IF (VIS(3,INDEX).GT.0.0) THEN
                     FRQMUL = 1.0D0
                     IF (TYPUVD.LE.0) FRQMUL = FZ + FI *
     *                  (LOOP - 1 + BCHAN - CATUVR(KRCRP+KLOCFY))
                     VR = VIS(1,INDEX)
                     VI = VIS(2,INDEX)
                     AMPLIT = VR*VR + VI*VI
                     IF (ABS(RPARM(1+ILOCU)*FRQMUL).LT.APARM(9)) THEN
                        NNCNT(9) = NNCNT(9) + 1
                        VIS(3,INDEX) = -VIS(3,INDEX)
                        MCHAN(LOOP,IS,IIF) = MCHAN(LOOP,IS,IIF) + 1
                     ELSE IF (AMPLIT.GT.APARM(1)) THEN
                        NNCNT(1) = NNCNT(1) + 1
                        LL1 = MAX (1, LOOP-BPARM1)
                        LL2 = MIN (NCHAN, LOOP+BPARM1)
                        DO 8 LL = LL1,LL2
                           LI = INDEX + (LL-LOOP) * INCFI
                           VIS(3,LI) = -ABS (VIS(3,LI))
                           MCHAN(LL,IS,IIF) = MCHAN(LL,IS,IIF) + 1
 8                         CONTINUE
                     ELSE IF ((PTEST) .AND. (VIS(3,INDEX+INCSI).GT.0.0))
     *                  THEN
                        VR = VR - VIS(1,INDEX+INCSI)
                        VI = VI - VIS(2,INDEX+INCSI)
                        AMPLIT = VR*VR + VI*VI
                        IF (AMPLIT.GT.APARM(6)) THEN
                           NNCNT(6) = NNCNT(6) + 1
                           LL1 = MAX (1, LOOP-BPARM1)
                           LL2 = MIN (NCHAN, LOOP+BPARM1)
                           DO 9 LL = LL1,LL2
                              LI = INDEX + (LL-LOOP) * INCFI
                              VIS(3,LI) = -ABS (VIS(3,LI))
                              VIS(3,LI+INCSI) = -ABS (VIS(3,LI+INCSI))
                              MCHAN(LL,IS,IIF) = MCHAN(LL,IS,IIF) + 2
 9                            CONTINUE
                           END IF
                        END IF
                     END IF
                  INDEX = INDEX + INCFI
 10               CONTINUE
C                                       Get arrays for line fitting
 15            FITNUM = 0
               INDEX = OFF + 1
               DO 20 LOOP = 1,NCHAN
                  IF (VIS(3,INDEX).GT.0.0) THEN
                     IF (FITWTS(LOOP+IOFF).GT.0) THEN
                        FITNUM = FITNUM + 1
                        FITRE(FITNUM) = VIS(1,INDEX)
                        FITIM(FITNUM) = VIS(2,INDEX)
                        FITCHA(FITNUM) = LOOP
                        END IF
                     END IF
                  INDEX = INDEX + INCFI
 20               CONTINUE
C                                       Some data to fit
               FLOOP = FLOOP + 1
               IF (FITNUM.GT.0) THEN
                  CALL LINFIT (NORDER, FITCHA, FITRE, FITNUM, AR, BR)
                  CALL LINFIT (NORDER, FITCHA, FITIM, FITNUM, AI, BI)
C                                       Now subtract from data
                  IF (FLOOP.LT.5) THEN
                     INDEX = OFF + 1
                     RMS = 0.0
                     FMS = 0.0
                     IMS = 0.0
                     NRMS = 0
                     DO 30 LOOP = 1,NCHAN
                        IF ((VIS(3,INDEX).GT.0.0) .AND.
     *                     (FITWTS(LOOP+IOFF).GT.0)) THEN
C                                       Interpolated value (re, imag)
                           AVGR = AR + BR * LOOP
                           AVGI = AI + BI * LOOP
C                                       Subtract from vis.
                           RESULT(1) = (VIS(1,INDEX) - AVGR) ** 2
                           RESULT(2) = (VIS(2,INDEX) - AVGI) ** 2
                           RMS = RMS + RESULT(1)
                           IMS = IMS + RESULT(2)
                           NRMS = NRMS + 1
                           END IF
                        INDEX = INDEX + INCFI
 30                     CONTINUE
                     FMS = RMS + IMS
                     RMS = MAX (RMS, IMS)
                     FMS2 = FMS
                     RMS2 = RMS
                     IF (NRMS.GT.0) THEN
                        FMS2 = (FMS / NRMS) * (APARM(4)**2)
                        FMS  = (FMS / NRMS) * ((1.414*(4-FLOOP) +
     *                     APARM(4))**2)
                        RMS2 = (RMS / NRMS) * (APARM(5)**2)
                        RMS  = (RMS / NRMS) * ((4-FLOOP + APARM(5))**2)
                        END IF
                     INDEX = OFF + 1
                     WILFLG = .FALSE.
                     DO 35 LOOP = 1,NCHAN
                        IF ((VIS(3,INDEX).GT.0.0) .AND.
     *                     (FITWTS(LOOP+IOFF).GT.0)) THEN
C                                       Interpolated value (re, imag)
                           AVGR = AR + BR * LOOP
                           AVGI = AI + BI * LOOP
C                                       Subtract from vis.
                           RESULT(1) = (VIS(1,INDEX) - AVGR) ** 2
                           RESULT(2) = (VIS(2,INDEX) - AVGI) ** 2
                           AMPLIT = RESULT(1) + RESULT(2)
                           AVGR = MAX (RESULT(1), RESULT(2))
C                                       clip on local rms
                           IF (AMPLIT.GT.FMS2) WILFLG = .TRUE.
                           IF (AVGR.GT.RMS2) WILFLG = .TRUE.
                           IF (AMPLIT.GT.FMS) THEN
                              NNCNT(4) = NNCNT(4) + 1
                              LL1 = MAX (1, LOOP-BPARM1)
                              LL2 = MIN (NCHAN, LOOP+BPARM1)
                              DO 33 LL = LL1,LL2
                                 LI = INDEX + (LL-LOOP) * INCFI
                                 MCHAN(LL,IS,IIF) = MCHAN(LL,IS,IIF)+1
                                 VIS(3,LI) = -ABS (VIS(3,LI))
 33                              CONTINUE
                           ELSE IF (AVGR.GT.RMS) THEN
                              NNCNT(5) = NNCNT(5) + 1
                              LL1 = MAX (1, LOOP-BPARM1)
                              LL2 = MIN (NCHAN, LOOP+BPARM1)
                              DO 34 LL = LL1,LL2
                                 LI = INDEX + (LL-LOOP) * INCFI
                                 MCHAN(LL,IS,IIF) = MCHAN(LL,IS,IIF)+1
                                 VIS(3,LI) = -ABS (VIS(3,LI))
 34                              CONTINUE
                              END IF
                           END IF
                        INDEX = INDEX + INCFI
 35                     CONTINUE
                     IF (.NOT.WILFLG) FLOOP = 5
                     GO TO 15
                  ELSE
                     INDEX = OFF + 1
                     DO 40 LOOP = 1,NCHAN
                        IF (VIS(3,INDEX).GT.0.0) THEN
C                                       Interpolated value (re, imag)
                           AVGR = AR + BR * LOOP
                           AVGI = AI + BI * LOOP
C                                       Subtract from vis.
                           RESULT(1) = (VIS(1,INDEX) - AVGR) ** 2
                           RESULT(2) = (VIS(2,INDEX) - AVGI) ** 2
                           AMPLIT = RESULT(1) + RESULT(2)
C                                       Scale by integration time
                           IF (FITWTS(LOOP+IOFF).GT.0) THEN
                              IF (AMPLIT*VIS(3,INDEX).GT.APARM(2)) THEN
                                 NNCNT(2) = NNCNT(2) + 1
                                 LL1 = MAX (1, LOOP-BPARM1)
                                 LL2 = MIN (NCHAN, LOOP+BPARM1)
                                 DO 38 LL = LL1,LL2
                                    LI = INDEX + (LL-LOOP) * INCFI
                                    MCHAN(LL,IS,IIF) = MCHAN(LL,IS,IIF)
     *                                 + 1
                                    VIS(3,LI) = -ABS (VIS(3,LI))
 38                                 CONTINUE
                                 END IF
                           ELSE
                              IF (AMPLIT.GT.APARM(3)) THEN
                                 NNCNT(3) = NNCNT(3) + 1
                                 LL1 = MAX (1, LOOP-BPARM1)
                                 LL2 = MIN (NCHAN, LOOP+BPARM1)
                                 DO 39 LL = LL1,LL2
                                    LI = INDEX + (LL-LOOP) * INCFI
                                    MCHAN(LL,IS,IIF) = MCHAN(LL,IS,IIF)
     *                                 + 1
                                    VIS(3,LI) = -ABS (VIS(3,LI))
 39                                 CONTINUE
                                 END IF
                              END IF
                           END IF
                        INDEX = INDEX + INCFI
 40                     CONTINUE
                     END IF
                  END IF
               LBAD = 0
               INDEX = OFF + 1
               DO 45 LOOP = 1,NCHAN
                  IF (VIS(3,INDEX).LE.0) LBAD = LBAD + 1
                  INDEX = INDEX + INCFI
 45               CONTINUE
               IF (LBAD.GE.BPARM(2)) THEN
                  NNCNT(10) = NNCNT(10) + 1
                  INDEX = OFF + 1
                  DO 50 LOOP = 1,NCHAN
                     VIS(3,INDEX) = -ABS (VIS(3,INDEX))
                     INDEX = INDEX + INCFI
 50                  CONTINUE
               ELSE
                  INDEX = OFF + 1
                  DO 55 LOOP = 1,NCHAN
                     IF (VIS(3,INDEX).GT.0) THEN
                        NNCNT(8) = NNCNT(8) + 1
                        NGOOD = NGOOD + 1
                        END IF
                     INDEX = INDEX + INCFI
 55                  CONTINUE
                  END IF
C                                       Increase corresponding counter
               MALL(IA1,IA2,IS,IIF) = MALL(IA1,IA2,IS,IIF)+1
               MCBAD(IA1,IA2,IS,IIF) = MCBAD(IA1,IA2,IS,IIF) + NCHAN -
     *            NGOOD
C                                       Now flag everything if needed
               IF (NGOOD.EQ.0)  THEN
C                                       Increase corresponding counters
                  NBDCOR = NBDCOR + 1
                  MBAD(IA1,IA2,IS,IIF) = MBAD(IA1,IA2,IS,IIF)+1
               ELSE IF (GOODDT) THEN
                  IRET = 0
                  END IF
 80            CONTINUE
 90         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Working on visibility record ', I8)
      END
      SUBROUTINE LINFIT (N, X, Y, NDATA, A, B)
C-----------------------------------------------------------------------
C     Routine to fit straight line
C-----------------------------------------------------------------------
      REAL      X(*), Y(*), A, B
      INTEGER   N, NDATA
C
      DOUBLE PRECISION SX, SY, SXY, SYY, SXX
      INTEGER  I
      REAL     DELTA
C-----------------------------------------------------------------------
      SX = 0.D0
      SY = 0.D0
      SXX = 0.D0
      SXY = 0.D0
      SYY = 0.D0
C
      DO 100 I = 1,NDATA
         SY = SY + Y(I)
         IF (N.GT.0) THEN
            SX = SX + X(I)
            SXX = SXX + X(I) * X(I)
            SXY = SXY + X(I) * Y(I)
            SYY = SYY + Y(I) * Y(I)
            END IF
 100     CONTINUE
C
      A = 0.
      B = 0.
      IF ((NDATA.GT.2) .AND. (N.GT.0)) THEN
         DELTA = NDATA * SXX - SX * SX
         IF (DELTA.GT.0) THEN
            A = ( SXX * SY - SX * SXY ) / DELTA
            B = ( SXY * NDATA - SX * SY ) / DELTA
            END IF
      ELSE IF ((NDATA.GT.0) .AND. (N.EQ.0)) THEN
         A = SY / NDATA
         END IF
C
 999  RETURN
      END
      SUBROUTINE FLAGMW (NUMVIS, IA1, IA2, NA, NP, NC, NI, MALL, MBAD,
     *   MCBAD, MCHAN, VIS, RPARM, WASBAD, IRET)
C-----------------------------------------------------------------------
C   Routine to fit median window to chosen channels, subtract and check
C   residual values.  *** IT FITS TO REAL AND IMAGINARY COMPONENTS ***
C   Inputs:
C      NUMVIS   I        Visibility number
C      IA1      I        First antenna number
C      IA2      I        Second antenna number
C      NA       I        Number of antennas
C      NP       I        Number of polarizations
C      NC       I        Number of channels
C      NI       I        Number of IFs
C      VIS      R(3,*)   Visibilities in order real, imaginary, weight
C                        (Jy, Jy, unitless).  Weight <= 0 => flagged.
C      RPARM    R(*)     Random parameter array
C   Inputs from COMMON:
C      BCHAN    I        Lowest channel number.
C      ECHAN    I        Highest channel number.
C      INCSI    I        Input Stokes' increment in vis.
C      INCFI    I        Input frequency increment in vis.
C      INCIFI   I        Input IF increment in vis.
C      CATBLK   I        Catalog header block
C      FITWTS   I(*)     Weights for fitting
C   Output:
C      MALL     I(*)     Counts samples by baseline etc
C      MBAD     I(*)     Counts full bad spectra by baseline
C      MCBAD    I(*)     Counts bad channels by baseline
C      MCHAN    I(*)     Counts flags by channel
C      WASBAD   I(*)     =1 if bad on input, -1 if not, matches VIS
C      IRET     I        Return code   0 => OK
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IA1, IA2, NA, NP, NC, NI, MALL(NA,NA,NP,NI),
     *   MBAD(NA,NA,NP,NI), MCBAD(NA,NA,NP,NI), MCHAN(NC,NP,NI),
     *   WASBAD(*), IRET
      REAL      VIS(3,*), RPARM(*)
C
      INCLUDE 'FLGIT.INC'
      INTEGER   LOOP, INDEX, OFF, IS, IIF, FITNUM, NGOOD, IOFF, BPARM1,
     *   LL, LL1, LL2, LBAD, LI
      REAL      RESULT(2), FITRE(MAXCHA), FITIM(MAXCHA), AMPLIT, VR, VI,
     *   CATUVR(256)
      LOGICAL   GOODDT, PTEST
      DOUBLE PRECISION FZ, FI, FRQMUL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATUVR, CATUV)
C-----------------------------------------------------------------------
      BPARM1 = BPARM(1) + 0.1
C                                       Set up on first call
      IF (NUMVIS.EQ.1) THEN
         NBDCOR = 0
         CALL FILL (9, 0, NNCNT)
         END IF
C                                       process data
      IRET = -1
      IF (NUMVIS.GT.0) THEN
         IF (MOD(NUMVIS-1,VISMSG).EQ.0) THEN
            WRITE (MSGTXT,1000) NUMVIS
            CALL MSGWRT (2)
         ELSE IF (MOD(NUMVIS-1,VISINC).EQ.0) THEN
            WRITE (MSGTXT,1000) NUMVIS
            CALL MSGWRT (1)
            END IF
C                                       Loop over IF, Stokes
         DO 90 IIF = 1,NIF
            IOFF = (IIF - 1) * NCHAN
            FZ = FOFF(IIF) / UVFREQ + 1.0D0
            FI = FINC(IIF) / UVFREQ
            DO 80 IS = 1,NPOLN
               NGOOD = 0
               PTEST = (IS.EQ.1) .AND. (NPOLN.GT.1) .AND.
     *            (APARM(6).GT.0.0)
C                                       Offset in Stokes and IF
               OFF = (IS - 1) * INCSI + (IIF - 1) * INCIFI
C                                       Index for this channel, IF
               INDEX = OFF + 1
               GOODDT = .FALSE.
               DO 5 LOOP = 1,NCHAN
                  IF (VIS(3,INDEX).GT.0.0) THEN
                     WASBAD(INDEX) = -1
                     GOODDT = .TRUE.
                  ELSE
                     WASBAD(INDEX) = 1
                     NNCNT(7) = NNCNT(7) + 1
                     END IF
                  INDEX = INDEX + INCFI
 5                CONTINUE
               INDEX = OFF + 1
               DO 10 LOOP = 1,NCHAN
                  IF (VIS(3,INDEX).GT.0.0) THEN
                     FRQMUL = 1.0D0
                     IF (TYPUVD.LE.0) FRQMUL = FZ + FI *
     *                  (LOOP - 1 + BCHAN - CATUVR(KRCRP+KLOCFY))
                     VR = VIS(1,INDEX)
                     VI = VIS(2,INDEX)
                     AMPLIT = VR*VR + VI*VI
                     IF (ABS(RPARM(1+ILOCU)*FRQMUL).LT.APARM(9)) THEN
                        NNCNT(9) = NNCNT(9) + 1
                        VIS(3,INDEX) = -VIS(3,INDEX)
                        MCHAN(LOOP,IS,IIF) = MCHAN(LOOP,IS,IIF) + 1
                     ELSE IF (AMPLIT.GT.APARM(1)) THEN
                        LL1 = MAX (1, LOOP-BPARM1)
                        LL2 = MIN (NCHAN, LOOP+BPARM1)
                        NNCNT(1) = NNCNT(1) + 1
                        DO 8 LL = LL1,LL2
                           LI = INDEX + (LL-LOOP) * INCFI
                           VIS(3,LI) = -ABS (VIS(3,LI))
                           MCHAN(LL,IS,IIF) = MCHAN(LL,IS,IIF) + 1
 8                         CONTINUE
                        ELSE IF ((PTEST) .AND.
     *                     (VIS(3,INDEX+INCSI).GT.0.0)) THEN
                        VR = VR - VIS(1,INDEX+INCSI)
                        VI = VI - VIS(2,INDEX+INCSI)
                        AMPLIT = VR*VR + VI*VI
                        IF (AMPLIT.GT.APARM(6)) THEN
                           LL1 = MAX (1, LOOP-BPARM1)
                           LL2 = MIN (NCHAN, LOOP+BPARM1)
                           NNCNT(6) = NNCNT(6) + 1
                           DO 9 LL = LL1,LL2
                              LI = INDEX + (LL-LOOP) * INCFI
                              VIS(3,LI) = -ABS (VIS(3,LI))
                              VIS(3,LI+INCSI) = -ABS (VIS(3,LI+INCSI))
                              MCHAN(LL,IS,IIF) = MCHAN(LL,IS,IIF) + 2
 9                            CONTINUE
                           END IF
                        END IF
                     END IF
                  INDEX = INDEX + INCFI
 10               CONTINUE
C                                       Get arrays for line fitting
               FITNUM = 0
               INDEX = OFF + 1
               DO 20 LOOP = 1,NCHAN
                  IF (VIS(3,INDEX).LE.0.0) THEN
                     FITRE(LOOP) = FBLANK
                     FITIM(LOOP) = FBLANK
                  ELSE
                     FITNUM = FITNUM + 1
                     FITRE(LOOP) = VIS(1,INDEX)
                     FITIM(LOOP) = VIS(2,INDEX)
                     END IF
                  INDEX = INDEX + INCFI
 20               CONTINUE
C                                       Subt
               IF (FITNUM.GT.0) THEN
                  CALL MWFILT (NCHAN, MAXWIN, AVGWIN, FITRE)
                  CALL MWFILT (NCHAN, MAXWIN, AVGWIN, FITIM)
                  INDEX = OFF + 1
                  DO 40 LOOP = 1,NCHAN
                     IF (VIS(3,INDEX).GT.0.0) THEN
                        RESULT(1) = FITRE(LOOP) ** 2
                        RESULT(2) = FITIM(LOOP) ** 2
                        AMPLIT = RESULT(1) + RESULT(2)
C                                       Scale by integration time
                        IF (FITWTS(LOOP+IOFF).GT.0) THEN
                           IF (AMPLIT*VIS(3,INDEX).GT.APARM(2)) THEN
                              LL1 = MAX (1, LOOP-BPARM1)
                              LL2 = MIN (NCHAN, LOOP+BPARM1)
                              NNCNT(2) = NNCNT(2) + 1
                              DO 30 LL = LL1,LL2
                                 LI = INDEX + (LL-LOOP) * INCFI
                                 MCHAN(LL,IS,IIF) = MCHAN(LL,IS,IIF)+1
                                 VIS(3,LI) = -ABS (VIS(3,LI))
 30                              CONTINUE
                              END IF
                        ELSE
                           IF (AMPLIT.GT.APARM(3)) THEN
                              LL1 = MAX (1, LOOP-BPARM1)
                              LL2 = MIN (NCHAN, LOOP+BPARM1)
                              NNCNT(3) = NNCNT(3) + 1
                              DO 35 LL = LL1,LL2
                                 LI = INDEX + (LL-LOOP) * INCFI
                                 VIS(3,LI) = -ABS (VIS(3,LI))
                                 MCHAN(LL,IS,IIF) = MCHAN(LL,IS,IIF)+1
 35                              CONTINUE
                              END IF
                           END IF
                        END IF
                     INDEX = INDEX + INCFI
 40                  CONTINUE
                  END IF
               LBAD = 0
               INDEX = OFF + 1
               DO 45 LOOP = 1,NCHAN
                  IF (VIS(3,INDEX).LE.0) LBAD = LBAD + 1
                  INDEX = INDEX + INCFI
 45               CONTINUE
               IF (LBAD.GE.BPARM(2)) THEN
                  NNCNT(10) = NNCNT(10) + 1
                  INDEX = OFF + 1
                  DO 50 LOOP = 1,NCHAN
                     VIS(3,INDEX) = -ABS (VIS(3,INDEX))
                     INDEX = INDEX + INCFI
 50                  CONTINUE
               ELSE
                  INDEX = OFF + 1
                  DO 55 LOOP = 1,NCHAN
                     IF (VIS(3,INDEX).GT.0) THEN
                        NNCNT(8) = NNCNT(8) + 1
                        NGOOD = NGOOD + 1
                        END IF
                     INDEX = INDEX + INCFI
 55                  CONTINUE
                  END IF
C                                       Increase corresponding counter
               MALL(IA1,IA2,IS,IIF) = MALL(IA1,IA2,IS,IIF)+1
               MCBAD(IA1,IA2,IS,IIF) = MCBAD(IA1,IA2,IS,IIF) +
     *            NCHAN - NGOOD
C                                       Now flag everything if needed
               IF (NGOOD.EQ.0)  THEN
C                                       Increase corresponding counters
                  NBDCOR = NBDCOR + 1
                  MBAD(IA1,IA2,IS,IIF) = MBAD(IA1,IA2,IS,IIF)+1
               ELSE IF (GOODDT) THEN
                  IRET = 0
                  END IF
 80            CONTINUE
 90         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Working on visibility record ', I8)
      END
      SUBROUTINE MWFILT (NX, NW, NA, VALS)
C-----------------------------------------------------------------------
C   Runs a median window filter through a row of data subtracting the
C   median from the row.
C   Input:
C      NX     I      Number of points in VALS
C      NW     I      Width of filter
C      NA     I      Channels to average
C   In/out:
C      VALS   R(*)   Data row
C-----------------------------------------------------------------------
      INTEGER   NX, NW, NA
      REAL      VALS(*)
C
      INTEGER   MAXW
      PARAMETER (MAXW=127)
      INTEGER   IL(MAXW), I, NL, IH, LA
      REAL      DL(MAXW), RESULT
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      NL = 0
      NW = MIN (MAXW, NW)
      IF (NW.LT.3) NW = 5
      LA = MAX (1, MIN (NA, NW-2))
      IH = NW / 2
C                                       roll 1/2 window in
      DO 10 I = 1,IH
         IF (VALS(I).NE.FBLANK) THEN
            CALL MWMERG (NW, LA, -1, VALS(I), NL, DL, IL, RESULT)
         ELSE
            CALL MWMERG (NW, LA, -2, VALS(I), NL, DL, IL, RESULT)
            END IF
 10      CONTINUE
C                                       loop over row
      DO 20 I = 1,NX
         IF ((I.GT.NX-IH) .OR. (VALS(I+IH).EQ.FBLANK)) THEN
            CALL MWMERG (NW, LA, 0, VALS(I+IH), NL, DL, IL, RESULT)
         ELSE
            CALL MWMERG (NW, LA, 1, VALS(I+IH), NL, DL, IL, RESULT)
            END IF
         IF (VALS(I).NE.FBLANK) VALS(I) = VALS(I) - RESULT
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE MWMERG (NW, NV, NA, DA, NL, DL, IL, RESULT)
C-----------------------------------------------------------------------
C   merges a new value into a sorted list decrementing the
C   corresponding counter list and returning the median value
C   Inputs:
C      NW       I      Window full width
C      NV       I      Number central values (max) to average
C      NA       I      Number values to insert (0, or 1), -1 => insert
C                      one no result returned, -2 no result no insert
C      DA       R      Value to insert
C   In/out:
C      NL       I      Current list length
C      DL       R(*)   ordered list
C      IL       I      number times used so far from list
C   Output:
C      RESULT   R      median value
C-----------------------------------------------------------------------
      INTEGER   NW, NA, NL, NV, IL(*)
      REAL      DA, DL(*), RESULT
C
      INTEGER   I, J, K, J1, J2, LV
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       decrement entries
      IF (NL.GT.0) THEN
         J = 0
         DO 10 I = 1,NL
            IL(I) = IL(I) - 1
            IF (IL(I).EQ.0) J = I
 10         CONTINUE
C                                       squeeze it out
         IF (J.GT.0) THEN
            J = J + 1
            DO 20 I = J,NL
               DL(I-1) = DL(I)
               IL(I-1) = IL(I)
 20            CONTINUE
            NL = NL - 1
            END IF
         END IF
C                                       insert datum
      IF (ABS(NA).EQ.1) THEN
         J = 0
C                                       find place in list
         IF (NL.GT.0) THEN
            DO 30 I = 1,NL
               IF (DA.GT.DL(I)) J = I
 30            CONTINUE
C                                       make room
            DO 40 I = 1,NL-J
               K = NL + 1 - I
               DL(K+1) = DL(K)
               IL(K+1) = IL(K)
 40            CONTINUE
            END IF
         DL(J+1) = DA
         IL(J+1) = NW
         NL = NL + 1
         END IF
C                                       return value
      RESULT = FBLANK
      IF ((NA.GE.0) .AND. (NL.GT.0)) THEN
         J = (NL + 1) / 2
         LV = MAX (1, MIN (NL-1, NV))
         K = LV / 2
         RESULT = 0.0
         IF (MOD(NL,2).EQ.1) THEN
            IF (MOD(LV,2).EQ.1) THEN
               J1 = J - K
               J2 = J + K
            ELSE
               RESULT = (DL(J-K) + DL(J+K)) / 2.0
               J1 = J - K + 1
               J2 = J + K - 1
               END IF
         ELSE
            IF (MOD(LV,2).EQ.1) THEN
               RESULT = (DL(J-K) + DL(J+K+1)) / 2.0
               J1 = J - K + 1
               J2 = J + K
            ELSE
               J1 = J - K + 1
               J2 = J + K
               END IF
            END IF
         DO 50 I = J1,J2
            RESULT = RESULT + DL(I)
 50         CONTINUE
         RESULT = RESULT / LV
         END IF
C
 999  RETURN
      END
      SUBROUTINE MAKEFG (LUN, LFGRNO, FGKOLS, FGNUMV, IA1, IA2, ISUB,
     *   REASON, VIS, RPARM, WASBAD, BUFFLG, IRET)
C-----------------------------------------------------------------------
C   Writes one or more FG table entries for current record
C   Inputs:
C      LUN      I        LUN to use
C      IA1      I        Antenna 1
C      IA2      I        Antenna 2
C      ISUB     I        Subarray
C      REASON   C*24     Reason string
C      VIS      R(3,*)   Visibilities with output flagging
C      RPARM    R(*)     Random parms
C      WASBAD   I(*)     Which were bad before FLGIT
C   In/Out:
C      LFGRNO   I        Record number onto FG table
C      FGKOLS   I(*)     FG table column pointers
C      FGNUMV   I(*)     FG table number parms /column
C      BUFFLG   I(512)   FG table IO buffer
C      IRET     I        Input: -1 => full record to be flagged
C                              -99 => close FG table
C                        Output: FG I/O error ccode
C-----------------------------------------------------------------------
      INTEGER   LUN, LFGRNO, FGKOLS(*), FGNUMV(*), IA1, IA2, ISUB,
     *   WASBAD(*), BUFFLG(512), IRET
      CHARACTER REASON*(*)
      REAL      VIS(3,*), RPARM(*)
C
      INCLUDE 'FLGIT.INC'
      INTEGER   LOOP, INDEX, OFF, IS, IIF, IDS, LS, LBC, LEC, LIF, JS,
     *   JSM, JX
      REAL      BT, ET, EPS
      LOGICAL   PFLAGS(4), DOFL
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA EPS /1.11574E-6/
C-----------------------------------------------------------------------
      IDS = 0
      IF (ILOCSU.GE.0) IDS = RPARM(1+ILOCSU)
      IF (IDS.LE.0) IDS = SOUWAN(1)
      BT = RPARM(1+ILOCT) - EPS
      ET = RPARM(1+ILOCT) + EPS
C                                       close
      IF (IRET.EQ.-99) THEN
         IF (NFGWRI.GT.0) THEN
            CALL FLAGFG ('CLOS', LUN, DISKIN, CNOIN, FGVERI, FGVERO,
     *         LFGRNO, FGKOLS, FGNUMV, IDS, ISUB, FRQSEL, IA1, IA2, BT,
     *         ET, 0, 0, 0, 0, PFLAGS, REASON, CATUV, BUFFLG, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'CLOS'
               CALL MSGWRT (8)
               END IF
         ELSE
            IRET = 0
            END IF
C                                       flag all
      ELSE IF (IRET.LT.0) THEN
         CALL LFILL (4, .TRUE., PFLAGS)
         CALL FLAGFG ('FLAG', LUN, DISKIN, CNOIN, FGVERI, FGVERO,
     *      LFGRNO, FGKOLS, FGNUMV, IDS, ISUB, FRQSEL, IA1, IA2, BT, ET,
     *      0, 0, 0, 0, PFLAGS, REASON, CATUV, BUFFLG, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'FLAG'
            CALL MSGWRT (8)
            END IF
         NFGWRI = NFGWRI + 1
C                                       flag some
      ELSE
C                                       Loop over IF, Stokes
         DO 90 IS = 1,NPOLN
            LS = ABS (ICOR0) + IS - 1
            CALL LFILL (4, .FALSE., PFLAGS)
            PFLAGS(LS) = .TRUE.
            JSM = 0
            IF (APARM(10).GT.0) THEN
               IF ((LS.EQ.1) .OR. ((LS.EQ.2) .AND. (ICOR0.LT.0))) THEN
                  PFLAGS(3) = .TRUE.
                  PFLAGS(4) = .TRUE.
                  IF (ICOR0.GT.0) PFLAGS(2) = .TRUE.
                  JSM = ABS (ICOR0) + NPOLN - 1
                  END IF
               END IF
            DO 80 IIF = 1,NIF
               LIF = IIF + BIF - 1
C                                       Offset in Stokes and IF
               OFF = (IS - 1) * INCSI + (IIF - 1) * INCIFI
C                                       Index for this channel, IF
               INDEX = OFF + 1
               DOFL = .FALSE.
               DO 70 LOOP = 1,NCHAN
                  IF (DOFL) THEN
                     IF (VIS(3,INDEX).LE.0.0) THEN
                        LEC = LOOP + BCHAN - 1
                        DO 10 JS = LS+1,JSM
                           JX = INDEX + (JS - LS) * INCSI
                           IF (PFLAGS(JS)) WASBAD(JX) = MAX (0,
     *                        WASBAD(JX))
 10                        CONTINUE
                     ELSE
                        CALL FLAGFG ('FLAG', LUN, DISKIN, CNOIN, FGVERI,
     *                     FGVERO, LFGRNO, FGKOLS, FGNUMV, IDS, ISUB,
     *                     FRQSEL, IA1, IA2, BT, ET, LIF, LIF, LBC, LEC,
     *                     PFLAGS, REASON, CATUV, BUFFLG, IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1000) IRET, 'FLAG'
                           CALL MSGWRT (8)
                           GO TO 999
                           END IF
                        NFGWRI = NFGWRI + 1
                        DOFL = .FALSE.
                        END IF
                  ELSE IF ((VIS(3,INDEX).LE.0.0) .AND.
     *               (WASBAD(INDEX).LT.0)) THEN
                     DOFL = .TRUE.
                     LBC = LOOP + BCHAN - 1
                     LEC = LBC
                     DO 20 JS = LS+1,JSM
                        JX = INDEX + (JS - LS) * INCSI
                        IF (PFLAGS(JS)) WASBAD(JX) = MAX (0, WASBAD(JX))
 20                     CONTINUE
                     END IF
                  INDEX = INDEX + INCFI
 70               CONTINUE
 80            CONTINUE
 90         CONTINUE
         END IF
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MAKEFG: FLAGFG RETURNS ERROR CODE',I5,' ON ',A)
      END
      SUBROUTINE FLAGFG (OPCODE, LUN, DISK, CNO, VERI, VER, LFGRNO,
     *   FGKOLS, FGNUMV, ID, SUBA, FQID, ANT1, ANT2, BTIME, ETIME, BIF,
     *   EIF, BCHAN, ECHAN, PFLAGS, REASON, CATUV, BUFF, IRET)
C-----------------------------------------------------------------------
C   Updates the Flag (FG) table. Adapted from FLAGUP
C   One entry is made indicating a visibility to be rejected.
C   The FLAG table will be opened on the first call but a final call
C   with OPCODE='CLOS' is required to close the file.
C   Inputs:
C      OPCODE   C*4      Operation desired, 'CLOS'=>close file
C                        Anything else = 'FLAG'
C      LUN      I        Logical unit number to use
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      VERI     I        Input version number
C      VER      I        FG file version
C      ID       I        Source ID as defined in SOURCE table
C      SUBA     I        Subarray number.
C      FQID     I        Freqid number
C      ANT1     I        First antenna number in baseline
C      ANT2     I        Second antenna number in baseline
C      BTIME    R        Start time of data to be flagged (Days)
C      ETIME    R        End time of data to be flagged (Days)
C      BIF      I        First IF number to flag. 0=>all
C      EIF      I        Last IF number to flag. 0=>all higher than IFS(1)
C      BCHAN    I        First channel number to flag. 0=>all
C      ECHAN    I        Last channel number to flag. 0=>all higher.
C      PFLAGS   L(4)     Correlator flags
C      REASON   C*24     Reason for flagging blank => ignore for unflag.
C   Input/Output:
C      LFGRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      FGKOLS   I(*)     The column pointer array in order, SOURCE,
C                        SUBARRAY, ANTS, TIMERANG, IFS, CHANS, PFLAGS,
C                        REASON
C      FGNUMV   I(*)     Element count in each column.
C      CATUV    I(256)   Header for disk file to get FG table
C      BUFF     I(512)   I/O buffer and related storage, also defines
C                        file if open.
C   Output:
C      IRET     I        Error code, 0=>OK else TABIO error.
C                        Note: -1 => read, but record deselected.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, REASON*24
      INTEGER   LUN, DISK, CNO, VERI, VER, LFGRNO, FGKOLS(*), FGNUMV(*),
     *   ID, SUBA, FQID, ANT1, ANT2, BIF, EIF, BCHAN, ECHAN, CATUV(256),
     *   BUFF(*), IRET
      REAL      BTIME, ETIME
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER TREAS*24, CTEMP*12
      INTEGER   IDT, SUBT, ANTS(2), IFS(2), CHANS(2), IDUM, FIND, I,
     *   BUFF2(512), LUN2, IFGKOL(MAXFGC), IFGNUM(MAXFGC), NROW, IFQ,
     *   IFGRNO
      LOGICAL   PFLAGS(4), TFLAGS(4), FIRST
      REAL      TIMER(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      SAVE FIRST
      DATA FIRST /.TRUE./
C-----------------------------------------------------------------------
C                                       See if table open - check FTAB
      IF (OPCODE.NE.'CLOS') THEN
         FIND = BUFF(82)
C                                       Open file
         IF ((FIND.LT.0) .OR. (FIND.GT.10000) .OR. (LUN.NE.FTAB(FIND)))
     *      THEN
            CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV',
     *         IDUM, 'CLRD', BUFF, IRET)
            CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV',
     *         IDUM, 'WRIT', BUFF, IRET)
C
            CALL FLGINI ('WRIT', BUFF, DISK, CNO, VER, CATUV, LUN,
     *         LFGRNO, FGKOLS, FGNUMV, IRET)
C                                       Report on the need for flagging
            WRITE (MSGTXT,1000) VER
            IF (.NOT.FIRST) WRITE (MSGTXT,1001) VER
            CALL MSGWRT (2)
            IF (IRET.NE.0) GO TO 999
C                                       Copy the old file
            IF ((FIRST) .AND. (VERI.GT.0)) THEN
               LUN2 = LUN + 1
               CALL FLGINI ('READ', BUFF2, DISK, CNO, VERI, CATUV, LUN2,
     *            IFGRNO, IFGKOL, IFGNUM, IRET)
               IF (IRET.NE.0) GO TO 999
               NROW = BUFF2(5)
               WRITE (MSGTXT,1002) NROW, VERI, VER
               CALL MSGWRT (2)
               DO 20 I = 1,NROW
                  CALL TABFLG ('READ', BUFF2, IFGRNO, IFGKOL, IFGNUM,
     *               IDT, SUBT, IFQ, ANTS, TIMER, IFS, CHANS, TFLAGS,
     *               TREAS, IRET)
                  IF (IRET.GT.0) GO TO 999
                  IF (IRET.EQ.0) THEN
                     CALL TABFLG ('WRIT', BUFF, LFGRNO, FGKOLS, FGNUMV,
     *                  IDT, SUBT, IFQ, ANTS, TIMER, IFS, CHANS, TFLAGS,
     *                  TREAS, IRET)
                     IF (IRET.NE.0) GO TO 999
                     END IF
 20               CONTINUE
               CALL TABIO ('CLOS', 0, IFGRNO, BUFF2, BUFF2, I)
               END IF
            FIRST = .FALSE.
C                                       Mark as unsorted
            BUFF(43) = 0
            BUFF(44) = 0
            END IF
C                                       Set up for flagging
         ANTS(1) = ANT1
         ANTS(2) = ANT2
         TIMER(1) = BTIME
         TIMER(2) = ETIME
         IFS(1) = BIF
         IFS(2) = EIF
         CHANS(1) = BCHAN
         CHANS(2) = ECHAN
C                                       Flag table entry.
         CALL TABFLG ('WRIT', BUFF, LFGRNO, FGKOLS, FGNUMV, ID, SUBA,
     *      FQID, ANTS, TIMER, IFS, CHANS, PFLAGS, REASON, IRET)
C                                       Close
      ELSE
         CALL TABFLG ('CLOS', BUFF, LFGRNO, FGKOLS, FGNUMV, IDT, SUBT,
     *      FQID, ANTS, TIMER, IFS, CHANS, TFLAGS, TREAS, IRET)
C                                       Clear write status
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV', IDUM,
     *      'CLWR', BUFF, IRET)
C                                       Reset status to read
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV', IDUM,
     *      'READ', BUFF, IRET)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Found some bad data, will write flags to table FG', I4)
 1001 FORMAT ('Found some bad data, will add   flags to table FG', I4)
 1002 FORMAT ('Copy',I8,' rows from FG vers',I3,' to',I3)
      END

      SUBROUTINE QRFT (APCORE, UDATA, UFT, UPH0, NFT, NDATA)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Does real, inverse FT with arbitrary spacing.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2006, 2012, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FORTRAN version of FPS AP VFC routine
C   QRFT computes a real, inverse fourier transform from data with an
C   arbitrary spacing.
C   Inputs:
C      UDATA  I  AP base address of input data.
C                expects 2*NDATA words after UDATA of work space
C      UFT    I  AP base address of output F. T.
C      UPH0   I  AP base address of phase information for F. T.
C                  0=COS((TWOPI/(NG*NFT))*(1-ICENT)(1-BIAS))
C                  1=SIN((TWOPI/(NG*NFT))*(1-ICENT)(1-BIAS))
C                  2=COS((TWOPI/(NG*NFT))*(1-ICENT))
C                  3=SIN((TWOPI/(NG*NFT))*(1-ICENT))
C                  4=COS((TWOPI/(NG*NFT))*(1-BIAS))
C                  5=SIN((TWOPI/(NG*NFT))*(1-BIAS))
C                  6=COS((TWOPI/(NG*NFT)))
C                  7=SIN((TWOPI/(NG*NFT)))
C                  ICENT = center pixel of grid
C                  BIAS = center of data array (1 rel)
C                  NG = No. tabulated points per cell.
C      NFT    I  Number of FT points
C      NDATA  I  Number of data points.
C    Fourier transform is calculated by repeatedly applying a phase ramp
C   to the complex input vector and summing the result.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   UDATA, UFT, UPH0, NFT, NDATA
C
      INTEGER   I, LOOP, DATA, WORK, INDEX
      LONGINT   JPH0, DPH, DPH0, DDPH, JINDEX, JA, JB, FT
      DOUBLE PRECISION SUMRE, PHASE, AMPL, DPHASE, TEMPR, TEMPI
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                       Set up addresses.
      FT = UFT + PSAPOF
C                                       Check for data.
      IF (NDATA.LE.0) GO TO 999
C                                       Set pointers
      DPH = UPH0 + 1 + PSAPOF
      DPH0 = DPH + 2
      DDPH = DPH0 + 2
      WORK = UDATA + 2 * NDATA + 1
      DATA = UDATA + 1
      JPH0 = UPH0 + PSAPOF
C                                       Phase ramp
      AMPL = SQRT (APCORE(JPH0)*APCORE(JPH0) +
     *   APCORE(JPH0+1)*APCORE(JPH0+1))
      PHASE = ATAN2 (APCORE(JPH0+1), APCORE(JPH0)+1.0D-30)
      DPHASE = ATAN2 (APCORE(DPH+2), APCORE(DPH+1)+1.0D-30)
      JINDEX = WORK + PSAPOF - 1
      INCLUDE 'INCS:ZVND.INC'
      DO 20 LOOP = 1,NDATA
         APCORE(JINDEX) = AMPL
         APCORE(JINDEX+1) = PHASE + (LOOP-1) * DPHASE
         JINDEX = JINDEX + 2
 20      CONTINUE
C                                       Convert to rectangular
      INDEX = WORK - 1
      CALL QRECT (APCORE, INDEX, 2, INDEX, 2, NDATA)
C                                       Multiply by ramp
      JA = DATA + PSAPOF - 1
      JB = WORK + PSAPOF - 1
      INCLUDE 'INCS:ZVND.INC'
      DO 40 LOOP = 1,NDATA
         TEMPR = APCORE(JA)*APCORE(JB) - APCORE(JA+1)*APCORE(JB+1)
         TEMPI = APCORE(JA)*APCORE(JB+1) + APCORE(JA+1)*APCORE(JB)
         APCORE(JA) = TEMPR
         APCORE(JA+1) = TEMPI
C                                        Update indices
         JA = JA + 2
         JB = JB + 2
 40      CONTINUE
C                                       Set phase ramp for inner loop
      AMPL = SQRT (APCORE(DPH0+1)*APCORE(DPH0+1) +
     *   APCORE(DPH0+2)*APCORE(DPH0+2))
      PHASE = ATAN2 (APCORE(DPH0+2), APCORE(DPH0+1)+1.0D-30)
      DPHASE = ATAN2 (APCORE(DDPH+2), APCORE(DDPH+1)+1.0D-30)
      JINDEX = WORK + PSAPOF - 1
      INCLUDE 'INCS:ZVND.INC'
      DO 60 LOOP = 1,NDATA
         APCORE(JINDEX) = AMPL
         APCORE(JINDEX+1) = PHASE + (LOOP-1) * DPHASE
         JINDEX = JINDEX + 2
 60      CONTINUE
C                                       Convert to rectangular
      INDEX = WORK - 1
      CALL QRECT (APCORE, INDEX, 2, INDEX, 2, NDATA)
C                                       Do Fourier transform
C                                       Loop
      DO 200 I = 1,NFT
C                                       Multiply by ramp and sum
         JA = DATA + PSAPOF - 1
         JB = WORK + PSAPOF - 1
         SUMRE = 0.0D0
      INCLUDE 'INCS:ZVND.INC'
         DO 100 LOOP = 1,NDATA
            SUMRE = SUMRE + APCORE(JA)
            TEMPR = APCORE(JA)*APCORE(JB) - APCORE(JA+1)*APCORE(JB+1)
            TEMPI = APCORE(JA)*APCORE(JB+1) + APCORE(JA+1)*APCORE(JB)
            APCORE(JA) = TEMPR
            APCORE(JA+1) = TEMPI
C                                           Update indices
            JA = JA + 2
            JB = JB + 2
 100        CONTINUE
         APCORE(FT) = SUMRE
         FT = FT + 1
 200     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE FLGSTK (STOKES, OPCODE, PFLAGS, LFSET, IRET)
C-----------------------------------------------------------------------
C! Set Stokes flag for uv flagging.
C# Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2008, 2014-2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Subroutine to compute flag for UVFLG visibility flagging based on
C   STOKES and OPCODE.  Uses current values in /MAPHDR/ CATBLK
C   and the /UVHDR/ common (filled by UVPGET).
C   Input:
C      STOKES    C*4  Stokes' type,
C                     Recognized are 'I', 'Q', 'U', 'V', 'IQU',
C                     'IQUV', 'IV', 'RR', 'LL', 'LR', 'RL',
C                     'VV','HH','VH','HV','CROS'
C                     'HALF'(=RR,LL) and 'FULL' (=RR,LL,RL,LR)
C                     '    '=>all stokes' types.
C      OPCODE    C*4  'FLAG', 'UFLG' 'REAS' (=Unflag by REASON)
C   Output:
C      PFLAGS(4) L    Polarization flags, same order as in data.
C                     If data true Stokes' or correlator (baseline)
C                     flagging is requested all 4 are filled in;
C                     for IF (RR and/or LL) flagging only first 2
C                     are meaningful.
C      LFSET     L    .TRUE. if flag, .FALSE. if unflag.
C      IRET      I    Return code, 0=OK, else data incompatible
C                     with request.
C-----------------------------------------------------------------------
      CHARACTER STOKES*4, OPCODE*4
      INTEGER   IRET
      LOGICAL   PFLAGS(4), LFSET
C
      INTEGER   NSTOK
      PARAMETER (NSTOK = 23)
      CHARACTER CHSTOK(NSTOK)*4, CHMASK(16)*4, CHOPCO(5)*4
      INTEGER   NOPCO, ISTOK, IOPCO, I
      LOGICAL   T, F
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA NOPCO /5/
      DATA CHSTOK /'I', 'Q', 'U', 'V', 'IQU', 'IQUV', 'IV',
     *   'RR', 'LL', 'RL', 'LR', 'RRLL', 'RLLR',
     *   'VV', 'HH', 'VH', 'HV', 'VVHH', 'VHHV',
     *   'HALF','FULL','CROS',' '/
      DATA CHMASK /'1000','0100','0010','0001','1100','1010','1001',
     *   '0110','0101','0011','1110','1101','1011','0111','1111','0000'/
      DATA CHOPCO /'FLAG','UFLG','REAS','WILD','    '/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IRET = 0
C                                       See if a mask
      ISTOK = 0
      DO 10 I = 1,16
         IF (STOKES.EQ.CHMASK(I)) ISTOK = I
 10      CONTINUE
C                                       parse the mask
      IF (ISTOK.GT.0) THEN
         DO 15 I = 1,4
            PFLAGS(I) = STOKES(I:I).EQ.'1'
 15         CONTINUE
         LFSET = (OPCODE.EQ.CHOPCO(1)) .OR. (OPCODE.EQ.CHOPCO(5))
         GO TO 999
         END IF
C                                       Find Stokes number
      DO 50 I = 1,NSTOK
         IF (STOKES.EQ.CHSTOK(I)) THEN
            ISTOK = I
            GO TO 60
            END IF
 50      CONTINUE
C                                       Unknown Stokes'
      WRITE (MSGTXT,1050) STOKES
      IRET = 9
      GO TO 990
C                                       Find OPCODE number
 60   DO 70 I = 1,NOPCO
         IF (OPCODE.EQ.CHOPCO(I)) THEN
            IOPCO = I
            GO TO 80
            END IF
 70      CONTINUE
C                                       Unknown OPCODE
      WRITE (MSGTXT,1070) OPCODE
      IRET = 10
      GO TO 990
C                                       Decide if flag or unflag.
 80   LFSET = (IOPCO.EQ.1) .OR. (IOPCO.EQ.5)
C                                       Decide if true stokes or
C                                       correlator (RR, LL etc.)
      PFLAGS(1) = F
      PFLAGS(2) = F
      PFLAGS(3) = F
      PFLAGS(4) = F
      IF (ICOR0.GE.0) THEN
C                                       True stokes - check
         IF ((ISTOK.GE.8) .AND. (ISTOK.NE.NSTOK)) GO TO 950
C                                       Same for antenna or baseline
C                                       based.
         IF ((ISTOK.EQ.1) .OR. (ISTOK.EQ.5) .OR. (ISTOK.EQ.6) .OR.
     *      (ISTOK.EQ.7) .OR. (ISTOK.EQ.NSTOK)) PFLAGS(1) = T
         IF ((ISTOK.EQ.2) .OR. (ISTOK.EQ.5) .OR. (ISTOK.EQ.6) .OR.
     *      (ISTOK.EQ.NSTOK)) PFLAGS(2) = T
         IF ((ISTOK.EQ.3) .OR. (ISTOK.EQ.5) .OR. (ISTOK.EQ.6) .OR.
     *      (ISTOK.EQ.NSTOK)) PFLAGS(3) = T
         IF ((ISTOK.EQ.4) .OR. (ISTOK.EQ.6) .OR. (ISTOK.EQ.7) .OR.
     *      (ISTOK.EQ.NSTOK)) PFLAGS(4) = T
C                                       Correlator based data (RR...)
      ELSE IF (ICOR0.GT.-5) THEN
         IF ((ISTOK.EQ.1) .OR. ((ISTOK.GE.4) .AND. (ISTOK.LE.8)) .OR.
     *      (ISTOK.EQ.12) .OR. (ISTOK.EQ.NSTOK) .OR.
     *      ((ISTOK.GE.19) .AND. (ISTOK.LE.21))) PFLAGS(1) = T
         IF ((ISTOK.EQ.1) .OR. ((ISTOK.GE.4) .AND. (ISTOK.LE.7)) .OR.
     *      (ISTOK.EQ.9) .OR. (ISTOK.EQ.12) .OR. (ISTOK.EQ.NSTOK) .OR.
     *      ((ISTOK.GE.19) .AND. (ISTOK.LE.21))) PFLAGS(2) = T
         IF ((ISTOK.EQ.2) .OR. (ISTOK.EQ.3) .OR. (ISTOK.EQ.5) .OR.
     *      (ISTOK.EQ.6) .OR. (ISTOK.EQ.10) .OR. (ISTOK.EQ.13) .OR.
     *      ((ISTOK.GE.21) .AND. (ISTOK.LE.NSTOK))) PFLAGS(3) = T
         IF ((ISTOK.EQ.2) .OR. (ISTOK.EQ.3) .OR. (ISTOK.EQ.5) .OR.
     *      (ISTOK.EQ.6) .OR. (ISTOK.EQ.11) .OR. (ISTOK.EQ.13) .OR.
     *      ((ISTOK.GE.21) .AND. (ISTOK.LE.NSTOK))) PFLAGS(4) = T
C                                       Correlator based data (VV...)
      ELSE
         IF ((ISTOK.EQ.1) .OR. ((ISTOK.GE.5) .AND. (ISTOK.LE.7)) .OR.
     *      (ISTOK.EQ.14) .OR. (ISTOK.EQ.18) .OR. (ISTOK.EQ.20) .OR.
     *      (ISTOK.EQ.21) .OR. (ISTOK.EQ.NSTOK)) PFLAGS(1) = T
         IF ((ISTOK.EQ.1) .OR. ((ISTOK.GE.5) .AND. (ISTOK.LE.7)) .OR.
     *      (ISTOK.EQ.15) .OR. (ISTOK.EQ.18) .OR. (ISTOK.EQ.NSTOK) .OR.
     *      (ISTOK.EQ.20) .OR. (ISTOK.EQ.21)) PFLAGS(2) = T
         IF ((ISTOK.EQ.16) .OR. (ISTOK.EQ.19) .OR.
     *      ((ISTOK.GE.21) .AND. (ISTOK.LE.NSTOK))) PFLAGS(3) = T
         IF ((ISTOK.EQ.17) .OR. (ISTOK.EQ.19) .OR.
     *      ((ISTOK.GE.21) .AND. (ISTOK.LE.NSTOK))) PFLAGS(4) = T
         END IF
      GO TO 999
C                                       Data incompatible
 950  WRITE (MSGTXT,1950)
      IRET = 1
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('FLGSTK: UNKNOWN STOKES PARAMETER: ',A4)
 1070 FORMAT ('FLGSTK: UNKNOWN OPCODE: ',A4)
 1950 FORMAT ('FLGSTK: DATA INCOMPATIBLE WITH REQUEST')
      END

LOCAL INCLUDE 'RLCAL.INC'
C                                                         Include RLCAL
C                                       Local include for RLCAL
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
C                                       MAXDAT = Number of vis in
C                                       arrays.
C                                       MAXSCN max # time intervals
      INTEGER   MAXDAT, MAXSCN
      PARAMETER (MAXDAT=20000)
      PARAMETER (MAXSCN=5000)
C
      INTEGER   CATIN(256), SEQIN, SEQ2, DISKIN, DISK2, CNOIN, CNOIN2,
     *   CCTVER, VISDSK, VISCNO, VMDSK, VMCNO, JBUFSZ, ANTS(2,MAXDAT),
     *   VSOU(MAXDAT), VCALID, NCOMP(MAXFLD), NUMDAT,
     *   IONSCR, FREQID, CHNSEL(3,20,MAXIF), PSMRAD, CPVER, CSIDNO,
     *   NSCANS
      LOGICAL   SINGLE, CLNMOD, ISXY, AVGIF, IMODEL, DOLINE, DOINTP,
     *   CMODEL
      REAL   XSI, XDI, XQUAL, XTIME(8), XBAND, XFREQ, XFQID, XBIF, XEIF,
     *   XANTS(50), XUVRA(2), XSUBA, XDOCAL, XGUSE, XDOPOL, XPDVER,
     *   XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH(3), XCHNS(4,20), XS2,
     *   XD2, XVER, XNCOMP(MAXAFL), XFLUX, XNMAP, XSMOD(7),
     *   XSPECT(4,20), XSOLIN, XPRTLV, XBADD(10),
     *   BUFF1(UVBFSS), BUFF2(UVBFSS), TIME(MAXDAT), PARAN(2,MAXDAT),
     *   VMOD(2,4,MAXDAT), VWT(4,MAXDAT), VOBS(2,4,MAXDAT),
     *   VFLUX(4,MAXIF), VFINC(MAXIF), REFPIX, PSMTAB(1024),
     *   PHDIFF(MAXCIF), TSCAN(2,MAXSCN), PCORR(MAXIF,MAXSCN)
      HOLLERITH XNAMEI(3), XCLAIN(2), XXCALC(1), XXSOUR(4,30),
     *   XNAME2(3), XCLAS2(2), XCMETH(1), XCMOD(1)
      DOUBLE PRECISION FREQSO(MAXIF)
      CHARACTER NAMEIN*12, CLAIN*6, XSOUR(30)*16, NAME2*12, CLAS2*6,
     *   CMETH*4, CMOD*4, CSNAME*16, XCALCO*4
      COMMON /CINFO/ CATIN, FREQSO, NCOMP, SINGLE, CLNMOD, CNOIN,
     *   CNOIN2, CCTVER, VISDSK, VISCNO, VMDSK, VMCNO, IONSCR,
     *   DISKIN, DISK2, SEQIN, SEQ2, FREQID, IMODEL, CHNSEL, DOLINE,
     *   PSMRAD, PSMTAB, DOINTP, CPVER, CSIDNO, CMODEL
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
      COMMON /XINPUT/ XNAMEI, XCLAIN, XSI, XDI, XXSOUR, XQUAL, XXCALC,
     *   XTIME, XBAND, XFREQ, XFQID, XBIF, XEIF, XANTS, XUVRA, XSUBA,
     *   XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER,
     *   XSMOTH, XCHNS, XNAME2, XCLAS2, XS2, XD2, XVER, XNCOMP, XFLUX,
     *   XNMAP, XCMETH, XCMOD, XSMOD, XSPECT, XSOLIN, XPRTLV, XBADD
      COMMON /CHRCOM/ NAMEIN, CLAIN, XSOUR, NAME2, CLAS2, CMETH,
     *   CMOD, CSNAME, XCALCO
      COMMON /VDATA/ TIME, PARAN, VMOD, VWT, VOBS, VFLUX, ISXY,
     *   AVGIF, NUMDAT, ANTS, VSOU, VCALID, VFINC,
     *   REFPIX, PHDIFF, NSCANS, TSCAN, PCORR
C                                                          End RLCAL
LOCAL END
      PROGRAM RLCAL
C-----------------------------------------------------------------------
C! Determines Antenna polarization characteristics
C# UV Calibration AP-appl EXT-appl polarization
C-----------------------------------------------------------------------
C;  Copyright (C) 2011-2012, 2014-2016, 2019, 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   RLCAL computes polarization parameters and enters them into the AN
C   table  also determines calibrator polarizations and enters them in
C   the SU table.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, NC, NI, NA
      INCLUDE 'RLCAL.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DGDS.INC'
      DATA PRGM /'RLCAL'/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL RLCIN (PRGM, NC, NI, NA, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Determine poln. parameters.
      CALL RLCUV (NC, NI, NA, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       History
      CALL RLCHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE RLCIN (PRGN, NC, NI, NA, IRET)
C-----------------------------------------------------------------------
C   RLCIN gets input parameters for RLCAL.
C   Inputs:
C      PRGN    C*6     Program name
C      NC      I     Number spectral channels
C      NI      I     Number IFs
C      NA      I     Max antenna number
C   Output:
C      IRET    I         Error code: 0 => ok
C                          1 => too few frequency channels.
C                          5 => catalog troubles
C                          8 => cannot start
C   Commons: /XINPUT/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in RLCAL for more details.
C-----------------------------------------------------------------------
      INTEGER   NC, NI, NA, IRET
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, UTYPE*2
      HOLLERITH CATH(256)
      INTEGER   IERR, NPARM, I, MXFLD, NUMSUB, IROUND, LUN1, NUMAN(513),
     *   J, K, K1, K2, LUNTMP, BUFFER(512), IDUM(2)
      HOLLERITH HDUM(2)
      LOGICAL   T, TABLE, EXIST, FITASC, MATCH
      REAL      CATR(256), CATINR(256), DUM(2)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'RLCAL.INC'
      INTEGER   NW(MAXIF), ISBAND(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      DOUBLE PRECISION REFFRQ, FOFF(MAXIF), FRATIO
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DANS.INC'
      EQUIVALENCE (NUMAN, BUFF2), (IDUM, HDUM)
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      EQUIVALENCE (CATIN, CATINR)
      DATA LUN1 /28/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
      NSOUWD = 1
C                                       Get input parameters.
C                                       Max # fields is or was 16
      MXFLD = MAXAFL
      NPARM = 397 + MAXAFL
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSI)
      SEQ2 = IROUND (XS2)
      DISKIN = IROUND (XDI)
      DISK2 = IROUND (XD2)
      CCTVER = IROUND (XVER)
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAME2, NAME2)
      CALL H2CHR (6, 1, XCLAS2, CLAS2)
      CALL H2CHR (4, 1, XCMETH, CMETH)
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
 20      CONTINUE
      CALL H2CHR (4, 1, XXCALC, XCALCO)
C                                       Get CATBLK from old file.
      CNOIN = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'REST', BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1050) IRET
         GO TO 990
         END IF
C                                       Init. scratch file info.
      VISDSK = DISKIN
      VISCNO = CNOIN
      VMDSK = 0
      VMCNO = 0
C                                       Get uv header info.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       BADDISK
      DO 30 I = 1,10
         IBAD(I) = IROUND (XBADD(I))
 30      CONTINUE
C                                       Linearly polarized feeds?
      ISXY = CATD(KDCRV+JLOCS) .LT. -4.0D0
C                                       Check sort order, must be T*
      IF (ISORT(1:1).NE.'T') THEN
         IRET = 4
         WRITE (MSGTXT,1070) ISORT, 'T*'
         GO TO 990
         END IF
C                                       Save input header.
      CALL COPY (256, CATBLK, CATIN)
C                                       See if a multiple source file
      LUNS(1) = 29
      CALL ISTAB ('SU', DISKIN, CNOIN, 1, LUNS(1), BUFFER, TABLE, EXIST,
     *   FITASC, IERR)
      SINGLE = (.NOT.EXIST) .OR. (IERR.NE.0) .OR. (ILOCSU.LT.0)
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DO 40 I = 1,30
         SOURCS(I) = XSOUR(I)
 40      CONTINUE
      SELQUA = IROUND (XQUAL)
      SELCOD = XCALCO
      CALL RCOPY (8, XTIME, TIMRNG)
      DXTIME = 1.0/86400.0
      UVRNG(1) = XUVRA(1)
      UVRNG(2) = XUVRA(2)
      DOPOL = IROUND (XDOPOL)
      IF ((DOPOL.EQ.0) .AND. (XDOPOL.GT.0.0)) DOPOL = 1
      PDVER = IROUND (XPDVER)
      STOKES = 'RLLR'
      BCHAN = 1
      ECHAN = CATBLK(KINAX+JLOCF)
      NC = ECHAN
      IF (JLOCIF.GE.0) THEN
         NI = CATBLK(KINAX+JLOCIF)
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, NI))
         EIF = IROUND (XEIF)
         IF (EIF.LT.BIF) EIF = NI
         EIF = MAX (1, MIN (EIF, NI))
      ELSE
         BIF = 1
         EIF = 1
         END IF
      XBIF = BIF
      XEIF = EIF
C                                       Channel selection for
C                                       channel 0
      I = 60 * MAXIF
      CALL FILL (I, 0, CHNSEL)
      CALL FILL (MAXIF, 0, NW)
      DO 60 I = 1,20
         K = IROUND (XCHNS(2,I))
         IF (K.LE.0) GO TO 65
         K = IROUND (XCHNS(4,I))
         IF ((K.LE.0) .OR. (K.GT.MAXIF)) THEN
            K1 = 1
            K2 = MAXIF
         ELSE
            K1 = K
            K2 = K
            END IF
         DO 55 K = K1,K2
            NW(K) = NW(K) + 1
            DO 50 J = 1,3
               CHNSEL(J,NW(K),K) = IROUND (XCHNS(J,I))
               IF (CHNSEL(J,NW(K),K).LT.0) CHNSEL(J,NW(K),K) = 0
 50            CONTINUE
            IF (CHNSEL(3,NW(K),K).EQ.0) CHNSEL(3,NW(K),K) = 1
 55         CONTINUE
 60      CONTINUE
 65   J = CATBLK(KINAX+JLOCF)
      DO 75 K = 1,MAXIF
         IF (NW(K).LE.0) THEN
            NW(K) = 1
            CHNSEL(1,1,K) = 1
            CHNSEL(2,1,K) = ECHAN
            CHNSEL(3,1,K) = 1
         ELSE
            DO 70 I = 1,NW(K)
               CHNSEL(1,I,K) = MAX (1, MIN (CHNSEL(1,I,K), J))
               IF (CHNSEL(2,I,K).LT.CHNSEL(1,I,K)) CHNSEL(2,I,K) = J
               CHNSEL(2,I,K) = MAX (1, MIN (CHNSEL(2,I,K), J))
 70            CONTINUE
            END IF
 75      CONTINUE
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN1, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, IRET)
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1060)
         IRET = 1
         GO TO 990
         END IF
      IF (IRET.GT.0) GO TO 999
      FREQID = FRQSEL
C                                       Antennas
      DO 85 I = 1,50
         ANTENS(I) = IROUND (XANTS(I))
 85      CONTINUE
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LE.0) SUBARR = 1
      FGVER = IROUND (XFLAG)
      CLVER = 0
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
C                                       Default SI = 10 min.
      CALL FNDEXT ('NX', CATBLK, I)
      IF (XSOLIN.LE.0.0) THEN
         IF (I.GT.0) THEN
            XSOLIN = 1.E6
         ELSE
            XSOLIN = 10.0
            END IF
         END IF
      XSOLIN = XSOLIN / (24.0 * 60.0)
      CMODEL = ((NAME2.NE.' ') .OR. (CLAS2.NE.' ')) .AND. (XNMAP.GT.0.5)
      IF (CMODEL) CALL RFILL (7, 0.0, XSMOD)
      IMODEL = XSMOD(1).GT.0.0
      IF (.NOT.IMODEL) CALL RFILL (7, 0.0, XSMOD)
C                                       Find number of subarrays
      CALL FNDEXT ('AN', CATBLK, NUMSUB)
      NUMSUB = MAX (1, NUMSUB)
      IF (NUMSUB.LT.SUBARR) THEN
         WRITE (MSGTXT,1085) SUBARR, NUMSUB
         GO TO 990
         END IF
C                                       Find number of antennas.
      CALL GETNAN (DISKIN, CNOIN, CATBLK, LUN1, BUFF1, NUMAN, IRET)
      IF (IRET.NE.0) GO TO 999
      NUMANT = NUMAN(2)
      IF (SUBARR.LE.NUMAN(1)) NUMANT = NUMAN(1+SUBARR)
C                                       Number of IFs
      NUMIF = 1
      IF (JLOCIF.GE.0) NUMIF = CATBLK(KINAX+JLOCIF)
C                                       Get antenna info
      CALL GETANT (DISKIN, CNOIN, SUBARR, CATBLK, BUFF1, IRET)
      IF (IRET.NE.0) GO TO 999
      NA = NSTNS
C                                       check UV data set exists,
C                                       set variables for RLCSOU
      CALL UVGET ('INIT', DUM, DUM, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL UVGET ('CLOS', DUM, DUM, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Init. cal. fluxes etc.
      VCALID = 0
      K = 4 *NUMIF
      CALL RFILL (K, 0.0, VFLUX)
C                                       single source
      IF (SINGLE) THEN
         CALL RCOPY (4, XSMOD, VFLUX)
         IF ((.NOT.IMODEL) .AND. (.NOT.CMODEL)) THEN
            IRET = 8
            MSGTXT = 'YOU MUST PROVIDE A PMODEL(1) FOR SINGLE-SOURCE'
     *         // ' FILES'
            CALL MSGWRT (8)
            MSGTXT = 'OR PERHAPS NMAPS > 0 IF YOU HAVE SET IN2NAME'
            GO TO 990
            END IF
         VCALID = 1
         CALL COPY (2, CATUV(KHOBJ), IDUM)
         CALL H2CHR (8, 1, HDUM, CSNAME)
         CSIDNO = 1
         CALL DFILL (NUMIF, 0.0D0, FREQSO)
         END IF
C                                       read source, index tables
      CALL RLCSOU (IRET)
      IF (IRET.GT.0) GO TO 999
C                                       get full frequencies
      K1 = 1
      LUN1 = LUNTMP (1)
      CALL CHNDAT ('READ', BUFFER, DISKIN, CNOIN, K1, CATIN, LUN1,
     *   NUMIF, FOFF, ISBAND, VFINC, BNDCOD, FREQID, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
         END IF
      REFFRQ = CATD(KDCRV+JLOCF)
      REFPIX = CATR(KRCRP+JLOCF)
      DO 100 J = 1,NUMIF
         FREQSO(J) = FREQSO(J) + REFFRQ + FOFF(J)
         IF (IMODEL) THEN
            FRATIO = FREQSO(J) / FREQSO(1)
            DO 95 K = 1,4
               VFLUX(K,J) = XSMOD(K) * (FRATIO**XSPECT(K,1))
 95            CONTINUE
            END IF
 100     CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RLCIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,' . ',A6,' . ',
     *   I3,' DISK=',I3,' USID=',I4)
 1050 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1060 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
 1070 FORMAT ('SORT ORDER IS ',A2,' NOT ',A2,' AS REQUIRED')
 1085 FORMAT ('SPECIFIED SUBARRAY ',I4,' > MAX. OF ',I4)
 1100 FORMAT ('RLCIN: ERROR',I4,' GETTING FREQUENCY PARAMETERS')
      END
      SUBROUTINE RLCSOU (IRET)
C-----------------------------------------------------------------------
C   RLCSOU collects calibrator polarized flux density information.
C   Input from common:
C      NSOUWD   I       Number of sources included or excluded; if 0
C                       all sources are included.
C      DOSWNT   L       If .TRUE. then sources in SOUWAN are included
C                       If .FALSE. then excluded.
C      SOUWAN   I(30)   The source numbers of sources included or
C                       excluded.
C      DISKIN   I       Disk number of the input multisource data file
C                       whose SU table is to be used.
C      CNOIN    I       Catalog slot number for SU file.
C   Output to Common:
C      VCALID   I       Calibrator ID numbers
C      VFLUX    R(4,if)   Polarized flux densities (I,Q,U,V) (Jy)
C   Output:
C      IRET     I       Return code, 0 => OK, otherwise abort.
C   Note: also uses buffer NXBUFF
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'RLCAL.INC'
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4
      INTEGER   I, SUKOLS(MAXSUC), SUNUMV(MAXSUC), IDSOU, QUAL, SULUN,
     *   ISURNO, NUMSOU, LOOP, SUFQID, II, ISUB, VS, VE, VERS
      DOUBLE PRECISION BANDW, RAEPO, DECEPO, EPOCH, RAAPP, DECAPP,
     *   PMRA, PMDEC, LSRVEL(MAXIF), FREQO(MAXIF), RESTFQ(MAXIF), RAOBS,
     *   DECOBS
      REAL      FLUX(4,MAXIF), EPS, TBEG, CTIME, DTIME
      LOGICAL   TABLE, EXIST, FITASC
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA SULUN /27/
C-----------------------------------------------------------------------
      EPS = 1.0 / (24.0 * 3600.0 * 10.0)
      IF (.NOT.SINGLE) THEN
C                                       Open source (SU) table
         CALL SOUINI ('READ', NXBUFF, DISKIN, CNOIN, 1, CATUV,
     *      SULUN, NUMIF, VELTYP, VELDEF, SUFQID, ISURNO, SUKOLS,
     *      SUNUMV, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING SOURCE TABLE'
            GO TO 990
            END IF
C                                       Check FREQID compatibility.
         IF ((SUFQID.GT.0) .AND. (FREQID.GT.0) .AND.
     *      (SUFQID.NE.FREQID)) THEN
            MSGTXT = 'WARNING - POTENTIALLY FATAL ERROR'
            CALL MSGWRT (6)
            WRITE (MSGTXT,1040) SUFQID
            CALL MSGWRT (6)
            WRITE (MSGTXT,1050) FREQID
            CALL MSGWRT (6)
            MSGTXT = '   Rerun SETJY with the correct FREQID'
            CALL MSGWRT (6)
            IRET = 5
            GO TO 999
            END IF
C                                       Get number of sources
         NUMSOU = NXBUFF(5)
C                                       Read flux array
         VCALID = 0
         DO 50 LOOP = 1,NUMSOU
            ISURNO = LOOP
            CALL TABSOU ('READ', NXBUFF, ISURNO, SUKOLS, SUNUMV,
     *         IDSOU, SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO,
     *         DECEPO, EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL,
     *         RESTFQ, PMRA, PMDEC, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING SOURCE TABLE'
               GO TO 990
               END IF
C                                       Save calibrator fluxes
C                                       See if wanted
            IF (NSOUWD.GT.0) THEN
               DO 20 I = 1,NSOUWD
                  IF (IDSOU.EQ.SOUWAN(I)) GO TO 30
 20               CONTINUE
C                                       Not wanted
               GO TO 50
               END IF
C                                       Wanted
 30         IF (VCALID.GT.0) THEN
               MSGTXT = 'MORE THAN ONE SOURCE MATCHES SOURCE PARAMETERS'
               IRET = 10
               GO TO 990
            ELSE
               VCALID = IDSOU
               DO 35 I = 1,NUMIF
                  VFLUX(1,I) = FLUX(1,I)
                  VFLUX(2,I) = FLUX(2,I)
                  VFLUX(3,I) = FLUX(3,I)
                  VFLUX(4,I) = FLUX(4,I)
                  FREQSO(I) = FREQO(I)
 35               CONTINUE
               CSNAME = SOUNAM
               CSIDNO = IDSOU
               END IF
 50         CONTINUE
C                                       Close table
         CALL TABIO ('CLOS', 0, ISURNO, BUFF1, NXBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING SOURCE TABLE'
            GO TO 990
            END IF
         END IF
C                                       Index table
      VERS = 1
      CALL ISTAB ('NX', DISKIN, CNOIN, VERS, SULUN, NXBUFF, TABLE,
     *   EXIST, FITASC, IRET)
      IF ((EXIST) .AND. (IRET.EQ.0)) THEN
         CALL NDXINI ('READ', NXBUFF, DISKIN, CNOIN, VERS, CATUV, SULUN,
     *      ISURNO, SUKOLS, SUNUMV, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING INDEX TABLE'
            GO TO 990
            END IF
         NUMSOU = NXBUFF(5)
C                                       Read flux array
         DO 110 LOOP = 1,NUMSOU
            ISURNO = LOOP
            CALL TABNDX ('READ', NXBUFF, ISURNO, SUKOLS, SUNUMV, CTIME,
     *         DTIME, IDSOU, ISUB, VS, VE, FREQID, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING INDEX TABLE'
               GO TO 990
               END IF
            IF ((ISUB.NE.SUBARR) .AND. (SUBARR.GT.0)) GO TO 110
            IF ((FREQID.GT.0) .AND. (FRQSEL.NE.FREQID) .AND.
     *         (FRQSEL.GT.0)) GO TO 110
            IF (IDSOU.EQ.CSIDNO) THEN
               IF (XSOLIN.GE.DTIME) THEN
                  NSCANS = NSCANS + 1
                  TSCAN(1,NSCANS) = CTIME - DTIME/2 - EPS
                  TSCAN(2,NSCANS) = CTIME + DTIME/2 + EPS
               ELSE
                  II = DTIME / XSOLIN + 0.5
                  TBEG = CTIME - DTIME/2
                  DTIME = DTIME / II
                  DO 105 I = 1,II
                     NSCANS = NSCANS + 1
                     TSCAN(1,NSCANS) = TBEG + (I-1)*DTIME - EPS/3.
                     TSCAN(2,NSCANS) = TBEG + I*DTIME + EPS/3.
 105                 CONTINUE
                  END IF
               END IF
 110        CONTINUE
C                                       Close table
         CALL TABIO ('CLOS', 0, ISURNO, BUFF1, NXBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING INDEX TABLE'
            GO TO 990
            END IF
C                                       no NX
      ELSE IF ((IRET.GT.0) .OR. (.NOT.SINGLE)) THEN
         MSGTXT = 'UNABLE TO OPEN INDEX TABLE'
         IF (IRET.LE.0) IRET = 10
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RLCSOU: ERROR',I3,' ON ',A)
 1040 FORMAT ('   Your calibrators have their fluxes set for FQID ',I3)
 1050 FORMAT ('   You are using them to calibrate FQID ',I3)
      END
      SUBROUTINE RLCUV (NC, NI, NA, IRET)
C-----------------------------------------------------------------------
C   RLCUV cause the work to be done
C   Inputs:
C      NC       I      Number spectral channels
C      NI       I      Number IFs
C      NA       I      Max antenna number
C   Output:
C      IRET     I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NC, NI, NA, IRET
C
      INCLUDE 'RLCAL.INC'
      HOLLERITH CATINH(256)
      INTEGER   I, IFNO, ISNRNO, NODENO, SAVEIF, SAVBIF, J, SNBUFF(512),
     *   SNKOLS(MAXSNC), SNNUMV(MAXSNC), NUMNOD, VER, LUN, LOOPC,
     *   REFA(2,MAXIF), INNSCR, LOOPIF
      LOGICAL   ISAPPL
      REAL      RANOD, DECNOD, LFR, MBDELY(2), TIMEI, CREAL(2,MAXIF),
     *   CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF), WEIGHT(2,MAXIF),
     *   DISP(2), DDISP(2)
      DOUBLE PRECISION CTIME
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (CATIN, CATINH)
C-----------------------------------------------------------------------
      I = MAXIF * MAXSCN
      CALL RFILL (I, 0.0, PCORR)
      SAVBIF = BIF
      SAVEIF = EIF
C                                       an IF at a time
      DO 20 IFNO = SAVBIF,SAVEIF
         INNSCR = NSCR
         VISDSK = 0
         VISCNO = 0
         CALL RLCSEL (IFNO, NC, CHNSEL(1,1,IFNO), IRET)
         IF (IRET.NE.0) GO TO 999
         DO 10 I = INNSCR+1,NSCR
            LOOPIF = 1
            LOOPC = 2
            CALL MAPCLR (LOOPIF, SCRVOL(I), SCRCNO(I), LOOPC, BUFF2)
 10         CONTINUE
         NSCR = INNSCR
 20      CONTINUE
      BIF = SAVBIF
      EIF = SAVEIF
C                                       write a new SN table
      VER = 0
      NUMANT = NA
      NUMPOL = 2
      NUMIF = NI
      NUMNOD = 0
      GMMOD = 1.0
      RANOD = 0.0
      DECNOD = 0.0
      ISAPPL = .FALSE.
      LUN = 27
      CALL SNINI ('WRIT', SNBUFF, DISKIN, CNOIN, VER, CATIN, LUN,
     *   ISNRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING NEW SN TABLE'
         GO TO 980
         END IF
      LFR = 0.0
      MBDELY(1) = 0.0
      MBDELY(2) = 0.0
      DISP(1) = 0.0
      DISP(2) = 0.0
      DDISP(1) = 0.0
      DDISP(2) = 0.0
      NODENO = 0
      I = 2 * NI
      CALL RFILL (I, 1.0, CREAL)
      CALL RFILL (I, 0.0, CIMAG)
      CALL RFILL (I, 0.0, DELAY)
      CALL RFILL (I, 0.0, RATE)
      CALL RFILL (I, 1.0, WEIGHT)
      CALL FILL (I, 1, REFA)
      DO 100 I = 1,NSCANS
         DO 80 IFNO = BIF,EIF
            CREAL(2,IFNO) = COS (DG2RAD * PCORR(IFNO,I))
            CIMAG(2,IFNO) = -SIN (DG2RAD * PCORR(IFNO,I))
 80         CONTINUE
         CTIME = TSCAN(1,I)/2.0D0  + TSCAN(2,I)/2.0D0
         TIMEI = TSCAN(2,I) - TSCAN(1,I)
         DO 90 J = 1,NA
            CALL TABSN ('WRIT', SNBUFF, ISNRNO, SNKOLS, SNNUMV, NUMPOL,
     *         CTIME, TIMEI, CSIDNO, J, SUBARR, FRQSEL, LFR, NODENO,
     *         MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *         REFA, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'WRITING SN TABLE'
               GO TO 980
               END IF
 90         CONTINUE
 100     CONTINUE
      CALL TABSN ('CLOS', SNBUFF, ISNRNO, SNKOLS, SNNUMV, NUMPOL, CTIME,
     *   TIMEI, CSIDNO, J, SUBARR, FRQSEL, LFR, NODENO, MBDELY, DISP,
     *   DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITING SN TABLE'
         GO TO 980
         END IF
      WRITE (MSGTXT,1100) VER
      CALL MSGWRT (2)
      GO TO 999
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RLCUV ERROR',I4,' ON ',A)
 1100 FORMAT ('Wrote SN table version',I5)
      END
      SUBROUTINE RLCSEL (IFNO, NC, CHNS, IRET)
C-----------------------------------------------------------------------
C   RLCSEL will read a multi source data set into a scratch file.
C   Editing and calibration may be applied.  It then adds a model to
C   that file in adjacent channels.  It rereads the data file getting
C   the phase correction averaged over time and spectral channel.  If
C   there was no NX table, it prepares an integration list on the first
C   pass.  That is used for the time averaging thereafter.
C   Input:
C      IFNO         I    Do this IF now
C      NC           I    Number spectral channels
C      CHNS         I(3,20)   channel selection
C   Input via common:
C      XSOLIN       R    Solution interval (min)
C   Inputs via common /SELCAL/  (Include DSEL.INC)
C      UNAME        C    AIPS name of input file.
C      UCLAS        C    AIPS class of input file.
C      UDISK        R    AIPS disk of input file.
C      USEQ         R    AIPS sequence of input file.
C      SOURCS(30)   C    Name (16 char) of desired cal source
C      TIMRNG(8)    R    Start day, hour, min, sec, end day, hour,
C                        min,sec. 0 => all
C      UVRNG(2)     R    Minimum and maximum baseline lengths in
C                        1000's wavelengths. 0's => all
C      ANTENS(50)   I    List of antennas selected, 0=>all,
C                        any negative => all except those specified
C      FGVER        I    FLAG file version number, if .le. 0 then
C                        NO flagging is applied.
C      CLUSE        I    Cal file version number to apply.
C   Output in common:
C      NUMDAT       I    Number of visibilities in arrays:
C      TIME(*)      R    Times (days) of the visibilities
C      ANTS(2,*)    I    Antenna numbers
C      PARAN(2,*)   R    Parallactic angles (radians)
C      VMOD(2,4,*)  R    Complex polarization model (I,Q,U,V) (Jy)
C      VOBS(2,4,*)  R    Complex observed values (RR,RL,LR,LL)  or
C                        (XX,XY,YX,YY) (Jy).
C      VWT(4,*)     R    "Weights" of the observations.
C      VCALID       I    Calibrator ID numbers
C   Output:
C      IRET         I    Error code: 0 => OK,
C                        -1 => end of data
C                        >0 => failed, abort process.
C-----------------------------------------------------------------------
      INTEGER   IFNO, NC, CHNS(3,20), IRET
C
      INCLUDE 'INCS:ZPBUFSZ.INC'
      CHARACTER IFILE*48
      INTEGER   LUN1, LUN2, LSOU, SAVNRP, SAVLRC, IND, ILENBU, KBIND,
     *   IPTRI, INIO, SAVCR0, NT,IP, JP, IC, PRTLEV, LOOP, VO, BO, NW,
     *   LOPCNT, IIVER, OOVER, PTIME(4), ISCAN
      LOGICAL   T, F
      REAL      DUM(2), LTIMEP, CTIME, TSCEND, SAVSTK, CATR(256), CHWT
      DOUBLE PRECISION CATD(128), PRR, PII, PRS, PIS, PW, PT, D
      COMPLEX   RLMOD, LRMODS, RLDAT, LRDATS
      INCLUDE 'RLCAL.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSCD.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (CATBLK, CATR, CATD)
      DATA T, F /.TRUE.,.FALSE./
      DATA VO, BO /0,1/
      DATA LUN1,LUN2 /27,28/
C-----------------------------------------------------------------------
C                                       Setup
      WRITE (MSGTXT,1002) IFNO
      CALL MSGWRT (2)
      PRTLEV = XPRTLV + 0.5
C                                       Get data
      BIF = IFNO
      EIF = IFNO
      CALL UVGET ('INIT', DUM, DUM, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy to scratch file.
      IF (NVIS.LE.0) THEN
         CALL UVGET ('CLOS', DUM, DUM, IRET)
         VISDSK = 0
         VISCNO = 0
         IRET = -1
         WRITE (MSGTXT,1100) IFNO
         GO TO 990
         END IF
C                                       do copy
      CALL RLCCOP (VISDSK, VISCNO, BUFF1, JBUFSZ, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Model polarizations
C                                       Create new file with room for
C                                       model.
      CALL COPY (256, CATBLK, SCRCAT)
      SCLREC = LREC
      SCRPRM = NRPARM
      COMPDT = CATBLK(KINAX).EQ.1
      DATDIV = .TRUE.
      IF (COMPDT) THEN
         CALL AXEFND (8, 'WEIGHT  ', SCRCAT(KIPCN), SCRHOL(KHPTP),
     *      WTLOC, IRET)
C                                       Must have this one
         IF ((IRET.NE.0) .OR. (WTLOC.LT.0)) THEN
            IRET = 5
            MSGTXT = 'CANNOT FIND WEIGHT AND SCALE FOR COMPRESSED
     *         DATA'
            CALL MSGWRT (8)
            GO TO 999
            END IF
         IRET = 0
         END IF
      CALL UVDPAD (VISDSK, VISCNO, VMCNO, JBUFSZ, BUFF1, BUFF2, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy relevant portion of IF
C                                       table.
      IIVER = 1
      OOVER = 1
      CALL CHNCOP (IIVER, OOVER, LUN1, LUN2, DISKIN, SCRVOL(VMCNO),
     *   CNOIN, SCRCNO(VMCNO), CATUV, CATBLK, BIF, EIF, FRQSEL,
     *   SFREQS, BUFF1, BUFF2, UBUFF, UBUFF(2049), IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Save header values.
      SAVNRP = NRPARM
      SAVLRC = LREC
      SAVCR0 = ICOR0
      SAVSTK = CATR(KRCIC+JLOCS)
      NRPARM = LREC
      LREC = 2 * SAVLRC - SAVNRP
      ICOR0 = 2
      CATR(KRCIC+JLOCS) = ABS (CATR(KRCIC+JLOCS))
      CATD(KDCRV+JLOCS) = 2.0D0
      CALL CATIO ('UPDT', SCRVOL(VMCNO), SCRCNO(VMCNO), CATBLK,
     *   'REST', BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1102) IRET
         GO TO 990
         END IF
C                                       Model computation
      CALL RLCFLX (IFNO, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       find corrections
      LTIMEP = -1.0E10
      LSOU = -10
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('SC', SCRVOL(VMCNO), SCRCNO(VMCNO), 1, IFILE, IRET)
      CALL ZOPEN (LUN1, IND, SCRVOL(VMCNO), IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
         END IF
      ILENBU = 1
      CALL UVINIT ('READ', LUN1, IND, NVIS, VO, LREC, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IPTRI = KBIND
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1121) IRET
         GO TO 990
         END IF
C                                       Read data
      TSCEND = -1.0E10
      LOPCNT = 0
      ISCAN = 0
      DO 200 LOOP = 1,NVIS+1
C                                       Read vis. record.
         CALL UVDISK ('READ', LUN1, IND, BUFF2, INIO, KBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1124) IRET
            GO TO 990
            END IF
         IPTRI = KBIND
         CTIME = BUFF2(IPTRI+ILOCT)
C                                       See if average finished
         IF ((CTIME.GT.TSCEND) .OR. (INIO.LE.0)) THEN
C                                       Average
            IF (TSCEND.GT.0.0) THEN
               IF (PW.GT.0.0) THEN
                  PRR = PRR / PW
                  PII = PII / PW
                  PRS = PRS / PW - PRR * PRR
                  PIS = PIS / PW - PII * PII
                  PRS = SQRT (MAX (0.0D0, PRS))
                  PIS = SQRT (MAX (0.0D0, PIS))
                  PCORR(IFNO,ISCAN) = ATAN2 (PII, PRR) * RAD2DG
                  IF (PRTLEV.GT.0) THEN
                     CTIME = PT / NT
                     CALL TODHMS (CTIME, PTIME)
                     PT = RAD2DG * SQRT ((PII*PRS)**2 +
     *                  (PRR*PIS)**2) / (PRR**2+PII**2)
                     WRITE (MSGTXT,1015) IFNO, PTIME, PCORR(IFNO,ISCAN),
     *                  PT, NW
                     CALL MSGWRT (3)
                     END IF
                  END IF
               END IF
            IF (INIO.LE.0) GO TO 210
C                                       new sub-scan
            ISCAN = ISCAN + 1
            NT = 0
            NW = 0
            PW = 0.0D0
            PRR = 0.0D0
            PII = 0.0D0
            PRS = 0.0D0
            PIS = 0.0D0
            PT = 0.0D0
            TSCEND = TSCAN(2,ISCAN)
            END IF
C                                       add in
         PT = PT + CTIME
         NT = NT + 1
         IP = IPTRI + SAVNRP - 7
         JP = IPTRI + NRPARM - 7
         DO 50 IC = 1,NC
            IP = IP + 6
            JP = JP + 6
            CHWT = MIN (BUFF2(IP+3), BUFF2(IP+6))
            CALL WANTCH (CHNS, IC, CHWT)
            IF (CHWT.GT.0.0) THEN
               RLMOD = CMPLX (BUFF2(JP+1)-BUFF2(JP+5),
     *            BUFF2(JP+2)+BUFF2(JP+4))
               LRMODS = CMPLX (BUFF2(JP+1)+BUFF2(JP+5),
     *            -BUFF2(JP+2)+BUFF2(JP+4))
               RLMOD = RLMOD / CABS (RLMOD)
               LRMODS = LRMODS / CABS (LRMODS)
               RLDAT = CMPLX (BUFF2(IP+1), BUFF2(IP+2))
               LRDATS = CMPLX (BUFF2(IP+4), -BUFF2(IP+5))
               RLDAT = RLDAT / CABS (RLDAT)
               LRDATS = LRDATS / CABS (LRDATS)
               RLDAT = RLDAT / RLMOD
               LRDATS = LRDATS / LRMODS
               PW = PW + CHWT
               NW = NW + 1
               D = REAL (RLDAT)
               PRR = PRR + D * CHWT
               PRS = PRS + D * D * CHWT
               D = AIMAG (RLDAT)
               PII = PII + D * CHWT
               PIS = PIS + D * D * CHWT
               PW = PW + CHWT
               NW = NW + 1
               D = REAL (LRDATS)
               PRR = PRR + D * CHWT
               PRS = PRS + D * D * CHWT
               D = AIMAG (LRDATS)
               PII = PII + D * CHWT
               PIS = PIS + D * D * CHWT
               END IF
 50         CONTINUE
 200     CONTINUE
C                                       Force new scratch files next
C                                       pass.
 210  VISDSK = 0
      VISCNO = 0
      VMCNO = 0
C                                       Close scratch files
      CALL ZCLOSE (LUN1, IND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1300) IRET
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1002 FORMAT ('Processing IF number',I3)
 1015 FORMAT ('IF',I3,' at',I3,'/',2(I2.2,':'),I2.2,F8.2,' +-',F6.2,
     *   '   Nsamp',I11)
 1100 FORMAT ('RLCSEL: NO DATA SELECTED FOR IF',I3)
 1102 FORMAT ('RLCSEL: ERROR ',I5,' UPDATING SCRATCH FILE CATBLK')
 1120 FORMAT ('RLCSEL: ZOPEN ERROR ',I3,' OPENING SCRATCH FILE')
 1121 FORMAT ('RLCSEL: UVINIT ERROR ',I3,' INITIALIZING SCRATCH FILE')
 1124 FORMAT ('RLCSEL: UVDISK ERROR ',I3,' READING SCRATCH FILE')
 1300 FORMAT ('RLCSEL: ZCLOSE ERROR ',I3,' CLOSING SCRATCH FILE')
      END
      SUBROUTINE RLCFLX (IFNO, IRET)
C-----------------------------------------------------------------------
C   RLCFLX includes the CLEAN model visibilities into the data.
C   The model visibilities computed are in the form of I,Q,U and V,
C   one IF at a time in and uv data file created by RLCSEL with space
C   for both observed and model visibilities.
C   If no model is found or a point model is specified then the flux
C   densities are obtained from the Source (SU) table.
C   Computes all four Stokes parameters if available.
C   Inputs: from commons
C     XNIT      R    Number of components to be computed.
C     VMDSK     I    Input file disk number (0=scratch)
C     VMCNO     I    Input file catalog number.
C     NAME2     C*12 CLEAN model name.
C     CLASS2    C*6  Clean model class (I,Q,U,V class)
C     DISK2     I    CLEAN file disk number.
C     XNMAP     R    Number of model files.
C     CCTVER    I    CC table version number.
C     VCALID    I    Calibrator ID numbers
C   Output:
C     CNOIN2    I    CLEAN file catalog number.
C     IRET      I    Return code, 0 => ok, otherwise not.
C-----------------------------------------------------------------------
      INTEGER   IFNO, IRET
C
      DOUBLE PRECISION APCORE(2)
      CHARACTER CLASS*6, STAT*4, CHSTOK(4)*1, UTYPE*2
      INTEGER   MODEL, METHOD, ISTOKE, DISKO, ISCR, CHAN, NCHAN, I,
     *   IROUND
      LOGICAL   DOMSG, DOSUM, F, WASOME
      INCLUDE 'RLCAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGDS.INC'
      INTEGER   BITER(MAXFLD)
      INCLUDE 'INCS:DSEL.INC'
      DATA DOMSG, DOSUM, F /.FALSE.,.FALSE.,.FALSE./
      DATA CHSTOK /'I','Q','U','V'/
C-----------------------------------------------------------------------
      IRET = 0
C                                       Set model and method
C                                       (Options limited by sort order.)
      MODEL = 0
      IF (CMOD.EQ.'COMP') MODEL = 1
      IF (CMOD.EQ.'IMAG') MODEL = 2
      IF (CMOD.EQ.'SUBI') MODEL = 3
      METHOD = 0
      IF (CMETH.EQ.'DFT ') METHOD = -1
      IF (CMETH.EQ.'GRID') METHOD = 1
      DOPTMD = (NAME2.EQ.' ') .AND. (CLAS2.EQ.' ')
C                                       ADD the models.
      FACGRD(1) = -1.0
      FACGRD(2) = 1.0
C                                       Can have only 1 source here with
C                                       known polarization.
      PTRAOF = XSMOD(5)
      PTDCOF = XSMOD(6)
C                                       Loop over four Stokes.
      DO 200 ISTOKE = 2,3
C                                       pointers for model routines
         NSTOK = 1
         KSTOK = ISTOKE
         VOFF = (ISTOKE-2) * 3
C                                       Point model only
         CLNMOD = .NOT.DOPTMD
         IF (DOPTMD) THEN
            PTFLX = VFLUX(ISTOKE,IFNO)
         ELSE
            PARMOD(1) = 0.0
C                                       Get info on model file(s)
            LIMFLX = XFLUX
            MFIELD = IROUND (XNMAP)
            IF (MFIELD.LE.0) MFIELD = 1
            NONEG = F
            WASOME = F
            DO 30 I = 1,MFIELD
               BITER(I) = 1
               IF (I.LE.MAXAFL) THEN
                  NCOMP(I) = ABS (XNCOMP(I)) + 0.1
                  IF (XNCOMP(I).LE.-1.0) NONEG = .TRUE.
                  IF (NCOMP(I).GT.0) WASOME = .TRUE.
               ELSE
                  NCOMP(I) = 0
                  IF (WASOME) NCOMP(I) = 1000000000
                  END IF
 30            CONTINUE
C                                       Get correct class
            CLASS = CLAS2
            CLASS(1:1) = CHSTOK(ISTOKE)(1:1)
            CNOIN2 = 1
            UTYPE = 'MA'
            CALL CATDIR ('SRCH', DISK2, CNOIN2, NAME2, CLASS, SEQ2,
     *         UTYPE, NLUSER, STAT, BUFF1, IRET)
C                                       cannot find - not allowed
            IF (IRET.NE.0) THEN
               MSGTXT = 'CANNOT FIND MODEL IMAGE'
               CALL MSGWRT (8)
               GO TO 999
               END IF
            CALL SETGDS (DISKIN, CNOIN, NAME2, CLASS, SEQ2, DISK2,
     *         MFIELD, CCTVER, NCOMP, BITER, MODEL, METHOD, BUFF1,
     *         BUFF2, ISTOKE, IRET)
            IF (IRET.NE.0) GO TO 999
            IF (MODEL.GT.0) THEN
               IF (MODEL.EQ.3) THEN
                  MSGTXT = 'Using sub-images for the source model'
               ELSE IF (MODEL.EQ.2) THEN
                  MSGTXT = 'Using images for the source model'
               ELSE
                  MSGTXT = 'Using Clean Component source model'
                  END IF
               CALL MSGWRT (3)
C              CALL FACSET (DISKIN, CNOIN, IFNO, SOUWAN(1), MODEL,
C    *            FACGRD(1), IRET)
C              IF (IRET.NE.0) GO TO 999
               END IF
            CNOIN2 = CCCNO(1)
            END IF
C                                       Compute model.
         DISKO = VMDSK
         ISCR = VMCNO
         CHAN = 1
         NUMIF = 1
         IF (JLOCIF.GT.0) NUMIF = CATBLK(KINAX+JLOCIF)
         NCHAN = CATBLK(KINAX+JLOCF)
         CALL UVMSUB (APCORE, DISKO, ISCR, DISKO, ISCR, 0, MODEL,
     *      METHOD, CHAN, NCHAN, DOSUM, DOMSG, CATBLK, JBUFSZ, FRQSEL,
     *      BUFF1, BUFF2, UBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL UNSETG (BUFF2)
 200     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE RLCHIS
C-----------------------------------------------------------------------
C   RLCHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER CTIME(2)*12, HILINE*72
      INTEGER   LUN, IERR, I, ITIME(3), DATE(3), K, J
      LOGICAL   T
      INCLUDE 'RLCAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN /28/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Open old history
      CALL HIOPEN (LUN, DISKIN, CNOIN, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (ITIME)
      CALL TIMDAT (ITIME, DATE, CTIME(2), CTIME)
      WRITE (HILINE,1000) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Add selection/calibration
C                                       criteria:
C                                       Sources
      WRITE (HILINE,3000) TSKNAM, I, CSNAME, VCALID
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Timerange
      CALL HITIME (TSTART, TEND, LUN, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Subarray
      WRITE (HILINE,3013) TSKNAM, SUBARR
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Flag table
      WRITE (HILINE,3014) TSKNAM, FGVER
      IF (DOFLAG) CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Calibration info
C                                       Gain tables
      IF (DOCAL) THEN
         WRITE (HILINE,3019) TSKNAM, CLUSE
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         END IF
C                                       Write control info.
C                                       CC tables
      IF (CLNMOD) THEN
C                                       CC File Name etc.
         CALL HENCO2 (TSKNAM, NAME2, CLAS2, SEQ2, DISK2, LUN, BUFF2,
     *      IERR)
         IF (IERR.NE.0) GO TO 190
C                                        CCfile version no.
         WRITE (HILINE,2001) TSKNAM, CCTVER
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                        Number of images
         WRITE (HILINE,2002) TSKNAM, MFIELD
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
C                                       Number of CLEAN components
C                                       actually used (incl FLUX)
         DO 30 I = 1,MFIELD
            NCOMP(I) = MAX (1, NSUBG(I)) - 1
            WRITE (HILINE,2003) TSKNAM, I, NCOMP(I)
            CALL HIADD (LUN, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 190
 30         CONTINUE
         END IF
C                                       Point source model
      IF (XSMOD(1).GE.1.0E-5) THEN
         WRITE (HILINE,2020) TSKNAM, XSMOD(2), XSMOD(3)
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         WRITE (HILINE,2021) TSKNAM, XSMOD(5), XSMOD(6)
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         END IF
C                                       spectral index
      IF (XSPECT(1,1).NE.0.0) THEN
         WRITE (HILINE,2030) TSKNAM, (XSPECT(J,1), J = 2,3),
     *      VCALID
         CALL HIADD (LUN, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 190
         END IF
C                                       Solution interval
      XSOLIN = XSOLIN * (24.0 * 60.0)
      WRITE (HILINE,2022) TSKNAM, XSOLIN
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       IFs.
      BIF = XBIF + 0.01
      EIF = XEIF + 0.01
      WRITE (HILINE,2025) TSKNAM, BIF, EIF
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Channel selection
      DO 65 K = BIF,EIF
         DO 60 I = 1,20
            IF ((CHNSEL(1,I,K).GT.0) .AND.
     *         (CHNSEL(2,I,K).GE.CHNSEL(1,I,K))) THEN
               WRITE (HILINE,3050) TSKNAM, (CHNSEL(J,I,K), J = 1,3), K
               CALL HIADD (LUN, HILINE, BUFF2, IERR)
               IF (IERR.NE.0) GO TO 190
               END IF
 60         CONTINUE
 65      CONTINUE
C                                       Close HI file
 190   CALL HICLOS (LUN, T, BUFF2, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 2001 FORMAT (A6,'INVER = ',I5,' /CC file version no.')
 2002 FORMAT (A6,'NMAPS =',I4,' /NUMBER OF CLEAN IMAGES USED')
 2003 FORMAT (A6,'NCOMP(',I3,') = ',I8,' /Number of CLEAN comps.')
 2020 FORMAT (A6,'PMODEL =',F9.4,',',F9.4,' / Q, U fluxes')
 2021 FORMAT (A6,'        ',2(F9.3,','),F9.3,' /Poln. model')
 2022 FORMAT (A6,'SOLINT =',F10.3,' /Solution interval (min)')
 2025 FORMAT (A6,'BIF =',I3,', EIF =',I4,' /IFs processed')
 2030 FORMAT (A6,'XSPECT=',2F7.3,'  / Q, U spectral index source',I3)
 3000 FORMAT (A6,'CALSOUR(',I2,') = ''',A,''' ID=',I4,'  / cal source')
 3013 FORMAT (A6,'SUBARRAY =',I4)
 3014 FORMAT (A6,'FLAGVER =',I3,' /Flagging table used')
 3019 FORMAT (A6,'GAINUSE = ',I3,' /CL table applied')
 3050 FORMAT (A6,'/ Chns used: Start, Stop, Inc ',2I5,I4,'  IF=',I3)
      END
      SUBROUTINE RLCCOP (DISK, CNOSCR, BUFFER, BUFSZ, IRET)
C-----------------------------------------------------------------------
C   Routine to copy selected data from one data file to another
C   optionally applying calibration and editing information.
C   The input file should have been opened with UVGET.
C     Note: UVGET returns the information necessary to catalog the
C   output file.  The output file will be compressed if necessary at
C   completion of RLCCOP.
C   Inputs:
C      DISK     I       Disk number for catalogd output file.
C                       If .LE. 0 then the output file is a /CFILES/
C                       scratch file.
C      BUFFER   R(*)    Work buffer for writing.
C      BUFSZ    I       Size of BUFFER in bytes.
C
C   Input via common:
C      LREC     I       (/UVHDR/) length of vis. record in R words.
C      NRPARM   I       (/UVHDR/) number of R random parameters.
C   In/out:
C      CNOSCR   I       Catalog slot number for if cataloged file;
C                       /CFILES/ scratch file number if a scratch file,
C                       IF DISK=CNOSCR=0 then the scratch is created.
C                       On output = Scratch file number if created.
C   In/out via common:
C      CATBLK   I(256)  Catalog header block from UVGET
C                       on output with actual no. records
C      NVIS     I       (/UVHDR/) Number of vis. records.
C   Output:
C      IRET     I       Error code: 0 => OK,
C                          > 0 => failed, abort process.
C   Usage notes:
C   (1) UVGET with OPCODE='INIT' MUST be called before RLCCOP to setup
C       for calibration, editing and data translation.  If an output
C       cataloged file is to be created this should be done after the
C       call to UVGET.
C   (2) Uses AIPS LUNs 24 and 27
C-----------------------------------------------------------------------
      INTEGER   DISK, CNOSCR, BUFSZ, IRET
      REAL      BUFFER(*)
C
      INCLUDE 'INCS:ZPBUFSZ.INC'
      CHARACTER NAME*48
      INTEGER   VOL, LUN, FIND, BIND, LENBU, NIO, CNO, BO, VO, I,
     *   XCOUNT, ISIZE, JERR
      LOGICAL   DONX
      REAL      STIME, UTIME, ETIME
      PARAMETER (LUN = 24)
      INCLUDE 'RLCAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA BO, VO /1,0/
C-----------------------------------------------------------------------
      IRET = 0
      LENBU = 1
      DONX = NSCANS.LE.0
      IF ((DONX) .AND. (XSOLIN.LE.0.0)) XSOLIN = 10.0 / (24.0 * 60.0)
      STIME = -100.
      ETIME = -101.
C                                       Create output file if necessary
      IF ((DISK.EQ.0) .AND. (CNOSCR.EQ.0)) THEN
C                                       Determine size.
         CALL UVSIZE (LREC, NVIS, ISIZE)
C                                       Create scratch file.
         CALL SCREAT (ISIZE, BUFFER, IRET)
         CNOSCR = NSCR
         IF (IRET.NE.0) THEN
            IF (IRET.EQ.1) WRITE (MSGTXT,1000)
            IF (IRET.GT.1) WRITE (MSGTXT,1001) IRET
            GO TO 990
            END IF
C                                       Update CATBLK.
         CALL CATIO ('UPDT', SCRVOL(CNOSCR), SCRCNO(CNOSCR), CATBLK,
     *      'REST', BUFFER, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1002) IRET
            END IF
         END IF
C                                       Set output file name.
      IF (DISK.GT.0) THEN
         CNO = CNOSCR
         VOL = DISK
         CALL ZPHFIL ('UV', VOL, CNOSCR, 1, NAME, IRET)
      ELSE
         CNO = SCRCNO(CNOSCR)
         VOL = SCRVOL(CNOSCR)
         CALL ZPHFIL ('SC', VOL, SCRCNO(CNOSCR), 1, NAME, IRET)
         END IF
C                                       Open output file.
      CALL ZOPEN (LUN, FIND, VOL, NAME, .TRUE., .FALSE., .TRUE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1003) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      CALL UVINIT ('WRIT', LUN, FIND, NVIS, VO, LREC, LENBU, BUFSZ,
     *    BUFFER, BO, BIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1005) IRET
         GO TO 990
         END IF
      DO 100 I = 1,NVIS
         XCOUNT = I
C                                       Read old.
         CALL UVGET ('READ', BUFFER(BIND), BUFFER(BIND+NRPARM), IRET)
         IF (IRET.LT.0) GO TO 110
         IF (IRET.NE.0) GO TO 999
         IF (DONX) THEN
            UTIME = BUFFER(BIND+ILOCT)
            IF (UTIME.GT.ETIME) THEN
               NSCANS = NSCANS + 1
               ETIME = UTIME + XSOLIN
               TSCAN(1,NSCANS) = UTIME
               END IF
            TSCAN(2,NSCANS) = MAX (UTIME, TSCAN(2,NSCANS))
            END IF
C                                       Write new
         NIO = 1
         CALL UVDISK ('WRIT', LUN, FIND, BUFFER, NIO, BIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1008) IRET
            GO TO 990
            END IF
 100     CONTINUE
C                                       Check if last call to UVGET
C                                       returned valid data.
 110  IF (IRET.LT.0) XCOUNT = XCOUNT - 1
      NIO = 0
      CALL UVDISK ('FLSH', LUN, FIND, BUFFER, NIO, BIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1008) IRET
         GO TO 990
         END IF
C                                       Close input
      CALL UVGET ('CLOS', BUFFER(BIND), BUFFER(BIND+NRPARM), IRET)
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, VOL, CNO, LUN, CATBLK, IRET)
C                                      Put vis. count in CATBLK
      CATBLK(KIGCN) = NVIS
C                                       Update CATBLK.
      CALL CATIO ('UPDT', VOL, CNO, CATBLK, 'REST', BUFFER, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1002) IRET
         END IF
      CALL UVPGET (JERR)
C                                       Close output
      CALL ZCLOSE (LUN, FIND, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RLCCOP: TOO LITTLE DISK SPACE FOR SCRATCH FILE')
 1001 FORMAT ('RLCCOP: ERROR ',I5,' CREATING SCRATCH FILE')
 1002 FORMAT ('RLCCOP: ERROR ',I5,' UPDATING SCRATCH FILE CATBLK')
 1003 FORMAT ('RLCCOP: ERROR ',I5,' OPENING OUTPUT FILE')
 1005 FORMAT ('RLCCOP: ERROR ',I5,' INIT. OUTPUT FILE')
 1008 FORMAT ('RLCCOP: ERROR ',I5,' WRITING OUTPUT FILE')
      END

LOCAL INCLUDE 'XMBUFRS'
      INCLUDE 'INCS:PMAD.INC'
      REAL      BUFF1(MABFSS), BUFF2(MABFSS)
      INTEGER   IBUFF1(MABFSS), IBUFF2(MABFSS), SCRTCH(512)
      EQUIVALENCE (IBUFF1, BUFF1), (IBUFF2, BUFF2)
      COMMON /BUFRS/ BUFF1, BUFF2, SCRTCH
LOCAL END
LOCAL INCLUDE 'LISPX.INC'
      INTEGER   MAXFQ, MAXSP
      PARAMETER (MAXSP=100)
      PARAMETER (MAXFQ=32768)
C
      INCLUDE 'XMBUFRS'
      CHARACTER INFILE*48, OUFILE*48, OPTYPE*4, FUNCTY(7)*2,
     *   CUNITS(7)*8, SPCHAR(MAXSP)*128
      HOLLERITH XINFIL(12), XOUFIL(12), XOPTYP(1)
      REAL      FCUT, REFREQ, DPARM(10), CPARM(10)
      DOUBLE PRECISION XFREQ(MAXFQ)
      REAL      XDATA(MAXFQ), XRMS(MAXFQ), SPIX(7,MAXSP)
      INTEGER   NSPEC, FVALU(MAXSP)
      COMMON /INPARM/ XINFIL, XOUFIL, FCUT, REFREQ, XOPTYP, DPARM, CPARM
      COMMON /CHPARM/ INFILE, OUFILE, SPCHAR, OPTYPE, FUNCTY, CUNITS
      COMMON /PARMS/ XFREQ, XDATA, XRMS, FVALU, NSPEC, SPIX
LOCAL END
LOCAL INCLUDE 'LISPX.TV'
      INTEGER   IGR1, IGR2, IGR3, IGR4, IGR5, IGR7, IPL(2)
      INCLUDE 'INCS:DTVC.INC'
      COMMON /TVLISP/ IGR1, IGR2, IGR3, IGR4, IGR5, IGR7, IPL
LOCAL END
      PROGRAM LISPX
C-----------------------------------------------------------------------
C! LISPX fits 1-D spectral indexes from a text file
C# Map-util Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   LISPX fits 1-dimensional spectral inices to spectra from a text file
C   It fits and then allows TV interaction to blank bad values
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INFILE         INFILE        Text file with data
C      OUTFILE        OUFILE        Optional output text file
C      FLUX           FCUT          Flux cutoff: use only data >
C                                   FLUX.
C      OPTYPE         XOPTY         'CURV' to do curvature
C      DPARM          DPARM         Blanking on values
C      CPARM          CPARM         blanking on uncertainties
C   Programmer Eric W. Greisen  2025
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, ITYP
      INCLUDE 'LISPX.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'LISPX'/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL LISPIN (PRGM, ITYP, IRET)
C                                       Call routine that sends data
C                                       to the user routine.
      IF (IRET.EQ.0) CALL LISPDO (ITYP, IRET)
      IF (IRET.EQ.0) CALL LISPTV (ITYP, IRET)
      IF (IRET.EQ.0) CALL LISPOU (ITYP, IRET)
C                                       Close down files, etc.
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE LISPIN (PRGN, ITYP, IRET)
C-----------------------------------------------------------------------
C   LISPIN gets input parameters for LISPX.
C   Inputs:
C      PRGN     C*6    Program name (2 chars/word)
C   Output:
C      ITYP     I      # output parameters
C      IRET     I      Error code: 0 => ok
C                                4 => user routine detected error.
C                                5 => catalog troubles
C                                8 => can't start
C                               <0 => failed to get all frequencies
C      /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN(6)
      INTEGER   ITYP, IRET
C
      INTEGER   IERR, NPARM
      INCLUDE 'LISPX.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 47
      CALL GTPARM (PRGN, NPARM, RQUICK, XINFIL, SCRTCH, IERR)
      RQUICK = .FALSE.
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      CALL H2CHR (48, 1, XINFIL, INFILE)
      CALL H2CHR (48, 1, XOUFIL, OUFILE)
      CALL H2CHR (12, 1, XOPTYP, OPTYPE)
      ITYP = 5
      IF (OPTYPE.EQ.'CURV') ITYP = 7
C                                       reference freq
      IF (REFREQ.LE.0.0) REFREQ = 1.0
C                                       set DPARM defaults
      IF (DPARM(1).LT.0.0) DPARM(1) = 0
      IF (DPARM(2).EQ.0.0) DPARM(2) = -1.E8
      IF (DPARM(3).EQ.0.0) DPARM(3) = 1.E8
      IF (DPARM(4).LT.0.0) DPARM(4) = 0
      IF (DPARM(5).EQ.0.0) DPARM(5) = 1.E8
      IF (DPARM(6).LT.0.0) DPARM(6) = 0
      IF (DPARM(7).EQ.0.0) DPARM(7) = 1.E8
      IF (DPARM(8).EQ.0.0) DPARM(8) = -1.E8
      IF (DPARM(9).EQ.0.0) DPARM(9) = 1.E8
      DPARM(10) = 0.0
      IF (CPARM(1).LE.0.0) CPARM(1) = 1.E8
      IF (CPARM(2).LE.0.0) CPARM(2) = 1.E8
      IF (CPARM(3).LE.0.0) CPARM(3) = 1.E8
C                                       Read data
      CALL READIT (IRET)
      IF (IRET.NE.0) GO TO 990
      IF (NSPEC.LE.0) THEN
         MSGTXT = 'YOU MUST DEFINE SOME SPECTRA'
         IF (IRET.EQ.0) CALL MSGWRT (8)
         IRET = 10
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('LISPIN: ERROR',I3,' ON ',A)
      END
      SUBROUTINE READIT (IRET)
C-----------------------------------------------------------------------
C   Read the input text file, find the spectra
C   Output
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'LISPX.INC'
      CHARACTER LINE*128
      INTEGER   TLUN, TIND, J, JTRIM, M, N, LUNTMP, I1, I2, LLIM, LP
      DOUBLE PRECISION X
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (INFILE.EQ.' ') THEN
         IRET = 10
         MSGTXT = 'YOU MUST SPECIFY INFILE'
         GO TO 999
      END IF
      TLUN = LUNTMP (2)
C                                       open the text file
      CALL ZTXOPN ('READ', TLUN, TIND, INFILE, .FALSE., IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN INPUT TEXT FILE'
         GO TO 999
         END IF
      N = 0
      M = 0
 10   CALL ZTXIO ('READ', TLUN, TIND, LINE, IRET)
      IF (IRET.EQ.2) THEN
         IRET = 0
         NSPEC = N
         FVALU(N+1) = M+1
         CALL ZTXCLS (TLUN, TIND, J)
      ELSE IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING INPUT TEXT FILE'
      ELSE
         LLIM = JTRIM (LINE)
         IF ((LLIM.LE.0) .OR. (LINE(1:).EQ.'#')) GO TO 10
         IF (LINE(:4).EQ.'SPEC') THEN
            N = N + 1
            FVALU(N) = M + 1
            SPCHAR(N) = ' '
            I1 = INDEX (LINE, '''')
            IF (I1.GT.0) THEN
               I2 = INDEX (LINE(I1+1:), '''')
               IF (I2.LE.0) I2 = LLIM - I1 + 1
               I2 = I2 + I1 - 1
               I1 = I1 + 1
               SPCHAR(N) = LINE(I1:I2)
               END IF
         ELSE
            M = M + 1
            LP = 1
            CALL GETNUM (LINE, LLIM, LP, X)
            IF ((X.EQ.DBLANK) .OR. (X.LE.0.0))THEN
               M = M - 1
               GO TO 10
            ELSE
               XFREQ(M) = X
               END IF
            CALL GETNUM (LINE, LLIM, LP, X)
            IF (X.EQ.DBLANK) THEN
               M = M - 1
               GO TO 10
            ELSE
               XDATA(M) = X
               END IF
            CALL GETNUM (LINE, LLIM, LP, X)
            IF (X.EQ.DBLANK) THEN
               XRMS(M) = FBLANK
            ELSE
               XRMS(M) = X
               END IF
            END IF
         GO TO 10
         END IF
C                                       go to log space
      DO 100 J = 1,M
         XFREQ(J) = LOG10 (XFREQ(J)/REFREQ)
 100     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('READIT: ERROR',I4,' ON ',A)
      END
      SUBROUTINE LISPDO (ITYP, IRET)
C-----------------------------------------------------------------------
C   LISPDO sends image one row at a time to the moment fitting
C   routine and then saves the answers
C   Inputs
C      ITYP     I      # answers (5 or 7)
C   Output:
C      IRET     I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   ITYP, IRET
C
      INTEGER   I, I1, N
      INCLUDE 'LISPX.INC'
      REAL      ANSWER(7)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      DO 100 I = 1,NSPEC
         N = FVALU(I+1) - FVALU(I)
         I1 = FVALU(I)
C                                       Call DO1SPX
         IF (OPTYPE.NE.'CURV') THEN
            CALL DO1SPX (N, XFREQ(I1), XDATA(I1), ANSWER)
         ELSE
            CALL DO2SPX (N, XFREQ(I1), XDATA(I1), ANSWER)
            END IF
C                                       Save answer
         DO 20 I1 = 1,ITYP
            SPIX(I1,I) = ANSWER(I1)
 20         CONTINUE
 100     CONTINUE
      IRET = 0
C
 999  RETURN
      END
      SUBROUTINE DO1SPX (N, XF, XD, RESULT)
C-----------------------------------------------------------------------
C   DO1SPX fits spectral index to a row of an image and returns the
C   answers in RESULT.
C   Inputs:
C      N        I      Number samples in spectrm
C      XF       D(*)   Frequencies
C      XD       R(*)   Data
C   Values from commons:
C      FCUT     R      Flux cutoff
C   Output:
C      RESULT   R      (count, br, br err, spix sp err,...)
C-----------------------------------------------------------------------
      INTEGER   N
      DOUBLE PRECISION XF(*)
      REAL      XD(*), RESULT(*)
C
      INTEGER   INPTS, I, IRET
      REAL      LFCUT, V , TMIN, TMAX
      DOUBLE PRECISION X, Y, SXX, SX, SY, SXY, SN, DET, VM, VB, SDD
      LOGICAL   FAIL
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'LISPX.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Not last call
      CALL RFILL (5, FBLANK, RESULT)
      IF (N.GT.0) THEN
         LFCUT = FCUT
         LFCUT = MAX (1.E-10, LFCUT)
         INPTS = N
         SXX = 0.0
         SX  = 0.0
         SXY = 0.0
         SY  = 0.0
         SN  = 0.0
         TMIN = 1.E8
         TMAX = -TMIN
         DO 20 I = 1,INPTS
            V = XD(I)
            IF ((V.GT.LFCUT) .AND. (V.NE.FBLANK)) THEN
               TMIN = MIN (TMIN, V)
               TMAX = MAX (TMAX, V)
               Y = LOG10 (V)
               X = XF(I)
               SX = SX + X
               SY = SY + Y
               SXX = SXX + X * X
               SXY = SXY + X * Y
               SN = SN + 1.0
               END IF
 20         CONTINUE
         IRET = 0
         DET = SN * SXX - SX * SX
         FAIL = (DET.LE.0.0) .OR. (SN.LE.1.5)
         IF (.NOT.FAIL) THEN
            VB = (SXX * SY - SX * SXY) / DET
            VM = (SN * SXY - SX * SY) / DET
C                                       find overall sigma**2
            SDD = 0.0
            DO 30 I = 1,INPTS
               Y = XD(I)
               IF ((Y.GT.LFCUT) .AND. (Y.NE.FBLANK)) THEN
                  Y = LOG10 (Y)
                  X = XF(I)
                  SDD = SDD + (VM * X + VB - Y)**2
                  END IF
 30            CONTINUE
            IRET = 0
            SDD = SDD / SN
            RESULT(2) = VB
            RESULT(4) = VM
            RESULT(1) = SN
            RESULT(3) = SQRT (SDD * SXX / DET)
            RESULT(5) = SQRT (SN * SDD / DET)
            RESULT(6) = 0.0
            RESULT(7) = 0.0
C                                       but want T not log T
            RESULT(2) = 10.0 ** (RESULT(2))
            RESULT(3) = RESULT(2) * RESULT(3)
C                                       test results
            IF (RESULT(1).LT.DPARM(1)) FAIL = .TRUE.
            IF (RESULT(4).LT.DPARM(2)) FAIL = .TRUE.
            IF (RESULT(4).GT.DPARM(3)) FAIL = .TRUE.
            IF (TMIN.GT.0.0) THEN
               IF (RESULT(2)/TMIN.LT.DPARM(4)) FAIL = .TRUE.
               END IF
            IF (RESULT(2)/TMAX.GT.DPARM(5)) FAIL = .TRUE.
            IF (RESULT(2).LT.DPARM(6)) FAIL = .TRUE.
            IF (RESULT(2).GT.DPARM(7)) FAIL = .TRUE.
            IF (RESULT(3).GT.CPARM(1)) FAIL = .TRUE.
            IF (RESULT(5).GT.CPARM(2)) FAIL = .TRUE.
            IF (FAIL) DPARM(10) = DPARM(10) + 1.0
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE DO2SPX (N, XF, XD, RESULT)
C-----------------------------------------------------------------------
C   DO2SPX fits spectral index plus curvature to a spectrum and
C   returns the answers in RESULT.
C   Inputs:
C      N        I      Number samples in spectrm
C      XF       D(*)   Frequencies
C      XD       R(*)   Data
C   Values from commons:
C      FCUT     R      Flux cutoff
C   Output:
C      RESULT   R      (count, br, br err, spix sp err,...)
C-----------------------------------------------------------------------
      INTEGER   N
      DOUBLE PRECISION XF(*)
      REAL      XD(*), RESULT(*)
C
      INTEGER   INPTS, I, IRET
      REAL      LFCUT, V, TMAX, TMIN
      DOUBLE PRECISION X, Y, SXXXX, SXXX, SXX, SX, SY, SXY, SXXY, SN,
     *   DET, VM, VB, VC, SDD, AB, AC, AM, BB, BC, BM, CB, CC, CM
      LOGICAL   FAIL
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'LISPX.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      CALL RFILL (7, FBLANK, RESULT)
C                                       Not last call
      IF (N.GT.0) THEN
         LFCUT = FCUT
         LFCUT = MAX (1.E-10, LFCUT)
         INPTS = N
         SXXXX = 0.0
         SXXX = 0.0
         SXX = 0.0
         SX = 0.0
         SXXY = 0.0
         SXY = 0.0
         SY = 0.0
         SN = 0.0
         TMIN = 1.E8
         TMAX = -TMIN
         DO 20 I = 1,INPTS
            V = XD(I)
            IF ((V.GT.LFCUT) .AND. (V.NE.FBLANK)) THEN
               TMIN = MIN (TMIN, V)
               TMAX = MAX (TMAX, V)
               Y = LOG10 (V)
               X = XF(I)
               SX = SX + X
               SY = SY + Y
               SXX   = SXX + X * X
               SXXXX = SXXXX + X * X * X * X
               SXXX  = SXXX + X * X * X
               SXXY = SXXY + X * X * Y
               SXY = SXY + X * Y
               SN = SN + 1.0
               END IF
 20         CONTINUE
         IRET = 0
         DET = SN*SXXXX*SXX - SXXXX*SX*SX - SN*SXXX*SXXX +
     *      2.0*SXXX*SXX*SX  - SXX*SXX*SXX
         FAIL = (DET.LE.0.0) .OR. (SN.LE.2.5)
         IF (.NOT.FAIL) THEN
C                                       const (log brightness)
            AB = (SXXX*SX - SXX*SXX) / DET
            BB = (SXXX*SXX - SXXXX*SX) / DET
            CB = (SXXXX*SXX - SXXX*SXXX) / DET
            VB = (SXXY * AB + SXY * BB + SY * CB)
C                                       slope (spectral index)
            AM = (SXX*SX - SN*SXXX) / DET
            BM = (SN*SXXXX - SXX*SXX) / DET
            CM = (SXXX*SXX - SXXXX*SX) / DET
            VM = (SXXY * AM + SXY * BM + SY * CM)
C                                       curvature
            AC = (SN*SXX - SX*SX) / DET
            BC = (SXX*SX - SN*SXXX) / DET
            CC = (SXXX*SX - SXX*SXX) / DET
            VC = (SXXY * AC + SXY * BC + SY * CC)
C                                       find overall sigma**2
            SDD = 0.0
            DO 30 I = 1,INPTS
               Y = XD(I)
               IF ((Y.GT.LFCUT) .AND. (Y.NE.FBLANK)) THEN
                  Y = LOG10 (Y)
                  X = XF(I)
                  SDD = SDD + (VC * X * X + VM * X + VB - Y)**2
                  END IF
 30            CONTINUE
            IRET = 0
            SDD = SDD / SN
            RESULT(2) = VB
            RESULT(4) = VM
            RESULT(1) = SN
            RESULT(6) = VC
C                                       error bars
            X = AB * AB * SXXXX + BB * BB * SXX + CB * CB +
     *         2. * (AB*BB*SXXX + AB*CB*SXX + BB*CB*SX)
            X = ABS (X)
            RESULT(3) = SQRT (SDD * X)
            X = AM * AM * SXXXX + BM * BM * SXX + CM * CM +
     *         2. * (AM*BM*SXXX + AM*CM*SXX + BM*CM*SX)
            X = ABS (X)
            RESULT(5) = SQRT (SDD * X)
            X = AC * AC * SXXXX + BC * BC * SXX + CC * CC +
     *         2. * (AC*BC*SXXX + AC*CC*SXX + BC*CC*SX)
            X = ABS (X)
            RESULT(7) = SQRT (SDD * X)
C                                       but want T not log T
            RESULT(2) = 10.0 ** (RESULT(2))
            RESULT(3) = RESULT(2) * RESULT(3)
C                                       test results
            IF (RESULT(1).LT.DPARM(1)) FAIL = .TRUE.
            IF (RESULT(4).LT.DPARM(2)) FAIL = .TRUE.
            IF (RESULT(4).GT.DPARM(3)) FAIL = .TRUE.
            IF (TMIN.GT.0.0) THEN
               IF (RESULT(2)/TMIN.LT.DPARM(4)) FAIL = .TRUE.
               END IF
            IF (RESULT(2)/TMAX.GT.DPARM(5)) FAIL = .TRUE.
            IF (RESULT(2).LT.DPARM(6)) FAIL = .TRUE.
            IF (RESULT(2).GT.DPARM(7)) FAIL = .TRUE.
            IF (RESULT(6).LT.DPARM(8)) FAIL = .TRUE.
            IF (RESULT(6).GT.DPARM(9)) FAIL = .TRUE.
            IF (RESULT(3).GT.CPARM(1)) FAIL = .TRUE.
            IF (RESULT(5).GT.CPARM(2)) FAIL = .TRUE.
            IF (RESULT(7).GT.CPARM(3)) FAIL = .TRUE.
            IF (FAIL) DPARM(10) = DPARM(10) + 1.0
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE LISPTV (ITYP, IRET)
C-----------------------------------------------------------------------
C   LISPTV interacts with user and answers
C   Inputs
C      ITYP     I      # answers (5 or 7)
C   In/output in COMMON
C      SPIX     R(*)   Answer images
C   Output:
C      IRET     I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   ITYP, IRET
C
      INTEGER   I, J, MTYPE, MCOL, MROWS(2), GRCHS(2), TIMLIM, CHS,
     *   TVBUT, TOPSEP, SIDSEP, NTITL
      CHARACTER CHOIC1(4)*16, CHOICS(10)*16, ROUTIN*6, ISHELP*6,
     *   TITLE*128
      LOGICAL   LEAVE(10)
      INCLUDE 'LISPX.INC'
      INCLUDE 'LISPX.TV'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA CHOIC1 /'EXIT', 'ABORT', ' ', 'REDO ALL'/
      DATA LEAVE /.FALSE., 9*.TRUE./
C-----------------------------------------------------------------------
      TITLE = ' '
      CALL TVOPEN (SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING TV DISPLAY'
         GO TO 990
         END IF
      CALL YINIT (BUFF1, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT THE TV DISPLAY'
         GO TO 990
         END IF
C                                       prepare menu
      J = 4
      DO 10 I = 1,4
         CHOICS(I) = CHOIC1(I)
 10      CONTINUE
      MROWS(1) = J
      MTYPE = 0
      MCOL = 1
C                                       turn on graphics
      IGR1 = 1 + NGRAY
      IGR2 = 2 + NGRAY
      IGR3 = 3 + NGRAY
      IGR4 = 4 + NGRAY
      IGR5 = 5 + NGRAY
      IGR7 = 7 + NGRAY
      ROUTIN = 'YSLECT'
      CALL YSLECT ('ONNN', IGR1, 0, IBUFF1, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL YSLECT ('ONNN', IGR2, 0, IBUFF1, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL YSLECT ('ONNN', IGR3, 0, IBUFF1, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL YSLECT ('ONNN', IGR4, 0, IBUFF1, IRET)
      IF (IRET.NE.0) GO TO 980
      GRCHS(1) = 2
      GRCHS(2) = 1
      TOPSEP = 3
      SIDSEP = 10
      ISHELP = TSKNAM
      TIMLIM = 0
      NTITL = 0
C                                       title lines
 50   CALL TVMENU (MTYPE, MCOL, MROWS, GRCHS, TOPSEP, SIDSEP, ISHELP,
     *   CHOICS, TIMLIM, LEAVE, NTITL, TITLE, CHS, TVBUT, IBUFF2, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'RETURNED FROM TVMENU'
         GO TO 990
         END IF
C                                       case statement
C                                       exit
      IF (CHOICS(CHS).EQ.'EXIT') THEN
         MSGTXT = 'Bye-bye'
         CALL MSGWRT (2)
         GO TO 990
      ELSE IF (CHOICS(CHS).EQ.'ABORT') THEN
         MSGTXT = 'Bye-bye and skip output text'
         CALL MSGWRT (2)
         IRET = 10
         GO TO 990
C                                       blank
      ELSE IF (CHOICS(CHS).EQ.' ') THEN
C                                       redo all
      ELSE IF (CHOICS(CHS).EQ.'REDO ALL') THEN
         CALL YZERO (IGR5, IRET)
         CALL YZERO (1, IRET)
         CALL UPDALL (ITYP, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'RE-DOING ALL'
            GO TO 990
            END IF
         END IF
      GO TO 50
C                                       TV function failure
 980  WRITE (MSGTXT,1000) IRET, 'TV INIT FUNCTIONS'
C
 990  IF ((IRET.GT.0) .AND. (IRET.NE.99)) CALL MSGWRT (8)
      CALL TVCLOS (SCRTCH, J)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('LISPTV ERROR',I4,' ON A',A)
      END
      SUBROUTINE UPDALL (ITYP, IRET)
C-----------------------------------------------------------------------
C   UPDALL re-does fitting on all spectra
C   Inputs:
C      ITYP   I      # parameters (5, 7)
C   In/out in COMMON
C      SPIX   R(*)   Answers
C   Output:
C      IRET   I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   ITYP, IRET
C
      INCLUDE 'LISPX.INC'
      INTEGER   I, N, I1
      REAL      ANSWER(7)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      DO 100 I = 1,NSPEC
         N = FVALU(I+1) - FVALU(I)
         I1 = FVALU(I)
         CALL RCOPY (ITYP, SPIX(1,I), ANSWER)
         CALL SPREDO (I, N, ITYP, XFREQ(I1), XDATA(I1), ANSWER, IRET)
         IF (IRET.EQ.99) THEN
            WRITE (MSGTXT,1000) I-1, NSPEC
            CALL MSGWRT (6)
            IRET = 0
            GO TO 999
            END IF
         IF (IRET.NE.0) GO TO 999
         CALL RCOPY (ITYP, ANSWER, SPIX(1,I))
 100     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Only',i3,' spectra of',I3,' processed before QUIT',
     *   'requested')
      END
      SUBROUTINE SPREDO (ISP, NZ, ITYP, XF, XD, RESULT, IRET)
C-----------------------------------------------------------------------
C   SPREDO displays a spectrum, allows interaction to fit, flag data
C   returns new values to the answer
C   Inputs
C      ISP     I      Spectrum number
C      NZ      I      # spectral points
C      ITYP    I      # answers (5 or 7)
C      XF      D(*)   Frequencies
C      XD      R(*)   spectrum
C   In/Output:
C     RESULT  R(*)   Initial/New fit parms (or blanked)
C     Output
C      IRET    I      =99 -> QUIT, else TV error
C-----------------------------------------------------------------------
      INTEGER   ISP, NZ, ITYP, IRET
      REAL      XD(*), RESULT(*)
      DOUBLE PRECISION XF(*)
C
      INCLUDE 'LISPX.INC'
      INCLUDE 'LISPX.TV'
      INTEGER   I, J, MCOL, MROWS(1), TVWIND(4), IDROP(2), LABEL,
     *   IDEPTH(5), TVSIZE(2), IX1, IY1, IX2, IY2, ICHL, ICHB, ICHR,
     *   ICHT, NYA, NXA, IDX, IDY, I4XTRA, NTEXT, MTYPE, TIMLIM, TOPSEP,
     *   SIDSEP, GRCHS(2), CHS, TVBUT, IPOS(7), NPIX, NROW, IM,
     *   LXPT(MAXFQ), LYPT(MAXFQ), IR, IP, IBUT, ITW(3), QUAD, LBUT
      CHARACTER CHOICS(10)*12, TEXT(2)*80, MSGBUF*80, ISHELP*8, TITLE*80
      REAL      D, LDATA(16384), LRES(7), LMOD(MAXFQ), VMIN, VMAX, YGAP,
     *   RANGE(2), PBLC(2), PTRC(2), XBLC(7), XTRC(7), FQFINC, CH(4),
     *   XYRATO, X, XX, Y, DY, DX, XFAC, XOFF, RPOS(2), PPOS(2), VX, VY,
     *   XM(2)
      LOGICAL   LEAVE(10), DOIT, T, F
      DOUBLE PRECISION FF, FMIN, FMAX, FFMN, FFMX
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVS.INC'
      DATA CHOICS /'CHAN RANGE', 'RESET CHANS', 'FLAG POINTS',
     *   'UNDO FLAGS', 'NEW FIT', ' ', 'GOOD', 'BAD', ' ', 'QUIT'/
      DATA MCOL, MTYPE, TIMLIM, TOPSEP, SIDSEP /1, -1, 0, 1, 10/
      DATA MROWS /10/
      DATA LRES, IPOS /7*0.0, 7*1/
      DATA IDROP, IDEPTH, LABEL /0,0, 5*1, 3/
      DATA LEAVE /10*.TRUE./
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IRET = 0
C                                       make local copies
      IF (NZ.GT.16384) THEN
         MSGTXT = 'SPECTRUM TOO LARGE FOR ME'
         GO TO 980
         END IF
      CALL RCOPY (NZ, XD, LDATA)
      CALL RCOPY (ITYP, RESULT, LRES)
      DO 5 I = 1,ITYP
         IF (LRES(I).EQ.FBLANK) THEN
            CALL RCOPY (ITYP, FBLANK, RESULT)
            WRITE (MSGTXT,1010) ISP
            CALL MSGWRT (6)
            GO TO 999
            END IF
 5       CONTINUE
C                                       X axis range
      FMIN = 1.D15
      FMAX = -FMIN
      DO 10 I = 1,NZ
         FF = 10.0D0**XF(I)
         FMIN = MIN (FF, FMIN)
         FMAX = MAX (FF, FMAX)
 10      CONTINUE
      DX = 0.05 * (FMAX - FMIN)
      FMIN = (FMIN - DX) * REFREQ
      FMAX = (FMAX + DX) * REFREQ
      FFMN = FMIN
      FFMX = FMAX
      CALL RFILL (7, 1.0, XBLC)
      CALL RCOPY (7, XBLC, XTRC)
      XTRC(1) = XBLC(1) + NZ - 1
C                                       Compute model, max/min
 20   D = LOG10 (LRES(2))
      VMIN = 1.E15
      VMAX = -VMIN
      DO 30 I = 1,NZ
         LMOD(I) = D + LRES(4)*XF(I) + LRES(6)*(XF(I)**2)
         LMOD(I) = 10.0**LMOD(I)
         VMIN = MIN (VMIN, LMOD(I))
         VMAX = MAX (VMAX, LMOD(I))
         IF (LDATA(I).NE.FBLANK) THEN
            VMIN = MIN (VMIN, LDATA(I))
            VMAX = MAX (VMAX, LDATA(I))
            END IF
 30      CONTINUE
      DY = 0.05 * (VMAX - VMIN)
      VMIN = VMIN - DY
      VMAX = VMAX + DY
      RANGE(1) = VMIN
      RANGE(2) = VMAX
      CALL YWINDO ('READ', TVWIND, IRET)
      IF (IRET.NE.0) THEN
         TVWIND(1) = 1
         TVWIND(2) = 1
         TVWIND(3) = MAXXTV(1)
         TVWIND(4) = MAXXTV(2)
         END IF
      IF (IRET.NE.0) GO TO 970
      CALL YHOLD ('ONNN', IRET)
      CALL YSLECT ('OFFF', 1, 0, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 970
      DO 35 I = 1,5
         J = I + NGRAY
         CALL YZERO (J, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YSLECT ('ONNN', J, 0, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YCINIT (J, SCRTCH)
 35      CONTINUE
      CATR(IRRAN) = RANGE(1)
      CATR(IRRAN+1) = RANGE(2)
      XFAC = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      XOFF = 40000.0 - XFAC * CATR(IRRAN+1)
      PBLC(2) = RANGE(1) * XFAC + XOFF
      PTRC(2) = RANGE(2) * XFAC + XOFF
C                                       Label inits
      LOCNUM = 1
      I = NZ * 110
      FQFINC = (FFMX - FFMN) / (I-1)
      CALL SLBINI (IDROP, I, RANGE, PBLC, PTRC, XBLC, XTRC, FFMN,
     *   FQFINC, IDEPTH, LABEL, YGAP, CH, TEXT, NTEXT)
      IF (ITYP.LT.7) THEN
         WRITE (TEXT(1),1035) (LRES(I), I=2,5)
      ELSE
         WRITE (TEXT(1),1036) (LRES(I), I=2,7)
         END IF
      NTEXT = 1
      CH(2) = CH(2) + 1.333
      RANGE(1) = XFAC*RANGE(1) + XOFF
      RANGE(2) = XFAC*RANGE(2) + XOFF
      TVSIZE(1) = TVWIND(3) - TVWIND(1) + 1
      TVSIZE(2) = 0.75 * (TVWIND(4) - TVWIND(2) + 1)
      XYRATO = (PTRC(2) - PBLC(2)) / (PTRC(1) - PBLC(1))
      IX1 = PBLC(1) + .5
      IY1 = PBLC(2) + .5
      IX2 = PTRC(1) + .5
      IY2 = PTRC(2) + .5
      ICHL = CH(1) * CSIZTV(1) + .5
      ICHB = CH(2) * CSIZTV(2) + .5
      ICHR = CH(3) * CSIZTV(1) + .5
      ICHT = CH(4) * CSIZTV(2) + .5
      NYA = TVSIZE(2) - ICHT -ICHB -1
      NXA = TVSIZE(1) - ICHL - ICHR - 1
C                                       compute scaling
      X = IX2
      X = ABS (X - IX1)
      XX = X * XYRATO
      Y = IY2
      Y = ABS (Y - IY1)
      IF ((XX.LE.0.0) .OR. (Y.LE.0.0)) THEN
         MSGTXT = 'SCALING ERROR'
         CALL MSGWRT (8)
         IRET = 1
         GO TO 999
         END IF
      IF ((XX/Y).LE.FLOAT(NXA)/FLOAT(NYA)) THEN
         SCALEY = NYA / Y
         SCALEX = SCALEY * Y / X * FLOAT(TVSIZE(1)) / FLOAT(TVSIZE(2))
      ELSE
         SCALEX = NXA / X
         SCALEY = SCALEX * X / Y
         END IF
C
      NXA = SCALEX * X + ICHL + ICHR
      IF (NXA.GE.TVSIZE(1)) THEN
         SCALEX = SCALEX * (FLOAT(TVSIZE(1)) / (NXA + 5.0))
         SCALEY = SCALEY * (FLOAT(TVSIZE(1)) / (NXA + 5.0))
         NXA = SCALEX * X + ICHL + ICHR
         END IF
      NYA = SCALEY * Y + ICHB + ICHT
      IF (NXA.GE.TVSIZE(1)) THEN
         SCALEX = SCALEX * (FLOAT(TVSIZE(2)) / (NYA + 5.0))
         SCALEY = SCALEY * (FLOAT(TVSIZE(2)) / (NYA + 5.0))
         NXA = SCALEX * X + ICHL + ICHR
         NYA = SCALEY * Y + ICHB + ICHT
         END IF
      RX0 = ICHL + MAX (0, TVSIZE(1)-NXA) / 2 + TVWIND(1)
      RY0 = ICHB + MAX (0, TVSIZE(2)-NYA) / 2 + TVWIND(2)
C                                       Put stuff in image catalog.
      CATBLK(IIWIN  ) = IX1
      CATBLK(IIWIN+1) = IY1
      CATBLK(IIWIN+2) = IX2
      CATBLK(IIWIN+3) = IY2
      CATBLK(IICOR  ) = RX0 + 0.5
      CATBLK(IICOR+1) = RY0 + 0.5
      CATBLK(IICOR+2) = RX0 + X * SCALEX + 0.5
      CATBLK(IICOR+3) = RY0 + Y * SCALEY + 0.5
      CATBLK(IIPLT) = 5
      CATBLK(IIOTH) = LABEL
      CATBLK(IIOTH+1) = IDROP(1)
      CATBLK(IIOTH+2) = IDROP(2)
      I4XTRA = IIOTH + 3
      CATR(I4XTRA  ) = XBLC(1)
      CATR(I4XTRA+1) = XBLC(2)
      CATR(I4XTRA+2) = XTRC(1)
      CATR(I4XTRA+3) = XTRC(2)
C                                       Update image catalog
      CALL YCWRIT (IGR5, CATBLK(IICOR), CATBLK, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'TV IMAGE CATALOG ERROR'
         CALL MSGWRT (6)
         END IF
C                                       set scale for plot routines
      RX0 = RX0 - PBLC(1) * SCALEX + 0.5
      RY0 = RY0 - PBLC(2) * SCALEY + 0.5
C                                       label the plot
      IGR = IGR5
      CALL TVLAB (PBLC, PTRC, LABEL, YGAP, TEXT, NTEXT, CH, .FALSE.,
     *   IRET)
      IF (IRET.NE.0) GO TO 970
C                                       add spectrum number
      DX = PTRC(1)*SCALEX + RX0 - 8.5 * CSIZTV(1)
      DY = PTRC(2)*SCALEY + RY0 - 2.0 * CSIZTV(2)
      IDX = DX + 0.5
      IDY = DY + 0.5
      WRITE (MSGBUF,1060) ISP
      CALL IMCHAR (IGR, IDX, IDY, 0, 0, MSGBUF(:7), SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       add ID string
      DX = PBLC(1)*SCALEX + RX0
      DY = PTRC(2)*SCALEY + RY0 + 0.5 * CSIZTV(2)
      IDX = DX + 0.5
      IDY = DY + 0.5
      MSGBUF = SPCHAR(ISP)(:80)
      CALL IMCHAR (IGR, IDX, IDY, 0, 0, MSGBUF, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       add data points
      DX = 0.02* (PTRC(1) - PBLC(1))
      DY = 0.02* (PTRC(2) - PBLC(2))
      IGR = IGR4
      CALL FILL (NZ, -10000, LXPT)
      CALL FILL (NZ, -10000, LYPT)
      DO 50 I = 1,NZ
         FF = (10.0D0**XF(I)) * REFREQ
         IF ((LDATA(I).NE.FBLANK) .AND. (FF.GE.FFMN) .AND. (FF.LT.FFMX))
     *      THEN
            X = (FF - FFMN) / (FFMX - FFMN)
            LXPT(I) = X * (CATBLK(IICOR+2) - CATBLK(IICOR)) +
     *         CATBLK(IICOR)
            X = X * (PTRC(1) - PBLC(1)) + PBLC(1)
            Y = (LDATA(I) - VMIN) / (VMAX - VMIN)
            LYPT(I) = Y * (CATBLK(IICOR+3) - CATBLK(IICOR+1)) +
     *         CATBLK(IICOR+1)
            Y = Y * (PTRC(2) - PBLC(2)) + PBLC(2)
            CALL TVVEC (X+DX, Y, 1, IRET)
            IF (IRET.EQ.0) CALL TVVEC (X-DX, Y, 2, IRET)
            IF (IRET.EQ.0) CALL TVVEC (X, Y+DY, 1, IRET)
            IF (IRET.EQ.0) CALL TVVEC (X, Y-DY, 2, IRET)
            IF (IRET.NE.0) GO TO 970
            END IF
 50      CONTINUE
      J = 1
      DO 60 I = 1,NZ
         FF = (10.0D0**XF(I)) * REFREQ
         IF ((FF.GE.FFMN) .AND. (FF.LE.FFMX)) THEN
            X = (FF - FFMN) / (FFMX - FFMN)
            X = X * (PTRC(1) - PBLC(1)) + PBLC(1)
            Y = (LMOD(I) - VMIN) / (VMAX - VMIN)
            Y = Y * (PTRC(2) - PBLC(2)) + PBLC(2)
            CALL TVVEC (X, Y, J, IRET)
            IF (IRET.NE.0) GO TO 970
            J = 2
            END IF
 60      CONTINUE
      CALL YHOLD ('FFFF', IRET)
      GRCHS(1) = 2
      GRCHS(2) = 1
      RPOS(1) = MAXXTV(1) / 2
      RPOS(2) = MAXXTV(2) / 2
      ISHELP = TSKNAM
      TITLE = ' '
 100  CALL TVMENU (MTYPE, MCOL, MROWS, GRCHS, TOPSEP, SIDSEP, ISHELP,
     *   CHOICS, TIMLIM, LEAVE, 1, TITLE, CHS, TVBUT, IBUFF2, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'RETURNED FROM TVMENU'
         GO TO 980
         END IF
C                                       case statement
C                                       exit
      IF (CHOICS(CHS).EQ.'GOOD') THEN
         CALL RCOPY (ITYP, LRES, RESULT)
         GO TO 990
      ELSE IF (CHOICS(CHS).EQ.'BAD') THEN
         CALL RFILL (ITYP, FBLANK, RESULT)
         GO TO 990
      ELSE IF (CHOICS(CHS).EQ.'QUIT') THEN
         IRET = 99
         GO TO 990
      ELSE IF (CHOICS(CHS).EQ.'RESET CHANS') THEN
         FFMN = FMIN
         FFMX = FMAX
         GO TO 20
      ELSE IF (CHOICS(CHS).EQ.'CHAN RANGE') THEN
         CALL YZERO (IGR1, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YZERO (IGR2, IRET)
         IF (IRET.NE.0) GO TO 970
         NPIX = 16 * CSIZTV(1)
         NROW = 3 * CSIZTV(2)
         IX1 = WINDTV(1)
         IY1 = WINDTV(4) - NROW + 1
         IF (IX1+NPIX-1.GT.MAXXTV(1)) IX1 = 1
         IF (IY1+NROW-1.GT.MAXXTV(2)) IY1 = MAXXTV(2) - NROW + 1
         IX2 = IX1 + NPIX - 1
         IY2 = IY1 + NROW - 1
         CALL YFILL (IGR2, IX1, IY1, IX2, IY2, 0, IBUFF2, IRET)
         IF (IRET.NE.0) GO TO 970
         WRITE (MSGTXT,1090)
         CALL MSGWRT (1)
         WRITE (MSGTXT,1092)
         CALL MSGWRT (1)
         WRITE (MSGTXT,1093)
         CALL MSGWRT (1)
         CALL ZTIME (ITW)
         RPOS(1) = (CATBLK(IICOR) + CATBLK(IICOR+2)) / 2
         RPOS(2) = (CATBLK(IICOR+1) + CATBLK(IICOR+3)) / 2
         CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IRET)
         IF (IRET.NE.0) GO TO 970
         XM(1) = FFMN
         XM(2) = FFMX
         IM = 1
 110     IGR = IGR3
         X = (XM(1) - FFMN) / (FFMX - FFMN)
         X = X * (PTRC(1) - PBLC(1)) + PBLC(1)
         CALL TVVEC (X, PBLC(2), 1, IRET)
         IF (IRET.EQ.0) CALL TVVEC (X, PTRC(2), 2, IRET)
         X = (XM(2) - FFMN) / (FFMX - FFMN)
         X = X * (PTRC(1) - PBLC(1)) + PBLC(1)
         CALL TVVEC (X, PBLC(2), 1, IRET)
         IF (IRET.EQ.0) CALL TVVEC (X, PTRC(2), 2, IRET)
C                                       Cursor read loop point
         CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF (DOIT) THEN
            LBUT = IBUT
C                                       Display coordinate
            QUAD = 0
            CALL YCURSE ('FXIT', F, T, RPOS, QUAD, IBUT, IRET)
            IF (RPOS(1).LT.CATBLK(IICOR)) RPOS(1) = CATBLK(IICOR)
            IF (RPOS(1).GT.CATBLK(IICOR+2)) RPOS(1) = CATBLK(IICOR+2)
            IF (RPOS(2).LT.CATBLK(IICOR+1)) RPOS(2) = CATBLK(IICOR+1)
            IF (RPOS(2).GT.CATBLK(IICOR+3)) RPOS(2) = CATBLK(IICOR+3)
            VX = (RPOS(1) - CATBLK(IICOR)) * (FFMX - FFMN) /
     *         (CATBLK(IICOR+2)-CATBLK(IICOR)) + FFMN
            VY = (RPOS(2) - CATBLK(IICOR+1)) * (VMAX - VMIN) /
     *         (CATBLK(IICOR+3)-CATBLK(IICOR+1)) + VMIN
            IF (IM.EQ.2) THEN
               VX = MAX (VX, XM(1))
            ELSE
               VX = MIN (VX, XM(2))
               END IF
            RPOS(1) = (VX - FFMN) * (CATBLK(IICOR+2)-CATBLK(IICOR)) /
     *         (FFMX - FFMN) + CATBLK(IICOR)
            WRITE (MSGBUF,1115) VY
            I = IY1 + 1.5*CSIZTV(2)
            CALL IMCHAR (IGR2, IX1, I, 0, 0, MSGBUF(:18), IBUFF2, IRET)
            IF (IRET.NE.0) GO TO 970
            WRITE (MSGBUF,1116) VX
            CALL IMCHAR (IGR2, IX1, IY1, 0, 0, MSGBUF(:14), IBUFF2,
     *         IRET)
            IF (IRET.NE.0) GO TO 970
            X = (XM(1) - FFMN) / (FFMX - FFMN)
            X = X * (PTRC(1) - PBLC(1)) + PBLC(1)
            CALL TVVEC (X, PBLC(2), 1, IRET)
            IF (IRET.EQ.0) CALL TVVEC (X, PTRC(2), 3, IRET)
            X = (XM(2) - FFMN) / (FFMX - FFMN)
            X = X * (PTRC(1) - PBLC(1)) + PBLC(1)
            CALL TVVEC (X, PBLC(2), 1, IRET)
            IF (IRET.EQ.0) CALL TVVEC (X, PTRC(2), 3, IRET)
            XM(IM) = VX
            IF ((LBUT.GT.0) .AND. (LBUT.LE.3)) THEN
               IM = 3 - IM
               IF (IM.EQ.1) THEN
                  WRITE (MSGTXT,1090)
               ELSE
                  WRITE (MSGTXT,1091)
                  END IF
               CALL MSGWRT (1)
               END IF
            END IF
         IF (LBUT.LE.3) GO TO 110
         FFMN = XM(1)
         FFMX = XM(2)
         CALL YZERO (IGR3, IRET)
         IF (IRET.NE.0) GO TO 970
         GO TO 20
C                                       blank
      ELSE IF (CHOICS(CHS).EQ.' ') THEN
C                                       undo flags
      ELSE IF (CHOICS(CHS).EQ.'UNDO FLAGS') THEN
         CALL RCOPY (NZ, XD, LDATA)
         CALL RCOPY (ITYP, RESULT, LRES)
         GO TO 20
      ELSE IF (CHOICS(CHS).EQ.'NEW FIT') THEN
         IF (ITYP.LT.7) THEN
            CALL DO1SPX (NZ, XF, LDATA, LRES)
         ELSE
            CALL DO2SPX (NZ, XF, LDATA, LRES)
            END IF
         IF (LRES(2).EQ.FBLANK) THEN
            MSGTXT = '****** FIT FAILED, UNDOING FLAGS ******'
            CALL MSGWRT (6)
            MSGTXT = '*** YOU SHOULD PROBABLY MARK IT BAD ***'
            CALL MSGWRT (6)
            CALL RCOPY (NZ, XD, LDATA)
            CALL RCOPY (ITYP, RESULT, LRES)
            END IF
         GO TO 20
      ELSE IF (CHOICS(CHS).EQ.'FLAG POINTS') THEN
         CALL YZERO (IGR1, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YZERO (IGR2, IRET)
         IF (IRET.NE.0) GO TO 970
         NPIX = 16 * CSIZTV(1)
         NROW = 3 * CSIZTV(2)
         IX1 = WINDTV(1)
         IY1 = WINDTV(4) - NROW + 1
         IF (IX1+NPIX-1.GT.MAXXTV(1)) IX1 = 1
         IF (IY1+NROW-1.GT.MAXXTV(2)) IY1 = MAXXTV(2) - NROW + 1
         IX2 = IX1 + NPIX - 1
         IY2 = IY1 + NROW - 1
         CALL YFILL (IGR2, IX1, IY1, IX2, IY2, 0, IBUFF2, IRET)
         IF (IRET.NE.0) GO TO 970
         WRITE (MSGTXT,1100)
         CALL MSGWRT (1)
         WRITE (MSGTXT,1101)
         CALL MSGWRT (1)
         WRITE (MSGTXT,1102)
         CALL MSGWRT (1)
         CALL ZTIME (ITW)
         RPOS(1) = (CATBLK(IICOR) + CATBLK(IICOR+2)) / 2
         RPOS(2) = (CATBLK(IICOR+1) + CATBLK(IICOR+3)) / 2
         CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IRET)
         IF (IRET.NE.0) GO TO 970
C                                       Cursor read loop point
 115     CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IRET)
         IF (IRET.NE.0) GO TO 970
         IF (IBUT.GE.4) GO TO 100
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF (DOIT) THEN
            LBUT = IBUT
C                                       Find new image catalog block
            QUAD = 0
            CALL YCURSE ('FXIT', F, T, RPOS, QUAD, IBUT, IRET)
            VX = (RPOS(1) - CATBLK(IICOR)) * (FFMX - FFMN) /
     *         (CATBLK(IICOR+2)-CATBLK(IICOR)) + FFMN
            VY = (RPOS(2) - CATBLK(IICOR+1)) * (VMAX - VMIN) /
     *         (CATBLK(IICOR+3)-CATBLK(IICOR+1)) + VMIN
            WRITE (MSGBUF,1115) VY
            I = IY1 + 1.5*CSIZTV(2)
            CALL IMCHAR (IGR2, IX1, I, 0, 0, MSGBUF(:18), IBUFF2, IRET)
            IF (IRET.NE.0) GO TO 970
            WRITE (MSGBUF,1116) VX
            CALL IMCHAR (IGR2, IX1, IY1, 0, 0, MSGBUF(:14), IBUFF2,
     *         IRET)
            IF (IRET.NE.0) GO TO 970
            IF (LBUT.GT.0) THEN
               IP = 0
               IR = 100000
               DO 120 I = 1,NZ
                  XX = (RPOS(1)-LXPT(I))**2 + (RPOS(2)-LYPT(I))**2
                  IF (XX.LT.IR) THEN
                     IR = XX + 0.5
                     IP = I
                     END IF
 120              CONTINUE
               IF (IR.LT.100) THEN
                  DX = 0.02* (PTRC(1) - PBLC(1))
                  DY = 0.02* (PTRC(2) - PBLC(2))
                  IGR = IGR3
                  FF = (10.0D0**XF(IP)) * REFREQ
                  X = (FF - FFMN) / (FFMX - FFMN)
                  X = X * (PTRC(1) - PBLC(1)) + PBLC(1)
                  Y = (LDATA(IP) - VMIN) / (VMAX - VMIN)
                  Y = Y * (PTRC(2) - PBLC(2)) + PBLC(2)
                  CALL TVVEC (X+DX, Y, 1, IRET)
                  IF (IRET.EQ.0) CALL TVVEC (X-DX, Y, 2, IRET)
                  IF (IRET.EQ.0) CALL TVVEC (X, Y+DY, 1, IRET)
                  IF (IRET.EQ.0) CALL TVVEC (X, Y-DY, 2, IRET)
                  IF (IRET.NE.0) GO TO 970
                  LDATA(IP) = FBLANK
                  END IF
               END IF
            END IF
         GO TO 115
         END IF
      GO TO 100
C
 970  WRITE (MSGTXT,1000) IRET, 'TV FUNCTION'
C
 980  CALL MSGWRT (8)
C
 990  CALL YINIT (BUFF1, I)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPREDO ERROR',I4,' ON ',A)
 1010 FORMAT ('SPREDO: SPECTRUM',I4,' ALREADY FAILED')
 1035 FORMAT ('T0=',F8.3,' (',F7.3,') SP=',F7.3,' (',F6.3,')')
 1036 FORMAT ('T0=',F8.3,' (',F7.3,') SP=',F7.3,' (',F6.3,') CU=',F7.3,
     *   ' (',F6.3,')')
 1060 FORMAT ('S=',I5)
 1090 FORMAT ('Setting lower limit')
 1091 FORMAT ('Setting lower limit')
 1092 FORMAT ('Hit button A or B to switch to other limit')
 1093 FORMAT ('Hit button C or D to exit')
 1100 FORMAT ('Cursor selects which pixel is displayed')
 1101 FORMAT ('Hit button A or B to flag a point')
 1102 FORMAT ('Hit button C or D to exit flagging')
 1115 FORMAT (F10.5,' Jy/beam')
 1116 FORMAT (F10.5,' ?Hz')
      END
      SUBROUTINE LISPOU (ITYP, IRET)
C-----------------------------------------------------------------------
C   LISPOU prints the answers and optionally writes a text file
C   Inputs
C      ITYP     I      # answers (5 or 7)
C   Output:
c      IRET    I      0 => ok,  4 => real trouble.
C------------------------------------------------------------------------
      INTEGER   ITYP, IRET
C
      REAL      TFREQ, TMOD, TDIF
      INTEGER   TLUN, TIND, LUNTMP, ISP, J, JTRIM, K, I, I1, I2
      LOGICAL   DOTEXT
      CHARACTER STRING*128
      INCLUDE 'LISPX.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
      DO 20 ISP = 1,NSPEC
         J = JTRIM (SPCHAR(ISP))
         J = MIN (45, MAX (1,J))
         IF (SPIX(1,ISP).EQ.FBLANK) THEN
            WRITE (MSGTXT,1005) ISP, SPCHAR(ISP)(:J)
            CALL MSGWRT (5)
         ELSE
            K = SPIX(1,ISP) + 0.1
            WRITE (MSGTXT,1010) ISP, K, SPCHAR(ISP)(:J)
            CALL MSGWRT (5)
            WRITE (MSGTXT,1020) ' ', SPIX(2,ISP), SPIX(3,ISP)
            CALL MSGWRT (5)
            WRITE (MSGTXT,1021) ' ', SPIX(4,ISP), SPIX(5,ISP)
            CALL MSGWRT (5)
            IF (ITYP.EQ.7) THEN
               WRITE (MSGTXT,1022) ' ', SPIX(6,ISP), SPIX(7,ISP)
               CALL MSGWRT (5)
               END IF
            END IF
 20      CONTINUE
C                                       text file
      DOTEXT = OUFILE.NE.' '
      IF (DOTEXT) THEN
         TLUN = LUNTMP (2)
         CALL ZTXOPN ('WRIT', TLUN, TIND, OUFILE, .TRUE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT TEXT FILE'
            CALL MSGWRT (8)
            GO TO 999
            END IF
         DO 50 ISP = 1,NSPEC
            I1 = FVALU(ISP)
            I2 = FVALU(ISP+1) - 1
            J = JTRIM (SPCHAR(ISP))
            J = MIN (92, MAX (1,J))
            IF (SPIX(1,ISP).EQ.FBLANK) THEN
               WRITE (STRING,1005) ISP, SPCHAR(ISP)(:J)
               J = JTRIM (STRING)
               CALL ZTXIO ('WRIT', TLUN, TIND, STRING(:J), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (STRING,1000) IRET, 'WRITING OUTPUT TEXT FILE'
                  CALL MSGWRT (8)
                  DOTEXT = .FALSE.
                  END IF
            ELSE
               K = SPIX(1,ISP) + 0.1
               WRITE (STRING,1011) ISP, K, SPCHAR(ISP)(:J)
               J = JTRIM (STRING)
               CALL ZTXIO ('WRIT', TLUN, TIND, STRING(:J), IRET)
               IF (IRET.NE.0) GO TO 900
               WRITE (STRING,1020) '#', SPIX(2,ISP), SPIX(3,ISP)
               J = JTRIM (STRING)
               CALL ZTXIO ('WRIT', TLUN, TIND, STRING(:J), IRET)
               IF (IRET.NE.0) GO TO 900
               WRITE (STRING,1021) '#', SPIX(4,ISP), SPIX(5,ISP)
               J = JTRIM (STRING)
               CALL ZTXIO ('WRIT', TLUN, TIND, STRING(:J), IRET)
               IF (IRET.NE.0) GO TO 900
               IF (ITYP.EQ.7) THEN
                  WRITE (STRING,1022) '#', SPIX(6,ISP), SPIX(7,ISP)
                  J = JTRIM (STRING)
                  CALL ZTXIO ('WRIT', TLUN, TIND, STRING(:J), IRET)
                  IF (IRET.NE.0) GO TO 900
                  DO 30 I = I1,I2
                     TFREQ = (10.0 ** (XFREQ(I))) * REFREQ
                     TMOD = LOG10 (SPIX(2,ISP)) + SPIX(4,ISP) * XFREQ(I)
     *                  + SPIX(6,ISP) * (XFREQ(I)**2)
                     TMOD = 10.0 ** TMOD
                     TDIF = XDATA(I) - TMOD
                     IF (XRMS(I).EQ.FBLANK) THEN
                        WRITE (STRING,1030) TFREQ, XDATA(I), TMOD, TDIF
                     ELSE
                        WRITE (STRING,1030) TFREQ, XDATA(I), XRMS(I),
     *                     TMOD, TDIF
                        END IF
                     J = JTRIM (STRING)
                     CALL ZTXIO ('WRIT', TLUN, TIND, STRING(:J), IRET)
                     IF (IRET.NE.0) GO TO 900
 30                  CONTINUE
               ELSE
                  DO 40 I = I1,I2
                     TFREQ = (10.0 ** (XFREQ(I))) * REFREQ
                     TMOD = LOG10 (SPIX(2,ISP)) + SPIX(4,ISP) * XFREQ(I)
                     TMOD = 10.0 ** TMOD
                     TDIF = XDATA(I) - TMOD
                     IF (XRMS(I).EQ.FBLANK) THEN
                        WRITE (STRING,1030) TFREQ, XDATA(I), TMOD, TDIF
                     ELSE
                        WRITE (STRING,1030) TFREQ, XDATA(I), XRMS(I),
     *                     TMOD, TDIF
                        END IF
                     J = JTRIM (STRING)
                     CALL ZTXIO ('WRIT', TLUN, TIND, STRING(:J), IRET)
                     IF (IRET.NE.0) GO TO 900
 40                  CONTINUE
                  END IF
               END IF
 50         CONTINUE
         END IF
      IF ((OUFILE.NE.' ') .AND. (TIND.NE.0)) CALL ZTXCLS (TLUN, TIND, J)
      GO TO 999
C
 900  WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT TEXT FILE'
      CALL MSGWRT (8)
      CALL ZTXCLS (TLUN, TIND, J)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('LISPOU ERROR',I5,' ON ',A)
 1005 FORMAT ('Spectrum',I3,'  FLAGGED BAD   label=''',A,'''')
 1010 FORMAT ('Spectrum',I3,'  N data=',I6,' label=''',A,'''')
 1011 FORMAT ('SPECTRUM',I3,'  N data=',I6,' label=''',A,'''')
 1020 FORMAT (A1,4X,'Flux at ref fr',F10.3,'  (',F8.3,')')
 1021 FORMAT (A1,4X,'Spectral index',F10.3,'  (',F8.3,')')
 1022 FORMAT (A1,4X,'Spectral curv.',F10.3,'  (',F8.3,')')
 1030 FORMAT (F15.10,4F12.6)
      END

LOCAL INCLUDE 'IM2TX.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQIN, DISKIN, OLDCNO, JBUFSZ, ICODE
      HOLLERITH XNAMEI(3), XCLAIN(2), XOPCOD(1), XOUFIL(12)
      CHARACTER NAMEIN*12, CLAIN*6, OPCODE*4, OUTFIL*48
      REAL      XSEQIN, XDISKI, BLC(7), TRC(7), BUFF1(MABFSS)
      LOGICAL   ISFREQ
      DOUBLE PRECISION XFREQ(16384)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, BLC, TRC, XOPCOD,
     *   XOUFIL
      COMMON /CHPARM/ NAMEIN, CLAIN, OUTFIL, OPCODE
      COMMON /PARMS/ SEQIN, DISKIN, OLDCNO, JBUFSZ, ICODE, ISFREQ
      COMMON /BUFRS/ XFREQ, BUFF1
LOCAL END
      PROGRAM IM2TX
C-----------------------------------------------------------------------
C! Sum or average a region in N-1 axes, write text spectrum in the other
C# Map-util Analysis
C-----------------------------------------------------------------------
C;  Copyright (C) 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   IM2TX sums or averages a BLC-TRC region in all axes but one and
C   writes a text file "spectrum" in that axis.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      OPCODE         OPCODE        User specified opcode.
C      OUTFILE        OUTFIL        Text file
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'IM2TX.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'IM2TX '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL IM2TXI (PRGM, IRET)
C                                       Call routine that sends data
C                                       to the user routine.
      IF (IRET.EQ.0) CALL IM2TXR (IRET)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE IM2TXI (PRGN, IRET)
C-----------------------------------------------------------------------
C   IM2TXI gets input parameters for IM2TX and creates an output text
C   file.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      CHARACTER  STAT*4, MTYPE*2, NUMCH(7)*1
      INTEGER   IERR, NPARM, IROUND, I
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'IM2TX.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      DATA NUMCH /'1', '2', '3', '4', '5', '6', '7'/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      locnum = 1
C                                       Get input parameters.
      NPARM = 34
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      CALL H2CHR (48, 1, XOUFIL, OUTFIL)
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      DISKIN = IROUND (XDISKI)
      IF (OUTFIL.EQ.' ') THEN
         MSGTXT = 'OUTFILE MUST BE SPECIFIED'
         GO TO 990
         END IF
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'READ', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
      ICODE = 0
      DO 20 I = 1,CATBLK(KIDIM)
         IF (OPCODE(:1).EQ.NUMCH(I)) ICODE = I
 20      CONTINUE
      IF (ICODE.EQ.0) THEN
         MSGTXT = 'OPCODE DOES NOT SAY WHICH AXIS'
         GO TO 990
         END IF
      IF (TRC(ICODE)-BLC(ICODE).LT.1.0) THEN
         MSGTXT = 'TRC AND BLC SPECIFY A NULL 1-D IMAGE'
         GO TO 990
         END IF
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('IM2TXI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE IM2TXR (IRET)
C-----------------------------------------------------------------------
C   IM2TXR opens the input image, creates the text file, writes the text
C   file header, and then invokes various routines to fine and create
C   the output data.
C   Output:
C      IRET   I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER IFILE*48, CTYPE*8, OUTLIN*128, BUNIT*8, AXTYPE*8
      INTEGER   I, NPTS, LUNI, LUNT, COUNT(16384), INDI, FINDT, J, NAX,
     *   JTRIM, K, L, DEPTH(7), I1, I2
      REAL      FI, FR, C1CRP, C1CIC, XPIX, YPIX
      DOUBLE PRECISION FV, C1CRV, X(7), ANSW(16384), ANSS(16384)
      LOGICAL   T, F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'IM2TX.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI, LUNT /16, 3/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      ISFREQ = F
      CALL AXEFND (8, 'SEQ.NUM.', CATBLK(KIDIM), CATH(KHCTP), L, IRET)
      IF (IRET.NE.0) L = -1
      CALL AXEFND (4, 'FQID', CATBLK(KIDIM), CATH(KHCTP), K, IRET)
      IF (IRET.NE.0) K = -1
      CALL AXEFND (4, 'FREQ', CATBLK(KIDIM), CATH(KHCTP), J, IRET)
      IF (K.EQ.-1) K = L
      IF (K.EQ.-1) K = J
      IF (IRET.EQ.0) THEN
         ISFREQ = K.EQ.ICODE-1
         NAX = CATBLK(KINAX+K)
         FV = CATD(KDCRV+J)
         FI = CATR(KRCIC+J)
         FR = CATR(KRCRP+J)
         CALL H2CHR (8, 1, CATH(KHCTP+2*K), AXTYPE)
         IF (AXTYPE.EQ.'FREQ') THEN
            DO 10 I = 1,NAX
               XFREQ(I) = FV + FI * (I - FR)
 10            CONTINUE
         ELSE IF (AXTYPE.EQ.'SEQ.NUM.') THEN
            CALL HIGET (DISKIN, OLDCNO, NAX, XFREQ, IRET)
         ELSE IF (AXTYPE.EQ.'FQID') THEN
            C1CRV = CATD(KDCRV+K)
            C1CRP = CATR(KRCRP+K)
            C1CIC = CATR(KRCIC+K)
            CALL FQGET (DISKIN, OLDCNO, NAX, FV, C1CRV, C1CRP, C1CIC,
     *         CATBLK, XFREQ, IRET)
            END IF
         FV = 0.0D0
         I1 = BLC(K+1) + 0.1
         I2 = TRC(K+1) + 0.1
         DO 15 I = I1,I2
            FV = FV + XFREQ(I)
 15         CONTINUE
         FV = FV / (I2 - I1 + 1)
      END IF
      DO 20 I = 1,7
         DEPTH(I) = (TRC(I) + BLC(I)) / 2.0 + 0.5
 20   CONTINUE
      CALL SETLOC (DEPTH(3), .FALSE.)
      XPIX = DEPTH(1)
      YPIX = DEPTH(2)
      CALL DFILL (7, 0.0D0, X)
      CALL XYVAL (XPIX, YPIX, X(1), X(2), X(3), IRET)
C                                       Open and init for read
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT IMAGE FILE'
         GO TO 990
         END IF
      CALL ZTXOPN ('WRIT', LUNT, FINDT, OUTFIL, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATING OUTPUT TEXT FILE'
         GO TO 990
         END IF
C                                       text file header
      CALL H2CHR (8, 1, CATH(KHCTP+2*ICODE-2), AXTYPE)
      WRITE (OUTLIN,2000) ICODE, AXTYPE, OPCODE(2:4)
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', LUNT, FINDT, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      CALL H2CHR (8, 1, CATH(KHBUN), BUNIT)
      CALL H2CHR (8, 1, CATH(KHDOB), CTYPE)
      WRITE (OUTLIN,2005) BUNIT, CTYPE
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', LUNT, FINDT, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      CALL H2CHR (8, 1, CATH(KHOBJ), CTYPE)
      WRITE (OUTLIN,2006) CTYPE
      J = JTRIM (OUTLIN)
      CALL ZTXIO ('WRIT', LUNT, FINDT, OUTLIN(:J), IRET)
      IF (IRET.NE.0) GO TO 980
      IF ((AXTYPE.EQ.'FREQ') .OR. (AXTYPE(:4).EQ.'VELO') .OR.
     *   (AXTYPE(:4).EQ.'FELO')) THEN
         IF (CATBLK(KIALT).NE.0) THEN
            WRITE (OUTLIN,2007) CATBLK(KIALT)
            J = JTRIM (OUTLIN)
            CALL ZTXIO ('WRIT', LUNT, FINDT, OUTLIN(:J), IRET)
            IF (IRET.NE.0) GO TO 980
            WRITE (OUTLIN,2008) CATD(KDARV), CATR(KRARP)
            J = JTRIM (OUTLIN)
            CALL ZTXIO ('WRIT', LUNT, FINDT, OUTLIN(:J), IRET)
            IF (IRET.NE.0) GO TO 980
            END IF
         IF (CATD(KDRST).NE.0.0D0) THEN
            WRITE (OUTLIN,2009) CATD(KDRST)
            J = JTRIM (OUTLIN)
            CALL ZTXIO ('WRIT', LUNT, FINDT, OUTLIN(:J), IRET)
            IF (IRET.NE.0) GO TO 980
            END IF
         END IF
      DO 40 I = 1,CATBLK(KIDIM)
         CALL H2CHR (8, 1, CATH(KHCTP+2*I-2), CTYPE)
         IF ((CTYPE.EQ.'FREQ') .OR. (CTYPE.EQ.'FQID') .OR.
     *      (CTYPE.EQ.'SEQ.NUM.')) X(I) = FV
         WRITE (OUTLIN,2010) I, CTYPE, CATBLK(KINAX+I-1), BLC(I), TRC(I)
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', LUNT, FINDT, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         WRITE (OUTLIN,2011) I, CATD(KDCRV+I-1), CATR(KRCIC+I-1)
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', LUNT, FINDT, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         WRITE (OUTLIN,2012) I, CATR(KRCRP+I-1)
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', LUNT, FINDT, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         WRITE (OUTLIN,2013) I, X(I)
         J = JTRIM (OUTLIN)
         IF (X(I).NE.0.0D0) CALL ZTXIO ('WRIT', LUNT, FINDT, OUTLIN(:J),
     *      IRET)
         IF (IRET.NE.0) GO TO 980
 40      CONTINUE
C                                       now do it
      NPTS = TRC(ICODE) - BLC(ICODE) + 1.1
      CALL RFILL (NPTS, 0.0, ANSW)
      CALL RFILL (NPTS, 0.0, ANSS)
      CALL FILL (NPTS, 0, COUNT)
      IF (ICODE.EQ.1) THEN
         CALL DOIT1 (NPTS, LUNI, INDI, LUNT, FINDT, ANSW, COUNT, ANSS,
     *      IRET)
      ELSE IF (ICODE.EQ.2) THEN
         CALL DOIT2 (NPTS, LUNI, INDI, LUNT, FINDT, ANSW, COUNT, ANSS,
     *      IRET)
      ELSE
         CALL DOIT3 (NPTS, LUNI, INDI, LUNT, FINDT, ANSW, COUNT, ANSS,
     *      IRET)
         END IF
      IF (IRET.NE.0) GO TO 999
C                                       close text file
      CALL ZTXCLS (LUNT, FINDT, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSING OUTOUT TEXT FILE'
         GO TO 990
         END IF
      GO TO 999
C
 980  WRITE (MSGTXT,1000) IRET, 'WRITING TEXT FILE'
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('IM2TXR ERROR',I5,' ON ',A)
 2000 FORMAT ('#Data type',I2,' ''',A,'''  value is ',A)
 2005 FORMAT ('#INFO BUNIT ''',A,'''  OBSDATE ''',A,'''')
 2006 FORMAT ('#INFO SRCNAME ''',A,'''')
 2007 FORMAT ('#INFO ALTCODE',I7)
 2008 FORMAT ('#INFO ALTVAL',1PE14.6,' ALTPIX',0PF7.1)
 2009 FORMAT ('#INFO RESTFREQ',1PE14.6)
 2010 FORMAT ('#HEADa',I2,'  ''',A,''' Npts',I6,' BLC/TRC',2F7.0)
 2011 FORMAT ('#HEADb',I2,'  Refval',1PE15.7,'  Cdelt',1PE14.6)
 2012 FORMAT ('#HEADc',I2,'  Refpix',F8.1)
 2013 FORMAT ('#HEADd',I2,'  AvgValue',1PE17.9)
      END
      SUBROUTINE DOIT1 (NPTS, LUNI, INDI, LUNT, FINDT, ANSW, COUNT,
     *   ANSS, IRET)
C-----------------------------------------------------------------------
C   DOIT1 sums aver the BLC-TRC window in axes 2-N.
C   Inputs
C      NPTS    I      Number points in spectrum
C      LUNI    I      LUN of open data file
C      INDI    I      FTAB pointer of open data file
C      LUNT    I      LUN of open text file
C      FINDT   I      FTAB pointer of open data file
C   Outputs
C      ANSW    D(*)   Answer
C      COUNT   I(*)   Number samples in ANSW
C      ANSS    D(*)   RMS
C      IRET    I      > 0 => error
C-----------------------------------------------------------------------
      INTEGER   NPTS, LUNI, INDI, LUNT, FINDT, COUNT(*), IRET
      DOUBLE PRECISION ANSW(*), ANSS(*)
C
      INTEGER   IROUND, NYI, NXI, WINI(4), BOI, LIM1, LIM2, LIM3, LIM4,
     *   LIM5, LIM6, LIM7, I1, I2, I3, I4, I5, I6, I7, IPOS(7),
     *   DEPTH(5), IBIND, J, JTRIM
      LOGICAL   T, F
      CHARACTER OUTLIN*128
      REAL      XPIX, YPIX
      DOUBLE PRECISION X(3), XV
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'IM2TX.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Setup for I/O
      NXI = CATBLK(KINAX)
      NYI = CATBLK(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         DO 600 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            DO 500 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               DO 400 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  DO 300 I3 = 1,LIM3
                     IPOS(3) = BLC(3) + I3 - 0.9
C                                       Init. files, first input.
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IPOS(3), BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'FIND OFFSET FOR I/O'
            GO TO 990
            END IF
         BOI = BOI + 1
         CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT READ OF DATA'
            GO TO 990
            END IF
         DO 200 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
C                                       Read.
            CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'read IMAGE DATA'
               GO TO 990
               END IF
            DO 100 I1 = 1,LIM1
               IF (BUFF1(IBIND+I1-1).NE.FBLANK) THEN
                  ANSW(I1) = ANSW(I1) + BUFF1(IBIND+I1-1)
                  ANSS(I1) = ANSS(I1) + BUFF1(IBIND+I1-1)**2
                  COUNT(I1) = COUNT(I1) + 1
                  END IF
 100              CONTINUE
 200           CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       average
      IF ((OPCODE(2:4).EQ.'AVG') .OR. (OPCODE(2:4).EQ.'RMS')) THEN
         DO 710 I1 = 1,LIM1
            IF (COUNT(I1).GT.0) THEN
               ANSW(I1) = ANSW(I1) / COUNT(I1)
               ANSS(I1) = ANSS(I1) / COUNT(I1) - ANSW(I1)**2
               ANSS(I1) = SQRT (MAX (0.0D0, ANSS(I1)))
               END IF
 710        CONTINUE
         END IF
      DEPTH(1) = (TRC(3) + BLC(3)) / 2.0 + 0.5
      DEPTH(2) = (TRC(4) + BLC(4)) / 2.0 + 0.5
      DEPTH(3) = (TRC(5) + BLC(5)) / 2.0 + 0.5
      DEPTH(4) = (TRC(6) + BLC(6)) / 2.0 + 0.5
      DEPTH(5) = (TRC(7) + BLC(7)) / 2.0 + 0.5
      CALL SETLOC (DEPTH, T)
      YPIX = (TRC(2) + BLC(2)) / 2.0
      DO 720 I1 = 1,LIM1
         J = BLC(1) + I1 - 0.9
         IF (ISFREQ) THEN
            XV = XFREQ(J)
         ELSE
            XPIX = BLC(1) + I1 - 1.0
            CALL XYVAL (XPIX, YPIX, X(1), X(2), X(3), IRET)
            XV = X(1)
         END IF
         IF (OPCODE(2:4).EQ.'RMS') THEN
            WRITE (OUTLIN,1710) XV, ANSS(I1)
         ELSE IF (OPCODE(2:4).EQ.'AVG') THEN
            WRITE (OUTLIN,1710) XV, ANSW(I1), ANSS(I1)
         ELSE
            WRITE (OUTLIN,1710) XV, ANSW(I1)
            END IF
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', LUNT, FINDT, OUTLIN(:J), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT TEXT FILE'
            GO TO 990
            END IF
 720     CONTINUE
C
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DOIT1: ERROR',I3,' ON ',A)
 1710 FORMAT (1PE17.9,2X,2(1PE14.6))
      END
      SUBROUTINE DOIT2 (NPTS, LUNI, INDI, LUNT, FINDT, ANSW, COUNT,
     *   ANSS, IRET)
C-----------------------------------------------------------------------
C   DOIT1 sums aver the BLC-TRC window in axes 2-N.
C   Inputs
C      NPTS    I      Number points in spectrum
C      LUNI    I      LUN of open data file
C      INDI    I      FTAB pointer of open data file
C      LUNT    I      LUN of open text file
C      FINDT   I      FTAB pointer of open data file
C   Outputs
C      ANSW    D(*)   Answer
C      COUNT   I(*)   Number samples in ANSW
C      ANSS    D(*)   RMS
C      IRET    I      > 0 => error
C-----------------------------------------------------------------------
      INTEGER   NPTS, LUNI, INDI, LUNT, FINDT, COUNT(*), IRET
      DOUBLE PRECISION ANSW(*), ANSS(*)
C
      INTEGER   IROUND, NYI, NXI, WINI(4), BOI, LIM1, LIM2, LIM3, LIM4,
     *   LIM5, LIM6, LIM7, I1, I2, I3, I4, I5, I6, I7, IPOS(7), CORN(7),
     *   IBIND, J, JTRIM, DEPTH(5)
      LOGICAL   T, F
      CHARACTER OUTLIN*128
      REAL      XPIX, YPIX
      DOUBLE PRECISION X(3), XV
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'IM2TX.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Setup for I/O
      NXI = CATBLK(KINAX)
      NYI = CATBLK(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         CORN(7) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            CORN(6) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               CORN(5) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  CORN(4) = I4
                  DO 300 I3 = 1,LIM3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     CORN(3) = I3
C                                       Init. files, first input.
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IPOS(3), BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'FIND OFFSET FOR I/O'
            GO TO 990
            END IF
         BOI = BOI + 1
         CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT READ OF DATA'
            GO TO 990
            END IF
         DO 200 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
C                                       Read.
            CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'read IMAGE DATA'
               GO TO 990
               END IF
            DO 100 I1 = 1,LIM1
               IF (BUFF1(IBIND+I1-1).NE.FBLANK) THEN
                  ANSW(I2) = ANSW(I2) + BUFF1(IBIND+I1-1)
                  ANSS(I2) = ANSS(I2) + BUFF1(IBIND+I1-1)**2
                  COUNT(I2) = COUNT(I2) + 1
                  END IF
 100              CONTINUE
 200           CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       average
      IF ((OPCODE(2:4).EQ.'AVG') .OR. (OPCODE(2:4).EQ.'RMS')) THEN
         DO 710 I1 = 1,LIM1
            IF (COUNT(I1).GT.0) THEN
               ANSW(I1) = ANSW(I1) / COUNT(I1)
               ANSS(I1) = ANSS(I1) / COUNT(I1) - ANSW(I1)**2
               ANSS(I1) = SQRT (MAX (0.0D0, ANSS(I1)))
               END IF
 710        CONTINUE
         END IF
      DEPTH(1) = (TRC(3) + BLC(3)) / 2.0 + 0.5
      DEPTH(2) = (TRC(4) + BLC(4)) / 2.0 + 0.5
      DEPTH(3) = (TRC(5) + BLC(5)) / 2.0 + 0.5
      DEPTH(4) = (TRC(6) + BLC(6)) / 2.0 + 0.5
      DEPTH(5) = (TRC(7) + BLC(7)) / 2.0 + 0.5
      CALL SETLOC (DEPTH, T)
      XPIX = (TRC(1) + BLC(1)) / 2.0
      DO 720 I2 = 1,LIM2
         J = BLC(2) + I2 - 0.9
         IF (ISFREQ) THEN
            XV = XFREQ(J)
         ELSE
            YPIX = BLC(2) + I2 - 1.0
            CALL XYVAL (XPIX, YPIX, X(1), X(2), X(3), IRET)
            XV = X(2)
            END IF
         IF (OPCODE(2:4).EQ.'RMS') THEN
            WRITE (OUTLIN,1710) XV, ANSS(I2)
         ELSE IF (OPCODE(2:4).EQ.'AVG') THEN
            WRITE (OUTLIN,1710) XV, ANSW(I2), ANSS(I2)
         ELSE
            WRITE (OUTLIN,1710) XV, ANSW(I2)
            END IF
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', LUNT, FINDT, OUTLIN(:J), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT TEXT FILE'
            GO TO 990
            END IF
 720     CONTINUE
C
      IRET = 0
      GO TO 999
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DOIT2: ERROR',I3,' ON ',A)
 1710 FORMAT (1PE17.9,2X,2(1PE14.6))
      END
      SUBROUTINE DOIT3 (NPTS, LUNI, INDI, LUNT, FINDT, ANSW, COUNT,
     *   ANSS, IRET)
C-----------------------------------------------------------------------
C   DOIT3 sums aver the BLC-TRC window in axes 1-2, 4-N.
C   Inputs
C      NPTS    I      Number points in spectrum
C      LUNI    I      LUN of open data file
C      INDI    I      FTAB pointer of open data file
C      LUNT    I      LUN of open text file
C      FINDT   I      FTAB pointer of open data file
C   Outputs
C      ANSW    D(*)   Answer
C      COUNT   I(*)   Number samples in ANSW
C      ANSS    D(*)   RMS
C      IRET    I      > 0 => error
C-----------------------------------------------------------------------
      INTEGER   NPTS, LUNI, INDI, LUNT, FINDT, COUNT(*), IRET
      DOUBLE PRECISION ANSW(*), ANSS(*)
C
      INTEGER   IROUND, NYI, NXI, WINI(4), BOI, LIM1, LIM2, LIM3, LIM4,
     *   LIM5, LIM6, LIM7, I1, I2, I3, I4, I5, I6, I7, IPOS(7), CORN(7),
     *   IBIND, J, JTRIM, DEPTH(5)
      LOGICAL   T, F
      CHARACTER OUTLIN*128
      REAL      XPIX, YPIX
      DOUBLE PRECISION X(3), XV
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'IM2TX.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Setup for I/O
      NXI = CATBLK(KINAX)
      NYI = CATBLK(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         CORN(7) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            CORN(6) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               CORN(5) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  CORN(4) = I4
                  DO 300 I3 = 1,LIM3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     CORN(3) = I3
C                                       Init. files, first input.
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IPOS(3), BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'FIND OFFSET FOR I/O'
            GO TO 990
            END IF
         BOI = BOI + 1
         CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT READ OF DATA'
            GO TO 990
            END IF
         DO 200 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
C                                       Read.
            CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'read IMAGE DATA'
               GO TO 990
               END IF
            DO 100 I1 = 1,LIM1
               IF (BUFF1(IBIND+I1-1).NE.FBLANK) THEN
                  ANSW(I3) = ANSW(I3) + BUFF1(IBIND+I1-1)
                  ANSS(I3) = ANSS(I3) + BUFF1(IBIND+I1-1)**2
                  COUNT(I3) = COUNT(I3) + 1
                  END IF
 100              CONTINUE
 200           CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       average
      IF ((OPCODE(2:4).EQ.'AVG') .OR. (OPCODE(2:4).EQ.'RMS')) THEN
         DO 710 I1 = 1,LIM1
            IF (COUNT(I1).GT.0) THEN
               ANSW(I1) = ANSW(I1) / COUNT(I1)
               ANSS(I1) = ANSS(I1) / COUNT(I1) - ANSW(I1)**2
               ANSS(I1) = SQRT (MAX (0.0D0, ANSS(I1)))
               END IF
 710        CONTINUE
         END IF
      DEPTH(2) = (TRC(4) + BLC(4)) / 2.0 + 0.5
      DEPTH(3) = (TRC(5) + BLC(5)) / 2.0 + 0.5
      DEPTH(4) = (TRC(6) + BLC(6)) / 2.0 + 0.5
      DEPTH(5) = (TRC(7) + BLC(7)) / 2.0 + 0.5
      XPIX = (TRC(1) + BLC(1)) / 2.0
      YPIX = (TRC(2) + BLC(2)) / 2.0
      DO 720 I3 = 1,LIM3
         DEPTH(1) = BLC(3) + I3 - 1
         CALL SETLOC (DEPTH, T)
         J = BLC(3) + I3 - 0.9
         IF (ISFREQ) THEN
            XV = XFREQ(J)
         ELSE
            CALL XYVAL (XPIX, YPIX, X(1), X(2), X(3), IRET)
            XV = X(3)
            END IF
         IF (OPCODE(2:4).EQ.'RMS') THEN
            WRITE (OUTLIN,1710) XV, ANSS(I3)
         ELSE IF (OPCODE(2:4).EQ.'AVG') THEN
            WRITE (OUTLIN,1710) XV, ANSW(I3), ANSS(I3)
         ELSE
            WRITE (OUTLIN,1710) XV, ANSW(I3)
            END IF
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', LUNT, FINDT, OUTLIN(:J), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT TEXT FILE'
            GO TO 990
            END IF
 720     CONTINUE
C
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DOIT3: ERROR',I3,' ON ',A)
 1710 FORMAT (1PE17.9,2X,2(1PE14.6))
      END
      SUBROUTINE HIGET (DISK, CNO, NF, XFREQ, IRET)
C-----------------------------------------------------------------------
C   HIGET tries to get the frequencies from the history file
C   Inputs:
C      DISK    I      Disk number
C      CNO     I      Catalog number
C      NF      I      Number of frequencies
C   Output
C      XFREQ   D(*)   Frequencies
C      IRET    I      Error code
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, NF, IRET
      DOUBLE PRECISION XFREQ(*)
C
      INTEGER   IHLUN, NREC, IHPTR, HIBUFF(256), IBLK, ICARD, IP, MF,
     *   ICUR, IHIND, II
      CHARACTER LINE*72, CTYP*8
      DOUBLE PRECISION X
      REAL      HRBUFF(256)
      EQUIVALENCE (HIBUFF, HRBUFF)
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      MF = 0
      CALL DFILL (NF, 0.0D0, XFREQ)
C                                       open history file
      IHLUN = 27
C                                       Open history file.
      CALL HIINIT (3)
      CALL HIOPEN (IHLUN, DISK, CNO, HIBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL HILOCT ('SRCH', IHLUN, IHPTR, IRET)
      IF (IRET.NE.0) GO TO 100
C                                       Determine no. of hist. recs.
      NREC = HITAB(IHPTR+2)
      IHIND = HITAB(IHPTR+1)
      IBLK = 0
      ICARD = NHILPR
      DO 20 ICUR = 1,NREC
C                                       Read next buffer.
         ICARD = ICARD + 1
         IF (ICARD.GT.NHILPR) THEN
            IBLK = IBLK + 1
            ICARD = 1
            CALL ZFIO ('READ', IHLUN, IHIND, IBLK, HIBUFF, IRET)
            IF (IRET.NE.0) GO TO 100
            END IF
C                                       desired task?
         II = (ICARD-1) * NHIWPL + 5
         CALL H2CHR (72, 1, HRBUFF(II), LINE)
         IF (LINE(:12).EQ.'MCUBE COORD=') THEN
            READ (LINE,1000) X, CTYP, IP
C                                       test
            IF ((CTYP(:4).EQ.'FREQ') .AND. (IP.GT.0) .AND. (IP.LE.NF))
     *         THEN
               XFREQ(IP) = X
               MF = MF + 1
               WRITE (MSGTXT,1001) CTYP, X, IP
               CALL MSGWRT (3)
            ELSE
               WRITE (MSGTXT,1010) X, CTYP, IP
               CALL MSGWRT (7)
               END IF
            END IF
 20      CONTINUE
C                                       Close history file.
 100  CALL HICLOS (IHLUN, .FALSE., HIBUFF, II)
C                                       fill it all in??
      MF = NF
      DO 110 II = 1,NF
         IF (XFREQ(II).GT.0.0D0) MF = MF - 1
 110     CONTINUE
      IF (IRET.LE.0) IRET = -MF
      IF (MF.GT.0) THEN
         WRITE (MSGTXT,1110) MF
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (12X,E13.5,5X,13X,A8,11X,I5)
 1001 FORMAT ('Found in MCUBE history ',A8,' F=',1PE13.5,' plane',I5)
 1010 FORMAT ('Coordinate mismatch',1PE13.5,' ''',A8,''' plane',I5)
 1110 FORMAT ('WARNING:',I3,
     *   ' FREQUENCY PLANES NOT FOUND IN HISTORY FILE')
      END
      SUBROUTINE FQGET (DISK, CNO, NF, FV, CV, CP, CI, CATBLK, XFREQ,
     *   IRET)
C-----------------------------------------------------------------------
C   Gets the frequencies from the FQ table
C   Inputs:
C      DISK     I        disk
C      CNO      I        calatog number
C      NF       I        Number of frequencies
C      FV       D        Header ref frequency
C      CV       D        FQID axis ref value
C      CP       D        FQID axis ref pixel
C      CI       D        FQID axis increment
C      CATBLK   I(256)   old image header
C   Outputs:
C      XFREQ    D(*)     LOG10(freq/FV)
C      IRET     I        Error code
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, NF, CATBLK(*), IRET
      DOUBLE PRECISION FV, CV, XFREQ(*)
      REAL      CP, CI
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   BUFFER(512), VER, LUN, IFQRNO, FQKOLS(MAXFQC),
     *   FQNUMV(MAXFQC), NUMIF, FQID, IFSIDE, IREC, NREC, I, MF
      DOUBLE PRECISION IFFREQ
      REAL      IFCHW, IFTBW
      CHARACTER BNDCOD*8
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       open
      VER = 1
      LUN = 20
      NUMIF = 1
      CALL FQINI ('READ', BUFFER, DISK, CNO, VER, CATBLK, LUN, IFQRNO,
     *   FQKOLS, FQNUMV, NUMIF, IRET)
      IF (IRET.NE.0) GO TO 999
      NREC = BUFFER(5)
C                                       read
      DO 10 IREC = 1,NREC
         CALL TABFQ ('READ', BUFFER, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *      FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IRET)
         IF (IRET.NE.0) GO TO 20
         I = (FQID - CV) / CI + CP + 0.5
         IF ((I.GE.1) .AND. (I.LE.NF)) XFREQ(I) = IFFREQ + FV
 10      CONTINUE
 20   CALL TABFQ ('CLOS', BUFFER, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *   FQID, IFFREQ, IFCHW, IFTBW, IFSIDE, BNDCOD, IREC)
C                                       test
      MF = NF
      DO 30 I = 1,NF
         IF (XFREQ(I).GT.0.0D0) MF = MF - 1
 30      CONTINUE
      IF (IRET.LE.0) IRET = -MF
      IF (MF.GT.0) THEN
         WRITE (MSGTXT,1030) MF
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('WARNING:',I3,' FREQUENCY PLANES NOT FOUND IN FQ FILE')
      END

      SUBROUTINE CLBSNR (VOBS, IS, JS, WT, NUMBLS, NUMTEL, GAIN, SNR,
     *   CLOSER, SNRMIN, TIME, IF, IST, COUNT, PRTLV, RMSLIM, PRTSOU)
C-----------------------------------------------------------------------
C! Gain Soln: Compute antenna based SNRs from phase residuals.
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CLBSNR computes antenna based signal-to-noise ratioes (SNR) based
C   on phase residuals from a gain model.  The approximation used is
C   that SNR = 1.0 / RMS phase residual.
C      If CLOSER are greater than 0 then any values exceeding these
C   limits will be printed under control of PRTLV
C      Does a weighted solution for the SNR.  If insufficient data is
C   present to compute an RMS but at least one observation exists, the
C   SNR is set to 6.0.
C   Inputs:
C      IS       I(*)     Array of first antenna numbers.
C      JS       I(*)     Array of second antenna numbers.
C      WT       R(*)     Array of visibility baseline weights.
C      NUMBLS   I        Number of observations (baselines)
C      NUMTEL   I        Number of antennas.
C      GAIN     R(2,*)   Antenna gains to be applied (real, imaginary)
C      CLOSER   R(2,2)   (i,j) If (j=1/2) amplitude/phase closure errors
C                        exceed these limits on average (i=1) or
C                        individually (i=2) they will be printed
C      SNRMIN   R        Minimum SNR allowed.
C      TIME     D        Time in days of data, used for labeling.
C      IF       I        IF number used for labeling only.
C      IST      I        Stokes parameter of soln. 1-5 => R,L,R,L,I.
C      PRTLV    I        Print level: 0 none, 1 statistics of failures,
C                        2 individual failures, 3 the antenna SNRs
C      RMSLIM   R        Print only closures > rmslim * expected sigma
C      PRTSOU   C*16     Current source name.
C   Input/Output:
C      VOBS     R(2,*)   Normalized visibility (real, imaginary)
C                        Zero value assumed invalid on input.
C                        On return real part is replaced with the phase
C                        difference.
C      COUNT    I(*)     A work array used for the counts for each
C                        antenna, must be at least MAXANT in size.
C   Outputs:
C      SNR      R(*)     Signal to noise ratio for each antenna.
C                        If an antenna is used in fewer than 3 baselines
C                        the returned value is SNRMIN + 1.0
C-----------------------------------------------------------------------
      CHARACTER PRTSOU*16
      INTEGER   IS(*), JS(*), NUMBLS, NUMTEL, COUNT(*), IF, IST, PRTLV
      REAL      VOBS(2,*), GAIN(2,*), SNR(*), WT(*), CLOSER(2,2),
     *   SNRMIN, RMSLIM
      DOUBLE PRECISION TIME
C
      CHARACTER POL(5)*4
      INTEGER   LOOP, II, JJ, NPRT, ID, IH, IM, LS, BLPRT(3,3), NE
      LOGICAL   DOCLOS, MSGDUN, DOCLS1, DOCLS2
      REAL      ZR, ZI, ZZR, ZZI, PRTSNR, TMTEMP, PHSQ, AE, PE, AW, PW,
     *   NW, BLRPRT(3)
      INCLUDE 'INCS:PUVD.INC'
      REAL      SUMWT(MAXANT)
      INTEGER   ERROR(MAXANT), PERROR(MAXANT)
      INCLUDE 'INCS:DMSG.INC'
      DATA POL /'Rpol','Lpol','Rpol','Lpol','Ipol'/
C-----------------------------------------------------------------------
      DOCLS1 = (CLOSER(1,1) * CLOSER(1,2).GT.1.0E-20) .AND.
     *   (CLOSER(1,1) * CLOSER(1,2).LT.1.0E20) .AND. (PRTLV.GT.0)
      DOCLS2 = ((CLOSER(2,1) * CLOSER(2,2).GT.1.0E-20) .AND.
     *   (CLOSER(2,1) * CLOSER(2,2).LT.1.0E20)) .AND. (PRTLV.GT.0)
      DOCLOS = (DOCLS1) .OR. (DOCLS2)
      MSGDUN = .FALSE.
C                                       Label for any closure errors:
      IF (DOCLOS) THEN
         ID = TIME
         TMTEMP = (TIME - ID) * 24.0
         IH = TMTEMP
         TMTEMP = (TMTEMP - IH) * 60.0
         IM = TMTEMP
         TMTEMP = (TMTEMP - IM) * 60.0
         LS = TMTEMP
         IF (LS.EQ.60) THEN
            LS = 0
            IM = IM + 1
            IF (IM.EQ.60)  THEN
               IM = 0
               IH = IH + 1
               IF (IH.EQ.24) THEN
                  IH = 0
                  ID = ID + 1
                  END IF
               END IF
            END IF
         WRITE (MSGTXT,1000) ID, IH, IM, LS, PRTSOU, IF, POL(IST)
         END IF
C                                       Zero sums, counts etc.
      NPRT = 0
      DO 10 LOOP = 1,NUMTEL
         SNR(LOOP) = 0.0
         SUMWT(LOOP) = 0.0
         COUNT(LOOP) = 0
         ERROR(LOOP) = 0
         PERROR(LOOP) = 0
 10      CONTINUE
C                                       Determine phase residuals.
      NE = 0
      AE = 0.0
      PE = 0.0
      AW = 0.0
      PW = 0.0
      NW = 0.0
      DO 30 LOOP = 1,NUMBLS
         II = IS(LOOP)
         JJ = JS(LOOP)
         ZR = GAIN(1,II) * GAIN(1,JJ) + GAIN(2,II) * GAIN(2,JJ)
         ZI = GAIN(1,II) * GAIN(2,JJ) - GAIN(2,II) * GAIN(1,JJ)
         ZZR = VOBS(1,LOOP) * ZR - VOBS(2,LOOP) * ZI
         ZZI = VOBS(1,LOOP) * ZI + VOBS(2,LOOP) * ZR
         VOBS(2,LOOP) = SQRT (ZZR*ZZR + ZZI*ZZI)
         IF (VOBS(2,LOOP)*WT(LOOP).GT.1.0E-20) THEN
            VOBS(1,LOOP) = ATAN2 (ZZI, ZZR)
            IF (DOCLS1) THEN
               NE = NE + 1
               PE = PE + ABS (VOBS(1,LOOP))
               AE = AE + ABS (LOG10 (ABS (VOBS(2,LOOP)+1.E-20)))
               NW = NW + WT(LOOP)
               PW = PW + ABS (VOBS(1,LOOP)) * WT(LOOP)
               AW = AW + ABS (LOG10 (ABS (VOBS(2,LOOP)+1.E-20))) *
     *            WT(LOOP)
               END IF
            END IF
 30      CONTINUE
C                                       Statistical failure
      IF ((DOCLS1) .AND. (NE.GT.0)) THEN
         PE = PE / NE
         AE = AE / NE
         AE = (10.0 ** AE) - 1.0
         PW = PW / NW
         AW = AW / NW
         AW = (10.0 ** AW) - 1.0
C                                       print header, message
         IF ((AE.GT.CLOSER(1,1)) .OR. (PE.GT.CLOSER(1,2))) THEN
            CALL MSGWRT (4)
            MSGDUN = .TRUE.
            AE = AE * 100.0
            PE = PE * 57.296
            WRITE (MSGTXT,1030) AE, PE
            CALL MSGWRT (4)
            AW = AW * 100.0
            PW = PW * 57.296
            WRITE (MSGTXT,1031) AW, PW
            CALL MSGWRT (4)
            END IF
         END IF
C                                       Sum square residuals
      NE = 0
      DO 50 LOOP = 1,NUMBLS
         IF (VOBS(2,LOOP)*WT(LOOP).GE.1.0E-20) THEN
            PHSQ = VOBS(1,LOOP) * VOBS(1,LOOP) * WT(LOOP)
            II = IS(LOOP)
            COUNT(II) = COUNT(II) + 1
            SNR(II) = SNR(II) + PHSQ
            SUMWT(II) = SUMWT(II) + WT(LOOP)
            JJ = JS(LOOP)
            COUNT(JJ) = COUNT(JJ) + 1
            SNR(JJ) = SNR(JJ) + PHSQ
            SUMWT(JJ) = SUMWT(JJ) + WT(LOOP)
C                                       check closure error
            IF (DOCLS2) THEN
               PE = ABS (VOBS(1,LOOP))
               AE = VOBS(2,LOOP)
               IF ((AE.LT.1.0) .AND. (AE.GT.0.0)) AE = 1.0 / AE
               AE = AE - 1.0
               AW = SQRT (1.0 / WT(LOOP))
               PW = ASIN (MIN (1.0, AW))
               AW = RMSLIM * AW
               PW = RMSLIM * PW
               IF ((AE.GT.CLOSER(2,1)) .OR. (PE.GT.CLOSER(2,2))) THEN
                  ERROR(II) = ERROR(II) + 1
                  ERROR(JJ) = ERROR(JJ) + 1
                  NE = NE + 1
C                                       individual messages
                  IF ((PRTLV.GE.2) .AND. ((AE.GT.AW) .OR. (PE.GT.PW)))
     *               THEN
                     PERROR(II) = PERROR(II) + 1
                     PERROR(JJ) = PERROR(JJ) + 1
C                                       Print header message
                     IF (.NOT.MSGDUN) THEN
                        CALL MSGWRT (4)
                        MSGDUN = .TRUE.
                        END IF
C                                       Flush buffer if full
                     IF (NPRT.GE.3) THEN
                        WRITE (MSGTXT,1035) (BLPRT(1,LS), BLPRT(2,LS),
     *                     BLRPRT(LS), BLPRT(3,LS), LS = 1,NPRT)
                        CALL MSGWRT (4)
                        NPRT = 0
                        END IF
C                                       New entry
                     NPRT = NPRT + 1
                     BLPRT(1,NPRT) = II
                     BLPRT(2,NPRT) = JJ
                     BLPRT(3,NPRT) = PE * 57.296 + 0.5
                     BLRPRT(NPRT) = MAX (-9999., MIN (9999., AE*100.))
                     END IF
                  END IF
               END IF
            END IF
 50      CONTINUE
C                                       Flush closure message buffer
      IF (NPRT.GT.0) THEN
         WRITE (MSGTXT,1035) (BLPRT(1,LOOP), BLPRT(2,LOOP),
     *      BLRPRT(LOOP), BLPRT(3,LOOP), LOOP = 1,NPRT)
         CALL MSGWRT (4)
         NPRT = 0
         END IF
C                                       summary by antenna
      IF (NE.GT.0) THEN
         IF (.NOT.MSGDUN) THEN
            CALL MSGWRT (4)
            MSGDUN = .TRUE.
            END IF
         DO 60 LOOP = 1,NUMTEL
            IF (ERROR(LOOP).GT.0) THEN
               WRITE (MSGTXT,1050) LOOP, ERROR(LOOP), PERROR(LOOP)
               CALL MSGWRT (4)
               END IF
 60         CONTINUE
         END IF
C                                       Convert to SNRs
      DO 70 LOOP = 1,NUMTEL
         IF (COUNT(LOOP).LE.0) SNR(LOOP) = 0.0
C                                       For insufficient data (but
C                                       some) use SNRMIN + 1.0
         IF ((COUNT(LOOP).GE.1) .AND. (COUNT(LOOP).LE.2))
     *      SNR(LOOP) = SNRMIN + 1.0
         IF ((COUNT(LOOP).GE.3) .AND. (SNR(LOOP).GT.1.0E-20))
     *      SNR(LOOP) = 1.0 / SQRT (SNR(LOOP) /
     *      ((COUNT(LOOP)-1) * SUMWT(LOOP)))
C                                       Print result if desired.
         IF ((COUNT(LOOP).GE.1) .AND. (PRTLV.GE.3)) THEN
            PRTSNR = MIN (9999.999, SNR(LOOP))
            WRITE (MSGTXT,1060) LOOP, COUNT(LOOP), PRTSNR
            CALL MSGWRT (4)
            END IF
 70      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Closure errors at',I3,'/',I2.2,2(':',I2.2),1X,A12,
     *   ' IF no.',I3,2X,A4)
 1030 FORMAT ('Average closure error',F10.3,'%',F8.2,'d')
 1031 FORMAT ('Average closure error',F10.3,'%',F8.2,'d - weighted avg')
 1035 FORMAT (3(I4.2,'-',I2.2,F7.1,'%',I5,'d'))
 1050 FORMAT ('Antenna ',I2,' had',I5,' excess closure errors,',I5,
     *   ' printed')
 1060 FORMAT ('Antenna(',I2,') ',I3,' obs, SNR =',F10.3)
      END

LOCAL INCLUDE 'UVHIM.INC'
      REAL      XSEQ, XDISK, XQUAL, XBAND, XFREQ, XFQID, XTIME(8),
     *   XANT(50), XBASE(50), XUVRA(2), XSUBA, XBCHAN, XECHAN, XNCHAV,
     *   XCHINC, XBIF, XEIF, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER,
     *   XFLAG, XDOBND, XBPVER, XSMOTH(3), XOSEQ, XODISK, XIMSIZ(2),
     *   BPARM(10), DOBLNK, BADD(10)
      HOLLERITH XNAME(3), XCLASS(2), XSOUR(4), XCALC(1), XSTOK(1),
     *   XONAME(3), XOCLAS(2), MAPH(256)
      REAL      DOMAIN(2,2), MAPR(256)
      INTEGER   INDISK, CNO, NSUBA, NFRQ, CHINC, IMSIZE(2), CSIZE,
     *   CTYPE, DISKO, CNOO, MAPHDR(256), SEQO, INSEQ, ATYPE(2), NOUT,
     *   NIN, SCRTCH(256), NCHAV
      LOGICAL   HERMIT
      DOUBLE PRECISION MAPD(128)
      CHARACTER INNAME*12, INCLAS*6, OUNAME*12, OUCLAS*6
      EQUIVALENCE (MAPHDR, MAPH, MAPR, MAPD)
      COMMON /UVHIMP/ XNAME, XCLASS, XSEQ, XDISK, XSOUR, XQUAL, XCALC,
     *   XSTOK, XBAND, XFREQ, XFQID, XTIME, XANT, XBASE, XUVRA, XSUBA,
     *   XBCHAN, XECHAN, XNCHAV, XCHINC, XBIF, XEIF, XDOCAL, XGUSE,
     *   XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH, XIMSIZ,
     *   XONAME, XOCLAS, XOSEQ, XODISK, BPARM, DOBLNK, BADD
      COMMON /UVHIMI/ MAPHDR, SCRTCH, INDISK, CNO, NSUBA, NFRQ, CHINC,
     *   IMSIZE, DOMAIN, CSIZE, CTYPE, DISKO, CNOO, INSEQ, SEQO, NCHAV,
     *   ATYPE, NOUT, NIN, HERMIT
      COMMON /UVHIMC/ INNAME, INCLAS, OUNAME, OUCLAS
LOCAL END
      PROGRAM UVHIM
C-----------------------------------------------------------------------
C! Makes image of 2-D histogram of a UV data set.
C# Util UV Analysis
C-----------------------------------------------------------------------
C;  Copyright (C) 2006, 2008-2010, 2012, 2015-2016, 2018, 2020,
C;  Copyright (C) 2022-2023, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVHIM makes an image of a 2-D histogram of a UV data set.
C   Adverbs:
C      INNAME(3)    uv name  (12 chars).
C      INCLASS(2)   uv class ( 6 chars).
C      INSEQ        uv sequence number.
C      INDISK       uv disk.
C      STOKES       Stokes parameter (I, Q, U, V, RR, LL, RL, LR).
C      BCHAN        1st Spectral channel number.
C      ECHAN        last Spectral channel
C      BIF          1st IF band to use
C      EIF          last Spectral channel
C-----------------------------------------------------------------------
      INTEGER   IERR, NWORDS
      LONGINT   OFFSET, COFSET
      REAL      HIMAG(2), HCONV(2)
      INCLUDE 'UVHIM.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       Initialize and open file.
      CALL UVHGIN (IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'INITIALIZATION PROBLEM.'
         GO TO 990
         END IF
C                                       make memory for image
      NWORDS = (IMSIZE(1) * IMSIZE(2) - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, HIMAG, OFFSET, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'CANNOT MAKE MEMORY FOR IMAGE'
         GO TO 990
         END IF
      NWORDS = CSIZE * CSIZE
      HCONV(1) = 1.0
      COFSET = 0
      IF (NWORDS.GT.1) THEN
         NWORDS = (NWORDS - 1) / 1024 + 1
         CALL ZMEMRY ('GET ', TSKNAM, NWORDS, HCONV, COFSET, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'CANNOT MAKE MEMORY FOR CONVOLUTION FUNCTION'
            GO TO 990
            END IF
         CALL BLDCNV (CSIZE, CTYPE, HCONV(1+COFSET))
         END IF
C                                       Accumulate statistics from the
C                                       uv data.
      CALL BLDHGM (IMSIZE(1), IMSIZE(2), HIMAG(1+OFFSET), CSIZE,
     *   HCONV(1+COFSET), IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'PROBLEM PROCESSING THE UV DATA.'
         GO TO 990
         END IF
C                                       write out image
      CALL WRIHGM (IMSIZE(1), IMSIZE(2), HIMAG(1+OFFSET), IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'PROBLEM WRITING OUT THE IMAGE'
         GO TO 990
         END IF
      GO TO 995
C
 990  CALL MSGWRT (8)
C
 995  CALL DIE (IERR, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE UVHGIN (IERR)
C-----------------------------------------------------------------------
C    UVHGIN gets adverbs for UVHIM, opens the uv file, and determines
C    what is to be done.
C    Inputs:
C       IERR         I       Error code, 0 means success.
C   Output in Common:
C       .....        R(*)    AIPS adverbs values.
C       NBINS        I       Number of histogram bins.
C       INDISK       I       uv input disk number.
C       CNO          I       uv catalog slot number.
C       BCHAN        I       Frequency channel.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      CHARACTER PRGM*6, PTYPE*2, CBLANK*6
      LOGICAL   TABLE, EXIST, FITASC, MATCH
      INTEGER   I, IRET, IROUND, IUSER, LUN, FQVER, NIF, JERR, UVLUN,
     *   UVIND, NPARMS
      HOLLERITH CATH(256), CATUH(256)
      REAL      CATR(256), CATUR(256)
      DOUBLE PRECISION CATD(128), CATUD(128)
      INCLUDE 'UVHIM.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (CATBLK, CATH, CATR, CATD)
      EQUIVALENCE (CATUV, CATUH, CATUR, CATUD)
      DATA PRGM /'UVHIM '/
      DATA CBLANK /' '/
C-----------------------------------------------------------------------
C                                       Initialize parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARMS = 175
      CALL GTPARM (PRGM, NPARMS, RQUICK, XNAME, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010)
         CALL MSGWRT (8)
         RQUICK = .TRUE.
         CALL RELPOP (IERR, SCRTCH, IRET)
         GO TO 999
         END IF
C                                       Restart AIPS.
      IF (RQUICK) CALL RELPOP (IERR, SCRTCH, IRET)
C                                       Decode adverb values.
C                                       AIPS user number.
      IUSER = NLUSER
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
C                                       Input uv name etc.
      CALL H2CHR (12, 1, XNAME, INNAME)
      CALL H2CHR (6, 1, XCLASS, INCLAS)
      INSEQ  = IROUND (XSEQ)
      INDISK = IROUND (XDISK)
      CALL H2CHR (12, 1, XONAME, OUNAME)
      CALL H2CHR (6, 1, XOCLAS, OUCLAS)
      SEQO  = IROUND (XOSEQ)
      DISKO = IROUND (XODISK)
      CALL H2CHR (4, 1, XSTOK, STOKES)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (16, 1, XSOUR, SOURCS(1))
      SELQUA = IROUND (XQUAL)
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
C                                       Number of histogram bins.
      IMSIZE(1) = IROUND (XIMSIZ(1))
      IMSIZE(2) = IROUND (XIMSIZ(2))
      IF (IMSIZE(1).LE.64) IMSIZE(1) = 256
      IF (IMSIZE(2).LE.64) IMSIZE(2) = 256
C                                       Open the uv file and get its
C                                       catalog header.
      UVLUN = 45
      PTYPE = 'UV'
      CALL MAPOPN ('READ', INDISK, INNAME, INCLAS, INSEQ, PTYPE, IUSER,
     *   UVLUN, UVIND, CNO, CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'UVHGIN: ERROR OPENING UV FILE.'
         IERR = 1
         GO TO 990
         END IF
      CALL CHR2H (12, INNAME, 1, XNAME)
      CALL CHR2H (6, INCLAS, 1, XCLASS)
      XDISK = INDISK
      XSEQ = INSEQ
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = INDISK
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 0
      CALL COPY (256, CATBLK, CATUV)
C                                       Get uv pointer information from
C                                       the catalog header.
      CALL UVPGET (IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'UVHGIN: ERROR GETTING OFFSETS FROM UV FILE HEADER.'
         IERR = 1
         GO TO 990
         END IF
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = INNAME
      UCLAS = INCLAS
      UDISK = INDISK
      USEQ = INSEQ
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      UVRNG(1) = XUVRA(1)
      UVRNG(2) = XUVRA(2)
      IF (TYPUVD.GT.0) CALL RFILL (2, 0.0, UVRNG)
      IF (UVRNG(2).LE.0.0) UVRNG(2) = 1.0E10
C                                       Check spectral channel.
      BCHAN = 1
      ECHAN = 1
      IF (JLOCF.GE.0) THEN
         I = CATBLK(KINAX+JLOCF)
         IF (I.GT.1) THEN
            BCHAN = IROUND (XBCHAN)
            ECHAN = IROUND (XECHAN)
            IF (BCHAN.LE.0) BCHAN = 1
            IF ((ECHAN.LT.BCHAN) .OR. (ECHAN.GT.I)) ECHAN = I
            IF (BCHAN.GT.I) THEN
               WRITE (MSGTXT,1020) BCHAN, I
               IERR = 1
               GO TO 990
               END IF
            END IF
         END IF
      NCHAV = XNCHAV + 0.01
      IF (NCHAV.LE.0) NCHAV = 1
      IF (NCHAV.GT.ECHAN-BCHAN+1) NCHAV = ECHAN-BCHAN+1
      CHINC = XCHINC + 0.01
      IF (CHINC.LE.0) CHINC = NCHAV
      IF (CHINC.GT.ECHAN-BCHAN+1) CHINC = NCHAV
C                                       Check IF band
      BIF = 1
      EIF = 1
      IF (JLOCIF.GT.1) THEN
         I = CATBLK(KINAX+JLOCIF)
         IF (I.GT.1) THEN
            BIF = IROUND (XBIF)
            EIF = IROUND (XEIF)
            IF (BIF.LE.0) BIF = 1
            IF ((EIF.LT.BIF) .OR. (EIF.GT.I)) EIF = I
            IF (BIF.GT.I) THEN
               WRITE (MSGTXT,1025) BIF, I
               IERR = 1
               GO TO 990
               END IF
            END IF
         END IF
      XBCHAN = BCHAN
      XECHAN = ECHAN
      XNCHAV = NCHAV
      XCHINC = CHINC
      XBIF = BIF
      XEIF = EIF
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
C                                       Allow multiple subarrays
      CALL FNDEXT ('AN', CATBLK, NSUBA)
      IF ((SUBARR.GT.0) .AND. (SUBARR.LE.NSUBA)) NSUBA = 1
      NSUBA = MAX (1, NSUBA)
C                                       Allow multiple FQ ids
      NFRQ = 1
      IF ((FRQSEL.LE.0) .AND. (SELBAN.LE.0.0) .AND. (SELFRQ.LE.0D0))
     *   THEN
         FRQSEL = 1
C                                       Determine the number of FREQIDs.
         FQVER = 1
         CALL ISTAB ('FQ', INDISK, CNO, FQVER, LUN, FQBUFF, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) THEN
            CALL FQINI ('READ', FQBUFF, INDISK, CNO, FQVER, CATBLK,
     *         LUN, IFQRNO, FQKOLS, FQNUMV, NIF, JERR)
            IF (JERR.NE.0) GO TO 999
            NFRQ = FQBUFF(5)
            IF (NFRQ.GT.1) THEN
               WRITE (MSGTXT,1030) NFRQ
               CALL MSGWRT (3)
               END IF
            CALL TABIO ('CLOS', 0, IFQRNO, FQBUFF, FQBUFF, JERR)
            IF (JERR.NE.0) GO TO 999
            END IF
         END IF
C                                       Find specified FQ id
      CALL FQMATC (INDISK, CNO, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
      DOACOR = .FALSE.
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       histogram type
      ATYPE(1) = IROUND (BPARM(1))
      ATYPE(2) = IROUND (BPARM(2))
      IF ((ATYPE(1).LT.1) .OR. (ATYPE(1).GT.12) .OR. (ATYPE(2).LT.1)
     *   .OR. (ATYPE(2).GT.12) .OR. (ATYPE(1).EQ.ATYPE(2))) THEN
         ATYPE(1) = 1
         ATYPE(2) = 2
         END IF
C                                       Hermitian??
      IF (ATYPE(1).EQ.12) THEN
         HERMIT = ATYPE(2).EQ.9
         ATYPE(1) = 10
      ELSE IF (ATYPE(2).EQ.12) THEN
         HERMIT = ATYPE(1).EQ.9
         ATYPE(2) = 10
         END IF
      CSIZE = 100.0 * BPARM(8) + 0.5
      CSIZE = (CSIZE/2) * 2 + 1
      CTYPE = IROUND (BPARM(9))
      IF (CSIZE.EQ.1) CTYPE = -1
C                                       build image header
      CALL CATINI (CATBLK)
      CALL RCOPY (2, CATUH(KHOBJ), CATH(KHOBJ))
      CALL RCOPY (2, CATUH(KHTEL), CATH(KHTEL))
      CALL RCOPY (2, CATUH(KHINS), CATH(KHINS))
      CALL RCOPY (2, CATUH(KHOBS), CATH(KHOBS))
      CALL RCOPY (2, CATUH(KHDOB), CATH(KHDOB))
      CATBLK(KIDIM) = 5
      CATBLK(KINAX) = IMSIZE(1)
      CATBLK(KINAX+1) = IMSIZE(2)
      CATR(KREPO) = CATUR(KREPO)
      CALL COPY (3, CATUV(KICCL), CATBLK(KICCL))
      IF (DOCAL) CATBLK(KICCL) = CATBLK(KICCL) + 1
      IF (DOBAND.GT.0) CATBLK(KICBP) = CATBLK(KICBP) + 1
      IF (DOPOL.GT.0) CATBLK(KICPD) = CATBLK(KICPD) + 1
C                                       Build new file cat name.
      CALL MAKOUT (INNAME, INCLAS, INSEQ, CBLANK, OUNAME, OUCLAS, SEQO)
      CALL CHR2H (12, OUNAME, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, OUCLAS, KHIMCO, CATH(KHIMC))
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
      CATBLK(KIIMS) = SEQO
C                                       Create new cataloged file.
      CALL MCREAT (DISKO, CNOO, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1100) IERR
         GO TO 990
         END IF
      SEQO = CATBLK(KIIMS)
      CALL COPY (256, CATBLK, MAPHDR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CNOO
      FRW(NCFILE) = 2
C                                       copy some (all) keywords
      CALL KEYPCP (INDISK, CNO, DISKO, CNOO, 0, ' ', IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('UVHGIN: ERROR GETTING ADVERB VALUES.')
 1020 FORMAT ('UVHGIN: FREQUENCY CHANNEL',I4,' EXCEEDS LIMIT',I4)
 1025 FORMAT ('UVHGIN: IF BAND',I4,' EXCEEDS LIMIT',I4)
 1030 FORMAT ('Plotting',I4,' frequency IDs.')
 1100 FORMAT ('UVHGIN: MCREAT ERROR',I5)
      END
      SUBROUTINE BLDHGM (NX, NY, IMG, CS, CF, IERR)
C-----------------------------------------------------------------------
C   BLDHGM does two passes through the uv data file.  Firstly to get
C   the maxima and minima of the various parameters, and second to
C   construct the histogram image
C   Inputs:
C      NX     I          X pixels in image
C      NY     I          Y pixels in image
C      CS     I          size convolving function
C      CF     R(CS,CS)   convolving function
C   Outputs:
C      IMG    R(NX,NY)   histogram image
C      IERR   I          error code from UV disk IO mostly
C-----------------------------------------------------------------------
      INTEGER   NX, NY, CS, IERR
      REAL      IMG(NX,NY), CF(CS,CS)
C
      INCLUDE 'INCS:ZPBUFSZ.INC'
      LOGICAL   DOTHIS, REQBAS, DESEL
      INTEGER   ADDRES, IBIN(2), IROUND, K, IIF, ICHAN, ISTK1, ISTK2,
     *   ISTK, JSUB, IFRQ, ISUB, NIF, NXVER, NXLUN, NANT, IANT(50),
     *   NBAS, IBAS(50), I, J, IHERM, NHERM, LCHAN, LC2
      REAL      AMPMAX, AMPSQ, ASQMAX, IM, R2D, RE, RSQ, TMAX, TMIN, U,
     *   V, VAR, W, WGT, WGTMAX, UVMAX, RSQMAX, VIS(UVBFSS), RPARM(20),
     *   CATUVR(256), RBIN(2), SRE, SIM, SWT
      LONGINT   NSAMP
      DOUBLE PRECISION FI, FZ, FRQMUL
      INCLUDE 'UVHIM.INC'
      INCLUDE 'INCS:DSEL.INC'
      DOUBLE PRECISION FOFF(MAXIF)
      REAL      FINC(MAXIF)
      INTEGER   ISBAND(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATUV, CATUVR)
      PARAMETER (R2D = 180.0/3.14159265358)
C-----------------------------------------------------------------------
      NHERM = 1
      IF (HERMIT) NHERM = 2
      JSUB = SUBARR
      NXVER = 1
      NXLUN = 90
      NSAMP = 0
C                                       Initialize baseline selection.
      CALL SETANT (50, XANT, XBASE, NANT, NBAS, IANT, IBAS, DESEL)
C                                       init maxima
      RSQMAX =  0.0
      TMIN   =  1E30
      TMAX   = -1E30
      ASQMAX =  0.0
      WGTMAX =  0.0
      ISTK1 = 1
      ISTK2 = 0
C                                       range set by user
      IF ((BPARM(3).GT.0.0) .AND. (BPARM(4).LT.BPARM(5)) .AND.
     *   (BPARM(6).LT.BPARM(7)))  THEN
         DOMAIN(1,1) = BPARM(4)
         DOMAIN(2,1) = BPARM(5)
         DOMAIN(1,2) = BPARM(6)
         DOMAIN(2,2) = BPARM(7)
C                                       range set by data
      ELSE
         MSGTXT = 'Begin determination of scaling'
         CALL MSGWRT (1)
         DO 90 IFRQ = 1,NFRQ
            IF (NFRQ.GT.1) FRQSEL = IFRQ
            CALL CHNDAT ('READ', NXBUFF, INDISK, CNO, NXVER, CATUV,
     *         NXLUN, NIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IERR)
            IF (IERR.NE.0) THEN
               MSGTXT = 'PROBLEM FINDING FREQUENCIES'
               CALL MSGWRT (6)
               GO TO 90
               END IF
            DO 80 ISUB = 1,NSUBA
               IF (JSUB.EQ.0) SUBARR = ISUB
C                                       Init vis file for read.
               CALL UVGET ('INIT', RPARM, VIS, IERR)
C
               IF (IERR.EQ.-1) GO TO 70
               IF (IERR.EQ.5) GO TO 70
               IF (IERR.GT.0) GO TO 999
               IF (ISTK2.LE.0) ISTK2 = CATBLK(KINAX+JLOCS)

C                                       Loop Read vis. record.
 10            CALL UVGET ('READ', RPARM, VIS, IERR)
               IF (IERR.GT.0) THEN
                  WRITE (MSGTXT,1010) IERR
                  GO TO 990
C                                       a data record
               ELSE IF (IERR.EQ.0) THEN
C                                       Do we need this baseline?
                  IF (ILOCB.GE.0) THEN
                     I = INT (RPARM(ILOCB+1)) / 256
                     J = MOD (INT (RPARM(ILOCB+1)), 256)
                  ELSE
                     I = RPARM(ILOCA1+1) + 0.1
                     J = RPARM(ILOCA2+1) + 0.1
                     END IF
                  IF (.NOT.REQBAS (I, J, DESEL, IANT, NANT, IBAS, NBAS))
     *               GO TO 10
                  DOTHIS = .FALSE.
                  DO 60 ICHAN = BCHAN,ECHAN,CHINC
                     DO 50 IIF = BIF,EIF
                        FZ = FOFF(IIF) / UVFREQ + 1.0D0
                        FI = FINC(IIF) / UVFREQ
                        FRQMUL = 1.0D0
                        IF (TYPUVD.LE.0) FRQMUL = FZ + FI *
     *                    (ICHAN - 1 + BCHAN - CATUVR(KRCRP+KLOCFY))
                        FRQMUL = FRQMUL ** 2
                        DO 40 ISTK = ISTK1,ISTK2
                           LC2 = MIN (ECHAN, ICHAN+NCHAV-1)
                           SRE = 0.0
                           SIM = 0.0
                           SWT = 0.0
                           DO 20 LCHAN = ICHAN,LC2
                              ADDRES = 1 + (LCHAN-BCHAN) * INCF +
     *                           (IIF-BIF) * INCIF + (ISTK-ISTK1) * INCS
                              WGT = VIS(ADDRES+2)
                              IF (WGT.GT.0.0) THEN
                                 SRE = SRE + WGT * VIS(ADDRES)
                                 SIM = SIM + WGT * VIS(ADDRES+1)
                                 SWT = SWT + WGT
                                 END IF
 20                           CONTINUE
C                                       Get maxima and minima.
                           IF (SWT.GT.0.0) THEN
                              DOTHIS = .TRUE.
                              RE = SRE / SWT
                              IM = SIM / SWT
                              AMPSQ  = RE**2 + IM**2
                              ASQMAX = MAX (ASQMAX, AMPSQ)
                              WGTMAX = MAX (WGTMAX, SWT)
                              END IF
 40                        CONTINUE
 50                     CONTINUE
 60                  CONTINUE
C                                       Get maxima and minima.
                  IF (DOTHIS) THEN
                     RSQ    = (RPARM(1+ILOCU)**2 + RPARM(1+ILOCV)**2)
     *                  * FRQMUL
                     RSQMAX = MAX (RSQ, RSQMAX)
                     TMIN   = MIN (TMIN, RPARM(1+ILOCT))
                     TMAX   = MAX (TMAX, RPARM(1+ILOCT))
                     END IF
                  GO TO 10
                  END IF
 70            CALL UVGET ('CLOS', RPARM, VIS, IERR)
 80            CONTINUE
 90         CONTINUE
C
         AMPMAX = SQRT (ASQMAX)
         UVMAX = SQRT (RSQMAX)
         DO 95 I = 1,2
            IF (ATYPE(I).LE.2) THEN
               DOMAIN(1,I) = -AMPMAX
               DOMAIN(2,I) = AMPMAX
            ELSE IF (ATYPE(I).EQ.3) THEN
               DOMAIN(1,I) = 0.0
               DOMAIN(2,I) = AMPMAX
            ELSE IF (ATYPE(I).EQ.4) THEN
               DOMAIN(1,I) = -180.0
               DOMAIN(2,I) = 180.0
            ELSE IF (ATYPE(I).EQ.5) THEN
               DOMAIN(1,I) = 0.0
               DOMAIN(2,I) = WGTMAX
            ELSE IF (ATYPE(I).EQ.6) THEN
               DOMAIN(1,I) = TMIN
               DOMAIN(2,I) = TMAX
            ELSE IF (ATYPE(I).EQ.7) THEN
               DOMAIN(1,I) = 0.0
               DOMAIN(2,I) = UVMAX
            ELSE IF (ATYPE(I).EQ.8) THEN
               DOMAIN(1,I) = -180.0
               DOMAIN(2,I) = 180.0
            ELSE IF (ATYPE(I).GE.9) THEN
               DOMAIN(1,I) = -UVMAX
               DOMAIN(2,I) = UVMAX
               END IF
            IF (BPARM(3).GT.0.0) THEN
               IF (BPARM(2+2*I).LT.BPARM(3+2*I)) THEN
                  DOMAIN(1,I) = BPARM(2+2*I)
                  DOMAIN(2,I) = BPARM(3+2*I)
               ELSE IF (BPARM(2+2*I).GT.BPARM(3+2*I)) THEN
                  DOMAIN(1,I) = MAX (BPARM(3+2*I), DOMAIN(1,I))
                  DOMAIN(2,I) = MIN (BPARM(2+2*I), DOMAIN(2,I))
                  END IF
               END IF
 95         CONTINUE
         END IF
C                                       Second pass:  Accumulate data
C                                       for the histograms.
C                                       Clear the histogram storage
C                                       array.
      MSGTXT = 'Begin binning of the data'
      CALL MSGWRT (1)
      I = NX * NY
      CALL RFILL (I, 0.0, IMG)
      NOUT = 0
      NIN = 0
C                                       over FQID
      DO 190 IFRQ = 1,NFRQ
         IF (NFRQ.GT.1) FRQSEL = IFRQ
         CALL CHNDAT ('READ', NXBUFF, INDISK, CNO, NXVER, CATUV,
     *      NXLUN, NIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IERR)
         IF (IERR.NE.0) GO TO 190
         DO 180 ISUB = 1,NSUBA
            IF (JSUB.EQ.0) SUBARR = ISUB
C                                       Init vis file for read.
            CALL UVGET ('INIT', RPARM, VIS, IERR)
C
            IF (IERR.EQ.-1) GO TO 175
            IF (IERR.EQ.5) GO TO 175
            IF (IERR.GT.0) GO TO 999
            IF (ISTK2.LE.0) ISTK2 = CATBLK(KINAX+JLOCS)
C                                       Loop Read vis. record.
 110        CALL UVGET ('READ', RPARM, VIS, IERR)
            IF (IERR.GT.0) THEN
               WRITE (MSGTXT,1010) IERR, IFRQ, ISUB
               GO TO 990
C                                       a data record
            ELSE IF (IERR.EQ.0) THEN
C                                       Do we need this baseline?
               IF (ILOCB.GE.0) THEN
                  I = INT (RPARM(ILOCB+1)) / 256
                  J = MOD (INT (RPARM(ILOCB+1)), 256)
               ELSE
                  I = RPARM(ILOCA1+1) + 0.1
                  J = RPARM(ILOCA2+1) + 0.1
                  END IF
               IF (.NOT.REQBAS (I, J, DESEL, IANT, NANT, IBAS, NBAS))
     *            GO TO 110
C                                       Get visibilities out of uvbuff.
               DO 170 ICHAN = BCHAN,ECHAN,CHINC
                  DO 150 IIF = BIF,EIF
                     FZ = FOFF(IIF) / UVFREQ + 1.0D0
                     FI = FINC(IIF) / UVFREQ
                     FRQMUL = 1.0D0
                     IF (TYPUVD.LE.0) FRQMUL = FZ + FI *
     *                  (ICHAN - 1 + BCHAN - CATUVR(KRCRP+KLOCFY))
C                                       Get (u,v,w) out of uvbuff.
                     U = RPARM(1+ILOCU) * FRQMUL
                     V = RPARM(1+ILOCV) * FRQMUL
                     W = RPARM(1+ILOCW) * FRQMUL
                     DO 140 ISTK = ISTK1,ISTK2
                        ADDRES = 1 + (ICHAN-BCHAN) * INCF +
     *                     (IIF-BIF) * INCIF + (ISTK-ISTK1) * INCS
                        LC2 = MIN (ECHAN, ICHAN+NCHAV-1)
                        SRE = 0.0
                        SIM = 0.0
                        SWT = 0.0
                        DO 120 LCHAN = ICHAN,LC2
                           ADDRES = 1 + (LCHAN-BCHAN) * INCF +
     *                        (IIF-BIF) * INCIF + (ISTK-ISTK1) * INCS
                           WGT    = VIS(ADDRES+2)
                           IF (WGT.GT.0.0) THEN
                              SRE = SRE + WGT * VIS(ADDRES)
                              SIM = SIM + WGT * VIS(ADDRES+1)
                              SWT = SWT + WGT
                              END IF
 120                       CONTINUE
                        WGT = SWT
                        IF (WGT.GT.0.0) THEN
                           NSAMP = NSAMP + 1
                           RE  = SRE / WGT
                           IM  = SIM / WGT
                           DO 135 IHERM = 1,NHERM
                           DO 130 I = 1,2
                              VAR = 0.0
                              K = ATYPE(I)
C                                       Identify the variable.
                              IF (K.EQ.9) THEN
                                 VAR = U
                              ELSE IF (K.EQ.10) THEN
                                 VAR = V
                              ELSE IF (K.EQ.11) THEN
                                 VAR = W
                              ELSE IF (K.EQ.7) THEN
                                 VAR = SQRT (U*U + V*V)
                              ELSE IF (K.EQ.8) THEN
                                 IF ((U.NE.0.0) .OR. (V.NE.0.0))
     *                              VAR = ATAN2 (V, U) * R2D
                              ELSE IF (K.EQ.6) THEN
                                 VAR = RPARM(1+ILOCT)
                              ELSE IF (K.EQ.1) THEN
                                 VAR = RE
                              ELSE IF (K.EQ.2) THEN
                                 VAR = IM
                              ELSE IF (K.EQ.3) THEN
                                 VAR = SQRT (RE*RE + IM*IM)
                              ELSE IF (K.EQ.4) THEN
                                 IF ((RE.NE.0.0) .OR. (IM.NE.0.0))
     *                              VAR = ATAN2 (IM, RE) * R2D
                              ELSE IF (K.EQ.5) THEN
                                 VAR = WGT
                                 END IF
C                                       Calculate the bin.
                              RBIN(I) = (IMSIZE(I)-1.0) *
     *                           (VAR-DOMAIN(1,I)) /
     *                           (DOMAIN(2,I)-DOMAIN(1,I)) + 1.0
                              IBIN(I) = IROUND (RBIN(I))
 130                          CONTINUE
C                                       Check for under- or overflow.
                           IF ((IBIN(1).LT.1) .OR.(IBIN(2).LT.1) .OR.
     *                        (IBIN(1).GT.IMSIZE(1)) .OR.
     *                        (IBIN(2).GT.IMSIZE(2))) THEN
                              NOUT = NOUT + 1
C                                       grid the sample
                           ELSE IF (CS.EQ.1) THEN
                              NIN = NIN + 1
                              IMG(IBIN(1),IBIN(2)) =
     *                           IMG(IBIN(1),IBIN(2)) + 1
                           ELSE
                              NIN = NIN + 1
                              CALL GRIDIT (NX, NY, IMG, CS, CF, RBIN,
     *                           IBIN)
                              END IF
                           U = -U
                           V = -V
 135                       CONTINUE
                           END IF
 140                    CONTINUE
 150                 CONTINUE
 170              CONTINUE
               GO TO 110
               END IF
 175        CALL UVGET ('CLOS', RPARM, VIS, IERR)
 180        CONTINUE
 190     CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ERROR INITING FQ',I3,' SUBARRAY',I3)
      END
      SUBROUTINE BLDCNV (CS, CT, CF)
C-----------------------------------------------------------------------
C   Build and normalizes the convolving function
C   Inputs:
C      CS   I          Size in pixels of convolving function
C      CT   I          Type of convolving function
C   Outputs:
C      CF   R(CS,CS)   Convolving function
C-----------------------------------------------------------------------
      INTEGER   CS, CT
      REAL      CF(CS,CS)
C
      INTEGER   I, J, IC, IA, IB, I1, I2, J1, J2, II, JJ, IR
      REAL      X, Y, R, SUP, YF, SCALE
C-----------------------------------------------------------------------
      IC = (CS + 1) / 2
      IF ((CT.LT.-4) .OR. (CT.GT.4) .OR. (CT.EQ.0)) CT = -1
C                                       initial function computation
      SCALE = 1.0 / MAX (1.0, IC-1.0)
      SUP = (IC-1) * (IC-1)
C                                       rectangles : pill box
      IF (CT.EQ.-1) THEN
         I = CS * CS
         CALL RFILL (I, 1.0, CF)
C                                       linear
      ELSE IF (CT.EQ.-2) THEN
         DO 25 J = 1,CS
            Y = ABS (J-IC)
            YF = MAX (0.0, (1.0 - Y*SCALE))
            DO 20 I = 1,CS
               X = ABS (I-IC)
               CF(I,J) = YF * MAX (0.0, (1.0 - X*SCALE))
 20            CONTINUE
 25         CONTINUE
C                                       exponential
      ELSE IF (CT.EQ.-3) THEN
         DO 35 J = 1,CS
            Y = ABS (J-IC) * SCALE
            YF = EXP ( - 2.0 * Y)
            DO 30 I = 1,CS
               X = ABS (I-IC) * SCALE
               CF(I,J) = YF * EXP (-2.0 * X)
 30            CONTINUE
 35         CONTINUE
C                                       gaussian
      ELSE IF (CT.EQ.-4) THEN
         DO 45 J = 1,CS
            Y = ABS (J-IC) * SCALE
            YF = EXP ( - 4.0 * Y * Y)
            DO 40 I = 1,CS
               X = ABS (I-IC) * SCALE
               CF(I,J) = YF * EXP (-4.0 * X * X)
 40            CONTINUE
 45         CONTINUE
C                                       circular: pill box
      ELSE IF (CT.EQ.1) THEN
         DO 115 J = 1,CS
            Y = (J-IC)*(J-IC)
            DO 110 I = 1,CS
               X = I-IC
               R = X*X + Y
               IF (R.LE.SUP) THEN
                  CF(I,J) = 1.0
               ELSE
                  CF(I,J) = 0.0
                  END IF
 110           CONTINUE
 115        CONTINUE
C                                       circular: linear
      ELSE IF (CT.EQ.2) THEN
         DO 125 J = 1,CS
            Y = (J-IC)*(J-IC)
            DO 120 I = 1,CS
               X = I-IC
               R = X*X + Y
               IF (R.LE.SUP) THEN
                  R = SQRT (R) * SCALE
                  CF(I,J) = MAX (0.0, (1.0 - R))
               ELSE
                  CF(I,J) = 0.0
                  END IF
 120           CONTINUE
 125        CONTINUE
C                                       circular: exponential
      ELSE IF (CT.EQ.3) THEN
         DO 135 J = 1,CS
            Y = (J-IC)*(J-IC)
            DO 130 I = 1,CS
               X = I-IC
               R = X*X + Y
               IF (R.LE.SUP) THEN
                  R = SQRT (R) * SCALE
                  CF(I,J) = 1.0 - EXP (-2.0 * R)
               ELSE
                  CF(I,J) = 0.0
                  END IF
 130           CONTINUE
 135        CONTINUE
C                                       circular: gaussian
      ELSE IF (CT.EQ.4) THEN
         DO 145 J = 1,CS
            Y = (J-IC)*(J-IC)
            DO 140 I = 1,CS
               X = I-IC
               R = X*X + Y
               IF (R.LE.SUP) THEN
                  R = R * SCALE * SCALE
                  CF(I,J) = 1.0 - EXP (-4.0 * R)
               ELSE
                  CF(I,J) = 0.0
                  END IF
 140           CONTINUE
 145        CONTINUE
         END IF
C                                       Now normalize so that each
C                                       convolution sums to 1.0
      IA = IC - 25
      IB = IC + 24
      IR = (CS -1) / 100 + 1
      DO 290 J = IA,IB
         J1 = J - 50 * IR
         IF (J1.LT.1) J1 = J1 + 50
         IF (J1.LT.1) J1 = J1 + 50
         IF (J1.LT.1) J1 = J1 + 50
         IF (J1.LT.1) J1 = J1 + 50
         J2 = J + 50 * IR
         IF (J2.GT.CS) J2 = J2 - 50
         IF (J2.GT.CS) J2 = J2 - 50
         IF (J2.GT.CS) J2 = J2 - 50
         IF (J2.GT.CS) J2 = J2 - 50
         DO 280 I = IA,IB
            I1 = I - 50 * IR
            IF (I1.LT.1) I1 = I1 + 50
            IF (I1.LT.1) I1 = I1 + 50
            IF (I1.LT.1) I1 = I1 + 50
            IF (I1.LT.1) I1 = I1 + 50
            I2 = I + 50 * IR
            IF (I2.GT.CS) I2 = I2 - 50
            IF (I2.GT.CS) I2 = I2 - 50
            IF (I2.GT.CS) I2 = I2 - 50
            IF (I2.GT.CS) I2 = I2 - 50
            SUP = 0.0
            DO 220 JJ = J1,J2,50
               DO 210 II = I1,I2,50
                  SUP = SUP + CF(II,JJ)
 210              CONTINUE
 220           CONTINUE
            IF (SUP.GT.0.0) THEN
               DO 240 JJ = J1,J2,50
                  DO 230 II = I1,I2,50
                     CF(II,JJ) = CF(II,JJ) / SUP
 230                 CONTINUE
 240              CONTINUE
               END IF
 280        CONTINUE
 290     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE GRIDIT (NX, NY, IMG, CS, CF, RBIN, IBIN)
C-----------------------------------------------------------------------
C   grids a sample to the image
C   Inputs:
C      NX     I          X size of image
C      NY     I          Y size of image
C      CS     I          Size of convolving function
C      CF     R(CS,CS)   Convolving function
C      RBIN   R(2)       Bin location in image pixels
C      IBIN   I(2)       Integerized bin location
C   In/Out
C      IMG    R(NX,NY)   Image
C-----------------------------------------------------------------------
      INTEGER   NX, NY, CS, IBIN(2)
      REAL      IMG(NX,NY), CF(CS,CS), RBIN(2)
C
      INTEGER   IC, ICX, ICY, IROUND, IR, I, I1, I2, J, J1, J2, II, JJ
C-----------------------------------------------------------------------
      IC = (CS + 1) / 2
      ICX = IROUND ((RBIN(1) - IBIN(1)) * 50.0)
      ICY = IROUND ((RBIN(2) - IBIN(2)) * 50.0)
      ICX = IC - ICX
      ICY = IC - ICY
      IR = (CS - 1) / 100 + 1
      J1 = IBIN(2) - IR
      J2 = IBIN(2) + IR
      I1 = IBIN(1) - IR
      I2 = IBIN(1) + IR
      DO 50 J = J1,J2
         JJ = ICY + (J-IBIN(2)) * 50
         IF ((JJ.GE.1) .AND. (JJ.LE.CS)) THEN
            DO 40 I = I1,I2
               II = ICX + (I-IBIN(1)) * 50
               IF ((II.GE.1) .AND. (II.LE.CS))
     *            IMG(I,J) = IMG(I,J) + CF(II,JJ)
 40            CONTINUE
            END IF
 50      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE WRIHGM (NX, NY, IMG, IERR)
C-----------------------------------------------------------------------
C   WRIHGM completes the image header, writes the image data, does the
C   HI file
C   Inputs:
C      NX     I          X size of image
C      NY     I          Y size of image
C      IMG    R(NX,NY)   Image
C   Output:
C      IERR   I          Error code
C   CATBLK comes in pointing at UV data, MAPHDR at image header
C-----------------------------------------------------------------------
      INTEGER   NX, NY, IERR
      REAL      IMG(NX,NY)
C
      INCLUDE 'INCS:PMAD.INC'
      INCLUDE 'UVHIM.INC'
      INTEGER   I, J, OLUN, OIND, OWIN(4), IBLKOF, NBY, OBIND, IH1LUN,
     *   IH2LUN, I1, I2, NFILES
      CHARACTER TYPE(11)*8, UNITS(11)*11, MTYPE*2, HILINE*72
      REAL      CATR(256), BUFF(MABFSS), RMAX, RMIN, RSUM
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA TYPE /'VIS (RE)', 'VIS (IM)', 'VIS (AM)', 'VIS (PH)',
     *   'WEIGHT', 'TIME', 'BASELENG', 'BASEL PA', 'U', 'V', 'W'/
      DATA UNITS /'Jy', 'Jy', 'Jy', 'Degrees', '1/(Jy**2)', 'Days',
     *   'Wavelengths', 'Degrees', 3*'Wavelengths'/
C-----------------------------------------------------------------------
C                                       work on header
      CALL CHR2H (8, 'COUNT   ', 1, MAPH(KHBUN))
      MAPD(KDORA) = CATD(KDORA)
      MAPD(KDODE) = CATD(KDODE)
      MAPD(KDRST) = CATD(KDRST)
      CALL CHR2H (8, TYPE(ATYPE(1)), 1, MAPH(KHCTP))
      CALL CHR2H (8, TYPE(ATYPE(2)), 1, MAPH(KHCTP+2))
      MAPD(KDCRV) = DOMAIN(1,1)
      MAPD(KDCRV+1) = DOMAIN(1,2)
      MAPR(KRCRP) = 1.0
      MAPR(KRCRP+1) = 1.0
      MAPR(KRCIC) = (DOMAIN(2,1)-DOMAIN(1,1)) / (IMSIZE(1)-1.0)
      MAPR(KRCIC+1) = (DOMAIN(2,2)-DOMAIN(1,2)) / (IMSIZE(2)-1.0)
      I = 1
      IF (JLOCF.GE.0) THEN
         I = I + 1
         MAPH(KHCTP+2*I) = CATH(KHCTP+2*JLOCF)
         MAPH(KHCTP+2*I+1) = CATH(KHCTP+2*JLOCF+1)
         MAPD(KDCRV+I) = CATD(KDCRV+JLOCF) + (1.-CATR(KRCRP+JLOCF)) *
     *      CATR(KRCIC+JLOCF)
         MAPR(KRCIC+I) = CATR(KRCIC+JLOCF)
         MAPR(KRCRP+I) = 1.0
         END IF
      IF (JLOCR.GE.0) THEN
         I = I + 1
         MAPH(KHCTP+2*I) = CATH(KHCTP+2*JLOCR)
         MAPH(KHCTP+2*I+1) = CATH(KHCTP+2*JLOCR+1)
         MAPD(KDCRV+I) = CATD(KDCRV+JLOCR)
         MAPR(KRCIC+I) = CATR(KRCIC+JLOCR)
         MAPR(KRCRP+I) = 1.0
         END IF
      IF (JLOCD.GE.0) THEN
         I = I + 1
         MAPH(KHCTP+2*I) = CATH(KHCTP+2*JLOCD)
         MAPH(KHCTP+2*I+1) = CATH(KHCTP+2*JLOCD+1)
         MAPD(KDCRV+I) = CATD(KDCRV+JLOCD)
         MAPR(KRCIC+I) = CATR(KRCIC+JLOCD)
         MAPR(KRCRP+I) = 1.0
         END IF
      MAPHDR(KIDIM) = I + 1
      RMAX = -1.E10
      RMIN = -RMAX
      RSUM = 0.0
      DO 20 J = 1,NY
         DO 10 I = 1,NX
            IF ((DOBLNK.GT.0.0) .AND. (IMG(I,J).LE.0.0)) THEN
               IMG(I,J) = FBLANK
            ELSE
               RMAX = MAX (RMAX, IMG(I,J))
               RMIN = MIN (RMIN, IMG(I,J))
               RSUM = RSUM + IMG(I,J)
               END IF
 10         CONTINUE
 20      CONTINUE
      MAPR(KRDMX) = RMAX
      MAPR(KRDMN) = RMIN
      IF (DOBLNK.GT.0.0) MAPR(KRBLK) = FBLANK
C                                       force header update
      CALL CATIO ('UPDT', DISKO, CNOO, MAPHDR, 'REST', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CATIO UPDATE'
         CALL MSGWRT (7)
         END IF
C                                       open image output
      OLUN = 49
      MTYPE = 'MA'
      CALL MAPOPN ('INIT', DISKO, OUNAME, OUCLAS, SEQO, MTYPE, NLUSER,
     *   OLUN, OIND, CNOO, MAPHDR, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN'
         GO TO 990
         END IF
      OWIN(1) = 1
      OWIN(2) = 1
      OWIN(3) = NX
      OWIN(4) = NY
      IBLKOF = 1
      NBY = 2 * MABFSS
      CALL MINIT ('WRIT', OLUN, OIND, NX, NY, OWIN, BUFF, NBY, IBLKOF,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'MINIT'
         GO TO 990
         END IF
      DO 40 J = 1,NY
         CALL MDISK ('WRIT', OLUN, OIND, BUFF, OBIND, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'WRITE'
            GO TO 990
            END IF
         CALL RCOPY (NX, IMG(1,J), BUFF(OBIND))
 40      CONTINUE
      CALL MDISK ('FINI', OLUN, OIND, BUFF, OBIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'FINISH'
         GO TO 990
         END IF
C                                       Initialize HITAB
      NFILES = 3
      CALL HIINIT (NFILES)
C                                       Create and copy history file.
      IH1LUN = 61
      IH2LUN = 62
      CALL HISCOP (IH1LUN, IH2LUN, INDISK, DISKO, CNO, CNOO,
     *   MAPHDR, BUFF, SCRTCH, IERR)
      IF (IERR.GT.3) GO TO 300
      IF (IERR.EQ.3) GO TO 200
C                                       add UVHIM history
      CALL HENCO1 (TSKNAM, INNAME, INCLAS, INSEQ, INDISK, IH2LUN,
     *   SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, OUNAME, OUCLAS, SEQO, DISKO, IH2LUN,
     *   SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       calibration adverbs
C                                       TIMERANG
      CALL HITIME (TSTART, TEND, IH2LUN, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Stokes'
      WRITE (HILINE,1100) TSKNAM, XSTOK
      CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       IF range
      WRITE (HILINE,1110) TSKNAM, BIF, EIF
      CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Chan range
      WRITE (HILINE,1120) TSKNAM, BCHAN, ECHAN, CHINC
      CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Subarray
      IF (NSUBA.LE.1) THEN
         WRITE (HILINE,1130) TSKNAM, SUBARR
      ELSE
         WRITE (HILINE,1131) TSKNAM, NSUBA
         END IF
      CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Flagging
      IF (FGVER.GT.0) THEN
         WRITE (HILINE,1140) TSKNAM, FGVER
         CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                        Spectral smoothing
      IF (SMOOTH(1).GT.0.5) THEN
         I1 = SMOOTH(1) + 0.5
         I2 = SMOOTH(3) + 0.5
         WRITE (HILINE,1150) TSKNAM, I1, SMOOTH(2), I2
         CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       Calibration
      IF (DOCAL) THEN
         WRITE (HILINE,1160) TSKNAM, CLUSE
         CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       Polzn correction
      IF (DOPOL.GT.0) THEN
         WRITE (HILINE,1170) TSKNAM, DOPOL
         CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       BL table
      IF (XBLVER.GE.0.0) THEN
         WRITE (HILINE,1180) TSKNAM, BLVER
         CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       BP table
      IF (XDOBND.GT.0.0) THEN
         WRITE (HILINE,1190) TSKNAM, DOBAND
         CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
         WRITE (HILINE,1200) TSKNAM, BPVER
         CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       Calibrate weights?
      IF (DOCAL) THEN
         IF (DOWTCL) THEN
            WRITE (HILINE,1210) TSKNAM
         ELSE
            WRITE (HILINE,1211) TSKNAM
            END IF
         CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                      Add any other history
      WRITE (HILINE,1220) TSKNAM, 'X', TYPE(ATYPE(1)), UNITS(ATYPE(1))
      CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      MSGTXT = HILINE(8:)
      CALL MSGWRT (2)
      WRITE (HILINE,1221) TSKNAM, 'X', DOMAIN(1,1), DOMAIN(2,1)
      CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      MSGTXT = HILINE(8:)
      CALL MSGWRT (2)
      WRITE (HILINE,1220) TSKNAM, 'Y', TYPE(ATYPE(2)), UNITS(ATYPE(2))
      CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      MSGTXT = HILINE(8:)
      CALL MSGWRT (2)
      WRITE (HILINE,1221) TSKNAM, 'Y', DOMAIN(1,2), DOMAIN(2,2)
      CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      MSGTXT = HILINE(8:)
      CALL MSGWRT (2)
      WRITE (HILINE,1225) TSKNAM, NIN, RSUM
      CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 200
      MSGTXT = HILINE(8:)
      CALL MSGWRT (2)
      IF (NOUT.GT.0) THEN
         WRITE (HILINE,1226) TSKNAM, NOUT
         CALL HIADD (IH2LUN, HILINE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 200
         MSGTXT = HILINE(8:)
         CALL MSGWRT (2)
         END IF
C
 200  CALL HICLOS (IH2LUN, .TRUE., SCRTCH, IERR)
C                                       close image
 300  CALL MAPCLS ('INIT', DISKO, CNOO, OLUN, OIND, MAPHDR, .TRUE.,
     *   SCRTCH, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('WRIHGM: ERROR',I5,' DOING ',A)
 1100 FORMAT (A6,'STOKES = ''',A4,''' / Stokes type')
 1110 FORMAT (A6,'BIF =',I4,', EIF =',I4,'/ IF range')
 1120 FORMAT (A6,'BCHAN=',I5,', ECHAN=',I5,', CHINC=',I3,
     *   '   / Chan range')
 1130 FORMAT (A6,'SUBARRAY =',I4)
 1131 FORMAT (A6,'NSUBA =',I4,'   / multiple subarrays included')
 1140 FORMAT (A6,'/ Edited using FG table version',I3)
 1150 FORMAT (A6,'SMOOTH = ',I1,',',F6.1,',',I4,
     *   ' / Spectral smoothing parms')
 1160 FORMAT (A6,'GAINUSE =',I3,' / CL table')
 1170 FORMAT (A6,'DOPOL = ',I2,'  / polarization correction made')
 1180 FORMAT (A6,'BL table ',I3,' / applied to data')
 1190 FORMAT (A6,'/ BP correction done, DOBAND = ',I2)
 1200 FORMAT (A6,'/ BP correction used BP table ',I2)
 1210 FORMAT (A6,'/ Weights calibrated')
 1211 FORMAT (A6,'/ Weights not calibrated')
 1220 FORMAT (A6,'/ ',A,'-axis type  ',A,'   units  ',A)
 1221 FORMAT (A6,'/ ',A,'-axis range',2(1PE13.5))
 1225 FORMAT (A6,'/ Pixels in image',I10,' pix sum',F13.2)
 1226 FORMAT (A6,'/ Values outside image',I10)
      END

      SUBROUTINE ACTFRQ (IANT, SOURNU, TIME, FRQSEL, IF, ICHAN, DISKIN,
     *   CNOIN, NUMCL, FIRST, LAST, FREQA, IRET)
C-----------------------------------------------------------------------
C! Determines true frequency of any spectral channel at any time.
C# Calibration, Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2000, 2012, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Routine to determine the frequency of any channel in any IF at any
C   time.
C   Inputs:
C      IANT     I       Antenna number of first of baseline pair
C      SOURNU   I       Source number
C      TIME     R       Time of record (days)
C      FRQSEL   I       Freq ID of current record.
C      IF       I       IF number requested
C      ICHAN    I       Channel number requested
C      DISKIN   I       Data disk number
C      CNOIN    I     Data catalogue number
C      NUMCL    I       CL table to use for time varying freq. info
C      LAST     L       If TRUE close down open CL table
C   Input from common
C      CATBLK   I(256)   Catalog header
C  Input/Output
C    FIRST        L       Must be TRUE for first call, routine will then
C                         set to false - useful for internal bookeeping
C  Output:
C    FREQA        D       Actual freq value
C    IRET         I       Error code: 0 => OK
C                                     anything else is bad
C
C  The actual frequency is determined by:
C      Reference freq in catalogue header
C    + offset for the IF
C    + offset for the source
C    + time variable offset for the source/antenna
C    + offset for the channel from the reference
C
C N.B. ACTFRQ assumes that the CL table has been sorted to time
C      increasing order - if not it will fail, with an appropriate
C      error message.
C
C Uses LUN 49 and 50 - requires their use throughout the operation, if
C there is conflict - these can be changed by changing the data
C statement below.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IANT, SOURNU, IF, ICHAN, DISKIN, CNOIN, FRQSEL,
     *   NUMCL, IRET
      LOGICAL FIRST, LAST
      DOUBLE PRECISION FREQA
C
      CHARACTER COLHED(MAXCLC)*24, KEYW(4)*8, VELTYP*8, VELDEF*8,
     *   SOUNAM*16, CALCOD*4, BNDCOD(MAXIF)*8
      INTEGER   I, J,  NKEY, NREC, NCOL, DATP(128,2), IPOINT,
     *   KOLS(MAXCLC), KEYTYP(4), KLOCS(4), KEYVAL(6), NUMANT, NUMPOL,
     *   NUMBBC, BUFF1(512), CVER, ILUN,  NUMIF, ISBAND(MAXIF), INOGRP,
     *   SUFQID, ISURNO, CLLUN, SUKOLS(MAXSUC), SUNUMV(MAXSUC), NSOURC,
     *   IDSOU, QUAL, ICLRNO, NCLINR, CLBUFF(512), CLKOLS(MAXCLC),
     *   CLNUMV(MAXCLC), CURRNO(MAXANT), IFNO, LIMIT, REC2(XCLRSZ),
     *   TIMKOL, SOUKOL, ANTKOL, DOPKOL, INTKOL, IFOFF, OLDSOU, KANT,
     *   LASTAN, SVER
      LOGICAL   T, MULTI, RDSU, CLCARE
      REAL      GMMOD, FINC(MAXIF), FLUX(4,MAXIF), CURCLI(MAXANT),
     *   CURLOO(MAXANT,MAXIF), KEYVAR(6), REC4(XCLRSZ), TIMLOW,
     *   TIMHI, TIME
      DOUBLE PRECISION REFF, FOFF(MAXIF), FREQO(MAXIF), BANDW, RAEPO,
     *   DECEPO, EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL(MAXIF),
     *   RESTFQ(MAXIF), PMRA, PMDEC, FREQS, CURCLT(MAXANT),
     *   REC8(XCLRSZ/2), KEYVAD
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (KEYVAL, KEYVAR)
      EQUIVALENCE (REC2, REC4, REC8)
      EQUIVALENCE (TIMKOL,CLKOLS(1)),  (INTKOL,CLKOLS(2)),
     *   (SOUKOL,CLKOLS(3)),  (ANTKOL,CLKOLS(4)),
     *   (DOPKOL,CLKOLS(9))
      SAVE FREQS, OLDSOU, CURRNO, CURCLT, CURCLI, CURLOO, CLBUFF,
     *   LASTAN
      DATA COLHED /'TIME', 'TIME INTERVAL', 'SOURCE ID',
     *   'ANTENNA NO.', 'SUBARRAY', 'FREQ ID', 'I.FAR.ROT',
     *   'GEODELAY', 'DOPPOFF', 'ATMOS', 'DATMOS', 'MBDELAY1',
     *   'CLOCK 1', 'DCLOCK 1', 'DISP 1', 'DDISP 1', 'REAL1',
     *   'IMAG1', 'RATE 1', 'DELAY 1', 'WEIGHT 1', 'REFANT 1',
     *   'MBDELAY2', 'CLOCK 2', 'DCLOCK 2', 'DISP 2', 'DDISP 2',
     *   'REAL2', 'IMAG2', 'RATE 2', 'DELAY 2', 'WEIGHT 2',
     *   'REFANT 2' /
      DATA KEYW /'NO_ANT', 'NO_POL', 'NO_IF', 'MGMOD'/
      DATA T /.TRUE./
      DATA ILUN, CLLUN /50, 49/
C-----------------------------------------------------------------------
C                                       Multi source file?
      CALL MULSDB (CATBLK, MULTI)
C                                       Set base ref. freq.
      REFF = CATD(KDCRV+JLOCF)
C                                       Get IF offset info.
      CVER = 1
      CALL CHNDAT ('READ', BUFF1, DISKIN, CNOIN, CVER, CATBLK,
     *   ILUN, NUMIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IRET)
      IF (IRET.NE.0) THEN
        WRITE (MSGTXT,1000) IRET
        GO TO 990
        END IF
C                                       add up cpts so far
      FREQA = REFF + FOFF(IF)
C                                       Initialize other cpts
      FREQS = 0.D0
C                                       Peculiar source offset
      IF (MULTI) THEN
         RDSU = FIRST
         IF (OLDSOU.NE.SOURNU) RDSU = .TRUE.
         IF (RDSU) THEN
C                                       Open SU table
            SVER = 1
            CALL SOUINI ('READ', BUFF1, DISKIN, CNOIN, SVER, CATBLK,
     *         ILUN, INOGRP, VELTYP, VELDEF, SUFQID, ISURNO, SUKOLS,
     *         SUNUMV, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'SU', SVER
               GO TO 990
               END IF
C                                       Get number of sources.
            NSOURC = BUFF1(5)
C                                       Loop through records
            DO 100 I = 1,NSOURC
               IRET = 1
C                                       Read record
               ISURNO = I
               CALL TABSOU ('READ', BUFF1, ISURNO, SUKOLS, SUNUMV,
     *            IDSOU, SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW,
     *            RAEPO, DECEPO, EPOCH, RAAPP, DECAPP, RAOBS, DECOBS,
     *            LSRVEL, RESTFQ, PMRA, PMDEC, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1020) IRET, 'SU'
                  GO TO 990
                  END IF
C
               IF (SOURNU.EQ.IDSOU) THEN
                  FREQS = FREQO(IF)
                  OLDSOU = IDSOU
                  END IF
 100           CONTINUE
            IF (IRET.LE.0) THEN
               CALL TABIO ('CLOS', 0, I, REC4, BUFF1, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1040) IRET, 'SU'
                  GO TO 990
                  END IF
               END IF
            END IF
         END IF
C                                       add up cpts so far
      FREQA = FREQA + FREQS
C                                       Check the CL sort order
      IF (MULTI) THEN
         IF (FIRST) THEN
C                                       Open Calibration table
            NKEY = 0
            NREC = 0
            NCOL = 0
            ICLRNO = 1
            CALL TABINI ('READ', 'CL', DISKIN, CNOIN, NUMCL, CATBLK,
     *         ILUN, NKEY, NREC, NCOL, DATP, CLBUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'CL', NUMCL
               GO TO 990
               END IF
C                                       Get number of scans
            NCLINR = CLBUFF(5)
C                                       Check if empty
            IF (NCLINR.LE.0) THEN
               WRITE (MSGTXT,1030)
               IRET = 1
               GO TO 990
               END IF
C                                       Get column pointers
            NKEY = MAXCLC
            CALL FNDCOL (NKEY, COLHED, 24, T, CLBUFF, KOLS, IRET)
            IF ((IRET.GE.1) .AND. (IRET.LE.10)) GO TO 999
            IRET = 0
            CALL FILL (NKEY, 0, CLKOLS)
            CALL FILL (NKEY, 0, CLNUMV)
            DO 110 J = 1,NKEY
               IPOINT = KOLS(J)
               IF (IPOINT.NE.0) THEN
                  CLKOLS(J) = DATP(IPOINT,1)
                  CLNUMV(J) = DATP(IPOINT,2) / 10
                  END IF
 110           CONTINUE
C                                       Table keywords
            NKEY = 4
            CALL TABKEY ('READ', KEYW, NKEY, CLBUFF, KLOCS, KEYVAL,
     *         KEYTYP, IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Retrieve keyword values
C                                       No. antennas.
            IPOINT = KLOCS(1)
            IF (IPOINT.GT.0) NUMANT = KEYVAL(IPOINT)
C                                       No. IFs per pair.
            IPOINT = KLOCS(2)
            IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. IF pairs.
            IPOINT = KLOCS(3)
            IF (IPOINT.GT.0) NUMBBC = KEYVAL(IPOINT)
C                                       Gain modulus
            IPOINT = KLOCS(4)
            IF (IPOINT.GT.0) THEN
               IF (KEYTYP(4).EQ.1) THEN
                  CALL RCOPY (2, KEYVAR(IPOINT), KEYVAD)
                  GMMOD = KEYVAD
               ELSE
                  GMMOD = KEYVAR(IPOINT)
                  END IF
               END IF
C                                       check order
            IF (CLBUFF(43).EQ.KOLS(1)) THEN
               CLCARE = .FALSE.
               IF (CLBUFF(44).EQ.KOLS(4)) CLCARE = .TRUE.
C                                       Close table
               CALL TABIO ('CLOS', 0, ICLRNO, REC4, CLBUFF, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1040) IRET, 'CL'
                  GO TO 990
                  END IF
               GO TO 200
               END IF
C                                       Close table
            CALL TABIO ('CLOS', 0, ICLRNO, REC4, CLBUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1040) IRET, 'CL'
               GO TO 990
               END IF
            MSGTXT = 'ACTFRQ: CL table is in wrong sort order'
            IRET = 1
            GO TO 990
C                                       Open for use
 200        NKEY = 0
            NREC = 0
            NCOL = 0
            ICLRNO = 1
            CALL TABINI ('READ', 'CL', DISKIN, CNOIN, NUMCL, CATBLK,
     *         CLLUN, NKEY, NREC, NCOL, DATP, CLBUFF, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1010) IRET, 'CL', NUMCL
               GO TO 990
               END IF
            WRITE (MSGTXT,1050) NUMCL
            CALL MSGWRT (6)
C                                       Get number of scans
            NCLINR = CLBUFF(5)
            END IF
         END IF
C                                       Is there a time variable
C                                       offset for this source/antenna/
C                                       time?
      IF (MULTI) THEN
C                                       Init offset matrix
         IF (FIRST) THEN
            LASTAN = 0
            DO 220 I = 1, MAXANT
               DO 210 J = 1, MAXIF
                  CURLOO(I,J) = 0.0
 210              CONTINUE
 220           CONTINUE
            END IF
C                                       Do we need to look through
C                                       table
         IF (CURRNO(IANT).GT.0) THEN
            IF (TIME.LE.(CURCLT(IANT) + 0.5*CURCLI(IANT))) THEN
               GO TO 400
               END IF
            END IF
C                                       Read until selected time.
         IF (CURRNO(IANT).EQ.0) THEN
            LIMIT = 1
         ELSE
            LIMIT = CURRNO(IANT)
            END IF
         DO 300 I = LIMIT, NCLINR
            ICLRNO = I
            CALL TABIO ('READ', 0, ICLRNO, REC4, CLBUFF, IRET)
            IF (IRET.LT.0) GO TO 300
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1020) IRET, 'CL'
               GO TO 990
               END IF
C                                       See if correct source
            IF (REC2(SOUKOL).NE.SOURNU) GO TO 300
            KANT = REC2(ANTKOL)
C                                       Check time
            TIMLOW = REC8(TIMKOL) - (REC4(INTKOL)/2.0)
            TIMHI  = REC8(TIMKOL) + (REC4(INTKOL)/2.0)
            IF ( (TIME.LE.TIMHI) .AND. (TIME.GE.TIMLOW) ) THEN
C                                       Loop over IF
               DO 250 IFNO = 1, NUMIF
                  IFOFF = IFNO - 1
                  CURLOO(KANT,IFNO) = REC4(DOPKOL+IFOFF)
 250              CONTINUE
               CURCLT(KANT) = REC8(TIMKOL)
               CURCLI(KANT) = REC4(INTKOL)
               CURRNO(KANT) = ICLRNO
               LASTAN = KANT
               END IF
C                                       If time-ant order then
C                                       we need to read through and
C                                       find the antenna of interest
            IF (CLCARE) THEN
               IF (LASTAN.GE.IANT) GO TO 400
               GO TO 300
               END IF
            IF (REC8(TIMKOL) .GT. TIME) GO TO 400
 300        CONTINUE
         END IF
C                                       add up cpts so far
 400  IF (MULTI) FREQA = FREQA + CURLOO(IANT,IF)
C                                       Determine the channel
C                                       offset.
      FREQA = FREQA + (ICHAN - CATR(KRCRP+JLOCF)) * FINC(IF)
      FIRST = .FALSE.
C                                       If last record, tidy up
      IF (LAST .AND. MULTI) THEN
C                                       Close table
         CALL TABIO ('CLOS', 0, ICLRNO, REC4, CLBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ACTFRQ: ERROR',I3,' GETTING FREQ. INFO. WITH CHNDAT')
 1010 FORMAT ('ACTFRQ: ERROR',I3,' OPENING ',A2,' TABLE, VERSION',I5)
 1020 FORMAT ('ACTFRQ: ERROR',I3,' READING ',A2,' TABLE')
 1030 FORMAT ('ACTFRQ: EMPTY CL TABLE')
 1040 FORMAT ('ACTFRQ: ERROR',I3,' CLOSING ',A2,' TABLE')
 1050 FORMAT ('Using CL table ',I3,' to obtain time dependent freq',
     *   ' offsets')
      END

      SUBROUTINE FNDX (XPIX, YVAL, XVAL, IERR)
C-----------------------------------------------------------------------
C! returns X-axis coordinate value given X pixel and Y coordinate value
C# Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FNDX returns the X axis coordinate value of a point given the Y
C   axis coordinate value and the X axis pixel position of the point.
C   Needed for rotations and non-linear axes (L-M).
C   Inputs:
C      XPIX   R     X pixel position
C      YVAL   D     Y coordinate value
C   Output:
C      XVAL   D     X coordinate value
C      IERR   I     0 ok, 1 out of range, 2 bad type, 3 undefined
C   Common:
C      /LOCATI/ pos parms must have been set up by SETLOC
C-----------------------------------------------------------------------
      REAL      XPIX
      INTEGER   IERR
      DOUBLE PRECISION YVAL, XVAL
C
      DOUBLE PRECISION R, D, P, RA0, DEC0, DS, DX, DZ, COSR, SINR
      INTEGER   I
      INCLUDE 'INCS:DLOC.INC'
C-----------------------------------------------------------------------
      IERR = 0
      DX = (XPIX - RPLOC(1,LOCNUM)) * AXINC(1,LOCNUM)
C                                       x not related to y, z
      IF ((AXTYP(LOCNUM).LE.0) .OR. (AXTYP(LOCNUM).GE.3)) THEN
         XVAL = DX + RPVAL(1,LOCNUM)
         IF ((KLOCF(LOCNUM).EQ.0) .AND. (AXFUNC(1,LOCNUM).EQ.1)) XVAL =
     *      RPVAL(1,LOCNUM) + DX / (1.0D0 + AXDENU(LOCNUM) *
     *      (XPIX-RPLOC(1,LOCNUM)))
C                                       related somehow
      ELSE
         I = AXFUNC(KLOCL(LOCNUM)+1,LOCNUM)
         R = ROT(LOCNUM) * COND2R
         COSR = COS (R)
         SINR = SGNROT(LOCNUM) * SIN (R)
C                                       x with y
         IF (AXTYP(LOCNUM).NE.2) THEN
C                                       linear
            IF ((CORTYP(LOCNUM).LE.0) .OR. (I.LE.1)) THEN
               IF (COSR.EQ.0.) DX = 0.0
               IF (COSR.NE.0.) DX = (DX - (YVAL-RPVAL(2,LOCNUM))*SINR) /
     *            COSR
               XVAL = DX + RPVAL(1,LOCNUM)
C                                       non-linear
            ELSE
               D = COND2R * YVAL
               P = COND2R * DX
               RA0 = COND2R * RPVAL(CORTYP(LOCNUM),LOCNUM)
               DEC0 = COND2R * RPVAL(3-CORTYP(LOCNUM),LOCNUM)
               IF (CORTYP(LOCNUM).EQ.1) THEN
                  CALL DIRRA (I, P, D, RA0, DEC0, R, DS, XVAL, IERR)
               ELSE IF (CORTYP(LOCNUM).EQ.2) THEN
                  CALL DIRDEC (I, P, D, RA0, DEC0, R, DS, XVAL, IERR)
                  END IF
               XVAL = XVAL / COND2R
               END IF
C                                       x with z : rotation first
         ELSE
            DZ = (ZDEPTH(ZAXIS(LOCNUM)-2,LOCNUM) - RPLOC(3,LOCNUM)) *
     *         AXINC(3,LOCNUM)
            P = DX*COSR - DZ*SINR
            DZ = DZ*COSR + DX*SINR
            DX = P
C                                       linear
            IF ((CORTYP(LOCNUM).LE.0) .OR. (I.LE.1)) THEN
               XVAL = DX + RPVAL(1,LOCNUM)
C                                       non-linear
            ELSE
               DX = COND2R * DX
               DZ = COND2R * DZ
               RA0 = COND2R * RPVAL(1,LOCNUM)
               DEC0 = COND2R * RPVAL(3,LOCNUM)
               IF (CORTYP(LOCNUM).EQ.3) THEN
                  CALL NEWPOS (I, RA0, DEC0, DX, DZ, XVAL, DS, IERR)
               ELSE IF (CORTYP(LOCNUM).EQ.4) THEN
                  CALL NEWPOS (I, DEC0, RA0, DZ, DX, DS, XVAL, IERR)
                  END IF
               XVAL = XVAL / COND2R
               END IF
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE YZOOMC (MAG, XZOOM, YZOOM, VRTRTC, IERR)
C-----------------------------------------------------------------------
C! set the TV zoom magnification and center
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YZOOM writes (ONLY!!!!) the zoom control registers of the TV
C   Inputs:
C      MAG     I     0-3 for magnification 1,2,4,8 times, resp.
C      XZOOM   I     X center of expansion (1-512, 1 => LHS)
C      YZOOM   I     Y center of expansion (1-512, 1 => bot)
C      VRTRTC  L     Do on vertical retrace only?
C   Output:
C      IERR    I     error code of Z...XF: 0 -> ok, 2 -> input error
C   YZOOMC updates the /TVDEV/ common TVZOOM parameter
C   Version for IIS Model 75
C-----------------------------------------------------------------------
      INTEGER   MAG, XZOOM, YZOOM, IERR
      LOGICAL   VRTRTC
C
      INTEGER   UNIT, HEADER(8), BUFFER(2), BUFSIZ, NB, MAGSFT, MAGPOW,
     *   ZMASK, TMASK, ICHAN
      LOGICAL   COMAND
      INCLUDE 'INCS:DTVC.INC'
      DATA UNIT, COMAND, BUFSIZ / 6, .FALSE., 2/
C-----------------------------------------------------------------------
      IERR = 2
      IF ((MAG.LT.0) .OR. (MAG.GT.MXZOOM)) GO TO 999
      IF ((XZOOM.LT.1) .OR. (XZOOM.GT.MAXXTV(1))) GO TO 999
      IF ((YZOOM.LT.1) .OR. (YZOOM.GT.MAXXTV(2))) GO TO 999
C                                       TMASK = 1201 hex
      TMASK = 4609
C                                       Set data.  Find the postion of
C                                       the upper left corner of the
C                                       zoom window
      MAGPOW = 2 ** MAG
C                                       Old IIS version
C      BUFFER(1) = MAX0 (0, ((XZOOM - 1) - (256 / MAGPOW)))
C      BUFFER(2) = MAX0 (0, ((MAXXTV(2) - YZOOM) - (256 / MAGPOW)))
C      BUFFER(1) = MIN0 (512 - (512 / MAGPOW), BUFFER(1))
C      BUFFER(2) = MIN0 (512 - (512 / MAGPOW), BUFFER(2))
C                                       Corrected we hope
      BUFFER(1) = (XZOOM-1.0) * (MAGPOW-1.0) / REAL(MAGPOW)
      BUFFER(2) = (MAXXTV(2) - YZOOM) * (MAGPOW-1.0) / REAL(MAGPOW)
      CALL YLOWON (TVLIMG(1), ICHAN)
      ICHAN = ICHAN + 1
      BUFFER(1) = BUFFER(1) - TVSCRX(ICHAN)
      BUFFER(2) = BUFFER(2) + TVSCRY(ICHAN)
      IF (BUFFER(1).LT.0) BUFFER(1) = BUFFER(1) + MAXXTV(1)
      IF (BUFFER(2).LT.0) BUFFER(2) = BUFFER(2) + MAXXTV(2)
      IF (BUFFER(1).GT.MAXXTV(1)) BUFFER(1) = BUFFER(1) - MAXXTV(1)
      IF (BUFFER(2).GT.MAXXTV(2)) BUFFER(2) = BUFFER(2) - MAXXTV(2)
C                                       Move two LSBs of zoom factor
C                                       MAG into data words bit 12 and
C                                       bit 13
      MAGSFT = MAG * 4096
      BUFFER(1) = MAGSFT + BUFFER(1)
      BUFFER(2) = MAGSFT + BUFFER(2)
C                                       Grey channels
C                                       Header + IO.  ZMASK = 7F hex
      ZMASK = 127
      CALL YMKHDR ('WRIT', UNIT, COMAND, BUFSIZ, 0, 0, ZMASK, TMASK,
     *   VRTRTC, HEADER)
      NB = 2 * BUFSIZ
      CALL ZM70XF ('WRIT', NB, HEADER, BUFFER, IERR)
C                                       ZMASK = 80 hex
C                                       Graphics planes
      ZMASK = 128
      BUFFER(1) = BUFFER(1) + TVSCRX(ICHAN) - TVSCRX(16) - MAGSFT
      BUFFER(2) = BUFFER(2) - TVSCRX(ICHAN) + TVSCRX(16) - MAGSFT
      IF (BUFFER(1).LT.0) BUFFER(1) = BUFFER(1) + MAXXTV(1)
      IF (BUFFER(2).LT.0) BUFFER(2) = BUFFER(2) + MAXXTV(2)
      IF (BUFFER(1).GT.MAXXTV(1)) BUFFER(1) = BUFFER(1) - MAXXTV(1)
      IF (BUFFER(2).GT.MAXXTV(2)) BUFFER(2) = BUFFER(2) - MAXXTV(2)
C                                       Increment BUFFER(1) and
C                                       BUFFER(2) by 800 hex
      BUFFER(1) = BUFFER(1) + 2048 + MAGSFT
      BUFFER(2) = BUFFER(2) + 2048 + MAGSFT
      CALL YMKHDR ('WRIT', UNIT, COMAND, BUFSIZ, 0, 0, ZMASK, TMASK,
     *   VRTRTC, HEADER)
      NB = 2 * BUFSIZ
      CALL ZM70XF ('WRIT', NB, HEADER, BUFFER, IERR)
C                                       Update common /TVCHAR/
      IF (IERR.EQ.0) THEN
         TVZOOM(1) = MAG
         TVZOOM(2) = XZOOM
         TVZOOM(3) = YZOOM
         END IF
C
 999  RETURN
      END

       SUBROUTINE ZMEMRY (OPCODE, NAME, KWORDS, NBASE, OFFSET, IERR)
C-----------------------------------------------------------------------
C! initialize and manage dynamic memory allocations
C# Z System
C-----------------------------------------------------------------------
C;  Copyright (C) 1996, 2005, 2009, 2012, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Allocate and free dynamic memory sections
C   Inputs:
C      OPCODE   C*4    'INIT' : init all pointers
C                      'GET ' : get one memory segment
C                      'FREE' : free one meory segment
C                      'FRAL' : free all NAME's segments
C                      'QUIT' : free all segments silently
C      NAME     C*6    Subroutine name
C      KWORDS   I      Kilo Number of INTEGER words requested
C      NBASE    I(*)   Base address: OFFSET will be an index relative to
C                      NBASE
C   In/out:
C      OFFSET   I      first index into array NBASE allocated
C   Output:
C      IERR     I      Error code: 0 okay,
C                         1 not found (FREE, FRAL, QUIT)
C                         2 tables full (GET)
C                         3 malloc error (GET)
C                         4 free error (FREE, FRAL, QUIT)
C                         5 opcode error
C   Generic version - calls ZMEMR2
C-----------------------------------------------------------------------
      CHARACTER OPCODE*(*), NAME*(*)
      INTEGER   KWORDS, NBASE(*), IERR
      LONGINT   OFFSET
C
      INTEGER   TABSIZ
      PARAMETER (TABSIZ = 50)
      INTEGER   NWDS(TABSIZ), I, J, N, M
      LONGINT   OFFST(TABSIZ), ADDR(TABSIZ)
      CHARACTER PNAME(TABSIZ)*6
      INCLUDE 'INCS:DMSG.INC'
      SAVE      NWDS, ADDR, OFFST, PNAME
C-----------------------------------------------------------------------
      IERR = 0
C                                       init
      IF (OPCODE(:4).EQ.'INIT') THEN
         DO 10 I = 1,TABSIZ
            NWDS(I) = 0
            ADDR(I) = 0
            OFFST(I) = 0
            PNAME(I) = ' '
 10         CONTINUE
C                                       get memory
      ELSE IF (OPCODE(:3).EQ.'GET') THEN
C                                       find free word
         I = TABSIZ + 1
         DO 20 J = 1,TABSIZ
            IF (NWDS(J).LE.0) I = MIN (I, J)
 20         CONTINUE
         IF (I.GT.TABSIZ) THEN
            IERR = 2
            MSGTXT = 'MEMORY TABLE FULL AT ' // NAME
            DO 25 J = 1,TABSIZ
               CALL MSGWRT (8)
               WRITE (MSGTXT,1020) J, PNAME(J), NWDS(J), OFFST(J)
 25            CONTINUE
            GO TO 990
         ELSE
            N = 4 * KWORDS
            J = 0
C                                       ZMEMR2 takes kilobytes now
            CALL ZMEMR2 (J, N, NBASE, ADDR(I), OFFSET, IERR)
            IF (IERR.NE.0) THEN
               MSGTXT = 'ZMEMRY: MEMORY ALLOCATION FAILS AT ' // NAME
               IERR = 3
               GO TO 990
            ELSE
               NWDS(I) = KWORDS
               OFFST(I) = OFFSET
               PNAME(I) = NAME
               END IF
            END IF
C                                       free one
      ELSE IF (OPCODE(:4).EQ.'FREE') THEN
C                                       find it
         I = TABSIZ + 1
         DO 30 J = 1,TABSIZ
            IF ((PNAME(J).EQ.NAME) .AND. (OFFST(J).EQ.OFFSET))
     *         I = MIN (I, J)
 30         CONTINUE
         IF (I.GT.TABSIZ) THEN
            IERR = 1
            MSGTXT = 'ZMEMRY: ENTRY NOT FOUND AT ' // NAME
            GO TO 990
         ELSE
            N = 4 * NWDS(I)
            J = 1
            CALL ZMEMR2 (J, N, NBASE, ADDR(I), OFFSET, IERR)
            IF (IERR.NE.0) THEN
               MSGTXT = 'MEMORY FREE FAILS AT ' // NAME
               IERR = 4
               GO TO 990
            ELSE
               NWDS(I) = 0
               ADDR(I) = 0
               OFFST(I) = 0
               PNAME(I) = ' '
               END IF
            END IF
C                                       free one
      ELSE IF ((OPCODE(:4).EQ.'FRAL') .OR. (OPCODE(:4).EQ.'QUIT')) THEN
C                                       find it
         M = 0
 40      I = TABSIZ + 1
C                                       FRAL uses subroutine name
            IF (OPCODE(:4).EQ.'FRAL') THEN
               DO 45 J = 1,TABSIZ
                  IF (PNAME(J).EQ.NAME) I = J
 45               CONTINUE
C                                       QUIT kills all starting at high
            ELSE
               DO 46 J = 1,TABSIZ
                  IF (NWDS(J).GT.0) I = J
 46               CONTINUE
               END IF
            IF (I.GT.TABSIZ) THEN
               IF ((M.GT.0) .OR. (OPCODE(:4).EQ.'QUIT')) GO TO 999
               IERR = 1
               MSGTXT = 'ENTRY NOT FOUND AT ' // NAME
               GO TO 990
            ELSE
               N = 4 * NWDS(I)
               J = 1
               CALL ZMEMR2 (J, N, NBASE, ADDR(I), OFFSET, IERR)
               IF (IERR.NE.0) THEN
                  MSGTXT = 'MEMORY FREE FAILS AT ' // NAME
                  IERR = 4
                  GO TO 990
               ELSE
                  M = M + 1
                  NWDS(I) = 0
                  ADDR(I) = 0
                  OFFST(I) = 0
                  PNAME(I) = ' '
                  END IF
               END IF
            GO TO 40
C                                       bad opcode
      ELSE
         IERR = 5
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('ZMEMRY: LIST(',I3,') NAME, WORDS, OFFSET ',A,I8,I14)
      END

      SUBROUTINE SLOCIN (INODIM)
C-----------------------------------------------------------------------
C! initialize location common for slice (on the TEK) model fitting
C# Slice Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2007, 2009, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SLOCIN (slice LOCATI init) will initialize the location common
C   for the peculiar values needed for gaussian fitting of slice files.
C   Output;
C      INODIM   I   Number of dimensions (1 or 2) of fit. Always 1 now.
C   Commons output:
C      /MAPHDR/ filled with header associated with TK device
C      /LOCATI/ position common
C-----------------------------------------------------------------------
      INTEGER   INODIM
C
      CHARACTER TEXT(2)*80
      REAL      BLC(2), TRC(2), XBLC(7), XTRC(7), CH(4), RANGE(2),
     *   YGAP, FQFINC
      INTEGER   IDEPTH(5), IDROP(2), ITYPE, IX, IY, I, IRXTRA, IERR,
     *   INOSL, K, LABEL, NTEXT
      DOUBLE PRECISION FQFREQ
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Read tek image cat header.
      IX = 0
      IY = 0
      CALL TKCATL ('READ', IX, IY, CATBLK, IERR)
      IF ((IERR.GT.0) .AND. (IERR.NE.11)) GO TO 970
C                                       Test image type for slice.
      ITYPE = CATBLK(IIPLT)
      INODIM = 1
      IF (ITYPE.NE.5) GO TO 980
C                                       Reconstruct original values.
      LABEL = CATBLK(IIOTH)
      IDROP(1) = CATBLK(IIOTH+1)
      IDROP(2) = CATBLK(IIOTH+2)
      IRXTRA = IIOTH + 3
      XBLC(1) = CATR(IRXTRA)
      XBLC(2) = CATR(IRXTRA+1)
      XTRC(1) = CATR(IRXTRA+2)
      XTRC(2) = CATR(IRXTRA+3)
      XBLC(3) = CATR(IRXTRA+4)
      XTRC(3) = CATR(IRXTRA+5)
      IRXTRA = IRXTRA + 6
      IRXTRA = IRXTRA/2 + 1
      FQFREQ = CATD(IRXTRA)
      IRXTRA = 2*IRXTRA + 1
      FQFINC = CATR(IRXTRA)
      INOSL = CATBLK(IIWIN+2) - CATBLK(IIWIN) + IDROP(1) + IDROP(2) + 1
      RANGE(1) = CATR(IRRAN)
      RANGE(2) = CATR(IRRAN+1)
      BLC(2) = CATBLK(IIWIN+1)
      TRC(2) = CATBLK(IIWIN+3)
      K = 1
      DO 10 I = 4,7
         XBLC(I) = CATBLK(IIDEP+K)
         XTRC(I) = CATBLK(IIDEP+K)
         K = K + 1
 10      CONTINUE
C                                       Initialize location common.
      CALL SLBINI (IDROP, INOSL, RANGE, BLC, TRC, XBLC, XTRC, FQFREQ,
     *   FQFINC, IDEPTH, LABEL, YGAP, CH, TEXT, NTEXT)
      GO TO 999
C                                       Error conditions.
C                                       Image catalog error.
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (7)
      GO TO 999
C                                       Invalid plot type.
 980  WRITE (MSGTXT,1980) ITYPE
      CALL MSGWRT (6)
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1970 FORMAT ('IMAGE CATALOG ERROR')
 1980 FORMAT ('INVALID PLOT TYPE',I6,' (ONLY SLICE ALLOWED SO FAR)')
      END

      SUBROUTINE YLUT (OP, CHANNL, COLOR, VRTRTC, LUT, IERR)
C-----------------------------------------------------------------------
C! read/write channel-based look-up-table
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YLUT reads/writes full channel look up tables to TV.
C   Inputs:
C      OP      C*4    'READ' from TV, 'WRIT' to TV
C      CHANNL  I      channel select bit mask
C      COLOR   I      color select bit mask (RGB <-> 421)
C      VRTRTC  L      T => do it only during vertical retrace
C   In/Out:
C      LUT     I(*)   look up table (dimension = MAXINT+1, values to
C                     LUTOUT are used)
C   Out:
C      IERR    I      error code of Z...XF : 0 => ok, 2 => input error
C   Version for IIS Models 70 and 75
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   CHANNL, COLOR, LUT(*), IERR
      LOGICAL   VRTRTC
C
      INTEGER   UNIT, HEADER(8), BUFSIZ, NB
      LOGICAL   COMAND
      DATA  UNIT, COMAND, BUFSIZ /2, .FALSE., 256/
C-----------------------------------------------------------------------
      CALL YMKHDR (OP, UNIT, COMAND, BUFSIZ, 0, 0, COLOR, CHANNL,
     *   VRTRTC, HEADER)
      NB = 2 * BUFSIZ
      CALL ZM70XF (OP, NB, HEADER, LUT, IERR)
C
 999  RETURN
      END

      SUBROUTINE APVCHK (APCORE, LABEL, INDEX, ROWNUM, ROW, ROWSIZ,
     *   APTEMP)
C-----------------------------------------------------------------------
C! AP routine: Find and print maximum value element of a vector.
C# AP-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C AP Vector CHecK: Find and print maximum value of a vector and address
C of the maximum.
C   Inputs:
C      LABEL   C*20 Label for maximum output
C      INDEX   I    Index label
C      ROWNUM  I    Row number in cells
C      ROW     I    Location of the Row in the AP
C      ROWSIZ  I    Number of elements in Row
C      APTEMP  I    Work index in AP for max value and location.
C                   AP locations APTEMP and APTEMP+1 will be modified
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      CHARACTER*20 LABEL
      INTEGER   INDEX, ROWNUM, ROW, ROWSIZ, APTEMP
C
      INTEGER   VLOC
      REAL      VMAX, RVLOC
      EQUIVALENCE (VLOC, RVLOC)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       wait for AP
      CALL QWD
C                                       put maximum in the row at APTEMP
      CALL QMAXV (APCORE, ROW, 1, APTEMP, ROWSIZ)
      CALL QWR
C                                       read maximum from AP loc APTEMP
      CALL QGET  (APCORE, VMAX, APTEMP, 1, 2)
      CALL QWD
C                                       read location from AP APTEMP+1
      CALL QGET  (APCORE, RVLOC, APTEMP+1, 1, 1)
      CALL QWD
C                                       calc cell number
      VLOC = ((VLOC - ROW)/2) + 1
      WRITE (MSGTXT,1000,ERR=999) LABEL, INDEX, ROWNUM, VMAX, VLOC
C                                       if none zero, write
      IF (VMAX.NE.0.0) CALL MSGWRT(3)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('APVCHK: ',A,' I=',I5,', ROW=',I5,', MAX=',1PE11.3,
     *        ', AT=',I5)
      END

      SUBROUTINE ZTAPE (OP, LUN, FIND, COUNT, IERR)
C-----------------------------------------------------------------------
C! mount, dismount, position, write EOF, etc. for tapes
C# Z Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Performs standard tape manipulating functions.
C   Inputs:
C       OP      C*4   Operation to be performed. 4 characters ASCII.
C                     'ADVF' = advance file marks
C                     'ADVR' = advance records
C                     'BAKF' = backspace file marks.
C                     'BAKR' = backspace records.
C                     'REWI' = rewind the tape on unit LUN
C                     'WEOF' = write end of file on unit LUN: writes 2
C                              EOFs, positions tape after first one
C                     'BEGW' = "begin write": backs just over the last
C                              EOF, writes 2 EOFs, backs over the 2nd -
C                              should be done before writing.  It is
C                              required on Exabyte 8200s anywhere except
C                              BOM and EOM.
C                     'AEOI' = Advance to end of information (2 EOFs)
C       LUN     I     logical unit number == 30 + DriveNumber
C       FIND    I     FTAB pointer.
C   In/out:         Out not yet used
C       COUNT   I     In: Number of records or file marks to skip.
C                     Out: (AEOI) > 0 EOI after COUNT files
C                                 < 0 EOI after skipping -COUNT files
C   Outputs:
C       IERR  I       Error return: 0 => ok
C                        1 = File not open
C                        2 = Input specification error.
C                        3 = I/O error.
C                        4 = End Of File
C                        5 = Beginning Of Medium
C                        6 = End Of Medium
C   Generic version - uses ZTAP2 and ZTAPR.  No longer does Mount or
C   dismount.  Differs from older versions in that it has COUNT passed
C   through to ZTAP2 as an extra argument.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   LUN, FIND, COUNT, IERR
C
      LOGICAL   MAP
      CHARACTER ERRNAM(4)*8, OPTAB*32, HER*4, LOP*4
      HOLLERITH HOPTAB(8)
      INTEGER   MTLUN1, IER, IOP, NOP, FOFF, IEREOF, IERBOM, IEREOM,
     *   IERIO, I, JC, I1
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA MTLUN1 /128/
      DATA IEREOF, IERBOM, IEREOM, IERIO /4, 5, 6, 3/
      DATA ERRNAM /'IO ERROR', 'END FILE','BEG.TAPE','END TAPE'/
      DATA NOP, OPTAB /8, 'ADVFADVRBAKFBAKRREWIWEOFBEGWAEOI'/
C-----------------------------------------------------------------------
C                                       check input errors
      IF (FTAB(FIND).NE.LUN) THEN
         IERR = 1
         WRITE (MSGTXT,1000) LUN
         GO TO 990
         END IF
      IERR = 2
      IF ((LUN.LE.MTLUN1-NTAPED) .OR. (LUN.GT.MTLUN1)) THEN
         WRITE (MSGTXT,1010) LUN
         GO TO 990
         END IF
      DO 20 IOP = 1,NOP
         I1 = IOP * 4 - 3
         IF (OP.EQ.OPTAB(I1:I1+3)) GO TO 25
 20      CONTINUE
      WRITE (MSGTXT,1020) OP
      GO TO 990
 25   IF ((IOP.LE.4) .AND. (COUNT.LE.0)) THEN
         WRITE (MSGTXT,1025) COUNT, OP
         GO TO 990
         END IF
C                                       input OK !
C                                       Remote tapes:
      IF (TPNAME(MTLUN1-LUN+1).NE.'LOCAL') THEN
         CALL ZTAPR (OP, LUN, FIND, COUNT, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR
            IF (IERR.EQ.3) THEN
               CALL MSGWRT (7)
               MSGTXT = 'This usually means PARITY ERROR'
            ELSE IF (IERR.EQ.4) THEN
               CALL MSGWRT (7)
               MSGTXT = 'This usually means unexpected END-OF-FILE'
            ELSE IF (IERR.EQ.5) THEN
               CALL MSGWRT (7)
               MSGTXT = 'This usually means unexpected ' //
     *            'BEGINNING-OF-TAPE'
            ELSE IF (IERR.EQ.6) THEN
               CALL MSGWRT (7)
               MSGTXT = 'This usually means you''re at END-OF-TAPE'
               END IF
            GO TO 990
            END IF
         GO TO 999
         END IF
C                                       Local tapes
C                                       map or non-map file?
 50   I = (NBTB1*NTAB1 + NBTB2*NTAB2)/2
      MAP = FIND.GT.I
      FOFF = FIND + NMOFF
      IF (MAP) FOFF = FIND + MOFF
      IERR = 0
      JC = 1
      CALL CHR2H (32, OPTAB, 1, HOPTAB)
C                                       branch to OP
      GO TO (100, 200, 300, 400, 500, 600, 700, 800), IOP
C                                       Advance file
 100  LOP = 'ADVF'
         CALL ZTAP2 (HOPTAB(IOP), COUNT, FTAB(FOFF), IER)
C                                       EOF condition normal: no error
         IF ((IER.NE.0) .AND. (IER.NE.IEREOF)) GO TO 900
         GO TO 999
C                                       Advance records; leave just
C                                       beyond EOF if encountered
 200  LOP = 'ADVR'
         CALL ZTAP2 (HOPTAB(IOP), COUNT, FTAB(FOFF), IER)
C                                       No conditions normal
         IF (IER.NE.0) GO TO 900
         GO TO 999
C                                       Back COUNT file marks
C                                       then advance 1 unless BOM
 300  LOP = 'BAKF'
         CALL ZTAP2 (HOPTAB(IOP), COUNT, FTAB(FOFF), IER)
C                                       EOF normal
         IF ((IER.NE.0) .AND. (IER.NE.IEREOF) .AND. (IER.NE.IERBOM))
     *      GO TO 900
         GO TO 999
C                                       Back COUNT records
C                                       leave just beyond EOF if needed
 400  LOP = 'BAKR'
         CALL ZTAP2 (HOPTAB(IOP), COUNT, FTAB(FOFF), IER)
         IF (IER.NE.0) GO TO 900
         GO TO 999
C                                       Rewind
 500  LOP = 'REWI'
         CALL ZTAP2 (HOPTAB(IOP), 1, FTAB(FOFF), IER)
C                                       EOF + BOM normal
         IF ((IER.EQ.0) .OR. (IER.EQ.IERBOM)) GO TO 999
         GO TO 900
C                                       Write EOF
 600  LOP = 'WEOF'
         CALL ZTAP2 (HOPTAB(IOP), 1, FTAB(FOFF), IER)
         IF ((IER.NE.0) .AND. (IER.NE.IEREOF)) GO TO 900
         GO TO 999
C                                       Begin write to tape w BAKF
 700  LOP = 'BEGW'
         CALL ZTAP2 (HOPTAB(IOP), 1, FTAB(FOFF), IER)
         IF ((IER.NE.0) .AND. (IER.NE.IEREOF) .AND. (IER.NE.IERBOM))
     *      GO TO 900
         GO TO 999
C                                       Advance to end-of-info
 800  LOP = 'AEOI'
         COUNT = 1
         CALL ZTAP2 (HOPTAB(IOP), COUNT, FTAB(FOFF), IER)
         IF ((IER.NE.0) .AND. (IER.NE.IEREOF) .AND. (IER.NE.IEREOM))
     *      GO TO 900
         GO TO 999
C                                       handle errors 3 - 6.
 900  IERR = IER
      I = IERR - IERIO + 1
      IER = FTAB(FOFF+2)
      CALL ZHEX (IER, 4, HER)
      WRITE (MSGTXT,1900) LUN, ERRNAM(I), JC, LOP, HER
      CALL MSGWRT (7)
C                                       extra for unknowns
      IF (IERR.EQ.IERIO) THEN
         CALL ZERROR ('ZTAP2', IER, ' ', FTAB(FOFF), MAP)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZTAPE: LUN ',I4,' NOT OPEN')
 1010 FORMAT ('ZTAPE: LUN',I4,' NOT ALLOWED FOR TAPES')
 1020 FORMAT ('ZTAPE: INVALID OPERATION: ',A4)
 1025 FORMAT ('ZTAPE: COUNT ',I6,' OP ',A4,' INVALID')
 1030 FORMAT ('REMOTE ZTAPE RETURNS ERROR',I6)
 1900 FORMAT ('ZTAPE: LUN',I3,1X,A8,' AT',I4,' OP OF ',A4,
     *   ' SYS ERR CODE ',A4)
      END

LOCAL INCLUDE 'DBAPP.INC'
C                                       Local include for DBAPP
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   MAXSOU, MXANT
C                                       MAXSOU = size of source table
      PARAMETER (MAXSOU=2000)
C                                       MXANT = max no antennas
      PARAMETER (MXANT=MAXANT)
      INTEGER   SEQ1, SEQ2, SEQO, DISKI, DISKO, BUFSZ, CATII(256),
     *   CATO(256), MAXA(2), FIXPOL, POLANT(4), CNOI, CNOO,
     *   I1LOCU, I1LOCV, I1LOCW, I1LOCT, I1LOCB, I1LOCS, I1LOCQ,
     *   I1LOCI, I1LOCC, I1LOCA, I1LOC1, I1LOC2,
     *   J1LOCC, J1LOCS, J1LOCF, J1LOCD, J1LOCR, J1LOCI, INCS1, INCF1,
     *   INCIF1, ICOR01, NPARM1, LREC1, NCOR1, TYUVD1,
     *   I2LOCU, I2LOCV, I2LOCW, I2LOCT, I2LOCB, I2LOCS, I2LOCQ,
     *   I2LOCI, I2LOCC, I2LOCA, I2LOC1, I2LOC2,
     *   J2LOCC, J2LOCS, J2LOCF, J2LOCR, J2LOCD, J2LOCI, INCS2, INCF2,
     *   INCIF2, ICOR02, NPARM2, LREC2, NCOR2, TYUVD2,
     *   IORD(14), JORD(2,MAXCIF), NUMSOU, SOUTRA(MAXSOU),
     *   FQ2TRA(MAXFQ), NEWVIS, TBUFF1(512), TBUFF2(512),
     *   IBUFF1(UVBFSL), IBUFF2(UVBFSL), SCRTCH(512)
      INTEGER   NVIS1, NVIS2, NNIF
      LOGICAL   DOUVMI, ISCMPI, ISCMPO, MULTI, FIXANT
      REAL      XS1, XD1, XS2, XSO, XDO, XFQTOL, DAYOFF,
     *   BUFF1(UVBFSL), BUFF2(UVBFSL), TBUFF(UVBFSS), XBUFF(UVBFSS),
     *   CATRI(256), CATRO(256), DEQUI1, DEQUI2, DOARR, DOPOS
      HOLLERITH XNAME1(3), XCLAS1(2), XNAMEO(3), XCLASO(2),
     *   CATHI(256), CATHO(256)
      CHARACTER NAMEI*12, CLASSI*6, NAMEO*12, CLASSO*6
      DOUBLE PRECISION FREQ1, FREQ2, RA1, RA2, DEC1, DEC2, UVMULT,
     *   CATDI(128), CATDO(128), DELTC, DELTF
      EQUIVALENCE (IBUFF1, BUFF1), (IBUFF2, BUFF2)
      COMMON /INPARM/ XNAME1, XCLAS1, XS1, XD1, XS2, XNAMEO, XCLASO,
     *   XSO, XDO, XFQTOL
      COMMON /DBAPPP/ SEQ1, SEQ2, SEQO, DISKI, DISKO, BUFSZ, DAYOFF,
     *   ISCMPI, ISCMPO, MULTI, CNOI, CNOO, NEWVIS, IORD, JORD, MAXA,
     *   FIXPOL, POLANT, NUMSOU, SOUTRA, NNIF, FQ2TRA, DOARR, DOPOS,
     *   FIXANT
      EQUIVALENCE (CATII, CATRI, CATHI, CATDI),
     *   (CATO, CATRO, CATHO, CATDO)
      COMMON /BUFRS/ BUFF1, BUFF2, TBUFF, XBUFF, TBUFF1, TBUFF2, SCRTCH
      COMMON /CHRCOM/ NAMEI, CLASSI, NAMEO, CLASSO
      COMMON /CATHDR/ CATII, CATO, UVMULT, DELTC, DELTF, DOUVMI
C                                       This common MUST match the one
C                                       in DUVH.INC from FREQ to DEQUI
      COMMON /UVHINC/
     *   FREQ1, RA1, DEC1, NVIS1, I1LOCU, I1LOCV, I1LOCW, I1LOCT,
     *   I1LOCB, I1LOCS, I1LOCQ, I1LOCI, I1LOCC, I1LOCA, I1LOC1, I1LOC2,
     *   J1LOCC, J1LOCS, J1LOCF, J1LOCR, J1LOCD, J1LOCI, INCS1, INCF1,
     *   INCIF1, ICOR01, NPARM1, LREC1, NCOR1, TYUVD1, DEQUI1,
     *   FREQ2, RA2, DEC2, NVIS2, I2LOCU, I2LOCV, I2LOCW,I2LOCT, I2LOCB,
     *   I2LOCS, I2LOCQ, I2LOCI, I2LOCC, I2LOCA, I2LOC1, I2LOC2,
     *   J2LOCC, J2LOCS, J2LOCF, J2LOCR, J2LOCD, J2LOCI, INCS2, INCF2,
     *   INCIF2, ICOR02, NPARM2, LREC2, NCOR2, TYUVD2, DEQUI2
C                                                          End DBAPP
LOCAL END
      PROGRAM DBAPP
C-----------------------------------------------------------------------
C! Appends uv data files to the output file
C# UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2014-2015, 2018, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task to concatenate two uv data bases. Output data will be in a
C   format which will hold both data sets but antenna files will be
C   separatly copied.  No attempt will be made to renumber antennas.
C   Sources will be renumbered as necessary.
C   Inputs:
C      Adverb      Pgm. name      Description
C      INNAME      NAMEI          First uv file name
C      INCLASS     CLASSI         First uv file class
C      INSEQ       SEQ1           First uv file sequence no.
C      INDISK      DISKI          First uv file disk number.
C      IN2SEQ      SEQ2           Second uv file sequence no.
C      OUTNAME     NAME3          Output uv file name
C      OUTCLASS    CLASS3         Output uv file class
C      OUTSEQ      SEQ3           Output uv file sequence no.
C      OUTDISK     DISK3          Output uv file disk no.
C      DOPOS       DOPOS          First value (1,1):
C                                 If <= 0 do not check positions.
C                                 If > 0 will shift position of second
C                                 data set to that of first.
C                                 Second value (2,1):
C                                 If <= 0 check frequency for multi-
C                                 channel data sets.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, IERR, II
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'DBAPP.INC'
      DATA PRGM /'DBAPP '/
C-----------------------------------------------------------------------
C                                       Get inputs.
      IRET = 8
      CALL DBAPIN (PRGM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Loop over inputs
      DO 100 II = 2,NCFILE
         DISKI = FVOL(II)
         CNOI  = FCNO(II)
         CALL CATIO ('READ', DISKI, CNOI, CATII, 'REST', SCRTCH, IERR)
         IF (IERR.GT.1) THEN
            WRITE (MSGTXT,1000) IERR, DISKI, CNOI
            CALL MSGWRT (8)
            GO TO 990
            END IF
         WRITE (MSGTXT,1010) II-1, DISKI, CNOI
         CALL MSGWRT (2)
C                                       Check data compatibility and
C                                       determine output format.
         CALL FRMAT (IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Merge source tables.
         IF (MULTI) THEN
            CALL DBSOUR (IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
C                                       Merge AN tables without
C                                       renumbering antennas.
         IF (FIXANT) THEN
            CALL DBANT (IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
C                                       Sequential copy
         CALL DBCOPY (IERR)
         IF (IERR.NE.0) GO TO 990
C                                       history, tables
         CALL HISANT
 100     CONTINUE
      IRET = 0
C                                       Close down
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('COULD NOT READ INPUT CATALOG HEADER: ERROR, DISK, CNO',
     *   I3,I3,I7)
 1010 FORMAT ('Processing file',I3,' disk',I3,' cno',I6)
      END
      SUBROUTINE DBAPIN (PRGM, IRET)
C-----------------------------------------------------------------------
C   DBAPIN gets inputs for DBAPP and marks input files 'READ'
C   Inputs:
C      PRGM   C*6   Task name
C   Output:
C      IRET   I     Return error code, 0 = OK,
C                                      1 = Error, abort.
C                                      2 = only 1 multisource
C-----------------------------------------------------------------------
      CHARACTER PRGM*(*)
      INTEGER   IRET
C
      CHARACTER STAT*4, UTYPE*2, CHDATE*8, PNAME*48, KEYWRD*8
      INTEGER   CNO, IROUND, NPARM, IERR, LUN, DISK, SEQ, N, INSIZE,
     *   OUTSIZ, FIND, CORCOI, CORCOO, ARRAY1(1), ARRAY2(1), ARRAY3(1),
     *   NUMKEY, LOCS, VALUE, KEYTYP, NWORDS, SAVDSK
      LOGICAL   T, F, TABLE, FITASC, ISOMS, ISMS, FIRST
      DOUBLE PRECISION JD1, JDO
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'DBAPP.INC'
      EQUIVALENCE (ARRAY1, FREQ1),  (ARRAY2, FREQ2),  (ARRAY3, FREQ)
      DATA T, F /.TRUE.,.FALSE./
      DATA LUN /27/
      DATA FIRST /.TRUE./
C-----------------------------------------------------------------------
C                                        Initialize
      IRET = 0
      CALL ZDCHIN (T)
      CALL VHDRIN
      NSCR = 0
      NCFILE = 0
      BUFSZ = UVBFSL * 2
      FIXANT = .FALSE.
C                                        Get input.
      NPARM = 16
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAME1, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
         IRET = 8
         RQUICK = F
         GO TO 990
         END IF
C                                        Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
C                                        Crunch input.
      SEQ1 = IROUND (XS1)
      SEQ2 = IROUND (XS2)
      SEQ2 = MAX (SEQ1, SEQ2)
      SEQO = IROUND (XSO)
      DISKI = IROUND (XD1)
      DISKO = IROUND (XDO)
      CALL FILL (10, 0, IBAD)
C                                       Convert characters
      CALL H2CHR (12, 1, XNAME1, NAMEI)
      CALL H2CHR (6, 1, XCLAS1, CLASSI)
      CALL H2CHR (12, 1, XNAMEO, NAMEO)
      CALL H2CHR (6, 1, XCLASO, CLASSO)
      IF (XFQTOL.LE.0.0) XFQTOL = 100.0
      XFQTOL = XFQTOL * 1000.0
C                                        Find output file and get CAT
      CNOO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKO, CNOO, NAMEO, CLASSO, SEQO, UTYPE,
     *   NLUSER, STAT, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET, NAMEO, CLASSO, SEQO, 'UV', DISKO,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKO, CNOO, CATO, 'WRIT', SCRTCH, IRET)
      IF (IRET.GT.1) THEN
         WRITE (MSGTXT,1000) IRET,
     *      'READING CATALOG HEADER FOR INPUT FILE'
         GO TO 990
         END IF
C                                        Update /CFILE/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CNOO
      FRW(NCFILE) = 1
C                                       See if multisource
      CALL MULSDB (CATO, ISOMS)
      IF (ISOMS) THEN
         CALL ISTAB ('SU', DISKO, CNOO, 1, LUN, SCRTCH, TABLE, ISOMS,
     *      FITASC, IERR)
         ISOMS = ISOMS .AND. (IERR.EQ.0)
         END IF
C                                       reference date
      CALL H2CHR (8, 1, CATHO(KHDOB), CHDATE)
      CALL JULDAY (CHDATE, JDO)
C                                       All data in the same subarray
      DOARR = 1.0
C                                       Do not shift positions
      DOPOS = 0.0
      MULTI = .FALSE.
C                                       vis or corr coeff?
      NUMKEY = 1
      KEYWRD = 'CORRCOEF'
      CALL CATKEY ('REED', DISKO, CNOO, KEYWRD, NUMKEY, LOCS, VALUE,
     *   KEYTYP, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         CORCOO = 0
      ELSE
         CORCOO = VALUE
         END IF
C                                       pointers
      CALL COPY (256, CATO, CATBLK)
      CALL UVPGET (IERR)
      NNIF = 1
      IF (JLOCIF.GE.0) NNIF = CATBLK(KINAX+JLOCIF)
C                                        Fill values in /CATHDR/
      NWORDS = 28 + 3 * NWDPDP
      CALL COPY (NWORDS, ARRAY3, ARRAY2)
C                                       only do one subarray
      CALL FNDEXT ('AN', CATBLK, NUMKEY)
      IF (NUMKEY.GT.1) THEN
         MSGTXT = 'ONLY WORKS FOR A SINGLE SUBARRAY DATA SET'
         IRET = 10
         GO TO 990
         END IF
C                                       fill DANS for output file
      NUMKEY = 1
      CALL GETANT (DISKO, CNOO, NUMKEY, CATBLK, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'GETTING OUTPUT FILE ANTENNA INFO'
         GO TO 990
         END IF
C                                       Get input files
      NEWVIS = 0
      SAVDSK = DISKI
      DO 100 SEQ = SEQ1,SEQ2
         CNO = 1
         UTYPE = 'UV'
         DISK = SAVDSK
         CALL CATDIR ('SRCH', DISK, CNO, NAMEI, CLASSI, SEQ, UTYPE,
     *      NLUSER, STAT, SCRTCH, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1020) IRET, NAMEI, CLASSI, SEQ, 'UV', DISK,
     *         NLUSER
            GO TO 990
            END IF
         CALL CATIO ('READ', DISK, CNO, CATII, 'READ', SCRTCH, IRET)
         IF (IRET.GT.1) THEN
            WRITE (MSGTXT,1000) IRET,
     *         'READING CATALOG HEADER FOR INPUT FILE'
            GO TO 980
            END IF
C                                        Update /CFILE/
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISK
         FCNO(NCFILE) = CNO
         FRW(NCFILE) = 0
         NEWVIS = NEWVIS + CATII(KIGCN)
         CNOI = CNO
         DISKI = DISK
C                                       See if multisource
         CALL MULSDB (CATII, ISMS)
         IF (ISMS) THEN
            CALL ISTAB ('SU', DISKI, CNOI, 1, LUN, SCRTCH, TABLE, ISMS,
     *         FITASC, IERR)
            ISMS = ISMS .AND. (IERR.EQ.0)
            END IF
C                                       Both multi-source
         IF ((ISOMS) .AND. (ISMS)) THEN
            MULTI = .TRUE.
C                                       Cannot combine
         ELSE IF ((ISOMS) .OR. (ISMS)) THEN
            IRET = 2
            MSGTXT = 'CANNOT COMBINE SINGLE AND MULTISOURCE FILES'
            GO TO 980
            END IF
C                                       cannot change reference day
         CALL H2CHR (8, 1, CATHI(KHDOB), CHDATE)
         CALL JULDAY (CHDATE, JD1)
         IF (JD1.LT.JDO) THEN
            MSGTXT = 'REFERENCE DATE OF OUTPUT MUST PRECEDE ALL INPUTS'
            IRET = 2
            GO TO 980
            END IF
C                                       get header keyword CORRCOEF
         NUMKEY = 1
         CALL CATKEY ('REED', DISKI, CNOI, KEYWRD, NUMKEY, LOCS, VALUE,
     *      KEYTYP, SCRTCH, IERR)
         IF (IERR.NE.0) THEN
            CORCOI = 0
         ELSE
            CORCOI = VALUE
            END IF
         IF (CORCOI.NE.CORCOO) THEN
            IF ((CORCOI.NE.0) .AND. (CORCOO.NE.0)) THEN
               MSGTXT = 'CANNOT COMBINE CORRELATION COEFFICIENTS WITH'
     *            // ' VISIBILITIES'
               GO TO 990
            ELSE IF ((CORCOI.EQ.1) .OR. (CORCOO.EQ.1)) THEN
               MSGTXT = 'WARNING: COMBINING CORR. COEFFICIENTS WITH'
     *            // 'DATA OF UNKNOWN TYPE'
               CALL MSGWRT (7)
            ELSE
               MSGTXT = 'WARNING: COMBINING VISIBILITY DATA WITH DATA'
     *            // 'OF UNKNOWN TYPE'
               CALL MSGWRT (7)
               END IF
            END IF
C                                       dimensionality
         IF (CATII(KIDIM).NE.CATO(KIDIM)) THEN
            MSGTXT = 'NUMBER OF REGULAR AXES DOES NOT MATCH'
            GO TO 980
            END IF
         IF (CATII(KIPCN).NE.CATO(KIPCN)) THEN
            MSGTXT = 'NUMBER OF RANDOM PARAMETERS DOES NOT MATCH'
            GO TO 980
            END IF
C                                       pointers
         CALL COPY (256, CATII, CATBLK)
         CALL UVPGET (IERR)
C                                        Fill values in /CATHDR/
         NWORDS = 28 + 3 * NWDPDP
         CALL COPY (NWORDS, ARRAY3, ARRAY1)
C                                       array size
         IF ((CATII(KINAX+J1LOCS).NE.CATO(KINAX+J2LOCS)) .OR.
     *      (CATII(KINAX+J1LOCF).NE.CATO(KINAX+J2LOCF)) .OR.
     *      (CATII(KINAX+J1LOCI).NE.CATO(KINAX+J2LOCI))) THEN
            MSGTXT = 'NUMBERS OF POINTS ON AXES DO NOT MATCH'
            GO TO 980
            END IF
C                                       check axis information
         CALL CHKAX (IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'ERROR COMPARING INPUT AND OUTPUT AXIS INFO'
            GO TO 980
            END IF
C                                       check antenna information
         CALL CHKANT (IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'ERROR COMPARING INPUT AND OUTPUT ANTENNA TABLES'
            GO TO 980
            END IF
C                                       check frequency information
         CALL CHKFQ (FIRST, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'ERROR COMPARING INPUT AND OUTPUT FREQ TABLES'
            GO TO 980
            END IF
         FIRST = .FALSE.
C                                       Check compatibility
         IF ((.NOT.MULTI) .AND. (TYPUVD.LE.0)) THEN
C                                       Check Epoch
            IF (CATRI(KREPO).NE.CATRO(KREPO)) THEN
               WRITE (MSGTXT,1100) SEQ, CATRI(KREPO), CATRO(KREPO)
               CALL MSGWRT (7)
               END IF
C                                        Check RA
            IF (ABS(RA1-RA2).GT.3.0E-10) THEN
               WRITE (MSGTXT,1101) SEQ, 'RA'
               CALL MSGWRT (7)
               END IF
C                                        Check Dec.
            IF (ABS(DEC1-DEC2).GT.3.0E-10) THEN
               WRITE (MSGTXT,1101) SEQ, 'DEC'
               CALL MSGWRT (7)
               END IF
            END IF
 100     CONTINUE
C                                       expand the output file
      CALL COPY (256, CATO, CATBLK)
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZPHFIL ('UV', DISKO, CNOO, 1, PNAME, IERR)
      N = CATO(KIGCN)
      CALL UVSIZE (LREC, N, INSIZE)
      N = N + NEWVIS
      CALL UVSIZE (LREC, N, OUTSIZ)
      N = OUTSIZ - INSIZE
      CALL ZOPEN (LUN, FIND, DISKO, PNAME, .TRUE., .TRUE., .TRUE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING OUTPUT FILE TO EXPAND IT'
         GO TO 990
         END IF
      CALL ZEXPND (LUN, DISKO, PNAME, N, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'EXPANDING OUTPUT FILE'
         GO TO 990
         END IF
      CALL ZCLOSE (LUN, FIND, IERR)
      IRET = 0
      GO TO 999
C                                       error inside loop
 980  CALL MSGWRT (8)
      IF (IRET.LE.0) IRET = 8
      WRITE (MSGTXT,1980) SEQ
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR:',I5,1X,A)
 1020 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,1X,A2,
     *   ' DISK=',I2,' USER=',I4)
 1100 FORMAT ('SEQ',I6,' EPOCHS DO NOT MATCH',2F8.1)
 1101 FORMAT ('SEQ',I6,1X,A,' DOES NOT MATCH')
 1980 FORMAT ('ERROR AROSE WITH INPUT FILE SEQUENCE NUMBER',I6)
      END
      SUBROUTINE CHKAX (IRET)
C-----------------------------------------------------------------------
C   Compares axis information to make sure all is well
C   Output:
C      IRET   I    0 => match okay, 1 => they don't
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   I, J, M, N
      CHARACTER CHTEMP*8, OUTHDR(14)*8
      INCLUDE 'DBAPP.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      IRET = 0
      N = CATO(KIDIM)
      IF (CATII(KIDIM).NE.N) THEN
         WRITE (MSGTXT,1000) N, CATII(KIDIM)
         CALL MSGWRT (7)
         IRET = IRET + 1
         END IF
      M = KHCTP
      DO 10 I = 1,N
         CALL H2CHR (8, 1, CATHO(M), OUTHDR(I))
         M = M + 2
 10      CONTINUE
      M = KHCTP
      DO 20 J = 1,CATII(KIDIM)
         CALL H2CHR (8, 1, CATHI(M), CHTEMP)
         M = M + 2
         DO 15 I = 1,N
            IF (CHTEMP.EQ.OUTHDR(I)) GO TO 20
 15         CONTINUE
         WRITE (MSGTXT,1015) CHTEMP
         CALL MSGWRT (7)
         IRET = IRET + 1
 20      CONTINUE
C                                       random parameters
      N = CATO(KIPCN)
      IF (CATII(KIPCN).NE.N) THEN
         WRITE (MSGTXT,1020) N, CATII(KIPCN)
         CALL MSGWRT (7)
         IRET = IRET + 1
         END IF
      M = KHPTP
      DO 30 I = 1,N
         CALL H2CHR (8, 1, CATHO(M), OUTHDR(I))
         M = M + 2
 30      CONTINUE
      M = KHPTP
      DO 40 J = 1,CATII(KIPCN)
         CALL H2CHR (8, 1, CATHI(M), CHTEMP)
         M = M + 2
         DO 35 I = 1,N
            IF (CHTEMP.EQ.OUTHDR(I)) GO TO 40
 35         CONTINUE
         WRITE (MSGTXT,1035) CHTEMP
         CALL MSGWRT (7)
         IRET = IRET + 1
 40      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('NUMBER OF AXES DISAGREE',2I4)
 1015 FORMAT ('AXIS ''',A,''' NOT FOUND IN OUTPUT')
 1020 FORMAT ('NUMBER OF RANDOM PARAMETERS DISAGREE',2I4)
 1035 FORMAT ('RANDOM PARAMETER ''',A,''' NOT FOUND IN OUTPUT')
      END
      SUBROUTINE CHKANT (IRET)
C-----------------------------------------------------------------------
C   CHKANT makes sure that the antenna file for DISKI, CNOI matches that
C   for the output file (already in DANS.INC)
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'DBAPP.INC'
      INTEGER   LUN, NR, IR, IVER
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      DATA LUN /40/
C-----------------------------------------------------------------------
      IVER = 1
      CALL ANTINI ('READ', TBUFF1, DISKI, CNOI, IVER, CATII, LUN,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      NR = TBUFF1(5)
      IF ((ABS(CNTRX-ARRAYC(1)).GT.1.) .OR. (ABS(CNTRY-ARRAYC(2)).GT.1.)
     *   .OR. (ABS(CNTRZ-ARRAYC(3)).GT.1.) .OR. (TIMLAB.NE.TIMSYS) .OR.
     *   (DATUTC.NE.ANTIAT)) THEN
         IRET = 7
         MSGTXT = 'ANTENNA TABLE HEADERS DO NOT MATCH'
         GO TO 990
         END IF
      IF (UT1UTC.NE.ANTUTC) THEN
         MSGTXT = 'UT1UTC PARAMETER IN ANTENNA FILES DIFFERS'
         CALL MSGWRT (7)
         END IF
C                                      Read AN records
      DO 200 IR = 1,NR
         IANRNO = IR
         CALL TABAN ('READ', TBUFF1, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT FILE ANTENNA TABLE'
            GO TO 900
            END IF
C                                       Skip records with
C                                       zero station numbers
         IF ((NOSTA.LE.0) .OR. (NOSTA.GT.MAXANT)) THEN
            WRITE (MSGTXT,1010) NOSTA, IR, IVER
            CALL MSGWRT (6)
            GO TO 200
            END IF
C
         IF ((STNNAM(NOSTA).NE.' ') .AND. (STNNAM(NOSTA).NE.'OUT') .AND.
     *      (ANNAME.NE.'OUT')) THEN
            IF ((STNNAM(NOSTA).NE.ANNAME) .OR. (TELNO(NOSTA).NE.NOSTA)
     *         .OR. (ABS(STNX(NOSTA)-STAXYZ(1)).GT.2.)
     *         .OR. (ABS(STNY(NOSTA)-STAXYZ(2)).GT.2.)
     *         .OR. (ABS(STNZ(NOSTA)-STAXYZ(3)).GT.2.)) THEN
               WRITE (MSGTXT,1020) NOSTA
               IRET = 8
               GO TO 900
               END IF
         ELSE IF (ANNAME.NE.'OUT') THEN
            FIXANT = .TRUE.
            END IF
 200     CONTINUE
C                                      Close AN extension file
 900  IF (IRET.GT.0) CALL MSGWRT (8)
      CALL TABIO ('CLOS', 1, IANRNO, TBUFF1, TBUFF1, IR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CHKANT ERROR;',I4,' ON ',A)
 1010 FORMAT ('BAD STATION NUMBER',I6,' FOR ENTRY=',I4,' SUBA=',I3)
 1020 FORMAT ('CHKANT: STATION',I3,' NAME OR POSITION DOES NOT AGREE')
      END
      SUBROUTINE CHKFQ (FIRST, IRET)
C-----------------------------------------------------------------------
C   Compares output and input FQ tables
C   Input:
C      FIRST   L   T => read output table
C   Outputs:
C      IRET    I   Error or does not match
C-----------------------------------------------------------------------
      LOGICAL   FIRST
      INTEGER   IRET
C
      INCLUDE 'DBAPP.INC'
      INTEGER   MAXFQN
      PARAMETER (MAXFQN = 20)
      INTEGER   LUN, KOLS(MAXFQC), NUMV(MAXFQC), NUMIFQ, NR, I, RNOFQ,
     *   FQID, IIF
      DOUBLE PRECISION FREQFQ(MAXIF)
      REAL      TBWFQ(MAXIF), CHBWFQ(MAXIF)
      INTEGER   SIDFQ(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8

      DOUBLE PRECISION FQFRQS(MAXIF,MAXFQN)
      REAL             FQINCS(MAXIF,MAXFQN)
      INTEGER          FQSIDS(MAXIF,MAXFQN)
      COMMON /FQTABL/ FQFRQS, FQINCS, FQSIDS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA LUN /41/
C-----------------------------------------------------------------------
C                                       input freq at ref pix of output
      FREQFQ(1) = CATDI(KDCRV+J1LOCF) + CATRI(KRCIC+J1LOCF) *
     *   (CATRO(KRCRP+J2LOCF) - CATRI(KRCRP+J1LOCF))
      IF (ABS(FREQFQ(1)-CATDO(KDCRV+J2LOCF)).GT.XFQTOL) THEN
         WRITE (MSGTXT,1010) FREQFQ(1)/1.D9, CATDO(KDCRV+J2LOCF)/1.D9
         CALL MSGWRT (7)
         IRET = 9
         GO TO 999
         END IF
C                                       fill comparison table
      IF (FIRST) THEN
         I = MAXIF * MAXFQN
         CALL RFILL (I, 0.0, FQINCS)
         CALL DFILL (I, 0.0D0, FQFRQS)
         CALL FQINI ('READ', TBUFF1, DISKO, CNOO, 1, CATO, LUN, RNOFQ,
     *      KOLS, NUMV, NUMIFQ, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING FQ TABLE OF OUTPUT'
            GO TO 990
            END IF
         NR = TBUFF1(5)
         DO 50 I = 1,NR
            RNOFQ = I
            CALL TABFQ ('READ', TBUFF1, RNOFQ, KOLS, NUMV, NUMIFQ, FQID,
     *         FREQFQ, CHBWFQ, TBWFQ, SIDFQ, BNDCOD, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READING FQ TABLE OF OUTPUT'
               GO TO 990
               END IF
            IF ((FQID.GE.1) .AND. (FQID.LE.MAXFQN)) THEN
               DO 20 IIF = 1,NUMIFQ
                  FQFRQS(IIF,FQID) = FREQFQ(IIF)
                  FQINCS(IIF,FQID) = CHBWFQ(IIF)
                  FQSIDS(IIF,FQID) = SIDFQ(IIF)
 20               CONTINUE
               END IF
 50         CONTINUE
         CALL TABIO ('CLOS', 0, RNOFQ, TBUFF1, TBUFF1, I)
         END IF
C                                       now test
      CALL FQINI ('READ', TBUFF1, DISKI, CNOI, 1, CATII, LUN, RNOFQ,
     *   KOLS, NUMV, NUMIFQ, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING FQ TABLE OF INPUT'
         GO TO 990
         END IF
      NR = TBUFF1(5)
      DO 90 I = 1,NR
         RNOFQ = I
         CALL TABFQ ('READ', TBUFF1, RNOFQ, KOLS, NUMV, NUMIFQ, FQID,
     *      FREQFQ, CHBWFQ, TBWFQ, SIDFQ, BNDCOD, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING FQ TABLE OF INPUT'
            GO TO 990
            END IF
         IF ((FQID.GE.1) .AND. (FQID.LE.MAXFQN)) THEN
            DO 70 IIF = 1,NUMIFQ
               IF (ABS(FQFRQS(IIF,FQID)-FREQFQ(IIF)).GT.XFQTOL)
     *            GO TO 100
               IF (ABS(FQINCS(IIF,FQID)-CHBWFQ(IIF)).GT.XFQTOL/100.)
     *            GO TO 100
               IF (FQSIDS(IIF,FQID).NE.SIDFQ(IIF)) GO TO 100
 70            CONTINUE
            END IF
 90      CONTINUE
      CALL TABIO ('CLOS', 0, RNOFQ, TBUFF1, TBUFF1, I)
      GO TO 999
C                                       failure
 100  CALL TABIO ('CLOS', 0, RNOFQ, TBUFF1, TBUFF1, I)
      WRITE (MSGTXT,1100) IIF, FQID
      IRET = 8
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CHKFQ ERROR',I4,' ON ',A)
 1010 FORMAT ('HEADER FREQS',2F10.6,' MISMATCH')
 1100 FORMAT ('CHKFQ: MISMATCH AT IF, FQID',2I4)
      END
      SUBROUTINE FRMAT (IRET)
C-----------------------------------------------------------------------
C   FRMAT determines the compatibility of files, determines the output
C   format and the translation tables for the three formats and creates
C   the output file.
C   Output:
C      IRET    I     Return error code, 0 => OK, else abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER SRTYPE(2)*8, CHDATE*8
      INTEGER   ARRAY1(1), ARRAY2(1), ARRAY3(1), IERR, NWORDS, LIM, I,
     *   NRAN, INDEX, LIM2, J, JNDX, JJ
      LOGICAL   EQUAL
      DOUBLE PRECISION JDI, JDO, TIMADD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'DBAPP.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (ARRAY1, FREQ1),  (ARRAY2, FREQ2),  (ARRAY3, FREQ)
C-----------------------------------------------------------------------
      IRET = 1
      ISCMPI = CATII(KINAX).EQ.1
      ISCMPO = CATO(KINAX).EQ.1
C                                       Header #1, leave in CATBLK
      CALL COPY (256, CATII, CATBLK)
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 999
      NWORDS = 28 + 3 * NWDPDP
      CALL COPY (NWORDS, ARRAY3, ARRAY1)
C                                       Convert ref. freq.
      DOUVMI = ABS (CATRO(KRCRP+J2LOCF)-CATRI(KRCRP+JLOCF)).GT.0.01
      DOUVMI = DOUVMI .AND. (TYPUVD.LE.0)
      UVMULT = CATDI(KDCRV+JLOCF)
      DELTC = 0.0D0
      DELTF = 0.0D0
      IF (DOUVMI) THEN
         DELTC = (CATRO(KRCRP+J2LOCF) - CATRI(KRCRP+JLOCF))
         DELTF = DELTC * CATRI(KRCIC+JLOCF)
         CATDI(KDCRV+JLOCF) = CATDI(KDCRV+JLOCF) + DELTF
         CATRI(KRCRP+JLOCF) = CATRO(KRCRP+J2LOCF)
         END IF
      CATD(KDCRV+JLOCF) = CATDI(KDCRV+JLOCF)
      CATR(KRCRP+JLOCF) = CATRI(KRCRP+JLOCF)
      FREQ = CATDI(KDCRV+JLOCF)
      UVMULT = FREQ / UVMULT
      WRITE (MSGTXT,1000) CNOI, UVMULT
      IF (DOUVMI) CALL MSGWRT (6)
C                                        Check random parameters.
C                                        Fill random parm. pointers
      LIM = MAX (NPARM1, NPARM2)
      DO 40 I = 1,LIM
         IORD(I) = I - 1
 40      CONTINUE
      NRAN = NPARM1
C                                        Munge random parameters #2.
      DO 50 I = 1,NPARM2
         INDEX = KHPTP + (I-1)*2
         LIM2 = MIN (KIPTPN, NRAN)
         DO 45 J = 1,LIM2
            JNDX = KHPTP + (J-1)*2
            JJ = J
            CALL CHCOMP (8, 1, CATH(JNDX), 1, CATHO(INDEX), EQUAL)
            IF (EQUAL) IORD(I) = JJ - 1
 45         CONTINUE
 50      CONTINUE
C                                        Update output CATBLK pointers
      CALL COPY (256, CATO, CATBLK)
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 999
C                                        Check sort order, if both the
C                                        same leave as is.
      CALL H2CHR (8, 1, CATHO(KHDOB), CHDATE)
      CALL JULDAY (CHDATE, JDO)
      CALL H2CHR (8, 1, CATHI(KHDOB), CHDATE)
      CALL JULDAY (CHDATE, JDI)
      TIMADD = JDI - JDO
      CALL H2CHR (2, 1, CATHO(KITYP), SRTYPE(1))
      CALL H2CHR (2, 1, CATHI(KITYP), SRTYPE(2))
      CALL H2CHR (2, 1, CATH(KITYP), ISORT(1:2))
      IF ((SRTYPE(1).NE.SRTYPE(2)) .OR. (SRTYPE(1)(:1).NE.'T')) THEN
         ISORT = '**'
         END IF
      IF (ISORT(:1).EQ.'T') CALL CHKTIM (TIMADD, ISORT, IERR)
      CALL CHR2H (4, ISORT, 1, CATH(KITYP))
      CALL CHR2H (4, ISORT, 1, CATHO(KITYP))
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Scaling u,v,w of data set',I2,' by',1PE15.7)
      END
      SUBROUTINE CHKTIM (TIMADD, SRTORD, IRET)
C-----------------------------------------------------------------------
C   Checks that the last time of the output is < first time of input
C   In/Out:
C      SRTORD   C*4   Sort order: in 'T?'. out '**' if time not okay
C   Output
C      IRET     I     Disk error: sort to ** if NX missing
C-----------------------------------------------------------------------
      DOUBLE PRECISION TIMADD
      CHARACTER SRTORD*(*)
      INTEGER   IRET
C
      INCLUDE 'DBAPP.INC'
      INTEGER   VER, LUN, INXRNO, NXKOLS(MAXNXC), NXNUMV(MAXNXC), IDS,
     *   SUBA, IVS, IVE, FQID, IERR
      REAL      TIME, DTIME, TOUT, TIN

      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       output NX table
      VER = 1
      LUN = 55
      MSGSUP = 32000
      CALL NDXINI ('READ', TBUFF1, DISKO, CNOO, VER, CATO, LUN, INXRNO,
     *   NXKOLS, NXNUMV, IRET)
      MSGSUP = 0
      IF (IRET.EQ.2) THEN
         IRET = 0
         SRTORD = '**'
      ELSE IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OUTPUT NX TABLE'
      ELSE
         INXRNO = TBUFF1(5)
         CALL TABNDX ('READ', TBUFF1, INXRNO, NXKOLS, NXNUMV, TIME,
     *      DTIME, IDS, SUBA, IVS, IVE, FQID, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ OUTPUT NX TABLE'
         ELSE
            TOUT = TIME + DTIME/2.
            END IF
         CALL TABNDX ('CLOS', TBUFF1, INXRNO, NXKOLS, NXNUMV, TIME,
     *      DTIME, IDS, SUBA, IVS, IVE, FQID, IERR)
         END IF
      IF (IRET.NE.0) GO TO 990
C                                       input NX table
      MSGSUP = 32000
      CALL NDXINI ('READ', TBUFF1, DISKi, CNOi, VER, CATii, LUN, INXRNO,
     *   NXKOLS, NXNUMV, IRET)
      MSGSUP = 0
      IF (IRET.EQ.2) THEN
         IRET = 0
         SRTORD = '**'
      ELSE IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN inPUT NX TABLE'
      ELSE
         INXRNO = 1
         CALL TABNDX ('READ', TBUFF1, INXRNO, NXKOLS, NXNUMV, TIME,
     *      DTIME, IDS, SUBA, IVS, IVE, FQID, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ INPUT NX TABLE'
         ELSE
            TIN = TIMADD + TIME - DTIME/2.
            END IF
         CALL TABNDX ('CLOS', TBUFF1, INXRNO, NXKOLS, NXNUMV, TIME,
     *      DTIME, IDS, SUBA, IVS, IVE, FQID, IERR)
         END IF
      IF (IRET.NE.0) GO TO 990
      IF (TIN.LT.TOUT) THEN
         SRTORD = '**'
         MSGTXT = 'T* DATA NOT IN TIME ORDER: SORT BECOMES ''**'''
         CALL MSGWRT (6)
         END IF
      GO TO 999
C
 990  SRTORD = '**'
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CHKTIM ERROR',I4,' ON ',A)
      END
      SUBROUTINE DBSOUR (IRET)
C-----------------------------------------------------------------------
C   DBSOUR merges the source table of the input file into the output.
C   Makes a translation table for the source ids of the input file.
C   Output:
C      IRET   I   Return error code  0 => ok, else error.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4, CHARS*27
      INTEGER   VER, LUN1, LUN2, SUKOL1(MAXSUC), SUKOL2(MAXSUC),
     *   SUNUM1(MAXSUC), SUNUM2(MAXSUC), NUMFST, NUMIF, IDSOU, QUAL,
     *   IDTEMP, NEXT, IERR, I, LUMIF, NRECIN, INREC, OUTREC, LOOP,
     *   SUFQD1, SUFQD2, II, JJ, NRECO
      LOGICAL   T, F, NEW, MATCH
      DOUBLE PRECISION BANDW, RAEPO, DECEPO, EPOCH, RAAPP, DECAPP, PMRA,
     *   PMDEC, RAOBS, DECOBS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'DBAPP.INC'
      INTEGER   SUQUAL(MAXSOU)
      CHARACTER SUNAM(MAXSOU)*16, SUCODE(MAXSOU)*4
      REAL      FLUX(4,MAXIF)
      DOUBLE PRECISION LSRVEL(MAXIF), FREQO(MAXIF), RESTFQ(MAXIF)
      DOUBLE PRECISION DEPOCH(MAXSOU), DRAEPO(MAXSOU), DCEPO(MAXSOU),
     *   SEPS
      DATA LUN1, LUN2 /27, 28/
      DATA T, F /.TRUE.,.FALSE./
      DATA CHARS /' ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
C-----------------------------------------------------------------------
      NUMSOU = 0
      II = 1
      JJ = 1
C                                       EPS for source coord comparison
C                                       is 10mas
      SEPS = 0.01D0 / 3600.0D0
C                                       Open first input table
      MSGSUP = 32000
      IRET = 0
      VER = 1
      CALL SOUINI ('WRIT', TBUFF1, DISKO, CNOO, VER, CATO, LUN1, NUMIF,
     *   VELTYP, VELDEF, SUFQD1, INREC, SUKOL1, SUNUM1, IERR)
      MSGSUP = 0
C                                       If not there - quit
      IF (IERR.EQ.2) GO TO 999
      IF (IERR.GT.0) THEN
         IRET = 2
         WRITE (MSGTXT,1000) IERR, 'OPENING OUTPUT SU TABLE'
         GO TO 990
         END IF
      LUMIF = NUMIF
      IF (NUMIF.NE.NNIF) THEN
         WRITE (MSGTXT,1010) 'OUTPUT', NUMIF, NNIF
         CALL MSGWRT (8)
         END IF
C                                       Get number of input records.
      NRECIN = TBUFF1(5)
      NRECO = NRECIN
C                                       Copy
      NUMFST = 0
      IRET = 6
      CALL DFILL (MAXSOU, 0.0D0, DRAEPO)
      DO 20 LOOP = 1,NRECIN
         INREC = LOOP
         CALL TABSOU ('READ', TBUFF1, INREC, SUKOL1, SUNUM1, IDSOU,
     *      SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA,
     *      PMDEC, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READING OUTPUT SU TABLE'
            GO TO 990
            END IF
C                                       Check number of sources
         IF (IDSOU.GT.MAXSOU) THEN
            IRET = 7
            WRITE (MSGTXT,1015) IDSOU, MAXSOU
            GO TO 990
            END IF
C                                       Save name, qual, coordinates
         SUQUAL(IDSOU) = QUAL
         SUNAM(IDSOU) = SOUNAM
         SUCODE(IDSOU) = CALCOD
         DEPOCH(IDSOU) = EPOCH
         DRAEPO(IDSOU) = RAEPO
         DCEPO(IDSOU) = DECEPO
         NUMFST = MAX (NUMFST, IDSOU)
 20      CONTINUE
      OUTREC = NRECIN + 1
C                                       Open second input
      IRET = 0
      VER = 1
      CALL SOUINI ('READ', TBUFF2, DISKI, CNOI, VER, CATII, LUN2, NUMIF,
     *   VELTYP, VELDEF, SUFQD2, INREC, SUKOL2, SUNUM2, IERR)
C                                       If not there - quit
      IF (IERR.EQ.2) GO TO 800
      IF (IERR.GT.0) THEN
         IRET = 2
         WRITE (MSGTXT,1000) IERR, 'OPEING INPUT SOURCE TABLE'
         GO TO 990
         END IF
      IF (NUMIF.NE.NNIF) THEN
         WRITE (MSGTXT,1010) 'INPUT', NUMIF, NNIF
         CALL MSGWRT (8)
         END IF
      IF (NUMIF.NE.LUMIF) THEN
         WRITE (MSGTXT,1020) LUMIF, NUMIF
         CALL MSGWRT (8)
         END IF
C                                       Get number of input records.
      NRECIN = TBUFF2(5)
      IRET = 6
      NUMSOU = NRECIN
      NEXT = NUMFST + 1
      MATCH = F
      CALL FILL (NUMSOU, NEXT, SOUTRA)
C                                       Copy, accumulating translation
C                                       table.
      DO 100 LOOP = 1,NRECIN
         INREC = LOOP
         CALL TABSOU ('READ', TBUFF2, INREC, SUKOL2, SUNUM2, IDSOU,
     *      SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA,
     *      PMDEC, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READING INPUT FILE SU TABLE'
            GO TO 990
            END IF
C                                       Make translation table
         NEW = F
         DO 30 I = 1,NUMFST
            IDTEMP = I
            IF ((QUAL.EQ.SUQUAL(I)) .AND. (SOUNAM.EQ.SUNAM(I)) .AND.
     *         (CALCOD.EQ.SUCODE(I))) THEN
               IF ((ABS(DEPOCH(I)-EPOCH).LT.0.1) .AND.
     *            (ABS(DRAEPO(I)-RAEPO).LE.SEPS) .AND.
     *            (ABS(DCEPO(I)-DECEPO).LE.SEPS)) THEN
                  MATCH = T
                  GO TO 40
               ELSE
                  II = II + 1
                  IF (II.EQ.28) THEN
                     II = 1
                     JJ = JJ + 1
                     END IF
                  WRITE (MSGTXT,1025) SUNAM(I), SUQUAL(I)
                  CALL MSGWRT (6)
                  SOUNAM(15:15) = CHARS(JJ:JJ)
                  SOUNAM(16:16) = CHARS(II:II)
                  WRITE (MSGTXT,1026) SOUNAM
                  CALL MSGWRT (6)
                  END IF
               END IF
 30         CONTINUE
C                                       No match - new source.
         NEW = T
         IDTEMP = NEXT
         NEXT = NEXT + 1
C                                       Record source translation num
 40      SOUTRA(IDSOU) = IDTEMP
         IDSOU = IDTEMP
         NUMSOU = MAX (NUMSOU, IDSOU)
C                                       Check number of sources
         IF (IDSOU.GT.MAXSOU) THEN
            IRET = 7
            WRITE (MSGTXT,1015) IDSOU, MAXSOU
            GO TO 990
            END IF
C                                       Write
         IF (NEW) THEN
            CALL TABSOU ('WRIT', TBUFF1, OUTREC, SUKOL1, SUNUM1, IDSOU,
     *         SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *         EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ,
     *         PMRA, PMDEC, IERR)
            IF (IERR.GT.0) THEN
               WRITE (MSGTXT,1000) IERR, 'WRITING OUTPUT SU TABLE'
               GO TO 990
               END IF
            END IF
 100     CONTINUE
C                                       Close first input.
      CALL TABIO ('CLOS', 0, INREC, TBUFF2, TBUFF2, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING INPUT SU TABLE'
         GO TO 990
         END IF
C                                       Close output table
 800  CALL TABIO ('CLOS', 0, OUTREC, TBUFF1, TBUFF1, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'CLOSING OUTPUT SU TABLE'
         GO TO 990
         END IF
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BDSOUR ERROR',I5,' ON ',A)
 1010 FORMAT ('DBSOUR: ',A,' SU table NUMIF=',I3,' NOT',I3,' OF DATA')
 1015 FORMAT ('DBSOUR: TOO MANY SOURCES:',I5, '>', I5,
     *   ' INCREASE TABLES')
 1020 FORMAT ('DBSOUR: TWO SU TABLES NUMIF =',2I3,' DIFFER!!!')
 1025 FORMAT ('DBSOUR: Coordinates disagree for ''',A,''' Qual',I5)
 1026 FORMAT ('DBSOUR: Source renamed ''',A,'''')
      END
      SUBROUTINE DBANT (IRET)
C-----------------------------------------------------------------------
C   DBANT will update the output AN table for any antenna that occurs
C   in the input file and not in the AN file.
C   Output:
C      IRET   I   Return error code 0 => ok, else error.
C-----------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
C                                       Modified include DANT
C                                       (2 buffers).
C                                       NOTE: uses PARAMETER in PUVD.INC
C                                       Declarations for ANTINI
      INTEGER   ANKOLS(MAXANC,2), ANNUMV(MAXANC,2), NUMORB, NOPCAL,
     *   ANTNIF, ANFQID, IANRNO
      CHARACTER ANAME*8, RDATE*8, TIMSYS*8, XYZHAN*8, TFRAME*8
      REAL      POLRXY(2), UT1UTC, DATUTC
      DOUBLE PRECISION  ARRAYC(3), GSTIA0, DEGPDY, SAFREQ
C                                       Declarations for TABAN
      INTEGER   NOSTA, MNTSTA
      CHARACTER ANNAME*8, POLTYA*2, POLTYB*2
      REAL      STAXOF, DIAMAN, FWHMAN(MAXIF), POLAA, POLCA(2*MAXIF),
     *   POLAB, POLCB(2*MAXIF)
      DOUBLE PRECISION  STAXYZ(3), ORBPRM(6)
C                                       End modified include.
      INCLUDE 'DBAPP.INC'
      INTEGER   ANTREC(MAXANT), LUNI, LUNO, NREC, MREC, K, L, IEXTAN
      DOUBLE PRECISION LX, LY, LZ
      DATA LUNI, LUNO /27, 28/
C----------------------------------------------------------------------
C                                       Read output, find missing ants
      CALL FILL (MAXANT, 0, ANTREC)
      IEXTAN = 1
      CALL ANTINI ('WRIT', TBUFF1, DISKO, CNOO, IEXTAN, CATO, LUNO,
     *   IANRNO, ANKOLS(1,1), ANNUMV(1,1), ARRAYC, GSTIA0, DEGPDY,
     *   SAFREQ, RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *   TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT AN FILE'
         GO TO 990
         END IF
      NREC = TBUFF1(5)
C                                       Compile the AN index.
      DO 20 K = 1,NREC
         IANRNO = K
         CALL TABAN ('READ', TBUFF1, IANRNO, ANKOLS(1,1), ANNUMV(1,1),
     *      ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN,
     *      FWHMAN, POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING OUTPUT AN FILE'
            GO TO 990
            END IF
         LX = ARRAYC(1) + STAXYZ(1)
         LY = ARRAYC(2) + STAXYZ(2)
         LZ = ARRAYC(3) + STAXYZ(3)
         LX = LX*LX + LY*LY + LZ*LZ
         IF ((NOSTA.GT.0) .AND. (NOSTA.LE.MAXANT)) THEN
            IF ((LX.LE.0.0D0) .OR. (ANNAME.EQ.' ') .OR.
     *         (ANNAME.EQ.'OUT')) THEN
               ANTREC(NOSTA) = -K
            ELSE
               ANTREC(NOSTA) = K
               END IF
            END IF
 20      CONTINUE
C                                       read input file
      CALL ANTINI ('READ', TBUFF2, DISKI, CNOI, IEXTAN, CATII, LUNI,
     *   IANRNO, ANKOLS(1,2), ANNUMV(1,2), ARRAYC, GSTIA0, DEGPDY,
     *   SAFREQ, RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *   TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT AN FILE'
         GO TO 990
         END IF
      MREC = TBUFF2(5)
      DO 50 L = 1,MREC
         IANRNO = L
         CALL TABAN ('READ', TBUFF2, IANRNO, ANKOLS(1,2), ANNUMV(1,2),
     *      ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN,
     *      FWHMAN, POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING INPUT AN FILE'
            GO TO 990
            END IF
         LX = ARRAYC(1) + STAXYZ(1)
         LY = ARRAYC(2) + STAXYZ(2)
         LZ = ARRAYC(3) + STAXYZ(3)
         LX = LX*LX + LY*LY + LZ*LZ
         IF ((NOSTA.GT.0) .AND. (NOSTA.LE.MAXANT)) THEN
            IF ((LX.GT.0.0D0) .AND. (ANNAME.NE.' ') .AND.
     *         (ANNAME.NE.'OUT') .AND. (ANTREC(NOSTA).LE.0)) THEN
               IF (ANTREC(NOSTA).EQ.0) THEN
                  NREC = NREC + 1
                  K = NREC
               ELSE
                  K = -ANTREC(NOSTA)
                  END IF
               IANRNO = K
               CALL TABAN ('WRIT', TBUFF1, IANRNO, ANKOLS(1,1),
     *            ANNUMV(1,1), ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA,
     *            STAXOF, DIAMAN, FWHMAN, POLTYA, POLAA, POLCA, POLTYB,
     *            POLAB, POLCB, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT AN FILE'
                  GO TO 990
                  END IF
               END IF
            END IF
 50      CONTINUE
C                                       close up
      CALL TABIO ('CLOS', 0, IANRNO, TBUFF1, TBUFF1, IRET)
      CALL TABIO ('CLOS', 0, IANRNO, TBUFF2, TBUFF2, IRET)
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DBANT ERROR',I4,' ON ',A)
      END
      SUBROUTINE DBCOPY (IRET)
C-----------------------------------------------------------------------
C   DBCOPY copies and reformats the two old data bases into a new
C   database.
C   Output: IRET   I    Return error code, 0 => OK, 1 => error, abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'DBAPP.INC'
      INTEGER   LUNI, LUNO, FINDI, FINDO, IPTRI, IPTRO, IOP, INIO,
     *   NIOUT, BINDI, BINDO, WTOFF, OCNT, I, ILENBU, LLREC, NPARM, IR,
     *   IRN, VO, BO, SUID, NCMPLX, IROUND, NNCOR, WWTOFF, NCH, NST,
     *   NIF, IIF, ICH, IST, NNCORO, XLREC, RNXRET, OREC, INCSI, INCFI,
     *   INCIFI, INCSO, INCFO, INCIFO, INDXI, INDXO, IMXS, MSGSAV, NSUB
      LOGICAL   T, F
      REAL      TIMADD
      DOUBLE PRECISION JDO, JDI
      CHARACTER IFILE*48, OFILE*48, CHDATE*8
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DRNX.INC'
      LOGICAL SOUCHN(MAXSOU)
      SAVE SOUCHN
      DATA T, F /.TRUE.,.FALSE./
      DATA LUNI, LUNO /16, 17/
      DATA BO /1/
C-----------------------------------------------------------------------
      MSGSAV = MSGSUP
C                                       Open first input file
      CALL ZPHFIL ('UV', DISKI, CNOI, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, FINDI, DISKI, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT UV DATA'
         GO TO 990
         END IF
C                                       Open output file.
      CALL ZPHFIL ('UV', DISKO, CNOO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, FINDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT UV DATA'
         GO TO 990
         END IF
C                                       Reset output CATBLK pointers
      CALL COPY (256, CATO, CATBLK)
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
      NCMPLX = CATBLK(KINAX)
      NNCORO = (LREC - NRPARM) / NCMPLX
      XLREC = NRPARM + 3 * NNCORO
C                                       Find weight for compressed data.
      IF (ISCMPO) CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN),
     *   CATH(KHPTP), WTOFF, IRET)
      IF (ISCMPI) CALL AXEFND (8, 'WEIGHT  ', CATII(KIPCN),
     *   CATHI(KHPTP), WWTOFF, IRET)
C                                       Determine read/write sizes.
C                                       Init I/O
      ILENBU = 0
      VO = 0
      CALL UVINIT ('READ', LUNI, FINDI, NVIS1, VO, LREC1, ILENBU,
     *   BUFSZ, BUFF1, BO, BINDI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INITING INPUT UV DATA'
         GO TO 990
         END IF
C                                       output
      ILENBU = 0
      VO = NVIS
      CALL UVINIT ('WRIT', LUNO, FINDO, NVIS1, VO, LREC, ILENBU, BUFSZ,
     *   BUFF2, BO, BINDO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INITING OUTPUT UV DATA'
         GO TO 990
         END IF
      IPTRO = BINDO
      NIOUT = ILENBU
      OREC = NVIS
      CALL H2CHR (8, 1, CATHO(KHDOB), CHDATE)
      CALL JULDAY (CHDATE, JDO)
      CALL H2CHR (8, 1, CATHI(KHDOB), CHDATE)
      CALL JULDAY (CHDATE, JDI)
      TIMADD = JDI - JDO
      DAYOFF = TIMADD
C                                       get input NX table info
      CALL RNXGET (DISKI, CNOI, CATII)
      IF (DAYOFF.GT.0) THEN
         CALL FNDEXT ('AN', CATBLK, NSUB)
         IR = 0
         DO 15 I = 1,NSUB
            IR = IR + RNXNOS(I)
 15         CONTINUE
         DO 20 I = 1,IR
            RNXTSC(I) = RNXTSC(I) + DAYOFF
 20         CONTINUE
         END IF
C                                       make an index table
      MSGSUP = 32000
      CALL RNXINI (DISKO, CNOO, CATBLK, RNXRET)
      MSGSUP = MSGSAV
      RNXVIS = OREC
C                                       # channels, Stokes, IFs, in
C                                       second (to be shifted) stream.
      IF (JLOCF.EQ.-1) THEN
         NCH = 1
      ELSE
         NCH = CATBLK(KINAX+JLOCF)
         END IF
      IF (JLOCS.EQ.-1) THEN
         NST = 1
      ELSE
         NST = CATBLK(KINAX+JLOCS)
         END IF
      IF (JLOCIF.EQ.-1) THEN
         NIF = 1
      ELSE
         NIF = CATBLK(KINAX+JLOCIF)
         END IF
      IF (ISCMPO) THEN
         I = 3
      ELSE
         I = 1
         END IF
      INCSO = I * INCS2
      INCFO = I * INCF2
      INCIFO = I * INCIF2
      IF (ISCMPI) THEN
         I = 3
      ELSE
         I = 1
         END IF
      INCSI = I * INCS1
      INCFI = I * INCF1
      INCIFI = I * INCIF1
      OCNT = 0
      LLREC = LREC1
      NPARM = NPARM1
      NCMPLX = CATII(KINAX)
      NNCOR = (LLREC - NPARM) / NCMPLX
C
      IMXS = MAXSOU
      DO 30 I = 1,IMXS
         SOUCHN(I) = .FALSE.
 30      CONTINUE
C                                       Copy file # 1
C                                       Begin loop
 50   CALL UVDISK ('READ', LUNI, FINDI, BUFF1, INIO, BINDI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ'
         GO TO 990
         END IF
      IF (INIO.GT.0) THEN
         IPTRI = BINDI
C                                       Loop thru records.
         DO 100 IR = 1,INIO
C                                       Copy record.
            IF (ISCMPI) THEN
               CALL RCOPY (NPARM, BUFF1(IPTRI), TBUFF)
               CALL ZUVXPN  (NNCOR, BUFF1(IPTRI+NPARM),
     *            BUFF1(IPTRI+WWTOFF), TBUFF(1+NPARM))
            ELSE
               CALL RCOPY (LLREC, BUFF1(IPTRI), TBUFF)
               END IF
C                                       Translate Source number
            IF (NUMSOU.GT.0) THEN
               SUID = IROUND (TBUFF(1+I1LOCS))
C                                       If id is actually different
               IF ((SUID.GT.0) .AND. (SUID.LE.MAXSOU)) THEN
C                                       Change the Source ID
                  IF (SUID.NE.SOUTRA(SUID)) THEN
                     TBUFF(1+I1LOCS) = SOUTRA(SUID)
                     IF (.NOT.SOUCHN(SUID)) THEN
                        WRITE (MSGTXT,1050) SUID, SOUTRA(SUID)
                        CALL MSGWRT (3)
                        SOUCHN(SUID) = .TRUE.
                        END IF
                     END IF
                  END IF
               END IF
C                                       Scale to ref. pixel 1
            IF (DOUVMI) THEN
               TBUFF(1+I1LOCU) = UVMULT * TBUFF(1+I1LOCU)
               TBUFF(1+I1LOCV) = UVMULT * TBUFF(1+I1LOCV)
               TBUFF(1+I1LOCW) = UVMULT * TBUFF(1+I1LOCW)
               END IF
C                                       Zero output record.
            CALL RFILL (XLREC, 0.0, XBUFF)
C                                       Copy random parameters
            DO 70 IRN = 1,NPARM
               IOP = IORD(IRN)
               XBUFF(1+IOP) = TBUFF(IRN)
 70            CONTINUE
C                                        Adjust time
            XBUFF(1+ILOCT) = XBUFF(1+ILOCT) + TIMADD
C                                       Copy data.
            DO 85 IIF = 1,NIF
               DO 80 ICH = 1,NCH
                  DO 75 IST = 1,NST
                     INDXI = (IST-1) * INCSI + (ICH-1) * INCFI +
     *                  (IIF - 1) * INCIFI
                     INDXO = (IST-1) * INCSO + (ICH-1) * INCFO +
     *                  (IIF - 1) * INCIFO
                     INDXI = INDXI + NPARM
                     INDXO = INDXO + NRPARM
                     XBUFF(INDXO+1) = TBUFF(INDXI+1)
                     XBUFF(INDXO+2) = TBUFF(INDXI+2)
                     XBUFF(INDXO+3) = TBUFF(INDXI+3)
 75                  CONTINUE
 80               CONTINUE
 85            CONTINUE
C                                       update NX table
            CALL RNXUPD (XBUFF, RNXRET)
            OREC = OREC + 1
            IF (MOD(OREC,10000).EQ.0) THEN
               WRITE (MSGTXT,1080) OREC
               CALL MSGWRT (2)
               END IF
C                                       move to output buffer
            IF (ISCMPO) THEN
               CALL RCOPY (NRPARM, XBUFF, BUFF2(IPTRO))
               CALL ZUVPAK (NNCORO, XBUFF(1+NRPARM), BUFF2(IPTRO+WTOFF),
     *            BUFF2(IPTRO+NRPARM))
            ELSE
               CALL RCOPY (LREC, XBUFF, BUFF2(IPTRO))
               END IF
C                                       Update pointers.
            OCNT = OCNT + 1
            IPTRI = IPTRI + LLREC
            IPTRO = IPTRO + LREC
C                                       Write if necessary
            IF (OCNT.GE.NIOUT) THEN
               NIOUT = OCNT
               CALL UVDISK ('WRIT', LUNO, FINDO, BUFF2, NIOUT, BINDO,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT UV DATA'
                  GO TO 990
                  END IF
               OCNT = 0
               IPTRO = BINDO
               END IF
 100        CONTINUE
C                                       Loop back
         GO TO 50
         END IF
C                                       Close input
      CALL ZCLOSE (LUNI, FINDI, IRET)
C                                       Flush and close files.
      NIOUT = -OCNT
      CALL UVDISK ('FLSH', LUNO, FINDO, BUFF2, NIOUT, BINDO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FLUSHING OUTPUT UV DATA'
         GO TO 990
         END IF
C                                       Close
      CALL ZCLOSE (LUNO, FINDO, IRET)
      IRET = 0
      NVIS2 = NVIS2 + NVIS1
      CATO(KIGCN) = CATO(KIGCN) + NVIS1
      CATBLK(KIGCN) = CATO(KIGCN)
      IRET = 0
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I4,' ON ',A)
 1050 FORMAT ('DBCOPY: changing source ID',I5,' to',I5)
 1080 FORMAT ('DBCOPY: at output record',I10)
      END
      SUBROUTINE HISANT
C-----------------------------------------------------------------------
C   HISANT updates history files when FILENO is 2 and appends some of
C   tables
C-----------------------------------------------------------------------
      INTEGER   NUMAPP
      PARAMETER (NUMAPP=13)
C
      INCLUDE 'DBAPP.INC'
      CHARACTER HILINE*72, APTYPE(NUMAPP)*2
      INTEGER   LUN1, LUN2, IVER, OVER, IERR, I, NVER1, NVER2, NVER
      REAL      TIMADD
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1, LUN2 /27,28/
      DATA APTYPE /'CL','FG','TY','WX','IM','MC','PC','AT','CT','GC',
     *   'OB','SY','SN'/
C-----------------------------------------------------------------------
C                                       Write History.
C
      CALL HIINIT (2)
C                                       open output HI file
      CALL HIOPEN (LUN1, DISKO, CNOO, BUFF2, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING OUTPUT HISTORY FILE'
         CALL MSGWRT (7)
C                                       New history
      ELSE
         CALL HENCO1 (TSKNAM, NAMEI, CLASSI, SEQ1, DISKI, LUN1, BUFF2,
     *      IERR)
         IF (IERR.NE.0) GO TO 90
         WRITE (HILINE,1020) TSKNAM, SEQ2
         CALL HIADD (LUN1, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 90
         WRITE (HILINE,1025) TSKNAM, XFQTOL/1.E3
         CALL HIADD (LUN1, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 90
C                                       Close history
 90      CALL HICLOS (LUN1, .TRUE., BUFF2, IERR)
         END IF
C                                       Append table(s)
      DO 200 I = 1,NUMAPP
         CALL FNDEXT (APTYPE(I), CATII, NVER1)
         CALL FNDEXT (APTYPE(I), CATO, NVER2)
         NVER = MAX (NVER1, NVER2)
         IF (NVER.GT.1) THEN
            MSGTXT = 'WARNING: APPENDING MULTIPLE VERSIONS OF ' //
     *         APTYPE(I) // ' TABLES'
            CALL MSGWRT (7)
            MSGTXT = '         THIS MAY NOT BE DESIRABLE'
            CALL MSGWRT (7)
            END IF
         DO 150 IVER = 1,NVER
            OVER = IVER
            TIMADD = DAYOFF
C                                       Update times
            CALL DBCAPP (APTYPE(I), IVER, OVER, LUN1, LUN2, DISKI,
     *         DISKO, CNOI, CNOO, CATBLK, NUMSOU, SOUTRA, DAYOFF,
     *         .FALSE., IBUFF1, IBUFF2, IERR)
 150        CONTINUE
 200     CONTINUE
C                                       Update CATBLK.
      CALL CATIO ('UPDT', DISKO, CNOO, CATBLK, 'REST', SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('HISANT: ERROR',I3,' ON ',A)
 1020 FORMAT (A6,'IN2SEQ =',I6,'  / append SEQ = INSEQ1:INSEQ2')
 1025 FORMAT (A6,'FQTOL =',F9.3,'  / kHz frequency tolerance')
      END
      SUBROUTINE DBCAPP (TYPE, INVER, OUTVER, LUN1, LUN2, VOL1, VOL2,
     *   CNO1, CNO2, CATBLK, NUMSOU, SOUTRA, TOFF, REWRIT, BUFF1, BUFF2,
     *   IRET)
C-----------------------------------------------------------------------
C   DBCAPP appends one table (input) onto the end of a similar table
C   (output) with the translation of source id numbers.
C   Inputs:
C    TYPE       C*2   Extension table type (e.g. 'CC','AN')
C    INVER      I     Version number to append, 0 => highest.
C    OUTVER     I     Version number on output file, 0=>create
C                     a new one.
C    LUN1       I     LUN for first file (input)
C    LUN2       I     LUN for second file (output)
C    VOL1       I     Disk number for first file.
C    VOL2       I     Disk number for second file.
C    CNO1       I     Catalog slot number for first file
C    CNO2       I     Catalog slot number for second file
C    NUMSOU     I     Number of entries in translation table
C    SOUTRA(*)  I     Source id translation table.
C    TOFF       R     Time offset in days
C    REWRIT     L     If TRUE start writing output at begenning of the
C                     output table
C   In/out:
C    CATBLK(256)I     Catalog header for the first file.
C   Output:
C    BUFF1(512) I     Work buffer
C    BUFF2(512) I     Work buffer
C    IRET       I     Return error code  0 => ok
C                                        1 => files the same, no copy.
C                                        2 => no input files exist
C                                        3 => failed
C                                        4 => no output files created.
C                                        5 => failed to update CATBLK
C-----------------------------------------------------------------------
      CHARACTER TYPE*2
      INTEGER   INVER, OUTVER, LUN1, LUN2, VOL1, VOL2, CNO1, CNO2,
     *   CATBLK(256), NUMSOU, SOUTRA(*), BUFF1(*), BUFF2(*), IRET
      REAL      TOFF
      LOGICAL   REWRIT
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER REST*4, SIDKEY(7)*24
      INTEGER   NOTIME, IT2, IT, CATTMP(256)
      REAL      RECR(XBPRSZ)
      DOUBLE PRECISION RECD(XBPRSZ/2)
      INTEGER   NKEY, NREC, NCOL, DATP(128,2,2), IER, I, SOUKOL, LOOP,
     *   RECORD(XBPRSZ), SUID, NRECIN, NRECOU, INREC, OUTREC, TIMKOL
      LOGICAL   T, F, NEW, GOTSOU, NEWSID, DOTIME, DOTIMR, DOTIMD,
     *   TABLE, EXIST, FITASC, OPEN1, OPEN2
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (RECORD, RECR, RECD, DATP)
      DATA REST /'REST'/
      DATA SIDKEY /'SOURCE_ID ', 'SOURCE  ', 'TIME ', 'TIME RANGE ',
     *   'FREQ ID', 'SUBARRAY', 'ARRAY'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      OPEN1 = F
      OPEN2 = F
C                                       Get CATBLK for first file in
C                                       CATTMP.
      CALL CATIO ('READ', VOL1, CNO1, CATTMP, REST, BUFF1, IER)
      IF ((IER.GT.0) .AND. (IER.LT.5)) THEN
         IRET = 1
         WRITE (MSGTXT,1000) IER
         GO TO 990
         END IF
C                                       Open first (input) file
      MSGSUP = 32000
      IRET = 0
      NREC = 100
      CALL TABINI ('READ', TYPE, VOL1, CNO1, INVER, CATTMP, LUN1,
     *   NKEY, NREC, NCOL, DATP(1,1,1), BUFF1, IER)
      MSGSUP = 0
C                                       If not there - quit
      IF (IER.EQ.2) GO TO 999
      IF (IER.GT.0) THEN
         IRET = 2
         WRITE (MSGTXT,1010) IER
         GO TO 990
         END IF
      OPEN1 = T
C                                       Find source id column.
      CALL FNDCOL (1, SIDKEY(1), 10, T, BUFF1, SOUKOL, IER)
      IF (IER.NE.0) CALL FNDCOL (1, SIDKEY(2), 7, T, BUFF1, SOUKOL, IER)
      GOTSOU = IER.EQ.0
      IF (GOTSOU) SOUKOL = DATP(SOUKOL,1,1)
C                                       Offset time?
      DOTIME = ABS (TOFF).GT.1.0E-5
      DOTIMR = F
      DOTIMD = F
      NOTIME = 0
      IF (DOTIME) THEN
         CALL FNDCOL (1, SIDKEY(3), 8, T, BUFF1, TIMKOL, IER)
         IF (IER.NE.0) CALL FNDCOL (1, SIDKEY(4), 10, T, BUFF1, TIMKOL,
     *      IER)
         IF (IER.NE.0) THEN
            DOTIME = F
         ELSE
            NOTIME = DATP(TIMKOL,2,1) / 10
            IT2 = DATP(TIMKOL,2,1) - NOTIME * 10
            NOTIME = MAX (1, NOTIME)
            DOTIMD = DOTIME .AND. (IT2.EQ.1)
            DOTIMR = DOTIME .AND. (IT2.EQ.2)
            TIMKOL = DATP(TIMKOL,1,1)
            END IF
         END IF
C                                       Does output file exist
      CALL ISTAB (TYPE, VOL2, CNO2, OUTVER, LUN2, BUFF2, TABLE, EXIST,
     *   FITASC, IER)
      NEW = .NOT.EXIST
C                                       create output and fill
      IF (NEW) THEN
         CALL TABIO ('CLOS', 0, INREC, RECORD, BUFF1, IER)
         IF (IER.GT.0) THEN
            MSGTXT = 'DBCAPP: FAILS TO CLOSE INPUT TABLE FOR COPY'
            GO TO 990
            END IF
         OPEN1 = F
         CALL TABCOP (TYPE, INVER, OUTVER, LUN1, LUN2, VOL1, VOL2, CNO1,
     *      CNO2, CATBLK, BUFF1, BUFF2, IER)
         IF (IER.NE.0) THEN
            MSGTXT = 'DBCAPP: FAILS TO MAKE NEW TABLE BY COPY'
            GO TO 990
            END IF
         NREC = 100
         CALL TABINI ('READ', TYPE, VOL1, CNO1, INVER, CATTMP, LUN1,
     *      NKEY, NREC, NCOL, DATP(1,1,1), BUFF1, IER)
         IF (IER.NE.0) THEN
            MSGTXT = 'DBCAPP: FAILS TO REOPEN INPUT TBLE AFTER COPY'
            GO TO 990
            END IF
         OPEN1 = T
         END IF
C                                       Open second (output) file
      NREC = 100
      CALL TABINI ('WRIT', TYPE, VOL2, CNO2, OUTVER, CATBLK, LUN2,
     *   NKEY, NREC, NCOL, DATP(1,1,2), BUFF2, IER)
      IF (IER.GT.0) THEN
         IRET = 3
         WRITE (MSGTXT,1020) IER
         GO TO 990
         END IF
      OPEN2 = T
C                                       Check table data.
      DO 50 I = 1,NCOL
         IF (DATP(I,2,2).NE.DATP(I,2,1)) THEN
            IRET = 5
            MSGTXT = 'DBCAPP: INPUT TABLES DO NOT MATCH'
            GO TO 990
            END IF
 50      CONTINUE
C                                       Tables don't match
C                                       Get number of records in the
C                                       files.
      NRECIN = BUFF1(5)
      NRECOU = BUFF2(5)
      OUTREC = NRECOU + 1
      IF (REWRIT .OR. NEW) OUTREC = 1
      IF (REWRIT) THEN
         WRITE (MSGTXT,1050) TYPE, OUTVER
      ELSE
         WRITE (MSGTXT,1051) TYPE, OUTVER
         END IF
      CALL MSGWRT (2)
C                                       Mark unsorted
      BUFF2(43) = 0
      BUFF2(44) = 0
C                                       Copy
      NEWSID = (NUMSOU.GT.0) .AND. GOTSOU
      IRET = 6
      DO 200 LOOP = 1,NRECIN
         INREC = LOOP
         CALL TABIO ('READ', 0, INREC, RECORD, BUFF1, IER)
         IF (IER.GT.0) THEN
            WRITE (MSGTXT,1070) IER, 'READ', TYPE
            GO TO 990
            END IF
C                                       Source translate
         IF (NEWSID) THEN
            SUID = RECORD(SOUKOL)
            IF (SUID.GT.0) RECORD(SOUKOL) = SOUTRA(SUID)
            END IF
C                                       Modify time?
         IF (DOTIMR) THEN
            DO 150 IT = 1,NOTIME
               RECR(TIMKOL+IT-1) = RECR(TIMKOL+IT-1) + TOFF
 150           CONTINUE
            END IF
         IF (DOTIMD) THEN
            DO 160 IT = 1,NOTIME
               RECD(TIMKOL+IT-1) = RECD(TIMKOL+IT-1) + TOFF
 160           CONTINUE
            END IF
         CALL TABIO ('WRIT', 0, OUTREC, RECORD, BUFF2, IER)
         IF (IER.GT.0) THEN
            WRITE (MSGTXT,1070) IER, 'WRIT', TYPE
            GO TO 990
            END IF
         OUTREC = OUTREC + 1
 200     CONTINUE
C                                       Close tables.
      CALL TABIO ('CLOS', 0, INREC, RECORD, BUFF1, IER)
      IF (IER.GT.0) THEN
         WRITE (MSGTXT,1070) IER, 'CLOS', TYPE
         GO TO 990
         END IF
      OPEN1 = F
      CALL TABIO ('CLOS', 0, OUTREC, RECORD, BUFF2, IER)
      IF (IER.GT.0) THEN
         WRITE (MSGTXT,1070) IER, 'CLOS', TYPE
         GO TO 990
         END IF
      OPEN2 = F
      IRET = 0
      IF (NEW) CALL CATIO ('UPDT', VOL2, CNO2, CATBLK, REST, BUFF1,
     *   IER)
      IF (IER.NE.0) IRET = 5
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
      IF (OPEN1) CALL TABIO ('CLOS', 0, INREC, RECORD, BUFF1, IER)
      IF (OPEN2) CALL TABIO ('CLOS', 0, OUTREC, RECORD, BUFF2, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('DBCAPP: ERROR',I5,' READING CATBLK')
 1010 FORMAT ('DBCAPP: ERROR',I5,' OPENING OUTPUT TABLE')
 1020 FORMAT ('DBCAPP: ERROR',I5,' OPENING INPUT TABLE')
 1050 FORMAT ('Updating  data in output ',A,' table version',I3)
 1051 FORMAT ('Appending data to output ',A,' table version',I3)
 1070 FORMAT ('DBCAPP: ERROR ',I3,2X,A4,'ING ',A2,' TABLE')
      END

      SUBROUTINE ZDELAY (SECS, IERR)
C-----------------------------------------------------------------------
C! delay current process a specified interval
C# Z Service
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Cause an execution delay for a specified time interval.
C   Can't use MSGWRT - called by MSGWRT subroutines.
C   Inputs:
C      SECS   R   Number of seconds to delay
C   Output:
C      IERR   I   Error return code: 0 => no error
C                    1 => error
C   Generic version - calls ZDELA2 protecting input argument.
C-----------------------------------------------------------------------
      REAL      SECS
      INTEGER   IERR
C
      REAL      SECS2
C-----------------------------------------------------------------------
C                                       Call lower level routine with
C                                       the proper arguments.  The
C                                       Fortran routine is needed to
C                                       allow literals in argument
C                                       list (e.g., ZDELAY (5.0, ierr).
      SECS2 = SECS
      CALL ZDELA2 (SECS2, IERR)
C
 999  RETURN
      END

      SUBROUTINE ZMI2 (OPER, FCB, BUFF, NBLOCK, NBYTES, IERR)
C-----------------------------------------------------------------------
C! read/write large blocks of data from/to disk, quick return
C# Z2 IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Read/write "nbytes" of data from/to disk starting at virtual block
C   "nblock" using "map" I/O (i.e., double buffered, asynchronous I/O).
C   Block sizes are determined by the value assigned to NBPS as
C   AIPS-bytes in ZDCHIN.
C   Inputs:
C      OPER     C*4    Operation code "READ" or "WRIT"
C      FCB      I(*)   File control block for open map disk file
C                      and buffer involved
C      NBLOCK   I      Virtual starting block (1-relative)
C      NBYTES   I      Number of AIPS-bytes (1/2 of a local integer)
C                      to be transferred
C   In/out:
C      BUFF     I(*)   I/O buffer
C   Output:
C      IERR     I      Error return code: 0 => no error
C                         2 => bad opcode
C                         3 => I/O error (also see ZWAI2)
C                         4 => end of file (see ZWAI2)
C   VMS version.
C-----------------------------------------------------------------------
      CHARACTER OPER*4
      INTEGER   FCB(*), NBLOCK, NBYTES, BUFF(*), IERR
C
      INTEGER   SYS$QIO, SYS$SETEF, JERR, LREC, FCODE, ERRCNT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE '($IODEF)'
      INCLUDE '($SSDEF)'
      SAVE ERRCNT
      DATA ERRCNT/0/
C-----------------------------------------------------------------------
C                                       Go to 512 8-bit-byte records
      LREC = ((2 * NBPS) / 512) * (NBLOCK - 1) + 1
C                                       Read
      FCB(1+FCBREQ) = 2 * NBYTES
      IF (OPER.EQ.'READ') THEN
         FCODE = IO$_READVBLK
      ELSE IF (OPER.EQ.'WRIT') THEN
         FCODE = IO$_WRITEVBLK
      ELSE
         IERR = 2
         GO TO 999
         END IF
C                                       Do it
      IF (NBYTES.GT.0) THEN
C                                       Event flags range 32 to 63
         IF (FCB(1+FCBSP1).LT.32 .OR. FCB(1+FCBSP1) .GT. 63) THEN
C                                       print only a few error messages
            IF (ERRCNT .LT. 10) THEN
               WRITE(*,1000) OPER, NBLOCK, NBYTES, FCB(1+FCBSP1)
               CALL MSGWRT(5)
               ERRCNT = ERRCNT + 1
               END IF
C                                       Just use first event flag
            FCB(1+FCBSP1) = 32
C                                       end if event flag OK
            END IF
C                                       do I/O (pass values = %VAL)
         JERR = SYS$QIO (%VAL(FCB(1+FCBSP1)), %VAL(FCB(1+FCBFD)),
     *      %VAL(FCODE), FCB(1+FCBSP2), , , BUFF, %VAL(FCB(1+FCBREQ)),
     *      %VAL(LREC), , , )
      ELSE
C                                       else just set event flag
         FCB(1+FCBSP2) = 1
         JERR = SYS$SETEF (%VAL(FCB(1+FCBSP1)))
         IF ((JERR.EQ.SS$_WASCLR) .OR. (JERR.EQ.SS$_WASSET)) JERR = 1
         END IF
C                                       error testing
      IF (JERR.NE.1) THEN
         IERR = 3
         FCB(1+FCBERR) = JERR
         FCB(1+FCBSP2) = JERR
         FCB(1+FCBXFR) = 0
C                                       print only a few error messages
         IF (ERRCNT .LT. 11) THEN
            WRITE(MSGTXT,1000) OPER, NBLOCK, NBYTES, FCB(1+FCBSP1)
            CALL MSGWRT(5)
            ERRCNT = ERRCNT + 1
            END IF
C                                       use first event flag
         FCB(1+FCBSP1) = 32
C                                       try again
         JERR = SYS$QIO (%VAL(FCB(1+FCBSP1)), %VAL(FCB(1+FCBFD)),
     *      %VAL(FCODE), FCB(1+FCBSP2), , , BUFF, %VAL(FCB(1+FCBREQ)),
     *      %VAL(LREC), , , )
         END IF
C                                       if last I/O was OK
      IF (JERR.EQ.1) THEN
         IERR = 0
         FCB(1+FCBERR) = 0
         END IF
C
 999  RETURN
C----------------------------------------------------------------------------
1000  FORMAT(' ZMI2: ',A,' ERROR at NBLK',I6,', NBYT',I6,', EVENT',I6)
      END

LOCAL INCLUDE 'IMFPTS.INC'
C   The maximum number of pixels that JMFIT uses is encapsulated right
C   here.  Just increase MAXPTS to whatever level is desired.  The only
C   proper way to do this however is to rearrange FXDVD so that the
C   double precision vector RESID is no longer required
      INTEGER   MAXPTS
      PARAMETER (MAXPTS=40000)
LOCAL END
LOCAL INCLUDE 'IMFIT.INC'
      INCLUDE 'INCS:PMAD.INC'
C                                       Local include for IMFIT
      CHARACTER TITL1*132, TITL2*132, SCRTCH*132, LPNAME*48, INNA*36,
     *   OUTNA*36
      INTEGER   HOI(256), LUN1, INSL, OUTSL, DEPTH(5), NGAUSS, NITER,
     *   IVAR(24), JVAR(24), XTYPE(4), NX, NY, NPTS, PTMAX, PTMIN,
     *   NPARM, NNGOOD, LUNP, INDP, ILINE, IPAGE, OUTVER, NACROS, INVOL,
     *   FREQAX, INBLK(256)
      LOGICAL   NWIDTH(4), XPR
      INCLUDE 'IMFPTS.INC'
      REAL      WIN(4), ACTRMS, G(6,4), E(6,4), CB(3), DATA(MAXPTS),
     *   DMAX, DMIN, OFFSET, DOCRT, SUMSQ, RESSUM, RESMAX, XCEN, YCEN,
     *   LINE(MAXIMG), XU, HCB(3), UCB(3), HCBP(3)
      DOUBLE PRECISION XRA, XDEC, XFREQ
      COMMON /IMFDA/ XRA, XDEC, XFREQ, HOI, INBLK, DATA, DMAX, DMIN,
     *   OFFSET, NX, NY, NPTS, PTMAX, PTMIN, NPARM, NNGOOD, WIN, ACTRMS,
     *   LUN1, INSL, OUTSL, DEPTH, OUTVER, DOCRT, LUNP, INDP, ILINE,
     *   IPAGE, NGAUSS, NITER, XTYPE, G, E, CB, IVAR, JVAR, NWIDTH,
     *   SUMSQ, RESSUM, RESMAX, XCEN, YCEN, LINE, XU, HCB, UCB, HCBP,
     *   FREQAX, INVOL
      COMMON /CHRCOM/ TITL1, TITL2, SCRTCH, INNA, OUTNA, LPNAME
C                                       inputs
      REAL      XSE, XDI, XBL(7), XTR(7), XOS, XOD, XNG, XTY(4), GM(4),
     *   GP(2,4), GW(3,4), XDM(4), XDP(2,4), XDW(3,4), BWS, RADIUS, XNI,
     *   XCRT, XNDIG, XDOO, XOFS, XDOM, XOVER, XSTVER, PBPARM(7), FACTOR
      HOLLERITH XNA(3), XCL(2), XON(3), XOC(2), XOP(12)
      COMMON /INPARM/ XNA, XCL, XSE, XDI, XBL, XTR, XON, XOC, XOS,
     *   XOD, XNG, XTY, GM, GP, GW, XDM, XDP, XDW, BWS, RADIUS, XNI,
     *   XCRT, XNDIG, XOP, XDOO, XOFS, XDOM, XOVER, XSTVER, PBPARM,
     *   NACROS, XPR, FACTOR
C                                       outputs
      REAL      FGM(4), FGP(2,4), FGW(3,4), FSHIFT(2), FDM(4), FDP(2,4),
     *   FDW(3,4)
      COMMON /OUPARM/ FGM, FGP, FGW, FSHIFT, FDM, FDP, FDW
LOCAL END
LOCAL INCLUDE 'ORFIT.INC'
      CHARACTER REFRA*14, REFDEC*14
      REAL      ORA(4), ORERRA(4), ORERRX(4), ORERRY(4), ORERMA(4),
     *   ORERMI(4), ORERFI(4), ORBMAJ(4), ORBMIN(4), ORBPA(4)
      LOGICAL   OREXIS
      COMMON /VORFIT/ ORA, ORERRA, ORERRX, ORERRY, ORERMA, ORERMI,
     *   ORERFI, ORBMAJ, ORBMIN, ORBPA, OREXIS
      COMMON /CORFIT/ REFRA, REFDEC
LOCAL END
      PROGRAM IMFIT
C-----------------------------------------------------------------------
C! Fit Gaussians to an image
C# Map Modeling EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2001-2005, 2007-2015, 2018, 2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   IMFIT is a two-dimensional gaussian fitting program for image
C   modelling.  Up to four gaussian components can be fit to a part of
C   an image.
C   INPUTS:
C      INNAME(3)                Image name (name)
C      INCLASS(2)               Image name (class)
C      INSEQ                    Image name (seq. #)
C      INDISK                   Disk unit # of image
C      BLC(7)                   Bottom left corner to model
C      TRC(7)                   Top right corner to model
C      OUTNAME(3)               Image outname (name)
C      OUTCLASS(2)              Image outname (class)
C      OUTSEQ                   Image outname (seq. #)
C      OUTDISK                  Disk unit # of output
C      NGAUSS                   Number of gaussians to fit
C      XTYPE(4)                 Type of model component
C      GMAX(4)                  Peak intensity
C      GPOS(2,4)                (X,Y) Position in pixels
C      GWIDTH(3,4)              (BMAJ,BMIN,BPA) in pixels, pixels
C                                   degrees
C      NITER                    Number of loop iterations
C      DOMAX(4)                 Peak intensity variability
C      DOPOS(2,4)               (X,Y) Position variability
C      DOWIDTH(3,4)             (BMAJ,BMIN,BPA) variability
C      DOCRT                    Print output on Lineprinter?
C      DOOUTPUT                 Catalog residual map?
C      OFFSET                   Ignore values below OFFSET*PEAK
C      DOMODEL                  Make a CC file with input image
C
C     COMMON /IMFIO/ HOI, INNA, OUTNA, LUN1, WIN, INSL, OUTSL, DEPTH
C        HOI(256)      I          Output image header
C        WIN(4)        R          Window from MAPWIN
C        LUN1          I          Logical unit # for input
C        INSL          I          Slot number of INNA
C        OUTSL         I          Slot number of OUTNA
C        DEPTH(5)      I          Axis position axes on 3-7
C
C     COMMON /CHRCOM/ TITL1, TITL2, SCRTCH, INNA, OUTNA
C        INN           C          WaWa input map name
C        OUTNA         C          WaWa output map name
C
C     COMMON /IMMOD/ NGAUSS, NITER, XTYPE, G, E, CB, IVAR, JVAR
C        NGAUSS        I          Number of Gaussian components
C        NITER         I          Maximum number of iterations
C        XTYPE(4)      I          Component type
C        G(1,4)        R          Component intensities
C        G(2:3,4)      R          Component positions
C        G(4:6,4)      R          Component diameters
C        E(1,4)        R          Component intensity errors
C        E(2:3,4)      R          Component position errors
C        E(4:6,4)      R          Component diameter errors
C        CB(3)         R          Clean beam diameter
C        IVAR(24)      I          Comp. number of ith variable
C        JVAR(24)      I          Type number of ith variable
C
C     COMMON /IMFDA/ NX, NY, NPTS, DATA, DMAX, DMIN,
C                    BLNK, PTMAX, PTMIN, NPARM
C        DATA(MAXPTS)  R          Data point values
C        DMAX          R          Maximum value of data
C        DMIN          R          Minimum value of data
C        OFFSET        R          Disregard points below OFFSET*DMAX
C        NX            I          Number of columns
C        NY            I          Number of rows
C        NPTS          I          Number of points
C        BLNK          I          Blanking value 0-> none
C        PTMAX         I          Data point at maximum
C        PTMIN         I          Data point at minimum
C        NPARM         I          Number of fitting iterations
C   FCN is the subroutine which calculates the model and derivatives
C      maps where the RA increment was not equal to the DEC increment.
C-----------------------------------------------------------------------
      INCLUDE 'IMFIT.INC'
      CHARACTER PRGNAM*6
      INTEGER   INN, INVAR, LDJAC, NVAR, IER, IERR, INF, IPVT(24), NK,
     *   I, IRET, NSUMSQ
      REAL      BUFF(MAXPTS), RSTO, DSCALE, DOMODL
      DOUBLE PRECISION    VALVAR(24), FVEC(MAXPTS), FJAC(24,24),
     *   WA(3120), TOL, FJROW(24)
      EXTERNAL FCN
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA PRGNAM /'IMFIT '/
C-----------------------------------------------------------------------
      IRET = 8
C                                        Some initialization
      NPARM = 111
      LDJAC = 24
      NNGOOD = 0
      IER = 0
C                                        Initialize POPS
      CALL TINBEG (PRGNAM, NPARM, XNA, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 900
         END IF
C                                       output adverbs
      CALL RCOPY (24, XDM, FDM)
      CALL RCOPY (24, GM, FGM)
      CALL RFILL (2, 0.0, FSHIFT)
      IF (FACTOR.LE.0.0) FACTOR = 1.3
C                                       Get inputs, open map
      XU = NLUSER
      CALL IMFOPN (IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 900
         END IF
C                                       Print and store flags
      RSTO = XDOO
      OFFSET = XOFS
      DOMODL = XDOM
      OUTVER = XOVER + 0.1
      IF (XOVER.LT.0.0) OUTVER = -1
      CALL IMFDAT (IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         GO TO 900
         END IF
C                                       Insert defaults
      CALL IMFDEF
C                                       Determine scale factor
      DSCALE = MAX(DMAX, -DMIN)
      DSCALE = 10.0 ** (AINT (LOG10 (DSCALE/2.5) + 25.0) - 26.0)
      IF (-DMIN.GT.DMAX) DSCALE = -DSCALE
C                                        Print out input model
      XPR = XCRT.NE.0.0
      CALL IMFPRT (IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 900
         END IF
C                                        Print out map data
      IF (XPR) CALL IMPLOT (1, DSCALE)
C                                       Close input map
      CALL FILCLS (LUN1)
C                                        Store variables properly
      CALL IMFVST (NVAR, VALVAR)
C                                        Save map data in a buffer
      NNGOOD = 0
      DO 60 I = 1,NPTS
         BUFF(I) = DATA(I)
         IF (DATA(I).NE.FBLANK) THEN
            DATA(I) = 0.0
            NNGOOD = NNGOOD + 1
            END IF
 60      CONTINUE
C                                        Calculate model data
      NPARM = 0
      INN = NNGOOD
      INVAR = NVAR
      CALL FCN (INN, INVAR, VALVAR, FVEC, FJROW, 0)
C                                        Print out model data
      NK = 0
      DO 65 I = 1,NPTS
         IF (DATA(I).NE.FBLANK) THEN
            NK = NK + 1
            DATA(I) = FVEC(NK)
            END IF
 65      CONTINUE
      IF (XPR) CALL IMPLOT (2, DSCALE)
C                                        Restore data from buffer
      NSUMSQ = 0
      SUMSQ = 0.0
      DO 70 I = 1,NPTS
         IF (BUFF(I).NE.FBLANK) THEN
            NSUMSQ = NSUMSQ + 1
            SUMSQ = SUMSQ + (DATA(I) - BUFF(I)) ** 2
            END IF
         DATA(I) = BUFF(I)
 70      CONTINUE
      IF (NSUMSQ.GT.0) SUMSQ = SQRT (SUMSQ / NSUMSQ)
      MSGTXT = ' '
      IF (DOCRT.GT.-2.5) THEN
         CALL DOPRT
      ELSE
         CALL MSGWRT (4)
         END IF
      WRITE (MSGTXT,1070) SUMSQ, NSUMSQ
      CALL DOPRT
C                                        Call fitting subroutine
      TOL = 1.0D-16
      SUMSQ = 0.0
      RESSUM = 0.0
      RESMAX = 0.0
      IF (NVAR.GT.0) THEN
         INN = NNGOOD
         INVAR = NVAR
         CALL LMSTR1 (FCN, INN, INVAR, VALVAR, FVEC, FJAC, LDJAC,
     *      TOL, INF, IPVT, WA, 3120)
C                                        Termination type
         CALL IMFMSG (INF, NPARM)
         IF ((INF.EQ.-11) .OR. (INF.EQ.4)) THEN
            WRITE (MSGTXT,1071)
            GO TO 900
            END IF
C                                        Get residual data
         NK = 0
         DO 80 I = 1,NPTS
            IF (DATA(I).NE.FBLANK) THEN
               NK = NK + 1
               DATA(I) = -FVEC(NK)
               SUMSQ = SUMSQ + DATA(I)**2
               RESSUM = RESSUM + DATA(I)
               RESMAX = MAX (RESMAX, ABS (DATA(I)))
               END IF
 80         CONTINUE
         IF (CB(1)*CB(2).NE.0.0) THEN
            RESSUM = RESSUM / (1.1331 * CB(1) * CB(2))
         ELSE IF (NK.NE.0) THEN
            RESSUM = RESSUM / NK
            END IF
         IF (NK.GT.0) SUMSQ = SQRT (SUMSQ / NK)
         END IF
C                                        Calculate error estimate
      INN = NNGOOD
      CALL IMFERR (BUFF, INN, NVAR, VALVAR, FVEC, FJAC, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1080) IERR
         GO TO 900
         END IF
C                                        Residual plot?
      IF (XPR) CALL IMPLOT (3, DSCALE)
C                                       Store residual map
      IF (RSTO.GT.0.0) THEN
         CALL IMFSTO (IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1090) IERR
            GO TO 900
            END IF
         END IF
C                                        Convert to useful form
      IF (NVAR.NE.0) THEN
         CALL IMFOUT (RSTO, DOMODL, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR
            GO TO 900
            END IF
         END IF
C                                        Finished, no errors
      IRET = 0
      GO TO 980
C                                        Error return
 900  IER = 1
      CALL MSGWRT (8)
C                                       Close line printer
 980  IF (XCRT.NE.0.0) CALL LPCLOS (LUNP, INDP, ILINE, IERR)
C                                        Normal ending
      IF (.NOT.RQUICK) CALL PTPARM (50, FGM, BUFF, IERR)
      CALL TSKEND (IRET)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('COULD NOT INITIATE TASK.  IER=',I7)
 1020 FORMAT ('ERROR FROM IMFDEF.  IER=',I7)
 1030 FORMAT ('COUNT NOT STORE MAP DATA.  IER=',I7)
 1040 FORMAT ('COULD NOT PRINT INPUT MODEL.  IER=',I7)
 1070 FORMAT ('Initial guess RMS',1PE12.4,' in',I5,' usable pixels')
 1071 FORMAT ('CHECK INPUT MODEL.  MODEL VALUE IS CRAZY')
 1080 FORMAT ('COULD NOT GET MODEL ERRORS.  IER=',I7)
 1090 FORMAT ('COULD NOT STORE RESID MAP.  IER=',I7)
 1100 FORMAT ('COULD NOT PRINT CONVERTED MODEL.  IER=',I7)
      END
      SUBROUTINE IMFOPN (IER)
C-----------------------------------------------------------------------
C   IMFOPN checks the inputs, opens the input map, finds the true rms,
C   and then initializes the I/O
C   Outputs:
C      IER     I       Error return  0-> okay, 1-> error return
C-----------------------------------------------------------------------
      INTEGER   IER
C
      INCLUDE 'IMFIT.INC'
      INTEGER   IERR, IROUND, I, J, LOCS, NUMKEY, KEYTYP, MSGSAV, IFIL,
     *   CGBUFF(512), LUNCG, IRNO, CGKOLS(4), CGNUMV(4), NRNO, NWORDS
      LOGICAL   F
      HOLLERITH MA(2)
      CHARACTER KEYWRD*8
      REAL      BPA0, BLC(7), TRC(7), VALUE, XC, YC, BMAJ, BMIN, BPA,
     *   RMSMAP(2)
      LONGINT   RMSPTR
      DOUBLE PRECISION X, XMIN
      EXTERNAL  FCN
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DLOC.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      CALL FILL (5, 1, DEPTH)
      IER = 0
      LUN1 = 16
      CALL RFILL (3, 0.0, CB)
      CALL H2CHR (48, 1, XOP, LPNAME)
C                                       Store name for easy I/O
      CALL CHR2H (4, 'MA  ', 1, MA)
      CALL H2WAWA (XNA, XCL, XSE, MA, XDI, XU, INNA)
C                                       Open input map
      CALL OPENCF (LUN1, INNA, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 900
         END IF
C                                       Get header values
      CALL GETHDR (LUN1, CATBLK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1005) IERR
         GO TO 900
         END IF
      CALL COPY (256, CATBLK, INBLK)
C                                       check header for rms
      CALL FILNUM (LUN1, IFIL, IERR)
      INVOL = FILTAB (POVOL,IFIL)
      INSL = FILTAB (POCAT,IFIL)
C                                       set noise to use
C                                       direct adverb
      IF (RADIUS.LT.0.0) THEN
         ACTRMS = -RADIUS
         WRITE (MSGTXT,1006) ACTRMS
C                                       header or fit
      ELSE
         NUMKEY = 1
         KEYWRD = 'ACTNOISE'
         MSGSAV = MSGSUP
         MSGSUP = 32000
         CALL CATKEY ('READ', INVOL, INSL, KEYWRD, NUMKEY, LOCS, VALUE,
     *      KEYTYP, LINE, IERR)
         MSGSUP = MSGSAV
         IF ((IERR.EQ.0) .AND. (VALUE.GT.0.0) .AND. (RADIUS.EQ.0.)) THEN
            ACTRMS = VALUE
            WRITE (MSGTXT,1007) ACTRMS
C                                       no get from data
         ELSE
C                                       init whole image plane
            CALL RCOPY (7, XBL, BLC)
            CALL RCOPY (7, XTR, TRC)
            BLC(1) = 1.0
            BLC(2) = 1.0
            TRC(1) = 0.0
            TRC(2) = 0.0
            XC = (XBL(1) + XTR(1)) / 2.0
            YC = (XBL(2) + XTR(2)) / 2.0
            IF (RADIUS.EQ.0.0) RADIUS = 1.E6
            RADIUS = RADIUS * RADIUS
C                                       Whole plane window
            CALL MAPWIN (LUN1, BLC, TRC, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1010) IERR
               GO TO 900
               END IF
C                                       Get dimension of output
            WIN(1) = FILTAB(POBLC,6)
            WIN(2) = FILTAB(POBLC+1,6)
            WIN(3) = FILTAB(POTRC,6)
            WIN(4) = FILTAB(POTRC+1,6)
            NX = WIN(3) - WIN(1) + 1.5
            NY = WIN(4) - WIN(2) + 1.5
C                                       allocate memory
            NWORDS = (NX * NY - 1) / 1024 + 4
            CALL ZMEMRY ('GET ', 'JMFOPN', NWORDS, RMSMAP, RMSPTR, IERR)
            IF (IERR.NE.0) THEN
               MSGTXT = 'FAILED TO GET MEMORY FOR REAL RMS'
               CALL MSGWRT (8)
               GO TO 999
               END IF
C                                       get full rms
            CALL FNDRMS (NX, NY, RMSMAP(1+RMSPTR), LUN1, XC, YC,
     *         RADIUS, ACTRMS, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL ZMEMRY ('FREE', 'JMFOPN', NWORDS, RMSMAP, RMSPTR, IERR)
            IF (RADIUS.GT.1.E10) THEN
               WRITE (MSGTXT,1040) ACTRMS
            ELSE
               RADIUS = SQRT (RADIUS)
               WRITE (MSGTXT,1041) ACTRMS, RADIUS
               END IF
            END IF
         END IF
      CALL MSGWRT (3)
C                                       Window of map
      CALL MAPWIN (LUN1, XBL, XTR, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         GO TO 900
         END IF
C                                       Get dimension of output
      WIN(1) = FILTAB(POBLC,6)
      WIN(2) = FILTAB(POBLC+1,6)
      DEPTH(1) = FILTAB(POBLC+2,6)
      DEPTH(2) = FILTAB(POBLC+3,6)
      DEPTH(3) = FILTAB(POBLC+4,6)
      DEPTH(4) = FILTAB(POBLC+5,6)
      DEPTH(5) = FILTAB(POBLC+6,6)
      WIN(3) = FILTAB(POTRC,6)
      WIN(4) = FILTAB(POTRC+1,6)
      NX = WIN(3) - WIN(1) + 1.5
      NY = WIN(4) - WIN(2) + 1.5
      LOCNUM = 1
      CALL SETLOC (DEPTH, F)
      NPTS = NX * NY
      IF (NPTS.GT.MAXPTS) THEN
         WRITE (MSGTXT,1080) NX, NY, NPTS
         GO TO 900
         END IF
      XCEN = CATR(KRCRP)
      YCEN = CATR(KRCRP+1)
      XRA = 0.00D0
      XDEC = 0.0D0
      IF (AXTYP(LOCNUM).EQ.1) THEN
         XRA = CATD(KDORA)
         XDEC = CATD(KDODE)
         IF ((XDEC.NE.0.0D0) .OR. (XRA.NE.0.0D0)) THEN
            IF (CORTYP(LOCNUM).EQ.1) THEN
               CALL XYPIX (XRA, XDEC, XCEN, YCEN, IERR)
            ELSE
               CALL XYPIX (XDEC, XRA, XCEN, YCEN, IERR)
               END IF
            IF (IERR.NE.0) THEN
               XCEN = CATR(KRCRP)
               YCEN = CATR(KRCRP+1)
               IF (CORTYP(LOCNUM).EQ.1) THEN
                  XRA = CATD(KDCRV)
                  XDEC = CATD(KDCRV+1)
               ELSE
                  XRA = CATD(KDCRV+1)
                  XDEC = CATD(KDCRV)
                  END IF
               END IF
         ELSE
            IF (CORTYP(LOCNUM).EQ.1) THEN
               XRA = CATD(KDCRV)
               XDEC = CATD(KDCRV+1)
            ELSE
               XRA = CATD(KDCRV+1)
               XDEC = CATD(KDCRV)
               END IF
            END IF
      ELSE IF (BWS.GT.0.0) THEN
         MSGTXT = 'COORDINATES NOT RIGHT FOR BANDWIDTH SMEARING'
     *      // ' CORRECTION'
         CALL MSGWRT (6)
         BWS = 0.0
         END IF
C                                       Get slot number
      INSL = FILTAB(POCAT, 6)
C                                       Model defaults
      NGAUSS = IROUND (XNG)
      IF (NGAUSS.EQ.0) NGAUSS = 1
      NITER = IROUND (XNI)
      IF (NITER.EQ.0) NITER = 200 * NGAUSS
C                                       Loop over component
      DO 160 I = 1,NGAUSS
         XTYPE(I) = IROUND (XTY(I))
         IF (XTYPE(I).LT.1) XTYPE(I) = 1
         G(1,I) = GM(I)
         E(1,I) = XDM(I)
         DO 120 J = 2,3
            G(J,I) = GP(J-1,I)
            E(J,I) = XDP(J-1,I)
 120        CONTINUE
         NWIDTH(I) = .TRUE.
         DO 140 J = 4,6
            G(J,I) = GW(J-3,I)
            E(J,I) = XDW(J-3,I)
            NWIDTH(I) = NWIDTH(I) .AND. (E(J,I).LE.0)
 140        CONTINUE
 160     CONTINUE
C                                       Header Clean beam in pixels
      HCB(1) = CATR(KRBMJ)
      HCB(2) = CATR(KRBMN)
      HCB(3) = CATR(KRBPA)
      BPA0 = HCB(3) - ROT(LOCNUM)
      CALL ELIPSQ (HCB(1), HCB(2), BPA0, -AXINC(1,LOCNUM),
     *   AXINC(2,LOCNUM), HCBP(1), HCBP(2), HCBP(3))
C                                       Actual Clean beam
      CB(1) = -1.0
      XFREQ = 0.0D0
      CALL AXEFND (4, 'FREQ', CATBLK(KIDIM), CATBLK(KHCTP), FREQAX,
     *   IERR)
      IF (IERR.EQ.0) THEN
         XFREQ = CATD(KDCRV+FREQAX) + CATR(KRCIC+FREQAX) *
     *      (DEPTH(FREQAX-1) - CATR(KRCRP+FREQAX))
         CALL FNDEXT ('CG', CATBLK, J)
C                                       find Clean beam from CG table
         IF (J.GT.0) THEN
            LUNCG = 57
            CALL CGINI ('READ', CGBUFF, INVOL, INSL, J, CATBLK, LUNCG,
     *         IRNO, CGKOLS, CGNUMV, I, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1160) IERR, 'OPENING CG TABLE'
               CALL MSGWRT (7)
               GO TO 180
               END IF
            XMIN = 1.D16
            NRNO = CGBUFF(5)
            DO 170 I = 1,NRNO
               IRNO = I
               CALL TABCG ('READ', CGBUFF, IRNO, CGKOLS, CGNUMV, X,
     *            BMAJ, BMIN, BPA, IERR)
               IF (IERR.GT.0) THEN
                  WRITE (MSGTXT,1160) IERR, 'READING CG TABLE'
                  GO TO 900
               ELSE IF (IERR.EQ.0) THEN
                  IF (ABS(X-XFREQ).LT.XMIN) THEN
                     XMIN = ABS (X - XFREQ)
                     UCB(1) = BMAJ
                     UCB(2) = BMIN
                     UCB(3) = BPA
                     END IF
                  END IF
 170           CONTINUE
            BPA0 = UCB(3) - ROT(LOCNUM)
            CALL ELIPSQ (UCB(1), UCB(2), BPA0, -AXINC(1,LOCNUM),
     *         AXINC(2,LOCNUM), CB(1), CB(2), CB(3))
            CALL TABCG ('CLOS', CGBUFF, IRNO, CGKOLS, CGNUMV, X, BMAJ,
     *         BMIN, BPA, IERR)
            BMAJ = UCB(1) * 3600.
            BMIN = UCB(2) * 3600.
            BPA = UCB(3)
            WRITE (MSGTXT,1170) BMAJ, BMIN, BPA, 'CG table'
            END IF
         END IF
C                                       did not find in CG table
 180  IF (CB(1).LT.0.0) THEN
         CALL RCOPY (3, HCB, UCB)
         CALL RCOPY (3, HCBP, CB)
         BMAJ = UCB(1) * 3600.
         BMIN = UCB(2) * 3600.
         BPA = UCB(3)
         WRITE (MSGTXT,1170) BMAJ, BMIN, BPA, 'image header'
         END IF
      CALL MSGWRT (3)
      GO TO 999
C                                       Error return
 900  IER = 1
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('IMFOPN: COULD NOT OPEN INPUT MAP.  IER=',I7)
 1005 FORMAT ('IMFOPN: COULD NOT GET HEADER.  IER=',I7)
 1006 FORMAT ('True rms taken from RADIUS adverb =',1PE10.3)
 1007 FORMAT ('True rms taken from ACTNOISE in header =',1PE10.3)
 1010 FORMAT ('IMFOPN: COULD NOT MAPWIN.  IER=',I7)
 1040 FORMAT ('Robust solution gives RMS =',1PE10.3)
 1041 FORMAT ('Robust solution gives RMS =',1PE10.3,' in radius',
     *   0PF7.1,' pixels')
 1080 FORMAT ('IMFOPN: TOO MANY POINTS',I4,'X',I4,'=',I7,' POINTS')
 1160 FORMAT ('IMFOPN ERROR',I3,' ON ',A)
 1170 FORMAT ('Using Clean beam',2F10.5,F8.2,' from ',A)
      END
      SUBROUTINE FNDRMS (NX, NY, IMAGE, LUN, XC, YC, RADIUS, ACTRMS,
     *   IERR)
C-----------------------------------------------------------------------
C   Does robust rms on full image plane within a radius
C   Inputs:
C      NX       I      Number X pixels
C      NY       I      Number Y pixels
C      LUN      I      LUN to read image
C      XC       R      center X pixel
C      YC       R      center Y pixel
C      RADIUS   R      circle to do rms (squared in pixels)
C   Outputs:
C      IMAGE    R(*)   full image data
C      ACTRMS   R      actual robust rms
C      IERR     I      error code
C-----------------------------------------------------------------------
      INTEGER   NX, NY, LUN, IERR
      REAL      IMAGE(NX,*), XC, YC, RADIUS, ACTRMS
C
      INTEGER   NITER
      PARAMETER (NITER=8)
C
      INTEGER   I, J, NTRY, IT
      REAL      WS(NITER), VP, VM, R, V
      DOUBLE PRECISION SV, SSV, NV
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA WS /5.0, 4.0, 3.5, 3.0, 2.7, 2.6, 2.5, 3.5/
C-----------------------------------------------------------------------
      NTRY = 0
      DO 20 J = 1,NY
         CALL MAPIO ('READ', LUN, IMAGE(1,J), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READING IMAGE FOR RMS'
            CALL MSGWRT (8)
            GO TO 999
            END IF
 20      CONTINUE
C                                       ROBUST mean, rms
 25   VP = 1.E5
      VM = -VP
      DO 80 IT = 1,NITER
         SV = 0.0D0
         SSV = 0.0D0
         NV = 0.0D0
         DO 40 J = 1,NY
            DO 30 I = 1,NX
               V = IMAGE(I,J)
               IF ((V.NE.FBLANK) .AND. (V.NE.0.0)) THEN
                  R = (XC-I)*(XC-I) + (YC-J)*(YC-J)
                  IF (R.LE.RADIUS) THEN
                     IF ((V.GT.VM) .AND. (V.LT.VP)) THEN
                        SV = SV + V
                        SSV = SSV + V * V
                        NV = NV + 1.0D0
                        END IF
                     END IF
                  END IF
 30            CONTINUE
 40         CONTINUE
         IF (NV.GT.0.0D0) THEN
            SV = SV / NV
            SSV = SSV / NV - SV * SV
            SSV = SQRT (MAX (0.0D0, SSV))
            IF (IT.LT.NITER) THEN
               VP = SV + WS(IT+1) * SSV
               VM = SV - WS(IT+1) * SSV
               END IF
         ELSE
            VP = 1.E4
            VM = -1.E4
            END IF
 80      CONTINUE
C                                       okay??
      IF (NV.LE.5.0D0) THEN
         IF ((NTRY.EQ.0) .AND. (RADIUS.LE.NX*NY)) THEN
            MSGTXT = 'FNDRMS TRYING 2ND TIME WITH LARGE RADIUS'
            CALL MSGWRT (7)
            RADIUS = 1.E10
            GO TO 25
            END IF
         MSGTXT = 'FNDRMS FAILS TO FIND ROBUST RMS'
         CALL MSGWRT (8)
         IERR = 10
         END IF
C-
      ACTRMS = SSV
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FNDRMS: ERROR',I4,' ON ',A)
      END
      SUBROUTINE IMFDAT (IER)
C-----------------------------------------------------------------------
C   Subroutine IMFDAT reads the input data into the array DATA.
C   INPUTS:        none
C   OUTPUTS:
C     IER       I         Error return 0 -> okay
C                            1 -> error
C-----------------------------------------------------------------------
      INTEGER   IER, IERR, PTS, I, J
      LOGICAL   FPOS
      INCLUDE 'IMFIT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DITB.INC'
C-----------------------------------------------------------------------
C                                       Initialize
      IER = 0
      DMAX = -1.0E25
      DMIN = 1.0E25
      FPOS = .TRUE.
      PTS = 0
C                                       Line loop
      DO 40 J = 1,NY
         CALL MAPIO ('READ', LUN1, LINE, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) I, IERR
            GO TO 900
            END IF
C                                       Row loop, fill data
         DO 30 I = 1,NX
            PTS = PTS + 1
            DATA(PTS) = LINE(I)
C                                       Look for a blank pixel
            IF (LINE(I).NE.FBLANK) THEN
C                                       Look for extremum
               IF (DMAX.LE.LINE(I)) THEN
                  DMAX = LINE(I)
                  PTMAX = PTS
                  END IF
               IF (DMIN.GE.LINE(I)) THEN
                  DMIN = LINE(I)
                  PTMIN = PTS
                  END IF
               END IF
 30         CONTINUE
 40      CONTINUE
      IF (PTS.NE.NPTS) THEN
         WRITE (MSGTXT,1040) PTS, NPTS
         GO TO 900
         END IF
C                                        Apply cutoff
      IF (OFFSET.NE.0.0) THEN
         IF (DMAX.LT.-DMIN) FPOS = .FALSE.
         IF (FPOS) THEN
            OFFSET = OFFSET * DMAX
         ELSE
            OFFSET = OFFSET * DMIN
            END IF
         DO 70 I = 1,NPTS
            IF (DATA(I).EQ.FBLANK) GO TO 70
            IF (FPOS .AND. (DATA(I).GE.OFFSET)) GO TO 70
            IF (.NOT.FPOS .AND. (DATA(I).LE.OFFSET)) GO TO 70
               DATA(I) = FBLANK
 70         CONTINUE
         END IF
      GO TO 999
C                                       Error return
 900  IER = 1
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('IMFDAT: COULD NOT READ LINE ',I7,'  IER=',I7)
 1040 FORMAT ('JMFDAT: # point read=',I7,'  NX x NY=',I7)
      END
      SUBROUTINE IMFDEF
C-----------------------------------------------------------------------
C   IMFDEF is a subroutine for IMFIT which inserts defaults for
C   the input parameters.
C-----------------------------------------------------------------------
      INTEGER   ITEMP, IBTEMP, I, J, IERR
      REAL      TEMP, DX, DY, SMCB(3)
      LOGICAL   FMAX, FIRST
      DOUBLE PRECISION XD, X(3)
      INCLUDE 'IMFIT.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
C                                        Initialize
C                                        Min or max higher?
      FMAX = .TRUE.
      FIRST = .TRUE.
      IF (DMAX.LT.-DMIN) FMAX=.FALSE.
C                                        Component loop
      DO 300 I = 1,NGAUSS
C                                        XTYPE 1 = Gaussian
C                                              2 = Zero offset
C                                              3 = Zero, slope
C                                              4 = Zero, slope, curv
C                                              5 = General six param
         IBTEMP = XTYPE(I)
C                                        Gaussian component
         IF (IBTEMP.EQ.1) THEN
            IF (G(1,I).EQ.0.0) THEN
C                                           Amplitude.  Use max
               TEMP = 0.1
               IF (FIRST) TEMP = 1.0
               IF (FMAX) THEN
                  G(1,I) = DMAX * TEMP
               ELSE
                  G(1,I) = DMIN * TEMP
                  END IF
               FIRST = .FALSE.
               END IF
C                                           Position.  Use max posit.
            IF ((G(2,I).EQ.0.0) .AND. (G(3,I).EQ.0.0)) THEN
               IF (FMAX) THEN
                  G(2,I) = AINT(WIN(1) + MOD(PTMAX-1,NX) + 0.5)
                  G(3,I) = AINT(WIN(2) + AINT((PTMAX-0.5)/NX) + 0.5)
               ELSE
                  G(2,I) = AINT(WIN(1) + MOD(PTMIN-1,NX) + 0.5)
                  G(3,I) = AINT(WIN(2) + AINT((PTMIN-0.5)/NX) + 0.5)
                  END IF
               END IF
            IF (G(4,I).EQ.0.0) THEN
C                                       Widths
               IF (CB(1).NE.0.0) THEN
C                                       Use clean beam if avail.
C                                       BW smearing here
C                                       Radius
                  XD = 0.0D0
                  IF (((CORTYP(LOCNUM).EQ.1) .OR. (CORTYP(LOCNUM).EQ.2))
     *               .AND. (BWS.GT.0.0)) THEN
                     DX = G(2,I)
                     DY = G(3,I)
                     CALL XYVAL (DX, DY, X(1), X(2), X(3), IERR)
                     IF (IERR.NE.0) THEN
                        XD = 0.0D0
                     ELSE IF (CORTYP(LOCNUM).EQ.1) THEN
                        XD = SIN (DG2RAD*X(2)) * SIN (DG2RAD*XDEC) +
     *                     COS (DG2RAD*X(2)) * COS (DG2RAD*XDEC) *
     *                     COS (DG2RAD * (X(1) - XRA))
                     ELSE
                        XD = SIN (DG2RAD*X(1)) * SIN (DG2RAD*XDEC) +
     *                     COS (DG2RAD*X(1)) * COS (DG2RAD*XDEC) *
     *                     COS (DG2RAD * (X(2) - XRA))
                        END IF
                     IF (XD.GT.1.0D0) THEN
                        XD = 0.0D0
                     ELSE
                        XD = RAD2DG * ACOS (XD)
                        END IF
                     END IF
                  DX = G(2,I) - XCEN
                  DY = G(3,I) - YCEN
                  CALL BWSMCB (DX, DY, XD, BWS, CB, SMCB)
                  G(4,I) = SMCB(1)
                  G(5,I) = SMCB(2)
                  G(6,I) = SMCB(3)
C                                       Use 2 pixels
               ELSE
                  G(4,I) = 2.0
                  G(5,I) = 2.0
                  G(6,I) = 0.0
                  END IF
               END IF
C                                        Baseline
         ELSE IF ((IBTEMP.GE.2) .AND. (IBTEMP.LE.4)) THEN
            ITEMP = XTYPE(I) - 0.9
            XTYPE(I) = 2
            DO 150 J = 1,6
               G(J,I) = 0.0
               E(J,I) = -1.0
 150           CONTINUE
C                                        Zero offset only
            IF (IBTEMP.EQ.2) THEN
               E(1,I) = 1.0
C                                        Zero and slope
            ELSE IF (IBTEMP.EQ.3) THEN
               DO 190 J = 1,3
                  E(J,I) = 1.0
 190              CONTINUE
C                                        Zero, slope and curvature
            ELSE
               DO 210 J = 1,6
                  E(J,I) = 1.0
 210              CONTINUE
               END IF
            END IF
 300     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE IMFPRT (IER)
C-----------------------------------------------------------------------
C   IMFPRT is a subroutine of IMFIT which prints out models on the line
C   printer and the message terminal.
C   Outputs:
C      IER       I      Error status   0=> okay
C                             1=> problem
C-----------------------------------------------------------------------
      CHARACTER RSTR(2)*20, HFIX*2, MODEL(3)*8, CNAME*12, CCLAS*6,
     *   CUNIT*8, COBJ*8, CTYPX*2, FAST(6)*2, FILSPC*256
      INTEGER   IER, IERR, IBTEMP, CVOL, CUID, PASUM, SEQ, I, J, ILEN,
     *   I2TMP, PERR, IBUFF(256), ITRIM, FLEN, JERR
      REAL      DXREF, DYREF, RCONST, XREF, YREF, TEMP
      DOUBLE PRECISION    X(3)
      LOGICAL   ATEST
      INCLUDE 'IMFIT.INC'
      INCLUDE 'ORFIT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA HFIX  /'**'/
      DATA MODEL /'Gaussian', 'Baseline', '????????'/
C-----------------------------------------------------------------------
C                                        Initialize
      IER = 0
      ATEST = .FALSE.
      PASUM = 90.
      RCONST = 3.14159265 / 180.0
      CALL WAWA2A (INNA, CNAME, CCLAS, SEQ, CTYPX, CVOL, CUID)
      CALL H2CHR (8, 1, CATH(KHBUN), CUNIT)
      CALL H2CHR (8, 1, CATH(KHOBJ), COBJ)
C                                       Line printer initialization
      PERR = 0
      OREXIS = .FALSE.
      DOCRT = 1.0
      IF (XPR) THEN
         IF (LPNAME.EQ.' ') THEN
            DOCRT = MAX (-1.0, XCRT)
         ELSE
            DOCRT = MIN (-1.0, XCRT)
            END IF
         IF ((DOCRT.LT.-3.5) .AND. (LPNAME.NE.' ')) THEN
            CALL ZFULLN (LPNAME, ' ', ' ', FILSPC, JERR)
            IF (JERR.EQ.0) THEN
               FLEN = ITRIM (FILSPC)
               INQUIRE (FILE=FILSPC, EXIST=OREXIS)
               END IF
            END IF
         ILINE = 900
         IPAGE = 0
         CALL LPOPEN (LPNAME, DOCRT, LUNP, INDP, NACROS, IBUFF, PERR)
         IF ((PERR.EQ.0) .AND. (DOCRT.GT.-3.5)) THEN
            WRITE (TITL1,1020) CNAME, CCLAS, SEQ, COBJ, CUNIT
            TITL2 = ' '
            IF (DOCRT.LE.-2.5) CALL PRTLIN (LUNP, INDP, DOCRT, NACROS,
     *         TITL1, TITL2, TITL1, ILINE, IPAGE, SCRTCH, PERR)
            END IF
         IF (PERR.NE.0) XPR = .FALSE.
         END IF
C                                        Some header information
      WRITE (MSGTXT,1021) CNAME, CCLAS, SEQ
      CALL MSGWRT (4)
      WRITE (MSGTXT,1022) COBJ, CUNIT
      CALL MSGWRT (4)
      XREF = CATR(KRCRP)
      YREF = CATR(KRCRP+1)
      DXREF = CATR(KRCIC)
      DYREF = CATR(KRCIC+1)
      CALL XYVAL (XREF, YREF, X(1), X(2), X(3), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1100) IERR
         CALL MSGWRT (8)
         GO TO 115
         END IF
C                                        Check axes types
C                                        Normal RA and DEC
      IF (AXTYP(LOCNUM).EQ.1) THEN
         DXREF = 3600.0 * DXREF
         DYREF = 3600.0 * DYREF
         DO 105 J = 1,2
            I2TMP = J - 1
            CALL AXSTRN (CTYP(J,LOCNUM), X(J), I2TMP, ILEN, RSTR(J))
 105        CONTINUE
         WRITE (MSGTXT,1105) XREF, RSTR(1), DXREF
         CALL DOPRT
         WRITE (MSGTXT,1107) YREF, RSTR(2), DYREF
         CALL DOPRT
         REFRA = RSTR(1)(4:17)
         IF (RSTR(2)(5:5).EQ.'-') THEN
            REFDEC = RSTR(2)(5:18)
         ELSE
            REFDEC = RSTR(2)(4:17)
            END IF
C                                        Not RA and DEC
      ELSE
         WRITE (MSGTXT,1110) XREF, X(1), DXREF
         CALL DOPRT
         WRITE (MSGTXT,1112) YREF, X(2), DYREF
         CALL DOPRT
         END IF
C                                       Other axes
 115  WRITE (MSGTXT,1115) DEPTH
      IF (DOCRT.GT.-2.5) THEN
         CALL DOPRT
      ELSE
         CALL MSGWRT (4)
         END IF
      DO 116 J = 1,2
         IF (SAXLAB(J,LOCNUM).NE.' ') THEN
            WRITE (MSGTXT,1116) J+2, SAXLAB(J,LOCNUM)
            IF (DOCRT.GT.-2.5) THEN
               CALL DOPRT
            ELSE
               CALL MSGWRT (4)
               END IF
            END IF
 116     CONTINUE
      WRITE (MSGTXT,1120)
      IF (DOCRT.GT.-2.5) THEN
         CALL DOPRT
      ELSE
         CALL MSGWRT (4)
         END IF
      WRITE (MSGTXT,1122)
      CALL DOPRT
C                                        Print input model
      DO 400 I = 1,NGAUSS
         FAST(1) = '  '
         FAST(2) = '  '
         FAST(3) = '  '
         FAST(4) = '  '
         FAST(5) = '  '
         FAST(6) = '  '
C                                        Gaussian comp
         IBTEMP = XTYPE(I)
         IF (IBTEMP.NE.2) THEN
            DO 140 J = 1,6
               IF (E(J,I).LE.0.0) FAST(J) = HFIX
 140           CONTINUE
            WRITE (MSGTXT,1140) I, MODEL(IBTEMP)
            CALL DOPRT
            WRITE (MSGTXT,1141) G(1,I), FAST(1), CUNIT
            CALL DOPRT
            WRITE (MSGTXT,1142) (G(J,I), FAST(J), J = 2,3)
            CALL DOPRT
            WRITE (MSGTXT,1144) (G(J,I), FAST(J), J = 4,6)
            CALL DOPRT
C                                        Fix diameters
            G(4,I) = ABS (G(4,I))
            G(5,I) = ABS (G(5,I))
            IF (G(4,I).LT.G(5,I)) THEN
               TEMP = G(5,I)
               G(5,I) = G(4,I)
               G(4,I) = TEMP
               G(6,I) = G(6,I) + 90.0
               END IF
C                                        Diameter circularity
            IF ((G(4,I)-G(5,I).LE.G(4,I)/10.0) .AND. (E(4,I).GT.0.0)
     *         .AND. (E(5,I).GT.0.0)) THEN
               G(4,I) = G(4,I)*1.10
               G(5,I) = G(5,I)/1.10
               WRITE (MSGTXT,1150)
               IF (DOCRT.GT.-2.5) THEN
                  CALL DOPRT
               ELSE
                  CALL MSGWRT (4)
                  END IF
               END IF
C                                        Fix position angle
            G(6,I) = (G(6,I) - PASUM) * RCONST
C                                        Baseline term
         ELSE
            WRITE (MSGTXT,1230) I, MODEL(IBTEMP)
            CALL DOPRT
C                                        Zero offset?
            IF (E(1,I).GT.0.0) THEN
               WRITE (MSGTXT,1232) G(1,I), FAST(1), CUNIT
               CALL DOPRT
               END IF
C                                        Slope?
            IF ((E(2,I).GT.0.0) .OR. (E(3,I).GT.0.0)) THEN
               WRITE (MSGTXT,1260) (G(J,I), FAST(J), J = 2,3)
               CALL DOPRT
               END IF
C                                        Curvature?
            IF ((E(4,I).GT.0.0) .OR. (E(5,I).GT.0.0) .OR.
     *         (E(6,I).GT.0.0)) THEN
               WRITE (MSGTXT,1290) (G(J,I), FAST(J), J = 4,6)
               CALL DOPRT
               END IF
C                                        Fix up ampl and angles
            G(3,I) = (G(3,I) - PASUM) * RCONST
            G(6,I) = (G(6,I) - PASUM) * RCONST
            END IF
         DO 370 J = 1,6
            IF (FAST(J).EQ.HFIX) ATEST = .TRUE.
 370        CONTINUE
 400     CONTINUE
C                                        Any parameters fixed?
      IF (ATEST) THEN
         WRITE (MSGTXT,1415)
         IF (DOCRT.GT.-2.5) THEN
            CALL DOPRT
         ELSE
            CALL MSGWRT (4)
            END IF
         END IF
C                                        Clean beam information
      IF (CB(1).GT.0.0) THEN
         WRITE (MSGTXT,1120)
         IF (DOCRT.GT.-2.5) THEN
            CALL DOPRT
         ELSE
            CALL MSGWRT (4)
            END IF
         WRITE (MSGTXT,1418) CB(1), CB(2), CB(3)
      ELSE
         WRITE (MSGTXT,1420)
         END IF
      CALL DOPRT
C                                        Offset?
      IF (OFFSET.GT.0.0) THEN
         WRITE (MSGTXT,1430) OFFSET, CUNIT
         CALL DOPRT
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('Model fit to ',A12,'.',A6,'.',I4,'  Source= ',A8,' in ',
     *   A8)
 1021 FORMAT ('Model fit to ',A12,'.',A6,'.',I4)
 1022 FORMAT ('Source= ',A8,' in units ',A8)
 1100 FORMAT ('ERROR',I3,' CONVERTING TO REFERENCE COORDINATES')
 1105 FORMAT ('X-ref pix=',F6.1,2X,A,' Pix sep (asec)',F8.4)
 1107 FORMAT ('Y-ref pix=',F6.1,2X,A,' Pix sep (asec)',F8.4)
 1110 FORMAT ('X-ref pix=',F6.1,'  Value=',1PE14.5,'  Pix sep=',
     *   1PE13.5)
 1112 FORMAT ('Y-ref pix=',F6.1,'  Value=',1PE14.5,'  Pix sep=',
     *   1PE13.5)
 1115 FORMAT ('Axes 3-7 pixels =',5I7)
 1116 FORMAT ('Axis',I2,' : ',A)
 1120 FORMAT (1X,30('- '))
 1122 FORMAT ('******** Input Model ',2('********************'))
 1140 FORMAT ('Component=',I3,2X,A)
 1141 FORMAT (6X,'Peak=',1PE11.4,1X,A2,1X,A8)
 1142 FORMAT (6X,'Xpos=',F8.2,1X,A2,'   Ypos=',F8.2,1X,A2,'  pixels')
 1144 FORMAT (6X,'Size=',F7.2,1X,A2,' x',F7.2,1X,A2,' Pixels at pa',
     *   F7.2,1X,A2,' deg')
 1150 FORMAT (6X,'Component made 10% elliptical for better fitting')
 1230 FORMAT ('Component=',I3,2X,A8)
 1232 FORMAT (6X,'Zero lev=',1PE11.4,1X,A2,1X,A8)
 1260 FORMAT (6X,'Slope=',1PE11.4,1X,A2,' Ampl/pixel:   Angle=',0PF6.2,
     *   1X,A2)
 1290 FORMAT (6X,'Curvature=',1PE11.4,1X,A2,'   Eccen=',F5.3,1X,A2,
     *   '   Angle=',F6.2,1X,A2)
 1415 FORMAT (6X,13X,'** means parameter is held fixed')
 1418 FORMAT (6X,'Beam=',F7.2,3X,' X',F7.2,3X,' Pixels: in pa',
     *   F6.2,3X,' Deg')
 1420 FORMAT (6X,'No CLEAN beam')
 1430 FORMAT (6X,'Clipping below',1PE11.4,1X,A8)
      END
      SUBROUTINE IMPLOT (N, DSCALE)
C-----------------------------------------------------------------------
C   Subroutine IMPLOT prints a digital representation of the maps from
C   IMFIT on the line printer.
C   Inputs:
C      N        I   Type of map
C      DSCALE   R   Scale of display
C-----------------------------------------------------------------------
      CHARACTER  BLANKS*132, ALINE*132, WORD(3)*12, CTEMP*8
      INTEGER   N, WIN1, WIN2, WIN3, WIN4, WINH, WINL, IPTS, I, J, IL,
     *   PLINE, PERR, IROUND, NXX, IC, IP, IS
      REAL      DSCALE, TEMP, DTEMP, DSAVE, LSCALE, RMIN, RMAX
      INCLUDE 'IMFIT.INC'
      INCLUDE 'INCS:DDCH.INC'
      SAVE DSAVE
      DATA BLANKS /' '/
      DATA WORD /'Input map   ', 'Input model ', 'Residual map'/
C-----------------------------------------------------------------------
      IF (XCRT.LT.-3.5) GO TO 999
      WIN1 = WIN(1) + 0.01
      WIN2 = WIN(2) + 0.01
      WIN3 = WIN(3) + 0.01
      WIN4 = WIN(4) + 0.01
      NXX = WIN3 - WIN1 + 1
      IC = (NACROS - 6) / NXX
      IC = MIN (6, MAX (IC, 3))
      IF ((XNDIG.GE.3.0) .AND. (XNDIG.LT.IC)) IC = XNDIG + 0.01
      IL = (NACROS - 6) / IC
      LSCALE = DSCALE
      IF (IC.GT.3) LSCALE = DSCALE / (10.0 ** (IC-3))
      RMAX = (10.0**IC) - 0.51
      RMIN = -(10.0**(IC-1)) + 0.51
C                                       Write map scale
      WRITE (ALINE,1000) WORD(N), LSCALE
      IF ((N.GT.1) .AND. (DSAVE.NE.LSCALE)) WRITE (ALINE,1001)
     *   WORD(N), LSCALE
      IF (DOCRT.GT.-2.5) THEN
         CALL PRTLIN (LUNP, INDP, DOCRT, NACROS, TITL1, TITL2, BLANKS,
     *      ILINE, IPAGE, SCRTCH, PERR)
         IF (PERR.NE.0) GO TO 900
         END IF
      CALL PRTLIN (LUNP, INDP, DOCRT, NACROS, TITL1, TITL2, ALINE,
     *   ILINE, IPAGE, SCRTCH, PERR)
      IF (PERR.NE.0) GO TO 900
      IF (DOCRT.GT.-2.5) THEN
         CALL PRTLIN (LUNP, INDP, DOCRT, NACROS, TITL1, TITL2, BLANKS,
     *      ILINE, IPAGE, SCRTCH, PERR)
         IF (PERR.NE.0) GO TO 900
         END IF
C                                       Map headings
      DTEMP = LSCALE
      DSAVE = LSCALE
      WINL = WIN1
      WINH = WIN3
      IF (WINH-WINL.GE.IL) THEN
         WINL = WINL + (WINH - WINL - IL) / 2
         WINH = WINL + IL - 1
         END IF
      ALINE = ' '
      IP = IC + 1
      DO 20 I = WINL,WINH,2
          WRITE (CTEMP,1020) I
          ALINE(IP:) = CTEMP
          IP = IP + 2 * IC
 20       CONTINUE
      CALL PRTLIN (LUNP, INDP, DOCRT, NACROS, TITL1, TITL2, ALINE,
     *   ILINE, IPAGE, SCRTCH, PERR)
      IF (PERR.NE.0) GO TO 900
      IL = WIN4 + 1
C                                       Line loop
      IS = 9 - IC
      DO 40 I = WIN2,WIN4
         IL = IL - 1
         IPTS = (IL - WIN2) * (WIN3 - WIN1 + 1) + (WINL - WIN1)
C                                       Row loop
         IP = 6
         WRITE (ALINE,1020) IL
         DO 30 J = WINL,WINH
            IPTS = IPTS + 1
            TEMP = DATA(IPTS)
            IF (TEMP.NE.FBLANK) THEN
               TEMP = TEMP / DTEMP
               TEMP = MAX (RMIN, MIN (RMAX, TEMP))
               PLINE = IROUND (TEMP)
               WRITE (CTEMP,1030) PLINE
               ALINE(IP:) = CTEMP(IS:)
               END IF
            IP = IP + IC
 30         CONTINUE
C                                       Write a line of data
         CALL PRTLIN (LUNP, INDP, DOCRT, NACROS, TITL1, TITL2, ALINE,
     *      ILINE, IPAGE, SCRTCH, PERR)
         IF (PERR.NE.0) GO TO 900
 40      CONTINUE
      GO TO 999
C
 900  XPR = .FALSE.
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A12,10X,'1 Map unit=',1PE10.3)
 1001 FORMAT (A12,10X,'1 Map unit=',1PE10.3,'  Changed  ********')
 1020 FORMAT (I5)
 1030 FORMAT (I8)
      END
      SUBROUTINE IMFVST (NVAR, VALVAR)
C-----------------------------------------------------------------------
C   INFVST is a subroutine for IMFIT which stores the variable
C   parameters in the proper arrays for use in FCN and LMSTR1.
C   INPUTS:  none  see COMMONs
C   OUTPUTS:
C      NVAR            I       The number of variables
C      VALVAR(24)      D       The value of this variable
C-----------------------------------------------------------------------
      INTEGER   NVAR, I, J
      DOUBLE PRECISION    VALVAR(24)
      INCLUDE 'IMFIT.INC'
C-----------------------------------------------------------------------
C                                       Initialize
      NVAR = 0
C                                       Loop over components
      DO 50 I = 1,NGAUSS
         DO 40 J = 1,6
C                                       not holding parameter fixed
            IF (E(J,I).GT.0.0) THEN
               NVAR = NVAR + 1
               VALVAR(NVAR) = G(J,I)
               IVAR(NVAR) = I
               JVAR(NVAR) = J
               E(J,I) = 1.0
            ELSE
               E(J,I) = -1.0
               END IF
 40         CONTINUE
 50      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE FCN (INN, INVAR, VALVAR, FVEC, FJAC, IFLAG)
C-----------------------------------------------------------------------
C   FCN calculates the difference between the model and the data.  This
C   subroutine is used in the task IMFIT.
C   Inputs:
C      INN         I   The number of data points (adj. array dim.)
C      INVAR       I   The number of variable parameters (adj. array
C                      dim.)
C      VALVAR(24)  D   The value of the variable param.
C      IFLAG       I   Type of operation
C                        0 = Calculate function outside LMDER
C                        1 = Calculate function inseide LMDER
C                        N >1 Calculate Jacobian of row N-1
C                             where N not equal to 1
C   Outputs:
C      FVEC(MAXPTS) D   Model-Data for each grid point used
C      FJAC(24)     D   The function partials
C-----------------------------------------------------------------------
      INCLUDE 'IMFIT.INC'
      INTEGER   INN, INVAR, IFLAG
      DOUBLE PRECISION    VALVAR(24), FVEC(*), FJAC(24)
C
      INTEGER   NVAR, K, II, I, J
      REAL      FUNC(MAXPTS)
      INTEGER   X1, Y1, NK, KK
      SAVE X1, Y1
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IF (INN.GT.NPTS) THEN
         MSGTXT = 'MORE POINTS IN CALL TO FUNCTION THAN WE HAVE'
         CALL MSGWRT (6)
         END IF
      NVAR = INVAR
C                                       Test on IFLAG
      IF (IFLAG.LE.1) THEN
C                                        X pixel and Y pixel range
         X1 = WIN(1) + 0.5
         Y1 = WIN(2) + 0.5
C                                        Put data function array
         NK = 0
         DO 10 K = 1,NPTS
            IF (DATA(K).NE.FBLANK) THEN
               NK = NK + 1
               FVEC(NK) = -DATA(K)
               END IF
 10         CONTINUE
C                                        Fill in new variable values
         DO 20 II = 1,NVAR
            G(JVAR(II),IVAR(II)) = VALVAR(II)
 20         CONTINUE
C                                        Loop over components
         DO 40 I = 1,NGAUSS
C                                        Evaluate function
C
            CALL IMFMOD (XTYPE(I), I, I, 0, G(1,I), E(1,I), X1, Y1,
     *         NPARM, NX, NY, FUNC, FJAC(1))
C                                        Sum up solution
            NK = 0
            DO 30 K = 1,NPTS
               IF (DATA(K).NE.FBLANK) THEN
                  NK = NK + 1
                  FVEC(NK) = FUNC(K) + FVEC(NK)
                  END IF
 30            CONTINUE
 40         CONTINUE
         IF (IFLAG.EQ.0) GO TO 999
C                                        Terminate due to conv.
         IF (NPARM.GE.15) THEN
            CALL IMFCHK (NVAR, JVAR, IVAR, VALVAR, XTYPE, WIN, DMAX,
     *         DMIN, IFLAG)
            IF (IFLAG.LE.-10) THEN
               NITER = NPARM
               GO TO 999
               END IF
            END IF
C                                        Terminate due to NITER?
         IF (NPARM.GE.NITER) IFLAG = -9
C                                       Calculate the Jacobian
C                                       Get data point
      ELSE
         NK = IFLAG - 1
         KK = 0
         DO 105 I = 1,NPTS
            IF (DATA(I).NE.FBLANK) THEN
               KK = KK + 1
               IF (KK.GE.NK) THEN
                  K = I
                  GO TO 108
                  END IF
               END IF
 105        CONTINUE
C                                       Loop over variables
 108     DO 110 II = 1,NVAR
            I = IVAR(II)
            J = JVAR(II)
C                                             Calculate Jacobian
            CALL IMFMOD (XTYPE(I), I, J, K, G(1,I), E(1,I), X1, Y1,
     *         NPARM, NX, NY, FUNC, FJAC(II))
 110        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE IMFMOD (TYPE, NC, JV, IC, G, E, X1, Y1, NPARM, NX, NY,
     *    FUNC, FJAC)
C-----------------------------------------------------------------------
C   IMFMOD is a subroutine of IMFIT.  This subroutine is called by FCN
C   and supplied the value of the function at all data points and the
C   value of the Jacobian at each data point.  It can be generalized to
C   include other function types.
C   Inputs:
C      TYPE            I     The component type
C                              1=Gaussian, 2=Baseline
C      NC              I     The component number
C      JV              I     The variable number of the component
C      IC              I     Type of calculation
C                              0=Calculate function at all points
C                              N>0=Calculate Jacobian for Nth point
C      G(6)            R     Parameter values
C      E(6)            R     Parameter errors (0=hold fixed)
C      X1              I     Smallest X pixel
C      Y1              I     Smallest Y pixel
C      NPARM           I     Iteration number
C      NX              I     Number of X pixels
C      NY              I     Number of Y pixels
C   Outputs:
C      FUNC(MAXPTS)    R     The function value at all points
C      FJAC            D     The Jacobian for (IC-1) point
C-----------------------------------------------------------------------
      INTEGER   TYPE, NC, JV, IC, X1, Y1, NX, NY, NPARM
      REAL      G(6), E(6), FUNC(*), X2, Y2, X0, Y0
      DOUBLE PRECISION    FJAC
      INTEGER   NPTS, KP, IP, K
      REAL      CON, X, Y
C                                        Working arrays
      INCLUDE 'IMFPTS.INC'
      REAL      SINTH2(4), COSTH2(4), SIN2TH(4), COS2TH(4)
      REAL      VA(4), VB(4), VC(4), VD(4), MJ(4), MN(4)
      REAL      F(MAXPTS,4)
      REAL      SINP, COSP, SINP2, COSP2, SIN2P, SINT, COST
      REAL      EL, ELC, CURV, SL, ZERO
      SAVE SINTH2, COSTH2, SIN2TH, COS2TH, VA, VB, VC, VD, MJ, MN,
     *   F, SINP, COSP, SINP2, COSP2, SIN2P, SINT, COST,
     *   EL, ELC, CURV, SL, ZERO, X2, Y2, X0, Y0, con, x, y, NPTS, KP,
     *   IP, K
      INCLUDE 'INCS:DMSG.INC'
      DATA CON /2.772589/
C-----------------------------------------------------------------------
C                                        Gaussian
      IF (TYPE.EQ.1) THEN
C              G(1) = Peak of Gaussian component
C              G(2) = X-pixel location of peak
C              G(3) = Y-pixel location of peak
C              G(4) = Full width-half intensity of major axis in pixels
C              G(5) = Full width-half intensity of minor axis in pixels
C              G(6) = Position angle of major axis in radians
C                     Measured from vertical, increasing CCW
C                                        Function or Jacobian
         IF (IC.LE.0) THEN
C                                        Function
C                                        First time through?
            IF (NPARM.LT.NC) THEN
C                                        Initialize fixed constants
               NPTS = NX * NY
               IF (E(6).LT.0.0) THEN
                  SINTH2(NC) = SIN(G(6))**2
                  COSTH2(NC) = COS(G(6))**2
                  SIN2TH(NC) = -SIN(2.0*G(6))
                  COS2TH(NC) = COS(2.0*G(6))
                  END IF
               IF (E(4).LT.0.0) MJ(NC) = G(4)*G(4)/CON
               IF (E(5).LT.0.0) MN(NC) = G(5)*G(5)/CON
               IF (E(4).LT.0.0 .AND. E(5).LT.0.0 .AND. E(6).GE.0.0)
     *            THEN
                  VA(NC) = COSTH2(NC)/MJ(NC) + SINTH2(NC)/MN(NC)
                  VB(NC) = SINTH2(NC)/MJ(NC) + COSTH2(NC)/MN(NC)
                  VC(NC) = SIN2TH(NC) * (1.0/MN(NC) - 1.0/MJ(NC))
                  VD(NC) = COS2TH(NC) * (1.0/MN(NC) - 1.0/MJ(NC))
                  END IF
               END IF
            NPARM = NPARM + 1
C                                        Initialize variable constants
            IF (E(6).GE.0.0) THEN
               SINTH2(NC) = SIN(G(6))**2
               COSTH2(NC) = COS(G(6))**2
               SIN2TH(NC) = -SIN(2.0*G(6))
               COS2TH(NC) = COS(2.0*G(6))
               END IF
            IF (E(4).GE.0.0) MJ(NC) = G(4)*G(4)/CON
            IF (E(5).GE.0.0) MN(NC) = G(5)*G(5)/CON
            IF (E(4).GE.0.0 .OR. (E(5).GE.0.0) .OR. (E(6).LT.0.0))
     *         THEN
               VA(NC) = COSTH2(NC)/MJ(NC) + SINTH2(NC)/MN(NC)
               VB(NC) = SINTH2(NC)/MJ(NC) + COSTH2(NC)/MN(NC)
               VC(NC) = SIN2TH(NC) * (1.0/MN(NC) - 1.0/MJ(NC))
               VD(NC) = COS2TH(NC) * (1.0/MN(NC) - 1.0/MJ(NC))
               END IF
C                                        Cycle through grid points
            DO 100 K = 1,NPTS
               X = X1 + MOD(K-1,NX) - G(2)
               Y = Y1 + AINT((K-0.5)/NX) - G(3)
               FUNC(K) = G(1) * EXP(-(VA(NC) * X**2 +
     *            VB(NC) * Y**2 + VC(NC) * X * Y))
C                                        Store value for later use
               F(K,NC) = FUNC(K)
 100           CONTINUE
C                                        Set counter for Jacobian
            KP = 0
            IP = 0
C                                        Calculate Jacobian
      ELSE
C                                        Data point
         K = IC
C                                        New data point of component?
         IF ((K.NE.KP) .OR. (IP.NE.NC)) THEN
            KP = K
            IP = NC
            X = X1 + MOD (K-1, NX) - G(2)
            Y = Y1 + AINT ((K-0.5)/NX) - G(3)
            X2 = X * X
            Y2 = Y * Y
            END IF
C                                        Amplitude
         IF (JV.EQ.1) THEN
            IF (G(1).EQ.0.0) G(1)=1.0E-10
            FJAC = F(K,NC) / G(1)
C                                        X-position
         ELSE IF (JV.EQ.2) THEN
            FJAC = F(K,NC) * (2.0 * X * VA(NC) + Y * VC(NC))
C                                        Y-position
         ELSE IF (JV.EQ.3) THEN
            FJAC = F(K,NC) * (2.0 * Y * VB(NC) + X * VC(NC))
C                                        Major axis
         ELSE IF (JV.EQ.4) THEN
            FJAC = 2.0 * CON * F(K,NC) / G(4)**3 *
     *         (X2 * COSTH2(NC) + Y2 * SINTH2(NC) - X * Y * SIN2TH(NC))
C                                        Minor axis
         ELSE IF (JV.EQ.5) THEN
            FJAC = 2.0 * CON * F(K,NC) / G(5)**3 *
     *         (X2 * SINTH2(NC) + Y2 * COSTH2(NC) + X * Y * SIN2TH(NC))
C                                        Position angle
         ELSE IF (JV.EQ.6) THEN
            FJAC = F(K,NC) * (VC(NC) * (X2 - Y2) + VD(NC) * 2.0 * X * Y)
            END IF
         END IF
C                         General baseline
      ELSE IF (TYPE.EQ.2) THEN
C              G(1) = Zero level offset
C              G(2) = Baseline slope in ampl/pixel
C              G(3) = Orientation of slope in radians
C              G(4) = Major axis curvature in ampl**2/pixel
C              G(5) = Curvature eccentricity
C              G(6) = Orientation of major axis curvature
C                                        Function or Jacobian
         IF (IC.LE.0) THEN
C                                        Function
C                                        First time through?
            IF (NPARM.LT.NC) THEN
C                                       Initialize fixed constants
               NPTS = NX * NY
               X0 = X1 + (NX-1) / 2.0
               Y0 = Y1 + (NY-1) / 2.0
               IF (E(6).LT.0) THEN
                  SINP = SIN(G(6))
                  COSP = COS(G(6))
                  SINP2 = SINP * SINP
                  COSP2 = COSP * COSP
                  SIN2P = 2.0 * SINP * COSP
                  END IF
               IF (E(5).LT.0.0) THEN
                  EL = G(5)
                  ELC = 1 - EL
                  END IF
               IF (E(4).LT.0.0) CURV = G(4)
               IF (E(3).LT.0.0) THEN
                  SINT = SIN(G(3))
                  COST = COS(G(3))
                  END IF
               IF (E(2).LT.0.0) SL = G(2)
               IF (E(1).LT.0.0) ZERO = G(1)
               END IF
            NPARM = NPARM + 1
C                                        Initialize variables
            IF (E(6).GE.0) THEN
               SINP = SIN(G(6))
               COSP = COS(G(6))
               SINP2 = SINP * SINP
               COSP2 = COSP * COSP
               SIN2P = 2.0 * SINP * COSP
               END IF
            IF (E(5).GE.0.0) THEN
               EL = G(5)
               ELC = 1 - EL
               END IF
            IF (E(4).GE.0.0) CURV = G(4)
            IF (E(3).GE.0.0) THEN
               SINT = SIN(G(3))
               COST = COS(G(3))
               END IF
            IF (E(2).GE.0.0) SL = G(2)
            IF (E(1).GE.0.0) ZERO = G(1)
C                                        Evaluate function
            DO 340 K = 1,NPTS
               X = X1 + MOD(K-1,NX) - X0
               Y = Y1 + AINT((K-0.5)/NX) - Y0
               F(K,NC) = X * X * (COSP2 + EL * SINP2) +
     *            Y * Y * (SINP2 + EL * COSP2) +
     *            X * Y * 2.0 * SIN2P * ELC
               FUNC(K) = ZERO + SL * (X*COST + Y*SINT) + CURV * F(K,NC)
 340           CONTINUE
C                                        Set counter for Jacobian
            KP = 0
            IP = 0
C                                        Calculate Jacobian
C                                        Data point
         ELSE
            K = IC
C                                        New data point of component?
            IF ((K.NE.KP) .OR. (IP.NE.NC)) THEN
               KP = K
               IP = NC
               X = X1 + MOD (K-1,NX) - X0
               Y = Y1 + AINT ((K-0.5)/NX) - Y0
               END IF
C                                        Go to correct variable type
            IF (JV.EQ.1) THEN
               FJAC = 1.0
            ELSE IF (JV.EQ.2) THEN
               FJAC = X * COST + Y * SINT
            ELSE IF (JV.EQ.3) THEN
               FJAC = SL * (Y * COST - X * SINT)
            ELSE IF (JV.EQ.4) THEN
               FJAC = F(K,NC)
            ELSE IF (JV.EQ.5) THEN
               FJAC = CURV * (X*X * SINP2 + Y*Y * COSP2 - 2.0 * X * Y *
     *            SIN2P)
            ELSE IF (JV.EQ.6) THEN
               FJAC = CURV*ELC * (SIN2P*(Y*Y - X*X) + (COSP2 -
     *            SINP2)*4.0*X*Y)
               END IF
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE IMFCHK (NVAR, JVAR, IVAR, VALVAR, XTYPE, WIN, DMAX,
     *   DMIN, IFLAG)
C-----------------------------------------------------------------------
C   Subroutine IMFCHK, a subroutine for IMFIT, compared two consecutive
C   solutions and checks if the difference between all of the fitted
C   parameters have changed insignificantly.
C   Inputs:
C      NVAR        I       The number of variables
C      JVAR(24)    I       The variable type
C      IVAR(24)    I       The variable component
C      VALVAR(24)  D       The variable value
C      XTYPE(4)    I       The component type
C      WIN(4)      R       The fitting window
C      DMAX        R       The data maximum
C      DMIN        R       The data minimum
C   Output:
C      IFLAG       I       1-> Solution still changing
C                          -10 -> Solution has converged
C-----------------------------------------------------------------------
      INTEGER   NVAR, JVAR(24), IVAR(24), XTYPE(4), IFLAG
      REAL      WIN(4), DMAX, DMIN
      DOUBLE PRECISION    VALVAR(24)

      INTEGER   IBTEMP, IB2T, NCOUNT, I, JV(24), IV(24), II, PNVAR
      REAL      TEMP
      DOUBLE PRECISION    VAL(2,24)
      SAVE TEMP, JV, IV, PNVAR, VAL, NCOUNT
      INCLUDE 'INCS:DMSG.INC'
      DATA NCOUNT, PNVAR /0,0/
C-----------------------------------------------------------------------
      IF (NVAR.NE.PNVAR) NCOUNT = 0
      PNVAR = NVAR
      NCOUNT = NCOUNT + 1
C                                        First time through
      IF (NCOUNT.LE.1) THEN
         TEMP = MAX(DMAX, -DMIN)
         DO 20 I = 1,NVAR
            JV(I) = JVAR(I)
            IV(I) = IVAR(I)
            VAL(2,I)= VALVAR(I)
 20         CONTINUE
C                                        Store next set of values
      ELSE
         DO 40 I = 1,NVAR
            II = MOD(NCOUNT,2) + 1
            VAL(II,I) = VALVAR(I)
 40         CONTINUE
C                                        Make comparisons
         DO 200 I = 1,NVAR
            IBTEMP = XTYPE(IV(I))
            IB2T = JV(I)
            IF (IBTEMP.NE.2) THEN
               IF (IB2T.LE.1) THEN
                  IF (ABS((VAL(1,I)-VAL(2,I)) / TEMP).GT.0.0001D0)
     *               GO TO 210
               ELSE IF (IB2T.NE.6) THEN
                  IF (ABS(VAL(1,I)-VAL(2,I)).GT.0.001D0) GO TO 210
               ELSE
                  IF (ABS(VAL(1,I)-VAL(2,I)).GT.0.0001D0) GO TO 210
                  END IF
            ELSE
               IF ((IB2T.LE.2) .OR. (IB2T.EQ.4)) THEN
                  IF (ABS((VAL(1,I)-VAL(2,I)) / TEMP).GT.0.0001D0)
     *               GO TO 210
               ELSE IF (IB2T.EQ.5) THEN
                  IF (ABS(VAL(1,I)-VAL(2,I)).GT.0.001D0) GO TO 210
               ELSE
                  IF (ABS(VAL(1,I)-VAL(2,I)).GT.0.0001D0) GO TO 210
                  END IF
               END IF
 200        CONTINUE
C                                        Nothing much has changed
         IFLAG = -10
C                                        Check on ridiculous val.
 210     IF (MOD(NCOUNT,10).NE.9) THEN
            DO 300 I = 1,NVAR
               IBTEMP = XTYPE(IV(I))
               IF (IBTEMP.EQ.1) THEN
                  IB2T = JV(I)
C                                        Gaussian
                  IF (IB2T.EQ.1) THEN
                     IF (ABS(VAL(1,I)).GT.5.0*TEMP) GO TO 310
                  ELSE IF (IB2T.EQ.2) THEN
                     IF (VAL(1,I).LE.(WIN(1)-10.0D0) .OR.
     *                  (VAL(1,I).GE.(WIN(3)+10.0D0))) GO TO 310
                  ELSE IF (IB2T.EQ.3) THEN
                     IF (VAL(1,I).LE.(WIN(2)-10.0D0) .OR.
     *                  (VAL(1,I).GE.(WIN(4)+10.0D0))) GO TO 310
                  ELSE IF (IB2T.EQ.4) THEN
                     IF (VAL(1,I).GE.30.0D0) GO TO 310
                  ELSE IF (IB2T.EQ.5) THEN
                     IF (VAL(1,I).GE.30.0D0) GO TO 310
                     END IF
                  END IF
 300           CONTINUE
            GO TO 999
C                                        Bad value
 310        IFLAG = -11
            WRITE (MSGTXT,1310) IV(I), JV(I),VAL(1,I)
            CALL MSGWRT (4)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1310 FORMAT ('STRANGE VALUE FOR COMP=',I2,' PARAM=',I2,' VALUE=',
     *   1PE11.3)
      END
      SUBROUTINE IMFMSG (INFO, MITER)
C-----------------------------------------------------------------------
C   Subroutine IMFMSG writes out the termination messages from LMDER1,
C   the basic fitting routine in IMFIT.
C   INPUTS:
C      INFO     I      Number from LMDER1
C      MITER    I      Number of iterations
C-----------------------------------------------------------------------
      INTEGER   INFO, I, MITER
      INCLUDE 'IMFIT.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      I = INFO + 1
      IF (I.EQ.-8) I = 9
      IF (I.EQ.-9) I = 10
      IF (I.EQ.-10) I = 11
      IF (I.EQ.1) THEN
         WRITE (MSGTXT,1010) MITER
      ELSE IF (I.EQ.2) THEN
         WRITE (MSGTXT,1020) MITER
      ELSE IF (I.EQ.3) THEN
         WRITE (MSGTXT,1030) MITER
      ELSE IF (I.EQ.4) THEN
         WRITE (MSGTXT,1040) MITER
      ELSE IF (I.EQ.5) THEN
         WRITE (MSGTXT,1050) MITER
      ELSE IF (I.EQ.6) THEN
         WRITE (MSGTXT,1060) MITER
      ELSE IF (I.EQ.7) THEN
         WRITE (MSGTXT,1070) MITER
      ELSE IF (I.EQ.8) THEN
         WRITE (MSGTXT,1080) MITER
      ELSE IF (I.EQ.9) THEN
         WRITE (MSGTXT,1090) MITER
      ELSE IF (I.EQ.10) THEN
         WRITE (MSGTXT,1100) MITER
      ELSE IF (I.EQ.11) THEN
         WRITE (MSGTXT,1110) MITER
      ELSE
         WRITE (MSGTXT,1950) MITER
         END IF
      CALL DOPRT
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('IMPROPER INPUT PARAMETERS.  NITER=',I5)
 1020 FORMAT ('Sum of squares is less than tolerance.  niter=',I5)
 1030 FORMAT ('Solution errors is less than tolerance.  niter=',I5)
 1040 FORMAT ('RMS of fit and errors less than tolerance.  niter=',I5)
 1050 FORMAT ('SOLUTION IS SINGULAR; CHECK PARAMETERS.  NITER=',I5)
 1060 FORMAT ('Reached iteration limit in algorithm spec.  niter=',I5)
 1070 FORMAT ('Tolerance is too small-no further reduction.  niter=',
     *   I5)
 1080 FORMAT ('Tolerance is too small for better solution.  niter=',I5)
 1090 FORMAT ('Terminated by niter=',I5)
 1100 FORMAT ('Solution unchanging.  niter=',I5)
 1110 FORMAT ('RIDICULOUS VALUE FOR SOME PARAMETER AT NITER=',I5)
 1950 FORMAT ('INPROPER ERROR CONDITION.  I=',I8)
      END
      SUBROUTINE IMFERR (BUFF, NN, NVAR, VALVAR, FVEC, FJAC, IER)
C-----------------------------------------------------------------------
C   IMFERR is a subroutine of IMFIT which determines the parameter
C   errors for the fit.
C   INPUTS:
C      BUFF     R(*)       Original data
C      NVAR     I          Number of independent variables
C      NN       I          Number of data points
C      VALVAR   D(24)      The parameter values
C      FVEC     D(*)       The residual data
C      FJAC     D(24,24)   Jacobian array for FCN
C   OUTPUTS:
C      IER      I          Error return  0-> okay
C                              1-> error
C-----------------------------------------------------------------------
      REAL      BUFF(*)
      INTEGER   NN, NVAR, IER
      DOUBLE PRECISION FJAC(24,24), FVEC(*), VALVAR(24)
C
      INTEGER   IERR, IBTEMP, INN, INVAR, NLO, NHI, NK, I, II, J, K1,
     *   K2, K3, K4
      REAL      SUM2, RMS, CBAREA, TEMP, RM(3), DIFF, ERR, CURV, NIND,
     *   NW(4), CNST
      INCLUDE 'IMFIT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                        Initialization
      IER = 0
      IF (NVAR.LE.0) THEN
         WRITE (MSGTXT,1000)
         CALL DOPRT
         GO TO 615
         END IF
      CNST = 3.14159265 / 180.0
      SUM2 = 0.0
      NIND = 1.0
      CBAREA = CB(1) * CB(2)
      IF (CBAREA.LT.0.5) CBAREA = ABS (G(4,1)*G(5,1))
      IF (CBAREA.GT.25.) CBAREA = 25.0
C                                        Find RMS residual
      NK = 0
      DO 20 I = 1,NPTS
         IF (DATA(I).NE.FBLANK) THEN
            NK = NK + 1
            SUM2 = SUM2 + DATA(I)*DATA(I)
            END IF
 20      CONTINUE
      IF (NK.LT.2) THEN
         WRITE (MSGTXT,1020) NK
         GO TO 900
         END IF
      RMS = SQRT (SUM2 / NK)
C                                        Check scale factor
      WRITE (MSGTXT,1030) RMS
      CALL DOPRT
      WRITE (MSGTXT,1034)
      CALL DOPRT
C                                        Get approximate
C                                        component errors
      TEMP = NVAR
C      RMS = RMS * SQRT(TEMP)
      CALL RFILL (24, 0.0, E)
      DO 400 II = 1,NVAR
         I = IVAR(II)
         J = JVAR(II)
         IBTEMP = XTYPE(I)
C                                        Gaussian fit
         IF (IBTEMP.EQ.1) THEN
            TEMP = ABS (G(1,I))
            IF (J.EQ.1) THEN
               E(1,I) = RMS * 2.0
            ELSE IF (J.EQ.2) THEN
               E(2,I) = RMS / TEMP / 1.5 * G(4,I)
               IF (E(2,I).GT.G(4,I)) E(2,I) = G(4,I)
            ELSE IF (J.EQ.3) THEN
               E(3,I) = RMS / TEMP / 1.5 * G(4,I)
               IF (E(3,I).GT.G(4,I)) E(3,I) = G(4,I)
            ELSE IF (J.EQ.4) THEN
               E(4,I) = RMS / TEMP / 1.5 * G(4,I)
               IF (E(4,I).GT.G(4,I)) E(4,I) = G(4,I)
            ELSE IF (J.EQ.5) THEN
               E(5,I) = RMS / TEMP / 1.5 * G(5,I)
               IF (E(5,I).GT.G(5,I)) E(5,I) = G(5,I)
            ELSE IF (J.EQ.6) THEN
               E(6,I) = (E(4,I)/G(4,I) + E(5,I)/G(5,I))
               IF (E(6,I).GT.1.5) E(6,I) = 1.5
               END IF
C                                        Background fit
         ELSE IF (IBTEMP.EQ.2) THEN
            IF (J.EQ.1) THEN
               E(1,I) = RMS
            ELSE IF (J.EQ.2) THEN
               E(2,I) = RMS
            ELSE IF (J.EQ.3) THEN
               E(3,I) = RMS / ABS (G(2,I))
               IF (E(3,I).GT.0.7)  E(3,I) = 0.7
            ELSE IF (J.EQ.4) THEN
               E(4,I) = RMS
            ELSE IF (J.EQ.5) THEN
               E(5,I) = RMS / ABS (G(4,I))
               IF (E(5,I).GT.1.0) E(5,I) = 1.0
            ELSE IF (J.EQ.6) THEN
               E(6,I) = RMS / ABS (G(4,I))
               IF (E(6,I).GT.0.7) E(6,I) = 0.7
               END IF
            END IF
 400     CONTINUE
C                                        Store original data
      DO 410 K1 = 1,NPTS
         DATA(K1) = BUFF(K1)
 410     CONTINUE
C                                        Get more accurate errors
      DO 600 II = 1,NVAR
         I = IVAR(II)
         J = JVAR(II)
C                                        Set variable value for loop
 420     VALVAR(II) = VALVAR(II) - 2*E(J,I)
C                                        Find relevant area
C                                        Gaussian
         IF (XTYPE(I).EQ.1) THEN
            TEMP = 0.75 * MAX (ABS (G(4,I)), ABS (G(5,I)))
            IF (TEMP.GT.100.0) TEMP = 100.0
            NW(1) = G(2,I) - TEMP
            NW(2) = G(3,I) - TEMP
            NW(3) = G(2,I) + TEMP
            NW(4) = G(3,I) + TEMP
            IF (NW(1).LT.WIN(1)) NW(1) = WIN(1)
            IF (NW(2).LT.WIN(2)) NW(2) = WIN(2)
            IF (NW(3).GT.WIN(3)) NW(3) = WIN(3)
            IF (NW(4).GT.WIN(4)) NW(4) = WIN(4)
            NLO = 1 + NX*(NW(2) - WIN(2)) + NW(1) - WIN(1)
            NHI = NPTS - NX*(WIN(4) - NW(4)) - NW(3) + WIN(3)
C                                        Baseline
         ELSE
            NLO = 1
            NHI = NPTS
            END IF
C                                        Find RMS
         IF (NIND.LT.1.0) NIND = 1.0
         K4 = 0
         DO 490 K2 = 1,3
C                                        Change values
            VALVAR(II) = VALVAR(II) + E(J,I)
            INN = NN
            INVAR = NVAR
            CALL FCN (INN, INVAR, VALVAR, FVEC, FJAC, 0)
            SUM2 = 0.
            NK = 0.
C                                        Find the RMS
            DO 480 K3 = 1,NPTS
               IF (DATA(K3).NE.FBLANK) THEN
                  NK = NK + 1
                  IF ((K3.GE.NLO) .AND. (K3.LE.NHI)) SUM2 = SUM2 +
     *               FVEC(NK)*FVEC(NK)
                  END IF
 480           CONTINUE
            IF (NK.LE.1) THEN
               WRITE (MSGTXT,1020) NK
               GO TO 900
               END IF
            RM(K2) = SQRT (SUM2 / NK)
 490        CONTINUE
         VALVAR(II) = VALVAR(II) - E(J,I)
C                                        Find RMS well
         CALL IMFSOL (RM, DIFF, ERR, CURV, IERR)
         IF (IERR.NE.0) THEN
            DIFF = 0.0
            ERR = 0.0
            CURV = 1.0E-10
            WRITE (MSGTXT,1490) I, J
            CALL DOPRT
            GO TO 500
            END IF
C                                        Get value at RMS minimum
         IF (DIFF.GT.1.5) DIFF = 1.50
         IF (DIFF.LT.-1.5) DIFF = -1.50
         VALVAR(II) = VALVAR(II) + DIFF * E(J,I)
C                                        Too far from minimum
         K4 = K4 + 1
         IF (K4.GE.5) THEN
            DIFF = 0.0
            ERR = 0.0
            CURV = 1.0E-10
            WRITE (MSGTXT,1490) I, J
            CALL DOPRT
            GO TO 500
            END IF
         IF (ABS(DIFF).GE.1.50) GO TO 420
C                                        What is error?
 500     NIND = 4.0 * NK / CBAREA
         DIFF = ERR / NIND
         E(J,I) = SQRT (DIFF/CURV) * E(J,I)
 600     CONTINUE
C                                        Get residual data
      DO 610 I=1,NPTS
         DATA(I) = BUFF(I)
 610     CONTINUE
 615  INN = NN
      INVAR = NVAR
      CALL FCN (INN, INVAR, VALVAR, FVEC, FJAC, 0)
      NK = 0
      SUM2 = 0.0
      DO 620 I = 1,NPTS
         IF (DATA(I).EQ.FBLANK) GO TO 620
            NK = NK+1
            SUM2 = SUM2 + FVEC(NK) * FVEC(NK)
            DATA(I) = -FVEC(NK)
 620     CONTINUE
C                                        Final RMS
      ERR = SQRT (SUM2 / NK)
      WRITE (MSGTXT,1600) ERR
      CALL DOPRT
      GO TO 999
C                                        Error return
 900  IER = 1
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('NO PARAMETER TO FIT.  WILL SUBTRACT MODEL FROM DATA')
 1020 FORMAT ('TOO FEW POINTS FOR RMS.  #=',I3)
 1030 FORMAT ('******  RMS of fit=',1PE12.4,' per point  ******')
 1034 FORMAT ('Begin tweaking each parameter')
 1490 FORMAT ('ERROR FOR COMP',I2,' VARIABLE',I2,' UNDEFINED')
 1600 FORMAT ('******  New RMS of fit=',1PE12.4,' per point  ******')
      END
      SUBROUTINE IMFSTO (IER)
C-----------------------------------------------------------------------
C   IMFSTO, a subroutine of IMFIT, creates, opens and stores the
C   residual map after fitting.
C   Outputs:
C      IER             I        Error return  0-> okay
C                                  1-> error
C-----------------------------------------------------------------------
      HOLLERITH MA(2), HOH(256)
      INTEGER   IER, IERR, J, I1, I
      REAL      HOR(256), MAX, MIN, RRMAX, RRMIN
      DOUBLE PRECISION    HOD(128)
      INCLUDE 'IMFIT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (HOI, HOR, HOD, HOH)
C-----------------------------------------------------------------------
C                                       Initialize
      IER = 0
      CALL COPY (256, CATBLK, HOI)
C                                       Fill in outname
      CALL CHR2H (4, 'MA  ', 1, MA)
      CALL H2WAWA (XON, XOC, XOS, MA, XOD, XU, OUTNA)
C                                       Fill in header values
      HOI(KINAX) = NX
      HOI(KINAX+1) = NY
      HOI(KINAX+2) = 1
      HOI(KINAX+3) = 1
      HOI(KINAX+4) = 1
      HOI(KINAX+5) = 1
      HOI(KINAX+6) = 1
      HOR(KRCRP) = CATR(KRCRP) - WIN(1) + 1.0
      HOR(KRCRP+1) = CATR(KRCRP+1) - WIN(2) + 1.0
      HOR(KRCRP+2) = CATR(KRCRP+2) - DEPTH(1) + 1.0
      HOR(KRCRP+3) = CATR(KRCRP+3) - DEPTH(2) + 1.0
      HOR(KRCRP+4) = CATR(KRCRP+4) - DEPTH(3) + 1.0
      HOR(KRCRP+5) = CATR(KRCRP+5) - DEPTH(4) + 1.0
      HOR(KRCRP+6) = CATR(KRCRP+6) - DEPTH(5) + 1.0
      CALL CATCLR (HOI)
C                                       Create map
      CALL MAPCR (INNA, OUTNA, HOI, IERR)
      IF (IERR.EQ.0) GO TO 60
         WRITE (MSGTXT,1050) IERR
         GO TO 900
C                                       Open map
 60   CALL OPENCF (LUN1, OUTNA, IERR)
      IF (IERR.EQ.0) GO TO 70
         WRITE (MSGTXT,1060) IERR
         GO TO 900
C                                       Write data line by line
 70   RRMAX = -1.E20
      RRMIN = -RRMAX
      DO 80 J = 1,NY
         I1 = (J-1) * NX
         DO 75 I = 1,NX
            I1 = I1 + 1
            IF (DATA(I1).EQ.FBLANK) GO TO 75
               RRMAX = MAX (RRMAX, DATA(I1))
               RRMIN = MIN (RRMIN, DATA(I1))
 75         CONTINUE
         I1 = (J-1) * NX + 1
         CALL MAPIO ('WRIT', LUN1, DATA(I1), IERR)
         IF (IERR.EQ.0) GO TO 80
            WRITE (MSGTXT,1070) J, IERR
            GO TO 900
 80      CONTINUE
C                                        Get HI files
      OUTSL = FILTAB(POCAT,6)
      XOD = FILTAB(POVOL,6)
      CALL H2WAWA (XON, XOC, XOS, MA, XOD, XU, OUTNA)
      HOR(KRDMX) = RRMAX
      HOR(KRDMN) = RRMIN
      CALL FILCLS (LUN1)
      CALL IMFHI (IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1080) IERR
         CALL MSGWRT (8)
         GO TO 999
C                                       Error return
 900  IER = 1
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('IMFSTO: COULD NOT CREATE MAP.  IER=',I7)
 1060 FORMAT ('IMFSTO: COULD NOT OPEN MAP.  IER=',I7)
 1070 FORMAT ('IMFSTO: WRITE ERROR LINE ',I6,'  IER=',I7)
 1080 FORMAT ('IMFSTO: HI FILE GENERATION ERROR.  IER=',I7)
      END
      SUBROUTINE IMFSOL (RM, DIFF, ERR, CURV, IER)
C-----------------------------------------------------------------------
C   IMFSOL calculates the best first parabola through three points of
C   value RM(1), RM(2), and RM(3); located at -1, 0 and +1.  DIFF is
C   the location of the minimum; ERR is the values at the minimum; CURV
C   is the curvature (rms units/unit) of the fit.  This subroutine is
C   used with IMFERR and IMFIT.
C   INPUTS:
C      RM(3)         R     The input triad of points
C   OUTPUTS:
C      DIFF          R     Location of minimum
C      ERR           R     Value of RM at minimum
C      CURV          R     The curvature
C      IER           I     Error return
C-----------------------------------------------------------------------
      INTEGER   IER
      REAL   RM(3), DIFF, ERR, CURV
      REAL   TEMP
C-----------------------------------------------------------------------
      IER = 0
      TEMP = RM(1) - 2.0*RM(2) + RM(3)
      IF (TEMP.LE.0.0) GO TO 950
         DIFF = 0.5 * (RM(1) - RM(3)) / TEMP
         ERR = RM(2) - 0.125*(RM(1) - RM(3))**2 / TEMP
         CURV = 0.5 * TEMP
         GO TO 999
C                                        Error return
 950  IER = 1
C
 999  RETURN
      END
      SUBROUTINE IMFHI (IER)
C-----------------------------------------------------------------------
C   IMFHI creates and writes the HI file for the task IMFIT.
C   Outputs:
C      IER            I     Error return  0->okay
C                             1->uh-oh
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6, HILINE*72, MODEL(3)*8, CNAME*12, CCLAS*6,
     *   CTYP*2, ONAME*12, OCLAS*6
      INTEGER   IER, IERR, NHISTF, LHIN, LHOUT, IVOL, OVOL, IBTEMP
      INTEGER   IBUFF1(256), IBUFF2(256), INSEQ, OSEQ, CUSEID,
     *   ITEMP(7), I, J
      LOGICAL   T
      INCLUDE 'IMFIT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      DATA NHISTF, LHIN, LHOUT /2,27,28/
      DATA T /.TRUE./
      DATA PRGNAM /'IMFIT '/
      DATA MODEL /'Gaussian','Baseline','????????'/
C-----------------------------------------------------------------------
C                                       Initialize HI
      CALL HIINIT (NHISTF)
      IER = 0
C                                       Create and open output HI file
      CALL WAWA2A (OUTNA, ONAME, OCLAS, OSEQ, CTYP, OVOL, CUSEID)
      CALL WAWA2A (INNA, CNAME, CCLAS, INSEQ, CTYP, IVOL, CUSEID)
C                                       copy keywords
      CALL KEYPCP (IVOL, INSL, OVOL, OUTSL, 0, ' ', IERR)
C                                       copy HI
      CALL HISCOP (LHIN, LHOUT, IVOL, OVOL, INSL, OUTSL, HOI,
     *   IBUFF1, IBUFF2, IERR)
      IF (IERR.LE.2) GO TO 50
         WRITE (MSGTXT,1000) IERR
         GO TO 900
C                                       Add new HI entries
C                                       Input name
 50   CALL HENCO1 (PRGNAM, CNAME, CCLAS, INSEQ, IVOL, LHOUT,
     *   IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Output name
      CALL HENCOO (PRGNAM, ONAME, OCLAS, OSEQ, OVOL, LHOUT,
     *   IBUFF2, IERR)
      IF (IERR.NE.0) GO TO 900
C                                        Rest of inputs
      DO 60 I = 1,7
         ITEMP(I) = XBL(I) + 0.5
 60      CONTINUE
      WRITE (HILINE,1060) PRGNAM, ITEMP
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      DO 70 I = 1,7
         ITEMP(I) = XTR(I) + 0.5
 70      CONTINUE
      WRITE (HILINE,1070) PRGNAM, ITEMP
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      WRITE (HILINE,1072) PRGNAM, NGAUSS, (XTYPE(I), I = 1,NGAUSS)
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      WRITE (HILINE,1074) PRGNAM, (GM(I), I = 1,NGAUSS)
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      WRITE (HILINE,1076) PRGNAM, ((GP(J,I), J = 1,2),
     *   I = 1,NGAUSS)
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      WRITE (HILINE,1078) PRGNAM, ((GW(J,I), J = 1,3),
     *   I = 1,NGAUSS)
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      WRITE (HILINE,1080) PRGNAM, NITER
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      WRITE (HILINE,1082) PRGNAM, (XDM(I), I = 1,NGAUSS)
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      WRITE (HILINE,1084) PRGNAM, ((XDP(J,I), J = 1,2),
     *   I = 1,NGAUSS)
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      WRITE (HILINE,1086) PRGNAM, ((XDW(J,I), J = 1,3),
     *   I = 1,NGAUSS)
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      WRITE (HILINE,1088) PRGNAM, XCRT, XDOO
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      WRITE (HILINE,1090) PRGNAM, XOFS
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
C                                        Solution
      WRITE (HILINE,1100) PRGNAM
      CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
      DO 250 I = 1,NGAUSS
         WRITE (HILINE,1105) PRGNAM, MODEL(XTYPE(I))
         CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
         IBTEMP = XTYPE(I)
         GO TO (110, 170), IBTEMP
C                                        Gaussian
 110        WRITE (HILINE,1110) PRGNAM, G(1,I), E(1,I)
            CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
            WRITE (HILINE,1112) PRGNAM, (G(J,I), E(J,I), J = 2,3)
            CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
            WRITE (HILINE,1114) PRGNAM, (G(J,I), E(J,I), J = 4,6)
            CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
            GO TO 250
C                                        Baseline
 170        WRITE (HILINE,1170) PRGNAM, G(1,I), E(1,I)
            CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
            WRITE (HILINE,1172) PRGNAM, (G(J,I), E(J,I), J = 2,3)
            CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
            WRITE (HILINE,1174) PRGNAM, (G(J,I), E(J,I), J = 4,5)
            CALL HIADD (LHOUT, HILINE, IBUFF2, IERR)
            WRITE (HILINE,1176) PRGNAM, G(6,I), E(6,I)
            GO TO 250
 250     CONTINUE
      GO TO 950
C
 900  IER = 1
      CALL MSGWRT (8)
C                                       Close HI file
 950  CALL HICLOS (LHOUT, T, IBUFF2, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CANNOT COPY HI FILE.  IER=',I8)
 1060 FORMAT (A6,'BLC=',7I6)
 1070 FORMAT (A6,'TRC=',7I6)
 1072 FORMAT (A6,'NGAUSS=',I3,',  CTYPE=',4(I3,','))
 1074 FORMAT (A6,'GMAX=',4(1PE11.4,','))
 1076 FORMAT (A6,'GPOS=',4(F6.2,',',F6.2,','))
 1078 FORMAT (A6,'GWID=',4(F4.1,',',F4.1,',',F4.1,','))
 1080 FORMAT (A6,'NITER=',I5)
 1082 FORMAT (A6,'DOMAX=',4F4.1)
 1084 FORMAT (A6,'DOPOS=',8F4.1)
 1086 FORMAT (A6,'DOWID=',12F4.1)
 1088 FORMAT (A6,'DOVECT=',F4.1,',  DOCAT=',F4.1)
 1090 FORMAT (A6,'OFFSET=',F5.2)
 1100 FORMAT (A6,'/Solution')
 1105 FORMAT (A6,'Model type= ',A8)
 1110 FORMAT (A6,'PEAK=',1PE13.3,',',1PE12.3)
 1112 FORMAT (A6,'POS=',F6.2,F5.2,',',F6.2,F5.2)
 1114 FORMAT (A6,'SIZE=',3(F6.1,',',F6.1,4X))
 1170 FORMAT (A6,'ZERO LEVEL=',1PE13.3,',',1PE12.3)
 1172 FORMAT (A6,'SLOPE=',1PE13.3,',',1PE12.2,' ANGLE=',0PF6.1,',',
     *   F5.1)
 1174 FORMAT (A6,'CURV=',1PE13.3,',',1PE12.3,'  ECCEN=',0PF6.4,',',
     *   F5.4)
 1176 FORMAT (A6,'ANGLE OF CURV=',F6.1,',',F5.1)
      END
      SUBROUTINE IMFOUT (RSTO, DOMODL, IER)
C-----------------------------------------------------------------------
C   IMFOUT is a subroutine of IMFIT which prints out the parameter
C   solutions and converts them into useful coordinates.
C   Inputs:
C      RSTO       R         > 0 => write a CC file, > 1.5 use convolved
C                              components, not deconvolved
C      DOMODL     R         Add a CC file also to input image
C   Outputs:
C      IER        I         Error return  0-> okay, 1-> error
C-----------------------------------------------------------------------
      CHARACTER RSTR(2)*20, DUM*12, WORD(3)*8, MODEL(3)*8, CNAME*12,
     *   CCLAS*6, CCTYP*2, CUNIT*8, AXIS*8, FUNIT*8, KEYWRD*8, ARRAY*8,
     *   CAX(3)*14, STRING*24, TUNIT*8
      REAL      TEMP, PASUM, DOMODL, DCONV(3,3), RSTO, RECORD(7),
     *   RICORD(7), CAXINC(2), INT, XXT, YYT, BMAJS, BMINS, BPAS, COSC,
     *   SINC, ERRINT, LN, A, X0, Y0, IMAJ, IMIN, FI, BMAJ, BMIN, RINC,
     *   ARBEAM, ARIMAG, ERRA, FRERRA, ERRMAJ, ERRMIN, ERRFI, ERRX0,
     *   ERRY0, ERRMAS, ERRMIS, ERRAA, XCONV(3,3), RTITLE(8), DX, DY,
     *   SMCB(3), BMFACT, DLFACT, ARHEAD, STWID(3), RDUM, R, XYSH(2),
     *   CORA, CORINT, CORINE, SNR
      HOLLERITH HTITLE(8)
      DOUBLE PRECISION    X(3), XX, YY, ZZ, LAMBDA, XD, STXY(2), DEC1
      LOGICAL   DOCC, CRIT1, CRIT2, SESTAT, OUTSID
      INTEGER   IER, I2TMP, CCLUN, CCVOL, CCVER, CILUN, CIVOL, IROUND,
     *   CIVER, SCRBUF(256), IRNO, IERR, I, J, IBTEMP, MFBUF(512),
     *   MFRNO, ITITLE(8), CSEQ, MFLUN,CUSEID, K, ILEN, STBUF(512),
     *   STKOLS(7), STNUMV(7), STTYPE, STVER, LUNTMP, STLUN, ISTRNO,
     *   RPT, PLANE
      INCLUDE 'INCS:PMFC.INC'
      REAL      ROW(NUMCOL)
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   CCBUFF(512), CIBUFF(512), CCRNO, CIRNO, CCNCOL, CCTYPE,
     *   CCKOLS(MAXCCC), CCNUMV(MAXCCC)
      REAL      CCX, CCY, CCZ, FLUX, PARMS(3)
      INCLUDE 'IMFIT.INC'
      INCLUDE 'ORFIT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (HTITLE, ITITLE, RTITLE)
      DATA WORD /'Major ax','Minor ax','Pos ang '/
      DATA MODEL /'Gaussian','Baseline','????????'/
      DATA CAX /'Major axis','Minor axis','Position angle'/
C-----------------------------------------------------------------------
C                                        Initialization
      IER = 0
      PASUM = 90.0
      CALL H2CHR (8, 1, CATH(KHBUN), CUNIT)
      CALL H2CHR (8, 1, CATH(KHTEL), ARRAY)
      TUNIT = CUNIT
      CALL CHLTOU (8, TUNIT)
      FUNIT = CUNIT
      IF (TUNIT.EQ.'JY/BEAM') FUNIT = 'JANSKYS'
      IF (CUNIT.EQ.'Jy/beam') FUNIT = 'Janskys'
      CALL RFILL (NUMCOL, 0.0, ROW)
      PLANE = 1
      SESTAT = .FALSE.
      CALL FNDEXT ('ST', INBLK, I)
      STVER = -1
      IF (XSTVER.GE.0.0) THEN
         STVER = XSTVER + 0.5
         IF ((STVER.EQ.0) .OR. (STVER.GT.I)) STVER = I + 1
         STLUN = LUNTMP (1)
         CALL STINI ('WRITE', STBUF, INVOL, INSL, STVER, INBLK, STLUN,
     *      ISTRNO, STKOLS, STNUMV, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'CANNOT OPEN ST FILE FOR OUTPUT'
            CALL MSGWRT (7)
            STVER = -1
         ELSE
            WRITE (MSGTXT,1001) 'ST', STVER
            CALL MSGWRT (4)
            END IF
         STTYPE = 3
         END IF
C                                       find frequency
      IF (XFREQ.GT.0.0D0) THEN
         LAMBDA = VELITE / XFREQ
      ELSE
         PBPARM(1) = 0.0
         END IF
C                                       Create CC files
      DOCC = (RSTO.GT.0.0) .OR. (DOMODL.GT.0.0)
      IF ((DOCC) .OR. (OUTVER.GE.0)) THEN
         MFLUN = 29
         CCLUN = 28
         CILUN = 27
         CALL WAWA2A (INNA, CNAME, CCLAS, CSEQ, CCTYP, CIVOL, CUSEID)
         CALL WAWA2A (OUTNA, CNAME, CCLAS, CSEQ, CCTYP, CCVOL, CUSEID)
         CCNCOL = 7
         CCVER = 0
         CIVER = 0
         IF (RSTO.GT.0.0) THEN
            CALL CCMINI ('WRIT', CCBUFF, CCVOL, OUTSL, CCVER, HOI,
     *         CCLUN, CCRNO, CCKOLS, CCNUMV, CCNCOL, IERR)
            IF (IERR.NE.0) THEN
               RSTO = -1.0
            ELSE
               WRITE (MSGTXT,1000) CCVER
               CALL MSGWRT (4)
               END IF
            END IF
         END IF
      IF (.NOT.DOCC) DOMODL = -1.0
C                                       Open with input image
      IF ((DOMODL.GT.0.0) .OR. (OUTVER.GE.0)) THEN
         CALL CATIO ('READ', CIVOL, INSL, CATBLK, 'WRIT', SCRBUF, IERR)
         IF (IERR.EQ.0) THEN
            SESTAT = .TRUE.
            IF (DOMODL.GT.0.0) THEN
               CALL CCMINI ('WRIT', CIBUFF, CIVOL, INSL, CIVER, CATBLK,
     *            CILUN, CIRNO, CCKOLS, CCNUMV, CCNCOL, IERR)
               IF (IERR.NE.0) THEN
                  DOMODL = -1.0
               ELSE
                  WRITE (MSGTXT,1001) 'CC', CIVER
                  CALL MSGWRT (4)
                  END IF
               END IF
            IF (OUTVER.GE.0) THEN
C                                       get plane number
               PLANE = 1
               IF (CATBLK(KIDIM).GE.7) PLANE = MAX (DEPTH(5), 1)
               IF (CATBLK(KIDIM).GE.6) PLANE = MAX (DEPTH(4), 1) +
     *            (PLANE-1) * MAX (CATBLK(KINAX+5), 1)
               IF (CATBLK(KIDIM).GE.5) PLANE = MAX (DEPTH(3), 1) +
     *            (PLANE-1) * MAX (CATBLK(KINAX+4), 1)
               IF (CATBLK(KIDIM).GE.4) PLANE = MAX (DEPTH(2), 1) +
     *            (PLANE-1) * MAX (CATBLK(KINAX+3), 1)
               IF (CATBLK(KIDIM).GE.3) PLANE = MAX (DEPTH(1), 1) +
     *            (PLANE-1) * MAX (CATBLK(KINAX+2), 1)
               CALL MFINI (MFLUN, CIVOL, INSL, DEPTH, PLANE, OUTVER,
     *            CATBLK, MFBUF, IERR)
               IF (IERR.GT.0) THEN
                  OUTVER = -1
               ELSE
                  MFRNO = MFBUF(5)
                  WRITE (MSGTXT,1001) 'MF', OUTVER
                  CALL MSGWRT (4)
C                                       Update the Keyword
                  KEYWRD = 'REALRMS'
                  CALL CHR2H (8, KEYWRD, 1, HTITLE)
                  RTITLE(3) = ACTRMS
                  ITITLE(4) = 0
                  ITITLE(5) = 2
                  CALL TABIO ('WRIT', 5, 7, HTITLE, MFBUF, IERR)
                  IF (IERR.NE.0) OUTVER = -1
                  END IF
               END IF
            END IF
         END IF
C
      IF (DOCRT.GT.-2.5) THEN
         MSGTXT = ' '
         CALL DOPRT
         END IF
      WRITE (MSGTXT,1005)
      CALL DOPRT
      WRITE (MSGTXT,1010) ACTRMS, CUNIT
      CALL DOPRT
      IF (DOCRT.GT.-2.5) THEN
         MSGTXT = ' '
         CALL DOPRT
         END IF
      ROW(COLPLN) = PLANE
      ROW(CORRMS) = SUMSQ
      ROW(CORPEK) = RESMAX
      ROW(CORFLX) = RESSUM
      IRNO = 0
      DO 800 I = 1,NGAUSS
         DO 10 J = 1,6
            E(J,I) = ABS (E(J,I))
 10         CONTINUE
         IBTEMP = XTYPE(I)
         GO TO (15, 215, 415), IBTEMP
C                                        GAUSSIAN COMPONENT
C                                        First, scale amplitude
 15      RECORD(1) = G(1,I)
         E(1,I) = ABS (E(1,I))
C                                       MF out
         MFRNO = MFRNO + 1
         IF (.NOT.NWIDTH(I)) ROW(COLTYP) = 1.0
C                                        Fix diameters
         G(6,I) = G(6,I)/DG2RAD + PASUM
         E(6,I) = E(6,I)/DG2RAD
         G(4,I) = ABS (G(4,I))
         G(5,I) = ABS (G(5,I))
         IF (G(4,I).GE.G(5,I)) GO TO 20
            TEMP = G(5,I)
            G(5,I) = G(4,I)
            G(4,I) = TEMP
            G(6,I) = G(6,I) - 90.0
 20      IF (G(6,I).LE.180.0) GO TO 30
            G(6,I) = G(6,I) - 180.0
            GO TO 20
 30      IF (G(6,I).GT.0.0) GO TO 40
            G(6,I) = G(6,I) + 180.0
            GO TO 30
C                                        Print out header
 40      WRITE (MSGTXT,1042) I, MODEL(XTYPE(I))
         CALL DOPRT
C                                       implement better designation fo
C                                       the fitting parameters
         A = G(1,I)
         CORA = A
         X0 = G(2,I)
         Y0 = G(3,I)
         IMAJ = G(4,I)
         IMIN = G(5,I)
         FI = G(6,I)
         BMAJ = CB(1)
         BMIN = CB(2)
         ARBEAM = BMAJ*BMIN
         ARHEAD = HCBP(1)*HCBP(2)
         IF (ARHEAD.LE.0.0) ARHEAD = ARBEAM
         ARIMAG = IMAJ*IMIN
         CRIT1 = ARBEAM .LT. 0.1*ARIMAG
         CRIT2 = ARBEAM .GT. 0.9*ARIMAG
         LN = SQRT (8 * ALOG (2.0))
         RPT = 4
C                                       FSHIFT output
         IF ((I.EQ.1) .AND. (AXTYP(LOCNUM).EQ.1)) THEN
            FSHIFT(1) = (X0 - IROUND (X0)) * AXINC(1,LOCNUM)*3600.
            FSHIFT(2) = (Y0 - IROUND (Y0)) * AXINC(2,LOCNUM)*3600.
            DEC1 = RPVAL(3-CORTYP(LOCNUM),LOCNUM)
            XYSH(1) = CATR(KRXSH) * COS(DG2RAD*DEC1) * 3600.
            XYSH(2) = CATR(KRYSH) * 3600.
            IF (ABS(ROT(LOCNUM)).GT.1.E-3) THEN
               R = ROT(LOCNUM) * DG2RAD
               RDUM = XYSH(1)
               XYSH(1) = RDUM * COS(R) + XYSH(2) * SIN(R)
               XYSH(2) = XYSH(2) * COS(R) - RDUM * SIN(R)
               END IF
            FSHIFT(1) = XYSH(1) + FSHIFT(1)
            FSHIFT(2) = XYSH(2) + FSHIFT(2)
            END IF
C                                       Implement the error analysis of
C                                       J. Condon, 'Errors in elliptical
C                                       gausian fits', AJ, 1996
C                                       fitted gaussian is much wider
C                                       than beam size
         IF (CRIT1) THEN
            ERRA = 2.0 * ACTRMS
            IF ((ARIMAG.GT.0.0) .AND. (ARBEAM.GT.0.0)) ERRA =
     *         SQRT (8.0*ARBEAM/ARIMAG) * ACTRMS
C                                       fitted gaussian near beam size.
         ELSE IF (CRIT2) THEN
            ERRA = ACTRMS
C                                       The source is partially
C                                       resolved. The errors formulas
C                                       are not garanteed correct!!!
         ELSE
            ERRA = 2.0 * ACTRMS
            IF ((ARIMAG.GT.0.0) .AND. (ARBEAM.GT.0.0)) ERRA =
     *         SQRT (0.8 + (0.2/0.8)*(ARBEAM/ARIMAG-0.1)) * ACTRMS
            END IF
         ORA(I) = A
         ORERRA(I) = ERRA
         FRERRA = 1
         IF (A.NE.0.0) FRERRA = ABS (ERRA / A)
         ERRMAJ = ABS (IMAJ * FRERRA)
         ERRMIN = ABS (IMIN * FRERRA)
         ERRFI = SQRT (2.0) * (IMAJ*IMIN) / MAX (1.E-6, IMAJ**2-IMIN**2)
     *      * FRERRA * RAD2DG
         ERRFI = MIN (360.0, ABS(ERRFI))
         ORERFI(I) = ERRFI
         COSC = COS (DG2RAD * FI)
         SINC = SIN (DG2RAD * FI)
C                                       SINC&COSC switch because
C                                       the angle is measured from Y
         ERRX0 = SQRT ((ERRMAJ*SINC)**2 + (ERRMIN*COSC)**2) / LN
         ERRY0 = SQRT ((ERRMAJ*COSC)**2 + (ERRMIN*SINC)**2) / LN
C                                        Amplitude
         ERRAA = ERRA
         ROW(COLPEK) = RECORD(1)
         ROW(COEPEK) = ERRAA
         FGM(I) = A
         IF (XDM(I).GT.0.0) FDM(I) = ERRAA
         IF (((ARHEAD/ARBEAM.LT.0.99) .OR. (ARHEAD/ARBEAM.GT.1.01))
     *      .AND. (TUNIT.EQ.'JY/BEAM')) THEN
            WRITE (MSGTXT,1144) A, ERRAA
            CALL DOPRT
            WRITE (MSGTXT,1145) A*ARBEAM/ARHEAD, ERRAA*ARBEAM/ARHEAD
            CALL DOPRT
         ELSE
            SNR = 0.0
            IF (ERRAA.GT.0.0) SNR = MIN (999.0, A/ERRAA)
            WRITE (MSGTXT,1044) A, ERRAA, CUNIT, SNR
            CALL DOPRT
            END IF
C                                       Radius
         BMFACT = 1.0
         DLFACT = 1.0
         XD = 0.0D0
         IF (((CORTYP(LOCNUM).EQ.1) .OR. (CORTYP(LOCNUM).EQ.2)) .AND.
     *      ((PBPARM(1).GT.0.0) .OR. (BWS.GT.0.0))) THEN
            CALL XYVAL (G(2,I), G(3,I), X(1), X(2), X(3), IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1051) IERR, I
               CALL MSGWRT (7)
               XD = 0.0D0
            ELSE IF (CORTYP(LOCNUM).EQ.1) THEN
               XD = SIN (DG2RAD*X(2)) * SIN (DG2RAD*XDEC) +
     *           COS (DG2RAD*X(2)) * COS (DG2RAD*XDEC) *
     *           COS (DG2RAD * (X(1) - XRA))
            ELSE
               XD = SIN (DG2RAD*X(1)) * SIN (DG2RAD*XDEC) +
     *           COS (DG2RAD*X(1)) * COS (DG2RAD*XDEC) *
     *           COS (DG2RAD * (X(2) - XRA))
               END IF
            IF (XD.GT.1.0D0) THEN
               XD = 0.0D0
            ELSE
               XD = RAD2DG * ACOS (XD)
               END IF
            END IF
C                                       primary beam
         IF (((CORTYP(LOCNUM).EQ.1) .OR. (CORTYP(LOCNUM).EQ.2)) .AND.
     *      (PBPARM(1).GT.0.0)) THEN
            CALL PBCALC (XD, LAMBDA, ARRAY, PBPARM(2), BMFACT, OUTSID)
            BMFACT = MAX (BMFACT, PBPARM(1))
            IF (OUTSID) BMFACT = PBPARM(1)
            END IF
C                                       BW smearing here
         IF ((CB(1).GT.0.0) .AND. (BWS.GT.0.0)) THEN
            DX = G(2,I) - XCEN
            DY = G(3,I) - YCEN
            CALL BWSMCB (DX, DY, XD, BWS, CB, SMCB)
            DLFACT = SMCB(1) * SMCB(2) / (CB(1) * CB(2))
            END IF
C                                       correct amplitude
         IF ((DLFACT.NE.1.0) .OR. (BMFACT.NE.1.0)) THEN
            ERRAA = ERRAA * DLFACT / BMFACT
            CORA = A  * DLFACT / BMFACT
            SNR = 0.0
            IF (ERRAA.GT.0.0) SNR = MIN (999.0, CORA/ERRAA)
            IF (((ARHEAD/ARBEAM.LT.0.99) .OR. (ARHEAD/ARBEAM.GT.1.01))
     *         .AND. (TUNIT.EQ.'JY/BEAM')) THEN
               WRITE (MSGTXT,1045) CORA, ERRAA, CUNIT, SNR
            ELSE
               WRITE (MSGTXT,1046) CORA, ERRAA, CUNIT
               END IF
            CALL DOPRT
            END IF
C                                       flux is scaled with header beam
C                                       not actual beam
         IF (ARHEAD.GT.0.0) THEN
            INT = ARIMAG / ARHEAD * A
            IF (NWIDTH(I)) THEN
               ERRINT = FRERRA * INT
            ELSE
               ERRINT = FRERRA * SQRT(1 + 2*(ARHEAD/ARIMAG)) * INT
               END IF
            ERRINT = ABS (ERRINT)
            CORINT = INT
            CORINE = ERRINT
            WRITE (MSGTXT,1047) INT, ERRINT, FUNIT
            CALL DOPRT
            RECORD(1) = INT
            ROW(COEFLX) = ERRINT
C                                       correct flux
            IF (BMFACT.NE.1.0) THEN
               CORINE = ERRINT / BMFACT
               CORINT = INT / BMFACT
               WRITE (MSGTXT,1048) CORINT, CORINE, FUNIT
               CALL DOPRT
               END IF
C                                       resolution issue
            IF (CORA.GT.0.0) THEN
               IF (CORINT-CORINE.GT.CORA) THEN
                  RPT = 3
               ELSE
                  RPT = 2
                  END IF
            ELSE IF (CORA.LT.0.0) THEN
               IF (CORINT+CORINE.LT.CORA) THEN
                  RPT = 3
               ELSE
                  RPT = 2
                  END IF
               END IF
         ELSE
            ROW(COEFLX) = ROW(COEPEK)
            END IF
         ROW(COLFLX) = RECORD(1)
         ROW(COBMFA) = 1.0 / MAX (1.E-12, BMFACT)
         ROW(CODLFA) = DLFACT
C                                        Positions
         WRITE (MSGTXT,1050) 'X', X0, ERRX0
         CALL DOPRT
         FGP(1,I) = X0
         IF (XDP(1,I).GT.0.0) FDP(1,I) = ERRX0
         WRITE (MSGTXT,1050) 'Y', Y0, ERRY0
         CALL DOPRT
         ORERRX(I) = ERRX0
         ORERRY(I) = ERRY0
         FGP(2,I) = Y0
         IF (XDP(2,I).GT.0.0) FDP(2,I) = ERRY0
         RECORD(2) = (G(2,I) - RPLOC(1,LOCNUM)) * AXINC(1,LOCNUM)
         RECORD(3) = (G(3,I) - RPLOC(2,LOCNUM)) * AXINC(2,LOCNUM)
         CALL RCOPY (5, G(2,I), ROW(COPCEX))
C                                       get local pixel pair
         CALL XYVAL (G(2,I), G(3,I), X(1), X(2), X(3), IERR)
         STXY(1) = X(1)
         STXY(2) = X(2)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1051) IERR, I
            CALL MSGWRT (7)
            CAXINC(1) = AXINC(1,LOCNUM)
            CAXINC(2) = AXINC(2,LOCNUM)
            GO TO 80
         ELSE
            CALL XYVAL (G(2,I)+1.0, G(3,I), XX, YY, ZZ, IERR)
            XXT = (XX - X(1)) * COS (DG2RAD*X(2))
            YYT = YY - X(2)
            CAXINC(1) = XXT * COS (DG2RAD*ROT(LOCNUM)) + YYT *
     *         SIN (DG2RAD*ROT(LOCNUM))
            CALL XYVAL (G(2,I), G(3,I)+1.0, XX, YY, ZZ, IERR)
            XXT = (XX - X(1)) * COS (DG2RAD*X(2))
            YYT = YY - X(2)
            CAXINC(2) = YYT * COS (DG2RAD*ROT(LOCNUM)) -
     *         XXT * SIN (DG2RAD*ROT(LOCNUM))
            END IF
         ROW(COLDLX) = RECORD(2)
         ROW(COLDLY) = RECORD(3)
         ROW(COEDLX) = ABS (ERRX0 * CAXINC(1))
         ROW(COEDLY) = ABS (ERRY0 * CAXINC(2))
C                                       Coordinate labels
C                                       RA and DEC
         IF (AXTYP(LOCNUM).EQ.1) THEN
            RINC = MAX (ABS (CAXINC(1)), ABS (CAXINC(2))) * 3600.0
            DO 60 J = 1,2
               I2TMP = J - 1
               CALL AXSTRN (CTYP(J,LOCNUM), X(J), I2TMP, ILEN, RSTR(J))
 60            CONTINUE
            ERRX0 = ABS (ERRX0 * CAXINC(1) * 240.0 / COS (DG2RAD*X(2)))
            ERRY0 = ABS (ERRY0 * CAXINC(2) * 3600.0)
            IF (RINC.GT.1.0) THEN
               WRITE (MSGTXT,1060) RSTR(1), ERRX0
            ELSE IF (RINC.GT.0.01) THEN
               WRITE (MSGTXT,1061) RSTR(1), ERRX0
            ELSE IF (RINC.GT.0.0001) THEN
               WRITE (MSGTXT,1062) RSTR(1), ERRX0
            ELSE
               WRITE (MSGTXT,1063) RSTR(1), ERRX0
               END IF
            CALL DOPRT
            IF (RINC.GT.1.0) THEN
               WRITE (MSGTXT,1065) RSTR(2), ERRY0
            ELSE IF (RINC.GT.0.01) THEN
               WRITE (MSGTXT,1066) RSTR(2), ERRY0
            ELSE IF (RINC.GT.0.0001) THEN
               WRITE (MSGTXT,1067) RSTR(2), ERRY0
            ELSE
               WRITE (MSGTXT,1068) RSTR(2), ERRY0
               END IF
C                                       Other type
         ELSE
            ERRX0 = ABS (ERRX0 * CAXINC(1))
            ERRY0 = ABS (ERRY0 * CAXINC(2))
            CALL H2CHR (8, 1, CATH(KHCTP), AXIS)
            WRITE (MSGTXT,1070) AXIS, X(1), ERRX0
            CALL DOPRT
            CALL H2CHR (8, 1, CATH(KHCTP+2), AXIS)
            WRITE (MSGTXT,1070) AXIS, X(2), ERRY0
            END IF
         CALL DOPRT
         IF (NWIDTH(I)) THEN
            ERRMAJ = 0.0
            ERRMIN = 0.0
            ERRFI = 0.0
            END IF
C                                       Diameters
 80      IF (E(6,I).GT.90.0) E(6,I) = 90.0
         IF (ERRFI.GT.90.0) ERRFI = 90.0
         DO 85 J = 4,5
            IF (G(J,I).GE.99.5) G(J,I) = 99.5
            IF (E(J,I).GE.99.5) E(J,I) = 99.5
 85         CONTINUE
         IF (ERRMAJ.GE.99.5) ERRMAJ = 99.5
         IF (ERRMIN.GE.99.5) ERRMIN = 99.5
         WRITE (MSGTXT,1080) CAX(1), IMAJ, ERRMAJ, ' pixels'
         CALL DOPRT
         FGW(1,I) = IMAJ
         IF (XDW(1,I).GT.0.0) FDW(1,I) = ERRMAJ
         WRITE (MSGTXT,1080) CAX(2), IMIN, ERRMIN, ' pixels'
         CALL DOPRT
         FGW(2,I) = IMIN
         IF (XDW(2,I).GT.0.0) FDW(2,I) = ERRMIN
         WRITE (MSGTXT,1081) CAX(3), FI, ERRFI, ' degrees'
         CALL DOPRT
         FGW(3,I) = FI
         IF (XDW(3,I).GT.0.0) FDW(3,I) = ERRFI
C                                       convert from pixels
         CALL GAUSPS ('P2S', G(2,I), G(3,I), G(4,I), G(5,I), G(6,I),
     *      BMAJS, BMINS, BPAS, IERR)
         STWID(1) = BMAJS
         STWID(2) = BMINS
         STWID(3) = BPAS
         WRITE (STRING,1075) I
C                                       stars info now known
         IF (STVER.GT.0) THEN
            CALL TABST ('WRIT', STBUF, ISTRNO, STKOLS, STNUMV, STXY,
     *         STWID, STTYPE, STRING, IERR)
            IF (IERR.NE.0) THEN
               MSGTXT = 'ERROR WRITING STARS FILE'
               CALL MSGWRT (7)
               STVER = 0
               END IF
            END IF
         RECORD(4) = BMAJS
         RECORD(5) = BMINS
         RECORD(6) = BPAS
         RECORD(7) = 2.0
         ROW(COLMJX) = RECORD(4)
         ROW(COLMNX) = RECORD(5)
         ROW(COLPAN) = RECORD(6)
         IF (ROW(COLPAN).LT.0.0) ROW(COLPAN) = ROW(COLPAN) + 180.0
         CALL RCOPY (7, RECORD, RICORD)
         RICORD(7) = 1.0
C                                       non RA/Dec
         IF (AXTYP(LOCNUM).NE.1) THEN
            ROW(COLMJX) = G(4,I)
            ROW(COEMJX) = ERRMAJ
            ROW(COLMNX) = G(5,I)
            ROW(COEMNX) = ERRMIN
            ROW(COLPAN) = G(6,I)
            ROW(COEPAN) = ERRFI
C                                       RA, Dec display
         ELSE
C                                       Put in arcsec
            BMAJS = BMAJS * 3600.
            BMINS = BMINS * 3600.
            IF (G(4,I).NE.0.0) THEN
               ERRMAS = ERRMAJ * BMAJS / G(4,I)
            ELSE
               ERRMAS = -1.0
               END IF
            IF (G(5,I).NE.0.0) THEN
               ERRMIS = ERRMIN * BMINS / G(5,I)
            ELSE
               ERRMIS = -1.0
               END IF
            ORERMA(I) = ERRMAS
            ORERMI(I) = ERRMIS
            ORBMAJ(I) = BMAJS
            ORBMIN(I) = BMINS
            ORBPA(I) = BPAS
            ROW(COEMJX) = ERRMAS / 3600.
            ROW(COEMNX) = ERRMIS / 3600.
            ROW(COEPAN) = ERRFI
            IF (RINC.GT.1.0) THEN
               WRITE (MSGTXT,1085) CAX(1), BMAJS, ERRMAS, ' asec'
            ELSE IF (RINC.GT.0.01) THEN
               WRITE (MSGTXT,1086) CAX(1), BMAJS, ERRMAS, ' asec'
            ELSE IF (RINC.GT.0.0001) THEN
               WRITE (MSGTXT,1087) CAX(1), BMAJS, ERRMAS, ' asec'
            ELSE
               WRITE (MSGTXT,1088) CAX(1), BMAJS, ERRMAS, ' asec'
               END IF
            CALL DOPRT
            IF (RINC.GT.1.0) THEN
               WRITE (MSGTXT,1085) CAX(2), BMINS, ERRMIS, ' asec'
            ELSE IF (RINC.GT.0.01) THEN
               WRITE (MSGTXT,1086) CAX(2), BMINS, ERRMIS, ' asec'
            ELSE IF (RINC.GT.0.0001) THEN
               WRITE (MSGTXT,1087) CAX(2), BMINS, ERRMIS, ' asec'
            ELSE
               WRITE (MSGTXT,1088) CAX(2), BMINS, ERRMIS, ' asec'
               END IF
            CALL DOPRT
            WRITE (MSGTXT,1081) CAX(3), BPAS, ERRFI, ' degrees'
            CALL DOPRT
            IF (I.EQ.1) THEN
               WRITE (MSGTXT,1082) FSHIFT
               CALL DOPRT
               END IF
            END IF
C                                       Deconvolve if possible
         IF (CB(1).GT.0.0) THEN
C                                       BW smearing here
            DX = G(2,I) - XCEN
            DY = G(3,I) - YCEN
            CALL BWSMCB (DX, DY, XD, BWS, CB, SMCB)
            CALL BMVAL (G(4,I), G(5,I), G(6,I), ERRMAJ, ERRMIN, ERRFI,
     *         SMCB(1), SMCB(2), SMCB(3), FACTOR, DCONV)
            WRITE (MSGTXT,1090)
            IF (DOCRT.GT.-2.5) THEN
               CALL DOPRT
            ELSE
               CALL MSGWRT (4)
               END IF
            WRITE (MSGTXT,1092)
            CALL DOPRT
            WRITE (MSGTXT,1094)
            CALL DOPRT
            DO 100 J = 1,3
               WRITE (MSGTXT,1096) WORD(J), (DCONV(J,K), K = 1,3)
               CALL DOPRT
 100           CONTINUE
C                                       resolved??
            IF (DCONV(1,1).LE.0.0) RPT = 1
            IF (RPT.EQ.3) THEN
               IF (DCONV(1,2).LE.0) RPT = 2
            ELSE IF (RPT.EQ.2) THEN
               IF (DCONV(1,2).LE.0.0) RPT = 1
               END IF
C                                       RA, Dec display
            IF (AXTYP(LOCNUM).EQ.1) THEN
               WRITE (MSGTXT,1105)
               CALL DOPRT
               WRITE (MSGTXT,1094)
               CALL DOPRT
               DO 105 J = 1,3
C                                       convert from pixels
                  IF (DCONV(1,J).GT.0.0) THEN
                     CALL GAUSPS ('P2S', G(2,I), G(3,I), DCONV(1,J),
     *                  DCONV(2,J), DCONV(3,J), BMAJS, BMINS, BPAS,
     *                  IERR)
                     XCONV(1,J) = BMAJS
                     XCONV(2,J) = BMINS
                     XCONV(3,J) = BPAS
                  ELSE
                     XCONV(1,J) = DCONV(1,J) * ABS (CAXINC(1))
                     XCONV(2,J) = DCONV(2,J) * ABS (CAXINC(1))
                     XCONV(3,J) = DCONV(3,J) - ROT(LOCNUM)
                     END IF
                  IF (XCONV(3,J).GT.180.) XCONV(3,J)=XCONV(3,J)-180.
                  IF (XCONV(3,J).LT.0.) XCONV(3,J) = XCONV(3,J)+180.
                  DCONV(1,J) = XCONV(1,J) * 3600.
                  DCONV(2,J) = XCONV(2,J) * 3600.
                  DCONV(3,J) = XCONV(3,J)
 105              CONTINUE
               DO 110 J = 1,3
                  WRITE (MSGTXT,1107) WORD(J), (DCONV(J,K), K = 1,3)
                  CALL DOPRT
 110              CONTINUE
               RICORD(4) = DCONV(1,1) / 3600.0
               RICORD(5) = DCONV(2,1) / 3600.0
               RICORD(6) = DCONV(3,1)
               IF ((RSTO.GT.0.0) .AND. (RSTO.LE.1.5)) THEN
                  RECORD(4) = RICORD(4)
                  RECORD(5) = RICORD(5)
                  RECORD(6) = RICORD(6)
                  RECORD(7) = 1.0
                  END IF
               END IF
            IF ((RPT.GE.1) .AND. (RPT.LE.3)) THEN
               IF (RPT.EQ.1) THEN
                  MSGTXT = '  Component appears unresolved, use peak as'
     *               // ' total flux'
               ELSE IF (RPT.EQ.3) THEN
                  MSGTXT = '  Component appears resolved, use integral'
     *               // ' as total flux'
               ELSE
                  MSGTXT = '  Component may be unresolved or resolved,'
     *               // ' use caution'
                  END IF
               CALL DOPRT
               END IF
            END IF
         CALL RCOPY (9, XCONV, ROW(COLD0J))
         IF (OUTVER.GE.0) THEN
            CALL TABIO ('WRIT', 0, MFRNO, ROW, MFBUF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1110) IERR, 'MF', MFRNO
               CALL MSGWRT (7)
               OUTVER = -1
               END IF
            END IF
C                                       write CC file(s)
         IF (DOCC) THEN
            IRNO = IRNO + 1
            IERR = 0
            FLUX = RECORD(1)
            CCX = RECORD(2)
            CCY = RECORD(3)
            CCZ = 0.0
            CALL RCOPY (3, RECORD(4), PARMS)
            CCTYPE = RECORD(7) + 0.01
            IF (RSTO.GT.0.0) THEN
               CCRNO = IRNO
               CALL TABCCM ('WRIT', CCBUFF, CCRNO, CCKOLS, CCNUMV,
     *            CCNCOL, CCX, CCY, CCZ, FLUX, CCTYPE, PARMS, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1110) IERR, 'CC', IRNO
                  CALL MSGWRT (7)
                  RSTO = -1
                  END IF
               END IF
            IF (DOMODL.GT.0.0) THEN
               CIRNO = IRNO
               CALL TABCCM ('WRIT', CIBUFF, CIRNO, CCKOLS, CCNUMV,
     *            CCNCOL, CCX, CCY, CCZ, FLUX, CCTYPE, PARMS, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1110) IERR, 'CC', IRNO
                  CALL MSGWRT (7)
                  DOMODL = -1.0
                  END IF
               END IF
            END IF
         GO TO 790
C                                       Baseline solution
 215     WRITE (MSGTXT,1042) I, MODEL(XTYPE(I))
         CALL DOPRT
C                                        Zero level
         IF (E(1,I).EQ.0.0) GO TO 220
            E(1,I) = ABS (E(1,I))
            WRITE (MSGTXT,1215) G(1,I), E(1,I)
            CALL DOPRT
            FGM(I) = G(1,I)
            IF (XDM(I).GT.0.0) FDM(I) = E(1,I)
C                                        Slope
 220     IF ((E(2,I).EQ.0.0) .AND. (E(3,I).EQ.0.0)) GO TO 260
            E(2,I) = ABS (E(2,I))
            G(3,I) = G(3,I) / DG2RAD + PASUM
            E(3,I) = E(3,I) / DG2RAD
 230        IF (G(3,I).LE.180.0) GO TO 240
               G(3,I) = G(3,I) - 180.0
               GO TO 230
 240        IF (G(3,I).GT.0.0) GO TO 250
               G(3,I) = G(3,I) + 180.0
               GO TO 240
 250        IF (E(2,I).GT.1.0) E(2,I) = 1.0
            IF (E(3,I).GT.90.0) E(3,I) = 90.0
            WRITE (MSGTXT,1245) G(2,I), E(2,I)
            CALL DOPRT
            WRITE (MSGTXT,1246) G(3,I), E(3,I)
            CALL DOPRT
            FGP(1,I) = G(2,I)
            FGP(2,I) = G(3,I)
            IF (XDP(1,I).GT.0.0) FDP(1,I) = E(2,I)
            IF (XDP(2,I).GT.0.0) FDP(2,I) = E(3,I)
C                                        Curvature
 260     IF ((E(4,I).EQ.0.0) .AND. (E(5,I).EQ.0.0) .AND.
     *      (E(6,I).EQ.0.0)) GO TO 300
            E(4,I) = ABS (E(4,I))
            G(5,I) = ABS (G(5,I))
            G(6,I) = G(6,I) / DG2RAD + PASUM
            E(6,I) = E(6,I) / DG2RAD
            IF (E(5,I).GT.2.0) E(5,I) = 2.0
            IF (E(6,I).GT.90.0) E(6,I) = 90.0
 270        IF (G(6,I).LE.180.0) GO TO 280
               G(6,I) = G(6,I) - 180.0
               GO TO 270
 280        IF (G(6,I).GT.0.0) GO TO 290
               G(6,I) = G(6,I) + 180.0
               GO TO 280
 290        WRITE (MSGTXT,1290) G(4,I), E(4,I)
            CALL DOPRT
            WRITE (MSGTXT,1291) G(6,I), E(6,I)
            CALL DOPRT
            WRITE (MSGTXT,1292) G(5,I), E(5,I)
            CALL DOPRT
            FGW(1,I) = G(4,I)
            FGW(2,I) = G(5,I)
            FGW(3,I) = G(6,I)
            IF (XDW(1,I).GT.0.0) FDW(1,I) = E(4,I)
            IF (XDW(2,I).GT.0.0) FDW(2,I) = E(5,I)
            IF (XDW(3,I).GT.0.0) FDW(3,I) = E(6,I)
 300        CONTINUE
         GO TO 790
C
 415     CONTINUE
 790     WRITE (MSGTXT,1090)
         IF (DOCRT.GT.-2.5) THEN
            CALL DOPRT
         ELSE
            CALL MSGWRT (4)
            END IF
 800     CONTINUE
      IF (DOCRT.LE.-3.5) CALL ORPRT
      IF (OUTVER.GE.0) CALL TABIO ('CLOS', 0, MFRNO, ROW, MFBUF, IERR)
      IF (RSTO.GT.0.)CALL TABCCM ('CLOS', CCBUFF, CCRNO, CCKOLS, CCNUMV,
     *   CCNCOL, CCX, CCY, CCZ, FLUX, CCTYPE, PARMS, IERR)
      IF (DOMODL.GT.0.) CALL TABCCM ('CLOS', CIBUFF, CIRNO, CCKOLS,
     *   CCNUMV, CCNCOL, CCX, CCY, CCZ, FLUX, CCTYPE, PARMS, IERR)
      IF (STVER.GT.0) CALL TABST ('CLOS', STBUF, ISTRNO, STKOLS, STNUMV,
     *   STXY, STWID, STTYPE, STRING, IERR)
      IF (SESTAT) CALL CATDIR ('CSTA', CIVOL, INSL, DUM, DUM, DUM, DUM,
     *   DUM, 'CLWR', SCRBUF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Writing CC file version',I4,' attached to output image')
 1001 FORMAT ('Writing ',A,' file version',I4,
     *   ' attached to input image')
 1005 FORMAT ('********* Solution from IMFIT ',3('***********'))
 1010 FORMAT ('Error estimate based on rms',1PE10.3,1X,A)
 1042 FORMAT ('Component ',I3,' - ',A8)
 1044 FORMAT (2X,'Peak intensity    =',1PE11.4,' +/-',1PE9.2,1X,A8,2X,
     *   '(',0PF6.2,')')
 1144 FORMAT (2X,'Peak intensity    =',1PE11.4,' +/-',1PE9.2,
     *   ' Jy/headerbeam')
 1145 FORMAT (2X,'Peak intensity    =',1PE11.4,' +/-',1PE9.2,
     *   ' Jy/channelbeam')
 1045 FORMAT (2X,'Corrected peak int=',1PE11.4,' +/-',1PE9.2,1X,A8,2X,
     *   '(',0PF6.2,')')
 1046 FORMAT (2X,'Corrected peak int=',1PE11.4,' +/-',1PE9.2,1X,A8)
 1047 FORMAT (2X,'Integral intensity=',1PE11.4,' +/-',1PE9.2,1X,A8)
 1048 FORMAT (2X,'Corrected flux    =',1PE11.4,' +/-',1PE9.2,1X,A8)
 1050 FORMAT (2X,A,'-position        =  ',F9.3,' +/-',F9.4, ' pixels')
 1051 FORMAT ('ERROR',I3,' CONVERTING TO SKY POSITION OF COMPONENT',I3)
 1060 FORMAT (2X,20X,A20,' +/- ',F8.3)
 1061 FORMAT (2X,20X,A20,' +/- ',F10.7)
 1062 FORMAT (2X,20X,A20,' +/- ',F12.9)
 1063 FORMAT (2X,20X,A20,' +/- ',F14.11)
 1065 FORMAT (2X,20X,A20,' +/- ',F8.2)
 1066 FORMAT (2X,20X,A20,' +/- ',F10.6)
 1067 FORMAT (2X,20X,A20,' +/- ',F12.8)
 1068 FORMAT (2X,20X,A20,' +/- ',F14.10)
 1070 FORMAT (2X,A8,11X,'=',1PE13.5,' +/- ',1PE10.3)
 1075 FORMAT ('IMFIT_',I1)
 1080 FORMAT (2X,A14,'    =',F8.3,' +/- ',F7.4, A)
 1081 FORMAT (2X,A14,'    =',F8.3,' +/- ',F6.3, A)
 1082 FORMAT ('  RASHIFT=',F11.6,' DECSHIFT=',F11.6,
     *   ' to center on pixel')
 1085 FORMAT (2X,A14,'    =',F8.3,' +/-',F8.3, A)
 1086 FORMAT (2X,A14,'    =',F9.5,' +/-',F9.5, A)
 1087 FORMAT (2X,A14,'    =',F10.7,' +/-',F10.7, A)
 1088 FORMAT (2X,A14,'    =',F11.9,' +/-',F11.9, A)
 1090 FORMAT (2X,30('- '))
 1092 FORMAT (18X,'Deconvolution of component in pixels')
 1094 FORMAT (23X, 'Nominal',5X,'Minimum',5X,'Maximum')
 1096 FORMAT (4X,A8,6X,3F12.3)
 1105 FORMAT (18X,'Deconvolution of component in asec')
 1107 FORMAT (4X,A8,6X,3F12.6)
 1110 FORMAT ('ERROR',I5,' WRITING ',A,' ROW',I7)
 1215 FORMAT (2X,'Zero level=',1PE12.4,'(',1PE11.4,')  Ampl. units')
 1245 FORMAT (2X,'Slope=',1PE11.3,'(',1PE10.3,') Ampl/pixl')
 1246 FORMAT (5X,'in angle',0PF7.2,'(',0PF6.2,') Deg')
 1290 FORMAT (2X,'Curv.=',1PE11.3,'(',1PE10.3,')  Ampl/pixel**2')
 1291 FORMAT (5X,'in angle',F7.2,'(',F6.2,') deg')
 1292 FORMAT (5X,'Eccentricity=',F8.3,'(',F7.3,')')
      END
      SUBROUTINE BMVAL (BMAJ, BMIN, BPA, BMAJE, BMINE, BPAE, CBMAJ,
     *   CBMIN, CBPA, FACTOR, R)
C-----------------------------------------------------------------------
C   Subroutine BMVAL deconvoles the fitted beam from the clean beam and
C   also generates appropriate errors.  This is used with IMFIT.
C   Inputs:
C      BMAJ       R       Fitter major axis
C      BMIN       R       Fitted minor axis
C      BPA        R       Fitted pos. angle (deg)   WRT Y
C      BMAJE      R       Fitted major axis error
C      BMINE      R       Fitted minor axis error
C      BPAE       R       Fitted pos. angle error (deg)
C      CBMAJ      R       Clean beam major axis
C      CBMIN      R       Clean beam minor axis
C      CBPA       R       Clean beam pos. angle (deg)  WRT Y
C   Outputs:
C      R(3,3)     R       RMAJ, RMIN, RPA array
C-----------------------------------------------------------------------
      REAL      BMAJ, BMIN, BPA, BMAJE, BMINE, BPAE, CBMAJ, CBMIN, CBPA,
     *   FACTOR, R(3,3)
C
      INTEGER   IERR, I, J, K, IC
      REAL      B1, B2, B3, DELT(3), MAJOR, MINOR, PA, TEMP
      DATA DELT /-0.7,0.0,0.7/
C-----------------------------------------------------------------------
C                                       Deconvolve the fit
      CALL DECONV (BMAJ, BMIN, BPA, CBMAJ, CBMIN, CBPA, MAJOR, MINOR,
     *   PA, IERR)
      R(1,1) = MAJOR
      R(2,1) = MINOR
      R(3,1) = PA
C                                       initial minimum
      R(1,2) = MAJOR
      R(2,2) = MINOR
      R(3,2) = PA
C                                       Initial maximum
      R(1,3) = MAJOR
      R(2,3) = MINOR
      R(3,3) = PA
C                                      Set up looping
      IC = 0
      DO 50 K = 1,3
         B3 = BPA + DELT(K) * BPAE * FACTOR
         DO 49 J = 1,3
            B2 = BMIN + DELT(J) * BMINE * FACTOR
            DO 48 I = 1,3
               B1 = BMAJ + DELT(I) * BMAJE * FACTOR
               IC = IC + 1
               CALL DECONV (B1, B2, B3, CBMAJ, CBMIN, CBPA, MAJOR,
     *            MINOR, PA, IERR)
C                                       If FIT worked sort of::
               IF (R(1,1).GT.0.0) THEN
C                                       first look at PA
                  PA = MOD((R(3,1) - PA +720.0), 180.0)
                  IF (PA.LT.45) THEN
                     PA = PA + R(3,1)
                  ELSE IF (PA.GT.135) THEN
                     PA = PA + R(3,1) - 180.0
C                                       Switch major, minor axes
                  ELSE
                     TEMP = MINOR
                     MINOR = MAJOR
                     MAJOR = TEMP
                     PA = PA + R(3,1) -90.0
                     END IF
                  END IF
C                                       Upper and lower bounds
               R(1,2) = MIN (R(1,2), MAJOR)
               R(1,3) = MAX (R(1,3), MAJOR)
               R(2,2) = MIN (R(2,2), MINOR)
               R(2,3) = MAX (R(2,3), MINOR)
               R(3,2) = MIN (R(3,2), PA)
               R(3,3) = MAX (R(3,3), PA)
 48            CONTINUE
 49         CONTINUE
 50      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE BWSMCB (DX, DY, DR, BWS, CB, SMCB)
C-----------------------------------------------------------------------
C   convolves the Clean beam for bandwidth smearing
C   Inputs:
C      DX     R      Component X pixel from ref
C      DY     R      Component Y pixel from ref
C      DR     D      Component radius from reference
C      BWS    R      Smearing factor
C      CB     R(3)   Central Clean beam
C   Output
C      SMCB   R(3)   Effective Clean beam at component
C-----------------------------------------------------------------------
      REAL     DX, DY, BWS, CB(3), SMCB(3)
      DOUBLE PRECISION DR
C
      REAL     SMGAUS(3), SMGAUD(3)
      INTEGER  IERR
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DLOC.INC'
C-----------------------------------------------------------------------
C                                       No smearing
      IF ((BWS.LE.0.0) .OR. ((DX.EQ.0.0) .AND. (DY.EQ.0.0))) THEN
         SMCB(1) = CB(1)
         SMCB(2) = CB(2)
         SMCB(3) = CB(3)
C                                       Smearing
      ELSE
         SMGAUD(1) = DR * BWS
         SMGAUD(2) = SMGAUD(1) / 1000.0
         SMGAUD(3) = ATAN2 (DX * AXINC(1,LOCNUM), DY * AXINC(2,LOCNUM))
     *      * RAD2DG
         CALL ELIPSQ (SMGAUD(1), SMGAUD(2), SMGAUD(3), -AXINC(1,LOCNUM),
     *      AXINC(2,LOCNUM), SMGAUS(1), SMGAUS(2), SMGAUS(3))
         SMGAUS(2) = 0.0
         CALL RECONV (CB(1), CB(2), CB(3), SMGAUS(1), SMGAUS(2),
     *      SMGAUS(3), SMCB(1), SMCB(2), SMCB(3), IERR)
         IF (IERR.NE.0) THEN
            SMCB(1) = CB(1)
            SMCB(2) = CB(2)
            SMCB(3) = CB(3)
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE DOPRT
C-----------------------------------------------------------------------
C   DOPRT calls MSGWRT and optionally PRTLIN with MSGTXT
C   In/Out - COMMON
C      XPR   L   Do printing?
C-----------------------------------------------------------------------
C
      INTEGER   PERR
      INCLUDE 'IMFIT.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       message file in any case
      CALL MSGWRT (4)
C                                       print file
      IF ((XPR) .AND. (XCRT.GE.-3.5)) THEN
         CALL PRTLIN (LUNP, INDP, DOCRT, NACROS, TITL1, TITL2, MSGTXT,
     *      ILINE, IPAGE, SCRTCH, PERR)
         IF (PERR.NE.0) XPR = .FALSE.
         END IF
C
 999  RETURN
      END
      SUBROUTINE ORPRT
C-----------------------------------------------------------------------
C   ORPRT does the DOCRT=-4 special print format to file
C-----------------------------------------------------------------------
      INTEGER   SEQ, CVOL, CUID, JTRIM, IL, IPA, IPE, IBPA, IERR, I,
     *   IROUND, J
      CHARACTER CNAME*12, CCLAS*6, CPTYPE*2, TLINE*156, PCODE*1,
     *   ACODE*1, AUNIT*2, RCODE*1
      REAL      PEAK, XINC, YINC, XP, YP, AXMAJ, AXMIN, BMAJ, BMIN,
     *   PRMS, SCALE, BMFACT
      INCLUDE 'IMFIT.INC'
      INCLUDE 'ORFIT.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      BMFACT = 0.0
      IF (HCB(1)*HCB(2).GT.0.0) BMFACT = UCB(1)*UCB(2) / (HCB(1)*HCB(2))
      IF (BMFACT.LE.0.0) BMFACT = 1.0
C                                       name manipulation
      CALL WAWA2A (INNA, CNAME, CCLAS, SEQ, CPTYPE, CVOL, CUID)
      IL = JTRIM (CNAME)
      DO 10 I = 1,IL
         IF (CNAME(I:I).EQ.' ') CNAME(I:I) = '.'
 10      CONTINUE
      IF (CCLAS(5:6).NE.' ') CNAME(11:12) = CCLAS(5:6)
      XINC = CATR(KRCIC)
      YINC = CATR(KRCIC+1)
      ACODE = ' '
      SCALE = 1.0
      AUNIT = ' '
      IF (AXTYP(LOCNUM).EQ.1) THEN
         XINC = XINC * 3600.0
         YINC = YINC * 3600.0
         UCB(1) = UCB(1) * 3600.0
         UCB(2) = UCB(2) * 3600.0
         IF (MAX(ABS(XINC),ABS(YINC)).LT.0.1) THEN
            SCALE = 1000.0
            ACODE = 'm'
            END IF
         AUNIT = 'as'
         END IF
      BMAJ = UCB(1) * SCALE
      BMIN = UCB(2) * SCALE
      IBPA = IROUND (UCB(3))
      PRMS = ACTRMS * BMFACT
      IF (PRMS.LT.1.E-3) THEN
         RCODE = 'u'
         PRMS = PRMS * 1.E6
      ELSE IF (PRMS.LT.1.0) THEN
         RCODE = 'm'
         PRMS = PRMS * 1.E3
      ELSE IF (PRMS.LT.1.E3) THEN
         RCODE = ' '
      ELSE
         RCODE = 'k'
         PRMS = PRMS * 1.E-3
         END IF
      J = 0
      IF (.NOT.OREXIS) THEN
         WRITE (TLINE,1000) ACODE, AUNIT, ACODE, AUNIT, ACODE, AUNIT,
     *      ACODE, AUNIT
         CALL ZTXIO ('WRIT', LUNP, INDP, TLINE, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1015) IERR, 0
            CALL MSGWRT (8)
            GO TO 999
            END IF
         END IF
      DO 50 I = 1,NGAUSS
         IF (NGAUSS.GT.1) J = I
         PEAK = G(1,I) * BMFACT
         IF (PEAK.GT.0.0) THEN
            IF ((PEAK.LT.1.E-3) .AND. (ORERRA(I).LT.1.E-4)) THEN
               PCODE = 'u'
               PEAK = PEAK * 1.E6
               ORERRA(I) = ORERRA(I) * 1.E6
            ELSE IF ((PEAK.LT.1.0) .AND. (ORERRA(I).LT.0.1)) THEN
               PCODE = 'm'
               PEAK = PEAK * 1.E3
               ORERRA(I) = ORERRA(I) * 1.E3
            ELSE IF ((PEAK.LT.1.E3) .AND. (ORERRA(I).LT.100.)) THEN
               PCODE = ' '
            ELSE
               PCODE = 'k'
               PEAK = PEAK * 1.E-3
               ORERRA(I) = ORERRA(I) * 1.E-3
               END IF
         ELSE
            IF ((ABS(PEAK).LT.1.E-4) .AND. (ORERRA(I).LT.1.E-4)) THEN
               PCODE = 'u'
               PEAK = PEAK * 1.E6
               ORERRA(I) = ORERRA(I) * 1.E6
            ELSE IF ((ABS(PEAK).LT.0.1) .AND. (ORERRA(I).LT.0.1)) THEN
               PCODE = 'm'
               PEAK = PEAK * 1.E3
               ORERRA(I) = ORERRA(I) * 1.E3
            ELSE IF ((ABS(PEAK).LT.1.E2) .AND. (ORERRA(I).LT.100.)) THEN
               PCODE = ' '
            ELSE
               PCODE = 'k'
               PEAK = PEAK * 1.E-3
               ORERRA(I) = ORERRA(I) * 1.E-3
               END IF
            END IF
         XP = (G(2,I) - CATR(KRCRP)) * XINC * SCALE
         YP = (G(3,I) - CATR(KRCRP+1)) * YINC * SCALE
         ORERRX(I) = ORERRX(I) * ABS(XINC) * SCALE
         ORERRY(I) = ORERRY(I) * ABS(YINC) * SCALE
         AXMAJ = ORBMAJ(I) * SCALE
         AXMIN = ORBMIN(I) * SCALE
         ORERMA(I) = ORERMA(I) * SCALE
         ORERMI(I) = ORERMI(I) * SCALE
         IPA = IROUND (ORBPA(I))
         IPE = IROUND (ORERFI(I))
         WRITE (TLINE,1010) CNAME, DEPTH(1), PEAK, ORERRA(I), PCODE, XP,
     *      ORERRX(I), YP, ORERRY(I), REFRA(:2), REFRA(4:5),
     *      REFRA(7:13), REFDEC(:3), REFDEC(5:6), REFDEC(8:14),
     *      AXMAJ, ORERMA(I), AXMIN, ORERMI(I), IPA, IPE, BMAJ, BMIN,
     *      IBPA, PRMS, RCODE, J
         CALL ZTXIO ('WRIT', LUNP, INDP, TLINE, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1015) IERR, I
            CALL MSGWRT (8)
            GO TO 999
            END IF
 50      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT('!Source       Ch   Fnu _Jy Err    E-W Offset (',A1,A2,
     +   ')     N-S Offset (',A1,A2,
     *   ')       RA          DEC      Major(',A1,A2,')   Minor(',A1,A2,
     *   ') PA(deg)       Beam         RMS  #')
 1010 FORMAT (A12,I4,1X,2F7.3,A1,2(F12.3,F8.3),1X,2A2,A7,A3,A2,A7,
     *   2(F7.2,F6.2),I4,I3,F7.2,F6.2,I4,F7.2,A1,I2)
 1015 FORMAT ('ZTXIO ERROR',I4,' WRITING COMPONENT',I2)
      END

      SUBROUTINE YCREAD (IPLANE, IX, IY, CATBLK ,IERR)
C-----------------------------------------------------------------------
C! read the image catalog, return image header for TV only
C# Y0 TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Read image catalog block into CATBLK - TV only (TK in TKCATL)
C   Inputs:
C      IPLANE  I       plane containing image whose block is wanted
C      IX      I       X pixel coordinate of a point within image
C      IY      I       Y pixel coordinate of point within image
C   Outputs:
C      CATBLK  I(256)  Image catalog block
C      IERR    I       error codes: 0 => ok
C                         1 => IX, IY lies outside image
C                         2 => Catalog i/o errors
C                         3 => refers to TK device
C   Generic Y routine: for local host operated TV device
C-----------------------------------------------------------------------
      INTEGER   IPLANE, IX, IY, CATBLK(256), IERR
C
      INTEGER   ILUN, IIND, IER, I, J, NLAST, NNOW, NSEQ, LL, NREC
      LOGICAL   IN, T, F
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA ILUN /20/
C-----------------------------------------------------------------------
C                                       Open image catalog
      IERR = 0
      CALL ICOPEN (IPLANE, ILUN, IIND, IER)
      IF (IER.NE.0) GO TO 970
      LL = (NIMAGE - 1) / 51
C                                       Read image catalog directory
C                                       Single-image planes
      IF (IPLANE.LE.NGRAY) GO TO 100
         NREC = IPLANE + NGRAY * (NIMAGE + LL)
         IF (IPLANE.LE.NGRAY+NGRAPH) GO TO 200
            IERR = 3
            GO TO 999
C                                       Multi-image planes
 100  NREC = (IPLANE - 1) * (1 + NIMAGE + LL)
C                                       Search directory
      NLAST = 0
      NSEQ = 0
      DO 150 I = 1,NIMAGE
         IF (MOD(I,51).NE.1) GO TO 110
            NREC = NREC + 1
            CALL ZFIO ('READ', ILUN, IIND, NREC, CATBLK, IER)
            IF (IER.NE.0) GO TO 970
 110     J = 5 * MOD (I-1, 51) + 2
         NNOW = CATBLK(J)
C                                       entry empty or older than
C                                       present last entry?
         IF (NNOW.LE.NLAST) GO TO 150
C                                       Does image contain IX, IY?
            IN = (IX.GE.CATBLK(J+1)) .AND. (IX.LE.CATBLK(J+3))
            IN = IN .AND. (IY.GE.CATBLK(J+2)) .AND. (IY.LE.CATBLK(J+4))
            IF (.NOT. IN) GO TO 150
               NLAST = NNOW
               NSEQ = I
 150     CONTINUE
C                                       Did we find anything?
      IF (NLAST.GT.0) GO TO 160
         IERR = 1
         GO TO 980
 160  NREC = NSEQ + IPLANE * (NIMAGE + 1 + LL) - NIMAGE
C                                       Read requested image block
 200  CALL ZFIO ('READ', ILUN, IIND, NREC, CATBLK, IER)
      IF (IER.EQ.0) GO TO 980
C                                       IO error
 970  IF (IER.EQ.11) THEN
         WRITE (MSGTXT,1970)
         IERR = 3
      ELSE
         WRITE (MSGTXT,1971) IER
         IERR = 2
         END IF
      CALL MSGWRT (6)
C
 980  CALL ZCLOSE (ILUN, IIND, IER)
C                                       Check if pixel inside graphics
      IF ((IPLANE.LE.NGRAY) .OR. (IERR.NE.0)) GO TO 999
         IF ((IX.GE.CATBLK(IICOR)) .AND. (IX.LE.CATBLK(IICOR+2))
     *      .AND. (IY.GE.CATBLK(IICOR+1)) .AND. (IY.LE.CATBLK(IICOR+3)))
     *      GO TO 999
            IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1970 FORMAT ('YCREAD: NO LONGER HANDLES TK DEVICES')
 1971 FORMAT ('YCREAD: CAN''T ACCESS IMAGE CATALOG, ERROR =',I6)
      END

      SUBROUTINE ZLPOP2 (LUN, FILNAM, IERR)
C-----------------------------------------------------------------------
C! open a line-printer text file - actual OPEN call
C# Z2 Printer
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   open a line-printer text file - the actual machine-dependent OPEN
C   call in Fortran or whatever
C   Input:
C      LUN      I       LUN to use
C      FILNAM   C*(*)   output file name
C   Output:
C      IERR     I       error status returned by system
C   VMS version.
C-----------------------------------------------------------------------
      CHARACTER FILNAM*(*)
      INTEGER   LUN, IERR
C-----------------------------------------------------------------------
C                                       Fortran generic call
      OPEN (UNIT=LUN, STATUS='NEW', FILE=FILNAM, IOSTAT=IERR,
     *   CARRIAGECONTROL='FORTRAN', DISP='DELETE')
C
 999  RETURN
      END

      SUBROUTINE TFILTR (FILTER, RATE, TMINT, RFACT, IERR)
C-----------------------------------------------------------------------
C! Compute rate decorrelation corrections as a function of filter type
C# Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2007
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  Compute rate decorrelation corrections as a function of filter type
C   Inputs:
C      FILTER   I    Filter type: 4 => 64-8; 3 => 32-4; 0 => BOX
C      RATE     R    Fringe rate (radians/day)
C      TMINT    R    Averaging time (days)
C   Outputs:
C      RFACT    R    Amplitude correction factor
C      IERR     I    Return code (0=> ok; else error)
C-----------------------------------------------------------------------
      REAL      RATE, TMINT, RFACT
      INTEGER   FILTER, IERR
C
      INCLUDE 'INCS:PSTD.INC'
C                                       Polynomial order for
C                                       VLBA filter corrections
      INTEGER N32D4, N64D8
      PARAMETER (N32D4 = 14)
      PARAMETER (N64D8 = 14)
      DOUBLE PRECISION DP
      REAL C32D4(N32D4), C64D8(N64D8), ARG
      INTEGER J
      INCLUDE 'INCS:DMSG.INC'
C                                       Polynomial coefficients for
C                                       VLBA filter corrections,
C                                       derived by L. Kogan (96):
C                                       32-tap; decimation 4
      DATA C32D4 /0.9998181, 0.05842116, -0.315723E+1,
     *   0.2541054E+2, -0.4032384E+2, -0.8400728E+2, -0.1156864E+3,
     *   0.7344348E+3, 0.1153372E+4, 0.7487309E+3, -0.1181970E+5,
     *   -0.5113351E+4, 0.4165397E+5, -0.2703458E+5/
C                                       64-TAP; decimation 8
      DATA C64D8 /0.1000438E+1, -0.1965840E-1, -0.8578708,
     *   0.4649189E+1, 0.1179239E+2, -0.2645647E+2, -0.2537850E+3,
     *   0.4259856E+3, 0.5437562E+3, -0.1127070E+4, 0.4009456E+4,
     *   -0.8898893E+4, -0.1362069E+4, 0.9950514E+4/
C-----------------------------------------------------------------------
C                                       Initialization
      IERR = 0
      RFACT = 1.0
C                                       RATE is given in radians/day
      ARG = ABS (TMINT * RATE / TWOPI)
C                                       Case filter_type of:
      IF (FILTER .EQ. 3) THEN
C                                       32-tap; decimation factor 4
         IF (ARG .LE. 0.5 .AND. ARG .GT. 0.01) THEN
            DP = C32D4(N32D4)
            DO 50 J = (N32D4-1), 1, -1
               DP = DP * ARG + C32D4(J)
50             CONTINUE
            RFACT = 1.0 / DP
         ELSE
            RFACT = 1.0
            END IF
      ELSE IF (FILTER .EQ. 4) THEN
C                                       64-tap; decimation factor 8
         IF (ARG .LE. 0.5 .AND. ARG .GT. 0.01) THEN
            DP = C64D8(N64D8)
            DO 100 J = (N64D8-1), 1, -1
               DP = DP * ARG + C64D8(J)
100            CONTINUE
            RFACT = 1.0 / RFACT
         ELSE
            RFACT = 1.0
            END IF
      ELSE IF (FILTER .EQ. 0) THEN
C                                       Boxcar filter
         ARG = 0.5 * ARG * TWOPI
         IF (ARG .GT. 1.0E-5) THEN
            RFACT = ARG / SIN (ARG)
         ELSE
            RFACT = 1.0
            END IF
      ELSE
C                                       Unidentified filter
         IERR = 1
         WRITE (MSGTXT,1200) FILTER
         GO TO 990
         END IF
C                                       Endcase
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Exit
999   RETURN
C----------------------------------------------------------------------
1200  FORMAT ('TFILTR: UNIDENTIFIED CORRELATOR FILTER TYPE:',I4)
      END

      PROGRAM ZSTRTA
C-----------------------------------------------------------------------
C! Changes process name to AIPSn
C# Z System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZSTRTA changes the process name to 'AIPSx'
C   VMS version
C-----------------------------------------------------------------------
      INTEGER*2 LIST2(8)
      INTEGER   IBUF(256), IAIPS, LAIPS, RETLN, IERR, LERR(15), I, J,
     *   LIST4(4), INUN1, INUN2
      CHARACTER THISTT*10, TRYTT*10, RESSTT*7, MYNAME*5, POPSNO*1,
     *   TEMP*15
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE '($SYSSRVNAM)'
      INCLUDE '($DVIDEF)'
      INCLUDE '($LNMDEF)'
      EQUIVALENCE (LIST2, LIST4)
C-----------------------------------------------------------------------
C                                       Set values especially NINTRN.
      CALL ZDCHIN (.TRUE., IBUF)
C
      MYNAME = 'AIPS  '
C                                       Figure out who we are.
C                                       Extra translations if needed
      LIST2(1) = 10
      LIST2(2) = DVI$_TT_PHYDEVNAM
      LIST4(2) = %LOC(THISTT)
      LIST4(3) = %LOC(RETLN)
      LIST4(4) = 0
      IERR = SYS$GETDVI( , , 'TT', LIST4, , , , )
C                                       Find 1st non '_' in name.
      INUN1 = 1
      DO 10 I = 1,10
         IF (THISTT(INUN1:INUN1).NE.'_') GO TO 15
         INUN1 = INUN1 + 1
 10      CONTINUE
C                                       See if we are in list of
C                                       reserved terminals.
 15   LAIPS = 0
      LIST2(1) = 10
      LIST2(2) = LNM$_STRING
      LIST4(2) = %LOC(TRYTT)
      LIST4(3) = 0
      LIST4(4) = 0
      DO 30 IAIPS = 1,NINTRN
         CALL ZEHEX (IAIPS, 1, POPSNO)
         RESSTT = 'RESSTT' // POPSNO
         LERR(IAIPS) = SYS$TRNLNM ( , 'AIPS_USER', RESSTT, , LIST4)
         IF (LERR(IAIPS).EQ.1) THEN
C                                       Strip leading underscores.
            INUN2 = 1
            DO 20 I = 1,10
               IF (TRYTT(INUN2:INUN2).NE.'_') GO TO 25
               INUN2 = INUN2 + 1
 20            CONTINUE
C
 25         IF (THISTT(INUN1:INUN1+3).EQ.TRYTT(INUN2:INUN2+3)) THEN
               LAIPS = IAIPS
               GO TO 50
               END IF
            END IF
 30      CONTINUE
C                                       Change process name to 'AIPSx'
C                                       Not a reserved terminal
      DO 40 IAIPS = 1,NINTRN
         IF (LERR(IAIPS).NE.1) THEN
            CALL ZEHEX (IAIPS, 1, POPSNO)
            MYNAME = 'AIPS' // POPSNO
            IERR = SYS$SETPRN(MYNAME)
            IF (IERR.EQ.1) THEN
               LAIPS = IAIPS
               GO TO 60
               END IF
            END IF
 40      CONTINUE
      LAIPS = 0
      GO TO 60
C                                       reserved terminal
 50   CONTINUE
         CALL ZEHEX (LAIPS, 1, POPSNO)
         MYNAME(5:5) = POPSNO
         IERR = SYS$SETPRN(MYNAME)
         IF (IERR.NE.1) LAIPS = 0
C
 60   IF (LAIPS.LE.0) THEN
         WRITE (6,1060)
      ELSE
         WRITE (6,1065) POPSNO
         END IF
C
 999  CONTINUE
C-----------------------------------------------------------------------
 1060 FORMAT (' ******  ALL AIPS ARE IN USE.  ******')
 1065 FORMAT (' Begin the one true AIPS number ',A1)
      END

      SUBROUTINE REALOG (IOP, RV, DV, IV)
C-----------------------------------------------------------------------
C! converts numbers between floating and an integer version of their log
C# TV-util Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   REALOG converts between real numbers and an integer*2 representation
C   of the logarithm (base e) of the number.
C   Inputs:
C      IOP  I       1 => R4 -> IV,    2 => R8 -> IV
C                   3 => IV -> R4,    4 => IV -> R8
C   In/out:
C      RV   R       Single precision real value
C      DV   D       Double precision real value
C      IV   I(4)    Log base e representation as follows:
C                        IV(1) = sign of number (-1, 0, 1)
C                        IV(2) = log(V) * 1000.
C                        IV(3) = remainder * 100000.
C                        IV(4) = remainder of that * 100000.
C-----------------------------------------------------------------------
      INTEGER   IOP, IV(4)
      REAL      RV
      DOUBLE PRECISION DV
C
      DOUBLE PRECISION DT, DL
C-----------------------------------------------------------------------
      IF ((IOP.LT.1) .OR. (IOP.GT.4)) GO TO 999
C                                       Real to integer
      IF (IOP.GT.2) GO TO 20
         CALL FILL (3, 0, IV)
         IF (IOP.EQ.2) IV(4) = 0
         IF ((IOP.EQ.1) .AND. (RV.EQ.0.0)) GO TO 999
         IF ((IOP.EQ.2) .AND. (DV.EQ.0.0D0)) GO TO 999
         IF (IOP.EQ.1) DT = RV
         IF (IOP.EQ.2) DT = DV
         IV(1) = 1
         IF (DT.LT.0.0D0) IV(1) = -1
         DT = DT * IV(1)
         DL = LOG (DT) * 1.0D3
         IV(2) = DL
         DL = (DL - IV(2)) * 1.0D5
         IV(3) = DL
         IF (IOP.EQ.1) GO TO 999
            DL = (DL - IV(3)) * 1.0D5
            IV(4) = DL
            GO TO 999
C                                       Integer to real
 20   CONTINUE
         DL = IV(2) / 1.0D3 + IV(3) / 1.0D8
         IF (IOP.EQ.4) DL = DL + IV(4) / 1.0D13
         DT = IV(1) * EXP (DL)
         IF (IOP.EQ.3) RV = DT
         IF (IOP.EQ.4) DV = DT
C
 999  RETURN
      END

      SUBROUTINE RFFTF (C, N, F, W)
C-----------------------------------------------------------------------
C! Vectorizable, table lookup Fast Fourier transform (non-AP)
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Vector table lookup version (Non AP)
C   Does an in-place real-to-complex forward or complex-to-real inverse
C   In the complex domain C is in a packed format; the real part of
C   C(N/2+1) is in the imaginary part of C(1). The imaginary portions
C   of these words are always zero and this convention allows the size
C   of C to be the same in either domain.
C    Inputs:
C      C(2,N/2)  R    Vector to be FFTed if complex, or
C      C(N)      R    Vector to be FFTed if real.
C      N         I    Real element count (power of 2)
C      F         I    flag, 1=>forward FFT, -1=> reverse FFT.
C                     Forward = real-to-complex
C                     Reverse = complex to real
C    Outputs:
C      C(2,N/2)  R    FFTed Vector if complex, or
C      C(N)      R    FFTed Vector if real.
C      W(2,N)    R    Work Vector.
C    Subroutines called: FOURYF
C-----------------------------------------------------------------------
      INTEGER   N, F, H, Q, LOOP, JC, JI, JJ
      REAL      C(2,N), W(2,N), TEMPR, TWOPI, PHASE, PHAS0, DPHAS,
     *   SUMR, SUMI, DIFFR, DIFFI
C                                       TABLR, TABLI for 4096 FFTs
      REAL      TABLR(1024), TABLI(1024)
      INTEGER   NOLD
      SAVE      NOLD, TABLR, TABLI
      DATA TWOPI, NOLD /6.2831852,0/
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
C                                       Setup
      H = N / 2
      Q = H / 2
      JC = 1
      JI = 2
      JJ = H
C                                       See if table to be initialized
      IF (N.EQ.NOLD) GO TO 50
         NOLD = N
         PHAS0 = -TWOPI / 4.0
         DPHAS = -TWOPI / N
         DO 20 LOOP = 1,Q
            PHASE = PHAS0 + LOOP * DPHAS
            TABLR(LOOP) = COS (PHASE)
            TABLI(LOOP) = SIN (PHASE)
 20         CONTINUE
C                                       Separate code for for./rev. FFT
 50   IF (F.LT.0) GO TO 200
C                                       Forward (real to complex)
C                                       Complex FFT
         CALL FOURYF (C, H, F, W)
      INCLUDE 'INCS:ZVND.INC'
         DO 100 LOOP = 1,Q
            SUMR = C(1,JI) + C(1,JJ)
            SUMI = C(2,JI) - C(2,JJ)
            DIFFR = C(1,JI) - C(1,JJ)
            DIFFI = C(2,JI) + C(2,JJ)
            C(1,JI) = SUMR + (TABLR(LOOP) * DIFFR - TABLI(LOOP) *
     *         DIFFI)
            C(2,JI) = SUMI + (TABLI(LOOP) * DIFFR + TABLR(LOOP) *
     *         DIFFI)
            C(1,JJ) = SUMR - (TABLR(LOOP) * DIFFR - TABLI(LOOP) *
     *         DIFFI)
            C(2,JJ) = -SUMI + (TABLI(LOOP) * DIFFR + TABLR(LOOP) *
     *         DIFFI)
            JI = JI + 1
            JJ = JJ - 1
 100        CONTINUE
C                                       Pack
         TEMPR = 2.0 * (C(1,JC) + C(2,JC))
         C(2,JC) = 2.0 * (C(1,JC) - C(2,JC))
         C(1,JC) = TEMPR
         GO TO 999
C                                       Reverse (complex to real)
      INCLUDE 'INCS:ZVND.INC'
 200     DO 300 LOOP = 1,Q
            SUMR = C(1,JI) + C(1,JJ)
            SUMI = C(2,JI) - C(2,JJ)
            DIFFR = C(1,JI) - C(1,JJ)
            DIFFI = C(2,JI) + C(2,JJ)
            C(1,JI) = SUMR + (TABLR(LOOP) * DIFFR + TABLI(LOOP) *
     *         DIFFI)
            C(2,JI) = SUMI - (TABLI(LOOP) * DIFFR - TABLR(LOOP) *
     *         DIFFI)
            C(1,JJ) = SUMR - (TABLR(LOOP) * DIFFR + TABLI(LOOP) *
     *         DIFFI)
            C(2,JJ) = -SUMI - (TABLI(LOOP) * DIFFR - TABLR(LOOP) *
     *         DIFFI)
            JI = JI + 1
            JJ = JJ - 1
 300        CONTINUE
C                                       Pack
         TEMPR = (C(1,JC) + C(2,JC))
         C(2,JC) = (C(1,JC) - C(2,JC))
         C(1,JC) = TEMPR
         CALL FOURYF (C, H, F, W)
C
 999  RETURN
      END

      SUBROUTINE MFILL (ILUN, FILVAL, DATA, IERR)
C-----------------------------------------------------------------------
C! Fill a window in an image with a given value.
C# IO-WaWa Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   MFILL (for use with WAWA IO only) will fill a windowed section of
C   an open map file with a given value.
C    Inputs:
C     INLUN   I      map LUN.
C     FILVAL  R      fill value.
C     DATA    R(*)   IO buffer big enough for 1 row.
C Output:
C     IERR    I      standard WAWA IO error code.
C-----------------------------------------------------------------------
      REAL      DATA(*), FILVAL, XMIN, XMAX
      INTEGER   IBLC(7), ITRC(7), IERR, INODIM
      INTEGER   ILUN, I7, I6, I5, I4, I3, I2, I1
      INTEGER   IPIXS1, IPIXS2, IPIXS3, IPIXS4, IPIXS5, IPIXS6, IPIXS7
      INCLUDE 'INCS:DITB.INC'
C-----------------------------------------------------------------------
C                                       Initialize XMIN and XMAX
      XMIN = 1.0E30
      XMAX = - XMIN
C                                       Get window information
      CALL GETWIN (ILUN, INODIM, IBLC, ITRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Do fill.
      IPIXS1 = ITRC(1) - IBLC(1) + 1
      IPIXS2 = ITRC(2) - IBLC(2) + 1
      IPIXS3 = ITRC(3) - IBLC(3) + 1
      IPIXS4 = ITRC(4) - IBLC(4) + 1
      IPIXS5 = ITRC(5) - IBLC(5) + 1
      IPIXS6 = ITRC(6) - IBLC(6) + 1
      IPIXS7 = ITRC(7) - IBLC(7) + 1
      DO 700 I7 = 1,IPIXS7
      DO 600 I6 = 1,IPIXS6
      DO 500 I5 = 1,IPIXS5
      DO 400 I4 = 1,IPIXS4
      DO 300 I3 = 1,IPIXS3
      DO 200 I2 = 1,IPIXS2
         DO 100 I1 = 1,IPIXS1
            DATA(I1) = FILVAL
 100        CONTINUE
         CALL MAPIO ('WRIT', ILUN, DATA, IERR)
         IF (IERR.NE.0) GO TO 999
 200     CONTINUE
 300     CONTINUE
 400     CONTINUE
 500     CONTINUE
 600     CONTINUE
 700     CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'DFTPL.INC'
C                                       Local include for DFTPL
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XOPTYP(1), XSTOK(1), XSOUR(4),
     *   XCALC(1), XOUTXT(12)
      REAL      USERID, XSIN, XDISIN, UVRANG(2), TIMER(8), SHIFT(2),
     *   BPARM(10), XQUAL, XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF,
     *   XBCHAN, XECHAN, XANT(50), XBASL(50), XDOCAL, XGUSE, XDOPOL,
     *   XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH(3), DOCIRC,
     *   PRTLEV, XLABEL, XDOTV, XGRCH, BADD(10)
      DOUBLE PRECISION FOFF(MAXIF), DXC, DYC, DZC, RAS, DECS
      REAL      BUFF1(UVBFSS), TIMR(10000), DFT(10000,3), TBEG, TFIN,
     *   ERROR(10000,3), XYSCL(2,3), XYOFF(2,3), AREA(2), OFREQ, FRPIX,
     *   TAVG, XNUL, FINC(MAXIF), VRANGE(2,4)
      CHARACTER NAMEIN*12, CLAIN*6, OUTEXT*48, PLABL(3)*3, OPTYPE*4
      INTEGER   SEQIN, DISKIN, LUNI, INDI, LABEL, VER, NBASL, BCNT,
     *   TESTEM(2), JBUFSZ, GRCHN, TVCHN, TVCORN(4), NPARMS, IPLOT,
     *   FREQID, KNCS, KNCF, KNCIF, LTYPE, XVAR, NPOL, NXANT, IXANT(50),
     *   NXBASL, IXBASL(50)
      LOGICAL   UVREV, SCALEM(2), NOUVR, DOGRID, DOTV, PACKED, DESEL
      COMMON /INPARM/ USERID, XNAMEI, XCLAIN, XSIN, XDISIN, XOPTYP,
     *   UVRANG, TIMER, SHIFT, XSTOK, BPARM, XSOUR, XQUAL, XCALC, XBAND,
     *   XFREQ, XFQID, XSUBA, XBIF, XEIF, XBCHAN, XECHAN, XANT, XBASL,
     *   XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER,
     *   XSMOTH, DOCIRC, PRTLEV, XOUTXT, XLABEL, XDOTV, XGRCH, BADD
      COMMON /BUFRS/ BUFF1, JBUFSZ
      COMMON /FTPCOM/ FOFF, DXC, DYC, DZC, RAS, DECS, FINC, TIMR, DFT,
     *   ERROR, TBEG, TFIN, TAVG, XYSCL, XYOFF, OFREQ, FRPIX, AREA,
     *   XNUL, UVREV, SCALEM, NOUVR, DOGRID, NBASL, BCNT, SEQIN, DISKIN,
     *   LUNI, INDI, LABEL, VER, TESTEM, GRCHN, TVCHN, TVCORN, DOTV,
     *   NPARMS, IPLOT, FREQID, PACKED, KNCS, KNCF, KNCIF, LTYPE, XVAR,
     *   NPOL, VRANGE, NXANT, IXANT, NXBASL, IXBASL, DESEL
      COMMON /CHRCOM/ NAMEIN, CLAIN, OUTEXT, PLABL, OPTYPE
C                                                          End DFTPL.
LOCAL END
      PROGRAM DFTPL
C-----------------------------------------------------------------------
C! Plots summed uv data for a position in the sky as a function of time.
C# UV Plot-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000-2002, 2008-2009, 2012, 2014-2018,
C;  Copyright (C) 2021-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DFTPL creates a 'PL' extension file for display of the DFT of the
C   visibilities for an arbitrary position in the sky. Plots resulting
C   flux as a function of time. The data may be binned with arbitrary
C   averages in time.
C
C   NOTE 1: DFTPL wants the first key of the sort order of the UV data
C           base to be TIME.
C
C   NOTE 2: At present, DFTPL will only plot up to 10000 bins. For 5 s
C           averages this means roughly 17 minutes of plotting. For 1
C           min averages, more than 3 hrs, etc.
C
C   Inputs:
C     USERID                       UV data file owner # ignored
C     INNAME         NAMEIN        Name of input UV data.
C     INCLASS        CLAIN         Class of input UV data.
C     INSEQ          SEQIN         Seq. of input UV data.
C     INDISK         DISKIN        Disk number of input VU data.
C     UVRANGE....Range of UV projected spacings to include (Klambda)
C     TIMER......Selection parameters:
C        1 = Start IAT day (day 0 = first day in data base)
C        2 = Start IAT hour
C        3 = Start IAT minute
C        4 = Start IAT second
C        5 = Stop IAT day (day 0 = first day in data base)
C        6 = Stop IAT hour
C        7 = Stop IAT minute
C        8 = Stop IAT second
C        9 = Offset in right ascension (asec)
C       10 = Offset in declination (asec)
C     BPARM......Control parameters:
C        1 = 1 then plot RR data only
C            2      plot LL data only
C            3      plot RL data only
C            4      plot LR data only
C            5      plot IPOL
C            6      plot VPOL
C            7      plot QPOL
C            8      plot UPOL
C        2 = averaging interval in sec
C        3 = Do not autoscale if > zero, use following values:
C        4 = Minimum of X-axis,
C        5 = Maximum of X-axis,
C        6 = Minimum of Y-axis.
C        7 = Maximum of Y-axis,
C        8 = X to Y ratio
C        9 = 1 => write time, flux density, and error to message file
C                 but don't plot error bars
C            0 => do not write to message file or plot error bars
C           -1 => write stuff to message file AND plot error bars
C   DOCIRCLE   DOGRID      Draw ticks all the way across ?
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C
C   Written by T. Bastian, Univ. of Colorado, Aug. 1986
C   Used UVPLT as task template.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IERR, IRET, IPL
      INCLUDE 'DFTPL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'DFTPL '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL FTPIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Do DFT's
      CALL ACDFT (IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Print 'em up
      IF ((PRTLEV.GT.0.0) .OR. (OUTEXT.NE.' ')) THEN
         CALL PRTFT (IRET)
         IF (IRET.NE.0) GO TO 995
         END IF
C                                       Plot 'em up
      DO 20 IPL = 1,NPOL
         CALL PLTFT (IPL, IRET)
         IF (IRET.NE.0) GO TO 30
 20      CONTINUE
C                                       Clear catlg on error
 30   IF ((IRET.NE.0) .AND. (NCFILE.GE.1)) THEN
         CALL DELEXT ('PL', FVOL(1), FCNO(1), 'READ', CATBLK, BUFF1,
     *      VER, IERR)
         CALL ZCLOSE (LUNI, INDI, IERR)
         NCFILE = NCFILE - 1
         END IF
C                                       Close down
 995  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE FTPIN (PRGM, JERR)
C-----------------------------------------------------------------------
C   FTPIN gets input parameters for DFTPL .
C   Inputs:
C      PRGM    C*6    Program name
C   Output:
C      JERR    I      Error code: 0 => ok, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   JERR
C
      INCLUDE 'DFTPL.INC'
      CHARACTER BNDCOD(MAXIF)*8, CSTOK(11)*4
      INTEGER   OLDCNO, IUSER, I, IERR, IROUND, FQVER, NIF, CHBUFF(512),
     *   ISBAND(MAXIF), LUNCH
      REAL      CATR(256), RPARM(20), ST
      LOGICAL   T, ISFPA
      DOUBLE PRECISION RA0, DEC0, CATD(128)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (CATBLK, CATR, CATD)
      DATA T /.TRUE./
      DATA CSTOK /'RR', 'LL', 'I', 'V', 'Q', 'U', 'VV', 'HH', 'HALF',
     *   'IQU', 'FPA'/
C-----------------------------------------------------------------------
C                                       Init IO et al.
      CALL ZDCHIN (T, BUFF1)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
      VER = 10000
C                                       Get input parameters.
      NPARMS = 184
      CALL GTPARM (PRGM, NPARMS, RQUICK, USERID, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         JERR = 8
         RQUICK = .TRUE.
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR, 'GETTING USER ADVERB VALUES'
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      XVAR = BPARM(1) + 0.1
      IF ((XVAR.LE.0) .OR. (XVAR.GT.6)) XVAR = 1
      DOGRID = DOCIRC.GT.0.0
      USERID = NLUSER
      IUSER = NLUSER
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      TBEG = TIMER(1) + (TIMER(2)+(TIMER(3)+TIMER(4)/60.)/60.)/24.
      TFIN = TIMER(5) + (TIMER(6)+(TIMER(7)+TIMER(8)/60.)/60.)/24.
      IF (TFIN.LE.TBEG) TFIN = 1.E6
      IF (TBEG.LE.0.0) TBEG = -1.E6
      DOTV = XDOTV.GT.0.0
      GRCHN = IROUND (XGRCH)
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
      LABEL = IROUND (XLABEL)
      LTYPE = MOD (ABS(LABEL), 100)
      IF ((LTYPE.EQ.0) .OR. (LTYPE.GT.10)) LTYPE = 3
      IF (LTYPE.GT.7) LTYPE = 7
      IF ((LTYPE.GE.4) .AND. (LTYPE.LE.6)) LTYPE = 3
      IF (LABEL.LT.0) THEN
         LABEL = (LABEL/100)*100 + LTYPE
      ELSE
         LABEL = (LABEL/100)*100 - LTYPE
         END IF
      XLABEL = LABEL
      IPLOT = 1
      IF (ABS(BPARM(9)).GT.1.5) IPLOT = 2
      IF (ABS(BPARM(9)).GT.2.5) IPLOT = 3
      IF ((BPARM(10).LT.0.2) .OR. (BPARM(10).GT.10.0)) BPARM(10) = 1.
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XSTOK, STOKES)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (16, 1, XSOUR, SOURCS(1))
      CALL H2CHR (48, 1, XOUTXT, OUTEXT)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      SELQUA = IROUND (XQUAL)
      ISFPA = STOKES.EQ.'FPA'
      IF (ISFPA) STOKES = 'IQU'
C                                       Antennas
      CALL SETANT (50, XANT, XBASL, NXANT, NXBASL, IXANT, IXBASL, DESEL)
      IF ((NXANT.LE.0) .AND. (NXBASL.GT.0)) THEN
         CALL COPY (NXBASL, IXBASL, IXANT)
         NXANT = NXBASL
         NXBASL = 0
         END IF
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = .FALSE.
      CALL RCOPY (8, TIMER, TIMRNG)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
      BCHAN = XBCHAN
      ECHAN = XECHAN
      BIF = XBIF
      EIF = XEIF
C                                       Test UV range
      NOUVR = .FALSE.
      IF ((UVRANG(1).GE.UVRANG(2)) .OR. (UVRANG(1).LT.0.0)) THEN
         NOUVR = .TRUE.
         UVRANG(1) = 0.0
         UVRANG(2) = 1.E10
         END IF
      UVRNG(1) = UVRANG(1)
      UVRNG(2) = UVRANG(2)
      UVRANG(1) = UVRANG(1) * 1.0E3
      UVRANG(2) = UVRANG(2) * 1.0E3
C                                       Autoscale ?
      SCALEM(1) = (BPARM(3).LE.0.0) .OR. (BPARM(4).EQ.BPARM(5))
      SCALEM(2) = (BPARM(3).LE.0.0) .OR. (BPARM(6).EQ.BPARM(7))
      TESTEM(1) = 1
      IF (BPARM(4).GT.BPARM(5)) TESTEM(1) = -1
      IF ((BPARM(3).EQ.0.0) .OR. (BPARM(4).EQ.BPARM(5))) TESTEM(1) = 0
      TESTEM(2) = 1
      IF (BPARM(6).GT.BPARM(7)) TESTEM(2) = -1
      IF ((BPARM(3).EQ.0.0) .OR. (BPARM(6).EQ.BPARM(7))) TESTEM(2) = 0
C                                       X/Y ratio ?
      AREA(1) = 1000.
      AREA(2) = 1000.
      IF (BPARM(8).EQ.0.0) BPARM(8) = 1.0
      IF (BPARM(8).GT.1.0) AREA(2) = AREA(2) / BPARM(8)
      IF (BPARM(8).LT.1.0) AREA(1) = AREA(1) * BPARM(8)
C                                       Get CATBLK from UVGET
      CALL UVGET ('INIT', RPARM, BUFF1, IERR)
      IF (IERR.LT.0) THEN
         MSGTXT = 'INITIAL UVGET RETURNS NO DATA FOUND'
         GO TO 980
      ELSE IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'INITIAL UVGET CALL'
         GO TO 980
         END IF
C                                       save adverbs
      XSIN = IUSEQ
      XDISIN = IUDISK
      CALL CHR2H (12, UNAME, 1, XNAMEI)
      CALL CHR2H (6, UCLAS, 1, XCLAIN)
      OLDCNO = IUCNO
      XBCHAN = BCHAN
      XECHAN = ECHAN
      XBIF = BIF
      XEIF = EIF
      XSUBA = SUBARR
      CALL UVGET ('CLOS', RPARM, BUFF1, IERR)
      IF (NCFILE.LE.0) THEN
         NCFILE = 1
         FVOL(NCFILE) = IUDISK
         FCNO(NCFILE) = IUCNO
         FRW(NCFILE) = 0
         END IF
      CALL COPY (256, CATUV, CATBLK)
C                                       x axis needs
      IF (XVAR.NE.1) CALL GETANT (IUDISK, IUCNO, MAX (1, SUBARR),
     *   CATBLK, BUFF1, IERR)
C                                       UVPGET was called for output
      IF ((ILOCSU.GE.0) .OR. ((RA.EQ.0.0D0) .AND. (DEC.EQ.0.0D0))) THEN
         IERR = 8
         MSGTXT = 'YOU MUST SELECT ONLY ONE SOURCE'
         GO TO 980
         END IF
C                                       Source offsets
      RA0 = RA
      DEC0 = DEC
      IF (COS(DG2RAD*DEC0).NE.0.0D0) RA = RA0 + SHIFT(1) / 3600.D0
     *   / COS(DG2RAD * DEC0)
      DEC = DEC + SHIFT(2) / 3600.D0
      RAS = RA
      DECS = DEC
      DXC = SIN (DG2RAD * (RA-RA0)) * COS (DEC * DG2RAD)
      DYC = COS (DEC0 * DG2RAD) * SIN (DEC * DG2RAD) -
     *   SIN (DEC0 * DG2RAD) * COS (DEC * DG2RAD) *
     *   COS ((RA - RA0) * DG2RAD)
      DZC = SIN (DG2RAD * DEC0) * SIN (DG2RAD * DEC) +
     *   COS (DG2RAD * DEC0) * COS (DG2RAD * DEC) *
     *   COS (DG2RAD * (RA - RA0)) - 1.0D0
      DXC = TWOPI * DXC
      DYC = TWOPI * DYC
      DZC = TWOPI * DZC
C                                       Sort order OK ?
      IF (ISORT(:1).NE.'T') THEN
         MSGTXT = 'FIRST KEY OF SORT ORDER MUST BE TIME !!'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 999
         END IF
C                                       Frequency and bandwidth
      IF (JLOCIF.LT.0) THEN
         FOFF(1) = 0.0D0
         FINC(1) = CATR(KRCIC+JLOCF)
      ELSE
         FQVER = 1
         LUNCH = 87
         CALL CHNDAT ('READ',  CHBUFF, DISKIN, OLDCNO, FQVER, CATBLK,
     *      LUNCH, NIF, FOFF, ISBAND, FINC, BNDCOD, FREQID, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR
            CALL MSGWRT (7)
            JERR = 1
            GO TO 999
            END IF
         END IF
      OFREQ = CATD(KDCRV+JLOCF)
      FRPIX = CATR(KRCRP+JLOCF)
C                                       Update catalog header.
      FRW(NCFILE) = 0
      JERR = 0
C                                       Check correlator display
      IF (ISFPA) STOKES = 'FPA'
      DO 20 I = 1,11
         IF (STOKES.EQ.CSTOK(I)) THEN
            BPARM(1) = I
            IF (I.LT.9) THEN
               NPOL = 1
               PLABL(1) = CSTOK(I)
            ELSE IF (I.EQ.9) THEN
               ST = CATD(KDCRV+JLOCS) + (1.0-CATR(KRCRP+JLOCS)) *
     *            CATR(KRCIC+JLOCS)
               IF (ST.LT.-4.5) THEN
                  PLABL(1) = 'VV'
                  PLABL(2) = 'HH'
               ELSE
                  PLABL(1) = 'RR'
                  PLABL(2) = 'LL'
                  END IF
               NPOL = 2
            ELSE IF (I.EQ.10) THEN
               NPOL = 3
               PLABL(1) = 'I'
               PLABL(2) = 'Q'
               PLABL(3) = 'U'
            ELSE
               STOKES = 'IQU'
               NPOL = 3
               PLABL(1) = 'P/I'
               PLABL(2) = 'P'
               PLABL(3) = 'PA'
               END IF
            GO TO 999
            END IF
 20      CONTINUE
C                                       Stokes unavailable
      WRITE (MSGTXT,1900) STOKES
      JERR = 1
C
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FTPIN: ERROR',I3,' ON ',A)
 1050 FORMAT ('ERROR',I5,' READING FREQUENCIES WITH CHNDAT')
 1900 FORMAT ('REQUESTED STOKES PARAMETER ''',A,''' NOT ALLOWED')
      END
      SUBROUTINE ACDFT (IRET)
C-----------------------------------------------------------------------
C   ACDFT accumlates the flux density for each averaging interval as
C   well as an estimate of the error. Also sets scaling for later use.
C   Output:
C      IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'DFTPL.INC'
      INTEGER   FLAG, NUMVIS, XUMVIS, IA1, IA2
      REAL      XY(2,3), Z(2), VIS(UVBFSS), RPARM(20), BASEN
      DOUBLE PRECISION T1, T2
      LOGICAL   REQBAS
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
C                                       Set up binning
      XNUL = FBLANK
      CALL RFILL (10000, XNUL, DFT)
      CALL RFILL (10000, XNUL, TIMR)
      CALL RFILL (10000, 0.0, ERROR)
C                                       Get start/stop times
      CALL TBTIME (TBEG, TFIN, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINDING START AND STOP TIMES'
         GO TO 990
         END IF
C                                       set bin count, T averaging
      BCNT = 1
      IF (BPARM(2).LE.0.001) BPARM(2) = 864. * (TFIN - TBEG)
      TAVG = BPARM(2) / 86400.
      T1 = TBEG
      T2 = T1 + TAVG
C                                       Init vis file for read.
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT UV IO'
         GO TO 990
         END IF
      NUMVIS = 0
      XUMVIS = 0
      KNCS = INCS
      KNCF = INCF
      KNCIF = INCIF
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING UV DATA'
         GO TO 990
      ELSE IF (IRET.EQ.0) THEN
C                                       antenna/baseline
         IF (ILOCB.GE.0) THEN
            BASEN = RPARM(1+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
            END IF
         IF (.NOT.REQBAS (IA1, IA2, DESEL, IXANT, NXANT, IXBASL,
     *      NXBASL)) GO TO 100
C                                       Is this a valid point ?
 125     CALL WANTED (RPARM, VIS, T1, T2, FLAG)
C                                       Bad point, try again
         IF (FLAG.EQ.1) GO TO 100
C                                       End of time search
         IF (FLAG.EQ.3) GO TO 200
C                                       Next time interval
         IF (FLAG.EQ.2) THEN
            CALL DODFT (RPARM, VIS, T1, T2, FLAG, IRET)
            T1 = T2
            T2 = T1 + TAVG
            GO TO 125
            END IF
C                                       Good point
         CALL DODFT (RPARM, VIS, T1, T2, FLAG, IRET)
         XUMVIS = XUMVIS + 1
         GO TO 100
         END IF
C                                       Any valid points
 200  IF (XUMVIS.LE.1) THEN
         IRET = 4
         WRITE (MSGTXT,1200) XUMVIS
         GO TO 990
         END IF
C                                       Get plot ranges and scales
      BCNT = BCNT - 1
      CALL XYSCAL (XY, Z, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1110) IRET
         GO TO 990
         END IF
C                                       close UV data
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ACDFT: ERROR',I3,' ON ',A)
 1110 FORMAT ('ACDFT: XYSCL ERROR',I3)
 1200 FORMAT ('FOUND',I5,' POINTS: NOT ENOUGH TO SELF-SCALE')
      END
      SUBROUTINE PRTFT (IRET)
C-----------------------------------------------------------------------
C   Print the dfts
c   Output
c      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'DFTPL.INC'
      INTEGER   I, LUN, FIND, IP, J, JTRIM, ITT(4)
      REAL      XM(3), XT, YT
      LOGICAL   PFLAG
      CHARACTER PREFIX(3)*5, OUTLIN*132, XLAB(6)*10, JY(3)*7, TSIGN*1,
     *   ER(3)*7
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN /3/
      DATA XLAB /'Time', 'Elevation', 'Hour angle', 'LST',
     *   'Par angle', 'Azimuth'/
      DATA JY /3*'Janskys'/
      DATA ER /3*'JyError'/
C-----------------------------------------------------------------------
      DO 10 IP = 1,NPOL
         XT = MAX (ABS(VRANGE(2,IP+1)), ABS(VRANGE(1,IP+1)))
         YT = XT
         CALL METSCA (XT, PREFIX(IP), PFLAG)
         XM(IP) = XT / YT
 10      CONTINUE
      IF (OUTEXT.NE.' ') THEN
         CALL ZTXOPN ('WRIT', LUN, FIND, OUTEXT, .TRUE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT TEXT FILE'
            GO TO 990
            END IF
         WRITE (OUTLIN,2000) XLAB(XVAR), (PLABL(IP), IP = 1,NPOL),
     *      (PLABL(IP), IP = 1,NPOL)
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', LUN, FIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         WRITE (OUTLIN,2010) (PREFIX(IP), IP = 1,NPOL),
     *      (PREFIX(IP), IP = 1,NPOL)
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', LUN, FIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         IF (BPARM(1).LT.11) THEN
            WRITE (OUTLIN,2020) (JY(IP), IP = 1,NPOL),
     *         (ER(IP), IP = 1,NPOL)
         ELSE
            WRITE (OUTLIN,2021)
            END IF
         J = JTRIM (OUTLIN)
         CALL ZTXIO ('WRIT', LUN, FIND, OUTLIN(:J), IRET)
         IF (IRET.NE.0) GO TO 980
         DO 20 I = 1,BCNT
            IF (XVAR.EQ.1) THEN
               CALL T2DHMS (TIMR(I), TSIGN, ITT)
               WRITE (OUTLIN,2030) I, ITT, (DFT(I,IP)*XM(IP),
     *            IP = 1,NPOL), (ERROR(I,IP)*XM(IP), IP = 1,NPOL)
            ELSE
               WRITE (OUTLIN,2031) I, TIMR(I), (DFT(I,IP)*XM(IP),
     *            IP = 1,NPOL), (ERROR(I,IP)*XM(IP), IP = 1,NPOL)
               END IF
            DO 15 IP = 1,NPOL
               IF (DFT(I,IP).EQ.FBLANK) THEN
                  J = 17 + (IP-1) * 10
                  OUTLIN(J:J+9) = '     Inde '
                  END IF
               IF (ERROR(I,IP).EQ.FBLANK) THEN
                  J = 17 + 10*NPOL + (IP-1)*10
                  OUTLIN(J:J+9) = '     Inde '
                  END IF
 15            CONTINUE
            J = JTRIM (OUTLIN)
            CALL ZTXIO ('WRIT', LUN, FIND, OUTLIN(:J), IRET)
            IF (IRET.NE.0) GO TO 980
 20         CONTINUE
         CALL ZTXCLS (LUN, FIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSING TEXT FILE'
            GO TO 990
         END IF
      ELSE IF (NPOL.LT.3) THEN
         WRITE (MSGTXT,2000) XLAB(XVAR), (PLABL(IP), IP = 1,NPOL),
     *      (PLABL(IP), IP = 1,NPOL)
         CALL MSGWRT (3)
         WRITE (MSGTXT,2010) (PREFIX(IP), IP = 1,NPOL),
     *      (PREFIX(IP), IP = 1,NPOL)
         CALL MSGWRT (3)
         IF (BPARM(1).LT.11) THEN
            WRITE (MSGTXT,2020) (JY(IP), IP = 1,NPOL),
     *         (ER(IP), IP = 1,NPOL)
         ELSE
            WRITE (MSGTXT,2021)
            END IF
         CALL MSGWRT (3)
         DO 30 I = 1,BCNT
            IF (XVAR.EQ.1) THEN
               CALL T2DHMS (TIMR(I), TSIGN, ITT)
               WRITE (MSGTXT,2030) I, ITT, (DFT(I,IP)*XM(IP),
     *            IP = 1,NPOL), (ERROR(I,IP)*XM(IP), IP = 1,NPOL)
            ELSE
               WRITE (MSGTXT,2031) I, TIMR(I), (DFT(I,IP)*XM(IP),
     *            IP = 1,NPOL), (ERROR(I,IP)*XM(IP), IP = 1,NPOL)
               END IF
            DO 25 IP = 1,NPOL
               IF (DFT(I,IP).EQ.FBLANK) THEN
                  J = 17 + (IP-1) * 10
                  MSGTXT(J:J+9) = '     Inde '
                  END IF
               IF (ERROR(I,IP).EQ.FBLANK) THEN
                  J = 17 + 10*NPOL + (IP-1)*10
                  MSGTXT(J:J+9) = '     Inde '
                  END IF
 25            CONTINUE
            CALL MSGWRT (3)
 30         CONTINUE
      ELSE
         WRITE (MSGTXT,2300) XLAB(XVAR), (PLABL(IP), IP = 1,NPOL),
     *      (PLABL(IP), IP = 1,NPOL)
         CALL MSGWRT (3)
         WRITE (MSGTXT,2310) (PREFIX(IP), IP = 1,NPOL),
     *      (PREFIX(IP), IP = 1,NPOL)
         CALL MSGWRT (3)
         IF (BPARM(1).LT.11) THEN
            WRITE (MSGTXT,2320) (JY(IP), IP = 1,NPOL),
     *         (ER(IP), IP = 1,NPOL)
         ELSE
            WRITE (MSGTXT,2321)
            END IF
         CALL MSGWRT (3)
         DO 40 I = 1,BCNT
            IF (XVAR.EQ.1) THEN
               CALL T2DHMS (TIMR(I), TSIGN, ITT)
               WRITE (MSGTXT,2330) I, ITT, (DFT(I,IP)*XM(IP),
     *            IP = 1,NPOL), (ERROR(I,IP)*XM(IP), IP = 1,NPOL)
            ELSE
               WRITE (MSGTXT,2331) I, TIMR(I), (DFT(I,IP)*XM(IP),
     *            IP = 1,NPOL), (ERROR(I,IP)*XM(IP), IP = 1,NPOL)
               END IF
            DO 35 IP = 1,NPOL
               IF (DFT(I,IP).EQ.FBLANK) THEN
                  J = 17 + (IP-1) * 8
                  MSGTXT(J:J+7) = '    Inde'
                  END IF
               IF (ERROR(I,IP).EQ.FBLANK) THEN
                  J = 18 + 7*NPOL + (IP-1)*8
                  MSGTXT(J:J+7) = '    Inde'
                  END IF
 35            CONTINUE
            CALL MSGWRT (3)
 40         CONTINUE
         END IF
      GO TO 999
C
 980  WRITE (MSGTXT,1000) IRET, 'WRITING OUTPUT TEXT FILE'
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PRTFT ERROR',I4,' ON ',A)
 2000 FORMAT (6X,A,5X,6(A,7X))
 2010 FORMAT (16X,4X,6(A,5X))
 2020 FORMAT (18X,6(A,3X))
 2021 FORMAT (16X,10X,'   Janskys','   Degrees',5X,'Error',2X,
     *   'Jy Error','   Deg Err')
 2030 FORMAT (I5,I2,'/',2(I2.2,':'),I2.2,6F10.3)
 2031 FORMAT (I5,F8.2,3X,6F10.3)
C
 2300 FORMAT (6X,A,3X,6(A,5X))
 2310 FORMAT (17X,2X,6(A,3X))
 2320 FORMAT (17X,6(A,1X))
 2321 FORMAT (16X,8X,' Janskys',' Degrees','   Error',' JyError',
     *   ' Deg Err')
 2330 FORMAT (I5,I2,'/',2(I2.2,':'),I2.2,6F8.3)
 2331 FORMAT (I5,F8.2,3X,6F8.3)
      END
      SUBROUTINE XYSCAL (XY, Z, IRET)
C-----------------------------------------------------------------------
C   XYSCAL converts to FPA if reqested, finds max/min over data, and
C   finds the scaling parameters needed to fit X and Y into a 1000x1000
C   plotting area .
C   Outputs:
C      XY      R(2,3)   Min, max of up to 3 parameters
C      Z       R(2)     X axis min max
C      XYOFF   R(2,3)   when added to XY changes minimum to zero .
C      XYSCL   R(2,3)   scale XY so that maximum is 1000.
C      IRET    I        Error return code , non-zero if error .
C-----------------------------------------------------------------------
      REAL      XY(2,3), Z(2)
      INTEGER   IRET
c
      INTEGER   I, IROUND, J, IP
      REAL      RI, RQ, RU, EI, EQ, EU, RP, EP, TEMP
      INCLUDE 'DFTPL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       convert to FPA
      IF (BPARM(1).EQ.11) THEN
         DO 20 I = 1,BCNT
            RI = DFT(I,1)
            RQ = DFT(I,2)
            RU = DFT(I,3)
            EI = ERROR(I,1)
            EQ = ERROR(I,2)
            EU = ERROR(I,3)
            IF ((RI.EQ.FBLANK) .OR. (RQ.EQ.FBLANK) .OR. (RU.EQ.FBLANK)
     *         .OR. (EI.EQ.FBLANK) .OR. (EQ.EQ.FBLANK) .OR.
     *         (EU.EQ.FBLANK) .OR. (RI.EQ.0.0)) THEN
               DFT(I,1) = FBLANK
               DFT(I,2) = FBLANK
               DFT(I,3) = FBLANK
               ERROR(I,1) = FBLANK
               ERROR(I,2) = FBLANK
               ERROR(I,3) = FBLANK
            ELSE
               RP = SQRT (RQ*RQ + RU*RU)
               DFT(I,2) = RP
               DFT(I,1) = RP / RI
               DFT(I,3) = 0.5 * RAD2DG * ATAN2 (RU, RQ)
               EP = SQRT ((RQ * EQ)**2 + (RU * EU)**2) / RP
               ERROR(I,2) = EP
               ERROR(I,1) = SQRT (EP**2 + (RP*EI/RI)**2) / RI
               ERROR(I,3) = (1.0/(1.0+(RU/RQ)**2)) *
     *            SQRT ((EU/RQ)**2 + (RU/RQ/RQ*EQ)**2) * 0.5 * RAD2DG
               END IF
 20         CONTINUE
         END IF
C                                       MAX/MIN
      XY(1,1) = 1.E10
      XY(2,1) = -1.E10
      XY(1,2) = 1.E10
      XY(2,2) = -1.E10
      XY(1,3) = 1.E10
      XY(2,3) = -1.E10
      CALL RCOPY (2, XY, Z)
      I = IROUND (BPARM(9))
      IF (I.EQ.2) THEN
         DO 30 I = 1,BCNT
            IF (TIMR(I).NE.FBLANK) THEN
               Z(1) = MIN (Z(1), TIMR(I))
               Z(2) = MAX (Z(2), TIMR(I))
               DO 25 IP = 1,NPOL
                  IF (DFT(I,IP).NE.FBLANK) THEN
                     RI = DFT(I,IP) - ERROR(I,IP)
                     XY(1,IP) = MIN (XY(1,IP), RI)
                     XY(2,IP) = MAX (XY(2,IP), RI)
                     RI = DFT(I,IP) + ERROR(I,IP)
                     XY(1,IP) = MIN (XY(1,IP), RI)
                     XY(2,IP) = MAX (XY(2,IP), RI)
                     END IF
 25               CONTINUE
               END IF
 30         CONTINUE
      ELSE
         DO 40 I = 1,BCNT
            IF (TIMR(I).NE.FBLANK) THEN
               Z(1) = MIN (Z(1), TIMR(I))
               Z(2) = MAX (Z(2), TIMR(I))
               DO 35 IP = 1,NPOL
                  IF (DFT(I,IP).NE.FBLANK) THEN
                     RI = DFT(I,IP)
                     XY(1,IP) = MIN (XY(1,IP), RI)
                     XY(2,IP) = MAX (XY(2,IP), RI)
                     END IF
 35               CONTINUE
               END IF
 40         CONTINUE
         END IF
      CALL RCOPY (2, Z, VRANGE(1,1))
      CALL RCOPY (6, XY, VRANGE(1,2))
C                                       Are they in requested range
      J = IROUND (BPARM(3))
      IF (J.GT.0) THEN
         IF (BPARM(4).LT.BPARM(5)) THEN
            Z(1) = BPARM(4)
            Z(2) = BPARM(5)
            END IF
         IF (BPARM(6).LT.BPARM(7)) THEN
            DO 45 IP = 1,NPOL
               XY(1,IP) = BPARM(6)
               XY(2,IP) = BPARM(7)
 45            CONTINUE
            END IF
      ELSE IF (J.LT.0) THEN
         IF (BPARM(4).LT.BPARM(5)) THEN
            Z(1) = MAX (Z(1), BPARM(4))
            Z(2) = MIN (Z(2), BPARM(5))
            END IF
         IF (BPARM(6).LT.BPARM(7)) THEN
            DO 50 IP = 1,NPOL
               XY(1,IP) = MAX (XY(1,IP), BPARM(6))
               XY(2,IP) = MIN (XY(2,IP), BPARM(7))
 50            CONTINUE
            END IF
         END IF
C                                       Convert to scaling factors
C                                       provide room at edges too.
      TEMP = 0.01 * (Z(2) - Z(1))
      Z(1) = Z(1) - TEMP
      Z(2) = Z(2) + TEMP
      XYOFF(1,1) = Z(1)
      XYSCL(1,1)  = AREA(1) / (Z(2) - Z(1))
      DO 100 IP = 1,NPOL
         XYOFF(1,IP) = XYOFF(1,1)
         XYSCL(1,IP) = XYSCL(1,1)
         TEMP = 0.01 * (XY(2,IP) - XY(1,IP))
         XY(1,IP) = XY(1,IP) - TEMP
         XY(2,IP) = XY(2,IP) + TEMP
         XYOFF(2,IP) = XY(1,IP)
         XYSCL(2,IP) = AREA(2) / (XY(2,IP) - XY(1,IP))
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE WANTED (RPBUF, VIS, T1, T2, FLAG)
C-----------------------------------------------------------------------
C   WANTED determines whether the current visibility sample is valid
C   and selected via the selection parameters.
C   Inputs:
C      RPBUF   R(*)   Random parameters
C      VIS     R(*)   Visibilities
C      T1      D      Start desired time range
C      T2      D      End desired time range
C   Outputs:
C      FLAG    I      0 => data selected as good
C                     1    data NO GOOD
C                     2    time exceeds T2
C                     3    time exceeds TFIN
C-----------------------------------------------------------------------
      REAL      RPBUF(*), VIS(*)
      DOUBLE PRECISION T1, T2
      INTEGER   FLAG
C
      REAL      TEMP
      INTEGER   LAD, IIF, ICH, IROUND
      LOGICAL   GOOD, ANY
      INCLUDE 'DFTPL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
      FLAG = 1
C                                       Check FREQID
      IF (ILOCFQ.GE.0) THEN
         IIF = IROUND (RPBUF(1+ILOCFQ))
         IF ((FREQID.GT.0) .AND. (IIF.GT.0) .AND. (IIF.NE.FREQID))
     *      GO TO 999
         END IF
C                                       Check UV range
      IF (.NOT.NOUVR) THEN
         TEMP = SQRT (RPBUF(1+ILOCU)**2 + RPBUF(1+ILOCV)**2)
         IF ((TEMP.LT.UVRANG(1)) .OR. (TEMP.GT.UVRANG(2))) GO TO 999
         END IF
C                                       Are data flagged?
      ANY = .FALSE.
      DO 20 IIF = BIF,EIF
         DO 10 ICH = BCHAN,ECHAN
            LAD = 1 + (IIF-BIF)*KNCIF + (ICH-BCHAN)*KNCF
            GOOD = VIS(LAD+2).GT.0.0
            ANY = ANY .OR. GOOD
 10         CONTINUE
 20      CONTINUE
      IF (.NOT.ANY) GO TO 999
C                                       Test time range
      TEMP = RPBUF(1+ILOCT)
      IF (TEMP.LT.T1) GO TO 999
      FLAG = 2
      IF (TEMP.GE.T2) GO TO 999
      FLAG = 3
      IF (TEMP.GT.TFIN) GO TO 999
      FLAG = 0
C
 999  RETURN
      END
      SUBROUTINE PLTFT (IPL, IRET)
C-----------------------------------------------------------------------
C   PLTFT actually plots the data.
C   Input
C      IPL    I    Data polarization
C   Output:
C      IRET   I    Return code, 0 => OK, otherwise abort.
C                     1 => failed to add to catalog
C                     2 => failed to create
C                     3 => graph file write error
C                     4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   IPL, IRET
C
      CHARACTER TEXT*80, PFILE*48, CHTYPE(6)*20, AUNITS(6)*20,
     *   NAMCL*18, TIME*8, DATE*12, TS*1, CHR*1, CHD*1, FPATYP(3)*8,
     *   CTEMP*4
      INTEGER   BUFFER(256), IERR, ITYPE, IPSIZE, I, INCHAR, LUNPL,
     *   FINDPL, ITIM(8), INP, IBIN, NGOOD, NNOFIT, IT(3), ID(3),
     *   HMR(2), HMD(2)
      REAL      BLC(2), TRC(2), CHOUT(4), XYRATO, DX, DY, TR, TI, XY(2),
     *   XXFREQ, SECR, SECD
      LOGICAL   GOOD, DOHST
      INCLUDE 'DFTPL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGPH.INC'
      DATA LUNPL /26/
      DATA AUNITS /'IAT hours', 'EL degrees', 'HA hours', 'LST hours',
     *   'PA degrees', 'AZ degrees'/
      DATA CHTYPE /'Time', 'Elevation', 'Hour angle', 'LST',
     *   'Parallactic Angle', 'Azimuth'/
      DATA FPATYP /'Ratio','Janskys','Degrees'/
C-----------------------------------------------------------------------
      NGOOD = 0
      NNOFIT = 0
      IRET = 1
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', DISKIN, FCNO(1), CATUV, BUFF1, .TRUE.,
     *      'UPDT', VER, IRET)
         IF (IRET.NE.0) THEN
            NCFILE = NCFILE - 1
            GO TO 999
            END IF
         END IF
C                                       Fill in last of actual parms
      BPARM(5) = AREA(1)/XYSCL(1,IPL) + XYOFF(1,IPL)
      BPARM(7) = AREA(2)/XYSCL(2,IPL) + XYOFF(2,IPL)
      BPARM(4) = XYOFF(1,IPL)
      BPARM(6) = XYOFF(2,IPL)
      DOHST = IPLOT.EQ.3
      CALL RFILL (8, 0.0, TIMER)
      TIMER(1) = TBEG
      TIMER(5) = TFIN
      XFLAG = FGVER
      CTEMP = PLABL(IPL)
      CALL CHR2H (4, CTEMP, 1, XSTOK)
C                                       Create plot file
      CALL ZPHFIL ('PL', DISKIN, FCNO(1), VER, PFILE, IERR)
      IF (IERR.NE.0) GO TO 999
      IPSIZE = 0
      ITYPE = 23
      CALL GINIT (DISKIN, FCNO(1), PFILE, IPSIZE, ITYPE, NPARMS, USERID,
     *   DOTV, TVCHN, GRCHN, TVCORN, CATUV, BUFFER, LUNPL, FINDPL,
     *   IERR)
      IRET = 2
      IF (IERR.NE.0) GO TO 999
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = AREA(1)
      TRC(2) = AREA(2)
      XYRATO = BPARM(8)
      IRET = 3
      CALL FILL (5, 1, ITIM)
C                                       Set up location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      DO 30 I = 1,2
         TR = AREA(I) / XYSCL(I,IPL)
         RPLOC(I,LOCNUM) = BLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I,IPL)
         AXINC(I,LOCNUM) = TR / (TRC(I) - BLC(I))
         IF (I.EQ.2) THEN
            CTYP(I,LOCNUM) = 'Janskys'
            IF (OPTYPE.EQ.'PHAS') CTYP(I,LOCNUM) = 'Degrees'
            IF (BPARM(1).EQ.11) CTYP(I,LOCNUM) = FPATYP(IPL)
            TR = MAX (ABS(TR), ABS(XYOFF(2,IPL)), ABS(TR+XYOFF(2,IPL)))
            TI = TR
            CALL METSCL (LABEL, TR, CPREF(I,LOCNUM), GOOD)
            RPVAL(I,LOCNUM) = RPVAL(I,LOCNUM) * TR / TI
            AXINC(I,LOCNUM) = AXINC(I,LOCNUM) * TR / TI
         ELSE
            CPREF(I,LOCNUM) = ' '
            CTYP(I,LOCNUM) = AUNITS(XVAR)
            IF ((XVAR.EQ.1) .OR. (XVAR.EQ.3) .OR. (XVAR.EQ.4)) THEN
                LABTYP(LOCNUM) = 7
                IF (XVAR.GT.1) LABTYP(LOCNUM) = 5 + XVAR
                RPVAL(I,LOCNUM) = RPVAL(I,LOCNUM) * 360.
                AXINC(I,LOCNUM) = AXINC(I,LOCNUM) * 360.
                END IF
            END IF
 30      CONTINUE
C                                       number characters around
      CALL RFILL (4, 0.5, CHOUT)
      CALL CHNTIC (BLC, TRC, INP)
      IF (LTYPE.EQ.2) CHOUT(1) = 2.5
      IF (LTYPE.GT.2) CHOUT(1) = INP + 4.0
      IF (LTYPE.GT.1) CHOUT(2) = 2.0
      IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         CHOUT(4) = 3.333
         IF (LABEL.GT.1) CHOUT(4) = CHOUT(4) + 1.333
         IF (.NOT.NOUVR) CHOUT(4) = CHOUT(4) + 1.333
         IF ((TBEG.GE.-1.E5) .OR. (TFIN.LE.1.0E5)) CHOUT(4) =
     *      CHOUT(4) + 1.333
         END IF
C                                       Init for line drawing.
      CALL GINITL (BLC, TRC, XYRATO, CHOUT, ITIM, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 975
C                                       Draw border
      CALL GLTYPE (1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (BLC(1), BLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (TRC(1), BLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (TRC(1), TRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (BLC(1), TRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Top labels: version number
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DX = 0.0
         DY = CHOUT(4) - 1.5
         IF (LABEL.GT.1) THEN
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, TIME, DATE)
            WRITE (TEXT,1030) VER, DATE, TIME
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            DY = DY - 1.333
            END IF
C                                       Top labels: type & name
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         TEXT = 'DFT vs ' // CHTYPE(XVAR) // ' for '
         NAMCL = NAMEIN
         NAMCL(13:18) = CLAIN
         CALL NAMEST (NAMCL, SEQIN, TEXT(26:), INCHAR)
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         DY = DY - 1.333
C                                       Time range, ra, dec
         IF ((TBEG.GE.-1.E5) .OR. (TFIN.LE.1.0E5)) THEN
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL COORDD (1, RAS, CHR, HMR, SECR)
            CALL COORDD (2, DECS, CHD, HMD, SECD)
            CALL T2DHMS (TBEG, TS, ITIM(1))
            CALL T2DHMS (TFIN, TS, ITIM(5))
            ITIM(1) = MIN (ITIM(1), 999)
            ITIM(5) = MIN (ITIM(5), 999)
            WRITE (TEXT,1035) (ITIM(I), I = 1,8), HMR, SECR, CHD, HMD,
     *         SECD
            IF (TEXT(46:46).EQ.' ') TEXT(46:46) = '0'
            IF (TEXT(64:64).EQ.' ') TEXT(64:64) = '0'
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            DY = DY - 1.333
            END IF
C                                       UV range
         IF (.NOT.NOUVR) THEN
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            WRITE (TEXT,1040) UVRANG
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            DY = DY - 1.333
            END IF
C                                       Frequency, etc.
         XXFREQ = (OFREQ + FOFF(BIF) + ((ECHAN+BCHAN+1.)/2. - FRPIX) *
     *      FINC(BIF)) / 1.E9
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         WRITE (TEXT,1045) OPTYPE, PLABL(IPL), BCHAN, ECHAN, BIF, EIF,
     *      XXFREQ
         IF (ECHAN.EQ.BCHAN) TEXT(32:39) = ' '
         IF (EIF.EQ.BIF) TEXT(47:51) = ' '
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Put on labels and ticks
      XYRATO = 1.0
      CALL CLAB1 (BLC, TRC, CHOUT, LABEL, XYRATO, DOGRID, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Plot binned data.
      IF (.NOT.DOHST) THEN
         CALL GLTYPE (4, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         DX = 3.0 * BPARM(10)
         DO 110 IBIN = 1,BCNT
C                                       Points ...
            IF (DFT(IBIN,IPL).NE.XNUL) THEN
               NGOOD = NGOOD + 1
               DY = ERROR(IBIN,IPL) * XYSCL(2,IPL)
               IF (IPLOT.EQ.1) DY = 3.0 * BPARM(10)
               XY(1) = (TIMR(IBIN) - XYOFF(1,IPL))*XYSCL(1,IPL)
               XY(2) = (DFT(IBIN,IPL) - XYOFF(2,IPL))*XYSCL(2,IPL)
               IF ((XY(2).GE.BLC(2)) .AND. (XY(2).LE.TRC(2))) THEN
                  CALL GPOS (XY(1)+DX, XY(2), BUFFER, IRET)
                  IF (IRET.NE.0) GO TO 970
                  CALL GVEC (XY(1)-DX, XY(2), BUFFER, IRET)
                  IF (IRET.NE.0) GO TO 970
                  CALL GPOS (XY(1), XY(2)+DY, BUFFER, IRET)
                  IF (IRET.NE.0) GO TO 970
                  CALL GVEC (XY(1), XY(2)-DY, BUFFER, IRET)
                  END IF
               END IF
 110        CONTINUE
C                                       Histogram mode ...
      ELSE
         DX = TAVG*XYSCL(1,IPL)/2.0
         CALL GLTYPE (2, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 970
         DO 210 IBIN = 1,BCNT
            IF (DFT(IBIN,IPL).NE.XNUL) THEN
               NGOOD = NGOOD + 1
               XY(1) = (TIMR(IBIN) - XYOFF(1,IPL))*XYSCL(1,IPL)
               XY(2) = (DFT(IBIN,IPL) - XYOFF(2,IPL))*XYSCL(2,IPL)
               DY = 0.0
               IF (DFT(IBIN+1,IPL).NE.XNUL) DY =
     *            (DFT(IBIN+1,IPL)-DFT(IBIN,IPL))*XYSCL(2,IPL)
               IF (((XY(2)+DY).GT.AREA(2)) .OR.
     *            ((XY(2)+DY).LT.0.0)) DY = 0.0
               IF ((XY(2).GE.BLC(2)) .AND. (XY(2).LE.TRC(2))) THEN
                  CALL GPOS (XY(1)-DX, XY(2), BUFFER, IRET)
                  IF (IRET.NE.0) GO TO 970
                  CALL GVEC (XY(1)+DX, XY(2), BUFFER, IRET)
                  IF (IRET.NE.0) GO TO 970
                  CALL GVEC (XY(1)+DX, XY(2)+DY, BUFFER, IRET)
                  END IF
               END IF
 210        CONTINUE
         END IF
      GPHPAG = IPL.LT.NPOL
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.NE.0) GO TO 975
         IRET = 0
         GO TO 990
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 990
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         END IF
      GO TO 999
C                                       No catalog update
C                                       Messages
 990  WRITE (MSGTXT,1990) NGOOD
      CALL MSGWRT (2)
      WRITE (MSGTXT,1991) NNOFIT
      IF (NNOFIT.GE.1.0D0) CALL MSGWRT (2)
      IF (.NOT.DOTV) THEN
         CALL HIPLOT (DISKIN, FCNO(1), VER, BUFFER, IERR)
         WRITE (MSGTXT,1992) VER
         CALL MSGWRT (2)
         END IF
      IRET = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('Plot file version',I4,'__created ',A12,A8)
 1035 FORMAT ('From',I3,'/',2(I2.2,':'),I2.2,' _to',I4,'/',2(I2.2,':'),
     *   I2.2,' __RA',I3.2,':',I2.2,':',F5.2,' _DEC ',A1,2(I2.2,':'),
     *   F4.1)
 1040 FORMAT ('UVrange ',2(1PE12.4),' wavelengths')
 1045 FORMAT (A,'__ Corr ',A,' _Channel',I6,' -',I6,' _IF',I3,' -',I3,
     *   ' _Freq =',F8.4,' GHz')
 1970 FORMAT ('PLTFT: ERROR DURING GRAPHING. WILL TRY TO FINISH',
     *   ' PARTIAL GRAPH')
 1990 FORMAT ('PLTFT: ',I10,' Points plotted')
 1991 FORMAT ('PLTFT: ',I10,' Points did not fit')
 1992 FORMAT ('PLTFT: Plot file version',I5,'  created.')
      END
      SUBROUTINE DODFT (RPBUF, VIS, T1, T2, FLAG, IRET)
C-----------------------------------------------------------------------
C   DODFT computes the DFT for a given set of visibilities with the
C   proper sky offset applied.
C   Inputs:
C     RPBUF   R(*)   one visibility record - random parameters
C     VIS     R(*)   one visibility record - data
C     T1      D      Start of interval
C     T2      D      End of interval
C     FLAG    I      If 0, continue summing DFT
C                    If 2, wrap it up, clear
C   Outputs:
C     IRET    I      0 => operation sucessful
C                    1 => trouble
C                    -1 => no data to average
C-----------------------------------------------------------------------
      REAL      RPBUF(*), VIS(*)
      INTEGER   FLAG, IRET
C
      REAL      TR, TI, WT, DELS, UU, VV, WW, SMN, TNR, TNI, TNU1(3,3),
     *   TNU2(3,3), TUMWT(3), TNA, XX, XV, XVARS(3)
      DOUBLE PRECISION T1, T2, AFREQ
      INTEGER   IIF, ICH, TAMP(3), LAD, IP, J
      LOGICAL   GOOD
      INCLUDE 'DFTPL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      SAVE TNU1, TNU2, TUMWT, TAMP, XVARS
      DATA TNU1, TNU2, TUMWT, XVARS, TAMP /24*0.0, 3*0/
C-----------------------------------------------------------------------
      TR = 0.0
      TI = 0.0
      IRET = 0
      IF (FLAG.NE.0) GO TO 500
C                                       loop over IF and channel
      DO 100 IIF = BIF,EIF
         DO 90 ICH = BCHAN,ECHAN
            AFREQ = OFREQ + FOFF(IIF) + (ICH-FRPIX) * FINC(IIF)
C                                       Set U and V
            UU = RPBUF(ILOCU+1) * AFREQ / OFREQ
            VV = RPBUF(ILOCV+1) * AFREQ / OFREQ
            WW = RPBUF(ILOCW+1) * AFREQ / OFREQ
            DO 80 IP = 1,NPOL
C                                       Find visibilities and weights
               LAD = 1 + (ICH-BCHAN)*KNCF + (IIF-BIF)*KNCIF +
     *            (IP-1)*KNCS
               IF (VIS(LAD+2).GT.0.0) THEN
                  TR = VIS(LAD)
                  TI = VIS(LAD+1)
                  WT = VIS(LAD+2)
C                                       sum it up
                  XX = UU * DXC + VV * DYC + WW * DZC
                  TNR = TR * COS (XX) + TI * SIN (XX)
                  TNI = TI * COS (XX) - TR * SIN (XX)
                  TNA = SQRT (TNR*TNR + TNI*TNI)
                  TNU1(IP,1) = TNU1(IP,1) + WT * TNR
                  TNU2(IP,1) = TNU2(IP,1) + WT * TNR * TNR
                  TNU1(IP,2) = TNU1(IP,2) + WT * TNI
                  TNU2(IP,2) = TNU2(IP,2) + WT * TNI * TNI
                  TNU1(IP,3) = TNU1(IP,3) + WT * TNA
                  TNU2(IP,3) = TNU2(IP,3) + WT * TNA * TNA
                  TUMWT(IP) = TUMWT(IP) + WT
                  TAMP(IP) = TAMP(IP) + 1
                  IF (XVAR.GT.1) THEN
                     TR = RPBUF(ILOCT+1)
                     CALL GETXV (TR, XV)
                     XVARS(IP) = XVARS(IP) + WT * XV
                     END IF
                  END IF
 80            CONTINUE
 90         CONTINUE
 100     CONTINUE
      GO TO 999
C                                      Finish up this interval
 500  GOOD = .FALSE.
      J = 1
      IF (OPTYPE.EQ.'IMAG') J = 2
      IF (OPTYPE.EQ.'SAMP') J = 3
      IF (OPTYPE.EQ.'AMP') J = 4
      IF (OPTYPE.EQ.'PHAS') J = 5
      IF (J.EQ.1) OPTYPE = 'REAL'
      DO 510 IP = 1,NPOL
         IF (TUMWT(IP).GT.0.0) THEN
            GOOD = .TRUE.
            IF (J.LE.3) THEN
               SMN = TNU1(IP,J) / TUMWT(IP)
               DELS = TNU2(IP,J) / TUMWT(IP) - SMN*SMN
               DELS = SQRT (MAX (0.0, DELS))
               DFT(BCNT,IP) = SMN
               ERROR(BCNT,IP) = DELS / SQRT (MAX (1.0, TAMP(IP)-1.))
            ELSE
               TNR = TNU1(IP,1) / TUMWT(IP)
               TNI = TNU1(IP,2) / TUMWT(IP)
               TNA = SQRT (TNR*TNR + TNI*TNI)
               TR = TNU2(IP,1) / TUMWT(IP) - TNR*TNR
               TR = SQRT (MAX (0.0, TR))
               TI = TNU2(IP,2) / TUMWT(IP) - TNI*TNI
               TI = SQRT (MAX (0.0, TI))
               IF (TNA.LE.0.0) THEN
                  DFT(BCNT,IP) = FBLANK
                  ERROR(BCNT,IP) = FBLANK
               ELSE IF (J.EQ.4) THEN
                  DFT(BCNT,IP) = TNA
                  ERROR(BCNT,IP) = SQRT ((TNR*TR)**2 + (TNI*TI)**2)/TNA
               ELSE
                  DFT(BCNT,IP) = ATAN2 (TNI, TNR) * RAD2DG
                  ERROR(BCNT,IP) = SQRT ((TNI*TR)**2 + (TNR*TI)**2) /
     *                  TNA**2 * RAD2DG
                  END IF
               END IF
            TIMR(BCNT) = (T1+T2)/2.
            IF (XVAR.GT.1) TIMR(BCNT) = XVARS(IP) / TUMWT(IP)
         ELSE
            DFT(BCNT,IP) = FBLANK
            ERROR(BCNT,IP) = FBLANK
            END IF
 510     CONTINUE
      IF (GOOD) THEN
         IRET = 0
         BCNT = BCNT + 1
      ELSE
         IRET = -1
         END IF
      CALL RFILL (9, 0.0, TNU1)
      CALL RFILL (9, 0.0, TNU2)
      CALL RFILL (3, 0.0, TUMWT)
      CALL RFILL (3, 0.0, XVARS)
      CALL FILL (3, 0, TAMP)
C
 999  RETURN
      END
      SUBROUTINE GETXV (T, XV)
C-----------------------------------------------------------------------
C   returns the X axis variable when not time
C   Input
C      T    R   Time
C   Output
C      XV   R   X value
C-----------------------------------------------------------------------
      REAL      T, XV
C
      INCLUDE 'DFTPL.INC'
      INTEGER   IA
      REAL      HA, EL, AZ, PA
      DOUBLE PRECISION R, D, TT
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      R = RAS * DG2RAD
      D = DECS * DG2RAD
      TT = T
C                                       parallactic angle
      IF (XVAR.EQ.5) THEN
         CALL PARACO (T, R, D, PA)
         XV = PA * RAD2DG
C                                       el, ax, ha, lst
      ELSE
         IA = 1
         CALL COOELV (IA, TT, R, D, HA, EL, AZ)
         IF (XVAR.EQ.2) THEN
            XV = EL * RAD2DG
         ELSE IF (XVAR.EQ.3) THEN
            XV = HA * RAD2DG / 360.0
         ELSE IF (XVAR.EQ.4) THEN
            XV = (HA + R) * RAD2DG / 360.0
         ELSE
            XV = AZ * RAD2DG
            IF (XV.GT.180.) XV = XV - 360.
            END IF
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'UVCRS.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:DMSG.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XOFILE(12), XXSTOK(1)
      REAL      XSIN, XDISIN, APARM(10), BUFF1(UVBFSS), XANT(50),
     *   BUFF2(UVBFSS), UVRADI, UVRADX, UVRADY, XIF, XF, IATUTC,
     *   UT1XXX, HRAD, GRRAD, DELTA, ALFA, PI, DAYRAD, XSNVER,
     *   GNMOD, TIMINT
      INTEGER SNKOLS(MAXSNC), SNNUMV(MAXSNC), ISNRNO, NUMNOD,
     *   SNV, SNLUN, SNBUFF(1024), NPOLZN, NUMBIF, NUMTEL
      INTEGER   SEQIN, DISKIN, NUMHIS, JBUFSZ, ILOCWT, CATOLD(256),
     *   INCSI, INCFI, INCIFI, LRECI, NRPRMI, NANT, ANTNO(MAXANT),
     *   NNVIS, NUMCR, ISTOK, NIF, NF, NCORI, ANTS(50), NANTS, NNIF,
     *   NNF, SNOLD
      DOUBLE PRECISION AFREQ, GST0, XA(MAXANT),YA(MAXANT),ZA(MAXANT),
     *   CTIM, ARRLON
      LOGICAL   ISCOMP, RECT, ELIP, ISAPPL
      CHARACTER NAMEIN*12, CLAIN*6, HISCRD(50)*64, STANAM(MAXANT)*8,
     *   OFILE*48, STOKES*4
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN,  XIF, XF,
     *   XXSTOK, XANT, XSNVER, XOFILE, APARM, SEQIN, DISKIN, NUMHIS,
     *   ILOCWT, CATOLD, INCSI, INCFI, INCIFI, LRECI, NRPRMI, ISCOMP,
     *   NIF, NF, NNF, NNIF
      COMMON /CHARPM/ NAMEIN, CLAIN, OFILE,  HISCRD, STANAM, STOKES
      COMMON /GRHRAD/ HRAD, GRRAD, DELTA, ALFA, PI, DAYRAD, UVRADI,
     *   UVRADX, UVRADY, RECT, ELIP, NNVIS, NUMCR, ISTOK, NCORI,
     *   NUMTEL, NPOLZN, NUMBIF
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ, ANTS, NANTS
      COMMON /CANIN/ XA, YA, ZA, ARRLON, AFREQ, GST0, CTIM, IATUTC,
     *   UT1XXX, NANT, ANTNO
      COMMON /SNPARM/ SNBUFF, SNKOLS, SNNUMV, ISNRNO,
     *   NUMNOD, SNV, SNLUN, GNMOD, ISAPPL, TIMINT, SNOLD
LOCAL END
      PROGRAM UVCRS
C-----------------------------------------------------------------------
C! Find intersections of UV ellipses
C# Utility UV UV-util VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2000, 2003, 2009, 2012, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVCRS finds intersections of UV ellipses and detemines corresponding
C   ratio of complex correlation coefficients
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      STOKES         STOKES        STOKE's type
C      BIF            NIF           The IF's number
C      BCHAN          NF            The F's number
C      ANTENNAS       ANTS          The well calibrated antenna,
C                                   the gain is forced to 1.
C      SNVER          SNV           The number of SN table
C      OUTFILE        OFILE         Filename in which to write
C                                   the table of crossings
C      APARM(10)      APARM         Aparm(1) = UVRADX
C                                   Aparm(2) = UVRADY
C                                   Aparm(3)=0 => rectangular
C                                           >0 => eliptical
C
C   Programmer L. R. Kogan, December 1993.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'UVCRS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DSOU.INC'
      DATA PRGM /'UVCRS '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create inputs for RATIO
      CALL UVCRIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Find crossing, ratios and
C                                       print the table
      CALL RATIO (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL UVCHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE UVCRIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   UVCRIN gets input parameters for RATIO
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      ISCOMP  L  If true data is compressed
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
      CHARACTER STAT*4, UTYPE*2, STOK(4)*4
      INTEGER   OLDCNO, IROUND, NPARM, IERR, INCX, VER, I, L, KEYLOC,
     *   KEYTYP, ORIGIN, NUMKEY
      REAL      DECNOD(25), RANOD(25)
      LOGICAL   T, F, CHSTAT, MULTI
      INCLUDE 'UVCRS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA STOK /'RR  ', 'LL  ', '    ', '    '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 83
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
      SNV = IROUND(XSNVER)
      SNOLD = SNV
      UVRADX = APARM(1)*1.0E6
      IF (UVRADX.EQ.0.0) THEN
         UVRADX = 0.5E6
         UVRADY = 0.5E6
      ELSE
         IF (APARM(2).EQ.0.0) THEN
            UVRADY = UVRADX
         ELSE
            UVRADY = APARM(2) * 1.0E6
         END IF
      END IF
      UVRADI = SQRT (UVRADX*UVRADX + UVRADY*UVRADY)
      IF (APARM(3).EQ.0) THEN
         RECT = .TRUE.
         ELIP = .FALSE.
      ELSE
         RECT = .FALSE.
         ELIP = .TRUE.
         END IF
      NANTS = 0
      DO 10 I = 1,50
         ANTS(I) = IROUND(XANT(I))
         IF ( (I.GT.1) .AND. ( (ANTS(I).EQ.ANTS(I-1)) .OR.
     *      (ANTS(I-1).EQ.0) ) ) ANTS(I) = 0
         IF (ANTS(I).NE.0) NANTS = NANTS + 1
   10    CONTINUE
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (48, 1, XOFILE, OFILE)
      CALL H2CHR (4, 1, XXSTOK, STOKES)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      NIF = IROUND (XIF)
      IF (NIF.EQ.0) NIF = 1
      NF = IROUND (XF)
      IF (NF.EQ.0) NF = 1
      OLDCNO = 1
C                                       Get CATBLK from old file.
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   UTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       does the given Stokes exist
C                                       at the data? If yes what is
C                                       its number?
      ISTOK = 0
      DO 20 I = 1,NCOR
         L = I - ICOR0 - 1
         IF (STOK(L).EQ.STOKES) THEN
            ISTOK = I
            GO TO 30
            END IF
   20    CONTINUE
   30    CONTINUE
      IF (ISTOK.EQ.0) THEN
         JERR = 1
         WRITE (MSGTXT, 1060) STOKES
         GO TO 990
         END IF
      NNIF = 1
      NNF = 1
      IF (JLOCIF.GE.0) NNIF = CATBLK(KINAX+JLOCIF)
      IF (JLOCF.GE.0) NNF = CATBLK(KINAX+JLOCF)
      IF ((NIF.GT.NNIF) .OR. (NIF.LE.0)) THEN
         JERR = 1
         WRITE (MSGTXT, 1080) NIF, NNIF
         GO TO 990
         END IF
      IF ((NF.GT.NNF) .OR. (NF.LE.0)) THEN
         JERR = 1
         WRITE (MSGTXT, 1100) NF, NNF
         GO TO 990
         END IF
C                                       Get a source coordinates
      CALL GETSOU (1, DISKIN, OLDCNO, CATBLK, 40, JERR)
      ALFA = RAAPP
      DELTA = DECAPP
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                        Put input file in READ
      UTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   UTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
C                                       Prepare antennas data
      VER = 1
      CALL ANTDAT (VER, DISKIN, OLDCNO, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT, 1120)
         GO TO 990
         END IF
C                                       Open SN table
      IF (SNV.GE.0) THEN
C                                       Change status to 'writ'
C                                       Determine status of file
         UTYPE = 'UV'
         CHSTAT = .FALSE.
         CALL CATDIR ('INFO', DISKIN, OLDCNO, NAMEIN, CLAIN,
     *      SEQIN, UTYPE, NLUSER, STAT, BUFF1, IERR)
C                                       Change status
         IF (STAT.EQ.  'READ') THEN
            STAT = 'CLRD'
            CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN,
     *         SEQIN, UTYPE, NLUSER, STAT, BUFF1 , IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1140) IERR, STAT
               GO TO 990
               END IF
            STAT = 'WRIT'
            CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN,
     *         SEQIN, UTYPE, NLUSER, STAT, BUFF1, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1140) IERR, STAT
               GO TO 990
               END IF
            CHSTAT = .TRUE.
            END IF
C
         ISAPPL = F
         GNMOD = 1.0
         DO 60 I = 1, 25
            RANOD(I) = 0.0
            DECNOD(I) = 0.0
   60       CONTINUE
         SNLUN = 48
         NUMBIF = NNIF
         NUMTEL = NANT
         NPOLZN = 2
         IF (NCOR.EQ.1) NPOLZN = 1
         NUMNOD = 0
         CALL SNINI ('WRIT', SNBUFF, DISKIN, OLDCNO, SNV, CATBLK, SNLUN,
     *      ISNRNO, SNKOLS, SNNUMV, NUMTEL, NPOLZN, NUMBIF, NUMNOD,
     *      GNMOD, RANOD, DECNOD, ISAPPL, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) SNV
            GO TO 990
            END IF
         ISNRNO = 1
C                                       Add the ORIGIN keyword
         CALL MULSDB (CATBLK, MULTI)
         KEYLOC = 1
         KEYTYP = 4
         ORIGIN = 0
         NUMKEY = 1
         IF (.NOT.MULTI) ORIGIN = 1
         CALL TABKEY ('WRIT', 'SNORIGIN', NUMKEY, SNBUFF, KEYLOC,
     *      ORIGIN, KEYTYP, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1015) IERR
            GO TO 990
            END IF
C                                       Check if changed status
         IF (CHSTAT) THEN
            STAT = 'CLWR'
            CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN,
     *         SEQIN, UTYPE, NLUSER, STAT, BUFF1, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1140) IERR, STAT
               GO TO 990
               END IF
            STAT = 'READ'
            CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN,
     *         SEQIN, UTYPE, NLUSER, STAT, BUFF1, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1140) IERR, STAT
               GO TO 990
               END IF
            END IF
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVCRIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('UVCRIN: Writing to SN table ',I3)
 1015 FORMAT ('UVCRIN: ERROR',I3,' READING KEYWORDS FROM SN TABLE')
 1020 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1060 FORMAT ('UVCRIN: ERROR. STOKES ',A4,' is not compatible')
 1080 FORMAT ('UVCRIN: IFs NUMBER ',I4, '> MAXIMUM IFs NUMBER -',I2)
 1100 FORMAT ('UVCRIN: Fs NUMBER ',I4, '> MAXIMUM Fs NUMBER -',I2)
 1120 FORMAT ('UVCRIN: PROBREM OF READING DATA FROM ANTENNA TABLE')
 1140 FORMAT ('UVCRIN: ERROR ',I3,' CHANGING ',A4,' STATUS')
      END
      SUBROUTINE RATIO (IRET)
C-----------------------------------------------------------------------
C   RATIO finds the all crossings inside UVRADI and calculates
C   the average ratio of visibilities' amplitudes
C   Input in common:
C      UVRADX     R  Semi axis of the crossings region
C      UVRADY     R
C      RECT, ELIP L  A form of the region
C      LRECI      I  Input file record length
C      NRPRMI     I  Input number of random parameters.
C      INCSI      I  Input Stokes' increment in vis.
C      INCFI      I  Input frequency increment in vis.
C      INCIFI     I  Input IF increment in vis.
C      ISCOMP     L  If true data is compressed
C   Output:
C      IRET       I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INCLUDE 'UVCRS.INC'
      INTEGER   IRET, NCR, NCROSS(5000), LUNPR, PFIND, NCH, ITRIM
      CHARACTER IFILE*48, LINE*132, SIMB(5000)*1, ST1*8, ST2*8,
     *          ST3*8, ST4*8, QUEST*1, STREF(50)*8
      INTEGER   LUNI, INDI, INCX, BASN(1000), SBASN(1000), ANN1(1000),
     *   ANN2(1000), A1, A2, B1, B2, I, K, L, TEMP1, TEMP2, III, NB,
     *   ANTN, K0(50), NREG(5000), A(MAXANT), AN(MAXANT), ANREF, INDOBS,
     *   K00, KOBS, ANREF0, REFA(2,MAXIF), LESOL
      LOGICAL   T, F, WPRINT
      REAL      UVX, UVY, RAT, TT1(10), TT2(10), TALL(50000),
     *          TB(1000), TE(1000), TDI(20000), TDK(20000), NOBS,
     *          R(MAXANT), M(MAXANT*MAXANT), GAIN(MAXANT),RATL,
     *          RATLOG(5000), RATCOR, GLOG(MAXANT), REAL(2,MAXIF),
     *          IMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF),
     *          WEIGHT(2,MAXIF), MBDELY(2), DISP(2), DDISP(2),
     *          VX(MAXANT), SSQRES, VARRES, VARY, FIT, G(MAXANT),
     *          UALL(50000), VALL(50000), AMALL(50000), WEALL(50000)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI /16/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      PI = 3.1415926
      GRRAD = PI/180.0
      HRAD = PI/12.0
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
      IF (ISCOMP) INCX = 3
C                                       Number of visibilities in input
      NCORI = (LRECI - NRPRMI) / CATOLD(KINAX)
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Store  and sort the data
      CALL BASVIS (LUNI, INDI, ANN1, ANN2, BASN, SBASN,
     *      NB, TB, TE, TALL, UALL, VALL, AMALL, WEALL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       find number of possible crossing
C                                       baselines - NCR, and array of
C                                       its identificators - NCROSS
      CALL CROSAT (TB, TE, NCR, NCROSS, TDI, TDK, SIMB)
      IF (NCR.EQ.0) THEN
         IRET = 1
         WRITE (MSGTXT, 1040)
         GO TO 990
         END IF
C                                       ANTS -  antennas are not
C                                       corrected;  gain=1.
C                                       Exclude ANTS from the list
      ANTN = 0
      ANREF = 0
      DO 20 K = 1, NANT
         ANREF0 = ANREF
         DO 10 I = 1, NANTS
            IF (ANTNO(K).EQ.ANTS(I)) THEN
               ANREF = ANREF + 1
               K0(ANREF) = K
               STREF(ANREF) = STANAM(K)
               END IF
   10       CONTINUE
         IF (ANREF.EQ.ANREF0) THEN
            ANTN = ANTN + 1
            AN(ANTN) = ANTNO(K)
            END IF
   20    CONTINUE
C                                       Force a result vector R and
C                                       matrix M to zero
      DO 40 K = 1, ANTN
         R(K) = 0.0
         DO 30 I = 1, ANTN
            M(I + (K-1)*ANTN) = 0.0
   30       CONTINUE
   40    CONTINUE
      UVX = UVRADX / 1.0E6
      UVY = UVRADY / 1.0E6
C
      WPRINT = .FALSE.
      IF (OFILE(1:1).NE.' ') WPRINT = .TRUE.
C                                       open the outfile and print
      IF (WPRINT) THEN
C                                       print the title of the table
         LUNPR = 10
         CALL ZTXOPN ('WRIT', LUNPR, PFIND, OFILE, F, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1060) IRET
            GO TO 990
            END IF
         WRITE (LINE,1080) NAMEIN, CLAIN, SEQIN, DISKIN
         NCH = ITRIM(LINE)
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
         WRITE (LINE,1100) NNVIS
         NCH = ITRIM(LINE)
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
         IF (RECT) WRITE (LINE,1120) UVX, UVY
         IF (ELIP) WRITE (LINE,1140) UVX, UVY
         NCH = ITRIM(LINE)
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
         WRITE (LINE,1160) NCR
         NCH = ITRIM(LINE)
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
C                                       print the blank line
         LINE = ' '
         NCH = 1
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
         END IF
C                                       print the title of the table
      IF (APARM(4).GT.0) THEN
         WRITE (MSGTXT,1080) NAMEIN, CLAIN, SEQIN, DISKIN
         CALL MSGWRT (4)
         WRITE (MSGTXT,1100) NNVIS
         CALL MSGWRT (4)
         IF (RECT) THEN
            WRITE (MSGTXT,1120) UVX, UVY
            CALL MSGWRT (4)
            END IF
         IF (ELIP) THEN
            WRITE (MSGTXT,1140) UVX, UVY
            CALL MSGWRT (4)
            END IF
         WRITE (MSGTXT,1160) NCR
         CALL MSGWRT (4)
         END IF
C
      III = 0
      KOBS = 0
C                                       find the ratios for predicted
C                                       crossings
      DO 100 I = 1, NCR
C                                       restore momemts of intersections
         DO 45 K = 1,10
            TT1(K) = TDI(K + 10*(I-1))
            TT2(K) = TDK(K + 10*(I-1))
   45       CONTINUE
         A1 = NCROSS(I)/1000000
         TEMP1 = NCROSS(I) - A1*1000000
         A2 = TEMP1/10000
         TEMP2 = TEMP1 - A2*10000
         B1 = TEMP2/100
         B2 = TEMP2 - B1*100
         CALL RATCRO (A1, A2, B1, B2, NB, TT1, TT2, BASN, SBASN, ANN1,
     *      ANN2, TALL, UALL, VALL, AMALL, WEALL, RAT, RATL)
         IF (RAT.NE.0.0) THEN
            III = III + 1
            RATLOG(III) = RATL
            NCROSS(III) = NCROSS(I)
            NREG(III) = NUMCR
            IF (APARM(4).GT.0.0) THEN
               WRITE (MSGTXT,1200) III, NREG(III), A1, A2, B1, B2, RAT
               CALL MSGWRT (4)
               END IF
            DO 55 K = 1, ANTN
               A(K) = 0
   55          CONTINUE
C                                       Prepare a row of a matrix A
            INDOBS = 0
            DO 60 K = 1, ANTN
               IF (AN(K).EQ.A1) THEN
                  IF ((B1.NE.A1) .AND. (B2.NE.A1)) A(K) = 1
                  INDOBS = INDOBS + 1
                  END IF
               IF (AN(K).EQ.A2) THEN
                  IF ((B1.NE.A2) .AND. (B2.NE.A2)) A(K) = 1
                  INDOBS = INDOBS + 1
                  END IF
               IF (AN(K).EQ.B1) THEN
                  IF ((A1.NE.B1) .AND. (A2.NE.B1)) A(K) = -1
                  INDOBS = INDOBS + 1
                  END IF
               IF (AN(K).EQ.B2) THEN
                  IF ((A1.NE.B2) .AND. (A2.NE.B2)) A(K) = -1
                  INDOBS = INDOBS + 1
                  END IF
   60          CONTINUE
            IF (INDOBS.NE.0) KOBS = KOBS + 1
C                                       Prepare result vector R=A*RAT
C                                       and matrix M = AT * A
            DO 80 K = 1, ANTN
               R(K) = RATL * A(K) + R(K)
               DO 70 L = 1, ANTN
                  M(L + (K-1)*ANTN) = A(L)*A(K) + M(L + (K-1)*ANTN)
   70             CONTINUE
   80          CONTINUE
            END IF
  100    CONTINUE
      IF (III.EQ.0) THEN
         IRET = 1
         WRITE (MSGTXT, 1220)
         GO TO 990
         END IF
      NOBS = KOBS
      CALL LEASQR (ANTN, NOBS, 1, 1, R, M, GAIN, VX, SSQRES, VARRES,
     *             VARY, FIT, LESOL)
C                                       LESOL=0 => solution founded
      IF (LESOL.EQ.0) THEN
         IF (WPRINT) THEN
            LINE = ' '
            NCH = 1
            CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
            WRITE (LINE,1230)
            NCH = ITRIM(LINE)
            CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
            DO 110 I = 1, ANREF
               WRITE (LINE,1235) STREF(I)
               NCH = ITRIM(LINE)
               CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
  110          CONTINUE
            LINE = ' '
            NCH = 1
            CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
            END IF
C                                       Combine both found and
C                                       forced to 1 gains
         IF (SNOLD.EQ.0) THEN
            DO 120 L = 1, 2
               MBDELY(L) = 0.0
               DISP(L) = 0.0
               DDISP(L) = 0.0
               DO 115 I = 1, NNIF
                  IMAG(L, I) = 0.0
                  REAL(L,I) = 1.0
                  DELAY(L, I) = 0.0
                  RATE(L, I) = 0.0
                  WEIGHT(L, I) = 1.0
                  REFA(L, I) = ANTNO(1)
  115             CONTINUE
  120          CONTINUE
            END IF
         I = 1
         K00 = K0(1)
         IF (K00.EQ.0) K00 = 100
         DO 140 K = 1, NANT
            IF (K.LT.K00) THEN
               GLOG(K) = GAIN(K - I + 1)
               G(K) = EXP(GAIN(K - I + 1))
            ELSE
               IF (K.EQ.K00) THEN
                  GLOG(K) = 0.0
                  G(K) = 1.0
                  I = I + 1
                  IF (I.LE.ANREF) THEN
                     K00 = K0(I)
                  ELSE
                     K00 = 100
                     END IF
                  END IF
               END IF
C                                       write SN table
            IF (SNV.GE.0) THEN
               IF (SNOLD.GT.0) THEN
                  CALL TABSN ('READ', SNBUFF, ISNRNO, SNKOLS, SNNUMV,
     *               NPOLZN, CTIM, TIMINT, 0, ANTNO(K), 1, -1, 0.0, 0,
     *               MBDELY, DISP, DDISP, REAL, IMAG, DELAY, RATE,
     *               WEIGHT, REFA, IRET)
                  ISNRNO = ISNRNO - 1
                  END IF
               REAL(ISTOK, NIF) = 1.0/G(K)
               CALL TABSN ('WRIT', SNBUFF, ISNRNO, SNKOLS, SNNUMV,
     *            NPOLZN, CTIM, TIMINT, 0, ANTNO(K), 1, -1, 0.0, 0,
     *            MBDELY, DISP, DDISP, REAL, IMAG, DELAY, RATE, WEIGHT,
     *            REFA, IRET)
               NUMHIS = NUMHIS + 1
               WRITE (HISCRD(NUMHIS),1310) STANAM(K), G(K)
               END IF
C         PRINT 1240, K, STANAM(K), G(K)
            IF (WPRINT) THEN
               WRITE (LINE,1240)  K, STANAM(K), G(K)
               NCH = ITRIM(LINE)
               CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
               END IF
  140       CONTINUE
         END IF
C                                       end of yes solution
      IF (WPRINT) THEN
         LINE = ' '
         NCH = 1
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
         LINE = ' '
         NCH = 1
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
         IF (LESOL.EQ.0) THEN
            WRITE (LINE,1260)
            NCH = ITRIM(LINE)
            CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
         ELSE
            WRITE (LINE,1270)
            NCH = ITRIM(LINE)
            CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
            END IF
         WRITE (LINE,1280)
         NCH = ITRIM(LINE)
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
         WRITE (LINE,1290)
         NCH = ITRIM(LINE)
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
         LINE = ' '
         NCH = 1
         CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
         END IF
C                                       Print the table of ratios
C                                       before and after correction
      DO 200 I = 1, III
         RATCOR = RATLOG(I)
         A1 = NCROSS(I)/1000000
         TEMP1 = NCROSS(I) - A1*1000000
         A2 = TEMP1/10000
         TEMP2 = TEMP1 - A2*10000
         B1 = TEMP2/100
         B2 = TEMP2 - B1*100
         DO 160 K = 1,NANT
            IF (LESOL.NE.0) GLOG(K) = 1.0
            IF (ANTNO(K).EQ.A1) THEN
               ST1 = STANAM(K)
               RATCOR = RATCOR - GLOG(K)
               END IF
            IF (ANTNO(K).EQ.A2) THEN
               ST2 = STANAM(K)
               RATCOR = RATCOR - GLOG(K)
               END IF
            IF (ANTNO(K).EQ.B1) THEN
               ST3 = STANAM(K)
               RATCOR = RATCOR + GLOG(K)
               END IF
            IF (ANTNO(K).EQ.B2) THEN
               ST4 = STANAM(K)
               RATCOR = RATCOR + GLOG(K)
               END IF
  160       CONTINUE
            RATCOR = EXP(RATCOR)
C                                       mark bad points
         IF ( (RATLOG(I).GE.ALOG(2.0)) .OR.
     *        (RATLOG(I).LE.ALOG(0.5)) ) THEN
            QUEST = '?'
         ELSE
            QUEST = ' '
            END IF
         RAT = EXP(RATLOG(I))

C         PRINT 1300, QUEST, I, NREG(I), ST1, ST2,
C     *            ST3, ST4, A1, A2, B1, B2, RAT, RATCOR
         IF (WPRINT) THEN
            WRITE (LINE,1300) QUEST, I, NREG(I), ST1,
     *             ST2, ST3, ST4, A1, A2, B1, B2, RAT, RATCOR
            NCH = ITRIM(LINE)
            CALL ZTXIO ('WRIT', LUNPR, PFIND, LINE(1:NCH), IRET)
            END IF
  200    CONTINUE
C                                       Close SN table
      IF (SNV.GE.0) THEN
         CALL TABIO ('CLOS', 0, ISNRNO, SNBUFF, SNBUFF, IRET)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('RATIO: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1020 FORMAT ('RATIO: ERROR',I3,' A PROBLEM INTO BASVIS')
 1040 FORMAT ('RATIO: NOONE CROSSING HAS BEEN PREDICTED!')
 1060 FORMAT ('RATIO: ERROR',I3,' A PROBLEM INTO ZTXOPN')
 1080 FORMAT (1X,'Filename = ', A12,3X,'.',A6,'.',I5, I5 )
 1100 FORMAT (1X,'Number of visibilities = ', I6)
 1120 FORMAT (1X,'Rectangular with half the length and width',
     *        1X, F4.1,' x ', F4.1,' Megalamda')
 1140 FORMAT (1X,'Ellipse with half axes',
     *        1X, F4.1,' x ', F4.1,' Megalamda ')
 1160 FORMAT (1X,'Number of possible crossings = ',I5)
 1200 FORMAT (1X, I4, I4, 1X, I3,'-',I3,' /',I3,'-',I3, 1X, F6.3)
 1220 FORMAT ('      RATIO: NOONE CROSSING HAS BEEN FOUND!')
 1230 FORMAT (' The least square solution for the antannas gains')
 1235 FORMAT (' The gain for antenna ' ,A8, ' is forced to 1')
 1240 FORMAT (1X, I3, 1X, A8, 1X, F10.3)
 1260 FORMAT (' The table of original ratios and resulting ratios',
     *        ' after applying the solution')
 1270 FORMAT (' The table of original ratios. The data is not',
     *        ' enough to find solution.')
 1280 FORMAT (' The sign ? marks the lines with a ratio less than 0.5',
     *        ' or greater than 2.0')
 1290 FORMAT (' The last two columns are the original and resulting',
     *        ' ratios')
 1300 FORMAT (1X, A1, I4, I4, 1X, A8,'-',A8,' / ',A8,'-',
     *        A8, I3,'-',I3,' /',I3,'-',I3, 1X, F6.3, 1X, F6.3)
 1310 FORMAT (A8, F10.3)
      END
      SUBROUTINE UVCHIS
C-----------------------------------------------------------------------
C   FUGHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER CTIME(2)*12,  HILINE*72, LABEL*8
      INTEGER   LUN, IERR, TIME(3), DATE(3), I
      LOGICAL   T
      INCLUDE 'UVCRS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN, DISKIN, FCNO(NCFILE), BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME(2)(1:8), CTIME)
      WRITE (HILINE,1010) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any other history.
      IF (NUMHIS.LE.0) GO TO 200
         WRITE (LABEL,1020) TSKNAM
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN, HILINE, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
C                                       Close HI file
 200   CALL HICLOS (LUN, T, BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6, 'RELEASE =''',A7,' ''  /********* Start ',
     *   A12, 2X, A8)
 1020 FORMAT (A6)
      END
      SUBROUTINE BASVIS (LUNI, INDI, AN1, AN2, BASN, SBASN,
     *      NB, TB, TE, TALL, UALL, VALL, AMALL, WEALL, KERR)
C--------------------------------------------------------------------
C    BASVIS calculates number of visibilities BASN(I)
C    corresponding to the baseline AN1-AN2, and sums of these numbers
C    SBUSN(I) for all previous baselines; accumalates (sorts) U,V and
C    amplitudes. The LOG of amplitudes are taken instead of amplitudes
C    itselfs.
C   Inputs:
C      LUNI    I  Port's number
C      INDI    I  Disk number
C   Input in common:
C      NANT    I  Number of antennas
C      ANTNO   I  Array of antennas numbers
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Outputs:
C       AN1    I  Array of the first antennas of a baseline
C       AN2    I  Array of the second antennas of abaseline
C       BASN   I  Array of number of visibilities of
C                 a baseline
C      SBASN   I  Array of last visibilities numbers on the border
C                 between neighbours base lines
C       NB     I  Number of baselines
C      TB(*)   R  Array of beginings
C      TE(*)   R  Array of endings
C      TALL(*) R  Times moment sorted by baselines
C      UALL(*) R  U sorted by baselines
C      VALL(*) R  V sorted by baselines
C      AMALL(*)R  Amplitude sorted by baselines
C      WEALL(*)R  Weight sorted by baselines
C      KERR    I  Error code:  0 => OK
C-----------------------------------------------------------------------
      INTEGER   IA1, IA2, KERR, BASN(*), SBASN(*), AN1(*), AN2(*), NB,
     *   TSBASN(1000), I, K, L, INIO, IPTRI, IBIND, ILENBU, VO, BO,
     *   LUNI, INDI, INDEXI, INDEX, ITB
      INCLUDE 'UVCRS.INC'
      REAL      RE, IM, UALL(*), VALL(*), AMALL(*), WEALL(*),
     *   TB(*), TE(*), TIM, TALL(*), CBUFF(UVBFSS), TMAX, TMIN
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA VO,BO /0, 1/
C---------------------------------------------------------------------
      TMAX = 0.0
      TMIN = 100.0
      KERR = 0
      NB = 0
      DO 20 I = 1, NANT-1
         DO 10 K = I+1, NANT
            NB = NB + 1
            AN1(NB) = ANTNO(I)
            AN2(NB) = ANTNO(K)
   10       CONTINUE
   20    CONTINUE
      DO 25 I = 1,NB
         BASN(I) = 0
         TB(I) = 100.0
         TE(I) = 0.0
   25    CONTINUE
C                                       Read all data to determine
C                                       the number of visibilities
C                                       corresponding to a baseline
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, KERR)
      IF (KERR.NE.0) THEN
         WRITE (MSGTXT,1000) KERR
         GO TO 990
         END IF
C                                       Loop
 30   CONTINUE
C                                       Read vis. record.
      CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, KERR)
      IF (KERR.NE.0) THEN
         WRITE (MSGTXT,1020) KERR
         GO TO 990
         END IF
      IPTRI = IBIND
C                                       Out of data?
      IF (INIO.LE.0) GO TO 60
C                                       Loop over buffer
      DO 50 I = 1,INIO
         IF (ILOCB.GE.0) THEN
            IA2 = BUFF1(IPTRI+ILOCB) + 0.1
            IA1 = IA2 / 256
            IA2 = IA2 - IA1*256
         ELSE
            IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
            IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
            END IF
         TIM = BUFF1(IPTRI+ILOCT)
         IF (TIM.GT.TMAX) TMAX = TIM
         IF (TIM.LT.TMIN) TMIN = TIM
         DO 40 K = 1, NB
            IF ((IA1.EQ.AN1(K)) .AND. (IA2.EQ.AN2(K))) THEN
               BASN(K) = BASN(K) + 1
C                                       find the min and max time
               IF (TIM.GT.TE(K)) TE(K) = TIM
               IF (TIM.LT.TB(K)) TB(K) = TIM
               END IF
   40       CONTINUE
         IPTRI = IPTRI + LRECI
   50 CONTINUE
      GO TO 30
   60 CONTINUE
      SBASN(1) = 0.0
      TSBASN(1)= 0.0
      DO 80 I = 2, NB
         SBASN(I) = SBASN(I-1) + BASN(I-1)
         TSBASN(I) = SBASN(I)
   80    CONTINUE
      NNVIS = SBASN(NB) + BASN(NB)
      IF (NNVIS.GT.50000) THEN
         KERR = -1
         WRITE (MSGTXT, 1040) KERR, NNVIS
         GO TO 990
         END IF
      CTIM = (TMAX + TMIN) / 2.0
      TIMINT = TMAX - TMIN
C                                       Again read all data to store
C                                       sorted by baseline U, V,
C                                       amplitude and weight
      L = 0
      ILENBU = 0
      INDEXI = 3*( (NIF - 1) * INCIFI + (NF - 1) * INCFI +
     *         (ISTOK - 1) * INCSI )
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, KERR)
      IF (KERR.NE.0) THEN
         WRITE (MSGTXT,1000) KERR
         GO TO 990
         END IF
C                                       Loop
 130   CONTINUE
C                                       Read vis. record.
      CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, KERR)
      IF (KERR.NE.0) THEN
         WRITE (MSGTXT,1020) KERR
         GO TO 990
         END IF
      IPTRI = IBIND
C                                       Out of data?
      IF (INIO.LE.0) GO TO 160
C                                       Loop over buffer
      DO 150 I = 1,INIO
         IF (ILOCB.GE.0) THEN
            IA2 = BUFF1(IPTRI+ILOCB) + 0.1
            IA1 = IA2 / 256
            IA2 = IA2 - IA1*256
         ELSE
            IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
            IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
            END IF
         DO 140 K = 1, NB
            IF ((IA1.EQ.AN1(K)) .AND. (IA2.EQ.AN2(K))) THEN
               TSBASN(K) = TSBASN(K) + 1
               L = TSBASN(K)
               UALL(L) = BUFF1(IPTRI + ILOCU)
               VALL(L) = BUFF1(IPTRI + ILOCV)
               TALL(L) = BUFF1(IPTRI + ILOCT)
C                                       get the visibilities
               IF (ISCOMP) THEN
C                                       Compressed data.
                  CALL ZUVXPN (NCORI, BUFF1(IPTRI+NRPRMI),
     *               BUFF1(IPTRI+ILOCWT), CBUFF)
                  RE = CBUFF (INDEXI + 1)
                  IM = CBUFF (INDEXI + 2)
C                                       Take logarithm of amplitudes
                  AMALL(L) = 0.5 * ALOG(RE*RE + IM*IM)
                  WEALL(L) = CBUFF(INDEXI + 3)
               ELSE
C                                       Un compressed data
                  INDEX = INDEXI + IPTRI + NRPRMI
                  RE = BUFF1(INDEX)
                  IM = BUFF1(INDEX + 1)
C                                       Take logarithm of amplitudes
                  AMALL(L) = 0.5 * ALOG(RE*RE + IM*IM)
                  WEALL(L) = BUFF1(INDEX + 2)
                  END IF
               END IF
  140       CONTINUE
         IPTRI = IPTRI + LRECI
  150 CONTINUE
      GO TO 130
  160 CONTINUE
C                                       Does time interval include
C                                       midnight?
      DO 200 I = 1,NB
         ITB = TB(I)
         TB(I) = TB(I) - ITB
         TE(I) = TE(I) - ITB
         IF (TE(I).GT.1.0) THEN
            IF (TB(I).LT.1.0) THEN
               TE(I) = -TE(I)
            ELSE
               TB(I) = TB(I) - 1
               TE(I) = TE(I) - 1
               END IF
            END IF
  200    CONTINUE
      GO TO 999
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BASVIS: ERROR', I3, ' INIT-FOR-READ VIS FILE')
 1020 FORMAT ('BASVIS: ERROR', I3, ' READING VIS FILE')
 1040 FORMAT ('BASVIS: ERROR', I3,' Number of vis.',I6,' > Max = 50000')
      END
      SUBROUTINE ANTDAT (VER, DISKI, CNOIN, IERR)
C-----------------------------------------------------------------------
C   Selects station information
C   Inputs:
C      VER           I    Antenna array number (AN file ver.)
C      DISKI         I    Vol number
C      CNOIN         I    CNO
C   Outputs in common:
C      XA,YA,ZA(*)   D    Cartesian coordinates for stations in wavelengths.
C      STANAM(*)     C*8  Names of stations
C      NANT          I    Number of antennas
C      ANTNO(*)      I    Array of antennas' numbers
C-----------------------------------------------------------------------
      INTEGER   IERR, IA, LUNA, CNOIN, IABUF(512), VER,  DISKI
      CHARACTER STNAME*8
      DOUBLE PRECISION  DX, DY, DZ, LAMBDA
      INCLUDE 'UVCRS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                     open antenna file
      LUNA = 28
      CALL ANTINI ('READ', IABUF, DISKI, CNOIN, VER, CATBLK, LUNA,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GST0, DEGPDY, AFREQ, RDATE,
     *   POLRXY, UT1XXX, IATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID,IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
      DX = ARRAYC(1)
      DY = ARRAYC(2)
      DZ = ARRAYC(3)
      NANT = IABUF(5)
      LAMBDA = 299792.D3/AFREQ
      ARRLON = 0.0D0
      IF ((ABS(DX).GT.1.0D2) .AND. (ABS(DY).GT.1.D2)) ARRLON =
     *   ATAN2 (DY, DX)
C                                     Get antenna info.
      DO 30 IA = 1,NANT
         IANRNO = IA
         CALL TABAN ('READ', IABUF, IANRNO, ANKOLS, ANNUMV, STNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IA, IERR
            CALL MSGWRT (8)
            END IF
C                                       RH system here
         XA(NOSTA) = STAXYZ(1) / LAMBDA
         YA(NOSTA) = STAXYZ(2) / LAMBDA
         ZA(NOSTA) = STAXYZ(3) / LAMBDA
         STANAM(NOSTA) = STNAME
         ANTNO(IA) = NOSTA
 30      CONTINUE
C                                     close antenna file
      CALL TABIO ('CLOS', 1, IANRNO, IABUF, IABUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ANTIN: ERROR IN OPEN AN-FILE IERR = ',I6)
 1010 FORMAT ('ANTIN: ERROR IN FINDING STATION',I3,' IERR=',I3)
 1030 FORMAT ('ANTIN: ERROR IN CLOSING AN-FILE IERR = ',I6)
      END
      SUBROUTINE CROSAT (TB, TE, NCR, NCROSS, TDI, TDK, SIMB)
C-----------------------------------------------------------------------
C   Find possible crossing comparing UVRADI with precalculated minimum
C   distance between points of the ellipses
C   Inputs:
C      TB            R    Array of beginning times
C      TE            R    Array of ending times
C   Inputs in common:
C      UVRADI        R    The threshold determining the crossing in
C                         billions of wavelength.
C      DELTA         R    Declination of the source in radians
C      ALFA          R    Right assension of the source in radians
C      ANTNO(*)      I    Array of antennas' numbers
C      XA,YA,ZA(*)   D    Cartesian coordinates for stations in billion
C                         of wavelengths.
C      STANAM(*)     C*8  Names of stations
C      NANT          I    Number of antennas
C   Outputs:
C      NCR           I    Number of possible crossing
C      NCROSS(*)     I    Array of identificators of crossing: 8 digits:
C                         each consecutive pair of digits corresponds
C                         to the antenna number.
C      TDI(*)        R    Moments of intersection at the first antenna
C      TDK(*)        R    Moments of intersection at the first antenna
C      SIMB          C*1  Simbol marking an nonintersect crossing
C-----------------------------------------------------------------------
      INTEGER    NB, ANI, ANK, NCR, NBAI, NBAK, NCROSS(*),
     *           NBASE(100),I, K, L, M
      CHARACTER  SIMB(*)*1
      LOGICAL    INTER1, INTER2, INTERS, MINRA1, MINRAN, TOT,
     *           NONINT, TIME1, TIME2, TIMEK, TIMEI, NONCON, TIMEIK
      REAL       BX, BY, BQ(1125), BZ(1125), RANMI1, RMIN1, RMIN2,
     *           RMIN3, RMIN4, RMIN5, RMIN6, TI(10), RMIN7, RMIN8,
     *           R1MIN, TB(*), TE(*), GSALF, TK(10), DEZ1, DEZ2, BSQR,
     *           A(1000), HI, HK, UTI, UTK, TAND, DELTZ1, DELTZ2,
     *           DELTBQ, BQS, TDI(*), TDK(*)
      INCLUDE 'UVCRS.INC'
C---------------------------------------------------------------------
C                                       Determine pairs of baselines
C                                       which can give a crossing
      GSALF = GST0*GRRAD - ALFA
      DAYRAD = (1.0 - 1.0/365) / (2.0*PI)
      TAND = TAN(DELTA)
      NB = 0
      DO 20 I = 1, NANT-1
         ANI = ANTNO(I)
         DO 10 K = I+1, NANT
            ANK = ANTNO(K)
            NB = NB + 1
            NBASE(NB) = 100*ANI + ANK
C                                       The first two digits at NBASE
C                                       is the first antenna number;
C                                       The second two digits is the
C                                       second antenna number.
            BX = XA(ANK) - XA(ANI)
            BY = YA(ANK) - YA(ANI)
            BQ(NB) = SQRT (BX*BX + BY*BY)
            BZ(NB) = ZA(ANK) - ZA(ANI)
C                                       make left handed
            A(NB) = -ARRLON + ATAN2 (-BY, BX)
C                                       force negative BZ
            IF (BZ(NB).GT.0.0) THEN
               BZ(NB) = -BZ(NB)
               A(NB) = A(NB) + PI
               END IF
   10       CONTINUE
   20    CONTINUE
C                                       increase timerange by 60 min
C                                       for including nearest crosing
C-----------------------------------------------
      DO 30 I=1,NB
         TB(I) = TB(I) - 0.04
         IF (TE(I).GT.0) THEN
            TE(I) = TE(I) + 0.04
            ELSE
            TE(I) = TE(I) -0.04
            END IF
   30    CONTINUE
C-------------------------------------------------
C                                       looking for crossing
      NCR = 0
      DO 100 I = 1, NB-1
         NBAI = NBASE(I)
         DO 90 K = I+1,NB
C                                       negative values for time of
C                                       intersection if is not realized
            DO 40 M = 1,10
               TI(M) = -1.0
               TK(M) = -1.0
   40       CONTINUE
            NBAK = NBASE(K)
            DELTZ1 = BZ(I) - BZ(K)
            DELTZ2 = BZ(I) + BZ(K)
            DEZ1 = DELTZ1 / TAND
            DEZ2 = DELTZ2 / TAND
            DELTBQ = BQ(I) - BQ(K)
            BQS =    BQ(I) + BQ(K)
            BSQR = BQ(I)*BQ(I) - BQ(K)*BQ(K)
C---------------------------------------------------------------------
C                                       condition of intersection
C                                       with up-ellipse
            INTER1 = ((TAND.LT.ABS(DELTZ1/DELTBQ))
     *          .AND. (TAND.GT.ABS(DELTZ1/BQS)))
            IF (INTER1) THEN
C                                       the first pair of intersection
               TIME1 = .FALSE.
               DO 50 L = 1,2
                  HI = ((-1)**L)*ACOS((BSQR+DEZ1**2)/(2*BQ(I)*DEZ1))
                  HK = ((-1)**L)*ACOS((BSQR-DEZ1**2)/(2*BQ(K)*DEZ1))
C                                       time of an intersection at days
                  UTI = (HI - GSALF + A(I)) * DAYRAD
                  UTI = AMOD(UTI,1.0)
                  IF (UTI.LT.0.0) UTI = UTI + 1
C
                  UTK = (HK - GSALF + A(K)) * DAYRAD
                  UTK = AMOD(UTK,1.0)
                  IF (UTK.LT.0.0) UTK = UTK + 1
C
                  IF (TE(I).LT.0) THEN
C                                       Midnight between beg. and end
                      TIMEI = ((UTI.GT.TB(I)) .AND. (UTI.LT.1.0))
     *               .OR. ((UTI.GT.0.0) .AND. (UTI.LT.(-TE(I)-1 )))
                   ELSE
                      TIMEI = (UTI.GT.TB(I)) .AND. (UTI.LT.TE(I))
                      END IF
                   IF (TE(K).LT.0) THEN
C                                       Midnight between beg. and end
                      TIMEK = ((UTK.GT.TB(K)) .AND. (UTK.LT.1.0))
     *               .OR. ((UTK.GT.0.0) .AND. (UTK.LT.(-TE(K) -1)))
                   ELSE
                      TIMEK = (UTK.GT.TB(K)) .AND. (UTK.LT.TE(K))
                      END IF
                   IF ( (TIMEI .AND. TIMEK)) THEN
                      TI(L) = UTI
                      TK(L) = UTK
                      END IF
                   TIME1 = TIME1 .OR. (TIMEI .AND. TIMEK)
   50           CONTINUE
               END IF
C-----------------------------------------------------------------------
C                                       condition of intersection
C                                       with down-ellipse
            INTER2 = ((TAND.LT.ABS(DELTZ2/DELTBQ))
     *          .AND. (TAND.GT.ABS(DELTZ2/BQS)))
            IF (INTER2) THEN
C                                       the second pair of intersection
               TIME2 = .FALSE.
               DO 60 L = 1,2
                 HI = ((-1)**(L+1))*ACOS((BSQR+DEZ2**2)/(2*BQ(I)*DEZ2))
                  HK = ((-1)**L)*ACOS(-(BSQR-DEZ2**2)/(2*BQ(K)*DEZ2))
C                                       time of an intersection at days
                  UTI = (HI - GSALF + A(I)) * DAYRAD
                  UTI = AMOD(UTI,1.0)
                  IF (UTI.LT.0.0) UTI = UTI + 1
C
                  UTK = (HK - GSALF + A(K)) * DAYRAD
                  UTK = AMOD(UTK,1.0)
                  IF (UTK.LT.0.0) UTK = UTK + 1
C
                  IF (TE(I).LT.0) THEN
C                                       Midnight between beg. and end
                      TIMEI = ((UTI.GT.TB(I)) .AND. (UTI.LT.1.0))
     *               .OR. ((UTI.GT.0.0) .AND. (UTI.LT.(-TE(I)-1 )))
                   ELSE
                      TIMEI = (UTI.GT.TB(I)) .AND. (UTI.LT.TE(I))
                   END IF
                   IF (TE(K).LT.0) THEN
C                                       Midnight between beg. and end
                      TIMEK = ((UTK.GT.TB(K)) .AND. (UTK.LT.1.0))
     *               .OR. ((UTK.GT.0.0) .AND. (UTK.LT.(-TE(K) -1)))
                   ELSE
                      TIMEK = (UTK.GT.TB(K)) .AND. (UTK.LT.TE(K))
                   END IF
                   IF ( (TIMEI .AND. TIMEK)) THEN
                      TI(L+2) = UTI
                      TK(L+2) = UTK
                      END IF
                   TIME2 = TIME2 .OR. (TIMEI .AND. TIMEK)
   60           CONTINUE
                END IF
C-----------------------------------------------------------------------
            INTER1 = INTER1 .AND. TIME1
            INTER2 = INTER2 .AND. TIME2
C                                       condition of any intersect
            INTERS = INTER1 .OR. INTER2
C-----------------------------------------------------------------------
C                                       unconditional minimum
            RMIN1 = ABS(DELTBQ*SIN(DELTA) + DELTZ1*COS(DELTA))
            RMIN2 = ABS(DELTBQ*SIN(DELTA) - DELTZ1*COS(DELTA))
            RMIN3 = ABS(BQS*SIN(DELTA) + DELTZ1*COS(DELTA))
            RMIN4 = ABS(BQS*SIN(DELTA) - DELTZ1*COS(DELTA))
            RMIN5 = ABS(DELTBQ*SIN(DELTA) + DELTZ2*COS(DELTA))
            RMIN6 = ABS(DELTBQ*SIN(DELTA) - DELTZ2*COS(DELTA))
            RMIN7 = ABS(BQS*SIN(DELTA) + DELTZ2*COS(DELTA))
            RMIN8 = ABS(BQS*SIN(DELTA) - DELTZ2*COS(DELTA))
            R1MIN = MIN(RMIN1, RMIN2, RMIN3, RMIN4, RMIN5,
     *                  RMIN6, RMIN7, RMIN8)
C----------------------------------------------------------------------
            NONCON = R1MIN.LT.UVRADI
C                                       Looking for times of uncon-
C                                       ditional crossing; h=0, h=PI
C                                       condition of intersection
C                                       with down-ellipse
            IF (NONCON) THEN
               TIME1 = .FALSE.
               DO 65 L = 1,2
C                                       time of an intersection at days
                  UTI = ( (L-1)*PI - GSALF + A(I)) * DAYRAD
                  UTI = AMOD(UTI,1.0)
                  IF (UTI.LT.0.0) UTI = UTI + 1
                  IF (TE(I).LT.0) THEN
C                                       Midnight between beg. and end
                      TIMEI = ((UTI.GT.TB(I)) .AND. (UTI.LT.1.0))
     *               .OR. ((UTI.GT.0.0) .AND. (UTI.LT.(-TE(I)-1 )))
                   ELSE
                      TIMEI = (UTI.GT.TB(I)) .AND. (UTI.LT.TE(I))
                   END IF
                   DO 62 M = 1,2
                      UTK = ((M-1)*PI - GSALF + A(K)) * DAYRAD
                      UTK = AMOD(UTK,1.0)
                      IF (UTK.LT.0.0) UTK = UTK + 1
                      IF (TE(K).LT.0) THEN
C                                       Midnight between beg. and end
                         TIMEK = ((UTK.GT.TB(K)) .AND. (UTK.LT.1.0))
     *                      .OR. ((UTK.GT.0.0) .AND.
     *                            (UTK.LT.(-TE(K) -1)))
                      ELSE
                         TIMEK = (UTK.GT.TB(K)) .AND. (UTK.LT.TE(K))
                      END IF
                      TIMEIK = TIMEI . AND. TIMEK
                      IF (TIMEIK) THEN
                         TI(M + 2*(L-1) + 4) = UTI
                         TK(M + 2*(L-1) + 4) = UTK
                         END IF
                      TIME1 = TIME1 .OR. TIMEIK
   62                 CONTINUE
   65              CONTINUE
                END IF
C-----------------------------------------------------------------------
                NONCON = NONCON .AND. TIME1
C                                       condition of random minimum
            MINRA1 = ((TAND.LT.ABS(DELTBQ/DELTZ1)))
C                                        random minimum
            RANMI1 = SQRT(DELTBQ**2 + DELTZ1**2)
            MINRAN = MINRA1 .AND. (RANMI1.LT.UVRADI)
C                                       time of up-random minimum
            IF (MINRAN) THEN
               TIME1 = .FALSE.
               DO 70 L = 1,2
                  HI = ((-1)**(L+1))*ACOS(-(DELTZ1*TAND)/(DELTBQ))
                  HK = HI
C                                       time of an intersection at days
                  UTI = (HI - GSALF + A(I)) * DAYRAD
                  UTI = AMOD(UTI,1.0)
                  IF (UTI.LT.0.0) UTI = UTI + 1
                  IF (TE(I).LT.0) THEN
C                                       Midnight between beg. and end
                      TIMEI = ((UTI.GT.TB(I)) .AND. (UTI.LT.1.0))
     *               .OR. ((UTI.GT.0.0) .AND. (UTI.LT.(-TE(I)-1 )))
                   ELSE
                      TIMEI = (UTI.GT.TB(I)) .AND. (UTI.LT.TE(I))
                   END IF
                   UTK = (HK - GSALF + A(K)) * DAYRAD
                   UTK = AMOD(UTK,1.0)
                   IF (UTK.LT.0.0) UTK = UTK + 1
                   IF (TE(K).LT.0) THEN
C                                       Midnight between beg. and end
                       TIMEK = ((UTK.GT.TB(K)) .AND. (UTK.LT.1.0))
     *                      .OR. ((UTK.GT.0.0) .AND.
     *                            (UTK.LT.(-TE(K) -1)))
                    ELSE
                         TIMEK = (UTK.GT.TB(K)) .AND. (UTK.LT.TE(K))
                    END IF
                    TIMEIK = TIMEI . AND. TIMEK
                    IF (TIMEIK) THEN
                       TI(L + 8) = UTI
                       TK(L + 8) = UTK
                       END IF
                      TIME1 = TIME1 .OR. TIMEIK
   70              CONTINUE
                END IF
C-----------------------------------------------------------------------
            MINRAN = MINRAN .AND. TIME1
C                                       condition of crossing
            NONINT = MINRAN .OR. NONCON
            TOT = INTERS .OR. NONINT
            IF (TOT) THEN
               NCR = NCR + 1
C                                       each next two digits at NCROSS
C                                       is the number of antenna
               NCROSS(NCR) = 10000*NBAI + NBAK
C                                       store moments of crossing
               DO 80 M = 1,10
                  TDI(M + 10*(NCR-1)) = TI(M)
                  TDK(M + 10*(NCR-1)) = TK(M)
 80               CONTINUE
                IF (.NOT. NONINT) THEN
                  SIMB(NCR) = ' '
                 ELSE
                  SIMB(NCR) = '*'
                  END IF
               END IF
 90         CONTINUE
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE RATCRO (A1, A2, B1, B2, NB, TT1, TT2,
     *       BASN, SBASN, ANN1, ANN2, TALL, UALL, VALL, AMALL,
     *       WEALL, RAT, RATL)
C-----------------------------------------------------------------------
C   Find average ratio of amplitudes of baselines A1-A2 and B1-B2
C   Inputs:

C      A1      I    Number of the first antenna of the first base
C      A2      I    Number of the second antenna of the first base
C      B1      I    Number of the first antenna of the second base
C      B2      I    Number of the second antenna of the second base
C      NB      I    Number of possible baselines
C      TT1     R    Moments of intersections of the first antenna
C      TT2     R    Moments of intersections of the second antenna
C      BASN    I    Array of numbers of visibilities for a given antenna
C      SBASN   I    Array of number of  visibilities of preceded
C                   anntennas
C      ANN1    I    Array of the first antennas numbers
C      ANN2    I    Array of the second antennas numbers
C      TALL    R    Array of all T
C      UALL    R    Array of all U
C      VALL    R    Array of all V
C      AMALL   R    Array of all amplitudes
C      WEALL   R    Array of all weeghts
C   Inputs in COMMON:
C      UVRADX  R    Threshold at U billion of wavelength
C      UVRADY  R    Threshold at V billion of wavelength
C   Outputs:
C      RAT     R    Average ratio of amplitudes
C      RATL    R    Natural logarithm of the ratio
C-----------------------------------------------------------------------
      INTEGER A1, A2, B1, B2, KSUM, ICROS, BASN(*), SBASN(*)
      INTEGER NUMREF, NUMNEI, I, K, L, M, NB, ANN1(*), ANN2(*),
     *        KREF, KNEI, NUMRE, NUMNE
      REAL  UREF(1000), VREF(1000), AMPREF(1000), WEREF(1000),
     *      UNEI(1000), VNEI(1000), AMPNEI(1000), WENEI(1000),
     *      TALL(*), UALL(*), VALL(*), AMALL(*), WEALL(*)
      REAL  RAT, RATL, RATT, UR1, UR2, VR1, VR2, TT1(*), TT2(*)
      REAL  TRES, TGIVEN, DT, TCROS, TR, H, R, RER
      LOGICAL GOOD
      INCLUDE 'UVCRS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
C---------------------------------------------------------------------
C                                       time interval near crossing
      TR = 0.04
C                                       find a baseline number KREF
C                                       corresponding to A1&A2
      DO 30 I = 1, NB
         IF ( (A1.EQ.ANN1(I)) .AND. (A2.EQ.ANN2(I))) THEN
            KREF = I
            GO TO 40
            END IF
 30      CONTINUE
 40   NUMREF = BASN(KREF)
C                                       find a baseline number KNEI
C                                       corresponding to B1&B2
      DO 50 I = 1, NB
         IF ( (B1.EQ.ANN1(I)) .AND. (B2.EQ.ANN2(I))) THEN
            KNEI = I
            GO TO 60
            END IF
 50      CONTINUE
 60   NUMNEI = BASN(KNEI)
C                                       Loop for groups of
C                                       intersections
      TRES = TR
      KSUM = 0
      RAT = 0.0
      DO 200 M = 1,10
C                                       find the data for A1&A2
         L = 0
         IF (M.GT.4) TRES = TR * 2
         TCROS = TT1(M)
         IF (TCROS.GT.0.0) THEN
            DO 70 I = 1, NUMREF
               TGIVEN = TALL(SBASN(KREF) + I)
               IF (TGIVEN.GT.1.0) TGIVEN = TGIVEN - 1.0
               DT = ABS (TCROS - TGIVEN)
               DT = MIN(DT, (1-DT))
               IF (DT.LT.TRES) THEN
                  L = L + 1
                  UREF(L) = UALL(SBASN(KREF) + I)
                  VREF(L) = VALL(SBASN(KREF) + I)
                  AMPREF(L) = AMALL(SBASN(KREF) + I)
                  WEREF(L) = WEALL(SBASN(KREF) + I)
                  END IF
 70            CONTINUE
            END IF
         NUMRE = L
C                                       find the data for B1&B2
         L = 0
         TCROS = TT2(M)
         IF (TCROS.GT.0.0) THEN
            DO 80 I = 1, NUMNEI
               TGIVEN = TALL(SBASN(KNEI) + I)
               IF (TGIVEN.GT.1.0) TGIVEN = TGIVEN - 1.0
               DT = ABS (TCROS - TGIVEN)
               DT = MIN(DT, (1-DT))
               IF (DT.LT.TRES) THEN
                  L = L + 1
                  UNEI(L) = UALL(SBASN(KNEI) + I)
                  VNEI(L) = VALL(SBASN(KNEI) + I)
                  AMPNEI(L) = AMALL(SBASN(KNEI) + I)
                  WENEI(L) = WEALL(SBASN(KNEI) + I)
                  END IF
 80            CONTINUE
            END IF
         NUMNE = L
C
         IF ((NUMRE.GT.0) .AND. (NUMNE.GT.0)) THEN
            DO 100 I = 1, NUMRE
               RATT = 0.0
               ICROS = 0
               DO 90 K = 1, NUMNE
                  UR1 = ABS(UREF(I) - UNEI(K))
                  VR1 = ABS(VREF(I) - VNEI(K))
                  UR2 = ABS(UREF(I) + UNEI(K))
                  VR2 = ABS(VREF(I) + VNEI(K))
C                                       criteria of crossing
C-----------------------------------------------------------------
                  GOOD = .FALSE.
C                                       rectangular criteria
                  IF (RECT) THEN
                     IF (   ((UR1.LE.UVRADX) .AND.
     *                       (VR1.LE.UVRADY))
     *                  .OR.((UR2.LE.UVRADX) .AND.
     *                  (VR2.LE.UVRADY)) ) GOOD = .TRUE.
                     END IF
C                                       elliptical criteria
                  IF (ELIP) THEN
                     IF (UR1.EQ.0.0) THEN
                        H = PI/2.0
                     ELSE
                        H = ATAN(VR1 / UR1)
                     END IF
                     R = (UVRADX*COS(H))**2 + (UVRADY*SIN(H))**2
                     RER = VR1*VR1 + UR1*UR1
                     IF (RER.LE.R) GOOD = .TRUE.
                     IF (UR2.EQ.0.0) THEN
                        H = PI/2.0
                     ELSE
                        H = ATAN(VR2 / UR2)
                     END IF
                     R = (UVRADX*COS(H))**2 + (UVRADY*SIN(H))**2
                     RER = VR2*VR2 + UR2*UR2
                     IF (RER.LE.R) GOOD = .TRUE.
                     END IF
C---------------------------------------------------------------------
                  IF (GOOD) THEN
                     ICROS = ICROS + 1
C                                       Logarithm of amplitudes are
C                                       used. So we subtract them
C                                       instead of devide
                     RATT = RATT + AMPNEI(K) - AMPREF(I)
                     END IF
 90               CONTINUE
               IF (ICROS.NE.0) THEN
                  RATT = RATT/ICROS
                  KSUM = KSUM + 1
                  RAT = RAT + RATT
                  END IF
 100           CONTINUE
            END IF
 200     CONTINUE
      NUMCR = KSUM
      IF (KSUM.NE.0) THEN
         RAT = RAT/KSUM
C                                       Return back to ratios from LOG
         RATL = RAT
         RAT = EXP (RATL)
      ELSE
         RAT = 0.0
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'TAFFY.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO,
     *   CATOLD(256), NUMHIS, JBUFSZ, ICODE
      LOGICAL   DROP1
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOT(2), XOPCOD(1)
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, OPCODE*4,
     *   HISCRD(10)*64
      REAL      XSEQIN, XDISKI, XSEQO, XDISKO, BLC(7), TRC(7),
     *   CPARM(10), DPARM(10), BUFF1(MABFSS), BUFF2(MABFSS)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XNAMOU, XCLAOT,
     *   XSEQO, XDISKO, BLC, TRC, XOPCOD, CPARM, DPARM
      COMMON /CHPARM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, OPCODE, HISCRD
      COMMON /PARMS/ CATOLD, DROP1, SEQIN, SEQOUT, DISKIN, DISKO,
     *   NEWCNO, OLDCNO, JBUFSZ, ICODE, NUMHIS
      COMMON /BUFRS/ BUFF1, BUFF2
LOCAL END
      PROGRAM TAFFY
C-----------------------------------------------------------------------
C! Template task which performs operation on first axis of input image
C# Map-util Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2000, 2008, 2010, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TAFFY allows a user to provide a subroutine which performs an
C   operation on the first axis of the input image writing an output
C   image.  If pixel blanking is desired it should first be done
C   in COMB or some other appropriate task.  The  image should then be
C   transposed (with task TRANS) if necessary such that the desired
C   axis is first.
C   IMPORTANT NOTE: to avoid confusion this task should be renamed.
C   To rename (max. 5 char) and install the new task :
C     1) copy the source code to a new file with the name newname.
C        then add desired code to subroutines NEWHED and DIDDLE.
C             NEWHED allows modification of the catalog header before
C        the output file is created. If the size of the output file
C        is to be different from the input then the necessary
C        changes must be made to NEWHED.  Validity checks on the
C        input parameters or the input image may be made in NEWHED.
C             DIDDLE is passed the image one row at a time.  Any
C        operation desired is made and DIDDLE returns the result.
C        Blanking is fully supported.
C     2) using the source editor change all references to TAFFY to
C        newname.  It is especially important to change the string
C        entered into array PRGM at or near line 61 to the new name.
C     3) compile and link edit with the APL  subroutine
C        library from AIPS.
C     4) copy, rename, and modify as appropriate the TAFFY HELP file.
C        (This file starts with the INPUTS information.)
C
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLAOUT        Class of the output image.
C                                   Default is input class.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      OPCODE         OPCODE        User specified opcode.
C      CPARM(10)      CPARM         User specified array.
C      DPARM(10)      DPARM         User specified array.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'TAFFY.INC'
      INCLUDE 'INCS:DCAT.INC'
C
C   CHANGE THIS DATA STATMENT. WHEN CHANGING THE PROGRAM NAME.
C
      DATA PRGM /'TAFFY '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL TAFIN (PRGM, IRET)
C                                       Call routine that sends data
C                                       to the user routine.
      IF (IRET.EQ.0) CALL SENDMA (IRET)
C                                       History
      IF (IRET.EQ.0) CALL TAFHIS
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE TAFIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   TAFIN gets input parameters for TAFFY and creates an output file.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in TAFFY for more details.
C
C   To change the adverb list sent to this task change:
C   1)  the HELP file (Inputs section).
C   2)  the contents of COMMON /INPARM/.  Remember all adverbs are sent
C       as R, INNAME etc. are 12 char. 3 words;
C       INCLASS etc. are 6 char., 2 words.
C       Values will be filled into COMMON /INPARM/ in the order
C       specified in the inputs file.
C   3)  If the first adverb is not INNAME (NAMEIN) then replace
C       NAMEIN in the call to GTPARM with the name of the first
C       adverb.
C   4)  Change the value of NPARM sent to GTPARM to the number of
C       R words desired.
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      CHARACTER  STAT*4, MTYPE*2
      INTEGER   IERR, NPARM, IROUND
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'TAFFY.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 49
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOT, CLAOUT)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO = IROUND (XDISKO)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, 'READ', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Copy old CATBLK to new.
      CALL COPY (256, CATOLD, CATBLK)
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '      ', NAMOUT, CLAOUT,
     *   SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATOLD(KIDIM), CATOLD(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get user modification to CATBLK
      IRET = 4
      CALL NEWHED (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create output file.
      NEWCNO = 1
      IRET = 4
      CALL MCREAT (DISKO, NEWCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      IRET = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy most keywords
      CALL KEYPCP (DISKIN, OLDCNO, DISKO, NEWCNO, 0, ' ', IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TAFIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1060 FORMAT ('TAFIN: ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE SENDMA (IRET)
C-----------------------------------------------------------------------
C   SENDMA sends image one row at a time to the user supplied
C   routine and then writes the modified data.
C   Output:
C      IRET   I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER IFILE*48
      INTEGER   IROUND, LUNI, LUNO, NYI, NXI, WINI(4), NXO, NYO,
     *   WINO(4), BOI, BOO, LIM2, LIM3, LIM4, LIM5, LIM6, LIM7, I1, I2,
     *   I3, I4, I5, I6, I7, IPOS(7), CORN(7), BOTEMP, KOFF, LIMO,
     *   LIMIT, IBIND, OBIND, INDI, INDO, LIM1, DIDRET, OUTCNT
      REAL      OUTMAX, OUTMIN, OLD4(256)
      DOUBLE PRECISION    OLD8(128)
      LOGICAL   T, F, BLNKD
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'TAFFY.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (CATOLD, OLD4, OLD8)
      DATA LUNI, LUNO /16,17/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, IFILE, T, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Setup for I/O
      NXI = CATOLD(KINAX)
      NYI = CATOLD(KINAX+1)
      NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      OUTMAX = -1.0E20
      OUTMIN = 1.0E20
      BLNKD = F
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
      KOFF = 0
      IF (DROP1) KOFF = -1
      CORN(7) = 1
      LIMO = CATBLK(KINAX) - 1
      IF (DROP1) LIMO = 0
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         CORN(7+KOFF) = I7
         DO 600 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            CORN(6+KOFF) = I6
            DO 500 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               CORN(5+KOFF) = I5
               DO 400 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  CORN(4+KOFF) = I4
                  DO 300 I3 = 1,LIM3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     CORN(3+KOFF) = I3
C                                       Init. files, first input.
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1099) IRET
            GO TO 990
            END IF
         BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI, BUFF1, JBUFSZ,
     *      BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) 'READ', IRET
            GO TO 990
            END IF
C                                       Init output file.
         IF ((.NOT.DROP1) .OR. (I3.LE.1)) THEN
            CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORN(3), BOTEMP,
     *         IRET)
            BOO = BOTEMP + 1
            CALL MINIT ('WRIT', LUNO, INDO, NXO, NYO, WINO, BUFF2,
     *         JBUFSZ, BOO, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1100) 'WRIT', IRET
               GO TO 990
               END IF
            END IF
         DIDRET = 0
         OUTCNT = NYO
         IF (DROP1) OUTCNT = 1
         DO 220 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
C                                       Read.
            CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'READ', IRET
               GO TO 990
               END IF
C                                       Write.
            IF ((DROP1) .AND. (I2.GT.1)) GO TO 180
C                                       Check for deferred output.
            IF (DIDRET.GE.0) THEN
               CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IRET)
               OBIND = OBIND - 1
               OUTCNT = OUTCNT - 1
               IF (OUTCNT.LT.0) THEN
                  WRITE (MSGTXT,1113)
                  GO TO 990
                  END IF
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1120) 'WRIT', IRET
                  GO TO 990
                  END IF
               END IF
C                                       Call DIDDLE
 180        IF (DIDRET.GE.0) OBIND = OBIND + 1
            CALL DIDDLE (IPOS, BUFF1(IBIND), BUFF2(OBIND), IRET)
            DIDRET = IRET
            IF (DIDRET.GT.0) THEN
               WRITE (MSGTXT,1180) IRET
               GO TO 990
C                                       Check if output deferred.
            ELSE IF (DIDRET.EQ.0) THEN
C                                       Check max, min, blanking.
               LIMIT = OBIND + LIMO
               DO 200 I1 = OBIND,LIMIT
                  IF (BUFF2(I1).NE.FBLANK) THEN
                     OUTMAX = MAX (OUTMAX, BUFF2(I1))
                     OUTMIN = MIN (OUTMIN, BUFF2(I1))
                  ELSE
                     BLNKD = .TRUE.
                     END IF
 200              CONTINUE
               END IF
 220        CONTINUE
C                                       Read out any remaining rows
C                                       from DIDDLE.
         DO 260 I2 = 1,OUTCNT
            IPOS(1) = -1
C                                       Check if write requested.
            IF (.NOT.DROP1) THEN
               CALL MDISK ('WRIT', LUNO, INDO, BUFF2, OBIND, IRET)
               OBIND = OBIND - 1
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1120) 'WRIT', IRET
                  GO TO 990
                  END IF
               END IF
            OBIND = OBIND + 1
            CALL DIDDLE (IPOS, BUFF1(IBIND), BUFF2(OBIND), IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1180) IRET
               GO TO 990
               END IF
C                                       Check max, min, blanking.
            LIMIT = OBIND + LIMO
            DO 250 I1 = OBIND,LIMIT
               IF (BUFF2(I1).NE.FBLANK) THEN
                  OUTMAX = MAX (OUTMAX, BUFF2(I1))
                  OUTMIN = MIN (OUTMIN, BUFF2(I1))
               ELSE
                  BLNKD = .TRUE.
                  END IF
 250           CONTINUE
 260        CONTINUE
C                                       Flush buffer.
         IF ((.NOT.DROP1) .OR. (I3.GE.LIM3)) THEN
            CALL MDISK ('FINI', LUNO, INDO, BUFF2, OBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) 'FINI', IRET
               GO TO 990
               END IF
C                                       Update CATBLK.
            CATR(KRDMX) = OUTMAX
            CATR(KRDMN) = OUTMIN
            CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', BUFF1,
     *         IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1260) IRET
               GO TO 990
               END IF
            END IF
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Mark blanking in CATBLK.
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
C                                       Close input map.
      CALL ZCLOSE (LUNI, INDI, IRET)
C                                       Final call to functions
      IPOS(1) = -2
      CALL DIDDLE (IPOS, BUFF1, BUFF2, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1180) IRET
         GO TO 990
         END IF
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SENDMA: ERROR',I3,' OPENING INPUT FILE')
 1020 FORMAT ('SENDMA: ERROR',I5,' OPENING OUTPUT FILE')
 1099 FORMAT ('SENDMA: COMOFF ERROR',I3)
 1100 FORMAT ('SENDMA: INIT-FOR-',A4,' ERROR',I3)
 1113 FORMAT ('SENDMA: OUTCNT.LT.0! Too many output rows returned.')
 1120 FORMAT ('SENDMA: ',A,' ERROR',I3)
 1180 FORMAT ('SENDMA: DIDDLE ERROR',I3)
 1260 FORMAT ('SENDMA: CATIO ERROR',I3,' UPDATING CATBLK')
      END
      SUBROUTINE TAFHIS
C-----------------------------------------------------------------------
C   TAFHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER LABEL*8, LINE*80, NOTTYP(1)*2
      INTEGER   LUN1, LUN2, IERR, I, NONOT
      LOGICAL   T
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'TAFFY.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
C                                       Change to omit copying tables
C                                       such 'CC' if appropriate
      DATA NONOT, NOTTYP /1, '  '/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       BLC
      WRITE (MSGTXT,2000) TSKNAM, BLC
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       TRC
      WRITE (MSGTXT,2001) TSKNAM, TRC
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       OPCODE
      WRITE (MSGTXT,2002) TSKNAM, OPCODE
      CALL HIADD (LUN2, MSGTXT, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any user supplied history.
      IF (NUMHIS.LE.0) GO TO 200
         WRITE (LABEL,1010) TSKNAM
         LINE(1:8) = LABEL(1:8)
         DO 50 I = 1,NUMHIS
            LINE(9:64) = HISCRD(I)(1:64)
            CALL HIADD (LUN2, LINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO, OLDCNO,
     *   NEWCNO, CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST', BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TAFHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,' /')
 2000 FORMAT (A6,' BLC =',6(F6.0,','),F6.0)
 2001 FORMAT (A6,' TRC =',6(F6.0,','),F6.0)
 2002 FORMAT (A6,' OPCODE = ''',A4,'''')
      END
      SUBROUTINE NEWHED (IRET)
C-----------------------------------------------------------------------
C   NEWHED is a routine in which the user performs several operations
C   associated with beginning the task.  For many purposes simply
C   changing some of the values in the DATA statments will be all that
C   is necessary.  The following functions are/can be performed
C   in NEWHED:
C       1) Modifying the catalog header block to represent the
C   output file.  The MINIMUM modifications required here are those
C   required to define the size of the output file; ie.
C      CATBLK(KIDIM)   = the number of axes,
C      CATBLK(KINAX+i) = the dimension of each axis, and
C   Other changes can be made either here or in DIDDLE; the
C   catalog block will be updated when the history file is
C   written.
C       2) Checking the input image and/or input parameters.
C   For example, if a given first axis type such as
C   Frequency/Velocity is required this should be checked.  The
C   routine currently does this and all that is required to
C   implement this is to modify the DATA statments.
C   A returned value of IRET .NE. 0 will cause the task to terminate.
C   A message to the user via MSGWRT about the reason for the
C   termination would be friendly.  This can be done by encoding
C   the message into MSGTXT, setting IRET to a non-zero value
C   and issuing a GO TO 990.
C       3) Setting default values of some of the input parameters
C   (OUTNAME, OUTCLASS, OUTSEQ, OUTDISK, TRC and BLC defaults are
C   set elsewhere).  As currently set the default OPCODE is the
C   first value in the array CODES which is set in a data statment.
C
C    Input:
C       CATBLK    I(256)  Output catalog header, also CATR, CATD
C       CATOLD    I(256)  Input catalog header, also OLD4, OLD8
C    Output:
C       CATBLK    I(256)  Modified output catalog header.
C       IRET      I       Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER ATYPES(10)*8, FCHARS(3)*4, BLANK*8, CODES(10)*4,
     *   UNITS(10)*8, CTEMP*8
      HOLLERITH OLD4(256)
      DOUBLE PRECISION    OLD8(128)
      INTEGER   NCODE, NTYPES, IOFF, IERR, INDXI, INC, INDEX,
     *   NCHTYP(10), LIMIT, I, FIRSTI, FIRSTO
      LOGICAL   LDROP1
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'TAFFY.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (CATOLD, OLD4, OLD8)
      DATA FCHARS /'FREQ','VELO','FELO'/
      DATA BLANK /'        '/
C                                       User definable values
C                                       # and value of OPCODEs
      DATA NCODE /0/
      DATA CODES /10*'    '/
C                                       Output units for each OPCODE.
C                                       Two R   words with 4 char. ea.
      DATA UNITS /'UNDEFINE',9*'    '/
C                                       Allowed number of axis types
C                                       and types.
      DATA NTYPES /0/
      DATA ATYPES /10*'        '/
      DATA NCHTYP /10*4/
C                                       If LDROP1 is .TRUE. then the
C                                       first axis will be dropped,
C                                       (ie, one value results from
C                                       the operation on each row.)
      DATA LDROP1 /.FALSE./
C-----------------------------------------------------------------------
C                                       Set DROP1
      DROP1 = LDROP1
C                                       Set default OPCODE
      ICODE = 1
      IF (NCODE.GT.0) THEN
         DO 10 I = 1,NCODE
            ICODE = I
            IF (OPCODE.EQ.CODES(I)) GO TO 20
 10         CONTINUE
C                                       Default OPCODE is first.
         OPCODE = CODES(1)
         ICODE = 1
         END IF
C                                       Set output units.
 20   IF (NCODE.GT.1) CALL CHR2H (8, UNITS(ICODE), 1, CATH(KHBUN))
C                                       Check allowed axis types
      IF (NTYPES.GT.0) THEN
         DO 30 I = 1, NTYPES
C                                       Check for type.
            CALL AXEFND (NCHTYP(I), ATYPES(I), KICTPN, OLD4(KHCTP),
     *         IOFF, IERR)
C                                       IOFF is axis number
C                                       IERR = 0 if axis found.
            IF (IERR.EQ.0) GO TO 40
 30         CONTINUE
C                                       Axis not found.
         IOFF = -1
C                                       Check if axis first
 40      IF (IOFF.EQ.0) GO TO 50
C                                       Axis not found or not first.
            IRET = 1
            IF (IOFF.GT.0) WRITE (MSGTXT,1040)
            IF (IOFF.LT.0) WRITE (MSGTXT,1041)
            CALL MSGWRT (8)
            WRITE (MSGTXT,1042) (ATYPES(I), I = 1,NTYPES)
            GO TO 990
         END IF
C                                       Set axes in output CATBLK.
  50  FIRSTI = -1
      FIRSTO = -1
      LIMIT = CATOLD(KIDIM)
      INC = 2
      IF (.NOT.DROP1) GO TO 60
         LIMIT = LIMIT - 1
         FIRSTI = 0
C                                       Copy/update axis values
 60   DO 80 I = 1,LIMIT
         CATBLK(KINAX+FIRSTO+I) = TRC(I+FIRSTI+1) -
     *      BLC(I+FIRSTI+1) + 1.01
         CATR(KRCRP+FIRSTO+I) = OLD4(KRCRP+FIRSTI+I) - BLC(I+FIRSTI+1)
     *      + 1.0
         CATR(KRCIC+FIRSTO+I) = CATR(KRCIC+FIRSTI+I)
         CATD(KDCRV+FIRSTO+I) = OLD8(KDCRV+FIRSTI+I)
         INDXI = KHCTP + (I+FIRSTI) * INC
         INDEX = KHCTP + (I-1) * INC
         CALL H2CHR (8, 1, CATH(INDEX), CTEMP)
         CALL CHR2H (8, CTEMP, 1, OLD4(INDXI))
         IF (CATBLK(KIALT).EQ.0) GO TO 80
            CALL H2CHR (4, 1, CATH(INDEX), CTEMP)
            IF ((CTEMP(1:4).EQ.FCHARS(1)) .OR.
     *          (CTEMP(1:4).EQ.FCHARS(2)) .OR.
     *          (CTEMP(1:4).EQ.FCHARS(3)))
     *      CATR(KRARP) = CATR(KRARP) - BLC(FIRSTI+I+1) + 1.0
 80      CONTINUE
C                                       If DROP1 reset CATBLK(KIDIM)
C                                       and blank last axis type.
      IF (.NOT.DROP1) GO TO 90
         CATBLK(KIDIM) = CATOLD(KIDIM) - 1
         INDEX = KHCTP + CATBLK(KIDIM) * INC
         CALL CHR2H (8, BLANK, 1, CATH(INDEX))
         INDEX = CATBLK(KIDIM)
         CATD(KDCRV+INDEX) = 0.0D0
         CATR(KRCRP+INDEX) = 0.0
         CATR(KRCIC+INDEX) = 0.0
         CATBLK(KINAX+INDEX) = 0
C                                       Put other checks here.
C                                       Finished.
 90   IRET = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('REQUIRED FIRST AXIS NOT FIRST, TRANSPOSE IMAGE')
 1041 FORMAT ('REQUIRED FIRST AXIS TYPE NOT FOUND IN IMAGE')
 1042 FORMAT ('REQUIRED TYPES ARE:',10(1X,A4))
      END
      SUBROUTINE DIDDLE (IPOS, DATA, RESULT, IRET)
C-----------------------------------------------------------------------
C   This is a skeleton version of subroutine DIDDLE which allows
C   operations on an image one row at a time (1st dimension).
C   Input DATA are Real*4 with blanking if necessary; output values
C   are R   which may also be blanked.  The calling routine keeps track
C   of max., min. and the occurence of blanking.  If DROP1 is .TRUE.,
C   the calling routine expects 1 value returned per call;
C   otherwise, CATBLK(KINAX) values per call are expected returned.
C   NOTE: blanked values are denoted by the value of the common variable
C   FBLANK.
C       DIDDLE may accumulate a scrolling buffer by returning a negative
C   value of IRET.  This tells the calling routine to defer writting the
C   next row.  If rows are deferred then and equal number of calls to
C   DIDDLE will be made with no input data; this allows reading out any
C   rows left in DIDDLEs internal buffers.  Such a "no input call" is
C   indicated by a value of IPOS(1) of -1.  The writting of the returned
C   values of these "no input calls" may NOT be deferred.
C       Up to 10 history entries can be written by using ENCODE to
C   record up to 64 characters per entry into array HISCRD. Ex:
C         WRITE (HISCRD(entry #), format) list
C   TRC, BLC and OPCODE are already taken care of.
C   The history is written after the last call to DIDDLE.
C       Messages can be written to the monitor/logfile by encoding
C   the message (up to 80 char) into array MSGTXT in COMMON /MSGCOM/
C   and then issuing a call:
C        CALL MSGWRT (priority #)
C   Unit 1 is the line printer
C
C       If IRET .GT. 0 then the output file will be destroyed.
C
C       After all data have been processed a final call will be made to
C   DIDDLE with IPOS(1)=-2.  This is to allow for the completion of
C   pending operations, i.e. preparation of HIstory cards.
C
C       LUN's 16-18 are open and not available to DIDDLE.
C
C       The current contents of CATBLK will be written back to the
C   catalog after the last call to DIDDLE.
C
C   Inputs:
C      IPOS   I(7)    BLC (input image) of first value in DATA
C                     IPOS(1) = -1 => no input data this call.
C                     IPOS(2) = -2 => last call (no input data).
C      DATA   R(*)    Input row, magic value blanked.
C   Values from commons:
C      ICODE   I      Opcode number from list in NEWHED.
C      FBLANK  R      Value of blanked pixel.
C      CPARM   R(10)  Input adverb array.
C      DPARM   R(10)  Input adverb array.
C      CATBLK  I      Output catalog header (also CATR, CATD)
C      CATOLD  I      Input catalog header (also OLD4, OLD8)
C      DROP1   L      True if one output value per call.
C   Output:
C      RESULT  R(*)   Output row.
C      IRET    I      Return code   0 => OK
C                                  >0 => error, terminate.
C   Output in COMMON:
C     NUMHIS  I          # history entries (max. 10)
C     HISCRD  C(NUMHIS)  History records
C     CATBLK  I          Catalog header block
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), IRET
      REAL      DATA(*), RESULT(*)
C
      REAL      OLD4(256)
      INTEGER   LROW
      DOUBLE PRECISION OLD8(128)
C                                       SAVE variables in first call
      SAVE LROW
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'TAFFY.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (CATOLD, OLD4, OLD8)
C-----------------------------------------------------------------------
      IRET = 0
C                                       Check if last call (no input
C                                       data).
      IF (IPOS(1).GT.-2) THEN
C                                       Check if first call per plane.
         IF (IPOS(2).LE.1) THEN
C                                       First call per plane.
C                                       Set length of a row
            LROW = CATBLK(KINAX)
            END IF
C                                       Branch here for subsequent
C                                       calls.
C                                       Example, copy input to output.
         CALL RCOPY (LROW, DATA, RESULT)
C
C    USER CODE GOES HERE
C
C
C
C
C
C
C
C
C                                       Last call - do history etc.
      ELSE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
C   FORMAT STATEMENTS GO HERE
      END

      SUBROUTINE MULSDB (CATBLK, ISMULT)
C-----------------------------------------------------------------------
C! Determines if a uv file is multi- or single- source.
C# UV EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2011-2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Determines if data set described by catlogue header CATBLK is
C   a single source, calibrated or multi-source uncalibrated data set.
C   The presence of a source table (type SU) is used to determine.
C    Input:
C       CATBLK   I(256)   Catalog header record.
C    Output:
C       ISMULT   L       .TRUE. if data set is a multi source, raw
C                              data set, else .FALSE.
C-----------------------------------------------------------------------
      INTEGER   CATBLK(256)
      LOGICAL   ISMULT
C
      INTEGER   I, IOFF, IERR, NMSG
      CHARACTER SORC*8
      LOGICAL   ISSU, ISSORC
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      SAVE NMSG
      DATA NMSG /0/
      DATA SORC /'SOURCE'/
C-----------------------------------------------------------------------
      CALL FNDEXT ('SU', CATBLK, I)
      ISSU = I.GT.0
      CALL AXEFND (8, SORC, CATBLK(KIPCN), CATBLK(KHPTP), IOFF, IERR)
      ISSORC = (IOFF.GE.0) .AND. (IERR.EQ.0)
      IF ((ISSU) .AND. (.NOT.ISSORC)) THEN
         NMSG = NMSG + 1
         IF (NMSG.LE.2) THEN
            MSGTXT = 'Source table but no source random parameter'
            CALL MSGWRT (6)
            END IF
      ELSE IF ((.NOT.ISSU) .AND. (ISSORC)) THEN
         MSGTXT = 'SOURCE RANDOM PARAMETER BUT NO SOURCE TABLE!'
         CALL MSGWRT (8)
         END IF
      ISMULT = (ISSU) .AND. (ISSORC)
C
 999  RETURN
      END

      SUBROUTINE CLSEL (DISKI, CNOI, DISKO, CNOO, VER, CATIN, CATOUT,
     *   LUNI, LUNO, BPOL, EPOL, BIF, EIF, IFQID, TB, TE, NSOU, SOUIND,
     *   AN, NA, ISUB, JSUB, BUFFER, OBUFF, IRET)
C-----------------------------------------------------------------------
C! Copies a subset of IFs in a CL table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2007, 2011
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Copies a subset of IFs in a CL table, can also modify the FQ ID
C   Inputs:
C      DISKI    I        Input volume number
C      CNOI     I        Input catalog number
C      DISKO    I        Output volume number
C      CNOO     I        Output catalog number
C      VER      I        Version to check/modify
C      CATIN    I(256)   Input catalog header
C      CATOUT   I(256)   Output catalog header
C      LUNI     I        LUN to use
C      LUNO     I        LUN to use
C      BPOL     I        First polarization to copy
C      EPOL     I        Last polarization to copy
C      BIF      I        Start IF number
C      EIF      I        End IF number
C      IFQID    I        FQ ID to select (set to 1 on output)
C                           if <= 0 then output value unchanged.
C      TB       D        Beginning time in days
C      TE       D        Ending time in days
C      NSOU     I        Number of selected sources
C      SOUIND   I(*)     Array of sources indexes selected
C      AN       I(*)     Array of selected antennas
C      NA       I        Number of selected antennas
C      ISUB     I        Selected subarray (= 0 any)
C      JSUB     I        Output subarray number (< 0 => NO CHANGE)
C   Input/Output:
C      BUFFER   I(*)     Work buffer
C      OBUFF    I(*)     Work buffer
C   Output:
C      IRET     I        Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER DISKI, CNOI, DISKO, CNOO, VER, CATIN(256), CATOUT(256),
     *   LUNI, LUNO, BPOL, EPOL, BIF, EIF, IFQID, AN(*), NA, SOUIND(*),
     *   NSOU, ISUB, JSUB, BUFFER(*), OBUFF(*), IRET
      DOUBLE PRECISION TB, TE
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ICLRNO, CLKOLS(MAXCLC), CLNUMV(MAXCLC), NUMANT, NUMPOL,
     *   NUMIF, OKOLS(MAXCLC), ONUMV(MAXCLC), NCLROW, I, SOURID, ANTNO,
     *   SUBA, FREQID, REFA(2,MAXIF), OCLRNO, NTERM, NEWNIF, IIF, JIF,
     *   IPOL, K, OVER, LBPOL, NEWPOL, LBIF
      REAL      GMMOD, TIMEI, IFR, ATMOS, DATMOS, MBDELY(2), CLOCK(2),
     *   DCLOCK(2), DISP(2), DDISP(2), DOPOFF(MAXIF), CREAL(2,MAXIF),
     *   CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF), WEIGHT(2,MAXIF)
      DOUBLE PRECISION TIME, GEODLY(10)
      LOGICAL   GOTIT, REFMT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       Open CL file
      CALL CALINI ('READ', BUFFER, DISKI, CNOI, VER, CATIN, LUNI,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       New no. of IF's
      LBIF = MAX (1, BIF)
      NEWNIF = MIN (NUMIF, EIF) - LBIF + 1
      IF (NEWNIF.LE.0) THEN
         LBIF = 1
         NEWNIF = NUMIF
         END IF
      LBPOL = MAX (1, BPOL)
      NEWPOL = MIN (2, MIN (NUMPOL, EPOL)) - LBPOL + 1
      IF (NEWPOL.LE.0) THEN
         LBPOL = 1
         NEWPOL = NUMPOL
         END IF
      REFMT = (NEWNIF.NE.NUMIF) .OR. (NEWPOL.NE.NUMPOL)
C                                       # rows in old table
      NCLROW = BUFFER(5)
C                                       Open up new CL table
      OVER = VER
      CALL CALINI ('WRIT', OBUFF, DISKO, CNOO, OVER, CATOUT, LUNO,
     *   OCLRNO, OKOLS, ONUMV, NUMANT, NEWPOL, NEWNIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 100 I = 1,NCLROW
         CALL TABCAL ('READ', BUFFER, ICLRNO, CLKOLS, CLNUMV,
     *      NUMPOL, NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID,
     *      IFR, GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK,
     *      DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
C                                       Error
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1030) IRET
            GO TO 990
            END IF
C                                       Time selection
         IF ((TIME.LT.TB) .OR. (TIME.GT.TE)) IRET = -1
C                                       Sources selection
         IF ((NSOU.GT.0) .AND. (SOURID.GT.0)) THEN
            GOTIT = .FALSE.
            DO 20 K = 1,NSOU
               GOTIT = GOTIT .OR. (SOURID.EQ.SOUIND(K))
 20            CONTINUE
            IF (.NOT.GOTIT) IRET = -1
            END IF
C                                       Antennas selection
         IF ((NA.GT.0) .AND. (ANTNO.GT.0)) THEN
            GOTIT = .FALSE.
            DO 30 K = 1,NA
               GOTIT = GOTIT .OR. (ANTNO.EQ.AN(K))
 30            CONTINUE
            IF (.NOT.GOTIT) IRET = -1
            END IF
C                                       FQ selection
         IF ((IFQID.GT.0) .AND. (FREQID.GT.0) .AND. (IFQID.NE.FREQID))
     *      IRET = -1
C                                       Suba selection
         IF ((SUBA.GT.0) .AND. (ISUB.GT.0) .AND. (ISUB.NE.SUBA))
     *      IRET = -1
C                                       Is this record selected ?
         IF (IRET.LT.0) THEN
            REFMT = .TRUE.
C                                       Re-number IF's
         ELSE
            DO 90 JIF = 1,NEWNIF
               IIF = JIF + LBIF - 1
               DOPOFF(JIF) = DOPOFF(IIF)
               DO 80 IPOL = 1,NEWPOL
                  K = IPOL + LBPOL - 1
                  CREAL(IPOL,JIF) = CREAL(K,IIF)
                  CIMAG(IPOL,JIF) = CIMAG(K,IIF)
                  DELAY(IPOL,JIF) = DELAY(K,IIF)
                  RATE(IPOL,JIF) = RATE(K,IIF)
                  WEIGHT(IPOL,JIF) = WEIGHT(K,IIF)
                  REFA(IPOL,JIF) = REFA(K,IIF)
 80               CONTINUE
 90            CONTINUE
C
            IF (IFQID.GT.0) FREQID = 1
            IF (JSUB.GE.0) SUBA = JSUB
            CALL TABCAL ('WRIT', OBUFF, OCLRNO, OKOLS, ONUMV, NEWPOL,
     *         NEWNIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *         GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK,
     *         DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA,
     *         IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1040) IRET
               GO TO 990
               END IF
            END IF
 100     CONTINUE
      IRET = 0
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ICLRNO, BUFFER, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OCLRNO, OBUFF, OBUFF, IRET)
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         IF (REFMT) THEN
            WRITE (MSGTXT,1100) 'Reformatted CL', DISKI, CNOI, VER,
     *         DISKO, CNOO, OVER
         ELSE
            WRITE (MSGTXT,1100) 'Copied CL', DISKI, CNOI, VER, DISKO,
     *         CNOO, OVER
            END IF
         CALL MSGWRT (3)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('CLSEL: ERROR ',I3,' INITING OLD TABLE')
 1020 FORMAT ('CLSEL: ERROR ',I3,' INITING NEW TABLE')
 1030 FORMAT ('CLSEL: ERROR ',I3,' READING OLD TABLE')
 1040 FORMAT ('CLSEL: ERROR ',I3,' WRITING NEW TABLE')
 1100 FORMAT (A,' file from vol/cno/vers',I3,I5,I4,' to',I3,I5,I4)
      END

LOCAL INCLUDE 'PCCOR.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER MXANS, MXANSF, MXTIME, MXSIFT
      PARAMETER (MXANS = MAXANT*2)
      PARAMETER (MXANSF = MXANS*MAXIF)
      PARAMETER (MXTIME = 750)
      PARAMETER (MXSIFT = MAXIF*MXTIME)
C                                       XCALS was (4,1) but in POPSDAT
C                                       it's got 30 elements in the
C                                       second dimension.  PPM 19961001
      HOLLERITH  XNAMEI(3), XCLAIN(2), XCALS(4,30)
      REAL XSIN, XDISIN, TIMER(8), XSNVER, XPCVER, XREFA, XSUBA,
     *   XFQID, XOFF, XBIF, XEIF, XDELC, UTONES(2,MAXAFL),
     *   BUFF1(UVBFSS), TIME1, TIME2,
     *   GNMOD, DELAR(MXANSF), ADELY(MXANS), IFTBW(MAXIF),
     *   IFCHBW(MAXIF), F1(MAXIF), DFREQ(MAXIF)
      INTEGER NTWOPI
      INTEGER SNKOLS(MAXSNC), SNNUMV(MAXSNC), ISNRNO, NUMNOD,
     *   SUBA, SNV, SNLUN, SNBUFF(1024), PCBUFF(1024), NPOLZN,
     *   OLDCNO, PCVER, PCLUN, PCTOT, REFANT, NSRC, SELQUA(30),
     *   SOURID(30), NANPC(MAXANT), NTIME, RANT, NNMAX, FREQID,
     *   CABOFF, NNNIF, IBIF, IEIF, MDELC
      INTEGER SEQIN, DISKIN, NUMHIS, JBUFSZ, ILOCWT, CATOLD(256),
     *   INCSI, INCFI, INCIFI, LRECI, NRPRMI, NANT, ANTNO(MAXANT),
     *   NNIF, NNF, NCORI, NUMPC, SIND, IFSID(MAXIF),
     *   TONE1(MAXIF), TONE2(MAXIF)
      DOUBLE PRECISION AFREQ, GST0, XA(MAXANT),YA(MAXANT),ZA(MAXANT),
     *   DCABL(MAXANT),IFFREQ(MAXIF)
      LOGICAL   ISCOMP, ISAPPL, SOUCHK, PCYES(MXANSF), DATNO(MAXANT)
      CHARACTER NAMEIN*12, CLAIN*6, HISCRD(10)*64, STANAM(MAXANT)*8,
     *   CALSOU(1)*16
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, TIMER, XSNVER,
     *   XPCVER, XREFA, XSUBA,  XFQID, XCALS, XOFF, XBIF, XEIF,
     *   XDELC, UTONES
      COMMON /PCPARM/ CATOLD, SEQIN, DISKIN, NUMHIS, ILOCWT, INCSI,
     *   INCFI, INCIFI, LRECI, NRPRMI, ISCOMP, NNIF, NNF, NCORI, TIME1,
     *   TIME2, NANT, NPOLZN, OLDCNO, SIND, DELAR, ADELY, NANPC, NTIME,
     *   CABOFF, NNNIF, RANT, F1, DFREQ, NNMAX, SOUCHK, PCYES, DATNO,
     *   NTWOPI, IBIF, IEIF
      COMMON /CHARPM/ NAMEIN, CLAIN, HISCRD, STANAM, CALSOU
      COMMON /BUFRS/ BUFF1, JBUFSZ
      COMMON /CANIN/ XA, YA, ZA, AFREQ, GST0, DCABL, ANTNO, IFFREQ
      COMMON /SNPARM/ SNBUFF, PCBUFF, SNKOLS, SNNUMV, ISNRNO, NUMNOD,
     *   SNV, SNLUN, PCLUN, GNMOD, ISAPPL, PCVER, NUMPC, PCTOT,
     *   REFANT, NSRC, SELQUA, SOURID, IFTBW, IFCHBW, IFSID, FREQID,
     *   SUBA, TONE1, TONE2, MDELC
LOCAL END
      PROGRAM PCCOR
C-----------------------------------------------------------------------
C! Correct antennas gains using PC table data
C# Utility UV UV-util VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2003, 2009, 2011-2012, 2014-2015, 2018
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PCCOR corrects antennas gains using cal tones information
C   recorded in PC table.
C   This is a new version which works better for uncontinuos IFs
C
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      TIMERANG(8)    TIMER          Timerange of the calibrator
C                                   1-4 = start Day, Hour, Min, Sec.
C                                   5-8 =  end  Day, Hour, Min, Sec.
C      SNVER          SNV           The SN table number
C      PCVER          PCVER         The PC table number
C      REFANT         REFANT        A reference antenna
C      CALSOUR        CALSOU        Calibrator source
C      SUBARRAY       SUBA          Subarray
C      FREQID         FREQID        Frequency ID
C      CUTOFF         CABOFF        Switch off the cabel correction
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'PCCOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
C
      DATA PRGM /'PCCOR '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL PCCIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Calculate corrections for
C                                       the calibrator
      CALL PCCAL (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       apply the corrections for
C                                       target sources and
C                                       record them into SN table
      CALL PCTAG (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL PCCHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE PCCIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   PCCIN gets input parameters for PCCOR
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code:  0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      ISCOMP  L  If true data is compressed
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, UTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, CALCS(1), I, SUBAR,
     *   KEYLOC, KEYTYP, ORIGIN, NUMKEY, IDN(1), NSOUR, NID
      REAL      DECNOD(25), RANOD(25), TEMP
      LOGICAL   T, F, CHSTAT, MULTI, TABLE, EXIST, FITASC
C
      INCLUDE 'INCS:PPCV.INC'
C
      INTEGER   IPCRNO, NOPOLZ, NTONES, NOBAND
      INTEGER   PCKOLS(MAXPCC), PCNUMV(MAXPCC)
C
      INCLUDE 'PCCOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
C                                       Fixed PPM 1996.09.30: was 24!!!
C                                       add MAXAFL*2 for the arrays of
C                                       user tones UTONES
      NPARM = 144 + MAXAFL*2
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999

      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      SUBA = IROUND(XSUBA)
      FREQID = IROUND (XFQID)
      IF (FREQID.LE.0) FREQID = 1
      CABOFF = IROUND(XOFF)
      MDELC = IROUND(XDELC)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   UTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1060) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Check to see if PC table exists
      CALL FNDEXT ('PC', CATBLK, PCTOT)
      IF (PCTOT.EQ.0) THEN
         WRITE (MSGTXT,1040)
         JERR = 1
         GO TO 990
         END IF
C                                       PC number
      PCVER = IROUND(XPCVER)
      PCLUN = 30
      CALL PCINI ('READ', PCBUFF, DISKIN, OLDCNO, PCVER, CATBLK,
     *   PCLUN, IPCRNO, PCKOLS, PCNUMV, NOPOLZ, NOBAND, NTONES,
     *   JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1090) JERR
         GO TO 990
         END IF
      NUMPC = PCBUFF(5)
      CALL TABIO ('CLOS', 0, IPCRNO, PCBUFF, PCBUFF, JERR)
      JERR = 0
C                                       Set time range in days.
      TIME1 = TIMER(1)+TIMER(2)/24.+TIMER(3)/(24.*60.)
     *   +TIMER(4)/(24.*3600.)
      TIME2 = TIMER(5)+TIMER(6)/24.+TIMER(7)/(24.*60.)
     *   +TIMER(8)/(24.*3600.)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      JERR)
         IF (JERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      NNF = 1
      IF (JLOCF.GE.0) NNF = CATBLK(KINAX+JLOCF)
      NNNIF = 1
      IF (JLOCIF.GE.0) NNNIF = CATBLK(KINAX+JLOCIF)
      IF (JLOCIF.GE.0) THEN
         IBIF = IROUND (XBIF)
         IBIF = MAX (1, MIN (IBIF, CATBLK(KINAX+JLOCIF)))
         IEIF = IROUND (XEIF)
         IF (IEIF.EQ.0) IEIF = CATBLK(KINAX+JLOCIF)
         IF (IBIF.GT.IEIF) IEIF = CATBLK(KINAX+JLOCIF)
         IEIF = MAX (1, MIN (IEIF, CATBLK(KINAX+JLOCIF)))
      ELSE
         IBIF = 1
         IEIF = 1
         END IF
      NNIF = IEIF - IBIF + 1
C                                       PCAL can not be used if NNF or
C                                       NNIF.EQ.1
      IF (NNIF.LE.1) THEN
         WRITE (MSGTXT,1100) NNIF
         JERR = 1
         GO TO 990
         END IF
      IF (NNF.LE.1) THEN
         WRITE (MSGTXT,1110) NNF
         JERR = 1
         GO TO 990
         END IF
      TEMP = NNF * CATR(KRCIC+JLOCF) / 1.E6
      IF ((TEMP.LT.2.0*NTONES) .AND. (NTONES.GT.4)) THEN
         MSGTXT = 'YOU HAVE A LARGE PC TABLE: USE PCFLG OR PCRMS TO' //
     *      ' EDIT IT'
         CALL MSGWRT (7)
         MSGTXT = 'THEN USE PCFIT TO DETERMINE DELAY CHANGES WITH TIME'
         CALL MSGWRT (7)
         MSGTXT = 'SEE AIPS MEMO 123 FOR THE DETAILS'
         CALL MSGWRT (7)
         MSGTXT = 'YOU WILL STILL NEED TO USE FRING AS WELL'
         CALL MSGWRT (7)
         JERR = 10
         GO TO 999
         END IF

C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                        Put input file in READ
      UTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   UTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Prepare antennas data
      SUBAR = SUBA
      IF (SUBAR.LE.0) SUBAR = 1
      CALL ANTDAT (SUBAR, DISKIN, OLDCNO, IERR)
      IF (IERR.NE.0) THEN
         JERR = 1
         WRITE (MSGTXT, 1120)
         GO TO 990
         END IF
C                                       Refant
      REFANT = IROUND(XREFA)
      IF (REFANT.EQ.0) REFANT = ANTNO(1)
C                                       Calibrator and its ID
      CALL H2CHR (16, 1, XCALS(1,1), CALSOU(1))
C                                       use source selection?
      CALCS(1) = -1
      NSOUR = 1
      NID = 1
      CALL SOURNU (CALSOU, CALCS, NSOUR, DISKIN, OLDCNO, NID,
     *   BUFF1, IDN, IERR)
      IF (IERR.NE.0) THEN
         JERR = 1
         WRITE (MSGTXT,1130) CALSOU
         GO TO 990
         END IF
      SOUCHK = NID.GT.0
      SIND = IDN(1)
      UTYPE = 'UV'
      CHSTAT = .FALSE.
      CALL CATDIR ('INFO', DISKIN, OLDCNO, NAMEIN, CLAIN,
     *   SEQIN, UTYPE, NLUSER, STAT, BUFF1, IERR)
C                                       Change status
      IF (STAT.EQ.  'READ') THEN
         STAT = 'CLRD'
         CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN,
     *      SEQIN, UTYPE, NLUSER, STAT, BUFF1 , IERR)
         IF (IERR.NE.0) THEN
            JERR = 1
            WRITE (MSGTXT,1140) IERR, STAT
            GO TO 990
            END IF
         STAT = 'WRIT'
         CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN,
     *      SEQIN, UTYPE, NLUSER, STAT, BUFF1, IERR)
         IF (IERR.NE.0) THEN
            JERR = 1
            WRITE (MSGTXT,1140) IERR, STAT
            GO TO 990
            END IF
         CHSTAT = .TRUE.
         END IF
C
      ISAPPL = F
      GNMOD = 1.0
      DO 60 I = 1, 25
         RANOD(I) = 0.0
         DECNOD(I) = 0.0
   60    CONTINUE
      SNLUN = 48
      NPOLZN = 2
      IF (NCOR.EQ.1) NPOLZN = 1
      NUMNOD = 0
C                                       SNVER
      SNV = IROUND(XSNVER)
C                                       terminate if the given SN table
C                                       exists
      IF (SNV.NE.0) THEN
         CALL ISTAB ('SN', DISKIN, OLDCNO, SNV, SNLUN, BUFF1, TABLE,
     *      EXIST, FITASC, JERR)
         IF (EXIST) THEN
            JERR = 1
            WRITE (MSGTXT, 1080) SNV
            GO TO 990
            END IF
         END IF
C                                       Open SN table
      CALL SNINI ('WRIT', SNBUFF, DISKIN, OLDCNO, SNV, CATBLK, SNLUN,
     *   ISNRNO, SNKOLS, SNNUMV, NANT, NPOLZN, NNNIF, NUMNOD,
     *   GNMOD, RANOD, DECNOD, ISAPPL, IERR)
      IF (IERR.NE.0) THEN
         JERR = 1
         WRITE (MSGTXT,1010) SNV
         GO TO 990
         END IF
      ISNRNO = 1
      WRITE (MSGTXT,1070) SNV
      CALL MSGWRT (8)
C                                       history file
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2100) (TIMER(I),I=1,8)
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2200) CALSOU(1)
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2300) SNV, PCVER
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2500) REFANT, SUBA
      NUMHIS = NUMHIS + 1
      WRITE (HISCRD(NUMHIS),2600) FREQID
C                                       Add the ORIGIN keyword
      CALL MULSDB (CATBLK, MULTI)
      KEYLOC = 1
      KEYTYP = 4
      ORIGIN = 0
      NUMKEY = 1
      IF (.NOT.MULTI) ORIGIN = 1
      CALL TABKEY ('WRIT', 'SNORIGIN', NUMKEY, SNBUFF, KEYLOC,
     *   ORIGIN, KEYTYP, IERR)
      IF (IERR.NE.0) THEN
         JERR = 1
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       Check if changed status
      IF (CHSTAT) THEN
         STAT = 'CLWR'
         CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN,
     *      SEQIN, UTYPE, NLUSER, STAT, BUFF1, IERR)
         IF (IERR.NE.0) THEN
            JERR = 1
            WRITE (MSGTXT,1140) IERR, STAT
            GO TO 990
            END IF
         STAT = 'READ'
         CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN,
     *      SEQIN, UTYPE, NLUSER, STAT, BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1140) IERR, STAT
            GO TO 990
            END IF
         END IF
      JERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PCCIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('PCCIN: ERROR in initialization of SN table ',I3)
 1020 FORMAT ('PCCIN: ERROR',I3,' READING KEYWORDS FROM SN TABLE')
 1030 FORMAT ('PCCIN: UNABLE TO DETERMINE DATA STOP TIME')
 1040 FORMAT ('No PC table found')
 1050 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1060 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1070 FORMAT ('Writing to SN table ',I3)
 1080 FORMAT ('SN table', I3,' already exists')
 1090 FORMAT ('PCCIN: ERROR ',I3,' OPENING PC TABLE')
 1100 FORMAT ('Data have',I3, ' IFs. It is too small.')
 1110 FORMAT ('Data have',I3,' frequencies per IF. It is too small.')
 1120 FORMAT ('PCCIN: PROBREM OF READING DATA FROM ANTENNA TABLE')
 1130 FORMAT ('PCCIN: Source ',A16, ' not found in the SU table')
 1140 FORMAT ('PCCIN: ERROR ',I3,' CHANGING ',A4,' STATUS')
 2100 FORMAT (F3.0,1X,F3.0,F3.0,F4.1,' - ',F3.0,1X,F3.0,F3.0,F4.1,
     *   '/ Time range')
 2200 FORMAT ('Calibrator = ', A16)
 2300 FORMAT ('SN table =',I3, 2X, 'PC table =',I3)
 2500 FORMAT ('Reference antenna =',I4, 2X,' Subarray =', I2)
 2600 FORMAT ('Freqid =',I3)
      END
      SUBROUTINE PCCAL (IRET)
C-----------------------------------------------------------------------
C   PCCAL estimates single and multi band delays using the both
C   PC table data of calibrator and visibilities of calibrator
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      ISCOMP  L  If true data is compressed
C      NNIF    I  Number of IFs
C      NF      I  Number of frequencies in each IF
C      NPOLZN  I  Number of polarization in antennas
C      TIME1   R  The start time of calibrator, in days
C      TIME2   R  The end time of calibrator, in days
C
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C   Output in common:
C      DELAR   R(*) single band delay for each stokes, IF, antenna
C                   which align phase for all IFs, using the calibrator
C      ADELY   R(*) additional delay for each stokes and antenna
C                   constant for all IF. This delay
C                   flatten the align phase for all IF.
C      DCABL   D(*) Mean delay in the cable for each
C                   antenna while observing the calibrator
C                   depending on IF, polarisation and time.
C      NTIME   I    Number of reference antenna appearences in PC table.
C      RANT    I    Reference antenna number
C-----------------------------------------------------------------------
      INCLUDE 'PCCOR.INC'
      INTEGER MXTOT, MJF, MXTONE
      PARAMETER (MXTOT = 100000)
      PARAMETER (MJF = 2*MAXCHA)
      PARAMETER (MXTONE = MAXIF*8)
      CHARACTER  IFILE*48, POL(2)*3
      INTEGER   INIO, IPTRI, LUNI, INDI, ILENBU, IBIND, I, IA1, IA2,
     *   INCX, BO, VO, JIF, JF, JS, IANT, INDEXI, IRET, ITIME, FQID,
     *   LUNFQ, ADR, IND1, IND2, IROW, NBASE, NMAX, LANT, MXT, MXOUR,
     *   CURSUB, CURSOU, ITONE, KTONES, KIF, LTONE
      LOGICAL   T, F, SOUFOU, FIRST, BAD
      REAL  BASEN,  CBUFF(UVBFSS), REAL1(MXANSF), IMAG1(MXANSF),
     *   REAL2(MXANSF), IMAG2(MXANSF), RE, IM, REOUT(MXTOT), WT, FA,
     *   FPULS, DATA(MJF), DELL, IMOUT(MXTOT), AMPP, DDAMP, DDEL,
     *   IDATA(MXTONE), FIIN1(MXANSF), FIIN2(MXANSF), DELIF(MAXIF),
     *   FTONE(MXTONE), FIACT1, FIACT2, FICOR1, FICOR2, DFREQM,
     *   DFTONM, DFA, COEFF, TAUA, ATANG2, DFI, RPIX
      DOUBLE PRECISION MXFTON, MNFTON
      CHARACTER BNDCOD(MAXIF)*8
C
      INCLUDE 'INCS:PPCV.INC'
C
      INTEGER   IPCRNO, NOPOLZ, NTONES
      INTEGER   NOSTA, IARRAY, IFQID, ISRC
      REAL      TINT, PCREL(2, MAXTON, MAXIF),
     *   PCIMG(2,  MAXTON,MAXIF), PCRAT(2, MAXTON, MAXIF),
     *   STATE(2, 4, MAXIF)
      DOUBLE PRECISION TIME, CABLCL, PCFRQ(2, MAXTON, MAXIF), PCABLC
      INTEGER   PCKOLS(MAXPCC), PCNUMV(MAXPCC)
C
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
C
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DGLB.INC'
C
      DATA FPULS /1.0E6/
      DATA LUNI /16/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      PCABLC = 0.0D0
      CALL PCINI ('READ', PCBUFF, DISKIN, OLDCNO, PCVER, CATBLK,
     *   PCLUN, IPCRNO, PCKOLS, PCNUMV, NOPOLZ, NOBAND, NTONES,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       STOP: number of tones is .LT.2
      IF (NTONES.LT.2) THEN
         IRET = 1
C         IF (2*NOBAND*NOPOLZ.GT.16) THEN
C            WRITE (MSGTXT,1005) NOBAND, NOPOLZ
C            CALL MSGWRT (8)
C            WRITE (MSGTXT,1006)
C            GO TO 990
C         ELSE
            WRITE (MSGTXT,1007)
            GO TO 990
C            END IF

         END IF


      DFTONM = FPULS
      IF (2*NNF.GT.MJF)  THEN
         IRET = 1
         WRITE (MSGTXT,1010) NNF, MJF/2
         GO TO 990
         END IF
C                                       Get FQ table information
      FQID = FREQID
      LUNFQ = 40
      CALL GETFQ (FQID, DISKIN, OLDCNO, CATBLK, LUNFQ, IFFREQ, IFTBW,
     *   IFCHBW, IFSID, BNDCOD, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
      IF (ISCOMP) INCX = 3
C                                       Number of visibilities in input
      NCORI = (LRECI - NRPRMI) / CATOLD(KINAX)
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1040) IRET
         GO TO 990
         END IF
C                                       reference antenna number
      DO 40 IANT = 1, NANT
         IF (ANTNO(IANT).EQ.REFANT) GO TO 50
   40    CONTINUE
      IRET = 1
      WRITE (MSGTXT,1050) REFANT
      GO TO 990
   50 CONTINUE
      RANT = IANT
C
C                                       initialize real and image of
C                                       the tones and cablcal
      DO 70 I = 1, NANT
         DCABL(I) = 0.0D0
         NANPC(I) = 0
         DO 65 JIF = 1,NNNIF
            DO 60 JS = 1,NOPOLZ
               ADR = JS + (JIF-1)*NOPOLZ + (I-1)*NOPOLZ*NNNIF
               REAL1(ADR) = 0.0
               IMAG1(ADR) = 0.0
               REAL2(ADR) = 0.0
               IMAG2(ADR) = 0.0
   60          CONTINUE
   65          CONTINUE
   70    CONTINUE
      SOUFOU = F
C                                       Read the data from PC table
C                                       and average it through the
C                                       given timerange
C
C                                       Introduce TONE1(JIF), TONE2(JIF)
C                                       and IFSID(JIF) to handle both
C                                       LSB and USB
      ITIME = 0
      FIRST = .TRUE.
      DO 110 IROW = 1, NUMPC
         CALL TABPC ('READ', PCBUFF, IPCRNO, PCKOLS, PCNUMV,
     *      NOPOLZ, TIME, TINT, ISRC, NOSTA, IARRAY, IFQID,
     *      CABLCL, STATE, PCFRQ, PCREL, PCIMG, PCRAT, IRET)
         IF (IRET.NE.0) THEN
            CALL TABERR ('READ', 'TABPC ', 'PCCAL ', IRET)
            GO TO 999
            END IF
         IF (CABLCL.EQ.DBLANK) THEN
            CABLCL = PCABLC
         ELSE
            PCABLC = CABLCL
            END IF
C                                       take frequencies for the given
C                                       FREQID only at the first
C                                       appearence of the FREQID
         IF (FREQID.NE.IFQID) GO TO 110


C                                       Select subarray, FREQID
         IF ((SUBA.NE.IARRAY) .AND. (SUBA.NE.0)) GO TO 110
C                                       select time for calibrator
         IF (TIME.GT.TIME2  .OR.  TIME.LT.TIME1)
     *      GO TO 110
C                                       select calibrator source
         IF (SOUCHK) THEN
            IF (ISRC.NE.SIND) GO TO 110
            SOUFOU = SOUFOU .OR. (ISRC.EQ.SIND)
         ELSE
            SOUFOU = .TRUE.
            END IF
         DO 90 IANT = 1, NANT
            IF (ANTNO(IANT).EQ.NOSTA) GO TO 95
   90    CONTINUE
         GO TO 110
   95    CONTINUE
         IF (FIRST) THEN
            DFREQM = 0.0
            DO 80 JIF = 1,NNNIF
C                                       take the most left and right
C                                       tones if there are more than two
               MXFTON = 0
               MNFTON = 1.0E20
               LTONE = 0
               DO 75 ITONE = 1, NTONES
C                                       skip bad rows at the PC table
                  BAD = (PCFRQ(1, ITONE, JIF).LE.0) .OR.
     *               (PCREL(1, ITONE, JIF).EQ.0 .AND.
     *               PCIMG(1, ITONE, JIF).EQ.0) .OR.
     *               (PCREL(1, ITONE, JIF).EQ.FBLANK) .OR.
     *               (PCIMG(1, ITONE, JIF).EQ.FBLANK)
C                                       count the good tones number
C                                       for the given IF
                  IF (BAD) THEN
                     GO TO 75
                  ELSE
                     LTONE = LTONE + 1
                     END IF
                  IF (PCFRQ(1, ITONE, JIF).GT.MXFTON) THEN
                     MXFTON = PCFRQ(1, ITONE, JIF)
                     TONE2(JIF) = ITONE
                     END IF
                  IF (PCFRQ(1, ITONE, JIF).LT.MNFTON) THEN
                     MNFTON = PCFRQ(1, ITONE, JIF)
                     TONE1(JIF) = ITONE
                     END IF
   75             CONTINUE
C                                       Enter the input TONE1, TONE2
               IF (INT(UTONES(1,JIF)) .GT. 0 .AND.
     *            INT(UTONES(1,JIF)) .LE. NTONES)
     *            TONE1(JIF) = UTONES(1,JIF)

               IF (INT(UTONES(2,JIF)) .GT. 0 .AND.
     *            INT(UTONES(2,JIF)) .LE. NTONES)
     *            TONE2(JIF) = UTONES(2,JIF)
C                                       go to the next row if at least
C                                       one IF has only one (or 0) tones
               IF (LTONE.LT.2) GO TO 110
               IFSID(JIF) = 1
               DFREQ(JIF) = PCFRQ(1, TONE2(JIF), JIF) -
     *            PCFRQ(1, TONE1(JIF), JIF)
C                                       change sign of the Fourie if
C                                       the last tone frequency is less
C                                       the first one
               IF ((PCFRQ(1, LTONE, JIF) - PCFRQ(1, 1, JIF)).LE.0)
     *            IFSID(JIF) = -1
               F1(JIF) = PCFRQ(1, TONE1(JIF), JIF) - IFFREQ(JIF)
C                                       Find the maximum of DFREQ
               IF(DFREQ(JIF).GE.DFREQM) DFREQM = DFREQ(JIF)
   80          CONTINUE
            FIRST = .FALSE.
            END IF
         LANT = IANT
C                                       average cablecal data
         DCABL(LANT) = DCABL(LANT) + CABLCL
         NANPC(LANT) = NANPC(LANT) + 1
         DO 105 KIF = 1, NNIF
C                                       take only selected IFs
C                                       For all other IFs REAL, IMAG
C                                       stay zero
            JIF = KIF + IBIF - 1
C                                       average complex amplitudes
C                                       of tones in time
            DO 100 JS = 1,NOPOLZ
               ADR = JS + (JIF-1)*NOPOLZ + (LANT-1)*NOPOLZ*NNNIF
C                                       skip bad rows of PC table
               BAD = (PCIMG(JS, TONE1(JIF),JIF).EQ.0.0 .AND.
     *            PCREL(JS, TONE1(JIF),JIF).EQ.0) .OR.
     *            (PCIMG(JS, TONE2(JIF),JIF).EQ.0.0 .AND.
     *            PCREL(JS, TONE2(JIF),JIF).EQ.0) .OR.
     *            (PCREL(JS, TONE1(JIF),JIF).EQ.FBLANK) .OR.
     *            (PCIMG(JS, TONE1(JIF),JIF).EQ.FBLANK) .OR.
     *            (PCREL(JS, TONE2(JIF),JIF).EQ.FBLANK) .OR.
     *            (PCIMG(JS, TONE2(JIF),JIF).EQ.FBLANK)
               IF (BAD) GO TO 100
               REAL1(ADR) = REAL1(ADR) + PCREL(JS, TONE1(JIF),JIF)
               IMAG1(ADR) = IMAG1(ADR) + PCIMG(JS, TONE1(JIF),JIF) *
     *               IFSID(JIF)
               REAL2(ADR) = REAL2(ADR) + PCREL(JS, TONE2(JIF),JIF)
               IMAG2(ADR) = IMAG2(ADR) + PCIMG(JS, TONE2(JIF),JIF) *
     *            IFSID(JIF)
  100          CONTINUE
  105       CONTINUE
  110    CONTINUE
      NTIME = ITIME
C                                       Is there at least one good line
C                                       in PC table?
      IF(FIRST) THEN
         IRET = 1
         WRITE (MSGTXT,1090)
         GO TO 990
         END IF
C                                       Is there selected source
C                                       in PC table?
      IF(.NOT. SOUFOU) THEN
         IRET = 1
         WRITE (MSGTXT,1080) CALSOU(1)
         CALL MSGWRT (8)
         WRITE (MSGTXT,1085)
         GO TO 990
         END IF
C                                       Is there PC tones?
      POL(1) = 'RCP'
      POL(2) = 'LCP'
      DO 140 IANT = 1, NANT
         IF (NANPC(IANT).NE.0) THEN
            DCABL(IANT) = DCABL(IANT) / NANPC(IANT)
         ELSE
            WRITE (MSGTXT,1095) IANT
            CALL MSGWRT (8)
            GO TO 140
            END IF
         DO 130 KIF = 1,NNIF
            JIF = KIF + IBIF - 1
            DO 120 JS = 1,NOPOLZ
               ADR = JS + (JIF-1)*NOPOLZ + (IANT-1)*NOPOLZ*NNNIF
               PCYES(ADR) = .TRUE.
               IF ((REAL1(ADR).EQ.0.0 .AND. IMAG1(ADR).EQ.0.0)
     *            .OR. (REAL2(ADR).EQ.0.0.AND.IMAG2(ADR).EQ.0.0))
     *            THEN
                  PCYES(ADR) = .FALSE.
                  WRITE (MSGTXT,1100) IANT, POL(JS), JIF
                  CALL MSGWRT (8)
                  END IF
  120          CONTINUE
  130       CONTINUE
  140    CONTINUE
C                                       Find the ambiguaty range
      NMAX = DFREQM / FPULS
      NMAX = MAX(1, NMAX)
      NMAX = 2*NMAX
C                                       the range is doubled because
C                                       we compare the difference
C                                       between two antennas
      NNMAX = 2*NMAX + 1
C                                       enough demension of arrays
C                                       REOUT(), IMOUT()?
      MXT = MXTOT
      MXOUR = NANT*NNNIF*NPOLZN*NNF
      IF (MXOUR.GT.MXT) THEN
         IRET = 1
         WRITE (MSGTXT,1110) MXOUR, MXT
         GO TO 990
         END IF
      DO 200 IANT = 1, NANT
         IF (NANPC(IANT).EQ.0) GO TO 200
         DO 180 KIF = 1,NNIF
            JIF = KIF + IBIF - 1
            DO 160 JS = 1,NOPOLZ
               ADR = JS + (JIF-1)*NOPOLZ + (IANT-1)*NOPOLZ*NNNIF
               IF (PCYES(ADR)) THEN
                  FIIN1(ADR) = ATANG2(IMAG1(ADR), REAL1(ADR))
                  FIIN2(ADR)=  ATANG2(IMAG2(ADR), REAL2(ADR))
                  END IF
  160          CONTINUE
  180       CONTINUE
  200    CONTINUE
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1120) IRET
         GO TO 990
         END IF
      NBASE = (NANT * (NANT-1)) / 2
C                                       Initialize ampl. and phase to
C                                       zero before averaging in time
      DO 280 IANT = 1, NANT
         DO 260 JIF = 1,NNNIF
            DO 240 JS = 1,NPOLZN
               DO 220 JF = 1,NNF
                  ADR = JS + (JIF-1)*NPOLZN + (JF-1)*NPOLZN*NNNIF
     *               + (IANT-1)*NPOLZN*NNNIF*NNF
                  REOUT(ADR) = 0.0
                  IMOUT(ADR) = 0.0
  220             CONTINUE
  240             CONTINUE
  260       CONTINUE
  280    CONTINUE
C----------------------------------------------------------------
C                                       average in time visibilities
C                                       of interferometers with
C                                       reference antenna for
C                                       selected calibrator and time
  300 CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1140) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Out of data?
         IF (INIO.LE.0) GO TO 500
C                                       Loop over buffer
         DO 480 I = 1,INIO
            IF ( BUFF1(IPTRI+ILOCT).LT.TIME1 ) GO TO 460
            IF ( BUFF1(IPTRI+ILOCT).GT.TIME2 ) GO TO 500
            IF (ILOCB.GE.0) THEN
               BASEN = BUFF1(IPTRI+ILOCB)
               IA1 = BASEN / 256. + 0.1
               IA2 = BASEN - IA1*256. + 0.1
C                                       check subarray
               CURSUB = 1.1 + 100.0 * AMOD(BASEN, 1.0)
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               CURSUB = BUFF1(IPTRI+ILOCSA) + 0.1
               END IF
            IF ((CURSUB.NE.SUBA) .AND. (SUBA.NE.0)) GO TO 460
C                                       check cal. source
            CURSOU = SIND
            IF (ILOCSU.GE.0) CURSOU = BUFF1(IPTRI+ILOCSU) + 0.5
            IF ((CURSOU.NE.SIND) .AND. SOUCHK) GO TO 460
C                                       take only cros correlation
            IF (IA1.EQ.IA2) GO TO 460
C                                       take baselines with ref. ant.
            IF (IA1.NE.REFANT) THEN
               IF (IA2.NE.REFANT) GO TO 460
               DO 320 IANT = 1, NANT
                  IF (ANTNO(IANT).EQ.IA1) GO TO 340
  320             CONTINUE
               GO TO 460
  340          CONTINUE
               LANT = IANT
               COEFF = -1
            ELSE
               DO 360 IANT = 1, NANT
                  IF (ANTNO(IANT).EQ.IA2) GO TO 380
  360             CONTINUE
               GO TO 460
  380          CONTINUE
               LANT = IANT
               COEFF = 1
               END IF
C                                       Compressed data.
            IF (ISCOMP)  CALL ZUVXPN (NCORI, BUFF1(IPTRI+NRPRMI),
     *         BUFF1(IPTRI+ILOCWT), CBUFF)
            DO 440 KIF = 1,NNIF
               JIF = KIF + IBIF - 1
                  DO 420 JS = 1,NPOLZN
                     DO 400 JF = 1,NNF
                        ADR = JS + (JIF-1)*NPOLZN + (JF-1)*NPOLZN*NNNIF
     *                     + (LANT-1)*NPOLZN*NNNIF*NNF
                        INDEXI = (JIF-1) * INCIFI + (JF-1) *
     *                     INCFI + (JS-1) * INCSI + 1
                        IF (ISCOMP) THEN
                           RE = CBUFF(1 + (INDEXI - 1)*3 )
                           IM = CBUFF(2 + (INDEXI - 1)*3 )*COEFF
                           WT = CBUFF(3 + (INDEXI -1)*3 )
                        ELSE
                           RE = BUFF1(IPTRI + NRPRMI +
     *                        (INDEXI -1)*3 )
                           IM = BUFF1(IPTRI + NRPRMI + 1 +
     *                        (INDEXI -1)*3 ) * COEFF
                           WT = BUFF1(IPTRI + NRPRMI + 2 +
     *                        (INDEXI -1)*3 )
                           END IF
C                                       average in time
                        REOUT(ADR) = REOUT(ADR) + RE*WT
                        IMOUT(ADR) = IMOUT(ADR) + IM*WT
  400                   CONTINUE
  420             CONTINUE
  440          CONTINUE
  460          IPTRI = IPTRI + LRECI
  480       CONTINUE
C                                       Read next buffer.
         GO TO 300
  500 CONTINUE
C                                       check the data exist for all
C                                       antennas with reference one
      DO 550 IANT = 1, NANT
         DATNO(IANT) = .FALSE.
         IF(IANT.EQ.RANT) GO TO 550
         ADR =  1 + (IBIF-1)*NPOLZN + (IANT-1)*NPOLZN*NNNIF*NNF
         IF ((REOUT(ADR).EQ.0.0) .AND.
     *      (IMOUT(ADR).EQ.0.0)) THEN
            DATNO(IANT) = .TRUE.
            WRITE (MSGTXT,1150) ANTNO(IANT), ANTNO(IANT), ANTNO(RANT)
            CALL MSGWRT (8)
            END IF
  550    CONTINUE
C-----------------------------------------------------------------
C      Estimate 'multiband' delay TAUA combining phases of data
C      at pc tones location. Estimate requied single band delays
C      DEL as a difference of phase slopes of data DELIF and TAUA
C-----------------------------------------------------------------
C                                       Store everything for reference
C                                       antenna
       IF ((NANPC(RANT).EQ.0) .OR. DATNO(RANT)) GO TO 600
       DO 580 JS = 1, NPOLZN
C
          IND1 = JS + (RANT-1)*NPOLZN
          ADELY(IND1) = 0
C
          DO 570 KIF = 1, NNIF
             JIF = KIF + IBIF - 1
C
             IND2 = JS + (JIF-1)*NPOLZN + (RANT-1)*NPOLZN*NNNIF
             DFI = FIIN2(IND2) - FIIN1(IND2)
             IF (DFI.GT.PI) DFI = DFI - TWOPI
             IF (DFI.LE.-PI) DFI = DFI + TWOPI
C                                       store delay at the reference
C                                       scan for reference antenna
             DELAR(IND2) = DFI / DFREQ(JIF) / TWOPI
  570        CONTINUE
  580     CONTINUE
C
  600 CONTINUE
C                                       reference pixel of the
C                                       reference frequency
C
      RPIX = CATR(KRCRP+1)
C                                       tones' delay of other
C                                       (not reference) antennas
      DO 660 IANT = 1, NANT
         IF ((NANPC(IANT).EQ.0) .OR. DATNO(IANT)) GO TO 660
         IF (IANT.EQ.RANT)  GO TO 660
         DO 650 JS = 1, NPOLZN
C
            ITONE = 0
C                                       calculate phases of data
C                                       at the tones points corrected
C                                       by pccal data
            DO 640 KIF = 1, NNIF
               JIF = KIF + IBIF - 1
               DO 615 JF = 1, NNF
                  ADR = JS + (JIF-1)*NPOLZN + (JF-1)*NPOLZN
     *               *NNNIF + (IANT-1)*NPOLZN*NNNIF*NNF
                  DATA(2*JF-1) = REOUT(ADR)
                  DATA(2*JF)   = IMOUT(ADR)
  615             CONTINUE
C                                       estimate amplitude, rate and
C                                       phase of the data
               CALL AFRFI (DATA, NNF, AMPP, DELL, FA, DDAMP, DDEL,
     *               DFA, IRET)
C                                       store delays for each IF
               DELIF(JIF) = DELL / IFCHBW(JIF)
               IND1 = JS + (JIF-1)*NPOLZN + (RANT-1)*NPOLZN*NNNIF
               IND2 = JS + (JIF-1)*NPOLZN + (IANT-1)*NPOLZN*NNNIF
C                                       the first tone
               ITONE = ITONE + 1
               FTONE(ITONE) = PCFRQ(JS, TONE1(JIF),JIF)
C                                       Fa is the phase of the first
C                                       point at the spectrum. So we
C                                       have to recalculate the first
C                                       point's phase to the place of
C                                       the first pulse cal
               FIACT1 = FA + TWOPI*DELIF(JIF)*
     *            (F1(JIF) - (1 - RPIX) * IFCHBW(JIF))
               FICOR1 = FIACT1 - FIIN1(IND2) + FIIN1(IND1)
               IDATA(2*ITONE-1) = COS(FICOR1)
               IDATA(2*ITONE) = SIN(FICOR1)
C                                       the second tone
               ITONE = ITONE + 1
               FTONE(ITONE) = PCFRQ(JS, TONE2(JIF),JIF)
               FIACT2 = FIACT1 + TWOPI*DELIF(JIF)*DFREQ(JIF)
               FICOR2 = FIACT2 - FIIN2(IND2) + FIIN2(IND1)
               IDATA(2*ITONE-1) = COS(FICOR2)
               IDATA(2*ITONE) = SIN(FICOR2)
  640          CONTINUE
            KTONES = ITONE
C                                       find 'multiband' delay TAUA,
C                                       using phases of data at pc tones
C                                       position
            CALL AFRF (IDATA, KTONES, FTONE, DFTONM, AMPP, TAUA, FA,
     *         DDAMP, DDEL, DFA, IRET)
C
            IND1 = JS + (IANT-1)*NPOLZN
            ADELY(IND1) = -TAUA
C
            DO 645 KIF = 1,NNIF
               JIF = KIF + IBIF - 1
               IND1 = JS + (JIF-1)*NPOLZN + (RANT-1)*NPOLZN*NNNIF
               IND2 = JS + (JIF-1)*NPOLZN + (IANT-1)*NPOLZN*NNNIF
C                                       unambiguos delay for difference
C                                       given - reference antenna
               DELAR(IND2) = DELIF(JIF) - TAUA
C                                       unambiguos delay for the given
C                                       antenna, adding delay of
C                                       reference antenna
               DELAR(IND2) = DELAR(IND2) + DELAR(IND1)
  645          CONTINUE
  650       CONTINUE
  660    CONTINUE
C                                       Close up
      CALL ZCLOSE (LUNI, INDI, IRET)
C                                       Close PC table
      CALL TABIO ('CLOS', 0, IPCRNO, PCBUFF, PCBUFF, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PCCAL: ERROR ',I3,' OPENING PC TABLE')
 1005 FORMAT ('Number of tones <2 because 2*NIF (=',I2,
     *   ')*NPOL(=',I2,') exceeds ')
 1006 FORMAT ('number of available PC detectors (equaled 16)')
 1007 FORMAT ('Stop because number of tones <2')
 1010 FORMAT ('Frequency channels number ', I5, 'exceeds maximum', I5)
 1020 FORMAT ('PCCAL: ERROR ',I3,' READING FQ TABLE')
 1040 FORMAT ('PCCAL: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1050 FORMAT ('The reference antenna #',I3,
     *   ' is not in the antenna list')
 1080 FORMAT ('Source ',A16, ' does not exist in the PC table')
 1085 FORMAT ('for the given timerang')
 1090 FORMAT ('All rows of the PC table are bad for the selected'
     *   , ' parameters')
 1095 FORMAT ('Antenna ', I2, ' is not corrected: no PCAL  at the',
     *   ' selected scan')
 1100 FORMAT ('There is no PCAL for ANT=',I2,',  POL=',A3,',  IF=',I2)
 1110 FORMAT ('The product NANT*NIF*NPOLZN*NF = ',I7,
     *   ' exceeds',I6)
 1120 FORMAT ('PCCAL: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1140 FORMAT ('PCCAL: ERROR',I3,' READING VIS FILE')
 1150 FORMAT ('Antenna',I2,' is not corrected: baseline',
     *   I2,'-',I2,' absent at the scan')
      END
      SUBROUTINE PCTAG (IRET)
C-----------------------------------------------------------------------
C   PCTAG uses single and multi band delays obtained from a calibrator
C   and the pccal information from a row of PC table and transforms
C   the row to SN table row.
C   Input in common:
C      NNIF    I    Number of IFs
C      NF      I    Number of frequencies in each IF
C      NPOLZN  I    Number of polarization in antennas
C      DELAR   R(*) Single band delay for each stokes, IF, antenna
C                   which align phase for all IFs, using the calibrator
C      ADELY   R(*) additional delay for each stokes and antenna
C                   constant for all IF. This delay
C                   flatten the align phase for all IF.
C      DCABL   D(*) Mean delay in the cable for each
C                   antenna while observing the calibrator
C      NTIME   I    Number of reference antenna appearences in PC table.
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER MAXN, MXTOT, MAXND
      PARAMETER (MAXN = 200)
      PARAMETER (MAXND = MAXN*5)
      PARAMETER (MXTOT = 100000)
      INCLUDE 'PCCOR.INC'
      INTEGER   I, L, JIF, JS, IANT, MODENO, IRET, REFA(2,MAXIF), IND1,
     *   IROW, LANT, IND0, IROUND
      DOUBLE PRECISION CTIM
      REAL REAL(2,MAXIF), IMAG(2,MAXIF), DELAY(2,MAXIF), FI, DISP(2),
     *   RATE(2,MAXIF), WEIGHT(2,MAXIF), MBDELY(2), TIMINT, IFRM,
     *   ADDEL, DELL, DFI, FIREF, DELL1, CABCOR, ATANG2, DDISP(2)
      LOGICAL REIM
C
      INCLUDE 'INCS:PPCV.INC'
C
      INTEGER   IPCRNO, NOPOLZ, NTONES
      INTEGER   NOSTA, IARRAY, IFQID, ISRC
      REAL      TINT, PCREL(2, MAXTON, MAXIF),
     *   PCIMG(2,  MAXTON,MAXIF), PCRAT(2, MAXTON, MAXIF),
     *   STATE(2, 4, MAXIF)
      DOUBLE PRECISION TIME, CABLCL, PCFRQ(2, MAXTON, MAXIF), PCABLC
      INTEGER   PCKOLS(MAXPCC), PCNUMV(MAXPCC)
C
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DGLB.INC'
C-----------------------------------------------------------------------
      PCLUN = 30
      PCABLC = 0.0D0
      CALL PCINI ('READ', PCBUFF, DISKIN, OLDCNO, PCVER, CATBLK,
     *   PCLUN, IPCRNO, PCKOLS, PCNUMV, NOPOLZ, NOBAND, NTONES,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1090) PCVER
         GO TO 990
         END IF
      NUMPC = PCBUFF(5)
C                                       Initials for a new SN table
Cnew
C      DO 4 L = 1, 2
C         MBDELY(L) = 0.0
C         DO 2 I = 1, NNIF
C            IMAG(L, I) = 0.0
C            REAL(L,I) = 1.0
C            DELAY(L, I) = 0.0
C            RATE(L, I) = 0.0
C            WEIGHT(L, I) = 1.0
C            REFA(L, I) = REFANT
C    2       CONTINUE
C    4    CONTINUE
C                                       Read the data from PC table
      DO 100 IROW = 1, NUMPC
         CALL TABPC ('READ', PCBUFF, IPCRNO, PCKOLS, PCNUMV,
     *      NOPOLZ, TIME, TINT, ISRC, NOSTA, IARRAY, IFQID,
     *      CABLCL, STATE, PCFRQ, PCREL, PCIMG, PCRAT, IRET)
         IF (IRET.NE.0) THEN
            CALL TABERR ('READ', 'TABPC ', 'PCCAL ', IRET)
            GO TO 999
            END IF
         DO 20 IANT = 1, NANT
            IF (ANTNO(IANT).EQ.NOSTA) GO TO 25
   20       CONTINUE
         GO TO 100
   25    CONTINUE
         IF (CABLCL.EQ.DBLANK) THEN
            CABLCL = PCABLC
         ELSE
            PCABLC = CABLCL
            END IF
         LANT = IANT
C                                       Initials for a new SN table's
C                                       row
         DO 40 L = 1, 2
            MBDELY(L) = 0.0
            DISP(L) = 0.0
            DDISP(L) = 0.0
            DO 30 I = 1, NNNIF
               IMAG(L, I) = 0.0
               REAL(L,I) = 1.0
               DELAY(L, I) = 0.0
               RATE(L, I) = 0.0
               WEIGHT(L, I) = 1.0
               REFA(L, I) = REFANT
   30          CONTINUE
   40       CONTINUE
C                                       Length and central of time
C                                       interval for SN table
         CTIM = TIME
         TIMINT = TINT
C                                       do not correct SN table row
C                                       if there is no
C                                       data of PC table or calibrator
C                                       was not observed by the antenna
         IF ((NANPC(LANT).EQ.0) .OR. DATNO(LANT)) GO TO 90
C                                       correct the cable length
C                                       change
C                                       Switch off the cable correction?
         CABCOR = DCABL(LANT) - CABLCL
         IF (CABOFF.GT.0) CABCOR = 0.0

C                                       Select subarray, FREQID
         IF ((SUBA.NE.IARRAY) .AND. (SUBA.NE.0)) GO TO 100
         IF (FREQID.NE.IFQID) GO TO 100
         IFRM = 0.0
         MODENO = 0
         DO 80 JS = 1,NOPOLZ
            IND1 = JS + (LANT-1)*NPOLZN
            ADDEL = ADELY(IND1) + CABCOR
            IF (MDELC.EQ.0) MBDELY(JS) = ADDEL
            DO 75 JIF = 1, NNNIF
C                                       skip if IFs not selected
               IF ((JIF.LT.IBIF) .OR. (JIF.GT.IEIF)) GO TO 75
               IND0 = JS + (JIF-1)*NPOLZN +(LANT-1)*NPOLZN*NNNIF
C                                       check the tones are not blank
               REIM = (PCIMG(JS, TONE1(JIF),JIF).EQ.0.0 .AND.
     *            PCREL(JS, TONE1(JIF),JIF).EQ.0) .OR.
     *            (PCIMG(JS, TONE2(JIF),JIF).EQ.0.0 .AND.
     *            PCREL(JS, TONE2(JIF),JIF).EQ.0) .OR.
     *            PCIMG(JS, TONE1(JIF),JIF).EQ.FBLANK .OR.
     *            PCREL(JS, TONE1(JIF),JIF).EQ.FBLANK .OR.
     *            PCIMG(JS, TONE2(JIF),JIF).EQ.FBLANK .OR.
     *            PCREL(JS, TONE2(JIF),JIF).EQ.FBLANK
               FI = IFSID(JIF) * ATANG2(PCIMG(JS, TONE1(JIF),JIF),
     *            PCREL(JS, TONE1(JIF),JIF))
               DFI = IFSID(JIF) * ATANG2(PCIMG(JS, TONE2(JIF),JIF),
     *            PCREL(JS, TONE2(JIF),JIF)) - FI
C                                       blank if tones are zero
               IF (REIM) THEN
                  REAL(JS,JIF) = FBLANK
                  IMAG(JS,JIF) = FBLANK
                  DELAY(JS,JIF) = 0.0
                  GO TO 75
                  END IF
C
               IF (DFI.GT.PI) DFI = DFI - TWOPI
               IF (DFI.LE.-PI) DFI = DFI + TWOPI
               DELL = -DFI / DFREQ(JIF) / TWOPI
C                                       resolve ambiguaty in DELL
C                                       using DELAR found early in
C                                       PCCAL
               NTWOPI = IROUND((-DELAR(IND0) - DELL) * DFREQ(JIF))

               DELL = DELL + NTWOPI / DFREQ(JIF)
               IF(JIF.EQ.1) DELL1 = DELL
C               FIREF = - FI - TWOPI*
C     *            ((DELL - DELL1) * F1(JIF) -
C     *            ADDEL * (IFFREQ(JIF) - IFFREQ(1)))
C                                       IFFREQ(1) is  the reference
C                                       frequecy. So I recalculate to
C                                       the reference frequency
C                                       (that is good) not to the most
C                                       left one
               FIREF = - FI - TWOPI * ( (DELL + ADDEL) * F1(JIF) -
     *            ADDEL * (PCFRQ(1, TONE1(JIF), JIF)
C     *            -PCFRQ(1, TONE1(1), 1)))
     *            -PCFRQ(1, TONE1(IBIF), IBIF)))

C               FIREF = - FI - TWOPI * ( (DELL + ADDEL) * F1(JIF) -
C     *            ADDEL * (IFFREQ(JIF) - IFFREQ(1)))
               REAL(JS,JIF) = COS (FIREF)
               IMAG(JS,JIF) = SIN (FIREF)
               DELAY(JS,JIF) = DELL  + ADDEL
   75          CONTINUE
   80       CONTINUE
   90    CONTINUE
C                                       write SN table
         CALL TABSN ('WRIT', SNBUFF, ISNRNO, SNKOLS, SNNUMV, NPOLZN,
     *      CTIM, TIMINT, ISRC, NOSTA, IARRAY, FREQID, IFRM, MODENO,
     *      MBDELY, DISP, DDISP, REAL, IMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
  100    CONTINUE
C                                       Close SN table
      CALL TABIO ('CLOS', 0, ISNRNO, SNBUFF, SNBUFF, IRET)
C                                       Close PC table
      CALL TABIO ('CLOS', 0, IPCRNO, PCBUFF, PCBUFF, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1090 FORMAT ('PCTAG: ERROR in initialization of PC table ',I3)
      END

      SUBROUTINE ANTDAT (VER, DISKI, CNOIN, IERR)
C-----------------------------------------------------------------------
C   Selects station information
C   Inputs:
C      VER           I    Antenna array number (AN file ver.)
C      DISKI         I    Vol number
C      CNOIN         I    CNO
C   Outputs in common:
C      XA,YA,ZA(*)   D    Cartesian coordinates for stations in wavelengths.
C      STANAM(*)     C*8  Names of stations
C      NANT          I    Number of antennas
C      ANTNO(*)      I    Array of antennas' numbers
C-----------------------------------------------------------------------
      INTEGER   IERR, IA, LUNA, CNOIN, IABUF(512), VER,  DISKI
      REAL UT1XXX, IATUTC
      CHARACTER STNAME*8
      DOUBLE PRECISION  DX, DY, DZ, LAMBDA
      LOGICAL DOVLBI, DOATCA
      INCLUDE 'PCCOR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                     open antenna file
      LUNA = 28
      CALL ANTINI ('READ', IABUF, DISKI, CNOIN, VER, CATBLK, LUNA,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GST0, DEGPDY, AFREQ, RDATE,
     *   POLRXY, UT1XXX, IATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
      DX = ARRAYC(1)
      DY = ARRAYC(2)
      DZ = ARRAYC(3)
      NANT = IABUF(5)
      DOATCA = (ANAME.EQ.'ATCA') .OR. (ANAME.EQ.'ATLBA')
C                                       note this includes EVLA
      DOVLBI = (ABS(DX).LE.1000.0D0) .AND. (ABS (DY).LE.1000.0D0)
     *    .AND. (ABS (DZ).LE.1000.0D0) .AND. (.NOT.DOATCA)
      LAMBDA = 299792.D3/AFREQ
C                                     Get antenna info.
      DO 30 IA = 1,NANT
         IANRNO = IA
         CALL TABAN ('READ', IABUF, IANRNO, ANKOLS, ANNUMV, STNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IA, IERR
            CALL MSGWRT (8)
            END IF
         XA(NOSTA) = (STAXYZ(1) + DX)/LAMBDA
         IF (DOVLBI) THEN
            YA(NOSTA) = (STAXYZ(2) + DY)/LAMBDA
         ELSE
            YA(NOSTA) = -(STAXYZ(2) + DY)/LAMBDA
            END IF
         ZA(NOSTA) = (STAXYZ(3) + DZ)/LAMBDA
         STANAM(NOSTA) = STNAME
         ANTNO(IA) = NOSTA
 30      CONTINUE
C                                     close antenna file
      CALL TABIO ('CLOS', 1, IANRNO, IABUF, IABUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ANTDAT: ERROR IN OPEN AN-FILE IERR = ',I6)
 1010 FORMAT ('ANTDAT: ERROR IN FINDING STATION',I3,' IERR=',I3)
 1030 FORMAT ('ANTDAT: ERROR IN CLOSING AN-FILE IERR = ',I6)
      END
      SUBROUTINE PCCHIS
C-----------------------------------------------------------------------
C   PCCHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER CTIME(2)*12,  HILINE*72, LABEL*8
      INTEGER   LUN, IERR, TIM(3), DATE(3), I
      LOGICAL   T
      INCLUDE 'PCCOR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN, DISKIN, FCNO(NCFILE), SNBUFF, IERR)
      IF (IERR.NE.0) GO TO 200
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIM)
      CALL TIMDAT (TIM, DATE, CTIME(2)(1:8), CTIME)
      WRITE (HILINE,1010) TSKNAM, RLSNAM, CTIME
      CALL HIADD (LUN, HILINE, SNBUFF, IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any other history.
      IF (NUMHIS.LE.0) GO TO 200
         WRITE (LABEL,1020) TSKNAM
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN, HILINE, SNBUFF, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
C                                       Close HI file
 200   CALL HICLOS (LUN, T, SNBUFF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PCCHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6, 'RELEASE =''',A7,' ''  /********* Start ',
     *   A12, 2X, A8)
 1020 FORMAT (A6)
 1200 FORMAT ('PCCHIS: ERROR COPYING TABLES')
      END
      SUBROUTINE AFRF (DATA, NNN, XARR, DXARM, AMPP, RATE, FI, DDAMP,
     *   DDRATE, DDFI, IERR)
C-----------------------------------------------------------------------
C   Estimates the values of frequency, initial phase and amplitude of
C   a complex exponent given (with noise) in the data set.
C   The DATA are determined on non aquidistant array XARR
C   (XARR(I) > XARR(I-1)) and can be approximated BY:
C   DATA(I) = A * EXP (J*TWOPI*RATE*(XARR(I)-XARR(1)) + FI)
C   where   RATE is unknown rate of phase change;
C           FI   is unknown phase at the first data point;
C           A    is unknown amplitude.
C   A two step process is used. The first is an Fourie analisys with step
C   1/XARR(N) at the range +- 1/DXARM;
C   The final solution of the amplitude, frequency and phase is found by
C   least square method.
C-----------------------------------------------------------------------
C   Programmer  L.R. Kogan
C-----------------------------------------------------------------------
C   Inputs:
C      DATA     R(2*NNN) input array of data
C      NNN        I      Number of complex points in the DATA
C      XARR     R(NNN)   array of argument of input data
C      DXARM    R        Element of space of input data
C   Outputs
C      AMPP     found amplitude
C      RATE     found frequency in parts of window. -0.5<RATE<0.5
C               Dimensional RATE can be obtained having devided
C               RATE by period of samples in data.
C      FI       found phase of the most left point of the data, in radian
C      DDAMP    rms of amplitude
C      DDRATE   rms of frequency
C      DDFI     rms of phase
C      IERR     error
C-----------------------------------------------------------------------
C
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      INTEGER   NNN, I, LESOL, IK, K, ITER, IERR, L, LL, LF
      REAL DATA(*), RATE, FI, AMPP, TAMP, R(3), MATR(9), NOBS, SUM, SSQ,
     *   SOL(3),VX(3), SSQRES, VARRES, VARY, FIT,DRE, DIM, ARG,
     *   SINK, COSK, DDAMP, DDRATE,DDFI, XARR(*), RE, IM, DXARR,
     *   DXARM, FSTEP, FE, ATANG2
      IERR = 0
      IF (NNN.GT.1024)  THEN
         IERR = 1
         WRITE (MSGTXT,1000) NNN
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Fourie analisys
      FSTEP = 0.5/XARR(NNN)
      L = (1.0 / DXARM) / FSTEP
      LL = 2*L + 1
C                                       find max of amplitude
      AMPP = 0.0
      DO 50 LF = 1, LL
         FE = (LF - L -1) * FSTEP
         RE = 0.0
         IM = 0.0
         DO 40 I = 1, NNN
            ARG = TWOPI*FE*(XARR(I) - XARR(1))
            RE = RE + DATA(2*I-1)*COS(ARG) + DATA(2*I)*SIN(ARG)
            IM = IM - DATA(2*I-1)*SIN(ARG) + DATA(2*I)*COS(ARG)
   40       CONTINUE
         TAMP = RE * RE + IM * IM
C                                       find max of amplitude
         IF (TAMP.GE.AMPP) THEN
            AMPP = TAMP
            RATE = FE
            FI = ATANG2 (IM, RE)
            END IF
   50    CONTINUE
      AMPP = SQRT(AMPP) / NNN
C --------------------------------------------------------------------
C                   L E A S T    S Q U A R E
C
C        precise AMP, RATE and FI using non linear least square
C              fitting a  complex exponent to the given data.
C                We have NNN2 = 2*NNN points of data
C             (real and image for each point of data)
C         We have 3 unknown magnitudes: ampl., rate and phase
C --------------------------------------------------------------------
      ITER = 1
  100 CONTINUE
C                                       Force result vector R(3),
C                                       matrix M(3*3) to zero
      DO 120 I = 1, 3
         R(I) = 0.0
         DO 110 K = 1, 3
            IK = K + (I - 1)*3
            MATR (IK) = 0.0
 110        CONTINUE
 120     CONTINUE
      SUM = 0.0
      SSQ = 0.0
      NOBS = 0.0
C                                       Prepare result vector R(3)
C                                       and matrix MATR(3*3)
C                                       for routine LEASQR

      DO 140 I = 1, NNN
         DXARR = TWOPI * (XARR(I) - XARR(1))
C                                       take only the points.NE.0
         IF ((DATA(2*I-1).EQ.0.0) .AND.
     *      (DATA(2*I).EQ.0.0)) GOTO 140
         NOBS = NOBS + 1
         DRE = DATA (2*I -1)
         DIM = DATA (2*I)
C                                       difference of DATA and model
         ARG = DXARR * RATE + FI
         SINK = SIN(ARG)
         COSK = COS(ARG)
         DRE = DRE - AMPP * COSK
         DIM = DIM - AMPP * SINK
         SUM = SUM + DRE + DIM
         SSQ = SSQ + DRE*DRE + DIM*DIM
C
C                                       1-ampl; 2-rate; 3-fi.
         R(1) =  R(1) + DRE * COSK
     *      + DIM * SINK
         R(2) =  R(2) - DRE * AMPP * SINK * DXARR
     *      + DIM * AMPP * COSK * DXARR
         R(3) =  R(3) - DRE * AMPP*SINK
     *      + DIM * AMPP*COSK
C                                       calculate upper/right
C                                       triangle of MATR
         MATR(1) = MATR(1) + COSK*COSK + SINK*SINK
C         MATR(2) = MATR(2) - COSK*AMPP*SINK*DXARR
C     *      + SINK*AMPP*COSK*DXARR
C         MATR(3) = MATR(3) - COSK*AMPP*SINK + SINK*AMPP*COSK
         MATR(4) = MATR(4) - AMPP*SINK*DXARR*COSK
     *      + AMPP*COSK*DXARR*SINK
         MATR(5) = MATR(5) + AMPP*SINK*DXARR*AMPP*SINK*DXARR
     *      + AMPP*COSK*DXARR*AMPP*COSK*DXARR
C         MATR(6) = MATR(6) + AMPP*SINK*DXARR*AMPP*SINK
C     *      + AMPP*COSK*DXARR*AMPP*COSK
         MATR(7) = MATR(7) - AMPP*SINK*COSK + AMPP*COSK*SINK
         MATR(8) = MATR(8) + AMPP*SINK*AMPP*SINK*DXARR
     *      + AMPP*COSK*AMPP*COSK*DXARR
         MATR(9) = MATR(9) + AMPP*SINK*AMPP*SINK
     *      + AMPP*COSK*AMPP*COSK
 140     CONTINUE
      NOBS = 2*NOBS
C                                       NOBS need to be real for LEASQR
      CALL LEASQR (3, NOBS, SUM, SSQ, R, MATR, SOL, VX, SSQRES,
     *   VARRES, VARY, FIT, LESOL)
C                                       find the solution
      AMPP = AMPP + SOL(1)
      RATE = RATE + SOL(2)
      FI = FI + SOL(3)
      ITER = ITER + 1
      IF (ITER.LE.2) GO TO 100
      DDAMP = SQRT (VX(1))
      DDRATE = SQRT (VX(2))
      DDFI = SQRT (VX(3))
C-----------------------------------------------------------------------
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('AFRFI: The number of points ',I6,' is more MAX=1024')
      END
      REAL FUNCTION ATANG2 (Y, X)
C-----------------------------------------------------------------------
C! Calculate ATAN2(Y,X) considering ATAT2(0, 0) = 0
C# UV-util
C-----------------------------------------------------------------------
C   Inputs:
C      Y, X    R       Y, X arguments of ATAN
C-----------------------------------------------------------------------
      REAL    X, Y
C-----------------------------------------------------------------------
      IF (X.EQ.0.0  .AND.  Y.EQ.0.0) THEN
         ATANG2 = 0.0
      ELSE
         ATANG2 = ATAN2(Y, X)
         END IF
C
 999  RETURN
      END

      SUBROUTINE MAKGAU (OUT, IERR)
C-----------------------------------------------------------------------
C! Tim Cornwell routine: Make a Gaussian convolution function.
C# IO-appl Math Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   MAKGAU make a Gaussian convolution function
C   Programmer =  T.J. Cornwell      December 1987
C-----------------------------------------------------------------------
      INTEGER   OUT, JLIM
      REAL      RFACT, U, V, R, RMAX, COSPA, SINPA, RNORM, DEGRAD, DU,
     *   DV
      INTEGER   AKOPEN, AKCESS, AKCLOS
      INTEGER   IU, IV
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA DEGRAD /57.29577951/
C-----------------------------------------------------------------------
      IERR = 0
C
      RMAX = 30.0
      COSPA = COS ((BPA+90.0)/DEGRAD)
      SINPA = SIN ((BPA+90.0)/DEGRAD)
      RFACT = 4.0*(ATAN (1.0))**2/LOG (2.0)
      DU = 1.0 / (CELLX * FLOAT(NX))
      DV = 1.0 / (CELLY * FLOAT(NY))
      RNORM = 1.1331 * BMAJ * BMIN * ABS (DU) * ABS(DV)
C                                       Open file
      IF (AKOPEN (OUT, 1, 'WRIT', BUFFR1).NE.0) GO TO 990
C                                       Begin loop thru map.
      JLIM = NX / 2 + 1
      DO 125 IU = 1,JLIM
         IF (AKCESS (OUT, BUFFR1).NE.0) GO TO 990
         I1 = BIND(1)
      INCLUDE 'INCS:ZVND.INC'
         DO 120 IV = 1,NY/2
            U = DU * COSPA * REAL (IU-1) - DV * SINPA * REAL (IV-1)
            V = DU * SINPA * REAL (IU-1) + DV * COSPA * REAL (IV-1)
            R = RFACT * ((BMAJ*U)**2 + (BMIN*V)**2)
            IF (R.GT.RMAX) THEN
               BUFFR1(I1) = 0.0
            ELSE
               BUFFR1(I1)   = RNORM * EXP (-R)
               END IF
            BUFFR1(I1+1) = 0.0
            I1 = I1 + 2
 120        CONTINUE
      INCLUDE 'INCS:ZVND.INC'
         DO 121 IV = NY/2+1, NY
            U = DU * COSPA * REAL (IU-1) - DV * SINPA * REAL (IV-NY)
            V = DU * SINPA * REAL (IU-1) + DV * COSPA * REAL (IV-NY)
            R = RFACT * ((BMAJ*U)**2 + (BMIN*V)**2)
            IF (R.GT.RMAX) THEN
               BUFFR1(I1) = 0.0
            ELSE
               BUFFR1(I1)   = RNORM * EXP (-R)
               END IF
            BUFFR1(I1+1) = 0.0
            I1 = I1 + 2
 121        CONTINUE
 125     CONTINUE
      IF (AKCLOS (OUT, BUFFR1).NE.0) GO TO 990
C
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1010)
      CALL MSGWRT (8)
      IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('MAKGAU')
      END

      SUBROUTINE ZPATH (LLEN, LOGFIL, FLEN, FULNAM, FACT, IERR)
C-----------------------------------------------------------------------
C! convert a file name 'Logical:file' to full path name
C# Z2 IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2002, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Translate a file specification of the form "logical:file" to a
C   full path name.  "/..." absolute path name is also allowed.
C   Inputs:
C      LLEN     I          Length of "logfil" (1-relative)
C      LOGFIL   H*(*)      File specification (may contain a valid,
C                          colon terminated logicalvariable)
C      FLEN     I          Length of "fulnam" (1-relative)
C   Output:
C      FULNAM   H*(flen)   Full path name (blank filled)
C      FACT     I          Position of last non-blank in "fulnam"
C                          (1-relative)
C      IERR     I          Error return code: 0 => no error
C                              1 => improper combination of inputs
C                              2 => no translation for "logical"
C                              3 => "fulnam" too short
C                              4 => logical name required
C   Generic version  - stub
C-----------------------------------------------------------------------
      INTEGER   LLEN, FLEN, FACT, IERR
      HOLLERITH LOGFIL(*), FULNAM(*)
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 1
      MSGTXT = 'ZPATH REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (9)
      CALL CHR2H (FLEN, MSGTXT, 1, FULNAM)
C
 999  RETURN
      END

      SUBROUTINE REWAIT (LWT, WT)
C-----------------------------------------------------------------------
C! alters data weight by specified function
C# Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Alters data weights.
C   Inputs:
C      LWT   I   1 - sqrt
C                2 - wt**0.25
C                3 - 1.0
C   In/out:
C      WT    R   Data weight changed if > 0.
C-----------------------------------------------------------------------
      INTEGER   LWT
      REAL      WT
C
C-----------------------------------------------------------------------
      IF (WT.GT.0.0) THEN
         IF (LWT.EQ.1) THEN
            WT = SQRT (WT)
         ELSE IF (LWT.EQ.2) THEN
            WT = WT ** 0.25
         ELSE IF (LWT.EQ.3) THEN
            WT = 1.0
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE YISDSC (OP, CYLNDR, GOADDR, IERR)
C-----------------------------------------------------------------------
C! read/write micro-processor memory of NRAO-ISU device
C# Y3 TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YISMPM is a special Y routine for the NRAO Image Storage Unit -
C   a device interposed between the host CPU and the IIS Model 70 TV.
C   YISMPM reads or writes the micro processor memory.
C   Inputs:
C      OP      C*4     'READ", 'WRIT' disc to data memory
C      CYLNDR  I       Cylinder on disc
C      GOADDR  I       Microprocessor address to branch on completion
C   Output:
C      IERR    I       Error code of Z...XF: 0 okay, 2 input error
C   NO TV ISU VERSION - stub.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   CYLNDR, GOADDR, IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'THERE IS NO TV IMAGE STORAGE UNIT CONFIGURED'
      CALL MSGWRT (8)
C
 999  RETURN
      END

      SUBROUTINE QINTG (UV, MOD, PHAS, GRID, INTP, M, LROW, INC, NMOD,
     *   ROW)
C-----------------------------------------------------------------------
C! Convex Pseudo AP routine: Interpolate model visibilities from a grid.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Vector complier version
C   Will be slower on scalar machines than the scalar version.
C   QINTG Interpolates model visibilities from a grid,
C   corrects the phase and returns the value in the array
C   pointer to by MOD.
C   Assumes that the observations are never within M/2
C   of the outside edge of the grid.  Assumes that the interpolation
C   function is never more than 32x16 (total of 512 elements).
C   Inputs:
C      UV    I  Base address of (u,v) values in cells.
C      MOD   I  Base address for resultant model. (increment=4)
C      PHAS  I  Phase correction, complex value to be multiplied by
C               model vis. Increment = 4.
C      GRID  I  GRID = base address of gridded model vis.
C               Order assumed to be the  following  for each of the
C               M rows:
C                  1) 2 * LROW visibilities
C      INTP  I  base address of interpolation function.
C      M     I  number of rows kept in the AP. Also support size of
C               interp. fn
C      LROW  I  length of a row.
C      INC   I  increment for UV.
C      NMOD  I  number of model values to compute.
C      ROW   I  Address of lowest central row number.
C   All AP memory values are assumed floating.
C   It is assumed that all values of v correspond to row M/2.
C-----------------------------------------------------------------------
      INTEGER   UV, MOD, PHAS, GRID, INTP, M, LROW, INC, NMOD, ROW,
     *   INCR, HAF, IRND, IX, IY, LOOP, LIMIT
      INTEGER   JUV, JMOD, JPHAS, JGRID, JINTP, JCX, JCY,
     *   JG, JJLOOP, JNO2, JN, ICX, ICY, IG
      INTEGER   INCX(121), INCY(121), INCG(121), OLDM, OLDLRO
      REAL      X, XX, Y, SUMRE, SUMIM, WT, REMOD, IMMOD
      INCLUDE 'INCS:DAPC.INC'
      SAVE OLDM, OLDLRO, INCX, INCY, INCG
C-----------------------------------------------------------------------
      IRND(XX) = INT (XX + SIGN (0.5, XX))
      IF (NMOD.LE.0) GO TO 999
C                                       Get 1 rel. locations
      JUV = UV + 1
      JMOD = MOD + 1
      JPHAS = PHAS + 1
      JGRID = GRID + 1
      JINTP = INTP + 1
      JNO2 = M / 2
      JN = M
      HAF = LROW / 2 - JNO2
      INCR = 2 * LROW
      LIMIT = M * JN
      IF ((OLDM.EQ.M) .AND. (OLDLRO.EQ.LROW)) GO TO 70
C                                       Fill increment tables
      OLDM = M
      OLDLRO = LROW
      DO 50 LOOP = 1,LIMIT
         IY = (LOOP-1) / JN
         IX = (LOOP-1) - IY * JN
         INCX(LOOP) = IX * 200
         INCY(LOOP) = IY * 200
         INCG(LOOP) = IX * 2 + IY * INCR
 50      CONTINUE
C                                       Loop over visibilities.
 70   DO 300 JJLOOP = 1,NMOD
C                                        Determine location.
         X = APCORE(JUV+1)
         Y = APCORE(JUV)
C                                        Deter. interp. fn loc.
         JCX = IRND (200. * (IRND (X) - X - 0.5))
         JCY = IRND (200. * (IRND (Y) - Y - 0.5))
         JCX = JINTP + 200 + JCX
         JCY = JINTP + 200 + JCY
C                                        Determine grid loc.
         Y = Y - ROW
         JG = IRND (X) + IRND (Y) * LROW
         JG = JGRID + 2 * (JG + HAF)
C                                        Init. sums.
         SUMRE = 0.0
         SUMIM = 0.0
C                                       Unroll inter loop with gather.
C                                       Set pointer arrays for gather.
         DO 100 LOOP = 1,LIMIT
            ICX = JCX + INCX(LOOP)
            ICY = JCY + INCY(LOOP)
            IG = JG + INCG(LOOP)
C                                        Interpolation
            WT = APCORE(ICX) * APCORE(ICY)
            SUMRE = SUMRE + APCORE(IG) * WT
            SUMIM = SUMIM + APCORE(IG+1) * WT
 100        CONTINUE
C                                        Correct phase.
         REMOD = APCORE(JPHAS) * SUMRE - APCORE(JPHAS+1) * SUMIM
         IMMOD = APCORE(JPHAS) * SUMIM + APCORE(JPHAS+1) * SUMRE
         APCORE(JMOD) = REMOD
         APCORE(JMOD+1) = IMMOD
C                                       Update for next model.
         JUV = JUV + INC
         JMOD = JMOD + 4
         JPHAS = JPHAS + 4
 300     CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'ALVPR.INC'
C                                       Local include for ALVPR
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4,30), XCALC(1), XXSTOK(1),
     *   XLPNAM(12)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XSUBA, XBIF, XEIF, XBCHAN, XECHAN, XDOCAL, XGUSE, XDOPOL,
     *   XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH(3), XDOAC,
     *   SOLINT, DOCRT, BADD(10),
     *   SCRBUF(256), BUFF(UVBFSS), TLAST
      INTEGER   SEQIN, DISKIN, JBUFSZ, ILOCWT, CATOLD(256), INCSI,
     *   INCFI, INCIFI, NRPRMI, OLDCNO, NSTK, NIF, NFREQ, NBASL, CTIME,
     *   NTIMES
      CHARACTER NAMEIN*12, CLAIN*6, LPNAME*48
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XXSTOK, XTIME, XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF, XBCHAN,
     *   XECHAN, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND,
     *   XBPVER, XSMOTH, XDOAC, SOLINT, DOCRT, XLPNAM, BADD
      COMMON /ALVPRM/ CATOLD, SEQIN, DISKIN, ILOCWT, INCSI, INCFI,
     *   INCIFI, NRPRMI, OLDCNO, NSTK, NIF, NFREQ, NBASL, TLAST, CTIME,
     *   NTIMES
      COMMON /CHARPM/ NAMEIN, CLAIN, LPNAME
      COMMON /BUFRS/ SCRBUF, BUFF, JBUFSZ
C                                       End local include for ALVPR
LOCAL END
      PROGRAM ALVPR
C-----------------------------------------------------------------------
C! Allan-variance of a UV data set
C# Utility UV
C-----------------------------------------------------------------------
C;  Copyright (C) 2013, 2015-2016, 2018, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ALVPR pre-averages data to SOLINT seconds and computes the Allan
C   variance of the data, printing statistics of that variance at the
C   end.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C   full set of calibration adverbs
C      SOLINT         SOLINT        pre-average time in Sec (-> days)
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET, NWORDS
      REAL      SUMS(2), VALS(2), ANSW(2)
      LONGINT   PSUMS, PVALS, PANSW
      INCLUDE 'ALVPR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'ALVPR '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL ALVPRI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       count times
      MSGTXT = 'Count the number of SOLINTs in the data'
      CALL MSGWRT (2)
      NTIMES = 0
      CALL ALVPRC (IRET)
      IF (IRET.NE.0) GO TO 999
      NTIMES = NTIMES + 10
C                                       get memory
      NBASL = (NSTNS * (NSTNS+1)) / 2
      NWORDS = (3 * NSTK * NIF * NBASL - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, SUMS, PSUMS, IRET)
      NWORDS = (3 * NSTK * NIF * NBASL * NTIMES - 1) / 1024 + 2
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, VALS, PVALS,
     *   IRET)
      NWORDS = (4 * NTIMES - 1) / 1024 + 10
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, ANSW, PANSW,
     *   IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'CANNOT GET NEEDED MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       Sum up data, make big array
      MSGTXT = 'Sum up the data into big arrays'
      CALL MSGWRT (2)
      CALL ALVPRU (NSTK, NIF, NBASL, SUMS(1+PSUMS), VALS(1+PVALS),
     *   IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Display big array
      CALL ALVPCH (NSTK, NIF, NBASL, IRET)
      IF (IRET.NE.0) GO TO 990
      MSGTXT = 'Now find Allan variance and display'
      CALL MSGWRT (2)
      CALL ALVPRP (NSTK, NIF, NBASL, VALS(1+PVALS), ANSW(1+PANSW), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Close down files, etc.
 990  IRET = MAX (0, IRET)
      CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE ALVPRI (PRGN, JERR)
C-----------------------------------------------------------------------
C   ALVPRI gets input parameters for ALVPR
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in ALVPR for more details.
C
C   To change the adverb list sent to this task change:
C   1)  the inputs file.
C   2)  the contents of COMMON /INPARM/.  Remember all adverbs are sent
C       as R, INNAME etc. are 12 char. 3 words;
C       INCLASS etc. are 6 char., 2 words.
C       Values will be filled into COMMON /INPARM/ in the order
C       specified in the inputs file.
C   3)  If the first adverb is not INNAME (NAMEIN) then replace
C       NAMEIN in the call to GTPARM with the name of the first
C       adverb.
C   4)  Change the value of NPARM sent to GTPARM to the number of
C       R words desired.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, LUN
      LOGICAL   MATCH
      REAL      CATR(256), RPARM(20)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'ALVPR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 182
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      CALL H2CHR (48, 1, XLPNAM, LPNAME)
      IF ((IERR.NE.0) .OR. (NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000))
     *   DOCRT = MIN (-1.0, DOCRT)
      RQUICK = (RQUICK) .AND. (DOCRT.LE.0.0)
      IF (RQUICK) RQUICK = LPNAME.NE.' '
      IF (RQUICK) CALL RELPOP (JERR, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (4, 1, XXSTOK, STOKES)
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = XDOAC.GT.0.0
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NFREQ = CATBLK(KINAX+JLOCF)
      BCHAN = IROUND (XBCHAN)
      ECHAN = IROUND (XECHAN)
      IF ((BCHAN.LE.0) .OR. (BCHAN.GT.NFREQ)) BCHAN = 1
      IF ((ECHAN.LE.0) .OR. (ECHAN.GT.NFREQ)) ECHAN = NFREQ
      IF (BCHAN.GT.ECHAN) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, SCRBUF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, SCRBUF, IERR)
C                                       Save input file info
      NSTK = 1
      NFREQ = 1
      NIF = 1
      IF (JLOCS.GE.0) NSTK = CATBLK(KINAX+JLOCS)
      IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
      IF (JLOCF.GE.0) NFREQ = CATBLK(KINAX+JLOCF)
      INCX = CATBLK(KINAX)
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', SCRBUF, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       get antenna info
      CALL COPY (256, CATOLD, CATBLK)
      CALL GETANT (DISKIN, OLDCNO, SUBARR, CATBLK, SCRBUF, IERR)
      IF (SOLINT.LE.0.0) SOLINT = 9.95
      SOLINT = SOLINT / (24.0 * 3600.0)
      JERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ALVPRI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE ALVPRC (IRET)
C-----------------------------------------------------------------------
C   ALVPRC counts time intervals
C   Output:
C      IRET   I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'ALVPR.INC'
      INTEGER   NUMVIS, XCOUNT, CATMP(256)
      REAL      T, VIS(UVBFSS), RPARM(20)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
C                                       defend cat header from UVGET
      CALL COPY (256, CATBLK, CATMP)
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL COPY (256, CATMP, CATBLK)
      NUMVIS = 0
      XCOUNT = 0
C                                       buffer pointers
      TLAST = -1.E6
      CTIME = 0
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over buffer
      ELSE IF (IRET.EQ.0) THEN
         T = RPARM(1+ILOCT)
         IF (T.GT.TLAST) THEN
            IF (TLAST.GT.0.0) NTIMES = NTIMES + 1
            TLAST = T + SOLINT
            END IF
         GO TO 100
         END IF
C                                       Close file
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ALVPRC: ERROR',I3,' OPEN/INIT INPUT VIS FILE')
 1100 FORMAT ('ALVPRC: ERROR',I3,' READING VIS FILE')
      END
      SUBROUTINE ALVPRU (NS, NI, NB, SUMS, VALS, IRET)
C-----------------------------------------------------------------------
C   ALVPRU sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input
C      NS     I      Number stokes
C      NI     I      Number IFs
C      NB     I      Number baselines
C   Output:
C      SUMS   R(*)   Summing variables
C      VALS   R(*)   Time sequence of real and imaginary averages
C      IRET   I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NS, NI, NB, IRET
      REAL      SUMS(3,NS,NI,*), VALS(3,NS,NI,NB,*)
C
      INCLUDE 'ALVPR.INC'
      INTEGER   IA1, IA2, NUMVIS, XCOUNT, CATMP(256)
      REAL      DUM, BASEN, VIS(UVBFSS), RPARM(20)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
C-----------------------------------------------------------------------
C                                       defend cat header from UVGET
      CALL COPY (256, CATBLK, CATMP)
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL COPY (256, CATMP, CATBLK)
      NUMVIS = 0
      XCOUNT = 0
C                                       buffer pointers
      TLAST = -1.E6
      CTIME = 0
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over buffer
      ELSE IF (IRET.EQ.0) THEN
         IF (ILOCB.GE.0) THEN
            BASEN = RPARM(1+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
            END IF
         NUMVIS = NUMVIS + 1
C                                       call user routine
         CALL DIDDLE (NUMVIS, RPARM(1+ILOCT), IA1, IA2, VIS, NS, NI, NB,
     *      SUMS, VALS)
         GO TO 100
         END IF
C                                       last average
      NUMVIS = -1
      CALL DIDDLE (NUMVIS, DUM, IA1, IA2, SCRBUF, NS, NI, NB, SUMS,
     *   VALS)
C                                       Close file
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ALVPRU: ERROR',I3,' OPEN/INIT INPUT VIS FILE')
 1100 FORMAT ('ALVPRU: ERROR',I3,' READING VIS FILE')
      END
      SUBROUTINE DIDDLE (NUMVIS, T, IA1, IA2, VIS, NS, NI, NB, SUMS,
     *   VALS)
C-----------------------------------------------------------------------
C
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      T       R    Time in days since 0 IAT on the first day for
C                   which there is data, the julian day corresponding
C                   to this day can be obtained in D   form by:
C                   CALL JULDAY (CATH(KHDOB),XDAY) where XDAY will
C                   be the Julian day number.
C      IA1     I    First antenna number
C      IA2     I    Second antenna number
C      VIS     R(3,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C      NS     I      Number stokes
C      NI     I      Number IFs
C      NB     I      Number baselines
C   In/Output:
C      SUMS   R(*)   Summing variables
C      VALS   R(*)   Time sequence of real and imaginary averages
C   Inputs from COMMON:
C      NRPARM     I       # random parameters.
C      NCOR       I       # correlators
C      CATBLK     I(256)  Catalog header record. See Going Aips for
C                         details.
C      NRPRMI     I    Input number of random parameters.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
C   Output:
C      T          R    Time in same units as input.
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IA1, IA2, NS, NI, NB, IRET
      REAL      T, VIS(3,*), SUMS(3,NS,NI,*), VALS(3,NS,NI,NB,*)
C
      INTEGER   JI, JF, JS, JB, INDEXI, INDI
      REAL      VR, VI, VW
      INCLUDE 'ALVPR.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.LT.0) T = 1.E6
C                                       new integration
      IF (T.GT.TLAST) THEN
C                                       average this lot
         IF (TLAST.GT.0.0) THEN
            CTIME = CTIME + 1
            DO 40 JB = 1,NB
               DO 30 JI = 1,NI
                  DO 20 JS = 1,NS
                     VW = SUMS(3,JS,JI,JB)
                     IF ((VW.GT.0.0) .AND. (VW.NE.FBLANK)) THEN
                        VALS(1,JS,JI,JB,CTIME) = SUMS(1,JS,JI,JB)/VW
                        VALS(2,JS,JI,JB,CTIME) = SUMS(2,JS,JI,JB)/VW
                        VALS(3,JS,JI,JB,CTIME) = VW
                     ELSE
                        VALS(1,JS,JI,JB,CTIME) = FBLANK
                        VALS(2,JS,JI,JB,CTIME) = FBLANK
                        VALS(3,JS,JI,JB,CTIME) = FBLANK
                        END IF
 20                  CONTINUE
 30               CONTINUE
 40            CONTINUE
            END IF
         JF = 3 * NS * NI * NB
         CALL RFILL (JF, 0.0, SUMS)
         TLAST = T + SOLINT
         END IF
C                                       time average
      IF (NUMVIS.GT.0) THEN
         JB = ((IA1-1)*NSTNS) - (((IA1-1)*IA1)/2) + IA2
         DO 130 JI = 1,NI
            DO 120 JS = 1,NS
               INDI = (JI-1) * INCIFI + (JS-1) * INCSI + 1
               VR = 0.0
               VI = 0.0
               VW = 0.0
               INDEXI = INDI
C                                       average over frequency
               DO 110 JF = 1,NFREQ
                  IF (VIS(3,INDEXI).GT.0.0) THEN
                     VR = VR + VIS(1,INDEXI) * VIS(3,INDEXI)
                     VI = VI + VIS(2,INDEXI) * VIS(3,INDEXI)
                     VW = VW + VIS(3,INDEXI)
                     END IF
                  INDEXI = INDEXI + INCFI
 110              CONTINUE
               SUMS(1,JS,JI,JB) = SUMS(1,JS,JI,JB) + VR
               SUMS(2,JS,JI,JB) = SUMS(2,JS,JI,JB) + VI
               SUMS(3,JS,JI,JB) = SUMS(3,JS,JI,JB) + VW
 120           CONTINUE
 130        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE ALVPCH (NS, NI, NB, IRET)
C-----------------------------------------------------------------------
C   ALVPCH checks the printer line count
C   Input
C      NS     I      Number stokes
C      NI     I      Number IFs
C      NB     I      Number baselines
C   Output:
C      IRET   I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NS, NI, NB, IRET
C
      INCLUDE 'ALVPR.INC'
      CHARACTER CTEMP*4, SCRTCH*132
      INTEGER   NCOUNT, TTY(2), I
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       do we need to do this
      IRET = 0
      IF ((DOCRT.GT.0.0) .OR. (LPNAME.NE.' ')) GO TO 999
      MSGTXT = 'Checking count of lines for direct output to printer'
      CALL MSGWRT (2)
      NCOUNT = 0
C                                       header
      IF (DOCRT.GT.-2.5) NCOUNT = NCOUNT + 4
      IF (DOCRT.GT.-1.5) NCOUNT = NCOUNT + 1
C                                       over baselines
      NCOUNT = NCOUNT + NB * NI * NS
C                                       ask if needed
      IF ((NPOPS.GT.NINTRN) .OR. (ISBTCH.EQ.32000)) THEN
         IF (NCOUNT.GT.1000) IRET = -1
      ELSE IF (NCOUNT.GT.500) THEN
         TTY(1) = 5
         CALL ZOPEN (TTY(1), TTY(2), 1, SCRTCH, .FALSE., .FALSE.,
     *      .TRUE., IRET)
         MSGTXT = 'PROBLEM OPENING TERMINAL'
         IF (IRET.GT.0) GO TO 990
         WRITE (SCRTCH,1000) NCOUNT
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, IRET)
         MSGTXT = 'PROBLEM DOING IO TO TERMINAL'
         IF (IRET.GT.0) GO TO 990
         SCRTCH = 'Do you really want to print this much??' //
     *      ' Enter Y or y if so'
         CALL INQSTR (TTY, SCRTCH, 1, CTEMP, IRET)
         IF (IRET.GT.0) GO TO 990
         IF ((CTEMP(:1).NE.'y') .AND. (CTEMP(:1).NE.'Y')) THEN
            IRET = -1
            SCRTCH = 'Good choice - save trees'
         ELSE
            SCRTCH = 'OKAY, printing anyway'
            END IF
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, SCRTCH, I)
         CALL ZCLOSE (TTY(1), TTY(2), I)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Requested print job is',I10,' lines long!')
      END
      SUBROUTINE ALVPRP (NS, NI, NB, VALS, ANSW, IRET)
C-----------------------------------------------------------------------
C   ALVPRU sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input
C      NS     I      Number stokes
C      NI     I      Number IFs
C      NB     I      Number baselines
C   Output:
C      VALS   R(*)   Time sequence of real and imaginary averages
C      IRET   I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   NS, NI, NB, IRET
      REAL      VALS(3,NS,NI,NB,*), ANSW(4,*)
C
      INTEGER   NITER
      PARAMETER (NITER = 8)
C
      INCLUDE 'ALVPR.INC'
      CHARACTER TITL1*132, TITL2*132, LINE*132, SCRTCH*132
      INTEGER   LUNP, FINDP, NACROS, IA1, IA2, JB, JI, JS, JT, NG, JP,
     *   PAGE, IPCNT, IT
      REAL      TR1, TI1, TR2, TI2, TR3, TI3, TA1, TA2, TA3, SR, SI,
     *   RAW(2,4), ROB(2,4), WS(NITER), VP, VM, P1, P2, P3
      DOUBLE PRECISION S1, S2, S3, S4, Q1, Q2, Q3, Q4, NSQ, SV, SSV, NV
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA WS /5.0, 4.0, 3.5, 3.0, 2.7, 2.6, 2.5, 3.5/
C-----------------------------------------------------------------------
C                                       Open output device
      IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
      CALL LPOPEN (LPNAME, DOCRT, LUNP, FINDP, NACROS, BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING LINE PRINTER'
         GO TO 990
         END IF
C                                       header
      PAGE = 0
      IPCNT = 998
      TITL1 = ' '
      TITL2 = ' '
      IF (DOCRT.GT.-2.5) THEN
         WRITE (LINE,2000) NAMEIN, CLAIN, SEQIN, DISKIN, NLUSER, BCHAN,
     *      ECHAN
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 960
         LINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 960
         END IF
      WRITE (TITL1,2010)
      WRITE (TITL2,2011)
      IF (DOCRT.GT.-2.5) THEN
         LINE = TITL1
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 960
         LINE = TITL2
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 960
         END IF
      IF (DOCRT.GT.-1.5) THEN
         LINE = ' '
         CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 960
         END IF
C                                       over baselines
      IA1 = 1
      IA2 = 0
      DO 200 JB = 1,NB
         IA2 = IA2 + 1
         IF (IA2.GT.NSTNS) THEN
            IA1 = IA1 + 1
            IA2 = IA1
             END IF
         DO 190 JI = 1,NI
            DO 180 JS = 1,NS
C                                       find amplitudes
               NG = 0
               DO 100 JT = 1,NTIMES
                  IF ((VALS(1,JS,JI,JB,JT).NE.FBLANK) .AND.
     *               (VALS(2,JS,JI,JB,JT).NE.FBLANK)) THEN
                     VALS(3,JS,JI,JB,JT) = SQRT (VALS(1,JS,JI,JB,JT)**2
     *                  + VALS(2,JS,JI,JB,JT)**2)
                     IF (VALS(3,JS,JI,JB,JT).LE.0.0) THEN
                        VALS(1,JS,JI,JB,JT) = FBLANK
                        VALS(2,JS,JI,JB,JT) = FBLANK
                        VALS(3,JS,JI,JB,JT) = FBLANK
                     ELSE
                        NG = NG + 1
                        END IF
                  ELSE
                     VALS(3,JS,JI,JB,JT) = FBLANK
                     END IF
 100              CONTINUE
C                                       none
              IF (NG.LE.0) THEN
                 CALL RFILL (6, 0.0, RAW)
C                                       find differences
              ELSE
C                                       do brute rms/mean
                 S1 = 0.0D0
                 S2 = 0.0D0
                 S3 = 0.0D0
                 S4 = 0.0D0
                 Q1 = 0.0D0
                 Q2 = 0.0D0
                 Q3 = 0.0D0
                 Q4 = 0.0D0
                 NSQ = 0.0D0
                 DO 110 JT = 1,NTIMES-2
                    TR1 = VALS(1,JS,JI,JB,JT)
                    TI1 = VALS(2,JS,JI,JB,JT)
                    TA1 = VALS(3,JS,JI,JB,JT)
                    TR2 = VALS(1,JS,JI,JB,JT+1)
                    TI2 = VALS(2,JS,JI,JB,JT+1)
                    TA2 = VALS(3,JS,JI,JB,JT+1)
                    TR3 = VALS(1,JS,JI,JB,JT+2)
                    TI3 = VALS(2,JS,JI,JB,JT+2)
                    TA3 = VALS(3,JS,JI,JB,JT+2)
                    IF ((TA1.NE.FBLANK) .AND. (TA2.NE.FBLANK) .AND.
     *                 (TA3.NE.FBLANK)) THEN
                       ANSW(3,JT) = (TA3 + TA1 - 2.*TA2) ** 2
                       SR = (TR3 + TR1 - 2.*TR2)
                       SI = (TI3 + TI1 - 2.*TI2)
                       ANSW(2,JT) = SR * SR + SI * SI
                       SR = (TR3/TA3 + TR1/TA1 - 2.*TR2/TA2)
                       SI = (TI3/TA3 + TI1/TA1 - 2.*TI2/TA2)
                       ANSW(1,JT) = SR * SR + SI * SI
                       P1 = ATAN2 (TI1, TR1)
                       P2 = ATAN2 (TI2, TR2)
                       P3 = ATAN2 (TI3, TR3)
                       CALL PHMINI (P1, P2, P3, ANSW(4,JT))
                       Q1 = Q1 + ANSW(1,JT)
                       S1 = S1 + ANSW(1,JT) ** 2
                       Q2 = Q2 + ANSW(2,JT)
                       S2 = S2 + ANSW(2,JT) ** 2
                       Q3 = Q3 + ANSW(3,JT)
                       S3 = S3 + ANSW(3,JT) ** 2
                       Q4 = Q4 + ANSW(4,JT)
                       S4 = S4 + ANSW(4,JT) ** 2
                       NSQ = NSQ + 1.0D0
                    ELSE
                       ANSW(1,JT) = FBLANK
                       ANSW(2,JT) = FBLANK
                       ANSW(3,JT) = FBLANK
                       ANSW(4,JT) = FBLANK
                       END IF
 110                CONTINUE
                 IF (NSQ.GT.0.0D0) THEN
                    RAW(1,1) = Q1 / NSQ
                    RAW(1,2) = Q2 / NSQ
                    RAW(1,3) = Q3 / NSQ
                    RAW(1,4) = Q4 / NSQ
                    RAW(2,1) = S1 / NSQ - RAW(1,1)*RAW(1,1)
                    RAW(2,2) = S2 / NSQ - RAW(1,2)*RAW(1,2)
                    RAW(2,3) = S3 / NSQ - RAW(1,3)*RAW(1,3)
                    RAW(2,4) = S4 / NSQ - RAW(1,4)*RAW(1,4)
                    RAW(2,1) = SQRT (MAX (0.0, RAW(2,1)))
                    RAW(2,2) = SQRT (MAX (0.0, RAW(2,2)))
                    RAW(2,3) = SQRT (MAX (0.0, RAW(2,3)))
                    RAW(2,4) = SQRT (MAX (0.0, RAW(2,4)))
                    END IF
C                                       loop over 3 parameters
                 DO 140 JP = 1,4
                    VP = RAW(1,JP) + WS(1) * RAW(2,JP)
                    VM = RAW(1,JP) - WS(1) * RAW(2,JP)
                    DO 130 IT = 1,NITER
                       SV = 0.0D0
                       SSV = 0.0D0
                       NV = 0.0D0
                       DO 120 JT = 1,NTIMES-2
                          IF (ANSW(JP,JT).NE.FBLANK) THEN
                             IF ((ANSW(JP,JT).GT.VM) .AND.
     *                          (ANSW(JP,JT).LT.VP)) THEN
                                SV = SV + ANSW(JP,JT)
                                SSV = SSV + ANSW(JP,JT)**2
                                NV = NV + 1.0D0
                                END IF
                             END IF
 120                      CONTINUE
                       IF (NV.GT.0.0D0) THEN
                          SV = SV / NV
                          SSV = SSV / NV - SV * SV
                          SSV = SQRT (MAX (0.0D0, SSV))
                          IF (IT.LT.NITER) THEN
                             VP = SV + WS(IT+1) * SSV
                             VM = SV - WS(IT+1) * SSV
                             END IF
                       ELSE
                          VP = 1.E4
                          VM = -1.E4
                          END IF
 130                   CONTINUE
                    ROB(1,JP) = SV
                    ROB(2,JP) = SSV
 140                CONTINUE
                  WRITE (LINE,2140) IA1, IA2, JS, JI, RAW(1,1),
     *               RAW(2,1), RAW(1,4), RAW(2,4), ROB(1,1), ROB(2,1),
     *               ROB(1,4), ROB(2,4)
                  CALL PRTLIN (LUNP, FINDP, DOCRT, NACROS, TITL1, TITL2,
     *               LINE, IPCNT, PAGE, SCRTCH, IRET)
                  IF (IRET.NE.0) GO TO 960
                  END IF
 180           CONTINUE
 190        CONTINUE
 200     CONTINUE
C
 960  IF (IRET.LE.0) IRET = 0
      CALL LPCLOS (LUNP, FINDP, IPCNT, IRET)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ALVPRP: ERROR',I4,' ON ',A)
 2000 FORMAT (A12,'.',A6,'.',I4,'  Vol=',I2,'  User=',I5,'  Channels=',
     *   I4,' to ',I4)
 2010 FORMAT ('An1 An2 S IF',16X,'Mean square',14X,2X,10X,
     *   'Robust mean square')
 2011 FORMAT (12X,'  Normal Vector Amp ','   Phase (radians^2)',3X,
     *   '  Normal Vector Amp ','   Phase (radians^2)')
 2140 FORMAT (I3,I4,I2,I3,2F10.6,1x,2F10.6,2X,2F10.6,1X,2F10.6)
      END
      SUBROUTINE PHMINI (P1, P2, P3, PDMIN)
C-----------------------------------------------------------------------
C   Find minimum (P3 - 2*P2 + P1)**2
C   Inputs:
C      P1      R   Phase at data point
C      P2      R   Phase at data point+1
C      P3      R   Phase at data point+2
C   Outputs
C      PDMIN   R   Minimum Allan variance
C-----------------------------------------------------------------------
      REAL      P1, P2, P3, PDMIN
C
      INTEGER   I, J
      REAL      P
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      PDMIN = 1.E10
      DO 20 I = 1,5
         DO 10 J = 1,3
            P = ((P3 + (I-3)*TWOPI) - 2.0 * (P2 + (J-2)*TWOPI) + P1) **2
            PDMIN = MIN (P, PDMIN)
 10         CONTINUE
 20      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE UVSORT (APCORE, DISKI, CNOSCI, DISKO, CNOSCO, SORT,
     *   ROTATE, CATRIO, NBUF, LUNST, JBUFSZ, BUFF1, BUFF2, IERR)
C-----------------------------------------------------------------------
C! Sorts (and rotates) one uv data file to another
C# Sort UV-util AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2001, 2006, 2008, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Sorts and optionally rotates the u,v plane of one uv data file to
C   another.  Will create output file is necessary.
C      Uses the "AP" to presort blocks of data and uses a disk based
C   merge sort if necessary.
C      The contents of DCAT.INC and DUVH.INC commons are modified.
C   Input:
C      DISKI    I        Input file disk number for cataloged files,
C                        .LE. 0 => /CFILES/ scratch file.
C      CNOSCI   I        Input file catalog slot number or /CFILES/
C                        scratch file number.
C      DISKO    I        Output file disk number for cataloged files,
C                        .LE. 0 => /CFILES/ scratch file.
C      SORT    C*2       desired sort order keys:
C                        T=time, B=baseline, X=abs (U), Y=abs (V)
C      ROTATE   R        U, V rotation in deg.
C      NBUFF    I        Number of input streams to be used in the merge
C      LUN     I(NBUFF,2) LUNs for work files, each is opened NBUFF
C                        times.
C   Input/Output:
C      CNOSCO   I        Output file catalog slot number or /CFILES/
C                        scratch file number. 0 => create.
C      CATRIO   R(*)     On input the input uv file catalog header
C                        On output the output uv file cat. header; also
C                        it is updated on disk.
C      JBUFSZ   I        I/O buffer size in bytes
C      BUFF1    R(*)     I/O buffer
C      BUFF2    R(*)     I/O buffer
C   Output:
C      IERR     I        Return code, 0=OK else failed.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   DISKI, CNOSCI, DISKO, CNOSCO, NBUF, LUNST(NBUF,1),
     *   JBUFSZ, IERR
      CHARACTER SORT*2
      REAL      ROTATE, CATRIO(*), BUFF1(*), BUFF2(*)
C
      INTEGER   APSIZE, NSORT, JERR, LRECS, ISIZE, DISKX, CNOX, VOL(2),
     *   FILCNO(2), KEY1, KEY2, LENBU, LREC2, NF, FR(2), ICATI(256),
     *   OCATI(256), I, INDX, I1, I2, INSCR, MSGSAV, NEED, KAP
      REAL      ICATR(256), OCATR(256)
      HOLLERITH ICATH(256), OCATH(256)
      DOUBLE PRECISION ICATD(256), OCATD(256)
      LOGICAL   ONEPAS
      CHARACTER SORDER*4
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (ICATI, ICATR, ICATH, ICATD)
      EQUIVALENCE (OCATI, OCATR, OCATH, OCATD)
      DATA FR /2*2/
C                                       Recognized sort order codes
      DATA SORDER /'TBXY'/
C-----------------------------------------------------------------------
C                                       Check sort codes
      I1 = INDEX (SORDER, SORT(1:1))
      I2 = INDEX (SORDER, SORT(2:2))
      IF ((I1.LE.0) .OR. (I2.LE.0)) THEN
         MSGTXT = 'UVSORT: UNKNOWN SORT CODE: ' // SORT
         IERR = 1
         GO TO 990
         END IF
C                                       How many vis can be sorted at a
C                                       time?
      CALL COPY (256, CATRIO, ICATI)
      CALL COPY (256, CATRIO, CATBLK)
      CALL UVPGET (JERR)
C                                       Number of "AP" words per vis.
      LRECS = LREC + 2 + 3
C                                       No. words per vis. in sort.
      LREC2 = LREC + 2
C                                       No. words per buffer
      ISIZE = ((JBUFSZ / NBUF) - 2 * NBPS) / 2
      LENBU = ISIZE / LREC2
C                                       "AP" size
      NEED = NVIS * LRECS + LENBU + 20
      NEED = NEED / 1024
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL QINIT (APCORE, NEED, 0, KAP)
      MSGSUP = MSGSAV
      IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
         NEED = NVIS * LRECS / 10 + LENBU + 20
         NEED = NEED / 1024
         NEED = MIN (64 * 1024, NEED) + 2
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            NEED = NVIS * LRECS / 100 + LENBU + 20
            NEED = NEED / 1024
            NEED = MIN (16 * 1024, NEED) + 2
            CALL QINIT (APCORE, NEED, 0, KAP)
            IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
               IERR = 8
               MSGTXT = 'UVSORT: UNABLE TO GET MEMORY FOR SORTING'
               GO TO 990
               END IF
            END IF
         END IF
      APSIZE = PSAPNW * 1024 - 20
      NSORT = APSIZE / LRECS
      CALL QRLSE
C                                       Can the job be done in a single
C                                       pass?
      ONEPAS = NSORT.GE.NVIS
      NSORT = MIN (NSORT, NVIS)
C                                       Create output scratch file if
C                                       necessary.
      IF ((DISKO.LE.0) .AND. (CNOSCO.EQ.0)) THEN
         CALL UVSIZE (LREC, NVIS+100, ISIZE)
         CALL SCREAT (ISIZE, BUFF2, IERR)
         CNOSCO = NSCR
         IF (IERR.GT.0) THEN
            MSGTXT = 'CREATING SCRATCH FILE'
            IF (IERR.EQ.1) MSGTXT = 'NO SPACE FOR SCRATCH FILE'
            GO TO 990
            END IF
         END IF
C                                       Set output file for first pass
      IF (ONEPAS) THEN
         DISKX = DISKO
         CNOX = CNOSCO
C                                       Horseshit for AMERGE
      ELSE
         INSCR = NSCR
C                                       No. words per vis. in sort.
         LREC2 = LREC + 2
C                                       No. words per buffer
         ISIZE = ((JBUFSZ / NBUF) - 2 * NBPS) / 2
         LENBU = ISIZE / LREC2
C                                       NSORT must be a multiple of
C                                       LENBU
         ISIZE = NSORT / LENBU
         NSORT = ISIZE * LENBU
         NSORT = MAX (NSORT, 1)
C                                       Make a couple more scratch
C                                       files.
         CALL UVSIZE (LREC2, NVIS+100, ISIZE)
         CALL SCREAT (ISIZE, BUFF2, IERR)
         VOL(1) = SCRVOL(NSCR)
         FILCNO(1) = SCRCNO(NSCR)
         DISKX = 0
         CNOX = NSCR
         IF (IERR.GT.0) THEN
            MSGTXT = 'CREATING SCRATCH FILE'
            IF (IERR.EQ.1) MSGTXT = 'NO SPACE FOR SCRATCH FILE'
            GO TO 990
            END IF
         CALL SCREAT (ISIZE, BUFF2, IERR)
         VOL(2) = SCRVOL(NSCR)
         FILCNO(2) = SCRCNO(NSCR)
         IF (IERR.GT.0) THEN
            MSGTXT = 'CREATING SCRATCH FILE'
            IF (IERR.EQ.1) MSGTXT = 'NO SPACE FOR SCRATCH FILE'
            GO TO 990
            END IF
C                                       End of preparation for merge
         END IF
C                                       First pass, read to "AP" sort
C                                       and write output.
      CALL SRTIN (APCORE, DISKI, CNOSCI, DISKX, CNOX, SORT, ROTATE,
     *   ONEPAS, NSORT, LUNST, JBUFSZ, BUFF1, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Merge sort if multiple passes
      IF (.NOT.ONEPAS) THEN
         KEY1 = 1
         KEY2 = 2
C                                       Merge sort
         CALL AMERGE (KEY1, KEY2, NVIS, LREC2, NSORT, NBUF, LUNST, VOL,
     *      FILCNO, LENBU, BUFF1, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 995
C                                       Copy scratch to output
         CALL SRTOUT (VOL(1), FILCNO(1), DISKO, CNOSCO, LUNST, JBUFSZ,
     *      BUFF1, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 995
C                                       Delete scratch files
         NF = 2
         CALL MAPCLR (NF, VOL, FILCNO, FR, BUFF1)
         NSCR = INSCR
         END IF
C                                       Fix up output CATBLK
      IF (DISKO.LE.0) THEN
         DISKX = SCRVOL(CNOSCO)
         CNOX = SCRCNO(CNOSCO)
      ELSE
         DISKX = DISKO
         CNOX = CNOSCO
         END IF
C                                       Read output CATBLK
      CALL CATIO ('READ', DISKX, CNOX, OCATI, 'REST', BUFF1, IERR)
      IF ((IERR.GT.1) .AND. (IERR.LE.3)) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
      ELSE
         IERR = 0
         END IF
C                                       Copy random parms
      OCATI(KIPCN) = ICATI(KIPCN)
      INDX = KHPTP
      DO 400 I = 1,OCATI(KIPCN)
         OCATH(INDX) = ICATH(INDX)
         INDX = INDX + 1
         OCATH(INDX) = ICATH(INDX)
         INDX = INDX + 1
 400     CONTINUE
C                                       Copy regular axes
      OCATI(KIDIM) = ICATI(KIDIM)
      INDX = KHCTP
      DO 410 I = 1,OCATI(KIPCN)
         OCATH(INDX) = ICATH(INDX)
         INDX = INDX + 1
         OCATH(INDX) = ICATH(INDX)
         INDX = INDX + 1
         OCATI(KINAX+I-1) = ICATI(KINAX+I-1)
         OCATR(KRCIC+I-1) = ICATR(KRCIC+I-1)
         OCATR(KRCRP+I-1) = ICATR(KRCRP+I-1)
         OCATR(KRCRT+I-1) = ICATR(KRCRT+I-1)
         OCATD(KDCRV+I-1) = ICATD(KDCRV+I-1)
 410     CONTINUE
C                                       No. vis.
      OCATI(KIGCN) = NVIS
C                                       Sort order
      CALL CHR2H (2, SORT, 1, OCATH(KITYP))
C                                       Rotation
      OCATR(KRCRT+JLOCD) = OCATR(KRCRT+JLOCD) + ROTATE
C                                       Units
      OCATH(KHBUN) = ICATH(KHBUN)
      OCATH(KHBUN+1) = ICATH(KHBUN+1)
C                                       Save output CATBLK
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL CATIO ('UPDT', DISKX, CNOX, OCATI, 'REST', BUFF1, IERR)
C                                       If failed try 'WRIT'
      IF (IERR.NE.0) CALL CATIO ('WRIT', DISKX, CNOX, OCATI, 'REST',
     *   BUFF1, IERR)
      MSGSUP = MSGSAV
      IF ((IERR.GT.1) .AND. (IERR.LE.4)) THEN
         WRITE (MSGTXT,1410) IERR
         GO TO 990
      ELSE
         IERR = 0
         END IF
C                                       Return output CATBLK
      CALL RCOPY (256, OCATR, CATRIO)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (7)
 995  MSGTXT = 'UVSORT: ERROR SORTING UV DATA'
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVSORT: ERROR ',I3,' READING OUTPUT CATBLK')
 1410 FORMAT ('UVSORT: ERROR ',I3,' WRITING OUTPUT CATBLK')
      END

      SUBROUTINE PSEUDO (BRANCH)
C-----------------------------------------------------------------------
C! compiles pseudoverbs: PROC, declarations, IF, THEN, WHILE, FINISH, ..
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PSEUDO handles procedure and array declarations, setups for run-
C   time operators IF, THEN, ELSE, WHILE (which require forward
C   references and an additional clean-up pass), and the FINISH
C   operator.
C   Inputs:
C      BRANCH   I   pseudoverb number: specifies desired operation
C                      PROCEDURE     1
C                      PROC          1
C                      SCALAR        2
C                      VERB          3
C                      PSEUDOVRB     4
C                      ARRAY         5
C                      STRING        6
C                      ELSE          7
C                      THEN          8
C                      IF            9
C                      WHILE        10
C                      FINISH       11
C                      DEBUG        12
C                      MSGKILL      13
C                      ISBATCH      14
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
C                                  push down stack for clean-up
C                                  "FINISH" operation
      INTEGER   BPR(100), TSTACK(100)
C                                  reason why an item was pushed down
C                                  during clean-up
      INTEGER   REASON
      INTEGER   A(100), B(100), TAGS, I, ISGN, ISIZE, IT, K3SAVE,
     *   KXLINK, LL, LLI, LS, MM, N, NARG, NCH, NDIM, NOTHNG, NP, NSIZE,
     *   NT, LMODE, LLOCAT, RLOCAT, RETNUM, POTERR, NTHEN, NWHILE,
     *   NELSE, NEND, NENDR, NFOR
      LOGICAL   PREVDF
      CHARACTER PRGNAM*6
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSMS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DIO.INC'
      EQUIVALENCE (BPR(1), V(1))
      EQUIVALENCE (STACK(1), A(1)),    (CSTACK(1), B(1))
      DATA NOTHNG, RETNUM /0, 25/
      DATA PRGNAM /'PSEUDO'/
      DATA NTHEN, NWHILE, NELSE, NEND, NENDR, NFOR
     *   /   107,    109,   106,   22,    96,   21/
C-----------------------------------------------------------------------
      POTERR = 71
      IF ((MODE.EQ.1) .AND. (BRANCH.EQ.1)) GO TO 980
      POTERR = 70
      IF ((MODE.EQ.0) .AND. (BRANCH.GT.1) .AND. (BRANCH.LT.12))
     *   GO TO 980
      POTERR = 76
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.14)) GO TO 980
C
      GO TO (100, 150, 160, 160, 200, 250, 300, 310, 320, 350, 400,
     *   500, 500, 500), BRANCH
C-----------------------------------------------------------------------
C                                       PROC name (arg1, arg2, ...)
C-----------------------------------------------------------------------
 100  LMODE = MODE
      MODE = 69
      IPT = ':'
      CALL GETFLD
      MODE = 1
      IF (ERRNUM.NE.0) GO TO 980
      POTERR = 14
      IF ((SYTYPE.NE.1) .AND. (SYTYPE.NE.3)) GO TO 980
C                                        protect VLAGEN'd procs
      POTERR = 25
      IF (L.LT.K(7)) GO TO 980
      NAMEP = LOCSYM + 2
      NARG = 0
 105  CALL GETFLD
         IF (ERRNUM.NE.0) GO TO 980
         IF (TAG.EQ.1) GO TO 105
         IF (TAG.EQ.2) GO TO 105
         IF (TAG.EQ.3) GO TO 110
         IF ((TAG.EQ.0) .OR. (TAG.EQ.20)) GO TO 110
            POTERR = 23
C                                        real parameters
            IF (SYTYPE.NE.1) GO TO 106
               CALL PUSH (TSTACK, NARG, TAG)
               IF (ERRNUM.NE.0) GO TO 980
               GO TO 105
C                                        string/array parameters
 106        IF ((SYTYPE.NE.2) .AND. (SYTYPE.NE.7)) GO TO 980
               CALL PUSH (TSTACK, NARG, SYTYPE)
               CALL PUSH (TSTACK, NARG, K(LOCSYM+3))
               CALL PUSH (TSTACK, NARG, TAG)
               CALL PUSH (TSTACK, NARG, 2)
               IF (ERRNUM.NE.0) GO TO 980
               GO TO 105
 110     CONTINUE
            N = NARG + 4
            LL = LLOCAT (N, K, LPGM)
            IF (ERRNUM.NE.0) GO TO 980
            LPGM = LL
            K(NAMEP) = LL
            CALL SETTYP (K, NAMEP, 3)
            LL = LL+2
            IF (NARG.EQ.0) GO TO 120
               DO 115 I = 1,NARG
                  K(LL) = -TSTACK(I)
                  LL = LL + 1
 115              CONTINUE
               K(LL) = 3
               LL = LL + 1
 120  K(LL) = 1
      GO TO 999
C-----------------------------------------------------------------------
C                                       SCALAR <name>, <name>, ...
C-----------------------------------------------------------------------
 150  POTERR = 36
      IF ((MODE.NE.1) .AND. (MODE.NE.3)) GO TO 980
      K3SAVE = K(3)
      LMODE = MODE
      MODE = 69
      CALL GETFLD
      MODE = LMODE
         IF (ERRNUM.NE.0) GO TO 980
         IF (TAG.EQ.1) GO TO 150
         IF ((TAG.EQ.0) .OR. (TAG.EQ.20)) GO TO 999
            POTERR = 14
            IF (SYTYPE.NE.1) GO TO 980
            IF (K3SAVE.LE.L) C(TAG) = 0.0
            GO TO 150
C-----------------------------------------------------------------------
C                                       VERB <name> = #, <name>, ...
C                                       PSEUDOVRB <name> = #, <name>, ..
C-----------------------------------------------------------------------
 160  POTERR = 36
      IF ((MODE.NE.1) .AND. (MODE.NE.3)) GO TO 980
      K3SAVE = K(3)
      LMODE = MODE
      MODE = 69
C                                       get verb name
      CALL GETFLD
      MODE = LMODE
         IF (ERRNUM.NE.0) GO TO 980
         IF (TAG.EQ.1) GO TO 160
         IF ((TAG.EQ.0) .OR. (TAG.EQ.20)) GO TO 999
         POTERR = 8
         IF ((SYTYPE.EQ.4) .AND. (BRANCH.EQ.4)) GO TO 980
         IF ((SYTYPE.EQ.5) .AND. (BRANCH.EQ.3)) GO TO 980
         IF ((SYTYPE.NE.1) .AND. (SYTYPE.NE.4) .AND. (SYTYPE.NE.5))
     *      GO TO 980
         PREVDF = (SYTYPE.EQ.4) .OR. (SYTYPE.EQ.5)
         POTERR = 14
         IF ((.NOT.PREVDF) .AND. (K3SAVE.GT.L)) GO TO 980
         POTERR = 25
         IF ((.NOT.PREVDF) .AND. (K(7).GT.L)) GO TO 980
         LS = L + 2
C                                       get = sign
         POTERR = 8
         CALL GETFLD
         IF (ERRNUM.NE.0) GO TO 980
         IF ((TAG.NE.4) .AND. (TAG.NE.17)) GO TO 980
C                                       get value
         CALL GETFLD
         IF (ERRNUM.NE.0) GO TO 980
C                                       allow a new number
         IF (SYTYPE.NE.11) GO TO 980
         IT = X(1) + 0.5
         IF ((IT.LT.1) .OR. (IT.GT.999)) GO TO 980
C                                       put in K array
         I = BRANCH + 1
         CALL SETTYP (K, LS, I)
         K(LS) = IT
         GO TO 160
C-----------------------------------------------------------------------
C                                       A R R A Y <name> <(n)>.
C-----------------------------------------------------------------------
 200  POTERR = 36
      IF ((MODE.NE.1) .AND. (MODE.NE.3)) GO TO 980
      K3SAVE = K(3)
      LMODE = MODE
      MODE = 69
      CALL GETFLD
      MODE = LMODE
      IF (ERRNUM.NE.0) GO TO 980
      IF (TAG.EQ.1) GO TO 200
      IF ((TAG.EQ.0) .OR. (TAG.EQ.20)) GO TO 999
         POTERR = 8
         IF ((SYTYPE.NE.1) .AND. (SYTYPE.NE.2)) GO TO 980
         PREVDF = SYTYPE.EQ.2
         POTERR = 14
         IF ((.NOT.PREVDF) .AND. (K3SAVE.GT.L)) GO TO 980
         POTERR = 25
         IF ((.NOT.PREVDF) .AND. (K(7).GT.L)) GO TO 980
         TAGS = TAG
         LS = LOCSYM + 2
         CALL SETTYP (K, LS, 2)
         NDIM = 0
         NP = 0
C                                       Parse Dimensions: open paren
         CALL GETFLD
         IF (ERRNUM.NE.0) GO TO 980
         POTERR = 8
         IF(TAG.NE.2) GO TO 980
C                                       get number
 210     CALL GETFLD
            IF (ERRNUM.NE.0) GO TO 980
            ISGN = 1
C                                       - sign, get number
            IF (TAG.EQ.6) THEN
               ISGN = -1
               CALL GETFLD
               IF (ERRNUM.NE.0) GO TO 980
               END IF
            POTERR = 8
            IF ((SYTYPE.NE.1) .AND. (SYTYPE.NE.11)) GO TO 980
            NDIM = NDIM + 1
            LL = C(TAG) * ISGN
            CALL GETFLD
            IF (ERRNUM.NE.0) GO TO 980
C                                       a range of numbers
            IF ((TAG.EQ.15) .AND. (SYTYPE.EQ.4)) THEN
               CALL GETFLD
               IF (ERRNUM.NE.0) GO TO 980
               ISGN = 1
               IF (TAG.EQ.6) THEN
                  ISGN = -1
                  CALL GETFLD
                  IF (ERRNUM.NE.0) GO TO 980
                  END IF
               POTERR = 8
               IF((SYTYPE.NE.1) .AND. (SYTYPE.NE.11)) GO TO 980
               MM = C(TAG)*ISGN - LL + 1
               CALL GETFLD
               IF (ERRNUM.NE.0) GO TO 980
            ELSE
               MM = LL
               LL = 1
               END IF
C                                       put on stack for later
            POTERR = 6
            IF (MM.LE.0) GO TO 980
            CALL PUSH (TSTACK, NP, LL)
            IF (ERRNUM.NE.0) GO TO 980
            CALL PUSH (TSTACK, NP, MM)
            IF (ERRNUM.NE.0) GO TO 980
C                                       if not close paren, loop
            IF (TAG.NE.3) GO TO 210
C                                       Build array dope vector.
         N = 2*NDIM + 2
         LS = LS + 1
         IF (.NOT.PREVDF) LL = LLOCAT (N, K, LS)
         IF (ERRNUM.NE.0) GO TO 980
         IF (PREVDF) LL = K(LS)
         LLI = LL + 2
         N = N - 2
C                                         Allocate remaining space.
         ISIZE = 1
         DO 215 I = 2,N,2
            ISIZE = ISIZE * TSTACK(I)
 215        CONTINUE
         POTERR = 14
         IF ((PREVDF) .AND. (ISIZE.NE.K(LL))) GO TO 980
         IF ((PREVDF) .AND. (NDIM.NE.K(LL+1))) GO TO 980
         K(LL) = ISIZE
         K(LL+1) = NDIM
         KXLINK = 1
         CALL COPY (N, TSTACK, K(LLI))
C                                       make space, zero fill
         IF (.NOT.PREVDF) THEN
            N  =  ISIZE - 1
            LL = RLOCAT (N, K(KXORG), C, KXLINK)
            IF (ERRNUM.NE.0) GO TO 980
            CALL RFILL (ISIZE, 0.0, C(TAGS))
            END IF
         GO TO 200
C-----------------------------------------------------------------------
C                                     S T R I N G * n <name> <(dim)>.
C-----------------------------------------------------------------------
C                                       parse length
 250  POTERR = 36
      IF ((MODE.NE.1) .AND. (MODE.NE.3)) GO TO 980
      LMODE = MODE
      MODE = 69
      K3SAVE = K(3)
      CALL GETFLD
      MODE = LMODE
      IF (ERRNUM.NE.0) GO TO 980
C                                       length at beginning
      IF (TAG.EQ.7) THEN
         CALL GETFLD
         IF (ERRNUM.NE.0) GO TO 980
         POTERR = 8
         IF ((SYTYPE.NE.1) .AND. (SYTYPE.NE.11)) GO TO 980
         NCH = C(TAG) + 0.1
         NSIZE = (NCH + 3) / 4
         POTERR = 13
         IF (NCH.GT.132) GO TO 980
      ELSE
         POTERR = 8
         GO TO 980
         END IF
C                                       Parse name of string.
 260  K3SAVE = K(3)
      LMODE = MODE
      MODE = 69
      CALL GETFLD
      MODE = LMODE
         IF (ERRNUM.NE.0) GO TO 980
         IF (TAG.EQ.1) GO TO 260
         IF ((TAG.EQ.0) .OR. (TAG.EQ.20)) GO TO 999
            POTERR = 8
            IF ((SYTYPE.NE.1) .AND. (SYTYPE.NE.7)) GO TO 980
            PREVDF = SYTYPE.EQ.7
            POTERR = 14
            IF ((.NOT.PREVDF) .AND. (K3SAVE.GT.L)) GO TO 980
            POTERR = 25
            IF ((.NOT.PREVDF) .AND. (K(7).GT.L)) GO TO 980
            TAGS = TAG
            LS = LOCSYM + 2
            CALL SETTYP (K, LS, 7)
            NDIM = 1
            NP = 0
            CALL PUSH (TSTACK, NP, 1)
            IF (ERRNUM.NE.0) GO TO 980
            CALL PUSH (TSTACK, NP, NSIZE)
            IF (ERRNUM.NE.0) GO TO 980
C                                       Parse dimensions.
            CALL GETFLD
            IF (ERRNUM.NE.0) GO TO 980
            IF ((TAG.GT.1) .AND. (TAG.NE.20)) THEN
               POTERR = 8
C                                       must be open paren
               IF (TAG.NE.2) GO TO 980
C                                       get number
 270           CALL GETFLD
               IF (ERRNUM.NE.0) GO TO 980
               ISGN = 1
               IF (TAG.EQ.6) THEN
                  ISGN = -1
                  CALL GETFLD
                  IF (ERRNUM.NE.0) GO TO 980
                  END IF
               POTERR = 8
               IF ((SYTYPE.NE.1) .AND. (SYTYPE.NE.11)) GO TO 980
               NDIM = NDIM + 1
               LL = C(TAG) * ISGN
C                                       get next symbol
               CALL GETFLD
               IF (ERRNUM.NE.0) GO TO 980
C                                       a range ("TO" or ":")
               IF ((TAG.EQ.15) .AND. (SYTYPE.EQ.4)) THEN
                  CALL GETFLD
                  IF (ERRNUM.NE.0) GO TO 980
                  ISGN = 1
                  IF (TAG.EQ.6) THEN
                     ISGN = -1
                     CALL GETFLD
                     IF (ERRNUM.NE.0) GO TO 980
                     END IF
                  POTERR = 8
                  IF ((SYTYPE.NE.1) .AND. (SYTYPE.NE.11)) GO TO 980
                  MM = C(TAG)*ISGN - LL + 1
                  CALL GETFLD
                  IF (ERRNUM.NE.0) GO TO 980
               ELSE
                  MM = LL
                  LL = 1
                  END IF
C                                       dimensions to stack
               POTERR = 6
               IF (MM.LE.0) GO TO 980
               CALL PUSH (TSTACK, NP, LL)
               IF (ERRNUM.NE.0) GO TO 980
               CALL PUSH (TSTACK, NP, MM)
               IF (ERRNUM.NE.0) GO TO 980
               IF (TAG.NE.3) GO TO 270
               END IF
C                                          Allocate remaining space.
         N = 2 * NDIM + 2
         LS = LS + 1
         IF (.NOT.PREVDF) LL = LLOCAT (N, K, LS)
         IF (ERRNUM.NE.0) GO TO 980
         IF (PREVDF) LL = K(LS)
         LLI = LL + 2
         N = N - 2
         ISIZE = 1
         DO 275 I = 2,N,2
            ISIZE = ISIZE * TSTACK(I)
 275        CONTINUE
         POTERR = 14
         IF ((PREVDF) .AND. (ISIZE.NE.K(LL))) GO TO 980
         IF ((PREVDF) .AND. (NDIM.NE.K(LL+1))) GO TO 980
         CALL COPY (N, TSTACK, K(LLI))
         K(LL) = ISIZE
         K(LL+1) = NDIM
         K(LL+3) = NCH
C                                       make space
         IF (.NOT.PREVDF) THEN
            KXLINK = 1
C                                       -1 since 1 already allocated
            N = ISIZE - 1
            LL = RLOCAT (N, K(KXORG), C, KXLINK)
            IF (ERRNUM.NE.0) GO TO 980
C                                       Blank fill.
            CALL RFILL (ISIZE, HBLANK, C(TAGS))
            END IF
         IF ((TAG.EQ.0) .OR. (TAG.EQ.20)) GO TO 999
         GO TO 260
C-----------------------------------------------------------------------
C                                       E L S E.
C-----------------------------------------------------------------------
 300  GO TO 310
C-----------------------------------------------------------------------
C                                       T H E N.
C-----------------------------------------------------------------------
 310  CONTINUE
      IFFLAG = 0
      NEXTP = 0
      CALL BCLEAN
      CALL PUSH (A, AP, 0)
      IF (ERRNUM.NE.0) GO TO 980
      CALL PUSH (A, AP, 0)
      IF (ERRNUM.NE.0) GO TO 980
      CALL PUSH (A, AP, TAG)
      IF (ERRNUM.NE.0) GO TO 980
      LAST = NOTHNG
      GO TO 999
C-----------------------------------------------------------------------
C                                       I F
C-----------------------------------------------------------------------
 320  IFFLAG = 1
      NEXTP = 0
      CALL BCLEAN
      LAST = NOTHNG
      GO TO 999
C-----------------------------------------------------------------------
C                                       W H I L E.
C-----------------------------------------------------------------------
 350  IFFLAG = 1
      IT = 97
      NEXTP = 0
      CALL BCLEAN
      CALL PUSH (A, AP, IT)
      IF (ERRNUM.NE.0) GO TO 980
      CALL PUSH (B, BP, TAG)
      IF (ERRNUM.NE.0) GO TO 980
      BPR(BP) = 0
      CALL PUSH (B, BP, 0)
      IF (ERRNUM.NE.0) GO TO 980
      BPR(BP) = 0
      CALL PUSH (B, BP, 0)
      IF (ERRNUM.NE.0) GO TO 980
      BPR(BP) = 0
      GO TO 999
C-----------------------------------------------------------------------
C                                       F I N I S H.
C-----------------------------------------------------------------------
 400  MODE = 2
      NT = 0
      IF (IDEBUG.LE.0) GO TO 405
         WRITE (MSGTXT,1400) NAMEP, K(NAMEP)
         CALL MSGWRT (4)
 405  POTERR = 11
      IF ((NAMEP.LT.200) .OR. (NAMEP.GT.KXORG)) GO TO 980
      L = K(NAMEP)
      POTERR = 11
      IF (L.EQ.0) GO TO 980
      NAMEP = 0
 410  LINK = K(L)
         L = L+1
 415     L = L+1
            IF (IDEBUG.GT.0) THEN
               WRITE (MSGTXT,1415) L, K(L), NT, TSTACK(NT)
               CALL MSGWRT (4)
               END IF
            IF (K(L).EQ.1) GO TO 450
C                                          THEN or WHILE.
            IF ((K(L).NE.NTHEN) .AND. (K(L).NE.NWHILE)) GO TO 435
 430           CALL PUSH (TSTACK, NT, L)
               IF (ERRNUM.NE.0) GO TO 980
               CALL PUSH (TSTACK, NT, K(L))
               IF (ERRNUM.NE.0) GO TO 980
               GO TO 415
C                                          ELSE or END.
 435        IF ((K(L).NE.NELSE) .AND. (K(L).NE.NEND) .AND.
     *         (K(L).NE.NENDR)) GO TO 440
               POTERR = 21
               IF (NT.EQ.0) GO TO 980
               CALL POP (TSTACK, NT, REASON)
               IF (ERRNUM.NE.0) GO TO 980
C                                     If END operator of an IF stmt
C                                     change to Opcode 96 (a no-op)
C                                     which won't hurt the EDITOR.
               IF (((REASON.EQ.NELSE) .OR. (REASON.EQ.NTHEN)) .AND.
     *            (K(L).EQ.NEND)) K(L) = NENDR
               CALL POP (TSTACK, NT, IT)
               IF (ERRNUM.NE.0) GO TO 980
               IF (IT.EQ.0) GO TO 415
                  K(IT-2) = -L-1
                  K(IT-1) = -LINK
                  IF (LINK.LE.0) K(IT-1) = -K(3)
                  IF (K(L).EQ.NELSE) GO TO 430
                  GO TO 415
C                                          FOR.
 440        IF (K(L).NE.NFOR) GO TO 415
               CALL PUSH (TSTACK, NT, 0)
               IF (ERRNUM.NE.0) GO TO 980
               CALL PUSH (TSTACK, NT, K(L))
               IF (ERRNUM.NE.0) GO TO 980
               GO TO 415
 450     L = LINK
         IF (L.NE.0) GO TO 410
      POTERR = 21
      IF (NT.NE.0) GO TO 980
      IPT = '>'
C                                       Put a RETURN in automatically
      IF (MODE.NE.0) THEN
         CALL PUSH (A, AP, RETNUM)
         CALL PUSH (A, AP, 1)
         END IF
      IF (ERRNUM.NE.0) GO TO 980
      GO TO 999
C-----------------------------------------------------------------------
C                                       M S G K I L L  <true/false>.
C                                       D E B U G  <true/false>.
C                                       I S B A T C H  <true/false>.
C-----------------------------------------------------------------------
 500  CALL GETFLD
      IF (ERRNUM.NE.0) GO TO 980
      ISGN = 1
C                                       - sign, get number
      IF (TAG.EQ.6) THEN
         ISGN = -1
         CALL GETFLD
         IF (ERRNUM.NE.0) GO TO 980
         END IF
      POTERR = 8
      IF ((SYTYPE.NE.1) .AND. (SYTYPE.NE.11) .AND. (SYTYPE.NE.15))
     *    GO TO 980
C                                       DEBUG
      IF (BRANCH.EQ.12) THEN
         IDEBUG = 1
         IF (ISGN*C(TAG).LT.0.0) IDEBUG = -1
C                                       MSGKILL
      ELSE IF (BRANCH.EQ.13) THEN
         MSGKIL = 32000 + ISGN*C(TAG) - 0.99
         IF (ISGN*C(TAG).LT.0.0) MSGKIL = 0
C                                       ISBATCH
      ELSE IF (BRANCH.EQ.14) THEN
         ISBTCH = 32000
         IF (ISGN*C(TAG).LT.0.0) ISBTCH = 0
         IF (NPOPS.GT.NINTRN+1) ISBTCH = 32000
         END IF
      GO TO 999
C-----------------------------------------------------------------------
C                                   Error return.
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1400 FORMAT ('NAMEP, K(NAMEP)=',2I10)
 1415 FORMAT ('FINISH: L,K(L),NT,TSTACK(NT): ', 4I10)
      END

      SUBROUTINE SMMWF (WIDTH, ALPHA, X, Y, W, N, YS, WS, YOR, WOR)
C-----------------------------------------------------------------------
C! Median window smoothing of an irregularly spaced array with blanking
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;  Eric W. Greisen
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SMMWF does a median window smoothing of weighted irregularly spaced
C   points possibly with blanked values.  Only returns blanked values if
C   no valid data found.  First good value used for all previous points,
C   last good value used for all subsequent points in which all data are
C   blanked in the boxcar.  A datum is blanked if its weight is <= 0 or
C   FBLANK.
C   Inputs:
C      WIDTH   R      Width of boxcar in same units as X: 0 => replace
C                     blanks with interpolated closest 2, < 0 => replace
C                     only blanks with the b oxcar smoothed values (all
C                     others remain unchanged)
C      ALPHA   R      0 -> 1 = pure boxcar -> pure MWF (ALPHA of the
C                     data samples are discarded and the rest averaged).
C      X       R(N)   Absissae of points to be smoothed in increasing
C                     order
C      Y       R(N)   Values to be smoothed.
C      W       R(N)   Weights of data.
C      N       I      Number of points to smooth.
C    Output:
C      YS      R(N)   Smoothed values.
C      WS      R(N)   Smoothed weights
C      YOR     R(N)   Scratch
C      WOR     R(N)   Scratch
C-----------------------------------------------------------------------
      INTEGER   N
      REAL      WIDTH, ALPHA, X(N), Y(N), W(N), YS(N), WS(N), YOR(N),
     *   WOR(N)
C
      INTEGER   I, J, K, L, I1, I2, IC
      REAL      HW, D, TEMP, BETA
      LOGICAL   WASB, ONLYB, BLNKD
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IF (N.LE.0) GO TO 999
      D = ABS (WIDTH)
      ONLYB = WIDTH.LE.0.0
      HW = D / 2.0
      WASB = .FALSE.
      BETA = MAX (0.05, MIN (0.95, ALPHA)) / 2.0
C                                       0.0 => interp only
      IF (D.LE.0.0) THEN
         DO 10 I = 1,N
            BLNKD = (Y(I).EQ.FBLANK) .OR. (W(I).LE.0.0) .OR.
     *         (W(I).EQ.FBLANK)
            IF (BLNKD) THEN
               YS(I) = 0.0
               WS(I) = 0.0
               WASB = .TRUE.
            ELSE
               YS(I) = Y(I)
               WS(I) = W(I)
               END IF
 10         CONTINUE
C                                       Smooth
      ELSE
         DO 100 I = 1,N
            BLNKD = (Y(I).EQ.FBLANK) .OR. (W(I).LE.0.0) .OR.
     *         (W(I).EQ.FBLANK)
            IF (BLNKD) THEN
               YS(I) = 0.0
               WS(I) = 0.0
               IC = 0
            ELSE
               YS(I) = Y(I) * W(I)
               WS(I) = W(I)
               IC = 1
               YOR(IC) = Y(I)
               WOR(IC) = W(I)
               END IF
            IF ((BLNKD) .OR. (.NOT.ONLYB)) THEN
               DO 30 K = 1,I-1
                  IF (ABS(X(I)-X(I-K)).GT.HW) THEN
                     GO TO 35
                  ELSE
                     IF ((Y(I-K).NE.FBLANK) .AND. (W(I-K).GT.0.0) .AND.
     *                  (W(I-K).NE.FBLANK)) THEN
C                                       order the datum
                        DO 15 J = 1,IC
                           L = J
                           IF (YOR(J).GT.Y(I-K)) GO TO 20
 15                        CONTINUE
                        L = IC + 1
 20                     DO 25 J = L,IC
                           I1 = IC - J + L
                           YOR(I1+1) = YOR(I1)
                           WOR(I1+1) = WOR(I1)
 25                        CONTINUE
                        YOR(L) = Y(I-K)
                        WOR(L) = W(I-K)
                        END IF
                     END IF
 30               CONTINUE
 35            DO 60 K = I+1,N
                  IF (ABS(X(I)-X(K)).GT.HW) THEN
                     GO TO 65
                  ELSE
                     IF ((Y(K).NE.FBLANK) .AND. (W(K).GT.0.0) .AND.
     *                  (W(K).NE.FBLANK)) THEN
                        DO 45 J = 1,IC
                           L = J
                           IF (YOR(J).GT.Y(K)) GO TO 50
 45                        CONTINUE
                        L = IC + 1
 50                     DO 55 J = L,IC
                           I1 = IC - J + L
                           YOR(I1+1) = YOR(I1)
                           WOR(I1+1) = WOR(I1)
 55                        CONTINUE
                        YOR(L) = Y(K)
                        WOR(L) = W(K)
                        END IF
                     END IF
 60               CONTINUE
C                                       Now average the center set
 65            YS(I) = 0.0
               WS(I) = 0.0
               IF (IC.GT.0) THEN
                  K = BETA * IC + 0.5
                  I1 = 1 + K
                  I2 = IC - K
                  IF (I2.LT.I1) THEN
                     I1 = MAX (1, I1 - 1)
                     I2 = MIN (IC, I2 + 1)
                     END IF
                  DO 70 K = I1,I2
                     YS(I) = YS(I) + YOR(K) * WOR(K)
                     WS(I) = WS(I) + WOR(K)
 70                  CONTINUE
                  END IF
               END IF
            IF (WS(I).GT.0.0) THEN
               YS(I) = YS(I) / WS(I)
            ELSE
               WASB = .TRUE.
               END IF
 100        CONTINUE
         END IF
C                                       fill in remaining blanks
      IF (WASB) THEN
C                                       extrapolate to ends
         I1 = N+1
         I2 = 0
         DO 110 I = 1,N
            IF (WS(I).GT.0.0) THEN
               I1 = MIN (I, I1)
               I2 = MAX (I, I2)
               END IF
 110        CONTINUE
         IF (I1.GT.1) THEN
            J = I1 - 1
            CALL RFILL (J, YS(I1), YS(1))
            CALL RFILL (J, WS(I1), WS(1))
            END IF
         IF (I2.LT.N) THEN
            J = N - I2
            CALL RFILL (J, YS(I2), YS(I2+1))
            CALL RFILL (J, WS(I2), WS(I2+1))
            END IF
C                                       interpolate others
         DO 130  I = 1,N
            IF (WS(I).GT.0.0) THEN
               I1 = I
            ELSE
               DO 120 I2 = I+1,N
                  IF (WS(I2).GT.0.0) GO TO 125
 120              CONTINUE
 125           TEMP = X(I2) - X(I1)
               IF (TEMP.EQ.0.0) TEMP = 1.0
               YS(I) = YS(I1) + (X(I)-X(I1)) * (YS(I2)-YS(I1)) / TEMP
               WS(I) = WS(I1) + (X(I)-X(I1)) * (WS(I2)-WS(I1)) / TEMP
               END IF
 130        CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZLASCL (FILNAM, LUN, DELFIL, SYSERR, IERR)
C-----------------------------------------------------------------------
C! close and spool a laser printer print/plot file
C# Z2 Printer Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   close and spool a file for printing a plot on a laser printer
C   Inputs:
C      FILNAM   C*48   print/plot file name
C      LUN      I      LUN under which file is open
C      DELFIL   I      1 => delete the file after print, 0 => keep it
C                      -1 => close file only
C   Output
C      SYSERR   I      system error code (on IERR 2)
C      IERR     I      error code: 0 => okay, 1 => could not queue
C                         2 => Fortran close error
C   VMS version - queues file in the Fortran close.
C-----------------------------------------------------------------------
      CHARACTER FILNAM*48
      INTEGER   LUN, DELFIL, SYSERR, IERR
C
      INTEGER   ITRIM, FLEN, LELFIL, XLNB, SYS$CRELNM, LIST4(4)
      CHARACTER DEVICQ*64
      INTEGER*2 LIST2(8)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE '($LNMDEF)'
      EQUIVALENCE (LIST2, LIST4)
C-----------------------------------------------------------------------
      SYSERR = 0
      IERR = 0
      LELFIL = DELFIL
C                                       assign the printer: find queue
C                                       Find out Queue name for plotter.
      CALL ZTRLOG (6, 'LASQUE', 64, DEVICQ, XLNB, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         IERR = 1
C                                       Assign SYS$PRINT to plotter
C                                       device queue.
      ELSE
         LIST2(1) = XLNB
         LIST2(2) = LNM$_STRING
         LIST4(2) = %LOC (DEVICQ)
         LIST4(3) = 0
         LIST4(4) = 0
         SYSERR = SYS$CRELNM ( , 'LNM$PROCESS_TABLE', 'SYS$PRINT', ,
     *      LIST4)
         IF (SYSERR.NE.1) THEN
            WRITE (MSGTXT,1010) SYSERR
            CALL MSGWRT (6)
            IERR = 1
            END IF
         END IF
      IF (IERR.NE.0) THEN
         LELFIL = 0
      ELSE
         SYSERR = 0
         END IF
C                                       Fortran close to printer
      IF (LELFIL .GT. 0)
     *   CLOSE (UNIT=LUN, DISP='PRINT/DELETE', IOSTAT=SYSERR)
      IF (LELFIL .EQ. 0)
     *   CLOSE (UNIT=LUN, DISP='PRINT', IOSTAT=SYSERR)
      IF (LELFIL .LT. 0)
     *   CLOSE (UNIT=LUN, DISP='SAVE', IOSTAT=SYSERR)
      IF (SYSERR.NE.0) IERR = 2
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZLASCL: NO GROUP LOGICAL NAME ''LASQUE''. IERR=',I8)
 1010 FORMAT ('ZLASCL: COULD NOT ASSIGN LOGICAL NAME, IERR=',I8)
      END

      SUBROUTINE CCMINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   ICCRNO, CCKOLS, CCNUMV, NUMCOL, IERR)
C-----------------------------------------------------------------------
C! Create/open/init I/O to CC model table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2006, 2011, 2020-2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes component model (CC) extension tables.
C   Inputs:
C      OPCODE  C*4      Operation code:
C                       'WRIT' = create/init for write or read
C                       'READ' = open for read only
C      BUFFER  I(512)   I/O buffer and related storage, also defines
C                       file if open.
C      DISK    I        Disk to use.
C      CNO     I        Catalog slot number
C      VER     I        CC file version
C      CATBLK  I(256)   Catalog header block.
C      LUN     I        Logical unit number to use
C   Input/output
C-----------------------------------------------------------------------
C     NUMCOL  I         Number of columns, 3,4 => point components only
C                          4,8 -> z column, 3,7 -> no Z column
C   Output:
C      ICCRNO  I        Next scan number, start of the file if 'READ',
C                       the last+1 if WRITE
C      CCKOLS  I(MAXCCC) The column pointer array in order, Flux, X, Y
C                        (and if NUMCOL>3) Major, Minor, PA, type.
C      CCNUMV  I(MAXCCC) Element count in each column.
C      IERR    I        Return error code, 0=>OK, else TABINI or TABIO
C                       error.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, ICCRNO,
     *   CCKOLS(MAXCCC), CCNUMV(MAXCCC), NUMCOL, IERR
C
      HOLLERITH HOLTMP(6)
      CHARACTER TTITLE*56, TITLE(MAXCCC)*24, UNITS(MAXCCC)*8
      INTEGER   NKEY, NREC, DATP(128,2), NCOL, NTT, DTYP(MAXCCC), NDATA,
     *   I, JERR, NC, ITRIM, IPOINT, J, ITEMP(6)
      LOGICAL   T, F, DOREAD, NEWFIL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (HOLTMP, ITEMP)
      DATA T, F /.TRUE.,.FALSE./
      DATA NTT /56/
      DATA TTITLE /'AIPS CC CLEAN COMPONENTS TABLE'/
      DATA NDATA /MAXCCC/
      DATA DTYP /MAXCCC*12/
      DATA TITLE /'FLUX', 'DELTAX', 'DELTAY', 'DELTAZ', 'MAJOR AX',
     *   'MINOR AX', 'POSANGLE', 'TYPE OBJ'/
      DATA UNITS /'JY', 6*'DEGREES ', 'CODE'/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NREC = 500
      NCOL = MAX (MIN (NUMCOL, MAXCCC), 3)
      IF (DOREAD) NCOL = 0
      NKEY = 0
      NEWFIL = F
C                                       Fill in types
      CALL COPY (NDATA, DTYP, DATP(1,2))
C                                       Create/open file
      CALL TABINI (OPCODE, 'CC', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'CCMINI', IERR)
         GO TO 990
         END IF
      NUMCOL = NCOL
      NKEY = 0
C                                       See if file exists.
      IF (IERR.LT.0) THEN
         NEWFIL = T
C                                       File created, initialize
         I = 0
         DO 40 J = 1,NCOL
            I = I + 1
            IF ((NCOL.EQ.7) .AND. (I.EQ.4)) I = I + 1
C                                       Col. labels.
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, J, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'CCMINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, J, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'CCMINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
         END IF
C                                       Get number of components
      ICCRNO = BUFFER(5)
      ICCRNO = ICCRNO + 1
      IF (DOREAD) ICCRNO = 1
C                                      Get array indices
C                                      Cover your ass from FNDCOL -
C                                      close to flush the buffers and
C                                      then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, BUFFER, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'CCMINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'CC', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'CCMINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (MAXCCC, TITLE, 24, T, BUFFER, CCKOLS, JERR)
C                                      Get array indices and no. values
      DO 150 I = 1,NDATA
         MSGTXT = ' '
         IPOINT = CCKOLS(I)
         IF (IPOINT.GT.0) THEN
            CCKOLS(I) = DATP(IPOINT,1)
            CCNUMV(I) = DATP(IPOINT,2) / 10
            IF (CCNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               END IF
         ELSE
            CCKOLS(I) = -1
            CCNUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            END IF
         IF (MSGTXT.NE.' ') THEN
            IF ((I.LE.3) .OR. (NCOL.EQ.8)) THEN
               CALL MSGWRT (6)
            ELSE IF ((NCOL.EQ.7) .AND. (I.NE.4)) THEN
               CALL MSGWRT (6)
               END IF
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('CCMINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('CCMINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('CCMINI: ERROR INITIALIZING CLEAN COMPONENTS TABLE FOR ',
     *   A4)
      END

      SUBROUTINE GETANT (DISK, CNO, SUBA, CATBLK, BUFFER, IERR)
C-----------------------------------------------------------------------
C! Reads AN table and stores the info in common.
C# EXT-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2001, 2003, 2007, 2009, 2011-2012, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GETANT reads an antennas (AN) extension file and saves the
C   information in a common in DANS.INC.
C   The antenna latitude and longitude are strictly correct only for
C   the VLA and VLBI.  For other arrays the value returned will
C   be the value at the array center. (note: VLBI means here that the
C   antenna locations are given in an earth centered system.  Also the
C   handedness of the system is opposite the array centered scheme.)
C   NOTE: Uses AIPS LUN 40 for read the antenna file.
C   Inputs:
C      DISK     I        Volume number
C      CNO      I        Catalog slot number
C      SUBA     I        Subarray number (AN version number)
C      CATBLK   I(256)   Catalog header block
C   Outputs sent to COMMON (DANS.INC):
C      NSTNS    I        Maximum antenna number
C      STNNAM   C(*)*8   Antenna names
C      TELNO    I(*)     Antenna number: TELNO(i) = i
C      STNX     D(*)     X (meters)
C      STNY     D(*)     Y (meters)
C      STNZ     D(*)     Z (meters)
C      STNLAT   D(*)     Antenna latitude (rad).
C      STNLON   D(*)     Antenna east longitude (rad).
C      STNRAD   D(*)     Antenna radius from earth center (meter)
C      STNEPL   R(2,*)   Feed real/elipticity (poln, IF)
C      STNORI   R(2,*)   Feed imag/orientation (poln, IF)
C      STNPST   C*8      Feed solution type:
C                           'APPROX  ' => linear approximation
C                           'ORI-ELP ' => orientation-ellipticity
C      TIMLAB   C*8      Time system label (e.g. 'IAT', 'UTC')
C      ANTUTC   R        UT1-UTC (time sec)
C      ANTIAT   R        Data time - UTC (sec)
C      GSTIAT   D        GST (rad) at IAT=0 on reference date.
C      ROTIAT   D        Rotation rate of the earth in IAT (Radians/day)
C      ANTUTC   R        UT1-UTC (time sec)
C      ANTIAT   R        Data time - UTC (sec)
C      FQIDAN   I        FQID for which polzn properties determined.
C   Output:
C     BUFFER    I(*)     I/O buffer
C     IERR      I        Error code: 0=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, SUBA, CATBLK(256), BUFFER(*), IERR
C
      CHARACTER CHSOLT*8, CHELP*8
      INTEGER   IVER, LUN, LOOP, NIF, IANT, LOCS, KEYTYP, JERR, NR, I
      LOGICAL   DOELP
      DOUBLE PRECISION X, Y, Z, RHO, ARRLON
      HOLLERITH HSTNPS(2)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA CHSOLT, CHELP /'POLTYPE ','ORI-ELP'/
      DATA LUN /40/
C-----------------------------------------------------------------------
C                                       init the values
      NSTNS = 0
      FQIDAN = 0
      ANTIAT = 0.0
      ANTUTC = 0.0
      POLARX = 0.0
      POLARY = 0.0
      STNPST = ' '
      TIMLAB = ' '
      CNTRX = 0.0D0
      CNTRY = 0.0D0
      CNTRZ = 0.0D0
      GSTIAT = 0.0D0
      ROTIAT = 0.0D0
      DO 10 I = 1,MAXANT
         TELNO(I) = I
         MNTYP(I) = 0
         ANDIAM(I) = 0.0
         CALL RFILL (MAXIF, 0.0, ANFWHM(1,I))
         CALL RFILL (2*MAXIF, 0.0, STNELP(1,1,I))
         STNNAM(I) = ' '
         STNX(I) = 0.0D0
         STNY(I) = 0.0D0
         STNZ(I) = 0.0D0
         STNLAT(I) = 0.0D0
         STNLON(I) = 0.0D0
         STNRAD(I) = 0.0D0
 10      CONTINUE
C                                      Open AN extension file.
      IVER = SUBA
      IERR = 0
      CALL ANTINI ('READ', BUFFER, DISK, CNO, IVER, CATBLK, LUN, IANRNO,
     *   ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE, POLRXY,
     *   UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB, NOPCAL,
     *   ANTNIF, ANFQID, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
      NR = BUFFER(5)
      NSTNS = 0
C                                       Get polarization solution type.
      STNPST = ' '
      MSGSUP = 32000
      CALL TABKEY ('READ', CHSOLT, 1, BUFFER, LOCS, HSTNPS, KEYTYP,
     *   JERR)
      MSGSUP = 0
      IF (JERR.EQ.0) CALL H2CHR (8, 1, HSTNPS, STNPST)
      DOELP = STNPST.EQ.CHELP
      CNTRX = ARRAYC(1)
      CNTRY = ARRAYC(2)
      CNTRZ = ARRAYC(3)
      GSTIAT = GSTIA0 * DG2RAD
      ROTIAT = DEGPDY * DG2RAD
      TIMLAB = TIMSYS
      ANTUTC = UT1UTC
      ANTIAT = DATUTC
      POLARX = POLRXY(1)
      POLARY = POLRXY(2)
      FQIDAN = ANFQID
C                                      Read AN records
      DO 200 IANT = 1,NR
         IANRNO = IANT
         CALL TABAN ('READ', BUFFER, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *      STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *      POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR
            GO TO 990
            END IF
C                                       Skip records with
C                                       zero station numbers
         IF ((NOSTA.LE.0) .OR. (NOSTA.GT.MAXANT)) THEN
            WRITE (MSGTXT,1120) NOSTA, IANT, IVER
            CALL MSGWRT (6)
            GO TO 200
            END IF
C
         NSTNS = MAX (NSTNS, NOSTA)
         STNNAM(NOSTA) = ANNAME
         TELNO(NOSTA)  = NOSTA
         ANDIAM(NOSTA) = DIAMAN
         STNX(NOSTA)   = STAXYZ(1)
         STNY(NOSTA)   = STAXYZ(2)
         STNZ(NOSTA)   = STAXYZ(3)
         IF ((STAXYZ(1).EQ.0.0) .AND. (STAXYZ(2).EQ.0.0))
     *      STNY(NOSTA) = 1.0D0
         IF (STAXYZ(3).EQ.0.0) STNZ(NOSTA) = 1.0D0
C                                       X => (lat 0, long 0)
C                                       Y => (lat 0, long 90E)
C                                       Z => (lat 90)
C                                       Get antenna latitude and
C                                       east longitude.
         X = CNTRX
         Y = CNTRY
         Z = CNTRZ
         IF ((ABS(X).GT.1.D2) .AND. (ABS(Y).GT.1.D2) .AND.
     *      (ABS(Z).GT.1.D2)) THEN
            ARRLON = ATAN2 (Y, X)
            X = X + STAXYZ(1)*COS (ARRLON) - STAXYZ(2)*SIN (ARRLON)
            Y = Y + STAXYZ(2)*COS (ARRLON) + STAXYZ(1)*SIN (ARRLON)
            Z = Z + STAXYZ(3)
         ELSE
            X = X + STAXYZ(1)
            Y = Y + STAXYZ(2)
            Z = Z + STAXYZ(3)
            END IF
         RHO = SQRT (X*X + Y*Y + Z*Z)
         STNLAT(NOSTA) = 0.0D0
         STNLON(NOSTA) = 0.0D0
         STELEV(NOSTA) = 0.0
C                                       get geodetic latitude
         IF ((X.NE.0.D0) .OR. (Y.NE.0.0D0)) CALL XYZ2LL (X, Y, Z,
     *      STNLON(NOSTA), STNLAT(NOSTA), STELEV(NOSTA))
         STNRAD(NOSTA) = RHO
         MNTYP(NOSTA) = MNTSTA
C                                       Feed polarizations, FWHM
         LOOP = -1
         DO 180 NIF = 1,ANTNIF
            LOOP = LOOP + 2
            ANFWHM(NIF,NOSTA) = FWHMAN(NIF)
            STNELP(1,NIF,NOSTA) = POLCA(LOOP)
            STNORI(1,NIF,NOSTA) = POLCA(LOOP+1)
            STNELP(2,NIF,NOSTA) = POLCB(LOOP)
            STNORI(2,NIF,NOSTA) = POLCB(LOOP+1)
C                                       Default circular poln
            IF ((ABS (POLCA(LOOP)).LT.1.0E-10) .AND. DOELP) THEN
               STNELP(1,NIF,NOSTA) =  0.785398164
               STNELP(2,NIF,NOSTA) = -0.785398164
               STNORI(1,NIF,NOSTA) = 0.0
               STNORI(2,NIF,NOSTA) = 0.0
               END IF
 180        CONTINUE
 200     CONTINUE
C                                      Close AN extension file
      CALL TABIO ('CLOS', 1, IANRNO, BUFFER, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1200) IERR
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETANT: ERROR',I3,' OPEN-FOR-READ AN FILE')
 1100 FORMAT ('GETANT: ERROR',I3,' READING AN FILE')
 1120 FORMAT ('GETANT: STATION NUMBER',I6,' FOR ENTRY=',I4,' SUBA=',I3)
 1200 FORMAT ('GETANT: ERROR',I3,' CLOSING AN FILE')
      END

      SUBROUTINE FNDSPX (DISK, CNO, SRC, FREQID, CATBLK, NTERM, SPIX,
     *   IERR)
C-----------------------------------------------------------------------
C! find spectral index of a source from SU table
C# UV Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 2013-2014, 2017
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FNDSPC fits the spectral index of the specified source to the fluxes
C   in the source table.
C   Finds the source info into DSOU.INC and the freq info
C   Requires UVPGET to have been called.
C   Inputs:
C      DISK     I      Disk number
C      CNO      I      Catalog number
C      SRC      I      Source number
C      FREQID   I      Freq ID number
C      CATBLK   I(*)   header
C      NTERM    I      =2 => return curvature in SPIX(3)
C   Outputs:
C      SPIX     R(3)   Spectral index: (1) Flux at 1 GHz
C                         (2) spectral index
C                         (3) curvature (wrt 1 GHz) or zero
C      IERR     I      Error code: 0 okay, 1 no answer, 2 IO troubles,
C                      3 input troubles
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, SRC, FREQID, CATBLK(256), NTERM, IERR
      REAL      SPIX(*)
C
      INCLUDE 'INCS:DCHND.INC'
      INTEGER   IRET, LUN, LUNTMP, JIF, NIF, TABUFF(512), VER, I,
     *   CATI(256)
      DOUBLE PRECISION REFREQ, CATD(128), X(MAXIF), Y(MAXIF), BFIT(6),
     *   SX, SY, SXX, SXY, SX3, SX4, SXXY, DEN
      REAL      CATR(256)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (CATI, CATD, CATR)
C-----------------------------------------------------------------------
      IERR = 2
      SPIX(1) = 0.0
      SPIX(2) = 0.0
      IF (NTERM.EQ.2) SPIX(3) = 0.0
      LUN = LUNTMP (1)
C                                       find source
      CALL GETSOU (SRC, DISK, CNO, CATBLK, LUN, IRET)
      IF (IRET.EQ.11) THEN
         IERR = 3
         MSGTXT = 'CANNOT FIND SPECIFIED SOURCE IN SU TABLE'
         GO TO 990
      ELSE IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FINDING SOURCE IN SU TABLE'
         GO TO 990
         END IF
C                                       count valid fluxes
      NIF = 0
      DO 10 JIF = 1,MAXIF
         IF ((FLUX(1,JIF).GT.0.0) .AND. (FLUX(1,JIF).NE.FBLANK)) THEN
            NIF = NIF + 1
            END IF
 10      CONTINUE
 20   JIF = NIF
C                                       get frequencies
      CALL FNDEXT ('FQ', CATBLK, VER)
      JIF = NIF
      FQCHND = FREQID
      CALL CHNDAT ('READ', TABUFF, DISK, CNO, VER, CATBLK, LUN, NIF,
     *   FOFF, ISBAND, FINC, BNDCOD, FQCHND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING FREQUENCY TABLE'
         GO TO 990
         END IF
      IF ((JIF.LT.2) .OR. (NIF.LT.2)) THEN
         IERR = 1
         MSGTXT = 'NOT ENOUGH FLUXES IN SU TABLE TO FIT SPECTRAL INDEX'
         GO TO 990
         END IF
C                                       values
      CALL COPY (256, CATBLK, CATI)
      REFREQ = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *   (CATI(KINAX+JLOCF)/2.0 - CATR(KRCRP+JLOCF))
      JIF = 0
      SX = 0.0D0
      SY = 0.0D0
      SXX = 0.0D0
      SXY = 0.0D0
      SX3 = 0.0D0
      SX4 = 0.0D0
      SXXY = 0.0D0
      DO 50 I = 1,NIF
         IF ((FLUX(1,I).NE.0.0) .AND. (FLUX(1,I).NE.FBLANK)) THEN
            JIF = JIF + 1
            Y(JIF) = LOG10 (FLUX(1,I))
            X(JIF) = LOG10 (REFREQ+FOFF(I)) - 9.0D0
            SX  = SX  + X(JIF)
            SXX = SXX + X(JIF)*X(JIF)
            SY  = SY  + Y(JIF)
            SXY = SXY + X(JIF)*Y(JIF)
            SX3 = SX3 + X(JIF)*X(JIF)*X(JIF)
            SX4 = SX4 + X(JIF)*X(JIF)*X(JIF)*X(JIF)
            SXXY = SXXY + X(JIF)*X(JIF)*Y(JIF)
            END IF
 50      CONTINUE
C                                       curvature
      IF (NTERM.EQ.2) THEN
         DEN = SX * SX - JIF * SXX
         IF ((JIF.EQ.2) .AND. (DEN.NE.0.0D0)) THEN
            BFIT(1) = (SX * SXY - SXX * SY) / DEN
            BFIT(2) = (SX * SY - JIF * SXY) / DEN
            BFIT(3) = 0.0D0
         ELSE IF (JIF.GE.3) THEN
            DEN = (SX*SXX-JIF*SX3) * (SXX*SX3-SX*SX4) -
     *         (SXX*SXX-JIF*SX4) * (SXX*SXX-SX*SX3)
            BFIT(1) = ((SXX*SXY-SX3*SY) * (SXX*SX3-SX*SX4) -
     *         (SXX*SXXY-SX4*SY) * (SXX*SXX-SX*SX3)) / DEN
            BFIT(2) = ((SXX*SXXY-SX4*SY) * (SX*SXX-JIF*SX3) -
     *         (SXX*SXY-SX3*SY) * (SXX*SXX-JIF*SX4)) / DEN
            BFIT(3) = ((SX*SY-JIF*SXY) * (SXX*SX-JIF*SX3) -
     *         (SXX*SY-JIF*SXXY) * (SX*SX-JIF*SXX)) /
     *         ((SX*SXX-JIF*SX3) * (SXX*SX-JIF*SX3) -
     *         (SX*SX-JIF*SXX) * (SXX*SXX-JIF*SX4))
         ELSE
            GO TO 990
            END IF
         IERR = 0
         SPIX(1) = 10.D0 ** BFIT(1)
         SPIX(2) = BFIT(2)
         SPIX(3) = BFIT(3)
         WRITE (MSGTXT,1050) SPIX(1), BFIT(2), BFIT(3), SRC
         CALL MSGWRT (3)
C                                       simple spectral index
      ELSE
         DEN = SX * SX - JIF * SXX
         IF ((JIF.GE.2) .AND. (DEN.NE.0.0D0)) THEN
            BFIT(1) = (SX * SXY - SXX * SY) / DEN
            BFIT(2) = (SX * SY - JIF * SXY) / DEN
         ELSE
            GO TO 990
            END IF
         IERR = 0
         SPIX(1) = 10.0D0 ** BFIT(1)
         SPIX(2) = BFIT(2)
         WRITE (MSGTXT,1060) SPIX(1), BFIT(2), SRC
         CALL MSGWRT (3)
         END IF
      GO TO 999
C
 990  MSGTXT = 'TOO LITTLE DATA FOR SPECTRAL FIT OR SINGULAR'
      IERR = 1
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FNDSPX: ERROR',I4,' ON ',A)
 1050 FORMAT ('FNDSPX: F1 spix spcurv',F8.3,2F8.4,' for source',I5)
 1060 FORMAT ('FNDSPX: flux 1GHz & spectral index',2F7.3,
     *   ' for source',I5)
      END

LOCAL INCLUDE 'QMSPL.INC'
      REAL   SEQIN, DSKIN, VERSN, ASPMM, COPIES, XXPEN, DPARM(10),
     *   TRANFN(6), SCALEX, SCALEY, AMASK(256), RNRAND
      HOLLERITH XNAMIN(3), XCLSIN(2), XOUTFL(12), XOPTYP, XTRANF(6)
      CHARACTER NAMIN*12, CLSIN*6, OUTFIL*48, OPTYPE*4, CTRANF*2,
     *   QMBUFF*80
      INTEGER GOPR, ITRN, QMPOS, QMSIZE, IXL, IYL, IX0, IY0, MAXXQM(2),
     *   MXD, MYD, MRAND(100), NRAND, PRAND, QRAND, JRAND
      COMMON /INPARM/ XNAMIN, XCLSIN, SEQIN, DSKIN, VERSN, ASPMM,
     *   COPIES, XXPEN, XOUTFL, XOPTYP, XTRANF, DPARM, TRANFN, GOPR,
     *   ITRN
      COMMON /CHPARM/ NAMIN, CLSIN, OUTFIL, OPTYPE, CTRANF
C                                       Important NOTE:
C                                       The variables in QMSPL are NOT
C                                       what they appear, DPARM here
C                                       starts with AIPS DPARM(3);
C                                       TRANFN includes several adverbs
C                                       plus the first two words of
C                                       DPARM.
      COMMON /QMSPCL/ QMPOS, QMSIZE, IXL, IYL, IX0, IY0,
     *   SCALEX, SCALEY, MAXXQM, MXD, MYD, AMASK
      COMMON /QMSPCH/ QMBUFF
      COMMON /RANDMM/ RNRAND, MRAND, NRAND, PRAND, QRAND, JRAND
LOCAL END
      PROGRAM QMSPL
C-----------------------------------------------------------------------
C! Task to pass plot (PL) files to a QMS printer
C# Plot-appl Plot-util Printer
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2009, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   QMSPL is a program for the AIPS graphics package.  The program runs
C   as a detached task initiated from AIPS.  First a cataloged file is
C   found using data passed from AIPS.  The list of associated files is
C   searched for a PLot file corresponding to the version number.  The
C   graphics commands are converted to character strings appropriate to
C   the QMS device and written to a file which "prints" at the end.
C   Inputs:  (from AIPS)
C      INNAME  R(3)   Name of primary file.
C      INCLASS R(2)   Class of primary file.
C      INSEQ   R      Sequence number of primary file.
C      INDISK  R      Disk volume number. 0 means try all.
C      INVERS  R      Extension file version number. 0 ->
C                     use the highest version number.
C      ASPMM   R      Arc sec per millimeter. 0 -> self scale.
C      COPIES  R      Number of copies desired.
C      LPEN    R      Pen width in dots.  0 => 3.
C      OUTFILE R(12)   output file name
C      OPTYPE  R      'NONE' ignore grey scale commands
C                     'MBIT' use sine pattern to build a font
C                     'BITS' use sine pattern to determine each dot
C                     'QRAN' use random numbers to build character font
C                     'MRAN' use 78 levels nots 26
C                     'RAND' use random numbers to determine each dot
C      FUNCTYPE  R    Convert after clipping by 'NE' negative linear,
C                     'LG' log, 'NG' negative log, 'PL' power law,
C                     'NL' negative power law.
C      FACTOR  R      Power law index for use with 'PL' or 'NL'
C                     FUNCTYPE's.
C      AXVAL   R(2)   Inflection point for transition from 1/FACTOR
C                     to FACTOR power law (0,0) => only use FACTOR
C      DPARM  R(10)   (1,2) Min, max clipping range 0 <= min<max <= 1.
C                           before FUNCTYPE, then
C                     (3,4) rescale g = DPARM(3)*g + DPARM(4) and
C                           clip again to 0 to 1.
C                  Parms for BIT opcodes only:
C                     (5) <=0 -> ignore rest of DPARM, use Gaus
C                         1 -> Use DPARM for Gaussian 'BIT ' mask
C                         2 -> ignore rest of DPARM, use Sine
C                         3 -> Use DPARM for Sine wave 'BIT ' mask
C                     (6) width of mask (dots)
C                     (7) width of Gaussian, sine 0 => 1
C                     (8) x-shift of Gaus/sin in mask
C                     (9) y-shift of Gaus/sin in mask
C   Note: the adverbs are declared internally somewhat differently.
C   FACTOR, AXVAL -> TRANFN(2-4)
C   DPARM(1,2) -> TRANFN(5,6) and DPARM(3,10) -> DPARM(1,8).  The other
C   two positions in DPARM are declared however and used internally.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   BUFFER(256), LUN, FIND, IRET, IERR
      LOGICAL   QUICK
      INCLUDE 'QMSPL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGNAM /'QMSPL '/
      DATA LUN /26/
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL QMSINI (PRGNAM, LUN, FIND, QUICK, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Write to Tektronix 4012.
      CALL QMSDRW (LUN, FIND, IRET)
      IF (IRET.EQ.0) GO TO 990
         WRITE (MSGTXT,1000)
         CALL MSGWRT (8)
         GO TO 990
C                                       Close graph file.
 990  CALL ZCLOSE (LUN, FIND, IERR)
 995  CALL DIETSK (IRET, QUICK, BUFFER)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR WRITING TO QMS DEVICE')
      END
      SUBROUTINE QMSINI (PRGNAM, LUN, FIND, QUICK, BUFFER, IRET)
C-----------------------------------------------------------------------
C   QMSINI does the initialization for QMSPL, getting parameters,
C   locating the Plot file, and opening it.
C   Inputs: PRGNAM   C*6)     Task name
C           LUN      I        LUN to use for plot file
C   Output: FIND     I        FTAB pointer for plot file
C           QUICK    L        Quick return desired or not.
C           BUFFER   I(256)   Plot buffer
C           IRET     I        Error code: not 0 => quit.
C-----------------------------------------------------------------------
      CHARACTER  TYPIN*2, STATUS*4, PRGNAM*6, GFILE*48, OKOPS(6)*4,
     *    OKTRN(5)*2
      INTEGER  LUN, FIND, IRET, BUFFER(256), CATERR, IERR, NPARMS,
     *   SLOT, IVER, I, IVOL, ISEQ, USER, NOPS, NTRN, IROUND
      LOGICAL   NOMAP, QUICK, NOEXCL, WAIT, EQUAL
      INCLUDE 'QMSPL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA NOPS, OKOPS /6, 'NONE','MBIT','BITS','QRAN','MRAN','RAND'/
      DATA NTRN, OKTRN /5, 'NE','LG','NG','PL','NL'/
      DATA NOMAP, NOEXCL, WAIT /.FALSE.,.FALSE.,.TRUE./
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE., BUFFER)
      CALL VHDRIN
C                                       Get input values from AIPS.
      NPARMS = 38
      CALL GTPARM (PRGNAM, NPARMS, QUICK, XNAMIN, BUFFER, IRET)
      IF (IRET.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (8)
 10   IF (QUICK) CALL RELPOP (IRET, BUFFER, IERR)
      IF (IRET.NE.0) GO TO 999
C                                       Set DPARMs not set by GTPARM
      DPARM(9) = 1.
      DPARM(10) = 1.
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
      CALL H2CHR (48, 1, XOUTFL, OUTFIL)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      CALL H2CHR (2, 1, XTRANF(1), CTRANF)
      DO 12 I = 1, 6
         TRANFN(I) = XTRANF(I)
 12      CONTINUE
C                                       Clip power law, inflec. point
      IF ((TRANFN(2).LT.0.001) .OR. (TRANFN(2).GT.999.)) TRANFN(2) = 1.0
      IF ((TRANFN(3).GE.0.001) .AND. (TRANFN(3).LE.0.999) .AND.
     *   (TRANFN(4).GE.0.001) .AND. (TRANFN(4).LE.0.999)) GO TO 15
         TRANFN(3) = 0.5
         TRANFN(4) = 0.5
C                                       Get OPcode for grey conversion
 15   GOPR = 0
      DO 20 I = 1,NOPS
         IF (OPTYPE.EQ.OKOPS(I)) GOPR = I
 20      CONTINUE
      IF (GOPR.EQ.0) GOPR = 2
C                                       Transfer function: type, clips
      ITRN = 0
      DO 25 I = 1,NTRN
         EQUAL = OKTRN(I) .EQ. CTRANF
         IF (EQUAL) ITRN = I
 25      CONTINUE
      ITRN = ITRN + 1
      IF ((TRANFN(5).LE.0.0) .OR. (TRANFN(5).GE.0.999)) TRANFN(5) = 0.0
      IF ((TRANFN(6).GT.1.0) .OR. (TRANFN(6).LE.TRANFN(5))) TRANFN(6) =
     *   1.0
      IF ((DPARM(1).LE.0.01) .OR. (DPARM(1).GE.100.)) DPARM(1) = 1.0
      IF (ABS(DPARM(2)).GT.0.9) DPARM(2) = 0.0
C                                       Get map header.
      ISEQ = IROUND (SEQIN)
      IVOL = IROUND (DSKIN)
      USER = NLUSER
      IVER = IROUND (VERSN)
      SLOT = 1
      TYPIN = ' '
      CALL CATDIR ('SRCH', IVOL, SLOT, NAMIN, CLSIN, ISEQ, TYPIN, USER,
     *   STATUS, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 995
         END IF
C                                       Read catalog header.
      CALL CATIO ('READ', IVOL, SLOT, CATBLK, 'REST', BUFFER, CATERR)
      IF ((CATERR.EQ.0) .OR. (CATERR.EQ.6)) GO TO 50
 45      WRITE (MSGTXT,1045) CATERR
         GO TO 995
C                                        Find plot file:
C                                        if PL & IVER=0, then main file
 50   EQUAL = TYPIN .EQ. 'PL'
      IF ((EQUAL) .AND. (CATERR.EQ.6)) GO TO 45
      IF ((EQUAL) .AND. (IVER.EQ.0)) IVER = CATBLK(KIIMS)
C                                        else take IVER as given or
C                                        as max version #
      IF (IVER.LE.0) CALL FNDEXT ('PL', CATBLK, IVER)
C                                       PLot file not found.
      IF (IVER.LE.0) THEN
         WRITE (MSGTXT,1060)
         GO TO 995
         END IF
C                                       Save parms
      SEQIN = ISEQ
      DSKIN = IVOL
      VERSN = IVER
C                                       Build file name.
      CALL ZPHFIL ('PL', IVOL, SLOT, IVER, GFILE, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Open graphics file.
      CALL ZOPEN (LUN, FIND, IVOL, GFILE, NOMAP, NOEXCL, WAIT, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1070)
         GO TO 995
C                                       Error
 995  CALL MSGWRT (8)
      IF (IRET.EQ.0) IRET = 4
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('COULD NOT GET INPUTS FROM AIPS. GTPARM ERR =',I5)
 1020 FORMAT ('CATALOG ENTRY NOT FOUND. CATDIR ERR =',I5)
 1045 FORMAT ('ERROR READING CATALOG HEADER. CATIO ERR =',I5)
 1060 FORMAT ('PLOT FILE NOT IN CATALOG')
 1070 FORMAT ('PLOT FILE NOT FOUND')
      END
      SUBROUTINE QMSDRW (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C   This routine will execute the commands in a graph file for the
C   QMS.
C   INPUTS:  LUN     I   logical unit number of an open graph file.
C            FIND    I   pointer to the FTAB info of the graph file.
C            BUFFER   I(256)   buffer to use for I/O.
C            IERR    I   error code. 0 = ok.
C-----------------------------------------------------------------------
      CHARACTER CHBUF*200, OPTELL*4, CHLAND(2)*1
      REAL   DX, DY, SCALEF, X, XYRATO, Y, RX1, RX2, TOTPIX, VALUE, RY1,
     *   RY2, AX, AY, XPXSEP, YPXSEP, YQMDMM, UASPMM, XYDIFF, YASPMM,
     *   DELTA, XQMDMM, RCALEX, RCALEY, GRSCAL, GROFF, NOWPIX, TEMPV,
     *   DUMMY
      INTEGER   ITYPE, BUFFER(256), QY, LXA, FIND, GRYERR, CSIZQM(2),
     *   NNCHAR, LYA, IANGL, ICHB, ICHL, ICHR, ICHT, IERR, INCRRN,
     *   IOPOS, IX, IX1, IY, IY1, LUN, NXA, NYA, OPCODE, QMSLUN, I,
     *   IERRC, IX2, IY2, NCHAR, IROUND, LLPEN, IGRLO, IGRHI, NPTSX,
     *   NPTSY, NXDPP, NYDPP, IPER, IPER2, N, ICNT, NPIX, IERRCH, ILAND,
     *   SCRTCH(256), IORRN
      LOGICAL   DOLAND, DOGREY, T
      HOLLERITH HBUFFR(256)
      INCLUDE 'QMSPL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (HBUFFR, BUFFER)
      DATA QMSLUN, T /7, .TRUE./
      DATA CHLAND /'P','L'/
C-----------------------------------------------------------------------
C                                       Initialize all values.
      MAXXQM(1) = 10. * 300
      MAXXQM(2) = 7.5 * 300
      CSIZQM(1) = 33
      CSIZQM(2) = 50
      XQMDMM = 11.81
C                                       Assume symetric device for now.
      YQMDMM = XQMDMM
      IERR = 0
      IERRC = 0
      IERRCH = 0
      GRYERR = 0
      DOGREY = .FALSE.
      IOPOS = 9999
      ICNT = 0
      QMPOS = 0
      QMSIZE = 80
      QMBUFF = ' '
C                                       Open QMS file
      CALL ZLASIO ('OPEN', QMSLUN, OUTFIL, NNCHAR, QMBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       determine where plot starts
      CALL ZFIO ('READ', LUN, FIND, 1, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 980
      IORRN = (BUFFER(10) + 9) / 256 + 1
C                                       next plot command
C                                       Read record.
 50   IF (IOPOS.LE.256) GO TO 60
 55      IORRN = IORRN + 1
         CALL ZFIO ('READ', LUN, FIND, IORRN, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 980
         IOPOS = 1
C                                       Transfer based on opcode.
 60   IF (ICNT.GT.0) GO TO 65
         CALL GTTELL (0, OPTELL, DUMMY, SCRTCH, IERR)
         IF (IERR.LE.1) GO TO 65
            WRITE (MSGTXT,1060) OPTELL
            CALL MSGWRT (4)
            IF (IERR.EQ.2) GO TO 990
            GO TO 993
 65   ICNT = ICNT + 1
      IF (ICNT.GE.200) ICNT = 0
      OPCODE = BUFFER(IOPOS)
      IF ((OPCODE.GT.0) .AND. (OPCODE.LE.8)) GO TO (100, 200,
     *   300, 400, 500, 600, 700, 800), OPCODE
      IF (OPCODE.EQ.0) GO TO 55
C                                       End of file.
      IF (OPCODE.NE.32767) GO TO 970
         GO TO 990
C                                       Opcode 1, initialize.
C                                       Put map type in image header.
 100  ITYPE = BUFFER(IOPOS+5)
      IOPOS = IOPOS + 6
      GO TO 50
C                                       Opcode 2, line drawing init.
 200  XYRATO = BUFFER(IOPOS+1) / 100.0
      SCALEF = BUFFER(IOPOS+2)
      IX1    = BUFFER(IOPOS+3)
      IY1    = BUFFER(IOPOS+4)
      IX2    = BUFFER(IOPOS+5)
      IY2    = BUFFER(IOPOS+6)
      RX1    = BUFFER(IOPOS+7)/1000.0 + IX1
      RY1    = BUFFER(IOPOS+8)/1000.0 + IY1
      RX2    = BUFFER(IOPOS+9)/1000.0 + IX2
      RY2    = BUFFER(IOPOS+10)/1000.0 + IY2
      ICHL   = (BUFFER(IOPOS+11)/10.0) * CSIZQM(1)  +  0.5
      ICHB   = (BUFFER(IOPOS+12)/10.0) * CSIZQM(2)  +  0.5
      ICHR   = (BUFFER(IOPOS+13)/10.0) * CSIZQM(1)  +  0.5
      ICHT   = (BUFFER(IOPOS+14)/10.0) * CSIZQM(2) +  0.5
      IOPOS = IOPOS + 15
C                                       Find no. pixels inside border.
      NYA = MAXXQM(2) - ICHT - ICHB - 1
      NXA = MAXXQM(1) - ICHL - ICHR - 1
      LYA = MAXXQM(1) - ICHT - ICHB - 1
      LXA = MAXXQM(2) - ICHL - ICHR - 1
      IF ((NXA.GT.0) .AND. (NYA.GT.0)) GO TO 205
         WRITE (MSGTXT,1200) NXA, NYA
         CALL MSGWRT (7)
         GO TO 990
C                                       Compute scaling: sizes
 205  AX = ABS(IX2 - IX1) * XYRATO
      AY = ABS(IY2 - IY1)
      X = ABS(RX2-RX1) * XYRATO
      Y = ABS(RY2-RY1)
      IF ((X.GT.0) .AND. (Y.GT.0)) GO TO 210
         WRITE (MSGTXT,1205) X, Y
         CALL MSGWRT (7)
         GO TO 990
C                                       Factors: landscape mode
 210  IF ((X/Y).GT.FLOAT(NXA)/FLOAT(NYA)) GO TO 215
         SCALEY = NYA/SCALEF * AY/Y
         SCALEX = SCALEY * AX/AY
         GO TO 220
 215  CONTINUE
         SCALEX = NXA/SCALEF * AX/X
         SCALEY = SCALEX * AY/AX
C                                       Factors: portrait mode
 220  IF ((X/Y).GT.FLOAT(LXA)/FLOAT(LYA)) GO TO 223
         RCALEY = LYA/SCALEF * AY/Y
         RCALEX = RCALEY * AX/AY
         GO TO 225
 223  CONTINUE
         RCALEX = LXA/SCALEF * AX/X
         RCALEY = RCALEX * AY/AX
C                                       Use portrait
 225  DOLAND =  SCALEX*SCALEY.GE.RCALEX*RCALEY
      ILAND = 2
      IF (DOLAND) GO TO 230
         ILAND = 1
         SCALEX = RCALEX
         SCALEY = RCALEY
         I = MAXXQM(2)
         MAXXQM(2) = MAXXQM(1)
         MAXXQM(1) = I
C                                       Mm / arc sec scaling
 230  LOCNUM = 1
      AXTYP(LOCNUM) = 0
      UASPMM = ASPMM
      IF ((ITYPE.NE.2) .AND. (ITYPE.NE.3) .AND. (ITYPE.NE.6)) GO TO 235
         CALL SETLOC (BUFFER(IOPOS), T)
         IF (AXTYP(LOCNUM).NE.1) GO TO 235
            XPXSEP = AXINC(1,LOCNUM) * 3600.0 / XYRATO
C                                       odd: but XYRATO has AXINC(1)/(2)
            YPXSEP = XPXSEP
            CALL SCALMM (AX, AY, XPXSEP, YPXSEP, SCALEF, XQMDMM,
     *         YQMDMM, ASPMM, SCALEX, SCALEY)
            GO TO 240
C                                       Scale it down ?
 235  IF ((ASPMM.LE.0.02) .OR. (ASPMM.GT.0.98)) GO TO 240
         AXTYP(LOCNUM) = -10
         WRITE (MSGTXT,1235) ASPMM
         CALL MSGWRT (4)
         SCALEX = SCALEX * ASPMM
         SCALEY = SCALEY * ASPMM
C                                        Center
 240  NXA = SCALEX*SCALEF*X/AX + ICHL + ICHR
      IX0 = ICHL + MAX(0,MAXXQM(1)-NXA)/2 + 1
      NYA = SCALEY*SCALEF*Y/AY + ICHB + ICHT
      IY0 = ICHB + MAX(0,MAXXQM(2)-NYA)/2 + 1
      IOPOS = IOPOS + 5
      IF (BUFFER(IOPOS).NE.3) GO TO 350
      DOGREY = .TRUE.
C                                       Opcode 3, grey scale init.
 300  IF ((GOPR.GT.1) .AND. (DOGREY)) GO TO 305
         IOPOS = IOPOS + 5
         WRITE (MSGTXT,1300)
         IF (.NOT.DOGREY) CALL MSGWRT (7)
         DOGREY = .FALSE.
         GO TO 350
C                                       parms pick up
 305  IGRLO = BUFFER(IOPOS+1)
      IGRHI = BUFFER(IOPOS+2)
      NPTSX = BUFFER(IOPOS+3)
      NPTSY = BUFFER(IOPOS+4)
      IOPOS = IOPOS + 5
      IF ((IGRLO.LT.IGRHI) .AND. (NPTSX.GT.0) .AND. (NPTSY.GT.0)
     *   .AND. (NPTSX.LT.MAXXQM(1)-ICHL-ICHR)) GO TO 310
         WRITE (MSGTXT,1305) IGRLO, IGRHI, NPTSX, NPTSY
         CALL MSGWRT (7)
         DOGREY = .FALSE.
         GO TO 350
C                                       Change to RAND if small
 310  TOTPIX = REAL(NPTSX) * REAL(NPTSY)
      IF ((GOPR.EQ.3) .OR. (GOPR.EQ.6) .OR. (TOTPIX.GT.156)) GO TO 320
         WRITE (MSGTXT,1310)
         CALL MSGWRT (3)
         GOPR = 1
         DOGREY = .FALSE.
C                                       dots per pixel
 320  NXDPP = (NXA - ICHL - ICHR) * XYRATO / X  + 0.05
      NYDPP = (NYA - ICHT - ICHB) / Y  + 0.05
      IF (NXDPP*X/XYRATO.GT.MAXXQM(1)-ICHL-ICHR) NXDPP = NXDPP - 1
      IF (NYDPP*Y.GT.MAXXQM(2)-ICHB-ICHT) NYDPP = NYDPP - 1
C                                       Check for aspmm type
      IF ((AXTYP(LOCNUM).EQ.1) .AND. (AXINC(1,LOCNUM).NE.0.0)) THEN
         IF (ABS(ABS(XYRATO*AXINC(2,LOCNUM) /
     *      AXINC(1,LOCNUM))-1.0).LT.0.05) THEN
            IF (NXDPP.EQ.NYDPP-1) NYDPP = NXDPP
            IF (NXDPP.EQ.NXDPP-1) NXDPP = NYDPP
            END IF
         END IF
      CALL FIXDPP (GOPR, NXDPP, NYDPP, DPARM)
      NXDPP = MAX (1, NXDPP)
      NYDPP = MAX (1, NYDPP)
      IF ((NXDPP.GE.4) .AND. (NYDPP.GE.4)) GO TO 325
         IF (NXDPP*NYDPP.GE.10) GO TO 325
         IF ((GOPR.NE.2) .AND. (GOPR.NE.4) .AND. (GOPR.NE.5)) GO TO 325
            WRITE (MSGTXT,1320)
            IF (GOPR.EQ.2) WRITE (MSGTXT,1321)
            CALL MSGWRT (7)
            DOGREY = .FALSE.
            GOPR = 1
C                                       reset scales
 325  SCALEX = NXDPP * (AX / XYRATO) / SCALEF
      SCALEY = NYDPP * AY / SCALEF
      NXA = ICHL + ICHR + NXDPP * X / XYRATO
      NYA = ICHB + ICHT + NYDPP * Y
      IX0 = ICHL + MAX (0, MAXXQM(1) - NXA) / 2
      IY0 = ICHB + MAX (0, MAXXQM(2) - NYA) / 2
      GRSCAL = 0.998 / (REAL(IGRHI) - REAL(IGRLO))
      GROFF = IGRLO - 0.001 / GRSCAL + TRANFN(5) / GRSCAL
      GRSCAL = GRSCAL / (TRANFN(6) - TRANFN(5))
C                                       Offset for negative coords
 350  IX0 = IX0 - (RX1-IX1) * XYRATO * SCALEX * SCALEF / AX
      IY0 = IY0 - (RY1-IY1) * SCALEY * SCALEF / AY
C                                       Display arcsec / mm info
      IF (AXTYP(LOCNUM).NE.1) GO TO 370
         ASPMM = ABS (AX * AXINC(1,LOCNUM) * 3600.0 * XQMDMM)
     *      / (SCALEX * SCALEF * XYRATO)
         YASPMM = ABS (AY * AXINC(2,LOCNUM) * 3600.0 * YQMDMM)
     *      / (SCALEY * SCALEF)
         XYDIFF = ABS (ASPMM - YASPMM)
         DELTA = .025 * ASPMM
C                                       X and Y ASPMM about the same.
         IF (XYDIFF.GT.DELTA) GO TO 355
            WRITE (MSGTXT,1350) ASPMM
            CALL MSGWRT (4)
            GO TO 360
C                                       Using different X and Y ASPMM
 355     CONTINUE
            WRITE (MSGTXT,1355) ASPMM
            CALL MSGWRT (4)
            WRITE (MSGTXT,1356) YASPMM
            CALL MSGWRT (4)
C
 360     IF ((UASPMM.LE.0.0) .OR. (UASPMM.GE.ASPMM-DELTA)) GO TO 370
            WRITE (MSGTXT,1360)
            CALL MSGWRT (2)
C                                       Inits: on QUIC
 370  WRITE (CHBUF,2370)
      NNCHAR = 5
      CALL ZLASIO ('WRIT', QMSLUN, OUTFIL, NNCHAR, CHBUF, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       on freeform,landscape/portrait
      WRITE (CHBUF,2371) CHLAND(ILAND)
      NNCHAR = 8
      CALL ZLASIO ('WRIT', QMSLUN, OUTFIL, NNCHAR, CHBUF, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       Copies
      NNCHAR = IROUND (COPIES)
      IF (NNCHAR.LE.0) NNCHAR = 1
      WRITE (CHBUF,2373) NNCHAR
      NNCHAR = 31
      CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       set top,left borders
      WRITE (CHBUF,2374)
      NNCHAR = 22
      CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       on graphics, pen width
      LLPEN = IROUND (XXPEN)
      IF (LLPEN.LT.1) LLPEN = 3
      IF (LLPEN.GT.99) LLPEN = 99
      WRITE (CHBUF,2375) LLPEN
      NNCHAR = 11
      CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       Init grey scale generation
      IF (.NOT.DOGREY) GO TO 380
         CALL QMSGRY (1, QMSLUN, GOPR, NXDPP, NYDPP, IX, IY, DOLAND,
     *      LLPEN, VALUE, DPARM, CHBUF, IERR)
         IF (IERR.EQ.0) GO TO 375
            WRITE (MSGTXT,1370) IERR
            CALL MSGWRT (7)
            DOGREY = .FALSE.
            GO TO 50
C                                       Init variables for progress
C                                       report.
 375     TOTPIX = REAL(NPTSX) * REAL(NPTSY)
         NOWPIX = 0.0
         IPER = 0
         WRITE (MSGTXT,1375)
         CALL MSGWRT (1)
C                                       Send a dummy character line
C                                       avoids a problem hopefully
 380  CALL QMSVEC (0, 0, 1, QMSLUN, IERR)
      WRITE (CHBUF,2600)
      NNCHAR = 33
      CHBUF(33:36) = '    '
      NNCHAR = 36
      CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
      IF (IERR.NE.0) GO TO 960
      WRITE (CHBUF,2375) LLPEN
      NNCHAR = 11
      CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
      IF (IERR.NE.0) GO TO 960
      CALL CNTPLT (LUN, FIND, IOPOS, IORRN, IX0, SCALEX, CSIZQM(1),
     *   ICHL, NXA, MAXXQM(1), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 980
      GO TO 50
C                                       Opcode 4, position cursor.
 400  IX = BUFFER(IOPOS+1)
      IY = BUFFER(IOPOS+2)
      IOPOS = IOPOS + 3
      CALL QMSVEC (IX, IY, 1, QMSLUN, IERR)
      IF (IERR.EQ.0) GO TO 50
      IF (IERR.NE.10) GO TO 960
         IERRC = IERRC + 1
         GO TO 50
C                                       Opcode 5, draw vector.
 500  IX = BUFFER(IOPOS+1)
      IY = BUFFER(IOPOS+2)
      IOPOS = IOPOS + 3
      CALL QMSVEC (IX, IY, 2, QMSLUN, IERR)
      IF (IERR.EQ.0) GO TO 50
      IF (IERR.NE.10) GO TO 960
         IERRC = IERRC + 1
         GO TO 50
C                                       Opcode 6, write characters.
 600  NCHAR = BUFFER(IOPOS+1)
      IANGL = BUFFER(IOPOS+2)
      DX    = BUFFER(IOPOS+3)/100.0
      DY    = BUFFER(IOPOS+4)/100.0
      IX = IXL + DX * CSIZQM(1)
      IY = IYL + DY * CSIZQM(2)
      QY = IY + 0.25 * CSIZQM(2)
C                                       horizontal
      IF (IANGL.NE.1) THEN
         CALL QMSVEC (IX, QY, 3, QMSLUN, IERR)
         IF (IERR.EQ.10) IERRCH = IERRCH + 1
         IF (IERR.EQ.10) GO TO 630
         IF (IERR.NE.0) GO TO 960
         WRITE (CHBUF,2600)
         NNCHAR = 33
         CALL H2CHR (NCHAR, 1, HBUFFR(IOPOS+5), CHBUF(33:33+NCHAR-1))
         NNCHAR = NCHAR + NNCHAR - 1
         CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
         IF (IERR.NE.0) GO TO 960
C                                       on graphics
         WRITE (CHBUF,2375) LLPEN
         NNCHAR = 11
         CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
         IF (IERR.NE.0) GO TO 960
C                                       vertical
      ELSE
         DO 620 I = 1,NCHAR
            CALL QMSVEC (IX, QY, 3, QMSLUN, IERR)
            IF (IERR.EQ.10) IERRCH = IERRCH + 1
            IF (IERR.EQ.10) GO TO 630
            IF (IERR.NE.0) GO TO 960
            WRITE (CHBUF,2600)
            NNCHAR = 33
            CALL H2CHR (1, I, HBUFFR(IOPOS+5), CHBUF(33:))
            CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
            IF (IERR.NE.0) GO TO 960
C                                       Reposition vertical
            QY = QY - CSIZQM(2)
C                                       on graphics
            WRITE (CHBUF,2375) LLPEN
            NNCHAR = 11
            CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
            IF (IERR.NE.0) GO TO 960
 620        CONTINUE
         END IF
 630  IOPOS = IOPOS + 5 + ((NCHAR+3)/4)
      GO TO 50
C                                       Opcode 7, write grey scale.
 700  IF (DOGREY) GO TO 710
         GRYERR = GRYERR + 1
C                                       Update IO position. Read
C                                       proper RRN if necessary.
         IOPOS = IOPOS + 3 + BUFFER(IOPOS+1)
         IF (IOPOS.LE.256) GO TO 60
            INCRRN = (IOPOS-1)/256
            IORRN = IORRN + INCRRN
            IOPOS = IOPOS - 256*INCRRN
            CALL ZFIO ('READ', LUN, FIND, IORRN, BUFFER, IERR)
            IF (IERR.EQ.0) GO TO 60
            GO TO 980
C                                       Get grey values from record(s).
 710  NPIX = BUFFER(IOPOS+1)
      IANGL = BUFFER(IOPOS+2)
      IOPOS = IOPOS + 3
      IF (NPIX.LE.0) GO TO 50
      IX = IXL - NXDPP/2
      IY = IYL + NYDPP/2
C                                       Set bits for each pixel.
      DO 790 N = 1,NPIX
C                                       Need another buffer of G values
         IF (IOPOS.LE.256) GO TO 720
            IORRN = IORRN + 1
            CALL ZFIO ('READ', LUN, FIND, IORRN, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 980
            IOPOS = 1
C
 720     VALUE = (BUFFER(IOPOS) - GROFF) * GRSCAL
         VALUE = MAX (0.001, MIN (0.999, VALUE))
         IF ((ITRN.EQ.2) .OR. (ITRN.EQ.4) .OR. (ITRN.EQ.6))
     *      VALUE = 1.000 - VALUE
         IF ((ITRN.EQ.3) .OR. (ITRN.EQ.4))
     *      VALUE = LOG10 (30.0*VALUE + 1.0) / LOG10 (30.42) - .007
         IF ((ITRN.NE.5) .AND. (ITRN.NE.6)) GO TO 722
            TEMPV = VALUE
            IF (TEMPV.LT.TRANFN(3))
     *         VALUE = TRANFN(4) * (VALUE / TRANFN(3)) ** (1./TRANFN(2))
            IF (TEMPV.GE.TRANFN(3))
     *         VALUE = TRANFN(4) + (1.-TRANFN(4)) *
     *                  ((VALUE-TRANFN(3))/(1.-TRANFN(3))) ** TRANFN(2)
 722     CONTINUE
         VALUE = DPARM(1) * VALUE + DPARM(2)
         VALUE = MAX (0.0, MIN (1.0, VALUE))
C                                       position for pixel
         IF ((IANGL.EQ.0) .AND. (N.GT.1)) GO TO 725
            CALL QMSVEC (IX, IY, 3, QMSLUN, IERR)
            IF (IERR.EQ.10) GO TO 730
            IF (IERR.NE.0) GO TO 960
            WRITE (CHBUF,2720)
            NNCHAR = 32
            CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
            IF (IERR.NE.0) GO TO 960
C                                       do it
 725     CALL QMSGRY (2, QMSLUN, GOPR, NXDPP, NYDPP, IX, IY, DOLAND,
     *      LLPEN, VALUE, DPARM, CHBUF, IERR)
         IF (IERR.NE.0) GO TO 960
C                                       reset position
 730     IF (IANGL.EQ.0) IX = IX + NXDPP
         IF (IANGL.EQ.1) IY = IY + NYDPP
         IF (IANGL.EQ.2) IX = IX - NXDPP
         IF (IANGL.EQ.3) IY = IY - NYDPP
         IOPOS = IOPOS + 1
C                                       on graphics
         IF ((IANGL.EQ.0) .AND. (N.LT.NPIX)) GO TO 790
            WRITE (CHBUF,2375) LLPEN
            NNCHAR = 11
            CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
            IF (IERR.NE.0) GO TO 960
 790     CONTINUE
      NOWPIX = NOWPIX + NPIX
      IPER2 = INT(5.0 * NOWPIX / TOTPIX)
C                                       Write progress report.
      IF (IPER2.EQ.IPER) GO TO 50
         IPER = 20*IPER2
         WRITE (MSGTXT,1790) IPER
         IPER = IPER2
         CALL MSGWRT (1)
         GO TO 50
C                                       Opcode 8, put misc info in
C                                       image catalog.
 800  IOPOS = IOPOS + 2 + BUFFER(IOPOS+1)
      GO TO 50
C                                       Write error.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      GO TO 990
C                                       Invalid opcode.
 970  WRITE (MSGTXT,1970) OPCODE
      CALL MSGWRT (8)
      GO TO 990
C                                       Disk error.
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (8)
C                                       Close files.
C                                       delete font
C                                       normal syntax
 990  WRITE (CHBUF,2990) CHLAND(ILAND)
      NNCHAR = 38
      CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
      IF (IERR.NE.0) GO TO 993
      IF (QMPOS.GT.0) CALL ZLASIO ('WRIT', QMSLUN, OUTFIL, QMPOS,
     *   QMBUFF,
     *   IERR)
      IF (IERR.NE.0) GO TO 993
C                                       and quit (off free form)
      WRITE (CHBUF,2992)
      NNCHAR = 5
      CALL ZLASIO ('WRIT', QMSLUN, OUTFIL, NNCHAR, CHBUF, IERR)
      IF (IERR.NE.0) GO TO 993
         CALL ZLASIO ('CLOS', QMSLUN, OUTFIL, 0, CHBUF, IERR)
 993  IF (GRYERR.EQ.0) GO TO 995
         WRITE (MSGTXT,1993) GRYERR
         CALL MSGWRT (3)
 995  IF ((IERRC.LE.0) .AND. (IERRCH.LE.0)) GO TO 999
         WRITE (MSGTXT,1995) IERRC
         IF (IERRC.GT.0) CALL MSGWRT (3)
         WRITE (MSGTXT,1996) IERRCH
         IF (IERRCH.GT.0) CALL MSGWRT (3)
C
 999  RETURN
C-----------------------------------------------------------------------
C                                       Some changes made 870806
C                                       Pat Murphy
C                                       QUIC programming errors and the
C                                       infamous ^PN^- documentation
C                                       slipup by QMS, inc. (it has to
C                                       be on a line by itself).
 1000 FORMAT ('QMSDRW: ERROR',I4,' OPENING QMS FILE/DEVICE')
 1060 FORMAT (A4,' Operation received from tell')
 1200 FORMAT ('QMSDRW: ERR FROM GINITL ARGS. NXA, NYA=',2I6)
 1205 FORMAT ('QMSDRW: ERR FROM GINITL ARGS. X,Y=',2E10.3)
 1235 FORMAT ('Plot reduced in size by factor',F6.3)
 1300 FORMAT ('QMSDRW: Init grey scale out of order, ignored')
 1305 FORMAT ('QMSDRW: BAD PARMS FROM GINITG:',4I7)
 1310 FORMAT ('FEWER THAN 157 PIXELS, USE BITS OR RAND')
 1320 FORMAT ('PIXELS TOO SMALL FOR QRAN OR MRAN, USE RAND')
 1321 FORMAT ('PIXELS TOO SMALL FOR MBIT, USE BITS')
 1350 FORMAT ('Using',1PE12.5,' arc sec per mm')
 1355 FORMAT ('Using',1PE12.5,' arc sec per mm for x axis')
 1356 FORMAT ('Using',1PE12.5,' arc sec per mm for y axis')
 1360 FORMAT ('Which overrides user ASPMM in order to fit plot on',
     *   ' screen')
 1370 FORMAT ('QMSDRW: ERROR',I5,' INITIALIZING GREY SCALE')
 1375 FORMAT ('Grey scale initialization complete')
 1790 FORMAT (I3,' %  of grey scale pixels plotted')
 1960 FORMAT ('QMSDRW: QMS WRITE ERROR')
 1970 FORMAT ('QMSDRW: INVALID OPCODE',I5,' IN GRAPH FILE')
 1980 FORMAT ('QMSDRW: DISK IO RELATED ERROR',I3)
 1993 FORMAT ('QMSDRW: ',I5,' GREY SCALE OPCODES IGNORED')
 1995 FORMAT (I8,' vectors truncated at edges')
 1996 FORMAT (I4,' character strings omitted at edges')
 2370 FORMAT ('^PY^-')
 2371 FORMAT ('^IO',A1,'^G^-')
 2373 FORMAT ('^DC',I4.4,'^ISYNTAX00010^G^ISTFX0^G')
 2374 FORMAT ('^IT0150^G^IJ0150^G^F^-')
 2375 FORMAT ('^IGV^G^PW',I2.2)
 2600 FORMAT ('^IGE^G^SM00204^IL0600^G^IC0900^G')
 2720 FORMAT ('^IGE^G^SM09001^IL0000^G^IC0000^G')
C                                       Drop "^," at end for test
 2990 FORMAT ('^IGE^G^DF09001',A1,'^G^ISYNTAX00000^O^G^-')
 2992 FORMAT ('^PN^-')
      END
      SUBROUTINE QMSVEC (IX, IY, IN, QMSLUN, IERR)
C-----------------------------------------------------------------------
C   This routine will put control characters, and X and Y coordinates
C   into the QMS output file.
C   INPUTS:   IX    I   X coordinate value.
C             IY    I   Y coordinate value.
C             IN    I   control value:
C                           1 = Scale IX and IY and preceed coordinates
C                               by 'write dark vector' control charactr
C                           2 = Scale IX and IY, put in buffer.
C                           3 = IX and IY are not scaled, 'write dark
C                               vector' control character is put into
C                               the buffer.
C                           4 = no scale, write vector
C             QMSLUN  I   LUN of QMS file
C   Output:   IERR    I   Error code: 0 => ok
C                                    10 => vector truncated
C                                    else I/O error
C   Common:   QMBUFF
C             QMPOS
C             IXL
C             IYL
C-----------------------------------------------------------------------
      CHARACTER QMSCOM*16, COMAND(2)*2
      INTEGER   IX, IY, IN, QMSLUN, IERR
      REAL      ALPHA, BETA
      INTEGER   IXN, IYN, X, Y, QY, INC
      LOGICAL   ISERR
      INCLUDE 'QMSPL.INC'
      DATA COMAND /'^U','^D'/
C-----------------------------------------------------------------------
      ISERR = .FALSE.
C                                       Set last X and Y.
      IXN = IX
      IYN = IY
C                                       If IN = 1 or 2 do scaling.
      IF (IN.GT.2) GO TO 10
         IXN = IX*SCALEX + IX0 + .5
         IYN = IY*SCALEY + IY0 + .5
C                                       Bright vector
 10   INC = 1
C                                       If IN = 1 or 3 'dark vector'.
      IF ((IN.NE.1) .AND. (IN.NE.3)) INC = 2
      IF (INC.EQ.2) GO TO 30
C                                       Check start point
         X = MAX (1, MIN (MAXXQM(1), IXL))
         Y = MAX (1, MIN (MAXXQM(2), IYL))
         IF ((X.EQ.IXL) .AND. (Y.EQ.IYL)) GO TO 30
            ALPHA = 1.0
            IF (IXN.NE.IXL) ALPHA = REAL (X-IXN) / REAL (IXL-IXN)
            BETA = 1.0
            IF (IYN.NE.IYL) BETA = REAL (Y-IYN) / REAL (IYL-IYN)
            ALPHA = MIN (ALPHA, BETA)
            X = IXN + ALPHA * (IXL-IXN) + 0.5
            Y = IYN + ALPHA * (IYL-IYN) + 0.5
            QY = MAXXQM(2) - Y
            WRITE (QMSCOM,1010) COMAND(1), X, QY
            CALL QMSIO (QMSLUN, 12, QMSCOM, IERR)
            IF (IERR.NE.0) GO TO 90
C                                       Check end point
 30      X = MAX (1, MIN (MAXXQM(1), IXN))
         Y = MAX (1, MIN (MAXXQM(2), IYN))
         IF ((X.EQ.IXN) .AND. (Y.EQ.IYN)) GO TO 40
            IF ((IXN.LT.1) .AND. (IXL.LT.1)) GO TO 90
            IF ((IYN.LT.1) .AND. (IYL.LT.1)) GO TO 90
            IF ((IXN.GT.MAXXQM(1)) .AND. (IXL.GT.MAXXQM(1))) GO TO 90
            IF ((IYN.GT.MAXXQM(2)) .AND. (IYL.GT.MAXXQM(2))) GO TO 90
            ISERR = .TRUE.
            ALPHA = 1.0
            IF (IXN.NE.IXL) ALPHA = REAL(X-IXL)/REAL(IXN-IXL)
            BETA = 1.0
            IF (IYN.NE.IYL) BETA = REAL(Y-IYL)/REAL(IYN-IYL)
            ALPHA = MIN (ALPHA, BETA)
            X = IXL + ALPHA * (IXN-IXL) + 0.5
            Y = IYL + ALPHA * (IYN-IYL) + 0.5
 40      QY = MAXXQM(2) - Y
         WRITE (QMSCOM,1010) COMAND(INC), X, QY
         CALL QMSIO (QMSLUN, 12, QMSCOM, IERR)
C                                         Save new pos
 90   IXL = IXN
      IYL = IYN
      IF ((IERR.EQ.0) .AND. (ISERR)) IERR = 10
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (A2,I4.4,':',I4.4,';')
      END
      SUBROUTINE QMSIO (QMSLUN, N, QBUF, IERR)
C-----------------------------------------------------------------------
C   QMSIO moves characters to the buffer and if needed causes an I/O
C   to occur to the QMS "print" file.
C   Inputs: QMSLUN   I        LUN of file
C           N        I        Number of new characters
C           QBUF     C(*)     Character string (packed)
C   Output: IERR     I        Error code: 0 -> ok, else I/O error
C-----------------------------------------------------------------------
      CHARACTER  QBUF*(*)
      INTEGER   QMSLUN, N, IERR
      INTEGER   J, J0, J1
      INCLUDE 'QMSPL.INC'
C-----------------------------------------------------------------------
      IERR = 0
      J0 = N
      J1 = 1
C                                       Do an I/O (or two or three...)
 10   IF (QMPOS+J0.LE.QMSIZE) GO TO 30
         J = QMSIZE - QMPOS
         QMPOS = QMPOS + 1
         QMBUFF(QMPOS:QMPOS+J-1) = QBUF(J1:J1+J-1)
         QMPOS = QMPOS + J - 1
         J0 = J0 - J
         J1 = J1 + J
         CALL ZLASIO ('WRIT', QMSLUN, OUTFIL, QMPOS, QMBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         QMPOS = 0
         GO TO 10
C                                       Just move characters
 30   CONTINUE
         QMPOS = QMPOS + 1
         QMBUFF(QMPOS:QMPOS+J0-1) = QBUF(J1:J1+J0-1)
         QMPOS = QMPOS + J0 - 1
C
 999  RETURN
      END
      SUBROUTINE QMSGRY (IOP, QMSLUN, GGOPR, NX, NY, IX, IY, DOLAND,
     *   LLPEN, VALUE, DDPARM, CHBUF, IERR)
C-----------------------------------------------------------------------
C   QMSGRY performs (IOP=1) the grey scale initialization needed for the
C   given operation: GGOPR = 4,5 compute random character set and
C   download to the QMS, GGOPR = 6 initialize random number generator,
C   GGOPR = 2,3 prepare sine/Gaussian array for masking and on 2
C   download a character set.  On IOP=2, it writes the pixel to the
C   device as a character (GGOPR = 2,4,5) or as a dot matrix.
C   Inputs:
C      IOP      I      = 1 -> INIT, = 2 -> do it.
C      QMSLUN   I      LUN for open QMS print file.
C      GGOPR    I      Type operation: 2 MBIT, 3 BITS, 4 QRAN, 5 MRAN,
C                         6 RAND - On IOP=1, can be changed to 3 or 6.
C      NX       I      Number dots per pixel in X
C      NY       I      Number dots per pixel in Y
C      IX       I      Current dot position of pixel in X.
C      IY       I      Current dot position of pixel in Y.
C      DOLAND   I      T => landscape mode, else portrait
C      LLPEN    I      Pen width for graphics
C      VALUE    R      Grey scale pixel value (0. to 1.)
C   Output:
C      CHBUF    C*80   Scratch buffer
C      IERR     I      Error code: 0 -> ok, 1 -> input error,
C                         2 -> I/O error
C-----------------------------------------------------------------------
      CHARACTER CHBUF*80, XOUFIL*48, CHLAND(2)*1, CHHEX(16)*1,
     *   ALPHA(3)*26, CTEMP*2
      INTEGER   IOP, QMSLUN, GGOPR, NX, NY, IX, IY, LLPEN, IERR
      LOGICAL   DOLAND
      REAL      VALUE, DDPARM(10)
      INTEGER   ITJ(4), I, J, NNCHAR, INX, INY, NC, I1, I2, IT, IL, IC,
     *   JJ, IOFF, ILY, LLLY
      REAL      TV, SX, SY, AM, ADX, ADY, CNX, CNY, CAX, CAY, CBX, CBY
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'QMSPL.INC'
      DATA CHLAND, XOUFIL /'P','L',' '/
      DATA CHHEX /'0','1','2','3','4','5','6','7','8','9','A','B','C',
     *   'D','E','F'/
      DATA ITJ /8, 4, 2, 1/
      DATA ALPHA /'ABCDEFGHIJKLMNOPQRSTUVWXYZ',
     *            'abcdefghijklmnopqrstuvwxyz',
     *            '1234567890!@#$%&*()-+=<>,.'/
C-----------------------------------------------------------------------
C                                       Test inputs
      IERR = 1
      IF ((IOP.NE.1) .AND. (IOP.NE.2)) GO TO 999
      IF ((GGOPR.LT.2) .OR. (GGOPR.GT.6)) GO TO 999
      IERR = 0
C                                       Initialization
      IF (IOP.EQ.2) GO TO 500
         MXD = DDPARM(9) + 0.01
         MYD = DDPARM(10) + 0.01
         IF (MXD.LE.0) MXD = 1
         IF (MYD.LE.0) MYD = 1
C                                       'QRAN', 'MRAN', 'MBIT', 'BITS'
         IF (GGOPR.EQ.6) GO TO 100
C                                       Get BIT mask
            IF ((GGOPR.EQ.4) .OR. (GGOPR.EQ.5)) GO TO 20
               INX = MXD / 2 + 1
               SX = 6.283185 * DDPARM(5) / MXD
               INY = MYD / 2 + 1
               SY = 6.283185 * DDPARM(5) / MYD
               AM = 0.0
               ADX = DDPARM(5) / (MXD/4.0) ** 2
               ADY = DDPARM(5) / (MYD/4.0) ** 2
               CNX = INX - DDPARM(6)
               CNY = INY - DDPARM(7)
               CAX = MXD + 1 - DDPARM(6)
               CAY = MYD + 1 - DDPARM(7)
               CBX = 1 - DDPARM(6)
               CBY = 1 - DDPARM(7)
               I1 = 0
               DO 15 I = 1,MYD
                  TV = COS (SY * (I-CNY))
                  ILY = I1 + 1
                  DO 10 J = 1,MXD
                     I1 = I1 + 1
                     AMASK(I1) = 0.4995 * (TV * COS (SX*(J-CNX))
     *                  + 1.0)
                     IF (DDPARM(3).GT.1.5) GO TO 10
                        AMASK(I1) =
     *                     EXP (-ADX*((J-CNX)**2) - ADY*((I-CBY)**2))
     *                   + EXP (-ADX*((J-CAX)**2) - ADY*((I-CNY)**2))
     *                   + EXP (-ADX*((J-CNX)**2) - ADY*((I-CAY)**2))
     *                   + EXP (-ADX*((J-CBX)**2) - ADY*((I-CNY)**2))
                        AM = MAX (AM, AMASK(I1))
 10                  CONTINUE
 15               CONTINUE
               IF (DDPARM(3).GT.1.5) GO TO 19
                  AM = 1.001 * AM
                  I1 = 0
                  DO 18 I = 1,MYD
                     ILY = I1 + 1
                     DO 17 J = 1,MXD
                        I1 = I1 + 1
                        AMASK(I1) = 1.0 - AMASK(I1) / AM
 17                     CONTINUE
 18                  CONTINUE
 19            IF (GGOPR.EQ.3) GO TO 999
C                                       get sizes
 20         INX = NX
            INY = NY
            IF (.NOT.DOLAND) GO TO 25
               INX = NY
               INY = NX
 25         NC = ((INX+15) / 16) * 4
C                                       memory requirements
            I2 = (((NC/2.) * INY + 10.) * 78. + 1023.) / 1024.
            IF (I2.LE.100) GO TO 30
               GGOPR = 1
               WRITE (MSGTXT,1025)
               CALL MSGWRT (6)
               GO TO 100
C                                       init random numbers
 30         CALL RANDIN (IERR)
            IF (IERR.NE.0) GO TO 999
C                                       compute a character set
            I = 1
            IF (DOLAND) I = 2
            WRITE (CHBUF,1030) CHLAND(I), NY
            NNCHAR = 23
            CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
            IF (IERR.NE.0) GO TO 995
C                                       define characters
            DO 75 I = 1,26
               DO 70 J = 1,3
C                                       character in hex
                  IT = ICHAR (ALPHA(J)(I:I))
                  CALL ZHEX (IT, 2, CTEMP)
                  WRITE (CHBUF,1031) CTEMP, NX, INY, INX
                  NNCHAR = 20
                  CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
                  IF (IERR.NE.0) GO TO 995
C                                       Value of char
                  VALUE = 0.001 + 0.998 * (I-1) / 25.0
                  IF ((GGOPR.EQ.2) .OR. (GGOPR.EQ.5)) VALUE = 0.001
     *               + 0.998 * ((J-1)*26+I-1) / 77.
                  IOFF = -1
                  DO 65 IL = 1,INY
                     I1 = 0
                     ILY = MOD (IL+IOFF, MYD) * MXD + 1
                     DO 60 IC = 1,NC
                        QMPOS = QMPOS + 1
                        IF (QMPOS.LE.QMSIZE) GO TO 35
                           CALL ZLASIO ('WRIT', QMSLUN, XOUFIL, QMSIZE,
     *                        QMBUFF, IERR)
                           IF (IERR.NE.0) GO TO 995
                           QMPOS = 1
 35                     IT = 1
C                                       Random functions
                        IF (GGOPR.EQ.2) GO TO 45
                           DO 40 JJ = 1,4
                              I1 = I1 + 1
                              IF (I1.GT.INX) GO TO 55
                                 CALL RANDUM (TV)
                                 IF (VALUE.GT.TV) IT = IT + ITJ(JJ)
 40                           CONTINUE
                           GO TO 55
C                                       Starlink function
 45                     CONTINUE
                           DO 50 JJ = 1,4
                              I1 = I1 + 1
                              IF (I1.GT.INX) GO TO 55
                                 I2 = ILY + MOD (I1+IOFF, MXD)
                                 IF (VALUE.GT.AMASK(I2)) IT = IT +
     *                              ITJ(JJ)
 50                           CONTINUE
 55                     QMBUFF(QMPOS:) = CHHEX(IT)
 60                     CONTINUE
 65                  CONTINUE
 70               CONTINUE
 75            CONTINUE
            WRITE (CHBUF,1075) LLPEN
            NNCHAR = 13
            CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
            IF (IERR.NE.0) GO TO 995
            GO TO 999
C                                       'RAND'
 100     IF (GGOPR.NE.6) GO TO 999
C                                       init random numbers
            CALL RANDIN (IERR)
            GO TO 999
C                                       Do it: grey to QMS
 500  CONTINUE
C                                       All character forms
         IF ((GGOPR.EQ.3) .OR. (GGOPR.EQ.6)) GO TO 600
C                                       random case
            IF (GGOPR.NE.4) GO TO 510
               CALL RANDUM (TV)
               J = 1
               IF (TV.GT.0.3333) J = 2
               IF (TV.GT.0.6666) J = 3
C                                       get character
               I = 25.0 * VALUE + 1.50
               IF (I.LE.0) I = 1
               IF (I.GT.26) I = 26
               GO TO 520
C                                       Finer levels
 510        CONTINUE
               I = 77.0 * VALUE + 1.50
               IF (I.LE.0) I = 1
               IF (I.GT.78) I = 78
               J = (I-1) / 26 + 1
               I = I - (J-1)*26
C                                       Position in ALPHA
 520        QMPOS = QMPOS + 1
C                                       Do I/O when needed
            IF (QMPOS.LE.QMSIZE) GO TO 530
               CALL ZLASIO ('WRIT', QMSLUN, XOUFIL, QMSIZE, QMBUFF,
     *            IERR)
               IF (IERR.NE.0) GO TO 995
               QMPOS = 1
 530        QMBUFF(QMPOS:QMPOS) = ALPHA(J)(I:I)
            GO TO 999
C                                       'RAND', 'SIN ' : each dot
 600     IF ((GGOPR.NE.3) .AND. (GGOPR.NE.6)) GO TO 999
C                                       This may not be correct for
C                                       landscape mode - try it
            INX = NX
            INY = NY
            IF (.NOT.DOLAND) GO TO 610
C               INX = NY
C               INY = NX
 610        NC = ((INX + 15) / 16) * 4
            WRITE (CHBUF,1610) INX
            NNCHAR = 6
            CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
            IF (IERR.NE.0) GO TO 995
            LLLY = MYD * 1000 - IY
C                                       Send random bits until full
            DO 650 I = 1,INY
               I1 = 0
               ILY = LLLY + I - 2
               ILY = MOD (ILY, MYD) * MXD + 1
               IL = IX - 2
               DO 645 J = 1,NC
                  QMPOS = QMPOS + 1
                  IF (QMPOS.LE.QMSIZE) GO TO 620
                     CALL ZLASIO ('WRIT', QMSLUN, XOUFIL, QMSIZE,
     *                  QMBUFF,
     *                  IERR)
                     IF (IERR.NE.0) GO TO 995
                     QMPOS = 1
 620              IT = 1
C                                       Random case
                  IF (GGOPR.EQ.3) GO TO 630
                     DO 625 I2 = 1,4
                        I1 = I1 + 1
                        IF (I1.GT.INX) GO TO 640
                           CALL RANDUM (TV)
                           IF (VALUE.GE.TV) IT = IT + ITJ(I2)
 625                    CONTINUE
                     GO TO 640
C                                       Starlink case
 630              CONTINUE
                     DO 635 I2 = 1,4
                        I1 = I1 + 1
                        IF (I1.GT.INX) GO TO 640
                           IC = ILY + MOD (IL+I1, MXD)
                           IF (VALUE.GT.AMASK(IC)) IT = IT + ITJ(I2)
 635                    CONTINUE
 640              QMBUFF(QMPOS:) = CHHEX(IT)
 645              CONTINUE
 650           CONTINUE
C                                       End dots
            WRITE (CHBUF,1650)
            NNCHAR = 2
            CALL QMSIO (QMSLUN, NNCHAR, CHBUF, IERR)
            IF (IERR.NE.0) GO TO 995
            GO TO 999
C                                       I/O error
 995  WRITE (MSGTXT,1995) IERR
      IERR = 2
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1025 FORMAT ('QMSGRY: SWITCH TO DOT-BY-DOT - TOO MUCH CORE NEEDED IN',
     *   ' QUICK MODES')
 1030 FORMAT ('^IGE^G^DF09001',A1,'0AIPS',I3.3)
 1031 FORMAT (',',A2,I3.3,'^M',I3.3,I3.3,'000000')
 1075 FORMAT ('^G^IGV^G^PW',I2.2)
 1610 FORMAT ('^P',I4.4)
 1650 FORMAT ('^G')
 1995 FORMAT ('QMSGRY: QMS WRITE ERROR',I5)
      END
      SUBROUTINE FIXDPP (GOPR, NXDPP, NYDPP, DPARM)
C-----------------------------------------------------------------------
C   FIXDPP attempts to fix up the dots/pixel and mask size to be
C   compatible
C   Inputs: GOPR    I        Type of grey scale
C   In/out: NXDPP   I        Dots/pixel in X: (in) request (out) used
C           NYDPP   I        Dots/pixel in Y: (in) request (out) used
C           DPARM   R(10)    (3) default mask size (in)
C                            (6) use this X mask size (out)
C                            (7) use this Y mask size (out)
C-----------------------------------------------------------------------
      INTEGER   GOPR, NXDPP, NYDPP
      REAL      DPARM(10)
      INTEGER   N(2), M, I, J, IROUND, LM, LJ, L, MD(2)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       BITS Parameters
      M = 8
      IF ((GOPR.NE.2) .AND. (GOPR.NE.3)) GO TO 100
         I = IROUND (DPARM(3))
         IF (I.LE.0) I = 0
         IF (I.GT.3) I = 0
         DPARM(3) = I
         IF ((I.EQ.1) .OR. (I.EQ.3)) GO TO 20
            DPARM(5) = 1.0
            DPARM(4) = 8.0
            DPARM(6) = 10.0
            DPARM(7) = 10.0
            M = 8
            GO TO 100
 20      CONTINUE
            IF (DPARM(5).LT.0.01) DPARM(5) = 1.0
            M = ABS (DPARM(4)) + 0.01
            IF (M.LE.4) M = 8
            IF (M.GT.16) M = 16
            IF (DPARM(4).GT.-0.5) DPARM(4) = M
            IF (DPARM(4).LE.-0.5) DPARM(4) = -M
C                                       Not pixel masked
 100  IF (GOPR.EQ.2) GO TO 110
C                                       now done before this call
C         IF (NYDPP.EQ.NXDPP+1) NYDPP = NXDPP
C         IF (NXDPP.EQ.NYDPP+1) NXDPP = NYDPP
         DPARM(9) = M
         DPARM(10) = M
         IF (GOPR.EQ.3) GO TO 150
         GO TO 999
C                                       Pixel masked
 110  CONTINUE
         N(1) = NXDPP
         N(2) = NYDPP
         DO 140 I = 1,2
            DPARM(8+I) = M
            IF ((DPARM(4).LT.0) .AND. (N(I).LT.M)) GO TO 140
            LJ = M
C                                       Program chooses mask
            IF (DPARM(4).LT.0) GO TO 135
               IF (N(I).LT.7) GO TO 140
               IF (N(I).GT.13) GO TO 120
                  DPARM(8+I) = N(I)
                  GO TO 140
 120           LM = N(I)
               LJ = 1
               DO 130 J = 7,13
                  L = N(I) - (N(I)/J) * J
                  IF (L.GE.LM) GO TO 130
                     LM = L
                     LJ = J
 130              CONTINUE
 135        DPARM(8+I) = LJ
            N(I) = (N(I)/LJ) * LJ
 140        CONTINUE
         NXDPP = N(1)
         NYDPP = N(2)
C                                       Default shifts
 150  IF (ABS(DPARM(6)).GT.0.9) DPARM(6) = 0.25 * DPARM(9) / 8.0
      IF (ABS(DPARM(7)).GT.0.9) DPARM(7) = 0.133 * DPARM(10) / 8.0
      MD(1) = DPARM(9) + 0.01
      MD(2) = DPARM(10) + 0.01
      WRITE (MSGTXT,1150) NXDPP, NYDPP, MD
      CALL MSGWRT (2)
      IF (DPARM(3).LT.1.5) WRITE (MSGTXT,1151) DPARM(5), DPARM(6),
     *   DPARM(7)
      IF (DPARM(3).GE.1.5) WRITE (MSGTXT,1152) DPARM(5), DPARM(6),
     *   DPARM(7)
      CALL MSGWRT (2)
C
 999  RETURN
C-----------------------------------------------------------------------
 1150 FORMAT ('Using x,y dots/pix, dot/mask',4I5)
 1151 FORMAT ('      Scale, x-, y-shift  =',3F9.5,' gaussian')
 1152 FORMAT ('      Scale, x-, y-shift  =',3F9.5,' sin')
      END
      SUBROUTINE CNTPLT (LUN, FIND, IOPOS, IRRN, IX0, SCALEX, CSIZEX,
     *   ICHL, NXA, MAXX, BUFFER, IERR)
C-----------------------------------------------------------------------
C   CNTPLT reads a few records from the plot file to see if some
C   character string or other command will cause the plot to overflow
C   in the X direction (on the right).  It will correct IX0 if possible.
C   Inputs:
C      LUN     I         LUN of open plot file
C      FIND    I         FTAB pointer for plot file
C      IOPOS   I         Position in BUFFER of next command
C      SCALEX  R         X scaling factor
C      CSIZEX  I         Size of character in X
C      ICHL    I         Number chars to left of plot (dots)
C      NXA     I         Number dots in X plot expected
C      IRRN    I   !!    Record number now in BUFFER.
C      MAXX    I         Max X value allowed (1 is min)
C      BUFFER  I(256)    I/O buffer with plot file record IRRN
C   In/out:
C      IX0     I         X bias position
C   Output:
C      IERR    I         Error code from ZFIO
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IOPOS, IRRN, IX0, CSIZEX, MAXX, BUFFER(256),
     *   NXA, ICHL, IERR
      REAL      SCALEX
C
      REAL      DX
      INTEGER   LRRN, XMAX, XMIN, X, LOPOS, I, IX, NCHAR, IANGL, LX
C-----------------------------------------------------------------------
C                                       Init
      X = 0
      XMAX = IX0 + NXA - ICHL
      XMIN = IX0 - ICHL
      LOPOS = IOPOS
      LRRN = IRRN
      IERR = 0
C                                       Read record from disk
 50   IF (LOPOS.LE.256) GO TO 60
 55      LRRN = LRRN + 1
         IF (LRRN.GT.IRRN+4) GO TO 900
         CALL ZFIO ('READ', LUN, FIND, LRRN, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
         LOPOS = 1
C                                       Branch to type log record
 60   I = BUFFER(LOPOS)
      IF (I.EQ.0) GO TO 55
      IF ((I.LT.0) .OR. (I.GT.8)) GO TO 900
      GO TO (100, 200, 300, 400, 500, 600, 700, 800), I
C                                       Init
 100  LOPOS = LOPOS + 6
      GO TO 50
C                                       Init line drawing
 200  LOPOS = LOPOS + 20
      GO TO 50
C                                       Init grey scale
 300  LOPOS = LOPOS + 5
      GO TO 50
C                                       Vector position
 400  CONTINUE
C                                       Vector draw
 500  IX = BUFFER(LOPOS+1)
      LOPOS = LOPOS + 3
      X = IX * SCALEX + IX0 + 0.5
      XMIN = MIN (XMIN, X)
      XMAX = MAX (XMAX, X)
      GO TO 50
C                                       Characters
 600  NCHAR = BUFFER(LOPOS+1)
      IANGL = BUFFER(LOPOS+2)
      DX = BUFFER(LOPOS+3) / 100.0
      LX = X + DX * CSIZEX
      IF (IANGL.EQ.0) IX = LX + NCHAR * CSIZEX
      IF (IANGL.NE.0) IX = LX + CSIZEX
      IF (IANGL.EQ.2) LX = LX - (NCHAR-1) * CSIZEX
      XMIN = MIN (XMIN, IX, LX)
      XMAX = MAX (XMAX, LX, IX)
      LOPOS = LOPOS + 5 + ((NCHAR+3)/4)
      GO TO 50
C                                       Do grey scale (quit here)
 700  GO TO 900
C                                       Misc info
 800  LOPOS = LOPOS + 2 + BUFFER(LOPOS+1)
      GO TO 50
C                                       Recover record
 900  IF (LRRN.EQ.IRRN) GO TO 910
         LRRN = IRRN
         CALL ZFIO ('READ', LUN, FIND, LRRN, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Reset origin
 910  I = XMAX - MAXX
      IF (I.LE.0) GO TO 999
         X = XMIN - IX0
         IX0 = IX0 - I - (XMIN/2-I-1)/2
         IX0 = MAX (2, IX0)
         X = X + IX0
         IF (X.LT.2) IX0 = IX0 + 2 - X
C
 999  RETURN
      END

      SUBROUTINE HICREA (HLUN, KVOL, CNO, CATBLK, BUFFER, IERR)
C-----------------------------------------------------------------------
C! open a history file, creating one if needed
C# History
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   HICREA creates and opens a history file.  If there is already a
C   history file, no creation is done and the existing file is opened
C   for adding output.
C   Inputs:
C      HLUN    I         lun to use
C      KVOL    I         disk number
C      CNO     I         catalog location
C      CATBLK  I(256)    map header
C   Output:
C      BUFFER  I(256)    HI work buffer (contains first rec)
C      IERR    I         error code - 0 => ok
C                                     others
C-----------------------------------------------------------------------
      INTEGER   HLUN, KVOL, CNO, CATBLK(256), BUFFER(256), IERR
C
      CHARACTER HNAME*48, CTEMP*2, CHTM12*12, CHTM6*6
      INTEGER   VER, HPTR, IER, I, IDUM, ISIZE, LSIZE
      LOGICAL   T, F, OLD
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                        does HI already exist
      CALL FNDEXT ('HI', CATBLK, I)
C                                        Already an HI warning
      IF (I.GT.0) THEN
         MSGTXT = 'HICREA: WARNING - ADDING TO EXISTING HI FILE'
         CALL MSGWRT (6)
         OLD = T
C                                        NO - add extension
      ELSE
         CALL MADDEX ('HI', KVOL, CNO, CATBLK, BUFFER, T, 'UPDT', VER,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
C                                        create >= 40 log recs
         ISIZE = 39 / NHILPR + 1
         OLD = F
         CALL ZPHFIL ('HI', KVOL, CNO, VER, HNAME, IERR)
         CALL ZCREAT (KVOL, HNAME, ISIZE, F, LSIZE, IERR)
         IF (IERR.NE.0) THEN
            IF (IERR.NE.1) THEN
               WRITE (MSGTXT,1010) IERR
               IF (IERR.EQ.5) WRITE (MSGTXT,1011) KVOL
               GO TO 900
C                                       warning replace old file
            ELSE
               MSGTXT = 'HICREA: WARNING - REPLACING OLD HI PHYSICAL'
     *            // ' FILE'
               CALL MSGWRT (6)
               OLD = T
               END IF
            END IF
         END IF
C                                        open it
 30   CALL HIOPEN (HLUN, KVOL, CNO, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 40
         WRITE (MSGTXT,1030) IERR
         GO TO 900
C                                        reset things for new files
 40   IF (.NOT.OLD) THEN
         CALL HILOCT ('SRCH', HLUN, HPTR, IER)
         HITAB(HPTR+2) = 0
         HITAB(HPTR+3) = NHILPR * LSIZE
         BUFFER(1) = HITAB(HPTR+2)
         BUFFER(2) = HITAB(HPTR+3)
         END IF
      BUFFER(3) = HPTR
      GO TO 999
C                                        errors
 900  CALL MSGWRT (7)
      IF (.NOT.OLD) THEN
         CALL DELEXT ('HI', KVOL, CNO, 'WRIT', CATBLK, BUFFER, VER, IER)
         CALL ZDESTR (KVOL, HNAME, IER)
         CHTM12 = ' '
         CHTM6 = ' '
         CTEMP = ' '
         CALL CATDIR ('CSTA', KVOL, CNO, CHTM12, CHTM6, IDUM, CTEMP,
     *      IDUM, 'WRIT', BUFFER, IER)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('HICREA: ZCREAT ERROR',I7)
 1011 FORMAT ('HICREA: PROHIBITED FROM CREATING FILE ON DISK',I4)
 1030 FORMAT ('HICREA: CAN''T OPEN HI FILE - ERROR',I7)
      END

      PROGRAM BAKTP
C-----------------------------------------------------------------------
C! write machine-dependent backup tape of 1 or more  catalog entries
C# Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   This program will write a series of maps or UV data bases plus
C   extensions to tape using the "backup" (machine-dependent) format of
C   the host system. Each set of file+extension(s) is in a separate
C   physical file on the tape, in order to facilitate selective
C   reloading. On VMS the tape format is "BACKUP" and on Unix it is tar.
C   Inputs:
C      DOALL     R      > 0 means do every catalog entry that matches
C                       the inputs.  Else do 1st that matches.
C      INNAME    H*12   Name of input file.
C      INCLASS   H*6    Class of file.
C      INSEQ     R      sequence number of file.
C      INDISK    R      disk volume no. of file.
C      INTYPE    R      file type (UV or MA or blank).
C      OUTTAPE   R      tape number for output.
C      OPCODE    H*4    'INIT'=initialize tape, 'BACK' or ' '= do BAKTP.
C-----------------------------------------------------------------------
      INTEGER   ISCR(256), ICNO, IMAX, IERR, IVOL, INDEX, JERR, LSEQ,
     *   ZLUN, NTAPE, LZMT0N, I
      LOGICAL   FIND1, T, F, EOF
      CHARACTER ZBKNAM*30, BAKTXT*12, ZMT0N*48, CNAME*12, CCLASS*6,
     *   CTYPE*2
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DBTP.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       init CFILs counters
      NCFILE = 0
      NSCR = 0
      TIND = 0
C                                       Get input parameters, defaults
      CALL BAKINI (RQUICK, ISCR, ZLUN, ZBKNAM, BAKTXT, NTAPE, ZMT0N,
     *   LZMT0N, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       branch on OP:
      IF (OP.EQ.'INIT') GO TO 990
      IF ((OP.NE.'BACK') .AND. (OP.NE.' ')) THEN
         WRITE (MSGTXT,1020) OP
         CALL MSGWRT (7)
         GO TO 990
         END IF
C                                       BACK op: loop for all disks.
      FIND1 = F
      IMAX = 32767
      IF (DOALL.LE.0.0) IMAX = 1
      IF (ISEQ.LE.0) ISEQ = 0
      LSEQ = ISEQ
      IF ((ISEQ.LE.0) .AND. (DOALL.LE.0.0)) LSEQ = -1
      CALL H2CHR (12, 1, NAME, CNAME)
      CALL H2CHR (6, 1, CLASS, CCLASS)
      CALL H2CHR (2, 1, TYPE, CTYPE)
      DO 100 IVOL = IBVOL,IEVOL
C                                       Loop for all files on disk.
         ICNO = 0
         DO 80 INDEX = 1,IMAX
            ICNO = ICNO + 1
C                                       Find next data base.
            CALL H2CHR (12, 1, NAME, CNAME)
            CALL H2CHR (6, 1, CLASS, CCLASS)
            CALL H2CHR (2, 1, TYPE, CTYPE)
            CALL NXTMAP ('READ', IVOL, CNAME, CCLASS, LSEQ, CTYPE, USER,
     *         DLUN, DIND, ICNO, CATBLK, ISCR, EOF, IERR)
            IF (IERR.NE.0) GO TO 990
            IF (EOF) GO TO 90
            CALL ZCLOSE (DLUN, DIND, IERR)
            FIND1 = T
C                                       Set DIE values for this file.
            NCFILE = 1
            FVOL(1) = IVOL
            FCNO(1) = ICNO
            FRW(1) = 0
C                                       write this one out:
            CALL BAKWRT (ZLUN, ZBKNAM, BAKTXT, USER, IVOL, ICNO,
     *         NTAPE, ZMT0N, LZMT0N, IERR)
            IF (IERR.NE.0) GO TO 990
            CALL CATDIR ('CSTA', IVOL, ICNO, CNAME, CCLASS, LSEQ, CTYPE,
     *         USER, 'CLRD', ISCR, JERR)
            NCFILE = 0
C
 80         CONTINUE
 90      IF ((IMAX.EQ.1) .AND. (FIND1)) GO TO 900
 100     CONTINUE
C                                       Could not find file of type ...
 900  IF (.NOT.FIND1) THEN
         WRITE (MSGTXT,1900) CTYPE, USER, CNAME, CCLASS, ISEQ, IBVOL,
     *      IEVOL
         CALL MSGWRT (7)
         IERR = 1
      ELSE
         MSGTXT = 'Adding extra EOFs for safety - sorry for the delay'
         CALL MSGWRT (2)
         IERR = 0
         IF (TIND.LE.0) CALL ZTPOPN (TLUN, TIND, NTAPE, TNAME, 'WRIT',
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1910) IERR
            CALL MSGWRT (8)
         ELSE
            I = 1
            CALL ZTAPE ('BEGW', TLUN, TIND, I, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1915) IERR
               CALL MSGWRT (8)
               END IF
            END IF
         END IF
C
 990  IF (OP.NE.'INIT') THEN
         CALL ZBKTP3 (ZLUN, ZBKNAM, JERR)
         IF (IERR.EQ.0) IERR = JERR
         END IF
      IF (TIND.GT.0) THEN
         CALL ZTPCLS (TLUN, TIND, JERR)
         IF (IERR.EQ.0) IERR = JERR
         END IF
      CALL DIE (IERR, ISCR)
C
 999  STOP
C-----------------------------------------------------------------------
 1020 FORMAT ('ILLEGAL OPCODE ',A4,'; Legal = INIT, BACK, or blank.')
 1900 FORMAT ('NO ',A2,' FILE! USER:',I5,1X,A12,'.',A6,'.',I4,' VOLS:',
     *   I2,' -',I2)
 1910 FORMAT ('ERROR',I5,' REOPENING THE TAPE')
 1915 FORMAT ('ERROR',I5,' WRITING EOF OR REPOSITIONING TAPE')
      END
      SUBROUTINE BAKINI (RQUICK, ISCR, ZLUN, ZBKNAM, BAKTXT, NTAPE,
     *   ZMT0N, LZMT0N, IRET)
C-----------------------------------------------------------------------
C   BAKINI does the most basic inits for BAKTP.  Get the parameters,
C   restart AIPS if required, fill in defaults, init the tape I/O.
C   For the 'INIT' opcode, BAKINI expects ZBAKTP1 to do the work.
C   For the 'BACK' opcode, position tape just before EOI.
C   Outputs:
C      RQUICK  L       T -> AIPS already restarted
C      ISCR    I(256)  Scratch buffer
C      ZLUN    I       LUN to use (set in ZMKTP1)
C      ZBKNAM  C*(*)   Full name of command file
C      BAKTXT  C*(*)   Name of text file for commands
C      NTAPE   I       Tape drive unit number
C      ZMT0N   C*(*)   tape name - translattion of MT0n
C      LZMT0N  I       length of last char in ZMT0N
C      IRET    I       Return code : 0 => ok, else quit
C   Common
C      /INPARM/
C      /MORPRM/
C-----------------------------------------------------------------------
      LOGICAL   RQUICK
      INTEGER   ISCR(256), ZLUN, NTAPE, LZMT0N, IRET
      CHARACTER ZBKNAM*(*), BAKTXT*(*), ZMT0N*(*)
C
      CHARACTER PRGNAM*6
      INTEGER   NPARM, IERR
      LOGICAL   T
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DBTP.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA PRGNAM, NPARM /'BAKTP ', 11/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
      CALL ZDCHIN (.TRUE., ISCR)
      CALL VHDRIN
C                                       Initialize for AIPS
      CALL GTPARM (PRGNAM, NPARM, RQUICK, DOALL, ISCR, IRET)
      IF (IRET.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (8)
         GO TO 20
C                                       Only interactive tasks
 10   IF ((NPOPS.LE.NINTRN) .AND. (ISBTCH.NE.32000)) GO TO 20
         WRITE (MSGTXT,1010)
         CALL MSGWRT (8)
         IRET = 4
C                                       Restart AIPS
 20   IF (RQUICK) CALL RELPOP (IRET, ISCR, IERR)
      IF (IRET.NE.0) GO TO 999
      CALL H2CHR (4, 1, OPCODE, OP)
C                                       get tape drive:
      NTAPE = NTAPE4 + 0.5
      IF (NTAPE.EQ.0) NTAPE = 1
      TLUN = 129 - NTAPE
      CALL ZPHFIL ('MT', NTAPE, 1, 1, TNAME, IERR)
      IF (IERR.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) IERR
         GO TO 990
C
 30   CALL ZTPOPN (TLUN, TIND, NTAPE, TNAME, 'WRIT', IERR)
      IF (IERR.EQ.0) GO TO 40
         WRITE (MSGTXT,1030) IERR
         GO TO 990
C                                       Set some default values,
C                                       and global parameters.
 40   USER = NLUSER
      DLUN = 16
      ISEQ = SEQ4 + .5
      IBVOL = KVOL4 + .5
      IEVOL = IBVOL
      IF (IBVOL.LE.0) THEN
         IBVOL = 1
         IEVOL = NVOL
         END IF
C                                       BAKTP init:
      BAKTXT = 'BAKAIP.TXT'
      CALL ZBKTP1 (ZLUN, ZBKNAM, BAKTXT, NTAPE, ZMT0N, LZMT0N, IERR)
      IF (IERR.NE.0) GO TO 995
      IF (OP.NE.'INIT') THEN
         WRITE (MSGTXT,1040)
         CALL MSGWRT (4)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
 995  IRET = 16
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('COULD NOT GET PARMS.  IER=',I3)
 1010 FORMAT ('TAPES NOT AVAILABLE TO BATCH AIPS  ')
 1020 FORMAT ('COULD NOT GET PHYSICAL NAME OF TAPE.  IER=',I4)
 1030 FORMAT ('COULD NOT OPEN TAPE.  IER=',I4)
 1040 FORMAT ('V-Cno User Rlsnam  Date-bak Date-map Ty Name',8X,
     *   ' Class   Seq')
      END
      SUBROUTINE BAKWRT (ZLUN, ZBKNAM, BAKTXT, USID, IVOL, ICNO, NTAPE,
     *   ZMT0N, LZMT0N, IERR)
C-----------------------------------------------------------------------
C   Write it out!
C   Inputs:
C      ZLUN    I       LUN to use (set in ZMKTP1)
C      ZBKNAM  C*(*)   Full name of command file
C      BAKTXT  C*(*)   Name of text file for commands
C      USID    I       User number
C      IVOL    I       Disk number
C      ICNO    I       Catalog entry number
C      NTAPE   I       Tape drive unit number
C      ZMT0N   C*(*)   tape name - translattion of MT0n
C      LZMT0N  I       length of last char in ZMT0N
C   Outputs:
C      IERR     I
C-----------------------------------------------------------------------
      INTEGER   ZLUN, USID, IVOL, ICNO, NTAPE, LZMT0N, IERR
      CHARACTER ZBKNAM*(*), BAKTXT*(*), ZMT0N*(*)
C
      CHARACTER BAKREC*60
      INTEGER   IDATE(3)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DBTP.INC'
C-----------------------------------------------------------------------
C                                       encode directory string:
      CALL ZDATE (IDATE)
      IDATE(1) = MOD (IDATE(1), 100)
      WRITE (BAKREC,1000) USID, RLSNAM, IDATE(3), IDATE(2), IDATE(1),
     *   CATBLK(KIIMS)
      CALL H2CHR (8, 1, CATH(KHDMP), BAKREC(23:30))
      CALL H2CHR (2, KHPTYO, CATH(KHPTY), BAKREC(32:33))
      CALL H2CHR (12, KHIMNO, CATH(KHIMN),BAKREC(35:46))
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), BAKREC(48:53))
      WRITE (MSGTXT,1005) IVOL, ICNO
      MSGTXT(7:) = BAKREC(:58)
      CALL MSGWRT (2)
C                                       do machine-dep stuff:
      CALL ZBKTP2 (ZLUN, ZBKNAM, BAKTXT, BAKREC, IVOL, ICNO, NTAPE,
     *   ZMT0N, LZMT0N, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I4.4,1X,A7,1X,I2.2,'/',I2.2,'/',I2.2,1X,8X,1X,2X,1X,
     *   12X,'.',6X,'.',I4.4)
 1005 FORMAT (I1,'-',I3.3)
      END

      SUBROUTINE TABFRM (FORMAT, IWIDTH, FRAC, ITYPE, IERR)
C-----------------------------------------------------------------------
C! Parses format for FITS ASCI table entries.
C# FITS Tape EXT-util Parsing
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   This routine will parse a table file format specifier and determine
C   the format width, fractional part (for D or E formats) and the
C   format code.
C   Inputs:
C      FORMAT   C*8   Format code in the form Iww or Aww or
C                     Eww.dd or Dww.dd, padded with blanks.
C   Output:
C      IWIDTH   I     The width of the field.
C      FRAC     I     The fractional part of the field (E and D only).
C      ITYPE    I     The type of the field (D=1, E=2, A=3, I=4)
C      IERR     I     Error code: 0 = ok.
C-----------------------------------------------------------------------
      CHARACTER FORMAT*8
      INTEGER   IWIDTH, FRAC, ITYPE, IERR
C
      CHARACTER TYPES*10, NUMS*10, ONECHR*1
      INTEGER   IT, IPOS, ISTART, ITYPES(10)
      INCLUDE 'INCS:DMSG.INC'
      DATA NUMS /'0123456789'/
      DATA TYPES /'DdEeAaIiFf'/
C                                       Note that F format is E format
      DATA ITYPES /1,1,2,2,3,3,4,4,2,2/
C-----------------------------------------------------------------------
C                                       Find type
      IPOS = INDEX (TYPES, FORMAT(1:1))
      IF (IPOS.LE.0) GO TO 970
      ITYPE = ITYPES(IPOS)
C                                       Determine width.
      IWIDTH = 0
      DO 300 IPOS = 2,8
         ONECHR = FORMAT(IPOS:IPOS)
         IF ((ONECHR.EQ.'.') .AND. (ITYPE.LT.3)) GO TO 400
         IF ((ONECHR.EQ.' ') .AND. (ITYPE.GE.3)) GO TO 600
         IT = INDEX (NUMS, ONECHR)
         IF (IT.LE.0) GO TO 980
         IWIDTH = 10 * IWIDTH + (IT - 1)
 300     CONTINUE
      IF (ITYPE.GE.3) GO TO 600
C                                       Determine fraction.
 400  ISTART = IPOS + 1
      FRAC = 0
      DO 500 IPOS = ISTART,8
         ONECHR = FORMAT(IPOS:IPOS)
         IF (ONECHR.EQ.' ') GO TO 999
         IT = INDEX (NUMS, ONECHR)
         IF (IT.LE.0) GO TO 980
         FRAC = 10 * FRAC + (IT - 1)
 500     CONTINUE
C                                       Integer or character
 600  FRAC = -1
      GO TO 999
C                                       Problem decoding
 970  WRITE (MSGTXT,1970) FORMAT
      GO TO 990
 980  WRITE (MSGTXT,1980) FORMAT
 990  CALL MSGWRT (6)
      IERR = 1
 999  RETURN
C-----------------------------------------------------------------------
 1970 FORMAT ('TABFRM: BAD FITS TABLE FORMAT ',A)
 1980 FORMAT ('TABFRM: BAD FITS TABLE ASCII NUMBER, FORMAT IS ',A)
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER   NPARMS
C                                       NPARMS=no. adverbs passed.
      PARAMETER (NPARMS=19)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                                       NOTE: Uses values in PAOOF.INC
C                                       Adverb names
C                     1         2          3        4         5
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INEXT',
C           6         7          8           9         10
     *   'INVERS', 'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK',
C           11         12        13        14         15        16
     *   'IN2VERS', 'BCOUNT', 'ECOUNT', 'COMPCOL', 'SELCOL', 'DOALL',
C           17       18          19
     *   'DOCRT', 'OUTPRINT', 'BADDISK'/
C                                       Adverb data types (PAOOF.INC)
C                    1       2       3       4       5
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOACAR,
C          6       7       8       9       10
     *   OOAINT, OOACAR, OOACAR, OOAINT, OOAINT,
C          11      12      13      14      15      16
     *   OOAINT, OOAINT, OOAINT, OOACAR, OOACAR, OOARE,
C          17     18      19
     *   OOARE, OOACAR, OOAINT/
C                                       Adverb dimensions (as 2D)
C                   1    2    3    4    5
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 2,1,
C         6     7    8    9    10
     *   1,1, 12,1, 6,1, 1,1, 1,1,
C         11   12   13    14     15    16
     *   1,1, 1,1, 1,1, 16,30, 16,30, 1,1,
C         17    18    19
     *   1,1, 48,1, 10,1/
LOCAL END
LOCAL INCLUDE 'TBDIF.INC'
C                                       Local include for TBDIF print
C                                       info.
C                                       MAXCOL = max number cols.
      INTEGER   MAXCOL
      PARAMETER (MAXCOL=128)
      INTEGER   NCOL, COLTYP(MAXCOL), COLDIM(MAXCOL), NPSEL,
     *   SELCOL(MAXCOL), SELSTR(MAXCOL), SELLEN(MAXCOL), ONESTR, ONELEN,
     *   TWOSTR, TWOLEN, DIFSTR, DIFLEN, MAXLIN
      CHARACTER TITLE(MAXCOL)*24, UNITS(MAXCOL)*8
C                                        Table I/O arrays
      INTEGER   IVAL1(1024), IVAL2(1024)
      CHARACTER CVAL1*1024, CVAL2*1024
      LOGICAL   LVAL1(1024), LVAL2(1024)
      REAL      RVAL1(1024), RVAL2(1024)
      DOUBLE PRECISION DVAL1(1024), DVAL2(1024)
      EQUIVALENCE (IVAL1, RVAL1, LVAL1, DVAL1),
     *   (IVAL2, RVAL2, LVAL2, DVAL2)
C                                       Summary info
      INTEGER   MAXSUM
C                                       MAXSUM = max entries in summary.
      PARAMETER (MAXSUM = 100)
      INTEGER   NUMSUM, SUMCNT(MAXSUM)
      DOUBLE PRECISION SUMMAX(MAXSUM), SUMMIN(MAXSUM), SUMSUM(MAXSUM),
     *   SUMSU2(MAXSUM)
C                                       Commons
      COMMON /LOCNUM/ DVAL1, DVAL2, NCOL, COLTYP, COLDIM, NPSEL, SELCOL,
     *   SELSTR, SELLEN, ONESTR, ONELEN, TWOSTR, TWOLEN, DIFSTR, DIFLEN,
     *   MAXLIN
      COMMON /SUMCOM/ SUMMAX, SUMMIN, SUMSUM, SUMSU2, NUMSUM, SUMCNT
      COMMON /LOCCHR/ TITLE, UNITS, CVAL1, CVAL2
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(10)
      LOGICAL   LDUM(10)
      REAL      RDUM(10)
      DOUBLE PRECISION DDUM(5)
      EQUIVALENCE (DDUM, RDUM, IDUM, LDUM)
      COMMON /TBDIFG/ DDUM
LOCAL END
      PROGRAM TBDIF
C-----------------------------------------------------------------------
C! Compare selected columns and rows in two similar tables
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999, 2004, 2007, 2009, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Compare selected columns and rows in two similar tables
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, INTAB*36, IN2TAB*36
      INTEGER   IRET, BUFF1(256)
      INCLUDE 'TBDIF.INC'
      DATA PRGM /'TBDIF '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL DIFTIN (PRGM, INTAB, IN2TAB, IRET)
C                                       Process table
      IF (IRET.EQ.0) CALL DIFTAB (INTAB, IN2TAB, IRET)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE DIFTIN (PRGN, INTAB, IN2TAB, IRET)
C-----------------------------------------------------------------------
C   DIFTIN gets input parameters for TBDIF and creates the input objects
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS file
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6, INTAB*36, IN2TAB*36
C
      INTEGER   NKEY1, NKEY2, TYPE, DIM(7)
C                                       NKEY1=no. adverbs to copy to
C                                       INTAB
      PARAMETER (NKEY1=13)
C                                       NKEY2=no. adverbs to copy to
C                                       IN2TAB
      PARAMETER (NKEY2=6)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32, CDUMMY*1
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to INTAB
C                   1         2          3        4         5
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INEXT',
C           6         7         8         9          10        11
     *   'INVERS', 'BCOUNT', 'ECOUNT', 'COMPCOL', 'SELCOL', 'DOCRT',
C           12          13
     *   'OUTPRINT', 'DOALL'/
C                                       May rename adverbs to INTAB
C                    1       2        3        4       5
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'TBLTYPE',
C           6      7         8         9          10        11
     *   'VER', 'BCOUNT', 'ECOUNT', 'COMPCOL', 'SELCOL', 'DOCRT',
C           12          13
     *   'OUTPRINT', 'DOALL'/
C                                       Adverbs to copy to IN2TAB
C                   1          2           3         4          5
      DATA INK2 /'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK', 'INEXT',
C           6
     *   'IN2VERS'/
C                                       May rename adverbs to IN2TAB
C                    1       2        3        4       5
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'TBLTYPE',
C           6
     *   'VER'/
C-----------------------------------------------------------------------
C                                       Startup,  returns "Input" object
C                                       containing POPS adverbs
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       BADDISK
      CALL OGET ('Input', 'BADDISK', TYPE, DIM, IBAD, CDUMMY, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create input object
      INTAB = 'First input table'
      CALL CREATE (INTAB, 'TABLE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, INTAB, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create Output Object
      IN2TAB = 'Second input table'
      CALL CREATE (IN2TAB, 'TABLE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, IN2TAB, IRET)
      IF (IRET.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE DIFTAB (INTAB, IN2TAB, IERR)
C-----------------------------------------------------------------------
C   Compare table.
C   Inputs:
C      INTAB   C*   Name of input table object.
C      IN2TAB  C*   Name of output table object.
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*), IN2TAB*(*)
      INTEGER   IERR
C
      INTEGER   PLUN, PIND, BUFF(256), NACROS, IPCNT, PAGE, TYPE,
     *   DIM(3), ICOL, NCOL, CCOLS(30), NSEL, SCOLS(30), ROW, BC, EC,
     *   NROW, IN2, N2ROW, FSTAB2, FSTMP
      LOGICAL   MATCH, TBCOMP, PAST
      REAL      DOCRT, DOALL
      CHARACTER LPNAME*48, TITL1*132, TITL2*132, SCRTCH*132, LINE*132
      CHARACTER SELLAB(30)*16, CSLL*(16*30), CDUMMY*1
      EQUIVALENCE (SELLAB, CSLL)
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Sort tables
C                                       Lookup columns for selection.
      CALL OGET (INTAB, 'SELCOL', TYPE, DIM, IDUM, CSLL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Sort by first selection column
      CALL TBLSRT (INTAB, SELLAB(1), SELLAB(1), IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TBLSRT (IN2TAB, SELLAB(1), SELLAB(1), IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open input table
      CALL OOPEN (INTAB, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
C                                        Look up relevant columns, CCOLS
C                                        are the columns to compare and
C                                        SCOLS are those for the
C                                        selection.
      CALL THEAD (INTAB, NCOL, CCOLS, NSEL, SCOLS, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        Open output table
      CALL OOPEN (IN2TAB, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open printer
      CALL OGET (INTAB, 'OUTPRINT', TYPE, DIM, IDUM, LPNAME, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'DOALL', TYPE, DIM, IDUM, CDUMMY, IERR)
      DOALL = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'DOCRT', TYPE, DIM, IDUM, CDUMMY, IERR)
      DOCRT = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      IF (LPNAME.EQ.' ') DOCRT = MAX (-1.0, DOCRT)
      CALL LPOPEN (LPNAME, DOCRT, PLUN, PIND, NACROS, BUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      RDUM(1) = DOCRT
      CALL OPUT (INTAB, 'DOCRT', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get number of entries to compare
      CALL OGET (INTAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IERR)
      NROW = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'BCOUNT', TYPE, DIM, IDUM, CDUMMY, IERR)
      BC = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      BC = MIN (MAX (BC, 1), NROW)
      CALL OGET (INTAB, 'ECOUNT', TYPE, DIM, IDUM, CDUMMY, IERR)
      EC = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      IF (EC.LE.0) EC = NROW
      EC = MIN (EC, NROW)
      CALL OGET (IN2TAB, 'NROW', TYPE, DIM, IDUM, CDUMMY, IERR)
      N2ROW = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      PAGE = 0
C                                       Loop over comparison columns
      DO 500 ICOL = 1,NCOL
C                                       Write header info
         CALL PRTHED (INTAB, IN2TAB, CCOLS(ICOL), NSEL, SCOLS, PLUN,
     *      PIND, DOCRT, NACROS, TITL1, TITL2, LINE, IPCNT, PAGE,
     *      SCRTCH, IERR)
C                                       Done?
         IF (IERR.LT.0) GO TO 600
         IF (IERR.NE.0) GO TO 999
C                                       Initialize beginning row in
C                                       second table
         FSTAB2 = 1
C                                       Compare tables
         DO 200 ROW = BC,EC
C                                       Get row number of first match in
C                                       first selection column.
            FSTMP = -1
C                                       Loop through second input table
            DO 100 IN2 = FSTAB2,N2ROW
C                                       Is this a match?
               MATCH = TBCOMP (INTAB, IN2TAB, ROW, IN2, NSEL, SCOLS,
     *            FSTMP, PAST, IERR)
               IF (IERR.NE.0) GO TO 999
C                                       Too far?
               IF (PAST) GO TO 150
               IF (MATCH) THEN
C                                       Display comparison
                  CALL PRTCOM (INTAB, IN2TAB, ROW, IN2, CCOLS(ICOL),
     *               NSEL,  PLUN, PIND, DOALL, DOCRT, NACROS, TITL1,
     *               TITL2, LINE, IPCNT, PAGE, SCRTCH, IERR)
C                                       Done?
                  IF (IERR.LT.0) GO TO 600
                  IF (IERR.NE.0) GO TO 999
                  GO TO 150
                  END IF
 100           CONTINUE
C                                       Update first row for search in
C                                       second table.
 150           IF (FSTMP.GT.FSTAB2) FSTAB2 = FSTMP
 200        CONTINUE
C                                       Print comparison summary if
C                                       appropriate.
         CALL PRTSUM (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
C                                       Done?
         IF (IERR.LT.0) GO TO 600
         IF (IERR.NE.0) GO TO 999
C                                       End comparison col loop
 500     CONTINUE
C                                       Close printer
 600  IERR = 0
      CALL LPCLOS (PLUN, PIND, IPCNT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Close tables
      CALL OCLOSE (INTAB, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OCLOSE (IN2TAB, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE THEAD (INTAB, NCOL, CCOLS, NSEL, SCOLS, IERR)
C-----------------------------------------------------------------------
C   Lookup comparison and selection columns
C   Inputs:
C      INTAB   C*?  Name of first input table object
C   Output:
C      NCOL    I    The number of columns to compare
C      CCOLS   I(*) List of column numbers to compare
C      NSEL    I    Number of selection rows.
C      SCOLS   I(*) Columns numbers of the selection columns
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*)
      INTEGER   NCOL, CCOLS(*), NSEL, SCOLS(*), IERR
C
C                                        MAXCOL = max number cols.
      INTEGER   MAXCOL
      PARAMETER (MAXCOL=128)
      CHARACTER COLLAB(30)*16, CLAB*(16*30), TLABEL(MAXCOL)*24,
     *   TLAB*(24*MAXCOL), COL*24, CDUMMY*1
      INTEGER   TYPE, DIM(7), I, J, NC, NICOL, IEND, JEND, ITRIM, IL
      LOGICAL   BADCOL
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
C                                       Need to equivalence character
C                                       arrays for OGET
      EQUIVALENCE (COLLAB, CLAB), (TLABEL, TLAB)
C-----------------------------------------------------------------------
      NCOL = 0
      NSEL = 0
      BADCOL = .FALSE.
C                                       Fetch Input table info
      CALL OGET (INTAB, 'NCOL', TYPE, DIM, IDUM, CDUMMY, IERR)
      NC = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'COLABEL', TYPE, DIM, IDUM, TLAB, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Lookup columns for comparison.
      CALL OGET (INTAB, 'COMPCOL', TYPE, DIM, IDUM, CLAB, IERR)
      IF (IERR.NE.0) GO TO 999
      NICOL = DIM(2)
C                                        Look up columns in input
      DO 200 I = 1,NICOL
C                                        Blank entry?
         IF (COLLAB(I).NE.' ') THEN
C                                        Given column number?
            IF (COLLAB(I)(1:5) .EQ. 'COL#(') THEN
C                                       Parse column number.
               JEND = INDEX (COLLAB(I), ')') - 1
C                                        Found closing )?
               IF (JEND.LE.0) GO TO 110
               IEND = MAX (JEND, 6)
               COL = '        '
               COL(14-IEND:8) = COLLAB(I)(6:IEND)
               READ (COL,1000,ERR=110) J
C                                       Valid column number?
               IF ((J.LE.0) .OR. (J.GT.NC)) THEN
C                                        Invalid column number
                  MSGTXT = 'INVALID COLUMN NUMBER: ' // COLLAB(I)
                  CALL MSGWRT (6)
                  BADCOL = .TRUE.
                  GO TO 200
                  END IF
C                                       Looks OK - process
               GO TO 120
            ELSE
C                                       Check list of column names
               DO 100 J = 1,NC
                  IF (COLLAB(I).EQ.TLABEL(J)(1:16)) GO TO 120
 100              CONTINUE
               IL = ITRIM (COLLAB(I))
               DO 105 J = 1,NC
                  IF (COLLAB(I)(:IL).EQ.TLABEL(J)(:IL)) GO TO 120
 105              CONTINUE
               END IF
C                                        If it got here the column
C                                        wasn't found.
            MSGTXT = 'COULD NOT FIND COLUMN: '// COLLAB(I)
            CALL MSGWRT (6)
            MSGTXT = 'CHECK SPELLING, IGNORING REQUEST'
            CALL MSGWRT (6)
            BADCOL = .TRUE.
            GO TO 200
C                                        Decode error for col.
 110        MSGTXT = 'ERROR DECODING COLUMN NUMBER: ' // COLLAB(I)
            CALL MSGWRT (6)
            BADCOL = .TRUE.
            GO TO 200
C                                        OK: Save column number
 120        NCOL = NCOL + 1
            CCOLS(NCOL) = J
            END IF
 200     CONTINUE
C                                        Better have some columns
      IF (NCOL.LE.0) THEN
         MSGTXT = 'ERROR: NO COMPARISON COLUMNS SELECTED'
         CALL MSGWRT (8)
         IERR = 5
         GO TO 999
         END IF
C                                       Lookup columns for selection.
      CALL OGET (INTAB, 'SELCOL', TYPE, DIM, IDUM, CLAB, IERR)
      IF (IERR.NE.0) GO TO 999
      NICOL = DIM(2)
C                                        Look up columns in input
      DO 400 I = 1,NICOL
C                                        Blank entry?
         IF (COLLAB(I).NE.'     ') THEN
C                                        Given column number?
            IF (COLLAB(I)(1:5) .EQ. 'COL#(') THEN
C                                       Parse column number.
               JEND = INDEX (COLLAB(I), ')') - 1
C                                        Found closing )?
               IF (JEND.LE.0) GO TO 310
               IEND = MAX (JEND, 6)
               COL = '        '
               COL(14-IEND:8) = COLLAB(I)(6:IEND)
               READ (COL,1000,ERR=310) J
C                                       Valid column number?
               IF ((J.LE.0) .OR. (J.GT.NC)) THEN
C                                        Invalid column number
                  MSGTXT = 'INVALID COLUMN NUMBER: ' // COLLAB(I)
                  CALL MSGWRT (6)
                  BADCOL = .TRUE.
                  GO TO 400
                  END IF
C                                       Looks OK - process
               GO TO 320
            ELSE
C                                       Check list of column names
               DO 300 J = 1,NC
                  IF (COLLAB(I).EQ.TLABEL(J)(1:16)) GO TO 320
 300              CONTINUE
               IL = ITRIM (COLLAB(I))
               DO 305 J = 1,NC
                  IF (COLLAB(I)(:IL).EQ.TLABEL(J)(:IL)) GO TO 320
 305              CONTINUE
               END IF
C                                        If it got here the column
C                                        wasn't found.
            MSGTXT = 'COULD NOT FIND COLUMN: '// COLLAB(I)
            CALL MSGWRT (6)
            MSGTXT = 'CHECK SPELLING, IGNORING REQUEST'
            CALL MSGWRT (6)
            BADCOL = .TRUE.
            GO TO 400
C                                        Decode error for col.
 310        MSGTXT = 'ERROR DECODING COLUMN NUMBER: ' // COLLAB(I)
            CALL MSGWRT (6)
            BADCOL = .TRUE.
            GO TO 400
C                                        OK: Save column number
 320        NSEL = NSEL + 1
            SCOLS(NSEL) = J
            END IF
 400     CONTINUE
C                                        Better have some columns
      IF (NSEL.LE.0) THEN
         MSGTXT = 'ERROR: NO SELECTION COLUMNS SELECTED'
         CALL MSGWRT (8)
         IERR = 5
         GO TO 999
         END IF
C                                        Warn if bad columns detected.
      IF (BADCOL) THEN
         MSGTXT = 'Warning: Problems were encountered in selecting' //
     *      ' some columns'
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I8)
      END
      SUBROUTINE PRTHED (INTAB, IN2TAB, COL, NSEL, SCOLS, PLUN, PIND,
     *   DOCRT, NACROS, TITL1, TITL2, LINE, IPCNT, PAGE, SCRTCH, IERR)
C-----------------------------------------------------------------------
C   Prints a header and prepares page titles for the comparison of a
C   given column.
C   Inputs:
C      INTAB   C*?  Name of first input table object
C      IN2TAB  C*?  Name of second input table object
C      COL     I    Column number to compare.
C      NSEL    I    Number of selection rows.
C      SCOLS   I(*) Columns numbers of the selection columns
C      PLUN    I       LUN for print device (open): 1 => line printer,
C                         3 => text (disk) file, 5 => terminal
C      PIND    I       FTAB pointer for print device
C      DOCRT   R       > 0. => use CRT, else line printer or disk
C      NC      I       Number characters in line
C      TITL1   C*132   Page title line 1, if ' ' then ignored
C      TITL2   C*132   Page title line 2, if ' ' then ignored
C      LINE    C*132   Text line, printed even if ' '
C   In/out:
C      IPCNT   I       Number lines so far on page
C                         > 1000 => just ask about continuing (DOCRT
C                                   true).  Do not print anything.
C                         =  999 => print new page title(s) and LINE
C                                   but do not ask the user about
C                                   whether he wants to continue
C      PAGE    I       Current page number
C                         = 0 => start of print job (user not asked on
C                                DOCRT true)
C   Output:
C      SCRTCH  C*(*)   Scratch core > 132
C      IERR    I       Error code: 0 => OK, -1 user asks to quit
C   Hints:
C      (1) First call: set IPAGE = 0, IPCNT = (e.g.) 990
C      (2) Thereafter, leave IPCNT and IPAGE alone in your code, unless
C      (3) to force a page break, reset IPCNT to (e.g.) 990
C   where 990 is an arbitrary number < 999 and > number of lines on the
C   printer page.
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*), IN2TAB*(*), TITL1*132, TITL2*132, SCRTCH*132,
     *   LINE*132
      INTEGER   COL, NSEL, PLUN, PIND, NACROS, IPCNT, PAGE, IERR
      INTEGER   SCOLS(NSEL)
      REAL      DOCRT
C
      CHARACTER NAME*12, CLASS*6, TTYPE*2, CDUMMY*1
      INTEGER   SEQ, DISK, VER, TYPE, DIM(7), I, J
      INCLUDE 'TBDIF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Setup columns in output
      CALL PRTSCL (INTAB, NACROS, COL, NSEL, SCOLS, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Initialize summary
      CALL SUMINI (COL)
C                                       Labels
      TITL1 = ' '
      TITL2 = ' '
      LINE = ' Comparison of ' // TITLE(COL) // ' column'
      IPCNT = 990
      IF (DOCRT.GT.-2.5) THEN
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       Tell which table being compared.
C                                       First table
         CALL OGET (INTAB, 'NAME', TYPE, DIM, IDUM, NAME, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OGET (INTAB, 'CLASS', TYPE, DIM, IDUM, CLASS, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OGET (INTAB, 'IMSEQ', TYPE, DIM, IDUM, CDUMMY, IERR)
         SEQ = IDUM(1)
         IF (IERR.NE.0) GO TO 999
         CALL OGET (INTAB, 'DISK', TYPE, DIM, IDUM, CDUMMY, IERR)
         DISK = IDUM(1)
         IF (IERR.NE.0) GO TO 999
         CALL OGET (INTAB, 'TBLTYPE', TYPE, DIM, IDUM, TTYPE, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OGET (INTAB, 'VER', TYPE, DIM, IDUM, CDUMMY, IERR)
         VER = IDUM(1)
         IF (IERR.NE.0) GO TO 999
         WRITE (LINE,1001) NAME, CLASS, SEQ, DISK, TTYPE, VER
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       Second table
         CALL OGET (IN2TAB, 'NAME', TYPE, DIM, IDUM, NAME, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OGET (IN2TAB, 'CLASS', TYPE, DIM, IDUM, CLASS, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OGET (IN2TAB, 'IMSEQ', TYPE, DIM, IDUM, CDUMMY, IERR)
         SEQ = IDUM(1)
         IF (IERR.NE.0) GO TO 999
         CALL OGET (IN2TAB, 'DISK', TYPE, DIM, IDUM, CDUMMY, IERR)
         DISK = IDUM(1)
         IF (IERR.NE.0) GO TO 999
         CALL OGET (IN2TAB, 'TBLTYPE', TYPE, DIM, IDUM, TTYPE, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OGET (IN2TAB, 'VER', TYPE, DIM, IDUM, CDUMMY, IERR)
         VER = IDUM(1)
         IF (IERR.NE.0) GO TO 999
         WRITE (LINE,1002) NAME, CLASS, SEQ, DISK, TTYPE, VER
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
C                                       Column labels
C                                       Selection columns
      DO 20 I = 1,NPSEL
         J = SELCOL(I)
         TITL1(SELSTR(I):SELSTR(I)+SELLEN(I)-1) =
     *      TITLE(J)(1:MIN (SELLEN(I),24))
         TITL2(SELSTR(I):SELSTR(I)+SELLEN(I)-1) =
     *      UNITS(J)(1:MIN (SELLEN(I), 8))
 20      CONTINUE
C                                       Comparison
      TITL1(ONESTR:ONESTR+ONELEN-1) = TITLE(COL)(1:MIN (ONELEN,24))
      TITL2(ONESTR:ONESTR+ONELEN-1) =
     *   UNITS(COL)(1:MIN (ONELEN, 8))
      TITL1(TWOSTR:TWOSTR+TWOLEN-1) = 'Second'
      TITL2(TWOSTR:TWOSTR+TWOLEN-1) =
     *   UNITS(COL)(1:MIN (TWOLEN, 8))
      IF (DIFLEN.GT.0) THEN
         TITL1(DIFSTR:DIFSTR+DIFLEN-1) = 'Difference'
         TITL2(DIFSTR:DIFSTR+DIFLEN-1) =
     *      UNITS(COL)(1:MIN (DIFLEN, 8))
         END IF
C                                       Print blank line and col.
C                                       labels.
      IF (DOCRT.GT.-2.5) THEN
         LINE = ' '
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
      CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, TITL1,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, TITL2,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
      GO TO 999
C                                       Error printing
 900  IF (IERR.GT.0) THEN
         MSGTXT = 'ERROR PRINTING TABLE COMPARISON'
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1001 FORMAT ('First table  : ',A,'.',A,'.',I3,' Disk =', I2,1X,A,
     *   ' Table',I4)
 1002 FORMAT ('Second table : ',A,'.',A,'.',I3,' Disk =', I2,1X,A,
     *   ' Table',I4)
      END
      SUBROUTINE PRTSCL (INTAB, NACROS, COL, NSEL, SCOLS, IERR)
C-----------------------------------------------------------------------
C   Determines the number of characters required for each column.
C   Assumes formats D13.6, E10.3, I10, L8
C   Inputs:
C      INTAB   C*?  Name of input table object
C      NACROS  I    Number of columns avainable in output
C      COL     I    Column number to compare.
C      NSEL    I    Number of selection rows.
C      SCOLS   I(*) Columns numbers of the selection columns
C   Outputs in common:
C      NCOL    I     Number of columns in table
C      TITLE   C(*)*24 Column lables
C      UNITS   C(*)*8  Column Units
C      COLTYP  I(*)  type of column: 1-7 = dp, sp, ch, i, l, i
C                    11,12 = dp and sp time in D/HMS
C      COLDIM  I(*)  Dimensionality of column
C      NPSEL   I     Number of selection columns to print
C      SELCOL  I(*)  Column number of selection cols to be printed.
C      SELSTR  I(*)  Start column of selection columns
C      SELLEN  I(*)  Number of columns in output for selection cols.
C      ONESTR  I     Start column for comparison value in first table.
C      ONELEN  I     Number of columns for comparison value in first.
C      TWOSTR  I     Start column for comparison value in second table.
C      TWOLEN  I     Number of columns for comparison value in second.
C      DIFSTR  I     Start column for difference.
C      DIFLEN  I     Number of columns for difference; 0 => column type
C                    that is not suitable for subtraction.
C      MAXLIN  I     Maximum dimensionality (lines printed per
C                    comparison).
C   Output:
C      IERR    I     Error code
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*)
      INTEGER   COL, NACROS, NSEL, SCOLS(*), IERR
C
      INCLUDE 'TBDIF.INC'
      INTEGER   TYPE, DIM(7), NCH(MAXCOL), LCH(7),  I, J, LENGTH, NCOMP,
     *   NEXT
      CHARACTER CTITLE*(24*MAXCOL), CUNITS*(MAXCOL*8), CDUMMY*1
      EQUIVALENCE (TITLE, CTITLE), (UNITS, CUNITS)
      INCLUDE 'GFORT'
      DATA LCH /15, 12, 0, 12, 10, 10, 0/
C-----------------------------------------------------------------------
C                                       Get table info
      CALL OGET (INTAB, 'NCOL', TYPE, DIM, IDUM, CDUMMY, IERR)
      NCOL = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'COLUNIT', TYPE, DIM, IDUM, CUNITS, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'COLABEL', TYPE, DIM, IDUM, CTITLE, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'COLTYPE', TYPE, DIM, COLTYP, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INTAB, 'COLDIM', TYPE, DIM, COLDIM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get types and number of columns
C                                       needed for each column in the
C                                       table.
      DO 20 J = 1,NCOL
C                                       basics
         I = COLTYP(J)
         LENGTH = COLDIM(J)
         NCH(J) = LCH(I)
C                                       is it a time?
         IF ((COLTYP(J).LE.2) .AND. (UNITS(J)(1:4).EQ.'DAYS')) THEN
            UNITS(J) = 'd/h:m:s'
            COLTYP(J) = 10 + COLTYP(J)
            IF (COLTYP(J).EQ.11) NCH(J) = 16
            IF (COLTYP(J).EQ.12) NCH(J) = 14
            END IF
C                                       Get length of character or bit
C                                       arrays.
         IF ((I.EQ.3) .OR. (I.EQ.7)) NCH(J) = LENGTH
C                                       Minimum entry = 10 characters
         NCH(J) = MAX (NCH(J), 10)
 20      CONTINUE
C                                       Determine the maximum number of
C                                       lines needed for print
      IF (COLTYP(COL).EQ.3) THEN
         MAXLIN = 1
      ELSE
         MAXLIN = COLDIM(COL)
         END IF
C                                       Determine number of columns
C                                       needed for comparison.
C                                       Don't need difference column
C                                       except for numeric types.
      IF ((COLTYP(COL).EQ.1) .OR. (COLTYP(COL).EQ.2) .OR.
     *   (COLTYP(COL).EQ.4)) THEN
         NCOMP = 3 * NCH(COL)
      ELSE
         NCOMP = 2 * NCH(COL)
         END IF
C                                       Comparison starts and lengths
      ONESTR = NACROS - NCOMP + 1
      ONELEN = NCH(COL)
      TWOSTR = ONESTR + ONELEN
      TWOLEN = NCH(COL)
      DIFSTR = TWOSTR + TWOLEN
C                                       Only difference numeric types
      IF ((COLTYP(COL).EQ.1) .OR. (COLTYP(COL).EQ.2) .OR.
     *   (COLTYP(COL).EQ.4) .OR. (COLTYP(COL).GT.10)) THEN
         DIFLEN = NCH(COL)
      ELSE
         DIFLEN = 0
         END IF
C                                       Set up for all selection strings
C                                       that will fit.
      NPSEL = 0
C                                       Set start column for selection
C                                       columns.
      NEXT = 7
      DO 50 I = 1,NSEL
         J = SCOLS(I)
         IF ((NEXT+NCH(J)).LT.ONESTR) THEN
            NPSEL = NPSEL + 1
            SELSTR(NPSEL) = NEXT
            SELLEN(NPSEL) = NCH(J)
            SELCOL(NPSEL) = SCOLS(I)
            NEXT = NEXT + SELLEN(NPSEL)
C                                       Only one line for characters
            IF (COLTYP(J).NE.3) MAXLIN = MAX (MAXLIN, COLDIM(J))
            END IF
 50      CONTINUE
C                                       Compress any space in center of
C                                       listing.

      IF (ONESTR.GT.NEXT) THEN
         ONESTR = NEXT
         TWOSTR = ONESTR + ONELEN
         DIFSTR = TWOSTR + TWOLEN
         END IF
C
 999  RETURN
      END
      LOGICAL FUNCTION TBCOMP (INTAB, IN2TAB, ROW1, ROW2, NSEL, SCOLS,
     *   FSTMP, PAST, IERR)
C-----------------------------------------------------------------------
C   Compares rows in two tables to see if they match according to a set
C   of selection criteia.  For a match all data in the selected columns
C   must match according to the following criteria:
C     Double:    abs (difference)/abs (value1) < 1.0D-10
C     Real:      abs (difference)/abs (value1) < 1.0D-5
C     Character: exact
C     Integer:   exact
C     Logical:   exact
C     Other:     no comparison => always match
C   Note: the row number of the first match to the first selection
C   column is also set.  If this has not yet occurred then the input
C   value of FSTMP should be < 0.  If a match is found then the row
C   number in the second table is passed in FSTMP.
C      If FSTMP is true and the first selection column does not match
C   then the current record is past a possible match and PAST is set
C   true, else false.
C   Inputs:
C      INTAB   C*?  Name of first input table object
C      IN2TAB  C*?  Name of second input table object
C      ROW1    I    Row in first table
C      ROW2    I    Row in second table
C      NSEL    I    Number of selection rows.
C      SCOLS   I(*) Columns numbers of the selection columns
C   Output:
C      FSTMP   I    First row in second input table with a match on
C                   the first selection column
C      PAST    L    If true then this record is past the last possible
C                   match.
C      IERR    I    Error code, 0=OK else failed.
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*), IN2TAB*(*)
      INTEGER   ROW1, ROW2, NSEL, FSTMP, IERR
      LOGICAL   PAST
      INTEGER   SCOLS(NSEL)
C
      INCLUDE 'TBDIF.INC'
      INTEGER   I, TYPE, DIM(7), ISEL, LEN, TEST
      LOGICAL   LTEST
      REAL      RCOMP
      DOUBLE PRECISION DCOMP
C-----------------------------------------------------------------------
      TBCOMP = .FALSE.
C                                       Loop over selection criteria
      DO 500 ISEL = 1,NSEL
C                                       Get entries
         CALL TABDGT (INTAB, ROW1, SCOLS(ISEL), TYPE, DIM, IVAL1, CVAL1,
     *      IERR)
C                                       If blanked return
         IF (IERR.LT.0) THEN
            IERR = 0
            GO TO 999
            END IF
         IF (IERR.NE.0) GO TO 999
         CALL TABDGT (IN2TAB, ROW2, SCOLS(ISEL), TYPE, DIM, IVAL2,
     *      CVAL2, IERR)
C                                       If blanked return
         IF (IERR.LT.0) THEN
            IERR = 0
            GO TO 999
            END IF
         IF (IERR.NE.0) GO TO 999
         IF (IERR.NE.0) GO TO 999
C                                       Total number of values
         LEN = DIM(1)
         IF (DIM(2).GT.1) LEN = LEN * DIM(2)
         IF (DIM(3).GT.1) LEN = LEN * DIM(3)
C                                       Compare by type
         IF (TYPE.EQ.1) THEN
C                                       Double precision
            DO 110 I = 1,LEN
               DCOMP = ABS (DVAL1(I))
               IF (DCOMP.LT.1.0D-30) DCOMP = 1.0D0
               LTEST = (ABS (DVAL1(I)-DVAL2(I)) / DCOMP) .GT. 1.0D-10
C                                       Past match?
               IF ((ISEL.EQ.1) .AND. (I.EQ.1)) PAST = (FSTMP.GT.0) .AND.
     *            LTEST
               IF (LTEST) GO TO 999
 110           CONTINUE
         ELSE IF (TYPE.EQ.2) THEN
C                                       Real
            DO 120 I = 1,LEN
               RCOMP = ABS (RVAL1(I))
               IF (RCOMP.LT.1.0E-25) RCOMP = 1.0
               LTEST = (ABS (RVAL1(I)-RVAL2(I)) / RCOMP) .GT. 1.0E-5
C                                       Past match?
               IF ((ISEL.EQ.1) .AND. (I.EQ.1)) PAST = (FSTMP.GT.0) .AND.
     *            LTEST
               IF (LTEST) GO TO 999
 120           CONTINUE
         ELSE IF (TYPE.EQ.3) THEN
C                                       Character
C                                       Found first match of first
C                                       selection column, only test up
C                                       to 8 char.
            TEST = MIN (8, LEN)
            LTEST = (CVAL1(1:TEST).NE.CVAL2(1:TEST))
            IF ((ISEL.EQ.1) .AND. (FSTMP.LE.0) .AND. (.NOT.LTEST))
     *         FSTMP = ROW2
C                                       Past match?
            IF (ISEL.EQ.1) PAST = (FSTMP.GT.0) .AND. LTEST
            IF (CVAL1(1:LEN).NE.CVAL2(1:LEN)) GO TO 999
         ELSE IF (TYPE.EQ.4) THEN
C                                       Integer
            DO 140 I = 1,LEN
               LTEST = IVAL1(I).NE.IVAL2(I)
C                                       Past match?
               IF ((ISEL.EQ.1) .AND. (I.EQ.1)) PAST = (FSTMP.GT.0) .AND.
     *            LTEST
               IF (LTEST) GO TO 999
 140           CONTINUE
         ELSE IF (TYPE.EQ.5) THEN
C                                       Logical
            DO 150 I = 1,LEN
               IF (LVAL1(I).NEQV.LVAL2(I)) GO TO 999
 150           CONTINUE
         ELSE
C                                       Comparisons of other types
C                                       unimplemented.
            END IF
C                                       Found first match of first
C                                       selection column?
         IF ((ISEL.EQ.1) .AND. (FSTMP.LE.0)) FSTMP = ROW2
 500     CONTINUE
C                                       Everything seems to match
      TBCOMP = .TRUE.
C
 999  RETURN
      END
      SUBROUTINE  PRTCOM (INTAB, IN2TAB, ROW1, ROW2, COL, NSEL,
     *   PLUN, PIND, DOALL, DOCRT, NACROS, TITL1, TITL2, LINE, IPCNT,
     *   PAGE, SCRTCH, IERR)
C-----------------------------------------------------------------------
C   Prints a comparison of the contents of a selected row and column in
C   a pair of tables.
C   Also updates comparison summary arrays.
C   Note: uses common variables set by PRTSCL.
C   Inputs:
C      INTAB   C*?  Name of first input table object
C      IN2TAB  C*?  Name of second input table object
C      ROW1    I    Row in first table
C      ROW2    I    Row in second table
C      COL     I    Column number to compare.
C      NSEL    I    Number of selection rows.
C      PLUN    I    LUN for print device (open): 1 => line printer,
C                     3 => text (disk) file, 5 => terminal
C      PIND    I    FTAB pointer for print device
C      DOALL   R    > 0 print everything
C      DOCRT   R    > 0. => use CRT, else line printer or disk
C      NACROS  I    Number characters in line
C      TITL1   C*132   Page title line 1, if ' ' then ignored
C      TITL2   C*132   Page title line 2, if ' ' then ignored
C   In/out:
C      LINE    C*132   Text line
C      IPCNT   I       Number lines so far on page
C                         > 1000 => just ask about continuing (DOCRT
C                                   true).  Do not print anything.
C                         =  999 => print new page title(s) and LINE
C                                   but do not ask the user about
C                                   whether he wants to continue
C      PAGE    I       Current page number
C                         = 0 => start of print job (user not asked on
C                                DOCRT true)
C   Output:
C      SCRTCH  C*(*)   Scratch core > 132
C      IERR    I       Error code: 0 => OK, -1 user asks to quit
C-----------------------------------------------------------------------
      CHARACTER INTAB*(*), IN2TAB*(*), TITL1*132, TITL2*132, SCRTCH*132,
     *   LINE*132
      INTEGER   ROW1, ROW2, COL, NSEL, PLUN, PIND, NACROS, IPCNT, PAGE,
     *   IERR
      REAL      DOALL, DOCRT
C
      INCLUDE 'TBDIF.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INTEGER   J, TYPE, DIM(7), ISEL, LEN, IB, IE, IB2, IE2, IBD,
     *   IED
      REAL      RCOMP
      DOUBLE PRECISION DCOMP, DSCALE
      LOGICAL   DIFFER
C-----------------------------------------------------------------------
C                                       Loop over number of lines per
C                                       comparison.
      DO 600 J = 1,MAXLIN
         LINE = ' '
         DIFFER = DOALL.GT.0.0
C                                       Row number
         WRITE (LINE(1:5),1000) ROW1
C                                       Loop over selection criteria
         DO 200 ISEL = 1,NSEL
C                                       Get value
            CALL TABDGT (INTAB, ROW1, SELCOL(ISEL), TYPE, DIM, IVAL1,
     *         CVAL1, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       Total number of values
            LEN = DIM(1)
            IF (DIM(2).GT.1) LEN = LEN * DIM(2)
            IF (DIM(3).GT.1) LEN = LEN * DIM(3)
C                                       Is this column done?
            IF (LEN.LT.J) GO TO 200
C                                       Strings printed on top line only
            IF ((TYPE.EQ.3) .AND. (J.GT.1)) GO TO 200
C                                       Which columns?
            IB = SELSTR(ISEL)
            IE = SELSTR(ISEL) + SELLEN(ISEL) - 1
C                                       Print by type
            IF (TYPE.EQ.1) THEN
C                                       Double precision
               IF (DVAL1(J).EQ.DBLANK) THEN
                  LINE(IB:IE) = ' blanked'
               ELSE
C                                       Time?
                  IF (COLTYP(SELCOL(ISEL)).GT.10) THEN
                     CALL DTHMS (DVAL1(J), LINE(IB:IE))
                  ELSE
                     WRITE (LINE(IB:IE), 1100) DVAL1(J)
                     END IF
                  END IF
            ELSE IF (TYPE.EQ.2) THEN
C                                       Real
               IF (RVAL1(J).EQ.FBLANK) THEN
                  LINE(IB:IE) = ' blanked'
               ELSE
C                                       Time?
                  IF (COLTYP(SELCOL(ISEL)).GT.10) THEN
                     CALL RTHMS (RVAL1(J), LINE(IB:IE))
                  ELSE
                     WRITE (LINE(IB:IE), 1200) RVAL1(J)
                     END IF
                  END IF
            ELSE IF (TYPE.EQ.3) THEN
C                                       Character
               LINE(IB:IE) = CVAL1(1:MAX (LEN,SELLEN(ISEL)))
            ELSE IF (TYPE.EQ.4) THEN
C                                       Integer
               WRITE (LINE(IB:IE), 1400) IVAL1(J)
            ELSE IF (TYPE.EQ.5) THEN
C                                       Logical
               WRITE (LINE(IB:IE), 1500) LVAL1(J)
            ELSE
C                                       Printing of other types
C                                       unimplemented.
               END IF
 200        CONTINUE
C                                       Comparison
C                                       Get from first table
         CALL TABDGT (INTAB, ROW1, COL, TYPE, DIM, IVAL1, CVAL1, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Total number of values
         LEN = DIM(1)
         IF (DIM(2).GT.1) LEN = LEN * DIM(2)
         IF (DIM(3).GT.1) LEN = LEN * DIM(3)
C                                       Is this column done?
         IF (LEN.LT.J) GO TO 500
C                                       Strings printed on 1st line only
         IF ((TYPE.EQ.3) .AND. (J.GT.1)) GO TO 500
C                                       Get value from second table
         CALL TABDGT (IN2TAB, ROW2, COL, TYPE, DIM, IVAL2, CVAL2, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Which columns?
         IB = ONESTR
         IE = ONESTR + ONELEN - 1
         IB2 = TWOSTR
         IE2 = TWOSTR + TWOLEN - 1
         IBD = DIFSTR
         IED = DIFSTR + DIFLEN - 1
C                                       Print by type
         IF (TYPE.EQ.1) THEN
C                                       Double precision
C                                       First
            IF (DVAL1(J).EQ.DBLANK) THEN
               LINE(IB:IE) = ' blanked'
            ELSE
               WRITE (LINE(IB:IE), 1100) DVAL1(J)
               END IF
C                                       Second
            IF (DVAL2(J).EQ.DBLANK) THEN
               LINE(IB2:IE2) = ' blanked'
            ELSE
               WRITE (LINE(IB2:IE2), 1100) DVAL2(J)
               END IF
C                                       Difference
            IF ((DVAL1(J).EQ.DBLANK) .OR. (DVAL2(J).EQ.DBLANK)) THEN
               LINE(IBD:IED) = ' blanked'
               IF (DVAL1(J).NE.DVAL2(J)) DIFFER = .TRUE.
            ELSE
               DCOMP = DVAL1(J) - DVAL2(J)
               WRITE (LINE(IBD:IED), 1100) DCOMP
               DSCALE = MAX (ABS(DVAL1(J)), ABS(DVAL2(J)))
               IF (DSCALE.EQ.0.0D0) DSCALE = 1.0D0
               IF (ABS(DCOMP/DSCALE).GT.1.D-6) DIFFER = .TRUE.
C                                       Summary information
               IF (J.LE.MAXSUM) THEN
                  SUMCNT(J) = SUMCNT(J) + 1
                  SUMMAX(J) = MAX (SUMMAX(J), DCOMP)
                  SUMMIN(J) = MIN (SUMMIN(J), DCOMP)
                  SUMSUM(J) = SUMSUM(J) + DCOMP
                  SUMSU2(J) = SUMSU2(J) + DCOMP * DCOMP
                  END IF
               END IF
         ELSE IF (TYPE.EQ.2) THEN
C                                       Real
C                                       First
            IF (RVAL1(J).EQ.FBLANK) THEN
               LINE(IB:IE) = ' blanked'
            ELSE
               WRITE (LINE(IB:IE), 1200) RVAL1(J)
               END IF
C                                       Second
            IF (RVAL2(J).EQ.FBLANK) THEN
               LINE(IB2:IE2) = ' blanked'
            ELSE
               WRITE (LINE(IB2:IE2), 1200) RVAL2(J)
               END IF
C                                       Difference
            IF ((RVAL1(J).EQ.FBLANK) .OR. (RVAL2(J).EQ.FBLANK)) THEN
               LINE(IBD:IED) = ' blanked'
               IF (RVAL1(J).NE.RVAL2(J)) DIFFER = .TRUE.
            ELSE
               RCOMP = RVAL1(J) - RVAL2(J)
               DSCALE = MAX (ABS(RVAL1(J)), ABS(RVAL2(J)))
               IF (DSCALE.EQ.0.0D0) DSCALE = 1.0D0
               IF (ABS(RCOMP/DSCALE).GT.1.D-5) DIFFER = .TRUE.
C                                       If units are 'DEG' then reduce
C                                       to range (-180,180)
               IF (UNITS(COL)(1:3).EQ.'DEG') THEN
                  RCOMP = MOD (RCOMP, 360.0)
                  IF (RCOMP.GT. 180.0) RCOMP = RCOMP - 360.0
                  IF (RCOMP.LT.-180.0) RCOMP = RCOMP + 360.0
                  END IF
               WRITE (LINE(IBD:IED), 1200) RCOMP
C                                       Summary information
               IF (J.LE.MAXSUM) THEN
                  DCOMP = RCOMP
                  SUMCNT(J) = SUMCNT(J) + 1
                  SUMMAX(J) = MAX (SUMMAX(J), DCOMP)
                  SUMMIN(J) = MIN (SUMMIN(J), DCOMP)
                  SUMSUM(J) = SUMSUM(J) + DCOMP
                  SUMSU2(J) = SUMSU2(J) + DCOMP * DCOMP
                  END IF
               END IF
         ELSE IF (TYPE.EQ.3) THEN
C                                       Character
            LINE(IB:IE) = CVAL1(1:MAX (LEN,ONELEN))
            LINE(IB2:IE2) = CVAL2(1:MAX (LEN,TWOLEN))
            IF (LINE(IB:IE).NE.LINE(IB2:IE2)) DIFFER = .TRUE.
         ELSE IF (TYPE.EQ.4) THEN
C                                       Integer
            WRITE (LINE(IB:IE), 1400) IVAL1(J)
            WRITE (LINE(IB2:IE2), 1400) IVAL2(J)
            WRITE (LINE(IBD:IED), 1400) IVAL1(J)-IVAL2(J)
            RCOMP = IVAL1(J) - IVAL2(J)
            DSCALE = MAX (ABS(IVAL1(J)), ABS(IVAL2(J)))
            IF (DSCALE.EQ.0.0D0) DSCALE = 1.0D0
            IF (ABS(RCOMP/DSCALE).GT.1.D-5) DIFFER = .TRUE.
C                                       Summary information
            IF (J.LE.MAXSUM) THEN
               DCOMP = IVAL1(J)-IVAL2(J)
               SUMCNT(J) = SUMCNT(J) + 1
               SUMMAX(J) = MAX (SUMMAX(J), DCOMP)
               SUMMIN(J) = MIN (SUMMIN(J), DCOMP)
               SUMSUM(J) = SUMSUM(J) + DCOMP
               SUMSU2(J) = SUMSU2(J) + DCOMP * DCOMP
               END IF
         ELSE IF (TYPE.EQ.5) THEN
C                                       Logical
            WRITE (LINE(IB:IE), 1500) LVAL1(J)
            WRITE (LINE(IB2:IE2), 1500) LVAL2(J)
            IF (LVAL1(J).NEQV.LVAL2(J)) DIFFER = .TRUE.
         ELSE
C                                       Printing of other types
C                                       unimplemented.
            END IF
C                                       Print it
 500     IF (DIFFER) THEN
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
 600     CONTINUE
      GO TO 999
C                                       Error printing
 900  IF (IERR.GT.0) THEN
         MSGTXT = 'ERROR PRINTING TABLE COMPARISON'
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I5)
 1100 FORMAT (1PD13.6)
 1200 FORMAT (1PE10.3)
 1400 FORMAT (I10)
 1500 FORMAT (L8)
      END
      SUBROUTINE DTHMS (TIME, STRING)
C-----------------------------------------------------------------------
C   Routine to convert double precision time to string giving day, hour,
C   min, sec.
C   Inputs:
C      TIME   D    Time in days.
C   Outputs:
C      STRING C*?  Time as string "ddd/hh:mm:ss.sss".  Note: if STRING
C                  is shorter then it will be truncated from the right.
C-----------------------------------------------------------------------
      DOUBLE PRECISION TIME
      CHARACTER STRING*(*)
C
      INTEGER   DAY, HM(2), SL
      REAL      S
      CHARACTER CHSIGN*1, TSTR*16
      DOUBLE PRECISION T
C-----------------------------------------------------------------------
C                                       Convert time
      DAY = TIME
      T = (TIME - DAY) * 24.0D0
      CALL COORDD (2, T, CHSIGN, HM, S)
C                                       Encode into string
      WRITE (TSTR,1000) DAY, HM, S
      IF (TSTR(11:11).EQ.' ') TSTR(11:11) = '0'
C                                       Copy to output
      SL = MIN (LEN (STRING), 16)
      STRING = TSTR(1:SL)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I3,'/',I2.2,':',I2.2,':',F6.3)
      END
      SUBROUTINE RTHMS (TIME, STRING)
C-----------------------------------------------------------------------
C   Routine to convert single precision time to string giving day, hour,
C   min, sec.
C   Inputs:
C      TIME   R    Time in days.
C   Outputs:
C      STRING C*?  Time as string "ddd/hh:mm:ss.sss".  Note: if STRING
C                  is shorter then it will be truncated from the right.
C-----------------------------------------------------------------------
      REAL      TIME
      CHARACTER STRING*(*)
C
      INTEGER   DAY, HM(2), SL
      REAL      S
      CHARACTER CHSIGN*1, TSTR*16
      DOUBLE PRECISION T
C-----------------------------------------------------------------------
C                                       Convert time
      DAY = TIME
      T = (TIME - DAY) * 24.0D0
      CALL COORDD (2, T, CHSIGN, HM, S)
C                                       Encode into string
      WRITE (TSTR,1000) DAY, HM, S
      IF (TSTR(11:11).EQ.' ') TSTR(11:11) = '0'
C                                       Copy to output
      SL = MIN (LEN (STRING), 16)
      STRING = TSTR(1:SL)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I3,'/',I2.2,':',I2.2,':',F6.3)
      END
      SUBROUTINE SUMINI (COL)
C-----------------------------------------------------------------------
C   Initialize comparison summary.
C   Inputs:
C      COL    I    Column being compared
C   Inputs in common:
C      COLDIM I(*) Dimensionality of columns
C   Outputs in common:
C      NUMSUM I    Number of comparisons in the summary (basically the
C                  dimensionality of the column).
C      SUMCNT I(*) Number of counts in each bin
C      SUMMIN D(*) Minimum difference
C      SUMMAX D(*) Maximum difference
C      SUMSUM D(*) Sum of differences
C      SUMSU2 D(*) Sum of differences**2
C-----------------------------------------------------------------------
      INTEGER   COL
C
      INCLUDE 'TBDIF.INC'
      INTEGER   LOOP
C-----------------------------------------------------------------------
C                                       Dimensionality of comparison
      NUMSUM = MIN (MAXSUM, COLDIM(COL))
C                                       Initialize arrays
      DO 100 LOOP = 1,NUMSUM
         SUMCNT(LOOP) = 0
         SUMMIN(LOOP) = 1.0D20
         SUMMAX(LOOP) = -1.0D20
         SUMSUM(LOOP) = 0.0D0
         SUMSU2(LOOP) = 0.0D0
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE PRTSUM (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *   IPCNT, PAGE, SCRTCH, IERR)
C-----------------------------------------------------------------------
C   Print comparison summary.
C   Inputs:
C      PLUN    I       LUN for print device (open): 1 => line printer,
C                         3 => text (disk) file, 5 => terminal
C      PIND    I       FTAB pointer for print device
C      DOCRT   R       > 0. => use CRT, else line printer or disk
C      NACROS  I       Number characters in line
C   In/out:
C      TITL1   C*132   Page title line 1, if ' ' then ignored
C      TITL2   C*132   Page title line 2, if ' ' then ignored
C      LINE    C*132   Text line
C      IPCNT   I       Number lines so far on page
C                         > 1000 => just ask about continuing (DOCRT
C                                   true).  Do not print anything.
C                         =  999 => print new page title(s) and LINE
C                                   but do not ask the user about
C                                   whether he wants to continue
C      PAGE    I       Current page number
C                         = 0 => start of print job (user not asked on
C                                DOCRT true)
C   Output:
C      SCRTCH  C*(*)   Scratch core > 132
C      IERR    I       Error code: 0 => OK, -1 user asks to quit
C   Inputs in common:
C      DIFLEN  I       If difference comparison not made then don't
C                      print results.
C      NUMSUM I    Number of comparisons in the summary (basically the
C                  dimensionality of the column).
C      SUMCNT I(*) Number of counts in each bin
C      SUMMIN D(*) Minimum difference
C      SUMMAX D(*) Maximum difference
C      SUMSUM D(*) Sum of differences
C      SUMSU2 D(*) Sum of differences**2
C-----------------------------------------------------------------------
      INTEGER   PLUN, PIND, NACROS, IPCNT, PAGE, IERR
      REAL      DOCRT
      CHARACTER TITL1*132, TITL2*132, LINE*132, SCRTCH*132
C
      INCLUDE 'TBDIF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INTEGER   LOOP
      DOUBLE PRECISION AVG, SIGMA
C-----------------------------------------------------------------------
C                                       Anything to do?
      IF ((NUMSUM.LE.0) .OR. (DIFLEN.LE.0)) GO TO 999
C                                       Header and labels
      LINE = ' '
      TITL1 = ' '
      TITL2 = ' '
C                                       Blank line
      IF (DOCRT.GT.-2.5) THEN
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       Header
         LINE = 'Comparison summary'
         CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *      IPCNT, PAGE, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
C                                       Column lables
      TITL1 = '    #  count    Average         Sigma         ' //
     *   'Minimum        Maximum'
      CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, TITL1,
     *   IPCNT, PAGE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Print comparison summary
      DO 100 LOOP = 1,NUMSUM
         IF (SUMCNT(LOOP).GT.0) THEN
            AVG = SUMSUM(LOOP) / SUMCNT(LOOP)
            IF (SUMCNT(LOOP).GT.1) THEN
               SIGMA = SQRT ((SUMSU2(LOOP) - (SUMSUM(LOOP)*SUMSUM(LOOP)
     *            / SUMCNT(LOOP))) / (SUMCNT(LOOP)-1))
            ELSE
               SIGMA = -1.0D0
               END IF
            WRITE (LINE,1100) LOOP, SUMCNT(LOOP), AVG, SIGMA,
     *         SUMMIN(LOOP), SUMMAX(LOOP)
C                                       Print line
            CALL PRTLIN (PLUN, PIND, DOCRT, NACROS, TITL1, TITL2, LINE,
     *         IPCNT, PAGE, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            END IF
 100     CONTINUE
      GO TO 999
C                                       Error printing
 900  IF (IERR.GT.0) THEN
         MSGTXT = 'ERROR PRINTING TABLE COMPARISON'
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT (I5, I7, 1PD15.7, 3D15.7)
      END

      SUBROUTINE DTRC (TRCMAT, ALPH0, DEL0, ALPHA, DELTA)
C-----------------------------------------------------------------------
C! Transforms spherical coordinates given transform matrix.
C# Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Spherical coordinates of an object are given in a coordinate
C   system C1.  The matrix is given which relates C1 to another system,
C   C2.  The procedure computes the spherical coordinates of the same
C   object in the coordinate system C2.
C-----------------------------------------------------------------------
      DOUBLE PRECISION TRCMAT(3,3), ALPH0, DEL0, ALPHA, DELTA
      INTEGER   I, J
      DOUBLE PRECISION VEC0(3), VEC(3)
C-----------------------------------------------------------------------
      CALL DCUV (ALPH0, DEL0, VEC0(1), VEC0(2), VEC0(3))
      DO 10 I = 1,3
         VEC(I) = 0.D0
         DO 9 J = 1,3
            VEC(I) = TRCMAT(I,J) * VEC0(J) + VEC(I)
 9          CONTINUE
 10      CONTINUE
      CALL DUVC (VEC(1), VEC(2), VEC(3), ALPHA, DELTA)
C
 999  RETURN
      END

C   CX_IMAGE Class utility module
C-----------------------------------------------------------------------
C! Object Oriented AIPS Fortran "CX_IMAGE" utility module.
C# MAP-util Utility Object-Oriented
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This package of utility routines is related to the complex image
C   (CX_IMAGE) class.  These mostly convert between CX_IMAGE objects
C   (the only type of complex image allowed permanently in AIPS) and
C   IMAGE objects of type complex (the useful ones for image
C   arithmetic).
C   Public functions:
C   IMG2CX (image, cximag, ierr)
C      Convert image of type complex to a CX_IMAGE.
C   CX2IMG (cximag, image, ierr)
C      Convert CX_IMAGE to image of type complex.
C   IMGR2C (rimage, cimage, ierr)
C      Convert real image to image of type complex with zero imaginary.
C-----------------------------------------------------------------------
LOCAL INCLUDE 'CXUSTUF.INC'
C                                       Local include for CXUTIL
      INCLUDE 'INCS:PMAD.INC'
      REAL     ROW(2*MAXIMG)
      COMMON /CXULCM/ ROW
LOCAL END
      SUBROUTINE IMG2CX (IMAGE, CXIMAG, IERR)
C-----------------------------------------------------------------------
C   CX_IMAGE class utility routine
C   Converts from an IMAGE of type complex (the type that is useful for
C   arithmetic)  to a complex CX_IMAGE (the type allowed permanantly in
C   AIPS).
C   Inputs:
C      IMAGE    C*?  Name of input IMAGE object.
C      CXIMAG   C*?  Name of output CX_IMAGE object.
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER IMAGE*(*), CXIMAG*(*)
      INTEGER   IERR
C
      INTEGER   TYPE, DIM(7), NAXIS(7), BLC(7), TRC(7), DUMMY,
     *   I2, I3, I4, I5, I6, I7
      LOGICAL   DOCMPL
      CHARACTER DATYPE*8
      INCLUDE 'CXUSTUF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Open input.
      CALL IMGOPN (IMAGE, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARROPN (IMAGE, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Input better be complex
      CALL ARDGET (IMAGE, 'DATATYPE', TYPE, DIM, DUMMY, DATYPE, IERR)
      DOCMPL = (DATYPE.EQ.'COMPLEX') .AND. (IERR.EQ.0)
      IERR = 0
      IF (.NOT.DOCMPL) THEN
         IERR = 5
         MSGTXT = 'IMG2CX: INPUT NOT A COMPLEX IMAGE'
         GO TO 990
         END IF
C                                       Window
      CALL ARRWIN (IMAGE, BLC, TRC, NAXIS, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Open output.
      CALL CIMOPN (CXIMAG, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Loop over array
      DO 700 I7 = BLC(7),TRC(7)
         DO 600 I6 = BLC(6),TRC(6)
            DO 500 I5 = BLC(5),TRC(5)
               DO 400 I4 = BLC(4),TRC(4)
                  DO 300 I3 = BLC(3),TRC(3)
                     DO 200 I2 = BLC(2),TRC(2)
C                                       Read
      CALL ARREAD (IMAGE, DIM, ROW, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Write
      DIM(1) = DIM(1) / 2
      CALL CIPUTX (CXIMAG, DIM, ROW, IERR)
      IF (IERR.NE.0) GO TO 995
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close
      CALL ARRCLO (IMAGE, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL IMGCLO (IMAGE, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL CIMCLO (CXIMAG, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 990  CALL MSGWRT (7)
 995  MSGTXT = 'IMG2CX: ERROR COPYING ' // IMAGE
      CALL MSGWRT (7)
      MSGTXT = 'TO ' // CXIMAG
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE CX2IMG (CXIMAG, IMAGE, IERR)
C-----------------------------------------------------------------------
C   CX_IMAGE class utility routine
C   Converts from a complex CX_IMAGE (the type allowed permanantly in
C   AIPS) to an IMAGE of type complex (the type that is useful for
C   arithmetic).
C   Inputs:
C      CXIMAG   C*?  Name of Input CX_IMAGE object.
C      IMAGE    C*?  Name of output IMAGE object.  Created as a scratch
C                    object if necessary.
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER CXIMAG*(*), IMAGE*(*)
      INTEGER   IERR
C
      INTEGER   TYPE, DIM(7), NAXIS(7), BLC(7), TRC(7), DUMMY,
     *   I2, I3, I4, I5, I6, I7
      LOGICAL   EXIST
      CHARACTER CXIR*32, DATYPE*8
      INCLUDE 'CXUSTUF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Open input.
      CALL CIMOPN (CXIMAG, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
C                                        Get names of component parts.
      CALL OGET (CXIMAG, 'REALPART', TYPE, DIM, DUMMY, CXIR, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Window
      CALL ARRWIN (CXIR, BLC, TRC, NAXIS, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Create output if necessary
      CALL OBFEXS (IMAGE, EXIST, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (.NOT.EXIST) THEN
         IF (IMAGE.EQ.'        ') IMAGE = 'Scratch object in CX2IMG'
         NAXIS(1) = NAXIS(1) * 2
         CALL  IMGSCR (IMAGE, NAXIS, IERR)
         IF (IERR.NE.0) GO TO 995
         END IF
C                                       Output complex
      DATYPE = 'COMPLEX'
      DIM(1) = LEN (DATYPE)
      DIM(2) = 1
      CALL ARDPUT (IMAGE, 'DATATYPE', OOACAR, DIM, DUMMY, DATYPE, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Open output.
      CALL IMGOPN (IMAGE, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARROPN (IMAGE, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Loop over array
      DO 700 I7 = BLC(7),TRC(7)
         DO 600 I6 = BLC(6),TRC(6)
            DO 500 I5 = BLC(5),TRC(5)
               DO 400 I4 = BLC(4),TRC(4)
                  DO 300 I3 = BLC(3),TRC(3)
                     DO 200 I2 = BLC(2),TRC(2)
C                                       Read
      CALL CIGETX (CXIMAG, DIM, ROW, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Write
      DIM(1) = DIM(1) * 2
      CALL ARRWRI (IMAGE, DIM, ROW, IERR)
      IF (IERR.NE.0) GO TO 995
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close
      CALL CIMCLO (CXIMAG, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (IMAGE, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL IMGCLO (IMAGE, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 990  CALL MSGWRT (7)
 995  MSGTXT = 'CX2IMG: ERROR COPYING ' // CXIMAG
      CALL MSGWRT (7)
      MSGTXT = 'TO ' // IMAGE
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE IMGR2C (RIMAGE, CIMAGE, IERR)
C-----------------------------------------------------------------------
C   CX_IMAGE class utility routine
C   Converts from a real image to an image of type complex zeroing the
C   imaginary parts.
C   Inputs:
C      RIMAGE   C*?  Name of Input real object.
C      CIMAGE   C*?  Name of output complex object.  Created as a
C                    scratch object if necessary.
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER RIMAGE*(*), CIMAGE*(*)
      INTEGER   IERR
C
      INTEGER   DIM(7), NAXIS(7), BLC(7), TRC(7), DUMMY, LROW, J1, K1,
     *   I1, I2, I3, I4, I5, I6, I7
      LOGICAL   EXIST
      CHARACTER DATYPE*8
      INCLUDE 'CXUSTUF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Open input.
      CALL IMGOPN (RIMAGE, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARROPN (RIMAGE, 'READ', IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Window
      CALL ARRWIN (RIMAGE, BLC, TRC, NAXIS, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Create output if necessary
      CALL OBFEXS (CIMAGE, EXIST, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (.NOT.EXIST) THEN
         IF (CIMAGE.EQ.'        ') CIMAGE = 'Scratch object in CX2IMG'
         NAXIS(1) = NAXIS(1) * 2
         CALL  IMGSCR (CIMAGE, NAXIS, IERR)
         IF (IERR.NE.0) GO TO 995
         END IF
C                                       Output complex
      DATYPE = 'COMPLEX'
      DIM(1) = LEN (DATYPE)
      DIM(2) = 1
      CALL ARDPUT (CIMAGE, 'DATATYPE', OOACAR, DIM, DUMMY, DATYPE, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Open output.
      CALL IMGOPN (CIMAGE, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARROPN (CIMAGE, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Loop over array
      LROW = TRC(1) - BLC(1) + 1
      DO 700 I7 = BLC(7),TRC(7)
         DO 600 I6 = BLC(6),TRC(6)
            DO 500 I5 = BLC(5),TRC(5)
               DO 400 I4 = BLC(4),TRC(4)
                  DO 300 I3 = BLC(3),TRC(3)
                     DO 200 I2 = BLC(2),TRC(2)
C                                       Read
      CALL ARREAD (RIMAGE, DIM, ROW, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Shuffle and zero
      DO 150 I1 = 2,LROW
         K1 = LROW - I1 + 2
         J1 = ((K1 - 1) * 2) + 1
         ROW(J1) = ROW(K1)
         ROW(J1+1) = 0.0
 150     CONTINUE
      ROW(2) = 0.0
C                                       Write
      DIM(1) = DIM(1) * 2
      CALL ARRWRI (CIMAGE, DIM, ROW, IERR)
      IF (IERR.NE.0) GO TO 995
 200                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close
      CALL ARRCLO (RIMAGE, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL ARRCLO (CIMAGE, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL IMGCLO (RIMAGE, IERR)
      IF (IERR.NE.0) GO TO 995
      CALL IMGCLO (CIMAGE, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error
 990  CALL MSGWRT (7)
 995  MSGTXT = 'IMGR2C: ERROR COPYING ' // RIMAGE
      CALL MSGWRT (7)
      MSGTXT = 'TO ' // CIMAGE
      CALL MSGWRT (7)
C
 999  RETURN
      END

      SUBROUTINE YTVOPN (BUF, IERR)
C-----------------------------------------------------------------------
C! open the TV device and the TV disk control/parameter file.
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YTVOPN opens the TV including TV lock/parameter file and reads the
C   parameters, placing them in commons.
C   Outputs:
C      BUF   I(256)   Scratch buffer
C      IERR  I        Error return from YTVOP2
C                        = 10 TV unavailable to this version
C   Virtual TV version - from the wire.
C-----------------------------------------------------------------------
      INTEGER   BUF(256), IERR
C
      INTEGER   IER, I
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DVTV.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 10
      TVIND2 = 0
      TVLUN = 9
      TVMAP = .FALSE.
      TVLUN2 = 8
C                                       Open actual TV device
      CALL YTVOP2 (TVLUN, TVIND, IERR)
      IF (IERR.EQ.0) GO TO 40
         WRITE (MSGTXT,1030) IERR
         GO TO 990
C                                       get actual parms
 40   BUFSR = 256
      BUFSW = 0
      CALL MKYBUF ('READ', 'YTVOPN', BUFSW, BUFSR, NGRAY, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
      IF (IERR.EQ.0) THEN
         CALL UNYBUF (BUFSR, NGRAY, HEADER)
         TVIND2 = TVIND
         GO TO 999
      ELSE
         CALL ZVTVCL (TVLUN, TVIND, IER)
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       error
 990  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('YTVOPN: TV OPEN ERROR',I7)
 1040 FORMAT ('YTVOPN: ERROR',I5,' GETTING TV PARAMETERS OVER THE WIRE')
      END

      PROGRAM CCMRG
C-----------------------------------------------------------------------
C! Merge CC / CX (CLEAN components) table.
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2009, 2020
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task CCMRG sorts AIPS CC tables to bring all components at the same
C   cell together, then it sums them, and finally it resorts the file
C   into the original order (by flux of the new components).
C   Inputs:
C      AIPS Adverb   Prg. Name          Description
C      INNAME         NAME          File name.
C      INCLASS        CLASS         File class.
C      INSEQ          SEQ           File sequence number.
C      INDISK         DISK          Disk volume on which file resides.
C      INVER          INVER         Input file version number
C      IN2VER         OUTVER        Output file version number
C      BADDISK        IBADD(10)     Disks to avoid for scratch.
C-----------------------------------------------------------------------
      CHARACTER NAME*12, CLASS*6, PTYPE*2, PRGM*6, ATIME*8, ADATE*12,
     *   HILINE*72, TTYPE*2
      INTEGER   CATBLK(256), USERID, SEQ, INVER, OUTVER, CNO, DISK,
     *   IRET, BUFSZ, NPARM, IBUF(1), IROUND, LUN, FIND, IERR, ID(3),
     *   IT(3), HLUN, I, INPCMP, OUTCMP, MVERS
      REAL      XSEQ, XDISK, XVER, X2VER, BADD(10), CATR(256),
     *   BUFFER(8196)
      DOUBLE PRECISION CATD(64)
      HOLLERITH XNAME(3), XCLASS(2), CATH(256)
      LOGICAL   T, DOCX
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DFIL.INC'
      COMMON /INPARM/ XNAME, XCLASS, XSEQ, XDISK, XVER, X2VER, BADD
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK, CATR, CATD, CATH)
      EQUIVALENCE (IBUF, BUFFER)
      DATA PRGM  /'CCMRG '/
      DATA LUN, HLUN /16,27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init I/O, parameters
      NPARM = 19
      CALL SETUP (PRGM, NPARM, XNAME, IBUF, IRET)
      IF (IRET.NE.0) GO TO 990
      USERID = NLUSER
      SEQ = IROUND (XSEQ)
      DISK = IROUND (XDISK)
      INVER = IROUND (XVER)
      OUTVER = IROUND (X2VER)
      CALL H2CHR (12, 1, XNAME, NAME)
      CALL H2CHR (6, 1, XCLASS, CLASS)
C                                       Open file and get CATBLK.
      PTYPE = '  '
      CALL MAPOPN ('WRIT', DISK, NAME, CLASS, SEQ, PTYPE, USERID,
     *   LUN, FIND, CNO, CATBLK, IBUF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       Mark in /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISK
      FCNO(NCFILE) = CNO
      FRW(NCFILE) = 1
C                                       Close file, leave marked.
      CALL ZCLOSE (LUN, FIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       BADDISK
      DO 25 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 25      CONTINUE
C                                       CC or CX?
      CALL FNDEXT ('CC', CATBLK, MVERS)
      TTYPE = 'CC'
      DOCX = MVERS.LE.0
      IF (DOCX) THEN
         CALL FNDEXT ('CX', CATBLK, MVERS)
         IF (MVERS.LE.0) THEN
            MSGTXT = 'NEITHER CC NOR CX TABLES FOUND'
            CALL MSGWRT (8)
            IERR = 10
            GO TO 990
            END IF
         TTYPE = 'CX'
         END IF
C                                       Sort: to scratch (1)
      BUFSZ = 8192
      IF (DOCX) THEN
         CALL CXMERG (DISK, CNO, INVER, OUTVER, INPCMP, OUTCMP, BUFSZ,
     *      BUFFER, IRET)
      ELSE
         CALL CCMERG (DISK, CNO, INVER, OUTVER, INPCMP, OUTCMP, BUFSZ,
     *      BUFFER, IRET)
         END IF
      IF (IRET.NE.0) GO TO 990
C                                       History
      CALL HIINIT (3)
      CALL HIOPEN (HLUN, DISK, CNO, IBUF, IERR)
      IF (IERR.EQ.0) GO TO 110
         WRITE (MSGTXT,1100) IERR
         CALL MSGWRT (6)
         GO TO 990
C                                       Version, date, time
 110  CALL ZDATE (ID)
      CALL ZTIME (IT)
      CALL TIMDAT (IT, ID, ATIME, ADATE)
      WRITE (HILINE,1110) TSKNAM, RLSNAM, ADATE, ATIME
      CALL HIADD (HLUN, HILINE, IBUF, IERR)
      IF (IERR.NE.0) GO TO 120
C                                       Input vers, number
      WRITE (MSGTXT,1111) INPCMP, TTYPE, INVER
      CALL MSGWRT (3)
      WRITE (HILINE,1112) TSKNAM, INPCMP, TTYPE, INVER
      CALL HIADD (HLUN, HILINE, IBUF, IERR)
      IF (IERR.NE.0) GO TO 120
C                                       Output vers, number
      WRITE (MSGTXT,1113) OUTCMP, TTYPE, OUTVER
      CALL MSGWRT (3)
      WRITE (HILINE,1114) TSKNAM, OUTCMP, TTYPE, OUTVER
      CALL HIADD (HLUN, HILINE, IBUF, IERR)
      IF (IERR.NE.0) GO TO 120
C
 120  CALL HICLOS (HLUN, T, IBUF, IERR)
C                                       Write end message
 990  CALL DIE (IRET, IBUF)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR:',I7,' OPENING MAP FILE')
 1010 FORMAT ('ERROR:',I7,' CLOSING MAP FILE')
 1100 FORMAT ('ERROR:',I7,' OPENING HISTORY FILE')
 1110 FORMAT (A6,'RELEASE =''',A7,' ''  /********* Run',
     *   A12,2X,A8)
 1111 FORMAT ('Read ',I10,' CLEAN components from ',A,' file version',
     *   I3)
 1112 FORMAT (A6,'/Read ',I10,' CLEAN components from ',A,
     *   ' file version',I3)
 1113 FORMAT ('Wrote',I10,' CLEAN components to ',A,' file version',I3)
 1114 FORMAT (A6,'/Wrote',I10,' CLEAN components to ',A,
     *   ' file version',I3)
      END
      SUBROUTINE CXMERG (DISK, CNO, INVER, OUTVER, INPCMP, OUTCMP,
     *   JBUFS, BUFFER, IRET)
C-----------------------------------------------------------------------
C   CXMERG sorts AIPS CX tables to bring all components at the same
C   cell together, then it sums them, and finally it resorts the file
C   into the original order (by flux of the new components).
C   Inputs:
C      DISK     I      File disk number
C      CNO      I      File catalog number
C      JBUFS    I      Number words in BUFFER
C   In/out:
C      INVER    I      Input CC version number: 0 => MAXVER
C      OUTVER   I      Output CC version number: 0 => MAXVER+1
C   Output:
C      BUFFER   I(*)   sort buffer
C      INPCMP   I      Number components on input.
C      OUTCMP   I      Number components on output.
C      IRET     I      Error code
C   Common: /MAPHDR/ CATBLK for the affected image file
C   The routine assumes that the CATBLK is in this common already and
C   that the file has been opened in the catalog for WRITE.  (The image
C   file itself does not need to be open.)  The routine assumes that
C   the CFIL common is initialized especially IBAD (BADDISK).
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, INVER, OUTVER, JBUFS, INPCMP, OUTCMP, IRET
      REAL      BUFFER(*)
C
      CHARACTER CCTIT1(4)*8, TYPE*2, PHNAME*48, CHTMP*2
      INTEGER   SCVER(2), EQUKOL(10), SUMKOL(10), MAXVER, KEY(2,4),
     *   TABUFF(512), BUFSZ, I, LUN(2), JCOL1, JP, IERR, NKEY, NCOL,
     *   NREC, DATP(128,2), EMAX, EMIN, IVER, INSCR, CATSAV(256),
     *   KEYSUB(2,2)
      REAL      TSTKOL(10), FKEY(2,2), EPS
      LOGICAL   T
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA TYPE /'CX'/
      DATA EPS, T /0.05, .TRUE./
      DATA LUN /16,17/
      DATA KEYSUB /4*1/
      DATA CCTIT1 /'X', 'Y', 'REAL', 'IMAG'/
C-----------------------------------------------------------------------
      INSCR = NSCR + 1
      IF (INSCR.LE.0) NSCR = 0
      IF (INSCR.LE.0) INSCR = 1
C                                       find version numbers
      CALL FNDEXT (TYPE, CATBLK, MAXVER)
      IF (MAXVER.GT.0) GO TO 10
         WRITE (MSGTXT,1000)
         GO TO 990
 10   IF ((INVER.LE.0) .OR. (INVER.GT.MAXVER)) INVER = MAXVER
      IF (OUTVER.LE.0) OUTVER = MAXVER + 1
      SCVER(1) = MAX (OUTVER, MAXVER+1)
      SCVER(2) = SCVER(1) + 1
C                                       Open table file
      NKEY = 0
      NCOL = 0
      NREC = 0
      CALL TABINI ('READ', TYPE, DISK, CNO, INVER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, TABUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, TYPE, INVER
         GO TO 990
         END IF
C                                       Number input components
      INPCMP = TABUFF(5)
C                                       Find columns
      CALL FILL (10, 0, EQUKOL)
      CALL FILL (10, 0, SUMKOL)
      JCOL1 = 2
      CALL FNDCOL (JCOL1, CCTIT1(1), 8, T, TABUFF, EQUKOL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
      CALL FNDCOL (2, CCTIT1(3), 8, T, TABUFF, SUMKOL, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         GO TO 990
         END IF
C                                       insort
      KEY(1,1) = EQUKOL(2)
      KEY(2,1) = 0
      KEY(1,2) = EQUKOL(1)
      KEY(2,2) = 0
C                                       outsort
      KEY(1,3) = -SUMKOL(1)
      KEY(2,3) = 0
      KEY(1,4) = -SUMKOL(2)
      KEY(2,4) = 0
C                                       sort weights: not sum cols
      FKEY(1,1) = -1.0
      FKEY(2,1) = 0.0
      FKEY(1,2) = -1.0
      FKEY(2,2) = 0.0
C                                       tolerances
      TSTKOL(1) = EPS * ABS (CATR(KRCIC))
      TSTKOL(2) = EPS * ABS (CATR(KRCIC+1))
C                                       Close the table file
      CALL TABIO ('CLOS', 0, 0, DATP, TABUFF, IERR)
C                                       Sort: to scratch (1)
      IRET = 0
      IF (INPCMP.GT.0) THEN
         BUFSZ = JBUFS * 2
         WRITE (MSGTXT,1030) SCVER(1)
         CALL MSGWRT (2)
         CALL TABSRT (DISK, CNO, TYPE, INVER, SCVER(1), KEY, KEYSUB,
     *      FKEY, TABUFF, CATBLK, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Merge: scratch(2)
         WRITE (MSGTXT,1031) SCVER(2)
         CALL MSGWRT (2)
         CALL TABMRG (DISK, CNO, TYPE, SCVER(1), SCVER(2), EQUKOL,
     *      SUMKOL, TSTKOL, BUFFER, TABUFF, CATBLK, OUTCMP, IRET)
         IF (IRET.NE.0) GO TO 900
         CALL ZPHFIL (TYPE, DISK, CNO, OUTVER, PHNAME, IERR)
         CALL ZDESTR (DISK, PHNAME, IERR)
C                                       Sort to output
         WRITE (MSGTXT,1032) OUTVER
         CALL MSGWRT (2)
         CALL TABSRT (DISK, CNO, TYPE, SCVER(2), OUTVER, KEY(1,3),
     *      KEYSUB, FKEY, TABUFF, CATBLK, IRET)
C                                       empty table
      ELSE IF (INVER.NE.OUTVER) THEN
         CALL ZPHFIL (TYPE, DISK, CNO, OUTVER, PHNAME, IERR)
         CALL ZDESTR (DISK, PHNAME, IERR)
         CALL TABCOP (TYPE, INVER, OUTVER, LUN(1), LUN(2), DISK, DISK,
     *      CNO, CNO, CATBLK, TABUFF, TABUFF(257), IRET)
         END IF
C                                       extension file clean up
C                                       FNDEXT, TABINI called FXHDEX
 900  DO 910 I = 1,KIEXTN
         CALL H2CHR (2, 1, CATH(KHEXT+I-1), CHTMP)
         IF (CHTMP.EQ.TYPE) THEN
            JP = KIVER + I - 1
            IF (CATBLK(JP).GT.MAXVER) THEN
               EMAX = CATBLK(JP)
               GO TO 920
               END IF
            END IF
 910     CONTINUE
      GO TO 999
 920  EMIN = MAXVER + 1
      IF (IRET.EQ.0) EMIN = MAX (EMIN, OUTVER+1)
C                                       delete the extras
      IF (EMIN.LE.EMAX) THEN
         CATBLK(JP) = EMIN - 1
         DO 930 IVER = EMIN,EMAX
            CALL ZPHFIL (TYPE, DISK, CNO, IVER, PHNAME, IERR)
            CALL ZDESTR (DISK, PHNAME, IERR)
            IF (IERR.GT.1) CATBLK(JP) = IVER
 930        CONTINUE
C                                       Update catalog
         CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'REST', TABUFF, IERR)
         END IF
C                                       Delete scratch files
      IF (NSCR.LT.INSCR) THEN
         EMIN = NSCR - INSCR + 1
         CALL FILL (EMIN, 2, DATP)
         CALL COPY (256, CATBLK, CATSAV)
         CALL MAPCLR (EMIN, SCRVOL(INSCR), SCRCNO(INSCR), DATP, TABUFF)
         CALL COPY (256, CATSAV, CATBLK)
         NSCR = INSCR - 1
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
      IRET = 8
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR: NO CX FILES ASSOCIATED WITH IMAGE')
 1010 FORMAT ('ERROR:',I7,' OPENING ',A2,' FILE VERSION',I3)
 1020 FORMAT ('ERROR:',I7,' FINDING NEEDED CX FILE COLUMNS')
 1030 FORMAT ('Start sort to CX file scratch version',I4)
 1031 FORMAT ('Start merge to CX file scratch version',I4)
 1032 FORMAT ('Start sort to CX file output version',I4)
      END

      SUBROUTINE TABHDK (CARD, HLUN, HBLK, MAXKEY, NUMKEY, KEYWRD,
     *   KEYVAL, KEYCHR, KEYTYP, ENDKEY, IERR)
C-----------------------------------------------------------------------
C! Reads a FITS table header.
C# EXT-util FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2016
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TABHDK interprets TABle HeaDer Keywords on an input card image and
C   puts the data for recognized symbols into a set of output arrays.
C   Selected 'SINGLDSH' keywords are kept; the rest are ignored
C   Inputs:
C      CARD     C*80     FITS Card to decoded and stored
C      HLUN     I        History file LUN.
C      HBLK     I(256)   History file I/O buffer.
C      MAXKEY   I        Maximum number of keys in arrays
C   In/Out:
C      NUMKEY   I        Location to store next keyword
C   Outputs:
C      KEYWRD   C(*)*8   Keywords
C      KEYVAL   D(*)     List of arbitrary numeric/logical values:
C                           KEYVAL(n) => Value in D.
C                           logicals coded as -1.0=>F, 1.0=>T.
C      KEYCHR   C(*)*8   List of character keyword values values.
C      KEYTYP   I(*)     Keyword type codes.
C      ENDKEY   L        True when END card is found.
C      IERR     I        error code 0=ok. 1=error.
C   Commons:
C      /EXTHDR/    Extension file values.
C      /THDR/      Header values for a tables extension file.
C-----------------------------------------------------------------------
      CHARACTER KEYWRD(*)*8, KEYCHR(*)*8
      INTEGER   HLUN, HBLK(256), MAXKEY, NUMKEY, KEYTYP(*), IERR
      DOUBLE PRECISION KEYVAL(*)
      LOGICAL ENDKEY
C                                       Define number of Keywords
      INTEGER   NN
      PARAMETER (NN=14)
      CHARACTER SYMBOL*8, STR*80, TWORD(NN)*8, CARD*80, HILINE*72,
     *   HISTRY*8, COMENT*8, SNGDSH*8
      DOUBLE PRECISION X
      INTEGER   TLIMIT(NN), N, TABNO, NBYT, NPNT, NCHAR, IHIERR, KTYPE,
     *   COUNT, IST, HERR, JERR, NRCX, ICARD, ITRIM
      LOGICAL   ISHIS, WARN
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DEHD.INC'
      INCLUDE 'INCS:DTHD.INC'
C                                       Remember to warn only once
      SAVE  WARN, IHIERR, HERR
      DATA  WARN, IHIERR, HERR /.TRUE., 0, 0/
      DATA  HISTRY,     COMENT,     SNGDSH
     *    /'HISTORY ', 'COMMENT ', 'SINGLDSH'/
C                                       Special keywords
      DATA TWORD     /'TFIELDS ',  'EXTNAME ',  'EXTVER  ',
     *   'EXTLEVEL',  'TTYPE   ',  'TBCOL   ',  'TFORM   ',
     *   'TUNIT   ',  'TSCAL   ',  'TZERO   ',  'TNULL   ',
     *   'TFDIM   ',  'AUTHOR  ',  'REFERENC'/
      DATA TLIMIT / 0,0,0,0,999,999,999,999,999,999,999,999,0,0/
C-----------------------------------------------------------------------
      NRCX = 1
C                                       Find symbol
      NPNT = 1
      CALL IDWCRD (CARD, NN, TLIMIT, TWORD, NPNT, SYMBOL, TABNO, N,
     *   JERR)
C                                       Exit on finding END
      ENDKEY = SYMBOL(1:3).EQ.'END'
      IF (ENDKEY) GO TO 999
C                                       unrecognized keyword =
      IF (JERR.EQ.1) THEN
C                                       check keyword limit
         IF (NUMKEY.LT.MAXKEY) THEN

            CALL GETKEY (SYMBOL, CARD, NPNT, NUMKEY, KEYWRD, KEYVAL,
     *         KEYCHR, KEYTYP, JERR)
C                                       ignore invalid ones.
            IF ((KEYTYP(NUMKEY).LE.0) .OR. (KEYTYP(NUMKEY).GT.6))
     *         THEN
               WRITE (MSGTXT,1001) SYMBOL
               CALL MSGWRT (6)
               NUMKEY = NUMKEY - 1
C                                       else Key is ok
C                                       Set common number of keywords
            ELSE
               ITANKY = NUMKEY
               END IF
C                                       blew keyword limit
         ELSE
            IF (WARN) THEN
               WRITE (MSGTXT,1002) MAXKEY
               CALL MSGWRT (6)
               WARN = .FALSE.
               END IF
            END IF
      END IF
C                                       If not recognised add to
C                                       history if not single dish
      IF ((JERR.NE.0) .AND. (JERR.NE.1)) THEN
C                                       Not normal keyword=value card.
         IF (CARD(1:8).EQ.SNGDSH) THEN
C                                       Process selected SINGLDSH
C                                       keywords.
C           CALL SDTCRD (ICARD, FITBLK, MAXKEY, NUMKEY, KEYWRD,
C     *        KEYVAL, KEYCHR, KEYTYP, WARN, NRCX[B)
C                                       table type 'SD'
            ITYPE = 'SD'
         ELSE
C                                       No "KEYWORD =" put card in
C                                       history if history exists
            IF (HERR.EQ.0) THEN
               IHIERR = IHIERR + 1
C                                       Explanation for first hist.
               IF (IHIERR.LE.0) THEN
                  WRITE (HILINE,1110) TSKNAM
                  CALL HIADD (HLUN, HILINE, HBLK, HERR)
                  END IF
C                                       History card begins with
C                                       HISTROY, COMMENT or blanks
               ISHIS = (CARD(:8).EQ.HISTRY) .OR. (CARD(:8).EQ.COMENT)
     *            .OR. (CARD(:8).EQ.' ')
               IST = 1
C                                       remove word 'HISTORY'
               IF (ISHIS) IST = 9
               CALL HIAD80 (HLUN, IST, CARD, HBLK, HERR)
               IF (.NOT.ISHIS) THEN
                  WRITE (MSGTXT,1100) SYMBOL
                  CALL MSGWRT (6)
                  END IF
               END IF
            END IF
         END IF
C                                       If a Recognized keyword
      IF (JERR.EQ.0) THEN
C                                       Figure out what we have.
         GO TO (210, 220, 230, 240, 250, 260, 270,
     *       280, 290, 300, 310, 320, 330, 330), TABNO
C                                       Number of fields.
 210     CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 990
         ITNCOL = X + .5
         IF (ITNCOL.GT.127) THEN
            WRITE (MSGTXT,1210) ITNCOL
            CALL MSGWRT (7)
            MSGTXT = 'WILL KEEP ONLY THE FIRST 127 COLUMNS'
            CALL MSGWRT (7)
            ITNCOL = 127
            END IF
         GO TO 999
C                                       Extension name.
 220     NBYT = 24
         CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
         EXTNAM = STR(1:NCHAR)
C                                       If standard AIPS table type
C                                       then EXTNAM is of the form
C                                       'AIPS XX' where XX is the
C                                       table type.
         IF ((EXTNAM(1:5).NE.'AIPS ').AND.(EXTNAM(1:4).NE.'VLA '))
     *      THEN
            ITYPE = 'UK'
         ELSE
            ITYPE = STR(6:7)
            END IF
         GO TO 999
C                                       Extension version.
 230     CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 990
         EXTVER = X + .01
         GO TO 999
C                                       Extension level.
 240     CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 990
         EXTLEV = X + .01
         GO TO 999
C                                       Field type.
 250     NBYT = 24
         CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
         TTYPE(N) = STR(1:NCHAR)
         GO TO 999
C                                       Starting column.
 260     CALL GETNUM (CARD, 80, NPNT, X)
         IF (X.EQ.DBLANK) GO TO 990
         TBCOL(N) = X + .5
         GO TO 999
C                                       Field format.
 270     NBYT = 8
         CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
         TFORM(N) = STR(1:NCHAR)
C                                       Decode format.
C                                       ASCII table
            CALL TABSPC (TFORM(N), COUNT, TWIDTH(N), TFRAC(N),
     *              KTYPE, JERR)
            TFCODE(N) = KTYPE + (10 * COUNT)
C                                       characters or bit length in dimension
            IF (KTYPE.EQ.3 .OR. KTYPE.EQ.7)
     *         TFCODE(N) = KTYPE + (10 * TWIDTH(N))
            GO TO 999
C                                       Field units.
 280        NBYT = 8
            CALL GETSTR (CARD, 80, NBYT, NPNT, STR, NCHAR)
            TUNIT(N) = STR(1:NCHAR)
            GO TO 999
C                                       Field scale.
 290        CALL GETNUM (CARD, 80, NPNT, X)
            IF (X.EQ.DBLANK) GO TO 990
            TSCAL(N) = X
            GO TO 999
C                                       Field offset.
 300        CALL GETNUM (CARD, 80, NPNT, X)
            IF (X.EQ.DBLANK) GO TO 990
            TZERO(N) = X
            GO TO 999
C                                       Field null value.
 310        NBYT = 8
            CALL GETSTR (CARD, 24, NBYT, NPNT, STR, NCHAR)
            TNULL(N) = STR(1:NCHAR)
            GO TO 999
C                                       Column width or dimension.
 320        CALL GETNUM (CARD, 80, NPNT, X)
            IF (X.EQ.DBLANK) GO TO 990
C                                       if not characters or bit type
            KTYPE = MOD ( TFCODE(N), 10)
            IF (KTYPE.NE.3 .AND. KTYPE.NE.7) THEN
               COUNT = X + 0.01
               TFCODE(N) = KTYPE + (10 * COUNT)
               END IF
            GO TO 999
C                                       AUTHOR or REFERENC add to hist.
 330     CONTINUE
            WRITE (HILINE,1120,ERR=999) TSKNAM
            ICARD = MIN(ITRIM(CARD),66)
            HILINE(7:7+ICARD-1) = CARD(1:ICARD)
            CALL HIADD (HLUN, HILINE, HBLK, HERR)
            GO TO 999
         END IF
      GO TO 999
C
 990  IERR = 1
      MSGTXT = 'TABHDK: NUMBER OUT OF RANGE ON ' // SYMBOL
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TABHDK: ERROR READING TABLE EXTENSION FROM TAPE')
 1001 FORMAT ('TABHDK: KEYWORD ',A8,' OF INDETERMINATE DATA TYPE')
 1002 FORMAT ('TABHDK: BLEW NO. OF KEYWORD LIMIT OF ',I5,' IGNORE REST')
 1100 FORMAT ('TABHDK: UNKNOWN SYMBOL ',A8)
 1110 FORMAT (A6,'/ UNKNOWN CARDS IN TABLE HEADER')
 1120 FORMAT (A6,A66)
 1210 FORMAT ('TABHDK:',I5,' COLUMNS EXCEEDS AIPS LIMIT OF 127')
      END

      SUBROUTINE GCOMNT (ML, COMNT, BUFF, IERR)
C-----------------------------------------------------------------------
C! writes a comment command in a plot file
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GCOMNT writes a comment command into a plot file and to the message
C   file.
C   The output record contains:
C             I      opcode, 18 in this command
C             I      nchar - number characters in string
C             H(*)   the comment string in holleriths
C   Inputs:
C      ML      I        message level to use -1 => no
C      COMNT   C*(*)    Comment
C   In/out:
C      BUFF    I(256)   Plot buffer
C   Output:
C      IERR    I        Error code: 1 disk error
C-----------------------------------------------------------------------
      CHARACTER COMNT*(*)
      INTEGER   ML, BUFF(256), IERR
C
      INTEGER   OPCODE, NC, JTRIM, NEED, NL
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA OPCODE /18/
C-----------------------------------------------------------------------
      IERR = 0
      NC = JTRIM (COMNT)
      NC = MIN (80, NC)
      IF (NC.GT.0) THEN
C                                       Plot files
         IF (.NOT.GPHDOT) THEN
            NEED = 257 - 2 - (NC+3)/4
C                                       See if enough room in buffer.
            IF (GPHPOS.GE.NEED) THEN
               CALL GPHWRT (BUFF, IERR)
               IF (IERR.NE.0) THEN
                  IERR = 1
                  GO TO 999
                  END IF
               END IF
C                                       Put data in buffer.
            BUFF(GPHPOS+1) = OPCODE
            BUFF(GPHPOS+2) = NC
            CALL CHR2H (NC, COMNT, 1, BUFF(GPHPOS+3))
            GPHPOS = GPHPOS + 2 + (NC+3)/4
            END IF
         IF (ML.GE.0) THEN
            NL = MAX (2, MIN (5, ML))
            MSGTXT = COMNT
            CALL MSGWRT (NL)
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE SGLOCA (IOP, IVER, FIXIT)
C-----------------------------------------------------------------------
C! locates a Save/Get file by name in catalog of SG files
C# POPS-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2004, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SGLOCA takes care of locating a SAVE / GET file from the user's
C   input.  This routine is probably only of use to STORES.
C   Inputs:
C      IOP    I   1 => GET : will use min match, must exist
C                 2 => SAVE : exact match , new vers ok
C                 3 => GET LASTEXIT
C                 4 => SAVE LASTEXIT
C   Output:
C      IVER   I   Version # of S/G file (1 - 46655)
C      FIXIT  L   out of date version needs fixing?
C   Common:
C      POPS error common ERRNUM carries any error codes
C-----------------------------------------------------------------------
      INTEGER   IOP, IVER
      LOGICAL   FIXIT
C                                       Number of Names for matching
      INTEGER   MAXMAT
      PARAMETER (MAXMAT=150)
      CHARACTER PHNAME*48, PRGNAM*6, UNAME*16, TNAME*16
      INTEGER   IBLK(256), NWPL, NLPR, NCHAR, LCHAR, ITRIM, POTERR,
     *   IERR, IER, LUN, FIND, NTASK, LPNT, IREC, LREC, IMSP, SGVOK,
     *   IMSTK(MAXMAT), I, ISVERS, ISCHAR, ISIZE, IRRN, LSIZE, MPG(10),
     *   LPG(10)
      LOGICAL   T, F, N1WRIT, NEW
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:PKSZ.INC'
      DATA LUN /27/
      DATA PRGNAM /'SGLOCA'/
      DATA T, F /.TRUE.,.FALSE./
C                                       Old convertible ones:
C                                       14 can be COMPRESSed to 15
      DATA SGVOK /14/
C                                       MPAGE for vers 14 - 17
      DATA MPG /150, 150, 388, 1512, 6*1512/
C                                       LPAGE for vers 14 - 17
      DATA LPG / 40,  40, 160, 640, 6*640/
C-----------------------------------------------------------------------
      FIXIT = .FALSE.
C                                       set number of integers per
C                                       SAVE/GET entry
      NWPL = 7
C                                       number of SAVE/GET entries/block
      NLPR = 256 / NWPL
      IVER = 0
C                                       LASTEXIT implementation
      IF (IOP.GE.3) THEN
         UNAME = 'LASTEXIT'
         NCHAR = 8
C                                       Get user name
      ELSE
         CALL GETNME (' ', 16, UNAME)
         IF (ERRNUM.NE.0) GO TO 980
C                                       Count characters
         NCHAR = ITRIM (UNAME)
         POTERR = 8
         IF (NCHAR.LE.0) GO TO 980
         END IF
C                                       Directory file
      LCHAR = 16
      IF ((IOP.EQ.1) .OR. (IOP.EQ.3)) LCHAR = NCHAR
      CALL ZPHFIL ('SG', 1, NLUSER, 0, PHNAME, IERR)
      IER = 1
      POTERR = 101
C                                       "Create it" on Save
      CALL ZEXIST (1, PHNAME, LSIZE, IERR)
      NEW = IERR.EQ.1
      IF (NEW) THEN
         IF ((IOP.EQ.2) .OR. (IOP.EQ.4)) THEN
            ISIZE = 1000 / NLPR + 1
            CALL ZCREAT (1, PHNAME, ISIZE, F, LSIZE, IER)
            IF (IER.GE.2) THEN
               WRITE (MSGTXT,1020) IER
               CALL MSGWRT (6)
               GO TO 980
               END IF
         ELSE
            MSGTXT = 'NO SAVE/GET DIECTORY FOUND'
            IF (IOP.EQ.1) THEN
               CALL MSGWRT (6)
            ELSE
               POTERR = 45
               END IF
            GO TO 980
            END IF
      ELSE IF (IERR.GT.1) THEN
         WRITE (MSGTXT,1021) IERR
         CALL MSGWRT (6)
         GO TO 980
         END IF
      LSIZE = LSIZE * NLPR - 1
      LSIZE = MIN (LSIZE, 46655)
      CALL FILL (256, 0, IBLK)
C                                       Open directory
      CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) GO TO 980
      POTERR = 50
C                                       Read old file
      IF (.NOT.NEW) THEN
         CALL ZFIO ('READ', LUN, FIND, 1, IBLK, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       The time, inits
      LREC = 3
      IF ((IOP.EQ.2) .OR. (IOP.EQ.4)) LREC = 5
      CALL CATIME (1, IBLK(LREC), IMSTK)
      N1WRIT = F
      LREC = 1
C                                     Number of names in SAVE/GET
      NTASK = IBLK(1)
      LPNT = NTASK + 1
      IMSP = 0
C                                       Look thru dir for name
      IF (NTASK.GT.0) THEN
         DO 50 I = 1,NTASK
            IRRN = I / NLPR + 1
            IF (IRRN.NE.LREC) THEN
C                                      Write only once
               IF (.NOT.N1WRIT) THEN
                  CALL ZFIO ('WRIT', LUN, FIND, 1, IBLK, IERR)
                  IF (IERR.NE.0) GO TO 970
                  N1WRIT = T
                  END IF
               CALL ZFIO ('READ', LUN, FIND, IRRN, IBLK, IERR)
               IF (IERR.NE.0) GO TO 970
               LREC = IRRN
               END IF
            IREC = MOD (I, NLPR) * NWPL + 1
C                                      read length of string
            ISCHAR = MOD (IBLK(IREC), 32)
C                                      if SAVE and input length <= name read
            IF (((IOP.EQ.2) .OR. (IOP.EQ.4)) .OR.
     *         (LCHAR.LE.ISCHAR)) THEN
C                                      name length is 0
               IF (IBLK(IREC).LE.0) THEN
C                                       reset number of names in SAVE/GET
                  LPNT = MIN (LPNT, I)
               ELSE
C                                       get SAVE/GET name
                  CALL H2CHR (ISCHAR, 1, IBLK(IREC+3), TNAME)
C                                      if name match up to L characters
                  IF (UNAME(1:LCHAR).EQ.TNAME(1:LCHAR)) THEN
C                                      if room in match array
                     IF (IMSP.LT.MAXMAT) THEN
C                                      keep track of matchs
                        IMSP = IMSP + 1
                        IMSTK(IMSP) = I
                        ISVERS = IBLK(IREC) / 32
                        END IF
C                                      if an exact match
                     IF (LCHAR.GE.ISCHAR) THEN
C                                      forget close names, record match
                        IMSP = 1
                        IMSTK(1) = I
C                                      end search
                        GO TO 60
                        END IF
                     END IF
                  END IF
               END IF
 50         CONTINUE
C                                       end if any files in dir.
         END IF
C                                       if GET operation
 60   IF ((IOP.EQ.1) .OR. (IOP.EQ.3)) THEN
         IF (.NOT.N1WRIT) CALL ZFIO ('WRIT', LUN, FIND, 1, IBLK, IERR)
         IF (IERR.NE.0) GO TO 970
         POTERR = 45
         IVER = IMSTK(1)
         IF (IMSP.EQ.1) THEN
            IF (ISVERS.LT.SGVERS) THEN
               POTERR = 30
               FIXIT = ISVERS.GE.SGVOK
               IF (FIXIT) THEN
                  MPAGE = MPG(ISVERS-SGVOK+1)
                  LPAGE = LPG(ISVERS-SGVOK+1)
                  MPAGE = MPAGE + LPAGE
                  END IF
            ELSE IF (ISVERS.GT.SGVERS) THEN
               POTERR = 3
            ELSE
               POTERR = 0
               END IF
            END IF
C                                       Not unique
         IF (IMSP.LE.1) GO TO 970
C                                       inform user
            MSGTXT = PRGNAM // ': SAVE/GET NAME ''' //
     *         UNAME(1:LCHAR) // ''' IS NOT UNIQUE '
            CALL MSGWRT (6)
C                                       for all matches
            DO 70 I = 1,IMSP
C                                       Which block has current name
               IRRN = IMSTK(I) / NLPR + 1
C                                       if current block not last block
               IF (IRRN.NE.LREC) THEN
                  CALL ZFIO ('READ', LUN, FIND, IRRN, IBLK, IERR)
                  IF (IERR.NE.0) GO TO 970
                  LREC = IRRN
                  END IF
C                                       location in block of name
               IREC = MOD (IMSTK(I), NLPR) * NWPL + 1
C                                      read length of string
               ISCHAR = MOD (IBLK(IREC), 32)
               CALL H2CHR (ISCHAR, 1, IBLK(IREC+3), TNAME)
               MSGTXT = PRGNAM // ': COULD BE ''' //
     *            TNAME(1:ISCHAR) // ''''
               CALL MSGWRT (6)
 70            CONTINUE
            GO TO 970
C                                       end if GET option
         END IF
C                                       else SAVE option
 75   IVER = LPNT
      IF (IMSP.EQ.1) IVER = IMSTK(1)
C                                       Too many versions
      IF (IVER.GT.LSIZE) THEN
         POTERR = 101
         WRITE (MSGTXT,1075) LSIZE
         CALL MSGWRT (6)
         GO TO 970
         END IF
C                                       Create/update entry
      IRRN = IVER / NLPR + 1
      I = MOD (IVER, NLPR) * NWPL + 1
C                                       if not already written
      IF ((.NOT.N1WRIT) .AND. (IRRN.NE.1)) THEN
         CALL ZFIO ('WRIT', LUN, FIND, 1, IBLK, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
      IF (IRRN.NE.LREC) CALL ZFIO ('READ', LUN, FIND, IRRN, IBLK, IERR)
      IF (IERR.NE.0) GO TO 970
      IBLK(I) = NCHAR + 32 * SGVERS
      CALL CATIME (1, IBLK(I+1), IMSTK)
      CALL CHR2H (16, UNAME, 1, IBLK(I+3))
C                                       Save & get rec 1 back
      IF (IRRN.NE.1) THEN
         CALL ZFIO ('WRIT', LUN, FIND, IRRN, IBLK, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL ZFIO ('READ', LUN, FIND, 1, IBLK, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Update info
      IF (IVER.GT.NTASK) IBLK(1) = IVER
      IF ((IVER.LE.NTASK) .AND. (IMSP.EQ.0)) IBLK(2) = IBLK(2) - 1
      CALL ZFIO ('WRIT', LUN, FIND, 1, IBLK, IERR)
      IF (IERR.EQ.0) POTERR = 0
C                                       Close file
 970  CALL ZCLOSE (LUN, FIND, IERR)
C                                       error test
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('UNABLE TO CREATE DIRECTORY. IER =',I7)
 1021 FORMAT ('UNABLE TO ACCESS DIRECTORY. IER =',I7)
 1075 FORMAT ('ONLY',I6,' SAVE FILES ARE ALLOWED PER USER')
      END

LOCAL INCLUDE 'SDCAL.INC'
C                                       Local include to SDCAL
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   SEQIN, CNOIN, SEQOUT, DISKIN, DISKO, NUMHIS, JBUFSZ
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSTOK(1), XNAMOU(3), XCLAOU(2)
      CHARACTER NAMEIN*12, CLAIN*6, XSTOK*4, NAMOUT*12, CLAOUT*6,
     *   HISCRD(10)*64
      REAL      XSIN, XDISIN, XTIME(8), XBIF, XEIF, XBCHAN, XECHAN,
     *   XSUBA, XDOCAL, XGUSE, XFLAG, XSOUT, XDISO, APARM(10),
     *   XBADD(10), BUFF1(UVBFSS)
      COMMON /BUFRS/ BUFF1, JBUFSZ
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XTIME, XXSTOK, XBIF,
     *   XEIF, XBCHAN, XECHAN, XSUBA, XDOCAL, XGUSE, XFLAG, XNAMOU,
     *   XCLAOU, XSOUT, XDISO, APARM, XBADD,
     *   SEQIN, SEQOUT, DISKIN, DISKO, CNOIN, NUMHIS
      COMMON /CHRCOM/ NAMEIN, CLAIN, XSTOK, NAMOUT, CLAOUT, HISCRD
LOCAL END
      PROGRAM SDCAL
C-----------------------------------------------------------------------
C! Applies a CS calibration table to a single dish data file.
C# Sdish Calibration EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2000, 2008, 2012, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Applies a CS table to a single  dish data file.
C   Inputs:
C      AIPS adverb          Description.
C      INNAME.....Input UV file name (name).      Standard defaults.
C      INCLASS....Input UV file name (class).     Standard defaults.
C      INSEQ......Input UV file name (seq. #).    0 => highest.
C      INDISK.....Disk drive # of input UV file.  0 => any.
C      TIMERANG...Time range of the data to be copied.
C      STOKES.....Stokes type to pass.
C      BIF........First IF to copy. 0=>all.
C      EIF........Highest IF to copy. 0=>all higher than BIF
C      BCHAN......First channel to copy. 0=>all.
C      ECHAN......Highest channel to copy. 0=>all higher than BIF
C      SUBARRAY...Subarray number to copy. 0=>all.
C      DOCALIB....If true (>0) then calibrate the data.
C      GAINUSE....Version number of the Cal. table to use.
C      FLAGVER....Specifies the version of the flagging table.
C      OUTNAME....Output SD file name.
C      OUTCLASS...Output SD file name (class).    Standard defaults.
C      OUTSEQ.....Output UV file name (seq. #).   0 => highest unique
C      OUTDISK....Disk drive # of output UV file. 0 => highest with
C                 space for the file.
C      APARM......Control information:
C                    1 > 0 => avg. freq. in IF
C                    2 = Integration time (sec)
C                    3 > 0 => drop subarray info
C      BADDISK....Disks to avoid for scratch files.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'SDCAL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'SDCAL '/
C-----------------------------------------------------------------------
C                                       Get input parameters.
      CALL SDCTIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Loop over sources.
      CALL SDCTUV (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE SDCTIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   SDCTIN gets input parameters for SDCAL, finds input file and
C   prepares the list of sources.  All selection criteria
C   except the source name is filled into the commons in D/CSEL.INC.
C   Inputs:  PRGN    C*6      Program name
C   Output:
C     JERR         I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in SDCAL for more details.
C-----------------------------------------------------------------------
      CHARACTER  STAT*4, PRGN*6, UTYPE*2
      INTEGER   JERR
      INTEGER   NPARM, IROUND, IERR, I
      REAL      CATR(256)
      LOGICAL   T
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'SDCAL.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATR,CATBLK)
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 51
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.EQ.0) GO TO 10
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
C                                       Restart AIPS
 10   IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
      WRITE (MSGTXT,4000)
      CALL MSGWRT (2)
C                                       Crunch input parameters.
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XXSTOK, XSTOK)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       Get CATBLK from old file.
      CNOIN = 1
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.EQ.0) GO TO 40
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
 40   CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.EQ.0) GO TO 50
         WRITE (MSGTXT,1040) IERR
         GO TO 990
 50   NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 0
C                                       Save input header
      CALL COPY (256, CATBLK, CATUV)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       BADDISK
      DO 70 I = 1,10
         IBAD(I) = IROUND (XBADD(I))
 70      CONTINUE
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      CALL RCOPY (8, XTIME, TIMRNG)
      STOKES = XSTOK
      BCHAN = IROUND (XBCHAN)
      BCHAN = MAX (1, MIN (BCHAN, CATBLK(KINAX+JLOCF)))
      ECHAN = IROUND (XECHAN)
      IF (ECHAN.LT.BCHAN) ECHAN = CATBLK(KINAX+JLOCF)
      ECHAN = MAX (1, MIN (ECHAN, CATBLK(KINAX+JLOCF)))
      IF (JLOCIF.GE.0) THEN
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, CATBLK(KINAX+JLOCIF)))
         EIF = IROUND (XEIF)
         IF (BIF.GT.EIF) EIF = CATBLK(KINAX+JLOCIF)
         EIF = MAX (1, MIN (EIF, CATBLK(KINAX+JLOCIF)))
      ELSE
         BIF = 1
         EIF = 1
         END IF
      DOCAL = XDOCAL.GT.0.0
      SUBARR = IROUND (XSUBA)
      FGVER = IROUND (XFLAG)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      DXTIME = APARM(2) / 86400.0
C                                       Get source list
      IUDISK = FVOL(1)
      IUCNO = FCNO(1)
      IXLUN = 28
      NSOUWD = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SDCTIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 4000 FORMAT ('YOU ARE USING A NON-STANDARD PROGRAM')
      END
      SUBROUTINE SDCTUV (IRET)
C-----------------------------------------------------------------------
C   SDCTUV uses SDGET and SDCCOP to calibrate data.
C   The history and relevant tables are also copied.
C   Input:
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
      HOLLERITH CATH(256), CATUVH(256), CATSAH(256)
      LOGICAL   F, DOAVG, DOAPPT, FINISH, NOSUB, SMILE
      INTEGER   NUMVIS, TOTREC(2,3), IERR, ERRCNT, TMPVER, SUB, LIMS1,
     *   LIMS2, SUBTMP, CATSAV(256), OUTDSK, OUTCNO
      REAL      RPARM(2), VIS(2), CATR(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:PUVD.INC'
      DOUBLE PRECISION   FREQO(MAXIF)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'SDCAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATSAV, CATSAH)
      EQUIVALENCE (CATBLK, CATH, CATR, CATD),  (CATUV, CATUVH)
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      ERRCNT = 0
      SMILE = F
      TMPVER = CLVER
      DOAPPT = DOAPPL
      DOAVG = APARM(1).GT.0.0
      NOSUB = APARM(3).GT.0.0
C                                       Find number of subarrays
      IF (SUBARR.GT.1) THEN
         LIMS1 = SUBARR
         LIMS2 = SUBARR
      ELSE
         CALL FNDEXT ('AN', CATUV, LIMS2)
         LIMS1 = 1
         LIMS2 = MAX (1, LIMS2)
         END IF
      SUBTMP = SUBARR
C                                       Create header, fiddle tables etc
         SUBARR = SUBTMP
         CALL SDGET ('INIT', RPARM, VIS, IERR)
         DOAPPL = F
         CLVER = CLUSE
         IF (IERR.NE.0) GO TO 450
C                                       Close again - only need header
C                                       for sum of subarrays.
         CALL SDGET ('CLOS', RPARM, VIS, IERR)
         IF (IERR.NE.0) GO TO 450
C                                       Put new values in CATBLK.
         CALL MAKOUT (NAMEIN, CLAIN, SEQIN, '    ', NAMOUT, CLAOUT,
     *      SEQOUT)
         CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
         CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
         CATBLK(KIIMS) = SEQOUT
C                                       Velocity etc. info IF=BIF
         CATD(KDRST) = 0.0
         CATD(KDARV) = 0.0
         CATR(KRARP) = 0.0
         CATBLK(KIALT) = 0
C                                       If averaging set CATBLK
         IF (DOAVG) THEN
            IF (BCHAN.EQ.0  .AND.  ECHAN.EQ.0 ) THEN
               CATR(KRCIC+JLOCF) = CATR(KRCIC+JLOCF)
     *                           * CATBLK(KINAX+JLOCF)
            ELSE
               CATR(KRCIC+JLOCF) = CATR(KRCIC+JLOCF)
     *                           * (ECHAN - BCHAN + 1)
               END IF
            CATBLK(KINAX+JLOCF) = 1
            END IF
C                                       Make sure there is data
         IF (CATBLK(KIGCN).LE.0) GO TO 450
C                                       Create output file.
         CCNO = 1
         CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
         IF (IERR.NE.2) GO TO 200
            WRITE (MSGTXT,1100)
            CALL MSGWRT (6)
 200     IF (IERR.NE.0) GO TO 450
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKO
         FCNO(NCFILE) = CCNO
         FRW(NCFILE) = 2
         OUTDSK = DISKO
         OUTCNO = CCNO
C                                       copy keywords
         CALL KEYCOP (DISKIN, CNOIN, DISKO, CCNO, IERR)
C                                       Loop over subarrays.
         NUMVIS = 0
         DO 300 SUB = LIMS1,LIMS2
            SUBARR = SUB
C                                       Save CATBLK - SDGET will modify
            CALL COPY (256, CATBLK, CATSAV)
C                                       Initialize reading data
            CALL SDGET ('INIT', RPARM, VIS, IERR)
            IF (IERR.NE.0) GO TO 450
C                                       Update sort order if necessary
            IF (NUMVIS.GT.0) CALL CHR2H (2, '**', 1, CATSAH(KITYP))
C                                       Restore CATBLK
            CALL COPY (256, CATSAV, CATBLK)
C                                       Copy data
            FINISH = SUB.EQ.LIMS2
            CALL SDCCOP (NUMVIS, TOTREC, FINISH, DOAVG, DISKO, CCNO,
     *         NOSUB, FREQO, IERR)
            SMILE = SMILE .OR. (IERR.EQ.0)
            IF (IERR.NE.0) GO TO 450
            NUMVIS = NUMVIS + NVIS
 300        CONTINUE
C                                       History
         CLVER = TMPVER
         DOAPPL = DOAPPT
         SUBARR = SUBTMP
         CALL SDCTHI (OUTDSK, OUTCNO)
         CLVER = CLUSE
         DOAPPL = F
         NCFILE = NCFILE - 2
         GO TO 500
C                                       Error, close input file
C                                       then resume.
 450        CALL SDGET ('CLOS', RPARM, VIS, IERR)
            ERRCNT = ERRCNT + 1
C                                       Tell which source
            WRITE (MSGTXT,1450) SOURCS(1)
            CALL MSGWRT (6)
 500     CONTINUE
C                                       Make sure bad files
C                                       destroyed
      IRET = 1
      IF (SMILE) IRET = 0
      NCFILE = NCFILE - 1
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('CANNOT OVERWRITE OLD FILE')
 1450 FORMAT ('PROBLEM WITH SOURCE: ',A)
      END
      SUBROUTINE SDCTHI (DISK, CNO)
C-----------------------------------------------------------------------
C   SDCTHI copies and updates history file.  It also copies any tables
C   extension files.
C    Input:
C     DISK    I    Output file disk number
C     CNO     I    Output file catalog slot number.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP(8)*2, HILINE*72, LABEL*8, UTYPE*2, STAT*4
      INTEGER   DISK, CNO
      INTEGER   IERR, I, LUN1, LUN2, NONOT
      REAL      BUFF2(1), CATR(256)
      LOGICAL   T
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'SDCAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (BUFF1(1025), BUFF2)
      EQUIVALENCE (CATBLK, CATR)
      DATA LUN1, LUN2 /28,29/
      DATA T /.TRUE./
      DATA NONOT, NOTTYP /8, 'CS','FG','NX','SU','SN','CC','CH','BP'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISK, CNOIN,
     *   CNO, CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.LE.2) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
C                                       New history
 10   CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, CATBLK(KIIMS), DISKO, LUN2,
     *   BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       TIMERANG
      CALL HITIME (TSTART, TEND, LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Stokes'
      WRITE (HILINE,2010) TSKNAM, XSTOK
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       IF range
      WRITE (HILINE,2001) TSKNAM, BIF, EIF
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Chan range
      WRITE (HILINE,2002) TSKNAM, BCHAN, ECHAN
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Subarray
      WRITE (HILINE,2003) TSKNAM, SUBARR
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Flagging
      IF (FGVER.GT.0) THEN
         WRITE (HILINE,2004) TSKNAM, FGVER
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                       Calibration
      IF (DOCAL) THEN
C                                       Table
         WRITE (HILINE,2005) TSKNAM, CLUSE
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       Averaging
         WRITE (HILINE,2011) TSKNAM, APARM(1)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
C                                       Integration time
         WRITE (HILINE,2012) TSKNAM, APARM(2)
         CALL HIADD (LUN2, HILINE, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 200
         END IF
C                                      Add any user supplied history.
      IF (NUMHIS.GT.0) THEN
         WRITE (LABEL,1010) TSKNAM
         DO 150 I = 1,NUMHIS
            HILINE = LABEL // HISCRD (I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
 150        CONTINUE
         END IF
      NUMHIS = 0
C                                       Close HI file
 200   CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                       Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN,
     *   DISK,  CNOIN, CNO, CATBLK, BUFF1, BUFF2, IERR)
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Clear status
      UTYPE = 'UV'
      STAT = 'CLWR'
      CALL CATDIR ('CSTA', DISK, CNO, NAMOUT, CLAOUT, CATBLK(KIIMS),
     *   UTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SDCTHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,' /')
 2001 FORMAT (A6,' BIF =',I4,', EIF =',I4,'/ IF RANGE')
 2002 FORMAT (A6,' BCHAN =',I4,', ECHAN =',I4,'/ CHAN RANGE')
 2003 FORMAT (A6,' SUBARRAY =',I4)
 2004 FORMAT (A6,' FGVER = ',I3, '/ Edited using FG table')
 2005 FORMAT (A6,' GAINUSE =',I3,' / CS table')
 2010 FORMAT (A6,' STOKES = ''',A4,''' / STOKES type')
 2011 FORMAT (A6,' APARM(1) =',F5.2,' / >0 => Average in freq.')
 2012 FORMAT (A6,' APARM(2) =',F5.2,' / Integration time (sec)')
      END
      SUBROUTINE SDCCOP (VISOFF, TOTREC, FINISH, DOAVG, DISK, CNO,
     *   NOSUB, FREQO, IRET)
C-----------------------------------------------------------------------
C   SDCCOP reads and corrects data files with optional averaging
C   over the frequency axis.
C   Input:
C    VISOFF      I    Offset in output file
C    TOTREC(2,3) I    Total counts of record flagging
C    FINISH      L    If True, this finishes the source, compress, etc.
C    DOAVG       L    If true, average frequencies in IF
C    DISK        I    Output disk number.
C    CNO         I    Output catalog slot number.
C    NOSUB       L    IF True drop subarray code.
C    FREQO(*)    D    IF Frequency offsets for source (Hz)
C   Input from common:
C    JBUFSZ      I    Size of BUFF1
C    INCF   I     Increment in freq. of data from SDGET
C    INCIF  I     Increment in IF of data from SDGET
C    INCS   I     Increment in Stokes' of data from SDGET
C    JLOCF  I     Offset of freq. of data from SDGET
C    JLOCIF I     Offset of IF of data from SDGET
C    JLOCS  I     Offset of Stokes' of data from SDGET
C   Output:
C    BUFF1  R     Output I/O buffer.
C    IRET   I     Return error code, 0=>OK, otherwise error.
C-----------------------------------------------------------------------
      CHARACTER NAME*48
      INTEGER   VISOFF, DISK, CNO, IRET
      LOGICAL   FINISH, DOAVG, NOSUB
      DOUBLE PRECISION    FREQO(*)
      INTEGER   LUN, FIND, BIND, LENBU, NIO, LOOPS, LOOPIF, LOOPF,
     *   JNCIF, JNCS, LRECO, INP, NUMFRQ, NNIF, NOPOL
      LOGICAL   T, F
      INTEGER   BO, I, XCOUNT, INDEX, OUTDEX, IIVER, TOTREC(2,3), BLCODE
      REAL SUMWT, SUMRE, SUMIM, XNORM, WT, VIS(4098)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'SDCAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
C
      REAL      FINC(MAXIF)
      INTEGER   ISBAND(MAXIF)
      CHARACTER BNDCOD(MAXIF)*8
      DOUBLE PRECISION FOFF(MAXIF)
C
      DATA T, F /.TRUE.,.FALSE./
      DATA LUN, BO /18,1/
C-----------------------------------------------------------------------
C                                       Set lengths of input axes.
      NUMFRQ = ECHAN - BCHAN + 1
      NUMIF = 1
      IF (JLOCIF.GT.0) NUMIF = CATBLK(KINAX+JLOCIF)
      NOPOL = CATBLK(KINAX+JLOCS)
C                                       Set output increments
C                                       (averaging)
      JNCIF = INCIF
      IF (JLOCF.LT.JLOCIF) JNCIF = INCIF / NUMFRQ
      JNCS = INCS
      IF (JLOCF.LT.JLOCS) JNCS = INCS / NUMFRQ
C                                       If output file already open
C                                       close it.
      IF ((FTAB(FIND).EQ.LUN) .AND. (VISOFF.LE.0))
     *   CALL ZCLOSE (LUN, FIND, IRET)
C                                       Setup for new file
      IF (VISOFF.GT.0) GO TO 30
C                                       Zero flag counts
         TOTREC(1,1) = 0
         TOTREC(2,1) = 0
         TOTREC(1,2) = 0
         TOTREC(2,2) = 0
         TOTREC(1,3) = 0
         TOTREC(2,3) = 0
C                                       Set output file name.
         CALL ZPHFIL ('UV', DISK, CNO, 1, NAME, IRET)
C                                       Open output file.
         CALL ZOPEN (LUN, FIND, DISK, NAME, T, F, T, IRET)
         IF (IRET.EQ.0) GO TO 20
            WRITE (MSGTXT,1000) IRET
            GO TO 990
C                                       Init vis file for write
 20      LENBU = 1
         LRECO = LREC
         IF (DOAVG) LRECO = NRPARM + (LREC-NRPARM) / NUMFRQ
         CALL UVINIT ('WRIT', LUN, FIND, CATBLK(KIGCN), VISOFF, LRECO,
     *      LENBU, JBUFSZ, BUFF1, BO, BIND, IRET)
         IF (IRET.EQ.0) GO TO 30
            WRITE (MSGTXT,1020) IRET
            GO TO 990
C                                       Copy file
 30   XCOUNT = 0
      DO 100 I = 1,NVIS
         IF (DOAVG) GO TO 40
C                                       No averaging:
            CALL SDGET ('READ', BUFF1(BIND), BUFF1(BIND+NRPARM), IRET)
            IF (IRET.LT.0) GO TO 110
            IF (IRET.NE.0) GO TO 999
            GO TO 90
C                                       Average in freq in each IF
 40         CALL SDGET ('READ', BUFF1(BIND), VIS, IRET)
            IF (IRET.LT.0) GO TO 110
            IF (IRET.NE.0) GO TO 999
C                                       Average.
            DO 70 LOOPS = 1,NOPOL
               DO 69 LOOPIF = 1,NUMIF
                  SUMWT = 0.0
                  SUMRE = 0.0
                  SUMIM = 0.0
                  INDEX = 1 + (LOOPS-1) * INCS + (LOOPIF-1) * INCIF
                  OUTDEX = BIND + NRPARM + (LOOPS-1) * JNCS +
     *               (LOOPIF-1) * JNCIF
                  DO 50 LOOPF = 1,NUMFRQ
                     INP = INDEX + (LOOPF-1) * INCF
                     WT = VIS(INP+2)
                     IF (WT.LE.0.0) WT = 0.0
                     SUMRE = SUMRE + VIS(INP) * WT
                     SUMIM = SUMIM + VIS(INP+1) * WT
                     SUMWT = SUMWT + WT
 50                  CONTINUE
                  XNORM = 1.0
                  IF (SUMWT.GT.1.0E-10) XNORM = 1.0 / SUMWT
                  BUFF1(OUTDEX) = SUMRE * XNORM
                  BUFF1(OUTDEX+1) = SUMIM * XNORM
                  BUFF1(OUTDEX+2) = SUMWT
 69               CONTINUE
 70            CONTINUE
C                                       Drop subarray if requested
 90      IF (ILOCB.GE.0) THEN
            BLCODE = BUFF1(BIND+ILOCB)
            IF (NOSUB) BUFF1(BIND+ILOCB) = BLCODE
         ELSE IF (NOSUB) THEN
            BUFF1(BIND+ILOCSA) = 1.0
            END IF
C                                       Write new
         NIO = 1
         XCOUNT = XCOUNT + 1
         CALL UVDISK ('WRIT', LUN, FIND, BUFF1, NIO, BIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1090) IRET
            GO TO 990
            END IF
 100     CONTINUE
C                                       If FINISH shut down output
 110  NVIS = XCOUNT
C                                       Sum flag counts
         TOTREC(1,1) = TOTREC(1,1) + CNTREC(1,1)
         TOTREC(2,1) = TOTREC(2,1) + CNTREC(2,1)
         TOTREC(1,2) = TOTREC(1,2) + CNTREC(1,2)
         TOTREC(2,2) = TOTREC(2,2) + CNTREC(2,2)
         TOTREC(1,3) = TOTREC(1,3) + CNTREC(1,3)
         TOTREC(2,3) = TOTREC(2,3) + CNTREC(2,3)
      IF (.NOT.FINISH) GO TO 800
C                                       Flush output
         NIO = 0
         CALL UVDISK ('FLSH', LUN, FIND, BUFF1, NIO, BIND, IRET)
         IF (IRET.EQ.0) GO TO 120
            WRITE (MSGTXT,1090) IRET
            GO TO 990
C                                       Compress output file.
 120     NVIS = XCOUNT + VISOFF
         CALL UCMPRS (NVIS, DISK, CNO, LUN, CATBLK, IRET)
C                                       Update CATBLK.
         CALL CATIO ('UPDT', DISK, CNO, CATBLK, 'REST', BUFF1, IRET)
         IF (IRET.EQ.0) GO TO 140
            WRITE (MSGTXT,1130) IRET
C                                       Copy relevant portion of IF
C                                       table.
 140     IF (JLOCIF.GT.0) THEN
C                                       Read old
            IIVER = 1
            CALL CHNDAT ('READ', BUFF1, IUDISK, IUCNO, IIVER, CATUV,
     *         LUN, NNIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Fixup
            NNIF = EIF - BIF + 1
            DO 150 I = BIF,EIF
               FOFF(I) = FOFF(I) + FREQO(I)
 150           CONTINUE
C                                       Rewrite new
            IIVER = 1
            CALL CHNDAT ('WRIT', BUFF1, DISK, CNO, IIVER, CATBLK, LUN,
     *         NNIF, FOFF(BIF), ISBAND(BIF), FINC(BIF), BNDCOD(BIF),
     *         FRQSEL, IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
C                                       Give data summary
         IF (DOCAL) THEN
            WRITE (MSGTXT,2800)
            CALL MSGWRT (6)
            WRITE (HISCRD(NUMHIS+1),2800)
            NUMHIS = NUMHIS + 1
            WRITE (MSGTXT,2801) TOTREC(1,1), TOTREC(1,2), TOTREC(1,3)
            CALL MSGWRT (6)
            WRITE (HISCRD(NUMHIS+1),2801) TOTREC(1,1), TOTREC(1,2),
     *         TOTREC(1,3)
            NUMHIS = NUMHIS + 1
            WRITE (MSGTXT,2802) TOTREC(2,1), TOTREC(2,2), TOTREC(2,3)
            CALL MSGWRT (6)
            WRITE (HISCRD(NUMHIS+1),2802) TOTREC(2,1), TOTREC(2,2),
     *         TOTREC(2,3)
            NUMHIS = NUMHIS + 1
         ELSE
            WRITE (MSGTXT,2803) NVIS
            CALL MSGWRT (6)
            WRITE (HISCRD(NUMHIS+1),2803) NVIS
            NUMHIS = NUMHIS + 1
            END IF
C                                       No data found.
         IF (NVIS.LE.0) THEN
            IRET = 9
            WRITE (MSGTXT,1800)
            GO TO 990
            END IF
C                                       Close files
         CALL ZCLOSE (LUN, FIND, IRET)
C
 800  CALL SDGET ('CLOS', BUFF1(BIND), BUFF1(BIND+NRPARM), IRET)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SDCCOP: ERROR',I5,' OPENING OUTPUT FILE')
 1020 FORMAT ('SDCCOP: ERROR',I5,' INIT. OUTPUT FILE')
 1090 FORMAT ('SDCCOP: ERROR',I5,' WRITING OUTPUT FILE')
 1130 FORMAT ('SDCCOP: ERROR',I3,' UPDATING CATALOGUE HEADER')
 1800 FORMAT ('SDCCOP: ERROR - NO DATA WRITTEN')
 2800 FORMAT (10X,' Previously flagged ','  flagged by gain   ',
     *   '      kept')
 2801 FORMAT ('Partially ',2(I15,5X),I10)
 2802 FORMAT ('Fully     ',2(I15,5X),I10)
 2803 FORMAT (I9,' visibilities written')
      END

      SUBROUTINE TABGA (OPCODE, BUFFER, IGARNO, GAKOLS, GANUMV,
     *   NUMPOL, TIME, TIMEI, SOURID, ANTNO, SUBA, NODENO,
     *   CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IERR)
C-----------------------------------------------------------------------
C! Does I/O to GAIN (GA) table opened by GAINI
C# EXT-util UV Calibration Obselete
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to GAIN extention tables. Usually used after setup by
C   GAINI.
C    Inputs:
C     OPCODE       C*4 Operation code:
C                      'READ' = read entry from table.
C                      'WRIT' = write entry in table.
C                      'CLOS' = close file, flush on write
C     BUFFER(512)  I   I/O buffer and related storage, also defines file
C                      if open. Should have been returned by TABINI or
C                      TABINI.
C     IGARNO       I   Next scan number to read or write.
C     GAKOLS(18)   I   The column pointer array in order, TIME,
C                      TIME INT., SOURCE ID., ANTENNA NO., SUBARRAY,
C                      NODE NO.,
C                      REAL1, IMAG1, DELAY1, RATE1, WEIGHT1, REFANT 1,
C                      Following used if 2 polarizations per IF
C                      REAL2, IMAG2, DELAY2, RATE2, WEIGHT2, REFANT 2,
C     GANUMV(18)   I   Element count in each column.
C     NUMPOL       I   Number of polarizations per IF.
C    Input/output: (written to or read from GAIN file)
C     TIME         D   Center time of GAIN record (Days)
C     TIMEI        R   Time interval covered by record (days)
C     SOURID       I   Source ID as defined in the SOURCE table.
C     ANTNO        I   Antenna number.
C     SUBA         I   Subarray number.
C     NODENO       I   Interpolation node number
C     CREAL(2,*)   R   Real part of the complex gain, 1 /Poln/IF
C     CIMAG(2,*)   R   Imag part of the complex gain, 1 /Poln/IF
C     DELAY(2,*)   R   Residual group delay (sec), 1 /Poln/IF
C     RATE(2,*)    R   Residual fringe rate (Hz), 1 /Poln/IF
C     WEIGHT(2,*)  R   Weight of solution, 1 /Poln/IF
C     REFA(2,*)    R   Ref. ant. of solution, 1 /Poln/IF
C    Output:
C     IGARNO       I   Next GAIN number.
C     IERR         I   Error code, 0=>OK else TABIO error.
C                      Note: -1=> read but record deselected.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   MAXIF
      PARAMETER (MAXIF=15)
      INTEGER   BUFFER(512), GAKOLS(18), GANUMV(18), NUMPOL, IERR,
     *   SOURID, ANTNO, SUBA, NODENO, REFA(2,MAXIF),
     *   RECI(1), KOLS(18), NUMIF,
     *   TIMKOL, INTKOL, SOUKOL, ANTKOL, SUBKOL, NODKOL,
     *   RE1KOL, IM1KOL, DL1KOL, RA1KOL, WT1KOL, RF1KOL,
     *   RE2KOL, IM2KOL, DL2KOL, RA2KOL, WT2KOL, RF2KOL
      LOGICAL   DOREAD, DOCLOS
      INTEGER   IGARNO,  LOOP
      REAL      RECORD(7+12*MAXIF),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF),
     *   WEIGHT(2,MAXIF), TIMEI
      DOUBLE PRECISION    TIME, RECD(1)
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (KOLS(1), TIMKOL), (KOLS(2), INTKOL),
     *   (KOLS(3), SOUKOL), (KOLS(4),ANTKOL), (KOLS(5), SUBKOL),
     *   (KOLS(6), NODKOL),
     *   (KOLS(7), RE1KOL), (KOLS(8),IM1KOL),
     *   (KOLS(9), DL1KOL), (KOLS(10), RA1KOL),
     *   (KOLS(11), WT1KOL), (KOLS(12), RF1KOL),
     *   (KOLS(13), RE2KOL), (KOLS(14),IM2KOL),
     *   (KOLS(15), DL2KOL), (KOLS(16), RA2KOL),
     *   (KOLS(17), WT2KOL), (KOLS(18), RF2KOL)
      EQUIVALENCE (RECD, RECORD, RECI)
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
      DOCLOS = OPCODE.EQ.'CLOS'
C                                       Branch for CLOS
      IF (DOCLOS) GO TO 800
C                                       Set pointers
      CALL COPY (18, GAKOLS, KOLS)
C                                       If write fill RECORD
      IF (DOREAD) GO TO 50
         RECORD(TIMKOL) = TIME
         RECORD(INTKOL) = TIMEI
         RECI(SOUKOL) = SOURID
         RECI(ANTKOL) = ANTNO
         RECI(SUBKOL) = SUBA
         RECI(NODKOL) = NODENO
C                                       First polarization
         NUMIF = GANUMV(7)
         DO 10 LOOP = 1,NUMIF
            RECORD(RE1KOL) = CREAL(1,LOOP)
            RECORD(IM1KOL) = CIMAG(1,LOOP)
            RECORD(DL1KOL) = DELAY(1,LOOP)
            RECORD(RA1KOL) = RATE(1,LOOP)
            RECORD(WT1KOL) = WEIGHT(1,LOOP)
            RECI(RF1KOL) = REFA(1,LOOP)
            IF (LOOP.GE.NUMIF) GO TO 10
               RE1KOL = RE1KOL + 1
               IM1KOL = IM1KOL + 1
               RA1KOL = RA1KOL + 1
               DL1KOL = DL1KOL + 1
               WT1KOL = WT1KOL + 1
               RF1KOL = RF1KOL + 1
 10         CONTINUE
         IF (NUMPOL.LT.2) GO TO 50
C                                       Two polarizations
            DO 20 LOOP = 1,NUMIF
               RECORD(RE2KOL) = CREAL(2,LOOP)
               RECORD(IM2KOL) = CIMAG(2,LOOP)
               RECORD(DL2KOL) = DELAY(2,LOOP)
               RECORD(RA2KOL) = RATE(2,LOOP)
               RECORD(WT2KOL) = WEIGHT(2,LOOP)
               RECI(RF2KOL) = REFA(2,LOOP)
               IF (LOOP.GE.NUMIF) GO TO 20
                  RE2KOL = RE2KOL + 1
                  IM2KOL = IM2KOL + 1
                  RA2KOL = RA2KOL + 1
                  DL2KOL = DL2KOL + 1
                  WT2KOL = WT2KOL + 1
                  RF2KOL = RF2KOL + 1
 20         CONTINUE
C                                       Process record.
 50   CALL TABIO (OPCODE, 0, IGARNO, RECORD, BUFFER, IERR)
      IGARNO = IGARNO + 1
      IF (IERR.GT.0) GO TO 990
C                                       If READ pick data from RECORD.
      IF (DOREAD) THEN
         TIME = RECORD(TIMKOL)
         TIMEI = RECORD(INTKOL)
         SOURID = RECI(SOUKOL)
         ANTNO = RECI(ANTKOL)
         SUBA = RECI(SUBKOL)
         NODENO = RECI(NODKOL)
C                                       First polarization
         DO 60 LOOP = 1,NUMIF
            CREAL(1,LOOP) = RECORD(RE1KOL)
            CIMAG(1,LOOP) = RECORD(IM1KOL)
            DELAY(1,LOOP) = RECORD(DL1KOL)
            RATE(1,LOOP) = RECORD(RA1KOL)
            WEIGHT(1,LOOP) = RECORD(WT1KOL)
            REFA(1,LOOP) = RECI(RF1KOL)
            IF (LOOP.LT.NUMIF) THEN
               RE1KOL = RE1KOL + 1
               IM1KOL = IM1KOL + 1
               RA1KOL = RA1KOL + 1
               DL1KOL = DL1KOL + 1
               WT1KOL = WT1KOL + 1
               RF1KOL = RF1KOL + 1
               END IF
 60         CONTINUE
C                                       Two polarizations
         IF (NUMPOL.GE.2) THEN
            DO 80 LOOP = 1,NUMIF
               CREAL(2,LOOP) = RECORD(RE2KOL)
               CIMAG(2,LOOP) = RECORD(IM2KOL)
               DELAY(2,LOOP) = RECORD(DL2KOL)
               RATE(2,LOOP) = RECORD(RA2KOL)
               WEIGHT(2,LOOP) = RECORD(WT2KOL)
               REFA(2,LOOP) = RECI(RF2KOL)
               IF (LOOP.LT.NUMIF) THEN
                  RE2KOL = RE2KOL + 1
                  IM2KOL = IM2KOL + 1
                  RA2KOL = RA2KOL + 1
                  DL2KOL = DL2KOL + 1
                  WT2KOL = WT2KOL + 1
                  RF2KOL = RF2KOL + 1
                  END IF
 80            CONTINUE
            END IF
         END IF
      GO TO 999
C                                       Close
 800  CALL TABIO ('CLOS', 0, IGARNO, RECORD, BUFFER, IERR)
      IF (IERR.GT.0) GO TO 990
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1800) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1800 FORMAT ('TABGA: TABIO ERROR',I3)
      END

      SUBROUTINE YCURSE (OP, WAIT, CORR, RPOS, QUAD, BUTTON, IERR)
C-----------------------------------------------------------------------
C! read and control TV cursor
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YCURSE reads cursor positions and controls the blink and visibility
C   of the TV cursor.
C   Inputs:
C      OP      C*4     'READ' read cursor position
C                      'ONNN' place cursor at RPOS & leave on
C                      'OFFF' turn cursor off
C                      'BLNK' reverse sense of cursor blink
C                      'FXIT' fix RPOS for zoom scroll, no IO
C      WAIT    L       wait for event; then return RPOS & BUTTON
C                      (done on all OPs)
C      CORR    L       T => correct RPOS for zoom & scroll
C   In/Out:
C      RPOS    R(2)    X,Y screen pos before  zoom & scroll
C      QUAD    I       TV quadrant to use for scrolls
C                         In: if <1 >4, no scroll
C                         Out: if in=-1, no scroll, else find
C                              quadrant (needs real TV pos)
C   Output:
C      BUTTON  I       event # (0 none, 1-7 low buttons,
C                      8-15 the "quit" button)
C      IERR    I       error code of Z...XF : 0 - ok
C                                             2 - input error
C   IVAS version
C   IVAS version - generic plus bug in 12-bit version 2.n IVAS  ??????
C-----------------------------------------------------------------------
      CHARACTER  OP*4
      REAL       RPOS(2)
      INTEGER    BUTTON, IERR, QUAD
      LOGICAL    WAIT, CORR
C
      CHARACTER  OPCODE(5)*4
      REAL       SRX, SRY, CURDEL, TMAG, TEMP
      INTEGER    ISCRX, ISCRY, NOP, MAG, ISX, ISY, IX, IY, IRBLNK, IBUT,
     *   J, NSCR, I, IOP, ZAND, IXC, IYC
      LOGICAL    OLDON, LINKX, LINKY, F, T, ON
      INCLUDE 'INCS:DTVC.INC'
      DATA NOP, OPCODE /5, 'READ','ONNN','OFFF','BLNK','FXIT'/
      DATA CURDEL /0.2/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      BUTTON = 0
C                                        get opcode
      IERR = 2
      DO 10 IOP = 1,NOP
         IF (OP.EQ.OPCODE(IOP)) GO TO 20
 10      CONTINUE
      GO TO 999
C                                        ON: alters cursor pos
C                                        go from real to screen
 20   IF (IOP.NE.2) GO TO 40
         IF (CORR) GO TO 25
            ISX = RPOS(1) + 0.5
            ISY = RPOS(2) + 0.5
            GO TO 40
C                                        what scroll to use
 25      ISCRX = 0
         ISCRY = 0
         IF ((QUAD.LT.1) .OR. (QUAD.GT.4)) GO TO 35
            NSCR = NGRAY + NGRAPH
            DO 30 I = 1,NSCR
               J = 2 ** (I-1)
               IF (ZAND(J,TVLIMG(QUAD)).NE.0) GO TO 31
 30            CONTINUE
            GO TO 35
 31         IF (I.GT.NGRAY) I = NGRAY + 1
            ISCRX = TVSCRX(I)
            ISCRY = TVSCRY(I)
 35      MAG = 1 + TVZOOM(1)
         IF (MXZOOM.GT.0) MAG = 2 ** TVZOOM(1)
         TMAG = MAG
C                                       IVAS 12-bit bug V2.n
         IF (NGRAY.EQ.2) THEN
            SRX = MOD (RPOS(1) - 1.0 + ISCRX + 10.0*MAXXTV(1)
     *         - 2.0 + 2.0/TMAG,
     *         REAL(MAXXTV(1))) + 1.0
            SRY = MOD (RPOS(2) - 1.0 + ISCRY + 10.0*MAXXTV(2)
     *         + 1.0/TMAG,
     *         REAL(MAXXTV(2))) + 1.0
         ELSE
            SRX = MOD (RPOS(1) - 1.0 + ISCRX + 10.0*MAXXTV(1),
     *         REAL(MAXXTV(1))) + 1.0
            SRY = MOD (RPOS(2) - 1.0 + ISCRY + 10.0*MAXXTV(2),
     *         REAL(MAXXTV(2))) + 1.0
            END IF
         IXC = (TVZOOM(2) - 1.0) * (TMAG - 1.0) / TMAG + 1.
         ISX = TMAG * (SRX - IXC) + 1.001
         IYC = (MAXXTV(2) - TVZOOM(3)) * (TMAG - 1.) / TMAG
         TEMP = MAXXTV(2) - IYC - MAXXTV(2) / TMAG + 1.0
         ISY = TMAG * (SRY - TEMP) + 1.001
         ISX = ISX + (MAG-1)/2
         ISY = ISY + (MAG-1)/2
C                                        read current status
 40   IF (IOP.EQ.5) THEN
         IX = RPOS(1) + 0.5
         IY = RPOS(2) + 0.5
         GO TO 70
         END IF
      CALL YCRCTL ('READ', OLDON, IX, IY, LINKX, LINKY, IRBLNK, IBUT,
     *   F, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        quick read is nearly done
      IF ((IOP.EQ.1) .AND. (.NOT.WAIT)) GO TO 70
C                                        ON: set new position
         IF (IOP.EQ.2) THEN
            IX = ISX
            IY = ISY
            END IF
C                                        BLNK: reverse blink rate
 45      IF (IOP.EQ.4) IRBLNK = MOD (IRBLNK+1, 2)
C                                        if reading set to ON
C                                        else set requested status
         ON = T
         IF ((IOP.EQ.3) .AND. (.NOT.WAIT)) ON = F
         IF ((IOP.EQ.4) .AND. (.NOT.WAIT)) ON = OLDON
C                                        write new pars to curs reg.
         CALL YCRCTL ('WRIT', ON, IX, IY, LINKX, LINKY, IRBLNK, IBUT,
     *      F, IERR)
         IF ((IERR.NE.0) .OR. (.NOT.WAIT)) GO TO 999
C                                        wait for event read cycle
 50      IF (IBUT.NE.0) GO TO 60
            CALL ZDELAY (CURDEL, IERR)
            CALL YCRCTL ('READ', ON, IX, IY, LINKX, LINKY, IRBLNK, IBUT,
     *         F, IERR)
            IF (IERR.NE.0) GO TO 999
            GO TO 50
C                                        event: reset status if need
 60      IF (IOP.EQ.3) ON = F
         IF ((IOP.EQ.1) .OR. (IOP.EQ.4)) ON = OLDON
         IF (.NOT.ON) CALL YCRCTL ('WRIT', ON, IX, IY, LINKX, LINKY,
     *      IRBLNK, IBUT, F, IERR)
         IF (IERR.NE.0) GO TO 999
C                                        return answers
 70   IF (IOP.NE.5) BUTTON = IBUT
      IF (CORR) GO TO 75
         RPOS(1) = IX
         RPOS(2) = IY
         GO TO 999
C                                        correct for zoom & scroll
 75   CONTINUE
C                                        Corr half cell
         MAG = 1 + TVZOOM(1)
         IF (MXZOOM.GT.0) MAG = 2 ** TVZOOM(1)
         IX = IX - (MAG-1)/2
         IY = IY - (MAG-1)/2
C                                        What quadr. scroll
         ISCRX = 0
         ISCRY = 0
         IF (QUAD.EQ.-1) GO TO 90
            QUAD = 4
            IF ((IX.GE.TVSPLT(1)) .AND. (IY.GE.TVSPLT(2))) QUAD = 1
            IF ((IX.LT.TVSPLT(1)) .AND. (IY.GE.TVSPLT(2))) QUAD = 2
            IF ((IX.LT.TVSPLT(1)) .AND. (IY.LT.TVSPLT(2))) QUAD = 3
            NSCR = NGRAY + NGRAPH
            DO 80 I = 1,NSCR
               J = 2 ** (I-1)
               IF (ZAND(J,TVLIMG(QUAD)).NE.0) GO TO 85
 80            CONTINUE
            GO TO 90
 85         IF (I.GT.NGRAY) I = NGRAY + 1
            ISCRX = TVSCRX(I)
            ISCRY = TVSCRY(I)
 90      TMAG = MAG
         IXC = (TVZOOM(2) - 1.0) * (TMAG - 1.0) / TMAG + 1.
         IYC = (MAXXTV(2) - TVZOOM(3)) * (TMAG - 1.) / TMAG
         TEMP = MAXXTV(2) - IYC - MAXXTV(2) / TMAG + 1.0
C                                       IVAS 12-bit bug V2.n
         IF (NGRAY.EQ.2) THEN
            RPOS(1) = (IX - 1.0) / TMAG + IXC  + 2.0 - 2.0/TMAG
            RPOS(2) = (IY - 1.0) / TMAG + TEMP - 1.0 / TMAG
         ELSE
            RPOS(1) = (IX - 1.0) / TMAG + IXC
            RPOS(2) = (IY - 1.0) / TMAG + TEMP
            END IF
C                                       correct for scroll
 100  RPOS(1) = MOD (RPOS(1) - 1.0 - ISCRX + 10.0*MAXXTV(1),
     *   REAL(MAXXTV(1))) +  1.0
      RPOS(2) = MOD (RPOS(2) - 1.0 - ISCRY + 10.0*MAXXTV(2),
     *   REAL(MAXXTV(2)))  +  1.0
      IERR = 0
C
 999  RETURN
      END

      SUBROUTINE ZTRLOG (LLEN, LOGNAM, XLEN, XLATED, XLNB, IERR)
C-----------------------------------------------------------------------
C! translate a logical name
C# System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  Translate a logical name (i.e., environment variable).
C  Inputs:
C     LLEN     I          Length of LOGNAM (1-relative)
C     LOGNAM   C*(LLEN)   Logical name
C     XLEN     I          Length of XLATED (1-relative)
C  Output:
C     XLATED   C*(XLEN)   Translation (blank filled)
C     XLNB     I          Position of last non-blank in XLATED
C                         (1-relative)
C     IERR     I          Error return code: 0 => no error
C                             1 => error
C  Generic version - calls ZTRLO2 with HOLLERITHs
C-----------------------------------------------------------------------
      INTEGER   LLEN, XLEN, XLNB, IERR
      CHARACTER LOGNAM*(*), XLATED*(*)
C
      HOLLERITH HOGNAM(64), HLATED(64), HBLANK(2)
C-----------------------------------------------------------------------
      CALL CHR2H (4, '    ', 1, HBLANK)
      CALL RFILL (64, HBLANK(1), HOGNAM)
      CALL RFILL (64, HBLANK(1), HLATED)
      XLATED = ' '
      CALL CHR2H (LLEN, LOGNAM, 1, HOGNAM)
      CALL ZTRLO2 (LLEN, HOGNAM, XLEN, HLATED, XLNB, IERR)
      IF (XLNB.GT.0) CALL H2CHR (XLNB, 1, HLATED, XLATED)
C
 999  RETURN
      END

LOCAL INCLUDE 'BLANK.INC'
C                                                      Include BLANK
      INCLUDE 'INCS:PMAD.INC'
C                                       Local include for BLANK
      REAL      XSEQIN, XDISKI, XSEQ2N, XDIS2I, XSEQO, XDISKO, BLC(7),
     *   TRC(7), BCHAN, ECHAN, DOCAT, DOALIN, DPARM(10), DOINVR, XNBOX,
     *   XBOX(4,10), TVCHAN, RANGE(2), TXINC, TYINC
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAM2I(3), XCLA2I(2), XNAMOU(3),
     *   XCLAOU(2), XOPCOD, XTVFUN
      CHARACTER NAMEIN*12, CLAIN*6, NAM2IN*12, CLA2IN*6, NAMOUT*12,
     *   CLAOUT*6, OPCODE*4, TVFUNC*4
      DOUBLE PRECISION CATD(128), OLDD(128), NEWD(128), CLPD(128)
      REAL      CATR(256), OLDR(256), NEWR(256), CLPR(256)
      HOLLERITH CATH(256), OLDH(256), NEWH(256), CLPH(256)
      INTEGER   CATBLK(256), CATOLD(256), CATNEW(256), CATCLP(256),
     *   SEQIN, SEQ2IN, SEQOUT, DISKIN, DIS2IN, DISKO, NEWCNO, NE2CNO,
     *   OLDCNO, JBUFSZ, ICODE, NAXSKP, BBLC(7), BTRC(7), NX2LIM(7),
     *   LUNI1, LUNI2, LUNO1, LUNO2, INDI1, INDI2, INDO1, INDO2, TTYLUN,
     *   TTYIND, SBUFF(256), IBUFF1(MABFSS), IBUFF2(MABFSS), IXAX, IYAX,
     *   BOXES(4,10), NBOX
      REAL      XBUFF1(MABFSS), XBUFF2(MABFSS), XBUFF3(MABFSS),
     *   XBUFF4(MABFSS)
      EQUIVALENCE (IBUFF1, XBUFF1), (IBUFF2, XBUFF2)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, XNAM2I, XCLA2I,
     *   XSEQ2N, XDIS2I, XNAMOU, XCLAOU, XSEQO, XDISKO, BLC, TRC,
     *   BCHAN, ECHAN, DOCAT, DOALIN, XOPCOD, DPARM, DOINVR, XNBOX,
     *   XBOX, TVCHAN, RANGE, XTVFUN, TXINC, TYINC
      COMMON /BLKCHR/ NAMEIN, CLAIN, NAM2IN, CLA2IN, NAMOUT, CLAOUT,
     *   OPCODE, TVFUNC
      COMMON /PARMS/ CATOLD, CATNEW, CATCLP, SEQIN, SEQ2IN, SBUFF,
     *   SEQOUT, DISKIN, DIS2IN, DISKO, NEWCNO, NE2CNO, OLDCNO, JBUFSZ,
     *   ICODE, NAXSKP, BBLC, BTRC, NX2LIM, LUNI1, LUNI2, LUNO1, LUNO2,
     *   INDI1, INDI2, INDO1, INDO2, TTYLUN, TTYIND, NBOX, IXAX, IYAX,
     *   BOXES
      COMMON /IMBUF/ XBUFF1, XBUFF2, XBUFF3, XBUFF4
      COMMON /MAPHDR/ CATBLK
      EQUIVALENCE (CATBLK, CATR, CATD, CATH)
      EQUIVALENCE (CATNEW, NEWR, NEWD, NEWH)
      EQUIVALENCE (CATOLD, OLDR, OLDD, OLDH)
      EQUIVALENCE (CATCLP, CLPR, CLPD, CLPH)
C                                                          End BLANK.
LOCAL END
      PROGRAM BLANK
C-----------------------------------------------------------------------
C! Blanks regions of an image selected by the user.
C# Map TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2000, 2006, 2008, 2010, 2015, 2022
C;  Copyright (C) 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BLANK blanks out regions of the image purportedly free of real
C   signal using one TV interactive and a variety of batch algorithms.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      OUTNAME        NAMOUT        Name of the output image
C                                   Default output is input image.
C      OUTCLASS       CLAOUT        Class of the output image.
C                                   Default is input class.
C      OUTSEQ         SEQOUT        Seq. number of output image.
C      OUTDISK        DISKO         Disk number of the output image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      BCHAN          BCHAN         First channel with signal
C      ECHAN          ECHAN         Last channel with signal
C      DOCAT          DOCAT         Catalog avg of blanked pixels
C      OPCODE         OPCODE        Operation type: 'TVCU','SELC',
C                                   'IN2C','FIXW','FLTW','MOMW','FLUW',
C      DPARM          DPARM         (1) window width
C                                   (2) <= 0 -> center 1st moment
C                                       else on peak
C                                   (3) F1 cutoff   (4) F2 cutoff
C                                   (5) > 0: replace blanks by DPARM(6)
C                                   (6) if (5)>0, use instead of blank.
C      TVCHAN                       TV channel to use
C      PIXRANGE                     Min,Max of image intensity
C                                   Max <= Min => entire range
C      TXINC                        X increment in TV loads
C      TYINC                        Y increment in TV loads
C  BCHAN......First x pixel (after application of BLC(1)) which
C             is allowed to be left unblanked in the output
C             image.  This option is useful only if the average
C             of the blanked pixels is written and provides a
C             wider region over which the averaging is performed.
C             The actual number of points on the output image row
C             is given by ECHAN - BCHAN + 1.   (0 => 1).
C  ECHAN......The last x pixel (after application of BLC(1))
C             which is allowed to be left unblanked in the output
C             image.  0 => TRC(1) - BLC(1) + 1.
C  OPCODE.....How the program is to do blanking:
C             'TVCU' : display image planes (any transposition)
C                      on TV and mark signal regions with cursor
C             'FIXW' : fixed window BCHAN through ECHAN
C             'FLTW' : floating window of fixed width
C             'MOMW' : window with width set by 2nd moment
C             'FLUW' : window set by fluxes (from peak through
C                      last pixel > F1 on each side plus "slop")
C             'SELC' : If F1 < F2, keep all F <= 1.0, F >= F2
C                      If F1 > F2, keep all F1 >= F >= F2.
C             'IN2C' : Like 'SELC', except the test is done on a
C                      second image (IN2NAME et al.) rather than
C                      the input image.
C  DPARM......Parameters:
C             (1) 'FLTW' window size in x pixels.
C                 'MOMW' window size = DPARM(1) * 2nd moment
C                 'SELC','IN2C','FLUW' "slop" - extend "good"
C                     areas by DPARM(1) pixels in each direction
C             (2) 'FLTW','MOMW','FLUW' center window on first
C                     moment (<= 0) or on peak intensity (> 0).
C             (3) (Called F1 above for 'SELC','IN2C','FLUW'.)
C                 Also ignore in moment computations all
C                 intensities < F1.  Units are those of image.
C             (4) (Called F2 above for 'SELC','IN2C'.)  Units are
C                 those of image.
C             (5) <= 0. -> retain existing magic-value blanks and
C                 use magic-values for newly blanked pixels.
C                 > 0.  -> change all magic values to DPARM(6) on
C                 output.
C             (6) if (5)>0, use instead of blank.
C   Programmer Eric W. Greisen:  October 1983
C     MRC 86/May/23: In BLNKIN change assignment of NA(1) and NA(2),
C                    In DO1BLK avoid divide by zero.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'BLANK.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'BLANK '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL BLNKIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the blanking routine
      IF (ICODE.EQ.7) THEN
         CALL BLNKTV (IRET)
      ELSE IF (ICODE.EQ.9) THEN
         CALL BLNKBX (IRET)
      ELSE
         CALL BLNKDO (IRET)
         END IF
C                                       Finish image(s), do History
      IF (IRET.EQ.0) CALL BLNKOU (IRET)
C                                       Close down files, etc.
 990  CALL DIE (IRET, SBUFF)
C
 999  STOP
      END
      SUBROUTINE BLNKIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   BLNKIN gets input parameters for BLANK and creates an output file
C   IF requested for the residual map.
C   Inputs:  PRGN    C*6       Program name
C   Output:  IRET    I         Error code: 0 => ok
C                                4 => user routine detected error.
C                                5 => catalog troubles
C                                8 => can't start
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER   STAT*4,  PRGN*6, BLANK*6, SEQTYP(2)*4, CODES(9)*4,
     *   MTYPE*2
      INTEGER  IRET
      INTEGER   IERR, NPARM, IROUND, NAX, I, NCODE, NA(2), J, K, KA,
     *   NX1, NX2, INPSEQ, IDEPTH(5)
      REAL      EPS, AXV
      DOUBLE PRECISION DAXV
      LOGICAL   EQUAL
      INCLUDE 'BLANK.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA IDEPTH /5*1/
      DATA BLANK /'      '/
      DATA SEQTYP /'AVGB','LK  '/
      DATA NCODE, CODES /9, 'IN2C','SELC','FIXW','FLTW','MOMW','FLUW',
     *   'TVCU','RADI','BOX'/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      CALL FILL (10, 0, IBAD)
C                                       Get input parameters.
      NPARM = 98
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SBUFF, IERR)
      IF (IERR.EQ.0) GO TO 10
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
C                                       Convert characters
 10   CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAM2I, NAM2IN)
      CALL H2CHR (6, 1, XCLA2I, CLA2IN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      CALL H2CHR (2, 1, XTVFUN, TVFUNC)
C                                       Using the TV
      ICODE = 0
      DO 15 I = 1,NCODE
         IF (OPCODE.EQ.CODES(I)) ICODE = I
 15      CONTINUE
      IF (ICODE.LE.0) THEN
         WRITE (MSGTXT,1020) OPCODE
         CALL MSGWRT (8)
         IRET = 4
      ELSE IF (ICODE.EQ.7) THEN
         IF ((NPOPS.GT.NINTRN) .OR. (NTVDEV.LE.0)) THEN
            ICODE = 0
            MSGTXT = 'THERE IS NO TV ASSIGNED TO YOUR AIPS'
            CALL MSGWRT (8)
            IRET = 8
            END IF
         END IF
C                                       Restart AIPS
      IF ((RQUICK) .AND. ((ICODE.NE.7) .OR. (IRET.NE.0))) CALL RELPOP
     *    (IRET, SBUFF, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQIN = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO = IROUND (XDISKO)
      LUNI1 = 16
      LUNI2 = 17
      LUNO1 = 18
      LUNO2 = 19
      TTYLUN = 5
      TTYIND = 0
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, SBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, 'READ', SBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATOLD(KIDIM), CATOLD(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Set up BOX
      IF (ICODE.EQ.9) THEN
         LOCNUM = 1
         CALL COPY (256, CATOLD, CATBLK)
         CALL SETLOC (IDEPTH, .FALSE.)
         IXAX = KLOCL(LOCNUM) + 1
         IYAX = KLOCM(LOCNUM) + 1
         IF ((IXAX.LE.0) .OR. (IYAX.LE.0)) THEN
            MSGTXT = 'COORDINATE PAIR NOT FOUND'
            IERR = 10
            GO TO 990
         END IF
         NBOX = XNBOX + 0.1
         NBOX = MAX (1, MIN (10, NBOX))
         DO 50 I = 1,NBOX
            DO 45 J = 1,4
               BOXES(J,I) = IROUND (XBOX(J,I))
 45            CONTINUE
            MSGTXT = 'BOX OUTSIDE BLC, TRC'
            IERR = 10
            IF (BOXES(1,I).GT.0) THEN
               IF (BOXES(1,I).LT.BLC(IXAX)) GO TO 990
               IF (BOXES(1,I).GT.TRC(IXAX)) GO TO 990
               IF (BOXES(2,I).LT.BLC(IYAX)) GO TO 990
               IF (BOXES(2,I).GT.TRC(IYAX)) GO TO 990
               END IF
            IF (BOXES(3,I).LT.BLC(IXAX)) GO TO 990
            IF (BOXES(3,I).GT.TRC(IXAX)) GO TO 990
            IF (BOXES(4,I).LT.BLC(IYAX)) GO TO 990
            IF (BOXES(4,I).GT.TRC(IYAX)) GO TO 990
 50         CONTINUE
         IERR = 0
         END IF
C                                       Second input file
      NCFILE = 2
      FRW(2) = -1
      NAXSKP = -1
      EPS = 0.2
      CALL FILL (7, 1, BBLC)
      CALL FILL (7, 1, BTRC)
      CALL FILL (7, 1, CATCLP(KINAX))
      IF (ICODE.NE.1) GO TO 100
C                                       Get CATBLK of 2nd old file.
         NEWCNO = 1
         DIS2IN = IROUND (XDIS2I)
         SEQ2IN = IROUND (XSEQ2N)
         MTYPE = 'MA'
         CALL CATDIR ('SRCH', DIS2IN, NEWCNO, NAM2IN, CLA2IN, SEQ2IN,
     *      MTYPE, NLUSER, STAT, SBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1030) IERR, NAM2IN, CLA2IN, SEQ2IN, DIS2IN,
     *         NLUSER
            GO TO 990
            END IF
C                                       Read CATBLK and mark 'READ'.
         CALL CATIO ('READ', DIS2IN, NEWCNO, CATCLP, 'READ', SBUFF,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1055) IERR
            GO TO 990
            END IF
         FVOL(NCFILE) = DIS2IN
         FCNO(NCFILE) = NEWCNO
         FRW(NCFILE) = 0
C                                       Decide IO pattern
         DO 65 I = 1,2
            NA(I) = 0
            K = KHCTP + (I-1) * 2
            DO 64 J = I,7
               IF (NA(I).EQ.0) THEN
                  CALL CHCOMP (8, 1, CLPH(K), 1, OLDH(KHCTP+(J-1)*2),
     *               EQUAL)
                  IF (EQUAL) NA(I) = J
                  END IF
 64            CONTINUE
 65         CONTINUE
         NAXSKP = 0
         IF (DOALIN.LT.-1.5) GO TO 75
         IF ((NA(1).EQ.0) .OR. (NA(2).EQ.0)) GO TO 70
         IF ((NA(1).GT.2) .OR. (NA(2).GT.3)) GO TO 70
         IF (NA(2).LE.NA(1)) GO TO 70
            IF (NA(2).GT.2) NAXSKP = 2
            IF (NA(1).EQ.2) NAXSKP = 1
            GO TO 80
C                                       possible non-alignment
 70      IF (DOALIN.LE.-0.1) GO TO 75
            WRITE (MSGTXT,1070)
            GO TO 990
 75      CONTINUE
            NA(1) = 1
            NA(2) = 2
C                                       set corners, check alignment
 80      KA = 0
         IF (NAXSKP.GT.0) KA = 1
         NX1 = CATOLD(KIDIM)
         NX2 = CATCLP(KIDIM)
         DO 90 I = 1,7
            BBLC(I) = 1
            BTRC(I) = 1
            J = I - 1
            IF (CATCLP(KINAX+J).LT.1) CATCLP(KINAX+J) = 1
            IF ((I.GT.NX2) .OR. (I+KA.GT.NX1) .OR. (CATCLP(KINAX+J)
     *         .LE.1)) GO TO 90
               IF (I.LE.2) K = NA(I) - 1
               IF (I.GT.2) K = I + KA - 1
               AXV = CLPR(KRCRP+J) - OLDR(KRCRP+K) + BLC(K+1)
               IF (DOALIN.LT.-1.5) AXV = BLC(K+1)
               IF ((DOALIN.LE.-0.1) .OR. (CLPR(KRCIC+J).EQ.0.0))
     *            GO TO 82
                  DAXV = OLDD(KDCRV+K) + OLDR(KRCIC+K)*(BLC(K+1) -
     *               OLDR(KRCRP+K))
                  AXV = (DAXV - CLPD(KDCRV+J)) / CLPR(KRCIC+J) +
     *               CLPR(KRCRP+J)
 82            BBLC(I) = IROUND (AXV)
               BTRC(I) = BBLC(I) + TRC(K+1) - BLC(K+1) + EPS
               IF (BTRC(I).LT.1) GO TO 95
               IF (BBLC(I).GT.CATCLP(KINAX+J)) GO TO 95
C                                       smaller subim needed?
               IF (BBLC(I).GE.1) GO TO 84
                  BLC(K+1) = BLC(K+1) + 1 - BBLC(I)
                  AXV = AXV + 1 - BBLC(I)
                  BBLC(I) = 1
 84            IF (BTRC(I).LE.CATCLP(KINAX+J)) GO TO 86
                  TRC(K+1) = TRC(K+1) + CATCLP(KINAX+J) - BTRC(I)
                  BTRC(I) = CATCLP(KINAX+J)
 86            IF (BTRC(I).LT.BBLC(I)) GO TO 95
               IF (BLC(K+1).GT.CATOLD(KINAX+K)) GO TO 95
               IF (TRC(K+1).LT.1) GO TO 95
C                                       full alignment check
               IF (DOALIN.LT.0.1) GO TO 90
                  IF (ABS(BBLC(I)-AXV).GT.EPS) GO TO 95
                  CALL CHCOMP (8, 1, CLPH(KHCTP+J*2), 1,
     *               OLDH(KHCTP+K*2), EQUAL)
                  IF (.NOT.EQUAL) GO TO 95
                  AXV = EPS * EPS * ABS(OLDR(KRCIC+K))
                  IF (ABS(OLDR(KRCIC+K)-CLPR(KRCIC+J)).GT.AXV) GO TO 95
                  IF (ABS(OLDR(KRCRT+K)-CLPR(KRCRT+J)).GT.1.0) GO TO 95
 90            CONTINUE
            GO TO 100
C                                       Failure to align
 95      CONTINUE
            WRITE (MSGTXT,1095)
            GO TO 990
C                                       Output file creation
C                                       Copy old CATBLK to new.
 100  CALL COPY (256, CATOLD, CATBLK)
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
      INPSEQ = SEQOUT
C                                       Get user modification to CATBLK
      IRET = 4
      CALL BLKHED (IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Create output file for blanked
      IRET = 4
      NEWCNO = 1
      CALL MCREAT (DISKO, NEWCNO, SBUFF, IERR)
      IF (IERR.EQ.0) GO TO 110
         WRITE (MSGTXT,1100) IERR
         GO TO 990
 110  NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 2
      SEQOUT = CATBLK(KIIMS)
C                                       copy some keywords
      CALL KEYPCP (DISKIN, OLDCNO, DISKO, NEWCNO, 0, ' ', IERR)
C                                       created avg of blanked image
      IF (ICODE.EQ.8) DOCAT = 0.0
      IF (DOCAT.LE.0.0) GO TO 150
C                                       save the blanked header
         CALL COPY (256, CATBLK, IBUFF2)
C                                       Basic output header: results
         CATBLK(KIDIM) = CATBLK(KIDIM) - 1
         NAX = CATBLK(KIDIM)
         DO 120 I = 1,NAX
            CATBLK(KINAX+I-1) = CATBLK(KINAX+I)
            CATR(KRCRP+I-1) = CATR(KRCRP+I)
            CATR(KRCRT+I-1) = CATR(KRCRT+I)
            CATR(KRCIC+I-1) = CATR(KRCIC+I)
            CATD(KDCRV+I-1) = CATD(KDCRV+I)
            CALL CHCOPY (8, 1, CATR(KHCTP+I*2), 1,
     *         CATR(KHCTP+(I-1)*2))
 120        CONTINUE
         DO 125 I = NAX,6
            CATBLK(KINAX+I) = 1
 125        CONTINUE
         CATBLK(KIIMS) = INPSEQ
         CALL CHR2H (6, SEQTYP, KHIMCO, CATR(KHIMC))
C                                       Create
         DISKO = XDISKO + 0.01
         NEWCNO = 1
         CALL MCREAT (DISKO, NEWCNO, SBUFF, IERR)
         IF (IERR.EQ.0) GO TO 130
            WRITE (MSGTXT,1125) IERR, SEQTYP
            GO TO 990
C                                       Record the creation
 130     NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKO
         FCNO(NCFILE) = NEWCNO
         FRW(NCFILE) = 2
         CALL COPY (256, CATBLK, CATNEW)
         CALL COPY (256, IBUFF2, CATBLK)
C                                       copy some keywords
         CALL KEYPCP (DISKIN, OLDCNO, DISKO, NEWCNO, 0, ' ', IERR)
C                                       OK ! - clean up
 150  IRET = 0
      DISKO = FVOL(3)
      NEWCNO = FCNO(3)
C                                       check defaults
      IF (DPARM(1).LE.0.0) DPARM(1) = 0.0
      IF ((ICODE.EQ.4) .AND. (DPARM(1).LE.1.0)) DPARM(1) =
     *   (ECHAN - BCHAN + 1.0) / 2.0
      IF ((ICODE.EQ.5) .AND. (DPARM(1).LE.0.1)) DPARM(1) = 3.0
      IF ((ICODE.GT.2) .OR. (DPARM(3).NE.DPARM(4))) GO TO 999
         DPARM(3) = MIN (0.0, 0.1*OLDR(KRDMN))
         DPARM(4) = MAX (0.0, 0.1*OLDR(KRDMX))
         GO TO 999
C
 990  CALL MSGWRT (8)
 995  IF ((RQUICK) .AND. (ICODE.EQ.7)) CALL RELPOP (IRET, SBUFF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BLNKIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1020 FORMAT ('OPCODE ''',A4,''' IS NOT RECOGNIZED')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I2,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' READING INPUT IMAGE CATBLK')
 1055 FORMAT ('ERROR',I3,' READING CLIP IMAGE CATBLK')
 1070 FORMAT ('UNABLE TO ALIGN THE AXES - CHECK TRANSPOSITION')
 1095 FORMAT ('INPUT AND CLIP IMAGES DO NOT OVERLAP: CHECK HEADERS')
 1100 FORMAT ('ERROR',I5,' CREATING OUTPUT FILE')
 1125 FORMAT ('ERROR',I5,' CREATING FILE OF AVG BLANKED PIXELS')
      END
      SUBROUTINE BLKHED (IRET)
C-----------------------------------------------------------------------
C   BLKHED modifies the new image header for the subimaging.
C   Input:
C      CATBLK(256)    I     Output catalog header, also CATR, CATD
C      CATOLD(256)    I     Input catalog header, also OLDR, OLDD
C   Output:
C      CATBLK(256)    I     Modified output catalog header.
C      IRET           I     Return error code, 0=>OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER FCHARS(3)*4, CHTM12*12
      INTEGER   IRET, IROUND, I
      LOGICAL   EQUAL
      REAL      TEMPB, TEMPT
      INCLUDE 'BLANK.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA FCHARS /'FREQ','VELO','FELO'/
C-----------------------------------------------------------------------
      IRET = 0
C                                       Check input axes
      IF ((ICODE.LE.2) .OR. (ICODE.GE.7)) GO TO 20
         DO 10 I = 1,3
            CALL H2CHR (4, 1, CATR(KHCTP), CHTM12)
            EQUAL = FCHARS(I)(1:4).EQ. CHTM12(1:4)
            IF (EQUAL) GO TO 20
 10         CONTINUE
         MSGTXT = 'WARNING: FIRST AXIS NOT FREQUENCY OR VELOCITY'
         CALL MSGWRT (6)
C                                       check input parms
 20   I = TXINC + 0.01
      IF (I.LE.0) I = 1
      TXINC = I
      I = TYINC + 0.01
      IF (I.LE.0) I = 1
      TYINC = I
C                                       Baseline
      IF (ICODE.EQ.8) THEN
         BCHAN = 1
         ECHAN = TRC(1) - BLC(1) + 1.0
      ELSE
         BCHAN = IROUND (BCHAN)
         ECHAN = IROUND (ECHAN)
         IF (BCHAN.LE.0.) BCHAN = 1.0
         IF ((ECHAN.LE.0.) .OR. (ECHAN.GT.TRC(1)-BLC(1)+1)) ECHAN =
     *      TRC(1) - BLC(1) + 1.0
         IF (BCHAN.GE.ECHAN) THEN
            WRITE (MSGTXT,1020) BCHAN, ECHAN
            IRET = 8
            GO TO 990
            END IF
         END IF
      TEMPB = BLC(1)
      TEMPT = TRC(1)
      BLC(1) = BLC(1) + BCHAN - 1.0
      TRC(1) = BLC(1) + ECHAN - BCHAN
      CALL SUBHDR (BLC, TRC, 1.0, 1.0)
      BLC(1) = TEMPB
      TRC(1) = TEMPT
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('BCHAN, ECHAN = ',2F7.0,' IMPROPER')
      END
      SUBROUTINE BLNKDO (IRET)
C-----------------------------------------------------------------------
C   BLNKDO sends image one row at a time to the blanking routine and
C   then writes the modified data.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER IFILE*48
      LOGICAL   TBLNKD
      INTEGER   IRET, IROUND, IBIND1, IBIND2, OBIND1, OBIND2, NYI, NXI,
     *   WINI(4), NXO, NYO, WINO(4), BOI, IINCR, BOO, LIM2, LIM3, LIM4,
     *   LIM5, LIM6, LIM7, I1, I2, I3, I4, I5, I6, I7, IPOS(7), CORN(7),
     *   BOTEMP, KOFF, LIMO, LIMIT, LIM1, LIM1C, LOFF, WINT(4),
     *   CORNOU(8), WINI2(4), IPLDO
      REAL      PLTODO, PLDONE, PMAX, PMIN, OUTMAX, OUTMIN
      LOGICAL   T, F, BLNKD
      INCLUDE 'BLANK.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI1, INDI1, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Init second input map
      IF (NAXSKP.GE.0) THEN
         CALL ZPHFIL ('MA', FVOL(2), FCNO(2), 1, IFILE, IRET)
         CALL ZOPEN (LUNI2, INDI2, FVOL(2), IFILE, T, F, T, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1010) IRET
            GO TO 990
            END IF
        END IF
C                                       output blanked
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO1, INDO1, DISKO, IFILE, T, T, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1015) IRET
         GO TO 990
         END IF
C                                       For residual map:
      IF (DOCAT.GT.0.) THEN
         CALL ZPHFIL ('MA', FVOL(4), FCNO(4), 1, IFILE, IRET)
         CALL ZOPEN (LUNO2, INDO2, FVOL(4), IFILE, T, T, T, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1020) IRET
            GO TO 990
            END IF
         END IF
C                                       Setup for I/O
      NXI = CATOLD(KINAX)
      NYI = CATOLD(KINAX+1)
      NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
      WINI2(1) = BBLC(1)
      WINI2(2) = BBLC(2)
      WINI2(3) = BTRC(1)
      WINI2(4) = BTRC(2)
      LIM1C = BTRC(1) - BBLC(1) + 1
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      WINT(1) = 1
      WINT(2) = 1
      WINT(3) = CATNEW(KINAX)
      WINT(4) = CATNEW(KINAX+1)
      OUTMAX = -1.0E20
      OUTMIN = -OUTMAX
      PMAX = OUTMAX
      PMIN = OUTMIN
      BLNKD = F
      TBLNKD = .FALSE.
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
      IPLDO = 0
      PLDONE = 0.0
      PLTODO = REAL(LIM7) * REAL(LIM4) * REAL(LIM5) * REAL(LIM6)
      PLTODO = PLTODO * CATBLK(KINAX+2)
      KOFF = 0
      IF (NAXSKP.GT.0) KOFF = -1
      CORN(7) = 1
      LIMO = CATBLK(KINAX) - 1
      LOFF = KINAX - 1 + KOFF
      CORNOU(8) = 1
      IINCR = 1
      IF (NAXSKP.EQ.1) IINCR = 0
C                                       Loop
      DO 700 I7 = 1,LIM7
         CORNOU(7) = I7
         IPOS(7) = BLC(7) + I7 - 0.9
         CORN(7+KOFF) = BBLC(7+KOFF) + I7 - 2
         CORN(7+KOFF) = MOD (CORN(7+KOFF), CATCLP(7+LOFF)) + 1
         DO 600 I6 = 1,LIM6
            CORNOU(6) = I6
            IPOS(6) = BLC(6) + I6 - 0.9
            CORN(6+KOFF) = BBLC(6+KOFF) + I6 - 2
            CORN(6+KOFF) = MOD (CORN(6+KOFF), CATCLP(6+LOFF)) + 1
            DO 500 I5 = 1,LIM5
               CORNOU(5) = I5
               IPOS(5) = BLC(5) + I5 - 0.9
               CORN(5+KOFF) = BBLC(5+KOFF) + I5 - 2
               CORN(5+KOFF) = MOD (CORN(5+KOFF), CATCLP(5+LOFF)) + 1
               DO 400 I4 = 1,LIM4
                  CORNOU(4) = I4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  CORN(4+KOFF) = BBLC(4+KOFF) + I4 - 2
                  CORN(4+KOFF) = MOD (CORN(4+KOFF), CATCLP(4+LOFF)) + 1
C                                       Init. files: clip input maybe
                  IF (NAXSKP.GT.0) THEN
                     CALL COMOFF (CATCLP(KIDIM), CATCLP(KINAX),
     *                  CORN(3), BOTEMP, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1050) IRET
                        GO TO 990
                        END IF
                     BOI = BOTEMP + 1
                     CALL MINIT ('READ', LUNI2, INDI2, WINI2(3),
     *                  WINI2(4), WINI2, XBUFF2, JBUFSZ, BOI, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1055) IRET
                        GO TO 990
                        END IF
                     END IF
C                                       Init. file: output average
                  IF (DOCAT.GT.0.0) THEN
                     CALL COMOFF (CATNEW(KIDIM), CATNEW(KINAX),
     *                  CORNOU(4), BOTEMP, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1060) IRET
                        GO TO 990
                        END IF
                     BOI = BOTEMP + 1
                     CALL MINIT ('WRIT', LUNO2, INDO2, WINT(3), WINT(4),
     *                  WINT, XBUFF4, JBUFSZ, BOI, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1065) IRET
                        GO TO 990
                        END IF
                     END IF
                  DO 300 I3 = 1,LIM3
                     CORNOU(3) = I3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     CORN(3+KOFF) = BBLC(3+KOFF) + I3 - 2
                     CORN(3+KOFF) = MOD (CORN(3+KOFF), CATCLP(3+LOFF))
     *                  + 1
                     PLDONE = PLDONE + 1
                     IPLDO = IPLDO + 1
                     WRITE (MSGTXT,1070) PLDONE, PLTODO
                     IF (IPLDO.EQ.1) CALL MSGWRT (1)
                     IF (IPLDO.GE.16) IPLDO = 0
C                                       Init. files, first input.
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1099) IRET
            GO TO 990
            END IF
         BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI1, INDI1, NXI, NYI, WINI, XBUFF1,
     *      JBUFSZ, BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
C                                       Init blanked file.
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORNOU(3), BOTEMP,
     *      IRET)
         BOO = BOTEMP + 1
         CALL MINIT ('WRIT', LUNO1, INDO1, NXO, NYO, WINO, XBUFF3,
     *      JBUFSZ, BOO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1105) IRET
            GO TO 990
            END IF
C                                       Init. files, first input.
         IF (NAXSKP.EQ.0) THEN
            CALL COMOFF (CATCLP(KIDIM), CATCLP(KINAX), CORN(3), BOTEMP,
     *         IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1050) IRET
               GO TO 990
               END IF
            BOI = BOTEMP + 1
            CALL MINIT ('READ', LUNI2, INDI2, WINI2(3), WINI2(4), WINI2,
     *         XBUFF2, JBUFSZ, BOI, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1055) IRET
               GO TO 990
               END IF
            END IF
C                                       read clip maybe
         IF (NAXSKP.GT.0) THEN
            CALL MDISK ('READ', LUNI2, INDI2, XBUFF2, IBIND2, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
               END IF
            END IF
C                                       "write" output avg
         OBIND2 = 1
         IF (DOCAT.GT.0.0) THEN
            CALL MDISK ('WRIT', LUNO2, INDO2, XBUFF4, OBIND2, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET
               GO TO 990
               END IF
            END IF
         DO 250 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
C                                       Read.
            CALL MDISK ('READ', LUNI1, INDI1, XBUFF1, IBIND1, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1150) IRET
               GO TO 990
               END IF
C                                       Write.
            CALL MDISK ('WRIT', LUNO1, INDO1, XBUFF3, OBIND1, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1175) IRET
               GO TO 990
               END IF
C                                       read clip if needed
            IF (NAXSKP.EQ.0) THEN
               CALL MDISK ('READ', LUNI2, INDI2, XBUFF2, IBIND2, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1120) IRET
                  GO TO 990
                  END IF
               END IF
C                                       Call function: DO1BLK
            IF (ICODE.EQ.1) THEN
               CALL DO1BLK (IPOS, XBUFF1(IBIND1), XBUFF2(IBIND2), IINCR,
     *            XBUFF3(OBIND1), XBUFF4(OBIND2), IRET)
            ELSE IF (ICODE.EQ.8) THEN
               CALL DOPBLK (IPOS, XBUFF1(IBIND1), XBUFF3(OBIND1), IRET)
            ELSE
               CALL DO1BLK (IPOS, XBUFF1(IBIND1), XBUFF1(IBIND1), IINCR,
     *            XBUFF3(OBIND1), XBUFF4(OBIND2), IRET)
               END IF
            IF (DOCAT.GT.0.0) OBIND2 = OBIND2 + 1
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1210) IRET
               GO TO 990
               END IF
C                                       Check max, min, blanking.
            LIMIT = OBIND1 + LIMO
            DO 220 I1 = OBIND1,LIMIT
               IF (XBUFF3(I1).EQ.FBLANK) THEN
                  BLNKD = .TRUE.
               ELSE
                  OUTMAX = MAX (OUTMAX, XBUFF3(I1))
                  OUTMIN = MIN (OUTMIN, XBUFF3(I1))
                  END IF
 220           CONTINUE
            IF (DOCAT.GT.0.0) THEN
               I1 = OBIND2 - 1
               IF (XBUFF4(I1).EQ.FBLANK) THEN
                  TBLNKD = .TRUE.
               ELSE
                  PMAX = MAX (PMAX, XBUFF4(I1))
                  PMIN = MIN (PMIN, XBUFF4(I1))
                  END IF
               END IF
 250        CONTINUE
C                                       Flush buffers for blanked
         CALL MDISK ('FINI', LUNO1, INDO1, XBUFF3, OBIND1, IRET)
         IF (IRET.EQ.0) GO TO 300
            WRITE (MSGTXT,1175) IRET
            GO TO 990
 300     CONTINUE
C                                       Flush buffers for avg.
                  IF (DOCAT.LE.0.0) GO TO 400
                     CALL MDISK ('FINI', LUNO2, INDO2, XBUFF4, OBIND2,
     *                  IRET)
                     IF (IRET.EQ.0) GO TO 400
                        WRITE (MSGTXT,1145) IRET
                        GO TO 990
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Update CATBLK in core only
      CATR(KRDMX) = OUTMAX
      CATR(KRDMN) = OUTMIN
      NEWR(KRDMX) = PMAX
      NEWR(KRDMN) = PMIN
C                                       Mark blanking in CATBLK.
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
      NEWR(KRBLK) = 0.0
      IF (TBLNKD) NEWR(KRBLK) = FBLANK
C                                       Close files
      CALL ZCLOSE (LUNI1, INDI1, IRET)
      IF (ICODE.EQ.1) CALL ZCLOSE (LUNI2, INDI2, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BLNKDO: ERROR',I3,' OPENING INPUT FILE')
 1010 FORMAT ('BLNKDO: ERROR',I3,' OPENING CLIPPING FILE')
 1015 FORMAT ('BLNKDO: ERROR',I3,' OPENING AVERAGE BLANKED FILE')
 1020 FORMAT ('BLNKDO: ERROR',I5,' OPENING OUTPUT FILE')
 1050 FORMAT ('BLNKDO: COMOFF (CLIP) ERROR',I3)
 1055 FORMAT ('BLNKDO: MINIT (CLIP) ERROR',I3)
 1060 FORMAT ('BLNKDO: COMOFF (AVG OUT) ERROR',I3)
 1065 FORMAT ('BLNKDO: MINIT (AVG OUT) ERROR',I3)
 1070 FORMAT ('BEGIN PLANE',F8.0,' OF',F8.0)
 1099 FORMAT ('BLNKDO: COMOFF (INPUT) ERROR',I3)
 1100 FORMAT ('BLNKDO: MINIT (INPUT) ERROR',I3)
 1105 FORMAT ('BLNKDO: MINIT (OUTPUT) ERROR',I3)
 1120 FORMAT ('BLNKDO: READ (CLIP) ERROR',I3)
 1145 FORMAT ('BLNKDO: WRITE (AVG OUT) ERROR',I3)
 1150 FORMAT ('BLNKDO: READ (INPUT) ERROR',I3)
 1175 FORMAT ('BLNKDO: WRITE (OUTPUT) ERROR',I3)
 1210 FORMAT ('BLNKDO: DO1BLK ERROR',I3)
      END
      SUBROUTINE DO1BLK (IPOS, IND1, IND2, IINCR, OUTD1, OUTD2, IRET)
C-----------------------------------------------------------------------
C   DO1BLK applies the windowing algorithms to each row - summing and
C   blanking pixels outside the window.
C   Inputs:
C      IPOS(7)   I    BLC (input image) of first value in DATA
C      IND1(*)   R    Input image row
C      IND2(*)   R    Clip image row (ICODE = 1 or 2)
C      IINCR     I    Increment to use in clip image row (0 or 1 only!)
C   Values from commons:
C      FBLANK    R    Value of blanked pixel.
C      BCHAN, ECHAN  R     Channel (x pixel) range of good data
C      BLC, TRC (7)  R     Window corners in original image
C   Output:
C      OUTD1(*)  R    Output row : input partly blanked
C      OUTD2(1)  R    Average of those pixels blanked
C      IRET      I    Return code   0 => OK
C                               >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), IINCR, IRET
      REAL      IND1(*), IND2(*), OUTD1(*), OUTD2
      INTEGER   I, J, IDA, ID1, ID2, IW1, IW2, NBL, NBL2, ICX, IBCHAN,
     *   IECHAN, IC
      REAL      SBL, ST, ST1, ST2, TEMP, CC, CM
      LOGICAL   KEEP
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'BLANK.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       sum up edges if any
      IDA = DPARM(1) + 0.01
      NBL = 0
      NBL2 = 0
      SBL = 0.0
      IBCHAN = BCHAN - 0.99
      IECHAN = ECHAN + 1.01
      ICX = TRC(1) - BLC(1) + 1.01
      DO 10 I = 1,IBCHAN
         NBL2 = NBL2 + 1
         IF (IND1(I).ne.FBLANK) then
            NBL = NBL + 1
            SBL = SBL + IND1(I)
            END IF
 10      CONTINUE
      IBCHAN = IBCHAN + 1
      DO 20 I = IECHAN,ICX
         NBL2 = NBL2 + 1
         IF (IND1(I).NE.FBLANK) THEN
            NBL = NBL + 1
            SBL = SBL + IND1(I)
            END IF
 20      CONTINUE
      IECHAN = IECHAN - 1
C                                       Move input to output row
      IC = IECHAN - IBCHAN + 1
      CALL RCOPY (IC, IND1(IBCHAN), OUTD1)
C                                       Fixed window done
      IF (ICODE.EQ.3) GO TO 900
C                                       Clip with some image
      IF (ICODE.LE.2) THEN
C                                       1 pixel clips a row
         IF (IINCR.LE.0) THEN
            I = IPOS(2) - BLC(2) + 1.01
            ICX = TRC(2) - BLC(2) + 1.01
            ID1 = MAX (1, I-IDA)
            ID2 = MIN (ICX, I+IDA)
            IF (ID1.GT.ID2) GO TO 800
C                                       keep if outside F1-F2
            IF (DPARM(3).LE.DPARM(4)) THEN
               DO 30 J = ID1,ID2
                  IF (IND2(J).NE.FBLANK) THEN
                     IF (IND2(J).LE.DPARM(3)) GO TO 900
                     IF (IND2(J).GE.DPARM(4)) GO TO 900
                     END IF
 30               CONTINUE
C                                       keep if inside F1-F2
            ELSE
               DO 40 J = ID1,ID2
                  IF (IND2(J).NE.FBLANK) THEN
                     IF ((IND2(J).LE.DPARM(3)) .AND.
     *                  (IND2(J).GE.DPARM(4))) GO TO 900
                     END IF
 40               CONTINUE
               END IF
C                                       go flag row
            GO TO 800
C                                       Clip with row & extend
C                                       keep if all outside F1-F2
         ELSE IF (DPARM(3).LE.DPARM(4)) THEN
            DO 70 I = IBCHAN,IECHAN
               ID1 = MAX (1, I-IDA)
               ID2 = MIN (ICX, I+IDA)
               KEEP = .FALSE.
               DO 65 J = ID1,ID2
                  IF (IND2(J).NE.FBLANK) THEN
                     IF (IND2(J).LE.DPARM(3)) KEEP = .TRUE.
                     IF (IND2(J).GE.DPARM(4)) KEEP = .TRUE.
                     END IF
 65               CONTINUE
               NBL2 = NBL2 + 1
               IF ((.NOT.KEEP) .AND. (IND1(I).NE.FBLANK)) THEN
                  NBL = NBL + 1
                  SBL = SBL + IND1(I)
                  OUTD1(I-IBCHAN+1) = FBLANK
                  END IF
 70            CONTINUE
            GO TO 900
C                                       keep inside F1-F2
         ELSE
            DO 90 I = IBCHAN,IECHAN
               ID1 = MAX (1, I-IDA)
               ID2 = MIN (ICX, I+IDA)
               KEEP = .FALSE.
               DO 85 J = ID1,ID2
                  IF (IND2(J).NE.FBLANK) THEN
                     IF ((IND2(J).LE.DPARM(3)) .AND.
     *                  (IND2(J).GE.DPARM(4))) KEEP = .TRUE.
                     END IF
 85               CONTINUE
               NBL2 = NBL2 + 1
               IF ((.NOT.KEEP) .AND. (IND1(I).NE.FBLANK)) THEN
                  NBL = NBL + 1
                  SBL = SBL + IND1(I)
                  OUTD1(I-IBCHAN+1) = FBLANK
                  END IF
 90            CONTINUE
            GO TO 900
            END IF
         END IF
C                                       Floating windows
C                                       find peak
      IF (DPARM(2).GT.0.0) THEN
         CC = 0.0
         CM = DPARM(3)
         DO 105 I = IBCHAN,IECHAN
            IF ((IND1(I).NE.FBLANK) .AND. (IND1(I).GE.CM)) THEN
               CC = I
               CM = IND1(I)
               END IF
 105        CONTINUE
         IF (CC.LE.0.0) GO TO 800
         END IF
C                                       Find moments
      IF ((ICODE.EQ.5) .OR. (DPARM(2).LE.0.0)) THEN
         IDA = 0
         ST = 0.0
         ST1 = 0.0
         ST2 = 0.0
         DO 115 I = IBCHAN,IECHAN
            TEMP = IND1(I)
            IF ((TEMP.NE.FBLANK) .AND. (TEMP.GE.DPARM(3))) THEN
               IDA = IDA + 1
               ST = ST + TEMP
               TEMP = TEMP * I
               ST1 = ST1 + TEMP
               ST2 = ST2 + TEMP * I
               END IF
 115        CONTINUE
         IF ((IDA.LE.1) .OR. (ST.EQ.0.0)) GO TO 800
         ST1 = ST1 / ST
         ST2 = ST2 / ST - ST1 * ST1
         IF ((ST2.LT.1.0) .AND. (ICODE.EQ.5)) GO TO 800
         ST2 = SQRT (ABS (ST2))
         IF (DPARM(2).LE.0.0) CC = ST1
         END IF
C                                       Set-width windows
      IF (ICODE.NE.6) THEN
         ST = DPARM(1)
         IF (ICODE.EQ.5) ST = ST * ST2
         IW1 = CC - ST/2.0 + 0.9999
         IW2 = CC + ST/2.0 - 0.0001
C                                       Flux-fixed windows
      ELSE
         IC = CC
         IW1 = 0
         DO 130 I = IBCHAN,IC
            J = IC - I + IBCHAN
            IF ((IND1(J).NE.FBLANK) .AND. (IND1(J).LT.DPARM(3))) THEN
               IW1 = J + 1 - DPARM(1)
               GO TO 135
               END IF
 130        CONTINUE
 135     IW2 = IECHAN + 1
         DO 140 I = IC,IECHAN
            IF ((IND1(I).NE.FBLANK) .AND. (IND1(I).LE.DPARM(3))) THEN
               IW2 = I - 1 + DPARM(1)
               GO TO 150
               END IF
 140        CONTINUE
         END IF
C                                       Blank outside windows
 150  IF (IW1.GT.IBCHAN) THEN
         IW1 = IW1 - 1
         DO 155 I = IBCHAN,IW1
            NBL2 = NBL2 + 1
            IF (IND1(I).NE.FBLANK) THEN
               NBL = NBL + 1
               SBL = SBL + IND1(I)
               OUTD1(I-IBCHAN+1) = FBLANK
               END IF
 155        CONTINUE
         END IF
      IF (IW2.LT.IECHAN) THEN
         IW2 = IW2 + 1
         DO 165 I = IW2,IECHAN
            NBL2 = NBL2 + 1
            IF (IND1(I).NE.FBLANK) THEN
               NBL = NBL + 1
               SBL = SBL + IND1(I)
               OUTD1(I-IBCHAN+1) = FBLANK
               END IF
 165        CONTINUE
         END IF
      GO TO 900
C                                       Blank entire row
 800  DO 810 I = 1,IC
         NBL2 = NBL2 + 1
         IF (OUTD1(I).NE.FBLANK) THEN
            NBL = NBL + 1
            SBL = SBL + OUTD1(I)
            OUTD1(I) = FBLANK
            END IF
 810     CONTINUE
C                                       Output the average too
 900  OUTD2 = 0.0
      IF ((NBL2.GT.0) .AND. (DPARM(5).LE.0.0)) OUTD2 = FBLANK
      IF (NBL.GT.0) OUTD2 = SBL / NBL
C                                       substitute DPARM(6)
      IF (DPARM(5).GT.0.0) THEN
         IC = IECHAN - IBCHAN + 1
         DO 910 I = 1,IC
            IF (OUTD1(I).EQ.FBLANK) OUTD1(I) = DPARM(6)
 910        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE DOPBLK (IPOS, IND1, OUTD1, IRET)
C-----------------------------------------------------------------------
C   DOPBLK blanks the data based on the radius of the pixel from the
C   reference pixel in arc seconds.
C   Inputs:
C      IPOS(7)   I    BLC (input image) of first value in DATA
C      IND1(*)   R    Input image row
C   Output:
C      OUTD1(*)  R    Output row : input partly blanked
C      IRET      I    Return code   0 => OK
C                               >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), IRET
      REAL      IND1(*), OUTD1(*)
C
      INTEGER   LPOS3, CATMP(256), I, IX, IY, IERR
      REAL      DX, DY
      DOUBLE PRECISION SKYPOS(3), RA1, DEC1, DD, RA0, DEC0
      INCLUDE 'BLANK.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      SAVE LPOS3, IX, IY, RA0, DEC0
      DATA LPOS3 /1000000/
C-----------------------------------------------------------------------
      IRET = 0
C                                       init coordinates
      IF (IPOS(3).LT.LPOS3) THEN
         LPOS3 = IPOS(3)
         LOCNUM = 1
         CALL COPY (256, CATBLK, CATMP)
         CALL COPY (256, CATOLD, CATBLK)
         CALL SETLOC (IPOS(3), .FALSE.)
         CALL COPY (256, CATMP, CATBLK)
C                                       coord type
         IX = MOD (CORTYP(LOCNUM)-1, 2) + 1
         IF (CORTYP(LOCNUM).GT.3) IX = IX + 1
         IY = 3 - IX
         IY = IY + (CORTYP(LOCNUM)-1) / 2
C                                       ref pixel
         CALL XYVAL (OLDR(KRCRP), OLDR(KRCRP+1), SKYPOS(1), SKYPOS(2),
     *      SKYPOS(3), IERR)
         RA0 = SKYPOS(IX) * DG2RAD
         DEC0 = SKYPOS(IY) * DG2RAD
C                                       default radius
         IF (DPARM(1).LE.0.0) THEN
            DX = CATBLK(KINAX) - CATR(KRCRP)
            DY = CATR(KRCRP) - 1
            DX = MAX (DX, DY)
            DPARM(1) = ABS (DX * CATR(KRCIC)) * 3600.0
            END IF
         END IF
      DY = IPOS(2)
      DO 100 I = 1,CATBLK(KINAX)
         OUTD1(I) = IND1(I)
         DX = IPOS(1) + I - 1
         CALL XYVAL (DX, DY, SKYPOS(1), SKYPOS(2), SKYPOS(3), IERR)
         IF (IERR.NE.0) THEN
            OUTD1(I) = FBLANK
         ELSE
            RA1 = SKYPOS(IX) * DG2RAD
            DEC1 = SKYPOS(IY) * DG2RAD
            DD = SIN(DEC1) * SIN(DEC0) + COS(DEC1) * COS(DEC0) *
     *         COS(RA1-RA0)
            DD = MAX (-1.0D0, MIN (1.0D0, DD))
            DD = ACOS (DD) * RAD2AS
            IF (DD.GT.DPARM(1)) OUTD1(I) = FBLANK
            END IF
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE BLNKTV (IRET)
C-----------------------------------------------------------------------
C   BLNKTV sends image one row at a time to the blanking routine and
C   then writes the modified data.  For the TV opcode only.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      CHARACTER    OFF*4, ON*4, IFILE*48
      INTEGER   IRET, NYI, NXI, WINI(4), NXO, NYO, WINO(4), BOI, I, J,
     *   BOO, LIM2, LIM3, LIM4, LIM5, LIM6, LIM7, I1, I2, K, I3, I4, I5,
     *   I6, I7, IPOS(7), BOTEMP, KOFF, NPOLY, IG, LZOOM(3), LIMO, IERR,
     *   LIMIT, IBIND1, OBIND1, OBIND2, LIM1, NVERT(40), NF, NXF, ICHAN,
     *   WINO2(4), NYF, NXT, NYT, CORNOU(8), LINC(2), WINT(4,64),
     *   WINX(4), IROUND, TVPLAN, XV(400), YV(400), ZOR, ITEMP
      REAL      PLTODO, PLDONE, XP, YP, OUTMAX, OUTMIN, PMAX, PMIN
      LOGICAL   T, F, BLNKD, TBLNKD
      INCLUDE 'BLANK.INC'
      INTEGER   BUFF1(MABFSS)
      EQUIVALENCE (XBUFF1, BUFF1)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      DATA OFF, ON /'OFFF', 'ONNN'/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open TV
      CALL TVOPEN (BUFF1, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Open terminal
      CALL ZOPEN (TTYLUN, TTYIND, 1, MSGTXT, F, T, T, IRET)
      IF (IRET.NE.0) THEN
         TTYIND = 0
         WRITE (MSGTXT,1000) IRET
         GO TO 980
         END IF
C                                       move CATBLK to CATCLP to save
C                                       get CATOLD into /MAPHDR/
      CALL COPY (256, CATBLK, CATCLP)
      CALL COPY (256, CATOLD, CATBLK)
C                                       Open and init for read
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI1, INDI1, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 980
         END IF
C                                       output blanked
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO1, INDO1, DISKO, IFILE, T, T, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1015) IRET
         GO TO 980
         END IF
C                                       For residual map:
      IF (DOCAT.GT.0.) THEN
         CALL ZPHFIL ('MA', FVOL(4), FCNO(4), 1, IFILE, IRET)
         CALL ZOPEN (LUNO2, INDO2, FVOL(4), IFILE, T, T, T, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1020) IRET
            GO TO 980
            END IF
         END IF
C                                       Setup for I/O
C                                       remember names switched
      NXI = CATOLD(KINAX)
      NYI = CATOLD(KINAX+1)
      NXO = CATCLP(KINAX)
      NYO = CATCLP(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      WINO2(1) = 1
      WINO2(2) = 1
      WINO2(3) = CATNEW(KINAX)
      WINO2(4) = CATNEW(KINAX+1)
C                                       TV windows
      LINC(1) = TXINC + 0.01
      LINC(2) = TYINC + 0.01
      NXT = (ECHAN - BCHAN) / TXINC + 1.0001
      NYT = (TRC(2) - BLC(2)) / TYINC + 1.0001
      NXF = (NXT - 1) / MAXXTV(1) + 1
      NYF = (NYT - 1) / MAXXTV(2) + 1
      NF = NXF * NYF
      XP = 0.0
      IF (NXF.GT.1) XP = ((NXT-1)*TXINC + 1 - TXINC*MAXXTV(1)) /
     *   (NXF - 1.0)
      YP = 0.0
      IF (NYF.GT.1) YP = ((NYT-1)*TYINC + 1 - TYINC*MAXXTV(2)) /
     *   (NYF - 1.0)
      K = 0
      DO 35 I = 1,NYF
         DO 30 J = 1,NXF
            K = K + 1
            WINT(1,K) = BLC(1) + BCHAN - 0.99 + XP * (J-1)
            WINT(2,K) = BLC(2) + YP * (I-1) + 0.01
            IF (NXF.GT.1) WINT(3,K) = WINT(1,K) + MAXXTV(1)*LINC(1) - 1
            IF (NXF.EQ.1) WINT(3,K) = WINT(1,K) + ECHAN - BCHAN + 0.01
            IF (NYF.GT.1) WINT(4,K) = WINT(2,K) + MAXXTV(2)*LINC(2) - 1
            IF (NYF.EQ.1) WINT(4,K) = TRC(2) + 0.01
 30         CONTINUE
 35      CONTINUE
      WINX(1) = (MAXXTV(1) - (WINT(3,1)-WINT(1,1)) / LINC(1) + 1) / 2
      WINX(2) = (MAXXTV(2) - (WINT(4,1)-WINT(2,1)) / LINC(2) + 1) / 2
      WINX(3) = WINX(1) + (WINT(3,1) - WINT(1,1)) / LINC(1)
      WINX(4) = WINX(2) + (WINT(4,1) - WINT(2,1)) / LINC(2)
C                                       other TV parms
      ICHAN = TVCHAN + 0.01
      IF ((ICHAN.LT.1) .OR. (ICHAN.GT.NGRAY)) ICHAN = 1
      TVPLAN = 2 ** (ICHAN-1)
      IG = MIN (3, NGRAPH)
      CALL RNGSET (RANGE, OLDR(KRDMX), OLDR(KRDMN), CATR(IRRAN))
      CALL CHR2H (2, TVFUNC(1:2), 1, CATH(IITRA))
      CATBLK(IICNO) = FCNO(1)
      CATBLK(IIVOL) = FVOL(1)
C                                       Init the TV
      I = IG + NGRAY
      CALL MOVIST (OFF, TVPLAN, 0, 0, 0, IERR)
      CALL YCINIT (ICHAN, BUFF1)
      CALL YCINIT (I, BUFF1)
      CALL YZERO (ICHAN, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL YZERO (I, IERR)
      IF (IERR.NE.0) GO TO 900
      J = NGRAY + NGRAPH
      DO 40 K = 1,J
         CALL YSLECT (OFF, K, 0, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 900
 40      CONTINUE
      CALL YSLECT (ON, I, 0, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL YSLECT (ON, ICHAN, 0, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 900
      ITEMP = 2 ** NGRAY
      I = ZOR (ITEMP, TVPLAN)
      CALL YSCROL (I, 0, 0, F, IERR)
      IF (IERR.NE.0) GO TO 900
      TVZOOM(1) = 0
      TVZOOM(2) = MAXXTV(1) / 2
      TVZOOM(3) = MAXXTV(2) / 2
      CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), F, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL COPY (3, TVZOOM, LZOOM)
C                                       Other IO initializations
      OUTMAX = -1.0E20
      OUTMIN = -OUTMAX
      PMAX = OUTMAX
      PMIN = OUTMIN
      BLNKD = F
      TBLNKD = .FALSE.
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
      PLDONE = 0.0
      PLTODO = REAL(LIM7) * REAL(LIM4) * REAL(LIM5) * REAL(LIM6)
      PLTODO = PLTODO * CATCLP(KINAX+2)
      KOFF = 0
      LIMO = CATCLP(KINAX) - 1
      CORNOU(8) = 1
C                                       Loop
      DO 700 I7 = 1,LIM7
         CORNOU(7) = I7
         IPOS(7) = BLC(7) + I7 - 0.9
         DO 600 I6 = 1,LIM6
            CORNOU(6) = I6
            IPOS(6) = BLC(6) + I6 - 0.9
            DO 500 I5 = 1,LIM5
               CORNOU(5) = I5
               IPOS(5) = BLC(5) + I5 - 0.9
               DO 400 I4 = 1,LIM4
                  CORNOU(4) = I4
                  IPOS(4) = BLC(4) + I4 - 0.9
C                                       Init. file: output average
                  IF (DOCAT.GT.0.0) THEN
                     CALL COMOFF (CATNEW(KIDIM), CATNEW(KINAX),
     *                  CORNOU(4), BOTEMP, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1060) IRET
                        GO TO 980
                        END IF
                     BOI = BOTEMP + 1
                     CALL MINIT ('WRIT', LUNO2, INDO2, WINO2(3),
     *                  WINO2(4), WINO2, XBUFF3, JBUFSZ, BOI, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1065) IRET
                        GO TO 980
                        END IF
                     END IF
                  DO 300 I3 = 1,LIM3
                     CORNOU(3) = I3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     PLDONE = PLDONE + 1
                     WRITE (MSGTXT,1070) PLDONE, PLTODO
                     CALL MSGWRT (1)
C                                       Find polygons
         NPOLY = 0
         CALL FILL (40, 0, NVERT)
         CALL COPY (5, IPOS(3), CATBLK(IIDEP))
         DO 80 K = 1,NF
            WRITE (MSGTXT,1071) WINT(1,K), WINT(3,K), WINT(2,K),
     *         WINT(4,K)
            IF (NF.GT.1) CALL MSGWRT (1)
            CALL TVLOAD (LUNI1, INDI1, ICHAN, LINC, WINX, WINT(1,K),
     *         JBUFSZ, XBUFF1, IRET)
            IF (IRET.EQ.0) GO TO 75
               WRITE (MSGTXT,1070) IRET
               GO TO 980
 75         CALL BLKTVF (IG, TVPLAN, LINC, TTYLUN, TTYIND, LZOOM, NPOLY,
     *         NVERT, XV, YV, IBUFF1, IRET)
            IF (IRET.NE.0) GO TO 990
 80         CONTINUE
C                                       Init. files, first input.
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET
            GO TO 980
            END IF
         BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI1, INDI1, NXI, NYI, WINI, XBUFF1,
     *      JBUFSZ, BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 980
            END IF
C                                       Init blanked file.
         CALL COMOFF (CATCLP(KIDIM), CATCLP(KINAX), CORNOU(3), BOTEMP,
     *      IRET)
         BOO = BOTEMP + 1
         CALL MINIT ('WRIT', LUNO1, INDO1, NXO, NYO, WINO, XBUFF2,
     *      JBUFSZ, BOO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1105) IRET
            GO TO 980
            END IF
C                                       "write" output avg
         OBIND2 = 1
         IF (DOCAT.GT.0.0) THEN
            CALL MDISK ('WRIT', LUNO2, INDO2, XBUFF3, OBIND2, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1145) IRET
               GO TO 980
               END IF
            END IF
         DO 250 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
C                                       Read.
            CALL MDISK ('READ', LUNI1, INDI1, XBUFF1, IBIND1, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1150) IRET
               GO TO 980
               END IF
            DO 170 I1 = 1,LIM1
               XBUFF4(I1) = XBUFF1(IBIND1+I1-1)
 170           CONTINUE
C                                       Write.
            CALL MDISK ('WRIT', LUNO1, INDO1, XBUFF2, OBIND1, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1175) IRET
               GO TO 980
               END IF
C                                       Call DO1TVB
            CALL DO1TVB (IPOS, NPOLY, NVERT, XV, YV, XBUFF4,
     *         XBUFF2(OBIND1), XBUFF3(OBIND2), IRET)
            IF (DOCAT.GT.0.0) OBIND2 = OBIND2 + 1
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1210) IRET
               GO TO 980
               END IF
C                                       Check max, min, blanking.
            LIMIT = OBIND1 + LIMO
            DO 220 I1 = OBIND1,LIMIT
               BLNKD = BLNKD .OR. (XBUFF2(I1).EQ.FBLANK)
               IF (XBUFF2(I1).NE.FBLANK) THEN
                  OUTMAX = MAX (OUTMAX, XBUFF2(I1))
                  OUTMIN = MIN (OUTMIN, XBUFF2(I1))
                  END IF
 220           CONTINUE
            IF (DOCAT.GT.0.0) THEN
               I1 = OBIND2 - 1
               TBLNKD = (TBLNKD) .OR. (XBUFF3(I1).EQ.FBLANK)
               IF (XBUFF3(I1).NE.FBLANK) THEN
                  PMAX = MAX (PMAX, XBUFF3(I1))
                  PMIN = MIN (PMIN, XBUFF3(I1))
                  END IF
               END IF
 250        CONTINUE
C                                       Flush buffers for blanked
         CALL MDISK ('FINI', LUNO1, INDO1, XBUFF2, OBIND1, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1175) IRET
            GO TO 980
            END IF
 300     CONTINUE
C                                       Flush buffers for avg.
                  IF (DOCAT.GT.0.0) THEN
                     CALL MDISK ('FINI', LUNO2, INDO2, XBUFF3, OBIND2,
     *                  IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1145) IRET
                        GO TO 980
                        END IF
                     END IF
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       restore CATBLK
      CALL COPY (256, CATCLP, CATBLK)
C                                       Update CATBLK in core only
      CATR(KRDMX) = OUTMAX
      CATR(KRDMN) = OUTMIN
      NEWR(KRDMX) = PMAX
      NEWR(KRDMN) = PMIN
C                                       Mark blanking in CATBLK.
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
      NEWR(KRBLK) = 0.0
      IF (TBLNKD) NEWR(KRBLK) = FBLANK
C                                       Close files
      CALL ZCLOSE (LUNI1, INDI1, IRET)
      IRET = 0
      GO TO 990
C                                       TV error
 900  IRET = 8
      WRITE (MSGTXT,1900) IERR
C                                       Error
 980  CALL MSGWRT (8)
C                                       close downs
 990  IF (TTYIND.GT.0) CALL ZCLOSE (TTYLUN, TTYIND, IERR)
      CALL TVCLOS (BUFF1, IERR)
C                                       resume AIPS on error
 995  IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BLNKTV: ERROR',I3,' OPENING USER TERMINAL')
 1010 FORMAT ('BLNKTV: ERROR',I3,' OPENING INPUT FILE')
 1015 FORMAT ('BLNKTV: ERROR',I3,' OPENING AVERAGE BLANKED FILE')
 1020 FORMAT ('BLNKTV: ERROR',I5,' OPENING OUTPUT FILE')
 1060 FORMAT ('BLNKTV: COMOFF (AVG OUT) ERROR',I3)
 1065 FORMAT ('BLNKTV: MINIT (AVG OUT) ERROR',I3)
 1070 FORMAT ('BEGIN PLANE',F8.0,' OF',F8.0)
 1071 FORMAT ('BEGIN SUBIMAGE XPIX =',I5,' -',I5,'  YPIX =',I5,' -',I5)
 1080 FORMAT ('BLNKTV: COMOFF (INPUT) ERROR',I3)
 1100 FORMAT ('BLNKTV: MINIT (INPUT) ERROR',I3)
 1105 FORMAT ('BLNKTV: MINIT (OUTPUT) ERROR',I3)
 1145 FORMAT ('BLNKBX: WRITE (AVG OUT) ERROR',I3)
 1150 FORMAT ('BLNKTV: READ (INPUT) ERROR',I3)
 1175 FORMAT ('BLNKTV: WRITE (OUTPUT) ERROR',I3)
 1210 FORMAT ('BLNKTV: DO1BLK ERROR',I3)
 1900 FORMAT ('BLNKTV: TV ERROR CODE',I7)
      END
      SUBROUTINE BLKTVF (IGR, ICHAN, LINC, TTYLUN, TTYIND, LZOOM, NPY,
     *   NV, XV, YV, SCRTCH, IRET)
C-----------------------------------------------------------------------
C   BLKTVF does the finding of the desired polygons
C   Inputs: IGR     I          Graphics plane to use: 1 - NGRAPH
C           ICHAN   I          Image plane (bit mask)
C           LINC    I(2)       TV load pixel increments (x,y)
C           TTYLUN  I          LUN of terminal opened for user comm.
C           TTYIND  I          FTAB pointer. for terminal
C   In/out: LZOOM   I(3)       Previous zoom parameters
C           NPY     I          Number of polygons
C           NV      I(30)      Number of vertices in each polygon
C           XV      I(400)     X pixel position of each vertex wrt the
C                              original image
C           YV      I(400)     Y pixel pos of vertices wrt input image
C   Output: SCRTCH  I(>520)    scrtach buffer
C           IRET    I          error code 0 ok, 1 TV, 2 TTY, 99 user
C-----------------------------------------------------------------------
      CHARACTER TEMP*4, ON*4, OFF*4, REDO*4, QUIT*4, LINE*80
      INTEGER   IGR, ICHAN, LINC(2), TTYLUN, TTYIND, LZOOM(3), NPY,
     *   NV(30), XV(400), YV(400), SCRTCH(*), IRET
      INTEGER   IB, IE, IE0, NPY0, I, J, CATBLK(256), IERR, JERR, IBO,
     *   ITW(3), QUAD, IBUT, ICH, LB, LE, IX(3), IY(3)
      REAL      PPOS(2), RPOS(2), DLIM
      LOGICAL   T, F, DOIT
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMMON /MAPHDR/ CATBLK
      DATA T, F /.TRUE.,.FALSE./
      DATA ON, OFF, REDO, QUIT /'ONNN','OFFF','REDO','QUIT'/
C-----------------------------------------------------------------------
      IRET = 1
      IE0 = 0
      NPY0 = NPY + 1
      IE = 0
C                                       Correct old ones to this subimg
      IF (NPY.LE.0) GO TO 15
         DO 10 I = 1,NPY
            IB = IE + 1
            IE = IB + NV(I) - 1
            DO 9 J = IB,IE
               XV(J) = (XV(J)-CATBLK(IIWIN)) / LINC(1) + CATBLK(IICOR)
               YV(J) = (YV(J)-CATBLK(IIWIN+1)) / LINC(2) +
     *            CATBLK(IICOR+1)
 9             CONTINUE
 10         CONTINUE
         IE0 = IE
C                                       clear graphics
 15   ICH = IGR + NGRAY
      CALL YZERO (ICH, IERR)
      IF (IERR.NE.0) GO TO 900
      NPY = NPY0 - 1
      IE = IE0
C                                       interactive zoom, enhance
      CALL YWINDO ('READ', WINDTV, IERR)
      IF (IERR.NE.0) GO TO 900
      I = LUTOUT + 1
      CALL COPY (3, LZOOM, TVZOOM)
      CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), F, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL TVFIDL (ICHAN, I, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL COPY (3, TVZOOM, LZOOM)
C                                       fill current polygons
      IF (NPY.GT.0) CALL BLTFIL (NPY, NV, XV, YV, IGR, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL ZTIME (ITW)
C                                       Start new polygon
 40   IF (NPY.GE.30) GO TO 800
      NPY = NPY + 1
      IB = IE + 1
      IE = IB
      NV(NPY) = 0
      WRITE (MSGTXT,1040) NPY
      CALL MSGWRT (1)
      WRITE (MSGTXT,1041)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1042)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1043)
      CALL MSGWRT (1)
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
      RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2
C                                       No scroll correction
      QUAD = -1
C                                       ON cursor at desired position
      CALL YCURSE (ON, F, T, RPOS, QUAD, IBUT, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 900
      IF (IERR.EQ.2) CALL YCURSE (ON, F, F, RPOS, QUAD, IBUT, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Cursor read loop
 50   CALL YCURSE ('READ', T, T, RPOS, QUAD, IBUT, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF (.NOT.DOIT) GO TO 50
C                                       No button -> no action
         IF (IBUT.EQ.0) GO TO 50
C                                       Time to quit marking
         IF ((IBUT.LT.4) .OR. (IB.LT.IE)) GO TO 60
            NPY = NPY - 1
            GO TO 200
C                                       Mark new vertex
 60      NV(NPY) = NV(NPY) + 1
         XV(IE) = RPOS(1) + 0.01
         YV(IE) = RPOS(2) + 0.01
         IF (IB.EQ.IE) XV(IE+1) = XV(IE)
         IF (IB.EQ.IE) YV(IE+1) = YV(IE)
         I = MAX (IB, IE-1)
         IE = IE + 1
C                                       draw line
         CALL IMVECT (ON, ICH, 2, XV(I), YV(I), SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       done with polygon
         IF ((IBUT.LT.2) .AND. (IE.LT.400)) GO TO 50
            NV(NPY) = NV(NPY) + 1
            XV(IE) = XV(IB)
            YV(IE) = YV(IB)
C                                       draw line
            CALL IMVECT (ON, ICH, 2, XV(IE-1), YV(IE-1), SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
C                                       Respond further to buttons
         IF (IE.GE.400) GO TO 810
         IF (IBUT.LT.4) GO TO 40
C                                       Vertex correction area
         IF (IBUT.GE.8) GO TO 200
C                                       some already set box
C                                       wait for indication which
 100  WRITE (MSGTXT,1100)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1101)
      CALL MSGWRT (1)
      WRITE (MSGTXT,1102)
      CALL MSGWRT (1)
      CALL YCURSE ('READ', T, T, RPOS, QUAD, IBUT, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       check button
      IF (IBUT.GE.8) GO TO 200
C                                       redraw polygons to be safe
 105  IF (IBUT.LT.4) GO TO 120
         LB = 1 + IE0
         DO 110 I = NPY0,NPY
            CALL IMVECT (ON, ICH, NV(I), XV(LB), YV(LB), SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 900
            LB = LB + NV(I)
 110        CONTINUE
         GO TO 40
C                                       Find nearest corner
 120  DLIM = 0.5
 125  LB = 1 + IE0
      DO 135 I = NPY0,NPY
         LE = LB + NV(I) - 1
         DO 130 J = LB,LE
            IF ((ABS(RPOS(1)-XV(J)).LE.DLIM) .AND. (ABS(RPOS(2)
     *         -YV(J)).LE.DLIM)) GO TO 140
 130        CONTINUE
         LB = LE + 1
 135     CONTINUE
      DLIM = DLIM + 1.5
      IF (DLIM.LE.4.0) GO TO 125
      GO TO 100
C                                       Got one
 140  IF (J.EQ.LE) J = LB
      IBO = J
      RPOS(1) = XV(IBO)
      RPOS(2) = YV(IBO)
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      IX(2) = XV(IBO)
      IX(1) = XV(IBO-1)
      IX(3) = XV(IBO+1)
      IF (IBO.EQ.LB) IX(1) = XV(LE-1)
      IY(2) = YV(IBO)
      IY(1) = YV(IBO-1)
      IY(3) = YV(IBO+1)
      IF (IBO.EQ.LB) IY(1) = YV(LE-1)
C                                       Cursor read loop
 150  CALL YCURSE ('READ', F, T, RPOS, QUAD, IBUT, IERR)
         IF (IERR.NE.0) GO TO 900
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF (.NOT.DOIT) GO TO 150
C                                       draw new lines
         CALL IMVECT (OFF, ICH, 3, IX, IY, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
         IX(2) = RPOS(1) + 0.5
         IY(2) = RPOS(2) + 0.5
         CALL IMVECT (ON, ICH, 3, IX, IY, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       mark this one
         IF (IBUT.EQ.0) GO TO 150
            XV(IBO) = IX(2)
            YV(IBO) = IY(2)
            IF (IBUT.LT.4) GO TO 100
            IF (IBUT.LT.8) GO TO 105
C                                       DONE: off zoom
 200  TVZOOM(1) = 0
      TVZOOM(2) = MAXXTV(1) / 2
      TVZOOM(3) = MAXXTV(2) / 2
      CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), F, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       fill current polygons
      IF (NPY.GT.0) CALL BLTFIL (NPY, NV, XV, YV, IGR, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       talk to user
      IRET = 2
      WRITE (LINE,1200)
      CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, LINE, IERR)
      IF (IERR.NE.0) GO TO 900
      CALL ZTTYIO ('READ', TTYLUN, TTYIND, 72, LINE, IERR)
      IF (IERR.NE.0) GO TO 900
      READ (LINE,1201) TEMP
      CALL CHLTOU (4, TEMP)
      IRET = 1
      IF (TEMP.EQ.REDO) GO TO 15
      IRET = 0
      IF (TEMP.EQ.QUIT) IRET = 99
C                                       Correct to image pixels
      IF (NPY.LE.0) GO TO 900
         IE = 0
         DO 210 I = 1,NPY
            IB = IE + 1
            IE = IB + NV(I) - 1
            DO 209 J = IB,IE
               XV(J) = (XV(J)-CATBLK(IICOR)) * LINC(1) + CATBLK(IIWIN)
               YV(J) = (YV(J)-CATBLK(IICOR+1)) * LINC(2) +
     *            CATBLK(IIWIN+1)
 209           CONTINUE
 210        CONTINUE
         GO TO 900
C                                       Overflow problems
 800  WRITE (MSGTXT,1800)
      CALL MSGWRT (7)
      GO TO 900
 810  WRITE (MSGTXT,1810)
      CALL MSGWRT (7)
      GO TO 200
C                                       close down
 900  CALL YCURSE (OFF, F, T, RPOS, QUAD, IBUT, JERR)
      IF (IRET.EQ.0) GO TO 999
         IF (IRET.EQ.1) WRITE (MSGTXT,1900) IERR
         IF (IRET.EQ.2) WRITE (MSGTXT,1901) IERR
         IF (IRET.EQ.99) WRITE (MSGTXT,1902)
         CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1040 FORMAT ('Begin setting region number',I3)
 1041 FORMAT ('Press button A to set intermediate vertex')
 1042 FORMAT ('Press buttons B, C, or D to set final vertex')
 1043 FORMAT ('C => then reset a vertex,  D => then exit')
 1100 FORMAT ('*************  move cursor to vertex to be reset')
 1101 FORMAT ('Then push button A or B to do resetting -- or')
 1102 FORMAT ('Push C to go to next region  or D to exit')
 1200 FORMAT ('Type REDO to do this image over, QUIT to stop,',
     *   ' hit return to go on')
 1201 FORMAT (A4)
 1800 FORMAT ('REACHED LIMIT OF 30 POLYGONS')
 1810 FORMAT ('REACHED LIMIT OF 400 VERTICES')
 1900 FORMAT ('TV ROUTINE RETURNS ERROR CODE',I7)
 1901 FORMAT ('TERMINAL IO ERROR CODE',I7)
 1902 FORMAT ('Terminating AT USER''S REQUEST')
      END
      SUBROUTINE DO1TVB (IPOS, NPOLY, NVERT, XV, YV, IND1, OUTD1, OUTD2,
     *   IRET)
C-----------------------------------------------------------------------
C   DO1TVB applies the polygon blanking to each row - summing and
C   blanking pixels outside the windows.
C   Inputs:
C      IPOS(7)   I    BLC (input image) of first value in DATA
C      NPOLY     I    Number of polygons
C      NVERT(*)  I    Number of vertices in each polygon
C      XV(*)     I    X pixel coords of vertices (wrt original input)
C      YV(*)     I    Y pixel coords of vertices (wrt original input)
C      IND1(*)   R    Input image row
C   Values from commons:
C      FBLANK    R    Value of blanked pixel.
C      BCHAN, ECHAN  R     Channel (x pixel) range of good data
C      BLC, TRC (7)  R     Window corners in original image
C   Output:
C      OUTD1(*)  R    Output row : input partly blanked
C      OUTD2(1)  R    Average of those pixels blanked
C      IRET      I    Return code   0 => OK
C                               >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), NPOLY, NVERT(*), XV(*), YV(*), IRET
      REAL      IND1(*), OUTD1(*), OUTD2
      INTEGER   I, J, NBL, NBL2, ICX, IBCHAN, IECHAN, IC, IX, LP,
     *   IXL(40), IXU(40), LNX
      REAL      SBL
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'BLANK.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       sum up edges if any
      NBL = 0
      NBL2 = 0
      SBL = 0.0
      IBCHAN = BCHAN - 0.99
      IECHAN = ECHAN + 1.01
      ICX = TRC(1) - BLC(1) + 1.01
      IF (IBCHAN.GE.1) THEN
         DO 10 I = 1,IBCHAN
            NBL2 = NBL2 + 1
            IF (IND1(I).NE.FBLANK) THEN
               NBL = NBL + 1
               SBL = SBL + IND1(I)
               END IF
 10         CONTINUE
         END IF
      IBCHAN = IBCHAN + 1
      IF (IECHAN.LE.ICX) THEN
         DO 20 I = IECHAN,ICX
            NBL2 = NBL2 + 1
            IF (IND1(I).NE.FBLANK) THEN
               NBL = NBL + 1
               SBL = SBL + IND1(I)
               END IF
 20         CONTINUE
         END IF
      IECHAN = IECHAN - 1
C                                       Move input to output row
      IC = IECHAN - IBCHAN + 1
      CALL RCOPY (IC, IND1(IBCHAN), OUTD1)
C                                       Init polygon search
      LNX = 0
      IF (NPOLY.GT.0) CALL BLTLIS (1, 1, NPOLY, NVERT, XV, YV,
     *      IPOS(2), LNX, IXL, IXU)
C                                       blank inside blotch regions
      IF (DOINVR.LE.0.0) GO TO 70
         IF (LNX.LE.0) GO TO 900
            LP = BLC(1) + BCHAN - 1.99
            DO 40 J = 1,IC
               IX = J + LP
               DO 30 I = 1,LNX
                  IF ((IX.GE.IXL(I)) .AND. (IX.LE.IXU(I))) GO TO 35
 30               CONTINUE
               GO TO 40
C                                       blank the 1 pixel inside
 35            NBL2 = NBL2 + 1
               IF (OUTD1(J).EQ.FBLANK) GO TO 40
                  NBL = NBL + 1
                  SBL = SBL + OUTD1(J)
                  OUTD1(J) = FBLANK
 40            CONTINUE
            GO TO 900
C                                       blank outside blotch regions
 70   CONTINUE
         IF (LNX.LE.0) GO TO 85
            LP = BLC(1) + BCHAN - 1.99
            DO 80 J = 1,IC
               IX = J + LP
               DO 75 I = 1,LNX
                  IF ((IX.GE.IXL(I)) .AND. (IX.LE.IXU(I))) GO TO 80
 75               CONTINUE
C                                       blank the 1 pixel (outside)
               NBL2 = NBL2 + 1
               IF (OUTD1(J).EQ.FBLANK) GO TO 80
                  NBL = NBL + 1
                  SBL = SBL + OUTD1(J)
                  OUTD1(J) = FBLANK
 80            CONTINUE
            GO TO 900
C                                       Blank whole row
 85      CONTINUE
            DO 90 J = 1,IC
               NBL2 = NBL2 + 1
               IF (OUTD1(J).EQ.FBLANK) GO TO 90
                  NBL = NBL + 1
                  SBL = SBL + OUTD1(J)
                  OUTD1(J) = FBLANK
 90            CONTINUE
C                                       Output the average too
 900  OUTD2 = 0.0
      IF ((NBL2.GT.0) .AND. (DPARM(5).LE.0.0)) OUTD2 = FBLANK
      IF (NBL.GT.0) OUTD2 = SBL / NBL
C                                       substitute DPARM(6)
      IF (DPARM(5).LE.0.0) GO TO 999
         DO 910 I = 1,IC
            IF (OUTD1(I).EQ.FBLANK) OUTD1(I) = DPARM(6)
 910        CONTINUE
C
 999  RETURN
      END
      SUBROUTINE BLNKBX (IRET)
C-----------------------------------------------------------------------
C   BLNKBX sends image one row at a time to the blanking routine and
C   then writes the modified data.
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER IFILE*48
      LOGICAL   TBLNKD
      LONGINT   PIMAGE
      INTEGER   IRET, IROUND, IBIND1, OBIND1, NYI, NXI, I, NIX, NIY,
     *   WINI(4), NXO, NYO, WINO(4), BOI, BOO, LIM2, LIM3, LIM4,
     *   LIM5, LIM6, LIM7, I1, I2, I3, I4, I5, I6, I7, IPOS(7), BOTEMP,
     *   LIMO, LIMIT, LIM1, LOFF, CORNOU(8), IPLDO, IMAGE(2)
      INTEGER DBGIMG(952,538), DBGI
      REAL      PLTODO, PLDONE, PMAX, PMIN, OUTMAX, OUTMIN
      LOGICAL   T, F, BLNKD
      INCLUDE 'BLANK.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI1, INDI1, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING INPUT IMAGE'
         GO TO 990
         END IF
C                                       output blanked
      CALL ZPHFIL ('MA', DISKO, NEWCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNO1, INDO1, DISKO, IFILE, T, T, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPENING OUTPUT IMAGE'
         GO TO 990
         END IF
C                                       Box Image
      NIX = CATOLD(KINAX+IXAX-1)
      NIY = CATOLD(KINAX+IYAX-1)
      I = (NIX * NIY - 1) / 1024 + 4
      CALL ZMEMRY ('GET ', 'BLNKBX', I, IMAGE, PIMAGE, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'GETTING DYNAMIC MEMORY'
         GO TO 990
         END IF
      CALL BOXIMG (NIX, NIY, NBOX, BOXES, IMAGE(1+PIMAGE))
      DBGI = NIX * NIY
      CALL COPY (DBGI, IMAGE(1+PIMAGE), DBGIMG)
C                                       Setup for I/O
      NXI = CATOLD(KINAX)
      NYI = CATOLD(KINAX+1)
      NXO = CATBLK(KINAX)
      NYO = CATBLK(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
      WINO(1) = 1
      WINO(2) = 1
      WINO(3) = NXO
      WINO(4) = NYO
      OUTMAX = -1.0E20
      OUTMIN = -OUTMAX
      PMAX = OUTMAX
      PMIN = OUTMIN
      BLNKD = F
      TBLNKD = .FALSE.
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
      IPLDO = 0
      PLDONE = 0.0
      PLTODO = REAL(LIM7) * REAL(LIM4) * REAL(LIM5) * REAL(LIM6)
      PLTODO = PLTODO * CATBLK(KINAX+2)
      LIMO = CATBLK(KINAX) - 1
      LOFF = KINAX - 1
      CORNOU(8) = 1
C                                       Loop
      DO 700 I7 = 1,LIM7
         CORNOU(7) = I7
         IPOS(7) = BLC(7) + I7 - 0.9
         DO 600 I6 = 1,LIM6
            CORNOU(6) = I6
            IPOS(6) = BLC(6) + I6 - 0.9
            DO 500 I5 = 1,LIM5
               CORNOU(5) = I5
               IPOS(5) = BLC(5) + I5 - 0.9
               DO 400 I4 = 1,LIM4
                  CORNOU(4) = I4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  DO 300 I3 = 1,LIM3
                     CORNOU(3) = I3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     PLDONE = PLDONE + 1
                     IPLDO = IPLDO + 1
                     WRITE (MSGTXT,1070) PLDONE, PLTODO
                     IF (IPLDO.EQ.1) CALL MSGWRT (1)
                     IF (IPLDO.GE.16) IPLDO = 0
C                                       Init. files, first input.
         CALL COMOFF (CATOLD(KIDIM), CATOLD(KINAX), IPOS(3), BOTEMP,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1099) IRET
            GO TO 990
            END IF
         BOI = BOTEMP + 1
         CALL MINIT ('READ', LUNI1, INDI1, NXI, NYI, WINI, XBUFF1,
     *      JBUFSZ, BOI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
C                                       Init blanked file.
         CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), CORNOU(3), BOTEMP,
     *      IRET)
         BOO = BOTEMP + 1
         CALL MINIT ('WRIT', LUNO1, INDO1, NXO, NYO, WINO, XBUFF3,
     *      JBUFSZ, BOO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1105) IRET
            GO TO 990
            END IF
         DO 250 I2 = 1,LIM2
            IPOS(2) = BLC(2) + I2 - 0.9
            IPOS(1) = IROUND (BLC(1))
C                                       Read.
            CALL MDISK ('READ', LUNI1, INDI1, XBUFF1, IBIND1, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1150) IRET
               GO TO 990
               END IF
C                                       Write.
            CALL MDISK ('WRIT', LUNO1, INDO1, XBUFF3, OBIND1, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1175) IRET
               GO TO 990
               END IF
C                                       Call function: DO1BLK
            CALL DO1BOX (IPOS, LIM1, XBUFF1(IBIND1), NIX, NIY,
     *         IMAGE(1+PIMAGE), XBUFF3(OBIND1))
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1210) IRET
               GO TO 990
               END IF
C                                       Check max, min, blanking.
            LIMIT = OBIND1 + LIMO
            DO 220 I1 = OBIND1,LIMIT
               IF (XBUFF3(I1).EQ.FBLANK) THEN
                  BLNKD = .TRUE.
               ELSE
                  OUTMAX = MAX (OUTMAX, XBUFF3(I1))
                  OUTMIN = MIN (OUTMIN, XBUFF3(I1))
                  END IF
 220           CONTINUE
 250        CONTINUE
C                                       Flush buffers for blanked
         CALL MDISK ('FINI', LUNO1, INDO1, XBUFF3, OBIND1, IRET)
         IF (IRET.EQ.0) GO TO 300
            WRITE (MSGTXT,1175) IRET
            GO TO 990
 300     CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Update CATBLK in core only
      CATR(KRDMX) = OUTMAX
      CATR(KRDMN) = OUTMIN
      NEWR(KRDMX) = PMAX
      NEWR(KRDMN) = PMIN
C                                       Mark blanking in CATBLK.
      CATR(KRBLK) = 0.0
      IF (BLNKD) CATR(KRBLK) = FBLANK
      NEWR(KRBLK) = 0.0
      IF (TBLNKD) NEWR(KRBLK) = FBLANK
C                                       Close files
      CALL ZCLOSE (LUNI1, INDI1, IRET)
      IF (ICODE.EQ.1) CALL ZCLOSE (LUNI2, INDI2, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BLNKBX: ERROR',I3,' ON ',A)
 1070 FORMAT ('BEGIN PLANE',F8.0,' OF',F8.0)
 1099 FORMAT ('BLNKBX: COMOFF (INPUT) ERROR',I3)
 1100 FORMAT ('BLNKBX: MINIT (INPUT) ERROR',I3)
 1105 FORMAT ('BLNKBX: MINIT (OUTPUT) ERROR',I3)
 1150 FORMAT ('BLNKBX: READ (INPUT) ERROR',I3)
 1175 FORMAT ('BLNKBX: WRITE (OUTPUT) ERROR',I3)
 1210 FORMAT ('BLNKBX: DO1BLK ERROR',I3)
      END
      SUBROUTINE BOXIMG (NX, NY, NBOX, BOXES, IMAGE)
C-----------------------------------------------------------------------
C   BOXIMG makes an image of the boxes (0 outside, 1 inside
C   Inputs
C      NX      I        Image X dimension
C      NY      I        Image X dimension
C      NBOX    I
C      BOXES   I(4,10)   Boxes
C   Output:
C      IMAGE   I(nx,ny)  image of boxes
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NBOX, BOXES(4,10), IMAGE(NX,*)
C
      INTEGER   IX, IY, N, IB, LX1, LX2, LY1, LY2
      REAL      R
C-----------------------------------------------------------------------
      IX = NX * NY
      CALL FILL (IX, 0, IMAGE)
      DO 50 IB = 1,NBOX
         IF (BOXES(1,IB).GT.0) THEN
            N = BOXES(3,IB) - BOXES(1,IB) + 1
            IX = BOXES(1,IB)
            DO 10 IY = BOXES(2,IB),BOXES(4,IB)
               CALL FILL (N, 1, IMAGE(IX,IY))
 10            CONTINUE
         ELSE
            LX1 = BOXES(3,IB) - BOXES(2,IB)
            LX2 = BOXES(3,IB) + BOXES(2,IB)
            LY1 = BOXES(4,IB) - BOXES(2,IB)
            LY2 = BOXES(4,IB) + BOXES(2,IB)
            DO 30 IY = LY1,LY2
               DO 20 IX = LX1,LX2
                  R = (IX-BOXES(3,IB))**2 + (IY-BOXES(4,IB))**2
                  R = SQRT (R)
                  IF (R.LE.BOXES(2,IB)) IMAGE(IX,IY) = 1
 20               CONTINUE
 30            CONTINUE
            END IF
 50      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE DO1BOX (IPOS, LIM1, IND1, NX, NY, IMAGE, OUTD1)
C-----------------------------------------------------------------------
C   DOPBLK blanks the data based on the radius of the pixel from the
C   reference pixel in arc seconds.
C   Inputs:
C      IPOS    I(7)     BLC (input image) of first value in DATA
C      LIM1    I        NUMBER VALUES IN ROW
C      NX      I        X pixels in IMAGE
C      NY      I        Y pixels in IMAGE
C      IMAGE   I(*,*)   image of boxes
C      IND1    R        Input image row
C   Output:
C      OUTD1   R(*)   Output row : input partly blanked
C      IRET    I      Return code   0 => OK
C                        >0 => error, terminate.
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), LIM1, NX, NY, IMAGE(NX,*)
      REAL      IND1(*), OUTD1(*)
C
      INTEGER   IX, LX, LY, J, dbgi(952)
      REAL      DBG(952)
      INCLUDE 'BLANK.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      LX = IPOS(IXAX)
      LY = IPOS(IYAX)
      J = 1
      IF (DOINVR.GT.0.0) J = 0
      CALL RCOPY (LIM1, IND1, DBG)
      call copy (lim1, image(1,ly), dbgi)
      DO 20 IX = 1,LIM1
         IF (IMAGE(LX,LY).EQ.J) THEN
            OUTD1(IX) = IND1(IX)
         ELSE
            OUTD1(IX) = FBLANK
            END IF
         IF (IXAX.EQ.1) LX = LX + 1
         IF (IYAX.EQ.1) LY = LY + 1
 20      CONTINUE
      CALL RCOPY (LIM1, OUTD1, DBG)
C
 999  RETURN
      END
      SUBROUTINE BLNKOU (IRET)
C-----------------------------------------------------------------------
C   BLNKOU completes the writing of the residual map (if any) and then
C   creates and fills (via PSCALE) the individual Gaussian parameters.
C   It calls BLNKHI for history info for all images.
C   Output: IRET    I      0 => ok,  4 => real trouble.
C-----------------------------------------------------------------------
      INTEGER   IRET
      INTEGER   IERR
      INCLUDE 'BLANK.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Blanked (normal) output
      WRITE (MSGTXT,1000)
      CALL MSGWRT (1)
      CALL ZCLOSE (LUNO1, INDO1, IERR)
C                                       Blanked history
      CALL BLNKHI (0, 3)
C                                       Avg of blanked pixels image
      IF (DOCAT.GT.0.0) THEN
         WRITE (MSGTXT,1050)
         CALL MSGWRT (1)
         NEWCNO = FCNO(4)
         DISKO = FVOL(4)
         CALL COPY (256, CATNEW, CATBLK)
         SEQOUT = CATBLK(KIIMS)
         CALL H2CHR (6, KHIMCO, CATR(KHIMC), CLAOUT)
         CALL ZCLOSE (LUNO2, INDO2, IERR)
C                                       Avg history
         CALL BLNKHI (1, 4)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Begin final output stage for blanked image')
 1050 FORMAT ('Begin final output stage for image of average of',
     *   ' blanked pixels')
      END
      SUBROUTINE BLNKHI (ITYP, NCN)
C-----------------------------------------------------------------------
C   BLNKHI copies and updates history file.
C   Inputs: ITYP   I      Output map type: 0 => first axis intact
C                         >0 => answers (get 1st axis info also)
C           NCN    I      Position in FILES common on catlgd file
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, OPEXP(7)*16, LABEL*8, NOTTYP*2
      INTEGER   ITYP, NCN, LUN1, LUN2, IERR, BUFF1(256)
      LOGICAL   T
      INCLUDE 'BLANK.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NOTTYP /'  '/
      DATA OPEXP /'IMAGE 2 CLIP    ',
     *   'SELF CLIP       ', 'FIXED WINDOW    ',
     *   'FLOATING WINDOW ', 'MOMENT WINDOW   ',
     *   'FLUX WINDOW     ', 'TV CURSOR SET   '/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   BUFF1, SBUFF, IERR)
      IF (IERR.LE.2) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 50
C                                       New history
 10   CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, SBUFF,
     *   IERR)
      IF (IERR.NE.0) GO TO 50
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2,
     *   SBUFF, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       BLC
      WRITE (HILINE,2000) TSKNAM, BLC
      CALL HIADD (LUN2, HILINE, SBUFF, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       TRC
      WRITE (HILINE,2001) TSKNAM, TRC
      CALL HIADD (LUN2, HILINE, SBUFF, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       other Parms
      WRITE (HILINE,2002) TSKNAM, BCHAN, ECHAN
      IF ((BCHAN.GE.2.) .OR. (ECHAN.LE.TRC(1)-BLC(1))) THEN
         CALL HIADD (LUN2, HILINE, SBUFF, IERR)
         END IF
      IF (IERR.NE.0) GO TO 50
      WRITE (HILINE,2003) TSKNAM, OPCODE, OPEXP(ICODE)
      CALL HIADD (LUN2, HILINE, SBUFF, IERR)
      IF (IERR.NE.0) GO TO 50
      IF (ICODE.EQ.1) CALL HENCO2 (TSKNAM, NAM2IN, CLA2IN, SEQ2IN,
     *   DIS2IN, LUN2, SBUFF, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       parameters
      IF ((ICODE.NE.3) .AND. (ICODE.LT.7)) THEN
         WRITE (HILINE,2004) TSKNAM, DPARM(1)
         IF (ICODE.EQ.4) WRITE (HILINE,2005) TSKNAM, DPARM(1)
         IF (ICODE.EQ.5) WRITE (HILINE,2006) TSKNAM, DPARM(1)
         IF (DPARM(1).GT.0.0) THEN
            CALL HIADD (LUN2, HILINE, SBUFF, IERR)
            END IF
         IF (IERR.NE.0) GO TO 50
         CALL H2CHR (8, 1, OLDH(KHBUN), LABEL)
         IF (ICODE.GT.2) THEN
            WRITE (HILINE,2007) TSKNAM, DPARM(2)
            IF (DPARM(2).GT.0.0) WRITE (HILINE,2008) TSKNAM,
     *         DPARM(2)
            CALL HIADD (LUN2, HILINE, SBUFF, IERR)
            IF (IERR.NE.0) GO TO 50
            WRITE (HILINE,2009) TSKNAM, DPARM(3), LABEL
            CALL HIADD (LUN2, HILINE, SBUFF, IERR)
            IF (IERR.NE.0) GO TO 50
            IF (ICODE.EQ.6) THEN
               WRITE (HILINE,2010) TSKNAM
               CALL HIADD (LUN2, HILINE, SBUFF, IERR)
               IF (IERR.NE.0) GO TO 50
               END IF
            GO TO 30
            END IF
C                                       clipping ones
         WRITE (HILINE,2015) TSKNAM, DPARM(3), LABEL
         CALL HIADD (LUN2, HILINE, SBUFF, IERR)
         IF (IERR.NE.0) GO TO 50
         WRITE (HILINE,2016) TSKNAM, DPARM(4), LABEL
         CALL HIADD (LUN2, HILINE, SBUFF, IERR)
         IF (IERR.NE.0) GO TO 50
C                                       explain F in messages
         WRITE (HILINE,2020) TSKNAM
         IF (ICODE.EQ.2) WRITE (HILINE,2021) TSKNAM
         CALL HIADD (LUN2, HILINE, SBUFF, IERR)
         IF (IERR.NE.0) GO TO 50
         END IF
C                                       TVCU: inverse or no
      IF (ICODE.EQ.7) THEN
         IF (DOINVR.GT.0.0) WRITE (HILINE,2025) TSKNAM
         IF (DOINVR.LE.0.0) WRITE (HILINE,2026) TSKNAM
         CALL HIADD (LUN2, HILINE, SBUFF, IERR)
         IF (IERR.NE.0) GO TO 50
      ELSE IF (ICODE.EQ.8) THEN
         WRITE (HILINE,2027) TSKNAM, DPARM(1)
         CALL HIADD (LUN2, HILINE, SBUFF, IERR)
         IF (IERR.NE.0) GO TO 50
         END IF
C                                       blanking
 30   IF (DPARM(5).GT.0.0) THEN
         WRITE (HILINE,2030) TSKNAM
      ELSE
         WRITE (HILINE,2031) TSKNAM
         END IF
      CALL HIADD (LUN2, HILINE, SBUFF, IERR)
      IF (IERR.NE.0) GO TO 50
C                                       Old axis 1
      IF (ITYP.GT.0) THEN
         CALL H2CHR (8, 1, OLDH(KHCTP), LABEL)
         WRITE (HILINE,2040) TSKNAM, LABEL
         CALL HIADD (LUN2, HILINE, SBUFF, IERR)
         IF (IERR.NE.0) GO TO 50
         WRITE (HILINE,2041) TSKNAM, CATOLD(KINAX)
         CALL HIADD (LUN2, HILINE, SBUFF, IERR)
         IF (IERR.NE.0) GO TO 50
         WRITE (HILINE,2042) TSKNAM, OLDR(KRCRP)
         CALL HIADD (LUN2, HILINE, SBUFF, IERR)
         IF (IERR.NE.0) GO TO 50
         WRITE (HILINE,2043) TSKNAM, OLDR(KRCIC)
         CALL HIADD (LUN2, HILINE, SBUFF, IERR)
         IF (IERR.NE.0) GO TO 50
         WRITE (HILINE,2044) TSKNAM, OLDD(KDCRV)
         CALL HIADD (LUN2, HILINE, SBUFF, IERR)
         END IF
C                                       Close HI file
 50   CALL HICLOS (LUN2, T, SBUFF, IERR)
C                                        Copy tables
      CALL ALLTAB (1, NOTTYP, LUN1, LUN2, DISKIN, DISKO, OLDCNO,
     *   NEWCNO, CATBLK, BUFF1, SBUFF, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'ERROR COPYING TABLE FILES'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK and close
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'CLWR', BUFF1, IERR)
      FRW(NCN) = -1
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BLNKHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 2000 FORMAT (A6,'BLC =',6(F6.0,','),F6.0)
 2001 FORMAT (A6,'TRC =',6(F6.0,','),F6.0)
 2002 FORMAT (A6,'BCHAN =',F5.0,'  ECHAN =',F5.0,6X,'/ signal ',
     *   'channels in window')
 2003 FORMAT (A6,'OPCODE = ''',A4,'''',17X,'/ operation ',A)
 2004 FORMAT (A6,'DPARM(1) =',F6.0,16X,'/ Extend signal area by ',
     *   'channels')
 2005 FORMAT (A6,'DPARM(1) =',F6.0,16X,'/ Window width in channels')
 2006 FORMAT (A6,'DPARM(1) =',F6.2,16X,'/ Window width = 2nd mom * ',
     *   'D(1)')
 2007 FORMAT (A6,'DPARM(2) =',F6.1,16X,'/ Window center at 1st',
     *   ' moment')
 2008 FORMAT (A6,'DPARM(2) =',F6.1,16X,'/ Window center at peak val')
 2009 FORMAT (A6,'DPARM(3) =',1PE13.5,9X,'/ Moms ignore < D(3) ',A8)
 2010 FORMAT (A6,'/ Also stop window at first pixel < D(3)')
 2015 FORMAT (A6,'DPARM(3) =',1PE13.5,9X,'/ Keep F <= D(3) in ',A8)
 2016 FORMAT (A6,'DPARM(4) =',1PE13.5,9X,'/ Keep F >= D(4) in ',A8)
 2020 FORMAT (A6,'/ Where F is from the second image')
 2021 FORMAT (A6,'/ Where F is from the input image itself')
 2025 FORMAT (A6,'/ Blank pixels inside blotch regions')
 2026 FORMAT (A6,'/ Blank pixels outside blotch regions')
 2027 FORMAT (A6,'/ Blank pixels outside',F9.3,' asec')
 2030 FORMAT (A6,'/ Blanked pixels set to 0.0 - as if they are valid')
 2031 FORMAT (A6,'/ Blanked pixels set to magic value blanking')
 2040 FORMAT (A6,'CTYPE1  = ''',A8,'''',12X,'/ Old axis 1')
 2041 FORMAT (A6,'NAXIS1  = ',I6,16X,'/ Old axis 1')
 2042 FORMAT (A6,'CRPIX1  = ',F9.3,13X,'/ Old axis 1')
 2043 FORMAT (A6,'CDELT1  = ',1PE13.5,9X,'/ Old axis 1')
 2044 FORMAT (A6,'CRVAL1  = ',1PE18.10,4X,'/ Old axis 1')
      END

      PROGRAM CLINV
C-----------------------------------------------------------------------
C! Task to invert calibration in SN/CL tables
C# EXT-util Utility Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1999, 2008-2009, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  CLINV copies AIPS SN/CL extension files, inverting some or all of the
C  calibration.  The specified output table should not exist before the
C  execution of CLINV.
C  ADVERBS:
C    INNAME      Input image name (name)
C    INCLASS     Input image name (class)
C    INSEQ       Input image name (seq. #)
C    INDISK      Input image disk unit #
C    INEXT       Input table extension type
C    INVERS      Input table file version no.
C    OUTNAME     Output image name (name)
C    OUTCLASS    Output image name (class)
C    OUTSEQ      Output image name (seq. #)
C    OUTDISK     Output image disk unit #.
C    OUTVERS     Output table file version.
C    OPTYPE      'PHAS', 'AMPL', else both
C-----------------------------------------------------------------------
      HOLLERITH XNAMIN(3), XCLAIN(2), XNMOUT(3), XCLOUT(2), XNEXT(1),
     *   CATHLD(256), XOPTYP(1)
      CHARACTER  NAMEIN*12, CLAIN*6, FTYPE*2, STAT*4, NAMOUT*12,
     *   CLAOUT*6, OPTYPE*4, PRGM*6, TABTYP*2, ATIME*8, ADATE*12
      INTEGER  IRET, SEQIN, SEQOUT, DISKIN, DISKO, NEWCNO, OLDCNO,
     *   CATOLD(256), BUFF1(512), BUFF2(512), IERR, IVER, OVER, LUN1,
     *   LUN2, NPARM, IROUND, NOLDT, TIME(3), DATE(3)
      REAL      XSEQIN, XDISKI, XIVER, XSEQO, XDISKO, XOVER
      LOGICAL   T, SAME
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /INPARM/ XNAMIN, XCLAIN, XSEQIN, XDISKI, XNEXT, XIVER,
     *   XNMOUT, XCLOUT, XSEQO, XDISKO, XOVER, XOPTYP
      EQUIVALENCE (CATOLD, CATHLD)
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA PRGM /'CLINV '/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 18
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMIN, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF1, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMIN, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNMOUT, NAMOUT)
      CALL H2CHR (6, 1, XCLOUT, CLAOUT)
      CALL H2CHR (2, 1, XNEXT, TABTYP)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      IF ((OPTYPE.NE.'PHAS') .AND. (OPTYPE.NE.'AMPL')) OPTYPE = 'BOTH'
C                                       Crunch input parameters.
      SEQIN  = IROUND (XSEQIN)
      SEQOUT = IROUND (XSEQO)
      DISKIN = IROUND (XDISKI)
      DISKO  = IROUND (XDISKO)
      IVER   = IROUND (XIVER)
      OVER   = IROUND (XOVER)
C                                       Default output = input.
      IF (NAMOUT.EQ.' ') NAMOUT = NAMEIN
      IF (CLAOUT.EQ.' ') CLAOUT = CLAIN
      IF (TABTYP.NE.'CL') TABTYP = 'SN'
C                                       Find input
      OLDCNO = 1
      FTYPE = ' '
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, FTYPE,
     *   NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Find output
      NEWCNO = 1
      FTYPE = ' '
      CALL CATDIR ('SRCH', DISKO, NEWCNO, NAMOUT, CLAOUT, SEQOUT, FTYPE,
     *    NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMOUT, CLAOUT, SEQOUT, DISKO,
     *      NLUSER
         GO TO 990
         END IF
      SAME = (DISKIN.EQ.DISKO) .AND. (OLDCNO.EQ.NEWCNO)
      STAT = 'READ'
      IF (SAME) STAT = 'REST'
C                                       Read old CATBLK and mark 'READ'
      CALL CATIO ('READ', DISKIN, OLDCNO, CATOLD, STAT, BUFF1, IERR)
      IF ((IERR.GT.0) .AND. (IERR.LT.5)) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      IF (.NOT.SAME) THEN
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = DISKIN
         FCNO(NCFILE) = OLDCNO
         FRW(NCFILE) = 0
         END IF
C                                       Read new CATBLK and mark 'WRIT'
      CALL CATIO ('READ', DISKO, NEWCNO, CATBLK, 'WRIT', BUFF1, IERR)
      IF ((IERR.GT.0) .AND. (IERR.LT.5)) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = NEWCNO
      FRW(NCFILE) = 1
C                                       copy keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
C                                       Check number of tables
      CALL FNDEXT (TABTYP, CATOLD, NOLDT)
C                                       use highest version if IVER = 0
      IF (IVER.LE.0) IVER = NOLDT
C                                       Copy table
      IF (TABTYP.EQ.'CL') THEN
         CALL CLINVR (OPTYPE, IVER, OVER, LUN1, LUN2, DISKIN, DISKO,
     *      OLDCNO, NEWCNO, CATOLD, CATBLK, BUFF1, BUFF2, IRET)
      ELSE
         CALL SNINVR (OPTYPE, IVER, OVER, LUN1, LUN2, DISKIN, DISKO,
     *      OLDCNO, NEWCNO, CATOLD, CATBLK, BUFF1, BUFF2, IRET)
         END IF
      IF (IRET.NE.0) THEN
         IF (IRET.EQ.1) THEN
            MSGTXT = 'INPUT AND OUTPUT TABLES ARE THE SAME.'
         ELSE IF (IRET.EQ.6) THEN
            MSGTXT = 'OUTPUT TABLE ALREADY EXISTS'
         ELSE
            WRITE (MSGTXT,1085) IRET, IVER
            END IF
         GO TO 990
         END IF
C                                       Finished copying tables
      IRET = 0
C                                       Add history to output
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN1, DISKO, NEWCNO, BUFF1, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1090) IERR
         CALL MSGWRT (6)
         GO TO 150
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
      WRITE (MSGTXT,1100) TSKNAM, RLSNAM, ADATE, ATIME
      CALL HIADD (LUN1, MSGTXT, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
C                                       Input file
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN1, BUFF1,
     *   IERR)
      IF (IERR.NE.0) GO TO 150
C                                       Type and version
      WRITE (MSGTXT,2000) TSKNAM, TABTYP, IVER, OVER
      CALL HIADD (LUN1, MSGTXT, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
C                                       OPTYPE
      WRITE (MSGTXT,2001) TSKNAM, OPTYPE
      CALL HIADD (LUN1, MSGTXT, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 150
C                                       Close HI file
 150  CALL HICLOS (LUN1, T, BUFF1, IERR)
      GO TO 995
C                                       Error
 990  CALL MSGWRT (8)
C                                       Close down files, etc
 995  CALL DIE (IRET, BUFF1)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' GETING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1085 FORMAT ('ERROR ',I4,' COPYING TABLE ',I5)
 1090 FORMAT ('ERROR',I3,' OPENING HISTORY FILE')
 1100 FORMAT (A6,'Release =''',A7,' ''  /********* Start ',
     *   A12,2X,A8)
 2000 FORMAT (A6,'INEXT=''',A2,''' INVERS=',I4,' OUTVERS=', I4)
 2001 FORMAT (A6,'OPTYPE=''',A,''' / what was inverted')
      END
      SUBROUTINE CLINVR (OP, INVER, OUTVER, LUNOLD, LUNNEW, VOLOLD,
     *   VOLNEW, CNOOLD, CNONEW, CATOLD, CATNEW, BUFF1, BUFF2, IRET)
C-----------------------------------------------------------------------
C   Routine to invert the calibration of a CL table.
C   Inputs:
C      OP       C*4     What to invert 'BOTH', 'PHAS', 'AMPL'
C      INVER    I       Version number to copy.
C      OUTVER   I       Version number on output file
C      LUNOLD   I       LUN for old file
C      LUNNEW   I       LUN for new file
C      VOLOLD   I       Disk number for old file.
C      VOLNEW   I       Disk number for new file.
C      CNOOLD   I       Catalog slot number for old file
C      CNONEW   I       Catalog slot number for new file
C      CATOLD   I       Catalog header for old file
C   In/out:
C      CATNEW   I(256)  Catalog header for new file.
C   Output:
C      BUFF1    I(512)  Work buffer
C      BUFF2    I(512)  Work buffer
C      IRET     I       Return error code  0 => ok
C                          1 => files the same, no copy.
C                          2 => no input files exist
C                          3 => failed
C                          4 => no output files created.
C                          5 => failed to update CATNEW
C                          6 => output file exists
C-----------------------------------------------------------------------
      INTEGER   INVER, OUTVER, LUNOLD, LUNNEW, VOLOLD, VOLNEW, CNOOLD,
     *   CNONEW, BUFF1(256), BUFF2(256), CATOLD(256), CATNEW(256), IRET
      CHARACTER OP*4
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ICLRNO, CLKOLS(MAXCLC), CLNUMV(MAXCLC), NUMANT, NUMPOL,
     *   NUMIF, NTERM, OKOLS(MAXCLC), ONUMV(MAXCLC), NCLROW, I, SOURID,
     *   ANTNO, SUBA, FREQID, REFA(2,MAXIF), OCLRNO, IIF, IIP, NNP
      REAL      TIMEI, IFR, DOPOFF(MAXIF), ATMOS, DATMOS, MBDELY(2),
     *   CLOCK(2), DCLOCK(2), DISP(2), DDISP(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF),
     *   WEIGHT(2,MAXIF), GMMOD, CR, CI, CA
      LOGICAL   TABLE, EXIST, FITASC
      DOUBLE PRECISION TIME, GEODLY(20)
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       Check existance
      IF (OUTVER.GT.0) THEN
         CALL ISTAB ('CL', VOLNEW, CNONEW, OUTVER, LUNNEW, BUFF2, TABLE,
     *      EXIST, FITASC, IRET)
         IF (EXIST) THEN
            IRET = 6
            GO TO 999
            END IF
         END IF
C                                       Open CL file
      CALL CALINI ('READ', BUFF1, VOLOLD, CNOOLD, INVER, CATOLD, LUNOLD,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       # rows in old table
      NCLROW = BUFF1(5)
      NNP = MIN (2, NUMPOL)
C                                       Open up new CL table
      CALL CALINI ('WRIT', BUFF2, VOLNEW, CNONEW, OUTVER, CATNEW,
     *   LUNNEW, OCLRNO, OKOLS, ONUMV, NUMANT, NUMPOL, NUMIF, NTERM,
     *   GMMOD, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 800 I = 1,NCLROW
         ICLRNO = I
         CALL TABCAL ('READ', BUFF1, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
C                                       Deselected record.
         IF (IRET.LT.0) GO TO 800
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1030) IRET
            GO TO 990
            END IF
C                                       Phase only
         IF (OP.EQ.'PHAS') THEN
            DO 45 IIF = 1,NUMIF
               DO 40 IIP = 1,NNP
                  IF ((CREAL(IIP,IIF).NE.FBLANK) .AND.
     *               (CIMAG(IIP,IIF).NE.FBLANK)) THEN
                     CR = CREAL(IIP,IIF)
                     CI = CIMAG(IIP,IIF)
                     CA = CR*CR+CI*CI
                     IF (CA.GT.0.0) THEN
                        CA = SQRT (CA)
                        CREAL(IIP,IIF) = CR / CA
                        CIMAG(IIP,IIF) = -CI / CA
                     ELSE
                        CREAL(IIP,IIF) = FBLANK
                        CIMAG(IIP,IIF) = FBLANK
                        END IF
                     END IF
                  IF (DELAY(IIP,IIF).NE.FBLANK)
     *               DELAY(IIP,IIF) = -DELAY(IIP,IIF)
                  IF (RATE(IIP,IIF).NE.FBLANK)
     *               RATE(IIP,IIF) = -RATE(IIP,IIF)
 40               CONTINUE
 45            CONTINUE
C                                       Amplitude only
         ELSE IF (OP.EQ.'AMPL') THEN
            DO 55 IIF = 1,NUMIF
               DO 50 IIP = 1,NNP
                  IF ((CREAL(IIP,IIF).NE.FBLANK) .AND.
     *               (CIMAG(IIP,IIF).NE.FBLANK)) THEN
                     CR = CREAL(IIP,IIF)
                     CI = CIMAG(IIP,IIF)
                     CA = CR*CR+CI*CI
                     IF (CA.GT.0.0) THEN
                        CREAL(IIP,IIF) = 1.0 / SQRT (CA)
                     ELSE
                        CREAL(IIP,IIF) = FBLANK
                        END IF
                     CIMAG(IIP,IIF) = 0.0
                     END IF
                  IF (DELAY(IIP,IIF).NE.FBLANK) DELAY(IIP,IIF) = 0.0
                  IF (RATE(IIP,IIF).NE.FBLANK) RATE(IIP,IIF) = 0.0
 50               CONTINUE
 55            CONTINUE
C                                       Both
         ELSE
            DO 65 IIF = 1,NUMIF
               DO 60 IIP = 1,NNP
                  IF ((CREAL(IIP,IIF).NE.FBLANK) .AND.
     *               (CIMAG(IIP,IIF).NE.FBLANK)) THEN
                     CR = CREAL(IIP,IIF)
                     CI = CIMAG(IIP,IIF)
                     CA = CR*CR+CI*CI
                     IF (CA.GT.0.0) THEN
                        CREAL(IIP,IIF) = CR / CA
                        CIMAG(IIP,IIF) = -CI / CA
                     ELSE
                        CREAL(IIP,IIF) = FBLANK
                        CIMAG(IIP,IIF) = FBLANK
                        END IF
                     END IF
                  IF (DELAY(IIP,IIF).NE.FBLANK)
     *               DELAY(IIP,IIF) = -DELAY(IIP,IIF)
                  IF (RATE(IIP,IIF).NE.FBLANK)
     *               RATE(IIP,IIF) = -RATE(IIP,IIF)
 60               CONTINUE
 65            CONTINUE
            END IF
C                                       Write new table.
         CALL TABCAL ('WRIT', BUFF2, OCLRNO, OKOLS, ONUMV, NUMPOL,
     *      NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1040) IRET
            GO TO 990
            END IF
 800     CONTINUE
      IRET = 0
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ICLRNO, BUFF1, BUFF1, IRET)
      CALL TABIO ('CLOS', 0, OCLRNO, BUFF2, BUFF2, IRET)
      WRITE (MSGTXT,1050) OP, VOLOLD, CNOOLD, INVER, VOLNEW, CNONEW,
     *   OUTVER
      CALL MSGWRT (3)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('CLINVR: ERROR ',I3,' INITING OLD TABLE')
 1020 FORMAT ('CLINVR: ERROR ',I3,' INITING NEW TABLE')
 1030 FORMAT ('CLINVR: ERROR ',I3,' READING OLD TABLE')
 1040 FORMAT ('CLINVR: ERROR ',I3,' WRITING NEW TABLE')
 1050 FORMAT ('Inverted CL ',A,' from vol/cno/vers',I3,I5,I4,' to',
     *   I3,I5,I4)
      END
      SUBROUTINE SNINVR (OP, INVER, OUTVER, LUNOLD, LUNNEW, VOLOLD,
     *   VOLNEW, CNOOLD, CNONEW, CATOLD, CATNEW, BUFF1, BUFF2, IRET)
C-----------------------------------------------------------------------
C   Routine to invert the calibration of a SN table.
C   Inputs:
C      OP       C*4     What to invert 'BOTH', 'PHAS', 'AMPL'
C      INVER    I       Version number to copy.
C      OUTVER   I       Version number on output file
C      LUNOLD   I       LUN for old file
C      LUNNEW   I       LUN for new file
C      VOLOLD   I       Disk number for old file.
C      VOLNEW   I       Disk number for new file.
C      CNOOLD   I       Catalog slot number for old file
C      CNONEW   I       Catalog slot number for new file
C      CATOLD   I       Catalog header for old file
C   In/out:
C      CATNEW   I(256)  Catalog header for new file.
C   Output:
C      BUFF1    I(512)  Work buffer
C      BUFF2    I(512)  Work buffer
C      IRET     I       Return error code  0 => ok
C                          1 => files the same, no copy.
C                          2 => no input files exist
C                          3 => failed
C                          4 => no output files created.
C                          5 => failed to update CATNEW
C                          6 => output file exists
C-----------------------------------------------------------------------
      INTEGER   INVER, OUTVER, LUNOLD, LUNNEW, VOLOLD, VOLNEW, CNOOLD,
     *   CNONEW, BUFF1(256), BUFF2(256), CATOLD(256), CATNEW(256), IRET
      CHARACTER OP*4
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   ISNRNO, SNKOLS(MAXSNC), SNNUMV(MAXSNC), NUMANT, NUMPOL,
     *   NUMIF, OKOLS(MAXSNC), ONUMV(MAXSNC), NSNROW, I, SOURID, NUMNOD,
     *   ANTNO, SUBA, FREQID, REFA(2,MAXIF), OSNRNO, IIF, IIP, NODENO,
     *   NNP
      REAL    GMMOD, RANOD(25), DECNOD(25), TIMEI, IFR, MBDELY(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), DISP(2),
     *   RATE(2,MAXIF), WEIGHT(2,MAXIF), CR, CI, CA, DDISP(2)
      LOGICAL   TABLE, EXIST, FITASC, ISAPPL
      DOUBLE PRECISION TIME
      INCLUDE 'INCS:PSNTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       Check existance
      IF (OUTVER.GT.0) THEN
         CALL ISTAB ('SN', VOLNEW, CNONEW, OUTVER, LUNNEW, BUFF2, TABLE,
     *      EXIST, FITASC, IRET)
         IF (EXIST) THEN
            IRET = 6
            GO TO 999
            END IF
         END IF
C                                       Open SN file
      CALL SNINI ('READ', BUFF1, VOLOLD, CNOOLD, INVER, CATOLD, LUNOLD,
     *   ISNRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       # rows in old table
      NSNROW = BUFF1(5)
      NNP = MIN (2, NUMPOL)
C                                       Open up new SN table
      CALL SNINI ('WRIT', BUFF2, VOLNEW, CNONEW, OUTVER, CATNEW,
     *   LUNNEW, OSNRNO, OKOLS, ONUMV, NUMANT, NUMPOL, NUMIF, NUMNOD,
     *   GMMOD, RANOD, DECNOD, ISAPPL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 800 I = 1,NSNROW
         ISNRNO = I
         CALL TABSN ('READ', BUFF1, ISNRNO, SNKOLS, SNNUMV, NUMPOL,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
C                                       Deselected record.
         IF (IRET.LT.0) GO TO 800
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1030) IRET
            GO TO 990
            END IF
C                                       Phase only
         IF (OP.EQ.'PHAS') THEN
            DO 45 IIF = 1,NUMIF
               DO 40 IIP = 1,NNP
                  IF ((CREAL(IIP,IIF).NE.FBLANK) .AND.
     *               (CIMAG(IIP,IIF).NE.FBLANK)) THEN
                     CR = CREAL(IIP,IIF)
                     CI = CIMAG(IIP,IIF)
                     CA = CR*CR+CI*CI
                     IF (CA.GT.0.0) THEN
                        CA = SQRT (CA)
                        CREAL(IIP,IIF) = CR / CA
                        CIMAG(IIP,IIF) = -CI / CA
                     ELSE
                        CREAL(IIP,IIF) = FBLANK
                        CIMAG(IIP,IIF) = FBLANK
                        END IF
                     END IF
                  IF (DELAY(IIP,IIF).NE.FBLANK)
     *               DELAY(IIP,IIF) = -DELAY(IIP,IIF)
                  IF (RATE(IIP,IIF).NE.FBLANK)
     *               RATE(IIP,IIF) = -RATE(IIP,IIF)
 40               CONTINUE
 45            CONTINUE
C                                       Amplitude only
         ELSE IF (OP.EQ.'AMPL') THEN
            DO 55 IIF = 1,NUMIF
               DO 50 IIP = 1,NNP
                  IF ((CREAL(IIP,IIF).NE.FBLANK) .AND.
     *               (CIMAG(IIP,IIF).NE.FBLANK)) THEN
                     CR = CREAL(IIP,IIF)
                     CI = CIMAG(IIP,IIF)
                     CA = CR*CR+CI*CI
                     IF (CA.GT.0.0) THEN
                        CREAL(IIP,IIF) = 1.0 / SQRT (CA)
                     ELSE
                        CREAL(IIP,IIF) = FBLANK
                        END IF
                     CIMAG(IIP,IIF) = 0.0
                     END IF
                  IF (DELAY(IIP,IIF).NE.FBLANK) DELAY(IIP,IIF) = 0.0
                  IF (RATE(IIP,IIF).NE.FBLANK) RATE(IIP,IIF) = 0.0
 50               CONTINUE
 55            CONTINUE
C                                       Both
         ELSE
            DO 65 IIF = 1,NUMIF
               DO 60 IIP = 1,NNP
                  IF ((CREAL(IIP,IIF).NE.FBLANK) .AND.
     *               (CIMAG(IIP,IIF).NE.FBLANK)) THEN
                     CR = CREAL(IIP,IIF)
                     CI = CIMAG(IIP,IIF)
                     CA = CR*CR+CI*CI
                     IF (CA.GT.0.0) THEN
                        CREAL(IIP,IIF) = CR / CA
                        CIMAG(IIP,IIF) = -CI / CA
                     ELSE
                        CREAL(IIP,IIF) = FBLANK
                        CIMAG(IIP,IIF) = FBLANK
                        END IF
                     END IF
                  IF (DELAY(IIP,IIF).NE.FBLANK)
     *               DELAY(IIP,IIF) = -DELAY(IIP,IIF)
                  IF (RATE(IIP,IIF).NE.FBLANK)
     *               RATE(IIP,IIF) = -RATE(IIP,IIF)
 60               CONTINUE
 65            CONTINUE
            END IF
C                                       Write new table.
         CALL TABSN ('WRIT', BUFF2, OSNRNO, OKOLS, ONUMV, NUMPOL,
     *      TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, NODENO,
     *      MBDELY, DISP, DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT,
     *      REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1040) IRET
            GO TO 990
            END IF
 800     CONTINUE
      IRET = 0
C                                       Close both tables
      CALL TABIO ('CLOS', 0, ISNRNO, BUFF1, BUFF1, IRET)
      CALL TABIO ('CLOS', 0, OSNRNO, BUFF2, BUFF2, IRET)
      WRITE (MSGTXT,1050) OP, VOLOLD, CNOOLD, INVER, VOLNEW, CNONEW,
     *   OUTVER
      CALL MSGWRT (3)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SNINVR: ERROR ',I3,' INITING OLD TABLE')
 1020 FORMAT ('SNINVR: ERROR ',I3,' INITING NEW TABLE')
 1030 FORMAT ('SNINVR: ERROR ',I3,' READING OLD TABLE')
 1040 FORMAT ('SNINVR: ERROR ',I3,' WRITING NEW TABLE')
 1050 FORMAT ('Inverted SN ',A,' from vol/cno/vers',I3,I5,I4,' to',
     *   I3,I5,I4)
      END

      SUBROUTINE AU2 (BRANCH)
C-----------------------------------------------------------------------
C! handles task-related activities: GO, TELL, WAIT, ABORT, SPY, TPUT
C# POPS-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2005, 2007-2008, 2010-2011, 2013-2018, 2021, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AU2 handles tasking activities
C   Input:
C      BRANCH   I   1 activate a task (named TASK in /CORE/)
C                   2 print list of active tasks
C                   3 delay until task completes (named TASK in /CORE/)
C                   4 kill a task                (named TASK in /CORE/)
C                   5 Save task adverbs for later TGET
C                   6 TELL running task some parameters
C                   7 STQUEUE queue of pending TELLs
C                   8 SETDEBUG sets debugging global parameter DBGAIP
C                   9 PARALLEL sets degree of parallelism for tasks
C                  10 Save task adverbs for later VGET
C   Inputs file function codes are in column 10 as:
C      ' '   GO
C      '*'   GO  TELL
C      '?'       TELL
C      '&'   GO  TELL  GET
C      '%'       TELL  GET
C      '$'   GO        GET
C      '@'             GET
C      other -> error message
C   INPUTS, TPUT, TGET and GO only do the GO adverbs, OUTPUTS only does
C   the GET adverbs, SHOW and TELL only do the TELL adverbs
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      INTEGER   NSYSAD, NSYSTA, NSYSDA, NSYSCH, NSYSIM
      PARAMETER (NSYSAD=36, NSYSTA=2, NSYSDA=9, NSYSCH=4, NSYSIM=11)
C
      CHARACTER ITASK*8, ANAME*6, ATIME*8, CTEST*8, CVER(4)*4, ADATE*12,
     *   PHNAME*48, LVERSN*48, AVERSN*48, JBUF*80, SYSADV(NSYSAD)*8,
     *   CTEMP*4, PRGNAM*6, CDUM*1, OPTELL*4, POPSNO*1, CODE*1,
     *   HHNAME*48
      INTEGER   POTERR, FINDIN, FINDTD, FINDTT, LUNTTY, IPRBUF(256),
     *   IUSER, IVER, NREC, I, JTRIM, IERR, LUNTG, FINDTG, IPOPS,
     *   ITIME(6), NTASK, JTASK, COLLBN, COLUBN, COLCOM, IEOF, ILOC,
     *   IPTR, IRETCD, ITAG, ITYPE, LUNIN, LUNTD, NBLOCK, VERTYP, NWPL,
     *   NLPR, ITEMP, PID(4), ISIZE, LPTR, LPTRMX, COLSHO, IX, IXL, IXH,
     *   IY, IYL, IYH, IREC, LREC, TSBLK, JOFF, NSIZE, LSIZE, NMATCC,
     *   IROUND, IDUM, LPID(4), NPROC, IPRGUF(256), JPTR, ADTYPE
      REAL      PARBUF(256), LMIN, LMAX, LIM(2), TSKDLY, SYSLIM(2), TDL,
     *   RDUM, DOWAIT, PARGUF(256)
      LOGICAL   T, F, ACTIVE, WASDEF, LDOWT, OK(16), ADVGET, TGNEW
      HOLLERITH HARBUF(256), HARGUF(256), HNAME(3)
      INCLUDE 'INCS:DSMS.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCRE.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DIO.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:PMAD.INC'
      INCLUDE 'INCS:PUVD.INC'
      COMMON /AIPSCR/ IPRBUF
      COMMON /AIPCCR/ PHNAME, LVERSN, AVERSN, JBUF
      EQUIVALENCE (IPRBUF(1), PARBUF(1), HARBUF(1))
      EQUIVALENCE (IPRGUF(1), PARGUF(1), HARGUF(1))
      EQUIVALENCE (ADTYPE, HNAME(3))
      DATA PRGNAM /'AU2 '/
      DATA LMIN, LMAX /-1.E16, 1.E16/
      DATA COLSHO, COLLBN, COLUBN, COLCOM /10, 11, 23, 35/
      DATA LUNIN, LUNTD, LUNTTY, LUNTG /11, 13, 5, 14/
      DATA IEOF /2/
      DATA T, F /.TRUE.,.FALSE./
      DATA CVER /'OLD:','NEW:','TST:','CVX:'/
      DATA SYSADV /'INTAPE  ', 'OUTTAPE ', 'INDISK  ', 'IN2DISK ',
     *   'IN3DISK ', 'IN4DISK ', 'DDISK', 'MDISK', 'TDISK', 'OUTDISK ',
     *   'OUT2DISK', 'BCHAN', 'ECHAN', 'CHANSEL', 'CHANNEL',
     *   'BLC', 'TRC', 'TBLC', 'TTRC', 'PIXXY', 'IMSIZE', 'BOX',
     *   'CLBOX', 'FLDSIZE', 'PIX2XY', 'UVSIZE',
     *   'BATQUE', 'NUMTELL', 'PRNUMBER', 'TVCHAN', 'TV2CHAN', 'GRCHAN',
     *   'GR2CHAN', 'TVCORN', 'TVXY', 'TVLEVS'/
C-----------------------------------------------------------------------
      ADVGET = .FALSE.
      NBLOCK = 8
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.10)) GO TO 999
      FINDTD = 0
      FINDTG = 0
      FINDIN = 0
      IPOPS = NPOPS
      CALL ADVERB ('TASK', 'C', 1, 8, IDUM, RDUM, ITASK)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('DOWAIT', 'R', 1, 0, IDUM, DOWAIT, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
C                                       get member name from stack
      IF ((BRANCH.EQ.2) .OR. ((BRANCH.GE.7) .AND. (BRANCH.LE.9)))
     *   GO TO 90
         POTERR = 7
         IF (SP.LT.4) GO TO 980
         POTERR = 8
         IF ((STACK(SP).NE.2) .OR. (STACK(SP-3).NE.14) .OR.
     *      (STACK(SP-2).NE.8)) GO TO 980
         WASDEF = CH(STACK(SP-1)).EQ.HBLANK
         IF (.NOT.WASDEF) CALL H2CHR (8, 1, C(STACK(SP-1)), ITASK)
         SP = SP - 4
C                                       open inputs file
         CALL ZPHFIL ('HE', 1, 0, 0, HHNAME, IERR)
         POTERR = 101
C                                       Allow min match
C                                       Return true value
         CALL ADVERB ('VERSION', 'C', 1, 48, IDUM, RDUM, LVERSN)
         IF (ERRNUM.NE.0) GO TO 980
         CALL VERMAT (1, HHNAME, ITASK, LVERSN, VERTYP, AVERSN, IERROR)
         IF (IERROR(1).NE.0) GO TO 980
         IF (ITASK(:4).EQ.'AIPS') THEN
            IF ((BRANCH.NE.3) .OR. (ITASK(:5).NE.'AIPSC')) THEN
               WRITE (MSGTXT,1000)
               CALL MSGWRT (8)
               POTERR = 101
               GO TO 980
               END IF
            END IF
C                                       Branch to operation
 90   GO TO (100, 300, 400, 500, 100, 600, 700, 800, 900, 100), BRANCH
C-----------------------------------------------------------------------
C                                       GO
C                                       start a task, save adverbs
C                                       TPUT
C                                       Just save the adverbs
C                                       VPUT
C                                       Just save the adverbs, versioned
C-----------------------------------------------------------------------
 100  IF (WASDEF) THEN
         CALL ADVRBS ('TASK', 'C', 1, 8, IDUM, RDUM, ITASK)
         IF (ERRNUM.NE.0) GO TO 980
         END IF
      CALL ZTOPEN (LUNIN, FINDIN, 1, HHNAME, ITASK, AVERSN, T, IERROR)
      POTERR = 31
      IF (IERROR(1).NE.0) THEN
         FINDIN = 0
         GO TO 980
         END IF
C                                       Name Task adverb save file
      IF (BRANCH.EQ.10) THEN
         CALL ADVERB ('VNUMBER', 'I', 1, 1, IVER, RDUM, CDUM)
         IF (ERRNUM.NE.0) GO TO 980
         IF ((IVER.LE.0) .OR. (IVER.GT.35)) IVER = 1
      ELSE
         IVER = 0
         END IF
      IUSER = 100 * NBLOCK
      IF ((IPOPS.GT.NINTRN) .OR. (TSKNAM(1:5).EQ.'AIPSC'))
     *   IUSER = IUSER + IPOPS
C                                       prime TV parameters
      IF (NGRAPH.LE.0) THEN
         IF (ISBTCH.EQ.32000) THEN
            NGRAY = 16
            NGRAPH = 8
            OFMINP = 16 * 2046
            MAXXTV(1) = 1024
            MAXXTV(2) = 1024
         ELSE
            MSGSUP = 32000
            CALL TVOPEN (IPRBUF, IERR)
            IF (IERR.EQ.0) CALL TVCLOS (IPRBUF, IERR)
            MSGSUP = 0
            END IF
         END IF
C                                       Open Task adverb save file
      CALL ZPHFIL ('TG', 1, IUSER, IVER, PHNAME, IERR)
      CALL ZEXIST (1, PHNAME, NSIZE, IERR)
      POTERR = 101
      TGNEW = .FALSE.
      IF (IERR.EQ.1) THEN
         NSIZE = 64
         CALL ZCREAT (1, PHNAME, NSIZE, F, LSIZE, IERR)
         IF (IERR.EQ.0) NSIZE = LSIZE
         TGNEW = .TRUE.
         END IF
      IF (IERR.GE.2) THEN
         WRITE (MSGTXT,1100) IERR
         CALL MSGWRT (6)
         GO TO 980
         END IF
      CALL ZOPEN (LUNTG, FINDTG, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         FINDTG = 0
         GO TO 980
         END IF
C                                       Init file record 1
      IPRBUF(1) = NSIZE
      IPRBUF(2) = 0
      IPRBUF(3) = 0
      IPRBUF(4) = 0
      IPRBUF(5) = NBLOCK
      POTERR = 50
      NWPL = 5
      NLPR = 51
C                                       Read old record 1
      IF (.NOT.TGNEW) THEN
         CALL ZFIO ('READ', LUNTG, FINDTG, 1, IPRBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         NBLOCK = MAX (8, IPRBUF(5))
         END IF
C                                       Search for task name
      LREC = 1
      NTASK = IPRBUF(2)
C                                       Self protection
      IF ((NTASK.GE.0) .AND. (NTASK.LE.508) .AND. (IPRBUF(5).EQ.NBLOCK)
     *   .AND. (IPRBUF(1).GT.0) .AND. (IPRBUF(1).LE.4090)) GO TO 120
         WRITE (MSGTXT,1115) IPRBUF(1), IPRBUF(2)
         CALL MSGWRT (8)
         TSBLK = -1143
         GO TO 160
 120  DO 130 JTASK = 1,NTASK
         IREC = JTASK / NLPR + 1
C                                       Read next rec
         IF (IREC.NE.LREC) THEN
            CALL ZFIO ('READ', LUNTG, FINDTG, IREC, IPRBUF, IERR)
            IF (IERR.NE.0) GO TO 980
            LREC = IREC
            END IF
         ITEMP = MOD (JTASK, NLPR) * NWPL + 1
         CALL H2CHR (8, 1, PARBUF(ITEMP), CTEST)
         IF (CTEST.EQ.ITASK) GO TO 140
 130     CONTINUE
C                                       Add task to directory
      JTASK = NTASK + 1
 140  IREC = JTASK / NLPR + 1
      I = MOD (JTASK, NLPR) * NWPL  +  1
      IF ((IREC.NE.LREC) .AND. (I.GT.1)) THEN
         CALL ZFIO ('READ', LUNTG, FINDTG, IREC, IPRBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         END IF
      CALL CHR2H (8, ITASK, 1, PARBUF(I))
      CALL CATIME (1, IPRBUF(I+2), ITIME)
      IPRBUF(I+4) = VERTYP
C                                       Save & get rec 1 back
      IF (IREC.GT.1) THEN
         CALL ZFIO ('WRIT', LUNTG, FINDTG, IREC, IPRBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         CALL ZFIO ('READ', LUNTG, FINDTG, 1, IPRBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         END IF
C                                       Save task count, expand file
      IPRBUF(2) = MAX (NTASK, JTASK)
      TSBLK = NBLOCK * (JTASK-1) + 11
      CALL CATIME (1, IPRBUF(3), ITIME)
      IF (TSBLK+NBLOCK-1.GT.IPRBUF(1)) THEN
         NREC = 16
         CALL ZEXPND (LUNTG, 1, PHNAME, NREC, IERR)
         IF (IERR.NE.0) GO TO 980
         IPRBUF(1) = IPRBUF(1) + NREC
         END IF
C                                       Return Record 1
      CALL ZFIO ('WRIT', LUNTG, FINDTG, 1, IPRBUF, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       open output file
 160  IF (BRANCH.EQ.1) THEN
         CALL ZPHFIL ('TD', 1, 0, 4, PHNAME, IERR)
         CALL ZOPEN (LUNTD, FINDTD, 1, PHNAME, F, T, T, IERR)
         POTERR = 101
         IF (IERR.NE.0) THEN
            FINDTD = 0
            GO TO 980
            END IF
         END IF
C                                       More self protection
      IF ((TSBLK.LT.11) .AND. (TSBLK.NE.-1143)) THEN
         WRITE (MSGTXT,1160) TSBLK
         CALL MSGWRT (8)
         TSBLK = -1143
         END IF
C                                      initial values
      JOFF = (IPOPS-1)*4 + 2
      CALL FILL (256, 0, IPRBUF)
      IPTR = 11
      JPTR = IPTR
      LPTR = IPTR
      LPTRMX = 256 * 4
      IPRBUF(1) = NLUSER
      IPRBUF(2) = NTVDEV
      IPRBUF(3) = NTKDEV
      IF ((ISBTCH.EQ.32000) .OR. (IPOPS.GT.NINTRN+1)) IPRBUF(2) = 0
      IF ((ISBTCH.EQ.32000) .OR. (IPOPS.GT.NINTRN+1)) IPRBUF(3) = 0
      IPRBUF(4) = MSGKIL
      IPRBUF(5) = ISBTCH
      IPRBUF(6) = DBGAIP
      CALL ADVERB ('QCREATE', 'I', 1, 1, I, RDUM, CDUM)
      IF (ERRNUM.NE.0) THEN
         MSGTXT = 'DO THE COMPRESS VERB TO ENABLE THE QCREATE ADVERB'
         CALL MSGWRT (6)
         ERRNUM = 0
      ELSE
         QCREAT = I
         END IF
      IPRBUF(7) = QCREAT
      IPRBUF(8) = 0
      PARBUF(IPTR-2) = DOWAIT
      CALL CHR2H (4, VERNAM, 1, PARBUF(IPTR-1))
      IF ((VERTYP.GE.1) .AND. (VERTYP.LE.4)) CALL CHR2H (4,
     *   CVER(VERTYP), 1, PARBUF(IPTR-1))
      IF ((VERTYP.GE.5) .AND. (VERTYP.LE.8)) CALL CHR2H (4,
     *   CVER(VERTYP-3), 1, PARBUF(IPTR-1))
      CALL COPY (256, IPRBUF, IPRGUF)
C                                       skip first 2 records
 180  CALL ZTREAD (LUNIN, FINDIN, JBUF, IERR)
      POTERR = 59
      IF (IERR.NE.0) GO TO 980
      IF (JBUF(1:1).EQ.';') GO TO 180
      IF (JBUF(1:8).EQ.'--------') THEN
         POTERR = 54
         GO TO 980
         END IF
 185  CALL ZTREAD (LUNIN, FINDIN, JBUF, IERR)
      IF (IERR.NE.0) GO TO 980
      IF (JBUF(1:1).EQ.';') GO TO 185
      IF (JBUF(1:8).EQ.'--------') THEN
         POTERR = 54
         GO TO 980
         END IF
C                                       loop for adverbs
 210  CALL ZTREAD (LUNIN, FINDIN, JBUF, IERR)
         IF (IERR.EQ.IEOF) GO TO 250
         POTERR = 59
         IF (IERR.NE.0) GO TO 980
         IF (JBUF(1:1).EQ.';') GO TO 210
         IF (JBUF(1:8).EQ.'--------') GO TO 250
         I = JTRIM (JBUF)
C                                       Decode adverb usage
         CODE = JBUF(COLSHO:COLSHO)
C                                       go tell get
         IF (CODE.EQ.'&') THEN
            ADVGET = .TRUE.
C                                       -- tell get
         ELSE IF (CODE.EQ.'%') THEN
            ADVGET = .TRUE.
            IF (BRANCH.NE.6) GO TO 210
C                                       go ---- get
         ELSE IF (CODE.EQ.'$') THEN
            ADVGET = .TRUE.
            IF (BRANCH.EQ.6) GO TO 210
C                                       -- ---- get
         ELSE IF (CODE.EQ.'@') THEN
            ADVGET = .TRUE.
            GO TO 210
C                                       -- tell ---
         ELSE IF (CODE.EQ.'?') THEN
            IF (BRANCH.NE.6) GO TO 210
C                                       go ---- ---
         ELSE IF (CODE.EQ.' ') THEN
            IF (BRANCH.EQ.6) GO TO 210
C                                       go tell --- code '*'
         ELSE IF (CODE.NE.'*') THEN
            MSGTXT = 'WRONG ADVERB CODE IN INPUTS'
            CALL MSGWRT (6)
            GO TO 210
            END IF
         JBUF(COLSHO:COLSHO) = ' '
         KARBUF = JBUF
         KBPTR = NMATCC (1, ' ', KARBUF)
C                                       comment
         IF (KBPTR.GE.COLLBN) GO TO 210
C                                       adverb: is it system value?
         SYSLIM(1) = -1.0
         SYSLIM(2) = -2.0
         DO 212 I = 1,NSYSAD
            IF (KARBUF(1:8).EQ.SYSADV(I)) THEN
               IF (I.LE.NSYSTA) THEN
                  SYSLIM(2) = NTAPED
               ELSE IF (I.LE.NSYSTA+NSYSDA) THEN
                  SYSLIM(2) = NVOL
               ELSE IF (I.LE.NSYSTA+NSYSDA+NSYSCH) THEN
                  SYSLIM(2) = MAXCHA
               ELSE IF (I.LE.NSYSTA+NSYSDA+NSYSCH+NSYSIM) THEN
                  SYSLIM(2) = MAXIMG
               ELSE
                  SYSLIM(2) = NINTRN + 1 + NBATQS
                  IF (SYSADV(I).EQ.'BATQUE') SYSLIM(2) = NBATQS
                  IF (SYSADV(I).EQ.'TVCHAN') SYSLIM(2) = NGRAY
                  IF (SYSADV(I).EQ.'TV2CHAN') SYSLIM(2) = NGRAY
                  IF (SYSADV(I).EQ.'GRCHAN') SYSLIM(2) = NGRAPH*11
                  IF (SYSADV(I).EQ.'GR2CHAN') SYSLIM(2) = NGRAPH
                  IF (SYSADV(I).EQ.'TVLEVS') SYSLIM(2) = OFMINP
                  IF (SYSADV(I).EQ.'TVXY') SYSLIM(2) =
     *               MAX (MAXXTV(1), MAXXTV(2))
                  IF (SYSADV(I).EQ.'TVCORN') SYSLIM(2) =
     *               MAX (MAXXTV(1), MAXXTV(2))
                  END IF
               GO TO 213
               END IF
 212        CONTINUE
C                                       get the adverb
 213     CALL GETFLD
         IF (ERRNUM.EQ.2) THEN
            MSGTXT = 'MISSING ADVERB: TRY A ''COMPRESS'' OR '
     *         // '''HELP NOADVERB'' FOR INFO'
            CALL MSGWRT (8)
            END IF
         IF (ERRNUM.NE.0) GO TO 980
         ITAG = TAG
         ILOC = LOCSYM
         ITYPE = SYTYPE
         LIM(1) = LMIN
         LIM(2) = LMAX
C                                       Type 7 is a string.
         IF (ITYPE.EQ.7) GO TO 225
         POTERR = 8
C                                       Type 1 is a scalar, 2=array.
         IF ((SYTYPE.NE.1) .AND. (SYTYPE.NE.2)) GO TO 980
C                                       find limits: reals, arrays
 215     KBPTR = NMATCC (KBPTR, ' ', KARBUF)
         IF (KBPTR.LT.COLCOM) THEN
            I = 2
            IF (KBPTR.LT.COLUBN) I = 1
            CALL GETFLD
            IF (ERRNUM.NE.0) GO TO 980
C                                       negative
            IF (TAG.EQ.6) THEN
               CALL GETFLD
               IF (ERRNUM.NE.0) GO TO 980
               LIM(I) = -C(TAG)
            ELSE
               LIM(I) = C(TAG)
               END IF
            GO TO 215
            END IF
C                                       values to buffer
 225     ISIZE = 1
         IF (ITYPE.NE.1) ISIZE = K(K(ILOC+3))
         IF (SYSLIM(2).GE.SYSLIM(1)) LIM(2) = SYSLIM(2)
C                                       Check character strings
         IF (ITYPE.EQ.7) THEN
            CALL VERSTR (ILOC)
            IF ((ERRNUM.NE.0).AND.(BRANCH.EQ.1)) GO TO 980
            IF ((ERRNUM.NE.0).AND.(BRANCH.GT.1)) GO TO 980
            END IF
C                                       output TGET adverb name, type
         ADTYPE = 10 * ISIZE + ITYPE
         CALL CHR2H (8, KARBUF, 1, HNAME)
         DO 230 I = 1,3
            HARGUF(JPTR) = HNAME(I)
            JPTR = JPTR + 1
            IF (JPTR.GT.256) THEN
               IF ((TSBLK.GE.4) .AND. (BRANCH.NE.6)) CALL ZFIO ('WRIT',
     *            LUNTG, FINDTG, TSBLK, IPRGUF, IERR)
               IF (IERR.NE.0) GO TO 980
               TSBLK = TSBLK + 1
               CALL FILL (256, 0, IPRGUF)
               JPTR = 1
               END IF
 230        CONTINUE
         DO 245 I = 1,ISIZE
            IF (ITYPE.EQ.7) THEN
               HARBUF(IPTR) = CH(ITAG)
               HARGUF(JPTR) = CH(ITAG)
            ELSE
               PARBUF(IPTR) = C(ITAG)
               PARGUF(JPTR) = C(ITAG)
C                                       Check value range
               CALL BOUNDS (C(ITAG), C(ITAG), LIM, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1235) JBUF(1:10)
                  CALL MSGWRT (6)
                  POTERR = 32
                  GO TO 980
                  END IF
               END IF
            ITAG = ITAG + 1
            IPTR = IPTR + 1
            JPTR = JPTR + 1
            LPTR = LPTR + 1
            IF (LPTR.GT.LPTRMX) THEN
               WRITE (MSGTXT,1240)
               CALL MSGWRT (8)
               POTERR = 32
               GO TO 980
               END IF
            IF (IPTR.GT.256) THEN
               IPTR = 1
               IF ((BRANCH.EQ.1) .OR. (BRANCH.EQ.6)) CALL ZFIO ('WRIT',
     *            LUNTD, FINDTD, JOFF, IPRBUF, IERR)
               POTERR = 50
               IF (IERR.NE.0) GO TO 980
               JOFF = JOFF + 1
               CALL FILL (256, 0, IPRBUF)
               END IF
            IF (JPTR.GT.256) THEN
               IF ((TSBLK.GE.4) .AND. (BRANCH.NE.6)) CALL ZFIO ('WRIT',
     *            LUNTG, FINDTG, TSBLK, IPRGUF, IERR)
               IF (IERR.NE.0) GO TO 980
               TSBLK = TSBLK + 1
               CALL FILL (256, 0, IPRGUF)
               JPTR = 1
               END IF
 245        CONTINUE
         GO TO 210
C
C                                       clear last block
 250  IF (IPTR.GT.1) THEN
         IERR = 0
         IF ((BRANCH.EQ.1) .OR. (BRANCH.EQ.6)) CALL ZFIO ('WRIT', LUNTD,
     *      FINDTD, JOFF, IPRBUF, IERR)
         POTERR = 50
         IF (IERR.NE.0) GO TO 980
         END IF
      IF (JPTR.GT.1) THEN
         IERR = 0
         POTERR = 50
         IF ((TSBLK.GE.4) .AND. (BRANCH.NE.6)) CALL ZFIO ('WRIT', LUNTG,
     *      FINDTG, TSBLK, IPRGUF, IERR)
         IF (IERR.NE.0) GO TO 980
         END IF
C                                       Close files
      CALL ZTCLOS (LUNIN, FINDIN, IERR)
      IF (BRANCH.NE.6) THEN
         CALL ZCLOSE (LUNTG, FINDTG, IERR)
         FINDTG = 0
      ELSE
         CALL ZCLOSE (LUNTD, FINDTD, IERR)
         FINDTD = 0
         END IF
      FINDIN = 0
      IF (BRANCH.NE.1) GO TO 999
C                                       Only GO from here on
C                                       DOWAIT changes ?
C      IF ((DOWAIT.LE.0.0) .AND. (ADVGET)) THEN
C         JOFF = (IPOPS-1)*NBLOCK + 2
C         CALL ZFIO ('READ', LUNTD, FINDTD, JOFF, IPRBUF, IERR)
C         POTERR = 50
C         IF (IERR.NE.0) GO TO 980
C         DOWAIT = 1.0
C         PARBUF(9) = DOWAIT
C         CALL ZFIO ('WRIT', LUNTD, FINDTD, JOFF, IPRBUF, IERR)
C         POTERR = 50
C         IF (IERR.NE.0) GO TO 980
C         END IF
C                                        pointer block (#1)
      CALL ZFIO ('READ', LUNTD, FINDTD, 1, IPRBUF, IERR)
      POTERR = 50
      IF (IERR.NE.0) GO TO 980
      ITEMP = 5*(IPOPS-1)
      CALL CHR2H (8, ITASK, 1, PARBUF(1+ITEMP))
      IPRBUF(3+ITEMP) = -999
      IPRBUF(4+ITEMP) = 0
      IPRBUF(5+ITEMP) = 0
      IPRBUF(256) = 4
      CALL ZFIO ('WRIT', LUNTD, FINDTD, 1, IPRBUF, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       close task data file
      CALL ZCLOSE (LUNTD, FINDTD, IERR)
      FINDTD = 0
C                                       task already running
      CALL BLDTNM (ITASK, IPOPS, ANAME, IERR)
      POTERR = 43
      IF (IERR.NE.0) GO TO 980
      CALL FILL (4, 0, PID)
      PID(1) = NLUSER
      CALL ZTACTQ (ANAME, PID, ACTIVE, IERR)
      IF (IERR.NE.0) GO TO 980
      POTERR = 42
      IF (ACTIVE) GO TO 980
C                                        close message file
      CALL MSGWRT (-1)
C                                        close input terminal
      IF ((NPOPS.LE.NINTRN+1) .AND. (ISBTCH.NE.32000)) THEN
         CALL LSERCH ('SRCH', LUNTTY, FINDTT, F, IERR)
         POTERR = 58
         IF (IERR.NE.0) GO TO 980
         CALL ZCLOSE (LUNTTY, FINDTT, IERR)
         IF (IERR.NE.0) GO TO 980
         END IF
C                                        activate the task
      CALL ZACTV8 (ITASK, IPOPS, AVERSN, PID, IERR)
      POTERR = 101
      IF (IERR.NE.0) GO TO 950
      IF (ADVGET) THEN
         MSGTXT = 'Waiting for returned adverbs'
         CALL MSGWRT (2)
         END IF
C                                       Wait for resumption through
C                                       TD file or abort of task
      TDL = 1.25
      IF (DOWAIT.GT.0.0) TDL = 2.01
      IF (NPOPS.GT.NINTRN+1) TDL = 15.
      IF (ISBTCH.EQ.32000) TDL = 15.
      LDOWT = TDL.GT.2.0
      IF (AIPSMK.GT.0.1) TDL = TDL / AIPSMK
      CALL TASKWT (ANAME, IPOPS, PID, LDOWT, TDL, IPRBUF, IRETCD, IERR)
C                                       ABORT not resume via TD
      IF (IRETCD.EQ.-999) CALL DESCR (IPRBUF)
C                                        reopen terminal
      IF ((NPOPS.LE.NINTRN+1) .AND. (ISBTCH.NE.32000))
     *   CALL ZOPEN (LUNTTY, FINDTT, 1, PHNAME, F, T, T, IERR)
C                                       resumption message
      MSGTXT = 'Resumes'
      CALL MSGWRT (2)
      IF (IRETCD.NE.0) THEN
         POTERR = 101
C                                       abort batch
         IF ((NPOPS.GT.NINTRN+1) .OR. (ISBTCH.EQ.32000)) POTERR = 100
         WRITE (MSGTXT,1285) IRETCD
         IF (IRETCD.NE.-999) CALL MSGWRT (9)
         GO TO 980
         END IF
C                                       get returned adverbs
      IF (ADVGET) THEN
         CALL ZTOPEN (LUNIN, FINDIN, 1, HHNAME, ITASK, AVERSN, T,
     *      IERROR)
         POTERR = 31
         IF (IERROR(1).NE.0) THEN
            FINDIN = 0
            GO TO 980
            END IF
         CALL ZPHFIL ('TD', 1, 0, 4, PHNAME, IERR)
         CALL ZOPEN (LUNTD, FINDTD, 1, PHNAME, F, T, T, IERR)
         POTERR = 101
         IF (IERR.NE.0) THEN
            FINDTD = 0
            GO TO 980
            END IF
         JOFF = (IPOPS-1)*4 + 2
         CALL ZFIO ('READ', LUNTD, FINDTD, JOFF, IPRBUF, IERR)
         IF (IERR.NE.0) THEN
            POTERR = 50
            GO TO 980
            END IF
         IPTR = 11
         LPTR = IPTR
         LPTRMX = 256 * 4
C                                       skip first 2 records
 255     CALL ZTREAD (LUNIN, FINDIN, JBUF, IERR)
         POTERR = 59
         IF (IERR.NE.0) GO TO 980
         IF (JBUF(1:1).EQ.';') GO TO 255
         IF (JBUF(1:8).EQ.'--------') THEN
            POTERR = 54
            GO TO 980
            END IF
 260     CALL ZTREAD (LUNIN, FINDIN, JBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         IF (JBUF(1:1).EQ.';') GO TO 260
         IF (JBUF(1:8).EQ.'--------') THEN
            POTERR = 54
            GO TO 980
            END IF
C                                       loop for adverbs
 265     CALL ZTREAD (LUNIN, FINDIN, JBUF, IERR)
            IF (IERR.EQ.IEOF) GO TO 290
            POTERR = 59
            IF (IERR.NE.0) GO TO 980
            IF (JBUF(1:1).EQ.';') GO TO 265
            IF (JBUF(1:8).EQ.'--------') GO TO 290
            I = JTRIM (JBUF)
C                                       Decode adverb usage
            CODE = JBUF(COLSHO:COLSHO)
C                                       get codes only
            IF ((CODE.NE.'&') .AND. (CODE.NE.'%') .AND.(CODE.NE.'$')
     *         .AND. (CODE.NE.'@')) GO TO 265
            JBUF(COLSHO:COLSHO) = ' '
            KARBUF = JBUF
            KBPTR = NMATCC (1, ' ', KARBUF)
C                                       comment
            IF (KBPTR.GE.COLLBN) GO TO 265
C                                       adverb
            CALL GETFLD
            IF (ERRNUM.NE.0) GO TO 980
            ITAG = TAG
            ILOC = LOCSYM
            ITYPE = SYTYPE
C                                       Type 7 is a string.
            POTERR = 8
C                                       Type 1 is a scalar, 2=array.
            IF ((SYTYPE.NE.1) .AND. (SYTYPE.NE.2) .AND. (SYTYPE.NE.7))
     *         GO TO 980
            ISIZE = 1
            IF (ITYPE.NE.1) ISIZE = K(K(ILOC+3))
            DO 270 I = 1,ISIZE
               IF (ITYPE.EQ.7) THEN
                  CH(ITAG) = HARBUF(IPTR)
               ELSE
                  C(ITAG) = PARBUF(IPTR)
                  END IF
               ITAG = ITAG + 1
               IPTR = IPTR + 1
               IF (IPTR.GT.256) THEN
                  IPTR = 1
                  JOFF = JOFF + 1
                  CALL ZFIO ('READ', LUNTD, FINDTD, JOFF, IPRBUF, IERR)
                  IF (IERR.NE.0) THEN
                     POTERR = 50
                     GO TO 980
                     END IF
                  END IF
 270           CONTINUE
C                                       Check character strings
            IF (ITYPE.EQ.7) THEN
               CALL VERSTR (ILOC)
               IF (ERRNUM.NE.0) GO TO 980
               END IF
            GO TO 265
C                                       Done !
 290     POTERR = 0
         CALL ZTCLOS (LUNIN, FINDIN, IERR)
         CALL ZCLOSE (LUNTD, FINDTD, IERR)
         FINDIN = 0
         FINDTD = 0
         END IF
      GO TO 999
C-----------------------------------------------------------------------
C                                        SPY
C                                        list running tasks
C                                        Z routines do actual lists now
C-----------------------------------------------------------------------
 300  CALL ADVERB ('DOALL', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ZTQSPY (RDUM, IPRBUF)
      IF (ERRNUM.NE.0) GO TO 980
      GO TO 999
C-----------------------------------------------------------------------
C                                        WAITTASK
C                                        wait for task to finish
C-----------------------------------------------------------------------
 400  CALL ADVERB ('NUMTELL', 'I', 1, 0, IPOPS, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IF (IPOPS.LT.1) IPOPS = NPOPS
      CALL BLDTNM (ITASK, IPOPS, ANAME, IERR)
      POTERR = 43
      IF (IERR.NE.0) GO TO 980
      I = 0
      CALL FILL (4, 0, PID)
      PID(1) = NLUSER
 405  CALL ZTACTQ (ANAME, PID, ACTIVE, IERR)
      IF (IERR.NE.0) GO TO 980
C                                        delay & try again
      IF (.NOT.ACTIVE) GO TO 410
         TSKDLY = 2.0
         IF (AIPSMK.GT.0.1) TSKDLY = 2.0 / SQRT (AIPSMK)
         CALL ZDELAY (TSKDLY, IERR)
         POTERR = 44
         IF (IERR.NE.0) GO TO 980
         I = 1
         GO TO 405
C                                        done
 410  CONTINUE
         IF (I.EQ.1) WRITE (MSGTXT,1410) ANAME
         IF (I.NE.1) WRITE (MSGTXT,1411) ANAME
         CALL MSGWRT (3)
         GO TO 999
C-----------------------------------------------------------------------
C                                        ABORTASK
C                                        abort specified task
C-----------------------------------------------------------------------
 500  CALL ADVERB ('NUMTELL', 'I', 1, 0, IPOPS, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IF (IPOPS.LT.1) IPOPS = NPOPS
      CALL BLDTNM (ITASK, IPOPS, ANAME, IERR)
      POTERR = 43
      IF (IERR.NE.0) GO TO 980
      CALL FILL (4, 0, PID)
      PID(1) = NLUSER
      CALL ZTACTQ (ANAME, PID, ACTIVE, IERR)
      IF (IERR.NE.0) GO TO 980
C                                        already gone
      IF (ACTIVE) GO TO 510
         WRITE (MSGTXT,1500) ANAME
         CALL MSGWRT (7)
         GO TO 999
C                                        kill it!
 510  CALL ZTABOR (ANAME, PID, IERR)
      IF (IERR.EQ.0) GO TO 520
         WRITE (MSGTXT,1510) ANAME, IERR
         CALL MSGWRT (7)
         GO TO 999
C                                       Clear scratch if possible.
 520  TDL = 1.0
      IF (AIPSMK.GT.0.5) TDL = TDL / SQRT (AIPSMK)
      I = 0
 525  CALL ZDELAY (TDL, IERR)
         CALL ZTACTQ (ANAME, PID, ACTIVE, IERR)
         IF (IERR.NE.0) GO TO 980
         I = I + 1
         IF ((ACTIVE) .AND. (I.LT.11)) GO TO 525
      CALL DESCR (IPRBUF)
      GO TO 999
C-----------------------------------------------------------------------
C                                       TELL
C                                       running task some parameters
C-----------------------------------------------------------------------
 600  IF (WASDEF) THEN
         CALL ADVRBS ('TASK', 'C', 1, 8, IDUM, RDUM, ITASK)
         IF (ERRNUM.NE.0) GO TO 980
         END IF
      CALL ADVERB ('NUMTELL', 'I', 1, 0, IPOPS, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IF (IPOPS.LT.1) IPOPS = NPOPS
      CALL ZTOPEN (LUNIN, FINDIN, 1, HHNAME, ITASK, AVERSN, T, IERROR)
      POTERR = 31
      IF (IERROR(1).NE.0) THEN
         FINDIN = 0
         GO TO 980
         END IF
C                                       Is the task active?
      CALL BLDTNM (ITASK, IPOPS, ANAME, IERR)
      POTERR = 43
      IF (IERR.NE.0) GO TO 980
      CALL FILL (4, 0, LPID)
      LPID(1) = NLUSER
      CALL ZTACTQ (ANAME, LPID, ACTIVE, IERR)
      IF (IERR.NE.0) GO TO 980
      POTERR = 101
      IF (ACTIVE) GO TO 610
         WRITE (MSGTXT,1500) ANAME
         CALL MSGWRT (7)
         GO TO 980
C                                       Open data file
 610  CALL ZPHFIL ('TC', 1, 0, 1, PHNAME, IERR)
      CALL ZOPEN (LUNTD, FINDTD, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         FINDTG = 0
         GO TO 980
         END IF
      IREC = (IPOPS - 1) / 2 + 1
      IXL = (IPOPS + 1 - 2 * IREC) * 128 + 1
      CALL ZFIO ('READ', LUNTD, FINDTD, IREC, IPRBUF, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Check/clear slots, find 1
      ITEMP = 0
 611  ITEMP = ITEMP + 1
      IX = IXL - 8
      IXH = 0
      DO 620 I = 1,16
         IX = IX + 8
         OK(I) = .FALSE.
         ACTIVE = .FALSE.
         IF (IPRBUF(IX).EQ.0) GO TO 615
         CALL H2CHR (8, 1, PARBUF(IX), CTEST)
         IF (CTEST.EQ.' ') GO TO 615
         IF ((IPRBUF(IX+4).GT.0) .AND. (IPRBUF(IX+4).NE.NLUSER) .AND.
     *      (ITEMP.EQ.1)) GO TO 620
         CALL BLDTNM (CTEST, IPOPS, ANAME, IERR)
         IF (IERR.EQ.0) THEN
            CALL FILL (4, 0, PID)
            PID(1) = IPRBUF(IX+4)
            PID(2) = IPRBUF(IX+6)
            IF (PID(1).LE.0) PID(1) = NLUSER
            CALL ZTACTQ (ANAME, PID, ACTIVE, IERR)
            END IF
 615     IF ((.NOT.ACTIVE) .OR. (IERR.NE.0)) THEN
            CALL FILL (8, 0, IPRBUF(IX))
            OK(I) = .TRUE.
            IF ((I.EQ.1) .OR. (.NOT.OK(I-1))) IXH = IX
            END IF
 620     CONTINUE
      IF (IXH.GT.0) GO TO 630
         IF (ITEMP.LT.2) GO TO 611
            WRITE (MSGTXT,1620)
            CALL MSGWRT (7)
            GO TO 980
C                                       Install task
 630  CALL CHR2H (8, ITASK, 1, PARBUF(IXH))
      CALL CATIME (1, IPRBUF(IXH+2), ITIME)
      CALL ADVERB ('OPTELL', 'C', 1, 4, IDUM, RDUM, OPTELL)
      IPRBUF(IXH+4) = NLUSER
      CALL CHR2H (4, OPTELL, 1, PARBUF(IXH+5))
      IPRBUF(IXH+6) = LPID(2)
      IPRBUF(IXH+7) = 0
      CALL ZFIO ('WRIT', LUNTD, FINDTD, IREC, IPRBUF, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       data parms
      JOFF = 19 + (IXH-IXL)/8 + 16 * (IPOPS-1)
      TSBLK = -1143
      IPTR = 2
      LPTR = 2
      CALL FILL (256, 0, IPRBUF)
      CALL CHR2H (4, OPTELL, 1, PARBUF(1))
      LPTRMX = 256
      GO TO 180
C-----------------------------------------------------------------------
C                                       STQUEUE
C                                       show queue of waiting TELLS
C-----------------------------------------------------------------------
 700  CALL ADVERB ('NUMTELL', 'I', 1, 0, IPOPS, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      CALL ADVERB ('DOALL', 'R', 1, 0, IDUM, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IF ((RDUM.GT.0.0) .OR. (IPOPS.LE.0) .OR.
     *   (IPOPS.GT.NINTRN+1+NBATQS)) THEN
         IYL = 1
         IYH = NINTRN
         IF (NBATQS.GT.0) IYH = NINTRN + 1 + NBATQS
      ELSE
         IYL = IPOPS
         IYH = IPOPS
         END IF
      POTERR = 50
      CALL ZPHFIL ('TC', 1, 0, 1, PHNAME, IERR)
      CALL ZOPEN (LUNTG, FINDTG, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         FINDTG = 0
         GO TO 980
         END IF
      LREC = 0
      CALL ZTIME (ITIME(4))
      CALL ZDATE (ITIME(1))
      CALL TIMDAT (ITIME(4), ITIME(1), ATIME, ADATE)
      WRITE (MSGTXT,1710) IYL, IYH, ADATE, ATIME
      CALL REFRMT (MSGTXT, '_', I)
      CALL MSGWRT (2)
      WRITE (MSGTXT,1711)
      CALL MSGWRT (2)
      DO 730 IY = IYL,IYH
         IREC = (IY - 1) / 2 + 1
         IF (IREC.EQ.LREC) GO TO 715
            CALL ZFIO ('READ', LUNTG, FINDTG, IREC, IPRBUF, IERR)
            IF (IERR.NE.0) GO TO 980
            LREC = IREC
 715     IXL = (IY + 1 - 2 * LREC) * 128 + 1
         IX = IXL - 8
         DO 725 I = 1,16
            IX = IX + 8
            IF (IPRBUF(IX).EQ.0) GO TO 725
            CALL H2CHR (8, 1, PARBUF(IX), ITASK)
            IF (ITASK.EQ.' ') GO TO 725
            IF (IPRBUF(IX+4).LE.0) GO TO 725
               CALL CATIME (2, IPRBUF(IX+2), ITIME)
               CALL TIMDAT (ITIME(4), ITIME(1), ATIME, ADATE)
               CTEST = ' '
               CALL BLDTNM (ITASK, IY, ANAME, IERR)
               IF (IERR.NE.0) GO TO 720
                  CALL FILL (4, 0, PID)
                  PID(1) = IPRBUF(IX+4)
                  PID(2) = IPRBUF(IX+6)
                  IF (PID(1).LE.0) PID(1) = NLUSER
                  CALL ZTACTQ (ANAME, PID, ACTIVE, IERR)
 720           CALL H2CHR (4, 1, PARBUF(IX+5), CTEMP)
               IF ((.NOT.ACTIVE) .OR. (IERR.NE.0)) CTEST = '****'
               CALL ZEHEX (IY, 1, POPSNO)
               WRITE (MSGTXT,1720) ITASK, POPSNO, ADATE, ATIME,
     *            IPRBUF(IX+4), CTEMP, CTEST
               CALL MSGWRT (2)
               IF (CTEST.EQ.'****') CALL FILL (8, 0, IPRBUF(IX))
 725        CONTINUE
         CALL ZFIO ('WRIT', LUNTG, FINDTG, LREC, IPRBUF, IERR)
         IF (IERR.NE.0) GO TO 980
 730     CONTINUE
      CALL ZCLOSE (LUNTG, FINDTG, IERR)
      FINDTG = 0
      POTERR = 0
      GO TO 980
C-----------------------------------------------------------------------
C                                       SETDEBUG
C                                       set the parameter DBGAIP
C-----------------------------------------------------------------------
 800  IF (SP.GT.0) THEN
         POTERR = 8
         IF ((SP.GE.4) .AND. (STACK(SP).EQ.2)) GO TO 980
         DBGAIP = IROUND (V(SP))
         SP = SP - 1
      ELSE
         DBGAIP = 0
         END IF
      GO TO 999
C-----------------------------------------------------------------------
C                                       PARALLEL
C                                       Set number of threads or
C                                       processors for subsequent
C                                       parallel tasks
C-----------------------------------------------------------------------
C                                       Get number
  900 IF (SP.GT.0) THEN
C                                       Syntax error - argument is array
         IF ((SP.GE.4) .AND. (STACK(SP).EQ.2)) THEN
            POTERR = 8
            GO TO 980
         ELSE
            NPROC = NINT (V(SP))
            SP = SP - 1
            END IF
      ELSE
         NPROC = 0
         END IF
      CALL ZPARAL (NPROC)
      WRITE (MSGTXT,1900) NPROC
      CALL MSGWRT (5)
      GO TO 999
C-----------------------------------------------------------------------
C                                       errors: close files
 950  IF ((NPOPS.LE.NINTRN+1) .AND. (ISBTCH.NE.32000))
     *   CALL ZOPEN (LUNTTY, FINDTT, 1, PHNAME, F, T, T, IERR)
C                                       POPS error management
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
      IF (FINDTD.GT.0) CALL ZCLOSE (LUNTD, FINDTD, IERR)
      IF (FINDTG.GT.0) CALL ZCLOSE (LUNTG, FINDTG, IERR)
      IF (FINDIN.GT.0) CALL ZTCLOS (LUNIN, FINDIN, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CANNOT DO THIS WITH AIPS, AIPSC, OR AIPSB')
 1100 FORMAT ('UNABLE TO CREATE ADVERB SAVE FILE.  IER=',I7)
 1115 FORMAT ('WARNING: TGET FILE HAS BEEN DAMAGED:',2I8)
 1160 FORMAT ('SOMEHOW TASK SAVE REC #',I7,' WAS REQUESTED & IGNORED')
 1235 FORMAT ('ERROR IS IN VALUE OF ADVERB ',A10)
 1240 FORMAT ('TOO MANY PARAMETERS FOR COMM FILE --- SEE THE',
     *   ' PROGRAMMER')
 1285 FORMAT ('RETURN CODE',I7,' RECEIVED: STOPPING')
 1410 FORMAT ('Task ',A,' has finished')
 1411 FORMAT (A,' was not found to be running')
 1500 FORMAT ('TASK ',A,' WAS NOT RUNNING')
 1510 FORMAT ('TASK ',A,' WAS NOT KILLED: ERR #',I5)
 1620 FORMAT ('NO ROOM: 16 TELLS ALREADY WAITING')
 1710 FORMAT ('Pending TELL operations on POPS',I3,' -',I3,' at ',A12,
     *   A8)
 1711 FORMAT ('Task',13X,'Queued',11X,'User',4X,'OP',6X,'Error')
 1720 FORMAT (A5,A1,4X,A12,A8,4X,I4,4X,A4,5X,A4)
 1900 FORMAT ('Subsequent parallel tasks will use ', I3, ' threads')
      END

      SUBROUTINE COMPAR (N, K1, K2, LR)
C-----------------------------------------------------------------------
C! compares two integer arrays and returns .TRUE. if they are equal
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   COMPAR compares N integer words in K1 and K2.  LR is .TRUE. if
C      they are equal, .FALSE. otherwise
C   Inputs:  N      I        number of words to be copied
C            K1     I(>=N)   input array
C            K2     I(>=N)   2nd input array
C   Outputs: LR     L        Comparison value
C-----------------------------------------------------------------------
      INTEGER   I, N, K1(*), K2(*)
      LOGICAL   LR
C-----------------------------------------------------------------------
      LR = .FALSE.
      DO 10 I = 1,N
         IF (K1(I).NE.K2(I)) GO TO 999
 10      CONTINUE
      LR = .TRUE.
C
 999  RETURN
      END

LOCAL INCLUDE 'WIPER.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   NUMPRM
      PARAMETER (NUMPRM = 21)
C
      CHARACTER NAMEIN*12, CLAIN*6, XSOUR(30)*16
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XCALC(1), XSTOK(1),
     *   TVCATH(256)
      REAL   XSIN, XDISIN, XQUAL, XBAND, XFREQ, XFQID, XTIME(8),
     *   XANT(50), XBASE(50), XUVRA(2), XSUBA, XBCHAN, XECHAN, XNCHAV,
     *   XCHINC, XBIF, XEIF, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER,
     *   XFLAG, XFGOUT, XDOBND, XBPVER, XSMOTH(3), BPARM(10), XREFAN,
     *   XROTPA, XIMSIZ(2), XDOCEN, XDOALL, PRTLEV, XBADD(10)
      REAL      BUFF1(UVBFSS), TBEG, TFIN, XYSCL(3), XYOFF(3),
     *   RPARM(20), XYMIN(3), XYMAX(3), FINC(MAXIF), ROTATE,
     *   TVCATR(256), SCALXY(2)
      DOUBLE PRECISION FOFF(MAXIF), TVCATD(128)
      INTEGER   IAW1, IAW2, INC, SEQIN, DISKIN, LUNI, INDI, TYPEAX(2),
     *   NCH, VER, JBUFSZ, IANT(50), NANT, IBAS(50), NBAS, CNOIN,
     *   IFRQ, NFRQ, NSUBA, GRCHN, TVCHN, TVCORN(4), ISBAND(MAXIF),
     *   EXCLFQ(MAXIF,MAXFQ), CHINC, LABEL, FIXSCL, CSOU, SBUFF(512),
     *   REFANT, COUNT(3,3), FGVERI, FGVERO, TVSCR(MAXIMG), NBDCOR,
     *   MANT, MIF, TVCAT(256), NCHAN, FLGPIX, NSOU, NPOL, LCOR0,
     *   NFGWRI, BLFLAG(MAXANT,MAXANT), MBL, TTY(2), IPHASE, NCHAV,
     *   LTYPE, TVMAXX(2),NANAX, JANT(MAXANT), NSAMP
      LOGICAL   UVREV, ISUVR, MULTI, DESEL, DOTV, ONEIF, ONECHN,
     *   INVAX(2), ONEPOL, NOTCRS, ISCROS(4), SPHASE
      EQUIVALENCE (TVCAT, TVCATR, TVCATD, TVCATH)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XXSOUR, XQUAL,
     *   XCALC, XSTOK, XBAND, XFREQ, XFQID, XTIME, XANT, XBASE, XUVRA,
     *   XSUBA, XBCHAN, XECHAN, XNCHAV, XCHINC, XBIF, XEIF, XDOCAL,
     *   XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XFGOUT, XDOBND, XBPVER,
     *   XSMOTH, BPARM, XREFAN, XROTPA, XIMSIZ, XDOCEN, XDOALL, PRTLEV,
     *   XBADD
      COMMON /CHPARM/ NAMEIN, CLAIN, XSOUR
      COMMON /BUFRS/ BUFF1, SBUFF, RPARM, JBUFSZ
      COMMON /UVPCOM/ TVCAT, FOFF, FINC, ISBAND, TBEG, TFIN, XYSCL,
     *   XYOFF, XYMIN, XYMAX, UVREV, ISUVR, MULTI, DOTV, IAW1, IAW2,
     *   INC, SEQIN, DISKIN, LUNI, INDI, TYPEAX, NCH, VER, CNOIN, IFRQ,
     *   NFRQ, NSUBA, TVCHN, GRCHN, TVCORN, EXCLFQ, CHINC, LABEL,
     *   FIXSCL, CSOU, REFANT, ROTATE, COUNT, FGVERI, FGVERO, ONEPOL,
     *   NOTCRS, ONEIF, ONECHN, TVSCR, NBDCOR, MANT, MIF, NCHAN, FLGPIX,
     *   NPOL, INVAX, LCOR0, ISCROS, NFGWRI, MBL, TTY, IPHASE, SPHASE,
     *   SCALXY, NCHAV, LTYPE, TVMAXX, NANAX, JANT, NSAMP
      COMMON /BASSEL/ DESEL, IANT, NANT, IBAS, NBAS, NSOU, BLFLAG
LOCAL END
      PROGRAM WIPER
C-----------------------------------------------------------------------
C! WIPER plots uvdata like UVPLT, then edits them
C# EXT-appl Graphics Plot UV-util editing
C-----------------------------------------------------------------------
C;  Copyright (C) 2002-2017, 2019, 2021-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   WIPER plots uv data like UVPLT and then edits them.
C   Inputs:
C      INNAME                             Input UV file name (name)
C      INCLASS                            Input UV file name (class)
C      INSEQ             0.0     9999.0   Input UV file name (seq. #)
C      INDISK                             Input UV file disk unit #
C      SOURCES                            Sources to plot, ' '=>all.
C      QUAL            -10.0              Qualifier -1=>all
C      CALCODE                            Calibrator code '    '=>all
C      STOKES                             Stokes type to select.
C      SELBAND                            Bandwidth to select (kHz)
C      SELFREQ                            Frequency to select (MHz)
C      FREQID                             Freq. ID to select.
C      TIMERANG                           Time range to select
C      ANTENNAS                           Antennas to plot
C      BASELINE                           Baselines with ANTENNAS
C      UVRANGE                            UV range in kilolambda.
C      SUBARRAY          0.0     1000.0   Subarray, 0 => all
C      BCHAN             0.0     4096.0   1st spectral channel #
C      ECHAN             0.0     4096.0   Last spectral channel #
C      CHINC             0.0     4096.0   Increment in channel #
C      BIF                                Low IF number to plot
C      EIF                                Highest IF number to plot
C      DOCALIB          -1.0        2.0   If >0 calibrate data
C                                         = 2 calibrate weights
C      GAINUSE                            CAL (CL or SN) table to apply
C      DOPOL            -1.0       10.0   If >0 correct polarization.
C      BLVER                              BL table to apply.
C      FLAGVER                            Flag table version
C      DOBAND           -1.0       10.0   If >0 apply bandpass cal.
C                                         Method used depends on value
C                                         of DOBAND (see HELP file).
C      BPVER                              Bandpass table version
C      SMOOTH                             Smoothing function. See
C                                         HELP SMOOTH for details.
C      BPARM                              Control parameters
C                                         1 : X-axis type 0=>UV dist
C                                         2 : Y-axis type 0=>Ampl
C                                             1=> amplitude (Jy)
C                                             2=> phase (degrees)
C                                             3=> uv dist. (klambda)
C                                             4=> uv p.a. (deg N->E)
C                                             5=> time (IAT days)
C                                             6=> u (klambda)
C                                             7=> v (klambda)
C                                             8=> w (klambda)
C                                             9=> Re(Vis) (Jy)
C                                             10=> Im(Vis) (Jy)
C                                             11=> time (IAT hours)
C                                             12=> log(ampl)
C                                             13=> weight
C                                             14=> HA (hours)
C                                             15=> elevation (deg)
C                                             16=> parallactic angle
C                                             17=> uv dist. (klambda)
C                                                  along p.a.
C                                             18=> azimuth (deg)
C                                             19=> frequency
C                                         3 : > 0.0 => fixed scale
C                                             < 0.0 => fixed range
C                                         4 : Xmin (fixed scale)
C                                         5 : Xmax (fixed scale)
C                                         6 : Ymin (fixed scale)
C                                         7 : Ymax (fixed scale)
C                                         10: > 0 => plot auto-corr too
C      REFANT          0.0        90.0    > 0 => use REFANT for plot
C                                         types 14, 15, 16
C      ROTATE       -360.0       360.0    uv p.a. for projection
C                                         (deg N->E); type 17 only
C      BADDISK                            Disk to avoid for scratch.
C-----------------------------------------------------------------------
      INTEGER   NBL
      PARAMETER (NBL = 25)
C
      CHARACTER PRGM*6
      INTEGER   IERR, IRET, NX, NY, NWORDS, TVCORE(2), MALL(2), MBAD(2),
     *   MSOM(2), BLCORE(2)
      LONGINT   TVADDR, OFFALL, OFFBAD, OFFSOM, BLADDR
      LOGICAL   GETSCL
      INCLUDE 'WIPER.INC'
      REAL      XZY(3,MAXCIF)
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'WIPER '/
C-----------------------------------------------------------------------
C                                       Get input parameters and create
C                                       output file if nec.
      CALL WIPEIN (PRGM, NX, NY, IRET)
      IF (IRET.NE.0) GO TO 995
      FLGPIX = 0
C                                       Determine limits for all axes
C                                       if any autoscaling will be done.
      GETSCL = (FIXSCL.LE.0) .OR. (BPARM(4).GE.BPARM(5)) .OR.
     *   (BPARM(6).GE.BPARM(7))
      CALL SCAL (GETSCL, XZY, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Allocate memory
      NWORDS = (NX * NY - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, TVCORE, TVADDR, IRET)
      IF (IRET.NE.0) GO TO 995
      NWORDS = (NBL * NX * NY - 1) / 1024 + 1
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, BLCORE, BLADDR, IRET)
      IF (IRET.NE.0) GO TO 995
C                                       Plot data to image in memory
      CALL PLOTUV (NPOL, XZY, NX, NY, TVCORE(1+TVADDR), NBL,
     *   BLCORE(1+BLADDR), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Interactive editor
      CALL EDITUV (NX, NY, TVCORE(1+TVADDR), NBL, BLCORE(1+BLADDR),
     *   IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Reporting arrays
      NWORDS = (MANT * MANT * MIF * NPOL - 1) / 1024 + 1
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, MALL, OFFALL,
     *   IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, MBAD, OFFBAD,
     *   IRET)
      IF (IRET.EQ.0) CALL ZMEMRY ('GET ', TSKNAM, NWORDS, MSOM, OFFSOM,
     *   IRET)
      IF (IRET.EQ.0) THEN
         NWORDS = 1024 * NWORDS
         CALL FILL (NWORDS, 0, MALL(1+OFFALL))
         CALL FILL (NWORDS, 0, MBAD(1+OFFBAD))
         CALL FILL (NWORDS, 0, MSOM(1+OFFSOM))
      ELSE
         GO TO 990
         END IF
      NBDCOR = 0
C                                       Write flag table
      CALL WIPEUV (NX, NY, TVCORE(1+TVADDR), MANT, MIF, NPOL, XZY,
     *   MALL(1+OFFALL), MBAD(1+OFFBAD), MSOM(1+OFFSOM), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       report results
      IF (PRTLEV.GT.1.0) CALL REPORT (MANT, MIF, NPOL, MALL(1+OFFALL),
     *   MBAD(1+OFFBAD), MSOM(1+OFFSOM), NBDCOR, FLGPIX)
C                                       Report deeds to History file
      IF (IRET.EQ.0) CALL WIPEHI (NX, NY)
C                                       Clear memory
 990  CALL ZMEMRY ('FRAL', TSKNAM, NWORDS, TVCORE, TVADDR, IERR)
C                                       Close it down
 995  IRET = MAX (0, IRET)
      CALL DIE (IRET, SBUFF)
C
 999  STOP
      END
      SUBROUTINE WIPEIN (PRGM, NX, NY, IRET)
C-----------------------------------------------------------------------
C   WIPEIN gets input parameters for WIPER .
C   Inputs:
C      PRGM   C*6   Program name
C   Output:
C      NX     I     X dimension of plot in memory image
C      NY     I     Y dimension of plot in memory image
C      IRET   I     Error code: 0 => ok, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   NX, NY, IRET
C
      CHARACTER UTYPE*2, STAT*4
      INTEGER  IUSER, I, IERR, ITEMP, IROUND, NPARM, LUNTB, LUN, FQVER,
     *   NIF, NUMAN(513), JERR, JJ, J
      LOGICAL   TABLE, FITASC, F, MATCH, SNEXST, EXIST
      INCLUDE 'WIPER.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA F /.FALSE./
      DATA LUNTB /19/
C-----------------------------------------------------------------------
C                                       Init IO et al.
      TSKNAM = PRGM
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSOU = 0
      NSCR = 0
      NCFILE = 0
      IRET = 0
      VER = 10000
      NFGWRI = 0
      J = MAXANT * MAXANT
      CALL FILL (J, 0, BLFLAG)
C                                       Get input parameters.
      NPARM = 288
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMEI, SBUFF, IERR)
      RQUICK = .FALSE.
      IF (IERR.NE.0) THEN
         IRET = 8
         IF (IERR.NE.1) THEN
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
            END IF
         GO TO 999
         END IF
      IF ((NPOPS.GT.NINTRN) .OR. (NTVDEV.LE.0)) THEN
         IRET = 4
         IF (NPOPS.GT.NINTRN) THEN
            MSGTXT = 'TV TASKS ARE RESERVED FOR INTERACTIVE USERS'
         ELSE
            MSGTXT = 'YOU HAVE NOT BEEN ASSIGNED A TV'
            END IF
         CALL MSGWRT (8)
         GO TO 999
         END IF
      IRET = 5
C                                       Hollerith -> Char
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XSTOK, STOKES)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      DO 25 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), SOURCS(I))
         XSOUR(I) = ' '
 25      CONTINUE
      SELQUA = IROUND (XQUAL)
      I = IROUND (XDOALL)
      I = MAX (0, I)
      ONECHN = MOD (I, 2) .EQ. 0
      I = I / 2
      ONEIF = MOD (I, 2) .EQ. 0
      I = I / 2
      ONEPOL = MOD (I, 2) .EQ. 0
      I = I / 2
      NOTCRS = MOD (I, 2) .NE. 0
      LTYPE = -7
C                                       Crunch input parameters.
      IUSER = NLUSER
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      TVCHN = 1
      REFANT = XREFAN + 0.01
      ROTATE = XROTPA
      CALL FILL (4, 0, TVCORN)
C                                       Get CATBLK from file.
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   IUSER, STAT, SBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      IUSER
         GO TO 990
         END IF
C                                       OK, get the header now
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, 'REST', SBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1035) IERR
         GO TO 990
         END IF
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
      XDISIN = DISKIN
      XSIN = SEQIN
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = CNOIN
      FRW(NCFILE) = 0
C                                       Multi-source file?
      CALL MULSDB (CATBLK, MULTI)
      IF (MULTI) THEN
         CALL ISTAB ('SU', DISKIN, CNOIN, 1, LUNTB, SBUFF, TABLE, MULTI,
     *      FITASC, JERR)
         MULTI = MULTI .AND. (JERR.EQ.0)
         END IF
C                                       If calibrating, does SN exist
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      IF ((DOCAL) .AND. (.NOT.MULTI)) THEN
         CALL ISTAB ('SN', DISKIN, CNOIN, 1, LUNTB, SBUFF, TABLE,
     *      SNEXST, FITASC, IRET)
         IF ((.NOT.SNEXST) .OR. (IRET.NE.0)) THEN
            WRITE (MSGTXT,1050)
            CALL MSGWRT (8)
            DOCAL = .FALSE.
            END IF
         END IF
      XSIN = SEQIN
      XDISIN = DISKIN
      CALL COPY (256, CATBLK, CATUV)
      CALL COPY (256, CATBLK, TVCAT)
C                                       set flag versions
      CALL FNDEXT ('FG', CATBLK, I)
      FGVERI = IROUND (XFLAG)
      IF ((FGVERI.EQ.0) .OR. (FGVERI.GT.I)) FGVERI = I
      FGVERO = IROUND (XFGOUT)
      IF ((FGVERO.LE.0) .OR. (FGVERO.GT.I)) FGVERO = I + 1
      IF (FGVERO.LE.I) FGVERI = -ABS(FGVERI)
C                                       Get uv header info.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
      LCOR0 = ICOR0
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      UVRNG(1) = XUVRA(1)
      UVRNG(2) = XUVRA(2)
      IF (TYPUVD.GT.0) CALL RFILL (2, 0.0, UVRNG)
      IF (UVRNG(2).LE.0.0) UVRNG(2) = 1.0E10
      BCHAN = IROUND (XBCHAN)
      BCHAN = MAX (1, BCHAN)
      IF (BCHAN.GT.CATBLK(KINAX+JLOCF)) BCHAN = CATBLK(KINAX+JLOCF)
      ECHAN = IROUND (XECHAN)
      NCHAN = CATBLK(KINAX+JLOCF)
      IF (ECHAN.GT.CATBLK(KINAX+JLOCF)) ECHAN = CATBLK(KINAX+JLOCF)
      IF (ECHAN.LT.BCHAN) ECHAN = CATBLK(KINAX+JLOCF)
      NCHAV = IROUND (XNCHAV)
      NCHAV = MAX (1, MIN (ECHAN-BCHAN+1, NCHAV))
      CHINC = IROUND (XCHINC)
      IF (CHINC.LE.0) CHINC = NCHAV
      IF (NCHAV.GE.ECHAN-BCHAN+1) CHINC = NCHAV
      I = (ECHAN + 1 - BCHAN - NCHAV) / CHINC
      ECHAN = BCHAN + I * CHINC + NCHAV - 1
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      MIF = EIF - BIF + 1
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = F
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
C                                       Max antenna number
C                                       Allow multiple subarrays
      CALL FNDEXT ('AN', CATBLK, NSUBA)
      IF (NSUBA.GT.0) THEN
         CALL GETNAN (DISKIN, CNOIN, CATBLK, LUN, BUFF1, NUMAN, JERR)
         IF ((NSUBA.GT.0) .AND. (JERR.EQ.0)) THEN
            JJ = NUMAN(1)
            MANT = 0
            DO 80 J = 1,JJ
               MANT = MAX (MANT, NUMAN(J+1))
 80            CONTINUE
            END IF
         END IF
      IF ((SUBARR.GT.0) .AND. (SUBARR.LE.NSUBA)) NSUBA = 1
      NSUBA = MAX (1, NSUBA)
C                                       Allow multiple FQ ids
      NFRQ = 1
      IF ((FRQSEL.LE.0) .AND. (SELBAN.LE.0.0) .AND. (SELFRQ.LE.0D0))
     *   THEN
         FRQSEL = 1
C                                       Determine the number of FREQIDs.
         FQVER = 1
         CALL ISTAB ('FQ', DISKIN, CNOIN, FQVER, LUN, FQBUFF, TABLE,
     *      EXIST, FITASC, IERR)
         IF (EXIST .AND. (IERR.EQ.0)) THEN
            CALL FQINI ('READ', FQBUFF, DISKIN, CNOIN, FQVER, CATBLK,
     *         LUN, IFQRNO, FQKOLS, FQNUMV, NIF, IRET)
            IF (IRET.NE.0) GO TO 999
            NFRQ = FQBUFF(5)
            IF (NFRQ.GT.1) THEN
               WRITE (MSGTXT,1060) NFRQ
               CALL MSGWRT (3)
               END IF
            CALL TABIO ('CLOS', 0, IFQRNO, FQBUFF, FQBUFF, IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
         END IF
C                                       Find specified FQ id
      CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FRQSEL, IRET)
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1070)
         IRET = 1
         GO TO 990
         END IF
      IF (IRET.GT.0) GO TO 999
C                                        Retain auto-correlations ?
      DOACOR = BPARM(10).GT.0.
      DOXCOR = BPARM(10).LT.100.
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
      DO 85 I = 1,10
         IBAD(I) = IROUND (XBADD(I))
 85   CONTINUE
C                                       get image size
      NX = IROUND (XIMSIZ(1))
      NY = IROUND (XIMSIZ(2))
      IF (NX*NY.LE.0) THEN
         CALL TVOPEN (SBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         TVMAXX(1) = MAXXTV(1) - 7 * CSIZTV(1)
         TVMAXX(2) = MAXXTV(2) - 4 * CSIZTV(2)
         IF ((TVMAXX(1)-1)/2+1.GT.TVMAXX(2)) THEN
            NY = (TVMAXX(2)-1)/2
            NY = 2 * NY + 1
            NX = 2 * NY - 1
         ELSE
            NX = (TVMAXX(1)-1) / 2
            NX = 2 * NX + 1
            NY = (NX - 1) / 2 + 1
            END IF
         CALL TVCLOS (SBUFF, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Get axis types.
      TYPEAX(1) = IROUND (BPARM(1))
      TYPEAX(2) = IROUND (BPARM(2))
      INVAX(1) = TYPEAX(1).LT.0
      INVAX(2) = TYPEAX(2).LT.0
      TYPEAX(1) = ABS (TYPEAX(1))
      TYPEAX(2) = ABS (TYPEAX(2))
      IF (TYPEAX(1).EQ.6) INVAX(1) = .NOT.INVAX(1)
      IF (TYPEAX(2).EQ.6) INVAX(2) = .NOT.INVAX(2)
      FIXSCL = IROUND (BPARM(3))
C                                       Test type of plot
      NSAMP = 1
      IF (TYPUVD.LE.0) THEN
         IF ((TYPEAX(1).LT.1) .OR. (TYPEAX(1).GT.NUMPRM)) TYPEAX(1) = 3
         IF ((TYPEAX(2).LT.1) .OR. (TYPEAX(2).GT.NUMPRM)) TYPEAX(2) = 1
         IF ((TYPEAX(1).EQ.3) .OR. ((TYPEAX(1).GE.6) .AND.
     *      (TYPEAX(1).LE.8)) .OR. ((TYPEAX(1).EQ.17))) THEN
            BPARM(4) = BPARM(4) * 1.0E3
            BPARM(5) = BPARM(5) * 1.0E3
            END IF
         IF ((TYPEAX(2).EQ.3) .OR. ((TYPEAX(2).GE.6) .AND.
     *      (TYPEAX(2).LE.8)) .OR. ((TYPEAX(2).EQ.17))) THEN
            BPARM(6) = BPARM(6) * 1.0E3
            BPARM(7) = BPARM(7) * 1.0E3
            END IF
         IF ((TYPEAX(1).EQ.21) .OR. (TYPEAX(2).EQ.21)) NSAMP = 2
      ELSE
         IF ((TYPEAX(1).LT.1) .OR. (TYPEAX(1).GT.NUMPRM)) TYPEAX(1) = 11
         IF ((TYPEAX(2).LT.1) .OR. (TYPEAX(2).GT.NUMPRM)) TYPEAX(2) = 9
         IF (TYPEAX(1).EQ.1) TYPEAX(1) = 9
         IF (TYPEAX(1).EQ.2) TYPEAX(1) = 10
         IF (TYPEAX(1).EQ.3) TYPEAX(1) = 6
         IF (TYPEAX(1).EQ.4) TYPEAX(1) = 7
         IF (TYPEAX(1).EQ.8) TYPEAX(1) = 6
         IF (TYPEAX(2).EQ.1) TYPEAX(2) = 9
         IF (TYPEAX(2).EQ.2) TYPEAX(2) = 10
         IF (TYPEAX(2).EQ.3) TYPEAX(2) = 6
         IF (TYPEAX(2).EQ.4) TYPEAX(2) = 7
         IF (TYPEAX(2).EQ.8) TYPEAX(2) = 6
         END IF
      XYMAX(1) = -1.0E10
      XYMAX(2) = XYMAX(1)
      XYMAX(3) = XYMAX(1)
      XYMIN(1) = 1.E10
      XYMIN(2) = XYMIN(1)
      XYMIN(3) = XYMIN(1)
      IPHASE = 0
      IF (TYPEAX(1).EQ.2) IPHASE = 1
      IF (TYPEAX(2).EQ.2) IPHASE = 2
      SPHASE = .FALSE.
C                                       If plotting uv only
C                                       then plot conjugate points
      ITEMP = TYPEAX(1) * TYPEAX(2)
      UVREV = (ITEMP.EQ.42) .OR. (ITEMP.EQ.48) .OR. (ITEMP.EQ.56)
      UVREV = (UVREV) .AND. (TYPUVD.LE.0)
C                                       Initialize baseline selection.
      CALL SETANT (50, XANT, XBASE, NANT, NBAS, IANT, IBAS, DESEL)
C                                       open terminal
      TTY(1) = 5
      TTY(2) = 0
      CALL ZOPEN (TTY(1), TTY(2), 1, MSGTXT, .FALSE., .TRUE., .TRUE.,
     *   IRET)
      IF (IRET.NE.0) THEN
         TTY(2) = 0
         MSGTXT = 'FAILED TO OPEN INTERACTIVE TERMINAL'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('WIPEIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('Error',I3,' finding ',A12,'.',A6,'.',I4,' disk =',
     *   I3,' user=',I5)
 1035 FORMAT ('Error',I3,' obtaining CATBLK ')
 1050 FORMAT ('NO SN FILE FOUND, BUT DOCALIB IS TRUE: NO CAL APPLIED')
 1060 FORMAT ('Plotting',I4,' frequency IDs.')
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
      END
      SUBROUTINE SCAL (GETSCL, XZY, IRET)
C-----------------------------------------------------------------------
C   SCAL sends uv points one at a time to XYOFF .
C   Input:
C      GETSCL   L   If false, do not read all the data, just go through
C                   the rest of the motions
C   Output:
C      IRET     I   Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      LOGICAL   GETSCL
      REAL      XZY(3,*)
      INTEGER   IRET
C
      INTEGER   I, NUMVIS, XUMVIS, J, JJJ, ISUB, JSUB, NXVER, NIF,
     *   NXLUN, IROUND, MSAMP
      LOGICAL   REQBAS, REQAS
      INCLUDE 'WIPER.INC'
      REAL      SV, CATR(256)
      DOUBLE PRECISION CATD(128)
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSOU.INC'
      EQUIVALENCE (CATBLK, CATR, CATD)
C-----------------------------------------------------------------------
      NUMVIS = 0
      XUMVIS = 0
      JSUB = SUBARR
      NXVER = 1
      NXLUN = 100
      CSOU = -1
      REQAS = ((TYPEAX(1).GE.14) .AND. (TYPEAX(1).LE.16)) .OR.
     *   ((TYPEAX(2).GE.14) .AND. (TYPEAX(2).LE.16))
      REQAS = REQAS .OR. (TYPEAX(1).EQ.18) .OR. (TYPEAX(2).EQ.18)
      REQAS = REQAS .OR. (TYPEAX(1).EQ.21) .OR. (TYPEAX(2).EQ.21)
C                                       Loop for each FREQID.
      DO 150 IFRQ = 1,NFRQ
         CALL FILL (MAXIF, 0, EXCLFQ(1,IFRQ))
         IF (NFRQ.GT.1) THEN
            FRQSEL = IFRQ
            WRITE (MSGTXT,1000) IFRQ
            CALL MSGWRT (5)
            END IF
         CALL CHNDAT ('READ', NXBUFF, DISKIN, CNOIN, NXVER, CATUV,
     *      NXLUN, NIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'PROBLEM FINDING FREQUENCIES'
            CALL MSGWRT (6)
            GO TO 150
            END IF
         DO 145 ISUB = 1,NSUBA
            IF (JSUB.EQ.0) SUBARR = ISUB
            IF (REQAS) THEN
               CALL GETANT (DISKIN, CNOIN, SUBARR, CATUV, SBUFF, IRET)
               IF (IRET.NE.0) THEN
                  EXCLFQ(ISUB,IFRQ) = 1
                  MSGTXT = 'PROBLEM FINDING ANTENNA INFO'
                  CALL MSGWRT (6)
                  GO TO 145
                  END IF
               IF ((TYPEAX(1).EQ.21) .OR. (TYPEAX(2).EQ.21))
     *            CALL ANAXIS (NANT, IANT, DESEL, NANAX, JANT)
               END IF
C                                       Init vis file for read.
            CALL UVGET ('INIT', RPARM, BUFF1, IRET)
C
            IF (IRET.EQ.-1) GO TO 140
            IF (IRET.EQ.5) THEN
               IRET = 0
               EXCLFQ(ISUB,IFRQ) = 1
               GO TO 140
               END IF
            IF (IRET.GT.0) GO TO 999
            NPOL = NCOR
            DO 20 I = 1,NPOL
               ISCROS(I) = .TRUE.
               SV = CATD(KDCRV+JLOCS) + (I-CATR(KRCRP+JLOCS)) *
     *            CATR(KRCIC+JLOCS)
               J = IROUND (SV)
               IF ((J.GE.-2) .AND. (J.LE.1)) ISCROS(I) = .FALSE.
               IF ((J.GE.-6) .AND. (J.LE.-5)) ISCROS(I) = .FALSE.
 20            CONTINUE
C                                       Loop Read vis. record.
 100        CALL UVGET ('READ', RPARM, BUFF1, IRET)
               IF (IRET.EQ.-1) GO TO 140
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1100) IRET
                  GO TO 990
                  END IF
               IF (.NOT.GETSCL) GO TO 140
C                                       Do we need this baseline?
               IF (ILOCB.GE.0) THEN
                  I = INT (RPARM(ILOCB+1)) / 256
                  J = MOD (INT (RPARM(ILOCB+1)), 256)
               ELSE
                  I = RPARM(ILOCA1+1) + 0.1
                  J = RPARM(ILOCA2+1) + 0.1
                  END IF
               IF (.NOT.REQBAS (I, J, DESEL, IANT, NANT, IBAS, NBAS))
     *            GO TO 100
               NUMVIS = NUMVIS + 1
               IF (CURSOU.NE.CSOU) THEN
                  CSOU = CURSOU
                  CALL GETSOU (CSOU, DISKIN, CNOIN, CATUV, NXLUN, IRET)
                  IF (IRET.NE.0) THEN
                     MSGTXT = 'TROUBLE GETTING SOURCE INFO'
                     IF (REQAS) CALL MSGWRT (6)
C                                       add to source list
                  ELSE
                     DO 110 I = 1,NSOU
                        IF (SNAME.EQ.XSOUR(I)) GO TO 115
 110                    CONTINUE
                     IF (NSOU.LT.30) THEN
                        NSOU = NSOU + 1
                        XSOUR(NSOU) = SNAME
                        END IF
                     END IF
                  END IF
C                                       Find scales
 115           MSAMP = 1
 120           CALL FNDXY (RPARM, BUFF1, NPOL, XZY, MSAMP)
               CALL XYSCAL (NUMVIS, NPOL, XZY, JJJ, IRET)
               IF (IRET.LE.0) THEN
                  IF (IRET.EQ.0) XUMVIS = XUMVIS + JJJ
                  MSAMP = MSAMP + 1
                  IF (MSAMP.EQ.NSAMP) GO TO 120
                  END IF
               GO TO 100
 140        CALL UVGET ('CLOS', RPARM, BUFF1, IRET)
 145        CONTINUE
 150     CONTINUE
      SUBARR = JSUB
      IRET = 0
      IF (.NOT.GETSCL) GO TO 999
C                                       Any valid points
      IF (XUMVIS.LE.1) THEN
         IRET = 4
         WRITE (MSGTXT,1200) XUMVIS
         GO TO 990
         END IF
C                                       Final call to XYSCAL
      NUMVIS = -1
      CALL XYSCAL (NUMVIS, NPOL, XZY, JJJ, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1110) IRET
         GO TO 990
         END IF
      IRET = 0
      GO TO 999

C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Processing FREQID =',I3)
 1100 FORMAT ('SCAL: ERROR',I3,' READING VIS FILE')
 1110 FORMAT ('SCAL: XYSCAL ERROR',I3)
 1200 FORMAT ('FOUND',I5,' POINTS: NOT ENOUGH TO SELF-SCALE')
      END
      SUBROUTINE PLOTUV (NP, XZY, NX, NY, TVCORE, NBL, BLCORE, IRET)
C-----------------------------------------------------------------------
C   PLOTUV actually plots uv data into TVCORE
C   Inputs:
C      NX       I          X dimension of TVCORE
C      NY       I          Y dimension of TVCORE
C      NBL      I          Max # BL in BLCORE point
C   Output:
C      TVCORE   I(*,*)     Plot as count of samples in cell
C      BLCORE   I(*,*,*)   Baseline numbers in tv pixels
C      IRET     I          Return code, 0 => OK, otherwise abort.
C                              4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   NP, NX, NY, TVCORE(NX,NY), NBL, BLCORE(NBL,NX,NY), IRET
      REAL      XZY(3,NP,*)
C
      INCLUDE 'WIPER.INC'
      CHARACTER AUNITS(NUMPRM)*8, BUNITS(NUMPRM)*8, BNDCOD(MAXIF)*8
      INTEGER   I, IC, J, JJJ, ICO, NUMVIS, JSUB, ISUB, NXLUN, NIF,
     *   NXVER, LC, LF, LP, IX, IY, NREV, IBL, MSAMP
      REAL      BLC(2), TRC(2), TR, XY(2), TEMP, SXYMIN(2), SXYMAX(2)
      HOLLERITH CATH(256)
      LOGICAL   REQBAS, REQAS
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSOU.INC'
      EQUIVALENCE (CATBLK, CATH)
      DATA AUNITS /'Janskys ', 'Degrees ', 'Wavlngth', 'Degrees ',
     *   'IAT days', 'Wavlngth', 'Wavlngth', 'Wavlngth', 'Janskys ',
     *   'Janskys ', 'IAT hrs ', 'log (Jy)', '1/Jy**2', 'Hours',
     *   'Degrees ', 'Degrees ', 'Wavlngth', 'Degrees', 'Hertz',
     *   'Pixels', 'Antenna#'/
      DATA BUNITS /'Kelvins ', 'Degrees ', 'Wavlngth', 'Degrees ',
     *   'IAT days', 'Wavlngth', 'Wavlngth', 'Wavlngth', 'Kelvins ',
     *   'Kelvins ', 'IAT hrs ', 'log (K)', '1/(K**2)', 'Hours',
     *   'Degrees ', 'Degrees ', 'Wavlngth', 'Degrees', 'Hertz',
     *   'Pixels', 'Antenna#'/
C-----------------------------------------------------------------------
      NREV = 1
      IF (UVREV) NREV = 2
      IRET = 1
      CALL FILL (9, 0, COUNT)
      IX = NX * NY
      CALL FILL (IX, 0, TVCORE)
      IX = NBL * IX
      CALL FILL (IX, 0, BLCORE)
      REQAS = ((TYPEAX(1).GE.14) .AND. (TYPEAX(1).LE.16)) .OR.
     *   ((TYPEAX(2).GE.14) .AND. (TYPEAX(2).LE.16))
      REQAS = REQAS .OR. (TYPEAX(1).EQ.18) .OR. (TYPEAX(2).EQ.18)
      REQAS = REQAS .OR. (TYPEAX(1).EQ.21) .OR. (TYPEAX(2).EQ.21)
      SPHASE = .FALSE.
      IF ((IPHASE.GT.0) .AND.
     *   (XYMAX(3)-XYMIN(3).LT.XYMAX(IPHASE)-XYMIN(IPHASE))) THEN
         SPHASE = .TRUE.
         XYMIN(IPHASE) = XYMIN(3)
         XYMAX(IPHASE) = XYMAX(3)
         END IF
C                                       User sets the scales
C                                       Note that case of FIXSCL<0
C                                       is handled in setting XYMIN
C                                       and XYMAX.
      IF (FIXSCL.GT.0) THEN
         IF (BPARM(5).GT.BPARM(4)) THEN
            XYMIN(1) = BPARM(4)
            XYMAX(1) = BPARM(5)
            IF ((IPHASE.EQ.1) .AND. (XYMIN(1).GE.0.0)) SPHASE = .TRUE.
            END IF
         IF (BPARM(7).GT.BPARM(6)) THEN
            XYMIN(2) = BPARM(6)
            XYMAX(2) = BPARM(7)
            IF ((IPHASE.EQ.2) .AND. (XYMIN(2).GE.0.0)) SPHASE = .TRUE.
            END IF
         END IF
      IF (FIXSCL.LT.0) THEN
         IF (BPARM(5).GT.BPARM(4)) THEN
            XYMIN(1) = MAX (XYMIN(1), BPARM(4))
            XYMAX(1) = MIN (XYMAX(1), BPARM(5))
            IF ((IPHASE.EQ.1) .AND. (XYMIN(1).GE.0.0)) SPHASE = .TRUE.
            END IF
         IF (BPARM(7).GT.BPARM(6)) THEN
            XYMIN(2) = MAX (XYMIN(2), BPARM(6))
            XYMAX(2) = MIN (XYMAX(2), BPARM(7))
            IF ((IPHASE.EQ.2) .AND. (XYMIN(2).GE.0.0)) SPHASE = .TRUE.
            END IF
         END IF
C                                       Provide room at edges.
      DO 10 I = 1,2
         TEMP = 0.025 * (XYMAX(I) - XYMIN(I))
         IF (XYMIN(I).NE.BPARM(2*I+2)) XYMIN(I) = XYMIN(I) - TEMP
         IF (XYMAX(I).NE.BPARM(2*I+3)) XYMAX(I) = XYMAX(I) + TEMP
         IF (XYMAX(I).EQ.XYMIN(I)) GO TO 999
 10      CONTINUE
C                                       Now set the offset and scale.
      IF (INVAX(1)) THEN
         XYOFF(1) = XYMAX(1)
         XYSCL(1) = (NX - 0.001) / (XYMIN(1)-XYMAX(1))
      ELSE
         XYOFF(1) = XYMIN(1)
         XYSCL(1) = (NX - 0.001) / (XYMAX(1)-XYMIN(1))
         END IF
      IF (INVAX(2)) THEN
         XYOFF(2) = XYMAX(2)
         XYSCL(2) = (NY - 0.001) / (XYMIN(2)-XYMAX(2))
      ELSE
         XYOFF(2) = XYMIN(2)
         XYSCL(2) = (NY - 0.001) / (XYMAX(2)-XYMIN(2))
         END IF
C                                       Fill in last of actual parms
      BPARM(5) = (NX-0.001)/XYSCL(1) + XYOFF(1)
      BPARM(7) = (NY-0.001)/XYSCL(2) + XYOFF(2)
      BPARM(4) = XYOFF(1)
      BPARM(6) = XYOFF(2)
C                                      Initialize UV reading
      ISUVR = (UVRNG(1).GE.0.0) .AND. (UVRNG(2).GT.UVRNG(1))
      IF ((UVRNG(1).EQ.0.0) .AND. (UVRNG(2).GE.1.E10)) ISUVR = .FALSE.
      XUVRA(1) = UVRNG(1)
      XUVRA(2) = UVRNG(2)
      CALL RCOPY (8, TIMRNG, XTIME)
      XBCHAN = BCHAN
      XECHAN = ECHAN
      XCHINC = CHINC
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = NX - 0.001
      TRC(2) = NY - 0.001
      IRET = 3
C                                       Set up location common and TV
C                                       header
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      IF (TYPEAX(1).EQ.11) LABTYP(LOCNUM) = 7
      IF (TYPEAX(2).EQ.11) LABTYP(LOCNUM) = 70
      AXTYP(LOCNUM) = 0
      DO 30 I = 1,2
         TR = TRC(I) / XYSCL(I)
         RPLOC(I,LOCNUM) = BLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I)
         AXINC(I,LOCNUM) = TR / (TRC(I) - BLC(I))
C                                       do not do METSCA here
         IF (TYPEAX(I).NE.11) THEN
            CPREF(I,LOCNUM) = ' '
            SXYMIN(I) = XYMIN(I)
            SXYMAX(I) = XYMAX(I)
         ELSE
            CPREF(I,LOCNUM) = ' '
            RPVAL(I,LOCNUM) = RPVAL(I,LOCNUM) * 360.
            AXINC(I,LOCNUM) = AXINC(I,LOCNUM) * 360.
            CTYP(I,LOCNUM) = AUNITS(11)
            SXYMIN(I) = XYMIN(I) * 24.0
            SXYMAX(I) = XYMAX(I) * 24.0
            END IF
C                                       interferometer
         IF (TYPUVD.LE.0) THEN
            CTYP(I,LOCNUM) = AUNITS(TYPEAX(I))
C                                       single dish
         ELSE
            CTYP(I,LOCNUM) = BUNITS(TYPEAX(I))
            END IF
         TVCATD(KDCRV+I-1) = RPVAL(I,LOCNUM)
         TVCATR(KRCRP+I-1) = RPLOC(I,LOCNUM)
         TVCATR(KRCIC+I-1) = AXINC(I,LOCNUM)
         CALL CHR2H (8, CTYP(I,LOCNUM), 1, CATH(KHCTP+2*(I-1)))
 30      CONTINUE
      TVCAT(KINAX) = NX
      TVCAT(KINAX+1) = NY
      NUMVIS = 0
      IF (INVAX(1)) THEN
         WRITE (MSGTXT,1030) 'X', CPREF(1,LOCNUM), CTYP(1,LOCNUM)(:12),
     *      SXYMAX(1), SXYMIN(1)
      ELSE
         WRITE (MSGTXT,1030) 'X', CPREF(1,LOCNUM), CTYP(1,LOCNUM)(:12),
     *      SXYMIN(1), SXYMAX(1)
         END IF
      CALL MSGWRT (3)
      IF (TYPEAX(1).EQ.21) CTYP(1,LOCNUM) = 'NO TICKS'
      IF (INVAX(2)) THEN
         WRITE (MSGTXT,1030) 'Y', CPREF(2,LOCNUM), CTYP(2,LOCNUM)(:12),
     *      SXYMAX(2), SXYMIN(2)
      ELSE
         WRITE (MSGTXT,1030) 'Y', CPREF(2,LOCNUM), CTYP(2,LOCNUM)(:12),
     *      SXYMIN(2), SXYMAX(2)
         END IF
      CALL MSGWRT (3)
      IF (TYPEAX(2).EQ.21) CTYP(2,LOCNUM) = 'NO TICKS'
C                                       Loop for each FREQID.
      NXLUN = 100
      NXVER = 1
      JSUB = SUBARR
      DO 150 IFRQ = 1,NFRQ
         IF (NFRQ.GT.1) FRQSEL = IFRQ
         CALL CHNDAT ('READ', NXBUFF, DISKIN, CNOIN, NXVER, CATUV,
     *      NXLUN, NIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'PROBLEM FINDING FREQUENCIES'
            CALL MSGWRT (6)
            GO TO 150
            END IF
         DO 145 ISUB = 1,NSUBA
            IF (EXCLFQ(ISUB,IFRQ).NE.0) GO TO 145
            IF (JSUB.EQ.0) SUBARR = ISUB
            IF (REQAS) THEN
               CALL GETANT (DISKIN, CNOIN, SUBARR, CATUV, SBUFF, IRET)
               IF (IRET.NE.0) THEN
                  EXCLFQ(ISUB,IFRQ) = 1
                  MSGTXT = 'PROBLEM FINDING ANTENNA INFO'
                  CALL MSGWRT (6)
                  GO TO 145
                  END IF
               IF ((TYPEAX(1).EQ.21) .OR. (TYPEAX(2).EQ.21))
     *            CALL ANAXIS (NANT, IANT, DESEL, NANAX, JANT)
               END IF
C                                       Initialize UV reading.
            CALL UVGET ('INIT', RPARM, BUFF1, IRET)
C
            IF (IRET.EQ.-1) GO TO 140
            IF (IRET.EQ.5) GO TO 140
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT, 1050) IRET
               CALL MSGWRT (8)
               IRET = 4
               GO TO 999
               END IF
            NPOL = NCOR
C                                       Loop: Read vis. record.
 100        CALL UVGET ('READ', RPARM, BUFF1, IRET)
               IF (IRET.EQ.-1) GO TO 140
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1100) IRET
                  CALL MSGWRT (8)
                  IRET = 4
                  GO TO 999
                  END IF
C                                       Check whether we need this
C                                       baseline
               IF (ILOCB.GE.0) THEN
                  I = INT (RPARM(ILOCB+1)) / 256
                  J = MOD (INT (RPARM(ILOCB+1)), 256)
               ELSE
                  I = RPARM(ILOCA1+1) + 0.1
                  J = RPARM(ILOCA2+1) + 0.1
                  END IF
               IF (.NOT.REQBAS (I, J, DESEL, IANT, NANT, IBAS, NBAS))
     *            GO TO 100
               IBL = 1000*I + J
               NUMVIS = NUMVIS + 1
               IF (CURSOU.NE.CSOU) THEN
                  CSOU = CURSOU
                  CALL GETSOU (CSOU, DISKIN, CNOIN, CATUV, NXLUN, IRET)
                  IF (IRET.NE.0) THEN
                     MSGTXT = 'TROUBLE GETTING SOURCE INFO'
                     IF (REQAS) CALL MSGWRT (6)
C                                       add to source list
                  ELSE
                     DO 110 I = 1,NSOU
                        IF (SNAME.EQ.XSOUR(I)) GO TO 111
 110                    CONTINUE
                     IF (NSOU.LT.30) THEN
                        NSOU = NSOU + 1
                        XSOUR(NSOU) = SNAME
                        END IF
                     END IF
                  END IF
C                                       Get and scale X, Y
 111           MSAMP = 1
 115           CALL FNDXY (RPARM, BUFF1, NP, XZY, MSAMP)
               ICO = ECHAN - BCHAN + 1
               LC = 0
               DO 135 LF = BIF,EIF
                  DO 130 IC = 1,ICO,CHINC
                     LC = LC + 1
                     DO 129 LP = 1,NPOL
                        IF ((XZY(1,LP,LC).NE.FBLANK) .AND.
     *                     (XZY(2,LP,LC).NE.FBLANK) .AND.
     *                     (XZY(3,LP,LC).GT.0.0)) THEN
                           IF ((SPHASE) .AND. (IPHASE.GT.0)) THEN
                              TEMP = XZY(IPHASE,LP,LC)
                              IF (TEMP.LT.0) TEMP = TEMP + 360.0
                              XZY(IPHASE,LP,LC) = TEMP
                              END IF
                           DO 128 JJJ = 1,NREV
                              DO 120 J = 1,2
                                 XY(J) = XYSCL(J) *
     *                              (XZY(J,LP,LC)-XYOFF(J))
 120                             CONTINUE
C                                       Mark the point
                              IX = XY(1) + 1.0
                              IY = XY(2) + 1.0
                              IF (IX.LT.1) THEN
                                 IF (IY.GT.NY) THEN
                                    COUNT(1,1) = COUNT(1,1) + 1
                                 ELSE IF (IY.GT.0) THEN
                                    COUNT(1,2) = COUNT(1,2) + 1
                                 ELSE
                                    COUNT(1,3) = COUNT(1,3) + 1
                                    END IF
                              ELSE IF (IX.GT.NX) THEN
                                 IF (IY.GT.NY) THEN
                                    COUNT(3,1) = COUNT(3,1) + 1
                                 ELSE IF (IY.GT.0) THEN
                                    COUNT(3,2) = COUNT(3,2) + 1
                                 ELSE
                                    COUNT(3,3) = COUNT(3,3) + 1
                                    END IF
                              ELSE
                                 IF (IY.GT.NY) THEN
                                    COUNT(2,1) = COUNT(2,1) + 1
                                 ELSE IF (IY.GT.0) THEN
                                    COUNT(2,2) = COUNT(2,2) + 1
                                    TVCORE(IX,IY) = TVCORE(IX,IY) + 1
                                    CALL COUNTR (NX, NY, IX, IY, IBL,
     *                                 NBL, BLCORE)
                                 ELSE
                                    COUNT(2,3) = COUNT(2,3) + 1
                                    END IF
                                 END IF
                              XZY(1,LP,LC) = -XZY(1,LP,LC)
                              XZY(2,LP,LC) = -XZY(2,LP,LC)
 128                          CONTINUE
                           END IF
 129                    CONTINUE
 130                 CONTINUE
 135              CONTINUE
               IF (MSAMP.LT.NSAMP) THEN
                  MSAMP = MSAMP + 1
                  GO TO 115
                  END IF
               GO TO 100
 140        CALL UVGET ('CLOS', RPARM, BUFF1, IRET)
 145        CONTINUE
 150     CONTINUE
      SUBARR = JSUB
C                                       Done
      IRET = 0
      WRITE (MSGTXT,1150) COUNT(2,2)
      CALL MSGWRT (2)
      IF (COUNT(2,2).LE.0) IRET = 1
      JJJ = -COUNT(2,2)
      DO 160 I = 1,3
         DO 155 J = 1,3
            JJJ = JJJ + COUNT(J,I)
 155        CONTINUE
 160     CONTINUE
C                                       points off plot
      IF (JJJ.GT.0) THEN
         WRITE (MSGTXT,1155) JJJ
         CALL MSGWRT (2)
         MSGTXT = 'Image of the points'' location wrt image'
         CALL MSGWRT (2)
         WRITE (MSGTXT,1160) COUNT(1,1), COUNT(2,1), COUNT(3,1)
         CALL MSGWRT (2)
         WRITE (MSGTXT,1160) COUNT(1,2), COUNT(2,2), COUNT(3,2)
         CALL MSGWRT (2)
         WRITE (MSGTXT,1160) COUNT(1,3), COUNT(2,3), COUNT(3,3)
         CALL MSGWRT (2)
         END IF
C                                       Add 1 to sampled cells only
      MBL = 1
      DO 200 J = 1,NY
         DO 190 I = 1,NX
            IF (TVCORE(I,J).GE.1) THEN
               TVCORE(I,J) = TVCORE(I,J) + 1
               DO 180 IBL = MBL,NBL
                  IF (BLCORE(IBL,I,J).NE.0) MBL = MAX (MBL, IBL)
 180              CONTINUE
               END IF
 190        CONTINUE
 200     CONTINUE
      IF (MBL.GE.NBL) THEN
         WRITE (MSGTXT,1200) NBL
         CALL MSGWRT (6)
         MSGTXT = 'This will complicate flagging by baseline'
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('PLOTUV: ',A1,' axis in ',A,A,2X,2(1PE11.3))
 1050 FORMAT ('PLOTUV: ERROR',I3,' INIT VIS FILE')
 1100 FORMAT ('PLOTUV: ERROR',I3,' READING VIS FILE')
 1150 FORMAT ('PLOTUV: ',I10,' Points put in array')
 1155 FORMAT ('PLOTUV: ',I10,' Points did not fit')
 1160 FORMAT ('PLOTUV: ',I10,' * ',I10,' * ',I10)
 1200 FORMAT ('Warning: more than',I3,' baselines at a single point')
      END
      SUBROUTINE COUNTR (NX, NY, IX, IY, IBL, NBL, BLCORE)
C-----------------------------------------------------------------------
C   Records the baseline in BLCORE(i,IX,IY) if possible
C   Inputs:
C      NX       I            X dimension of BLCORE
C      NY       I            Y dimension of BLCORE
C      IX       I            X pixel to do counting
C      IY       I            Y pixel to do counting
C      IBL      I            Baseline code
C      NBL      I            Max number BLs in BLCORE
C   In/Out:
C      BLCORE   I(10,NX,NY)   array of baseline codes
C-----------------------------------------------------------------------
      INTEGER   NX, NY, IX, IY, IBL, NBL, BLCORE(NBL,NX,NY)
C
      INTEGER   I, J
C-----------------------------------------------------------------------
      J = NBL
      DO 10 I = 1,NBL-1
         IF (IBL.EQ.ABS(BLCORE(I,IX,IY))) GO TO 999
         IF (BLCORE(I,IX,IY).EQ.0) J = MIN (J, I)
 10      CONTINUE
      IF (J.EQ.NBL) THEN
         BLCORE(NBL,IX,IY) = -1000000
      ELSE
         BLCORE(J,IX,IY) = IBL
         END IF
C
 999  RETURN
      END
      SUBROUTINE EDITUV (NX, NY, TVCORE, NBL, BLCORE, IRET)
C-----------------------------------------------------------------------
C   EDITUV displays the uv data on the TV and offers editing options
C   Inputs:
C      NX       I           X dimension of TVCORE
C      NY       I           Y dimension of TVCORE
C      NBL      I          Max # baselines in BLCORE
C   In/out:
C      TVCORE   I(*,*)      Plot as count of samples in cell - negative
C                           means flag.
C      BLCORE   I(*,*,*)   Baseline numbers in tv pixels
C   Output:
C      IRET     I           Return code, 0 => OK, otherwise abort.
C                              4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   NX, NY, TVCORE(NX,NY), NBL, BLCORE(NBL,NX,NY), IRET
C
      INCLUDE 'WIPER.INC'
      INTEGER   MC
      PARAMETER (MC = 19)
C
      INTEGER   TVC(4), IMW(4), IX, IY, IGR, I, IGM, MTYP, MCOL, MROW,
     *   MGRS(2), TOPSEP, TIMLIM, CHS, TVBUT, IP, ITY, ISN, SVZOOM(3),
     *   IGB, BX(2), BY(2), PZERO(2), CATTMP(256), IGBB, NTITLE, SIDSEP,
     *   II, J
      CHARACTER ISHELP*6, TITLE*24, CHOICS(MC)*12, CHTYPE(NUMPRM)*9,
     *   CHTYP2(NUMPRM)*9, TEXT*9
      LOGICAL   LEAVE(MC), MENUOK, BORDER(4), ZERO(2)
      REAL      TEMP
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA MCOL, MROW, TOPSEP, SIDSEP, TIMLIM /1, MC, 20, 10, 0/
      DATA CHOICS /'ABORT', 'EXIT', ' ', 'OFF ZOOM', 'TVZOOM',
     *   'SET WINDOW','RESET WINDOW', 'FLAG POINT', 'FLAG AREA',
     *   'FLAG FAST', 'FLAG FAT', 'FLAG BASELIN', 'UNFLAG POINT',
     *   'UNFLAG AREA', 'UNFLAG FAST', 'UNFLAG FAT', 'UNFLAG BASEL',
     *   'WIPER SET', 'WIPER SIZE'/
      DATA LEAVE /2*.FALSE., 5*.TRUE., 4*.FALSE., .TRUE., 4*.FALSE.,
     *   .TRUE., .FALSE., .TRUE./
      DATA CHTYPE /'Amplitude', 'Phase   ', 'UV dist ',
     *   'UV pa    ', 'Time    ', 'U       ', 'V       ',
     *   'W        ', 'Real    ', 'Imag    ', 'Time hrs',
     *   'log (amp)', 'Weight', 'Hour angl', 'Elevation', 'Para angl',
     *   'UV@pa=   ', 'Azimuth', 'Frequency', 'Channel', 'NO TICKS'/
      DATA CHTYP2 /'Flux     ', 'Offset  ', 'UV dist ',
     *   'UV pa    ', 'Time    ', 'Longitude', 'Latitude',
     *   'W        ', 'Flux    ', 'Offset  ', 'Time hrs',
     *   'log(flux)', 'Weight', 'Hour angl', 'Elevation', 'Para angl',
     *   'UV@pa=   ', 'Azimuth', 'Frequency', 'Channel', 'Antenna'/
C-----------------------------------------------------------------------
      CALL TVOPEN (SBUFF, IRET)
      IF (IRET.NE.0) GO TO 999
      TVMAXX(1) = MAXXTV(1) - 7 * CSIZTV(1)
      TVMAXX(2) = MAXXTV(2) - 4 * CSIZTV(2)
      MTYP = XDOCEN + 1.5
C                                       init the TV: off grays
C                                       clear graphics
      CALL YHOLD ('ONNN', IRET)
      TVZOOM(1) = 0
      TVZOOM(2) = MAXXTV(1)/2
      TVZOOM(3) = MAXXTV(2)/2
      CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), .TRUE., IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Turn off scroll!!
      I = 0
      IX = 2 ** NGRAY
      CALL YSCROL (IX, I, I, .FALSE., IRET)
      IF (IRET.NE.0) GO TO 990
      DO 5 I = 1,NGRAY+NGRAPH
         IF ((I.GT.NGRAY) .AND. (I.LE.NGRAY+5)) THEN
            CALL YZERO (I, IRET)
            IF (IRET.NE.0) GO TO 990
            CALL YSLECT ('ONNN', I, 0, TVSCR, IRET)
         ELSE
            CALL YSLECT ('OFFF', I, 0, TVSCR, IRET)
            END IF
         IF (IRET.NE.0) GO TO 990
 5       CONTINUE
      IGB = NGRAY + 5
      IGM = NGRAY + 2
      CALL YSLECT ('OFFF', IGM, 0, TVSCR, IRET)
      IF (IRET.NE.0) GO TO 990
      MENUOK = .FALSE.
      TITLE =' '
      NTITLE = 0
C                                       where is the value 0?
      TEMP = - XYSCL(1) * XYOFF(1)
      PZERO(1) = TEMP + 1.0
      TEMP = - XYSCL(2) * XYOFF(2)
      PZERO(2) = TEMP + 1.0
C                                       full image again
 10   IMW(1) = 1
      IMW(2) = 1
      IMW(3) = NX
      IMW(4) = NY
C                                       does it fit
 20   I = 1
      II = 1
      IX = IMW(3) - IMW(1) + 1
      IY = IMW(4) - IMW(2) + 1
 25   IF (((IX+I-1)/I.GT.TVMAXX(1)) .OR. ((IY+I-1)/I.GT.TVMAXX(2))) THEN
         I = I + 1
         GO TO 25
         END IF
C                                       Must smooth
      IF (I.GT.1) THEN
         WRITE (MSGTXT,1025) I
         CALL MSGWRT (1)
C                                       can we pixel replicate
      ELSE
 30      IF ((IX*II.LT.TVMAXX(1)) .AND. (IY*II.LT.TVMAXX(2))) THEN
            II = II + 1
            GO TO 30
         ELSE
            II = II - 1
            END IF
         WRITE (MSGTXT,1026) II
         IF (II.GT.1) CALL MSGWRT (4)
         END IF
C                                       Init
      CALL YWINDO ('READ', WINDTV, IRET)
      IF (IRET.NE.0) THEN
         WINDTV(1) = 1
         WINDTV(2) = 1
         WINDTV(3) = MAXXTV(1)
         WINDTV(4) = MAXXTV(2)
         IRET = 0
         END IF
C                                       window location
      IX = (IX + I - 1) / I * II
      IY = (IY + I - 1) / I * II
      TVC(1) = (TVMAXX(1) - IX)/2 + 1 + (MAXXTV(1)-TVMAXX(1))
      TVC(3) = TVC(1) + IX - 1
      TVC(2) = WINDTV(2) + 4.5*CSIZTV(2)
      TVC(4) = TVC(2) + IY - 1
      IF (TVC(4).GE.MAXXTV(2)) THEN
         TVC(2) = 1 + 5 * CSIZTV(2)
         TVC(4) = TVC(2) + IY - 1
         IF (TVC(4).GE.MAXXTV(2)) THEN
            TVC(2) = (TVMAXX(2) - IY)/2 + 1 + (MAXXTV(2)-TVMAXX(2))
            TVC(4) = TVC(2) + IY - 1
            END IF
         END IF
      BORDER(1) = (TVC(1).GT.1) .AND. (IMW(1).EQ.1)
      BORDER(2) = (TVC(2).GT.1) .AND. (IMW(2).EQ.1)
      BORDER(3) = (TVC(3).LT.MAXXTV(1)) .AND. (IMW(3).EQ.NX)
      BORDER(4) = (TVC(4).LT.MAXXTV(2)) .AND. (IMW(4).EQ.NY)
      ZERO(1) = (PZERO(1).GE.IMW(1)) .AND. (PZERO(1).LE.IMW(3))
      ZERO(2) = (PZERO(2).GE.IMW(2)) .AND. (PZERO(2).LE.IMW(4))
      IF ((TVC(1)-1.LT.WINDTV(1)) .OR. (TVC(2)-1.LT.WINDTV(2)) .OR.
     *   (TVC(3)+1.GT.WINDTV(3)) .OR. (TVC(4)+1.GT.WINDTV(4))) THEN
         WINDTV(1) = MIN (WINDTV(1), TVC(1))
         WINDTV(2) = MIN (WINDTV(2), TVC(2))
         WINDTV(3) = MAX (WINDTV(3), TVC(3))
         WINDTV(4) = MAX (WINDTV(4), TVC(4))
         IF (BORDER(1)) WINDTV(1) = MIN (WINDTV(1), TVC(1)-1)
         IF (BORDER(2)) WINDTV(2) = MIN (WINDTV(2), TVC(2)-1)
         IF (BORDER(3)) WINDTV(3) = MAX (WINDTV(3), TVC(3)+1)
         IF (BORDER(4)) WINDTV(4) = MAX (WINDTV(4), TVC(4)+1)
         CALL YWINDO ('WRIT', WINDTV, IRET)
         END IF
      CALL COPY (4, IMW, TVCAT(IIWIN))
      CALL COPY (4, TVC, TVCAT(IICOR))
      J = I
      IF (II.GT.1) J = -II
      CALL TVLOAD (NX, NY, TVCORE, J, TVC, IMW, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       draw border and label
      IGBB = 5
      IGB = NGRAY + IGBB
      CALL YZERO (IGB, IRET)
      IF (IRET.NE.0) GO TO 990
      CALL COPY (256, CATBLK, CATTMP)
      CALL COPY (256, TVCAT, CATBLK)
      IF (TYPUVD.LE.0) THEN
         TEXT = CHTYPE(TYPEAX(1))
      ELSE
         TEXT = CHTYP2(TYPEAX(1))
         END IF
      CALL CHR2H (8, TEXT, 1, CATH(KHCTP))
      IF (TYPUVD.LE.0) THEN
         TEXT = CHTYPE(TYPEAX(2))
      ELSE
         TEXT = CHTYP2(TYPEAX(2))
         END IF
      CALL CHR2H (8, TEXT, 1, CATH(KHCTP+2))
      CALL IAXIS1 (TVSCR, LTYPE, IGBB, 1, .FALSE., IRET)
      IF (IRET.NE.0) GO TO 990
      IF ((TYPEAX(1).EQ.21) .OR. (TYPEAX(2).EQ.21)) THEN
         CALL ANTLAB (TVSCR, LTYPE, IGBB, 1, .FALSE., IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
      CALL COPY (256, CATTMP, CATBLK)
      CALL REMETS (CPREF(1,LOCNUM), SCALXY(1))
      CALL REMETS (CPREF(2,LOCNUM), SCALXY(2))
C                                       zero graphics
      IF (ZERO(1)) THEN
         BX(1) = TVC(1) + PZERO(1) - IMW(1)
         BX(2) = BX(1)
         BY(1) = MAX (1, TVC(2) - 1)
         BY(2) = MIN (MAXXTV(2), TVC(4) + 1)
         CALL IMVECT ('ONNN', IGB, 2, BX, BY, TVSCR, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
      IF (ZERO(2)) THEN
         BY(1) = TVC(2) + PZERO(2) - IMW(2)
         BY(2) = BY(1)
         BX(1) = MAX (1, TVC(1) - 1)
         BX(2) = MIN (MAXXTV(1), TVC(3) + 1)
         CALL IMVECT ('ONNN', IGB, 2, BX, BY, TVSCR, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
      IF (I.GT.1) THEN
         MSGTXT = 'Select a sub-image to edit'
         CALL MSGWRT (1)
         IGR = 3 + NGRAY
         CALL WIPBOX (IGR, TVC, IMW, TVSCR, IRET)
         IF (IRET.NE.0) GO TO 990
         GO TO 20
         END IF
C                                       build menu
      MGRS(2) = MIN (NGRAPH, 3)
      ISHELP = TSKNAM
 100  MGRS(1) = IGM - NGRAY
      IF (MENUOK) MGRS(1) = -MGRS(1)
      CALL COPY (3, TVZOOM, SVZOOM)
C                                       Init
      CALL YWINDO ('READ', WINDTV, IRET)
      IF (IRET.NE.0) THEN
         WINDTV(1) = 1
         WINDTV(2) = 1
         WINDTV(3) = MAXXTV(1)
         WINDTV(4) = MAXXTV(2)
         IRET = 0
         END IF
C                                       force window large enough
      IF ((TVC(1).LT.WINDTV(1)) .OR. (TVC(2).LT.WINDTV(2)) .OR.
     *   (TVC(3).GT.WINDTV(3)) .OR. (TVC(4).GT.WINDTV(4))) THEN
         WINDTV(1) = MIN (WINDTV(1), TVC(1))
         WINDTV(2) = MIN (WINDTV(2), TVC(2))
         WINDTV(3) = MAX (WINDTV(3), TVC(3))
         WINDTV(4) = MAX (WINDTV(4), TVC(4))
         CALL YWINDO ('WRIT', WINDTV, IRET)
         END IF
      CALL TVMENU (MTYP, MCOL, MROW, MGRS, TOPSEP, SIDSEP, ISHELP,
     *   CHOICS, TIMLIM, LEAVE, NTITLE, TITLE, CHS, TVBUT, TVSCR, IRET)
      IF (IRET.NE.0) GO TO 990
      MENUOK = .TRUE.
C                                       Init
      CALL YWINDO ('READ', WINDTV, IRET)
      IF (IRET.NE.0) THEN
         WINDTV(1) = 1
         WINDTV(2) = 1
         WINDTV(3) = MAXXTV(1)
         WINDTV(4) = MAXXTV(2)
         IRET = 0
         END IF
C                                       force window large enough
      IF ((TVC(1).LT.WINDTV(1)) .OR. (TVC(2).LT.WINDTV(2)) .OR.
     *   (TVC(3).GT.WINDTV(3)) .OR. (TVC(4).GT.WINDTV(4))) THEN
         WINDTV(1) = MIN (WINDTV(1), TVC(1))
         WINDTV(2) = MIN (WINDTV(2), TVC(2))
         WINDTV(3) = MAX (WINDTV(3), TVC(3))
         WINDTV(4) = MAX (WINDTV(4), TVC(4))
         CALL YWINDO ('WRIT', WINDTV, IRET)
         END IF
C                                       Do something
      IF (CHOICS(CHS).EQ.'TVZOOM') THEN
         CALL TVZOME (IRET)
      ELSE IF (CHOICS(CHS).EQ.'OFF ZOOM') THEN
         TVZOOM(1) = 0
         TVZOOM(2) = MAXXTV(1)/2
         TVZOOM(3) = MAXXTV(2)/2
         CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), .TRUE., IRET)
      ELSE IF (CHOICS(CHS).EQ.'SET WINDOW') THEN
         MSGTXT = 'Select a sub-image to edit'
         CALL MSGWRT (1)
         IGR = 3 + NGRAY
         CALL WIPBOX (IGR, TVC, IMW, TVSCR, IRET)
         IF (IRET.NE.0) GO TO 990
         TVZOOM(2) = MAXXTV(1)/2
         TVZOOM(3) = MAXXTV(2)/2
         CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), .TRUE., IRET)
         IF (IRET.NE.0) GO TO 990
         CALL YHOLD ('ONNN', IRET)
         IF (IRET.EQ.0) GO TO 20
      ELSE IF (CHOICS(CHS).EQ.'RESET WINDOW') THEN
         TVZOOM(1) = 0
         TVZOOM(2) = MAXXTV(1)/2
         TVZOOM(3) = MAXXTV(2)/2
         CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), .TRUE., IRET)
         IF (IRET.NE.0) GO TO 990
         CALL YHOLD ('ONNN', IRET)
         IF (IRET.EQ.0) GO TO 10
      ELSE IF (CHOICS(CHS)(:7).EQ.'WIPER S') THEN
         TEMP = REAL (TVCAT(IICOR+2) - TVCAT(IICOR)) /
     *      REAL (TVCAT(IIWIN+2) - TVCAT(IIWIN))
         I = TEMP + 0.1
         I = MAX (1, I)
         IF (CHOICS(CHS)(7:).EQ.'SIZE') THEN
            CALL WIPSIZ (BPARM(9), I, TVSCR, IRET)
         ELSE
            TVZOOM(1) = 0
            TVZOOM(2) = MAXXTV(1)/2
            TVZOOM(3) = MAXXTV(2)/2
            CALL YZOOMC (TVZOOM(1), TVZOOM(2), TVZOOM(3), .TRUE., IRET)
            IF (IRET.NE.0) GO TO 990
            CALL WIPSET (BPARM(9), I, TVSCR, IRET)
            CALL COPY (3, SVZOOM, TVZOOM)
            END IF
      ELSE IF (CHOICS(CHS).EQ.'EXIT') THEN
         GO TO 990
      ELSE IF (CHOICS(CHS).EQ.'ABORT') THEN
         MSGTXT = 'ABORT selected - any editing is discarded'
         CALL MSGWRT (6)
         IRET = -1
      ELSE IF ((CHOICS(CHS).EQ.'FLAG BASELIN') .OR.
     *   (CHOICS(CHS).EQ.'UNFLAG BASEL')) THEN
         MENUOK = .FALSE.
         ISN = 1
         IF (CHOICS(CHS)(:2).EQ.'UN') ISN = -1
         CALL FLAGBL (ISN, NX, NY, TVCORE, NBL, BLCORE, IRET)
         IF (IRET.EQ.0) GO TO 20
      ELSE
         MENUOK = .FALSE.
         ISN = 1
         IF (CHOICS(CHS)(:2).EQ.'UN') ISN = -1
         IP = 7 - ISN
         ITY = 0
         IF (CHOICS(CHS)(IP:).EQ.'POINT') ITY = 1
         IF (CHOICS(CHS)(IP:).EQ.'AREA') ITY = 2
         IF (CHOICS(CHS)(IP:).EQ.'FAST') ITY = 3
         IF (CHOICS(CHS)(IP:).EQ.'FAT') ITY = 4
         IF (ITY.GT.0) CALL WIPEIT (ITY, ISN, NX, NY, TVCORE, NBL,
     *      BLCORE, IRET)
         END IF
      IF (IRET.EQ.0) GO TO 100
C
 990  CALL YHOLD ('OFFF', ITY)
      CALL TVCLOS (SBUFF, ISN)
C
 999  RETURN
C-----------------------------------------------------------------------
 1025 FORMAT ('Loading image smoothed by',I2,' pixels')
 1026 FORMAT ('Loading image pixel replicated by',I2,' pixels')
      END
      SUBROUTINE ANTLAB (IBUFF, ILAB, IGR, DOZERO, DOGRID, IERR)
C-----------------------------------------------------------------------
C   ANTLAB is an axis drawing and labelling routine for Drawing
C   directly onto the TV for baseline axes
C   Inputs:
C      IBUFF    I(*)   The output buffer used in writing to the TV:
C                      size >= max x dimension
C      ILAB     I      the type of labeling to use: 1 none, 2 notick
C                         3 = Ra/Dec, 4 = center-rel, 5 = subim centerd
C                         7 = like 3, but leave off top, bot lines
C      IGR      I      Use graphics plane IGR
C      DOZERO   I      1 => zero full graphics plane (UNIQUE true)
C                      -1 => zero only needed piece of graphics plane
C                      0 => do NOT zero the graphics plane
C      DOGRID   L      T => plot full coordinate grid, else ticks
C   Output:
C      IBUFF    I(*)   the updated TV output buffer.
C      IERR     I      error indicator: 0 no error; 10 = Image too small
C   Common:
C      /MAPHDR/ CATBLK   I(256)   the image catalog header.
C-----------------------------------------------------------------------
      INTEGER   IBUFF(*), ILAB, IGR, DOZERO, IERR
      LOGICAL   DOGRID
C
      INCLUDE 'WIPER.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DHDR.INC'
C      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INTEGER   I, IXCORN, IYCORN, IXTCRN, IYTCRN, IXBLC, IYBLC, IXTRC,
     *   IYTRC, TICLEN, INCHAR, IY, IX, IANGL, ILL, LX(4), LY(4), ITG1
      CHARACTER STRING*12
      REAL      XINC, YINC, V
      DATA ILL /0/
C-----------------------------------------------------------------------
      IXCORN = CATBLK(IICOR)
      IYCORN = CATBLK(IICOR+1)
      IXTCRN = CATBLK(IICOR+2)
      IYTCRN = CATBLK(IICOR+3)
      IXBLC = CATBLK(IIWIN)
      IYBLC = CATBLK(IIWIN+1)
      IXTRC = CATBLK(IIWIN+2)
      IYTRC = CATBLK(IIWIN+3)
      XINC = REAL(IXTRC-IXBLC) / REAL(IXTCRN-IXCORN)
      YINC = REAL(IYTRC-IYBLC) / REAL(IYTCRN-IYCORN)
      ITG1 = IGR + NGRAY
C                                       horizontal
      IF (TYPEAX(1).EQ.21) THEN
         IANGL = 0
C                                       label
         STRING = 'Antenna #'
         INCHAR = 9
         IX = (IXCORN + IXTCRN)/2.0 - (INCHAR/2.0)*CSIZTV(1) + 0.5
         IY = IYCORN - 2.833 * CSIZTV(2)
         IF (IY.LT.1) IY = IYCORN - 1.5*CSIZTV(2)
         IF ((IX.GE.1) .AND. (IY.GE.1)) THEN
            CALL IMANOT ('WRIT', IGR, IX, IY, IANGL, ILL,
     *         STRING(:INCHAR), IBUFF, IERR)
            IF ((IERR.NE.0).AND.(IERR.NE.2)) GO TO 980
            END IF
C                                       tick marks
         TICLEN = (IYTCRN - IYCORN) / 50.0 + 0.5
         LY(1) = IYCORN
         LY(2) = IYCORN + TICLEN
         LY(3) = IYTCRN
         LY(4) = IYTCRN - TICLEN
         DO 20 I = 1,NSTNS
            V = (I - 1.) * (NSTNS + 4.) + NSTNS / 2.0
            IF ((V.GE.XYMIN(1)) .AND. (V.LE.XYMAX(1))) THEN
               LX(1) = XYSCL(1) * (V - XYOFF(1))
               IF ((LX(1).GE.IXBLC) .AND. (LX(1).LE.IXTRC)) THEN
                  LX(1) = (LX(1) - IXBLC) / XINC + IXCORN
                  LX(2) = LX(1)
                  CALL IMVECT ('ONNN', ITG1, 2, LX, LY(3), IBUFF, IERR)
                  IF (IERR.NE.0) GO TO 980
                  CALL IMVECT ('ONNN', ITG1, 2, LX, LY(1), IBUFF, IERR)
                  IF (IERR.NE.0) GO TO 980
                  IY = LY(1) - 1.5 * CSIZTV(2)
                  WRITE (STRING,1000) I
                  IF (I.GE.10) THEN
                     IX = LX(1) - CSIZTV(1)
                     CALL IMANOT ('WRIT', IGR, IX, IY, IANGL, ILL,
     *                  STRING(:2), IBUFF, IERR)
                  ELSE
                     IX = LX(1) - 0.5 * CSIZTV(1)
                     CALL IMANOT ('WRIT', IGR, IX, IY, IANGL, ILL,
     *                  STRING(2:2), IBUFF, IERR)
                     END IF
                  END IF
               END IF
 20         CONTINUE
         END IF
C                                       vertical
      IF (TYPEAX(2).EQ.21) THEN
         IANGL = 3
C                                       label
         STRING = 'Antenna #'
         INCHAR = 9
         IY = (IYCORN + IYTCRN)/2.0 + (INCHAR/2.0)*CSIZTV(2) + 0.5
         IX = IXCORN - 5 * CSIZTV(1)
         IF (IX.LT.1) IX = IXCORN + 1.5*CSIZTV(2)
         IF ((IX.GE.1) .AND. (IY.GE.1)) THEN
            CALL IMANOT ('WRIT', IGR, IX, IY, IANGL, ILL,
     *         STRING(:INCHAR), IBUFF, IERR)
            IF ((IERR.NE.0).AND.(IERR.NE.2)) GO TO 980
            END IF
C                                       tick marks
         TICLEN = (IXTCRN - IXCORN) / 50.0 + 0.5
         LX(1) = IXCORN
         LX(2) = IXCORN + TICLEN
         LX(3) = IXTCRN
         LX(4) = IXTCRN - TICLEN
         IANGL = 0
         DO 40 I = 1,NSTNS
            V = (I - 1.) * (NSTNS + 4.) + NSTNS / 2.0
            IF ((V.GE.XYMIN(2)) .AND. (V.LE.XYMAX(2))) THEN
               LY(1) = XYSCL(2) * (V - XYOFF(2))
               IF ((LY(1).GE.IYBLC) .AND. (LY(1).LE.IYTRC)) THEN
                  LY(1) = (LY(1) - IYBLC) / YINC + IYCORN
                  LY(2) = LY(1)
                  CALL IMVECT ('ONNN', ITG1, 2, LX(3), LY, IBUFF, IERR)
                  IF (IERR.NE.0) GO TO 980
                  CALL IMVECT ('ONNN', ITG1, 2, LX(1), LY, IBUFF, IERR)
                  IF (IERR.NE.0) GO TO 980
                  IX = LX(1) - 2 * CSIZTV(1)
                  IY = LY(1)
                  WRITE (STRING,1000) I
                  IF (I.GE.10) THEN
                     IX = IX - CSIZTV(1)
                     CALL IMANOT ('WRIT', IGR, IX, IY, IANGL, ILL,
     *                  STRING(:2), IBUFF, IERR)
                  ELSE
                     IY = IY - 0.5*CSIZTV(2)
                     CALL IMANOT ('WRIT', IGR, IX, IY, IANGL, ILL,
     *                  STRING(2:2), IBUFF, IERR)
                     END IF
                  END IF
               END IF
 40         CONTINUE
         END IF
      GO TO 999
C
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I2)
 1980 FORMAT ('ANTLAB LABEL WRITING ERROR',I3)
      END
      SUBROUTINE FLAGBL (ISN, NX, NY, TVCORE, NBL, BLCORE, IRET)
C-----------------------------------------------------------------------
C   FLAGBL handles talking to the user about which baselines to flag
C   Inputs:
C      ISN      I          1 => flag, -1 => unflag
C      NX       I          X dimension of TVCORE
C      NY       I          Y dimension of TVCORE
C      NBL      I          Max # baselines in BLCORE
C   In/out:
C      TVCORE   I(*,*)     Plot as count of samples in cell - negative
C                          means flag.
C      BLCORE   I(*,*,*)   Baseline numbers in tv pixels
C   Outputs:
C      IRET     I          Error code
C-----------------------------------------------------------------------
      INTEGER   ISN, NX, NY, TVCORE(NX,NY), NBL, BLCORE(NBL,NX,NY), IRET
C
      INCLUDE 'WIPER.INC'
      CHARACTER MESSAG*72
      INTEGER   LTEMP(2), IA, JA, I1, I2, N, LT, IBL, I, IX, IY, NN, J
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IF (ISN.GT.0) THEN
         MESSAG = 'Enter baseline to flag (2 integers)'
      ELSE
         MESSAG = 'Enter baseline to unflag (2 integers)'
         END IF
      LTEMP(1) = 0
      LTEMP(2) = 0
      CALL INQINT (TTY, MESSAG, 2, LTEMP, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (8)
      ELSE IF (IRET.EQ.0) THEN
         N = 0
         NN = 0
         IA = MIN (LTEMP(1), LTEMP(2))
         JA = MAX (LTEMP(1), LTEMP(2))
         IF (JA.LE.0) GO TO 999
         IF (IA.LE.0) THEN
            I1 = 1
            I2 = MANT
         ELSE
            I1 = IA
            I2 = IA
            END IF
         DO 100 IA = I1,I2
            IF ((ISN.GT.0) .AND. (BLFLAG(IA,JA).EQ.0)) THEN
               N = N + 1
               BLFLAG(IA,JA) = 1
               BLFLAG(JA,IA) = 1
               LT = 1000 * MIN (IA,JA) + MAX (IA,JA)
               DO 30 IY = 1,NY
                  DO 20 IX = 1,NX
                     IF (TVCORE(IX,IY).NE.0) THEN
                        I = 0
                        J = 0
                        DO 10 IBL = 1,MBL
                           IF (BLCORE(IBL,IX,IY).EQ.LT) THEN
                              BLCORE(IBL,IX,IY) = -BLCORE(IBL,IX,IY)
                              J = J + 1
                              END IF
                           IF (BLCORE(IBL,IX,IY).GT.0) I = I + 1
 10                        CONTINUE
                        IF ((I.EQ.0) .AND. (J.GT.0)) THEN
                           NN = NN + 1
                           TVCORE(IX,IY) = -ABS (TVCORE(IX,IY))
                           END IF
                        END IF
 20                  CONTINUE
 30               CONTINUE
            ELSE IF ((ISN.LE.0) .AND. (BLFLAG(IA,JA).EQ.1)) THEN
               N = N + 1
               BLFLAG(IA,JA) = 0
               BLFLAG(JA,IA) = 0
               LT = 1000 * MIN (IA,JA) + MAX (IA,JA)
               DO 60 IY = 1,NY
                  DO 50 IX = 1,NX
                     IF (TVCORE(IX,IY).NE.0) THEN
                        I = 0
                        J = 0
                        DO 40 IBL = 1,MBL
                           IF (BLCORE(IBL,IX,IY).EQ.-LT) THEN
                              J = J + 1
                              BLCORE(IBL,IX,IY) = -BLCORE(IBL,IX,IY)
                              END IF
                           IF (BLCORE(IBL,IX,IY).GT.0) I = I + 1
 40                        CONTINUE
                        IF ((I.GT.0) .AND. (J.GT.0) .AND.
     *                     (TVCORE(IX,IY).LT.0)) THEN
                           NN = NN + 1
                           TVCORE(IX,IY) = ABS (TVCORE(IX,IY))
                           END IF
                        END IF
 50                  CONTINUE
 60               CONTINUE
               END IF
 100        CONTINUE
         WRITE (MSGTXT,1100) N, NN
         CALL MSGWRT (3)
         END IF
      IRET = MAX (IRET, 0)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I4,' ASKING FOR NUMBERS')
 1100 FORMAT ('Changed',I5,' baselines and',I9,' displayed points')
      END
      SUBROUTINE WIPEUV (NX, NY, TVCORE, NA, NI, NP, XZY, MALL, MBAD,
     *   MSOM, IRET)
C-----------------------------------------------------------------------
C   WIPEUV replots uv data, compares with TVCORE, and writes flag info.
C   Inputs:
C      NX       I        X dimension of TVCORE
C      NY       I        Y dimension of TVCORE
C      NA      I      Number of antennas
C      NI      I      Number of IFs
C   In/out:
C      TVCORE   I(*,*)   Plot as count of samples in cell - negative
C                        means flag.  Removes counts as they occur so as
C                        to confirm correct usage.
C   Output:
C      MALL    I(*)   Counts samples by baseline etc
C      MBAD    I(*)   Counts full bad spectra by baseline
C      MSOM    I(*)   Counts partly bad spectra by baseline
C      IRET     I        Return code, 0 => OK, otherwise abort.
C                           4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NP, TVCORE(NX,NY), NA, NI, MALL(NA,NA,NP,NI),
     *   MBAD(NA,NA,NP,NI), MSOM(NA,NA,NP,NI), IRET
      REAL      XZY(3,NP,*)
C
      INCLUDE 'WIPER.INC'
      CHARACTER ATIME*8, ADATE*12, REASON*24, BNDCOD(MAXIF)*8
      INTEGER   I, IC, J, JJJ, ICO, NUMVIS, JSUB, ISUB, NXLUN, NIF,
     *   NXVER, LC, LF, IX, IY, NREV, DOUNT(3,3), LUN, LFGRNO, IA1, IA2,
     *   LBIF, LEIF, LBCH, LECH, TIME(3), DATE(3), FGBUFL(512), NIN,
     *   NBAD, LP, DIDALL(MAXANT), JBCH, JECH, MSAMP
      REAL      BLC(2), TRC(2), XY(2), BTIME, ETIME, TEMP
      HOLLERITH CATH(256)
      LOGICAL   REQBAS, REQAS, FLAGDO, PFLAGS(4,4), FLAGED, AFLAGS(4),
     *   GOTONE
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      EQUIVALENCE (CATBLK, CATH)
      DATA LUN /48/
      DATA AFLAGS /4*.TRUE./
C-----------------------------------------------------------------------
      GOTONE = .FALSE.
      LBCH = 1
      LECH = 0
      JBCH = 1
      JECH = 0
      LBIF = 1
      LEIF = 0
      NREV = 1
      IF (UVREV) NREV = 2
      FLAGED = .FALSE.
      IRET = 1
      CALL FILL (9, 0, DOUNT)
      REQAS = ((TYPEAX(1).GE.14) .AND. (TYPEAX(1).LE.16)) .OR.
     * ((TYPEAX(2).GE.14) .AND. (TYPEAX(2).LE.16))
      REQAS = REQAS .OR. (TYPEAX(1).EQ.18) .OR. (TYPEAX(2).EQ.18)
      REQAS = REQAS .OR. (TYPEAX(1).EQ.21) .OR. (TYPEAX(2).EQ.21)
C                                      Set Stokes flag
      CALL LFILL (16, .TRUE., PFLAGS)
      IF (ICOR0.NE.LCOR0) ONEPOL = .FALSE.
      IF ((ICOR0.LT.0) .AND. (LCOR0.LT.0)) THEN
         IF (ONEPOL) THEN
            IF (STOKES.EQ.'RR') PFLAGS(2,1) = .FALSE.
            IF (STOKES.EQ.'LL') PFLAGS(1,1) = .FALSE.
            END IF
         IF (NOTCRS) THEN
            PFLAGS(3,1) = .FALSE.
            PFLAGS(4,1) = .FALSE.
            PFLAGS(3,2) = .FALSE.
            PFLAGS(4,2) = .FALSE.
            END IF
         IF (STOKES.EQ.'RL') THEN
            PFLAGS(1,1) = .FALSE.
            PFLAGS(2,1) = .FALSE.
            PFLAGS(4,1) = .FALSE.
         ELSE IF (STOKES.EQ.'LR') THEN
            PFLAGS(1,1) = .FALSE.
            PFLAGS(2,1) = .FALSE.
            PFLAGS(3,1) = .FALSE.
         ELSE IF ((STOKES.EQ.'RLLR') .OR. (STOKES.EQ.'CROS')) THEN
            PFLAGS(1,1) = .FALSE.
            PFLAGS(2,1) = .FALSE.
            PFLAGS(4,1) = .FALSE.
            PFLAGS(1,2) = .FALSE.
            PFLAGS(2,2) = .FALSE.
            PFLAGS(3,2) = .FALSE.
         ELSE IF ((STOKES.EQ.'HALF') .OR. (STOKES.EQ.'RRLL')) THEN
            IF (ONEPOL) PFLAGS(2,1) = .FALSE.
            IF (ONEPOL) PFLAGS(1,2) = .FALSE.
         ELSE IF ((STOKES.EQ.'FULL') .OR. (STOKES.EQ.'RLRL')) THEN
            IF (ONEPOL) PFLAGS(2,1) = .FALSE.
            IF (ONEPOL) PFLAGS(1,2) = .FALSE.
            PFLAGS(1,3) = .FALSE.
            PFLAGS(2,3) = .FALSE.
            PFLAGS(4,3) = .FALSE.
            PFLAGS(1,4) = .FALSE.
            PFLAGS(2,4) = .FALSE.
            PFLAGS(3,4) = .FALSE.
            END IF
      ELSE IF ((ICOR0.GT.0) .AND. (LCOR0.GT.0)) THEN
         IF ((STOKES.EQ.'Q') .OR. (STOKES.EQ.'U')) THEN
            PFLAGS(1,1) = .FALSE.
            PFLAGS(4,1) = .FALSE.
         ELSE IF ((STOKES.EQ.'IQU') .OR. (STOKES.EQ.'IQUV')) THEN
            PFLAGS(1,2) = .FALSE.
            PFLAGS(4,2) = .FALSE.
            PFLAGS(1,3) = .FALSE.
            PFLAGS(4,3) = .FALSE.
            IF (NOTCRS) THEN
               PFLAGS(2,1) = .FALSE.
               PFLAGS(3,1) = .FALSE.
               PFLAGS(2,4) = .FALSE.
               PFLAGS(3,4) = .FALSE.
               END IF
            END IF
      ELSE IF ((ICOR0.GT.0) .AND. (LCOR0.LT.0)) THEN
         IF ((STOKES.EQ.'Q') .OR. (STOKES.EQ.'U')) THEN
            PFLAGS(1,1) = .FALSE.
            PFLAGS(2,1) = .FALSE.
         ELSE IF ((STOKES.EQ.'IQU') .OR. (STOKES.EQ.'IQUV')) THEN
            PFLAGS(1,2) = .FALSE.
            PFLAGS(2,2) = .FALSE.
            PFLAGS(1,3) = .FALSE.
            PFLAGS(2,3) = .FALSE.
            IF (NOTCRS) THEN
               PFLAGS(3,1) = .FALSE.
               PFLAGS(4,1) = .FALSE.
               PFLAGS(3,4) = .FALSE.
               PFLAGS(4,4) = .FALSE.
               END IF
            END IF
      ELSE IF ((ICOR0.LT.0) .AND. (LCOR0.GT.0)) THEN
         IF ((STOKES.EQ.'RL') .OR. (STOKES.EQ.'LR') .OR.
     *      (STOKES.EQ.'RLLR') .OR. (STOKES.EQ.'CROS')) THEN
            PFLAGS(1,1) = .FALSE.
            PFLAGS(4,1) = .FALSE.
            PFLAGS(1,2) = .FALSE.
            PFLAGS(4,2) = .FALSE.
         ELSE IF ((STOKES.EQ.'FULL') .OR. (STOKES.EQ.'RLRL')) THEN
            PFLAGS(1,3) = .FALSE.
            PFLAGS(4,3) = .FALSE.
            PFLAGS(1,4) = .FALSE.
            PFLAGS(4,4) = .FALSE.
            IF (NOTCRS) THEN
               PFLAGS(2,1) = .FALSE.
               PFLAGS(3,1) = .FALSE.
               PFLAGS(2,2) = .FALSE.
               PFLAGS(3,2) = .FALSE.
               END IF
            END IF
         END IF
C                                       Initialize UV reading
      ISUVR = (UVRNG(1).GE.0.0) .AND. (UVRNG(2).GT.UVRNG(1))
      IF ((UVRNG(1).EQ.0.0) .AND. (UVRNG(2).GE.1.E10)) ISUVR = .FALSE.
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = NX - 0.001
      TRC(2) = NY - 0.001
      IRET = 3
      NUMVIS = 0
C                                       Set flagging reason
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
      REASON = TSKNAM // ADATE // ' ' // ATIME(:5)
C                                       Loop for each FREQID.
      NXLUN = 100
      NXVER = 1
      JSUB = SUBARR
      DO 160 IFRQ = 1,NFRQ
         IF (NFRQ.GT.1) FRQSEL = IFRQ
         CALL CHNDAT ('READ', NXBUFF, DISKIN, CNOIN, NXVER, CATUV,
     *      NXLUN, NIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'PROBLEM FINDING FREQUENCIES'
            CALL MSGWRT (6)
            GO TO 160
            END IF
         DO 155 ISUB = 1,NSUBA
            IF (EXCLFQ(ISUB,IFRQ).NE.0) GO TO 155
            IF (JSUB.EQ.0) SUBARR = ISUB
            IF (REQAS) THEN
               CALL GETANT (DISKIN, CNOIN, SUBARR, CATUV, SBUFF, IRET)
               IF (IRET.NE.0) THEN
                  EXCLFQ(ISUB,IFRQ) = 1
                  MSGTXT = 'PROBLEM FINDING ANTENNA INFO'
                  CALL MSGWRT (6)
                  GO TO 155
                  END IF
               IF ((TYPEAX(1).EQ.21) .OR. (TYPEAX(2).EQ.21))
     *            CALL ANAXIS (NANT, IANT, DESEL, NANAX, JANT)
               END IF
C                                       Initialize UV reading.
            CALL UVGET ('INIT', RPARM, BUFF1, IRET)
C
            IF (IRET.EQ.-1) GO TO 140
            IF (IRET.EQ.5) GO TO 140
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT, 1050) IRET
               CALL MSGWRT (8)
               IRET = 4
               GO TO 999
               END IF
            NPOL = NCOR
C                                       Loop: Read vis. record.
 100        CALL UVGET ('READ', RPARM, BUFF1, IRET)
               IF (IRET.EQ.-1) GO TO 140
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1100) IRET
                  CALL MSGWRT (8)
                  IRET = 4
                  GO TO 999
                  END IF
C                                       Check whether we need this
C                                       baseline
               IF (ILOCB.GE.0) THEN
                  IA1 = INT (RPARM(ILOCB+1)) / 256
                  IA2 = MOD (INT (RPARM(ILOCB+1)), 256)
               ELSE
                  IA1 = RPARM(ILOCA1+1) + 0.1
                  IA2 = RPARM(ILOCA2+1) + 0.1
                  END IF
               IF (.NOT.REQBAS (IA1, IA2, DESEL, IANT, NANT, IBAS,
     *            NBAS)) GO TO 100
               NUMVIS = NUMVIS + 1
               IF ((REQAS) .AND. (CURSOU.NE.CSOU)) THEN
                  CSOU = CURSOU
                  CALL GETSOU (CSOU, DISKIN, CNOIN, CATUV, NXLUN, IRET)
                  IF (IRET.NE.0) THEN
                     MSGTXT = 'TROUBLE GETTING SOURCE INFO'
                     CALL MSGWRT (6)
                     END IF
                  END IF
C                                       Get the time, set interval
               BTIME = RPARM(1+ILOCT) - 1.E-6
               ETIME = RPARM(1+ILOCT) + 1.E-6
C                                       Get and scale X, Y
               MSAMP = 1
 110           CALL FNDXY (RPARM, BUFF1, NP, XZY, MSAMP)
               ICO = ECHAN - BCHAN + 1
               LC = 0
               DO 135 LF = 1,NI
                  FLAGDO = .TRUE.
                  IF (ONEIF) THEN
                     LBIF = LF + BIF - 1
                     LEIF = LF + BIF - 1
                     END IF
                  DO 131 LP = 1,NPOL
                     NIN = 0
                     NBAD = 0
                     MALL(IA1,IA2,LP,LF) = MALL(IA1,IA2,LP,LF) + 1
                     LC = (LF - 1) * ((ICO-1)/CHINC + 1)
                     DO 130 IC = 1,ICO,CHINC
                        LC = LC + 1
                        IF ((XZY(1,LP,LC).NE.FBLANK) .AND.
     *                     (XZY(2,LP,LC).NE.FBLANK) .AND.
     *                     (XZY(3,LP,LC).GT.0.0)) THEN
                           IF ((SPHASE) .AND. (IPHASE.GT.0)) THEN
                              TEMP = XZY(IPHASE,LP,LC)
                              IF (TEMP.LT.0) TEMP = TEMP + 360.0
                              XZY(IPHASE,LP,LC) = TEMP
                              END IF
                           NIN = NIN + CHINC
                           IF (ONECHN) THEN
                              LBCH = IC + BCHAN -1
                              LECH = LBCH + CHINC - 1
                              END IF
                           DO 128 JJJ = 1,NREV
                              DO 120 J = 1,2
                                 XY(J) = XYSCL(J) *
     *                              (XZY(J,LP,LC)-XYOFF(J))
 120                             CONTINUE
C                                       Mark the point
                              IX = XY(1) + 1.0
                              IY = XY(2) + 1.0
                              IF (IX.LT.1) THEN
                                 IF (IY.GT.NY) THEN
                                    DOUNT(1,1) = DOUNT(1,1) + 1
                                 ELSE IF (IY.GT.0) THEN
                                    DOUNT(1,2) = DOUNT(1,2) + 1
                                 ELSE
                                    DOUNT(1,3) = DOUNT(1,3) + 1
                                    END IF
                              ELSE IF (IX.GT.NX) THEN
                                 IF (IY.GT.NY) THEN
                                    DOUNT(3,1) = DOUNT(3,1) + 1
                                 ELSE IF (IY.GT.0) THEN
                                    DOUNT(3,2) = DOUNT(3,2) + 1
                                 ELSE
                                    DOUNT(3,3) = DOUNT(3,3) + 1
                                    END IF
                              ELSE
                                 IF (IY.GT.NY) THEN
                                    DOUNT(2,1) = DOUNT(2,1) + 1
                                 ELSE IF (IY.GT.0) THEN
                                    DOUNT(2,2) = DOUNT(2,2) + 1
C                                       ALL the action: no flag
                                    IF (TVCORE(IX,IY).GE.0) THEN
                                       IF (TVCORE(IX,IY).GT.1) THEN
                                          TVCORE(IX,IY) = TVCORE(IX,IY)
     *                                       - 1
                                       ELSE IF (TVCORE(IX,IY).GE.0) THEN
                                          TVCORE(IX,IY) = 1000000000
                                          END IF
                                       IF (GOTONE) THEN
                                          NFGWRI = NFGWRI + 1
                                          CALL FLAGIT ('FLAG', LUN,
     *                                       DISKIN, CNOIN, FGVERI,
     *                                       FGVERO, LFGRNO, FGKOLS,
     *                                       FGNUMV, CURSOU, SUBARR,
     *                                       IFRQ, IA1, IA2, BTIME,
     *                                       ETIME, LBIF, LEIF, JBCH,
     *                                       JECH, PFLAGS(1,LP), REASON,
     *                                       CATUV, FGBUFL, IRET)
                                          IF (IRET.NE.0) GO TO 999
                                          GOTONE = .FALSE.
                                          END IF
C                                       flagging this point
                                    ELSE
                                       IF (TVCORE(IX,IY).LT.-1) THEN
                                          TVCORE(IX,IY) = TVCORE(IX,IY)
     *                                       + 1
                                       ELSE
                                          TVCORE(IX,IY) = -1000000000
                                          END IF
C                                       flag something
                                       IF (FLAGDO) THEN
                                          IF (ONECHN) THEN
                                             NBAD = NBAD + NCHAV
                                          ELSE
                                             NBAD = NBAD + 32768
                                             END IF
                                          FLAGED = .TRUE.
                                          IF (BLFLAG(IA1,IA2).EQ.0) THEN
                                             IF (.NOT.GOTONE) JBCH=LBCH
                                             JECH = LECH
                                             GOTONE = .TRUE.
                                             END IF
                                          FLAGDO = ONECHN
                                          END IF
                                       END IF
                                 ELSE
                                    DOUNT(2,3) = DOUNT(2,3) + 1
                                    END IF
                                 END IF
                              XZY(1,LP,LC) = -XZY(1,LP,LC)
                              XZY(2,LP,LC) = -XZY(2,LP,LC)
 128                          CONTINUE
                           END IF
 130                    CONTINUE
                     IF ((NBAD.GE.NIN) .AND. (NBAD.GT.0)) THEN
                        MBAD(IA1,IA2,LP,LF) = MBAD(IA1,IA2,LP,LF) + 1
                        NBDCOR = NBDCOR + NCHAN
                     ELSE IF (NBAD.GT.0) THEN
                        MSOM(IA1,IA2,LP,LF) = MSOM(IA1,IA2,LP,LF) + 1
                        NBDCOR = NBDCOR + NBAD
                        END IF
                     IF (GOTONE) THEN
                        NFGWRI = NFGWRI + 1
                        CALL FLAGIT ('FLAG', LUN, DISKIN, CNOIN, FGVERI,
     *                     FGVERO, LFGRNO, FGKOLS, FGNUMV, CURSOU,
     *                     SUBARR, IFRQ, IA1, IA2, BTIME, ETIME, LBIF,
     *                     LEIF, JBCH, JECH, PFLAGS(1,LP), REASON,
     *                     CATUV, FGBUFL, IRET)
                        IF (IRET.NE.0) GO TO 999
                        GOTONE = .FALSE.
                        END IF
 131                 CONTINUE
 135              CONTINUE
               IF (MSAMP.LT.NSAMP) THEN
                  MSAMP = MSAMP + 1
                  GO TO 110
                  END IF
               GO TO 100
 140        CALL UVGET ('CLOS', RPARM, BUFF1, IRET)
C                                       baseline flags
            LBCH = 1
            LECH = 0
            LBIF = BIF
            LEIF = EIF
            CALL FILL (MANT, 0, DIDALL)
            BTIME = TSTART
            ETIME = TEND
            DO 145 I = 1,MANT
               JJJ = 0
               DO 144 J = 1,MANT
                  IF (BLFLAG(I,J).GT.0) JJJ = JJJ + 1
 144              CONTINUE
               IF (JJJ.EQ.MANT) THEN
                  DIDALL(I) = 1
                  NFGWRI = NFGWRI + 1
                  FLAGED = .TRUE.
                  CALL FLAGIT ('FLAG', LUN, DISKIN, CNOIN, FGVERI,
     *               FGVERO, LFGRNO, FGKOLS, FGNUMV, CURSOU, SUBARR,
     *               IFRQ, I, 0, BTIME, ETIME, LBIF, LEIF, LBCH, LECH,
     *               AFLAGS, REASON, CATUV, FGBUFL, IRET)
                  IF (IRET.NE.0) GO TO 999
                  END IF
 145           CONTINUE
            DO 150 I = 1,MANT
               DO 146 J = I,MANT
                  IF ((BLFLAG(I,J).GT.0) .AND. (DIDALL(I).LE.0) .AND.
     *               (DIDALL(J).LE.0)) THEN
                     NFGWRI = NFGWRI + 1
                     FLAGED = .TRUE.
                     CALL FLAGIT ('FLAG', LUN, DISKIN, CNOIN, FGVERI,
     *                  FGVERO, LFGRNO, FGKOLS, FGNUMV, CURSOU, SUBARR,
     *                  IFRQ, I, J, BTIME, ETIME, LBIF, LEIF, LBCH,
     *                  LECH, AFLAGS, REASON, CATUV, FGBUFL, IRET)
                     IF (IRET.NE.0) GO TO 999
                     END IF
 146              CONTINUE
 150           CONTINUE
C                                       close/save flags
            IF (FLAGED) CALL FLAGIT ('CLOS', LUN, DISKIN, CNOIN, FGVERI,
     *         FGVERO, LFGRNO, FGKOLS, FGNUMV, CURSOU, SUBARR, IFRQ,
     *         IA1, IA2, BTIME, ETIME, LBIF, LEIF, LBCH, LECH, PFLAGS,
     *         REASON, CATUV, FGBUFL, IRET)
 155        CONTINUE
 160     CONTINUE
      SUBARR = JSUB
C                                       Done
      IRET = 0
      JJJ = 0
      DO 170 I = 1,3
         DO 165 J = 1,3
            DOUNT(J,I) = DOUNT(J,I) - COUNT(J,I)
            JJJ = JJJ + ABS (DOUNT(J,I))
 165        CONTINUE
 170     CONTINUE
C                                       points off plot
      IF (JJJ.GT.0) THEN
         WRITE (MSGTXT,1150) DOUNT(2,2)
         CALL MSGWRT (2)
         WRITE (MSGTXT,1155) JJJ
         IF (JJJ.NE.DOUNT(2,2)) CALL MSGWRT (2)
         MSGTXT = 'DIFFERENCE IMAGE OF THE POINTS'' LOCATION WRT IMAGE'
         CALL MSGWRT (2)
         WRITE (MSGTXT,1160) DOUNT(1,1), DOUNT(2,1), DOUNT(3,1)
         CALL MSGWRT (2)
         WRITE (MSGTXT,1160) DOUNT(1,2), DOUNT(2,2), DOUNT(3,2)
         CALL MSGWRT (2)
         WRITE (MSGTXT,1160) DOUNT(1,3), DOUNT(2,3), DOUNT(3,3)
         CALL MSGWRT (2)
         END IF
C                                       Check image itself
      JJJ = 0
      DO 180 J = 1,NY
         DO 175 I = 1,NX
            IF (ABS(TVCORE(I,J)).GT.1) THEN
               JJJ = JJJ + 1
               END IF
 175        CONTINUE
 180     CONTINUE
      IF (JJJ.GT.0) THEN
         WRITE (MSGTXT,1170) JJJ
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('WIPEUV: ERROR',I3,' INIT VIS FILE')
 1100 FORMAT ('WIPEUV: ERROR',I3,' READING VIS FILE')
 1150 FORMAT ('WIPEUV: ',I10,' DIFFERENT POINTS FELL IN ARRAY')
 1155 FORMAT ('WIPEUV: ',I10,' DIFFERENT POINTS DID NOT FIT')
 1160 FORMAT ('WIPEUV: ',I10,' * ',I10,' * ',I10)
 1170 FORMAT ('WIPEUV: ',I10,' PIXELS NOT PROPERLY ACCOUNTED FOR')
      END
      SUBROUTINE XYSCAL (NUMVIS, NP, XZY, NGOD, IRET)
C-----------------------------------------------------------------------
C   XYSCAL finds the scaling parameters needed to fit X and Y
C   into a 1000*1000 plotting area .
C   Inputs:
C      NUMVIS   I        Visibility number, -1 => final call, no data
C                        passed -> change to scaling factor from max/min
C      NP       I        Number pol in XZY
C      XZY      R(3,NP,*)   plotted parameters: 1 X, 2 Y, 3 weight
C   Outputs:
C      NGOD     I        Number good samples
C      IRET     I        Error return code , non-zero if error .
C   Outputs (common):
C      XYOFF    R(2)     when added to XZY changes minimum to zero .
C      XYSCL    R(2)     scale XZY so that maximum is 1000.
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, NP, NGOD
      REAL      XZY(3,NP,*)
C
      INTEGER   IRET, I, IC, ICO, LF, LC, J, LP
      REAL      TEMP
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'WIPER.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Get the data limits.
C                                       Will reset to BPARMS where
C                                       requested later in plot routine.
      NGOD = 0
      IF (NUMVIS.GE.0) THEN
         IRET = -1
         ICO = ECHAN - BCHAN + 1
         LC = 0
         DO 50 LF = BIF,EIF
            DO 40 IC = 1,ICO,CHINC
               LC = LC + 1
               DO 30 LP = 1,NPOL
                  IF ((XZY(1,LP,LC).NE.FBLANK) .AND.
     *               (XZY(2,LP,LC).NE.FBLANK)) THEN
                     IRET = 0
                     NGOD = NGOD + 1
C                                       Find max, min from data
C                                       For autoscaling within range
C                                       (bparm(3)<0), don't look at
C                                       all points.
                     DO 20 I = 1,2
                        J = 2*I+2
                        TEMP = XZY(I,LP,LC)
                        IF ((FIXSCL.GE.0) .OR. (BPARM(J).GE.BPARM(J+1))
     *                     .OR. (BPARM(J).LE.TEMP)) THEN
                           IF (TEMP.LT.XYMIN(I)) XYMIN(I) = TEMP
                           END IF
                        IF ((FIXSCL.GE.0) .OR. (BPARM(J).GE.BPARM(J+1))
     *                     .OR. (BPARM(J+1).GE.TEMP)) THEN
                           IF (TEMP.GT.XYMAX(I)) XYMAX(I) = TEMP
                           END IF
 20                     CONTINUE
                     IF (IPHASE.GT.0) THEN
                        J = 2*IPHASE+2
                        TEMP = XZY(IPHASE,LP,LC)
                        IF (TEMP.LT.0.0) TEMP = TEMP + 360.0
                        IF ((FIXSCL.GE.0) .OR. (BPARM(J).GE.BPARM(J+1))
     *                     .OR. (BPARM(J).LE.TEMP)) THEN
                           IF (TEMP.LT.XYMIN(3)) XYMIN(3) = TEMP
                           END IF
                        IF ((FIXSCL.GE.0) .OR. (BPARM(J).GE.BPARM(J+1))
     *                     .OR. (BPARM(J+1).GE.TEMP)) THEN
                           IF (TEMP.GT.XYMAX(3)) XYMAX(3) = TEMP
                           END IF
                        END IF
                     END IF
 30               CONTINUE
 40            CONTINUE
 50         CONTINUE
C                                       Last call:
      ELSE
         DO 120 I = 1,2
            IF (XYMAX(I).LE.XYMIN(I)) GO TO 980
C                                       Deal with U,V,W axes
            IF (UVREV) THEN
               XYMAX(I) = MAX (ABS(XYMAX(I)), ABS(XYMIN(I)))
               XYMIN(I) = -XYMAX(I)
               END IF
            IF ((XYMIN(I).GT.0.0) .AND. (XYMIN(I).LT.0.15*XYMAX(I)))
     *         XYMIN(I) = 0.0
 120        CONTINUE
         IF ((XYMIN(3).GT.0.0) .AND. (XYMIN(3).LT.0.15*XYMAX(3)))
     *      XYMIN(3) = 0.0
         IF ((FIXSCL.EQ.2) .AND. (TYPEAX(1).GE.6) .AND. (TYPEAX(1).LE.8)
     *      .AND. (TYPEAX(2).GE.6) .AND. (TYPEAX(2).LE.8)) THEN
            XYMAX(1) = MAX (XYMAX(1), XYMAX(2))
            XYMAX(2) = XYMAX(1)
            XYMIN(1) = MIN (XYMIN(1), XYMIN(2))
            XYMIN(2) = XYMIN(1)
            END IF
         END IF
      GO TO 999
C
 980  IRET = 1
      WRITE (MSGTXT,1980) I
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('XYSCAL: AXIS',I2,' DEGENERATE')
      END
      SUBROUTINE FNDXY (RANDP, BUFR, NP, XZY, MSAMP)
C-----------------------------------------------------------------------
C   FNDXY extracts the desired X and Y values from the Vis record.
C   Inputs:
C      RANDP   R(*)     Random parameters
C      BUFR    R(*)     Visibility record
C      NP      I        number pol in XZY
C   Outputs:
C      XZY      R(3,NP,*)   X, Y values and weight
C-----------------------------------------------------------------------
      INTEGER   NP, MSAMP
      REAL      RANDP(*), BUFR(*), XZY(3,NP,*)
C
      REAL      TR, TI, CATUVR(256), WT, H1, E1, H2, E2, RADPA, A1, A2,
     *   S1, S2, C1, C2
      INTEGER   I, J, LAD, IC, ICO, IA1, IA2, LF, LC, LP, LL, L, IS,
     *   LUN, IERR
      DOUBLE PRECISION FRQMUL, CATUVD(128), FZ, FI, TT, DRA, DDEC, JD0
      LOGICAL   PLANET
      INCLUDE 'WIPER.INC'
      REAL      PA(MAXANT)
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:PSTD.INC'
      EQUIVALENCE (CATUV, CATUVD, CATUVR)
C-----------------------------------------------------------------------
      IF (ILOCB.GE.0) THEN
         IA1 = RANDP(ILOCB+1) / 256. + 0.1
         IA2 = RPARM(ILOCB+1) - 256. * IA1 + 0.1
      ELSE
         IA1 = RANDP(ILOCA1+1) + 0.1
         IA2 = RANDP(ILOCA2+1) + 0.1
         END IF
C                                       Loop over channels
      ICO = ECHAN - BCHAN + 1
      LC = 0
      FRQMUL = 1.0D0
      DO 930 LF = BIF,EIF
         FZ = FOFF(LF) / UVFREQ + 1.0D0
         FI = FINC(LF) / UVFREQ
         DO 920 IC = 1,ICO,CHINC
            LC = LC + 1
            IF (TYPUVD.LE.0) FRQMUL = FZ + FI * (IC - 1 + BCHAN +
     *         (NCHAV-1.0)/2.0 - CATUVR(KRCRP+KLOCFY))
            DO 910 LP = 1,NPOL
               LAD = 1 + (IC-1)*INCF + (LF-BIF)*INCIF + (LP-1)*INCS
               WT = BUFR(LAD+2)
C                                       Loop over axes
               DO 900 I = 1,2
                  TR = 0.0
                  TI = 0.0
                  XZY(I,LP,LC) = FBLANK
                  J = TYPEAX(I)
C                                       amplitudes and phases
                  IF ((J.EQ.1) .OR. (J.EQ.2) .OR. (J.EQ.9) .OR.
     *               (J.EQ.10) .OR. (J.EQ.12) .OR. (J.EQ.13)) THEN
C                                       average channels
                     IF (NCHAV.GT.1) THEN
                        WT = 0.0
                        TR = 0.0
                        TI = 0.0
                        LL = LAD
                        DO 110 L = 1,NCHAV
                           IF (BUFR(LL+2).GT.0.0) THEN
                              WT = WT + BUFR(LL+2)
                              TR = TR + BUFR(LL+2)* BUFR(LL)
                              TI = TI + BUFR(LL+2)* BUFR(LL+1)
                              END IF
                           LL = LL + INCF
 110                       CONTINUE
                        IF (WT.GT.0.0) THEN
                           TR = TR / WT
                           TI = TI / WT
                           END IF
                     ELSE
                        TR = BUFR(LAD)
                        TI = BUFR(LAD+1)
                        END IF
                     IF (WT.LE.0.0) GO TO 900
C                                       amplitude
                     IF (J.EQ.1) THEN
                        IF ((IA1.EQ.IA2) .AND. (.NOT.ISCROS(LP))) THEN
                           XZY(I,LP,LC) = TR
                        ELSE
                           XZY(I,LP,LC) = SQRT (TR*TR + TI*TI)
                           END IF
C                                       log (ampl)
                     ELSE IF (J.EQ.12) THEN
                        XZY(I,LP,LC) = SQRT (TR*TR + TI*TI)
                        XZY(I,LP,LC) = LOG (MAX (1.E-12, XZY(I,LP,LC)))
C                                       phase
                     ELSE IF (J.EQ.2) THEN
                        IF ((TI.NE.0.0) .OR. (TR.NE.0.0)) XZY(I,LP,LC) =
     *                     RAD2DG * ATAN2 (TI, TR)
C                                       Real , Imag , Weight parts
                     ELSE IF (J.EQ.9) THEN
                        XZY(I,LP,LC) = TR
                     ELSE IF (J.EQ.10) THEN
                        XZY(I,LP,LC) = TI
                     ELSE IF (J.EQ.13) THEN
                        XZY(I,LP,LC) = WT
                        END IF
C                                       U, V distance
                  ELSE IF (J.EQ.3) THEN
                     XZY(I,LP,LC) = SQRT (RANDP(1+ILOCU)**2 +
     *                  RANDP(1+ILOCV)**2) * FRQMUL
C                                       U, V position angle
                  ELSE IF (J.EQ.4) THEN
                     TR = RANDP(1+ILOCU)
                     TI = RANDP(1+ILOCV)
                     IF ((TI.NE.0.0) .OR. (TR.NE.0.0)) XZY(I,LP,LC) =
     *                  RAD2DG * ATAN2 (TI, TR)
C                                       Time
C                                       Time (hours)
                  ELSE IF ((J.EQ.5) .OR. (J.EQ.11)) THEN
                     XZY(I,LP,LC) = RANDP(1+ILOCT)
C                                       U projected spacing
                  ELSE IF (J.EQ.6) THEN
                     XZY(I,LP,LC) = RANDP(1+ILOCU) * FRQMUL
C                                       V projected spacing
                  ELSE IF (J.EQ.7) THEN
                     XZY(I,LP,LC) = RANDP(1+ILOCV) * FRQMUL
C                                       W projected spacing
                  ELSE IF (J.EQ.8) THEN
                     XZY(I,LP,LC) = RANDP(1+ILOCW) * FRQMUL
C                                       HA, Elevation
                  ELSE IF ((J.EQ.14) .OR. (J.EQ.15) .OR. (J.EQ.18)) THEN
                     TR = RANDP(1+ILOCT)
                     TT = TR
                     IS = 0
                     IF (ILOCSU.GE.0) IS = RANDP(1+ILOCSU)
                     IF (IS.LE.0) IS = SOUWAN(1)
                     IF (IS.LE.0) IS = 1
                     CALL JULDAY (RDATE, JD0)
                     CALL FNDCOO (0, JD0, IS, DISKIN, CNOIN, CATUV,
     *                  LUN, TR, DRA, DDEC, PLANET, IERR)
                     IF (REFANT.GT.0) THEN
                        CALL COOELV (REFANT, TT, DRA, DDEC, H1, E1, A1)
                        IF (H1.LT.-90.) GO TO 900
                        IF (J.EQ.14) THEN
                           XZY(I,LP,LC) = H1 * RAD2DG / 15.0
                        ELSE IF (J.EQ.18) THEN
                           XZY(I,LP,LC) = A1 * RAD2DG
                        ELSE
                           XZY(I,LP,LC) = E1 * RAD2DG
                           END IF
                     ELSE
                        CALL COOELV (IA1, TT, DRA, DDEC, H1, E1, A1)
                        IF (H1.LT.-90.) GO TO 900
                        CALL COOELV (IA2, TT, DRA, DDEC, H2, E2, A2)
                        IF (H2.LT.-90.) GO TO 900
                        IF (J.EQ.14) THEN
                           S1 = SIN (H1)
                           S2 = SIN (H2)
                           C1 = COS (H1)
                           C2 = COS (H2)
                           XZY(I,LP,LC) = ATAN2 (S1+S2, C1+C2) *
     *                        RAD2DG / 15.
                        ELSE IF (J.EQ.18) THEN
                           S1 = SIN (A1)
                           S2 = SIN (A2)
                           C1 = COS (A1)
                           C2 = COS (A2)
                           XZY(I,LP,LC) = ATAN2 (S1+S2, C1+C2) * RAD2DG
                        ELSE
                           S1 = SIN (E1)
                           S2 = SIN (E2)
                           C1 = COS (E1)
                           C2 = COS (E2)
                           XZY(I,LP,LC) = ATAN2 (S1+S2, C1+C2) * RAD2DG
                           END IF
                        END IF
C                                       Parallactic angle
                  ELSE IF (J.EQ.16) THEN
                     TR = RANDP(1+ILOCT)
                     CALL JULDAY (RDATE, JD0)
                     CALL FNDCOO (0, JD0, IS, DISKIN, CNOIN, CATUV,
     *                  LUN, TR, DRA, DDEC, PLANET, IERR)
                     CALL PARACO (TR, DRA, DDEC, PA)
                     IF (REFANT.GT.0) THEN
                        XZY(I,LP,LC) = PA(REFANT) * RAD2DG
                     ELSE
                        S1 = SIN (PA(IA1))
                        S2 = SIN (PA(IA2))
                        C1 = COS (PA(IA1))
                        C2 = COS (PA(IA2))
                        XZY(I,LP,LC) = ATAN2 (S1+S2, C1+C2) * RAD2DG
                        END IF
C                                      Projected spacing along PA
                  ELSE IF (J.EQ.17) THEN
                     RADPA = ROTATE / RAD2DG
                     XZY(I,LP,LC) = ABS(RANDP(1+ILOCU)*SIN(RADPA) +
     *                  RANDP(1+ILOCV)*COS(RADPA)) * FRQMUL
C                                       frequency
                  ELSE IF (J.EQ.19) THEN
                     XZY(I,LP,LC) = FRQMUL * UVFREQ
C                                       Channel
                  ELSE IF (J.EQ.20) THEN
                     XZY(I,LP,LC) = (LF - 1) * CATUV(KINAX+KLOCFY) +
     *                  BCHAN - 1 + IC
C                                       baseline
                  ELSE IF (J.EQ.21) THEN
                     IF (MSAMP.EQ.1) THEN
                        LL = JANT(IA1)
                        XZY(I,LP,LC) = (LL - 1) * (NSTNS+4) + IA2
                        IF (LL.LE.0) XZY(I,LP,LC) = FBLANK
                     ELSE
                        LL = JANT(IA2)
                        XZY(I,LP,LC) = (LL - 1) * (NSTNS+4) + IA1
                        IF (LL.LE.0) XZY(I,LP,LC) = FBLANK
                        END IF
                     END IF
 900              CONTINUE
               IF (J.EQ.13) THEN
                  XZY(3,LP,LC) = 1.0
               ELSE
                  XZY(3,LP,LC) = WT
                  END IF
 910           CONTINUE
 920        CONTINUE
 930     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE FLAGIT (OPCODE, LUN, DISK, CNO, VERI, VER, LFGRNO,
     *   FGKOLS, FGNUMV, ID, SUBA, FQID, ANT1, ANT2, BTIME, ETIME, BIF,
     *   EIF, BCHAN, ECHAN, PFLAGS, REASON, CATUV, BUFF, IRET)
C-----------------------------------------------------------------------
C   Updates the Flag (FG) table. Adapted from FLAGUP
C   One entry is made indicating a visibility to be rejected.
C   The FLAG table will be opened on the first call but a final call
C   with OPCODE='CLOS' is required to close the file.
C   Inputs:
C      OPCODE   C*4      Operation desired, 'CLOS'=>close file
C                        Anything else = 'FLAG'
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      VERI     I        Input version number
C      VER      I        FG file version
C      LUN      I        Logical unit number to use
C      ID       I(NID)   List of source ID as defined in SOURCE table
C      NID      I        Number of elements in ID
C      SUBA     I        Subarray number.
C      FQID     I        Freqid number
C      ANT1     I        First antenna number in baseline
C      ANT2     I        Second antenna number in baseline
C      BTIME    R        Start time of data to be flagged (Days)
C      ETIME    R        End time of data to be flagged (Days)
C      BIF      I        First IF number to flag. 0=>all
C      EIF      I        Last IF number to flag. 0=>all higher than IFS(1)
C      BCHAN    I        First channel number to flag. 0=>all
C      ECHAN    I        Last channel number to flag. 0=>all higher.
C      PFLAGS   L(4)     Correlator flags
C      REASON   C*24     Reason for flagging blank => ignore for unflag.
C   Input/Output:
C      CATUV    I(256)   Header for disk file to get FG table
C      BUFF     I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      LFGRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      FGKOLS   I(*)     The column pointer array in order, SOURCE,
C                        SUBARRAY, ANTS, TIMERANG, IFS, CHANS, PFLAGS,
C                        REASON
C      FGNUMV   I(*)     Element count in each column.
C   Output:
C      IRET     I        Error code, 0=>OK else TABIO error.
C                        Note: -1 => read, but record deselected.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4, REASON*24
      INTEGER   LUN, DISK, CNO, VERI, VER, LFGRNO, FGKOLS(*), FGNUMV(*),
     *   ID, SUBA, FQID, ANT1, ANT2, BIF, EIF, BCHAN, ECHAN, CATUV(256),
     *   BUFF(*), IRET
      REAL      BTIME, ETIME
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER TREAS*24, CTEMP*12
      INTEGER   IDT, SUBT, ANTS(2), IFS(2), CHANS(2), IDUM, FIND, I,
     *   BUFF2(512), LUN2, IFGKOL(MAXFGC), IFGNUM(MAXFGC), NROW, IFQ,
     *   IFGRNO, OROW
      LOGICAL   PFLAGS(4), TFLAGS(4), FIRST
      REAL      TIMER(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      SAVE FIRST
      DATA FIRST /.TRUE./
C-----------------------------------------------------------------------
C                                       See if table open - check FTAB
      IF (OPCODE.NE.'CLOS') THEN
         FIND = BUFF(82)
C                                       Open file
         IF ((FIND.LT.0) .OR. (FIND.GT.10000) .OR. (LUN.NE.FTAB(FIND)))
     *      THEN
            CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV',
     *         IDUM, 'CLRD', BUFF, IRET)
            CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV',
     *         IDUM, 'CLRD', BUFF, IRET)
            CALL CATFIX (DISK, CNO, 'WRIT')
C           CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV',
C    *         IDUM, 'WRIT', BUFF, IRET)
C
            CALL FLGINI ('WRIT', BUFF, DISK, CNO, VER, CATUV, LUN,
     *         LFGRNO, FGKOLS, FGNUMV, IRET)
C                                       Report on the need for flagging
            WRITE (MSGTXT,1000) VER
            IF (.NOT.FIRST) WRITE (MSGTXT,1001) VER
            CALL MSGWRT (2)
            IF (IRET.NE.0) GO TO 999
C                                       Copy the old file
            IF ((FIRST) .AND. (VERI.GT.0)) THEN
               LUN2 = LUN + 1
               CALL FLGINI ('READ', BUFF2, DISK, CNO, VERI, CATUV, LUN2,
     *            IFGRNO, IFGKOL, IFGNUM, IRET)
               IF (IRET.NE.0) GO TO 999
               NROW = BUFF2(5)
               DO 20 I = 1,NROW
                  CALL TABFLG ('READ', BUFF2, IFGRNO, IFGKOL, IFGNUM,
     *               IDT, SUBT, IFQ, ANTS, TIMER, IFS, CHANS, TFLAGS,
     *               TREAS, IRET)
                  IF (IRET.GT.0) THEN
                     WRITE (MSGTXT,1010) 'READ', I, IRET
                     CALL MSGWRT (8)
                     GO TO 999
                     END IF
                  IF (IRET.EQ.0) THEN
                     CALL TABFLG ('WRIT', BUFF, LFGRNO, FGKOLS, FGNUMV,
     *                  IDT, SUBT, IFQ, ANTS, TIMER, IFS, CHANS, TFLAGS,
     *                  TREAS, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1010) 'WRIT', I, IRET
                        CALL MSGWRT (8)
                        GO TO 999
                        END IF
                     END IF
 20               CONTINUE
               OROW = BUFF(5)
               WRITE (MSGTXT,1002) OROW, NROW, VERI, VER
               CALL MSGWRT (2)
               CALL TABIO ('CLOS', 0, IFGRNO, BUFF2, BUFF2, I)
               END IF
            FIRST = .FALSE.
C                                       Mark as unsorted
            BUFF(43) = 0
            BUFF(44) = 0
            END IF
C                                       Set up for flagging
         ANTS(1) = ANT1
         ANTS(2) = ANT2
         TIMER(1) = BTIME
         TIMER(2) = ETIME
         IFS(1) = BIF
         IFS(2) = EIF
         CHANS(1) = BCHAN
         CHANS(2) = ECHAN
         ID = MAX (ID, 0)
C                                       Flag table entry.
         CALL TABFLG ('WRIT', BUFF, LFGRNO, FGKOLS, FGNUMV, ID, SUBA,
     *      FQID, ANTS, TIMER, IFS, CHANS, PFLAGS, REASON, IRET)
C                                       Close
      ELSE
         CALL TABFLG ('CLOS', BUFF, LFGRNO, FGKOLS, FGNUMV, IDT, SUBT,
     *      FQID, ANTS, TIMER, IFS, CHANS, TFLAGS, TREAS, IRET)
C                                       Clear write status
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV', IDUM,
     *      'CLWR', BUFF, IRET)
C                                       Reset status to read
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, 'UV', IDUM,
     *      'READ', BUFF, IRET)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Found some bad data, will write flags to table FG', I4)
 1001 FORMAT ('Found some bad data, will add   flags to table FG', I4)
 1002 FORMAT ('Copy',I8,' of',I8,' rows from FG vers',I3,' to',I3)
 1010 FORMAT ('ERROR ',A,'ING FG TABLE IN ROW',I7,I5)
      END
      SUBROUTINE TVLOAD (NX, NY, TVCORE, PXINC, TVC, WIN, IRET)
C-----------------------------------------------------------------------
C   Subroutine to load a subset of the plot image to 2 graphics planes.
C   Inputs:
C      NX       I      X dimension of TVCORE
C      NY       I      Y dimension of TVCORE
C      TVCORE   I(*)   Plot data values (> 1 -> valid, < -1 flagged)
C      PXINC    I      Increment in x,y between included pixels
C      TVC      I(4)   TV corners: BLC x,y TRC x,y
C      WIN      I(4)   Map window: ""
C   Outputs
C      IRET     I      Error code: 0 => ok
C                                  1 => input errors
C   Commons: /MAPHDR/ CATBLK  image header
C-----------------------------------------------------------------------
      INTEGER   NX, NY, TVCORE(NX,NY), PXINC, TVC(4), WIN(4), IRET
C
      INTEGER   JERR, I, IYTV, NPIX, IG1, IG2, IX, PLINC, NXINT,
     *   IBUFF(10240), JBUFF(10240), IY, IXTV, J, MX, MY
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL YHOLD ('ONNN', IRET)
C                                       start map read
      IF (PXINC.GE.0) THEN
         PLINC = MAX (1, PXINC)
         NXINT = 1
         NPIX = (WIN(3) - WIN(1)) / PLINC + 1
      ELSE
         PLINC = 1
         NXINT = -PXINC
         NPIX = (1 + WIN(3) - WIN(1)) * NXINT
         END IF
      IG1 = 1 + NGRAY
      IG2 = 4 + NGRAY
      CALL YZERO (IG1, IRET)
      IF (IRET.NE.0) GO TO 990
      CALL YZERO (IG2, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       set up TV writing
      IRET = 1
      IYTV = TVC(2)-1
      DO 70 IY = WIN(2),WIN(4),PLINC
         CALL FILL (NPIX, 0, IBUFF)
         CALL FILL (NPIX, 0, JBUFF)
         IXTV = 1 - NXINT
         DO 40 IX = WIN(1),WIN(3),PLINC
            IXTV = IXTV + NXINT
C                                       "sum"
            IF (PLINC.GT.1) THEN
               MY = MIN (IY+PLINC-1, WIN(4))
               MX = MIN (IX+PLINC-1, WIN(3))
               DO 30 J = IY,MY
                  DO 25 I = IX,MX
                     IF (TVCORE(I,J).GT.1) THEN
                        IBUFF(IXTV) = 1
                        JBUFF(IXTV) = 0
                     ELSE IF (TVCORE(I,J).LT.-1) THEN
                        IF (IBUFF(IXTV).EQ.0) JBUFF(IXTV) = 1
                        END IF
 25                  CONTINUE
 30               CONTINUE
C                                       "interpolate"
            ELSE IF (NXINT.GT.1) THEN
               IF (TVCORE(IX,IY).GT.1) THEN
                  CALL FILL (NXINT,1,IBUFF(IXTV))
               ELSE IF (TVCORE(IX,IY).LT.-1) THEN
                  CALL FILL (NXINT,1,JBUFF(IXTV))
                  END IF
            ELSE
               IF (TVCORE(IX,IY).GT.1) THEN
                  IBUFF(IXTV) = 1
               ELSE IF (TVCORE(IX,IY).LT.-1) THEN
                  JBUFF(IXTV) = 1
                  END IF
               END IF
 40         CONTINUE
C                                       write to TV
         DO 50 J = 1,NXINT
            IYTV = IYTV + 1
            CALL YIMGIO ('WRIT', IG1, TVC(1), IYTV, 0, NPIX, IBUFF,
     *         IRET)
            IF (IRET.NE.0) GO TO 980
            CALL YIMGIO ('WRIT', IG2, TVC(1), IYTV, 0, NPIX, JBUFF,
     *         IRET)
            IF (IRET.NE.0) GO TO 980
 50         CONTINUE
 70      CONTINUE
      IRET = 0
      GO TO 990
C
 980  WRITE (MSGTXT,1980) IRET
      CALL MSGWRT (8)
C
 990  CALL YHOLD ('OFFF', JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('ERROR FROM YIMGIO:',I5)
      END
      SUBROUTINE WIPBOX (IG, TVC, IMW, SCR, IRET)
C-----------------------------------------------------------------------
C   TVFBOX uses a graphics plane to show the user a rectangular box as
C   it is set with the cursor.
C   Inputs:
C      IG      I       graphics plane to use (NGRAY+1 - NGRAY+NGRAPH)
C      TVC     I(4)    TV corners of image
C   In/Out:
C      IMW     I(4)    In: Image corners painted in TVC
C                      Out: Image corners to repaint
C   Output:
C      SCR     I(*)    Scratch buffer: > X dimension (>1280)
C      IRET    I       Error code
C-----------------------------------------------------------------------
      INTEGER   IG, TVC(4), IMW(4), SCR(*), IRET
C
      INTEGER   ITW(3), IL, IX(5), IY(5), QUAD, IBUT, I, JERR, IPOS,
     *   JMW(4), MAG
      REAL      PPOS(2), RPOS(2)
      LOGICAL   T, F, DOIT, ONGR
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Check inputs
      IRET = 2
      IF ((IG.LT.NGRAY+1) .OR. (IG.GT.NGRAY+NGRAPH)) GO TO 999
      MAG = 1 + TVZOOM(1)
      IF (MXZOOM.GT.0) MAG = 2 ** TVZOOM(1)
C                                       Init
      CALL YWINDO ('READ', WINDTV, IRET)
      IF (IRET.NE.0) THEN
         WINDTV(1) = 1
         WINDTV(2) = 1
         WINDTV(3) = MAXXTV(1)
         WINDTV(4) = MAXXTV(2)
         IRET = 0
         END IF
      CALL ZTIME (ITW)
C                                       turn on graphics if needed
      I = 2 ** (IG-1)
      ONGR = MOD (TVLIMG(1)/I, 2) .EQ. 1
      IF (.NOT.ONGR) THEN
         CALL YSLECT ('ONNN', IG, 0, SCR, IRET)
         IPOS = 1
         IF (IRET.NE.0) GO TO 900
         END IF
      IPOS = 2
C                                       Init BLC of new box
      MSGTXT = 'Set B.L.C. : button A, B, C, or D to change to T.R.C.'
      CALL MSGWRT (1)
      RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2.0
      RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2.0
      CALL YCURSE ('FXIT', F, T, RPOS, QUAD, IBUT, IRET)
      IX(1) = RPOS(1) + 0.5
      IX(2) = IX(1)
      IX(3) = MAXXTV(1)
      IX(4) = IX(3)
      IX(5) = IX(4)
      IY(1) = MAXXTV(2)
      IY(2) = RPOS(2) + 0.5
      IY(3) = IY(2)
      IY(4) = IY(2)
      IY(5) = IY(4)
      RPOS(1) = IX(2)
      RPOS(2) = IY(2)
      IL = 1
C                                       No scroll correction
      QUAD = -1
C                                       ON cursor at desired position
 45   PPOS(1) = 0.0
      PPOS(2) = 0.0
      CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IRET)
      IF ((IRET.NE.0) .AND. (IRET.NE.2)) GO TO 900
      IF (IRET.EQ.2) CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IRET)
      IPOS = 3
      IF (IRET.NE.0) GO TO 900
C                                       Cursor read loop
 50   CALL YCURSE ('READ', F, T, RPOS, QUAD, IBUT, IRET)
      IPOS = 4
      IF (IRET.NE.0) GO TO 900
      IF (RPOS(1).LT.TVC(1)) RPOS(1) = TVC(1)
      IF (RPOS(2).LT.TVC(2)) RPOS(2) = TVC(2)
      IF (RPOS(1).GT.TVC(3)) RPOS(1) = TVC(3)
      IF (RPOS(2).GT.TVC(4)) RPOS(2) = TVC(4)
      CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
      IF (.NOT.DOIT) THEN
         GO TO 50
      ELSE
C                                       Erase current box
         CALL IMVECT ('OFFF', IG, 5, IX(1), IY(1), SCR, IRET)
         IPOS = 5
         IF (IRET.NE.0) GO TO 900
C                                       New corners: bottom
         IF (IL.NE.2) THEN
            IX(1) = RPOS(1) + 0.01
            IX(2) = IX(1)
            IY(2) = RPOS(2) + 0.01
            IY(3) = IY(2)
            IF (IL.EQ.1) THEN
               IY(4) = IY(3)
               IY(5) = IY(4)
            ELSE
               IX(5) = IX(1)
               END IF
C                                       top: regular boxes
         ELSE
            IX(3) = RPOS(1) + 0.81
            IX(4) = IX(3)
            IY(1) = RPOS(2) + 0.81
            IY(4) = IY(1)
            IY(5) = IY(1)
            IX(5) = IX(1)
            END IF
C                                       draw all boxes
         CALL IMVECT ('ONNN', IG, 5, IX(1), IY(1), SCR, IRET)
         IPOS = 6 + 100
         IF (IRET.NE.0) GO TO 900
C                                       Respond to buttons
         IF (IBUT.EQ.0) THEN
            GO TO 50
         ELSE
C                                       switch to TRC all buttons
            IF (IL.EQ.1) THEN
               IL = 2
               MSGTXT = 'Set T.R.C. : button A or B to repeat other'
     *            // ' corner'
               CALL MSGWRT (1)
               MSGTXT = 'Push C or D to exit'
               CALL MSGWRT (1)
               RPOS(1) = RPOS(1) + 10.0
               RPOS(2) = RPOS(2) + 10.0
               IF (RPOS(1).GT.MAXXTV(1)) RPOS(1) = MAXXTV(1)
               IF (RPOS(2).GT.MAXXTV(2)) RPOS(2) = MAXXTV(2)
C                                       switch to other corn, but A
            ELSE IF (IBUT.LE.2) THEN
               IF (IL.NE.3) THEN
                  IL = 3
                  RPOS(1) = IX(2)
                  RPOS(2) = IY(2)
                  MSGTXT = 'Reset B.L.C. : button A or B to repeat'
     *               // ' other corner'
               ELSE
                  IL = 2
                  RPOS(1) = IX(4)
                  RPOS(2) = IY(4)
                  MSGTXT = 'Reset T.R.C. : button A or B to repeat'
     *               // ' other corner'
                  END IF
               CALL MSGWRT (1)
               MSGTXT = 'Push C or D to exit'
               CALL MSGWRT (1)
               END IF
            IF (IBUT.LE.2) GO TO 45
            END IF
         END IF
C                                       force real BLC, TRC
      CALL IMVECT ('OFFF', IG, 5, IX(1), IY(1), SCR, IRET)
      IF (IX(2).GT.IX(4)) THEN
         JERR = IX(2)
         IX(2) = IX(4)
         IX(4) = JERR
         END IF
      IF (IY(2).GT.IY(4)) THEN
         JERR = IY(2)
         IY(2) = IY(4)
         IY(4) = JERR
         END IF
      CALL COPY (4, IMW, JMW)
      IMW(1) = JMW(1) + REAL(IX(2)-TVC(1)) / REAL(TVC(3)-TVC(1)) *
     *   REAL(JMW(3)-JMW(1)) + 0.5
      IMW(2) = JMW(2) + REAL(IY(2)-TVC(2)) / REAL(TVC(4)-TVC(2)) *
     *   REAL(JMW(4)-JMW(2)) + 0.5
      IMW(3) = JMW(1) + REAL(IX(4)-TVC(1)) / REAL(TVC(3)-TVC(1)) *
     *   REAL(JMW(3)-JMW(1)) + 0.5
      IMW(4) = JMW(2) + REAL(IY(4)-TVC(2)) / REAL(TVC(4)-TVC(2)) *
     *   REAL(JMW(4)-JMW(2)) + 0.5
      IRET = 0
C                                       Off cursor, graphics, scroll
 900  CALL YCURSE ('OFFF', F, T, RPOS, QUAD, IBUT, JERR)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1900) IRET, IPOS
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1900 FORMAT ('WIPBOX: ERROR CODE',I7,' AT',I5)
      END
      SUBROUTINE WIPEIT (ITY, ISN, NX, NY, TVCORE, NBL, BLCORE, IRET)
C-----------------------------------------------------------------------
C   Does the interactive editing functions
C   Inputs:
C      ITY      I      Type: 1-4 => point, area, fast, fat fast
C      ISN      I      1 flag, -1 unflag
C      TVC      I(4)   TV pixel corners
C      IMW      I(4)   Image corners
C      NX       I      X dimension of TVCORE
C      NY       I      Y dimension of TVCORE
C      NBL      I      Max number baselines in BLCORE
C      BLCORE   I(*)   Basseline IDs
C   In/out:
C      TVCORE   I(*)   Image of plot
C   Outputs:
C      IRET     I      Error code
C-----------------------------------------------------------------------
      INTEGER   ITY, ISN, NX, NY, TVCORE(NX,NY), NBL, BLCORE(NBL,NX,NY),
     *   IRET
C
      INTEGER   WW
      PARAMETER (WW = 15)
C
      CHARACTER STRING*24
      INTEGER   GV, GC, IG1, IG2, ITW(3), NPIX, NROW, MAG, IX0, IY0, IX,
     *   IY, ECOUNT, QUAD, IBUT, IX1, IY1, IMX, IMY, PIXVAL, FMT, TVX,
     *   TVY, IXP(5), IYP(5), TVC(4), DOBLC, I, I1, I2, J, NS, J2,
     *   MASK(2*WW-1,2*WW-1), MTYP, SP, LMX, LMY, WIN(4), NXINT,
     *   IBUFF(10240), JBUFF(10240), IMX1, IMX2, IMY1, IMY2, II, LCOUNT,
     *   MCOUNT, IA1, IA2, IDUM(4)
      REAL      PPOS(2), RPOS(2), XFACT, YFACT, LPOS(2), WR, TEMP, TT
      LOGICAL   DOIT, T, F, STARTD
      DOUBLE PRECISION CRD
      INCLUDE 'WIPER.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      STARTD = .FALSE.
      MTYP = XDOCEN + 1.5
C                                       make mask
      IF (ITY.EQ.4) THEN
         J = (2*WW-1) ** 2
         CALL FILL (J, 0, MASK)
         WR = BPARM(9)
         IF (WR.LT.0.5) WR = 1.2
         IF (WR.GT.WW-2) WR = WW-2
         BPARM(9) = WR
         I1 = WW - WR - 0.5
         I2 = WW + WR + 0.5
         I1 = MAX (1, I1)
         I2 = MIN (2*WW-1, I2)
         TT = WW
         DO 20 J = I1,I2
            DO 10 I = I1,I2
               TEMP = SQRT ((I-TT)**2 + (J-TT)**2)
               IF (TEMP.LT.WR) MASK(I,J) = 1
 10            CONTINUE
 20         CONTINUE
         END IF
C
      CALL ZTIME (ITW)
      CALL FILL (5, 1, IXP)
      CALL FILL (5, 1, IYP)
      DOBLC = 0
      FMT = 11
      IF ((NX.LT.10000) .AND. (NY.LT.10000)) THEN
         FMT = 10
         IF ((NX.LT.1000) .AND. (NY.LT.1000)) FMT = 9
         END IF
C                                       Turn on graphics
      GV = NGRAY + 3
      GC = NGRAY + 2
      IG1 = NGRAY + 1
      IG2 = NGRAY + 4
      CALL YHOLD ('ONNN', IRET)
      IF (IRET.NE.0) GO TO 970
      CALL YZERO (GC, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL YSLECT ('ONNN', GC, 0, TVSCR, IRET)
      IF (IRET.NE.0) GO TO 970
      IF (ITY.EQ.2) THEN
         CALL YZERO (GV, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YSLECT ('ONNN', GV, 0, TVSCR, IRET)
         IF (IRET.NE.0) GO TO 970
         END IF
C                                       Display area: location, size
C                                       Approx corr for zoom
      CALL COPY (4, TVCAT(IICOR), TVC)
      CALL COPY (4, TVCAT(IIWIN), WIN)
      NPIX = 15 * CSIZTV(1)
      IF (MAXANT.GT.99) NPIX = 19 * CSIZTV(1)
      NROW = 7.5 * CSIZTV(2) + 0.5
      MAG = 1 + TVZOOM(1)
      IF (MXZOOM.GT.0) MAG = 2 ** TVZOOM(1)
      IY0 = WINDTV(4) - MAG*NROW + 1 - (MAG-1)/2 - (CSIZTV(2)+1) / 2
      IF (MAG.GT.1) IY0 = IY0 + MAG
      IY0 = (IY0 - TVZOOM(3)) / MAG + TVZOOM(3)
      IY = MOD (IY0 - 1 - TVSCGY + 3*MAXXTV(2), MAXXTV(2)) + 1
      IY0 = MAX (1, IY)
      IF (IY0+NROW-1.GT.MAXXTV(2)) IY0 = MAXXTV(2) - NROW
C                                       Set X position
      IF (MTYP.LE.0) THEN
         IX0 = WINDTV(1) - (MAG-1)/2 + 1.5*CSIZTV(1)
      ELSE IF (MTYP.EQ.1) THEN
         IX0 = WINDTV(3) - (MAG-1)/2 - MAG*NPIX + 1
      ELSE
         IX0 = (WINDTV(1)+WINDTV(3)-NPIX) / 2 - (MAG-1)/2 + 1
         END IF
      IX0 = (IX0 - TVZOOM(2)) / MAG + TVZOOM(2)
      IX = MOD (IX0 - 1 - TVSCGX + 3*MAXXTV(1), MAXXTV(1)) + 1
      IX0 = MAX (1, IX)
      IF (IX0+NPIX-1.GT.MAXXTV(1)) IX0 = MAXXTV(1) - NPIX + 1
C                                       Fill with 1's, 0's
      IX1 = IX0 + NPIX - 1
      IY1 = IY0 + NROW - 1
      CALL YFILL (GC, IX0, IY0, IX1, IY1, 0, TVSCR, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL YHOLD ('OFFF', IRET)
C                                       Flagging
      IF (ITY.EQ.1) THEN
         MSGTXT = 'Hit button A or B to mark flagged position, '
     *      // 'loop for more'
         CALL MSGWRT (1)
         MSGTXT = 'Hit button C to mark flagged position, return to'
     *      // ' menu'
      ELSE IF (ITY.EQ.2) THEN
         MSGTXT = 'Hit button A to switch between BLC and TRC'
         CALL MSGWRT (1)
         MSGTXT = 'Hit button B to mark final box, loop for more'
         CALL MSGWRT (1)
         MSGTXT = 'Hit button C to mark final box, return to menu'
      ELSE
         MSGTXT = 'Position cursor, then hit button, A, B, or C'
     *      // ' to start operation'
         CALL MSGWRT (1)
         MSGTXT = 'Then simply position cursor on point to flag'
         CALL MSGWRT (1)
         MSGTXT = 'Hit buttons A, B, or C to flag and then return'
     *      // ' to menu'
         END IF
      CALL MSGWRT (1)
C                                       instructions: Button D
      MSGTXT = 'Hit button D to exit - no further flagging'
      CALL MSGWRT (1)
C                                       turn on cursor
      ECOUNT = 0
      RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
      RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2
      CALL YCURSE ('FXIT', F, T, RPOS, QUAD, IBUT, IRET)
      XFACT = REAL (TVC(3) - TVC(1)) / REAL (WIN(3)-WIN(1))
      YFACT = REAL (TVC(4) - TVC(2)) / REAL (WIN(4)-WIN(2))
      NXINT = XFACT + 0.1
      LCOUNT = 0
      MCOUNT = 0
 105  PPOS(1) = 0.0
      PPOS(2) = 0.0
      CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IRET)
      IF ((IRET.NE.0) .AND. (IRET.NE.2)) GO TO 970
C                                       Cursor read loop point
 110  CALL YCURSE ('READ', F, T, RPOS, QUAD, IBUT, IRET)
      IF ((IBUT.GE.8) .OR. (IRET.NE.0)) GO TO 970
      LPOS(1) = RPOS(1)
      LPOS(2) = RPOS(2)
      IF (ITY.NE.4) THEN
         IF (RPOS(1).LT.TVC(1)) RPOS(1) = TVC(1)
         IF (RPOS(2).LT.TVC(2)) RPOS(2) = TVC(2)
         IF (RPOS(1).GT.TVC(3)) RPOS(1) = TVC(3)
         IF (RPOS(2).GT.TVC(4)) RPOS(2) = TVC(4)
      ELSE
         RPOS(1) = MAX (RPOS(1), TVC(1)-WR)
         RPOS(2) = MAX (RPOS(2), TVC(2)-WR)
         RPOS(1) = MIN (RPOS(1), TVC(3)+WR)
         RPOS(2) = MIN (RPOS(2), TVC(4)+WR)
         END IF
      CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
      IF (DOIT) THEN
         TVX = RPOS(1) + 0.49
         TVY = RPOS(2) + 0.49
         IMX = (RPOS(1) - TVC(1)) / XFACT + 0.49 + TVCAT(IIWIN)
         IMY = (RPOS(2) - TVC(2)) / YFACT + 0.49 + TVCAT(IIWIN+1)
C                                       Write text to TV: pixel
         IF (FMT.EQ.11) THEN
            WRITE (STRING,1120) IMX, IMY
         ELSE IF (FMT.EQ.10) THEN
            WRITE (STRING,1121) IMX, IMY
         ELSE
            WRITE (STRING,1122) IMX, IMY
            END IF
         IY = IY0 + 6.0*CSIZTV(2) + 0.5
         CALL YHOLD ('ONNN', IRET)
         CALL IMCHAR (GC, IX0, IY, 0, 0, STRING(:11), TVSCR, IRET)
         IF (IRET.NE.0) GO TO 970
C                                       count
         LMX = MAX (1, MIN (NX, IMX))
         LMY = MAX (1, MIN (NY, IMY))
         PIXVAL = TVCORE (LMX,LMY)
         IF (PIXVAL.GT.1) THEN
            PIXVAL = PIXVAL - 1
         ELSE IF (PIXVAL.LT.-1) THEN
            PIXVAL = PIXVAL + 1
         ELSE
            PIXVAL = 0
            END IF
         WRITE (STRING,1125) PIXVAL
         CALL REFRMT (STRING, '_', IY)
         IY = IY0 + 1.5*CSIZTV(2) + 0.5
         CALL IMCHAR (GC, IX0, IY, 0, 0, STRING(:11), TVSCR, IRET)
         IF (IRET.NE.0) GO TO 970
         CRD = TVCATD(KDCRV) + (LMX - TVCATR(KRCRP)) * TVCATR(KRCIC)
         CRD = CRD * SCALXY(1)
         IF (TYPEAX(1).EQ.21) THEN
            CALL BLTEXT (CRD, 'X', STRING)
         ELSE IF (FMT.EQ.11) THEN
            WRITE (STRING,1130) 'X', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1131) 'X', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1132) 'X', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1133) 'X', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1134) 'X', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1135) 'X', CRD
         ELSE IF (FMT.EQ.10) THEN
            WRITE (STRING,1140) 'X', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1141) 'X', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1142) 'X', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1143) 'X', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1144) 'X', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1145) 'X', CRD
         ELSE
            WRITE (STRING,1150) 'X', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1151) 'X', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1152) 'X', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1153) 'X', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1154) 'X', CRD
            END IF
         IY = IY0 + 4.5 * CSIZTV(2)
         CALL IMCHAR (GC, IX0, IY, 0, 0, STRING(:11), TVSCR, IRET)
         IF (IRET.NE.0) GO TO 970
         CRD = TVCATD(KDCRV+1) + (LMY-TVCATR(KRCRP+1)) * TVCATR(KRCIC+1)
         CRD = CRD * SCALXY(2)
         IF (TYPEAX(2).EQ.21) THEN
            CALL BLTEXT (CRD, 'Y', STRING)
         ELSE IF (FMT.EQ.11) THEN
            WRITE (STRING,1130) 'Y', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1131) 'Y', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1132) 'Y', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1133) 'Y', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1134) 'Y', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1135) 'Y', CRD
         ELSE IF (FMT.EQ.10) THEN
            WRITE (STRING,1140) 'Y', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1141) 'Y', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1142) 'Y', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1143) 'Y', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1144) 'Y', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1145) 'Y', CRD
         ELSE
            WRITE (STRING,1150) 'Y', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1151) 'Y', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1152) 'Y', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1153) 'Y', CRD
            IF (STRING(FMT:FMT).EQ.'*') WRITE (STRING,1154) 'Y', CRD
            END IF
         IY = IY0 + 3.0 * CSIZTV(2) + 0.5
         CALL IMCHAR (GC, IX0, IY, 0, 0, STRING(:11), TVSCR, IRET)
         IF (IRET.NE.0) GO TO 970
C                                       baseline
         STRING = ' '
         NS = 0
         SP = 1
         J2 = MIN (MBL, NBL-1)
         DO 120 J = 1,J2
            IF (BLCORE(J,LMX,LMY).GT.0) THEN
               NS = NS + 1
               IF ((NS.EQ.1) .OR. (NS.EQ.2)) THEN
                  IA1 = BLCORE(J,LMX,LMY) / 1000
                  IA2 = BLCORE(J,LMX,LMY) - IA1*1000
                  IF (IA1.GT.99) THEN
                     WRITE (STRING(SP:SP+2),1160) IA1
                     SP = SP + 3
                  ELSE
                     WRITE (STRING(SP:SP+1),1161) IA1
                     SP = SP + 2
                     END IF
                  STRING(SP:SP) = '-'
                  SP = SP + 1
                  IF (IA2.GT.99) THEN
                     WRITE (STRING(SP:SP+2),1160) IA2
                     SP = SP + 3
                  ELSE
                     WRITE (STRING(SP:SP+1),1161) IA2
                     SP = SP + 2
                     END IF
                  SP = SP + 1
               ELSE IF (NS.EQ.3) THEN
                  STRING(SP:SP) = '+'
                  END IF
               END IF
 120        CONTINUE
         DO 125 J = 1,MBL
            IF (BLCORE(J,LMX,LMY).LT.0) THEN
               NS = NS + 1
               IF (J.EQ.MBL) NS = MAX (3, NS)
               IF ((NS.EQ.1) .OR. (NS.EQ.2)) THEN
                  STRING(SP:SP) = 'F'
                  SP = SP + 1
                  IA1 = -BLCORE(J,LMX,LMY) / 1000
                  IA2 = -BLCORE(J,LMX,LMY) - IA1*1000
                  IF (IA1.GT.99) THEN
                     WRITE (STRING(SP:SP+2),1160) IA1
                     SP = SP + 3
                  ELSE
                     WRITE (STRING(SP:SP+1),1161) IA1
                     SP = SP + 2
                     END IF
                  STRING(SP:SP) = '-'
                  SP = SP + 1
                  IF (IA2.GT.99) THEN
                     WRITE (STRING(SP:SP+2),1160) IA2
                     SP = SP + 3
                  ELSE
                     WRITE (STRING(SP:SP+1),1161) IA2
                     SP = SP + 2
                     END IF
                  SP = SP + 1
               ELSE IF (NS.EQ.3) THEN
                  STRING(SP:SP+1) = '+F'
                  SP = SP + 2
                  END IF
               END IF
 125        CONTINUE
         SP = MAX (SP, 2)
         IY = IY0
         CALL IMCHAR (GC, IX0, IY, 0, 0, STRING(:19), TVSCR, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YHOLD ('OFFF', IRET)
C                                       flagging or boxes
         IF ((IBUT.GT.0) .AND. (.NOT.STARTD)) THEN
            STARTD = .TRUE.
            IF (ITY.GT.2) IBUT = 0
            END IF
         IF (ITY.NE.4) THEN
            LCOUNT = 0
            MCOUNT = 0
            END IF
         IF (((ITY.EQ.1) .AND. (IBUT.GT.0)) .OR. ((ITY.EQ.3) .AND.
     *      (STARTD))) THEN
            IF (ISN*TVCORE(IMX,IMY).GT.1) THEN
               TVCORE(IMX,IMY) = -TVCORE(IMX,IMY)
               IF (TVCORE(IMX,IMY).GT.0) THEN
                  IX = 1
                  IY = 0
               ELSE
                  IX = 0
                  IY = 1
                  END IF
               FLGPIX = FLGPIX + ISN
               LCOUNT = LCOUNT + 1
               MCOUNT = MCOUNT + ABS (TVCORE(IMX,IMY)) - 1
               IF (NXINT.EQ.1) THEN
                  IDUM(1) = IX
                  CALL YIMGIO ('WRIT', IG1, TVX, TVY, 0, 1, IDUM, IRET)
                  IF (IRET.NE.0) GO TO 970
                  IDUM(1) = IY
                  CALL YIMGIO ('WRIT', IG2, TVX, TVY, 0, 1, IDUM, IRET)
                  IF (IRET.NE.0) GO TO 970
               ELSE
                  TVX = (IMX - WIN(1)) * NXINT + TVC(1)
                  TVY = (IMY - WIN(2)) * NXINT + TVC(2)
                  CALL FILL (NXINT, IX, IBUFF)
                  CALL FILL (NXINT, IY, JBUFF)
                  DO 130 I = 1,NXINT
                     CALL YIMGIO ('WRIT', IG1, TVX, TVY, 0, NXINT,
     *                  IBUFF, IRET)
                     IF (IRET.NE.0) GO TO 970
                     CALL YIMGIO ('WRIT', IG2, TVX, TVY, 0, NXINT,
     *                  JBUFF, IRET)
                     IF (IRET.NE.0) GO TO 970
                     TVY = TVY + 1
 130                 CONTINUE
                  END IF
               END IF
            IF (ISN.GT.0) THEN
               WRITE (MSGTXT,1100) 'Flagged', LCOUNT, MCOUNT
            ELSE
               WRITE (MSGTXT,1100) 'Unflagged', LCOUNT, MCOUNT
               END IF
            IF (LCOUNT.GT.0) CALL MSGWRT (3)
            IF (IBUT+ITY.GE.4) GO TO 970
C                                       fat fast
         ELSE IF ((ITY.EQ.4) .AND. (STARTD)) THEN
            IF (ISN.LT.0) THEN
               IX = 1
               IY = 0
            ELSE
               IX = 0
               IY = 1
               END IF
            IMX1 = IMX - WR - 0.5
            IMX2 = IMX + WR + 0.5
            IMX1 = MAX (WIN(1), IMX1)
            IMX2 = MIN (WIN(3), IMX2)
            IMY1 = IMY - WR - 0.5
            IMY2 = IMY + WR + 0.5
            IMY1 = MAX (WIN(2), IMY1)
            IMY2 = MIN (WIN(4), IMY2)
            CALL YHOLD ('ONNN', IRET)
            DO 145 J = IMY1,IMY2
               DO 140 I = IMX1,IMX2
                  IF (MASK(I-IMX+WW,J-IMY+WW)*ISN*TVCORE(I,J).GT.1)
     *               THEN
                     FLGPIX = FLGPIX + ISN
                     TVCORE(I,J) = -TVCORE(I,J)
                     TVX = (I - WIN(1)) * NXINT + TVC(1)
                     TVY = (J - WIN(2)) * NXINT + TVC(2)
                     CALL FILL (NXINT, IX, IBUFF)
                     CALL FILL (NXINT, IY, JBUFF)
                     LCOUNT = LCOUNT + 1
                     MCOUNT = MCOUNT + ABS (TVCORE(I,J)) - 1
                     DO 135 II = 1,NXINT
                        CALL YIMGIO ('WRIT', IG1, TVX, TVY, 0, NXINT,
     *                     IBUFF, IRET)
                        IF (IRET.NE.0) GO TO 970
                        CALL YIMGIO ('WRIT', IG2, TVX, TVY, 0, NXINT,
     *                     JBUFF, IRET)
                        IF (IRET.NE.0) GO TO 970
                        TVY = TVY + 1
 135                    CONTINUE
                     END IF
 140              CONTINUE
 145           CONTINUE
            CALL YHOLD ('OFFF', IRET)
            IF (IBUT.GT.0) THEN
               IF (ISN.GT.0) THEN
                  WRITE (MSGTXT,1101) 'Flagged', LCOUNT, MCOUNT
               ELSE
                  WRITE (MSGTXT,1101) 'Unflagged', LCOUNT, MCOUNT
                  END IF
               CALL MSGWRT (3)
               GO TO 970
               END IF
         ELSE IF (ITY.EQ.2) THEN
            CALL IMVECT ('OFFF', GV, 5, IXP, IYP, TVSCR, IRET)
            IF (IRET.NE.0) GO TO 970
            IF (IBUT.GT.7) GO TO 970
C                                       init position
            IF (DOBLC.EQ.0) THEN
               IXP(1) = TVX
               IXP(2) = IXP(1)
               IXP(3) = IXP(1)
               IXP(4) = MAXXTV(1)
               IXP(5) = IXP(4)
               IYP(1) = MAXXTV(2)
               IYP(2) = IYP(1)
               IYP(3) = TVY
               IYP(4) = IYP(3)
               IYP(5) = IYP(3)
C                                       setting BLC
            ELSE IF (DOBLC.EQ.1) THEN
               IXP(3) = TVX
               IXP(2) = IXP(3)
               IYP(3) = TVY
               IYP(4) = IYP(3)
C                                       setting TRC
            ELSE
               IXP(1) = TVX
               IXP(4) = IXP(1)
               IXP(5) = IXP(1)
               IYP(1) = TVY
               IYP(2) = IYP(1)
               IYP(5) = IYP(1)
               END IF
            CALL IMVECT ('ONNN', GV, 5, IXP, IYP, TVSCR, IRET)
            IF (IRET.NE.0) GO TO 970
C                                       respond to buttons: switch
            IF ((IBUT.EQ.1) .OR. ((IBUT.GT.1) .AND. (DOBLC.EQ.0))) THEN
               IF (DOBLC.EQ.0) THEN
                  CALL IMVECT ('OFFF', GV, 5, IXP, IYP, TVSCR, IRET)
                  IF (IRET.NE.0) GO TO 970
                  IXP(4) = IXP(3) + 10
                  IXP(1) = IXP(4)
                  IXP(5) = IXP(4)
                  IYP(2) = IYP(3) + 10
                  IYP(1) = IYP(2)
                  IYP(5) = IYP(2)
                  DOBLC = -1
                  CALL IMVECT ('ONNN', GV, 5, IXP, IYP, TVSCR, IRET)
                  IF (IRET.NE.0) GO TO 970
               ELSE
                  DOBLC = -DOBLC
                  END IF
               IF (DOBLC.EQ.1) THEN
                  RPOS(1) = IXP(3)
                  RPOS(2) = IYP(3)
               ELSE
                  RPOS(1) = IXP(1)
                  RPOS(2) = IYP(2)
                  END IF
C                                       flag the area
            ELSE IF (IBUT.GT.1) THEN
               IF (IXP(3).GT.IXP(1)) THEN
                  TVX = IXP(3)
                  IXP(3) = IXP(1)
                  IXP(1) = TVX
                  END IF
               IF (IYP(3).GT.IYP(1)) THEN
                  TVY = IYP(3)
                  IYP(3) = IYP(1)
                  IYP(1) = TVY
                  END IF
               IMX1 = (IXP(3) - TVC(1)) / XFACT + 0.49 + WIN(1)
               IMY1 = (IYP(3) - TVC(2)) / YFACT + 0.49 + WIN(2)
               IMX2 = (IXP(1) - TVC(1)) / XFACT + 0.49 + WIN(1)
               IMY2 = (IYP(1) - TVC(2)) / YFACT + 0.49 + WIN(2)
               IF (ISN.LT.0) THEN
                  IX = 1
                  IY = 0
               ELSE
                  IX = 0
                  IY = 1
                  END IF
               CALL YHOLD ('ONNN', IRET)
               DO 170 IMY = IMY1,IMY2
                  DO 160 IMX = IMX1,IMX2
                     IF (ISN*TVCORE(IMX,IMY).GT.1) THEN
                        TVCORE(IMX,IMY) = -TVCORE(IMX,IMY)
                        FLGPIX = FLGPIX + ISN
                        IF (NXINT.EQ.1) THEN
                           IBUFF(1) = IX
                           JBUFF(1) = IY
                        ELSE
                           CALL FILL (NXINT, IX, IBUFF)
                           CALL FILL (NXINT, IY, JBUFF)
                           END IF
                        TVX = (IMX - WIN(1)) * NXINT + TVC(1)
                        TVY = (IMY - WIN(2)) * NXINT + TVC(2)
                        LCOUNT = LCOUNT + 1
                        MCOUNT = MCOUNT + ABS (TVCORE(IMX,IMY)) - 1
                        DO 150 I = 1,NXINT
                           CALL YIMGIO ('WRIT', IG1, TVX, TVY, 0, NXINT,
     *                        IBUFF, IRET)
                           IF (IRET.NE.0) GO TO 970
                           CALL YIMGIO ('WRIT', IG2, TVX, TVY, 0, NXINT,
     *                        JBUFF, IRET)
                           IF (IRET.NE.0) GO TO 970
                           TVY = TVY + 1
 150                       CONTINUE
                        END IF
 160                 CONTINUE
 170              CONTINUE
               DOBLC = 0
               CALL IMVECT ('OFFF', GV, 5, IXP, IYP, TVSCR, IRET)
               IF (IRET.NE.0) GO TO 970
               IF (ISN.GT.0) THEN
                  WRITE (MSGTXT,1100) 'Flagged', LCOUNT, MCOUNT
               ELSE
                  WRITE (MSGTXT,1100) 'Unflagged', LCOUNT, MCOUNT
                  END IF
               CALL MSGWRT (3)
               IF (IBUT.GT.3) GO TO 970
               CALL FILL (5, 1, IXP)
               CALL FILL (5, 1, IYP)
               PPOS(1) = 0.
               CALL YHOLD ('OFFF', IRET)
               END IF
            END IF
         END IF
      IF (ITY.EQ.4) GO TO 110
      IF ((LPOS(1).NE.RPOS(1)) .OR. (LPOS(2).NE.RPOS(2))) GO TO 105
      GO TO 110
C-----------------------------------------------------------------------
C                                       Close downs
C                                       TV error possibly
 970  IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1970) IRET
         CALL MSGWRT (6)
         END IF
      CALL YZERO (GC, IY)
      CALL YHOLD ('OFFF', IY)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT (A,I6,' pixels',I9,' vis points')
 1101 FORMAT (A,I7,' pixels',I12,' vis points')
 1120 FORMAT (I5,',',I5)
 1121 FORMAT (I4,',',I5)
 1122 FORMAT (I3,',',I4)
 1125 FORMAT ('COUNT',I6)
 1130 FORMAT (A1,'=',F9.5)
 1131 FORMAT (A1,'=',F9.4)
 1132 FORMAT (A1,'=',F9.3)
 1133 FORMAT (A1,'=',F9.2)
 1134 FORMAT (A1,'=',F9.1)
 1135 FORMAT (A1,'=',F9.0)
 1140 FORMAT (A1,1X,F8.5)
 1141 FORMAT (A1,1X,F8.4)
 1142 FORMAT (A1,1X,F8.3)
 1143 FORMAT (A1,1X,F8.2)
 1144 FORMAT (A1,1X,F8.1)
 1145 FORMAT (A1,1X,F8.0)
 1150 FORMAT (A1,1X,F7.4)
 1151 FORMAT (A1,1X,F7.3)
 1152 FORMAT (A1,1X,F7.2)
 1153 FORMAT (A1,1X,F7.1)
 1154 FORMAT (A1,1X,F7.0)
 1160 FORMAT (I3.2)
 1161 FORMAT (I2.2)
 1970 FORMAT ('WIPEIT: TV ACTION IO ERROR',I7)
      END
      SUBROUTINE BLTEXT (CRD, AX, STRING)
C-----------------------------------------------------------------------
C   BLTEXT returns a baseline string
C   Inputs:
C      CRD      R       Axis value
C      AX       C*1     Axis ('X' or 'Y')
C   Output
C      STRING   C*(*)   String with baseline
C-----------------------------------------------------------------------
      DOUBLE PRECISION CRD
      CHARACTER AX*1, STRING*(*)
C
      INCLUDE 'WIPER.INC'
      INCLUDE 'INCS:DANS.INC'
      INTEGER   I, IA1, IA2
C-----------------------------------------------------------------------
      I = CRD + 0.5D0
      IA1 = I / (NSTNS+4) + 1
      IA2 = I - (IA1-1)*(NSTNS+4)
      WRITE (STRING,1000) AX, IA1, IA2
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A1,I4.2,'-',I2.2)
      END
      SUBROUTINE REPORT (NA, NI, NP, MALL, MBAD, MSOM, NBDCOR, FLGPIX)
C-----------------------------------------------------------------------
C   Print the reports
C   Inputs:
C      NA      I      Number of antennas
C      NI      I      Number of IFs
C      MALL    I(*)   Counts samples by baseline etc
C      MBAD    I(*)   Counts full bad spectra by baseline
C      MSOM    I(*)   Counts partly bad spectra by baseline
C-----------------------------------------------------------------------
      INTEGER   NA, NI, NP, MALL(NA,NA,NP,NI), MBAD(NA,NA,NP,NI),
     *   MSOM(NA,NA,NP,NI), NBDCOR, FLGPIX
C
      INTEGER   I, J, K, L, TOTALA, TOTALB, MMAX, MXA, I1, I2, TOTALS,
     *   MA, MB
      INCLUDE 'INCS:DSEL.INC'
      INTEGER   MAUX(MAXANT)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       First add the totals
      DO 100 K = 1,NP
         DO 90 L = 1,NI
            TOTALA = 0
            TOTALB = 0
            TOTALS = 0
            MMAX = 0
            MXA = 0
            DO 15 I = 1,NA
               DO 10 J = 1,NA
                  IF (MALL(I,J,K,L).GT.0) THEN
                     MXA = MAX (MXA, I)
                     MXA = MAX (MXA, J)
                     TOTALA = TOTALA + MALL(I,J,K,L)
                     IF (MALL(I,J,K,L).GT.MMAX) MMAX = MALL(I,J,K,L)
                     END IF
                  TOTALB = TOTALB + MBAD(I,J,K,L)
                  TOTALS = TOTALS + MSOM(I,J,K,L)
 10               CONTINUE
 15            CONTINUE
C                                       Now report on all visibilities
            IF (TOTALA.GT.0) THEN
               I = L + BIF - 1
               IF (ECHAN.LE.0) THEN
                  WRITE (MSGTXT,1020) TOTALB, TOTALA, I, K
                  CALL MSGWRT (4)
               ELSE
                  WRITE (MSGTXT,1021) TOTALB, TOTALA, I, K
                  CALL MSGWRT (4)
                  WRITE (MSGTXT,1022) TOTALS, TOTALA, I, K
                  CALL MSGWRT (4)
                  END IF
               WRITE (MSGTXT,1025) MMAX
               CALL MSGWRT (4)
               I1 = 1
 25            I2 = MIN (I1+27, MXA)
               IF (I2.GE.I1) THEN
                  DO 40 I= 1,MXA
                     DO 30 J= I1,I2
                        MAUX(J) = MALL(I,J,K,L)
                        MAUX(J) = NINT ((10. * MAUX(J)) / MMAX)
 30                     CONTINUE
                     WRITE (MSGTXT,1035) I, (MAUX(J), J = I1,I2)
                     CALL MSGWRT (4)
 40                  CONTINUE
                  I1 = I2 + 1
                  GO TO 25
                  END IF
               END IF
C                                       Now report percentage flagged
            IF ((TOTALA.GT.0) .AND. (TOTALB.GT.0)) THEN
               MSGTXT = 'Visibilities flagged (percent):'
               IF (ECHAN.GT.1) MSGTXT = 'Visibility spectra fully'
     *            // ' flagged (percent):'
               CALL MSGWRT (4)
               I1 = 1
 45            I2 = MIN (I1+27, MXA)
               IF (I2.GE.I1) THEN
                  DO 60 I = 1,MXA
                     DO 50 J = I1,I2
                        MA = MALL(I,J,K,L)
                        MB = MBAD(I,J,K,L)
                        IF (MA.GT.0) THEN
                           MAUX(J) = NINT ((100. * MB) / MA)
                        ELSE
                           MAUX(J) = 0
                           END IF
 50                     CONTINUE
                     WRITE (MSGTXT,1035) I, (MAUX(J), J = I1,I2)
                     CALL MSGWRT (4)
 60                  CONTINUE
                  I1 = I2 + 1
                  GO TO 45
                  END IF
               END IF
            IF ((TOTALA.GT.0) .AND. (TOTALS.GT.0)) THEN
               MSGTXT = 'Visibility spectra partly flagged (percent):'
               CALL MSGWRT (4)
               I1 = 1
 65            I2 = MIN (I1+27, MXA)
               IF (I2.GE.I1) THEN
                  DO 75 I = 1,MXA
                     DO 70 J = I1,I2
                        MA = MALL(I,J,K,L)
                        MB = MSOM(I,J,K,L)
                        IF (MA.GT.0) THEN
                           MAUX(J) = NINT ((100. * MB) / MA)
                        ELSE
                           MAUX(J) = 0
                           END IF
 70                     CONTINUE
                     WRITE (MSGTXT,1035) I, (MAUX(J), J = I1,I2)
                     CALL MSGWRT (4)
 75               CONTINUE
                  I1 = I2 + 1
                  GO TO 65
                  END IF
               END IF
 90         CONTINUE
 100     CONTINUE
C                                       Report flagged correlators
      WRITE (MSGTXT,1090) NBDCOR, FLGPIX
      CALL REFRMT (MSGTXT, '_', I1)
      CALL MSGWRT (4)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('Flagged',I8,' of',I10,' correlators for IF',I3,' POL',I2)
 1021 FORMAT ('Fully flagged ',I8,' of',I10,' spectra for IF',I3,' POL',
     *   I2)
 1022 FORMAT ('Partly flagged',I8,' of',I10,' spectra for IF',I3,' POL',
     *   I2)
 1025 FORMAT ('Visibilities per baseline (tens of percent of', I9 ,'):')
 1035 FORMAT ('Ant',I3,1X,28(I2))
 1090 FORMAT ('Flagged',I10,' correlators in',I9,' pixels')
      END
      SUBROUTINE WIPSIZ (WR, NXINT, TVSCR, IRET)
C-----------------------------------------------------------------------
C   WIPSIZ is an interactive setting of the wiper size using a plot of a
C   circle
C   Inputs:
C      NXINT   I      Numbr TV pixels per image pixel
C   In/out:
C      WR      R      Wiper radius in pixels
C   Output:
C      TVSCR   I(*)   Scratch buffer
C      IRET    I      Error code
C-----------------------------------------------------------------------
      INTEGER   NXINT, TVSCR(*), IRET
      REAL      WR
C
      INTEGER   NA
      PARAMETER (NA=60)
C
      INTEGER   GV, NPIX, NROW, MAG, IX0, IY0, IX, IY, CX0, CY0, QUAD,
     *   IBUT, I, IXP(NA), IYP(NA), ITW(3), IX1, IY1, IXC(4), IYC(4)
      REAL      RPOS(2), PPOS(2), A, B, PWR
      LOGICAL   T, F, DOIT
      CHARACTER STRING*6
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA T,F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      NXINT = MAX (1, NXINT)
      CALL ZTIME (ITW)
      GV = 3 + NGRAY
      CALL YHOLD ('ONNN', IRET)
      IF (IRET.NE.0) GO TO 970
      CALL YZERO (GV, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL YSLECT ('ONNN', GV, 0, TVSCR, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Display area: location, size
C                                       Approx corr for zoom
      NPIX = 6 * CSIZTV(1)
      NROW = 3 * CSIZTV(2) + 0.5
      MAG = 1 + TVZOOM(1)
      IF (MXZOOM.GT.0) MAG = 2 ** TVZOOM(1)
      IX0 = WINDTV(1) - (MAG-1)/2 + 1.5 * CSIZTV(1)
      IY0 = WINDTV(4) - MAG*NROW + 1 - (MAG-1)/2
      IF (MAG.GT.1) IY0 = IY0 + MAG
      IX0 = (IX0 - TVZOOM(2)) / MAG + TVZOOM(2)
      IY0 = (IY0 - TVZOOM(3)) / MAG + TVZOOM(3)
      IX = MOD (IX0 - 1 - TVSCGX + 3*MAXXTV(1), MAXXTV(1)) + 1
      IY = MOD (IY0 - 1 - TVSCGY + 3*MAXXTV(2), MAXXTV(2)) + 1
C                                       Fill with 1's, 0's
      IX0 = MAX (1, IX)
      IY0 = MAX (1, IY)
      IF (IX0+NPIX-1.GT.MAXXTV(1)) IX0 = MAXXTV(1) - NPIX + 1
      IF (IY0+NROW-1.GT.MAXXTV(2)) IY0 = MAXXTV(2) - NROW + 1
      IX1 = IX0 + NPIX - 1
      IY1 = IY0 + NROW - 1
      CALL YFILL (GV, IX0, IY0, IX1, IY1, 0, TVSCR, IRET)
      IF (IRET.NE.0) GO TO 970
      RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2.0
      RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2.0
      CALL YCURSE ('FXIT', F, T, RPOS, QUAD, IBUT, IRET)
      CX0 = RPOS(1) + 0.5
      CY0 = RPOS(2) + 0.5
      RPOS(1) = RPOS(1) + WR
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IRET)
      IF ((IRET.NE.0) .AND. (IRET.NE.2)) GO TO 970
      MSGTXT = 'Cursor sets fat wiper radius'
      CALL MSGWRT (1)
      MSGTXT = 'Any button returns to the menu'
      CALL MSGWRT (1)
      PWR = -1.0
C                                       draw circle
 50   B = WR * NXINT
      IXC(1) = CX0 - B
      IXC(2) = CX0 + B
      IXC(3) = CX0
      IXC(4) = CX0
      IYC(1) = CY0
      IYC(2) = CY0
      IYC(3) = CY0 + B
      IYC(4) = CY0 - B
      CALL IMVECT ('ONNN', GV, 2, IXC(1), IYC(1), TVSCR, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL IMVECT ('ONNN', GV, 2, IXC(3), IYC(3), TVSCR, IRET)
      IF (IRET.NE.0) GO TO 970
      DO 60 I = 1,NA
         A = (I - 1.0D0) * TWOPI / (NA - 1.0D0)
         IXP(I) = CX0 + B * SIN (A) + 0.5
         IYP(I) = CY0 + B * COS (A) + 0.5
 60      CONTINUE
      CALL IMVECT ('ONNN', GV, NA, IXP, IYP, TVSCR, IRET)
      IF (IRET.NE.0) GO TO 970
      WRITE (STRING,1060) WR
      CALL IMCHAR (GV, IX0, IY0, 0, 0, STRING(:6), TVSCR, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL YHOLD ('OFFF', IRET)
C                                       Now read the cursor
 100  CALL YCURSE ('READ', F, T, RPOS, QUAD, IBUT, IRET)
      CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
      IF (IBUT.GT.0) THEN
         GO TO 970
      ELSE IF (DOIT) THEN
         WR = SQRT ((RPOS(1)-CX0)**2 + (RPOS(2)-CY0)**2) / NXINT
         WR = MAX (0.1, MIN (12.0, WR))
         IF (ABS(PWR-WR).LT.0.3) GO TO 100
         CALL YHOLD ('ONNN', IRET)
         CALL IMVECT ('OFFF', GV, NA, IXP, IYP, TVSCR, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL IMVECT ('OFFF', GV, 2, IXC(1), IYC(1), TVSCR, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL IMVECT ('OFFF', GV, 2, IXC(3), IYC(3), TVSCR, IRET)
         IF (IRET.NE.0) GO TO 970
         PWR = WR
         GO TO 50
      ELSE
         GO TO 100
         END IF
C                                       TV error possibly
 970  IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1970) IRET
         CALL MSGWRT (6)
         END IF
      CALL YZERO (GV, IY)
      CALL YHOLD ('OFFF', IY)
C
 999  RETURN
C-----------------------------------------------------------------------
 1060 FORMAT (F6.2)
 1970 FORMAT ('WIPSIZ: TV ACTION IO ERROR',I7)
      END
      SUBROUTINE WIPSET (WR, NXINT, TVSCR, IRET)
C-----------------------------------------------------------------------
C   WIPSIZ is an interactive setting of the wiper size using a plot of a
C   horizontal line labeled from 0 to 12.
C   NO ZOOM allowed.
C   Inputs:
C      NXINT   I      Replication factor in image
C   In/out:
C      WR      R      Wiper radius in pixels
C   Output:
C      TVSCR   I(*)   Scratch buffer
C      IRET    I      Error code
C-----------------------------------------------------------------------
      INTEGER   NXINT, TVSCR(*), IRET
      REAL      WR
C
      INTEGER   NA
      PARAMETER (NA=60)
C
      INTEGER   GV, NPIX, NROW, IX0, IY0, IX, IY, CX0, CY0, QUAD,
     *   IBUT, I, IXP(NA), IYP(NA), JX0, JX1, ITW(3)
      REAL      RPOS(2), PPOS(2), A, B, PWR
      LOGICAL   T, F, DOIT
      CHARACTER STRING*6
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA T,F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      CALL ZTIME (ITW)
      GV = 3 + NGRAY
      PWR = -1.0
      CALL YHOLD ('ONNN', IRET)
      IF (IRET.NE.0) GO TO 970
      CALL YZERO (GV, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL YSLECT ('ONNN', GV, 0, TVSCR, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       Display area: location, size
C                                       Approx corr for zoom
      NPIX = 6 * CSIZTV(1)
      NROW = 3 * CSIZTV(2) + 0.5
      IX0 = WINDTV(1)
      IY0 = WINDTV(4) - NROW + 1
C                                       Draw line
      CX0 = (WINDTV(1) + WINDTV(3)) / 2
      CY0 = (5.0*WINDTV(2) + 3.0*WINDTV(4)) / 8.0
      IX = CX0 - 6 * CSIZTV(1)
      MSGTXT = 'WIPER RADIUS'
      CALL IMCHAR (GV, IX, IY0, 0, 0, MSGTXT(:12), TVSCR, IRET)
      IF (IRET.NE.0) GO TO 970
      JX0 = WINDTV(1) + (WINDTV(3) - WINDTV(1)) / 10.0
      JX1 = WINDTV(3) - (WINDTV(3) - WINDTV(1)) / 10.0
      IXP(1) = JX0
      IXP(2) = JX1
      IY = IY0 - 10 * CSIZTV(2)
      IYP(1) = IY
      IYP(2) = IY
      CALL IMVECT ('ONNN', GV, 2, IXP, IYP, TVSCR, IRET)
      IF (IRET.NE.0) GO TO 970
      DO 10 I = 1,13
         IX = ((I-1.0) / 12.0) * (JX1 - JX0) + JX0 + 0.5
         IXP(1) = IX
         IXP(2) = IX
         IYP(1) = IY - CSIZTV(2)
         IYP(2) = IY + CSIZTV(2)
         CALL IMVECT ('ONNN', GV, 2, IXP, IYP, TVSCR, IRET)
         IF (IRET.NE.0) GO TO 970
         WRITE (STRING,1000) I-1
         IXP(1) = IX - CSIZTV(1)
         IYP(1) = IY - 2.5 * CSIZTV(2)
         CALL IMCHAR (GV, IXP(1), IYP(1), 0, 0, STRING(:2), TVSCR, IRET)
         IF (IRET.NE.0) GO TO 970
 10      CONTINUE
      CY0 = IYP(1) - 8 - 12 * NXINT
      WR = MIN (WR, 12.0)
      PWR = WR
      RPOS(1) = JX0 + WR/12.0 * (JX1 - JX0)
      RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2.0
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IRET)
      IF ((IRET.NE.0) .AND. (IRET.NE.2)) GO TO 970
      MSGTXT = 'Cursor horizontal position sets fat wiper radius'
      CALL MSGWRT (1)
      MSGTXT = 'Any button returns to the menu'
      CALL MSGWRT (1)
C                                       draw circle
 50   B = NXINT * WR
      DO 60 I = 1,NA
         A = (I - 1.0D0) * TWOPI / (NA - 1.0D0)
         IXP(I) = CX0 + B * SIN (A) + 0.5
         IYP(I) = CY0 + B * COS (A) + 0.5
 60      CONTINUE
      CALL IMVECT ('ONNN', GV, NA, IXP, IYP, TVSCR, IRET)
      IF (IRET.NE.0) GO TO 970
      WRITE (STRING,1060) WR
      CALL IMCHAR (GV, IX0, IY0, 0, 0, STRING(:6), TVSCR, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL YHOLD ('OFFF', IRET)
C                                       Now read the cursor
 100  CALL YCURSE ('READ', F, T, RPOS, QUAD, IBUT, IRET)
      CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
      IF (IBUT.GT.0) THEN
         GO TO 970
      ELSE IF (DOIT) THEN
         WR = (RPOS(1)-JX0) * 12.0 / (JX1 - JX0)
         WR = MAX (0.1, MIN (12.0, WR))
         IF (ABS(PWR-WR).LT.0.3) GO TO 100
         CALL YHOLD ('ONNN', IRET)
         CALL IMVECT ('OFFF', GV, NA, IXP, IYP, TVSCR, IRET)
         IF (IRET.NE.0) GO TO 970
         PWR = WR
         GO TO 50
      ELSE
         GO TO 100
         END IF
C                                       TV error possibly
 970  IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1970) IRET
         CALL MSGWRT (6)
         END IF
      CALL YZERO (GV, IY)
      CALL YHOLD ('OFFF', IY)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I2.2)
 1060 FORMAT (F6.2)
 1970 FORMAT ('WIPSET: TV ACTION IO ERROR',I7)
      END
      SUBROUTINE WIPEHI (NX, NY)
C-----------------------------------------------------------------------
C   WIPEHI appends to the history file.
C-----------------------------------------------------------------------
      INTEGER   NX, NY
C
      INCLUDE 'WIPER.INC'
      CHARACTER ATIME*8, ADATE*12, HILINE*72, TEXT*9, CHTYPE(NUMPRM)*9,
     *   CHTYP2(NUMPRM)*9, AXIS(2)*1
      INTEGER   LUN, IERR, I, TIME(3), DATE(3), HBUFF(256), J, NC, ITRIM
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA LUN /28/
      DATA CHTYPE /'Amplitude', 'Phase   ', 'UV dist ',
     *   'UV pa    ', 'Time    ', 'U       ', 'V       ',
     *   'W        ', 'Real    ', 'Imag    ', 'Time hrs',
     *   'log (amp)', 'Weight', 'Hour angl', 'Elevation', 'Para angl',
     *   'UV@pa=   ', 'Azimuth', 'Frequency', 'Channel', 'Antenna'/
      DATA CHTYP2 /'Flux     ', 'Offset  ', 'UV dist ',
     *   'UV pa    ', 'Time    ', 'Longitude', 'Latitude',
     *   'W        ', 'Flux    ', 'Offset  ', 'Time hrs',
     *   'log(flux)', 'Weight', 'Hour angl', 'Elevation', 'Para angl',
     *   'UV@pa=   ', 'Azimuth', 'Frequency', 'Channel', 'Antenna'/
      DATA AXIS /'X','Y'/
C-----------------------------------------------------------------------
C                                       no HI if no flags
      IF (NBDCOR.LE.0) GO TO 999
C                                       Write History.
      CALL HIINIT (3)
C                                       Open history file.
      CALL HIOPEN (LUN, DISKIN, CNOIN, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
      WRITE (HILINE,1000) TSKNAM, ADATE, ATIME
      CALL HIADD (LUN, HILINE, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       No Sources
      IF (NSOU.LE.0) THEN
         WRITE (HILINE,1100) TSKNAM
         CALL HIADD (LUN, HILINE, HBUFF, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       Sources by name
      ELSE
C                                       Included or excluded?
         WRITE (HILINE,1101) TSKNAM
         IF (DOSWNT) WRITE (HILINE,1102) TSKNAM
         CALL HIADD (LUN, HILINE, HBUFF, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       First two and label.
         IF (NSOU.EQ.1) THEN
            WRITE (HILINE,1103) TSKNAM, XSOUR(1)
         ELSE
            WRITE (HILINE,2103) TSKNAM, XSOUR(1), XSOUR(2)
            END IF
         CALL HIADD (LUN, HILINE, HBUFF, IERR)
         IF (IERR.NE.0) GO TO 900
C                                       Rest of sources
         DO 10 I = 3,NSOU,2
            WRITE (HILINE,1104) TSKNAM, XSOUR(I), XSOUR(I+1)
            CALL HIADD (LUN, HILINE, HBUFF, IERR)
            IF (IERR.NE.0) GO TO 900
 10         CONTINUE
         END IF
C                                       QUAL, CALCODE
      WRITE (HILINE,1110) TSKNAM, SELQUA, SELCOD
      CALL HIADD (LUN, HILINE, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Subarray
      WRITE (HILINE,1111) TSKNAM, SUBARR
      CALL HIADD (LUN, HILINE, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Flag table
      WRITE (HILINE,1112) TSKNAM, FGVER
      CALL HIADD (LUN, HILINE, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
      WRITE (HILINE,1113) TSKNAM, FGVERO
      CALL HIADD (LUN, HILINE, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       TIMERANG
      CALL HITIME (TSTART, TEND, LUN, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       IF range
      WRITE (HILINE,1114) TSKNAM, BIF, EIF
      CALL HIADD (LUN, HILINE, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Chan range
      WRITE (HILINE,1115) TSKNAM, BCHAN, ECHAN
      CALL HIADD (LUN, HILINE, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Calibration
C                                       Table
      IF (DOCAL) THEN
         WRITE (HILINE,1116) TSKNAM, CLUSE
         CALL HIADD (LUN, HILINE, HBUFF, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
C                                       BP table
      IF (XDOBND.GT.0.0) THEN
         WRITE (HILINE,1117) TSKNAM, DOBAND
         CALL HIADD (LUN, HILINE, HBUFF, IERR)
         IF (IERR.NE.0) GO TO 900
         WRITE (HILINE,1118) TSKNAM, BPVER
         CALL HIADD (LUN, HILINE, HBUFF, IERR)
         IF (IERR.NE.0) GO TO 900
         END IF
C                                       Plot type and range
      DO 20 I = 1,2
         IF (TYPUVD.LE.0) THEN
            TEXT = CHTYPE(TYPEAX(I))
         ELSE
            TEXT = CHTYP2(TYPEAX(I))
            END IF
         NC = ITRIM (TEXT)
         WRITE (HILINE,1119) TSKNAM, AXIS(I), TEXT(:NC)
         CALL HIADD (LUN, HILINE, HBUFF, IERR)
         IF (IERR.NE.0) GO TO 900
         J = 2 * (I + 1)
         WRITE (HILINE,1120) TSKNAM, AXIS(I), BPARM(J)
         CALL HIADD (LUN, HILINE, HBUFF, IERR)
         IF (IERR.NE.0) GO TO 900
         J = J + 1
         WRITE (HILINE,1121) TSKNAM, AXIS(I), BPARM(J)
         CALL HIADD (LUN, HILINE, HBUFF, IERR)
         IF (IERR.NE.0) GO TO 900
         J = NX
         IF (I.EQ.2) J = NY
         WRITE (HILINE,1122) TSKNAM, AXIS(I), J
         CALL HIADD (LUN, HILINE, HBUFF, IERR)
         IF (IERR.NE.0) GO TO 900
 20      CONTINUE
C                                       Number of flagged correlators
      WRITE (HILINE,1123) TSKNAM, NBDCOR
      CALL HIADD (LUN, HILINE, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
      WRITE (HILINE,1124) TSKNAM, FLGPIX
      CALL HIADD (LUN, HILINE, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
      WRITE (HILINE,1125) TSKNAM, NFGWRI
      CALL HIADD (LUN, HILINE, HBUFF, IERR)
      IF (IERR.NE.0) GO TO 900
      WRITE (MSGTXT,1130) NFGWRI, FGVERO
      CALL MSGWRT (4)
C                                       Close HI file
 900  CALL HICLOS (LUN, .TRUE., HBUFF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'/********* Start ',A12,2X,A8)
 1100 FORMAT (A6,'SOURCES = ''''     /All sources selected')
 1101 FORMAT (A6,'/Sources excluded:')
 1102 FORMAT (A6,'/Sources included:')
 1103 FORMAT (A6,'SOURCES = ''',A16,'''')
 2103 FORMAT (A6,'SOURCES = ''',A16,''',''',A16,'''')
 1104 FORMAT (A6,'         ,''',A16,''',''',A16,'''')
 1110 FORMAT (A6,'QUAL = ',I4,' CALCODE = ',A4)
 1111 FORMAT (A6,'SUBARRAY =',I4)
 1112 FORMAT (A6,'FLAGVER  =',I4,' /Flagging table applied')
 1113 FORMAT (A6,'FLAGVERO =',I4,' /Flagging table written')
 1114 FORMAT (A6,'BIF =',I4,', EIF =',I4,'/ IF range')
 1115 FORMAT (A6,'BCHAN = ',I4,' ECHAN = ',I4,
     *   ' /Start and stop channels')
 1116 FORMAT (A6,'GAINUSE =',I3,' / CL table')
 1117 FORMAT (A6,'DOBAND =',I2,'  /BP correction done')
 1118 FORMAT (A6,'BPVER =',I3,' / BP correction used BP table')
 1119 FORMAT (A6,A1,'TYPE = ''',A,''' / plot axis type')
 1120 FORMAT (A6,A1,'MIN =',1PE12.5,'  / plot axis minimum')
 1121 FORMAT (A6,A1,'MAX =',1PE12.5,'  / plot axis maximum')
 1122 FORMAT (A6,A1,'PIXELS =',I6,'  / plot axis number TV pixels')
 1123 FORMAT (A6,'/ Correlators flagged:',I8)
 1124 FORMAT (A6,'/ TV pixels flagged:  ',I8)
 1125 FORMAT (A6,'/ FG records written: ',I8)
 1130 FORMAT (I10,' records written to FG table vers',I4)
      END
      SUBROUTINE ANAXIS (NANT, IANT, DESEL, NANAX, JANT)
C-----------------------------------------------------------------------
C   ANAXIS interprets IANT to an array to control plotting baselines
C   Inputs:
C      NANT    I       Number entries in IANT
C      IANT    I(*)    Selected or deselcted antennas
C      DESEL   L       select or deselect
C   Outputs:
C      NANAX   I       Number of antennas to be lotted
C      JANT    i(*)    JANT(antenna #) = plot sequence (0 not)
C-----------------------------------------------------------------------
      INTEGER   NANT, IANT(*), NANAX, JANT(*)
      LOGICAL   DESEL
C
      INTEGER   I, KANT(50), J, K, ILOW, KLOW
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
C-----------------------------------------------------------------------
C                                       include all
      CALL FILL (MAXANT, 0, JANT)
      IF (NANT.LE.0) THEN
         NANAX = NSTNS
         DO 10 I = 1,NSTNS
            JANT(I) = I
 10         CONTINUE
C                                       include only some
       ELSE IF (.NOT.DESEL) THEN
          CALL COPY (NANT, IANT, KANT)
          J = 0
          DO 30 I = 1,NANT
             ILOW = MAXANT
             DO 20 J = 1,NANT
                IF ((KANT(J).GT.0) .AND. (KANT(J).LT.ILOW)) THEN
                   ILOW = KANT(J)
                   KLOW = J
                   END IF
 20             CONTINUE
             J = J + 1
             JANT(ILOW) = KLOW
             KANT(KLOW) = 0
 30          CONTINUE
          NANAX = J
C                                       deselect
      ELSE
         J = 0
         DO 50 I = 1,NSTNS
            DO 40 K = 1,NANT
               IF (IANT(K).EQ.I) GO TO 50
 40            CONTINUE
            J = J + 1
            JANT(I) = J
 50         CONTINUE
         NANAX = J
         END IF
C
 999  RETURN
      END

      SUBROUTINE FPTRIM (INSTR, OUTST, NCHAR)
C-----------------------------------------------------------------------
C! removes leading blanks and trailing 0's from floating format string
C# Character
C-----------------------------------------------------------------------
C;  Copyright (C) 2011
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Removes leading blanks and trailing zeros from an Fa.b formatted
C   string
C   Input:
C      INSTR   C*(*)    Input string
C   Outputs:
C      OUTST   C*(*)    Output string
C      NCHAR   I        Number of useful characters in OUTST
C-----------------------------------------------------------------------
      INTEGER   NCHAR
      CHARACTER INSTR*(*), OUTST*(*)
C
      INTEGER   I, JTRIM, N, I1, I2, IP
C-----------------------------------------------------------------------
      N = JTRIM (INSTR)
C                                       find 1st char, check format
      I2 = N
      I1 = 0
      IP = 0
      DO 10 I = 1,N
         IF (INSTR(I:I).EQ.'.') THEN
            IP = I
         ELSE IF (INSTR(I:I).EQ.' ') THEN
            I1 = I
         ELSE IF ((INSTR(I:I).EQ.'-') .OR. (INSTR(I:I).EQ.'+')) THEN
            CONTINUE
C                                       bail on error
         ELSE IF ((INSTR(I:I).LT.'0') .OR. (INSTR(I:I).GT.'9')) THEN
            GO TO 30
            END IF
 10      CONTINUE
C                                       trailing zeros
      IF (IP.GT.0) THEN
         DO 20 I = N,IP+2,-1
            IF (INSTR(I:I).EQ.'0') I2 = I - 1
 20         CONTINUE
         END IF
C                                       copy to out: allows out to be in
 30   NCHAR = I2 - I1
      DO 40 I = 1,NCHAR
         OUTST(I:I) = INSTR(I+I1:I+I1)
 40      CONTINUE
      OUTST(NCHAR+1:) = ' '
C
 999  RETURN
      END

      PROGRAM NLINE
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C     Kluge program to print out the first \n-line (network address) in
C     each group of blank-line-delimited lines in a file.
C     Built to produce a network address distribution list for CPs with
C     E-mail addresses in WHOGETS who have not returned a survey form,
C     and who therefore do not have the Q87 attribute set (use SORT1 to
C     produce a "CP -COM -BA -Q87" file).
C     DCW, NRAO-CV, 11Jan88.
C-----------------------------------------------------------------------
      IMPLICIT    NONE
      INTEGER     L1, L2, L5, L6, ITRIM, BCOUNT, NCOUNT
      CHARACTER   LINE*100, INP*30, FNAME*60
      LOGICAL     NSEEN
C
      L1 = 1
      L2 = 2
      L5 = 5
      L6 = 6
C                                       Open files:
 110  CONTINUE
      WRITE (L6, 1110)
      READ  (L5, 1115, END=999, ERR=110) INP
      FNAME = INP(:ITRIM(INP)) // '.ADR'
      OPEN (UNIT=L1, FILE=FNAME, STATUS='OLD', ERR=120)
         GO TO 130
 120  CONTINUE
         WRITE (L6, 1120) FNAME(1:ITRIM(FNAME))
         GO TO 110
 130  CONTINUE
      WRITE (L6, 1130) 1, FNAME
      FNAME = INP(:ITRIM(INP)) // '.DIS'
      WRITE (L6, 1130) 2, FNAME
      OPEN (UNIT=L2, FILE=FNAME, STATUS='NEW',
     *      CARRIAGECONTROL='LIST', ERR=140)
         GO TO 150
 140  CONTINUE
         WRITE (L6, 1120) FNAME(1:ITRIM(FNAME))
         GO TO 110
 150  CONTINUE
C
      NSEEN = .FALSE.
      BCOUNT = 0
      NCOUNT = 0
C
 200  READ (L1, '(A)', END=900) LINE
         IF (LINE.EQ.' ') THEN
               NSEEN = .FALSE.
               BCOUNT = BCOUNT + 1
         END IF
         IF (.NOT.NSEEN) THEN
            IF (LINE(1:3).EQ.'\n ') THEN
               WRITE (L2, '(A)') LINE(4:ITRIM(LINE))
               NCOUNT = NCOUNT + 1
               NSEEN = .TRUE.
            END IF
         END IF
         GO TO 200
C
 900  CONTINUE
      CLOSE (UNIT = L1)
      CLOSE (UNIT = L2)
      WRITE (L6, '(''BCOUNT='', I4, '', NCOUNT='', I4)') BCOUNT, NCOUNT
 999  CONTINUE
C-----------------------------------------------------------------------
 1110 FORMAT (' Enter input address-list-file (w/o .ADR):', $)
 1115 FORMAT (A30)
 1120 FORMAT (' Cannot open file ', A)
 1130 FORMAT (' L', I1, '=', A)
      END
      INTEGER FUNCTION ITRIM (STRING)
C-----------------------------------------------------------------------
C   Function to determine length of a string. I.e., it trims trailing
C   blanks. Use with calls like:
C         TRIMMED = GROSS(1:ITRIM(GROSS))
C   DCW, NRAO-CV, 30Nov82.
C-----------------------------------------------------------------------
      IMPLICIT  NONE
      CHARACTER STRING*(*)
C
      ITRIM = LEN (STRING) + 1
 10   CONTINUE
         ITRIM = ITRIM - 1
         IF (ITRIM.LT.1) GO TO 999
         IF (STRING(ITRIM:ITRIM).EQ.' ') GO TO 10
 999  RETURN
      END

      SUBROUTINE TXTLEN (STRING, I1, I2)
C-----------------------------------------------------------------------
C! Find the first and last non-blank, non-tab characters in a string.
C# Character Parsing
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   finds the positions of the first and last non-blank, non-tab
C   characters in a string.
C   Inputs:
C      STRING   C*(*)   Input character string.
C   Outputs:
C      I1       I       Position of the first non-blank, non-tab; one
C                       plus the length of the string if none
C      I2       I       Position of the last non-blank, non-tab; 0 if
C                       none
C   Author: Mark Calabretta, Australia Telescope.
C      Origin; 1988/May/23.  Code last modified; 1989/Sep/06.
C-----------------------------------------------------------------------
      INTEGER   I1, I2
      CHARACTER STRING*(*)
C
      INTEGER   NCH
      CHARACTER TAB*1
C-----------------------------------------------------------------------
      TAB = CHAR(9)
      NCH = LEN(STRING)
C                                       Search forward for the start.
      DO 10 I1 = 1,NCH
         IF (STRING(I1:I1).EQ.' ') GO TO 10
         IF (STRING(I1:I1).EQ.TAB) GO TO 10
         GO TO 20
 10      CONTINUE
C                                       Search backward for the end.
 20   DO 30 I2 = NCH,1,-1
         IF (STRING(I2:I2).EQ.' ') GO TO 30
         IF (STRING(I2:I2).EQ.TAB) GO TO 30
         GO TO 999
 30      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ELVSOU (ANTNO, TIME, EL, AZ, RA, DEC, HA)
C-----------------------------------------------------------------------
C! Computes source coordinates from time, azimut, and elevation
C# Math Coordinates UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Subroutine to compute the apparent source coordinates based on
C   azimuth and elevation plos antenna coordinates in common.  The
C   routines GETANT and GETSOU should be called before this routine to
C   put the correct values in the relevant commons.
C   Inputs:
C      ANTNO      I    Antenna number
C      TIME       D    Current data time (days).
C      EL         R    Source elevation (rad)
C      AZ         R    Source azimuth (rad)
C   Input from common:
C      STNLAT     D(*) Antenna latitude (rad).
C      STNLON     D(*) Antenna east longitudes (rad).
C      GSTIAT     D    GST at IAT=0 of reference day (rad).
C      ROTIAT     D    Rotation of the earth rate in IAT.
C   Output:
C      RA         D    Right ascension (apparent)
C      DEC        D    Declination
C      HA         R    Source hour angle (rad)  returns -100 for bad
C-----------------------------------------------------------------------
      INTEGER   ANTNO
      DOUBLE PRECISION TIME, RA, DEC
      REAL      HA, EL, AZ
C
      DOUBLE PRECISION HRANG, ANTLST, DARG, DARG1, DARG2, DARG3
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
C-----------------------------------------------------------------------
C                                       Antenna LST
      ANTLST = GSTIAT + STNLON(ANTNO) + TIME * ROTIAT
C                                       declination
      DARG1 = SIN (STNLAT(ANTNO)) * SIN (EL)
      DARG2 =  COS (STNLAT(ANTNO)) * COS (EL) * COS (AZ)
      DARG = DARG1 + DARG2
      DEC = ASIN (DARG)
C                                       Hour angle
      DARG1 = COS (EL) * COS (AZ)
      DARG2 = COS (STNLAT(ANTNO)) * SIN (DEC)
      DARG = (DARG2 - DARG1) / SIN (STNLAT(ANTNO))
      DARG3 = - COS (EL) * SIN (AZ)
      HRANG = ATAN2 (DARG3, DARG)
      RA = ANTLST - HRANG
      RA = DMOD (RA, TWOPI)
C                                       translate to between -pi and pi
      IF (HRANG.GT.PI) HRANG = HRANG - TWOPI
      IF (HRANG.LT.-PI) HRANG = HRANG + TWOPI
      HA = HRANG
C
 999  RETURN
      END

      SUBROUTINE ZABOR2 (PRGN, TTYP, ACTION)
C-----------------------------------------------------------------------
C! establishes or carries out (when appropriate) abort handling
C# Z2 System
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZABOR2 will take one of two actions depending on the value of
C   "action".  If "action" is zero, it establishes abort handling
C   to clean up for programs in the event of an ABORTASK or otherwise
C   fatal signal.  Hangup, interrupt (except for AIPS or BATER) and
C   quit are ignored.  If running under the control of a debugger, it
C   simply returns (to avoid affecting the debugger signal handling).
C   If "action" is non-zero, it will issue an illegal instruction in
C   order to induce the abort handler.  This is mostly to get a
C   traceback for debugging purposes (e.g., when an invalid argument
C   to a subroutine is detected).
C   Inputs:
C      PRGN     H*6   Program name - actually HOLLERITH
C      TTYP     I     1 => stand-alone program, 0 => task
C      ACTION   I     Action indicator code:
C                        0 => establish abort handling
C                        1 => invoke an illegal instruction
C   Output:
C      none
C   Generic version - called by ZABORT makes message only.
C-----------------------------------------------------------------------
      HOLLERITH PRGN(*)
      INTEGER   ACTION, TTYP
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      MSGTXT = 'ZABOR2 REQUIRES LOCAL DEVELOPMENT - NO ABORT HANDLER'
      CALL MSGWRT (8)
C
 999  RETURN
      END

      SUBROUTINE COINC (IV, NMI, CLI, IS, JV, NMJ, CLJ, JS, UID, INF,
     *   SCR, IER )
C-----------------------------------------------------------------------
C! Checks if two maps are exactly coincident.
C# Map Header
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Checks if two maps are exactly coincident.
C   Inputs:
C      IV ,JV    I          volume nrs first and second map
C      NMI,NMJ   C*12       names first and second map
C      CLI,CLJ   C*6        class first and second map
C      IS ,JS    I          sequence nrs first and second map
C      UID       I          user number
C   Output:
C      INF       I          output information parameter.
C                           INF = 0 : maps coincident; INF > 0 indicates
C                           difference : 1 in # dims, 2 in # points/axis
C                           3 in pixel increments, 4 : maps are shifted
C                           in position.
C      SCR       I(256)     scratch array
C      IER       I          error in CATDIR or in CATIO.
C-----------------------------------------------------------------------
      CHARACTER NMI*12, CLI*6, NMJ*12, CLJ*6, STAT*4, TYPTMP*2
      INTEGER   IV, CN, IS, UID, SCR(256), IER, CAT1(256), JV, JS,
     *   CAT2(256), INF, NDIM, I, J, JRV, JIC, JRP
      REAL      CAT1R(256), CAT2R(256), EPS
      DOUBLE PRECISION    CAT1D(128), CAT2D(128), RFJ
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (CAT1, CAT1R, CAT1D)
      EQUIVALENCE (CAT2, CAT2R, CAT2D)
      DATA EPS /0.001/
C-----------------------------------------------------------------------
C                                       CATBLK for first file
      TYPTMP = 'MA'
      CALL CATDIR ('SRNH', IV, CN, NMI, CLI, IS, TYPTMP, UID, STAT, SCR,
     *    IER)
      IF (IER.NE.0) GO TO 999
      CALL CATIO ('READ', IV, CN, CAT1, 'REST', SCR, IER)
      IF (IER.NE.0) GO TO 999
C                                       CATBLK for second file
      TYPTMP = 'MA'
      CALL CATDIR ('SRNH', JV, CN, NMJ, CLJ, JS, TYPTMP, UID, STAT, SCR,
     *    IER)
      IF (IER.NE.0) GO TO 999
      CALL CATIO ('READ', JV, CN, CAT2, 'REST', SCR, IER)
      IF (IER.NE.0) GO TO 999
C                                       same dimensions ?
      IF (CAT1(KIDIM).EQ.CAT2(KIDIM)) GO TO 10
         INF = 1
         GO TO 999
C                                       same # points per axis ?
 10   NDIM = CAT1(KIDIM)
      DO 20 I = 1,NDIM
         IF (CAT1(KINAX+I-1).EQ.CAT2(KINAX+I-1)) GO TO 20
            INF = 2
            GO TO 999
 20      CONTINUE
C                                       same pixel increments  ?
      DO 30 I = 1,NDIM
         J = KRCIC + I - 1
         IF (ABS (CAT1R(J)-CAT2R(J)).LE.EPS*ABS (CAT1R(J))) GO TO 30
            INF = 3
            GO TO 999
 30      CONTINUE
C                                       coincident ?
      DO 40 I = 1,NDIM
         JRV = KDCRV + I - 1
         JIC = KRCIC + I - 1
         JRP = KRCRP + I - 1
         RFJ = CAT1D(JRV) + CAT1R(JIC) * (CAT2R(JRP) - CAT1R(JRP))
         IF (ABS (CAT2D(JRV)-RFJ).LE.EPS*ABS (CAT2R(JIC))) GO TO 40
            INF = 4
            GO TO 999
 40      CONTINUE
C                                       yes, coincident
      INF = 0
C
 999  RETURN
      END

      SUBROUTINE ZMSGWR (MSGBUF, MSGLEV)
C-----------------------------------------------------------------------
C! call MSGWRT based on call arguments - for C routines to call MSGWRT
C# Z2 Service
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Issues a call to MSGWRT with with the message contained in MSGBUF.
C   This is only called by routines that cannot otherwise access MSGTXT
C   as stored in /MSGCOM/ and call MSGWRT themselves (e.g., routines
C   written in "C").
C   Inputs:
C      MSGBUF   H(20)   Buffer containing message (80 characters)
C      MSGLEV   I       Message level argument for MSGWRT
C   Output:
C      None
C   Generic version - uses H2CHR, JTRIM, MSGWRT.
C-----------------------------------------------------------------------
      HOLLERITH MSGBUF(20)
      INTEGER   MSGLEV
C
      INTEGER   I, JTRIM
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL H2CHR (80, 1, MSGBUF, MSGTXT)
C                                       Blank fill starting at position
C                                       of first NUL, if any.
      I = JTRIM (MSGTXT)
C                                       Issue the message via MSGWRT.
      IF (I.GT.0) CALL MSGWRT (MSGLEV)
C
 999  RETURN
      END

      PROGRAM SL2PL
C-----------------------------------------------------------------------
C! Task to create a plot (PL) file from a slice (SL) file
C# Plot-util EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2002, 2005-2007, 2009, 2011-2012
C;  Copyright (C) 2014-2016, 2022, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SL2PL will find an SLice extension file and create a plot file
C   representation.
C   Inputs:   (from AIPS)
C      DOSLICE   R      > 0 means plot slice.
C      DOMODEL   R      > 0 means plot model.
C      DORESID   R      > 0 means plot residuals.
C      USERID    R      user number ignored
C      INNAME    H(3)   name of primary file.
C      INCLASS   H(2)   class of primary file.
C      INSEQ     R      sequence number of primary file.
C      INDISK    R      disk volume number. 0 means try all.
C      INVERS    R      version number of slice file, 0 means try
C                       latest version.
C      IN2VERS   R      version number of gaussian model if
C                       DOSLICE or DOMODEL is true.
C      LTYPE     R      1=no labeling 2 no ticks, 3 RA/dec
C                       4=center rel., 5=subslice center-rel
C      PIXRANGE  R(2)   The minimum and maximum values allowed for the
C                       plot.  All other values will be clipped
C                       If IRANGE(1).GE.IRANGE(2) then the slice max and
C                       min will be used.
C      BDROP     R    # Slice points not plotted on left
C      EDROP     R    # Slice points not plotted on right
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C      TVCORN   R(4)   TV pixel to use (both > 0 => pixel scale)
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6, NAMIN*12, CLSIN*6, TYPIN*2, PFILE*48, OPCODE*4
      HOLLERITH XNAMIN(3), XCLSIN(2)
      REAL      BLC(7), TRC(7), IRANGE(2), BDROP, DSKIN, VERSIN, LABEL,
     *   SEQIN, PRUSER, EDROP, DOSLIC, DOMODL, DORES, IN2VER, SBLK(256),
     *   RDUMMY(25), XDOTV, XGRCH
      INTEGER   IDROP(2), IPBLK(256), ISBLK(256), IROUND, ISLHDR(256),
     *   IERR, ISFIND, ILABEL, IPLUN, ISLUN, IMFIND, IRETCD, ISEQ,
     *   IMLUN, INPRMS, ISLOT, IUSER, IVER, IVOL, IMOD, IPFIND, IERR1,
     *   IERR2, IERR3, IERR4, GRCHN, GR2CHN, TVCHN, TVCORN(4), LTYPE
      LOGICAL   T, F, CATUP, NOSAVE, QUICK, SAVE, NOEXCL, WAIT, NOMAP,
     *   IDOMOD, DOTV
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /INPARM/ DOSLIC, DOMODL, DORES, PRUSER, XNAMIN, XCLSIN,
     *   SEQIN, DSKIN, VERSIN, IN2VER, LABEL, IRANGE, BDROP, EDROP,
     *   XDOTV, XGRCH
      COMMON /CHPARM/ NAMIN, CLSIN
      COMMON /SLHEAD/ RDUMMY
      COMMON /WORK/ SBLK
      EQUIVALENCE (T, SAVE, WAIT),      (F, NOEXCL, NOMAP, NOSAVE)
      EQUIVALENCE (ISBLK, SBLK)
      DATA IMLUN, ISLUN, IPLUN /16, 27, 26/
      DATA PRGNAM /'SL2PL '/
      DATA TYPIN /'  '/
      DATA F, T /.FALSE., .TRUE./
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE., ISBLK)
      CALL VHDRIN
C                                       Get input values from AIPS.
      INPRMS = 20
      IRETCD = 0
      CALL GTPARM (PRGNAM, INPRMS, QUICK, DOSLIC, ISBLK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRETCD = 1
         END IF
      IF (QUICK) CALL RELPOP (IRETCD, ISBLK, IERR)
      IF (IRETCD.NE.0) GO TO 995
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
C
      ISEQ = IROUND (SEQIN)
      IVOL = IROUND (DSKIN)
      IVER = IROUND (VERSIN)
      IMOD = IROUND (IN2VER)
      PRUSER = NLUSER
      IUSER = NLUSER
      ILABEL = IROUND (LABEL)
      LTYPE = MOD (ABS(ILABEL), 100)
      IF ((LTYPE.EQ.0) .OR. (LTYPE.GT.10)) THEN
         LTYPE = 3
         IF (ILABEL.GE.0) THEN
            ILABEL = (ILABEL/100)*100 + LTYPE
         ELSE
            ILABEL = (ILABEL/100)*100 - LTYPE
            END IF
         END IF
      LABEL = ILABEL
      IDROP(1) = BDROP
      IDROP(1) = MAX (0, IDROP(1))
      IDROP(2) = EDROP
      IDROP(2) = MAX (0, IDROP(2))
      CATUP = SAVE
      IDOMOD = (DOMODL.GT.0.) .OR. (DORES.GT.0.)
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      GR2CHN = GRCHN / 10
      GRCHN = MOD (GRCHN, 10)
      IF (GR2CHN.EQ.0) GR2CHN = MAX (1, GRCHN)
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
C                                       Open map file & get header.
      OPCODE = 'HDWR'
      IF (DOTV) OPCODE = 'READ'
      CALL MAPOPN (OPCODE, IVOL, NAMIN, CLSIN, ISEQ, TYPIN, IUSER,
     *   IMLUN, IMFIND, ISLOT, CATBLK, ISBLK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (8)
         GO TO 995
         END IF
C                                       Open SL extension file.
      CALL OPEXT ('SL', IVOL, ISLOT, IVER, ISLUN, NOEXCL, WAIT,
     *   ISFIND, IERR)
      IF (IERR.NE.0) GO TO 975
      VERSIN = IVER
C                                       Add plot file to header.
      IVER = 0
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', IVOL, ISLOT, CATBLK, ISBLK, SAVE, 'READ',
     *      IVER, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Build file name.
      CALL ZPHFIL ('PL', IVOL, ISLOT, IVER, PFILE, IERR)
C                                       Initialize LOCATI common, do
C                                       labeling.
      CALL SPINIT (ISLUN, ISFIND, IPBLK, IDROP, ILABEL, IDOMOD, IMOD,
     *   IRANGE, IVER, BLC, TRC, ISLHDR, IVOL, ISLOT, PFILE, IPLUN,
     *   IPFIND, DOTV, TVCHN, GRCHN, GR2CHN, TVCORN, IERR)
      IF (IERR.NE.0) GO TO 960
      IF (GR2CHN.GT.0) GPHTVG(1) = GR2CHN + NGRAY
C                                       Make sure a model exists before
C                                       trying to plot it:
      IF ((DOMODL.GT.0.0) .OR. (DORES.GT.0.0)) THEN
         IF (ISLHDR(58).EQ.0) THEN
            MSGTXT = '** WARNING ** NO MODELS EXIST IN THIS FILE'
            CALL MSGWRT (6)
            MSGTXT = 'Ignoring plot model and/or plot residual requests'
            CALL MSGWRT (6)
            DOMODL = -1.0
            DORES  = -1.0
            END IF
         END IF
C                                       Write selected plot if needed.
      IERR1 = 0
      IERR2 = 0
      IERR3 = 0
      IF (DOSLIC.GT.0.0) THEN
         CALL SPSLPL (ISLUN, ISFIND, IPBLK, BLC, TRC, IERR1)
         IF (IERR1.EQ.2) GO TO 960
         END IF
      IF (DOMODL.GT.0.0) THEN
         CALL SPGMPL (DOMODL, ISLHDR, IMOD, ISLUN, ISFIND, IPBLK, BLC,
     *      TRC, IERR2)
         IF (IERR2.EQ.2) GO TO 960
         END IF
      IF (DORES.GT.0.0) THEN
         CALL SPRSPL (ISLHDR, IMOD, ISLUN, ISFIND, IPBLK, BLC, TRC,
     *      IERR3)
         IF (IERR3.EQ.2) GO TO 960
         END IF
C                                       Write end code & final buffer.
      CALL GFINIS (IPBLK, IERR4)
      IF (((IERR1.EQ.1) .OR. (IERR2.EQ.1) .OR. (IERR3.EQ.1)) .AND.
     *   (IERR4.EQ.0)) WRITE (MSGTXT,1030) IVER
      IF (IERR4.NE.0) WRITE (MSGTXT,1032) IVER
      IF ((IERR1+IERR2+IERR3.EQ.0) .AND. (IERR4.EQ.0))
     *   WRITE (MSGTXT,1034) IVER
      CALL MSGWRT (2)
      CALL HIPLOT (IVOL, ISLOT, IVER, IPBLK, IERR)
      GO TO 980
C-----------------------------------------------------------------------
C                                       Slice writing error.
C                                       Fatal error. Destroy.
 960  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (IPLUN, IPFIND, IERR)
         CALL ZDESTR (IVOL, PFILE, IERR)
         END IF
      IF (.NOT.DOTV) CALL DELEXT ('PL', IVOL, ISLOT, 'READ', CATBLK,
     *   ISBLK, IVER, IERR)
 970  CALL ZCLOSE (IMLUN, IMFIND, IERR)
      CALL ZCLOSE (ISLUN, ISFIND, IERR)
      IRETCD = 8
      GO TO 995
C                                       before plot
 975  IRETCD = 16
C                                       Close map file.
 980  CALL MAPCLS ('READ', IVOL, ISLOT, IMLUN, IMFIND, CATBLK, NOSAVE,
     *   ISBLK, IERR)
C
 995  CALL DIETSK (IRETCD, QUICK, ISBLK)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR GETTING PARAMETERS FROM AIPS. GTPARM ERR =',I5)
 1020 FORMAT ('ERROR OPENING MAP FILE. MAPOPN ERR =',I6)
 1030 FORMAT ('Partial plot finished. Version',I5)
 1032 FORMAT ('Partial plot. No finish record. Version',I5)
 1034 FORMAT ('Successful plot file version',I5,'  created.')
      END
      SUBROUTINE SPINIT (ISLUN, ISFIND, IPBLK, IDROP, LABEL, IDOMOD,
     *   IMOD, RANGE, IVER, BLC, TRC, ISLHDR, IVOL, ISLOT, PFILE, IPLUN,
     *   IPFIND, DOTV, TVCHN, GRCHN, GR2CHN, TVCORN, IERR)
C-----------------------------------------------------------------------
C   Given an open slice file and an open graph file SPINIT will write
C   plot file commands labeling the slice into the plot file.
C   Inputs:
C      ISLUN   I        logical unit no. of open slice file.
C      ISFIND  I        FTAB index for slice file.
C      IPBLK   I(256)   I/O buffer for slice file.
C      IDROP   I(2)     # points to drop left, right
C      LABEL   I        type of labeling: 1=none, 2=no tick, 3=ra/dec,
C                       4=center-rel, 5=sub-slice center-rel
C      IDOMOD  L        T => do model
C      IMOD    I        If IDOMOD, the model version #
C      RANGE   R(2)     the minimum and maximum values allowed for
C                       the plot.  If RANGE(1) .GE. RANGE(2) then the
C                       MAP min and max will be used.
C      IVER    I        Plot file version number
C   Output:
C      BLC     R(7)     Plot BLC in funny units
C      TRC     R(7)     Plot TRC in ditto
C      ISLHDR  I(256)   Slice file record 1
C      IERR    I        error code 0= none.
C                          1 = bad input parms.
C                          2 = fatal error during graphing.
C-----------------------------------------------------------------------
      INTEGER   ISLUN, ISFIND, IPBLK(256), IDROP(2), LABEL, IMOD, IVER,
     *   ISLHDR(256), IVOL, ISLOT, IPLUN, IPFIND, TVCHN, GRCHN, GR2CHN,
     *   TVCORN(4), IERR
      LOGICAL   IDOMOD, DOTV
      REAL      RANGE(2), BLC(7), TRC(7)
      CHARACTER PFILE*48
C
      CHARACTER TEXT(2)*132, NAMIN*12, CLSIN*6, OPTYPE*4, JY*8
      HOLLERITH XNAMIN(3), XCLSIN(2), XOPTYP(1)
      REAL      RMAX, PIXMAX, PIXMIN, XFAC, XOFF, RANGE2(2), CH(4), DX,
     *   SEQIN, DSKIN, PRUSER, XBLC(7), XTRC(7), YGAP, XYRATO, YMAX,
     *   YMIN, RIMAGE(20), RINP(20), FQFINC, RSBLK(256)
      DOUBLE PRECISION FQFREQ, DSBLK(128)
      INTEGER   INOSL, NTEXT, IDEPTH(5), IMAGE(20), ISBLK(256),
     *   NRPBLK, IROUND, INPRMS, IPSIZE, IPTYPE
      LOGICAL   F, ISOLD
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      EQUIVALENCE (ISBLK, RSBLK, DSBLK)
      COMMON /SLHEAD/ PRUSER, XNAMIN, XCLSIN, SEQIN, DSKIN, XBLC, XTRC,
     *   XOPTYP, YMIN, YMAX
      COMMON /CHPARM/ NAMIN, CLSIN
      COMMON /WORK/ ISBLK
      COMMON /INPARM/ RINP
      EQUIVALENCE (IMAGE, RIMAGE)
      DATA F /.FALSE./
      DATA JY /'JY'/
C-----------------------------------------------------------------------
C                                       Calculate no. of floating pt.
C                                       values in a 512 byte block.
      NRPBLK = 256
C                                       Read first slice file record
      CALL ZFIO ('READ', ISLUN, ISFIND, 1, ISLHDR, IERR)
      IF (IERR.NE.0) GO TO 950
C                                       Test IMOD, set defaults.
      IF (IDOMOD) THEN
         IF (IMOD.LE.0) IMOD = ISLHDR(58)
         IF (IMOD.GT.ISLHDR(58)) THEN
            WRITE (MSGTXT,1000) IMOD, ISLHDR(58)
            CALL MSGWRT (5)
            IMOD = ISLHDR(58)
            END IF
         END IF
C
      INOSL = ISLHDR(57)
C                                       Read 2nd record to get
C                                       origional slice inputs.
      CALL ZFIO ('READ', ISLUN, ISFIND, 2, ISBLK, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL COPY (25, ISBLK(11), PRUSER)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      IF ((OPTYPE.EQ.'AVER') .OR. (OPTYPE.EQ.'FLUX') .OR.
     *   (OPTYPE.EQ.'LGFL') .OR. (OPTYPE.EQ.'LNFL') .OR.
     *   (OPTYPE.EQ.'ADER') .OR. (OPTYPE.EQ.'FDER') .OR.
     *   (OPTYPE.EQ.'LGAV') .OR. (OPTYPE.EQ.'LNAV')) THEN
         ISOLD = .FALSE.
      ELSE
         ISOLD = .TRUE.
         END IF
      IF (OPTYPE.EQ.'FLUX') CALL CHR2H (8, JY, 1, CATH(KHBUN))
      IF (OPTYPE.EQ.'LGFL') CALL CHR2H (8, 'LOG10 JY', 1, CATH(KHBUN))
      IF (OPTYPE.EQ.'LNFL') CALL CHR2H (8, 'LN (JY)', 1, CATH(KHBUN))
      IF (OPTYPE.EQ.'FDER') CALL CHR2H (8, 'dJY / dx', 1, CATH(KHBUN))
      IF (ISOLD) THEN
         FQFINC = 0.0
         FQFREQ = 0.0D0
      ELSE
         FQFINC = RSBLK(36)
         FQFREQ = DSBLK(19)
         END IF
C                                       Range in pixel values.
      IF (RANGE(2).LE.RANGE(1)) THEN
         RANGE2(2) = YMAX
         RANGE2(1) = YMIN
      ELSE
         RANGE2(2) = RANGE(2)
         RANGE2(1) = RANGE(1)
         END IF
      IF (RANGE2(2)-RANGE2(1).GT.200.*(YMAX-YMIN)) THEN
         IF (RANGE2(1).LT.2*YMIN-YMAX) RANGE2(1) = YMIN
         IF (RANGE2(2).GT.2*YMAX-YMIN) RANGE2(2) = YMAX
         END IF
      IF (RANGE2(1).EQ.RANGE2(2)) THEN
         RANGE2(1) = RANGE2(1) - 0.001
         RANGE2(2) = RANGE2(2) + 0.001
         END IF
C                                       Calc fac & offset to keep BLC
C                                       TRC within range to prevent
C                                       overflow in graphics routines.
      DX = (RANGE2(2) - RANGE2(1)) * 0.03
      RANGE2(2) = RANGE2(2) + DX
      RANGE2(1) = RANGE2(1) - DX
      PIXMAX = RANGE2(2)
      PIXMIN = RANGE2(1)
      XFAC = 39999.0 / (PIXMAX - PIXMIN)
      XOFF = 40000.0 - XFAC * PIXMAX
      RANGE2(1) = XFAC * RANGE2(1) + XOFF
      RANGE2(2) = XFAC * RANGE2(2) + XOFF
      RMAX = 2.0 ** (NBITWD-1)  -  1
C                                      Have to truncate max.
      IF (RANGE2(2).GT.RMAX) THEN
         MSGTXT = '** WARNING ** TRUNCATING MAX Y VALUE INPUT BY USER'
         CALL MSGWRT (6)
         RANGE2(2) = RMAX
         END IF
C                                       Must increase users min.
      IF (RANGE2(1).LT.-RMAX) THEN
         MSGTXT = '** WARNING ** INCREASING Y MIN INPUT BY USER.'
         CALL MSGWRT (6)
         RANGE2(1) = -RMAX
         END IF
C                                       Round and back calc range.
      RANGE2(1) = IROUND (RANGE2(1))
      RANGE2(2) = IROUND (RANGE2(2))
      RANGE(1) = (RANGE2(1) - XOFF) / XFAC
      RANGE(2) = (RANGE2(2) - XOFF) / XFAC
C                                       Save original image pixels.
      RIMAGE(4) = XBLC(1)
      RIMAGE(5) = XBLC(2)
      RIMAGE(6) = XTRC(1)
      RIMAGE(7) = XTRC(2)
      RIMAGE(8) = XBLC(3)
      RIMAGE(9) = XTRC(3)
C                                       Initialize parms.
      BLC(2) = RANGE2(1)
      TRC(2) = RANGE2(2)
      LOCNUM = 1
      CALL RFILL (4, 0.0, CH)
      YGAP = 0.0
      CALL SLBINI (IDROP, INOSL, RANGE, BLC, TRC, XBLC, XTRC, FQFREQ,
     *   FQFINC, IDEPTH, LABEL, YGAP, CH, TEXT, NTEXT)
      CATR(IRRAN) = RANGE(1)
      CATR(IRRAN+1) = RANGE(2)
C                                       Init plot file incl defaults
      IPSIZE = 0
      IPTYPE = 5
      INPRMS = 18
      RINP(15) = RANGE(1)
      RINP(16) = RANGE(2)
      CALL GINIT (IVOL, ISLOT, PFILE, IPSIZE, IPTYPE, INPRMS, RINP,
     *   DOTV, TVCHN, GRCHN, TVCORN, CATBLK, IPBLK, IPLUN, IPFIND, IERR)
      IF (IERR.NE.0) GO TO 950
      IF (GR2CHN.GT.0) GPHTVG(1) = GR2CHN + NGRAY
C                                       Initialize plot file line drw.
      XYRATO = (TRC(2) - BLC(2)) / (TRC(1) - BLC(1))
      CALL GINITL (BLC, TRC, XYRATO, CH, IDEPTH, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GLTYPE (1, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 950
C                                       put init corners in img cat
      IMAGE(1) = ABS (LABEL)
      IMAGE(2) = IDROP(1)
      IMAGE(3) = IDROP(2)
      CALL GMCAT (9, IMAGE, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 950
C                                       Draw axis and labels
      CALL SLABEL (LABEL, IVER, YGAP, TEXT, NTEXT, BLC, TRC, IPBLK,
     *   IERR)
      IF (IERR.NE.0) GO TO 930
      CALL CLAB1 (BLC, TRC, CH, LABEL, XYRATO, F, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 930
      GO TO 999
C                                       Error. Partial file written.
 930  IERR = 1
      MSGTXT = 'ERROR DURING GRAPHING. PARTIAL PLOT FILE CREATED'
      CALL MSGWRT (6)
      GO TO 999
C                                       Fatal error during init.
 950  IERR = 2
      MSGTXT = 'FATAL ERROR. DESTROYING BAD PLOT FILE'
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('** WARNING ** Model vers being reduced',I5,' to',I5)
      END
      SUBROUTINE SPSLPL (ISLUN, ISFIND, IPBLK, BLC, TRC, IERR)
C-----------------------------------------------------------------------
C   SPSLPL plots slice data into the plot file
C   Inputs:
C      ISLUN   I        logical unit no. of open slice file.
C      ISFIND  I        FTAB index for slice file.
C      IPBLK   I(256)   I/O buffer for slice file.
C      BLC     R(7)     Bottom left hand corner in plot units.
C      TRC     R(7)     Top right hand corner in plot units.
C  Output:
C      IERR    I        error code. 0=ok, 1=plotting error, 2=fatal err
C-----------------------------------------------------------------------
      INTEGER   ISLUN, ISFIND, IPBLK(256), IERR
      REAL      BLC(7), TRC(7)
C
      REAL      SBLK(256), Y, SCALEF, OFFSET, X
      INTEGER   NRPBLK, ISTART, IEND, IRRN, IPOS, ISL, ISBLK(256)
      LOGICAL   BLAST, BNEXT
      CHARACTER TXTMSG*80
      EQUIVALENCE (ISBLK, SBLK)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /WORK/ SBLK
C-----------------------------------------------------------------------
C                                       Draw plot.
      NRPBLK = 256
      ISTART = BLC(1) + 0.5
      IEND = TRC(1) + 0.5
      IRRN = 3 + (ISTART-1)/NRPBLK
      IPOS = ISTART - ((IRRN-3) * NRPBLK)
C                                       Scale factors to scale actual
C                                       max:min values to 4000:1.
      SCALEF = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      OFFSET = 40000.0 - SCALEF * CATR(IRRAN+1)
C                                       Read first data.
      CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, ISBLK, IERR)
      IF (IERR.NE.0) GO TO 930
C                                       Draw first data pt.
      TXTMSG = 'Draw slice plot'
      CALL GCOMNT (2, TXTMSG, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GLTYPE (2, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 950
      BLAST = .TRUE.
C                                       Do rest of data points.
      DO 100 ISL = ISTART,IEND
C                                       Read from slice file.
         IF (IPOS.GT.NRPBLK) THEN
            IRRN = IRRN + 1
            CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, ISBLK, IERR)
            IF (IERR.NE.0) GO TO 930
            IPOS = 1
            END IF
C                                       Draw to next slice pt.
         X = ISL
         Y = SCALEF * SBLK(IPOS)  +  OFFSET
         BNEXT = SBLK(IPOS).EQ.FBLANK
         Y = MIN (Y, TRC(2))
         Y = MAX (Y, BLC(2))
         IPOS = IPOS + 1
         IF ((BNEXT) .OR. (BLAST)) THEN
            CALL GPOS (X, Y, IPBLK, IERR)
            BLAST = BNEXT
         ELSE
            CALL GVEC (X, Y, IPBLK, IERR)
            END IF
         IF (IERR.NE.0) GO TO 930
 100     CONTINUE
C                                       Succesful finish.
      GO TO 999
C                                       Error. Partial file written.
 930  IERR = 1
      WRITE (MSGTXT,1930)
      CALL MSGWRT (6)
      GO TO 999
C                                       Fatal error during init.
 950  IERR = 2
      WRITE (MSGTXT,1950)
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1930 FORMAT ('ERROR DURING GRAPHING. PARTIAL PLOT FILE CREATED.')
 1950 FORMAT ('FATAL ERROR. DESTROYING BAD PLOT FILE.')
      END
      SUBROUTINE SLABEL (LABEL, IVER, YGAP, TEXT, NTEXT, BLC, TRC,
     *   IPBLK, IERR)
C-----------------------------------------------------------------------
C   SLABEL does peculiar labeling for slices to plot files: border
C   lines, top label, bottom, lines
C   Inputs:
C      LABEL   I         Type of label
C      IVER    I         Plot file version number
C      YGAP    R         Place to start putting TEXT below plot
C      TEXT    C(2)*132  Text for bottom of plot
C      NTEXT   I         # lines to be used in TEXT
C      BLC     R(2)      BLC of plot file
C      TRC     R(2)      TRC of plot file
C   In/out:
C      IPBLK   I(256)    Plot work buffer
C   Output:
C      IERR    I         Error if not zero
C-----------------------------------------------------------------------
      INTEGER   LABEL, IVER, NTEXT, IPBLK(256), IERR
      REAL      YGAP, BLC(2), TRC(2)
      CHARACTER TEXT(2)*132
C
      CHARACTER TIME*8, CTEMP*18, DATE*12, SPTEXT*80
      INTEGER   IANGL, INCHAR, IT(3), ID(3), I, NCHAR, LTYPE
      REAL      DCX, DCY
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Draw border.
      CALL GPOS (BLC(1), BLC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (TRC(1), BLC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (TRC(1), TRC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (BLC(1), TRC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GVEC (BLC(1), BLC(2), IPBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      LTYPE = MOD (ABS(LABEL), 100)
      IF (LTYPE.EQ.1) GO TO 999
C                                       Source name, stokes, freq.
      IF (LTYPE.LT.7) THEN
         CALL GPOS (BLC(1), TRC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         DCX = 0.0
         DCY = 0.5
         IANGL = 0
         CALL H2CHR (8, 1, CATH(KHOBJ), SPTEXT)
         INCHAR = 12
         IF (SPTEXT.EQ.' ') INCHAR = 1
         IF (NCHLAB(1,LOCNUM).GT.0) THEN
            IF (INCHAR.GT.1) SPTEXT(INCHAR-1:INCHAR-1) = '_'
            SPTEXT(INCHAR:) = SAXLAB(1,LOCNUM)(1:NCHLAB(1,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(1,LOCNUM)
            END IF
         IF (NCHLAB(2,LOCNUM).GT.0) THEN
            IF (INCHAR.GT.1) SPTEXT(INCHAR-1:INCHAR-1) = '_'
            SPTEXT(INCHAR:) = SAXLAB(2,LOCNUM)(1:NCHLAB(2,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(2,LOCNUM)
            END IF
C                                       image name
         IF (INCHAR.GT.1) SPTEXT(INCHAR-1:INCHAR-1) = '_'
         CALL H2CHR (18, 1, CATH(KHIMN), CTEMP)
         CALL NAMEST (CTEMP, CATBLK(KIIMS), SPTEXT(INCHAR:), NCHAR)
         CALL REFRMT (SPTEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPTEXT, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Date/time, version number
      IF ((LABEL.GT.1) .AND. (LTYPE.LT.7)) THEN
         CALL GPOS (BLC(1), TRC(2), IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         DCY = DCY + 1.333
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, TIME, DATE)
         WRITE (SPTEXT,1000) IVER, DATE, TIME
         CALL REFRMT (SPTEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, IANGL, DCX, DCY, SPTEXT, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Text at bottom
      IF ((NTEXT.GT.0) .AND. (LTYPE.LT.7)) THEN
         DCX = 0.
         IANGL = 0
         DCY = -YGAP
         DO 20 I = 1,NTEXT
            CALL GPOS (BLC(1), BLC(2), IPBLK, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL CHTRIM (TEXT(I), 80, TEXT(I), INCHAR)
            CALL GCHAR (INCHAR, IANGL, DCX, DCY, TEXT(I), IPBLK,
     *         IERR)
            IF (IERR.NE.0) GO TO 999
            DCY = DCY - 1.333
 20         CONTINUE
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Plot file version',I4,'__created ',A,A)
      END
      SUBROUTINE SPGMPL (DOMODL, ISLHDR, IMOD, ISLUN, ISFIND, IPBLK,
     *   BLC, TRC, IERR)
C-----------------------------------------------------------------------
C   Given an open slice file and an open plot file, SPGMPL will write
C   a plot file representation of the slice model.
C   Inputs:
C      DOMODL  R       1,3 model sum, 2,3 comps
C      ISLHDR  I(256)  the slice file header.
C      IMOD    I       the version number of the Gaussian model.
C      ISLUN   I       logical unit no. of open slice file.
C      ISFIND  I       FTAB index for slice file.
C      IPBLK   I       plot file I/O buffer.
C      BLC     R(7)    the bottom left corner of the plot.
C      TRC     R(7)    the top right corner of the plot.
C   Output:
C      IERR    I       error code 0= none.
C                         1 = error during graphing. Try finish.
C                         2 = fatal error. Give up.
C-----------------------------------------------------------------------
      INTEGER   ISLHDR(256), IMOD, ISLUN, ISFIND, IPBLK(256), IERR
      REAL      DOMODL, BLC(7), TRC(7)
C
      REAL      X, Y, SCALEF, OFFSET, SBLK(256), PARM(12), BASLIN(3),
     *   XCEN
      INTEGER   ISTART, IEND, IRRN, IPOS, INP, ISBLK(256), IS, I0, I1,
     *   NGAUSS, I, IC, ISL, IMAX, IWTH, IDOMOD
      CHARACTER TXTMSG*80
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /WORK/ ISBLK
      EQUIVALENCE (ISBLK, SBLK)
C-----------------------------------------------------------------------
      IDOMOD = DOMODL + 0.5
      IF (IDOMOD.LE.0) IDOMOD = 1
C                                       Init some variables.
      SCALEF = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      OFFSET = 40000.0 - SCALEF * CATR(IRRAN+1)
      ISTART = BLC(1) + .5
      IEND = TRC(1) + .5
      XCEN = (ISTART + IEND) / 2.0
C                                       Read data.
      IRRN = ISLHDR(59) + IMOD - 1
      CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, ISBLK, IERR)
      IF (IERR.NE.0) GO TO 930
C                                       Move data from buffer.
      IS = 24 + 1
      I0 = ISBLK(IS)
      I1 = ISLHDR(57) - ISBLK(IS+1)
      NGAUSS = ISBLK(IS+2)
      DO 10 I = 1,12
         PARM(I) = SBLK(I)
 10      CONTINUE
      DO 20 I = 1,NGAUSS
         IC = 3 * I - 2
         PARM(IC) = PARM(IC)
 20      CONTINUE
      CALL RCOPY (3, SBLK(83), BASLIN)
C                                       Plot data points.
      IF (MOD(IDOMOD,2).EQ.1) THEN
         TXTMSG = 'Draw slice sum model'
         CALL GCOMNT (2, TXTMSG, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GLTYPE (3, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 950
         INP = 1
         DO 50 ISL = ISTART,IEND
            X = ISL
C                                       Add up all components
            Y = 0.0
            DO 40 IC = 1,NGAUSS
               IMAX = 3 * IC - 2
               IPOS = IMAX + 1
               IWTH = IPOS + 1
               Y = Y + PARM(IMAX) * EXP (- 2.772 * (PARM(IPOS) - X)
     *            ** 2  /  (PARM(IWTH) * PARM(IWTH)))
 40            CONTINUE
            Y = Y + BASLIN(1) + (X-XCEN)*BASLIN(2) +
     *         (X-XCEN)*(X-XCEN)*BASLIN(3)
C
            Y = SCALEF * Y  +  OFFSET
            Y = MIN (Y, TRC(2))
            Y = MAX (Y, BLC(2))
            IF (INP.EQ.1) THEN
               CALL GPOS (X, Y, IPBLK, IERR)
            ELSE
               CALL GVEC (X, Y, IPBLK, IERR)
               END IF
            IF (IERR.NE.0) GO TO 950
            INP = 2
 50         CONTINUE
         END IF
      IF (IDOMOD/2.GT.0) THEN
         TXTMSG = 'Draw slice components'
         CALL GCOMNT (2, TXTMSG, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 950
         CALL GLTYPE (4, IPBLK, IERR)
         IF (IERR.NE.0) GO TO 950
         INP = 1
         DO 80 IC = 1,NGAUSS
            IMAX = 3 * IC - 2
            IPOS = IMAX + 1
            IWTH = IPOS + 1
            DO 70 ISL = ISTART,IEND
               X = ISL
               Y =  2.772 * (PARM(IPOS) - X) ** 2  /
     *            (PARM(IWTH) * PARM(IWTH))
               IF (Y.GT.12) THEN
                  INP = 1
               ELSE
                  Y = PARM(IMAX) * EXP (-Y)
                  Y = SCALEF * Y  +  OFFSET
                  Y = MIN (Y, TRC(2))
                  Y = MAX (Y, BLC(2))
                  IF (INP.EQ.1) THEN
                     CALL GPOS (X, Y, IPBLK, IERR)
                  ELSE
                     CALL GVEC (X, Y, IPBLK, IERR)
                     END IF
                  IF (IERR.NE.0) GO TO 950
                  INP = 2
                  END IF
 70            CONTINUE
 80         CONTINUE
         IF ((BASLIN(1).NE.0.0) .OR. (BASLIN(2).NE.0.0) .OR.
     *      (BASLIN(3).NE.0.0)) THEN
            INP = 1
            DO 90 ISL = ISTART,IEND
               X = ISL
               Y = BASLIN(1) + (X-XCEN)*BASLIN(2) +
     *            (X-XCEN)*(X-XCEN)*BASLIN(3)
               Y = SCALEF * Y  +  OFFSET
               Y = MIN (Y, TRC(2))
               Y = MAX (Y, BLC(2))
               IF (INP.EQ.1) THEN
                  CALL GPOS (X, Y, IPBLK, IERR)
               ELSE
                  CALL GVEC (X, Y, IPBLK, IERR)
                  END IF
               IF (IERR.NE.0) GO TO 950
               INP = 2
 90            CONTINUE
            END IF
         END IF
      GO TO 999
C                                       Slice read error.
 930  IERR = 1
      MSGTXT = 'SLICE FILE READ ERROR'
      CALL MSGWRT (6)
      GO TO 999
C                                       TEK write error.
 950  IERR = 2
      MSGTXT = 'PLOT FILE WRITE ERROR'
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE SPRSPL (ISLHDR, IMOD, ISLUN, ISFIND, IPBLK, BLC, TRC,
     *   IERR)
C-----------------------------------------------------------------------
C   Given an open slice file and an open plot file, SPRSPL will write
C   plot commands to display the difference between the slice data
C   and a slice model
C   Inputs:
C      ISLHDR  I(256)  the slice file header.
C      IMOD    I       the version number of the gaussian model.
C      ISLUN   I       logical unit no. of open slice file.
C      ISFIND  I       FTAB index for slice file.
C      IPBLK   I       plot file I/O buffer.
C      BLC     R(7)    the bottom left corner of the plot.
C      TRC     R(7)    the top right corner of the plot.
C   Output:
C      IERR    I       error code 0= none.
C                         1 = error during graphing. Try finish.
C                         2 = fatal error. Give up.
C-----------------------------------------------------------------------
      INTEGER   ISLHDR(256), IMOD, ISLUN, ISFIND, IPBLK(256), IERR
      REAL      BLC(7), TRC(7)
C
      REAL      X, Y, SCALEF, OFFSET, SBLK(256), PARM(12), YSLICE
      INTEGER   ISTART, IEND, IRRN, IPOS, ISBLK(256), IS, I0, I1,
     *   NGAUSS, I, IC, INDEX, ISL, IWTH, NRPBLK, IMAX
      LOGICAL   BLAST, T, F
      CHARACTER TXTMSG*80
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /WORK/ ISBLK
      EQUIVALENCE (ISBLK, SBLK)
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Init some variables.
      NRPBLK = 256
      SCALEF = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      OFFSET = 40000.0 - SCALEF * CATR(IRRAN+1)
      ISTART = BLC(1) + .5
      IEND = TRC(1) + .5
C                                       Read model data.
      IRRN = ISLHDR(59) + IMOD - 1
      CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, ISBLK, IERR)
      IF (IERR.NE.0) GO TO 930
C                                       Move model data from buffer.
      IS = 24 + 1
      I0 = ISBLK(IS)
      I1 = ISLHDR(57) - ISBLK(IS+1)
      NGAUSS = ISBLK(IS+2)
      DO 10 I = 1,12
         PARM(I) = SBLK(I)
 10      CONTINUE
      DO 15 I = 1,NGAUSS
         IC = 3*I - 2
         PARM(IC) = PARM(IC)
 15      CONTINUE
C                                       Read 1st block of slice pts.
      IRRN = 3 + (ISTART - 1) / NRPBLK
      CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, ISBLK, IERR)
      IF (IERR.NE.0) GO TO 930
      INDEX = ISTART - ((IRRN - 3) * NRPBLK)
      BLAST = T
C                                       Plot residual data points.
      TXTMSG = 'Draw slice minus model'
      CALL GCOMNT (2, TXTMSG, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 950
      CALL GLTYPE (4, IPBLK, IERR)
      IF (IERR.NE.0) GO TO 950
      DO 50 ISL = ISTART,IEND
C                                       Get new block of data
         IF (INDEX.GT.NRPBLK) THEN
            IRRN = IRRN + 1
            CALL ZFIO ('READ', ISLUN, ISFIND, IRRN, ISBLK, IERR)
            IF (IERR.NE.0) GO TO 930
            INDEX = 1
            END IF
C                                       Get actual value
         YSLICE = SBLK(INDEX)
         INDEX = INDEX + 1
C                                       Blanked pixel found. Dont show
         IF (YSLICE.EQ.FBLANK) THEN
            BLAST = T
         ELSE
            X = ISL
            YSLICE = YSLICE
C                                       Add up all components
            Y = 0.0
            DO 40 IC = 1,NGAUSS
               IMAX = 3 * IC - 2
               IPOS = IMAX + 1
               IWTH = IPOS + 1
               Y = Y + PARM(IMAX) * EXP (-2.772 * (PARM(IPOS) - X)
     *            ** 2  /  (PARM(IWTH) * PARM(IWTH)))
 40            CONTINUE
C
            Y = SCALEF * (YSLICE - Y)  +  OFFSET
            Y = MIN (Y, TRC(2))
            Y = MAX (Y, BLC(2))
            IF (BLAST) THEN
               CALL GPOS (X, Y, IPBLK, IERR)
               BLAST = F
            ELSE
               CALL GVEC (X, Y, IPBLK, IERR)
               END IF
            IF (IERR.NE.0) GO TO 950
            END IF
 50      CONTINUE
      GO TO 999
C                                       Slice read error.
 930  IERR = 1
      MSGTXT = 'SLICE FILE READ ERROR'
      CALL MSGWRT (6)
      GO TO 999
C                                       TEK write error.
 950  IERR = 2
      MSGTXT = 'PLOT FILE WRITE ERROR'
      CALL MSGWRT (7)
C
 999  RETURN
      END

      SUBROUTINE TABSOU (OPCODE, BUFFER, ISURNO, SUKOLS, SUNUMV,
     *   IDSOU, SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO,
     *   DECEPO, EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF,
     *   PMRA, PMDEC, IERR)
C-----------------------------------------------------------------------
C! Does I/O to Source (SU) table opened by SOUINI
C# EXT-util UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998, 2009, 2012-2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to SOURCE extention tables. Usually used after setup by
C   SOUINI.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'READ' = read entry from table.
C                        'WRIT' = write entry in table.
C                        'CLOS' = close file, flush on write
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open. Should have been returned by
C                        SOUINI
C      ISURNO   I        Next record number to read or write.
C      SUKOLS   I(21)    The column pointer array in order, ID. NO.,
C                        SOURCE, QUAL, CALCODE, IFLUX, QFLUX, UFLUX,
C                        VFLUX, FREQO, BANDWIDTH, RAEPO, DECEPO, EPOCH,
C                        RAAPP, DECAPP, LSRVEL, LRESTF, PMRA, PMDEC
C      SUNUMV   I(21)    Element count in each column.
C   Input/output: (written to or read from SOURCE file)
C      IDSOU    I        Source ID as defined in the SOURCE table.
C      SOUNAM   C*16     Source name
C      QUAL     I        Source qualifier.
C      CALCOD   C*4      Calibrator code
C      FLUX     R(4,*)   Total flux density I, Q, U, V pol, (Jy)
C                        1 set per IF.
C      FREQO    D(*)     Frequency offset (Hz) from IF nominal.
C      BANDW    D        Bandwidth (Hz)
C      RAEPO    D        Right ascension at mean EPOCH (degrees)
C      DECEPO   D        Declination at mean EPOCH (degrees)
C      EPOCH    D        Equinox for position in yr. since year 0.0
C      RAAPP    D        Apparent Right ascension (degrees)
C      DECAPP   D        Apparent Declination(degrees)
C      RAOBS    D        Antenna pointing Right ascension (degrees)
C      DECOBS   D        Antenna pointing Declination(degrees)
C      LSRVEL   D(*)     LSR velocity (m/sec) of each IF
C      LRESTF   D(*)     Line rest frequency (Hz) of each IF
C      PMRA     D        Proper motion (deg/day) in RA
C      PMDEC    D        Proper motion (deg/day) in declination
C   Output:
C      ISURNO   I        Next record number.
C      IERR     I        Error code, 0=>OK else TABIO error.
C                           Note: -1=> read but record deselected.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER OPCODE*4, CALCOD*4, SOUNAM*16
      INTEGER   BUFFER(512), ISURNO, SUKOLS(MAXSUC), SUNUMV(MAXSUC),
     *   IDSOU, QUAL, IERR
      REAL      FLUX(4,*)
      DOUBLE PRECISION FREQO(*), BANDW, RAEPO, DECEPO, EPOCH, RAAPP,
     *   DECAPP, RAOBS, DECOBS, LSRVEL(*), LRESTF(*), PMRA, PMDEC
C
      DOUBLE PRECISION RECD(14+5*MAXIF)
      REAL      RECORD(27+10*MAXIF)
      HOLLERITH RECH(27+10*MAXIF)
      INTEGER   RECI(27+10*MAXIF), LOOP, LIMIT, IDKOL, SOUKOL, QKOL,
     *   CCKOL, IFKOL, QFKOL, UFKOL, VFKOL, FRKOL, BANKOL, RAEKOL,
     *   DCEKOL, EPOKOL, RAAKOL, DCAKOL, RAOKOL, DCOKOL, LSRKOL, LRFKOL,
     *   PMRKOL, PMDKOL
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (RECD, RECORD, RECI, RECH)
C-----------------------------------------------------------------------
C                                       Close
      IF (OPCODE.EQ.'CLOS') THEN
         CALL TABIO ('CLOS', 0, ISURNO, RECORD, BUFFER, IERR)
         IF (IERR.GT.0) GO TO 990
C                                       illegal opcode
      ELSE IF ((OPCODE.NE.'READ') .AND. (OPCODE.NE.'WRIT')) THEN
         MSGTXT = 'TABSOU: INVALID OPCODE= ''' // OPCODE // ''''
         GO TO 995
C                                       read/write
      ELSE
C                                       set pointers
         IDKOL = SUKOLS(1)
         SOUKOL = SUKOLS(2)
         QKOL = SUKOLS(3)
         CCKOL = SUKOLS(4)
         IFKOL = SUKOLS(5)
         QFKOL = SUKOLS(6)
         UFKOL = SUKOLS(7)
         VFKOL = SUKOLS(8)
         FRKOL = SUKOLS(9)
         BANKOL = SUKOLS(10)
         RAEKOL = SUKOLS(11)
         DCEKOL = SUKOLS(12)
         EPOKOL = SUKOLS(13)
         RAAKOL = SUKOLS(14)
         DCAKOL = SUKOLS(15)
         RAOKOL = SUKOLS(16)
         DCOKOL = SUKOLS(17)
         LSRKOL = SUKOLS(18)
         LRFKOL = SUKOLS(19)
         PMRKOL = SUKOLS(20)
         PMDKOL = SUKOLS(21)
C                                       If write fill RECORD
         IF (OPCODE.EQ.'WRIT') THEN
            RECI(IDKOL) = IDSOU
            CALL CHR2H (SUNUMV(2), SOUNAM, 1, RECH(SOUKOL))
            RECI(QKOL) = QUAL
            IF (CALCOD.EQ.'NONE') THEN
               CALL CHR2H (4, '    ', 1, RECH(CCKOL))
            ELSE
               CALL CHR2H (4, CALCOD, 1, RECH(CCKOL))
               END IF
            RECD(BANKOL) = BANDW
            RECD(RAEKOL) = RAEPO
            RECD(DCEKOL) = DECEPO
            RECD(EPOKOL) = EPOCH
            RECD(RAAKOL) = RAAPP
            RECD(DCAKOL) = DECAPP
            IF (RAOKOL.GT.0) RECD(RAOKOL) = RAOBS
            IF (DCOKOL.GT.0) RECD(DCOKOL) = DECOBS
C                                       IF dependent values.
            LIMIT = SUNUMV(18)
            DO 10 LOOP = 1,LIMIT
               IF (SUNUMV(9).GE.LOOP) RECD(FRKOL+LOOP-1) = FREQO(LOOP)
               RECD(LSRKOL+LOOP-1) = LSRVEL(LOOP)
               IF (SUNUMV(19).GE.LOOP)
     *            RECD(LRFKOL+LOOP-1) = LRESTF(LOOP)
               IF (SUNUMV(5).GE.LOOP) THEN
                  RECORD(IFKOL+LOOP-1) = FLUX(1,LOOP)
                  RECORD(QFKOL+LOOP-1) = FLUX(2,LOOP)
                  RECORD(UFKOL+LOOP-1) = FLUX(3,LOOP)
                  RECORD(VFKOL+LOOP-1) = FLUX(4,LOOP)
                  END IF
 10            CONTINUE
 15         RECD(PMRKOL) = PMRA
            RECD(PMDKOL) = PMDEC
            END IF
C                                       Process record.
         CALL TABIO (OPCODE, 0, ISURNO, RECORD, BUFFER, IERR)
         ISURNO = ISURNO + 1
         IF (IERR.GT.0) GO TO 990
C                                       If READ pick data from RECORD.
         IF (OPCODE.EQ.'READ') THEN
            IDSOU = RECI(IDKOL)
            CALL H2CHR (SUNUMV(2), 1, RECH(SOUKOL), SOUNAM)
            QUAL = RECI(QKOL)
            CALL H2CHR (4, 1, RECH(CCKOL), CALCOD)
            IF (CALCOD.EQ.'NONE') CALCOD = ' '
            BANDW = RECD(BANKOL)
            RAEPO = RECD(RAEKOL)
            DECEPO = RECD(DCEKOL)
            EPOCH = RECD(EPOKOL)
            RAAPP = RECD(RAAKOL)
            DECAPP = RECD(DCAKOL)
            IF (RAOKOL.GT.0) THEN
               RAOBS = RECD(RAOKOL)
            ELSE
               RAOBS = RAEPO
               END IF
            IF (DCOKOL.GT.0) THEN
               DECOBS = RECD(DCOKOL)
            ELSE
               DECOBS = DECEPO
               END IF
C                                       IF dependent values.
            LIMIT = SUNUMV(18)
            DO 70 LOOP = 1,LIMIT
               FREQO(LOOP) = 0.0D0
               IF (SUNUMV(9).GE.LOOP) FREQO(LOOP) = RECD(FRKOL+LOOP-1)
               LSRVEL(LOOP) = RECD(LSRKOL+LOOP-1)
               LRESTF(LOOP) = 0.0D0
               IF (SUNUMV(19).GE.LOOP)
     *            LRESTF(LOOP) = RECD(LRFKOL+LOOP-1)
               IF (SUNUMV(5).GE.LOOP) THEN
                  FLUX(1,LOOP) = RECORD(IFKOL+LOOP-1)
                  FLUX(2,LOOP) = RECORD(QFKOL+LOOP-1)
                  FLUX(3,LOOP) = RECORD(UFKOL+LOOP-1)
                  FLUX(4,LOOP) = RECORD(VFKOL+LOOP-1)
                  END IF
 70            CONTINUE
            END IF
         END IF
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1800) IERR
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1800 FORMAT ('TABSOU: TABIO ERROR',I3)
      END

      SUBROUTINE YZOOMC (MAG, XZOOM, YZOOM, VRTRTC, IERR)
C-----------------------------------------------------------------------
C! set the TV zoom magnification and center
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YZOOM writes (ONLY!!!!) the zoom control registers of the TV
C   Inputs:
C      MAG     I     0-3 for magnification 1,2,4,8 times, resp.
C      XZOOM   I     X center of expansion (1-512, 1 => LHS)
C      YZOOM   I     Y center of expansion (1-512, 1 => bot)
C      VRTRTC  L     Do on vertical retrace only?
C   Output:
C      IERR    I     error code of Z...XF: 0 -> ok, 2 -> input error
C   YZOOMC updates the /TVDEV/ common TVZOOM parameter
C   Virtual TV version (for TV by communication).
C-----------------------------------------------------------------------
      INTEGER   MAG, XZOOM, YZOOM, IERR
      LOGICAL   VRTRTC
C
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DVTV.INC'
C-----------------------------------------------------------------------
      IERR = 2
      IF ((MAG.LT.0) .OR. (MAG.GT.ABS(MXZOOM))) GO TO 999
      IF ((XZOOM.LT.1) .OR. (XZOOM.GT.MAXXTV(1))) GO TO 999
      IF ((YZOOM.LT.1) .OR. (YZOOM.GT.MAXXTV(2))) GO TO 999
C                                        set data
      BUFFER(2) = MAG
      BUFFER(3) = XZOOM
      BUFFER(4) = YZOOM
      BUFFER(1) = 0
      IF (VRTRTC) BUFFER(1) = 1
C                                        header + IO
      BUFSW = 4
      BUFSR = 0
      CALL MKYBUF ('WRIT', 'YZOOMC', BUFSW, BUFSR, BUFFER, HEADER)
      CALL ZVTVXF (BUFSW, BUFSR, HEADER, IERR)
C                                        update common /TVCHAR/
      IF (IERR.EQ.0) THEN
         TVZOOM(1) = MAG
         TVZOOM(2) = XZOOM
         TVZOOM(3) = YZOOM
         END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'SYVSN.INC'
      INTEGER   NCODE
      PARAMETER (NCODE=8)
C                                       Local include for SYVSN
      INCLUDE 'INCS:PUVD.INC'
C                                       Input parameters
      REAL      XSIN, XDISIN, XSYVER, XSNVER, XQUAL, XTIME(8), XBAND,
     *   XFREQ, XFQID, XSUBA, XANT(50), PIXR(2), XNCOU, XREF, APARM(10),
     *   BPARM(10), CPARM(10), XXINC, CROWD, ABSICA, XDO3C, XSYM,
     *   FACTOR, XDOBL, XCUTOF, XSCAN, XLABEL, XDOTV, XGRCH, XYRATO
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSOUR(4,30), XXSTOK(1),
     *   XOPTY(1), XOPCOD(1), XSAMP(1)
      CHARACTER NAMEIN*12, CLAIN*6, TYPE*2, XSOUR(30)*16, XSTOK*4,
     *   OPTYPE*4, OPCODE*4, SAMTYP*4, SYTYPE*2
C                                       Program info
C
      INTEGER   MXSCAN
      PARAMETER (MXSCAN=5000)
C
      REAL      TSTART, TSTOP, TINT, XYSCL(2,2), XYOFF(2,2), YYMX(2,2),
     *   YYMN(2,2), XMX, XMN, XMXW, XMNW, GMMOD, SELBAN, TBEG, TEND,
     *   XSTART, XSTOP, CHOUT(4), XXMIN(MAXANT), XXMAX(MAXANT),
     *   YYMIN(2,MAXANT,2), TSCAN(MXSCAN), PPMAX(2,MAXANT),
     *   YYMAX(2,MAXANT,2), PPMIN(2,MAXANT), PRAN(2,2,2),
     *   DO3COL, TCAL(4,MAXIF,MAXANT), CSMIN, CSMAX, CUTOFF, STTSY(3),
     *   STTSN(3), RVALUE(2,MAXANT), RVALS(2,MAXANT,2000),
     *   RTS(2,MAXANT,2000)
      INTEGER   SEQIN, DISKIN, CNOIN, IVER(2), BIFS(3,2), ANTS(50),
     *   ICODES(2), NCODES, NPARMS, NID, SID(500), NANTSL, NPLOTS,
     *   SUMSTK, ISTOK, FRQSEL, XINC, GRCHN, TVCHN, TVCORN(4), XVAR,
     *   ISOU, OSOU, IANT, EIFS(3,2), ITVER(2), PCNUM, LABEL, SUBARR,
     *   MUMPOL, MUMIF, MUMANT, NTONE, NUMPTS(MAXANT,2), ISYM(2),
     *   BSYM, NANREC(MAXANT,2), FANREC(MAXANT,2), NOSCAN, BIF, EIF,
     *   STRANS(MXSCAN), SCNT(MXSCAN), REFANT, NCOUNT, COLORS(2,2),
     *   NSTRAN
      LOGICAL   DOAWNT, DOTV, NNODAT, DOLINE, SWAP, REREF
      DOUBLE PRECISION SELFRQ, JD0, GNRECD(XCLRSZ/2)
C                                       SN/CL table info
      INTEGER CLBUFF(512), NCLINR, NUMANT, NUMPOL, NUMIF, ICLRNO,
     *   KOLS(40), KOLTYP(40), KOLDIM(40), ICLUN, GNRECI(XCLRSZ),
     *   TIMKOL, INTKOL, SOUKOL, ANTKOL, SUBKOL, FRQKOL, IFRKOL,
     *   GEOKOL, DOPKOL, ATMKOL, DATKOL,
     *   MB1KOL, RE1KOL, IM1KOL, DL1KOL, RA1KOL, WT1KOL, RF1KOL, TS1KOL,
     *   TA1KOL, CK1KOL, DC1KOL, DS1KOL, DD1KOL,
     *   MB2KOL, RE2KOL, IM2KOL, DL2KOL, RA2KOL, WT2KOL, RF2KOL, TS2KOL,
     *   TA2KOL, CK2KOL, DC2KOL, DS2KOL, DD2KOL,
     *   MBKOL(4), REKOL(4), IMKOL(4), DLKOL(4), RAKOL(4), WTKOL(4),
     *   RFKOL(4), TSKOL(4), TAKOL(4), CKKOL(4), DCKOL(4), DSKOL(4),
     *   DDKOL(4), STKOL(4),
     *   DOPLKL, DOP3KL, CLTIME, CABKOL, ST1KOL, ST2KOL
      REAL GNREC(XCLRSZ)
C                                       Constants
      DOUBLE PRECISION SIDER, CLIGHT
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSYVER, XSNVER,
     *   XXSOUR, XQUAL, XTIME, XXSTOK, XBAND, XFREQ, XFQID, XSUBA, XANT,
     *   PIXR, XNCOU, XOPTY, XREF, XOPCOD, APARM, BPARM, XSAMP, CPARM,
     *   XXINC, CROWD, ABSICA, XDO3C, XSYM, FACTOR, XDOBL, XCUTOF,
     *   XSCAN, XLABEL, XDOTV, XGRCH, XYRATO
      COMMON /VPARM/ SEQIN, DISKIN, CNOIN, IVER, BIF, EIF, ANTS, NCOUNT,
     *   ICODES, NCODES, NPARMS, GRCHN, TVCHN, TVCORN, XVAR, ISOU, OSOU,
     *   IANT, ITVER, PCNUM, DOTV, NNODAT, LABEL, CHOUT, DO3COL,
     *   DOLINE, NOSCAN, TSCAN, STRANS, SCNT, SWAP, REREF, REFANT,
     *   CUTOFF, TBEG, TEND, BIFS, EIFS, COLORS, STTSY, STTSN, RVALUE,
     *   NSTRAN, RVALS, RTS
      COMMON /VGNCOM/ SELFRQ, JD0,
     *   TSTART, TSTOP, TINT, XYSCL, XYOFF, SELBAN, XMX, XMN, XMXW,
     *   XMNW, XSTART, XSTOP, GMMOD, NID, SID, NANTSL, PRAN,
     *   NPLOTS, DOAWNT, ISTOK, SUMSTK, FRQSEL, XINC,
     *   SUBARR, MUMPOL, MUMIF, MUMANT, NUMPTS, NTONE,
     *   XXMIN, XXMAX, YYMIN, YYMAX, PPMIN, PPMAX, YYMX, YYMN, ISYM,
     *   BSYM, TCAL, NANREC, FANREC, CSMIN, CSMAX
      COMMON /VGNCHR/ NAMEIN, CLAIN, TYPE, XSOUR, XSTOK, OPTYPE,
     *   OPCODE, SAMTYP, SYTYPE
      COMMON /TABCOM/ GNREC, CLBUFF, NCLINR, NUMANT, NUMPOL, NUMIF,
     *   ICLRNO, KOLS, KOLTYP, KOLDIM, ICLUN,
     *   MBKOL, REKOL, IMKOL, DLKOL, RAKOL, WTKOL, RFKOL, TSKOL,
     *   TAKOL, CKKOL, DCKOL, DSKOL, DDKOL, STKOL,
     *   DOPLKL, DOP3KL, CLTIME
      COMMON /CONST/ SIDER, CLIGHT
      EQUIVALENCE (GNREC, GNRECD, GNRECI)
      EQUIVALENCE (KOLS(1), TIMKOL), (KOLS(2), INTKOL),
     *   (KOLS(3), SOUKOL), (KOLS(4), ANTKOL), (KOLS(5), SUBKOL),
     *   (KOLS(6), FRQKOL), (KOLS(7), IFRKOL),
     *   (KOLS(8), GEOKOL), (KOLS(9), DOPKOL), (KOLS(10), ATMKOL),
     *   (KOLS(11), DATKOL)
      EQUIVALENCE (KOLS(12), MB1KOL),
     *   (KOLS(13), RE1KOL), (KOLS(14), IM1KOL),
     *   (KOLS(15), RA1KOL), (KOLS(16), DL1KOL), (KOLS(17), WT1KOL),
     *   (KOLS(18), RF1KOL), (KOLS(19), TS1KOL), (KOLS(20), TA1KOL),
     *   (KOLS(21), CK1KOL), (KOLS(22), DC1KOL),
     *   (KOLS(23), DS1KOL), (KOLS(24), DD1KOL)
      EQUIVALENCE (KOLS(25), MB2KOL),
     *   (KOLS(26), RE2KOL), (KOLS(27), IM2KOL),
     *   (KOLS(28), RA2KOL), (KOLS(29), DL2KOL), (KOLS(30), WT2KOL),
     *   (KOLS(31), RF2KOL), (KOLS(32), TS2KOL), (KOLS(33), TA2KOL),
     *   (KOLS(34), CK2KOL), (KOLS(35), DC2KOL),
     *   (KOLS(36), DS2KOL), (KOLS(37), DD2KOL),
     *   (KOLS(38), CABKOL), (KOLS(39), ST1KOL), (KOLS(40), ST2KOL)
C                                                          End SYVSN
LOCAL END
      PROGRAM SYVSN
C-----------------------------------------------------------------------
C! Plots data from anSY and an SN table
C# UV Plot EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2019-2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SYVSN plots SY and SN (phase)
C   Inputs:
C      INNAME.....UV file name (name).       Standard defaults.
C      INCLASS....UV file name (class).      Standard defaults.
C      INSEQ......UV file name (seq. #).     0 => highest.
C      INDISK.....Disk unit #.               0 => any.
C      INEXT......'SN','TY','PC' or 'CL' table to be plotted
C      INVERS.....Version number of table to plot, 0=>highest no.
C      SOURCES....Source list.  '*' = all; a "-" before a source
C                 name means all except ANY source named.
C      TIMERANG...Time range of the data to be plotted. In order:
C                 Start day, hour, min. sec,
C                 end day, hour, min. sec. Days relative to ref.
C                 date.
C      STOKES.....The desired Stokes type of the output data:
C                 'R' = RCP, 'L' = LCP, 'DIFF' = difference
C      ANTENNAS...A list of the antennas to be plotted. All 0 => all.
C                 If any number is negative then all antennas listed
C                 are NOT to be plotted and all others are.
C      PIXRANGE...Limit the plot to values between PIXR(1) and
C                 PIXR(2).  The plots will not exceed the min/max in
C                 the actual gains.  Basically, if PIXR(1) < PIXR(2),
C                 all plots will be on the same scale and be limited
C                 to max (datamin, PIXR(1)) through min (datamax,
C                 PIXR(2)).  If PIXR(1) >= PIXR(2), each plot will be
C                 self-scaled individually.
C      NCOUNT.....Number of antennas to plot per page (try 5).
C      OPTYPE.....Data to be plotted: 'PSYS' = Tsys from SY
C                 'PSUM' Psum frpm SY, 'PDIF'
C      OPCODE.....'PHAS' or 'DELA' or 'AMP' from SN
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C-----------------------------------------------------------------------
C
      CHARACTER PRGN*6
      REAL      DATPTS(2), SYDAT(2), SNDAT(2)
      LONGINT   PDATPT, PSYDAT, PSNDAT
      INTEGER   IRET, MVAL, NWORDS, NROWS, NVAL
      INCLUDE 'SYVSN.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGN /'SYVSN '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL SYVSNI (PRGN, NROWS, IRET)
      IF (IRET.NE.0) GO TO 990
      MUMANT = MAX (1, MUMANT)
C                                       dynamic memory hold SY data
      NVAL = 2 + MUMPOL
      NWORDS = (NVAL * NROWS - 1) / 1024 + 21
      CALL ZMEMRY ('GET ', 'SYVALS', NWORDS, SYDAT, PSYDAT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
      MVAL = 2 + MUMIF*MUMPOL
      NWORDS = (MVAL * NROWS - 1) / 1024  + 21
      CALL ZMEMRY ('GET ', 'SYDATA', NWORDS, DATPTS, PDATPT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       read data to figure out
C                                       distribution
      NWORDS = NWORDS * 1024
      IF (IRET.EQ.0) CALL SYPCNT (NWORDS, IRET)
C                                       Fetch data
      IF (IRET.EQ.0) CALL SYPGET (MVAL, DATPTS(1+PDATPT), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       subtract ref antenna
      IF (REREF) CALL SYPREF (MVAL, DATPTS(1+PDATPT), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Compute values, get scaling
      CALL SYPMAX (1, MVAL, APARM(7), DATPTS(1+PDATPT), NVAL,
     *   SYDAT(1+PSYDAT))
C                                       free big array
      CALL ZMEMRY ('FREE', 'SYDATA', NWORDS, DATPTS, PDATPT, IRET)
C                                       init SN table
      CALL INITSN (NROWS, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       dynamic memory hold SN data
      NWORDS = (NVAL * NROWS - 1) / 1024 + 21
      CALL ZMEMRY ('GET ', 'SNVALS', NWORDS, SNDAT, PSNDAT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
      NWORDS = (MVAL * NROWS - 1) / 1024  + 21
      CALL ZMEMRY ('GET ', 'SNDATA', NWORDS, DATPTS, PDATPT, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'UNABLE TO GET DYNAMIC MEMORY'
         CALL MSGWRT (8)
         GO TO 990
         END IF
      NWORDS = NWORDS * 1024
      IF (IRET.EQ.0) CALL SNPCNT (NWORDS, IRET)
C                                       Fetch data
      IF (IRET.EQ.0) CALL SNPGET (MVAL, DATPTS(1+PDATPT), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       subtract ref antenna
      IF (REREF) CALL SNPREF (MVAL, DATPTS(1+PDATPT), IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Compute values, get scaling
C                                       delay
      IF (ICODES(2).GT.4) THEN
         CALL SYPMAX (2, MVAL, BPARM(7), DATPTS(1+PDATPT), NVAL,
     *      SNDAT(1+PSNDAT))
C                                       phase
      ELSE
         CALL SNPMAX (MVAL, DATPTS(1+PDATPT), NVAL, SNDAT(1+PSNDAT))
         END IF
C                                       free big array
      CALL ZMEMRY ('FREE', 'SNDATA', NWORDS, DATPTS, PDATPT, IRET)
C                                       Do plots
      IF (SAMTYP.NE.' ') CALL SNPCOR (NVAL, MUMANT, SYDAT(1+PSYDAT),
     *   SNDAT(1+PSNDAT))
C                                       Do plots
      CALL SNPLOT (NVAL, MUMANT, SYDAT(1+PSYDAT), SNDAT(1+PSNDAT), IRET)
      IF (IRET.LT.0) IRET = 0
C                                       Close down
 990  CALL DIE (IRET, CLBUFF)
C
 999  STOP
      END
      SUBROUTINE SYVSNI (PRGN, NROWS, IERR)
C-----------------------------------------------------------------------
C   Gets the inputs parameters for SYVSN.
C   Inputs:
C      PRGN    C*6  Program name
C   Output in common:
C      SUMSTK  I    Selected Stokes 0=both, 1=R, 2=L, 4=difference
C   Output:
C      IERR    I    Error code: 0 => ok
C      ISTOK   I    1 = R, 2 = L
C      ICODE   I    'PSUM', 'PSYS' 'PDIF', 'PHAS', 'DELA', 'AMP'
C-----------------------------------------------------------------------
      INTEGER   NROWS, IERR
      CHARACTER PRGN*6
C
      INCLUDE 'SYVSN.INC'
      CHARACTER STAT*4, TYPTMP*2
      INTEGER   IRET, BUFF(256), I, J, K, JERR, QUAL(30), NSOUR, LTYPE,
     *   BUFFER(512), IROUND, LUN, NSTOK, ICODE, JJ
      LOGICAL   T, F, MATCH
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      OSOU = -1
      NPARMS = 243
C                                        Get input parameters.
      CALL SETUP (PRGN, NPARMS, XNAMEI, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRET = 8
         RQUICK = .FALSE.
         GO TO 990
         END IF
C                                       Decode inputs.
C                                       characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XXSTOK, XSTOK)
      CALL H2CHR (4, 1, XOPTY, OPTYPE)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      CALL H2CHR (4, 1, XSAMP, SAMTYP)
      ISYM(1) = IROUND (XSYM)
      IF ((ISYM(1).LE.0) .OR. (ISYM(1).GT.24)) ISYM(1) = 1
      ISYM(2) = MOD (ISYM(1), 24) + 1
      BSYM = IROUND (XDOBL)
      IF ((BSYM.GT.0) .AND. ((BSYM.EQ.ISYM(1)) .OR. (BSYM.EQ.ISYM(2))))
     *   BSYM = MOD (ISYM(2), 24) + 1
C
      DO3COL = XDO3C
      IF (XDO3C.GT.1.5) DO3COL = -1.
      DO 20 I = 1,30
         CALL H2CHR (16, 1, XXSOUR(1,I), XSOUR(I))
         QUAL(I) = IROUND (XQUAL)
 20      CONTINUE
C                                       Integers
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      IVER(1) = IROUND (XSYVER)
      IVER(2) = IROUND (XSNVER)
      NCOUNT = IROUND (XNCOU)
      IF (NCOUNT.LE.0) NCOUNT = 4
      XNCOU = NCOUNT
      XINC = IROUND (XXINC)
      IF ((XINC.LT.25) .AND. (XINC.GT.1)) XINC = 180
      IF (ABSICA.GE.0.0) XINC = 0
      XXINC = XINC
      XVAR = IROUND (ABSICA)
      IF ((XVAR.LT.1) .OR. (XVAR.GT.6)) XVAR = 1
      DOLINE = FACTOR.LT.0.0
      FACTOR = ABS (FACTOR)
      IF ((.NOT.DOLINE) .AND. (FACTOR.LT.0.1)) FACTOR = 1.0
      IF (FACTOR.GT.10.0) FACTOR = 1.0
      REFANT = XREF + 0.1
      REREF = REFANT.GT.0
C                                       Time range
      TSTART = XTIME(1) + (XTIME(2) / 24.0) + (XTIME(3) / (24.0*60.0)) +
     *   (XTIME(4) / (24.0*3600.0))
      TSTOP = XTIME(5) + (XTIME(6) / 24.0) + (XTIME(7) / (24.0*60.0)) +
     *   (XTIME(8) / (24.0*3600.0))
      IF (TSTART.GT.0) THEN
         IF (TSTOP.LE.TSTART) TSTOP = 999
      ELSE IF (TSTART.GE.TSTOP) THEN
         TSTART = 0.0
         TSTOP = 999.0
         END IF
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
      LABEL = IROUND (XLABEL)
      LTYPE = MOD (ABS(LABEL), 100)
      IF ((LTYPE.EQ.0) .OR. (LTYPE.GT.10)) LTYPE = 3
      IF (LTYPE.GT.7) LTYPE = 7
      IF ((LTYPE.GE.4) .AND. (LTYPE.LE.6)) LTYPE = 3
      IF (LABEL.LT.0) THEN
         LABEL = (LABEL/100)*100 - LTYPE
      ELSE
         LABEL = (LABEL/100)*100 + LTYPE
         END IF
C                                       Find input catalog
      CNOIN = 1
      TYPTMP = 'UV'
      CALL CATDIR ('SRCH', DISKIN, CNOIN, NAMEIN, CLAIN, SEQIN, TYPTMP,
     *   NLUSER, STAT, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      'UV', NLUSER
         GO TO 990
         END IF
C                                       Save name class etc.
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
      XDISIN = DISKIN
      XSIN = SEQIN
C                                       Read catalog header
      STAT = 'WRIT'
      IF (DOTV) STAT = 'READ'
      CALL CATIO ('READ', DISKIN, CNOIN, CATBLK, STAT, BUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FCNO(NCFILE) = CNOIN
      FVOL(NCFILE) = DISKIN
      FRW(NCFILE) = 1
      IF (DOTV) FRW(NCFILE) = 0
      XDISIN = DISKIN
      CALL UVPGET (IERR)
      IF (IERR.NE.0) GO TO 990
      SEQIN = CATBLK(KIIMS)
      XSIN = SEQIN
C                                       SY or TY
      CALL FNDEXT ('SY', CATBLK, JJ)
      IF (JJ.GT.0) THEN
         SYTYPE = 'SY'
      ELSE
         CALL FNDEXT ('TY', CATBLK, JJ)
         IF (JJ.GT.0) THEN
            SYTYPE = 'TY'
         ELSE
            MSGTXT = 'NEITHER SY OR TY TABLE FOUND'
            IERR = 10
            GO TO 990
            END IF
         END IF
C                                       plot types
      IF (SYTYPE.EQ.'SY') THEN
         ICODE = 1
         IF (OPTYPE.EQ.'PSUM') ICODE = 2
         IF (OPTYPE.EQ.'PDIF') ICODE = 3
         IF (ICODE.EQ.1) OPTYPE = 'PSYS'
         CALL CHR2H (4, OPTYPE, 1, XOPTY)
         NCODES = 1
         ICODES(1) = ICODE
      ELSE
         ICODE = 7
         IF (OPTYPE.EQ.'TANT') ICODE = 8
         IF (ICODE.EQ.7) OPTYPE = 'TSYS'
         ICODES(1) = ICODE
         END IF
      ICODE = 4
      IF (OPCODE.EQ.'DELA') ICODE = 5
      IF (OPCODE.EQ.'AMP')  ICODE = 6
      IF (ICODE.EQ.4) OPCODE = 'PHAS'
      CALL CHR2H (4, OPCODE, 1, XOPCOD)
      ICODES(2) = ICODE
C                                       Subarray
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.EQ.0) SUBARR = 1
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.GE.0) THEN
         LUN = 25
         CALL FQMATC (DISKIN, CNOIN, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *      FRQSEL, IERR)
         IF (.NOT.MATCH) THEN
            WRITE (MSGTXT,1070)
            IERR = 1
            GO TO 990
            END IF
         IF (IERR.GT.0) GO TO 999
         END IF
C                                       IF'S
      CALL FILL (6, 0, BIFS)
      CALL FILL (6, -1, EIFS)
      IF (APARM(7).EQ.0.0) APARM(7) = 1.0
      IF (BPARM(7).EQ.0.0) BPARM(7) = 1.0
      IF (JLOCIF.GE.0) THEN
         I = IROUND(APARM(1))
         J = IROUND(APARM(2))
         IF ((I.LE.0) .OR. (J.LT.I)) THEN
            MSGTXT = 'APARM(1,2) HAVE NO DEFAULT'
            IERR = 1
            GO TO 990
            END IF
         BIFS(1,1) = MIN (I, CATBLK(KINAX+JLOCIF))
         EIFS(1,1) = MIN (J, CATBLK(KINAX+JLOCIF))
         BIF = BIFS(1,1)
         EIF = EIFS(1,1)
         I = IROUND(APARM(3))
         J = IROUND(APARM(4))
         IF ((I.LE.0) .OR. (J.LT.I)) GO TO 21
         BIFS(2,1) = MIN (I, CATBLK(KINAX+JLOCIF))
         EIFS(2,1) = MIN (J, CATBLK(KINAX+JLOCIF))
         BIF = MIN (BIF, BIFS(2,1))
         EIF = MAX (EIF, EIFS(2,1))
         I = IROUND(APARM(5))
         J = IROUND(APARM(6))
         IF ((I.LE.0) .OR. (J.LT.I)) GO TO 21
         BIFS(3,1) = MIN (I, CATBLK(KINAX+JLOCIF))
         EIFS(3,1) = MIN (J, CATBLK(KINAX+JLOCIF))
         BIF = MIN (BIF, BIFS(3,1))
         EIF = MAX (EIF, EIFS(3,1))
 21      I = IROUND(BPARM(1))
         J = IROUND(BPARM(2))
         IF ((I.LE.0) .OR. (J.LT.I)) THEN
            MSGTXT = 'BPARM(1,2) HAVE NO DEFAULT'
            IERR = 1
            GO TO 990
            END IF
         BIFS(1,2) = MIN (I, CATBLK(KINAX+JLOCIF))
         EIFS(1,2) = MIN (J, CATBLK(KINAX+JLOCIF))
         BIF = MIN (BIF, BIFS(1,2))
         EIF = MAX (EIF, EIFS(1,2))
         I = IROUND(BPARM(3))
         J = IROUND(BPARM(4))
         IF ((I.LE.0) .OR. (J.LT.I)) GO TO 25
         BIFS(2,2) = MIN (I, CATBLK(KINAX+JLOCIF))
         EIFS(2,2) = MIN (J, CATBLK(KINAX+JLOCIF))
         BIF = MIN (BIF, BIFS(2,2))
         EIF = MAX (EIF, EIFS(2,2))
         I = IROUND(BPARM(5))
         J = IROUND(BPARM(6))
         IF ((I.LE.0) .OR. (J.LT.I)) GO TO 25
         BIFS(3,2) = MIN (I, CATBLK(KINAX+JLOCIF))
         EIFS(3,2) = MIN (J, CATBLK(KINAX+JLOCIF))
         BIF = MIN (BIF, BIFS(3,2))
         EIF = MAX (EIF, EIFS(3,2))
      ELSE
         BIFS(1,1) = 1
         EIFS(1,1) = 1
         BIF = 1
         EIF = 1
         BIFS(1,2) = 1
         EIFS(1,2) = 1
         END IF
C                                       Look up sources
 25   NID = 500
      NSOUR = 30
      MSGSUP = 32000
      CALL SOURNU (XSOUR, QUAL, NSOUR, DISKIN, CNOIN, NID, BUFFER, SID,
     *   JERR)
      MSGSUP = 0
      IF (JERR.LT.0) THEN
         MSGTXT = 'SPECIFIED SOURCE(S) NOT FOUND - CONTINUING'
         CALL MSGWRT (6)
         END IF
      IF (JERR.NE.0) NID = 0
C                                       Check antennas desired.
      NANTSL = 0
      DOAWNT = T
      I = 0
      DO 70 J = 1,50
         JJ = IROUND (XANT(J))
         IF (JJ.LT.0) DOAWNT = F
C                                       Make positive
         JJ = ABS (JJ)
C                                       Check for multiple entries
         DO 50 K = 1,I
            IF (JJ.EQ.ANTS(K)) GO TO 70
 50         CONTINUE
         IF (JJ.GT.0) THEN
            I = I + 1
            ANTS(I) = JJ
            NANTSL = I
            END IF
 70      CONTINUE
C                                       Make sure not too many
      IF (NANTSL.GT.MAXANT) NANTSL = MAXANT
C                                       add rEFANT if needed
      IF ((DOAWNT) .AND. (NANTSL.GT.0) .AND. (REFANT.GT.0)) THEN
         DO 71 K = 1,NANTSL
            IF (ANTS(I).EQ.REFANT) GO TO 75
 71         CONTINUE
         IF (NANTSL.LT.MAXANT) NANTSL = NANTSL + 1
         ANTS(NANTSL) = REFANT
         END IF
C                                       Get antenna names
 75   CALL GETANT (DISKIN, CNOIN, MAX (1, SUBARR), CATBLK, BUFFER, JERR)
      MUMANT = NSTNS
      IF (MUMANT.LE.1) THEN
         MUMANT = MAXANT
         TIMLAB = 'IAT'
         END IF
      CALL JULDAY (RDATE, JD0)
C                                       Check Stokes' (R or IPOL)
C                                       Set stokes request
      NSTOK = CATBLK(KINAX+JLOCS)
      MUMPOL = 1
      IF ((ICOR0.EQ.1) .OR. (ICOR0.EQ.-2) .OR. (ICOR0.EQ.-6) .OR.
     *   (((ICOR0.EQ.-1) .OR. (ICOR0.EQ.-5)) .AND. (NSTOK.EQ.1))) THEN
         ISTOK = ABS (ICOR0)
         SUMSTK = 1
         XSTOK = 'I'
         IF (ICOR0.EQ.-2) XSTOK='L'
         IF (ICOR0.EQ.-1) XSTOK='R'
      ELSE IF (ICOR0.EQ.-1) THEN
         IF ((XSTOK.EQ.'R') .OR. (XSTOK.EQ.'RR')) THEN
            ISTOK = 1
            SUMSTK = 1
            XSTOK = 'R'
         ELSE IF ((XSTOK.EQ.'L') .OR. (XSTOK.EQ.'LL')) THEN
            ISTOK = 2
            SUMSTK = 2
            XSTOK = 'L'
         ELSE
            ISTOK = 1
            SUMSTK = 0
            XSTOK = 'R&L'
            MUMPOL = 2
            END IF
      ELSE IF (ICOR0.EQ.-5) THEN
         IF ((XSTOK.EQ.'V') .OR. (XSTOK.EQ.'VV')) THEN
            ISTOK = 1
            SUMSTK = 1
            XSTOK = 'V'
         ELSE IF ((XSTOK.EQ.'H') .OR. (XSTOK.EQ.'HH')) THEN
            ISTOK = 2
            SUMSTK = 2
            XSTOK = 'H'
         ELSE
            ISTOK = 1
            SUMSTK = 0
            XSTOK = 'V&H'
            MUMPOL = 2
            END IF
         END IF
      CALL CHR2H (4, XSTOK, 1, XXSTOK)
C                                       Open table to check
      TYPE = SYTYPE
      CUTOFF = XCUTOF
      CALL FILL (2*MAXANT, 0, NUMPTS)
C                                       Open SN, CL, TY or PC table
      CALL SNPOPN (NROWS, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get TCals
      IF (OPTYPE.EQ.'PSYS') THEN
         J = 0
         CALL GETCDS (DISKIN, CNOIN, J, SUBARR, FRQSEL, CATBLK, TCAL,
     *      JERR)
         IF (JERR.NE.0) GO TO 999
         END IF
      XSYVER = IVER(1)
      MUMIF = EIF - BIF + 1
      CSMAX = -100000
      CSMIN = 1000000
      CALL RFILL (MAXANT, 1.E5, XXMIN)
      CALL RFILL (MAXANT, -1.E5, XXMAX)
      I = 2 * MAXANT
      CALL RFILL (I, 1.E8, PPMIN)
      CALL RFILL (I, -1.E8, PPMAX)
      I = I * 2
      CALL RFILL (I, 1.E8, YYMIN)
      CALL RFILL (I, -1.E8, YYMAX)
      CALL RFILL (2, -1.E8, YYMX)
      CALL RFILL (2,  1.E8, YYMN)
      IF (XVAR.EQ.1) THEN
         IF (TSTART.GT.0.0) CALL RFILL (MAXANT, TSTART, XXMIN)
         IF ((TSTOP.LT.999.) .AND. (TSTOP.GT.TSTART) .AND.
     *      (TSTOP.GT.0.0)) CALL RFILL (MAXANT, TSTOP, XXMAX)
         END IF
      IF ((XSCAN.GT.0.0) .AND. (XVAR.EQ.1)) THEN
         LUN = 25
         CALL GETNX (LUN, DISKIN, CNOIN, CATBLK, SUBARR, BUFFER, NOSCAN,
     *      TSCAN)
      ELSE
         NOSCAN = 0
         END IF
C                                       smoothing parms
      IF ((SAMTYP.NE.' ') .AND. (XVAR.GT.1)) THEN
         IF ((SAMTYP.EQ.'MWF') .OR. (SAMTYP.EQ.'2PT')) THEN
            MSGTXT = 'SAMTYP = MWF OR 2PT WORKS ONLY ON XAXIS 1 (TIME)'
            CALL MSGWRT (6)
            SAMTYP = ' '
            END IF
         END IF
      IF (SAMTYP.NE.' ') THEN
         STTSY(1) = CPARM(1)
         STTSY(2) = CPARM(6)
         STTSY(3) = 0.01
         IF (STTSY(1).LE.0.0) STTSY(1) = 30.0
         IF (STTSY(2).LE.0.0) STTSY(2) = STTSY(1) / 2.0
         STTSN(1) = CPARM(2)
         STTSN(2) = CPARM(7)
         STTSN(3) = 0.01
         IF (STTSN(1).LE.0.0) STTSN(1) = 30.0
         IF (STTSN(2).LE.0.0) STTSN(2) = STTSN(1) / 2.0
         I = 2 * MAXANT
         CALL RFILL (I, 0.0, RVALUE)
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR;',I7,'GETTING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',I3,
     *   ' TYPE=',A2,' USER=',I4)
 1040 FORMAT ('ERROR',I3,' COPYING CATALOG HEADER')
 1070 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
      END
      SUBROUTINE INITSN (NROWS, IERR)
C-----------------------------------------------------------------------
C   Inits the I/O to the SN table
C   Outputs:
C      NROWS   I   Number rows in SN table
C      IERR    I   Error code
C-----------------------------------------------------------------------
      INTEGER   NROWS, IERR
C
      INCLUDE 'SYVSN.INC'
C-----------------------------------------------------------------------
      TYPE = 'SN'
      CALL SNPOPN (NROWS, IERR)
      XSNVER = IVER(2)
C
 999  RETURN
      END
      SUBROUTINE SNPOPN (NROWS, IERR)
C-----------------------------------------------------------------------
C   Routine to open SN, CL, PC, TY, SY table and get necessary
C   information
C   Input from Common:
C      TYPE     C*2  'SN', 'CL', 'PC', 'TY', SY
C      DISKIN   I     Disk number
C      CNOIN    I     Catalog slot number
C      CATBLK   I(*)  Catalog header
C      SUMSTK   I     Stokes type requested 0=both, 1=R, 2=L,
C                     3=difference, 4=ratio
C   Output:
C      IERR     I     Error code, 0=OK else failed.
C   Output in common:
C      ICLRNO       I    Current cal record number
C      NCLINR       I    Number of gain records in file.
C      NUMANT       I    Number of antennas
C      NUMPOL       I    Number of polarizations
C      NUMIF        I    Number of IFs.
C      ITVER        I    Version number opened.
C      KOLS         I(*) Column pointers
C      KOLTYP       I(*) Column data types
C      KOLDIM       I(*) Column dimension
C-----------------------------------------------------------------------
      INTEGER   NROWS, IERR
      INCLUDE 'SYVSN.INC'
C
      CHARACTER KEYW(4)*8, COLHD1(11)*24, COLHD2(13)*24, COLHD3(13)*24,
     *   COLTAB(40)*24, COLHED(37)*24, KEYSN(4)*8
      INTEGER   NKEY, NREC, NCOL, DATP(128,2), IPOINT, KEYTYP(4), KK,
     *   KLOCS(4), KEYVAL(6), I, KP, MSGSAV
      LOGICAL   T, DOM
      REAL      KEYVR(6)
      DOUBLE PRECISION KEYVAD
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      EQUIVALENCE (KEYVAL, KEYVR)
      EQUIVALENCE (COLHED(1), COLHD1), (COLHED(12), COLHD2),
     *   (COLHED(25), COLHD3)
      DATA COLHD1 /'TIME                    ',
     *   'TIME INTERVAL           ',
     *   'SOURCE ID               ', 'ANTENNA NO.             ',
     *   'SUBARRAY                ', 'FREQ ID                 ',
     *   'I.FAR.ROT               ',
     *   'GEODELAY                ', 'DOPPOFF                 ',
     *   'ATMOS                   ', 'DATMOS                  '/
      DATA COLHD2 /'MBDELAY1      ',
     *   'REAL1                   ', 'IMAG1                   ',
     *   'RATE 1                  ', 'DELAY 1                 ',
     *   'WEIGHT 1                ', 'REFANT 1                ',
     *   'TSYS 1                  ', 'TANT 1                  ',
     *   'CLOCK 1                 ', 'DCLOCK 1                ',
     *   'DISP 1                  ', 'DDISP 1                 '/
      DATA COLHD3 /'MBDELAY2      ',
     *   'REAL2                   ', 'IMAG2                   ',
     *   'RATE 2                  ', 'DELAY 2                 ',
     *   'WEIGHT 2                ', 'REFANT 2                ',
     *   'TSYS 2                  ', 'TANT 2                  ',
     *   'CLOCK 2                 ', 'DCLOCK 2                ',
     *   'DISP 2                  ', 'DDISP 2                 '/
      DATA KEYSN /'NO_ANT  ', 'NO_POL  ', 'NO_IF   ','MGMOD   '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Open table
      ICLUN = 28
      NKEY = 0
      NREC = 0
      NCOL = 0
      ICLRNO = 1
      KK = 2
      IF (TYPE.EQ.'SY') KK = 1
      IF (TYPE.EQ.'TY') KK = 1
      CALL TABINI ('READ', TYPE, DISKIN, CNOIN, IVER(KK), CATBLK, ICLUN,
     *   NKEY, NREC, NCOL, DATP, CLBUFF, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1100) IERR, TYPE, IVER(KK)
         GO TO 980
         END IF
      ITVER(KK) = IVER(KK)
C                                       Get number of scans
      NCLINR = CLBUFF(5)
      NROWS = NCLINR
C                                       Check if empty
      IF (NCLINR.LE.0) THEN
         IERR = 6
         MSGTXT = 'ERROR: SELECTED TABLE IS EMPTY'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Get column pointers
      NKEY = 40
      DO 10 I = 1,NKEY
         COLTAB(I) = COLHED(I)
 10      CONTINUE
C                                       SY uses Re/Im/Wt for
C                                       DIF, SUM, GAIN
      IF (TYPE.EQ.'SY') THEN
         COLTAB(13) = 'POWER DIF1'
         COLTAB(14) = 'POWER SUM1'
         COLTAB(17) = 'POST GAIN1'
         COLTAB(21) = 'CAL TYPE'
         COLTAB(26) = 'POWER DIF2'
         COLTAB(27) = 'POWER SUM2'
         COLTAB(30) = 'POST GAIN2'
         COLTAB(34) = 'CAL TYPE'
         END IF
      CALL FNDCOL (NKEY, COLTAB, 24, T, CLBUFF, KOLS, IERR)
      IF ((IERR.GE.1) .AND. (IERR.LE.10)) GO TO 999
      IERR = 0
C                                       Time column logical number
      CLTIME = KOLS(1)
C                                       Convert to pointers, types
      DO 20 I = 1,NKEY
         KP = KOLS(I)
         IF (KP.GT.0) THEN
            KOLS(I) = DATP(KP,1)
            KOLTYP(I) = MOD (DATP(KP,2), 10)
            KOLDIM(I) = DATP(KP,2) / 10
         ELSE
            KOLS(I) = -1
            KOLTYP(I) = -1
            KOLDIM(I) = 0
            END IF
 20      CONTINUE
C                                       Table keywords
      NKEY = 4
      DO 30 I = 1,NKEY
         KEYW(I) = KEYSN(I)
 30      CONTINUE
      MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL TABKEY ('READ', KEYW, NKEY, CLBUFF, KLOCS, KEYVAL, KEYTYP,
     *   IERR)
      MSGSUP = MSGSAV
      IF ((IERR.GE.1) .AND. (IERR.LE.20)) GO TO 999
      IERR = 0
C                                       Retrieve keyword values: other
      NTONE = 1
C                                       No. antennas.
      NUMANT = NSTNS
      IPOINT = KLOCS(1)
      IF (IPOINT.GT.0) NUMANT = KEYVAL(IPOINT)
C                                       No. poln.
      NUMPOL = 1
      IPOINT = KLOCS(2)
      IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. IF
      NUMIF = 1
      IPOINT = KLOCS(3)
      IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       Mean gain modulus
      GMMOD = 1.0
      IPOINT = KLOCS(4)
      IF (IPOINT.GT.0) THEN
         IF (KEYTYP(4).EQ.1) THEN
            CALL DPCOPY (1, KEYVR(IPOINT), KEYVAD)
         ELSE
            KEYVAD = KEYVR(IPOINT)
            END IF
         IF (KEYVAD.GT.0.0) GMMOD = 1.0 / KEYVAD
         END IF
C                                       Set pointers
      DOPKOL = DOPKOL + BIF - 1
      DOP3KL = DOPKOL + EIF - 1
      DOPLKL = DOPKOL
      PCNUM = 1
C                                       1st poln
      IF ((ISTOK.EQ.ABS (ICOR0)) .OR. (ISTOK.EQ.ABS (ICOR0+4))) THEN
         MBKOL(1) = MB1KOL
         REKOL(1) = RE1KOL + ((BIF-1) * NTONE) + PCNUM - 1
         IMKOL(1) = IM1KOL + ((BIF-1) * NTONE) + PCNUM - 1
         DLKOL(1) = DL1KOL + BIF - 1
         RAKOL(1) = RA1KOL + BIF - 1
         WTKOL(1) = WT1KOL + BIF - 1
         RFKOL(1) = RF1KOL + BIF - 1
         TSKOL(1) = TS1KOL + BIF - 1
         TAKOL(1) = TA1KOL + BIF - 1
         CKKOL(1) = CK1KOL
         DCKOL(1) = DC1KOL
         DSKOL(1) = DS1KOL
         DDKOL(1) = DD1KOL
         STKOL(1) = ST1KOL + BIF - 1
C                                       2nd poln
      ELSE
         MBKOL(1) = MB2KOL
         REKOL(1) = RE2KOL + ((BIF-1) * NTONE) + PCNUM - 1
         IMKOL(1) = IM2KOL + ((BIF-1) * NTONE) + PCNUM - 1
         DLKOL(1) = DL2KOL + BIF - 1
         RAKOL(1) = RA2KOL + BIF - 1
         WTKOL(1) = WT2KOL + BIF - 1
         RFKOL(1) = RF2KOL + BIF - 1
         TSKOL(1) = TS2KOL + BIF - 1
         TAKOL(1) = TA2KOL + BIF - 1
         CKKOL(1) = CK2KOL
         DCKOL(1) = DC2KOL
         DSKOL(1) = DS2KOL
         DDKOL(1) = DD2KOL
         STKOL(1) = ST2KOL + BIF - 1
         END IF
C                                       2nd Poln
      MBKOL(2) = MB2KOL
      REKOL(2) = RE2KOL + ((BIF-1) * NTONE) + PCNUM - 1
      IMKOL(2) = IM2KOL + ((BIF-1) * NTONE) + PCNUM - 1
      DLKOL(2) = DL2KOL + BIF - 1
      RAKOL(2) = RA2KOL + BIF - 1
      WTKOL(2) = WT2KOL + BIF - 1
      RFKOL(2) = RF2KOL + BIF - 1
      TSKOL(2) = TS2KOL + BIF - 1
      TAKOL(2) = TA2KOL + BIF - 1
      CKKOL(2) = CK2KOL
      DCKOL(2) = DC2KOL
      DSKOL(2) = DS2KOL
      DDKOL(2) = DD2KOL
      STKOL(2) = ST2KOL + BIF - 1
C                                       Phase, amplitude
      DOM = .FALSE.
      IF ((TYPE.EQ.'SN') .AND. (OPCODE.EQ.'PHAS')) THEN
         IF ((REKOL(1).LT.0) .OR. (IMKOL(1).LT.0)) GO TO 500
         IF (((MUMPOL.EQ.2)) .AND. ((REKOL(2).LT.0) .OR.
     *      (IMKOL(2).LT.0))) GO TO 500
         END IF
      IF ((TYPE.EQ.'SN') .AND. (OPCODE.EQ.'AMP')) THEN
         IF ((REKOL(1).LT.0) .OR. (IMKOL(1).LT.0)) GO TO 500
         IF (((MUMPOL.EQ.2)) .AND. ((REKOL(2).LT.0) .OR.
     *      (IMKOL(2).LT.0))) GO TO 500
         END IF
C                                       Singleband Delay
      IF ((TYPE.EQ.'SN') .AND. (OPCODE.EQ.'DELA')) THEN
         IF (DLKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (DLKOL(2).LT.0)) GO TO 500
         END IF
C                                       SY Pdif
      IF ((TYPE.EQ.'SY') .AND. (OPTYPE.EQ.'PDIF')) THEN
         IF (REKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (IMKOL(2).LT.0)) GO TO 500
         END IF
C                                       SY Psum
      IF ((TYPE.EQ.'SY') .AND. (OPTYPE.EQ.'PSUM')) THEN
         IF (IMKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (IMKOL(2).LT.0)) GO TO 500
         END IF
C                                       SY TSYS
      IF ((TYPE.EQ.'SY') .AND. (OPTYPE.EQ.'PSYS')) THEN
         IF (REKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (REKOL(2).LT.0)) GO TO 500
         IF (IMKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (IMKOL(2).LT.0)) GO TO 500
         END IF
C                                       System temperature
      IF ((TYPE.EQ.'TY') .AND. (OPTYPE.EQ.'TSYS')) THEN
         IF (TSKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (TSKOL(2).LT.0)) GO TO 500
         END IF
C                                       Antenna temperature
      IF ((TYPE.EQ.'TY') .AND. (OPTYPE.EQ.'TANT')) THEN
         IF (TAKOL(1).LT.0) GO TO 500
         IF ((MUMPOL.EQ.2) .AND. (TAKOL(2).LT.0)) GO TO 500
         END IF
      GO TO 999
C                                       Requested data not in table
 500  WRITE(MSGTXT,1500) OPTYPE, TYPE
      IERR = 10
      GO TO 980
C                                       Error
 980  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ERROR ',I3,' OPENING ',A,' TABLE NO. ',I3)
 1500 FORMAT (' REQUESTED DATA ',A,' NOT IN ',A,' TABLE ')
      END
      SUBROUTINE SYPCNT (NWORDS, IERR)
C-----------------------------------------------------------------------
C   SNPCNT reads the SY table to find the number of samples for each ant
C   Input:
C      NWORDS   I      Size of work array
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NWORDS, IERR
C
      INCLUDE 'SYVSN.INC'
      LOGICAL   NODATA, OKAY
      INTEGER   I, NP
      REAL      GTIME, XVARIB, CSOU, VALUE(2*MAXIF), TEMP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      CALL FILL (MAXANT, 0, NANREC(1,1))
      CALL FILL (MXSCAN, 0, SCNT)
      NODATA = .TRUE.
      TBEG = 1.0E5
      TEND = -1.0E5
      IF ((XVAR.EQ.1) .AND. (TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TBEG = TSTART
         TEND = TSTOP
         END IF
      XMX = TEND
      XMN = TBEG
      XMXW = TEND
      XMNW = TBEG
C                                       Loop thru data
      TINT = -1.0
      IF (INTKOL.LE.0) TINT = 10.0 / 86400.0
      NP = MUMPOL * MUMIF
      DO 100 ICLRNO = 1,NCLINR
         CALL TABIO ('READ', 0, ICLRNO, GNREC, CLBUFF, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
C                                       Solution interval
         IF (TINT.LE.0) TINT = GNREC(INTKOL)
C                                       Record within specified
C                                       time range ?
         IF (KOLTYP(CLTIME).EQ.1) THEN
            GTIME = GNRECD(TIMKOL)
         ELSE
            GTIME = GNREC(TIMKOL)
            END IF
         IF ((GTIME.LT.TSTART) .OR. (GTIME.GT.TSTOP)) GO TO 100
C                                       Freq id
         IF ((GNRECI(FRQKOL).GT.0) .AND. (GNRECI(FRQKOL).NE.FRQSEL)
     *      .AND. (FRQSEL.GT.0)) GO TO 100
C                                       Subarray
         IF ((GNRECI(SUBKOL).GT.0) .AND. (SUBARR.GT.0) .AND.
     *      (GNRECI(SUBKOL).NE.SUBARR)) GO TO 100
C                                       Antenna?
         IANT = GNRECI(ANTKOL)
         IF (NANTSL.GT.0) THEN
            DO 50 I = 1,NANTSL
               IF ((IANT.EQ.ANTS(I)).AND.DOAWNT) GO TO 60
               IF ((IANT.EQ.ANTS(I)).AND.(.NOT.DOAWNT)) GO TO 100
 50            CONTINUE
            IF (DOAWNT) GO TO 100
            END IF
C                                       Check source
 60      IF (NID.GT.0) THEN
            ISOU = GNRECI(SOUKOL)
            DO 70 I = 1,NID
               IF (ISOU.EQ.SID(I)) GO TO 80
 70            CONTINUE
            GO TO 100
            END IF
C                                      Get start, stop times
 80      TBEG = MIN (TBEG, GTIME)
         TEND = MAX (TEND, GTIME)
C                                       Get value
         CALL SNPDAT (1, VALUE, XVARIB, CSOU, OKAY)
C                                       Max. - Min
         IF (((OKAY) .OR. (BSYM.GT.0)) .AND. (XVARIB.NE.FBLANK)) THEN
            IF (OKAY) NODATA = .FALSE.
            NANREC(IANT,1) = NANREC(IANT,1) + 1
            I = CSOU + 0.1
            IF ((I.GT.0) .AND. (I.LE.MXSCAN)) SCNT(I) = SCNT(I) + 1
            IF (XVAR.NE.6) THEN
               XMX = MAX (XMX, XVARIB)
               XMN = MIN (XMN, XVARIB)
            ELSE
               TEMP = XVARIB
               IF (TEMP.LT.0.0) TEMP = TEMP + 360.
               XMX = MAX (XMX, TEMP)
               XMN = MIN (XMN, TEMP)
               IF (TEMP.GT.180.0) TEMP = TEMP - 360
               XMXW = MAX (XMXW, TEMP)
               XMNW = MIN (XMNW, TEMP)
               END IF
            END IF
 100     CONTINUE
      IERR = MAX (0, IERR)
      FANREC(1,1) = 1
      DO 120 I = 2,MAXANT
         FANREC(I,1) = FANREC(I-1,1) + NANREC(I-1,1)
 120     CONTINUE
      IF (NWORDS.LT.FANREC(MAXANT,1)+NANREC(MAXANT,1)) THEN
         MSGTXT = 'SY MEMORY TOO SMALL'
         IERR = 10
         END IF
C                                       source number translation
      NP = 0
      CALL FILL (MXSCAN, 0, STRANS)
      DO 130 I = 1,MXSCAN
         IF (SCNT(I).GT.0) THEN
            NP = NP + 1
            STRANS(I) = NP
            END IF
 130     CONTINUE
      NSTRAN = NP
C
 990  IF (IERR.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SYPCNT: ERROR =',I3,' FROM TABIO')
      END
      SUBROUTINE SNPCNT (NWORDS, IERR)
C-----------------------------------------------------------------------
C   SNPCNT reads the SN or CL table to find the number of samples for
C   each antenna
C   Input:
C      NWORDS   I      Size of work array
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NWORDS, IERR
C
      INCLUDE 'SYVSN.INC'
      LOGICAL   NODATA, OKAY
      INTEGER   I, NP, IFNUM
      REAL      GTIME, XVARIB, CSOU, VALUE(2*MAXIF)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      CALL FILL (MAXANT, 0, NANREC(1,2))
      NODATA = .TRUE.
C                                       Loop thru data
      TINT = -1.0
      IF (INTKOL.LE.0) TINT = 10.0 / 86400.0
      NP = MUMPOL * MUMIF
      DO 100 ICLRNO = 1,NCLINR
         CALL TABIO ('READ', 0, ICLRNO, GNREC, CLBUFF, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
C                                       Solution interval
         IF (TINT.LE.0) TINT = GNREC(INTKOL)
C                                       Check weight per IF
C                                       If weight < CUTOFF them
C                                       set amp, phase, delay and
C                                       rate to FBLANK FOR EACH IF
         IF ((CUTOFF.GE.0.0) .AND. (WT1KOL.GT.0)) THEN
            IF (NUMPOL.EQ.2) THEN
               IF (SUMSTK.EQ.0) THEN
                  DO 5 IFNUM = 0, MUMIF - 1
                     IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                        GNREC(REKOL(1) + IFNUM) = FBLANK
                        GNREC(IMKOL(1) + IFNUM) = FBLANK
                        GNREC(DLKOL(1) + IFNUM) = FBLANK
                        GNREC(RAKOL(1) + IFNUM) = FBLANK
                        END IF
                     IF (GNREC(WTKOL(2) + IFNUM).LE.CUTOFF) THEN
                        GNREC(REKOL(2) + IFNUM) = FBLANK
                        GNREC(IMKOL(2) + IFNUM) = FBLANK
                        GNREC(DLKOL(2) + IFNUM) = FBLANK
                        GNREC(RAKOL(2) + IFNUM) = FBLANK
                        END IF
 5                   CONTINUE
               ELSE IF (SUMSTK.EQ.1) THEN
                  DO 15 IFNUM = 0, MUMIF - 1
                     IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                        GNREC(REKOL(1) + IFNUM) = FBLANK
                        GNREC(IMKOL(1) + IFNUM) = FBLANK
                        GNREC(DLKOL(1) + IFNUM) = FBLANK
                        GNREC(RAKOL(1) + IFNUM) = FBLANK
                        END IF
 15                  CONTINUE
               ELSE IF (SUMSTK.EQ.2) THEN
                  DO 25 IFNUM = 0, MUMIF - 1
                     IF (GNREC(WTKOL(2) + IFNUM).LE.CUTOFF) THEN
                        GNREC(REKOL(2) + IFNUM) = FBLANK
                        GNREC(IMKOL(2) + IFNUM) = FBLANK
                        GNREC(DLKOL(2) + IFNUM) = FBLANK
                        GNREC(RAKOL(2) + IFNUM) = FBLANK
                        END IF
 25                  CONTINUE
                  END IF
               END IF
            IF (NUMPOL.EQ.1) THEN
               DO 35 IFNUM = 0, MUMIF - 1
                  IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                     GNREC(REKOL(1) + IFNUM) = FBLANK
                     GNREC(IMKOL(1) + IFNUM) = FBLANK
                     GNREC(DLKOL(1) + IFNUM) = FBLANK
                     GNREC(RAKOL(1) + IFNUM) = FBLANK
                     END IF
 35               CONTINUE
               END IF
            END IF
C                                       Record within specified
C                                       time range ?
         IF (KOLTYP(CLTIME).EQ.1) THEN
            GTIME = GNRECD(TIMKOL)
         ELSE
            GTIME = GNREC(TIMKOL)
            END IF
         IF ((GTIME.LT.TSTART) .OR. (GTIME.GT.TSTOP)) GO TO 100
C                                       Freq id
         IF ((GNRECI(FRQKOL).GT.0) .AND. (GNRECI(FRQKOL).NE.FRQSEL)
     *      .AND. (FRQSEL.GT.0)) GO TO 100
C                                       Subarray
         IF ((GNRECI(SUBKOL).GT.0) .AND. (SUBARR.GT.0) .AND.
     *      (GNRECI(SUBKOL).NE.SUBARR)) GO TO 100
C                                       Antenna?
         IANT = GNRECI(ANTKOL)
         IF (NANTSL.GT.0) THEN
            DO 50 I = 1,NANTSL
               IF ((IANT.EQ.ANTS(I)).AND.DOAWNT) GO TO 60
               IF ((IANT.EQ.ANTS(I)).AND.(.NOT.DOAWNT)) GO TO 100
 50            CONTINUE
            IF (DOAWNT) GO TO 100
            END IF
C                                       Check source
 60      IF (NID.GT.0) THEN
            ISOU = GNRECI(SOUKOL)
            DO 70 I = 1,NID
               IF (ISOU.EQ.SID(I)) GO TO 80
 70            CONTINUE
            GO TO 100
            END IF
C                                      Get start, stop times
 80      TBEG = MIN (TBEG, GTIME)
         TEND = MAX (TEND, GTIME)
C                                       Get value
         CALL SNPDAT (2, VALUE, XVARIB, CSOU, OKAY)
C                                       Max. - Min
         IF (((OKAY) .OR. (BSYM.GT.0)) .AND. (XVARIB.NE.FBLANK)) THEN
            IF (OKAY) NODATA = .FALSE.
            NANREC(IANT,2) = NANREC(IANT,2) + 1
            I = CSOU + 0.1
            IF ((I.GT.0) .AND. (I.LE.MXSCAN)) SCNT(I) = SCNT(I) + 1
            END IF
 100     CONTINUE
      IERR = MAX (0, IERR)
      FANREC(1,2) = 1
      DO 120 I = 2,MAXANT
         FANREC(I,2) = FANREC(I-1,2) + NANREC(I-1,2)
 120     CONTINUE
      IF (NWORDS.LT.FANREC(MAXANT,2)+NANREC(MAXANT,2)) THEN
         MSGTXT = 'SN MEMORY TOO SMALL'
         IERR = 10
         END IF
C                                       source number translation
      NP = NSTRAN
      DO 130 I = 1,MXSCAN
         IF ((SCNT(I).GT.0) .AND. (STRANS(I).EQ.0)) THEN
            NP = NP + 1
            STRANS(I) = NP
            END IF
 130     CONTINUE
C
 990  IF (IERR.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SNPCNT: ERROR =',I3,' FROM TABIO')
      END
      SUBROUTINE SYPGET (NV, DATPTS, IERR)
C-----------------------------------------------------------------------
C   SYPGET reads the SY table to find the the data for Psum or Psys
C   for all IFs and then to compute the desired plot variable and find
C   the max and min of the variable
C   Input:
C      NV       I      Number values per time (source, X, n*Y)
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      DATPTS   R(*)   Data to be plotted (NV, *)
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NV, IERR
      REAL      DATPTS(NV,*)
C
      LOGICAL   NODATA, OKAY
      INTEGER   I, NP, NN, IS, KK
      REAL      GTIME, XVARIB, CSOU, TEMP
      INCLUDE 'SYVSN.INC'
      REAL      VALUE(2*MAXIF)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      NODATA = .TRUE.
C                                       Loop thru data
      TINT = -1.0
      IF (INTKOL.LE.0) TINT = 10.0 / 86400.0
      NP = MUMPOL * MUMIF
      DO 100 ICLRNO = 1,NCLINR
         CALL TABIO ('READ', 0, ICLRNO, GNREC, CLBUFF, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
C                                       Solution interval
         IF (TINT.LE.0) TINT = GNREC(INTKOL)
C                                       no weight cutoff in SY table
C                                       Record within specified
C                                       time range ?
         IF (KOLTYP(CLTIME).EQ.1) THEN
            GTIME = GNRECD(TIMKOL)
         ELSE
            GTIME = GNREC(TIMKOL)
            END IF
         IF ((GTIME.LT.TSTART) .OR. (GTIME.GT.TSTOP)) GO TO 100
C                                       Freq id
         IF ((GNRECI(FRQKOL).GT.0) .AND. (GNRECI(FRQKOL).NE.FRQSEL)
     *      .AND. (FRQSEL.GT.0)) GO TO 100
C                                       Subarray
         IF ((GNRECI(SUBKOL).GT.0) .AND. (SUBARR.GT.0) .AND.
     *      (GNRECI(SUBKOL).NE.SUBARR)) GO TO 100
C                                       Antenna?
         IANT = GNRECI(ANTKOL)
         IF (NANTSL.GT.0) THEN
            DO 50 I = 1,NANTSL
               IF ((IANT.EQ.ANTS(I)).AND.DOAWNT) GO TO 60
               IF ((IANT.EQ.ANTS(I)).AND.(.NOT.DOAWNT)) GO TO 100
 50            CONTINUE
            IF (DOAWNT) GO TO 100
            END IF
C                                       Check source
 60      IF (NID.GT.0) THEN
            ISOU = GNRECI(SOUKOL)
            DO 70 I = 1,NID
               IF (ISOU.EQ.SID(I)) GO TO 80
 70            CONTINUE
            GO TO 100
            END IF
C                                      Get start, stop times
 80      TBEG = MIN (TBEG, GTIME)
         TEND = MAX (TEND, GTIME)
C                                       Get value
         CALL SNPDAT (1, VALUE, XVARIB, CSOU, OKAY)
C                                       Max. - Min
         IF (((OKAY) .OR. (BSYM.GT.0)) .AND. (XVARIB.NE.FBLANK)) THEN
            IF (OKAY) NODATA = .FALSE.
C                                       Put in array
            NUMPTS(IANT,1) = NUMPTS(IANT,1) + 1
            NN = FANREC(IANT,1) + NUMPTS(IANT,1) - 1
            IS = CSOU + 0.1
            IF ((IS.GT.0) .AND. (IS.LE.MXSCAN)) CSOU = STRANS(IS)
            DATPTS(1,NN) = CSOU
            DATPTS(2,NN) = XVARIB
            KK = 3
            CALL RCOPY (NP, VALUE, DATPTS(KK,NN))
            IF (XVAR.NE.6) THEN
               XMX = MAX (XMX, XVARIB)
               XMN = MIN (XMN, XVARIB)
            ELSE
               TEMP = XVARIB
               IF (TEMP.LT.0.0) TEMP = TEMP + 360.
               XMX = MAX (XMX, TEMP)
               XMN = MIN (XMN, TEMP)
               IF (TEMP.GT.180.0) TEMP = TEMP - 360
               XMXW = MAX (XMXW, TEMP)
               XMNW = MIN (XMNW, TEMP)
               END IF
            XXMAX(IANT) = MAX (XXMAX(IANT), XVARIB)
            XXMIN(IANT) = MIN (XXMIN(IANT), XVARIB)
            CSMIN = MIN (CSMIN, CSOU)
            CSMAX = MAX (CSMAX, CSOU)
            END IF
 100     CONTINUE
C                                       Check for no data
      IF (NODATA) THEN
         IERR = 6
         MSGTXT = 'SYPGET: NO DATA SELECTED'
         GO TO 990
         END IF
      IERR = MAX (0, IERR)
      CALL TABIO ('CLOS', 0, ICLRNO, GNREC, CLBUFF, I)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SYPGET: ERROR =',I3,' FROM TABIO')
      END
      SUBROUTINE SNPGET (NV, DATPTS, IERR)
C-----------------------------------------------------------------------
C   SNPMAX reads the SN or CL table to fill the data array
C   Input:
C      NV       I      Number values per time (source, X, n*Y)
C   Input/Output in common:
C      TSTART   R      Start time of plot
C      TSTOP    R      Stop time of plot
C   Output:
C      DATPTS   R(*)   Data to be plotted (NV, *)
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NV, IERR
      REAL      DATPTS(NV,*)
C
      LOGICAL   NODATA, OKAY
      INTEGER   I, NP, NN, IS, KK, IFNUM
      REAL      GTIME, XVARIB, CSOU, TEMP, TMAX, TMIN
      INCLUDE 'SYVSN.INC'
      REAL      VALUE(2*MAXIF)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      NODATA = .TRUE.
C                                       Loop thru data
      TINT = -1.0
      IF (INTKOL.LE.0) TINT = 10.0 / 86400.0
      NP = MUMPOL * MUMIF
      DO 100 ICLRNO = 1,NCLINR
         CALL TABIO ('READ', 0, ICLRNO, GNREC, CLBUFF, IERR)
         IF (IERR.LT.0) GO TO 100
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
C                                       Solution interval
         IF (TINT.LE.0) TINT = GNREC(INTKOL)
C                                       Check weight per IF
C                                       If weight < CUTOFF them
C                                       set amp, phase, delay and
C                                       rate to FBLANK FOR EACH IF
         IF ((CUTOFF.GE.0.0) .AND. (WT1KOL.GT.0)) THEN
            IF (NUMPOL.EQ.2) THEN
               IF (SUMSTK.EQ.0) THEN
                  DO 5 IFNUM = 0, MUMIF - 1
                    IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(1) + IFNUM) = FBLANK
                       GNREC(IMKOL(1) + IFNUM) = FBLANK
                       GNREC(DLKOL(1) + IFNUM) = FBLANK
                       GNREC(RAKOL(1) + IFNUM) = FBLANK
                       END IF
                    IF (GNREC(WTKOL(2) + IFNUM).LE.CUTOFF) THEN
                       GNREC(REKOL(2) + IFNUM) = FBLANK
                       GNREC(IMKOL(2) + IFNUM) = FBLANK
                       GNREC(DLKOL(2) + IFNUM) = FBLANK
                       GNREC(RAKOL(2) + IFNUM) = FBLANK
                       END IF
 5                CONTINUE
               ELSE IF (SUMSTK.EQ.1) THEN
                  DO 15 IFNUM = 0, MUMIF - 1
                     IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                        GNREC(REKOL(1) + IFNUM) = FBLANK
                        GNREC(IMKOL(1) + IFNUM) = FBLANK
                        GNREC(DLKOL(1) + IFNUM) = FBLANK
                        GNREC(RAKOL(1) + IFNUM) = FBLANK
                        END IF
 15                  CONTINUE
               ELSE IF (SUMSTK.EQ.2) THEN
                  DO 25 IFNUM = 0, MUMIF - 1
                     IF (GNREC(WTKOL(2) + IFNUM).LE.CUTOFF) THEN
                        GNREC(REKOL(2) + IFNUM) = FBLANK
                        GNREC(IMKOL(2) + IFNUM) = FBLANK
                        GNREC(DLKOL(2) + IFNUM) = FBLANK
                        GNREC(RAKOL(2) + IFNUM) = FBLANK
                        END IF
 25                  CONTINUE
                  END IF
               END IF
            IF (NUMPOL.EQ.1) THEN
               DO 35 IFNUM = 0, MUMIF - 1
                  IF (GNREC(WTKOL(1) + IFNUM).LE.CUTOFF) THEN
                     GNREC(REKOL(1) + IFNUM) = FBLANK
                     GNREC(IMKOL(1) + IFNUM) = FBLANK
                     GNREC(DLKOL(1) + IFNUM) = FBLANK
                     GNREC(RAKOL(1) + IFNUM) = FBLANK
                     END IF
 35               CONTINUE
               END IF
            END IF
C                                       Record within specified
C                                       time range ?
         IF (KOLTYP(CLTIME).EQ.1) THEN
            GTIME = GNRECD(TIMKOL)
         ELSE
            GTIME = GNREC(TIMKOL)
            END IF
         IF ((GTIME.LT.TSTART) .OR. (GTIME.GT.TSTOP)) GO TO 100
C                                       Freq id
         IF ((GNRECI(FRQKOL).GT.0) .AND. (GNRECI(FRQKOL).NE.FRQSEL)
     *      .AND. (FRQSEL.GT.0)) GO TO 100
C                                       Subarray
         IF ((GNRECI(SUBKOL).GT.0) .AND. (SUBARR.GT.0) .AND.
     *      (GNRECI(SUBKOL).NE.SUBARR)) GO TO 100
C                                       Antenna?
         IANT = GNRECI(ANTKOL)
         IF (NANTSL.GT.0) THEN
            DO 50 I = 1,NANTSL
               IF ((IANT.EQ.ANTS(I)).AND.DOAWNT) GO TO 60
               IF ((IANT.EQ.ANTS(I)).AND.(.NOT.DOAWNT)) GO TO 100
 50            CONTINUE
            IF (DOAWNT) GO TO 100
            END IF
C                                       Check source
 60      IF (NID.GT.0) THEN
            ISOU = GNRECI(SOUKOL)
            DO 70 I = 1,NID
               IF (ISOU.EQ.SID(I)) GO TO 80
 70            CONTINUE
            GO TO 100
            END IF
C                                      Get start, stop times
 80      TBEG = MIN (TBEG, GTIME)
         TEND = MAX (TEND, GTIME)
C                                       Get value
         CALL SNPDAT (2, VALUE, XVARIB, CSOU, OKAY)
C                                       Max. - Min
         IF (((OKAY) .OR. (BSYM.GT.0)) .AND. (XVARIB.NE.FBLANK)) THEN
            IF (OKAY) NODATA = .FALSE.
C                                       Put in array
            NUMPTS(IANT,2) = NUMPTS(IANT,2) + 1
            NN = FANREC(IANT,2) + NUMPTS(IANT,2) - 1
            IS = CSOU + 0.1
            IF ((IS.GT.0) .AND. (IS.LE.MXSCAN)) CSOU = STRANS(IS)
            DATPTS(1,NN) = CSOU
            DATPTS(2,NN) = XVARIB
            KK = 3
            CALL RCOPY (NP, VALUE, DATPTS(KK,NN))
            IF (XVAR.NE.6) THEN
               XMX = MAX (XMX, XVARIB)
               XMN = MIN (XMN, XVARIB)
            ELSE
               TEMP = XVARIB
               IF (TEMP.LT.0.0) TEMP = TEMP + 360.
               XMX = MAX (XMX, TEMP)
               XMN = MIN (XMN, TEMP)
               IF (TEMP.GT.180.0) TEMP = TEMP - 360
               XMXW = MAX (XMXW, TEMP)
               XMNW = MIN (XMNW, TEMP)
               END IF
            XXMAX(IANT) = MAX (XXMAX(IANT), XVARIB)
            XXMIN(IANT) = MIN (XXMIN(IANT), XVARIB)
            CSMIN = MIN (CSMIN, CSOU)
            CSMAX = MAX (CSMAX, CSOU)
            END IF
 100     CONTINUE
      IERR = MAX (0, IERR)
C                                       Set actual X range
      SWAP = .FALSE.
      IF (XVAR.EQ.1) THEN
         XSTART = TBEG
         XSTOP = TEND
      ELSE IF (XVAR.EQ.6) THEN
         IF (XMX-XMN.LE.XMXW-XMNW) THEN
            XSTART = XMN
            XSTOP  = XMX
         ELSE
            XSTART = XMNW
            XSTOP  = XMXW
            SWAP = .TRUE.
            END IF
      ELSE
         XSTART = XMN
         XSTOP  = XMX
         END IF
C                                       Check for no data
      IF (NODATA) THEN
         IERR = 6
         MSGTXT = 'SNPGET: NO DATA SELECTED'
         GO TO 990
         END IF
C                                       check and set scaling
      IF ((XVAR.EQ.1) .AND. (TSTART.GT.0.0) .AND. (TSTOP.LT.999.0)) THEN
         TMAX = (XSTOP + 0.03 * (XSTOP - XSTART)) * 360.0
         TMIN = (XSTART- 0.03 * (XSTOP - XSTART)) * 360.0
      ELSE IF ((XVAR.EQ.1) .OR. (XVAR.EQ.3) .OR. (XVAR.EQ.4)) THEN
         TMAX = (XSTOP + 0.1 * (XSTOP - XSTART)) * 360.0
         TMIN = (XSTART- 0.1 * (XSTOP - XSTART)) * 360.0
      ELSE
         TMAX = (XSTOP + 0.1 * (XSTOP - XSTART))
         TMIN = (XSTART- 0.1 * (XSTOP - XSTART))
         END IF
C                                       If start time is stop time,
      IF (ABS (TMAX-TMIN) .LT. 0.01) THEN
         TMIN = MAX( TMIN-0.005, 0.0)
         TMAX = TMIN + 0.01
         END IF
      TSTART = TBEG
      TSTOP = TEND
      XYOFF(1,1) = TMIN
      XYSCL(1,1) = 1000.0 / (TMAX - TMIN)
      XYOFF(1,2) = TMIN
      XYSCL(1,2) = 1000.0 / (TMAX - TMIN)
      PRAN(1,1,1) = TMIN
      PRAN(2,1,1) = TMAX
      PRAN(1,1,2) = TMIN
      PRAN(2,1,2) = TMAX
C                                       Send back time range
      XTIME(1) = TSTART
      XTIME(2) = 0.0
      XTIME(3) = 0.0
      XTIME(4) = 0.0
      XTIME(5) = TSTOP
      XTIME(6) = 0.0
      XTIME(7) = 0.0
      XTIME(8) = 0.0
      CALL TABIO ('CLOS', 0, ICLRNO, GNREC, CLBUFF, I)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SNPGET: ERROR =',I3,' FROM TABIO')
      END
      SUBROUTINE SYPREF (NV, DATPTS, IERR)
C-----------------------------------------------------------------------
C   SYPREF re-references the Psum/Psys in DATPTS
C   Input:
C      NV       I      Number values per time (source, X, n*Y)
C   In/Output:
C      DATPTS   R(*)   Data to be plotted (NV, *)
C   Outputs
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NV, IERR
      REAL      DATPTS(NV,*)
C
      INTEGER   JANT, IA, IR, NREC, NMISS, NP, IREC, RREC, JREC, IIF,
     *   IIS, IP
      REAL      EPS, PH
      INCLUDE 'SYVSN.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA EPS /1.E-6/
C-----------------------------------------------------------------------
      NP = MUMPOL * MUMIF
C                                       loop over all antennas except
      RREC = NUMPTS(REFANT,1)
      DO 50 JANT = 1,MUMANT
         NMISS = 0
         IF (JANT.EQ.REFANT) GO TO 50
         IA = FANREC(JANT,1) - 1
         NREC = NUMPTS(JANT,1)
         DO 40 IREC = 1,NREC
            IA = IA + 1
C                                       seek a match
            IR = FANREC(REFANT,1) - 1
            DO 10 JREC = 1,RREC
               IR = IR + 1
               IF ((DATPTS(1,IR).EQ.DATPTS(1,IA)) .AND.
     *            (ABS(DATPTS(2,IR)-DATPTS(2,IA)).LE.EPS)) GO TO 15
 10            CONTINUE
C                                       not match
            NMISS = NMISS + 1
            CALL RFILL (NP, FBLANK, DATPTS(3,IA))
            GO TO 40
C                                       close enough
 15         IP = 2
            DO 30 IIF = 1,MUMIF
               DO 20 IIS = 1,MUMPOL
                  IP = IP + 1
                  IF ((DATPTS(IP,IR).EQ.FBLANK) .OR.
     *               (DATPTS(IP,IA).EQ.FBLANK)) THEN
                     DATPTS(IP,IA) = FBLANK
C                                       Psum, Psys
                  ELSE
                     PH = DATPTS(IP,IA) - DATPTS(IP,IR)
                     DATPTS(IP,IA) = PH
                     END IF
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
         IF (NMISS.GT.0) THEN
            WRITE (MSGTXT,1090) NMISS, NREC, JANT
            CALL MSGWRT (7)
            END IF
 50      CONTINUE
C                                       zero out refant
      IR = FANREC(REFANT,1) - 1
      NREC = NUMPTS(REFANT,1)
      JANT = REFANT
      DO 80 IREC = 1,NREC
         IR = IR + 1
         IP = 2
         DO 70 IIF = 1,MUMIF
            DO 60 IIS = 1,MUMPOL
               IP = IP + 1
               IF (DATPTS(IP,IR).NE.FBLANK) THEN
                  DATPTS(IP,IR) = 0.0
                  END IF
 60            CONTINUE
 70         CONTINUE
 80      CONTINUE
C
      IERR = 0
 999  RETURN
C-----------------------------------------------------------------------
 1090 FORMAT ('SYPREF: Points misaligned',I6,' of',I7,' antenna',I4)
      END
      SUBROUTINE SNPREF (NV, DATPTS, IERR)
C-----------------------------------------------------------------------
C   SNPMAX re-references the phases in DATPTS and recomputes min/max
C   Input:
C      NV       I      Number values per time (source, X, n*Y)
C   In/Output:
C      DATPTS   R(*)   Data to be plotted (NV, *)
C   Outputs
C      IERR     I      Error code, 0=OK else failed
C   Outputs in common:
C-----------------------------------------------------------------------
      INTEGER   NV, IERR
      REAL      DATPTS(NV,*)
C
      INTEGER   JANT, IA, IR, NREC, NMISS, NP, IP, IIF, IIS, IREC,
     *   RREC, JREC
      REAL      EPS, PH
      INCLUDE 'SYVSN.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA EPS /1.E-6/
C-----------------------------------------------------------------------
      NP = MUMPOL * MUMIF
C                                       loop over all antennas except
      RREC = NUMPTS(REFANT,2)
      DO 50 JANT = 1,MUMANT
         NMISS = 0
         IF (JANT.EQ.REFANT) GO TO 50
         IA = FANREC(JANT,2) - 1
         NREC = NUMPTS(JANT,2)
         DO 40 IREC = 1,NREC
            IA = IA + 1
C                                       seek a match
            IR = FANREC(REFANT,2) - 1
            DO 10 JREC = 1,RREC
               IR = IR + 1
               IF ((DATPTS(1,IR).EQ.DATPTS(1,IA)) .AND.
     *            (ABS(DATPTS(2,IR)-DATPTS(2,IA)).LE.EPS)) GO TO 15
 10            CONTINUE
C                                       not match
            NMISS = NMISS + 1
            CALL RFILL (NP, FBLANK, DATPTS(3,IA))
            GO TO 40
C                                       close enough
 15         IP = 2
            DO 30 IIF = 1,MUMIF
               DO 20 IIS = 1,MUMPOL
                  IP = IP + 1
                  IF ((DATPTS(IP,IR).EQ.FBLANK) .OR.
     *               (DATPTS(IP,IA).EQ.FBLANK)) THEN
                     DATPTS(IP,IA) = FBLANK
C                                       phase
                  ELSE IF (ICODES(2).EQ.4) THEN
                     PH = DATPTS(IP,IA) - DATPTS(IP,IR)
                     IF (PH.LT.-180.0) PH = PH + 360.0
                     IF (PH.GT.180.0) PH = PH - 360.0
                     DATPTS(IP,IA) = PH
C                                       delay, amp
                  ELSE
                     PH = DATPTS(IP,IA) - DATPTS(IP,IR)
                     DATPTS(IP,IA) = PH
                     END IF
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
         IF (NMISS.GT.0) THEN
            WRITE (MSGTXT,1090) NMISS, NREC, JANT
            CALL MSGWRT (7)
            END IF
 50      CONTINUE
C                                       zero out refant
      IR = FANREC(REFANT,2) - 1
      NREC = NUMPTS(REFANT,2)
      JANT = REFANT
      DO 80 IREC = 1,NREC
         IR = IR + 1
         IP = 2
         DO 70 IIF = 1,MUMIF
            DO 60 IIS = 1,MUMPOL
               IP = IP + 1
               IF (DATPTS(IP,IR).NE.FBLANK) THEN
                  DATPTS(IP,IR) = 0.0
                  END IF
 60            CONTINUE
 70         CONTINUE
 80      CONTINUE
C
      IERR = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1090 FORMAT ('SNPREF: Points misaligned',I6,' of',I7,' antenna',I4)
      END
      SUBROUTINE SYPMAX (KK, MV, FACT, DATPTS, NV, SYDAT)
C-----------------------------------------------------------------------
C   SYPMAX converts the full IF data into the desired form and then
C   finds the extrema
C   Inputs
C      KK       I         1 -> Psum, Psys, 2 -> delay
C      MV       I         Number points in DATPTS per sample
C      FACT     R         scale factor (APARM(7) or BPARM(7))
C      DATPTS   R(MV,*)   Full SY data
c      NV       I         Number of points in SYDAT per sample
C   Outputs:
C      SYDAT    R(NV,*)   SY data for plotting
C-----------------------------------------------------------------------
      INTEGER   KK, MV, NV
      REAL      FACT, DATPTS(MV,*), SYDAT(NV,*)
C
      INCLUDE 'SYVSN.INC'
      INTEGER   IA, IREC, NREC, JANT, IIF, IP, NSR, NSL, NBR, NBL
      REAL      VSR, VSL, VBR, VBL
      LOGICAL   NOBASE
      INCLUDE 'INS:DDCH.INC'
C-----------------------------------------------------------------------
      NOBASE = EIFS(2,KK).LT.BIFS(2,KK)
      DO 100 JANT = 1,MUMANT
         IA = FANREC(JANT,KK) - 1
         NREC = NUMPTS(JANT,KK)
         DO 90 IREC = 1,NREC
            IA = IA + 1
            NSR = 0
            NSL = 0
            VSR = 0.0
            VSL = 0.0
            NBR = 0
            NBL = 0
            VBR = 0.0
            VBL = 0.0
            SYDAT(1,IA) = DATPTS(1,IA)
            SYDAT(2,IA) = DATPTS(2,IA)
            IP = 2
            DO 50 IIF = BIF,MUMIF+BIF
               IP = IP + 1
               IF (DATPTS(IP,IA).NE.FBLANK) THEN
                  IF ((IIF.GE.BIFS(1,KK)) .AND. (IIF.LE.EIFS(1,KK)))
     *               THEN
                     NSR = NSR + 1
                     VSR = VSR + DATPTS(IP,IA)
                     END IF
                  IF ((IIF.GE.BIFS(2,KK)) .AND. (IIF.LE.EIFS(2,KK)))
     *               THEN
                     NBR = NBR + 1
                     VBR = VBR + DATPTS(IP,IA)
                     END IF
                  IF ((IIF.GE.BIFS(3,KK)) .AND. (IIF.LE.EIFS(3,KK)))
     *               THEN
                     NBR = NBR + 1
                     VBR = VBR + DATPTS(IP,IA)
                     END IF
                  END IF
               IF (MUMPOL.EQ.2) THEN
                  IP = IP + 1
                  IF (DATPTS(IP,IA).NE.FBLANK) THEN
                     IF ((IIF.GE.BIFS(1,KK)) .AND. (IIF.LE.EIFS(1,KK)))
     *                  THEN
                        NSL = NSL + 1
                        VSL = VSL + DATPTS(IP,IA)
                        END IF
                     IF ((IIF.GE.BIFS(2,KK)) .AND. (IIF.LE.EIFS(2,KK)))
     *                  THEN
                        NBL = NBL + 1
                        VBL = VBL + DATPTS(IP,IA)
                        END IF
                     IF ((IIF.GE.BIFS(3,KK)) .AND. (IIF.LE.EIFS(3,KK)))
     *                  THEN
                        NBL = NBL + 1
                        VBL = VBL + DATPTS(IP,IA)
                        END IF
                     END IF
                  END IF
 50            CONTINUE
C                                       output values
            IF (NSR.LE.0) THEN
               SYDAT(3,IA) = FBLANK
            ELSE IF (NOBASE) THEN
               SYDAT(3,IA) = VSR / NSR * FACT
            ELSE IF (NBR.LE.0) THEN
               SYDAT(3,IA) = FBLANK
            ELSE
               VSR = VSR / NSR
               VBR = VBR / NBR
               SYDAT(3,IA) = FACT * (VSR - VBR)
               IF (ABS(APARM(8)-1.0).LT.0.1) THEN
                  IF (VBR.EQ.0.0) THEN
                     SYDAT(3,IA) = FBLANK
                  ELSE
                     SYDAT(3,IA) = SYDAT(3,IA) / VBR
                     END IF
                  END IF
               END IF
            IF (SYDAT(3,IA).NE.FBLANK) THEN
               YYMIN(1,JANT,KK) = MIN (SYDAT(3,IA), YYMIN(1,JANT,KK))
               YYMAX(1,JANT,KK) = MAX (SYDAT(3,IA), YYMAX(1,JANT,KK))
               YYMN(1,KK) = MIN (SYDAT(3,IA), YYMN(1,KK))
               YYMX(1,KK) = MAX (SYDAT(3,IA), YYMX(1,KK))
               END IF
            IF (MUMPOL.EQ.2) THEN
               IF (NSL.LE.0) THEN
                  SYDAT(4,IA) = FBLANK
               ELSE IF (NOBASE) THEN
                  SYDAT(4,IA) = VSL / NSL * FACT
               ELSE IF (NBL.LE.0) THEN
                  SYDAT(4,IA) = FBLANK
               ELSE
                  VSL = VSL / NSL
                  VBL = VBL / NBL
                  SYDAT(4,IA) = FACT * (VSL - VBL)
                  IF (ABS(APARM(8)-1.0).LT.0.1) THEN
                     IF (VBL.EQ.0.0) THEN
                        SYDAT(4,IA) = FBLANK
                     ELSE
                        SYDAT(4,IA) = SYDAT(4,IA) / VBL
                        END IF
                     END IF
                  END IF
               IF (SYDAT(4,IA).NE.FBLANK) THEN
                  YYMIN(2,JANT,KK) = MIN (SYDAT(4,IA), YYMIN(2,JANT,KK))
                  YYMAX(2,JANT,KK) = MAX (SYDAT(4,IA), YYMAX(2,JANT,KK))
                  YYMN(2,KK) = MIN (SYDAT(4,IA), YYMN(2,KK))
                  YYMX(2,KK) = MAX (SYDAT(4,IA), YYMX(2,KK))
                  END IF
               END IF
 90         CONTINUE
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SNPMAX (MV, DATPTS, NV, SNDAT)
C-----------------------------------------------------------------------
C   SNPMAX converts the full IF data into the desired form and then
C   finds the extrema - for phases
C   Inputs
C      MV       I         Number points in DATPTS per sample
C      DATPTS   R(MV,*)   Full SY data
c      NV       I         Number of points in SNDAT per sample
C   Outputs:
C      SNDAT    R(NV,*)   SY data for plotting
C-----------------------------------------------------------------------
      INTEGER   MV, NV
      REAL      DATPTS(MV,*), SNDAT(NV,*)
C
      INCLUDE 'SYVSN.INC'
      INTEGER   KK, IA, IREC, NREC, JANT, IIF, IP, NSR, NSL, NBR, NBL
      REAL      SVSR, SVSL, SVBR, SVBL, CVSR, CVSL, CVBR, CVBL, CPH,
     *   SPH, RDUM(8)
      LOGICAL   NOBASE
      EQUIVALENCE (RDUM, SVSR)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      COMMON /LOCAL/ SVSR, SVSL, SVBR, SVBL, CVSR, CVSL, CVBR, CVBL
C-----------------------------------------------------------------------
      KK = 2
      NOBASE = EIFS(2,KK).LT.BIFS(2,KK)
      DO 100 JANT = 1,MUMANT
         IA = FANREC(JANT,KK) - 1
         NREC = NUMPTS(JANT,KK)
         DO 90 IREC = 1,NREC
            IA = IA + 1
            NSR = 0
            NSL = 0
            CALL RFILL (8, 0.0, RDUM)
            NBR = 0
            NBL = 0
            SNDAT(1,IA) = DATPTS(1,IA)
            SNDAT(2,IA) = DATPTS(2,IA)
            IP = 2
            DO 50 IIF = BIF,MUMIF+BIF
               IP = IP + 1
               IF (DATPTS(IP,IA).NE.FBLANK) THEN
                  CPH = COS (DATPTS(IP,IA) * DG2RAD)
                  SPH = SIN (DATPTS(IP,IA) * DG2RAD)
                  IF ((IIF.GE.BIFS(1,KK)) .AND. (IIF.LE.EIFS(1,KK)))
     *               THEN
                     NSR = NSR + 1
                     SVSR = SVSR + SPH
                     CVSR = CVSR + CPH
                     END IF
                  IF ((IIF.GE.BIFS(2,KK)) .AND. (IIF.LE.EIFS(2,KK)))
     *               THEN
                     NBR = NBR + 1
                     SVBR = SVBR + SPH
                     CVBR = CVBR + CPH
                     END IF
                  IF ((IIF.GE.BIFS(3,KK)) .AND. (IIF.LE.EIFS(3,KK)))
     *               THEN
                     NBR = NBR + 1
                     SVBR = SVBR + SPH
                     CVBR = CVBR + CPH
                     END IF
                  END IF
               IF (MUMPOL.EQ.2) THEN
                  IP = IP + 1
                  IF (DATPTS(IP,IA).NE.FBLANK) THEN
                     CPH = COS (DATPTS(IP,IA) * DG2RAD)
                     SPH = SIN (DATPTS(IP,IA) * DG2RAD)
                     IF ((IIF.GE.BIFS(1,KK)) .AND. (IIF.LE.EIFS(1,KK)))
     *                  THEN
                        NSL = NSL + 1
                        SVSL = SVSL + SPH
                        CVSL = CVSL + CPH
                        END IF
                     IF ((IIF.GE.BIFS(2,KK)) .AND. (IIF.LE.EIFS(2,KK)))
     *                  THEN
                        NBL = NBL + 1
                        SVBL = SVBL + SPH
                        CVBL = CVBL + CPH
                        END IF
                     IF ((IIF.GE.BIFS(3,KK)) .AND. (IIF.LE.EIFS(3,KK)))
     *                  THEN
                        NBL = NBL + 1
                        SVBL = SVBL + SPH
                        CVBL = CVBL + CPH
                        END IF
                     END IF
                  END IF
 50            CONTINUE
C                                       output values
            IF (NSR.LE.0) THEN
               SNDAT(3,IA) = FBLANK
            ELSE IF (NOBASE) THEN
               SNDAT(3,IA) = RAD2DG * ATAN2 (SVSR, CVSR)  * BPARM(7)
            ELSE IF (NBR.LE.0) THEN
               SNDAT(3,IA) = FBLANK
            ELSE
               SVSR = RAD2DG * ATAN2 (SVSR, CVSR)
               SVBR = RAD2DG * ATAN2 (SVBR, CVBR)
               SVSR = SVSR - SVBR
               IF (SVSR.LT.-180.0) SVSR = SVSR + 360.0
               IF (SVSR.GT.180.0) SVSR = SVSR - 360.0
               SNDAT(3,IA) = BPARM(7) * SVSR
               END IF
            IF (SNDAT(3,IA).NE.FBLANK) THEN
               YYMIN(1,JANT,KK) = MIN (SNDAT(3,IA), YYMIN(1,JANT,KK))
               YYMAX(1,JANT,KK) = MAX (SNDAT(3,IA), YYMAX(1,JANT,KK))
               YYMN(1,KK) = MIN (SNDAT(3,IA), YYMN(1,KK))
               YYMX(1,KK) = MAX (SNDAT(3,IA), YYMX(1,KK))
               SPH = SNDAT(3,IA)
               IF (SPH.LT.0.0) SPH = SPH + 360.0 * ABS (BPARM(7))
               PPMIN(1,JANT) = MIN (SPH, PPMIN(1,JANT))
               PPMAX(1,JANT) = MAX (SPH, PPMAX(1,JANT))
               END IF
            IF (MUMPOL.EQ.2) THEN
               IF (NSL.LE.0) THEN
                  SNDAT(4,IA) = FBLANK
               ELSE IF (NOBASE) THEN
                  SNDAT(4,IA) = RAD2DG * ATAN2 (SVSL, CVSL)  * BPARM(7)
               ELSE IF (NBL.LE.0) THEN
                  SNDAT(4,IA) = FBLANK
               ELSE
                  SVSL = RAD2DG * ATAN2 (SVSL, CVSL)
                  SVBL = RAD2DG * ATAN2 (SVBL, CVBL)
                  SVSL = SVSL - SVBL
                  IF (SVSL.LT.-180.0) SVSL = SVSL + 360.0
                  IF (SVSL.GT.180.0) SVSL = SVSL - 360.0
                  SNDAT(4,IA) = BPARM(7) * SVSL
                  END IF
               IF (SNDAT(4,IA).NE.FBLANK) THEN
                  YYMIN(2,JANT,KK) = MIN (SNDAT(4,IA), YYMIN(2,JANT,KK))
                  YYMAX(2,JANT,KK) = MAX (SNDAT(4,IA), YYMAX(2,JANT,KK))
                  YYMN(2,KK) = MIN (SNDAT(4,IA), YYMN(2,KK))
                  YYMX(2,KK) = MAX (SNDAT(4,IA), YYMX(2,KK))
                  SPH = SNDAT(4,IA)
                  IF (SPH.LT.0.0) SPH = SPH + 360.0 * ABS (BPARM(7))
                  PPMIN(2,JANT) = MIN (SPH, PPMIN(2,JANT))
                  PPMAX(2,JANT) = MAX (SPH, PPMAX(2,JANT))
                  END IF
               END IF
 90         CONTINUE
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE GETSCL (KK, LST1, LST2, LANT, DOIT)
C-----------------------------------------------------------------------
C   GETSCL converts a number of max/min's to a scale
C   Inputs:
C      KK      I   parameter number
C      LST1    I   1st Stokes
C      LST2    I   Upper Stokes
C      LANT    I   Antenna number
C   Output:
C      DOIT    L      There were valid values
C   Output in common
C      XYSCL   R(2)   Scaling - only 2nd one changed
C      XYOFF   R(2)   Offset  - only second one changed
C-----------------------------------------------------------------------
      INTEGER   KK, LST1, LST2, LANT
      LOGICAL   DOIT
C
      INCLUDE 'SYVSN.INC'
      INTEGER   IST
      REAL      YMX, YMN, PMX, PMN, TMAX, TMIN, TDIF, TOLER(8), SIZEY
C                                       Minimum value range for each
C                                       ICODE
C                  Psum  Psys  Pdif   Phs    Delay    Amp     Tsys
      DATA TOLER /0.001, 0.01, 0.001, 0.001, 1.0E-12, 0.001, 0.001,
C        Tant
     *   0.000001/
C-----------------------------------------------------------------------
      DOIT = .FALSE.
      YMX = -1.E8
      YMN = -YMX
      PMX = YMX
      PMN = YMN
      DO 20 IST = LST1,LST2
         IF (YYMAX(IST,LANT,KK).GE.YYMIN(IST,LANT,KK)) THEN
            DOIT = .TRUE.
            YMX = MAX (YMX, YYMAX(IST,LANT,KK))
            YMN = MIN (YMN, YYMIN(IST,LANT,KK))
            IF (ICODES(KK).EQ.4) THEN
               PMX = MAX (PMX, PPMAX(IST,LANT))
               PMN = MIN (PMN, PPMIN(IST,LANT))
               END IF
            END IF
 20      CONTINUE
      IF ((ICODES(KK).EQ.4) .AND. (PMX-PMN.LT.YMX-YMN)) THEN
         YMX = PMX
         YMN = PMN
         END IF
      IF ((KK.EQ.1) .AND. (PIXR(2).GT.PIXR(1))) THEN
         YMX = PIXR(2)
         YMN = PIXR(1)
         END IF
      SIZEY = 1000.0 / NCOUNT
      TMAX = YMX + 0.1 * (YMX - YMN)
      TMIN = YMN - 0.1 * (YMX - YMN)
      IF (ABS (TMAX-TMIN) .LT. TOLER(ICODES(KK))) THEN
         TMAX = TMAX + TOLER(ICODES(KK))
         TMIN = TMIN - TOLER(ICODES(KK))
         END IF
      TDIF = TMAX - TMIN
      IF (ABS (TDIF).LE.1.0E-25) TDIF = 1.0E-25
      XYOFF(2,KK) = TMIN
      XYSCL(2,KK) = 1000.0 / TDIF / NCOUNT
      PRAN(1,2,KK) = TMIN
      PRAN(2,2,KK) = TMAX
C
 999  RETURN
      END
      SUBROUTINE SNPDAT (KK, VALUE, XVARIB, CSOU, OKAY)
C-----------------------------------------------------------------------
C   Routine to get the specified value from a SN/CL/TY table entry
C   Input from common:
C      GNREC    R(*)  Table record
C      ICODE    I     Plot code
C      SUMSTK   I     Selected Stokes 0=both, 1=R, 2=L
C   Also uses pointers etc. set in SNPOPN
C   Output:
C      VALUE    R(*)   Table value, magic value blanked (amp on ICODE 6)
C      XVARIB   R      Value of associated x-axis variable
C      CSOU     R      source number
C      OKAY     L      Some values are good
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   KK
      REAL      VALUE(2*MAXIF), XVARIB, CSOU
      LOGICAL   OKAY
C
      INTEGER   IIS, IIF, IP1, IP2, LP, JP1, JP2, ICODE
      REAL      V, TC
      LOGICAL   T
      INCLUDE 'SYVSN.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       In case the data is bad
      LP = MUMPOL * MUMIF
      CALL XCALC (XVARIB, CSOU)
      ICODE = ICODES(KK)
      CALL RFILL (LP, FBLANK, VALUE)
C                                       Select data type
C                                       Phase (deg)
      IF (ICODE.EQ.4) THEN
         DO 110 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = REKOL(IIS) - NTONE
            JP1 = IMKOL(IIS) - NTONE
            IP2 = REKOL(2) - NTONE
            JP2 = IMKOL(2) - NTONE
            DO 105 IIF = 1,MUMIF
               IP1 = IP1 + NTONE
               JP1 = JP1 + NTONE
               IP2 =  IP2 + NTONE
               JP2 = JP2 + NTONE
               LP = LP + MUMPOL
               IF ((GNREC(IP1).NE.FBLANK) .AND.
     *            (GNREC(JP1).NE.FBLANK)) THEN
                  VALUE(LP) = 57.296 *
     *               ATAN2 (GNREC(JP1), GNREC(IP1) + 1.0E-20)
                  END IF
 105           CONTINUE
 110        CONTINUE
C                                       Delay (sec)
      ELSE IF (ICODE.EQ.5) THEN
         DO 150 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = DLKOL(IIS) - 1
            IP2 = DLKOL(2) - 1
            DO 145 IIF = 1,MUMIF
               IP1 = IP1 + 1
               IP2 =  IP2 + 1
               LP = LP + MUMPOL
               IF (GNREC(IP1).NE.FBLANK) THEN
                  VALUE(LP) = GNREC(IP1)
                  END IF
 145           CONTINUE
 150        CONTINUE
C                                       Amplitude
      ELSE IF (ICODE.EQ.6) THEN
         DO 130 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = REKOL(IIS) - NTONE
            JP1 = IMKOL(IIS) - NTONE
            IP2 = REKOL(2) - NTONE
            JP2 = IMKOL(2) - NTONE
            DO 125 IIF = 1,MUMIF
               IP1 = IP1 + NTONE
               JP1 = JP1 + NTONE
               IP2 =  IP2 + NTONE
               JP2 = JP2 + NTONE
               LP = LP + MUMPOL
               IF ((GNREC(IP1).NE.FBLANK) .AND.
     *            (GNREC(JP1).NE.FBLANK)) THEN
                  VALUE(LP) = SQRT ((GNREC(IP1)**2) + (GNREC(JP1)**2)) *
     *               GMMOD
                  END IF
 125           CONTINUE
 130        CONTINUE
C                                       Pdif
      ELSE IF (ICODE.EQ.3) THEN
         DO 420 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = REKOL(IIS) - NTONE
            IP2 = REKOL(2) - NTONE
            DO 415 IIF = 1,MUMIF
               IP1 = IP1 + NTONE
               IP2 = IP2 + NTONE
               LP = LP + MUMPOL
               IF (GNREC(IP1).NE.FBLANK) VALUE(LP) = GNREC(IP1)
 415           CONTINUE
 420        CONTINUE
C                                       Psum
      ELSE IF (ICODE.EQ.2) THEN
         DO 430 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = IMKOL(IIS) - NTONE
            IP2 = IMKOL(2) - NTONE
            DO 425 IIF = 1,MUMIF
               IP1 = IP1 + NTONE
               IP2 = IP2 + NTONE
               LP = LP + MUMPOL
               IF (GNREC(IP1).NE.FBLANK) VALUE(LP) = GNREC(IP1)
 425           CONTINUE
 430        CONTINUE
C                                       PSYS = PSUM / PDIF = Tsys/Tcal
      ELSE IF (ICODE.EQ.1) THEN
         DO 450 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = REKOL(IIS) - NTONE
            IP2 = REKOL(2) - NTONE
            JP1 = IMKOL(IIS) - NTONE
            JP2 = IMKOL(2) - NTONE
            DO 445 IIF = 1,MUMIF
               IP1 = IP1 + NTONE
               IP2 = IP2 + NTONE
               JP1 = JP1 + NTONE
               JP2 = JP2 + NTONE
               LP = LP + MUMPOL
               IF ((CKKOL(1).GT.0) .AND. (GNRECI(CKKOL(1)).EQ.1)) THEN
                  TC = TCAL(ISTOK+IIS+1, IIF-1+BIF, IANT)
               ELSE
                  TC = TCAL(ISTOK+IIS-1, IIF-1+BIF, IANT)
                  END IF
               IF (TC.LE.0.0) TC = FBLANK
               IF ((GNREC(IP1).NE.FBLANK) .AND. (GNREC(JP1).NE.FBLANK)
     *            .AND. (GNREC(IP1).GT.0.0) .AND. (TC.NE.FBLANK)) THEN
                  V = GNREC(JP1) / GNREC(IP1) / 2.0 * TC
                  VALUE(LP) = V
                  END IF
 445           CONTINUE
 450        CONTINUE
C                                       Tsys (TY table)
      ELSE IF (ICODE.EQ.7) THEN
         DO 190 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = TSKOL(IIS) - 1
            DO 185 IIF = 1,MUMIF
               IP1 = IP1 + 1
               LP = LP + MUMPOL
               IF (ABS(GNREC(IP1)-999.0).LT.0.1) GNREC(IP1) = FBLANK
               IF (GNREC(IP1).NE.FBLANK) VALUE(LP) = GNREC(IP1)
 185           CONTINUE
 190        CONTINUE
C                                       Tant (K)
      ELSE IF (ICODE.EQ.8) THEN
         DO 290 IIS = 1,MUMPOL
            LP = IIS - MUMPOL
            IP1 = TAKOL(IIS) - 1
            DO 285 IIF = 1,MUMIF
               IP1 = IP1 + 1
               LP = LP + MUMPOL
               IF (ABS(GNREC(IP1)-999.0).LT.0.1) GNREC(IP1) = FBLANK
               IF (GNREC(IP1).NE.FBLANK) VALUE(LP) = GNREC(IP1)
 285           CONTINUE
 290        CONTINUE
         END IF
C
      OKAY = .TRUE.
      LP = MUMPOL * MUMIF
      DO 910 IIS = 1,LP
         IF (VALUE(IIS).NE.FBLANK) GO TO 999
 910     CONTINUE
      OKAY = .FALSE.
C
 999  RETURN
      END
      SUBROUTINE SNPCOR (NV, NA, SYPTS, SNPTS)
C-----------------------------------------------------------------------
C   Computes correlation coefficients: first regrids the data on a 1
C   second grid, then computes linear correlation coefficient and prints
C   it
C      NV       I      Number values per antenna
C      NA       I      Number antennas in data array
C      SYPTS    R(*)   SY Data (NV,*)
C      SNPTS    R(*)   SN Data (NV,*)
C   Output:
C      IRET     I      Return code, 0=OK else failed
C-----------------------------------------------------------------------
      INTEGER   NV, NA
      REAL      SYPTS(NV,*), SNPTS(NV,*)
C
      INCLUDE 'SYVSN.INC'
      INTEGER   IA, IIS, NST, I, IT, J, IXX(86400), LT, NT, IRET
      REAL      TMIN, TMAX, YY(86400), SS(86400), CC(86400), SYV(86400),
     *   SNV(86400), R, SYMIN, SNMIN, XSCALE(6), SCALE
      CHARACTER MARK*1
      LOGICAL   DOPLOT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA XSCALE /86400., 100., 8640., 8640., 100., 100./
C-----------------------------------------------------------------------
      DOPLOT = ABSICA.LT.0.0
      TMIN = 1.E10
      TMAX = -1.E10
      NST = NV - 2
      DO 20 IA = 1,NA
         IF ((NUMPTS(IA,1).GT.0) .AND. (NUMPTS(IA,2).GT.0)) THEN
            I = FANREC(IA,1)
            DO 10 J = 1,NUMPTS(IA,1)
               TMIN = MIN (TMIN, SYPTS(2,I))
               TMAX = MAX (TMAX, SYPTS(2,I))
               I = I + 1
 10            CONTINUE
            I = FANREC(IA,2)
            DO 15 J = 1,NUMPTS(IA,2)
               TMIN = MIN (TMIN, SNPTS(2,I))
               TMAX = MAX (TMAX, SNPTS(2,I))
               I = I + 1
 15            CONTINUE
            END IF
 20      CONTINUE
      SCALE = XSCALE (XVAR)
      NT = (TMAX - TMIN) * SCALE + 1.99
      DO 100 IA = 1,NA
         IF ((NUMPTS(IA,1).GT.0) .AND. (NUMPTS(IA,2).GT.0) .AND.
     *      (IA.NE.REFANT)) THEN
            DO 90 IIS = 1,NST
C                                       copy SY to work area, smooth
               IT = 0
               DO 30 I = 1,NUMPTS(IA,1)
                  J = I + FANREC(IA,1) - 1
                  IF (SYPTS(2+IIS,J).NE.FBLANK) THEN
                     IT = IT + 1
                     IXX(IT) = (SYPTS(2,J) - TMIN) * SCALE + 1.5
                     YY(IT) = SYPTS(2+IIS,J)
                     END IF
 30               CONTINUE
               CALL SMOOTH (SAMTYP, STTSY, IT, IXX, YY, NT, SYV)
               LT = IT
C                                       copy SN to work area, smooth
               IT = 0
               DO 35 I = 1,NUMPTS(IA,2)
                  J = I + FANREC(IA,2) - 1
                  IF (SNPTS(2+IIS,J).NE.FBLANK) THEN
                     IT = IT + 1
                     IXX(IT) = (SNPTS(2,J) - TMIN) * SCALE + 1.5
                     SS(IT) = SIN (DG2RAD * SNPTS(2+IIS,J))
                     CC(IT) = COS (DG2RAD * SNPTS(2+IIS,J))
                     END IF
 35               CONTINUE
               LT = MIN (LT, IT)
               CALL SMOOTH (SAMTYP, STTSN, IT, IXX, CC, NT, YY)
               CALL SMOOTH (SAMTYP, STTSN, IT, IXX, SS, NT, CC)
               SYMIN = 1.E10
               SNMIN = 1000.
               DO 40 I = 1,NT
                  SNV(I) = FBLANK
                  IF ((CC(I).NE.FBLANK) .AND. (YY(I).NE.FBLANK)) THEN
                     SNV(I) = RAD2DG * ATAN2 (CC(I), YY(I))
                     SNMIN = MIN (SNMIN, SNV(I))
                     END IF
                  IF (SYV(I).NE.FBLANK) SYMIN = MIN (SYMIN, SYV(I))
 40               CONTINUE
C                                       get full correlation coeff
               CALL GETCOR (NT, SYV, SNV, R)
               MARK = ' '
               IF (ABS(R).GT.0.3) MARK = '*'
               WRITE (MSGTXT,1050) IA, IIS, LT, R, MARK
               CALL MSGWRT (4)
               RVALUE(IIS,IA) = R
               IF (DOPLOT) THEN
                  CALL PLTSY (NT, IA, IIS, R, SYV, SNV, IRET)
                  IF (IRET.NE.0) DOPLOT = .FALSE.
                  END IF
               IF (ABSICA.LT.0.0) CALL SUBCOR (NT, IIS, IA, SYV, SNV,
     *            TMIN)
 90            CONTINUE
            END IF
 100     CONTINUE
C      IF ((XINC.GT.0) .AND. (ABSICA.LT.0.0)) CALL PLTCOR
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('Ant',I4,' St',I2,'  Npoints',I8,'  Corr coef',F9.3,1X,A1)
      END
      SUBROUTINE GETCOR (NV, SYV, SNV, R)
C-----------------------------------------------------------------------
C   GETCOR computes the correlation of 2 arrays
C   Inputs
C      NV    I      Number values
C      SYV   R(*)   First array
C      SNV   R(*)   Second array
C   Outputs
C      R     R      Linear correlation coefficient
C-----------------------------------------------------------------------
      INTEGER   NV
      REAL      SYV(*), SNV(*), R
C
      INTEGER   I, NNT
      REAL      SX, SY, SXY, SXX, SYY
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      SX = 0.0
      SY = 0.0
      SXX = 0.0
      SYY = 0.0
      SXY = 0.0
      NNT = 0
      DO 20 I = 1,NV
         IF ((SYV(I).NE.FBLANK) .AND. (SNV(I).NE.FBLANK)) THEN
            NNT = NNT + 1
            SX = SX + SYV(I)
            SXX = SXX + SYV(I) * SYV(I)
            SXY = SXY + SYV(I) * SNV(I)
            SY = SY + SNV(I)
            SYY = SYY + SNV(I) * SNV(I)
            END IF
 20      CONTINUE
      R = (NNT * SXX - SX * SX) * (NNT * SYY - SY * SY)
      R = SQRT (MAX (0.0, R))
      IF (R.NE.0.0) R = (NNT * SXY - SX * SY) / R
C
 999  RETURN
      END
      SUBROUTINE SUBCOR (NV, IST, IA, SYV, SNV, TMIN)
C-----------------------------------------------------------------------
C   SUBCOR takes equal subintervals of 2 arrays and gets their linear
C   correlation coefficients as a function of time
C   Inputs:
C      NV     I      Number 1-sec times in arrays
C      IST    I      Stokes
C      IA     I      Antenna
C      SYV    R(*)   Array 1
C      SNV    R(*)   Array 2
C      TMIN   R      Start time
C   Inputs common:
C      XINC   I      Desired increment in seconds between sub groups
C   Outputs common
C      RVALS  R(*)   Corr coeff (ist, iant, t)
C      RTS    R      Times (t)
C-----------------------------------------------------------------------
      INTEGER   NV, IST, IA
      REAL      SYV(*), SNV(*), TMIN
C
      INCLUDE 'SYVSN.INC'
      INTEGER   I, J, NT
      REAL      R
C-----------------------------------------------------------------------
      IF (XINC.GT.0) THEN
         R = NV
         I = R / XINC + 0.5
         NT = NV / I
         J = NV / NT
         IF (J.GT.2000) NT = NV / 2000
         J = 0
         DO 20 I = 1,NV,NT
            J = J + 1
            CALL GETCOR (NT, SYV(I), SNV(I), R)
            RVALS(IST,IA,J) = R
            RTS(IST,IA,J) = TMIN + (I-0.5+NT/2.0) / 86400.0
 20         CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE SMOOTH (TYPE, STT, IT, IXX, YY, NT, OUT)
C-----------------------------------------------------------------------
C   SMOOTH smooths an input array at irregular times to an output array
C   at integer seconds relative to the start
C   Inputs:
C      TYPE  C*4    type of smoothing
C      STT   R(3)   Support, half width, wt cutoff
C      IT    I      Number samples in input arrays
C      IXX   I(*)   Input times in integer seconds
C      YY    R(*)   Data values
C      NT    I      Number of times out (== max relative time)
C   Outputs
C      OUR   R(*)   Smoothed regular array
C-----------------------------------------------------------------------
      CHARACTER TYPE*4
      INTEGER   IT, IXX(*), NT
      REAL      STT(3), YY(*), OUT(*)
C
      INTEGER   I, J, J1, J2, K, K1, K2, J0, N
      REAL      HWIDTH, SCRTCH(86400), FWIDTH, WT, MEDIAN, CUT
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      HWIDTH = STT(1) / 2.0
      CALL RFILL (NT, 0.0, OUT)
      CALL RFILL (NT, 0.0, SCRTCH)
      K = HWIDTH + 0.5
      CUT = STT(3)
C                                       median window filter
      IF (TYPE.EQ.'MWF') THEN
         J0 = 1
         DO 130 I = 1,NT
            K1 = MAX (1, I-K)
            K2 = MIN (NT, I+K)
            J1 = NT
            J2 = 0
            DO 110 J = J0,IT
               IF (IXX(J).GE.K1) THEN
                  IF (IXX(J).LE.K2) THEN
                     J1 = MIN (J1, J)
                     J2 = MAX (J2, J)
                  ELSE
                     GO TO 115
                     END IF
                  END IF
 110           CONTINUE
 115        IF (J2.EQ.J1) THEN
               OUT(I) = YY(J)
               J0 = J1
            ELSE IF (J2.GT.J1) THEN
               N = J2 - J1 + 1
               CALL RCOPY (N, YY(J1), SCRTCH)
               OUT(I) = MEDIAN (N, SCRTCH)
               J0 = J1
               END IF
 130        CONTINUE
C                                       2 point
      ELSE IF (TYPE.EQ.'2PT') THEN
         J1 = IXX(1)
         CALL RCOPY (J1, YY(1), OUT(1))
         DO 220 J = 2,IT
            J2 = IXX(J)
            IF (J2.GT.J1) THEN
               WT = J2 - J1
               DO 210 I = J1,J2
                  OUT(I) = YY(J1) + (YY(J2)-YY(J1)) * (I-J1) / WT
 210              CONTINUE
               END IF
            J1 = J2
 220        CONTINUE
C                                       Gaussian
      ELSE IF (TYPE.EQ.'GAUS') THEN
         FWIDTH = STT(2) / 2.0 / SQRT (LOG (2.0))
         DO 320 J = 1,IT
            J1 = MAX (1, IXX(J) - K)
            J2 = MIN (IT, IXX(J) + K)
            DO 310 I = J1,J2
               WT = ABS (IXX(J) - I) / FWIDTH
               WT = EXP (-(WT*WT))
               OUT(I) = OUT(I) + YY(J) * WT
               SCRTCH(I) = SCRTCH(I) + WT
 310           CONTINUE
 320        CONTINUE
         DO 330 I = 1,NT
            IF (SCRTCH(I).GE.CUT) THEN
               OUT(I) = OUT(I) / SCRTCH(I)
            ELSE
               OUT(I) = FBLANK
               END IF
 330        CONTINUE
C                                       Exponential
      ELSE IF (TYPE.EQ.'EXP') THEN
         FWIDTH = STT(2) / 2.0 / LOG (2.0)
         DO 420 J = 1,IT
            J1 = MAX (1, IXX(J) - K)
            J2 = MIN (IT, IXX(J) + K)
            DO 410 I = J1,J2
               WT = ABS (IXX(J) - I) / FWIDTH
               WT = EXP (-WT)
               OUT(I) = OUT(I) + YY(J) * WT
               SCRTCH(I) = SCRTCH(I) + WT
 410           CONTINUE
 420        CONTINUE
         DO 430 I = 1,NT
            IF (SCRTCH(I).GE.CUT) THEN
               OUT(I) = OUT(I) / SCRTCH(I)
            ELSE
               OUT(I) = FBLANK
               END IF
 430        CONTINUE
C                                       Linear
      ELSE IF (TYPE.EQ.'LINE') THEN
         FWIDTH = STT(2)
         DO 520 J = 1,IT
            J1 = MAX (1, IXX(J) - K)
            J2 = MIN (IT, IXX(J) + K)
            DO 510 I = J1,J2
               WT = ABS (IXX(J) - I) / FWIDTH
               WT = MAX (0.0, 1.0-WT)
               OUT(I) = OUT(I) + YY(J) * WT
               SCRTCH(I) = SCRTCH(I) + WT
 510           CONTINUE
 520        CONTINUE
         DO 530 I = 1,NT
            IF (SCRTCH(I).GE.CUT) THEN
               OUT(I) = OUT(I) / SCRTCH(I)
            ELSE
               OUT(I) = FBLANK
               END IF
 530        CONTINUE
C                                       boxcar
      ELSE
         DO 620 J = 1,IT
            J1 = MAX (1, IXX(J) - K)
            J2 = MIN (IT, IXX(J) + K)
            DO 610 I = J1,J2
               OUT(I) = OUT(I) + YY(J)
               SCRTCH(I) = SCRTCH(I) + 1.0
 610           CONTINUE
 620        CONTINUE
         DO 630 I = 1,NT
            IF (SCRTCH(I).GE.CUT) THEN
               OUT(I) = OUT(I) / SCRTCH(I)
            ELSE
               OUT(I) = FBLANK
               END IF
 630        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE SNPLOT (NV, NA, SYPTS, SNPTS, IRET)
C-----------------------------------------------------------------------
C   SNPLOT plots the data thru calls to PLTSN.
C   Input:
C      NV       I      Number values per antenna
C      NA       I      Number antennas in data array
C      SYPTS    R(*)   SY Data (NV,*)
C      SNPTS    R(*)   SN Data (NV,*)
C   Output:
C      IRET     I      Return code, 0=OK else failed
C-----------------------------------------------------------------------
      INTEGER   NV, NA, IRET
      REAL      SYPTS(NV,*), SNPTS(NV,*)
C
      INTEGER   IPLOT, JPLT, IPLT, NPLT, KK, LUMST, LST1, LST2, IIS,
     *   DOLAB
      LOGICAL   DOIT, DOPOL, OVERL
      INCLUDE 'SYVSN.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IPLOT = 0
C                                       Loop thru stations to plot
      LUMST = MUMPOL
      DOPOL = (ABS(CROWD-1.0).LT.0.5)
      OVERL = (ABS(CROWD-2.0).LT.0.5)
      CALL FILL (4, 4, COLORS)
      IF (DOPOL) THEN
         COLORS(1,1) = 3
         COLORS(1,2) = 3
      ELSE IF (OVERL) THEN
         COLORS(1,1) = 3
         COLORS(2,1) = 3
         END IF
      IF (DOPOL) LUMST = 1
      NCODES = 2
C                                       not overlapped
      IF (.NOT.OVERL) THEN
C                                       count the plots
         NPLOTS = 0
         DO 40 IPLT = 1,MUMANT
            IF (IPLT.NE.REFANT) THEN
               DO 30 IIS = 1,LUMST
                  IF (DOPOL) THEN
                     LST1 = 1
                     LST2 = MUMPOL
                  ELSE
                     LST1 = IIS
                     LST2 = IIS
                     END IF
                  DO 25 KK = 1,NCODES
                     CALL GETSCL (KK, LST1, LST2, IPLT, DOIT)
                     IF (DOIT) NPLOTS = NPLOTS + 1
 25                  CONTINUE
 30               CONTINUE
               END IF
 40         CONTINUE
C                                       Now plot
         NPLT = 0
         DOLAB = 2
         DO 90 IPLT = 1,MUMANT
            IF (IPLT.NE.REFANT) THEN
               DO 80 IIS = 1,LUMST
                  IF (DOPOL) THEN
                     LST1 = 1
                     LST2 = MUMPOL
                  ELSE
                     LST1 = IIS
                     LST2 = IIS
                     END IF
                  DO 70 KK = 1,NCODES
                     CALL GETSCL (KK, LST1, LST2, IPLT, DOIT)
                     IF (DOIT) THEN
                        NPLT = NPLT + 1
                        JPLT = NPLT
                        IPLOT = MOD (NPLT-1, NCOUNT) + 1
                        IF (NPLT.EQ.NPLOTS) IPLOT = -IPLOT
                        IF (KK.EQ.1) THEN
                           CALL PLTSN (DOLAB, IPLOT, KK, LST1, LST2,
     *                        IPLT,NV, SYPTS, IRET)
                        ELSE
                           CALL PLTSN (DOLAB, IPLOT, KK, LST1, LST2,
     *                        IPLT,NV, SNPTS, IRET)
                           END IF
                        IF (IRET.NE.0) GO TO 999
                        END IF
 70                  CONTINUE
 80               CONTINUE
               END IF
 90         CONTINUE
C                                       overlap 2 physical types
      ELSE
C                                       count the plots
         NPLOTS = 0
         DO 140 IPLT = 1,MUMANT
            IF (IPLT.NE.REFANT) THEN
               DO 130 IIS = 1,LUMST
                  IF (DOPOL) THEN
                     LST1 = 1
                     LST2 = MUMPOL
                  ELSE
                     LST1 = IIS
                     LST2 = IIS
                     END IF
                  CALL GETSCL (2, LST1, LST2, IPLT, DOIT)
                  IF (DOIT) THEN
                     CALL GETSCL (1, LST1, LST2, IPLT, DOIT)
                     IF (DOIT) NPLOTS = NPLOTS + 1
                     END IF
 130              CONTINUE
               END IF
 140        CONTINUE
C                                       Now plot
         NPLT = 0
         DO 190 IPLT = 1,MUMANT
            IF (IPLT.NE.REFANT) THEN
               DO 180 IIS = 1,LUMST
                  LST1 = IIS
                  LST2 = IIS
                  CALL GETSCL (2, LST1, LST2, IPLT, DOIT)
                  IF (DOIT) THEN
                     CALL GETSCL (1, LST1, LST2, IPLT, DOIT)
                     IF (DOIT) THEN
                        NPLT = NPLT + 1
                        JPLT = NPLT
                        IPLOT = MOD (NPLT-1, NCOUNT) + 1
                        DOLAB = 1
                        CALL PLTSN (DOLAB, IPLOT, 1, LST1, LST2, IPLT,
     *                     NV,SYPTS, IRET)
                        IF (IRET.NE.0) GO TO 999
                        CALL GETSCL (2, LST1, LST2, IPLT, DOIT)
                        IF (DOIT) THEN
                           DOLAB = 3
                           IF (NPLT.EQ.NPLOTS) IPLOT = -IPLOT
                           CALL PLTSN (DOLAB, IPLOT, 2, LST1, LST2, IPLT
     *                        ,NV, SNPTS, IRET)
                           IF (IRET.NE.0) GO TO 999
                           END IF
                        END IF
                     END IF
 180              CONTINUE
               END IF
 190        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE PLTSN (DOLAB, IPLOT, KK, LST1, LST2, ANTNO, NV, PLTPTS,
     *   IRET)
C-----------------------------------------------------------------------
C   PLTSN actually plots data.
C   Input:
C      DOLAB    I      1 -> label, do not end plot
C                      2 -> label and end plot is appropriate
C                      3 -> no label, end plot if appropriate
C      IPLOT    I      Plot number on current page. If neg. then this is
C                      last plot.
C      KK       I      Parameter number
C      LST1     I      1st Stokes this plot
C      LST2     I      last Stokes this plot
C      ANTNO    I      Antenna number
C      NV       I      Number values
C      PLTPTS   R(*)   Data to plot (NV,*)
C   Output:
C      IRET     I      Return code, 0 => OK, otherwise abort.
C                       -1 => user request termination
C                        1 => failed to add to catalog
C                        2 => failed to create
C                        3 => graph file write error
C                        4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   DOLAB, IPLOT, KK, LST1, LST2, ANTNO, NV, IRET
      REAL      PLTPTS(NV,*)
C
      INCLUDE 'SYVSN.INC'
C
      CHARACTER TEXT*132, PFILE*48, ATIME*8, ADATE*12, CHTMP*18,
     *   AUNITS(NCODE)*8, CHTYPE(NCODE)*16, XUNITS(6)*20,
     *   TXTMSG*80, CSAVE*5, STEXT*16
      INTEGER   BUFFER(256), VER, IERR, ITYPE, IPSIZE, LUNPL, LTYPE,
     *   FINDPL, DEPTH(5), INCHAR, INP, IT(3), ID(3), IAXLAB, IAPLOT,
     *   I, NGOOD, NNOFIT, JCODE, NN, IP, IST, ILITY, NNN, NR(2)
      REAL      BLC(2), TRC(2), DX, DY, TR, VALUE, TI, XY(2),
     *   XTRC(2), XBLC(2), TLC(2), PLTINC, YYOFF(2), SIZE, XMULT(2),
     *   DBY, COLV, COL(3), AX(5), AY(5), OLDSRC, RMAX, RMIN
      LOGICAL   T, F, GOOD, CATUP, DONEG, BLNKD, SCOLOR, DOCOLR
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      SAVE XMULT, CSAVE, LTYPE, BUFFER
      DATA LUNPL /26/
      DATA DEPTH /5*1/
      DATA T, F /.TRUE.,.FALSE./
      DATA AUNITS /'Kelvin', 'Counts', 'Counts', 'Degrees', 'Seconds',
     *   'Gain', 'Kelvin', 'Kelvin'/
      DATA CHTYPE /'Psys', 'Power sum', 'Power diff', 'Gain phs',
     *   'Delay', 'Gain amp', 'Tsys', 'Tant'/
      DATA XUNITS /'IAT (hr)', 'Elevation (degrees)',
     *   'Hour Angle (hr)', 'LST (hr)', 'Parallactic angle',
     *   'Azimuth (degrees)' /
C-----------------------------------------------------------------------
      IF (ABS(APARM(8)-1.0).LT.0.1) AUNITS(1) = 'Ratio-1'
      IF (ABS(APARM(8)-1.0).LT.0.1) AUNITS(2) = 'Ratio-1'
C                                       Time system from AN table
      SCOLOR = (XDO3C.GT.1.5) .AND. (CSMAX-CSMIN.GT.0.99)
      OLDSRC = -1000.0
      XUNITS(1)(1:3) = TIMLAB(1:3)
      NGOOD = 0
      NNOFIT = 0
      IRET = 3
      CATUP = T
C
      JCODE = ICODES(KK)
C                                       Create plot file
      IF ((ABS (IPLOT).EQ.1) .AND. (DOLAB.LT.3)) THEN
C                                       Update catalog header.
         VER = 0
         IRET = 1
         IF (.NOT.DOTV) THEN
            CALL MADDEX ('PL', DISKIN, CNOIN, CATBLK, BUFFER, CATUP,
     *         'WRIT', VER, IERR)
            IF (IERR.NE.0) THEN
               NCFILE = NCFILE - 1
               GO TO 999
               END IF
            END IF
         CALL ZPHFIL ('PL', DISKIN, CNOIN, VER, PFILE, IERR)
         IF (IERR.NE.0) GO TO 960
         IPSIZE = 0
         ITYPE = 58
         CALL GINIT (DISKIN, CNOIN, PFILE, IPSIZE, ITYPE, NPARMS,
     *      XNAMEI, DOTV, TVCHN, GRCHN, TVCORN, CATBLK, BUFFER, LUNPL,
     *      FINDPL, IERR)
         IRET = 2
         IF (IERR.NE.0) GO TO 960
         END IF
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      IF (DOTV) THEN
         TRC(1) = WINDTV(3) - WINDTV(1)
         TRC(2) = WINDTV(4) - WINDTV(2)
         IF (DO3COL.LE.0.0) THEN
            CALL GCINIT (GPHTVG(4), 0, IERR)
            IF (IERR.NE.0) GO TO 960
            CALL GCINIT (GPHTVG(3), 0, IERR)
            IF (IERR.NE.0) GO TO 960
            CALL GCINIT (GPHTVG(2), 0, IERR)
            IF (IERR.NE.0) GO TO 960
            END IF
         END IF
      PLTINC = TRC(2) / NCOUNT
      IF (XYRATO.LT.0.01) XYRATO = 1.0
C                                       Set window for current plot.
      XBLC(1) = BLC(1)
      XBLC(2) = TRC(2) - ABS (IPLOT) * PLTINC
      XTRC(1) = TRC(1)
      XTRC(2) = XBLC(2) + PLTINC - 1.0
      TLC(1) = XBLC(1)
      TLC(2) = XTRC(2)
C                                       Offsets for current plot.
      YYOFF(1) = XBLC(1)
      YYOFF(2) = XBLC(2)
C                                       fool with location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 7
      IF (XVAR.EQ.2) LABTYP(LOCNUM) = 0
      IF (XVAR.EQ.6) LABTYP(LOCNUM) = 0
      IF (XVAR.EQ.3) LABTYP(LOCNUM) = 8
      IF (XVAR.EQ.4) LABTYP(LOCNUM) = 9
      IF (XVAR.EQ.5) LABTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      TR = 1.1 * (PRAN(2,2,KK)-PRAN(1,2,KK))
      IF (TR.LE.0.0) TR = 1.0
      IF ((ABS(IPLOT).EQ.1) .OR. (NCODES.GT.1)) THEN
         TI = TR
         CALL METSCL (LABEL, TR, CPREF(2,LOCNUM), GOOD)
         XMULT(2) = TR / TI
         CSAVE = CPREF(2,LOCNUM)
         END IF
      CPREF(1,LOCNUM) = ' '
      XMULT(1) = 1.0
      DO 50 I = 1,2
         SIZE = XTRC(I) - XBLC(I) + 1
         TR = PRAN(2,I,KK) - PRAN(1,I,KK)
         XYSCL(I,KK) = (XTRC(I) - XBLC(I)) / TR
         RPLOC(I,LOCNUM) = XBLC(I)
         RPVAL(I,LOCNUM) = XYOFF(I,KK) * XMULT(I)
         AXINC(I,LOCNUM) = TR * XMULT(I) / (XTRC(I) - XBLC(I))
 50      CONTINUE
      CTYP(1,LOCNUM) = XUNITS(XVAR)
      CTYP(2,LOCNUM) = AUNITS(JCODE)
C                                       Init plot calls again
C                                       Number of characters on each
C                                       side of the plot
      IF ((ABS (IPLOT).EQ.1) .AND. (DOLAB.LT.3)) THEN
         CALL RFILL (4, 0.5, CHOUT)
C                                       Not fully initialized, may make
C                                       INP too large which is okay.
         CALL CHNTIC (XBLC, XTRC, INP)
         INP = MAX (INP, 3)
         IF (NCODES.GT.1) INP = MAX (INP, 7)
         LTYPE = MOD (ABS (LABEL), 100)
         IF (LTYPE.EQ.2) CHOUT(1) = 2.5
         IF (LTYPE.GT.2) CHOUT(1) = INP + 4
         IF (LTYPE.GT.1) CHOUT(2) = 2.0
         IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
         IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = 4.666
         IF ((LABEL.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7))
     *      CHOUT(4) = CHOUT(4) + 1.333
C                                       Init for line drawing.
         CALL GINITL (BLC, TRC, XYRATO, CHOUT, DEPTH, BUFFER, IERR)
         IRET = 3
         IF (IERR.NE.0) GO TO 970
         IF (.NOT.DOTV) THEN
            WRITE (MSGTXT,1000) VER
            CALL MSGWRT (2)
            END IF
         END IF
      IRET = 3
      CATUP = T
C                                       Draw border
      ILITY = 1
      CALL GLTYPE (ILITY, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      IF (DOLAB.LT.3) THEN
         CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL GVEC (XBLC(1), XBLC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL GVEC (XTRC(1), XBLC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL GVEC (XTRC(1), XTRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL GVEC (XBLC(1), XTRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Top labels: type & name
         IF ((ABS(IPLOT).EQ.1) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7))
     *      THEN
            DX = 0.0
            DY = 0.5 + 2 * 1.333
C                                       The second line of the header
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            INCHAR = 16
            INP = 1
            TEXT = CHTYPE(ICODES(1))
            CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
            IF (ABS(APARM(8)-1.0).LT.0.1) THEN
               TEXT(INP+1:) = ' ratio'
               INP = INP + 6
               END IF
            TEXT(INP+1:) = ' and ' // CHTYPE(ICODES(2))
            INCHAR = 40
            CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
            INP = INP + 1
            IF (XVAR.EQ.1) THEN
               TEXT(INP:INP+16) = ' vs '// TIMLAB(1:3) // ' time for '
               INP = INP + 17
            ELSE IF (XVAR.EQ.2) THEN
               TEXT(INP:INP+17) = ' vs elevation for '
               INP = INP + 18
            ELSE IF (XVAR.EQ.3) THEN
               TEXT(INP:INP+10) = ' vs HA for '
               INP = INP + 11
            ELSE IF (XVAR.EQ.4) THEN
               TEXT(INP:INP+16) = ' vs LST time for '
               INP = INP + 17
            ELSE IF (XVAR.EQ.5) THEN
               TEXT(INP:INP+17) = ' vs parallactic angle for '
               INP = INP + 26
            ELSE IF (XVAR.EQ.6) THEN
               TEXT(INP:INP+17) = ' vs azimuth for '
               INP = INP + 16
               END IF
C                                       File name
            CALL H2CHR (18, KHIMNO, CATH(KHIMN), CHTMP)
            CALL H2CHR (6, KHIMCO, CATH(KHIMC), CHTMP(13:18))
            CALL NAMEST (CHTMP, CATBLK(KIIMS), TEXT(INP:), INCHAR)
            CALL REFRMT (TEXT, ' ', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
C                                       the third line of header
            DY = 0.5
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            INP = 1
            WRITE (TEXT(INP:),1010) SYTYPE, ITVER(1), 'SN', ITVER(2)
            INP = INP + 16
C                                       Stokes and IF
            IF (SUMSTK.GT.0) THEN
               TEXT(INP:) = XSTOK(:1) // 'pol_'
               INP = INP + 7
            ELSE
               TEXT(INP:) = 'Rpol & Lpol_'
               IF (ICOR0.LT.-4) TEXT(INP:) = 'Vpol & Hpol_'
               INP = INP + 14
               END IF
            IF (BIFS(1,1).EQ.EIFS(1,1)) THEN
               WRITE (TEXT(INP:),1021) SYTYPE, BIFS(1,1)
               INP = INP + 12
            ELSE
               WRITE (STEXT,1026) BIFS(1,1), EIFS(1,1)
               CALL REBLNK (STEXT, INCHAR)
               WRITE (TEXT(INP:),1022) SYTYPE, STEXT(:INCHAR)
               INP = INP + 9 + INCHAR
               END IF
            IF (BIFS(1,2).EQ.EIFS(1,2)) THEN
               WRITE (TEXT(INP:),1021) 'SN', BIFS(1,2)
               INP = INP + 12
            ELSE
               WRITE (STEXT,1026) BIFS(1,2), EIFS(1,2)
               CALL REBLNK (STEXT, INCHAR)
               WRITE (TEXT(INP:),1022) 'SN', STEXT(:INCHAR)
               INP = INP + 9 + INCHAR
               END IF
            CALL REFRMT (TEXT, '_', INCHAR)
             CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
C                                       refant, baseline
            DY = 0.5 + 1.333
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            INP = 9
            IF (REFANT.GT.0) THEN
               WRITE (TEXT,1025) REFANT
            ELSE
               TEXT = 'No refant'
               END IF
            IF (BIFS(2,1).LE.EIFS(2,1)) THEN
               TEXT(INP+1:) = '__SY Baseline IFs'
               INP = INP + 18
               WRITE (STEXT,1026) BIFS(2,1), EIFS(2,1)
               CALL REBLNK (STEXT, INCHAR)
               TEXT(INP+1:) = STEXT(:INCHAR)
               INP = INP + INCHAR
               IF (BIFS(3,1).LE.EIFS(3,1)) THEN
                  TEXT(INP+1:) = ' + '
                  INP = INP + 3
                  WRITE (STEXT,1026) BIFS(3,1), EIFS(3,1)
                  CALL REBLNK (STEXT, INCHAR)
                  TEXT(INP+1:) = STEXT(:INCHAR)
                  INP = INP + INCHAR
                  END IF
            ELSE
               TEXT(INP+1:) = '___No SY basline IFs'
               INP = INP + 20
               END IF
            IF (BIFS(2,2).LE.EIFS(2,2)) THEN
               TEXT(INP+1:) = '__SN Baseline IFs'
               INP = INP + 18
               WRITE (STEXT,1026) BIFS(2,2), EIFS(2,2)
               CALL REBLNK (STEXT, INCHAR)
               TEXT(INP+1:) = STEXT(:INCHAR)
               INP = INP + INCHAR
               IF (BIFS(3,2).LE.EIFS(3,2)) THEN
                  TEXT(INP+1:) = ' + '
                  INP = INP + 3
                  WRITE (STEXT,1026) BIFS(3,2), EIFS(3,2)
                  CALL REBLNK (STEXT, INCHAR)
                  TEXT(INP+1:) = STEXT(:INCHAR)
                  INP = INP + INCHAR
                  END IF
            ELSE
               TEXT(INP+1:) = '___No SN basline IFs'
               END IF
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
C                                       Date/time/version
            IF ((LABEL.GT.0) .AND. (LTYPE.GT.1)) THEN
               DY = 0.5 + 3 * 1.333
C                                       the first line of the header
               CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               CALL ZDATE (ID)
               CALL ZTIME (IT)
               CALL TIMDAT (IT, ID, ATIME, ADATE)
               WRITE (TEXT,1030) VER, ADATE, ATIME
               CALL REFRMT (TEXT, '_', INCHAR)
               CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               END IF
            END IF
C                                       station ID
         CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         DX =  1.5
         DY = -1.8
         WRITE (TEXT,1040) ANTNO
         INP = 4
         IF (MUMPOL.LE.1) THEN
            TEXT(INP:) = XSTOK(:1)
            INP = INP + 1
         ELSE
            IF (ICOR0.LT.-4) THEN
               TEXT(INP:) = 'V'
               IF (LST1.EQ.2) TEXT(INP:) = 'H'
            ELSE
               TEXT(INP:) = 'R'
               IF (LST1.EQ.2) TEXT(INP:) = 'L'
               END IF
            INP = INP + 1
            END IF
         TEXT(INP+1:) = STNNAM(ANTNO)
         CALL CHTRIM (TEXT, 132, TEXT, INCHAR)
         IF (SAMTYP.NE.' ') WRITE (TEXT(INCHAR+1:),1050)
     *      RVALUE(LST1,ANTNO)
         CALL REFRMT (TEXT, '_', INCHAR)
         IF ((LST1.NE.LST2) .AND. (DO3COL.GT.0.0) .AND. (DOLAB.EQ.2))
     *      THEN
            IF (COLORS(LST1,KK).NE.ILITY) THEN
               ILITY = COLORS(LST1,KK)
               CALL GLTYPE (ILITY, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               END IF
            END IF
         CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         IF (LST1.NE.LST2) THEN
            CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            DX =  1.5
            DY = -3.25
            WRITE (TEXT,1040) ANTNO
            INP = 4
            IF (MUMPOL.LE.1) THEN
               TEXT(INP:) = XSTOK(:1)
               INP = INP + 1
            ELSE
               IF (ICOR0.LT.-4) THEN
                  TEXT(INP:) = 'H'
               ELSE
                  TEXT(INP:) = 'L'
                  END IF
               INP = INP + 1
               END IF
            TEXT(INP+1:) = STNNAM(ANTNO)
            CALL CHTRIM (TEXT, 132, TEXT, INCHAR)
            IF (SAMTYP.NE.' ') WRITE (TEXT(INCHAR+1:),1050)
     *         RVALUE(LST2,ANTNO)
            CALL REFRMT (TEXT, '_', INCHAR)
            IF ((DO3COL.GT.0.0) .AND. (DOLAB.EQ.2)) THEN
               IF (COLORS(LST2,KK).NE.ILITY) THEN
                  ILITY = COLORS(LST2,KK)
                  CALL GLTYPE (ILITY, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  END IF
               END IF
            CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
         END IF
C                                       type of plot
      IF (NCODES.GT.1) THEN
         IF (DO3COL.GT.0.0) THEN
            IF (DOLAB.EQ.2) THEN
               IF (1.NE.ILITY) THEN
                  ILITY = 1
                  CALL GLTYPE (ILITY, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  END IF
            ELSE IF (COLORS(LST1,KK).NE.ILITY) THEN
               ILITY = COLORS(LST1,KK)
               CALL GLTYPE (ILITY, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               END IF
            END IF
         TEXT = CHTYPE(JCODE)
         CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
         CALL GPOS (XTRC(1), XTRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         DX = -INP - 3.0
         DY = -4.25
         IF (DOLAB.LT.3) DY = -2.8
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Set up location common
C                                       Blank bottom label.
      IF ((IPLOT.GE.0) .AND. (ABS (IPLOT).NE.NCOUNT)) THEN
         CPREF(1,LOCNUM) = ' '
         CTYP(1,LOCNUM) = ' '
         END IF
C                                       Only label Y axis once.
      IAXLAB = NCOUNT / 2 + 1
      IAPLOT = ABS (IPLOT)
      IF (NCODES.LE.1) THEN
         CPREF(2,LOCNUM) = CSAVE
         IF ((IAPLOT.NE.IAXLAB) .AND. ((IPLOT.GE.0) .OR.
     *      (IAPLOT.GT.IAXLAB))) CPREF(2,LOCNUM) = '-1'
         END IF
C                                       Put on labels and ticks
      IF (DOLAB.LT.3) THEN
         IF (1.NE.ILITY) THEN
            ILITY = 1
            CALL GLTYPE (ILITY, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
         CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XYRATO, F, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Size of symbol.
      DBY = 0.5 * FACTOR
C                                       Loop
      ILITY = 4
      CALL GLTYPE (ILITY, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      DOCOLR = SCOLOR
C                                       Outer loop: IF, stokes
      COLV = 0.0
      DO 190 IST = LST1,LST2
         IF (DO3COL.GT.0.0) THEN
            IF (COLORS(IST,KK).NE.ILITY) THEN
               ILITY = COLORS(IST,KK)
               CALL GLTYPE (ILITY, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               END IF
            END IF
         IP = IST + 2
C                                       Point plot
         DO 120 NN = 1,NUMPTS(ANTNO,KK)
            DONEG = (JCODE.EQ.4)
C                                       Scale X
            NNN = NN - 1 + FANREC(ANTNO,KK)
            XY(1) = PLTPTS(2,NNN)
            IF ((SWAP) .AND. (XY(1).GT.180.0)) XY(1) = XY(1) - 360.0
            IF ((XVAR.EQ.1) .OR. (XVAR.EQ.3) .OR. (XVAR.EQ.4))
     *         XY(1) = XY(1) * 360.0
            XY(1) = XYSCL(1,KK) * (XY(1) - XYOFF(1,KK)) + YYOFF(1)
            IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1))) THEN
               NNOFIT = NNOFIT + (LST2-LST1+1)
               GO TO 120
               END IF
C                                       source color
            IF ((SCOLOR) .AND. (ABS(PLTPTS(1,NNN)-OLDSRC).GT.0.1)) THEN
               COLV = 0.97 * (PLTPTS(1,NNN)-CSMIN) / (CSMAX-CSMIN)
               CALL COLOR3 (COLV, .FALSE., COL)
               CALL G3VCOL (COL(1), COL(2), COL(3), BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               OLDSRC = PLTPTS(1,NNN)
               END IF
C                                       loop for points
            VALUE = PLTPTS(IP,NNN)
C                                       ?????????????????
            IF (VALUE.NE.FBLANK) THEN
 110           XY(2) = VALUE
               XY(2) = XYSCL(2,KK) * (XY(2) - XYOFF(2,KK)) + YYOFF(2)
               IF ((XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2))) THEN
                  IF (DONEG) THEN
                     IF (VALUE.LT.0.) THEN
                        VALUE = VALUE + 360. * ABS (BPARM(7))
                     ELSE
                        VALUE = VALUE - 360. * ABS (BPARM(7))
                        END IF
                     DONEG = .FALSE.
                     GO TO 110
                  ELSE
                     NNOFIT = NNOFIT + 1
                     END IF
               ELSE
                  NGOOD = NGOOD + 1
C                                       Mark point
                  DY = 5.0 * FACTOR
                  DX = 5.0 * FACTOR
                  IF (XYRATO.GT.1.0) THEN
                     DY = DY * XYRATO
                  ELSE
                     DX = DX / XYRATO
                     END IF
                  AX(1) = XY(1)
                  AY(1) = XY(2)
                  AX(2) = AX(1)
                  AX(3) = AX(1)
                  AX(4) = AX(1) - DX
                  AX(5) = AX(1) + DX
                  AY(2) = AY(1) + DY
                  AY(3) = AY(1) - DY
                  AY(4) = AY(1)
                  AY(5) = AY(1)
                  IF ((DO3COL.LE.0) .AND. (ILITY.NE.4)) THEN
                     ILITY = 4
                     CALL GLTYPE (ILITY, BUFFER, IERR)
                     IF (IERR.NE.0) GO TO 970
                     END IF
                  CALL PNTPLT (ISYM(IST), AX, AY, XBLC, XTRC, .FALSE.,
     *               DOCOLR, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  END IF
            ELSE IF (BSYM.GT.0) THEN
               DY = 5.0 * FACTOR
               DX = 5.0 * FACTOR
               IF (XYRATO.GT.1.0) THEN
                  DY = DY * XYRATO
               ELSE
                  DX = DX / XYRATO
                  END IF
               XY(2) = XBLC(2) + DY
               AX(1) = XY(1)
               AY(1) = XY(2)
               AX(2) = AX(1)
               AX(3) = AX(1)
               AX(4) = AX(1) - DX
               AX(5) = AX(1) + DX
               AY(2) = AY(1) + DY
               AY(3) = AY(1) - DY
               AY(4) = AY(1)
               AY(5) = AY(1)
               IF ((DO3COL.LE.0) .AND. (ILITY.NE.3)) THEN
                  ILITY = 2
                  CALL GLTYPE (ILITY, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  END IF
               CALL PNTPLT (BSYM, AX, AY, XBLC, XTRC, .FALSE.,
     *            DOCOLR, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               END IF
 120        CONTINUE
C                                       Line plot
         IF (DOLINE) THEN
            BLNKD = .TRUE.
            DO 140 NN = 1,NUMPTS(ANTNO,KK)
               DONEG = (JCODE.EQ.4)
C                                       Scale X
               NNN = NN - 1 + FANREC(ANTNO,KK)
               XY(1) = PLTPTS(2,NNN)
               IF ((XVAR.NE.2) .AND. (XVAR.NE.5) .AND. (XVAR.NE.6))
     *            XY(1) = XY(1) * 360.0
               XY(1) = XYSCL(1,KK) * (XY(1) - XYOFF(1,KK)) + YYOFF(1)
               IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1)))
     *            GO TO 140
C                                       loop for points
               VALUE = PLTPTS(IP,NNN)
               IF (VALUE.EQ.FBLANK) THEN
                  BLNKD = .TRUE.
               ELSE
 130              XY(2) = VALUE
                  XY(2) = XYSCL(2,KK) * (XY(2) - XYOFF(2,KK)) +
     *               YYOFF(2)
                  IF ((XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2)))
     *               THEN
                     IF (DONEG) THEN
                        IF (VALUE.LT.0.) THEN
                           VALUE = VALUE + 360. * ABS (BPARM(7))
                        ELSE
                           VALUE = VALUE - 360. * ABS (BPARM(7))
                           END IF
                        DONEG = .FALSE.
                        GO TO 130
                        END IF
                  ELSE
                     NGOOD = NGOOD + 1
C                                       Mark point
                     IF (BLNKD) THEN
                        CALL GPOS (XY(1), XY(2), BUFFER, IERR)
                        BLNKD = .FALSE.
                     ELSE IF (DOCOLR) THEN
                        CALL G3VEC (XY(1), XY(2), BUFFER, IERR)
                     ELSE
                        CALL GVEC (XY(1), XY(2), BUFFER, IERR)
                        END IF
                     IF (IERR.NE.0) GO TO 970
                     END IF
                  END IF
 140           CONTINUE
            END IF
C                                       plot scan boundaries
         IF ((XSCAN.GT.0.0) .AND. (NOSCAN.GT.0)) THEN
            WRITE (TXTMSG,1150) NOSCAN
            CALL GCOMNT (-1, TXTMSG, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            ILITY = 2
            CALL GLTYPE (ILITY, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            AY(1) = XYSCL(2,KK) * (PRAN(1,2,KK)-XYOFF(2,KK)) +
     *         YYOFF(2)
            AY(2) = XYSCL(2,KK) * (PRAN(2,2,KK)-XYOFF(2,KK)) +
     *         YYOFF(2)
            IF (XSCAN.GE.1.5) AY(2) = AY(1) + 0.1*(AY(2)-AY(1))
            DO 160 I = 1,NOSCAN
               AX(1) = XYSCL(1,KK) * (TSCAN(I)*360.-XYOFF(1,KK)) +
     *            YYOFF(1)
               IF ((AX(1).GE.XBLC(1)) .AND. (AX(1).LE.XTRC(1))) THEN
                  CALL GPOS (AX(1), AY(1), BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  CALL GVEC (AX(1), AY(2), BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  END IF
 160           CONTINUE
            END IF
 190     CONTINUE
C                                       Plot multiple R values
      IF ((KK.EQ.1) .AND. (XINC.GT.0) .AND. (ABSICA.LT.0)) THEN
         RMAX = -100.
         RMIN = 100.
         DO 220 IST = LST1,LST2
C                                       find max min
            DO 210 NN = 1,1000
               IF (RTS(IST,ANTNO,NN).NE.0.0) THEN
                  NR(IST) = NN
                  RMAX = MAX (RMAX, RVALS(IST,ANTNO,NN))
                  RMIN = MIN (RMIN, RVALS(IST,ANTNO,NN))
                  END IF
 210           CONTINUE
 220        CONTINUE
         DX = MAX (RMAX-RMIN, 0.1)
         RMAX = RMAX + 0.1*DX
         RMIN = RMIN - 0.1*DX
         TR = (XTRC(2)-XBLC(2)) / (RMAX - RMIN)
C                                       plot
         ILITY = 2
         CALL GLTYPE (ILITY, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         WRITE (MSGTXT,1220) LST1, LST2, ANTNO, RMIN, RMAX
         CALL MSGWRT (2)
         DO 290 IST = LST1,LST2
            BLNKD = .TRUE.
            DO 230 NN = 1,NR(IST)
               XY(1) = RTS(IST,ANTNO,NN) * 360.0
               XY(1) = XYSCL(1,KK) * (XY(1) - XYOFF(1,KK)) + YYOFF(1)
               IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1)))
     *            GO TO 230
               VALUE = RVALS(IST,ANTNO,NN)
               IF (VALUE.EQ.FBLANK) THEN
                  BLNKD = .TRUE.
               ELSE
                  XY(2) = VALUE
                  XY(2) = TR * (VALUE - RMIN) + YYOFF(2)
                  IF ((XY(2).GE.XBLC(2)) .AND. (XY(2).LE.XTRC(2))) THEN
                     IF (BLNKD) THEN
                        CALL GPOS (XY(1), XY(2), BUFFER, IERR)
                        BLNKD = .FALSE.
                     ELSE
                        CALL GVEC (XY(1), XY(2), BUFFER, IERR)
                        END IF
                     IF (IERR.NE.0) GO TO 970
                  ELSE
                     BLNKD = .TRUE.
                     END IF
                  END IF
 230           CONTINUE
            DO 240 NN = 1,NR(IST)
               XY(1) = RTS(IST,ANTNO,NN) * 360.0
               XY(1) = XYSCL(1,KK) * (XY(1) - XYOFF(1,KK)) + YYOFF(1)
               IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1)))
     *            GO TO 240
               VALUE = RVALS(IST,ANTNO,NN)
               IF (VALUE.NE.FBLANK) THEN
                  XY(2) = TR * (VALUE - RMIN) + YYOFF(2)
                  IF ((XY(2).GE.XBLC(2)) .AND. (XY(2).LE.XTRC(2))) THEN
C                                       Mark point
                     DY = 5.0 * FACTOR
                     DX = 5.0 * FACTOR
                     IF (XYRATO.GT.1.0) THEN
                        DY = DY * XYRATO
                     ELSE
                        DX = DX / XYRATO
                        END IF
                     AX(1) = XY(1)
                     AY(1) = XY(2)
                     AX(2) = AX(1)
                     AX(3) = AX(1)
                     AX(4) = AX(1) - DX
                     AX(5) = AX(1) + DX
                     AY(2) = AY(1) + DY
                     AY(3) = AY(1) - DY
                     AY(4) = AY(1)
                     AY(5) = AY(1)
                     CALL PNTPLT (3, AX, AY, XBLC, XTRC, .FALSE.,
     *                  .FALSE., BUFFER, IERR)
                     END IF
                  END IF
 240           CONTINUE
 290        CONTINUE
         END IF
C                                       Done: finish plot
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      IF ((IPLOT.LT.0) .OR. ((ABS(IPLOT).GE.NCOUNT) .AND. (DOLAB.GT.1)))
     *   THEN
         GPHPAG = IPLOT.GT.0
         CALL GFINIS (BUFFER, IERR)
         IF (IERR.GT.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
            IERR = 0
            END IF
         END IF
      IF (IERR.GT.0) GO TO 975
         IRET = IERR
         GO TO 999
C                                       ZPHFIL or GINIT failure.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      IF (.NOT.DOTV) THEN
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
      GO TO 999
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      GPHPAG = IPLOT.GT.0
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.NE.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
            IERR = 0
            END IF
         GO TO 999
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Plot file version',I4,'  created.')
 1010 FORMAT (A2,I4,'__',A2,I4,'_')
 1021 FORMAT ('___',A2,' IF ',I2)
 1022 FORMAT ('___',A2,' IF ',A)
 1025 FORMAT ('Refant',I3)
 1026 FORMAT (I3,' - ',I2)
 1030 FORMAT ('Plot file version',I4,'__created ',A, A)
 1040 FORMAT (I3)
 1050 FORMAT (' _R=',F6.3)
 1150 FORMAT ('Plotting',I4,' scan breaks')
 1200 FORMAT ('PLTSN:',I9,' points plotted')
 1202 FORMAT ('PLTSN:',I9,' points did not fit')
 1220 FORMAT ('Corr coeff: stokes',2I2,' ant',I4,' range',2F7.3)
 1960 FORMAT ('PLTSN: ERROR DURING GRAPH FILE CREATION')
 1970 FORMAT ('PLTSN: ERROR DURING GRAPHING. WILL TRY TO FINISH ',
     *   'PARTIAL GRAPH')
      END
      SUBROUTINE PLTSY (NV, ANTNO, IST, RV, SYPTS, SNPTS, IRET)
C-----------------------------------------------------------------------
C   PLTSY actually plots data.
C   Input:
C      NV       I      Number values
C      ANTNO    I      Antenna number
C      IST      I      Stokes
C      RV       R      Correlation coeff
C      SYPTS    R(*)   SY Data to plot (NV,*)
C      SnPTS    R(*)   Sn Data to plot (NV,*)
C   Output:
C      IRET     I      Return code, 0 => OK, otherwise abort.
C                       -1 => user request termination
C                        1 => failed to add to catalog
C                        2 => failed to create
C                        3 => graph file write error
C                        4 => UV file IO error
C-----------------------------------------------------------------------
      INTEGER   NV, ANTNO, IST, IRET
      REAL      RV, SYPTS(NV), SNPTS(NV)
C
      INCLUDE 'SYVSN.INC'
C
      CHARACTER TEXT*132, PFILE*48, ATIME*8, ADATE*12, CHTMP*18,
     *   AUNITS(NCODE)*8, CHTYPE(NCODE)*16, STEXT*16
      INTEGER   BUFFER(256), VER, IERR, ITYPE, IPSIZE, LUNPL, LTYPE,
     *   FINDPL, DEPTH(5), INCHAR, INP, IT(3), ID(3), I, NGOOD, NNOFIT,
     *   NN, IP, ILITY, IPLOT
      REAL      BLC(2), TRC(2), DX, DY, TR, TI, XY(2), XTRC(2), XBLC(2),
     *   TLC(2), PLTINC, YYOFF(2), SIZE, XMULT(2), DBY, COLV, AX(5),
     *   AY(5)
      LOGICAL   T, F, GOOD, CATUP, SCOLOR, DOCOLR
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      SAVE XMULT, LTYPE, BUFFER
      DATA LUNPL /26/
      DATA DEPTH /5*1/
      DATA T, F /.TRUE.,.FALSE./
      DATA AUNITS /'Kelvin', 'Counts', 'Counts', 'Degrees', 'Seconds',
     *   'Gain', 'Kelvin', 'Kelvin'/
      DATA CHTYPE /'Psys', 'Power sum', 'Power diff', 'Gain phs',
     *   'Delay', 'Gain amp', 'Tsys', 'Tant'/
C-----------------------------------------------------------------------
      IPLOT = 1
      IF (ABS(APARM(8)-1.0).LT.0.1) AUNITS(1) = 'Ratio-1'
      IF (ABS(APARM(8)-1.0).LT.0.1) AUNITS(2) = 'Ratio-1'
      IF (ABS(APARM(8)-1.0).LT.0.1) AUNITS(3) = 'Ratio-1'
      NGOOD = 0
      NNOFIT = 0
      IRET = 3
      CATUP = T
      NCODES = 2
C                                       get the scales
      CALL SCALIT (NV, SYPTS, SNPTS)
C                                       Create plot file
C                                       Update catalog header.
      VER = 0
      IRET = 1
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', DISKIN, CNOIN, CATBLK, BUFFER, CATUP,
     *      'WRIT', VER, IERR)
         IF (IERR.NE.0) THEN
            NCFILE = NCFILE - 1
            GO TO 999
            END IF
         END IF
      CALL ZPHFIL ('PL', DISKIN, CNOIN, VER, PFILE, IERR)
      IF (IERR.NE.0) GO TO 960
      IPSIZE = 0
      ITYPE = 58
      CALL GINIT (DISKIN, CNOIN, PFILE, IPSIZE, ITYPE, NPARMS,
     *   XNAMEI, DOTV, TVCHN, GRCHN, TVCORN, CATBLK, BUFFER, LUNPL,
     *   FINDPL, IERR)
      IRET = 2
      IF (IERR.NE.0) GO TO 960
C                                       Graph drawing parameters.
      BLC(1) = 0.0
      BLC(2) = 0.0
      TRC(1) = 1000.0
      TRC(2) = 1000.0
      IF (DOTV) THEN
         TRC(1) = WINDTV(3) - WINDTV(1)
         TRC(2) = WINDTV(4) - WINDTV(2)
         CALL GCINIT (GPHTVG(4), 0, IERR)
         IF (IERR.NE.0) GO TO 960
         CALL GCINIT (GPHTVG(3), 0, IERR)
         IF (IERR.NE.0) GO TO 960
         CALL GCINIT (GPHTVG(2), 0, IERR)
         IF (IERR.NE.0) GO TO 960
         END IF
      PLTINC = TRC(2)
      IF (XYRATO.LT.0.01) XYRATO = 1.0
C                                       Set window for current plot.
      XBLC(1) = BLC(1)
      XBLC(2) = BLC(2)
      XTRC(1) = TRC(1)
      XTRC(2) = TRC(2)
      TLC(1) = XBLC(1)
      TLC(2) = XTRC(2)
C                                       Offsets for current plot.
      YYOFF(1) = XBLC(1)
      YYOFF(2) = XBLC(2)
C                                       fool with location common
      LOCNUM = 1
      ROT(LOCNUM) = 0.0
      CORTYP(LOCNUM) = 0
      LABTYP(LOCNUM) = 0
      AXTYP(LOCNUM) = 0
      TR = 1.1 * (PRAN(2,2,1)-PRAN(1,2,1))
      IF (TR.LE.0.0) TR = 1.0
      TI = TR
      CALL METSCL (LABEL, TR, CPREF(1,LOCNUM), GOOD)
      XMULT(1) = TR / TI
      TR = 1.1 * (PRAN(2,2,2)-PRAN(1,2,2))
      IF (TR.LE.0.0) TR = 1.0
      TI = TR
      CALL METSCL (LABEL, TR, CPREF(2,LOCNUM), GOOD)
      XMULT(2) = TR / TI
      DO 50 I = 1,2
         SIZE = XTRC(I) - XBLC(I) + 1
         TR = PRAN(2,2,I) - PRAN(1,2,I)
         XYSCL(2,I) = (XTRC(I) - XBLC(I)) / TR
         RPLOC(I,LOCNUM) = XBLC(I)
         RPVAL(I,LOCNUM) = XYOFF(2,I) * XMULT(I)
         AXINC(I,LOCNUM) = TR * XMULT(I) / (XTRC(I) - XBLC(I))
 50      CONTINUE
      CTYP(1,LOCNUM) = AUNITS(ICODES(1))
      CTYP(2,LOCNUM) = AUNITS(ICODES(2))
C                                       Init plot calls again
C                                       Number of characters on each
C                                       side of the plot
      CALL RFILL (4, 0.5, CHOUT)
C                                       Not fully initialized, may make
C                                       INP too large which is okay.
      CALL CHNTIC (XBLC, XTRC, INP)
      INP = MAX (INP, 3)
      INP = MAX (INP, 7)
      LTYPE = MOD (ABS (LABEL), 100)
      IF (LTYPE.EQ.2) CHOUT(1) = 2.5
      IF (LTYPE.GT.2) CHOUT(1) = INP + 4
      IF (LTYPE.GT.1) CHOUT(2) = 2.0
      IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = 4.666
      IF ((LABEL.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7))
     *   CHOUT(4) = CHOUT(4) + 1.333
C                                       Init for line drawing.
      CALL GINITL (BLC, TRC, XYRATO, CHOUT, DEPTH, BUFFER, IERR)
      IRET = 3
      IF (IERR.NE.0) GO TO 970
      IF (.NOT.DOTV) THEN
         WRITE (MSGTXT,1000) VER
         CALL MSGWRT (2)
         END IF
      IRET = 3
      CATUP = T
C                                       Draw border
      ILITY = 1
      CALL GLTYPE (ILITY, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XBLC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XTRC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL GVEC (XBLC(1), XTRC(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Top labels: type & name
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         DX = 0.0
         DY = 0.5 + 2 * 1.333
C                                       The second line of the header
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         INCHAR = 16
         INP = 1
         TEXT = CHTYPE(ICODES(1))
         CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
         IF (ABS(APARM(8)-1.0).LT.0.1) THEN
            TEXT(INP+1:) = ' ratio'
            INP = INP + 6
            END IF
         TEXT(INP+1:) = ' vs ' // CHTYPE(ICODES(2))
         INCHAR = 40
         CALL CHTRIM (TEXT, INCHAR, TEXT, INP)
         INP = INP + 1
C                                       File name
         CALL H2CHR (18, KHIMNO, CATH(KHIMN), CHTMP)
         CALL H2CHR (6, KHIMCO, CATH(KHIMC), CHTMP(13:18))
         CALL NAMEST (CHTMP, CATBLK(KIIMS), TEXT(INP:), INCHAR)
         CALL REFRMT (TEXT, ' ', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       the third line of header
         DY = 0.5
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         INP = 1
         WRITE (TEXT(INP:),1010) SYTYPE, ITVER(1), 'SN', ITVER(2)
         INP = INP + 16
C                                       Stokes and IF
         IF (SUMSTK.GT.0) THEN
            TEXT(INP:) = XSTOK(:1) // 'pol_'
            INP = INP + 7
         ELSE
            TEXT(INP:) = 'Rpol & Lpol_'
            IF (ICOR0.LT.-4) TEXT(INP:) = 'Vpol & Hpol_'
            INP = INP + 14
            END IF
         IF (BIFS(1,1).EQ.EIFS(1,1)) THEN
            WRITE (TEXT(INP:),1021) SYTYPE, BIFS(1,1)
            INP = INP + 12
         ELSE
            WRITE (STEXT,1026) BIFS(1,1), EIFS(1,1)
            CALL REBLNK (STEXT, INCHAR)
            WRITE (TEXT(INP:),1022) SYTYPE, STEXT(:INCHAR)
            INP = INP + 9 + INCHAR
            END IF
         IF (BIFS(1,2).EQ.EIFS(1,2)) THEN
            WRITE (TEXT(INP:),1021) 'SN', BIFS(1,2)
            INP = INP + 12
         ELSE
            WRITE (STEXT,1026) BIFS(1,2), EIFS(1,2)
            CALL REBLNK (STEXT, INCHAR)
            WRITE (TEXT(INP:),1022) 'SN', STEXT(:INCHAR)
            INP = INP + 9 + INCHAR
            END IF
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       refant, baseline
         DY = 0.5 + 1.333
         CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         INP = 9
         IF (REFANT.GT.0) THEN
            WRITE (TEXT,1025) REFANT
         ELSE
            TEXT = 'No refant'
            END IF
         IF (BIFS(2,1).LE.EIFS(2,1)) THEN
            TEXT(INP+1:) = '__SY Baseline IFs'
            INP = INP + 18
            WRITE (STEXT,1026) BIFS(2,1), EIFS(2,1)
            CALL REBLNK (STEXT, INCHAR)
            TEXT(INP+1:) = STEXT(:INCHAR)
            INP = INP + INCHAR
            IF (BIFS(3,1).LE.EIFS(3,1)) THEN
               TEXT(INP+1:) = ' + '
               INP = INP + 3
               WRITE (STEXT,1026) BIFS(3,1), EIFS(3,1)
               CALL REBLNK (STEXT, INCHAR)
               TEXT(INP+1:) = STEXT(:INCHAR)
               INP = INP + INCHAR
               END IF
         ELSE
            TEXT(INP+1:) = '___No SY basline IFs'
            INP = INP + 20
            END IF
         IF (BIFS(2,2).LE.EIFS(2,2)) THEN
            TEXT(INP+1:) = '__SN Baseline IFs'
            INP = INP + 18
            WRITE (STEXT,1026) BIFS(2,2), EIFS(2,2)
            CALL REBLNK (STEXT, INCHAR)
            TEXT(INP+1:) = STEXT(:INCHAR)
            INP = INP + INCHAR
            IF (BIFS(3,2).LE.EIFS(3,2)) THEN
               TEXT(INP+1:) = ' + '
               INP = INP + 3
               WRITE (STEXT,1026) BIFS(3,2), EIFS(3,2)
               CALL REBLNK (STEXT, INCHAR)
               TEXT(INP+1:) = STEXT(:INCHAR)
               INP = INP + INCHAR
               END IF
         ELSE
            TEXT(INP+1:) = '___No SN basline IFs'
            END IF
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       Date/time/version
         IF ((LABEL.GT.0) .AND. (LTYPE.GT.1)) THEN
            DY = 0.5 + 3 * 1.333
C                                       the first line of the header
            CALL GPOS (BLC(1), TRC(2), BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (TEXT,1030) VER, ADATE, ATIME
            CALL REFRMT (TEXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
C                                       station ID
         CALL GPOS (XBLC(1), XTRC(2), BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         DX =  1.5
         DY = -1.8
         WRITE (TEXT,1040) ANTNO
         INP = 4
         IF (MUMPOL.LE.1) THEN
            TEXT(INP:) = XSTOK(:1)
            INP = INP + 1
         ELSE
            IF (ICOR0.LT.-4) THEN
               TEXT(INP:) = 'V'
               IF (IST.EQ.2) TEXT(INP:) = 'H'
            ELSE
               TEXT(INP:) = 'R'
               IF (IST.EQ.2) TEXT(INP:) = 'L'
               END IF
            INP = INP + 1
            END IF
         TEXT(INP+1:) = STNNAM(ANTNO)
         CALL CHTRIM (TEXT, 132, TEXT, INCHAR)
         IF (SAMTYP.NE.' ') WRITE (TEXT(INCHAR+1:),1050) RV
         CALL REFRMT (TEXT, '_', INCHAR)
         CALL GICHAR (1, INCHAR, 0, DX, DY, TEXT, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Put on labels and ticks
      IF (1.NE.ILITY) THEN
         ILITY = 1
         CALL GLTYPE (ILITY, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
      CALL CLAB1 (XBLC, XTRC, CHOUT, LABEL, XYRATO, F, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Size of symbol.
      DBY = 0.5 * FACTOR
C                                       Loop
      ILITY = 4
      CALL GLTYPE (ILITY, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      DOCOLR = SCOLOR
C                                       Outer loop: IF, stokes
      COLV = 0.0
      IP = IST + 2
C                                       Point plot
      DO 120 NN = 1,NV
C                                       Scale X
         IF ((SNPTS(NN).NE.FBLANK) .AND. (SYPTS(NN).NE.FBLANK)) THEN
            XY(1) = SYPTS(NN)
            XY(1) = XYSCL(2,1) * (XY(1) - XYOFF(2,1)) + YYOFF(1)
            IF ((XY(1).LT.XBLC(1)) .OR. (XY(1).GT.XTRC(1))) THEN
               NNOFIT = NNOFIT + 1
               GO TO 120
               END IF
C                                       loop for points
            XY(2) = SNPTS(NN)
            XY(2) = XYSCL(2,2) * (XY(2) - XYOFF(2,2)) + YYOFF(2)
            IF ((XY(2).LT.XBLC(2)) .OR. (XY(2).GT.XTRC(2))) THEN
               NNOFIT = NNOFIT + 1
            ELSE
               NGOOD = NGOOD + 1
C                                       Mark point
               DY = 5.0 * FACTOR
               DX = 5.0 * FACTOR
               IF (XYRATO.GT.1.0) THEN
                  DY = DY * XYRATO
               ELSE
                  DX = DX / XYRATO
                  END IF
               AX(1) = XY(1)
               AY(1) = XY(2)
               AX(2) = AX(1)
               AX(3) = AX(1)
               AX(4) = AX(1) - DX
               AX(5) = AX(1) + DX
               AY(2) = AY(1) + DY
               AY(3) = AY(1) - DY
               AY(4) = AY(1)
               AY(5) = AY(1)
               IF (ILITY.NE.4) THEN
                  ILITY = 4
                  CALL GLTYPE (ILITY, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 970
                  END IF
               CALL PNTPLT (ISYM(IST), AX, AY, XBLC, XTRC, .FALSE.,
     *            DOCOLR, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               END IF
         ELSE IF (BSYM.GT.0) THEN
            DY = 5.0 * FACTOR
            DX = 5.0 * FACTOR
            IF (XYRATO.GT.1.0) THEN
               DY = DY * XYRATO
            ELSE
               DX = DX / XYRATO
               END IF
            XY(2) = XBLC(2) + DY
            AX(1) = XY(1)
            AY(1) = XY(2)
            AX(2) = AX(1)
            AX(3) = AX(1)
            AX(4) = AX(1) - DX
            AX(5) = AX(1) + DX
            AY(2) = AY(1) + DY
            AY(3) = AY(1) - DY
            AY(4) = AY(1)
            AY(5) = AY(1)
            IF (ILITY.NE.3) THEN
               ILITY = 3
               CALL GLTYPE (ILITY, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 970
               END IF
            CALL PNTPLT (BSYM, AX, AY, XBLC, XTRC, .FALSE.,
     *         DOCOLR, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 970
            END IF
 120     CONTINUE
C                                       Done: finish plot
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      GPHPAG = .TRUE.
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.GT.0) GO TO 975
      IF (.NOT.DOTV) THEN
         CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
         IERR = 0
         END IF
      IF (IERR.GT.0) GO TO 975
         IRET = IERR
         GO TO 999
C                                       ZPHFIL or GINIT failure.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      IF (.NOT.DOTV) THEN
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
      GO TO 999
C                                       Try to finish partial graph
 970  WRITE (MSGTXT,1970)
      CALL MSGWRT (6)
      WRITE (MSGTXT,1200) NGOOD
      CALL MSGWRT (2)
      IF (NNOFIT.GE.1) THEN
         WRITE (MSGTXT,1202) NNOFIT
         CALL MSGWRT (2)
         END IF
      GPHPAG = .TRUE.
      CALL GFINIS (BUFFER, IERR)
      IF (IERR.NE.0) GO TO 975
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (DISKIN, CNOIN, VER, BUFFER, IERR)
            IERR = 0
            END IF
         GO TO 999
C                                       Destroy the plot file
 975  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (LUNPL, FINDPL, IERR)
         CALL ZDESTR (DISKIN, PFILE, IERR)
         CALL DELEXT ('PL', DISKIN, CNOIN, 'WRIT', CATBLK, BUFFER,
     *      VER, IERR)
         NCFILE = NCFILE - 1
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Plot file version',I4,'  created.')
 1010 FORMAT (A2,I4,'__',A2,I4,'_')
 1021 FORMAT ('___',A2,' IF ',I2)
 1022 FORMAT ('___',A2,' IF ',A)
 1025 FORMAT ('Refant',I3)
 1026 FORMAT (I3,' - ',I2)
 1030 FORMAT ('Plot file version',I4,'__created ',A, A)
 1040 FORMAT (I3)
 1050 FORMAT (' _R=',F6.3)
 1200 FORMAT ('PLTSY:',I9,' points plotted')
 1202 FORMAT ('PLTSY:',I9,' points did not fit')
 1960 FORMAT ('PLTSY: ERROR DURING GRAPH FILE CREATION')
 1970 FORMAT ('PLTSY: ERROR DURING GRAPHING. WILL TRY TO FINISH ',
     *   'PARTIAL GRAPH')
      END
      SUBROUTINE SCALIT (NV, SYPTS, SNPTS)
C-----------------------------------------------------------------------
C   Finds scales for SN vs SY plot
C   Inputs:
C      NV      I      Number samples
C      SYPTS   R(*)   SY data on regular grid
C      SNPTS   R(*)   SN data on same regular grid
C   Outputs in COMMON
C      XYOFF   R(2,*)   TMIN: (2,1) SY (2,2) SN
C      XYSCL   R(2,*)   1000/(tmax-tmin) as above
C      PRAN    R(2,2,*)   (1,2,1) SY TMIN (1,2,2) SN TMIN (2,2,1) SYTMAX
C-----------------------------------------------------------------------
      INTEGER   NV
      REAL      SYPTS(*), SNPTS(*)
C
      INCLUDE 'SYVSN.INC'
      INTEGER   I, KK
      REAL      YMX, YMN, PMX, PMN, TMAX, TMIN, TDIF, XXMX, XXMN, PH,
     *   TOLER(8)
      INCLUDE 'INCS:DDCH.INC'
C                                       Minimum value range for each
C                                       ICODE
C                  Psum  Psys  Pdif   Phs    Delay    Amp     Tsys
      DATA TOLER /0.001, 0.01, 0.001, 0.001, 1.0E-12, 0.001, 0.001,
C        Tant
     *   0.000001/
C-----------------------------------------------------------------------
      YMX = -1.E8
      YMN = -YMX
      PMX = YMX
      PMN = YMN
      XXMX = YMX
      XXMN = YMN
      DO 20 I = 1,NV
         IF ((SYPTS(I).NE.FBLANK) .AND. (SNPTS(I).NE.FBLANK)) THEN
            XXMX = MAX (XXMX, SYPTS(I))
            XXMN = MIN (XXMN, SYPTS(I))
            YMX = MAX (YMX, SNPTS(I))
            YMN = MIN (YMN, SNPTS(I))
            IF (ICODES(2).EQ.4) THEN
               PH = SNPTS(I)
               IF (PH.LT.0.0) PH = PH + 360.0
               PMX = MAX (PMX, PH)
               PMN = MIN (PMN, PH)
               END IF
            END IF
 20      CONTINUE
C                                       phase 0 -> 360 ??
      IF ((ICODES(2).EQ.4) .AND. (PMX-PMN.LT.YMX-YMN)) THEN
         YMX = PMX
         YMN = PMN
         DO 25 I = 1,NV
            IF (SNPTS(I).LT.0.0) SNPTS(I) = SNPTS(I) + 360.0
 25         CONTINUE
         END IF
      KK = 1
      TMAX = XXMX + 0.05 * (XXMX - XXMN)
      TMIN = XXMN - 0.05 * (XXMX - XXMN)
      IF (ABS (TMAX-TMIN) .LT. TOLER(ICODES(KK))) THEN
         TMAX = TMAX + TOLER(ICODES(KK))
         TMIN = TMIN - TOLER(ICODES(KK))
         END IF
      TDIF = TMAX - TMIN
      IF (ABS (TDIF).LE.1.0E-25) TDIF = 1.0E-25
      XYOFF(2,KK) = TMIN
      XYSCL(2,KK) = 1000.0 / TDIF
      PRAN(1,2,KK) = TMIN
      PRAN(2,2,KK) = TMAX
      KK = 2
      TMAX = YMX + 0.05 * (YMX - YMN)
      TMIN = YMN - 0.05 * (YMX - YMN)
      IF (ABS (TMAX-TMIN) .LT. TOLER(ICODES(KK))) THEN
         TMAX = TMAX + TOLER(ICODES(KK))
         TMIN = TMIN - TOLER(ICODES(KK))
         END IF
      TDIF = TMAX - TMIN
      IF (ABS (TDIF).LE.1.0E-25) TDIF = 1.0E-25
      XYOFF(2,KK) = TMIN
      XYSCL(2,KK) = 1000.0 / TDIF
      PRAN(1,2,KK) = TMIN
      PRAN(2,2,KK) = TMAX
C
 999  RETURN
      END
      SUBROUTINE XCALC (XVARIB, XSOU)
C-----------------------------------------------------------------------
C  Routine to use the source and antenna geometry information in order
C  to return the requested value of the x-variable against which the
C  data is to be plotted.
C  Inputs (in common):
C    XVAR        I       Type of variable to calculate:
C                        1 = time (easy)
C                        2 = source elevation
C                        3 = HA
C                        4 = LST
C                        5 = Parallactic angle
C                        6 = Azimuth
C  Output:
C    XVARIB      R       Value of requested variable
C                        Time, LST (days)
C                        Elevation, HA (degrees)
C    XSOU        I       source number
C----------------------------------------------------------------------
      REAL    XVARIB, XSOU
C
      REAL    HA, EL, PA, AZ, TT
      INTEGER IERR, ISLUN, CSOU, I
      DOUBLE PRECISION LST, TIME, LTIME, DRA, DDEC
      LOGICAL PLANET
      INCLUDE 'SYVSN.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      SAVE LTIME, DRA, DDEC
      DATA ISLUN /25/
      DATA LTIME /-1.D0/
C-----------------------------------------------------------------------
      CSOU = GNRECI(SOUKOL)
      XSOU = CSOU
C                                      Time
      IF (KOLTYP(CLTIME).EQ.1) THEN
         TIME = GNRECD(TIMKOL)
      ELSE
         TIME = GNREC(TIMKOL)
         END IF
      IF (XVAR.EQ.1) THEN
         XVARIB = TIME
         GO TO 999
         END IF
C
C                                      Get source parameters
      IF ((OSOU.EQ.-1) .OR. (CSOU.NE.OSOU) .OR. (TIME.GT.LTIME)) THEN
         I = MSGSUP
         MSGSUP = 32000
         TT = TIME
         CALL FNDCOO (0, JD0, CSOU, DISKIN, CNOIN, CATBLK, ISLUN, TT,
     *      DRA, DDEC, PLANET, IERR)
         MSGSUP = I
         OSOU = CSOU
         LTIME = TIME
         END IF
C                                      Geometry parameters
      CALL ANTGEO (IANT, TIME, DRA, DDEC, HA, EL, LST, PA, AZ)
      IF (XVAR.EQ.2) THEN
         XVARIB = EL * RAD2DG
      ELSE IF (XVAR.EQ.3) THEN
         XVARIB = HA / TWOPI
      ELSE IF (XVAR.EQ.4) THEN
         XVARIB = LST / TWOPI
      ELSE IF (XVAR.EQ.5) THEN
         XVARIB = PA * RAD2DG
      ELSE IF (XVAR.EQ.6) THEN
         XVARIB = AZ * RAD2DG
         IF (XVARIB.LT.0.0) XVARIB = XVARIB + 360.0
         END IF
      IF (EL.LT.0.0) XVARIB = FBLANK
C
 999  RETURN
      END
      SUBROUTINE ANTGEO (ANTNO, TIME, DRA, DDEC, HA, EL, ANTLST, PA, AZ)
C-----------------------------------------------------------------------
C   Subroutine to compute the apparent source elevations based on source
C   and antenna coordinates in common.  The routines GETANT and GETSOU
C   should be called before this routine to put the correct values in
C   the relevant commons.
C   Inputs:
C      ANTNO      I    Antenna number
C      TIME       D    Current data time (days).
C      DRA        D    Apparent RA of source
C      DDEC       D    Apparent Declination of source.
C   Input from common:
C      STNLAT     D(*) Antenna latitude (rad).
C      STNLON     D(*) Antenna east longitudes (rad).
C      GSTIAT     D    GST at IAT=0 of reference day (rad).
C      ROTIAT     D    Rotation of the earth rate in IAT.
C   Output:
C      HA         R    Source hour angle (rad)
C      EL         R    Source elevation (rad)
C      ANTLST     D    Antenna LST (rad)
C      PA         R    Parallactic angle (rad)
C      AZ         R    Azimuth (rad)
C-----------------------------------------------------------------------
      INTEGER   ANTNO
      DOUBLE PRECISION TIME, ANTLST, DRA, DDEC
      REAL      HA, EL, PA, AZ
C
      LOGICAL   ISVLA
      DOUBLE PRECISION HRANG, ARLONG, ARLAT, DARG, DARG2, DAZ
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANS.INC'
C-----------------------------------------------------------------------
C                                       Antenna LST
      ANTLST = GSTIAT + STNLON(ANTNO) + TIME * ROTIAT
C                                       Hour angle
      HRANG = ANTLST - DRA
      HRANG = DMOD (HRANG, TWOPI)
      IF (HRANG.GT.PI) HRANG = HRANG - TWOPI
      IF (HRANG.LT.-PI) HRANG = HRANG + TWOPI
      HA = HRANG
C                                       Elevation angle
      DARG = SIN (STNLAT(ANTNO)) * SIN (DDEC) + COS (STNLAT(ANTNO))
     *   * COS (DDEC) * COS (HRANG)
      EL = (PI/2.0D0 - ACOS (DARG))
C                                       AZ = ATAN2(SD*CL - CD*SL*CH,
C                                       CD*SH)
      DARG = SIN (DDEC) * COS (STNLAT(ANTNO)) -
     *       COS (DDEC) * SIN (STNLAT(ANTNO)) * COS(HRANG)
      DARG2 = COS (DDEC) * SIN (HRANG)
      DAZ = ATAN2 (DARG, DARG2)
      DAZ = MOD (DAZ - PI/2.0D0, TWOPI)
      IF (DAZ.LT.0.0D0) DAZ = DAZ + TWOPI
      AZ = DAZ
C                                       Is this the VLA?
      ISVLA = (ABS (CNTRX + 1.601162D6) .LE. 10.0D0) .AND.
     *   (ABS (CNTRY + 5.042003D6) .LE. 10.0D0) .AND.
     *   (ABS (CNTRZ - 3.554915D6) .LE. 10.0D0)
C                                       All VLA antennas have the same
C                                       parallactic angle.
      PA = 0.0
      IF (ISVLA) THEN
         ARLONG = ATAN2 (CNTRY, CNTRX)
         ARLAT = ASIN (CNTRZ / SQRT (CNTRX*CNTRX + CNTRY*CNTRY +
     *      CNTRZ*CNTRZ))
      ELSE
         ARLONG = STNLON(ANTNO)
         ARLAT = STNLAT(ANTNO)
         END IF
C                                       Dont compute Equatorial or space
      IF ((MNTYP(ANTNO).NE.1) .AND. (MNTYP(ANTNO).NE.2)) THEN
C                                       Antenna LST
         HRANG = GSTIAT + ARLONG + TIME * ROTIAT
C                                       Hour angle
         HRANG = HRANG - DRA
C                                       Parallactic angle
         PA = ATAN2 (COS (ARLAT) * SIN (HRANG),
     *     (SIN (ARLAT) * COS (DDEC) -
     *     COS (ARLAT) * SIN (DDEC) * COS(HRANG)))
C                                       EW-mount
         IF (MNTYP(ANTNO).EQ.3) THEN
            PA =  ATAN2 (COS(HRANG), SIN(HRANG)*SIN(DDEC))
C                                       Right  Nasmyth
         ELSE IF (MNTYP(ANTNO).EQ.4) THEN
            PA = PA + EL
C                                       Left Nasmyth
         ELSE IF (MNTYP(ANTNO).EQ.5) THEN
            PA = PA -EL
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE FNDSOU (DISK, CNO, SOURCS, BUFFER, NSOUWD, DOSWNT,
     *   SOUWAN, IERR)
C-----------------------------------------------------------------------
C! Find source numbers for a list of sources.
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Fills in arrays of source numbers to be included or excluded.
C   Inputs:
C      DISK         I    Input disk number.
C      CNO          I    Catalog slot number
C      SOURCS(30)   C*16 Names of up to 30 sources, *=>all
C                        First character of name '-' => all except those
C                        specified.
C   Input from common /MAPHDR/
C      CATBLK(256)  I    Catalog header record.
C   Input/Output:
C      BUFFER(512)  I    I/O Buffer for source (SU) table
C   Output:
C      NSOUWD       I    Number of sources included or excluded; if
C                        0 all sources are included.
C      DOSWNT       L    If .TRUE. then sources in SOUWAN are included
C                        If .FALSE. then excluded.
C      SOUWAN(30)   I    The source numbers of sources included or
C                        excluded.
C      IERR         I    Return code, 0=>OK, otherwise failed.
C   Note: uses AIPS LUN 29.
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, BUFFER(768), NSOUWD, SOUWAN(30), IERR
      LOGICAL   DOSWNT
      CHARACTER SOURCS(30)*16
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER VELDEF*8, VELTYP*8, CALCOD*4, SOUNAM*16
      INTEGER   CATBLK(256), JERR, IDSOU, SUKOLS(MAXSUC), IXLUN,
     *   SUNUMV(MAXSUC), QUAL, NUMIF, J, K, NSOURC, I, ISURNO, SUFQID,
     *   I1
      LOGICAL   T, F, TABLE, EXIST, FITASC, ALLSOU, ALLBLK
      DOUBLE PRECISION    BANDW, RAEPO, DECEPO, EPOCH, RAAPP, DECAPP,
     *   RAOBS, DECOBS, PMRA, PMDEC
      REAL      FLUX(4,MAXIF)
      DOUBLE PRECISION    LSRVEL(MAXIF), FREQO(MAXIF), LRESTF(MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      COMMON /MAPHDR/ CATBLK
      DATA T, F /.TRUE.,.FALSE./
      DATA IXLUN /29/
C-----------------------------------------------------------------------
C                                       See if SU file exists.
      CALL ISTAB ('SU', DISK, CNO, 1, IXLUN, BUFFER, TABLE, EXIST,
     *   FITASC, JERR)
      IF ((JERR.NE.0) .OR. (.NOT.TABLE) .OR. (.NOT.EXIST)) GO TO 800
C                                       Open SU table
      CALL SOUINI ('READ', BUFFER, DISK, CNO, 1, CATBLK, IXLUN,
     *   NUMIF, VELDEF, VELTYP, SUFQID, ISURNO, SUKOLS, SUNUMV, JERR)
      IF (JERR.LE.0) GO TO 20
         WRITE (MSGTXT,1000) JERR
         GO TO 990
C                                       Get number of sources.
 20   NSOURC = BUFFER(5)
C                                       Check if empty
      IF (NSOURC.LE.0) GO TO 800
      DOSWNT = T
      NSOUWD = 0
      ALLSOU = F
      ALLBLK = T
C                                       Check if source excluded
C                                       or if all are included
      DO 30 J = 1,30
C                                       Sources
         ALLSOU = ALLSOU .OR. (SOURCS(J)(1:1).EQ.'*')
C                                       Check for blanks
         ALLBLK = ALLBLK .AND. (SOURCS(J).EQ.' ')
C                                       Check for "-"
C                                       Minus sign NOT removed
         IF (SOURCS(J)(1:1).EQ.'-') DOSWNT = F
 30      CONTINUE
C                                       See if all blanks or "*"
      IF ((ALLBLK) .OR. (ALLSOU)) GO TO 900
C                                       Loop through records
      DO 100 I = 1,NSOURC
         IERR = 1
C                                       Read record
         CALL TABSOU ('READ', BUFFER, ISURNO, SUKOLS, SUNUMV,
     *      IDSOU, SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO,
     *      DECEPO, EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, LRESTF,
     *      PMRA, PMDEC, JERR)
C                                       Check error
         IF (JERR.LE.0) GO TO 35
            WRITE (MSGTXT,1020) JERR
            GO TO 990
 35      IERR = 0
C                                       Search list
         DO 80 J = 1,30
            I1 = 1
            IF (SOURCS(J)(1:1).EQ.'-') I1 = 2
C                                       Got one - redundancy check
            IF (SOURCS(J)(I1:).EQ.SOUNAM) THEN
               DO 40 K = 1,NSOUWD
                  IF (SOUWAN(K).EQ.IDSOU) GO TO 100
 40               CONTINUE
C                                       Add source
               NSOUWD = NSOUWD + 1
               SOUWAN(NSOUWD) = IDSOU
               GO TO 100
               END IF
 80         CONTINUE
C                                       No match
 100     CONTINUE
C                                       Should have found matches:
      IF (NSOUWD.GT.0) GO TO 900
      IERR = 9
      WRITE (MSGTXT,1100)
      GO TO 990
C                                       No SOURCE file
 800  IERR = 10
      WRITE (MSGTXT,1800)
      GO TO 990
C                                       Close file
 900  IF (JERR.LE.0) CALL TABIO ('CLOS', 0, I, BUFFER, BUFFER, IERR)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FNDSOU: ERROR',I3,' OPENING SOURCE TABLE')
 1020 FORMAT ('FNDSOU: ERROR',I3,' READING SOURCE TABLE')
 1100 FORMAT ('FNDSOU: NO SOURCES SPECIFIED FOUND IN SU TABLE')
 1800 FORMAT ('FNDSOU: NO SU TABLE WAS FOUND.')
      END

      SUBROUTINE BSCONV (NX, THROWP, THROWM, SCALE, IC, CONV)
C-----------------------------------------------------------------------
C! convolution function for centering a beam-switched image
C# Map-util singledish
C-----------------------------------------------------------------------
C;  Copyright (C) 1996, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;  Eric W, Greisen
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Computes a convolution function to use for combining the two images
C   Inputs:
C      NX       I      Number X points on row
C      THROWP   R      Throw of "plus" image in cells
C      THROWM   R      Throw of "minus" image in cells
C      SCALE    R      Scale plus image wrt minus image
C      IC       I      Index in CONV for x = 0
C   Outputs:
C      CONV     R(*)   Convolution function
C   Restricted to throws that are integer multiples of AXV for now.
C-----------------------------------------------------------------------
      INTEGER   NX, IC
      REAL      THROWP, THROWM, SCALE, CONV(*)
C
      INTEGER   IP, J, IX, N
      REAL      V, VS, X, S, Y, XK, XF
      DOUBLE PRECISION DY
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      CALL RFILL (2*NX, 0.0, CONV)
C                                       get throws, scale
      VS = SCALE
      IF (VS.LE.0.0) VS = 1.0
      S = ABS (THROWM - THROWP)
      IF (THROWM.GT.THROWP) THEN
         XF = 0.5
      ELSE
         XF = -0.5
         END IF
      N = NX / S + 1
      IC = NX + 1
      IP = 2*NX+1
      DO 20 IX = 1,IP
         CONV(IX) = 0.0
         X = IX - IC
         DO 10 J = -N,N+1
            XK = 2*J - 1
            DY = (X - XK * S / 2.0) * PI
            IF (ABS(DY).LT.1.D-7) THEN
               Y = 1.0
            ELSE
               Y = SIN (DY) / DY
               END IF
            CONV(IX) = CONV(IX) + Y * XF * SIGN (1.0, XK)
 10         CONTINUE
 20      CONTINUE
C                                       scale
      IF (VS.NE.1.0) THEN
         DO 30 IX = 1,NX
            V = VS ** (IX/S)
            CONV(IC+IX) = CONV(IC+IX) * V
            CONV(IC-IX) = CONV(IC-IX) / V
 30         CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZPTBIT (NBITS, WORD, BITS)
C-----------------------------------------------------------------------
C! put array of bits into a word
C# Z Service
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Build WORD from NBITS bit values contained in the array BITS, where
C   BITS[1] supplies the lsb, BITS[2] the next higher bit, etc.  The
C   rest of the bits in WORD are set to zero.  For example, if
C
C   bits[1:*] = 0 1 1 1 0 1 0 1 ... 0 1 1 1 0 0 0 0
C               ^                                 ^
C              LSB                               MSB
C   and NBITS = 4, then WORD = 14 (decimal)
C   Inputs:
C      NBITS   I      Number of bits to use from the array "bits"
C      BITS    I(*)   Array of bit values (0 or 1)
C   Output:
C      WORD    I      Result containing bit pattern from the first
C                     "nbits" values of the array "bits"
C   Generic version - stub
C-----------------------------------------------------------------------
      INTEGER   NBITS, WORD, BITS(*)
C
      INTEGER   I, L
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      IF (NBITS.GT.0) THEN
         L = NBITS + 1
         L = MIN (L, NBITWD) - 1
         WORD = 0
         DO 10 I = 1,L
            IF (BITS(I).GT.0) WORD = WORD + 2 ** (I-1)
 10         CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE ZX8XL (NBIT, INB, OUTB)
C-----------------------------------------------------------------------
C! convert FITS table bit array to AIPS bit array
C# FITS
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZXLX8 converts an FITS table bit array to an AIPS bit array. An AIPS
C   bit array has the bits in locations of increasing signifigance
C   NBITWD per integer.  A FITS bit array has the bits in order of
C   decreasing signifigance with 8 bits per real world byte, zero filled
C   Inputs:
C      NBIT   I      Number of bits
C      INB    I(*)   Input buffer of FITS bit array data as 8-bit byte
C                    stream.
C   Output:
C      OUTB   I(*)   Out buffer of AIPS bit array data.
C   Generic version: works whenever local integer is a multiple of 16
C   bits and has no more than 64 bits.
C-----------------------------------------------------------------------
      INTEGER   NBIT, INB(*), OUTB(*)
C                                       NUMBIT = number of bits in
C                                       a local integer
      INTEGER   NUMBIT
      PARAMETER (NUMBIT=64)
      INTEGER   IBITS(NUMBIT), OBITS(NUMBIT), IWORK(NUMBIT/16), J,
     *   NBITS, NCONV, NWORDS, NLEFT, LOOP, ILOOP, NLOOP, IPOINT
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      NWORDS = (NBIT-1) / NBITWD + 1
      NLEFT = NBIT
      NCONV = NBITWD / 16
C                                       Loop over input words
      DO 100 LOOP = 1,NWORDS
         NBITS = NBITWD
         IF (NBITS.GT.NLEFT) NBITS = NLEFT
C                                       Input bits are 16 per
C                                       integer:
C                                       Convert to local integers.
         CALL ZI16IL (NCONV, 1, INB(LOOP), IWORK)
C                                       Extract the bits 16 per word.
         IPOINT = NBITWD - 15
         NLOOP = (NBITS-1) / 16 + 1
         DO 20 ILOOP = 1,NLOOP
C                                       Trap local integer > 16 bits
C                                       and sign bit turned on.
            IF ((NBITWD.GT.16) .AND. (IWORK(ILOOP).LT.0))
     *         IWORK(ILOOP) = 65536 + IWORK(ILOOP)
            CALL ZGTBIT (16, IWORK(ILOOP), IBITS(IPOINT))
            IPOINT = IPOINT - 16
 20         CONTINUE
C                                       Reverse bit order.
         DO 40 ILOOP = 1,NBITS
            OBITS(ILOOP) = IBITS(NBITWD-ILOOP+1)
 40         CONTINUE
C                                       Zero remaining output bits
         J = NBITS+1
         DO 60 ILOOP = J,NBITWD
            OBITS(ILOOP) = 0
 60         CONTINUE
C                                       Output bytes NBITWD per integer
         CALL ZPTBIT (NBITWD, OUTB(LOOP), OBITS)
         NLEFT = NLEFT - NBITS
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE GRDSET (MODEL, SCRGRD, SCRWRK, BUFFER, IRET)
C-----------------------------------------------------------------------
C! Creates scratch files and sets up for GRDSUB
C# UV Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2000, 2006, 2008-2009, 2012, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GRDSET sets up for GRDSUB, mostly creates scratch files (type SC)
C   Also fills in LUNS array in /CFILES/ = 16,17,18,19,20
C   Input:
C      MODEL    I        Doing image (2,3) or CC (1)
C   Output:
C      SCRGRD   I        /CFILES/ file number for grid file.
C      SCRWRK   I        /CFILES/ file number for work file
C      BUFFER   I(512)   Work buffer.
C      IRET     I        Return code, 0=>OK, otherwise failed.
C-----------------------------------------------------------------------
      INTEGER   MODEL, SCRGRD, SCRWRK, BUFFER(512), IRET
C
      INTEGER   NX, NY, NP(5), NCVSIZ, IFIELD, SIZE, SIZE2, MX, MY,
     *   MXOFF, MYOFF, II
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DGDS.INC'
C-----------------------------------------------------------------------
C                                       Setup.
      NCVSIZ = 10
C                                       Find largest input file.
      NX = 1
      NY = 1
      DO 10 IFIELD = 1,MFIELD
         CALL CATIO ('READ', CCDISK(IFIELD), CCCNO(IFIELD), BUFFER,
     *      'REST', BUFFER(257), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, IFIELD
            GO TO 990
            END IF
         IF (MODEL.GT.1) THEN
            CALL IMGSIZ (BUFFER, BUFFER, MX, MY, MXOFF, MYOFF, IRET)
         ELSE
            MX = BUFFER(KINAX)
            MY = BUFFER(KINAX+1)
            END IF
         NX = MAX (NX, MX)
         NY = MAX (NY, MY)
 10      CONTINUE
      CALL POWER2 (NX, II)
      IF (II.LT.NX) NX = 2 * II
      CALL POWER2 (NY, II)
      IF (II.LT.NY) NY = 2 * II
C                                       Grid. file.
C                                       Increase size if possible for
C                                       interpolation
      IF (NX.LE.8192) NX = 2 * NX
      IF (NY.LE.8192) NY = 2 * NY
C                                       try two estimates of size:
      NP(1) = 2 * NY + 2 * NCVSIZ
      NP(2) = NX / 2 + 1 + 2 * NCVSIZ
      CALL MAPSIZ (2, NP, SIZE2)
C
      NP(1) = MIN (NX, NY) + 2
      NP(2) = MAX (NX, NY) + 2
C                                       Add extra rows for bandwidth
C                                       synthesis.
      NP(1) = NP(1) + 2 * NCVSIZ
C                                       Determine file size
      CALL MAPSIZ (2, NP, SIZE)
      SIZE = MAX (SIZE, SIZE2)
C                                       Make GRID (SCRGRD) file.
      CALL SCREAT (SIZE, BUFFER, IRET)
      SCRGRD = NSCR
      IF (IRET.NE.0) THEN
         IF (IRET.EQ.1) THEN
            MSGTXT = 'TOO LITTLE DISK SPACE FOR SCRATCH FILE'
         ELSE
            WRITE (MSGTXT,1011) IRET
            END IF
         GO TO 990
         END IF
C                                       WORK file (SCRWRK)
 40   CALL SCREAT (SIZE, BUFFER, IRET)
      SCRWRK = NSCR
      IF (IRET.NE.0) THEN
         IF (IRET.EQ.1) THEN
            MSGTXT = 'TOO LITTLE DISK SPACE FOR SCRATCH FILE'
         ELSE
            WRITE (MSGTXT,1011) IRET
            END IF
         GO TO 990
         END IF
C                                       Fill LUNS array in /CFILES/
 50   LUNS(1) = 16
      LUNS(2) = 17
      LUNS(3) = 18
      LUNS(4) = 19
      LUNS(5) = 20
      IRET = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GRDSET: ERROR',I5,' READING CATBLK FIELD',I3)
 1011 FORMAT ('GRDSET: ERROR',I5,' CREATING SCRATCH FILE')
      END

LOCAL INCLUDE 'PRTPL.INC'
      REAL   XMWPF, XWPL, XWPP, SCALEX, SCALEY
      INTEGER   IXL, IYL, IX0, IY0, NGRAYS, IRRN(2), INBLK,
     *   IMAXS, IMIDS, IYSPAC, IXBIT, LINWID
      COMMON /CPRT/ SCALEX, SCALEY, IXL, IYL, IX0, IY0, NGRAYS,
     *   IRRN, INBLK, IMAXS, IMIDS, XMWPF, XWPL, XWPP, IYSPAC,
     *   IXBIT, LINWID
LOCAL END
      PROGRAM PRTPL
C-----------------------------------------------------------------------
C! Task to write a plot file to a particular printer-plotter
C# Graphics Plot-appl Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2009, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PRTPL is a program for the graphics package. The program runs as a
C   detached task initiated from AIPS.  First a cataloged file is found
C   using data passed from AIPS.  The list of associated files is
C   searched for a PLot file corresponding to the version number.  The
C   graphics commands in this file are used to create a bit map on disk.
C   This bit map is then used to write to a particular printer-plotter
C   by ZDOPRT.
C   INPUTS:  (from AIPS)
C            INNAME  R(3)   Name of primary file.
C            INCLASS R(2)   Class of primary file.
C            INSEQ   R      Sequence number of primary file.
C            INDISK  R      Disk volume number. 0 means try all.
C            INVERS  R      Extension file version number. 0 means.
C                           use the highest version number.
C            ASPMM   R      Arc sec per milimetersec, 0=self scale.
C                           on normal CNTR, GREYS, PCNTR plots
C                           else used as scale factor (0 < aspmm < 1)
C            COPIES   R     Number of copies of the plot.
C            DOCENTER R     TRUE (1) means center on a page. FALSE (-1)
C                           means use maximum possible plot even if the
C                           plot runs across a page boundary.
C            DOINVERS R     TRUE (>= 0) means white on black image
C                           normal is black on white
C            BADDISK  R(10)    Disks to avoid for scratch
C-----------------------------------------------------------------------
      CHARACTER NAMIN*12, CLSIN*6, TYPIN*2, STATUS*4, NAME*6,
     *   GFILE*48
      HOLLERITH XNAMIN(3), XCLSIN(2)
      REAL   CENTER, DSKIN, SEQIN, ASPMM, VERSN, XINVER, COPIES,
     *   BADD(10)
      INTEGER   BUFFER(256), SCRTCH(8192), CATERR, LUN, FIND, IERR,
     *   RETCOD, SLOT, IVER, ISEQ, IERR2, USER, ISIZE, ICENT, NCOPY,
     *   IROUND, IVOL, I, NPARMS
      LOGICAL   NOEXCL, WAIT, EQUAL, NOMAP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'PRTPL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (NOMAP, NOEXCL)
      COMMON /INPARM/ XNAMIN, XCLSIN, SEQIN, DSKIN, VERSN, ASPMM,
     *   COPIES, CENTER, XINVER, BADD
      DATA NAME /'PRTPL '/
      DATA NOEXCL, WAIT /.FALSE.,.TRUE./
      DATA LUN, ISIZE /26, 8192/
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE., BUFFER)
      CALL VHDRIN
      NSCR = 0
      NCFILE = 0
C                                       Get input values from AIPS.
      NPARMS = 22
      CALL GTPARM (NAME, NPARMS, RQUICK, XNAMIN, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         END IF
C
      RETCOD = IERR
      IF (RQUICK) CALL RELPOP (RETCOD, BUFFER, IERR2)
      IF (IERR.NE.0) GO TO 995
      RETCOD = 1
C                                       Hollerith -> char.
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
      TYPIN = ' '
C                                       Get map header.
      ISEQ = IROUND (SEQIN)
      IVOL = IROUND (DSKIN)
      IVER = IROUND (VERSN)
      DO 30 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 30      CONTINUE
      IF (CENTER.LE.0.0) ICENT = -1
      IF (CENTER.GT.0.0) ICENT = 1
      IF (XINVER.GT.0.0) IXBIT = 0
      IF (XINVER.LE.0.0) IXBIT = 1
      USER = NLUSER
      SLOT = 1
      CALL CATDIR ('SRCH', IVOL, SLOT, NAMIN, CLSIN, ISEQ, TYPIN, USER,
     *   STATUS, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (8)
         GO TO 995
         END IF
C                                       Read catalog header.
      CALL CATIO ('READ', IVOL, SLOT, CATBLK, 'REST', BUFFER, CATERR)
      IF ((CATERR.EQ.0) .OR. (CATERR.EQ.6)) GO TO 50
 45      WRITE (MSGTXT,1045) IERR
         CALL MSGWRT (8)
         GO TO 995
C                                        Find plot file:
C                                        if PL & IVER=0, then main file
 50   EQUAL = TYPIN .EQ. 'PL'
      IF ((EQUAL) .AND. (CATERR.EQ.6)) GO TO 45
      IF ((EQUAL) .AND. (IVER.EQ.0)) IVER = CATBLK(KIIMS)
C                                        else take IVER as given or
C                                        as max version #
      IF (IVER.LE.0) CALL FNDEXT ('PL', CATBLK, IVER)
C                                       PLot file not found.
      IF (IVER.LE.0) THEN
         WRITE (MSGTXT,1060)
         CALL MSGWRT (8)
         GO TO 995
         END IF
C
C                                       Build file name.
      CALL ZPHFIL ('PL', IVOL, SLOT, IVER, GFILE, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Open graphics file.
      CALL ZOPEN (LUN, FIND, IVOL, GFILE, NOMAP, NOEXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1070)
         CALL MSGWRT (8)
         GO TO 995
         END IF
C                                       Write bit map & que to printer.
      NCOPY = IROUND (COPIES)
      IF (NCOPY.LT.1) NCOPY = 1
      CALL PRTDRW (LUN, FIND, IVOL, ICENT, ISIZE, ASPMM, NCOPY, SCRTCH,
     *   IERR)
      IF (IERR.EQ.0) THEN
         RETCOD = 0
      ELSE
         WRITE (MSGTXT,1080)
         CALL MSGWRT (8)
         END IF
C                                       Close graph file.
      CALL ZCLOSE (LUN, FIND, IERR)
 995  CALL DIE (RETCOD, BUFFER)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('COULD NOT GET INPUTS FROM AIPS. GTPARM ERR =',I5)
 1030 FORMAT ('CATALOG ENTRY NOT FOUND. CATDIR ERR =',I5)
 1045 FORMAT ('ERROR READING CATALOG HEADER. CATIO ERR =',I5)
 1060 FORMAT ('PLOT FILE NOT IN CATALOG')
 1070 FORMAT ('PLOT FILE NOT FOUND')
 1080 FORMAT ('ERROR WRITING BIT MAP')
      END
      SUBROUTINE GRYRAN (VALUE, NBITS, BITS)
C-----------------------------------------------------------------------
C   GRYRAN sets bits in the bit array BITS by calling a random number
C   generator.  If the generated value is < VALUE, the bit is set on,
C   else it is set off.
C   Inputs: VALUE  R           test level (0. <= VALUE <= 1.)
C           NBITS  I           > 0 -> number of bits to set
C                              < 0 -> do initialization
C           BITS   I(NBITS)    bit array, set to 1/0's
C-----------------------------------------------------------------------
      REAL      VALUE, X
      INTEGER   NBITS, BITS(1), I
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                        init
      IF (NBITS.GT.0) GO TO 10
         CALL RANDIN (I)
         IF (I.EQ.0) GO TO 999
            WRITE (MSGTXT,1000) I
            CALL MSGWRT (7)
            GO TO 999
C                                        do the usual
 10   DO 20 I = 1,NBITS
         CALL RANDUM (X)
         BITS(I) = 0
         IF (X.LT.VALUE) BITS(I) = 1
 20      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GRYRAN: Strange return from RANDIN :',I7)
      END
      SUBROUTINE PRBMCR (IVOL, ILUN, IND, INX, INY, IFILE, ISCVOL,
     *   IBLKS, WORDS, SCRTCH, IERR)
C-----------------------------------------------------------------------
C   PRBMCR will calculate the size for a bit map file and create
C   a unique version of this scratch file on a disk other than the
C   disk used by the graphics file if possible.
C   INPUTS:   IVOL    I   disk volume number for this scratch file.
C             ILUN    I   logical unit number for this file.
C             INX     I   number of X pixels in this file. (dots)
C             INY     I   number of Y pixels in this file. (dots)
C   OUTPUTS:  IND     I   pointer to info in FTAB.
C             IFILE   C*48   file name of scratch file.
C             ISCVOL  I   Volume number of bit map file.
C             IBLKS   I   The number of 512 byte blocks in this file.
C             WORDS   R   The number of words needed for the bit map.
C             SCRTCH  I(512)     Scratch buffer
C             IERR    I   error indicator.
C                         0 = no error.
C                         1 = could not build file name.
C                         2 = unexpected create error.
C                         3 = all 99 versions of scratch in use.
C                         4 = unexpected open error.
C-----------------------------------------------------------------------
      CHARACTER IFILE*48
      REAL      WORDS
      INTEGER   IERR, ILUN, IND, INX, INY, ISCVOL, ISEQ, IVER, IVOL,
     *   IBLKS, SCRTCH(*), ISIZE
      LOGICAL   EXCL, NOMAP, WAIT
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (EXCL, WAIT)
      DATA IVER /1/
      DATA EXCL, NOMAP /.TRUE.,.TRUE./
C-----------------------------------------------------------------------
C                                       Calculate size of new file.
      ISIZE = ((INX-1) / NBITWD + 1)
      WORDS = ISIZE * INY
      ISIZE = (WORDS-1) / 256  +  2.0001
      IBLKS = ISIZE
C                                       Find disk on volume other than
C                                       IVOL if possible.
      NSCR = 1
      SCRVOL(1) = IVOL
      CALL SCREAT (ISIZE, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         IERR = 2
         CALL MSGWRT (8)
         NSCR = 0
         GO TO 999
         END IF
C                                       Undo lie to SCREAT
      SCRVOL(1) = SCRVOL(2)
      SCRCNO(1) = SCRCNO(2)
      NSCR = 1
      ISCVOL = SCRVOL(1)
      ISEQ = SCRCNO(1)
C                                       Create scratch file name.
      CALL ZPHFIL ('SC', ISCVOL, ISEQ, IVER, IFILE, IERR)
C                                       Open scratch file.
      CALL ZOPEN (ILUN, IND, ISCVOL, IFILE, NOMAP, EXCL, WAIT, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (8)
         IERR = 4
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PRBMCR: SCRATCH CREATE ERROR ',I5)
 1020 FORMAT ('PRBMCR: COULD NOT OPEN FILE! ZOPEN ERR =',I5)
      END
      SUBROUTINE PRCHAR (ILEN, HORV, STRING, ILUN, IND, IOBLK, IERR)
C-----------------------------------------------------------------------
C   PRCHAR will generate the vector commands for characters.
C   INPUTS:   ILEN     I   number of characters in the character string
C             HORV     I   0 = draw characters horizontally, 1=vertical
C             STRING   C(*)   array containing ASCII characters
C             ILUN     I   logical unit number of bit map file.
C             IND      I   FTAB index of bit map file.
C             IOBLK    I(??)   I/O block for bit map file.
C   COMMON:   CSIZPR   I(2)   character size (X,Y) in bits.
C             IXL      I   current absolute x coordinate in bit map.
C             IYL      I   current absolute Y coordinate in bit map.
C   OUTPUTS:  IERR     I   error code.
C                          0 = ok.
C   COMMON:   IXL      I   updated position.
C             IYL      I   updated Y position.
C             IOBLK    I   updated I/O block.
C-----------------------------------------------------------------------
      CHARACTER IT*2, STRING*(*)
      INTEGER   IOBLK(1), HORV, I, ICHAR, IERR, ILEN, ILUN, KT,
     *   INCOM, IND, INDEX, IOP, IXC, IXSAV, IYC, IYSAV, J, K,
     *   BITS(15), NIT, JT, LT
      INTEGER   ICHTAB(931), INDTAB(95)
      INTEGER   SPACE ( 1), EXCLAM( 6), QUOTE ( 6), POUND (13)
     *        , DOLLAR(15), PERCNT(16), AMPERS(13), APOSTR( 8)
     *        , LPAREN( 6), RPAREN( 6), ASTER (13), PLUS  (07)
     *        , COMMA ( 8), MINUS ( 4), PERIOD( 7), SLASH ( 4)
     *        , ZERO  (14), ONE   ( 8), TWO   (12), THREE (16)
     *        , FOUR  ( 7), FIVE  (12), SIX   (13), SEVEN ( 8)
     *        , EIGHT (18), NINE  (13), COLON (13), SEMICO(14)
     *        , LESS  ( 5), EQUALS( 7), GREATR( 5), QUESTN(11)
      INTEGER   ATSIGN(15), AUPPER(10), BUPPER(17), CUPPER(10)
     *        , DUPPER(11), EUPPER( 9), FUPPER( 8), GUPPER(12)
     *        , HUPPER(10), IUPPER(10), JUPPER(10), KUPPER(10)
     *        , LUPPER( 5), MUPPER( 7), NUPPER(10), OUPPER(11)
     *        , PUPPER( 9), QUPPER(14), RUPPER(12), SUPPER(14)
     *        , TUPPER( 7), UUPPER( 8), VUPPER( 7), WUPPER( 7)
     *        , XUPPER(11), YUPPER( 8), ZUPPER( 8), LBRACK( 6)
     *        , BKSLSH( 4), RBRACK( 6), CARET ( 5), USCORE( 4)
     *        , ACCENT( 7), ALOWER(15), BLOWER(13), CLOWER(10)
     *        , DLOWER(13), ELOWER(12), FLOWER( 9), GLOWER(13)
     *        , HLOWER(10), ILOWER(10), JLOWER(10), KLOWER(11)
     *        , LLOWER( 8), MLOWER(14), NLOWER(10), OLOWER(11)
     *        , PLOWER(13), QLOWER(13), RLOWER( 9), SLOWER(11)
     *        , TLOWER(10), ULOWER(10), VLOWER( 7), WLOWER(14)
     *        , XLOWER( 7), YLOWER(13), ZLOWER( 6), LBRACE(14)
     *        , ORSIGN( 4), RBRACE(14), TILDE ( 6)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'PRTPL.INC'
      EQUIVALENCE (SPACE , ICHTAB(  1)), (EXCLAM, ICHTAB(  2))
     *          , (QUOTE , ICHTAB(  8)), (POUND , ICHTAB( 14))
     *          , (DOLLAR, ICHTAB( 27)), (PERCNT, ICHTAB( 42))
     *          , (AMPERS, ICHTAB( 58)), (APOSTR, ICHTAB( 71))
     *          , (LPAREN, ICHTAB( 79)), (RPAREN, ICHTAB( 85))
     *          , (ASTER , ICHTAB( 91)), (PLUS  , ICHTAB(104))
     *          , (COMMA , ICHTAB(111)), (MINUS , ICHTAB(119))
     *          , (PERIOD, ICHTAB(123)), (SLASH , ICHTAB(130))
     *          , (ZERO  , ICHTAB(134)), (ONE   , ICHTAB(148))
     *          , (TWO   , ICHTAB(156)), (THREE , ICHTAB(168))
     *          , (FOUR  , ICHTAB(184)), (FIVE  , ICHTAB(191))
     *          , (SIX   , ICHTAB(203)), (SEVEN , ICHTAB(216))
     *          , (EIGHT , ICHTAB(224)), (NINE  , ICHTAB(242))
     *          , (COLON , ICHTAB(255)), (SEMICO, ICHTAB(268))
     *          , (LESS  , ICHTAB(282)), (EQUALS, ICHTAB(287))
     *          , (GREATR, ICHTAB(294)), (QUESTN, ICHTAB(299))
      EQUIVALENCE (ATSIGN, ICHTAB(310)), (AUPPER, ICHTAB(325))
     *          , (BUPPER, ICHTAB(335)), (CUPPER, ICHTAB(352))
     *          , (DUPPER, ICHTAB(362)), (EUPPER, ICHTAB(373))
     *          , (FUPPER, ICHTAB(382)), (GUPPER, ICHTAB(390))
     *          , (HUPPER, ICHTAB(402)), (IUPPER, ICHTAB(412))
     *          , (JUPPER, ICHTAB(422)), (KUPPER, ICHTAB(432))
     *          , (LUPPER, ICHTAB(442)), (MUPPER, ICHTAB(447))
     *          , (NUPPER, ICHTAB(454)), (OUPPER, ICHTAB(464))
     *          , (PUPPER, ICHTAB(475)), (QUPPER, ICHTAB(484))
     *          , (RUPPER, ICHTAB(498)), (SUPPER, ICHTAB(510))
     *          , (TUPPER, ICHTAB(524)), (UUPPER, ICHTAB(531))
     *          , (VUPPER, ICHTAB(539)), (WUPPER, ICHTAB(546))
     *          , (XUPPER, ICHTAB(553)), (YUPPER, ICHTAB(564))
     *          , (ZUPPER, ICHTAB(572)), (LBRACK, ICHTAB(580))
     *          , (BKSLSH, ICHTAB(586)), (RBRACK, ICHTAB(590))
     *          , (CARET , ICHTAB(596)), (USCORE, ICHTAB(601))
      EQUIVALENCE (ACCENT, ICHTAB(605)), (ALOWER, ICHTAB(612))
     *          , (BLOWER, ICHTAB(627)), (CLOWER, ICHTAB(640))
     *          , (DLOWER, ICHTAB(650)), (ELOWER, ICHTAB(663))
     *          , (FLOWER, ICHTAB(675)), (GLOWER, ICHTAB(684))
     *          , (HLOWER, ICHTAB(697)), (ILOWER, ICHTAB(707))
     *          , (JLOWER, ICHTAB(717)), (KLOWER, ICHTAB(727))
     *          , (LLOWER, ICHTAB(738)), (MLOWER, ICHTAB(746))
     *          , (NLOWER, ICHTAB(760)), (OLOWER, ICHTAB(770))
     *          , (PLOWER, ICHTAB(781)), (QLOWER, ICHTAB(794))
     *          , (RLOWER, ICHTAB(807)), (SLOWER, ICHTAB(816))
     *          , (TLOWER, ICHTAB(827)), (ULOWER, ICHTAB(837))
     *          , (VLOWER, ICHTAB(847)), (WLOWER, ICHTAB(854))
     *          , (XLOWER, ICHTAB(868)), (YLOWER, ICHTAB(875))
     *          , (ZLOWER, ICHTAB(888)), (LBRACE, ICHTAB(894))
     *          , (ORSIGN, ICHTAB(908)), (RBRACE, ICHTAB(912))
     *          , (TILDE , ICHTAB(926))
C-----------------------------------------------------------------------
      DATA SPACE  /00/
      DATA EXCLAM /02, 38, 33, 01, 30, 00/
      DATA QUOTE  /02, 28, 26, 02, 48, 46/
      DATA POUND  /02, 10, 18, 02, 58, 50, 02, 62, 02, 02
     *           , 06, 66, 00/
      DATA DOLLAR /10, 01, 51, 62, 63, 54, 14, 05, 06, 17
     *           , 67, 02, 38, 30, 00/
      DATA PERCNT /05, 07, 18, 27, 16, 07, 02, 01, 67, 05
     *           , 50, 61, 52, 41, 50, 00/
      DATA AMPERS /11, 60, 06, 07, 18, 48, 46, 02, 01, 10
     *           , 30, 63, 00/
      DATA APOSTR /06, 24, 46, 48, 38, 37, 47, 00/
      DATA LPAREN /04, 40, 22, 26, 48, 00/
      DATA RPAREN /04, 20, 42, 46, 28, 00/
      DATA ASTER  /02, 01, 67, 02, 07, 61, 02, 04, 64, 02
     *           , 37, 31, 00/
      DATA PLUS   /02, 14, 54, 02, 36, 32, 00/
      DATA COMMA  /06, 20, 42, 44, 34, 33, 43, 00/
      DATA MINUS  /02, 14, 54, 00/
      DATA PERIOD /05, 20, 30, 31, 21, 20, 00/
      DATA SLASH  /02, 01, 67, 00/
      DATA ZERO   /09, 10, 50, 61, 67, 58, 18, 07, 01, 10
     *           , 02, 01, 67, 00/
      DATA ONE    /02, 10, 50, 03, 30, 38, 16, 00/
      DATA TWO    /10, 07, 18, 58, 67, 65, 54, 24, 02, 00
     *           , 60, 00/
      DATA THREE  /07, 07, 18, 58, 67, 65, 54, 34, 06, 54
     *           , 63, 61, 50, 10, 01, 00/
      DATA FOUR   /05, 50, 58, 03, 02, 72, 00/
      DATA FIVE   /10, 01, 10, 40, 62, 63, 45, 05, 08, 68
     *           , 67, 00/
      DATA SIX    /11, 04, 54, 63, 61, 50, 10, 01, 06, 28
     *           , 58, 67, 00/
      DATA SEVEN  /06, 20, 23, 67, 68, 08, 07, 00/
      DATA EIGHT  /16, 14, 03, 01, 10, 50, 61, 63, 54, 14
     *           , 05, 07, 18, 58, 67, 65, 54, 00/
      DATA NINE   /11, 01, 10, 40, 62, 67, 58, 18, 07, 05
     *           , 14, 64, 00/
      DATA COLON  /05, 22, 32, 33, 23, 22, 05, 26, 36, 37
     *           , 27, 26, 00/
      DATA SEMICO /06, 10, 32, 34, 24, 23, 33, 05, 26, 36
     *           , 37, 27, 26, 00/
      DATA LESS   /03, 50, 14, 58, 00/
      DATA EQUALS /02, 12, 52, 02, 16, 56, 00/
      DATA GREATR /03, 10, 54, 18, 00/
      DATA QUESTN /07, 06, 07, 18, 58, 67, 34, 33, 01, 31
     *           , 00/
      DATA ATSIGN /13, 54, 45, 34, 43, 54, 64, 66, 48, 28
     *           , 06, 02, 20, 50, 00/
      DATA AUPPER /05, 00, 05, 38, 65, 60, 02, 03, 63, 00/
      DATA BUPPER /06, 00, 50, 61, 63, 54, 14, 05, 08, 58
     *           , 67, 65, 54, 02, 18, 10, 00/
      DATA CUPPER /08, 67, 58, 28, 06, 02, 20, 50, 61, 00/
      DATA DUPPER /06, 00, 40, 62, 66, 48, 08, 02, 18, 10
     *           , 00/
      DATA EUPPER /04, 60, 00, 08, 68, 02, 34, 04, 00/
      DATA FUPPER /03, 00, 08, 68, 02, 34, 04, 00/
      DATA GUPPER /10, 67, 58, 28, 06, 02, 20, 50, 61, 64
     *           , 44, 00/
      DATA HUPPER /02, 00, 08, 02, 60, 68, 02, 04, 64, 00/
      DATA IUPPER /02, 10, 50, 02, 30, 38, 02, 18, 58, 00/
      DATA JUPPER /05, 01, 10, 20, 31, 38, 02, 18, 58, 00/
      DATA KUPPER /02, 00, 08, 02, 68, 02, 02, 24, 60, 00/
      DATA LUPPER /03, 08, 00, 60, 00/
      DATA MUPPER /05, 00, 08, 35, 68, 60, 00/
      DATA NUPPER /02, 00, 08, 02, 07, 61, 02, 60, 68, 00/
      DATA OUPPER /09, 20, 40, 62, 66, 48, 28, 06, 02, 20
     *           , 00/
      DATA PUPPER /07, 00, 08, 58, 67, 66, 55, 05, 00/
      DATA QUPPER /09, 20, 40, 62, 66, 48, 28, 06, 02, 20
     *           , 02, 33, 60, 00/
      DATA RUPPER /07, 00, 08, 58, 67, 66, 55, 05, 02, 15
     *           , 60, 00/
      DATA SUPPER /12, 01, 10, 50, 61, 63, 54, 14, 05, 07
     *           , 18, 58, 67, 00/
      DATA TUPPER /02, 30, 38, 02, 08, 68, 00/
      DATA UUPPER /06, 08, 01, 10, 50, 61, 68, 00/
      DATA VUPPER /05, 08, 03, 30, 63, 68, 00/
      DATA WUPPER /05, 08, 00, 33, 60, 68, 00/
      DATA XUPPER /04, 00, 01, 67, 68, 04, 08, 07, 61, 60
     *           , 00/
      DATA YUPPER /03, 08, 35, 68, 02, 35, 30, 00/
      DATA ZUPPER /06, 08, 68, 67, 01, 00, 60, 00/
      DATA LBRACK /04, 40, 20, 28, 48, 00/
      DATA BKSLSH /02, 07, 61, 00/
      DATA RBRACK /04, 20, 40, 48, 28, 00/
      DATA CARET  /03, 05, 38, 65, 00/
      DATA USCORE /02,-01,-61, 00/
      DATA ACCENT /05, 27, 28, 38, 37, 55, 00/
      DATA ALOWER /05, 06, 26, 35, 31, 40, 07, 31, 20, 10
     *           , 01, 02, 13, 33, 00/
      DATA BLOWER /02, 08, 00, 08, 02, 20, 30, 41, 44, 35
     *           , 25, 03, 00/
      DATA CLOWER /08, 41, 30, 10, 01, 04, 15, 35, 44, 00/
      DATA DLOWER /02, 48, 40, 08, 42, 20, 10, 01, 04, 15
     *           , 25, 43, 00/
      DATA ELOWER /10, 40, 10, 01, 04, 15, 35, 44, 43, 32
     *           , 02, 00/
      DATA FLOWER /04, 10, 17, 28, 37, 02, 04, 24, 00/
      DATA GLOWER /11, 40, 10, 01, 04, 15, 35, 44,-41,-23
     *           ,-13,-02, 00/
      DATA HLOWER /02, 00, 08, 05, 03, 25, 35, 44, 40, 00/
      DATA ILOWER /01, 37, 03, 25, 35, 30, 02, 20, 40, 00/
      DATA JLOWER /01, 37, 06, 35,-32,-23,-13,-02,-01, 00/
      DATA KLOWER /02, 08, 00, 02, 01, 45, 03, 40, 22, 23
     *           , 00/
      DATA LLOWER /02, 20, 40, 03, 30, 38, 28, 00/
      DATA MLOWER /06, 00, 04, 15, 25, 34, 30, 05, 34, 45
     *           , 55, 64, 60, 00/
      DATA NLOWER /02, 00, 05, 05, 03, 25, 35, 44, 40, 00/
      DATA OLOWER /09, 01, 04, 15, 35, 44, 41, 30, 10, 01
     *           , 00/
      DATA PLOWER /02,-03, 05, 08, 03, 25, 35, 44, 41, 30
     *           , 20, 02, 00/
      DATA QLOWER /02,-43, 45, 08, 43, 25, 15, 04, 01, 10
     *           , 20, 42, 00/
      DATA RLOWER /02, 00, 05, 04, 03, 25, 35, 44, 00/
      DATA SLOWER /09, 00, 30, 41, 42, 33, 13, 04, 15, 45
     *           , 00/
      DATA TLOWER /02, 06, 26, 05, 18, 11, 20, 30, 41, 00/
      DATA ULOWER /05, 05, 01, 10, 20, 42, 02, 40, 45, 00/
      DATA VLOWER /05, 05, 02, 20, 42, 45, 00/
      DATA WLOWER /06, 05, 01, 10, 20, 31, 35, 05, 31, 40
     *           , 50, 61, 65, 00/
      DATA XLOWER /02, 00, 55, 02, 05, 50, 00/
      DATA YLOWER /05, 05, 01, 10, 30, 41, 05, 45,-42,-33
     *           ,-23,-12, 00/
      DATA ZLOWER /04, 05, 55, 00, 50, 00/
      DATA LBRACE /06, 40, 30, 21, 23, 14, 04, 05, 14, 25
     *           , 27, 38, 48, 00/
      DATA ORSIGN /02, 30, 38, 00/
      DATA RBRACE /06, 20, 30, 41, 43, 54, 64, 05, 54, 45
     *           , 47, 38, 28, 00/
      DATA TILDE  /04, 06, 28, 46, 68, 00/
C
      DATA INDTAB /  1,   2,   8,  14,  27,  42,  58,  71,  79,  85,
     *              91, 104, 111, 119, 123, 130, 134, 148, 156, 168,
     *             184, 191, 203, 216, 224, 242, 255, 268, 282, 287,
     *             294, 299, 310, 325, 335, 352, 362, 373, 382, 390,
     *             402, 412, 422, 432, 442, 447, 454, 464, 475, 484,
     *             498, 510, 524, 531, 539, 546, 553, 564, 572, 580,
     *             586, 590, 596, 601, 605, 612, 627, 640, 650, 663,
     *             675, 684, 697, 707, 717, 727, 738, 746, 760, 770,
     *             781, 794, 807, 816, 827, 837, 847, 854, 868, 875,
     *             888, 894, 908, 912, 926 /
C-----------------------------------------------------------------------
C                                       Loop for each character.
      DO 100 I = 1,ILEN
C                                       get standard ASCII char
C                                       in machine-ind. fashion
         JT = NBITWD/8
         IT(1:1) = STRING(I:I)
         CALL ZCLC8 (1, IT, JT, LT)
         CALL ZI32IL (1, 1, LT, KT)
         NIT = NBITWD - (JT-1)*8
         CALL ZGTBIT (NIT, KT, BITS)
         CALL ZPTBIT (8, ICHAR, BITS(NIT-7))
C                                       Set origin & check validity.
         ICHAR = ICHAR - 31
         IF ((ICHAR.LT.1) .OR. (ICHAR.GT.95)) ICHAR = 32
C                                       Find index into table of vectrs
         INDEX = INDTAB(ICHAR)
         IXSAV = IXL
         IYSAV = IYL
C                                       DO WHILE no. of commands not 0.
         DO 50 J = 1,99
            INCOM = ICHTAB(INDEX)
            IF (INCOM.EQ.0) GO TO 60
C                                       Loop for all vector commands.
            IOP = 3
            IXL = IXSAV
            IYL = IYSAV
            DO 30 K = 1,INCOM
               INDEX = INDEX + 1
C                                       Calc X and Y values.
               IYC = (MOD(ICHTAB(INDEX), 10)*CSIZPR(2)) / 10 + IYSAV
               IXC = (ICHTAB(INDEX)/10 * CSIZPR(1)) / 10
               IXC = ABS (IXC) + IXSAV
               CALL PRTVEC (IXC, IYC, IOP, ILUN, IND, IOBLK, IERR)
               IF (IERR.NE.0) GO TO 999
               IOP = 4
 30            CONTINUE
            INDEX = INDEX + 1
 50         CONTINUE
C                                       Set last X and Y.
C                                       Horizontal
 60      IF (HORV.EQ.1) GO TO 65
            IYL = IYSAV
            IXL = IXSAV + CSIZPR(1)
            GO TO 100
C                                       Vertical.
 65      CONTINUE
            IXL = IXSAV
            IYL = IYSAV - CSIZPR(2) - IYSPAC
C
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE PRSBIT (IX, IY, IN, ILUN, IND, SCRTCH, IERR)
C-----------------------------------------------------------------------
C   PRSBIT will set a bit in the bit map.  This routine keeps part of
C   the bit map in two buffers.  The routine determines if the bit to be
C   set is in one of these two buffers.  If not the buffer containing
C   the section of the bit map farthest from the bit is written to disk
C   and the 'page' containing the bit is read from disk.  The bit map is
C   stored such that the top of the plot is stored in the first part of
C   the file.
C   Inputs:  IX     I(IN)   the X positions of the bits in the bit map
C                   ( 1 relative starting from bottom left corner of
C                   the finished graph.)
C            IY     I(IN)   the line ( Y positions ) of the bits to be
C                   set.
C            IN      I   the number of bits to be set.
C            ILUN   I   the logical unit number of the bit map file.
C            IND    I   index into FTAB info.
C            SCRTCH I(??)   the array used for the two I/O buffers.
C   Common:  INBLK  I   the number of 512 byte blocks in each of the
C                   two buffers. (ie page size).
C            IRRN(1) I   first relative record number (1 relative) in
C                    I/O buffer one.
C            IRRN(2) I   first relative record number in I/O buffer two
C            IMAXS   the maximum number of sectors (blocks) in the
C                    bit map file.
C            IMIDS   I   the first word in SCRTCH used for I/O buffer
C                    two.
C            XMWPF   R   the maximum number of words in the bit map.
C            XWPL    R   the number of words per line in bit map.
C            XWPP    R   the number of words per 'page' in bit map.
C   Outputs: IERR    I   error code passed from ZMI3.
C   Common:  IRRN(1) I   page number  of buffer one updated after read.
C            IRRN(2) I   page number of buffer two updated after read.
C-----------------------------------------------------------------------
      REAL      XWIF, XPAGE
      INTEGER   IBITS(64), SCRTCH(*), IX(1), IY(1), IBUFF, IEND,
     *   IERR, ILUN, IND, IN, INWRDS, IPAGE, ISTART, ISWRD, IWBIT,
     *   IWORD, IWRD, IP, IWIP, NBYTES, IBLKNO(2)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'PRTPL.INC'
C-----------------------------------------------------------------------
C                                       Loop for number of bits.
      DO 100 IP = 1,IN
C                                       Find word in file starting from
C                                       the first of the file.
         XWIF = XWPL*REAL(IY(IP))  -  REAL((IX(IP)-1)/NBITWD) - 1.0
         XWIF = XMWPF - XWIF
C                                       Find page in file.
         XPAGE = AINT((XWIF-1) / XWPP  +  .0001)
         IPAGE = XPAGE + .0001
C                                       Find word in page.
         IWIP = XWIF - (XPAGE * XWPP)  +  0.0001
C                                       Find word in bit.
         IWBIT = NBITWD - MOD (IX(IP)-1, NBITWD)
C                                       See if RRN is in core.
         IBUFF = 1
         IF (IPAGE.EQ.IRRN(1)) GO TO 40
         IBUFF = 2
         IF (IPAGE.EQ.IRRN(2)) GO TO 40
C                                       Not in core.
C                                       Determine farthest buffer.
         IBUFF = 1
         ISWRD = 1
         INWRDS = INBLK * 256
         IF (ABS (IRRN(2)-IPAGE).GT.IABS (IRRN(1)-IPAGE)) IBUFF = 2
         IF (IBUFF.EQ.2) ISWRD = IMIDS
C                                       See if we need to save
         IF (IRRN(IBUFF).EQ.-9999) GO TO 20
C                                       Save previous data.
            IWRD = ISWRD
            ISTART = INBLK * IRRN(IBUFF) + 2
            IEND = MIN (ISTART + INBLK - 1, IMAXS)
            IF ((ISTART.GT.0) .AND. (ISTART.LE.IEND)) GO TO 10
               WRITE (MSGTXT,1000) IBUFF,IRRN(IBUFF)
               CALL MSGWRT (6)
               IERR = 0
               GO TO 20
 10         NBYTES = (IEND - ISTART + 1) * 512
            IBLKNO(2) = 0
            IBLKNO(1) = (ISTART-1) * (512/NBPS) + 1
            CALL ZMIO ('WRIT', ILUN, IND, IBLKNO, NBYTES, SCRTCH(IWRD),
     *         IBUFF, IERR)
            IF (IERR.EQ.0) CALL ZWAIT (ILUN, IND, IBUFF, IERR)
            IF (IERR.EQ.0) GO TO 20
               WRITE (MSGTXT,1010) IERR
               CALL MSGWRT (8)
               GO TO 999
C                                       Load new page.
 20      IWRD = ISWRD
C                                       Determine start of page.
         ISTART = INBLK * IPAGE  +  2
         IEND = MIN (ISTART + INBLK - 1, IMAXS)
         IF ((ISTART.GT.0) .AND. (ISTART.LE.IEND)) GO TO 25
            WRITE (MSGTXT,1020) IX(IP),IY(IP),IPAGE
            CALL MSGWRT (8)
            GO TO 999
 25      NBYTES = (IEND - ISTART + 1) * 512
         IBLKNO(2) = 0
         IBLKNO(1) = (ISTART-1) * (512/NBPS) + 1
         CALL ZMIO ('READ', ILUN, IND, IBLKNO, NBYTES, SCRTCH(IWRD),
     *      IBUFF, IERR)
         IF (IERR.EQ.0) CALL ZWAIT (ILUN, IND, IBUFF, IERR)
         IF (IERR.EQ.0) GO TO 30
            WRITE (MSGTXT,1025) IERR
            CALL MSGWRT (8)
            GO TO 999
 30         CONTINUE
         IRRN(IBUFF) = IPAGE
C                                       Calculate word in buffer.
 40      IWORD = IWIP + (IBUFF-1) * (IMIDS-1)
         IF (IWIP.GT.0) GO TO 45
            WRITE (MSGTXT,1040) IWIP,IX(IP),IY(IP),XWIF
            GO TO 100
C                                       Set bit.
 45      CALL ZGTBIT (NBITWD, SCRTCH(IWORD), IBITS)
         IBITS(IWBIT) = IXBIT
         CALL ZPTBIT (NBITWD, SCRTCH(IWORD), IBITS)
 100     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PRSBIT: ILL WRITE BLOCKS-BUF# IRRN',2I7)
 1010 FORMAT ('PRSBIT: DISK WRITE ERROR', I4)
 1020 FORMAT ('PRSBIT: ILL READ BLOCKS-X,Y,PAGE',3I7)
 1025 FORMAT ('PRSBIT: DISK READ ERROR', I4)
 1040 FORMAT ('PRSBIT: INDEX=',I7,' BAD AT X,Y,XWIF=',2I7,F12.1)
      END
      SUBROUTINE PRTDRW (LUN, FIND, IVOL, ICENT, ISIZE, ASPMM, NCOPY,
     *   BIGBLK, IERR)
C-----------------------------------------------------------------------
C   This routine will read a graph file and convert the commands into
C   a bit map.  Then the bit map is queued to the printer by calling
C   ZDOPRT.
C   INPUTS:  LUN     I   logical unit number of an open graph file.
C            FIND    I   pointer to the FTAB info of the graph file.
C            IVOL    I   disk volume number of graph file.
C            ICENT   I   if 1 center on page. If -1 write across pages.
C            ISIZE   I   number of words in BIGBLK.
C            ASPMM   R   Requested arcsec / mm (0 => self scale)
C            BIGBLK  I(ISIZE)   buffer for bit map I/O.
C            IERR    I   error code. 0 = ok.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IVOL, ICENT, ISIZE, NCOPY, BIGBLK(*), IERR
      REAL      ASPMM
C
      CHARACTER SFILE*48, STRING*132
      REAL      DX, DY, GROFF, GRSCAL, SCALEF, X, WORDS, XYRATO, Y,
     *   NOWPIX, RX1, RX2, RY1, RY2, AX, AY, XPXSEP, YPXSEP, UASPMM,
     *   YASPMM, XYDIFF, DELTA, YMMXMM, YPRDMM, VALUE, TOTPIX
      INTEGER   IOBLK(256), IBITS(256), IXPT(256), IYPT(256), GRYERR,
     *   I3, IANGL, IBLKS, IBMIND, IBMLUN, ICHB, ICHL, ICHR, ICHT, IEND,
     *   IERR2, IERRC, IERRLM, ISTART, ISWRD, IX, IX1, IX2, IY, NXA,
     *   NYA, OPCODE, IBLKNO(2), NBYTES, KOFF, JOFF, IOPOS, IORRN,
     *   ISCVOL, ITYPE, IY1, IY2, NYA0, NPTSX, NPTSY, IGRLO, IGRHI,
     *   NXDPP, NYDPP, NBITS, IPER, NCHAR, INCRRN, NPIX, N, J, L, NPTS,
     *   K, IPER2
      LOGICAL   EXCL, WAIT, DOGRAY, T
      HOLLERITH HOBLK(256)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'PRTPL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (IOBLK, HOBLK)
      EQUIVALENCE (WAIT, EXCL)
      DATA IBMLUN, I3  /28, 3/
      DATA EXCL, T /.TRUE.,.TRUE./
C-----------------------------------------------------------------------
C                                       Initialize all values.
C                                       Assume symetric device for now.
      YPRDMM = XPRDMM
      YMMXMM = YPRDMM / XPRDMM
      IERR = 0
      IERRC = 0
      IERRLM = 20
      GRYERR = 0
      IOPOS = 9999
      DOGRAY = .FALSE.
      IYSPAC = 3
      LINWID = 2
      IF (MAXXPR(1).LT.1101) LINWID = 1
C                                       determine where plot starts
      CALL ZFIO ('READ', LUN, FIND, 1, IOBLK, IERR)
      IF (IERR.NE.0) GO TO 980
      IORRN = (IOBLK(10) + 9) / 256 + 1
C                                       next plot command
 50   IF (IOPOS.LE.256) GO TO 60
C                                       Read record.
 55      IORRN = IORRN + 1
         CALL ZFIO ('READ', LUN, FIND, IORRN, IOBLK, IERR)
         IF (IERR.NE.0) GO TO 980
         IOPOS = 1
C                                       Transfer based on opcode.
 60   OPCODE = IOBLK(IOPOS)
      IF (OPCODE.LT.0) GO TO 970
      IF (OPCODE.EQ.0) GO TO 55
      IF (OPCODE.LE.8) GO TO (100,200,300,400,500,600,700,800), OPCODE
      IF (OPCODE.NE.32767) GO TO 970
C                                       End of file.
      IBLKNO(2) = 0
      IF (IRRN(1).EQ.-9999) GO TO 70
C                                       Save buffer one.
         ISTART = INBLK * IRRN(1)  +  2
         IEND = MIN(ISTART + INBLK - 1, IMAXS)
         ISWRD = 1
         IBLKNO(1) = (ISTART-1) * (512/NBPS) + 1
         NBYTES = (IEND-ISTART+1) * 512
         CALL ZMIO ('WRIT', IBMLUN, IBMIND, IBLKNO, NBYTES,
     *      BIGBLK(ISWRD), 1, IERR)
         IF (IERR.EQ.0) CALL ZWAIT (IBMLUN, IBMIND, 1, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Save buffer two.
 70   IF (IRRN(2).EQ.-9999) GO TO 80
         ISTART = INBLK * IRRN(2)  +  2
         IEND = MIN(ISTART + INBLK - 1, IMAXS)
         ISWRD = IMIDS
         IBLKNO(1) = (ISTART-1) * (512/NBPS) + 1
         NBYTES = (IEND-ISTART+1) * 512
         CALL ZMIO ('WRIT', IBMLUN, IBMIND, IBLKNO, NBYTES,
     *      BIGBLK(ISWRD), 1, IERR)
         IF (IERR.EQ.0) CALL ZWAIT (IBMLUN, IBMIND, 1, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       Queue bit map to printer.
 80   CALL ZCLOSE (IBMLUN, IBMIND, IERR)
      CALL ZDOPRT (ISCVOL, IBMLUN, NCOPY, SFILE, ISIZE, BIGBLK, IERR)
      IF (IERR.EQ.0) GO TO 995
         WRITE (MSGTXT,1080) IERR
         CALL MSGWRT (6)
         GO TO 995
C-----------------------------------------------------------------------
C                                       Opcode 1, initialize.
 100  CONTINUE
      ITYPE = IOBLK(IOPOS+5)
      IOPOS = IOPOS + 6
      GO TO 50
C-----------------------------------------------------------------------
C                                       Opcode 2, line drawing init.
 200  XYRATO = IOBLK(IOPOS+1) / 100.0
      SCALEF = IOBLK(IOPOS+2)
      IX1    = IOBLK(IOPOS+3)
      IY1    = IOBLK(IOPOS+4)
      IX2    = IOBLK(IOPOS+5)
      IY2    = IOBLK(IOPOS+6)
      RX1    = IOBLK(IOPOS+7)/1000.0
      RY1    = IOBLK(IOPOS+8)/1000.0
      RX2    = IOBLK(IOPOS+9)/1000.0
      RY2    = IOBLK(IOPOS+10)/1000.0
      ICHL   = (IOBLK(IOPOS+11)/10.0) * CSIZPR(1) + 0.5
      ICHB   = (IOBLK(IOPOS+12)/10.0) * (CSIZPR(2) + IYSPAC) + 0.5
      ICHR   = (IOBLK(IOPOS+13)/10.0) * CSIZPR(1) + 0.5
      ICHT   = (IOBLK(IOPOS+14)/10.0) * (CSIZPR(2) + IYSPAC) + 0.5
      IOPOS = IOPOS + 20
C                                       Find no. dots inside border.
      NXA = MAXXPR(1) - ICHL - ICHR - 4
      IF (NXA.GT.0) GO TO 210
         WRITE (MSGTXT,1200) NXA
         CALL MSGWRT (7)
         GO TO 990
C                                        self scale
 210  AX = ABS (REAL(IX2) - REAL(IX1)) * XYRATO
      AY = ABS (REAL(IY2) - REAL(IY1))
      X = ABS (IX2+RX2-IX1-RX1) * XYRATO
      Y = ABS (IY2+RY2-IY1-RY1)
      IF ((X.GT.0) .AND. (Y.GT.0)) GO TO 220
         WRITE (MSGTXT,1210) X, Y
         CALL MSGWRT (7)
         GO TO 990
 220  SCALEX = NXA/SCALEF * AX/X
      SCALEY = SCALEX * AY/AX * YMMXMM
C                                       Arcsec / mm scaling ?
      LOCNUM = 1
      AXTYP(LOCNUM) = 0
      UASPMM = ASPMM
      IF ((ITYPE.NE.2) .AND. (ITYPE.NE.3) .AND. (ITYPE.NE.6)) GO TO 223
         CALL SETLOC (IOBLK(IOPOS-5), T)
         IF (AXTYP(LOCNUM).NE.1) GO TO 223
            XPXSEP = AXINC(1,LOCNUM) * 3600.0 / XYRATO
            YPXSEP = XPXSEP
            CALL SCALMM (AX, AY, XPXSEP, YPXSEP, SCALEF, XPRDMM,
     *         YPRDMM, ASPMM, SCALEX, SCALEY)
            GO TO 225
C                                       Scale it down?
 223  IF ((ASPMM.LT.0.02) .OR. (ASPMM.GT.0.98)) GO TO 225
         AXTYP(LOCNUM) = -10
         WRITE (MSGTXT,1223) ASPMM
         CALL MSGWRT (4)
C                                       Center
 225  NXA = SCALEX * SCALEF * X/AX + ICHL + ICHR + .5
      NYA0 = SCALEY * SCALEF * Y/AY + ICHB + ICHT
C                                       Rescale to fit on page.
      IF ((NYA0.LE.MAXXPR(2)) .OR. (ICENT.EQ.-1)) GO TO 230
         NYA0 = MAXXPR(2)
         SCALEY = (NYA0 - ICHT - ICHB - 4) / SCALEF * AY / Y
         SCALEX = SCALEY * AX / AY / YMMXMM
         IF (AXTYP(LOCNUM).EQ.1) CALL SCALMM (AX, AY, XPXSEP, YPXSEP,
     *      SCALEF, XPRDMM, YPRDMM, ASPMM, SCALEX, SCALEY)
         NXA = SCALEX * SCALEF * X/AX + ICHL + ICHR
C                                       Factor it down
 230  IF (AXTYP(LOCNUM).NE.-10) GO TO 240
         SCALEX = SCALEX * ASPMM
         SCALEY = SCALEY * ASPMM * YMMXMM
         NXA = SCALEX * SCALEF * X/AX + ICHL + ICHR + .5
         NYA0 = SCALEY * SCALEF * Y/AY + ICHB + ICHT
 240  IF (IOBLK(IOPOS).NE.3) GO TO 370
C-----------------------------------------------------------------------
C                                       Opcode 3, gray scale init
 300  NPTSX = IOBLK(IOPOS+3)
      NPTSY = IOBLK(IOPOS+4)
      IGRLO = IOBLK(IOPOS+1)
      IGRHI = IOBLK(IOPOS+2)
      IF (IGRHI.LE.IGRLO) GO TO 305
      IF ((NPTSX.LE.0) .OR. (NPTSY.LE.0)) GO TO 305
C                                       Error from GINITG
      IF (NPTSX.LE.MAXXPR(1)-ICHL-ICHR) GO TO 320
 305     WRITE (MSGTXT,1305) NPTSX, NPTSY, IGRLO, IGRHI
         CALL MSGWRT (7)
         GO TO 50
C
 320  IOPOS = IOPOS + 5
      NXDPP = (NXA - ICHL - ICHR) * XYRATO / X + 0.05
      NYDPP = (NYA0 - ICHB - ICHT) / Y + 0.05
C                                       Patch on a bunch of tests to
C                                       correct bugs.
      IF (NXDPP*X/XYRATO.GT.MAXXPR(1)-ICHL-ICHR) NXDPP = NXDPP - 1
      IF (NYDPP*Y.GT.MAXXPR(2)-ICHT-ICHB) NYDPP = NYDPP - 1
      NXDPP = MAX (1, NXDPP)
      NYDPP = MAX (1, NYDPP)
      IF (NYDPP.EQ.NXDPP+1) NYDPP = NXDPP
      IF (NXDPP.EQ.NYDPP+1) NXDPP = NYDPP
C                                       reset scaling
      SCALEX = NXDPP * (AX / XYRATO) / SCALEF
      SCALEY = NYDPP * AY / SCALEF
      NXA = ICHL + ICHB + NXDPP * X / XYRATO
      NYA0 = ICHB + ICHT + NYDPP * Y
      IF (AXTYP(LOCNUM).EQ.1) ASPMM = ABS (AX*XPXSEP*XPRDMM) /
     *   (SCALEX*SCALEF)
C                                       Initialize random no. generator
      VALUE = 0.0
      NBITS = -1
      CALL GRYRAN (VALUE, NBITS, IBITS)
      NBITS = NXDPP
C                                       Array not big enough.
      IF (NBITS.LE.256) GO TO 350
         WRITE (MSGTXT,1330) NXDPP, NYDPP
         CALL MSGWRT (7)
         GO TO 990
C
 350  DOGRAY = .TRUE.
      KOFF = 1 + NXDPP / 2
      JOFF = 1 + NYDPP / 2
      GROFF = IGRLO
      GRSCAL = 1.0/(REAL(IGRHI)-REAL(IGRLO))
C                                       Init variables for progress
C                                       report.
      TOTPIX = REAL(NPTSX) * REAL(NPTSY)
      NOWPIX = 0.0
      IPER = 0
      WRITE (MSGTXT,1350)
      CALL MSGWRT (1)
C                                       set last of parms
 370  NYA = NYA0 + MAX (0, MAXXPR(2) - NYA0) / 2  + 2
      IX0 = ICHL + MAX (0, MAXXPR(1) - NXA) / 2  +  1 -
     *   RX1 * XYRATO * SCALEX * SCALEF / AX
      IY0 = ICHB +  1 - RY1 * SCALEY * SCALEF / AY
C                                       Print arc sec per mm info.
      IF (AXTYP(LOCNUM).NE.1) GO TO 380
         YASPMM = ABS (AY * AXINC(2,LOCNUM) * 3600.0 * YPRDMM)
     *      / (SCALEY * SCALEF)
         XYDIFF = ABS (ASPMM - YASPMM)
         DELTA = .05 * ASPMM
C                                       X and Y ASPMM about the same.
         IF (XYDIFF.GT.DELTA) GO TO 375
            WRITE (MSGTXT,1370) ASPMM
            CALL MSGWRT (4)
            GO TO 379
C                                       Using different X and Y ASPMM
 375     CONTINUE
            WRITE (MSGTXT,1375) ASPMM
            CALL MSGWRT (4)
            WRITE (MSGTXT,1376) YASPMM
            CALL MSGWRT (4)
C                                       changed user's ASPMM
 379     IF ((UASPMM.LE.0.0) .OR. (UASPMM.GE.ASPMM)) GO TO 380
            WRITE (MSGTXT,1379)
            CALL MSGWRT (4)
C                                       Open bit map file.
 380  CALL PRBMCR (IVOL, IBMLUN, IBMIND, MAXXPR(1), NYA,
     *   SFILE, ISCVOL, IBLKS, WORDS, BIGBLK, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Set common variables.
      IMAXS = IBLKS
      XMWPF = WORDS
      XWPL = (MAXXPR(1) - 1) / NBITWD + 1
      IMIDS = ISIZE / 2  +  1
      INBLK = (ISIZE / 2) / 256
      XWPP = INBLK * 256
      MAXXPR(2) = NYA
      IRRN(1) = -9999
      IRRN(2) = -9999
C                                       Initialize bit map file.
      CALL PRFINT (NYA, IBMLUN, IBMIND, IOPOS, IOBLK, ISIZE, BIGBLK,
     *   IERR)
      IF (IERR.NE.0) GO TO 980
      WRITE (MSGTXT,1380)
      CALL MSGWRT (1)
      GO TO 50
C-----------------------------------------------------------------------
C                                       Opcode 4, position cursor.
 400  IX = IOBLK(IOPOS+1)
      IY = IOBLK(IOPOS+2)
      IOPOS = IOPOS + 3
      CALL PRTVEC (IX, IY, 1, IBMLUN, IBMIND, BIGBLK, IERR)
      IF (IERR.EQ.0) GO TO 50
      IF (IERR.NE.2) GO TO 960
         IERRC = IERRC + 1
         GO TO 50
C-----------------------------------------------------------------------
C                                       Opcode 5, draw vector.
 500  IX = IOBLK(IOPOS+1)
      IY = IOBLK(IOPOS+2)
      IOPOS = IOPOS+3
      CALL PRTVEC (IX, IY, 2, IBMLUN, IBMIND, BIGBLK, IERR)
      IF (IERR.EQ.0) GO TO 50
      IF (IERR.NE.2) GO TO 960
         IERRC = IERRC + 1
         GO TO 50
C-----------------------------------------------------------------------
C                                       Opcode 6, write characters.
 600  NCHAR = IOBLK(IOPOS+1)
      IANGL = IOBLK(IOPOS+2)
      DX    = IOBLK(IOPOS+3)/100.0
      DY    = IOBLK(IOPOS+4)/100.0
      IX = IXL + DX * CSIZPR(1)
      IY = IYL + DY * (CSIZPR(2) + IYSPAC)
      CALL PRTVEC (IX, IY, I3, IBMLUN, IBMIND, BIGBLK, IERR)
      IF (IERR.EQ.0) THEN
         CALL H2CHR (NCHAR, 1, HOBLK(IOPOS+5), STRING)
         CALL PRCHAR (NCHAR, IANGL, STRING, IBMLUN, IBMIND, BIGBLK,
     *      IERR)
         END IF
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 960
      IOPOS = IOPOS + 5 + ((NCHAR+3)/4)
      GO TO 50
C-----------------------------------------------------------------------
C                                       Opcode 7, write grey scale.
C                                       ignore gray scale
 700  IF (DOGRAY) GO TO 710
         GRYERR = GRYERR + 1
C                                       Update IO position. Read
C                                       proper RRN if necessary.
         IOPOS = IOPOS + 3 + IOBLK(IOPOS+1)
         IF (IOPOS.LE.256) GO TO 60
C                                       Update position & buffer.
            INCRRN = (IOPOS-1)/256
            IORRN = IORRN + INCRRN
            IOPOS = IOPOS - 256*INCRRN
            CALL ZFIO ('READ', LUN, FIND, IORRN, IOBLK, IERR)
            IF (IERR.EQ.0) GO TO 60
            GO TO 980
C                                       Get gray values from record(s).
 710  NPIX = IOBLK(IOPOS+1)
      IANGL = IOBLK(IOPOS+2)
      IOPOS = IOPOS + 3
      IF (NPIX.LE.0) GO TO 50
C                                       Set bits for each pixel.
      DO 790 N = 1,NPIX
C                                       Need another buffer of G values
         IF (IOPOS.LE.256) GO TO 720
            IORRN = IORRN + 1
            CALL ZFIO ('READ', LUN, FIND, IORRN, IOBLK, IERR)
            IF (IERR.NE.0) GO TO 980
            IOPOS = 1
C
 720     VALUE = (IOBLK(IOPOS) - GROFF) * GRSCAL
C                                       Loop for each bit in pixel.
         IERR = 0
         DO 750 J = 1,NYDPP
            CALL GRYRAN (VALUE, NBITS, IBITS)
            L = 0
            NPTS = 0
            DO 730 K = 1,NXDPP
               L = L + 1
               IF (IBITS(L).EQ.0) GO TO 730
                  NPTS = NPTS + 1
                  IXPT(NPTS) = IXL + K - KOFF
                  IYPT(NPTS) = IYL + J - JOFF
 730           CONTINUE
            IF (NPTS.NE.0) CALL PRSBIT (IXPT, IYPT, NPTS, IBMLUN,
     *         IBMIND, BIGBLK, IERR)
            IF (IERR.NE.0) GO TO 980
 750        CONTINUE
C
         IF (IANGL.EQ.0) IXL = IXL + NXDPP
         IF (IANGL.NE.0) IYL = IYL + NYDPP
         IOPOS = IOPOS + 1
 790     CONTINUE
      NOWPIX = NOWPIX + NPIX
      IPER2 = INT(5.0 * NOWPIX / TOTPIX)
      IF (IPER2.EQ.IPER) GO TO 50
C                                       Write progress report.
      IPER = 20*IPER2
      WRITE (MSGTXT,1790) IPER
      IPER = IPER2
      CALL MSGWRT (1)
      GO TO 50
C-----------------------------------------------------------------------
C                                       Opcode 8 from GMCAT, ignore.
 800  IOPOS = IOPOS + 2 + IOBLK(IOPOS+1)
      GO TO 50
C-----------------------------------------------------------------------
C                                       Write error.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      GO TO 990
C                                       Invalid opcode.
 970  WRITE (MSGTXT,1970) OPCODE, IOPOS, IORRN
      CALL MSGWRT (8)
      GO TO 990
C                                       Disk error.
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (8)
C                                       Close files.
 990  CALL ZCLOSE (IBMLUN, IBMIND, IERR2)
      IF (GRYERR.EQ.0) GO TO 995
         WRITE (MSGTXT,1990) GRYERR
         CALL MSGWRT (3)
C
 995  IF (IERRC.LE.0) GO TO 999
         WRITE (MSGTXT,1995) IERRC
         CALL MSGWRT (3)
C
 999  RETURN
C-----------------------------------------------------------------------
 1080 FORMAT ('PRTDRW: BIT MAP CREATED BUT COULD NOT WRITE TO PRINTER',
     *   I7)
 1200 FORMAT ('PRTDRW: ERR FROM GINITL ARGS. NXA=',I6)
 1210 FORMAT ('PRTDRW: ERR FROM GINITL ARGS. X,Y=',2E10.3)
 1223 FORMAT ('Plot reduced in size by factor',F6.3)
 1305 FORMAT ('PRTDRW: ERROR FROM GINITG',4I6)
 1330 FORMAT ('PRTDRW: ARRAY FOR BITS TOO SMALL. BITS=',I5,'X',I5)
 1350 FORMAT ('Random number generator initialized')
 1370 FORMAT ('Using',1PE12.5,' arc sec per mm')
 1375 FORMAT ('Using',1PE12.5,' arc sec per mm for x axis')
 1376 FORMAT ('Using',1PE12.5,' arc sec per mm for y axis')
 1379 FORMAT ('Overriding user aspmm in order to fit plot on page')
 1380 FORMAT ('Bit map file initialized')
 1790 FORMAT (I3,' %  of grey scale pixels plotted')
 1960 FORMAT ('PRTDRW: WRITE ERROR LIMIT EXCEEDED')
 1970 FORMAT ('PRTDRW: INVALID OPCODE',I6,' AT POS,REC',2I6)
 1980 FORMAT ('PRTDRW: DISK IO RELATED ERROR',I3)
 1990 FORMAT ('PRTDRW: ',I5,' grey scale opcodes ignored')
 1995 FORMAT (I8,' vectors truncated at edges')
      END
      SUBROUTINE PRTVEC (IX, IY, IN, ILUN, IND, SCRTCH, IERR)
C-----------------------------------------------------------------------
C   PRTVEC scales coordinates, sets bits to represent lines in
C   the bit map and saves latest coordinate values.
C   Inputs: IX      I         X position
C           IY      I         Y position
C           IN      I         1 => scale IX,IY but no vector
C                             2 => scale IX,IY write vector
C                             3 => no scaling, no vector
C                             4 => no scaling, write vector
C           ILUN    I         bit map file logical unit number.
C           IND     I         pointer to bit map info in FTAB.
C   Output: SCRTCH  I(??)    scratch buffer
C           IERR    I         error code of ZMI3
C-----------------------------------------------------------------------
      INTEGER   IX, IY, IN, ILUN, IND, SCRTCH(*), IERR
C
      REAL      T, XI, XMAX, ALPHA, BETA
      INTEGER   IXT(2), IYT(2), I, IMAX, IXN, IYN, X1, X2, Y1, Y2,
     *   IABSX, IABSY
      LOGICAL   ISERR
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'PRTPL.INC'
C-----------------------------------------------------------------------
C                                        scale
      IERR = 0
      ISERR = .FALSE.
      IXN = IX
      IYN = IY
      IF (IN.GT.2) GO TO 10
         IXN = IXN * SCALEX  +  IX0 + 0.5
         IYN = IYN * SCALEY  +  IY0 + 0.5
C                                        test
 10   IF ((IN.NE.2) .AND. (IN.NE.4)) GO TO 50
         X1 = MAX (1, MIN (MAXXPR(1), IXL))
         X2 = MAX (1, MIN (MAXXPR(1), IXN))
         Y1 = MAX (1, MIN (MAXXPR(2), IYL))
         Y2 = MAX (1, MIN (MAXXPR(2), IYN))
         IF ((X1.EQ.IXL) .AND. (Y1.EQ.IYL)) GO TO 15
            ALPHA = 1.0
            IF (IXL.NE.IXN) ALPHA = REAL(X1-IXL)/REAL(IXN-IXL)
            BETA = 1.0
            IF (IYL.NE.IYN) BETA = REAL(Y1-IYL)/REAL(IYN-IYL)
            ALPHA = MIN (ALPHA, BETA)
            X1 = IXL + ALPHA * (IXN-IXL)
            Y1 = IYL + ALPHA * (IYN-IYL)
            ISERR = .TRUE.
 15      IF ((X2.EQ.IXN) .AND. (Y2.EQ.IYN)) GO TO 20
            ALPHA = 1.0
            IF (IXL.NE.IXN) ALPHA = REAL(X2-IXL)/REAL(IXN-IXL)
            BETA = 1.0
            IF (IYL.NE.IYN) BETA = REAL(Y2-IYL)/REAL(IYN-IYL)
            ALPHA = MIN (ALPHA, BETA)
            X2 = IXL + ALPHA * (IXN-IXL)
            Y2 = IYL + ALPHA * (IYN-IYL)
            ISERR = .TRUE.
 20      CONTINUE
C                                       Check for entire line off plot.
         IF ((X1.LT.1) .OR. (X1.GT.MAXXPR(1)) .OR.
     *      (Y1.LT.1) .OR. (Y1.GT.MAXXPR(2)) .OR.
     *      (X2.LT.1) .OR. (X2.GT.MAXXPR(1)) .OR.
     *      (Y2.LT.1) .OR. (Y2.GT.MAXXPR(2)) ) GO TO 50
C                                       Proceed to draw vector
            XI = 0.0
            IABSX = ABS (X1 - X2)
            IABSY = ABS (Y1 - Y2)
            IMAX = MAX (IABSX, IABSY)
            XMAX = IMAX
            IF (IMAX.EQ.0) XMAX = 1.0
C                                       Loop and set bits between end
C                                       points.
            IMAX = IMAX + 1
            DO 35 I = 1,IMAX
               T = XI / XMAX
C                                       Double wide lines.
C                                       horizontal widening
               IF (IABSX.GT.IABSY) GO TO 25
                  IXT(1) = REAL(X1) + REAL(X2 - X1) * T +
     *               0.5 * (2-LINWID)
                  IXT(2) = IXT(1) + 1
                  IYT(1) = REAL(Y1) + REAL(Y2 - Y1) * T + .5
                  IYT(2) = IYT(1)
                  GO TO 30
C                                       vertical widening
 25            CONTINUE
                  IYT(1) = REAL(Y1) + REAL(Y2 - Y1) * T +
     *               0.5 * (2-LINWID)
                  IYT(2) = IYT(1) + 1
                  IXT(1) = REAL(X1) + REAL(X2 - X1) * T + .5
                  IXT(2) = IXT(1)
 30            XI = XI + 1.0
               CALL PRSBIT (IXT, IYT, LINWID, ILUN, IND, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 50
 35            CONTINUE
C                                        set last position
 50   IXL = IXN
      IYL = IYN
      IF ((IERR.EQ.0) .AND. (ISERR)) IERR = 2
C
 999  RETURN
      END
      SUBROUTINE PRFINT (NYA, IBMLUN, IBMIND, IOPOS, IOBLK, ISIZE,
     *   ISCBLK, IERR)
C-----------------------------------------------------------------------
C   PRFINT will find the first 'long' vertical line (.25 of maximum
C   vertical) and a second vertical line with corresponding Y end
C   points (if the commands for this line is in the first block of
C   graphics commands).  The bits representing these lines are set
C   during initialization of the bit map file.
C   INPUTS:   NYA     I        The number of print lines in the bit map
C                              bit map file.
C             IBMLUN  I        The bit map file LUN.
C             IBMIND  I        The bit map file FTAB position.
C             IOPOS   I        The position in the block containing the
C                              graphics commands to start looking.
C             IOBLK   I(256)   The buffer containing the graphics
C                              commands.
C             ISIZE   I        Size of ISCBLK in words
C             ISCBLK  I(***)   Scratch buffer used for I/O.
C   COMMON:   IMAXS   I        Maximum number of sectors in the file.
C   OUTPUT:   IERR    I        Error code. 0=ok; 1=I/O error.
C-----------------------------------------------------------------------
      INTEGER   IBITS(64), IOBLK(256), ISCBLK(*), IWINC(4), ISIZE,
     *   IWORD(4), IXS(3), IFCHAR, IACHAR, IBLKNO(2), NBYTES,
     *   I2POS, IOPOS, IN, IBLK, IEBLK, ICODE, IX, IY,
     *   IDUM, IERR, IX1, IY1, NYA, IYTOP, IYBOT, NCHAR, IANGLE,
     *   IWOUT, ITEMP, IWPL, ITX, ISBLK, INW, ISTART, I, IBIT, INDEX,
     *   IBMLUN, IBMIND, IWRD, J
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'PRTPL.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IFCHAR = 1 - IXBIT
      CALL FILL (NBITWD, IFCHAR, IBITS)
      CALL ZPTBIT (NBITWD, IACHAR, IBITS)
      I2POS = IOPOS
      IN = 0
      IBLK = 0
      IEBLK = 1
C                                       look for vertical lines
 100  IF (I2POS.GT.256) GO TO 800
      ICODE = IOBLK(I2POS)
      IF ((ICODE.LT.1) .OR. (ICODE.GT.8)) GO TO 800
      GO TO (800, 800, 800, 400, 500, 600, 800, 200) , ICODE
C                                       Catalog info command
 200  I2POS = I2POS + 2 + IOBLK(I2POS+1)
      GO TO 100
C                                       position command
 400  IX = IOBLK(I2POS+1)
      IY = IOBLK(I2POS+2)
      I2POS = I2POS + 3
      CALL PRTVEC (IX, IY, 1, IDUM, IDUM, ISCBLK, IERR)
      GO TO 100
C                                       vector command
 500  IX = IOBLK(I2POS+1)
      IY = IOBLK(I2POS+2)
      I2POS = I2POS + 3
      IX1 = IXL
      IY1 = IYL
      CALL PRTVEC (IX, IY, 1, IDUM, IDUM, ISCBLK, IERR)
C                                       see if line vert & long
      IF (IX1.NE.IXL) GO TO 100
      IF (ABS(IYL-IY1).LT..25*NYA) GO TO 100
C                                       See if 1st line.
      IF (IN.EQ.0) GO TO 550
C                                       Not first line.
         IF (MAX (IY1, IYL).NE.IYTOP) GO TO 100
         IF (MIN (IY1, IYL).NE.IYBOT) GO TO 100
C                                       we found long vert line
 550  IN = IN + 1
C                                       set code to position
      IOBLK(I2POS-3) = 4
      IXS(IN) = IX1
      IYTOP = MAX(IY1, IYL)
      IYBOT = MIN(IY1, IYL)
      IF (IN.GE.2) GO TO 800
      GO TO 100
C                                       character string command
 600  NCHAR = IOBLK(I2POS+1)
      IANGLE = IOBLK(I2POS+2)
      I2POS = I2POS + 5 + ((NCHAR+3)/4)
      IF (I2POS.GT.256)  GO TO 800
C                                       horizontal string
      IF (IANGLE.EQ.1) GO TO 650
         IXL = IXL + NCHAR * CSIZPR(1)
         GO TO 100
C                                       vertical string
 650  IXL = IXL + CSIZPR(1)
      IYL = IYL - NCHAR * CSIZPR(2)
      GO TO 100
C                                       Init & draw vertical lines
C                                       Put no. of lines in block 1
 800  CALL FILL (ISIZE, IACHAR, ISCBLK)
      ISCBLK(1) = NYA
      NBYTES = 2 * ISIZE
      IBLKNO(2) = 0
      IBLKNO(1) = 1
      IWOUT = 256
      IEBLK = 1
      IF (IN.EQ.0) GO TO 885
      IF (IN.EQ.1) GO TO 830
C                                       Sort X values.
      IF (IXS(1).LT.IXS(2)) GO TO 830
         ITEMP = IXS(1)
         IXS(1) = IXS(2)
         IXS(2) = ITEMP
C                                       Calculate start-stop blocks
 830  IWPL = (MAXXPR(1)-1) / NBITWD + 1
      ITX = (IXS(1) - 1) / NBITWD
      ISBLK = (REAL(NYA - IYTOP) * REAL(IWPL) + REAL(ITX))
     *   / 256.0  +  2.001
      IEBLK = ISBLK + REAL(IYTOP - IYBOT + 1) * REAL(IWPL)
     *   / 256.0 + .001
C                                       calculate words, increments
      INW = 0
      IXS(IN+1) = IWPL * NBITWD + IXS(1)
      ISTART = REAL(IWPL) * REAL(NYA-IYTOP) + REAL(ITX) -
     *   REAL(ISBLK-2) * 256.0  +  1.001
C                                       Loop for number of vert lines.
      DO 850 I = 1,IN
         CALL FILL (NBITWD, IFCHAR, IBITS)
         INW = INW + 1
C                                       Calculate inc to this word.
         IWINC(INW) = (IXS(I+1)-1)/NBITWD  - (IXS(I)-1)/NBITWD
C                                       Calculate and set bit for word.
         IBIT = NBITWD - MOD(IXS(I)-1, NBITWD)
         IBITS(IBIT) = IXBIT
C                                       Set 2nd bit for wide line.
         IBIT = IBIT - 1
         IF (IBIT.GT.0) GO TO 840
C                                       2 words required.
            CALL ZPTBIT (NBITWD, IWORD(INW), IBITS)
            INW = INW + 1
            IWINC(INW) = IWINC(INW-1) - 1
            IWINC(INW-1) = 1
            IBITS(1) = IFCHAR
            IBIT = NBITWD
 840     IF (LINWID.GT.1) IBITS(IBIT) = IXBIT
         CALL ZPTBIT (NBITWD, IWORD(INW), IBITS)
 850     CONTINUE
C                                       loop up to start of line
      INDEX = ISBLK - 1
      IF (INDEX.LT.2) GO TO 865
         DO 860 IBLK = 2,INDEX
            IWOUT = IWOUT + 256
            IF (IWOUT.LT.ISIZE) GO TO 860
               CALL ZMIO ('WRIT', IBMLUN, IBMIND, IBLKNO, NBYTES,
     *            ISCBLK, 1, IERR)
               IF (IERR.EQ.0) CALL ZWAIT (IBMLUN, IBMIND, 1, IERR)
               IF (IERR.NE.0) GO TO 980
                  IWOUT = 0
                  IBLKNO(1) = IBLKNO(1) + NBYTES/NBPS
                  ISCBLK(1) = IACHAR
 860        CONTINUE
C                                       write vertical lines
 865  IWRD = ISTART
      IBLK = ISBLK
C                                       Loop for all lines.
      DO 880 I = IYBOT,IYTOP
C                                       Loop for words to set per line.
         DO 875 J = 1,INW
            ISCBLK(IWRD+IWOUT) = IWORD(J)
            IWRD = IWRD + IWINC(J)
            IF (IWRD.LE.256) GO TO 875
               IWRD = IWRD - 256
               IWOUT = IWOUT + 256
               IBLK = IBLK + 1
               IF (IWOUT.LT.ISIZE) GO TO 875
                  CALL ZMIO ('WRIT', IBMLUN, IBMIND, IBLKNO, NBYTES,
     *               ISCBLK, 1, IERR)
                  IF (IERR.EQ.0) CALL ZWAIT (IBMLUN, IBMIND, 1, IERR)
                  IF (IERR.NE.0) GO TO 980
                     IWOUT = 0
                     IBLKNO(1) = IBLKNO(1) + NBYTES/NBPS
                     CALL FILL (ISIZE, IACHAR, ISCBLK)
 875        CONTINUE
 880     CONTINUE
C                                       finish rest of file
 885  INDEX = IEBLK + 1
      IF (INDEX.GT.IMAXS) GO TO 900
         DO 890 IBLK = INDEX, IMAXS
            IWOUT = IWOUT + 256
            IF (IWOUT.LT.ISIZE) GO TO 890
               CALL ZMIO ('WRIT', IBMLUN, IBMIND, IBLKNO, NBYTES,
     *            ISCBLK, 1, IERR)
               IF (IERR.EQ.0) CALL ZWAIT (IBMLUN, IBMIND, 1, IERR)
               IF (IERR.NE.0) GO TO 980
                  IWOUT = 0
                  IBLKNO(1) = IBLKNO(1) + NBYTES/NBPS
                  CALL FILL (ISIZE, IACHAR, ISCBLK)
 890        CONTINUE
 900  IF (IWOUT.LE.0) GO TO 999
         NBYTES = 2 * IWOUT
         CALL ZMIO ('WRIT', IBMLUN, IBMIND, IBLKNO, NBYTES, ISCBLK, 1,
     *      IERR)
         IF (IERR.EQ.0) CALL ZWAIT (IBMLUN, IBMIND, 1, IERR)
         IF (IERR.EQ.0) GO TO 999
C                                       I/O error.
 980  WRITE (MSGTXT,1980) IERR
      IERR = 1
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1980 FORMAT ('I/O ERROR FROM ZMIO WHILE INITIALIZING BIT MAP. IER=',I5)
      END

      PROGRAM TKPL
C-----------------------------------------------------------------------
C! Plots an AIPS plot (PL) file on a graphics device.
C# EXT-appl Graphics
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2002-2003, 2006, 2009, 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TKPL is a program for the graphics package. The program
C   runs as a detached task initiated from AIPS. First a cataloged
C   file is found using data passed from AIPS.  The list of
C   associated files is searched for a PLot file corresponding
C   to the version number.  The graphics commands in this file
C   are executed for the Tektronix 4012.
C   Inputs:  (from AIPS)
C      INNAME   H*12  Name of primary file.
C      INCLASS  H*6   Class of primary file.
C      INSEQ    R     Sequence number of primary file.
C      INDISK   R     Disk volume number. 0 means try all.
C      INVERS   R     Extension file version number. 0 means.
C                       use the highest version number.
C      ASPMM    R      arc sec per millimeters. 0 means self scale.
C-----------------------------------------------------------------------
      CHARACTER NAMIN*12, CLSIN*6, TYPIN*2, STATUS*4, NAME*6, GFILE*48,
     *   SCRTCH*132
      HOLLERITH XNAMIN(3), XCLSIN(2)
      REAL      DSKIN, SEQIN, VERSN, ASPMM
      INTEGER   BUFFER(256), CATERR, LUN, FIND, IERR, NPARMS, RETCOD,
     *   SLOT, IVER, IPLANE, IVOL, ISEQ, IERR2, USER, IROUND, INLUN, NC
      LOGICAL   NOMAP, QUICK, NOEXCL, WAIT, EQUAL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DTKS.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /INPARM/ XNAMIN, XCLSIN, SEQIN, DSKIN, VERSN, ASPMM
      DATA NAME /'TKPL  '/
      DATA NOMAP, NOEXCL, WAIT /.FALSE.,.FALSE.,.TRUE./
      DATA INLUN, LUN /5, 26/
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE., BUFFER)
      CALL VHDRIN
C                                       Get input values from AIPS.
      NPARMS = 9
      CALL GTPARM (NAME, NPARMS, QUICK, XNAMIN, BUFFER, IERR)
      RETCOD = IERR
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 20
         END IF
      IF (NPOPS.LE.NTKACC) GO TO 20
         WRITE (MSGTXT,1010)
         CALL MSGWRT (8)
         RETCOD = 8
 20   IF (QUICK) THEN
         CALL RELPOP (RETCOD, BUFFER, IERR2)
      ELSE
         MSGTXT = 'Type Return after Plot is finished to continue'
         CALL MSGWRT(3)
         END IF
      IF (RETCOD.NE.0) GO TO 995
C                                       Get map header.
      ISEQ = IROUND (SEQIN)
      IVOL = IROUND (DSKIN)
      USER = NLUSER
      IVER = IROUND (VERSN)
C                                       Character inputs
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
      TYPIN = ' '
      SLOT = 1
      CALL CATDIR ('SRCH', IVOL, SLOT, NAMIN, CLSIN, ISEQ, TYPIN, USER,
     *   STATUS, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (8)
         GO TO 995
         END IF
C                                       Read catalog header.
      CALL CATIO ('READ', IVOL, SLOT, CATBLK, 'REST', BUFFER, CATERR)
      IF ((CATERR.EQ.0) .OR. (CATERR.EQ.6)) GO TO 50
 40      WRITE (MSGTXT,1040) IERR
         CALL MSGWRT (8)
         GO TO 995
C                                        Find plot file:
C                                        if PL & IVER=0, then main file
 50   EQUAL = TYPIN(1:2) .EQ. 'PL'
      IF ((EQUAL) .AND. (CATERR.EQ.6)) GO TO 40
      IF ((EQUAL) .AND. (IVER.EQ.0)) IVER = CATBLK(KIIMS)
C                                        else take IVER as given or
C                                        as max version #
      IF (IVER.LE.0) CALL FNDEXT ('PL', CATBLK, IVER)
C                                       PLot file not found.
      IF (IVER.LE.0) THEN
         WRITE (MSGTXT,1060)
         CALL MSGWRT (8)
         GO TO 995
         END IF
C                                       Build file name.
      CALL ZPHFIL ('PL', IVOL, SLOT, IVER, GFILE, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Open graphics file.
      CALL ZOPEN (LUN, FIND, IVOL, GFILE, NOMAP, NOEXCL, WAIT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1070)
         CALL MSGWRT (8)
         GO TO 995
         END IF
C                                       Open TEKTRONICS device.
      CALL ZTKOPN (IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TEKTRONIX OPEN ERROR'
         CALL MSGWRT (8)
         GO TO 990
         END IF
C                                       init TK catalog
      CALL TKCATL ('INIT', IPLANE, IPLANE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 980
      CATBLK(IIVOL) = IVOL
      CATBLK(IICNO) = SLOT
C                                       Write to Tektronix 4012.
      CALL TEKDRW (LUN, FIND, ASPMM, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1080)
         CALL MSGWRT (8)
         GO TO 980
         END IF
C                                       update TK catalog
      CALL TKCATL ('WRIT', IPLANE, IPLANE, CATBLK, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1090) IERR
         CALL MSGWRT (6)
         END IF
C                                       Close TEK
 980  CALL ZTKCLS (IERR)
C                                       Close graph file.
 990  CALL ZCLOSE (LUN, FIND, IERR)
C                                       Get user input before quiting
      IF (.NOT.QUICK .AND. ISBTCH.NE.1) THEN
         CALL ZTTOPN (INLUN, FIND, IERR)
         NC = 1
         CALL ZTTYIO ('READ', INLUN, FIND, NC, SCRTCH, IERR)
         CALL ZTTCLS (INLUN, FIND, IERR)
         END IF

 995  CALL DIETSK (RETCOD, QUICK, BUFFER)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('COULD NOT GET INPUTS FROM AIPS. GTPARM ERR =',I5)
 1010 FORMAT ('TEK DEVICES ALL IN USE')
 1020 FORMAT ('CATALOG ENTRY NOT FOUND. CATDIR ERR =',I5)
 1040 FORMAT ('ERROR READING CATALOG HEADER. CATIO ERR =',I5)
 1060 FORMAT ('PLOT FILE NOT IN CATALOG')
 1070 FORMAT ('PLOT FILE NOT FOUND')
 1080 FORMAT ('ERROR WRITING TO TEKTRONIX DEVICE')
 1090 FORMAT ('ERROR ',I3,' UPDATING TEK CATALOG')
      END
      SUBROUTINE TEKDRW (LUN, FIND, ASPMM, IERR)
C-----------------------------------------------------------------------
C   This routine will execute the commands in a graph file for the
C   TEKTRONIX 4012.
C   Inputs:  LUN     I   logical unit number of an open graph file.
C            FIND    I   pointer to the FTAB info of the graph file.
C            ASPMM   R   user requested arc sec / mm
C            IERR    I   error code. 0 = ok.
C-----------------------------------------------------------------------
      CHARACTER LINE*132
      REAL   DX, DY, SCALEF, X, XYRATO, RX1, RX2, RY1, RY2, AX, AY, Y,
     *   ASPMM, XPXSEP, YPXSEP, YTKDMM, UASPMM, XYDIFF, YASPMM, DELTA
      LOGICAL   T
      INTEGER   ITYPE, FIND, GRYERR, INO, IANGL, ICHB, ICHL, ICHR, ICHT,
     *   IERR, IERR2, INCRRN, IOPOS, IORRN, IT, IX1, IY1, LUN, NXA, NYA,
     *   OPCODE, IOBUF(256), IERRC, IERRLM, IX2, IY2, NCHAR
      HOLLERITH HOBUF(256)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DTKS.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (HOBUF, IOBUF)
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Initialize all values.
C                                       Assume symetric device for now.
      YTKDMM = XTKDMM
      IERR = 0
      IERRLM = 20
      IERRC = 0
      GRYERR = 0
      IOPOS = 9999
C                                       determine where plot starts
      CALL ZFIO ('READ', LUN, FIND, 1, IOBUF, IERR)
      IF (IERR.NE.0) GO TO 980
      IORRN = (IOBUF(10) + 9) / 256 + 1
      IF (IOBUF(3).GT.0) IORRN = IORRN + 1
C                                       next plot command
C                                       Read record.
 50   IF (IOPOS.LE.256) GO TO 60
 55      IORRN = IORRN + 1
         CALL ZFIO ('READ', LUN, FIND, IORRN, IOBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         IOPOS = 1
C                                       Transfer based on opcode.
 60   OPCODE = IOBUF(IOPOS)
      IF ((OPCODE.GT.0) .AND. (OPCODE.LE.18)) GO TO (100, 200,
     *   300, 400, 500, 600, 700, 800, 150, 500, 700, 300, 300, 600,
     *   600, 160, 500, 810), OPCODE
      IF (OPCODE.EQ.0) GO TO 55
C                                       End of file.
      IF (OPCODE.NE.32767) GO TO 970
         GO TO 990
C                                       Opcode 1, initialize.
C                                       Put map type in image header.
 100  ITYPE = IOBUF(IOPOS+5)
      CATBLK(IIPLT) = ITYPE
      IOPOS = IOPOS + 6
      GO TO 50
C                                       Opcode 9, line type (ignored)
 150  IOPOS = IOPOS + 2
      GO TO 50
C                                       Opcode 16, 3-color color
C                                       (ignored)
 160  IOPOS = IOPOS + 4
      GO TO 50
C                                       Opcode 2, line drawing init.
 200  XYRATO = IOBUF(IOPOS+1) / 100.0
      SCALEF = IOBUF(IOPOS+2)
      IX1    = IOBUF(IOPOS+3)
      IY1    = IOBUF(IOPOS+4)
      IX2    = IOBUF(IOPOS+5)
      IY2    = IOBUF(IOPOS+6)
      RX1    = IOBUF(IOPOS+7)/1000.0
      RY1    = IOBUF(IOPOS+8)/1000.0
      RX2    = IOBUF(IOPOS+9)/1000.0
      RY2    = IOBUF(IOPOS+10)/1000.0
      ICHL   = (IOBUF(IOPOS+11)/10.0) * CSIZTK(1)  +  0.5
      ICHB   = (IOBUF(IOPOS+12)/10.0) * CSIZTK(2)  +  0.5
      ICHR   = (IOBUF(IOPOS+13)/10.0) * CSIZTK(1)  +  0.5
      ICHT   = (IOBUF(IOPOS+14)/10.0) * CSIZTK(2) +  0.5
      IOPOS = IOPOS + 15
C                                       Find no. pixels inside border.
      NYA = MAXXTK(2) - ICHT - ICHB - 1
      NXA = MAXXTK(1) - ICHL - ICHR - 1
      IF ((NXA.GT.0) .AND. (NYA.GT.0)) GO TO 210
         WRITE (MSGTXT,1200) NXA, NYA
         CALL MSGWRT (7)
         GO TO 990
C                                       Compute scaling: sizes
 210  AX = ABS(IX2 - IX1) * XYRATO
      AY = ABS(IY2 - IY1)
      X = ABS(IX2+RX2-IX1-RX1) * XYRATO
      Y = ABS(IY2+RY2-IY1-RY1)
      IF ((X.GT.0) .AND. (Y.GT.0)) GO TO 220
         WRITE (MSGTXT,1210) X, Y
         CALL MSGWRT (7)
         GO TO 990
C                                       Factors
 220  IF ((X/Y).GT.FLOAT(NXA)/FLOAT(NYA)) GO TO 225
         SCALEY = NYA/SCALEF * AY/Y
         SCALEX = SCALEY * AX/AY
         GO TO 230
 225     SCALEX = NXA/SCALEF * AX/X
         SCALEY = SCALEX * AY/AX
C                                       Mm / arc sec scaling
 230  LOCNUM = 1
      IF ((ITYPE.EQ.2) .OR. (ITYPE.EQ.3) .OR. (ITYPE.EQ.6) .OR.
     *   (ITYPE.EQ.18) .OR. (ITYPE.EQ.27) .OR. (ITYPE.EQ.28) .OR.
     *   (ITYPE.EQ.29)) THEN
         CALL SETLOC (IOBUF(IOPOS), T)
         IF (AXTYP(LOCNUM).EQ.1) THEN
            XPXSEP = AXINC(1,LOCNUM) * 3600.0 / XYRATO
            YPXSEP = XPXSEP
C                                       odd: but XYRATO has AXINC(1)/(2)
            UASPMM = ASPMM
            CALL SCALMM (AX, AY, XPXSEP, YPXSEP, SCALEF, XTKDMM,
     *         YTKDMM, ASPMM, SCALEX, SCALEY)
            YASPMM = ABS (AY * AXINC(2,LOCNUM) * 3600.0 * YTKDMM)
     *         / (SCALEY * SCALEF)
            XYDIFF = ABS (ASPMM - YASPMM)
            DELTA = .05 * ASPMM
C                                       X and Y ASPMM about the same.
            IF (XYDIFF.LE.DELTA) THEN
               WRITE (MSGTXT,1230) ASPMM
               CALL MSGWRT (4)
C                                       Using different X and Y ASPMM
            ELSE
               WRITE (MSGTXT,1232) ASPMM
               CALL MSGWRT (4)
               WRITE (MSGTXT,1233) YASPMM
               CALL MSGWRT (4)
               END IF
C
            IF ((UASPMM.GT.0.0) .AND. (UASPMM.LT.ASPMM)) THEN
               WRITE (MSGTXT,1234)
               CALL MSGWRT (2)
               END IF
            END IF
         END IF
C                                        Center
      NXA = SCALEX*SCALEF*X/AX + ICHL + ICHR
      RX0 = ICHL + MAX(0,MAXXTK(1)-NXA)/2 + 1
      NYA = SCALEY*SCALEF*Y/AY + ICHB + ICHT
      RY0 = ICHB + MAX(0,MAXXTK(2)-NYA)/2 + 1
C                                        upgrade catalog header
      CATBLK(IIWIN  ) = IX1
      CATBLK(IIWIN+1) = IY1
      CATBLK(IIWIN+2) = IX2
      CATBLK(IIWIN+3) = IY2
      CALL COPY (5, IOBUF(IOPOS), CATBLK(IIDEP))
      IOPOS = IOPOS + 5
      RX0 = RX0 - RX1 * XYRATO * SCALEX * SCALEF / AX
      RY0 = RY0 - RY1 * SCALEY * SCALEF / AY
      CATBLK(IICOR  ) = RX0 + 0.5
      CATBLK(IICOR+1) = RY0 + 0.5
      CATBLK(IICOR+2) = RX0 + SCALEX*SCALEF + 0.5
      CATBLK(IICOR+3) = RY0 + SCALEY*SCALEF + 0.5
C                                       Clear screen.
      CALL TKCLR (IERR)
      GO TO 50
C                                       Opcode 3, grey scale init.
 300  IOPOS = IOPOS + 5
      IF (OPCODE.EQ.13) IOPOS = IOPOS + 3
      IF (OPCODE.EQ.12) IOPOS = IOPOS + 7
      GO TO 50
C                                       Opcode 4, position cursor.
 400  X = IOBUF(IOPOS+1)
      Y = IOBUF(IOPOS+2)
      IOPOS = IOPOS+3
      CALL TEKVEC (X, Y, 1,  IERR)
      IF (IERR.EQ.0) GO TO 50
      IF (IERR.NE.2) GO TO 960
         IERRC = IERRC + 1
         GO TO 50
C                                       Opcode 5, draw vector.
C                                       Opcode 10, dark vector
C                                       Opcode 17, color vector
 500  X = IOBUF(IOPOS+1)
      Y = IOBUF(IOPOS+2)
      IOPOS = IOPOS+3
      CALL TEKVEC (X, Y, 2, IERR)
      IF (IERR.EQ.0) GO TO 50
      IF (IERR.NE.2) GO TO 960
         IERRC = IERRC + 1
         GO TO 50
C                                       Opcode 6, write characters.
 600  NCHAR = IOBUF(IOPOS+1)
      IANGL = IOBUF(IOPOS+2)
      DX    = IOBUF(IOPOS+3)/100.0
      DY    = IOBUF(IOPOS+4)/100.0
      CALL H2CHR (NCHAR, 1, HOBUF(IOPOS+5), LINE)
      CALL TKCHAR (NCHAR, IANGL, DX, DY, LINE, IERR)
      IF (IERR.NE.0) GO TO 960
      IOPOS = IOPOS + 5 + ((NCHAR-1) / 4) + 1
      GO TO 50
C                                       Opcode 7, write grey scale.
C                                       Opcode 11, write 3color scale.
 700  GRYERR = GRYERR + 1
C                                       Update IO position. Read
C                                       proper RRN if necessary
      IF (OPCODE.EQ.7) THEN
         IOPOS = IOPOS + 3 + IOBUF(IOPOS+1)
      ELSE
         IOPOS = IOPOS + 3 + 3*IOBUF(IOPOS+1)
         END IF
      IF (IOPOS.LE.256) GO TO 60
         INCRRN = (IOPOS-1)/256
         IORRN = IORRN + INCRRN
         IOPOS = IOPOS - 256*INCRRN
         CALL ZFIO ('READ', LUN, FIND, IORRN, IOBUF, IERR)
         IF (IERR.EQ.0) GO TO 60
         GO TO 980
C                                       Opcode 8, put misc info in
C                                       image catalog.
 800  INO = IOBUF(IOPOS+1)
      IOPOS = IOPOS + 2
      CALL COPY (INO, IOBUF(IOPOS), CATBLK(IIOTH))
      IOPOS = IOPOS + INO
      GO TO 50
C                                       Opcode 18, comment
 810  INO = IOBUF(IOPOS+1)
      IOPOS = IOPOS + (INO+3)/4 + 2
      GO TO 50
C                                       Write error.
 960  WRITE (MSGTXT,1960)
      CALL MSGWRT (8)
      GO TO 990
C                                       Invalid opcode.
 970  WRITE (MSGTXT,1970) OPCODE
      CALL MSGWRT (8)
      GO TO 990
C                                       Disk error.
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (8)
C                                       Close files.
C                                       force alpha
 990  CONTINUE
C                       Move to bottom of the plot
      CALL TEKVEC (1.0, 1.0, 1,  IERR)
      IT = 31
      CALL ZTKBUF (IT, 1, IERR2)
      CALL TEKFLS (IERR2)
      IF (IERR.EQ.2) IERR = 2
      IF (GRYERR.EQ.0) GO TO 995
         WRITE (MSGTXT,1990) GRYERR
         CALL MSGWRT (3)
 995  IF (IERRC.LE.0) GO TO 999
         WRITE (MSGTXT,1995) IERRC
         CALL MSGWRT (3)
C
 999  RETURN
C-----------------------------------------------------------------------
 1200 FORMAT ('TEKDRW: ERR FROM GINITL ARGS. NXA, NYA=',2I6)
 1210 FORMAT ('TEKDRW: ERR FROM GINITL ARGS. X,Y=',2E10.3)
 1230 FORMAT ('Using',1PE12.5,' arc sec per mm')
 1232 FORMAT ('Using',1PE12.5,' arc sec per mm for x axis')
 1233 FORMAT ('Using',1PE12.5,' arc sec per mm for y axis')
 1234 FORMAT ('Which overrides user aspmm in order to fit plot on',
     *   ' screen')
 1960 FORMAT ('TEKDRW: TEKTRONIX WRITE ERROR')
 1970 FORMAT ('TEKDRW: INVALID OPCODE',I5,' IN GRAPH FILE')
 1980 FORMAT ('TEKDRW: DISK IO RELATED ERROR',I3)
 1990 FORMAT ('TEKDRW: ',I5,' GREY SCALE OPCODES IGNORED')
 1995 FORMAT (I8,' Vectors truncated at edges')
      END

      PROGRAM RECAT
C-----------------------------------------------------------------------
C! RECAT recovers entries in map catalogs.
C# Utility Catalog
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2004, 2007, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   A service routine to recover entries in map catalogs.  It uses a
C   user's Catalog Block files to rebuild a CAtalog directory.
C   Any existing catalog is destroyed.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   TTY(2), I, IUSER, IVOL, RANGE(2), IERR, NPARM,
     *   BUFFER(256)
      LOGICAL   RQUICK
      REAL      XXX
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA TTY /5,0/, PRGNAM /'RECAT '/
C-----------------------------------------------------------------------
C                                       Standard AIPS inits.
      CALL AIPINI (TTY, PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       check for running as task
C                                       not allowed!!
      NPARM = 1
      CALL GTPARM (PRGNAM, NPARM, RQUICK, XXX, BUFFER, IERR)
      IF (IERR.EQ.0) THEN
         I = 8
         CALL RELPOP (I, BUFFER, IERR)
         MSGTXT = 'YOU HAVE INVOKED THE STAND-ALONE PROGRAM RECAT AS A'
     *      // ' TASK'
         CALL MSGWRT (9)
         MSGTXT = 'THIS IS NOT ALLOWED.'
         CALL MSGWRT (9)
         MSGTXT = 'TO RUN THE *VERB* RECAT SIMPLY SAY RECAT WITHOUT A'
     *      // ' GO'
         CALL MSGWRT (9)
         GO TO 990
         END IF
C                                       continue as intended
      NPOPS = 1
      DO 100 I = 1,32000
         CALL GETUSR (TTY, IUSER, IVOL, RANGE)
         IF (IUSER.EQ.0) GO TO 990
         CALL REBILD (TTY, IUSER, IVOL, RANGE)
 100     CONTINUE
C
 990  CALL ACOUNT (2)
C
 999  STOP
      END
      SUBROUTINE GETUSR (TTY, IUSER, IVOL, RANGE)
C-----------------------------------------------------------------------
C   Get a user number, a disk volume, and a range of catalog blocks.
C   Input:
C      TTY     I(2)   LUN and FTAB index of open TTY.
C   Output:
C      IUSER   I      User number. 0 means quit.
C      IVOL    I      Volume number.
C      RANGE   I(2)   Range of catalog slot numbers.
C-----------------------------------------------------------------------
      INTEGER   TTY(2), IUSER, IVOL, RANGE(2), IANS, IERR, IDUM(2)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
 10   CONTINUE
         IUSER = 0
         WRITE (MSGTXT,1010)
         CALL INQINT (TTY, MSGTXT, 1, IDUM, IERR)
         IUSER = IDUM(1)
         IF ((IERR.NE.0) .OR. (IUSER.EQ.0)) GO TO 900
 20      WRITE (MSGTXT,1020)
         CALL INQINT (TTY, MSGTXT, 1, IDUM, IERR)
         IVOL = IDUM(1)
         IF (IERR.LT.0) GO TO 20
         IF (IERR.GT.0) GO TO 900
 25      WRITE (MSGTXT,1025) 1, UCTSIZ
         CALL INQINT (TTY, MSGTXT, 2, RANGE, IERR)
         IF (IERR.LT.0) GO TO 25
         IF (IERR.GT.0) GO TO 900
         IF (RANGE(1).EQ.0) RANGE(1) = 1
         IF (RANGE(2).EQ.0) RANGE(2) = UCTSIZ
 30      WRITE (MSGTXT,1030)
         CALL INQINT (TTY, MSGTXT, 1, IDUM, IERR)
         IANS = IDUM(1)
         IF (IERR.LT.0) GO TO 30
         IF (IERR.GT.0) GO TO 900
         IF (IANS.NE.2) GO TO 10
C
 900  IF (IERR.NE.0) IUSER = 0
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('Enter user number to rebuild catalog (0 or Q => quit)')
 1020 FORMAT ('Enter disk volume number of catalog')
 1025 FORMAT ('Enter range of catalog slots (e.g. ',I2,I4,')')
 1030 FORMAT ('Enter: 1=I need to re-enter, 2=continue')
      END
      SUBROUTINE REBILD (TTY, IUSER, IVOL, RANGE)
C-----------------------------------------------------------------------
C  Rebuild a catalog from catalog block files.
C  Input:
C     TTY     I(2)   LUN and FTAB index of open terminal device.
C     IUSER   I      User number.
C     IVOL    I      Disk volume number of bad catalog.
C     RANGE   I(2)   Range of catalog slots to check for existence of
C                    catalog blocks.
C-----------------------------------------------------------------------
      CHARACTER  PNAME*48,  CTEMP*18
      INTEGER   TTY(2), IUSER, IVOL, RANGE(2), ISLOT, IR0, IR1,
     *   IERR, MAXSIZ, BUFFER(256), LUNCB, INDCB, ISAVE,
     *   NCHAR
      LOGICAL   T, F, WUPS
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA T /.TRUE./, F /.FALSE./, LUNCB /15/
C-----------------------------------------------------------------------
C                                       Create or replace catalog file.
      MAXSIZ = MAX (RANGE(2), UCTSIZ)
      CALL MAKCAT (TTY, IUSER, IVOL, MAXSIZ, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 999
      IR0 = RANGE(1)
      IR1 = RANGE(2)
      WUPS = F
      DO 100 ISLOT = IR0, IR1
C                                       Check on existence of CB.
         ISAVE = NLUSER
         NLUSER = IUSER
         CALL ZPHFIL ('CB', IVOL, ISLOT, 1, PNAME, IERR)
         NLUSER = ISAVE
         MSGSUP = 32000
         CALL ZOPEN (LUNCB, INDCB, IVOL, PNAME, F, T, T, IERR)
         MSGSUP = 0
         IF (IERR.EQ.2) THEN
            MSGTXT = ' '
         ELSE IF (IERR.EQ.0) THEN
C                                       Insert Catalog block in catalog.
            CALL ZFIO ('READ', LUNCB, INDCB, 1, CATBLK, IERR)
C                                       Check if the CB file is empty
C                                       If so, skip and warn the user
            IF (IERR.EQ.4) THEN
               WRITE (MSGTXT, 1010) ISLOT
               CALL ZCLOSE (LUNCB, INDCB, IERR)
               WUPS = T
C                                       Also skip if other error occurs
            ELSE IF (IERR.NE.0) THEN
               WRITE (MSGTXT, 1020) IERR, ISLOT
               CALL ZCLOSE (LUNCB, INDCB, IERR)
               WUPS = T
C                                       The coast SHOULD be clear...
            ELSE
               CALL ZCLOSE (LUNCB, INDCB, IERR)
               CALL CATINS (IUSER, IVOL, ISLOT, BUFFER, IERR)
               WRITE (MSGTXT,1000) ISLOT
               CALL H2CHR (18, 1, CATH(KHIMN), CTEMP)
               CALL NAMEST (CTEMP, CATBLK(KIIMS), MSGTXT(5:24), NCHAR)
               END IF
         ELSE
            WUPS = T
            END IF
         IF (MSGTXT.NE.' ') CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72,
     *      MSGTXT, IERR)
C
 100     CONTINUE
      IF (WUPS) THEN
         WRITE (MSGTXT, 1015)
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, MSGTXT, IERR)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Put                       in slot ',I4)
 1010 FORMAT ('Catalog Block file for slot ',I4,' is EMPTY!  Skipping.')
 1015 FORMAT ('WARNING!!  AT LEAST ONE FILE MAY NEED DELETED BY HAND!')
 1020 FORMAT ('Error ',I4,' reading CB file for slot ',I4,'! Skipping.')
      END
      SUBROUTINE MAKCAT (TTY, IUSER, IVOL, MAXSIZ, BUFFER, IERR)
C-----------------------------------------------------------------------
C  Create a new catalog file for a user.  Destroy any existing catalog.
C  Inputs:
C     TTY     I(2)     LUN and FTAB index for open terminal.
C     IUSER   I        User number.
C     IVOL    I        Disk Volume.
C     MAXSIZ  I        Size of catalog in slots.
C  Output:
C     BUFFER  I        Work Buffer.
C     IERR    I        Error code, 0=ok.
C-----------------------------------------------------------------------
      CHARACTER PNAME*48
      INTEGER   TTY(2), IUSER, IVOL, MAXSIZ, BUFFER(256), IERR, ISIZE,
     *   ISAVE
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      ISAVE = NLUSER
      NLUSER = IUSER
      CALL ZPHFIL ('CA', IVOL, 0, 0, PNAME, IERR)
      NLUSER = ISAVE
      CALL ZEXIST (IVOL, PNAME, ISIZE, IERR)
      IF (IERR.NE.0) GO TO 100
         WRITE (MSGTXT,1000) IUSER
         CALL ZTTYIO ('WRIT', TTY(1), TTY(2), 72, MSGTXT, IERR)
         CALL ZDESTR (IVOL, PNAME, IERR)
         IF (IERR.NE.0) GO TO 999
 100  CONTINUE
      ISAVE = NLUSER
      NLUSER = IUSER
      CALL CATCR (IVOL, MAXSIZ, BUFFER, IERR)
      NLUSER = ISAVE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Destroying existing catalog for user',I5)
      END
      SUBROUTINE CATINS (IUSER, IVOL, CNO, BUFF, IERR)
C-----------------------------------------------------------------------
C   Put an entry in a catalog directory using information in a
C   catalog block found in common /MAPHDR/.
C   Inputs:  IUSER  I        User number.
C            IVOL   I        Disk volume containing catalog (1 rel)
C            CNO    I        Slot number of interest
C                            change of status is desired
C            BUFF   I(256)   Working buffer
C            IERR   I        Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER   CTEMP*20
      INTEGER   IUSER, IVOL, CNO, BUFF(256), IERR, NREC, IER, CMAX,
     *   CMOD, NIND, NSEQ, NNAME, CIND, NSTAT, CLUN, INERR, RDERR, NWPL,
     *   ISAVE, NLPR, NTIME, IT(6)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA CLUN /15/
      DATA NSTAT, NTIME, NSEQ, NNAME /1,2,4,5/
      DATA INERR, RDERR /2, 3/
C-----------------------------------------------------------------------
      ISAVE = NLUSER
      NLUSER = IUSER
      CALL CATOPN (IVOL, CIND, BUFF, CMAX, IERR)
      NLUSER = ISAVE
      IF (IERR.EQ.3) GO TO 980
      IF (IERR.NE.0) GO TO 999
C                                       check validity of CNO
      IF ((0.LT.CNO) .AND. (CMAX.GE.CNO)) GO TO 20
         IERR = INERR
         WRITE (MSGTXT,1015) CNO
         GO TO 970
C                                       get directory block
 20   NWPL = 10
      NLPR = 256 / NWPL
      CMOD = (CNO - 1)/NLPR
      NREC = 2 + CMOD
      NIND = 1 + NWPL*(CNO - NLPR*CMOD -1 )
      CALL ZFIO ('READ', CLUN, CIND, NREC, BUFF, IER)
      IF (IER.EQ.0) GO TO 25
         IERR = RDERR
         GO TO 980
 25   CONTINUE
C                                       Add fields from CATBLK
      BUFF(NIND) = IUSER
      BUFF(NIND+NSTAT) = 0
      IF (CATBLK(KIIMS).LE.0) CATBLK(KIIMS) = 1000 + CNO
      BUFF(NIND+NSEQ) = CATBLK(KIIMS)
      CALL H2CHR (20, 1, CATH(KHIMN), CTEMP)
      CALL CHR2H (20, CTEMP, 1, BUFF(NIND+NNAME))
C                                       return directory to disk
C                                       with latest time
      CALL CATIME (1, BUFF(NIND+NTIME), IT)
      CALL ZFIO ('WRIT', CLUN, CIND, NREC, BUFF, IER)
      CALL ZCLOSE (CLUN, CIND, IER)
      GO TO 999
C                                       error message out
 970  CALL MSGWRT (6)
C                                       close & free catalog file
 980  CALL ZCLOSE (CLUN, CIND, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1015 FORMAT ('CATIO: Catno ',I6,' out of range')
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NPARMS
      PARAMETER (NPARMS=25)
      INTEGER   AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                      1         2          3        4         5
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INEXT',
C            6         7          8         9           10
     *   'INVERS', 'DODELAY', 'FREQID', 'SUBARRAY', 'FLAGVER',
C            11          12         13     14      15          16
     *   'OUTFGVER', 'TIMERANG', 'BIF', 'EIF', 'ANTENNAS', 'SOLINT',
C            17        18        19       20        21         22
     *   'DETIME', 'DOHIST', 'DOTWO', 'EXPERT', 'CROWDED', 'DO3COL',
C            23        24        25
     *   'REASON', 'ANTUSE', 'BADDISK'/
C                    1       2       3       4       5
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, OOACAR,
C          6       7       8       9       10
     *   OOAINT, OOARE, OOAINT, OOAINT, OOAINT,
C          11      12      13      14      15      16
     *   OOAINT, OOARE,  OOAINT, OOAINT, OOAINT, OOARE,
C          17      18      19      20      21      22
     *   OOARE,  OOARE,  OOALOG, OOALOG, OOAINT, OOARE,
C          23      24      25
     *   OOACAR, OOAINT, OOAINT/
C                   1     2     3     4     5
      DATA AVDIM /12,1,  6,1,  1,1,  1,1,  2,1,
C         6     7     8     9     10
     *   1,1,  1,1,  1,1,  1,1,  1,1,
C         11    12    13    14    15    16
     *   1,1,  8,1,  1,1,  1,1, 50,1,  1,1,
C         17    18    19    20    21    22
     *   1,1,  1,1,  1,1,  1,1,  1,1,  1,1,
C         23    24    25
     *  24,1, 50,1, 10,1/
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(10)
      LOGICAL   LDUM(10)
      REAL      RDUM(10)
      DOUBLE PRECISION DDUM(5)
      EQUIVALENCE (DDUM, RDUM, IDUM, LDUM)
      COMMON /EDITAG/ DDUM
LOCAL END
      PROGRAM EDITA
C-----------------------------------------------------------------------
C! UV editing with the TV displaying System temperature or gain tables
C# Task AP OOP UV EDITING TV-APPL CALIBRATION
C-----------------------------------------------------------------------
C;  Copyright (C) 1996-2000, 2004, 2007, 2010, 2012, 2015, 2018, 2020,
C;  Copyright (C) 2022-2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TY table data used for uv editing
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, UVDATA*32, TBEDIT*32, TBTYPE*2
      INTEGER  IRET, BUFF1(256)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'EDITA'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL EDITIN (PRGM, UVDATA, TBEDIT, TBTYPE, IRET)
C                                       CLEAN
      IF (IRET.EQ.0) CALL EDITIT (UVDATA, TBEDIT, TBTYPE, IRET)
C                                       Close down files, etc.
      CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE EDITIN (PRGN, UVDATA, TBEDIT, TBTYPE, IERR)
C-----------------------------------------------------------------------
C   EDITIN gets input parameters for EDITA, creates the EDIT object.
C   Inputs:
C      PRGN     C*6    Program name
C   Output:
C      UVDATA   C*32   Name of input uv data. - as master
C      TBEDIT   C*32   Name of table object to be used in editing
C      TBTYPE   C*2    Type of table in use
C      IERR     I      Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER PRGN*6, UVDATA*(*), TBEDIT*(*), TBTYPE*2
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NKEY1, NKEY2
C                                       NKEY1 = # adverbs FOR UVDATA
      PARAMETER (NKEY1=5)
C                                       NKEY2 = # adverbs for TBEDIT
      PARAMETER (NKEY2=20)
      INTEGER   DIM(7), TYPE, I, BIF, EIF, NIF, SUBA, FGVERI, FGVERO,
     *   FGVERC, FGV, DDELAY, ANTS(50), DISK, CNO, BUFFER(512)
      LOGICAL   DODELY, MULTIB, DODISP
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32, CDUMMY*1, TBTEMP*32, FGNAME(3)*32, FGIN*32
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to UVDATA object
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'DOHIST'/
C                                       Rename
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'DOHIST'/
C                                       Adverbs for TBEDIT object
      DATA INK2 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'INVERS',
     *   'FREQID', 'SUBARRAY', 'TIMERANG', 'BIF', 'EIF', 'ANTENNAS',
     *   'SOLINT', 'DETIME', 'INEXT', 'DOTWO', 'EXPERT',
     *   'CROWDED', 'DO3COL', 'REASON', 'ANTUSE'/
C                                       Rename
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'VER',
     *   'FRQSEL', 'SUBARR', 'TIMERANG', 'BIF', 'EIF', 'ANTENNAS',
     *   'EQU_TIME', 'GAP_TIME', 'TBLTYPE', 'COMPARE',
     *   'DOEXPERT', 'CROWDED', 'DO3COLOR', 'REASON', 'ANTS2USE'/
      DATA FGNAME /'IN_FGVER', 'OUT_FGVER', 'COP_FGVER'/
C-----------------------------------------------------------------------
C                                       Startup interactive
      CALL AV2INT (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IERR)
      IF (IERR.NE.0) GO TO 999
      RQUICK = .FALSE.
C                                       BADDISK
      CALL OGET ('Input', 'BADDISK', TYPE, DIM, IBAD, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       check table type
      CALL OGET ('Input', 'INEXT', TYPE, DIM, IDUM, TBTYPE, IERR)
      IF (IERR.NE.0) GO TO 999
      IF ((TBTYPE.NE.'TY') .AND. (TBTYPE.NE.'SN') .AND.
     *   (TBTYPE.NE.'CL') .AND. (TBTYPE.NE.'SY')) THEN
         MSGTXT = 'TABLE TYPE ''' // TBTYPE // ''' NOT SUPPORTED'
         CALL MSGWRT (8)
         IERR = 8
         GO TO 999
         END IF
      CALL OGET ('Input', 'DODELAY', TYPE, DIM, IDUM, CDUMMY, IERR)
      DDELAY = RDUM(1)
      IF (IERR.NE.0) GO TO 999
      IF (DDELAY.GT.2.5) THEN
         DODISP = .TRUE.
         MULTIB = .FALSE.
         DODELY = .FALSE.
      ELSE IF (DDELAY.GT.1.5) THEN
         DODISP = .FALSE.
         MULTIB = .TRUE.
         DODELY = .FALSE.
      ELSE
         DODISP = .FALSE.
         MULTIB = .FALSE.
         DODELY = DDELAY.GT.0.0
         END IF
      IF ((TBTYPE.NE.'SN') .AND. (TBTYPE.NE.'CL')) THEN
         DODISP = .FALSE.
         MULTIB = .FALSE.
         DODELY = .FALSE.
         END IF
C                                       SUBARRAY
      CALL OGET ('Input', 'SUBARRAY', TYPE, DIM, IDUM, CDUMMY, IERR)
      SUBA = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      SUBA = MAX (1, SUBA)
      IDUM(1) = SUBA
      CALL OPUT ('Input', 'SUBARRAY', TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       ANTENNAS
      CALL OGET ('Input', 'ANTENNAS', TYPE, DIM, ANTS, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Create UV master object
      UVDATA = 'UVDATA master input object'
      CALL CREATE (UVDATA, 'UVDATA', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, UVDATA, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open UVDATA to be sure it's OK
      CALL OOPEN (UVDATA, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       get file parameters
      CALL FNAGET (UVDATA, 'DISK', TYPE, DIM, IDUM, CDUMMY, IERR)
      DISK = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL FNAGET (UVDATA, 'CNO', TYPE, DIM, IDUM, CDUMMY, IERR)
      CNO = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL ANTOUT (DISK, CNO, SUBA, ANTS, CATBLK, BUFFER, IERR)
      IF (IERR.EQ.0) THEN
         DIM(1) = 50
         DIM(2) = 1
         CALL OPUT ('Input', 'ANTENNAS', OOAINT, DIM, ANTS, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OPUT (UVDATA, 'ANTENNAS', OOAINT, DIM, ANTS, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       close
      CALL OCLOSE (UVDATA, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Find highest FG table.
      FGIN = 'Temporary FG table for EDITR'
      FGV = 1
      CALL UV2TAB (UVDATA, FGIN, 'FG', FGV, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TBLHIV (FGIN, FGV, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TABDES (FGIN, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Set FLAGVER
      CALL OGET ('Input', 'FLAGVER', TYPE, DIM, IDUM, CDUMMY, IERR)
      FGVERI = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET ('Input', 'OUTFGVER', TYPE, DIM, IDUM, CDUMMY, IERR)
      FGVERO = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      FGVERI = MIN (FGVERI, FGV)
      IF (FGVERI.EQ.0) FGVERI = FGV
      IF ((FGVERO.LE.0) .OR. (FGVERO.GT.FGV)) FGVERO = FGV + 1
      FGVERC = FGVERI
      IF (FGVERO.LE.FGV) FGVERC = - ABS (FGVERI)
      IDUM(1) = FGVERI
      CALL OPUT (UVDATA, FGNAME(1), TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IDUM(1) = FGVERO
      CALL OPUT (UVDATA, FGNAME(2), TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IDUM(1) = FGVERC
      CALL OPUT (UVDATA, FGNAME(3), TYPE, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Create TBEDIT object
      TBEDIT = TBTYPE // ' table to be used in editing'
      CALL CREATE (TBEDIT, 'TABLE', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, TBEDIT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Use input for editing
      IF ((TBTYPE.EQ.'TY') .OR. (TBTYPE.EQ.'SY')) THEN
C                                       Open TBEDIT to be sure it's OK.
         CALL OOPEN (TBEDIT, 'READ', IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OGET (TBEDIT, 'KEY.NO_IF', TYPE, DIM, IDUM, CDUMMY, IERR)
         NIF = IDUM(1)
         IF ((IERR.NE.0) .OR. (NIF.LE.0)) NIF = 1
         CALL OCLOSE (TBEDIT, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       make copy of input
      ELSE
         DIM(1) = 1
         DIM(2) = 1
         I = 0
         IDUM(1) = 0
         CALL OPUT (TBEDIT, 'VER', OOAINT, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
         LDUM(1) = DODELY
         CALL OPUT (TBEDIT, 'DODELAY', OOALOG, DIM, IDUM, CDUMMY, IERR)
         IF (IERR.NE.0) GO TO 999
         LDUM(1) = MULTIB
         CALL OPUT (TBEDIT, 'MULTIBAND', OOALOG, DIM, IDUM, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         LDUM(1) = DODISP
         CALL OPUT (TBEDIT, 'DISPERSION', OOALOG, DIM, IDUM, CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Create TBTEMP object
         TBTEMP = 'Temp input file to be copied'
         CALL CREATE (TBTEMP, 'TABLE', IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
         CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, TBTEMP, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Open TBTEMP to be sure it's OK.
         CALL OOPEN (TBTEMP, 'READ', IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OGET (TBTEMP, 'KEY.NO_IF', TYPE, DIM, IDUM, CDUMMY, IERR)
         NIF = IDUM(1)
         IF ((IERR.NE.0) .OR. (NIF.LE.0)) NIF = 1
         CALL OCLOSE (TBTEMP, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       copy input table to output
         CALL TBLCOP (TBTEMP, TBEDIT, IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'EDITIN: TROUBLE COPYING INPUT TO OUTPUT TABLE'
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       remove object (leave input
C                                       table untouched)
         CALL TABDES (TBTEMP, IERR)
         END IF
C                                       IF numbers
C                                       Default BIF, EIF
      CALL OGET ('Input', 'BIF', TYPE, DIM, IDUM, CDUMMY, IERR)
      BIF = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      CALL OGET ('Input', 'EIF', TYPE, DIM, IDUM, CDUMMY, IERR)
      EIF = IDUM(1)
      IF (IERR.NE.0) GO TO 999
      BIF = MAX (1, BIF)
      BIF = MIN (BIF, NIF)
      IF (EIF.LT.BIF) EIF = NIF
      EIF = MIN (EIF, NIF)
C                                       Save in Inputs for history
      DIM(1) = 1
      IDUM(1) = BIF
      CALL OPUT ('Input', 'BIF', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OPUT (TBEDIT, 'BIF', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IDUM(1) = EIF
      CALL OPUT ('Input', 'EIF', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OPUT (TBEDIT, 'EIF', OOAINT, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE EDITIT (UVDATA, TBEDIT, TBTYPE, IERR)
C-----------------------------------------------------------------------
C   Does the editing
C   Inputs:
C      UVDATA   C*32   Name of input uv data. - as master
C      TBEDIT   C*32   Name of TY table data
C      TBTYPE   C*2    Type of table
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER UVDATA*(*), TBEDIT*(*), TBTYPE*2
C
      CHARACTER UVEDIT*32, STATUS*4, TVDEVC*32, CDUMMY*1
      INTEGER   JERR, DIM(7)
      LOGICAL   DOFLAG
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      DATA DOFLAG /.TRUE./
C-----------------------------------------------------------------------
C                                       open TV object
      TVDEVC = 'EDITA task TV object'
      CALL TVDCRE (TVDEVC, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL TVDOPN (TVDEVC, STATUS, IERR)
      IF (IERR.NE.0) GO TO 985
C                                       open edit object
      UVEDIT = 'EDITA task EDIT object'
      CALL EDICRE (UVEDIT, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL EDIOPN (UVEDIT, STATUS, IERR)
      IF (IERR.NE.0) GO TO 975
C                                       Insert object info
      DIM(1) = LEN(UVDATA)
      DIM(2) = 1
      CALL EDIPUT (UVEDIT, 'UVMASTER', OOACAR, DIM, IDUM, UVDATA, IERR)
      IF (IERR.NE.0) GO TO 980
      DIM(1) = LEN(TBEDIT)
      CALL EDIPUT (UVEDIT, 'TBEDIT', OOACAR, DIM, IDUM, TBEDIT, IERR)
      IF (IERR.NE.0) GO TO 980
      DIM(1) = LEN(TVDEVC)
      CALL EDIPUT (UVEDIT, 'TVDEVICE', OOACAR, DIM, IDUM, TVDEVC, IERR)
      IF (IERR.NE.0) GO TO 980
      DIM(1) = 1
      LDUM(1) = DOFLAG
      CALL EDIPUT (UVEDIT, 'DOUVFLAG', OOALOG, DIM, IDUM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       system temperatures
      IF (TBTYPE.EQ.'TY') THEN
C                                       do it
         CALL EDITTY ('INIT', UVEDIT, IERR)
C                                       Clean up - no apply
         IF (IERR.NE.0) THEN
            IF (IERR.LT.0) THEN
               CALL EDITTY ('ABOR', UVEDIT, JERR)
               IERR = 0
            ELSE
               CALL EDITTY ('KILL', UVEDIT, JERR)
               END IF
C                                       apply FG and clean up
         ELSE
            CALL EDITTY ('APPL', UVEDIT, IERR)
            END IF
         CALL TABCLO (TBEDIT, JERR)
         CALL TABDES (TBEDIT, JERR)
C                                       system temperatures
      ELSE IF (TBTYPE.EQ.'SY') THEN
C                                       do it
         CALL EDITSY ('INIT', UVEDIT, IERR)
C                                       Clean up - no apply
         IF (IERR.NE.0) THEN
            IF (IERR.LT.0) THEN
               CALL EDITSY ('ABOR', UVEDIT, JERR)
               IERR = 0
            ELSE
               CALL EDITSY ('KILL', UVEDIT, JERR)
               END IF
C                                       apply FG and clean up
         ELSE
            CALL EDITSY ('APPL', UVEDIT, IERR)
            END IF
         CALL TABCLO (TBEDIT, JERR)
         CALL TABDES (TBEDIT, JERR)
C                                       gain solutions
      ELSE
C                                       do it
         CALL EDITSN ('INIT', UVEDIT, IERR)
C                                       Clean up - no apply
         IF (IERR.NE.0) THEN
            IF (IERR.LT.0) THEN
               CALL EDITSN ('ABOR', UVEDIT, JERR)
               IERR = 0
            ELSE
               CALL EDITSN ('KILL', UVEDIT, JERR)
               END IF
C                                       apply FG and clean up
         ELSE
            CALL EDITSN ('APPL', UVEDIT, IERR)
            END IF
         CALL TABCLO (TBEDIT, JERR)
         CALL TABZAP (TBEDIT, JERR)
         END IF
C                                       Delete object
      CALL EDICLO (UVEDIT, JERR)
 975  CALL EDIDES (UVEDIT, JERR)
C                                       close and delete TV device
 980  CALL TVDCLO (TVDEVC, JERR)
 985  CALL TVDDES (TVDEVC, JERR)
C                                       error message
 990  IF (IERR.NE.0) THEN
         MSGTXT = 'ERROR EDITING ' // TBEDIT
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
      END

      SUBROUTINE TABCAL (OPCODE, BUFFER, ICLRNO, CLKOLS, CLNUMV, NUMPOL,
     *   NUMIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR, GEODLY,
     *   DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP, DDISP,
     *   CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IERR)
C-----------------------------------------------------------------------
C! Does I/O to Calibration (CL) table opened by CALINI
C# EXT-util UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to CALIBRATION extention tables. Usually used after setup
C   by CALINI.
C    Inputs:
C     OPCODE   C*4         Operation code:
C                          'READ' = read entry from table.
C                          'WRIT' = write entry in table.
C                          'CLOS' = close file, flush on write
C     BUFFER   I(512)      I/O buffer and related storage, also defines
C                          file if open. Should have been returned by
C                          TABINI or CALINI.
C     ICLRNO   I           Next scan number to read or write.
C     CLKOLS   I(MAXCLC)   The column pointer array in order defined by
C                          the parameters in PCLTAB.INC.
C     CLNUMV   I(MAXCLC)   Element count in each column.
C     NUMPOL   I           Number of polarizations per IF.
C     NUMIF    I           Number of IFs.
C   Input/output: (written to or read from CAL file)
C     TIME     D           Center time of CAL record (Days)
C     TIMEI    R           Time interval covered by record (days)
C     SOURID   I           Source ID as defined in the SoUrce table.
C     ANTNO    I           Antenna number as defined in Antenna table
C     SUBA     I           Subarray number.
C     FREQID   I           Freqid # as defined in FQ table.
C     IFR      R           Ionospheric Faraday Rotation (rad/m**2)
C     GEODLY   D(*)        Geometric delay polynomial series at TIME
C                          (sec)
C     DOPOFF   R(*)        Doppler offset for each IF (Hz)
C     ATMOS    R(2)        Atmospheric delay (sec) 1/Poln
C     DATMOS   R(2)        Time derivative of ATMOS (sec/sec)
C     MBDELY   R(2)        Multi band delays (sec) 1/Poln
C     CLOCK    R(2,*)      "Clock" epoch error (sec) 1/poln
C     DCLOCK   R(2,*)      Time derivative of CLOCK (sec/sec)
C     DISP     R(2,*)      Dispersive delay (sec/m^2 scales as lambda^2)
C                          1/poln
C     DDISP    R(2,*)      Time derivative of DISP (sec/sec/m^2)
C     CREAL    R(2,*)      Real part of the complex gain, 1/poln/IF
C     CIMAG    R(2,*)      Imag part of the complex gain, 1/poln/IF
C     DELAY    R(2,*)      Residual group delay (sec), 1/poln/IF
C     RATE     R(2,*)      Residual fringe rate (Hz), 1/poln/IF
C     WEIGHT   R(2,*)      Weight of solution, 1/poln/IF
C     REFA     I(2,*)      Reference antenna use for cal. solution.
C    Output:
C     ICLRNO   I           Next CAL number.
C     IERR     I           Error code, 0=>OK else TABIO error.
C                          Note: -1=> read but record deselected.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER OPCODE*4
      DOUBLE PRECISION TIME, GEODLY(*)
      REAL      TIMEI, IFR, DOPOFF(MAXIF), ATMOS, DATMOS, MBDELY(2),
     *   CLOCK(2), DCLOCK(2), DISP(2), DDISP(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF),
     *   WEIGHT(2,MAXIF)
      INTEGER   BUFFER(512), CLKOLS(MAXCLC), CLNUMV(MAXCLC), NUMPOL,
     *   NUMIF, SOURID, ANTNO, SUBA, FREQID, REFA(2,MAXIF), IERR
C
      INCLUDE 'INCS:PCLTAB.INC'
      INTEGER   RECI(XCLRSZ), LOOP, NTERMS, DOPKOL, REAKOL, IMAKOL,
     *   DELKOL, RATKOL, WEIKOL, REFKOL, ICLRNO
      LOGICAL   DOREAD, DOCLOS
      REAL      RECORD(XCLRSZ)
      DOUBLE PRECISION RECD(XCLRSZ/2)
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (RECD, RECORD, RECI)
      DATA RECORD /XCLRSZ*0.0D0/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
      DOCLOS = OPCODE.EQ.'CLOS'
C                                       Branch for CLOS
      IF (DOCLOS) GO TO 800
C                                       If write fill RECORD
      IF (.NOT.DOREAD) THEN
         RECD(CLKOLS(CLDTIM)) = TIME
         RECORD(CLKOLS(CLRTMI)) = TIMEI
         RECI(CLKOLS(CLISID)) = SOURID
         RECI(CLKOLS(CLIANT)) = ANTNO
         RECI(CLKOLS(CLISUB)) = SUBA
         IF (CLKOLS(CLIFQI).GT.0) RECI(CLKOLS(CLIFQI)) = FREQID
         IF (CLKOLS(CLRIFR).GT.0) RECORD(CLKOLS(CLRIFR)) = IFR
         NTERMS = CLNUMV(CLDDEL)
         DO 5 LOOP = 1,NTERMS
            RECD(CLKOLS(CLDDEL)+LOOP-1) = GEODLY(LOOP)
 5          CONTINUE
         IF (CLKOLS(CLRATM).GT.0) RECORD(CLKOLS(CLRATM)) = ATMOS
         IF (CLKOLS(CLRDAT).GT.0) RECORD(CLKOLS(CLRDAT)) = DATMOS
         IF (CLKOLS(CLRMD1).GT.0) RECORD(CLKOLS(CLRMD1)) = MBDELY(1)
         IF (CLKOLS(CLRCK1).GT.0) RECORD(CLKOLS(CLRCK1)) = CLOCK(1)
         IF (CLKOLS(CLRDC1).GT.0) RECORD(CLKOLS(CLRDC1)) = DCLOCK(1)
         IF (CLKOLS(CLRDS1).GT.0) RECORD(CLKOLS(CLRDS1)) = DISP(1)
         IF (CLKOLS(CLRDD1).GT.0) RECORD(CLKOLS(CLRDD1)) = DDISP(1)
C                                       Setup for looping over IF
         DOPKOL = CLKOLS(CLRDOP)
         REAKOL = CLKOLS(CLRRE1)
         IMAKOL = CLKOLS(CLRIM1)
         RATKOL = CLKOLS(CLRRA1)
         DELKOL = CLKOLS(CLRDE1)
         WEIKOL = CLKOLS(CLRWE1)
         REFKOL = CLKOLS(CLIRF1)
C                                       First polarization
         DO 10 LOOP = 1,NUMIF
            RECORD(DOPKOL+LOOP-1) = DOPOFF(LOOP)
            RECORD(REAKOL+LOOP-1) = CREAL(1,LOOP)
            RECORD(IMAKOL+LOOP-1) = CIMAG(1,LOOP)
            RECORD(DELKOL+LOOP-1) = DELAY(1,LOOP)
            RECORD(RATKOL+LOOP-1) = RATE(1,LOOP)
            RECORD(WEIKOL+LOOP-1) = WEIGHT(1,LOOP)
            RECI(REFKOL+LOOP-1) = REFA(1,LOOP)
 10         CONTINUE
         IF (NUMPOL.GE.2) THEN
C                                       Two polarizations
            IF (CLKOLS(CLRMD2).GT.0) RECORD(CLKOLS(CLRMD2)) = MBDELY(2)
            IF (CLKOLS(CLRCK2).GT.0) RECORD(CLKOLS(CLRCK2)) = CLOCK(2)
            IF (CLKOLS(CLRDC2).GT.0) RECORD(CLKOLS(CLRDC2)) = DCLOCK(2)
            IF (CLKOLS(CLRDS2).GT.0) RECORD(CLKOLS(CLRDS2)) = DISP(2)
            IF (CLKOLS(CLRDD2).GT.0) RECORD(CLKOLS(CLRDD2)) = DDISP(2)
C                                       Setup for looping over IF
            REAKOL = CLKOLS(CLRRE2)
            IMAKOL = CLKOLS(CLRIM2)
            RATKOL = CLKOLS(CLRRA2)
            DELKOL = CLKOLS(CLRDE2)
            WEIKOL = CLKOLS(CLRWE2)
            REFKOL = CLKOLS(CLIRF2)
            DO 20 LOOP = 1,NUMIF
               RECORD(REAKOL+LOOP-1) = CREAL(2,LOOP)
               RECORD(IMAKOL+LOOP-1) = CIMAG(2,LOOP)
               RECORD(DELKOL+LOOP-1) = DELAY(2,LOOP)
               RECORD(RATKOL+LOOP-1) = RATE(2,LOOP)
               RECORD(WEIKOL+LOOP-1) = WEIGHT(2,LOOP)
               RECI(REFKOL+LOOP-1) = REFA(2,LOOP)
 20            CONTINUE
            END IF
         END IF
C                                       Process record.
 50   CALL TABIO (OPCODE, 0, ICLRNO, RECORD, BUFFER, IERR)
      ICLRNO = ICLRNO + 1
      IF (IERR.GT.0) GO TO 990
C                                       If READ pick data from RECORD.
      IF (DOREAD) THEN
         TIME = RECD(CLKOLS(CLDTIM))
         TIMEI = RECORD(CLKOLS(CLRTMI))
         SOURID = RECI(CLKOLS(CLISID))
         ANTNO = RECI(CLKOLS(CLIANT))
         SUBA = RECI(CLKOLS(CLISUB))
         NTERMS = CLNUMV(CLDDEL)
         DO 55 LOOP = 1,NTERMS
            GEODLY(LOOP) = RECD(CLKOLS(CLDDEL)+LOOP-1)
 55         CONTINUE
         FREQID = 1
         IF (CLKOLS(CLIFQI).GT.0) FREQID = RECI(CLKOLS(CLIFQI))
         IFR = 0.0
         IF (CLKOLS(CLRIFR).GT.0) IFR = RECORD(CLKOLS(CLRIFR))
         ATMOS = 0.0
         IF (CLKOLS(CLRATM).GT.0) ATMOS = RECORD(CLKOLS(CLRATM))
         DATMOS = 0.0
         IF (CLKOLS(CLRDAT).GT.0) DATMOS = RECORD(CLKOLS(CLRDAT))
         MBDELY(1) = 0.0
         IF (CLKOLS(CLRMD1).GT.0) MBDELY(1) = RECORD(CLKOLS(CLRMD1))
         CLOCK(1) = 0.0
         IF (CLKOLS(CLRCK1).GT.0) CLOCK(1) = RECORD(CLKOLS(CLRCK1))
         DCLOCK(1) = 0.0
         IF (CLKOLS(CLRDC1).GT.0) DCLOCK(1) = RECORD(CLKOLS(CLRDC1))
         DISP(1) = 0.0
         IF (CLKOLS(CLRDS1).GT.0) DISP(1) = RECORD(CLKOLS(CLRDS1))
         DDISP(1) = 0.0
         IF (CLKOLS(CLRDD1).GT.0) DDISP(1) = RECORD(CLKOLS(CLRDD1))
C                                       Setup for looping over IF
         DOPKOL = CLKOLS(CLRDOP)
         REAKOL = CLKOLS(CLRRE1)
         IMAKOL = CLKOLS(CLRIM1)
         RATKOL = CLKOLS(CLRRA1)
         DELKOL = CLKOLS(CLRDE1)
         WEIKOL = CLKOLS(CLRWE1)
         REFKOL = CLKOLS(CLIRF1)
C                                       First polarization
         DO 60 LOOP = 1,NUMIF
            DOPOFF(LOOP) = RECORD(DOPKOL+LOOP-1)
            CREAL(1,LOOP) = RECORD(REAKOL+LOOP-1)
            CIMAG(1,LOOP) = RECORD(IMAKOL+LOOP-1)
            DELAY(1,LOOP) = RECORD(DELKOL+LOOP-1)
            RATE(1,LOOP) = RECORD(RATKOL+LOOP-1)
            WEIGHT(1,LOOP) = RECORD(WEIKOL+LOOP-1)
            REFA(1,LOOP) = RECI(REFKOL+LOOP-1)
 60         CONTINUE
         IF (NUMPOL.GE.2) THEN
C                                       Two polarizations
            MBDELY(2) = 0.0
            IF (CLKOLS(CLRMD2).GT.0) MBDELY(2) = RECORD(CLKOLS(CLRMD2))
            CLOCK(2) = 0.0
            IF (CLKOLS(CLRCK2).GT.0) CLOCK(2) = RECORD(CLKOLS(CLRCK2))
            DCLOCK(2) = 0.0
            IF (CLKOLS(CLRDC2).GT.0) DCLOCK(2) = RECORD(CLKOLS(CLRDC2))
            DISP(2) = 0.0
            IF (CLKOLS(CLRDS2).GT.0) DISP(2) = RECORD(CLKOLS(CLRDS2))
            DDISP(2) = 0.0
            IF (CLKOLS(CLRDD2).GT.0) DDISP(2) = RECORD(CLKOLS(CLRDD2))
C                                       Setup for looping over IF
            REAKOL = CLKOLS(CLRRE2)
            IMAKOL = CLKOLS(CLRIM2)
            RATKOL = CLKOLS(CLRRA2)
            DELKOL = CLKOLS(CLRDE2)
            WEIKOL = CLKOLS(CLRWE2)
            REFKOL = CLKOLS(CLIRF2)
            DO 70 LOOP = 1,NUMIF
               CREAL(2,LOOP) = RECORD(REAKOL+LOOP-1)
               CIMAG(2,LOOP) = RECORD(IMAKOL+LOOP-1)
               DELAY(2,LOOP) = RECORD(DELKOL+LOOP-1)
               RATE(2,LOOP) = RECORD(RATKOL+LOOP-1)
               WEIGHT(2,LOOP) = RECORD(WEIKOL+LOOP-1)
               REFA(2,LOOP) = RECI(REFKOL+LOOP-1)
 70            CONTINUE
            END IF
         END IF
      GO TO 999
C                                       Close
 800  CALL TABIO ('CLOS', 0, ICLRNO, RECORD, BUFFER, IERR)
      IF (IERR.GT.0) GO TO 990
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1800) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1800 FORMAT ('TABCAL: TABIO ERROR',I3)
      END

      SUBROUTINE APSUM (APCORE, USTRT, USTOP, UZERO, ROWSIZ, LOGRID,
     *   APSMWT, LROW, SUMWT)
C-----------------------------------------------------------------------
C! AP routine: Load AP sum weights
C# AP-util UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C AP Sum Weights: Sum the real component of the gridded uv data.
C For the Beam imaginary comp is zero and real is 1.0 * Weight.
C   Inputs:
C      USTRT   I    Start U row to write
C      USTOP   I    Stop  U row to write
C      UZERO   I    Row number of minimum row in AP to be processed
C                   (Often Location of row U=0 in AP)
C      ROWSIZ  I    Length of a Row in AP, number of reals
C      LOGRID  I    Index of start of rows in AP (0 relative)
C      APSMWT  I    Index to AP location to use for summing weights
C      LROW    I    Number of Cells in Row
C   Output:
C      SUMWT   R    Sum of Weights
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   USTRT, USTOP, UZERO, ROWSIZ, LOGRID, APSMWT, LROW
      REAL      SUMWT
C
      INTEGER IU, U, EROW
      REAL    APXTMP
C-----------------------------------------------------------------------
C                                       init sum
      SUMWT = 0
C                                       for all u to sum
      DO 100 IU = USTRT,USTOP
C                                       Convert to decreasing U
         U = USTOP - IU + USTRT
C                                       calc start of row for U
         IF (U.GE.UZERO) THEN
            EROW = LOGRID + ((U-UZERO)*ROWSIZ)
            CALL QWAIT
C                                       Sum Vector Elements (SVE)
            CALL QSVE (APCORE, EROW, 2, APSMWT, LROW)
C                                       Read sum of weights
            CALL QWR
C                                       Get weigth out of AP
            CALL QGET (APCORE, APXTMP, APSMWT, 1, 2)
            CALL QWD
C                                       accumulate sum
            SUMWT = SUMWT + APXTMP
            END IF
 100     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE MOM (ARA, X, Y, NX, NY, MOMAR, IERR)
C-----------------------------------------------------------------------
C! calculates moments in a 16x16 data array
C# Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Calculate all 0th, 1st, and 2nd moments of a NX*NY subarray of ARA,
C   centered at X,Y.  NX and NY should be odd.
C   Inputs:
C      ARA     R(16,16)  Input data array
C      X       R         x-center for moment calculation
C      Y       R         y-center
C      NX      I         # of points to include in x-direction. NX
C                        should be odd.  The points will be centered
C                        about X (rounded)
C      NY      I         # of points in y-direction
C   Outputs:
C      MOMAR   R(6)      00,10,20,01,11,02 yx-moments of ARA
C      IERR    I         0 => o.k.
C                        1 => subarray doesn't fit in main array
C-----------------------------------------------------------------------
      REAL       ARA(16,16), MOMAR(6), X, Y
      INTEGER    NX, NY, IERR
C
      INTEGER    IND, I, J, NJ, INDX, INDY, IAX1, IAX2, IAY1, IAY2
      REAL       S, T
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       compute loop limits
      I = X + 0.5
      IAX1 = I - NX/2
      IAX2 = IAX1 + NX - 1
      I = Y + 0.5
      IAY1 = I - NY/2
      IAY2 = IAY1+ NY - 1
C                                       check loop limits
      IERR = 1
      IF((IAX1.LT.1) .OR. (IAX2.GT.16) .OR. (IAY1.LT.1) .OR.
     *   (IAY2.GT.16)) GO TO 999
C                                       compute moments
      IERR = 0
      IND = 0
      DO 40 I = 1,3
         NJ = 4 - I
         DO 30 J = 1,NJ
            IND = IND + 1
            S = 0.0
            DO 20 INDX = IAX1,IAX2
               DO 10 INDY = IAY1,IAY2
                  T = ARA(INDX, INDY)
                  IF (T.EQ.FBLANK) GO TO 10
                     IF (I.GT.1) T = T * ((INDX - X)**(I-1))
                     IF (J.GT.1) T = T * ((INDY - Y)**(J-1))
                     S = S + T
 10               CONTINUE
 20            CONTINUE
            MOMAR(IND) = S
 30         CONTINUE
 40      CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'VLBSY.INC'
C                                                          Include VLBSY
C                                       Local include for VLBSY
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MXFQID, MAXNX
C                                       Max. # of FQ-IDs allowed
      PARAMETER (MXFQID = 28)
C                                       Max. # of NX entries allowed
      PARAMETER (MAXNX = 1024)
C                                       Inputs and general info
      INTEGER   SEQIN, DISKIN, ISUBA, LUNK, FINDK, OLDCNO, DROPED,
     *   ADDED, NPOL, NIFS, MISSED
      LOGICAL   DOCONC
      REAL      XSIN, XDISIN, XSUBA, XSYVER, DOKEEP, BADD(10)
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAME2(12)
      CHARACTER NAMEIN*12, CLAIN*6, NAME2*48
C                                       Buffers and file info
      INTEGER   SCBUFF(512), SYVER, SYTOT
C                                       Inputs and general info
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAME2, XSUBA,
     *   XSYVER, DOKEEP, BADD
      COMMON /TASKPM/ SEQIN, DISKIN, ISUBA, LUNK, FINDK, OLDCNO,
     *   SYTOT, DROPED, ADDED, DOCONC, NPOL, NIFS, MISSED
C                                       CHARACTER info
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAME2
C                                       Buffers and file info
      COMMON /SCFILE/ SCBUFF, SYVER
C                                       NX, FQ table information
      DOUBLE PRECISION DFRQ(MAXIF)
      REAL      TIMENX(2,MAXNX)
      INTEGER   INXSOU(MAXNX), INXFQ(MAXNX), IFQUV(MXFQID), NXDAT,
     *   NFQUV, NIFFQ, FREQID
      COMMON /NXFQIN/ DFRQ, TIMENX, INXSOU, INXFQ, IFQUV, NFQUV,
     *   NXDAT, NIFFQ, FREQID
C                                                          End VLBSY
LOCAL END
      PROGRAM VLBSY
C-----------------------------------------------------------------------
C! Read in VLBA tot data from ascii file.
C# UV Calibration EXT-util VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task VLBSY reads an ascii file containing the pulse-cal, cable cal
C   and state count information generated by the VLBA monitoring system.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input UV data.
C      INFILE         INFIL         Name of aux. file.
C      SUBARRAY       ISUBA         Subarray number
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'VLBSY.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'VLBSY '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL VLBSYI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Read total power ascii file
      CALL READSY (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Copy and update HI file.
      CALL VLBSYH
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCBUFF)
 999  STOP
      END
      SUBROUTINE VLBSYI (PRGN, JERR)
C-----------------------------------------------------------------------
C   VLBSYI gets input parameters for VLBSY.
C   Inputs:  PRGN    C*6       Program name
C   Output:  JERR    I         Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => cannot start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   JERR
C
      CHARACTER STAT*4, ANTNAM(10)*2, UTYPE*2, LINE*80
      LOGICAL   T, F
      INTEGER   NPARM, IERR, LC, JTRIM, IROUND, I, VER, LUNTMP, LUNSC
      INCLUDE 'VLBSY.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCHND.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA ANTNAM /'BR','FD','HN','KP','LA','MK','NL','OV','PT','SC'/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      LUNK = 10
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
      MISSED = 0
C                                       Get input parameters.
      NPARM = 32
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCBUFF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
            END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCBUFF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
C                                       Convert characters
      DO 5 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 5       CONTINUE
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (48, 1, XNAME2, NAME2)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      ISUBA = IROUND (XSUBA)
      ISUBA = MAX (ISUBA, 1)
      DROPED = 0
      ADDED = 0
C                                       Find file, read CATBLK
      OLDCNO = 1
      STAT = 'SRCH'
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, SCBUFF, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'WRIT', SCBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'COPYING CATBLK'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      NPOL = MIN  (2, CATBLK(KINAX+JLOCS))
      NIFS = CATBLK(KINAX+JLOCIF)
C                                       Open text file
      LC = JTRIM (NAME2)
      IF (NAME2(LC:LC).NE.'_') THEN
         CALL ZTXOPN ('QRED', LUNK, FINDK, NAME2, F, IERR)
      ELSE
         DO 40 I = 1,10
            NAME2(LC+1:) = ANTNAM(I)
            MSGSUP = 32000
            CALL ZTXOPN ('QRED', LUNK, FINDK, NAME2, F, IERR)
            MSGSUP = 0
            IF (IERR.EQ.0) GO TO 50
 40         CONTINUE
         END IF
 50   IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING TEXT FILE'
         JERR = IERR
         GO TO 990
         END IF
C                                       read first line
      CALL ZTXIO ('READ', LUNK, FINDK, LINE, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READ FIRST TEXT LINE'
         JERR = IERR
         GO TO 990
         END IF
      IF (LINE(:16).NE.'# Project Code: ') THEN
         MSGTXT = 'FILE HAS FORMAT UNCERTAINTIES'
         JERR = 8
         GO TO 990
         END IF
      CALL ZTXCLS (LUNK, FINDK, IERR)
      IF (NAME2(LC:LC).EQ.'_') NAME2(LC+1:) = '  '
C                                       get frequencies
      VER = 1
      LUNSC = LUNTMP (1)
      CALL CHNDAT ('READ', SCBUFF, DISKIN, OLDCNO, VER, CATBLK, LUNSC,
     *   I, FOFF, ISBAND, FINC, BNDCOD, FREQID, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'GETTING FREQUENCY INFORMATION'
         JERR = 10
         GO TO 990
         END IF
      DO 70 I = 1,NIFS
         DFRQ(I) = (CATD(KDCRV+JLOCF) + FOFF(I)) / 1.0D6
 70      CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VLBSYI: ERROR',I3,' ON ',A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
      END
      SUBROUTINE READSY (IERR)
C-----------------------------------------------------------------------
C   READSY builds an SY table from the DiFX ascii format file
C   Can loop over VLBA named files
C   Output:
C      IRET   I   > 0 -> failure of some sort
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'VLBSY.INC'
      INTEGER   LUNFQ, SUBA, LC, JTRIM, ILOOP, KBPLIM, KBP, SDAY,  IP,
     *   LIF, NOBAND, LUNSY, SYBUFF(512), ISYRNO, SYKOLS(MAXSYC),
     *   SYNUMV(MAXSYC), I, ISRC, IFQID, NOSTA, IROUND, IR, IL,
     *   NPV(2), IFREQS(MAXIF), J, NID, NOSORC, NPOLZ, CALTYP, NLINE,
     *   MISCNT
      LOGICAL   DOLOOP, FIRST
      CHARACTER ANTNAM(10)*2, TELNAM*8, LLINE*5000, NAMTEL*8,
     *   OBSDAT*8, SORC*16, PLINE*5000, PPLINE*5000
      DOUBLE PRECISION  XX, TIME, PVALS(3,MAXIF), JD, SCTIME, TIME1,
     *   TIME2, FREQOF, PTIME(2)
      REAL      DTIME, PSUM(2,MAXIF), PDIFF(2,MAXIF), PGAIN(2,MAXIF),
     *   RTIME
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA ANTNAM /'BR','FD','HN','KP','LA','MK','NL','OV','PT','SC'/
      DATA FIRST /.TRUE./
C-----------------------------------------------------------------------
      CALL H2CHR (8, 1, CATH(KHDOB), OBSDAT)
      CALL JULDAY (OBSDAT, JD)
      JD = JD - 2400000.5D0
      SDAY = JD + 0.001
      TELNAM = ' '
      CALL FILL (MAXIF, 0, IFREQS)
      CALTYP = 0
      MISCNT = 0
C                                       Make these not fatal errors
C                                       Read NX table information
      LUNFQ = 40
      CALL NXREAD (DISKIN, OLDCNO, ISUBA, CATBLK, LUNFQ, SCBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING NX TABLE'
         CALL MSGWRT (7)
         END IF
C                                       Get list of station names
      SUBA = ISUBA
      CALL GETANT (DISKIN, OLDCNO, SUBA, CATBLK, SCBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING ANTENNA DATA'
         CALL MSGWRT (7)
         END IF
C                                       file name
      LC = JTRIM (NAME2)
      DOLOOP = NAME2(LC:LC).EQ.'_'
      ILOOP = 0
 50   ILOOP = ILOOP + 1
      IF (DOLOOP) NAME2(LC+1:) = ANTNAM(ILOOP)
      IF (MISCNT.GT.0) THEN
         WRITE (MSGTXT,1050) MISCNT
         CALL MSGWRT (7)
         END IF
      MISCNT = 0
      CALL ZTXOPN ('READ', LUNK, FINDK, NAME2, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING TEXT FILE'
         IF (.NOT.DOLOOP) GO TO 990
         WRITE (MSGTXT,1000) IERR, 'OPENING TEXT FILE FOR ' //
     *      ANTNAM(ILOOP)
         CALL MSGWRT (7)
         GO TO 210
         END IF
      NOSORC = 0
      NLINE = 0
      NPV(1) = 0
      NPV(2) = 0
C                                       read a line
 100  PPLINE = PLINE
      PLINE = LLINE
      CALL ZTXIO ('READ', LUNK, FINDK, LLINE, IERR)
      IF (IERR.EQ.2) THEN
         GO TO 200
      ELSE IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READING TEXT FILE'
         IF (.NOT.DOLOOP) GO TO 990
         WRITE (MSGTXT,1000) IERR, 'READING TEXT FILE FOR' //
     *      ANTNAM(ILOOP)
         CALL MSGWRT (7)
         GO TO 200
      ELSE
         NLINE = NLINE + 1
         KBPLIM = JTRIM (LLINE)
C                                       new scan - get source
         IF (LLINE(:18).EQ.'#P  setObservation') THEN
            KBP = 19
            CALL GETNUM (LLINE, KBPLIM, KBP, XX)
            SCTIME = XX - SDAY
            NOSORC = 0
            DO 105 I = KBP,KBPLIM
               IF (LLINE(I:I).NE.' ') GO TO 110
 105           CONTINUE
            GO TO 100
 110        J = 0
            KBP = I
            SORC = ' '
            DO 115 I = KBP,KBPLIM
               IF ((LLINE(I:I).NE.' ') .AND. (J.LT.16)) THEN
                  J = J + 1
                  SORC(J:J) = LLINE(I:I)
               ELSE
                  GO TO 120
                  END IF
 115           CONTINUE
 120        NOSORC = 0
            IF (SORC.NE.'FINAL') THEN
               NID = 1
               CALL SOURNU (SORC, 0, 1, DISKIN, OLDCNO, NID, SCBUFF,
     *            NOSORC, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READING SOURCE TABLE'
                  CALL MSGWRT (7)
                  NOSORC = 0
                  END IF
               END IF
            GO TO 100
         ELSE IF (LLINE(:13).EQ.'#P  setFreq 0') THEN
            KBP = 14
            CALL GETNUM (LLINE, KBPLIM, KBP, XX)
            FREQOF = XX
            GO TO 100
         ELSE IF ((LLINE(1:1).EQ.'#') .OR. (NOSORC.EQ.0)) THEN
            GO TO 100
            END IF
C                                       antenna data
C                                       telescope name
         NAMTEL = LLINE(:2)
         CALL CHLTOU (8, NAMTEL)
         IF (NAMTEL.NE.TELNAM) THEN
            NOSTA = 0
            DO 125 I = 1,NSTNS
               IF (NAMTEL.EQ.STNNAM(I)) NOSTA = TELNO(I)
 125           CONTINUE
            IF (NOSTA.LE.0) NOSTA = NSTNS + ILOOP
            IF (MISCNT.GT.0) THEN
               WRITE (MSGTXT,1050) MISCNT
               CALL MSGWRT (7)
               END IF
            MISCNT = 0
            MSGTXT = 'Data line changes telescope from ' //
     *         TELNAM(:JTRIM(TELNAM)) // ' to ' //
     *         NAMTEL(:JTRIM(NAMTEL))
            IF (TELNAM.NE.' ') CALL MSGWRT (6)
            TELNAM = NAMTEL
            END IF
C                                       time
         KBP = 3
         CALL GETNUM (LLINE, KBPLIM, KBP, XX)
         TIME1 = XX - SDAY
         CALL GETNUM (LLINE, KBPLIM, KBP, XX)
         TIME2 = XX - SDAY
         TIME = (TIME2 + TIME1) / 2.0D0
         DTIME = (TIME2 - TIME1)
         LIF = INDEX (LLINE, 'flagged')
         IF (LIF.GT.0) GO TO 100
         IR = INDEX (LLINE, ' R ')
         IL = INDEX (LLINE, ' L ')
         IP = 1
         IF (IL.GT.0) IP = 2
C                                       look for mismatches
         IF ((NPV(IP).GT.0) .OR. ((NPV(3-IP).GT.0) .AND.
     *      (TIME-PTIME(3-IP).GT.0.000001))) THEN
            MSGTXT = 'MISSING SOMETHING'
            IF (MISCNT.LE.0) CALL MSGWRT (7)
            MISCNT = MISCNT + 1
            MISSED = MISSED + 1
            IF (ISRC.LE.0) DROPED = DROPED + 1
            IF ((ISRC.GT.0) .OR. (DOKEEP.GT.0.0)) THEN
               CALL TABSY ('WRIT', SYBUFF, ISYRNO, SYKOLS, SYNUMV,
     *            NPOLZ, NIFS, TIME, DTIME, CALTYP, NOSORC, NOSTA,
     *            ISUBA, FREQID, PDIFF, PSUM, PGAIN, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITING OUTPUT SY TABLE'
                  GO TO 990
                  END IF
               ADDED = ADDED + 1
               END IF
            NPV(1) = 0
            NPV(2) = 0
            PTIME(1) = 0.0D0
            PTIME(2) = 0.0D0
            I = 2 * MAXIF
            CALL RFILL (I, FBLANK, PSUM)
            CALL RFILL (I, FBLANK, PDIFF)
            CALL RFILL (I, 1.0, PGAIN)
            END IF
         PTIME(IP) = TIME
C                                       Get source id. for this time
         RTIME = TIME
         CALL NXSRCH (RTIME, ISRC, IFQID)
         IF ((ISRC.NE.NOSORC) .AND. (ISRC.NE.0)) THEN
            WRITE (MSGTXT,1125) ISRC, NOSORC, SORC
            CALL MSGWRT (7)
            END IF
         FREQID = IFQID
C                                       FIRST: init arrays, open table
         IF (FIRST) THEN
            NOBAND = NIFS
            NPOLZ = NPOL
            I = CATBLK(KINAX+JLOCS)
            I = MIN (I, 2)
            IF ((NPOLZ.NE.I) .OR. (NOBAND.NE.CATBLK(KINAX+JLOCIF)))
     *         THEN
               WRITE (MSGTXT,1110) NPOLZ, NOBAND, I,
     *            CATBLK(KINAX+JLOCIF)
               CALL MSGWRT (6)
               END IF
            I = 2 * MAXIF
            CALL RFILL (I, FBLANK, PSUM)
            CALL RFILL (I, FBLANK, PDIFF)
            CALL RFILL (I, 1.0, PGAIN)
C                                       SY number
            SYVER = IROUND (XSYVER)
C                                       Check to see if SY table exists
            CALL FNDEXT ('SY', CATBLK, SYTOT)
            IF (SYVER.LE.0) SYVER = SYTOT + 1
            LUNSY = 30
            CALL SYINI ('WRIT', SYBUFF, DISKIN, OLDCNO, SYVER, CATBLK,
     *         LUNSY, ISYRNO, SYKOLS, SYNUMV, NSTNS, NPOLZ, NOBAND,
     *         IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'OPENING SY TABLE'
               GO TO 990
               END IF
C                                       warning of concatenation
            IF (SYVER.LE.SYTOT) THEN
               DOCONC = .TRUE.
               WRITE (MSGTXT,1111) SYVER
               CALL REFRMT (MSGTXT, '_', I)
               CALL MSGWRT (5)
               END IF
C                                       Update CATBLK
            CALL CATIO ('UPDT', DISKIN, OLDCNO, CATBLK, 'REST', SCBUFF,
     *         IERR)
            FIRST = .FALSE.
            END IF
C                                       parse the remainder of the line
         DO 130 LIF = 1,NIFS
C                                       frequency
            CALL GETNUM (LLINE, KBPLIM, KBP, XX)
            PVALS(1,LIF) = XX
C                                       bandwidth
            CALL GETNUM (LLINE, KBPLIM, KBP, XX)
            IF (PVALS(1,LIF).LT.0.0D0) PVALS(1,LIF) = -PVALS(1,LIF) - XX
            KBP = KBP + 2
C                                       PON
            CALL GETNUM (LLINE, KBPLIM, KBP, XX)
            PVALS(2,LIF) = XX / 1.0D9
C                                       POFF
            CALL GETNUM (LLINE, KBPLIM, KBP, XX)
            PVALS(3,LIF) = XX / 1.0D9
 130        CONTINUE
C                                       Freq order
         IF (IFREQS(1).EQ.0) THEN
            DO 150 LIF = 1,NIFS
               DO 140 I = 1,NIFS
                  IF (ABS(PVALS(1,LIF)-DFRQ(I)).LT.8.D0)
     *               IFREQS(LIF) = I
 140              CONTINUE
 150           CONTINUE
            END IF
         DO 160 LIF = 1,NIFS
            J = IFREQS(LIF)
            PSUM(IP,J) = PVALS(2,LIF) + PVALS(3,LIF)
            PDIFF(IP,J) = PVALS(2,LIF) - PVALS(3,LIF)
 160        CONTINUE
         NPV(IP) = 1
C                                       write it out
         IF (NPV(1)+NPV(2).EQ.2) THEN
            IF (ISRC.LE.0) DROPED = DROPED + 1
            IF ((ISRC.GT.0) .OR. (DOKEEP.GT.0.0)) THEN
               CALL TABSY ('WRIT', SYBUFF, ISYRNO, SYKOLS, SYNUMV,
     *            NPOLZ, NIFS, TIME, DTIME, CALTYP, NOSORC, NOSTA,
     *            ISUBA, FREQID, PDIFF, PSUM, PGAIN, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'WRITING OUTPUT SY TABLE'
                  GO TO 990
                  END IF
               ADDED = ADDED + 1
               END IF
            NPV(1) = 0
            NPV(2) = 0
            PTIME(1) = 0.0D0
            PTIME(2) = 0.0D0
            I = 2 * MAXIF
            CALL RFILL (I, FBLANK, PSUM)
            CALL RFILL (I, FBLANK, PDIFF)
            CALL RFILL (I, 1.0, PGAIN)
            END IF
         GO TO 100
         END IF
C                                       close input text file
 200  CALL ZTXCLS (LUNK, FINDK, IERR)
 210  IF ((DOLOOP) .AND. (ILOOP.LT.10)) GO TO 50
      IF (MISCNT.GT.0) THEN
         WRITE (MSGTXT,1050) MISCNT
         CALL MSGWRT (7)
         END IF
      MISCNT = 0
      CALL TABSY ('CLOS', SYBUFF, ISYRNO, SYKOLS, SYNUMV, NPOLZ, NIFS,
     *   TIME, DTIME, CALTYP, NOSORC, NOSTA, ISUBA, FREQID, PDIFF, PSUM,
     *   PGAIN, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('READSY ERROR',I4,' ON ',A)
 1050 FORMAT ('MISSING SOMETHING',I7,' MORE TIMES')
 1110 FORMAT ('SY FILE Npol, Nif',I2,I4,' DO NOT MATCH UV DATA',I2,I4)
 1111 FORMAT ('READSY: Concatenating to SY table',I5)
 1125 FORMAT ('SOURCE NUMBER',I4,' EXPECTED',I4,' ''',A,'''')
      END
      SUBROUTINE VLBSYH
C-----------------------------------------------------------------------
C   VLBSYH copies and updates history file.
C-----------------------------------------------------------------------
      INTEGER   LUN1, IERR, ITIME(3), DATE(3), I
      CHARACTER HILINE*72, CITIME*20
      INCLUDE 'VLBSY.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1 /27/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HIOPEN (LUN1, DISKIN, FCNO(NCFILE), SCBUFF, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (ITIME)
      CALL TIMDAT (ITIME, DATE, CITIME(13:20), CITIME(1:12))
      WRITE (HILINE,1010) TSKNAM, RLSNAM, CITIME(1:12), CITIME(13:20)
      CALL HIADD (LUN1, HILINE, SCBUFF, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       File name
      WRITE (HILINE,2000) TSKNAM, NAME2
      CALL HIADD (LUN1, HILINE, SCBUFF, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Version #
      IF (DOCONC) THEN
         WRITE (HILINE,2001) TSKNAM, SYVER, ADDED
         CALL HIADD (LUN1, HILINE, SCBUFF, IERR)
         IF (IERR.NE.0) GO TO 100
         WRITE (MSGTXT,1020) ADDED, SYVER
         CALL REFRMT (MSGTXT, '_', I)
         CALL MSGWRT (4)
      ELSE
         WRITE (HILINE,2002) TSKNAM, SYVER, ADDED
         CALL HIADD (LUN1, HILINE, SCBUFF, IERR)
         IF (IERR.NE.0) GO TO 100
         WRITE (MSGTXT,1021) ADDED, SYVER
         CALL REFRMT (MSGTXT, '_', I)
         CALL MSGWRT (4)
         END IF
C                                       Dropped
      IF (DROPED.GT.0) THEN
         IF (DOKEEP.GT.0.0) THEN
            WRITE (HILINE,2003) TSKNAM, DROPED
         ELSE
            WRITE (HILINE,2004) TSKNAM, DROPED
            END IF
         CALL HIADD (LUN1, HILINE, SCBUFF, IERR)
         IF (IERR.NE.0) GO TO 100
         MSGTXT = HILINE(9:)
         CALL REFRMT (MSGTXT, '_', I)
         CALL MSGWRT (4)
         END IF
C                                       missing a polariz
      IF (MISSED.GT.0) THEN
         WRITE (HILINE,2010) TSKNAM, MISSED
         CALL HIADD (LUN1, HILINE, SCBUFF, IERR)
         IF (IERR.NE.0) GO TO 100
         MSGTXT = HILINE(9:)
         CALL REFRMT (MSGTXT, '_', I)
         CALL MSGWRT (4)
         END IF
C                                       Close HI file
 100  CALL HICLOS (LUN1, .TRUE., SCBUFF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VLBSYH: ERROR',I3,' OPENING HISTORY FILE')
 1010 FORMAT (A6,'RELEASE =''',A,' ''  /********* Start ',
     *   A12,2X,A8)
 1020 FORMAT (I10,' records added to old SY table version',I4)
 1021 FORMAT (I10,' records written to new SY table version',I4)
 2000 FORMAT (A6,'INFILE = ''',A48,'''')
 2001 FORMAT (A6,'SYVERS =',I4,'  / Concatenated',I8,
     *   ' records to existing table')
 2002 FORMAT (A6,'SYVERS =',I4,'  / Wrote',I8,
     *   ' records to new table')
 2003 FORMAT (A6,'/ Kept',I8,' records not in scans')
 2004 FORMAT (A6,'/ Dropped',I8,' records not in scans')
 2010 FORMAT (A6,'/ ',I8,' records missing a polarization')
      END
      SUBROUTINE NXREAD (INDISK, ICNO, ISUB, CATBLK, ILUN, JBUFF, IRET)
C-----------------------------------------------------------------------
C   Subroutine to read NX table information into memory
C   Inputs:
C      INDISK  I       Disk volume number
C      ICNO    I       Catalog slot number
C      ISUB    I       Subarray number
C      CATBLK  I(256)  Catalog header block
C      ILUN    I       LUN to use for table I/O
C      JBUFF   I(*)    Buffer for table I/O
C      MAXNX   I       Maximum dimension of TIMENX, INXSOU, INXFQ
C      MXFQID  I       Maximum dimension of IFQUV
C   Outputs to common:
C      TIMENX  R(2,*)  Scan start, stop times
C      INXSOU  I(*)    Source ID's from NX table
C      INXFQ   I(*)    FQ-ID's from NX table
C      NXDAT   I       Number of NX table entries read
C      IFQUV   I(*)    Array of FQ-ID's found
C      NFQUV   I       No. of entries in IFQUV
C   Outputs:
C      IRET    I       Return code (0 => ok)
C-----------------------------------------------------------------------
      INTEGER   INDISK, ICNO, ISUB, CATBLK(256), ILUN, JBUFF(*), IRET
C
      INCLUDE 'VLBSY.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      LOGICAL   WTABLE, WEXIST, WFITS
      REAL      TIME, TINT, TEPS
      INTEGER    NXKOLS(MAXNXC), NXNUMV(MAXNXC), IERR, I, INXRNO,
     *   IDSOUR, ISUBNX, ISTART, IEND, IFQID, NROW, NVISMX, J
C-----------------------------------------------------------------------
C                                       Initialisation
      IRET = 0
      NXDAT = 0
      TEPS = 0.1 / (24.0 * 3600.0)
C                                       Does an NX table exist ?
      CALL ISTAB ('NX', INDISK, ICNO, 1, ILUN, JBUFF, WTABLE, WEXIST,
     *   WFITS, IERR)
      IF ((IERR.NE.0).OR.(.NOT.(WEXIST.AND.WTABLE))) THEN
         IRET = 1
         WRITE (MSGTXT,1020)
         GO TO 990
         END IF
C                                       Open the NX table
      CALL NDXINI ('READ', JBUFF, INDISK, ICNO, 1, CATBLK, ILUN,
     *   INXRNO, NXKOLS, NXNUMV, IERR)
      IF (IERR.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Read table into memory
      NROW = JBUFF(5)
      NVISMX = 0
      DO 100 I = 1, NROW
         CALL TABNDX ('READ', JBUFF, INXRNO, NXKOLS, NXNUMV, TIME,
     *      TINT, IDSOUR, ISUBNX, ISTART, IEND, IFQID, IERR)
C                                       Record de-selected ?
         IF (IERR.EQ.-1) GO TO 100
         IF (IERR.NE.0) THEN
            IRET = 3
            WRITE (MSGTXT,1100) IERR
            GO TO 990
            END IF
C                                       Update maximum vis. no.
         NVISMX = MAX (NVISMX, IEND)
C                                       Correct subarray ?
         IF (ISUBNX.NE.ISUB) GO TO 100
C                                       NX buffer too small ?
         NXDAT = NXDAT + 1
         IF (NXDAT.GT.MAXNX) THEN
            IRET = 4
            WRITE (MSGTXT,1120)
            GO TO 990
            END IF
C
         TIMENX(1,NXDAT) = TIME - TINT / 2.0 - TEPS
         TIMENX(2,NXDAT) = TIME + TINT / 2.0 + TEPS
         INXSOU(NXDAT) = IDSOUR
         INXFQ(NXDAT) = IFQID
100      CONTINUE
C                                       Close NX table
      CALL TABIO ('CLOS', 0, INXRNO, JBUFF, JBUFF, IERR)
      IF (IERR.NE.0) THEN
         IRET = 4
         WRITE (MSGTXT,1140) IERR
         GO TO 990
         END IF
C                                       Determine whether NX table is
C                                       current by matching Nvis in
C                                       catalog hdr. with NVISMX from
C                                       NX table.
      IF (NVISMX.NE.CATBLK(KIGCN)) THEN
         IRET = 5
         WRITE (MSGTXT,1160)
         GO TO 990
         END IF
C                                       Any valid scans found ?
      IF (NXDAT.EQ.0) THEN
         IRET = 6
         WRITE (MSGTXT,1180)
         GO TO 990
         END IF
C                                       Compile table of all unique
C                                       FQ_IDs in the data. Use
C                                       information read from the NX
C                                       table.
      NFQUV = 0
      DO 200 I = 1, NXDAT
         DO 150 J = 1, NFQUV
            IF (IFQUV(J).EQ.INXFQ(I)) GO TO 200
150         CONTINUE
C                                       New FQ-ID found
         NFQUV = NFQUV + 1
         IF (NFQUV.GT.MXFQID) THEN
            WRITE (MSGTXT,1150)
            IRET = 11
            GO TO 990
            END IF
         IFQUV(NFQUV) = INXFQ(I)
200      CONTINUE
C
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C
999   RETURN
C-----------------------------------------------------------------------
1020  FORMAT ('NXREAD: NO VALID NX TABLE FOUND - RUN INDXR')
1040  FORMAT ('NXREAD: ERR',I3,' OPENING NX TABLE')
1100  FORMAT ('NXREAD: ERR',I3,' READING NX TABLE')
1120  FORMAT ('NXREAD: INCREASE PARAMETER MAXNX')
1140  FORMAT ('NXREAD: ERR',I3,' CLOSING NX TABLE')
1160  FORMAT ('NXREAD: NX TABLE OLD - RUN INDXR')
1180  FORMAT ('NXREAD: NO SCANS FOR SUBARRAY',I4)
1150  FORMAT ('NXREAD: PARAMETER MXFQID NEEDS TO BE INCREASED')
      END
      SUBROUTINE NXSRCH (RTIME, ISOUID, IFQID)
C----------------------------------------------------------------------
C   Search the NX table for the source and freq. ID. at a given time
C   Inputs:
C      RTIME   R   Input time relative to the ref. date (in days)
C   Outputs:
C      ISOUID  I   Source id. (0 if not found)
C      IFQID   I   FQ. id.
C---------------------------------------------------------------------
      REAL RTIME
      INTEGER ISOUID, IFQID
C
      INCLUDE 'VLBSY.INC'
      INTEGER I
C---------------------------------------------------------------------
      ISOUID = 0
      IFQID = 0
C                                       Search the NX table
      DO 100 I = 1, NXDAT
         IF ((RTIME.GE.TIMENX(1,I)).AND.(RTIME.LE.TIMENX(2,I))) THEN
            ISOUID = INXSOU(I)
            IFQID = INXFQ(I)
            END IF
100      CONTINUE
C                                       Exit
      RETURN
      END

LOCAL INCLUDE 'PTVSPC.INC'
      INTEGER   NOPT, MAXCHR
      PARAMETER (NOPT = 13)
      PARAMETER (MAXCHR = 19)
LOCAL END
LOCAL INCLUDE 'TVSPC.INC'
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER NAMIN*12, CLSIN*6, NAMIN2*12, CLSIN2*6, FUNTYP*2,
     *   SAMTYP*4, NAMIN3*12, CLSIN3*6, NAMIN4*12, CLSIN4*6
      HOLLERITH XNAMIN(3), XCLSIN(2), XNAMI2(3), XCLSI2(2), XNAMI3(3),
     *   XCLSI3(2), XFUNC,XSAMP, XNAMI4(3), XCLSI4(2)
      REAL      SEQIN, DSKIN, SEQIN2, DSKIN2, SEQIN3, DSKIN3, SEQIN4,
     *   DSKIN4, TBLC(7), TTRC(7), XTVCH, RANGE(2), APARM(10), XCBPLT
      INTEGER   CATBLK(256), CATBL1(256), CATBL2(256), CATBL3(256),
     *   CATBL4(256), CATBLS(256), CATBLP(256), CATBS2(256)
      REAL      CATR(256), CATR1(256), CATR2(256), CATR3(256),
     *   CATR4(256), CATRS(256), PRANGE(2), CRANGE(2)
      DOUBLE PRECISION CATD(128), CATD1(128), CATD2(128), CATD3(128),
     *   CATD4(128), CATDS(128)
      HOLLERITH CATH(256), CATH1(256), CATH2(256), CATH3(256),
     *   CATH4(256), CATHS(256)
      REAL      BUFF1(MABFSS), SPECTR(MAXIMG), SFUNC(128), GAUSS(15,2),
     *   GRMS, SPECT2(MAXIMG), SLDATA(MAXIMG), SLPOS(MAXIMG), XCEN
      INTEGER   LUN1, LUN2, LUN3, IND1, IND2, IND3, VOL1, VOL2, VOL3,
     *   SLOT1, SLOT2, SLOT3, SEQ1, SEQ2, SEQ3, IUSER, TVCH, JBUFSZ,
     *   CURWIN(4,2), LWINTV(4), GRMENU, GRSPC1, GRSPC2, GRMEBG, GRLABL,
     *   GRMODL, GRESID, GRBLAC, IBUFF(MAXIMG), JBUFF(MAXIMG),
     *   IWINTV(4), SWINTV(4), LASTYZ(3), SMTYPE, SMWID, NGAUSS, ITTER,
     *   SCRTCH(MAXIMG), BCHAN, ECHAN, JJC, IDROP(2), LUN4, IND4, VOL4,
     *   SLOT4, SEQ4, JWINTV(4), CURPLN, CURCHN, SPECOK, DOLABL,
     *   SWIN1(4), SWIN2(4), CBPLOT
      LOGICAL   MENUOK, TWOCUB, TWOIMG
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
      EQUIVALENCE (CATBL1, CATR1, CATH1, CATD1)
      EQUIVALENCE (CATBL2, CATR2, CATH2, CATD2)
      EQUIVALENCE (CATBL3, CATR3, CATH3, CATD3)
      EQUIVALENCE (CATBL4, CATR4, CATH4, CATD4)
      EQUIVALENCE (CATBLS, CATRS, CATHS, CATDS)
      COMMON /MAPHDR/ CATD, CATD1, CATD2, CATD3, CATD4, CATDS, CATBLP,
     *   CATBS2
      COMMON /INPARM/ XNAMIN, XCLSIN, SEQIN, DSKIN, TBLC, TTRC, XTVCH,
     *   RANGE, XFUNC, XNAMI2, XCLSI2, SEQIN2, DSKIN2, APARM, XSAMP,
     *   XNAMI3, XCLSI3, SEQIN3, DSKIN3, XNAMI4, XCLSI4, SEQIN4, DSKIN4,
     *   XCBPLT
      COMMON /CHARPM/ NAMIN, CLSIN, NAMIN2, CLSIN2, NAMIN3, CLSIN3,
     *   NAMIN4, CLSIN4, SAMTYP, FUNTYP
      COMMON /BUFFRS/ BUFF1, IBUFF, JBUFF
      COMMON /TVSPCP/ LUN1, LUN2, LUN3, IND1, IND2, IND3, VOL1, VOL2,
     *   VOL3, SEQ1, SEQ2, SEQ3, SLOT1, SLOT2, SLOT3, TVCH, JBUFSZ,
     *   IUSER, CURWIN, PRANGE, LWINTV, IWINTV, SWINTV, GRMENU, GRSPC1,
     *   GRSPC2, GRMEBG, GRLABL, GRMODL, GRESID, GRBLAC, MENUOK, LASTYZ,
     *   SMTYPE,SMWID, SFUNC, NGAUSS, GRMS, ITTER, TWOCUB, TWOIMG,
     *   GAUSS, SPECTR, SPECT2, SLDATA, SLPOS, BCHAN, ECHAN, SPECOK,
     *   XCEN, JJC, IDROP, SCRTCH, LUN4, IND4, VOL4, SEQ4, SLOT4,
     *   JWINTV, CURPLN, CURCHN, CRANGE, DOLABL, SWIN1, SWIN2, CBPLOT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DDCH.INC'
LOCAL END
      PROGRAM TVSPC
C-----------------------------------------------------------------------
C! displays spectrum under cursor from 1 or 2 cubes, incl Gaussian fit
C# TV Map-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2016-2017, 2019, 2021-2022, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TVSPC will display an image on the TV based on input images giving
C   separate red, green, and blue pictures.  It allows for interactive
C   scaling of the images.
C   INPUTS:   (from AIPS)
C      USERID   R      user number, 0 means use logon user number,
C                      32000 means any user can be accessed.
C      INNAME   R(3)   name of RGB/redimage.
C      INCLASS  R(2)   class of RGB/red image.
C      INSEQ    R      sequence number of RGB/red image.
C      INDISK   R      disk volume number. 0 means try all.
C      IN2NAME  R(3)   name of green image.
C      IN2CLASS R(2)   class of green image.
C      IN2SEQ   R      sequence number of green image.
C      IN2DISK  R      disk volume number. 0 means try all.
C      IN3NAME  R(3)   name of blue image.
C      IN3CLASS R(2)   class of blue image.
C      IN3SEQ   R      sequence number of blue image.
C      IN3DISK  R      disk volume number. 0 means try all.
C      TBLC      R(7)   the coordinate in the input file to become the
C                      left hand coordinate (1,1) of the contour plot.
C                      TBLC(1) is the X coordinate and TBLC(2) is the Y
C                      coordinate.  The first coordinate in the input
C                      image is (1,1).
C      TTRC      R(7)   the coordinate in the input file to become the
C                      top right hand corner of the plot.
C      DOALIGN  R      >= 0 => 2nd/3rd image must align with 1st
C      TVCHAN   R      Desired TV channel
C      PIXRANGE R(2)   the maximum and minimum values allowed for the
C                      map.  All other values will be clipped.  If
C                      IRANGE(1) .GE. IRANGE(2) then the map max and
C                      min will be used.
C      DPARM    R(10)  (1,2) pixrange of 2nd image, default = PIXRANGE
C                      (3,4) pixrange of 3rd image, default = PIXRANGE
C                      (5) # levels per R,G,B   < 8 or > 40 => 32.
C                      (6) # pixels in subimage <= 86000.  0 => 86000.
C                      (7) # levels/r,g,b during interaction <= (5)
C                      (8) > 0 => use 1-channel method on TVs capable of
C                          full RGB
C      DOOUTPUT R      > 0 => write RGB PostScript
C      OUTFILE  H(12)  Name of the output file. blank -> place in
C                      printer queue.
C      RGBGAMMA R(3)   RGB Gamma corrections
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   INPRMS, IRET, NWORDS, NX, NY, JERR, NX2, NY2, NZ2
      LONGINT   PIMAGE, PIMAG2
      REAL      IMAGE(2), IMAGE2(2)
      CHARACTER PRGNAM*6
      INCLUDE 'TVSPC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       init the task
      INPRMS = 58
      PRGNAM = 'TVSPC'
      CALL TVSPIN (PRGNAM, INPRMS, IRET)
      IF (IRET.NE.0) GO TO 910
C                                       allocate image
      NX = TTRC(1) - TBLC(1) + 1
      NY = TTRC(2) - TBLC(2) + 1
      NWORDS = (NX * NY - 1) / 1024 + 3
      CALL ZMEMRY ('GET ', TSKNAM, NWORDS, IMAGE, PIMAGE, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'GETTING MEMORY FOR IMAGE'
         GO TO 900
         END IF
C                                       read image
      MSGTXT = 'read image 1 into memory'
      CALL MSGWRT (2)
      CALL TVSPIM (NX, NY, IMAGE(1+PIMAGE), IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READING IMAGE'
         GO TO 900
         END IF
C                                       allocate image
      IF (TWOIMG) THEN
         NX2 = CATBL4(KINAX)
         NY2 = CATBL4(KINAX+1)
         NZ2 = CATBL4(KINAX+2)
         NWORDS = (NX2 * NY2 * NZ2 - 1) / 1024 + 3
         CALL ZMEMRY ('GET ', TSKNAM, NWORDS, IMAGE2, PIMAG2, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'GETTING MEMORY FOR IMAGE 2'
            GO TO 900
            END IF
         MSGTXT = 'read image cube 2 into memory'
         CALL MSGWRT (2)
         CALL TVSPI2 (NX2, NY2, NZ2, IMAGE2(1+PIMAG2), IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING IMAGE'
            GO TO 900
            END IF
         END IF
C                                       do the function
      CALL TVSPDO (NX, NY, IMAGE(1+PIMAGE), NX2, NY2, NZ2,
     *   IMAGE2(1+PIMAG2), IRET)
      GO TO 910
C                                       error message
 900  IF (IRET.NE.0) CALL MSGWRT (8)
C                                       close TV
 910  IF ((TVIND.GT.0) .AND. (TVIND2.GT.0)) THEN
         CALL TVCLOS (SCRTCH, JERR)
         END IF
C                                       close files
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' ON ',A)
      END
      SUBROUTINE TVSPIN (PRGNAM, INPRMS, IRET)
C-----------------------------------------------------------------------
C   Routine to get parameters for TVSPC
C   Inputs:
C      PRGNAM   C*6    Program name
C      INPRMS   I      Number of data parameters from AIPS
C   Outputs:
C       SCRTCH  I(*)   Scratch buffer
C       IRET    I      Return code 0=> OK, else just go to DIE
C   Task parameters are returned in common /INPARM/
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   INPRMS, IRET
C
      INCLUDE 'PTVSPC.INC'
C
      INTEGER   IERR, IROUND, I, II, TVCODE, DEPTH(5)
      CHARACTER FTYPE*2, SUBR*8, CTEMP*8, TTEMP*8
      REAL      SLOPE, RTEMP
      DOUBLE PRECISION DTEMP
      INCLUDE 'TVSPC.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
      NSCR = 0
      NCFILE = 0
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      IRET = 0
      JBUFSZ = 2 * MABFSS
C                                       Get input values from AIPS.
      CALL GTPARM (PRGNAM, INPRMS, RQUICK, XNAMIN, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'OBTAINING INPUT PARAMETERS'
            CALL MSGWRT (8)
      ELSE
         RQUICK = .FALSE.
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       AIPS Holleriths ->
C                                       characters
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
      CALL H2CHR (12, 1, XNAMI2, NAMIN2)
      CALL H2CHR (6, 1, XCLSI2, CLSIN2)
      CALL H2CHR (12, 1, XNAMI3, NAMIN3)
      CALL H2CHR (6, 1, XCLSI3, CLSIN3)
      CALL H2CHR (12, 1, XNAMI4, NAMIN4)
      CALL H2CHR (6, 1, XCLSI4, CLSIN4)
      CALL H2CHR (2, 1, XFUNC, FUNTYP)
      CALL H2CHR (4, 1, XSAMP, SAMTYP)
      CALL TYPESM (SAMTYP, SMTYPE)
      CURPLN = 0
      CURCHN = 0
C
      LUN1 = 16
      LUN2 = 17
      LUN3 = 18
      LUN4 = 19
      SEQ1 = IROUND (SEQIN)
      SEQ2 = IROUND (SEQIN2)
      SEQ3 = IROUND (SEQIN3)
      SEQ4 = IROUND (SEQIN4)
      VOL1 = IROUND (DSKIN)
      VOL2 = IROUND (DSKIN2)
      VOL3 = IROUND (DSKIN3)
      VOL4 = IROUND (DSKIN4)
      IUSER = NLUSER
      TVCH = IROUND (XTVCH)
      IF (TVCH.LE.0) TVCH = 1
      CBPLOT = IROUND (ABS(XCBPLT))
C                                       open 2nd spectrum image
      FTYPE = 'MA'
      TWOCUB = NAMIN3.NE.' '
      IF (TWOCUB) THEN
         CALL MAPOPN ('READ', VOL3, NAMIN3, CLSIN3, SEQ3, FTYPE, IUSER,
     *      LUN3, IND3, SLOT3, CATBLK, SCRTCH, IERR)
         IF (IERR.GE.2) THEN
            WRITE (MSGTXT,1000) IERR, 'OPENING IMAGE 3'
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = VOL3
         FCNO(NCFILE) = SLOT3
         FRW(NCFILE) = 0
         CALL COPY (256, CATBLK, CATBL3)
         END IF
      TWOIMG = NAMIN4.NE.' '
      IF (TWOIMG) THEN
         CALL MAPOPN ('READ', VOL4, NAMIN4, CLSIN4, SEQ4, FTYPE, IUSER,
     *      LUN4, IND4, SLOT4, CATBLK, SCRTCH, IERR)
         IF (IERR.GE.2) THEN
            WRITE (MSGTXT,1000) IERR, 'OPENING IMAGE 4'
            GO TO 990
            END IF
         NCFILE = NCFILE + 1
         FVOL(NCFILE) = VOL4
         FCNO(NCFILE) = SLOT4
         FRW(NCFILE) = 0
         CALL COPY (256, CATBLK, CATBL4)
         CATBLK(IIVOL) = VOL4
         CATBLK(IICNO) = SLOT4
         CRANGE(1) = CATR4(KRDMN)
         CRANGE(2) = CATR4(KRDMX)
         CATR(IRRAN) = CRANGE(1)
         CATR(IRRAN+1) = CRANGE(2)
         CALL CHR2H (2, FUNTYP, 1, CATH(IITRA))
         CALL COPY (256, CATBLK, CATBLP)
         END IF
C                                       open spectrum image
      CALL MAPOPN ('WRIT', VOL2, NAMIN2, CLSIN2, SEQ2, FTYPE, IUSER,
     *   LUN2, IND2, SLOT2, CATBLK, SCRTCH, IERR)
      IF (IERR.GE.2) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING IMAGE 2'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = VOL2
      FCNO(NCFILE) = SLOT2
      FRW(NCFILE) = 1
      CALL COPY (256, CATBLK, CATBL2)
      CALL FILL (5, 1, DEPTH)
      BCHAN = 1
      ECHAN = CATBL2(KINAX)
C                                       check stuff
      IF (TWOIMG) THEN
         SUBR = 'IN4NAME'
         CALL H2CHR (8, 1, CATH2(KHCTP), CTEMP)
         CALL H2CHR (8, 1, CATH4(KHCTP+4), TTEMP)
         IF (CTEMP.NE.TTEMP) GO TO 970
         CALL H2CHR (8, 1, CATH2(KHCTP+2), CTEMP)
         CALL H2CHR (8, 1, CATH4(KHCTP), TTEMP)
         IF (CTEMP.NE.TTEMP) GO TO 970
         CALL H2CHR (8, 1, CATH2(KHCTP+4), CTEMP)
         CALL H2CHR (8, 1, CATH4(KHCTP+2), TTEMP)
         IF (CTEMP.NE.TTEMP) GO TO 970
         END IF
      IF (TWOCUB) THEN
         SUBR = 'IN3NAME'
         DO 10 I = 0,4,2
            CALL H2CHR (8, 1, CATH2(KHCTP+I), CTEMP)
            CALL H2CHR (8, 1, CATH3(KHCTP+I), TTEMP)
            IF (CTEMP.NE.TTEMP) GO TO 970
 10         CONTINUE
         END IF
C                                       cheat on header to make easy
      DTEMP = CATD(KDCRV)
      CATD(KDCRV) = CATD(KDCRV+1)
      CATD(KDCRV+1) = CATD(KDCRV+2)
      CATD(KDCRV+2) = DTEMP
      RTEMP = CATD(KRCRP)
      CATR(KRCRP) = CATR(KRCRP+1)
      CATR(KRCRP+1) = CATR(KRCRP+2)
      CATR(KRCRP+2) = RTEMP
      RTEMP = CATR(KRCIC)
      CATR(KRCIC) = CATR(KRCIC+1)
      CATR(KRCIC+1) = CATR(KRCIC+2)
      CATR(KRCIC+2) = RTEMP
      I = CATBLK(KINAX)
      CATBLK(KINAX) = CATBLK(KINAX+1)
      CATBLK(KINAX+1) = CATBLK(KINAX+2)
      CATBLK(KINAX+2) = I
      RTEMP = CATR(KHCTP)
      CATR(KHCTP) = CATR(KHCTP+2)
      CATR(KHCTP+2) = CATR(KHCTP+4)
      CATR(KHCTP+4) = RTEMP
      RTEMP = CATR(KHCTP+1)
      CATR(KHCTP+1) = CATR(KHCTP+3)
      CATR(KHCTP+3) = CATR(KHCTP+5)
      CATR(KHCTP+5) = RTEMP
      LOCNUM = 2
      CALL SETLOC (DEPTH, .FALSE.)
C                                       Open TV image
      CALL MAPOPN ('READ', VOL1, NAMIN, CLSIN, SEQ1, FTYPE, IUSER,
     *   LUN1, IND1, SLOT1, CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN INPUT IMAGE 1'
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = VOL1
      FCNO(NCFILE) = SLOT1
      FRW(NCFILE) = 0
      CALL COPY (256, CATBLK, CATBL1)
C                                       Check windows
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), TBLC, TTRC, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'SETTING TV WINDOW'
         GO TO 990
         END IF
      CALL RCOPY (5, TBLC(3), TTRC(3))
      DO 20 I = 1,5
         DEPTH(I) = TBLC(I+2) + 0.1
 20      CONTINUE
      LOCNUM = 1
      CALL SETLOC (DEPTH, .FALSE.)
C                                       pix ranges
      CALL RNGSET (RANGE, CATR(KRDMX), CATR(KRDMN), PRANGE)
C                                       open the TV
      IRET = 8
      CALL TVOPEN (SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPENING TV'
         GO TO 990
         END IF
      CALL YHOLD ('ONNN', IERR)
      SUBR = 'YCINIT'
      CALL YCINIT (TVCH, SCRTCH)
      IF (IERR.NE.0) GO TO 980
      SUBR = 'YINIT'
      CALL YINIT (SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 980
      II = NGRAY + NGRAPH
      SUBR = 'YSLECT'
      DO 60 I = 1,II
         IF (I.EQ.TVCH) THEN
            CALL YSLECT ('ONNN', I, 0, SCRTCH, IERR)
         ELSE
            CALL YSLECT ('OFFF', I, 0, SCRTCH, IERR)
            END IF
         IF (IERR.NE.0) GO TO 980
 60      CONTINUE
C                                       Init OFM
      II = OFMINP + 1
      CALL RFILL (II, 0.0, BUFF1)
      II = LUTOUT + 1
      SLOPE = 1.0 / REAL (LUTOUT)
      DO 65 I = 2,II
         BUFF1(I) = (I-1) * SLOPE
 65      CONTINUE
      BUFF1(1) = 0.0
      SUBR = 'YOFM'
      CALL YOFM ('WRIT', 7, .TRUE., BUFF1, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       LUTs
      II = MAXINT + 1
      SLOPE = REAL (LUTOUT) / REAL (MAXINT)
      DO 70 I = 1,II
         SCRTCH(I) = (I-1) * SLOPE + 0.5
 70      CONTINUE
      TVCODE = 2 ** (TVCH - 1)
      SUBR = 'YLUT'
      CALL YLUT ('WRIT', TVCODE, 7, .TRUE., SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 980
      CURWIN(1,1) = TBLC(1) + 0.1
      CURWIN(2,1) = TBLC(2) + 0.1
      CURWIN(3,1) = TTRC(1) + 0.1
      CURWIN(4,1) = TTRC(2) + 0.1
      CURWIN(1,2) = 1
      CURWIN(2,2) = 1
      CURWIN(3,2) = CATBL4(KINAX)
      CURWIN(4,2) = CATBL4(KINAX+1)
      CATBLK(IIVOL) = VOL1
      CATBLK(IICNO) = SLOT1
      CATR(IRRAN) = PRANGE(1)
      CATR(IRRAN+1) = PRANGE(2)
      CALL CHR2H (2, FUNTYP, 1, CATH(IITRA))
      DO 80 I = 3,7
         CATBLK(IIDEP+I-3) = IROUND (TBLC(I))
80       CONTINUE
      IRET = 0
      GO TO 999
C                                       axis types not matching
 970  IERR = 10
      WRITE (MSGTXT,1970) SUBR, CTEMP, TTEMP
      GO TO 990
C                                       TV error
 980  WRITE (MSGTXT,1000) IERR, 'TV FUNCTION ' // SUBR
C                                       all errors
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TVSPIN: ERROR',I3,' ON ',A)
 1970 FORMAT ('IN2NAME ',A,'AXIS TYPES DO NOT MATCH ',A,' vs ',A)
      END
      SUBROUTINE TVSPIM (NX, NY, IMAGE, IRET)
C-----------------------------------------------------------------------
C   TVSPIM reads in the image to core
C   Inputs
C      NX      I      Number x pixels
C      NY      I      Number y pixels
C   Outputs
C      IMAGE   R(*)   Image
C      IRET    I      error
C-----------------------------------------------------------------------
      INTEGER   NX, NY, IRET
      REAL      IMAGE(NX,*)
C
      INCLUDE 'TVSPC.INC'
      INTEGER   J, OFFS, WIN(4), BIND
C-----------------------------------------------------------------------
      CALL COMOFF (CATBL1(KIDIM), CATBL1(KINAX), CATBLK(IIDEP), OFFS,
     *   IRET)
      OFFS = OFFS + 1
      WIN(1) = TBLC(1) + 0.1
      WIN(2) = TBLC(2) + 0.1
      WIN(3) = TTRC(1) + 0.1
      WIN(4) = TTRC(2) + 0.1
      CALL MINIT ('READ', LUN1, IND1, NX, NY, WIN, BUFF1, JBUFSZ, OFFS,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT IO TO TV IMAGE'
         GO TO 990
         END IF
      DO 20 J = 1,NY
         CALL MDISK ('READ', LUN1, IND1, BUFF1, BIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ TV IMAGE ROW'
            GO TO 990
            END IF
         CALL RCOPY (NX, BUFF1(BIND), IMAGE(1,J))
 20      CONTINUE
      CALL ZCLOSE (LUN1, IND1, J)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TVSPIM: ERROR',I4,' ON ',A)
      END
      SUBROUTINE TVSPI2 (NX, NY, NZ, IMAGE, IRET)
C-----------------------------------------------------------------------
C   TVSPI2 reads in the 4th image cube to core
C   Inputs
C      NX      I      Number x pixels
C      NY      I      Number y pixels
C      NZ      I      Number Z pixels
C   Outputs
C      IMAGE   R(*)   Image
C      IRET    I      error
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NZ, IRET
      REAL      IMAGE(NX,NY,*)
C
      INCLUDE 'TVSPC.INC'
      INTEGER   J, K, OFFS, WIN(4), BIND, DEPTH(5)
      DATA DEPTH /5*1/
C-----------------------------------------------------------------------
      WIN(1) = 1
      WIN(2) = 1
      WIN(3) = NX
      WIN(4) = NY
      DO 30 K = 1,NZ
         DEPTH(1) = K
         CALL COMOFF (CATBL4(KIDIM), CATBL4(KINAX), DEPTH, OFFS,
     *      IRET)
         OFFS = OFFS + 1
         CALL MINIT ('READ', LUN4, IND4, NX, NY, WIN, BUFF1, JBUFSZ,
     *      OFFS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT IO TO TV IMAGE CUBE'
            GO TO 990
            END IF
         DO 20 J = 1,NY
            CALL MDISK ('READ', LUN4, IND4, BUFF1, BIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ TV IMAGE CUBE ROW'
               GO TO 990
               END IF
            CALL RCOPY (NX, BUFF1(BIND), IMAGE(1,J,K))
 20         CONTINUE
 30      CONTINUE
      CALL ZCLOSE (LUN4, IND4, J)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TVSPI2: ERROR',I4,' ON ',A)
      END
      SUBROUTINE TVSPDO (NX, NY, IMAGE, NX2, NY2, NZ2, IMAGE2, IRET)
C-----------------------------------------------------------------------
C   TVSPDO does the interaction control
C   Inputs
C      NX       I      Number x pixels
C      NY       I      Number y pixels
C      NX2      I      Number x pixels image 2
C      NY2      I      Number y pixels image 2
C      NZ2      I      Number z pixels image 2
C   Outputs
C      IMAGE    R(*)   Image
C      IMAGE2   R(*)   Image plane from #2
C      IRET     I      error
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NX2, NY2, NZ2, IRET
      REAL      IMAGE(NX,*), IMAGE2(NX2,NY2,*)
C
      INCLUDE 'TVSPC.INC'
      INTEGER   NOPT
      PARAMETER (NOPT = 25)
C
      INTEGER   I, II, IBUT, GRCS(2), CHS, NTITLE, TOPSEP, SIDSEP, MOPT,
     *   TTY(2), TIMLIM, ICOLOR, MBOX, NBO, NLEVS, TVCODE, CATSAV(256)
      LOGICAL   DOIT, LEAVE(NOPT), VERBOS, FIRST
      REAL      BLCO(7), TRCO(7), RPOS(2), SLOPE, PPOS(2)
      DOUBLE PRECISION DTEMP(10)
      CHARACTER OPTION(NOPT)*20, SUBR*6, ISHELP*8, TITLE*8, MSGBUF*72,
     *   CTEMP*4
      INCLUDE 'INCS:PTVC.INC'
      REAL      OFM(TVMOFM,3), IOFM(TVMOFM,3)
      DATA OPTION /'OFF TRANS', 'OFF PSEUDO', 'TVTRANSF', 'TVPSEUDO',
     *   'TVPHLAME', 'OFMCOLOR', 'SET APARM', 'LABEL IMAGES?', ' ',
     *   'SET WINDOW', 'RESET WINDOW', 'SET CHANNELS', 'RESET CHANNELS',
     *   'CURVALUE', 'PLOT SPECTRA', 'FIT SPECTRUM', 'SAVE SPECTRUM',
     *   ' ', 'LOAD PLANE', 'PLOT PL SPECTRA', 'SET PL WINDOW',
     *   'RESET PL WIN', 'SET PL RANGE', '  ', 'EXIT'/
      DATA LEAVE /13*.TRUE., 2*.FALSE.,3*.TRUE.,2*.FALSE.,4*.TRUE.,
     *   .FALSE./
C-----------------------------------------------------------------------
C                                        Initialize
      TTY(1) = 5
      TTY(2) = 0
      TITLE = ' '
      NTITLE = 0
      MENUOK = .FALSE.
      DOLABL = 0
      GRMENU = 1 + NGRAY
      GRSPC1 = 2 + NGRAY
      GRSPC2 = 3 + NGRAY
      GRMEBG = 4 + NGRAY
      GRLABL = 5 + NGRAY
      GRMODL = 6 + NGRAY
      GRESID = 7 + NGRAY
      GRBLAC = 8 + NGRAY
      TVCODE = 2 ** (TVCH - 1)
      SPECOK = 0
C                                       start by forcing a load
      DOIT = .TRUE.
      VERBOS = .FALSE.
      FIRST = .TRUE.
C                                       init smoothing function
      CALL SMFUNC
C                                       Menu interaction loop point
C                                       check window
 100  CALL YWINDO ('READ', WINDTV, IRET)
      SUBR = 'YWINDO'
      IF (IRET.NE.0) GO TO 990
      IF (WINDTV(1).NE.LWINTV(1)) MENUOK = .FALSE.
      IF (WINDTV(2).NE.LWINTV(2)) MENUOK = .FALSE.
      IF (WINDTV(3).NE.LWINTV(3)) MENUOK = .FALSE.
      IF (WINDTV(4).NE.LWINTV(4)) MENUOK = .FALSE.
      CALL COPY (4, WINDTV, LWINTV(1))
      CALL COPY (4, LWINTV, IWINTV)
      CALL COPY (4, LWINTV, SWINTV)
      IF ((APARM(5).LT.0.1) .OR. (APARM(5).GT.0.9)) APARM(5) = 0.5
      IF (APARM(4).LT.0.0) THEN
         SWINTV(4) = SWINTV(2) + APARM(5) * (SWINTV(4) - SWINTV(2))
         IWINTV(2) = SWINTV(4) + 1
         IF (TWOIMG) THEN
            CALL COPY (4, IWINTV, JWINTV)
            IWINTV(3) = IWINTV(1) + 0.5 * (IWINTV(3) - IWINTV(1))
            JWINTV(1) = IWINTV(3) + 1
            END IF
      ELSE IF (APARM(4).GT.0.0) THEN
         IWINTV(3) = IWINTV(1) + (1.0-APARM(5)) * (IWINTV(3)-IWINTV(1))
         SWINTV(1) = IWINTV(3) + 1
         IF (TWOIMG) THEN
            CALL COPY (4, IWINTV, JWINTV)
            IWINTV(4) = IWINTV(2) + 0.5 * (IWINTV(4) - IWINTV(2))
            JWINTV(2) = IWINTV(4) + 1
            END IF
      ELSE IF (TWOIMG) THEN
         CALL COPY (4, IWINTV, JWINTV)
         IWINTV(3) = IWINTV(1) + 0.5 * (IWINTV(3) - IWINTV(1))
         JWINTV(1) = IWINTV(3) + 1
         END IF
      IF (FIRST) GO TO 200
C                                       build menu
      GRCS(1) = GRMENU - NGRAY
      IF (MENUOK) GRCS(1) = -GRCS(1)
      GRCS(2) = GRMEBG - NGRAY
      ISHELP = TSKNAM
      TOPSEP = 3 * CSIZTV(2) + 1
      SIDSEP = 5
      TIMLIM = 0
      MOPT = NOPT
      IF (.NOT.TWOIMG) THEN
         OPTION(NOPT-6) = OPTION(NOPT)
         MOPT = MOPT - 6
         END IF
      CALL TVMENU (0, 1, MOPT, GRCS, TOPSEP, SIDSEP, ISHELP, OPTION,
     *   TIMLIM, LEAVE, NTITLE, TITLE, CHS, IBUT, SCRTCH, IRET)
      SUBR = 'TVMENU'
      IF (IRET.NE.0) GO TO 990
      MENUOK = .TRUE.
C                                       Something to do
C                                       off B&W transfer
      DOIT = .FALSE.
      IF (OPTION(CHS).EQ.'OFF TRANS') THEN
         CALL YHOLD ('ONNN', IRET)
         II = MAXINT + 1
         SLOPE = REAL (LUTOUT) / REAL (MAXINT)
         DO 120 I = 1,II
            SCRTCH(I) = (I-1) * SLOPE + 0.5
 120        CONTINUE
         SUBR = 'YLUT'
         CALL YLUT ('WRIT', TVCODE, 7, .TRUE., SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       off coloring
      ELSE IF (OPTION(CHS).EQ.'OFF PSEUDO') THEN
         CALL YHOLD ('ONNN', IRET)
         II = OFMINP + 1
         CALL RFILL (II, 0.0, BUFF1)
         II = LUTOUT + 1
         SLOPE = 1.0 / REAL (LUTOUT)
         DO 125 I = 1,II
            BUFF1(I) = I * SLOPE
 125        CONTINUE
         BUFF1(1) = 0.0
         SUBR = 'YOFM'
         CALL YOFM ('WRIT', 7, .TRUE., BUFF1, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       B&W transfer function
      ELSE IF (OPTION(CHS).EQ.'TVTRANSF') THEN
         I = 1
         ICOLOR = 7
         SUBR = 'IENHNS'
         CALL IENHNS (TVCODE, ICOLOR, I, RPOS, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       pseudo coloring
      ELSE IF (OPTION(CHS).EQ.'TVPSEUDO') THEN
         NLEVS = LUTOUT + 1
         SUBR = 'TVPSUD'
         CALL TVPSUD (NLEVS, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       flame coloring
      ELSE IF (OPTION(CHS).EQ.'TVPHLAME') THEN
         NLEVS = LUTOUT + 1
         SUBR = 'TVFLAM'
         CALL TVFLAM (NLEVS, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       OFM madness
      ELSE IF (OPTION(CHS).EQ.'OFMCOLOR') THEN
         NLEVS = LUTOUT + 1
         SUBR = 'OFMCOL'
         CALL OFMCOL (NLEVS, OFM, IOFM, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       reset APARM values
      ELSE IF (OPTION(CHS).EQ.'SET APARM') THEN
C                                       Open terminal
         IF (TTY(2).LE.0) THEN
            TTY(2) = 0
            CALL ZOPEN (TTY(1), TTY(2), 1, MSGBUF, .FALSE., .TRUE.,
     *         .TRUE., IRET)
            IF (IRET.NE.0) THEN
               TTY(2) = 0
               WRITE (MSGTXT,1250) IRET
               CALL MSGWRT (6)
               GO TO 200
               END IF
            END IF
         MSGBUF = 'Spectral plot range min and max'
         CALL INQFLT (TTY, MSGBUF, 2, DTEMP, IRET)
         IF (IRET.LT.0) GO TO 200
         SUBR = 'INQFLT'
         IF (IRET.GT.0) GO TO 990
         APARM(1) = DTEMP(1)
         APARM(2) = DTEMP(2)
         MSGBUF = 'Spectral averaging radius in YZ pixels'
         CALL INQFLT (TTY, MSGBUF, 1, DTEMP, IRET)
         IF (IRET.LT.0) GO TO 200
         IF (IRET.GT.0) GO TO 990
         APARM(3) = DTEMP(1)
         MSGBUF = 'Split screen: < 0 vertical, > 0 horizontal, 0 none'
         CALL INQFLT (TTY, MSGBUF, 1, DTEMP, IRET)
         IF (IRET.LT.0) GO TO 200
         IF (IRET.GT.0) GO TO 990
         IF ((APARM(4).GT.0.0) .AND. (DTEMP(1).LE.0.0D0)) DOIT = .TRUE.
         IF ((APARM(4).EQ.0.0) .AND. (DTEMP(1).NE.0.0D0)) DOIT = .TRUE.
         IF ((APARM(4).LT.0.0) .AND. (DTEMP(1).GT.0.0D0)) DOIT = .TRUE.
         APARM(4) = DTEMP(1)
         IF (APARM(4).NE.0.0) THEN
            MSGBUF = 'Fraction of split screen for spectra'
            CALL INQFLT (TTY, MSGBUF, 1, DTEMP, IRET)
            IF (IRET.LT.0) GO TO 200
            IF (IRET.GT.0) GO TO 990
            IF ((DTEMP(1).LT.0.1D0) .OR. (DTEMP(1).GT.0.9D0))
     *         DTEMP(1) = 0.5D0
            IF (ABS(APARM(5)-DTEMP(1)).GT.0.03) DOIT = .TRUE.
            APARM(5) = DTEMP(1)
            END IF
         IF (TWOCUB) THEN
            MSGBUF = 'Split spectra: <= 0 no, > 0 yes'
            CALL INQFLT (TTY, MSGBUF, 1, DTEMP, IRET)
            IF (IRET.LT.0) GO TO 200
            IF (IRET.GT.0) GO TO 990
            APARM(6) = DTEMP(1)
            END IF
         MSGBUF = 'Label spectra in channels: > 0 -> yes'
         CALL INQFLT (TTY, MSGBUF, 1, DTEMP, IRET)
         IF (IRET.LT.0) GO TO 200
         IF (IRET.GT.0) GO TO 990
         IF ((APARM(8).GT.0.0) .AND. (DTEMP(1).LE.0.0)) DOIT = .TRUE.
         IF ((APARM(8).LE.0.0) .AND. (DTEMP(1).GT.0.0)) DOIT = .TRUE.
         APARM(8) = DTEMP(1)
         MSGBUF = 'Baseline fit order: > 0 -> yes'
         CALL INQFLT (TTY, MSGBUF, 1, DTEMP, IRET)
         IF (IRET.LT.0) GO TO 200
         IF (IRET.GT.0) GO TO 990
         APARM(9) = DTEMP(1)
         IF (DOIT) THEN
            CALL COPY (4, LWINTV, IWINTV)
            CALL COPY (4, LWINTV, SWINTV)
            IF (APARM(4).LT.0.0) THEN
               SWINTV(4) = SWINTV(2) + APARM(5) * (SWINTV(4)-SWINTV(2))
               IWINTV(2) = SWINTV(4) + 1
               IF (TWOIMG) THEN
                  CALL COPY (4, IWINTV, JWINTV)
                  IWINTV(3) = IWINTV(1) + 0.5 * (IWINTV(3) - IWINTV(1))
                  JWINTV(1) = IWINTV(3) + 1
                  END IF
            ELSE IF (APARM(4).GT.0.0) THEN
               IWINTV(3) = IWINTV(1) + (1.0-APARM(5)) *
     *            (IWINTV(3)-IWINTV(1))
               SWINTV(1) = IWINTV(3) + 1
               IF (TWOIMG) THEN
                  CALL COPY (4, IWINTV, JWINTV)
                  IWINTV(4) = IWINTV(2) + 0.5 * (IWINTV(4) - IWINTV(2))
                  JWINTV(2) = IWINTV(4) + 1
                  END IF
            ELSE IF (TWOIMG) THEN
               CALL COPY (4, IWINTV, JWINTV)
               IWINTV(3) = IWINTV(1) + 0.5 * (IWINTV(3) - IWINTV(1))
               JWINTV(1) = IWINTV(3) + 1
               END IF
            CALL YHOLD ('ONNN', IRET)
            SUBR = 'YZERO'
            CALL YZERO (GRSPC1, IRET)
            IF (IRET.NE.0) GO TO 990
            SPECOK = 0
            CALL YZERO (GRMODL, IRET)
            IF (IRET.NE.0) GO TO 990
            CALL YZERO (GRESID, IRET)
            IF (IRET.NE.0) GO TO 990
            CALL YZERO (GRSPC2, IRET)
            IF (IRET.NE.0) GO TO 990
            END IF
         MSGBUF = 'Spectral smoothing function type (4 characters)'
         CALL INQSTR (TTY, MSGBUF, 4, CTEMP, IRET)
         IF (IRET.LT.0) GO TO 200
         SUBR = 'INQSTR'
         IF (IRET.GT.0) GO TO 990
         SAMTYP = CTEMP
         CALL TYPESM (SAMTYP, SMTYPE)
         IF (SMTYPE.GT.0) THEN
            SUBR = 'INQFLT'
            IF ((SMTYPE.EQ.1) .OR. (SMTYPE.EQ.2)) THEN
               MSGBUF ='Spectral smoothing support in channels'
            ELSE IF (SMTYPE.GT.2) THEN
               MSGBUF ='Spectral smoothing FWHM in channels'
               END IF
            CALL INQFLT (TTY, MSGBUF, 1, DTEMP, IRET)
            IF (IRET.LT.0) GO TO 200
            IF (IRET.GT.0) GO TO 990
            APARM(7) = DTEMP(1)
            CALL SMFUNC
            END IF
         MSGBUF = 'Set CBPLOT to 0 to 4:'
         CALL INQINT (TTY, MSGBUF, 1, CBPLOT, IRET)
         IF (IRET.LT.0) GO TO 200
         IF (IRET.GT.0) GO TO 990
         CBPLOT = MAX (0, MIN (4, CBPLOT))
C                                       set a sub-image
      ELSE IF (OPTION(CHS).EQ.'SET WINDOW') THEN
         DOIT = .TRUE.
         NBO = 0
         MBOX = 1
         SUBR = 'GRBOXS'
         I = GRMEBG - NGRAY
         CALL GRBOXS (I, MBOX, NBO, BLCO, TRCO, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         CURWIN(1,1) = BLCO(1) + 0.1
         CURWIN(2,1) = BLCO(2) + 0.1
         CURWIN(3,1) = TRCO(1) + 0.1
         CURWIN(4,1) = TRCO(2) + 0.1
C                                       DEBUG
         CALL YHOLD ('ONNN', IRET)
         CALL YSLECT ('OFFF', GRMEBG, 0, SCRTCH, IRET)
C                                       back to full image
      ELSE IF (OPTION(CHS).EQ.'RESET WINDOW') THEN
         DOIT = .TRUE.
         CURWIN(1,1) = TBLC(1) + 0.1
         CURWIN(2,1) = TBLC(2) + 0.1
         CURWIN(3,1) = TTRC(1) + 0.1
         CURWIN(4,1) = TTRC(2) + 0.1
C                                       back to full spectram
      ELSE IF (OPTION(CHS).EQ.'RESET CHANNELS') THEN
         BCHAN = 1
         ECHAN = CATBL2(KINAX)
C                                       set partial spectrum
      ELSE IF (OPTION(CHS).EQ.'SET CHANNELS') THEN
         IF (SPECOK.GT.0) THEN
            SUBR = 'TVSCHN'
            CALL TVSCHN (IRET)
            IF (IRET.GT.0) GO TO 990
         ELSE
            MSGTXT = 'YOU MUST PLOT SPECTRA FIRST'
            CALL MSGWRT (6)
            END IF
C                                       load plane from cube
      ELSE IF (OPTION(CHS).EQ.'LOAD PLANE') THEN
         IF (SPECOK.GT.0) THEN
            SUBR = 'TVPLAN'
            CALL TVPLAN (VERBOS, NX2, NY2, NZ2, IMAGE2, IRET)
            IF (IRET.GT.0) GO TO 990
            SPECOK = 2
         ELSE
            MSGTXT = 'YOU MUST PLOT SPECTRA FIRST'
            CALL MSGWRT (6)
            END IF
C                                       set a sub-image
      ELSE IF (OPTION(CHS).EQ.'SET PL WINDOW') THEN
         IF ((CURPLN.LT.1) .OR. (CURPLN.GT.NZ2)) THEN
            MSGTXT = 'YOU MUST LOAD A PLANE FIRST'
            CALL MSGWRT (6)
         ELSE
            DOIT = .TRUE.
            CALL COPY (256, CATBLK, CATSAV)
            CALL COPY (256, CATBLP, CATBLK)
            NBO = 0
            MBOX = 1
            SUBR = 'GRBOXS'
            I = GRMEBG - NGRAY
            CALL GRBOXS (I, MBOX, NBO, BLCO, TRCO, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 990
            CURWIN(1,2) = BLCO(1) + 0.1
            CURWIN(2,2) = BLCO(2) + 0.1
            CURWIN(3,2) = TRCO(1) + 0.1
            CURWIN(4,2) = TRCO(2) + 0.1
            CALL YSLECT ('OFFF', GRMEBG, 0, SCRTCH, IRET)
            CALL COPY (256, CATSAV, CATBLK)
            END IF
C                                       back to full image
      ELSE IF (OPTION(CHS).EQ.'RESET PL WIN') THEN
         DOIT = (CURPLN.GE.1) .AND. (CURPLN.LE.NZ2)
         CURWIN(1,2) = 1
         CURWIN(2,2) = 1
         CURWIN(3,2) = CATBL4(KINAX)
         CURWIN(4,2) = CATBL4(KINAX+1)
C                                       set plane pixrange
      ELSE IF (OPTION(CHS).EQ.'SET PL RANGE') THEN
C                                       Open terminal
         IF (TTY(2).LE.0) THEN
            TTY(2) = 0
            CALL ZOPEN (TTY(1), TTY(2), 1, MSGBUF, .FALSE., .TRUE.,
     *         .TRUE., IRET)
            IF (IRET.NE.0) THEN
               TTY(2) = 0
               WRITE (MSGTXT,1250) IRET
               CALL MSGWRT (6)
               GO TO 200
               END IF
            END IF
         WRITE (MSGBUF,1030) CATR4(KRDMN), CATR4(KRDMX)
         CALL INQFLT (TTY, MSGBUF, 2, DTEMP, IRET)
         IF (IRET.LT.0) GO TO 200
         SUBR = 'INQFLT'
         IF (IRET.GT.0) GO TO 990
         DOIT = .TRUE.
         IF (DTEMP(1).LT.DTEMP(2)) THEN
            CRANGE(1) = DTEMP(1)
            CRANGE(2) = DTEMP(2)
            CRANGE(1) = MAX (CRANGE(1), CATR4(KRDMN))
            CRANGE(2) = MIN (CRANGE(2), CATR4(KRDMX))
         ELSE
            CRANGE(1) = CATR4(KRDMN)
            CRANGE(2) = CATR4(KRDMX)
            END IF
C                                       verbose
      ELSE IF (OPTION(CHS).EQ.'VERBOSE?') THEN
         VERBOS = .NOT.VERBOS
C                                       curvalue
      ELSE IF (OPTION(CHS).EQ.'CURVALUE') THEN
         SUBR = 'TVSPCV'
         CALL TVSPCV (NX, NY, IMAGE, NX2, NY2, NZ2, IMAGE2, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       label pimages
      ELSE IF (OPTION(CHS).EQ.'LABEL IMAGES?') THEN
         CALL YHOLD ('ONNN', IRET)
C                                       turn labels off
         IF (DOLABL.EQ.2) THEN
            SUBR = 'YSLECT'
            CALL YSLECT ('OFFF', GRLABL, 0, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 990
            CALL YSLECT ('OFFF', GRBLAC, 0, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 990
            SUBR = 'YZERO'
            CALL YZERO (GRLABL, IRET)
            IF (IRET.NE.0) GO TO 990
            CALL YZERO (GRBLAC, IRET)
            IF (IRET.NE.0) GO TO 990
            DOLABL = 0
C                                       plot labels
         ELSE
            DOLABL = DOLABL + 1
            SUBR = 'TVSPLA'
            CALL TVSPLA (IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
C                                       interactive spectral plot
      ELSE IF (OPTION(CHS).EQ.'PLOT SPECTRA') THEN
         NGAUSS = 0
         SUBR = 'TVSPPL'
         CALL TVSPPL (VERBOS, IWINTV, PPOS, NX, NY, IMAGE, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       interactive spectral plot
      ELSE IF (OPTION(CHS).EQ.'PLOT PL SPECTRA') THEN
         IF ((CURPLN.LT.1) .OR. (CURPLN.GT.NZ2)) THEN
            MSGTXT = 'YOU MUST LOAD A PLANE FIRST'
            CALL MSGWRT (6)
         ELSE
            CALL COPY (256, CATBLK, CATSAV)
            CALL COPY (256, CATBLP, CATBLK)
            LOCNUM = 1
            CALL SETLOC (CATBLK(IIDEP), .FALSE.)
            NGAUSS = 0
            SUBR = 'TVSPPL'
            CALL TVSPPL (VERBOS, JWINTV, PPOS, NX2, NY2,
     *         IMAGE2(1,1,CURPLN), IRET)
            IF (IRET.NE.0) GO TO 990
            CALL COPY (256, CATSAV, CATBLK)
            LOCNUM = 1
            CALL SETLOC (CATBLK(IIDEP), .FALSE.)
            END IF
C                                       fit spectrum as slice Gaussians
      ELSE IF (OPTION(CHS).EQ.'FIT SPECTRUM') THEN
         SUBR = 'TVSFIT'
         CALL TVSFIT (IRET)
         IF (IRET.GT.0) GO TO 990
C                                       save spectrum as slice
      ELSE IF (OPTION(CHS).EQ.'SAVE SPECTRUM') THEN
         SUBR = 'TVSPSL'
         CALL TVSPSL (IRET)
         IF (IRET.NE.0) GO TO 990
C                                       blank
      ELSE IF (OPTION(CHS).EQ.' ') THEN
C                                       quit
      ELSE IF (OPTION(CHS).EQ.'EXIT') THEN
         IRET = 0
         GO TO 990
         END IF
C                                       load TV
 200  IF (DOIT) THEN
         CALL YHOLD ('ONNN', IRET)
         CALL YZERO (TVCH, IRET)
         CALL TVSPLD (NX, NY, IMAGE, IRET)
         SUBR = 'TVSPLD'
         IF (IRET.NE.0) GO TO 990
         CALL TVSPL2 (DOIT, NX2, NY2, NZ2, IMAGE2, IRET)
         SUBR = 'TVSPL2'
         IF (IRET.NE.0) GO TO 990
         IF (DOLABL.GT.0) THEN
            SUBR = 'TVSPLA'
            CALL TVSPLA (IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
         END IF
      FIRST = .FALSE.
      GO TO 100
C
 990  IF (IRET.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1990) IRET, SUBR
         CALL MSGWRT (8)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('Enter image 4 pixrange: min, max',2(1PE11.3))
 1250 FORMAT ('TVSPDO ERROR',I5,' OPENING TERMINAL TO ASK QUESTIONS')
 1990 FORMAT ('TVSPDO: ERROR',I5,' RETURNED BY ROUTINE ',A)
      END
      SUBROUTINE TYPESM (SAMTYP, SMTYPE)
C-----------------------------------------------------------------------
C   TYPESM checks the SAMTYP string for allowed values
C   Input:
C      SAMTYP   C*4   Smoothing type specified
C   Output:
C      SMTYPE   I     Code: 0 none
C-----------------------------------------------------------------------
      CHARACTER SAMTYP*(*)
      INTEGER   SMTYPE
C
      INTEGER   NTYPES
      PARAMETER (NTYPES=5)
C
      INTEGER   I
      CHARACTER TYPES(NTYPES)*4
      DATA TYPES /'BOX','MWF','HANN','GAUS','EXP'/
C-----------------------------------------------------------------------
      CALL CHLTOU (4, SAMTYP)
      SMTYPE = 0
      DO 10 I = 1,NTYPES
         IF (SAMTYP.EQ.TYPES(I)) SMTYPE = I
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE SMFUNC
C-----------------------------------------------------------------------
C   SMFUNC uses parameters in COMMON to compute a smoothing function
C   returned also in COMMON
C-----------------------------------------------------------------------
C
      INCLUDE 'TVSPC.INC'
      INTEGER   I
      REAL      W, Y
C-----------------------------------------------------------------------
      SMWID = 0
      CALL RFILL (128, 0.0, SFUNC)
      SFUNC(1) = 1.0
C                                       boxcar
      IF (SMTYPE.EQ.1) THEN
         I = APARM(7)/2.0 + 0.1
         CALL RFILL (I, 1.0, SFUNC)
         SMWID = I + 1
         SFUNC(SMWID) = 0.5
C                                       MWF
      ELSE IF (SMTYPE.EQ.2) THEN
         SMWID = APARM(7) + 1.1
C                                       hanning
      ELSE IF (SMTYPE.EQ.3) THEN
         W = APARM(7) / 2.0
         IF (W.GT.0.0) THEN
            DO 30 I = 1,128
               Y = 1.0 - (I - 1.0) / (2.0*W)
               IF (Y.GT.0.0) THEN
                  SFUNC(I) = Y
                  SMWID = I
               ELSE
                  GO TO 999
                  END IF
 30            CONTINUE
            END IF
C                                       Gaussian
      ELSE IF (SMTYPE.EQ.4) THEN
         W = APARM(7) / 2.0
         IF (W.GT.0.0) THEN
            W = LOG (2.0) / (W * W)
            DO 40 I = 1,128
               Y = EXP (-W * (I-1.0) * (I-1.0))
               IF (Y.GT.0.00001) THEN
                  SFUNC(I) = Y
                  SMWID = I
               ELSE
                  GO TO 999
                  END IF
 40            CONTINUE
            END IF
C                                       Exponential
      ELSE IF (SMTYPE.EQ.5) THEN
         W = APARM(7) / 2.0
         IF (W.GT.0.0) THEN
            W = LOG (2.0) / W
            DO 50 I = 1,128
               Y = EXP (-W * (I-1.0))
               IF (Y.GT.0.00001) THEN
                  SFUNC(I) = Y
                  SMWID = I
               ELSE
                  GO TO 999
                  END IF
 50            CONTINUE
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE TVSPLD (NX, NY, IMAGE, IRET)
C-----------------------------------------------------------------------
C   TVSPLD loads image #1 or its subimage to the TV
C   Inputs:
C      NX       I      Number x pixels
C      NY       I      Number y pixels
C      IMAGE    R(*)   Image
C   Outputs:
C      IRET     I      error code
C-----------------------------------------------------------------------
      INTEGER   NX, NY, IRET
      REAL      IMAGE(NX,*)
C
      INCLUDE 'TVSPC.INC'
      INTEGER   IX, IY, MX, MY, LX, LY, NXINT, NYINT, PLINC(2), NXP,
     *   NYP, I, J, IY1, IY2, IYTV, MPIX
      CHARACTER SUBR*8
      REAL      X, Y
C-----------------------------------------------------------------------
      MX = IWINTV(3) - IWINTV(1) + 1
      MY = IWINTV(4) - IWINTV(2) + 1
      LX = CURWIN(3,1) - CURWIN(1,1) + 1
      LY = CURWIN(4,1) - CURWIN(2,1) + 1
C                                       increments
      IF ((LX.GT.MX) .OR. (LY.GT.MY)) THEN
         NXINT = 1
         NYINT = 1
         PLINC(1) = (LX - 1) / MX + 1
         PLINC(2) = (LY - 1) / MY + 1
         PLINC(1) = MAX (PLINC(1), PLINC(2))
         PLINC(2) = PLINC(1)
         NXP = (LX - 1) / PLINC(1) + 1
         NYP = (LY - 1) / PLINC(2) + 1
         WRITE (MSGTXT,1000) PLINC(1)
      ELSE
         PLINC(1) = 1
         PLINC(2) = 1
         NXINT = (MX - 1) / LX
         NYINT = (MY - 1) / LY
         NXINT = MIN (NXINT, NYINT)
         NXINT = MAX (1, NXINT)
         NYINT = NXINT
         NXP = (LX - 1) * NXINT + 1
         NYP = (LY - 1) * NYINT + 1
         IF (NXINT.GT.1) THEN
            WRITE (MSGTXT,1001) NXINT
         ELSE
            MSGTXT = 'Loading every image pixel in window'
            END IF
         END IF
      CALL MSGWRT (2)
      WRITE (MSGTXT,1010) (CURWIN(J,1), J = 1,4)
      CALL MSGWRT (2)
C                                       corners
      CALL COPY (4, CURWIN(1,1), CATBLK(IIWIN))
      IX = (MX - NXP) / 2
      CATBLK(IICOR) = IX + IWINTV(1)
      CATBLK(IICOR+2) = IX + IWINTV(1) + NXP - 1
      IY = (MY - NYP) / 2
      CATBLK(IICOR+1) = IY + IWINTV(2)
      CATBLK(IICOR+3) = IY + IWINTV(2) + NYP - 1
      CALL YCWRIT (TVCH, CATBLK(IICOR), CATBLK, SCRTCH, IRET)
      SUBR = 'YCWRIT'
      IF (IRET.NE.0) GO TO 990
C                                       load to TV
      IYTV = IY + IWINTV(2) - 1
      MPIX = 1 + (NXP - 1) / NXINT
C                                       First row
      IX = CURWIN(1,1)
      IY = CURWIN(2,1)
      IY1 = IY + 1
      IY2 = CURWIN(4,1)
      CALL ISCALE (FUNTYP, MAXINT, CATR(IRRAN), LX, PLINC(1),
     *   IMAGE(IX,IY), SCRTCH)
      CALL LINTER (MPIX, NXINT, SCRTCH, IBUFF)
      SUBR = 'YIMGIO'
      DO 50 IY = IY1,IY2
         IF (MOD(IY-IY1+1,PLINC(2)).EQ.0) THEN
            CALL ISCALE (FUNTYP, MAXINT, CATR(IRRAN), LX, PLINC(1),
     *         IMAGE(IX,IY), SCRTCH)
            CALL LINTER (MPIX, NXINT, SCRTCH, JBUFF)
            IYTV = IYTV + 1
            CALL YIMGIO ('WRIT', TVCH, CATBLK(IICOR), IYTV, 0, NXP,
     *         IBUFF, IRET)
            IF (IRET.NE.0) GO TO 990
            IF (NYINT.GT.1) THEN
               X = 1.0 / NYINT
               DO 40 I = 2,NYINT
                  Y = (I-1) * X
                  DO 30 J = 1,NXP
                     IF ((JBUFF(J).EQ.0) .OR. (IBUFF(J).EQ.0)) THEN
                        SCRTCH(J) = 0
                     ELSE
                        SCRTCH(J) = IBUFF(J) + Y * (JBUFF(J)-IBUFF(J))
     *                     + 0.49999
                        END IF
 30                  CONTINUE
                  IYTV = IYTV + 1
                  CALL YIMGIO ('WRIT', TVCH, CATBLK(IICOR), IYTV, 0,
     *               NXP, SCRTCH, IRET)
                  IF (IRET.NE.0) GO TO 990
 40               CONTINUE
               END IF
            CALL COPY (NXP, JBUFF, IBUFF)
            END IF
 50      CONTINUE
      GO TO 999
C
 990  WRITE (MSGTXT,1990) IRET, SUBR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Loading every',I3,' pixel of image')
 1001 FORMAT ('Loading image interpolated by',I3)
 1010 FORMAT ('Image corners',4I6)
 1990 FORMAT ('TVSPLD ERROR',I5,' FROM ROUTINE ',A)
      END
      SUBROUTINE TVSPL2 (FIRST, NX, NY, NZ, IMAGE, IRET)
C-----------------------------------------------------------------------
C   TVSPL2 loads image #4 or its subimage to the TV
C   Inputs:
C      NX       I      Number x pixels
C      NY       I      Number y pixels
C      IMAGE    R(*)   Image
C   Outputs:
C      IRET     I      error code
C-----------------------------------------------------------------------
      LOGICAL   FIRST
      INTEGER   NX, NY, NZ, IRET
      REAL      IMAGE(NX,NY,*)
C
      INCLUDE 'TVSPC.INC'
      INTEGER   IX, IY, MX, MY, LX, LY, NXINT, NYINT, PLINC(2), NXP,
     *   NYP, I, J, K, IY1, IY2, IYTV, MPIX, DEPTH(5), CATSAV(256)
      CHARACTER SUBR*8
      REAL      X, Y
      DATA DEPTH /5*1/
C-----------------------------------------------------------------------
      IF ((CURPLN.LT.1) .OR. (CURPLN.GT.NZ)) GO TO 999
      CALL COPY (256, CATBLK, CATSAV)
      CALL COPY (256, CATBLP, CATBLK)
      MX = JWINTV(3) - JWINTV(1) + 1
      MY = JWINTV(4) - JWINTV(2) + 1
      LX = CURWIN(3,2) - CURWIN(1,2) + 1
      LY = CURWIN(4,2) - CURWIN(2,2) + 1
      K = CURPLN
      DEPTH(1) = K
C                                       increments
      IF ((LX.GT.MX) .OR. (LY.GT.MY)) THEN
         NXINT = 1
         NYINT = 1
         PLINC(1) = (LX - 1) / MX + 1
         PLINC(2) = (LY - 1) / MY + 1
         PLINC(1) = MAX (PLINC(1), PLINC(2))
         PLINC(2) = PLINC(1)
         NXP = (LX - 1) / PLINC(1) + 1
         NYP = (LY - 1) / PLINC(2) + 1
         WRITE (MSGTXT,1000) PLINC(1)
      ELSE
         PLINC(1) = 1
         PLINC(2) = 1
         NXINT = (MX - 1) / LX
         NYINT = (MY - 1) / LY
         NXINT = MIN (NXINT, NYINT)
         NXINT = MAX (1, NXINT)
         NYINT = NXINT
         NXP = (LX - 1) * NXINT + 1
         NYP = (LY - 1) * NYINT + 1
         IF (NXINT.GT.1) THEN
            WRITE (MSGTXT,1001) NXINT
         ELSE
            MSGTXT = 'Loading every image pixel in window'
            END IF
         END IF
      IF (FIRST) CALL MSGWRT (2)
      WRITE (MSGTXT,1010) (CURWIN(J,2), J = 1,4)
      IF (FIRST) CALL MSGWRT (2)
C                                       corners
      CALL COPY (5, DEPTH, CATBLK(IIDEP))
      CALL COPY (4, CURWIN(1,2), CATBLK(IIWIN))
      IX = (MX - NXP) / 2
      CATBLK(IICOR) = IX + JWINTV(1)
      CATBLK(IICOR+2) = IX + JWINTV(1) + NXP - 1
      IY = (MY - NYP) / 2
      CATBLK(IICOR+1) = IY + JWINTV(2)
      CATBLK(IICOR+3) = IY + JWINTV(2) + NYP - 1
      CATR(IRRAN) = CRANGE(1)
      CATR(IRRAN+1) = CRANGE(2)
      CALL YCWRIT (TVCH, CATBLK(IICOR), CATBLK, SCRTCH, IRET)
      SUBR = 'YCWRIT'
      IF (IRET.NE.0) GO TO 990
      IF (FIRST) THEN
         SUBR = 'YFILL'
         CALL YFILL (TVCH, JWINTV(1), JWINTV(2), JWINTV(3), JWINTV(4),
     *      0, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
C                                       load to TV
      IYTV = IY + JWINTV(2) - 1
      MPIX = 1 + (NXP - 1) / NXINT
C                                       First row
      IX = CURWIN(1,2)
      IY = CURWIN(2,2)
      IY1 = IY + 1
      IY2 = CURWIN(4,2)
      CALL ISCALE (FUNTYP, MAXINT, CATR(IRRAN), LX, PLINC(1),
     *   IMAGE(IX,IY,K), SCRTCH)
      CALL LINTER (MPIX, NXINT, SCRTCH, IBUFF)
      SUBR = 'YIMGIO'
      DO 50 IY = IY1,IY2
         IF (MOD(IY-IY1+1,PLINC(2)).EQ.0) THEN
            CALL ISCALE (FUNTYP, MAXINT, CATR(IRRAN), LX, PLINC(1),
     *         IMAGE(IX,IY,K), SCRTCH)
            CALL LINTER (MPIX, NXINT, SCRTCH, JBUFF)
            IYTV = IYTV + 1
            CALL YIMGIO ('WRIT', TVCH, CATBLK(IICOR), IYTV, 0, NXP,
     *         IBUFF, IRET)
            IF (IRET.NE.0) GO TO 990
            IF (NYINT.GT.1) THEN
               X = 1.0 / NYINT
               DO 40 I = 2,NYINT
                  Y = (I-1) * X
                  DO 30 J = 1,NXP
                     IF ((JBUFF(J).EQ.0) .OR. (IBUFF(J).EQ.0)) THEN
                        SCRTCH(J) = 0
                     ELSE
                        SCRTCH(J) = IBUFF(J) + Y * (JBUFF(J)-IBUFF(J))
     *                     + 0.49999
                        END IF
 30                  CONTINUE
                  IYTV = IYTV + 1
                  CALL YIMGIO ('WRIT', TVCH, CATBLK(IICOR), IYTV, 0,
     *               NXP, SCRTCH, IRET)
                  IF (IRET.NE.0) GO TO 990
 40               CONTINUE
               END IF
            CALL COPY (NXP, JBUFF, IBUFF)
            END IF
 50      CONTINUE
      GO TO 995
C
 990  WRITE (MSGTXT,1990) IRET, SUBR
      CALL MSGWRT (8)
C
 995  CALL COPY (256, CATBLK, CATBLP)
      CALL COPY (256, CATSAV, CATBLK)
      FIRST = .FALSE.
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Loading every',I3,' pixel of image cube plane')
 1001 FORMAT ('Loading image cube plane interpolated by',I3)
 1010 FORMAT ('Image cube plane corners',4I6)
 1990 FORMAT ('TVSPL2 ERROR',I5,' FROM ROUTINE ',A)
      END
      SUBROUTINE TVSPPL (VERBOS, IWIN, PPOS, NX, NY, IMAGE, IRET)
C-----------------------------------------------------------------------
C   Interactive spectrum plot
C   Inputs:
C      VERBOS   L      tell pixel or no
C      IWIN     I(4)   TV window of image
C      NX       I      Number x pixels
C      NY       I      Number y pixels
C      IMAGE    R(*)   Image
C   In/out:
C      PPOS     R(2)   Cursor position of selected slice
C   Outputs:
C      IRET     I      error code
C-----------------------------------------------------------------------
      LOGICAL   VERBOS
      INTEGER   IWIN(4), NX, NY, IRET
      REAL      PPOS(2), IMAGE(NX,*)
C
      INCLUDE 'TVSPC.INC'
      INTEGER   QUAD, IBUT, ITW(3), IXY(2), I, NPIX, NROW, IX0, IY0,
     *   IX1, IY1, IX, IY, IROUND
      REAL      RPOS(2), PIXVAL
      CHARACTER SUBR*8, STRING*16, PREFIX*5
      DOUBLE PRECISION SKY(3)
      LOGICAL   F, DOIT, EQUAL, DOERR
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      CALL YHOLD ('ONNN', IRET)
      SUBR = 'YSLECT'
      CALL YSLECT ('ONNN', GRSPC1, 0, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 990
      SUBR = 'YZERO'
      CALL YZERO (GRSPC1, IRET)
      IF (IRET.NE.0) GO TO 990
      IF (GRMEBG.NE.GRSPC1) THEN
         CALL YZERO (GRMEBG, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
      CALL YZERO (GRMODL, IRET)
      IF (IRET.NE.0) GO TO 990
      CALL YZERO (GRESID, IRET)
      IF (IRET.NE.0) GO TO 990
      IF (TWOCUB) THEN
         CALL YZERO (GRSPC2, IRET)
         IF (IRET.NE.0) GO TO 990
         SUBR = 'YSLECT'
         CALL YSLECT ('ONNN', GRSPC2, 0, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
C                                       window for curvalue
      NPIX = 13 * CSIZTV(1)
      NROW = 4 * CSIZTV(2)
      IX0 = WINDTV(1) + 2*CSIZTV(1)
      IY0 = WINDTV(4) - NROW + 1 - 2*CSIZTV(2)
      IX1 = IX0 + NPIX - 1
      IY1 = IY0 + NROW - 1
      IF (NGRAPH.EQ.8) THEN
         CALL YZERO (GRBLAC, IRET)
         IF (IRET.NE.0) GO TO 990
         SUBR = 'YFILL'
         CALL YFILL (GRBLAC, IX0, IY0, IX1, IY1, 1, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         SUBR = 'YSLECT'
         CALL YSLECT ('ONNN', GRBLAC, 0, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
      SUBR = 'YSLECT'
      CALL YSLECT ('ONNN', GRMEBG, 0, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       cursor set up
      CALL ZTIME (ITW)
      IF ((PPOS(1).LT.IWIN(1)) .OR. (PPOS(1).GT.IWIN(3)) .OR.
     *   (PPOS(2).LT.IWIN(2)) .OR. (PPOS(2).GT.IWIN(4))) THEN
         PPOS(1) = (IWIN(1) + IWIN(3)) / 2.0
         PPOS(2) = (IWIN(2) + IWIN(4)) / 2.0
         END IF
      RPOS(1) = PPOS(1)
      RPOS(2) = PPOS(2)
C                                       on cursor
      SUBR = 'YCURSE'
      CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IRET)
      IF (IRET.NE.0) GO TO 990
      MSGTXT = 'Hit buttons C or D to stop'
      CALL MSGWRT (1)
      DOERR = .TRUE.
C                                       loop point
 20   SUBR = 'YCURSE'
      CALL YHOLD ('OFFF', IRET)
      CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IRET)
      IF (IRET.NE.0) GO TO 990
      CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
C                                       do something
      IF (DOIT) THEN
C                                       exit
         IF (IBUT.GE.4) GO TO 900
C                                       keep in window
         IF ((PPOS(1).LT.CATBLK(IICOR)) .OR.
     *      (PPOS(1).GT.CATBLK(IICOR+2)) .OR.
     *      (PPOS(2).LT.CATBLK(IICOR+1)) .OR.
     *      (PPOS(2).GT.CATBLK(IICOR+3))) THEN
            IF (PPOS(1).LT.CATBLK(IICOR)) PPOS(1) = CATBLK(IICOR)
            IF (PPOS(1).GT.CATBLK(IICOR+2)) PPOS(1) = CATBLK(IICOR+2)
            IF (PPOS(2).LT.CATBLK(IICOR+1)) PPOS(2) = CATBLK(IICOR+1)
            IF (PPOS(2).GT.CATBLK(IICOR+3)) PPOS(2) = CATBLK(IICOR+3)
            SUBR = 'YCURSE'
            CALL YCURSE ('ONNN', F, F, PPOS, QUAD, IBUT, IRET)
            IF (IRET.NE.0) GO TO 990
            END IF
C                                       get image pixel coordinate
         CALL IMA2MP (PPOS, RPOS)
         LOCNUM = 1
         CALL XYVAL (RPOS(1), RPOS(2), SKY(1), SKY(2), SKY(3), IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'BAD SKY COORDINATE XYVAL - TRY AGAIN'
            IF (DOERR) CALL MSGWRT (6)
            DOERR = .FALSE.
            GO TO 20
            END IF
C                                       curvalue
         CALL YHOLD ('ONNN', IRET)
         SUBR = 'YFILL'
         CALL YFILL (GRMEBG, IX0, IY0, IX1, IY1, 0, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         IX = IROUND (RPOS(1))
         IY = IROUND (RPOS(2))
         PIXVAL = IMAGE(IX,IY)
         WRITE (STRING,1020) IX, IY
         IY = IY0 + 3 * CSIZTV(2)
            SUBR = 'IMCHAR'
         CALL IMCHAR (GRMEBG, IX0, IY, 0, 0, STRING(:13), SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         IY = IY - 1.5 * CSIZTV(2)
         IF (PIXVAL.NE.FBLANK) THEN
            CALL METSCA (PIXVAL, PREFIX, EQUAL)
            WRITE (STRING,1021) PIXVAL
            CALL IMCHAR (GRMEBG, IX0, IY, 0, 0, STRING(:10), SCRTCH,
     *         IRET)
            IF (IRET.NE.0) GO TO 990
            STRING = PREFIX
            CALL H2CHR (8, 1, CATH(KHBUN), STRING(6:))
         ELSE
            STRING = 'B  BLANKED'
            CALL IMCHAR (GRMEBG, IX0, IY, 0, 0, STRING(:10), SCRTCH,
     *         IRET)
            IF (IRET.NE.0) GO TO 990
            STRING = ' '
            CALL IMCHAR (GRMEBG, IX0, IY0, 0, 0, STRING(:13), SCRTCH,
     *         IRET)
            STRING = ' '
            END IF
         CALL IMCHAR (GRMEBG, IX0, IY0, 0, 0, STRING(:13), SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       pixel in cube
         LOCNUM = 2
         IF (CORTYP(1).EQ.1) THEN
            IF (CORTYP(LOCNUM).EQ.1) THEN
               CALL XYPIX (SKY(1), SKY(2), RPOS(1), RPOS(2), IRET)
            ELSE
               CALL XYPIX (SKY(2), SKY(1), RPOS(1), RPOS(2), IRET)
               END IF
         ELSE IF (CORTYP(1).EQ.2) THEN
            IF (CORTYP(LOCNUM).EQ.1) THEN
               CALL XYPIX (SKY(2), SKY(1), RPOS(1), RPOS(2), IRET)
            ELSE
               CALL XYPIX (SKY(1), SKY(2), RPOS(1), RPOS(2), IRET)
               END IF
            END IF
         IF (IRET.NE.0) THEN
            MSGTXT = 'BAD SKY COORDINATE XYPIX - TRY AGAIN'
            CALL MSGWRT (6)
            GO TO 20
            END IF
         IXY(1) = RPOS(1) + 0.5
         IXY(2) = RPOS(2) + 0.5
         IF ((IXY(1).LT.1) .OR. (IXY(1).GT.CATBL2(KINAX+1)) .OR.
     *      (IXY(2).LT.1) .OR. (IXY(2).GT.CATBL2(KINAX+2))) THEN
            WRITE (MSGTXT,1000) IXY
            IF (DOERR) CALL MSGWRT (6)
            DOERR = .FALSE.
            GO TO 20
            END IF
         WRITE (MSGTXT,1005) IXY
         IF (VERBOS) CALL MSGWRT (2)
         CALL GETSPE (IXY, IRET)
         SUBR = 'GETSPE'
         IF (IRET.GT.0) GO TO 990
         IF (IRET.LT.0) THEN
            WRITE (MSGTXT,1001) IXY
            IF (DOERR) CALL MSGWRT (6)
            DOERR = .FALSE.
            GO TO 20
            END IF
         DOERR = .TRUE.
         LOCNUM = 3
         CALL PLOTSP (IXY, IRET)
         SUBR = 'PLOTSP'
         IF (IRET.NE.0) GO TO 990
         LASTYZ(1) = IXY(1)
         LASTYZ(2) = IXY(2)
         LASTYZ(3) = APARM(3) + 0.5
         CALL YHOLD ('OFFF', IRET)
         END IF
      GO TO 20
C                                       shut down nicely
 900  CALL YCURSE ('OFFF', F, F, PPOS, QUAD, IBUT, I)
      SUBR = 'YSLECT'
      CALL YHOLD ('ONNN', I)
      CALL YSLECT ('OFFF', GRMEBG, 0, SCRTCH, I)
      IF (IRET.NE.0) GO TO 990
      IF (NGRAPH.EQ.8) THEN
         CALL YSLECT ('OFFF', GRBLAC, 0, SCRTCH, I)
         IF (IRET.NE.0) GO TO 990
         END IF
      SPECOK = MAX (1, SPECOK)
      GO TO 999
C                                       error
 990  WRITE (MSGTXT,1990) IRET, SUBR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('YZ pixel',2I6,' out of range')
 1001 FORMAT ('YZ pixel',2I6,' no valid data')
 1005 FORMAT ('Plotting YZ pixel',2I6,' from transposed cube')
 1020 FORMAT ('X=',I4,' Y=',I4)
 1021 FORMAT ('B=',F8.3)
 1990 FORMAT ('TVSPPL ERROR',I4,' RETURNED FROM ',A)
      END
      SUBROUTINE GETSPE (IXY, IRET)
C-----------------------------------------------------------------------
C   GETSPE places the spectrum at that pixel into common
C   Inputs:
C      IXY    I(2)   Y,Z pixel position
C   Outputs:
C      IRET   I      error code
C-----------------------------------------------------------------------
      INTEGER   IXY(2), IRET
C
      INCLUDE 'TVSPC.INC'
      INTEGER   WIN(4), DEPTH(5), OFFS, BIND, IY1, IY2, IZ1, IZ2, IY,
     *   IZ, I, NP, J, K, I1, I2, OK1, OK2
      REAL      RR, RLIM, SIBUFF(MAXIMG), SJBUFF(MAXIMG)
      DATA DEPTH /5*1/
C-----------------------------------------------------------------------
      APARM(3) = MAX (0.0, APARM(3))
      I = APARM(3) + 0.5
      RLIM = APARM(3) * APARM(3)
      IY1 = MAX (IXY(1) - I, 1)
      IY2 = MIN (IXY(1) + I, CATBL2(KINAX+1))
      IZ1 = MAX (IXY(2) - I, 1)
      IZ2 = MIN (IXY(2) + I, CATBL2(KINAX+2))
      NP = CATBL2(KINAX)
      WIN(1) = 1
      WIN(3) = NP
      WIN(2) = IY1
      WIN(4) = IY2
      CALL FILL (NP, 0, IBUFF)
      CALL RFILL (NP, 0.0, SPECTR)
      DO 50 IZ = IZ1,IZ2
         DEPTH(1) = IZ
         CALL COMOFF (CATBL2(KIDIM), CATBL2(KINAX), DEPTH, OFFS, IRET)
         OFFS = OFFS + 1
         CALL MINIT ('READ', LUN2, IND2, CATBL2(KINAX), CATBL2(KINAX+1),
     *      WIN, BUFF1, JBUFSZ, OFFS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'INIT IO TO CUBE IMAGE'
            GO TO 990
            END IF
         DO 40 IY = IY1,IY2
            CALL MDISK ('READ', LUN2, IND2, BUFF1, BIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'READ TV IMAGE ROW'
               GO TO 990
               END IF
            RR = (IY - IXY(1))**2 + (IZ - IXY(2))**2
            IF (RR.LE.RLIM) THEN
               DO 30 I = 1,NP
                  IF (BUFF1(BIND+I-1).NE.FBLANK) THEN
                     IBUFF(I) = IBUFF(I) + 1
                     SPECTR(I) = SPECTR(I) + BUFF1(BIND+I-1)
                     END IF
 30               CONTINUE
               END IF
 40         CONTINUE
 50      CONTINUE
      OK1 = 0
      DO 60 I = 1,NP
         IF (IBUFF(I).GT.0) THEN
            SPECTR(I) = SPECTR(I) / IBUFF(I)
            OK1 = OK1 + 1
         ELSE
            SPECTR(I) = FBLANK
            END IF
 60      CONTINUE
C                                       Median window smooth
      IF (SMTYPE.EQ.2) THEN
         CALL SMWF (NP, SMWID, SPECTR, SIBUFF, SJBUFF)
C                                       function smooth
      ELSE IF ((SMTYPE.GT.0) .AND. (SMWID.GT.0)) THEN
         CALL RFILL (NP, 0.0, SIBUFF)
         CALL RFILL (NP, 0.0, SJBUFF)
         DO 80 J = 1,NP
            IF (SPECTR(J).NE.FBLANK) THEN
               I1 = MAX (1, J-SMWID)
               I2 = MIN (NP, J+SMWID)
               DO 70 I = I1,I2
                  K = ABS (I - J)
                  SIBUFF(I) = SIBUFF(I) + SFUNC(K) * SPECTR(J)
                  SJBUFF(I) = SJBUFF(I) + SFUNC(K)
 70               CONTINUE
               END IF
 80         CONTINUE
         OK1 = 0
         DO 90 J = 1,NP
            IF (SJBUFF(J).NE.0.0) THEN
               SPECTR(J) = SIBUFF(J) / SJBUFF(J)
               OK1 = OK1 + 1
            ELSE
               SPECTR(J) = FBLANK
               END IF
 90         CONTINUE
         END IF
C                                       read in image 4
      IF (TWOCUB) THEN
         CALL FILL (NP, 0, IBUFF)
         CALL RFILL (NP, 0.0, SPECT2)
         DO 150 IZ = IZ1,IZ2
            DEPTH(1) = IZ
            CALL COMOFF (CATBL3(KIDIM), CATBL3(KINAX), DEPTH, OFFS,
     *         IRET)
            OFFS = OFFS + 1
            CALL MINIT ('READ', LUN3, IND3, CATBL3(KINAX),
     *         CATBL3(KINAX+1), WIN, BUFF1, JBUFSZ, OFFS, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'INIT IO TO 2nd CUBE IMAGE'
               GO TO 990
               END IF
            DO 140 IY = IY1,IY2
               CALL MDISK ('READ', LUN3, IND3, BUFF1, BIND, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1000) IRET, 'READ 2nd CUBE IMAGE ROW'
                  GO TO 990
                  END IF
               RR = (IY - IXY(1))**2 + (IZ - IXY(2))**2
               IF (RR.LE.RLIM) THEN
                  DO 130 I = 1,NP
                     IF (BUFF1(BIND+I-1).NE.FBLANK) THEN
                        IBUFF(I) = IBUFF(I) + 1
                        SPECT2(I) = SPECT2(I) + BUFF1(BIND+I-1)
                        END IF
 130                 CONTINUE
                  END IF
 140           CONTINUE
 150        CONTINUE
         OK2 = 0
         DO 160 I = 1,NP
            IF (IBUFF(I).GT.0) THEN
               SPECT2(I) = SPECT2(I) / IBUFF(I)
               OK2 = OK2 + 1
            ELSE
               SPECT2(I) = FBLANK
               END IF
 160        CONTINUE
C                                       Median window smooth
         IF (SMTYPE.EQ.2) THEN
            CALL SMWF (NP, SMWID, SPECT2, SIBUFF, SJBUFF)
C                                       function smooth
         ELSE IF ((SMTYPE.GT.0) .AND. (SMWID.GT.0)) THEN
            CALL RFILL (NP, 0.0, SIBUFF)
            CALL RFILL (NP, 0.0, SJBUFF)
            DO 180 J = 1,NP
               IF (SPECT2(J).NE.FBLANK) THEN
                  I1 = MAX (1, J-SMWID)
                  I2 = MIN (NP, J+SMWID)
                  DO 170 I = I1,I2
                     K = ABS (I - J)
                     SIBUFF(I) = SIBUFF(I) + SFUNC(K) * SPECT2(J)
                     SJBUFF(I) = SJBUFF(I) + SFUNC(K)
 170                 CONTINUE
                  END IF
 180           CONTINUE
            OK2 = 0
            DO 190 J = 1,NP
               IF (SJBUFF(J).NE.0.0) THEN
                  SPECT2(J) = SIBUFF(J) / SJBUFF(J)
                  OK2 = OK2 + 1
               ELSE
                  SPECT2(J) = FBLANK
                  END IF
 190           CONTINUE
            END IF
         END IF
      IF (TWOCUB) THEN
         IF ((OK1.LE.2) .AND. (OK2.LE.2)) IRET = -1
      ELSE
         IF (OK1.LE.2) IRET = -1
         END IF
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETSPE ERROR',I5,' ON 'A)
      END
      SUBROUTINE SMWF (NP, SMWID, SPECTR, SIBUFF, SJBUFF)
C-----------------------------------------------------------------------
C   SMWF does a median window filter on the spectrum
C   Input:
C      NP        I      Size of SPECTR
C      SMWID     I      Support size pixels
C   In/Out:
C      SPECTR    R(*)   Spectrum: out is smoothed
C   Outputs:
C      SIBUFF    R(*)   scratch buffer
C      SJBUFF    R(*)   scratch buffer
C-----------------------------------------------------------------------
      INTEGER   NP, SMWID
      REAL      SPECTR(*), SIBUFF(*), SJBUFF(*)
C
      INTEGER   N, I1, I2, I, J, K
      REAL      MEDIAN
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      K = SMWID / 2
      DO 30 J = 1,NP
         I1 = MAX (1, J-K)
         I2 = MIN (NP, J+K)
         N = 0
         DO 20 I = I1,I2
            IF (SPECTR(I).NE.FBLANK) THEN
               N = N + 1
               SIBUFF(N) = SPECTR(I)
               END IF
 20         CONTINUE
         IF (N.LE.0) THEN
            SJBUFF(J) = FBLANK
         ELSE
            SJBUFF(J) = MEDIAN (N, SIBUFF)
            END IF
 30      CONTINUE
      CALL RCOPY (NP, SJBUFF, SPECTR)
C
 999  RETURN
      END
      SUBROUTINE PLOTSP (IYZ, IRET)
C-----------------------------------------------------------------------
C   PLOTSP plots the spectrum in common onto graphics channel GRSPC1/2
C   Inputs:
C      IYZ      I(2)   y/z pixels
C   Outputs:
C      IRET     I      error code
C-----------------------------------------------------------------------
      INTEGER   IYZ(2), IRET
C
      INCLUDE 'TVSPC.INC'
      INTEGER   I, NP, CATSAV(256), JDROP(2), TVSIZE(2), NXA, NYA,
     *   I4XTRA, ICHB, ICHL, ICHR, ICHT, IX1, IX2, IY1, IY2, LABEL,
     *   NTEXT, IROUND, INP, JTRIM
      LOGICAL   BLAST, SPLIT, SVERT
      REAL      SRANGE(2), FQFINC, PIXMIN, PIXMAX, RANGE2(2), RMAX,
     *   XBLC(7), XTRC(7), BLC(2), TRC(2), CH(4), YGAP, DX, X, Y, XFAC,
     *   XOFF, XYRATO, XX
      CHARACTER TEXT(2)*80, SUBR*8, XTEXT*80
      DOUBLE PRECISION FQFREQ
      INCLUDE 'INCS:DTVS.INC'
      DATA XBLC, XTRC /14*1.0/
      DATA JDROP /2*0/
C-----------------------------------------------------------------------
C                                       protect TV image catalog
      CALL COPY (256, CATBLK, CATSAV)
      CALL COPY (256, CATBL2, CATBLK)
      CALL COPY (4, SWINTV, SWIN1)
      CALL COPY (4, SWINTV, SWIN2)
C                                       split spectra plots
      SPLIT = (TWOCUB) .AND. (APARM(6).GT.0.0)
      SVERT = .FALSE.
      IF (SPLIT) THEN
C                                       split horizontally
         IF (APARM(4).LT.0.0) THEN
            SWIN1(3) = SWIN1(1) + (SWINTV(3) - SWINTV(1)) / 2
            SWIN2(1) = SWIN1(3) + 1
C                                       split vertically
         ELSE
            SVERT = .TRUE.
            SWIN2(4) = SWIN2(2) + (SWINTV(4) - SWINTV(2)) / 2
            SWIN1(2) = SWIN2(4) + 1
            END IF
         END IF
      LABEL = 3
      IF (APARM(8).GT.0.0) LABEL = 6
      IGR = GRSPC1
      NP = ECHAN - BCHAN + 1
      XBLC(1) = BCHAN
      XBLC(2) = IYZ(1)
      XBLC(3) = IYZ(2)
      XTRC(1) = ECHAN
      XTRC(2) = IYZ(1)
      XTRC(3) = IYZ(2)
C                                       fixed scale
      IF (APARM(2).GT.APARM(1)) THEN
         SRANGE(1) = APARM(1)
         SRANGE(2) = APARM(2)
C                                       full scale
      ELSE IF (APARM(2).LT.APARM(1)) THEN
         SRANGE(1) = CATR(KRDMN)
         SRANGE(2) = CATR(KRDMX)
         IF ((TWOCUB) .AND. (APARM(6).LE.0.0)) THEN
            SRANGE(1) = MIN (SRANGE(1), CATR4(KRDMN))
            SRANGE(2) = MAX (SRANGE(2), CATR4(KRDMX))
            END IF
C                                       self-scale
      ELSE
         SRANGE(1) = 1.E10
         SRANGE(2) = -1.E10
         DO 20 I = BCHAN,ECHAN
            IF (SPECTR(I).NE.FBLANK) THEN
               SRANGE(1) = MIN (SRANGE(1), SPECTR(I))
               SRANGE(2) = MAX (SRANGE(2), SPECTR(I))
               END IF
 20         CONTINUE
         IF ((TWOCUB) .AND. (APARM(6).LE.0.0)) THEN
            DO 25 I = BCHAN,ECHAN
               IF (SPECT2(I).NE.FBLANK) THEN
                  SRANGE(1) = MIN (SRANGE(1), SPECT2(I))
                  SRANGE(2) = MAX (SRANGE(2), SPECT2(I))
                  END IF
 25            CONTINUE
            END IF
         IF (SRANGE(1).GT.SRANGE(2)) THEN
            SRANGE(1) = CATR(KRDMN)
            SRANGE(2) = CATR(KRDMX)
            IF ((TWOCUB) .AND. (APARM(6).LE.0.0)) THEN
               SRANGE(1) = MIN (SRANGE(1), CATR4(KRDMN))
               SRANGE(2) = MAX (SRANGE(2), CATR4(KRDMX))
               END IF
            END IF
         END IF
      FQFREQ = 0.0D0
      FQFINC = 0.0
C                                       mess about a bit
 30   DX = (SRANGE(2) - SRANGE(1)) * 0.03
      RANGE2(2) = SRANGE(2) + DX
      RANGE2(1) = SRANGE(1) - DX
C                                       Calc fac & offset to keep BLC
C                                       TRC within range to prevent
C                                       overflow in graphics routines.
      PIXMAX = RANGE2(2)
      PIXMIN = RANGE2(1)
      XFAC = 39999.0 / (PIXMAX - PIXMIN)
      XOFF = 40000.0 - XFAC * PIXMAX
      RANGE2(1) = XFAC * RANGE2(1) + XOFF
      RANGE2(2) = XFAC * RANGE2(2) + XOFF
      RMAX = 2.0 ** (NBITWD-1) - 1
C                                       Must reduce users max value.
      IF (RANGE2(2).GT.RMAX) RANGE2(2) = RMAX
C                                       Must increase users min.
      IF (RANGE2(1).LT.-RMAX) RANGE2(1) = -RMAX
C                                       Round and back calc range.
      RANGE2(1) = IROUND (RANGE2(1))
      RANGE2(2) = IROUND (RANGE2(2))
      IF (RANGE2(1).GE.RANGE2(2)) THEN
         SRANGE(1) = CATR(KRDMN)
         SRANGE(2) = CATR(KRDMX)
         GO TO 30
         END IF
      SRANGE(1) = (RANGE2(1) - XOFF) / XFAC
      SRANGE(2) = (RANGE2(2) - XOFF) / XFAC
      BLC(2) = RANGE2(1)
      TRC(2) = RANGE2(2)
C                                       Initialize plot file line drw.
      CALL SLBINI (JDROP, NP, SRANGE, BLC, TRC, XBLC, XTRC, FQFREQ,
     *   FQFINC, CATBLK(IIDEP), LABEL, YGAP, CH, TEXT, NTEXT)
      XYRATO = (TRC(2) - BLC(2)) / (TRC(1) - BLC(1))
      IX1 = BLC(1) + .5
      IY1 = BLC(2) + .5
      IX2 = TRC(1) + .5
      IY2 = TRC(2) + .5
      IF (SVERT) THEN
         CH(1) = MAX (9.0, CH(1))
         CH(2) = 0.5
         XTEXT = TEXT(1)
         NTEXT = 0
         CTYP(1,LOCNUM) = ' '
         CPREF(1,LOCNUM) = ' '
         END IF
      ICHL = CH(1) * CSIZTV(1) + .5
      ICHB = CH(2) * CSIZTV(2) + .5
      ICHR = CH(3) * CSIZTV(1) + .5
      ICHT = CH(4) * CSIZTV(2) + .5
      TVSIZE(1) = SWIN1(3) - SWIN1(1) + 1
      TVSIZE(2) = SWIN1(4) - SWIN1(2) + 1
      NYA = SWIN1(4) - SWIN1(2) - ICHT - ICHB
      NXA = SWIN1(3) - SWIN1(1) - ICHL - ICHR
C                                       compute scaling
      X = IX2
      X = ABS (X - IX1)
      XX = X * XYRATO
      Y = IY2
      Y = ABS (Y - IY1)
      IF ((XX.LE.0.0) .OR. (Y.LE.0.0)) THEN
         MSGTXT = 'SCALING ERROR'
         CALL MSGWRT (8)
         IRET = 1
         GO TO 999
         END IF
      SCALEY = (NYA - 1) / Y
      SCALEX = (NXA - 1) / X
      NXA = SCALEX * X + ICHL + ICHR
      IF (NXA.GE.TVSIZE(1)) THEN
         SCALEX = SCALEX * (FLOAT(TVSIZE(1)) / (NXA + 5.0))
         SCALEY = SCALEY * (FLOAT(TVSIZE(1)) / (NXA + 5.0))
         NXA = SCALEX * X + ICHL + ICHR
         END IF
      NYA = SCALEY * Y + ICHB + ICHT
      IF (NXA.GE.TVSIZE(1)) THEN
         SCALEX = SCALEX * (FLOAT(TVSIZE(2)) / (NYA + 5.0))
         SCALEY = SCALEY * (FLOAT(TVSIZE(2)) / (NYA + 5.0))
         NXA = SCALEX * X + ICHL + ICHR
         NYA = SCALEY * Y + ICHB + ICHT
         END IF
      RX0 = ICHL + MAX (0, TVSIZE(1)-NXA) / 2 + SWIN1(1)
      RY0 = ICHB + MAX (0, TVSIZE(2)-NYA) / 2 + SWIN1(2)
C                                       Put stuff in image catalog.
      CATBLK(IIWIN  ) = IX1 + BCHAN - 1
      CATBLK(IIWIN+1) = IY1
      CATBLK(IIWIN+2) = IX2 + BCHAN - 1
      CATBLK(IIWIN+3) = IY2
      CATBLK(IICOR  ) = RX0 + 0.5
      CATBLK(IICOR+1) = RY0 + 0.5
      CATBLK(IICOR+2) = RX0 + X * SCALEX + .5
      CATBLK(IICOR+3) = RY0 + Y * SCALEY + .5
      CATBLK(IIPLT) = 5
      CATBLK(IIOTH) = LABEL
      CATBLK(IIOTH+1) = JDROP(1)
      CATBLK(IIOTH+2) = JDROP(2)
      I4XTRA = IIOTH + 3
      CATR(I4XTRA  ) = XBLC(1)
      CATR(I4XTRA+1) = XBLC(2)
      CATR(I4XTRA+2) = XTRC(1)
      CATR(I4XTRA+3) = XTRC(2)
      CATR(I4XTRA+4) = XBLC(3)
      CATR(I4XTRA+5) = XTRC(3)
      I4XTRA = I4XTRA + 6
      I4XTRA = I4XTRA/2 + 1
      CATD(I4XTRA) = FQFREQ
      I4XTRA = 2*I4XTRA + 1
      CATR(I4XTRA) = FQFINC
      CALL CHR2H (2, 'SL', KHPTYO, CATH(KHPTY))
      CATR(IRRAN) = SRANGE(1)
      CATR(IRRAN+1) = SRANGE(2)
C
      RX0 = RX0 - BLC(1) * SCALEX + .5
      RY0 = RY0 - BLC(2) * SCALEY + .5
C                                       image catalog etc
      CALL YCINIT (GRSPC1, SCRTCH)
      SUBR = 'YZERO'
      CALL YZERO (GRSPC1, IRET)
      IF (IRET.NE.0) GO TO 990
      SUBR = 'YCWRIT'
      CALL YCWRIT (GRSPC1, CATBLK(IICOR), CATBLK, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 990
      IF ((TWOCUB) .AND. (APARM(6).LE.0.0)) THEN
         CALL YCINIT (GRSPC2, SCRTCH)
         SUBR = 'YZERO'
         CALL YZERO (GRSPC2, IRET)
         IF (IRET.NE.0) GO TO 990
         SUBR = 'YCWRIT'
         CALL YCWRIT (GRSPC2, CATBLK(IICOR), CATBLK, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
      IF (NTEXT.GE.1) THEN
         INP = JTRIM (TEXT(1))
         WRITE (XTEXT,1030) IYZ, APARM(3)
         CALL REFRMT (XTEXT, '_', I)
         TEXT(1)(INP+3:) = XTEXT(:I)
         END IF
      SUBR = 'TVLAB'
      CALL TVLAB (BLC, TRC, LABEL, YGAP, TEXT, NTEXT, CH, .FALSE., IRET)
      IF (IRET.NE.0) GO TO 990
C                                       plot slice
      SUBR = 'TVVEC'
      BLAST = .TRUE.
      DO 50 I = BCHAN,ECHAN
         IF (SPECTR(I).EQ.FBLANK) THEN
            BLAST = .TRUE.
         ELSE
            X = I - BCHAN + 1
            Y = XFAC * SPECTR(I) + XOFF
            Y = MIN (Y, RANGE2(2))
            Y = MAX (Y, RANGE2(1))
            INP = 2
            IF (BLAST) INP = 1
            CALL TVVEC (X, Y, INP, IRET)
            IF (IRET.NE.0) GO TO 990
            BLAST = .FALSE.
            END IF
 50      CONTINUE
      IF ((TWOCUB) .AND. (APARM(6).LE.0.0)) THEN
         IGR = GRSPC2
         BLAST = .TRUE.
         DO 60 I = BCHAN,ECHAN
            IF (SPECT2(I).EQ.FBLANK) THEN
               BLAST = .TRUE.
            ELSE
               X = I - BCHAN + 1
               Y = XFAC * SPECT2(I) + XOFF
               Y = MIN (Y, RANGE2(2))
               Y = MAX (Y, RANGE2(1))
               INP = 2
               IF (BLAST) INP = 1
               CALL TVVEC (X, Y, INP, IRET)
               IF (IRET.NE.0) GO TO 990
               BLAST = .FALSE.
               END IF
 60         CONTINUE
         IGR = GRSPC1
         END IF
C                                       save 1st cube spectrum plot
      CALL COPY (256, CATBLK, CATBLS)
C                                       Split spectra
      IF (SPLIT) THEN
         CALL COPY (256, CATBL3, CATBLK)
         LABEL = 3
         IF (APARM(8).GT.0.0) LABEL = 6
         IGR = GRSPC2
         NP = ECHAN - BCHAN + 1
         XBLC(1) = BCHAN
         XBLC(2) = IYZ(1)
         XBLC(3) = IYZ(2)
         XTRC(1) = ECHAN
         XTRC(2) = IYZ(1)
         XTRC(3) = IYZ(2)
C                                       fixed scale
         IF (APARM(2).GT.APARM(1)) THEN
            SRANGE(1) = APARM(1)
            SRANGE(2) = APARM(2)
C                                       full scale
         ELSE IF (APARM(2).LT.APARM(1)) THEN
            SRANGE(1) = CATR(KRDMN)
            SRANGE(2) = CATR(KRDMX)
C                                       self-scale
         ELSE
            SRANGE(1) = 1.E10
            SRANGE(2) = -1.E10
            DO 120 I = BCHAN,ECHAN
               IF (SPECT2(I).NE.FBLANK) THEN
                  SRANGE(1) = MIN (SRANGE(1), SPECT2(I))
                  SRANGE(2) = MAX (SRANGE(2), SPECT2(I))
                  END IF
 120           CONTINUE
            END IF
         FQFREQ = 0.0D0
         FQFINC = 0.0
C                                       mess about a bit
 130     DX = (SRANGE(2) - SRANGE(1)) * 0.03
         RANGE2(2) = SRANGE(2) + DX
         RANGE2(1) = SRANGE(1) - DX
C                                       Calc fac & offset to keep BLC
C                                       TRC within range to prevent
C                                       overflow in graphics routines.
         PIXMAX = RANGE2(2)
         PIXMIN = RANGE2(1)
         XFAC = 39999.0 / (PIXMAX - PIXMIN)
         XOFF = 40000.0 - XFAC * PIXMAX
         RANGE2(1) = XFAC * RANGE2(1) + XOFF
         RANGE2(2) = XFAC * RANGE2(2) + XOFF
         RMAX = 2.0 ** (NBITWD-1) - 1
C                                       Must reduce users max value.
         IF (RANGE2(2).GT.RMAX) RANGE2(2) = RMAX
C                                       Must increase users min.
         IF (RANGE2(1).LT.-RMAX) RANGE2(1) = -RMAX
C                                       Round and back calc range.
         RANGE2(1) = IROUND (RANGE2(1))
         RANGE2(2) = IROUND (RANGE2(2))
         IF (RANGE2(1).GE.RANGE2(2)) THEN
            SRANGE(1) = CATR(KRDMN)
            SRANGE(2) = CATR(KRDMX)
            GO TO 130
            END IF
         SRANGE(1) = (RANGE2(1) - XOFF) / XFAC
         SRANGE(2) = (RANGE2(2) - XOFF) / XFAC
         BLC(2) = RANGE2(1)
         TRC(2) = RANGE2(2)
C                                       Initialize plot file line drw.
         IF (SVERT) THEN
            LABEL = 7
            IF (APARM(8).GT.0.0) LABEL = 10
            END IF
         CALL SLBINI (JDROP, NP, SRANGE, BLC, TRC, XBLC, XTRC, FQFREQ,
     *      FQFINC, CATBLK(IIDEP), LABEL, YGAP, CH, TEXT, NTEXT)
         XYRATO = (TRC(2) - BLC(2)) / (TRC(1) - BLC(1))
         IX1 = BLC(1) + .5
         IY1 = BLC(2) + .5
         IX2 = TRC(1) + .5
         IY2 = TRC(2) + .5
         IF (SVERT) THEN
            CH(1) = MAX (9.0, CH(1))
            CH(4) = 0.5
            NTEXT = 1
            TEXT(1) = XTEXT
            CH(2) = CH(2) + 1.5
            END IF
         ICHL = CH(1) * CSIZTV(1) + .5
         ICHB = CH(2) * CSIZTV(2) + .5
         ICHR = CH(3) * CSIZTV(1) + .5
         ICHT = CH(4) * CSIZTV(2) + .5
         TVSIZE(1) = SWIN2(3) - SWIN2(1) + 1
         TVSIZE(2) = SWIN2(4) - SWIN2(2) + 1
         NYA = SWIN2(4) - SWIN2(2) - ICHT - ICHB
         NXA = SWIN2(3) - SWIN2(1) - ICHL - ICHR
C                                       compute scaling
         X = IX2
         X = ABS (X - IX1)
         XX = X * XYRATO
         Y = IY2
         Y = ABS (Y - IY1)
         IF ((XX.LE.0.0) .OR. (Y.LE.0.0)) THEN
            MSGTXT = 'SCALING ERROR'
            CALL MSGWRT (8)
            IRET = 1
            GO TO 999
            END IF
         SCALEY = (NYA - 1) / Y
         SCALEX = (NXA - 1) / X
         NXA = SCALEX * X + ICHL + ICHR
         IF (NXA.GE.TVSIZE(1)) THEN
            SCALEX = SCALEX * (FLOAT(TVSIZE(1)) / (NXA + 5.0))
            SCALEY = SCALEY * (FLOAT(TVSIZE(1)) / (NXA + 5.0))
            NXA = SCALEX * X + ICHL + ICHR
            END IF
         NYA = SCALEY * Y + ICHB + ICHT
         IF (NXA.GE.TVSIZE(1)) THEN
            SCALEX = SCALEX * (FLOAT(TVSIZE(2)) / (NYA + 5.0))
            SCALEY = SCALEY * (FLOAT(TVSIZE(2)) / (NYA + 5.0))
            NXA = SCALEX * X + ICHL + ICHR
            NYA = SCALEY * Y + ICHB + ICHT
             END IF
         RX0 = ICHL + MAX (0, TVSIZE(1)-NXA) / 2 + SWIN2(1)
         RY0 = ICHB + MAX (0, TVSIZE(2)-NYA) / 2 + SWIN2(2)
C                                       Put stuff in image catalog.
         CATBLK(IIWIN  ) = IX1 + BCHAN - 1
         CATBLK(IIWIN+1) = IY1
         CATBLK(IIWIN+2) = IX2 + BCHAN - 1
         CATBLK(IIWIN+3) = IY2
         CATBLK(IICOR  ) = RX0 + 0.5
         CATBLK(IICOR+1) = RY0 + 0.5
         CATBLK(IICOR+2) = RX0 + X * SCALEX + .5
         CATBLK(IICOR+3) = RY0 + Y * SCALEY + .5
         CATBLK(IIPLT) = 5
         CATBLK(IIOTH) = LABEL
         CATBLK(IIOTH+1) = JDROP(1)
         CATBLK(IIOTH+2) = JDROP(2)
         I4XTRA = IIOTH + 3
         CATR(I4XTRA  ) = XBLC(1)
         CATR(I4XTRA+1) = XBLC(2)
         CATR(I4XTRA+2) = XTRC(1)
         CATR(I4XTRA+3) = XTRC(2)
         CATR(I4XTRA+4) = XBLC(3)
         CATR(I4XTRA+5) = XTRC(3)
         I4XTRA = I4XTRA + 6
         I4XTRA = I4XTRA/2 + 1
         CATD(I4XTRA) = FQFREQ
         I4XTRA = 2*I4XTRA + 1
         CATR(I4XTRA) = FQFINC
         CALL CHR2H (2, 'SL', KHPTYO, CATH(KHPTY))
         CATR(IRRAN) = SRANGE(1)
         CATR(IRRAN+1) = SRANGE(2)
C
         RX0 = RX0 - BLC(1) * SCALEX + .5
         RY0 = RY0 - BLC(2) * SCALEY + .5
C                                       image catalog etc
         CALL YCINIT (GRSPC2, SCRTCH)
         SUBR = 'YZERO'
         CALL YZERO (GRSPC2, IRET)
         IF (IRET.NE.0) GO TO 990
         SUBR = 'YCWRIT'
         CALL YCWRIT (GRSPC2, CATBLK(IICOR), CATBLK, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         IF (NTEXT.GE.1) THEN
            INP = JTRIM (TEXT(1))
            WRITE (XTEXT,1030) IYZ, APARM(3)
            CALL REFRMT (XTEXT, '_', I)
            TEXT(1)(INP+3:) = XTEXT(:I)
            END IF
         SUBR = 'TVLAB'
         CALL TVLAB (BLC, TRC, LABEL, YGAP, TEXT, NTEXT, CH, .FALSE.,
     *      IRET)
         IF (IRET.NE.0) GO TO 990
C                                       plot slice
         SUBR = 'TVVEC'
         BLAST = .TRUE.
         DO 150 I = BCHAN,ECHAN
            IF (SPECT2(I).EQ.FBLANK) THEN
               BLAST = .TRUE.
            ELSE
               X = I - BCHAN + 1
               Y = XFAC * SPECT2(I) + XOFF
               Y = MIN (Y, RANGE2(2))
               Y = MAX (Y, RANGE2(1))
               INP = 2
               IF (BLAST) INP = 1
               CALL TVVEC (X, Y, INP, IRET)
               IF (IRET.NE.0) GO TO 990
               BLAST = .FALSE.
               END IF
 150        CONTINUE
         IGR = GRSPC1
         CALL COPY (256, CATBLK, CATBS2)
         END IF
      GO TO 995
C
 990  WRITE (MSGTXT,1990) IRET, SUBR
      CALL MSGWRT (8)
      CALL COPY (256, CATBLK, CATBLS)
C
 995  CALL COPY (256, CATSAV, CATBLK)
      IF (IRET.EQ.0) THEN
         CALL TVPMRK (IRET)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('PIXEL',2I6,'___RADIUS',F4.1)
 1990 FORMAT ('PLOTSP ERROR',I5,' FROM ',A)
      END
      SUBROUTINE TVSCHN (IRET)
C-----------------------------------------------------------------------
C   TVSCHN interacts to set new values for BCHAN and ECHAN
C   Outputs:
C      IRET   I   > 0 => serious error
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'TVSPC.INC'
      INTEGER   IBCHAN, IECHAN, NCHAN, IWIN(4), IXC(4), IYC(2), IX0,
     *   IX1, IY0, IY1, NPIX, NROW, IVAL, QUAD, IBUT, ITW(3), LBCHAN,
     *   LECHAN, IY
      REAL      RPOS(2), PPOS(2), LPOS(2), X
      CHARACTER STRING*6
      LOGICAL   DOIT, T, F
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      CALL ZTIME (ITW)
      CALL COPY (4, CATBLS(IICOR), IWIN)
      IBCHAN = CATBLS(IIWIN)
      IECHAN = CATBLS(IIWIN+2)
      LBCHAN = IBCHAN
      LECHAN = IECHAN
      NCHAN = IECHAN - IBCHAN + 1
      IYC(1) = IWIN(2)
      IYC(2) = IWIN(4)
      IXC(1) = IWIN(1)
      IXC(2) = IWIN(1)
      IXC(3) = IWIN(3)
      IXC(4) = IWIN(3)
      CALL YZERO (GRMEBG, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       curvalue display
      NPIX = 6 * CSIZTV(1)
      NROW = 2.5 * CSIZTV(2) + 0.5
      IX0 = WINDTV(1) + 2*CSIZTV(1)
      IY0 = WINDTV(4) - NROW + 1 - 2*CSIZTV(2)
      IX1 = IX0 + NPIX - 1
      IY1 = IY0 + NROW - 1
      IF (NGRAPH.EQ.8) THEN
         CALL YZERO (GRBLAC, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YFILL (GRBLAC, IX0, IY0, IX1, IY1, 1, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YSLECT ('ONNN', GRBLAC, 0, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         END IF
      CALL YSLECT ('ONNN', GRMEBG, 0, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 970
C                                       instructions
      MSGTXT = 'Hit buttons A or B to switch between lower and upper'
     *   // ' limits'
      CALL MSGWRT (1)
      MSGTXT = 'Hit buttons C or D to set new limits for next plot'
      CALL MSGWRT (1)
      RPOS(1) = IXC(3)
      RPOS(2) = (IYC(1) + IYC(2)) / 2.0
      IVAL = 2
 10   PPOS(1) = 0.0
      PPOS(2) = 0.0
      CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IRET)
      IF ((IRET.NE.0) .AND. (IRET.NE.2)) GO TO 970
C                                       cursor read loop point
 20   CALL YCURSE ('READ', F, T, RPOS, QUAD, IBUT, IRET)
      LPOS(1) = RPOS(1)
      LPOS(2) = RPOS(2)
      IF (RPOS(1).GT.IWIN(3)) RPOS(1) = IWIN(3)
      IF (RPOS(1).LT.IWIN(1)) RPOS(1) = IWIN(1)
      CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
      IF (.NOT.DOIT) THEN
         GO TO 20
      ELSE
         CALL IMVECT ('OFFF', GRMEBG, 2, IXC(1), IYC, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL IMVECT ('OFFF', GRMEBG, 2, IXC(3), IYC, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         IXC(2*IVAL-1) = RPOS(1) + 0.5
         IXC(2*IVAL) = RPOS(1) + 0.5
         CALL IMVECT ('ONNN', GRMEBG, 2, IXC(1), IYC, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL IMVECT ('ONNN', GRMEBG, 2, IXC(3), IYC, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         X = IBCHAN + ((RPOS(1) - IWIN(1)) / (IWIN(3) - IWIN(1))) *
     *      (IECHAN - IBCHAN)
         IF (IVAL.EQ.2) THEN
            LECHAN = X + 0.5
         ELSE
            LBCHAN = X + 0.5
            END IF
         WRITE (STRING,1020) LECHAN
         IY = IY0 + 1.5*CSIZTV(2) + 0.5
         CALL IMCHAR (GRMEBG, IX0, IY, 0, 0, STRING(:6), SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         WRITE (STRING,1020) LBCHAN
         CALL IMCHAR (GRMEBG, IX0, IY0, 0, 0, STRING(:6), SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         IF (IBUT.LT.4) THEN
            IF (IBUT.GT.0) THEN
               IVAL = 3 - IVAL
               RPOS(1) = IXC(2*IVAL)
               END IF
            IF ((RPOS(1).NE.LPOS(1)) .OR. (RPOS(2).NE.LPOS(2))) GO TO 10
            GO TO 20
            END IF
         END IF
      BCHAN = MIN (LBCHAN, LECHAN)
      ECHAN = MAX (LBCHAN, LECHAN)
      GO TO 990
C                                       error
 970  WRITE (MSGTXT,1970) IRET
      CALL MSGWRT (8)
C
 990  CALL YZERO (GRMEBG, IVAL)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT (I6)
 1970 FORMAT ('TVSCHN ERROR',I4,' ON BASIC TV OPERATION')
      END
      SUBROUTINE TVPLAN (VERBOS, NX, NY, NZ, IMAGE, IRET)
C-----------------------------------------------------------------------
C   TVPLAN interacts to load planes from cube
C   Outputs:
C      IRET   I   > 0 => serious error
C-----------------------------------------------------------------------
      LOGICAL   VERBOS
      INTEGER   NX, NY, NZ, IRET
      REAL      IMAGE(NX,NY,*)
C
      INCLUDE 'TVSPC.INC'
      INTEGER   IBCHAN, IECHAN, NCHAN, IWIN(4), IXC(2), IYC(2), IX0,
     *   IX1, IY0, IY1, NPIX, NROW, IVAL, QUAD, IBUT, ITW(3), LBCHAN,
     *   LECHAN, IY
      REAL      RPOS(2), PPOS(2), LPOS(2), X, XX
      CHARACTER STRING*6
      LOGICAL   DOIT, T, F, FIRST
      DOUBLE PRECISION VAL
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      CALL ZTIME (ITW)
      CALL COPY (4, CATBLS(IICOR), IWIN)
      IBCHAN = CATBLS(IIWIN)
      IECHAN = CATBLS(IIWIN+2)
      LBCHAN = IBCHAN
      LECHAN = IECHAN
      NCHAN = IECHAN - IBCHAN + 1
      IYC(1) = IWIN(2)
      IYC(2) = IWIN(4)
      IXC(1) = (IWIN(1) + IWIN(3)) / 2
      IXC(2) = IXC(1)
      CALL YHOLD ('ONNN', IRET)
      CALL YZERO (GRMEBG, IRET)
      IF (IRET.NE.0) GO TO 970
      FIRST = .TRUE.
C                                       curvalue display
      NPIX = 6 * CSIZTV(1)
      NROW = 1.5 * CSIZTV(2) + 0.5
      IX0 = WINDTV(1) + 2*CSIZTV(1)
      IY0 = WINDTV(4) - NROW + 1 - 2*CSIZTV(2)
      IX1 = IX0 + NPIX - 1
      IY1 = IY0 + NROW - 1
      IF (NGRAPH.EQ.8) THEN
         CALL YZERO (GRBLAC, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YFILL (GRBLAC, IX0, IY0, IX1, IY1, 1, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         CALL YSLECT ('ONNN', GRBLAC, 0, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         END IF
      CALL YSLECT ('ONNN', GRMEBG, 0, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 970
      CALL YHOLD ('FFFF', IRET)
C                                       instructions
      MSGTXT = 'Drag mouse to select plane'
      CALL MSGWRT (1)
      MSGTXT = 'Hit any button to exit'
      CALL MSGWRT (1)
      RPOS(1) = IXC(1)
      RPOS(2) = (IYC(1) + IYC(2)) / 2.0
      IVAL = 2
      PPOS(1) = 0.0
      PPOS(2) = 0.0
      CALL YCURSE ('ONNN', F, T, RPOS, QUAD, IBUT, IRET)
      IF ((IRET.NE.0) .AND. (IRET.NE.2)) GO TO 970
C                                       cursor read loop point
 20   CALL YCURSE ('READ', F, T, RPOS, QUAD, IBUT, IRET)
      LPOS(1) = RPOS(1)
      LPOS(2) = RPOS(2)
      IF (RPOS(1).GT.IWIN(3)) RPOS(1) = IWIN(3)
      IF (RPOS(1).LT.IWIN(1)) RPOS(1) = IWIN(1)
      CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
      IF (.NOT.DOIT) THEN
         GO TO 20
      ELSE
         CALL YHOLD ('ONNN', IRET)
         CALL IMVECT ('OFFF', GRMEBG, 2, IXC(1), IYC, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         IXC(1) = RPOS(1) + 0.5
         IXC(2) = IXC(1)
         CALL IMVECT ('ONNN', GRMEBG, 2, IXC(1), IYC, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         X = IBCHAN + ((RPOS(1) - IWIN(1)) / (IWIN(3) - IWIN(1))) *
     *      (IECHAN - IBCHAN)
         LECHAN = X + 0.5
         WRITE (STRING,1020) LECHAN
         IY = IY0 + 0.5*CSIZTV(2) + 0.5
         CALL IMCHAR (GRMEBG, IX0, IY, 0, 0, STRING(:6), SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 970
         VAL = CATD2(KDCRV) + (X-CATR2(KRCRP)) * CATR2(KRCIC)
         XX = (VAL - CATD4(KDCRV+2)) / CATR4(KRCIC+2) + CATR4(KRCRP+2)
         IF ((X.GE.0.5) .AND. (X.LT.NZ+0.5)) THEN
            CURPLN = XX + 0.5
            CURCHN = X + 0.5
            WRITE (MSGTXT,1025) CURPLN, VAL
            IF (VERBOS) CALL MSGWRT (2)
            CALL TVSPL2 (FIRST, NX, NY, NZ, IMAGE, IRET)
            IF (IRET.NE.0) GO TO 970
            END IF
         CALL YHOLD ('OFFF', IRET)
         IF (IBUT.EQ.0) GO TO 20
         END IF
      GO TO 990
C                                       error
 970  WRITE (MSGTXT,1970) IRET
      CALL MSGWRT (8)
C
 990  CALL YHOLD ('ONNN', IRET)
      CALL YZERO (GRMEBG, IVAL)
      IF (IRET.EQ.0) CALL TVPMRK (IRET)
      IF ((IRET.EQ.0) .AND. (DOLABL.GT.0)) THEN
         CALL YHOLD ('ONNN', IRET)
         CALL TVSPLA (IRET)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT (I6)
 1025 FORMAT ('Loading plane',I6,' value',1PE11.3)
 1970 FORMAT ('TVPLAN ERROR',I4,' ON BASIC TV OPERATION')
      END
      SUBROUTINE TVSPCV (NX, NY, IMAGE, NX2, NY2, NZ2, IMAGE2, IRET)
C-----------------------------------------------------------------------
C   TVSPDO does curvalue in any of the 4 picture areas
C   Inputs
C      NX       I      Number x pixels
C      NY       I      Number y pixels
C      NX2      I      Number x pixels image 2
C      NY2      I      Number y pixels image 2
C      NZ2      I      Number z pixels image 2
C      IMAGE    R(*)   Image
C      IMAGE2   R(*)   Image plane from #2
C   Outputs:
C      IRET     I      error
C-----------------------------------------------------------------------
      INTEGER   NX, NY, NX2, NY2, NZ2, IRET
      REAL      IMAGE(NX,*), IMAGE2(NX2,NY2,*)
C
      INCLUDE 'TVSPC.INC'
      INTEGER   QUAD, IBUT, ITW(3), I, NPIX, NROW, IX0, IY0, IX1, IY1,
     *   IX, IY, IROUND, CATSAV(256), IMTYPE, LIMTYP, IWIN(4,4), IBCHAN,
     *   IECHAN
      REAL      PPOS(2), RPOS(2), PIXVAL, X
      CHARACTER SUBR*8, STRING*16, PREFIX*5
      DOUBLE PRECISION SKY(3)
      LOGICAL   F, DOIT, EQUAL, DOERR
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      CALL COPY (256, CATBLK, CATSAV)
      LOCNUM = 1
      LIMTYP = 0
      CALL COPY (4, CATBLK(IICOR), IWIN(1,1))
      CALL COPY (4, CATBLP(IICOR), IWIN(1,2))
      CALL COPY (4, CATBLS(IICOR), IWIN(1,3))
      CALL COPY (4, CATBS2(IICOR), IWIN(1,4))
C                                       window for curvalue
      NPIX = 13 * CSIZTV(1)
      NROW = 5.5 * CSIZTV(2)
      IX0 = WINDTV(1) + 2*CSIZTV(1)
      IY0 = WINDTV(4) - NROW + 1 - 2*CSIZTV(2)
      IX1 = IX0 + NPIX - 1
      IY1 = IY0 + NROW - 1
      CALL YHOLD ('ONNN', IRET)
      SUBR = 'YZERO'
      CALL YZERO (GRMEBG, IRET)
      IF (IRET.NE.0) GO TO 990
      IF (NGRAPH.EQ.8) THEN
         CALL YZERO (GRBLAC, IRET)
         IF (IRET.NE.0) GO TO 990
         SUBR = 'YFILL'
         CALL YFILL (GRBLAC, IX0, IY0, IX1, IY1, 1, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         SUBR = 'YSLECT'
         CALL YSLECT ('ONNN', GRBLAC, 0, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
      SUBR = 'YSLECT'
      CALL YSLECT ('ONNN', GRMEBG, 0, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       cursor set up
      CALL ZTIME (ITW)
      PPOS(1) = (CATBLK(IICOR) + CATBLK(IICOR+2)) / 2.0
      PPOS(2) = (CATBLK(IICOR+1) + CATBLK(IICOR+3)) / 2.0
      RPOS(1) = PPOS(1)
      RPOS(2) = PPOS(2)
C                                       on cursor
      CALL YHOLD ('OFFF', IRET)
      SUBR = 'YCURSE'
      CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IRET)
      IF (IRET.NE.0) GO TO 990
      MSGTXT = 'Hit buttons C or D to stop'
      CALL MSGWRT (1)
      DOERR = .TRUE.
C                                       loop point
 20   SUBR = 'YCURSE'
      CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IRET)
      IF (IRET.NE.0) GO TO 990
      CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
C                                       do something
      IF (DOIT) THEN
C                                       exit
         IF (IBUT.GE.4) GO TO 900
C                                       which image?
         IMTYPE = 0
         IF ((SPECOK.GT.0) .AND. (TWOCUB)) THEN
            IF ((RPOS(1).GE.IWIN(1,4)) .AND. (RPOS(1).LE.IWIN(3,4))
     *         .AND. (RPOS(2).GE.IWIN(2,4)) .AND.
     *         (RPOS(2).LE.IWIN(4,4))) IMTYPE = 4
            END IF
         IF (SPECOK.GT.0) THEN
            IF ((RPOS(1).GE.IWIN(1,3)) .AND. (RPOS(1).LE.IWIN(3,3))
     *         .AND. (RPOS(2).GE.IWIN(2,3)) .AND.
     *         (RPOS(2).LE.IWIN(4,3))) IMTYPE = 3
            END IF
         IF ((TWOIMG) .AND.(CURPLN.GE.1) .AND. (CURPLN.LE.NZ2)) THEN
            IF ((RPOS(1).GE.IWIN(1,2)) .AND. (RPOS(1).LE.IWIN(3,2))
     *         .AND. (RPOS(2).GE.IWIN(2,2)) .AND.
     *         (RPOS(2).LE.IWIN(4,2))) IMTYPE = 2
            END IF
         IF ((RPOS(1).GE.IWIN(1,1)) .AND. (RPOS(1).LE.IWIN(3,1))
     *      .AND. (RPOS(2).GE.IWIN(2,1)) .AND.
     *       (RPOS(2).LE.IWIN(4,1))) IMTYPE = 1
         IF (IMTYPE.LE.0) GO TO 20
C                                       get coord system
         IF (IMTYPE.NE.LIMTYP) THEN
            IF (IMTYPE.EQ.4) THEN
               CALL COPY (256, CATBS2, CATBLK)
            ELSE IF (IMTYPE.EQ.3) THEN
               CALL COPY (256, CATBLS, CATBLK)
            ELSE IF (IMTYPE.EQ.2) THEN
               CALL COPY (256, CATBLP, CATBLK)
            ELSE
               CALL COPY (256, CATSAV, CATBLK)
               END IF
            CALL SETLOC (CATBLK(IIDEP), .FALSE.)
            LIMTYP = IMTYPE
            END IF
C                                       images
         IF (IMTYPE.LT.3) THEN
C                                       get image pixel coordinate
            CALL IMA2MP (PPOS, RPOS)
            LOCNUM = 1
            CALL XYVAL (RPOS(1), RPOS(2), SKY(1), SKY(2), SKY(3), IRET)
            IF (IRET.NE.0) THEN
               MSGTXT = 'BAD SKY COORDINATE XYVAL - TRY AGAIN'
               IF (DOERR) CALL MSGWRT (6)
               DOERR = .FALSE.
               GO TO 20
               END IF
C                                       curvalue
            CALL YHOLD ('ONNN', IRET)
            SUBR = 'YFILL'
            CALL YFILL (GRMEBG, IX0, IY0, IX1, IY1, 0, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 990
            IX = IROUND (RPOS(1))
            IY = IROUND (RPOS(2))
            IF (IMTYPE.EQ.1) THEN
               PIXVAL = IMAGE(IX,IY)
            ELSE
               PIXVAL = IMAGE2(IX,IY,CURPLN)
               END IF
            WRITE (STRING,1020) IX, IY
            IY = IY0 + 4.5 * CSIZTV(2)
            SUBR = 'IMCHAR'
            CALL IMCHAR (GRMEBG, IX0, IY, 0, 0, STRING(:13), SCRTCH,
     *         IRET)
            IF (IRET.NE.0) GO TO 990
            IY = IY - 1.5 * CSIZTV(2)
            IF (PIXVAL.NE.FBLANK) THEN
               CALL METSCA (PIXVAL, PREFIX, EQUAL)
               WRITE (STRING,1021) PIXVAL
               CALL IMCHAR (GRMEBG, IX0, IY, 0, 0, STRING(:10), SCRTCH,
     *            IRET)
               IF (IRET.NE.0) GO TO 990
               STRING = PREFIX
               CALL H2CHR (8, 1, CATH(KHBUN), STRING(6:))
            ELSE
               STRING = 'B  BLANKED'
               CALL IMCHAR (GRMEBG, IX0, IY, 0, 0, STRING(:10), SCRTCH,
     *            IRET)
               IF (IRET.NE.0) GO TO 990
               STRING = ' '
               CALL IMCHAR (GRMEBG, IX0, IY0, 0, 0, STRING(:13), SCRTCH,
     *            IRET)
               STRING = ' '
               END IF
            IY = IY - 1.5 * CSIZTV(2)
            CALL IMCHAR (GRMEBG, IX0, IY, 0, 0, STRING(:13), SCRTCH,
     *         IRET)
            IF (IRET.NE.0) GO TO 990
            STRING = ' '
            IF (IMTYPE.EQ.2) WRITE (STRING,1022) CURPLN
            CALL IMCHAR (GRMEBG, IX0, IY0, 0, 0, STRING(:13), SCRTCH,
     *         IRET)
            IF (IRET.NE.0) GO TO 990
            CALL YHOLD ('OFFF', IRET)
C                                       spectra plots
         ELSE
            IBCHAN = CATBLK(IIWIN)
            IECHAN = CATBLK(IIWIN+2)
            X = IBCHAN + ((RPOS(1) - IWIN(1,IMTYPE)) /
     *         (IWIN(3,IMTYPE) - IWIN(1,IMTYPE))) * (IECHAN - IBCHAN)
            I = X + 0.5
            IF (IMTYPE.EQ.3) THEN
               PIXVAL = SPECTR(I)
            ELSE
               PIXVAL = SPECT2(I)
               END IF
            WRITE (STRING,1020) LASTYZ(1), LASTYZ(2)
            IY = IY0 + 4.5 * CSIZTV(2)
            CALL YHOLD ('ONNN', IRET)
            SUBR = 'IMCHAR'
            CALL IMCHAR (GRMEBG, IX0, IY, 0, 0, STRING(:13), SCRTCH,
     *         IRET)
            IF (IRET.NE.0) GO TO 990
            IY = IY - 1.5 * CSIZTV(2)
            IF (PIXVAL.NE.FBLANK) THEN
               CALL METSCA (PIXVAL, PREFIX, EQUAL)
               WRITE (STRING,1021) PIXVAL
               CALL IMCHAR (GRMEBG, IX0, IY, 0, 0, STRING(:10), SCRTCH,
     *            IRET)
               IF (IRET.NE.0) GO TO 990
               STRING = PREFIX
               CALL H2CHR (8, 1, CATH(KHBUN), STRING(6:))
            ELSE
               STRING = 'B  BLANKED'
               CALL IMCHAR (GRMEBG, IX0, IY, 0, 0, STRING(:10), SCRTCH,
     *            IRET)
               IF (IRET.NE.0) GO TO 990
               STRING = ' '
               CALL IMCHAR (GRMEBG, IX0, IY0, 0, 0, STRING(:13), SCRTCH,
     *            IRET)
               STRING = ' '
               END IF
            IY = IY - 1.5 * CSIZTV(2)
            CALL IMCHAR (GRMEBG, IX0, IY, 0, 0, STRING(:13), SCRTCH,
     *         IRET)
            IF (IRET.NE.0) GO TO 990
            WRITE (STRING,1023) I, LASTYZ(3)
            CALL IMCHAR (GRMEBG, IX0, IY0, 0, 0, STRING(:13), SCRTCH,
     *         IRET)
            IF (IRET.NE.0) GO TO 990
            CALL YHOLD ('OFFF', IRET)
            END IF
         END IF
      GO TO 20
C                                       shut down nicely
 900  CALL YHOLD ('ONNN', I)
      CALL YCURSE ('OFFF', F, F, PPOS, QUAD, IBUT, I)
      SUBR = 'YSLECT'
      CALL YSLECT ('OFFF', GRMEBG, 0, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 990
      IF (NGRAPH.EQ.8) THEN
         CALL YSLECT ('OFFF', GRBLAC, 0, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
      CALL COPY (256, CATSAV, CATBLK)
      GO TO 999
C                                       error
 990  WRITE (MSGTXT,1990) IRET, SUBR
      CALL MSGWRT (8)
      CALL COPY (256, CATSAV, CATBLK)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('X=',I4,' Y=',I4)
 1021 FORMAT ('B=',F8.3)
 1022 FORMAT ('Z=',I4)
 1023 FORMAT ('Z=',I4,' R=',I4)
 1990 FORMAT ('TVSPCV ERROR',I4,' RETURNED FROM ',A)
      END
      SUBROUTINE TVSPLA (IRET)
C-----------------------------------------------------------------------
C   TVSPLA draws labels on the grey scale image(s)
C   Output:
C      IRET     I      Error return
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'TVSPC.INC'
      INTEGER   CATSAV(256), IBUFF1(MABFSS), ILAB, NZ2, IGR
      LOGICAL   DOGRID
      CHARACTER SUBR*8
      EQUIVALENCE (IBUFF1, BUFF1)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL COPY (256, CATBLK, CATSAV)
C                                       zero graphics
      SUBR = 'YZERO'
      CALL YZERO (GRLABL, IRET)
      IF (IRET.NE.0) GO TO 990
      IF (NGRAPH.EQ.8) THEN
         CALL YZERO (GRBLAC, IRET)
         IF (IRET.NE.0) GO TO 990
         SUBR = 'YSLECT'
         CALL YSLECT ('ONNN', GRBLAC, 0, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         END IF
      SUBR = 'YSLECT'
      CALL YSLECT ('ONNN', GRLABL, 0, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       parameters, main image
      NZ2 = CATBL4(KINAX+2)
      ILAB = 7
      DOGRID = DOLABL.EQ.2
      IGR = GRLABL - NGRAY
      SUBR = 'IAXIS1'
      CALL IAXIS1 (IBUFF1, ILAB, IGR, 0, DOGRID, IRET)
      IF (IRET.NE.0) GO TO 990
      IF (CBPLOT.GT.0) CALL ICBPLT (IBUFF1, CBPLOT, IGR, -1, IRET)
      IF (IRET.GT.0) GO TO 999
C                                       second image
      IF ((CURPLN.GE.1) .AND. (CURPLN.LE.NZ2)) THEN
         CALL COPY (256, CATBLP, CATBLK)
         LOCNUM = 1
         CALL SETLOC (CATBLK(IIDEP), .FALSE.)
         CALL IAXIS1 (IBUFF1, ILAB, IGR, 0, DOGRID, IRET)
         IF (IRET.NE.0) GO TO 990
         IF (CBPLOT.GT.0) CALL ICBPLT (IBUFF1, CBPLOT, IGR, -1, IRET)
         IF (IRET.GT.0) GO TO 999
         CALL COPY (256, CATSAV, CATBLK)
         LOCNUM = 1
         CALL SETLOC (CATBLK(IIDEP), .FALSE.)
         END IF
      GO TO 999
C                                       error
 990  WRITE (MSGTXT,1990) IRET, SUBR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1990 FORMAT ('TVSPLA ERROR',I5,' FROM ROUTINE ',A)
      END
      SUBROUTINE TVPMRK (IRET)
C-----------------------------------------------------------------------
C   Place a mark on the spectra plot showing where the displayed plane
C   lies
C   Output:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'TVSPC.INC'
      CHARACTER SUBR*8
      INTEGER   IWIN(4), IXC(2), IYC(2), LXC(2,2), LYC(2,2)
      REAL      IBCHAN, IECHAN, X
      SAVE LXC, LYC
      DATA LXC, LYC /8 * 0/
C-----------------------------------------------------------------------
      IRET = 0
      IF ((CURPLN.LE.0) .OR. (CURCHN.LE.0)) GO TO 999
C                                       do the marking: simple
      IF (.NOT.TWOCUB) THEN
         SUBR = 'YZERO'
         CALL YZERO (GRSPC2, IRET)
         IF (IRET.NE.0) GO TO 990
         SUBR = 'YSLECT'
         CALL YSLECT ('ONNN', GRSPC2, 0, SCRTCH, IRET)
         IF (IRET.NE.0) GO TO 990
         IBCHAN = CATBLS(IIWIN)
         IECHAN = CATBLS(IIWIN+2)
         CALL COPY (4, CATBLS(IICOR), IWIN)
         IYC(1) = IWIN(2)
         IYC(2) = IWIN(4)
         IF ((CURCHN.GE.IBCHAN) .AND. (CURCHN.LE.IECHAN)) THEN
            X = (CURCHN-IBCHAN) * (IWIN(3)-IWIN(1)) / (IECHAN-IBCHAN) +
     *         IWIN(1)
            IXC(1) = X + 0.5
            IXC(2) = IXC(1)
            SUBR = 'IMVECT'
            CALL IMVECT ('ONNN', GRSPC2, 2, IXC(1), IYC, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 990
            END IF
C                                       mark on both
      ELSE
         SUBR = 'IMVECT'
         IF (LXC(1,1).GT.0) THEN
            CALL IMVECT ('OFFF', GRSPC2, 2, LXC(1,1), LYC(1,1), SCRTCH,
     *         IRET)
            IF (IRET.NE.0) GO TO 990
            LXC(1,1) = 0
            END IF
         IF (LXC(1,2).GT.0) THEN
            CALL IMVECT ('OFFF', GRSPC1, 2, LXC(1,2), LYC(1,2), SCRTCH,
     *         IRET)
            IF (IRET.NE.0) GO TO 990
            LXC(1,2) = 0
            END IF
         IBCHAN = CATBLS(IIWIN)
         IECHAN = CATBLS(IIWIN+2)
         IF ((CURCHN.GE.IBCHAN) .AND. (CURCHN.LE.IECHAN)) THEN
            CALL COPY (4, CATBLS(IICOR), IWIN)
            IYC(1) = IWIN(2)
            IYC(2) = IWIN(4)
            X = (CURCHN-IBCHAN) * (IWIN(3)-IWIN(1)) / (IECHAN-IBCHAN) +
     *         IWIN(1)
            IXC(1) = X + 0.5
            IXC(2) = IXC(1)
            CALL IMVECT ('ONNN', GRSPC2, 2, IXC(1), IYC, SCRTCH, IRET)
            IF (IRET.NE.0) GO TO 990
            LXC(1,1) = IXC(1)
            LXC(2,1) = IXC(2)
            LYC(1,1) = IYC(1)
            LYC(2,1) = IYC(2)
C                                       two overlap
            IF (APARM(6).LE.0.0) THEN
               CALL IMVECT ('ONNN', GRSPC1, 2, IXC(1), IYC, SCRTCH,
     *            IRET)
               IF (IRET.NE.0) GO TO 990
C                                       separated
            ELSE
               IBCHAN = CATBS2(IIWIN)
               IECHAN = CATBS2(IIWIN+2)
               CALL COPY (4, CATBS2(IICOR), IWIN)
               IYC(1) = IWIN(2)
               IYC(2) = IWIN(4)
               X = (CURCHN-IBCHAN) * (IWIN(3)-IWIN(1)) / (IECHAN-IBCHAN)
     *            + IWIN(1)
               IXC(1) = X + 0.5
               IXC(2) = IXC(1)
               SUBR = 'IMVECT'
               CALL IMVECT ('ONNN', GRSPC1, 2, IXC(1), IYC, SCRTCH,
     *            IRET)
               IF (IRET.NE.0) GO TO 990
               LXC(1,2) = IXC(1)
               LXC(2,2) = IXC(2)
               LYC(1,2) = IYC(1)
               LYC(2,2) = IYC(2)
               END IF
            END IF
         END IF
      GO TO 999
C
 990  WRITE (MSGTXT,1990) IRET, SUBR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1990 FORMAT ('TVPMRK ERROR',I5,' ON TV FUNCTION ',A)
      END
      SUBROUTINE TVSPSL (IRET)
C-----------------------------------------------------------------------
C   TVSPSL takes the spectrum (with any Gaussian fit) and writes it to
C   a slice file
C   Outputs:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'TVSPC.INC'
      INTEGER   CATSAV(256), IWBLK(512), NRPBLK, NREC, INOSL, IVER, LUN,
     *   IND, IP, IREC, KREC, I, J, K
      REAL      RWBLK(512), DELTA, DMAX, DMIN
      DOUBLE PRECISION DWBLK(256)
      HOLLERITH HWBLK(512)
      CHARACTER UNITS*16
      EQUIVALENCE (DWBLK, RWBLK, IWBLK, HWBLK)
      DATA LUN /73/
C-----------------------------------------------------------------------
C                                       get cube's real header
      CALL COPY (256, CATBLK, CATSAV)
      CALL COPY (256, CATBL2, CATBLK)
C                                       init SL
      CALL FNDEXT ('SL', CATBLK, IVER)
      IVER = IVER + 1
      NRPBLK = 256
      INOSL = CATBLK(KINAX)
      NREC = (INOSL - 1) / NRPBLK + 3
      IF (NGAUSS.GT.0) NREC = NREC + 1
      CALL FILL (256, 0, IWBLK)
      CALL EXTINI ('WRIT', 'SL', VOL2, SLOT2, IVER, CATBLK, LUN, IND,
     *   NRPBLK, NREC, IWBLK, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT SL FILE'
         GO TO 990
         END IF
      WRITE (MSGTXT,1005) IVER
      CALL MSGWRT (3)
C                                       update header record
      CALL ZFIO ('READ', LUN, IND, 1, IWBLK, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ INITIAL SL HEADER'
         GO TO 990
         END IF
      CALL CHR2H (6, TSKNAM, 1, HWBLK(30))
      CALL ZDATE (IWBLK(33))
      CALL ZTIME (IWBLK(36))
      IWBLK(57) = INOSL
      IF (NGAUSS.GT.0) THEN
         IWBLK(58) = 1
      ELSE
         IWBLK(58) = 0
         END IF
      IWBLK(59) = NREC
      CALL ZFIO ('WRIT', LUN, IND, 1, IWBLK, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'UPDATE SL HEADER'
         GO TO 990
         END IF
C                                       Put inputs in 2nd record.
      CALL FILL (256, 0, IWBLK)
      CALL CHR2H (6, TSKNAM, 1, HWBLK(1))
      CALL ZDATE (IWBLK(4))
      CALL ZTIME (IWBLK(7))
      IWBLK(10) = 23
C                                       fake up SLICE adverbs
      RWBLK(11) = NLUSER
      CALL RCOPY (7, XNAMI2, RWBLK(12))
      CALL RFILL (14, 1.0, RWBLK(19))
      RWBLK(20) = LASTYZ(1)
      RWBLK(21) = LASTYZ(2)
      RWBLK(26) = INOSL
      RWBLK(27) = LASTYZ(1)
      RWBLK(28) = LASTYZ(2)
      CALL CHR2H (4, 'AVER', 1, HWBLK(33))
      CALL ZFIO ('WRIT', LUN, IND, 2, IWBLK, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'WRITE RECORD 2 IN SL FILE'
         GO TO 990
         END IF
      KREC = (INOSL - 1) / NRPBLK + 3
      IP = 1
      DMAX = -1.E10
      DMIN = 1.E10
      DO 20 IREC = 3,KREC
         DO 15 K = 1,256
            RWBLK(K) = SPECTR(IP)
            IF (SPECTR(IP).NE.FBLANK) THEN
               DMIN = MIN (DMIN, SPECTR(IP))
               DMAX = MAX (DMAX, SPECTR(IP))
               END IF
            IP = IP + 1
 15         CONTINUE
         CALL ZFIO ('WRIT', LUN, IND, IREC, IWBLK, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE DATA RECORD IN SL FILE'
            GO TO 990
            END IF
 20      CONTINUE
C                                       Gaussian fit
      IF (NGAUSS.GT.0) THEN
         IREC = KREC + 1
         CALL FILL (256, 0, IWBLK)
         CALL RCOPY (24, GAUSS, RWBLK(1))
         DO 25 I = 1,JJC
            RWBLK(82+I) = GAUSS(12+I,1)
            RWBLK(85+I) = GAUSS(12+I,2)
 25         CONTINUE
         IWBLK(25) = IDROP(1)
         IWBLK(26) = IDROP(2)
         IWBLK(27) = NGAUSS
         CALL ZDATE (IWBLK(28))
         CALL ZTIME (IWBLK(31))
         RWBLK(46) = GRMS
         J = 50
         DELTA = CATR(KRCIC)
         DO 30 I = 1,NGAUSS
            K = (I - 1) * 3 + 1
            RWBLK(J+1) = GAUSS(K,1)
            RWBLK(J+2) = GAUSS(K,2)
            RWBLK(J+3) = (GAUSS(K+1,1) - CATR(KRCRP)) * DELTA +
     *         CATD(KDCRV)
            RWBLK(J+4) = GAUSS(K+1,2) * ABS(DELTA)
            RWBLK(J+5) = GAUSS(K+2,1) * ABS(DELTA)
            RWBLK(J+6) = GAUSS(K+2,2) * ABS(DELTA)
            J = J + 6
 30         CONTINUE
         UNITS = ' '
         CALL H2CHR (8, 1, CATH(KHBUN), UNITS)
         CALL CHR2H (16, UNITS, 1, HWBLK(75))
         UNITS = ' '
         CALL H2CHR (8, 1, CATH(KHCTP), UNITS)
         CALL CHR2H (16, UNITS, 1, HWBLK(79))
         CALL ZFIO ('WRIT', LUN, IND, IREC, IWBLK, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITE MODEL RECORD IN SL FILE'
            GO TO 990
            END IF
         END IF
C                                       update record 2
C                                       update header record
      CALL ZFIO ('READ', LUN, IND, 2, IWBLK, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ SL RECORD 2'
         GO TO 990
         END IF
      RWBLK(34) = DMIN
      RWBLK(35) = DMAX
      CALL ZFIO ('WRIT', LUN, IND, 2, IWBLK, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'UPDATE SL RECORD 2'
         GO TO 990
         END IF
      CALL ZCLOSE (LUN, IND, I)
      GO TO 995
C
 990  CALL MSGWRT (8)
C
 995  CALL COPY (256, CATBLK, CATBL2)
      CALL COPY (256, CATSAV, CATBLK)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TVSPSL ERROR',I5,' ON ',A)
 1005 FORMAT ('Created SLice file version',I5)
      END
      SUBROUTINE TVSFIT (IRET)
C-----------------------------------------------------------------------
C   TVSFIT asks the user to point at the Gaussian peaks and half-widths
C   and then attempts a Gaussian fit.
C   Outputs:
C      IRET   I   > 0 -> hard error, -1 -> fit fails
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'TVSPC.INC'
      INTEGER   QUAD, BUTTON, NPTS, IPVT(15), WSIZE, I, INFO, J, INPARM,
     *   N, IBC, IEC
      REAL      RPOS(2), X, Y, W, XSC, YSC
      DOUBLE PRECISION PARMS(15), TOL, FJAC(15,15), FVEC(MAXIMG),
     *   WORK(MAXIMG+200), EPARMS(15), FNORM, ENORM
      EXTERNAL GFUNC
      CHARACTER SUBR*8, BLTYPE(3)*9
      DATA BLTYPE /'Constant', 'Slope', 'Curvature'/
C-----------------------------------------------------------------------
      NGAUSS = 0
      CALL RFILL (30, 0.0, GAUSS)
      CALL YZERO (GRMODL, IRET)
      IF (IRET.NE.0) GO TO 990
      CALL YZERO (GRESID, IRET)
      IF (IRET.NE.0) GO TO 990
      CALL DFILL (15, 0.0D0, PARMS)
C                                       Open, read, close Tektronix.
 10   WRITE (MSGTXT,1010) NGAUSS+1
      CALL MSGWRT (1)
      WRITE (MSGTXT,1011)
      CALL MSGWRT (1)
      CALL YCURSE ('READ', .TRUE., .TRUE., RPOS, QUAD, BUTTON, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'READ CURSOR'
         GO TO 990
         END IF
      IF (BUTTON.LT.4) THEN
         IF ((RPOS(1).LT.CATBLS(IICOR)) .OR.
     *      (RPOS(1).GT.CATBLS(IICOR+2)) .OR.
     *      (RPOS(2).LT.CATBLS(IICOR+1)) .OR.
     *      (RPOS(2).GT.CATBLS(IICOR+3))) THEN
            MSGTXT = 'CURSOR NOT IN SLICE'
            CALL MSGWRT (6)
            GO TO 10
         ELSE
            X = (CATBLS(IIWIN+2) - CATBLS(IIWIN)) *
     *         (RPOS(1) - CATBLS(IICOR)) /
     *         (CATBLS(IICOR+2) - CATBLS(IICOR)) + CATBLS(IIWIN)
            Y = (CATRS(IRRAN+1) - CATRS(IRRAN)) *
     *         (RPOS(2) - CATBLS(IICOR+1)) /
     *         (CATBLS(IICOR+3) - CATBLS(IICOR+1)) + CATRS(IRRAN)
            END IF
         WRITE (MSGTXT,1012) NGAUSS+1
         CALL MSGWRT (1)
         CALL YCURSE ('READ', .TRUE., .TRUE., RPOS, QUAD, BUTTON, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READ CURSOR'
            GO TO 990
            END IF
         IF (BUTTON.LT.4) THEN
            IF ((RPOS(1).LT.CATBLS(IICOR)) .OR.
     *         (RPOS(1).GT.CATBLS(IICOR+2)) .OR.
     *         (RPOS(2).LT.CATBLS(IICOR+1)) .OR.
     *         (RPOS(2).GT.CATBLS(IICOR+3))) THEN
               MSGTXT = 'CURSOR NOT IN SLICE'
               CALL MSGWRT (6)
               GO TO 10
            ELSE
               W = (CATBLS(IIWIN+2) - CATBLS(IIWIN)) *
     *            (RPOS(1) - CATBLS(IICOR)) /
     *            (CATBLS(IICOR+2) - CATBLS(IICOR)) + CATBLS(IIWIN)
               W = 2.0 * ABS (X - W)
               J = 3 * NGAUSS
               PARMS(J+1) = Y
               PARMS(J+2) = X
               PARMS(J+3) = W
               NGAUSS = NGAUSS + 1
               IF (NGAUSS.LT.4) GO TO 10
               END IF
            END IF
         END IF
      IF (NGAUSS.LE.0) THEN
         MSGTXT = 'No Gaussians specified, return to menu'
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       have read in comps
      IBC = CATBLS(IIWIN)
      IEC = CATBLS(IIWIN+2)
      N = IEC - IBC + 1
      IDROP(1) = IBC - 1
      IDROP(2) = CATBL2(KINAX) - IEC
      JJC = APARM(9) + 0.1
      JJC = MAX (0, MIN (3, JJC))
      XCEN = (IBC + IEC) / 2.0
      TOL = 1.D-5
      ITTER = 0
      NPTS = 0
      DO 110 I = IBC,IEC
         IF (SPECTR(I).NE.FBLANK) THEN
            NPTS = NPTS + 1
            SLDATA(NPTS) = SPECTR(I)
            SLPOS(NPTS) = I
            END IF
 110     CONTINUE
C                                       Fit gaussians using guess.
      INPARM = 3 * NGAUSS + JJC
      WSIZE = MAXIMG+200
      CALL LMSTR1 (GFUNC, NPTS, INPARM, PARMS, FVEC, FJAC, 15,
     *   TOL, INFO, IPVT, WORK, WSIZE)
      IF ((INFO.LT.1) .OR. (INFO.GT.3)) THEN
         WRITE (MSGTXT,1110) INFO
         IRET = -1
         NGAUSS = 0
         GO TO 990
         END IF
C                                       errors
      FNORM = ENORM (NPTS, FVEC)
      GRMS = FNORM
      CALL GETERR (IPVT, FJAC, EPARMS, INPARM, NPTS, 15, FNORM, WORK,
     *   TOL)
C                                       squirrel away answers
      J = 3*NGAUSS
      DO 120 I = 1,J
         GAUSS(I,1) = PARMS(I)
         GAUSS(I,2) = EPARMS(I)
 120     CONTINUE
      DO 121 I = 1,JJC
         GAUSS(12+I,1) = PARMS(J+I)
         GAUSS(12+I,2) = EPARMS(J+I)
 121     CONTINUE
C                                       display results
      WRITE (MSGTXT,1120)
      CALL MSGWRT (4)
      J = 0
      DO 130 I = 1,NGAUSS
         WRITE (MSGTXT,1121) I, GAUSS(J+1,1), GAUSS(J+1,2),
     *      GAUSS(J+2,1), GAUSS(J+2,2), GAUSS(J+3,1), GAUSS(J+3,2)
         CALL MSGWRT (4)
         J = J + 3
 130     CONTINUE
      DO 135 I = 1,JJC
         WRITE (MSGTXT,1122) BLTYPE(I), GAUSS(12+I,1), GAUSS(12+I,2)
         CALL MSGWRT (4)
 135     CONTINUE
C                                       plot model, residual
      DO 150 I = IBC,IEC
         X = 0.0
         DO 140 J = 1,INPARM,3
            Y = 2.7720 * (I - GAUSS(J+1,1))**2
            W = GAUSS(J+2,1)**2
            X = X + GAUSS(J,1) * EXP (-Y/W)
 140        CONTINUE
         IF (JJC.GT.0) X = X + GAUSS(13,1) + GAUSS(14,1) * (I-XCEN) +
     *      GAUSS(15,1) * (I-XCEN) * (I-XCEN)
         SLDATA(I) = X
 150     CONTINUE
      SUBR = 'YSLECT'
      CALL YSLECT ('ONNN', GRMODL, 0, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL YSLECT ('ONNN', GRESID, 0, SCRTCH, IRET)
      IF (IRET.NE.0) GO TO 980
      SUBR = 'YZERO'
      CALL YZERO (GRMODL, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL YZERO (GRESID, IRET)
      IF (IRET.NE.0) GO TO 980
      XSC = REAL (CATBLS(IICOR+2) - CATBLS(IICOR)) /
     *   REAL (CATBLS(IIWIN+2) - CATBLS(IIWIN))
      YSC = REAL (CATBLS(IICOR+3) - CATBLS(IICOR+1)) /
     *   (CATRS(IRRAN+1) - CATRS(IRRAN))
      DO 160 I = IBC,IEC
         J = I - IBC + 1
         X = XSC * (I - IBC) + CATBLS(IICOR)
         Y = YSC * (SLDATA(I) - CATRS(IRRAN)) + CATBLS(IICOR+1)
         IBUFF(J) = X + 0.5
         JBUFF(J) = Y + 0.5
         JBUFF(J) = MAX (CATBLS(IICOR+1), MIN (CATBLS(IICOR+3),
     *      JBUFF(J)))
 160     CONTINUE
      CALL IMVECT ('ONNN', GRMODL, N, IBUFF, JBUFF, SCRTCH, IRET)
      SUBR = 'IMVECT'
      IF (IRET.NE.0) GO TO 980
      DO 170 I = IBC,IEC
         J = I - IBC + 1
         Y = YSC * (SPECTR(I) - SLDATA(I) - CATRS(IRRAN)) +
     *      CATBLS(IICOR+1)
         JBUFF(J) = Y + 0.5
         JBUFF(J) = MAX (CATBLS(IICOR+1), MIN (CATBLS(IICOR+3),
     *      JBUFF(J)))
 170     CONTINUE
      CALL IMVECT ('ONNN', GRESID, N, IBUFF, JBUFF, SCRTCH, IRET)
      SUBR = 'IMVECT'
      IF (IRET.NE.0) GO TO 980
      GO TO 999
C
 980  WRITE (MSGTXT,1980) IRET, SUBR
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TVSFIT: ERROR',I5,' ON ',A)
 1010 FORMAT ('Position cursor at peak of Gaussian',I2)
 1011 FORMAT ('Hit buttons A or B to continue, hit C or D to quit')
 1012 FORMAT ('Position cursor at half-power of Gaussian',I2)
 1110 FORMAT ('FITTING ROUTINE RETURNS',I4,' RETURN TO MENU')
 1120 FORMAT ('N',4X,'Peak',6X,'+-',9X,'Center',4X,'+-',7X,'Width',
     *   2X,'+-')
 1121 FORMAT (I1,F12.6,F10.6,F10.3,F8.3,F9.3,F7.3)
 1122 FORMAT ('BL ',A9,2X,1PE13.4,' +-',1PE10.2)
 1980 FORMAT ('TVSFIT ERROR',I4,' ON TV FUNCTION ',A)
      END
      SUBROUTINE GFUNC (M, N, PARMS, FVEC, FJROW, IFLAG)
C-----------------------------------------------------------------------
C   This routine is called by the Argonne package to calculate the
C   difference between the current fit and the actual data OR the
C   Jacobian for this difference.
C   Inputs:
C      M        I      Number of data points in slice (adj. array.dim.).
C      N        I      No. of parameters (adj. array. dim. NGAUSS * 3 + JJC)
C      PARMS    D(N)   Parameters of Gaussian components,
C                         GMAX(1), GPOS(1), GWIDTH(1), GMAX(2), ...
C      IFLAG    I      1=calculate difference for current guess.
C                      2=calculate jacobian for current guess.
C   Common:
C      DATA     R(*)   Original slice data points.
C      ITTER    I      number of calls to evaluate FVEC.
C   Outputs:
C     FVEC     D(M)   Slice data points minus data points evaluated for
C                     current guess.
C     FJROW    D(N)   Row (IFLAG - 1) of Jacobian.
C-----------------------------------------------------------------------
      INTEGER   N, M, IFLAG
      DOUBLE PRECISION PARMS(N), FVEC(M), FJROW(N)
C
      DOUBLE PRECISION AMP, POS, SIG, EFACT, RES2, TSIG2, X
      INTEGER   IGAUSS, IDATA, IAMP, IPOS, ISIG, K, NGAUS
      INCLUDE 'TVSPC.INC'
C-----------------------------------------------------------------------
C                                       Determine difference between
C                                       data and current fit.
      NGAUS = N - JJC
      IF (IFLAG.LE.1) THEN
         ITTER = ITTER + 1
         DO 20 IDATA = 1,M
            FVEC(IDATA) = SLDATA(IDATA)
            DO 15 IGAUSS = 3,NGAUS,3
               IAMP = IGAUSS-2
               IPOS = IGAUSS-1
               ISIG = IGAUSS
               AMP = PARMS(IAMP)
               POS = PARMS(IPOS)
               SIG = PARMS(ISIG)
               X = SLPOS(IDATA)
               RES2 = 2.772D0 * (X - POS)**2
               TSIG2 = SIG**2
               EFACT = EXP (-1.D0 * RES2 / TSIG2)
               FVEC(IDATA) = FVEC(IDATA) - AMP*EFACT
   15          CONTINUE
            IF (JJC.GE.1) FVEC(IDATA) = FVEC(IDATA) - PARMS(NGAUS+1)
            IF (JJC.GE.2) FVEC(IDATA) = FVEC(IDATA) - PARMS(NGAUS+2) *
     *         (IDATA - XCEN)
            IF (JJC.GE.3) FVEC(IDATA) = FVEC(IDATA) - PARMS(NGAUS+3) *
     *         (IDATA - XCEN) * (IDATA - XCEN)
   20       CONTINUE
C                                       Calculate Jacobian.
      ELSE
         IDATA = IFLAG - 1
         K = 0
         DO 110 IGAUSS = 3,NGAUS,3
            K = K + 1
            IAMP = IGAUSS-2
            IPOS = IGAUSS-1
            ISIG = IGAUSS
            AMP = PARMS(IAMP)
            POS = PARMS(IPOS)
            SIG = PARMS(ISIG)
            X = SLPOS(IDATA)
            RES2 = 2.772 * (X - POS)**2
            TSIG2 = SIG**2
            EFACT = EXP (-1.D0 * RES2 / TSIG2)
            FJROW(IAMP) = 0.0D0
            FJROW(IAMP) = -EFACT
            FJROW(IPOS) = 0.0D0
            FJROW(IPOS) = -5.544D0 * AMP * EFACT * (X - POS) / (SIG*SIG)
            FJROW(ISIG) = 0.0D0
            FJROW(ISIG) = -2.D0 * AMP * EFACT * RES2 / (SIG ** 3)
 110        CONTINUE
         IF (JJC.GE.1) FJROW(NGAUS+1) = -1.0
         IF (JJC.GE.2) FJROW(NGAUS+2) = -(IDATA - XCEN)
         IF (JJC.GE.3) FJROW(NGAUS+3) = -(IDATA - XCEN) * (IDATA - XCEN)
         END IF
C
 999  RETURN
      END
      SUBROUTINE GETERR (IPVT, FJAC, PARERR, MPARMS, NDATA, MDATA,
     *   FNORM, WA, TOL)
C-----------------------------------------------------------------------
C   This subroutine for GAUSS calculates the errors on the fitted
C   parameters.
C   Inputs:
C      IPVT    I(MPARMS)   Defines a permutation matrix P such that
C                       JAC*P = Q*R, where JAC is the final calculated
C                       Jacobian, Q is
C                   orthogonal (not stored), and R is upper triangular
C                   with diagonal elements of nonincreasing magnitude.
C                   column J of P is column IPVT(J) of the identity
C                   matrix. (See FJAC below).
C           FJAC    D(MDATA,MPARMS)   The upper MPARMS by MPARMS sub-
C                   matrix of FJAC contains an upper triangular matrix
C                   R with diagonal elements of nonincreasing magnitude
C                   such that
C
C                    T     T           T
C                   P *(JAC *JAC)*P = R *R,
C
C                   where P is a permutation matrix and JAC is the final
C                   calculated Jacobian. Column J of P is column IPVT(J)
C                   (see above) of the identity matrix.
C           MPARMS  I Number of parameters in fitted function (adj.
C                   array dim.).
C           NDATA   I   Number of data points fitted.
C           MDATA   I Maximum no. of data points allowed for in
C                   FJAC (adj. array dim.).
C           FNORM   D   Euclidian norm of solution vector.
C           WA      D(MPARMS)   work array.
C  OUTPUT:  PARERR  D(MPARMS)   error in fitted parameters.
C           TOL     D   tolerance used in call to LMDER1.
C-----------------------------------------------------------------------
      INTEGER   MDATA, MPARMS, NDATA, IPVT(MPARMS)
      DOUBLE PRECISION FJAC(MDATA,MPARMS), PARERR(MPARMS), FNORM,
     *   WA(MPARMS), TOL
C
      INTEGER   IPARMS, J, NPARMS
      DOUBLE PRECISION EPSILN
C-----------------------------------------------------------------------
C                                       Calculate error following
C                                       Argonne write up
      NPARMS = MPARMS
C                                       Is this right ??????
      EPSILN = FNORM / SQRT(REAL(NDATA-NPARMS))
      IPARMS = NPARMS
      CALL COVAR (IPARMS, FJAC, MDATA, IPVT, TOL, WA)
      DO 10 J = 1,NPARMS
         PARERR(J) = EPSILN * SQRT(FJAC(J,J))
 10      CONTINUE
C
      RETURN
      END

      SUBROUTINE HENCOO (PRGNAM, NAMEOT, CLASOT, SEQOT, DISKOT,
     *   IHLUN, IOBLK, IERR)
C-----------------------------------------------------------------------
C! adds OUTNAME, OUTCLASS, OUTSEQ, OUTDISK to an open history file
C# History
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   HENCOO will add OUTNAME, OUTCLASS, OUTSEQ, OUTDISK values to an
C   open history file.
C   Inputs:
C      PRGNAM    C*6     task or verb name
C      NAMEOT    C*12    OUTNAME value
C      CLASOT    C*6     OUTCLASS value
C      SEQOT     I       OUTSEQ value
C      DISKOT    I       OUTDISK value
C      IHLUN     I       logical unit no. of an open history file
C   In/out:
C      IOBLK     I(256)  history work I/O buffer
C   Output:
C      IERR      I       error returned from HIADD. 0=ok
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6, NAMEOT*12, CLASOT*6
      INTEGER  SEQOT, DISKOT, IHLUN, IOBLK(256), IERR
C
      CHARACTER HILINE*72
C-----------------------------------------------------------------------
      WRITE (HILINE,1000) PRGNAM, NAMEOT, CLASOT
      CALL HIADD (IHLUN, HILINE, IOBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE (HILINE,1010) PRGNAM, SEQOT, DISKOT
      CALL HIADD (IHLUN, HILINE, IOBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (A6,'OUTNAME=''',A12,'''',3X,'OUTCLASS=''',A6,'''')
 1010 FORMAT (A6,'OUTSEQ=',I5,3X,'OUTDISK=',I3)
      END

      SUBROUTINE QMULCL (COMP, FLDECS, ABEAM, BBEAM, NCOMP)
C-----------------------------------------------------------------------
C! FPS AP version: Higher lever Clark CLEAN routine
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FPS AP version
C   Calls B. Clark's QCLNSU routine multiple times to
C   accumulate a number of CLEAN components in one AP call.
C     Inputs:
C      COMP  I  Base address of component vector 4 words per comp.:
C                  1 = component intensity.
C                  2 = x location (cells)
C                  3 = y location (cells)
C                  4 = field number
C                  NOTE: this vector is the output of this routine.
C      FLDESC I  Field descriptor vector base address.
C                  0 = Number of fields (REAL value)
C                   for each field:
C                  0 = Start address of residuals (REAL value) (AMAP)
C                     (location,intensity), intensity=2**14*x + y
C                  1 = Number of points in the map. (REAL value) (LMAP)
C                  2 = Current max. flux density (loc = FCOMP)
C                  3 = X position of current max.
C                  4 = Y position of current max.
C                  5 = CLEAN gain
C   ABEAM     I  Base address of the square (folded) beam patch.
C                  The Y direction is most rapid variable:-BY<Y<BY,
C                  X varies less rapidly, -1<X<BX
C   BBEAM     I  Beam description vector (BX,BY).
C                  In the current QCLNSU BX must equal BY.
C   NCOMP     I  Number of components to CLEAN.
C-----------------------------------------------------------------------
      INTEGER COMP, FLDECS, ABEAM, BBEAM, NCOMP
      INTEGER*2 ICOMP, IFLDEC, IABEAM, IBBEAM, INCOMP
C-----------------------------------------------------------------------
C                                        Convert inputs to unsigned I*2
      IF (COMP.LT.32768) ICOMP = COMP
      IF (COMP.GE.32768) ICOMP = COMP - 65536
      IF (FLDECS.LT.32768) IFLDEC = FLDECS
      IF (FLDECS.GE.32768) IFLDEC = FLDECS - 65536
      IF (ABEAM.LT.32768) IABEAM = ABEAM
      IF (ABEAM.GE.32768) IABEAM = ABEAM - 65536
      IF (BBEAM.LT.32768) IBBEAM = BBEAM
      IF (BBEAM.GE.32768) IBBEAM = BBEAM - 65536
      IF (NCOMP.LT.32768) INCOMP = NCOMP
      IF (NCOMP.GE.32768) INCOMP = NCOMP - 65536
C                                        Call FPS routine.
      CALL MULCLN (ICOMP, IFLDEC, IABEAM, IBBEAM, INCOMP)
C
 999  RETURN
      END

      INTEGER FUNCTION LLOCAT (NWORDS, ARRAY, LPT)
C-----------------------------------------------------------------------
C! allocates space in linked-list array and handles link pointers
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   LLOCAT allocates NWORDS from the array ARRAY and links the
C   last allocated block to the current block by the pointer LPT.
C   Inputs:
C      NWORDS  I      # words of storage needed
C   In/out
C      ARRAY   I(*)   in:  (3) next free space in ARRAY
C                     out: (3) new next free space in ARRAY
C                     in:  (5) max available space in ARRAY
C                     out: (in LPT) linked to new allocated space
C                     out: (LPTout:LPTout+NWORDS-1) set to zero
C      LPT     I      in:  place to link last old structure to new
C                     out: point to allocated space
C   Outputs:
C      LLOCAT  I      point to allocated space
C-----------------------------------------------------------------------
      INTEGER   NWORDS, ARRAY(*), LPT
C
      INTEGER   I, J, N, NFC
      CHARACTER PRGNAM*6
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      DATA PRGNAM /'LLOCAT'/
C-----------------------------------------------------------------------
C                                        NFC = point to next free space
      NFC = ARRAY(3)
C                                        N = max available space
      N = ARRAY(5)
      J = N - NFC - NWORDS + 1
      IF (J.LT.0) GO TO 980
      LLOCAT = NFC
C                                        link to new space
      ARRAY(LPT) = NFC
      NFC = NFC + NWORDS
C                                        return pointer to new
      LPT = LLOCAT
C                                        clear new space
      J = NFC - 1
      DO 50 I = LPT,J
         ARRAY(I) = 0
 50      CONTINUE
      ARRAY(3) = NFC
      GO TO 999
C                                        Error: no room
 980  ERRNUM = 1
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
      END

      SUBROUTINE COMPIL
C-----------------------------------------------------------------------
C! parses line of input with GETFLD, builds stacks for execution
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   COMPIL parses a line of input (using GETFLD) and builds the
C   stacks to be executed.  It exits when a pseudo-verb or the end
C   of the line is encountered.
C-----------------------------------------------------------------------
      INTEGER   PR(20), BPR(100), EQ, APIN, NSYMS, NUSYMS, IXT, A(100),
     *   B(100), I, IT, J, MAXLEV, N, NOTHNG, POTERR
      LOGICAL   WASP, TWIDDL
      CHARACTER PRGNAM*6
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DSMS.INC'
      EQUIVALENCE (BPR(1), V(1)), (STACK(1), A(1)), (CSTACK(1), B(1))
      DATA MAXLEV /10/,     NOTHNG /0/
      DATA PR/ 0,0,0,1,5, 5,6,6,7,3, 3,0,8,2,4, 4,3,2,2,0/
C                ( ) = +  - * / **>  <   - ^ TO BY= | & ;
      DATA PRGNAM /'COMPIL'/
C-----------------------------------------------------------------------
      EQ = -2
      NSYMS = -2
      NUSYMS = -2
      WASP = .FALSE.
      TWIDDL = .FALSE.
      APIN = AP + 1
 10   CALL GETFLD
      IF (ERRNUM.NE.0) GO TO 980
      IF ((NKAR.EQ.0) .OR. (TAG.EQ.0) .OR. (SYTYPE.EQ.5)) GO TO 100
      IF (LEVEL.EQ.0) NSYMS = NSYMS + 1
      NUSYMS = NUSYMS + 1
      IF ((SYTYPE.EQ.3) .OR. (SYTYPE.EQ.4)) GO TO 50
C-----------------------------------------------------------------------
C                  O P E R A N D    P R O C E S S O R
C-----------------------------------------------------------------------
C                                       insert comma between adverbs
      IF (LAST.GT.0) GO TO 20
         NEXTP = 1 + LEVEL
         CALL BCLEAN
         IF (ERRNUM.NE.0) GO TO 980
         IF ((NSYMS.LE.0) .OR. (LAST.GE.0) .OR. (LEVEL.GT.0) .OR.
     *      (WASP)) GO TO 20
            EQ = EQ + 1
            IF (EQ.GT.0) GO TO 20
               IF (EQ.EQ.0) AP = AP - 1
               EQ = 2
C                                       Operand is hollerith (no subs)
 20   IF (SYTYPE.NE.14) GO TO 25
         N = K(LOCSYM+1)/16
         GO TO 30
C                                       Operand is an array or string.
 25   IF ((SYTYPE.NE.2) .AND. (SYTYPE.NE.7)) GO TO 35
C                                       Check if in array subscipt mode
         N = K(LOCSYM+3)
C                                        stack gets -(2,tag,size,type)
 30   CONTINUE
         IXT = -SYTYPE
         CALL PUSH (A, AP, IXT)
         IF (ERRNUM.NE.0) GO TO 980
         IXT = -N
         CALL PUSH (A, AP, IXT)
         IF (ERRNUM.NE.0) GO TO 980
         IXT = -TAG
         CALL PUSH (A, AP, IXT)
         IF (ERRNUM.NE.0) GO TO 980
         IXT = -2
         CALL PUSH (A, AP, IXT)
         IF (ERRNUM.NE.0) GO TO 980
         GO TO 40
C                                       All other operands.
 35   CONTINUE
C                                       Check if in array subscipt mode
C                                       Check on maximum dimensions.
            POTERR = 6
 37      CONTINUE
         IXT = -TAG
         CALL PUSH (A, AP, IXT)
         IF (ERRNUM.NE.0) GO TO 980
 40   LAST = -TAG
      GO TO 10
C-----------------------------------------------------------------------
C                  O P E R A T O R    P R O C E S S O R
C-----------------------------------------------------------------------
C                                       Comma (,) operator.
 50   IF (TAG.NE.1) GO TO 55
         LAST = NOTHNG
         NEXTP = 1 + LEVEL
         CALL BCLEAN
         IF (ERRNUM.NE.0) GO TO 980
C                                           array assign?
         IF ((LEVEL.GT.0) .OR. (EQ.EQ.0) .OR. (WASP)) GO TO 10
C                                           yes: count
            EQ = EQ + 1
            IF (EQ.GT.0) GO TO 10
               IF (EQ.EQ.0) AP = AP - 1
               EQ = 2
            GO TO 10
C                                       Left Paren "(" operator.
 55   IF (TAG.NE.2) GO TO 65
         IF (LEVEL.EQ.0) NSYMS = NSYMS - 1
         NUSYMS = NUSYMS - 1
         LEVEL = LEVEL + MAXLEV
         IF (LAST.GT.0) GO TO 10
         IF (A(AP).NE.-2) GO TO 10
C                                           array subscript
            J = LEVEL - MAXLEV + 9
            CALL PUSH (B, BP, 98)
            IF (ERRNUM.NE.0) GO TO 980
            BPR(BP) = J
            DO 60 I = 1,4
               CALL POP (A, AP, IT)
               IF (ERRNUM.NE.0) GO TO 980
               CALL PUSH (B, BP, IT)
               IF (ERRNUM.NE.0) GO TO 980
               BPR(BP) = J
 60            CONTINUE
            GO TO 10
C                                       Right paren ")".
 65   IF (TAG.EQ.3) THEN
         LEVEL = LEVEL - MAXLEV
         NUSYMS = NUSYMS - 1
         GO TO 10
         END IF
C                                       Semi colon ";".
 70   IF (TAG.NE.20) GO TO 80
         NEXTP = 0
         IFFLAG = 0
         CALL BCLEAN
         IF (ERRNUM.NE.0) GO TO 980
         LAST = NOTHNG
C                                       push array operator
         IF ((EQ.GT.0) .OR. (TWIDDL)) THEN
            IF (A(AP).EQ.4) AP = AP - 1
            IXT = -MAX (1, EQ)
            CALL PUSH (A, AP, IXT)
            IF (ERRNUM.NE.0) GO TO 980
            IF (TWIDDL) THEN
               CALL PUSH (A, AP, 29)
            ELSE
               CALL PUSH (A, AP, 27)
               END IF
            IF (ERRNUM.NE.0) GO TO 980
            GO TO 75
            END IF
C                                       Do we have an operator?
 72      IF (APIN.GE.AP) GO TO 75
            IF (IFFLAG.EQ.1) GO TO 75
            DO 73 I = APIN,AP
               IF ((A(I).GT.50) .AND. (A(I).NE.98)) GO TO 75
               IF ((A(I).GE.21) .AND. (A(I).LE.30)) GO TO 75
               IF ((A(I).EQ.4) .OR. (A(I).EQ.41)) GO TO 75
 73            CONTINUE
C                                       No: stick on = for dummies
            CALL PUSH (A, AP, 4)
            IF (ERRNUM.NE.0) GO TO 980
 75      EQ = -2
         NSYMS = -2
         NUSYMS = -2
         WASP = .FALSE.
         TWIDDL = .FALSE.
         APIN = AP + 1
         GO TO 10
C                                        unary operator
 80   IF ((LAST.LT.0) .AND. (NUSYMS.GT.0)) GO TO 85
         IF ((LAST.LT.0) .AND. (NUSYMS.EQ.0) .AND. (IFFLAG.EQ.1))
     *      GO TO 85
C                                          Unary plus "+".
         IF (TAG.EQ.5) GO TO 10
C                                          Unary minus "-".
         IF (TAG.EQ.6) TAG = 13
C                                       "=" . . . compare or store?
C                                       Twiddle "="
 85   IF ((TAG.EQ.4) .OR. (TAG.EQ.29)) THEN
         IF ((IFFLAG.NE.1) .AND. (EQ.LT.0)) EQ = -1
         IF (IFFLAG.EQ.1) TAG = 17
         IF (TAG.EQ.29) THEN
            TWIDDL = .TRUE.
            TAG = 4
            END IF
         IFFLAG = 1
         END IF
C                                       All other operators.
90    CONTINUE
         NEXTP = LEVEL
         IF (TAG.EQ.24) IFFLAG = 1
         IF (TAG.LT.21) NEXTP = LEVEL + PR(TAG)
         IF ((TAG.GT.30) .OR. (TAG.EQ.26)) NEXTP = LEVEL + 9
         IF (TAG.EQ.41) NEXTP = LEVEL
         IF ((TAG.GE.42) .AND. (TAG.LE.44)) NEXTP = LEVEL + PR(11)
         IF (TAG.EQ.46) NEXTP = LEVEL + PR(5)
         IF (TAG.EQ.47) NEXTP = LEVEL + PR(15)
         CALL BCLEAN
         IF (ERRNUM.NE.0) GO TO 980
         CALL PUSH (B, BP, TAG)
         IF (ERRNUM.NE.0) GO TO 980
         BPR(BP) = NEXTP
         LAST = TAG
         IF ((TAG.EQ.23) .OR. (TAG.EQ.24)) WASP = .TRUE.
         GO TO 10
C-----------------------------------------------------------------------
C                                        final clean up
C-----------------------------------------------------------------------
 100  NEXTP = 0
      CALL BCLEAN
      IF (ERRNUM.NE.0) GO TO 980
      IF ((EQ.GT.0) .OR. (TWIDDL)) THEN
         IF (A(AP).EQ.4) AP = AP - 1
         IXT = -MAX (1, EQ)
         CALL PUSH (A, AP, IXT)
         IF (ERRNUM.NE.0) GO TO 980
         IF (TWIDDL) THEN
            CALL PUSH (A, AP, 29)
         ELSE
            CALL PUSH (A, AP, 27)
            END IF
         IF (ERRNUM.NE.0) GO TO 980
         GO TO 999
         END IF
C                                       Do we have an operator?
 105  IF (APIN.GE.AP) GO TO 999
         IF (IFFLAG.EQ.1) GO TO 999
         DO 110 I = APIN,AP
            IF ((A(I).GT.50) .AND. (A(I).NE.98)) GO TO 999
            IF ((A(I).GE.21) .AND. (A(I).LE.30)) GO TO 999
            IF ((A(I).EQ.4) .OR. (A(I).EQ.41)) GO TO 999
 110        CONTINUE
C                                       No: stick on = for dummies
         CALL PUSH (A, AP, 4)
         IF (ERRNUM.EQ.0) GO TO 999
C                                        error return
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
  999 RETURN
      END

LOCAL INCLUDE 'DTSIM.INC'
C                                       Local include for DTSIM
      INCLUDE 'INCS:ZPBUFSZ.INC'
C                                       Input adverbs
      HOLLERITH XNAME(3), XCLASS(2), XINFIL(12)
      CHARACTER LNAME*12, LCLASS*6, LINFIL*48
      REAL      XSEQ, XDISK, XPRTLV, DPARMS(70)
      INTEGER   ISEQ, IDISK, IPRTLV
      COMMON /DTCHR/ LNAME, LCLASS, LINFIL
      COMMON /INPARM/ XNAME, XCLASS, XSEQ, XDISK, XINFIL,
     *   XPRTLV, DPARMS, ISEQ, IDISK, IPRTLV
C                                       General global variables
      INTEGER   ICNOUT
      COMMON /DTGEN/ ICNOUT
C                                       Buffers
      INTEGER   NBUFSZ, NBUFTB
      PARAMETER (NBUFSZ = UVBFSL, NBUFTB = 512)
      REAL      BUFF(UVBFSL)
      INTEGER   JBUFF(NBUFTB)
      COMMON /DTBUF/ BUFF, JBUFF
C
LOCAL END
      PROGRAM DTSIM
C----------------------------------------------------------------------
C! Generate fake uv-data
C# UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2004, 2007-2009, 2012, 2015, 2017-2018,
C;  Copyright (C) 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
      CHARACTER LPGM*6
      INTEGER   IRET
C
      INTEGER   JLUNF, ILUNO, ILUNTB
      INCLUDE 'DTSIM.INC'
      DATA LPGM /'DTSIM'/
      DATA JLUNF /10/, ILUNO /18/, ILUNTB /28/
C----------------------------------------------------------------------
C                                       Read input adverbs/init.
      CALL DTSINP (LPGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Read simulation parameters
      CALL DTPARM (LINFIL, JLUNF, IPRTLV, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Write the fake uv-data
      CALL DTFILL (ILUNO, ILUNTB, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Create a history file
      CALL DTHIS (ILUNTB, IRET)
C                                       Exit
990   CALL DIE (IRET, BUFF)
C
999   STOP
      END
      SUBROUTINE DTSINP (LPGM, IRET)
C----------------------------------------------------------------------
C   Read input adverbs and perform general initialization
C   Inputs:
C      LPGM      C*6      Task name.
C   Output:
C      IRET      I        Return code (0=> ok; else error)
C----------------------------------------------------------------------
      CHARACTER LPGM*6
      INTEGER   IRET
C
      INTEGER   NPARM, IERR
      INCLUDE 'DTSIM.INC'
      INCLUDE 'INCS:DTPM.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C
      NSCR = 0
      NCFILE = 0
C                                       Get input adverbs
      NPARM = 90
      CALL GTPARM (LPGM, NPARM, RQUICK, XNAME, BUFF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 1
C                                       Check if initiator (AIPS)
C                                       not found.
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFF, IERR)
      IF (IERR.NE.0) IRET = 1
C                                       Abort if error obtaining
C                                       input parameters.
      IF (IRET.NE.0) GO TO 999
C                                       Convert input parameters
      ISEQ = XSEQ + 0.1
      IDISK = XDISK + 0.1
      IPRTLV = XPRTLV + 0.1
C
      CALL H2CHR (12, 1, XNAME, LNAME)
      CALL H2CHR (6, 1, XCLASS, LCLASS)
      CALL H2CHR (48, 1, XINFIL, LINFIL)
C                                       defaults to DTPM.INC
      DYEAR  = DPARMS(1) + 0.1
      DMONTH = DPARMS(2) + 0.1
      DDAY   = DPARMS(3) + 0.1
      NOPARA = DPARMS(4).GT.0.0
      CALL RFILL (MAXIF, DPARMS(40), DEFGAN)
      CALL RCOPY (30, DPARMS(11), DEFGAN)
      CALL RFILL (MAXIF, DPARMS(70), DEFSYS)
      CALL RCOPY (30, DPARMS(41), DEFSYS)
C
 999  RETURN
C----------------------------------------------------------------------
 1000 FORMAT ('DTSINP: ERROR',I4,' READING INPUT ADVERBS')
      END
      SUBROUTINE DTFILL (ILUNO, ILUNTB, IRET)
C----------------------------------------------------------------------
C   Generate and write the fake data file.
C   Input:
C      ILUNO   I     LUN for output uv-data file.
C      ILUNTB  I     LUN for general table I/O
C   Outputs:
C      IRET    I     Return code; 0 => ok, else error
C----------------------------------------------------------------------
      INTEGER   ILUNO, ILUNTB, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      LOGICAL   WMASK(4*MAXCIF), WERROR, WTRUE, WFALSE, WEND
      CHARACTER LNAM*12, LCLS*6, LOUTFL*48
      INTEGER   INDO, NVOUT, NFIRST, NPIO, NBO, IPTRO, NVCNT, NIOUT,
     *   KBIND, NFLSIZ, NVBUFF, N256, IENTRY, IANT, JANT, RNXRET,
     *   NFLAGD
      INCLUDE 'DTSIM.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DRNX.INC'
      DATA WTRUE, WFALSE /.TRUE., .FALSE./
      DATA NFIRST / 0/, NBO / 1/, NVOUT / 10000000/
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
      NFLAGD = 0
C                                       Construct the AIPS catalog hdr
      CALL DTCAT (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create the output uv-file
C                                       Fix output name
      LNAM = 'DTSIM'
      LCLS = 'UVDATA'
      CALL MAKOUT (LNAM, LCLS, 0, LCLS, LNAME, LCLASS, ISEQ)
C                                       Update in catalog header
      CALL CHR2H (12, LNAME, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, LCLASS, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = ISEQ
C                                       Create UV file
      ICNOUT = 1
      CALL UVCREA (IDISK, ICNOUT, BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Mark in /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = IDISK
      FCNO(NCFILE) = ICNOUT
      FRW(NCFILE) = 1
C                                       Read uv-data pointers in
C                                       catalog header
      CALL UVPGET (IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1110) IRET
         GO TO 990
         END IF
C                                       Construct physical file name
      CALL ZPHFIL ('UV', IDISK, ICNOUT, 1, LOUTFL, IRET)
C                                       Open for write
      CALL ZOPEN (ILUNO, INDO, IDISK, LOUTFL, WTRUE, WFALSE, WFALSE,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1130) IRET
         GO TO 990
         END IF
C                                       Set file size
      NFLSIZ = CATBLK(KIGCN)
C                                       Initialize for write
      NPIO = 0
      CALL UVINIT ('WRIT', ILUNO, INDO, NVOUT, NFIRST, LREC, NPIO,
     *   NBUFSZ, BUFF, NBO, IPTRO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1140) IRET
         GO TO 990
         END IF
C                                       No records per buffer
      NVBUFF = NPIO
C                                       Initialize
      NVCNT = 0
      NIOUT = 0
C                                       NX table
      CALL FILL (MAXSUB, 0, RNXNOS)
      RNXRET = 0
      CALL RNXINI (IDISK, ICNOUT, CATBLK, RNXRET)
C                                       Get first schedule entry
      WERROR = .FALSE.
      CALL DTFRST (IENTRY, IANT, JANT, WMASK, WEND)
C
C                                       While (still schedule data)
C                                          and (not error)
C                                       do (write uv-record)
100   IF (WERROR.OR.WEND) GO TO 800
C                                       Get next data point.
         CALL DTUVDT (IENTRY, IANT, JANT, BUFF(IPTRO), IRET)
         WERROR = (IRET.GT.0)
         IF (IRET.LT.0) NFLAGD = NFLAGD + 1
C                                       Write uv-record
         IF (IRET.EQ.0) THEN
C                                       update NX table
            CALL RNXUPD (BUFF(IPTRO), RNXRET)
            NIOUT = NIOUT + 1
            NVCNT = NVCNT + 1
            IPTRO = IPTRO + LREC
            IF (MOD(NVCNT,50000).EQ.1) THEN
               WRITE (MSGTXT,1100) NVCNT
               CALL MSGWRT (2)
               END IF
C                                       Is buffer full ?
            IF (NIOUT.GE.NVBUFF) THEN
C                                       Expand uv-file ?
               IF (NVCNT.GT.NFLSIZ) THEN
C                                       Add space for an additional
C                                       10 I/O buffers
                  N256 = ((10 * NVBUFF * LREC) / 256) + 1
                  CALL ZEXPND (ILUNO, IDISK, LOUTFL, N256, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1200) IRET
                     GO TO 990
                     END IF
C                                       Update file size
                  NFLSIZ = NFLSIZ + 10 * NVBUFF
                  END IF
C                                       Write buffer
               CALL UVDISK ('WRIT', ILUNO, INDO, BUFF, NIOUT, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1220) IRET
                  GO TO 990
                  END IF
C                                       Update pointers
               IPTRO = KBIND
               NVBUFF = NIOUT
               NIOUT = 0
               END IF
            END IF
C                                       Get next schedule record
         IF (IRET.LE.0) CALL DTNEXT (IENTRY, IANT, JANT, WMASK, WEND)
C                                       Endwhile
         GO TO 100
C                                       Close uv-file
C                                       First, finish last write.
800   IF (NVCNT.GT.NFLSIZ) THEN
C                                       Expand output file if necessary
         N256 = (((NVCNT-NFLSIZ) * LREC) / 256) + 1
         CALL ZEXPND (ILUNO, IDISK, LOUTFL, N256, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1200) IRET
            GO TO 990
            END IF
         END IF
C                                       Flush output buffer
      NIOUT = -ABS (NIOUT)
      CALL UVDISK ('FLSH', ILUNO, INDO, BUFF, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1220) IRET
         GO TO 990
         END IF
C                                       Compress output file
      CALL UCMPRS (NVCNT, IDISK, ICNOUT, ILUNO, CATBLK, BUFF, IRET)
C                                       Close output file
      CALL ZCLOSE (ILUNO, INDO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1400) IRET
         GO TO 990
         END IF
C                                       close NX table
      CALL RNXCLS (RNXRET)
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
C                                       Update visibility count in
C                                       catalog header
      CATBLK(KIGCN) = NVCNT
      CALL CATIO ('UPDT', IDISK, ICNOUT, CATBLK, 'REST', BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1500) IRET
         GO TO 990
         END IF
      IF (NFLAGD.GT.0) THEN
         WRITE (MSGTXT,1800) NFLAGD
         CALL MSGWRT (4)
         END IF
C                                       Write FQ table
      CALL DTFQTB (ILUNTB, IRET)
C                                       Write AN table(s)
      CALL DTANTB (ILUNTB, IRET)
C                                       Write SU table
      CALL DTSUTB (ILUNTB, IRET)
C                                       Write BP table
      CALL DTBPTB (ILUNTB, IRET)
C
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
      GO TO 999
C
999   RETURN
C----------------------------------------------------------------------
 1000 FORMAT ('DTFILL: ERROR',I4,' CREATING OUTPUT FILE')
 1100 FORMAT ('Writing record',I12)
 1110 FORMAT ('DTFILL: ERROR',I4,' READING CATALOG HEADER')
 1130 FORMAT ('DTFILL: ERROR',I4,' OPENING OUTPUT FILE')
 1140 FORMAT ('DTFILL: ERROR',I4,' INITIALIZING OUTPUT FILE')
 1200 FORMAT ('DTFILL: ERROR',I4,' ALLOCATING NEW DISK SPACE')
 1220 FORMAT ('DTFILL: ERROR',I4,' WRITING OUTPUT RECORD')
 1400 FORMAT ('DTFILL: ERROR',I4,' CLOSING OUTPUT FILE')
 1500 FORMAT ('DTFILL: ERROR',I4,' UPDATING CATALOG HEADER')
 1800 FORMAT ('DTFILL: omitted',I8,' fully flagged records')
      END
      SUBROUTINE DTUVDT (IENTRY, IANT, JANT, VBUFF, IRET)
C----------------------------------------------------------------------
C   Construct a simulated uv-data record
C   Input:
C      IENTRY  I     Entry number in schedule
C      IANT    I     Antenna 1
C      JANT    I     Antenna 2
C   Output:
C      VBUFF   R(*)  Output uv-record in AIPS format
C      IRET    I     Return code (0 => ok, -1 => fully flagged)
C-----------------------------------------------------------------------
      REAL      VBUFF(*)
      INTEGER   IENTRY, IANT, JANT, IRET
C
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DTPM.INC'
      CHARACTER LANT1*8, LANT2*8
      COMPLEX   GAINR1(MAXCHA), GAINL1(MAXCHA), GAINR2(MAXCHA),
     *   GAINL2(MAXCHA), CDAT(4)
      DOUBLE PRECISION TIME, DATE, DSHFT1, DSHFT2
      INTEGER   JFQ
      REAL      TINT, FLUXN(4), BWIDTH, SEED, WEIGHT(4), RTIME, PANG(2)
      DOUBLE PRECISION DAMPL1(2), DAMPL2(2), DFEED1(2,2),
     *   DFEED2(2,2), DRAP, DDECP, U, V, W, GAST, GAST0, GASTR,
     *   DX(2), DY(2), DZ(2), DRA, DDEC, DFR
      COMPLEX   FLUX(4), FLXOUT(4), GAIN(4)
      INTEGER   ISUBA, JSUBA, IFQID, K, JIF, ISTOKE, ICHAN, IOFF, M,
     *   JSOU, MODTYP, IMODEL, JNDXC1, JNDXC2, IDUM, NGOOD
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
      NGOOD = 0
C                                       Schedule entry descriptors
      ISUBA = IDTSSB(IENTRY)
      IFQID = IDTSFQ(IENTRY)
C                                       Match src, suba and freqid
C                                       in simulated data tables
      CALL DTMATC (LDTSCH(IENTRY), IDUM, ISUBA, IFQID, JSOU, IDUM,
     *   JSUBA, JFQ)
C                                       Check for valid subarray
      IF (JSUBA.EQ.0) THEN
         IRET = 1
         WRITE (MSGTXT,1050) ISUBA
         GO TO 990
         END IF
C                                       Check for valid source
      IF (JSOU.EQ.0) THEN
         IRET = 2
         WRITE (MSGTXT,1100) LDTSCH(IENTRY)
         GO TO 990
         END IF
C                                       Antenna names
      LANT1 = LDTANT(IANT,JSUBA)
      LANT2 = LDTANT(JANT,JSUBA)
C                                       Seed for random par. for noise
C                                       calcs.
      SEED = 0.0123456789
C                                       Integration for noise calcs.
      TINT = RDTINT(IENTRY) * 86400.0
C                                       First, get the proper Julian Date
      DATE = DTJDAT
C                                       Get UT time
      TIME = RDTSTK(IENTRY)
      RTIME = TIME
C                                       Get mean RA, DEC
      RA = DTSRA(JSOU)
      DEC = DTSDEC(JSOU)
      DRA = RA * DG2RAD
      DDEC = DEC * DG2RAD
C                                       Get GAST and GAST rate at UT0
      CALL GETGST (DATE, GAST0, GASTR)
      GAST = GAST0 + TIME * GASTR
C                                       Get baseline separation
      CALL GETBAS (TIME, GAST, RA, DEC, U, V, W,
     *     IDTMNT(IANT,JSUBA), IDTMNT(JANT,JSUBA),
     *     DTCPOS(1,IANT,JSUBA), DTCPOS(1,JANT,JSUBA),
     *     DTORB(1,IANT,JSUBA), DTORB(1,JANT,JSUBA), IRET)
C                                       If source is not mutually
C                                       visible, then set weight -ve
      CALL RFILL (4, 1.0, WEIGHT)
      IF (IRET.NE.0) THEN
         U = 1.0
         V = 1.0
         W = 1.0
         CALL RFILL (4, -1.0, WEIGHT)
         ENDIF
C                                       Convert meters to wavelengths
      U = U * DTRFRQ / VELITE
      V = V * DTRFRQ / VELITE
      W = W * DTRFRQ / VELITE
C                                       Calculate U,V,W coordinates
C                                       [send apparent sidereal time]
C                                       although Local should be used,
C                                       for now, send in Greenwich
      CALL CALCUV (DATE, TIME, GAST, RA, DEC, U, V, W, DRAP, DDECP)
C                                       Station coordinates reqd.
C                                       for natural fringe rate
C                                       calculation.
      CALL DFILL (2, 0.0D0, DX)
      CALL DFILL (2, 0.0D0, DY)
      CALL DFILL (2, 0.0D0, DZ)
C                                       All but space orbiting mount
      IF (IDTMNT(IANT,JSUBA).NE.2) THEN
         DX(1) = DTCPOS(1,IANT,JSUBA)
         DY(1) = DTCPOS(2,IANT,JSUBA)
         DZ(1) = DTCPOS(3,IANT,JSUBA)
         END IF
      IF (IDTMNT(JANT,JSUBA).NE.2) THEN
         DX(2) = DTCPOS(1,JANT,JSUBA)
         DY(2) = DTCPOS(2,JANT,JSUBA)
         DZ(2) = DTCPOS(3,JANT,JSUBA)
         END IF
C                                       Fill random parameters
C                                       (u,v,w)
      VBUFF(1+ILOCU) = U
      VBUFF(1+ILOCV) = V
      VBUFF(1+ILOCW) = W
C                                       Time, baseline
      VBUFF(1+ILOCT) = TIME
      VBUFF(1+ILOCA1) = IANT
      VBUFF(1+ILOCA2) = JANT
      VBUFF(1+ILOCSA) = ISUBA
C                                       Freq. id.
      VBUFF(1+ILOCFQ) = IFQID
C                                       Source ID.
      VBUFF(1+ILOCSU) = JSOU
      VBUFF(1+ILOCSU) = IDTSID(JSOU)
C                                       Integration time.
      VBUFF(1+ILOCIT) = TINT
C                                       This call just initializes
C                                       the random number generator
C                                       - it ignores FLUX...CDAT
      IRET = 0
      CALL ADNOIZ (FLUX, FLUXN, GAIN, CDAT, SEED, IRET)
      IF (IRET.NE.0) THEN
C        IRET=0 means a portable number generator was being used.
         IRET = 0
         END IF
C                                       Compute parallactic angle
C                                       for each antenna
      CALL ORIENT (IANT, JANT, JSUBA, GAST, DRAP, DDECP, PANG)
C
C                                       Fill uv_record:
C                                       Loop over IF
      DO 500 JIF = 1, NDTIF
C                                       Compute antenna-based gain
C                                       factors. First antenna_1.
C
C                                       Compute channel shift if
C                                       VLBA data
         DSHFT1 = 0.0D0
         GSTIAT = GAST0
         IF (LDTARR(JSUBA).EQ.'VLBA') THEN
            CALL DETRAT (RTIME, DRA, DDEC, DX(1), DY(1), DZ(1),
     *         DTFREQ(JIF,JFQ), DFR)
            IF (RDTCHW(JIF,JFQ).NE.0.0) DSHFT1 = DFR / RDTCHW(JIF,JFQ)
            END IF
C
         CALL DTINDX (LANT1, IFQID, JNDXC1)
         CALL DTGAIN (JSOU, IANT, JSUBA, JFQ, JIF, JNDXC1, RTIME,
     *      DSHFT1, GAINR1, GAINL1, DAMPL1, DFEED1, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Antenna_2.
         DSHFT2 = 0.0D0
         IF (LDTARR(JSUBA).EQ.'VLBA') THEN
            CALL DETRAT (RTIME, DRA, DDEC, DX(2), DY(2), DZ(2),
     *         DTFREQ(JIF,JFQ), DFR)
            IF (RDTCHW(JIF,JFQ).NE.0.0) DSHFT2 = DFR / RDTCHW(JIF,JFQ)
            END IF
C
         CALL DTINDX (LANT2, IFQID, JNDXC2)
         CALL DTGAIN (JSOU, JANT, JSUBA, JFQ, JIF, JNDXC2, RTIME,
     *      DSHFT2, GAINR2, GAINL2, DAMPL2, DFEED2, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Now, we have channel bandwidth
         BWIDTH = RDTCHW(JIF,JFQ)
C
         FLUXN(1) = DAMPL1(1) * DAMPL2(1) / SQRT(2.0*BWIDTH*TINT)
         FLUXN(2) = DAMPL1(2) * DAMPL2(2) / SQRT(2.0*BWIDTH*TINT)
         FLUXN(3) = DAMPL1(1) * DAMPL2(2) / SQRT(2.0*BWIDTH*TINT)
         FLUXN(4) = DAMPL1(2) * DAMPL2(1) / SQRT(2.0*BWIDTH*TINT)
C                                       Compute inverse variance
C                                       weights
         DO 375 K = 1, 4
C                                       Compute weight if not already
C                                       flagged on elevation; unit
C                                       weight if no noise specified.
            IF ((WEIGHT(K).GT.0).AND.(FLUXN(K).GT.0)) WEIGHT(K) =
     *         1.0 / (FLUXN(K) ** 2)
375         CONTINUE
C                                       Loop over freq. channel
         DO 400 ICHAN = 1, NDTCHN
C                                       Baseline gain factors
            GAIN(1) = GAINR1(ICHAN) * CONJG (GAINR2(ICHAN))
            GAIN(2) = GAINL1(ICHAN) * CONJG (GAINL2(ICHAN))
            GAIN(3) = GAINR1(ICHAN) * CONJG (GAINL2(ICHAN))
            GAIN(4) = GAINL1(ICHAN) * CONJG (GAINR2(ICHAN))
C                                       Form polzn. corr. pairs
            MODTYP = 0
            CALL ADDMOD (MODTYP, RDTSPM(1,1), U, V, FLUX)
C                                       If MODTYP = 0, vis is ZEROed!
            DO 200 IMODEL = 1,NDTSMD
               IF (LDTSMD(IMODEL).EQ.LDTSCH(IENTRY)) THEN
                  MODTYP = RDTSPM(1,IMODEL)
                  CALL ADDMOD (MODTYP, RDTSPM(2,IMODEL), U, V, FLUX)
                  END IF
 200           CONTINUE
C                                       Convert IQUV into RR,LL,RL,LR
C                                       Flux = (I,Q,U,V)
            FLUX(3) = (0.0,1.0)*FLUX(3)
C                                       Flux = (I,Q,iU,V)
            FLUX(2) = FLUX(2) - FLUX(4)
            FLUX(4) = FLUX(2) + FLUX(4)
            FLUX(2) = FLUX(4) - FLUX(2)
C                                       Flux = (I,V,iU,Q)
            FLUX(1) =     FLUX(1) - FLUX(2)
            FLUX(2) = 2.0*FLUX(2) + FLUX(1)
            FLUX(3) =     FLUX(4) + FLUX(3)
            FLUX(4) = 2.0*FLUX(4) - FLUX(3)
C                                       Flux = (I-V,I+V,Q+iU,Q-iU)
C
C                                       Correct for instrumental
C                                       polarization
            CALL DTERMS (FLUX, FLXOUT, DFEED1, DFEED2, PANG, WDTLIN,
     *         NOPARA)
C                                       Add noise
            CALL ADNOIZ (FLXOUT, FLUXN, GAIN, CDAT, SEED, IRET)
C                                       Index in buffer
            IOFF = NRPARM + 1 + (JIF - 1) * INCIF + (ICHAN - 1) * INCF
C                                       Loop over Stokes
            DO 300 ISTOKE = 1, NDTSTK
C                                       Update index
               K = IOFF + (ICOR0 - IDTSTK(ISTOKE)) * INCS
C                                       Fill (Re, Im, Wgt)
               M = MIN (-IDTSTK(ISTOKE), 4)
               M = MAX (M, 1)
               VBUFF(K) = REAL (CDAT(M))
               VBUFF(K+1) = AIMAG (CDAT(M))
               VBUFF(K+2) = WEIGHT(M)
               IF (WEIGHT(M).GT.0.0) NGOOD = NGOOD + 1
300            CONTINUE
400         CONTINUE
500      CONTINUE
      IF ((NGOOD.EQ.0) .AND. (IRET.EQ.0)) IRET = -1
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Exit
999   RETURN
C----------------------------------------------------------------------
1050  FORMAT ('DTUVDT: UNIDENTIFIED SUBARRAY',I4,' IN SCHEDULE')
1100  FORMAT ('DTUVDT: UNIDENTIFIED SOURCE ',A16,' IN SCHEDULE')
      END
      SUBROUTINE DTGAIN (JSOU, JANT, JSUBA, JFQ, JIF, JNDXCE, TIME,
     *   DSHIFT, GAINR, GAINL, DAMPL, DFEED, IRET)
C----------------------------------------------------------------------
C   Compute antenna-based calibration factors.
C   Input:
C      JSOU     I       Source index
C      JANT     I       Antenna index
C      JSUBA    I       Subarray index
C      JFQ      I       Freqid. index
C      JIF      I       IF number
C      JNDXCE   I       Cal. error index
C      TIME     R       Time in days since reference day.
C      DSHIFT   D       Frequency shift (channels)
C   Output:
C      GAINR    CX(*)   Complex gain spectrum (RCP)
C      GAINL    CX(*)   Complex gain spectrum (LCP)
C      DAMPL    R(2)    Noise power level in Janskys (RCP,LCP)
C      DFEED    D(2,2)  Feed D-terms (Re,Im; RCP,LCP)
C      IRET     I       Return code (0=> ok; else error)
C----------------------------------------------------------------------
      DOUBLE PRECISION DFEED(2,2), DSHIFT
      COMPLEX GAINR(*), GAINL(*)
      REAL TIME
      INTEGER JSOU, JANT, JSUBA, JFQ, JIF, JNDXCE, IRET
C
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DTPM.INC'
      DOUBLE PRECISION DELAY(2), DPHASE(2), DRATE(2), DACCEL(2),
     *   DGAIN(2), DTSYS(2), DAMPL(2), DGERR(2), DARG, DOMEGA
      COMPLEX BAND(2,MAXCHA)
      INTEGER J
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C                                       Set to unit gain.
      DO 10 J = 1, NDTCHN
         GAINR(J) = CMPLX (1.0, 0.0)
         GAINL(J) = CMPLX (1.0, 0.0)
10       CONTINUE
C                                       Compute calibration error
C                                       quantities.
      CALL DTCALS (JSOU, JANT, JSUBA, JFQ, JIF, JNDXCE, TIME, DELAY,
     *   DPHASE, DRATE, DACCEL, DFEED, DGAIN, DTSYS, DAMPL, DGERR)
C                                       Get complex bandpass
C                                       response function in both
C                                       polarizations.
      CALL DTBAND (JNDXCE, JIF, TIME, DSHIFT, BAND)
C                                       Freq. factor for delay slope
      DOMEGA = TWOPI * RDTCHW(JIF,JFQ)
C                                       Fill spectrum
      DO 200 J = 1, NDTCHN
         DARG = DPHASE(1) + (J - 1) * DOMEGA * DELAY(1)
         GAINR(J) = DGERR(1) * BAND(1,J) *
     *      CMPLX (COS (DARG), SIN (DARG))
         DARG = DPHASE(2) + (J - 1) * DOMEGA * DELAY(2)
         GAINL(J) = DGERR(2) * BAND(2,J) *
     *      CMPLX (COS (DARG), SIN (DARG))
200      CONTINUE
C                                       Exit
 999  RETURN
      END
      SUBROUTINE DTCAT (IRET)
C----------------------------------------------------------------------
C   Construct the AIPS catalog header.
C   Output:
C      IRET    I     Return code; 0=> ok, else error.
C----------------------------------------------------------------------
      INTEGER IRET
C
      CHARACTER RTYPES(12)*8, TYPES(7)*8, UNITS*8
      INTEGER   I, NAXIS, NRAN, NDIM(7), INDEX, JLOW
      REAL      CRINC(7), CRPIX(7)
      DOUBLE PRECISION CRVAL(7)
C
      INCLUDE 'INCS:DTPM.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
C                                        No. random parameters.
      DATA NRAN /10/
C                                        Rand. parm. names.
      DATA RTYPES /'UU-L-SIN','VV-L-SIN','WW-L-SIN',
     *   'TIME1   ','SUBARRAY','SOURCE  ','FREQSEL',
     *   'INTTIM  ','ANTENNA1','ANTENNA2','WEIGHT','SCALE'/
C                                       Uniform axes.
C                                        No. axes.
      DATA NAXIS /6/
C                                        Axes names.
      DATA TYPES /'COMPLEX ','STOKES  ','FREQ    ',
     *   'IF      ','RA      ','DEC     ','        '/
C                                        Axis dimensions
      DATA NDIM /3,1,1,1,1,1,0/
C                                        Reference values
      DATA CRVAL /1.0D0, -1.0D0, 0.0D0, 1.0D0, 3*0.0D0/
C                                        Reference pixel.
      DATA CRPIX /7*1.0/
C                                        Coordinate increment.
      DATA CRINC /1.0, -1.0, 0.0, 1.0, 0.0, 0.0, 0.0/
C                                       Units
      DATA UNITS /'CORREL. '/
C-----------------------------------------------------------------------
C                                       Zero fill CATBLK
      CALL FILL (256, 0, CATBLK)
C                                       Fill axis arrays.
C                                       Random axis names
      DO 10 I = 1,KIPTPN
         INDEX = KHPTP + (I-1) * 2
         CALL CHR2H (8, '        ', 1, CATH(INDEX))
 10      CONTINUE
C                                       Compressed data?
      IF (IDTCMP.GT.0) THEN
         NRAN = 12
         NDIM(1) = 1
      ELSE
         NRAN = 10
         NDIM(1) = 3
         END IF
C                                       Actual random parameters.
      DO 20 I = 1,NRAN
         INDEX = KHPTP + (I-1) * 2
         CALL CHR2H (8, RTYPES(I), 1, CATH(INDEX))
 20      CONTINUE
C                                       Uniform axes
      DO 30 I = 1,KICTPN
C                                       Init dimension
         CATBLK(KINAX+I-1) = NDIM(I)
C                                       Init. increment.
         CATR(KRCIC+I-1) = CRINC(I)
C                                       Init. rotation.
         CATR(KRCRT+I-1) = 0.0
C                                       Init. ref pixel.
         CATR(KRCRP+I-1) = CRPIX(I)
C                                       Init. ref value.
         CATD(KDCRV+I-1) = CRVAL(I)
C                                       Fill axis type from
C                                       TYPES
         INDEX = KHCTP + (I-1) * 2
         CALL CHR2H (8, TYPES(I), 1, CATH(INDEX))
 30      CONTINUE
C                                       Fill in values.
C                                       Set number of axes.
      CATBLK(KIDIM) = NAXIS
      CATBLK(KIPCN) = NRAN
C                                       User ID
      CATBLK(KIIMU) = NLUSER
C                                       Miscellaneous items.
C                                       Epoch.
      CATR(KREPO) = 2000.0
C                                       Convolving beam
      CATR(KRBMJ) = 0.0
      CATR(KRBMN) = 0.0
      CATR(KRBPA) = 0.0
      CATBLK(KINIT) = 0
C                                       Max. min.
      CATR(KRDMX) = 0.0
      CATR(KRDMN) = 0.0
C                                       Shift
      CATR(KRXSH) = 0.0
      CATR(KRYSH) = 0.0
C                                       "Old" (observed) position.
      CATD(KDORA) = 0.0D0
      CATD(KDODE) = 0.0D0
C                                       Rest Frequency
      CATD(KDRST) = DTLRFQ
C                                       Alternate ref. value & pixel
      CATD(KDARV) = 0.0D0
      CATR(KRARP) = 0.0
      CATBLK(KIALT) = 0
C                                       Sort order ('TB'=>time-baseline
C                                       order)
      CALL CHR2H (2, 'TB', 1, CATH(KITYP))
C                                       Magic value blanking.
      CATR(KRBLK) = 0.0
C                                       Units
      CALL CHR2H (8, UNITS, 1, CATH(KHBUN))
C-----------------------------------------------------------------------
C                                       Number of vis. (Init. 1000)
      CATBLK(KIGCN) = 1000
C                                       Position (RA, DEC).
      CATD(KDCRV+4) = 0.0D0
      CATD(KDCRV+5) = 0.0D0
C                                       Number of polarizations.
      CATBLK(KINAX+1) = NDTSTK
C                                       Lowest Stokes type.
      CATD(KDCRV+1) = IDTSTK(1)
C                                       Reference frequency.
      CATD(KDCRV+2) = DTRFRQ
C                                       Find channel bandwidth of
C                                       IF.1 of lowest FQ_ID.
      JLOW = IDTFQD(1)
      CATR(KRCIC+2) = RDTCHW(1,1)
       DO 50 I = 1, NDTFQD
          IF (IDTFQD(I).LT.JLOW) THEN
             JLOW = IDTFQD(I)
             CATR(KRCIC+2) = RDTCHW(1,I)
             END IF
50       CONTINUE
C                                       Number of frequencies.
      CATBLK(KINAX+2) = NDTCHN
C                                       Number of IFS.
      CATBLK(KINAX+3) = NDTIF
C                                       Observing date.
      CALL CHR2H (8, LDTDAT, 1, CATH(KHDOB))
C                                       Object.
      CALL CHR2H (8, 'MULTI   ', 1, CATH(KHOBJ))
C                                       Telescope.
      CALL CHR2H (8, 'DTSIM   ', 1, CATH(KHTEL))
C                                       Receiver
      CALL CHR2H (8, '        ', 1, CATH(KHINS))
C                                       Observer's name.
      CALL CHR2H (8, '        ', 1, CATH(KHOBS))
C                                       UV data
      CALL CHR2H (2, 'UV', KHPTYO, CATH(KHPTY))
C                                       Finished.
      IRET = 0
C
 999  RETURN
      END
      SUBROUTINE DTFLAG (TIME, LANT1, LANT2, ISUBA, IFQID, LSOUR,
     *   WMASK, WFLAG)
C----------------------------------------------------------------------
C   Determine flagging on a given time-baseline record
C   Inputs:
C      TIME    R      Time (in days since reference day).
C      LANT1   C*8    Antenna 1.
C      LANT2   C*8    Antenna 2.
C      ISUBA   I      Subarray number.
C      IFQID   I      Frequency id.
C      LSOUR   C*16   Source name.
C   Outputs:
C      WMASK   L(*)   Mask defining valid data (per IF,chan,Stokes)
C      WFLAG   L      True if all data flagged.
C----------------------------------------------------------------------
      LOGICAL WMASK(*), WFLAG
      CHARACTER LANT1*8, LANT2*8, LSOUR*16
      REAL TIME
      INTEGER ISUBA, IFQID
C
      INTEGER NFILL, J, K, M, JJ, I
      INCLUDE 'INCS:DTPM.INC'
C----------------------------------------------------------------------
C                                       Initialization
      NFILL = 4 * NDTIF * NDTCHN
      DO 20 J = 1, NFILL
         WMASK(J) = .TRUE.
20       CONTINUE
C                                       Loop through flag records.
      DO 500 J = 1, NDTFG
C                                       Check time
         IF ((TIME.LT.RDTSFG(J)).OR.(TIME.GT.RDTEFG(J))) GO TO 500
C                                       Check antennas
         IF ((LDTFGA(J).NE.'ALL').AND.(LANT1.NE.LDTFGA(J))) GO TO 500
         IF ((LDTFGB(J).NE.'ALL').AND.(LANT2.NE.LDTFGB(J))) GO TO 500
C                                       Check fqid.
         IF ((IDTFFQ(J).GT.0).AND.(IFQID.NE.IDTFFQ(J))) GO TO 500
C                                       Check subarray.
         IF ((IDTSBF(J).GT.0).AND.(ISUBA.NE.IDTSBF(J))) GO TO 500
C                                       Check source
         IF ((LDTFGS(J).NE.'ALL').AND.(LSOUR.NE.LDTFGS(J))) GO TO 500
C                                       Update mask of flagged data
C                                       for each Stokes, IF and chan.
         DO 300 M = 1, 4
            DO 280 K = IDTBIF(J), IDTEIF(J)
               DO 260 I = IDTBCH(J), IDTECH(J)
C                                       Compute index in WMASK
                  JJ = (M - 1) * NDTIF * NDTCHN +
     *               (K - 1) * NDTCHN + I
                  WMASK(JJ) = .FALSE.
260               CONTINUE
280            CONTINUE
300         CONTINUE
C
500      CONTINUE
C                                       Are all data flagged ?
      WFLAG = .TRUE.
      DO 600 J = 1, NFILL
         IF (WMASK(J)) WFLAG = .FALSE.
600      CONTINUE
C                                       Exit
999   RETURN
      END
      SUBROUTINE DTFRST (IENTRY, IANT, JANT, WMASK, WEND)
C----------------------------------------------------------------------
C   Initialize the schedule pipe; get the first entry in TB order
C   Outputs:
C      IENTRY     I      Schedule entry number.
C      IANT       I      Antenna 1.
C      JANT       I      Antenna 2.
C      WMASK      L(*)   Mask of valid data (per IF,Stokes,channel).
C      WEND       L      True if end of schedule reached.
C----------------------------------------------------------------------
      LOGICAL WMASK(*), WEND
      INTEGER IENTRY, IANT, JANT
C
      INTEGER K
      INCLUDE 'INCS:DTPM.INC'
C----------------------------------------------------------------------
C                                       Initialization
      IENTRY = 0
C                                       Loop over schedule entries.
      DO 200 K = 1, NDTSCH
C                                       Generate stack containing
C                                       current time of each schedule
C                                       entry.
         RDTSTK(K) = RDTSTT(K) + RDTINT(K) / 2.0
C                                       Check for end.
         IF (RDTSTK(K).GT.RDTEND(K)) RDTSTK(K) = -1.0
C                                       Roll each schedule entry until
C                                       record containing unflagged
C                                       data is found.
         IANT = 1
         JANT = 0
         CALL DTROLL (K, IANT, JANT, WMASK)
C                                       Find lowest time
         IF (RDTSTK(K).LT.0) GO TO 200
         IF (IENTRY.EQ.0) THEN
            IENTRY = K
         ELSE
            IF (RDTSTK(K).LT.RDTSTK(IENTRY)) IENTRY = K
            END IF
C
200      CONTINUE
C                                       End of schedule ?
      WEND = (IENTRY.EQ.0)
C                                       Exit
999   RETURN
      END
      SUBROUTINE DTNEXT (IENTRY, IANT, JANT, WMASK, WEND)
C----------------------------------------------------------------------
C   Get next schedule point in time-baseline order
C   Input/Output:
C      IENTRY     I      Current schedule entry number.
C      IANT       I      Current antenna 1.
C      JANT       I      Current antenna 2.
C   Output:
C      WMASK      L(*)   Mask for valid data (per IF,Stokes,channel)
C      WEND       L      True if end of schedule.
C----------------------------------------------------------------------
      LOGICAL WMASK(*), WEND
      INTEGER IENTRY, IANT, JANT
C
      REAL TOLD
      INTEGER K
      INCLUDE 'INCS:DTPM.INC'
C----------------------------------------------------------------------
C                                       Get next baseline on current
C                                       schedule entry.
      TOLD = RDTSTK(IENTRY)
      CALL DTROLL (IENTRY, IANT, JANT, WMASK)
C                                       Search all entries if new
C                                       time returned.
      WEND = (RDTSTK(IENTRY).LT.0)
      IF ((RDTSTK(IENTRY).NE.TOLD).OR.WEND) THEN
C                                       Find lowest time.
         IENTRY = 0
         DO 200 K = 1, NDTSCH
            IF (RDTSTK(K).LT.0) GO TO 200
            IF (IENTRY.EQ.0) THEN
               IENTRY = K
            ELSE
               IF (RDTSTK(K).LT.RDTSTK(IENTRY)) IENTRY = K
               END IF
200         CONTINUE
C                                       End of schedule ?
         WEND = (IENTRY.EQ.0)
C                                       Get first entry at lowest
C                                       time found.
         IF (.NOT.WEND) THEN
            IANT = 1
            JANT = 0
            CALL DTROLL (IENTRY, IANT, JANT, WMASK)
            END IF
         END IF
C                                       Exit
      RETURN
      END
      SUBROUTINE DTROLL (IENTRY, IANT, JANT, WMASK)
C----------------------------------------------------------------------
C   Roll the stack for a given schedule entry.
C   Input:
C      IENTRY    I     Schedule entry number.
C   Input/Output:
C      IANT      I     Antenna 1.
C      JANT      I     Antenna 2.
C      WMASK     L(*)  Mask for valid data (per IF,Stokes,channel)
C----------------------------------------------------------------------
      LOGICAL WMASK(*)
      INTEGER IENTRY, IANT, JANT
C
      LOGICAL WEND, WFLAG, WSELCT
      CHARACTER LSOUR*16, LANT1*8, LANT2*8, LSEL*8, LPRE*1
      INTEGER IFQID, ISUBA
      INCLUDE 'INCS:DTPM.INC'
C----------------------------------------------------------------------
C                                       Initialization
      ISUBA = IDTSSB(IENTRY)
      IFQID = IDTSFQ(IENTRY)
      LSOUR = LDTSCH(IENTRY)
      LSEL = LDTSEL(IENTRY)(2:8)
      LPRE = LDTSEL(IENTRY)(1:1)
      WEND = .FALSE.
      WSELCT = .FALSE.
C                                       Repeat
C                                       Increment baseline
30    JANT = JANT + 1
      IF (JANT.GT.NDTANT(ISUBA)) THEN
         IANT = IANT + 1
         JANT = IANT
         IF (IANT.GT.NDTANT(ISUBA)) THEN
            IANT = 1
            JANT = 1
            RDTSTK(IENTRY) = RDTSTK(IENTRY) + RDTINT(IENTRY)
C                                       End of this schedule entry ?
            IF (RDTSTK(IENTRY).GT.RDTEND(IENTRY)) THEN
               RDTSTK(IENTRY) = -1.0
               WEND = .TRUE.
               END IF
            END IF
         END IF
C                                       Is this baseline selected ?
      LANT1 = LDTANT(IANT,ISUBA)
      LANT2 = LDTANT(JANT,ISUBA)
      IF (LPRE.EQ.'*') THEN
         WSELCT = (LSEL.EQ.LANT1).OR.(LSEL.EQ.LANT2)
      ELSE IF (LPRE.EQ.'-') THEN
         WSELCT = (LSEL.NE.LANT1).AND.(LSEL.NE.LANT2)
      ELSE IF (LPRE.EQ.' ') THEN
         WSELCT = .TRUE.
         END IF
C                                       Until (end of schedule entry)
C                                       or (selected baseline found)
      IF ((.NOT.WSELCT).AND.(.NOT.WEND)) GO TO 30
C                                       Check flagging information
C                                       for this record.
      WFLAG = .FALSE.
      IF (.NOT.WEND) THEN
         CALL DTFLAG (RDTSTK(IENTRY), LANT1, LANT2, ISUBA, IFQID,
     *      LSOUR, WMASK, WFLAG)
         END IF
C                                       Until (unflagged data found)
C                                       or (end of schedule entry)
      IF ((WFLAG).AND.(.NOT.WEND)) GO TO 30
C                                       Exit
      RETURN
      END
      SUBROUTINE DTFQTB (ILUN, IRET)
C----------------------------------------------------------------------
C   Create an FQ table for a simulated dataset
C   Input:
C      ILUN     I      Logical unit number.
C   Output:
C      IRET     I      Return code (0=> ok; else error)
C----------------------------------------------------------------------
      INTEGER ILUN, IRET
C
      INCLUDE 'DTSIM.INC'
      INCLUDE 'INCS:DTPM.INC'
      DOUBLE PRECISION DFOFF(MAXIF)
      INTEGER FQKOLS(MAXFQC), FQNUMV(MAXFQC), IVER, IFQRNO, J, I
      CHARACTER BNDCOD(MAXIF)*8
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C                                       Create FQ table; open for
C                                       write
      CALL FQINI ('WRIT', JBUFF, IDISK, ICNOUT, IVER, CATBLK, ILUN,
     *   IFQRNO, FQKOLS, FQNUMV, NDTFID, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Write FQ table records
      DO 200 J = 1, NDTFQD
         IFQRNO = J
C                                       Subtract ref. frequency
         DO 150 I = 1, NDTIF
            DFOFF(I) = DTFREQ(I,J) - DTRFRQ
            BNDCOD(I) = ' '
150         CONTINUE
C
         CALL TABFQ ('WRIT', JBUFF, IFQRNO, FQKOLS, FQNUMV, NDTFID,
     *      IDTFQD(J), DFOFF, RDTCHW(1,J), RDTTBW(1,J),
     *      IDTSDB(1,J), BNDCOD, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1020) IRET
            GO TO 990
            END IF
200      CONTINUE
C                                       Close FQ table
      IFQRNO = 0
      CALL TABIO ('CLOS', 0, IFQRNO, JBUFF, JBUFF, IRET)
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Exit
999   RETURN
C----------------------------------------------------------------------
1010  FORMAT ('DTFQTB: ERROR',I4,' OPENING FQ TABLE')
1020  FORMAT ('DTFQTB: ERROR',I4,' WRITING TO FQ TABLE')
      END
      SUBROUTINE DTANTB (ILUN, IRET)
C----------------------------------------------------------------------
C   Create AN tables for a simulated dataset
C   Input:
C      ILUN      I      LUN for table I/O
C   Output:
C      IRET      I      Return code (0=> ok; else error)
C----------------------------------------------------------------------
      INTEGER ILUN, IRET
C
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'DTSIM.INC'
      INCLUDE 'INCS:DTPM.INC'
      CHARACTER LPOLTP*8, LSOURC*16
      HOLLERITH HSOLTY(2)
      DOUBLE PRECISION DELAY(2), DPHASE(2), DRATE(2), DACCEL(2),
     *   DFEED(2,2), DGAIN(2), DTSYS(2), DAMPL(2), DGERR(2)
      REAL TIME
      INTEGER   ISUBA, IVER, NFILL, J, K, M, I, INDXCE, ILOC, IKEYTP,
     *   NN, JSOU, JANT, JSUBA, JFQ
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA LPOLTP /'POLTYPE '/, LSOURC /' '/
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C                                       Loop over subarrays
      DO 500 J = 1, NDTSUB
         ISUBA = IDTSUB(J)
C                                       Compute GST at UT 0 and
C                                       GST rate
         CALL GETGST (DTJDAT, GSTIA0, DEGPDY)
         GSTIA0 = GSTIA0 * RAD2DG
         DEGPDY = DEGPDY * RAD2DG
C                                       Create AN table; open for
C                                       write. First initialize.
         CALL DFILL (3, 0.0D0, ARRAYC)
         CALL RFILL (2, 0.0, POLRXY)
         UT1UTC = 0.0
         DATUTC = 0.0
         TIMSYS = 'UTC'
         NUMORB = 6
         NOPCAL = 2
         ANFQID = 1
         XYZHAN = 'RIGHT'
         TFRAME = 'ITRF'
C                                       Open AN table
         IANRNO = 0
         IVER = ISUBA
         CALL ANTINI ('WRIT', JBUFF, IDISK, ICNOUT, IVER, CATBLK, ILUN,
     *      IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, DTRFRQ,
     *      LDTDAT, POLRXY, UT1UTC, DATUTC, TIMSYS, LDTARR(J), XYZHAN,
     *      TFRAME, NUMORB, NOPCAL, NDTIF, ANFQID, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, ISUBA
            GO TO 990
            END IF
C                                       Write AN records
         DO 250 K = 1, NDTANT(J)
            IANRNO = K
C                                       Initialize AN record
C                                       Get Antenna Position
            IF (IDTMNT(K,J).NE.2) THEN
               STAXYZ(1) = DTCPOS(1,K,J)
               STAXYZ(2) = DTCPOS(2,K,J)
               STAXYZ(3) = DTCPOS(3,K,J)
            ELSE
               CALL DFILL (3, 0.0D0, STAXYZ)
               END IF
            STAXOF = 0.0
            POLTYA = 'R '
            POLTYB = 'L '
            POLAA = 0.0
            POLAB = 0.0
C                                       Transfer polzn. solutions
C                                       to AN record if requested
            IF (WDTPOL(J)) THEN
C                                       Loop over IF
               DO 150 M = 1, NDTIF
C                                       Compute D-terms for (t=0)
C                                       and (FQ_ID = 1)
                  CALL DTINDX (LDTANT(K,J), ANFQID, INDXCE)
                  CALL DTMATC (LSOURC, IDTANO(K,J), ISUBA, ANFQID,
     *               JSOU, JANT, JSUBA, JFQ)
                  TIME = 0.0
                  CALL DTCALS (JSOU, JANT, JSUBA, JFQ, M, INDXCE,
     *               TIME, DELAY, DPHASE, DRATE, DACCEL, DFEED, DGAIN,
     *               DTSYS, DAMPL, DGERR)
C                                       Copy D-terms to AN record
                  DO 140 I = 1, 2
                     POLCA(I) = DFEED(I,1)
                     POLCB(I) = DFEED(I,2)
140                  CONTINUE
150               CONTINUE
C                                       Zero polzn. cal.
            ELSE
               NFILL = 2 * MAXIF
               CALL RFILL (NFILL, 0.0, POLCA)
               CALL RFILL (NFILL, 0.0, POLCB)
               END IF
C                                       Write AN record
            CALL TABAN ('WRIT', JBUFF, IANRNO, ANKOLS, ANNUMV,
     *         LDTANT(K,J), STAXYZ, DTORB(1,K,J), IDTANO(K,J),
     *         IDTMNT(K,J), STAXOF, DIAMAN, FWHMAN, POLTYA, POLAA,
     *         POLCA, POLTYB, POLAB, POLCB, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1250) IRET, ISUBA
               GO TO 990
               END IF
250         CONTINUE
C                                       Add polarization solution
C                                       type keyword if requested
         CALL CHBLNK (8, 1, LDTPOL(J), NN)
         IF (NN.NE.0) THEN
            ILOC = 1
            IKEYTP = 3
            CALL CHR2H (8, LDTPOL(J), 1, HSOLTY)
            CALL TABKEY ('WRIT', LPOLTP, 1, JBUFF, ILOC, HSOLTY,
     *         IKEYTP, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1300) IRET, ISUBA
               GO TO 990
               END IF
            END IF
C                                       Close AN table
         CALL TABIO ('CLOS', 0, IANRNO, JBUFF, JBUFF, IRET)
500      CONTINUE
C
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Exit
999   RETURN
C----------------------------------------------------------------------
1010  FORMAT ('DTANTB: ERROR',I4,' CREATING AN TABLE',I4)
1250  FORMAT ('DTANTB: ERROR',I4,' WRITING AN TABLE',I4)
1300  FORMAT ('DTANTB: ERR',I4,' WRITING POLZN. KEYWORD FOR AN',I4)
      END
      SUBROUTINE DTSUTB (ILUN, IRET)
C----------------------------------------------------------------------
C   Create an SU table for a simulated dataset
C   Input:
C      ILUN      I       LUN for table I/O.
C   Output:
C      IRET      I       Return code (0=> ok; else error)
C----------------------------------------------------------------------
      INTEGER ILUN, IRET
C
      INCLUDE 'DTSIM.INC'
      INCLUDE 'INCS:DTPM.INC'
      DOUBLE PRECISION DSFREQ(MAXIF)
      INTEGER SUKOLS(MAXSUC), SUNUMV(MAXSUC), NFILL, IVER, ISURNO, J
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DMSG.INC'
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C                                       Create SU table; open
C                                       for write.
      IVER = 1
C                                       Initialise SU table.
      VELTYP = '        '
      VELDEF = '        '
      SUFQID = 1
      ISURNO = 0
C
      CALL SOUINI ('WRIT', JBUFF, IDISK, ICNOUT, IVER, CATBLK, ILUN,
     *   NDTIF, VELTYP, VELDEF, SUFQID, ISURNO, SUKOLS, SUNUMV, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Write SU records
      DO 250 J = 1, NDTSID
C                                       Initialize SU record
         QUAL = 0
         CALCOD = '    '
         NFILL = 4 * MAXIF
         CALL RFILL (NFILL, 0.0, FLUX)
         CALL DFILL (MAXIF, 0.0D0, DSFREQ)
         BANDW = RDTTBW(1,1)
         CALL DCOPY (MAXIF, DTSUFQ(1,J), 1, RESTFQ, 1)
         CALL DCOPY (MAXIF, DTSLSR(1,J), 1, LSRVEL, 1)
         PMRA = 0.0D0
         PMDEC = 0.0D0
C
         ISURNO = J
         RAOBS = DTSRA(J)
         DECOBS = DTSDEC(J)
         IF (DTEPOC(J).LE.0.0) DTEPOC(J) = 2000.
         CALL TABSOU ('WRIT', JBUFF, ISURNO, SUKOLS, SUNUMV, IDTSID(J),
     *      LDTSOU(J), QUAL, CALCOD, FLUX, DSFREQ, BANDW, DTSRA(J),
     *      DTSDEC(J), DTEPOC(J), DTSRA(J), DTSDEC(J), RAOBS, DECOBS,
     *      LSRVEL, RESTFQ, PMRA, PMDEC, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1250) IRET
            GO TO 990
            END IF
250      CONTINUE
C                                       Close SU table
      CALL TABIO ('CLOS', 0, ISURNO, JBUFF, JBUFF, IRET)
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Exit
999   RETURN
C----------------------------------------------------------------------
1010  FORMAT ('DTSUTB: ERROR',I4,' CREATING SU TABLE')
1250  FORMAT ('DTSUTB: ERROR',I4,' WRITING TO SU TABLE')
      END
      SUBROUTINE DTHIS (ILUN, IRET)
C----------------------------------------------------------------------
C   Create history (HI) file
C   Input:
C      ILUN     I     LUN for HI table I/O.
C   Output:
C      IRET     I     Return code (0=> ok; else error)
C----------------------------------------------------------------------
      INTEGER   ILUN, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER LHIST*72, LDATE*12, LTIME*8, INLINE*128
      INTEGER   IDATE(3), ITIME(3), IERR, FPHI, VPHI, I, JTRIM, LUN,
     *   IND, J
      INCLUDE 'DTSIM.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DMSG.INC'
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
C                                       Initialize /HICOM/
      CALL HIINIT (3)
C                                       Create/open history file.
      CALL HICREA (ILUN, IDISK, ICNOUT, CATBLK, BUFF, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (7)
         GO TO 900
         END IF
C                                       Write HI records
C                                       Get current date/time
      CALL ZDATE (IDATE)
      CALL ZTIME (ITIME)
      CALL TIMDAT (ITIME, IDATE, LTIME, LDATE)
      WRITE (LHIST,1010) TSKNAM, NLUSER, LDATE, LTIME
      CALL HIADD (ILUN, LHIST, BUFF, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       default values
      IDATE(1) = DPARMS(1) + 0.1
      IDATE(2) = DPARMS(2) + 0.1
      IDATE(3) = DPARMS(3) + 0.1
      IF ((IDATE(1).GT.0) .OR. (IDATE(2).GT.0) .OR. (IDATE(3).GT.0))
     *   THEN
         WRITE (LHIST,1020) TSKNAM, IDATE
         CALL HIADD (ILUN, LHIST, BUFF, IERR)
         IF (IERR.NE.0) GO TO 100
         END IF
      FPHI = 0
      VPHI = 0
      DO 30 I = 1,30
         IF (DPARMS(10+I).GT.0.0) FPHI = I
         IF (DPARMS(40+I).GT.0.0) VPHI = I
 30      CONTINUE
      DO 40 I = 1,FPHI
         WRITE (LHIST,1030) TSKNAM, I, DPARMS(10+I), I
         CALL HIADD (ILUN, LHIST, BUFF, IERR)
         IF (IERR.NE.0) GO TO 100
 40      CONTINUE
      DO 50 I = 1,FPHI
         WRITE (LHIST,1040) TSKNAM, I, DPARMS(40+I), I
         CALL HIADD (ILUN, LHIST, BUFF, IERR)
         IF (IERR.NE.0) GO TO 100
 50      CONTINUE
C                                       INFILE
      I = JTRIM (LINFIL)
      WRITE (LHIST,1050) TSKNAM, LINFIL(:I)
      CALL HIADD (ILUN, LHIST, BUFF, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       open
      LUN = 3
      CALL ZTXOPN ('READ', LUN, IND, LINFIL, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'HISTORY ROUTINE FAILS TO OPEN INFILE'
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       read loop
 60   CALL ZTXIO ('READ', LUN, IND, INLINE, IERR)
      IF (IERR.EQ.0) THEN
         I = JTRIM (INLINE)
         J = MIN (I, 64)
         LHIST = TSKNAM // '/ ' // INLINE(1:J)
         CALL HIADD (ILUN, LHIST, BUFF, IERR)
         IF (IERR.NE.0) GO TO 100
         IF (I.GT.64) THEN
            J = MIN (I, 128)
            LHIST =  '      / ' // INLINE(65:J)
            CALL HIADD (ILUN, LHIST, BUFF, IERR)
            IF (IERR.NE.0) GO TO 100
            END IF
         GO TO 60
      ELSE IF (IERR.NE.2) THEN
         MSGTXT = 'HISTORY ROUTINE FAILS WHILE READING INFILE'
         CALL MSGWRT (6)
         END IF
      CALL ZTXCLS (LUN, IND, IERR)
C
 100  CALL HICLOS (ILUN, .TRUE., BUFF, IERR)
C                                       Update CATBLK
 900  CALL CATIO ('UPDT', IDISK, ICNOUT, CATBLK, 'REST', BUFF, IERR)
C                                       Exit
 999  RETURN
C----------------------------------------------------------------------
 1000 FORMAT ('DTHIS: ERROR ',I4,' CREATING HI FILE')
 1010 FORMAT (A6,'/created by user ',I5,' at ',A12,2X,A8)
 1020 FORMAT (A6,'DPARM=',I5,',',I3,',',I3,
     *   '  / default year, month, day')
 1030 FORMAT (A6,'FPARM(',I2.2,')=',F8.3,'  / default gain (Jy/K), IF',
     *   I3)
 1040 FORMAT (A6,'VPARM(',I2.2,')=',F8.2,'  / default Tsys (K), IF',I3)
 1050 FORMAT (A6,'INFILE=''',A,''' / KEYIN')
      END
      SUBROUTINE GETGST (DATE, GAST0, GASTR)
C----------------------------------------------------------------------
C   Compute GAST0 and GASTR(radians), given DATE(julian days)
C   Input:
C      DATE   D  Julian date (Julian days)
C   Output:
C      GAST0  D  GAST on DATE at UT0 (radians)
C      GASTR  D  GAST rate on DATE at UT0 (radians/day)
C                (both computed only if DATE has changed since
C                 last call)
C----------------------------------------------------------------------
      DOUBLE PRECISION DATE, GAST0, GASTR
C
      DOUBLE PRECISION DELPSI, DELEPS, SPSI, SEPS, TC, EPS, EQEQ,
     *   GMSTM, LASDAT, GST0, B1950, BESCEN, J1900, JULCEN, GSTR
      SAVE LASDAT, GST0, GSTR, EQEQ
      INCLUDE 'INCS:PSTD.INC'
      DATA LASDAT, GST0, GSTR, EQEQ /0.0D0, 0.0D0, 0.0D0, 0.0D0/
C----------------------------------------------------------------------
C                                       This date already processed ?
      IF (DATE.NE.LASDAT) THEN
C                                       Set some constants
C                                       [all dates and intervals are
C                                        measured in Julian day units]
         B1950 = 2433282.423D0
         BESCEN = 36524.21988D0
         J1900 = 2415020.0D0
         JULCEN = 36525.0D0
C
         LASDAT = DATE
C                                       Get GST(rad) at UT=0
         TC = (DATE - J1900) / JULCEN
         GMSTM = (8640184.542D0 * TC) / 86400.0D0
         GMSTM = MOD (GMSTM, 1.0D0) +
     *        (6.0D0 + (38.0D0 + 45.836D0/60.0D0) / 60.0D0) / 24.0D0 +
     *        (0.0929D0 * TC * TC) / 86400.0D0
         GST0 = GMSTM * TWOPI
C                                       Compute Advance of Equinoxes(rad)
         CALL NUT4 (DATE, DELPSI, DELEPS, SPSI, SEPS)
         TC = (DATE - B1950) / BESCEN
         EPS = (-46.850D0 + (-0.0034D0 + 0.0018D0 * TC) * TC) * TC
         EPS = (84404.84D0 + EPS) * AS2RAD
         EQEQ = DELPSI * COS (EPS)
C                                       Get GSTdot(rad)
         GSTR = (1.00273790265D0 + 0.589D-10 * TC) * TWOPI
         ENDIF
      GAST0 = GST0 + EQEQ
      GASTR = GSTR
      RETURN
      END
      SUBROUTINE GETBAS (TIME, GAST, RA , DEC, DX, DY, DZ,
     *   MNTYPA, MNTYPB, CPOSA, CPOSB, ORBA, ORBB, IRET)
C----------------------------------------------------------------------
C   Compute antenna separation in meters, also check source elevation
C   Inputs:
C      TIME       D     UT  (hours)
C      GAST       D     Greenwich Apparent Sidereal Time (radians)
C      RA         D     J2000 Right ascension (decimal degrees)
C      DEC        D     J2000 Declination (decimal degrees)
C      MNTYP{A,B} I     mount type of antennas
C      LONG{A,B}  D     west longitude of antennas (degrees)
C      LAT{A,B}   D     north latitude of antennas  (degrees)
C      ELEV{A,B}  D(*)  elevation of antennas above earth (meters)
C      ORB{A,B}   D(*)  orbital parameters for antennas [if applicable]
C   Output:
C      DX,DY,DZ   D     separation of antennas in meters
C      IRET       I     return code, 0=>okay,
C                                    1=> not visible at both antennas
C----------------------------------------------------------------------
      DOUBLE PRECISION TIME, GAST, RA, DEC, DX, DY, DZ,
     *   CPOSA(3), CPOSB(3), ORBA(*), ORBB(*)
      INTEGER MNTYPA, MNTYPB, IRET
C
      DOUBLE PRECISION X, Y, Z
C----------------------------------------------------------------------
      IRET = 0
C                                       Get first antenna's position
      IF (MNTYPA.NE.2) THEN
         X = CPOSA(1)
         Y = CPOSA(2)
         Z = CPOSA(3)
C                                       Check source elevation
         CALL CHKELE (X, Y, Z, RA, DEC, GAST, IRET)
         IF (IRET.GT.0) GO TO 999
      ELSE
         CALL ORBPOS (ORBA, TIME, GAST, X, Y, Z)
         ENDIF
      DX = X
      DY = Y
      DZ = Z
C                                       Get second antenna's position
      IF (MNTYPB.NE.2) THEN
         X = CPOSB(1)
         Y = CPOSB(2)
         Z = CPOSB(3)
         CALL CHKELE (X, Y, Z, RA, DEC, GAST, IRET)
         IF (IRET.GT.0) GO TO 999
      ELSE
         CALL ORBPOS (ORBB, TIME, GAST, X, Y, Z)
         ENDIF
      DX = DX - X
      DY = DY - Y
      DZ = DZ - Z
 999  RETURN
      END
      SUBROUTINE GEOGEO (X, Y, Z, LON, LAT, ELE)
C----------------------------------------------------------------------
C   Returns geodetic (surface of the earth) coordinates, given
C   cartesian coordinates.
C   Output:
C      LON    D   geodetic west longitude (degrees)
C      LAT    D   geodetic north latitude (degrees)
C      ELE    D   geodetic elevation (meters)
C   Input:
C      X      D   x coord, X-axis lies along Greenwich Longitude
C      Y      D   y coord, Y-axis lies along N.American Longitude
C      Z      D   z coord, Z-axis lies passes through North Pole
C---------------------------------------------------------------------
      DOUBLE PRECISION LON, LAT, ELE, X, Y, Z
C
      DOUBLE PRECISION ECC2, ELIPR
      DOUBLE PRECISION SMAXIS, FLATEN, ERAD, NLAT
      PARAMETER (SMAXIS = 6378136.D0)
      PARAMETER (FLATEN = 1.D0/298.257)
      INCLUDE 'INCS:PSTD.INC'
C----------------------------------------------------------------------
C                                       these formulas come from the
C                                       Astronomical Almanac 1996, pg K12.
C                                       longitude is easy
      LON = ATAN2 (Y, X) * RAD2DG
C                                       latitude is not
C
C                                       work out axial displacement
      ERAD = SQRT(X*X + Y*Y)
C                                       work out earth oblateness
      ECC2 = (2.D0 - FLATEN) * FLATEN
C                                       start the ball rolling - so to speak
      LAT = 0.0D0
 10   CONTINUE
C                                       get earth depth at current latitude
      ELIPR = SMAXIS / (SQRT (1.D0 - ECC2 * SIN(LAT)**2 ))
C                                       recompute latitude
      NLAT = ATAN2 (Z + ELIPR*ECC2*SIN(LAT), ERAD)
C                                       perform reduction of the latitude
      IF (ABS(NLAT-LAT).GT.1.0D-6) THEN
         LAT = NLAT
         GO TO 10
         END IF
C                                       finally, first extract elevation
      ELE = ERAD / COS (LAT) - ELIPR
C                                       then latitude
      LAT = LAT * RAD2DG
      RETURN
      END
      SUBROUTINE ORBPOS (ORBPAR, TIME, GAST, X, Y, Z)
C----------------------------------------------------------------------
C   Given orbital parameters, return cartesian coordinates
C   Input:
C      ORBPAR   D(*)   Orbital parameters
C      TIME     D      UT at which orbital position is desired
C      GAST     D      Greenwich Sidereal Time when position is desired
C   Output:
C      X        D      x coord, X-axis lies along Greenwich Longitude
C      Y        D      y coord, Y-axis lies along N.American Longitude
C      Z        D      z coord, Z-axis lies passes through North Pole
C----------------------------------------------------------------------
      DOUBLE PRECISION ORBPAR(*), TIME, GAST, X, Y, Z
      DOUBLE PRECISION RALONG, INCLIN, PERIG, ECCEN, SEMMAJ, MEAANO
      DOUBLE PRECISION TIMSEC, TRUANO, RORBMA, RORBMI, VORBMA, VORBMI
      DOUBLE PRECISION XCELE, YCELE, ZCELE, VXCELE, VYCELE, VZCELE
      INCLUDE 'INCS:PSTD.INC'
C----------------------------------------------------------------------
      SEMMAJ = ORBPAR(1)
      ECCEN  = ORBPAR(2)
      INCLIN = ORBPAR(3)*DG2RAD
      RALONG = ORBPAR(4)*DG2RAD
      PERIG  = ORBPAR(5)*DG2RAD
      MEAANO = ORBPAR(6)*DG2RAD
      TIMSEC = TIME*8.64D4
      CALL ORBIT (SEMMAJ, ECCEN, INCLIN, RALONG, PERIG, MEAANO,
     *     TIMSEC, TRUANO, RORBMA, RORBMI, VORBMA, VORBMI,
     *     XCELE, YCELE, ZCELE, VXCELE, VYCELE, VZCELE)
      X = XCELE*COS(GAST) + YCELE*SIN(GAST)
      Y = -YCELE*COS(GAST) + XCELE*SIN(GAST)
      Z = ZCELE
      RETURN
      END
      SUBROUTINE CHKELE (X, Y, Z, RA, DEC, GAST, IRET)
C----------------------------------------------------------------------
C   Check that the source is visible from the given XYZ position
C   Inputs
C      X,Y,Z  D  antenna vector (meters), RHS AIPS-VLBI coord system
C      RA,DEC D  apparent source coordinates (decimal deg), mean is ok
C      GAST   D  Greenwich Apparent Sidereal Time [radians]
C   Outputs
C      IRET   I  return code, 0=> source is visible
C                             1=> source is not visible
C----------------------------------------------------------------------
      DOUBLE PRECISION X, Y, Z, RA, DEC, GAST
      INTEGER IRET
C
      DOUBLE PRECISION INPROD, GHRA, RDEC
      INCLUDE 'INCS:PSTD.INC'
C----------------------------------------------------------------------
      IRET = 0
      GHRA = GAST - RA * DG2RAD
      RDEC = DEC * DG2RAD
C
      INPROD = X * COS (RDEC) * COS (GHRA)
     *     -   Y * COS (RDEC) * SIN (GHRA)
     *     +   Z * SIN (RDEC)
C
      IF (INPROD.LE.0.0) IRET = 1
      RETURN
      END
      SUBROUTINE CALCUV (DATE, TIME, LAST, RA, DEC, U, V, W, RAAPP,
     *   DECAPP)
C----------------------------------------------------------------------
C   Calculate (u,v,w) coordinates.
C   Input:
C      DATE    D  julian date [days]
C      TIME    D  UT time [days]
C      LAST    D  Local Apparent Sidereal Time [radians]
C      RA      D  J2000 ra [decimal degrees]
C      DEC     D  J2000 dec [decimal degrees]
C      U,V,W   D  baseline separations measured in lambdas
C   Output:
C      U,V,W   D  uvw coordinates
C      RAAPP   D  Apparent right ascension (radians)
C      DECAPP  D  Apparent declination (radians)
C----------------------------------------------------------------------
      DOUBLE PRECISION DATE, TIME, LAST, RA, DEC, U, V, W, RAAPP,
     *   DECAPP
C
      DOUBLE PRECISION ROTANG, CROTP, SROTP, JD, OBSPOS(3)
      REAL POLAR(2)
      LOGICAL GR
      INTEGER DIR
      DOUBLE PRECISION EPOCH, DELDAT, RHOGEO, PHIGEO
      DOUBLE PRECISION RAMEA, DECMEA, COSD, SIND, SINHA, COSHA
      DOUBLE PRECISION UT, VT, WT
      LOGICAL T
      INCLUDE 'INCS:PSTD.INC'
      DATA T /.TRUE./
      DATA OBSPOS, POLAR /3*0.0D0, 2*0.0/
C----------------------------------------------------------------------
C                                       Convert to radians
      RAMEA = RA * DG2RAD
      DECMEA = DEC * DG2RAD
C                                       Get sky rotation angle in rad.
      CALL GETROT (DATE, RAMEA, DECMEA, ROTANG)
      CROTP = COS (ROTANG)
      SROTP = SIN (ROTANG)
C
      JD = DATE + TIME
      EPOCH = 2000.0
      DELDAT = 0.5
      DIR = 1
      GR = T
      RHOGEO = 0.0
      PHIGEO = 0.0
C                                       Precess position to the apparent
C                                       coordinates.
      CALL JPRECS (JD, EPOCH, DELDAT, DIR, GR, OBSPOS, POLAR, RAMEA,
     *      DECMEA, RAAPP, DECAPP)
C      CALL PRECES (JD, EPOCH, DELDAT, RAMEA, DECMEA, RAAPP, DECAPP,
C     *   DIR, GR, DA, RHOGEO, PHIGEO, LAST, NR)
      COSD = COS (DECAPP)
      SIND = SIN (DECAPP)
      SINHA = SIN (LAST - RAAPP)
      COSHA = COS (LAST - RAAPP)
C                                       Start with apparent baseline
C                                       separations
      UT = U
      VT = V
      WT = W
C                                       Rotate to apparent RA of source
      U = SINHA * UT + COSHA * VT
      V = COSHA * UT - SINHA * VT
      W = WT
C                                       Rotate to apparent DEC of
C                                       source
      UT = U
      VT = -SIND * V + COSD * W
      WT = COSD * V + SIND * W
C                                       Rotate to orientation of mean
C                                       epoch
      U = CROTP * UT + SROTP * VT
      V = -SROTP * UT + CROTP * VT
      W = WT
      RETURN
      END
      SUBROUTINE GETROT (DATE, RA, DEC, ROTANG)
C----------------------------------------------------------------------
C   Get rotation of sky about apparent position given mean position
C   Input:
C      DATE   D  julian date at UT=0
C      RA     D  J2000 RA in radians
C      DEC    D  J2000 DEC in radians
C   Output:
C      ROTANG D  sky rotation factor for the epoch of DATE
C            remembers last LSIZE rotation angles computed
C----------------------------------------------------------------------
      DOUBLE PRECISION DATE, RA, DEC, ROTANG, OBSPOS(3)
C
      DOUBLE PRECISION EPOCH, DELDAT, RHOGEO, PHIGEO, LAST
      DOUBLE PRECISION RAMEA, DECMEA, RAAPP, DECAPP, DELDEC, DELRA
      REAL POLAR(2)
      LOGICAL GR, DA, NR
      INTEGER I,LNO, LSIZE, DIR
      PARAMETER (LSIZE=10)
      DOUBLE PRECISION LDATE(LSIZE), LRA(LSIZE), LDEC(LSIZE)
      DOUBLE PRECISION LROTAN(LSIZE), ACCEPT
      LOGICAL T, F
      DATA LNO /0/
      DATA LDATE, LRA, LDEC /LSIZE*0.D0,LSIZE*0.D0,LSIZE*0.D0/
      DATA LROTAN /LSIZE*0.D0/
      DATA ACCEPT /0.0D0/
      DATA T, F /.TRUE.,.FALSE./
      DATA OBSPOS, POLAR /3*0.0D0, 2*0.0/
C----------------------------------------------------------------------
C                                       If stack is not empty,search it
      IF (LNO.GT.0) THEN
         DO 100, I = 1, LNO
            IF ( (  ABS(LRA(I)-RA).LT.ACCEPT) .AND.
     *           (ABS(LDEC(I)-DEC).LT.ACCEPT) .AND.
     *           (        LDATE(I).EQ.DATE  )      ) THEN
               ROTANG = LROTAN(I)
               GOTO 999
               ENDIF
 100        CONTINUE
         ENDIF
C                                       If stack is full, roll it
      IF (LNO.EQ.LSIZE) THEN
         DO 200 I = 1,LSIZE-1
            LDATE(I) = LDATE(I+1)
            LRA(I) = LRA(I+1)
            LDEC(I) = LDEC(I+1)
            LROTAN(I) = LROTAN(I+1)
 200        CONTINUE
         LNO = LSIZE-1
         ENDIF
C                                       Get apparent pos for offset pos
C                                       assume all coords in J2000
      EPOCH = 2000.0
C                                       Use an interpolation interval
C                                       of 1/2 day
      DELDAT = 0.5D0
C                                       Arbitrarily choose ~20 asec
C                                       dec offset in radians
      RAMEA = RA
      DECMEA = DEC + 0.0001D0
      DIR = 1
      GR = T
      DA = F
      RHOGEO = 0.0
      PHIGEO = 0.0
      LAST = 0.0
      NR = T
C                                       Precess position to the apparent
C                                       coordinates.
      CALL JPRECS (DATE, EPOCH, DELDAT, DIR, GR, OBSPOS, POLAR, RAMEA,
     *      DECMEA, RAAPP, DECAPP)
C      CALL PRECES (DATE, EPOCH, DELDAT, RAMEA, DECMEA, RAAPP, DECAPP,
C     *     DIR, GR, DA, RHOGEO, PHIGEO, LAST, NR)
      DELDEC = DECAPP
      DELRA = RAAPP
C                                       Get apparent pos for mean pos.
      RAMEA = RA
      DECMEA = DEC
C                                       Precess position to the apparent
C                                       coordinates.
      CALL JPRECS (DATE, EPOCH, DELDAT, DIR, GR, OBSPOS, POLAR, RAMEA,
     *      DECMEA, RAAPP, DECAPP)
C      CALL PRECES (DATE, EPOCH, DELDAT, RAMEA, DECMEA, RAAPP, DECAPP,
C     *     DIR, GR, DA, RHOGEO, PHIGEO, LAST, NR)
C                                       Del[ra,dec] is apparent offset
      DELDEC = DELDEC - DECAPP
      DELRA = (DELRA - RAAPP) * COS(DECMEA)
C                                       Rotang is rotation apparent offset
      ROTANG = -ATAN2 (DELRA, DELDEC)
C                                       Increment stack, store basics
      LNO = LNO + 1
      LDATE(LNO) = DATE
      LRA(LNO) = RA
      LDEC(LNO) = DEC
      LROTAN(LNO) = ROTANG
C                                       Done, end
 999  RETURN
      END
      SUBROUTINE ADNOIZ (FLUX, FLUXN, GAIN, VIS, SEED, IRET)
C----------------------------------------------------------------------
C   Produce noisy data given noise-free data and noise info
C   Input:
C      FLUX   CX(4) Full polarization noise-free visibility model
C      FLUXN  R(4)  Full polarization noise flux
C      GAIN   CX(4) Full polarization antenna gains
C      SEED   R     seed for random number generator, used only once
C   Output:
C      VIS    CX(4) Noisy full polarization visibility model
C      IRET   I     on first call, IRET=0 means portable RND calls
C                                  IRET=1 means non-portable RND calls
C                   for later calls, IRET
C----------------------------------------------------------------------
      COMPLEX FLUX(4), GAIN(4), VIS(4)
      REAL FLUXN(4), SEED
      INTEGER IRET
C                                       0 <= ADRAND < 1
      REAL ADRAND
      EXTERNAL ADRAND
      REAL SIGMAR, SIGMAI, SIGMA
      INTEGER I
      REAL R
      INTEGER  SEEDED
      SAVE SEEDED
      DATA SEEDED /0/
C----------------------------------------------------------------------
      IRET = 0
      IF (SEEDED.EQ.0) THEN
         SEEDED = 1
         SEED = MOD(SEED, 1.0)
         R = ADRAND(SEED)
         IF (SEED.NE.R) IRET = 1
      ELSE
C                                       R=0.0 means continue current
C                                       seq. of random #s
         R = 0.0
         DO 110, I = 1,4
C                                       Generate complex random # in
C                                       unit circle
 100        CONTINUE
            SIGMAR = ADRAND(R) - 0.5
            SIGMAI = ADRAND(R) - 0.5
            SIGMA = SIGMAR * SIGMAR + SIGMAI * SIGMAI
            IF (SIGMA.GT.0.25) GOTO 100
C                                       Construct measured visibility
            IF (SIGMA*FLUXN(I) .NE. 0.0) THEN
               SIGMA = FLUXN(I)*SQRT(-4.0*LOG(4.0*SIGMA))/ SQRT (SIGMA)
               VIS(I) = GAIN(I) * FLUX(I) + CMPLX (SIGMAR,SIGMAI)
     *            * SIGMA
            ELSE
               VIS(I) = GAIN(I) * FLUX(I)
               ENDIF
 110        CONTINUE
         ENDIF
 999  CONTINUE
      RETURN
      END
      SUBROUTINE ADDMOD (TYP, PAR, UCORD, VCORD, FLUX)
C----------------------------------------------------------------------
C   Add a point source model, described by MODPAR to I,Q,U,V
C   Input:
C      TYP      I     model type
C      PAR      R(*)  model parameters
C      UCORD    R     ucoordinate of baseline
C      VCORD    R     vcoordinate of baseline
C      FLUX     CX(4) complex visibility 4-vector
C   Output:
C      FLUX     CX(4) complex visibility 4-vector
C---------------------------------------------------------------------
      INTEGER   TYP
      REAL      PAR(*)
      DOUBLE PRECISION UCORD, VCORD
      COMPLEX   FLUX(4)
C
      INTEGER I
      REAL RTEMP, SKYPHS
      COMPLEX CTEMP
      INCLUDE 'INCS:PSTD.INC'
C----------------------------------------------------------------------
C                                       Ignore entry if TYPE(1) is <0.
      IF (TYP.LT.0) GOTO 990
      IF (TYP.EQ.0) THEN
         DO 10 I = 1,4
            FLUX(I) = 0.0
 10         CONTINUE
         GOTO 990
         ENDIF
C                                       B22NUL converts U*U*size*size
C                                       to gaus.
C                                       MODPAR(1) offset in ra (asec)
C                                       MODPAR(2) offset in dec (asec)
         SKYPHS = UCORD * PAR(1) + VCORD * PAR(2)
         SKYPHS = SKYPHS * AS2RAD * TWOPI
C                                       If MODTYP = 1
C                                       MODPAR(3-6) flux in I,Q,U,V (Jy)
      IF (TYP.EQ.1) THEN
         DO 100 I = 1,4
            FLUX(I) = FLUX(I) + PAR(2+I) * CEXP (CMPLX(0.0,SKYPHS))
 100        CONTINUE
         ENDIF
C                                       If MODTYP = 2
C                                       MODPAR(3) position angle (deg)
C                                       MODPAR(4) major axis (asec)
C                                       MODPAR(5) minor axis (asec)
C                                       MODPAR(6-9) I flux (Jy)
C                                       exp(-11.602077) = (pi*pi) /
C                                          360^2*sqrt(100ln2)
      IF (TYP.EQ.2) THEN
         RTEMP = PAR(3) * DG2RAD
         CTEMP = CMPLX (UCORD, VCORD) * CEXP(CMPLX (-11.602077, RTEMP))
         RTEMP = (AIMAG (CTEMP) * PAR(4)) **2 +
     *      (REAL (CTEMP) * PAR(5)) **2
         IF (RTEMP.LT.20.0) THEN
            DO 200 I = 1,4
               FLUX(I) = FLUX(I) + PAR(5+I) *
     *            CEXP (CMPLX (-RTEMP, SKYPHS))
 200           CONTINUE
            ENDIF
         ENDIF
 990  CONTINUE
      RETURN
      END
      SUBROUTINE ORIENT (JA1, JA2, JSUBA, DGAST, DRAP, DDECP, PANG)
C----------------------------------------------------------------------
C   Compute parallactic angle
C   Inputs:
C      JA1       I       Ant_1 index
C      JA2       I       Ant_2 index
C      JSUBA     I       Subarray index
C      DGAST     D       GAST (radians)
C      DRAP      D       Apparent right ascension (radians)
C      DDECP     D       Apparent declination (radians)
C   Output:
C      PANG      R(2)    Parallactic angle for (IA1,IA2) in radians
C----------------------------------------------------------------------
      DOUBLE PRECISION DGAST, DRAP, DDECP
      REAL PANG(2)
      INTEGER JA1, JA2, JSUBA
C
      INCLUDE 'INCS:DTPM.INC'
      INCLUDE 'INCS:PSTD.INC'
      DOUBLE PRECISION DLST, DHRANG, DLATR, DLONGR, DELEV, DAZ
      INTEGER   JA(2), J, JANT, ISIGN
C----------------------------------------------------------------------
C                                       Initialization
      JA(1) = JA1
      JA(2) = JA2
      CALL RFILL (2, 0.0, PANG)
C                                       Loop over each antenna
      DO 200 J = 1, 2
         JANT = JA(J)
C                                       Get Latitude and longitude (rad)
         IF (IDTMNT(JANT,JSUBA).NE.2) THEN
            CALL GEOGEO (DTCPOS(1,JANT,JSUBA), DTCPOS(2,JANT,JSUBA),
     *         DTCPOS(3,JANT,JSUBA), DLONGR, DLATR, DELEV)
            DLONGR = DLONGR * DG2RAD
            DLATR = DLATR * DG2RAD
            END IF
C                                       Compute parallactic angle
C                                       only for alt-az antennas
C                                       for now (orbiters later).
C                                       incl X-Y and Nasmyth
         IF ((IDTMNT(JANT,JSUBA).NE.1) .AND.
     *         (IDTMNT(JANT,JSUBA).NE.2)) THEN
C                                       LST
            DLST = DGAST - DLONGR
C                                       Hour angle
            DHRANG = DLST - DRAP
C            DAZ = ATAN2(SD*CL - CD*SL*CH,CD*SH)
            DAZ = ATAN2(SIN(DDECP)*COS(DLATR)-
     *            COS(DDECP)*SIN(DLATR)*COS(DHRANG),
     *            COS(DDECP)*SIN(DHRANG))
C                                       Parallactic angle
            PANG(J) = ATAN2 (COS (DLATR) * SIN (DHRANG),
     *         (SIN (DLATR) * COS (DDECP) -
     *         COS (DLATR) * SIN (DDECP) * COS (DHRANG)))
            END IF
C                                       EW-Mount
         IF (IDTMNT(JANT,JSUBA).EQ.3) THEN
            PANG(J) = ATAN2(COS(DHRANG),SIN(DHRANG)*SIN(DDECP))
C                                       Nasmyth
         ELSE IF ((IDTMNT(JANT,JSUBA).EQ.4) .OR.
     *      (IDTMNT(JANT,JSUBA).EQ.5)) THEN
            ISIGN = 1
C                                       Left Handed
            IF (IDTMNT(JANT,JSUBA).EQ.5) ISIGN = -ISIGN
            PANG(J) = PANG(J) + ISIGN * DELEV
C                                       BWG
         ELSE IF ((IDTMNT(JANT,JSUBA).EQ.6) .OR.
     *      (IDTMNT(JANT,JSUBA).EQ.7)) THEN
            ISIGN = 1
C                                       Left Handed
            IF (IDTMNT(JANT,JSUBA).EQ.7) ISIGN = -ISIGN
            PANG(J) = PANG(J) + ISIGN*DELEV -ISIGN*DAZ
            END IF
 200     CONTINUE
C                                       Exit
      RETURN
      END
      SUBROUTINE DTERMS (FLUXIN, FLXOUT, DFEED1, DFEED2, PANG, WLINP,
     *   NOPARA)
C----------------------------------------------------------------------
C   Correct true cross-correlations for intrumental polzn. response
C   Input:
C      FLXIN     C(4)     Input correlation pairs (RR,LL,RL,LR)
C      DFEED1    D(2,2)   Instrumental polzn. for ant_1 (Re,Im; R,L)
C      DFEED2    D(2,2)   Instrumental polzn. for ant_2 (Re,Im; R,L)
C      PANG      R(2)     Parallactic angles (ant_1, ant_2) (rad)
C      WLINP     L        True if linearized polzn. model required,
C                         else include all polzn. terms.
C   Output:
C      FLXOUT    C(4)     Corrupted correlation pairs (RR,LL,RL,LR)
C----------------------------------------------------------------------
      LOGICAL   WLINP, NOPARA
      COMPLEX   FLUXIN(4), FLXOUT(4)
      DOUBLE PRECISION DFEED1(2,2), DFEED2(2,2)
      REAL      PANG(2)
C
      INCLUDE 'INCS:PUVD.INC'
      COMPLEX CSUM, CDIFF, CSUMC, CDIFFC, CFEED(2,2), CFEEDC(2,2),
     *   CZERO
      DOUBLE PRECISION DSUM, DIFF
      INTEGER J, IANT, JANT, IRCP, ILCP, IRR, ILL, IRL, ILR
      DATA IANT, JANT, IRCP, ILCP /1, 2, 1, 2/
      DATA IRR, ILL, IRL, ILR /1, 2, 3, 4/
C----------------------------------------------------------------------
C                                       Initialization
      DO 50 J = 1, 4
         FLXOUT(J) = FLUXIN(J)
50       CONTINUE
C                                       Complex feed terms
      CZERO = CMPLX (0.0, 0.0)
      DO 100 J = 1, 2
         CFEED(J,IANT) = CMPLX (DFEED1(1,J), DFEED1(2,J))
         CFEED(J,JANT) = CMPLX (DFEED2(1,J), DFEED2(2,J))
C                                       Conjugated feed terms
         CFEEDC(J,IANT) = CONJG (CFEED(J,IANT))
         CFEEDC(J,JANT) = CONJG (CFEED(J,JANT))
100      CONTINUE
C                                       Parallactic angle terms
C                                       (sum and difference)
      DSUM = PANG(1) + PANG(2)
      DIFF = PANG(1) - PANG(2)
      CSUM = CMPLX (COS (DSUM), SIN (DSUM))
      CDIFF = CMPLX (COS (DIFF), SIN (DIFF))
C                                       Conjugated terms
      CSUMC = CONJG (CSUM)
      CDIFFC = CONJG (CDIFF)
C                                       First include linear terms only
C                                       RR:
      FLXOUT(IRR) = FLUXIN(IRR) * CDIFFC
C                                       LL:
      FLXOUT(ILL) = FLUXIN(ILL) * CDIFF
C                                       RL:
      FLXOUT(IRL) = FLUXIN(IRL) * CSUMC +
     *   FLUXIN(IRR) * CFEEDC(ILCP,JANT) * CDIFFC +
     *   FLUXIN(ILL) * CFEED(IRCP,IANT) * CDIFF
C                                       LR:
      FLXOUT(ILR) = FLUXIN(ILR) * CSUM +
     *   FLUXIN(ILL) * CFEEDC(IRCP,JANT) * CDIFF +
     *   FLUXIN(IRR) * CFEED(ILCP,IANT) * CDIFFC
C                                       Second-order terms if requested
      IF (.NOT.WLINP) THEN
C                                       RR:
         FLXOUT(IRR) = FLXOUT(IRR) +
     *      FLUXIN(IRL) * CFEEDC(IRCP,JANT) * CSUMC +
     *      FLUXIN(ILR) * CFEED(IRCP,IANT) * CSUM +
     *      FLUXIN(ILL) * CFEED(IRCP,IANT) * CFEEDC(IRCP,JANT) * CDIFF
C                                       LL:
         FLXOUT(ILL) = FLXOUT(ILL) +
     *      FLUXIN(ILR) * CFEEDC(ILCP,JANT) * CSUM +
     *      FLUXIN(IRL) * CFEED(ILCP,IANT) * CSUMC +
     *      FLUXIN(IRR) * CFEED(ILCP,IANT) * CFEEDC(ILCP,JANT) * CDIFFC
C                                       RL:
         FLXOUT(IRL) = FLXOUT(IRL) +
     *      FLUXIN(ILR) * CFEED(IRCP,IANT) * CFEEDC(ILCP,JANT) * CSUM
C                                       LR:
         FLXOUT(ILR) = FLXOUT(ILR) +
     *      FLUXIN(IRL) * CFEED(ILCP,IANT) * CFEEDC(IRCP,JANT) * CSUMC
         END IF
C                                       undo paralactic angle
      IF (.NOT.NOPARA) THEN
         FLXOUT(IRR) = FLXOUT(IRR) * CDIFF
         FLXOUT(ILL) = FLXOUT(ILL) * CDIFFC
         FLXOUT(IRL) = FLXOUT(IRL) * CSUM
         FLXOUT(ILR) = FLXOUT(ILR) * CSUMC
         END IF
C                                       Exit
999   RETURN
      END
      SUBROUTINE DTBPTB (ILUN, IRET)
C----------------------------------------------------------------------
C   Create a BP table for a simulated dataset
C   Input:
C      ILUN      I       LUN for table I/O
C   Output:
C      IRET      I       Return code (0=>ok; else error)
C----------------------------------------------------------------------
      INTEGER ILUN, IRET
C
      INCLUDE 'INCS:DTPM.INC'
      LOGICAL WPOLY
      DOUBLE PRECISION DAMPL, DTIME, DSHFT(MAXIF), DXSHF
      COMPLEX BAND(2,MAXCHA)
      REAL RLOW, RDEL, TIME, TIMEC, WEIGHT(2*MAXIF),
     *   BNDPAS(2*MAXCIF), BANDW, PARM(MAXERP)
      INTEGER IBPRNO, IBPKOL(MAXBPC), IBPNMV(MAXBPC), IBCHAN, JROW,
     *   INDXCE, JIF, JPOL, J, K, NFILL, NN, M, JCHAN, JSUBA, JANT,
     *   IANT, ISOU, ISUBA, IREFA(2), IERR, I, IVER, NPOL, NZERO
      INCLUDE 'DTSIM.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C----------------------------------------------------------------------
C                                       Initialization
      IRET = 0
      IF (NDTBPD.EQ.0) GO TO 999
C                                       Create BP table
      IBCHAN = 1
      RLOW = 0.0
      RDEL = 0.0
      NPOL = MIN (2, NDTSTK)
      IVER = IDTBPV
      CALL BPINI ('WRIT', JBUFF, IDISK, ICNOUT, IVER, CATBLK, ILUN,
     *   IBPRNO, IBPKOL, IBPNMV, NDTBPA, NPOL, NDTIF, NDTCHN,
     *   IBCHAN, IDTBPN, RLOW, RDEL, LDTBPT, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1050) IRET
         GO TO 990
         END IF
C                                       Polynomial BP ?
      CALL CHBLNK (8, 1, LDTBPT, NN)
      WPOLY = (NN.NE.0)
C                                       Loop over BP entries
      DO 500 JROW = 1, NDTBPD
C                                       Start time
         TIME = RDTBPT(JROW)
C                                       Repeat:
C                                       Compute BP for center of this
C                                       solution interval.
100      TIMEC = TIME + RDTBPS(JROW) / 2.0
C                                       Loop over polarization
         DO 250 JPOL = 1,NPOL
C                                       Loop over IF
            DO 200 JIF = 1,NDTIF
C                                       Default unit bandpass
               DO 150 J = 1,NDTCHN
                  BAND(1,J) = (1.0, 0.0)
                  BAND(2,J) = (1.0, 0.0)
150               CONTINUE
C                                       Use calibration errors ?
               IF (IDTBPC(JROW).EQ.1) THEN
                  CALL DTINDX (LDTBAN(JROW), IDTBFQ(JROW), INDXCE)
C                                       Check for polynomial BP
                  IF (INDXCE.LE.0) THEN
                     CALL RFILL (MAXERP, 0.0, PARM)
                  ELSE
                     CALL RCOPY (MAXERP, RDTBP(1,JIF,JPOL,INDXCE), PARM)
                     END IF
                  IF (WPOLY) THEN
C                                       Transfer coeff. directly
                     NZERO = 0
C                                       Check for null BP
                     DO 155 M = 2, 9
                        IF (PARM(M).EQ.0.0) NZERO = NZERO + 1
155                     CONTINUE
                     IF (NZERO.EQ.8) PARM(2) = 2.0
C
                     DO 160 M = 1, NDTCHN
                        IF (M.LE.4) THEN
                           BAND(JPOL,M) = CMPLX (PARM(M+1), PARM(M+5))
                        ELSE
                           BAND(JPOL,M) = CMPLX (FBLANK, FBLANK)
                           END IF
160                     CONTINUE
                  ELSE
C                                       Simulate BP
                     DXSHF = 0.0D0
                     CALL DTBAND (INDXCE, JIF, TIMEC, DXSHF, BAND)
                     END IF
                  END IF
C                                       Fill BREAL,BIMAG arrays
C                                       (with flagging)
               DO 175 JCHAN = 1, NDTCHN
                  K = JCHAN + NDTCHN * ((JIF - 1) + NDTIF * (JPOL
     *               - 1))
                  BNDPAS(2 * K - 1) = REAL (BAND(JPOL,JCHAN))
                  BNDPAS(2 * K)      = AIMAG (BAND(JPOL,JCHAN))
C                                       Is this channel flagged ?
                  DO 165 I = 1, NDTIF
                     IF ((IDTBFP(I,JROW).NE.JPOL) .OR.
     *                  (IDTBFI(I,JROW).NE.JIF)) GO TO 165
                     M = 2 * (I - 1) + 1
                     IF ((IDTBFC(M,JROW).LE.JCHAN) .AND.
     *                  (IDTBFC(M+1,JROW).GE.JCHAN)) THEN
C                                       Blank
                        BNDPAS(2 * K - 1) = FBLANK
                        BNDPAS(2 * K)     = FBLANK
                        END IF
165                  CONTINUE
175               CONTINUE
200            CONTINUE
250         CONTINUE
C                                       If AC bandpass requested then
C                                       set phase/imag. to zero; square
C                                       if standard bandpass.
         IF (IDTBPX(JROW).EQ.1) THEN
            NFILL = NDTIF * NDTCHN * NPOL
            CALL CHBLNK (8, 1, LDTBPT, NN)
C                                       Standard BP
            IF (NN.EQ.0) THEN
               DO 275 J = 1, NFILL
                  IF ((BNDPAS(2 * J - 1).EQ.FBLANK) .OR.
     *               (BNDPAS(2 * J).EQ.FBLANK)) GO TO 275
C                                       Zero phase
                  DAMPL = SQRT (BNDPAS(2 * J - 1) ** 2
     *               + BNDPAS(2 * J) ** 2)
                  BNDPAS(2 * J) = 0.0
C                                       Square amplitude
                  BNDPAS(2 * J - 1) = DAMPL * DAMPL
275               CONTINUE
C                                       Polynomial BP
            ELSE
               DO 280 J = 1, NFILL
                  IF ((BNDPAS(2 * J - 1).NE.FBLANK) .AND.
     *               (BNDPAS(2 * J).NE.FBLANK)) THEN
                     BNDPAS(2 * J) = 0.0
                  END IF
  280             CONTINUE
               END IF
            END IF
C                                       Find antenna number
         ISUBA = 0
         IANT = 0
         JSUBA = 0
         DO 300 J = 1, NDTSUB
            IF (IDTSUB(J).EQ.IDTBSB(JROW)) JSUBA = J
300         CONTINUE
         IF (JSUBA.GT.0) THEN
            ISUBA = IDTSUB(JSUBA)
            JANT = 0
            DO 320 J = 1, NDTANT(JSUBA)
               IF (LDTANT(J,JSUBA).EQ.LDTBAN(JROW)) JANT = J
320            CONTINUE
            IF (JANT.GT.0) IANT = IDTANO(JANT,JSUBA)
            END IF
C                                       Write BP record
         DTIME = TIMEC
         ISOU = 0
         BANDW = 0.0
         CALL DFILL (NDTIF, 0.0D0, DSHFT)
         CALL FILL (2, 0, IREFA)
         CALL RFILL (NDTIF * NPOL, 1.0, WEIGHT)
         CALL TABBP ('WRIT', JBUFF, IBPRNO, IBPKOL, IBPNMV, NDTIF,
     *      NDTCHN, NPOL, DTIME, RDTBPS(JROW), ISOU, ISUBA, IANT,
     *      BANDW, DSHFT, IDTBFQ(JROW), IREFA, WEIGHT, BNDPAS, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1330) IRET
            GO TO 990
            END IF
C                                       Until (time > end) or (end = 0)
C                                        or (interv = 0);
         TIME = TIME + RDTBPI(JROW)
         IF ((TIME.LE.RDTBPE(JROW)) .AND. (RDTBPE(JROW).NE.0.0)
     *      .AND. (RDTBPI(JROW).NE.0.0)) GO TO 100
C
500      CONTINUE
C                                       Close BP table
      CALL TABIO ('CLOS', 0, IBPRNO, JBUFF, JBUFF, IERR)
      GO TO 999
C                                       Error
990   CALL MSGWRT (8)
C                                       Exit
999   RETURN
C----------------------------------------------------------------------
1050  FORMAT ('DTBPTB: ERROR',I4,' CREATING BP TABLE')
1330  FORMAT ('DTBPTB: ERROR',I4,' WRITING BP TABLE')
      END
C----------------------------------------------------------------------
C     Function RAND came from NETLIB
C     source: http://www.netlib.org/fn.rand.f
C     GAMS taxonomic reference: L6a21
C     stated purpose: portable uniform random number generator
C     Modifications:  entire routine was capitalized
C                     changed RAND to ADRAND everywhere
C                     included two lines of variable declarations
C---------------------------------------------------------------------
      FUNCTION ADRAND (R)
C
C      THIS PSEUDO-RANDOM NUMBER GENERATOR IS PORTABLE AMOUNG A WIDE
C VARIETY OF COMPUTERS.  RAND(R) UNDOUBTEDLY IS NOT AS GOOD AS MANY
C READILY AVAILABLE INSTALLATION DEPENDENT VERSIONS, AND SO THIS
C ROUTINE IS NOT RECOMMENDED FOR WIDESPREAD USAGE.  ITS REDEEMING
C FEATURE IS THAT THE EXACT SAME RANDOM NUMBERS (TO WITHIN FINAL ROUND-
C OFF ERROR) CAN BE GENERATED FROM MACHINE TO MACHINE.  THUS, PROGRAMS
C THAT MAKE USE OF RANDOM NUMBERS CAN BE EASILY TRANSPORTED TO AND
C CHECKED IN A NEW ENVIRONMENT.
C      THE RANDOM NUMBERS ARE GENERATED BY THE LINEAR CONGRUENTIAL
C METHOD DESCRIBED, E.G., BY KNUTH IN SEMINUMERICAL METHODS (P.9),
C ADDISON-WESLEY, 1969.  GIVEN THE I-TH NUMBER OF A PSEUDO-RANDOM
C SEQUENCE, THE I+1 -ST NUMBER IS GENERATED FROM
C             X(I+1) = (A*X(I) + C) MOD M,
C WHERE HERE M = 2**22 = 4194304, C = 1731 AND SEVERAL SUITABLE VALUES
C OF THE MULTIPLIER A ARE DISCUSSED BELOW.  BOTH THE MULTIPLIER A AND
C RANDOM NUMBER X ARE REPRESENTED IN DOUBLE PRECISION AS TWO 11-BIT
C WORDS.  THE CONSTANTS ARE CHOSEN SO THAT THE PERIOD IS THE MAXIMUM
C POSSIBLE, 4194304.
C      IN ORDER THAT THE SAME NUMBERS BE GENERATED FROM MACHINE TO
C MACHINE, IT IS NECESSARY THAT 23-BIT INTEGERS BE REDUCIBLE MODULO
C 2**11 EXACTLY, THAT 23-BIT INTEGERS BE ADDED EXACTLY, AND THAT 11-BIT
C INTEGERS BE MULTIPLIED EXACTLY.  FURTHERMORE, IF THE RESTART OPTION
C IS USED (WHERE R IS BETWEEN 0 AND 1), THEN THE PRODUCT R*2**22 =
C R*4194304 MUST BE CORRECT TO THE NEAREST INTEGER.
C      THE FIRST FOUR RANDOM NUMBERS SHOULD BE .0004127026,
C .6750836372, .1614754200, AND .9086198807.  THE TENTH RANDOM NUMBER
C IS .5527787209, AND THE HUNDREDTH IS .3600893021 .  THE THOUSANDTH
C NUMBER SHOULD BE .2176990509 .
C      IN ORDER TO GENERATE SEVERAL EFFECTIVELY INDEPENDENT SEQUENCES
C WITH THE SAME GENERATOR, IT IS NECESSARY TO KNOW THE RANDOM NUMBER
C FOR SEVERAL WIDELY SPACED CALLS.  THE I-TH RANDOM NUMBER TIMES 2**22,
C WHERE I=K*P/8 AND P IS THE PERIOD OF THE SEQUENCE (P = 2**22), IS
C STILL OF THE FORM L*P/8.  IN PARTICULAR WE FIND THE I-TH RANDOM
C NUMBER MULTIPLIED BY 2**22 IS GIVEN BY
C I   =  0  1*P/8  2*P/8  3*P/8  4*P/8  5*P/8  6*P/8  7*P/8  8*P/8
C RAND=  0  5*P/8  2*P/8  7*P/8  4*P/8  1*P/8  6*P/8  3*P/8  0
C THUS THE 4*P/8 = 2097152 RANDOM NUMBER IS 2097152/2**22.
C      SEVERAL MULTIPLIERS HAVE BEEN SUBJECTED TO THE SPECTRAL TEST
C (SEE KNUTH, P. 82).  FOUR SUITABLE MULTIPLIERS ROUGHLY IN ORDER OF
C GOODNESS ACCORDING TO THE SPECTRAL TEST ARE
C    3146757 = 1536*2048 + 1029 = 2**21 + 2**20 + 2**10 + 5
C    2098181 = 1024*2048 + 1029 = 2**21 + 2**10 + 5
C    3146245 = 1536*2048 +  517 = 2**21 + 2**20 + 2**9 + 5
C    2776669 = 1355*2048 + 1629 = 5**9 + 7**7 + 1
C
C      IN THE TABLE BELOW LOG10(NU(I)) GIVES ROUGHLY THE NUMBER OF
C RANDOM DECIMAL DIGITS IN THE RANDOM NUMBERS CONSIDERED I AT A TIME.
C C IS THE PRIMARY MEASURE OF GOODNESS.  IN BOTH CASES BIGGER IS BETTER.
C
C                   LOG10 NU(I)              C(I)
C       A       I=2  I=3  I=4  I=5    I=2  I=3  I=4  I=5
C
C    3146757    3.3  2.0  1.6  1.3    3.1  1.3  4.6  2.6
C    2098181    3.3  2.0  1.6  1.2    3.2  1.3  4.6  1.7
C    3146245    3.3  2.2  1.5  1.1    3.2  4.2  1.1  0.4
C    2776669    3.3  2.1  1.6  1.3    2.5  2.0  1.9  2.6
C   BEST
C    POSSIBLE   3.3  2.3  1.7  1.4    3.6  5.9  9.7  14.9
C
C             INPUT ARGUMENT --
C R      IF R=0., THE NEXT RANDOM NUMBER OF THE SEQUENCE IS GENERATED.
C        IF R.LT.0., THE LAST GENERATED NUMBER WILL BE RETURNED FOR
C          POSSIBLE USE IN A RESTART PROCEDURE.
C        IF R.GT.0., THE SEQUENCE OF RANDOM NUMBERS WILL START WITH THE
C          SEED R MOD 1.  THIS SEED IS ALSO RETURNED AS THE VALUE OF
C          RAND PROVIDED THE ARITHMETIC IS DONE EXACTLY.
C
C             OUTPUT VALUE --
C RAND   A PSEUDO-RANDOM NUMBER BETWEEN 0. AND 1.
C
C IA1 AND IA0 ARE THE HI AND LO PARTS OF A.  IA1MA0 = IA1 - IA0.
      REAL R, TMP, ADRAND
      INTEGER IA1, IA0, IA1MA0, IC, IX0, IX1, IY0, IY1
      SAVE IX0, IX1

      DATA IA1, IA0, IA1MA0 /1536, 1029, 507/
      DATA IC /1731/
      DATA IX1, IX0 /0, 0/
C-----------------------------------------------------------------------
      IF (R.LT.0.) GO TO 10
      IF (R.GT.0.) GO TO 20
C
C           A*X = 2**22*IA1*IX1 + 2**11*(IA1*IX1 + (IA1-IA0)*(IX0-IX1)
C                   + IA0*IX0) + IA0*IX0
C
      IY0 = IA0*IX0
      IY1 = IA1*IX1 + IA1MA0*(IX0-IX1) + IY0
      IY0 = IY0 + IC
      IX0 = MOD (IY0, 2048)
      IY1 = IY1 + (IY0-IX0)/2048
      IX1 = MOD (IY1, 2048)
C
 10   TMP = IX1*2048 + IX0
      ADRAND = TMP / 4194304.
      RETURN
C
 20   IX1 = AMOD(R,1.)*4194304. + 0.5
      IX0 = MOD (IX1, 2048)
      IX1 = (IX1-IX0)/2048
      GO TO 10
C
      END

      SUBROUTINE ALLTAB (NONOT, NOTTYP, LUNOLD, LUNNEW, VOLOLD, VOLNEW,
     *   CNOOLD, CNONEW, CATNEW, BUFF1, BUFF2, IRET)
C-----------------------------------------------------------------------
C! Copies all table extension files from one catalog slot to another
C# EXT-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2003, 2010, 2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ALLTAB copies all Table extension file(s).  The output files must
C   be new - old ones cannot be rewritten.  The output file must be
C   opened WRIT in the catalog and will have its CATBLK updated on disk.
C   NX tables are never copied.
C   Inputs:
C      NONOT   I       Number of "Forbidden" types to copy.
C      NOTTYP  C*2(*)  Table types to ignore.
C      LUNOLD  I       LUN for old file
C      LUNNEW  I       LUN for new file
C      VOLOLD  I       Disk number for old file.
C      VOLNEW  I       Disk number for new file.
C      CNOOLD  I       Catalog slot number for old file
C      CNONEW  I       Catalog slot number for new file
C   In/out:
C      CATNEW  I(256)  Catalog header for new file.
C   Output:
C      BUFF1   I(1024) Work buffer
C      BUFF2   I(1024) Work buffer
C      IRET    I       Return error code  0 => ok, otherwise TABCOP
C                                             or 10*CATIO error.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP(*)*2
      INTEGER   NONOT, LUNOLD, LUNNEW, VOLOLD, VOLNEW, CNOOLD, CNONEW,
     *   BUFF1(*), BUFF2(*), CATNEW(256), IRET
C
      INCLUDE 'INCS:PHDR.INC'
      INTEGER   IVERI, IVERO, IER, NONON, IEXT, JEXT, OLDNUM(NIEXTN)
      LOGICAL   TABLE, EXIST, FITASC
      CHARACTER READ*4, REST*4, OLDTYP(NIEXTN)*2, NONTAB(20)*2, BLANK*4
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C                                       Non table extension files
      DATA NONON /3/
      DATA NONTAB /'HI','PL','SL',17*'  '/
      DATA READ, REST, BLANK  /'READ','REST','    '/
C-----------------------------------------------------------------------
      IRET = 0
      IF ((VOLOLD.EQ.VOLNEW) .AND. (CNOOLD.EQ.CNONEW)) GO TO 999
C                                       Get old CATBLK in BUFF2.
      CALL CATIO (READ, VOLOLD, CNOOLD, BUFF2, REST, BUFF1, IRET)
      IF ((IRET.GE.1) .AND. (IRET.LE.4)) THEN
         WRITE (MSGTXT,1000) IRET
         CALL MSGWRT (6)
         IRET = 10 * IRET
         GO TO 999
      ELSE
         IRET = 0
         END IF
C                                       header ext format
      CALL FXHDEX (BUFF2)
C                                       Get extension file info
      DO 40 IEXT = 1,KIEXTN
         OLDTYP(IEXT) = BLANK
         CALL H2CHR (2, 1, BUFF2(KHEXT+IEXT-1), OLDTYP(IEXT))
         OLDNUM(IEXT) = BUFF2(KIVER+IEXT-1)
C                                       Do NOT copy NX tables
         IF (OLDTYP(IEXT).EQ.'NX') OLDNUM(IEXT) = 0
C                                       Check if on non table list
         DO 20 JEXT = 1,NONON
            IF (OLDTYP(IEXT).EQ.NONTAB(JEXT)) OLDNUM(IEXT) = 0
 20         CONTINUE
C                                       Check "forbidden" types
         IF (NONOT.LE.0) GO TO 40
            DO 30 JEXT = 1,NONOT
               IF (OLDTYP(IEXT).EQ.NOTTYP(JEXT)) OLDNUM(IEXT) = 0
 30            CONTINUE
 40      CONTINUE
C                                       Loop, copying tables.
      DO 100 IEXT = 1,KIEXTN
         IF (OLDNUM(IEXT).LE.0) GO TO 100
C                                       Copy each table independently
         DO 90 JEXT = 1,OLDNUM(IEXT)
C                                       See if files exist and are
C                                       wanted.
            CALL ISTAB (OLDTYP(IEXT), VOLOLD, CNOOLD, JEXT, LUNOLD,
     *         BUFF1, TABLE, EXIST, FITASC, IER)
            IF (TABLE .AND. EXIST .AND. (IER.EQ.0)) THEN
               IVERI = JEXT
               IVERO = JEXT
C                                       Copy
               CALL TABCOP (OLDTYP(IEXT), IVERI, IVERO, LUNOLD, LUNNEW,
     *            VOLOLD, VOLNEW, CNOOLD, CNONEW, CATNEW, BUFF1, BUFF2,
     *            IER)
               IRET = MAX (IER, IRET)
               END IF
 90         CONTINUE
 100     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ALLTAB: ERROR',I5,' READING OLD CATBLK')
      END

      SUBROUTINE ALIAS (ANTNO, AARRAY)
C-----------------------------------------------------------------------
C! implements antenna aliasing
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   The antenna number in ANTNO, if it appears in AARRAY(2:*) then it
C   is reset to AARRAY(2), AARRAY(1) should be the number of positive
C   elements in AARRAY inclusively.  e.g. AARRAY = 2 4 5 0 would be
C   incorrect; AARRAY = 3 4 5 0 would treat antenna 5 as if it were
C   antenna 4.
C   Inputs:
C      AARRAY   I(*)   (1) length of alias list
C                      (2) antenna to which others are aliased
C                      (3:AARRAY(1)) list of antennas aliased to (2)
C   In/Out:
C      ANTNO    I      in: antenna number to be (possibly) aliased
C                      out:(possibly) aliased antenna number
C-----------------------------------------------------------------------
      INTEGER   ANTNO, AARRAY(*)
C
      INTEGER   I
C-----------------------------------------------------------------------
      IF (AARRAY(1).GE.3) THEN
         DO 10 I = 3,AARRAY(1)
            IF (ANTNO.EQ.AARRAY(I)) ANTNO = AARRAY(2)
 10         CONTINUE
         END IF
C
 999  RETURN
      END

      PROGRAM GETTBC
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Program to read a gripe file and separate \tbc gripes into a
C   separate file.
C   DCW, 30Sept84
C-----------------------------------------------------------------------
      INTEGER     NGRIPE, LIN, LOUT, LTBC, L5, L6, NIN, NOUT, NTBC,
     *   NFIRST, NLAST, KSPLIT, ITRIM
      CHARACTER   GRIPE*5000, NEWLIN*3, INFIL*30, OUTFIL*30, TBCFIL*30,
     *   SPLIT*20, STAT*6, GRARGS(9)*5000, FNLOUT*1, FNLTBC*1, FNLIN*1
      DATA        LIN, LOUT, LTBC, L5, L6 /1, 2, 3, 5, 6/
      DATA        NEWLIN /'|||'/
C-----------------------------------------------------------------------
C                                       initialize: infile
 10   CONTINUE
         WRITE (L6,1010) ' INFIL'
         READ (L5,1015) INFIL
         IF (INFIL.EQ.' ') GO TO 15
            CALL PADTEX (L6, INFIL)
            OPEN (UNIT=LIN, FILE=INFIL, STATUS='OLD', ERR=10)
            GO TO 20
 15      CONTINUE
            OPEN (UNIT=LIN, FILE='GRINFIL', STATUS='OLD', ERR=10)
 20   CONTINUE
         WRITE (L6, 1010) 'OUTFIL'
         READ (L5, 1015) OUTFIL
         IF (OUTFIL.EQ.' ') GO TO 25
            CALL PADTEX (L6, OUTFIL)
            OPEN (UNIT=LOUT, FILE=OUTFIL, STATUS='NEW',
     *         CARRIAGECONTROL='LIST', ERR=20)
            GO TO 30
 25      CONTINUE
            OPEN (UNIT=LOUT, FILE='GROUTFIL', STATUS='NEW',
     *         CARRIAGECONTROL='LIST', ERR=20)
 30   CONTINUE
         WRITE (L6, 1010) 'TBCFIL'
         READ (L5, 1015) TBCFIL
         IF (TBCFIL.EQ.' ') GO TO 35
            CALL PADTEX (L6, TBCFIL)
            OPEN (UNIT=LTBC, FILE=TBCFIL, STATUS='NEW',
     *         CARRIAGECONTROL='LIST', ERR=30)
            GO TO 40
 35      CONTINUE
            OPEN (UNIT=LTBC, FILE='GRTBCFIL', STATUS='NEW',
     *         CARRIAGECONTROL='LIST', ERR=30)
 40   CONTINUE
         WRITE (L6,1040) 'OUTFIL'
         FNLOUT = 'F'
         READ (L5,1015,ERR=40) FNLIN
         IF (FNLIN.EQ.'T') FNLOUT = 'T'
 42   CONTINUE
         WRITE (L6,1040) 'TBCFIL'
         FNLTBC = 'F'
         READ (L5,1015,ERR=42) FNLIN
         IF (FNLIN.EQ.'T') FNLTBC = 'T'
 45   CONTINUE
         WRITE (L6,1045)
         READ (L5,1015,ERR=45) SPLIT
         IF (SPLIT.EQ.' ') GO TO 45
         KSPLIT = ITRIM (SPLIT)
      NIN = 0
      NOUT = 0
      NTBC = 0
C                                       big loop:
 50   CONTINUE
         CALL GETGRI (L6, LIN, NEWLIN, NGRIPE, GRIPE, GRARGS)
         IF (GRIPE.EQ.' ') GO TO 900
         NIN = NIN + 1
         IF (NIN.EQ.1) NFIRST = NGRIPE
C                                       test for "splitting" string:
         IF (INDEX (GRIPE, SPLIT(1:KSPLIT)).NE.0) GO TO 60
            IF (NOUT.EQ.0) WRITE (LOUT,1050) FNLOUT
            CALL WRIGRI (L6, LOUT, NEWLIN, GRIPE)
            NOUT = NOUT + 1
            GO TO 70
 60      CONTINUE
            IF (NTBC.EQ.0) WRITE (LTBC,1050) FNLTBC
            CALL WRIGRI (L6, LTBC, NEWLIN, GRIPE)
            NTBC = NTBC + 1
 70      CONTINUE
         NLAST = NGRIPE
         GO TO 50
C                                       that's all, folks:
 900  CONTINUE
      WRITE (L6, 1900) NIN, NFIRST, NLAST, NOUT, NTBC, SPLIT(1:KSPLIT)
      CLOSE (UNIT=LIN)
C                                       close LOUT:
      IF (NOUT.GT.0) GO TO 910
         STAT = 'DELETE'
         GO TO 920
 910  CONTINUE
         WRITE (LOUT, 1920)
         STAT = 'KEEP'
 920  CLOSE (UNIT=LOUT, STATUS=STAT)
C                                       close LTBC:
      IF (NTBC.GT.0) GO TO 930
         STAT = 'DELETE'
         GO TO 940
 930  CONTINUE
         WRITE (LTBC, 1920)
         STAT = 'KEEP'
 940  CONTINUE
      CLOSE (UNIT=LTBC, STATUS=STAT)
C-----------------------------------------------------------------------
 1010 FORMAT (' GETTBC: enter name for file ', A6, ': ', $)
 1015 FORMAT (A30)
 1040 FORMAT (' GETTBC: enter \finalrun for file ', A6, ': ', $)
 1045 FORMAT (' GETTBC: enter the "splitting" string (e.g., \tbc): ', $)
 1050 FORMAT ('\input aipsgrip:gripemac5.tex', /,
     *        '\def\finalrun{',A,'}', /)
 1900 FORMAT (' GETTBC:', I5, ' gripes in (', I4, ' to', I5,
     *                                       '), separated into', /,
     *        '        ', I5, ' regular and', I5, ' containing "',
     *                                       A, '".')
 1920 FORMAT ('\end')
      END

      SUBROUTINE ZSSSLK (OP, IERR)
C-----------------------------------------------------------------------
C! lock SUN-Screen-Server (TV) device
C# TV-IO
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 2000, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Lock/unlock SUN-Screen-Server (TV) device
C   Inputs:
C      OP     C*4   'LOCK', 'UNLK'
C   Output:
C      IERR   I     Error return code: 0 = no error
C                      1 = LUN already in use
C                      2 = file not found
C                      3 = volume not found
C                      4 = excl requested but not available
C                      5 = no room for lun
C                      6 = other open errors
C   Uses TVLUN2, TVIND2 from common
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   IERR
C
      CHARACTER PNAME*48
      HOLLERITH HNAME(12)
      LOGICAL   F
      INTEGER   ERRLUN, ERRTER, IT, IER
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA F /.FALSE./
      DATA ERRLUN, ERRTER /12, 6/
C-----------------------------------------------------------------------
      CALL ZPHFIL ('TV', 1, 1, 1, PNAME, IER)
C
      IERR = 6
      IF ((TVLUN2.EQ.ERRLUN) .OR. (TVLUN2.EQ.ERRTER)) GO TO 980
      IF ((TVLUN2.LE.0) .OR. (TVLUN2.GT.50)) GO TO 980
      IERR = 0
C                                       allocate table
      CALL LSERCH ('OPEN', TVLUN2, TVIND2, F, IER)
      IF (IER.NE.0) THEN
         IF (IER.EQ.2) THEN
            IERR = 1
            WRITE (MSGTXT,1000) TVLUN2
            GO TO 990
         ELSE IF (IER.EQ.3) THEN
            IERR = 5
            WRITE (MSGTXT,1005) TVLUN2
         ELSE
            IERR = 6
            WRITE (MSGTXT,1010) IER, TVLUN2
            END IF
         GO TO 990
         END IF
C                                       non-disk devices
      IT = 0
      IF (OP.EQ.'LOCK') IT = 1
      CALL CHR2H (48, PNAME, 1, HNAME)
      CALL ZSSSL2 (FTAB(TVIND2+NMOFF), HNAME, IT, IER)
      IF (IER.EQ.4) THEN
         IERR = 4
      ELSE IF (IER.NE.0) THEN
         IERR = 6
         WRITE (MSGTXT,1020) IER, OP
         CALL MSGWRT (6)
      ELSE
         IERR = 0
         END IF
C                                       remove FTAB
      CALL LSERCH ('CLOS', TVLUN2, TVIND2, F, IER)
      IF (IERR.NE.0) TVIND2 = 0
      GO TO 999
C                                       Errors
C                                       illegal lun
 980  WRITE (MSGTXT,1980) TVLUN2, PNAME(1:24)
C                                       print msg
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZSSSLK: LUN',I4,' ALREADY IN USE')
 1005 FORMAT ('ZSSSLK: LUN TABLE FULL, CANT FIT LUN',I4)
 1010 FORMAT ('ZSSSLK: ERROR',I5,' LUN',I2,' ON LSERCH')
 1020 FORMAT ('ZSSSLK: ERROR',I4,' ON ',A)
 1980 FORMAT ('ZSSSLK: LUN',I6,' ILLEGAL FOR ',A24)
      END

      SUBROUTINE YGRAPH (OP, CHAN, SCRTCH, IERR)
C-----------------------------------------------------------------------
C! turns TV graphics planes on and off
C# Y1 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YGRAPH is used to turn graphics overlay planes on & off by
C   altering the graphics color look up table.  The color pattern is:
C      CHAN = 1    insert   yellow            drawing plots
C             2    insert   green+.05 red     axis labels
C             3    insert   blue + 0.6 green  blotch
C                           + red
C             4    insert   black             label backgrounds
C             5-7  add      nothing           null channels
*>                                      MRC 87/Apr/07: Further colours.
*             5    insert   white             miscellaneous.
*             6    insert   aquamarine        miscellaneous.
*             7    insert   red               miscellaneous.
*=
*<
C             8    insert   purple            cursor
C   Inputs:
C      OP      C*4       'ONNN' or 'OFFF'
C      CHAN    I         channel number (1 - 8)
C   Output:
C      SCRTCH  I(256)    scratch buffer
C      IERR    I         error code of Z...XF: 0 => ok
C                                              2 => input error
C   DeAnza version (W. Jaffe)
C   I have substituted a slower but simpler algorithim than the original
C   IIS code.  That code was near impossible to impliment on DEANZA.
*>                                      MRC 90/May/16:
*   MRC 87/Apr/07: Modifications for the default graphics colours and
*                  for changing them interactively.
*=
*<
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   CHAN, SCRTCH(256), IERR
C
      LOGICAL   VRTRTC, NOCUR, LON
      INTEGER   DCOLOR(8), ANSERT(8), BITS(16), IJ, ZEOR, ZOR, I,
     *   ICOLOR, IDX, INSERT, J, LCOLOR, ENABLE, ITEMP
      INCLUDE 'INCS:YDEA.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA ANSERT /1,1,1,1,0,0,0,1/
C     BGR values   00:15:15, 00:15:00, 15:03:03, 00:00:00,
C                  15:15:15, 00:15:15, 15:15:00, 15:00:15
      DATA DCOLOR /  17407,    17392,    32371,    16912,
     :               32767,    17407,    32752,    32287/
      DATA VRTRTC, NOCUR /.FALSE., .FALSE./
C                                       For BLACK overlay need to set
C                                       enable bits on, but intensity
C                                       values to zero.  Z4210=16912
      DATA ENABLE /16912/
C-----------------------------------------------------------------------
C                                       Initialization only
      IF (OP.EQ.'INIT') THEN
         IERR = 0
         CALL COPY (8, DCOLOR, YBUFF(GRPHCL))
         GO TO 999
         END IF
C                                        check input
      IERR = 2
      IF ((CHAN.LT.1) .OR. (CHAN.GT.8)) GO TO 999
      IF ((OP.NE.'ONNN') .AND. (OP.NE.'OFFF')) GO TO 999
      IF (YBUFF(GRPHCL+7).EQ.0) CALL COPY (8, DCOLOR, YBUFF(GRPHCL))
C                                        color = 0 => nothing to do
 20   IERR = 0
      INSERT = ANSERT(CHAN)
      ICOLOR = YBUFF(GRPHCL+CHAN-1)
      IF ((ICOLOR.EQ.0) .AND. (INSERT.EQ.0)) GO TO 999
C                                        Cursor
      IF (CHAN.EQ.8) THEN
         CALL FILL (256, ICOLOR, SCRTCH)
         CALL YGGRAM ('WRIT', .TRUE., SCRTCH, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR
            CALL MSGWRT (6)
            END IF
         GO TO 999
         END IF
C                                        read existing graphics LUT
      CALL YGGRAM ('READ', NOCUR, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      IDX = (2 ** (CHAN-1)) + 1
C                                       Set no-intersection color on/off
      IF (OP.EQ.'ONNN') THEN
         SCRTCH(IDX) = ICOLOR
      ELSE
         SCRTCH(IDX) = 0
         END IF
C                                        plane intersections: use XOR
C                                        of colors presently on.
      DO 120 I = 1,256
         ITEMP = I - 1
         CALL ZGTBIT (16, ITEMP, BITS)
C                                        CHAN intersects this level
         IF (BITS(CHAN).EQ.1) THEN
            LCOLOR = 0
            LON = .FALSE.
            DO 110 J = 1,8
               IF (BITS(J).NE.0) THEN
                  IJ = (2**(J-1))
                  LON = LON .OR. (SCRTCH(IJ+1).NE.0)
                  LCOLOR= ZEOR (LCOLOR, SCRTCH(IJ+1))
                  END IF
 110           CONTINUE
C                                       If on fix up enable bits
            IF (LON) THEN
               SCRTCH(I) = ZOR (LCOLOR, ENABLE)
            ELSE
               SCRTCH(I) = 0
               END IF
            END IF
 120     CONTINUE
C                                        return the lut to graphics ram
      CALL YGGRAM ('WRIT', NOCUR, SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('YGRAPH: ERROR',I3,' WRITING THE CURSOR LUT.')
      END

C   AIPS Object Oriented utility module
C-----------------------------------------------------------------------
C! Object Oriented AIPS Fortran utility module.
C# Ext-util Utility Object-Oriented
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2008, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  Public functions:
C    OBSCNF (name, scrno, ierr)
C       Fills in file description info for a scratch file created
C       outside of the OOP package.
C    OBFEXS (name, exist, ierr)
C       Determines if an object exists, for objects with an underlying
C       disk file the existance of this file is also checked. ierr=0
C       mean it exists else not.
C    OBFSIZ (name, exist, size, ierr)
C       Determines if an object exists, for objects with an underlying
C       disk file the existance of this file is also checked and the
C       size returned,  ierr=0 mean it exists else not.
C    OBACF (disk, cno, index)
C       Determines if a specified AIPS disk and catalog slot already has
C       an AIPS catalog flags set and registered in the DFIL.INC common.
C    OBCSYN (name, ierr)
C       Synchronizes the memory resident CATBLK with the one on disk,
C       i.e. reads from disk.
C    FNDSKC (name, disk, cno, ierr)
C       Looks up disk, cno number; object need not have been previously
C       opened.
C-----------------------------------------------------------------------
      SUBROUTINE OBSCNF (NAME, SCRNO, IERR)
C-----------------------------------------------------------------------
C   OOP utility routine
C   Fills in file descriptive information for an object associated with
C   an AIPS scratch file created outside of the OOP package.  It is
C   passed the scratch file number in the common in DFIL.INC.
C   Also reads disk catalog header into object memory.
C   Inputs:
C      NAME    C*?  Name of input object with associated scratch file.
C      SCRNO   I    DFIL.INC scratch file number
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   SCRNO, IERR
      CHARACTER NAME*(*)
C
      INTEGER   OBJNUM, DIM(7), CSEQ, CUSID, DUMMY
      CHARACTER CNAME*12, CCLASS*6, CPTYPE*2, STAT*4, CDUMMY*1
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       Object number
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Scratch file number
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      CALL OBPUT (OBJNUM, 'SCRCNO', OOAINT, DIM, SCRNO, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Disk
      CALL OBPUT (OBJNUM, 'DISK', OOAINT, DIM, SCRVOL(SCRNO), CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 990
C                                       CNO
      CALL OBPUT (OBJNUM, 'CNO', OOAINT, DIM, SCRCNO(SCRNO), CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Names
      CALL CATDIR ('INFO', SCRVOL(SCRNO), SCRCNO(SCRNO), CNAME, CCLASS,
     *   CSEQ, CPTYPE, CUSID, STAT, SBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 995
         END IF
C                                       Save name
      DIM(1) = LEN (CNAME)
      CALL OBPUT (OBJNUM, 'NAME', OOACAR, DIM, DUMMY, CNAME, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Save class
      DIM(1) = LEN (CCLASS)
      CALL OBPUT (OBJNUM, 'CLASS', OOACAR, DIM, DUMMY, CCLASS, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Save sequence
      DIM(1) = 1
      CALL OBPUT (OBJNUM, 'IMSEQ', OOAINT, DIM, CSEQ, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Save CATBLK
      CALL CATIO ('READ', SCRVOL(SCRNO), SCRCNO(SCRNO), CATBLK, 'REST',
     *   SBUFF, IERR)
      IF ((IERR.GE.1) .AND. (IERR.LE.4)) THEN
         WRITE (MSGTXT,1001) IERR
         GO TO 995
         END IF
      IERR = 0
      CALL OBHPUT (NAME, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 995  CALL MSGWRT (6)
 990  MSGTXT = 'OBSCNF: ERROR SPECIFYING ' // NAME
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('OBSCNF: CATDIR ERROR ', I4)
 1001 FORMAT ('OBSCNF: CATIO ERROR ', I4)
      END
      SUBROUTINE OBFEXS (NAME, EXIST, IERR)
C-----------------------------------------------------------------------
C   OOP utility routine
C   Determines if and object exists, for objects with an underlying
C   disk file the existance of this file is also checked.
C   Inputs:
C      NAME    C*?  Name of input object to be tested
C   Output:
C      EXIST   L    True if object fully instantiated
C      IERR    I    Error code: 0 => ok 1 => usually means does not
C                                            exist
C-----------------------------------------------------------------------
      INTEGER   IERR
      LOGICAL   EXIST
      CHARACTER NAME*(*)
C
      INTEGER   NDSK
C                                       NDSK = lisk of classes with
C                                       underlying disk files.
      PARAMETER (NDSK=3)
      INTEGER   OBJNUM, CLASNO, LOOP, DISK, CNO, VER, TYPE, DIM(7),
     *   ISIZE, MSGSAV, DUMMY
      CHARACTER CNAME*8, DSKCLA(NDSK)*8, NAMCLT*20, FNAME*48, FTYPE*2
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA DSKCLA /'IMAGE', 'UVDATA', 'TABLE'/
C-----------------------------------------------------------------------
      EXIST = .FALSE.
      MSGSAV = MSGSUP
C                                       Is the object extant
      MSGSUP = 32000
      CALL OBNAME (NAME, OBJNUM, IERR)
      MSGSUP = MSGSAV
      IF (IERR.EQ.1) THEN
         IERR = 0
         GO TO 999
         END IF
      IF (IERR.NE.0) GO TO 995
C                                       Object class
      MSGSUP = 32000
      CALL OBCLAS (OBJNUM, CLASNO, CNAME, IERR)
      MSGSUP = MSGSAV
      IF (IERR.EQ.1) THEN
         IERR = 0
         GO TO 999
         END IF
      IF (IERR.NE.0) GO TO 995
C                                       Check for disk?
      DO 100 LOOP = 1,NDSK
         IF (CNAME.EQ.DSKCLA(LOOP)) GO TO 200
 100     CONTINUE
C                                       Nope?
      EXIST = .TRUE.
      GO TO 999
C                                       Check disk file
 200  MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL FNDSKC (NAME, DISK, CNO, IERR)
      MSGSUP = MSGSAV
      IF (IERR.EQ.1) THEN
         DISK = 0
         IERR = 0
         END IF
      IF (IERR.NE.0) GO TO 995
      IF ((DISK.LE.0) .OR. (CNO.LE.0)) GO TO 999
C                                       Tables are different
      IF (CNAME.EQ.'TABLE') THEN
         CALL TBLKUP (NAME, DISK, CNO, FTYPE, VER, IERR)
         IF (IERR.NE.0) GO TO 990
      ELSE
         CALL FNAGET (NAME, 'NAMCLSTY', TYPE, DIM, DUMMY, NAMCLT, IERR)
         IF (IERR.NE.0) GO TO 990
         FTYPE = NAMCLT(19:20)
         VER = 1
         END IF
C                                       Does file exist?
      CALL ZPHFIL (FTYPE, DISK, CNO, VER, FNAME, IERR)
      CALL ZEXIST (DISK, FNAME, ISIZE, IERR)
      EXIST = IERR .EQ. 0
      IF (IERR.EQ.1) IERR = 0
      GO TO 999
C                                       Error
 995  CALL MSGWRT (7)
 990  MSGTXT = 'OBFEXS: DETERMINING EXISTANCE OF ' // NAME
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE OBFSIZ (NAME, EXIST, SIZE, IERR)
C-----------------------------------------------------------------------
C   OOP utility routine
C   Determines if and object exists, for objects with an underlying
C   disk file the existance of this file is also checked.
C   Inputs:
C      NAME    C*?  Name of input object to be tested
C   Output:
C      EXIST   L    True if object fully instantiated
C      SIZE    I    size of file in AIPS blocks (256-word records)
C      IERR    I    Error code: 0 => ok 1 => usually means does not
C                                            EXIST
C-----------------------------------------------------------------------
      INTEGER   SIZE, IERR
      LOGICAL   EXIST
      CHARACTER NAME*(*)
C
      INTEGER   NDSK
C                                       NDSK = lisk of classes with
C                                       underlying disk files.
      PARAMETER (NDSK=3)
      INTEGER   OBJNUM, CLASNO, LOOP, DISK, CNO, VER, TYPE, DIM(7),
     *   MSGSAV, DUMMY
      CHARACTER CNAME*8, DSKCLA(NDSK)*8, NAMCLT*20, FNAME*48, FTYPE*2
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA DSKCLA /'IMAGE', 'UVDATA', 'TABLE'/
C-----------------------------------------------------------------------
      EXIST = .FALSE.
      SIZE = 0
      MSGSAV = MSGSUP
C                                       Is the object extant
      MSGSUP = 32000
      CALL OBNAME (NAME, OBJNUM, IERR)
      MSGSUP = MSGSAV
      IF (IERR.EQ.1) THEN
         IERR = 0
         GO TO 999
         END IF
      IF (IERR.NE.0) GO TO 995
C                                       Object class
      MSGSUP = 32000
      CALL OBCLAS (OBJNUM, CLASNO, CNAME, IERR)
      MSGSUP = MSGSAV
      IF (IERR.EQ.1) THEN
         IERR = 0
         GO TO 999
         END IF
      IF (IERR.NE.0) GO TO 995
C                                       Check for disk?
      DO 100 LOOP = 1,NDSK
         IF (CNAME.EQ.DSKCLA(LOOP)) GO TO 200
 100     CONTINUE
C                                       Nope?
      EXIST = .TRUE.
      GO TO 999
C                                       Check disk file
 200  MSGSAV = MSGSUP
      MSGSUP = 32000
      CALL FNDSKC (NAME, DISK, CNO, IERR)
      MSGSUP = MSGSAV
      IF (IERR.EQ.1) THEN
         DISK = 0
         IERR = 0
         END IF
      IF (IERR.NE.0) GO TO 995
      IF ((DISK.LE.0) .OR. (CNO.LE.0)) GO TO 999
C                                       Tables are different
      IF (CNAME.EQ.'TABLE') THEN
         CALL TBLKUP (NAME, DISK, CNO, FTYPE, VER, IERR)
         IF (IERR.NE.0) GO TO 990
      ELSE
         CALL FNAGET (NAME, 'NAMCLSTY', TYPE, DIM, DUMMY, NAMCLT, IERR)
         IF (IERR.NE.0) GO TO 990
         FTYPE = NAMCLT(19:20)
         VER = 1
         END IF
C                                       Does file exist?
      CALL ZPHFIL (FTYPE, DISK, CNO, VER, FNAME, IERR)
      CALL ZEXIST (DISK, FNAME, SIZE, IERR)
      EXIST = IERR.EQ.0
      IF (IERR.EQ.1) IERR = 0
      GO TO 999
C                                       Error
 995  CALL MSGWRT (7)
 990  MSGTXT = 'OBFSIZ: DETERMINING SIZE OF ' // NAME
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE OBACF (DISK, CNO, INDEX)
C-----------------------------------------------------------------------
C   Determines if a specified AIPS disk and catalog slot already has
C   an AIPS catalog flags set and registered in the DFIL.INC common and
C   if so which entry in the CFIL.INC arrays correspond to this AIPS
C   catalog entry.
C   Inputs:
C      DISK   I  AIPS disk number
C      CNO    I  AIPS catalog slot number
C   Output:
C      INDEX  I  Corresponding index in DFIL.INC arrays, 0 => not found.
C-----------------------------------------------------------------------
      INTEGER   DISK, CNO, INDEX
C
      INTEGER   LOOP
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
      INDEX = 0
      DO 100 LOOP = 1,NCFILE
         IF ((FVOL(LOOP).EQ.DISK) .AND. (FCNO(LOOP).EQ.CNO)) THEN
            INDEX = LOOP
            GO TO 999
            END IF
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE OBCSYN (NAME, IERR)
C-----------------------------------------------------------------------
C   Reads a new version of the catalog header for NAME from disk.
C   Inputs:
C      NAME    C*?  Name of input object.
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   IERR
C
      INTEGER   DISK, CNO
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:CLASSIO.INC'
C-----------------------------------------------------------------------
C                                       Find disk, cno
      CALL OBDSKC (NAME, DISK, CNO, IERR)
      IF (IERR.NE.0) GO TO 995
C                                       Fetch  CATBLK
      CALL CATIO ('READ', DISK, CNO, CATBLK, 'REST', SBUFF, IERR)
      IF ((IERR.GE.1) .AND. (IERR.LE.4)) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
C                                       Svae CATBLK
      CALL OBHPUT (NAME, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 995
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (7)
 995  MSGTXT = 'OBCSYN: ERROR SYNCING CATBLK FOR  ' // NAME
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' READING SCRATCH FILE CATBLK')
      END
      SUBROUTINE FNDSKC (NAME, DISK, CNO, IERR)
C-----------------------------------------------------------------------
C   Return Disk and slot information for object, works for any class and
C   the object need not have been previously opened.
C      Also saves FILE_NAME NAMCLSTY and CNO.
C   Inputs:
C      NAME   C*32  Name of object
C   Outputs:
C      DISK   I     Disk number
C      CNO    I     Catalog slot number
C      IERR   I     Error code, 0=OK. 1= file not found.
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   DISK, CNO, IERR
C
      INTEGER   TYPE, DIM(3), CSEQ, CUSID, DUMMY
      CHARACTER CNAME*12, CCLASS*6, CPTYPE*2, STAT*4, FNCT*20, CDUMMY*1
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Find disk  and slot
      CALL FNAGET (NAME, 'DISK', TYPE, DIM, DISK, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL FNAGET (NAME, 'NAME', TYPE, DIM, DUMMY, CNAME, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL FNAGET (NAME, 'CLASS', TYPE, DIM, DUMMY, CCLASS, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL FNAGET (NAME, 'IMSEQ', TYPE, DIM, CSEQ, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      CNO = 0
      CPTYPE = '  '
      CUSID = 0
      CALL CATDIR ('SRCH', DISK, CNO, CNAME, CCLASS, CSEQ, CPTYPE,
     *   CUSID, STAT, SBUFF, IERR)
      IF (IERR.EQ.5) THEN
         IERR = 1
         GO TO 999
         END IF
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 995
         END IF
C                                       Save values
      FNCT = CNAME // CCLASS // CPTYPE
      DIM(1) = LEN (FNCT)
      DIM(2) = 1
      CALL FNAPUT (NAME, 'NAMCLSTY', OOACAR, DIM, DUMMY, FNCT, IERR)
      IF (IERR.NE.0) GO TO 990
      DIM(1) = 1
      CALL FNAPUT (NAME, 'CNO', OOAINT, DIM, CNO, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 995  CALL MSGWRT (6)
 990  MSGTXT = 'FNDSKC: ERROR WITH ' // NAME
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FNDSKC: CATDIR ERROR ', I4)
      END

      SUBROUTINE ZRLR32 (NVAL, NP, INB, OUTB)
C-----------------------------------------------------------------------
C! converts buffer of local REAL values to IEEE 32-bit floating-point
C# Binary
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Converts from local single precision to 32 bit IEEE floating format.
C
C   The IEEE format is:
C
C                1         2         3
C      01234567890123456789012345678901
C      seeeeeeeemmmmmmmmmmmmmmmmmmmmmmm
C
C   where sign = -1 _*_* s, exponent = eee..., mantissa = 1.mmmmm...
C
C   The value is given by:
C
C      value = sign _* 2 _*_*(exp-127) _* mantissa
C
C   Note: these values have a "hidden" bit and must always be normalized
C   The IEEE nan (not a number) values are used to indicate an invalid
C   number; a value with all bits set is recognized as a "nan".
C
C   The AIPS internal format for an invalid number is the value which
C   has the same bit pattern as 'INDE'.
C
C   The IEEE special values (-0., +/- Infty) are not recognized.
C
C   A multiplication by a factor of 4.0 converts between VAX F and IEEE
C   32 bit formats.
C
C   Inputs:
C      NVAL   I      Number of values to convert
C      NP     I      First value in OUTB for result
C      INB    R(*)   Local format values
C   Output:
C      OUTB   R(*)   32-bit IEEE FORMAT values ('INDE' values are
C                    replaced with "nan")
C   Generic version - does IEEE and VAX F formats for 32-bit machines,
C   is stubbed with STOP for all others.
C-----------------------------------------------------------------------
      INTEGER   NVAL, NP
      REAL      INB(*), OUTB(*)
C
      INTEGER   LOOP, I4NAN, J
      REAL      R4NAN
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (I4NAN, R4NAN)
C                                       Equivalence should yield
C                                       R4NAN = FFFFFFFF
      DATA I4NAN /-1/
C-----------------------------------------------------------------------
      IF (NVAL.LE.0) GO TO 999
C                                       only works for 32-bit words
      IF (NBITWD.NE.32) THEN
         WRITE (MSGTXT,1000) NBITWD
         CALL MSGWRT (10)
         STOP
      ELSE
C                                       IEEE floating-point - copy
         IF (SPFRMT.EQ.1) THEN
            DO 10 LOOP = 1,NVAL
               J = LOOP + NP - 1
               IF (INB(LOOP).EQ.FBLANK) THEN
                  OUTB(J) = R4NAN
               ELSE
                  OUTB(J) = INB(LOOP)
                  END IF
 10            CONTINUE
            LOOP = 2 * NVAL
            CALL ZBYTFL (LOOP, OUTB(NP), OUTB(NP))
C                                       VAX F - multiply by 4
         ELSE IF (SPFRMT.EQ.2) THEN
            DO 20 LOOP = 1,NVAL
               J = LOOP + NP - 1
               IF (INB(LOOP).EQ.FBLANK) THEN
                  OUTB(J) = R4NAN
               ELSE
                  OUTB(J) = INB(LOOP) * 0.250
                  END IF
 20            CONTINUE
            LOOP = 2 * NVAL
            CALL ZBYTFL (LOOP, OUTB(NP), OUTB(NP))
C                                       VAX G, IBM not easy
         ELSE IF (SPFRMT.EQ.4) THEN
               
               CALL S2IEEE(NVAL,INB,OUTB(NP))

         ELSE
            WRITE (MSGTXT,1020) SPFRMT
            CALL MSGWRT (10)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZRLR32: REQUIRES LOCAL DEVELOPMENT FOR NBITWD =',I7)
 1020 FORMAT ('ZRLR32: REQUIRES LOCAL DEVELOPMENT FOR SPFRMT =',I7)
      END

      SUBROUTINE TRTOCS (APCORE, ISB, NCORR, DATA, WORK)
C-----------------------------------------------------------------------
C! FFT correlation functions -> spectra
C# UV IO-appl Calibration Spectral
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  This routine transforms a complex correlation function DATA of
C  length NCORR to a single sideband, complex spectrum of length
C  NSPEC=NCORR/2.
C  Inputs:
C      DATA(2,NCORR)    R     array containing the delay lag function
C      WORK(2,NCORR)    R     work array
C      NCORR            I     length of complex correlation function
C      ISB              I     sideband of output data (1=upper,-1=lower)
C  Outputs:
C      DATA(2,NSPEC)    R     array containing the transformed data
C  P. Diamond   18 March 1987
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   NCORR, ISB, K, I, NSPEC
      INTEGER   FFTDIR
      REAL      DATA(2,*), WORK(2,*), TEMP1, TEMP2
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DCVL.INC'
C-----------------------------------------------------------------------
      NSPEC = NCORR / 2
C
C                            Rearrange the correlation function so that
C                            the center channel (ncorr/2 + 1) winds up
C                            in the first element of the array to be
C                            transformed.  the correlation function
C                            to be transformed should be (nspec * 2)
C                            points long.
      DO 10 I = 1,NSPEC
         K = I + NSPEC
         TEMP1 = DATA(1,I)
         TEMP2 = DATA(2,I)
         DATA(1,I) = DATA(1,K)
         DATA(2,I) = DATA(2,K)
         DATA(1,K) = TEMP1
         DATA(2,K) = TEMP2
 10      CONTINUE
C                            transform
C                            isign determines which sideband will end
C                            up in first half of data
      FFTDIR = ISB
C                                       Use AP routines
      IF (POWRTO .OR. PRIME) THEN
         CALL QPUT (APCORE, DATA(1,1), APBEG, NCMPLX, APTYPE)
         CALL QWD
         FFTDIR = -FFTDIR
         CALL QCFFT (APCORE, APBEG, NCORR, FFTDIR)
         CALL QWR
         CALL QGET (APCORE, DATA(1,1), APBEG, NCMPLX, APTYPE)
         CALL QWD
C                                       non-AP routine
      ELSE
         CALL FOURG (DATA, NCORR, FFTDIR, WORK)
         END IF
C
      RETURN
      END

      INTEGER FUNCTION AKCESS (FIL, BUFFER)
C-----------------------------------------------------------------------
C! *TESS routine to read or write files
C# IO-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   AKCESS accesses (reads from or writes to) a scratch file using MDISK
C   Programmer =  T.J. Cornwell      December 1987
C-----------------------------------------------------------------------
      INTEGER   FIL, LUN, IARG, IERR
      REAL      BUFFER(*)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
      LUN = BUFNUM(FIL) + 15
      IARG = BUFNUM(FIL)
      AKCESS = 0
      CALL MDISK (ACCTYP(FIL), LUN, FIND(IARG), BUFFER,
     *   BIND(IARG), IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1000) IERR, FIL
         CALL MSGWRT (8)
         AKCESS = IERR
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR ',I3,' ACCESSING FILE ',I2,' IN AKCESS ROUTINE:')
      END

LOCAL INCLUDE 'PEVACL.INC'
C                                       Parameter include for EVACL
      INTEGER   MAXQAD, MAXTRP
C                                       MAXQAD = max. no. quads
      PARAMETER (MAXQAD=100000)
C                                       MAXTRP = max. no. triples
      PARAMETER (MAXTRP=100000)
LOCAL END
LOCAL INCLUDE 'EVACL.INC'
C                                       Local include for EVACL
      INCLUDE 'PEVACL.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:DMSG.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XXSTOK(1), XOPCOD(1)
      CHARACTER NAMEIN*12, CLAIN*6, OPCODE*4, XSTOK*4
      REAL      XSIN, XDISIN, XBIF, XEIF, XBCHAN, XECHAN, XFLAGV,
     *   XANT(50), XSOLIN
      REAL      BUFF1(UVBFSS), SOLINT, ANSERS(6,MAXIF)
      INTEGER   JBUFSZ, NANT, OLDCNO, CATKEP(256), OBUFF(1024),
     *   TOTALS(2,MAXIF)
      INTEGER   SEQIN, DISKIN, LUNI, INDI, NCH, NUMQAD, NUMTRP,
     *   CPQUAD(4,MAXQAD), GOODAM(MAXQAD), GOODPH(MAXTRP),
     *   CPTRIP(3,MAXTRP), INCANT(MAXANT)
C                                       WARNING: many of these commons
C                                       are declared locally with
C                                       variables of different names!!!
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XXSTOK, XBIF, XEIF,
     *   XBCHAN, XECHAN, XFLAGV, XANT, XOPCOD, XSOLIN
      COMMON /BUFRS/ BUFF1, OBUFF, JBUFSZ
      COMMON /VBPCOM/ SEQIN, DISKIN, LUNI, INDI, OLDCNO, NCH, INCANT,
     *   CATKEP, GOODPH, GOODAM, NUMTRP, NUMQAD, CPTRIP, CPQUAD, NANT,
     *   SOLINT, ANSERS, TOTALS
      COMMON /CHRCOM/ NAMEIN, CLAIN, XSTOK, OPCODE
LOCAL END
LOCAL INCLUDE 'CLAVER.INC'
      LOGICAL   GOTPHS, GOTAMP
      INTEGER   ACOUNT(4,MAXQAD), ACOUN1(4,MAXQAD), COUNTA(MAXQAD),
     *   PCNTIM, ACNTIM, IVSCNT, PCOUNT(3,MAXTRP), PCOUN1(3,MAXTRP),
     *   VISINC, VISMSG
      REAL      ASUMT, PSUMT, AWORK(2,4,MAXQAD), AWORKC(MAXQAD),
     *   AGAMP(4,MAXQAD), AGERR(4,MAXQAD), TLAST, DTUTC,
     *   PWORK(2,3,MAXTRP), PWORKC(2,MAXTRP), PGAMP(3,MAXTRP),
     *   PGERR(3,MAXTRP)
      COMMON /CLAVG/ ACOUNT, ACOUN1, COUNTA, PCOUNT, PCOUN1,
     *   AWORK, AWORKC, AGAMP, AGERR, PWORK, PWORKC, PGAMP, PGERR,
     *   TLAST, DTUTC, IVSCNT, GOTPHS, GOTAMP, PCNTIM, PSUMT, ACNTIM,
     *   ASUMT, VISINC, VISMSG
LOCAL END
      PROGRAM EVACL
C-----------------------------------------------------------------------
C! Evaluates closure phases and amplitudes
C# UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   EVACL plots uv data . A 'PL' extension file is made which can
C   be displayed in the usual ways.  It plots closure amplitudes,
C   Inputs:
C     USERID                       UV data file owner # ignored
C     INNAME         NAMEIN        Name of input UV data.
C     INCLASS        CLAIN         Class of input UV data.
C     INSEQ          SEQIN         Seq. of input UV data.
C     INDISK         DISKIN        Disk number of input UV data.
C     BCHAN          BCHAN         Start channel for averaging
C     ECHAN          ECHAN         End channel for averaging
C     BIF            BIF           Start IF number for averaging
C     EIF            EIF           End IF number for averaging
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'EVACL.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'EVACL '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL EVACLI (PRGM, IRET)
C                                       Scaling
      IF (IRET.EQ.0) CALL EVACLD (IRET)
C                                       Close down
      CALL DIE (IRET, OBUFF)
C
 999  STOP
      END
      SUBROUTINE EVACLI (PRGM, IRET)
C-----------------------------------------------------------------------
C   EVACLI gets input parameters for EVACL .
C   Inputs:  PRGM   C*6       Program name
C   Output:  IRET   I         Error code: 0 => ok, else quit
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
C
      INCLUDE 'EVACL.INC'
      CHARACTER UTYPE*2, STAT*4, ALSTOK(12)*4
      INTEGER   NPARM, IERR, IUSER, I, K, L, J, MXANT, MXQUAD, IROUND,
     *   NUMOUT, OUTANS(MAXANT)
      REAL      CATR(256), EPS
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSOU.INC'
      EQUIVALENCE (CATR, CATBLK)
      DATA MXANT /MAXANT/
      DATA MXQUAD /MAXQAD/
      DATA ALSTOK /'I','Q','U','V','RR','LL','RL','LR','VV','HH','VH',
     *   'HV'/
C-----------------------------------------------------------------------
C                                       Init IO et al.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      CALL SELINI
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
C                                       Get input parameters.
      NPARM = 65
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAMEI, OBUFF, IERR)
      IF (IERR.NE.0) THEN
         IRET = 8
         RQUICK = .TRUE.
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, OBUFF, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
      SEQIN = XSIN + EPS
      DISKIN = XDISIN + EPS
C                                       Check SOLINT
      IF (XSOLIN.EQ.0.0) THEN
         XSOLIN = 5.0
         WRITE (MSGTXT,1020)
         CALL MSGWRT (3)
         END IF
C                                       Characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XXSTOK, XSTOK)
      CALL H2CHR (4, 1, XOPCOD, OPCODE)
      IF (OPCODE.NE.'INDE') OPCODE = 'CLOS'
      DO 10 I = 1,12
         IF (XSTOK.EQ.ALSTOK(I)) GO TO 15
 10      CONTINUE
      XSTOK = 'I'
 15   STOKES = XSTOK
      CALL CHR2H (4, XSTOK, 1, XXSTOK)
C                                       Get CATBLK from file.
      LUNI = 16
      UTYPE = 'UV'
      OLDCNO = 1
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   IUSER, STAT, OBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      IUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', OBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1035) IRET
         GO TO 990
         END IF
      XSIN = SEQIN
      XDISIN = DISKIN
      CALL CHR2H (12, NAMEIN, 1, XNAMEI)
      CALL CHR2H (6, CLAIN, 1, XCLAIN)
C                                       Get uv header info.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
      CALL COPY (256, CATBLK, CATKEP)
C                                       Freq id
      SUBARR = 1
      FRQSEL = 1
C                                       antenna info
      CALL EVACLA (DISKIN, OLDCNO, SUBARR, CATBLK, NANT, NUMOUT, OUTANS,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, 'FINDING MAX ANTENNA NUMBER'
         GO TO 990
         END IF
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      IUDISK = UDISK
      IUCNO = OLDCNO
      FGVER = IROUND (XFLAGV)
C                                       Test channel #
      BCHAN = IROUND (XBCHAN)
      BCHAN = MAX (1, MIN (BCHAN, CATBLK(KINAX+JLOCF)))
      ECHAN = IROUND (XECHAN)
      IF (ECHAN.LT.BCHAN) ECHAN = CATBLK(KINAX+JLOCF)
      ECHAN = MAX (1, MIN (ECHAN, CATBLK(KINAX+JLOCF)))
      IF (ECHAN.GT.BCHAN) THEN
         WRITE (MSGTXT,1040) BCHAN, ECHAN
         CALL MSGWRT (2)
         END IF
      XBCHAN = BCHAN
      XECHAN = ECHAN
C                                       IF number
      IF (JLOCIF.GE.0) THEN
         BIF = IROUND (XBIF)
         BIF = MAX (1, MIN (BIF, CATBLK(KINAX+JLOCIF)))
         EIF = IROUND (XEIF)
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         EIF = MAX (1, MIN (EIF, CATBLK(KINAX+JLOCIF)))
      ELSE
         BIF = 1
         EIF = 1
         END IF
      IF (EIF.GT.BIF) THEN
         WRITE (MSGTXT,1050) BIF, EIF
         CALL MSGWRT (2)
         END IF
      XBIF = BIF
      XEIF = EIF
C                                       omit or include
      L = 0
      K = 0
      DO 20 I = 1,50
         J = IROUND (XANT(I))
         IF (J.GT.0) K = K + 1
         IF (J.LT.0) L = L + 1
 20      CONTINUE
      IF ((K.EQ.0) .AND. (L.EQ.0)) THEN
         CALL FILL (MAXANT, 1, INCANT)
      ELSE IF (L.EQ.0) THEN
         CALL FILL (MAXANT, 0, INCANT)
         DO 25 I = 1,50
            J = IROUND (XANT(I))
            IF (J.GT.0) INCANT(J) = 1
 25         CONTINUE
      ELSE
         CALL FILL (MAXANT, 1, INCANT)
         DO 30 I = 1,50
            J = IROUND (XANT(I))
            J = ABS (J)
            IF (J.GT.0) INCANT(J) = 0
 30         CONTINUE
         END IF
      DO 35 I = 1,NUMOUT
         INCANT(OUTANS(I)) = 0
 35      CONTINUE
C                                       which triples
      CALL SETTRP (IRET)
C                                       which quads
      IF (IRET.EQ.0) CALL SETQAD (IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'ERROR SETING TRIANGLES/QUADRANGLES'
         GO TO 990
         END IF
C                                       report
      WRITE (MSGTXT,1100) NUMTRP, NUMQAD
      CALL MSGWRT (3)
      WRITE (MSGTXT,1101) NANT, NUMOUT
      CALL MSGWRT (3)
      GO TO 999
C
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('EVACLI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('EVACLI: ERROR',I4,' ON ',A)
 1020 FORMAT ('EVACLI: SOLINT was 0, resetting to 5 minutes')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1040 FORMAT ('Averaging from channel ',I4,'-',I4)
 1050 FORMAT ('Displaying from IF ',I4,'-',I4)
 1100 FORMAT ('Using',I6,' triangles and',I6,' quadrangles')
 1101 FORMAT ('Using max antenna #',I4,' with',I2,' known to be out')
      END
      SUBROUTINE EVACLA (IUDISK, IUCNO, IUVER, CATBLK, MAXA, NUMOUT,
     *   OUTANS, IERR)
C-----------------------------------------------------------------------
C   finds the max antenna number in an antenna file - this may easily
C   not be the same as the number of records.  Also finds and antennas
C   listed as OUT
C   Inputs:
C      IUDISK   I        Disk number
C      IUCNO    I        Catalog number
C      IUVER    I        AN version number = subarray number
C      CATBLK   I(256)   Catalog block
C   Output:
C      MAXA     I        Max antenna number
C      NUMOUT   I        Number of OUT antennas
C      OUTANS   I(*)     Antenna numbers of OUT antennas
C      IERR     I        Error code
C   Output in Common: DANT.INC after ANTINI and several TABAN calls
C-----------------------------------------------------------------------
      INTEGER   IUDISK, IUCNO, IUVER, CATBLK(256), MAXA, NUMOUT,
     *   OUTANS(*),  IERR
C
      INTEGER   NUMSUB, IA, ANBUFF(512), ILUN, NANT
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA ILUN /110/
C-----------------------------------------------------------------------
      MAXA = 0
      NUMOUT = 0
      IERR = 0
      CALL FNDEXT ('AN', CATBLK, NUMSUB)
      IF ((NUMSUB.GE.IUVER) .AND. (IUVER.GE.1)) THEN
         IA = 0
         CALL ANTINI ('READ', ANBUFF, IUDISK, IUCNO, IUVER, CATBLK,
     *      ILUN, IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY,
     *      SAFREQ, RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME,
     *      XYZHAN, TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'INIT', IUVER
            GO TO 980
            END IF
         NANT = ANBUFF(5)
C                                       read the an tables
         DO 90 IA = 1,NANT
            CALL TABAN ('READ', ANBUFF, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA,POLCA, POLTYB, POLAB, POLCB, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1000) IERR, 'READ', IUVER
               GO TO 970
               END IF
            IF (ANNAME.EQ.'OUT') THEN
               NUMOUT = NUMOUT + 1
               OUTANS(NUMOUT) = NOSTA
            ELSE IF ((STAXYZ(1).EQ.0.0D0) .AND. (STAXYZ(2).EQ.0.0D0)
     *         .AND. (STAXYZ(3).EQ.0.0D0)) THEN
               NUMOUT = NUMOUT + 1
               OUTANS(NUMOUT) = NOSTA
            ELSE
               MAXA = MAX (MAXA, NOSTA)
               END IF
 90         CONTINUE
         CALL TABIO ('CLOS', 0, IANRNO, ANBUFF, ANBUFF, IERR)
         END IF
      GO TO 999
C
 970  CALL MSGWRT (6)
      CALL TABIO ('CLOS', 0, IANRNO, ANBUFF, ANBUFF, IA)
      GO TO 999
C
 980  CALL MSGWRT (6)
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('EVACLA: ERROR',I5,1X,A,'ING AN TABLE',I4)
      END
      SUBROUTINE SETTRP (IRET)
C-----------------------------------------------------------------------
C   Sets the list of triples
C   Output:
C      IRET   I   Error occurred if > 0
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'EVACL.INC'
      INTEGER   I, J, K, A1
C-----------------------------------------------------------------------
C                                       unique
      NUMTRP = 0
      IRET = 0
      IF (OPCODE.EQ.'INDE') THEN
         DO 20 J = 3,NANT
            A1 = 1
            DO 10 I = 1,NANT
               IF ((A1.LT.J-1) .AND. (INCANT(A1).EQ.1) .AND.
     *            (INCANT(A1+1).EQ.1) .AND. (INCANT(J).EQ.1)) THEN
                  NUMTRP = NUMTRP + 1
                  CPTRIP(1,NUMTRP) = A1
                  CPTRIP(2,NUMTRP) = A1 + 1
                  CPTRIP(3,NUMTRP) = J
                  END IF
               A1 = A1 + 1
 10            CONTINUE
 20         CONTINUE
C                                       all
      ELSE
         DO 50 I = 1,NANT-2
            IF (INCANT(I).EQ.0) GO TO 50
            DO 40 J = 2,NANT-1
               IF ((I.EQ.J) .OR. (INCANT(J).EQ.0)) GO TO 40
               DO 30 K = 1,NANT
                  IF (INCANT(K).EQ.0) GO TO 30
                  IF ((K.EQ.I) .OR. (K.EQ.J)) GO TO 30
                  IF ((I.GT.J) .OR. (I.GT.K) .OR. (J.GT.K)) GO TO 30
                  NUMTRP = NUMTRP + 1
                  CPTRIP(1,NUMTRP) = I
                  CPTRIP(2,NUMTRP) = J
                  CPTRIP(3,NUMTRP) = K
 30               CONTINUE
 40            CONTINUE
 50         CONTINUE
         END IF
C                                       did we get anything
      IF (NUMTRP.LE.0) THEN
         MSGTXT = 'SETTRP DID NOT FIND ANY ALLOWED TRIPLES'
         CALL MSGWRT (8)
         IRET = 1
         END IF
C
 999  RETURN
      END
      SUBROUTINE SETQAD (IRET)
C-----------------------------------------------------------------------
C   Detrimines the quadrangles to be used
C   Output:
C      IRET   I   > 0 -> no quadrangles found
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'EVACL.INC'
      INTEGER   I, J, K, L

C-----------------------------------------------------------------------
      NUMQAD = 0
      IRET = 0
C                                       independent
      IF (OPCODE.EQ.'INDE') THEN
         DO 20 J = 3,NANT
            K = 1
            DO 10 I = 1,NANT
               IF ((K.LT.J-2) .AND. (INCANT(K).EQ.1) .AND.
     *            (INCANT(K+1).EQ.1) .AND. (INCANT(K+2).EQ.1) .AND.
     *            (INCANT(J).EQ.1))  THEN
                  NUMQAD = NUMQAD + 1
                  CPQUAD(1,NUMQAD) = K
                  CPQUAD(2,NUMQAD) = K + 1
                  CPQUAD(3,NUMQAD) = K + 2
                  CPQUAD(4,NUMQAD) = J
                  END IF
               K = K + 1
 10            CONTINUE
 20         CONTINUE
      ELSE
         DO 80 I = 1,NANT
            IF (INCANT(I).EQ.0) GO TO 80
            DO 70 J = 1,NANT
               IF (INCANT(J).EQ.0) GO TO 70
               DO 60 K = 1,NANT
                  IF (INCANT(K).EQ.0) GO TO 60
                  DO 50 L = 1,NANT
                     IF ((I.LT.J) .AND. (J.LT.K) .AND. (K.LT.L) .AND.
     *                  (INCANT(L).EQ.1)) THEN
                        NUMQAD = NUMQAD + 1
                        CPQUAD(1,NUMQAD) = I
                        CPQUAD(2,NUMQAD) = J
                        CPQUAD(3,NUMQAD) = K
                        CPQUAD(4,NUMQAD) = L
                        END IF
 50                  CONTINUE
 60               CONTINUE
 70            CONTINUE
 80         CONTINUE
         END IF
C                                       get any?
      IF (NUMQAD.LE.0) THEN
         MSGTXT = 'SETQAD DID NOT FIND ANY QUADRANGLES'
         CALL MSGWRT (8)
         IRET = 1
         END IF
C
 999  RETURN
      END
      SUBROUTINE EVACLD (IRET)
C-----------------------------------------------------------------------
C   Finds the closure phases and amplitudes, computes statistics
C   Output:
C      IRET   I   > 0 -> error
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'EVACL.INC'
      INCLUDE 'CLAVER.INC'
      INTEGER   I, J, LBIF, LEIF, NUMVIS, SCANUM, IC, NUMP, NUMA,
     *   MAXTOT
      REAL      AWT(3), PWT(3), AOFF, POFF, DT, ASCANV(MAXQAD), WT,
     *   ACLERR(MAXQAD), PSCANV(MAXTRP), PCLERR(MAXTRP), RPARM(20)
      REAL      DBGA(269), DBGP(309), DBGEA(269), DBGEP(309)
      EQUIVALENCE (DBGP, PSCANV), (DBGA, ASCANV), (DBGEA, ACLERR),
     *   (DBGEP, PCLERR)
      LOGICAL   NUSCAN, FIRST
      DOUBLE PRECISION CPRMS(3,2), CARMS(3,2)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      LBIF = BIF
      LEIF = EIF
C                                       loop 1 IF at a time
      DO 100 BIF = LBIF,LEIF
         EIF = BIF
         CALL UVGET ('INIT', RPARM, BUFF1, IRET)
         IF (IRET.EQ.-1) THEN
            CALL UVGET ('CLOS', RPARM, BUFF1, IRET)
         ELSE IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, BIF, 'OPEN UV DATA'
            GO TO 990
         ELSE
            NUMP = 0
            NUMA = 0
            CALL DFILL (6, 0.0D0, CPRMS)
            CALL DFILL (6, 0.0D0, CARMS)
            DT = XSOLIN / 1440.0
            NUMVIS = 0
            FIRST = .TRUE.
            WT = 800.0 / (NUMTRP + NUMQAD)
            VISINC = CATBLK(KIGCN) / 20
            VISMSG = CATBLK(KIGCN) / 10
            VISINC = MAX (100000, MIN (1000000,VISINC))
            VISINC = VISINC * WT
            VISINC = ((VISINC+500)/1000) * 1000
            VISINC = MAX (40000, MIN (500000,VISINC))
            VISMSG = WT * VISMSG
            VISMSG = (VISMSG / VISINC) * VISINC
            IF (VISMSG.LT.VISINC) VISMSG = 100 * VISINC
 20         CONTINUE
               CALL CLOSAV (NUMVIS, NUMTRP, CPTRIP, NUMQAD, CPQUAD, DT,
     *            ASCANV, ACLERR, PSCANV, PCLERR, NUSCAN, SCANUM, RPARM,
     *            BUFF1, IRET)
               IF (IRET.EQ.-2) GO TO 20
               IF (IRET.GT.0) THEN
                  WRITE (MSGTXT,1000) IRET, BIF, 'READING DATA'
                  GO TO 990
                  END IF
               IF (FIRST) THEN
                  FIRST = .FALSE.
                  AOFF = 0.
                  IC = 0
                  DO 30 J = 1,NUMQAD
                     IF ((ASCANV(J).NE.FBLANK) .AND.
     *                  (ACLERR(J).NE.FBLANK)) THEN
                        AOFF = AOFF + ACLERR(J)**2
                        IC = IC + 1
                        END IF
 30                  CONTINUE
                  IF (IC.GT.0) AOFF = AOFF / IC
                  POFF = 0.0
                  IC = 0
                  DO 40 J = 1,NUMTRP
                     IF ((PSCANV(J).NE.FBLANK) .AND.
     *                  (PCLERR(J).NE.FBLANK)) THEN
                        POFF = POFF + PCLERR(J)**2
                        IC = IC + 1
                        END IF
 40                  CONTINUE
                  IF (IC.GT.0) POFF = POFF / IC
                  END IF
C                                       amplitude
               DO 60 J = 1,NUMQAD
                  IF (ASCANV(J).NE.FBLANK) THEN
                     NUMA = NUMA + 1
                     CALL RFILL (3, 1.0, AWT)
                     IF (ACLERR(J).GT.0.0) AWT(1) = 1.0 / ACLERR(J)**2
                     AWT(2) = 1.0 / (ACLERR(J)*2 + AOFF)
                     DO 50 I = 1,3
                        CARMS(I,1) = CARMS(I,1) + AWT(I)*(ASCANV(J)**2)
                        CARMS(I,2) = CARMS(I,2) + AWT(I)
 50                     CONTINUE
                     END IF
 60               CONTINUE
C                                       phase
               DO 80 J = 1,NUMTRP
                  IF (PSCANV(J).NE.FBLANK) THEN
                     NUMP = NUMP + 1
                     CALL RFILL (3, 1.0, PWT)
                     IF (PCLERR(J).GT.0.0) PWT(1) = 1.0 / PCLERR(J)**2
                     PWT(2) = 1.0 / (PCLERR(J)**2 + POFF)
                     DO 70 I = 1,3
                        CPRMS(I,1) = CPRMS(I,1) + PWT(I)*(PSCANV(J)**2)
                        CPRMS(I,2) = CPRMS(I,2) + PWT(I)
 70                     CONTINUE
                     END IF
 80               CONTINUE
               IF (IRET.EQ.0) GO TO 20
C                                       finish up
            CALL UVGET ('CLOS', RPARM, BUFF1, IRET)
            DO 90 I = 1,3
               IF (CARMS(I,2).GT.0.0) CARMS(I,1) = SQRT (CARMS(I,1) /
     *            CARMS(I,2))
               IF (CPRMS(I,2).GT.0.0) CPRMS(I,1) = SQRT (CPRMS(I,1) /
     *            CPRMS(I,2))
               ANSERS(I,BIF) = CPRMS(I,1)
               ANSERS(I+3,BIF) = CARMS(I,1)
 90            CONTINUE
            TOTALS(1,BIF) = NUMP
            TOTALS(2,BIF) = NUMA
            END IF
 100     CONTINUE
C                                       check scale
      MAXTOT = 0
      DO 110 BIF = LBIF,LEIF
         MAXTOT = MAX (MAXTOT, TOTALS(1,BIF))
         MAXTOT = MAX (MAXTOT, TOTALS(2,BIF))
 110     CONTINUE
      WT = MAXTOT
      MAXTOT = LOG10 (WT)
      IF (MAXTOT.GE.7) THEN
         WT = 10.0 ** (MAXTOT-6)
         DO 115 BIF = LBIF,LEIF
            TOTALS(1,BIF) = TOTALS(1,BIF) / WT + 0.5
            TOTALS(2,BIF) = TOTALS(2,BIF) / WT + 0.5
 115        CONTINUE
         WRITE (MSGTXT,1115) WT
         CALL MSGWRT (4)
         END IF
C                                       print answers
      MSGTXT = ' '
      CALL MSGWRT (5)
      MSGTXT = 'IF  ----------  PHASE  ----------' //
     *           '  --------  AMPLITUDE ---------'
      CALL MSGWRT (5)
      MSGTXT = '      Unwt   Robwt  Natwt   Count' //
     *           '    Unwt   Robwt  Natwt   Count'
      CALL MSGWRT (5)
      MSGTXT = ' '
      CALL MSGWRT (5)
      DO 120 BIF = LBIF,LEIF
         WRITE (MSGTXT,1100) BIF, (ANSERS(I,BIF), I = 1,3),
     *      TOTALS(1,BIF), (ANSERS(I,BIF), I=4,6), TOTALS(2,BIF)
         CALL MSGWRT (5)
 120     CONTINUE
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('EVACLD ERROR',I4,' IF',I3,' ON ',A)
 1100 FORMAT (I2,F9.2,2F7.2,I8,F9.4,2F7.4,I8)
 1115 FORMAT ('Counts reduced by a factor of',F6.0)
      END
      SUBROUTINE CLAVER (OP, NUMTRP, CPTRIP, NUMQAD, CPQUAD, T1, DT,
     *   RPARM, VIS)
C-----------------------------------------------------------------------
C   Adds a sample in to, or zeros, the summing arrays
C   DOERRB always true, DOMODL always false
C   Inputs:
C      OP       C*4      OPeration - 'ZERO', or 'AVER'
C      NUMTRP   I        Number phase triplets
C      CPTRIP   I(3,*)   Antennas in triplets
C      NUMQAD   I        Number amplitude quadrangles
C      CPQUAD   I(4,*)   Antennas in quadrangles
C      DT       R        Time interval to average
C      RPARM    R(*)     Random parameter set
C      VIS      R(3,*)   Data visibilities/weights
C   Outputs
C      T1       R        Start time this average: set if input > 10^9
C-----------------------------------------------------------------------
      CHARACTER OP*(*)
      INTEGER   NUMTRP, CPTRIP(3,*), NUMQAD, CPQUAD(4,*)
      REAL      T1, DT, RPARM(*), VIS(3,*)
C
      INTEGER   I, IVIS, KVIS, JA1, JA2, IDAY, STTRIP, ITRIP, IBASE,
     *   STQUAD
      REAL      CT, TEMP
      DOUBLE PRECISION X8
      INCLUDE 'PEVACL.INC'
      INCLUDE 'CLAVER.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANT.INC'
C-----------------------------------------------------------------------
C                                       zero
      IF (OP.EQ.'ZERO') THEN
         TLAST = -1.0
         DTUTC = DATUTC / 86400.0
         IVSCNT = 0
         I = 3 * MAXTRP
         CALL FILL (I, 0, PCOUNT)
         CALL FILL (I, 0, PCOUN1)
         CALL RFILL (I, 0.0, PGAMP)
         CALL RFILL (I, 0.0, PGERR)
         I = 2 * 3 * MAXTRP
         CALL RFILL (I, 0.0, PWORK)
         I = 2 * MAXTRP
         CALL RFILL (I, 0.0, PWORKC)
         PCNTIM = 0
         PSUMT = 0.0
         I = 4 * MAXQAD
         CALL FILL (I, 0, ACOUNT)
         CALL FILL (I, 0, ACOUN1)
         CALL RFILL (I, 0.0, AGAMP)
         CALL RFILL (I, 0.0, AGERR)
         I = 2 * 4 * MAXQAD
         CALL RFILL (I, 0.0, AWORK)
         I = 2 * MAXQAD
         CALL RFILL (I, 0.0, AWORKC)
         ACNTIM = 0
         ASUMT = 0.0
C                                       add one vis into arrays:
      ELSE
         KVIS = (LREC-NRPARM) / 3
C                                       Set up first time boundary
         CT = RPARM(ILOCT+1) - DTUTC
         IVSCNT = IVSCNT + 1
         IF (IVSCNT.EQ.1) THEN
            IDAY = CT
            X8 = (CT - IDAY) / ABS (DT)
            TLAST = IDAY + DINT (X8) * ABS (DT) + ABS (DT)
            END IF
C                                       Antenna numbers
         IF (ILOCB.GE.0) THEN
            JA1 = RPARM(ILOCB+1) / 256. + 0.1
            JA2 = RPARM(ILOCB+1) - JA1 * 256 + 0.1
         ELSE
            JA1 = RPARM(ILOCA1+1) + 0.1
            JA2 = RPARM(ILOCA2+1) + 0.1
            END IF
         STTRIP = 1
         STQUAD = 1
C                                       Return to here to look for
C                                       further triplets involving this
C                                       baseline.
C                                       Find triplet and member
 100     DO 110 I = STTRIP,NUMTRP
            ITRIP = I
            IBASE = 1
            IF ((JA1.EQ.CPTRIP(1,I).AND.(JA2.EQ.CPTRIP(2,I)))) GO TO 120
            IBASE = 2
            IF ((JA1.EQ.CPTRIP(1,I).AND.(JA2.EQ.CPTRIP(3,I)))) GO TO 120
            IBASE = 3
            IF ((JA1.EQ.CPTRIP(2,I).AND.(JA2.EQ.CPTRIP(3,I)))) GO TO 120
 110        CONTINUE
C                                       Not wanted
         GO TO 200
C                                       wanted
 120     GOTPHS = .TRUE.
         STTRIP = ITRIP + 1
C                                       Time
         PSUMT = PSUMT + RPARM(ILOCT+1)
         IF (T1.GT.1.0E9) T1 = RPARM(ILOCT+1)
         PCNTIM = PCNTIM + 1
C                                       Vector average:
      INCLUDE 'INCS:ZVD.INC'
         DO 130 IVIS = 1,KVIS
            IF (VIS(3,IVIS).GT.0.0) THEN
               PCOUNT(IBASE,ITRIP) = PCOUNT(IBASE,ITRIP) + 1
               PCOUN1(IBASE,ITRIP) = PCOUN1(IBASE,ITRIP) + 1
               PWORK(1,IBASE,ITRIP) = PWORK(1,IBASE,ITRIP) + VIS(1,IVIS)
               PWORK(2,IBASE,ITRIP) = PWORK(2,IBASE,ITRIP) + VIS(2,IVIS)
               PGAMP(IBASE,ITRIP) = PGAMP(IBASE,ITRIP) +
     *            SQRT (VIS(1,IVIS)*VIS(1,IVIS) + VIS(2,IVIS)*
     *            VIS(2,IVIS))
               PGERR(IBASE,ITRIP) = PGERR(IBASE,ITRIP) +
     *            SQRT (1.0/VIS(3,IVIS))
               END IF
 130        CONTINUE
C                                       averaging closure phases
         IF (DT.LT.0.0) THEN
C                                       completed a triangle
            IF ((PCOUN1(1,ITRIP).GT.0) .AND. (PCOUN1(2,ITRIP).GT.0)
     *         .AND. (PCOUN1(3,ITRIP).GT.0)) THEN
               TEMP = ATAN2 (PWORK(2,1,ITRIP), PWORK(1,1,ITRIP)+1.0E-20)
     *            - ATAN2 (PWORK(2,2,ITRIP), PWORK(1,2,ITRIP)+1.0E-20)
     *            + ATAN2 (PWORK(2,3,ITRIP), PWORK(1,3,ITRIP)+1.0E-20)
               PWORKC(1,ITRIP) = PWORKC(1,ITRIP) + COS (TEMP)
               PWORKC(2,ITRIP) = PWORKC(2,ITRIP) + SIN (TEMP)
               CALL RFILL (6, 0.0, PWORK(1,1,ITRIP))
               CALL FILL (3, 0, PCOUN1(1,ITRIP))
               END IF
            END IF
C                                       This baseline may be involved in
C                                       more triplets.
         GO TO 100
C                                       NOW DO QUADRANGLES
C                                       Return to here to look for
C                                       further quadruplets involving
C                                       this baseline.
C                                       Find quadruplet and member
 200     DO 210 I = STQUAD,NUMQAD
            ITRIP = I
            IBASE = 1
            IF ((JA1.EQ.CPQUAD(1,I).AND.(JA2.EQ.CPQUAD(2,I)))) GO TO 220
            IBASE = 2
            IF ((JA1.EQ.CPQUAD(3,I).AND.(JA2.EQ.CPQUAD(4,I)))) GO TO 220
            IBASE = 3
            IF ((JA1.EQ.CPQUAD(1,I).AND.(JA2.EQ.CPQUAD(3,I)))) GO TO 220
            IBASE = 4
            IF ((JA1.EQ.CPQUAD(2,I).AND.(JA2.EQ.CPQUAD(4,I)))) GO TO 220
 210        CONTINUE
C                                       Not wanted
         GO TO 999
C                                       wanted
 220     GOTAMP = .TRUE.
         STQUAD = ITRIP + 1
C                                       Time
         ASUMT = ASUMT + RPARM(ILOCT+1)
         IF (T1.GT.1.0E9) T1 = RPARM(ILOCT+1)
         ACNTIM = ACNTIM + 1
C                                       Vector average:
      INCLUDE 'INCS:ZVD.INC'
         DO 230 IVIS = 1,KVIS
            IF (VIS(3,IVIS).GT.0.0) THEN
               ACOUNT(IBASE,ITRIP) = ACOUNT(IBASE,ITRIP) + 1
               ACOUN1(IBASE,ITRIP) = ACOUN1(IBASE,ITRIP) + 1
               AWORK(1,IBASE,ITRIP) = AWORK(1,IBASE,ITRIP) +
     *            VIS(1,IVIS)
               AWORK(2,IBASE,ITRIP) = AWORK(2,IBASE,ITRIP) +
     *            VIS(2,IVIS)
               AGAMP(IBASE,ITRIP) = AGAMP(IBASE,ITRIP) +
     *            SQRT (VIS(1,IVIS)*VIS(1,IVIS) + VIS(2,IVIS)*
     *            VIS(2,IVIS))
               AGERR(IBASE,ITRIP) = AGERR(IBASE,ITRIP) +
     *            SQRT (1.0/VIS(3,IVIS))
               END IF
 230        CONTINUE
C                                       averaging closure phases
         IF (DT.LT.0.0) THEN
C                                       completed a triangle
            IF ((ACOUN1(1,ITRIP).GT.0) .AND. (ACOUN1(2,ITRIP).GT.0)
     *         .AND. (ACOUN1(3,ITRIP).GT.0).AND. (ACOUN1(4,ITRIP).GT.0))
     *         THEN
               TEMP = SQRT (AWORK(1,3,ITRIP)**2 + AWORK(2,3,ITRIP)**2) *
     *            SQRT (AWORK(1,4,ITRIP)**2 + AWORK(2,4,ITRIP)**2) /
     *            (ACOUN1(3,ITRIP) * ACOUN1(4,ITRIP))
               IF (TEMP.NE.0.0) THEN
                  AWORKC(ITRIP) = AWORKC(ITRIP) +
     *               SQRT (AWORK(1,1,ITRIP)**2 + AWORK(2,1,ITRIP)**2) *
     *               SQRT (AWORK(1,2,ITRIP)**2 + AWORK(2,2,ITRIP)**2) /
     *               (ACOUN1(1,ITRIP) * ACOUN1(2,ITRIP)) / TEMP
                  COUNTA(ITRIP) = COUNTA(ITRIP) + 1
                  END IF
               CALL RFILL (8, 0.0, AWORK(1,1,ITRIP))
               CALL FILL (4, 0, ACOUN1(1,ITRIP))
               END IF
            END IF
C                                       This baseline may be involved in
C                                       more quadrangles
         GO TO 200
C
         END IF
C
 999  RETURN
      END
      SUBROUTINE CLOSAV (NUMVIS, NUMTRP, CPTRIP, NUMQAD, CPQUAD, DT,
     *   ASCANV, ACLERR, PSCANV, PCLERR, NUSCAN, SCANUM, RPARM, VIS,
     *   IERR)
C-----------------------------------------------------------------------
C   Reads a uv data base and returns averages of closure phases for
C   selected triplets.  The triplets are specified in array CPTRIP.
C   Needs to be initialized by a call to UVGET.
C   Inputs:
C     NUMVIS   I        Current visibility number
C     NUMTRP   I        The number of triplets selected
C     CPTRIP   I(3,*)   The antenna numbers involved in the triplets.
C     DT       R        Averaging time in days
C   Input/Output:
C     RPARM    R(*)     Random parameter array, first record of call.
C                       (1) = 'INDE' => don't use.
C     VIS      R(3,*)   Visibility array, first record of call.
C   Outputs:
C     PSCANV   R(*)     The closure phase values for the selected
C                       triplets, corresponds to CPTRIP.
C                       Undefined values will contain 'INDE'.
C     PCLERR   R(*)     The formal error associated with the closure
C                       phase, calculated as CLERR = SQRT (err(12)**2
C                       + err(13)**2 + err(23)**2)
C     NUSCAN   L        True IF the first record in a new scan.
C     IERR     I        Return code, 0 => OK, -1 => out of data,
C                          > 0 => failed.
C   Note:   If the end of data is encountered (IERR=-1) then UVGET is
C   called with OPCODE='CLOS'.
C-----------------------------------------------------------------------
      INTEGER   NUMTRP, NUMQAD, CPTRIP(3,*), CPQUAD(4,*), SCANUM,
     *    NUMVIS, IERR
      LOGICAL   NUSCAN
      REAL      RPARM(*), VIS(3,*), DT, ASCANV(*), ACLERR(*), PSCANV(*),
     *   PCLERR(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'PEVACL.INC'
      LOGICAL   GOODP, GOODA
      INTEGER   I, KVIS, ICP, IDAY
      REAL      T1, CP, CT, TEMP
      DOUBLE PRECISION X8
      INCLUDE 'CLAVER.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      IF (NUMVIS.EQ.0) CALL CLAVER ('ZERO', NUMTRP, CPTRIP, NUMQAD,
     *   CPQUAD, T1, DT, RPARM, VIS)
C                                       Save scan number (0= no index)
      NUSCAN = SCANUM.NE.INXRNO
      SCANUM = INXRNO
C                                       Initialize time
      T1 = 1.0E10
      KVIS = (LREC-NRPARM) / 3
C                                       Loop reading data
 100  CONTINUE
         CALL UVGET ('READ', RPARM, VIS, IERR)
         IF (IERR.GT.0) GO TO 999
         IF (IERR.EQ.-1) GO TO 200
         NUMVIS = NUMVIS + 1
         IF (MOD(NUMVIS-1,VISMSG).EQ.0) THEN
            WRITE (MSGTXT,1100) BIF, NUMVIS
            CALL MSGWRT (2)
         ELSE IF (MOD(NUMVIS-1,VISINC).EQ.0) THEN
            WRITE (MSGTXT,1100) BIF, NUMVIS
            CALL MSGWRT (1)
            END IF
         CT = RPARM(ILOCT+1) - DTUTC
C                                       Set up first time boundary
         IF (IVSCNT.EQ.0) THEN
            IDAY = CT
            X8 = (CT - IDAY) / ABS (DT)
            TLAST = IDAY + DINT (X8) * ABS (DT) + ABS (DT)
            END IF
C                                       Check if avg. or scan done
         IF ((INXRNO.LE.SCANUM) .AND. (CT.LE.TLAST)) THEN
            CALL CLAVER ('AVER', NUMTRP, CPTRIP, NUMQAD, CPQUAD, T1, DT,
     *         RPARM, VIS)
            GO TO 100
            END IF
C                                       Integration done:
C                                       Go through sums
 200  GOODP = .FALSE.
      IF (GOTPHS) THEN
C                                       Vector averaging
         CP = TWOPI
         DO 210 I = 1,NUMTRP
            IF ((PCOUNT(1,I).GT.0) .AND. (PCOUNT(2,I).GT.0) .AND.
     *         (PCOUNT(3,I).GT.0)) THEN
               IF (DT.GT.0.0) THEN
                  PSCANV(I) = ATAN2 (PWORK(2,1,I), PWORK(1,1,I)+1.0E-20)
     *               - ATAN2 (PWORK(2,2,I), PWORK(1,2,I)+1.0E-20)
     *               + ATAN2 (PWORK(2,3,I), PWORK(1,3,I)+1.0E-20)
               ELSE
                  PSCANV(I) = ATAN2 (PWORKC(2,I), PWORKC(1,I)+1.0E-20)
                  END IF
               PGERR(1,I) = PGERR(1,I) / PGAMP(1,I)
               PGERR(2,I) = PGERR(2,I) / PGAMP(2,I)
               PGERR(3,I) = PGERR(3,I) / PGAMP(3,I)
               PCLERR(I) = SQRT (
     *            PGERR(1,I)* PGERR(1,I) / MAX(PCOUNT(1,I)-1,1) +
     *            PGERR(2,I)* PGERR(2,I) / MAX(PCOUNT(2,I)-1,1) +
     *            PGERR(3,I)* PGERR(3,I) / MAX(PCOUNT(3,I)-1,1))
               GOODP = .TRUE.
            ELSE
               PSCANV(I) = FBLANK
               PCLERR(I) = FBLANK
               END IF
 210        CONTINUE
         END IF
C                                       have some results
      IF (GOODP) THEN
C                                       Force range of values= +/- pi
C                                       rad.
         DO 220 I = 1,NUMTRP
            IF (PSCANV(I).NE.FBLANK) THEN
               CP = PSCANV(I) / TWOPI
               ICP = CP
               CP = (CP - ICP) * TWOPI
               IF (CP.GT.PI) CP = CP - TWOPI
               IF (CP.LT.-PI) CP = CP + TWOPI
               PSCANV(I) = CP
               PSCANV(I) = PSCANV(I) * RAD2DG
               IF (PCLERR(I).NE.FBLANK) PCLERR(I) = PCLERR(I) * RAD2DG
               END IF
 220        CONTINUE
         END IF
C                                       now amplitudes
      GOODA = .FALSE.
      IF (GOTAMP) THEN
C                                       Vector averaging
         DO 230 I = 1,NUMQAD
            IF ((ACOUNT(1,I).GT.0) .AND. (ACOUNT(2,I).GT.0) .AND.
     *         (ACOUNT(3,I).GT.0) .AND. (ACOUNT(4,I).GT.0)) THEN
               IF (DT.GT.0.0) THEN
                  ASCANV(I) = SQRT (AWORK(1,1,I)**2 + AWORK(2,1,I)**2) *
     *               SQRT (AWORK(1,2,I)**2 + AWORK(2,2,I)**2) /
     *               (ACOUNT(1,I) * ACOUNT(2,I))
                  TEMP = SQRT (AWORK(1,3,I)**2 + AWORK(2,3,I)**2) *
     *               SQRT (AWORK(1,4,I)**2 + AWORK(2,4,I)**2) /
     *               (ACOUNT(3,I) * ACOUNT(4,I))
               ELSE
                  ASCANV(I) = AWORKC(I)
                  TEMP = COUNTA(I)
                  END IF
               IF ((TEMP.GT.0.0) .AND. (ASCANV(I).GT.0.0)) THEN
                  ASCANV(I) = ASCANV(I) / TEMP
                  AGERR(1,I) = AGERR(1,I) / ACOUNT(1,I)
                  AGERR(2,I) = AGERR(2,I) / ACOUNT(2,I)
                  AGERR(3,I) = AGERR(3,I) / ACOUNT(3,I)
                  AGERR(4,I) = AGERR(4,I) / ACOUNT(4,I)
                  ACLERR(I) = SQRT (
     *               AGERR(1,I)*AGERR(1,I)/MAX(1,ACOUNT(1,I)-1) +
     *               AGERR(2,I)*AGERR(2,I)/MAX(1,ACOUNT(2,I)-1) +
     *               AGERR(3,I)*AGERR(3,I)/MAX(1,ACOUNT(3,I)-1) +
     *               AGERR(4,I)*AGERR(4,I)/MAX(1,ACOUNT(4,I)-1))
                  IF (ASCANV(I).NE.0.0) THEN
                     ACLERR(I) = ACLERR(I) / ASCANV(I)
                     ASCANV(I) = LOG (ASCANV(I))
                     END IF
                  GOODA = .TRUE.
               ELSE
                  ASCANV(I) = FBLANK
                  ACLERR(I) = FBLANK
                  END IF
            ELSE
               ASCANV(I) = FBLANK
               ACLERR(I) = FBLANK
               END IF
 230        CONTINUE
         END IF
C                                       have some results
C                                       save current sample
      IF (IERR.EQ.0) THEN
         CALL CLAVER ('ZERO', NUMTRP, CPTRIP, NUMQAD, CPQUAD, T1, DT,
     *      RPARM, VIS)
         CALL CLAVER ('AVER', NUMTRP, CPTRIP, NUMQAD, CPQUAD, T1, DT,
     *      RPARM, VIS)
         END IF
C                                       End of data, calling routine
C                                       will close.
      IF ((.NOT.GOODP) .AND. (.NOT.GOODA)) THEN
         IF ((IERR.EQ.0) .AND. (SCANUM.GE.INXRNO)) GO TO 100
         IF (IERR.EQ.0) IERR = -2
         END IF
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('IF',I4,'  at visibility number',I10)
      END

      PROGRAM TGREP
C-----------------------------------------------------------------------
C! Lists TGD files with desired task name
C# Utility Catalog
C-----------------------------------------------------------------------
C;  Copyright (C) 2018, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   A service routine to find and list contents of TG files
C-----------------------------------------------------------------------
      INTEGER   NMAX
      PARAMETER (NMAX=1000)
C
      CHARACTER PHNAME*48, TNAME*8, MSGBUF*80, PRGNAM*6, OLDTG*3,
     *   CTEST*8, ATIME*8, ADATE*12
      INTEGER   IBLK(256), TTYLUN, TTYIND, IERR, LUN, FIND, IREC, IVER,
     *   TTY(2), I, IUSER, MXUSER, LREC, NTASK, NWPL, NLPR, IOFF, JTRIM,
     *   BUFFER(256), INUSER, IRET, NPARM, NC
      LOGICAL   T, F, RQUICK, ISTASK
      HOLLERITH XXTASK(2)
      CHARACTER TNMS(NMAX)*8, OLDTGS(NMAX)*3, ANAME*8
      INTEGER   ITIMES(6,NMAX), USERS(NMAX), KK, KKLAST, K
      DOUBLE PRECISION JDS(NMAX), JD
      HOLLERITH HBLK(256)
      EQUIVALENCE (HBLK, IBLK)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (TTY(1), TTYLUN),  (TTY(2), TTYIND)
      DATA PRGNAM /'TGREP '/
      DATA T, F /.TRUE.,.FALSE./
      DATA TTYLUN, LUN /5, 16/
C-----------------------------------------------------------------------
C                                       AIPS init
      NPOPS = 1
      MSGCNT = -1
      NLUSER = 1
      TSKNAM = PRGNAM
      CALL ZDCHIN (.TRUE.)
      NPARM = 2
      IRET = 0
      ISTASK = .FALSE.
C                                       Are we a task?
      CALL GTPARM (PRGNAM, NPARM, RQUICK, XXTASK, BUFFER, IERR)
      IF (IERR.EQ.0) THEN
         INUSER = NLUSER
         CALL H2CHR (8, 1, XXTASK, TNAME)
         ISTASK = .TRUE.
         IF (RQUICK) CALL RELPOP (IRET, BUFFER, IERR)
         IRET = 8
         IF (TNAME.EQ.' ') THEN
            MSGTXT = 'YOU MUST SPECIFY A TASK'
            CALL MSGWRT (8)
            GO TO 995
            END IF
      ELSE
         NPOPS = 1
         INUSER = 1
         RQUICK = .TRUE.
         END IF
C                                       Open terminal
      IF (.NOT.ISTASK) THEN
         CALL ZOPEN (TTYLUN, TTYIND, 1, PHNAME, F, F, T, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPENING TERMINAL'
            CALL MSGWRT (8)
            GO TO 995
            END IF
         END IF
      MSGTXT = 'I look for tasks in TGET files'
      CALL MSGWRT (2)
C                                       Loop to ask for vol, cat #s
 10   IF (.NOT.ISTASK) THEN
         MSGBUF = 'Enter desired task name - QUIT to stop'
         CALL INQSTR (TTY, MSGBUF, 8, TNAME, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READING FROM TERMINAL'
            CALL MSGWRT (8)
            GO TO 995
            END IF
         IF (IERR.LT.0) GO TO 995
         END IF
      NC = JTRIM (TNAME)
      CALL CHLTOU (8, TNAME)
      IF (TNAME.EQ.'QUIT') GO TO 995
      MXUSER = 36 * 36 * 36 - 1
      IVER = 0
      KK = 0
      DO 100 IUSER = 1,MXUSER
         KKLAST = KK + 1
         NLUSER = IUSER
         CALL ZPHFIL ('TG', 1, 800, IVER, PHNAME, IERR)
         CALL ZEXIST (1, PHNAME, I, IERR)
         IF (IERR.EQ.1) THEN
            CALL ZPHFIL ('TG', 1, 400, IVER, PHNAME, IERR)
            CALL ZEXIST (1, PHNAME, I, IERR)
            OLDTG = 'old'
         ELSE
            OLDTG = 'new'
            END IF
         NLUSER = INUSER
         IF (IERR.NE.0) GO TO 100
C                                       open file
 20      NLUSER = INUSER
         CALL ZOPEN (LUN, FIND, 1, PHNAME, F, T, T, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'OPEN TG FILE'
            GO TO 90
            END IF
         CALL ZFIO ('READ', LUN, FIND, 1, IBLK, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1000) IERR, 'READ TG FILE REC 1'
            GO TO 90
            END IF
         NTASK = IBLK(2)
         LREC = 1
         NWPL = 5
         NLPR = 256 / NWPL
         DO 30 I = 1,NTASK
            IREC = I / NLPR + 1
            IF (IREC.NE.LREC) THEN
               CALL ZFIO ('READ', LUN, FIND, IREC, IBLK, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1000) IERR, 'READ TG FILE'
                  GO TO 90
                  END IF
               END IF
            IOFF = MOD (I, NLPR) * NWPL
            CALL H2CHR (8, 1, HBLK(IOFF+1), CTEST)
            IF (CTEST(:NC).EQ.TNAME(:NC)) THEN
               IF (KK.GE.KKLAST) THEN
                  DO 25 K = KKLAST,KK
                     IF (CTEST.EQ.TNMS(K)) GO TO 30
 25                  CONTINUE
                  END IF
               KK = KK + 1
               TNMS(KK) = CTEST
               CALL CATIME (2, IBLK(IOFF+3), ITIMES(1,KK))
               USERS(KK) = IUSER
               OLDTGS(KK) = OLDTG
               CALL DAT2JD (ITIMES(1,KK), JDS(KK))
C               CALL TIMDAT (ITIME(4), ITIME(1), ATIME, ADATE)
C               WRITE (MSGTXT,1030) IUSER, CTEST, ADATE, ATIME, OLDTG
C               CALL MSGWRT (5)
C               J = J + 1
               END IF
 30         CONTINUE
         CALL ZCLOSE (LUN, FIND, IERR)
         IF (OLDTG.EQ.'new') THEN
            NLUSER = IUSER
            CALL ZPHFIL ('TG', 1, 400, IVER, PHNAME, IERR)
            CALL ZEXIST (1, PHNAME, I, IERR)
            OLDTG = 'old'
            IF (IERR.EQ.0) GO TO 20
            END IF
         GO TO 100
C                                       error
 90      CALL MSGWRT (8)
C                                       close
         CALL ZCLOSE (LUN, FIND, IERR)
 100     CONTINUE
C                                       now print
      KKLAST = KK
C                                       find a task to print
 110  ANAME = 'ZZZZZZZZ'
      KK = 0
      DO 115 K = 1,KKLAST
         IF (TNMS(K).NE.' ') THEN
            IF (TNMS(K).LT.ANAME) THEN
               KK = K
               ANAME = TNMS(K)
               END IF
            END IF
 115     CONTINUE
      IF (KK.LE.0) ANAME = ' '
C                                       now sort by time
      IF (ANAME.NE.' ') THEN
 120     JD = 1.E10
         KK = 0
         DO 125 K = 1,KKLAST
            IF ((TNMS(K).NE.' ') .AND. (JDS(K).GT.0.0D0)) THEN
               IF ((JDS(K).LT.JD) .AND. (TNMS(K).EQ.ANAME)) THEN
                  KK = K
                  JD = JDS(K)
                  END IF
               END IF
 125        CONTINUE
         IF (KK.GT.0) THEN
            CALL TIMDAT (ITIMES(4,KK), ITIMES(1,KK), ATIME, ADATE)
            WRITE (MSGTXT,1030) USERS(KK), TNMS(KK), ADATE, ATIME,
     *         OLDTGS(KK)
            CALL MSGWRT (5)
            JDS(KK) = -1.E10
            TNMS(KK) = ' '
            GO TO 120
            END IF
         GO TO 110
         END IF
C                                       loop for more interactive
      IF (.NOT.ISTASK) GO TO 10
      IRET = 0
C
 995  IF (ISTASK) THEN
         NLUSER = INUSER
         CALL DIETSK (IRET, RQUICK, BUFFER)
      ELSE
         CALL ZCLOSE (TTYLUN, TTYIND, IERR)
         NLUSER = 1
         CALL ACOUNT (2)
         END IF
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' ON ',A)
 1030 FORMAT ('Found user',I6,' task ',A,2X,A12,A8,' TG vers ',A)
      END

      PROGRAM FIXAN
C-----------------------------------------------------------------------
C! Prints contents of ANtenna file
C# Calibration Utility VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 2012, 2016, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   FIXAN prints the contents of an antenna 'AN' file on the line
C   printer.
C   Inputs:
C      AIPS ADVERB    PRGM NAME            Description.
C      USERID           ID          User id number for desired file.
C      INNAME           NAME        Name of desired uv data file.
C      INCLASS          CLASS       Class of desired uv data file.
C      INSEQ            SEQ         Seq. no. of desired file.
C      INDISK           DISK        Disk number of desired file.
C      INVER            VER         Version number of ext. file
C                                   0 => most recent
C      OPTYPE           OPTYPE      'CENTR' only known one
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANT.INC'
      HOLLERITH XNAME(3), XCLASS(2), XOPTYP(1)
      CHARACTER PRGM*6, NAME*12, CLASS*6, ATIME*8, ADATE*12, OPTYPE*4,
     *   UTYPE*2, STAT*4, HILINE*72, KEYWRD(3)*8
      INTEGER   SEQ, DISK, VER, IABUF(512), LUN, FIND, LUNA, CNO, IERR,
     *   DATE(3), IT(3), NPARM, IRET, ID, IANT, NANT, IROUND, NSUM,
     *   BUFFER(256), IABUF2(512), VER2, LUNB, I, HLUN, LOCS(3),
     *   KEYTYP(3)
      LOGICAL   RQUICK
      REAL      XSEQ, XDISK, XVER, OVER, ABUFF(512)
      DOUBLE PRECISION OLDC(3), NEWC(3), DX, DY, COSA, SINA, ARRLON
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      COMMON /INCOM/ XNAME, XCLASS, XSEQ, XDISK, XVER, OVER, XOPTYP
      EQUIVALENCE (IABUF, ABUFF)
      DATA PRGM /'FIXAN '/
      DATA LUN, LUNA, LUNB, HLUN /16, 29,30, 31/
      DATA KEYWRD /'ARRAYX','ARRAYY','ARRAYZ'/
      DATA LOCS, KEYTYP /1,3,5, 3*1/
C-----------------------------------------------------------------------
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                        Get parms.
      NPARM = 10
      CALL GTPARM (PRGM, NPARM, RQUICK, XNAME, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         IRET = 8
         RQUICK = .FALSE.
         GO TO 990
         END IF
      IRET = 0
C                                        Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFFER, IERR)
      IRET = 8
C                                        Crunch parameters.
      ID = NLUSER
      SEQ = IROUND (XSEQ)
      DISK = IROUND (XDISK)
      VER = IROUND (XVER)
      CALL H2CHR (12, 1, XNAME, NAME)
      CALL H2CHR (6, 1, XCLASS, CLASS)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      UTYPE = 'UV'
      STAT = 'WRIT'
      CALL MAPOPN (STAT, DISK, NAME, CLASS, SEQ, UTYPE, ID, LUN,
     *   FIND, CNO, CATBLK, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, NAME, CLASS, SEQ, 'UV', DISK, ID
         CALL MSGWRT (8)
         GO TO 990
         END IF
      CALL FNDEXT ('AN', CATBLK, I)
      IF ((VER.LE.0) .OR. (VER.GT.I)) VER = I
      VER2 = IROUND (OVER)
      IF (VER2.LE.0) VER2 = VER
C                                        Init AN file.
      CALL ANTINI ('READ', IABUF, DISK, CNO, VER, CATBLK, LUNA, IANRNO,
     *   ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE, POLRXY,
     *   UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB, NOPCAL,
     *   ANTNIF, ANFQID, IERR)
      IF (IERR.NE.0) GO TO 980
      NANT = IABUF(5)
C                                       CENT operation
C                                       assumes stupid Earth surface
C                                       coords
      IF (OPTYPE.EQ.'WRNG') THEN
         IF ((ARRAYC(1).LE.1.D0) .AND. (ARRAYC(2).LE.1.D0) .AND.
     *      (ARRAYC(3).LE.1.D0)) THEN
            MSGTXT = 'WRNG REQUIRES EARTH SURFACE ARRAY CENTER'
            CALL MSGWRT (8)
            IRET = 10
            GO TO 970
            END IF
         OLDC(1) = ARRAYC(1)
         OLDC(2) = ARRAYC(2)
         OLDC(3) = ARRAYC(3)
         ARRAYC(1) = 0.0D0
         ARRAYC(2) = 0.0D0
         ARRAYC(3) = 0.0D0
         NEWC(1) = ARRAYC(1)
         NEWC(2) = ARRAYC(2)
         NEWC(3) = ARRAYC(3)
         CALL ANTINI ('WRIT', IABUF2, DISK, CNO, VER2, CATBLK, LUNB,
     *      IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *      RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *      TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IRET)
         IF (IRET.NE.0) GO TO 980
         IF ((NEWC(1).NE.ARRAYC(1)) .OR. (NEWC(2).NE.ARRAYC(2)) .OR.
     *      (NEWC(3).NE.ARRAYC(3))) THEN
            CALL TABKEY ('WRIT', KEYWRD, 3, IABUF2, LOCS, NEWC,
     *         KEYTYP, IRET)
            IF (IRET.NE.0) GO TO 970
            END IF
C                                       do the naive fix
         DO 20 IANT = 1,NANT
            IANRNO = IANT
            CALL TABAN ('READ', IABUF, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
            IF (IRET.GT.0) GO TO 970
            IF (IRET.EQ.0) THEN
               STAXYZ(1) = STAXYZ(1) + OLDC(1)
               STAXYZ(2) = STAXYZ(2) + OLDC(2)
               STAXYZ(3) = STAXYZ(3) + OLDC(3)
               IANRNO = IANT
               CALL TABAN ('WRIT', IABUF2, IANRNO, ANKOLS, ANNUMV,
     *            ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN,
     *            FWHMAN, POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB,
     *            IRET)
               IF (IRET.GT.0) GO TO 970
               END IF
 20         CONTINUE
C                                       Correct surface -> centric
      ELSE IF (OPTYPE.EQ.'CENT') THEN
         IF ((ARRAYC(1).LE.1.D0) .AND. (ARRAYC(2).LE.1.D0) .AND.
     *      (ARRAYC(3).LE.1.D0)) THEN
            MSGTXT = 'CENT REQUIRES EARTH SURFACE ARRAY CENTER'
            CALL MSGWRT (8)
            IRET = 10
            GO TO 970
            END IF
         ARRLON = ATAN2 (ARRAYC(2), ARRAYC(1))
         SINA = SIN (ARRLON)
         COSA = COS (ARRLON)
         OLDC(1) = ARRAYC(1)
         OLDC(2) = ARRAYC(2)
         OLDC(3) = ARRAYC(3)
         ARRAYC(1) = 0.0D0
         ARRAYC(2) = 0.0D0
         ARRAYC(3) = 0.0D0
         NEWC(1) = ARRAYC(1)
         NEWC(2) = ARRAYC(2)
         NEWC(3) = ARRAYC(3)
         CALL ANTINI ('WRIT', IABUF2, DISK, CNO, VER2, CATBLK, LUNB,
     *      IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *      RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *      TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IRET)
         IF (IRET.NE.0) GO TO 980
         IF ((NEWC(1).NE.ARRAYC(1)) .OR. (NEWC(2).NE.ARRAYC(2)) .OR.
     *      (NEWC(3).NE.ARRAYC(3))) THEN
            CALL TABKEY ('WRIT', KEYWRD, 3, IABUF2, LOCS, NEWC,
     *         KEYTYP, IRET)
            IF (IRET.NE.0) GO TO 970
            END IF
C                                       do the correct fix
         DO 30 IANT = 1,NANT
            IANRNO = IANT
            CALL TABAN ('READ', IABUF, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
            IF (IRET.GT.0) GO TO 970
            IF (IRET.EQ.0) THEN
               DX = STAXYZ(1)*COSA - STAXYZ(2)*SINA
               DY = STAXYZ(2)*COSA + STAXYZ(1)*SINA
               STAXYZ(1) = OLDC(1) + DX
               STAXYZ(2) = OLDC(2) + DY
               STAXYZ(3) = OLDC(3) + STAXYZ(3)
               IANRNO = IANT
               CALL TABAN ('WRIT', IABUF2, IANRNO, ANKOLS, ANNUMV,
     *            ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN,
     *            FWHMAN, POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB,
     *            IRET)
               IF (IRET.GT.0) GO TO 970
               END IF
 30         CONTINUE
C                                       assumes Earth centric ->
C                                       correct surface oriented
      ELSE IF (OPTYPE.EQ.'SURF') THEN
         IF ((ARRAYC(1).GT.1.D0) .OR. (ARRAYC(2).GT.1.D0) .OR.
     *      (ARRAYC(3).GT.1.D0)) THEN
            MSGTXT = 'SURF REQUIRES EARTH CENTRIC ARRAY CENTER'
            CALL MSGWRT (8)
            IRET = 10
            GO TO 970
            END IF
C                                       average
         NSUM = 0
         DO 50 IANT = 1,NANT
            IANRNO = IANT
            CALL TABAN ('READ', IABUF, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
            IF (IRET.GT.0) GO TO 970
            IF (IRET.EQ.0) THEN
               IF ((ABS(STAXYZ(1)).GT.1.0D0) .OR.
     *            (ABS(STAXYZ(2)).GT.1.0D0) .OR.
     *            (ABS(STAXYZ(3)).GT.1.0D0)) NSUM = NSUM + 1
               ARRAYC(1) = ARRAYC(1) + STAXYZ(1)
               ARRAYC(2) = ARRAYC(2) + STAXYZ(2)
               ARRAYC(3) = ARRAYC(3) + STAXYZ(3)
               END IF
 50         CONTINUE
         ARRAYC(1) = ARRAYC(1) / NSUM
         ARRAYC(2) = ARRAYC(2) / NSUM
         ARRAYC(3) = ARRAYC(3) / NSUM
         IF ((ANAME.EQ.'VLA') .OR. (ANAME.EQ.'EVLA')) THEN
            ARRAYC(1) = -1601185.365D0
            ARRAYC(2) =  -5041977.547D0
            ARRAYC(3) =  3554875.87D0
            END IF
         ARRLON = ATAN2 (ARRAYC(2), ARRAYC(1))
         SINA = SIN (ARRLON)
         COSA = COS (ARRLON)
         NEWC(1) = ARRAYC(1)
         NEWC(2) = ARRAYC(2)
         NEWC(3) = ARRAYC(3)
         CALL ANTINI ('WRIT', IABUF2, DISK, CNO, VER2, CATBLK, LUNB,
     *      IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *      RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN,
     *      TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IRET)
         IF (IRET.NE.0) GO TO 980
         IF ((NEWC(1).NE.ARRAYC(1)) .OR. (NEWC(2).NE.ARRAYC(2)) .OR.
     *      (NEWC(3).NE.ARRAYC(3))) THEN
            CALL TABKEY ('WRIT', KEYWRD, 3, IABUF2, LOCS, NEWC,
     *         KEYTYP, IRET)
            IF (IRET.NE.0) GO TO 970
            END IF
         DO 60 IANT = 1,NANT
            IANRNO = IANT
            CALL TABAN ('READ', IABUF, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
            IF (IRET.GT.0) GO TO 970
            DX = STAXYZ(1) - NEWC(1)
            DY = STAXYZ(2) - NEWC(2)
            STAXYZ(1) = DX * COSA + DY * SINA
            STAXYZ(2) = DY * COSA - DX * SINA
            STAXYZ(3) = STAXYZ(3) - NEWC(3)
            IANRNO = IANT
            CALL TABAN ('WRIT', IABUF2, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
            IF (IRET.GT.0) GO TO 970
 60         CONTINUE
         END IF
C                                       should be HI
      CALL ZTIME (IT)
      CALL DATEST (RDATE, DATE)
      CALL TIMDAT (IT, DATE, ATIME, ADATE)
      CALL HIINIT (3)
      CALL HIOPEN (HLUN, DISK, CNO, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      WRITE (HILINE,1060) TSKNAM, RLSNAM, ADATE, ATIME
      CALL HIADD (HLUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      WRITE (HILINE,1061) TSKNAM, VER
      CALL HIADD (HLUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      WRITE (HILINE,1062) TSKNAM, VER2
      CALL HIADD (HLUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      IF (OPTYPE.EQ.'WRNG') THEN
         WRITE (HILINE,1066) TSKNAM
      ELSE IF (OPTYPE.EQ.'CENT') THEN
         WRITE (HILINE,1067) TSKNAM
      ELSE
         WRITE (HILINE,1068) TSKNAM
         END IF
      CALL HIADD (HLUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL HICLOS (HLUN, .TRUE., BUFFER, IERR)
C
 970  CALL TABAN ('CLOS', IABUF, IANRNO, ANKOLS, ANNUMV, ANNAME, STAXYZ,
     *   ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN, POLTYA, POLAA,
     *   POLCA, POLTYB, POLAB, POLCB, IERR)
      CALL TABAN ('CLOS', IABUF2, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *   STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN, POLTYA,
     *   POLAA, POLCA, POLTYB, POLAB, POLCB, IERR)
 980  CALL MAPCLS ('WRIT', DISK, CNO, LUN, FIND, CATBLK, .TRUE.,
     *   BUFFER, IERR)
C
 990  CALL DIETSK (IRET, RQUICK, BUFFER)
C
 999  STOP
C-----------------------------------------------------------------------
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,1X,A2,
     *   ' DISK=',I3,' USER=',I5)
 1060 FORMAT (A6,'RELEASE =''',A7,'''  /********* Start ',
     *   A12,A8)
 1061 FORMAT (A6,'INVERS =',I6,'  / input AN version number')
 1062 FORMAT (A6,'OUTVERS=',I6,'  / output AN version number')
 1066 FORMAT (A6,'OPTYPE=''WRNG''  / correct erroneous Earth',
     *   ' surface to Earth centric')
 1067 FORMAT (A6,'OPTYPE=''CENT''  / change correct Earth',
     *   ' surface to Earth centric')
 1068 FORMAT (A6,'OPTYPE=''SURF''  / change Earth centric',
     *   ' to correct Earth surface')
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QCLNSU (COMP, AMAP, LMAP, ABEAM, BBEAM)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Low level Clark CLEAN routine.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Pseudo-AP version
C   QCLNSU does a CLEAN on the map points in the pseudo AP
C   using the portion of the beam in the pseudo AP.
C   Inputs:
C      COMP  I  Base address of the component vector:
C               0 => intensity
C               1 => x in cells
C               2 => Y in cells
C               3 => CLEAN loop gain (fractional)
C      AMAP  I  Base address of the map stored as (X,Y,intensity)
C               -1<X<NX  -1<Y<NY
C      LMAP  I  Number of map points
C      ABEAM I  Base address of the piece of the beam.  The Y
C               dimension varies the fastest: -BY<Y<BY,
C               X varies slowest -1<X<BX
C      BBEAM I  Base address of beam descriptor vector (BX,BY)
C-----------------------------------------------------------------------
      INTEGER   COMP, AMAP, LMAP, ABEAM, BBEAM, IBX, IBY, IDX, IDY,
     *   JCOMP, JAMAP, JBBEAM, LOOP, BEAMO, IFIX, IABS, SAVLOC, I,
     *   JAMAX, IMAX, IDXA(20000), IDYA(20000), BEAMOA(20000),
     *   IBYA, IBYT, JAMAP2, JCOMP1, JCOMP2
      REAL      XLOC, X, Y, DX, DY, SUBT, XCOMP, YCOMP,
     *   XMAX, AXMAX,
     *   TEMPX(20000), TEMPY(20000), TEMPZ(20000)
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                        Get 1-rel addresses.
      JCOMP = COMP + 1
      JCOMP1 = COMP + 2
      JCOMP2 = COMP + 3
      JAMAP = AMAP + 1
      JAMAP2 = AMAP + 3
      JBBEAM = BBEAM + 1
      IF (LMAP.LE.0) GO TO 999
      IF (LMAP.GT.20000) THEN
         WRITE(*,*) 'LMAP .GT. 20000 (QCLNSU).  LMAP = ', LMAP
         GO TO 999
      END IF
C                                        Get component to be CLEANed
      XCOMP = APCORE(JCOMP1)
      YCOMP = APCORE(JCOMP2)
      SUBT = (- APCORE(JCOMP)) * APCORE(JCOMP+3)
C                                        Get beam patch
      IBX = APCORE(JBBEAM) + 0.1
      IBY = APCORE(JBBEAM+1) + 0.1
      IBYA = IBY + ABEAM
C                                        Added stuff.
      IBYT = 2 * IBY - 1
      JAMAX = JAMAP + 3 * (LMAP - 1)
C                                      
      I = 1
      DO 10 LOOP = JAMAP, JAMAX, 3
         TEMPX(I) = APCORE(LOOP) - XCOMP
         TEMPY(I) = APCORE(LOOP+1) - YCOMP
         I = I + 1
 10      CONTINUE
C
      DO 20 I = 1,LMAP
         IF(TEMPX(I).LT.0.0) THEN
           IDXA(I) = TEMPX(I) - 0.1
         ELSE
           IDXA(I) = TEMPX(I) + 0.1
         ENDIF
         IF(TEMPY(I).LT.0.0) THEN
           IDYA(I) = TEMPY(I) - 0.1
         ELSE
           IDYA(I) = TEMPY(I) + 0.1
         ENDIF
 20      CONTINUE
C
      DO 40 I = 1,LMAP
         IF(IDXA(I).LT.0) THEN 
           BEAMOA(I) = (-IDXA(I)*IBYT)-IDYA(I)
         ELSE
           BEAMOA(I) = IDXA(I)*IBYT+IDYA(I)
         ENDIF
 40      CONTINUE
C
      DO 60 I = 1,LMAP
         TEMPZ(I) = APCORE(BEAMOA(I)+IBYA)
 60      CONTINUE
C
      DO 70 I = 1,LMAP
         IF( (ABS(IDXA(I)) .GE. IBX)
     *            .OR.( ABS(IDYA(I)) .GE. IBY))
     *      TEMPZ(I) = 0.0
 70      CONTINUE
C
      CALL SAXPY(LMAP,SUBT,TEMPZ,1,APCORE(JAMAP2),3)
C                                        Find largest mag. residual
C                                        using ESSL call.
      IMAX = ISAMAX(LMAP,APCORE(JAMAP2),3)
      SAVLOC = JAMAP2 + (IMAX - 1) * 3
C                                        Crunch location
      APCORE(JCOMP) = APCORE(SAVLOC)
      APCORE(JCOMP1) = APCORE(SAVLOC-2)
      APCORE(JCOMP2) = APCORE(SAVLOC-1)
C
 999  RETURN
      END

      SUBROUTINE MAPCR (ONAMS, NAMS, HDR, ERROR)
C-----------------------------------------------------------------------
C! create and catalog an image in the WaWa package
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   WaWa IO system: Create and catalog a map whose catalog description
C   is defined by the namestring NAMS, and whose size is specified by
C   the KIDIM, KINAX, and KIBPX parameters in the Header.
C   Inputs:
C      ONAMS  C*36    Namestring of related "input" file - must be
C                     complete and correct; used to complete defaults
C                     in NAMS (typically the input file namestring).
C   In/Out:
C      NAMS   C*36    Namestring NAME:CLASS:TYPE:SEQ:VOL:USID of map to
C                     be created; can contain blanks, wildcards...
C      HDR    I(256)  Catalog header for map, containing enough info to
C                     define size.  The updated header is returned for
C                     real images, not SC files
C   Outputs:
C      ERROR  I       Error code: 0 => ok
C                                10 => catalog error
C                                14 => no room in catalog
C                                21 => file already exists
C                                23 => create error
C   written by WaWa (4/21/81)
C-----------------------------------------------------------------------
      INTEGER   HDR(256), ERROR
      CHARACTER ONAMS*36, NAMS*36
C
      CHARACTER DNAMS*36, BLANK*6, DNAME*12, DCLAS*6, DPTYP*2, ONAME*12,
     *   OCLAS*6, OPTYP*2
      LOGICAL   LSC
      INTEGER   IERR, SEQ, DUM, CNO, CATER, CREATR(4), OSEQ, IV, I,
     *   DVOL, DUSE, OVOL, OUSE
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA CATER, CREATR /10, 23,21,14,10/
      DATA BLANK /'    '/
C-----------------------------------------------------------------------
C                                             Copy header
      CALL COPY (256, HDR, CATBLK)
C                                             Prepare name
      CALL PRENAM (NAMS, DNAMS, LSC)
      CALL WAWA2A (DNAMS, DNAME, DCLAS, SEQ, DPTYP, DVOL, DUSE)
      CALL WAWA2A (ONAMS, ONAME, OCLAS, OSEQ, OPTYP, OVOL, OUSE)
      IF (LSC) SEQ = 0
      IF (.NOT.LSC) CALL MAKOUT (ONAME, OCLAS, OSEQ, BLANK, DNAME,
     *   DCLAS, SEQ)
      IF (DPTYP.EQ.' ') DPTYP = OPTYP
      IF (DUSE.LT.1) DUSE = OUSE
C                                             Copy name info into HDR
      CALL CHR2H (12, DNAME, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, DCLAS, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQ
      CALL CHR2H (2, DPTYP, KHPTYO, CATH(KHPTY))
      CATBLK(KIIMU) = DUSE
C                                       Do create: map
 15   ERROR = 0
      IF (LSC) GO TO 20
         CALL MCREAT (DVOL, CNO, WBUFF, IERR)
C                                             Copy header
         IF (IERR.EQ.0) CALL COPY (256, CATBLK, HDR)
         IF (IERR.EQ.0) GO TO 40
            IF (IERR.GT.4) IERR = 4
            ERROR = CREATR(IERR)
            GO TO 990
C                                       Scratch create
 20   CONTINUE
         DVOL = 1
         IF (NSCR.GE.1) DVOL = SCRVOL(NSCR)
         IF ((NSCR.LE.0) .AND. (NCFILE.GE.1)) DVOL = FVOL(NCFILE)
         DO 30 IV = 1,NVOL
            DVOL = MOD (DVOL, NVOL) + 1
            DO 25 I = 1,10
               IF (DVOL.EQ.IBAD(I)) GO TO 30
 25            CONTINUE
            CALL MCREAT (DVOL, CNO, WBUFF, IERR)
            IF (IERR.EQ.0) GO TO 40
               IF (IERR.EQ.1) GO TO 30
                  IF (IERR.GT.4) IERR = 4
                  ERROR = CREATR(IERR)
                  GO TO 990
 30         CONTINUE
         ERROR = CREATR(1)
         GO TO 990
C                                       Return actual seq #
 40   SEQ = CATBLK(KIIMS)
      CALL A2WAWA (DNAME, DCLAS, SEQ, DPTYP, DVOL, DUSE, DNAMS)
      NAMS = DNAMS
C                                       Leave catlg at rest
      CALL CATDIR ('CSTA', DVOL, CNO, DNAME, DCLAS, DUM, DPTYP,
     *   DUSE, 'CLWR', WBUFF, IERR)
      IF (IERR.EQ.0) GO TO 50
         ERROR = CATER
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (8)
         GO TO 990
C                                       Put this file in CFIL common.
 50   IF (.NOT.LSC) THEN
         IF (NCFILE.LT.FILIST) THEN
            NCFILE = NCFILE + 1
            FVOL(NCFILE) = DVOL
            FCNO(NCFILE) = CNO
            FRW(NCFILE) = 2
         ELSE
            MSGTXT = 'MAPCR: FILE LIST OVERFLOWS'
            CALL MSGWRT (8)
            IERR = 9
            END IF
      ELSE
         IF (NSCR.LT.SCRLST) THEN
            NSCR = NSCR + 1
            SCRVOL(NSCR) = DVOL
            SCRCNO(NSCR) = CNO
         ELSE
            MSGTXT = 'MAPCR: SCRATCH FILE LIST OVERFLOWS'
            CALL MSGWRT (8)
            IERR = 9
            END IF
         END IF
      IF (IERR.EQ.0) GO TO 999
C
 990  CALL PRTNAM (DNAMS, 8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('CATDIR ERROR',I7,' CLEARING WRITE AFTER CREATE')
      END

      SUBROUTINE QVSMSA (A, I, B, C, D, L, N)
C-----------------------------------------------------------------------
C! FPS AP version: Vector scalar multiply, scalar add
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FPS AP version
C   Vector Scalar multiply, scalar add:
C        D(mL) = (A(mI) * B) + C    for m=0,N-1
C    Inputs:
C      A  I  First source vector base address
C      I  I  A address increment
C      B  I  Source multiplicative scalar address
C      C  I  Source additive scalar address
C      D  I  Destination vector base address
C      L  I  D address increment
C      N  I  Element count
C-----------------------------------------------------------------------
      INTEGER A, I, B, C, D, L, N
      INTEGER*2 IA, II, IB, IC, ID, IL, IN
C-----------------------------------------------------------------------
C                                        Convert inputs to unsigned I*2
      IF (A.LT.32768) IA = A
      IF (A.GE.32768) IA = A - 65536
      IF (I.LT.32768) II = I
      IF (I.GE.32768) II = I - 65536
      IF (B.LT.32768) IB = B
      IF (B.GE.32768) IB = B - 65536
      IF (C.LT.32768) IC = C
      IF (C.GE.32768) IC = C - 65536
      IF (D.LT.32768) ID = D
      IF (D.GE.32768) ID = D - 65536
      IF (L.LT.32768) IL = L
      IF (L.GE.32768) IL = L - 65536
      IF (N.LT.32768) IN = N
      IF (N.GE.32768) IN = N - 65536
C                                        Call FPS routine.
      CALL VSMSA (IA, II, IB, IC, ID, IL, IN)
C
 999  RETURN
      END

      SUBROUTINE GCINIT (CHN, COL, IERR)
C-----------------------------------------------------------------------
C! inits the image catalog and image plane for TV-using plot
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2002
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GCINIT initializes a TV channel: YCINIT, YZERO, ZSLECT
C   Inputs:
C      CHN     I   TV channel 1 - NGRAY+NGRAPH
C      COL     I   0 ALL, 1 R, 2 G, 3 B
C   Output:
C      IERR    I   Error code
C-----------------------------------------------------------------------
      INTEGER   CHN, COL, IERR
C
      INTEGER   LC
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DGPH.INC'
C-----------------------------------------------------------------------
      IERR = 0
      IF (CHN.LT.0) CHN = -CHN
      IF (GPHCON(CHN).LE.0) THEN
         LC = COL
         IF (CHN.GT.NGRAY) LC = 0
         CALL YCINIT (CHN, GPHSCR)
         CALL YZERO (CHN, IERR)
         IF ((IERR.EQ.0) .AND. (LC.NE.0)) CALL YSLECT ('OFFF', CHN, 0,
     *      GPHSCR, IERR)
         IF (IERR.EQ.0) CALL YSLECT ('ONNN', CHN, LC, GPHSCR, IERR)
         GPHCON(CHN) = 1
         END IF
C
 999  RETURN
      END

      SUBROUTINE TABSPC (FORMAT, COUNT, IWIDTH, FRAC, TYPE, IERR)
C-----------------------------------------------------------------------
C! Determines repeat count and data type for FITS 3-D tables entries.
C# FITS Tape EXT-util Parsing
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Determines the TABle SPeCification of a variable with from a FORMAT
C   type. The repeat count and data type from a format used by the
C   FITS 1-D and 3-D tables.  The recognized data types are:
C       Format   Type code         Type
C         D        1         Double precision real
C         E        2         Single precision real
C         A        3         Character
C         J        4         Long integer (32 bits)
C         L        5         Logical
C         I        6         Short integer (16 bits)
C         X        7         bit array
C   Input:
C      FORMAT   C*8   Format, eg. '4E15.6'
C   Output:
C      COUNT    I     Element count
C      IWIDTH   I     The width of the field.
C      FRAC     I     The fractional part of the field (E and D only).
C      TYPE     I     Data type
C      IERR     I     Error code, 0 => OK,   else failed.
C-----------------------------------------------------------------------
      CHARACTER FORMAT*(*)
      INTEGER   COUNT, IWIDTH, FRAC, TYPE, IERR
C
      CHARACTER DTYCOD*14, NUMS*10, FTYPE*1, ONECHR
      INTEGER   TYCOD(14), NTYP, ITYP, ISUM, LOOP, INUM, INDEX, IPOS,
     *   ISTART
      INCLUDE 'INCS:DMSG.INC'
      PARAMETER (NTYP=14)
      DATA DTYCOD /'DdEeAaJjLlIiXx'/
      DATA TYCOD  / 1,1,2,2,3,3,4,4,5,5,6,6,7,7/
      DATA NUMS /'0123456789'/
C-----------------------------------------------------------------------
      IERR = 1
      COUNT = 0
      TYPE = 0
C                                       Initialize count
      ISUM = 0
C                                       Decode count
      DO 50 LOOP = 1,8
         INUM = INDEX(NUMS, FORMAT(LOOP:LOOP))
         IPOS = LOOP
         IF (INUM.LE.0) GO TO 60
         ISUM = 10 * ISUM + (INUM - 1)
 50      CONTINUE
C                                       Shouldn't get here.
      GO TO 980
C                                       No counts are interpreted as 1 count
 60   IF (ISUM.EQ.0 .AND. IPOS.EQ.1 .AND. FORMAT(1:1).NE.'0') THEN
         COUNT = 1
      ELSE
         COUNT = ISUM
         END IF
C                                       Find data type.
      FTYPE = FORMAT(IPOS:IPOS)
      ITYP = INDEX (DTYCOD(1:NTYP), FTYPE)
C                                       Shouldn't get here - invalid
C                                       type
      IF (ITYP.LE.0) GO TO 980
      TYPE = TYCOD(ITYP)
C                                       Determine width.
      IWIDTH = 0
C                                       Width starts after Type
      ISTART = IPOS + 1
C                                       If no chars left exit
      IF (ISTART.GT.8) GO TO 980
      DO 300 IPOS = ISTART,8
         ONECHR = FORMAT(IPOS:IPOS)
         IF ((ONECHR.EQ.'.') .OR. (ONECHR.EQ.' ')) GO TO 400
         INUM = INDEX (NUMS, ONECHR)
C                                       if invalid character, jump to exit
         IF (INUM.LE.0) GO TO 980
         IWIDTH = (10 * IWIDTH) + (INUM - 1)
 300     CONTINUE
C                                       if not R*8 or R*4, we are finished
 400  IF (TYPE.GE.3) THEN
         FRAC = -1
         IERR = 0
         GO TO 999
         END IF
C                                       Determine fraction.
      FRAC = 0
      ISTART = IPOS + 1
      IF (ISTART.GT.8) GO TO 980
      DO 500 IPOS = ISTART,8
         ONECHR = FORMAT(IPOS:IPOS)
C                                       End of format, done
         IF (ONECHR.EQ.' ') THEN
            IERR = 0
            GO TO 999
            END IF
         INUM = INDEX (NUMS, ONECHR)
C                                       invalid number
         IF (INUM.LE.0) GO TO 980
         FRAC = (10 * FRAC) + (INUM - 1)
 500     CONTINUE
 
      IERR = 0
      GO TO 999
C                                       Error
 980  WRITE (MSGTXT,1080) FORMAT
      CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1080 FORMAT ('TABSPC: COULD NOT DECODE FORMAT ',A)
      END

      SUBROUTINE BLREFM (DISK, CNO, VER, CATBLK, LUN, IRET)
C-----------------------------------------------------------------------
C! Checks existence of BL table, changes format if necessary
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1998
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Routine to change the format of the BL table from one containing
C   13/9 columns to the 14/10 columns needed by the addition of the
C   FREQID column.
C   NOTE: routine uses LUN 45 as a temporary logical unit number.
C
C   Inputs:
C      DISK            I       Volume number
C      CNO             I       Catalogue number
C      VER             I       Version to check/modify
C      CATBLK(256)     I       Catalogue header
C      LUN             I       LUN to use
C   Output:
C      IRET            I       Error, 0 => OK
C
C   Note, routine will leave no trace of its operation, i.e. BL table
C   will be closed on output and will have same number as one specified.
C   Difference will be only that number of columns has changed if that
C   is required.
C-----------------------------------------------------------------------
      INTEGER DISK, CNO, VER, CATBLK(256), LUN, IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER CTEMP*12, UTYPE*2, STAT*4
      INTEGER   BUFFER(1024), IBLRNO, BLKOLS(MAXBLC), BLNUMV(MAXBLC),
     *   NUMANT, NUMPOL, NUMIF, OVER, OLUN, OBUFF(1024), OKOLS(MAXBLC),
     *   ONUMV(MAXBLC), NBLROW, I, SOURID, ANT1, ANT2, SUBA, FREQID,
     *   OBLRNO, MSGSAV, IDUM
      LOGICAL   CHSTAT
      REAL      TIME, FACMUL(2,2,MAXIF), FACADD(2,2,MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA OLUN /45/
C-----------------------------------------------------------------------
C                                       Open BL file
      CALL BLINI ('READ', BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IBLRNO, BLKOLS, BLNUMV, NUMANT, NUMPOL, NUMIF, IRET)
      IF (IRET.EQ.2) THEN
         IRET = 0
         GO TO 999
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Is it new format?
      IF ((BUFFER(10).EQ.14) .OR. (BUFFER(10).EQ.10)) THEN
         CALL TABIO ('CLOS', 0, IBLRNO, BUFFER, BUFFER, IRET)
         GO TO 999
         END IF
C                                       Check is old format
      IF ((BUFFER(10).NE.13) .AND. (BUFFER(10).NE.9)) THEN
         WRITE (MSGTXT,1000) BUFFER(10)
         IRET = 1
         GO TO 990
         END IF
C                                       Determine status of file
      UTYPE = 'UV'
      CHSTAT = .FALSE.
      CALL CATDIR ('INFO', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE, IDUM,
     *   STAT, OBUFF, IRET)
      IF (STAT.EQ.'READ') THEN
C                                       Change status
         STAT = 'CLRD'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'CLRD'
            GO TO 990
            END IF
         STAT = 'WRIT'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'WRIT'
            GO TO 990
            END IF
         CHSTAT = .TRUE.
         END IF
C                                       # rows in old table
      NBLROW = BUFFER(5)
C                                       Open up new BL table
      OVER = 0
      CALL BLINI ('WRIT', OBUFF, DISK, CNO, OVER, CATBLK, OLUN,
     *   OBLRNO, OKOLS, ONUMV, NUMANT, NUMPOL, NUMIF, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Loop and copy
      DO 100 I = 1, NBLROW
         CALL TABBL ('READ', BUFFER, IBLRNO, BLKOLS, BLNUMV, NUMPOL,
     *      TIME, SOURID, ANT1, ANT2, SUBA, FREQID, FACMUL, FACADD,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
         CALL TABBL ('WRIT', OBUFF, OBLRNO, OKOLS, ONUMV, NUMPOL,
     *      TIME, SOURID, ANT1, ANT2, SUBA, FREQID, FACMUL, FACADD,
     *      IRET)
         IF (IRET.NE.0) GO TO 999
 100     CONTINUE
C                                       Close both tables
      CALL TABIO ('CLOS', 0, IBLRNO, BUFFER, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OBLRNO, OBUFF, OBUFF, IRET)
C                                       Delete the original file
      CALL RMEXT (DISK, CNO, 'BL', VER, CATBLK, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy new file to place
C                                       occupied by old one
      MSGSAV = MSGSUP
      MSGSUP = 31999
      CALL TABCOP ('BL', OVER, VER, OLUN, LUN, DISK, DISK, CNO, CNO,
     *   CATBLK, OBUFF, BUFFER, IRET)
      MSGSUP = MSGSAV
      IF (IRET.NE.0) GO TO 999
C                                       Delete the now defunct
C                                       original output file
      CALL RMEXT (DISK, CNO, 'BL', OVER, CATBLK, BUFFER, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Check if changed status
      IF (CHSTAT) THEN
         STAT = 'CLWR'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'CLWR'
            GO TO 990
            END IF
         STAT = 'READ'
         CALL CATDIR ('CSTA', DISK, CNO, CTEMP, CTEMP, IDUM, UTYPE,
     *      IDUM, STAT, OBUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1080) IRET, 'READ'
            GO TO 990
            END IF
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BLREFM: UNKNOWN BL FORMAT, # COLS = ',I3)
 1010 FORMAT ('BLREFM: ERROR ',I3,' RETURNED FROM BLINI')
 1080 FORMAT ('BLREFM: ERROR ',I3,' CHANGING ',A4,' STATUS')
      END

      SUBROUTINE ZPRMPT (IPC, BUFF, IERR)
C-----------------------------------------------------------------------
C! prompt user and read 80-characters from CRT screen
C# Z Terminal
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZPRMPT prompts user on CRT screen and reads a line.
C   Input:
C      IPC     I      prompt character.
C   Output:
C      BUFF    C*80   line of user input.
C      IERR    I      error code:   0 => ok.
C                        1 => read/write error.
C   VAX version.  Uses $ to avoid CR after prompt.
C-----------------------------------------------------------------------
      CHARACTER IPC*1, BUFF*(*)
C
      INTEGER   IERR, LUNCRT, OUTLUN
      DATA LUNCRT, OUTLUN /5, 6/
C-----------------------------------------------------------------------
      IERR = 0
      WRITE (OUTLUN,1000,ERR=90) IPC
      READ (LUNCRT,1010,ERR=90) BUFF
      GO TO 999
C                                       Read/write error.
 90   IERR = 1
C
 999  RETURN
C-----------------------------------------------------------------------
C                                       The $ suppreses CR LF
 1000 FORMAT (1X,A1,$)
 1010 FORMAT (A)
      END

      SUBROUTINE BLSET (TIME, IERR)
C-----------------------------------------------------------------------
C! Fills current baseline calibration table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997, 2000, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Fills current baseline correction table (BLFAC) by interpolation.
C   Inputs:
C      TIME    R        Current time (of data) in days.
C     Inputs from common /SELCAL/:
C      BLTAB   R(*,2)   Baseline table from BL table file.
C                       The second dimension corresponds to the time
C                       before and after the current data time.
C                       Indexing scheme: an entry defined by ant1<ant2
C                       starts in element:
C         lentry * (((ant1-1)*numant-((ant1+1)*ant1)/2 + ant2) - 1) + 1
C                       where lentry = 2 * NUMPOL * (EIF-BIF+1)
C                       An entry contains the values in order:
C                       By IF (NUMIF)
C                          By Polarization (NUMPOL)
C                              Real part, imaginary part.
C      BLTIM   R(3)     Time of two cal. entries; third value is
C                       time of current values.
C      IBLP1   I        Pointer in BLTAB, BLTIM to previous time.
C      IBLP2   I        Pointer in BLTAB, BLTIM to next time.
C      DOBL    L        If true then use baseline correction table,
C                       else return
C   Output:
C      IERR    I        Return error code, 0=>OK else error.
C   Output to common /SELCAL/:
C      BLFAC   R        Baseline dependent factors as (real, imag)
C                       Includes GMMOD correction if necessary.
C                       Addressing is like BLTAB.
C-----------------------------------------------------------------------
      INTEGER   IERR
      REAL      TIME
C
      INTEGER   LOOP, NUMBER, JBLP1, JBLP2
      LOGICAL   GOOD1, GOOD2
      REAL      WTT1, WTT2, G1R, G1I, G2R, G2I, CATR(256), WT1, WT2
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (CATBLK, CATR)
C-----------------------------------------------------------------------
      IERR = 0
C                                       Check if baseline calibration
      IF (.NOT.DOBL) THEN
         IBLP1 = 1
         GO TO 999
         END IF
C                                       size of array
      NUMBER = (NUMANT * (NUMANT+1)) / 2
      NUMBER = NUMBER * (EIF-BIF+1) * NUMPOL * 2
C                                       Set pointer
      JBLP2 = MAX (1, IBLP2)
C                                       See if time for new table entry
      IF ((TIME.GT.BLTIM(JBLP2)) .OR. (IBLP2.LT.0))
     *   CALL BLGET (TIME, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Reset pointers
      JBLP1 = MAX (1, IBLP1)
      JBLP2 = MAX (1, IBLP2)
      IF (IBLP1.LT.0) IBLP1 = -2
      IF (IBLP2.LT.0) IBLP2 = -2
      BLTIM(3) = TIME
C                                       Set interpolation weights.
      WTT1 = 0.0
      IF ((IBLP1.GT.0) .AND. (BLTIM(JBLP1).NE.BLTIM(JBLP2)))
     *   WTT1 = (BLTIM(JBLP2) - TIME) / (BLTIM(JBLP2) -
     *      BLTIM(JBLP1))
      WTT2 = 1.0 - WTT1
C                                       See if only BL cal. before data
      IF (IBLP2.LT.0) WTT1 = 1.0
      IF (IBLP2.LT.0) WTT2 = 0.0
      DO 500 LOOP = 1,NUMBER,2
C                                       Initialize soln with blanks
         BLFAC(LOOP) = FBLANK
         BLFAC(LOOP+1) = FBLANK
C                                       Check for blanked soln.
         GOOD1 = (BLTAB(LOOP,JBLP1).NE.FBLANK) .AND.
     *           (BLTAB(LOOP+1,JBLP1).NE.FBLANK) .AND.
     *           (WTT1.GT.0.0)
         GOOD2 = (BLTAB(LOOP,JBLP2).NE.FBLANK) .AND.
     *           (BLTAB(LOOP+1,JBLP2).NE.FBLANK) .AND.
     *           (WTT2.GT.0.0)
         IF (.NOT.(GOOD1.OR.GOOD2)) GO TO 500
            WT1 = WTT1
            WT2 = WTT2
            IF (.NOT.GOOD1) WT1 = 0.0
            IF (.NOT.GOOD1) WT2 = 1.0
            IF (.NOT.GOOD2) WT1 = 1.0
            IF (.NOT.GOOD2) WT2 = 0.0
C                                       Set values
            G1R = BLTAB(LOOP,JBLP1)
            G1I = BLTAB(LOOP+1,JBLP1)
            G2R = BLTAB(LOOP,JBLP2)
            G2I = BLTAB(LOOP+1,JBLP2)
C                                       Interpolate
            BLFAC(LOOP) = WT1 * G1R + WT2 * G2R
            BLFAC(LOOP+1) = WT1 * G1I + WT2 * G2I
 500        CONTINUE
      GO TO 999
C                                       Initialize BLFAC, reset IBLP1
C 600  IBLP1 = 1
C      DO 650 LOOP = 1,NUMBER,2
C         BLFAC(LOOP) = 1.0
C         BLFAC(LOOP+1) = 0.0
C 650     CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INCLUDE 'INCS:PAOOF.INC'
      INTEGER NPARMS
      PARAMETER (NPARMS=28)
      INTEGER AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPCOM.INC'
      INTEGER  NANTSL, ANTS(50), NREFSL, BASES(50)
      REAL TAVG, TSKP
      LOGICAL  DOCOMB, DOAWTN, DORMS, NOSCAL
      COMMON /INPP/ NANTSL, ANTS, NREFSL, BASES, TAVG, TSKP,
     *   DOCOMB, DOAWTN, DORMS, NOSCAL
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                                       Uses PAOOF.INC
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
     *   'SOURCES', 'QUAL', 'TIMERANG', 'BIF', 'EIF',
     *   'PMODEL', 'DOCALIB', 'GAINUSE', 'DOPOL', 'PDVER', 'BLVER',
     *   'FLAGVER', 'DOBAND', 'BPVER', 'SMOOTH', 'OUTNAME', 'OUTDISK',
     *   'OUTSEQ', 'IMSIZE', 'CELLSIZE',
     *   'APARM', 'ANTENNAS', 'BASELINE',
     *   'BADDISK'/
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT,
     *   OOACAR, OOAINT, OOARE, OOAINT, OOAINT,
     *   OOARE, OOARE, OOAINT, OOAINT, OOAINT, OOAINT,
     *   OOAINT, OOAINT, OOAINT, OOARE, OOACAR, OOAINT,
     *   OOAINT, OOAINT, OOARE,
     *   OOARE, OOAINT, OOAINT,
     *   OOAINT/
      DATA AVDIM /12,1, 6,1, 1,1, 1,1,
     *   16,30, 1,1, 8,1, 1,1, 1,1,
     *   7,1, 1,1, 1,1, 1,1, 1,1, 1,1,
     *   1,1, 1,1, 1,1, 3,1, 12,1, 1,1,
     *   1,1, 2,1, 2,1,
     *   10,1, 50,1, 50,1,
     *   10,1/
LOCAL END
LOCAL INCLUDE 'GFORT'
      INTEGER   IDUM(14)
      LOGICAL   LDUM(14)
      REAL      RDUM(14)
      DOUBLE PRECISION DDUM(7)
      EQUIVALENCE (DDUM, RDUM, LDUM, IDUM)
      COMMON /IMDXRG/ DDUM
LOCAL END
      PROGRAM MAPBM
C-----------------------------------------------------------------------
C! Map VLA beam polarization
C# TASK CALIBRATION POLARIZATION UV Image VLA OOP
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2000, 2002-2003, 2006-2007, 2010, 2015,
C;  Copyright (C) 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Map VLA beam polarization
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, UVDATA*32, IMAGE*32
      INTEGER  IRET, BUFF(256)
      INTEGER  KANTSL
      INTEGER  IANT
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPCOM.INC'
      INCLUDE 'INPUTDATA.INC'
      DATA PRGM /'MAPBM '/
C-----------------------------------------------------------------------
C                                       make selection of antenna list
C                                       and reference antenna list
      CALL MPBSL (PRGM, UVDATA, IMAGE, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Cycle over selected antennas
      IF (DOCOMB) THEN
         KANTSL = 1
      ELSE
         KANTSL = NANTSL
         END IF
      DO 100 IANT = 1, KANTSL
         CALL MPBIN (UVDATA, IRET)
         IF (IRET.NE.0) GO TO 990
C                                       Average and grid data
         CALL MPBDO (UVDATA, IMAGE, IANT, IRET)
         IF (IRET.NE.0) GO TO 990
  100    CONTINUE
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF)
C
 999  STOP
      END
      SUBROUTINE MPBSL (PRGN, UVDATA, IMAGE, IRET)
C-----------------------------------------------------------------------
C   MPBSL selects antenna and reference antenna list based on ANTENNA
C   and BASELINE
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      UVDATA  C*?  Input uv data object
C      IMAGE   C*?  Output image object
C      IRET    I    Error code: 0 => ok, else failed.
C   Output in common INPP
C      NANTSL  I    Number of selected antennas
C      ANTS(*) I    List of selected antennas
C      NREFSL  I    Number of selected references antennas
C      BASES(*)I    List of selected referenses antennas
C      DOAWTN  L    TRUE if all ANTENNAS are positive
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      CHARACTER UVDATA*(*), IMAGE*(*)
      INTEGER   IRET
      INTEGER   I, K, XANT(50), XBASE(50)
      REAL      APARM(10)
C
      INTEGER   NKEY1, NKEY2
C                                       NKEY1=no. adverbs to copy to
C                                       UVDATA
      PARAMETER (NKEY1=21)
C                                       NKEY2=no. adverbs to copy to
C                                       IMAGE
      PARAMETER (NKEY2=5)
C
      INTEGER   IERR, DIM(7), TYPE, IMSIZE(2), NAXIS(7), TDISK, TCNO,
     *   BUFF(256)
      INTEGER  IANTSL, ANTI, ANTK, ANTSS(50)
      REAL     CRPIX(7), CDELT(7), CELLSI(2), XDOCAL
      DOUBLE PRECISION CRVAL(7)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32
      CHARACTER  CLASS*6, INNAME*12, OUTNAM*12, UNITS*8, CTYPE(7)*8,
     *   CNAME*8, KEYW*8, CDUM*1
C
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPCOM.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INPUTDATA.INC'
C
C                                       Adverbs to copy to uv data
C                    1         2         3         4        5
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK', 'TIMERANG',
C          6       7        8         9        10
     *   'BIF', 'EIF', 'PMODEL', 'GAINUSE', 'DOPOL',
C          11         12       13        14         15          16
     *   'FLAGVER', 'APARM', 'QUAL', 'SOURCES', 'ANTENNAS', 'BASELINE',
     *   'BLVER', 'DOBAND', 'BPVER', 'SMOOTH', 'PDVER'/
C                                       Rename to object
C                  1       2         3       4         5
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK', 'CALEDIT.TIMRNG',
C          6       7        8          9
     *   'BIF', 'EIF', 'PMODEL',  'CALEDIT.CLUSE',
C           10               11               12           13
     *   'CALEDIT.DOPOL', 'CALEDIT.FGVER',  'APARM', 'CALEDIT.SELQUA',
C           14         15          16
     *   'SOUSEL', 'ANTENNAS', 'BASELINE', 'CALEDIT.BLVER',
     *   'CALEDIT.DOBAND', 'CALEDIT.BPVER', 'CALEDIT.SMOOTH',
     *   'CALEDIT.PDVER'/
C                                       Adverbs to copy to IMAGE object
C                      1        2          3         4        5
      DATA INK2 /'OUTNAME', 'OUTDISK', 'OUTSEQ', 'IMSIZE', 'CELLSIZE'/
C                   1        2      3         4        5
      DATA OUTK2 /'NAME', 'DISK', 'IMSEQ', 'IMSIZE', 'CELLSIZE'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       BADDISK
      CALL OGET ('Input', 'BADDISK', TYPE, DIM, IBAD, CDUM, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Declare 'PARANGLE' a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'PARANGLE'
      CALL OBVHKW (CNAME, KEYW, OOARE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Declare 'ZENANGLE' a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'ZENANGLE'
      CALL OBVHKW (CNAME, KEYW, OOARE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Declare 'AZIMUTH' a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'AZIMUTH'
      CALL OBVHKW (CNAME, KEYW, OOARE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Declare SCALI a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'SCALI'
      CALL OBVHKW (CNAME, KEYW, OOARE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Declare SCALQ a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'SCALQ'
      CALL OBVHKW (CNAME, KEYW, OOARE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Declare SCALU a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'SCALU'
      CALL OBVHKW (CNAME, KEYW, OOARE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Declare SCALV a header
C                                       keyword for the image class.
      CNAME = 'IMAGE'
      KEYW = 'SCALV'
      CALL OBVHKW (CNAME, KEYW, OOARE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       default OUTNAME = INNAME
      CALL OGET ('Input', 'INNAME', TYPE, DIM, IDUM, INNAME, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'OUTNAME', TYPE, DIM, IDUM, OUTNAM, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (OUTNAM.EQ.' ') OUTNAM = INNAME
      CALL OPUT ('Input', 'OUTNAME', TYPE, DIM, IDUM, OUTNAM, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Control parameters
      CALL OGET ('Input', 'APARM', TYPE, DIM, IDUM, CDUM, IERR)
      IF (IRET.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, APARM)
C                                       compine the selected antennas
C                                       data?
      DOCOMB = APARM(5) .GT. 0.1
      TAVG = APARM(1)
      TSKP = APARM(2)
      DORMS = APARM(3).GT.0.1
      NOSCAL = APARM(4).GT.0.1
C                                       Antennas
      CALL OGET ('Input', 'ANTENNAS', TYPE, DIM, XANT, CDUM, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Reference antennas
      CALL OGET ('Input', 'BASELINE', TYPE, DIM, XBASE, CDUM, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Check antennas desired.
      NANTSL = 0
      DOAWTN = .TRUE.
      DO 20 I = 1,50
         ANTS(I) = XANT(I)
         IF (ANTS(I).LT.0) DOAWTN = .FALSE.
C                                       Make positive
         ANTS(I) = ABS (ANTS(I))
         IF (NANTSL.LT.1) GO TO 10
            DO 5 K = 1, NANTSL
               IF (ANTS(I).EQ.ANTS(K)) ANTS(I) = 0
    5          CONTINUE
C                                       Check for multiple entries
 10      IF (ABS (ANTS(I)).GE.1) NANTSL = I
 20      CONTINUE
C                                       Check reference antenna desired
      NREFSL = 0
      DO 40 I = 1,50
         BASES(I) = XBASE(I)
         IF (NREFSL.LT.1) GO TO 30
            DO 25 K = 1,NREFSL
               IF (BASES(I).EQ.BASES(K)) BASES(I) = 0
   25          CONTINUE
C                                       Check for multiple entries
 30      IF (BASES(I).GE.1) NREFSL = I
 40      CONTINUE
C                                       Make sure not too many
      IF (NANTSL.GT.MAXANT) NANTSL = MAXANT
      IF (NREFSL.GT.MAXANT) NREFSL = MAXANT
C                                       Reference antenna list must
C                                       be given
      IF (NREFSL.EQ.0) THEN
         IRET = 1
         MSGTXT = 'BASELINE is not allowed to be zero!'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Now prepare reading AN table
C                                       by GETANT for the case
C                                       NANTSL = 0
C                                       Create input uv data object
      UVDATA = 'Input uv data'
      CALL CREATE (UVDATA, 'UVDATA', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, UVDATA, IRET)
      IF (IRET.NE.0) GO TO 999

C                                       DOCALIB
      CALL OGET ('Input', 'DOCALIB', TYPE, DIM, IDUM, CDUM, IRET)
      XDOCAL = RDUM(1)
      IF (IRET.NE.0) GO TO 999
      LDUM(1) = XDOCAL.GT.0.0
      CALL OPUT (UVDATA, 'CALEDIT.DOCAL', OOALOG, DIM, IDUM, CDUM,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      LDUM(1) = (XDOCAL.GT.0.0) .AND. (XDOCAL.LE.99.0)
      CALL OPUT (UVDATA, 'CALEDIT.DOWTCL', OOALOG, DIM, IDUM, CDUM,
     *   IRET)
      IF (IRET.NE.0) GO TO 999

C                                       I do not know why but the
C                                       following 3 cards about image
C                                       are required to make OBDSKC
C                                       work for GETANT (LK)
      IMAGE = 'Output image'
      CALL CREATE (IMAGE, 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, IMAGE, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Add AIPS file class.
      DIM(1) = LEN (CLASS)
      DIM(2) = 1
      DIM(3) = 0
      CLASS = 'QUBEST'
      CALL OPUT (IMAGE, 'CLASS', OOACAR, DIM, IDUM, CLASS, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy uv descriptors
      CALL U2IDES (UVDATA, IMAGE, .FALSE., IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Set axis labels
      CALL OGET (IMAGE, 'IMAGE_DESC.CTYPE', TYPE, DIM, IDUM, CTYPE,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CTYPE(1) = 'AZIMUTH'
      CTYPE(2) = 'ELEVAT'
      CTYPE(3) = 'STOKES'
      CALL OPUT (IMAGE, 'IMAGE_DESC.CTYPE', TYPE, DIM, IDUM, CTYPE,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Set az, el ref. val
      CALL OGET (IMAGE, 'IMAGE_DESC.CRVAL', TYPE, DIM, IDUM, CDUM,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
      CALL DPCOPY (DIM(1), DDUM, CRVAL)
      CRVAL(1) = 0.0D0
      CRVAL(2) = 0.0D0
      CRVAL(3) = 1.0D0
      CALL DPCOPY (DIM(1), CRVAL, DDUM)
      CALL OPUT (IMAGE, 'IMAGE_DESC.CRVAL', TYPE, DIM, IDUM, CDUM,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Set units (ratio)
      UNITS = 'RATIO'
      DIM(1) = LEN (UNITS)
      DIM(2) = 1
      CALL OPUT (IMAGE, 'IMAGE_DESC.BUNIT', OOACAR, DIM, IDUM, UNITS,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Set reference pixel
      CALL OGET ('Input', 'IMSIZE', TYPE, DIM, IMSIZE, CDUM, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL RFILL (7, 1.0, CRPIX)
      CRPIX(1) = IMSIZE(1) / 2 + 1
      CRPIX(2) = IMSIZE(2) / 2 + 1
      CRPIX(3) = 1
      DIM(1) = 7
      DIM(2) = 1
      CALL RCOPY (7, CRPIX, RDUM)
      CALL IMDPUT (IMAGE, 'CRPIX', OOARE, DIM, IDUM, CDUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Set image size
      CALL FILL (7, 1, NAXIS)
      NAXIS(1) = IMSIZE(1)
      NAXIS(2) = IMSIZE(2)
      NAXIS(3) = 4
      DIM(1) = 7
      DIM(2) = 1
      CALL OPUT (IMAGE, 'NAXIS', OOAINT, DIM, NAXIS, CDUM, IRET)
      IF (IRET.NE.0) GO TO 999
      DIM(1) = 1
      IDUM(1) = 3
      CALL OPUT (IMAGE, 'NDIM', OOAINT, DIM, IDUM, CDUM, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Set axis increments
      CALL OGET (IMAGE, 'CELLSIZE', TYPE, DIM, IDUM, CDUM, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL RCOPY (DIM(1), RDUM, CELLSI)
      CALL RFILL (7, 1.0, CDELT)
      CDELT(1) = CELLSI(1) / 3600.0
      CDELT(2) = CELLSI(2) / 3600.0
      CDELT(3) = 1.0
      DIM(1) = 7
      DIM(2) = 1
      CALL RCOPY (7, CDELT, RDUM)
      CALL OPUT (IMAGE, 'CDELT', OOARE, DIM, IDUM, CDUM, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Set up antenna array
      CALL OBDSKC (UVDATA, TDISK, TCNO, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get CATBLK
      CALL OBHGET (UVDATA, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Set antennas
      CALL GETANT (TDISK, TCNO, 1, CATBLK, BUFF, IERR)
      IF (IERR.NE.0) THEN
C                                       GETANT error
         MSGTXT = 'ERROR INITIALIZING ANTENNA INFORMATION'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       NANTSL = 0
      IF (NANTSL .EQ. 0) THEN
         NANTSL = NSTNS
         DO 60 I = 1, NANTSL
            ANTS(I) = TELNO(I)
   60       CONTINUE
         END IF
C                                       DOAWTN = .FALSE.
      IF (.NOT.DOAWTN) THEN

         DO 80 I = 1, NSTNS
            ANTI = TELNO(I)
            DO 70 K = 1, NANTSL
               ANTK = ANTS(K)
               IF (ANTI.EQ.ANTK) GO TO 80
   70          CONTINUE
            IANTSL = IANTSL + 1
            ANTSS(IANTSL) = ANTI
   80       CONTINUE
         NANTSL = IANTSL
         DO 90 I=1, NANTSL
            ANTS(I) = ANTSS(I)
   90       CONTINUE
         END IF
C
 999  RETURN
      END
C
      SUBROUTINE MPBIN (UVDATA, IRET)
C-----------------------------------------------------------------------
C   MPBIN puts couple of elements to the object UVDATA
C   Inputs:
C      UVDATA  C*?  Input uv data object
C   Output:
C      IRET    I    Error code: 0 => ok, else failed.
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER UVDATA*(*)
      INTEGER   DIM(7)
      CHARACTER CDUM*1
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C-----------------------------------------------------------------------
C                                       Subarray 1
      DIM(1) = 1
      DIM(2) = 1
      IDUM(1) = 1
      CALL OPUT (UVDATA, 'CALEDIT.SUBARR', OOAINT, DIM, IDUM, CDUM,
     *   IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Initialize "next source"
      DIM(1) = 1
      CALL OPUT (UVDATA, 'NEXTSID', OOAINT, DIM, IDUM, CDUM, IRET)
      IF (IRET.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE MPBDO (UVDATA, OIMAGE, IANT, IERR)
C-----------------------------------------------------------------------
C   Find pointings in raster, calibrate, average and grid data.
C   Inputs:
C      UVDATA  C*?  UV data object
C      OIMAGE  C*?  output image object
C      IANT    I    The antenna to reduce
C   Input in common INPP
C      NANTSL  I    Number of selected antennas
C      ANTS(*) I    List of selected antennas
C      NREFSL  I    Number of selected references antennas
C      BASES(*)I    List of selected referenses antennas
C      DOAWTN  L    TRUE if all ANTENNAS are positive
C   Output:
C      IERR    I    Return code, 0=> OK
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER UVDATA*(*), OIMAGE*(*)
C
      CHARACTER CLNAME*6
C
      INTEGER   GSIZE
C                                       Set maximum grid size
      PARAMETER (GSIZE=30)
      INTEGER   TYPE, DIM(7), NX, NY, NAXIS(7), I
      REAL   TTOL, CDELT(7)
C
      REAL   QUBIMA(GSIZE,GSIZE,4), QUBRMS(GSIZE,GSIZE,4)
      INTEGER K, IS
      INTEGER IANT, KANTS
C
      CHARACTER UVSCR*32, CDUM*1
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INPCOM.INC'
C-----------------------------------------------------------------------
      IERR = 0
      UVSCR = '    '
C                                       Cell spacing
      CALL OGET (OIMAGE, 'CDELT', TYPE, DIM, IDUM, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL RCOPY (DIM(1), RDUM, CDELT)
C                                       U,V position tolerance 0.3 cells
      TTOL = 0.3 * MIN (ABS(CDELT(1)), ABS(CDELT(2)))
      TTOL = TTOL / 57.29577951
C                                       Size of image
      CALL OGET (OIMAGE, 'NAXIS', TYPE, DIM, NAXIS, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
      NX = NAXIS(1)
      NY = NAXIS(2)
C                                       Check size
      IF (NX*NY.LE.0) THEN
         IERR = 3
         MSGTXT = 'OUTPUT IMAGE SIZE MUST BE DEFINED'
         GO TO 980
         END IF
      IF (NX.GT.GSIZE .OR. NY.GT.GSIZE) THEN
         IERR = 4
         MSGTXT = 'OUTPUT IMAGE SIZE EXCEEDS INTERNAL ARRAYS'
         GO TO 980
         END IF
C                                       Initialize images
      DO 70 I = 1,NX
         DO 60 K = 1,NY
            DO 50 IS = 1, 4
               QUBIMA(I,K,IS) = FBLANK
               QUBRMS(I,K,IS) = FBLANK
   50          CONTINUE
   60       CONTINUE
   70    CONTINUE
C                                       Loop over "sources"
 100  CALL MBNEXT (UVDATA, UVSCR, IERR)
C                                       Done?
      IF (IERR.LT.0) GO TO 200
      IF (IERR.NE.0) GO TO 990
C                                       Averaging control.
      DIM(1) = 1
      DIM(2) = 1
      RDUM(1) = TAVG
      CALL OPUT (UVSCR, 'TIMEAVG', OOARE, DIM, IDUM, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
      RDUM(1) = TSKP
      CALL OPUT (UVSCR, 'TIMESKP', OOARE, DIM, IDUM, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
      RDUM(1) = TTOL
      CALL OPUT (UVSCR, 'UVTOL', OOARE, DIM, IDUM, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Time average
C                                       KANTS is the selected antenna;
C                                       is used if common map for all
C                                       selected antenna
      KANTS = ANTS(IANT)
C
      CALL MBTAVG (UVSCR, UVSCR, KANTS, IERR)
C
      IF (IERR .EQ. 7) THEN
         IERR = 0
         GO TO 999
         END IF
      IF (IERR.NE.0) GO TO 990
C                                       Average over baseline
      CALL MBMAVG (UVDATA, UVSCR, NX, NY, QUBIMA, QUBRMS, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Next pointing
         GO TO 100
C                                       Done - write the qube image
 200  CONTINUE
C
      CLNAME(1:4) = 'ANT_'
      IF (DOCOMB .AND. NANTSL.GT.1) THEN
         CLNAME = 'ANT_**'
      ELSE
         WRITE(CLNAME(5:6), 1000) KANTS
         END IF
C
      CALL MBMOUT (OIMAGE, UVDATA, CLNAME, NX, NY, QUBIMA, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (DORMS) THEN
         CLNAME(1:4) = 'RMS_'
         IF (DOCOMB .AND. NANTSL.GT.1) THEN
            CLNAME = 'RMS_**'
         ELSE
            WRITE(CLNAME(5:6), 1000) KANTS
            END IF
         CALL MBMOUT (OIMAGE, UVDATA, CLNAME, NX, NY, QUBRMS, IERR)
         END IF
      IF (IERR.NE.0) GO TO 990
C
      CALL OUVZAP (UVSCR, IERR)
C
      GO TO 999
C                                       Error
 980  CALL MSGWRT (8)
 990  MSGTXT = 'ERROR IMAGING ' // UVDATA
      CALL MSGWRT (8)
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT(I2)
      END
      SUBROUTINE MBNEXT (UVDATA, UVSCR, IERR)
C-----------------------------------------------------------------------
C   Routine to find next "source"
C   Inputs:
C      UVDATA  C*?  UV data object
C      UVSCR   C*?  Selected data in scratch object
C   Output:
C      IERR    I    Error code, 0=OK, -1 => no more data, else failed
C-----------------------------------------------------------------------
      CHARACTER UVDATA*(*), UVSCR*(*)
      INTEGER   IERR
C
      CHARACTER SUTAB*32, NXTAB*32, COLNAM(3)*24, SOURCE(30)*16,
     *   SOUSEL(30)*16, CDUM*1
      REAL      TIMER(8), TBEG, TEND, TAVG
      INTEGER   TYPE, DIM(3), KOL(3), QUAL, QUAKOL, NAMKOL, IDKOL, I,
     *   TQUAL, SOUID, ISNEXT, NUMBSU, IS, NSOU
      LOGICAL   OK, ALLSOU, WNTSOU
      INCLUDE 'GFORT'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (NAMKOL, KOL(1)), (QUAKOL, KOL(2)), (IDKOL, KOL(3))
      DATA COLNAM /'SOURCE', 'QUAL', 'ID. NO.'/
      DATA SOURCE /30*'    '/
C-----------------------------------------------------------------------
C                                       Time range
      CALL OGET (UVDATA, 'CALEDIT.TIMRNG', TYPE, DIM, IDUM, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL RCOPY (DIM(1), RDUM, TIMER)
      TBEG = TIMER(1) + TIMER(2) / 24.0 + TIMER(3) / 1440.0 + TIMER(4) /
     *   86400.0
      TEND = TIMER(5) + TIMER(6) / 24.0 + TIMER(7) / 1440.0 + TIMER(8) /
     *   86400.0
      IF (TEND.LE.1.0E-10) TEND = 1.0E10
C                                       Source names
      CALL OGET (UVDATA, 'SOUSEL', TYPE, DIM, IDUM, SOUSEL, IERR)
      IF (IERR.NE.0) GO TO 990
      NSOU = 0
      DO 10 IS = 1,30
         IF (SOUSEL(IS).NE.'     ') NSOU = IS
 10      CONTINUE
      ALLSOU = NSOU.LE.0
C                                       Qualifier
      CALL OGET (UVDATA, 'CALEDIT.SELQUA', TYPE, DIM, IDUM, CDUM, IERR)
      QUAL = IDUM(1)
      IF (IERR.NE.0) GO TO 990
C                                       Get first SU table entry
      CALL OGET (UVDATA, 'NEXTSID', TYPE, DIM, IDUM, CDUM, IERR)
      ISNEXT = IDUM(1)
      IF (IERR.NE.0) GO TO 990
C                                       Index table
      NXTAB = 'NX table for MBNEXT'
      CALL UV2TAB (UVDATA, NXTAB, 'NX', 1, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Open
      CALL OOPEN (NXTAB, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Source table
      SUTAB = 'SU table for MBNEXT'
      CALL UV2TAB (UVDATA, SUTAB, 'SU', 1, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Open
      CALL OOPEN (SUTAB, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Find highest number in SU
      CALL TABGET (SUTAB, 'NROW', TYPE, DIM, IDUM, CDUM, IERR)
      NUMBSU = IDUM(1)
      IF (IERR.NE.0) GO TO 990
C                                       Find column numbers
      CALL TABCOL (SUTAB, 3, COLNAM, KOL, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Loop over source table
      DO 500 IS = ISNEXT,NUMBSU
C                                       Get QUAL
         CALL TABDGT (SUTAB, IS, QUAKOL, TYPE, DIM, IDUM, CDUM, IERR)
         TQUAL = IDUM(1)
         IF (IERR.NE.0) GO TO 990
         OK = (TQUAL.EQ.QUAL)
C                                       Check source
         CALL TABDGT (SUTAB, IS, NAMKOL, TYPE, DIM, IDUM, SOURCE, IERR)
         IF (IERR.NE.0) GO TO 990
         WNTSOU = .TRUE.
         IF (.NOT.ALLSOU) THEN
            WNTSOU = .FALSE.
            DO 110 I = 1,NSOU
               IF (SOURCE(1).EQ.SOUSEL(I)) WNTSOU = .TRUE.
 110           CONTINUE
            END IF
         OK = OK .AND. WNTSOU
         IF (OK) THEN
C                                       Get Source ID
            CALL TABDGT (SUTAB, IS, IDKOL, TYPE, DIM, IDUM, CDUM, IERR)
            SOUID = IDUM(1)
            IF (IERR.NE.0) GO TO 990
C                                       See if observed in timerange
            CALL MBMSOK (NXTAB, SOUID, TBEG, TEND, TAVG, OK, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
C                                       Use this one.
         IF (OK) GO TO 600
 500     CONTINUE
C                                       Close and get rid of tables.
      CALL OCLOSE (SUTAB, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL DESTRY (SUTAB, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OCLOSE (NXTAB, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL DESTRY (NXTAB, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Nothing more found
      IERR = -1
      GO TO 999
C                                       Save next su entry
 600  DIM(1) = 1
      DIM(2) = 1
      ISNEXT = IS + 1
      IDUM(1) = ISNEXT
      CALL OPUT (UVDATA, 'NEXTSID', OOAINT, DIM, IDUM, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Save this source ID
      IDUM(1) = SOUID
      CALL OPUT (UVDATA, 'CURSID', OOAINT, DIM, IDUM, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Tell what you're doing
      MSGTXT = ' Processing source: ' // SOURCE(1)
      CALL MSGWRT (5)
C                                       Close and get rid of tables.
      CALL OCLOSE (SUTAB, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL DESTRY (SUTAB, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OCLOSE (NXTAB, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL DESTRY (NXTAB, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Select "source"
      DIM(1) = LEN (SOURCE(1))
      DIM(2) = 30
      CALL OPUT (UVDATA, 'CALEDIT.SOURCS', OOACAR, DIM, IDUM, SOURCE,
     *   IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Create scratch file if necessary
      IF (UVSCR.EQ.'     ') THEN
         UVSCR = 'Calibrated, selected uvdata'
         CALL OUVSCR (UVDATA, UVSCR, 2000, .FALSE., IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       Copy, calibrate etc.
      CALL UV2SCR (UVDATA, UVSCR, .FALSE., IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Don't calibrate UVSCR
      DIM(1) = 1
      DIM(2) = 1
      LDUM(1) = .FALSE.
      CALL OPUT (UVSCR, 'CALEDIT.DOCAL', OOALOG, DIM, IDUM, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
      IDUM(1) = -1
      CALL OPUT (UVSCR, 'CALEDIT.DOPOL', OOAINT, DIM, IDUM, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR FINDING NEXT POINTING '
      CALL MSGWRT (8)
 999  RETURN
      END
      SUBROUTINE MBTAVG (UVIN, UVOUT, IANT, IERR)
C-----------------------------------------------------------------------
C   UVdata class utility routine
C   Time average time ordered holography data with optional blanking at
C   the beginning of each integration.  In holography mode the "U" and
C   "V" are the projected az and el offsets.
C   Can only process one subarray.
C   This routine uses an I/O buffer to hold the data being averaged.
C   Inputs:
C      UVIN    C*?   Name of input uvdata object.
C      UVOUT   C*?   Name of output uvdata object. (may be UVIN)
C      IANT     I    Selected antenna if
C                    Maps are created for each of the selected antennas
C   Inputs in common INPP
C      NANTSL   I    Number of antennas at the ANTENNAS list
C      ANTS(*)  I    List of selected antenna if the combine
C                    map is created for the all selected antennas
C      DOAWTN   L    True if all numbers at the ANTENNAS list positive
C      NREFSL   I    Number of antennas at the BASELINE list
C      BASES(*) I    List of antennas at the BASELINE list
C   Inputs from UVIN Object.
C      TIMEAVG  R    averaging time in seconds
C      TIMESKP  R    Time in seconds to skip at the beginning of each
C                    integration.
C      UVTOL    R    Tolerance for a change in u or u not to initiate a
C                    new integration (radians)
C   Output:
C       IERR   I     Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER UVIN*(*), UVOUT*(*)
      INTEGER   IANT
      INTEGER   IERR, KERR, K
C
      INTEGER   MXVS
C                                       MXVS = maximum no. correlations
C                                       in a record.
      PARAMETER (MXVS = 2048)
      REAL     RP(50), VS(3,MXVS)
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER SRTORD*2, TOUT*32, ANTAB*32, CDUM*1
      INTEGER   TYPE, DIM(3), COUNT, LREC, NRPARM, NCOR, ILOCU, ILOCV,
     *   ILOCW, ILOCT, ILOCB, ILOCSU, ILOCFQ, ILOCA1, ILOCA2, ILOCSA,
     *   JLOCC, JLOCS, JLOCF, JLOCIF, JLOCR, JLOCD, INCS, INCF, INCIF,
     *   CNT, VSCNT, LOOP, BLPNT(MXBASE), BLCNT(MXBASE), ANTOFF(MAXANT),
     *   BUFNO, MAXAN, SUBARR, I, J, PNT, BLNO, IOFF, INDEX, NUMBL,
     *   NWORD, LBASE, ANT1, ANT2, INDXCT, CNTINT
      REAL      RPS(50), VSS(3,MXVS), TTOL, TIME, SID, FQID,
     *   OLDU, OLDV, TGOOD
      REAL  TAVGOL, TSKPOL
      LOGICAL   NEXT, DOSU, DOFQ, EXIST, NEWPOS
      INCLUDE 'GFORT'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INPCOM.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Open input
      CALL OUVOPN (UVIN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Check that sort = T*
      CALL UVDGET (UVIN, 'SORTORD', TYPE, DIM, IDUM, SRTORD, IERR)
      IF (IERR.NE.0) GO TO 990
      IF (SRTORD(1:1).NE.'T') THEN
         MSGTXT = 'MBTAVG: DATA NOT IN T* ORDER, USE UVSRT'
         IERR = 5
         GO TO 995
         END IF
C                                       Subarray number
      CALL SECGET (UVIN, 'SUBARR', TYPE, DIM, IDUM, CDUM, IERR)
      SUBARR = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      IF (SUBARR.LE.0) SUBARR = 1
C                                       Create AN table and use for
C                                       buffer.
      ANTAB = 'AN table for MBTAVG'
      CALL UV2TAB (UVIN, ANTAB, 'AN', SUBARR, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Open
      CALL OBOPEN (ANTAB, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Get buffer number
      CALL OBINFO (ANTAB, BUFNO, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Create output if necessary
      CALL OBFEXS (UVOUT, EXIST, IERR)
      IF (IERR.GT.1) GO TO 990
      IERR = 0
      IF (.NOT.EXIST) THEN
         CALL OUVCLN (UVIN, UVOUT, IERR)
         IF (IERR.NE.0) GO TO 990
         END IF
C                                       Temporary output in case in =
C                                       out.
      TOUT = 'Temporary output for MBTAVG'
      CALL OUVCOP (UVOUT, TOUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Open output
      CALL OUVOPN (TOUT, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy UVDESC
      CALL UVDSCP (UVIN, TOUT, IERR)
      IF (IERR.NE.0) GO TO 990
      COUNT = 0
C                                       Zero number of visibilities
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      IDUM(1) = COUNT
      CALL UVDPUT (TOUT, 'GCOUNT', OOAINT, DIM, IDUM, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Averaging time (to day)
      CALL OUVGET (UVIN, 'TIMEAVG', TYPE, DIM, IDUM, CDUM, IERR)
      TAVG = RDUM(1)
      IF (IERR.NE.0) GO TO 990
C                                       store the TAVG in sec
      TAVGOL = TAVG
      TAVG = TAVG / (60.0 * 60.0 * 24.0)
C                                       Reduce by 1%
      TAVG = TAVG * 0.99
C                                       Blanking time (to day)
      CALL OUVGET (UVIN, 'TIMESKP', TYPE, DIM, IDUM, CDUM, IERR)
      TSKP = RDUM(1)
      IF (IERR.NE.0) GO TO 990
C                                       store the TSKP in sec
      TSKPOL = TSKP
      TSKP = TSKP / (60.0 * 60.0 * 24.0)
C                                       U,v tolerance for same average.
      CALL OUVGET (UVIN, 'UVTOL', TYPE, DIM, IDUM, CDUM, IERR)
      TTOL = RDUM(1)
      IF (IERR.NE.0) GO TO 990
C                                       Get info
C                                       Uv data pointers
      CALL UVDPNT (UVIN, ILOCU, ILOCV, ILOCW, ILOCT, ILOCB, ILOCSU,
     *   ILOCFQ, ILOCA1, ILOCA2, ILOCSA, JLOCC, JLOCS, JLOCF, JLOCR,
     *   JLOCD, JLOCIF, INCS, INCF, INCIF, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Which random parameters to check
      DOSU = ILOCSU.GE.1
      DOFQ = ILOCFQ.GE.1
C                                       LREC
      CALL UVDGET (UVIN, 'LREC', TYPE, DIM, IDUM, CDUM, IERR)
      LREC = IDUM(1)
      IF (IERR.NE.0) GO TO 990
C                                       NRPARM
      CALL UVDGET (UVIN, 'NRPARM', TYPE, DIM, IDUM, CDUM, IERR)
      NRPARM = IDUM(1)
      IF (IERR.NE.0) GO TO 990
C                                       NCORR
      CALL UVDGET (UVIN, 'NCORR', TYPE, DIM, IDUM, CDUM, IERR)
      NCOR = IDUM(1)
      IF (IERR.NE.0) GO TO 990
C                                       Check that it fits
      IF (NCOR.GT.MXVS) THEN
         WRITE (MSGTXT,1000) NCOR, MXVS
         IERR = 5
         GO TO 995
         END IF
C                                       How many antennas?
      CALL ANTNO (ANTAB, SUBARR, MAXAN, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Length of a baseline entry with
C                                       count words at end
      LBASE = LREC + NCOR
C                                       Get baseline pointers
      PNT = 1
      IOFF = 1
      DO 20 I = 1,MAXAN-1
         ANTOFF(I) = IOFF - I - 1
         DO 10 J = I+1,MAXAN
            BLNO = ANTOFF(I) + J
            BLPNT(BLNO) = PNT
            PNT = PNT + LBASE
 10         CONTINUE
         IOFF = IOFF + (MAXAN - I)
 20      CONTINUE
      NUMBL = (MAXAN * (MAXAN - 1) ) / 2
C                                       Does it all fit in the BUFFER?
      IF (PNT.GT.BUFSIZ) THEN
         MSGTXT = 'MBTAVG: WORK ARRAY TOO SMALL'
         IERR = 5
         GO TO 995
         END IF
C                                       Clear accumulators
      NWORD = NUMBL * LBASE
      CALL RFILL (NWORD, 0.0, OBUFFR(1,BUFNO))
      CALL FILL (NUMBL, 0, BLCNT)
      CNT = 0
      TIME = 0.0
      TGOOD = -1.0E5
      SID = 0.0
      FQID = 0.0
      CNTINT = 0
C                                       First read
      CALL UVREAD (UVIN, RP, VS, IERR)
      IF (IERR.LT.0) GO TO 200
      IF (IERR.GT.0) GO TO 990
      TGOOD = RP(ILOCT) + TSKP
      GO TO 110
C                                       Loop through input data
 100     CALL UVREAD (UVIN, RP, VS, IERR)
         IF (IERR.LT.0) GO TO 200
         IF (IERR.GT.0) GO TO 990
C                                       Initial "old" u,v
         IF (CNT.LE.0) THEN
            OLDU = RP(ILOCU)
            OLDV = RP(ILOCV)
            END IF
C                                       Still in blanking period?
 110     IF (RP(ILOCT).LT.TGOOD) GO TO 100
C
         IF (ILOCB.GT.0) THEN
            ANT1 = (RP(ILOCB) / 256.0) + 0.001
            ANT2 = (RP(ILOCB) - ANT1 * 256) + 0.001
         ELSE
            ANT1 = RP(ILOCA1) + 0.001
            ANT2 = RP(ILOCA2) + 0.001
            END IF
C                                       check the selected baselines
         IF (DOCOMB) THEN
C                                       all selected antennas added
            DO 125 I = 1, NANTSL
               DO 120 K = 1, NREFSL
                  IF ((ANT1.EQ.ANTS(I) .AND. ANT2.EQ.BASES(K)) .OR.
     *               (ANT2.EQ.ANTS(I) .AND. ANT1.EQ.BASES(K)))
     *               GO TO 135
  120             CONTINUE
 125           CONTINUE
               GO TO 100
C
 135        CONTINUE
         ELSE
            DO 140 I = 1, NREFSL
            IF ((ANT1.EQ.IANT .AND. ANT2.EQ.BASES(I)) .OR.
     *         (ANT2.EQ.IANT .AND. ANT1.EQ.BASES(I))) GO TO 145
  140          CONTINUE
            GO TO 100
  145       CONTINUE
            END IF
C                                       Previous average done?
C                                       Exceed time?
         NEXT = (RP(ILOCT)-TIME) .GT. TAVG
C                                       New source
         NEXT = NEXT .OR. (DOSU .AND. (SID.NE.RPS(ILOCSU)))
C                                       New FQid
         NEXT = NEXT .OR. (DOFQ .AND. (FQID.NE.RPS(ILOCFQ)))
C                                       New pointing?
         NEWPOS = (ABS (OLDU-RP(ILOCU)).GT.TTOL) .OR.
     *      (ABS (OLDV-RP(ILOCV)).GT.TTOL)
         NEXT = NEXT .OR. NEWPOS
C                                       Need some data
         NEXT = NEXT .AND. (CNT .GT. 0)
         IF (NEXT) THEN
C                                       Set blanking for next
C                                       integration.
            IF (NEWPOS) TGOOD = RP(ILOCT) + TSKP
            CNTINT = CNTINT + 1
C                                       Average then write old
C                                       accumulations.
            DO 160 BLNO = 1,NUMBL
               IF (BLCNT(BLNO).GT.0) THEN
C                                       Pointer into OBUFFR
                  PNT = BLPNT(BLNO)
                  CALL COPY (NRPARM, OBUFFR(PNT,BUFNO), RPS)
C                                       U
                  RPS(ILOCU) = OBUFFR(PNT+ILOCU-1,BUFNO) / BLCNT(BLNO)
C                                       V
                  RPS(ILOCV) = OBUFFR(PNT+ILOCV-1,BUFNO) / BLCNT(BLNO)
C                                       W
                  RPS(ILOCW) = OBUFFR(PNT+ILOCW-1,BUFNO) / BLCNT(BLNO)
C                                       Time
                  RPS(ILOCT) = OBUFFR(PNT+ILOCT-1,BUFNO) / BLCNT(BLNO)
C                                       Vis
                  INDEX = PNT + NRPARM
                  INDXCT = PNT + LREC
                  DO 150 LOOP = 1,NCOR
                     VSCNT = OBUFFR(INDXCT,BUFNO) + 0.5
                     IF (VSCNT.GT.0) THEN
                        VSS(1,LOOP) = OBUFFR(INDEX,BUFNO) / VSCNT
                        VSS(2,LOOP) = OBUFFR(INDEX+1,BUFNO) / VSCNT
                        VSS(3,LOOP) = OBUFFR(INDEX+2,BUFNO)
                     ELSE
                        VSS(1,LOOP) = 0.0
                        VSS(2,LOOP) = 0.0
                        VSS(3,LOOP) = 0.0
                        END IF
                     INDEX = INDEX + 3
                     INDXCT = INDXCT + 1
 150                 CONTINUE
                  COUNT = COUNT + 1
                  CALL UVWRIT (TOUT, RPS, VSS, IERR)
                  IF (IERR.GT.0) GO TO 990
C                                       Clear accumulators
                  CALL RFILL (LBASE, 0.0, OBUFFR(PNT,BUFNO))
                  BLCNT(BLNO) = 0
                  END IF
 160           CONTINUE
C                                       Clear no. vis this integrations
C                                       count.
            CNT = 0
            END IF
C                                       Save position offsets
         OLDU = RP(ILOCU)
         OLDV = RP(ILOCV)
C                                       Still in blanking period?
         IF (RP(ILOCT).LT.TGOOD) GO TO 100
C                                       Accumulate
C                                       Antenna, baseline info
         IF (ILOCB.GT.0) THEN
            ANT1 = (RP(ILOCB) / 256.0) + 0.001
            ANT2 = (RP(ILOCB) - ANT1 * 256) + 0.001
         ELSE
            ANT1 = RP(ILOCA1) + 0.001
            ANT2 = RP(ILOCA2) + 0.001
            END IF
         BLNO = ANTOFF(ANT1) + ANT2
         PNT = BLPNT(BLNO)
         BLCNT(BLNO) = BLCNT(BLNO) + 1
         CNT = CNT + 1
         IF (CNT.LE.1) THEN
C                                       Save info for this integration
            TIME = RP(ILOCT)
            SID = 1
            FQID = 1
            IF (DOSU) SID =  RP(ILOCSU)
            IF (DOFQ) FQID =  RP(ILOCFQ)
            END IF
         IF (BLCNT(BLNO).LE.1) THEN
C                                       First vis for baseline
            CALL RCOPY (NRPARM, RP, OBUFFR(PNT,BUFNO))
         ELSE
            OBUFFR(PNT-1+ILOCU,BUFNO) = OBUFFR(PNT-1+ILOCU,BUFNO) +
     *         RP(ILOCU)
            OBUFFR(PNT-1+ILOCV,BUFNO) = OBUFFR(PNT-1+ILOCV,BUFNO) +
     *         RP(ILOCV)
            OBUFFR(PNT-1+ILOCW,BUFNO) = OBUFFR(PNT-1+ILOCW,BUFNO) +
     *         RP(ILOCW)
            OBUFFR(PNT-1+ILOCT,BUFNO) = OBUFFR(PNT-1+ILOCT,BUFNO) +
     *         RP(ILOCT)
            END IF
         INDEX = PNT + NRPARM
         INDXCT = PNT + LREC
         DO 180 LOOP = 1,NCOR
            IF (VS(3,LOOP).GT.0.0) THEN
               OBUFFR(INDXCT,BUFNO) = OBUFFR(INDXCT,BUFNO) + 1.0
               OBUFFR(INDEX,BUFNO) = OBUFFR(INDEX,BUFNO) +
     *            VS(1,LOOP)
               OBUFFR(INDEX+1,BUFNO) = OBUFFR(INDEX+1,BUFNO) +
     *            VS(2,LOOP)
               OBUFFR(INDEX+2,BUFNO) = OBUFFR(INDEX+2,BUFNO) +
     *            VS(3,LOOP)
               END IF
            INDEX = INDEX + 3
            INDXCT = INDXCT + 1
 180        CONTINUE
C                                       Loop for next vis
         GO TO 100
C                                       Done
 200  IERR = 0
      IF (CNT.GT.0) CNTINT = CNTINT + 1
C                                       Average and write last set.
      DO 260 BLNO = 1,NUMBL
         IF (BLCNT(BLNO).GT.0) THEN
C                                       Pointer into OBUFFR
            PNT = BLPNT(BLNO)
            CALL COPY (NRPARM, OBUFFR(PNT,BUFNO), RPS)
C                                       U
            RPS(ILOCU) = OBUFFR(PNT+ILOCU-1,BUFNO) / BLCNT(BLNO)
C                                       V
            RPS(ILOCV) = OBUFFR(PNT+ILOCV-1,BUFNO) / BLCNT(BLNO)
C                                       W
            RPS(ILOCW) = OBUFFR(PNT+ILOCW-1,BUFNO) / BLCNT(BLNO)
C                                       Time
            RPS(ILOCT) = OBUFFR(PNT+ILOCT-1,BUFNO) / BLCNT(BLNO)
C                                       Vis
            INDEX = PNT + NRPARM
            INDXCT = PNT + LREC
            DO 250 LOOP = 1,NCOR
               VSCNT = OBUFFR(INDXCT,BUFNO) + 0.5
               IF (VSCNT.GT.0) THEN
                  VSS(1,LOOP) = OBUFFR(INDEX,BUFNO) / VSCNT
                  VSS(2,LOOP) = OBUFFR(INDEX+1,BUFNO) / VSCNT
                  VSS(3,LOOP) = OBUFFR(INDEX+2,BUFNO)
               ELSE
                  VSS(1,LOOP) = 0.0
                  VSS(2,LOOP) = 0.0
                  VSS(3,LOOP) = 0.0
                  END IF
               INDEX = INDEX + 3
               INDXCT = INDXCT + 1
 250        CONTINUE
            COUNT = COUNT + 1
            CALL UVWRIT (TOUT, RPS, VSS, IERR)
            IF (IERR.GT.0) GO TO 990
            END IF
 260     CONTINUE
C                                       Better be some data
      IF (COUNT.LE.0) THEN
         WRITE (MSGTXT, 1200) IANT
         CALL MSGWRT (7)
         KERR = 7
      ELSE
         KERR = 0
         WRITE (MSGTXT,1250) COUNT, CNTINT
         CALL MSGWRT (4)
         END IF
C                                       Set sort order (unsorted)
      SRTORD = '  '
      DIM(1) = LEN (SRTORD)
      DIM(2) = 1
      CALL UVDPUT (TOUT, 'SORTORD', OOACAR, DIM, IDUM, SRTORD, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Close files
      CALL OUVCLO (UVIN, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OUVCLO (TOUT, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OBCLOS (ANTAB, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy tables
      CALL UVDTCO (UVIN, TOUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Mark output as valid
      DIM(1) = 1
      LDUM(1) = .TRUE.
      CALL FSTPUT (UVOUT, 'VALID', OOALOG, DIM, IDUM, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Delete temporary objects
      CALL OUVDES (TOUT, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OUVDES (ANTAB, IERR)
      IF (IERR.NE.0) GO TO 990
C
      IERR = KERR
C                                       restore the TAVG, TSKP in sec
      TAVG = TAVGOL
      TSKP = TSKPOL
C
      GO TO 999
C                                       Error
 995  CALL MSGWRT (7)
 990  MSGTXT = 'MBTAVG: ERROR TIME AVERAGING ' // UVIN
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MBTAVG: TOO MANY CORRELATIONS ', I6,' > ', I6)
 1200 FORMAT ('NO DATA SELECTED FOR ANTENNA ', I2)
 1250 FORMAT ('MBTAVG: Wrote ',I7,' avg. vis. in ',I4,' integrations')
      END
      SUBROUTINE MBMAVG (UVMULT, UVDATA, NX, NY, QUBIMA, QUBRMS,
     *   IERR)
C-----------------------------------------------------------------------
C   Routine to Average data over baseline and divide by IPOL
C   Observing geometry (azimuth, zenith angle, parallactic angle) are of
C   the central pointing are attached to UVMULT.
C   Inputs:
C      UVMULT  C*?  Original Multi source UV data.
C      UVDATA  C*?  UV data object
C      NX      I    Number of columns in images
C      NY      I    Number of rows in images
C   Output:
C      QUBIMA  R(NX,NX,4) array of the qube image for all stokes
C      QUBRMS  R(NX,NX,4) array of the qube rms image for all stokes
C      IERR    I    Error code, 0=OK else failed
C-----------------------------------------------------------------------
      CHARACTER UVMULT*(*), UVDATA*(*)
      INTEGER   NX, NY, IERR
      REAL  QUBIMA(NX,NY,4), QUBRMS(NX,NY,4)
      REAL  SCALI, SCALQ, SCALU, SCALV
C
      INTEGER   LSIZE
C                                       Maximum list size
      PARAMETER (LSIZE=1000)
      INTEGER   I, TYPE, DIM(3), NDIM, NAXIS(7), INDXS, INDXT, INDXU,
     *   INDXV, LIMS(2,7), D(7), COUNT(4), IS, IX, IY, IROUND,
     *   ISDCEN, LSTCNT
      LOGICAL   EOF
      LOGICAL   CENTE
      REAL      RP(50), VIS(3,1024), VS(3,4), PMODEL(6), FSTOK(4), VAL,
     *   IIPOL, IIRMS, QQPOL, QQRMS, UUPOL, UURMS, VVPOL, VVRMS,
     *   CELLSI(2), U, V, OLDU, OLDV, TOLU, TOLV, TCEN, AZC, ELC, PAC,
     *   ZA, USUM, VSUM, UCNT, VCNT, TU, TQ, SCHI, CCHI
      REAL      XPOS(LSIZE), YPOS(LSIZE), ILIST(LSIZE), IRLIST(LSIZE),
     *   QLIST(LSIZE), QRLIST(LSIZE), ULIST(LSIZE), URLIST(LSIZE),
     *   VLIST(LSIZE), VRLIST(LSIZE)
      COMPLEX   IPOL, XPOL
      CHARACTER IQUV*4, SUTAB*32, CDUM*1
      DOUBLE PRECISION SUM(4), SUM2(4)
      INCLUDE 'GFORT'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INPCOM.INC'
      DATA IQUV /'IQUV'/
C-----------------------------------------------------------------------
C                                       Get source polarization
      CALL OGET ('Input', 'PMODEL', TYPE, DIM, IDUM, CDUM, IERR)
      CALL RCOPY (DIM(1), RDUM, PMODEL)
      IF (IERR.NE.0) GO TO 990
      IF (PMODEL(1).LE.0) THEN
         IERR = 2
         MSGTXT = 'YOU MUST SUPPLY PMODEL'
         GO TO 980
         END IF
      FSTOK(2) = PMODEL(2) / PMODEL(1)
      FSTOK(3) = PMODEL(3) / PMODEL(1)
      FSTOK(4) = PMODEL(4) / PMODEL(1)
C                                       Cell spacing
      CALL OGET ('Input', 'CELLSIZE', TYPE, DIM, IDUM, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL RCOPY (DIM(1), RDUM, CELLSI)
C                                       Must have non zero values for
C                                       CELLSIZE
      IF ((CELLSI(1).EQ.0.0) .OR. (CELLSI(2).EQ.0.0)) THEN
         IERR = 2
         MSGTXT = 'INVALID IMSIZE OR CELLSIZE'
         GO TO 980
         END IF
C                                       Convert to radians
C                                       Note first axis has been
C                                       reversed in u already.
      CELLSI(1) = CELLSI(1) / 206264.8062
      CELLSI(2) = CELLSI(2) / 206264.8062
C                                       Tolerance 0.3 cell for same
C                                       pointing.
      TOLU = 0.3 * ABS (CELLSI(1))
      TOLV = 0.3 * ABS (CELLSI(2))
C                                       Want IQUV
      DIM(1) = LEN (IQUV)
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (UVDATA, 'CALEDIT.STOKES', OOACAR, DIM, IDUM, IQUV,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open uvdata
      CALL OUVOPN (UVDATA, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Get vis info
      CALL UVDGET (UVDATA, 'NDIM', TYPE, DIM, IDUM, CDUM, IERR)
      NDIM = IDUM(1)
      IF (IERR.NE.0) GO TO 990
      CALL UVDGET (UVDATA, 'NAXIS', TYPE, DIM, NAXIS, CDUM, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL UVDFND (UVDATA, 2, 'STOKES', INDXS, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE FINDING STOKES AXIS'
         GO TO 980
         END IF
      CALL UVDFND (UVDATA, 1, 'TIME1', INDXT, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE FINDING TIME1 RANDOM PARAMETER'
         GO TO 980
         END IF
      CALL UVDFND (UVDATA, 1, 'UU-L', INDXU, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE FINDING U RANDOM PARAMETER'
         GO TO 980
         END IF
      CALL UVDFND (UVDATA, 1, 'VV-L', INDXV, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'TROUBLE FINDING V RANDOM PARAMETER'
         GO TO 980
         END IF
      CALL FILL (5, 1, D)
      CALL FILL (10, 0, LIMS)
      DO 50 I = 1,NDIM
         D(I) = NAXIS(I)
         LIMS(1,I) = 1
         LIMS(2,I) = NAXIS(I)
 50   CONTINUE
      DO 60 IS = 1,4
         SUM(IS) = 0.0D0
         SUM2(IS) = 0.0D0
         COUNT(IS) = 0
 60      CONTINUE
      USUM = 0.0
      UCNT = 0.0
      VSUM = 0.0
      VCNT = 0.0
      LSTCNT = 0
C
      CENTE = .FALSE.
C                                       Source table
      SUTAB = 'SU table for MBMAVG'
      CALL UV2TAB (UVMULT, SUTAB, 'SU', 1, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Get this source ID
C                                       This is set in MBNEXT
      CALL OGET (UVMULT, 'CURSID', TYPE, DIM, IDUM, CDUM, IERR)
      ISDCEN = IDUM(1)
      IF (IERR.NE.0) GO TO 990
C                                       Initial read
      CALL UVREAD (UVDATA, RP, VIS, IERR)
      IF (IERR.GT.0) GO TO 990
C                                       Done?
      EOF = IERR.LT.0
      IF (IERR.LT.0) GO TO 300
      OLDU = RP(INDXU)
      OLDV = RP(INDXV)
      GO TO 110
C                                       Read datum
 100     CALL UVREAD (UVDATA, RP, VIS, IERR)
         IF (IERR.GT.0) GO TO 990
C                                       Done?
         EOF = IERR.LT.0
         IF (IERR.LT.0) GO TO 300
C                                       Pointing done?
 110     U = RP(INDXU)
         V = RP(INDXV)
         IF ((ABS (U-OLDU).GT.TOLU) .OR. (ABS (V-OLDV).GT.TOLV))
     *      GO TO 300
C                                       Accumulate U,V
         USUM = USUM + U
         UCNT = UCNT + 1.0
         VSUM = VSUM + V
         VCNT = VCNT + 1.0
C                                       Average vis by STOKES
         DO 150 IS = 1,4
            LIMS(1,INDXS) = IS
            LIMS(2,INDXS) = IS
            CALL AVGVIS (D(2), D(3), D(4), D(5), LIMS, VIS, VS(1,IS))
C                                       Sum
            IF ((VS(3,1).GT.0.0) .AND. (VS(3,IS).GT.0.0)) THEN
               IF (IS.EQ.1) THEN
                  VAL = SQRT (VS(1,1)*VS(1,1) + VS(2,1)*VS(2,1))
               ELSE
                  IPOL = CMPLX (VS(1,1), VS(2,1))
                  XPOL = CMPLX (VS(1,IS), VS(2,IS))
C                                       Take ratio
                  VAL = REAL (XPOL / IPOL)
                  END IF
               COUNT(IS) = COUNT(IS) + 1
               SUM(IS) = SUM(IS) + VAL
               SUM2(IS) = SUM2(IS) + VAL * VAL
               END IF
 150        CONTINUE
C                                       Loop until pointing done.
         GO TO 100
C                                       Finished pointing
 300  IERR = 0
      LSTCNT = LSTCNT + 1

C                                       Average U,V as x,y in cells
      IF (UCNT.GT.0.1) THEN
         XPOS(LSTCNT) = -(USUM / UCNT) / CELLSI(1) + NX/2 + 1
      ELSE
         XPOS(LSTCNT) = FBLANK
         END IF
      IF (VCNT.GT.0.1) THEN
         YPOS(LSTCNT) = (VSUM / VCNT) / CELLSI(2) + NY/2 + 1
      ELSE
         YPOS(LSTCNT) = FBLANK
         END IF
C                                       Average
      IF (COUNT(1).GT.0) THEN
         IIPOL = SUM(1) / COUNT(1)
      ELSE
         IIPOL = FBLANK
         END IF
      IF (COUNT(1).GT.1) THEN
         IIRMS = (SUM2(1) - ((SUM(1)**2) / COUNT(1))) / (COUNT(1) - 1.0)
         IIRMS = SQRT (ABS (IIRMS / COUNT(1)))
      ELSE
         IIRMS = FBLANK
         END IF
C
      IF (COUNT(2).GT.0) THEN
         QQPOL = SUM(2) / COUNT(2)
      ELSE
         QQPOL = FBLANK
         END IF
      IF (COUNT(2).GT.1) THEN
         QQRMS = (SUM2(2) - ((SUM(2)**2) / COUNT(2))) / (COUNT(2) - 1.0)
         QQRMS = SQRT (ABS (QQRMS / COUNT(2)))
      ELSE
         QQRMS = FBLANK
         END IF
C
      IF (COUNT(3).GT.0) THEN
         UUPOL = SUM(3) / COUNT(3)
      ELSE
         UUPOL = FBLANK
         END IF
      IF (COUNT(3).GT.1) THEN
         UURMS = (SUM2(3) - ((SUM(3)**2) / COUNT(3))) / (COUNT(3) - 1.0)
         UURMS = SQRT (ABS (UURMS / COUNT(3)))
      ELSE
         UURMS = FBLANK
         END IF
C
      IF (COUNT(4).GT.0) THEN
         VVPOL = SUM(4) / COUNT(4)
      ELSE
         VVPOL = FBLANK
         END IF
      IF (COUNT(4).GT.1) THEN
         VVRMS = (SUM2(4) - ((SUM(4)**2) / COUNT(4))) / (COUNT(4) - 1.0)
         VVRMS = SQRT (ABS (VVRMS / COUNT(4)))
      ELSE
         VVRMS = FBLANK
         END IF
C                                       Correct
      IF (IIPOL.NE.FBLANK) IIPOL = IIPOL / PMODEL(1)
      IF (IIRMS.NE.FBLANK) IIRMS = IIRMS / PMODEL(1)
      IF (QQPOL.NE.FBLANK) QQPOL = QQPOL - FSTOK(2)
      IF (UUPOL.NE.FBLANK) UUPOL = UUPOL - FSTOK(3)
      IF (VVPOL.NE.FBLANK) VVPOL = VVPOL - FSTOK(4)
C                                       Reset u,v stuff for next
C                                       pointing
      OLDU = U
      OLDV = V
C                                       Get geometry
      IX = IROUND (XPOS(LSTCNT))
      IY = IROUND (YPOS(LSTCNT))
      TCEN = RP(INDXT)
      CALL MBAZEL (SUTAB, ISDCEN, TCEN, AZC, ELC, PAC, IERR)
      IF (IERR.NE.0) GO TO 990
      IF ((IX.EQ.(NX/2+1)) .AND. (IY.EQ.(NY/2+1))) THEN
C                                       Attach to UVDATA, for center
C                                       pointing.
         DIM(1) = 1
         DIM(2) = 1
         ZA = 90.0 - ELC
         RDUM(1) = PAC
         CALL OPUT (UVMULT, 'PARANGLE', OOARE, DIM, IDUM, CDUM, IERR)
         RDUM(1) = ZA
         CALL OPUT (UVMULT, 'ZENANGLE', OOARE, DIM, IDUM, CDUM, IERR)
         RDUM(1) = AZC
         CALL OPUT (UVMULT, 'AZIMUTH ', OOARE, DIM, IDUM, CDUM, IERR)
C
         CENTE = .TRUE.
         END IF
C                                       Correct Q and U for the spurious
C                                       rotation of the instrumental
C                                       polarization in the calibration
      SCHI = SIN (2.0 * PAC * DG2RAD)
      CCHI = COS (2.0 * PAC * DG2RAD)
      IF ((UUPOL.NE.FBLANK) .AND. (QQPOL.NE.FBLANK)) THEN
         TQ = QQPOL
         TU = UUPOL
         QQPOL = CCHI * TQ + SCHI * TU
         UUPOL = CCHI * TU - SCHI * TQ
         TQ = QQRMS
         TU = UURMS
         QQRMS = CCHI * TQ + SCHI * TU
         UURMS = CCHI * TU - SCHI * TQ
         END IF
C                                       Save values in lists
      ILIST(LSTCNT) = IIPOL
      IRLIST(LSTCNT) = IIRMS
      QLIST(LSTCNT) = QQPOL
      QRLIST(LSTCNT) = QQRMS
      ULIST(LSTCNT) = UUPOL
      URLIST(LSTCNT) = UURMS
      VLIST(LSTCNT) = VVPOL
      VRLIST(LSTCNT) = VVRMS
C                                       Clear accumulators
      USUM = 0.0
      UCNT = 0.0
      VSUM = 0.0
      VCNT = 0.0
      DO 360 IS = 1,4
         SUM(IS) = 0.0D0
         SUM2(IS) = 0.0D0
         COUNT(IS) = 0
 360     CONTINUE
C                                       Next pointing
      IF (.NOT.EOF) GO TO 110
C                                       I have not passed through the
C                                       center of the image
      IF (.NOT. CENTE) THEN
         IERR = 2
         MSGTXT = 'the rastr does not include the center'
         GO TO 980
         END IF
C                                       Destroy SU table object
      CALL DESTRY (SUTAB, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Close uvdata
      CALL OUVCLO (UVDATA, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Grid the four stokes images
C                                       and merge them at one qube
      SCALI = 1.0
      SCALQ = 1.0
      SCALU = 1.0
      SCALV = 1.0
      DO 500 IS = 1,4
         GO TO (410, 420, 430, 440), IS
  410    CALL MBGRID (NX, NY, LSTCNT, XPOS, YPOS, ILIST, QUBIMA(1,1,1))
C                                       calculate the maximum of
C                                       QUBIMA(*,*,1)
         IF (NOSCAL) GO TO 500
         SCALI = 0
         DO 415 IX = 1, NX
            DO 412 IY = 1, NY
               SCALI = MAX(SCALI, QUBIMA(IX, IY, 1))
  412          CONTINUE
  415       CONTINUE
C                                       devide IPOL by its maximum
         IF (SCALI .GT. 0) THEN
            WRITE (MSGTXT, 1100) SCALI
            CALL MSGWRT (8)
            DO 417 IX = 1, NX
               DO 416 IY = 1, NY
                  QUBIMA(IX, IY, 1) = QUBIMA(IX, IY, 1) / SCALI
  416             CONTINUE
  417          CONTINUE
            END IF

         GO TO 500
  420    CALL MBGRID (NX, NY, LSTCNT, XPOS, YPOS, QLIST, QUBIMA(1,1,2))
C                                       calculate the maximum of
C                                       QPOL
         IF (NOSCAL) GO TO 500
         SCALQ = 0
         DO 425 IX = 1, NX
            DO 422 IY = 1, NY
               SCALQ = MAX(SCALQ, QUBIMA(IX, IY, 2))
  422          CONTINUE
  425       CONTINUE
C                                       devide QPOL by its maximum
         IF (SCALQ .GT. 0) THEN
            WRITE (MSGTXT, 1200) SCALQ
            CALL MSGWRT (8)
            DO 427 IX = 1, NX
               DO 426 IY = 1, NY
                  QUBIMA(IX, IY, 2) = QUBIMA(IX, IY, 2) / SCALQ
  426             CONTINUE
  427          CONTINUE
            END IF
         GO TO 500
  430    CALL MBGRID (NX, NY, LSTCNT, XPOS, YPOS, ULIST, QUBIMA(1,1,3))
C                                       calculate the maximum of
C                                       UPOL
         IF (NOSCAL) GO TO 500
         SCALU = 0
         DO 435 IX = 1, NX
            DO 432 IY = 1, NY
               SCALU = MAX(SCALU, QUBIMA(IX, IY, 3))
  432          CONTINUE
  435       CONTINUE
C                                       devide QPOL by its maximum
         IF (SCALU .GT. 0) THEN
            WRITE (MSGTXT, 1300) SCALU
            CALL MSGWRT (8)
            DO 437 IX = 1, NX
               DO 436 IY = 1, NY
                  QUBIMA(IX, IY, 3) = QUBIMA(IX, IY, 3) / SCALU
  436             CONTINUE
  437          CONTINUE
            END IF
         GO TO 500
  440    CALL MBGRID (NX, NY, LSTCNT, XPOS, YPOS, VLIST, QUBIMA(1,1,4))
C                                       calculate the maximum of
C                                       VPOL
         IF (NOSCAL) GO TO 500
         SCALV = 0
         DO 445 IX = 1, NX
            DO 442 IY = 1, NY
               SCALV = MAX(SCALV, QUBIMA(IX, IY, 4))
  442          CONTINUE
  445       CONTINUE
C                                       devide VPOL by its maximum
         IF (SCALV .GT. 0) THEN
            WRITE (MSGTXT, 1400) SCALV
            CALL MSGWRT (8)
            DO 447 IX = 1, NX
               DO 446 IY = 1, NY
                  QUBIMA(IX, IY, 4) = QUBIMA(IX, IY, 4) / SCALV
  446             CONTINUE
  447          CONTINUE
            END IF
         GO TO 500
 500     CONTINUE
C                                       put the SCALs to keywords
         RDUM(1) = SCALI
         CALL OPUT (UVMULT, 'SCALI   ', OOARE, DIM, IDUM, CDUM, IERR)
         RDUM(1) = SCALQ
         CALL OPUT (UVMULT, 'SCALQ   ', OOARE, DIM, IDUM, CDUM, IERR)
         RDUM(1) = SCALU
         CALL OPUT (UVMULT, 'SCALU   ', OOARE, DIM, IDUM, CDUM, IERR)
         RDUM(1) = SCALV
         CALL OPUT (UVMULT, 'SCALV   ', OOARE, DIM, IDUM, CDUM, IERR)
C                                       Grid the four stokes rms images
C                                       and merge them at one qube
      DO 600 IS = 1,4
         GO TO (510, 520, 530, 540), IS
  510    CALL MBGRID (NX, NY, LSTCNT, XPOS, YPOS, IRLIST, QUBRMS(1,1,1))
         GO TO 600
  520    CALL MBGRID (NX, NY, LSTCNT, XPOS, YPOS, QRLIST, QUBRMS(1,1,2))
         GO TO 600
  530    CALL MBGRID (NX, NY, LSTCNT, XPOS, YPOS, URLIST, QUBRMS(1,1,3))
         GO TO 600
  540    CALL MBGRID (NX, NY, LSTCNT, XPOS, YPOS, VRLIST, QUBRMS(1,1,4))
         GO TO 600
 600     CONTINUE
      GO TO 999
C                                       Error
 980  CALL MSGWRT (8)
 990  MSGTXT = 'ERROR IMAGING ' // UVDATA
      CALL MSGWRT (8)
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('!!! The IPOL map devided by ', F7.3, ' !!!')
 1200 FORMAT ('!!! The QPOL map devided by ', F7.3, ' !!!')
 1300 FORMAT ('!!! The UPOL map devided by ', F7.3, ' !!!')
 1400 FORMAT ('!!! The VPOL map devided by ', F7.3, ' !!!')
      END
      SUBROUTINE MBMOUT (OIMAGE, UVDATA, CLASS, NX, NY, ARRAY, IERR)
C-----------------------------------------------------------------------
C   Routine to write output array
C   Inputs:
C      OIMAGE  C*?  output image object
C      UVDATA  C*?  UV data object
C      CLASS   C*6  Class of array
C      NX      I    Number of columns in ARRAY
C      NY      I    Number of rows in ARRAY
C      ARRAY   R(*) Data array
C   Output:
C      IERR    I    Error code, 0=OK else failed
C-----------------------------------------------------------------------
      CHARACTER UVDATA*(*), OIMAGE*(*), CLASS*6
      INTEGER   NX, NY, IERR
      REAL      ARRAY(NX,NY,4)
C
      CHARACTER ACCESS*8
      INTEGER   DIM(3)
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
C  DEBUG
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Add AIPS file class.
      DIM(1) = LEN (CLASS)
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (OIMAGE, 'CLASS', OOACAR, DIM, IDUM, CLASS, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open image
      CALL IMGOPN (OIMAGE, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Access by array
      ACCESS = 'ARRAY'
      DIM(1) = LEN(ACCESS)
      DIM(2) = 1
      CALL ARPPUT (OIMAGE, 'ACCESS', OOACAR, DIM, IDUM, ACCESS, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Write image
      DIM(1) = NX
      DIM(2) = NY
      DIM(3) = 4
      CALL ARRWRI (OIMAGE, DIM, ARRAY, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Close array and image
      CALL ARRCLO (OIMAGE, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL IMGCLO (OIMAGE, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       History
      CALL UVDHIS (UVDATA, OIMAGE)
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING OUTPUT IMAGE '
      CALL MSGWRT (8)
 999  RETURN
      END
      SUBROUTINE UVDHIS (UVDATA, OIMAGE)
C-----------------------------------------------------------------------
C   Routine to write history file to output image object.
C   Also copies observing geometry from uvdata; these should come out as
C   catalog header keywords in the AIPS files.
C   Inputs:
C      UVDATA  C*?  UV data object
C      OIMAGE  C*?  output image object
C-----------------------------------------------------------------------
      CHARACTER UVDATA*(*), OIMAGE*(*)
C
      INTEGER   NADV
      PARAMETER (NADV=20)
      CHARACTER LIST(NADV)*8, OGEOM(7)*8
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
     *   'QUAL', 'TIMERANG', 'BIF', 'EIF', 'PMODEL',
     *   'DOCALIB', 'GAINUSE', 'DOPOL', 'PDVER', 'FLAGVER',
     *   'OUTNAME', 'OUTDISK', 'OUTSEQ',
     *   'IMSIZE', 'CELLSIZE',
     *   'APARM'/
C                                       Observing geometry
      DATA OGEOM /'PARANGLE', 'ZENANGLE', 'AZIMUTH', 'SCALI',
     *   'SCALQ', 'SCALU', 'SCALV'/
C-----------------------------------------------------------------------
C                                        Copy old history
      CALL OHCOPY (UVDATA, OIMAGE, IERR)
      IF (IERR.NE.0) GO TO 990
C                                        New additions - copy adverb
C                                        values.
      CALL OHLIST ('Input', LIST, NADV, OIMAGE, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy observing geometry
      CALL OOPEN (OIMAGE, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 990
C
      CALL IN2OBJ (UVDATA, 7, OGEOM, OGEOM, OIMAGE, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL OCLOSE (OIMAGE, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // OIMAGE
      CALL MSGWRT (4)
 999  RETURN
C-----------------------------------------------------------------------
      END
      SUBROUTINE MBFSOU (UVDATA, SOURCE, SUID, IERR)
C-----------------------------------------------------------------------
C   Find source ID
C   Inputs:
C      UVDATA  C*?  UV data object
C      SOURCE  C*16 Source name
C   Output:
C      SUID    I    Source ID, < 0 => not found
C      IERR    I    Error code, 0=OK, 1 => not found, else failed
C-----------------------------------------------------------------------
      CHARACTER UVDATA*(*), SOURCE*16
      INTEGER   SUID, IERR
C
      CHARACTER SUTAB*32, SOUNAM*16, COLNAM(2)*24, CDUM*1
      INTEGER   TYPE, DIM(3), SUROW, NUMSU, KOL(2), NAMKOL, IDKOL
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (NAMKOL, KOL(1)), (IDKOL, KOL(2))
      DATA COLNAM /'SOURCE', 'ID. NO.'/
C-----------------------------------------------------------------------
C                                       Make SU table
      SUTAB = 'SU table for MBFSOU'
      CALL UV2TAB (UVDATA, SUTAB, 'SU', 1, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Open
      CALL OOPEN (SUTAB, 'READ', IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Number of rows
      CALL TABGET (SUTAB, 'NROW', TYPE, DIM, IDUM, CDUM, IERR)
      NUMSU = IDUM(1)
      IF (IERR.NE.0) GO TO 990
C                                       Find column numbers
      CALL TABCOL (SUTAB, 2, COLNAM, KOL, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Loop over table
      SUID = -1
      DO 100 SUROW = 1,NUMSU
         CALL TABDGT (SUTAB, SUROW, NAMKOL, TYPE, DIM, IDUM, SOUNAM,
     *      IERR)
         IF (IERR.NE.0) GO TO 990
         IF (SOUNAM.EQ.SOURCE) GO TO 200
 100     CONTINUE
C                                       Not found
      GO TO 300
C                                       Get number
 200  CALL TABDGT (SUTAB, SUROW, IDKOL, TYPE, DIM, IDUM, CDUM, IERR)
      SUID = IDUM(1)
      IF (IERR.NE.0) GO TO 990
C                                       Close table
 300  CALL OCLOSE (SUTAB, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Delete object
      CALL DESTRY (SUTAB, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Did it work?
      IF (SUID.LE.0) IERR = 1
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR LOOKING UP SOURCE ' // SOURCE
      CALL MSGWRT (8)
 999  RETURN
      END
      SUBROUTINE MBMSOK (NXTAB, SOUID, TBEG, TEND, TAVG, OK, IERR)
C-----------------------------------------------------------------------
C   Check if a given source was observed in the given timerange; only
C   the centertime os the scan is used fro this test.
C   Note: no check is made to see if there are multiple scans.
C   Inputs:
C      NXTAB   C*?  NX table, already opened
C      SOUID   I    Source ID to check
C      TBEG    R    Start of timerange in days
C      TEND    R    End of timerange in days
C   Output:
C      TAVG    R    Average time of scan
C      OK      L    If true source observed in scan
C      IERR    I    Error code, 0=OK, 1 => not found, else failed
C-----------------------------------------------------------------------
      CHARACTER NXTAB*(*)
      INTEGER   SOUID, IERR
      REAL      TBEG, TEND, TAVG
      LOGICAL   OK
C
      CHARACTER COLNAM(2)*24, CDUM*1
      INTEGER   TYPE, DIM(3), NXROW, IDSOU, NUMNX, KOL(2), IDKOL,
     *   TIMKOL
      REAL      TIME
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'GFORT'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (IDKOL, KOL(1)), (TIMKOL, KOL(2))
      DATA COLNAM /'SOURCE ID', 'TIME'/
C-----------------------------------------------------------------------
C                                       Number of rows
      CALL TABGET (NXTAB, 'NROW', TYPE, DIM, IDUM, CDUM, IERR)
      NUMNX = IDUM(1)
      IF (IERR.NE.0) GO TO 990
C                                       Find column numbers
      CALL TABCOL (NXTAB, 2, COLNAM, KOL, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Loop over table
      OK = .FALSE.
      TAVG = -1.0E5
      DO 100 NXROW = 1,NUMNX
         CALL TABDGT (NXTAB, NXROW, IDKOL, TYPE, DIM, IDUM, CDUM, IERR)
         IDSOU = IDUM(1)
         IF (IERR.NE.0) GO TO 990
         IF (IDSOU.EQ.SOUID) THEN
C                                       Check center time
            CALL TABDGT (NXTAB, NXROW, TIMKOL, TYPE, DIM, IDUM, CDUM,
     *         IERR)
            TIME = RDUM(1)
            IF (IERR.NE.0) GO TO 990
            IF ((TIME.GE.TBEG) .AND. (TIME.LE.TEND)) GO TO 200
            END IF
 100     CONTINUE
C                                       Not found
      GO TO 999
C                                       Set scan time
 200  TAVG = TIME
      OK = .TRUE.
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR FINDING NEXT SOURCE IN INDEX TABLE'
      CALL MSGWRT (8)
 999  RETURN
      END
      SUBROUTINE MBAZEL (TABLE, SOURID, TIME, AZ, EL, PA, IERR)
C-----------------------------------------------------------------------
C   Returns the azimuth and elevation of a source at a given time.
C   (assumed to be the same for all antennas)
C   Note it assumes GETANT has been called.
C   Inputs:
C      TABLE   C*?  Input table object (assumed to have associated AN
C                   and SU tables)
C      SOURID  I    Source ID number, use -1 for single source data
C      TIME    R    Time in days
C   Output:
C      AZ      R    Source Azimuth in degrees
C      EL      R    Source elevation in degrees
C      PA      R    Parallactic angle in degrees
C      IERR    I    Return code, O=OK, else failed.
C-----------------------------------------------------------------------
      CHARACTER TABLE*(*)
      INTEGER    SOURID, IERR
      REAL       TIME, AZ, EL, PA
C
      INTEGER   TDISK, TCNO, TVER, LUN, ANT, SUBARR
      CHARACTER TTYPE*2
      DOUBLE PRECISION DTIME
C    *   SINDEC, COSDEC, HRANG, SINLAT, COSLAT,
      REAL       HA
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      REAL      PANGS(MAXANT)
C-----------------------------------------------------------------------
      IERR = 0
      ANT = 1
      SUBARR = 1
      DTIME = TIME
C                                       Look up table info
      CALL TBLKUP (TABLE, TDISK, TCNO, TTYPE, TVER, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Get LUN
      CALL OBLUN (LUN, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Get CATBLK
      CALL OBHGET (TABLE, CATBLK, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Set source if necessary
      IF ((SOURID.NE.IDSOUR) .OR. (SOURID.LE.0)) CALL GETSOU (SOURID,
     *   TDISK, TCNO, CATBLK, LUN, IERR)
      IF (IERR.NE.0) GO TO 900
C                                       Free LUN
      CALL OBLUFR (LUN)
C                                       Determine elevation
      CALL SOUELV (ANT, DTIME, HA, EL, AZ)
C                                       Parallactic angle
      CALL PARANG (TIME, PANGS)
      PA = PANGS(ANT)
C                                       Azimuth
C     SINDEC = SIN (DECAPP)
C     COSDEC = COS (DECAPP)
C     HRANG = HA
C     COSLAT = COS (STNLAT(ANT))
C     SINLAT = SIN (STNLAT(ANT))
C     AZ = ATAN2 (-COSDEC*SIN (HRANG),
C    *   (SINDEC*COSLAT - COSDEC*COS (HRANG)*SINLAT))
C                                       Convert to degrees
      EL = EL * 57.29577951
      AZ = AZ * 57.29577951
      PA = PA * 57.29577951
      GO TO 999
C                                       Error
 900  MSGTXT = 'PROBLEM SOURCE GEOMETRY FOR ' // TABLE
      CALL MSGWRT (7)
C
 999  RETURN
      END
      SUBROUTINE MBGRID (NX, NY, COUNT, X, Y, LIST, IMAGE)
C-----------------------------------------------------------------------
C   Grid quasi regularly sampled values from a list into a regular grid.
C   A three term Lagrangian interpolation is used in each axis.
C   Inputs:
C      NX      I    Number of columns in image
C      NY      I    Number of rows in image
C      COUNT   I    Number of items in the list
C      X       R(*) "X" positions in cells of items in the list
C      Y       R(*) "Y" positions in cells of items in the list
C      LIST    R(*) List of values
C   Output:
C      IMAGE   R(*) Regularly gridded array.
C-----------------------------------------------------------------------
      INTEGER   NX, NY, COUNT
      REAL      X(COUNT), Y(COUNT), LIST(COUNT), IMAGE(NX,NY)
C
      INTEGER   IX, IY, I, J, K, XL(3,3), USED(9), USECNT, IPOS, JPOS,
     *   OFFSET(2,8), IXT, IYT
      LOGICAL   GOOD
      REAL      XC, YC, PX(3,3), PY(3), YCR(3), DIST, D2, XW, YW, NUMX,
     *   DENOMX, NUMY, DENOMY, SUM, SUMWT
      INCLUDE 'INCS:DDCH.INC'
      DATA OFFSET /-1,-1, -1,0, -1,1, 0,-1, 0,1, 1,-1, 1,0, 1,1/
C-----------------------------------------------------------------------
C                                       Loop over X
      DO 500 IX = 1,NX
         XC = IX
C                                       Loop over Y
         DO 490 IY = 1,NY
C                                       In case of no data
            IMAGE(IX,IY) = FBLANK
            YC = IY
            DO 20 I = 1,3
               DO 10 J = 1,3
                  XL(I,J) = -1
 10               CONTINUE
 20            CONTINUE
C                                       Find center cell
            DIST = 1.0E20
            DO 50 I = 1,COUNT
               D2 = 1.0E20
               IF ((X(I).NE.FBLANK) .AND. (Y(I).NE.FBLANK) .AND.
     *            (LIST(I).NE.FBLANK)) D2 = (X(I)-XC)**2 + (Y(I)-YC)**2
               IF (D2.LT.DIST) THEN
                  IPOS = I
                  DIST = D2
                  END IF
 50            CONTINUE
C                                       Must be within one cell
            IF (DIST.GT.0.95) GO TO 490
            XL(2,2) = IPOS
            USECNT = 1
            USED(USECNT) = IPOS
C                                       Look for 8 adjacent cells
            DO 100 J = 1,8
C                                       Take care of edge effects
               IXT = IX + OFFSET(1,J)
               IYT = IY + OFFSET(2,J)
               IF ((IXT.GE.1) .AND. (IXT.LE.NX) .AND. (IYT.GE.1) .AND.
     *            (IYT.LE.NY)) THEN
                  XW = X(IPOS) + OFFSET(1,J)
                  YW = Y(IPOS) + OFFSET(2,J)
                  DIST = 1.0E20
                  DO 60 I = 1,COUNT
                     D2 = 1.0E20
                     IF ((X(I).NE.FBLANK) .AND. (Y(I).NE.FBLANK) .AND.
     *                  (LIST(I).NE.FBLANK))
     *                  D2 = (X(I)-XW)**2 + (Y(I)-YW)**2
                     IF (D2.LT.DIST) THEN
                        JPOS = I
                        DIST = D2
                        END IF
 60                  CONTINUE
               ELSE
C                                       Off edge
                  JPOS = -1
                  END IF
C                                       Must be within one cell
               IF (DIST.GT.0.95) JPOS = -1
C                                       Can't be picked already
               DO 80 I = 1,USECNT
                  IF (JPOS.EQ.USED(I)) JPOS = -1
 80               CONTINUE
               XL(2+OFFSET(1,J),2+OFFSET(2,J)) = JPOS
               USECNT = USECNT + 1
               USED(USECNT) = JPOS
 100           CONTINUE
C                                       Compute Lagrangian coefficients
C                                       Interpolate in each row then
C                                       column.
            DO 200 I = 1,3
               DO 190 J = 1,3
                  NUMX = 1.0
                  DENOMX = 1.0
                  GOOD = .FALSE.
                  IF ((XL(I,J).GT.0) .AND. (LIST(XL(I,J)).NE.FBLANK))
     *               THEN
                     DO 130 K = 1,3
                        IF ((K.NE.I) .AND.
     *                     (XL(K,J).GT.0) .AND.
     *                     (LIST(XL(K,J)).NE.FBLANK) .AND.
     *                     (X(XL(K,J)).NE.FBLANK)) THEN
                           NUMX = NUMX * (XC - X(XL(K,J)))
                           DENOMX = DENOMX * (X(XL(I,J)) -
     *                        X(XL(K,J)))
                           GOOD = .TRUE.
                           END IF
 130                    CONTINUE
                     END IF
                  IF (GOOD .AND. (DENOMX.NE.0.0)) THEN
                     PX(I,J) = NUMX / DENOMX
                  ELSE
                     PX(I,J) = 0.0
                     END IF
 190           CONTINUE
 200        CONTINUE
C                                       Get central Y on each row, use
C                                       another if not avaliable.
         DO 210 J = 1,3
            YCR(J) = FBLANK
            IF (XL(2,J).GT.0) YCR(J) = Y(XL(2,J))
            IF ((YCR(J).EQ.FBLANK) .AND. (XL(1,J).GT.0))
     *         YCR(J) = Y(XL(1,J))
            IF ((YCR(J).EQ.FBLANK) .AND. (XL(3,J).GT.0))
     *         YCR(J) = Y(XL(3,J))
 210        CONTINUE
C                                       Interpolation factors in Y
         DO 250 J = 1,3
            NUMY = 1.0
            DENOMY = 1.0
            GOOD = .FALSE.
            IF (YCR(J).NE.FBLANK) THEN
               DO 240 K = 1,3
                  IF ((K.NE.J) .AND. (YCR(K).NE.FBLANK)) THEN
                     NUMY = NUMY * (YC - YCR(K))
                     DENOMY = DENOMY * (YCR(J) - YCR(K))
                     GOOD = .TRUE.
                     END IF
 240              CONTINUE
               END IF
               IF (GOOD .AND. (DENOMY.NE.0.0)) THEN
                  PY(J) = NUMY / DENOMY
               ELSE
                  PY(J) = 0.0
               END IF
 250        CONTINUE
C                                       Interpolate
            SUM = 0.0
            SUMWT = 0.0
            GOOD = .FALSE.
            DO 300 I = 1,3
               DO 290 J = 1,3
                  IF ((PX(I,J)*PY(J).GT.1.0E-10) .AND.
     *               (XL(I,J).GT.0) .AND. (LIST(XL(I,J)).NE.FBLANK))
     *               THEN
                     SUM = SUM + PX(I,J) * PY(J) * LIST(XL(I,J))
                     SUMWT = SUMWT + PX(I,J) * PY(J)
                     GOOD = .TRUE.
                     END IF
 290              CONTINUE
 300           CONTINUE
            IF (GOOD .AND. (ABS (SUMWT).GT.1.0E-20)) THEN
               IMAGE(IX,IY) = SUM / SUMWT
               END IF
 490        CONTINUE
 500     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE GRDCRM (APCORE, IFIELD, DOSUM, APLO, APBUF, FIRST,
     *   NUMBER, NLOAD, GPARMS, JBUFSZ, BUFF1, BUFF2, BUFF3, IRET)
C-----------------------------------------------------------------------
C! Loads CLEAN components into AP for uv model computation.
C# AP-util Map UV EXT-appl Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 1999-2002, 2005-2006, 2008, 2012-2013,
C;  Copyright (C) 2015, 2019-2020, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GRDCRM loads CLEAN components for field IFIELD into the AP in
C   preparation for transformation to the data plane.  If GRDCRM starts
C   from the first component, the flux density of the CLEAN components
C   is summed.  The signs of the cell offsets are adjusted for flips
C   made to the map.
C   Input:
C      IFIELD   I      Current field number.
C      DOSUM    L      If true sum flux densities.
C      APLO     I      AP start location for the component array.
C      APBUF    I      AP start location for the buffer.
C      FIRST    I      First CLEAN component to be loaded.
C      NUMBER   I      Number of CLEAN components to be loaded.
C      NLOAD    I      AP buffer size.
C      JBUFSZ   I      Size in bytes of buffers. Dimension of BUFF1,2,3
C                      must be at least (2048 + 512) * 2
C   Output:
C      GPARMS   R(3)   BMAJ, BMIN, BPA of 1 size Gaussian in file
C      BUFF1    R(*)   Working buffer
C      BUFF2    R(*)   Working buffer
C      BUFF3    R(*)   Working buffer
C      NUMBER   I      Number of clean components loaded.
C      IRET     I      Return error code, 0=OK, 10=>no Comps found,
C                      otherwise fatal error.
C   Inputs from COMMON /MAPDES/:
C      CCDISK   I(*)     Disk numbers for CC files
C      CCCNO    I(*)     Catalog slot numbers for CC files.
C      CCVER    I(*)     CC file version number for each field.
C      NONEG    L        Stop reading comps. from a file past the first
C                        negative component.
C      LIMFLX   R        Stop reading comps < LIMFLX in abs value
C      NCLNG    I(*)     Changed if flux limit hit.
C   CLEAN components loaded into the AP in blocks of 5 words as:
C      0   = Y (integer form)
C      1   = FLUXG * cos(UX)
C      2   = FLUXG * sin(UX)
C      3,4 = cos, sin(X)
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   IFIELD, APLO, APBUF, FIRST, NUMBER, NLOAD, JBUFSZ, IRET
      LOGICAL   DOSUM
      REAL      GPARMS(3), BUFF1(*), BUFF2(*), BUFF3(*)
C
      INTEGER   IERR, NREC, LIMIT, NCOUNT, I, LREC, LUNC, NX, NY, NKEY,
     *   IPOINT, ICOUNT, JCOUNT, APLOC, APLOC1, APLOC2, APLOC3, APLOC4,
     *   NNCNT, IDDX, IDDY,IROUND, BADCNT, KLNBL2(256), CCBUFF(512)
      REAL      FNX, FNY
      LOGICAL   F, DONE
      REAL      TEMP(6), TWOPIX(2), DDX, DDY, CSX, CSY, XDDX,
     *   XDDY, CSXY
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DGDS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INTEGER   CCKOLS(MAXCCC), CCNUMV(MAXCCC), CCRNO, CCNCOL, CCTYPE
      REAL      XX, YY, ZZ, FLUX, PARMS(3)
      DATA F /.FALSE./
      DATA LUNC /28/
C-----------------------------------------------------------------------
C                                       Get image size
      NX = FLDSZ(1,IFIELD) * OSFX + 0.1
      NY = FLDSZ(2,IFIELD) * OSFY + 0.1
      FNX = NX
      FNY = NY
C                                       Open CLEAN component file.
      LREC = 0
      NREC = 1
      NKEY = 0
      JCOUNT = 0
C                                       Make sure this header applies
C                                       to this image
      CALL CATIO ('READ', CCDISK(IFIELD), CCCNO(IFIELD), KLNBL2, 'REST',
     *   BUFF1(2049), IRET)
      IF ((IRET.NE.0) .AND. (IRET.LT.5)) THEN
         WRITE (MSGTXT,1000) IRET, 'READ HEADER WITH CATIO'
         CALL MSGWRT(8)
         GO TO 999
         END IF
C                                       Tabini can update header on disk
      CALL CCMINI ('READ', CCBUFF, CCDISK(IFIELD), CCCNO(IFIELD),
     *   ABS(CCVER(IFIELD)), KLNBL2, LUNC, CCRNO, CCKOLS, CCNUMV,
     *   CCNCOL, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN TABLE FOR READ'
         GO TO 990
         END IF
      LREC = CCNCOL
C                                       Check for 3D
      IF (CCNUMV(4).GT.0) THEN
         MSGTXT = 'GRDCRM: GRIDDED MODELS CANNOT DO 3D CC TABLES'
         IRET = 10
         GO TO 990
         END IF
      APLOC = APLO
      ICOUNT = 0
      IPOINT = FIRST
      DDX = XPOFF(IFIELD)
      DDY = YPOFF(IFIELD)
      CSX = ABS (CELLSG(1)) / 3600.0
      CSY = ABS (CELLSG(2)) / 3600.0
      CSXY = SQRT (CSX*CSY)
      BADCNT = 0
C                                       Begin loading into computer buff
C                                       Make sure to load in small
C                                       enough pieces.
      LIMIT = JBUFSZ / 8
      LIMIT = MIN (LIMIT, NLOAD, 2048)
      IF (NUMBER.LT.LIMIT) LIMIT = NUMBER
      CALL RFILL (3, 0.0, GPARMS)
C                                       Jump to here if more passes
C                                       necessary.
 30   CONTINUE
         NCOUNT = 0
         DO 50 I = 1,LIMIT
            CCRNO = IPOINT
            CALL TABCCM ('READ', CCBUFF, CCRNO, CCKOLS, CCNUMV, CCNCOL,
     *         XX, YY, ZZ, FLUX, CCTYPE, PARMS, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1030) IRET, CCRNO
               GO TO 990
            ELSE IF (IRET.LT.0) THEN
               IRET = 0
               GO TO 45
               END IF
C                                       Deal with component.
C                                       Make sure a point.
            DONE = (ABS(FLUX).LT.LIMFLX) .OR.
     *         ((NONEG) .AND. (FLUX.LT.0.0))
            IF (DONE) THEN
               NCLNG(IFIELD) = IPOINT - 1
               GO TO 55
               END IF
            IF ((LREC.LE.3) .OR. (CCTYPE.LE.1)) THEN
               NCOUNT = NCOUNT + 1
C                                       Gaussians
C                                       Check points for difmap also
               IF (LREC.GT.4) THEN
                  IF (NCOUNT.EQ.1) THEN
                     IF ((CCTYPE.EQ.1) .OR. (CCTYPE.EQ.0)) THEN
                        GPARMS(1) = PARMS(1)
                        GPARMS(2) = PARMS(2)
                        GPARMS(3) = PARMS(3)
                        END IF
                  ELSE
                     IF ((CCTYPE.EQ.1) .OR. (CCTYPE.EQ.0)) THEN
                        IF ((ABS(GPARMS(1)-PARMS(1))/CSXY.LT.0.05)
     *                     .AND. (ABS(GPARMS(2)-PARMS(2))/CSXY.LT.0.05)
     *                     .AND. (ABS(GPARMS(3)-PARMS(3)).LT.0.2))
     *                     GO TO 40
                        END IF
                     MSGTXT = 'CC FILE NOT ALL ONE TYPE/SIZE'
                     CALL MSGWRT (8)
                     MSGTXT = 'TRY DFT MODEL SUBTRACTION/DIVISION'
                     IRET = 10
                     GO TO 990
                     END IF
                  END IF
 40            XX = XX + DDX
               YY = YY + DDY
C                                       Check for bad cell numbers
               XDDX = XX / CSX
               XDDY = YY / CSY
               IDDX = IROUND (XDDX)
               IDDY = IROUND (XDDY)
               IF ((ABS(XDDX-IDDX).GT.0.05) .OR.
     *            (ABS(XDDY-IDDY).GT.0.05)) THEN
                  BADCNT = BADCNT + 1
                  IF (BADCNT.LE.50) THEN
                     WRITE (MSGTXT,1040) I, XDDX, XDDY
                     CALL MSGWRT (8)
                     END IF
                  END IF
               BUFF1(NCOUNT) = FLUX
               BUFF2(NCOUNT) = XX
               BUFF3(NCOUNT) = YY
               IF (DOSUM) THEN
                  FLUXG(IFIELD) = FLUXG(IFIELD) + FLUX
                  TFLUXG = TFLUXG + FLUX
                  END IF
               END IF
 45         IPOINT = IPOINT + 1
 50         CONTINUE
 55      NSUBG(IFIELD) = IPOINT
         IF (NCOUNT.GT.0) THEN
            NNCNT = NCOUNT
C                                       Form AP indexes.
            APLOC1 = APLOC + 1
            APLOC2 = APLOC + 2
            APLOC3 = APLOC + 3
            APLOC4 = APLOC + 4
C                                       Load data into AP buffer APBUF.
C                                       Load flux (FLUXG*cos(ux))
            CALL QPUT (APCORE, BUFF1, APBUF, NNCNT, 2)
            CALL QWD
            CALL QVMOV (APCORE, APBUF, 1, APLOC1, 5, NNCNT)
C                                       Load and fix dec cell numbers.
            CALL QWR
            CALL QPUT (APCORE, BUFF3, APBUF, NNCNT, 2)
            CALL QWD
C                                       Move values before fixing.
            CALL QVMOV (APCORE, APBUF, 1, APLOC, 5, NNCNT)
            CALL QWR
C                                       Set constants in AP.
            TEMP(1) = (-FNY/2.) * CELLSG(2) / 3600.
            TEMP(2) = (FNY/2.0-1.0) * CELLSG(2) / 3600.
            TEMP(3) = FNY * CELLSG(2) / 3600.
            TEMP(4) = 2.0 / (CELLSG(2) / 3600.)
            TEMP(5) = 0.0
            TEMP(6) = -0.5 * CELLSG(2) / 3600.
            CALL QPUT (APCORE, TEMP, 1, 6, 2)
            CALL QWD
C                                       Put declinations in the range
C                                       (0,FNY-1) and multiply by 2,fix.
C                                       Use APLOC2 for temporary use.
            CALL QVFILL (APCORE, 6, APLOC2, 5, NNCNT)
            CALL QVCLIP (APCORE, APLOC, 5, 1, 2, APLOC, 5, NNCNT)
            CALL QLVGT (APCORE, APLOC2, 5, APLOC, 5, APLOC2, 5, NNCNT)
            CALL QVSMUL (APCORE, APLOC2, 5, 3, APLOC2, 5, NNCNT)
            CALL QVADD (APCORE, APLOC2, 5, APLOC, 5, APLOC, 5, NNCNT)
            CALL QVSMAF (APCORE, APLOC, 5, 4, 5, APLOC, 5, NNCNT)
C                                       Load and float RA cell numbers.
            CALL QWR
            CALL QPUT (APCORE, BUFF2, APBUF, NNCNT, 2)
            CALL QWD
            CALL QVMOV (APCORE, APBUF, 1, APLOC3, 5, NNCNT)
C                                       Store -2 PI/FNX/CELLSG(1)
            TWOPIX(1) = ((-2.0 * 3.1415926) / FNX) / (CELLSG(1) / 3600.)
            CALL QWR
            CALL QPUT (APCORE, TWOPIX, 1, 1, 2)
            CALL QWD
C                                       Scale RA by -2 PI/FNX/CELLSG(1)
            CALL QVSMUL (APCORE, APLOC3, 5, 1, APLOC3, 5, NNCNT)
C                                       Clear APLOC+2 (FLUXG*sin(ux) ).
            CALL QVCLR (APCORE, APLOC2, 5, NNCNT)
C                                       Take sine and cosine of
C                                       RA to 3 and 4.
            CALL QVSIN (APCORE, APLOC3, 5, APLOC4, 5, NNCNT)
            CALL QVCOS (APCORE, APLOC3, 5, APLOC3, 5, NNCNT)
            END IF
         ICOUNT = ICOUNT + LIMIT
         JCOUNT = JCOUNT + NCOUNT
C                                       If load complete close CC
C                                       file and return.
C                                       Update APLOC.
         APLOC = APLOC + (NNCNT * 5)
C                                       Return for another load.
         IF ((ICOUNT.LT.NUMBER) .AND. (.NOT.DONE)) THEN
            IF (NUMBER-ICOUNT.LT.LIMIT) LIMIT = NUMBER - ICOUNT
            GO TO 30
            END IF
C                                       Make sure CC loaded.
      IF (JCOUNT.LE.0) IRET = 10
      NUMBER = JCOUNT
C                                       Close CLNFIL.
      CALL TABCCM ('CLOS', CCBUFF, CCRNO, CCKOLS, CCNUMV, CCNCOL,
     *   XX, YY, ZZ, FLUX, CCTYPE, PARMS, IRET)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1060) IERR
         GO TO 990
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GRDCRM: ERROR',I3,' ON ',A)
 1030 FORMAT ('GRDCRM: READ ERROR',I3,' RECORD ',I5)
 1040 FORMAT ('GRDCRM: BAD CELL(',I7,') =', 2F10.3)
 1060 FORMAT ('GRDCRM: ERROR',I3,' CLOSING FILE ')
      END

      SUBROUTINE OSORT (A, N, NP2, KEY1, KEY2, LEN, WK, IP, IER)
C-----------------------------------------------------------------------
C! does quick sort on array of vectors, then reorders by calling PERMAT
C# Sort UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   OSORT does a quick sort on the keys and a permutation vector and
C   then reorders the data with PERMAT.  Data sorted into descending
C   order of the keys.
C   Input:
C      A     R(LEN,N)   Array of data to be sorted.
C      N     I         Number of records to be sorted
C      NP2   I         Number of words in work arrays = N+2
C      KEY1  I         Word in record of slower varying key
C      KEY2  I         Word in record of faster varying key
C      LEN   I         Length of record in R words (must be .LE. 2048)
C   Output:
C      WK    R(2,NP2)  Work buffer for keys.
C      IP    I(NP2)    Work buffer for permutation vector.
C      A     R(LEN,N)  Array of data sorted.
C      IER   I         Error code,   0 => OK
C                                    1 => input error (LEN > 2048)
C   Adapted from ACM alg. #347 - June 1981
C-----------------------------------------------------------------------
      INTEGER   N, LEN, NP2, IP(NP2), KEY1, KEY2, IER
      REAL      A(LEN,N), WK(2,NP2)
C
      INTEGER   TP, TTP, IU(20), IL(20), I, IJ, J, K, KK, L, M
      REAL      T(2), TT(2)
C-----------------------------------------------------------------------
C                                       Check length
      IER = 1
      IF (LEN.GT.2048) GO TO 999
      IER = 0
C                                       Build array of keys to sort
C                                       Minus sign makes order descend.
C                                       Note "blockers" put at ends.
      DO 5 KK = 1,N
         I = KK + 1
         IP(I) = KK
         WK(1,I) = -A(KEY1,KK)
         WK(2,I) = -A(KEY2,KK)
 5       CONTINUE
      WK(1,1) = -1.0E20
      WK(1,N+2) = 1.E20
      M = 1
      I = 2
      J = N + 1
C                                       Sort subgroup
 10   CONTINUE
         IF (I.GE.J) GO TO 240
C
 20      CONTINUE
            K = I
            IJ = (J+I)/2
            T(1) = WK(1,IJ)
            T(2) = WK(2,IJ)
            TP = IP(IJ)
            IF ((WK(1,I).GT.T(1)) .OR. ((WK(1,I).EQ.T(1)) .AND.
     *         (WK(2,I).GT.T(2)))) THEN
               DO 60 KK = 1,2
                  WK(KK,IJ) = WK(KK,I)
                  WK(KK,I) = T(KK)
                  T(KK) = WK(KK,IJ)
 60               CONTINUE
               IP(IJ) = IP(I)
               IP(I) = TP
               TP = IP(IJ)
               END IF
C
            L = J
            IF ((WK(1,J).GT.T(1)) .OR. ((WK(1,J).EQ.T(1)) .AND.
     *         (WK(2,J).GE.T(2)))) GO TO 160
               DO 100 KK = 1,2
                  WK(KK,IJ) = WK(KK,J)
                  WK(KK,J) = T(KK)
                  T(KK) = WK(KK,IJ)
 100              CONTINUE
               IP(IJ) = IP(J)
               IP(J) = TP
               TP = IP(IJ)
               IF ((WK(1,I).LT.T(1)) .OR. ((WK(1,I).EQ.T(1)) .AND.
     *            (WK(2,I).LE.T(2)))) GO TO 160
                     DO 130 KK = 1,2
                        WK(KK,IJ) = WK(KK,I)
                        WK(KK,I) = T(KK)
                        T(KK) = WK(KK,IJ)
 130                    CONTINUE
                     IP(IJ) = IP(I)
                     IP(I) = TP
                     TP = IP(IJ)
                     GO TO 160
C
 140              CONTINUE
                     DO 150 KK = 1,2
                        WK(KK,L) = WK(KK,K)
                        WK(KK,K) = TT(KK)
 150                    CONTINUE
                     IP(L) = IP(K)
                     IP(K) = TTP
C                                       Put substring on stack
 160        L = L - 1
            IF (L.LE.0) THEN
               IER = 3
               GO TO 999
               END IF
            IF ((WK(1,L).GT.T(1)) .OR. ((WK(1,L).EQ.T(1)) .AND.
     *         (WK(2,L).GT.T(2)))) GO TO 160
               TT(1) = WK(1,L)
               TT(2) = WK(2,L)
               TTP = IP(L)
 200           K = K + 1
               IF ((WK(1,K).LT.T(1)) .OR. ((WK(1,K).EQ.T(1)) .AND.
     *            (WK(2,K).LT.T(2)))) GO TO 200
                  IF (K.LE.L) GO TO 140
                  IF (L-I.GT.J-K) THEN
                     IL(M) = I
                     IU(M) = L
                     I = K
                     M = M + 1
                  ELSE
                     IL(M) = K
                     IU(M) = J
                     J = L
                     M = M + 1
                     END IF
                  GO TO 250
C                                       Next substring from stack
 240        CONTINUE
               M = M - 1
               IF (M.EQ.0) GO TO 900
               I = IL(M)
               J = IU(M)
C                                       Straight insertion sort done
C                                       if <= 10 elements in group
 250        IF (J-I.GE.11) GO TO 20
         IF (I.EQ.2) GO TO 10
      I = I-1
 260  I = I+1
         IF (I.EQ.J) GO TO 240
            T(1) = WK(1,I+1)
            T(2) = WK(2,I+1)
            TP = IP(I+1)
            IF ((WK(1,I).LT.T(1)) .OR. ((WK(1,I).EQ.T(1)) .AND.
     *         (WK(2,I).LE.T(2)))) GO TO 260
               K = I
C
 300           CONTINUE
                  WK(1,K+1) = WK(1,K)
                  WK(2,K+1) = WK(2,K)
                  IP(K+1) = IP(K)
                  K = K-1
                  IF (K.LE.0) THEN
                     IER = 4
                     GO TO 999
                     END IF
                  IF ((T(1).LT.WK(1,K)) .OR. ((T(1).EQ.WK(1,K)) .AND.
     *               (T(2).LE.WK(2,K)))) GO TO 300
                     WK(1,K+1) = T(1)
                     WK(2,K+1) = T(2)
                     IP(K+1) = TP
                     GO TO 260
C                                       Permute full matrix finally
 900  CONTINUE
         CALL PERMAT (A, LEN, LEN, N, 0, IP(2), WK)
C
 999  RETURN
      END

      SUBROUTINE ZM70CL (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C! close an IIS Model 70 TV device, flushing any buffer
C# IO-TV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Close the IIS model 70 TV device associated with LUN and clear its
C   FTAB entry.
C   Inputs:
C      LUN     I   Logical unit number
C      FIND    I   Index in FTAB to file control block for LUN
C   Output:
C      IERR    I   Error return code: 0 => no error
C                              1 => close error or flush error
C                              2 => file already closed in FTAB
C                              3 => both errors
C                              4 => erroneous LUN
C   Generic version.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
C
      INTEGER   IDUM, JERR, TVLUN, TVDEVN, FCBOFF, I, J
      LOGICAL   F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA F /.FALSE./
      DATA TVLUN, TVDEVN /9, 4/
C-----------------------------------------------------------------------
      IERR = 4
C                                       Valid LUN?
      IF (LUN.EQ.TVLUN) GO TO 10
         WRITE (MSGTXT,1000) LUN
         GO TO 995
C                                       Valid device type?
 10   IF (DEVTAB(LUN).EQ.TVDEVN) GO TO 20
         WRITE (MSGTXT,1010) LUN, DEVTAB(LUN)
         GO TO 995
C                                       Locate LUN in FTAB.
 20   IERR = 0
      CALL LSERCH ('SRCH', LUN, FIND, F, JERR)
      IF (JERR.EQ.0) GO TO 30
         IERR = 2
         WRITE (MSGTXT,1020) LUN
         GO TO 995
C                                       Flush buffers.
 30   CALL ZM70XF ('FLSH', IDUM, IDUM, IDUM, JERR)
      IF (JERR.EQ.0) GO TO 40
         IERR = 1
         WRITE (MSGTXT,1030) JERR
C                                       Close the device.
 40   FCBOFF = FIND + NMOFF
      CALL ZM70C2 (FTAB(FCBOFF), JERR)
      IF (JERR.EQ.0) GO TO 50
         IERR = 1
         WRITE (MSGTXT,1040) JERR
         CALL MSGWRT (7)
         CALL ZERROR ('ZM70C2', FTAB(FCBOFF+FCBERR), ' ', FTAB(FCBOFF),
     *      F)
C                                       Clear FTAB entry.
 50   CALL LSERCH ('CLOS', LUN, FIND, F, JERR)
      IF (JERR.EQ.0) THEN
         CALL FSERCH (FIND, I, J, JERR)
         IF (JERR.EQ.0) THEN
            IF (I.EQ.1) DEVNAM(J) = ' '
            IF (I.EQ.2) NONNAM(J) = ' '
            IF (I.EQ.3) MAPNAM(J) = ' '
            END IF
         GO TO 999
      ELSE
         IERR = IERR + 2
         WRITE (MSGTXT,1050) LUN
         END IF
C
 995  CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZM70CL: INVALID LUN = ',I4)
 1010 FORMAT ('ZM70CL: DEVTAB(',I2,') = ',I2,' = INVALID DEVICE TYPE')
 1020 FORMAT ('ZM70CL: LUN = ',I2,' ALREADY CLOSED IN FTAB ON SEARCH')
 1030 FORMAT ('ZM70CL: ZM70XF RETURNS ERROR = ',I6)
 1040 FORMAT ('ZM70CL: ZM70C2 RETURNS ERROR = ',I6)
 1050 FORMAT ('ZM70CL: LUN = ',I2,' ALREADY CLOSED IN FTAB ON CLOSE')
      END

C   Array pointer Class:  name ='ARRAY_PNT'
C-----------------------------------------------------------------------
C! Object Oriented AIPS Fortran "Array Pointer" class library
C# Map-util Utility Object-Oriented
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   An array pointer contains a pointer to the first element of the last
C   read access or next write access to an array and the access type.
C
C   Class Public members:
C      POSN    I(7)    Element number on each axis of first element of
C                      last read or next write.
C      ACCESS  C*8     Array access type: 'PIXEL', 'ROW', 'PLANE',
C                      'ARRAY'
C
C   Public functions:
C      ARPGET (name, keywrd, type, dim, value, valuec, ierr)
C         Return array pointer.
C      ARPPUT (name, keywrd, type, dim, value, valuec, ierr)
C         Store array pointer.
C
LOCAL INCLUDE 'ARRAY_PNT.INC'
C                                       ARRAY_PNT class include
      INTEGER   NMEML
      PARAMETER (NMEML = 2)
      CHARACTER MEMS(NMEML)*8, THSCLS*16
      DATA MEMS /'POSN', 'ACCESS'/
      DATA THSCLS /'ARRAY_PNT'/
LOCAL END
      SUBROUTINE ARPGET (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public
C   Return array pointer member value.
C   Inputs:
C      NAME    C*?   Object name
C      KEYWRD  C*?   Keyword in form 'mem1.mem2...'
C   Outputs:
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of the array.
C      VALUE   ?     associated value (non character)
C      VALUEC  C*?   associated value (character)
C      IERR    I     Error code, 0=OK.  1=> did not find.,
C                    2= Input error.
C-----------------------------------------------------------------------
      INTEGER   TYPE, DIM(*), VALUE(*), IERR
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC*(*)
C
      INTEGER   IMEM, LOOP, OBJNUM, POINT
      CHARACTER MEMBER*16
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'ARRAY_PNT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Lookup NAME
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Look for base class.member name
C                                       in KEYWRD.
      POINT = INDEX (KEYWRD, '.')
C                                       No base classes exist for this
C                                       class.
      IF (POINT.GE.1) THEN
         IERR = 2
         MSGTXT = 'NO BASE CLASSES FOR CLASS ' // THSCLS
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Save member name
      IF (POINT.LE.0) THEN
         MEMBER = KEYWRD
      ELSE
         MEMBER = KEYWRD(1:POINT-1)
         END IF
C                                       Search list of recognized
C                                       members.
      IMEM = -1
      DO 10 LOOP = 1,NMEML
         IF (MEMBER.EQ.MEMS(LOOP)) IMEM = LOOP
 10      CONTINUE
C                                       Find it?
      IF (IMEM.LE.0) THEN
         IERR = 2
         MSGTXT = 'UNRECOGNIZED ' // THSCLS // ' MEMBER ' // MEMBER
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Fetch value:
         CALL OBGET (OBJNUM, KEYWRD(POINT+1:), TYPE, DIM, VALUE, VALUEC,
     *      IERR)
C                                       Message if not found
         IF (IERR.EQ.1) THEN
            MSGTXT = 'MEMBER ' // MEMBER // ' NOT FOUND'
            CALL MSGWRT (6)
            MSGTXT = 'OBJECT =' // NAME
            CALL MSGWRT (6)
            END IF
C
 999  RETURN
      END
      SUBROUTINE ARPPUT (NAME, KEYWRD, TYPE, DIM, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Public
C   Store array pointer member value.
C   Inputs:
C      NAME    C*?    Object name
C      KEYWRD  C*(*)  Keyword in form 'mem1.mem2...'
C   Outputs:
C      TYPE    I     data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      DIM     I(*)  Dimensionality of the array.
C      VALUE   ?     associated value (non character)
C      VALUEC  C*?   associated value (character)
C      IERR    I     Error code, 0=OK.  1=> did not find.,
C                    2= Input error.
C-----------------------------------------------------------------------
      INTEGER   TYPE, DIM(*), VALUE(*), IERR
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC*(*)
C
      INTEGER   IMEM, LOOP, OBJNUM, POINT
      CHARACTER MEMBER*16
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'ARRAY_PNT.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Lookup NAME
      CALL OBNAME (NAME, OBJNUM, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Look for base class.member name
C                                       in KEYWRD.
      POINT = INDEX (KEYWRD, '.')
C                                       No base classes exist for this
C                                       class.
      IF (POINT.GE.1) THEN
         IERR = 2
         MSGTXT = 'NO BASE CLASSES FOR CLASS ' // THSCLS
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Save member name
      IF (POINT.LE.0) THEN
         MEMBER = KEYWRD
      ELSE
         MEMBER = KEYWRD(1:POINT-1)
         END IF
C                                       Search list of recognized
C                                       members.
      IMEM = -1
      DO 10 LOOP = 1,NMEML
         IF (MEMBER.EQ.MEMS(LOOP)) IMEM = LOOP
 10      CONTINUE
C                                       Find it?
      IF (IMEM.LE.0) THEN
         IERR = 2
         MSGTXT = 'UNRECOGNIZED ' // THSCLS // ' MEMBER ' // MEMBER
         CALL MSGWRT (7)
         GO TO 999
         END IF
C                                       Fetch value:
         CALL OBPUT (OBJNUM, KEYWRD(POINT+1:), TYPE, DIM, VALUE, VALUEC,
     *      IERR)
C                                       Message if not stored
         IF (IERR.NE.0) THEN
            MSGTXT = 'MEMBER ' // MEMBER // ' COULD NOT BE STORED'
            CALL MSGWRT (6)
            MSGTXT = 'OBJECT =' // NAME
            CALL MSGWRT (6)
            END IF
C
 999  RETURN
      END

      SUBROUTINE LEASQR (NP, N, SUM, SSQ, R, M, X, VX, SSQRES,
     *   VARRES, VARY, FIT, IERR)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C     LEASQR does the matrix inversion and other necessary tasks
C     involved in a least squares analysis.
C
C     Given:
C          NP        I     Number of parameters.
C          N         R     The number of observations.
C          SUM       R     Error sum.
C          SSQ       R     Square error sum.
C          R(NP)     R     Results vector.
C
C     Given and returned:
C          M(NP,NP)  R     On input, the upper triangular part contains
C                          the design matrix.  This is not changed.
C                          On output, the lower triangular part contains
C                          the covariance matrix.  Diagonal elements of
C                          the covariance matrix are stored in VX.
C
C     Returned:
C          X(NP)     R     Vector holding the least squares solution.
C          VX(NP)    R     Variance of the best fit parameters.
C          SSQRES    R     Sum of squares of the residuals.
C          VARRES    R     Variance of the residuals.
C          VARY      R     Variance of the error values.
C          FIT       R     Goodness of fit parameter, lies between 0
C                          and 1.
C          IERR      I     Error status, 0 means successful.
C                             1 - nonspecific error return,
C                             2 - insufficient degrees of freedom.
C
C     Called:
C          none
C
C     Algorithm:
C          LU-triangular factorization with scaled partial pivoting.
C          The sub-diagonal triangular matrix contains the scaling
C          factors used at each step in the Gaussian elimination.  Row
C          interchanges are recorded in vectors MXS and SXM.
C             During forward substitution, the pivoting and Gaussian
C          elimination operations performed on matrix M are applied to
C          vector R.  Vector X holds the intermediate result.
C             On backward substitution, successive elements of the
C          solution vector, X, are calculated by substitution of the
C          preceding elements into the equations of the upper triangular
C          factorization of the design matrix.
C
C     Notes:
C       1) Strictly speaking, the design matrix will usually contain
C          rows of zeroes and therefore be singular.  This arises if no
C          observations sensitive to a particular parameter have been
C          done.
C             In practice, any such singularities are ignored and the
C          associated parameters remain undetermined.
C
C       2) The covariance matrix is the inverse of M(i,j) multiplied by
C          the variance of the residuals.  It is obtained by forward and
C          backward substitution on the columns of the unit matrix.
C
C       3) Two statement functions, C, and SC have been employed to
C          partially alleviate the problems posed by passing arrays in
C          FORTRAN.  The design/covariance matrix m(i,j) is copied into
C          the working vector s(i).  This is addressed by using C, and
C          SC in an attempt to make it look like the matrix that it
C          actually represents.
C
C       4) The maximum size problem that LEASQR can handle is set by
C          parameter MX.= 200.
C
C     Author:
C          Mark Calabretta, Australia Telescope.
C          Origin; 1988/Sep/29. Code last modified; 1989/Nov/22.
C-----------------------------------------------------------------------
C     Parameter which determines the maximum size problem.
      INTEGER   MX
      PARAMETER (MX = 200)
C
      INTEGER   C, I, IERR, ITEMP, J, K, MXS(MX), NF, NP, PIVOT,
     *          SXM(MX)
      REAL      COLMAX, DTEMP, FIT, M(NP,NP), N, R(NP), RESIDU, RLEN,
     *          ROWMAX(MX), S(MX*MX), SC, RTEMP, SSQ, SSQRES, SUM,
     *          VARRES, VARY, VX(NP), W(MX), X(NP)
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C     Statement functions for array manipulation, see note 3 above.
      C(I,J)  = NP*(I-1) + J
      SC(I,J) = S(C(I,J))
C-----------------------------------------------------------------------
C  Initialize.
C     Anticipate and return immediately on error.
      IERR = 1

C     Initialize arrays.
      DO 40 I = 1, NP
C        Vector which records row interchanges.
         MXS(I) = I

C        The solution and variance vectors.
         X(I)  = 0.0
         VX(I) = 0.0

C        Copy the design matrix and zero the covariance matrix.
         DO 10 J = 1, I-1
            M(I,J) = 0.0
            S(C(I,J)) = M(J,I)
 10      CONTINUE
         DO 20 J = I, NP
            S(C(I,J)) = M(I,J)
 20      CONTINUE

C        Find the maximum absolute element in each row.
         ROWMAX(I) = 0.0
         DO 30 J = 1, NP
            ROWMAX(I) = MAX(ROWMAX(I), ABS(SC(I,J)))
 30      CONTINUE
 40   CONTINUE

      VARY   = 0.0
      SSQRES = 0.0
      VARRES = 0.0
      FIT    = 0.0


C     Find the number of degrees of freedom.
      NF = N
      DO 60 I = 1, NP
         IF (ROWMAX(I).NE.0.0) THEN
            NF = NF - 1
         ELSE IF (R(I).NE.0.0) THEN
C           Any row of zeroes must extend to the results vector.
            WRITE (MSGTXT,50) I
 50         FORMAT ('LEASQR: Design matrix inconsistency in row',I4)
            CALL MSGWRT (6)
         END IF
 60   CONTINUE

      IF (NF.LE.1) THEN
         WRITE (MSGTXT,70)
 70      FORMAT ('LEASQR: Insufficient degrees of freedom.')
         CALL MSGWRT (6)
         IERR = 2
         RETURN
      END IF


C  Factorize the matrix.
      DO 120 K = 1, NP
C        Check for a row of zeroes.
         IF (ROWMAX(K).EQ.0.0) GO TO 120

C        A non-zero row maximum implies non-zero diagonal element.
         IF (SC(K,K).EQ.0.0) THEN
            WRITE (MSGTXT,50) MXS(K)
            CALL MSGWRT (6)
            GO TO 120
         END IF

C        Decide whether to pivot.
         COLMAX = ABS(SC(K,K))/ROWMAX(K)
         PIVOT = K
         DO 80 I = K+1, NP
            IF (ROWMAX(I).NE.0.0) THEN
               IF (ABS(SC(I,K))/ROWMAX(I).GT.COLMAX) THEN
                  COLMAX = ABS(SC(I,K))/ROWMAX(I)
                  PIVOT = I
               END IF
            END IF
 80      CONTINUE

         IF (PIVOT.GT.K) THEN
C           We must pivot, interchange the rows of the design matrix.
            DO 90 J = 1, NP
               DTEMP = SC(PIVOT,J)
               S(C(PIVOT,J)) = SC(K,J)
               S(C(K,J)) = DTEMP
 90         CONTINUE

C           Don't forget the vector of row maxima.
            DTEMP = ROWMAX(PIVOT)
            ROWMAX(PIVOT) = ROWMAX(K)
            ROWMAX(K) = DTEMP

C           Record the interchange for later use.
            ITEMP = MXS(PIVOT)
            MXS(PIVOT) = MXS(K)
            MXS(K) = ITEMP
         END IF

C        Gaussian elimination.
         DO 110 I = K+1, NP
C           Nothing to do if SC(i,k) is zero.
            IF (SC(I,K).NE.0.0) THEN
C              Save the scaling factor.
               S(C(I,K)) = SC(I,K)/SC(K,K)

C              Subtract rows.
               DO 100 J = K+1, NP
                  S(C(I,J)) = SC(I,J) - SC(I,K)*SC(K,J)
 100           CONTINUE
            END IF
 110     CONTINUE
 120  CONTINUE

C     MXS(i) records which row of M corresponds to row i of SC.
C     SXM(i) records which row of S corresponds to row i of M.
      DO 130 I = 1, NP
         SXM(MXS(I)) = I
 130  CONTINUE


C  Solve the normal equations.
      DO 150 I = 1, NP
C        Forward substitution.
         W(I) = R(MXS(I))
         DO 140 J = 1, I-1
            W(I) = W(I) - SC(I,J)*W(J)
 140     CONTINUE
 150  CONTINUE

      DO 170 I = NP, 1, -1
C        Backward substitution.
         IF (SC(I,I).NE.0.0) THEN
            DO 160 J = I+1, NP
               W(I) = W(I) - SC(I,J)*W(J)
 160        CONTINUE
            W(I) = W(I)/SC(I,I)
         END IF
         X(I) = W(I)
 170  CONTINUE

C     Check that the solution is acceptable.
      RLEN = 0.0
      RESIDU = 0.0
      DO 200 I = 1, NP
         RTEMP = 0.0
         DO 180 J = 1, I-1
            RTEMP = RTEMP + M(J,I)*X(J)
 180     CONTINUE
         DO 190 J = I, NP
            RTEMP = RTEMP + M(I,J)*X(J)
 190     CONTINUE

         RLEN = RLEN + R(I)**2
         RESIDU = RESIDU + (RTEMP - R(I))**2
 200  CONTINUE

      IF (RESIDU.GT.0.001*RLEN) THEN
         WRITE (MSGTXT,210) RESIDU/RLEN
 210     FORMAT ('LEASQR: The solution is discrepant at',E8.1)
         CALL MSGWRT (6)
         RETURN
      END IF


C  Determine goodness-of-fit estimates, and statistical errors.
      SSQRES = SSQ
      DO 220 I = 1, NP
         SSQRES = SSQRES - X(I)*R(I)
 220  CONTINUE
      IF (SSQRES.LT.0.0) SSQRES = 0.0

      VARRES = SSQRES/NF
      VARY = (SSQ - SUM*SUM/N)/(N - 1.0)
      FIT = 1.0
      IF (VARY.NE.0.0) FIT = 1.0 - SSQRES/(SSQ - SUM*SUM/N)

C     Determine the covariance matrix.
      DO 280 K = 1, NP
C        Forward substitution affects only that part of W() below the
C        first non-zero entry.
         DO 230 I = 1, SXM(K)-1
            W(I) = 0.0
 230     CONTINUE
         W(SXM(K)) = 1.0

         DO 250 I = SXM(K)+1, NP
C           Forward substitution.
            W(I) = 0.0
            DO 240 J = SXM(K), I-1
               W(I) = W(I) - SC(I,J)*W(J)
 240        CONTINUE
 250     CONTINUE

         DO 270 I = NP, K, -1
            IF (SC(I,I).NE.0.0) THEN
C              Backward substitution.
               DO 260 J = I+1, NP
                  W(I) = W(I) - SC(I,J)*W(J)
 260           CONTINUE
               W(I) = W(I)/SC(I,I)
            END IF

            IF (I.NE.K) THEN
C              Off diagonal elements of the covariance matrix.
               M(I,K) = VARRES*W(I)
            ELSE IF (I.EQ.K) THEN
C              Diagonal elements of the covariance matrix.
               VX(K)  = VARRES*W(I)
            END IF
 270     CONTINUE
 280  CONTINUE


C  Successful completion.
      IERR = 0


      RETURN
      END

      SUBROUTINE YSCROL (CHANNL, SCROLX, SCROLY, VRTRTC, IERR)
C-----------------------------------------------------------------------
C! write the scroll registers (shift location of 1 or more TV channels)
C# TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YSCROL writes the scroll registers on the TV.
C   Inputs:
C      CHANNL   I   bit map channel select: bits 1-NGRAY gray channels,
C                   bit NGRAY+1 => all graphics
C      VRTRTC   L   T => do it on vertical retrace only
C   In/Out:
C      SCROLX   I   amount of X scroll (>0 to right)
C      SCROLY   I   amount of Y scroll (>0 upwards)
C   Output:
C      IERR     I   error from Z...XF : 0 => ok, 2 => input error
C   YSCROL updates the scroll variables in /TVDEV/ common
C   IVAS version
C-----------------------------------------------------------------------
      INTEGER   CHANNL, SCROLX, SCROLY, IERR
      LOGICAL   VRTRTC
C
      INTEGER   ISCX, ISCY, IC, ITEMP, ZAND, I, JERR, JX, JY, JD,
     *   MAGFAC, JXG, JYG
      INTEGER   FIVASVPZOOMSCROLL
      REAL      TMAG
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       vertical retrace
      CALL YVRTR (VRTRTC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        write: set buffer
      ISCX = MOD (16*MAXXTV(1)-SCROLX, MAXXTV(1))
      ISCY = MOD (16*MAXXTV(2)+SCROLY, MAXXTV(2))
      ISCX = (ISCX / SCXINC) * SCXINC
      ISCY = (ISCY / SCYINC) * SCYINC
      ITEMP = 2 ** NGRAY - 1
      IC = ZAND (CHANNL, ITEMP)
      JD = 0
      IF (IC.GT.0) JD = 1
      IF (IC.NE.CHANNL) JD = JD + 2
C                                       Scroll equivalent
      MAGFAC = 1 + TVZOOM(1)
      IF (MXZOOM.GT.0) MAGFAC = 2 ** TVZOOM(1)
      TMAG = MAGFAC
      JX = (TVZOOM(2)-1.0) * (TMAG-1.0) / TMAG
      JY = (MAXXTV(2)-TVZOOM(3)) * (TMAG-1.0) / TMAG
      JX = JX + ISCX
      JY = JY + ISCY
      IF (JX.LT.0) JX = JX + MAXXTV(1)
      IF (JX.GE.MAXXTV(1)) JX = JX - MAXXTV(1)
      IF (JY.LT.0) JY = JY + MAXXTV(2)
      IF (JY.GE.MAXXTV(2)) JY = JY - MAXXTV(2)
C                                       Graphics off of grey
      JXG = JX
      JYG = JY
      IF ((NGRAY.EQ.2) .AND. ((SYSNAM(:5).EQ.'NRAO1') .OR.
     *   (SYSNAM(:5).EQ.'nrao1'))) THEN
         IF (MAGFAC.EQ.2) JXG = JXG + 1
         IF (MAGFAC.GT.2) JXG = JXG + 2
         IF (JXG.LT.0) JXG = JXG + MAXXTV(1)
         IF (JXG.GE.MAXXTV(1)) JXG = JXG - MAXXTV(1)
         END IF
C                                       Now do IO
      JERR = 0
      IF (IC.GT.0) JERR = FIVASVPZOOMSCROLL (JX, JY, MAGFAC, MAGFAC, 1)
      IF (JERR.NE.0) GO TO 900
      IF (IC.NE.CHANNL) JERR = FIVASVPZOOMSCROLL (JXG, JYG, MAGFAC,
     *   MAGFAC, 2)
      IF (JERR.NE.0) GO TO 900
C                                        reset common scroll record
      IF ((JD.NE.1) .AND. (JD.NE.3)) GO TO 15
         DO 10 I = 1,NGRAY
            TVSCRX(I) = -ISCX
            TVSCRY(I) = ISCY
 10         CONTINUE
 15   IF (JD.LT.2) GO TO 999
         TVSCRX(NGRAY+1) = -ISCX
         TVSCRY(NGRAY+1) = ISCY
         GO TO 999
C                                       Error
 900  CALL YDOERR ('YSCROL', JERR, IERR)
C
 999  RETURN
      END

      SUBROUTINE CONV1 (APCORE, LUN, VOL, FIL, BO, XBUFF1, BUFSZ1,
     *   XBUFF2, BUFSZ2, NX, NY, IERR)
C-----------------------------------------------------------------------
C! First of four routines to convolve two real images.
C# AP-FFT Math Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2000, 2006, 2019
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CONV1 = first of four routines to convolve two real images.
C   In this routine the input image is read in, zero padded, row
C   transformed, partially transposed and written to disk if necessary.
C   Five file are used by CONV1-CONV4: 1=input NX x NY real image,
C   2&3 = scratch (work) file (4*NX x NY+2), 4=Output (NX x NY) file
C   and 5=FFT of convolving image (4*NX x NY+2).
C        If the entire map will fit into the AP the intermediate results
C   are not written to the WORK files.
C   Input:
C     LUN(5)      I    LUNs for files
C     VOL(5)      I    Volume numbers for the files.
C     FIL(5)      C*48 Physical names for the files.
C     BO(5)       I    Block offsets for the files.
C     XBUFF1(),XBUFF2()  R    Work buffers for I/O
C     BUFSZ1,BUFSZ2  I    Size in bytes for XBUFF1 and XBUFF2
C     NX,NY          I    Number of grid cells in X and Y of maps.
C   Output:
C     IERR          I    Return error code, 0=>OK, otherwise failed.
C                        3=>image too small to FFT
C     Partially transformed and transposed file left in the AP or
C     on the WORK file if necessary.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      CHARACTER FIL(5)*48, BADOP*4
      INTEGER   LUN(5), VOL(5), BO(5), BUFSZ1, BUFSZ2, NX, NY, IHALF,
     *   IERR, NX2, NY2, KOFF, KROW, JPASS
      REAL      XBUFF1(*), XBUFF2(*)
      INTEGER   FIND1, FIND2, BIND1, BIND2, BADFIL, WIN(4), IER, J, K,
     *   MPASS, NROW, JAPWRD,  I, ILIM, IT, APSIZ, HALFNX, INDEX, ONENX,
     *   ONEROW, JNDEX, ONENY, NWORD, TWONX, QUATNX, HALFNY, QUATNY
      DOUBLE PRECISION   XNDEX
      LOGICAL   MAP, WAIT, EXCL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DAPM.INC'
      DATA MAP, WAIT, EXCL /2*.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IERR = 0
C                                       Get power of 2 size of AP.
      JAPWRD = PSAPNW
      CALL AP2SIZ (JAPWRD, APSIZ)
C                                       Make sure min. dim .ge. 4
      IF ((NX.GE.4) .AND. (NY.GE.4)) GO TO 5
           WRITE (MSGTXT,1000) NX,NY
           CALL MSGWRT (8)
           IERR = 3
           GO TO 999
C                                       Determine number of AP loads
C                                       required
C                                       Have to zero padd input.
 5    XNDEX = (NX * 2.0) / APSIZ
      MPASS = NY * XNDEX* 2 + 0.0001
C                                       DEBUG
      MPASS = MAX (MPASS, 1)
      IF (MPASS.GT.1) THEN
         MSGTXT = 'APCONV: MORE THAN 1 PASS REQUIRED'
         CALL MSGWRT (9)
         END IF
      NY2 = NY * 2
      NX2 = NX * 2
      TWONX = NX * 4
      HALFNX = NX
      QUATNX = NX / 2
      HALFNY = NY
      QUATNY = NY / 2
      ONENX = NX * 2
      ONENY = NY * 2
      NWORD = 0
C                                       Open input and work file.
      BADFIL = 1
      BADOP = 'OPEN'
      CALL ZOPEN (LUN(1), FIND1, VOL(1), FIL(1), MAP, EXCL, WAIT,
     *   IERR)
      IF (IERR.GT.0) GO TO 900
C                                        Write only on multiple AP loads
      IF (MPASS.LE.1) GO TO 20
         BADFIL = 2
         CALL ZOPEN (LUN(2), FIND2, VOL(2), FIL(2), MAP, EXCL, WAIT,
     *      IERR)
         IF (IERR.GT.0) GO TO 900
 20   BADOP = 'INIT'
C                                       INIT output file.
         WIN(1) = 1
         WIN(2) = 1
         WIN(3) = NX2
         WIN(4) = NY2
C                                        Write only for multiple AP
C                                        loads.
         IF (MPASS.LE.1) GO TO 35
            CALL MINIT ('WRIT', LUN(2), FIND2, NX2, NY2, WIN, XBUFF2,
     *         BUFSZ2, BO(2), IERR)
            IF (IERR.NE.0) GO TO 900
            WIN(2) = NY/2 + 1
 35       WIN(3) = NX
          WIN(4) = NY
C                                       NROW = no. rows loaded at once.
         NROW = APSIZ / NX2
         NROW = MIN (NROW, NY2)
         ONEROW = NROW
C                                       Load second half first.
C                                       Jump to here for first half.
 40      CONTINUE
C                                       INIT Input file.
            CALL MINIT ('READ', LUN(1), FIND1, NX, NY, WIN, XBUFF1,
     *         BUFSZ1, BO(1), IERR)
            IF (IERR.EQ.0) GO TO 50
               BADOP = 'INIT'
               BADFIL = 1
               GO TO 900
 50         ILIM = MPASS / 2
            ILIM = MAX (ILIM, 1)
            DO 120 I = 1,ILIM
               KOFF = ((I-1) * NY2) / MPASS
               IF ((MPASS.GT.1) .AND. (WIN(2).EQ.1)) KOFF = KOFF + NY
C                                       If this whole pass 0 skip
               JPASS = I + MPASS/2
               IF (WIN(2).EQ.1) JPASS = I
               IF (((JPASS.LE.(MPASS/4)) .OR. (JPASS.GT.(3*MPASS/4)))
     *           .AND. (MPASS.GE.4)) GO TO 120
               DO 80 J = 1,NROW
C                                       Compute index
                  K = J
C                                       Following to scramble input
C                                       if MPASS = 1.
                  IF (MPASS.EQ.1) THEN
                     K = J - NY
                     IF (J.LE.NY) K = J + NY
                     END IF
                  INDEX = (K - 1) * ONENX
C                                       Zero row
                  CALL QVCLR (APCORE, INDEX, 1, ONENX)
C                                       Is this a real row?
                  KROW = KOFF + K
                  IF ((KROW.GT.QUATNY) .AND. (KROW.LE.HALFNY+QUATNY))
     *               GO TO 80
C                                       Read
                     CALL MDISK ('READ', LUN(1), FIND1, XBUFF1, BIND1,
     *                  IERR)
                     IF (IERR.EQ.0) GO TO 60
                        IT = (I - 1) * NROW + WIN(3) + J - 1
                        BADOP = 'READ'
                        BADFIL = 1
                        GO TO 900
C                                       Load data in AP, scramble.
 60                  CALL QWR
                     CALL QPUT (APCORE, XBUFF1(BIND1+NX/2), INDEX,
     *                  QUATNX, 2)
                     JNDEX = INDEX + HALFNX + QUATNX
                     CALL QPUT (APCORE, XBUFF1(BIND1), JNDEX, QUATNX, 2)
                     CALL QWD
C                                       Row loaded, do FFT.
                     CALL QRFFT (APCORE, INDEX, ONENX, 1)
 80               CONTINUE
               CALL QWR
C                                       Transpose.
               IHALF = HALFNX
               CALL APXPOS (APCORE, NROW, IHALF, 0, IERR)
               IF (IERR.NE.0) GO TO 990
C                                       Write out from AP to work file.
C                                       Write only on multiple AP loads.
               IF (MPASS.LE.1) GO TO 115
                  DO 110 J = 1,NROW
                     CALL MDISK ('WRIT', LUN(2), FIND2, XBUFF2, BIND2,
     *                  IERR)
                     IF (IERR.EQ.0) GO TO 100
                        IT = WIN(2) + I + J - 1
                        BADOP = 'WRIT'
                        BADFIL = 2
                        GO TO 900
 100                 INDEX = (J - 1) * ONENX
                     CALL QGET (APCORE, XBUFF2(BIND2), INDEX, ONENX, 2)
                     CALL QWD
 110                 CONTINUE
C                                       Roll AP if necessary.
C                                       Roll whole AP memory if
C                                       MPASS=1 otherwise none.
 115           NWORD = 0
               IF (MPASS.EQ.1) NWORD = APSIZ
               CALL QROLL (APCORE, NWORD, XBUFF1, BUFSZ1, IERR)
               IF (IERR.NE.0) GO TO 999
 120           CONTINUE
C                                       Check to see if finished.
            IF (WIN(2).EQ.1) GO TO 130
               WIN(2) = 1
               GO TO 40
C                                       Write only on multiple AP loads
 130     IF (MPASS.LE.1) GO TO 990
            BADFIL = 2
            BADOP = 'FINI'
            CALL MDISK ('FINI', LUN(2), FIND2, XBUFF2, BIND2, IERR)
            IF (IERR.NE.0) GO TO 900
            GO TO 990
C                                       Errors
 900  WRITE (MSGTXT,1900) BADOP, IERR, FIL(BADFIL)
      IF ((BADOP.EQ.'READ') .OR. (BADOP.EQ.'WRIT')) WRITE (MSGTXT,1901)
     *   BADOP, IERR, IT, FIL(BADFIL)
      CALL MSGWRT (8)
C                                       Close files.
 990  IF ((MPASS.GT.1) .AND. (BADOP.NE.'OPEN')) CALL ZCLOSE (LUN(2),
     *   FIND2, IER)
      IF ((BADOP.NE.'OPEN') .OR. (BADFIL.EQ.2)) CALL ZCLOSE (LUN(1),
     *   FIND1, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CONV1: NX OR NY (',I5,',',I5,') LESS THAN 4')
 1900 FORMAT ('CONV1: ',A4,' ERROR',I7,' FILE ',A)
 1901 FORMAT ('CONV1: ',A4,' ERROR',I7,' ROW',I5,' FILE ',A)
      END

      SUBROUTINE YRHIST (MODE, COLOR, INITI, NINT, HISTOG, IERR)
C-----------------------------------------------------------------------
C! read the histogram of the selected TV output color
C# Y2 TV-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YRHIST reads the histogram of the output of a selected OFM of the
C   TV.   Intensity values 0 through OFMOUT may be read.
C   Inputs:
C      MODE    I         selects area to histogram: 0 blotch,
C                        1 not blotch, 2 all, 3 external blotch
C      COLOR   I         bit map of single color (RGB - 4,2,1)
C      INITI   I         first intensity to histo (1 - 1024)
C      NINT    I         # values to get
C   Output:
C      HISTOG  I(NINT)   histogram
C      IERR    I         error code of Z...XF : 0 => ok, 2 => input err
C   No TV (histogram generator) version - stub: level 2 for IIS so far.
C-----------------------------------------------------------------------
      INTEGER   MODE, COLOR, INITI, NINT, HISTOG(*), IERR
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'THERE IS NO TV HISTOGRAM GENERATOR CONFIGURED'
      CALL MSGWRT (8)
C
 999  RETURN
      END

      SUBROUTINE TSKEND (IRET)
C-----------------------------------------------------------------------
C! closes down a task and its files in the WaWa system
C# IO-WaWa
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   WaWa IO system: Terminate a task, including calls to CLENUP and
C   RELPOP if appropriate.  Also close down messages.
C   Inputs:
C      IRET      I      A return code passed to AIPS if task was run
C                       in wait mode: 0 => ok, else => failure.
C   Written by WaWa (last rev 4/21/81).
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   I, IERR, INEXT
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Clear cat, destroy scratch file
      CALL CLENUP
C                                       If error delete all files
C                                       created by MAPCR.  They are
C                                       probably messed up.
      IF ((IRET.EQ.0) .OR. (NCFILE.LE.0)) GO TO 20
         DO 10 I = 1,NCFILE
            IF (FRW(I).EQ.2) CALL MDESTR (FVOL(I), FCNO(I), CATBLK,
     *         WBUFF, INEXT, IERR)
 10         CONTINUE
C                                       Close down message
C                                       Resume AIPS if needed
 20   RQUICK = QUACK.NE.0
      CALL DIETSK (IRET, RQUICK, WBUFF)
C
 999  RETURN
      END

      SUBROUTINE PDINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IPDRNO, PDKOLS, PDNUMV, NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *   POLTYP, IERR)
C-----------------------------------------------------------------------
C! Create/open/initialize antenna polarization spectrum (PD) table
C# EXT-util Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2010, 2012, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes antenna polarization spectrum (PD) extension
C   tables.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                        'WRIT' = create/init for write or read
C                        'READ' = open for read only
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      LUN      I        Logical unit number to use
C   Input/output
C      VER      I        PD file version
C      CATBLK   I(256)   Catalog header block.
C   Input (create) / output (pre-existing)
C      NUMANT   I        Number of antennas
C      NUMPOL   I        Number of polarizations.
C      NUMIF    I        Number of IFs
C      NUMFRQ   I        Number of frequency channels
C      POLTYP   C*8      Polarization solution type:
C                           'APPROX','ORI-ELP','X-Y LIN', 'VLBI'
C   Output:
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      IPDRNO   I        Next scan number, start of the file if 'READ',
C                        the last+1 if WRITE
C      PDKOLS   I(MAXPDC)   The column pointer array in order:
C                        ANTENNA, SUBARRAY, FREQ ID,
C                        REFANT, P_DIFF
C                        REAL 1, IMAG 1, REAL 2, IMAG 2
C     PDNUMV    I(MAXPDC)   Element count in each column.
C     IERR      I        Return error code, 0=>OK, else TABINI or TABIO
C                        error.
C   MAXPDC = 9 only known locally.
C-----------------------------------------------------------------------
C     INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXPDC
      PARAMETER (MAXPDC = 9)
C
      CHARACTER OPCODE*4, POLTYP*8
      INTEGER   BUFFER(*), DISK, CNO, VER, CATBLK(256), LUN, IPDRNO,
     *   PDKOLS(MAXPDC), PDNUMV(MAXPDC), NUMANT, NUMPOL, NUMIF, NUMFRQ,
     *   IERR
C
      HOLLERITH HOLTMP(6)
      CHARACTER TTITLE*56, TITLE(MAXPDC)*24, UNITS(MAXPDC)*8, KEYW(5)*8
      INTEGER   NKEY, NREC, DATP(128,2), NCOL, NTT, DTYP(MAXPDC), NDATA,
     *   KLOCS(5), KEYVAL(6), KEYTYP(5), IPOINT, MSGSAV, I, NC, JERR,
     *   ITRIM, ITEMP(6)
      LOGICAL   DOREAD, NEWFIL
      EQUIVALENCE (ITEMP, HOLTMP)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA NTT /56/
      DATA TTITLE /'AIPS ANTENNA POLARIZATION SPECTRUM TABLE'/
      DATA DTYP /4*14, 5*2/
      DATA TITLE /'ANTENNA', 'SUBARRAY ', 'FREQ ID ', 'REFANT',
     *   'P_DIFF', 'REAL 1 ', 'IMAG 1 ', 'REAL 2 ', 'IMAG 2 '/
      DATA UNITS /9*' '/
      DATA KEYW /'NO_ANT', 'NO_POL', 'NO_IF', 'NO_CHAN', 'POLTYPE'/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NREC = 500
      NKEY = 5
      NDATA = MAXPDC
      CALL FILL (NDATA, 0, PDKOLS)
      CALL FILL (NDATA, 0, PDNUMV)
C                                       Fill in types
      IF (.NOT.DOREAD) THEN
         NCOL = 5 + NUMPOL * 2
         CALL COPY (NDATA, DTYP, DATP(1,2))
C                                       Correct for real/imag
         DATP(5,2) = DTYP(5)
         IF (POLTYP.EQ.'ORI-ELP') DATP(5,2) = DTYP(5) + 10*NUMFRQ*NUMIF
         DATP(6,2) = DTYP(6) + 10*NUMFRQ*NUMIF
         DATP(7,2) = DTYP(7) + 10*NUMFRQ*NUMIF
         DATP(8,2) = DTYP(8) + 10*NUMFRQ*NUMIF
         DATP(9,2) = DTYP(9) + 10*NUMFRQ*NUMIF
      ELSE
         NCOL = 0
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'PD', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'PDINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
      MSGSAV = MSGSUP
C                                       Get number of scans
      IPDRNO = BUFFER(5) + 1
      IF (DOREAD) IPDRNO = 1
      NKEY = 5
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 10 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'PDINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'PDINI', IERR)
               GO TO 990
               END IF
 10         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       Set keyword values
C                                       No. antennas.
         KLOCS(1) = 1
         KEYTYP(1) = 4
         KEYVAL(1) = NUMANT
C                                       No. Polarizations
         KLOCS(2) = 2
         KEYTYP(2) = 4
         KEYVAL(2) = NUMPOL
C                                       No. IFs
         KLOCS(3) = 3
         KEYTYP(3) = 4
         KEYVAL(3) = NUMIF
C                                       No. CHAN
         KLOCS(4) = 4
         KEYTYP(4) = 4
         KEYVAL(4) = NUMFRQ
C                                       polarization solution type
         KLOCS(5) = 5
         KEYTYP(5) = 3
         CALL CHR2H (8, POLTYP, 1, KEYVAL(5))
C                                       Only write if just created.
         CALL TABKEY ('WRIT', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'PDINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         MSGSUP = 32000
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         MSGSUP = MSGSAV
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'PDINI', IERR)
            GO TO 990
            END IF
C                                       Retrieve keyword values
C                                       No. antennas.
         NUMANT = 0
         IPOINT = KLOCS(1)
         IF (IPOINT.GT.0) NUMANT = KEYVAL(IPOINT)
C                                       No. polarizations
         NUMPOL = 0
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. IFs
         NUMIF = 0
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       No. CHAN
         NUMFRQ = 0
         IPOINT = KLOCS(4)
         IF (IPOINT.GT.0) NUMFRQ = KEYVAL(IPOINT)
C                                       polarization solution type
         POLTYP = ' '
         IPOINT = KLOCS(5)
         IF (IPOINT.GT.0) CALL H2CHR (8, 1, KEYVAL(IPOINT), POLTYP)
         END IF
      IERR = 0
C                                      Get array indices
C                                      Cover your ass from FNDCOL -
C                                      close to flush the buffers and
C                                      then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, KEYVAL, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'PDINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'PD', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'PDINI', IERR)
         GO TO 990
         END IF
      CALL FNDCOL (NDATA, TITLE, 24, .TRUE., BUFFER, PDKOLS, JERR)
C                                      Get array indices and no. values
      DO 150 I = 1,NDATA
         IPOINT = PDKOLS(I)
         IF (IPOINT.GT.0) THEN
            PDKOLS(I) = DATP(IPOINT,1)
            PDNUMV(I) = DATP(IPOINT,2) / 10
            IF (PDNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               IF ((I.NE.5) .OR. (POLTYP.EQ.'ORI-ELP')) CALL MSGWRT (6)
               END IF
         ELSE
            PDKOLS(I) = -1
            PDNUMV(I) = 0
            IF ((NUMPOL.GT.1) .OR. (I.LE.NDATA-2)) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1101) TITLE(I)(:NC)
               CALL MSGWRT (6)
               END IF
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('PDINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('PDINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('PDINI: ERROR INITIALIZING POLARIZATION TABLE FOR ',A)
      END

LOCAL INCLUDE 'XPLBUFRS'
      INCLUDE 'INCS:PMAD.INC'
      INTEGER   SCRTCH(256)
      REAL      XBAR, XDATA(MABFSS), BUFF1(MABFSS)
      COMMON /BUFRS/ BUFF1, XDATA, SCRTCH, XBAR
LOCAL END
LOCAL INCLUDE 'XPLOT.INC'
C                                       Local include for XPLOT
      INCLUDE 'XPLBUFRS'
      INTEGER   SEQIN, DISKIN, OLDCNO, JBUFSZ, GRCHN, GR2CHN, NPARM
      REAL      XSEQIN, XDISKI, BLC(7), TRC(7), FCUT, YINC, ZINC,
     *   PIXVAL, PLTYPE, RANGE(2), XDOTV, XGRCHN, XYRATO
      HOLLERITH XNAMEI(3), XCLAIN(2)
      CHARACTER NAMEIN*12, CLAIN*6
      COMMON /INPARM/ XNAMEI, XCLAIN, XSEQIN, XDISKI, BLC, TRC, YINC,
     *   ZINC, FCUT, RANGE, PLTYPE, PIXVAL, XDOTV, XGRCHN, XYRATO
      COMMON /XPLCHR/ NAMEIN, CLAIN
      COMMON /PARMS/ NPARM, SEQIN, DISKIN, OLDCNO, JBUFSZ, GRCHN, GR2CHN
      INCLUDE 'INCS:DCAT.INC'
LOCAL END
      PROGRAM XPLOT
C-----------------------------------------------------------------------
C! Plots rows of an image on a graphics device.
C# Map Spectral Graphics TV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2000, 2005, 2007, 2012, 2014-2015,
C;  Copyright (C) 2024-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   XPLOT plots rows of an image on the TEK graphics screen.
C   AIPS adverbs:
C      INNAME         NAMEIN        Name of input image.
C      INCLASS        CLAIN         Class of input image.
C      INSEQ          SEQIN         Seq. of input image.
C      INDISK         DISKIN        Disk number of input image.
C      BLC(7)         BLC           Bottom left corner of subimage
C                                   of input image.
C      TRC(7)         TRC           Top right corner of subimage.
C      YINC           YINC          Pixel increment on 2nd axis
C      ZINC           ZINC          Pixel increment on 3rd axis
C      FLUX           FCUT          Flux cutoff: > 2 consecutive
C                                   points must > FLUX to plot
C      LTYPE                        Type of labeling: 1 border,
C                                   2 no ticks, 3 standard, 4 rel
C                                   to center, 5 rel to subim cen
C                                   6 map pixels
C      PIXRANGE                     Min,Max of image intensity
C                                   Max <= Min => entire range
C      PIXVAL         PIXVAL        Display only if peak < PIXVAL
C   Programmer Eric W. Greisen based on Cotton's Taffy and Fickling's
C   TKSLICE.   July 1983
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'XPLOT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'XPLOT '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL XPLTIN (PRGM, IRET)
C                                       Call routine that sends data
C                                       to the user routine.
      IF (IRET.EQ.0) CALL XPLTDO (IRET)
C                                       Close down files, etc.
      CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE XPLTIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   XPLTIN gets input parameters for XPLOT
C   Inputs:  PRGN    C*6       Program name
C   Output:  IRET    I         Error code: 0 => ok
C                                4 => user routine detected error.
C                                5 => catalog troubles
C                                8 => can't start
C            /MAPHDR/ file catalog header
C-----------------------------------------------------------------------
      CHARACTER PRGN*6
      INTEGER   IRET
C
      CHARACTER STAT*4, MTYPE*2
      INTEGER   IERR, I
      REAL      EPS
      INCLUDE 'XPLOT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = 2 * MABFSS
      IRET = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
C                                       Get input parameters.
      NPARM = 31
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         END IF
C                                       Using the TEK?
      IF ((NPOPS.GT.NINTRN) .OR. ((NTKDEV.LE.0) .AND. (XDOTV.LE.-2.0))
     *   .OR. ((NTVDEV.LE.0) .AND. (XDOTV.GT.0.0))) THEN
         IRET = 8
         WRITE (MSGTXT,1010)
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (IRET.EQ.0) RQUICK = .FALSE.
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      EPS = 0.1
      SEQIN = XSEQIN + EPS
      DISKIN = XDISKI + EPS
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      MTYPE = 'MA'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, MTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
C                                       Read CATBLK and mark 'READ'.
      STAT = 'READ'
      IF ((XDOTV.GT.-2.0) .AND. (XDOTV.LE.0.0)) STAT = 'WRIT'
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      IF (STAT.EQ.'WRIT') FRW(NCFILE) = 1
C                                       Set defaults on BLC,TRC
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       check parms -> defaults
      IRET = 4
      I = YINC + 0.01
      IF (I.LE.0) I = 1
      YINC = I
      I = ZINC + 0.01
      IF (I.LE.0) I = 1
      ZINC = I
C      IF (FCUT.LE.0.0) FCUT = 0.0005
      IF (PIXVAL.LE.FCUT) PIXVAL = 100000.
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XPLTIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('NO TV OR TEK OR NOT ALLOWED IN BATCH')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I3,' DISK=',
     *   I2,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE XPLTDO (IRET)
C-----------------------------------------------------------------------
C   XPLTDO sends image one row at a time to the plotting routine
C   Output: IRET   I    Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER IFILE*48
      INTEGER   IROUND, LUNI, NYI, NXI, WINI(4), BOI, LIM2, LIM3, LIM4,
     *   LIM5, LIM6, LIM7, I1, I2, I3, I4, I5, I6, I7, IPOS(7), BOTEMP,
     *   IBIND, INDI, LIM1, IINC2, IINC3
      REAL      PLTODO, PLDONE
      LOGICAL   T, F
      INCLUDE 'XPLOT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNI /16/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Open and init for read
      CALL ZPHFIL ('MA', DISKIN, OLDCNO, 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, T, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Setup for I/O
      NXI = CATBLK(KINAX)
      NYI = CATBLK(KINAX+1)
      WINI(1) = IROUND (BLC(1))
      WINI(2) = IROUND (BLC(2))
      WINI(3) = IROUND (TRC(1))
      WINI(4) = IROUND (TRC(2))
C                                       Setup for looping
      LIM1 = TRC(1) - BLC(1) + 1.01
      LIM2 = TRC(2) - BLC(2) + 1.01
      LIM3 = TRC(3) - BLC(3) + 1.01
      LIM4 = TRC(4) - BLC(4) + 1.01
      LIM5 = TRC(5) - BLC(5) + 1.01
      LIM6 = TRC(6) - BLC(6) + 1.01
      LIM7 = TRC(7) - BLC(7) + 1.01
      IINC2 = YINC + 0.01
      IINC3 = ZINC + 0.01
      PLDONE = 0.0
      PLTODO = REAL(LIM7) * REAL(LIM4) * REAL(LIM5) * REAL(LIM6)
      PLTODO = PLTODO * ((LIM3 - 1) / IINC3 + 1)
C                                       Loop
      DO 700 I7 = 1,LIM7
         IPOS(7) = BLC(7) + I7 - 0.9
         DO 600 I6 = 1,LIM6
            IPOS(6) = BLC(6) + I6 - 0.9
            DO 500 I5 = 1,LIM5
               IPOS(5) = BLC(5) + I5 - 0.9
               DO 400 I4 = 1,LIM4
                  IPOS(4) = BLC(4) + I4 - 0.9
                  DO 300 I3 = 1,LIM3,IINC3
                     IPOS(3) = BLC(3) + I3 - 0.9
                     PLDONE = PLDONE + 1
                     WRITE (MSGTXT,1090) PLDONE, PLTODO
                     CALL MSGWRT (1)
C                                       Init. files, first input.
                     CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IPOS(3),
     *                  BOTEMP, IRET)
                     IF (IRET.GT.0) THEN
                        WRITE (MSGTXT,1099) IRET
                        GO TO 990
                        END IF
                     BOI = BOTEMP + 1
                     CALL MINIT ('READ', LUNI, INDI, NXI, NYI, WINI,
     *                  BUFF1, JBUFSZ, BOI, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1100) 'READ', IRET
                        GO TO 990
                        END IF
                     DO 250 I2 = 1,LIM2
                        IPOS(2) = BLC(2) + I2 - 0.9
                        IPOS(1) = IROUND (BLC(1))
C                                       Read.
                        CALL MDISK ('READ', LUNI, INDI, BUFF1, IBIND,
     *                     IRET)
                        IF (IRET.NE.0) THEN
                           WRITE (MSGTXT,1120) 'READ', IRET
                           GO TO 990
                           END IF
C                                       Want this row?
                        IF (MOD(I2-1,IINC2).EQ.0) THEN
C                                       Copy to buffer.
                           DO 160 I1 = 1,LIM1
                              XDATA(I1) = BUFF1(IBIND+I1-1)
 160                          CONTINUE
C                                       Call DO1PLT
                           CALL DO1PLT (IPOS, IRET)
                           IF (IRET.LT.0) THEN
                              GO TO 710
                           ELSE IF (IRET.GT.0) THEN
                              WRITE (MSGTXT,1180) IRET
                              GO TO 990
                              END IF
                           END IF
 250                    CONTINUE
 300                 CONTINUE
 400              CONTINUE
 500           CONTINUE
 600        CONTINUE
 700     CONTINUE
C                                       Close files
 710  CALL ZCLOSE (LUNI, INDI, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('XPLTDO: ERROR',I3,' OPENING INPUT FILE')
 1090 FORMAT ('Begin plane',F8.0,' of',F8.0)
 1099 FORMAT ('XPLTDO: COMOFF ERROR',I3)
 1100 FORMAT ('XPLTDO: INIT-FOR-',A4,' ERROR',I3)
 1120 FORMAT ('XPLTDO: ',A4,' ERROR',I3)
 1180 FORMAT ('XPLTDO: DO1PLT ERROR',I3)
      END
      SUBROUTINE DO1PLT (IPOS, IRET)
C-----------------------------------------------------------------------
C   DO1PLT calls the TEK, TV or plot file routines
C   Inputs:
C      IPOS(7)   I    BLC (input image) of first value in XDATA
C   Values from commons:
C      XDATA(*)  R    Input row, magic value blanked.
C      FBLANK    R    Value of blanked pixel.
C      CATBLK    I    Input catalog header (also CATR, CATD)
C   Output:
C      IRET      I    Return code   0 => OK
C                               <0 => user requests end
C                               >0 => error, terminate.
C   Output in COMMON
C     CATBLK     I    Catalog header block
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), IRET
C
      INTEGER   INPTS, LABEL, TKERR, FVEC(512), IERR
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'XPLOT.INC'
      INCLUDE 'INCS:DTKS.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Not last call
      IF (IPOS(1).GE.0) THEN
         INPTS = TRC(1) - BLC(1) + 1.01
         XBAR = IPOS(1) - 1 - CATR(KRCRP)
         CALL XPLTGE (INPTS, FCUT, PIXVAL, IERR)
C                                       Plot it
         IF (IERR.EQ.0) THEN
            LABEL = ABS (PLTYPE)
            IF (MOD(LABEL,100).LE.0) LABEL = (LABEL/100)*100 + 3
            IF (XDOTV.LE.-2.0) THEN
               CALL PTKINI (IPOS, INPTS, LABEL, RANGE, FVEC, TKERR)
            ELSE IF (XDOTV.GT.1.0) THEN
               CALL PTVINI (IPOS, INPTS, LABEL, RANGE, XGRCHN, TKERR)
            ELSE
               CALL PLOTIT (IPOS, INPTS, LABEL, RANGE, XGRCHN, TKERR)
               END IF
            IRET = TKERR
            IF (TKERR.EQ.102) IRET = -1
            END IF
         END IF
C
 999  RETURN
      END
      SUBROUTINE XPLTGE (ND, FC, PIXVAL, IERR)
C-----------------------------------------------------------------------
C   XPLTGE decides if the data are intense enough to plot.
C   Inputs:
C      ND       I   Number of data samples
C      FC       R   Flux cutoff
C      PIXVAL   R   No plot if peak > PIXVAL
C   Output:
C      IERR     I   0 => ok, 1 => all data too low
C-----------------------------------------------------------------------
      INTEGER   ND, IERR
      REAL      FC, PIXVAL
C
      INTEGER   IM, I
      REAL      X, XM, BLP, BLM, BL
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'XPLBUFRS'
C-----------------------------------------------------------------------
      IM = 0
      XM = 0.
      DO 40 I = 2,ND-1
         BL = XDATA(I)
         IF ((BL.NE.FBLANK) .AND. (BL.GE.FC)) THEN
            BLM = XDATA(I-1)
            BLP = XDATA(I+1)
            IF ((BLP.NE.FBLANK) .AND. (BLM.NE.FBLANK) .AND. (BLP.GE.FC)
     *         .AND. (BLM.GE.FC)) THEN
               X = BLP + BL + BLM
               IF (X.GE.XM) THEN
                  XM = X
                  IM = I
                  END IF
               END IF
            END IF
 40      CONTINUE
C                                       Find anything?
      IERR = 1
C                                       test desire to plot
      IF (IM.GE.1) THEN
         IF (XM/3.0.LE.PIXVAL) IERR = 0
         END IF
C
 999  RETURN
      END
      SUBROUTINE PTKINI (IPOS, INPTS, LABEL, PIXR, FVEC, IERR)
C-----------------------------------------------------------------------
C   PTKINI initializes the TEK for a XPLOT plot, plots axis labels,
C   and, plots the data.
C   Inputs:
C      IPOS    I(7)     Position in cube first point in row.
C      INPTS   I        Number of points in row.
C      LABEL   I        Requested label type
C      PIXR    R(2)     Requested plot value range
C   Output:
C      FVEC    I(512)   Scratch buffer
C      IERR    I        > 0 => plot failed
C                             102 => DIE
C   Common:
C      TKLUN   I        LUN for open TEK
C      TKIND   I        FTAB pointer for TEK
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), INPTS, LABEL, FVEC(512), IERR
      REAL      PIXR(2)
C
      CHARACTER TEMP*4, TEXT(2)*80, MSGBUF*132
      REAL      ORANGE(2), XBLC(7), XTRC(7), PBLC(2), PTRC(2), YGAP,
     *   CH(4), XYRATO, X, XX, Y, YFAC, YOFF, DX, DY, FQFINC
      INTEGER   IDROP(2), IX1, IX2, IY1, IY2, ICHL, ICHB, ICHR, ICHT,
     *   NXA, NYA, I, J, JERR, TTYLUN, TTYIND, IPLANE, I4XTRA, NTEXT
      LOGICAL   T, F, BLAST, BNEXT
      DOUBLE PRECISION FQFREQ
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTKS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'XPLBUFRS'
      DATA T, F /.TRUE.,.FALSE./
      DATA TTYLUN /5/
C-----------------------------------------------------------------------
C                                       inits, open TEK
      CALL ZTKOPN (IERR)
      IF (IERR.NE.0) GO TO 999
      CALL TKCATL ('INIT', I, I, FVEC, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       "Slice" corners
      IDROP(1) = 0
      IDROP(2) = 0
      DO 10 I = 1,7
         XBLC(I) = IPOS(I)
         XTRC(I) = XBLC(I)
 10      CONTINUE
      XTRC(1) = XBLC(1) + INPTS - 1
C                                       Set PIX ranges
      ORANGE(1) = PIXR(1)
      ORANGE(2) = PIXR(2)
C                                       Default: actual range
      IF (PIXR(2).LE.PIXR(1)) THEN
         ORANGE(1) = 1.0E10
         ORANGE(2) = -ORANGE(1)
         DO 15 I = 1,INPTS
            IF (XDATA(I).NE.FBLANK) THEN
               ORANGE(1) = MIN (ORANGE(1), XDATA(I))
               ORANGE(2) = MAX (ORANGE(2), XDATA(I))
               END IF
 15         CONTINUE
         YFAC = ORANGE(2) - ORANGE(1)
         ORANGE(2) = ORANGE(2) + 0.25  * YFAC
         ORANGE(1) = ORANGE(1) - 0.25  * YFAC
         END IF
      CATR(IRRAN) = ORANGE(1)
      CATR(IRRAN+1) = ORANGE(2)
      YFAC = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      YOFF = 40000.0 - YFAC * CATR(IRRAN)
      PBLC(2) = ORANGE(1) * YFAC + YOFF
      PTRC(2) = ORANGE(2) * YFAC + YOFF
C                                       Label inits
      LOCNUM = 1
      FQFINC = 0.0
      FQFREQ = 0.0D0
      CALL SLBINI (IDROP, INPTS, ORANGE, PBLC, PTRC, XBLC, XTRC,
     *   FQFREQ, FQFINC, CATBLK(IIDEP), LABEL, YGAP, CH, TEXT, NTEXT)
      ORANGE(1) = YFAC*ORANGE(1) + YOFF
      ORANGE(2) = YFAC*ORANGE(2) + YOFF
      XYRATO = (PTRC(2) - PBLC(2)) / (PTRC(1) - PBLC(1))
      IX1 = PBLC(1) + .5
      IY1 = PBLC(2) + .5
      IX2 = PTRC(1) + .5
      IY2 = PTRC(2) + .5
      ICHL = CH(1) * CSIZTK(1) + .5
      ICHB = CH(2) * CSIZTK(2) + .5
      ICHR = CH(3) * CSIZTK(1) + .5
      ICHT = CH(4) * CSIZTK(2) + .5
      NYA = MAXXTK(2) - ICHT -ICHB -1
      NXA = MAXXTK(1) - ICHL - ICHR - 1
C                                       compute scaling
      X = IX2
      X = ABS (X - IX1)
      XX = X * XYRATO
      Y = IY2
      Y = ABS (Y - IY1)
      IF ((XX.LE.0.0) .OR. (Y.LE.0.0)) THEN
         WRITE (MSGTXT,1020)
         CALL MSGWRT (8)
         IERR = 1
         GO TO 999
         END IF
      IF ((XX/Y).LE.FLOAT(NXA)/FLOAT(NYA)) THEN
         SCALEY = NYA / Y
         SCALEX = SCALEY * Y / X
      ELSE
         SCALEX = NXA / X
         SCALEY = SCALEX * X / Y
         END IF
C
      NXA = SCALEX * X + ICHL + ICHR
      RX0 = ICHL + MAX (0, MAXXTK(1)-NXA) / 2 + 1
      NYA = SCALEY * Y + ICHB + ICHT
      RY0 = ICHB + MAX (0, MAXXTK(2)-NYA) / 2 + 1
C                                       Put stuff in image catalog.
      CATBLK(IIWIN  ) = IX1
      CATBLK(IIWIN+1) = IY1
      CATBLK(IIWIN+2) = IX2
      CATBLK(IIWIN+3) = IY2
      CATBLK(IICOR  ) = RX0 + 0.5
      CATBLK(IICOR+1) = RY0 + 0.5
      CATBLK(IICOR+2) = RX0 + X * SCALEX + 0.5
      CATBLK(IICOR+3) = RY0 + Y * SCALEY + 0.5
      CATBLK(IIPLT) = 5
      CATBLK(IIOTH) = LABEL
      CATBLK(IIOTH+1) = IDROP(1)
      CATBLK(IIOTH+2) = IDROP(2)
      I4XTRA = IIOTH + 3
      CATR(I4XTRA  ) = XBLC(1)
      CATR(I4XTRA+1) = XBLC(2)
      CATR(I4XTRA+2) = XTRC(1)
      CATR(I4XTRA+3) = XTRC(2)
      CALL TKCATL ('WRIT', IPLANE, IPLANE, CATBLK, IERR)
C                                       set scale for plot routines
      RX0 = RX0 - PBLC(1) * SCALEX + .5
      RY0 = RY0 - PBLC(2) * SCALEY + .5
C                                       label the plot
      CALL TKLAB (PBLC, PTRC, LABEL, YGAP, TEXT, NTEXT, CH, F, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       add pixel coordinates
      DX = -8.5
      DY = -2.0
      CALL TEKVEC (PTRC(1), PTRC(2), 1, IERR)
      IF (IERR.NE.0) GO TO 990
      WRITE (MSGBUF,1060) IPOS(2)
      J = 7
      CALL TKCHAR (J, 0, DX, DY, MSGBUF, IERR)
      IF (IERR.NE.0) GO TO 990
      DY = DY - 1.5
      CALL TEKVEC (PTRC(1), PTRC(2), 1, IERR)
      IF (IERR.NE.0) GO TO 990
      WRITE (MSGBUF,1061) IPOS(3)
      CALL TKCHAR (J, 0, DX, DY, MSGBUF, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       plot data
      BLAST = .TRUE.
      DO 70 I = 1,INPTS
         BNEXT = XDATA(I).EQ.FBLANK
         IF (.NOT.BNEXT) THEN
            X = I - 0.5
            Y = XDATA(I) * YFAC + YOFF
            Y = MIN (ORANGE(2), MAX (ORANGE(1), Y))
            J = 2
            IF (BLAST) J = 1
            CALL TEKVEC (X, Y, J, IERR)
            IF (IERR.NE.0) GO TO 990
            X = I + 0.5
            J = 2
            CALL TEKVEC (X, Y, J, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
         BLAST = BNEXT
 70      CONTINUE
C                                       alpha mode
      I = 31
      CALL ZTKBUF (I, 1, IERR)
      CALL TEKFLS (IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Talk to user
      CALL ZOPEN (TTYLUN, TTYIND, 1, MSGBUF, F, T, T, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1900) JERR
         CALL MSGWRT (6)
         GO TO 990
         END IF
      WRITE (MSGBUF,1910)
      CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, JERR)
      IF (JERR.NE.0) GO TO 920
      CALL ZTTYIO ('READ', TTYLUN, TTYIND, 72, MSGBUF, JERR)
      IF (JERR.NE.0) GO TO 920
      READ (MSGBUF,1911) TEMP
      IF ((TEMP(1:1).EQ.'Q') .OR. (TEMP(1:1).EQ.'q')) IERR = 102
      GO TO 930
C                                       TTY error
 920  WRITE (MSGTXT,1920) JERR
      CALL MSGWRT (6)
 930  CALL ZCLOSE (TTYLUN, TTYIND, JERR)
C                                       Close all the time
 990  CALL ZTKCLS (JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('SCALING ERROR.')
 1060 FORMAT ('Y=',I5)
 1061 FORMAT ('Z=',I5)
 1900 FORMAT ('OPEN TERMINAL ERROR',I7)
 1910 FORMAT ('**** Type QUIT to end task, hit return to proceed')
 1911 FORMAT (A4)
 1920 FORMAT ('TERMINAL I/O ERROR',I7)
      END
      SUBROUTINE PTVINI (IPOS, INPTS, LABEL, PIXR, GRCHAN, IERR)
C-----------------------------------------------------------------------
C   PTVINI initializes the TV for a XPLOT plot, plots axis labels,
C   and, plots the data.
C   Inputs:
C      IPOS     I(7)     Position in cube first point in row.
C      INPTS    I        Number of points in row.
C      LABEL    I        Requested label type
C      PIXR     R(2)     Requested plot value range
C      GRCHAN   R        User adverb selects graphics channel.
C   Output:
C      IERR     I        > 0 => plot failed
C                             102 => DIE
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), INPTS, LABEL, IERR
      REAL      PIXR(2), GRCHAN
C
      CHARACTER TEMP*4, TEXT(2)*80, MSGBUF*132
      REAL      ORANGE(2), XBLC(7), XTRC(7), PBLC(2), PTRC(2), YGAP,
     *   CH(4), XYRATO, X, XX, Y, YFAC, YOFF, DX, DY, FQFINC
      INTEGER   IDROP(2), IX1, IX2, IY1, IY2, ICHL, ICHB, ICHR, ICHT,
     *   NXA, NYA, I, J, JERR, TTYLUN, TTYIND, I4XTRA, IDX, IDY,
     *   TVWIND(4), TVSIZE(2), NTEXT
      LOGICAL   T, F, BLAST, BNEXT, FIRST
      DOUBLE PRECISION FQFREQ
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DTVS.INC'
      INCLUDE 'XPLBUFRS'
      SAVE FIRST
      DATA T, F /.TRUE.,.FALSE./
      DATA FIRST /.TRUE./
      DATA TTYLUN /5/
C-----------------------------------------------------------------------
C                                       inits, open TEK
      CALL TVOPEN (SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 999
      IGR = GRCHAN + 0.01
      IGR = MOD (IGR,10)
      IF (IGR.LE.0) IGR = 1
      IF (IGR.GT.7) IGR = 1
      IGR = IGR + NGRAY
      CALL YHOLD ('ONNN', IERR)
      IF (FIRST) THEN
         DO 10 I = 1,NGRAY+NGRAPH
            CALL YSLECT ('OFFF', I, 0, SCRTCH, IERR)
            IF (IERR.NE.0) GO TO 990
 10         CONTINUE
         CALL YSLECT ('ONNN', IGR, 0, SCRTCH, IERR)
         IF (IERR.NE.0) GO TO 990
         FIRST = .FALSE.
         END IF
C                                       "Slice" corners
      IDROP(1) = 0
      IDROP(2) = 0
      DO 15 I = 1,7
         XBLC(I) = IPOS(I)
         XTRC(I) = XBLC(I)
 15   CONTINUE
      XTRC(1) = XBLC(1) + INPTS - 1
C                                       Set PIX ranges
      ORANGE(1) = PIXR(1)
      ORANGE(2) = PIXR(2)
C                                       Default: actual range
      IF (PIXR(2).LE.PIXR(1)) THEN
         ORANGE(1) = 1.0E10
         ORANGE(2) = -ORANGE(1)
         DO 20 I = 1,INPTS
            IF (XDATA(I).NE.FBLANK) THEN
               ORANGE(1) = MIN (ORANGE(1), XDATA(I))
               ORANGE(2) = MAX (ORANGE(2), XDATA(I))
               END IF
 20            CONTINUE
         YFAC = ORANGE(2) - ORANGE(1)
         ORANGE(2) = ORANGE(2) + 0.02  * YFAC
         ORANGE(1) = ORANGE(1) - 0.02  * YFAC
         END IF
      CATR(IRRAN) = ORANGE(1)
      CATR(IRRAN+1) = ORANGE(2)
      YFAC = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      YOFF = 40000.0 - YFAC * CATR(IRRAN)
      PBLC(2) = ORANGE(1) * YFAC + YOFF
      PTRC(2) = ORANGE(2) * YFAC + YOFF
C                                       Label inits
      LOCNUM = 1
      FQFINC = 0.0
      FQFREQ = 0.0D0
      CALL SLBINI (IDROP, INPTS, ORANGE, PBLC, PTRC, XBLC, XTRC,
     *   FQFREQ, FQFINC, CATBLK(IIDEP), LABEL, YGAP, CH, TEXT, NTEXT)
      ORANGE(1) = YFAC*ORANGE(1) + YOFF
      ORANGE(2) = YFAC*ORANGE(2) + YOFF
      XYRATO = (PTRC(2) - PBLC(2)) / (PTRC(1) - PBLC(1))
      IX1 = PBLC(1) + .5
      IY1 = PBLC(2) + .5
      IX2 = PTRC(1) + .5
      IY2 = PTRC(2) + .5
      ICHL = CH(1) * CSIZTV(1) + .5
      ICHB = CH(2) * CSIZTV(2) + .5
      ICHR = CH(3) * CSIZTV(1) + .5
      ICHT = CH(4) * CSIZTV(2) + .5
      CALL YWINDO ('READ', TVWIND, IERR)
      IF (IERR.NE.0) THEN
         TVWIND(1) = 1
         TVWIND(2) = 1
         TVWIND(3) = MAXXTV(1)
         TVWIND(4) = MAXXTV(2)
         END IF
      TVSIZE(1) = TVWIND(3) - TVWIND(1) + 1
      TVSIZE(2) = TVWIND(4) - TVWIND(2) + 1
      NYA = TVSIZE(2) - ICHT -ICHB -1
      NXA = TVSIZE(1) - ICHL - ICHR - 1
C                                       compute scaling
      X = IX2
      X = ABS (X - IX1)
      XX = X * XYRATO
      Y = IY2
      Y = ABS (Y - IY1)
      IF ((XX.LE.0.0) .OR. (Y.LE.0.0)) THEN
         WRITE (MSGTXT,1020)
         CALL MSGWRT (8)
         IERR = 1
         GO TO 990
         END IF
      IF ((XX/Y).LE.FLOAT(NXA)/FLOAT(NYA)) THEN
         SCALEY = NYA / Y
         SCALEX = SCALEY * Y / X
      ELSE
         SCALEX = NXA / X
         SCALEY = SCALEX * X / Y
         END IF
C
      NXA = SCALEX * X + ICHL + ICHR
      RX0 = ICHL + MAX (0, TVSIZE(1)-NXA) / 2 + TVWIND(1)
      NYA = SCALEY * Y + ICHB + ICHT
      RY0 = ICHB + MAX (0, TVSIZE(2)-NYA) / 2 + TVWIND(2)
C                                       Put stuff in image catalog.
      CATBLK(IIWIN  ) = IX1
      CATBLK(IIWIN+1) = IY1
      CATBLK(IIWIN+2) = IX2
      CATBLK(IIWIN+3) = IY2
      CATBLK(IICOR  ) = RX0 + 0.5
      CATBLK(IICOR+1) = RY0 + 0.5
      CATBLK(IICOR+2) = RX0 + X * SCALEX + 0.5
      CATBLK(IICOR+3) = RY0 + Y * SCALEY + 0.5
      CATBLK(IIPLT) = 5
      CATBLK(IIOTH) = LABEL
      CATBLK(IIOTH+1) = IDROP(1)
      CATBLK(IIOTH+2) = IDROP(2)
      I4XTRA = IIOTH + 3
      CATR(I4XTRA  ) = XBLC(1)
      CATR(I4XTRA+1) = XBLC(2)
      CATR(I4XTRA+2) = XTRC(1)
      CATR(I4XTRA+3) = XTRC(2)
C                                       Update image catalog
      CALL YCINIT (IGR, SCRTCH)
      CALL YCWRIT (IGR, CATBLK(IICOR), CATBLK, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040)
         CALL MSGWRT (6)
         END IF
C                                       clear screen
      CALL YZERO (IGR, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       set scale for plot routines
      RX0 = RX0 - PBLC(1) * SCALEX + .5
      RY0 = RY0 - PBLC(2) * SCALEY + .5
C                                       label the plot
      CALL TVLAB (PBLC, PTRC, LABEL, YGAP, TEXT, NTEXT, CH, F, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       add pixel coordinates
      DX = PTRC(1)*SCALEX + RX0 - 8.5 * CSIZTV(1)
      DY = PTRC(2)*SCALEY + RY0 - 2.0 * CSIZTV(2)
      WRITE (MSGBUF,1060) IPOS(2)
      IDX = DX + 0.5
      IDY = DY + 0.5
      CALL IMCHAR (IGR, IDX, IDY, 0, 0, MSGBUF(:7), INBUF, IERR)
      IF (IERR.NE.0) GO TO 990
      DY = DY - 1.5 * CSIZTV(2)
      WRITE (MSGBUF,1061) IPOS(3)
      IDY = DY + 0.5
      CALL IMCHAR (IGR, IDX, IDY, 0, 0, MSGBUF(:7), INBUF, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       plot data
      BLAST = .TRUE.
      DO 70 I = 1,INPTS
         BNEXT = XDATA(I).EQ.FBLANK
         IF (.NOT.BNEXT) THEN
            X = I - 0.5
            Y = XDATA(I) * YFAC + YOFF
            Y = MIN (ORANGE(2), MAX (ORANGE(1), Y))
            J = 2
            IF (BLAST) J = 1
            CALL TVVEC (X, Y, J, IERR)
            IF (IERR.NE.0) GO TO 990
            X = I + 0.5
            J = 2
            CALL TVVEC (X, Y, J, IERR)
            IF (IERR.NE.0) GO TO 990
            END IF
         BLAST = BNEXT
 70      CONTINUE
C                                       Talk to user
      CALL YHOLD ('OFFF', JERR)
      CALL ZOPEN (TTYLUN, TTYIND, 1, MSGBUF, F, T, T, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1900) JERR
         CALL MSGWRT (6)
         GO TO 990
         END IF
      WRITE (MSGBUF,1910)
      CALL ZTTYIO ('WRIT', TTYLUN, TTYIND, 72, MSGBUF, JERR)
      IF (JERR.NE.0) GO TO 920
      CALL ZTTYIO ('READ', TTYLUN, TTYIND, 72, MSGBUF, JERR)
      IF (JERR.NE.0) GO TO 920
      READ (MSGBUF,1911) TEMP
      IF ((TEMP(1:1).EQ.'Q') .OR. (TEMP(1:1).EQ.'q')) IERR = 102
      GO TO 930
C                                       TTY error
 920  WRITE (MSGTXT,1920) JERR
      CALL MSGWRT (6)
 930  CALL ZCLOSE (TTYLUN, TTYIND, JERR)
C                                       Close all the time
 990  CALL YHOLD ('OFFF', JERR)
      CALL TVCLOS (SCRTCH, JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('SCALING ERROR.')
 1040 FORMAT ('TV IMAGE CATALOG ERROR.')
 1060 FORMAT ('Y=',I5)
 1061 FORMAT ('Z=',I5)
 1900 FORMAT ('OPEN TERMINAL ERROR',I7)
 1910 FORMAT ('**** Type QUIT to end task, hit return to proceed')
 1911 FORMAT (A4)
 1920 FORMAT ('TERMINAL I/O ERROR',I7)
      END
      SUBROUTINE PLOTIT (IPOS, INPTS, LABEL, PIXR, GRCHAN, IRET)
C-----------------------------------------------------------------------
C   PLOTIT makes an XPLOT style plot using the full plot package.
C   Inputs:
C      IPOS     I(7)     Position in cube first point in row.
C      INPTS    I        Number of points in row.
C      LABEL    I        Requested label type
C      PIXR     R(2)     Requested plot value range
C      GRCHAN   R        User adverb selects graphics channel.
C   Output:
C      IERR     I        > 0 => plot failed
C                             102 => DIE
C-----------------------------------------------------------------------
      INTEGER   IPOS(7), INPTS, LABEL, IRET
      REAL      PIXR(2), GRCHAN
C
      INCLUDE 'XPLOT.INC'
      REAL      ORANGE(2), XBLC(7), XTRC(7), PBLC(2), PTRC(2), YGAP,
     *   CH(4), X, Y, YFAC, YOFF, DX, DY, FQFINC, INCR, OFY, RPIX,
     *   RANGE2(2), SCALY, XYRATI, XSEP
      INTEGER   IDROP(2), I, IERR, PLUN, PIND, PVER, NTEXT, PLBUFF(256),
     *   IPTYPE, TVCHN, TVCORN(4), INCHAR, ID(3), IT(3), NCHAR
      LOGICAL   T, F, DOTV, DOCENT, PENUP
      DOUBLE PRECISION FQFREQ, RVAL
      CHARACTER PLNAME*48, TEXT(2)*80, SPRTXT*80, CTEMP*20, ATIME*8,
     *   ADATE*12
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA TVCHN, TVCORN /1, 4*0/
C-----------------------------------------------------------------------
      DOCENT = T
      DOTV = XDOTV.GT.0.0
      GR2CHN = GRCHAN/10.0 + 0.01
      GRCHN = GRCHAN - 10.0*GR2CHN
      IF (XYRATO.LE.0.0) XYRATO = 1.4
C                                       Add plot file to CATBLK
      PVER = 0
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', DISKIN, OLDCNO, CATBLK, BUFF1, .TRUE.,
     *      'UPDT', PVER, IRET)
         IF (IRET.EQ.0) THEN
            WRITE (MSGTXT,1010) PVER
            CALL MSGWRT (6)
         ELSE
            WRITE (MSGTXT,1000) IRET, 'ADDING PLOT FILE TO HEADER'
            GO TO 990
            END IF
         END IF
C                                       Generate the plot file name
      CALL ZPHFIL ('PL', DISKIN, OLDCNO, PVER, PLNAME, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'MAKING PLOT FILE NAME'
         GO TO 990
         END IF
C                                       "Slice" corners
      IDROP(1) = 0
      IDROP(2) = 0
      DO 15 I = 1,7
         XBLC(I) = IPOS(I)
         XTRC(I) = XBLC(I)
 15      CONTINUE
      XTRC(1) = XBLC(1) + INPTS - 1
C                                       Set PIX ranges
      ORANGE(1) = PIXR(1)
      ORANGE(2) = PIXR(2)
C                                       Default: actual range
      IF (PIXR(2).LE.PIXR(1)) THEN
         ORANGE(1) = 1.0E10
         ORANGE(2) = -ORANGE(1)
         DO 20 I = 1,INPTS
            IF (XDATA(I).NE.FBLANK) THEN
               ORANGE(1) = MIN (ORANGE(1), XDATA(I))
               ORANGE(2) = MAX (ORANGE(2), XDATA(I))
               END IF
 20            CONTINUE
         YFAC = ORANGE(2) - ORANGE(1)
         ORANGE(2) = ORANGE(2) + 0.02  * YFAC
         ORANGE(1) = ORANGE(1) - 0.02  * YFAC
         END IF
      CATR(IRRAN) = ORANGE(1)
      CATR(IRRAN+1) = ORANGE(2)
      YFAC = 39999.0 / (CATR(IRRAN+1) - CATR(IRRAN))
      YOFF = 40000.0 - YFAC * CATR(IRRAN)
      PBLC(2) = ORANGE(1) * YFAC + YOFF
      PTRC(2) = ORANGE(2) * YFAC + YOFF
C                                       Label inits
      LOCNUM = 1
      FQFINC = 0.0
      FQFREQ = 0.0D0
C                                       start on labeling as a slice
      CALL RCOPY (7, BLC, XBLC)
      CALL RCOPY (7, TRC, XTRC)
      CALL RCOPY (6, XBLC(2), XTRC(2))
      IDROP(1) = 0
      IDROP(2) = 0
      RVAL  = CATD(KDCRV)
      RPIX  = CATR(KRCRP)
      INCR  = CATR(KRCIC)
C                                       init SL plot
      CATR(IRRAN) = PIXR(1)
      CATR(IRRAN+1) = PIXR(2)
      SCALY = 39999.0 / (ORANGE(2) - ORANGE(1))
      OFY = 40000.0 - SCALY * ORANGE(2)
      RANGE2(1) = SCALY * ORANGE(1) + OFY
      RANGE2(2) = SCALY * ORANGE(2) + OFY
      PBLC(2) = RANGE2(1)
      PTRC(2) = RANGE2(2)
      LOCNUM = 1
      CALL RFILL (4, 0.0, CH)
      YGAP = 0.0
      CALL SLBINI (IDROP, INPTS, ORANGE, PBLC, PTRC, XBLC, XTRC,
     *   FQFREQ, FQFINC, CATBLK(IIDEP), LABEL, YGAP, CH, TEXT, NTEXT)
      ORANGE(1) = YFAC*ORANGE(1) + YOFF
      ORANGE(2) = YFAC*ORANGE(2) + YOFF
      PBLC(1) = PBLC(1) * 10 - 5
      PTRC(1) = PTRC(1) * 10 + 5
      RPLOC(1,LOCNUM) = RPLOC(1,LOCNUM) * 10.0
      AXINC(1,LOCNUM) = AXINC(1,LOCNUM) / 10.0
C                                       display window
      CH(2) = CH(2) - NTEXT * 1.333
      NTEXT = 1
      IF (LABEL.GT.3) NTEXT = 2
      IF (LABEL.GT.6) NTEXT = 0
      CH(2) = CH(2) + NTEXT * 1.333
C                                       init plot file
      IPTYPE = 20
      CALL GINIT (DISKIN, OLDCNO, PLNAME, 0, IPTYPE, NPARM, XNAMEI,
     *   DOTV, TVCHN, GRCHN, TVCORN, CATBLK, PLBUFF, PLUN, PIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'INIT THE PLOT FILE'
         GO TO 990
         END IF
      IF (GR2CHN.GT.0) GPHTVG(1) = GR2CHN + NGRAY
C                                       init line drawing
      XYRATI = (PTRC(2) - PBLC(2)) / (PTRC(1) - PBLC(1)) * XYRATO
      CALL GINITL (PBLC, PTRC, XYRATI, CH, IPOS(3), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GLTYPE (1, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                        Draw the box
      CALL GPOS (PBLC(1), PBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (PTRC(1), PBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (PTRC(1), PTRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (PBLC(1), PTRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GVEC (PBLC(1), PBLC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                       More labeling: x,y coords
      IF ((LABEL.GT.1) .AND. (LABEL.LT.7)) THEN
         CALL GPOS (PBLC(1), PTRC(2), PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 980
         DX = 0.0
         DY = 0.5
         CALL H2CHR (8, 1, CATH(KHOBJ), SPRTXT)
         INCHAR = 12
         IF (SPRTXT.EQ.' ') INCHAR = 1
         IF (NCHLAB(1,LOCNUM).GT.0) THEN
            IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
            SPRTXT(INCHAR:) = SAXLAB(1,LOCNUM)(:NCHLAB(1,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(1,LOCNUM)
            END IF
         IF (NCHLAB(2,LOCNUM).GT.0) THEN
            IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
            SPRTXT(INCHAR:) = SAXLAB(2,LOCNUM)(:NCHLAB(2,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(2,LOCNUM)
            END IF
C                                       image name
         IF (INCHAR.GT.1) SPRTXT(INCHAR-1:INCHAR-1) = '_'
         CALL H2CHR (18, 1, CATH(KHIMN), CTEMP)
         CALL NAMEST (CTEMP, CATBLK(KIIMS), SPRTXT(INCHAR:), NCHAR)
         CALL REFRMT (SPRTXT, '_', INCHAR)
         CALL GCHAR (INCHAR, 0, DX, DY, SPRTXT, PLBUFF, IRET)
         IF (IRET.NE.0) GO TO 980
C                                       Date/time, version number
         IF (LABEL.GT.1) THEN
            CALL GPOS (PBLC(1), PTRC(2), PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 980
            DY = DY + 1.333
            CALL ZDATE (ID)
            CALL ZTIME (IT)
            CALL TIMDAT (IT, ID, ATIME, ADATE)
            WRITE (SPRTXT,1015) PVER, ADATE, ATIME
            CALL REFRMT (SPRTXT, '_', INCHAR)
            CALL GCHAR (INCHAR, 0, DX, DY, SPRTXT, PLBUFF, IRET)
            IF (IRET.NE.0) GO TO 980
            END IF
C                                       Text at bottom
         IF (NTEXT.GT.0) THEN
            DX = 0.
            DY = -YGAP
            DO 30 I = 1,NTEXT
               CALL GPOS (PBLC(1), PBLC(2), PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 980
               CALL CHTRIM (TEXT(I), 80, TEXT(I), INCHAR)
               CALL GCHAR (INCHAR, 0, DX, DY, TEXT(I), PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 980
               DY = DY - 1.333
 30            CONTINUE
            END IF
         END IF
C                                       Axis labels and ticks
      CALL CLAB1 (PBLC, PTRC, CH, LABEL, XYRATI, F, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GLTYPE (4, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      CALL GPOS (PTRC(1), PTRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      X = -10.
      Y = -4.
      WRITE (SPRTXT,1030) 'Y=', IPOS(2)
      CALL GICHAR (1, 7, 0, X, Y, SPRTXT, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      Y = -5.333
      CALL GPOS (PTRC(1), PTRC(2), PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      WRITE (SPRTXT,1030) 'Z=', IPOS(3)
      CALL GICHAR (1, 7, 0, X, Y, SPRTXT, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
C                                       Plot intensities
      CALL GLTYPE (2, PLBUFF, IRET)
      IF (IRET.NE.0) GO TO 980
      PENUP = .TRUE.
      XSEP = 0.0
      IF (DOCENT) XSEP = 0.5
      DO 40 I = 1,INPTS
         IF (XDATA(I).EQ.FBLANK) THEN
            PENUP = T
         ELSE
            Y = XDATA(I) * SCALY + OFY
            Y = MAX (RANGE2(1), MIN (RANGE2(2), Y))
            X = MAX (PBLC(1), (I-XSEP)*10)
            IF (PENUP) THEN
               CALL GPOS (X, Y, PLBUFF, IRET)
               PENUP = F
            ELSE
               CALL GVEC (X, Y, PLBUFF, IRET)
               END IF
            IF (IRET.NE.0) GO TO 980
            IF (DOCENT) THEN
               X = MIN (PTRC(1), (I+XSEP)*10)
               CALL GVEC (X, Y, PLBUFF, IRET)
               IF (IRET.NE.0) GO TO 980
               END IF
            END IF
 40      CONTINUE
C                                       Finish up
      GPHPAG = T
      CALL GFINIS (PLBUFF, IRET)
      IF (.NOT.DOTV) CALL HIPLOT (DISKIN, OLDCNO, PVER, BUFF1, IERR)
      GO TO 999
C                                       Plot error - try partial
 980  WRITE (MSGTXT,1980) IRET
      CALL MSGWRT (7)
      CALL GFINIS (PLBUFF, IERR)
      IF (IERR.EQ.0) THEN
         IRET = 0
      ELSE
         IF (.NOT.DOTV) THEN
            CALL ZCLOSE (PLUN, PIND, IERR)
            CALL ZDESTR (DISKIN, PLNAME, IERR)
            END IF
         END IF
      IF ((IRET.NE.0) .AND. (.NOT.DOTV)) CALL DELEXT ('PL', DISKIN,
     *   OLDCNO, 'READ', CATBLK, PLBUFF, PVER, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('PLOTIT ERROR',I4,' ON ',A)
 1010 FORMAT ('Created plot file version',I5)
 1015 FORMAT ('Plot file version',I4,'__created ',A12,A8)
 1030 FORMAT (A,I5)
 1980 FORMAT ('ERROR ',I5,' PLOTTING - TRY TO FINISH PARTIAL GRAPH')
      END

LOCAL INCLUDE 'ANCAL.INC'
C                                                          Include ANCAL
C                                       Local include for ANCAL
C                                       Needs parameter from PUVD.INC
      INTEGER MAXSRC
      PARAMETER (MAXSRC=500)
C                                       MXTANT is the maximum number of
C                                       antenna temperature entries.
      INTEGER MXTANT
      PARAMETER (MXTANT=20000)
C                                       Inputs and general info
      INTEGER   SEQIN, SUBA, DISKIN, NUMHIS, LUNK, FINDK, DISKCL, CNOCL,
     *   CLVER, BLVER, BIF, EIF, POLNO, ITYRNO, FREQID, NUMANT, NUMPOL,
     *   NUMIF
      REAL      XSIN, XDISIN, XSUBA, XGVER, XBVER, XBAND, XFREQ,
     *   XFQID, XBAD(10), SELBAN
      DOUBLE PRECISION SELFRQ
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAME2(12)
      CHARACTER HISCRD(10)*64, NAMEIN*12, CLAIN*6, NAME2*48
C                                       Source info
      INTEGER   REFDAY, YEAR, NAXIS, NCMPLX, NSTOKE, NFREQS
      CHARACTER SUNAM(MAXSRC)*8
      REAL      TFLUX(MAXSRC)
C                                       Gain info
      INTEGER   NTANT(MAXANT), NTSYS(MAXANT), IGAIN(MAXANT), ISTART,
     *    NSKPDY, NSTEPS, NDAYS(20), SKIPDY(20)
      REAL      GACOEF(10,MAXANT), GAOFFS(MAXANT), DPFU(MAXANT),
     *   TOFFS(2,MAXANT), TDPFU(2,MAXANT),
     *   TANTS(2,MAXANT,MXTANT), BFAC(MAXANT,MAXANT),  BDEF
      LOGICAL   ISTATS(MAXANT), DOBFAC
C                                       Buffers and file info
      INTEGER   DISKSC, CNOSC, LUNSC, INDSC, IBPSC, SCRTCH(256),
     *   SCBUFF(512), SXBUFF(512), ITYVER
      DOUBLE PRECISION DUMMY(100000)
C                                       Important constants
      DOUBLE PRECISION PI, TWOPI, SIDER, CLIGHT
C                                       Inputs and general info
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAME2, XSUBA,
     *   XGVER, XBVER, XBAND, XFREQ, XFQID, XBAD, SEQIN, DISKIN, SUBA,
     *   CLVER, BLVER, BIF, EIF, POLNO, FREQID, NUMANT, NUMPOL, NUMIF
      COMMON /KEYCOM/ SELFRQ, SELBAN, ITYRNO, LUNK, FINDK, DISKCL,
     *   CNOCL, NUMHIS
C                                       CHARACTER info
      COMMON /CHRCOM/ NAMEIN, CLAIN, NAME2, SUNAM, HISCRD
C                                       Source info
      COMMON /SRXDAT/ REFDAY, YEAR, NAXIS, NCMPLX, NSTOKE, NFREQS
C                                       Gain info
      COMMON /CALIB/ GACOEF, GAOFFS, DPFU, TOFFS, TDPFU, TANTS, BFAC,
     *   TFLUX, BDEF, NTANT, NTSYS, IGAIN, ISTART,
     *   SKIPDY, NDAYS, NSKPDY, NSTEPS, ISTATS, DOBFAC
C                                       Buffers and file info
      COMMON /SCFILE/ DUMMY, SCRTCH, SCBUFF, SXBUFF, DISKSC, CNOSC,
     *   LUNSC, INDSC, IBPSC, ITYVER
C                                       Important constants
      COMMON /CONST/ PI, TWOPI, SIDER, CLIGHT
C                                                          End ANCAL
LOCAL END
LOCAL INCLUDE 'ANCAL2.INC'
C                                       TY table stuff
      INTEGER   ANT(2), TYKOLS(MAXTYC), TYNUMV(MAXTYC), NUMTY
      REAL      XTIME(2), XTSYS(2,MAXIF,2), XTANT(2,MAXIF,2)
      COMMON /TYCOM/ XTIME, XTSYS, XTANT, NUMTY, ANT, TYKOLS, TYNUMV
LOCAL END
      PROGRAM ANCAL
C-----------------------------------------------------------------------
C! VLBI amplitude calibration from antenna and system temperatures etc.
C# UV Calibration EXT-util VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2003, 2007, 2011, 2014-2015, 2019,
C;  Copyright (C) 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Task ANCAL computes user supplied gain calibrations to VLBI
C   visibility amplitudes. A table of T sys's and gain curves is read
C   from the AIPS runfile directory.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input UV data.
C      IN2NAME        NAME2         Name of aux. file.
C      SUBARRAY       SUBA          Specified  subarray.
C      GAINVER        CLVER         CL table to update
C      BADDISK        IBAD          Disks to avoid for scratch files.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ANCAL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'ANCAL '/
C-----------------------------------------------------------------------
C                                       Get input parameters
      CALL ANCLIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Read gain curves, antenna
C                                       temps, flux, b-factors, T sys's,
C                                       etc. Update CL table.
      CALL GCURVE (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Update TY table
      CALL TYCONS (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       BL table if necessary
      IF (DOBFAC) CALL BLFAC (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Copy and update HI file.
      CALL ANCLHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRTCH)
 999  STOP
      END
      SUBROUTINE ANCLIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   ANCLIN gets input parameters for ANCAL.
C   Inputs:  PRGN    C*6       Program name
C   Output:  JERR    I         Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      CHARACTER STAT*4, PRGN*6, CHTM8*8, UTYPE*2
      LOGICAL   T, F, MATCH
      INTEGER   JERR, NPARM, IERR, I
      INTEGER   OLDCNO, IROUND, IT(6), LUN
      REAL      BANDW
      DOUBLE PRECISION JD
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ANCAL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      NUMHIS = 0
      LUNK = 10
C                                       Set important constants
      PI = 3.1415926536D0
      TWOPI = 6.2831853072D0
      SIDER = 1.002737923D0
      CLIGHT = 2.997925D8
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 35
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
            END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRTCH, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (48, 1, XNAME2, NAME2)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      SUBA = XSUBA + 0.5
      CLVER = IROUND (XGVER)
      BLVER = IROUND (XBVER)
      DO 20 I = 1,10
         IBAD(I) = IROUND (XBAD(I))
 20      CONTINUE
C                                       Find file, read CATBLK
      OLDCNO = 1
      STAT = 'SRCH'
      UTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN, UTYPE,
     *   NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'WRIT', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 1
      DISKCL = DISKIN
      CNOCL = OLDCNO
      DISKSC = DISKIN
      CNOSC = OLDCNO
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FREQID = IROUND (XFQID)
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ,
     *   MATCH, FREQID, JERR)
      IF (.NOT.MATCH) THEN
         WRITE (MSGTXT,1050)
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       Load pointers for vis's.
      NRPARM = CATBLK(KIPCN)
      NAXIS  = CATBLK(KIDIM)
      NCMPLX = CATBLK(KINAX+JLOCC)
      NSTOKE = CATBLK(KINAX+JLOCS)
      NFREQS = CATBLK(KINAX+JLOCF)
      IF (NFREQS.LE.0) NFREQS = 1
      IF (NSTOKE.LE.0) NSTOKE = 1
      IF (NCOR.LE.0)   NCOR   = 1
      IF (NCOR.GT.2)   NCOR   = 2
C                                       Get observing bandwidth
      BANDW  = NFREQS * CATR(KRCIC+JLOCF)
C                                       Check sort order of input
      IF (ISORT(1:2).NE.'TB') THEN
         WRITE (MSGTXT,1060) ISORT
         JERR = 1
         GO TO 990
         END IF
C                                       Get source-observation info.
      CALL H2CHR (8, 1, CATH(KHDOB), CHTM8)
      CALL JULDAY (CHTM8, JD)
      CALL JD2DAT (JD, IT)
      CALL DAYYR  (IT(1), IT(2), IT(3), REFDAY)
      YEAR   = IT(1) + 1900
C                                       If the IAT corrections got lost,
C                                       calculate new ones.
      IF (ANTIAT.LE.0.0) THEN
         ANTUTC = 0.0
         ANTIAT = YEAR - 1973. + 12.
         END IF
C                                       Put new values in CATBLK.
      JERR = 0
C                                       Open text file (T sys, etc)
      CALL ZTXOPN ('READ', LUNK, FINDK, NAME2, F, IERR)
      IF (IERR.EQ.0) GO TO 999
         WRITE (MSGTXT,1070) IERR
         JERR = IERR
         GO TO 990
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ANCLIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS')
 1060 FORMAT ('INPUT VIS RECORDS MISORDERED, SORTED = ',A2,
     *        ' SHOULD BE = TB')
 1070 FORMAT ('ANCLIN: ERROR',I3,' OPENING TEXT FILE')
      END
      SUBROUTINE GCURVE (IERR)
C-----------------------------------------------------------------------
C   GCURVE is called from ANCAL. GCURVE reads the user's text
C   calibration file located in the AIPS run file subdirectory.
C   GCURVE calculates T ants from gain curves or lists of
C   measured T ants.
C     The CL  table is first sorted to antenna-time order and then
C   updated using the antenna-time sorted Tsys (TY) table from GETCAL
C   and Tant measurments in common.
C   Output in common:
C      NUMANT   I   The maximum antenna number
C      NUMPOL   I   Number (1 or 2) of polarizations/feeds
C      NUMIF    I   The number of IF in the data.
C   Output: IERR  I   return code, 0=OK, else failed
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PCLTAB.INC'
      INTEGER   IUTDAY, CLKOLS(MAXCLC), CLNUMV(MAXCLC), NTERM, IPOL,
     *   NUMNOD, SOURID, ANTNO, LUNX, LUNG, I, JSRC, RELKOL, IMAKOL,
     *   RECI(13+32*MAXIF), IIF, IDX, IDAY, KKEY(2,2), KEYSUB(2,2),
     *   LSTSOU, ICLRNO,  LOOP, NUMREC, INPOL, POLOOP
      REAL      FKEY(2,2), DT, TANTUT, HARAD, ZADEG, HAHR, ELDEG, AZRAD,
     *   RELGAI, GNAMP, UTMIN, POLY, GMMOD, TSYST(2,MAXIF), THETA,
     *   ELRAD, RECORD(13+32*MAXIF), TR
      DOUBLE PRECISION PIBY2, RDTODG, TIME, ENDTIM, RECD(13+32*MAXIF),
     *   JD0, DRA, DDEC
      LOGICAL   PLANET
      INCLUDE 'ANCAL.INC'
      INCLUDE 'ANCAL2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DSOU.INC'
      EQUIVALENCE (RECORD, RECI, RECD)
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
      DATA   LUNG  /28/
      DATA LUNX /29/
C-----------------------------------------------------------------------
      PIBY2  = PI / 2.0D0
      RDTODG = 180.0D0 / PI
      ITYRNO = 0
      LSTSOU = -1
C                                       Read AN file.
      CALL GETANT (DISKCL, CNOCL, SUBA, CATBLK, SXBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL JULDAY (RDATE, JD0)
C                                        Read the user's text cal
C                                        file. Load the T ant and gain
C                                        arrays, return start/stop
C                                        times for station T sys lists.
      CALL GETCAL (IERR)
      IF (IERR.NE.0.AND.IERR.NE.1) GO TO 999
      ITYRNO = 0
C                                       Do not update CL table?
      IF (CLVER.EQ.-1) GO TO 999
C                                       Reformat CL table?
      CALL CLREFM (DISKCL, CNOCL, CLVER, CATBLK, LUNG, IERR)
      IF (IERR.NE.0) GO TO 999
C                                         Open CL table
      CALL CALINI ('READ', SXBUFF, DISKCL, CNOCL, CLVER, CATBLK, LUNG,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, NTERM,
     *   GMMOD, IERR)
      XGVER = CLVER
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR
         GO TO 990
         END IF
C                                       Set sort keys
      KKEY(1,1) = CLIANT
      KKEY(2,1) = CLIANT
      KKEY(1,2) = CLDTIM
      KKEY(2,2) = CLDTIM
C                                       Set up polzn loop parms
      POLOOP = 1
      IF ((POLNO.EQ.3) .AND. (NUMPOL.EQ.2)) POLOOP = 2
      IF ((POLNO.EQ.3) .AND. (NUMPOL.EQ.1)) THEN
         IERR = 1
         MSGTXT = 'INDEX KEY SUGGESTS DUAL POLZN DATA'
         CALL MSGWRT (8)
         MSGTXT = 'CL TABLE CLAIMS ONLY 1 POLZN'
         GO TO 990
         END IF
C                                       Loop over polarizations
      DO 600 INPOL = 1, POLOOP
C                                       Real and imaginary column
C                                       pointers.
         IF (POLOOP.EQ.1) THEN
            RELKOL = CLKOLS(CLRRE1) - 1
            IMAKOL = CLKOLS(CLRIM1) - 1
            IPOL = 1
C                                       LCP in dual poln data?
            IF ((POLNO.EQ.2) .AND. (NUMPOL.GT.1)) THEN
               RELKOL = CLKOLS(CLRRE2) - 1
               IMAKOL = CLKOLS(CLRIM2) - 1
               IPOL = 2
               END IF
         ELSE IF (POLOOP.EQ.2) THEN
            IF (INPOL.EQ.1) THEN
               RELKOL = CLKOLS(CLRRE1) - 1
               IMAKOL = CLKOLS(CLRIM1) - 1
               IPOL = 1
            ELSE IF (INPOL.EQ.2) THEN
               RELKOL = CLKOLS(CLRRE2) - 1
               IMAKOL = CLKOLS(CLRIM2) - 1
               IPOL = 2
               END IF
            END IF
C                                       Load correct gain/offset
         DO 30 I = 1, MAXANT
            DPFU(I) = TDPFU(IPOL,I)
            GAOFFS(I) = TOFFS(IPOL,I)
 30         CONTINUE
C                                       Get number of records
         NUMREC = SXBUFF(5)
C                                       Close table
         CALL TABIO ('CLOS', 0, ICLRNO, RECORD, SXBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Sort to antenna time order.
         IF ((SXBUFF(43).NE.CLIANT) .OR. (SXBUFF(44).NE.CLDTIM)) THEN
            CALL TABSRT (DISKCL, CNOCL, 'CL', CLVER, CLVER, KKEY,
     *         KEYSUB, FKEY, SXBUFF, CATBLK, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
C                                         Reopen CL table read/write
         CALL CALINI ('WRIT', SXBUFF, DISKCL, CNOCL, CLVER, CATBLK,
     *      LUNG, ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF,
     *      NUMNOD, NTERM, GMMOD, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            GO TO 990
            END IF
         ENDTIM = -1.0E10
C                                         Loop through time intervals,
C                                         calc and write gain curve
C                                         factors in CL file.
         DO 500 LOOP = 1,NUMREC
C                                       Read CL table
            ICLRNO = LOOP
            CALL TABIO ('READ', 0, ICLRNO, RECORD, SXBUFF, IERR)
            IF (IERR.LE.0) GO TO 200
            WRITE (MSGTXT,1030) IERR, 'READ'
            GO TO 990
C                                       Check subarray
 200        IF ((RECI(CLKOLS(CLISUB)).NE.SUBA) .AND.
     *         ((RECI(CLKOLS(CLISUB)).GT.0) .AND.
     *         (SUBA.GT.0))) GO TO 500
C                                       Check freq id
            IF ((RECI(CLKOLS(CLIFQI)).NE.FREQID) .AND. (FREQID.GT.0)
     *         .AND. (RECI(CLKOLS(CLIFQI)).GT.0)) GO TO 500
C                                       Get time, etc.
            TIME = RECD(CLKOLS(CLDTIM))
            DT = RECORD(CLKOLS(CLRTMI))
            SOURID = RECI(CLKOLS(CLISID))
            ANTNO = RECI(CLKOLS(CLIANT))
            UTMIN = TIME * 1440.0
            IUTDAY = TIME
            IDAY   = REFDAY + IUTDAY
C                                       Skip if no data read for
C                                       this antenna
            IF (NTSYS(ANTNO).EQ.0) GO TO 480
C                                       Get the Tsys
            CALL GETSYS (TIME, ANTNO, TSYST, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       Find source info.
C            CALL GETSOU (SOURID, DISKCL, CNOCL, CATBLK, LUNX, IERR)
            TR = TIME
            CALL FNDCOO (0, JD0, SOURID, DISKCL, CNOCL, CATBLK, LUNX,
     *         TR, DRA, DDEC, PLANET, IERR)
            IF (IERR.NE.0) GO TO 999
            IF (SOURID.NE.LSTSOU) THEN
               LSTSOU = SOURID
C                                       Find source in KEYIN table
               DO 240 I = 1,MAXSRC
                  JSRC = I
                  IF (SNAME(1:8).EQ.SUNAM(I)(1:8)) GO TO 260
                  IF (SUNAM(I).EQ.' ') THEN
                     SUNAM(I) = SNAME(1:8)
                     TFLUX(I) = 0.0
                     WRITE (MSGTXT,1230) SNAME
                     CALL MSGWRT (8)
                     GO TO 260
                     END IF
 240              CONTINUE
C                                       Source not in KEYIN file
               IERR = 10
               WRITE (MSGTXT,1240) SNAME
               GO TO 990
               END IF
C                                       Loop thru stations and calc
C                                       gain curve values.
C                                       Interpolate antenna temps.
 260        IF (IGAIN(ANTNO).EQ.1) THEN
               CALL TWERP (ANTNO, TIME, TANTUT)
               IF (TFLUX(JSRC).GT.1.0E-10) TANTUT =
     *            TANTUT / TFLUX(JSRC)
               GO TO 450
               END IF
C                                      Calc gain curve
            CALL COOELV (ANTNO, TIME, DRA, DDEC, HARAD, ELRAD, AZRAD)
            ZADEG = 90.0 - ELRAD * RDTODG
            TANTUT= -1.0
            IF (HARAD.GT.PI) HARAD = HARAD - TWOPI
            IF (HARAD.LT.-PI) HARAD = HARAD + TWOPI
            HAHR  = HARAD * 12.0 / PI
C                                       Branch on computation type
            GO TO (450,300,320,340,360,380,490,490,490), IGAIN(ANTNO)
C
C                                      EQUAT gain curve.
 300        TANTUT = DPFU(ANTNO) * POLY (HAHR,  ANTNO, 6)
            GO TO 450
C                                      ALTAZ gain curve.
 320        TANTUT = DPFU(ANTNO) * POLY (ZADEG, ANTNO, 6)
            GO TO 450
C                                      NRAO 140' gain curve.
C                                      Updated Dec 1993. These are the
C                                      spherical harmonics in the 140'
C                                      VLB NUG calib. sheet. LJG.
C                                      Added 3 new terms in Dec 1993.
C                                      Order  of coefficients: Y00,
C                                      Y11o, Y10, Y11e, Y21o, Y20, Y21e,
C                                      Y22o, Y22e, Y30.
 340        THETA = PIBY2 - DDEC
            TANTUT = DPFU(ANTNO)*(GACOEF(1,ANTNO)
     *         + GACOEF(2,ANTNO)*SIN(THETA)*SIN(HARAD)
     *         + GACOEF(3,ANTNO)*COS(THETA)
     *         + GACOEF(4,ANTNO)*SIN(THETA)*COS(HARAD)
     *         + GACOEF(5,ANTNO)*3.0*SIN(THETA)*COS(THETA)*SIN(HARAD)
     *         + GACOEF(6,ANTNO)*0.5*(3.0*COS(THETA)**2 - 1.0)
     *         + GACOEF(7,ANTNO)*3.0*SIN(THETA)*COS(THETA)*COS(HARAD))
     *         + GACOEF(8,ANTNO)*3.0*(SIN(THETA)**2 * SIN(2.0*HARAD))
     *         + GACOEF(9,ANTNO)*3.0*(SIN(THETA)**2 * COS(2.0*HARAD))
     *         + GACOEF(10,ANTNO)*(2.5*COS(THETA)**3 - 1.5*COS(THETA))
            GO TO 450
C                                      ELEV gain curve.
 360        ELDEG = 90.0 - ZADEG
            TANTUT = DPFU(ANTNO) * POLY (ELDEG,ANTNO,6)
            GO TO 450
C                                      ARECIBO gain curve.
C                                      From Harry Payne, 1983.
C                                      18 cm. only.
 380        RELGAI = 1.0 / (0.98372 + 1.0665E-2*(ZADEG-8.0)
     *         - 1.9939E-3*(ZADEG-8.0)**2 + 4.9621E-4*(ZADEG-8.0)**3)
            IF (ABS (ZADEG).LE.8.0) RELGAI = 1.0
            TANTUT = DPFU(ANTNO) * RELGAI
            GO TO 450
 450        CONTINUE
C                                       Correct Tant for antennas for
C                                       which Tant/Tsys given (e.g. VLA)
            IF (ISTATS(ANTNO)) TANTUT = TANTUT /
     *         MAX (1.0E-5, TFLUX(JSRC))
C                                       Update CL record
            DO 460 IIF = BIF, EIF
               IDX = IIF - BIF + 1
               GNAMP  = 0.0
               IF ((TANTUT.GT.0.0) .AND.
     *           (TSYST(IPOL,IDX).NE. FBLANK)) GNAMP  =
     *            SQRT (BDEF  * TSYST(IPOL,IDX) / TANTUT)
               IF (GNAMP.LT.1.0E-20) GNAMP = FBLANK
               IF ((GNAMP.EQ.FBLANK) .AND.
     *             ((RECORD(RELKOL+IIF).NE.FBLANK) .AND.
     *             (RECORD(RELKOL+IIF).GT.0.0))) GNAMP = 1.0
               IF (GNAMP.EQ.FBLANK) THEN
                  RECORD(RELKOL+IIF) = FBLANK
                  RECORD(IMAKOL+IIF) = FBLANK
               ELSE
                  IF ((RECORD(RELKOL+IIF).NE.FBLANK))
     *               RECORD(RELKOL+IIF) = RECORD(RELKOL+IIF) * GNAMP
                  IF ((RECORD(IMAKOL+IIF).NE.FBLANK))
     *               RECORD(IMAKOL+IIF) = RECORD(IMAKOL+IIF) * GNAMP
                  END IF
 460           CONTINUE
C                                        Write CL record
 480        CALL TABIO ('WRIT', 0, ICLRNO, RECORD, SXBUFF, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1490) IERR
               GO TO 990
               END IF
 490        CONTINUE
C
 500     CONTINUE
C                                       Close TY table
         CALL TABIO ('CLOS', 0, ITYRNO, RECORD, SCBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
         ITYRNO = 0
 600     CONTINUE
C                                       Close CL table
         CALL TABIO ('CLOS', 0, ICLRNO, RECORD, SXBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('GCURVE: CLINI ERROR =',I3)
 1030 FORMAT ('GCURVE: TABIO ERROR =',I3,1X,A4,'ING CL TABLE')
 1230 FORMAT ('SOURCE ',A16,' NOT IN KEYIN INPUT. ADDED WITH FLUX 0.0')
 1240 FORMAT ('SOURCE ',A16,' NOT IN KEYIN CALIBRATION TABLE')
 1490 FORMAT ('GCURVE: ERROR =',I3,' FROM EXTIO')
      END
      SUBROUTINE GETCAL (IERR)
C-----------------------------------------------------------------------
C   GETCAL reads the external text file containing T sys, T ant,
C   gains, fluxes, etc.  Tsys measurments are written into an TY table
C   and sorted into antenna time order.
C   Output in common:
C      BIF        I    First IF number from file
C      EIF        I    Last IF number from file
C      POLNO      I    Polarization number from file (mode=1 only)
C   Output:
C      IERR       I    Error code, 0=OK, else failed.
C-----------------------------------------------------------------------
      INTEGER   IERR
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PTYTAB.INC'
      INTEGER NPRM
      PARAMETER (NPRM = 168)
C
      CHARACTER PARS(NPRM)*8, ENDMRK*8, CHFLUX*8, CHSOUR*8,
     *   CHORDR*8, CDUMMY*80, VALCH(NPRM)*8
      INTEGER   KMODE, NPARS, NVALS, NDUM, ITSYS, IVERS, LASTDY, NDY,
     *   IDIV, TYKOLS(MAXTYC), TYNUMV(MAXTYC), LASTST, I, IA, IB, ITYP,
     *   ISTN, KSTN1, KSTN, ISTN2, IDUM, ITANT, K, JSRC, MXANT,
     *   KKEY(2,2), KEYSUB(2,2), JSTN, NIF, SID, SUB, FQID, IPOL, CHANB,
     *   CHANE, TORDER(MAXIF), KPOL, KIF, INCHB, INCHE, IFJMP, IPTR,
     *   INBIF, INEIF, NCOL
      LOGICAL   GOTCTL, ALLCHN, BOTHSI, INDEX, POLSET, EIFSET
      REAL      FT, TIMOFF, FKEY(2,2), TTIME, TSYST(2,MAXIF),
     *   TANT(2,MAXIF), XTI
      DOUBLE PRECISION VALS(NPRM), DEFS(NPRM)
      INCLUDE 'ANCAL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA KKEY /TYIANT, TYIANT, TYRTIM, TYRTIM/
      DATA FKEY /1.0,0.0,1.0,0.0/
      DATA KEYSUB /4*1/
      DATA PARS/'BASELINE', 'TSYS    ', 'TANT    ',
     *   'GAIN    ', 'CONTROL ', 'UNBIAS  ', 'CALERR  ',
     *   'BDEF????', 'B       ', 'FT      ', 30*'********',
     *   60*'        ',
     *   'DPFU    ', 'DPFU    ', 'OFFSET  ', 'OFFSET  ',
     *   'POLY    ', 'POLY    ', 'POLY    ', 'POLY    ',
     *   'POLY    ', 'POLY    ', 'EQUAT   ', 'ALTAZ   ',
     *   'GCNRAO  ', 'EL???   ', 'GCAREC??', 'HISTORY ',
     *   'HISTORY ', 'HISTORY ', 'HISTORY ', 'HISTORY ',
     *   'HISTORY ', 'HISTORY ', 'SRC/SYS ', 'IFNO    ',
     *   'POLNO   ', 'TIMEOFF ', 'A00     ', 'A11O    ',
     *   'A10     ', 'A11E    ', 'A21O    ', 'A20     ',
     *   'A21E    ', 'A22O    ', 'A22E    ', 'A30     ',
     *   'BIF     ', 'EIF     ', 'ALLCHAN ',
     *   'BOTHSIDE', 28*'        '/
      DATA CHFLUX,     CHSOUR,    CHORDR,    ENDMRK
     *   /'FLUX??  ', 'SOURCE? ','INDEX?  ','/       '/
      DATA DEFS/7*-1.0D0,1.0D0,2*-1.0D0,30*-1.0D0,
     *   30*0.0D0,30*-1.0D0,-1.0D0,-1.0D0,0.0D0,0.0D0,
     *   1.0D0,5*0.0D0,12*-1.0D0,-1.0D0,-1.0D0,-1.0D0,0.0D0,
     *   10*0.0D0, 4*-1.0D0, 28*-1.D0/
      DATA NDUM /10000/
      DATA LASTST /0/
      DATA SID, SUB, FQID /-1, -1, -1/
C-----------------------------------------------------------------------
      NPARS = NPRM
      DO 20 I = 1,MAXANT
         ISTATS(I) = .FALSE.
 20      CONTINUE
      CALL FILL (20, 0, NDAYS)
      CALL RFILL (2*MAXIF, FBLANK, TANT)
      CALL RFILL (2*MAXIF, FBLANK, TSYST)
      MXANT = MAXANT
      IPOL = 1
      BIF = 1
      EIF = 1
      POLNO = 1
      POLSET = .FALSE.
      EIFSET = .FALSE.
      ALLCHN = .FALSE.
      BOTHSI = .FALSE.
      INDEX = .FALSE.
C                                      Open Tsys table.
      ITYVER = 0
      LUNSC = 30
      NIF = 1
      IF (JLOCIF.GT.0) NIF = CATBLK(KINAX+JLOCIF)
      NUMPOL = 1
      IF (CATBLK(KINAX+JLOCS).GT.1) NUMPOL = 2
      CALL TYINI ('WRIT', SXBUFF, DISKSC, CNOSC, ITYVER, CATBLK, LUNSC,
     *   ITYRNO, TYKOLS, TYNUMV, NUMPOL, NIF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Prepare to read KEYIN file.
C                                      Load station names in STNNAM
C                                      from AN file into KEYIN parms
C                                      array PARS.
      DO 50 I = 1, NSTNS
         PARS(10+I) = STNNAM(I)
 50      CONTINUE
C                                       Init antenna counts, bl factors
      DOBFAC = .FALSE.
      GOTCTL = .FALSE.
      DO 60 IA = 1,MXANT
         IGAIN(IA) = 0
         NTANT(IA) = 0
         NTSYS(IA) = 0
         DO 59 IB = 1,MXANT
            BFAC(IA,IB) = 1.0
 59         CONTINUE
 60      CONTINUE
      DO 80 I = 1,30
         PARS(I+40) = CHSOUR
         PARS(I+70) = CHFLUX
 80      CONTINUE
      DO 90 I = 1,28
         PARS(I+140) = CHORDR
 90      CONTINUE
C
C                                      Read a complete text entry up to
C                                      the endmark '/'. Load defaults
C                                      into the KEYIN output buffer
C                                      first.
 100  KMODE = 0
      DO 140 I = 1,NPARS
         VALS(I) = DEFS(I)
         VALCH(I) = '        '
 140     CONTINUE
      CALL KEYIN (PARS, VALS, VALCH, NPARS, ENDMRK, KMODE, LUNK, FINDK,
     *   IERR)
      IF (IERR.NE.0) THEN
C                                      Returns IERR=1 on EOF.
         IF (IERR.EQ.1) GO TO 700
         WRITE (MSGTXT,1140) IERR
         GO TO 990
         END IF
C
C                                      Which type of group has just been
C                                      read ?
      DO 160 I = 1,5
         ITYP  = I
         IF (VALS(I).NE.-1.D0) GO TO 170
 160     CONTINUE
C                                      Which station name has KEYIN
C                                      just read ?
 170  DO 180 I = 1, NSTNS
         ISTN = I
         JSTN = I
         IF (VALS(I+10).NE.-1.0D0) GO TO 190
 180     CONTINUE
      ITYP = 5
C                                       Only allow 1 "CONTROL" card
C                                       (blank entries default to
C                                       "CONTROL")
      IF ((ITYP.EQ.5) .AND. GOTCTL) GO TO 100
C
 190   CONTINUE
C                                       Get BIF, EIF and POLNO
      IF (VALS(124).GT.0.0D0) THEN
         BIF = NINT (VALS(124))
         EIF = BIF
         END IF
      IF (VALS(125).GT.0.0D0) THEN
         POLNO = NINT (VALS(125))
         POLSET = .TRUE.
         END IF
      IF (VALS(137).GT.0.0D0) BIF = NINT (VALS(137))
      IF (VALS(138).GT.0.0D0) THEN
         EIF = NINT (VALS(138))
         EIFSET = .TRUE.
         END IF
      BIF = MAX (1, BIF)
      EIF = MAX (BIF, EIF)
      IF ((POLNO.EQ.2) .AND. (NUMPOL.GT.1)) IPOL = 2
C                                       Jump to appropriate group.
      GO TO (200,300,400,500,600) ITYP
C-----------------------------------------------------------------------
C                                      BASELINE cal card was read.
 200  CONTINUE
      KSTN1 = ISTN + 1
      DO 210 KSTN = KSTN1, NSTNS
         ISTN2    = KSTN
         IF (VALS(KSTN+10).NE.-1D0) GO TO 220
 210     CONTINUE
C                                       Couldn't find 2nd antenna
      WRITE (MSGTXT,1210)
      IERR = 1
      GO TO 990
 220  CONTINUE
      IA = MIN (ISTN, ISTN2)
      IB = MAX (ISTN, ISTN2)
      BFAC(IA,IB) = VALS(9)
      DOBFAC = .TRUE.
      GO TO 100
C
C                                      TSYS cal card was read.
C                                      Read T sys list.
 300  CONTINUE
      KMODE = 3
      NVALS = NDUM
      TIMOFF = VALS(126) / 86400.0D0
      CALL KEYIN (CDUMMY, DUMMY, VALCH, NVALS, ENDMRK, KMODE, LUNK,
     *   FINDK, IERR)
      IF (IERR.EQ.0) GO TO 310
         WRITE (MSGTXT,1300) IERR
         GO TO 990
C                                      Load T sys etc. in TY table
 310  FT = VALS(10)
      IF (FT.LE.0.0) FT = 1.0
      LASTDY= 0
      NDY   = 0
      IDIV  = 0
      ITSYS = 0
C                                       Check if index card read
      IF (VALCH(141).NE.'        ') THEN
         CALL CHKORD (VALCH(141), TORDER, INCHB, INCHE, INBIF,
     *      INEIF, POLNO, NCOL)
C                                       Some simple checks
         IF (POLNO.EQ.3) THEN
            IF (NCOR.EQ.1) THEN
               IERR = 1
               WRITE (MSGTXT,1000) STNNAM(JSTN)
               CALL MSGWRT (6)
               MSGTXT = 'NO. POLZN IN INDEX KEYWORD DOES NOT MATCH DATA'
               GO TO 990
               END IF
            END IF
         IF (POLNO.EQ.1) THEN
            IF (ICOR0.NE.-1) THEN
               IERR = 1
               WRITE (MSGTXT,1000) STNNAM(JSTN)
               CALL MSGWRT (6)
               MSGTXT = 'RHC POLZN IN INDEX KEYWORD DOES NOT MATCH DATA'
               GO TO 990
               END IF
            END IF
         IF (POLNO.EQ.2) THEN
            IF ((NCOR.EQ.1) .AND. (ICOR0.NE.-2)) THEN
               IERR = 1
               WRITE (MSGTXT,1000) STNNAM(JSTN)
               CALL MSGWRT (6)
               MSGTXT = 'LHC POLZN IN INDEX KEYWORD DOES NOT MATCH DATA'
               GO TO 990
               END IF
            END IF
         INDEX = .TRUE.
         END IF
C                                       IF range
      CHANB = BIF
      CHANE = EIF
      IF (INDEX) THEN
         CHANB = INCHB
         CHANE = INCHE
         BIF = INBIF
         EIF = INEIF
         END IF
      IF (JLOCIF.GT.0) EIF = MIN (EIF, CATBLK(KINAX+JLOCIF))
C                                       One number for all channels
      ALLCHN = VALS(139).NE.-1.D0
      IF (ALLCHN) THEN
         IF (INDEX) THEN
            IERR = 2
            WRITE (MSGTXT,1000) STNNAM(JSTN)
            CALL MSGWRT (6)
            MSGTXT = 'ALLCHAN & INDEX SET - INVALID CONSTRUCT'
            GO TO 990
            END IF
         CHANB = 1
         CHANE = 1
         IF ((.NOT.POLSET) .AND. (NCOR.GT.1)) POLNO = 3
         IF ((.NOT.EIFSET) .AND. (JLOCIF.GT.0)) THEN
            EIF = NIF
            END IF
         END IF
C                                       Upper & lower sidebands stored
C                                       as different IF's, but only
C                                       have one Tsys for them.
      BOTHSI = VALS(140).NE.-1.D0
      IF (ALLCHN .AND. BOTHSI) THEN
         IERR = 1
         WRITE (MSGTXT,1000) STNNAM(JSTN)
         CALL MSGWRT (6)
         MSGTXT = 'ALLCHAN & BOTHSIDE SET - INVALID CONSTRUCT'
         GO TO 990
         END IF
      IFJMP = 1
      IF (BOTHSI) THEN
         IFJMP = 2
         CHANE = CHANE / 2
         END IF
C                                       Tant/Tsys given?
      IF (VALS(123).NE.-1.0D0) IDIV = 1
      ISTATS(JSTN) = ABS (VALS(123)+1.0D0) .GT. 1.0D-5
      IF (.NOT.INDEX) THEN
         DO 330 IDUM = 1,NVALS,3+CHANE-CHANB
            CALL CHKCRD (DUMMY(IDUM), JSTN, 1, IERR)
            IF (IERR.NE.0) GO TO 999
            TTIME = (DUMMY(IDUM) - REFDAY) + DUMMY(IDUM+1) /
     *         24.0 + TIMOFF
            DO 320 I = 1,NIF,IFJMP
               IF (ALLCHN) THEN
C                                       One number for all channels
C                                       1 polzn
                  IF (DUMMY(IDUM+2).LE.0.0) THEN
C                                       Negative Tsys
                     TSYST(IPOL,I) = FBLANK
                     IF ((POLNO.EQ.3).AND.(IPOL.EQ.1))
     *                  TSYST(IPOL+1,I) = FBLANK
                     WRITE (MSGTXT,1320) DUMMY(IDUM+2), STNNAM(JSTN)
                     CALL MSGWRT (8)
                  ELSE
                     TSYST(IPOL,I) = DUMMY(IDUM+2) * FT
                     IF (IDIV.EQ.1) TSYST(IPOL,I) = 1.0 / TSYST(IPOL,I)
C                                       2nd polzn
                     IF ((POLNO.EQ.3) .AND. (IPOL.EQ.1)) THEN
                        TSYST(IPOL+1,I) = DUMMY(IDUM+2) * FT
                        IF (IDIV.EQ.1) TSYST(IPOL+1,I) =
     *                     1.0 / TSYST(IPOL+1,I)
                        END IF
                     END IF
C
               ELSE IF (BOTHSI) THEN
C                                       One number for both sidebands
                  IF (DUMMY(IDUM+2).LE.0.0) THEN
                     TSYST(IPOL,I) = FBLANK
                     TSYST(IPOL,I+1) = FBLANK
                     WRITE (MSGTXT,1320) DUMMY(IDUM+2), STNNAM(JSTN)
                     CALL MSGWRT (8)
                  ELSE
                     TSYST(IPOL,I) = DUMMY(IDUM+2) * FT
                     TSYST(IPOL,I+1) = DUMMY(IDUM+2) * FT
                     IF (IDIV.EQ.1) TSYST(IPOL,I) = 1.0 / TSYST(IPOL,I)
                     IF (IDIV.EQ.1) TSYST(IPOL,I+1) = 1.0 /
     *                  TSYST(IPOL,I+1)
                     END IF
C
               ELSE
C                                       One to one correspondance
                  IF (DUMMY(IDUM+I+1).LE.0.0) THEN
                     TSYST(IPOL,I) = FBLANK
                     WRITE (MSGTXT,1320) DUMMY(IDUM+I+1), STNNAM(JSTN)
                     CALL MSGWRT(8)
                  ELSE
                     TSYST(IPOL,I) = DUMMY(IDUM+I+1) * FT
                     IF (IDIV.EQ.1) TSYST(IPOL,I) = 1.0 / TSYST(IPOL,I)
                     END IF
                  END IF
 320           CONTINUE
C
            CALL TABTY ('WRIT', SXBUFF, ITYRNO, TYKOLS, TYNUMV, NUMPOL,
     *            NIF, TTIME, XTI, SID, JSTN, SUB, FQID, TSYST, TANT,
     *            IERR)
            IF (IERR.NE.0) GO TO 999
            ITSYS = ITSYS + 1
 330        CONTINUE
C                                       Re-order columns
      ELSE IF (INDEX) THEN
         DO 350 IDUM = 1,NVALS,2+NCOL
            CALL CHKCRD (DUMMY(IDUM), JSTN, 1, IERR)
            IF (IERR.NE.0) GO TO 999
            TTIME = (DUMMY(IDUM) - REFDAY) + DUMMY(IDUM+1) /
     *         24.0 + TIMOFF
            IPTR = 0
            DO 340 I = 1,NCOL,1
               IPTR = IPTR + 1
               KPOL = 1
               IF (TORDER(IPTR).GT.100) KPOL = 2
               KIF = TORDER(IPTR) - 100*(KPOL-1)
               IF (KIF.GT.0) THEN
                  IF (BOTHSI) THEN
                     IF (DUMMY(IDUM+IPTR+1).LE.0.0) THEN
C                                       Negative system temperature
                        TSYST(KPOL,KIF) = FBLANK
                        TSYST(KPOL,KIF+1) = FBLANK
                        WRITE (MSGTXT,1320) DUMMY(IDUM+IPTR+1),
     *                     STNNAM(JSTN)
                        CALL MSGWRT (8)
                     ELSE
                        TSYST(KPOL,KIF) = DUMMY(IDUM+IPTR+1) * FT
                        TSYST(KPOL,KIF+1) = DUMMY(IDUM+IPTR+1) * FT
                        IF (IDIV.EQ.1) TSYST(KPOL,KIF) =
     *                     1.0 / TSYST(KPOL,KIF)
                        IF (IDIV.EQ.1) TSYST(KPOL,KIF+1) =
     *                     1.0 / TSYST(KPOL,KIF+1)
                        END IF
                     ELSE IF (.NOT.BOTHSI) THEN
                        IF (DUMMY(IDUM+IPTR+1).LE.0.0) THEN
C                                       Negative system temperature
                           TSYST(KPOL,KIF) = FBLANK
                           WRITE (MSGTXT,1320) DUMMY(IDUM+IPTR+1),
     *                        STNNAM(JSTN)
                           CALL MSGWRT (8)
                        ELSE
                           TSYST(KPOL,KIF) = DUMMY(IDUM+IPTR+1) * FT
                           IF (IDIV.EQ.1) TSYST(KPOL,KIF) =
     *                        1.0 / TSYST(KPOL,KIF)
                           END IF
                        END IF
                  END IF
 340           CONTINUE
            CALL TABTY ('WRIT', SXBUFF, ITYRNO, TYKOLS, TYNUMV, NUMPOL,
     *            NIF, TTIME, XTI, SID, JSTN, SUB, FQID, TSYST, TANT,
     *            IERR)
            IF (IERR.NE.0) GO TO 999
            ITSYS = ITSYS + 1
 350        CONTINUE
         END IF
      WRITE (MSGTXT,1330) ITSYS, STNNAM(JSTN)
      CALL MSGWRT (8)
      NTSYS(JSTN) = ITSYS
      LASTST = JSTN
      ALLCHN = .FALSE.
      GO TO 100
C
C                                      TANT cal card was read.
C                                      Read T ant list and load
C                                      into TANT array.
 400  CONTINUE
      FT = VALS(10)
      TIMOFF = VALS(126) / 86400.0D0
      IF (FT.LE.0.0) FT = 1.0
      KMODE = 3
      NVALS= NDUM
      CALL KEYIN (CDUMMY, DUMMY, VALCH, NVALS, ENDMRK, KMODE, LUNK,
     *   FINDK, IERR)
      IF (NVALS.GT.3*MXTANT) THEN
         WRITE (MSGTXT,1420) MXTANT, STNNAM(ISTN)
         IERR = 1
         GO TO 990
         END IF
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1440) IERR
         GO TO 990
         END IF
C
      ITANT = 0
      DO 460 IDUM = 1, NVALS, 3
         ITANT    = ITANT + 1
         CALL CHKCRD (DUMMY(IDUM), JSTN, 2, IERR)
         TANTS(1,ISTN,ITANT) = (DUMMY(IDUM) - REFDAY)
     *                       +   DUMMY(IDUM+1) / 24.0 + TIMOFF
         TANTS(2,ISTN,ITANT) =   DUMMY(IDUM+2) * FT
 460     CONTINUE
      NTANT(ISTN) = ITANT
      IGAIN(ISTN) = 1
      GO TO 100
C
C                                      GAIN cal card was read.
C                                      Load gain curve coefficents
C                                      into GACOEF and GAOFFS.
 500  TDPFU(1,ISTN) = VALS(101)
      TDPFU(2,ISTN) = VALS(102)
      IF ((TDPFU(1,ISTN).LE.0.0) .AND. (TDPFU(2,ISTN).GT.0.0)) THEN
         TDPFU(1,ISTN) = TDPFU(2,ISTN)
         END IF
      IF ((TDPFU(2,ISTN).LE.0.0) .AND. (TDPFU(1,ISTN).GT.0.0)) THEN
         TDPFU(2,ISTN) = TDPFU(1,ISTN)
         END IF
      TOFFS(1,ISTN) = VALS(103)
      TOFFS(2,ISTN) = VALS(104)
      IF ((TOFFS(1,ISTN).LE.0.0) .AND. (TOFFS(2,ISTN).GT.0.0)) THEN
         TOFFS(1,ISTN) = TOFFS(2,ISTN)
         END IF
      IF ((TOFFS(2,ISTN).LE.0.0) .AND. (TOFFS(1,ISTN).GT.0.0)) THEN
         TOFFS(2,ISTN) = TOFFS(1,ISTN)
         END IF
CCCC      DPFU(ISTN) = VALS(101)
CCCC      GAOFFS(ISTN) = VALS(103)
      DO 510 K = 1,6
         GACOEF(K,ISTN) = VALS(104+K)
 510     CONTINUE
C
C                                       Save antenna solution type.
      IF (VALS(111).NE.-1D0) IGAIN(ISTN) = 2
      IF (VALS(112).NE.-1D0) IGAIN(ISTN) = 3
      IF (VALS(113).NE.-1D0) IGAIN(ISTN) = 4
      IF (VALS(114).NE.-1D0) IGAIN(ISTN) = 5
      IF (VALS(115).NE.-1D0) IGAIN(ISTN) = 6
C
C                                       Load the NRAO 140' coefficients
      IF (VALS(113).NE.-1D0) THEN
         DO 515 K = 1, 10
            GACOEF(K,ISTN) = VALS(126+K)
 515        CONTINUE
         END IF
C
      GO TO 100
C
C                                     Load source flux, B default
C                                     here.
 600  BDEF = VALS(8)
      GOTCTL = .TRUE.
C                                     Set SUNAM's to blank and TFLUX's
C                                     to 1.0 for defaults.  Do for
C                                     all MAXSRC elements.
      DO 605 JSRC = 1,MAXSRC
         SUNAM(JSRC) = '        '
         TFLUX(JSRC) = 0.0
 605     CONTINUE
C                                     Now fill up to 30 sources from
C                                     input data.
      DO 610 JSRC = 1,30
         SUNAM(JSRC) = VALCH(40+JSRC)
         IF( SUNAM(JSRC) .NE. ' ' ) TFLUX(JSRC) = VALS(70+JSRC)
         WRITE (MSGTXT,1610) SUNAM(JSRC), TFLUX(JSRC)
         IF (TFLUX(JSRC).GT.0.0) CALL MSGWRT (8)
 610     CONTINUE
      GO TO 100
C                                       Close up
 700  CALL TABIO ('CLOS', 0, ITYRNO, TANT, SXBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL ZTXCLS (LUNK, FINDK, IERR)
C                                       Normalize baseline corrections
C                                       wrst default value.
      DO 710 IA = 1, NSTNS
C                                       Check the Tsys found for all
         IF (NTSYS(IA).EQ.0) THEN
            WRITE (MSGTXT,1710) STNNAM(IA)
            CALL MSGWRT (8)
            END IF
         DO 709 IB = 1, NSTNS
            IF (BFAC(IA,IB).NE.1.0.AND.BFAC(IA,IB).NE.0.0)
     *          BFAC(IA,IB) = BFAC(IA,IB) / BDEF
 709        CONTINUE
 710     CONTINUE
C                                       Sort TY table
      CALL TABSRT (DISKSC, CNOSC, 'TY', IVERS, IVERS, KKEY, KEYSUB,
     *   FKEY, SXBUFF, CATBLK, IERR)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETCAL: FOR STATION ',A)
 1140 FORMAT ('GETCAL: ERROR =',I3,' FROM FIRST KEYIN CALL')
 1210 FORMAT ('GETCAL: SECOND STATION NOT FOUND ON BASELINE CARD')
 1300 FORMAT ('GETCAL: ERROR =',I3,' FROM KEYIN SKIPPING TSYS CARDS')
 1320 FORMAT ('GETCAL: TSYS ',F8.1,' <0 BLANKED FOR STATION: ',A8)
 1330 FORMAT (I5,' System temps read for station : ',A)
 1420 FORMAT ('MAX. OF I4 ANT. TEMPS EXCEEDED FOR STN :',A)
 1440 FORMAT ('GETCAL: ERROR =',I3,' FROM KEYIN READING TANT CARDS')
 1610 FORMAT ('Source : ',A8,' Flux density (Jy) = ',F8.3)
 1710 FORMAT ('NO SYSTEM TEMPS FOUND FOR STATION : ',A)
      END
      SUBROUTINE CHKCRD (TVALS, ISTN, ITYP, IERR)
C-----------------------------------------------------------------------
C   Checks T sys or T ant cards read by KEYIN in GETCAL.
C   Inputs:
C    ISTN       I    Antenna number
C    ITYP       I    Temp. type, 1=Tsys, 2=Tant
C   Input/Output:
C    TVALS(3:)  D    On input KEYIN values
C   Output:
C    IERR       I    Error code, 0=>OK, 10 = bad entry.
C-----------------------------------------------------------------------
      CHARACTER TCARD(2)*4
      INTEGER    IERR, ITYP, ISTN, LTYP, LSTN
      INTEGER    IDYNUM, IHR, IMIN
      REAL       LTIME, TIME
      DOUBLE PRECISION TVALS(*)
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ANCAL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA TCARD /'TSYS','TANT'/
      DATA LTIME, LSTN, LTYP /0.0,0,0/
C-----------------------------------------------------------------------
      IERR = 0
      TIME = TVALS(1) * 24.0 + TVALS(2)
      IF ((TIME.LE.LTIME) .AND. (ISTN.EQ.LSTN) .AND.
     *   (ITYP.EQ.LTYP)) GO TO 30
      IF (TVALS(1).GE.1.0.AND.TVALS(1).LE.365.0.AND.
     *    TVALS(2).GE.0.0.AND.TVALS(2).LE.24.0.AND.
     *    TVALS(3).GT.0.0) GO TO 100
 30       IDYNUM = TVALS(1) + 0.01
          IHR    = TVALS(2) + 0.01
          IMIN   = (TVALS(2) - IHR ) * 60.0 + 0.01
          IF (IDYNUM.GT.9999) IDYNUM = 99999
          IF (IDYNUM.LT.-9999) IDYNUM = -99999
          IF (IHR.GT.99) IHR = 99
          IF (IHR.LT.-9) IHR = -9
          IF (IMIN.GT.99) IMIN = 99
          IF (IMIN.LT.-9) IMIN = -9
          WRITE (MSGTXT,1100) STNNAM(ISTN), TCARD(ITYP), IDYNUM, IHR,
     *      IMIN, TVALS(3)
          CALL MSGWRT (8)
          IERR = 10
 100  LTIME = TIME
      LSTN  = ISTN
      LTYP  = ITYP
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('BAD ENTRY IN ',A,1X,A,' CARD :',I5,I3,':',I2,F8.1)
      END
      SUBROUTINE TWERP (ISTN, UT, TOUT)
C-----------------------------------------------------------------------
C   Interpolate T ants at time UT from table in common.
C    Inputs:
C      ISTN    I    Antenna number
C      UT      D    Time (days)
C   Output:
C      TOUT    R    The Tant.
C   J.M. Benson  1 Nov 1983
C-----------------------------------------------------------------------
      INTEGER    ISTN
      DOUBLE PRECISION UT
      REAL       TOUT
C
      INTEGER   LO, HI, NTA, I
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ANCAL.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      NTA = NTANT(ISTN)
C                                       Interpolate antenna temp
      IF (UT.LE.TANTS(1,ISTN,1)) THEN
         TOUT = TANTS(2,ISTN,1)
         GO TO 999
         END IF
      IF (UT.GT.TANTS(1,ISTN,NTA)) THEN
         TOUT = TANTS(2,ISTN,NTA)
         GO TO 999
         END IF
C
      DO 210 I = 1, NTA - 1
         LO    = I
         HI    = I + 1
         IF (UT.GE.TANTS(1,ISTN,LO).AND.
     *       UT.LE.TANTS(1,ISTN,HI))  GO TO 220
 210     CONTINUE
C
 220  TOUT = TANTS(2,ISTN,LO) + (TANTS(2,ISTN,HI)-TANTS(2,ISTN,LO))*
     *                          (            UT-TANTS(1,ISTN,LO))/
     *                          (TANTS(1,ISTN,HI)-TANTS(1,ISTN,LO))
      GO TO 999
C
 999  RETURN
      END
      FUNCTION POLY (X, ISTN, NTERM)
C-----------------------------------------------------------------------
C   Evaluate the antenna gain polynomial for antenna ISTN at position
C   X using NTERM terms.
C   Input:
C    X      R    Argument of polynimial
C    ISTN   I    Antenna number
C    NTERM  I    Number of terms to use
C-----------------------------------------------------------------------
      INTEGER    NTERM, ISTN, I
      REAL       ARG, X, XARG, POLY
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ANCAL.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      POLY = 0.0
      IF (NTERM.LT.1) GO TO 999
      IF (NTERM.GT.6) GO TO 999
      POLY = GACOEF(1,ISTN)
      IF (NTERM.LT.2) GO TO 999
      XARG = X + GAOFFS(ISTN)
      ARG  = 1.0
      DO 10 I = 2, NTERM
         ARG  = ARG * XARG
         POLY = POLY + GACOEF(I,ISTN) * ARG
 10      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE DAYYR (YR, MN, DY, DAY)
C-----------------------------------------------------------------------
C   Calculate day number from year, month, day of month.
C   Inputs:
C    YR     I    Year number
C    MN     I    Month number
C    DY     I    Day of month
C   Output:
C    DAY    I    Day of year number
C   J.M. Benson, 1 Nov 1983
C-----------------------------------------------------------------------
      INTEGER   YR, MN, DY, DAY, DAYSUM(12)
      DATA DAYSUM /0,31,59,90,120,151,181,212,243,273,304,334/
C-----------------------------------------------------------------------
      DAY = DAYSUM (MN) + DY
      IF ((MOD(YR,4).EQ.0).AND.(MOD(YR,100).NE.0).AND.MN.GT.2)
     *   DAY = DAY + 1
C
 999  RETURN
      END
      SUBROUTINE BLFAC (IERR)
C-----------------------------------------------------------------------
C   BLFAC writes a BL table using values in BFAC.
C   Input in common:
C      BFAC     R(*,*)  Baseline amplitude factors.
C      NUMANT   I       The maximum antenna number
C      NUMPOL   I       Number (1 or 2) of polarizations/feeds
C      NUMIF    I       The number of IF in the data.
C   Input/Output in common:
C       BLVER   I       Output BL table number
C   Output:
C      IERR     I       Error code, 0=OK, else failed.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IBLRNO, BLKOLS(MAXBLC), BLNUMV(MAXBLC), LOOPA1, LOOPA2,
     *   LOOPIF,  BLSID, BLSUB, BLANT1, BLANT2, BLFQID, LUN
      REAL      BLTIME, FACMUL(2,2,MAXIF), FACADD(2,2,MAXIF)
      INCLUDE 'ANCAL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Open/create BL table.
      LUN = 29
      CALL BLINI ('WRIT', SCBUFF, DISKCL, CNOCL, BLVER, CATBLK, LUN,
     *   IBLRNO, BLKOLS, BLNUMV, NUMANT, NUMPOL, NUMIF, IERR)
      IF (IERR.NE.0) GO TO 999
      IBLRNO = 1
C                                       Set table wide values.
      BLTIME = 1.0
      BLSID = -1
      BLSUB = SUBA
      BLFQID = FREQID
C                                       Zero additive errors, imaginary
C                                       parts of mutiplicative errors.
      DO 50 LOOPIF = 1,NUMIF
         FACADD(1,1,LOOPIF) = 0.0
         FACADD(2,1,LOOPIF) = 0.0
         FACADD(1,2,LOOPIF) = 0.0
         FACADD(2,2,LOOPIF) = 0.0
         FACMUL(1,1,LOOPIF) = 1.0
         FACMUL(2,1,LOOPIF) = 0.0
         FACMUL(1,2,LOOPIF) = 1.0
         FACMUL(2,2,LOOPIF) = 0.0
 50      CONTINUE
C                                       Loop over first antenna
      DO 200 LOOPA1 = 1,NUMANT
         DO 100 LOOPA2 = LOOPA1+1,NUMANT
C                                       Set baseline values
            BLANT1 = LOOPA1
            BLANT2 = LOOPA2
            DO 60 LOOPIF = 1,NUMIF
               FACMUL(1,1,LOOPIF) = BFAC(BLANT1,BLANT2)
               FACMUL(1,2,LOOPIF) = BFAC(BLANT1,BLANT2)
 60            CONTINUE
C                                       Write table entry
            CALL TABBL ('WRIT', SCBUFF, IBLRNO, BLKOLS, BLNUMV, NUMPOL,
     *         BLTIME, BLSID, BLSUB, BLANT1, BLANT2, BLFQID, FACMUL,
     *         FACADD, IERR)
            IF (IERR.NE.0) GO TO 999
 100        CONTINUE
 200     CONTINUE
C                                       Close table
      CALL TABIO ('CLOS', 0, IBLRNO, FACMUL, SCBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1200) IERR
         CALL MSGWRT (7)
         END IF
 999  RETURN
C-----------------------------------------------------------------------
 1200 FORMAT ('BLFAC: ERROR ',I5, ' CLOSING BL TABLE')
      END
      SUBROUTINE ANCLHI
C-----------------------------------------------------------------------
C   ANCLHI copies and updates history file.
C-----------------------------------------------------------------------
      INTEGER   LUN1, IERR, I, TIME(3), DATE(3)
      CHARACTER HILINE*72, LABEL*8, CTIME*20
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'ANCAL.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN1 /27/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HIOPEN (LUN1, DISKIN, FCNO(NCFILE), SCRTCH, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       Task message
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, CTIME(13:20), CTIME(1:12))
      WRITE (HILINE,1010) TSKNAM, RLSNAM, CTIME(1:12), CTIME(13:20)
      CALL HIADD (LUN1, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       File name
      WRITE (HILINE,2000) TSKNAM, NAME2
      CALL HIADD (LUN1, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       IF and Poln. no.
      WRITE (HILINE,2001) TSKNAM, BIF, EIF, POLNO
      CALL HIADD (LUN1, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       SUBARRAY, GAINVER
      WRITE (HILINE,2002) TSKNAM, SUBA, CLVER
      CALL HIADD (LUN1, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       BLVER
      WRITE (HILINE,2003) TSKNAM, BLVER
      CALL HIADD (LUN1, HILINE, SCRTCH, IERR)
      IF (IERR.NE.0) GO TO 100
C                                      Add any user supplied history.
         IF (NUMHIS.GT.0) THEN
            WRITE (LABEL,1011) TSKNAM
            DO 15 I = 1,NUMHIS
               HILINE = LABEL // HISCRD(I)
               CALL HIADD (LUN1, HILINE, SCRTCH, IERR)
               IF (IERR.NE.0) GO TO 100
 15            CONTINUE
            END IF
C                                       Close HI file
 100  CALL HICLOS (LUN1, .TRUE., SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ANCLHI: ERROR',I3,' OPENING HISTORY FILE')
 1010 FORMAT (A6,'RELEASE =''',A,' ''  /********* Start ',
     *   A12,2X,A8)
 1011 FORMAT (A6,' /')
 2000 FORMAT (A6, ' IN2NAME = ''',A48,'''')
 2001 FORMAT (A6, ' / BIF =',I3,' EIF =',I3,' Polno =',I3,
     *   ' from text file')
 2002 FORMAT (A6, ' SUBARRAY =',I3,' GAINVER = ',I4,' /CL table')
 2003 FORMAT (A6, ' BLVER = ',I4,' /BL table')
      END
      SUBROUTINE GETSYS (TIME, ANTNO, TSYST, IERR)
C-----------------------------------------------------------------------
C   Interpolate Tsys for Antenna no. ANTNO at time TIME from the TY
C   table.  If ITYRNO = 0 then the TY table will be opened and read.
C   Input:
C    TIME      D    IAT time (days)
C    ANTNO     I    Antenna number
C   Input/Output in common:
C    BIF       I    First IF
C    EIF       I    Last IF
C    ITYRNO    I    Pointer in TY table.
C    SCBUFF(*) I    Buffer for TY
C   Output:
C    TSYST     R(2,*)    Tsys (K) per poln /IF
C    IERR      I    Return error code, 0=>OK, 10=couldn't find.
C   Note: Uses LUN 30.
C-----------------------------------------------------------------------
      INTEGER   ANTNO, IERR
      REAL      TSYST(2,*)
      DOUBLE PRECISION TIME
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   IP1, IP2, LUN, PLUS1, LOOP, LIMIT, I, SID, SUB,
     *   FQID, NIF
      REAL      WT1, WT2, DT, XTI
      INCLUDE 'ANCAL.INC'
      INCLUDE 'ANCAL2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANS.INC'
C-----------------------------------------------------------------------
      IF (ITYRNO.GT.0) GO TO 100
C                                       Init TY table
      LUN = 30
      CALL TYINI ('READ', SCBUFF, DISKSC, CNOSC, ITYVER, CATBLK, LUN,
     *   ITYRNO, TYKOLS, TYNUMV, NUMPOL, NIF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
C                                       Get no. records
      NUMTY = SCBUFF(5)
C                                       Find time.
 100  IP1 = 2
      IP2 = 1
C                                       First record
      PLUS1 = ITYRNO
      CALL TABTY ('READ', SCBUFF, PLUS1, TYKOLS, TYNUMV, NUMPOL, NIF,
     *   XTIME(IP2), XTI, SID, ANT(IP2), SUB, FQID, XTSYS(1,1,IP2),
     *   XTANT(1,1,IP2), IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1100) IERR
         GO TO 990
         END IF
      LIMIT = ITYRNO + 1
      DO 300 LOOP = LIMIT,NUMTY
C                                       Flip pointers
         IP1 = 3 - IP1
         IP2 = 3 - IP2
C                                       Right antenna
         PLUS1 = ITYRNO + 1
         CALL TABTY ('READ', SCBUFF, PLUS1, TYKOLS, TYNUMV, NUMPOL, NIF,
     *      XTIME(IP2), XTI, SID, ANT(IP2), SUB, FQID, XTSYS(1,1,IP2),
     *      XTANT(1,1,IP2), IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1100) IERR
            GO TO 990
            END IF
         IF (ANT(IP1).LT.ANTNO) GO TO 250
         IF (ANT(IP1).GT.ANTNO) GO TO 350
         IF ((TIME.GT.XTIME(IP2)) .AND. (ANTNO.EQ.ANT(IP2))) GO TO 250
         IF (TIME.GE.XTIME(IP1)) GO TO 180
C                                       Before first time
            DO 170 I = 1, EIF - BIF + 1
               TSYST(1,I) = XTSYS(1,I,IP1)
               TSYST(2,I) = XTSYS(2,I,IP1)
 170           CONTINUE
            GO TO 999
 180     IF (ANT(IP1).EQ.ANT(IP2)) THEN
C                                       Between, interpolate
            DT = (XTIME(IP2)-XTIME(IP1))
            IF (DT.LT.1.0E-10) DT = 1.0
            WT1 = (TIME-XTIME(IP1)) / DT
            WT2 = 1.0 - WT1
            DO 190 I = 1, EIF - BIF + 1
               IF ((XTSYS(1,I,IP1).EQ.FBLANK).OR.
     *            (XTSYS(1,I,IP2).EQ.FBLANK)) THEN
                  TSYST(1,I) = FBLANK
               ELSE
                  TSYST(1,I)  = WT2*XTSYS(1,I,IP1) + WT1*XTSYS(1,I,IP2)
                  END IF
               IF ((XTSYS(2,I,IP1).EQ.FBLANK).OR.
     *            (XTSYS(2,I,IP2).EQ.FBLANK)) THEN
                  TSYST(2,I) = FBLANK
               ELSE
                  TSYST(2,I)  = WT2*XTSYS(2,I,IP1) + WT1*XTSYS(2,I,IP2)
                  ENDIF
 190           CONTINUE
            GO TO 999
            END IF
C                                       After last time
            DO 210 I = 1, EIF - BIF + 1
               TSYST(1,I) = XTSYS(1,I,IP1)
               TSYST(2,I) = XTSYS(2,I,IP1)
 210           CONTINUE
            GO TO 999
C                                       Loop back and try next record.
 250     ITYRNO = ITYRNO + 1
 300     CONTINUE
      IF (ANTNO.EQ.ANT(IP2)) THEN
C                                       Must be after last in table
         DO 310 I = I, EIF - BIF + 1
            TSYST(1,I) = XTSYS(1,I,IP2)
            TSYST(2,I) = XTSYS(2,I,IP2)
 310        CONTINUE
         GO TO 999
         END IF
C                                       Something screwed up,
 350   WRITE (MSGTXT,1350) TIME, STNNAM(ANTNO)
       IERR = 10
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GETSYS: ERROR ',I3,' OPENING TY TABLE FOR READ')
 1100 FORMAT ('GETSYS: ERROR ',I3,' READING TY TABLE ')
 1350 FORMAT ('GETSYS: COULD NOT FIND TSYS FOR TIME=',F8.5,' ANT=',A)
      END
      SUBROUTINE TYCONS (IERR)
C-----------------------------------------------------------------------
C  Consolidate the TY table - due to the nature of the Tsys ASCII
C  file the source name is not attached to the Tsys's in a predictable
C  manner - therefore after dealing with all the tables we must run
C  back through the TY table and add sourcename info garnered from
C  the CL table
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER  IERR
C
      INTEGER  MAXNX
      PARAMETER (MAXNX = 20000)
      INTEGER  NXSRC(MAXNX), NXSUB(MAXNX), NXANT(MAXNX), I, J,  NUMNX,
     *   SUBARR, NUMPLT, NIFTY, SOURID, LUNG, ICLRNO, NUMREC,
     *   CLKOLS(MAXCLC), CLNUMV(MAXCLC), NUMNOD, NTERM, KKEY(2,2),
     *   SID, SUB, FQID, TYANT, RECI(13+32*MAXIF), NTYCHN, ANTNO,
     *   KEYSUB(2,2)
      REAL     XTI, TYTIM, GMMOD, FKEY(2,2), RECORD(13+32*MAXIF),
     *   DT, NXTIM(2,MAXNX)
      DOUBLE PRECISION RECD(13+32*MAXIF), TIME
      INCLUDE 'ANCAL.INC'
      INCLUDE 'ANCAL2.INC'
      INCLUDE 'INCS:PCLTAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (RECORD, RECI, RECD)
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
C-----------------------------------------------------------------------
      IERR = 0
C                                         Open CL table
      LUNG = 28
      CALL CALINI ('READ', SCBUFF, DISKCL, CNOCL, CLVER, CATBLK, LUNG,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, NTERM,
     *   GMMOD, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
C                                       Set sort keys
      KKEY(1,1) = CLIANT
      KKEY(2,1) = CLIANT
      KKEY(1,2) = CLDTIM
      KKEY(2,2) = CLDTIM
      NUMREC = SCBUFF(5)
C                                       Close table
      CALL TABIO ('CLOS', 0, ICLRNO, RECORD, SCBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Sort to antenna time order.
      IF ((SCBUFF(43).NE.CLIANT) .OR. (SCBUFF(44).NE.CLDTIM)) THEN
         CALL TABSRT (DISKCL, CNOCL, 'CL', CLVER, CLVER, KKEY, KEYSUB,
     *      FKEY, SCBUFF, CATBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                         Reopen CL table read/write
      CALL CALINI ('READ', SCBUFF, DISKCL, CNOCL, CLVER, CATBLK, LUNG,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, NTERM,
     *   GMMOD, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         GO TO 990
         END IF
C                                      Load up info from CL table
      NUMNX = -1
      DO 150 I = 1, NUMREC
         ICLRNO = I
         CALL TABIO ('READ', 0, ICLRNO, RECORD, SCBUFF, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1010) IERR, 'READ'
            GO TO 990
            END IF
C                                       Get time, etc.
         TIME = RECD(CLKOLS(CLDTIM))
         DT = RECORD(CLKOLS(CLRTMI))
         SOURID = RECI(CLKOLS(CLISID))
         ANTNO = RECI(CLKOLS(CLIANT))
         SUBARR = RECI(CLKOLS(CLISUB))
         IF (NUMNX.EQ.-1) THEN
            NUMNX = 1
            NXTIM(1,NUMNX) = TIME - 0.5 * DT
            NXTIM(2,NUMNX) = TIME + 0.5 * DT
            NXSRC(NUMNX) = SOURID
            NXANT(NUMNX) = ANTNO
            NXSUB(NUMNX) = SUBARR
            END IF
         IF ((SOURID.NE.NXSRC(NUMNX)) .OR. (ANTNO.NE.NXANT(NUMNX))
     *      .OR. (SUBARR.NE.NXSUB(NUMNX))) THEN
            NUMNX = NUMNX + 1
C                                       Check for array boundary error
            IF (NUMNX.GT.MAXNX) THEN
               WRITE (MSGTXT,1015)
               GO TO 990
               END IF
            NXTIM(1,NUMNX) = TIME - 0.5 * DT
            NXTIM(2,NUMNX) = TIME + 0.5 * DT
            NXSRC(NUMNX) = SOURID
            NXANT(NUMNX) = ANTNO
            NXSUB(NUMNX) = SUBARR
            END IF
         NXTIM(2,NUMNX) = TIME + 0.5 * DT
 150     CONTINUE
C                                       Close table
      CALL TABIO ('CLOS', 0, ICLRNO, RECORD, SCBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get the Tsys
C                                       Open Tsys table.
      NTYCHN = 0
      LUNSC = 30
      ITYRNO = 0
      NUMPLT = NUMPOL
      CALL TYINI ('WRIT', SXBUFF, DISKSC, CNOSC, ITYVER, CATBLK,
     *   LUNSC, ITYRNO, TYKOLS, TYNUMV, NUMPLT, NIFTY, IERR)
      IF (IERR.NE.0) GO TO 999
      NUMTY = SXBUFF(5)
C                                         Loop through TY table,
C                                         obtain necessary info from
C                                         NX arrays
      DO 300 I = 1, NUMTY
         ITYRNO = I
         CALL TABTY ('READ', SXBUFF, ITYRNO, TYKOLS, TYNUMV, NUMPLT,
     *      NIFTY, TYTIM, XTI, SID, TYANT, SUB, FQID, XTSYS, XTANT,
     *      IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) IERR
            GO TO 990
            END IF
C                                         need to change an entry?
         IF (SID.GT.0) GO TO 300
C                                         find appropriate slot in
C                                         NX arrays
         DO 200 J = 1, NUMNX
            IF ((TYTIM.GE.NXTIM(1,J)) .AND.
     *         (TYTIM.LE.NXTIM(2,J)) .AND. (TYANT.EQ.NXANT(J))) THEN
C                                      found entry
               SID = NXSRC(J)
               SUB = NXSUB(J)
               ITYRNO = I
               NTYCHN = NTYCHN + 1
               CALL TABTY ('WRIT', SXBUFF, ITYRNO, TYKOLS, TYNUMV,
     *            NUMPLT, NIFTY, TYTIM, XTI, SID, TYANT, SUB, FQID,
     *            XTSYS, XTANT, IERR)
               IF (IERR.NE.0) THEN
                  WRITE (MSGTXT,1030) IERR
                  GO TO 990
                  END IF
               END IF
 200        CONTINUE
 300     CONTINUE
C                                       Close TY table
      CALL TABIO ('CLOS', 0, ITYRNO, RECORD, SXBUFF, IERR)
      IF (IERR.NE.0) GO TO 999
C
      IF (NTYCHN.GT.NUMTY) NTYCHN = NUMTY
      WRITE (MSGTXT,1040) NTYCHN, NUMTY
      CALL MSGWRT (6)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TYCONS: ERROR ',I3,' OPENING CL TABLE')
 1010 FORMAT ('TYCONS: TABIO ERROR =',I3,1X,A4,'ING CL TABLE')
 1015 FORMAT ('TYCONS: PARAMETER MAXNX TOO SMALL')
 1020 FORMAT ('TYCONS: ERROR ',I3,' READING TY TABLE ')
 1030 FORMAT ('TYCONS: ERROR ',I3,' WRITING TY TABLE ')
 1040 FORMAT ('TYCONS: Added Source info to ',I5,' of ',I5,' TY',
     *   ' entries')
      END
      SUBROUTINE CHKORD (VALCH, TORDER, CHANB, CHANE, LIF, HIF, POLNO,
     *                   NCOL)
C-----------------------------------------------------------------------
C  Routine to read the INDEX keyword-values and fill in the TORDER
C  array. TORDER is an index used to sort the TSYS, TANT entries as they
C  are read into the TSYS table. The format of TORDER is:
C
C      TORDER(input) = output + 100*(poln-1)
C
C  where input is the column in the input file, output is the IF column
C  in the TSYS table and poln is either 1(RHC) or 2(LHC).
C
C  Input:
C     VALCH    C(*)*8       Characters from INDEX keyword-value
C  Output:
C     TORDER   I(*)         index
C     CHANB    I            Lowest channel
C     CHANE    I            Highest channel
C     LIF      I            Lowest IF i.e. different freq channels.
C     HIF      I            Lowest IF i.e. different freq channels.
C     POLNO    I            1 if all RHC, 2 if all LHC, 3 if both
C     NCOL     I            The number of columns indexed.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
C
      CHARACTER VALCH(*)*8
      INTEGER   TORDER(*), CHANB, CHANE, LIF, HIF, POLNO, NCOL
C
      INTEGER   I, MXIF, POLN, IPT, NIF
      LOGICAL   SOMER, SOMEL
      DATA MXIF /MAXIF/
C-----------------------------------------------------------------------
      CHANB = MXIF
      CHANE = 1
      NIF = 0
      SOMER = .FALSE.
      SOMEL = .FALSE.
      DO 100 I = 1,MXIF
         IF (VALCH(I)(1:1).NE.' ') THEN
            NIF = NIF + 1
            IF (VALCH(I)(1:1).EQ.'X') THEN
               IPT = 2
               CALL CITC2I (VALCH(I), 8, IPT, TORDER(I))
               CHANB = MIN (CHANB, TORDER(I))
               CHANE = MAX (CHANE, TORDER(I))
               TORDER(I) = -1
               GO TO 100
               END IF
            POLN = 0
            IF (VALCH(I)(1:1).EQ.'R') POLN = 1
            IF (VALCH(I)(1:1).EQ.'L') POLN = 2
            IPT = 2
            CALL CITC2I (VALCH(I), 8, IPT, TORDER(I))
            CHANB = MIN (CHANB, TORDER(I))
            CHANE = MAX (CHANE, TORDER(I))
            IF (POLN.EQ.1) SOMER = .TRUE.
            IF (POLN.EQ.2) SOMEL = .TRUE.
            TORDER(I) = TORDER(I) + 100*(POLN-1)
            IF (TORDER(I).LT.0) TORDER(I) = 0
            END IF
 100     CONTINUE
C
      LIF = CHANB
      HIF = CHANE
      CHANE = MAX (CHANE, NIF)
      NCOL = NIF
      IF (SOMER .AND. SOMEL) POLNO = 3
      IF (SOMER .AND. (.NOT.SOMEL)) POLNO = 1
      IF ((.NOT.SOMER) .AND. SOMEL) POLNO = 2
C
 999  RETURN
      END

C *** ZETA PDP-11 FORTRAN ZSUBS   RELEASE 5.36 OF 12/78
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
      SUBROUTINE NEWPEN(IPEN)
      COMMON /ZYYZ/ICHAR,IOBUFF(1100),IASCI(32),IDUM1,IPENUP,
     + IDUM2(9),IPNUM,IPRIM,IDUM3(3),OLDX,OLDY,DUM1(7),X0,DUM2(19)
      IOBUFF(ICHAR)=IASCI(8)
      IOBUFF(ICHAR+1)=IASCI(IPEN+1)
      ICHAR=ICHAR+2
      IPNUM=IPEN
      IPENUP=3
      IF(IPRIM.EQ.0)GO TO 10
      XSAV=OLDX
      CALL SYMBOL(-X0-1.5,OLDY,.2,5HPRIME,0.,5)
      CALL PLOT(XSAV,OLDY,3)
 10   RETURN
      END
      SUBROUTINE OFFSET(XO,XF,YO,YF)
      COMMON /ZYYZ/IDUM(1149),DUM1(2),XOFF,XFACT,
     + YOFF,YFACT,DUM2(23)
      XOFF=XO
      YOFF=YO
      YFACT=YF
      XFACT=XF
      RETURN
      END
      SUBROUTINE FACTOR(FACT1)
      COMMON /ZYYZ/IDUM(1149),DUM1(7),PMSIZE,FACT,DUM2(20)
      FACT=FACT1*PMSIZE*100.
      RETURN
      END
      SUBROUTINE ZETAPS(ISW,NUMPAT,ITOTNP)
      COMMON /ZYYZ/ICHAR,IOBUFF(1100),IASCI(32),IDASH,IDUM1,IOBLOK,
     + IDUM2(10),ISTORE,IPSTAT,IPLOC,OLDX,OLDY,DUM1(6),FACT,DUM2(20)
      COMMON /ZXXZ/IPA(1)
      CALL PLOT(OLDX,OLDY,3)
      IK=3*NUMPAT
      GO TO (100,100,200,300),ISW+1
 100  IPSTAT=ISW
      IPA(1)=ITOTNP*3+1
      IPA(IK-1)=OLDX*FACT+SIGN(.5,OLDX)
      IPA(IK)=OLDY*FACT+SIGN(.5,OLDY)
      IPLOC=ICHAR
      RETURN
 200  CALL ZZZZ
      IF(IPSTAT.EQ.0)GO TO 210
      IPA(IK-1)=OLDX*FACT+SIGN(.5,OLDX)-IPA(IK-1)
      IPA(IK)=OLDY*FACT+SIGN(.5,OLDY)-IPA(IK)
      GO TO 220
 210  ICHAR=IPLOC
      ITEMP=OLDX*FACT+SIGN(.5,OLDX)
      OLDX=IPA(IK-1)/FACT
      IPA(IK-1)=ITEMP-IPA(IK-1)
      ITEMP=OLDY*FACT+SIGN(.5,OLDY)
      OLDY=IPA(IK)/FACT
      IPA(IK)=ITEMP-IPA(IK)
 220  IPA(IK+1)=IPA(1)+ISTORE-1
      IPSTAT=-1
      RETURN
 300  ISTRT=IPA(IK-2)+1
      IFIN=IPA(IK+1)
 310  ITEMP=ISTRT+59
      IF(ITEMP.GT.IFIN)ITEMP=IFIN
      J=ICHAR-ISTRT
      DO 320 I=ISTRT,ITEMP
      IOBUFF(J+I)=IPA(I)
 320  CONTINUE
      ICHAR=J+ITEMP+1
      IF(ICHAR.GT.IOBLOK)CALL PLOT(OLDX,OLDY,3)
      IF(ITEMP.EQ.IFIN)GO TO 330
      ISTRT=ISTRT+60
      GO TO 310
 330  OLDX=OLDX+IPA(IK-1)/FACT
      OLDY=OLDY+IPA(IK)/FACT
      RETURN
      END
      SUBROUTINE WHERE(X,Y,FACT1)
      COMMON /ZYYZ/IDUM(1149),OLDX,OLDY,DUM1(5),
     + PMSIZE,FACT,DUM2(20)
      X=OLDX
      Y=OLDY
      FACT1=FACT/(PMSIZE*100.)
      RETURN
      END
      SUBROUTINE POFF
      CALL PLOT(0.,0.,998)
      RETURN
      END
      SUBROUTINE SPEED(IRATE)
      DIMENSION JRATE(20,2)
      COMMON /ZYYZ/ICHAR,IOBUFF(1100),IASCI(32),IDUM1(10),
     + MONIT,IDUM2(5),DUM(29)
      DATA JRATE/
     + 1H0,1H0,1H0,1H0,1H0,1H0,1H0,1H0,1H0,1H0,
     + 1H0,1H1,1H1,1H1,1H1,1H1,1H2,1H2,1H3,1H4,
     + 1H0,1H1,1H2,1H3,1H5,1H7,1HC,1HF,1HJ,1HO,
     + 1HT,1H0,1H6,1HE,1HL,1HS,1H2,1HC,1H4,1H6/
      IOBUFF(ICHAR)=IASCI(8)
      IOBUFF(ICHAR+1)=IASCI(6)
      ITEMP=IASCI(1)
      IF(MONIT.EQ.0)GO TO 10
      IOBUFF(ICHAR+2)=IASCI(IRATE+1)
      IOBUFF(ICHAR+3)=ITEMP
      IOBUFF(ICHAR+4)=ITEMP
      IOBUFF(ICHAR+5)=ITEMP
      GO TO 20
 10   IOBUFF(ICHAR+2)=ITEMP
      IOBUFF(ICHAR+3)=ITEMP
      IOBUFF(ICHAR+4)=JRATE(IRATE,1)
      IOBUFF(ICHAR+5)=JRATE(IRATE,2)
 20   ICHAR=ICHAR+6
      RETURN
      END
      SUBROUTINE ZPAUSE
      COMMON /ZYYZ/ICHAR,IOBUFF(1100),IASCI(32),IDUM(16),DUM(29)
      IOBUFF(ICHAR)=IASCI(8)
      IOBUFF(ICHAR+1)=IASCI(9)
      ICHAR=ICHAR+2
      RETURN
      END
      SUBROUTINE ZETOBS(M256)
      COMMON /ZYYZ/IDUM1(1135),IOBLOK,IOBLKS,IDUM2(12),DUM(29)
      IOBLKS=M256*256
      IOBLOK=IOBLKS
      RETURN
      END
      SUBROUTINE SYMBOL(X,Y,SIZE,MESS,ANGLE,N)
      DIMENSION MESS(1),INDEX(308)
      LOGICAL*1 LTEMP(2)
      EQUIVALENCE (JTEMP,LTEMP)
      COMMON /ZYYZ/ICHAR,IOBUFF(1100),IASCI(32),IDASH,IPENUP,IOBLOK,
     + IDUM1(7),MONIT,IDUM2(5),OLDX,OLDY,DUM1(4),ASPCT,DUM2(22)
      DATA INDEX/64,19,20,64,22,23,109,64,26,27,28,29,31,74,95,
     + 64,90,127,123,91,108,80,125,77,93,92,78,107,96,75,97,112,
     + 113,114,115,116,117,118,119,120,121,122,94,76,126,110,
     + 111,124,65,66,67,68,69,70,71,72,73,81,82,83,84,85,86,87,
     + 88,89,98,99,100,101,102,103,104,105,53,55,54,18,24,34,35,
     + 36,37,38,39,40,41,42,43,44,45,64,64,48,49,50,51,52,56,57,
     + 58,59,60,61,62,63,33,79,32,30,106,
     + 34,35,36,37,38,39,40,41,42,43,44,45,56,48,27,52,57,49,61,
     + 23,22,50,51,19,31,20,62,60,63,29,106,74,64,90,127,123,91,
     + 108,80,125,77,93,92,78,107,96,75,97,112,113,114,115,116,
     + 117,118,119,120,121,122,94,76,126,110,111,124,65,66,67,68,
     + 69,70,71,72,73,81,82,83,84,85,86,87,88,89,98,99,100,101,
     + 102,103,104,105,53,55,54,18,24,26,128,129,130,131,132,133,
     + 134,135,136,137,138,139,140,141,142,143,144,145,146,147,
     + 148,149,150,151,152,153,33,79,32,30,109,95,28,58,59,154,
     + 155,156,157,158,159,160,161,162,163,164,165,166,167,168,
     + 169,170,171,172,173,174,175,176,177,178,179,180,181,182,
     + 183,184,185,186,187,188,189,190,191,192,193,194,195,196,
     + 197,198,199,200,201,202,203,204,205,206,207,208,209,210,
     + 211,212,213,214,215,216,217,218/
      XZ=X
      YZ=Y
      SIZASP=SIZE*ASPCT
      IF(ANGLE.NE.0.)GO TO 10
      ANGCOS=1.
      ANGSIN=0.
      GO TO 30
 10   IF(ANGLE.NE.90.)GO TO 20
      ANGCOS=0.
      ANGSIN=1.
      GO TO 30
 20   TEMP1=ANGLE*.0174532925
      ANGCOS=COS(TEMP1)
      ANGSIN=SIN(TEMP1)
 30   IF(X.EQ.999.)XZ=OLDX
      IF(Y.NE.999.)GO TO 40
      IF(X.EQ.999.)GO TO 50
      YZ=OLDY
 40   ITEMP=3
      IF(N.LT.-1)ITEMP=-N
      CALL PLOT(XZ,YZ,ITEMP)
 50   IF(N)140,130,60
 60   IOBUFF(ICHAR)=IASCI(4)
      ICHAR=ICHAR+1
      SIZASP=ABS(SIZASP)*N
      IDASHS=IDASH
      IDASH=-10
      CALL PLOT(SIZASP*ANGCOS+OLDX,SIZASP*ANGSIN+OLDY,IPENUP)
      IOBUFF(ICHAR)=IASCI(N/32+1)
      IOBUFF(ICHAR+1)=IASCI((N.AND."37)+1)
      ICHAR=ICHAR+2
      I=1
      IOFF=-16+128*MONIT
      IF(SIZE.GT.0.)GO TO 90
 70   J=I+29
      IF(J.GT.N)J=N
 80   ITEMP=INDEX((MESS(I).AND."377)+IOFF)
      IOBUFF(ICHAR)=IASCI(ITEMP/32+1)
      IOBUFF(ICHAR+1)=IASCI((ITEMP.AND."37)+1)
      ICHAR=ICHAR+2
      I=I+1
      IF(I.LE.J)GO TO 80
      IF(ICHAR.GT.IOBLOK)CALL PLOT(OLDX,OLDY,IPENUP)
      IF(J.NE.N)GO TO 70
      IDASH=IDASHS
      RETURN
 90   NWDS=(N+1)/2
 100  J=I+14
      IF(J.GT.NWDS)J=NWDS
 110  ITEMP=INDEX((MESS(I).AND."377)+IOFF)
      IOBUFF(ICHAR)=IASCI(ITEMP/32+1)
      IOBUFF(ICHAR+1)=IASCI((ITEMP.AND."37)+1)
      JTEMP=MESS(I)
      ITEMP=LTEMP(2)
      ITEMP=INDEX((ITEMP.AND."377)+IOFF)
      IOBUFF(ICHAR+2)=IASCI(ITEMP/32+1)
      IOBUFF(ICHAR+3)=IASCI((ITEMP.AND."37)+1)
      ICHAR=ICHAR+4
      I=I+1
      IF(I.LE.J)GO TO 110
      IF(J.EQ.NWDS)GO TO 120
      IF(ICHAR.GT.IOBLOK)CALL PLOT(OLDX,OLDY,IPENUP)
      GO TO 100
 120  IF(N.NE.NWDS*2)ICHAR=ICHAR-2
      IF(ICHAR.GT.IOBLOK)CALL PLOT(OLDX,OLDY,IPENUP)
      IDASH=IDASHS
      RETURN
 130  IOBUFF(ICHAR)=IASCI(4)
      ICHAR=ICHAR+1
      IDASHS=IDASH
      IDASH=-10
      CALL PLOT(SIZASP*ANGCOS+OLDX,SIZASP*ANGSIN+OLDY,IPENUP)
      IDASH=IDASHS
      IOBUFF(ICHAR)=IASCI(1)
      IOBUFF(ICHAR+1)=IASCI(2)
      ITEMP=INDEX(MESS(1)-16+128*MONIT)
      IOBUFF(ICHAR+2)=IASCI(ITEMP/32+1)
      IOBUFF(ICHAR+3)=IASCI((ITEMP.AND."37)+1)
      ICHAR=ICHAR+4
      RETURN
 140  IOBUFF(ICHAR)=IASCI(5)
      ICHAR=ICHAR+1
      SIZASP=SIZASP*1.75
      TEMP1=OLDX
      TEMP2=OLDY
      IDASHS=IDASH
      IDASH=-10
      CALL PLOT(SIZASP*ANGCOS+OLDX,SIZASP*ANGSIN+OLDY,IPENUP)
      IDASH=IDASHS
      OLDX=TEMP1
      OLDY=TEMP2
      IOBUFF(ICHAR)=IASCI(MESS(1)+1)
      ICHAR=ICHAR+1
      RETURN
      END
      SUBROUTINE AXIS(X,Y,MESS,NCHARS,AXLEN,ANGLE,FIRVAL,DELVAL)
      INTEGER   N1
      COMMON /ZYYZ/IDUM1(1133),IDASH,IDUM2(15),OLDX,OLDY,
     + DUM1(4),ASPCT,DUM2(22)
      DIMENSION MESS(1)
      DATA N1 /1/
      ISIDE=SIGN(N1,NCHARS)
      TEMP1=ANGLE*.0174533
      ANGCOS=COS(TEMP1)
      ANGSIN=SIN(TEMP1)
      IF(FIRVAL.NE.999.)GO TO 10
      NTIC=AXLEN/DELVAL+1.E-5
      TEMP1=ANGCOS*DELVAL
      TEMP2=ANGSIN*DELVAL
      GO TO 70
 10   IEXPT=0
      TEMP1=ABS(DELVAL)
 20   IF(TEMP1.GT.0.0099)GO TO 30
      TEMP1=TEMP1*10.
      IEXPT=IEXPT-1
      GO TO 20
 30   NTIC=AXLEN+1.E-5
      TEMP1=FIRVAL+NTIC*DELVAL
      TEMP1=MAX(ABS(FIRVAL),ABS(TEMP1))*10.**(-IEXPT)
 40   IF(TEMP1.LT.999.95)GO TO 50
      TEMP1=TEMP1/10.
      IEXPT=IEXPT+1
      GO TO 40
 50   TEMP1=10.**(-IEXPT)
      TICVAL=FIRVAL*TEMP1
      TICDEL=DELVAL*TEMP1
      TEMP1=ISIDE*.1575-.0525
      TEMP2=ASPCT*.105
      XX=X-TEMP1*ANGSIN-TEMP2*ANGCOS
      YY=Y+TEMP1*ANGCOS-TEMP2*ANGSIN
      DO 60 I=0,NTIC
      CALL NUMBER(XX,YY,.105,TICVAL,ANGLE,2)
      XX=XX+ANGCOS
      YY=YY+ANGSIN
      TICVAL=TICVAL+TICDEL
 60   CONTINUE
      TEMP1=ANGCOS
      TEMP2=ANGSIN
 70   XX=X+AXLEN*ANGCOS
      YY=Y+AXLEN*ANGSIN
      CALL PLOT(XX,YY,3)
      XX=X+NTIC*TEMP1
      YY=Y+NTIC*TEMP2
      CALL PLOT(XX,YY,2)
      ITEMP=IDASH
      IDASH=-10
      TICX=-.07*ANGSIN*ISIDE
      TICY=.07*ANGCOS*ISIDE
      CALL PLOT(XX+TICX,YY+TICY,2)
      CALL PLOT(XX,YY,2)
      DO 80 I=1,NTIC
      XX=XX-TEMP1
      YY=YY-TEMP2
      CALL PLOT(XX,YY,2)
      CALL PLOT(XX+TICX,YY+TICY,2)
      CALL PLOT(XX,YY,2)
 80   CONTINUE
      IDASH=ITEMP
      IF(FIRVAL.EQ.999.)RETURN
      IF(NCHARS.NE.0)GO TO 90
      IF(IEXPT.EQ.0)RETURN
 90   ITEMP=ABS(NCHARS)
      TEMP1=ISIDE*.35-.07
      TEMP2=.14*ITEMP
      IF(IEXPT.NE.0)TEMP2=TEMP2+.56
      TEMP2=(AXLEN-TEMP2*ASPCT)/2.
      CALL PLOT(X+TEMP2*ANGCOS-TEMP1*ANGSIN,
     + Y+TEMP2*ANGSIN+TEMP1*ANGCOS,3)
      IF(NCHARS.EQ.0)GO TO 110
      CALL SYMBOL(999.,999.,.14,MESS,ANGLE,ITEMP)
      IF(IEXPT.EQ.0)RETURN
 110  CALL SYMBOL(999.,999.,.14,4H *10,ANGLE,4)
      TEMP1=IEXPT
      CALL NUMBER(OLDX-.11*ANGSIN,OLDY+.11*ANGCOS,
     + .07,TEMP1,ANGLE,-1)
      RETURN
      END
      SUBROUTINE LINE(XARR,YARR,NPTS,KCYCLE,NDP,ILETT)
      DIMENSION XARR(1),YARR(1)
      COMMON /ZYYZ/IDUM(1149),DUM1(2),XOFF,XFACT,YOFF,YFACT,DUM2(23)
      IF(NPTS.LT.0)GO TO 50
      IPTS=NPTS
      INC=KCYCLE
      IF(NDP)10,40,20
 10   IPEN=3
      INCSYM=-NDP
      GO TO 30
 20   IPEN=2
      INCSYM=NDP
 30   I=IPTS*INC+1
      XO=XARR(I)
      YO=YARR(I)
      I=I+INC
      XF=XARR(I)
      YF=YARR(I)
      GO TO 70
 40   INCSYM=0
      IPEN=ILETT
      IF(IPEN.LT.10)GO TO 30
      GO TO 60
 50   INC=1
      IPTS=-NPTS
      INCSYM=ABS(NDP)
      IPEN=KCYCLE
      IF(IPEN.LT.10)GO TO 30
 60   IPEN=IPEN-10
      XO=XOFF
      YO=YOFF
      XF=XFACT
      YF=YFACT
 70   X=(XARR(1)-XO)/XF
      Y=(YARR(1)-YO)/YF
      CALL PLOT(X,Y,3)
      IF(INCSYM.GT.0)CALL SYMBOL(999.,999.,.08,ILETT,0.,-1)
      I=2
      J=1
      K=1
 80   K=K+INC
      X=(XARR(K)-XO)/XF
      Y=(YARR(K)-YO)/YF
      CALL PLOT(X,Y,IPEN)
      IF(J.NE.INCSYM)GO TO 90
      CALL SYMBOL(999.,999.,.08,ILETT,0.,-1)
      J=0
 90   IF(I.EQ.IPTS)RETURN
      I=I+1
      J=J+1
      GO TO 80
      END
      SUBROUTINE SCALE(ARRAY,AXLEN,NPTS,INC1)
      DIMENSION ARRAY(1)
      INC=ABS(INC1)
      AMAX=ARRAY(1)
      AMIN=AMAX
      J=1
      DO 40 I=2,NPTS
      J=J+INC
      X=ARRAY(J)
      IF(AMAX.GE.X)GO TO 20
      AMAX=X
      GO TO 40
20    IF(AMIN.LE.X)GO TO 40
      AMIN=X
40    CONTINUE
      IF(AMAX.NE.AMIN) GO TO 45
      X=AXLEN/3.
      AMAX=AMAX+X
      AMIN=AMIN-X
 45   FNUM=(AMAX-AMIN)/AXLEN
      POW=LOG10(FNUM)
      IPOW=POW+.01
      IF(POW.LT.0.)IPOW=POW-.99
      IDIG=(FNUM/10.**IPOW)+.99
 47   IF(IDIG-2)50,100,70
 50   IDIG=1
      GO TO 100
70    IF(IDIG-5)80,100,87
80    IDIG=4
      GO TO 100
87    IF(IDIG-8)88,100,90
88    IDIG=8
      GO TO 100
90    IPOW=IPOW+1
      GO TO 50
 100  FUDGE=10.**(IPOW-5)
      DELTAV=IDIG*10.**IPOW
      IF(AMIN)105,110,115
 105  FIRST=AINT(AMIN/(DELTAV+FUDGE)-1.)
      GO TO 120
 110  FIRST=0.
      GO TO 120
 115  FIRST=AINT(AMIN/(DELTAV-FUDGE))
 120  FIRSTV=DELTAV*FIRST+FUDGE
      ALASTV=FIRSTV+(AXLEN*DELTAV)
      IF(ALASTV.GE.AMAX)GO TO 140
      IDIG=IDIG+1
      GO TO 47
 140  NAME1=NPTS*INC+1
      NAME2=NAME1+INC
      IF(INC1.LT.0)GO TO 170
      ARRAY(NAME1)=FIRSTV
      ARRAY(NAME2)=DELTAV
      GO TO 180
170   ARRAY(NAME1)=ALASTV
      ARRAY(NAME2)=-DELTAV
180   RETURN
      END
      SUBROUTINE NUMBER(X,Y,SIZE1,FNUM1,ANGLE,NDEC1)
      DIMENSION MESBUF(40)
      COMMON /ZYYZ/ICHAR,IOBUFF(1100),IASCI(32),IDASH,IPENUP,
     + IDUM(14),OLDX,OLDY,DUM1(4),ASPCT,DUM2(22)
      XZ=X
      YZ=Y
      IF(ANGLE.NE.0.)GO TO 1
      ANGCOS=1.
      ANGSIN=0.
      GO TO 3
 1    IF(ANGLE.NE.90.)GO TO 2
      ANGCOS=0.
      ANGSIN=1.
      GO TO 3
 2    TEMP=ANGLE*.0174532925
      ANGCOS=COS(TEMP)
      ANGSIN=SIN(TEMP)
 3    IF(X.EQ.999.)XZ=OLDX
      IF(Y.NE.999.)GO TO 4
      IF(X.EQ.999.)GO TO 5
      YZ=OLDY
 4    CALL PLOT(XZ,YZ,3)
 5    FNUM=FNUM1
      NDEC=-NDEC1
      IF(NDEC.GT.0)NDEC=NDEC-1
      IBSIZE=1
      IPOW=0
      IF(FNUM)10,75,20
10    MESBUF(IBSIZE)=IASCI(11)
      IBSIZE=IBSIZE+1
      FNUM=-FNUM
20    FNUM=FNUM+.5*10.**NDEC
      POW=LOG10(FNUM)
      IPOW=POW
      IF(POW.GE.0.)GO TO 75
      IPOW=POW-1.
      MESBUF(IBSIZE)=IASCI(1)
      IBSIZE=IBSIZE+1
      IF(NDEC1.LT.0)GO TO 100
      IPOW=0
50    IF(NDEC1.LT.0)GO TO 70
      MESBUF(IBSIZE)=IASCI(12)
      IBSIZE=IBSIZE+1
70    IPOW=IPOW-1
75    IF(IPOW.LT.NDEC)GO TO 100
      IDIG=(FNUM/10.**IPOW)
      MESBUF(IBSIZE)=IASCI(IDIG+1)
      IBSIZE=IBSIZE+1
      FNUM=FNUM-(IDIG*(10.**IPOW))
      IF(IPOW.NE.0)GO TO 70
      GO TO 50
100   IBSIZE=IBSIZE-1
      IOBUFF(ICHAR)=IASCI(6)
      ICHAR=ICHAR+1
      TEMP=ASPCT*SIZE1*IBSIZE
      ITEMP=IDASH
      IDASH=-10
      CALL PLOT(TEMP*ANGCOS+OLDX,TEMP*ANGSIN+OLDY,IPENUP)
      IDASH=ITEMP
      IOBUFF(ICHAR)=IASCI(IBSIZE+1)
      ICHAR=ICHAR+1
      DO 110 K=1,IBSIZE
      IOBUFF(ICHAR)=MESBUF(K)
      ICHAR=ICHAR+1
110   CONTINUE
      RETURN
      END
      SUBROUTINE PLOTS(IREL,IDUMMY,LGUNIT)
      COMMON /ZYYZ/IDUM1(1101),IASCI(32),IDASH,IPENUP,IDUM2,
     + IOBLKS,ISBE,NDEV,IERR,IDUM3(3),MONIT,IPNUM,IPRIM,
     + ISTORE,IPSTAT,IDUM4,OLDX,OLDY,XOFF,XFACT,YOFF,YFACT,
     + ASPCT,PMSIZE,FACT,X0,Y0,DUM(18)
      DATA IASCI/1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1HA,1HB,1HC,
     + 1HD,1HE,1HF,1HG,1HH,1HI,1HJ,1HK,1HL,1HM,1HN,1HO,1HP,
     + 1HQ,1HR,1HS,1HT,1HU,1HV,1HW,1HX/
      IOBLKS=1024
      IERR=1
      IF(LGUNIT.EQ.-1)GO TO 20
      IF(LGUNIT.EQ.0)GO TO 10
      NDEV=ABS(LGUNIT)
      IERR=-1
      GO TO 20
 10   IERR=0
 20   IDASH=-10
      IPENUP=3
      IF(IREL.NE.53)GO TO 30
      ISBE=-1
      MONIT=1
      GO TO 40
 30   ISBE=0
      MONIT=0
 40   IPNUM=1
      IPRIM=0
      ISTORE=1
      IPSTAT=-1
      OLDX=0.
      OLDY=0.
      XOFF=0.
      XFACT=1.
      YOFF=0.
      YFACT=1.
      ASPCT=1.
      PMSIZE=4.
      FACT=PMSIZE*100.
      X0=0.
      Y0=0.
      CALL PON
      RETURN
      END
      SUBROUTINE PON
      COMMON /ZYYZ/ICHAR,IOBUFF(1100),IDUM1(34),IOBLOK,IOBLKS,
     + IDUM2(2),IERR,IEO,IEOB1,IEOB2,IDUM3(6),DUM(29)
      DATA ICZ,IC9/1HZ,1H9/
      IOBLOK=IOBLKS
      DO 10 I=1,10
      IOBUFF(I)=ICZ
 10   CONTINUE
      ICHAR=11
      IF(IERR.NE.1)GO TO 20
      TYPE 1000
      IEO=2
      IEOB1=IC9
      IEOB2=IC9
 20   RETURN
 1000 FORMAT(1H ,20HZZZZZZZZZZZZZZZZZZZZ)
      END
      SUBROUTINE PLOT(X,Y,IP)
      COMMON /ZYYZ/ICHAR,IOBUFF(1100),IASCI(32),IDASH,IPENUP,IOBLOK,
     + IOBLKS,ISBE,NDEV,IERR,IEO,IEOB1,IEOB2,IDUM2(4),IPSTAT,IPLOC,
     + OLDX,OLDY,XOFF,XFACT,YOFF,YFACT,DUM(2),FACT,X0,Y0,DASH(3,6)
      DIMENSION IACK(2),IAC(4),IB32(43)
      DATA IAC,MASK/1HY,1H8,1H9,1HZ,"37/
      DATA IB32/0,1,2,3,4,5,6,7,9*0,8,9,10,11,12,13,14,15,16,
     + 17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,0,0/
      XX=X
      YY=Y
 10   IF(IP.LT.0)GO TO 30
      IF(IP-998)40,610,20
 20   IPEN=3
      ASSIGN 530 TO IRET
      GO TO 60
 30   IPEN=-IP
      ASSIGN 520 TO IRET
      GO TO 50
 40   IPEN=IP
      ASSIGN 510 TO IRET
 50   IF(IPEN.LT.10)GO TO 60
      XX=(XX-XOFF)/XFACT
      YY=(YY-YOFF)/YFACT
      IPEN=IPEN-10
 60   DX=XX-OLDX
      DY=YY-OLDY
 65   DX1=DX*FACT
      IF(DX1)70,80,75
 70   IF(DX1.LT.-32400.)GO TO 760
      IDX=DX1-.5
      GO TO 85
 75   IF(DX1.GT.32400.)GO TO 760
      IDX=DX1+.5
      GO TO 85
 80   IDX=0
 85   DY1=DY*FACT
      IF(DY1)90,100,95
 90   IF(DY1.LT.-32400.)GO TO 770
      IDY=DY1-.5
      GO TO 105
 95   IF(DY1.GT.32400.)GO TO 770
      IDY=DY1+.5
      GO TO 105
 100  IDY=0
 105  IF(IDASH.NE.-10)GO TO 700
 110  IF(IPEN.EQ.IPENUP)GO TO 120
      IOBUFF(ICHAR)=IASCI(5-IPEN)
      ICHAR=ICHAR+1
      IPENUP=IPEN
 120  IKAR=ICHAR+1
      IF(IDX)140,130,150
 130  NBYTEX=1
      GO TO 230
 140  KXY=-IDX-1
      ISXY=1
      GO TO 160
 150  KXY=IDX
      ISXY=0
 160  IF(KXY.GT.15)GO TO 170
      NBYTEX=2
      JXY=32*ISXY+IDX
      GO TO 220
 170  IF(KXY.GT.511)GO TO 180
      NBYTEX=3
      JXY=1024*ISXY+IDX
      GO TO 210
 180  JXY=32767*ISXY+IDX+ISXY
      IF(KXY.GT.16383)GO TO 190
      NBYTEX=4
      GO TO 200
 190  NBYTEX=5
      IOBUFF(IKAR)=IASCI(ISXY*31+1)
      IKAR=IKAR+1
 200  ITEMP=JXY/1024
      IOBUFF(IKAR)=IASCI(ITEMP+1)
      IKAR=IKAR+1
 210  ITEMP=JXY/32
      ITEMP=ITEMP.AND.MASK
      IOBUFF(IKAR)=IASCI(ITEMP+1)
      IKAR=IKAR+1
      JXY=JXY.AND.MASK
 220  IOBUFF(IKAR)=IASCI(JXY+1)
      IKAR=IKAR+1
 230  IF(IDY)250,240,260
 240  NBYTEY=1
      IF(NBYTEX.GT.1)GO TO 340
      GO TO 350
 250  KXY=-IDY-1
      ISXY=1
      GO TO 270
 260  KXY=IDY
      ISXY=0
 270  IF(KXY.GT.15)GO TO 280
      NBYTEY=2
      JXY=32*ISXY+IDY
      GO TO 330
 280  IF(KXY.GT.511)GO TO 290
      NBYTEY=3
      JXY=1024*ISXY+IDY
      GO TO 320
 290  JXY=32767*ISXY+IDY+ISXY
      IF(KXY.GT.16383)GO TO 300
      NBYTEY=4
      GO TO 310
 300  NBYTEY=5
      IOBUFF(IKAR)=IASCI(ISXY*31+1)
      IKAR=IKAR+1
 310  ITEMP=JXY/1024
      IOBUFF(IKAR)=IASCI(ITEMP+1)
      IKAR=IKAR+1
 320  ITEMP=JXY/32
      ITEMP=ITEMP.AND.MASK
      IOBUFF(IKAR)=IASCI(ITEMP+1)
      IKAR=IKAR+1
      JXY=JXY.AND.MASK
 330  IOBUFF(IKAR)=IASCI(JXY+1)
      IKAR=IKAR+1
 340  IOBUFF(ICHAR)=IASCI(2+NBYTEY+5*NBYTEX)
      ICHAR=IKAR
 350  IF(ICHAR.LE.IOBLOK)GO TO IRET
      IF(IPSTAT.LT.0)GO TO 355
      CALL ZZZZ
      IF(IPSTAT.EQ.1)GO TO 353
      ICHAR=IPLOC
      GO TO IRET
 353  IPLOC=ICHAR-IOBLOK
 355  ICHAR=ICHAR-IOBLOK
      IF(IERR)500,490,360
 360  ICHKS=0
      DO 370 I=1,IOBLOK
      ITEMP=IOBUFF(I)-8239
      ICHKS=ICHKS+IB32(ITEMP)
 370  CONTINUE
      ICHKS=ICHKS.AND.MASK
 380  TYPE 1000,(IOBUFF(I),I=1,IOBLOK)
      TYPE 2000,IEOB1,IASCI(ICHKS+1),IEOB2
 390  ACCEPT 3000,IACK
      DO 420 I=1,2
      DO 400 J=1,4
      ITEMP=J
      IF(IACK(I).EQ.IAC(J))GO TO 410
 400  CONTINUE
      GO TO 390
 410  IACK(I)=ITEMP
 420  CONTINUE
      DO 430 I=1,2
      ITEMP=I
      J=IACK(3-I)-2
      IF(IACK(I)-2)450,440,430
 430  CONTINUE
      GO TO 390
 440  IF(J+IEO.NE.3)GO TO 460
      IF(IACK(ITEMP).EQ.2)GO TO 380
      GO TO 390
 450  IF(J.NE.IEO)GO TO 390
 460  IEO=3-IEO
 470  ISBE=ISBE*ISBE
      IF(ICHAR.EQ.1)GO TO IRET
      ITEMP=ICHAR-1
      DO 480 I=1,ITEMP
      IOBUFF(I)=IOBUFF(I+IOBLOK)
 480  CONTINUE
      GO TO IRET
 490  TYPE 1000,(IOBUFF(I),I=1,IOBLOK)
      GO TO 470
 500  WRITE(NDEV,4000)(IOBUFF(I),I=1,IOBLOK)
      GO TO 470
 510  OLDX=OLDX+IDX/FACT
      OLDY=OLDY+IDY/FACT
      RETURN
 520  OLDX=(IDX-DX1)/FACT
      OLDY=(IDY-DY1)/FACT
      X0=X0+XX
      Y0=Y0+YY
      RETURN
 530  IOBUFF(ICHAR)=IASCI(8)
      IOBUFF(ICHAR+1)=IASCI(1)
      ICHAR=ICHAR+2
      IF(IERR.EQ.1)GO TO 540
      IOBUFF(ICHAR)=IASCI(1)
      ICHAR=ICHAR+1
 540  IF(ICHAR-IOBLOK-1)560,590,550
 550  ASSIGN 560 TO IRET
      ICHAR=ICHAR-IOBLOK
      IF(IERR)500,490,360
 560  IF(ISBE.LE.0)GO TO 570
      IOBLKS=IOBLOK
      IOBLOK=(ICHAR+62).AND.(-64)
      IF(ICHAR.GT.IOBLOK)GO TO 590
 570  ITEMP=IASCI(1)
      DO 580 I=ICHAR,IOBLOK
      IOBUFF(I)=ITEMP
 580  CONTINUE
 590  ICHAR=1
      ASSIGN 690 TO IRET
      IF(IERR.NE.1)GO TO 600
      IEOB1=IAC(4)
      IEOB2=IEOB1
      GO TO 360
 600  IOBUFF(IOBLOK)=IAC(4)
      IF(IERR.EQ.0)GO TO 490
      GO TO 500
 610  IF(IERR.EQ.1)GO TO 620
      IOBUFF(ICHAR)=IASCI(1)
      IOBUFF(ICHAR+1)=IASCI(1)
      ICHAR=ICHAR+2
 620  IF(ICHAR-IOBLOK-1)640,670,630
 630  ASSIGN 640 TO IRET
      ICHAR=ICHAR-IOBLOK
      IF(IERR.EQ.1)GO TO 360
      GO TO 490
 640  IF(ISBE.LE.0)GO TO 650
      IOBLKS=IOBLOK
      IOBLOK=(ICHAR+62).AND.(-64)
      IF(ICHAR.GT.IOBLOK)GO TO 670
 650  ITEMP=IASCI(1)
      DO 660 I=ICHAR,IOBLOK
      IOBUFF(I)=ITEMP
 660  CONTINUE
 670  ICHAR=1
      ASSIGN 690 TO IRET
      IF(IERR.NE.1)GO TO 680
      IEOB1=IAC(4)
      GO TO 360
 680  IOBUFF(IOBLOK-1)=IAC(4)
      IOBUFF(IOBLOK)=IAC(4)
      GO TO 490
 690  RETURN
 700  IF(IPEN-3)710,110,720
 710  IF(IDASH.LE.0)GO TO 110
      IOBUFF(ICHAR)=IASCI(8)
      IOBUFF(ICHAR+1)=IASCI(11)
      ICHAR=ICHAR+2
      IDASH=-IDASH
      GO TO 110
 720  ITEMP=IPEN-3
      IPEN=2
      IF(IDASH.EQ.ITEMP)GO TO 110
      IF(IDASH.NE.-ITEMP)GO TO 730
      IOBUFF(ICHAR)=IASCI(8)
      IOBUFF(ICHAR+1)=IASCI(10)
      ICHAR=ICHAR+2
      IDASH=-IDASH
      GO TO 110
 730  IOBUFF(ICHAR)=IASCI(8)
      IOBUFF(ICHAR+1)=IASCI(12)
      ICHAR=ICHAR+2
      IRET1=IRET
      ASSIGN 740 TO IRET
      IDXS=IDX
      IDYS=IDY
      IDASH=ITEMP
      IDX=DASH(1,IDASH)*FACT+.5
      IDY=DASH(2,IDASH)*FACT+.5
      IKAR=ICHAR+1
      GO TO 150
 740  IDX=DASH(3,IDASH)*FACT+.5
      IDY=0
      ASSIGN 750 TO IRET
      IKAR=ICHAR+1
      GO TO 150
 750  IDX=IDXS
      IDY=IDYS
      IRET=IRET1
      GO TO 110
 760  IF(ABS(DY).GT.ABS(DX))GO TO 770
      TEMP=SIGN(32000./FACT,DX)
      YT=DY*TEMP/DX
      XT=DX-TEMP
      DX=TEMP
      TEMP=YT
      YT=DY-TEMP
      DY=TEMP
      GO TO 780
 770  TEMP=SIGN(32000./FACT,DY)
      XT=DX*TEMP/DY
      YT=DY-TEMP
      DY=TEMP
      TEMP=XT
      XT=DX-TEMP
      DX=TEMP
 780  IRET2=IRET
      ASSIGN 790 TO IRET
      GO TO 65
 790  DX=XT
      DY=YT
      OLDX=OLDX+IDX/FACT
      OLDY=OLDY+IDY/FACT
      IRET=IRET2
      GO TO 65
 1000 FORMAT(1H ,64A1)
 2000 FORMAT(1H ,3A1)
 3000 FORMAT(2A1)
 4000 FORMAT(64A1)
      END
      SUBROUTINE DASHDF(I,DOWN1,UP,DOWN2)
      DIMENSION DDINIT(3,6)
      COMMON /ZYYZ/ICHAR,IOBUFF(1100),IASCI(32),IDASH,IDUM(15),
     + DUM(11),DASH(3,6)
      DATA DDINIT/.15,.07,.15,.04,.15,.04,
     + .25,.25,.25,.15,.06,.04,.5,.1,.1,2.,.1,.1/
      IF(I)10,50,30
 10   II=-I-3
      DO 20 J=1,3
      DASH(J,II)=DDINIT(J,II)
 20   CONTINUE
      GO TO 40
 30   II=I-3
      DASH(1,II)=DOWN1
      DASH(2,II)=UP
      DASH(3,II)=DOWN2
 40   IF(ABS(IDASH).EQ.II) GO TO 80
      IF(IDASH.EQ.-10) IDASH=0
      RETURN
 50   DO 70 J=1,3
      DO 60 K=1,6
      DASH(J,K)=DDINIT(J,K)
 60   CONTINUE
 70   CONTINUE
 80   IF(IDASH.LE.0)GO TO 90
      IOBUFF(ICHAR)=IASCI(8)
      IOBUFF(ICHAR+1)=IASCI(11)
      ICHAR=ICHAR+2
 90   IDASH=0
      RETURN
      END
      SUBROUTINE ZZZZ
      COMMON /ZYYZ/ICHAR,IOBUFF(1100),IDUM1(45),ISTORE,IDUM2,
     + IPLOC,DUM(29)
      COMMON /ZXXZ/IPA(1)
      ICHRM1=ICHAR-1
      J=ISTORE+IPA(1)-IPLOC
      DO 10 I=IPLOC,ICHRM1
      IPA(J+I)=IOBUFF(I)
 10   CONTINUE
      ISTORE=ISTORE+ICHAR-IPLOC
      RETURN
      END
      SUBROUTINE PRIME
      COMMON /ZYYZ/IDUM1(1145),IPRIM,IDUM2(3),DUM(29)
      IPRIM=1
      RETURN
      END
      SUBROUTINE ZPATSZ(NUMPAT,ISIZ)
      COMMON /ZYYZ/IDUM1(1146),ISTORE,IDUM2(2),DUM(29)
      COMMON /ZXXZ/IPA(1)
      IF(NUMPAT.NE.0)GO TO 10
      ISIZ=ISTORE+IPA(1)
      RETURN
 10   ISIZ=3*NUMPAT+1
      ISIZ=IPA(ISIZ)-IPA(ISIZ-3)+4
      RETURN
      END
      SUBROUTINE ITALIC(SLA)
      COMMON /ZYYZ/ICHAR,IOBUFF(1100),IASCI(32),IDASH,IPENUP,
     + IDUM(14),OLDX,OLDY,DUM1(6),FACT,DUM2(20)
      IOBUFF(ICHAR)=IASCI(8)
      IOBUFF(ICHAR+1)=IASCI(13)
      ICHAR=ICHAR+2
      IF(SLA.NE.0.)GO TO 100
      IOBUFF(ICHAR)=IASCI(13)
      IOBUFF(ICHAR+1)=IASCI(1)
      ICHAR=ICHAR+2
      RETURN
 100  OLDXS=OLDX
      RAD=SLA*.0174532925
      ITEMP=IDASH
      IDASH=-10
      CALL PLOT(256.*SIN(RAD)/(COS(RAD)*FACT)+OLDX,OLDY,IPENUP)
      IDASH=ITEMP
      OLDX=OLDXS
      RETURN
      END
      SUBROUTINE ASPECT(ASP)
      COMMON /ZYYZ/ICHAR,IOBUFF(1100),IASCI(32),IDASH,IPENUP,
     + IDUM(14),OLDX,OLDY,DUM1(4),ASPCT,DUM2,FACT,DUM3(20)
      ASPCT=ASP
      IOBUFF(ICHAR)=IASCI(8)
      IOBUFF(ICHAR+1)=IASCI(14)
      ICHAR=ICHAR+2
      OLDXS=OLDX
      ITEMP=IDASH
      IDASH=-10
      CALL PLOT(256./(ASP*FACT)+OLDX,OLDY,IPENUP)
      IDASH=ITEMP
      OLDX=OLDXS
      RETURN
      END
      SUBROUTINE ZMESS(MESS,NCHARS)
      DIMENSION MESS(1)
      COMMON /ZYYZ/ICHAR,IOBUFF(1100),IASCI(32),IDASH,IPENUP,
     + IOBLOK,IDUM(13),OLDX,OLDY,DUM(27)
      IOBUFF(ICHAR)=IASCI(8)
      IOBUFF(ICHAR+1)=IASCI(16)
      IOBUFF(ICHAR+2)=IASCI(NCHARS/32+1)
      IOBUFF(ICHAR+3)=IASCI((NCHARS.AND."37)+1)
      ICHAR=ICHAR+4
      NWDS=(NCHARS+1)/2
      IDASHS=IDASH
      IDASH=-10
      I=1
 10   J=I+14
      IF(J.GT.NWDS)J=NWDS
 20   ITEMP=MESS(I).AND."377
      IOBUFF(ICHAR)=IASCI(ITEMP/32+1)
      IOBUFF(ICHAR+1)=IASCI((ITEMP.AND."37)+1)
      ITEMP=MESS(I)/256
      IOBUFF(ICHAR+2)=IASCI(ITEMP/32+1)
      IOBUFF(ICHAR+3)=IASCI((ITEMP.AND."37)+1)
      ICHAR=ICHAR+4
      I=I+1
      IF(I.LE.J)GO TO 20
      IF(J.EQ.NWDS)GO TO 30
      IF(ICHAR.GT.IOBLOK)CALL PLOT(OLDX,OLDY,IPENUP)
      GO TO 10
 30   IF(NCHARS.NE.NWDS*2)ICHAR=ICHAR-2
      IF(ICHAR.GT.IOBLOK)CALL PLOT(OLDX,OLDY,IPENUP)
      IDASH=IDASHS
      RETURN
      END
      SUBROUTINE CIRCLE(X,Y,THS,THE,RAD,LINTYP)
      COMMON /ZYYZ/ICHAR,IOBUFF(1100),IASCI(32),IDASH,IPENUP,
     + IDUM(14),OLDX,OLDY,DUM(9),DASH(3,6)
      XX=X
      YY=Y
      IF(X.EQ.999.)XX=OLDX
      IF(Y.NE.999.)GO TO 10
      IF(X.EQ.999.)GO TO 20
      YY=OLDY
 10   CALL PLOT(XX,YY,3)
 20   IF(LINTYP.GE.4)GO TO 30
      IF(IDASH.LE.0)GO TO 60
      IOBUFF(ICHAR+1)=IASCI(11)
      GO TO 50
 30   ITEMP=LINTYP-3
      IF(ITEMP.EQ.IDASH)GO TO 70
      IF(ITEMP.EQ.-IDASH)GO TO 40
      IDASH=-10
      XX=OLDX
      YY=OLDY
      IOBUFF(ICHAR)=IASCI(8)
      IOBUFF(ICHAR+1)=IASCI(12)
      ICHAR=ICHAR+2
      CALL PLOT(OLDX+DASH(1,ITEMP),OLDY+DASH(2,ITEMP),IPENUP)
      CALL PLOT(OLDX+DASH(3,ITEMP),OLDY,IPENUP)
      OLDX=XX
      OLDY=YY
      GO TO 75
 40   IOBUFF(ICHAR+1)=IASCI(10)
 50   IOBUFF(ICHAR)=IASCI(8)
      ICHAR=ICHAR+2
      IDASH=-IDASH
 60   ITEMP=IDASH
 70   IDASH=-10
 75   TEMP1=THS*.0174533
      TEMP2=RAD*SIN(TEMP1)
      TEMP1=RAD*COS(TEMP1)
      XX=OLDX+TEMP1
      YY=OLDY+TEMP2
      IOBUFF(ICHAR)=IASCI(8)
      IOBUFF(ICHAR+1)=IASCI(15)
      ICHAR=ICHAR+2
      IF(MOD(THS-THE+360.05,360.).GT.(.1))GO TO 80
      TEMP1=OLDX
      TEMP2=OLDY
      CALL PLOT(XX,YY,IPENUP)
      OLDX=TEMP1
      OLDY=TEMP2
      IDASH=ITEMP
      RETURN
 80   IF(THS.LT.THE)GO TO 90
      IOBUFF(ICHAR)=IASCI(2)
      GO TO 100
 90   IOBUFF(ICHAR)=IASCI(1)
 100  ICHAR=ICHAR+1
      CALL PLOT(XX,YY,IPENUP)
      OLDX=OLDX-2.*TEMP1
      OLDY=OLDY-2.*TEMP2
      TEMP1=THE*.0174533
      CALL PLOT(OLDX+RAD*COS(TEMP1),OLDY+RAD*SIN(TEMP1),IPENUP)
      IDASH=ITEMP
      RETURN
      END
      SUBROUTINE ORIGIN(X,Y,IORIG)
      COMMON /ZYYZ/IDUM(1149),OLDX,OLDY,DUM1(7),X0,Y0,DUM2(18)
      IF(IORIG)10,20,30
 10   X=X0
      Y=Y0
      RETURN
 20   OLDX=OLDX+X0-X
      OLDY=OLDY+Y0-Y
      X0=X
      Y0=Y
      RETURN
 30   OLDX=OLDX-X
      OLDY=OLDY-Y
      X0=X0+X
      Y0=Y0+Y
      RETURN
      END
      SUBROUTINE SHADE(NSHADS,THICK)
      COMMON /ZYYZ/ICHAR,IOBUFF(1100),IASCI(32),IDASH,
     + IPENUP,IDUM(14),OLDX,OLDY,DUM1(6),FACT,DUM2(20)
      IOBUFF(ICHAR)=IASCI(8)
      IOBUFF(ICHAR+1)=IASCI(17)
      IF(NSHADS.EQ.0)GO TO 10
      ITHICK=THICK*256./NSHADS
      ICHAR=ICHAR+2
      OLDXS=OLDX
      OLDYS=OLDY
      IDASHS=IDASH
      IDASH=-10
      CALL PLOT(OLDX+NSHADS/FACT,OLDY+ITHICK/FACT,IPENUP)
      IDASH=IDASHS
      OLDX=OLDXS
      OLDY=OLDYS
      RETURN
 10   IOBUFF(ICHAR+2)=IASCI(13)
      IOBUFF(ICHAR+3)=IASCI(1)
      ICHAR=ICHAR+4
      RETURN
      END
      SUBROUTINE FPLOT(X,Y,IP)
      INTEGER   N2, N100
      COMMON /ZYYZ/IDUM(1149),OLDX,OLDY,XOFF,XFACT,
     + YOFF,YFACT,DUM(23)
      COMMON /ZWWZ/IBFCNT,IBUF0,NOK,ITEST,IPEN,BAND,XYBUF(200)
      DATA N2,N100 /2,100/
      IF(IP-1)10,20,30
 10   IF(IBFCNT-1)25,170,60
 20   BAND=X
      IBFCNT=0
      NOK=1
 25   IBUF0=0
      ITEST=2
      RETURN
 30   IF(IP.LT.10)GO TO 40
      XX=(X-XOFF)/XFACT
      YY=(Y-YOFF)/YFACT
      IPEN=IP-10
      GO TO 50
 40   XX=X
      YY=Y
      IPEN=IP
 50   IBFCNT=IBFCNT+1
      I=IBFCNT+IBUF0
      J=I-100
      IF(J.GT.0)I=J
      XYBUF(I)=XX
      XYBUF(I+100)=YY
      IF(IBFCNT.LT.ITEST)RETURN
 60   JTEST=IBFCNT
 70   I=JTEST+IBUF0
      J=I-100
      IF(J.GT.0)I=J
      XX=XYBUF(I)
      YY=XYBUF(I+100)
      DX=XX-OLDX
      DY=YY-OLDY
      ADX=ABS(DX)
      ADY=ABS(DY)
      JTSTM1=JTEST-1
      IF(ADX-ADY)120,80,100
 80   IF(DX.NE.0.)GO TO 100
      DO 90 I=1,JTSTM1
      J=I+IBUF0
      K=J-100
      IF(K.GT.0)J=K
      IF(ABS(XYBUF(J)-OLDX).GT.BAND)GO TO 150
      IF(ABS(XYBUF(J+100)-OLDY).GT.BAND)GO TO 150
 90   CONTINUE
      GO TO 140
 100  SLOPE=DY/DX
      CEPT1=OLDY-SLOPE*OLDX
      CEPT2=CEPT1-BAND
      CEPT1=CEPT1+BAND
      ADX=ADX+BAND
      DO 110 I=1,JTSTM1
      J=I+IBUF0
      K=J-100
      IF(K.GT.0)J=K
      XXX=XYBUF(J)
      YYY=XYBUF(J+100)
      IF(ABS(OLDX-XXX)+ABS(XX-XXX).GT.ADX)GO TO 150
      XXX=XXX*SLOPE
      IF(YYY.GT.XXX+CEPT1)GO TO 150
      IF(YYY.LT.XXX+CEPT2)GO TO 150
 110  CONTINUE
      GO TO 140
 120  SLOPE=DX/DY
      CEPT1=OLDX-SLOPE*OLDY
      CEPT2=CEPT1-BAND
      CEPT1=CEPT1+BAND
      ADY=ADY+BAND
      DO 130 I=1,JTSTM1
      J=I+IBUF0
      K=J-100
      IF(K.GT.0)J=K
      YYY=XYBUF(J+100)
      XXX=XYBUF(J)
      IF(ABS(OLDY-YYY)+ABS(YY-YYY).GT.ADY)GO TO 150
      YYY=YYY*SLOPE
      IF(XXX.GT.YYY+CEPT1)GO TO 150
      IF(XXX.LT.YYY+CEPT2)GO TO 150
 130  CONTINUE
 140  NOK=JTEST
      IF(NOK.NE.IBFCNT)GO TO 160
      IF(IP.EQ.0)GO TO 170
      IF(NOK.EQ.100)GO TO 170
      ITEST=MIN(N100,N2*NOK)
      RETURN
 150  NBAD=JTEST
 160  JTEST=(NBAD+NOK)/2
      IF(JTEST.GT.NOK)GO TO 70
 170  I=NOK+IBUF0
      J=I-100
      IF(J.GT.0)I=J
      CALL PLOT(XYBUF(I),XYBUF(I+100),IPEN)
      IBUF0=I
      IBFCNT=IBFCNT-NOK
      ITEST=NOK
      NOK=1
      IF(IP.EQ.0)GO TO 180
      RETURN
 180  IF(IBFCNT.NE.0)GO TO 60
      GO TO 25
      END
C
C     THE FOLLOWING MAIN PROGRAM IS INTENDED TO BE USED
C     WITH SUBROUTINE UTIL53 (WHICH FOLLOWS IMMEDIATELY
C     AFTER).  ITS FUNCTION IS TO INTERROGATE THE TERMINAL
C     FOR THE NAME OF THE PLOTFILE, OPEN THE FILE, AND
C     CALL UTIL53 WITH APPROPRIATE ARGUMENTS.
C
      TYPE 1000
      CALL ASSIGN(2,,-1)
      TYPE 2000
      ACCEPT 3000,M256
      CALL UTIL53(2,M256)
      STOP
 1000 FORMAT(1H ,23HENTER (DEVICE:)FILENAME,/)
 2000 FORMAT(1H ,29HENTER BLOCK SIZE (1,2,3,OR 4))
 3000 FORMAT(I1)
      END
C
C
C
      SUBROUTINE UTIL53(NDEV,M256)
      DIMENSION IOBUFF(1024),IASCI(32),IACK(2),IAC(4),IB32(43)
      DATA IASCI/1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1HA,1HB,
     + 1HC,1HD,1HE,1HF,1HG,1HH,1HI,1HJ,1HK,1HL,1HM,1HN,
     + 1HO,1HP,1HQ,1HR,1HS,1HT,1HU,1HV,1HW,1HX/
      DATA IAC,IC9,ICZ,IC0/1HY,1H8,1H9,1HZ,1H9,1HZ,1H0/
      DATA IB32/0,1,2,3,4,5,6,7,9*0,8,9,10,11,12,13,14,15,16,
     + 17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,0,0/
      NRECS=M256*4
 10   J=1
      DO 30 I=1,NRECS
      K=J+63
      READ(NDEV,1000,END=160)(IOBUFF(L),L=J,K)
      IF(IOBUFF(J).NE.ICZ)GO TO 20
      TYPE 2000
      IEOB=IC9
      IEO=2
 20   IF(IOBUFF(K).EQ.ICZ)GO TO 40
      J=J+64
 30   CONTINUE
      GO TO 50
 40   IEOB=ICZ
      IOBUFF(K)=IC0
 50   ICHKS=0
      DO 60 I=1,K
      J=IOBUFF(I)-8239
      ICHKS=ICHKS+IB32(J)
 60   CONTINUE
      ICHKS=ICHKS.AND.31
 70   TYPE 3000,(IOBUFF(I),I=1,K)
      TYPE 4000,IEOB,IASCI(ICHKS+1),IEOB
 80   ACCEPT 5000,IACK
      DO 110 I=1,2
      DO 90 J=1,4
      L=J
      IF(IACK(I).EQ.IAC(J))GO TO 100
 90   CONTINUE
      GO TO 80
 100  IACK(I)=L
 110  CONTINUE
      DO 120 I=1,2
      J=IACK(3-I)-2
      L=I
      IF(IACK(I)-2)140,130,120
 120  CONTINUE
      GO TO 80
 130  IF(J+IEO.NE.3)GO TO 150
      IF(IACK(L).EQ.2)GO TO 70
      GO TO 80
 140  IF(J.NE.IEO)GO TO 80
 150  IEO=3-IEO
      GO TO 10
 160  RETURN
 1000 FORMAT(64A1)
 2000 FORMAT(1H ,20HZZZZZZZZZZZZZZZZZZZZ)
 3000 FORMAT(1H ,64A1)
 4000 FORMAT(1H ,3A1)
 5000 FORMAT(2A1)
      END

      SUBROUTINE UVDISK (OP, LUN, FIND, BUFFER, NIO, BIND, IERR)
C-----------------------------------------------------------------------
C! reads/writes records of arbitrary length, esp UV data, see UVINIT
C# IO-basic UV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   UVDISK reads and writes records of arbitrary length especially UV
C   visibility data.  Operation is faster if blocks of data are integral
C   numbers of disk blocks.  There are three operations which can be
C   invoked: READ, WRITE and FLUSH (OPcodes READ, WRIT and FLSH).
C
C   READ reads the next sequential block of data as specified to
C   UVINIT and returns the number of visibilities in NIO and the
C   pointer in BUFFER to the first word of this data.
C
C   WRIT arranges data in a buffer until it is full.  Then as many full
C   blocks as possible are written to the disk with the remainder left
C   for the next disk write.  For tape I/O data is always written with
C   the block size specified to UVINIT; one I/O operation per call.
C   For disk write, left-over data is transfered to the beginning of
C   buffer 1 if that is the next buffer to be filled.  Value of NIO in
C   the call is the number of vis. rec. to be added to the buffer and
C   may be fewer than the number speecified to UVINIT.  On return NIO
C   is the maximum number which may be sent next time.  On return BIND
C   is the pointer in BUFFER to begin filling new data.
C
C   FLSH writes integral numbers of blocks and moves any data left over
C   to the beginning of buffer 1.  One exception to this is when
C   NIO => -NIO or 0, in which case the entire remaining data in the
C   buffer is written.  After the call BIND is the pointer in BUFFER
C   for new data.  The principal difference between FLSH and WRIT is
C   that FLSH always forces an I/O transfer.  This may cause trouble if
C   a transfer of less than 1 block is requested.  A call with a
C   nonpositive value of NIO should be the last call and corresponds
C   to a call to MDISk with opcode 'FINI'.
C
C   NOTE:  A call to UVINIT is REQUIRED prior to calling UVDISK.
C
C   Inputs:
C      OP       C*4   Opcode 'READ','WRIT','FLSH' are legal
C      LUN      I     Logical unit number
C      FIND     I     FTAB pointer returned by ZOPEN
C      BUFFER   I(*)  Buffer for I/O
C      NIO      I     No. additional visibilities to write.
C   Output:
C      NIO      I     No. visibilities read.
C                     Max. no. vis. for next write.
C      BIND     I     Pointer to start of data in buffer
C      IERR     I     Return error code: 0 => OK
C                        1 => file not open in FTAB
C                        2 => input error
C                        3 => I/O error
C                        4 => end of file
C                        7 => attempt to write more vis than specified
C                             to UVINIT or will fit in buffer.
C-----------------------------------------------------------------------
      CHARACTER OP*4
      INTEGER   LUN, FIND, BUFFER(*), NIO, BIND, IERR
C
      INTEGER   WRK, NVIS, BBO, XLEFT, VLEFT, ITEMP, FTAB6, NLEFT, NBR,
     *   IADDR, IBPT, INNIO, IOP, ISTART, JBUF, KBPS, KBUF, NBYTES
      LOGICAL   TAPE, FAST, FINISH
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Decode opcode.
      IOP = 0
      IF (OP.EQ.'READ') IOP = 1
      IF (OP.EQ.'WRIT') IOP = 2
      IF (OP.EQ.'FLSH') IOP = 3
C                                       Check for consistency
      IERR = 2
      IF ((IOP.NE.FTAB(FIND+9)) .AND. (IOP.NE.3)) GO TO 999
C                                       Check if open.
      IERR = 1
      IF (FTAB(FIND).NE.LUN) GO TO 999
      IERR = 0
C                                       Store input NIO
      INNIO = NIO
C                                       Check if read finished,
C                                       if so return NIO=0.
      NVIS = FTAB(FIND+2)
      BBO = FTAB(FIND+4)
      IF ((IOP.NE.1) .OR. (NVIS.GT.0)) GO TO 5
         IF (FTAB(FIND+13).GE.FTAB(FIND+12)) NIO = 0
         IF (FTAB(FIND+13).GE.FTAB(FIND+12)) GO TO 999
         GO TO 10
C                                       Check if more writes than
C                                       legal.
 5    IF (IOP.EQ.1) GO TO 10
         IF ((ABS(NIO).GT.(FTAB(FIND+12)-FTAB(FIND+13)))) IERR = 7
         IF ((NVIS.LE.0) .AND. (FTAB(FIND+13).GE.FTAB(FIND+12)))
     *      IERR = 7
         IF (IERR.NE.0) GO TO 999
C                                       For write, incr. # in buff.
         FTAB(FIND+13) = FTAB(FIND+13) + ABS(NIO)
C                                       Check if time for I/O.
 10   IF ((FTAB(FIND+13).GE.FTAB(FIND+12)) .OR. (IOP.EQ.3)) GO TO 15
C                                       Update pointers and return.
C                                       Determine number
C                                       of vis this call.
         NIO = MIN (FTAB(FIND+12)-FTAB(FIND+13), FTAB(FIND+11))
         IF (IOP.EQ.1) INNIO = FTAB(FIND+11)
C                                       # Processed in buffer. READ
         IF (IOP.EQ.1) FTAB(FIND+13) = FTAB(FIND+13) + ABS (NIO)
C                                       Set buffer call pointer.
         BIND = FTAB(FIND+15) + INNIO * FTAB(FIND+10)
         FTAB(FIND+15) = BIND
         GO TO 999
C                                       It's I/O time again folks.
C
 15   TAPE = DEVTAB(LUN).NE.0
C                                       JBUF = current buffer no.
      JBUF = ABS (FTAB(FIND+8))
C                                       Check if an intergral # of
C                                       blocks in this transfer.
      FAST = (MOD (FTAB(FIND+1),NBPS).EQ.0) .AND. (FTAB(FIND+6).EQ.0)
C                                       Determine next buffer #.
      KBUF = 1
      IF (FTAB(FIND+8).GT.0) KBUF = 3 - JBUF
C                                       If OP='FLSH' next buffer is
C                                       forced to to be 1
      IF (IOP.EQ.3) KBUF = 1
C                                       Determine # vis left to do.
      WRK = FTAB(FIND+13)
      NVIS = NVIS - WRK
      FTAB(FIND+2) = NVIS
      VLEFT = NVIS
C                                       Check if # vis completed.
C                                       READ
      IF (IOP.GE.2) GO TO 100
C                                       Determine number of bytes for
C                                       I/O.  If double buffering,
C                                       subtract an extra I/O from
C                                       apparent visibility count.
C                                       VLEFT => this call
C                                       XLEFT => next call.
         XLEFT = VLEFT
         IF (FTAB(FIND+8).GT.0) XLEFT = VLEFT - FTAB(FIND+12)
         NBYTES = FTAB(FIND+13) * FTAB(FIND+10) * 2 +
     *      FTAB(FIND+6)
         IF (XLEFT.GE.0) GO TO 20
C                                       Set max # vis in buffer
            IF (VLEFT.LT.0) FTAB(FIND+12) = FTAB(FIND+12) + VLEFT
C                                       Last READ single buffering.
C                                       Update NBYTES
            NBYTES = NBYTES + (XLEFT * FTAB(FIND+10) * 2)
            NBYTES = MAX (NBYTES, NBPS)
C                                        If this is the last double
C                                        buffer call skip read.
 20      IF ((VLEFT.LE.0) .AND. (FTAB(FIND+8).GT.0)) GO TO 30
C                                       Set NBYTES for tape
            IF (TAPE) NBYTES = FTAB(FIND+1)
C                                       Determine buffer pointer
C                                       for next I/O
            IBPT = (JBUF-1) * FTAB(FIND+1)/2 + 1
C                                       Do next I/O
            CALL ZMIO ('READ', LUN, FIND, BBO, NBYTES, BUFFER(IBPT),
     *         JBUF, IERR)
C                                       Update FTAB
            WRK = (FTAB(FIND+1)+FTAB(FIND+6)) / NBPS - 1
            IF ((FAST) .OR. (TAPE)) WRK = WRK + 1
C                                       Update block count for
C                                       next I/O
            BBO = BBO + WRK
            FTAB(FIND+4) = BBO
C                                       Set NIO for output.
 30      NIO = MIN (FTAB(FIND+12), FTAB(FIND+11))
C                                       Reset count in buffer.
         FTAB(FIND+13) = NIO
C                                       Save buffer number.
         IF (FTAB(FIND+8).GT.0) FTAB(FIND+8) = KBUF
C                                       Compute BIND
C                                       If double buffer back byte off
         FTAB6 = FTAB(FIND+6)
         IF (FTAB(FIND+8).GT.0) FTAB6 = NBPS -
     *      MOD (FTAB(FIND+1)-FTAB6, NBPS)
         FTAB6 = MOD (FTAB6, NBPS)
         IF ((FAST) .OR. (TAPE)) FTAB6 = 0
         BIND = ((KBUF-1) * FTAB(FIND+1) + FTAB6) / 2 + 1
C                                       First byte of next I/O
         FTAB(FIND+6) = MOD (FTAB(FIND+6)+FTAB(FIND+1), NBPS)
         IF ((TAPE) .OR. (FAST)) FTAB(FIND+6) = 0
C                                       Buffer pointer for next call
         FTAB(FIND+15) = BIND
C                                       Wait for previous I/O
         CALL ZWAIT (LUN, FIND, KBUF, IERR)
         GO TO 999
C
C                                       Write.
 100  CONTINUE
C                                       Check to see if a request was
C                                       made to terminate this file and
C                                       completely flush the buffer.
         FINISH = (IOP.EQ.3) .AND. (INNIO.LE.0)
C                                       Determine location in buffer
C                                       to begin transfer
         IBPT = MAX (FTAB(FIND+14), 1)
C                                       NBR = # bytes ready to write.
         NBR = 2 * FTAB(FIND+13) * FTAB(FIND+10) + FTAB(FIND+6)
         NBYTES = NBR - MOD (NBR, NBPS)
         NBYTES = MAX (NBYTES, NBPS)
C                                       Do write
C                                       If FINISH do whole thing
         IF ((FINISH) .OR. (VLEFT.LE.0)) NBYTES = MAX (NBR, NBPS)
         IF (TAPE) NBYTES = FTAB(FIND+1)
C                                        Check for null write.
         IF (NBR.LE.0) NBYTES = 0
         CALL ZMIO ('WRIT', LUN, FIND, BBO, NBYTES, BUFFER(IBPT),
     *      JBUF, IERR)
C                                       Set new byte offset.
         FTAB(FIND+6) = NBR - NBYTES
         IF ((TAPE) .OR. (FAST)) FTAB(FIND+6) = 0
C                                       Update this-write buffer
C                                       pointer, allow space
C                                       for left over data.
         KBPS = 2 * NBPS
         IF (FAST) KBPS = 0
         FTAB(FIND+14) = FTAB(FIND+14) + (NBR + KBPS) / 2
         IF (KBUF.EQ.1) FTAB(FIND+14) = 1
C                                       Update this-call buffer
C                                       pointer.
         BIND = FTAB(FIND+14) + FTAB(FIND+6) / 2
         FTAB(FIND+15) = BIND
         FTAB(FIND+13) = 0
C                                       Set output NIO
         NLEFT = FTAB(FIND+12)
         IF (VLEFT.LE.0) NLEFT = NLEFT + VLEFT
         NLEFT = MAX (0, NLEFT)
         NIO = MIN (FTAB(FIND+11), NLEFT)
C                                       If about to finish NVIS
C                                       update FTAB(FIND+12)
         FTAB(FIND+12) = NLEFT
C                                       Update block count for next I/O
         BBO = BBO + NBYTES / NBPS
         FTAB(FIND+4) = BBO
C                                       Update buffer no.
         IF (FTAB(FIND+8).GT.0) FTAB(FIND+8) = KBUF
C                                       If finished mark vis count
         IF ((FINISH) .OR. (VLEFT.LE.0)) NIO = 0
C                                       Wait for current buffer.
         CALL ZWAIT (LUN, FIND, KBUF, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Copy any unwriten values from
C                                       the end of the last buffer
C                                       to the start next buffer.
         IF (FTAB(FIND+6).LE.0) GO TO 999
            ISTART = IBPT + NBYTES/2
            IADDR = MAX (FTAB(FIND+14), 1)
            ITEMP = FTAB(FIND+6) / 2
            CALL COPY (ITEMP, BUFFER(ISTART), BUFFER(IADDR))
C
 999  RETURN
      END

LOCAL INCLUDE 'SETAN.INC'
C                                       Local include for SETAN
      INTEGER   SEQOUT, OUTVER, DISKO, NEWCNO, NUMHIS, JBUFSZ, ICODE,
     *   LUNIN,  FINDIN, BUFFER(4096)
      CHARACTER HISCRD(10)*64, FILEIN*48, NAMOUT*12, CLAOUT*6
      HOLLERITH XFILEI(12), XNAMOU(3), XCLAOU(2)
      REAL      XSEQO, XOVER, XDISKO
C                                       Program commons
      COMMON /INPARM/ XFILEI, XNAMOU, XCLAOU, XSEQO, XOVER, XDISKO
      COMMON /PARMS/ SEQOUT, OUTVER, DISKO, NEWCNO,
     *   JBUFSZ, ICODE, LUNIN, FINDIN, NUMHIS
      COMMON /BUFRS/ BUFFER
      COMMON /CHRCOM/ HISCRD, FILEIN, NAMOUT, CLAOUT
LOCAL END
      PROGRAM SETAN
C-----------------------------------------------------------------------
C! Task read AN file info from a text file
C# UV utility
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-1998, 2008-2009, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SETAN reads AN table information from an external text file.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INFILE         FILEIN        Input file.
C      OUTNAME        NAMOUT        Name of the output file
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output file.
C                                   Default is input class.
C      OUTSEQ         SEQOUT        Seq. number of output file.
C      OUTVER         OUTVER        Output AN table version number.
C      OUTDISK        DISKO         Disk number of the output file.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'SETAN.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'SETAN '/
C-----------------------------------------------------------------------
C                                       Get input parameters.
      CALL STAIN (PRGM, IRET)
C                                       Read antenna data.
      IF (IRET.EQ.0) CALL STAMA (IRET)
C                                       History
      IF (IRET.EQ.0) CALL STAHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE STAIN (PRGN, IRET)
C-----------------------------------------------------------------------
C   STAIN gets input parameters for SETAN.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                     4 => user routine detected error.
C                     5 => catalog troubles
C                     8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C   See prologue comments in SETAN for more details.
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6
C
      CHARACTER PTYPE*2, STAT*4
      INTEGER   IERR, NPARM, IROUND, JERR
      LOGICAL   T
      INCLUDE 'SETAN.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T, BUFFER)
      CALL VHDRIN
      JBUFSZ = 2 * 4096
      IRET = 0
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      LUNIN = 10
C                                       Init CATBLK.
      CALL FILL (256, 0, CATBLK)
C                                       Get input parameters.
      NPARM = 20
      CALL GTPARM (PRGN, NPARM, RQUICK, XFILEI, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
            END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFFER, IERR)
      IF (IRET.NE.0) GO TO 999
      IRET = 5
C                                       Crunch input parameters.
      SEQOUT = IROUND (XSEQO)
      OUTVER = IROUND (XOVER)
      DISKO = IROUND (XDISKO)
C                                       Characters
      CALL H2CHR (48, 1, XFILEI, FILEIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C                                       Find file
      NEWCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKO, NEWCNO, NAMOUT, CLAOUT, SEQOUT,
     *   PTYPE, NLUSER, STAT, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMOUT, CLAOUT, SEQOUT, DISKO,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKO, NEWCNO, CATBLK, 'WRIT', BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FCNO(NCFILE) = NEWCNO
      FVOL(NCFILE) = DISKO
      FRW(NCFILE) = 1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Open the input file
      CALL ZTXOPN ('READ', LUNIN, FINDIN, FILEIN, .FALSE., IERR)
      IF (IERR.NE.0) GO TO 999
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('STAIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE STAMA (IRET)
C-----------------------------------------------------------------------
C   STAMA accepts an file one row at a time from GETMA and writes to an
C   AIPS disk file.
C   Output:
C      IRET   I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   LUNO, NBYTES, KBP, NCHAR, IERR, LOOP, NREC, MOSTA,
     *   MAXRNO, NIF, JT, JTRIM
      LOGICAL   TABLE, EXIST, FITASC, OLD
      DOUBLE PRECISION X, CTAXYZ(3)
      CHARACTER LINE*132, STRING*8, CNNAME*8
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'SETAN.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA LUNO /25/
C-----------------------------------------------------------------------
      NIF = 1
      IF (JLOCIF.GE.0) NIF = MAX (1, CATBLK(KINAX+JLOCIF))
      ARRAYC(1) = 0.0
      ARRAYC(2) = 0.0
      ARRAYC(3) = 0.0
      GSTIA0 = 0.0D0
      DEGPDY = 0.0D0
      SAFREQ = 1.0D0
      RDATE = '19900101'
      POLRXY(1) = 0.0D0
      POLRXY(2) = 0.0D0
      UT1UTC = 0.0
      DATUTC = 0.0
      TIMSYS = 'UTC'
      ANAME = ' '
      NUMORB = 0
      NOPCAL = 2
      ANFQID = -1
      ANTNIF = NIF
C                                       Open AN file read to get
C                                       keywords.
      CALL ISTAB ('AN', DISKO, NEWCNO, OUTVER, LUNO, BUFFER, TABLE,
     *   EXIST, FITASC, IERR)
      OLD = EXIST .AND. (IERR.EQ.0)
      IF (OLD) THEN
         CALL ANTINI ('READ', BUFFER, DISKO, NEWCNO, OUTVER, CATBLK,
     *      LUNO, IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY,
     *      SAFREQ, RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME,
     *      XYZHAN, TFRAME, NUMORB, NOPCAL, ANTNIF, ANFQID, IRET)
         NREC = BUFFER(5)
C                                       Close table
         CALL TABIO ('CLOS', 0, IANRNO, BUFFER, BUFFER, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Read table header stuff
      CALL ANTHED (ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE, POLRXY,
     *   UT1UTC, DATUTC, ANAME, XYZHAN, TFRAME, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Open output table
      CALL ANTINI ('WRIT', BUFFER, DISKO, NEWCNO, OUTVER, CATBLK, LUNO,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       init basic AN record
      ANNAME = ' '
      STAXOF = 0.0
      STAXYZ(1) = 0.0D0
      STAXYZ(2) = 0.0D0
      STAXYZ(3) = 0.0D0
      ORBPRM(1) = 0.0D0
      NOSTA = 0
      MNTSTA = 0
      POLAA = 0.0
      POLAB = 0.0
      CALL RFILL (3, 0.0, POLCA)
      CALL RFILL (3, 0.0, POLCB)
      POLTYA = 'R'
      POLTYB = 'L'
      MAXRNO = 0
C                                       Loop to end of file
 100     CALL ZTXIO ('READ', LUNIN, FINDIN, LINE, IRET)
         IF (IRET.EQ.2) GO TO 200
         IF (IRET.NE.0) GO TO 999
         JT = JTRIM (LINE)
C                                       Get values
         KBP = 1
         NBYTES = 132
         CALL GETNUM (LINE, NBYTES, KBP, X)
         IF (X.EQ.DBLANK) GO TO 980
         NOSTA = X + 0.5
         CALL GETNUM (LINE, NBYTES, KBP, X)
         IF (X.EQ.DBLANK) GO TO 980
         STAXYZ(1) = X
         CALL GETNUM (LINE, NBYTES, KBP, X)
         IF (X.EQ.DBLANK) GO TO 980
         STAXYZ(2) = X
         CALL GETNUM (LINE, NBYTES, KBP, X)
         IF (X.EQ.DBLANK) GO TO 980
         STAXYZ(3) = X
         CALL GETSTR (LINE, NBYTES, 8, KBP, STRING, NCHAR)
         IF (STRING.NE.'        ') ANNAME = STRING(1:8)
C                                       Find any old entry.
         IF (OLD) THEN
            DO 50 LOOP = 1,NREC
               IANRNO = LOOP
               CALL TABAN ('READ', BUFFER, IANRNO, ANKOLS, ANNUMV,
     *            CNNAME, CTAXYZ, ORBPRM, MOSTA, MNTSTA, STAXOF,
     *            DIAMAN, FWHMAN, POLTYA, POLAA, POLCA, POLTYB, POLAB,
     *            POLCB, IRET)
               IF (IRET.NE.0) GO TO 999
               IANRNO = LOOP
               IF (MOSTA.EQ.NOSTA) GO TO 60
 50            CONTINUE
            IANRNO = MAXRNO + 1
            END IF
C                                       Write entry
 60      MAXRNO = MAX (MAXRNO, IANRNO)
         IF (NOSTA.GT.0) THEN
            CALL TABAN ('WRIT', BUFFER, IANRNO, ANKOLS, ANNUMV, ANNAME,
     *         STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF, DIAMAN, FWHMAN,
     *         POLTYA, POLAA, POLCA, POLTYB, POLAB, POLCB, IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
         GO TO 100
C                                       Close files
 200  CALL TABIO ('CLOS', 0, IANRNO, BUFFER, BUFFER, IRET)
      CALL ZTXCLS (LUNIN, FINDIN, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 980  MSGTXT = 'ERROR PARSING ' // LINE
      IRET = 1
 990  CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE STAHIS
C-----------------------------------------------------------------------
C   STAHIS copies and updates history file.
C-----------------------------------------------------------------------
      CHARACTER ATIME*8, ADATE*12, HILINE*72, LABEL*8, REST*4
      INTEGER   LUN, IERR, I, TIME(3), DATE(3)
      LOGICAL   T
      INCLUDE 'SETAN.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA LUN /27/
      DATA REST /'REST'/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Create/open hist. file.
      CALL HIOPEN (LUN, DISKO, NEWCNO, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Get current date/time.
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
C                                       Write first record.
      WRITE (HILINE,1010) TSKNAM, ADATE, ATIME
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       AIPS release
      WRITE (HILINE,2004) TSKNAM, RLSNAM
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       INFILE
      WRITE (HILINE,1012) TSKNAM, FILEIN
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       OUTVER
      WRITE (HILINE,1013) TSKNAM, OUTVER
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any other history.
      IF (NUMHIS.GT.0) THEN
         WRITE (LABEL,1011) TSKNAM
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
         END IF
C                                       Close HI file
 200  CALL HICLOS (LUN, T, BUFFER, IERR)
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, REST, BUFFER,
     *   IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('STAHIS: ERROR',I3,' OPEN HISTORY FILE')
 1010 FORMAT (A6,'/ Run at ',A12,2X,A8)
 1011 FORMAT (A6,' /')
 1012 FORMAT (A6, 'INFILE =''',A,'''')
 1013 FORMAT (A6, 'OUTVER = ', I4,' / Output AN table number')
 2004 FORMAT (A6,'RELEASE = ''',A7,' ''')
      END
      SUBROUTINE ANTHED (ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE, POLRXY,
     *   UT1UTC, DATUTC, ANAME, XYZHAN, TFRAME, IRET)
C-----------------------------------------------------------------------
C   ANTHED reads the header section of the external text file.
C   to be open and returns the values.
C   Input/Output:
C      ARRAYC  D(3)   Array center in m.
C      GSTIA0  D      GST at IAT0
C      DEGPDY  D      Earth rotation rate
C      SAFREQ  D      Subarray reference frequency
C      RDATE   C*8    Subarray reference date
C      POLRXY  R(2)   Position of pole (arc seconds)
C      UT1UTC  R      UT1-UTC
C      DATUTC  R      data time - UTC
C      ANAME   C*8    Array name
C      XYZHAN  C*8    Handedness of Bx, By, Bz
C      TFRME   C*8    Terrestrial reference frame
C   Output:
C      IRET    I      Return code, 0=OK
C-----------------------------------------------------------------------
      DOUBLE PRECISION ARRAYC(3), GSTIA0, DEGPDY, SAFREQ
      CHARACTER RDATE*8, ANAME*8, XYZHAN*8, TFRAME*8
      REAL      POLRXY(2), UT1UTC, DATUTC
      INTEGER   IRET
C
      INTEGER   NP
      PARAMETER (NP=14)
      CHARACTER PARS(NP)*8, ENDMRK*8, VALCH(NP)*24
      INTEGER   KMODE, NPARS, RARR, RGST, RDEG, RSAF, RPOL, RUT1, RIAT,
     *   CRDA, CANA, CXYZ, CTFR
      DOUBLE PRECISION VALS(NP)
      INCLUDE 'SETAN.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
C                                       Real data
      DATA PARS /'ARRAYX', 'ARRAYY', 'ARRAYZ', 'GSTIAT', 'DEGPDY',
     *   'FREQ', 'POLARX', 'POLARY', 'UT1UTC', 'DATUTC',
C                                       Character data
     *   'ARRNAM', 'RDATE', 'XYZHAN', 'TFRAME'/
      DATA ENDMRK /'/       '/
      DATA NPARS, KMODE /12, 0/
C                                       Pointers
      DATA RARR, RGST, RDEG, RSAF, RPOL, RUT1, RIAT
     *   /  1,    4,    5,    6,    7,    9,    10/
      DATA CANA, CRDA, CXYZ, CTFR /11, 12, 13, 14/
C-----------------------------------------------------------------------
C                                       Set defaults
C                                       Array center
      VALS(RARR) = ARRAYC(1)
      VALS(RARR+1) = ARRAYC(2)
      VALS(RARR+2) = ARRAYC(3)
C                                       GST at time=0
      VALS(RGST) = GSTIA0
C                                       Earth rotation rate
      VALS(RDEG) = DEGPDY
C                                       Reference frequency
      VALS(RSAF) = SAFREQ
C                                       Polar position
      VALS(RPOL) = POLRXY(1)
      VALS(RPOL+1) = POLRXY(2)
C                                       UT1 - UTC
      VALS(RUT1) = UT1UTC
C                                       data time - UTC
      VALS(RIAT) = DATUTC
C                                       Array name
      VALCH(CANA) = ANAME
C                                       Reference date
      VALCH(CRDA) = RDATE
C                                       handedness
      VALCH(CXYZ) = XYZHAN
C                                       Frame
      VALCH(CTFR) = TFRAME
C                                       Read file.
      CALL KEYIN (PARS, VALS, VALCH, NPARS, ENDMRK, KMODE, LUNIN,
     *   FINDIN, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Set output values
      ARRAYC(1) = VALS(RARR)
      ARRAYC(2) = VALS(RARR+1)
      ARRAYC(3) = VALS(RARR+2)
      GSTIA0 = VALS(RGST)
      DEGPDY = VALS(RDEG)
      SAFREQ = VALS(RSAF)
      POLRXY(1) = VALS(RPOL)
      POLRXY(2) = VALS(RPOL+1)
      UT1UTC = VALS(RUT1)
      DATUTC = VALS(RIAT)
      ANAME = VALCH(CANA)
      CALL DATFST ('F2L', VALCH(CRDA))
      RDATE = VALCH(CRDA)
      XYZHAN = VALCH(CXYZ)
      TFRAME = VALCH(CTFR)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ANTHED: ERROR =',I3,' FROM KEYIN')
 1020 FORMAT (6X,I2)
      END

      SUBROUTINE XYSHFT (RA, DEC, XSHIFT, YSHIFT, ROTATE, XRA, XDEC)
C-----------------------------------------------------------------------
C! Returns shifted coordinates
C# Map Header coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 1999
C;  Associated Universities, Inc. Washington DC, USA.
C;  Eric W. Greisen
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Shifts coordinates from RA, DEC
C   Input:
C      RA       D   Initial RA in degrees: ref point
C      DEC      D   Initial Declination in degrees: ref point
C      XSHIFT   R   Shift in "X" in arc sec - simple shifts not -SIN
C      YSHIFT   R   Shift in "Y" in arc sec
C      ROTATE   R   Image rotation in degrees
C   Output
C      XRA      D   RA of shifted point in degrees
C      XDEC     D   Declination of shifted point in degrees
C-----------------------------------------------------------------------
      DOUBLE PRECISION RA, DEC, XRA, XDEC
      REAL      XSHIFT, YSHIFT, ROTATE
C
      REAL      MAPRR
      DOUBLE PRECISION XXINC, XXSHFT, YYSHFT
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      MAPRR = ROTATE * DG2RAD
C                                       Undo rotation
      XXSHFT = (COS (MAPRR) * XSHIFT - SIN (MAPRR) * YSHIFT) / 3600.0
      YYSHFT = (SIN (MAPRR) * XSHIFT + COS (MAPRR) * YSHIFT) / 3600.0
C                                       -SIN shifts
C     XXINC = ATAN (XXSHFT / (YYSHFT * SIN (DEC * DG2RAD) -
C    *   COS (DEC * DG2RAD) * SQRT ( 1.0 - XXSHFT * XXSHFT -
C    *   YYSHFT * YYSHFT))) / DG2RAD
C     XRA = RA - XXINC
C     XDEC = ASIN (YYSHFT * COS (DEC * DG2RAD) +
C    *   SQRT (1.0 - XXSHFT * XXSHFT - YYSHFT * YYSHFT) *
C    *   SIN (DEC * DG2RAD)) / DG2RAD
C                                       simple shifts
      XDEC = DEC + YYSHFT
      XXINC = COS (DG2RAD * DEC)
      IF (XXINC.NE.0) THEN
         XRA = RA + XXSHFT / XXINC
      ELSE
         XRA = RA
         END IF
C
 999  RETURN
      END

      SUBROUTINE TVHELX (NLEVS, DOPRNT, IERR)
C-----------------------------------------------------------------------
C! OFM helix in color intensity space - interactive uses CUBHLX
C# POPS=appl TV-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 2010-2011, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does a helix in OFM colors, which is monotonically increasing in
C   perceived intensity (since R, G, B are appropriately weighted).
C   Dave Green -- MRAO
C-----------------------------------------------------------------------
      INTEGER   NLEVS, DOPRNT, IERR
C
      INTEGER   IBUT, ISIZEX, ISIZEY, QUAD, ITW(3), I, II, JJ, NLO, NHI
      REAL      START, ROTS, ROTATE, HUE, GAMMA, RPOS(2), PPOS(2),
     *   RED(32752), GRN(32752), BLU(32752)
      LOGICAL   PROT, VRTRTC, F, DOIT
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA F/.FALSE./
C-----------------------------------------------------------------------
      PROT = .FALSE.
      CALL ZTIME (ITW)
C                                       Give instructions...
      MSGTXT = 'Press button A to toggle rotation direction'
      CALL MSGWRT (1)
      MSGTXT = 'Press button B to increment number of rotations'
      CALL MSGWRT (1)
      MSGTXT = 'Press button C to increment hue saturation (by 0.2)'
      CALL MSGWRT (1)
      MSGTXT = 'Press button D to exit'
      CALL MSGWRT (1)
      MSGTXT = 'Cursor X controls starting color'
      CALL MSGWRT(1)
      MSGTXT = 'Cursor Y controls gamma (0.3 to 3.0)'
      CALL MSGWRT (1)
      START = 0.5
      ROTS = 1.5
      HUE = 1.0
      GAMMA = 1.0
C                                       Cursor on...
      QUAD = -1
      RPOS(1) = (WINDTV(1) + WINDTV(3)) / 2
      RPOS(2) = (WINDTV(2) + WINDTV(4)) / 2
      ISIZEX = WINDTV(3) - WINDTV(1) + 1
      ISIZEY = WINDTV(4) - WINDTV(2) + 1
      CALL YCURSE ('ONNN', F, F, RPOS, QUAD, IBUT, IERR)
      IF (IERR.NE.0) GO TO 930
C                                       Read cursor position...
 100  CALL YCURSE ('READ', F, F, RPOS, QUAD, IBUT, IERR)
      IF (IERR.NE.0) GO TO 930
C
C Buttons: 8 = D exit, otherwise read position, 4=C, 2=B, 1=A
C
      IF (IBUT.LE.7) THEN
         IF (IBUT.GT.0) THEN
            CALL YWINDO ('READ', WINDTV, IERR)
            IF (IERR.NE.0) GO TO 930
            ISIZEX = WINDTV(3) - WINDTV(1) + 1
            ISIZEY = WINDTV(4) - WINDTV(2) + 1
            END IF
C                                       hue > 1 clipped at ends
         IF (IBUT.GE.4) THEN
            HUE = HUE + 0.2
            IF (HUE.GT.2.1) HUE = 0.0
         ELSE IF (IBUT.GE.2) THEN
            ROTS = ROTS + 0.5
            IF (ROTS.GT.4.0) ROTS = 0.0
         ELSE IF (IBUT.EQ.1) THEN
            PROT = .NOT.PROT
            END IF
C
         CALL DLINTR (RPOS, IBUT, PPOS, ITW, DOIT)
         IF (DOIT) THEN
            START = 3.0 * (RPOS(1) - WINDTV(1) + 1.0) / ISIZEX - 1.0
            GAMMA = 10.0 ** ((RPOS(2) - WINDTV(2) + 1.0) / ISIZEY - 0.5)
            IF (PROT) THEN
               ROTATE = ROTS
            ELSE
               ROTATE = -ROTS
               END IF
C                                       compute the helix
            CALL CUBHLX (START, ROTATE, HUE, GAMMA, NLEVS, RED, GRN,
     *         BLU, NLO, NHI)
C                                       Extend to fill and load
            I = OFMINP + 1
            JJ = NLEVS
            I = I / JJ
            DO 110 II = 2,I
               CALL RCOPY (NLEVS, RED, RED(JJ+1))
               CALL RCOPY (NLEVS, GRN, GRN(JJ+1))
               CALL RCOPY (NLEVS, BLU, BLU(JJ+1))
               JJ = JJ + NLEVS
 110           CONTINUE
            VRTRTC = .FALSE.
            CALL YOFM ('WRIT', 4, VRTRTC, RED, IERR)
            IF (IERR.NE.0) GO TO 930
            CALL YOFM ('WRIT', 2, VRTRTC, GRN, IERR)
            IF (IERR.NE.0) GO TO 930
            CALL YOFM ('WRIT', 1, VRTRTC, BLU, IERR)
            IF (IERR.NE.0) GO TO 930
C                                       display
            IF (DOPRNT.GT.0) THEN
               WRITE (MSGTXT,1110) START, ROTATE, HUE, GAMMA
               CALL MSGWRT (1)
               IF (NLO+NHI.GT.0) THEN
                  WRITE (MSGTXT,1111) NLO, NHI, NLEVS
                  CALL MSGWRT (1)
                  END IF
               END IF
            END IF
C                                       Loop back...
         GO TO 100
C                                       done
      ELSE
         IF (DOPRNT.NE.0) THEN
            WRITE (MSGTXT,1110) START, ROTATE, HUE, GAMMA
            CALL MSGWRT (3)
            IF (NLO+NHI.GT.0) THEN
               WRITE (MSGTXT,1111) NLO, NHI, NLEVS
               CALL MSGWRT (3)
               END IF
            END IF
         END IF
      GO TO 999
C                                       TV error
 930  WRITE (MSGTXT,1000) IERR, 'IN TV OPERATION'
      CALL MSGWRT (8)
C                                       Exit...
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('TVHELX ERROR',I4,' ON ',A)
 1110 FORMAT ('TVHELIX: start=',F4.1,' rotations=',F4.1,' hue=',F4.1,
     *   ' gamma=',F4.1)
 1111 FORMAT ('TVHELIX: clipped (low/high): ',I4,'/',I4,' out of ',I4)
      END

      SUBROUTINE ZPROMP (IPC, BUFF, IERR)
C-----------------------------------------------------------------------
C! prompt user and read 80-characters from CRT screen
C# Z Terminal
C-----------------------------------------------------------------------
C;  Copyright (C) 2004, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZPRMPT prompts user on CRT screen and reads a line.
C   Input:
C      IPC     I      prompt character.
C   Output:
C      BUFF    C*80   line of user input.
C      IERR    I      error code:   0 => ok.
C                        1 => read/write error.
C   Generic version - call ZPRMPT with HOLLERITH if not VMS
C      VMS COMMENTED OUT
C-----------------------------------------------------------------------
      CHARACTER IPC*1, BUFF*(*)
      INTEGER   IERR
C
      INTEGER   LBUF
      HOLLERITH HPC,HBUF(64)
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C     IF (SYSTYP.EQ.'VMS') THEN
C        CALL ZPRMPT (IPC, BUFF, IERR)
C     ELSE
         CALL CHR2H (4, IPC, 1, HPC)
         CALL ZPRMPT (HPC, HBUF, IERR)
         LBUF = LEN (BUFF)
         LBUF = MIN (LBUF, 256)
         CALL H2CHR (LBUF, 1, HBUF, BUFF)
C        END IF
C
 999  RETURN
      END

LOCAL INCLUDE 'REBYTE.INC'
      INTEGER   USER, UMAX, NBYWD, LUNI, LUNO, VOLI, VOLO, BUFF(256),
     *   US1, US2
      LOGICAL   T, F, MBLANK
      COMMON /REBPAR/ BUFF, USER, UMAX, NBYWD, LUNI, LUNO, VOLI, VOLO,
     *   T, F, US1, US2, MBLANK
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
LOCAL END
      PROGRAM REBYTE
C-----------------------------------------------------------------------
C! RECAT converts whole data area from opposite to current byte order
C# Utility Catalog
C-----------------------------------------------------------------------
C;  Copyright (C) 2007-2008, 2010, 2015, 2017, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   A service routine to convert data from one byte order (MACPPC and
C   Solaris) to the other (Linux and Mac Intel) and vice versa.  It
C   assumes that the data are in the wrong byte order for the current
C   computer and changes them.  It writes in a data area separate from
C   the input area.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   TTY(2), IERR
      INCLUDE 'REBYTE.INC'
      DATA TTY /5,0/, PRGNAM /'REBYTE'/
C-----------------------------------------------------------------------
C                                       Standard AIPS inits.
      CALL AIPINI (TTY, PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL REBINI (TTY, IERR)
      IF (IERR.NE.0) GO TO 990
      NVOL = 35
      DO 10 USER = US1,US2
         CALL REBILD (IERR)
         IF (IERR.GT.0) GO TO 990
 10      CONTINUE
C
 990  CALL ACOUNT (2)
C
 999  STOP
      END
      SUBROUTINE REBINI (TTY, IERR)
C-----------------------------------------------------------------------
C   Assign disk areas, init parameters
C   Input:
C      TTY     I(2)   LUN and FTAB index of open TTY.
C   Output:
C      IERR    I      Error code
C-----------------------------------------------------------------------
      INTEGER   TTY(2), IERR
C
      INTEGER   J, JTRIM
      HOLLERITH HNAME(20), HDISK(1)
      CHARACTER FNAME*192, DISKN*4
      INCLUDE 'REBYTE.INC'
C-----------------------------------------------------------------------
C                                       limit of ehex 3 digit
      UMAX = 36 * 36 * 36 - 1
      NBYWD = NBITWD / 8
C                                       user number range
      WRITE (MSGTXT,1000) UMAX
      CALL INQINT (TTY, MSGTXT, 2, US1, IERR)
      IF ((IERR.NE.0) .OR. (US2.LT.US1)) GO TO 900
      IF ((US1.EQ.0) .AND. (US2.EQ.0)) THEN
         US1 = 1
         US2 = UMAX
         END IF
      US1 = MAX (US1, 1)
      US2 = MAX (US1, MIN (US2, UMAX))
C                                       data area in
      WRITE (MSGTXT,1010) 'input'
      CALL INQSTR (TTY, MSGTXT, 192, FNAME, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'ERROR READING FILE NAME'
         IF (IERR.EQ.10) MSGTXT = 'INPUT STRING LONGER THAN 192' //
     *      ' CHARACTERS'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      J = JTRIM (FNAME)
      CALL CHR2H (J, FNAME, 1, HNAME)
      DISKN = 'DA1Y'
      CALL CHR2H (4, DISKN, 1, HDISK)
      CALL ZCRLOG (4, HDISK, J, HNAME, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1015) IERR, 'input'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       data area out
      WRITE (MSGTXT,1010) 'output'
      CALL INQSTR (TTY, MSGTXT, 192, FNAME, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'ERROR READING FILE NAME'
         IF (IERR.EQ.10) MSGTXT = 'INPUT STRING LONGER THAN 192' //
     *      ' CHARACTERS'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      J = JTRIM (FNAME)
      CALL CHR2H (J, FNAME, 1, HNAME)
      DISKN = 'DA1Z'
      CALL CHR2H (4, DISKN, 1, HDISK)
      CALL ZCRLOG (4, HDISK, J, HNAME, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1015) IERR, 'output'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C
 900  IF ((IERR.EQ.0) .AND. (FNAME.EQ.' ')) IERR = 10
      IF ((IERR.EQ.0) .AND. (US2.LT.US1)) IERR = 10
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Enter range of user numbers between 1 and',I6)
 1010 FORMAT ('Enter full path name to ',A,' data directory')
 1015 FORMAT ('ERROR',I3,' CREATING ',A,' LOGICAL NAME')
      END
      SUBROUTINE REBILD (IRET)
C-----------------------------------------------------------------------
C   Byte reverse and copy a users data
C   Output:
C      IRET   I      error  code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER PNAMEI*48, PNAMEO*48
      INTEGER   INDI, INDO, SIZEI, SIZEO, NLPR, NWPL, IPOS, IREC, I, I1,
     *   VMAX, IVER
      INCLUDE 'REBYTE.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      LUNI = 15
      LUNO = 16
      VOLI = 34
      VOLO = 35
      T = .TRUE.
      F = .FALSE.
C                                       does this user have files
      CALL PHILEN ('MS', VOLI,  USER, 0, PNAMEI, IRET)
      CALL ZEXIST (VOLI, PNAMEI, SIZEI, IRET)
      IF (IRET.GT.1) THEN
         WRITE (MSGTXT,1000) IRET, 'EXIST', 'MS', 0
         GO TO 990
C                                       copy MS file
      ELSE IF ((IRET.EQ.0) .AND. (SIZEI.GT.0)) THEN
         WRITE (MSGTXT,2000) 'MS', 0, USER
         CALL MSGWRT (2)
         CALL PHILEN ('MS', VOLO,  USER, 0, PNAMEO, IRET)
         CALL ZCREAT (VOLO, PNAMEO, SIZEI, F, SIZEO, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATE', 'MS', 0
            GO TO 990
            END IF
         CALL ZOPEN (LUNI, INDI, VOLI, PNAMEI, F, F, T, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN IN', 'MS', 0
            GO TO 990
            END IF
         CALL ZOPEN (LUNO, INDO, VOLO, PNAMEO, F, T, T, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OUT', 'MS', 0
            GO TO 990
            END IF
         NLPR = 10
         NWPL = 25
         DO 20 IREC = 1,SIZEI
            CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'READ IN', 'MS', 0, IREC
               GO TO 990
               END IF
            IF (IREC.EQ.1) CALL ZBFLI2 (NBYWD, 2, 3, BUFF(1), BUFF(1))
            IPOS = 3
            DO 10 I = 1,NLPR
               CALL ZBFLI2 (NBYWD, 3, 3, BUFF(IPOS), BUFF(IPOS))
               IPOS = IPOS + NWPL
 10            CONTINUE
            CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'WRITE OUT', 'MS', 0, IREC
               GO TO 990
               END IF
 20         CONTINUE
         CALL ZCLOSE (LUNI, INDI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSE IN', 'MS', 0
            GO TO 990
            END IF
         CALL ZCLOSE (LUNO, INDO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSE OUT', 'MS', 0
            GO TO 990
            END IF
         END IF
C                                       TG files
      DO 30 IVER = 0,35
         CALL PHILEN ('TG', VOLI, 400, IVER, PNAMEI, IRET)
         CALL ZEXIST (VOLI, PNAMEI, SIZEI, IRET)
         IF (IRET.GT.1) THEN
            WRITE (MSGTXT,1000) IRET, 'EXIST', 'TG', IVER
            GO TO 990
C                                       copy TG file
         ELSE IF ((IRET.EQ.0) .AND. (SIZEI.GT.0)) THEN
            WRITE (MSGTXT,2000) 'TG', IVER, USER
            CALL MSGWRT (2)
            CALL FLPBYT ('TG', 400, IVER, SIZEI, IRET)
            IF (IRET.GT.0) GO TO 999
            END IF
 30      CONTINUE
C                                       SG directory file
      CALL PHILEN ('SG', VOLI, USER, 0, PNAMEI, IRET)
      CALL ZEXIST (VOLI, PNAMEI, SIZEI, IRET)
      IF (IRET.GT.1) THEN
         WRITE (MSGTXT,1000) IRET, 'EXIST', 'SG', 0
         GO TO 990
C                                       copy SG directory
      ELSE IF ((IRET.EQ.0) .AND. (SIZEI.GT.0)) THEN
         WRITE (MSGTXT,2000) 'SG', 0, USER
         CALL MSGWRT (2)
         CALL PHILEN ('SG', VOLO,  USER, 0, PNAMEO, IRET)
         CALL ZCREAT (VOLO, PNAMEO, SIZEI, F, SIZEO, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATE', 'SG', 0
            GO TO 990
            END IF
         CALL ZOPEN (LUNI, INDI, VOLI, PNAMEI, F, F, T, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN IN', 'SG', 0
            GO TO 990
            END IF
         CALL ZOPEN (LUNO, INDO, VOLO, PNAMEO, F, T, T, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OUT', 'SG', 0
            GO TO 990
            END IF
         NWPL = 7
         NLPR = 256 / NWPL
         DO 40 IREC = 1,SIZEI
            CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'READ IN', 'SG', 0, IREC
               GO TO 990
               END IF
            IF (IREC.EQ.1) THEN
               CALL ZBFLI2 (NBYWD, 7, 3, BUFF(1), BUFF(1))
               IPOS = 8
               I1 = 2
               VMAX = BUFF(1)
            ELSE
               IPOS = 1
               I1 = 1
               END IF
            DO 35 I = I1,NLPR
               CALL ZBFLI2 (NBYWD, 3, 3, BUFF(IPOS), BUFF(IPOS))
               IPOS = IPOS + NWPL
 35            CONTINUE
            CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'WRITE OUT', 'SG', 0, IREC
               GO TO 990
               END IF
 40         CONTINUE
         CALL ZCLOSE (LUNI, INDI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSE IN', 'SG', 0
            GO TO 990
            END IF
         CALL ZCLOSE (LUNO, INDO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSE OUT', 'SG', 0
            GO TO 990
            END IF
C                                       SG data files
         DO 50 IVER = 1,VMAX
            CALL PHILEN ('SG', VOLI, USER, IVER, PNAMEI, IRET)
            CALL ZEXIST (VOLI, PNAMEI, SIZEI, IRET)
            IF (IRET.GT.1) THEN
               WRITE (MSGTXT,1000) IRET, 'EXIST', 'SG', IVER
               GO TO 990
C                                       copy SG directory
            ELSE IF ((IRET.EQ.0) .AND. (SIZEI.GT.0)) THEN
               WRITE (MSGTXT,2000) 'SG', IVER, USER
               CALL MSGWRT (2)
               CALL FLPBYT ('SG', USER, IVER, SIZEI, IRET)
               IF (IRET.GT.0) GO TO 999
               END IF
 50         CONTINUE
         END IF
C                                       CA file
      IRET = 0
      CALL PHILEN ('CA', VOLI, 0, 0, PNAMEI, IRET)
      CALL ZEXIST (VOLI, PNAMEI, SIZEI, IRET)
      IF (IRET.GT.1) THEN
         WRITE (MSGTXT,1000) IRET, 'EXIST', 'CA', 0
         GO TO 990
C                                       copy CA file
      ELSE IF ((IRET.EQ.0) .AND. (SIZEI.GT.0)) THEN
         WRITE (MSGTXT,2000) 'CA', 0, USER
         CALL MSGWRT (2)
         CALL PHILEN ('CA', VOLO, 0, 0, PNAMEO, IRET)
         CALL ZCREAT (VOLO, PNAMEO, SIZEI, F, SIZEO, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CREATE', 'CA', 0
            GO TO 990
            END IF
         CALL ZOPEN (LUNI, INDI, VOLI, PNAMEI, F, F, T, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN IN', 'CA', 0
            GO TO 990
            END IF
         CALL ZOPEN (LUNO, INDO, VOLO, PNAMEO, F, T, T, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN OUT', 'CA', 0
            GO TO 990
            END IF
         NWPL = 10
         NLPR = 256 / NWPL
         DO 60 IREC = 1,SIZEI
            CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'READ IN', 'CA', 0, IREC
               GO TO 990
               END IF
            IF (IREC.EQ.1) THEN
               CALL ZBFLI2 (NBYWD, 15, 3, BUFF(1), BUFF(1))
            ELSE
               IPOS = 1
               DO 55 I = 1,NLPR
                  CALL ZBFLI2 (NBYWD, 5, 3, BUFF(IPOS), BUFF(IPOS))
                  IPOS = IPOS + NWPL
 55               CONTINUE
               END IF
            CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'WRITE OUT', 'CA', 0, IREC
               GO TO 990
               END IF
 60         CONTINUE
         CALL ZCLOSE (LUNI, INDI, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSE IN', 'CA', 0
            GO TO 990
            END IF
         CALL ZCLOSE (LUNO, INDO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOSE OUT', 'CA', 0
            GO TO 990
            END IF
C                                       process user data files
         CALL UDATA (IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
      IRET = 0
C
 990  IF (IRET.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' DOING ',A,' ON FILE TYPE ',A,' VER',I4)
 1010 FORMAT ('ERROR',I3,' DOING ',A,' ON FILE TYPE ',A,' VER',I4,
     *   ' REC',I6)
 2000 FORMAT ('Start copying ',A,' vers',I4,' for user',I5)
      END
      SUBROUTINE FLPBYT (TYPE, SEQ, VER, SIZEI, IRET)
C-----------------------------------------------------------------------
C   Copies a data set containing character and binary data but no
C   double precision data forcing byte and word flip.  This one creates
C   output, opens files, and closes them.  FLPIT does the I/O.
C   Inputs
C      TYPE    C*2   File type
C      SEQ     I     Seq (part of file name)
C      VER     I     Ver (part of file name)
C      SIZEI   I     Size of input file in 256-word records
C   Outputs
C      IRET    I     Error code
C-----------------------------------------------------------------------
      CHARACTER TYPE*2
      INTEGER   SEQ, VER, SIZEI, IRET
C
      INTEGER   SIZEO, INDI, INDO
      CHARACTER PNAMEI*48, PNAMEO*48
      INCLUDE 'REBYTE.INC'
C-----------------------------------------------------------------------
      CALL PHILEN (TYPE, VOLI, SEQ, VER, PNAMEI, IRET)
      CALL PHILEN (TYPE, VOLO, SEQ, VER, PNAMEO, IRET)
      CALL ZCREAT (VOLO, PNAMEO, SIZEI, F, SIZEO, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATE', TYPE, VER
         GO TO 990
         END IF
      CALL ZOPEN (LUNI, INDI, VOLI, PNAMEI, F, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN IN', TYPE, VER
         GO TO 990
         END IF
      CALL ZOPEN (LUNO, INDO, VOLO, PNAMEO, F, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OUT', TYPE, VER
         GO TO 990
         END IF
      CALL FLPIT (TYPE, VER, INDI, INDO, SIZEI, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL ZCLOSE (LUNI, INDI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSE IN', TYPE, VER
         GO TO 990
         END IF
      CALL ZCLOSE (LUNO, INDO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSE OUT', TYPE, VER
         GO TO 990
         END IF
C
 990  IF (IRET.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FLPBYT: ERROR',I3,' DOING ',A,' ON TYPE ',A,' VER',I4)
      END
      SUBROUTINE FLPIT (TYPE, VER, INDI, INDO, SIZEI, IRET)
C-----------------------------------------------------------------------
C   Copies a data set containing character and binary data but no
C   double precision data forcing byte and word flip.
C   Inputs
C      TYPE    C*2   File type
C      VER     I     Ver (part of file name)
C      INDI    I     input FTAB pointer
C      INDO    I     output FTAB pointer
C      SIZEI   I     Size of input file in 256-word records
C   Outputs
C      IRET    I     Error code
C-----------------------------------------------------------------------
      CHARACTER TYPE*2
      INTEGER   VER, INDI, INDO, SIZEI, IRET
C
      INTEGER   IREC
      INCLUDE 'REBYTE.INC'
C-----------------------------------------------------------------------
C                                       do copy
      DO 20 IREC = 1,SIZEI
         CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'READ IN', TYPE, VER, IREC
            GO TO 990
            END IF
         CALL ZBFLC2 (4, 256, 3, BUFF, BUFF)
         CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'WRITE OUT', TYPE, VER, IREC
            GO TO 990
            END IF
 20      CONTINUE
C
 990  IF (IRET.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('FLPIT: ERROR',I3,' DOING ',A,' ON TYPE ',A,' VER',I4,
     *   ' REC',I6)
      END
      SUBROUTINE FULFLP (TYPE, SEQ, VER, SIZEI, IRET)
C-----------------------------------------------------------------------
C   Copies a data set containing binary data but no characters or double
C   precision data forcing byte and word flip.  Treated as MAP files.
C   Inputs
C      TYPE    C*2   File type
C      SEQ     I     Seq (part of file name)
C      VER     I     Ver (part of file name)
C      SIZEI   I     Size of input file in 256-word records
C   Outputs
C      IRET    I     Error code
C-----------------------------------------------------------------------
      CHARACTER TYPE*2
      INTEGER   SEQ, VER, SIZEI, IRET
C
      INTEGER   SIZEO, INDI, INDO, IREC
      CHARACTER PNAMEI*48, PNAMEO*48
      INCLUDE 'REBYTE.INC'
C-----------------------------------------------------------------------
      CALL PHILEN (TYPE, VOLI, SEQ, VER, PNAMEI, IRET)
      CALL PHILEN (TYPE, VOLO, SEQ, VER, PNAMEO, IRET)
      CALL ZCREAT (VOLO, PNAMEO, SIZEI, T, SIZEO, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATE', TYPE, VER
         GO TO 990
         END IF
      CALL ZOPEN (LUNI, INDI, VOLI, PNAMEI, F, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN IN', TYPE, VER
         GO TO 990
         END IF
      CALL ZOPEN (LUNO, INDO, VOLO, PNAMEO, F, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OUT', TYPE, VER
         GO TO 990
         END IF
      DO 20 IREC = 1,SIZEI
         CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'READ IN', TYPE, VER, IREC
            GO TO 990
            END IF
         IF (MBLANK) THEN
            CALL ZBFLM2 (4, 256, 3, BUFF, BUFF)
         ELSE
            CALL ZBFLI2 (4, 256, 3, BUFF, BUFF)
            END IF
         CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'WRITE OUT', TYPE, VER, IREC
            GO TO 990
            END IF
 20      CONTINUE
      CALL ZCLOSE (LUNI, INDI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSE IN', TYPE, VER
         GO TO 990
         END IF
      CALL ZCLOSE (LUNO, INDO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSE OUT', TYPE, VER
         GO TO 990
         END IF
C
 990  IF (IRET.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FULFLP: ERROR',I3,' DOING ',A,' ON TYPE ',A,' VER',I4)
 1010 FORMAT ('FULFLP: ERROR',I3,' DOING ',A,' ON TYPE ',A,' VER',I4,
     *   ' REC',I6)
      END
      SUBROUTINE UDATA (IRET)
C-----------------------------------------------------------------------
C   Looks for header files, fixes them, fixes the data file, fixes the
C   extension files.
C   Output:
C      IRET   I   Error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   ABYTFL, NMISS, CNO, ITY, I, IPOS, VER, NVER, SIZEI,
     *   SIZEO, INDI, INDO, IREC, NWPL, NLPR
      CHARACTER TYPE*2, PNAMEI*48, PNAMEO*48
      LOGICAL   COMPRS
      INCLUDE 'REBYTE.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       look for all possible CB files
      NMISS = 0
      ABYTFL = BYTFLP
      DO 100 CNO = 1,UMAX
         TYPE = 'CB'
         CALL PHILEN (TYPE, VOLI, CNO, 1, PNAMEI, IRET)
         CALL ZEXIST (VOLI, PNAMEI, SIZEI, IRET)
         IF (IRET.GT.1) THEN
            WRITE (MSGTXT,1000) IRET, 'EXIST', TYPE, CNO
            GO TO 990
         ELSE IF ((IRET.EQ.1) .OR. (SIZEI.LE.0)) THEN
            NMISS = NMISS + 1
            IRET = 0
            IF (NMISS.GT.500) GO TO 999
C                                       copy CB file
         ELSE IF ((IRET.EQ.0) .AND. (SIZEI.GT.0)) THEN
            NMISS = 0
            WRITE (MSGTXT,2000) TYPE, CNO, USER
            CALL MSGWRT (2)
            CALL PHILEN (TYPE, VOLO, CNO, 1, PNAMEO, IRET)
            CALL ZCREAT (VOLO, PNAMEO, SIZEI, F, SIZEO, IRET)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1000) IRET, 'CREATE', TYPE, CNO
               GO TO 990
               END IF
            CALL ZOPEN (LUNI, INDI, VOLI, PNAMEI, F, F, T, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'OPEN IN', TYPE, CNO
               GO TO 990
               END IF
            CALL ZOPEN (LUNO, INDO, VOLO, PNAMEO, F, T, T, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'OPEN OUT', TYPE, CNO
               GO TO 990
               END IF
C                                       header record
            IREC = 1
            CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'READ IN', TYPE, CNO, IREC
               GO TO 990
               END IF
            CALL CATBYT (BUFF, CATBLK)
            CALL ZFIO ('WRIT', LUNO, INDO, IREC, CATBLK, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'WRITE OUT', TYPE, CNO, IREC
               GO TO 990
               END IF
C                                       keyword section
            NWPL = 5
            NLPR = 256 / NWPL
            DO 20 IREC = 2,SIZEI
               CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1010) IRET, 'READ IN', TYPE, CNO, IREC
                  GO TO 990
                  END IF
               IPOS = 4
               DO 10 I = 1,NLPR
                  IF ((IREC.EQ.2) .AND. (I.EQ.1)) THEN
                     CALL ZBFLI2 (4, 6, 3, BUFF, BUFF)
                  ELSE
                     CALL ZBFLI2 (4, 1, 3, BUFF(IPOS+2), BUFF(IPOS+2))
                     IF (BUFF(IPOS+2).EQ.1) THEN
                        CALL ZBFLI2 (8, 1, 3, BUFF(IPOS), BUFF(IPOS))
                     ELSE IF (BUFF(IPOS+2).NE.3) THEN
                        CALL ZBFLI2 (4, 2, 3, BUFF(IPOS), BUFF(IPOS))
                        END IF
                     END IF
                  IPOS = IPOS + NWPL
 10               CONTINUE
               CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1010) IRET, 'WRITE OUT', TYPE, CNO, IREC
                  GO TO 990
                  END IF
 20            CONTINUE
            CALL ZCLOSE (LUNI, INDI, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'CLOSE IN', TYPE, CNO
               GO TO 990
               END IF
            CALL ZCLOSE (LUNO, INDO, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1000) IRET, 'CLOSE OUT', TYPE, CNO
               GO TO 990
               END IF
C                                       data file
            CALL H2CHR (2, KHPTYO, CATH(KHPTY), TYPE)
            WRITE (MSGTXT,2000) TYPE, CNO, USER
            CALL MSGWRT (2)
            CALL PHILEN (TYPE, VOLI, CNO, 1, PNAMEI, IRET)
            CALL ZEXIST (VOLI, PNAMEI, SIZEI, IRET)
            IF (IRET.GT.1) THEN
               WRITE (MSGTXT,1000) IRET, 'EXIST', TYPE, CNO
               GO TO 990
C                                       copy data file
            ELSE IF ((IRET.EQ.0) .AND. (SIZEI.GT.0)) THEN
               MBLANK = .FALSE.
               IF ((TYPE.EQ.'MA') .AND. (CATR(KRBLK).EQ.FBLANK)) MBLANK
     *            = .TRUE.
               COMPRS = (TYPE.EQ.'UV') .AND. (CATBLK(KINAX).EQ.1)
               IF (COMPRS) THEN
                  CALL CMPFLP (CNO, 1, SIZEI, IRET)
               ELSE
                  CALL FULFLP (TYPE, CNO, 1, SIZEI, IRET)
                  END IF
               IF (IRET.NE.0) GO TO 999
            ELSE
               MSGTXT = 'WARNING: DATA FILE DOES NOT SEEM TO EXIST'
               CALL MSGWRT (7)
               END IF

C                                       extension files
            DO 50 ITY = 1,KIEXTN
               CALL H2CHR (2, 1, CATH(KHEXT+ITY-1), TYPE)
               NVER = CATBLK(KIVER+ITY-1)
               IF ((TYPE(1:1).LT.'A') .OR. (TYPE(2:2).LT.'A')) NVER = 0
               IF ((TYPE(1:1).GT.'Z') .OR. (TYPE(2:2).GT.'Z')) NVER = 0
               DO 40 VER = 1,NVER
                  CALL PHILEN (TYPE, VOLI, CNO, VER, PNAMEI, IRET)
                  CALL ZEXIST (VOLI, PNAMEI, SIZEI, IRET)
                  IF (IRET.GT.1) THEN
                     WRITE (MSGTXT,1000) IRET, 'EXIST', TYPE, CNO
                     GO TO 990
C                                       copy ext file
                  ELSE IF ((IRET.EQ.0) .AND. (SIZEI.GT.0)) THEN
                     WRITE (MSGTXT,2010) TYPE, CNO, VER, USER
                     CALL MSGWRT (2)
                     CALL PHILEN (TYPE, VOLO, CNO, VER, PNAMEO, IRET)
                     CALL ZCREAT (VOLO, PNAMEO, SIZEI, F, SIZEO, IRET)
                     IF (IRET.GT.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'CREATE', TYPE, CNO
                        GO TO 990
                        END IF
                     CALL ZOPEN (LUNI, INDI, VOLI, PNAMEI, F, F, T,
     *                  IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'OPEN IN', TYPE, CNO
                        GO TO 990
                        END IF
                     CALL ZOPEN (LUNO, INDO, VOLO, PNAMEO, F, T, T,
     *                  IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'OPEN OUT', TYPE, CNO
                        GO TO 990
                        END IF
C                                       HIstory file
                     IF (TYPE.EQ.'HI') THEN
                        DO 30 IREC = 1,SIZEI
                           CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF,
     *                        IRET)
                           IF (IRET.NE.0) THEN
                              WRITE (MSGTXT,1010) IRET, 'READ IN', TYPE,
     *                           CNO, IREC
                              GO TO 990
                              END IF
                           CALL ZBFLI2 (4, 4, 3, BUFF, BUFF)
                           CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF,
     *                        IRET)
                           IF (IRET.NE.0) THEN
                              WRITE (MSGTXT,1010) IRET, 'WRITE OUT',
     *                           TYPE, CNO, IREC
                              GO TO 990
                              END IF
 30                        CONTINUE
C                                       PLot files
                     ELSE IF (TYPE.EQ.'PL') THEN
                        CALL FLIPPL (VER, INDI, INDO, SIZEI, IRET)
                        IF (IRET.GT.0) GO TO 999
C                                       SLice files
                     ELSE IF (TYPE.EQ.'SL') THEN
                        CALL FLIPSL (VER, INDI, INDO, SIZEI, IRET)
                        IF (IRET.GT.0) GO TO 999
C                                       tables
                     ELSE
                        CALL FLPTAB (TYPE, VER, INDI, INDO, SIZEI, IRET)
                        IF (IRET.GT.0) GO TO 999
                        END IF
                     CALL ZCLOSE (LUNI, INDI, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'CLOSE IN', TYPE, CNO
                        GO TO 990
                        END IF
                     CALL ZCLOSE (LUNO, INDO, IRET)
                     IF (IRET.NE.0) THEN
                        WRITE (MSGTXT,1000) IRET, 'CLOSE OUT', TYPE, CNO
                        GO TO 990
                        END IF
                     END IF
 40               CONTINUE
 50            CONTINUE
            END IF
 100     CONTINUE
      IRET = 0
C
 990  IF (IRET.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UDATA: ERROR',I3,' DOING ',A,' ON TYPE ',A,' CNO',I4)
 1010 FORMAT ('UDATA: ERROR',I3,' DOING ',A,' ON TYPE ',A,' CNO',I4,
     *   ' REC',I6)
 2000 FORMAT ('Start copying ',A,' cno',I4,' for user',I5)
 2010 FORMAT ('Start copying ',A,' cno',I4,' ver',I4,' for user',I5)
      END
      SUBROUTINE CMPFLP (SEQ, VER, SIZEI, IRET)
C-----------------------------------------------------------------------
C   Copies a compressed uv data set containing binary data of float and
C   16-bit integer forms.
C   Inputs
C      SEQ     I     Seq (part of file name)
C      VER     I     Ver (part of file name)
C      SIZEI   I     Size of input file in 256-word records
C   Outputs
C      IRET    I     Error code
C-----------------------------------------------------------------------
      INTEGER   SEQ, VER, SIZEI, IRET
C
      INTEGER   SIZEO, INDI, INDO, IREC, NP, NV, NC, IP, I, J, LP, LV
      CHARACTER PNAMEI*48, PNAMEO*48, TYPE*2
      LOGICAL   RANDUM
      INCLUDE 'REBYTE.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       parameters
      NP = CATBLK(KIPCN)
      NV = 1
      J = CATBLK(KIDIM)
      DO 10 I = 1,J
         NV = NV * CATBLK(KINAX+I-1)
 10      CONTINUE
C                                       open files
      TYPE = 'UV'
      CALL PHILEN (TYPE, VOLI, SEQ, VER, PNAMEI, IRET)
      CALL PHILEN (TYPE, VOLO, SEQ, VER, PNAMEO, IRET)
      CALL ZCREAT (VOLO, PNAMEO, SIZEI, T, SIZEO, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CREATE', TYPE, VER
         GO TO 990
         END IF
      CALL ZOPEN (LUNI, INDI, VOLI, PNAMEI, F, F, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN IN', TYPE, VER
         GO TO 990
         END IF
      CALL ZOPEN (LUNO, INDO, VOLO, PNAMEO, F, T, T, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'OPEN OUT', TYPE, VER
         GO TO 990
         END IF
      IP = 1
      RANDUM = .TRUE.
      LP = NP
      LV = NV
      DO 30 IREC = 1,SIZEI
         CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'READ IN', TYPE, VER, IREC
            GO TO 990
            END IF
         IP = 1
 20      IF (IP.LT.257) THEN
            IF (RANDUM) THEN
               NC = MIN (257-IP, LP)
               CALL ZBFLI2 (4, NC, 3, BUFF(IP), BUFF(IP))
               LP = LP - NC
               IP = IP + NC
               IF (LP.LE.0) THEN
                  LV = NV
                  RANDUM = .FALSE.
                  END IF
            ELSE
               NC = MIN (257-IP, LV)
               J = 2 * NC
               CALL ZBFLI2 (2, J, 3, BUFF(IP), BUFF(IP))
               LV = LV - NC
               IP = IP + NC
               IF (LV.LE.0) THEN
                  LP = NP
                  RANDUM = .TRUE.
                  END IF
               END IF
            GO TO 20
            END IF
         CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'WRITE OUT', TYPE, VER, IREC
            GO TO 990
            END IF
 30      CONTINUE
      CALL ZCLOSE (LUNI, INDI, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSE IN', TYPE, VER
         GO TO 990
         END IF
      CALL ZCLOSE (LUNO, INDO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'CLOSE OUT', TYPE, VER
         GO TO 990
         END IF
C
 990  IF (IRET.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FULFLP: ERROR',I3,' DOING ',A,' ON TYPE ',A,' VER',I4)
 1010 FORMAT ('FULFLP: ERROR',I3,' DOING ',A,' ON TYPE ',A,' VER',I4,
     *   ' REC',I6)
      END
      SUBROUTINE FLPTAB (TYPE, VER, INDI, INDO, SIZEI, IRET)
C-----------------------------------------------------------------------
C   Copies a table extension file doing all needed byte flips
C   Inputs
C      TYPE    C*2   File type
C      VER     I     Ver (part of file name)
C      INDI    I     input FTAB pointer
C      INDO    I     output FTAB pointer
C      SIZEI   I     Size of input file in 256-word records
C   Outputs
C      IRET    I     Error code
C-----------------------------------------------------------------------
      CHARACTER TYPE*2
      INTEGER   VER, INDI, INDO, SIZEI, IRET
C
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   IREC, HEAD(256), DATP(128,2), NROW, MREC, FREC, NWORD,
     *   NDWORD, NFWORD, NCWORD, NSWORD, IROW, I, IPOS, BBUF(UVBFSS), J,
     *   L
      INCLUDE 'REBYTE.INC'
C-----------------------------------------------------------------------
C                                       header
      IREC = 1
      CALL ZFIO ('READ', LUNI, INDI, IREC, HEAD, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, 'READ IN', TYPE, VER, IREC
         GO TO 990
         END IF
C                                       flip non-character portions
      CALL ZBFLI2 (4, 16, 3, HEAD(1), HEAD(1))
      CALL ZBFLI2 (4, 8, 3, HEAD(31), HEAD(31))
      CALL ZBFLI2 (4, 13, 3, HEAD(41), HEAD(41))
      CALL ZBFLI2 (4, 44, 3, HEAD(57), HEAD(57))
      CALL ZBFLI2 (4, 128, 3, HEAD(129), HEAD(129))
      CALL ZFIO ('WRIT', LUNO, INDO, IREC, HEAD, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, 'WRITE OUT', TYPE, VER, IREC
         GO TO 990
         END IF
      NROW = HEAD(5)
C                                       pointers
      IREC = 2
      CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, 'READ IN', TYPE, VER, IREC
         GO TO 990
         END IF
      CALL ZBFLI2 (4, 256, 3, BUFF, DATP)
      CALL ZFIO ('WRIT', LUNO, INDO, IREC, DATP, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, 'WRITE OUT', TYPE, VER, IREC
         GO TO 990
         END IF
      MREC = HEAD(49) - 1
C                                       copy selection, titles, units
      DO 10 IREC = 3,MREC
         CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'READ IN', TYPE, VER, IREC
            GO TO 990
            END IF
         CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'WRITE OUT', TYPE, VER, IREC
            GO TO 990
            END IF
 10      CONTINUE
C                                       keywords
      FREC = HEAD(49)
      MREC = HEAD(50) - 1
      DO 30 IREC = FREC,MREC
         CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'READ IN', TYPE, VER, IREC
            GO TO 990
            END IF
         IPOS = 3
         DO 20 I = 1,51
            CALL ZBFLI2 (4, 1, 3, BUFF(IPOS+2), BUFF(IPOS+2))
            IF (BUFF(IPOS+2).EQ.1) THEN
               CALL ZBFLI2 (8, 1, 3, BUFF(IPOS), BUFF(IPOS))
            ELSE IF (BUFF(IPOS+2).NE.3) THEN
               CALL ZBFLI2 (4, 2, 3, BUFF(IPOS), BUFF(IPOS))
               END IF
            IPOS = IPOS + 5
 20         CONTINUE
         CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'WRITE OUT', TYPE, VER, IREC
            GO TO 990
            END IF
 30      CONTINUE
C                                       how many doubles
      NWORD = HEAD(8)
      NDWORD = 0
      NFWORD = 0
      NCWORD = 0
      DO 40 I = 1,HEAD(10)
         J = MOD (DATP(I,2), 10)
         L = (DATP(I,2) - J) / 10
         IF (J.EQ.1) THEN
            NDWORD = NDWORD + L
         ELSE IF (J.EQ.2) THEN
            NFWORD = NFWORD + L
         ELSE IF (J.EQ.3) THEN
            NCWORD = NCWORD + (L-1) / 4 + 1
            END IF
 40      CONTINUE
      NSWORD = NWORD - 2 * NDWORD - NFWORD - NCWORD
      FREC = HEAD(50)
C                                       1+ records / buffer
      IF (HEAD(9).GT.0) THEN
         DO 70 IREC = FREC,SIZEI
            CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'READ IN', TYPE, VER, IREC
               GO TO 990
               END IF
            IPOS = 1
            DO 60 I = 1,HEAD(9)
               IF (NDWORD.GT.0) CALL ZBFLI2 (8, NDWORD, 3, BUFF(IPOS),
     *            BUFF(IPOS))
               IPOS = IPOS + 2 * NDWORD
               IF (NFWORD.GT.0) CALL ZBFLI2 (4, NFWORD, 3, BUFF(IPOS),
     *            BUFF(IPOS))
               IPOS = IPOS + NFWORD + NCWORD
               IF (NSWORD.GT.0) CALL ZBFLI2 (4, NSWORD, 3, BUFF(IPOS),
     *            BUFF(IPOS))
               IPOS = IPOS + NSWORD
 60            CONTINUE
            CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'WRITE OUT', TYPE, VER, IREC
               GO TO 990
               END IF
 70         CONTINUE
C                                       > 1 buffer / record
      ELSE
         IREC = FREC - 1
         DO 80 IROW = 1,NROW
            IPOS = 1
            DO 75 I = 1,-HEAD(9)
               CALL ZFIO ('READ', LUNI, INDI, IREC+I, BBUF(IPOS), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1010) IRET, 'READ IN', TYPE, VER, IREC
                  GO TO 990
                  END IF
               IPOS = IPOS + 256
 75            CONTINUE
            IPOS = 1
            IF (NDWORD.GT.0) CALL ZBFLI2 (8, NDWORD, 3, BBUF(IPOS),
     *         BBUF(IPOS))
            IPOS = IPOS + 2 * NDWORD
            IF (NFWORD.GT.0) CALL ZBFLI2 (4, NFWORD, 3, BBUF(IPOS),
     *         BBUF(IPOS))
            IPOS = IPOS + NFWORD + NCWORD
            IF (NSWORD.GT.0) CALL ZBFLI2 (4, NSWORD, 3, BBUF(IPOS),
     *         BBUF(IPOS))
            IPOS = 1
            DO 76 I = 1,-HEAD(9)
               CALL ZFIO ('WRIT', LUNO, INDO, IREC+I, BBUF(IPOS), IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1010) IRET, 'WROTE OUT', TYPE, VER, IREC
                  GO TO 990
                  END IF
               IPOS = IPOS + 256
 76            CONTINUE
 80         CONTINUE
         IREC = IREC - HEAD(9)
         END IF
C
 990  IF (IRET.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('FLPTAB: ERROR',I3,' DOING ',A,' ON TYPE ',A,' VER',I4,
     *   ' REC',I6)
      END
      SUBROUTINE PHILEN (TYPE, IVOL, NSEQ, IVER, PNAM, IERR)
C-----------------------------------------------------------------------
C   Construct a physical file name in PNAM from TYPE, IVOL, NSEQ, and
C   IVER - either for public data files or user-specific files.
C   REBYTE version: uses USER not NLUSER
C   Inputs:
C      TYPE    C*2   Type of file: e.g. 'MA' for map file
C      IVOL    I     Number of the disk volume to be used (1-15)
C      NSEQ    I     Sequence number (000-4095)
C      IVER    I     Version number (00-255)
C   Outputs:
C      PNAM    C*48  physical file name, left justified
C      IERR    I     Error return code: 0 = good return.   1 = error.
C
C   Example: If TYPE='MA', IVOL=7, AIPSVER=C, NSEQ=321, IVER=12799,
C            NLUSER=762 then
C               PNAME='DA06:MAD08X9VJ;'      for public data or
C               PNAME='DA06:MAD08X9VJ.0L6;'  for private data
C           use base 36 now: 321 => 08X, 12799 => 9VJ, 762 => 0L6
C           disks are base 36 but 0 relative
C   TYPE = 'MT' leads to special name for tapes
C   TYPE = 'TK' leads to special name for TEK4012 plotter CRT
C   TYPE = 'TV' leads to special name for TV device
C   TYPE = 'ME' leads to special logical for POPS memory files
C
C   Generic version - the ZOPEN, ZTRLOG, etc. routines interpret the
C   resulting VMS-like names.
C-----------------------------------------------------------------------
      CHARACTER TYPE*2, PNAM*48
      INTEGER   IVOL, NSEQ, IVER, IERR
C
      INTEGER   IVOL2, NUNAME, UNAME, VERLIM, VOLLIM, CATLIM
      CHARACTER JUNK*4, UNAMES(15)*2, VERDAT*1, VERSYS*1
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'REBYTE.INC'
      DATA NUNAME, UNAMES /15, 'AC','BA','BQ','HE','IC','ID','IN','ME',
     *   'SP','TP','TD','GR','PW','MT','TC'/
C                                       Current AIPS data version level
      DATA VERDAT, VERSYS /'D','D'/
C-----------------------------------------------------------------------
      IERR = 1
      PNAM = 'DA00:MADFFFFFF; '
      PNAM(8:8) = VERDAT
      IF (TYPE.EQ.'MT') PNAM(1:2) = 'MT'
C                                       Special code for TEK 4012
      IF (TYPE.EQ.'TK') THEN
         IF (NTKDEV.LE.0) GO TO 999
         PNAM = 'TKDEV  :'
         CALL ZEHEX (NTKDEV, 2, PNAM(6:7))
C                                       TV device
      ELSE IF (TYPE.EQ.'TV') THEN
         IF (NTVDEV.LE.0) GO TO 999
         PNAM = 'TVDEV  :'
         CALL ZEHEX (NTVDEV, 2, PNAM(6:7))
C                                       Special POPS memory files
      ELSE IF ((TYPE.EQ.'ME') .AND. (IVER.EQ.0)) THEN
         PNAM = VERNAM(1:3) // 'MEM:ME1000000;'
         PNAM(10:10) = VERSYS
C                                       other devices (disk files)
      ELSE
C                                       Check input parameters.
         VERLIM = 36 * 36 * 36 - 1
         CATLIM = VERLIM
         VOLLIM = 35
         IF ((IVOL.LT.1) .OR. (IVOL.GT.VOLLIM)) GO TO 999
         IF ((NSEQ.LT.0) .OR. (NSEQ.GT.CATLIM)) GO TO 999
         IF ((IVER.LT.0) .OR. (IVER.GT.VERLIM)) GO TO 999
C                                       User private?
            UNAME = 0
            IF (NUNAME.LE.0) GO TO 45
               DO 40 UNAME = 1,NUNAME
                  IF (TYPE.EQ.UNAMES(UNAME)) GO TO 45
 40               CONTINUE
               UNAME = 0
C                                       Adjust for 1 relative input
 45         IVOL2 = IVOL - 1
            IF (UNAME.LE.0) IVOL2 = IVOL
            CALL ZEHEX (IVOL2, 4, JUNK)
            PNAM(3:4) = JUNK(3:4)
            PNAM(6:7) = TYPE
            IF (UNAME.LE.0) THEN
               PNAM(8:8) = VERDAT
            ELSE
               PNAM(8:8) = VERSYS
               END IF
            CALL ZEHEX (NSEQ, 4, JUNK)
            PNAM(9:11) = JUNK(2:4)
            CALL ZEHEX (IVER, 4, JUNK)
            PNAM(12:14) = JUNK(2:4)
C                                       User private additions
            IF ((UNAME.LE.0) .AND. (UCTSIZ.GT.0)) THEN
               CALL ZEHEX (USER, 4, JUNK)
               PNAM(15:) = '.' // JUNK(2:4) // ';'
               END IF
         END IF
C                                       No error
      IERR = 0
C
 999  RETURN
      END
      SUBROUTINE CATBYT (INB, OUT)
C-----------------------------------------------------------------------
C   Coverts a regular header by byte/word/double swap only
C   Inputs:
C      INB     I(256)   in buffer
C   Outputs:
C      OUT    I(256)   out buffer
C   If header format changes this may have to change
C-----------------------------------------------------------------------
      INTEGER   INB(256), OUT(256)
C
      INTEGER   I, IP
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PHDR.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
      CALL COPY (256, INB, OUT)
C                                       CRV
      I = 2 * KDCRV - 1
      CALL ZBFLI2 (8, KICTPN, 3, OUT(I), OUT(I))
C                                       CRP, CRT, EPO, DMX, DMN
      IP = 3 * KICTPN + 3
      CALL ZBFLI2 (4, IP, 3, OUT(KRCIC), OUT(KRCIC))
C                                       BLK
      CALL ZBFLM2 (4, 1, 3, OUT(KRBLK), OUT(KRBLK))
C                                       GCN, PCN, DIM, NAX, IMS
      IP = 3 + KICTPN + 1
      CALL ZBFLI2 (4, IP, 3, OUT(KIGCN), OUT(KIGCN))
C                                       IMU, ALT, BMJ, BMN, BPA, NIT
      IP = 6
      CALL ZBFLI2 (4, IP, 3, OUT(KIIMU), OUT(KIIMU))
C                                       ORA, ODE, RST, ARV
      I = 2 * KDORA - 1
      CALL ZBFLI2 (8, 4, 3, OUT(I), OUT(I))
C                                       ARP, XSH, YSH
      IP = 3
      CALL ZBFLI2 (4, IP, 3, OUT(KRARP), OUT(KRARP))
C                                       VER
      CALL ZBFLI2 (4, KIEXTN, 3, OUT(KIVER), OUT(KIVER))
C
 999  RETURN
      END
      SUBROUTINE FLIPSL (VER, INDI, INDO, SIZEI, IRET)
C-----------------------------------------------------------------------
C   Copies a SLice file containing character and binary data but no
C   double precision data forcing byte and word flip, skipping
C   holleriths
C   Inputs
C      VER     I     Ver (part of file name)
C      INDI    I     input FTAB pointer
C      INDO    I     output FTAB pointer
C      SIZEI   I     Size of input file in 256-word records
C   Outputs
C      IRET    I     Error code
C-----------------------------------------------------------------------
      INTEGER   VER, INDI, INDO, SIZEI, IRET
C
      INTEGER   IREC
      INCLUDE 'REBYTE.INC'
C-----------------------------------------------------------------------
C                                       do copy
      DO 20 IREC = 1,SIZEI
         CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'READ IN', 'SL', VER, IREC
            GO TO 990
            END IF
         IF (IREC.EQ.1) THEN
            CALL ZBFLI2 (4, 7, 3, BUFF(1), BUFF(1))
            CALL ZBFLI2 (4, 6, 3, BUFF(11), BUFF(11))
            CALL ZBFLI2 (4, 1, 3, BUFF(29), BUFF(29))
            CALL ZBFLI2 (4, 224, 3, BUFF(33), BUFF(33))
         ELSE IF (IREC.EQ.2) THEN
            CALL ZBFLI2 (4, 8, 3, BUFF(4), BUFF(4))
            CALL ZBFLI2 (4, 240, 3, BUFF(17), BUFF(17))
         ELSE
            CALL ZBFLI2 (4, 256, 3, BUFF, BUFF)
            END IF
         CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'WRITE OUT', 'SL', VER, IREC
            GO TO 990
            END IF
 20      CONTINUE
C
 990  IF (IRET.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('FLIPSL: ERROR',I3,' DOING ',A,' ON TYPE ',A,' VER',I4,
     *   ' REC',I6)
      END
      SUBROUTINE FLIPPL (VER, INDI, INDO, SIZEI, IRET)
C-----------------------------------------------------------------------
C   Copies a PLot file containing character and binary data but no
C   double precision data forcing byte and word flip, skipping
C   holleriths
C   Inputs
C      VER     I     Ver (part of file name)
C      INDI    I     input FTAB pointer
C      INDO    I     output FTAB pointer
C      SIZEI   I     Size of input file in 256-word records
C   Outputs
C      IRET    I     Error code
C-----------------------------------------------------------------------
      INTEGER   VER, INDI, INDO, SIZEI, IRET
C
      INTEGER   IREC, NREC, IOPOS, I, OP(2), NWD(18), IWD, NERR
      INCLUDE 'REBYTE.INC'
      DATA NWD /6, 20, 5, 3, 3, 5, 3, 2, 2, 3, 3, 12, 8, 5, 5, 4, 3, 2/
C-----------------------------------------------------------------------
      NERR = 0
C                                       header section
      IREC = 1
      CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET, 'READ IN', 'PL', VER, IREC
         GO TO 990
         END IF
      CALL ZBFLI2 (4, 1, 3, BUFF(10), I)
      NREC = (I + 9) / 256 + 1
      DO 10 IREC = 1,NREC
         CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'READ IN', 'PL', VER, IREC
            GO TO 990
            END IF
         CALL ZBFLC2 (4, 256, 3, BUFF, BUFF)
         CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'WRITE OUT', 'PL', VER, IREC
            GO TO 990
            END IF
 10      CONTINUE
      IOPOS = 9999
      IREC = NREC
C                                       loop through plot commands
 50   OP(1) = 0
      IF (IOPOS.LE.255) CALL ZBFLI2 (4, 2, 3, BUFF(IOPOS), OP)
C                                       write last record
      IF (OP(1).EQ.0) THEN
         CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'WRITE OUT', 'PL', VER, IREC
            GO TO 990
            END IF
         IF (IREC.GE.SIZEI) GO TO 999
C                                       new record
         IREC = IREC + 1
         CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'READ IN', 'PL', VER, IREC
            GO TO 990
            END IF
         IOPOS = 1
         CALL ZBFLI2 (4, 2, 3, BUFF(IOPOS), OP)
         END IF
C                                       deal with different rec types
C                                       grey-scale or color pixels
      IF ((OP(1).EQ.7) .OR. (OP(1).EQ.11)) THEN
         IWD = NWD(OP(1))
         CALL ZBFLI2 (4, IWD, 3, BUFF(IOPOS), BUFF(IOPOS))
         IOPOS = IOPOS + IWD
         IF (OP(1).EQ.11) OP(2) = 3 * OP(2)
 60      IWD = OP(2)
C                                       convert & write buffer
         IF (IWD+IOPOS.GT.257) THEN
            IWD = 257 - IOPOS
            CALL ZBFLI2 (4, IWD, 3, BUFF(IOPOS), BUFF(IOPOS))
            CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'WRITE OUT', 'PL', VER, IREC
               GO TO 990
               END IF
            IREC= IREC + 1
            CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'READ IN', 'PL', VER, IREC
               GO TO 990
               END IF
            OP(2) = OP(2) - IWD
            IOPOS = 1
            GO TO 60
            END IF
         CALL ZBFLI2 (4, IWD, 3, BUFF(IOPOS), BUFF(IOPOS))
C                                       character data
      ELSE IF ((OP(1).EQ.6) .OR. (OP(1).EQ.14) .OR. (OP(1).EQ.15)
     *   .OR. (OP(1).EQ.18)) THEN
         IWD = NWD(OP(1))
         CALL ZBFLI2 (4, IWD, 3, BUFF(IOPOS), BUFF(IOPOS))
         IWD = IWD + (OP(2) - 1) / 4 + 1
C                                       misc words
      ELSE IF (OP(1).EQ.8) THEN
         IWD = NWD(OP(1)) + OP(2)
         CALL ZBFLI2 (4, IWD, 3, BUFF(IOPOS), BUFF(IOPOS))
C                                       rest legal ops
      ELSE IF ((OP(1).GE.1) .AND. (OP(1).LE.18)) THEN
         IWD = NWD(OP(1))
         CALL ZBFLI2 (4, IWD, 3, BUFF(IOPOS), BUFF(IOPOS))
C                                       file end op
      ELSE IF (OP(1).EQ.32767) THEN
         IWD = 257 - IOPOS
         CALL ZBFLI2 (4, IWD, 3, BUFF(IOPOS), BUFF(IOPOS))
         CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1010) IRET, 'WRITE OUT', 'PL', VER, IREC
            GO TO 990
            END IF
C                                       any other records?
         NREC = IREC + 1
         DO 70 IREC = NREC,SIZEI
            CALL ZFIO ('READ', LUNI, INDI, IREC, BUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'READ IN', 'PL', VER, IREC
               GO TO 990
               END IF
            CALL ZBFLC2 (4, 256, 3, BUFF, BUFF)
            CALL ZFIO ('WRIT', LUNO, INDO, IREC, BUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) IRET, 'WRITE OUT', 'PL', VER, IREC
               GO TO 990
               END IF
 70         CONTINUE
         GO TO 999
C                                       oh no!
      ELSE
         WRITE (MSGTXT,1070) OP, IREC, IOPOS
         CALL MSGWRT (7)
         NERR = NERR + 1
         IWD = 2
         CALL ZBFLI2 (4, IWD, 3, BUFF(IOPOS), BUFF(IOPOS))
         IF (NERR.GT.10) THEN
            IRET = 100
            GO TO 999
            END IF
         END IF
      IOPOS = IOPOS + IWD
      GO TO 50
C
 990  IF (IRET.NE.0) CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('FLIPPL: ERROR',I3,' DOING ',A,' ON TYPE ',A,' VER',I4,
     *   ' REC',I6)
 1070 FORMAT ('FLIPPL: BAD OP',2I10,' AT REC, WD',I8,I4)
      END

      SUBROUTINE AXEFND (NCHC, TYPE, NAXIS, AXES, IOFF, IERR)
C-----------------------------------------------------------------------
C! finds axis number for specified axis type
C# header
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AXEFND determines the order number of an axis whose name is in the
C   character string TYPE.  It will work for either regular or random
C   axes.
C   Inputs:
C      NCHC       I       Compare only first NCHC characters of type
C      TYPE       C*(*)   Unpacked char. axis type.
C      NAXIS      I       the number of axes to search,
C                          for uniform axes use: CATBLK(KIDIM) or KICTPN
C                          for random axes use:  CATBLK(KIPCN) OR KIPTPN
C      AXES       H(*)    Catalog axis name list,
C                          for uniform axes use: CATH(KHCTP)
C                          for random axes use : CATH(KHPTP)
C   Output:
C      IOFF       I       Axis offset ( zero relative axis number)
C      IERR       I       Return error code, 0=>OK, 1=>could not find.
C-----------------------------------------------------------------------
      CHARACTER TYPE*(*)
      HOLLERITH AXES(*)
      INTEGER   NCHC, NAXIS, IOFF, IERR
C
      INTEGER   I, INC, INDEX
      CHARACTER CHTH*8
C-----------------------------------------------------------------------
C                                       Initialize IERR
      IERR = 1
      IF ((NCHC.LT.1) .OR. (NCHC.GT.8)) GO TO 999
C                                       Initialize IOFF
      IOFF = 0
C                                       Search
      INC = 2
      DO 10 I = 1,NAXIS
         INDEX = 1 + (I-1) * INC
         CALL H2CHR (NCHC, 1, AXES(INDEX), CHTH)
C                                       Found match
         IF (TYPE(1:NCHC).EQ.CHTH(1:NCHC)) THEN
            IOFF = I - 1
            IERR = 0
            GO TO 999
            END IF
 10      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE ZWINC (WCOLS)
C-----------------------------------------------------------------------
C! handles detection of window-size changes
C# IO-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1998-1999
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Finds the width and height of the current xterm (or other terminal)
C   window and sets the height into gloabl common if requested.
C   Output:
C      WCOLS   I   Width of window in characters,
C                  returns values from 72 through 132 only
C   Programmer = Jeff Uphoff, April-July 1998.  Eric Greisen 7/99.
C-----------------------------------------------------------------------
      INTEGER   WCOLS
C
      INTEGER   WLINES
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
      CALL ZWINC2 (WCOLS, WLINES)
C                                        if <=0 save in common
      IF (CRTMAX.LT.1) THEN
         IF (WLINES.GT.0) THEN
            CRTMAX = -WLINES
         ELSE
            IF (CRTMAX.GT.-10) CRTMAX = -24
            END IF
         END IF
      WCOLS = MIN (132, MAX (WCOLS, 72))
C
 999  RETURN
      END

LOCAL INCLUDE 'UVMAP.INC'
C                                       Local include for UVMAP
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INTEGER   ITV, NOGCOR, DISIN, DISOUT, MODE, NATWT, SEQIN, UNFBOX,
     *   NX, NY, CTYPX, CTYPY, ITAP, IZSP, ICNTRX, ICNTRY, INCNO,
     *   INDS(10), OUTSEQ, NCH, LRECIN, BUFSZ,
     *   NUMCH, CATOLD(256), ISCR(3), UVSCR, NUMMAP, SCRTCH(256)
      HOLLERITH XNAMEI(3), XCLASI(2), XNAMOU(3), XSTOK, XWTFN
      CHARACTER NAMEIN*12, CLASIN*6, NAMOUT*12, STOKES*4, WTFN*4
      REAL      XSEQIN, XDISO, XDISIN, USETV, XUNFBX, XNX, XNY, XFLD,
     *   YFLD, XSHIFT, YSHIFT, TAPERU, TAPERV, BLMIN, BLMAX, ZSP(4),
     *   WTZSP, XGCOR, CTYPEX, CTYPEY, CPARMX(10), CPARMY(10),
     *   XGUARD(2), BADD(10), WROW(UVBFSS), XSEQ,  APSIZ, BANWID, XNCH,
     *   XNOCH, XSH, YSH, DXCOR, DYCOR, DXC, DYC, DZC, SCLU, SCLV, SCLW,
     *   MAPROT, RCBUF(2*UVBFSS), RCBUF2(2*UVBFSS)
      LOGICAL   NOSHFT
      COMPLEX   CBUF(UVBFSS), CBUF2(UVBFSS)
      EQUIVALENCE (CBUF, RCBUF),   (CBUF2, RCBUF2)
      COMMON /MAPCHR/ NAMEIN, CLASIN, NAMOUT, STOKES, WTFN
      COMMON /MAPPRM/ CATOLD, APSIZ, BANWID, XSH, YSH, DXCOR, DYCOR,
     *   DXC, DYC, DZC, SCLU, SCLV, SCLW, NOSHFT,
     *   ITV, NOGCOR, DISIN, DISOUT, OUTSEQ, NATWT, SEQIN, UNFBOX,
     *   NX, NY, CTYPX, CTYPY, ITAP, IZSP, ICNTRX, ICNTRY,
     *   INCNO, INDS, NCH, NUMCH, MODE, LRECIN,
     *   ISCR, UVSCR, NUMMAP, MAPROT
      COMMON /XPARM/ XNAMEI, XCLASI, XSEQIN, XDISIN, XNCH, XNOCH,
     *   XNAMOU, XDISO, XSEQ, XSTOK, XNX, XNY, XFLD, YFLD, XSHIFT,
     *   YSHIFT, TAPERU, TAPERV, BLMIN, BLMAX, XWTFN, XUNFBX, XGCOR,
     *   USETV, ZSP, WTZSP, CTYPEX, CTYPEY,  CPARMX, CPARMY, XGUARD,
     *   BADD
      COMMON /BUFRS/ CBUF, CBUF2, WROW, SCRTCH, BUFSZ
C                                                          End UVMAP
LOCAL END
      PROGRAM UVMAP
C-----------------------------------------------------------------------
C! Image a UV data set
C# UV Map AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1997-2000, 2005-2006, 2008, 2015, 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVMAP computes a map or set of maps from a presorted visibility
C   data base.
C   Adverbs:
C      Adverb name      size    Prgm. name       Default
C      INNAME         R(2)      NAMEIN
C      INCLASS        R(2)      CLASIN
C      INSEQ          R         SEQIN
C      INDISK         R         DISIN
C      CHANNEL        R         NCH              0
C      NUMCHAN        R         NUMCH            1
C      OUTNAME        R(3)      NAMOUT           NAMEIN
C      OUTDISK        R         DISOUT
C      OUTSEQ         R         OUTSEQ           next highest.
C      STOKES         C*4       ISTOK           'I'
C      IMSIZE         R(2)      NX,NY
C      CELLSIZE       R(2)      XFLD,YFLD
C      SHIFT          R(2)      XSHIFT,YSHIFT
C      UVTAPER        R(2)      TAPERU,TAPERV,ITAP
C      UVRANGE        R(2)      BLMIN,BLMAX
C      UVWTFN         R         NATWT            'UN'
C      UVBOX          R         UNFBOX
C      DOGRIDCR       R         NOGCOR
C      DOTV           R         ITV
C      ZEROSP         R(5)      ZSP,WTZSP,IZSP
C      XTYPE          R         CTYPX            5=Spheriodal
C      YTYPE          R         CTYPY            XTYPE
C      XPARM          R(10)     CPARMX           set in GRDFLT
C      YPARM          R(10)     CPARMY           set in GRDFLT
C      GUARD          R(2)      XGUARD           guard band in uv plane
C      BADDISK        R(10)     IBAD
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(2)
      INTEGER   IRET, ITIME(3), IOCNT(2), NPASS, MTYPE(10), MLOC(10),
     *   MAPNT, I, JBUFSZ, KAP, NEED
      LOGICAL   HERM
      REAL      FFRAC(10), TIME, BMAX, DUM1, DUM2
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'UVMAP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DAPM.INC'
      DATA HERM /.FALSE./
C-----------------------------------------------------------------------
C                                       Init program, interpret parms
      CALL MAPINI (APCORE, NPASS, MTYPE, MLOC, FFRAC, IRET)
      IF (IRET.NE.0) GO TO 900
C                                       Read visibilities to internal
      CALL VISRD (IRET)
      IF (IRET.NE.0) GO TO 900
      CALL ZTIME (ITIME)
      CALL ZCPU (TIME, IOCNT)
      WRITE (MSGTXT,1000) ITIME, TIME
      CALL MSGWRT (1)
C                                       Uniform weight.
      IF (NATWT.NE.1) CALL UNIF (APCORE, FFRAC(1), IRET)
      IF (IRET.NE.0) GO TO 900
      NEED = NY * (NX/2 + 1)
      NEED = (4 * NEED) / 1024
      DO 50 I = 1,NPASS
C                                       Grid data
         CALL CONGRD (APCORE, MTYPE(I), MLOC(I), FFRAC(I), IRET)
         IF (IRET.NE.0) GO TO 900
         CALL ZTIME (ITIME)
         CALL ZCPU (TIME, IOCNT)
         WRITE (MSGTXT,1020) ITIME, TIME
         CALL MSGWRT (1)
C                                       Display sampling on TV
         IF ((I.EQ.1) .AND. (ITV.EQ.1)) CALL UVDISP
C                                       Do Fourier transform
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
            MSGTXT = 'UNABLE TO GET AP MEMORY IN MAIN LOOP'
            CALL MSGWRT (8)
            IRET = 10
            GO TO 900
            END IF
         JBUFSZ = 4  * UVBFSS
         CALL DSKFFT (APCORE, NX, NY, -1, HERM, ISCR(2), ISCR(2),
     *      ISCR(1), JBUFSZ, CBUF, CBUF2, DUM1, DUM2, IRET)
         IF (IRET.NE.0) GO TO 900
         CALL QRLSE
         CALL ZTIME (ITIME)
         CALL ZCPU (TIME, IOCNT)
         WRITE (MSGTXT,1021) ITIME, TIME
         CALL MSGWRT (1)
C                                       Scale & write output maps
         MAPNT = I * 2
         CALL MAPOUT (APCORE, MAPNT, FFRAC(I), BMAX, IRET)
         IF (IRET.NE.0) GO TO 900
         CALL ZTIME (ITIME)
         CALL ZCPU (TIME, IOCNT)
         WRITE (MSGTXT,1022) ITIME, TIME
         CALL MSGWRT (1)
 50   CONTINUE
C                                       If finished OK then only UV file
C                                       is left marked.
      NCFILE = 1
C                                       Close down
 900  CALL DIE (IRET, SCRTCH)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('Got vis data   at',I3,2(':',I2),' CPU time',F10.2)
 1020 FORMAT ('Finished gridding',I3,2(':',I2),' CPU time',F10.2)
 1021 FORMAT ('Finished fft   at',I3,2(':',I2),' CPU time',F10.2)
 1022 FORMAT ('Maps stored    at',I3,2(':',I2),' CPU time',F10.2)
      END
      SUBROUTINE MAPINI (APCORE, NPASS, MTYPE, MLOC, FFRAC, IRET)
C-----------------------------------------------------------------------
C   MAPINI performs initialization functions for UVMAP
C   Output
C     NPASS      I     Number of FFT passes.
C     MTYPE(*)   I     Map type for each pass, (see CONGRD for details)
C     MLOC(*)    I     Offset in visibility record for first vis in
C                      each FFT pass. (used by CONGRD)
C     FFRAC(*)   R     Frequency correction factor(-1) for each FFT pass
C     IRET       I      = 0  = > ok,  = 1  = > fatal error
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      CHARACTER PRGNAM*6, LL*8, MM*8, CFREQ*8, CSTOK*8, JYBM*8,
     *   CCLASS(9)*8, PROJ*4, UTYPE*2
      HOLLERITH OLDH(256)
      INTEGER   IERR, NPARM, IRET, IER, IMODE, IV, NPASS, MTYPE(10),
     *   MLOC(10), ICNO, ISIZE, ICLTYP(9,40), IMTYPE(5,20), IMLOC(5,10),
     *   II, I, NP(2), IROUND, INDEX, NEED, KAP
      LOGICAL   DOPROJ
      REAL      FFRAC(10), OLDR(256), OUFREQ
      DOUBLE PRECISION OLDD(128), STOK(9)
C      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'UVMAP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (CATOLD, OLDR, OLDD, OLDH)
      DATA NPARM, PRGNAM /68, 'UVMAP '/
      DATA   LL,          MM,      CFREQ,      CSTOK,       JYBM
     *   /'RA---SIN', 'DEC--SIN', 'FREQ    ', 'STOKES  ', 'JY/BEAM '/
      DATA STOK /1.0D0,0.0D0,2.0D0,3.0D0,4.0D0,1.0D0,0.0D0,1.0D0,0.0D0/
      DATA CCLASS /'IIM001  ','IBM001  ','QIM001  ',
     *   'UIM001  ','VIM001  ','RIM001  ',
     *   'RBM001  ','LIM001  ','LBM001  '/
      DATA ICLTYP /1,2,7*0,  1,2,3,4,5*0,  1,2,3,4,5,4*0, 1,2,5,6*0,
     *   6,7,7*0,  8,9,7*0,  6,7,8,6*0,  6,7,8,9,5*0,  18*0,
     *   1,2,7*1,  1,2,7*1,  1,2,7*1,  1,2,7*1,
     *   1,2,7*1,  1,2,7*1,  1,2,7*1,  1,2,7*1,  18*0,
     *   6,7,7*6,  6,7,7*6,  6,7,7*6,  6,7,7*6,
     *   6,7,7*6,  6,7,7*6,  6,7,7*6,  6,7,7*6,  18*0,
     *   8,9,7*8,  8,9,7*8,  8,9,7*8,  8,9,7*8,
     *   8,9,7*8,  8,9,7*8,  8,9,7*8,  8,9,7*8,  18*0/
      DATA IMLOC /1,0,0,0,0, 1,2,0,0,0, 1,2,4,0,0, 1,2,0,0,0,
     *   1,0,0,0,0, 1,0,0,0,0, 1,2,0,0,0, 1,2,0,0,0, 5*0,
     *   1,2,4,6,8/
       DATA IMTYPE/1,0,0,0,0, 1,2,0,0,0, 1,2,3,0,0, 1,3,0,0,0,
     *   1,0,0,0,0, 1,0,0,0,0, 1,3,0,0,0, 1,1,0,0,0, 10*0,
     *   1,0,0,0,0, 1,3,0,0,0, 1,4,0,0,0, 1,4,3,0,0, 1,4,4,0,0,
     *   1,4,4,3,0, 1,4,4,4,0, 1,4,4,4,3, 10*0/
C-----------------------------------------------------------------------
      IRET = 0
      NCFILE = 0
      NSCR = 0
C                                       file common
      DO 10 I = 1,10
         SCRVOL(I) = 0
         LUNS(I) = 15 + I
 10      CONTINUE
C                                       system commons
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      BUFSZ = UVBFSS  * 4
C                                       get task parms
      CALL GTPARM (PRGNAM, NPARM, RQUICK, XNAMEI, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         CALL MSGWRT (8)
         END IF
      IF (RQUICK) CALL RELPOP (IRET, SCRTCH, IER)
      IF (IRET.NE.0) GO TO 990
C                                       Get catalog block, open file
C                                       Will be used and closed in VISRD
      SEQIN = IROUND (XSEQIN)
      DISIN = IROUND (XDISIN)
C                                       Convert characters
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLASI, CLASIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (4, 1, XSTOK, STOKES)
      CALL H2CHR (4, 1, XWTFN, WTFN)
      UTYPE = 'UV'
      CALL MAPOPN ('READ', DISIN, NAMEIN, CLASIN, SEQIN, UTYPE,
     *   NLUSER, LUNS(2), INDS(2), INCNO, CATOLD, SCRTCH, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
C                                        Update /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISIN
      FCNO(NCFILE) = INCNO
      FRW(NCFILE) = 0
C                                       Get info.
      CALL COPY (256, CATOLD, CATBLK)
C                                       Disallow packed uv data
      IF (CATBLK(KINAX).EQ.1) THEN
         IRET = 9
         MSGTXT = 'ERROR: I cannot process packed UV data, use SPLIT'
         GO TO 990
         END IF
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Check UV data type
      IF (TYPUVD.GT.0) THEN
C                                       Not interferometer data.
         IRET = 5
         WRITE (MSGTXT,1040)
         GO TO 990
         END IF
C                                       interprete input parms
      CALL DPARM (NPASS, OUFREQ, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1041) IRET
         GO TO 990
         END IF
      BANWID = OLDR(KRCIC+JLOCF)
      DO 100 I = 1,NUMMAP
C                                       Construct headers
         CALL COPY (256, CATOLD, CATBLK)
C                                       Check input projection type
         INDEX = ILOCU * 2
         CALL H2CHR (4, 1, CATH(KHPTP+INDEX+1), PROJ)
         DOPROJ = PROJ .NE.'    '
         CALL CHR2H (8, JYBM, 1, CATH(KHBUN))
         CALL CHR2H (8, LL, 1, CATH(KHCTP))
         CALL CHR2H (8, MM, 1, CATH(KHCTP+2))
         CALL CHR2H (8, CFREQ, 1, CATH(KHCTP+4))
         CALL CHR2H (8, CSTOK, 1, CATH(KHCTP+6))
         IF (DOPROJ) CALL CHR2H (4, PROJ, 5, CATH(KHCTP))
         IF (DOPROJ) CALL CHR2H (4, PROJ, 5, CATH(KHCTP+2))
         CATD(KDCRV) = RA
         CATD(KDCRV+1) = DEC
C                                       Frequency
         CATD(KDCRV+2) = FREQ + (NCH - OLDR(KRCRP+JLOCF)) *
     *      OLDR(KRCIC+JLOCF)
C                                       Check for line maps.
         II = I
         IF (II.EQ.1) II = 2
         IF (MODE.GT.10) CATD(KDCRV+2) = FREQ + (NCH + II - 2 -
     *      OLDR(KRCRP+JLOCF)) * OLDR(KRCIC+JLOCF)
C                                       Check for MODE=8 (override freq)
         IF ((MODE.EQ.8) .AND. (I.GT.2))
     *      CATD(KDCRV+2) = FREQ + OUFREQ
C                                       Check for MODE=6 with override.
         IF ((MODE.EQ.6) .AND. (ABS(OUFREQ).GT.1.0E-5))
     *      CATD(KDCRV+2) = FREQ + OUFREQ
C                                       Stokes type.
         IMODE = ICLTYP(I,MODE)
         CATD(KDCRV+3) = STOK(IMODE)
         CATR(KRCIC) = -XFLD / NX / 3.6D3
         CATR(KRCIC+1) = YFLD / NY / 3.6D3
         CATR(KRCIC+2) = BANWID
         CATR(KRCIC+3) = 1.D0
         CATR(KRCRP) = ICNTRX + DXCOR
         CATR(KRCRP+1) = NY - ICNTRY + 2 - DYCOR
         CATR(KRCRP+2) = 1.
         CATR(KRCRP+3) = 1.
         CALL ROTFND (OLDR, CATR(KRCRT+1), IERR)
         CATR(KRCRT+0) = 0.0
         CATR(KRCRT+2) = 0.
         CATR(KRCRT+3) = 0.
         CATR(KRDMX) = 0.0
         CATR(KRDMN) = 0.0
         CATR(KRBLK) = 0.
         CATR(KRXSH) = CATR(KRXSH) + XSH
         CATR(KRYSH) = CATR(KRYSH) + YSH
         CATBLK(KIGCN) = 0
         CATBLK(KIPCN) = 0
         CATBLK(KIDIM) = 4
         CATBLK(KINAX) = NX
         CATBLK(KINAX+1) = NY
         CATBLK(KINAX+2) = 1
         CATBLK(KINAX+3) = 1
         CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
         CALL CHR2H (6, CCLASS(IMODE), KHIMCO, CATH(KHIMC))
         CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
         CATBLK(KIIMU) = NLUSER
C                                       Set sequence number.
         CATBLK(KIIMS) = OUTSEQ
         IF ((MODE.GE.10) .AND. (I.GT.2))
     *      CATBLK(KIIMS) = OUTSEQ + I - 2
C                                       Create output map file.
         CALL MCREAT (DISOUT, ICNO, WROW, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1070) IRET
            GO TO 990
            END IF
C                                       Mark in /CFILE/
         NCFILE = NCFILE + 1
         FCNO(NCFILE) = ICNO
         FVOL(NCFILE) = DISOUT
         FRW(NCFILE) = 2
C                                       If I = 1 get actual OUTSEQ
         IF (I.EQ.1) OUTSEQ = CATBLK(KIIMS)
 100     CONTINUE
C                                       Save UV CATBLK
      CALL COPY (256, CATOLD, CATBLK)
C                                       Set MTYPE
      IF (MODE.LE.10) CALL COPY (5, IMTYPE(1,MODE), MTYPE)
      IMODE = MOD (MODE, 10) + 10
      IF (MODE.GE.11) CALL COPY (5, IMTYPE(1,IMODE), MTYPE)
C                                       Set MLOC
      IF (MODE.LE.10) CALL COPY (5, IMLOC(1,MODE), MLOC)
      IF (MODE.GE.11) CALL COPY (5, IMLOC(1,10), MLOC)
C                                       Set FFRAC
C                                       FFRAC = frequency correction
C                                       factor - 1
      IF (MODE.LE.10) THEN
         DO 110 IV = 1,5
            FFRAC(IV) = ((NCH - OLDR(KRCRP+JLOCF)) *
     *         OLDR(KRCIC+JLOCF)) / FREQ
 110        CONTINUE
      ELSE
         FFRAC(1) = ((NCH - OLDR(KRCRP+JLOCF)) *
     *      OLDR(KRCIC+JLOCF)) / FREQ
         FFRAC(2) = ((NCH + 1 - OLDR(KRCRP+JLOCF)) *
     *      OLDR(KRCIC+JLOCF)) / FREQ
         IF (NUMCH.GE.3) FFRAC(2) = ((NCH + 1.5 -
     *      OLDR(KRCRP+JLOCF)) * OLDR(KRCIC+JLOCF)) / FREQ
         FFRAC(3) = ((NCH + 3 - OLDR(KRCRP+JLOCF)) *
     *      OLDR(KRCIC+JLOCF)) / FREQ
         IF (NUMCH.GE.5) FFRAC(3) = ((NCH + 3.5 -
     *      OLDR(KRCRP+JLOCF)) * OLDR(KRCIC+JLOCF)) / FREQ
         FFRAC(4) = ((NCH + 5 - OLDR(KRCRP+JLOCF)) *
     *      OLDR(KRCIC+JLOCF)) / FREQ
         IF (NUMCH.GE.7) FFRAC(4) = ((NCH + 5.5 -
     *      OLDR(KRCRP+JLOCF)) * OLDR(KRCIC+JLOCF)) / FREQ
         FFRAC(5) = ((NCH + 7 - OLDR(KRCRP+JLOCF)) *
     *      OLDR(KRCIC+JLOCF)) / FREQ
         END IF
      IF (MODE.EQ.8) FFRAC(2) = OUFREQ / FREQ
      IF ((MODE.EQ.6) .AND. (ABS(OUFREQ).GT.1.0E-5))
     *   FFRAC(1) = OUFREQ / FREQ
C                                       Create scratch: UV grid & work;
C                                       other for FFT output
      CALL UVSIZE (LRECIN, NVIS, ISIZE)
      CALL SCREAT (ISIZE, WROW, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1130) IRET
         GO TO 990
         END IF
      UVSCR = NSCR
      NP(1) = 2 * NX
      NP(2) = NY
      CALL MAPSIZ (2, NP, ISIZE)
      DO 150 I = 1,2
         CALL SCREAT (ISIZE, WROW, IRET)
         ISCR(I) = NSCR
         IF (IRET.NE.0) THEN
            IF (IRET.EQ.1) WRITE (MSGTXT,1140)
            IF (IRET.GT.1) WRITE (MSGTXT,1141)
            GO TO 990
            END IF
 150     CONTINUE
C                                       set AP size
      NEED = 4 * NY * (NX/2 + 1)
      NEED = NEED / 1024
      MSGSUP = 32000
      CALL QINIT (APCORE, NEED, 0, KAP)
      MSGSUP = 0
      IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
         NEED = (NY * (NX/2 + 1)) / 2
         NEED = NEED / 1024
         NEED = MIN (16 * 1024, NEED) + 4
         CALL QINIT (APCORE, NEED, 0, KAP)
         IF ((KAP.EQ.0) .OR. (PSAPNW.EQ.0)) THEN
            MSGTXT = 'MAPINI: CANNOT GET NEEDED MEMORY'
            IERR = 8
            GO TO 990
            END IF
         END IF
      APSIZ = 1024 * PSAPNW
      CALL QRLSE
C                                       Set gridding function defaults.
      CALL GRDFLT (CTYPX, CTYPY, CPARMX, CPARMY)
      GO TO 999
C                                       error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('TROUBLE GETTING PARMS: IERR=',I7)
 1040 FORMAT ('ERROR: DATA IS NOT INTERFEROMETER TYPE DATA')
 1041 FORMAT ('TROUBLE INTERPRETING PARMS: IERR=',I7)
 1030 FORMAT ('ERROR',I3,' FINDING UVDATA')
 1070 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1130 FORMAT ('ERROR',I3,' CREATING UV SCRATCH FILE')
 1140 FORMAT ('TOO LITTLE DISK SPACE FOR SCRATCH FILE')
 1141 FORMAT ('TROUBLE CREATING SCRATCH FILE')
      END
      SUBROUTINE DPARM (NPASS, OUFREQ, IER)
C-----------------------------------------------------------------------
C   DPARM decodes integer and some character input parameters and sets
C   some default values.
C   NOTE: LRECIN has a minimum size of 8 to allow a work space in
C   the AP for tapering and shifting in CONGRD
C   Output:
C     NPASS  I    Number of FFT passes required.
C     OUFREQ R    Override frequency.
C     IER    I    error code:  0=>OK,   8=>bad input parameter.
C-----------------------------------------------------------------------
      CHARACTER BLANK*6, STEMP*6, RSTOKE(10)*4
      INTEGER   MLEN(40), MMAP(40), MNPASS(40), NPASS, I, IER, IROUND,
     *   IERR, IX, IY
      REAL      EPS, OUFREQ, OLDR(128)
      DOUBLE PRECISION XRA, XDEC
      INCLUDE 'UVMAP.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:PMAD.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      EQUIVALENCE (CATOLD, OLDR)
      DATA RSTOKE /'I   ','IQU ','IQUV','IV','R   ','L   ','RL  ',
     *   'LINE','RLIN','LLIN'/
      DATA EPS /0.01/
      DATA MLEN /8,10,12,8,8,8,8,10,0,0,
     *   8,8,10,12,14,16,18,20,0,0,
     *   8,8,10,12,14,16,18,20,0,0,
     *   8,8,10,12,14,16,18,20,0,0/
      DATA MMAP /2,4,5,3,2,2,3,4,0,0,
     *   2,3,4,5,6,7,8,9,0,0,
     *   2,3,4,5,6,7,8,9,0,0,
     *   2,3,4,5,6,7,8,9,0,0/
      DATA MNPASS /1,2,3,2,1,1,2,2,0,0,
     *   1,2,2,3,3,4,4,5,0,0,
     *   1,2,2,3,3,4,4,5,0,0,
     *   1,2,2,3,3,4,4,5,0,0/
C-----------------------------------------------------------------------
      IER = 0
C                                       Get parameters.
      DISOUT = IROUND (XDISO)
      OUTSEQ = IROUND (XSEQ)
C                                       Default NAMEOUT = NAMEIN
      STEMP = '      '
      CALL MAKOUT (NAMEIN, CLASIN, SEQIN, BLANK, NAMOUT, STEMP, OUTSEQ)
C                                       Decode Stokes parms.
      DO 10 I = 1,10
         MODE = I
         IF (RSTOKE(MODE).EQ.STOKES) GO TO 20
 10      CONTINUE
      MODE = 1
C                                       Channel # (spectral line)
 20   NCH = 1
      IF (XNCH.GT.0.0) NCH = XNCH + EPS
C                                       Number of channels.
      NUMCH = 1
      IF (XNOCH.GT.0.0) NUMCH = XNOCH + EPS
      IF (NUMCH.GT.8)   NUMCH = 8
C                                       Check line MODE
      IF (MODE.EQ.8)  MODE = 10 + NUMCH
      IF (MODE.EQ.9)  MODE = 20 + NUMCH
      IF (MODE.EQ.10) MODE = 30 + NUMCH
C                                       Check LL freq. overide
      IF ((MODE.EQ.7) .AND. (CPARMX(9).GT.0.5)) MODE = 8
C                                       Set # maps, # FFT, record length
      NUMMAP = MMAP(MODE)
      NPASS  = MNPASS(MODE)
      LRECIN = MLEN(MODE)
C                                       TV
      ITV = 0
      IF (USETV.GT.0.0) ITV = 1
      IF (NTVDEV.LE.0) ITV = 0
C                                       Weighting.
      NATWT = 1
      IF (WTFN.NE.'NA  ') NATWT = 0
C                                       MAPPNTS (NX,NY)
      NX = XNX + EPS
      NY = XNY + EPS
C                                       Check if (NX,NY) is valid.
      CALL POWER2 (NX, IX)
      CALL POWER2 (NY, IY)
C                                       Invalid (NX,NY)
      IF ((NX.NE.IX) .OR. (NX.LT.32) .OR. (NX.GT.MAXIMG) .OR.
     *   (NY.NE.IY) .OR. (NY.LT.32) .OR. (NY.GT.MAXIMG)) THEN
         WRITE (MSGTXT,1030) NX, NY
         CALL MSGWRT (8)
         IER = 8
         GO TO 999
         END IF
C                                       cellsize -> FLDVU
      XFLD = XFLD * NX
      YFLD = YFLD * NY
      IF ((XFLD.LE.0.0) .OR. (YFLD.LE.0.0)) THEN
         WRITE (MSGTXT,1040)
         CALL MSGWRT (8)
         IER = 8
         GO TO 999
         END IF
C                                       Taper.
      TAPERU = MAX (0.0, TAPERU)
      TAPERV = MAX (0.0, TAPERV)
      ITAP = 0
      IF ((TAPERU.GT.0.0) .OR. (TAPERV.GT.0.0)) ITAP = 2
C                                       Map center.
      ICNTRX = NX / 2
      ICNTRY = NY / 2 + 1
C                                       Check defaults for BLLIM
      BLMIN = MAX (0.0, BLMIN)
      IF (BLMAX.LE.0.0) BLMAX = 1.0E15
C                                       Zero spacing flux densities.
      IZSP = 0
      IF ((ZSP(1).NE.0.0) .OR. (ZSP(2).NE.0.0) .OR. (ZSP(3).NE.0.0)
     *   .OR. (ZSP(4).NE.0.0)) IZSP = 1
C                                       Gridding correction.
      NOGCOR = 0
      IF (XGCOR.LE.0.) NOGCOR = 1
C                                       Convolution types
      CTYPX = CTYPEX + SIGN (EPS, CTYPEX)
      CTYPY = CTYPEY + SIGN (EPS, CTYPEY)
      UNFBOX = XUNFBX + 0.1
C                                       Bad disks.
      DO 60 I = 1,10
         IBAD(I) = BADD(I) + EPS
 60      CONTINUE
C                                       Override frequency.
C                                       Fix VLA problem here.
      OUFREQ = 0.0D0
      IF (MODE.EQ.8) OUFREQ = CPARMX(10)
      IF ((MODE.EQ.6) .AND. (CPARMX(9).GE.0.5)) OUFREQ = CPARMX(10)
C                                       Set for shift
      NOSHFT = (XSHIFT.EQ.0.0) .AND. (YSHIFT.EQ.0.0)
C                                       Get header shift and coor.
C                                       offset.
      CALL ROTFND (OLDR, MAPROT, IERR)
      MAPROT = MAPROT * DG2RAD
      XSH = COS (MAPROT) * XSHIFT - SIN (MAPROT) * YSHIFT
      YSH = SIN (MAPROT) * XSHIFT + COS (MAPROT) * YSHIFT
C                                       Field offsets.
      MAPROT = MAPROT / DG2RAD
      CALL XYSHFT (RA, DEC, XSHIFT, YSHIFT, MAPROT, XRA, XDEC)
      XSH = XRA - RA
      YSH = XDEC - DEC
      CALL SHFCRP (TYPUVD, RA, DEC, MAPROT, XRA, XDEC, DXCOR, DYCOR)
      DXCOR = DXCOR * NX /  XFLD
      DYCOR = DYCOR * NY /  YFLD
C                                       Check sort order.
      IF (ISORT(1:1).NE.'X') THEN
         WRITE (MSGTXT,1060) ISORT, 'X*'
         CALL MSGWRT (8)
         IER = 8
         GO TO 999
         END IF
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT ('DPARM: NX,NY = ',2I6,' ARE ILLEGAL')
 1040 FORMAT ('DPARM: FIELD OF VIEW IS <= ZERO')
 1060 FORMAT ('DPARM: SORT ORDER =',A2,' NOT ',A2)
      END
      SUBROUTINE VISRD (IER)
C-----------------------------------------------------------------------
C   VISRD gets necessary information from the catalog header and
C   reads the uv data and converts to the form expected in the rest
C   of the program.
C   Output:
C      IER   I    Return error code: 0=>OK, otherwise an error occured.
C-----------------------------------------------------------------------
      INTEGER   IER, LRECO, LENIN, JADR(2,8), ICHK, I, J, STYPE, INIO,
     *   NIOUT, BIND1, BIND2, MVIS, IFNUM, IBUFSZ, IPOINT, OPOINT,
     *   OCNT, BO, VO
      CHARACTER PHNAME*48
      REAL      WT, INBUF(1), OUTBUF(1), BLEN, BLMN2, BLMX2, DU, DV, DW,
     *   UMAX, VMAX, GCOR, SFACT(2,8), VSREC(20), UU, VV, WW, AUMAX,
     *   AVMAX, BUMAX, BVMAX, UTFACT, VTFACT
      LOGICAL   T, F, ALLWT
      INTEGER   XCOUNT
      COMPLEX   VS(8), CMPLX, CONJG
      DOUBLE PRECISION XRA, XDEC
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'UVMAP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (INBUF, CBUF),     (OUTBUF, CBUF2)
      EQUIVALENCE (UU, VSREC(1)), (VV, VSREC(2)), (WW, VSREC(3)),
     *   (WT, VSREC(4)), (VS, VSREC(5))
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      IBUFSZ = UVBFSS * 4
      LRECO = LRECIN
C                                       Determine some constants.
      DU = 2.06264E5 / XFLD
      DV = 2.06264E5 / YFLD
      DW = 1.0
C                                       Set limits.
      UMAX = (NX/2-0.5) * DU
      VMAX = (NY/2-0.5) * DV
      AUMAX = MAX (6.0, CPARMX(1)) * DU / UMAX
      AVMAX = MAX (6.0, CPARMY(1)) * DV / VMAX
C                                       taper factors
      UTFACT = 1.0
      VTFACT = 1.0
      IF (TAPERU.GT.0.0) UTFACT = EXP (LOG(0.3) *
     *   ((UMAX*0.7) / (1000. * TAPERU))**2)
      IF (TAPERV.GT.0.0) VTFACT = EXP (LOG(0.3) *
     *   ((VMAX*0.7) / (1000. * TAPERV))**2)
      UTFACT = SQRT (UTFACT)
      VTFACT = SQRT (VTFACT)
C                                       default guard band widths
      IF (XGUARD(1).LT.-0.001) THEN
         XGUARD(1) = AUMAX
      ELSE IF ((XGUARD(1).LE.0.001) .OR. (XGUARD(1).GT.0.9)) THEN
         XGUARD(1) = 0.3 * UTFACT
         END IF
      XGUARD(1) = MAX (XGUARD(1), AUMAX)
      IF (XGUARD(2).LT.-0.001) THEN
         XGUARD(2) = AVMAX
      ELSE IF ((XGUARD(2).LE.0.001) .OR. (XGUARD(2).GT.0.9)) THEN
         XGUARD(2) = 0.3 * VTFACT
         END IF
      XGUARD(2) = MAX (XGUARD(2), AVMAX)
C                                       Max is edge - guard
      UMAX = UMAX * (1.0 - XGUARD(1))
      VMAX = VMAX * (1.0 - XGUARD(2))
      BLMX2 = 1.0E6 * BLMAX * BLMAX
      BLMN2 = 1.0E6 * BLMIN * BLMIN
      AUMAX = 0.0
      AVMAX = 0.0
      BUMAX = 0.0
      BVMAX = 0.0
C                                       Correct to highest frequency.
C                                       BUG IF CIC IS < 0
      GCOR = (FREQ + (NCH+NUMCH-1 - CATR(KRCRP+JLOCF)) *
     *   CATR(KRCIC+JLOCF)) / FREQ
C                                       Check for MODE=8
      IF (MODE.EQ.8) GCOR = (FREQ + MAX (0.0, CPARMX(10))) / FREQ
      UMAX = UMAX / GCOR
      VMAX = VMAX / GCOR
      BLMX2 = BLMX2 / (GCOR * GCOR)
      BLMN2 = BLMN2 / (GCOR * GCOR)
C                                       Rotate and shift
      NOSHFT = T
      IF ((XSHIFT.NE.0.0) .OR. (YSHIFT.NE.0.0)) NOSHFT = F
C                                       calc U,V,W field shift terms
C                                       Field offsets.
      CALL XYSHFT (RA, DEC, XSHIFT, YSHIFT, MAPROT, XRA, XDEC)
C                                       set shift terms for field cent.
C                                       -NCP projection
      IF (TYPUVD.EQ.-1) THEN
         CALL SHINCP (RA, DEC, MAPROT, XRA, XDEC, DXC, DYC, DZC)
C                                       -SIN projection
      ELSE
         CALL SHISIN (RA, DEC, MAPROT, XRA, XDEC, DXC, DYC, DZC)
         END IF
C                                       Use opposite phase convention
      DXC = -DXC
      DYC = -DYC
      DZC = -DZC
C                                       NCH is the start channel no.
      IF (NCH.GT.CATBLK(KINAX+JLOCF)) THEN
         WRITE (MSGTXT,1000) NCH, CATBLK(KINAX+JLOCF)
         IER = 8
         GO TO 980
         END IF
      STYPE = MODE
      IF (MODE.EQ.8) STYPE = 7
C                                       For now IF=1
      IFNUM = 1
      CALL SETVIS (STYPE, NCH, IFNUM, MVIS, JADR, SFACT, ALLWT, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1010)
         GO TO 980
         END IF
C                                       Check record length.
      ICHK = 4 + MVIS*2
      ICHK = MAX (8, ICHK)
C                                       Special case.
      IF (MODE.EQ.8) ICHK = LRECIN
      IF (LRECIN.NE.ICHK) THEN
         WRITE (MSGTXT,1015) LRECIN, ICHK
         IER = 9
         GO TO 980
         END IF
C                                       Determine length of input
C                                       and buffer.
      LENIN = 0
C                                       Open scratch file.
      CALL ZPHFIL ('SC', SCRVOL(UVSCR), SCRCNO(UVSCR), 1, PHNAME, IER)
      CALL ZOPEN (LUNS(1), INDS(1), SCRVOL(UVSCR), PHNAME, T, T, T, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1020) IER
         GO TO 980
         END IF
C                                       Init files.
C                                       Input file opened in MAPINI
      INIO = LENIN
      CALL UVINIT ('READ', LUNS(2), INDS(2), NVIS, VO, LREC, INIO,
     *   IBUFSZ, INBUF, BO, BIND2, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1050) 'READ', IER
         GO TO 980
         END IF
      NIOUT = 0
      CALL UVINIT ('WRIT', LUNS(1), INDS(1), NVIS, VO, LRECO, NIOUT,
     *   IBUFSZ, OUTBUF, BO, BIND1, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1050) 'WRIT', IER
         GO TO 980
         END IF
      OPOINT = BIND1
      OCNT = 0
      XCOUNT = 0
C                                       Initialize visibilities.
      DO 80 I = 1,8
         VS(I) = CMPLX (0.,0.)
 80      CONTINUE
C                                       Conversion to cells done in
C                                       gridding routine in AP.
      SCLU = 1.0 / DU
C                                       Flip sign on v to make maps come
C                                       out upside down.
      SCLV = - 1.0 / DV
      SCLW = 1.0 / DW
C                                       Begin loop reading and convertin
 100  CONTINUE
C                                       Read buffer.
         CALL UVDISK ('READ', LUNS(2), INDS(2), INBUF, INIO, BIND2, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1100) 'READ', IER
            GO TO 980
            END IF
         IPOINT = BIND2
         IF (INIO.LE.0) GO TO 210
C                                       Loop thru buffer.
         DO 200 I = 1,INIO
C                                       Convert record. Correct for
C                                       frequency in CONGRD in AP.
            UU = INBUF(IPOINT+ILOCU)
            VV = INBUF(IPOINT+ILOCV)
            WW = INBUF(IPOINT+ILOCW)
C                                       Check if data desired.
            BLEN = UU*UU + VV*VV
            IF ((BLEN.LT.BLMN2) .OR. (BLEN.GT.BLMX2)) GO TO 190
            AUMAX = MAX (AUMAX, ABS(UU))
            AVMAX = MAX (AVMAX, ABS(VV))
            IF ((ABS(UU).GE.UMAX) .OR. (ABS(VV).GE.VMAX)) GO TO 190
            BUMAX = MAX (BUMAX, ABS(UU))
            BVMAX = MAX (BVMAX, ABS(VV))
C                                       Get visibilities.
            CALL GETVIS (STYPE, MVIS, JADR, SFACT, ALLWT,
     *         INBUF(IPOINT+NRPARM), WT, VS, IER)
            IF (IER.NE.0) GO TO 190
C                                       Put u,v,w on proper side of grid
            IF (UU.LT.0.0) THEN
               UU = -UU
               VV = -VV
               WW = -WW
               DO 140 J = 1,MVIS
                  VS(J) = CONJG (VS(J))
 140              CONTINUE
               END IF
C                                       Copy to output, note use of
C                                       EQUIVALENCE.
            CALL RCOPY (LRECO, VSREC, OUTBUF(OPOINT))
C                                       Count vis. rec.
            XCOUNT = XCOUNT + 1
C                                       Check if time for a write.
            OPOINT = OPOINT + LRECO
            OCNT = OCNT + 1
C                                       Time for write.
            IF (OCNT.GE.NIOUT) THEN
               NIOUT = OCNT
               CALL UVDISK ('WRIT', LUNS(1), INDS(1), OUTBUF, NIOUT,
     *            BIND1, IER)
               IF (IER.NE.0) THEN
                  WRITE (MSGTXT,1100) 'WRIT', IER
                  GO TO 980
                  END IF
               OPOINT = BIND1
               OCNT = 0
               END IF
C                                       Update input buffer.
 190        IPOINT = IPOINT + LREC
 200        CONTINUE
C                                       Loop back for next input buffer.
         GO TO 100
C                                       Flush output buffer.
 210  NIOUT = -OCNT
      CALL UVDISK ('FLSH', LUNS(1), INDS(1), OUTBUF, NIOUT, BIND1, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1100) 'FLSH', IER
         GO TO 980
         END IF
C                                        Check that some data given
      IF (XCOUNT.LT.1) THEN
         IER = 8
         WRITE (MSGTXT,1220)
         GO TO 980
         END IF
C                                       data outside grid?
      IF ((AUMAX.GT.UMAX) .OR. (AVMAX.GT.VMAX)) THEN
         MSGTXT = '**** WARNING data discarded outside usable part of'
     *      // ' UV plane ****'
         CALL MSGWRT (6)
         IF (AUMAX.GT.UMAX) THEN
            VV = ABS (XFLD / NX)
            UU = UMAX/AUMAX * VV
            WRITE (MSGTXT,1230) 'U', AUMAX, UMAX
            CALL MSGWRT (6)
            WRITE (MSGTXT,1231) UU, VV
            CALL MSGWRT (6)
            WRITE (MSGTXT,1232) 'U', XGUARD(1)
            CALL MSGWRT (6)
            END IF
         IF (AVMAX.GT.VMAX) THEN
            VV = ABS (YFLD / NY)
            UU = VMAX/AVMAX * VV
            WRITE (MSGTXT,1230) 'V', AVMAX, VMAX
            CALL MSGWRT (6)
            WRITE (MSGTXT,1231) UU, VV
            CALL MSGWRT (6)
            WRITE (MSGTXT,1232) 'V', XGUARD(2)
            CALL MSGWRT (6)
            END IF
         END IF
      IF ((BUMAX.GT.(1-0.35*UTFACT)*(NX/2-0.5)*DU) .OR.
     *   (BVMAX.GT.(1-0.35*VTFACT)*(NY/2-0.5)*DV)) THEN
         MSGTXT = '**** WARNING data included out of inner portion'
     *      // ' of UV plane ****'
         CALL MSGWRT (6)
         MSGTXT = '**** Watch for high-frequency & other poor ' //
     *      'cleaning effects ****'
         CALL MSGWRT (6)
         END IF
C                                       Get least lambda limit
      UMAX = MIN (UMAX, VMAX)
      UMAX = MIN (UMAX, SQRT(BLMX2))
C                                       Tell how much data to be used.
      WRITE (MSGTXT,1235,ERR=240) XCOUNT, NVIS, UMAX
      IF (XCOUNT.EQ.NVIS) WRITE (MSGTXT,1236,ERR=240) NVIS
 240  CALL MSGWRT (4)
C                                        Set new no. vis.
      NVIS = XCOUNT
C                                       Close files.
      CALL ZCLOSE (LUNS(1), INDS(1), IER)
      CALL ZCLOSE (LUNS(2), INDS(2), IER)
      IER = 0
      GO TO 999
C
 980  CALL MSGWRT (8)
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('VISRD: CHANNEL ',I4,' .GT. MAX=',I4)
 1010 FORMAT ('VISRD: REQUESTED DATA NOT AVAILABLE IN DATABASE')
 1015 FORMAT ('VISRD: EXPECTED LRECL =',I3,' GOT ',I4)
 1020 FORMAT ('VISRD: OPEN ERROR ',I3,' ON ',A4)
 1050 FORMAT ('VISRD: INIT FOR ',A4,' ERROR ',I3)
 1100 FORMAT ('VISRD: ',A4,' ERROR ',I3)
 1220 FORMAT ('VISRD: NO VALID DATA FOUND')
 1230 FORMAT ('**** Actual ',A,'max',1PE11.4,' exceeds limit',1PE11.4,
     *   8X,'****')
 1231 FORMAT ('**** Use cellsize <',F10.5,' not',F10.5,
     *   ' to get all data ****')
 1232 FORMAT ('**** using a ',A,' guard band of',F7.3,' of a radius',
     *   13X,'****')
 1235 FORMAT ('Using ONLY',I9,' of',I9,' Vis. < ',1PE9.2,' Lambdas')
 1236 FORMAT ('Using all ',I9,' Visibilities')
      END
      SUBROUTINE UVDISP
C-----------------------------------------------------------------------
C   UVDISP displays the sampled cells on the TV - filling in a maxint
C   for sampled cells and zero for unsampled.  Uses channel 1.
C-----------------------------------------------------------------------
      INTEGER   IROW(1024), WIN(4), BLKOF, ICH,
     *   IX, IY, L, M, L2, M2, II, I, IJ, IND, NNY2,
     *   J, LL2, ITS, IER, IX0, IY0, JX, JY, IANGL, ISCR3
      LOGICAL   T
      CHARACTER PHNAME*48
      REAL      XX
      INCLUDE 'UVMAP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DTVD.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (WROW, IROW)
      EQUIVALENCE (ISCR3, ISCR(2))
      DATA T /.TRUE./
      DATA BLKOF/1/
C-----------------------------------------------------------------------
C                                       Open TV, clear screen, catlg
      ICH = 1
      CALL TVOPEN (IROW, IER)
      IF (IER.NE.0) GO TO 999
      CALL TVSET (ICH, IROW, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1000) IER
         CALL MSGWRT (6)
         GO TO 990
         END IF
C                                       Open Grid file
      CALL ZPHFIL ('SC', SCRVOL(ISCR3), SCRCNO(ISCR3), 1, PHNAME, IER)
      CALL ZOPEN (LUNS(ISCR3), INDS(ISCR3), SCRVOL(ISCR3), PHNAME, T,
     *   T, T, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1010) IER
         CALL MSGWRT (6)
         GO TO 990
         END IF
C                                       Init IO
C                                       leave in transposed order
      IF ((TVYMOD.NE.1) .AND. (TVYMOD.NE.2)) THEN
         IX = (NX - 1) / MAXXTV(2) + 1
         IY = (NY - 1) / MAXXTV(1) + 1
         IX = MAX (IX, IY)
         IY = IX
         L = (NX-1) / IX + 1
         L2 = L * IX
         L2 = MIN (L2, NX)
         M = (NY-1) / IY + 1
         M2 = M * IY
         M2 = MIN (M2, NY)
         IX0 = (MAXXTV(2) - L) / 2
         IF (IX0.LT.0) IX0 = 0
         IY0 = (MAXXTV(1) - M) / 2
         IF (IY0.LT.0) IY0 = 0
         IANGL = 0
      ELSE
C                                       transpose by write TV cols
         IX = (NX - 1) / MAXXTV(1) + 1
         IY = (NY - 1) / MAXXTV(2) + 1
         IX = MAX (IX, IY)
         IY = IX
         L = (NX-1) / IX + 1
         L2 = L * IX
         L2 = MIN (L2, NX)
         M = (NY-1) / IY + 1
         M2 = M * IY
         M2 = MIN (M2, NY)
         IX0 = (MAXXTV(1) - L) / 2
         IF (IX0.LT.0) IX0 = 0
         IY0 = (MAXXTV(2) - M) / 2
         IF (IY0.LT.0) IY0 = 0
         IANGL = 1
         IF (TVYMOD.EQ.2) IANGL = 3
         END IF
      JX = IY0 + 1
      JY = JX
      IF (TVYMOD.EQ.2) JY = MAXXTV(2) - IY0
C                                       Set window for first half and
C                                       the size of rows in the grid
C                                       image; note that each pixel in
C                                       the grid image is a COMPLEX
C                                       number while MINIT/MDISK deal
C                                       with REALS
      WIN(1) = 1
      WIN(2) = L2 / 2 + 1
      WIN(3) = M2 * 2
      WIN(4) = L2
      NNY2 = NY * 2
C                                       Write on TV center at center.
      L = 1
      DO 60 II = 1,2
         CALL MINIT ('READ', LUNS(ISCR3), INDS(ISCR3), NNY2, NX, WIN,
     *      RCBUF, BUFSZ, BLKOF, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1015) IER
            GO TO 970
            END IF
C                                       Reset WIN for first half
         WIN(2) = 1
         WIN(4) = L2 / 2
C                                       Load to TV
         LL2 = L2 / 2
         DO 50 I = 1,LL2
            CALL MDISK ('READ', LUNS(ISCR3), INDS(ISCR3),
     *         RCBUF, IND, IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,1025) IER
               GO TO 970
               END IF
C                                      IND points to start of row in a
C                                      REAL buffer - convert for COMPLEX
C                                      buffer.
            IND = IND / 2 + 1
            ITS = I-1
            IF (MOD (ITS,IX).EQ.0) THEN
               IF (IANGL.EQ.0) JY = IX0 + L
               IF (TVYMOD.EQ.2) JX = IX0 + L
               IF (TVYMOD.EQ.1) JX = MAXXTV(1) + 1 - IX0 - L
               L = L + 1
               IJ = M2 / (2 * IY)
               DO 40 J = 1,M2,IY
                  XX = ABS (REAL (CBUF(IND-1+J)))
     *               + ABS (AIMAG (CBUF(IND-1+J)))
                  IJ = IJ + 1
                  IF (IJ.GT.M2/IY) IJ = 1
                  IROW(IJ) = 0
                  IF (XX.GT.1.0E-15) IROW(IJ) = MAXINT
 40               CONTINUE
               CALL YIMGIO ('WRIT', ICH, JX, JY, IANGL, M, IROW, IER)
               IF (IER.NE.0) THEN
                  WRITE (MSGTXT,1040) IER
                  GO TO 970
                  END IF
               END IF
 50         CONTINUE
 60      CONTINUE
      GO TO 980
C                                       returns
 970  CALL MSGWRT (6)
 980  CALL ZCLOSE (LUNS(ISCR3), INDS(ISCR3), IER)
 990  CALL TVCLOS (IROW, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVDISP: CANT CLEAR TV, IER=',I7)
 1010 FORMAT ('UVDISP: TROUBLE OPENING GRID FILE, IER=',I7)
 1015 FORMAT ('UVDISP: TROUBLE IN MINIT, IER=',I7)
 1025 FORMAT ('UVDISP: READ ERROR WITH MDISK, IER=',I7)
 1040 FORMAT ('UVDISP: TV IO ERROR=',I7)
      END
      SUBROUTINE MAPOUT (APCORE, MAPNT, FFRAC, BMAX, IER)
C-----------------------------------------------------------------------
C   MAPOUT reads the FFT output file, corrects the map for the Fourier
C   transform of the convolving function used to grid, and writes out
C   the maps to a scratch file. PNLPUT is then called to copy the map
C   to the catalogd file and MAPHIS is called to write the history
C   file.
C   Inputs:
C     MAPNT     I    Pointer in /CFILES/ to first output map.
C                    Note: UVDATA should be first in /CFILES/
C     FFRAC     R    Freq. correction factor (-1) for this cycle.
C   Input/Output:
C     BMAX      R    Map normalization factor. Determined from the
C                    center pixel in BEAM map
C   Output:
C     IER       I    Error code, 0=>OK, otherwise error.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   BLKOF, LUNH(2),IP1, IP2, ICH, KVOL(2), KCNO(2), I, IND,
     *   JWIN(4), MAPNT, KBUFS1, KBUFS2, IBUFF(2048), K, ITEMP, ISCR1,
     *   IER
      INTEGER   INDEX, IMAP, ONENX, TWONX, KTEMP1, KTEMP2,
     *   IXC, KMAP, IMX1, IMX2, JMX1, JMX2, IWORK, KAP,
     *   IYC, IMN1, IMN2, JMN1, JMN2, ONENY, IMAPP1, JMAP
      LOGICAL   T, TWOMAP
      CHARACTER PHNAME*48
      REAL      XMAX(2), XMIN(2), PKR(2), BUFF(4096), RBUFF(4096),
     *   BMAX, BIMAX, FFRAC, RDUM(2)
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'UVMAP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DAPM.INC'
      EQUIVALENCE (BUFF, CBUF),         (RBUFF, CBUF2, IBUFF)
      EQUIVALENCE (ISCR1, ISCR(1))
      DATA T /.TRUE./
      DATA BLKOF /1/
      DATA LUNH /27,28/
C-----------------------------------------------------------------------
      TWOMAP = MAPNT .LE. NUMMAP
      KBUFS1 = 2  * UVBFSS
      KBUFS2 = 2  * UVBFSS
C                                        Initialize history.
      CALL HIINIT (2)
C                                       AP Addresses
      ONENX = NX
      TWONX = NX * 2
      ONENY = NY
      KTEMP1 = NY + 1
      IMAP = 0
      IMAPP1 = IMAP + 1
      KMAP = IMAP + TWONX
      JMAP = KMAP + ONENX
      IXC = JMAP + ONENX
      IYC = IXC + ONENX
      IMX1 = IYC + ONENY
      IWORK = IMX1
      IMX2 = IMX1 + KTEMP1
      IMN1 = IMX2 + KTEMP1
      IMN2 = IMN1 + KTEMP1
      JMX1 = IMN2 + KTEMP1
      JMX2 = JMX1 + 1
      JMN1 = JMX2 + 1
      JMN2 = JMN1 + 1
C                                       Compute Fourier Transform of
C                                       the gridding function in the AP.
      CALL QINIT (APCORE, 0, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
         MSGTXT = 'MAPOUT: UNABLE TO GET AP MEMORY BACK'
         CALL MSGWRT (8)
         IER = 8
         GO TO 995
         END IF
C                                       Ones fill convolving fn.
C                                       correction
      XMAX(1) = 1.0
      CALL QPUT (APCORE, XMAX, IMAP, 1, 2)
      CALL QWD
      CALL QVFILL (APCORE, IMAP, IXC, 1, ONENX)
      CALL QVFILL (APCORE, IMAP, IYC, 1, ONENY)
C
      IF (NOGCOR.NE.1) THEN
         CALL GRDTAB (APCORE, NX, ICNTRX, CTYPX, CPARMX, IXC, IWORK,
     *      IBUFF)
         CALL GRDTAB (APCORE, NY, ICNTRY, CTYPY, CPARMY, IYC, IWORK,
     *      IBUFF)
         END IF
C                                       Open, init files.
C                                       FFT file
      CALL ZPHFIL ('SC', SCRVOL(ISCR1), SCRCNO(ISCR1), 1, PHNAME, IER)
      CALL ZOPEN (LUNS(1), INDS(1), SCRVOL(ISCR1), PHNAME, T, T, T, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1010) IER
         GO TO 995
         END IF
C                                       Get center of beam(first pass).
      IF (MAPNT.EQ.2) THEN
         JWIN(2) = ICNTRY
         ITEMP = (ICNTRX * 2 - 1) / TWONX
         JWIN(2) = JWIN(2) + ITEMP
         JWIN(1) = ICNTRX * 2  - ITEMP * TWONX
         JWIN(3) = JWIN(1) + 1
         JWIN(4) = JWIN(2) + 1
         JWIN(3) = MIN (JWIN(3), TWONX)
         JWIN(4) = MIN (JWIN(4), NY)
         CALL MINIT ('READ', LUNS(1), INDS(1), TWONX, NY, JWIN,
     *      BUFF, KBUFS1, BLKOF, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1020) IER
            GO TO 995
            END IF
         CALL MDISK ('READ', LUNS(1), INDS(1), BUFF, IND, IER)
C                                       Get beam center value.
         BMAX = BUFF(IND)
C                                       Reset JWIN
         JWIN(1) = 0
         JWIN(2) = 0
         JWIN(3) = 0
         JWIN(4) = 0
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1070) IER
            GO TO 995
            END IF
         END IF
      CALL MINIT ('READ', LUNS(1), INDS(1), TWONX, NY, JWIN, BUFF,
     *   KBUFS1, BLKOF, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1020) IER
         GO TO 995
         END IF
C                                       First map file.
      CALL ZPHFIL ('MA', DISOUT, FCNO(MAPNT), 1, PHNAME, IER)
      CALL ZOPEN (LUNS(2), INDS(2), DISOUT, PHNAME, T, T, T, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1010) IER
         GO TO 995
         END IF
      CALL MINIT ('WRIT', LUNS(2), INDS(2), NX, NY, JWIN, RBUFF, KBUFS2,
     *   BLKOF, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1020) IER
         GO TO 995
         END IF
C                                       Second map file.
      IF (TWOMAP) THEN
         CALL ZPHFIL ('MA', DISOUT, FCNO(MAPNT+1), 1, PHNAME, IER)
         CALL ZOPEN (LUNS(3), INDS(3), DISOUT, PHNAME, T, T, T, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1010) IER
            GO TO 995
            END IF
         CALL MINIT ('WRIT', LUNS(3), INDS(3), NX, NY, JWIN, WROW,
     *      KBUFS2, BLKOF, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1020) IER
            GO TO 995
            END IF
         END IF
C                                       Divide X gridding correction by
C                                       the peak of the beam to
C                                       normalize.
      IF (BMAX.LE.0.0) BMAX = 1.0
      BIMAX = 1.0 / BMAX
      RDUM(1) = BIMAX
      CALL QPUT (APCORE, RDUM, IMAP, 1, 2)
      CALL QWD
      CALL QVSMUL (APCORE, IXC, 1, IMAP, IXC, 1, ONENX)
C                                       Loop thru map normalizing,
C                                       gridding correcting and
C                                       writing the maps to
C                                       separate scratch files.
      DO 120 I = 1,NY
         INDEX = IMAP
         CALL MDISK ('READ', LUNS(1), INDS(1), BUFF, IND, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1070) IER
            GO TO 995
            END IF
         CALL QWR
         CALL QPUT (APCORE, BUFF(IND), INDEX, TWONX, 2)
C                                       Correct map for gridding and
C                                       normalize.
C                                       Writes.
         CALL MDISK ('WRIT', LUNS(2), INDS(2), RBUFF, IP1, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1080) IER
            GO TO 995
            END IF
         IF (TWOMAP) THEN
           CALL MDISK ('WRIT', LUNS(3), INDS(3), WROW, IP2, IER)
           IF (IER.NE.0) THEN
              WRITE (MSGTXT,1080) IER
              GO TO 995
              END IF
           END IF
         KTEMP2 = I - 1
         KTEMP1 = IYC + KTEMP2
         CALL QWD
         CALL QCRVMU (APCORE, IMAP, 2, IXC, 1, IMAP, 2, ONENX)
C                                       Split into two maps
         CALL QVSMUL (APCORE, IMAP, 2, KTEMP1, KMAP, 1, ONENX)
         IF (TWOMAP) CALL QVSMUL (APCORE, IMAPP1, 2, KTEMP1, JMAP, 1,
     *      ONENX)
C                                       Read maps to scratch files.
         CALL QWR
         CALL QGET (APCORE, RBUFF(IP1), KMAP, ONENX, 2)
         CALL QWD
C                                       Get second map.
         IF (TWOMAP) THEN
            CALL QGET (APCORE, WROW(IP2), JMAP, ONENX, 2)
            CALL QWD
            END IF
C                                       Find extrema
         IWORK = I - 1
         KTEMP1 = IMX1 + IWORK
         CALL QMAXV (APCORE, KMAP, 1, KTEMP1, ONENX)
         KTEMP2 = IMX2 + IWORK
         IF (TWOMAP) CALL QMAXV (APCORE, JMAP, 1, KTEMP2, ONENX)
         KTEMP1 = IMN1 + IWORK
         CALL QMINV (APCORE, KMAP, 1, KTEMP1, ONENX)
         KTEMP2 = IMN2 + IWORK
         IF (TWOMAP) CALL QMINV (APCORE, JMAP, 1, KTEMP2, ONENX)
 120     CONTINUE
C                                       Flush output buffers and close
C                                       files.
         CALL MDISK ('FINI', LUNS(2), INDS(2), RBUFF, IP1, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1080) IER
            GO TO 995
            END IF
         IF (TWOMAP) CALL MDISK ('FINI', LUNS(3), INDS(3), WROW, IP2,
     *      IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1080) IER
            GO TO 995
            END IF
         CALL ZCLOSE (LUNS(2), INDS(2), IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1140) IER
            GO TO 995
            END IF
            IF (TWOMAP) CALL ZCLOSE (LUNS(3), INDS(3), IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1140) IER
            GO TO 995
            END IF
C                                       Close grid file
      CALL ZCLOSE (LUNS(1), INDS(1), IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1160) IER
         GO TO 995
         END IF
      CALL QMAXV (APCORE, IMX1, 1, JMX1, ONENY)
      IF (TWOMAP) CALL QMAXV (APCORE, IMX2, 1, JMX2, ONENY)
      CALL QMINV (APCORE, IMN1, 1, JMN1, ONENY)
      IF (TWOMAP) CALL QMINV (APCORE, IMN2, 1, JMN2, ONENY)
      CALL QWR
      CALL QGET (APCORE, BUFF, JMX1, 4, 2)
      CALL QWD
C                                       Release AP
      CALL QRLSE
      XMAX(1) = BUFF(1)
      XMAX(2) = BUFF(2)
      XMIN(1) = BUFF(3)
      XMIN(2) = BUFF(4)
      IF (XMAX(1).EQ.XMIN(1)) XMAX(1) = XMIN(1) + 1.0
      IF (XMAX(2).EQ.XMIN(2)) XMAX(2) = XMIN(2) + 1.0
      DO 180 K = 1,2
         PKR(K) = XMAX(K)
         IF (ABS (XMIN(K)).GT.ABS (XMAX(K))) PKR(K) = XMIN(K)
 180     CONTINUE
      IF ((MAPNT.EQ.2) .OR. (MODE.GE.10)) WRITE (MSGTXT,2004) PKR(1)
      IF ((MAPNT.EQ.2) .AND. ((MODE.EQ.5) .OR. (MODE.EQ.7) .OR.
     *   (MODE.EQ.8))) WRITE (MSGTXT,2002) PKR(1)
      IF ((MAPNT.EQ.2) .AND. (MODE.EQ.6)) WRITE (MSGTXT,2003) PKR(1)
      IF ((MAPNT.EQ.4) .AND. ((MODE.EQ.7) .OR. (MODE.EQ.8)))
     *    WRITE (MSGTXT,2003) PKR(1)
      IF ((MAPNT.EQ.4) .AND. (MODE.LE.3)) WRITE (MSGTXT,2005) PKR(1)
      IF (((MODE.EQ.3) .AND. (MAPNT.EQ.6)) .OR. ((MODE.EQ.4) .AND.
     *   (MAPNT.EQ.4))) WRITE (MSGTXT,2007) PKR(1)
      CALL MSGWRT (3)
      IF (TWOMAP) THEN
         WRITE (MSGTXT,2004) PKR(2)
         IF ((MAPNT.EQ.2) .OR. ((MAPNT.EQ.4) .AND. (MODE.EQ.8)))
     *      WRITE (MSGTXT,2008) BMAX
         IF ((MODE.LE.3) .AND. (MAPNT.EQ.4)) WRITE (MSGTXT,2006)
     *      PKR(2)
         CALL MSGWRT (3)
         END IF
C                                       First map.
C                                       Get CATBLK
      CALL CATIO ('READ', DISOUT, FCNO(MAPNT), CATBLK, 'REST', SCRTCH,
     *   IER)
      WRITE (MSGTXT,1200) IER
      IF ((IER.GE.1).AND.(IER.LE.3)) GO TO 995
C                                       Set max. - min.
      CATR(KRDMX) = XMAX(1)
      CATR(KRDMN) = XMIN(1)
C                                       Update CATBLK
      CALL CATIO ('UPDT', DISOUT, FCNO(MAPNT), CATBLK, 'REST', SCRTCH,
     *   IER)
      WRITE (MSGTXT,1200) IER
      IF ((IER.GE.1).AND.(IER.LE.3)) GO TO 995
C                                       First map history.
      KCNO(1) = INCNO
      KCNO(2) = FCNO(MAPNT)
      KVOL(1) = DISIN
      KVOL(2) = DISOUT
C                                       Set spectral channel.
      ICH = NCH
      IF (MODE.GT.10) ICH = ICH + MAPNT - 3
      CALL MAPHIS (ICH, KCNO, KVOL, LUNH, FFRAC, IBUFF, PKR(1), BMAX)
C                                       Remove mark-for-destroy-on-fail
      FRW(MAPNT) = 0
C                                       Second map.
C                                       Get CATBLK
      IF (TWOMAP) THEN
         CALL CATIO ('READ', DISOUT, FCNO(MAPNT+1), CATBLK, 'REST',
     *      SCRTCH, IER)
         WRITE (MSGTXT,1200) IER
         IF ((IER.GE.1).AND.(IER.LE.3)) GO TO 995
C                                       Set max. - min.
         CATR(KRDMX) = XMAX(2)
         CATR(KRDMN) = XMIN(2)
C                                       Update CATBLK
         CALL CATIO ('UPDT', DISOUT, FCNO(MAPNT+1), CATBLK, 'REST',
     *      SCRTCH, IER)
         WRITE (MSGTXT,1200) IER
         IF ((IER.GE.1).AND.(IER.LE.3)) GO TO 995
C                                       Second map history.
         KCNO(2) = FCNO(MAPNT+1)
         IF ((MODE.GT.10) .AND. (MAPNT.GT.2)) ICH = ICH + 1
         CALL MAPHIS (ICH, KCNO, KVOL, LUNH, FFRAC, IBUFF, PKR(2), BMAX)
C                                       Remove destroy-on-failure flag
         FRW(MAPNT+1) = 0
         END IF
      GO TO 999
C                                       Error.
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('MAPOUT: TROUBLE OPENING GRID FILE, IER=',I3)
 1020 FORMAT ('MAPOUT: TROUBLE IN MINIT, IER=',I3)
 1070 FORMAT ('MAPOUT: READ ERROR WITH MDISK, IER=',I3)
 1080 FORMAT ('MAPOUT: WRITE ERROR WITH MDISK, IER=',I3)
 1140 FORMAT ('MAPOUT: TROUBLE CLOSING MAP FILE, IER=',I3)
 1160 FORMAT ('MAPOUT: TROUBLE CLOSING GRID FILE, IER=',I3)
 1200 FORMAT ('MAPOUT: CATIO ERROR ',I3)
 2002 FORMAT ('Peak R Flux = ',1PE10.3,' Jy.')
 2003 FORMAT ('Peak L Flux = ',1PE10.3,' Jy.')
 2004 FORMAT ('Peak I Flux = ',1PE10.3,' Jy.')
 2005 FORMAT ('Peak Q Flux = ',1PE10.3,' Jy.')
 2006 FORMAT ('Peak U Flux = ',1PE10.3,' Jy.')
 2007 FORMAT ('Peak V Flux = ',1PE10.3,' Jy.')
 2008 FORMAT ('Sum of weights =',1PE12.5)
      END
      SUBROUTINE MAPHIS (ICH, ICNO, VOL, LUN, FFRAC, BUFFER, PEAKFX,
     *   SUMWT)
C-----------------------------------------------------------------------
C   MAPHIS creates a history file for the map and enters the values
C   of the parameters controling the map and the name of the output
C   file.
C    Input:
C      ICH              I    Frequency channel number
C      ICNO(2)          I    Catalog slot numbers for maps.
C                            1 = Input(UV), 2 = output(MA).
C      VOL(2)           I    Volumn numbers for maps.
C      LUN(2)           I    LUN for history file I/O.
C      FFRAC            R    Frequency correction factor - 1
C      BUFFER(512)      I    Work buffer.
C      PEAKFX           R    Peak flux in map.
C      SUMWT            R    Sum of weights in the map
C   Input via Commons:
C      CATBLK(256)      I    Catalog header block for map
C      NX,NY            I    Map dimension (cells) RA and Dec.
C      XFLD,YFLD        R    Field of view (arcsec.) RA and Dec.
C      XSHIFT           R    Eastward shift of map center.(arcsec)
C      YSHIFT           R    Northward shift of map center.(arcsec)
C      TAPERU,TAPERV    R    Tapers in U and V
C      BLMIN,BLMAX      R    Max. and Min. UV values.
C      NATWT            I    = 1 for natural weighting, otherwise unif.
C      UNFBOX           I    Halfwidth of Unif. wt. smoothing box.
C      IZSP             I    = 1 if zero spacing flux density specified.
C      WTZSP            R    weight for zero spacing flux density.
C      ZSP(4)           R    Zero spacing flux densities(I,Q,U,V).
C      CTYPX,CTYPY      I    Convolving fn. type in RA and Dec.
C      CPARMX,CPARMY(10)R    Convolving fn. parameters.
C      NOGCOR           I    = 1 if no gridding correction to be made.
C      STOKES           C*4  Polarization maps requested,
C      FREQ             D    Frequency of observation (Hz).
C      NVIS             I    Number of visibility obs. used.
C      NCH              I    Number of first freq. chan. in this run
C      NUMCH            I    Number of frequency chan. in this run.
C      ICNTRY           I    Center pixel in Dec.
C    Output: One history file.
C-----------------------------------------------------------------------
      CHARACTER  XNAME*12, XCLASS*6, ATIME*8, ADATE*12, CHCONV(6)*8,
     *   HILINE*72, MTYPE*2
      INTEGER   ICNO(2), VOL(2), LUN(2), BUFFER(512), ICH, IERR, J
      INTEGER   TIME(3), DATE(3)
      LOGICAL   T
      REAL      FFRAC, PEAKFX, SUMWT, X, Y
      DOUBLE PRECISION DFRAC
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'UVMAP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA T /.TRUE./
      DATA CHCONV /'Pill box', 'Expontl ', 'Sinx / x',
     *             'Exp*Sinc', 'Spheroid', 'Bess*Exp'/
C-----------------------------------------------------------------------
C                                       copy keywords
      CALL KEYCOP (VOL(1), ICNO(1), VOL(2), ICNO(2), IERR)
C                                       Copy/open map file.
      CALL HISCOP (LUN(1), LUN(2), VOL(1), VOL(2), ICNO(1), ICNO(2),
     *   CATBLK, BUFFER(257), BUFFER, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       Get current time/date
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
C                                       Write first record.
      WRITE (HILINE,2000) TSKNAM, NLUSER, ADATE, ATIME
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Write mapname
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), XNAME)
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), XCLASS)
      CALL HENCOO (TSKNAM, XNAME, XCLASS, CATBLK(KIIMS),
     *   VOL(2), LUN(2), BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Source name.
      WRITE (HILINE,2001) TSKNAM, SOURCE
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Spectral channel
      WRITE (HILINE,2002) TSKNAM, ICH
      CALL HIADD (LUN(2),HILINE,BUFFER,IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Start and # of channels.
      WRITE (HILINE,2022) TSKNAM, NCH, NUMCH
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Map size.
      WRITE (HILINE,2005) TSKNAM, NX, NY
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Field of view
      WRITE (HILINE,2006) TSKNAM, XFLD, YFLD
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      X = XFLD / NX
      Y = YFLD / NY
      WRITE (HILINE,2106) TSKNAM, X, Y
      CALL HIADD (LUN(2),  HILINE,  BUFFER,  IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Frequency,polarization
      WRITE (HILINE,2007) TSKNAM, CATD(KDCRV+2), STOKES
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Translation
      WRITE (HILINE,2008) TSKNAM, XSHIFT, YSHIFT
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Taper
      WRITE (HILINE,2009) TSKNAM, TAPERU, TAPERV
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Annulus
      WRITE (HILINE,2010) TSKNAM, BLMIN, BLMAX
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Weighting,
      IF (NATWT.EQ.1) WRITE (HILINE,2011) TSKNAM
      IF (NATWT.NE.1) WRITE (HILINE,2012) TSKNAM, UNFBOX
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Zero spacing flux density
      IF (IZSP.EQ.1) THEN
         WRITE (HILINE,2013) TSKNAM, WTZSP
         CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 100
         WRITE (HILINE,2014) TSKNAM, ZSP
         CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
         IF (IERR.NE.0) GO TO 100
         END IF
C                                       Convolving function.
      WRITE (HILINE,2120) TSKNAM, CHCONV(CTYPX), CHCONV(CTYPY)
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,2015) TSKNAM, CTYPX, (CPARMX(J), J = 1,3)
      CALL HIADD (LUN(2), HILINE,  BUFFER,  IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,2016) TSKNAM, (CPARMX(J), J = 4,7)
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,2016) TSKNAM, (CPARMX(J), J = 8,10)
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,2017) TSKNAM, CTYPY, (CPARMY(J), J = 1,3)
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,2016) TSKNAM, (CPARMY(J), J = 4,7)
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,2016) TSKNAM, (CPARMY(J), J = 8,10)
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Gridding corrected?
      IF (NOGCOR.EQ.1) WRITE (HILINE,2018) TSKNAM
      IF (NOGCOR.NE.1) WRITE (HILINE,2019) TSKNAM
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Guard bands
      WRITE (HILINE,2030) TSKNAM, XGUARD
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Number of visibility pts. used.
      WRITE (HILINE,2020) TSKNAM, NVIS
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Peak flux density
      WRITE (HILINE,2023) TSKNAM, PEAKFX
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Frequency correction factor.
      DFRAC = 1.0D0 + FFRAC
      WRITE (HILINE,2021) TSKNAM, DFRAC
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Sum of griding weights
      WRITE (HILINE,2025) TSKNAM, SUMWT
      CALL HIADD (LUN(2), HILINE, BUFFER, IERR)
      IF (IERR.EQ.0) GO TO 200
C                                       An error occurred.
 100     WRITE (MSGTXT,1100) IERR
         CALL MSGWRT (6)
C                                       Close file.
 200  CALL HICLOS (LUN(2), T, BUFFER, IERR)
C                                       Clear write status.
      MTYPE = 'MA'
      CALL CATDIR ('CSTA', VOL(2), ICNO(2), XNAME, XCLASS,
     *   CATBLK(KIIMS), MTYPE, NLUSER, 'CLWR', SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MAPHIS: ERROR',I3,' CREATING HISTORY FILE')
 1100 FORMAT ('MAPHIS: ERROR',I3,' WRITING HISTORY FILE')
 2000 FORMAT (A6,'/ Map created by user ',I5,'  at ',A12,1X,A8)
 2001 FORMAT (A6,' SOURCE=''',A8,'''')
 2002 FORMAT (A6,' CHANNEL =',I4,' /Frequency channel')
 2005 FORMAT (A6,' IMSIZE=',I5,', ',I5,' /Image size')
 2006 FORMAT (A6,' MAPFLD=',E12.5,', ',E12.5,' /Field of view')
 2106 FORMAT (A6,' CELLSIZE=',E12.5,', ',E12.5,
     *   ' / Cell size arc sec.')
 2007 FORMAT (A6,' FREQ=',E14.7,' STOKES=''',A4,'''')
 2008 FORMAT (A6,' SHIFT=',F10.4,', ',F10.4)
 2009 FORMAT (A6,' UVTAPER=',E12.5,', ',E12.5,
     *   ' /UV taper kilolambda')
 2010 FORMAT (A6,' UVRANGE=',E12.5,', ',E12.5,
     *   ' /UV annulus kilolambda')
 2011 FORMAT (A6,' UVWTFN=''NA'' /Natural weighting')
 2012 FORMAT (A6,' UVWTFN=''  '' , UVBOX =',I5,' /Uniform weight')
 2013 FORMAT (A6,' WTZSP=',F10.2,' /Weight for 0 spacing flux')
 2014 FORMAT (A6,' ZEROSP=',F10.3,', ',F10.3,', ',F10.3,', ',F10.3)
 2015 FORMAT (A6,' XTYPE =',I3,' XPARM =',E12.5,', ',E12.5,', ',
     *   E12.5)
 2016 FORMAT (A6,' , ',E12.5,', ',E12.5,', ',E12.5,', ',E12.5)
 2017 FORMAT (A6,' YTYPE =',I3,' YPARM =',E12.5,', ',E12.5,', ',
     *   E12.5)
 2018 FORMAT (A6,' DOGRIDCR = -1 /No gridding correction')
 2019 FORMAT (A6,' DOGRIDCR = 1  /Gridding corrected')
 2020 FORMAT (A6,' /Number of vis. points used = ',I9)
 2021 FORMAT (A6,' /Frequency factor = ',1PD20.12)
 2022 FORMAT (A6,' CHANNEL1=',I4,' NOCH=',I4,
     *   ' /First and no. chan.')
 2023 FORMAT (A6,' /Peak in map =',1PE12.5,' Jy')
 2025 FORMAT (A6,' / Sum of gridding weights =',1PE12.5)
 2030 FORMAT (A6,' GUARD=',F7.4,',',F7.4,
     *   ' /U,V guard bands in UV-plane half widths')
 2120 FORMAT (A6,' /Convolution functions - U: ',A8,3X,
     *   'V: ',A8)
      END
      SUBROUTINE CONGRD (APCORE, NTYPE, ILOC, FFRAC, IER)
C-----------------------------------------------------------------------
C   CONGRD convolves uv data onto a grid using AP routines.
C   The visibilities are convolved onto the grid using the convolving
C   function specified by CTYPX,CTYPY,CPARMX,CPARMY.
C   The gridded data is phase rotated so that the map center comes out
C   at location ICNTRX,ICNTRY (set in a DATA statment).  If requested
C   a uv taper is applied to the visibility weights before gridding.
C   If NOSHFT is .FALSE. a three dimension phase reference position
C   shift is done in GRIDAP.
C   Zero spacing flux densities are gridded if provided.
C   For NTYPE = 1 the grid file, when transformed, will give the IPOL
C   and IBEM maps, NTYPE = 2 produces QPOL and UPOL maps , NTYPE = 3
C   results in a single map (VPOL or 1 line channel) and NTYPE=4
C   gives two line maps.
C   Output grid file in scratch file number ISCR(3).
C   Inputs:
C      NTYPE        I    Polarization type, 1 = IPOL,IBEM,
C                            2 = QPOL,UPOL, 3 = VPOL, 4=two line maps.
C      ILOC         I    Offset of first vis. record.
C      FFRAC        R    Factor - 1 to multiply by u,v,w
C   From commons:
C      NVIS         I    Number of visibility records
C      NX,NY        I    Dimension of map in RA, Dec (cells)
C      CTYPX,CTYPY  I    Convolving function types for RA and Dec
C      CPARMX(10)   R    Convolving function parameters for RA
C                        CPARMX(1) = support half width.
C      CPARMY(10)   R    Convolving function parameters for Dec.
C      IZSP         I    = 1 if zero spacing flux densities given.
C      WTZSP        R    Weight for zero spacing flux densities.
C      ZSP(4)       R    Zero spacing fluxes, I, Q, U, V (Jy)
C      ITAP         I    = 1 if taper requested
C      TAPERU,TAPERV R   TAPER ( to 30%) in u and v (kilolamda)
C      XFLD,YFLD    R    Field of view in RA and Dec (arcseconds)
C      NOSHFT       L    If .TRUE. apply no shift to position.
C      DXC,DYC,DZC  R    -2*pi*(delta ra, delta dec, and delta z)
C                        to be used in GRIDAP to shift positions.
C                        (u,v and w are in cells).
C      SCLU,SCLV,SCLW C*2 Conversion factors for u,v and w from
C                        wavelengths at the reference frequency
C                        to cells.
C      SCRVOL(10)   I    Volumn numbers of scratch files.
C                        1 = visibility file, 2 = grid file.
C      SCRCNO(10)   I    Catalog numbers of the scratch files.
C      APSIZ        R    Memory size of the AP in words.
C   Output:
C      IER          I    Return error code. 0=>OK, error otherwise.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   JBUFSZ, BLKOF, NNY2, JWIN(4), NTYPE,
     *   BIND1, BIND2, ILENBU, I, IBIND, IFACT, II, INCNT, INPTR, IU,
     *   JNPTR, LIM, NIO, NPOINT, NX2, ISCR2, IER, ILOC
      INTEGER   VO, BO, KAP, U, GRID, ROW, NUM, MO2, CY, CX, VIS, WT,
     *   END1, END2, NEXTRW, VVIS, NMOV, IDATA, ITEMP, UV, CINC,
     *   LLREC, NO2, M, LROW, TOLROW, TYP, TYPE, I4TMP, MAXREC, CNT
      LOGICAL   T, F, ENDROW
      CHARACTER PHNAME*48
      REAL      XTEMP(16), BUFF(1), UMIN, UMAX,
     *   RBUFF1(4096), RBUFF2(4096), TUC, TVC, XMAX, SSCLU,
     *   UU1, UU2, UU3, FFRAC
      DOUBLE PRECISION WX, WY, TWOPI, GFACT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'UVMAP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DAPM.INC'
      EQUIVALENCE (WROW, BUFF),  (RBUFF1, CBUF),  (RBUFF2, CBUF2)
      EQUIVALENCE (ISCR2, ISCR(2))
      DATA T, F /.TRUE.,.FALSE./
      DATA VO, BO, BLKOF, UV /0, 1, 1, 16/
C-----------------------------------------------------------------------
      IER = 0
      CINC = 100
      LLREC = LRECIN
      SSCLU = FFRAC * SCLU + SCLU
      GFACT = 1.0D0 / ((1.0D0 + FFRAC) * SCLU)
C                                       Set I/O length.
      ILENBU = 0
C                                       To simplify the map output
C                                       routine, shift the map center
C                                       here in the gridding routine.
C                                       ICNTRX and ICNTRY define the
C                                       pixel number of the map center,
C                                       counted from the front of the
C                                       file.
      TWOPI = 8D0 * ATAN(1D0)
      WX = (-TWOPI * (ICNTRX-1)) / NX
      WY = (-TWOPI * (ICNTRY-1)) / NY
C                                       Convert taper widths to
C                                       convenient constants.
      TUC = 0.0
      TVC = 0.0
      IF (ITAP.NE.0) THEN
         IF (TAPERU.GT.0.) TUC = LOG(.3) / (TAPERU * 1E3 /
     *      206265. * XFLD) ** 2
         IF (TAPERV.GT.0.) TVC = LOG(.3) / (TAPERV * 1E3 /
     *      206265. * YFLD) ** 2
         END IF
C                                       Open files. Use UVINIT and
C                                       UVDISK to read the
C                                       visibility file,
C                                       MINIT and MDISK to write the
C                                       grid file.
      CALL ZPHFIL ('SC', SCRVOL(UVSCR), SCRCNO(UVSCR), 1, PHNAME, IER)
      CALL ZOPEN (LUNS(1), INDS(1), SCRVOL(UVSCR), PHNAME, T, T, T, IER)
      IF (IER.GT.0) THEN
         WRITE (MSGTXT,1010) IER
         GO TO 995
         END IF
C                                       GRID file must be opened twice,
C                                       once for each half. Conjugate
C                                       points are written in the two
C                                       halves.
      CALL ZPHFIL ('SC', SCRVOL(ISCR2), SCRCNO(ISCR2), 1, PHNAME, IER)
      CALL ZOPEN (LUNS(2), INDS(2), SCRVOL(ISCR2), PHNAME, T, F, T, IER)
      IF (IER.GT.0) THEN
         WRITE (MSGTXT,1020) IER
         GO TO 995
         END IF
      CALL ZOPEN (LUNS(3), INDS(3), SCRVOL(ISCR2), PHNAME, T, F, T, IER)
      IF (IER.GT.0) THEN
         WRITE (MSGTXT,1020) IER
         GO TO 995
         END IF
      JBUFSZ = UVBFSS * 2
C                                       Init UV file.
      CALL UVINIT ('READ', LUNS(1), INDS(1), NVIS, VO, LRECIN, ILENBU,
     *   JBUFSZ, BUFF, BO, IBIND, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1040) IER
         GO TO 995
         END IF
C                                       Init GRID file (both halves).
      JBUFSZ = 4 * UVBFSS
      NNY2 = NY * 2
      JWIN(1) = 1
      JWIN(2) = NX/2
      JWIN(3) = NNY2
      JWIN(4) = 1
      CALL MINIT ('WRIT', LUNS(2), INDS(2), NNY2, NX, JWIN, RBUFF1,
     *   JBUFSZ, BLKOF, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1040) IER
         GO TO 995
         END IF
      JWIN(2) = NX / 2 + 1
      JWIN(4) = NX
      CALL MINIT ('WRIT', LUNS(3), INDS(3), NNY2, NX, JWIN, RBUFF2,
     *   JBUFSZ, BLKOF, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1040) IER
         GO TO 995
         END IF
C                                       Dummy 1st write (to make small
C                                       maps work).
      CALL MDISK ('WRIT', LUNS(3), INDS(3), RBUFF2, BIND2, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1160) IER
         GO TO 995
         END IF
      NX2 = NX / 2
C                                       Make sure an ODD number of rows
C                                       is being kept in the AP.
      NO2 = MAX (CPARMY(1), 1.0) + 0.1
      M = MAX (CPARMX(1), 1.0) + 0.1
      M = M * 2 + 1
      MO2 = M / 2
C                                       Setup for AP griding
C                                       Set AP pointers
      IFACT = 4
      GRID = APSIZ + 0.5
      I4TMP = M * IFACT
      GRID = GRID - I4TMP * NY - 1
      I4TMP = IFACT * (M - 1)
      ROW = GRID + I4TMP * NY
      NEXTRW = NY
      NEXTRW = ROW + 2 * NEXTRW
      CALL QINIT (APCORE, 0, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
         MSGTXT = 'CONGRD: UNABLE TO GET AP MEMORY BACK'
         CALL MSGWRT (8)
         IER = 8
         GO TO 995
         END IF
      NUM = NY
      NUM = IFACT * NUM * M
      CALL QVCLR (APCORE, GRID, 1, NUM)
      CY = 2 * NO2 + 1
      CY = GRID - 100 * CY - 1
      CX = CY - 100 * M - 1
      VIS = UV + 4 + (ILOC - 1) * 2
      WT = UV + 3
C                                       Set other AP values.
      LROW = NY
      TOLROW = 2 * NY
      TYPE = NTYPE
C                                       TYP negative  = > apply taper.
      TYP = NTYPE
      IF (NTYPE.EQ.4) TYP = 2
      IF (ITAP.GT.0) TYP = -TYP
C                                       Set gridding convolution tables
      CALL CONVFN (APCORE, CX, CTYPX, CPARMX, CBUF)
      CALL CONVFN (APCORE, CY, CTYPY, CPARMY, CBUF)
C                                       Set constants in AP.
      XTEMP(1) = COS ((NX / 2 - 1) * WX)
      XTEMP(2) = SIN ((NX / 2 - 1) * WX)
      XTEMP(3) = COS (WY)
      XTEMP(4) = SIN (WY)
      XTEMP(5) = COS (-WX)
      XTEMP(6) = SIN (-WX)
      XTEMP(7) = 1.0
      XTEMP(8) = 0.0
      XTEMP(9) = TUC
      XTEMP(10) = TVC
      XTEMP(11) = FFRAC*SCLU + SCLU
      XTEMP(12) = FFRAC*SCLV + SCLV
      XTEMP(13) = FFRAC*SCLW + SCLW
      XTEMP(14) = DXC / SCLU
      XTEMP(15) = DYC / SCLV
      XTEMP(16) = DZC / SCLW
      CALL QPUT (APCORE, XTEMP, 0, 16, 2)
C                                       Determine the maximum number
C                                       of visibility points which
C                                       fit in the AP.
      MAXREC = (CX - 16) / LRECIN - 5
C                                       Be sure MAXREC.GT.0
      IF (MAXREC.LE.0) THEN
         XMAX = - MAXREC * LRECIN
         WRITE (MSGTXT,1070) XMAX
         IER = 1
         GO TO 995
         END IF
      END1 = ROW - 1
      END2 = NY
      END2 = END1 + END2 * IFACT
      NMOV = IFACT * (M - 1)
      NMOV = NMOV * NY
C                                       Read first visibility record
      CALL UVDISK ('READ', LUNS(1), INDS(1), BUFF, NIO, IBIND, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1080) IER
         GO TO 995
         END IF
      INPTR = IBIND
      INCNT = 1
C                                       Loop through grid
      DO 200 I = 1,NX2
         IU = NX2 - I
         UMIN = (IU - 0.5) * GFACT
         UMAX = (IU + 0.5) * GFACT
         IDATA = UV
         CNT = 0
C                                       Return to here if more than one
C                                       record is loaded at a time.
  100    ENDROW = T
         NPOINT = 0
C                                       Check if all data read.
         IF (NIO.LE.0) GO TO 140
C                                       Make sure there is some data on
C                                       this row.
         IF (BUFF(INPTR).LT.UMIN) GO TO 140
C                                       Check if end of row occures in
C                                       this record.
         LIM = INCNT + MAXREC - CNT - 1
         LIM = MIN (LIM, NIO)
         JNPTR = INPTR
C                                       Check for missorted data.
         DO 110 II = INCNT,LIM
            IF (BUFF(JNPTR).LT.UMIN) GO TO 120
               IF (BUFF(JNPTR).GT.UMAX) THEN
                   UU1 = BUFF(JNPTR) * SSCLU
                   UU2 = UMIN * SSCLU
                   UU3 = UMAX * SSCLU
                   WRITE (MSGTXT,1100) UU1,UU2,UU3
                   CALL MSGWRT (1)
                   END IF
               NPOINT = NPOINT + 1
               JNPTR = JNPTR + LRECIN
 110           CONTINUE
C                                       Rest of record is on same row.
         ENDROW = F
 120     CONTINUE
         CNT = CNT + NPOINT
C                                       Load into AP.
         CALL QWR
         ITEMP = NPOINT * LRECIN
         CALL QPUT (APCORE, BUFF(INPTR), IDATA, ITEMP, 2)
         IDATA = IDATA + ITEMP
         INCNT = INCNT + NPOINT
         INPTR = INPTR + NPOINT * LRECIN
C                                       Check if AP full or row finished
         IF ((ENDROW) .OR. (CNT.GE.MAXREC)) GO TO 140
C                                       Read next record.
  125    INCNT = 1
C                                       Check if all records read.
         IF (NIO.LE.0) THEN
            ENDROW = T
C                                       Read again and Loop back
         ELSE
            CALL UVDISK ('READ', LUNS(1), INDS(1), BUFF, NIO, IBIND,
     *         IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,1130) IER
               GO TO 995
               END IF
            INPTR = IBIND
            GO TO 100
            END IF
C                                       Grid data
 140     IF (CNT.GT.0)  THEN
            CALL QWAIT
            ITEMP = - CNT
            IF (.NOT.NOSHFT) ITEMP = - ITEMP
            CALL QGRIDA (APCORE, UV ,VIS, WT, LLREC, GRID, CY, CX, CINC,
     *         NO2, M, LROW, ITEMP, TYP)
            CALL QWR
            IDATA = UV
            CNT = 0
C                                       Check if row finished.
            IF (INCNT.LT.NIO) GO TO 100
            IF (.NOT.ENDROW) GO TO 125
            END IF
C                                       Row finished, process.
         U = IU + M / 2
C                                       Do not write rows before the
C                                       start of the grid file.
         IF (U.LT.NX2) THEN
            CALL QWAIT
            CALL QFINGR (APCORE, U, ROW, MO2, LROW, TYPE)
C                                       Writes
            CALL MDISK ('WRIT', LUNS(2), INDS(2), RBUFF1, BIND1, IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,1160) IER, I
               GO TO 995
               END IF
            CALL MDISK ('WRIT', LUNS(3), INDS(3), RBUFF2, BIND2, IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,1160) IER, I
               GO TO 995
               END IF
            CALL QWAIT
C                                       Read out gridded data.
            CALL QGET (APCORE, RBUFF1(BIND1), ROW, TOLROW, 2)
            CALL QGET (APCORE, RBUFF2(BIND2), NEXTRW, TOLROW, 2)
            CALL QWAIT
            END IF
C                                       Prepare AP for next row.
         IF (IU.NE.0) CALL QVMOV(APCORE, END1, -1, END2, -1, NMOV)
         CALL QWAIT
         ITEMP = NY
         ITEMP = ITEMP * IFACT
         IF (IU.NE.0) CALL QVCLR (APCORE, GRID, 1, ITEMP)
         IF (U.GE.NX2) GO TO 200
 200     CONTINUE
C                                       Do zero spacing flux densities
      IF (IZSP.EQ.1) THEN
         IF (NTYPE.EQ.1) VVIS = UV + 4
         IF (NTYPE.EQ.2) VVIS = UV + 6
         IF (NTYPE.EQ.3) VVIS = UV + 10
         IF (NTYPE.EQ.4) VVIS = UV + 4
         XTEMP(1) = 0.0
         XTEMP(2) = 0.0
         XTEMP(3) = 0.0
         XTEMP(4) = WTZSP
         XTEMP(5) = ZSP(1)
         XTEMP(6) = 0.0
         XTEMP(7) = ZSP(2)
         XTEMP(8) = 0.0
         XTEMP(9) = ZSP(3)
         XTEMP(10) = 0
         XTEMP(11) = ZSP(4)
         XTEMP(12) = 0.0
         CALL QWAIT
         CALL QPUT (APCORE, XTEMP, UV, 12, 2)
         ITEMP = -1
         IF (.NOT.NOSHFT) ITEMP = 1
         CALL QWAIT
         CALL QGRIDA (APCORE, UV, VVIS, WT, LLREC, GRID, CY, CX, CINC,
     *      NO2, M, LROW, ITEMP, TYP)
         CALL QWAIT
         END IF
C                                       Finish reading out grid
      LIM = M / 2
      DO 300 I = 1,LIM
         U = LIM - I
         ROW = IFACT * (M - I - 1)
         ROW = GRID + ROW * NY
         NEXTRW = NY
         NEXTRW = ROW + 2 * NEXTRW
C                                       Grid row.
         CALL QWAIT
         CALL QFINGR (APCORE, U, ROW, MO2, LROW, TYPE)
C                                       Writes
         CALL MDISK ('WRIT', LUNS(2), INDS(2), RBUFF1, BIND1, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1160) IER, I
            GO TO 995
            END IF
C                                       Last conjugate row goes to grid
C                                       row NX/2+1.
         IF (U.EQ.0) THEN
C                                       Flush and re-init output #2.
            CALL MDISK ('FINI', LUNS(3), INDS(3), RBUFF2, BIND2, IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,1160) IER, I
               GO TO 995
               END IF
            JWIN(2) = NX / 2 + 1
            JWIN(4) = NX
            CALL MINIT ('WRIT', LUNS(3), INDS(3), NNY2, NX, JWIN,
     *         RBUFF2, JBUFSZ, BLKOF, IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,1040) IER
               GO TO 995
               END IF
            END IF
         CALL MDISK ('WRIT', LUNS(3), INDS(3), RBUFF2, BIND2, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1160) IER, I
            GO TO 995
            END IF
C                                       Zero extra row if U = 0.
         CALL QWAIT
         IF (U.EQ.0) CALL QVCLR (APCORE, NEXTRW, 1, TOLROW)
         CALL QWAIT
         CALL QGET (APCORE, RBUFF1(BIND1), ROW, TOLROW, 2)
         CALL QGET (APCORE, RBUFF2(BIND2), NEXTRW, TOLROW, 2)
         CALL QWAIT
 300     CONTINUE
      CALL QRLSE
C                                       Finish writes
      CALL MDISK ('FINI', LUNS(2), INDS(2), RBUFF1, BIND1, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1160) IER, I
         GO TO 995
         END IF
      CALL MDISK ('FINI', LUNS(3), INDS(3), RBUFF2, BIND2, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1160) IER, I
         GO TO 995
         END IF
C                                       Close files
      DO 350 I = 1,3
         CALL ZCLOSE(LUNS(I), INDS(I), IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1350) IER
            GO TO 995
            END IF
 350     CONTINUE
      GO TO 999
C                                       Error
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('CONGRD: TROUBLE OPENING UV DATA FILE, IER=',I3)
 1020 FORMAT ('CONGRD: TROUBLE OPENING GRID FILE, IER=',I3)
 1040 FORMAT ('CONGRD: TROUBLE IN MINIT, IER=',I3)
 1070 FORMAT ('CONGRD: ',F8.0,' TOO FEW AP WORDS AVAILABLE')
 1080 FORMAT ('CONGRD: READ ERROR IN VISIBILITY FILE, IER=',I3)
 1100 FORMAT ('IU=',F9.3,' NOT IN RANGE ',2F9.3,',DATA MISSORTED')
 1130 FORMAT ('CONGRD: ERROR',I3,' READING VIS. RECORD ')
 1160 FORMAT ('CONGRD: ERROR',I3,' WRITING GRID ROW ',I5)
 1350 FORMAT ('CONGRD: TROUBLE CLOSING FILE, IER=',I3)
      END
      SUBROUTINE UNIF (APCORE, FFRAC, IER)
C-----------------------------------------------------------------------
C   UNIF computes uniform weighting corrections and applies them to
C   the weights in the visibility data base.  The visibility weights
C   are divided by the number of visibilities occuring in cells within
C   a box of half width UNFBOX centered on the cell in which a given
C   visibility resides.
C   Inputs:
C      FFRAC       R    u,v,w frequency correction factor -1.0
C      SCLU,SCLV   C*2  u and v scaling to cells at ref. frequency.
C      NX,NY       I    Dimensions ( cells) of the map in RA and Dec
C      LUNS(5)     I    Logical unit numbers of the scratch files
C                       1 = visibility
C                       2 = Grid, used to store counts.
C      SCRVOL(5)   I    Volumn numbers of the scratch files.
C      SCRCNO(5)   I    Catalog numbers of the scratch files.
C      UNFBOX      I    Half width of unif. wt. counting box size.
C      NVIS        I    Number of visibility measurments.
C   Also the visibility data.
C   Output:
C      IER         I    Return error code, 0=>OK, error otherwise.
C   Also the visibility data with weights uniform weighted.
C-----------------------------------------------------------------------
      DOUBLE PRECISION APCORE(*)
      INTEGER   IER, BLKOF, WIN(4), I, II,
     *   IBIND, JBIND, KBIND, OPTR, U, JBUFSZ, KBUFSZ,
     *   HALFNX, ILENBU, INCNT, IU, J, JNPTR, KROW, LIM, ISCR1, INIO,
     *   LIMIT, NIO, NIOUT, NPOINT, NX2, NY2, NY1, INDEX, INPTR
      INTEGER   BO, VO, AMAX, AMIN, GRID, ROW, NROW, ROW2, IV,
     *   END1, END2, END3, WMAX, NMOV, IROW, WMIN, NUM, IDATA,
     *   KTEMP, LLREC, JNY, ITEMP, APSCLV, KAP, MAXREC, CNT, UV
      LOGICAL   T, F, ENDROW
      CHARACTER PHNAME*48
      REAL      TEMP(10), XMAX, SSCLV, SSCLU,
     *   BUFF(1), OBUFF(1), BUFF2(4096), UMIN, FFRAC
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'UVMAP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DAPM.INC'
      EQUIVALENCE (CBUF,BUFF), (OBUFF,CBUF2), (BUFF2,WROW)
      EQUIVALENCE (ISCR1, ISCR(1))
      DATA T, F/.TRUE.,.FALSE./
      DATA WIN, UV /4*0, 10/
      DATA BO, VO /1, 0/
      DATA BLKOF /1/
C-----------------------------------------------------------------------
      NY1 = NY - 1
      JNY = NY
      HALFNX = NX / 2
      ILENBU = 0
      LLREC = LRECIN
C                                       Prepare for reads and writes.
C                                       Open visibility and grid files.
C                                       Open visibility file.
      CALL ZPHFIL ('SC', SCRVOL(UVSCR), SCRCNO(UVSCR), 1, PHNAME, IER)
      CALL ZOPEN (LUNS(1), INDS(1), SCRVOL(UVSCR), PHNAME, T, F, T, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1020) IER
         GO TO 995
         END IF
C                                       Open grid file.
      CALL ZPHFIL ('SC', SCRVOL(ISCR1), SCRCNO(ISCR1), 1, PHNAME, IER)
      CALL ZOPEN (LUNS(2), INDS(2), SCRVOL(ISCR1), PHNAME, T, T, T, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1030) IER
         GO TO 995
         END IF
C                                       Init files.
      KBUFSZ = UVBFSS * 4
      JBUFSZ = UVBFSS * 2
C                                       Init. vis file.
      CALL UVINIT ('READ', LUNS(1), INDS(1), NVIS, VO, LRECIN, ILENBU,
     *   KBUFSZ, BUFF, BO, IBIND, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1040) IER
         GO TO 995
         END IF
C                                       Init. grid file.
      CALL MINIT ('WRIT', LUNS(2), INDS(2), NY, HALFNX, WIN, BUFF2,
     *   JBUFSZ, BLKOF, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1050) IER
         GO TO 995
         END IF
C                                       Load AP values
C                                       Maximum v.
      AMAX = 0
      TEMP(1) = NY / 2 - 1
C                                       Minimum v.
      AMIN = 1
      TEMP(2) = - NY / 2
C                                       Minimum count.
      WMIN = 2
      TEMP(3) = 1.0
C                                       Maximum count (to avoid I
C                                       problems)
      WMAX = 3
      TEMP(4) = 1.0E20
      IV = UV + 1
C                                       Scaling factors for u, v
C                                       to cells.
      APSCLV = 4
      TEMP(5) = SCLV + FFRAC * SCLV
      SSCLV = SCLV + FFRAC * SCLV
      SSCLU = 1.0 / (SCLU + FFRAC * SCLU)
C                                       Grab AP.
      CALL QINIT (APCORE, 0, 0, KAP)
      IF ((KAP.EQ.0) .OR. (PSAPNW.LE.0)) THEN
         MSGTXT = 'UNIF: UNABLE TO GET AP MEMORY BACK'
         CALL MSGWRT (8)
         IER = 8
         GO TO 995
         END IF
      CALL QPUT (APCORE, TEMP, 0, 10, 2)
      CALL QWD
C                                       Set pointers for AP
      NROW = 2 * UNFBOX + 1
      GRID = (APSIZ - 1) - NROW * NY
C                                       Set pointer for temporary row
      ROW = GRID - NY
C                                       Set pointers for output buffer
      ROW2 = ROW - NY
      END1 = ROW2 + NY - 1
C                                       Set pointer for shifting grid
      END2 = GRID + NROW * NY
      END3 = END2 - NY
C                                      Determine no. points to shift.
      NMOV = (NROW - 1) * NY
C                                       Clear AP
      NUM = NROW * NY
      CALL QVCLR (APCORE, GRID, 1, NUM)
      CALL QWR
      CALL QWD
C                                       Determine max. no. of vis.
C                                       points which will fit in AP.
      MAXREC = (ROW2 - 10) / LRECIN - 5
C                                       Make sure MAXREC.GT.0
      IF (MAXREC.LE.0) THEN
         XMAX = - MAXREC * LRECIN
         WRITE (MSGTXT,1060) XMAX
         IER = 1
         GO TO 995
         END IF
C                                       Read first visibility record.
      INCNT = 1
      CALL UVDISK ('READ', LUNS(1), INDS(1), BUFF, NIO, IBIND, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1070) IER
         GO TO 995
         END IF
      INPTR = IBIND
      NX2 = NX / 2
      NY2 = NY / 2
C                                       Begin counting loop.
      DO 200 I = 1,NX2
         IU = NX2 - I
         UMIN = (IU - 0.5) * SSCLU
         IDATA = UV
         CNT = 0
C                                       Return to here if more than one
C                                       record is loaded at a time.
  100    ENDROW = T
         NPOINT = 0
C                                       Check if all data read.
      IF (NIO.LE.0) GO TO 140
C                                       Make sure there is some data on
C                                       this row.
         IF (BUFF(INPTR).LT.UMIN) GO TO 140
C                                       Check if end of row occures in
C                                       this record.
         LIM = INCNT + MAXREC - CNT - 1
         LIM = MIN (LIM, NIO)
         JNPTR = INPTR
         DO 110 II = INCNT,LIM
            IF (BUFF(JNPTR).LT.UMIN) GO TO 120
               NPOINT = NPOINT + 1
               JNPTR = JNPTR + LRECIN
  110          CONTINUE
C                                       Rest of record is on same row.
         ENDROW = F
  120    CONTINUE
         CNT = CNT + NPOINT
C                                       Load into AP.
         CALL QWR
         KTEMP = NPOINT * LRECIN
         CALL QPUT (APCORE, BUFF(INPTR), IDATA, KTEMP, 2)
         IDATA = IDATA + KTEMP
         INPTR = INPTR + NPOINT * LRECIN
         INCNT = INCNT + NPOINT
C                                       Check if AP full or row finished
         IF ((ENDROW) .OR. (CNT.GE.MAXREC)) GO TO 140
C                                       Read next record.
  125    INCNT = 1
C                                       Check if all records read.
         IF (NIO.LE.0) ENDROW = T
         IF (NIO.LE.0) GO TO 140
            CALL UVDISK ('READ', LUNS(1), INDS(1), BUFF, NIO, IBIND,
     *         IER)
            IF (IER.NE.0) THEN
               WRITE (MSGTXT,1070) IER
               GO TO 995
               END IF
            INPTR = IBIND
C                                       Loop back
            GO TO 100
  140       CONTINUE
C                                       Grid data
         IF (CNT.LE.0) GO TO 145
         CALL QWD
C                                       Use HIST for counting.
C                                       Scale v to cells.
         CALL QVSMUL (APCORE, IV, LLREC, APSCLV, IV, LLREC, CNT)
         CALL QHIST (APCORE, IV, LLREC, GRID, CNT, JNY, AMAX, AMIN)
         IDATA = UV
         CNT = 0
C                                       Check if row finished.
         IF (ENDROW) GO TO 145
         IF (INCNT.LT.NIO) GO TO 100
         GO TO 125
C                                       Row finished, process.
  145    CONTINUE
         U = IU + NROW / 2
C                                       If U = 0 conjugate row.
         IF (U.EQ.0) THEN
            KTEMP = GRID + 1
            ITEMP = NY - 1
            CALL QVMOV (APCORE, KTEMP, 1, END1, -1, ITEMP)
            CALL QVMOV (APCORE, GRID, 1, ROW2, 1, 1)
            CALL QVADD (APCORE, GRID, 1, ROW2, 1, GRID, 1, JNY)
            END IF
C                                       Do not write rows before the
C                                       start of the grid file.
         IF (U.GE.NX2) GO TO 180
C                                       Sum rows.
         CALL MDISK ('WRIT', LUNS(2), INDS(2), BUFF2, JBIND, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1160) IER, I
            GO TO 995
            END IF
         CALL QVMOV (APCORE, GRID, 1, ROW, 1, JNY)
         IF (UNFBOX.GT.0) THEN
            LIMIT = NROW
            DO 160 J = 2,LIMIT
               IROW = GRID + JNY * (J-1)
               CALL QVADD (APCORE, IROW, 1, ROW, 1, ROW, 1, JNY)
 160           CONTINUE
            END IF
C                                       Boxsum sum of rows.
         CALL QBOXSU (APCORE, ROW, 1, NROW, ROW2, 1, JNY)
C                                       Make sure values reasonable.
         CALL QVCLIP (APCORE, ROW2, 1, WMIN, WMAX, ROW2, 1, JNY)
C                                       Read out row.
         CALL QWR
         CALL QGET (APCORE, BUFF2(JBIND), ROW2, JNY, 2)
         CALL QWD
C                                       Check if last row.
         IF (I.EQ.NX2) GO TO 200
C                                       Prepare AP for next row.
  180       CALL QVMOV (APCORE, END3, -1, END2, -1, NMOV)
            CALL QVCLR (APCORE, GRID, 1, JNY)
  200    CONTINUE
      IF (UNFBOX.LE.0) GO TO 305
C                                       Finish reading out grid
      DO 300 I = 1,UNFBOX
         CALL MDISK ('WRIT', LUNS(2), INDS(2), BUFF2, JBIND, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1160) IER, I
            GO TO 995
            END IF
C                                       Add conjugate to next row.
         IROW = GRID + JNY * I
         KTEMP = IROW + 1
         ITEMP = NY - 1
         CALL QVMOV (APCORE, KTEMP, 1, END1, -1, ITEMP)
         CALL QVMOV (APCORE, IROW, 1, ROW2, 1, 1)
         CALL QVADD (APCORE, IROW, 1, ROW2, 1, IROW, 1, JNY)
C                                       Sum rows.
         CALL QVMOV (APCORE, GRID, 1, ROW, 1, JNY)
         LIMIT = NROW - I
         DO 210 J = 2,LIMIT
            IROW = GRID + JNY * (J-1)
            CALL QVADD (APCORE, IROW, 1, ROW, 1, ROW, 1, JNY)
  210       CONTINUE
C                                       Boxsum sum of rows.
         CALL QBOXSU (APCORE, ROW, 1, NROW, ROW2, 1, JNY)
C                                       Make sure values reasonable.
         CALL QVCLIP (APCORE, ROW2, 1, WMIN, WMAX, ROW2, 1, JNY)
C                                       Read row back out.
         CALL QWR
         CALL QGET (APCORE, BUFF2(JBIND), ROW2, JNY, 2)
         CALL QWD
  300    CONTINUE
  305 CONTINUE
C                                       Finish write
      CALL MDISK ('FINI', LUNS(2), INDS(2), BUFF2, JBIND, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1160) IER, I
         GO TO 995
         END IF
      CALL QRLSE
C
C                                       Apply corrections.
C
C                                       Open visibility file for writing
      CALL ZPHFIL ('SC', SCRVOL(UVSCR), SCRCNO(UVSCR), 1, PHNAME, IER)
      CALL ZOPEN (LUNS(3), INDS(3), SCRVOL(UVSCR), PHNAME, T, F, T, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1320) IER
         GO TO 995
         END IF
C                                       Initialize vis. file for read.
      CALL UVINIT ('READ', LUNS(1), INDS(1), NVIS, VO, LRECIN, ILENBU,
     *   KBUFSZ, BUFF, BO, IBIND, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1040) IER
         GO TO 995
         END IF
C                                       Initialize vis. file for write.
      CALL UVINIT ('WRIT', LUNS(3), INDS(3), NVIS, VO, LRECIN, ILENBU,
     *   KBUFSZ, OBUFF, BO, KBIND, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1340) IER
         GO TO 995
         END IF
      OPTR = KBIND
C                                       Initialize grid file for read.
      CALL MINIT ('READ', LUNS(2), INDS(2), NY, HALFNX, WIN, BUFF2,
     *   JBUFSZ, BLKOF, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1050) IER
         GO TO 995
         END IF
C                                       Read first row of grid.
      KROW = NX / 2 - 1
      CALL MDISK ('READ', LUNS(2), INDS(2), BUFF2, JBIND, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1360) IER, KROW
         GO TO 995
         END IF
      UMIN = (KROW - 0.5) * SSCLU
C                                       Begin weighting loop.
  400 CONTINUE
C                                       Read vis record.
      CALL UVDISK ('READ', LUNS(1),INDS(1), BUFF, INIO, IBIND, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1070) IER
         GO TO 995
         END IF
      INPTR = IBIND
C                                       Loop thru record.
      IF (INIO.LE.0) GO TO 510
      DO 500 I = 1,INIO
C                                       Copy vis.
         DO 420 J = 1,LRECIN
            OBUFF(OPTR+J-1) = BUFF(INPTR+J-1)
  420       CONTINUE
C                                       See if new grid row needed,
C                                       if so find next grid row.
  430    IF (OBUFF(OPTR).GE.UMIN) GO TO 450
C                                       Read next grid row.
         KROW = KROW - 1
C                                       Check if gone too far.
         IF (KROW.LT.0) THEN
            WRITE (MSGTXT,1435) KROW
            CALL MSGWRT (7)
            GO TO 450
            END IF
         CALL MDISK ('READ', LUNS(2), INDS(2), BUFF2, JBIND, IER)
         IF (IER.NE.0) THEN
            WRITE (MSGTXT,1360) IER, KROW
            GO TO 995
            END IF
         UMIN = (KROW - 0.5) * SSCLU
C                                       Check if this row desired.
         GO TO 430
  450    CONTINUE
C                                       Apply natural weight correction
C                                       to weight.
         INDEX = OBUFF(OPTR+1) * SSCLV + NY2 + 0.5
         INDEX = MIN (INDEX, NY1)
         OBUFF(OPTR+3) = OBUFF(OPTR+3) / BUFF2(INDEX+JBIND)
         OPTR = OPTR + LRECIN
         INPTR = INPTR + LRECIN
  500    CONTINUE
C                                      Write
      NIOUT = INIO
      CALL UVDISK ('WRIT', LUNS(3), INDS(3), OBUFF, NIOUT, KBIND, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1505) IER
         GO TO 995
         END IF
      OPTR = KBIND
C                                       loop back.
      GO TO 400
C                                       Finish write.
 510  CONTINUE
      NIOUT = 0
      CALL UVDISK ('FLSH', LUNS(3), INDS(3), OBUFF, NIOUT, KBIND, IER)
      IF (IER.NE.0) THEN
         WRITE (MSGTXT,1505) IER
         GO TO 995
         END IF
C                                       Close files.
      CALL ZCLOSE (LUNS(1), INDS(1), IER)
      CALL ZCLOSE (LUNS(2), INDS(2), IER)
      CALL ZCLOSE (LUNS(3), INDS(3), IER)
      GO TO 999
C                                       Error
 995  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('UNIF: ERROR',I3,' OPENING VISIBILITY FILE')
 1030 FORMAT ('UNIF: ERROR',I3,' OPENING GRID FILE FOR WRITE')
 1040 FORMAT ('UNIF: ERROR',I3,' INIT. VIS. FILE FOR READ')
 1050 FORMAT ('UNIF: ERROR',I3,' INIT GRID FILE FOR WRITE')
 1060 FORMAT ('UNIF:',F8.0,' TOO FEW AP WORDS AVAILABLE')
 1070 FORMAT ('UNIF: ERROR',I3,' READING VIS RECORD')
 1160 FORMAT ('UNIF: ERROR',I3,' WRITING GRID ROW',I5)
 1320 FORMAT ('UNIF: ERROR',I3,' OPEN-FOR-WRITE VIS. FILE.')
 1340 FORMAT ('UNIF: ERROR',I3,' INIT.-FOR-WRITE VIS. FILE')
 1360 FORMAT ('UNIF: ERROR',I3,' READING GRID ROW',I5)
 1435 FORMAT ('UNIF: ATTEMPTED TO READ ROW',I6)
 1505 FORMAT ('UNIF: ERROR',I3,' WRITING VIS. RECORD')
      END

      SUBROUTINE AUB (BRANCH)
C-----------------------------------------------------------------------
C! verbs to prepare, edit, and review batch jobs and queues
C# POPS-appl Batch
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2010, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AUB performs batch preparation operations
C   BRANCH = 1  BATCH     read input to build batch work file
C            2  BATEDIT   read input to insert in batch work file
C            3  UNQUE     deque job, move back to work file
C            4  BATCLEAR  initialize batch work file
C            5  BATLIST   list part of batch work file
C            6  QUEUE     list contents of job queue
C            7  JOBLIST   list part of submitted (inactive) job
C            8  BAMODIFY  Change text of one line of batch work file
C   Adverbs used: BATQUE    queue number (BRANCH = 1 - 6)
C                 JOBNUM    job number   (         3, 7)
C                 BATFLINE  first line # (         2, 5, 7)
C                 BATNLINE  # of lines   (         5, 7)
C-----------------------------------------------------------------------
      INTEGER    BRANCH
C
      CHARACTER PRGNAM*6, PHNAME*48, STATUS*8, ATIME*8, ADATE*12, LPT*1,
     *    TEMP*100, QUEUED*8, RUNING*8, SUBMIT*8, DONE*8, FAILED*8,
     *    BVERS(5)*4, HOLD*1, INSRT*1, DELETE*1, SPACE*1, ICHAR*1,
     *    CDUM*1, RHOST*24, FILE*64
      INTEGER    POTERR, IQ, IERR, J, JB, IW, IL, IPX, IM, LINE, IT0(6),
     *   IER2, IT(6), LINES, NLPR, I, NWPL, MSGLUN, INP, KOP, JQ, J1,
     *   LBYTES, MSGIND, LIUNIT, ITEMP, NCHCPY, IREC, LREC, JTRIM, J2,
     *   IDUM, LBATQS
      REAL      EPS, RLINE, RDUM
      DOUBLE PRECISION JD0, JD1
      LOGICAL   T, F, INSERT, INSIGN, BATOPN, BWTOPN
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DIO.INC'
      INCLUDE 'INCS:DBAT.INC'
      INTEGER   BWTBUF(256)
      INCLUDE 'INCS:DBWT.INC'
      DATA PRGNAM /'AUB '/
      DATA T, F /.TRUE.,.FALSE./
      DATA QUEUED, RUNING, SUBMIT, DONE, FAILED /'WAITING ',
     *   'RUNNING ','CHECKING','FINISHED','FAILED  '/
      DATA BVERS /'OLD ','NEW ','TST ','CVX ','??? '/
      DATA EPS /0.01/
      DATA MSGLUN, HOLD, INSRT, SPACE, DELETE /6, '?', '_', '@','$'/
C-----------------------------------------------------------------------
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.8)) GO TO 999
      BWTLUN = 26
      BATLUN = 4
      BWTOPN = .FALSE.
      BATOPN = .FALSE.
      NWPL = 2 + (NCHLIN + 3) / 4
      NLPR = 252 / NWPL
C                                        test input
      POTERR = 32
      CALL ADVERB ('BATQUE', 'I', 1, 0, IQ, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IF ((BRANCH.EQ.3) .OR. (BRANCH.EQ.6) .OR. (BRANCH.EQ.7)) THEN
         CALL ADVERB ('REMHOST', 'C', 1, 24, IDUM, RDUM, RHOST)
         IF (ERRNUM.NE.0) GO TO 980
      ELSE
         RHOST = ' '
         END IF
      IF ((BRANCH.NE.6) .AND. (BRANCH.NE.7)) THEN
         IF ((IQ.LT.1) .OR. (IQ.GT.NBATQS)) THEN
            WRITE (MSGTXT,1000) IQ, NBATQS
            CALL MSGWRT (7)
            GO TO 980
            END IF
         END IF
C
      LBATQS = NBATQS
      IF (RHOST.NE.' ') LBATQS = 33
      CALL ADVERB ('JOBNUM', 'I', 1, 0, J, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      JQ = J / 100
      JB = MOD (J, 100)
      IF (BRANCH.EQ.6) JQ = IQ
C                                        open Queue file
      IF ((BRANCH.EQ.3) .OR. (BRANCH.EQ.6) .OR. (BRANCH.EQ.7)) THEN
         CALL ZPHFIL ('BQ', 1, 0, 0, PHNAME, IERR)
         J = JTRIM (RHOST)
C                                       local
         IF (J.EQ.0) THEN
            FILE = PHNAME
C                                       remote at this location
         ELSE
            FILE = 'NET0:' // RHOST(:J) // '/' // PHNAME(6:)
            END IF
         CALL ZEXIST (1, FILE, LBATQS, IERR)
         IF (IERR.NE.0) GO TO 960
         CALL ZOPEN (BATLUN, BATIND, 1, FILE, F, T, T, IERR)
         IF (IERR.NE.0) GO TO 960
         BATOPN = .TRUE.
         IF (BRANCH.NE.6) THEN
            CALL ZFIO ('READ', BATLUN, BATIND, JQ, BATDAT, IERR)
            IF (IERR.NE.0) GO TO 960
            END IF
         END IF
      IF ((BRANCH.EQ.3) .OR. (BRANCH.EQ.7)) THEN
         IF ((JQ.LT.1) .OR. (JQ.GT.LBATQS)) THEN
            JB = 100*LBATQS + 64
            WRITE (MSGTXT,1010) J, JB
            CALL MSGWRT (7)
            GO TO 980
            END IF
         IF ((JB.LT.1) .OR. (JB.GT.64)) THEN
            WRITE (MSGTXT,1015) J
            CALL MSGWRT (7)
            GO TO 980
            END IF
         END IF
C                                        open work file
      POTERR = 50
      IF ((BRANCH.NE.6) .AND. (BRANCH.NE.7)) THEN
         CALL ZPHFIL ('BA', 1, IQ, NPOPS, BWTNAM, IERR)
         CALL ZOPEN (BWTLUN, BWTIND, 1, BWTNAM, F, T, T, IERR)
         IF (IERR.NE.0) GO TO 980
         BWTOPN = .TRUE.
         CALL ZFIO ('READ', BWTLUN, BWTIND, 1, BWTBUF, IERR)
         IF (IERR.NE.0) GO TO 960
         BWTREC = 1
         BWTNUM = BWTBUF(4)
         END IF
C                                        branch to OP
      GO TO (100, 200, 300, 400, 500, 600, 700, 200), BRANCH
C-----------------------------------------------------------------------
C                                        BATCH
C                                        build work file
C-----------------------------------------------------------------------
C                                        DISP = NEW for new user, MOD
 100  IF (NLUSER.NE.BWTBUF(1)) THEN
         CALL FILL (256, 0, BWTBUF)
         BWTBUF(1) = NLUSER
         BWTBUF(2) = 2
         BWTBUF(3) = 1
         END IF
 110  IW = BWTBUF(2)
      IL = 0
      IPX = BWTBUF(3)
      IM = BWTBUF(2)
      CALL BBUILD (IW, IL, IPX, IM, BWTBUF)
      POTERR = 0
      GO TO 960
C-----------------------------------------------------------------------
C                                        BATEDIT
C                                        insert into work file
C-----------------------------------------------------------------------
C                                        must be user's work file
 200  IF (NLUSER.NE.BWTBUF(1)) THEN
         WRITE (MSGTXT,1200) NLUSER, BWTBUF(1)
         CALL MSGWRT (7)
         POTERR = 40
         GO TO 960
         END IF
C                                        get line #, opt. argument
      CALL ADVERB ('BATFLINE', 'R', 1, 0, IDUM, RLINE, CDUM)
      IF (ERRNUM.NE.0) GO TO 960
      IF ((SP.GE.1) .AND. (STACK(SP).NE.2)) THEN
         RLINE = V(SP)
         SP = SP - 1
         END IF
C                                        check line number
      LINE = RLINE + EPS
      INSERT = (ABS(RLINE-LINE) .GT. EPS) .AND. (BRANCH.EQ.2)
      IF ((RLINE.LE.EPS) .OR. (BRANCH.NE.2)) THEN
         IF ((BRANCH.NE.8) .OR. (LINE.LT.1) .OR.
     *      (LINE.GT.BWTBUF(2)-2)) THEN
            WRITE (MSGTXT,1210) RLINE
            CALL MSGWRT (7)
            POTERR = 32
            GO TO 960
            END IF
         END IF
      IF (LINE.GE.BWTBUF(2)-2) THEN
C                                        insert after current text
         IF ((INSERT) .OR. (LINE.NE.BWTBUF(2)-2)) THEN
            WRITE (MSGTXT,1215)
            CALL MSGWRT (3)
            GO TO 110
            END IF
         END IF
C                                        read file to find LINE
      IW = BWTBUF(2)
      IM = IW
      POTERR = 50
      DO 230 I = 1,LINE
         LREC = (BWTREC-1)/NLPR + 1
         J = 5 + NWPL * MOD (BWTREC-1, NLPR)
         BWTREC = BWTBUF(J)
         IF (BWTREC.LE.0) THEN
            IF ((I.NE.LINE) .OR. (LINE.NE.IM-2)) THEN
               WRITE (MSGTXT,1220) I
               CALL MSGWRT (9)
               POTERR = 40
               GO TO 960
               END IF
            END IF
         IREC = (BWTREC-1)/NLPR + 1
         IF (IREC.NE.LREC) THEN
            CALL ZFIO ('READ', BWTLUN, BWTIND, IREC, BWTBUF, IERR)
            IF (IERR.NE.0) GO TO 960
            END IF
 230     CONTINUE
C                                        set pointers
      J = 5 + NWPL * MOD (BWTREC-1, NLPR)
      IF (BRANCH.EQ.8) GO TO 800
      IL = BWTBUF(J)
      IF (INSERT) THEN
         IPX = BWTREC
      ELSE
         IPX = BWTBUF(J+1)
         IW = BWTREC
         END IF
      CALL BBUILD (IW, IL, IPX, IM, BWTBUF)
      POTERR = 0
      GO TO 960
C-----------------------------------------------------------------------
C                                        UNQUEUE
C                                        dequeue & recover text
C-----------------------------------------------------------------------
C                                        only inactive jobs this user
 300  J = 4 * JB - 3
      I = BATDAT(J)
      IF (I.NE.NLUSER) THEN
         IF (I.GT.0) THEN
            WRITE (MSGTXT,1300)
         ELSE IF (I.EQ.0) THEN
            WRITE (MSGTXT,1301)
         ELSE IF (BATDAT(J+1).GT.0) THEN
            WRITE (MSGTXT,1302)
         ELSE IF (BATDAT(J+1).EQ.0) THEN
            WRITE (MSGTXT,1303)
         ELSE
            WRITE (MSGTXT,1304)
            END IF
         CALL MSGWRT (7)
         POTERR = 40
         GO TO 960
         END IF
C                                        mark busy
      BATDAT(J) = -BATDAT(J)
      BATDAT(J+1) = ABS(BATDAT(J+1))
      CALL ZFIO ('WRIT', BATLUN, BATIND, JQ, BATDAT, IERR)
      CALL ZCLOSE (BATLUN, BATIND, IER2)
      IF ((IERR.NE.0) .OR. (IER2.NE.0)) THEN
         WRITE (MSGTXT,1305) IERR, IER2
         CALL MSGWRT (7)
         END IF
      BATOPN = .FALSE.
C                                        open file as input
      ITEMP = JQ + 1 + NINTRN
      CALL ZPHFIL ('BA', 1, JB, ITEMP, PHNAME, IERR)
      J = JTRIM (RHOST)
C                                       local
      IF (J.EQ.0) THEN
         FILE = PHNAME
C                                       remote at this location
      ELSE
         FILE = 'NET0:' // RHOST(:J) // '/' // PHNAME(6:)
         END IF
      CALL ZOPEN (BATLUN, BATIND, 1, FILE, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1310) IERR
         CALL MSGWRT (7)
         POTERR = 50
         GO TO 960
         END IF
      BATOPN = .TRUE.
C                                        set input unit
      LIUNIT = IUNIT
      IUNIT = 3
      BATREC = 1
      CALL ZFIO ('READ', BATLUN, BATIND, 1, BATDAT, IERR)
      IF (IERR.NE.0) GO TO 960
C                                       just like BATCH here
C                                       Do BATCLEAR always now
      CALL FILL (256, 0, BWTBUF)
      BWTBUF(1) = NLUSER
      BWTBUF(2) = 2
      BWTBUF(3) = 1
      IW = BWTBUF(2)
      IL = 0
      IPX = BWTBUF(3)
      IM = BWTBUF(2)
      CALL BBUILD (IW, IL, IPX, IM, BWTBUF)
      POTERR = 0
      IUNIT = LIUNIT
C                                        close & destroy
      CALL ZCLOSE (BATLUN, BATIND, IERR)
      BATOPN = .FALSE.
      CALL ZDESTR (1, FILE, IER2)
      IF ((IERR.NE.0) .OR. (IER2.NE.0)) THEN
         WRITE (MSGTXT,1320) IERR, IER2
         CALL MSGWRT (7)
         POTERR = 50
         GO TO 960
         END IF
C                                        remove from queue
      CALL ZPHFIL ('BQ', 1, 0, 0, PHNAME, IERR)
      J = JTRIM (RHOST)
C                                       local
      IF (J.EQ.0) THEN
         FILE = PHNAME
C                                       remote at this location
      ELSE
         FILE = 'NET0:' // RHOST(:J) // '/' // PHNAME(6:)
         END IF
      CALL ZOPEN (BATLUN, BATIND, 1, FILE, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1750) IERR
         CALL MSGWRT (9)
         GO TO 960
         END IF
      BATOPN = .TRUE.
      CALL ZFIO ('READ', BATLUN, BATIND, JQ, BATDAT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1755) IERR
         CALL MSGWRT (9)
         GO TO 960
         END IF
      J = 4 * JB - 3
      CALL FILL (4, 0, BATDAT(J))
      CALL ZFIO ('WRIT', BATLUN, BATIND, JQ, BATDAT, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1760) IERR
         CALL MSGWRT (9)
         END IF
      GO TO 960
C-----------------------------------------------------------------------
C                                        BATCLEAR
C                                        init work file
C-----------------------------------------------------------------------
 400  CALL FILL (256, 0, BWTBUF)
      BWTBUF(1) = NLUSER
      BWTBUF(2) = 2
      BWTBUF(3) = 1
      CALL ZFIO ('WRIT', BWTLUN, BWTIND, 1, BWTBUF, IERR)
      POTERR = 0
      IF (IERR.NE.0) POTERR = 50
      GO TO 960
C-----------------------------------------------------------------------
C                                        BATLIST
C                                        list work file
C-----------------------------------------------------------------------
 500  GO TO 720
C-----------------------------------------------------------------------
C                                        QUEUE
C                                        list jobs in queue
C-----------------------------------------------------------------------
 600  IF ((IQ.GE.1) .AND. (IQ.LE.LBATQS)) THEN
         J1 = IQ
         J2 = IQ
      ELSE
         J1 = 1
         J2 = LBATQS
         END IF
      CALL ZDATE (IT0(1))
      CALL ZTIME (IT0(4))
      CALL DAT2JD (IT0, JD0)
      WRITE (MSGTXT,1600)
      CALL MSGWRT (5)
C                                       loop over queues
      IW = 0
      DO 620 JQ = J1,J2
         IF (RHOST.NE.' ') MSGSUP = 32000
         CALL ZFIO ('READ', BATLUN, BATIND, JQ, BATDAT, IERR)
         MSGSUP = 0
         IF ((IERR.NE.0) .AND. (IW.GT.0)) GO TO 630
         IF (IERR.NE.0) GO TO 960
         IF (RHOST.NE.' ') IW = IW + 1
         ITEMP = 100*JQ
         DO 610 I = 1,64
            J = 4*I - 3
            IF (BATDAT(J).NE.0) THEN
               IW = ABS(BATDAT(J))
               IF (BATDAT(J).LE.0) THEN
                  STATUS = RUNING
                  IF (BATDAT(J+1).EQ.0) STATUS = SUBMIT
                  IF (BATDAT(J+1).LT.0) STATUS = DONE
               ELSE
                  STATUS = QUEUED
                  IF (BATDAT(J+1).LT.0) STATUS = FAILED
                  END IF
               BATDAT(J+1) = ABS(BATDAT(J+1))
               CALL CATIME (2, BATDAT(J+1), IT)
               CALL DAT2JD (IT, JD1)
               IF ((STATUS.NE.DONE) .OR. (JD1+7.GE.JD0)) THEN
                  IF ((STATUS.NE.FAILED) .OR. (JD1+15.GE.JD0)) THEN
                     IM = ITEMP + I
                     IF ((BATDAT(J+3).LE.0) .OR. (BATDAT(J+3).GT.4))
     *                  BATDAT(J+3) = 5
                     CALL TIMDAT (IT(4), IT(1), ATIME, ADATE)
                     WRITE (MSGTXT,1605) IM, ADATE, ATIME, STATUS, IW,
     *                  BVERS(BATDAT(J+3))
                     CALL MSGWRT (5)
                     END IF
                  END IF
               END IF
 610        CONTINUE
 620     CONTINUE
C                                        close Q file
 630  CALL ZCLOSE (BATLUN, BATIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1620) IERR
         CALL MSGWRT (8)
         END IF
      BATOPN = .FALSE.
      POTERR = 0
      GO TO 980
C-----------------------------------------------------------------------
C                                        JOBLIST
C                                        list submitted job
C-----------------------------------------------------------------------
C                                        list only inactive this user
 700  J = 4 * JB - 3
      I = BATDAT(J)
      IF (I.NE.NLUSER) THEN
         IF (I.GT.0) THEN
            WRITE (MSGTXT,1300)
         ELSE IF (I.EQ.0) THEN
            WRITE (MSGTXT,1301)
         ELSE IF (BATDAT(J+1).GT.0) THEN
            WRITE (MSGTXT,1302)
         ELSE IF (BATDAT(J+1).EQ.0) THEN
            WRITE (MSGTXT,1303)
         ELSE
            WRITE (MSGTXT,1304)
            END IF
         CALL MSGWRT (7)
         POTERR = 40
         GO TO 960
         END IF
C                                        mark busy
      BATDAT(J) = -BATDAT(J)
      INSIGN = BATDAT(J+1).LT.0
      BATDAT(J+1) = ABS(BATDAT(J+1))
      CALL ZFIO ('WRIT', BATLUN, BATIND, JQ, BATDAT, IERR)
      CALL ZCLOSE (BATLUN, BATIND, IER2)
      IF ((IERR.NE.0) .OR. (IER2.NE.0)) THEN
         WRITE (MSGTXT,1305) IERR, IER2
         CALL MSGWRT (7)
         END IF
      BATOPN = .FALSE.
C                                        open file
      ITEMP = JQ + 1 + NINTRN
      CALL ZPHFIL ('BA', 1, JB, ITEMP, PHNAME, IERR)
      J = JTRIM (RHOST)
C                                       local
      IF (J.EQ.0) THEN
         FILE = PHNAME
C                                       remote at this location
      ELSE
         FILE = 'NET0:' // RHOST(:J) // '/' // PHNAME(6:)
         END IF
      CALL ZOPEN (BWTLUN, BWTIND, 1, FILE, F, T, T, IERR)
      IF (IERR.NE.0) GO TO 750
      BWTOPN = .TRUE.
      CALL ZFIO ('READ', BWTLUN, BWTIND, 1, BWTBUF, IERR)
      IF (IERR.NE.0) GO TO 750
C                                        list work or file
 720  BWTREC = 1
      CALL ADVERB ('BATFLINE', 'I', 1, 0, LINE, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 960
      CALL ADVERB ('BATNLINE', 'I', 1, 0, LINES, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 960
      IF (BWTBUF(2).LE.2) THEN
         WRITE (MSGTXT,1720)
         CALL MSGWRT (3)
         POTERR = 101
         GO TO 750
         END IF
      IF (LINE.GT.BWTBUF(2)-2) THEN
         LINES = BWTBUF(2)-2
         WRITE (MSGTXT,1723) LINE,LINES
         CALL MSGWRT (7)
         POTERR = 32
         GO TO 750
         END IF
C                                        finish setting line range
      LINE = MAX(LINE, 1)
      IF (LINES.LE.1) LINES = BWTBUF(2) - LINE - 1
      LINES = MIN(LINES, BWTBUF(2)-LINE-1)
      LINES = LINES + LINE - 1
      NCHCPY = MIN (74, NCHLIN)
      DO 740 I = 1,LINES
         LREC = (BWTREC-1)/NLPR + 1
         J = 5 + NWPL * MOD (BWTREC-1, NLPR)
         BWTREC = BWTBUF(J)
         IF ((BWTREC.LE.0) .AND. (I.NE.LINES)) THEN
            WRITE (MSGTXT,1220) I
            CALL MSGWRT (9)
            POTERR = 40
            GO TO 750
            END IF
         IREC = (BWTREC-1)/NLPR + 1
         IF (IREC.NE.LREC) THEN
            CALL ZFIO ('READ', BWTLUN, BWTIND, IREC, BWTBUF, IERR)
            IF (IERR.NE.0) GO TO 750
            END IF
         IF (I.GE.LINE) THEN
            J = 5 + NWPL * MOD (BWTREC-1, NLPR)
            WRITE (MSGTXT,1735) I
            MSGTXT(5:6) = '  '
            CALL H2CHR (NCHCPY, 1, BWTBUF(J+2), MSGTXT(7:))
            CALL MSGWRT (5)
            END IF
 740     CONTINUE
      POTERR = 0
C                                        clear busy setting
 750  IF (BRANCH.NE.7) THEN
         GO TO 960
      ELSE
         CALL ZPHFIL ('BQ', 1, 0, 0, PHNAME, IERR)
         J = JTRIM (RHOST)
C                                       local
         IF (J.EQ.0) THEN
            FILE = PHNAME
C                                       remote at this location
         ELSE
            FILE = 'NET0:' // RHOST(:J) // '/' // PHNAME(6:)
            END IF
         CALL ZOPEN (BATLUN, BATIND, 1, FILE, F, T, T, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1750) IERR
            CALL MSGWRT (9)
            GO TO 960
            END IF
         BATOPN = .TRUE.
         CALL ZFIO ('READ', BATLUN, BATIND, JQ, BATDAT, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1755) IERR
            CALL MSGWRT (9)
            GO TO 960
            END IF
         J = 4 * JB - 3
         BATDAT(J) = ABS(BATDAT(J))
         IF (INSIGN) BATDAT(J+1) = -BATDAT(J+1)
         CALL ZFIO ('WRIT', BATLUN, BATIND, JQ, BATDAT, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1760) IERR
            CALL MSGWRT (9)
            END IF
         GO TO 960
         END IF
C-----------------------------------------------------------------------
C                                        BAMODIFY (continued)
C                                        modify text of one line
C-----------------------------------------------------------------------
C                                       Echo old line
 800  TEMP = HOLD
      LBYTES = NCHLIN
      CALL H2CHR (LBYTES, 1, BWTBUF(J+2), TEMP(2:))
      TEMP(LBYTES+2:) = ' '
      INP = JTRIM (TEMP)
      I = MAX (INP, 1)
      CALL ZMSGOP (MSGLUN, MSGIND, 1, PHNAME, IERR)
      CALL ZTTYIO ('WRIT', MSGLUN, MSGIND, I, TEMP, IERR)
      CALL ZMSGCL (MSGLUN, MSGIND, IERR)
      POTERR = 0
C                                       Read new line
      LPT = IPT
      LIUNIT = IUNIT
      IUNIT = 1
      IPT = HOLD
      CALL PREAD (KARBUF)
      IUNIT = LIUNIT
      IPT = LPT
      IF (ERRNUM.NE.0) GO TO 960
      IF (NBYTES.LE.0) GO TO 960
C                                       Merge old and new lines
      INP = 1
      KOP = 1
      INSERT = .FALSE.
      DO 845 I = 1,1000
         ICHAR = KARBUF(I:I)
C                                       Insert mode
         IF (INSERT) THEN
            IF ((ICHAR.EQ.INSRT) .OR. (I.GT.NBYTES)) THEN
               INSERT = .FALSE.
            ELSE
               KARBUF(KOP:KOP) = ICHAR
               IF (ICHAR.EQ.SPACE) KARBUF(KOP:KOP) = ' '
               IF (ICHAR.NE.DELETE) KOP = KOP + 1
               END IF
C                                       Substitute mode
         ELSE
            IF ((I.GT.NBYTES) .AND. (INP.GT.LBYTES)) GO TO 850
C                                       Pure copy at end
            IF (I.GT.NBYTES) THEN
               CALL H2CHR (1, INP, BWTBUF(J+2), KARBUF(KOP:KOP))
               KOP = KOP + 1
               INP = INP + 1
C                                       Start insert
            ELSE IF (ICHAR.EQ.INSRT) THEN
               INSERT = .TRUE.
C                                       Delete a character
            ELSE IF (ICHAR.EQ.DELETE) THEN
               INP = INP + 1
C                                       Change to blank
            ELSE IF (ICHAR.EQ.SPACE) THEN
               KARBUF(KOP:KOP) = ' '
               KOP = KOP + 1
               INP = INP + 1
C                                       Keep old character
            ELSE IF (ICHAR.EQ.' ') THEN
               KARBUF(KOP:KOP) = ' '
               IF (INP.LE.LBYTES) CALL H2CHR (1, INP, BWTBUF(J+2),
     *            KARBUF(KOP:KOP))
               INP = INP + 1
               KOP = KOP + 1
C                                       New character
            ELSE
               KARBUF(KOP:KOP) = ICHAR
               IF ((ICHAR.EQ.SPACE) .OR. (ICHAR.EQ.INSRT) .OR.
     *            (ICHAR.EQ.DELETE)) KARBUF(KOP:KOP) = ' '
               KOP = KOP + 1
               INP = INP + 1
               END IF
            END IF
 845     CONTINUE
C                                       Echo new line
 850  TEMP = ' ' // KARBUF(1:NCHLIN)
      CALL CHR2H (NCHLIN, KARBUF, 1, BWTBUF(J+2))
      INP = JTRIM (TEMP)
      I = MAX (INP, 1)
      CALL ZMSGOP (MSGLUN, MSGIND, 1, PHNAME, IERR)
      CALL ZTTYIO ('WRIT', MSGLUN, MSGIND, I, TEMP, IERR)
      CALL ZMSGCL (MSGLUN, MSGIND, IERR)
C                                       Write out record
      CALL ZFIO ('WRIT', BWTLUN, BWTIND, IREC, BWTBUF, IERR)
      IF (IERR.NE.0) POTERR = 50
      GO TO 960
C-----------------------------------------------------------------------
C                                        Close down area
C                                        close BAT or Q
 960  IF (BATOPN) CALL ZCLOSE (BATLUN, BATIND, IERR)
C                                        work file
      IF (BWTOPN) CALL ZCLOSE (BWTLUN, BWTIND, IERR)
C                                        POPS error mess
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('QUEUE #',I6,' OUTSIDE RANGE 1 -',I3)
 1010 FORMAT ('JOB #',I7,' OUTSIDE RANGE 101 -',I4)
 1015 FORMAT ('JOB #',I7,' INVALID')
 1200 FORMAT ('USER #',I5,' CANNOT EDIT BATCH OF',I5)
 1210 FORMAT ('BATFLINE',F7.1,' OUT OF RANGE')
 1215 FORMAT ('BATFLINE TOO LARGE: ADDING CODE AT END')
 1220 FORMAT ('LINK FAILS TO LINE',I6)
 1300 FORMAT ('YOU MAY ONLY UNQUEUE/JOBLIST YOUR OWN JOBS')
 1301 FORMAT ('JOB DOES NOT EXIST')
 1302 FORMAT ('JOB ALREADY RUNNING')
 1303 FORMAT ('JOB STILL SUBMITTING')
 1304 FORMAT ('JOB ALREADY DONE')
 1305 FORMAT ('DEQUE ERROR: WRITE',I7,' CLOSE',I7)
 1310 FORMAT ('OPEN BATCH FILE ERROR',I7)
 1320 FORMAT ('BATCH FILE ERROR CLOSE',I7,' DESTROY',I7)
 1600 FORMAT ('Job',8X,'Submit time',10X,'Status',11X,'Ver')
 1605 FORMAT (I3,3X,A12,1X,A8,4X,A8,I6,4X,A3)
 1620 FORMAT ('Q FILE CLOSE ERROR',I7)
 1720 FORMAT ('NO LINES IN FILE')
 1723 FORMAT ('BATFLINE',I7,' EXCEEDS MAX LINE',I6)
 1735 FORMAT (I4)
 1750 FORMAT ('JOB REQUEUE OPEN ERROR',I7)
 1755 FORMAT ('JOB REQUEUE READ ERROR',I7)
 1760 FORMAT ('JOB REQUEUE WRITE ERROR',I7)
      END

      SUBROUTINE QCFT3I (LEN1, LEN2, LEN3, WSAVE)
C-----------------------------------------------------------------------
C! Pseudo AP routine: initialize complex-to-complex 3D FFT
C# AP-FFT
C-----------------------------------------------------------------------
C;  Copyright (C) 1997, 2006
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Initialize a workspace for a complex-to-complex FFT of LEN1 by LEN2
C   by LEN3 elements. The following conditions must hold where FTWMUL,
C   FTWADD and FFTMAX are defined in INCS:PFFT.INC (and may change from
C   machine to machine)
C
C   0 < LEN1
C   0 < LEN2 <= FFTMAX
C   0 < LEN3 <= FFTMAX
C   length of WSAVE >= FTWMUL * (LEN1 + LEN2 + LEN3) + 3 * FTWADD
C
C   Once initialized by QCFT3I, WSAVE may be used in any number of calls
C   to the Fourier transform routine QCFT3D for FFTs of the same size.
C
C   Input:
C      LEN1        I         Number of rows to be transformed
C      LEN2        I         Number of columns to be transformed
C      LEN3        I         Number of planes to be transformed
C   Output:
C      WSAVE      R(*)       Initialized workspace for QCFT3D
C-----------------------------------------------------------------------
      INTEGER   LEN1, LEN2, LEN3
      REAL      WSAVE(*)
C
      INTEGER   IDX2, IDX3
      INCLUDE 'INCS:PFFT.INC'
C-----------------------------------------------------------------------
C                                       Generic pseudo AP version uses
C                                       adapted FFTPACK routines: WSAVE
C                                       is divided into 3 workspaces for
C                                       1D FFTs.
      IDX2 = FTWMUL * LEN1 + FTWADD + 1
      IDX3 = IDX2 + FTWMUL * LEN2 + FTWADD
      CALL QCFT1I (LEN1, WSAVE(1))
      CALL QCFT1I (LEN2, WSAVE(IDX2))
      CALL QCFT1I (LEN3, WSAVE(IDX3))
C
 999  RETURN
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QGRID (UV, VIS, WT, L, G, CX, CY, NO2, M, LROW, CNT,
     *   TY)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Grid uv data into row.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FORTRAN version of FPS AP VFC routine.
C   QGRID grids visibility data that has been loaded into the AP
C   previously.  Data is floated and scaled; a taper is applied
C   to the weights if requested before gridding.
C   When taper is requested and TY=2 or 3 locations VIS-2 and
C   VIS-1 are used for work space.  If TY=1 locations VIS+2 and
C   VIS+3 are used.
C   Inputs:
C      UV    I  Location of (u,v) values in cells.
C      VIS   I  Location of (complex) visibilities.
C      WT    I  Weight for data.
C      L     I  Length of visibility record.
C      G     I  base address of gridded data.
C      CX    I  base address of X convolving fn. (Y on sky)
C      CY    I  base address of Y convolving fn. (X on sky)
C      NO2   I  INT( (# cells used on a row) / 2 )
C      M     I  number of rows kept in the AP.
C      LROW  I  length of a row ( max. X).
C      CNT   I  Number of visibility points.
C      TY    I  Type of visibility data.
C                1 = I MAPS
C                2 = Q,U MAPS
C                3 = V MAPS
C               If TY is negative then tapering is requested.
C               If CNT is neg., do not float or scale.
C   Expects necessary constants in following AP locations:
C           8 = -SIG(U)**2 (CELLS**2) FOR TAPER
C           9 = -SIG(V)**2 (CELLS**2) FOR TAPER
C          13 = UVSC (scaling for u,v)
C          14 = SCVIS  (scaling for visibilities)
C          15 = SCWT   (scaling for weights)
C     It is assumed that all values of v correspond to row M/2.
C-----------------------------------------------------------------------
      INTEGER   UV, VIS, WT, L, G, CX, CY, NO2, M,
     *   LROW, CNT, TY, UV1, VIS1, IWORK1, VIS2, VIS3,
     *   JVIS, JWT, ITY, ICNT, IWORK2, I, LL, JUV
      LOGICAL   NOFLT, TAPER
C-----------------------------------------------------------------------
C                                       Get input values to be changed
      JUV = UV
      JVIS = VIS
      JWT = WT
      LL = L
      UV1 = JUV + 1
      VIS1 = JVIS + 1
C                                        Check for data
      IF (CNT.EQ.0) GO TO 999
C                                         Check for nofloat
      NOFLT = CNT.LT.0
      ICNT = ABS(CNT)
C                                        Check if taper requested.
      TAPER = TY.LT.0
      ITY = ABS(TY)
C                                         Float
      IF (NOFLT) GO TO 10
         CALL QVFLT (JUV, L, JUV, L, ICNT)
         CALL QVFLT (UV1, L, UV1, L, ICNT)
         CALL QVFLT (JVIS, L, JVIS, L, ICNT)
         CALL QVFLT (VIS1, L, VIS1, L, ICNT)
         CALL QVFLT (JWT, L, JWT, L, ICNT)
C                                        Scale
         CALL QVSMUL (JUV, L, 13, JUV, L, ICNT)
         CALL QVSMUL (UV1, L, 13, UV1, L, ICNT)
         CALL QVSMUL (JVIS, L, 14, JVIS, L, ICNT)
         CALL QVSMUL (VIS1, L, 14, VIS1, L, ICNT)
         CALL QVSMUL (JWT, L, 15, JWT, L, ICNT)
C                                         Taper if requested.
 10      CONTINUE
      IF (.NOT.TAPER) GO TO 50
C                                         Check type.
         IF (ITY.EQ.1) GO TO 20
C                                         Pick unused work area.
            IWORK1 = JVIS - 2
            IWORK2 = JVIS - 1
            GO TO 30
 20         CONTINUE
C                                         Q,U or V map
            IWORK1 = JVIS + 2
            IWORK2 = JVIS + 3
 30         CONTINUE
C                                        Apply taper.
         CALL QVSQ (JUV, L, IWORK1, L, ICNT)
         CALL QVSQ (UV1, L, IWORK2, L, ICNT)
         CALL QVSMUL (IWORK1, L, 8, IWORK1, L, ICNT)
         CALL QVSMUL (IWORK2, L, 9, IWORK2, L, ICNT)
         CALL QVADD (IWORK1, L, IWORK2, L, IWORK1, L, ICNT)
         CALL QVEXP (IWORK1, L, IWORK1, L, ICNT)
         CALL QVMUL (JWT, L, IWORK1, L, JWT, L, ICNT)
 50      CONTINUE
C                                         I or V maps.
C                                         Gridding loop.
      IF (ITY.EQ.2) GO TO 100
         DO 60 I = 1,ICNT
C                                         Grid vis point.
            CALL QGRD1 (JUV, JVIS, JWT, G, CX, CY, NO2, M, LROW)
C                                         Update pointers.
            JUV = JUV + LL
            JVIS = JVIS + LL
            JWT = JWT + LL
 60         CONTINUE
      GO TO 999
C                                         QPOL,UPOL maps.
C                                         Finish float.
 100  CONTINUE
         IF (NOFLT) GO TO 110
            VIS2 = JVIS + 2
            VIS3 = JVIS + 3
            CALL QVFLT (VIS2, L, VIS2, L, ICNT)
            CALL QVFLT (VIS3, L, VIS3, L, ICNT)
            CALL QVSMUL (VIS2, L, 14, VIS2, L, ICNT)
            CALL QVSMUL (VIS3, L, 14, VIS3, L, ICNT)
C                                         Gridding loop.
 110     DO 150 I = 1,ICNT
C                                         Grid vis. point.
            CALL QGRD2 (JUV, JVIS, JWT, G, CX, CY, NO2, M, LROW)
C                                         Update pointers.
            JUV = JUV + LL
            JVIS = JVIS + LL
            JWT = JWT + LL
 150        CONTINUE
C
 999  RETURN
      END

      SUBROUTINE QSPSUB (MODL, U, VS, INCVS, INCF, INCS, NCOMP, NVIS,
     *   NF, NS, FLAG)
C-----------------------------------------------------------------------
C! FPS AP version: Subtract transform of Spherical model from UV data
C# AP-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   FPS AP version
C   Subtracts the model visibility derived from Spherical components from
C   visibility records.  Arbitrary numbers of frequencies and
C   polarizations can be processed.
C     Inputs:
C       MODL  I  Base address of Spherical components, increment=11
C                  0 = used (model amplitude)
C                  1 = used (PHASE)
C                  2 = used (REAL)
C                  3 = used (IMAG)
C                  4 = -2 * PI * X (radians)
C                  5 = -2 * PI * Y
C                  6 = -2 * PI * Z
C                  7 = R = radius * 3.0462740E-5
C                  8 = 3 * Amplitude
C                  9 = MIN = min arg (0.1 good)
C                 10 = used (ARG)
C       U     I  Base address of U's, assumed followed by V, W
C       VS    I  Base address of vis rec. (real, imag, wt)
C       INCVS I  Increment of VS for next visibility
C       INCF  I  Increment of VS for next frequency
C       INCS  I  Increment of VS for next Stokes (RR or LL)
C       NCOMP I  Number of Spherical components.
C       NVIS  I  Number of visibilities.
C       NF    I  Number of frequencies.
C       NS    I  Number of Stokes (usually 1 or 2)
C       FLAG  I  If FLAG < 0 multiply model vis by i (SQRT(-1))
C     Also uses AP locations 0 and 1 and expects an array of length NS
C     beginning in location 2+NF composed of the correlator factors.
C     Beginning in location 2 should be an array of length NF :
C              Freq(0) / Freq(ref) - 1.0
C              Freq(1) / Freq(0)   - 1.0
C                      .
C                      .
C                      .
C              Freq(NF-1) / Freq(NF-2) - 1.0
C-----------------------------------------------------------------------
      INTEGER MODL, U, VS, INCVS, INCF, INCS, NCOMP, NVIS, NF, NS,
     *   FLAG
      INTEGER*2 IMODL, IU, IVS, IINCVS, IINCF, IINCS, INCOMP, INVIS,
     *   INF, INS, IFLAG
C-----------------------------------------------------------------------
C                                        Convert inputs to unsigned I*2
      IF (MODL.LT.32768) IMODL = MODL
      IF (MODL.GE.32768) IMODL = MODL - 65536
      IF (U.LT.32768) IU = U
      IF (U.GE.32768) IU = U - 65536
      IF (VS.LT.32768) IVS = VS
      IF (VS.GE.32768) IVS = VS - 65536
      IINCVS = INCVS
      IINCF = INCF
      IINCS = INCS
      IF (NCOMP.LT.32768) INCOMP = NCOMP
      IF (NCOMP.GE.32768) INCOMP = NCOMP - 65536
      IF (NVIS.LT.32768) INVIS = NVIS
      IF (NVIS.GE.32768) INVIS = NVIS - 65536
      INF = NF
      INS = NS
      IFLAG = FLAG
C                                        Call FPS routine.
      CALL SPHSUB (IMODL, IU, IVS, IINCVS, IINCF, IINCS, INCOMP, INVIS,
     *   INF, INS, IFLAG)
C
 999  RETURN
      END

      SUBROUTINE ZDRCHK
C-----------------------------------------------------------------------
C! Checks to see that all CA files are present and writable or read only
C# Z IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DRCHK checks those CA files for the current user to see if they
C   are writable or not.
C   Output: COMMON
C-----------------------------------------------------------------------
      CHARACTER PHNAME*48
      INTEGER   IER, IV, IV1, IV2, LSIZE
      HOLLERITH ANAME(12)
      LOGICAL   IAMOK
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DDRC.INC'
C-----------------------------------------------------------------------
      IV1 = 1
      IV2 = NVOL
C                                       Loop on disks
      DO 20 IV = IV1,IV2
         IF (.NOT.IAMOK(IV,'CA')) THEN
            DSKLOK(IV) = 2
         ELSE
            CALL ZPHFIL ('CA', IV, 0, 0, PHNAME, IER)
            CALL ZEXIST (IV, PHNAME, LSIZE, IER)
            IF (IER.NE.0) THEN
               DSKLOK(IV) = -1
            ELSE
               CALL CHR2H (48, PHNAME, 1, ANAME)
               CALL ZDRCH2 (ANAME, DSKLOK(IV))
               END IF
            END IF
 20      CONTINUE
C
 999  RETURN
      END

@PROCESS VECTOR DIR('@DIR')
      SUBROUTINE QXXPTS (C, U, VS, INCVS, INCF, INCS, NCOMP, NVIS,
     *   NF, NS, FLAG)
C-----------------------------------------------------------------------
C! Pseudo AP routine: Subtract point model visibility from uv data.
C# AP-appl UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Vector machine version
C   Subtracts the model visibility derived from CLEAN components from
C   visibility records.  Arbitrary numbers of frequencies and
C   polarizations can be processed.
C   Inputs:
C      C     I  Base address of CLEAN components, increment=7
C               0 = Amplitude
C               1 = used (PHASE)
C               2 = used (REAL)
C               3 = used (IMAG)
C               4 = -2 * PI * X
C               5 = -2 * PI * Y
C               6 = -2 * PI * Z
C      U     I  Base address of U's, assumed followed by V, W
C      VS    I  Base address of vis rec. (real, imag, wt)
C      INCVS I  Increment of VS for next visibility
C      INCF  I  Increment of VS for next frequency
C      INCS  I  Increment of VS for next IF (RR of LL)
C      NCOMP I  Number of CLEAN components.
C      NVIS  I  Number of visibilities.
C      NF    I  Number of frequencies.
C      NS    I  Number of Stokes' (usually 1 or 2)
C      FLAG  I  If FLAG < 0 multiply model vis by i (SQRT(-1))
C   Also uses AP locations 0 and 1 and expects an array of length NS
C   beginning in location 2+NF composed of the correlator factors.
C   Beginning in location 2 should be an array of length NF :
C            Freq(0) / Freq(ref) - 1.0
C            Freq(1) / Freq(0)   - 1.0
C                    .
C                    .
C                    .
C            Freq(NF-1) / Freq(NF-2) - 1.0
C   Note: all addresses are 0 relative and needed to be incremented by
C   1 to work in Fortran.
C   Note: the important loops to vectorize are 50, 100, and 130.
C   Calls: QRECT
C-----------------------------------------------------------------------
      INTEGER   C, U, VS, INCVS, INCS, INCF, NCOMP, NVIS, NF, NS,
     *   PHASE, REAL, IMAG, X, JVS, F, IU, IVS, IF,
     *   IV, FLAG, S, IS, JA, JX, JPHAS, JAMP, ICOMP, LOOP, KAMP,
     *   KREAL
      REAL   FREQF, SUMRE, SUMIM, REMOD, IMMOD
      INCLUDE 'INCS:DAPC.INC'
C-----------------------------------------------------------------------
C                                        Make sure that there is data.
      IF ((NCOMP.LE.0) .OR. (NVIS.LE.0) .OR. (NF.LE.0) .OR.
     *   (NS.LE.0))  GO TO 999
C                                       Setup array addresses
      PHASE = C + 1
      REAL = PHASE + 1
      IMAG = REAL + 1
      X = IMAG + 1
      IU = U
      IVS = VS
C                                        Begin visibility loop
      DO 300 IV = 1,NVIS
C                                        Compute phase at ref. freq.
         JX = X + 1
         JPHAS = PHASE + 1
C@DIR IGNORE RECRDEPS(APCORE)
         DO 50 LOOP = 1,NCOMP
            APCORE(JPHAS) = APCORE(JX) * APCORE(IU+1)
     *                    + APCORE(JX+1) * APCORE(IU+2)
     *                    + APCORE(JX+2) * APCORE(IU+3)
C                                       Update pointers.
            JPHAS = JPHAS + 7
            JX = JX + 7
 50         CONTINUE
C                                        Get ready for freq. loop.
         JVS = IVS
         F = 2
         S = NF + 2
         FREQF = 1.0
C                                        Begin frequency loop.
         DO 200 IF = 1,NF
C                                       Loop over component
            SUMRE = 0.0
            SUMIM = 0.0
            JPHAS = PHASE + 1
            JAMP = C + 1
            REAL = C + 3
            IMAG = C + 4
            KAMP = JAMP - 1
            KREAL = REAL - 1
C                                       Check scaling
            IF (ABS (APCORE(F+1)).GT.1.0E-20) GO TO 110
C                                       Convert to polar
               CALL QRECT (KAMP, 7, KREAL, 7, NCOMP)
               GO TO 130
C                                       Subsequent frequency
 110           FREQF = 1.0 + APCORE(F+1)
C                                       Scale frequency
C@DIR IGNORE RECRDEPS(APCORE)
               DO 120 ICOMP = 1,NCOMP
                  APCORE(JPHAS) = FREQF * APCORE(JPHAS)
                  JPHAS = JPHAS + 7
 120              CONTINUE
C                                       Convert to polar
               CALL QRECT (KAMP, 7, KREAL, 7, NCOMP)
C@DIR IGNORE RECRDEPS(APCORE)
 130           DO 140 ICOMP = 1,NCOMP
C                                       Do sum
                  SUMRE = SUMRE + APCORE(REAL)
                  SUMIM = SUMIM + APCORE(IMAG)
                  REAL = REAL + 7
                  IMAG = IMAG + 7
 140              CONTINUE
C                                       Correct visibility
            JA = JVS + 1
            REMOD = SUMRE
            IMMOD = SUMIM
            IF (FLAG.LT.0) REMOD = -SUMIM
            IF (FLAG.LT.0) IMMOD = SUMRE
C                                       Loop over Stokes' (1 or 2)
            DO 150 IS = 1,NS
C                                       Subtract model
               APCORE(JA) = APCORE(JA) - REMOD * APCORE(S+IS)
               APCORE(JA+1) = APCORE(JA+1) - IMMOD * APCORE(S+IS)
               JA = JA + INCS
 150           CONTINUE
C                                        Update vis pointer.
            JVS = JVS + INCF
            F = F + 1
 200        CONTINUE
C                                        Update pointers.
         IVS = IVS + INCVS
         IU = IU + INCVS
 300     CONTINUE
C
 999  RETURN
      END

      SUBROUTINE PL3VEC (X, Y, IERR)
C-----------------------------------------------------------------------
C! puts a 'draw vector' command in a plot file: Gary plot package
C# plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 2003
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   This routine will put a 'draw color vector' command in a plot file.
C   Vectors that are too big are interpolated.
C   Inputs:
C      X       R    X value.
C      Y       R    Y value.
C   Common:
C      /PLTCOM/
C   Output:
C      IERR    I    Error code.  0 means OK.
C-----------------------------------------------------------------------
      REAL      X, Y
      INTEGER   IERR
C
      REAL      XX, YY, XT(2), YT(2)
      INTEGER   NO
      INCLUDE 'INCS:DPLT.INC'
C-----------------------------------------------------------------------
      XX = XSCAL * X + XOFF
      YY = YSCAL * Y + YOFF
C                                       Test edge intersections
      CALL INTEDG (PBLC, PTRC, XX, YY, XLAST, YLAST, NO, XT, YT)
C                                       Vector all in plot
      IF (NO.LT.0) THEN
         CALL G3VEC (XX, YY, PLTBLK, IERR)
C                                       No points hit plot
      ELSE IF (NO.EQ.0) THEN
         IOFFPL = IOFFPL + 1
C                                       Both points off plot
      ELSE IF (NO.NE.1) THEN
         CALL GPOS (XT(1), YT(1), PLTBLK, IERR)
         IF (IERR.EQ.0) CALL G3VEC (XT(2), YT(2), PLTBLK, IERR)
C                                       This point off plot
      ELSE IF ((XX.LT.PBLC(1)) .OR. (XX.GT.PTRC(1)) .OR. (YY.LT.PBLC(2))
     *   .OR. (YY.GT.PTRC(2))) THEN
         IOFFPL = IOFFPL + 1
         CALL G3VEC (XT(1), YT(1), PLTBLK, IERR)
C                                       Last point off plot
      ELSE
         CALL GPOS (XT(1), YT(1), PLTBLK, IERR)
         IF (IERR.EQ.0) CALL G3VEC (XX, YY, PLTBLK, IERR)
         END IF
C                                       Save last desired position
 100  XLAST = XX
      YLAST = YY
C
 999  RETURN
      END

      SUBROUTINE DIRCOS (TYPE, RA0, DEC0, RA, DEC, L, M, IERR)
C-----------------------------------------------------------------------
C! determines direction cosines between ref position and test position
C# Coordinates
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999, 2002, 2013, 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DIRCOS determines the direction cosines (L,M) corresponding to
C   the separation from (RA0,DEC0), the reference pixel, to
C   (RA,DEC).  The direction cosine L is assumed to be positive to the
C   east; M is positive to the north.  Several projective geometries
C   are supported.
C   Inputs:
C      TYPE   I    Type of projection: 2 => SIN, 3 => TAN, 4 => Arc,
C                  5 => WSRT (rel north pole), 6 Global sinusoidal,
C                  7 Mercator, 8 Aitoff, 9 STG, 10 CAR, 11 MOL,
C                  12 PAR
C      RA0    D    Coordinate reference right ascension/longitude
C      DEC0   D    Coordinate reference declination/latitude
C      RA     D    right ascension/longitude of point
C      DEC    D    declination/latitude of point
C   Outputs:
C      L      D    Cosine angle of displacement to east
C      M      D    Cosine angle of displacement to north
C      IERR   I    0 ok, 1 out of range, 2 bad type, 3 undefined
C   ALL ANGLES ARE IN RADIANS.
C-----------------------------------------------------------------------
      INTEGER   IERR, TYPE
      DOUBLE PRECISION RA0, DEC0, RA, DEC, L, M
C
      DOUBLE PRECISION DEPS, COSS, SINS, DT, DA, DD, SINT, PHI, THETA
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA DEPS /1.0D-5/
C-----------------------------------------------------------------------
C                                       Use full accuracy
      IERR = 2
      IF ((TYPE.LT.2) .OR. (TYPE.GT.12)) GO TO 999
      IERR = 3
      IF (ABS(DEC).GT.PI/2.0D0) GO TO 999
      IF (ABS(DEC0).GT.PI/2.0D0) GO TO 999
      IERR = 0
      COSS = COS (DEC)
      SINS = SIN (DEC)
      DT = RA - RA0
      IF (DT.GT.PI) DT = DT - TWOPI
      IF (DT.LT.-PI) DT = DT + TWOPI
      L = SIN(DT) * COSS
      SINT = SINS * SIN(DEC0) + COSS * COS(DEC0) * COS(DT)
C                                       SIN projection
      IF (TYPE.EQ.2) THEN
         IF (SINT.LT.0.0D0) IERR = 1
         M = SINS * COS(DEC0) - COSS * SIN(DEC0) * COS(DT)
C                                       TAN projection
      ELSE IF (TYPE.EQ.3) THEN
         IF (SINT.LE.0.0D0) THEN
            IERR = 1
         ELSE
            M = SINS * SIN(DEC0) + COSS * COS(DEC0) * COS(DT)
            L = L / M
            M = (SINS * COS(DEC0) - COSS * SIN(DEC0) * COS(DT)) / M
            END IF
C                                       Arc projection
      ELSE IF (TYPE.EQ.4) THEN
         M = SINS * SIN(DEC0) + COSS * COS(DEC0) * COS(DT)
         M =  MIN (1.0D0, MAX (-1.0D0, M))
         M = ACOS (M)
         IF (M.NE.0.0D0) THEN
            M = M / SIN(M)
         ELSE
            M = 1.0D0
            END IF
         L = L * M
         M = (SINS * COS(DEC0) - COSS * SIN(DEC0) * COS(DT)) * M
         GO TO 999
C                                       WSRT projection
      ELSE IF (TYPE.EQ.5) THEN
         IF (DEC0.NE.0.0D0) THEN
            M = (COS(DEC0) - COSS * COS(DT)) / SIN(DEC0)
         ELSE
            IERR = 3
            WRITE (MSGTXT,1050)
            CALL MSGWRT (6)
            L = 0.0D0
            M = 0.0D0
            END IF
C                                       Stereographic
      ELSE IF (TYPE.EQ.6) THEN
         DD = 1.0D0 + SINS * SIN(DEC0) + COSS * COS(DEC0) * COS(DT)
         IF (ABS(DD).LT.DEPS) THEN
            IERR = 3
         ELSE
            DD = 2.0D0 / DD
            L = L * DD
            M = DD * (SINS * COS(DEC0) - COSS * SIN(DEC0) * COS(DT))
            END IF
C                                       modern ones
      ELSE
C                                       get native long/lat
         CALL CELNAT (RA, DEC, GEOMD1(LOCNUM), GEOMD2(LOCNUM),
     *      GEOMD3(LOCNUM), PHI, THETA)
C                                       Global sinusoidal
         IF (TYPE.EQ.7) THEN
            M = THETA
            L = PHI * COS(THETA)
C                                       Mercator
         ELSE IF (TYPE.EQ.8) THEN
            L = PHI
            DT = TAN ((PI/2.0D0 + THETA) / 2.0D0)
            IF (DT.LE.0) THEN
               IERR = 3
            ELSE
               M = LOG (DT)
               END IF
C                                       Aitoff
         ELSE IF (TYPE.EQ.9) THEN
            DT = SQRT ((1.0D0 + COS(THETA) * COS(PHI/2.D0)) / 2.0D0)
            IF (ABS(DT).LT.DEPS) THEN
               IERR = 3
            ELSE
               DT = 1.0 / DT
               L = 2.0D0 * DT * COS(THETA) * SIN(PHI/2.0)
               M = DT * SIN (THETA)
               DA = (L/4.0D0)**2 + (M/2.0D0)**2
               IF (DA.GT.0.5000009D0) IERR = 3
               END IF
C                                       Plate Carree (-CAR)
         ELSE IF (TYPE.EQ.10) THEN
            L = PHI
            M = THETA
C                                       Molweide
         ELSE IF (TYPE.EQ.11) THEN
            CALL MOLGAM (THETA, DT, IERR)
            IF (IERR.EQ.0) THEN
               L = SQRT (8.0D0) * PHI * COS (DT) / PI
               M = SQRT (2.0D0) * SIN (DT)
               END IF
C                                       parabolic
         ELSE IF (TYPE.EQ.12) THEN
            L = PHI * (2.0D0*COS(2.0D0*THETA/3.0D0) - 1.0D0)
            M = PI * SIN (THETA / 3.0D0)
            END IF
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1050 FORMAT ('DIRCOS: -NCP COORDINATES CANNOT HAVE DEC0 = 0')
      END

      PROGRAM DRCHK
C-----------------------------------------------------------------------
C! Intercompares HOSTS.LIST, DADEVS.LIST, NETSP, and $NET0
C# Utility
C-----------------------------------------------------------------------
C;  Copyright (C) 2001, 2009, 2012
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DRCHK checks the HOSTS.LIST list against NETSP, DADEVS, and the
C   directories in the $NET0 area, reporting any inconsistencies.
C-----------------------------------------------------------------------
      INTEGER   MHOST, NETSP, MSITE
      PARAMETER (MHOST=500, NETSP=8192, MSITE=6)
      CHARACTER PRGNAM*8, HOSTS(MHOST,MSITE)*16, DISKS(NETSP)*64,
     *   LINE*80, LFILE*80, THOST*16, SITES(MSITE)*8, TSITE*8, TDISK*64,
     *   AHOST*18, MSGTMP*160, SFILE*80, XLATED*80
      INTEGER   LUN, I, J, K, NHOST(MSITE), NHUSE(MHOST,MSITE), II, JJ,
     *   NNUSE(NETSP), IND, NSITE, NDISK, DSITE, SLUN, SIND, XLNB,
     *   IERR, KBP, JTRIM
      INCLUDE 'INCS:DMSG.INC'
      DATA PRGNAM /'DRCHK'/
      DATA LUN, SLUN /11,10/
C-----------------------------------------------------------------------
      TSKNAM = PRGNAM
      NPOPS = 1
      NLUSER = 1
      CALL ZDCHIN (.FALSE.)
C                                       Read HOSTS.LIST
      NSITE = 0
      CALL FILL (MSITE, 0, NHOST)
      I = MHOST * MSITE
      CALL FILL (I, 0, NHUSE)
      LFILE = 'AIPS_ROOT:HOSTS.LIST'
      CALL ZTXOPN ('READ', LUN, IND, LFILE, .FALSE., IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Read loop
 10   CONTINUE
         CALL ZTXIO ('READ', LUN, IND, LINE, IERR)
         IF (IERR.EQ.0) THEN
            I = JTRIM (LINE)
C                                       get Host name and site
            IF (LINE(1:1).EQ.'+') THEN
               KBP = 4
               CALL NXTSTR (LINE, 80, KBP, THOST, K)
               CALL NXTSTR (LINE, 80, KBP, TSITE, K)
               CALL NXTSTR (LINE, 80, KBP, TSITE, K)
C              CALL CHLTOU (16, THOST)
C              CALL CHLTOU (8, TSITE)
C                                       already mentioned
               DO 20 I = 1,NSITE
                  DO 15 J = 1,NHOST(I)
                     IF (THOST.EQ.HOSTS(J,I)) THEN
                        IF (TSITE.EQ.SITES(I)) THEN
                           WRITE (MSGTXT,1010) THOST, TSITE
                        ELSE
                           WRITE (MSGTXT,1011) THOST, TSITE, SITES(I)
                           END IF
                        CALL MSGWRT (6)
                        GO TO 10
                        END IF
 15                  CONTINUE
 20               CONTINUE
C                                       old site, new host
               DO 30 I = 1,NSITE
                  IF (TSITE.EQ.SITES(I)) THEN
                     NHOST(I) = NHOST(I) + 1
                     HOSTS(NHOST(I),I) = THOST
                     GO TO 10
                     END IF
 30               CONTINUE
C                                       new site and host
               NSITE = NSITE + 1
               NHOST(NSITE) = 1
               HOSTS(1,NSITE) = THOST
               SITES(NSITE) = TSITE
               END IF
            GO TO 10
C                                       I/O error
         ELSE IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1030) LFILE, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       end reading HOSTS.LIST
      CALL ZTXCLS (LUN, IND, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Read NETSP file
      NDISK = 0
      CALL FILL (NETSP, 0, NNUSE)
      LFILE = 'NET0:NETSP'
      CALL ZTXOPN ('READ', LUN, IND, LFILE, .FALSE., IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Read loop
 50   CONTINUE
         CALL ZTXIO ('READ', LUN, IND, LINE, IERR)
         IF (IERR.EQ.0) THEN
            I = JTRIM (LINE)
C                                       Non-comment: get disk name
            IF ((LINE.NE.' ') .AND. (LINE(1:1).NE.'#')) THEN
               KBP = 1
               CALL NXTSTR (LINE, 80, KBP, TDISK, K)
C              CALL CHLTOU (64, TDISK)
C                                       already defined
               DO 60 I = 1,NDISK
                  IF (TDISK.EQ.DISKS(I)) THEN
                     WRITE (MSGTXT,1050) TDISK
                     CALL MSGWRT (6)
                     GO TO 50
                     END IF
 60               CONTINUE
               NDISK = NDISK + 1
               DISKS(NDISK) = TDISK
               END IF
            GO TO 50
C                                       I/O error
         ELSE IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1030) LFILE, IERR
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       end reading NETSP
      CALL ZTXCLS (LUN, IND, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Check DADEVS.LIST.$SITE files
      DSITE = 0
      DO 200 I = 1,NSITE
         LFILE = 'NET0:DADEVS.LIST.' // SITES(I)
         MSGSUP = 32000
         CALL ZTXOPN ('QRED', LUN, IND, LFILE, .FALSE., IERR)
         MSGSUP = 0
C                                       file exists: read
         IF (IERR.EQ.0) THEN
            DSITE = DSITE + 1
            MSGTXT = 'Checking DADEVS.LIST.' // SITES(I)
            CALL MSGWRT (4)
 110        CALL ZTXIO ('READ', LUN, IND, LINE, IERR)
            IF ((IERR.EQ.0) .AND. (LINE(1:1).NE.'#') .AND.
     *         (LINE.NE.' ')) THEN
               J = JTRIM (LINE)
               TDISK = LINE(4:)
C              CALL CHLTOU (64, TDISK)
C                                       find HOST attached
               THOST = ' '
               DO 120 J = 1,NSITE
                  DO 115 K = 1,NHOST(J)
                     JJ = JTRIM (HOSTS(K,J))
                     AHOST = HOSTS(K,J)(:JJ) // '_'
                     II = INDEX (TDISK, AHOST(:JJ+1))
                     IF (II.GT.0) THEN
                        NHUSE(K,J) = NHUSE(K,J) + 1
                        IF (THOST.EQ.' ') THEN
                           THOST = HOSTS(K,J)
                        ELSE
                           WRITE (MSGTMP,1110) THOST, AHOST, TDISK
                           CALL REFRMT (MSGTMP, '_', II)
                           MSGTXT = MSGTMP
                           CALL MSGWRT (6)
                           END IF
                        END IF
 115                 CONTINUE
 120              CONTINUE
               IF (THOST.EQ.' ') THEN
                  WRITE (MSGTXT,1120) TDISK
                  CALL MSGWRT (6)
                  END IF
C                                       Open SPACE file to test
               JJ = JTRIM (TDISK)
               SFILE = TDISK(:JJ) // '/SPACE'
               MSGTXT = 'Opening SPACE file on ' // TDISK
               CALL MSGWRT (1)
               CALL ZTXOPN ('QRED', SLUN, SIND, SFILE, .FALSE., IERR)
               IF (IERR.EQ.0) THEN
                  CALL ZTXCLS (SLUN, SIND, IERR)
               ELSE
                  MSGTXT = 'Open SPACE failed on ' // TDISK
                  CALL MSGWRT (8)
                  END IF
C                                       Is it in NETSP
               JJ = 0
               DO 130 J = 1,NDISK
                  IF (TDISK.EQ.DISKS(J)) THEN
                     NNUSE(J) = NNUSE(J) + 1
                     JJ = J
                     END IF
 130              CONTINUE
               IF (JJ.LE.0) THEN
                  MSGTXT = 'NETSP DOES NOT CONTAIN ' // TDISK
                  CALL MSGWRT (7)
                  END IF
               GO TO 110
               END IF
            IF (IERR.EQ.0) THEN
               GO TO 110
            ELSE IF (IERR.NE.2) THEN
               WRITE (MSGTXT,1030) LFILE, IERR
               CALL MSGWRT (7)
               GO TO 999
               END IF
C                                       end reading DADEVS.LIST.site
            CALL ZTXCLS (LUN, IND, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 200     CONTINUE
C                                       Check DADEVS.LIST files
      IF (DSITE.LT.NSITE) THEN
         LFILE = 'NET0:DADEVS.LIST'
         CALL ZTXOPN ('QRED', LUN, IND, LFILE, .FALSE., IERR)
C                                       file exists: read
         IF (IERR.EQ.0) THEN
            MSGTXT = 'Checking DADEVS.LIST'
            CALL MSGWRT (4)
 210        CALL ZTXIO ('READ', LUN, IND, LINE, IERR)
            IF ((IERR.EQ.0) .AND. (LINE(1:1).NE.'#') .AND.
     *         (LINE.NE.' ')) THEN
               J = JTRIM (LINE)
               TDISK = LINE(4:)
C              CALL CHLTOU (64, TDISK)
C                                       find HOST attached
               THOST = ' '
               DO 220 J = 1,NSITE
                  DO 215 K = 1,NHOST(J)
                     JJ = JTRIM (HOSTS(K,J))
                     AHOST = HOSTS(K,J)(:JJ) // '_'
                     II = INDEX (TDISK, AHOST(:JJ+1))
                     IF (II.GT.0) THEN
                        NHUSE(K,J) = NHUSE(K,J) + 1
                        IF (THOST.EQ.' ') THEN
                           THOST = HOSTS(K,J)
                        ELSE
                           WRITE (MSGTMP,1110) THOST, AHOST, TDISK
                           CALL REFRMT (MSGTMP, '_', II)
                           MSGTXT = MSGTMP
                           CALL MSGWRT (6)
                           END IF
                        END IF
 215                 CONTINUE
 220              CONTINUE
               IF (THOST.EQ.' ') THEN
                  WRITE (MSGTXT,1120) TDISK
                  CALL MSGWRT (6)
                  END IF
C                                       Open SPACE file to test
               JJ = JTRIM (TDISK)
               SFILE = TDISK(:JJ) // '/SPACE'
               MSGTXT = 'Opening SPACE file on ' // TDISK
               CALL MSGWRT (1)
               CALL ZTXOPN ('QRED', SLUN, SIND, SFILE, .FALSE., IERR)
               IF (IERR.EQ.0) THEN
                  CALL ZTXCLS (SLUN, SIND, IERR)
               ELSE
                  MSGTXT = 'Open SPACE failed on ' // TDISK
                  CALL MSGWRT (8)
                  END IF
C                                       Is it in NETSP
               JJ = 0
               DO 230 J = 1,NDISK
                  IF (TDISK.EQ.DISKS(J)) THEN
                     NNUSE(J) = NNUSE(J) + 1
                     JJ = J
                     END IF
 230              CONTINUE
               IF (JJ.LE.0) THEN
                  MSGTXT = 'NETSP DOES NOT CONTAIN ' // TDISK
                  CALL MSGWRT (7)
                  END IF
               GO TO 210
               END IF
            IF (IERR.EQ.0) THEN
               GO TO 210
            ELSE IF (IERR.NE.2) THEN
               WRITE (MSGTXT,1030) LFILE, IERR
               CALL MSGWRT (7)
               GO TO 999
               END IF
C                                       end reading DADEVS.LIST
            CALL ZTXCLS (LUN, IND, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         END IF
C                                       was NETSP overused, underused?
      DO 300 I = 1,NDISK
         IF (NNUSE(I).LE.0) THEN
            MSGTXT = 'NETSP entry unused: ' // DISKS(I)
            CALL MSGWRT (6)
         ELSE IF (NNUSE(I).GT.1) THEN
            JJ = JTRIM (DISKS(I))
            JJ = MIN (JJ, 53)
            WRITE (MSGTXT,1300) NNUSE(I), DISKS(I)(:JJ)
            CALL MSGWRT (6)
            END IF
 300     CONTINUE
C                                       Was a host unused?
      DO 320 J = 1,NSITE
         DO 315 K = 1,NHOST(J)
            JJ = JTRIM (HOSTS(K,J))
            JJ = MIN (JJ, 40)
            IF (NHUSE(K,J).LE.0) THEN
               WRITE (MSGTXT,1310) HOSTS(K,J)(:JJ)
               CALL MSGWRT (6)
               END IF
 315        CONTINUE
 320     CONTINUE
C                                       Do $NET0/HOST/ files exist?
      CALL ZTRLOG (4, 'NET0', 80, XLATED, XLNB, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'UNABLE TO TRANSLATE NET0'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      DO 400 I = 1,NSITE
         DO 390 J = 1,NHOST(I)
            SFILE = XLATED(:XLNB) // '/' // HOSTS(J,I)
            JJ = JTRIM (SFILE)
            SFILE(JJ+1:) =  '/ACD000000\\;'
            MSGTXT = 'Opening ' // SFILE
            CALL MSGWRT (1)
            CALL ZTXOPN ('QRED', SLUN, SIND, SFILE, .FALSE., IERR)
            IF (IERR.EQ.0) THEN
               CALL ZTXCLS (SLUN, SIND, IERR)
            ELSE
               MSGTXT = 'Open AC failed on ' // HOSTS(J,I)
               CALL MSGWRT (8)
               END IF
 390        CONTINUE
 400     CONTINUE
C
 999  STOP
C-----------------------------------------------------------------------
 1010 FORMAT (A,' repeated for site ',A)
 1011 FORMAT (A,' listed for sites ',A,1X,A)
 1030 FORMAT (A,' I/O error',I6)
 1050 FORMAT ('Disk repeated in NETSP: ',A)
 1110 FORMAT ('Hosts ',A,1X,A,' found in ',A)
 1120 FORMAT ('No host name in ',A)
 1300 FORMAT ('NETSP entry used',I3,' times: ',A)
 1310 FORMAT ('Host ',A,' not mentioned in the DADEVS files.')
      END
      SUBROUTINE NXTSTR (KB, KBPLIM, KBP, ISTR, NCHAR)
C-----------------------------------------------------------------------
C   NXTSTR obtains a character value from a buffer - blank separators
C   Inputs:
C      KB      C*80     character buffer
C      KBPLIM  I        size of buffer
C      KBP     I        start position in KB
C   Outputs:
C      KBP     I        start position in KB next field
C      ISTR    C*(*)    packed string, blank filled
C      NCHAR   I        # characters (0 => no string found)
C-----------------------------------------------------------------------
      CHARACTER KB*80, ISTR*(*)
      INTEGER   KBPLIM, KBP, NCHAR
C
      INTEGER   JB, JJ, LMAX
C-----------------------------------------------------------------------
      NCHAR = 0
      LMAX = LEN (ISTR)
      ISTR = ' '
      IF (KBP.GT.KBPLIM) GO TO 999
C                                        skip leading blanks
 10   IF (KB(KBP:KBP).EQ.' ') THEN
         KBP = KBP + 1
         IF (KBP.GT.KBPLIM) GO TO 999
         GO TO 10
         END IF
C                                        find end
 15   JB = KBP
 20   KBP = KBP + 1
         IF (KBP.GT.KBPLIM) GO TO 25
         IF (KB(KBP:KBP).EQ.' ') GO TO 25
         GO TO 20
C                                        got it
 25   NCHAR = KBP - JB
      KBP = KBP + 1
      JJ = MIN (NCHAR, LMAX)
      NCHAR = MIN (NCHAR, LMAX)
      IF (NCHAR.NE.0) ISTR(1:JJ) = KB(JB:JB+JJ-1)
C                                        make null string ok
      IF (NCHAR.EQ.0) NCHAR = 1
C
 999  RETURN
      END

      SUBROUTINE BCTAB (OPCODE, BUFFER, IERR)
C-----------------------------------------------------------------------
C! I/O to baseline correction tables (following initialization by BCINI)
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2008
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to array geometry tables after setup by BCINI.
C   Inputs:
C      OPCODE   C*4        Operation code:
C                          'READ' = read entry from table.
C                          'WRIT' = write entry in table.
C                          'CLOS' = close file, flush on write
C      BUFFER   I(*)       I/O buffer and related storage, also defines
C                          file if open. Should have been returned by
C                          BCINI.
C   Inputs via common:
C      IBCRNO   I          Next scan number to read or write.
C      BCKOLS   I(MAXBCC)  The column pointer array in order:
C                          TIME, SOURCE ID, ARRAY, ANTENNA NOS.,
C                          FREQID, REAL_M, IMAG_M, REAL_A, IMAG_A
C      BCNUMV   I(MAXBCC)  Element count in each column.
C      NUMBND   I          # band's (IF's) in data
C   Input/output: (written to or read from antenna file)
C      TIME     R          Time of centre of interval since 0hr on
C                          reference day (days)
C      ISRC     I          Source number
C      ANTS     I(2)       1st and 2nd antennas of baseline to be
C                          corrected.
C      IARRAY   I          Array number
C      IFQID    I          Freq ID number
C      RLMUL    R(*)       Real part of multiplicative correction
C      IMMUL    R(*)       Imag part of multiplicative correction
C      RLADD    R(*)       Real part of additive correction
C      IMADD    R(*)       Imag part of additive correction
C                          where * is  one-dimensional implementing
c                          (NOSTKD,NOBAND)
C   Output:
C      IBCRNO   I          Next row number.
C      IERR     I          Error code, 0=>OK else TABIO error.
C                          Note: -1=> read but record deselected.
C   Usage NOTE: use the include 'DBCV.INC' for the declarations in
C   BCINI and BCTAB.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:DGLB.INC'
      CHARACTER OPCODE*4
      INTEGER   BUFFER(*), IERR
C
      LOGICAL   DOREAD, DOCLOS
      INTEGER   NCOPY
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DBCV.INC'
      INTEGER   RECI(MAXREC)
      REAL      RECORD(MAXREC)
      HOLLERITH RECH(MAXREC)
      DOUBLE PRECISION RECD(MAXRCD)
      EQUIVALENCE (RECD, RECORD, RECI, RECH)
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
      DOCLOS = OPCODE.EQ.'CLOS'
C                                       Branch for CLOS
      IF (DOCLOS) GO TO 800
C                                       If write fill RECORD
      IF (.NOT.DOREAD) THEN
C                                       Time
         RECORD(BCKOLS(KTIM)) = TIME
C                                       Source name
         RECI(BCKOLS(KSOU)) = ISRC
C                                       Antenna number
         RECI(BCKOLS(KANO)) = ANTS(1)
         RECI(BCKOLS(KANO) + 1) = ANTS(2)
C                                       Array number
         RECI(BCKOLS(KARR)) = IARRAY
C                                       Freqid number
         RECI(BCKOLS(KFQI)) = IFQID
C                                       REAL_M
         NCOPY = BCNUMV(KRM)
         CALL RCOPY (NCOPY, RLMUL, RECORD(BCKOLS(KRM)))
C                                       IMAG_M
         NCOPY = BCNUMV(KIM)
         CALL RCOPY (NCOPY, IMMUL, RECORD(BCKOLS(KIM)))
C                                       REAL_A
         NCOPY = BCNUMV(KRA)
         CALL RCOPY (NCOPY, RLADD, RECORD(BCKOLS(KRA)))
C                                       IMAG_A
         NCOPY = BCNUMV(KIA)
         CALL RCOPY (NCOPY, IMADD, RECORD(BCKOLS(KIA)))
         END IF
C                                       Process record.
 50   CALL TABIO (OPCODE, 0, IBCRNO, RECORD, BUFFER, IERR)
      IBCRNO = IBCRNO + 1
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABIO', 'BCTAB', IERR)
         GO TO 990
         END IF
      IF (IERR.LT.0) GO TO 50
C                                       If READ pick data from RECORD.
      IF (DOREAD) THEN
C                                       Time
         TIME = RECORD(BCKOLS(KTIM))
C                                       Source name
         ISRC = RECI(BCKOLS(KSOU))
C                                       Antenna number
         ANTS(1) = RECI(BCKOLS(KANO))
         ANTS(2) = RECI(BCKOLS(KANO) + 1)
C                                       Array number
         IARRAY = RECI(BCKOLS(KARR))
C                                       Freqid number
         IFQID = RECI(BCKOLS(KFQI))
C                                       REAL_M
         NCOPY = BCNUMV(KRM)
         CALL RCOPY (NCOPY, RECORD(BCKOLS(KRM)), RLMUL)
C                                       IMAG_M
         NCOPY = BCNUMV(KIM)
         CALL RCOPY (NCOPY, RECORD(BCKOLS(KIM)), IMMUL)
C                                       REAL_A
         NCOPY = BCNUMV(KRA)
         CALL RCOPY (NCOPY, RECORD(BCKOLS(KRA)), RLADD)
C                                       IMAG_A
         NCOPY = BCNUMV(KIA)
         CALL RCOPY (NCOPY, RECORD(BCKOLS(KIA)), IMADD)
         END IF
         GO TO 999
C                                       Close
 800  CALL TABIO ('CLOS', 0, IBCRNO, RECORD, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'BCTAB', IERR)
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1800) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1800 FORMAT ('BCTAB: TABIO ERROR',I5)
      END

      SUBROUTINE PLTVSZ (VPCORN, BLC, TRC, CATR, VBLC, VTRC, VASEC)
C-----------------------------------------------------------------------
C! Find size of box for polarization vector plot
C# Map Plot
C-----------------------------------------------------------------------
C;  Copyright (C) 2019, 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PLTVSZ figures out the size and scale of the polarization vector
C   Inputs:
C      VPCORN   I        Code indicating where to put the plot
C                           1: lower left-hand corner
C                           2: lower right-hand corner
C                           3: upper left-hand corner
C                           4: upper right-hand corner
C      CATR     R(256)   Map header.
C   Output:
C      VBLC     I(2)     vector box BLC
C      VTRC     I(2)     Vector box TRC
C      IERR     I        Error code. 0: success,
C                            -1: HPBW not defined
C                            -2: plot too big
C-----------------------------------------------------------------------
      INTEGER   VBLC(2), VTRC(2), VPCORN
      REAL      CATR(256), BLC(7), TRC(7), VASEC
C
      REAL     X, X0, XM, Y, DX, DY, Y0, YM, YC(24)
      INTEGER  I, K
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      DATA YC /0.001, 0.002, 0.005, 0.01, 0.02, 0.05, 0.1, 0.2, 0.5,
     *   1.0, 2.0, 5.0, 10.0, 20.0, 50.0, 100.0, 200.0, 500.0, 1000.,
     *   2000., 5000., 10000., 20000., 50000./
C-----------------------------------------------------------------------
      VBLC(1) = 0.0
      VTRC(1) = 0.0
      VBLC(2) = 0.0
      VTRC(2) = 0.0
      IF (AXTYP(LOCNUM).NE.1) GO TO 999
      IF ((LABTYP(LOCNUM).NE.56) .AND. (LABTYP(LOCNUM).NE.65)) GO TO 999
C
      X = (TRC(1) - BLC(1)) * ABS (CATR(KRCIC)) * 3600.0
      DO 10 I = 1,24
         K = X / YC(25-I)
         IF ((K.GE.9.0) .AND. (K.LE.18.0)) THEN
            Y = YC(25-I)
            GO TO 30
            END IF
 10      CONTINUE
      DO 20 I = 1,24
         K = X / YC(25-I)
         IF ((K.GE.7.0) .AND. (K.LE.25.0)) THEN
            Y = YC(25-I)
            GO TO 30
            END IF
 20      CONTINUE
 30   VASEC = Y
C                                       Compute scaling
      DX = 1.0
      DY = 1.0
      IF (CATR(KRCIC).NE.0.0) DX = 1.0 / (ABS(CATR(KRCIC)) * 3600.)
      IF (CATR(KRCIC+1).NE.0.0) DY = 1.0 / (ABS(CATR(KRCIC+1)) * 3600.)
      XM = Y * DX
      YM = Y * DY
      IF (VPCORN.EQ.1) THEN
         X0 = BLC(1) + XM/2.0
         Y0 = BLC(2) + YM/2.0
      ELSE IF (VPCORN.EQ.2) THEN
         X0 = TRC(1) - 2.5 * XM
         Y0 = BLC(2) + YM/2.0
      ELSE IF (VPCORN.EQ.3) THEN
         X0 = TRC(1) - 2.5 * XM
         Y0 = TRC(2) - 1.5 * YM
      ELSE IF (VPCORN.EQ.4) THEN
         X0 = BLC(1) + XM/2.0
         Y0 = TRC(2) - 1.5 * YM
         END IF
      IF ((X0.LT.BLC(1)) .OR. (X0+2.*XM.GT.TRC(1)) .OR.
     *   (Y0.LT.BLC(2)) .OR. (Y0+YM.GT.TRC(2))) GO TO 999
C                                       Draw a box around the beam
      VBLC(1) = X0 + 0.02
      VTRC(1) = X0 + 2.0 * XM
      VBLC(2) = Y0 + 0.02
      VTRC(2) = Y0 + YM + 0.98
C
 999  RETURN
      END

LOCAL INCLUDE 'PROFL.INC'
      REAL      PRUSER, SEQIN, DSKIN, BLC(7), TRC(7), XYRATO, ZXRATO,
     *   PFROT, SKEW, ODIST, XINC, YINC, RANGE(2), TLABEL, DOCIRC,
     *   XINVER, STMULT, XDOTV, XGRCH, XTVCRN(2)
      HOLLERITH XNAMIN(3), XCLSIN(2)
      CHARACTER NAMIN*12, CLSIN*6
      COMMON /INPARM/ PRUSER, XNAMIN, XCLSIN, SEQIN, DSKIN, BLC, TRC,
     *   XYRATO, ZXRATO, PFROT, SKEW, ODIST, XINC, YINC, RANGE,
     *   TLABEL, DOCIRC, XINVER, STMULT, XDOTV, XGRCH, XTVCRN
      COMMON /CHPARM/ NAMIN, CLSIN
LOCAL INCLUDE 'PROFL2.INC'
      REAL      SINSKW, COSSKW, SINROT, COSROT, OX, OY, ZDIST, Z0, ZR,
     *   ZMAX, ZMIN, CSIZX, CSIZY, XL, YL, XCOSRO, XSINRO, XOX, YOX
      INTEGER   LOW, NBKTS
      COMMON /CPFI/ SINSKW, COSSKW, SINROT, COSROT, OX, OY, ZDIST,
     *   Z0, ZR, ZMAX, ZMIN, CSIZX, CSIZY, XL, YL, XCOSRO, XSINRO,
     *   XOX, YOX, LOW, NBKTS
LOCAL END
      PROGRAM PROFL
C-----------------------------------------------------------------------
C! Task to produce a profile plot of an image.
C# Map Map-util Plot-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2002-2003, 2009, 2011, 2014-2015,
C;  Copyright (C) 2019, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   PROFL will write commands to a plot file for the execution
C   of a profile plot for a cataloged image file.  The program
C   runs as a detached task initiated from AIPS. First a cataloged
C   file is found using data passed from AIPS.  The list of
C   associated files is searched for PLot files to find the highest
C   version number.  Then a PLot file is created for this map and the
C   catalog header is updated.  Next the graphics commands are
C   written to the plot file.
C    Inputs:   (from AIPS)
C              USERID   R   user number, 0 means use logon user
C                       number, 32000 means any user can be accessed.
C              INNAME   R(3)   name of primary file.
C              INCLASS  R(2)   class of primary file.
C              INSEQ    R   sequence number of primary file.
C              INDISK   R   disk volume number. 0 means try all.
C              BLC      R(7)   the coordinate in the input file to
C                       become the left hand coordinate (1,1) of the
C                       contour plot.  BLC(1) is the X coordinate and
C                       BLC(2) is the Y coordinate.  The first
C                       coordinate in the input image is (1,1).
C              TRC      R(7)   the coordinate in the input file to
C                       become the top right hand corner of the
C                       contour plot. The conventions for BLC hold.
C              XYRATIO  R   the ratio between the scale factor to use
C                       for the X axis and the scale factor to use
C                       for the Y axis.
C              ZXRATIO  R   the ratio (Z/X) between the length of the
C                       unrotated X axis and the maximum height of the
C                       Z axis.
C              ROTATION R   the rotation in degrees of the X-Y plane
C                       about the Z axis counter clockwise.
C              SKEW     R   the rotation in degrees of the plot away
C                       from the initial X-Y plane.
C              DIST     Distance of the observer from the map center
C                       in X axis lengths.
C              XINC     R   draw a line along every XINCth column.  0
C                       means do not draw lines in the Y direction.
C              YINC     R   draw a line along every YINCth row.  0
C                       means do not draw lines in the X direction.
C              PIXRANGE R(2)   the maximum and minimum values allowed
C                       for the map.  All other values will be clipped.
C                       If PIXRANGE(1).GE.PIXRANGE(2) then the map max
C                       and min will be used.
C              LTYPE    R   the type of axis labeling to use for this
C                       plot: 1 = None, 2 = no ticks, 3 = Ra/Dec,
C                       4 = center-rel,  5 = subim center-rel
C              DOCIRCLE R   >0 draw coordinate grids, else just ticks
C              INVERS   R    ST file version number.
C              STFACTOR R    scale star sizes in file for plotting:
C                              0 => no plot of stars.
C      DOTV     R      > 0 => TV, else plot file
C      GRCHAN   R      graphics channel to use
C      TVCORN   R(2)   TV pixel to use (both > 0 => pixel scale)
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PMAD.INC'
      CHARACTER IGFILE*48, PRGNAM*6, TYPIN*2, OPCODE*4
      REAL   BCKTS(6000), RANGE2(2), IBUFF(MABFSS), IWBUFF(MABFSS)
      INTEGER   IBLKOF, IDEPTH(5), NBYBUF, INVER, IGBUFF(256), IWIN(4),
     *   IROUND, IERR, IGFIND, IGLUN, IGSIZE, ILABEL, J, I, IMFIND,
     *   IMLUN, INPRMS, IRETCD, ISEQ, ISLOT, ITYPE, IUSER, IXINC, IYINC,
     *   IVER, IVOL, GRCHN, TVCHN, TVCORN(2)
      LOGICAL   NOSAVE, QUICK, SAVE, T, DOGRID, DOTV
      INCLUDE 'PROFL.INC'
      INCLUDE 'PROFL2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA IMLUN, IGLUN /16, 26/
      DATA PRGNAM /'PROFL '/
      DATA NOSAVE, SAVE, T /.FALSE.,.TRUE.,.TRUE./
C-----------------------------------------------------------------------
C                                       Initialize the IO parameters.
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
C                                       Get input values from AIPS.
C                                       Dammit, CHECK INPARM!!!
C                                       Was 41, set to 39.
      INPRMS = 39
      IRETCD = 0
      CALL GTPARM (PRGNAM, INPRMS, QUICK, PRUSER, IWBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         IRETCD = 1
         END IF
      IF (QUICK) CALL RELPOP (IRETCD, IWBUFF, IERR)
      IF (IRETCD.NE.0) GO TO 999
      PRUSER = NLUSER
C
      NBKTS = 6000
      DO 25 I = 1,NBKTS
         BCKTS(I) = -32769.0
 25      CONTINUE
C                                       Hollerith -> char
      CALL H2CHR (12, 1, XNAMIN, NAMIN)
      CALL H2CHR (6, 1, XCLSIN, CLSIN)
      IXINC = IROUND(XINC)
      IYINC = IROUND(YINC)
      ISEQ = IROUND(SEQIN)
      IVOL = IROUND(DSKIN)
      ILABEL = IROUND (TLABEL)
      I = MOD (ABS(ILABEL), 100)
      IF ((I.EQ.0) .OR. (I.GT.10)) THEN
         IF (ILABEL.GE.0) THEN
            ILABEL = (ILABEL/100)*100 + 3
         ELSE
            ILABEL = (ILABEL/100)*100 - 3
            END IF
         END IF
      TLABEL = ILABEL
      IUSER = NLUSER
      IBLKOF = 1
      IRETCD = 4
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = 1
      TVCORN(1) = IROUND (XTVCRN(1))
      TVCORN(2) = IROUND (XTVCRN(2))
C                                       Open map file & get header.
      TYPIN = 'MA'
      OPCODE = 'HDWR'
      IF (DOTV) OPCODE = 'READ'
      CALL MAPOPN (OPCODE, IVOL, NAMIN, CLSIN, ISEQ, TYPIN, IUSER,
     *   IMLUN, IMFIND, ISLOT, CATBLK, IWBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1015) IERR, NAMIN, CLSIN, ISEQ, IVOL, IUSER
         CALL MSGWRT (8)
         GO TO 995
         END IF
C                                       Add extension file to header.
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', IVOL, ISLOT, CATBLK, IWBUFF, SAVE, 'READ',
     *      IVER, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       check ST plot parms
      I = 0
      IF (XINVER.LT.0.0) STMULT = 0.0
      IF (STMULT.NE.0.0) CALL FNDEXT ('ST', CATBLK, I)
      IF (I.GT.0) THEN
         J = XINVER + 0.1
         IF (J.LE.0) J = I
         XINVER = J
      ELSE
         XINVER = 0
         STMULT = 0.0
         END IF
      INVER = IROUND (XINVER)
C                                       set window parms
      CALL WINDOW (CATBLK(KIDIM), CATBLK(KINAX), BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 965
      IDEPTH(1) = IROUND(BLC(3))
      IDEPTH(2) = IROUND(BLC(4))
      IDEPTH(3) = IROUND(BLC(5))
      IDEPTH(4) = IROUND(BLC(6))
      IDEPTH(5) = IROUND(BLC(7))
      LOCNUM = 1
C                                       Default XYRATO: ratio of
C                                       incr if related.
      IF ((XYRATO.LE.0.01) .OR. (XYRATO.GT.320.0)) THEN
         CALL SETLOC (IDEPTH, T)
         IF ((AXTYP(LOCNUM).EQ.1) .AND. (CATR(KRCIC+1).NE.0.0)) XYRATO =
     *      ABS (CATR(KRCIC) / CATR(KRCIC+1))
         IF (((XYRATO.LE.0.04) .OR. (XYRATO.GT.50.)) .AND.
     *      (TRC(1).NE.BLC(1))) XYRATO = (TRC(2)-BLC(2)) /
     *      (TRC(1)-BLC(1))
         IF ((XYRATO.LE.0.04) .OR. (XYRATO.GT.50.)) XYRATO = 1.0
         END IF
C                                       Build file name.
      CALL ZPHFIL ('PL', IVOL, ISLOT, IVER, IGFILE, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020)
         CALL MSGWRT (7)
         GO TO 965
         END IF
C                                       Init graph file.
C                                       Set approx file size.
      IGSIZE =1
      ITYPE = 4
      CALL GINIT (IVOL, ISLOT, IGFILE, IGSIZE, ITYPE, INPRMS, PRUSER,
     *   DOTV, TVCHN, GRCHN, TVCORN, CATBLK, IGBUFF, IGLUN, IGFIND,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR
         CALL MSGWRT (7)
         GO TO 965
         END IF
C                                       Calculate block offset.
      CALL COMOFF (CATBLK(KIDIM), CATBLK(KINAX), IDEPTH, IBLKOF, IERR)
      IF (IERR.NE.0) GO TO 960
      IBLKOF = IBLKOF + 1
C                                       Find allowed max and min.
      CALL RNGSET (RANGE, CATR(KRDMX), CATR(KRDMN), RANGE2)
C                                           Set some common values.
      ZMAX = RANGE2(2)
      ZMIN = RANGE2(1)
      Z0 = 0.0D0
      ZR = (TRC(1) - BLC(1) + 1) / (ZMAX - Z0)  *  ZXRATO * XYRATO
      ZDIST = ODIST * (TRC(1) - BLC(1) + 1) * XYRATO
C                                       Write axis labeling commands.
      DOGRID = DOCIRC.GT.0.0
      CALL PFAXIS (IGBUFF, ILABEL, BLC, TRC, IDEPTH, XYRATO, PFROT,
     *   SKEW, IWIN, DOGRID, IVER, IERR)
      IF (IERR.NE.0) GO TO 950
C                                       Draw stars
      CALL PFSTAR (STMULT, IVOL, ISLOT, INVER, BLC, TRC, IGBUFF, IERR)
      IF (IERR.GE.3) GO TO 950
      CALL GLTYPE (2, IGBUFF, IERR)
      IF (IERR.NE.0) GO TO 950
C                                       Init for double buff read.
      NBYBUF = MABFSS * 2
      CALL MINIT ('READ', IMLUN, IMFIND, CATBLK(KINAX), CATBLK(KINAX+1),
     *   IWIN, IBUFF, NBYBUF, IBLKOF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         CALL MSGWRT (8)
         GO TO 960
         END IF
C                                       Draw 3D contour lines.
      CALL PFDRAW (IMLUN, IMFIND, IWIN, IXINC, IYINC, IBUFF,
     *   IWBUFF, IGBUFF, BCKTS, IERR)
      IF (IERR.NE.0) GO TO 950
C                                       Write 'finish graph' command.
      CALL GFINIS (IGBUFF, IERR)
C                                       Write sucessful finish message.
      IF (IERR.NE.0) GO TO 960
         IF (.NOT.DOTV) THEN
            CALL HIPLOT (IVOL, ISLOT, IVER, IGBUFF, IERR)
            WRITE (MSGTXT,1070) IVER
            CALL MSGWRT (2)
            END IF
         IRETCD = 0
         GO TO 980
C-----------------------------------------------------------------------
C                                       Graph writing error.
 950  WRITE (MSGTXT,1950)
      CALL MSGWRT (8)
C                                       Try to do finish.
      CALL GFINIS (IGBUFF, IERR)
      IF (IERR.EQ.0) THEN
         IF (.NOT.DOTV) CALL HIPLOT (IVOL, ISLOT, IVER, IGBUFF, IERR)
         GO TO 980
         END IF
C                                       Finish not sucessful. Destroy.
 960  IF (.NOT.DOTV) THEN
         CALL ZCLOSE (IGLUN, IGFIND, IERR)
         CALL ZDESTR (IVOL, IGFILE, IERR)
         END IF
 965  IF (.NOT.DOTV) CALL DELEXT ('PL', IVOL, ISLOT, 'READ', CATBLK,
     *   IWBUFF, IVER, IERR)
 970  CALL ZCLOSE (IMLUN, IMFIND, IERR)
      IRETCD = 8
      GO TO 995
C                                       Close map file.
 980  CALL MAPCLS ('READ', IVOL, ISLOT, IMLUN, IMFIND, CATBLK, NOSAVE,
     *   IWBUFF, IERR)
C
 995  CALL DIETSK (IRETCD, QUICK, IWBUFF)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR GETTING PARAMETERS FROM AIPS. GTPARM ERR =',I5)
 1015 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' (MA) DISK=',I3,
     *   ' USID=',I5)
 1020 FORMAT ('COULD NOT BUILD GRAPH FILE NAME')
 1030 FORMAT ('GRAPH FILE INIT ERROR. GINIT ERR =',I5)
 1040 FORMAT ('MINIT ERROR =',I5)
 1070 FORMAT ('Successful plot file version',I5,'  created.')
 1950 FORMAT ('Error during graphing will try to finish partial graph')
      END
      SUBROUTINE PFAXIS (IBUFF, ILAB, BLC, TRC, IDEPTH, XYR, PFROT,
     *   SKEW, IWIN, DOGRID, IVER, IERR)
C-----------------------------------------------------------------------
C   PFAXIS is an axis drawing and labelling routine for use with
C   the profile program.  The routine will set the parameters for
C   proper scalling by calling PFSCAL and then draw the axis and
C   labeling.
C   Inputs:
C      IBUFF    I(256)   The output buffer used in writting
C                        graph commands to the graph file.
C      ILAB     I        the type of labeling to use.
C      BLC      R(7)     X and Y pixels to form bottom left hand
C                        corner of the graph.
C      TRC      R(7)     X and Y pixels to form the top right hand
C                        corner of the graph.
C      IDEPTH   I(5)     the depth of the plot plane along the
C                        other 5 axis.
C      XYR      R        ratio between the scale factor to use for
C                        for the X axis to the scale factor to user for
C                        the Y axis.
C      PFROT    R        rotation of X axis counter clockwise.
C      SKEW     R        rotation of X axis away from Y axis.
C      DOGRID   L        do full grid? or just ticks
C   Output:
C      IBUFF    I(256)   the updated graphics output buffer.
C      IWIN     I(4)     calculated map window.
C      IERR     I        error indicator: 0 = No error.
C-----------------------------------------------------------------------
      CHARACTER SPRTXT*80, PLABEL(9)*16, ELABEL(2)*8, LABTXT(2)*80,
     *   ATIME*8, ADATE*12, BJUNK*8
      REAL   BLC(7), CH(4), TRC(7), HBLC(2), HTRC(2), NBLC(2), NTRC(2),
     *   DCX, DCY, X, X0, X1, XBRAT, XR, XYR, Y, Y0, Y1, YGAP,
     *   DUMCH(4), PFROT, SKEW
      INTEGER   IWIN(4), NTEXT, IDEPTH(5), IBUFF(256), IERR, ILAB,
     *   NLABEL(9), IANGL, INCHAR, I, IERR2, IROUND, IE, IEPO, IT(3),
     *   ID(3), IVER, LTYPE
      LOGICAL   FWD, SLICE, DOGRID
      INCLUDE 'PROFL2.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA NLABEL /14, 13, 14, 13, 15, 11, 12, 10, 11/
      DATA PLABEL /'Ecliptic long.  ', 'Ecliptic lat.   ',
     *   'Galactic long.  ', 'Galactic lat.   ', 'Right Ascension ',
     *   'Declination     ', 'Time (hours)    ', 'HA (hours)     ',
     *   'LST (hours)     '/
      DATA SLICE /.FALSE./
      DATA XBRAT, DUMCH /25.0, 4*0.5/
      DATA ELABEL /' (B1950)', ' (J2000)'/
C-----------------------------------------------------------------------
C                                       Initial values.
      XR = MAX (TRC(1) - BLC(1), TRC(2) - BLC(2)) / XBRAT
      NBLC(1) = BLC(1) - XR/XYR
      NBLC(2) = BLC(2) - XR
      NTRC(1) = TRC(1) + XR/XYR
      NTRC(2) = TRC(2) + XR
      X0 = NBLC(1)
      X1 = NTRC(1)
      Y0 = NBLC(2)
      Y1 = NTRC(2)
      IWIN(1) = BLC(1) + .5
      IWIN(2) = BLC(2) + .5
      IWIN(3) = TRC(1) + .5
      IWIN(4) = TRC(2) + .5
C                                       Set up labeling
      CH(1) = 0.0
      CH(2) = 0.0
      LTYPE = MOD (ABS(ILAB), 100)
      IF (LTYPE.LT.7) CH(2) = 1.333
      CH(3) = 0.0
      CH(4) = 0.0
      YGAP = 0.
      CALL LABINI (NBLC, NTRC, IDEPTH, CH, ILAB, SLICE, YGAP, LABTXT,
     *   NTEXT)
C                                       Scale and set common CPFI.
      CALL PFSCAL (PFROT, SKEW, XYR, NBLC, NTRC, CH, FWD)
C                                       Read, draw from top to keep
C                                       hidden line perspective right.
      IF (.NOT.FWD) THEN
         IWIN(2) = IWIN(4)
         IWIN(4) = BLC(2) + .5
         END IF
C                                       Init for line drawing.
      X = 1.0
      CALL GINITL (NBLC, NTRC, X, DUMCH, IDEPTH, IBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (7)
         GO TO 999
         END IF
      CALL GLTYPE (1, IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Calculate profile coor.
      CALL PFXY (X0, Y0, Z0, X, Y)
C                                       Draw borders.
      CALL GPOS (X, Y, IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL PFXY (X1, Y0, Z0, X, Y)
      CALL GVEC (X, Y, IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL PFXY (X1, Y1, Z0, X, Y)
      CALL GVEC (X, Y, IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL PFXY (X0, Y1, Z0, X, Y)
      CALL GVEC (X, Y, IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL PFXY (X0, Y0, Z0, X, Y)
      CALL GVEC (X, Y, IBUFF, IERR)
      IF (IERR.NE.0) GO TO 980
      IF (LTYPE.EQ.1) GO TO 999
C                                       check epoch
      IEPO = IROUND (REPOCH(LOCNUM))
      IF (IEPO.EQ.1950) THEN
         IE = 1
      ELSE IF (IEPO.EQ.2000) THEN
         IE = 2
      ELSE
         IE = 0
         END IF
C                                       Text below
      IF ((NTEXT.GT.0) .AND. (LTYPE.LT.7)) THEN
         DCX = 0.0
         DO 45 I = 1,NTEXT
            DCY = -YGAP
            IANGL = 0
            CALL CHTRIM (LABTXT(I), 80, SPRTXT, INCHAR)
            CALL PFCHAR (INCHAR, IANGL, X0, Y0, DCX, DCY, SPRTXT,
     *         IBUFF, IERR)
            IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
            YGAP = YGAP + 1.333
 45         CONTINUE
         END IF
C                                       Source name, stokes, freq.
      IF (LTYPE.LT.7) THEN
         DCX = 0.0
         DCY = 0.5
         IANGL = 0
         SPRTXT = ' '
         CALL H2CHR (8, 1, CATH(KHOBJ), SPRTXT(1:8))
         INCHAR = 12
         IF (NCHLAB(1,LOCNUM).GT.0) THEN
            SPRTXT(INCHAR:) = SAXLAB(1,LOCNUM)(1:NCHLAB(1,LOCNUM))
            INCHAR = INCHAR + 3 + NCHLAB(1,LOCNUM)
            END IF
         IF (NCHLAB(2,LOCNUM).GT.0) THEN
            SPRTXT(INCHAR:) = SAXLAB(2,LOCNUM)(1:NCHLAB(2,LOCNUM))
            INCHAR = INCHAR + NCHLAB(2,LOCNUM)
            END IF
         CALL PFCHAR (INCHAR, IANGL, X0, Y1, DCX, DCY, SPRTXT, IBUFF,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         END IF
C                                       Date/time version
      IF ((ILAB.GT.1) .AND. (LTYPE.LT.7)) THEN
         DCY = DCY + 1.333
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, ATIME, ADATE)
         WRITE (SPRTXT,1050) IVER, ADATE, ATIME
         CALL REFRMT (SPRTXT, '_', INCHAR)
         CALL PFCHAR (INCHAR, IANGL, X0, Y1, DCX, DCY, SPRTXT, IBUFF,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         END IF
C                                       vertical axes
      I = LABTYP(LOCNUM) / 10
      IF (I.GT.9) I = 0
      IF (I.GT.0) THEN
         INCHAR = NLABEL(I)
         SPRTXT = PLABEL(I)
         IF ((IE.GT.0) .AND. ((I.EQ.5) .OR. (I.EQ.6))) THEN
            SPRTXT(INCHAR+1:) = ELABEL(IE)
            INCHAR = INCHAR + 8
            END IF
      ELSE
         SPRTXT = CPREF(2,LOCNUM) // CTYP(2,LOCNUM)
         CALL CHTRIM (SPRTXT, 25, SPRTXT, INCHAR)
         END IF
      Y = (Y1-Y0)/2.0 + Y0
      DCX = -CH(1) + 0.5
      DCY = INCHAR / 2.0 - 1.0
      IANGL = 1
      CALL PFCHAR (INCHAR, IANGL, X0, Y, DCX, DCY, SPRTXT, IBUFF, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
C                                       horizontal axes
      I = MOD (LABTYP(LOCNUM), 10)
      IF (I.GT.9) I = 0
      IF (I.GT.0) THEN
         INCHAR = NLABEL(I)
         SPRTXT = PLABEL(I)
         IF ((IE.GT.0) .AND. ((I.EQ.5) .OR. (I.EQ.6))) THEN
            SPRTXT(INCHAR+1:) = ELABEL(IE)
            INCHAR = INCHAR + 8
            END IF
      ELSE
         SPRTXT = CPREF(1,LOCNUM) // CTYP(1,LOCNUM)
         CALL CHTRIM (SPRTXT, 25, SPRTXT, INCHAR)
         END IF
      X = (X1-X0)/2.0 + X0
      DCX = -INCHAR / 2.0
      DCY = -2.833
      IF (LTYPE.EQ.2) DCY = -1.5
      IANGL = 0
      CALL PFCHAR (INCHAR, IANGL, X, Y0, DCX, DCY, SPRTXT, IBUFF, IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
C                                       Peak flux.
      IF (LTYPE.LT.7) THEN
         DCX = 0.0
         DCY = -YGAP
         IANGL = 0
         IF (IERR.NE.0) GO TO 980
         CALL H2CHR (8, 1, CATH(KHBUN), BJUNK)
         WRITE (SPRTXT,1130) CATR(KRDMX), BJUNK
         CALL REFRMT (SPRTXT, '_', INCHAR)
         CALL PFCHAR (INCHAR, IANGL, X0, Y0, DCX, DCY, SPRTXT, IBUFF,
     *      IERR)
         IF ((IERR.NE.0) .AND. (IERR.NE.2)) GO TO 980
         END IF
      IERR = 0
C                                       Tell tic marks position of
C                                       border, not pixels.
      HBLC(1) = X0
      HBLC(2) = Y0
      HTRC(1) = X1
      HTRC(2) = Y1
C                                       Figure out where tic marks go.
      IF (LTYPE.NE.2) THEN
         IF (AXINC(1,LOCNUM).NE.0) CALL PFTICS (1, HBLC, HTRC, XYR,
     *      DOGRID, IBUFF, IERR2)
         IF (AXINC(2,LOCNUM).NE.0) CALL PFTICS (2, HBLC, HTRC, XYR,
     *      DOGRID, IBUFF, IERR2)
         END IF
      GO TO 999
C                                       Graph drawing error.
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('GRAPH FILE INITIALIZATION ERROR. GINITL ERR =',I5)
 1050 FORMAT ('Plot',I4,' at ',A12,A8)
 1130 FORMAT ('Peak brightness =',1PE11.3,1X,A8)
 1980 FORMAT ('GRAPH LABEL WRITING ERROR. IERR =',I5)
      END
      SUBROUTINE PFTICS (IAXIS, BLC, TRC, XYRATO, DOACRS, IBUFF, IERR)
C-----------------------------------------------------------------------
C   PFTICS writes tick marks and tick labels to a plot file
C   Inputs:  IAXIS    I   1 => horizontal,  2 => vertical
C            BLC      R(2)   X AND Y pixels to form bottom left hand
C                     corner of the graph.
C            TRC      R(2)   X and Y pixels to form the top right hand
C                     corner of the graph.
C            XYRATO   R      X to Y ratio
C            DOACRS   L      full coord. grid or just ticks
C            IBUFF    I(256)   buffer being used for output to
C                     the graphics file.
C   OUTPUTS: IBUFF    I(256)   updated graphics I/O buffer.
C            IERR     I   error code: 0 => ok
C                                     1 => bad IAXIS
C                                     2 => graph drawing error
C                                     3 => tic algorithm fails
C-----------------------------------------------------------------------
      CHARACTER SPRTXT*48, CHDL*4
      DOUBLE PRECISION DEG, DEGC, DTX, DX, DTY, DY, PT5SEC, TICX, TICY,
     *   DEGC0, DEGC1, DEG0, XDT, YDT, LDX, LDY, LLDX, LLDY, XTRY,
     *   UPLIM, LOLIM, AYX
      REAL  BLC(2), TRC(2), XYRATO, DCX, DSP, X, Y, XR, YR, XT, YT, DCY,
     *   JUNK, FRACT, PXT, PYT, TICL, XTL, YTL, TICT
      INTEGER   HML(2), IBUFF(256), IAXIS, AXISTP, I, IANGL, IERR, ILEN,
     *   ITRY, COOTYP, INOI, JERR, BAD, ICINC, NCINC, DONMSG, CHKCNT
      LOGICAL   NONUM, DOACRS, FIRST, DOCHK
      INCLUDE 'PROFL2.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA NCINC /512/
C-----------------------------------------------------------------------
C                                       Assign initial values.
      IERR = 0
      IANGL = 0
C                                       Determine axis type.
      IF (IAXIS.EQ.2) THEN
C                                       vertical
         AYX = 0.0D0
         CALL TICINC (IAXIS, BLC, TRC, XYRATO, AYX, DEGC, DEG, INOI,
     *      TICX, TICY, TICL, PT5SEC, ITRY, IERR)
         IF (IERR.NE.0) GO TO 999
         UPLIM = 1.E20
         LOLIM = -1.E20
         IF ((AXTYP(LOCNUM).EQ.1) .OR. (AXTYP(LOCNUM).EQ.3)) THEN
            IF ((CORTYP(LOCNUM).EQ.1) .OR. (CORTYP(LOCNUM).EQ.6)) THEN
               UPLIM = 90.0D0
               LOLIM = -90.0D0
               END IF
            IF ((CORTYP(LOCNUM).EQ.2) .OR. (CORTYP(LOCNUM).EQ.5)) THEN
               UPLIM = RPVAL(2,LOCNUM) + 180.0D0
               LOLIM = RPVAL(2,LOCNUM) - 180.0D0
               END IF
            END IF
         DCX = -1.0
         DCY = -0.5
         BAD = 0
         IF ((DOACRS) .AND. (CORTYP(LOCNUM).GE.1) .AND.
     *      (CORTYP(LOCNUM).LE.4)) BAD = 1
         IF (AXFUNC(1,LOCNUM).GE.2) BAD = 2 * BAD
         IF ((AXFUNC(1,LOCNUM).EQ.4) .OR. (AXFUNC(1,LOCNUM).EQ.6) .OR.
     *      (AXFUNC(1,LOCNUM).EQ.8)) BAD = 2 * BAD
         IF (ABS(AXINC(1,LOCNUM)).GE.0.1) BAD = BAD * 1.51
         IF (ABS(AXINC(1,LOCNUM)).LE.0.005) BAD = BAD / 2
         TICX = TICX / (2*BAD + 1.)
         TICL = TICL / (2*BAD + 1.)
         AXISTP = LABTYP(LOCNUM) / 10
C                                       horizontal
      ELSE IF (IAXIS.EQ.1) THEN
         DCX = 0.5
         DCY = -1.5
         AYX = 0.0D0
         CALL TICINC (IAXIS, BLC, TRC, XYRATO, AYX, DEGC, DEG, INOI,
     *      TICX, TICY, TICL, PT5SEC, ITRY, IERR)
         IF (IERR.NE.0) GO TO 999
         IF ((AXTYP(LOCNUM).EQ.1) .OR. (AXTYP(LOCNUM).EQ.2)) THEN
            IF ((CORTYP(LOCNUM).EQ.2) .OR. (CORTYP(LOCNUM).EQ.4)) THEN
               UPLIM = 90.0D0
               LOLIM = -90.0D0
               END IF
            IF ((CORTYP(LOCNUM).EQ.1) .OR. (CORTYP(LOCNUM).EQ.3)) THEN
               UPLIM = RPVAL(1,LOCNUM) + 180.0D0
               LOLIM = RPVAL(1,LOCNUM) - 180.0D0
               END IF
            END IF
         BAD = 0
         IF ((DOACRS) .AND. (CORTYP(LOCNUM).GE.1) .AND.
     *      (CORTYP(LOCNUM).LE.6)) BAD = 1
         IF (AXFUNC(2,LOCNUM).GE.2) BAD = 2 * BAD
         IF ((AXFUNC(2,LOCNUM).EQ.4) .OR. (AXFUNC(2,LOCNUM).EQ.6) .OR.
     *      (AXFUNC(2,LOCNUM).EQ.8)) BAD = 2 * BAD
         IF (ABS(AXINC(2,LOCNUM)).GE.0.1) BAD = BAD * 1.51
         IF (ABS(AXINC(2,LOCNUM)).LE.0.005) BAD = BAD / 2
         TICY = TICY / (2*BAD + 1.)
         TICL = TICL / (2*BAD + 1.)
         AXISTP = MOD (LABTYP(LOCNUM), 10)
      ELSE
         GO TO 990
         END IF
C                                       Determine possible tic intervls
      NONUM = (CPREF(IAXIS,LOCNUM).EQ.' ') .AND.
     *   (CTYP(IAXIS,LOCNUM).EQ.' ')
      COOTYP = 2
      IF ((AXISTP.EQ.5) .OR. (AXISTP.EQ.7)) COOTYP = 1
      LDX = -1.D10
      LLDX = -1.D10
      LDY = -1.D10
      LLDY = -1.D10
C                                       Draw tic marks and values.
      JUNK = -32000
      CALL FILL (2, JUNK, HML)
      DEGC0 = DEGC
      FIRST = .TRUE.
      CHDL = '$$'
      DEG0 = DEG
      DEGC1 = DEGC0 - DEG
      DO 290 I = 1,INOI
         IF (IAXIS.NE.1) THEN
            DY = DEGC
            CALL FNDX (BLC(1), DY, DX, JERR)
            IF (JERR.NE.0) GO TO 285
         ELSE
            DX = DEGC
            CALL FNDY (BLC(2), DX, DY, JERR)
            IF (JERR.NE.0) GO TO 285
            END IF
C                                       Convert degrees to pixels.
         CALL XYPIX (DX, DY, X, Y, JERR)
         IF (JERR.NE.0) GO TO 285
         IF ((X.LT.BLC(1)-0.01) .OR. (X.GT.TRC(1)+0.01)) GO TO 285
         IF ((Y.LT.BLC(2)-0.01) .OR. (Y.GT.TRC(2)+0.01)) GO TO 285
         IF (DX.NE.LDX) LLDX = LDX
         IF (DY.NE.LDY) LLDY = LDY
         LDX = DX
         LDY = DY
         CALL PFXY (X, Y, Z0, XR, YR)
         CALL GPOS (XR, YR, IBUFF, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       Find end of tic.
         DTX = DX + SIGN (1.0, AXINC(1,LOCNUM)) * TICX
         DTY = DY + SIGN (1.0, AXINC(2,LOCNUM)) * TICY
         CALL XYPIX (DTX, DTY, XT, YT, JERR)
         IF (JERR.NE.0) GO TO 235
         TICT = SQRT ((XT-X)**2 + (YT-Y)**2)
         IF (TICL.LE.0.) TICL = 1.
         IF ((TICT.GT.TICL) .OR. (TICT.LT.0.1*TICL)) THEN
            IF (TICT.EQ.0.0) GO TO 235
            DTX = DX + SIGN (1.0, AXINC(1,LOCNUM)) * TICX * TICL / TICT
            DTY = DY + SIGN (1.0, AXINC(2,LOCNUM)) * TICY * TICL / TICT
            CALL XYPIX (DTX, DTY, XT, YT, JERR)
            IF (JERR.NE.0) GO TO 235
            END IF
         IF ((XT.LT.BLC(1)-0.01) .OR. (XT.GT.TRC(1)+0.01)) GO TO 235
         IF ((YT.LT.BLC(2)-0.01) .OR. (YT.GT.TRC(2)+0.01)) GO TO 235
C                                       Simple tick
         IF (.NOT.DOACRS) THEN
C                                       Position at end of tic.
            CALL PFXY (XT, YT, Z0, XR, YR)
            CALL GPOS (XR, YR, IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
C                                       Draw back to border.
            CALL PFXY (X, Y, Z0, XR, YR)
            CALL GVEC (XR, YR, IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
            DEGC1 = DEGC - DEG
            IF (FIRST) DEGC0 = DEGC
            FIRST = .FALSE.
C                                       Tick all way across
         ELSE
            DONMSG = IAXIS
 230        CONTINUE
               IF (DONMSG.EQ.1) WRITE (MSGTXT,1230) DEGC
               IF (DONMSG.EQ.2) WRITE (MSGTXT,1231) DEGC
               IF (DONMSG.GT.0) CALL MSGWRT (2)
               DONMSG = 0
               CALL PFXY (XT, YT, Z0, XR, YR)
               CALL GVEC (XR, YR, IBUFF, IERR)
               IF (IERR.NE.0) GO TO 980
               PXT = XT
               PYT = YT
               XDT = DTX
               YDT = DTY
               DTX = DTX + SIGN (1.0, AXINC(1,LOCNUM)) * TICX
               DTY = DTY + SIGN (1.0, AXINC(2,LOCNUM)) * TICY
               CALL XYPIX (DTX, DTY, XT, YT, JERR)
               IF (JERR.NE.0) GO TO 235
               TICT = SQRT ((XT-PXT)**2 + (YT-PYT)**2)
               IF ((TICT.GT.TICL) .OR. (TICT.LT.0.1*TICL)) THEN
                  IF (TICT.EQ.0.0) GO TO 235
                  DTX = XDT + SIGN (1.0, AXINC(1,LOCNUM)) * TICX *
     *               TICL/TICT
                  DTY = YDT + SIGN (1.0, AXINC(2,LOCNUM)) * TICY *
     *               TICL/TICT
                  CALL XYPIX (DTX, DTY, XT, YT, JERR)
                  IF (JERR.NE.0) GO TO 235
                  END IF
               IF ((XT.GE.BLC(1)) .AND. (XT.LE.TRC(1)) .AND.
     *            (YT.GE.BLC(2)) .AND. (YT.LE.TRC(2))) GO TO 230
            FRACT = 1.0
            IF (XT.LT.BLC(1)) FRACT = (BLC(1) - PXT) / (XT - PXT)
            IF (XT.GT.TRC(1)) FRACT = (TRC(1) - PXT) / (XT - PXT)
            IF (YT.LT.BLC(2)) FRACT = MIN (FRACT,
     *         (BLC(2) - PYT) / (YT - PYT))
            IF (YT.GT.TRC(2)) FRACT = MIN (FRACT,
     *         (TRC(2) - PYT) / (YT - PYT))
            XT = PXT + FRACT * (XT - PXT)
            YT = PYT + FRACT * (YT - PYT)
            CALL PFXY (XT, YT, Z0, XR, YR)
            CALL GVEC (XR, YR, IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
            IF ((IAXIS.EQ.2) .AND. ((XT.GT.TRC(1)) .OR. (XT.LT.BLC(1))))
     *         DEGC1 = DEGC - DEG
            IF ((IAXIS.EQ.1) .AND. ((YT.GT.TRC(2)) .OR. (YT.LT.BLC(2))))
     *         DEGC1 = DEGC - DEG
            IF (FIRST) DEGC0 = DEGC
            IF (FIRST) DEGC1 = DEGC - DEG
            FIRST = .FALSE.
            END IF
C                                       Label
 235     IF (.NOT.NONUM) THEN
            CALL PFXY (X, Y, Z0, XR, YR)
            CALL GPOS (XR, YR, IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
            CALL TICSTR (ITRY, DEGC, PT5SEC, AXISTP, COOTYP, CHDL, HML,
     *         SPRTXT, ILEN)
            DSP = DCX - ILEN
            CALL PFCHAR (ILEN, IANGL, X, Y, DSP, DCY, SPRTXT, IBUFF,
     *         IERR)
            IF (IERR.NE.0) GO TO 980
            END IF
 285     DEGC = DEGC - DEG
 290     CONTINUE
C                                       Draw tics for other side.
      IF (DOACRS) GO TO 395
C                                       Same intervals but not
C                                       necessarily same values.
C                                       vertical
      IF (IAXIS.NE.1) THEN
         CALL TICINC (6, BLC, TRC, XYRATO, AYX, DEGC, DEG, INOI,
     *      TICX, TICY, TICL, PT5SEC, ITRY, IERR)
         IF (IERR.NE.0) GO TO 395
C                                       horizontal
      ELSE
         CALL TICINC (5, BLC, TRC, XYRATO, AYX, DEGC, DEG, INOI,
     *      TICX, TICY, TICL, PT5SEC, ITRY, IERR)
         IF (IERR.NE.0) GO TO 395
         END IF
      IF (INOI.LE.0) GO TO 395
C                                       Loop for other border.
      DO 390 I= 1,INOI
         IF (IAXIS.NE.1) THEN
            DY = DEGC
            CALL FNDX (TRC(1), DY, DX, JERR)
            IF (JERR.NE.0) GO TO 380
         ELSE
            DX = DEGC
            CALL FNDY (TRC(2), DX, DY, JERR)
            IF (JERR.NE.0) GO TO 380
            END IF
C                                       Convert degrees to pixels.
         CALL XYPIX (DX, DY, X, Y, JERR)
         IF (JERR.NE.0) GO TO 380
         IF ((X.LT.BLC(1)-0.01) .OR. (X.GT.TRC(1)+0.01)) GO TO 380
         IF ((Y.LT.BLC(2)-0.01) .OR. (Y.GT.TRC(2)+0.01)) GO TO 380
C                                       Find end of tic.
         DTX = DX - SIGN (1.0, AXINC(1,LOCNUM)) * TICX
         DTY = DY - SIGN (1.0, AXINC(2,LOCNUM)) * TICY
         CALL XYPIX (DTX, DTY, XT, YT, JERR)
         IF (JERR.NE.0) GO TO 380
         TICT = SQRT ((XT-X)**2 + (YT-Y)**2)
         IF ((TICT.GT.TICL) .OR. (TICT.LT.0.1*TICL)) THEN
            IF (TICT.EQ.0.0) GO TO 380
            DTX = DX - SIGN (1.0, AXINC(1,LOCNUM)) * TICX * TICL/TICT
            DTY = DY - SIGN (1.0, AXINC(2,LOCNUM)) * TICY * TICL/TICT
            CALL XYPIX (DTX, DTY, XT, YT, JERR)
            IF (JERR.NE.0) GO TO 380
            END IF
C                                       Simple ticks ONLY
         IF ((XT.GE.BLC(1)-0.01) .AND. (XT.LE.TRC(1)+0.01) .AND.
     *      (YT.GE.BLC(2)-0.01) .AND. (YT.LE.TRC(2)+0.01)) THEN
C                                       Position at end of tic.
            CALL PFXY (XT, YT, Z0, XT, YT)
            CALL GPOS (XT, YT, IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
C                                       Draw back to border.
            CALL PFXY (X, Y, Z0, X, Y)
            CALL GVEC (X, Y, IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
            END IF
 380     DEGC = DEGC - DEG
 390     CONTINUE
C                                       Full curves from top?
 395     IF (.NOT.DOACRS) GO TO 999
 396        DEGC = DEGC0 - DEG0
            ICINC = 3
            I = 1 - ICINC
            XTRY = 0.0D0
 399     I = I + ICINC
         IF (I.GT.NCINC) GO TO 450
 400     DEGC = DEGC + DEG0
            IF ((DEGC.LT.LOLIM) .AND. (DEG0.LT.0.0D0)) GO TO 450
            IF ((DEGC.GT.UPLIM) .AND. (DEG0.GT.0.0D0)) GO TO 450
            IF ((DEGC.LT.LOLIM) .AND. (DEG0.GT.0.0D0)) GO TO 400
            IF ((DEGC.GT.UPLIM) .AND. (DEG0.LT.0.0D0)) GO TO 400
            CHKCNT = 0
            DOCHK = .FALSE.
            PXT = ((NCINC+1.-I)*BLC(1) + I*TRC(1)) / (NCINC+1.0)
            PYT = ((NCINC+1.-I)*BLC(2) + I*TRC(2)) / (NCINC+1.0)
            IF (IAXIS.EQ.2) DY = DEGC
            IF (IAXIS.EQ.2) CALL FNDX (PXT, DY, DX, JERR)
            IF (IAXIS.EQ.1) DX = DEGC
            IF (IAXIS.EQ.1) CALL FNDY (PYT, DX, DY, JERR)
            IF (JERR.EQ.0) GO TO 404
               IF (IAXIS.EQ.1) DY = LDY
               IF (IAXIS.EQ.2) DX = LDX
               CALL XYPIX (DX, DY, X, Y, JERR)
               IF (JERR.NE.0) GO TO 445
               IF ((X.LE.TRC(1)) .AND. (X.GE.BLC(1)) .AND.
     *            (Y.LE.TRC(2)) .AND. (Y.GE.BLC(2))) GO TO 404
               XTRY = XTRY + 1.0D0
               IF (XTRY.GT.50.0D0) GO TO 450
               IF (IAXIS.EQ.1) DY = LDY + XTRY * (LDY - LLDY)
               IF (IAXIS.EQ.2) DX = LDX + XTRY * (LDX - LLDX)
 404        CALL XYPIX (DX, DY, X, Y, JERR)
            IF (JERR.NE.0) GO TO 445
            IF ((X.GT.TRC(1)) .OR. (X.LT.BLC(1))) GO TO 445
            IF ((Y.GT.TRC(2)) .OR. (Y.LT.BLC(2))) GO TO 445
            XTRY = 0.0D0
            IF (DX.NE.LDX) LLDX = LDX
            IF (DY.NE.LDY) LLDY = LDY
            LDX = DX
            LDY = DY
 405        DONMSG = IAXIS
            IF (DONMSG.EQ.1) WRITE (MSGTXT,1230) DEGC
            IF (DONMSG.EQ.2) WRITE (MSGTXT,1231) DEGC
            IF (DONMSG.GT.0) CALL MSGWRT (2)
            DONMSG = 0
            XT = X
            YT = Y
            DTX = DX
            DTY = DY
            CALL PFXY (X, Y, Z0, XR, YR)
            CALL GPOS (XR, YR, IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
 410        CONTINUE
               PXT = XT
               PYT = YT
               CALL PFXY (XT, YT, Z0, XR, YR)
               IF ((XT.NE.X) .OR. (YT.NE.Y)) CALL GVEC (XR, YR, IBUFF,
     *            IERR)
               IF (IERR.NE.0) GO TO 980
               XDT = DTX
               YDT = DTY
               DTX = DTX + SIGN (1.0, AXINC(1,LOCNUM)) * TICX
               DTY = DTY + SIGN (1.0, AXINC(2,LOCNUM)) * TICY
               CALL XYPIX (DTX, DTY, XT, YT, JERR)
               IF (JERR.NE.0) GO TO 415
               TICT = SQRT ((XT-PXT)**2 + (YT-PYT)**2)
               IF ((TICT.LE.TICL) .AND. (TICT.GE.0.1*TICL)) GO TO 411
                  IF (TICT.EQ.0.0) GO TO 415
                  DTX = XDT + SIGN (1.0, AXINC(1,LOCNUM)) * TICX *
     *               TICL/TICT
                  DTY = YDT + SIGN (1.0, AXINC(2,LOCNUM)) * TICY *
     *               TICL/TICT
                  CALL XYPIX (DTX, DTY, XT, YT, JERR)
                  IF (JERR.NE.0) GO TO 415
 411           IF ((XT.GE.BLC(1)) .AND. (XT.LE.TRC(1)) .AND.
     *            (YT.GE.BLC(2)) .AND. (YT.LE.TRC(2))) GO TO 410
            IF (IAXIS.EQ.1) DOCHK = (XT.LT.BLC(1)) .OR. (XT.GT.TRC(1))
            IF (IAXIS.EQ.2) DOCHK = (YT.LT.BLC(2)) .OR. (YT.GT.TRC(2))
            XTL = XT
            YTL = YT
            FRACT = 1.0
            IF (XT.LT.BLC(1)) FRACT = (BLC(1) - PXT) / (XT - PXT)
            IF (XT.GT.TRC(1)) FRACT = (TRC(1) - PXT) / (XT - PXT)
            IF (YT.LT.BLC(2)) FRACT = MIN (FRACT,
     *         (BLC(2) - PYT) / (YT - PYT))
            IF (YT.GT.TRC(2)) FRACT = MIN (FRACT,
     *         (TRC(2) - PYT) / (YT - PYT))
            XT = PXT + FRACT * (XT - PXT)
            YT = PYT + FRACT * (YT - PYT)
            CALL PFXY (XT, YT, Z0, XR, YR)
            CALL GVEC (XR, YR, IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
 415        XT = X
            YT = Y
            DTX = DX
            DTY = DY
            CALL PFXY (X, Y, Z0, XR, YR)
            CALL GPOS (XR, YR, IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
 420        CONTINUE
               PXT = XT
               PYT = YT
               CALL PFXY (XT, YT, Z0, XR, YR)
               IF ((XT.NE.X) .OR. (YT.NE.Y)) CALL GVEC (XR, YR, IBUFF,
     *            IERR)
               IF (IERR.NE.0) GO TO 980
               XDT = DTX
               YDT = DTY
               DTX = DTX - SIGN (1.0, AXINC(1,LOCNUM)) * TICX
               DTY = DTY - SIGN (1.0, AXINC(2,LOCNUM)) * TICY
               CALL XYPIX (DTX, DTY, XT, YT, JERR)
               IF (JERR.NE.0) GO TO 425
               TICT = SQRT ((XT-PXT)**2 + (YT-PYT)**2)
               IF ((TICT.LE.TICL) .AND. (TICT.GE.0.1*TICL)) GO TO 421
                  IF (TICT.EQ.0.0) GO TO 425
                  DTX = XDT - SIGN (1.0, AXINC(1,LOCNUM)) * TICX *
     *               TICL/TICT
                  DTY = YDT - SIGN (1.0, AXINC(2,LOCNUM)) * TICY *
     *               TICL/TICT
                  CALL XYPIX (DTX, DTY, XT, YT, JERR)
                  IF (JERR.NE.0) GO TO 425
 421           IF ((XT.GE.BLC(1)) .AND. (XT.LE.TRC(1)) .AND.
     *            (YT.GE.BLC(2)) .AND. (YT.LE.TRC(2))) GO TO 420
            IF (.NOT.DOCHK) XTL = XT
            IF (.NOT.DOCHK) YTL = YT
            IF (IAXIS.EQ.1) DOCHK = (XT.LT.BLC(1)) .OR. (XT.GT.TRC(1))
     *         .OR. DOCHK
            IF (IAXIS.EQ.2) DOCHK = (YT.LT.BLC(2)) .OR. (YT.GT.TRC(2))
     *         .OR. DOCHK
            FRACT = 1.0
            IF (XT.LT.BLC(1)) FRACT = (BLC(1) - PXT) / (XT - PXT)
            IF (XT.GT.TRC(1)) FRACT = (TRC(1) - PXT) / (XT - PXT)
            IF (YT.LT.BLC(2)) FRACT = MIN (FRACT,
     *         (BLC(2) - PYT) / (YT - PYT))
            IF (YT.GT.TRC(2)) FRACT = MIN (FRACT,
     *         (TRC(2) - PYT) / (YT - PYT))
            XT = PXT + FRACT * (XT - PXT)
            YT = PYT + FRACT * (YT - PYT)
            CALL PFXY (XT, YT, Z0, XR, YR)
            CALL GVEC (XR, YR, IBUFF, IERR)
            IF (IERR.NE.0) GO TO 980
 425        IF (.NOT.DOCHK) GO TO 400
               IF (CHKCNT.GT.0) GO TO 400
               IF (BAD.LE.1) GO TO 400
               CHKCNT = 1
               IF (IAXIS.EQ.1) PYT = (YTL + TRC(2)) / 2.0
               IF (IAXIS.EQ.2) PXT = (XTL + TRC(1)) / 2.0
               YTL = TRC(2) - (YTL - BLC(2)) / 2.0
               XTL = TRC(1) - (XTL - BLC(1)) / 2.0
               IF (IAXIS.EQ.1) PYT = MAX (PYT, YTL)
               IF (IAXIS.EQ.2) PXT = MAX (PXT, XTL)
               IF (IAXIS.EQ.2) CALL FNDX (PXT, DY, DX, JERR)
               IF (IAXIS.EQ.1) CALL FNDY (PYT, DX, DY, JERR)
               IF (JERR.NE.0) GO TO 400
               CALL XYPIX (DX, DY, X, Y, JERR)
               IF (JERR.NE.0) GO TO 400
               IF ((X.GT.TRC(1)) .OR. (X.LT.BLC(1))) GO TO 400
               IF ((Y.GT.TRC(2)) .OR. (Y.LT.BLC(2))) GO TO 400
               GO TO 405
 445     DEGC = DEGC - DEG0
         GO TO 399
C                                       Do other direction
 450  IF (DEGC0.EQ.DEGC1) GO TO 999
         DEGC0 = DEGC1
         DEG0 = -DEG0
         GO TO 396
C                                       Graph drawing error.
 980  WRITE (MSGTXT,1980) IERR
      CALL MSGWRT (7)
      IERR = 2
      GO TO 999
C                                       Invalid axis type.
 990  WRITE (MSGTXT,1990)
      CALL MSGWRT (8)
      IERR = 1
      GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
 1230 FORMAT ('Start following longitude =',1PD13.5)
 1231 FORMAT ('Start following latitude =',1PD13.5)
 1980 FORMAT ('PFTICS: GRAPH LABEL WRITING ERROR. IERR =',I5)
 1990 FORMAT ('PFTICS: INVALID AXIS TYPE.')
      END
      SUBROUTINE PFSCAL (ROT, SKEW, XYR, BLC, TRC, CH, FWD)
C-----------------------------------------------------------------------
C   This routine will calculate scale factors (in common CPFI) to
C   project a 3 D image onto a rectangle.  These values will be used
C   by PFXY to convert an X,Y,Z to a corresponding X,Y.
C   INPUTS:  ROT     R   rotation of X axis (counter clockwise).
C            SKEW    R   rotation of Y axis away from X axis.
C            XYR     R   ratio of X pixel separation to Y pixel sep.
C            BLC     R(2)   X,Y bottom left hand corner of map.
C            TRC     R(2)   X,Y top right hand corner of map.
C            CH      R(4)   distance (before rotation) of border of
C                    plot in characters from edges of map. CH(1) =
C                    left, CH(2)=bottom, CH(3)=right, CH(4)=top.
C   OUTPUTS: BLC     R(2)   X,Y bottom left hand corner of plot after
C                    rotation.
C            TRC     R(2)   X,Y top right hand corner of plot after
C                    rotation.
C            FWD     L   true if map to be read forward false if map
C                    to be read backward.
C   COMMON:  COSSKW  R   cosine of the skew angle.
C            SINSKW  R   sine of the skew angle.
C            COSROT  R   cosine of the rotation angle.
C            SINROT  R   sine of the rotation angle.
C            OX      R   X center of map about which rotations are
C                    calculated.
C            OY      R   Y center of map.
C            CSIZEX  R   the X size in pixels of characters (unrotated)
C            CSIZEY  R   the Y size in pixels of characters.
C-----------------------------------------------------------------------
      REAL   BLC(2), TRC(2), CH(4), CMX(4), CMY(4), EX(10), EY(10),
     *   CRAT, CONV, ROT, SKEW, XYR, XLEN, YLEN, YMAX
      INTEGER   I
      LOGICAL   T, F, FWD
      INCLUDE 'PROFL2.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA CRAT /625.0/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C
      CONV = 3.14159 / 180.0
C                                       Find SINs, COSs of skew, rot.
      COSSKW = COS(SKEW * CONV)
      SINSKW = SIN(SKEW * CONV)
      COSROT = COS(ROT * CONV)
      SINROT = SIN(ROT * CONV)
      XCOSRO = XYR * COSROT
      XSINRO = XYR * SINROT
C                                       Center of plot in pixel coor.
      OX = (TRC(1) + BLC(1)) / 2.0
      OY = (TRC(2) + BLC(2)) / 2.0
      XOX = 0.0
      YOX = 0.0
C                                       Length of X, Y in pixels.
      XLEN = TRC(1) - BLC(1) + 1
      YLEN = TRC(2) - BLC(2) + 1
C                                       Calculate corners of map.
      CALL PFXY (BLC(1), BLC(2), ZMAX, CMX(1), CMY(1))
      CALL PFXY (TRC(1), BLC(2), ZMAX, CMX(2), CMY(2))
      CALL PFXY (TRC(1), TRC(2), ZMAX, CMX(3), CMY(3))
      CALL PFXY (BLC(1), TRC(2), ZMAX, CMX(4), CMY(4))
C                                       Find maximum Y coordinate and
C                                       lowest corner.
      LOW = 1
      YMAX = (CMY(1) + CMY(2) + CMY(3) + CMY(4)) / 4.0
      CALL PFXY (OX, OY, ZMAX, CMX(4), CMY(4))
      YMAX = MAX (YMAX, CMY(4))
C                                       zero plane
      CALL PFXY (BLC(1), BLC(2), Z0, CMX(1), CMY(1))
      CALL PFXY (TRC(1), BLC(2), Z0, CMX(2), CMY(2))
      CALL PFXY (TRC(1), TRC(2), Z0, CMX(3), CMY(3))
      CALL PFXY (BLC(1), TRC(2), Z0, CMX(4), CMY(4))
      DO 15 I = 2,4
         IF (CMY(I).LT.CMY(LOW)) LOW = I
 15      CONTINUE
C                                       Heuristic for finding character
C                                       size.
      CSIZX = CSIZPR(1) / CRAT * MAX(XLEN, YLEN)
      CSIZY = CSIZX * CSIZPR(2) / CSIZPR(1)
      CSIZX = CSIZX / XYR
C                                       Find edges of character borders
C                                       before rotation.
C                                       'DEC top and bottom.
      EX(1) = BLC(1) - CH(1) * CSIZX
      EY(1) = (TRC(2) - BLC(2)) / 2.0 + BLC(2) + 9.5 * CSIZY
      EX(2) = EX(1)
      EY(2) = (TRC(2) - BLC(2)) / 2.0 + BLC(2) - 9.5 * CSIZY
C                                       Left no.'s top & bottom.
      EX(3) = BLC(1) - 2.0 * CSIZX
      EY(3) = TRC(2) + .5 * CSIZY
      EX(4) = EX(3)
      EY(4) = BLC(2) - 1.5 * CSIZY
C                                       Numbers etc. at bottom
      EX(5) = BLC(1)
      EY(5) = BLC(2) - CH(2) * CSIZY
      EX(6) = TRC(1)
      EY(6) = EY(5)
C                                       Bottom right corner.
      EX(7) = TRC(1)
      EY(7) = BLC(2)
C                                       Source name, ect.
      EX(8) = BLC(1)
      EY(8) = TRC(2) + CH(4) * CSIZY
      EX(9) = BLC(1) + 31.0 * CSIZX
      IF (CH(4).LT.1.0) EX(9) = BLC(1)
      EY(9) = EY(8)
C                                       Top right corner.
      EX(10) = TRC(1)
      EY(10) = TRC(2)
C                                       Rotate and skew outside corners.
      DO 20 I = 1,10
         CALL PFXY (EX(I), EY(I), Z0, EX(I), EY(I))
 20      CONTINUE
C                                       Find 4 outside corners.
      BLC(1) = EX(1)
      TRC(1) = EX(1)
      BLC(2) = EY(1)
      TRC(2) = MAX (YMAX, EY(1))
      DO 30 I =2,10
         BLC(1) = MIN (BLC(1), EX(I))
         BLC(2) = MIN (BLC(2), EY(I))
         TRC(1) = MAX (TRC(1), EX(I))
         TRC(2) = MAX (TRC(2), EY(I))
 30      CONTINUE
      XOX = -BLC(1) + 1.
      YOX = -BLC(2) + 1.
      BLC(1) = BLC(1) + XOX
      TRC(1) = TRC(1) + XOX
      BLC(2) = BLC(2) + YOX
      TRC(2) = TRC(2) + YOX
C                                       Determine if fwd or bckwrd read
      FWD = T
      IF ((LOW.EQ.3) .OR. (LOW.EQ.4)) FWD = F
C
 999  RETURN
      END
      SUBROUTINE PFXY (X, Y, Z, X2D, Y2D)
C-----------------------------------------------------------------------
C  Given an X,Y,Z of a three dimensional image, PFXY will calculate the
C  X2D, Y2D, of the projection.  PFXY uses parameters in
C  common CPFI which are initialized by PFSCAL.
C  INPUTS:  X       R   X coordinate of 3 D image.
C           Y       R   Y coordinate of 3 d image.
C           Z       R   Z coordinate of 3 D image.
C  COMMON:  COSROT  R   cos of the rotation of the X axis.
C           COSSKW  R   cos of the rotation of the Y axis away from
C                       the X axis.
C           SINROT  R   sin of the rotation of the X axis.
C           SINSKW  R   sin of the rotation of the Y axis away from
C                       the X axis.
C           OX      R   the X origin in pixel coordinates.
C           OY      R   the Y origin in pixel coordinates.
C           ZR      R   the multiplier for the Z value, ie
C                       Height in pixels s = ZR * (Z value)
C           ZMAX    R   the highest allowable Z value.
C           ZMIN    R   the lowest allowable Z value.
C           Z0      R   the pixel value representing zero.
C           ZDIST   R   distance of the observer in pixel lengths.
C  OUTPUTS: X2D     R   the X value of the projection.
C           Y2D     R   the Y value of the projection.
C-----------------------------------------------------------------------
      REAL      X, X1, X2, X2D, Y, Y1, Y2, Y2D, Z, Z1, Z2
      INCLUDE 'PROFL2.INC'
C-----------------------------------------------------------------------
C                                       Clip Z values.
      Z = MIN(Z, ZMAX)
      Z = MAX(Z, ZMIN)
C                                       Do rotation around Z axis.
      X1 = (X - OX) * XCOSRO - (Y - OX) * SINROT
      Y1 = (X - OX) * XSINRO + (Y - OY) * COSROT
      Z1 = (Z - Z0) * ZR
C                                       Rotate around X1 axis.
      X2 = X1
      Y2 = Y1 * COSSKW + Z1 * SINSKW
      Z2 = - Y1 * SINSKW + Z1 * COSSKW
C                                       Do perspective
      X2D = X2 / (1 - Z2/ZDIST) + XOX
      Y2D = Y2 / (1 - Z2/ZDIST) + YOX
C                                       Save last absolute values.
      XL = X2D
      YL = Y2D
C
 999  RETURN
      END
      SUBROUTINE PFDRAW (ILUN, IFIND, IWIN, IXINC, IYINC, IBLK, ILBLK,
     *   IGBLK, BCKTS, IERR)
C-----------------------------------------------------------------------
C   PFDRAW will draw the profile lines for the map.
C   INPUTS:  ILUN    I   logical unit number of graph file.
C            IFIND   I   FTAB pointer for graph file.
C            IWIN    I(4)   window for read of map file.
C            IXINC   I   draw profile line every IXINCth column. Zero
C                    means do not draw profile lines for columns.
C            IYINC   I   draw profile line every IYINCth row. Zero
C                    means do not draw profile lines for rows.
C            IBLK    R(?)   I/O buffer for map.
C            ILBLK   R(?)   array to contain previous row of map.
C            IGBLK   I(256)   I/O buffer for graph file.
C            BCKTS   R(??)   'lowest visible point' buckets.
C   OUTPUT:  IERR    I   error code from GPOS or GVEC. 0=ok.
C-----------------------------------------------------------------------
      REAL      BCKTS(1), YTHR, Y, X, Z, XX, YY, Y1, Y2, IBLK(1),
     *   ILBLK(1)
      INTEGER   IWIN(4), IGBLK(256), ILUN, IFIND, IXINC, IYINC, IERR,
     *   I, J, JJ, IPOS, INROWS, IZERO, INPIXS, IXSTRT, INCX,
     *   INCY, ILEFT, IRIGHT, IMID, J2, IX, IJ
      INCLUDE 'PROFL2.INC'
C-----------------------------------------------------------------------
      IZERO = Z0
      INROWS = ABS (IWIN(4) - IWIN(2)) + 1
      INPIXS = IWIN(3) - IWIN(1) + 1
C                                       Decide which way to loop over
C                                       rows and pixels.
      IXSTRT = IWIN(1)
      INCX = 1
C                                       Read rows right to left.
      IF ((LOW.EQ.1) .OR. (LOW.EQ.4)) GO TO 20
         IXSTRT = IWIN(3)
         INCX = -1
C                                       Do we draw cols from top or bot
 20   CONTINUE
      INCY = 1
      IF ((LOW.EQ.3) .OR. (LOW.EQ.4)) INCY = -1
      ILEFT = MIN (IWIN(1), IWIN(3) )
      IRIGHT = MAX (IWIN(1), IWIN(3) )
      YTHR = OY - ZDIST * SINSKW
C                                       Read first line.
      CALL MDISK ('READ', ILUN, IFIND, IBLK, IPOS, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       substitute for blanks
      CALL SNRVAL (INPIXS, Z0, IBLK(IPOS))
C                                       Loop over the rest of the rows.
      DO 100 I = 2,INROWS
         CALL RCOPY (INPIXS, IBLK(IPOS), ILBLK)
         CALL MDISK ('READ', ILUN, IFIND, IBLK, IPOS, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL SNRVAL (INPIXS, Z0, IBLK(IPOS))
C                                       Test for draw X profile.
         IF (IYINC.EQ.0) GO TO 50
         IF (MOD(I-2,IYINC).NE.0) GO TO 50
C                                       Draw along X axis.
            Y = IWIN(2) + (I-2) * INCY
            IF (Y.LT.YTHR) GO TO 42
C                                       Draw outside in.
               X = ILEFT
               Z = ILBLK(1)
               IMID = 1
               CALL PFXY (X, Y, Z, XX, YY)
               CALL GPOS (XX, YY, IGBLK, IERR)
               DO 30 J = 2,INPIXS
                  X = ILEFT + J - 1
                  IMID = J
                  Z = ILBLK(J)
                  CALL PFLINE (X, Y, Z, IGBLK, BCKTS, IERR)
                  IF (XL.GE.XOX) GO TO 35
 30               CONTINUE
C                                       Draw back toward middle.
 35            CONTINUE
               IF (IMID.EQ.INPIXS) GO TO 50
                  X = IRIGHT
                  Z = ILBLK(INPIXS)
                  CALL PFXY (X, Y, Z, XX, YY)
                  CALL GPOS (XX, YY, IGBLK, IERR)
                  J2 = INPIXS - IMID
                  DO 40 JJ = 1, J2
                     J = INPIXS - JJ
                     X = ILEFT + J - 1
                     Z = ILBLK(J)
                     CALL PFLINE (X, Y, Z, IGBLK, BCKTS, IERR)
 40                  CONTINUE
                  GO TO 50
C                                      Draw inside out.
 42            CONTINUE
               IMID = OX
               IMID = MAX (IMID, ILEFT)
               IF (IMID.GE.IRIGHT) GO TO 46
               X = IMID
               Z = ILBLK(IMID - ILEFT + 1)
               CALL PFXY (X, Y, Z, XX, YY)
               CALL GPOS (XX, YY, IGBLK, IERR)
               DO 44 J = IMID,IRIGHT
                  X = J
                  Z = ILBLK(J - ILEFT + 1)
                  CALL PFLINE (X, Y, Z, IGBLK, BCKTS, IERR)
 44               CONTINUE
C                                       Draw right to left.
 46            CONTINUE
               IF (IMID.LE.ILEFT) GO TO 50
                  X = IMID
                  Z = ILBLK(IMID - ILEFT + 1)
                  CALL PFXY (X, Y, Z, XX, YY)
                  CALL GPOS (XX, YY, IGBLK, IERR)
                  J2 = IMID - ILEFT
                  DO 48 JJ = 1, J2
                     J = IMID - JJ
                     X = J
                     Z = ILBLK(J - ILEFT + 1)
                     CALL PFLINE (X, Y, Z, IGBLK, BCKTS, IERR)
 48                  CONTINUE
C                                       Draw along Y axis
 50      IF (IXINC.LE.0) GO TO 100
            Y1 = IWIN(2) + (I-2) * INCY
            Y2 = Y1 + INCY
            DO 60 J = 1,INPIXS,IXINC
               IX = (J-1) * INCX + IXSTRT
               X = IX
               IJ = IX - IWIN(1) + 1
               Z = ILBLK(IJ)
C                                       Position.
               CALL PFXY (X, Y1, Z, XX, YY)
               CALL GPOS (XX, YY, IGBLK, IERR)
               IF (IERR.NE.0) GO TO 999
C                                       Draw up to next Y pixel.
               JJ = IPOS + IJ - 1
               Z = IBLK(JJ)
               CALL PFLINE (X, Y2, Z, IGBLK, BCKTS, IERR)
               IF (IERR.NE.0) GO TO 999
 60            CONTINUE
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE PFLINE (XX, YY, Z, IBLK, BCKTS, IERR)
C-----------------------------------------------------------------------
C  Given an X,Y,Z PFLINE will draw a line from the current position to
C  the new X,Y,Z.  This consists of determining what part of the line
C  is visible and calling GPOS and/or GVEC to draw a line consistent
C  with that determination.  BCKTS (an array containing lowest visible
C  points) is also updated.
C  INPUTS:  X       R   X position of endpoint.
C           Y       R   Y position of endpoint.
C           Z       R   Z position of endpoint.
C           IBLK    I(256)   I/O buffer for graph file.
C           BCKTS   R(??)   lowest visible points.
C  COMMON:  XLEN    R   length of X axis of map in pixels.
C           YLEN    R   length of Y axis of map in pixels.
C           GPHX1   R   BLC X value of plot.
C           GPHX2   R   TRC X value in pixel coordinates of plot.
C           GPHY1   R   BLC Y value of plot.
C           GPHY2   R   TRC Y value of plot.
C           XL      R   last X position in pixel coordinates.
C           YL      R   last Y position in pixel coordinates.
C  OUTPUTS: IERR    R   error code. 0 = ok; 1=error from GPOS or GVEC.
C-----------------------------------------------------------------------
      REAL   BCKTS(1), P1(4), X, Y, Z, XX, YY, XINC
      INTEGER   IBLK(256), IERR, INC, IBKT, IHIDE, I
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'PROFL2.INC'
C-----------------------------------------------------------------------
C                                       Find X,Y end points of line in
C                                       pixel coordinates.
      P1(1) = XL
      P1(2) = YL
      CALL PFXY (XX, YY, Z, P1(3), P1(4))
      INC = 1
      IF (P1(3).LT.P1(1)) INC = -1
      XINC = INC
C                                       Find bucket no. of far side of X
      IBKT = (P1(1) - GPHX1) * (NBKTS - 1) / (GPHX2 - GPHX1)  +  1.0
      IF (INC.LT.0) IBKT = IBKT + 1
      IHIDE = 1
      IF (BCKTS(IBKT).LT.P1(4)) IHIDE = -1
      IF ((BCKTS(IBKT).GT.P1(2)).AND.(IHIDE.LT.0)) P1(2) = BCKTS(IBKT)
C                                       Loop until we reach end of line.
      DO 30 I = 1,NBKTS
         IBKT = IBKT + INC
         X = (IBKT - 1) * (GPHX2 - GPHX1) / (NBKTS - 1) + GPHX1
         IF (XINC * P1(3) .LT. XINC * X) GO TO 40
C                                       Find Y value of line at bucket.
         Y = (X-P1(1)) * ( (P1(4)-P1(2)) / (P1(3)-P1(1)) )  +  P1(2)
C                                       Doing hidden line.
         IF (IHIDE.GE.0) THEN
C                                       Changing to visible line.
            IF (BCKTS(IBKT).LE.Y) THEN
               CALL GPOS ( X, Y, IBLK, IERR)
               IF (IERR.NE.0) GO TO 999
               BCKTS(IBKT) = Y
               IHIDE = -1
               END IF
C                                       Doing visible line.
C                                       Still visible.
         ELSE IF (BCKTS(IBKT).LE.Y) THEN
            BCKTS(IBKT) = Y
C                                       Changing to hidden line.
         ELSE
            CALL GVEC ( X, Y, IBLK, IERR)
            IF (IERR.NE.0) GO TO 999
            IHIDE = 1
            END IF
C
 30      CONTINUE
C                                       Draw up to last point.
 40   IF (IHIDE.LT.0) CALL GVEC (P1(3), P1(4), IBLK, IERR)
      IF (IHIDE.GT.0) CALL GPOS (P1(3), P1(4), IBLK, IERR)
      XL = P1(3)
      YL = P1(4)
C
 999  RETURN
      END
      SUBROUTINE PFCHAR (ILEN, HORV, X, Y, DCX, DCY, STRING, IOBLK,
     *   IERR)
C-----------------------------------------------------------------------
C   PRCHAR will generate the vector commands for characters.
C   INPUTS:   ILEN     I   number of characters in the character string
C             HORV     I   0 = draw characters horizontally, 1=vertical
C             X        R   starting X position (see DCX).
C             Y        R   starting Y position (see DCY).
C             DCX      R   X distance from starting position in
C                      characters at which to start drawing.
C             DCY      R   Y distance from starting position in
C                      characters at which to start drawing.
C             STRING   I(ILEN+1/2)   array containing ASCII characters
C             IOBLK    I(??)   I/O block for bit map file.
C   COMMON:   CSIZX    R   chracter width in pixels.
C             CSIZY    R   character height in pixels.
C             XL       R   current X coordinate in pixels.
C             YL       R   current Y coordinate in pixels.
C   OUTPUTS:  IERR     I   error code.
C                          0 = ok.
C   COMMON:   XL       I   updated X position.
C             YL       I   updated Y position.
C             IOBLK    I   updated I/O block.
C-----------------------------------------------------------------------
      CHARACTER IT*2, STRING*(*)
      REAL      DCX, DCY, YSAV, Y, XSAV, X, XLP, YLP, YC, XC, YSPACE,
     *   LDCY, LASTY, HIGHXP, MAXC
      INTEGER   IOBLK(1), HORV, I, ICHAR, IERR, ILEN, KT,
     *   INCOM, INDEX, J, K, NIT, JT, LT, BITS(16)
      INTEGER   ICHTAB(931), INDTAB(95)
      INTEGER   SPACE ( 1), EXCLAM( 6), QUOTE ( 6), POUND (13)
     *        , DOLLAR(15), PERCNT(16), AMPERS(13), APOSTR( 8)
     *        , LPAREN( 6), RPAREN( 6), ASTER (13), PLUS  (07)
     *        , COMMA ( 8), MINUS ( 4), PERIOD( 7), SLASH ( 4)
     *        , ZERO  (14), ONE   ( 8), TWO   (12), THREE (16)
     *        , FOUR  ( 7), FIVE  (12), SIX   (13), SEVEN ( 8)
     *        , EIGHT (18), NINE  (13), COLON (13), SEMICO(14)
     *        , LESS  ( 5), EQUALS( 7), GREATR( 5), QUESTN(11)
      INTEGER   ATSIGN(15), AUPPER(10), BUPPER(17), CUPPER(10)
     *        , DUPPER(11), EUPPER( 9), FUPPER( 8), GUPPER(12)
     *        , HUPPER(10), IUPPER(10), JUPPER(10), KUPPER(10)
     *        , LUPPER( 5), MUPPER( 7), NUPPER(10), OUPPER(11)
     *        , PUPPER( 9), QUPPER(14), RUPPER(12), SUPPER(14)
     *        , TUPPER( 7), UUPPER( 8), VUPPER( 7), WUPPER( 7)
     *        , XUPPER(11), YUPPER( 8), ZUPPER( 8), LBRACK( 6)
     *        , BKSLSH( 4), RBRACK( 6), CARET ( 5), USCORE( 4)
     *        , ACCENT( 7), ALOWER(15), BLOWER(13), CLOWER(10)
     *        , DLOWER(13), ELOWER(12), FLOWER( 9), GLOWER(13)
     *        , HLOWER(10), ILOWER(10), JLOWER(10), KLOWER(11)
     *        , LLOWER( 8), MLOWER(14), NLOWER(10), OLOWER(11)
     *        , PLOWER(13), QLOWER(13), RLOWER( 9), SLOWER(11)
     *        , TLOWER(10), ULOWER(10), VLOWER( 7), WLOWER(14)
     *        , XLOWER( 7), YLOWER(13), ZLOWER( 6), LBRACE(14)
     *        , ORSIGN( 4), RBRACE(14), TILDE ( 6)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'PROFL2.INC'
      EQUIVALENCE (SPACE , ICHTAB(  1)), (EXCLAM, ICHTAB(  2))
     *          , (QUOTE , ICHTAB(  8)), (POUND , ICHTAB( 14))
     *          , (DOLLAR, ICHTAB( 27)), (PERCNT, ICHTAB( 42))
     *          , (AMPERS, ICHTAB( 58)), (APOSTR, ICHTAB( 71))
     *          , (LPAREN, ICHTAB( 79)), (RPAREN, ICHTAB( 85))
     *          , (ASTER , ICHTAB( 91)), (PLUS  , ICHTAB(104))
     *          , (COMMA , ICHTAB(111)), (MINUS , ICHTAB(119))
     *          , (PERIOD, ICHTAB(123)), (SLASH , ICHTAB(130))
     *          , (ZERO  , ICHTAB(134)), (ONE   , ICHTAB(148))
     *          , (TWO   , ICHTAB(156)), (THREE , ICHTAB(168))
     *          , (FOUR  , ICHTAB(184)), (FIVE  , ICHTAB(191))
     *          , (SIX   , ICHTAB(203)), (SEVEN , ICHTAB(216))
     *          , (EIGHT , ICHTAB(224)), (NINE  , ICHTAB(242))
     *          , (COLON , ICHTAB(255)), (SEMICO, ICHTAB(268))
     *          , (LESS  , ICHTAB(282)), (EQUALS, ICHTAB(287))
     *          , (GREATR, ICHTAB(294)), (QUESTN, ICHTAB(299))
      EQUIVALENCE (ATSIGN, ICHTAB(310)), (AUPPER, ICHTAB(325))
     *          , (BUPPER, ICHTAB(335)), (CUPPER, ICHTAB(352))
     *          , (DUPPER, ICHTAB(362)), (EUPPER, ICHTAB(373))
     *          , (FUPPER, ICHTAB(382)), (GUPPER, ICHTAB(390))
     *          , (HUPPER, ICHTAB(402)), (IUPPER, ICHTAB(412))
     *          , (JUPPER, ICHTAB(422)), (KUPPER, ICHTAB(432))
     *          , (LUPPER, ICHTAB(442)), (MUPPER, ICHTAB(447))
     *          , (NUPPER, ICHTAB(454)), (OUPPER, ICHTAB(464))
     *          , (PUPPER, ICHTAB(475)), (QUPPER, ICHTAB(484))
     *          , (RUPPER, ICHTAB(498)), (SUPPER, ICHTAB(510))
     *          , (TUPPER, ICHTAB(524)), (UUPPER, ICHTAB(531))
     *          , (VUPPER, ICHTAB(539)), (WUPPER, ICHTAB(546))
     *          , (XUPPER, ICHTAB(553)), (YUPPER, ICHTAB(564))
     *          , (ZUPPER, ICHTAB(572)), (LBRACK, ICHTAB(580))
     *          , (BKSLSH, ICHTAB(586)), (RBRACK, ICHTAB(590))
     *          , (CARET , ICHTAB(596)), (USCORE, ICHTAB(601))
      EQUIVALENCE (ACCENT, ICHTAB(605)), (ALOWER, ICHTAB(612))
     *          , (BLOWER, ICHTAB(627)), (CLOWER, ICHTAB(640))
     *          , (DLOWER, ICHTAB(650)), (ELOWER, ICHTAB(663))
     *          , (FLOWER, ICHTAB(675)), (GLOWER, ICHTAB(684))
     *          , (HLOWER, ICHTAB(697)), (ILOWER, ICHTAB(707))
     *          , (JLOWER, ICHTAB(717)), (KLOWER, ICHTAB(727))
     *          , (LLOWER, ICHTAB(738)), (MLOWER, ICHTAB(746))
     *          , (NLOWER, ICHTAB(760)), (OLOWER, ICHTAB(770))
     *          , (PLOWER, ICHTAB(781)), (QLOWER, ICHTAB(794))
     *          , (RLOWER, ICHTAB(807)), (SLOWER, ICHTAB(816))
     *          , (TLOWER, ICHTAB(827)), (ULOWER, ICHTAB(837))
     *          , (VLOWER, ICHTAB(847)), (WLOWER, ICHTAB(854))
     *          , (XLOWER, ICHTAB(868)), (YLOWER, ICHTAB(875))
     *          , (ZLOWER, ICHTAB(888)), (LBRACE, ICHTAB(894))
     *          , (ORSIGN, ICHTAB(908)), (RBRACE, ICHTAB(912))
     *          , (TILDE , ICHTAB(926))
      SAVE LDCY, LASTY, HIGHXP
      DATA LDCY, LASTY, HIGHXP /-1.E10,-1.E10,-1.E10/
C-----------------------------------------------------------------------
      DATA SPACE  /00/
      DATA EXCLAM /02, 38, 33, 01, 30, 00/
      DATA QUOTE  /02, 28, 26, 02, 48, 46/
      DATA POUND  /02, 10, 18, 02, 58, 50, 02, 62, 02, 02
     *           , 06, 66, 00/
      DATA DOLLAR /10, 01, 51, 62, 63, 54, 14, 05, 06, 17
     *           , 67, 02, 38, 30, 00/
      DATA PERCNT /05, 07, 18, 27, 16, 07, 02, 01, 67, 05
     *           , 50, 61, 52, 41, 50, 00/
      DATA AMPERS /11, 60, 06, 07, 18, 48, 46, 02, 01, 10
     *           , 30, 63, 00/
      DATA APOSTR /06, 24, 46, 48, 38, 37, 47, 00/
      DATA LPAREN /04, 40, 22, 26, 48, 00/
      DATA RPAREN /04, 20, 42, 46, 28, 00/
      DATA ASTER  /02, 01, 67, 02, 07, 61, 02, 04, 64, 02
     *           , 37, 31, 00/
      DATA PLUS   /02, 14, 54, 02, 36, 32, 00/
      DATA COMMA  /06, 20, 42, 44, 34, 33, 43, 00/
      DATA MINUS  /02, 14, 54, 00/
      DATA PERIOD /05, 20, 30, 31, 21, 20, 00/
      DATA SLASH  /02, 01, 67, 00/
      DATA ZERO   /09, 10, 50, 61, 67, 58, 18, 07, 01, 10
     *           , 02, 01, 67, 00/
      DATA ONE    /02, 10, 50, 03, 30, 38, 16, 00/
      DATA TWO    /10, 07, 18, 58, 67, 65, 54, 24, 02, 00
     *           , 60, 00/
      DATA THREE  /07, 07, 18, 58, 67, 65, 54, 34, 06, 54
     *           , 63, 61, 50, 10, 01, 00/
      DATA FOUR   /05, 50, 58, 03, 02, 72, 00/
      DATA FIVE   /10, 01, 10, 40, 62, 63, 45, 05, 08, 68
     *           , 67, 00/
      DATA SIX    /11, 04, 54, 63, 61, 50, 10, 01, 06, 28
     *           , 58, 67, 00/
      DATA SEVEN  /06, 20, 23, 67, 68, 08, 07, 00/
      DATA EIGHT  /16, 14, 03, 01, 10, 50, 61, 63, 54, 14
     *           , 05, 07, 18, 58, 67, 65, 54, 00/
      DATA NINE   /11, 01, 10, 40, 62, 67, 58, 18, 07, 05
     *           , 14, 64, 00/
      DATA COLON  /05, 22, 32, 33, 23, 22, 05, 26, 36, 37
     *           , 27, 26, 00/
      DATA SEMICO /06, 10, 32, 34, 24, 23, 33, 05, 26, 36
     *           , 37, 27, 26, 00/
      DATA LESS   /03, 50, 14, 58, 00/
      DATA EQUALS /02, 12, 52, 02, 16, 56, 00/
      DATA GREATR /03, 10, 54, 18, 00/
      DATA QUESTN /07, 06, 07, 18, 58, 67, 34, 33, 01, 31
     *           , 00/
      DATA ATSIGN /13, 54, 45, 34, 43, 54, 64, 66, 48, 28
     *           , 06, 02, 20, 50, 00/
      DATA AUPPER /05, 00, 05, 38, 65, 60, 02, 03, 63, 00/
      DATA BUPPER /06, 00, 50, 61, 63, 54, 14, 05, 08, 58
     *           , 67, 65, 54, 02, 18, 10, 00/
      DATA CUPPER /08, 67, 58, 28, 06, 02, 20, 50, 61, 00/
      DATA DUPPER /06, 00, 40, 62, 66, 48, 08, 02, 18, 10
     *           , 00/
      DATA EUPPER /04, 60, 00, 08, 68, 02, 34, 04, 00/
      DATA FUPPER /03, 00, 08, 68, 02, 34, 04, 00/
      DATA GUPPER /10, 67, 58, 28, 06, 02, 20, 50, 61, 64
     *           , 44, 00/
      DATA HUPPER /02, 00, 08, 02, 60, 68, 02, 04, 64, 00/
      DATA IUPPER /02, 10, 50, 02, 30, 38, 02, 18, 58, 00/
      DATA JUPPER /05, 01, 10, 20, 31, 38, 02, 18, 58, 00/
      DATA KUPPER /02, 00, 08, 02, 68, 02, 02, 24, 60, 00/
      DATA LUPPER /03, 08, 00, 60, 00/
      DATA MUPPER /05, 00, 08, 35, 68, 60, 00/
      DATA NUPPER /02, 00, 08, 02, 07, 61, 02, 60, 68, 00/
      DATA OUPPER /09, 20, 40, 62, 66, 48, 28, 06, 02, 20
     *           , 00/
      DATA PUPPER /07, 00, 08, 58, 67, 66, 55, 05, 00/
      DATA QUPPER /09, 20, 40, 62, 66, 48, 28, 06, 02, 20
     *           , 02, 33, 60, 00/
      DATA RUPPER /07, 00, 08, 58, 67, 66, 55, 05, 02, 15
     *           , 60, 00/
      DATA SUPPER /12, 01, 10, 50, 61, 63, 54, 14, 05, 07
     *           , 18, 58, 67, 00/
      DATA TUPPER /02, 30, 38, 02, 08, 68, 00/
      DATA UUPPER /06, 08, 01, 10, 50, 61, 68, 00/
      DATA VUPPER /05, 08, 03, 30, 63, 68, 00/
      DATA WUPPER /05, 08, 00, 33, 60, 68, 00/
      DATA XUPPER /04, 00, 01, 67, 68, 04, 08, 07, 61, 60
     *           , 00/
      DATA YUPPER /03, 08, 35, 68, 02, 35, 30, 00/
      DATA ZUPPER /06, 08, 68, 67, 01, 00, 60, 00/
      DATA LBRACK /04, 40, 20, 28, 48, 00/
      DATA BKSLSH /02, 07, 61, 00/
      DATA RBRACK /04, 20, 40, 48, 28, 00/
      DATA CARET  /03, 05, 38, 65, 00/
      DATA USCORE /02,-01,-61, 00/
      DATA ACCENT /05, 27, 28, 38, 37, 55, 00/
      DATA ALOWER /05, 06, 26, 35, 31, 40, 07, 31, 20, 10
     *           , 01, 02, 13, 33, 00/
      DATA BLOWER /02, 08, 00, 08, 02, 20, 30, 41, 44, 35
     *           , 25, 03, 00/
      DATA CLOWER /08, 41, 30, 10, 01, 04, 15, 35, 44, 00/
      DATA DLOWER /02, 48, 40, 08, 42, 20, 10, 01, 04, 15
     *           , 25, 43, 00/
      DATA ELOWER /10, 40, 10, 01, 04, 15, 35, 44, 43, 32
     *           , 02, 00/
      DATA FLOWER /04, 10, 17, 28, 37, 02, 04, 24, 00/
      DATA GLOWER /11, 40, 10, 01, 04, 15, 35, 44,-41,-23
     *           ,-13,-02, 00/
      DATA HLOWER /02, 00, 08, 05, 03, 25, 35, 44, 40, 00/
      DATA ILOWER /01, 37, 03, 25, 35, 30, 02, 20, 40, 00/
      DATA JLOWER /01, 37, 06, 35,-32,-23,-13,-02,-01, 00/
      DATA KLOWER /02, 08, 00, 02, 01, 45, 03, 40, 22, 23
     *           , 00/
      DATA LLOWER /02, 20, 40, 03, 30, 38, 28, 00/
      DATA MLOWER /06, 00, 04, 15, 25, 34, 30, 05, 34, 45
     *           , 55, 64, 60, 00/
      DATA NLOWER /02, 00, 05, 05, 03, 25, 35, 44, 40, 00/
      DATA OLOWER /09, 01, 04, 15, 35, 44, 41, 30, 10, 01
     *           , 00/
      DATA PLOWER /02,-03, 05, 08, 03, 25, 35, 44, 41, 30
     *           , 20, 02, 00/
      DATA QLOWER /02,-43, 45, 08, 43, 25, 15, 04, 01, 10
     *           , 20, 42, 00/
      DATA RLOWER /02, 00, 05, 04, 03, 25, 35, 44, 00/
      DATA SLOWER /09, 00, 30, 41, 42, 33, 13, 04, 15, 45
     *           , 00/
      DATA TLOWER /02, 06, 26, 05, 18, 11, 20, 30, 41, 00/
      DATA ULOWER /05, 05, 01, 10, 20, 42, 02, 40, 45, 00/
      DATA VLOWER /05, 05, 02, 20, 42, 45, 00/
      DATA WLOWER /06, 05, 01, 10, 20, 31, 35, 05, 31, 40
     *           , 50, 61, 65, 00/
      DATA XLOWER /02, 00, 55, 02, 05, 50, 00/
      DATA YLOWER /05, 05, 01, 10, 30, 41, 05, 45,-42,-33
     *           ,-23,-12, 00/
      DATA ZLOWER /04, 05, 55, 00, 50, 00/
      DATA LBRACE /06, 40, 30, 21, 23, 14, 04, 05, 14, 25
     *           , 27, 38, 48, 00/
      DATA ORSIGN /02, 30, 38, 00/
      DATA RBRACE /06, 20, 30, 41, 43, 54, 64, 05, 54, 45
     *           , 47, 38, 28, 00/
      DATA TILDE  /04, 06, 28, 46, 68, 00/
C
      DATA INDTAB /  1,   2,   8,  14,  27,  42,  58,  71,  79,  85,
     *              91, 104, 111, 119, 123, 130, 134, 148, 156, 168,
     *             184, 191, 203, 216, 224, 242, 255, 268, 282, 287,
     *             294, 299, 310, 325, 335, 352, 362, 373, 382, 390,
     *             402, 412, 422, 432, 442, 447, 454, 464, 475, 484,
     *             498, 510, 524, 531, 539, 546, 553, 564, 572, 580,
     *             586, 590, 596, 601, 605, 612, 627, 640, 650, 663,
     *             675, 684, 697, 707, 717, 727, 738, 746, 760, 770,
     *             781, 794, 807, 816, 827, 837, 847, 854, 868, 875,
     *             888, 894, 908, 912, 926 /
      DATA YSPACE /.8/
C-----------------------------------------------------------------------
      IERR = 0
      IF (ILEN.LE.0) GO TO 999
      YSAV = Y + CSIZY * DCY
      XSAV = X + CSIZX * DCX
      MAXC = -1.E10
      IF ((DCY.NE.LDCY) .OR. (Y.NE.LASTY)) HIGHXP = MAXC
C                                       Loop for each character.
      DO 100 I = 1,ILEN
C                                       Get standard ASCII char
C                                       in machine inde. fashion.
         JT = NBITWD / 8
         IT(1:1) = STRING(I:I)
         CALL ZCLC8 (1, IT, JT, LT)
         CALL ZI32IL (1, 1, LT, KT)
         NIT = NBITWD - (JT-1) * 8
         CALL ZGTBIT (NIT, KT, BITS)
         CALL ZPTBIT (8, ICHAR, BITS(NIT-7))
C                                       Set orgion & check validity.
         ICHAR = ICHAR - 31
         IF ((ICHAR.LT.1) .OR. (ICHAR.GT.95)) ICHAR = 32
C                                       Find index into table of vectrs
         INDEX = INDTAB(ICHAR)
C                                       DO WHILE no. of commands not 0.
         DO 50 J = 1,99
            INCOM = ICHTAB(INDEX)
            IF (INCOM.EQ.0) GO TO 60
C                                       Loop for all vector commands.
            XLP = XSAV
            YLP = YSAV
            DO 30 K = 1,INCOM
               INDEX = INDEX + 1
C                                       Calc X and Y values.
               YC = ((MOD(ICHTAB(INDEX), 10) * CSIZY) / 10.0) * YSPACE
     *            + YSAV
               XC = ABS (ICHTAB(INDEX)/10 * CSIZX) / 10.0  +  XSAV
               CALL PFXY (XC, YC, Z0, XC, YC)
               IF ((I.EQ.1) .AND. (LDCY.EQ.DCY) .AND. (LASTY.EQ.Y) .AND.
     *            (XC.LE.HIGHXP)) GO TO 900
               IF (K.EQ.1) CALL GPOS (XC, YC, IOBLK, IERR)
               IF (K.NE.1) CALL GVEC (XC, YC, IOBLK, IERR)
               IF (IERR.NE.0) GO TO 999
               MAXC = MAX (MAXC, XC)
 30            CONTINUE
            INDEX = INDEX + 1
 50         CONTINUE
C                                       Set last X and Y.
 60      IF (HORV.EQ.1) GO TO 70
C                                       Horizontal.
            XSAV = XSAV + CSIZX
            GO TO 100
C                                       Vertical.
 70         YSAV = YSAV - CSIZY
C
 100     CONTINUE
C
 900  HIGHXP = MAX (HIGHXP, MAXC)
      LDCY = DCY
      LASTY = Y
C
 999  RETURN
      END
      SUBROUTINE PFSTAR (FACTOR, IVOL, CNO, VERS, BLC, TRC, PLBUF, IERR)
C-----------------------------------------------------------------------
C   PFSTAR plots star positions in a plot file as given by an ST
C   extension file of version VERS.  The ST file contains the center
C   position (RA-DEC, GLON-GLAT, ELON-ELAT) of each star and the
C   "uncertainties" in those star positions.  The plotted plus signs
C   are scaled by these uncertainties and then further scaled by
C   multiplying by FACTOR.
C   Inputs: FACTOR  R         Star scaling factor: <= 0 => no plot.
C           VERS    I         Desired ST file version number: 0 => high
C           IVOL    I         File disk number
C           CNO     I         File catalog number
C           BLC     R(2)      Plot lower left corner (pixels)
C           TRC     R(2)      Plot upper right corner (pixels)
C   In/Out: PLBUF   I(256)    Plot IO buffer
C   Output: IERR    I         Error code: 0 => okay
C                                -1 => there was no ST file
C                                +1 => logical error in ST file
C                                +2 => IO error in ST file
C                                +3 => IO error in plotting
C   Common: /MAPHDR/ CATBLK   Image header having the ST file
C-----------------------------------------------------------------------
      REAL      FACTOR, BLC(2), TRC(2)
      INTEGER   IVOL, CNO, VERS, PLBUF(256), IERR
C
C                                       Max Numb Columns, Label length
      INTEGER MXSTCL, MXSTLB, MXLINE
      PARAMETER (MXSTCL=7, MXSTLB=24, MXLINE=72)
      CHARACTER KEYS(MXSTCL)*8
      INTEGER   DATP(128,2), IOBUF(512), IV, I, NKEY, NCOL, NREC,
     *   TABLUN, KOLS(MXSTCL), IER, ITYPE, NPL, SCRTCH(50), NST,
     *   IST, LRNO, STTYPE, IROUND
      REAL      DELJ, DELN, AX(5), AY(5), POSANG, TX
      REAL      DELX, DELY, XR, YR, RDUM(6)
      DOUBLE PRECISION XPOS, YPOS, DX, DY, COSPA, SINPA, COSDEC,
     *   DDUM
      LOGICAL   LORDER
      CHARACTER*24 LABEL
      EQUIVALENCE (DDUM, RDUM)
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'PROFL2.INC'
      DATA TABLUN /27/
      DATA LORDER /.TRUE./
C-----------------------------------------------------------------------
      IERR = 0
      IF (FACTOR.LE.0.0) GO TO 999
C                                       Is there an ST file
      IERR = -1
      CALL FNDEXT ('ST', CATBLK, I)
      IF (I.LE.0) GO TO 999
      IV = VERS
      IF ((IV.LE.0) .OR. (IV.GT.I)) IV = I
C                                       Open ST table file
      NKEY = 0
      NCOL = 0
      NREC = 0
      CALL TABINI ('READ', 'ST', IVOL, CNO, IV, CATBLK, TABLUN, NKEY,
     *   NREC, NCOL, DATP, IOBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'ST', IV
         GO TO 990
         END IF
      NST = IOBUF(5)
C                                       Find needed columns
      I = 2
      CALL H2CHR (8, 1, CATH(KHCTP), KEYS(1))
      CALL H2CHR (8, 1, CATH(KHCTP+I), KEYS(2))
      KEYS(3) = 'MAJOR AX'
      KEYS(4) = 'MINOR AX'
      KEYS(5) = 'POSANG'
      KEYS(6) = 'STARTYPE'
      KEYS(7) = 'LABEL'
      CALL FNDCOL (NCOL, KEYS, 8, LORDER, IOBUF, KOLS, IER)
      IF (IER.GT.0) THEN
         IF (IER.LE.10) GO TO 975
            IERR = 1
            WRITE (MSGTXT,1020)
            GO TO 980
         END IF
C                                       I guess we can do it now
      NPL = 0
      LRNO = 0
      CALL GLTYPE (4, PLBUF, IER)
      IF (IER.NE.0) GO TO 985
      DO 100 IST = 1,NST
         CALL GETCOL (IST, KOLS(1), DATP, LRNO, IOBUF, ITYPE, XPOS,
     *      SCRTCH, IER)
         IF (IER.LT.0) GO TO 100
         IF (IER.NE.0) GO TO 975
         CALL GETCOL (IST, KOLS(2), DATP, LRNO, IOBUF, ITYPE, YPOS,
     *      SCRTCH, IER)
         IF (IER.NE.0) GO TO 975
         CALL GETCOL (IST, KOLS(3), DATP, LRNO, IOBUF, ITYPE, DDUM,
     *      SCRTCH, IER)
         DELX = RDUM(1)
         IF (IER.NE.0) GO TO 975
         CALL GETCOL (IST, KOLS(4), DATP, LRNO, IOBUF, ITYPE, DDUM,
     *      SCRTCH, IER)
         DELY = RDUM(1)
         IF (IER.NE.0) GO TO 975
         CALL GETCOL (IST, KOLS(3), DATP, LRNO, IOBUF, ITYPE, DDUM,
     *      SCRTCH, IER)
         DELJ = RDUM(1)
         IF (IER.NE.0) GO TO 975
         CALL GETCOL (IST, KOLS(4), DATP, LRNO, IOBUF, ITYPE, DDUM,
     *      SCRTCH, IER)
         DELN = RDUM(1)
         IF (IER.NE.0) GO TO 975
         POSANG = 0.0
         IF (NCOL.GT.4) THEN
            CALL GETCOL (IST, KOLS(5), DATP, LRNO, IOBUF, ITYPE, DDUM,
     *         SCRTCH, IER)
            POSANG = RDUM(1)
            END IF
         STTYPE = 0
C                                       If a Star type column
         IF (NCOL.GT.5) THEN
            CALL GETCOL (IST, KOLS(6), DATP, LRNO, IOBUF, ITYPE, DDUM,
     *         SCRTCH, IER)
            TX = RDUM(1)
            STTYPE = IROUND (TX)
            END IF
         LABEL = ' '
C                                       If a Star Label
         IF (NCOL.GT.6) THEN
            CALL GETCOL (IST, KOLS(7), DATP, LRNO, IOBUF, ITYPE, DDUM,
     *         SCRTCH, IER)
C                                       If label is right length
            IF (ITYPE.EQ.(MXSTLB*10)+3) THEN
               CALL H2CHR( MXSTLB, 1, RDUM, LABEL)
            ELSE
               LABEL = ' '
               END IF
            END IF
C                                       Convert to radians
         POSANG = POSANG*TWOPI/360.0
         COSPA = COS(POSANG)
         SINPA = SIN(POSANG)
         COSDEC = ABS (COS (YPOS*DG2RAD))
         CALL XYPIX (XPOS, YPOS, AX(1), AY(1), IER)
C                                       If star not in plot, get next
         IF ((BLC(1).GT.AX(1)) .OR. (BLC(2).GT.AY(1)) .OR.
     *       (TRC(1).LT.AX(1)) .OR. (TRC(2).LT.AY(1))) GO TO 100
C                                       Move and Put Text on plot
C                                       Calculate ends of star mark
         DELJ = 0.5 * DELJ * ABS(FACTOR)
         DELN = 0.5 * DELN * ABS(FACTOR)
         IF (CORTYP(LOCNUM).EQ.1) THEN
            COSDEC = ABS (COS (YPOS*DG2RAD))
            DX = XPOS + DELJ*SINPA/COSDEC
            DY = YPOS + DELJ*COSPA
         ELSE IF (CORTYP(LOCNUM).EQ.2) THEN
            COSDEC = ABS (COS (XPOS*DG2RAD))
            DX = XPOS + DELJ*COSPA
            DY = YPOS + DELJ*SINPA/COSDEC
         ELSE
            DX = XPOS
            DY = YPOS + DELJ
            END IF
         CALL XYPIX (DX, DY, AX(2), AY(2), IER)
         IF (IER.NE.0) GO TO 100
         DX = 2.0 * XPOS - DX
         DY = 2.0 * YPOS - DY
         CALL XYPIX (DX, DY, AX(3), AY(3), IER)
         IF (IER.NE.0) GO TO 100
         IF (CORTYP(LOCNUM).EQ.1) THEN
            DX = XPOS - DELN*COSPA/COSDEC
            DY = YPOS + DELN*SINPA
         ELSE IF (CORTYP(LOCNUM).EQ.2) THEN
            DX = XPOS + DELN*SINPA
            DY = YPOS - DELN*COSPA/COSDEC
         ELSE
            DX = XPOS - DELN
            DY = YPOS
            END IF
         CALL XYPIX (DX, DY, AX(4), AY(4), IER)
         IF (IER.NE.0) GO TO 100
         DX = 2.0 * XPOS - DX
         DY = 2.0 * YPOS - DY
         CALL XYPIX (DX, DY, AX(5), AY(5), IER)
         IF (IER.NE.0) GO TO 100
         CALL LINLIM (BLC, TRC, AX(2), AY(2), IER)
         IF (IER.NE.0) GO TO 100
         CALL LINLIM (BLC, TRC, AX(4), AY(4), IER)
         IF (IER.NE.0) GO TO 100
         IERR = 3
         CALL PFXY (AX(2), AY(2), Z0, XR, YR)
         CALL GPOS (XR, YR, PLBUF, IER)
         IF (IER.NE.0) GO TO 985
         CALL PFXY (AX(4), AY(4), Z0, XR, YR)
         CALL GVEC (XR, YR, PLBUF, IER)
         IF (IER.NE.0) GO TO 985
         CALL PFXY (AX(3), AY(3), Z0, XR, YR)
         CALL GVEC (XR, YR, PLBUF, IER)
         IF (IER.NE.0) GO TO 985
         CALL PFXY (AX(5), AY(5), Z0, XR, YR)
         CALL GVEC (XR, YR, PLBUF, IER)
         IF (IER.NE.0) GO TO 985
         CALL PFXY (AX(2), AY(2), Z0, XR, YR)
         CALL GVEC (XR, YR, PLBUF, IER)
         IF (IER.NE.0) GO TO 985
         NPL = NPL + 1
 100     CONTINUE
      IERR = 0
      WRITE (MSGTXT,1100) NPL, IV
      CALL MSGWRT (2)
      GO TO 985
C                                       Error print and close
 975  WRITE (MSGTXT,1975) IER
      IERR = 2
 980  CALL MSGWRT (8)
 985  CALL TABIO ('CLOS', I, IST, SCRTCH, IOBUF, IER)
      GO TO 999
C                                       Error print
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I5,' OPENING ',A2,' FILE VERSION',I4)
 1020 FORMAT ('CANNOT FIND COLUMNS IN STAR TABLE: HAS IMAGE',
     *   ' BEEN TRANSPOSED?')
 1100 FORMAT ('Plotted',I5,' positions from ST table version',I4)
 1975 FORMAT ('IO ERROR',I5,' IN STAR TABLE FILE')
      END

      SUBROUTINE ZWAI2 (FCB, IERR)
C-----------------------------------------------------------------------
C! wait for read/write large blocks of data from/to disk
C# Z2 IO-basic
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Waits for the completion of an asynchronous I/O operation and
C   returns its completion status and transfer count in AIPS-bytes
C   (1/2 of a local integer).
C   In/out:
C      FCB    I(*)   File control block for open disk file & buffer
C   Output:
C      IERR   I      Error return code: 0 => no error
C                       3 => I/O error
C                       4 => end of file
C   VMS version
C-----------------------------------------------------------------------
      INTEGER   FCB(*), IERR
C
      INTEGER   JERR, SYS$WAITFR, ITEMP(2)
      INTEGER*2 I2TEMP(4)
      INCLUDE 'INCS:DZCH.INC'
      INCLUDE '($SSDEF)'
      EQUIVALENCE (ITEMP, I2TEMP)
C-----------------------------------------------------------------------
      IERR = 0
C                                       Wait for IO completion
      JERR = SYS$WAITFR (%VAL(FCB(1+FCBSP1)))
C                                       Check error in service
      IF (JERR.NE.1) THEN
         IERR = 7
         FCB(1+FCBERR) = JERR
         FCB(1+FCBXFR) = 0
C                                       check IO errors
      ELSE
         ITEMP(1) = FCB(1+FCBSP2)
         ITEMP(2) = FCB(2+FCBSP2)
         JERR = I2TEMP(1)
C                                       long word byte count
         I2TEMP(4) = I2TEMP(3)
         I2TEMP(3) = I2TEMP(2)
         FCB(1+FCBXFR) = ITEMP(2)
C                                       no error
         IF ((JERR.EQ.1) .OR. (JERR.EQ.0)) THEN
            IERR = 0
            FCB(1+FCBERR) = 0
C                                       general IO error
         ELSE
            IERR = 3
            FCB(1+FCBERR) = JERR
            IF (JERR.EQ.SS$_ENDOFFILE) IERR = 4
            END IF
         END IF
C
 999  RETURN
      END

      SUBROUTINE AUC (BRANCH)
C-----------------------------------------------------------------------
C! verbs to enter, list, drop gripes, enter password, max ap size
C# POPS-appl Gripes
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1998, 2002, 2004, 2008, 2012-2013, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AUC performs operations related to the Gripe and Password files.
C   Branch = 1 : GRIPE    enter a new Gripe.
C            2 : GRINDEX  index the Gripes now in the file.
C            3 : GRLIST   list an individual gripe.
C            4 : PASSWORD change the current password.
C            5 : GRDROP   drop the most recent gripe
C            6 : SETMAXAP set the maximum AP size
C   The Gripe file is named GR100000. and starts with one record of
C   index information as:
C   Word   1   : Number of 512-byte records now in file.
C          2   : Number of Gripes now in file.
C          3   : Record number for next Gripe.
C          4   : Character position in that record for next Gripe.
C        5 - 7 : Reserved.
C          8   : Gripe #1 logon user number.
C          9   : Gripe #1 start record number.
C         10   : Gripe #1 start character position.
C         ...  : Gripes #2 - 83.
C   The individual entries are packed character strings having the
C   form: ' {date   time}  {system ID string}  {logon user #}
C   {...name...}  {...address...}  {...phone...}
C   {...gripe contents...} {one line description } {E-mail address }
C   { }'.
C-----------------------------------------------------------------------
      INTEGER   BRANCH
C
      LOGICAL   F, T
      INTEGER   HBUF(256), I, IERR, ILP, IND(2), IPC, IPOS, IRNO, JL,
     *   IT(6), ITRIM, J, J0, J1, J2, KPOS, KREC, LENSTR, LLP, IDUM,
     *   LLPOS, LLREC, LPC, LPOS, LREC, LUN(2), NCH, NCHPR, NUMBER,
     *   POTERR, PWUSER, IROUND, OPOS, JERR, ADDRSZ
      REAL      RBUF(256), RDUM, APSIZ
      HOLLERITH CBUF(256), WBUF(256)
      CHARACTER APASS*12, BPASS*12, DATE*12, EMAIL*80, PHNAME*48,
     *   PRGNAM*6, QUIT*4, TIME*8, CDUM*1, SCNAME*256
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DIO.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PAPC.INC'
      EQUIVALENCE (HBUF(1), RBUF(1))
      DATA T, F /.TRUE.,.FALSE./
      DATA QUIT /'_END'/
      DATA PRGNAM /'AUC '/
C-----------------------------------------------------------------------
C                                       Check status: interactive only
      IF ((BRANCH.LT.1) .OR. (BRANCH.GT.6)) GO TO 999
      POTERR = 60
      IF ((NPOPS.GT.NINTRN) .OR. (TSKNAM(1:5).EQ.'AIPSC')) GO TO 980
      IF (ISBTCH.EQ.32000) GO TO 980
      POTERR = 53
      IF ((IUNIT.NE.1) .AND. (BRANCH.EQ.1)) GO TO 980
      SCNAME = ' '
      LUN(1) = 13
      LUN(2) = 0
C                                       Open GR disk and read
      IF ((BRANCH.NE.4) .AND. (BRANCH.NE.6)) THEN
         POTERR = 50
         CALL ZPHFIL ('GR', 1, 0, 0, PHNAME, IERR)
         CALL ZOPEN (LUN, IND, 1, PHNAME, F, T, T, IERR)
         IF (IERR.NE.0) THEN
            IND(1) = 0
            GO TO 980
            END IF
         CALL ZFIO ('READ', LUN, IND, 1, RBUF, IERR)
         IF (IERR.NE.0) GO TO 970
         END IF
C                                       Branch to operation
      GO TO (100, 200, 300, 400, 300, 600), BRANCH
C-----------------------------------------------------------------------
C                                       GRIPE
C                                       Enter a new gripe.
C-----------------------------------------------------------------------
 100  IF (HBUF(2).GE.83) THEN
         WRITE (MSGTXT,1100)
         GO TO 960
         END IF
C                                       Create temporary mail file
      CALL ZFULLN (' ', 'FITS', 'gripemail', SCNAME, IERR)
      POTERR = 55
      IF (IERR.NE.0) GO TO 970
      LUN(2) = 3
      CALL ZTXOPN ('QWRT', LUN(2), IND(2), SCNAME, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         LUN(2) = 0
         SCNAME = ' '
         END IF
C                                       Set up new directory entry
      IPC = 8 + 3 * HBUF(2)
      HBUF(IPC)   = NLUSER
      HBUF(IPC+1) = HBUF(3)
      HBUF(IPC+2) = HBUF(4)
      IPT = '!'
C                                       Read first Gripe record
      IRNO = HBUF(3)
      CALL ZFIO ('READ', LUN, IND, IRNO, CBUF, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Date and time
      CALL ZDATE (IT(1))
      CALL ZTIME (IT(4))
      CALL TIMDAT (IT(4), IT(1), TIME, DATE)
      JBUFF = DATE // TIME
      CALL CHGRIP (0, LUN, IND, HBUF, CBUF, JBUFF(1:20), IERR)
      IF (IERR.NE.0) GO TO 190
C                                       System ID
      JBUFF = HSTNAM // ' ' // SYSNAM
      CALL CHGRIP (0, LUN, IND, HBUF, CBUF, JBUFF(1:33), IERR)
      IF (IERR.NE.0) GO TO 190
C                                       User # ID
      WRITE (JBUFF,1105) NLUSER, RLSNAM, SYSTYP
      CALL CHGRIP (0, LUN, IND, HBUF, CBUF, JBUFF(1:20), IERR)
      IF (IERR.NE.0) GO TO 190
C                                       General instructions
      MSGTXT = 'Please limit each GRIPE to one bug report and/or ' //
     *   'suggestion.'
      CALL MSGWRT (1)
      MSGTXT = 'Please give details and use lower case where ' //
     *   'appropriate.'
      CALL MSGWRT (1)
C                                       Name
      CALL ADVERB ('GRNAME', 'C', 1, 20, IDUM, RDUM, JBUFF)
      IF (ERRNUM.NE.0) GO TO 970
C                                       I've seen this one before
      IF (JBUFF.NE.' ') THEN
         MSGTXT = 'Hello again ' // JBUFF(1:20)
         CALL MSGWRT (1)
C                                       Don't know his name
      ELSE
         MSGTXT ='What is your name?'
         CALL MSGWRT (1)
         CALL PREAD (KARBUF)
         IF (ERRNUM.NE.0) GO TO 970
         CALL ADVRBS ('GRNAME', 'C', 1, 20, IDUM, RDUM, JBUFF)
         IF (ERRNUM.NE.0) GO TO 970
         END IF
      CALL CHGRIP (0, LUN, IND, HBUF, CBUF, JBUFF(1:20), IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Address - get it if I don't have
C                                       it.
      CALL ADVERB ('GRADDRES', 'C', 1, 48, IDUM, RDUM, JBUFF)
      IF (ERRNUM.NE.0) GO TO 970
      IF (JBUFF.EQ.' ') THEN
         MSGTXT = 'In one line, what is your address?'
         CALL MSGWRT (1)
         CALL PREAD (KARBUF)
         IF (ERRNUM.NE.0) GO TO 970
         CALL ADVRBS ('GRADDRES', 'C', 1, 48, IDUM, RDUM, JBUFF)
         IF (ERRNUM.NE.0) GO TO 970
         END IF
      CALL CHGRIP (0, LUN, IND, HBUF, CBUF, JBUFF(1:48), IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Phone - may already have it.
      CALL ADVERB ('GRPHONE', 'C', 1, 16, IDUM, RDUM, JBUFF)
      IF (ERRNUM.NE.0) GO TO 970
      IF (JBUFF.EQ.' ') THEN
         MSGTXT = 'What is your phone number?'
         CALL MSGWRT (1)
         CALL PREAD (KARBUF)
         IF (ERRNUM.NE.0) GO TO 970
         CALL ADVRBS ('GRPHONE', 'C', 1, 16, IDUM, RDUM, JBUFF)
         IF (ERRNUM.NE.0) GO TO 970
         END IF
      CALL CHGRIP (0, LUN, IND, HBUF, CBUF, JBUFF(1:16), IERR)
      IF (IERR.NE.0) GO TO 190
C                                       Get E-mail address
      CALL ADVERB ('GREMAIL', 'C', 1, 48, IDUM, RDUM, JBUFF)
      IF (ERRNUM.NE.0) GO TO 970
      IF (JBUFF.EQ.' ') THEN
         MSGTXT = 'At what E-Mail address can you be reached?'
         CALL MSGWRT (1)
         CALL PREAD (KARBUF)
         IF (ERRNUM.NE.0) GO TO 970
         CALL ADVRBS ('GREMAIL', 'C', 1, 48, IDUM, RDUM, JBUFF)
         IF (ERRNUM.NE.0) GO TO 970
         END IF
      EMAIL = JBUFF
C                                       Show system, version
      MSGTXT = 'Gripe from version ' // RLSNAM // ' System name: '//
     *   HSTNAM
      CALL MSGWRT (1)
C                                       Gripe itself
      MSGTXT = 'Enter your comment 1 line at a time.  Type _END ' //
     *   'or _end to stop.'
      CALL MSGWRT (1)
      MSGTXT = 'Type _FORGET or _forget to exit without recording the'
     *   // ' gripe'
      CALL MSGWRT (1)
      DO 160 I = 1,64
         CALL PREAD (KARBUF)
         IF (ERRNUM.NE.0) GO TO 970
         IPC = 2
         IF (I.EQ.1) IPC = 1
         CALL CHGRIP (IPC, LUN, IND, HBUF, CBUF, JBUFF(1:NBYTES), IERR)
         IF (IERR.EQ.99) GO TO 170
         IF (IERR.NE.0) GO TO 190
 160     CONTINUE
      MSGTXT = 'Enough already!!!'
      CALL MSGWRT (1)
      JBUFF = QUIT
      CALL CHGRIP (IPC, LUN, IND, HBUF, CBUF, JBUFF(1:4), IERR)
      IF ((IERR.NE.0) .AND. (IERR.NE.99)) GO TO 970
C                                       Get one line summary
 170  MSGTXT = 'Give a one line summary of your problem/suggestion:'
      CALL MSGWRT (1)
      CALL PREAD (KARBUF)
      IF (ERRNUM.NE.0) GO TO 970
C                                       Write one-liner, email final { }
      IP = 0
      LENSTR = ITRIM (JBUFF(:80))
      CALL CHGRIP (IP, LUN, IND, HBUF, CBUF, JBUFF(:LENSTR), IERR)
      IF (IERR.NE.0) GO TO 970
      LENSTR = ITRIM (EMAIL)
      CALL CHGRIP (IP, LUN, IND, HBUF, CBUF, EMAIL(1:LENSTR), IERR)
      IF (IERR.NE.0) GO TO 970
      CALL CHGRIP (IP, LUN, IND, HBUF, CBUF, '  ', IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Done : write data, dir.
      IRNO = HBUF(3)
      CALL ZFIO ('WRIT', LUN, IND, IRNO, CBUF, IERR)
      IF (IERR.NE.0) GO TO 970
      HBUF(2) = HBUF(2) + 1
      CALL ZFIO ('WRIT', LUN, IND, 1, RBUF, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       send e-mail
      IF (LUN(2).GT.0) THEN
         CALL ZTXCLS (LUN(2), IND(2), IERR)
         CALL ZGMAIL (SCNAME, IERR)
         IF (IERR.NE.0) CALL ZTXZAP (3, SCNAME, IERR)
         SCNAME = ' '
         END IF
      GO TO 990
C                                       _forget occurred
 190  IF (IERR.GT.0) GO TO 970
         MSGTXT = 'Partial gripe has been ''FORGOTTEN'''
         CALL MSGWRT (3)
         IF (LUN(2).GT.0) CALL ZTXCLS (LUN(2), IND(2), IERR)
         IF (SCNAME.NE.' ') CALL ZTXZAP (3, SCNAME, IERR)
         GO TO 990
C-----------------------------------------------------------------------
C                                       GRINDEX
C                                       Index contents: #, date, names
C-----------------------------------------------------------------------
 200  WRITE (MSGTXT,1200)
      CALL MSGWRT (2)
      LPC = 5
      NUMBER = HBUF(2)
      HBUF(3) = 0
      IF (NUMBER.LE.0) GO TO 990
      DO 230 I = 1,NUMBER
         LPC = LPC + 3
C                                       Read rec 1 of gripe
         IF (HBUF(LPC+1).EQ.HBUF(3)) GO TO 210
            HBUF(3) = HBUF(LPC+1)
            IRNO = HBUF(3)
            CALL ZFIO ('READ', LUN, IND, IRNO, CBUF, IERR)
            IF (IERR.NE.0) GO TO 970
 210     HBUF(4) = HBUF(LPC+2)
C                                       Seq and user #s
         WRITE (MSGTXT,1210) I, HBUF(LPC)
C                                       Time
         CALL CHGRIP (3, LUN, IND, HBUF, CBUF, JBUFF, IERR)
         IF (IERR.NE.0) GO TO 970
         MSGTXT(12:31) = JBUFF(1:20)
C                                       Skip System ID
         CALL CHGRIP (3, LUN, IND, HBUF, CBUF, JBUFF, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       user #, version, systype
         CALL CHGRIP (3, LUN, IND, HBUF, CBUF, JBUFF, IERR)
         IF (IERR.NE.0) GO TO 970
C                                       find version
         J1 = ITRIM (JBUFF)
         J0 = 0
 215     J0 = J0 + 1
         IF (JBUFF(J0:J0).NE.' ') GO TO 215
         J0 = J0 + 2
         MSGTXT(34:40) = JBUFF(J0:J0+6)
         J0 = J0 + 9
         J1 = MIN (J1, J0+3)
         IF (J0.LE.J1) MSGTXT(42:45) = JBUFF(J0:J1)
C                                       User name
         CALL CHGRIP (3, LUN, IND, HBUF, CBUF, JBUFF, IERR)
         IF (IERR.NE.0) GO TO 970
         MSGTXT(48:80) = JBUFF(1:33)
         CALL MSGWRT (2)
 230     CONTINUE
      GO TO 990
C-----------------------------------------------------------------------
C                                       GRLIST
C                                       List a gripe
C                                       GRDROP
C                                       Drop a gripe: e-mail part
C-----------------------------------------------------------------------
 300  CALL ADVERB ('JOBNUM', 'I', 1, 0, LPC, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IF ((LPC.LT.1) .OR. (LPC.GT.HBUF(2))) LPC = HBUF(2)
      IF (LPC.LE.0) GO TO 990
C                                       Create temporary mail file
      IPC = 5 + 3 * LPC
      LUN(2) = 0
      IF (BRANCH.EQ.5) THEN
         IF ((HBUF(IPC).NE.NLUSER) .AND. (NLUSER.NE.1)) THEN
            WRITE (MSGTXT,1500) LPC
            POTERR = 101
            GO TO 960
            END IF
         IF (HBUF(IPC).EQ.NLUSER) THEN
            CALL ZFULLN (' ', 'FITS', 'gripemail', SCNAME, JERR)
            POTERR = 55
            IF (JERR.NE.0) GO TO 970
            LUN(2) = 3
            CALL ZTXOPN ('QWRT', LUN(2), IND(2), SCNAME, .FALSE., JERR)
            IF (JERR.NE.0) THEN
               LUN(2) = 0
               SCNAME = ' '
               END IF
            END IF
         END IF
      I = 5 + 3 * LPC
      HBUF(3) = HBUF(I+1)
      HBUF(4) = HBUF(I+2)
      IRNO = HBUF(3)
      CALL ZFIO ('READ', LUN, IND, IRNO, CBUF, IERR)
      IF (IERR.NE.0) GO TO 970
      WRITE (MSGTXT,1300) LPC, HBUF(I)
      IF (BRANCH.EQ.5) WRITE (MSGTXT,1301) LPC, HBUF(I)
      CALL MSGWRT (3)
      DO 310 I = 1,72
         CALL CHGRIP  (3, LUN, IND, HBUF, CBUF, JBUFF, IERR)
         IF ((IERR.GT.0) .AND. (IERR.NE.100)) GO TO 970
         IF ((BRANCH.EQ.5) .AND. (LUN(2).GT.0)) THEN
            CALL CHTRIM (JBUFF, 80, JBUFF, JL)
            JL = MAX (1, JL)
            CALL ZTXIO ('WRIT', LUN(2), IND(2), JBUFF(:JL), JERR)
            IF (JERR.NE.0) THEN
               CALL ZTXCLS (LUN(2), IND(2), JERR)
               LUN(2) = 0
               END IF
         ELSE
            MSGTXT = JBUFF
            IF (I.NE.2) CALL MSGWRT (3)
            END IF
         IF ((I.GT.6) .AND. (IERR.NE.100)) GO TO 320
 310     CONTINUE
C                                       Summary
 320  MSGTXT = 'Summary:'
      IF (LUN(2).LE.0) CALL MSGWRT (3)
      CALL CHGRIP  (3, LUN, IND, HBUF, CBUF, JBUFF, IERR)
      IF (IERR.NE.0) GO TO 970
      IF ((BRANCH.EQ.5) .AND. (LUN(2).GT.0)) THEN
         CALL CHTRIM (JBUFF, 80, JBUFF, JL)
         JL = MAX (1, JL)
         CALL ZTXIO ('WRIT', LUN(2), IND(2), JBUFF(:JL), JERR)
         IF (JERR.NE.0) THEN
            CALL ZTXCLS (LUN(2), IND(2), JERR)
            LUN(2) = 0
            END IF
      ELSE
         MSGTXT = JBUFF
         CALL MSGWRT (3)
         END IF
C                                       E-Mail address
      CALL CHGRIP  (3, LUN, IND, HBUF, CBUF, JBUFF, IERR)
      IF (IERR.NE.0) GO TO 970
      IF ((BRANCH.EQ.5) .AND. (LUN(2).GT.0)) THEN
         CALL CHTRIM (JBUFF, 80, JBUFF, JL)
         JL = MAX (1, JL)
         CALL ZTXIO ('WRIT', LUN(2), IND(2), JBUFF(:JL), JERR)
         IF (JERR.NE.0) THEN
            CALL ZTXCLS (LUN(2), IND(2), JERR)
            LUN(2) = 0
            END IF
      ELSE
         MSGTXT = 'E-Mail address:' // JBUFF(1:50)
         CALL MSGWRT (3)
         END IF
C                                       send e-mail
      IF (BRANCH.EQ.5) THEN
         IF (LUN(2).GT.0) THEN
            JBUFF = '*****  DROP THE ABOVE GRIPE *****'
            CALL CHTRIM (JBUFF, 80, JBUFF, JL)
            JL = MAX (1, JL)
            CALL ZTXIO ('WRIT', LUN(2), IND(2), JBUFF(:JL), JERR)
            IF (JERR.NE.0) THEN
               CALL ZTXCLS (LUN(2), IND(2), JERR)
               LUN(2) = 0
            ELSE
               CALL ZTXCLS (LUN(2), IND(2), JERR)
               CALL ZGMAIL (SCNAME, JERR)
               IF (JERR.NE.0) THEN
                  CALL ZTXZAP (3, SCNAME, JERR)
                  LUN(2) = 0
                  END IF
               SCNAME = ' '
               END IF
            END IF
         IF (LUN(2).LE.0) THEN
            MSGTXT = 'Warning: no message sent to aipsmail@nrao.edu'
            CALL MSGWRT (6)
            END IF
         GO TO 500
         END IF
      GO TO 990
C-----------------------------------------------------------------------
C                                       PASSWORD
C                                       Enter a new password.
C-----------------------------------------------------------------------
 400  POTERR = 50
      CALL ZPHFIL ('PW', 1, 0, 0, PHNAME, IERR)
      CALL ZOPEN (LUN, IND, 1, PHNAME, F, T, T, IERR)
      IF (IERR.NE.0) THEN
         IND(1) = 0
         GO TO 980
         END IF
C                                       AIPS manager (user number 1) can
C                                       change passwords for others.
      PWUSER = NLUSER
C                                       Alternate user number on stack?
      IF (NLUSER.EQ.1) THEN
         IF ((SP.GE.1) .AND. (STACK(SP).NE.2)) THEN
            PWUSER = IROUND(V(SP))
            SP = SP - 1
            END IF
         END IF
      WRITE (MSGTXT,1400) PWUSER
      CALL MSGWRT (8)
      MSGTXT= 'Enter the desired new password (<= 12 characters)'
      CALL MSGWRT (1)
      CALL ZPASWD (APASS, HBUF, IERR)
      MSGTXT = 'Please verify'
      CALL MSGWRT (1)
      CALL ZPASWD (BPASS, HBUF, IERR)
      IF (BPASS.NE.APASS) THEN
         MSGTXT = 'Passwords don''t match!  try again'
         CALL MSGWRT (8)
         GO TO 990
         END IF
      IF (IERR.NE.0) GO TO 970
         I = 3
         J = 256 / I
         I = MOD (PWUSER-1, J) * 3 + 1
         IRNO = (PWUSER - 1) / J + 1
         CALL ZFIO ('READ', LUN, IND, IRNO, RBUF, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL PASENC (APASS, RBUF(I))
         CALL ZFIO ('WRIT', LUN, IND, IRNO, RBUF, IERR)
         IF (IERR.NE.0) GO TO 970
         GO TO 990
C-----------------------------------------------------------------------
C                                       GRDROP
C                                       Delete a gripe
C-----------------------------------------------------------------------
 500  CALL ADVERB ('JOBNUM', 'I', 1, 0, LPC, RDUM, CDUM)
      IF (ERRNUM.NE.0) GO TO 980
      IF ((LPC.LT.1) .OR. (LPC.GT.HBUF(2))) LPC = HBUF(2)
      IF (LPC.LE.0) GO TO 990
      IPC = 5 + 3 * LPC
      IF ((HBUF(IPC).EQ.NLUSER) .OR. (NLUSER.EQ.1)) GO TO 510
         WRITE (MSGTXT,1500) LPC
         POTERR = 101
         GO TO 960
C                                       gripe is last one
 510  IF (LPC.LT.HBUF(2)) GO TO 520
         HBUF(3) = HBUF(IPC+1)
         HBUF(4) = HBUF(IPC+2)
         GO TO 580
C                                       Gripe is intermediate one
 520  CONTINUE
         LREC = HBUF(IPC+1)
         KREC = HBUF(IPC+4)
         LPOS = HBUF(IPC+2)
         KPOS = HBUF(IPC+5)
         LLREC = HBUF(3)
         LLPOS = HBUF(4)
         NCHPR = 1024
         CALL ZFIO ('READ', LUN, IND, LREC, WBUF, IERR)
         IF (IERR.NE.0) GO TO 970
         CALL ZFIO ('READ', LUN, IND, KREC, CBUF, IERR)
         IF (IERR.NE.0) GO TO 970
         OPOS = LPOS
         IPOS = KPOS
 530     J1 = NCHPR + 1 - OPOS
            J2 = NCHPR + 1 - IPOS
            IF (KREC.EQ.LLREC) J2 = LLPOS - IPOS
            J0 = MIN (J1, J2)
            CALL CHCOPY (J0, IPOS, CBUF, OPOS, WBUF)
            OPOS = OPOS + J0
            IPOS = IPOS + J0
C                                       output record full
            IF (OPOS.LE.NCHPR) GO TO 540
               CALL ZFIO ('WRIT', LUN, IND, LREC, WBUF, IERR)
               IF (IERR.NE.0) GO TO 970
               LREC = LREC + 1
               OPOS = 1
C                                       input record exhausted
 540        IF ((KREC.EQ.LLREC) .AND. (IPOS.GE.LLPOS)) GO TO 550
            IF (IPOS.LE.NCHPR) GO TO 530
               KREC = KREC + 1
               IF (KREC.GT.LLREC) GO TO 550
               CALL ZFIO ('READ', LUN, IND, KREC, CBUF, IERR)
               IF (IERR.NE.0) GO TO 970
               IPOS = 1
               GO TO 530
 550     IF (OPOS.LE.1) GO TO 560
            LLP = NCHPR + 1 - OPOS
            CALL CHFILL (LLP, HBLANK, OPOS, WBUF)
            CALL ZFIO ('WRIT', LUN, IND, LREC, WBUF, IERR)
            IF (IERR.NE.0) GO TO 970
C                                       fix directory
 560     LLP = HBUF(2) - 1
         LPC = LPC + 1
         IPC = IPC + 3
         IF (LPC.GT.LLP) GO TO 570
            DO 565 ILP = LPC,LLP
               HBUF(IPC-3) = HBUF(IPC)
               NCH = HBUF(IPC+5) - HBUF(IPC+2) + HBUF(IPC-1) - 1
     *            + NCHPR * (HBUF(IPC+4) - HBUF(IPC+1))
               HBUF(IPC+1) = HBUF(IPC-2) + NCH / NCHPR
               HBUF(IPC+2) = MOD (NCH, NCHPR) + 1
               IPC = IPC + 3
 565           CONTINUE
 570     NCH = HBUF(4) - HBUF(IPC+2) + HBUF(IPC-1) - 1
     *      + NCHPR * (HBUF(3) - HBUF(IPC+1))
         HBUF(3) = HBUF(IPC-2) + NCH / NCHPR
         HBUF(4) = MOD (NCH, NCHPR) + 1
         HBUF(IPC-3) = HBUF(IPC)
 580  HBUF(2) = HBUF(2) - 1
      CALL ZFIO ('WRIT', LUN, IND, 1, RBUF, IERR)
      IF (IERR.NE.0) GO TO 970
      GO TO 990
C-----------------------------------------------------------------------
C                                       SETMAXAP
C                                       examine/set a max AP size
C-----------------------------------------------------------------------
 600  RDUM = 0.0
      IF ((SP.GE.1) .AND. (STACK(SP).NE.2)) THEN
         RDUM = V(SP)
         SP = SP - 1
         END IF
      APSIZ = KAPWRD / 128.0
      WRITE (MSGTXT,1600) APSIZ
      CALL MSGWRT (4)
      J = RDUM * 128.0 + 0.5
      CALL ZADRSZ (ADDRSZ)
      J1 = 2 * 128 * 8 - 48
      IF (ADDRSZ.EQ.8) J1 = 6 * 256 * 8
C                                       message
      IF ((J.LT.PSAPMN) .OR. (RDUM.GT.J1)) THEN
         J = PSAPMN / 256
         WRITE (MSGTXT,1601) J, J1
         CALL MSGWRT (4)
C                                       change the SP file!
      ELSE
         APSIZ = J / 128.0
         WRITE (MSGTXT,1602) APSIZ
         CALL MSGWRT (4)
         CALL ZPHFIL ('SP', 1, 0, 0, PHNAME, IERR)
         CALL ZOPEN (LUN, IND, 1, PHNAME, F, T, T, IERR)
         IF (IERR.NE.0) THEN
            IND(1) = 0
            GO TO 980
            END IF
         CALL ZFIO ('READ', LUN, IND, 1, RBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         HBUF(11) = J
         HBUF(69) = 0
         CALL ZFIO ('WRIT', LUN, IND, 1, RBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         CALL ZCLOSE (LUN, IND, IERR)
         KAPWRD = J
         KAP2WD = 0
         END IF
      GO TO 999
C-----------------------------------------------------------------------
C                                       Errors
 960  CALL MSGWRT (8)
 970  IF (SCNAME.NE.' ') CALL ZTXZAP (3, SCNAME, IERR)
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      IF (ERRNUM.NE.0) THEN
         ERRLEV = ERRLEV + 1
         IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
         END IF
C
 990  IPT = '>'
      IF (IND(1).GT.0) CALL ZCLOSE (LUN, IND, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('GRIPE FILE FULL - CALL AIPS MANAGER')
 1105 FORMAT (I5,2X,A7,2X,A4)
 1200 FORMAT ('Seq User',6X,'Date',7X,'Time',4X,'Version OS  ',2X,
     *   'Name')
 1210 FORMAT (I3,I5)
 1300 FORMAT ('Gripe number',I3,'  from user number',I5)
 1301 FORMAT ('Dropping gripe number',I3,'  from user number',I5)
 1400 FORMAT ('Changing password for user',I5)
 1500 FORMAT ('GRIPE',I3,' DOES NOT BELONG TO YOU')
 1600 FORMAT ('SETMAXAP: current max dynamic AP is',F10.3,' Mbytes')
 1601 FORMAT ('SETMAXAP: allowed range is',I4,' to',I6,' Mbytes')
 1602 FORMAT ('SETMAXAP: setting max dynamic AP to',F10.3,' Mbytes')
      END

      SUBROUTINE GINITL (BLC, TRC, XYRATO, CHOUT, DEPTH, BUFF, IERR)
C-----------------------------------------------------------------------
C! writes an initialize-for-line-drawing command into a plot file or TV
C# Plot-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2002, 2011, 2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GINITL will write an 'init for line drawing' command record to a
C   graph file. Common variables will also be initialized.
C   The output record description is:
C            I       opcode, 2 in this program.
C            I       XYRATO * 100
C            I       scale factor used in calculating I   X and Y in
C                    GPOS and GVEC. Equal to SCALEF.
C            I(4)    BLC,TRC integer part (BLC rounded up, TRC down)
C            I(4)    floating remainder * 1000 from BLC, TRC
C            I(4)    10 * (CHOUT) number of characters
C                    outside pix area on left, bot, right, top, resp.
C            I(5)    array location on axes 3,4,5,6,7
C   OR inputs for the TV display of the plot will be prepared.
C   Inputs:
C      BLC     R(2)    number of first pixel in row & col
C      TRC     R(2)    last pixel pos in row/col (usually 1 more
C                      than the number of pixels)
C      XYRATO  R       ratio between x and y axis plotting
C      DEPTH   I(5)    array location on axes 3 thru 7
C   In/Out:
C      CHOUT   R(4)    number of characters outside pix on left,
C                      bottom, right, top, resp.
C      BUFF    I(256)  buffer to use for I/O.
C   Output:
C      IERR    I       error code. 0 = ok.
C                                  1 => disk problems
C   Common:
C      GPHPOS  incremented by 20.
C      GPHRRN  incremented by 1 if a write to disk is needed.
C      GPHX1   set to X1 = BLC(1) (rounded up to integer)
C      GPHX2   set to X2 = TRC(1) (rounded down to integer)
C      GPHY1   set to Y1 = BLC(2) (rounded up to integer)
C      GPHY2   set to Y2 = TRC(2) (rounded down to integer)
C-----------------------------------------------------------------------
      REAL      BLC(2), TRC(2), XYRATO, CHOUT(4)
      INTEGER   DEPTH(5), BUFF(256), IERR
C
      INTEGER   NEED, OPCODE, IER, CMAXTV(2), NXA, NYA, I
      REAL      AX, AY, X, Y, CATR(256)
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      EQUIVALENCE (CATR, GPHCAT)
      DATA NEED, OPCODE /237, 2/
C-----------------------------------------------------------------------
      IERR = 0
      DO 10 I = 1,4
         CHOUT(I) = MAX (CHOUT(I), 0.833)
 10   CONTINUE
      IF (XYRATO.LE.0.0) THEN
         IF (GPHDOT) THEN
            IF (WINDTV(4).GT.WINDTV(2)) XYRATO =
     *         (WINDTV(3)-WINDTV(1)+1.0) / (WINDTV(4)-WINDTV(2)+1.0)
            IF (XYRATO.LE.0.0) XYRATO = 1.4
         ELSE
            XYRATO = 1.0
            END IF
         END IF
C                                       Set common values.
      GPHIX1 = BLC(1) + 0.999
      GPHIY1 = BLC(2) + 0.999
      GPHIX2 = TRC(1) + 0.001
      GPHIY2 = TRC(2) + 0.001
      GPHRX1 = BLC(1) - GPHIX1
      GPHRY1 = BLC(2) - GPHIY1
      GPHRX2 = TRC(1) - GPHIX2
      GPHRY2 = TRC(2) - GPHIY2
      GPHX1 = GPHIX1
      GPHX2 = GPHIX2
      GPHY1 = GPHIY1
      GPHY2 = GPHIY2
C                                       Plot file
      IF (.NOT.GPHDOT) THEN
         IF (GPHPOS.GE.NEED) THEN
            CALL GPHWRT (BUFF, IER)
            IF (IER.NE.0) THEN
               IERR = 1
               GO TO 999
               END IF
            END IF
C                                       Put data in buffer.
         BUFF(GPHPOS+1) = OPCODE
         BUFF(GPHPOS+2) = XYRATO * 100.0 + 0.5
         BUFF(GPHPOS+3) = SCALEF + 0.5
         BUFF(GPHPOS+4) = GPHIX1
         BUFF(GPHPOS+5) = GPHIY1
         BUFF(GPHPOS+6) = GPHIX2
         BUFF(GPHPOS+7) = GPHIY2
         BUFF(GPHPOS+8) = 1000.0 * GPHRX1 + 0.5
         BUFF(GPHPOS+9) = 1000.0 * GPHRY1 + 0.5
         BUFF(GPHPOS+10) = 1000.0 * GPHRX2 + 0.5
         BUFF(GPHPOS+11) = 1000.0 * GPHRY2 + 0.5
         BUFF(GPHPOS+12) = CHOUT(1)*10.0 + 0.5
         BUFF(GPHPOS+13) = CHOUT(2)*10.0 + 0.5
         BUFF(GPHPOS+14) = CHOUT(3)*10.0 + 0.5
         BUFF(GPHPOS+15) = CHOUT(4)*10.0 + 0.5
         CALL COPY (5, DEPTH, BUFF(GPHPOS+16))
C                                       Update buffer counter.
         GPHPOS = GPHPOS + 20
C                                       TV
      ELSE
         GPHCHL = CHOUT(1) * CSIZTV(1) + 0.9
         GPHCHB = CHOUT(2) * CSIZTV(2) + 0.9
         GPHCHR = CHOUT(3) * CSIZTV(1) + 0.9
         GPHCHT = CHOUT(4) * CSIZTV(2) + 0.9
         CALL COPY (5, DEPTH, GPHCAT(IIDEP))
C                                       check number pixels
         CMAXTV(1) = GPHTVW(3) - GPHTVW(1) + 1
         CMAXTV(2) = GPHTVW(4) - GPHTVW(2) + 1
         NXA = CMAXTV(1) - GPHCHL - GPHCHR - 1
         IF (NXA.LE.0) THEN
            GPHTVW(1) = 1
            GPHTVW(3) = MAXXTV(1)
            CMAXTV(1) = MAXXTV(1)
            NXA = MAXXTV(1) - GPHCHL - GPHCHR - 1
            END IF
         NYA = CMAXTV(2) - GPHCHT - GPHCHB - 1
         IF (NYA.LE.0) THEN
            GPHTVW(2) = 1
            GPHTVW(4) = MAXXTV(2)
            CMAXTV(2) = MAXXTV(2)
            NYA = MAXXTV(2) - GPHCHT - GPHCHB - 1
            END IF
         IF ((NXA.LE.0) .OR. (NYA.LE.0)) THEN
            WRITE (MSGTXT,1100) NXA, NYA
            GO TO 990
            END IF
C                                        self scale
         AX = ABS (GPHIX2 - GPHIX1) * XYRATO
         AY = ABS (GPHIY2 - GPHIY1)
         IF ((GPHIX2.EQ.GPHIX1) .OR. (GPHIY2.EQ.GPHIY1)) THEN
            WRITE (MSGTXT,1110) AX, AY
            GO TO 990
            END IF
         IF ((GPHCRN(1).EQ.0) .OR. (GPHCRN(2).EQ.0)) THEN
            X = ABS (GPHIX2+GPHRX2-GPHIX1-GPHRX1) * XYRATO
            Y = ABS (GPHIY2+GPHRY2-GPHIY1-GPHRY1)
            IF ((X.LE.0) .OR. (Y.LE.0)) THEN
               WRITE (MSGTXT,1110) X, Y
               GO TO 990
               END IF
C
            IF ((X/Y).LE.FLOAT(NXA)/FLOAT(NYA)) THEN
               GPHSCY = NYA * AY / Y
               GPHSCX = GPHSCY * AX / AY
            ELSE
               GPHSCX = NXA * AX / X
               GPHSCY = GPHSCX * AY/AX
               END IF
C                                       Center
            NXA = GPHSCX * X / AX + GPHCHL + GPHCHR
            IF (NXA.GT.CMAXTV(1)) THEN
               GPHTVW(1) = 1
               GPHTVW(3) = MAXXTV(1)
               CMAXTV(1) = MAXXTV(1)
               END IF
            GPHIX0 = GPHTVW(1) + GPHCHL + MAX (0, CMAXTV(1)-NXA)/2
     *         + 0.9 - GPHRX1 * XYRATO * GPHSCX / AX
            NYA = GPHSCY * Y/AY + GPHCHB + GPHCHT
            IF (NYA.GT.CMAXTV(2)) THEN
               GPHTVW(2) = 1
               GPHTVW(4) = MAXXTV(2)
               CMAXTV(2) = MAXXTV(2)
               END IF
            GPHIY0 = GPHTVW(2) + GPHCHB + MAX (0, CMAXTV(2)-NYA)/2
     *         + 0.9 - GPHRY1 * GPHSCY / AY
C                                        pixel scaling
         ELSE
            GPHIX0 = GPHCRN(1)
            GPHIY0 = GPHCRN(2)
            GPHSCX = GPHIX2 - GPHIX1
            GPHSCY = GPHIY2 - GPHIY1
            END IF
C                                       catalog block
         GPHCAT(IIWIN  ) = GPHIX1
         GPHCAT(IIWIN+1) = GPHIY1
         GPHCAT(IIWIN+2) = GPHIX2
         GPHCAT(IIWIN+3) = GPHIY2
         GPHCAT(IICOR  ) = GPHIX0
         GPHCAT(IICOR+1) = GPHIY0
         GPHCAT(IICOR+2) = GPHIX0 + GPHSCX
         GPHCAT(IICOR+3) = GPHIY0 + GPHSCY
         CALL CHR2H (2, '  ', 1, GPHCAT(IITRA))
         CATR(IRRAN) = 0.0
         CATR(IRRAN+1) = 0.0
         END IF
      GO TO 999
C                                       error
 990  CALL MSGWRT (7)
      IERR = 2
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('GINITL: NOT ROOM ON TV FOR CHARACTERS: NXA, NYA =',2I7)
 1110 FORMAT ('GINITL: NOT ENOUGH PIXELS SPECIFIED: X,Y =',2E10.3)
      END

      SUBROUTINE WXSEL (DISKI, CNOI, DISKO, CNOO, VER, CATIN, CATOUT,
     *   LUNI, LUNO, TB, TE, AN, NA, ISUB, JSUB, BUFFER, OBUFF, IRET)
C-----------------------------------------------------------------------
C! Copies a subset of times, antennas, subarrays in a weather table
C# EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2004, 2007, 2016, 2023
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Copies a subset of times, subarrays, antennas in a WX weather table
C   Inputs:
C      DISKI    I        Input volume number
C      CNOI     I        Input catalog number
C      DISKO    I        Output volume number
C      CNOO     I        Output catalog number
C      VER      I        Version to check/modify
C      CATIN    I(256)   Input catalog header
C      LUNI     I        LUN to use - in
C      LUNO     I        LUN to use - out
C      TB       D        Beginning time in days
C      TE       D        Ending time in days
C      AN       I(*)     Array of selected antennas
C      NA       I        Number of selected antennas
C      ISUB     I        Selected subarray (= 0 any)
C      JSUB     I        Output subarray number (< 0 => NO CHANGE)
C   Input/Output:
C      CATOUT   I(256)   Output catalog header
C      BUFFER   I(*)     Work buffer
C      OBUFF    I(*)     Work buffer
C   Output:
C      IRET     I        Error, 0 => OK
C-----------------------------------------------------------------------
      INTEGER   DISKI, CNOI, DISKO, CNOO, VER, CATIN(256), CATOUT(256),
     *   LUNI, LUNO, AN(*), NA, ISUB, JSUB, BUFFER(*), OBUFF(*), IRET
      DOUBLE PRECISION TB, TE
C
      INCLUDE 'INCS:DWXV.INC'
      INTEGER   IWXRNO, WXKOLS(MAXWXC), WXNUMV(MAXWXC), OKOLS(MAXWXC),
     *   ONUMV(MAXWXC), NWXROW, I, OVER, ANTNO,SUBA, OWXRNO, K, TABVER
      CHARACTER OBSCOD*8, OBSDAT*8
      LOGICAL   REFMT, GOTIT
      DOUBLE PRECISION TIME
      REAL      DTIME, TEMP, PRESS, DEWPT, WVEL, WDIR, WGUST, PRECIP,
     *   H2OCOL, IONCOL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
C-----------------------------------------------------------------------
C                                       Open WX file
      CALL WXINI ('READ', BUFFER, DISKI, CNOI, VER, CATIN, LUNI, IWXRNO,
     *   WXKOLS, WXNUMV, OBSCOD, OBSDAT, TABVER, IRET)
      IF (IRET.EQ.2) THEN
         IRET = 0
         GO TO 999
         END IF
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       # rows in old table
      REFMT = .FALSE.
      NWXROW = BUFFER(5)
C                                       Open up new WX table
      OVER = VER
      CALL WXINI ('WRIT', OBUFF, DISKO, CNOO, OVER, CATOUT, LUNO,
     *   OWXRNO, OKOLS, ONUMV, OBSCOD, OBSDAT, TABVER, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Loop and copy
      DO 100 I = 1,NWXROW
         CALL TABWX ('READ', BUFFER, IWXRNO, WXKOLS, WXNUMV, TIME,
     *      DTIME, ANTNO, SUBA, TEMP, PRESS, DEWPT, WVEL, WDIR, WGUST,
     *      PRECIP, H2OCOL, IONCOL, IRET)
C                                       Error reading table
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1020) IRET
            GO TO 990
C                                       check subarray, time
         ELSE IF (IRET.EQ.0) THEN
            IF ((SUBA.GT.0) .AND. (ISUB.GT.0) .AND. (ISUB.NE.SUBA))
     *         IRET = -1
            IF ((TIME.LT.TB) .OR. (TIME.GT.TE)) IRET = -1
C                                       antenna
            IF ((NA.GT.0) .AND. (ANTNO.GT.0)) THEN
               GOTIT = .FALSE.
               DO 30 K = 1,NA
                  GOTIT = GOTIT .OR. (ANTNO.EQ.AN(K))
 30               CONTINUE
               IF (.NOT.GOTIT) IRET = -1
               END IF
            END IF
C                                       This record dropped
         IF (IRET.LT.0) THEN
            REFMT = .TRUE.
C                                       This record kept
         ELSE
C                                       Write new one
            IF ((JSUB.GE.0) .AND. (SUBA.GT.0)) SUBA = JSUB
            CALL TABWX ('WRIT', OBUFF, OWXRNO, OKOLS, ONUMV, TIME,
     *         DTIME, ANTNO, SUBA, TEMP, PRESS, DEWPT, WVEL, WDIR,
     *         WGUST, PRECIP, H2OCOL, IONCOL, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1020) IRET
               GO TO 990
               END IF
            END IF
 100     CONTINUE
      IRET = 0
C                                       Close both tables
      CALL TABIO ('CLOS', 0, IWXRNO, BUFFER, BUFFER, IRET)
      CALL TABIO ('CLOS', 0, OWXRNO, OBUFF, OBUFF, IRET)
      IF ((MSGSUP.LT.31990) .OR. (MSGSUP.GE.32000)) THEN
         IF (REFMT) THEN
            WRITE (MSGTXT,1100) 'Reformatted WX', DISKI, CNOI, VER,
     *         DISKO, CNOO, OVER
         ELSE
            WRITE (MSGTXT,1100) 'Copied WX', DISKI, CNOI, VER, DISKO,
     *         CNOO, OVER
            END IF
         CALL MSGWRT (3)
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('WXSEL: ERROR ',I3,' RETURNED FROM WXINI')
 1020 FORMAT ('WXSEL: ERROR ',I3,' RETURNED FROM TABWX')
 1100 FORMAT (A,' file from vol/cno/vers',I3,I5,I4,' to',I3,I5,I4)
      END

LOCAL INCLUDE 'TARPL.INC'
C                                       PLTLAB declarations.
      INTEGER   MAXPNT, MAXTYP
      PARAMETER (MAXTYP = 30)
      PARAMETER (MAXPNT = 4000)
C
      REAL       CHOUT(4), YGAP, XP(MAXPNT,MAXTYP), YP1(MAXPNT,MAXTYP),
     *   YP2(MAXPNT,MAXTYP), XMAX, XMIN, Y1MAX, Y1MIN, Y2MAX, Y2MIN,
     *   Y3MIN, Y3MAX, BLC(7), TRC(7), YPS(MAXPNT,MAXTYP,2)
      INTEGER    PCODES(5), NP, STTYPE(MAXTYP,2), LITYPE(MAXTYP,2),
     *   NSTYPE(MAXTYP), NCOL, ICOL(MAXTYP), NGRP
      CHARACTER  XUNIT*24, YUNIT(2)*24, TITLE*80
      LOGICAL    DOCOLR, ISQU, DOTYP(30)
      EQUIVALENCE (YP1, YPS(1,1,1))
C                                       Plot labeling parameters.
      COMMON /PLTLAB/ CHOUT, YGAP, PCODES, XP, YP1, YP2, XMAX, XMIN,
     *   Y1MAX, Y1MIN, Y2MAX, Y2MIN, Y3MIN, Y3MAX, NP, BLC, TRC, NGRP,
     *   STTYPE, LITYPE, NSTYPE, DOCOLR, NCOL, ICOL, ISQU, DOTYP
      COMMON /PLCLAB/ XUNIT, YUNIT, TITLE
C                                       INPARM declarations.
      HOLLERITH XNAMIN(3), XCLSIN(2), XINFIL(12)
      REAL      PRUSER, XSEQ, XDISK, APARM(10), RPARM(30), VPARM(30),
     *   FACTOR, DO3COL, LTYPE, XYRATO, XDOTV, XGRCH, PARMS(96)
      EQUIVALENCE (PRUSER, PARMS)
C                                       Parameters from AIPS.
      COMMON /INPARM/ PRUSER, XNAMIN, XCLSIN, XSEQ, XDISK, XINFIL,
     *   APARM, RPARM, VPARM, FACTOR, DO3COL, LTYPE, XYRATO, XDOTV,
     *   XGRCH
C
LOCAL END
LOCAL INCLUDE 'TARPL.PLT'
      INTEGER   PLTBLK(256), GRCHN, TVCHN, TVCORN(4), IPLOT1, IPLOT2,
     *   LINT, IMSTUF(40), IBLKSZ, IVER, IPLOT, IOFFPL
      LOGICAL   DOTV
      REAL      XY, PBLC(2,2), PTRC(2,2), XSCAL, XOFF, YSCAL(2),
     *   YOFF(2), XRANGE, YRANGE(2), XLAST, YLAST
      COMMON /PLTARS/ PLTBLK, GRCHN, TVCHN, TVCORN, IPLOT1, IPLOT2,
     *   LINT, DOTV, XY, PBLC, PTRC, XSCAL, XOFF, YSCAL, YOFF, XRANGE,
     *   YRANGE, IMSTUF, IBLKSZ, IVER, XLAST, YLAST, IPLOT, IOFFPL
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DGPH.INC'
LOCAL END
      PROGRAM TARPL
C-----------------------------------------------------------------------
C! General plot task for TARS input and output files
C# Plot
C-----------------------------------------------------------------------
C;  Copyright (C) 2012, 2014-2015, 2017, 2020
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   TARPL is a task to read data rom a TARS output file and make plots
C   of RM spectra
C   Inputs:   (from AIPS)
C       USERID    R      user number, 0 means use logon user
C                        number, 32000 means any user can be accessed.
C       INNAME    R(3)   name of primary file. to attach plot file
C       INCLASS   R(2)   class of primary file.
C       INSEQ     R      sequence number of primary file.
C       NDISK     R      disk volume number. 0 means try all.
C       INFILE    H(12)  Input text file
C       APARM     R(10)  Plot controls
C       LTYPE     R      Label type.
C       DOTV      R      > 0 => TV, else plot file
C       GRCHAN    R      graphics channel to use (0 => 1)
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   NPARMS, IERR, IDEBUG, IPTYPE, IROUND, I
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'TARPL.PLT'
      INCLUDE 'TARPL.INC'
      DATA PRGNAM /'TARPL '/
C-----------------------------------------------------------------------
C                                       Copy from DATA to Commons
      IBLKSZ = MABFSS
      GPHIND = 0
C                                       Don't delete plot file on error
      IDEBUG = 1
C                                       This is the number of REAL*4
C                                       words to get from AIPS.
      NPARMS = 96
C                                       Plot type TARPL paraform
      IPTYPE = 70
      CALL FILL (5, 0, PCODES)
C                                       Get parms from AIPS, open map
C                                       file, create plot file,
      CALL TARPLI (PRGNAM, NPARMS, IERR)
C                                       Labeling type:
      PCODES(1) = IROUND (LTYPE)
      I = MOD (ABS(PCODES(1)), 100)
      IF ((I.EQ.0) .OR. (I.GT.10)) I = 3
      IF (PCODES(1).LT.0) THEN
         PCODES(1) = (PCODES(1)/100)*100 - I
      ELSE
         PCODES(1) = (PCODES(1)/100)*100 - I
         END IF
C                                       Do plotting.
      IF (IERR.EQ.0) CALL PLOTER (NPARMS, IPTYPE, IERR)
C                                       Shutdown.
      CALL PLEND (IERR, IDEBUG)
C
 999  STOP
      END
      SUBROUTINE TARPLI (PRGNAM, NPARMS, IERR)
C-----------------------------------------------------------------------
C   This routine does all the intial set up.  Get parms from AIPS,
C   open the map file, create the plot file and write the plot file
C   records to do the plot labeling.
C   Inputs:
C      PRGNAM C*6    Name of this program.
C      NPARMS I      Number of R words to get from AIPS.
C   Output:
C      IERR   I      Error code. 0=ok.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   NPARMS, IERR
C
      CHARACTER NAME*36, FNAME*12, FCLASS*6, FPTYPE*2, STAT*4, LINE*80,
     *   INFILE*48
      INTEGER   IWORK(256), FSEQ, FVOL, FUSID, TLUN, TIND, KBP, IMLUN,
     *   I, IROUND, JT, JTRIM, IGRP, J
      DOUBLE PRECISION X
      REAL      SCALE(2), TEMP
      LOGICAL   ISAMP, ZERO
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'TARPL.INC'
      INCLUDE 'TARPL.PLT'
      DATA TLUN, IMLUN /3, 16/
C-----------------------------------------------------------------------
C                                       Get parameters from AIPS, init
C                                       AIPS I/O, other startup things.
      CALL SETUP (PRGNAM, NPARMS, PARMS, IWORK, IERR)
      IF (IERR.NE.0) GO TO 999
      DOCOLR = DO3COL.GT.0.0
C                                       Open the map file.
      CALL H2CHR (12, 1, XNAMIN, FNAME)
      CALL H2CHR (6, 1, XCLSIN, FCLASS)
      FSEQ = XSEQ + 0.01
      FVOL = XDISK + 0.01
      PRUSER = NLUSER
      FUSID = NLUSER
      DOTV = XDOTV.GT.0.0
      GRCHN = XGRCH + 0.01
      TVCHN = 1
      CALL FILL (4, 0, TVCORN)
      STAT = 'HDWR'
      IF (DOTV) STAT = 'READ'
      CALL A2WAWA (FNAME, FCLASS, FSEQ, '  ', FVOL, FUSID, NAME)
      CALL INTMIO (IMLUN, STAT, NAME, BLC, TRC, IBLKSZ, CATBLK,
     *   IMSTUF, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       fill in adverbs w actual values
      CALL WAWA2A (NAME, FNAME, FCLASS, FSEQ, FPTYPE, FVOL, FUSID)
      CALL CHR2H (12, FNAME, 1, XNAMIN)
      CALL CHR2H (6, FCLASS, 1, XCLSIN)
      XSEQ = FSEQ
      XDISK = FVOL
      CALL FILL (MAXTYP, 0, NSTYPE)
      ZERO = .TRUE.
      DO 5 I = 1,MAXTYP
         DOTYP(I) = (RPARM(I).NE.0.0) .OR. (VPARM(I).GT.0.0)
         IF (DOTYP(I)) ZERO = .FALSE.
 5       CONTINUE
      IF (ZERO) CALL RFILL (MAXTYP, 1.0, RPARM)
      IF (ZERO) CALL LFILL (MAXTYP, .TRUE., DOTYP)
C                                       gather parameters
      DO 10 I = 1,MAXTYP
         STTYPE(I,1) = IROUND (RPARM(I))
         IF ((STTYPE(I,1).LT.0) .AND. (APARM(7).LE.0.0)) THEN
            STTYPE(I,2) = -STTYPE(I,1)
            STTYPE(I,1) = 0
         ELSE
            STTYPE(I,1) = ABS (STTYPE(I,1))
            STTYPE(I,2) = STTYPE(I,1)
            END IF
         IF (STTYPE(I,1).GT.23) STTYPE(I,1) = 1
         IF (STTYPE(I,2).GT.23) STTYPE(I,2) = 1
         LITYPE(I,1) = IROUND (VPARM(I))
         IF ((LITYPE(I,1).LT.0) .AND. (APARM(7).LE.0.0)) THEN
            LITYPE(I,2) = 0
            LITYPE(I,1) = -LITYPE(I,1)
         ELSE
            LITYPE(I,1) = ABS (LITYPE(I,1))
            LITYPE(I,2) = LITYPE(I,1)
            END IF
 10      CONTINUE
      XMAX = -1.E10
      Y1MAX = XMAX
      Y2MAX = XMAX
      Y3MAX = XMAX
      Y1MIN = -Y1MAX
      Y2MIN = -Y2MAX
      Y3MIN = -Y3MAX
      XMIN = Y1MIN
      J = IROUND (APARM(7))
      IF (J.EQ.0) J = -1
      IF (J.LT.-3) J = -1
      IF (J.GT.3) J = 1
      APARM(7) = J
      XUNIT = 'Rotation measure'
      IF (J.EQ.1) THEN
         YUNIT(1) = 'Real part'
         YUNIT(2) = 'Imaginary part'
      ELSE
         YUNIT(1) = 'Amplitude'
         YUNIT(2) = 'Phase'
         END IF
      CALL FILL (MAXTYP, -1, ICOL)
      NCOL = 0
C                                       OPEN text file to get info
      CALL H2CHR (48, 1, XINFIL, INFILE)
      CALL ZTXOPN ('READ', TLUN, TIND, INFILE, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READ TEXT FILE'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      IGRP = 0
      ISQU = .FALSE.
      APARM(10) = 0.0
C                                       Read for start of first group
 15   CALL ZTXIO ('READ', TLUN, TIND, LINE, IERR)
      IF (IERR.NE.0) GO TO 999
      JT = JTRIM (LINE)
      IF (JT.LE.0) GO TO 15
      IF (LINE(:1).EQ.';') THEN
         IF (LINE(:5).EQ.';   K') GO TO 40
         GO TO 15
         END IF
      ISQU = .TRUE.
      GO TO 90
C                                       parse a start-group card
 40   IGRP = IGRP + 1
      NGRP = IGRP
      NP = 0
      I = INDEX (LINE, '10^')
      I = I + 3
      READ (LINE(I:I), 1005) J
      SCALE(1) = 10.0 ** (-J)
      I = INDEX (LINE, 'PHASE')
      IF (I.GT.0) THEN
         ISAMP = .TRUE.
         SCALE(2) = 1.0
      ELSE
         ISAMP = .FALSE.
         SCALE(2) = SCALE(1)
         END IF
C                                       read loop
 50   CALL ZTXIO ('READ', TLUN, TIND, LINE, IERR)
      IF (IERR.EQ.0) THEN
         JT = JTRIM (LINE)
         IF (LINE(:5).EQ.';   K') GO TO 40
         IF (JT.LE.0) GO TO 50
         IF ((LINE(:1).NE.' ') .AND. ((LINE(:1).LT.'0') .OR.
     *      (LINE(:1).GT.'9'))) GO TO 50
         KBP = 1
         CALL GETNUM (LINE, 80, KBP, X)
         IF (X.NE.DBLANK) THEN
            CALL GETNUM (LINE, 80, KBP, X)
            IF (X.NE.DBLANK) THEN
               XP(NP+1,IGRP) = X
               CALL GETNUM (LINE, 80, KBP, X)
               IF (X.NE.DBLANK) THEN
                  YP1(NP+1,IGRP) = X * SCALE(1)
                  CALL GETNUM (LINE, 80, KBP, X)
                  IF (X.NE.DBLANK) THEN
                     YP2(NP+1,IGRP) = X * SCALE(2)
                     NP = NP + 1
                     NSTYPE(IGRP) = NSTYPE(IGRP) + 1
C                                       convert
                     IF (ISAMP) THEN
                        IF (APARM(7).GT.0.0) THEN
                           TEMP = YP1(NP,IGRP) *
     *                        COS (DG2RAD * YP2(NP,IGRP))
                           YP2(NP,IGRP) = YP1(NP,IGRP) *
     *                        SIN (DG2RAD * YP2(NP,IGRP))
                           YP1(NP,IGRP) = TEMP
                           END IF
                     ELSE IF (APARM(7).LE.0.0) THEN
                        TEMP = SQRT (YP1(NP,IGRP)**2 + YP2(NP,IGRP)**2)
                        YP2(NP,IGRP) = RAD2DG * ATAN2 (YP2(NP,IGRP),
     *                     YP1(NP,IGRP))
                        YP1(NP,IGRP) = TEMP
                        END IF
C                                       max/min
                     IF (DOTYP(IGRP)) THEN
                        XMAX = MAX (XMAX, XP(NP,IGRP))
                        Y1MAX = MAX (Y1MAX, YP1(NP,IGRP))
                        Y2MAX = MAX (Y2MAX, YP2(NP,IGRP))
                        XMIN = MIN (XMIN, XP(NP,IGRP))
                        Y1MIN = MIN (Y1MIN, YP1(NP,IGRP))
                        Y2MIN = MIN (Y2MIN, YP2(NP,IGRP))
                        IF (APARM(7).LE.0.0) THEN
                           TEMP = YP2(NP,IGRP)
                           IF (TEMP.LT.0.0) TEMP = TEMP + 360.
                           Y3MAX = MAX (Y3MAX, TEMP)
                           Y3MIN = MIN (Y3MIN, TEMP)
                           END IF
                        END IF
                     END IF
                  END IF
               END IF
            END IF
         GO TO 50
      ELSE IF (IERR.EQ.2) THEN
         CALL ZTXCLS (TLUN, TIND, IERR)
      ELSE
         WRITE (MSGTXT,1000) IERR, 'READ TEXT FILE'
         CALL MSGWRT (8)
         END IF
C                                       color pattern
      I = MAXTYP - NGRP
      CALL RFILL (I, 0.0, RPARM(NGRP+1))
      CALL RFILL (I, 0.0, VPARM(NGRP+1))
      CALL FILL (I, 0, NSTYPE(NGRP+1))
      CALL FILL (I, 0, STTYPE(NGRP+1,1))
      CALL FILL (I, 0, LITYPE(NGRP+1,1))
      CALL FILL (I, 0, STTYPE(NGRP+1,2))
      CALL FILL (I, 0, LITYPE(NGRP+1,2))
      DO 60 I = 1,MAXTYP
         IF ((NSTYPE(I).GT.0) .AND. ((STTYPE(I,1).GT.0) .OR.
     *      (LITYPE(I,1).GT.0) .OR. (STTYPE(I,2).GT.0) .OR.
     *      (LITYPE(I,2).GT.0))) THEN
            NCOL = NCOL + 1
            ICOL(I) = NCOL
            END IF
 60      CONTINUE
      GO TO 999
C                                       Q/U spectrum
 90   J = IROUND (APARM(7))
      IF (J.EQ.0) J = -1
      IF (J.LT.-3) J = -1
      IF (J.GT.3) J = 1
      APARM(7) = J
C                                       indicate input file
      APARM(10) = 1.0
      XUNIT = 'Frequency'
      IF (APARM(8).GT.0.0) XUNIT = 'Lambda**2'
      IF (J.EQ.1) THEN
         YUNIT(1) = 'Qpol'
         YUNIT(2) = 'Upol'
      ELSE
         YUNIT(1) = 'Ppol'
         YUNIT(2) = 'Phase'
         END IF
      IGRP = 1
      NGRP = 1
      NCOL = 1
      ICOL(1) = 1
      I = MAXTYP - NGRP
      CALL RFILL (I, 0.0, RPARM(NGRP+1))
      CALL RFILL (I, 0.0, VPARM(NGRP+1))
      CALL FILL (I, 0, NSTYPE(NGRP+1))
      CALL FILL (I, 0, STTYPE(NGRP+1,1))
      CALL FILL (I, 0, LITYPE(NGRP+1,1))
      CALL FILL (I, 0, STTYPE(NGRP+1,2))
      CALL FILL (I, 0, LITYPE(NGRP+1,2))
      GO TO 110
C                                       Q/U spectrum: read loop
 100  CALL ZTXIO ('READ', TLUN, TIND, LINE, IERR)
      IF (IERR.EQ.2) THEN
         CALL ZTXCLS (TLUN, TIND, IERR)
         GO TO 999
      ELSE IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR, 'READ TEXT FILE'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Q/U spectrum: parse
 110  IF ((LINE(:1).NE.' ') .AND. ((LINE(:1).LT.'0') .OR.
     *   (LINE(:1).GT.'9'))) GO TO 100
      KBP = 1
      CALL GETNUM (LINE, 80, KBP, X)
      IF (X.NE.DBLANK) THEN
         IF (APARM(8).GT.0.0) THEN
            XP(NP+1,1) = (VELITE / X) ** 2
         ELSE
            XP(NP+1,1) = X / 1.0D9
            END IF
         CALL GETNUM (LINE, 80, KBP, X)
         IF (X.NE.DBLANK) THEN
            YP1(NP+1,1) = X
            CALL GETNUM (LINE, 80, KBP, X)
            IF (X.NE.DBLANK) THEN
               YP2(NP+1,1) = X
               NP = NP + 1
               NSTYPE(1) = NSTYPE(1) + 1
               IF (APARM(7).LE.0.0) THEN
                  TEMP = SQRT (YP1(NP,1)**2 + YP2(NP,1)**2)
                  YP2(NP,1) = RAD2DG * ATAN2 (YP2(NP,1), YP1(NP,1))
                  YP1(NP,1) = TEMP
               END IF
C                                       max/min
               XMAX = MAX (XMAX, XP(NP,1))
               Y1MAX = MAX (Y1MAX, YP1(NP,1))
               Y2MAX = MAX (Y2MAX, YP2(NP,1))
               XMIN = MIN (XMIN, XP(NP,1))
               Y1MIN = MIN (Y1MIN, YP1(NP,1))
               Y2MIN = MIN (Y2MIN, YP2(NP,1))
               IF (APARM(7).LE.0.0) THEN
                  TEMP = YP2(NP,1)
                  IF (TEMP.LT.0.0) TEMP = TEMP + 360.
                  Y3MAX = MAX (Y3MAX, TEMP)
                  Y3MIN = MIN (Y3MIN, TEMP)
                  END IF
               END IF
            END IF
         END IF
      GO TO 100
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' ON ',A)
 1005 FORMAT (I1)
      END
      SUBROUTINE PLOTER (NPARMS, IPTYPE, IERR)
C-----------------------------------------------------------------------
C   This routine writes all of the plot commands (including the axis
C   drawing and labeling commands) into the plot file.
C      NPARMS I      Number of R words to get from AIPS.
C      IPTYPE I      Plot file type: 1 misc., 2 CNTR, 3 GREYS, 4 PROFL,
C                    5 SL2PL, 6 PCNTR, 7 IMEAN (hist), 8 UVPLT,
C                    9 GNPLT, 10 VBPLT, 11 PFPLn, 12 GAPLT, 13 PLCUB,
C                    14 IMVIM, 15 TAPLT.  Use 1 unless your inputs
C                    match those of these tasks - or take a new number,
C                    but AIPSUB:AU8A will need to know about it too.
C   Output:
C      IERR   I   Error code.  0=ok.
C-----------------------------------------------------------------------
      INTEGER   NPARMS, IPTYPE, IERR
C
      INCLUDE 'INCS:PMAD.INC'
      INCLUDE 'TARPL.INC'
      REAL      X, Y, AX(5), AY(5), DX, DY, CP(MAXTYP)
      INTEGER   I, IPL, DOC
      LOGICAL   DOIT, FIRST
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'TARPL.PLT'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL RFILL (MAXTYP, -1.0, CP)
      IF (NCOL.LE.1) DOCOLR = .FALSE.
      IF (DOCOLR) THEN
         DO 10 I = 1,MAXTYP
            IF (ICOL(I).GT.0) THEN
               IF ((NCOL.LE.4) .AND. (DO3COL.LT.1.5)) THEN
                  CP(I) = 6.0 - ICOL(I)
               ELSE
                  CP(I) = (ICOL(I) - 1.0) / (NCOL - 1.0)
                  END IF
               END IF
 10         CONTINUE
         END IF
C                                       phase wrap
      IF (APARM(7).LE.0.0) THEN
         IF (Y3MAX-Y3MIN.LT.Y2MAX-Y2MIN) THEN
            Y2MAX = Y3MAX
            Y2MIN = Y3MIN
            DO 15 IPL = 1,MAXTYP
               DO 14 I = 1,NSTYPE(IPL)
                  IF (YP2(I,IPL).LT.0.0) YP2(I,IPL) = YP2(I,IPL) + 360.0
 14               CONTINUE
 15            CONTINUE
            END IF
         END IF
C                                       Set corner values.
      IF (APARM(2).LE.APARM(1)) THEN
         APARM(1) = XMIN
         APARM(2) = XMAX
         END IF
      IF (APARM(4).LE.APARM(3)) THEN
         APARM(3) = Y1MIN
         APARM(4) = Y1MAX
         END IF
      IF (APARM(6).LE.APARM(5)) THEN
         APARM(5) = Y2MIN
         APARM(6) = Y2MAX
         END IF
      BLC(1) = 0.0
      TRC(1) = 0.0
      BLC(2) = 1000.0
      TRC(2) = 1000.0
      IF (FACTOR.LE.0.1) FACTOR = 1.0
      IF (XYRATO.LE.0.0) XYRATO = 1.35
      XY = XYRATO
C                                       plot ranges
      IF (ABS(APARM(7)).GT.2.5) THEN
         IPLOT1 = 2
         IPLOT2 = 2
         LINT = 0
      ELSE IF (ABS(APARM(7)).GT.1.5) THEN
         IPLOT1 = 1
         IPLOT2 = 1
         LINT = 1000
      ELSE
         IPLOT1 = 1
         IPLOT2 = 2
         LINT = 500
         IF (APARM(7).LE.0.0) LINT = 700
         END IF
C                                       Create and open plot file.
      CALL PLMAKE (NPARMS, PARMS, IPTYPE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Set up commons for plotting.
      CALL PLINI2 (IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Do axis labeling.
      CALL PLABL2 (IERR)
      IF (IERR.NE.0) GO TO 999
C                                       two plots possibly
      DO 100 IPLOT = IPLOT1,IPLOT2
         DX = 80.0 * FACTOR / XSCAL
         DY = 80.0 * FACTOR / YSCAL(IPLOT)
         DX = DX / SQRT (XY)
         DY = DY * SQRT (XY)
C                                       Line drawing:
         DO 30 IPL = 1,MAXTYP
            IF (ICOL(IPL).GT.0) THEN
               NP = NSTYPE(IPL)
               FIRST = .TRUE.
C                                       Point plot
               IF (STTYPE(IPL,IPLOT).GT.0) THEN
                  CALL GLTYPE (4, PLTBLK, IERR)
                  IF (IERR.NE.0) GO TO 999
                  DO 20 I = 1,NP
                     AX(1) = XP(I,IPL) * XSCAL + XOFF
                     AX(2) = AX(1)
                     AX(3) = AX(1)
                     AX(4) = AX(1) - DX * XSCAL
                     AX(5) = AX(1) + DX * XSCAL
                     AY(1) = YPS(I,IPL,IPLOT)*YSCAL(IPLOT) + YOFF(IPLOT)
                     AY(2) = AY(1) + DY * YSCAL(IPLOT)
                     AY(3) = AY(1) - DY * YSCAL(IPLOT)
                     AY(4) = AY(1)
                     AY(5) = AY(1)
                     IF ((DOCOLR) .AND. (FIRST)) THEN
                        DOC = -1
                        CALL COLVEC (DOC, X, Y, CP(IPL), PLTBLK, IERR)
                        IF (IERR.NE.0) GO TO 999
                        FIRST = .FALSE.
                        END IF
                     DOIT = DOCOLR .AND. (NCOL.GT.4)
                     CALL PNTPLT (STTYPE(IPL,IPLOT), AX, AY,
     *                  PBLC(1,IPLOT), PTRC(1,IPLOT), .FALSE., DOIT,
     *                  PLTBLK, IERR)
                     IF (IERR.NE.0) GO TO 999
 20                  CONTINUE
                  END IF
               END IF
 30         CONTINUE
C                                       Line drawing:
         DO 60 IPL = 1,MAXTYP
            IF (ICOL(IPL).GT.0) THEN
               NP = NSTYPE(IPL)
               FIRST = .TRUE.
               IF (LITYPE(IPL,IPLOT).GE.2) THEN
                  CALL GLTYPE (3, PLTBLK, IERR)
                  IF (IERR.NE.0) GO TO 999
                  X = XP(1,IPL)
                  Y = YPS(1,IPL,IPLOT)
                  CALL PLPOS (X, Y, IERR)
                  IF (IERR.NE.0) GO TO 999
                  DO 40 I = 1,NP-1
                     DOC = 1
                     FIRST = .FALSE.
                     CALL DLINE (LITYPE(IPL,IPLOT)-2, DOC, XP(I,IPL),
     *                  YPS(I,IPL,IPLOT), CP(IPL), PLTBLK, IERR)
                     IF (IERR.NE.0) GO TO 999
 40                  CONTINUE
                  X = XP(NP,IPL)
                  Y = YPS(NP,IPL,IPLOT)
                  CALL COLVEC (DOC, X, Y, CP(IPL), PLTBLK, IERR)
                  IF (IERR.NE.0) GO TO 999
C                                       step line
               ELSE IF (LITYPE(IPL,IPLOT).EQ.1) THEN
                  CALL GLTYPE (2, PLTBLK, IERR)
                  IF (IERR.NE.0) GO TO 999
                  X = XP(1,IPL) + (XP(1,IPL) - XP(MIN(2,NP),IPL)) / 2.0
                  X = MIN (XMAX, MAX (XMIN, X))
                  Y = YPS(1,IPL,IPLOT)
                  CALL PLPOS (X, Y, IERR)
                  IF (IERR.NE.0) GO TO 999
                  DO 50 I = 1,NP
                     IF (FIRST) THEN
                        DOC = 1
                        FIRST = .FALSE.
                     ELSE
                        DOC = 0
                        END IF
                     Y = YPS(I,IPL,IPLOT)
                     IF (I.GT.1) THEN
                        CALL COLVEC (DOC, X, Y, CP(IPL), PLTBLK, IERR)
                        IF (IERR.NE.0) GO TO 999
                        END IF
                     X = (XP(I,IPL) + XP(MIN(I+1,NP),IPL)) / 2.0
                     CALL COLVEC (DOC, X, Y, CP(IPL), PLTBLK, IERR)
                     IF (IERR.NE.0) GO TO 999
                     Y = (YPS(I,IPL,IPLOT) +
     *                  YPS(MIN(I+1,NP),IPL,IPLOT)) / 2.0
                     CALL COLVEC (DOC, X, Y, CP(IPL), PLTBLK, IERR)
                     IF (IERR.NE.0) GO TO 999
 50                  CONTINUE
                  END IF
               END IF
 60         CONTINUE
 100     CONTINUE
C
 999  RETURN
      END
      SUBROUTINE PLINI2 (IERR)
C-----------------------------------------------------------------------
C   This routine will set up the location commons for the plot file.
C   Inputs from common:
C      BLC     R(2)    Bottom left corner of plot.
C      TRC     R(2)    Top right corner of plot.
C   Output:
C      IERR    I       Error code. 0=OK.
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      REAL      XR, YR
      INTEGER   DEPT(5), I, LABEL, J, K
      LOGICAL   PFLG, F
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'TARPL.INC'
      INCLUDE 'TARPL.PLT'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      LABEL = PCODES(1)
      LTYPE = MOD (ABS(LABEL), 100)
C                                       X and Y plot axis not related
C                                       to map axis.
      IF (XY.EQ.0.0) XY = 1.0
      DO 10 I = 1,5
         DEPT(I) = 1
 10      CONTINUE
C                                       Set up default scaling parms.
      XSCAL = 1.0
      XOFF = 0.0
      XRANGE = APARM(2) - APARM(1)
      APARM(1) = APARM(1) - 0.03 * XRANGE
      APARM(2) = APARM(2) + 0.03 * XRANGE
      XRANGE = APARM(2) - APARM(1)
      XSCAL = 16000.0 / XRANGE
      XOFF = - APARM(1) * XSCAL
      TRC(1) = 16000.0
      BLC(1) = 0.0
      K = 0
      TRC(2) = 16000.0
      BLC(2) = 0.0
      PBLC(1,1) = BLC(1)
      PTRC(1,1) = TRC(1)
      PBLC(1,2) = BLC(1)
      PTRC(1,2) = TRC(1)
      PBLC(2,1) = BLC(2)
      PBLC(2,2) = BLC(2) + (LINT / 1000.0) * (TRC(2) - BLC(2))
      PTRC(2,1) = PBLC(2,2)
      PTRC(2,2) = TRC(2)
C                                       two plot types
      DO 100 IPLOT = IPLOT1,IPLOT2
         LOCNUM = IPLOT
         YOFF(IPLOT) = 0.0
         YSCAL(IPLOT) = 0.0
         CALL SETLOC (DEPT, F)
         AXFUNC(1,LOCNUM) = 0
         AXFUNC(2,LOCNUM) = 0
         AXTYP(LOCNUM) = 0
         CORTYP(LOCNUM) = 0
         LABTYP(LOCNUM) = 0
C                                        proper scaling labels
         J = 1 + 2 * IPLOT
         YRANGE(IPLOT) = APARM(J+1) - APARM(J)
         APARM(J) = APARM(J) - 0.03 * YRANGE(IPLOT)
         APARM(J+1) = APARM(J+1) + 0.03 * YRANGE(IPLOT)
         YRANGE(IPLOT) = 1.06 * YRANGE(IPLOT)
C                                       Some kind of error
         IF ((XRANGE.LE.0.0) .OR. (YRANGE(IPLOT).LE.0.0)) THEN
            MSGTXT = 'PLOT RANGE <= 0'
            CALL MSGWRT (8)
            IERR = 5
            GO TO 999
            END IF
         YR = YRANGE(IPLOT)
         CALL METSCL (LABEL, YR, CPREF(2,LOCNUM), PFLG)
C                                       reset scaling parms
         IF (IPLOT.EQ.1) THEN
            YSCAL(IPLOT) = 16000.0 * (LINT/1000.) / YRANGE(IPLOT)
            YOFF(IPLOT) = - APARM(J) * YSCAL(IPLOT)
            RPLOC(2,LOCNUM) = PBLC(2,IPLOT)
         ELSE
            YSCAL(IPLOT) = 16000.0 * (1. - LINT/1000.) / YRANGE(IPLOT)
            YOFF(IPLOT) = - APARM(J) * YSCAL(IPLOT) + 16.0*LINT
            RPLOC(2,LOCNUM) = PBLC(2,IPLOT)
            END IF
C                                       labeling coordinates
         XR = XRANGE
         CALL METSCL (LABEL, XR, CPREF(1,LOCNUM), PFLG)
         RPLOC(1,LOCNUM) = PBLC(1,1)
         RPVAL(1,LOCNUM) = APARM(1) * XR / XRANGE
         RPVAL(2,LOCNUM) = APARM(J) * YR / YRANGE(IPLOT)
         AXINC(1,LOCNUM) = XR / XRANGE / XSCAL
         AXINC(2,LOCNUM) = YR / YRANGE(IPLOT) / YSCAL(IPLOT)
         CTYP(1,LOCNUM) = XUNIT
         CTYP(2,LOCNUM) = YUNIT(IPLOT)
         IF ((IPLOT.EQ.2) .AND. (IPLOT1.LT.IPLOT2)) THEN
            CPREF(1,LOCNUM) = ' '
            CTYP(1,LOCNUM) = ' '
            END IF
C                                       Left border in characters
         IF (LTYPE.GT.2) THEN
            CALL CHNTIC (PBLC(1,IPLOT), PTRC(1,IPLOT), I)
            K = MAX (K, I)
            END IF
 100     CONTINUE
C                                       Left border in characters
      CHOUT(1) = 0.5
      IF (LTYPE.EQ.2) CHOUT(1) = 2.5
      IF (LTYPE.GT.2) THEN
         CHOUT(1) = 3.0
         IF (K.GT.0) CHOUT(1) = 4 + K
         END IF
C                                       Bottom border in characters
      CHOUT(2) = 0.5
      IF (LTYPE.GT.1) CHOUT(2) = CHOUT(2) + 1.5
      IF (LTYPE.GT.2) CHOUT(2) = CHOUT(2) + 1.333
      YGAP = CHOUT(2) - 0.5 + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CHOUT(2) =
     *    CHOUT(2)
C                                       Right border in characters
      CHOUT(3) = 0.5
C                                       Top border in characters
      CHOUT(4) = 0.5
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) CHOUT(4) = CHOUT(4) + 1.5
      IF ((LABEL.GT.0) .AND. (LTYPE.GT.1) .AND. (LTYPE.LT.7))
     *   CHOUT(4) = CHOUT(4) + 1.333
C                                       Write initialization records
C                                       into plot file.
C                                       initialize line drawing
      CALL GINITL (BLC, TRC, XY, CHOUT, DEPT, PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE PLABL2 (IERR)
C-----------------------------------------------------------------------
C   This program uses the values set in PLINI2 and passed through
C   commons LOCATI and PLTCOM to do the axes labeling.
C   Inputs from common:
C      /LOCATI/  (from incs:DLOC.INC)
C      /LOCATC/  (from incs:DLOC.INC)
C      /PLTARS/  (from TARPL.PLT)
C   Output:
C      IERR   I      Error code. 0=ok.
C-----------------------------------------------------------------------
      INTEGER  IERR
C
      REAL      DCX, DCY
      INTEGER   I, IANGLE, INCHAR, IT(3), ID(3), LABEL, J, LLTYPE
      CHARACTER WRKTXT*80, ATIME*8, ADATE*12, ANAME*18
      LOGICAL   F
      INCLUDE 'TARPL.PLT'
      INCLUDE 'INCS:DLOC.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'TARPL.INC'
      DATA F /.FALSE./
C-----------------------------------------------------------------------
      LABEL = PCODES(1)
      LLTYPE = MOD (ABS(PCODES(1)), 100)
C                                        Tics and tic labels
      CALL GLTYPE (1, PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 999
      DO 100 IPLOT = IPLOT1,IPLOT2
         LOCNUM = IPLOT
         CALL CLAB1 (PBLC(1,IPLOT), PTRC(1,IPLOT), CHOUT, LABEL, XY, F,
     *      PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 999
C                                        draw rectangle
         CALL GPOS (PBLC(1,IPLOT), PBLC(2,IPLOT), PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (PTRC(1,IPLOT), PBLC(2,IPLOT), PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (PTRC(1,IPLOT), PTRC(2,IPLOT), PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (PBLC(1,IPLOT), PTRC(2,IPLOT), PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GVEC (PBLC(1,IPLOT), PBLC(2,IPLOT), PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       draw line at zero
         J = IPLOT * 2 + 1
         IF ((APARM(J).LT.0.0) .AND. (APARM(J+1).GT.0.0)) THEN
            DCY = YOFF(IPLOT)
            CALL GPOS (PBLC(1,IPLOT), DCY, PLTBLK, IERR)
            IF (IERR.NE.0) GO TO 999
            CALL GVEC (PTRC(1,IPLOT), DCY, PLTBLK, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
 100     CONTINUE
C                                       title line.
      IF ((LLTYPE.GT.1) .AND. (LLTYPE.LT.7)) THEN
C                                       Standard title
         IF (PCODES(4).EQ.0) THEN
            CALL H2CHR (8, 1, CATH(KHOBJ), TITLE)
            INCHAR = 12
            IF (TITLE.EQ.' ') INCHAR = 1
            IF (NCHLAB(1,LOCNUM).GT.0) THEN
               IF (INCHAR.GT.1) TITLE(INCHAR-1:INCHAR-1) = '_'
               TITLE(INCHAR:) = SAXLAB(1,LOCNUM)(1:NCHLAB(1,LOCNUM))
               INCHAR = INCHAR + 3 + NCHLAB(1,LOCNUM)
               END IF
            IF (NCHLAB(2,LOCNUM).GT.0) THEN
               IF (INCHAR.GT.1) TITLE(INCHAR-1:INCHAR-1) = '_'
               TITLE(INCHAR:) = SAXLAB(2,LOCNUM)(1:NCHLAB(2,LOCNUM))
               INCHAR = INCHAR + 3 + NCHLAB(2,LOCNUM)
               END IF
            IF (INCHAR.GT.1) TITLE(INCHAR-1:INCHAR-1) = '_'
            CALL H2CHR (18, 1, CATH(KHIMN), ANAME)
            CALL NAMEST (ANAME, CATBLK(KIIMS), TITLE(INCHAR:), I)
            CALL REFRMT (TITLE, '_', INCHAR)
            END IF
         CALL GPOS (PBLC(1,IPLOT2), PTRC(2,IPLOT2), PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         DCX = 0.0
         DCY = .5
         IANGLE = 0
         CALL CHTRIM (TITLE, 80, TITLE, INCHAR)
         CALL GCHAR (INCHAR, IANGLE, DCX, DCY, TITLE, PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C                                       Date/time version
      IF ((LABEL.GT.0) .AND. (LLTYPE.GT.1) .AND. (LLTYPE.LT.7)) THEN
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, ATIME, ADATE)
         WRITE (WRKTXT,1020) IVER, ADATE, ATIME
         CALL REFRMT (WRKTXT, '_', INCHAR)
         DCY = DCY + 1.333
         CALL GPOS (PBLC(1,IPLOT2), PTRC(2,IPLOT2), PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL GCHAR (INCHAR, IANGLE, DCX, DCY, WRKTXT, PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT ('PLOT FILE VERSION',I4,'__CREATED ',A,A)
      END
      SUBROUTINE COLVEC (DOC, X, Y, CVAL, PLTBLK, IERR)
C-----------------------------------------------------------------------
C   Plot a color vector
C   Input:
C      X        R        Draw to (X,Y)
C      Y        R        Draw to (X,Y)
C      CVAL     R        Color value 0 - 1 or 2-5 line type
C   In/Out
C      DOC      I        Init the color 1,-1; plot line 1,0
C                        set to 0 on return
C      PLTBLK   I(256)   plot block
C   Output
C      IERR     I        error code
C-----------------------------------------------------------------------
      REAL      X, Y, CVAL
      INTEGER   DOC, PLTBLK(256), IERR
C
      INTEGER   ITY, IROUND
      REAL      RR, GG, BB, CP, GAMMA, V
      PARAMETER (CP = 0.5)
      PARAMETER (GAMMA = 1.0 / 3.0)
C-----------------------------------------------------------------------
C                                       init the color
      IF (DOC.NE.0) THEN
C                                       simple line type
         IF (CVAL.GT.1.5) THEN
            ITY = IROUND (CVAL) - 1
            IF ((ITY.GE.1) .AND. (ITY.LE.4)) THEN
               CALL GLTYPE (ITY, PLTBLK, IERR)
               IF (IERR.NE.0) GO TO 999
               END IF
C                                       3-color
         ELSE IF (CVAL.GE.0.0) THEN
            V = MAX (0.0, MIN (1.0, CVAL))
            BB = 1.0 - V / CP
            RR = (V - CP) / (1.0 - CP)
            BB = MAX (0.0, MIN (1.0, BB))
            RR = MAX (0.0, MIN (1.0, RR))
            GG = 1.0 - RR - BB
            BB = BB ** GAMMA
            GG = GG ** GAMMA
            RR = RR ** GAMMA
            CALL G3VCOL (RR, GG, BB, PLTBLK, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         END IF
C                                       plot vector: 3 color
      IF (DOC.GE.0) THEN
         IF ((CVAL.GE.0.0) .AND. (CVAL.LE.1.5)) THEN
            CALL PL3VEC (X, Y, IERR)
C                                       "no" color line type
         ELSE
            CALL PLVEC (X, Y, IERR)
            END IF
         END IF
      DOC = 0
C
 999  RETURN
      END
      SUBROUTINE DLINE (IT, DOC, XX, YY, CC, PLTBLK, IERR)
C-----------------------------------------------------------------------
C   Draws a dashed line
C   Inputs:
C      IT       I        Type: IT = # breaks between point 1 and 2
C      XX       R(2)     X value of points
C      YY       R(2)     Y value of points
C      CC       R        color
C   Outputs:
C      DOC      I        1 => change color on next line
C      PLTBLK   I(256)   Plot buffer
C      IERR     I        Error code
C-----------------------------------------------------------------------
      INTEGER   IT, DOC, PLTBLK(256), IERR
      REAL      XX(2), YY(2), CC
C
      REAL      DX, DY, X, Y, S
      INTEGER   I
C-----------------------------------------------------------------------
      S = 0.5
      IF (IT.GT.0) S = S / (2.0 * IT)
      DX = XX(2) - XX(1)
      DY = YY(2) - YY(1)
C                                       move to point first
      CALL COLVEC (DOC, XX(1), YY(1), CC, PLTBLK, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       loop
      X = XX(1) + S * DX
      Y = YY(1) + S * DY
      DOC = 0
      DO 20 I = 1,MAX(1,IT)
         CALL COLVEC (DOC, X, Y, CC, PLTBLK, IERR)
         IF (IERR.NE.0) GO TO 999
         DOC = 0
         X = X + 2.0 * S * DX
         Y = Y + 2.0 * S * DY
         IF (IT.GT.0) THEN
            CALL PLPOS (X, Y, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
         X = X + 2.0 * S * DX
         Y = Y + 2.0 * S * DY
 20      CONTINUE
C
 999  RETURN
      END
      SUBROUTINE PLMAKE (NP, RPARM, IGTYPE, IERR)
C-----------------------------------------------------------------------
C   This routine will create and open a plot file, put it in the map
C   header and write the first record into the plot file.
C   PLMAKE assumes that the map/uv file has been marked write and will
C   change it to a read flag.  It would be nice if the defaults had
C   been filled into RPARM before this routine is called.
C   Inputs:
C      NP     I      Number of floating point words in parameter list
C      RPARM  R(NP)  AIPS parameters
C      IGTYPE I      Plot file type: 1 => misc.,  2 => CNTR,
C                     3 => GREYS,  4 => PROFL,  5 => SL2PL,  6 => PCNTR,
C                     7 => IMEAN,  8 => UVPLT,  9 => GNPLT, 10 => VBPLT,
C                    11 => PFPLn, 12 => GAPLT, 13 => PLCUB, 14 => IMVIM,
C                    15 => TAPLT, 16 => POSSM, 17 => SNPLT, 18 => KNTR,
C                    19 => UVHGM, 20 => ISPEC
C                    Use 1 unless your inputs match those of these
C                    tasks - or take a new number, but
C                    AIPSUB:AU8A will need to know about it too.
C   Output:
C      IERR   I      Error code. two digit, first digit indicates
C                    subroutine: 1: MAPOPN, 2: MADDEX, 3: ZPHFIL,
C                    4: GINIT, second digit indicates error code of
C                    that subroutine.
C   Version for TARPL only - not match public version
C-----------------------------------------------------------------------
      INTEGER   NP, IERR, IGTYPE
      REAL      RPARM(*)
C
      INTEGER   IWBLK(256), IGSIZE, IGLUN, IGFIND, I
      CHARACTER PHNAME*48
      LOGICAL   SAVE
      INCLUDE 'TARPL.PLT'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DFIL.INC'
      DATA IGSIZE /0/
      DATA SAVE /.TRUE./
C-----------------------------------------------------------------------
      IF (IGTYPE.LT.1) IGTYPE = 1
C                                       Add plot file to header
      IVER = 0
      IF (.NOT.DOTV) THEN
         CALL MADDEX ('PL', IMSTUF(7), IMSTUF(5), CATBLK, IWBLK, SAVE,
     *      'READ', IVER, IERR)
         IF (IERR.NE.0) THEN
            IERR = IERR + 20
            GO TO 999
            END IF
         END IF
C                                       Change file common
      IF (NCFILE.GT.0) THEN
         DO 15 I = 1,NCFILE
            IF ((FVOL(I).EQ.IMSTUF(7)) .AND. (FCNO(I).EQ.IMSTUF(5)))
     *         FRW(I) = 0
 15         CONTINUE
         END IF
C                                       Make physical filename
      CALL ZPHFIL ('PL', IMSTUF(7), IMSTUF(5), IVER, PHNAME, IERR)
      IF (IERR.NE.0) THEN
         IERR = IERR + 30
         GO TO 999
         END IF
C                                       Open plot file
      CALL GINIT (IMSTUF(7), IMSTUF(5), PHNAME, IGSIZE, IGTYPE, NP,
     *   RPARM, DOTV, TVCHN, GRCHN, TVCORN, CATBLK, PLTBLK, IGLUN,
     *   IGFIND, IERR)
      IF (IERR.NE.0) THEN
         GPHIND = 0
         IERR = IERR + 40
         END IF
C
 999  RETURN
      END
      SUBROUTINE PLEND (ISTAT, IDEBUG)
C-----------------------------------------------------------------------
C   Do some plotting cleanup functions.  Write "end of plot" record,
C   close plot file, check for vectors that were off the plot.
C   Then terminates the task with a call to DIE.
C   Inputs:
C     ISTAT  I         0=successful completion, other=dies unnaturally.
C     IDEBUG I         > 0 => don't delete PL file despite errors
C   Version for TARPL
C-----------------------------------------------------------------------
      INTEGER   ISTAT, IDEBUG
C
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'TARPL.PLT'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DTVD.INC'
C-----------------------------------------------------------------------
C                                       Was plot even opened?
      IF ((GPHIND.GT.0) .OR. (TVIND.GT.0)) THEN
C                                       vectors off plot message
         IF (IOFFPL.GT.0) THEN
            WRITE (MSGTXT,1000) IOFFPL
            CALL MSGWRT (6)
            END IF
C                                       Attempt close partial graph
         IF (ISTAT.GT.0) THEN
            MSGTXT = 'ERROR DURING GRAPHING WILL TRY TO FINISH' //
     *         ' PARTIAL GRAPH'
            CALL MSGWRT (6)
            END IF
C                                       Close plot file
         CALL GFINIS (PLTBLK, IERR)
C                                       OK finish - do HI file
         IF (.NOT.DOTV) THEN
            IF ((IERR.EQ.0) .OR. (IDEBUG.GT.0)) THEN
               CALL HIPLOT (IMSTUF(7), IMSTUF(5), IVER, PLTBLK, IERR)
               WRITE (MSGTXT,1020) IVER
               CALL MSGWRT (2)
C                                       Finish not sucessful. Destroy.
            ELSE
               CALL ZCLOSE (GPHLUN, GPHIND, IERR)
               CALL ZDESTR (GPHVOL, GPHNAM, IERR)
               CALL DELEXT ('PL', IMSTUF(7), IMSTUF(5), 'RDRD', CATBLK,
     *            PLTBLK, IVER, IERR)
               END IF
            END IF
         END IF
C                                       Close down task
      CALL DIE (ISTAT, PLTBLK)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I7,' VECTORS TRUNCATED AT EDGES OF PLOT.')
 1020 FORMAT ('Plot file version',I4,' created')
      END
      SUBROUTINE PLVEC (X, Y, IERR)
C-----------------------------------------------------------------------
C   This routine will put a 'draw vector' command in a plot file.
C   Vectors that are too big are interpolated.
C   Inputs:
C      X       R    X value.
C      Y       R    Y value.
C   Common:
C      /PLTCOM/
C   Output:
C      IERR    I    Error code.  0 means OK.
C-----------------------------------------------------------------------
      REAL      X, Y
      INTEGER   IERR
C
      REAL      XX, YY, XT(2), YT(2)
      INTEGER   NO
      INCLUDE 'TARPL.PLT'
C-----------------------------------------------------------------------
      XX = XSCAL * X + XOFF
      YY = YSCAL(IPLOT) * Y + YOFF(IPLOT)
C                                       Test edge intersections
      CALL INTEDG (PBLC(1,IPLOT), PTRC(1,IPLOT), XX, YY, XLAST, YLAST,
     *   NO, XT, YT)
C                                       Vector all in plot
      IF (NO.LT.0) THEN
         CALL GVEC (XX, YY, PLTBLK, IERR)
C                                       Both points off plot
      ELSE IF (NO.EQ.0) THEN
         IOFFPL = IOFFPL + 1
      ELSE IF (NO.NE.1) THEN
         CALL GPOS (XT(1), YT(1), PLTBLK, IERR)
         IF (IERR.EQ.0) CALL GVEC (XT(2), YT(2), PLTBLK, IERR)
C                                       This point off plot
      ELSE IF ((XX.LT.PBLC(1,IPLOT)) .OR. (XX.GT.PTRC(1,IPLOT)) .OR.
     *   (YY.LT.PBLC(2,IPLOT)) .OR. (YY.GT.PTRC(2,IPLOT))) THEN
         IOFFPL = IOFFPL + 1
         CALL GVEC (XT(1), YT(1), PLTBLK, IERR)
C                                       Last point off plot
      ELSE
         CALL GPOS (XT(1), YT(1), PLTBLK, IERR)
         IF (IERR.EQ.0) CALL GVEC (XX, YY, PLTBLK, IERR)
         END IF
C                                       Save last desired position
      XLAST = XX
      YLAST = YY
C
 999  RETURN
      END
      SUBROUTINE PLPOS (X, Y, IERR)
C-----------------------------------------------------------------------
C   This routine will put a 'position vector' command in a plot file.
C   Inputs:
C      X       R    X value.
C      Y       R    Y value.
C      COMMON /PLTCOM/
C   Output:
C      IERR    I    Error code.  0 means OK.
C-----------------------------------------------------------------------
      REAL      X, Y
      INTEGER   IERR
C
      REAL      XX, YY
      INCLUDE 'TARPL.PLT'
C-----------------------------------------------------------------------
      XX = XSCAL * X + XOFF
      YY = YSCAL(IPLOT) * Y + YOFF(IPLOT)
C                                       Position off plot: flag
      IF ((XX.LT.PBLC(1,IPLOT)) .OR. (XX.GT.PTRC(1,IPLOT)) .OR.
     *   (YY.LT.PBLC(2,IPLOT)) .OR. (YY.GT.PTRC(2,IPLOT))) THEN
         IOFFPL = IOFFPL + 1
C                                       Put position in plot file
      ELSE
         CALL GPOS (XX, YY, PLTBLK, IERR)
         END IF
C                                       Save last position
      XLAST = XX
      YLAST = YY
C
 999  RETURN
      END
      SUBROUTINE PL3VEC (X, Y, IERR)
C-----------------------------------------------------------------------
C   This routine will put a 'draw color vector' command in a plot file.
C   Vectors that are too big are interpolated.
C   Inputs:
C      X       R    X value.
C      Y       R    Y value.
C   Common:
C      /PLTCOM/
C   Output:
C      IERR    I    Error code.  0 means OK.
C-----------------------------------------------------------------------
      REAL      X, Y
      INTEGER   IERR
C
      REAL      XX, YY, XT(2), YT(2)
      INTEGER   NO
      INCLUDE 'TARPL.PLT'
C-----------------------------------------------------------------------
      XX = XSCAL * X + XOFF
      YY = YSCAL(IPLOT) * Y + YOFF(IPLOT)
C                                       Test edge intersections
      CALL INTEDG (PBLC(1,IPLOT), PTRC(1,IPLOT), XX, YY, XLAST, YLAST,
     *   NO, XT, YT)
C                                       Vector all in plot
      IF (NO.LT.0) THEN
         CALL G3VEC (XX, YY, PLTBLK, IERR)
C                                       No points hit plot
      ELSE IF (NO.EQ.0) THEN
         IOFFPL = IOFFPL + 1
C                                       Both points off plot
      ELSE IF (NO.NE.1) THEN
         CALL GPOS (XT(1), YT(1), PLTBLK, IERR)
         IF (IERR.EQ.0) CALL G3VEC (XT(2), YT(2), PLTBLK, IERR)
C                                       This point off plot
      ELSE IF ((XX.LT.PBLC(1,IPLOT)) .OR. (XX.GT.PTRC(1,IPLOT)) .OR.
     *   (YY.LT.PBLC(2,IPLOT)) .OR. (YY.GT.PTRC(2,IPLOT))) THEN
         IOFFPL = IOFFPL + 1
         CALL G3VEC (XT(1), YT(1), PLTBLK, IERR)
C                                       Last point off plot
      ELSE
         CALL GPOS (XT(1), YT(1), PLTBLK, IERR)
         IF (IERR.EQ.0) CALL G3VEC (XX, YY, PLTBLK, IERR)
         END IF
C                                       Save last desired position
      XLAST = XX
      YLAST = YY
C
 999  RETURN
      END

      SUBROUTINE SKPEXT (DOHDR, FDVEC, TBIND, HLUN, ICARD, INBLK, HBUFF,
     *   TAPBUF, FITBLK, IERR)
C-----------------------------------------------------------------------
C! finishes reading FITS extension header, skips the extension data
C# FITS tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  This routine will read the rest of the FITS extension file header
C  to find the END card, and then skip over a number of blocks of data.
C  Inputs:
C     DOHDR    L         T => read rest of header
C     FDVEC    I(50)     File descriptor vector for TAPIO input
C     HLUN     I         LUN of open history file.
C     INBLK    I         Number of data blocks to skip.
C  In/Out:
C     TBIND    I         Buffer pointer in FITBLK
C     ICARD    I         Current card number in FITBLK.
C     TAPBUF   I(*)      Tape I/O block.
C     FITBLK   C*2880    Work buffer - local header record
C  Output:
C     IERR     I         Error code. 0=ok.
C-----------------------------------------------------------------------
      INTEGER   FDVEC(50), TBIND, HLUN, ICARD, INBLK, HBUFF(256),
     *   TAPBUF(*), IERR
      LOGICAL   DOHDR
      CHARACTER FITBLK*2880
C
      CHARACTER SYM*8, HILINE*72, CARD*80
      INTEGER   I, INC, ITYP, JERR, NPNT
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DEHD.INC'
      INCLUDE 'INCS:DTHD.INC'
C-----------------------------------------------------------------------
C                                       Read until we get an end card
      IF (DOHDR) THEN
         DO 10 I = 1,32000
            CALL SKPBLK (FITBLK, ICARD, FDVEC, TAPBUF, TBIND, IERR)
            IF (IERR.NE.0) GO TO 999
C                                       Look for END card
            INC = (ICARD - 1) * 80 + 1
            CARD = FITBLK(INC:INC+79)
C                                       Get next symbol.
            NPNT = 1
            CALL GETSYM (CARD, NPNT, SYM, ITYP)
C                                       Test for END card.
            IF (SYM.EQ.'END ') GO TO 20
            ICARD = ICARD + 1
 10         CONTINUE
C                                       Shouldn't get here.
         WRITE (MSGTXT,1010)
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Advance the proper number of
C                                       records.
 20   DO 30 I = 1,INBLK
         CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
         IF (IERR.EQ.0) GO TO 30
         IF (IERR.EQ.4) GO TO 999
            WRITE (MSGTXT,1020) IERR
            CALL MSGWRT (8)
            GO TO 999
 30      CONTINUE
C                                       Update history, print warning
      IF (EXTTYP.EQ.'BINTABLE') THEN
         WRITE (MSGTXT,1030) ITYPE, EXTVER, INBLK
      ELSE
         WRITE (MSGTXT,1031) INBLK, EXTTYP
         END IF
      CALL MSGWRT (6)
      HILINE = TSKNAM // '/ ' // MSGTXT(:64)
      CALL HIADD (HLUN, HILINE, HBUFF, JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('SKPEXT: MORE THAN 32000 HEADER CARDS FOR THIS',
     *   ' EXTENSION.')
 1020 FORMAT ('SKPEXT: I/O ERROR ',I3,' READING UNKNOWN TYPE TABLE')
 1030 FORMAT ('Skipped ',A,' extension file',I5,' of',I5,' blocks')
 1031 FORMAT ('SKIPPED UNKNOWN EXTENSION FILE OF',I5,' BLOCKS.',
     *   ' EXTTYP = ''',A8,'''')
      END

LOCAL INCLUDE 'SPRMS.INC'
C                                       Local include for SPRMS
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4,30), XCALC(1), XXSTOK(1),
     *   XOPTYP(1)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XANT(50), XBASE(50), XUVRA(2), XSUBA, XBIF, XEIF, XBCHAN,
     *   XECHAN, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND,
     *   XBPVER, XSMOTH(3), DOWGT, SOLINT, XPIXR(2), APARM(10), FACTOR,
     *   XDOTV, XGRCHN, XLABEL, BADD(10)
      REAL      SCRBUF(512), CATOR(256)
      HOLLERITH CATOH(256)
      INTEGER   SEQIN, DISKIN, JBUFSZ, ILOCWT, CATOLD(256), INCSI,
     *   INCFI, INCIFI, OLDCNO, IXANT(50), IXBAS(50), NXANT, NXBAS,
     *   NSAMP, GRCHAN, NPARM, IOPT, NVAL, SCRTCH(256)
      LOGICAL   DESEL
      DOUBLE PRECISION CATOD(128)
      CHARACTER NAMEIN*12, CLAIN*6, OPTYPE*4, LTITLE*80
      EQUIVALENCE (CATOD, CATOH, CATOR, CATOLD)
      DOUBLE PRECISION SR(MAXCIF), SI(MAXCIF), SA(MAXCIF), SW(MAXCIF),
     *   SSR(MAXCIF), SSI(MAXCIF), SSA(MAXCIF)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XXSTOK, XTIME, XBAND, XFREQ, XFQID, XANT, XBASE, XUVRA, XSUBA,
     *   XBIF, XEIF, XBCHAN, XECHAN, XDOCAL, XGUSE, XDOPOL, XPDVER,
     *   XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH, XOPTYP, DOWGT, SOLINT,
     *   XPIXR, APARM, FACTOR, XDOTV, XGRCHN, XLABEL, BADD
      COMMON /SPRMSS/ CATOLD, SEQIN, DISKIN, ILOCWT, INCSI, INCFI,
     *   INCIFI, OLDCNO, IXANT, IXBAS, NXANT, NXBAS,
     *   DESEL, NSAMP, GRCHAN, NPARM, IOPT, NVAL
      COMMON /CHARPM/ LTITLE, NAMEIN, CLAIN, OPTYPE
      COMMON /BUFRS/ SCRBUF, SCRTCH, JBUFSZ
      COMMON /SPDATA/ SR, SI, SA, SW, SSR, SSI, SSA
C                                       End local include for SPRMS
LOCAL END
      PROGRAM SPRMS
C-----------------------------------------------------------------------
C! Plots statistics of selected uv data
C# UV UV-util Calibration Plot
C-----------------------------------------------------------------------
C;  Copyright (C) 2020-2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   SPRMS plots statistics from a sample of uv data
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C   full set of calibration adverbs
C      OPTYPE         OPTYPE        Type of data to process
C      SOLINT         SOLINT        Averaging time (min)
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'SPRMS.INC'
      REAL      PV(MAXCIF), PS(MAXCIF)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      DATA PRGM /'SPRMS '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL SPRMSI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       read data
      CALL SPRMSR ( IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Average into plot buffers
      CALL SPRMSA (PV, PS, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Plot mean, std spectra
      CALL SPRMSP (1, PV, IRET)
      IF (IRET.EQ.0) CALL SPRMSP (2, PS, IRET)
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE SPRMSI (PRGN, JERR)
C-----------------------------------------------------------------------
C   SPRMSI gets input parameters for SPRMS
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, PTYPE*2
      INTEGER   IROUND, IERR, INCX, I, NFREQ, LUN
      LOGICAL   MATCH
      REAL      CATR(256), RPARM(20)
      HOLLERITH CATH(256)
      DOUBLE PRECISION CATD(128)
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'SPRMS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATR, CATH, CATD)
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 288
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRTCH, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      CALL H2CHR (4, 1, XXSTOK, STOKES)
      DO 5 I = 1,10
         IBAD(I) = IROUND (BADD(I))
 5       CONTINUE
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      CALL H2CHR (4, 1, XOPTYP, OPTYPE)
      IF (ABS(FACTOR).LE.0.01) THEN
         IF (FACTOR.GE.0.0) FACTOR = 1.0
         IF (FACTOR.LT.0.0) FACTOR = -1.0
         END IF
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      IF (OPTYPE.EQ.'AUTO') THEN
         DOACOR = .TRUE.
         DOXCOR = .FALSE.
         OPTYPE = 'AMP'
         END IF
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      UVRNG(1) = XUVRA(1)
      UVRNG(2) = XUVRA(2)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
      GRCHAN = XGRCHN + 0.1
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Test OPTYPE, STOKES
      IF ((OPTYPE.NE.'AMP') .AND. (OPTYPE.NE.'PHAS') .AND.
     *   (OPTYPE.NE.'REAL') .AND. (OPTYPE.NE.'IMAG') .AND.
     *   (OPTYPE.NE.'SAMP')) THEN
         OPTYPE = 'AMP'
         MSGTXT = 'SETTING OPTYPE TO AMP'
         CALL MSGWRT (6)
         END IF
      IOPT = 1
      IF (OPTYPE.EQ.'REAL') IOPT = 2
      IF (OPTYPE.EQ.'IMAG') IOPT = 3
      IF (OPTYPE.EQ.'PHAS') IOPT = 4
      IF (OPTYPE.EQ.'SAMP') IOPT = 5
      IF (STOKES.EQ.' ') STOKES = 'I'
      IF ((STOKES.EQ.'I') .OR. (STOKES.EQ.'Q') .OR. (STOKES.EQ.'U') .OR.
     *   (STOKES.EQ.'V')) GO TO 20
      IF (CATD(KDCRV+JLOCS).LE.-5.0) THEN
         IF ((STOKES.EQ.'VV') .OR. (STOKES.EQ.'HH') .OR.
     *      (STOKES.EQ.'VH') .OR. (STOKES.EQ.'HV')) GO TO 20
      ELSE IF (CATD(KDCRV+JLOCS).LE.-1.0) THEN
         IF ((STOKES.EQ.'RR') .OR. (STOKES.EQ.'LL') .OR.
     *      (STOKES.EQ.'RL') .OR. (STOKES.EQ.'LR')) GO TO 20
         END IF
      MSGTXT = 'ONLY ONE POLARIZATION ALLOWED: NOT ' // STOKES
      JERR = 10
      GO TO 990

C                                       Channel selection?
 20   IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      NFREQ = CATBLK(KINAX+JLOCF)
      BCHAN = IROUND (XBCHAN)
      ECHAN = IROUND (XECHAN)
      IF ((BCHAN.LE.0) .OR. (BCHAN.GT.NFREQ)) BCHAN = 1
      IF ((ECHAN.LE.0) .OR. (ECHAN.GT.NFREQ)) ECHAN = NFREQ
      IF (BCHAN.GT.ECHAN) THEN
         MSGTXT = 'INVALID BCHAN AND ECHAN'
         CALL MSGWRT (6)
         JERR = 1
         GO TO 990
         END IF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       Find baselines to copy
      CALL SETANT (50, XANT, XBASE, NXANT, NXBAS, IXANT, IXBAS, DESEL)
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, SCRBUF, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1035) JERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, SCRBUF, IERR)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                        Fill defaults for plots
      CALL RCOPY (8, TIMRNG, XTIME)
      CALL RCOPY (2, UVRNG, XUVRA)
      XBCHAN = BCHAN
      XECHAN = ECHAN
      XBIF = BIF
      XEIF = EIF
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', SCRTCH, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPRMSI: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('SPRMSI: UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE SPRMSR (IRET)
C-----------------------------------------------------------------------
C   SPRMSR reads the uv data and prepares a list of values with time
C   averaging (one or multiple times)
C   Input in common:
C      INCSI   I      Input Stokes' increment in vis.
C      INCFI   I      Input frequency increment in vis.
C      INCIFI  I      Input IF increment in vis.
C   Output:
C      IRET    I      Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   IA1, IA2, ICODE
      LOGICAL   REQBAS
      INCLUDE 'SPRMS.INC'
      REAL      BASEN, VIS(UVBFSS), RPARM(20), LTIME, TIME, RR(MAXCIF),
     *   RI(MAXCIF), RW(MAXCIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
C-----------------------------------------------------------------------
C                                       Open and init for read
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL UVPGET (IRET)
      IF (SOLINT.LE.0.0) SOLINT = 0.007
      SOLINT = SOLINT / (60.0 * 24.0)
      LTIME = -100.
      IF (DOWGT.GT.0.0) ICODE = 1
      NSAMP = 0
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over buffer
      ELSE IF (IRET.EQ.0) THEN
         IF (ILOCB.GE.0) THEN
            BASEN = RPARM(1+ILOCB)
            IA1 = BASEN / 256. + 0.1
            IA2 = BASEN - IA1*256. + 0.1
         ELSE
            IA1 = RPARM(1+ILOCA1) + 0.1
            IA2 = RPARM(1+ILOCA2) + 0.1
            END IF
         IF (.NOT.REQBAS (IA1, IA2, DESEL, IXANT, NXANT, IXBAS, NXBAS))
     *      GO TO 100
         TIME = RPARM(1+ILOCT)
         IF (DOWGT.GT.0.0) THEN
            CALL SPRMSG (ICODE, VIS, RR, RI, RW)
            NSAMP = NSAMP + 1
         ELSE
            IF (TIME.GT.LTIME+SOLINT) THEN
               ICODE = 2
               LTIME = TIME
            ELSE
               ICODE = 3
               END IF
C                                       call user routine
            CALL SPRMSG (ICODE, VIS, RR, RI, RW)
            NSAMP = NSAMP + 1
            END IF
C                                       Read next buffer.
         GO TO 100
         END IF
C                                       Final value
      ICODE = 2
      IF (DOWGT.LE.0.0) CALL SPRMSG (ICODE, VIS, RR, RI, RW)
C                                       Close files
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
C                                       close NX table
      IRET = 0
      IF (NSAMP.LE.0) THEN
         IRET = 10
         MSGTXT = 'NO DATA SAMPLES FOUND'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SPRMSR: ERROR',I3,' OPEN/INIT INPUT VIS FILE')
 1100 FORMAT ('SPRMSR: ERROR',I3,' READING VIS FILE')
      END
      SUBROUTINE SPRMSG (ICODE, VIS, RR, RI, RW)
C-----------------------------------------------------------------------
C   Finds the requested value from the current data
C   Inputs:
C      ICODE    I       1: VIS straight to global summers
c                       2: Average RR/RI -> new sum in RR/RI
c                       3: sum into RR/RI
C      VIS     R(3,*)   Visibilities in order real, imaginary, weight
C   Inputs from COMMON:
C      CATBLK   I(256)  Catalog header record. See Going Aips for
C                       details.
C      INCSI    I       Input Stokes' increment in vis.
C      INCFI    I       Input frequency increment in vis.
C      INCIFI   I       Input IF increment in vis.
C      DOWGT    R       > 0 do not average the output
C   In/out:
C      RR       R(*)    Local sum value real part
C      RI       R(*)    Local sum value imag part
C      RW       R(*)    Local sum weights
C-----------------------------------------------------------------------
      INTEGER   ICODE
      REAL      VIS(3,*), RR(*), RI(*), RW(*)
C
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXI, I
      REAL      VR, VI, VW, VA
      INCLUDE 'SPRMS.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
C                                       pointers to traverse the data
      NS = 1
      NIF = 1
      NF = 1
      IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
      IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
      IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
      NVAL = NS * NIF * NF
C                                       straight to global
      IF (ICODE.EQ.1) THEN
         I = 0
         DO 40 JIF = 1,NIF
            DO 30 JF = 1,NF
               DO 20 JS = 1,NS
                  I = I + 1
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  VR = VIS(1,INDEXI)
                  VI = VIS(2,INDEXI)
                  VW = VIS(3,INDEXI)
                  VA = SQRT (VR*VR + VI*VI)
                  IF (VW.GT.0.0) THEN
                     SR(I) = SR(I) + VW * VR
                     SI(I) = SI(I) + VW * VI
                     SA(I) = SA(I) + VW * VA
                     SSR(I) = SSR(I) + VW * VR * VR
                     SSI(I) = SSI(I) + VW * VI * VI
                     SSA(I) = SSA(I) + VW * VA * VA
                     SW(I) = SW(I) + VW
                     END IF
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
C                                       avg to global, start new
      ELSE IF (ICODE.EQ.2) THEN
         DO 100 I = 1,NVAL
            VW = RW(I)
            IF (VW.GT.0.0) THEN
               VR = RR(I) / VW
               VI = RI(I) / VW
               VA = SQRT (VR*VR + VI*VI)
               VW = 1.0
               SR(I) = SR(I) + VR
               SI(I) = SI(I) + VI
               SA(I) = SA(I) + VA
               SSR(I) = SSR(I) + VR * VR
               SSI(I) = SSI(I) + VI * VI
               SSA(I) = SSA(I) + VA * VA
               SW(I) = SW(I) + 1.0
               END IF
 100        CONTINUE
         I = 0
         DO 140 JIF = 1,NIF
            DO 130 JF = 1,NF
               DO 120 JS = 1,NS
                  I = I + 1
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  VR = VIS(1,INDEXI)
                  VI = VIS(2,INDEXI)
                  VW = VIS(3,INDEXI)
                  IF (VW.GT.0.0) THEN
                     RR(I) = VW * VR
                     RI(I) = VW * VI
                     RW(I) = VW
                  ELSE
                     RR(I) = 0.0
                     RI(I) = 0.0
                     RW(I) = 0.0
                     END IF
 120              CONTINUE
 130           CONTINUE
 140        CONTINUE
C                                       sum into local only
      ELSE IF (ICODE.EQ.3) THEN
         I = 0
         DO 240 JIF = 1,NIF
            DO 230 JF = 1,NF
               DO 220 JS = 1,NS
                  I = I + 1
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  VR = VIS(1,INDEXI)
                  VI = VIS(2,INDEXI)
                  VW = VIS(3,INDEXI)
                  IF (VW.GT.0.0) THEN
                     RR(I) = RR(I) + VW * VR
                     RI(I) = RI(I) + VW * VI
                     RW(I) = RW(I) + VW
                     END IF
 220              CONTINUE
 230           CONTINUE
 240        CONTINUE
         END IF
C
 999  RETURN
      END
      SUBROUTINE SPRMSA (PV, PS, IRET)
C-----------------------------------------------------------------------
C   SPRMSA averages the desired type
C   Outputs:
C      PV   R(*)   Spectrum of desired type
C      Ps   R(*)   Spectrum of std of desired type
C-----------------------------------------------------------------------
      INTEGER   IRET
      REAL      PV(*), PS(*)
C
      INCLUDE 'SPRMS.INC'
      INTEGER   I, J
      DOUBLE PRECISION VR, VI, UR, UI, VA
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      J = 0
C                                       vector amplitude
      IF (IOPT.EQ.1) THEN
         DO 110 I = 1,NVAL
            IF (SW(I).LE.0.0) THEN
               PV(I) = FBLANK
               PS(I) = FBLANK
            ELSE
               J = J + 1
               VR = SR(I) / SW(I)
               VI = SI(I) / SW(I)
               PV(I) = SQRT (VR*VR + VI*VI)
               UR = SSR(I) / SW(I) - VR * VR
               UI = SSI(I) / SW(I) - VI * VI
               UR = MAX (0.0, UR)
               UI = MAX (0.0, UI)
               IF (PV(I).LE.0.0) THEN
                  PS(I) = FBLANK
               ELSE
                  PS(I) = SQRT (VR*VR*UR + VI*VI*UI) / PV(I)
                  END IF
               END IF
 110        CONTINUE
C                                       real part
      ELSE IF (IOPT.EQ.2) THEN
         DO 120 I = 1,NVAL
            IF (SW(I).LE.0.0) THEN
               PV(I) = FBLANK
               PS(I) = FBLANK
            ELSE
               J = J + 1
               VR = SR(I) / SW(I)
               PV(I) = vr
               UR = SSR(I) / SW(I) - VR * VR
               UR = SQRT (MAX (0.0, UR))
               PS(I) = UR
               END IF
 120        CONTINUE
C                                       imaginary part
      ELSE IF (IOPT.EQ.3) THEN
         DO 130 I = 1,NVAL
            IF (SW(I).LE.0.0) THEN
               PV(I) = FBLANK
               PS(I) = FBLANK
            ELSE
               J = J + 1
               VI = SI(I) / SW(I)
               PV(I) = VI
               UI = SSI(I) / SW(I) - VI * VI
               UI = SQRT (MAX (0.0, UI))
               PS(I) = UI
               END IF
 130        CONTINUE
C                                       vector phase
      ELSE IF (IOPT.EQ.4) THEN
         DO 140 I = 1,NVAL
            PV(I) = FBLANK
            PS(I) = FBLANK
            IF (SW(I).GT.0.0) THEN
               VR = SR(I) / SW(I)
               VI = SI(I) / SW(I)
               VA = VR*VR + VI*VI
               IF (VA.GT.0.0) THEN
                  J = J + 1
                  PV(I) = RAD2DG * ATAN2 (VI, VR)
                  UR = SSR(I) / SW(I) - VR * VR
                  UI = SSI(I) / SW(I) - VI * VI
                  UR = MAX (0.0, UR)
                  UI = MAX (0.0, UI)
                  PS(I) = RAD2DG * SQRT (VR*VR*UI + VI*VI*UR) / VA
                  END IF
               END IF
 140        CONTINUE
C                                       scalar amplitude
      ELSE IF (IOPT.EQ.5) THEN
         DO 150 I = 1,NVAL
            IF (SW(I).LE.0.0) THEN
               PV(I) = FBLANK
               PS(I) = FBLANK
            ELSE
               J = J + 1
               VR = SA(I) / SW(I)
               PV(I) = VR
               UR = SSA(I) / SW(I) - VR * VR
               UR = SQRT (MAX (0.0, UR))
               PS(I) = UR
               END IF
 150        CONTINUE
         END IF
      IF (J.LE.0) THEN
         MSGTXT = 'SPRMSA: NO POINTS FOUND'
         CALL MSGWRT (8)
         IRET = 10
      ELSE
         IRET = 0
         END IF
C
 999  RETURN
      END
      SUBROUTINE SPRMSP (ITYPE, SP, IRET)
C-----------------------------------------------------------------------
C    SPRMSP plots the the mean and std spectra
C    Inputs:
C       ITYPE    I       1 mean, 2 std
C       STOKES   C*(*)   Stokes string
C       SP       R(*)    spectrum to plot
C    Outputs:
C       IRET     I       > 0 => plot failure
C-----------------------------------------------------------------------
      INTEGER   ITYPE, IRET
      REAL      SP(*)
C
      INCLUDE 'SPRMS.INC'
      INTEGER   I, PLUN, IOBLK(256), IVER, TVCHN, TVCORN(4), IDEPTH(5),
     *   J, LTYPE, LABEL, PIND, IROUND, NC, NI, CATSAV(256), JC, JI
      LOGICAL   DOTV, GOOD
      CHARACTER PFILE*48, CHT12*12, CHT6*6, CHTY*2, PTYPE(5)*20
      REAL      YMAX, YMIN, BLC(2), TRC(2), CH(4), X, FAC, XYRATO, DX,
     *   DY, XMIN, XMAX, LOCRAN(2), XYRAT, Y
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DTVC.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DGPH.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA TVCHN, TVCORN, IDEPTH /1, 4*0, 5*1/
      DATA PTYPE /'Amplitude (Jy)', 'Real part (Jy)', 'Imaginary (Jy)',
     *   'Phase (degrees)', 'Scalar amp (Jy)'/
C-----------------------------------------------------------------------
      DOTV = XDOTV.GT.0.0
C                                       Y scale
      YMAX = -1.E10
      YMIN = -YMAX
      NC = (ECHAN - BCHAN + 1)
      NI = (EIF - BIF + 1)
      JC = NC * NI
      DO 10 I = 1,JC
         IF (SP(I).NE.FBLANK) THEN
            YMIN = MIN (YMIN, SP(I))
            YMAX = MAX (YMAX, SP(I))
            END IF
 10      CONTINUE
      IF (ITYPE.EQ.1) THEN
         IF (XPIXR(2).GT.XPIXR(1)) THEN
            YMAX = XPIXR(2)
            YMIN = XPIXR(1)
            END IF
      ELSE IF (ITYPE.EQ.2) THEN
         IF (APARM(2).GT.APARM(1)) THEN
            YMAX = APARM(2)
            YMIN = APARM(1)
            END IF
         END IF
      IF (ITYPE.EQ.1) THEN
         XPIXR(2) = YMAX + 0.04 * (YMAX - YMIN)
         XPIXR(1) = YMIN - 0.04 * (YMAX - YMIN)
         YMAX = XPIXR(2)
         YMIN = XPIXR(1)
      ELSE
         APARM(2) = YMAX + 0.04 * (YMAX - YMIN)
         APARM(1) = YMIN - 0.04 * (YMAX - YMIN)
         YMAX = APARM(2)
         YMIN = APARM(1)
         END IF
      XMIN = 0.0
      XMAX = (NC + 1) * NI
C                                       Add plot file to the image
C                                       catalog header.
      IF (.NOT.DOTV) THEN
         CHT12 = ' '
         CHT6 = ' '
         CHTY = ' '
         IVER = 0
         IF (ITYPE.EQ.1) THEN
            CALL CATDIR ('CSTA', DISKIN, OLDCNO, CHT12, CHT6, 0, CHTY,
     *         0, 'CLRD', IOBLK, IRET)
            IF (IRET.EQ.0) CALL CATDIR ('CSTA', DISKIN, OLDCNO, CHT12,
     *         CHT6, 0, CHTY, 0, 'WRIT', IOBLK, IRET)
            FRW(NCFILE) = 1
            END IF
         CALL MADDEX ('PL', DISKIN, OLDCNO, CATOLD, IOBLK, .TRUE.,
     *      'WRIT', IVER, IRET)
         IF (IRET.NE.0) THEN
            MSGTXT = 'PLHGM: ERROR UPDATING CATALOGUE HEADER.'
            CALL MSGWRT (8)
            GO TO 999
            END IF
         END IF
C                                       Open the PLot file.
      CALL ZPHFIL ('PL', DISKIN, OLDCNO, IVER, PFILE, IRET)
      APARM(10) = ITYPE
      SOLINT = SOLINT * 24.0 * 60.0
      CALL GINIT (DISKIN, OLDCNO, PFILE, 0, 68, NPARM, XNAMEI, DOTV,
     *   TVCHN, GRCHAN, TVCORN, CATOLD, IOBLK, PLUN, PIND, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'PLHGM: ERROR OPENING PLOT FILE FOR THE HISTOGRAM.'
         CALL MSGWRT (8)
         IF (.NOT.DOTV) CALL DELEXT ('PL', DISKIN, OLDCNO, 'WRIT',
     *      CATOLD, IOBLK, IVER, I)
         GO TO 999
         END IF
      SOLINT = SOLINT / (24.0 * 60.0)
C                                       Set character offsets.
      LABEL = IROUND (XLABEL)
      LTYPE = MOD (ABS (LABEL), 100)
      LOCRAN(2) = YMAX
      LOCRAN(1) = YMIN
      CALL GTICNT (LABEL, LOCRAN, I)
      CALL RFILL (4, 0.5, CH)
      IF (LTYPE.EQ.2) CH(1) = 3.5
      IF (LTYPE.GT.2) CH(1) = I + 4.0
      IF (LTYPE.GT.1) CH(2) = 2.0
      IF (LTYPE.GT.2) CH(2) = CH(2) + 1.333
      IF ((LTYPE.GT.1) .AND. (LTYPE.LT.7)) THEN
         CH(2) = CH(2) + 1.333
         CH(4) = 2.0
         IF (LABEL.GT.0) CH(4) = CH(4) + 1.333
         END IF
C                                       Set BLC, TRC, XYRATO.
      BLC(1) = XMIN
      TRC(1) = XMAX
      BLC(2) = YMIN
      TRC(2) = YMAX
      IF (DOTV) THEN
         DX = WINDTV(3) - WINDTV(1) + 1 - CSIZTV(1) * (CH(1) + CH(3))
         DY = WINDTV(4) - WINDTV(2) + 1 - CSIZTV(2) * (CH(2) + CH(4))
         XYRATO = 1.0
         IF (DY.GT.0.0) XYRATO = DX / DY
      ELSE
         XYRATO = 1.0
         END IF
      XYRAT = (TRC(1) - BLC(1)) / (TRC(2) - BLC(2))
C                                       Kludge to keep XYRATO in bounds
C                                       to prevent overflow in GINITL.
      FAC = 1.0
      IF (XYRAT.GT.3.0) THEN
         DO 15 I = 1,10000
            IF (XYRAT.LT.2.0) GO TO 20
            FAC = FAC / 2.
            XYRAT = XYRAT / 2.
 15      CONTINUE
      ELSE IF (XYRAT.LT.0.333) THEN
         DO 16 I = 1,10000
            IF (XYRAT.GT.0.50) GO TO 20
            FAC = FAC * 2.
            XYRAT = XYRAT * 2.
 16         CONTINUE
         END IF
C
 20   TRC(2) = TRC(2) / FAC
      BLC(2) = BLC(2) / FAC
      XYRAT = XYRATO / XYRAT
C                                       Initialize for line drawing
      CALL GINITL (BLC, TRC, XYRAT, CH, IDEPTH, IOBLK, IRET)
      IF (IRET.NE.0) THEN
         MSGTXT = 'DRWHGM: ERROR INITIALIZING FOR LINE DRAWING.'
         GO TO 950
         END IF
      CALL GLTYPE (1, IOBLK, IRET)
      IF (IRET.NE.0) GO TO 920
C                                       Draw borders.
      CALL GPOS (BLC(1), BLC(2), IOBLK, IRET)
      IF (IRET.NE.0) GO TO 910
      CALL GVEC (TRC(1), BLC(2), IOBLK, IRET)
      IF (IRET.NE.0) GO TO 920
      CALL GVEC (TRC(1), TRC(2), IOBLK, IRET)
      IF (IRET.NE.0) GO TO 920
      CALL GVEC (BLC(1), TRC(2), IOBLK, IRET)
      IF (IRET.NE.0) GO TO 920
      CALL GVEC (BLC(1), BLC(2), IOBLK, IRET)
      IF (IRET.NE.0) GO TO 920
C                                       dividers
      DO 25 I = 1,NI-1
         X = I * (NC + 1.0)
         CALL GPOS (X, TRC(2), IOBLK, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL GVEC (X, BLC(2), IOBLK, IRET)
         IF (IRET.NE.0) GO TO 999
 25      CONTINUE
C                                       Labeling.
      CALL COPY (256, CATBLK, CATSAV)
      CALL COPY (256, CATOLD, CATBLK)
      CALL RMSLAB (ITYPE, PTYPE(IOPT), STOKES, BLC, TRC, FAC, NC, NI,
     *   BCHAN, BIF, IVER, LABEL, IOBLK, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Draw the data
      CALL GLTYPE (2, IOBLK, IRET)
      IF (IRET.NE.0) GO TO 920
      I = 0
      J = 0
      DX = 0.5 * ABS(FACTOR)
      DY = 0.5 * (TRC(2) - BLC(2)) / ((NC + 1.0)* NI) * ABS(FACTOR)
      CALL GPOS (X, 1.0, IOBLK, IRET)
      IF (IRET.NE.0) GO TO 910
      DO 50 JI = 1,NI
         DO 40 JC = 1,NC
            I = I + 1
            X = I
            J = J + 1
            IF (SP(J).NE.FBLANK) THEN
               Y = (SP(J) - YMIN) / (YMAX - YMIN) * (TRC(2)-BLC(2)) +
     *            BLC(2)
               IF ((Y.GT.BLC(2)) .AND. (Y.LT.TRC(2))) THEN
                  CALL GPOS (X-DX, Y+DY, IOBLK, IRET)
                  IF (IRET.NE.0) GO TO 910
                  CALL GVEC (X+DX, Y-DY, IOBLK, IRET)
                  IF (IRET.NE.0) GO TO 920
                  CALL GPOS (X+DX, Y+DY, IOBLK, IRET)
                  IF (IRET.NE.0) GO TO 910
                  CALL GVEC (X-DX, Y-DY, IOBLK, IRET)
                  IF (IRET.NE.0) GO TO 920
                  END IF
               END IF
  40        CONTINUE
         I = I + 1
  50     CONTINUE
      IF (FACTOR.LT.0.0) THEN
         CALL GLTYPE (4, IOBLK, IRET)
         IF (IRET.NE.0) GO TO 920
         I = 0
         J = 0
         DO 70 JI = 1,NI
            GOOD = .FALSE.
            DO 60 JC = 1,NC
               I = I + 1
               X = I
               J = J + 1
               IF (SP(J).NE.FBLANK) THEN
                  Y = (SP(J) - YMIN) / (YMAX - YMIN) * (TRC(2)-BLC(2)) +
     *               BLC(2)
                  IF ((Y.GT.BLC(2)) .AND. (Y.LT.TRC(2))) THEN
                     IF (GOOD) THEN
                        CALL GVEC (X, Y, IOBLK, IRET)
                        IF (IRET.NE.0) GO TO 920
                     ELSE
                        CALL GPOS (X, Y, IOBLK, IRET)
                        IF (IRET.NE.0) GO TO 910
                        END IF
                     GOOD = .TRUE.
                  ELSE
                     GOOD = .FALSE.
                     END IF
               ELSE
                  GOOD = .FALSE.
                  END IF
  60           CONTINUE
            I = I + 1
  70        CONTINUE
         END IF
      GPHPAG = ITYPE.EQ.1
      CALL GFINIS (IOBLK, IRET)
      IF (IRET.NE.0) GO TO 950
      CALL COPY (256, CATBLK, CATOLD)
      CALL COPY (256, CATSAV, CATBLK)
      GO TO 999
C                                       Error return from GPOS.
 910  MSGTXT = 'SPRMSP: PLOT ERROR OCCURRED WHILE MOVING TO A POINT.'
      GO TO 940
C                                       Error return from GVEC.
 920  MSGTXT = 'SPRMSP: PLOT ERROR OCCURRED WHILE DRAWING A LINE.'
 940  CALL MSGWRT (8)
 950  WRITE (MSGTXT,1950) IVER
      CALL MSGWRT (8)
C                                       Destroy the PLot file on error.
      IF (.NOT.DOTV) THEN
         CALL ZCLOSE (PLUN, PIND, I)
         CALL ZDESTR (DISKIN, PFILE, I)
         CALL DELEXT ('PL', DISKIN, OLDCNO, 'WRIT', CATOLD, IOBLK,
     *      IVER, I)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1950 FORMAT ('DESTROY PLOT VERSION',I4,' DUE TO ERRORS')
      END
      SUBROUTINE RMSLAB (ITY, UNITS, CSTOK, BLC, TRC, FAC, NC, NI,
     *   LBCHAN, LBIF, IVER, LABEL, BUFF1, IRET)
C-----------------------------------------------------------------------
C   Write labeling for SPRMS plots
C   Inputs:
C      ITY     I        Plot type: 1 for mean, 2 std
C      UNITS   C*(*)    vertical axis label
C      CSTOK   C*(*)    vertical axis label
C      BLC     R(2)     bottom left corner of plot.
C      TRC     R(2)     top right hand corner of plot.
C      FAC     R        FAC*XYRATO = real XYRATIO.
C      IVER    I        plot file version number
C      LABEL   I        labeling type
C   In/out:
C      BUFF1   I(256)   I/O buffer for plot file.
C   Output:
C      IRET    I        error code returned from GVEC.
C-----------------------------------------------------------------------
      REAL      BLC(2), TRC(2), FAC
      INTEGER   ITY, NC, NI, LBCHAN, LBIF, IVER, LABEL, BUFF1(256), IRET
      CHARACTER UNITS*(*), CSTOK*(*)
C
      CHARACTER PREFIX(2)*5, TIME*8, DATE*12, CTEMP*8, NAMSTR*18,
     *   MSGBUF*80
      LOGICAL   PFLAG
      REAL      XINTER(24), DCX, DCY, DIST, ODIST, TICSCL, XVAL, YTICEL,
     *   YTICER, YPOS, TICLEN, XINT, X, FREQ, DCXM, XDIST, DTRC, DBLC,
     *   DEG, DU, DL
      INTEGER   INOINT, INCHAR, I, IXO, NXFR, NAX, INC, IANGL,
     *   IT(3), ID(3), ICPNT, ITMP, LTYPE, LECHAN
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA TICSCL /70.0/
      DATA XINTER /.001, .002, .005, .01, .02, .05, .1, .2, .5,
     *   1., 2., 5., 10., 20., 50., 100., 200., 500.,
     *   1000., 2000., 5000., 10000., 20000., 50000./
C-----------------------------------------------------------------------
      LTYPE = MOD (ABS(LABEL), 100)
      IF (LTYPE.LE.1) GO TO 999
      LECHAN = LBCHAN + NC - 1
C                                       Tic positions.
      TICLEN = (TRC(1) - BLC(1)) / TICSCL
      YTICEL = BLC(1) + TICLEN
      YTICER = TRC(1) - TICLEN
C                                       Find vertical interval value.
      DIST = FAC * (TRC(2) - BLC(2))
      ODIST = DIST
      CALL METSCL (LABEL, DIST, PREFIX(2), PFLAG)
      IF (PFLAG) GO TO 110
      XDIST = DIST / ODIST
      DTRC = FAC * XDIST * TRC(2)
      DBLC = FAC * XDIST * BLC(2)
      XINT = 8.0
      DO 20 I = 1,24
         DEG = XINTER(I)
         DU = AINT (DTRC / DEG) * DEG
         IF (DU.GT.DTRC) DU = DU - DEG
         DL = AINT (DBLC / DEG) * DEG
         IF (DL.LT.DBLC) DL = DL + DEG
         INOINT = (DU - DL) / DEG + 1.001
         IF (INOINT.LE.XINT) GO TO 30
 20      CONTINUE
      GO TO 110
C                                       Interval and no of inter found.
 30   XINT = DEG
      INOINT = INOINT + 2
      ODIST = XDIST * FAC * BLC(2)
      XVAL = AINT (ODIST/XINT) * XINT
      IF (XVAL.GE.ODIST) XVAL = XVAL - XINT
      IXO = I
      DCXM = -0.5
C                                       Loop for all tics.
      DO 100 I = 1,INOINT
         XVAL = XVAL + XINT
         YPOS = XVAL / FAC / XDIST
         IF (YPOS.GT.TRC(2)) GO TO 110
C                                       right hand tic.
         CALL GPOS (TRC(1), YPOS, BUFF1, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL GVEC (YTICER, YPOS, BUFF1, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Left hand tic.
         CALL GPOS (YTICEL, YPOS, BUFF1, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL GVEC (BLC(1), YPOS, BUFF1, IRET)
         IF (IRET.NE.0) GO TO 999
C                                       Write value.
         IF (LTYPE.GT.2) THEN
            WRITE (MSGBUF,1030) XVAL
            CALL CHTRIM (MSGBUF, 14, MSGBUF, INCHAR)
            IF (IXO.GT.3) INCHAR = INCHAR - 1
            IF (IXO.GT.6) INCHAR = INCHAR - 1
            IF (IXO.GT.9) INCHAR = INCHAR - 2
            DCX = - INCHAR - 1.0
            DCY = -0.5
            DCXM = MIN (DCXM, DCX)
            CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, BUFF1, IRET)
            IF (IRET.NE.0) GO TO 999
            END IF
 100     CONTINUE
C                                       RMS
 110  DCX = DCXM - 2.0
      YPOS = (TRC(2) + BLC(2)) / 2.0
      CALL GPOS (BLC(1), YPOS, BUFF1, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (ITY.EQ.1) THEN
         MSGBUF = PREFIX(2) // ' Mean'
      ELSE IF (ITY.EQ.2) THEN
         MSGBUF = PREFIX(2) // ' std'
         END IF
      CALL CHTRIM (MSGBUF, 80, MSGBUF, INCHAR)
      MSGBUF(INCHAR+2:) = UNITS
      CALL CHTRIM (MSGBUF, 80, MSGBUF, INCHAR)
      DCY = INCHAR / 2.0 - 1.0
      CALL GCHAR (INCHAR, 1, DCX, DCY, MSGBUF, BUFF1, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Nchan, BIF, EIF
      IF (LTYPE.LT.7) THEN
         MSGBUF = 'IF'
         DCY = -2.833 - 1.333
         IF (LTYPE.EQ.2) DCY = -2.833
         XDIST = (TRC(1) - BLC(1)) / NI
         DO 120 I = 1,NI
            ITMP = LBIF + I - 1
            IF ((I.EQ.1) .OR. (NI.LE.4)) THEN
               IF (ITMP.LT.10) THEN
                  WRITE (MSGBUF(4:),1110) ITMP
               ELSE
                  WRITE (MSGBUF(4:),1111) ITMP
                  END IF
            ELSE
               IF (ITMP.LT.10) THEN
                  WRITE (MSGBUF(1:),1110) ITMP
               ELSE
                  WRITE (MSGBUF(1:),1111) ITMP
                  END IF
               END IF
            CALL REFRMT (MSGBUF, '_', INCHAR)
            X = (I - 0.5) * XDIST
            CALL GPOS (X, BLC(2), BUFF1, IRET)
            IF (IRET.NE.0) GO TO 999
            DCX = -INCHAR/2.0
            CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, BUFF1, IRET)
            IF (IRET.NE.0) GO TO 999
 120        CONTINUE
         END IF
C                                       Determine label range
      CALL PINLAB (BLC, TRC, LBCHAN, LECHAN, NI, LABEL, BUFF1, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Label with prefix
      DCY = -1.5
      IF (LTYPE.GT.2) DCY = -2.833
      X = (TRC(1) + BLC(1)) / 2.0
      CALL GPOS (X, BLC(2), BUFF1, IRET)
      IF (IRET.NE.0) GO TO 999
      MSGBUF = 'Spectral channels'
      CALL CHTRIM (MSGBUF, 17, MSGBUF, INCHAR)
      DCX = 0.5 - INCHAR / 2.0
      CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, BUFF1, IRET)
      IF (IRET.NE.0) GO TO 999
      IF (LTYPE.GE.7) GO TO 999
C                                       which axis is which?
      NXFR = 0
      NAX = CATBLK(KIDIM)
      INC = 2
      DO 200 I = 1,NAX
         ICPNT = KHCTP+(I-1)*INC
         CALL H2CHR (8, 1, CATH(ICPNT), CTEMP)
         IF (CTEMP(1:4).EQ.'FREQ') NXFR  = I
 200     CONTINUE
C                                       Source name, stokes, freq.
      CALL GPOS (BLC(1), TRC(2), BUFF1, IRET)
      IF (IRET.NE.0) GO TO 999
      DCX = 0.0
      DCY = 0.5
      IANGL = 0
      CALL H2CHR (8, 1, CATH(KHOBJ), CTEMP)
      FREQ = 0.0
      IF (NXFR.GT.2) FREQ = CATD(KDCRV+NXFR-1)
      FREQ = FREQ / 1.E6
      IF (NXFR.GT.2) WRITE (MSGBUF,1200) CTEMP, CSTOK, FREQ
      IF (NXFR.LE.2) WRITE (MSGBUF,1200) CTEMP, CSTOK
      CALL REFRMT (MSGBUF, '_', INCHAR)
C                                       image name
      INCHAR = INCHAR + 1
      IF (INCHAR.GT.1) THEN
         MSGBUF(INCHAR:INCHAR+2) = '  _'
         INCHAR = INCHAR + 3
         END IF
      CALL H2CHR (12, KHIMNO, CATH(KHIMN), NAMSTR(1:12))
      CALL H2CHR (6, KHIMCO, CATH(KHIMC), NAMSTR(13:18))
      CALL NAMEST (NAMSTR, CATBLK(KIIMS), MSGBUF(INCHAR:), ITMP)
      CALL REFRMT (MSGBUF, '_', INCHAR)
      CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, BUFF1, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       time/date, version
      IF (LABEL.GT.0) THEN
         CALL GPOS (BLC(1), TRC(2), BUFF1, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL ZDATE (ID)
         CALL ZTIME (IT)
         CALL TIMDAT (IT, ID, TIME, DATE)
         WRITE (MSGBUF,1210) IVER, DATE, TIME
         CALL REFRMT (MSGBUF, '_', INCHAR)
         DCY = DCY + 1.333
         CALL GCHAR (INCHAR, 0, DCX, DCY, MSGBUF, BUFF1, IRET)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (F14.3)
 1110 FORMAT (I1)
 1111 FORMAT (I2)
 1200 FORMAT (A,'  _',A4,'_ ',F10.3,' MHz')
 1210 FORMAT ('Plot file version',I4,'__created ',A,A)
      END
      SUBROUTINE PINLAB (BLC, TRC, BC, EC, NG, ILTYPE, BUFFER, IERR)
C-----------------------------------------------------------------------
C   To do X axis where we have multiple sub panels with integer counts
C   Inputs:
C      BLC      R(2)    X, Y pixels to form bottom left hand corner
C      TRC      R(2)    X, Y pixels to form the top right hand corner
C      BC       I       Begin count
C      EC       I       End count
C      NG       I       Number of such groups
C      ILTYPE   I       label type: 1 none, 2 no ticks, 3 RA/DEC
C                          4 center relative
C   In/out:
C      BUFFER   I(256)  the updated graphics output buffer.
C      IERR     I       error indicator: 0 = No error.
C-----------------------------------------------------------------------
      REAL      BLC(2), TRC(2)
      INTEGER   BC, EC, NG, ILTYPE, BUFFER(256), IERR
C
      INTEGER   NINTER
      PARAMETER (NINTER=15)
C
      INTEGER   INCHAR, LTYPE, I, XINTER(NINTER), XINT, DIST, NOINT,
     *   NINT, IG, XVAL, DEG, DU, DL
      REAL      DCX, DCY, XL, XI, XPOS
      CHARACTER SPRTXT*8
      INCLUDE 'INCS:DMSG.INC'
      DATA XINTER /1, 2, 5, 10, 20, 50, 100, 200, 500, 1000,
     *   2000, 5000, 10000, 20000, 50000/
C-----------------------------------------------------------------------
      LTYPE = MOD (ABS (ILTYPE), 100)
      IF (LTYPE.EQ.1) GO TO 999
C                                       tick marks
      XINT = 32 / NG
      XINT = MAX (3, MIN (16, XINT))
      DIST = EC - BC + 2
      DO 20 I = 1,NINTER
         DEG = XINTER(I)
         DU = (EC / DEG) * DEG
         IF (DU.GT.EC) DU = DU - DEG
         DL = (BC / DEG) * DEG
         IF (DL.LT.BC) DL = DL + DEG
         NOINT = (DU - DL) / DEG + 1
         IF (NOINT.LE.XINT) GO TO 30
 20      CONTINUE
      MSGTXT = 'PINLAB: TICK MARK ALGORITHM FAILED'
      CALL MSGWRT (6)
      IERR = 0
      GO TO 999
C                                       plot tick marks
 30   XINT = DEG
      NINT = (NOINT * NG) / 16
      NINT = MAX (1, MIN (NINT, NOINT))
      NOINT = NOINT + 2
      DCX = -0.5
      XL = DIST * NG + 1
      XL = (TRC(1) - BLC(1)) / XL
      XI = (TRC(2) - BLC(2)) / 25.
      DCY = -1.5
      DO 50 IG = 1,NG
         XVAL = (BC / XINT) * XINT
         IF (XVAL.EQ.BC) XVAL = XVAL - XINT
         DO 40 I = 1,NOINT
            XVAL = XVAL + XINT
            IF ((XVAL.GE.BC) .AND. (XVAL.LE.EC)) THEN
               XPOS = (XVAL-BC+1 + (IG-1)*DIST) + BLC(1)
               CALL GPOS (XPOS, TRC(2), BUFFER, IERR)
               IF (IERR.NE.0) GO TO 999
               CALL GVEC (XPOS, TRC(2)-XI, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 999
               CALL GPOS (XPOS, BLC(2)+XI, BUFFER, IERR)
               IF (IERR.NE.0) GO TO 999
               CALL GVEC (XPOS, BLC(2), BUFFER, IERR)
               IF (IERR.NE.0) GO TO 999
               IF ((LTYPE.GT.2) .AND. (MOD(I,NINT).EQ.0)) THEN
                  WRITE (SPRTXT,1030) XVAL
                  CALL CHTRIM (SPRTXT, 6, SPRTXT, INCHAR)
                  DCX = 0.5 - INCHAR
                  CALL GCHAR (INCHAR, 0, DCX, DCY, SPRTXT, BUFFER, IERR)
                  IF (IERR.NE.0) GO TO 999
                  END IF
               END IF
 40         CONTINUE
 50      CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1030 FORMAT (I6)
      END

      SUBROUTINE ZTABOR (NAME, PID, IERR)
C-----------------------------------------------------------------------
C! deletes (or kills) the specified process
C# System Z2
C-----------------------------------------------------------------------
C;  Copyright (C) 2004, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   ZTABOR will delete/kill the process specified by NAME.
C   Inputs:
C      NAME   C*6    actual task name
C      PID    I(4)   Process "ID" code:
C                       PID(1) user number  0 => any user
C                       PID(2-4) process #  0 => unknown
C   Output:
C      IERR   I      Error number: 0 => ok.
C                       1 => error.
C   Generic version - calls ZTKILL   VMS COMMENTED OUT
C-----------------------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   PID(4), IERR
C
      HOLLERITH HNAME(2)
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C     IF (SYSTYP.EQ.'VMS') THEN
C        CALL ZTKILL (NAME, PID, IERR)
C     ELSE
         CALL CHR2H (6, NAME, 1, HNAME)
         CALL ZTKILL (HNAME, PID, IERR)
C        END IF
C
 999  RETURN
      END

      SUBROUTINE R3DTAB (FDVEC, TBIND, DPTR, NAXIS, IBLK, TAPBUF, IERR)
C-----------------------------------------------------------------------
C! Read data from FITS 3-D table and write AIPS table.
C# FITS EXT-util tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1997, 2008, 2015
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  This routine will read the data section of a FITS 3-D table and copy
C  the data to the AIPS version of the table.
C  Inputs:
C     FDVEC    I(50)      File descriptor vector for TAPIO input
C     DPTR     I(128,2)   Data Pointers, used in table file control.
C     NAXIS    I(2)       Length of columns (in char), number of rows.
C  In/Out:
C     TBIND    I          Buffer pointer in TAPBUF
C     IBLK     I(*)       Disk Table file I/O buffer.
C     TAPBUF   I(*)       Tape I/O buffer.
C  Outputs:
C     IERR     I          Error code. 0=ok.
C-----------------------------------------------------------------------
      INTEGER   FDVEC(50), TBIND, DPTR(128,2), NAXIS(2), IBLK(*),
     *   TAPBUF(*), IERR
C
      INCLUDE 'INCS:PUVD.INC'
      DOUBLE PRECISION RECRD(XBPRSZ/2)
      CHARACTER CBUFF*2048
      HOLLERITH RECH(XBPRSZ)
      REAL      RECRR(XBPRSZ)
      LOGICAL   RECLL(XBPRSZ)
      INTEGER   TBYTCT, MXLREB, TLINE(XBPRSZ), ROWF, ROWL, NAXIS1,
     *   NAXIS2, LCTR, RECII(XBPRSZ), BYTCNT(7), KTYPE, I, IOFF, IT0,
     *   II, TCOUNT(128), NEXT, NBYTE, TPTYPE(128), LIMIT, TOFF(128),
     *   JT, JTRIM
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DTHD.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (RECII, RECLL, RECRD, RECRR, RECH)
      DATA BYTCNT /8,4,1,4,1,2,1/
C-----------------------------------------------------------------------
      IERR = 0
      IF (NAXIS(2).EQ.0) THEN
         CALL TABIO ('CLOS', 0, LCTR, RECRR, IBLK, IERR)
         WRITE (MSGTXT,1000) ITYPE
         GO TO 990
         END IF
C                                       Calculate end & type
C                                       of Column values.
C                                       Use TFCODE to determine types
C                                       because DPTR holds output info.
      TBYTCT = 0
      DO 10 I = 1,ITNCOL
         TPTYPE(I) = MOD (TFCODE(I),10)
         TCOUNT(I) = DPTR(I,2) / 10
         TOFF(I) = DPTR(I,1)
C                                       Count bytes
         KTYPE = TPTYPE(I)
         TBYTCT = TBYTCT + TCOUNT(I) * BYTCNT(KTYPE)
 10      CONTINUE
C                                       Check buffer size
      MXLREB = XBPRSZ * NBITWD / 8
C                                       Record too big
      IF (TBYTCT.GT.MXLREB) THEN
         IERR = 5
         WRITE (MSGTXT,1010) TBYTCT, MXLREB
         GO TO 990
         END IF
C                                       Read first record,
      CALL TAPIO ('READ', FDVEC, TAPBUF, TBIND, IERR)
      NEXT = 1
      IF (IERR.NE.0) GO TO 999
C                                       Loop for all lines in table.
      NAXIS1 = NAXIS(1)
      NAXIS2 = NAXIS(2)
      ROWF = IBLK(5) + 1
      ROWL = IBLK(5) + NAXIS2
      DO 800 LCTR = ROWF,ROWL
         DO 200 I = 1,ITNCOL
C                                       Read a FITS table data entry.
            KTYPE = TPTYPE(I)
            NBYTE = BYTCNT(KTYPE) * TCOUNT(I)
            IF (KTYPE.EQ.7) NBYTE = 1 + (TCOUNT(I)-1) / 8
            CALL GTF3D (FDVEC, TBIND, NEXT, TAPBUF, NBYTE, TLINE, IERR)
            IF (IERR.NE.0) GO TO 999
C????? HOW TO DEAL WITH NULLS?????
C                                       Look for null values.
C            CALL CHCOMP (TWIDTH(I), TBCOL(I), TLINE,
C     *         1, TNULL(1,I), NULL)
C                                       Go to correct type
            IOFF = TOFF(I)
            IT0 = TPTYPE(I)
C                                       Double precision
            IF (IT0.EQ.1) THEN
               CALL ZR64RL (TCOUNT(I), 1, TLINE, RECRD(IOFF))
C                                       Single precision
            ELSE IF (IT0.EQ.2) THEN
               CALL ZR32RL (TCOUNT(I), 1, TLINE, RECRR(IOFF))
C                                       Character.
            ELSE IF (IT0.EQ.3) THEN
               CALL ZC8CL (TCOUNT(I), 1, TLINE, CBUFF)
               JT = JTRIM (CBUFF(:TCOUNT(I)))
               CALL CHR2H (TCOUNT(I), CBUFF, 1, RECH(IOFF))
C                                       Long Integer.
C                                       Convert to local I
            ELSE IF (IT0.EQ.4) THEN
               CALL ZI32IL (TCOUNT(I), 1, TLINE, RECII(IOFF))
C                                       Logical
            ELSE IF (IT0.EQ.5) THEN
               LIMIT = TCOUNT(I)
               CALL ZC8CL (LIMIT, 1, TLINE, CBUFF)
               DO 155 II = 1,LIMIT
                  RECLL(IOFF+II-1) = CBUFF(II:II).EQ.'T'
 155              CONTINUE
C                                       Short Integer.
C                                       Convert to INTEGER
            ELSE IF (IT0.EQ.6) THEN
               CALL ZI16IL (TCOUNT(I), 1, TLINE, RECII(IOFF))
C                                       bit array
            ELSE IF (IT0.EQ.7) THEN
               CALL ZX8XL (TCOUNT(I), TLINE, RECII(IOFF))
               END IF
 200        CONTINUE
C                                       Write this table row.
         CALL TABIO ('WRIT', 0, LCTR, RECRR, IBLK, IERR)
 800     CONTINUE
      CALL TABIO ('CLOS', 0, LCTR, RECRR, IBLK, IERR)
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('Warning: table type ',A2,' is of zero length')
 1010 FORMAT ('ERROR: TABLE ROW =',I6,' BYTES, BUFFER SIZE =',I6)
      END

      SUBROUTINE YCURSE (OP, WAIT, CORR, RPOS, QUAD, BUTTON, IERR)
C-----------------------------------------------------------------------
C! read and control TV cursor
C# TV-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   YCURSE reads cursor positions and controls the blink and visibility
C   of the TV cursor.
C   Inputs:
C      OP      C*4     'READ' read cursor position
C                      'ONNN' place cursor at RPOS & leave on
C                      'OFFF' turn cursor off
C                      'BLNK' reverse sense of cursor blink
C                      'FXIT' fix RPOS for zoom scroll, no IO
C      WAIT    L       wait for event; then return RPOS & BUTTON
C                      (done on all OPs)
C      CORR    L       T => correct RPOS for zoom & scroll
C   In/Out:
C      RPOS    R(2)    X,Y screen pos before  zoom & scroll
C      QUAD    I       TV quadrant to use for scrolls
C                         In: if <1 >4, no scroll
C                         Out: if in=-1, no scroll, else find
C                              quadrant (needs real TV pos)
C   Output:
C      BUTTON  I       event # (0 none, 1-7 low buttons,
C                      8-15 the "quit" button)
C      IERR    I       error code of Z...XF : 0 - ok
C                                             2 - input error
C   IIS Model 70 version
C-----------------------------------------------------------------------
      CHARACTER  OP*4
      REAL       RPOS(2)
      INTEGER    BUTTON, IERR, QUAD
      LOGICAL    WAIT, CORR
C
      CHARACTER  OPCODE(5)*4
      REAL       SRX, SRY, CURDEL
      INTEGER    NOP, MAG, INC, IZ, ISX, ISY, IX, IY, IRBLNK, IBUT,
     *   MODMAG, J, NSCR, I, IN, IOP, ZAND, ISCRX, ISCRY
      LOGICAL    OLDON, LINKX, LINKY, F, T, ON
      INCLUDE 'INCS:DTVC.INC'
      DATA NOP, OPCODE /5, 'READ','ONNN','OFFF','BLNK','FXIT'/
      DATA CURDEL /0.2/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
      BUTTON = 0
C                                        get opcode
      IERR = 2
      DO 10 IOP = 1,NOP
         IF (OP.EQ.OPCODE(IOP)) GO TO 20
 10      CONTINUE
      GO TO 999
C                                        ON: alters cursor pos
C                                        go from real to screen
 20   IF (IOP.EQ.2) THEN
         IF (.NOT.CORR) THEN
            ISX = RPOS(1) + 0.5
            ISY = RPOS(2) + 0.5
C                                        what scroll to use
         ELSE
            ISCRX = 0
            ISCRY = 0
            IF ((QUAD.GE.1) .AND. (QUAD.LE.4)) THEN
               NSCR = NGRAY + NGRAPH
               DO 30 I = 1,NSCR
                  J = 2 ** (I-1)
                  IF (ZAND(J,TVLIMG(QUAD)).NE.0) THEN
                     J = MIN (I, NGRAY+1)
                     ISCRX = TVSCRX(J)
                     ISCRY = TVSCRY(J)
                     GO TO 35
                     END IF
 30               CONTINUE
               END IF
 35         MAG = 1 + TVZOOM(1)
            IF (MXZOOM.GT.0) MAG = 2 ** TVZOOM(1)
            SRX = MOD (RPOS(1) - 1.0 + ISCRX + 10.0*MAXXTV(1),
     *         REAL(MAXXTV(1))) + 1.0
            SRY = MOD (RPOS(2) - 1.0 + ISCRY + 10.0*MAXXTV(2),
     *         REAL(MAXXTV(2))) + 1.0
            IF ((SCXINC.NE.1) .OR. (SCYINC.NE.1)) THEN
               INC = MAX (1, SCXINC/MAG)
               IF (MAG.EQ.1) INC = 1
               IZ = ((TVZOOM(2)-1)/INC) * INC  +  1
               MODMAG = INC * MAG
               ISX = MAG * (SRX - IZ)  +  IZ - MOD(IZ-1, MODMAG)
               IF (MAG.GT.2) ISX = ISX + (MAG-1)/2
               INC = MAX (1, SCYINC/MAG)
               IF (MAG.EQ.1) INC = 1
               IZ = MAXXTV(2) - ((MAXXTV(2)-TVZOOM(3))/INC)*INC
               MODMAG = INC * MAG
               IF (MAG.NE.1) SRY = SRY + 1.0/MAG
               IF ((MAXXTV(2).EQ.480) .AND. (MAG.GE.4)) SRY = SRY
     *            + 1.0/MAG
               ISY = MAG * (SRY - IZ) + IZ + MOD(MAXXTV(2)-IZ, MODMAG)
               IF (MAG.GT.1) ISY = ISY - 1 - MAG/2
            ELSE
               ISX = MAG * (SRX - TVZOOM(2)) + TVZOOM(2) + 0.5
               ISY = MAG * (SRY - TVZOOM(3)) + TVZOOM(3) + 0.5
               ISX = ISX + (MAG-1)/2
               IF (MAG.GT.1) ISY = ISY + (MAG-1)/2 - MAG
               END IF
            END IF
         END IF
C                                        read current status
 40   IF (IOP.EQ.5) THEN
         IX = RPOS(1) + 0.5
         IY = RPOS(2) + 0.5
         GO TO 70
         END IF
      CALL YCRCTL ('READ', OLDON, IX, IY, LINKX, LINKY, IRBLNK, IBUT,
     *   F, IERR)
      IF (IERR.NE.0) GO TO 999
C                                        quick read is nearly done
      IF ((IOP.EQ.1) .AND. (.NOT.WAIT)) GO TO 70
C                                        ON: set new position
         IF (IOP.EQ.2) THEN
            IX = ISX
            IY = ISY
            END IF
C                                        BLNK: reverse blink rate
 45      IF (IOP.EQ.4) IRBLNK = MOD (IRBLNK+1, 2)
C                                        if reading set to ON
C                                        else set requested status
         ON = T
         IF ((IOP.EQ.3) .AND. (.NOT.WAIT)) ON = F
         IF ((IOP.EQ.4) .AND. (.NOT.WAIT)) ON = OLDON
C                                        write new pars to curs reg.
         CALL YCRCTL ('WRIT', ON, IX, IY, LINKX, LINKY, IRBLNK, IBUT,
     *      F, IERR)
         IF ((IERR.NE.0).OR.(.NOT.WAIT)) GO TO 999
C                                        wait for event read cycle
 50      IF (IBUT.NE.0) GO TO 60
            CALL ZDELAY (CURDEL, IERR)
            CALL YCRCTL ('READ', ON, IX, IY, LINKX, LINKY, IRBLNK, IBUT,
     *         F, IERR)
            IF (IERR.NE.0) GO TO 999
            GO TO 50
C                                        event: reset status if need
 60      IF (IOP.EQ.3) ON = F
         IF ((IOP.EQ.1) .OR. (IOP.EQ.4)) ON = OLDON
         IF (.NOT.ON) THEN
            CALL YCRCTL ('WRIT', ON, IX, IY, LINKX, LINKY, IRBLNK, IBUT,
     *         F, IERR)
            IF (IERR.NE.0) GO TO 999
            END IF
C                                        return answers
 70   IF (IOP.NE.5) BUTTON = IBUT
      IF (.NOT.CORR) THEN
         RPOS(1) = IX
         RPOS(2) = IY
C                                        correct for zoom & scroll
      ELSE
C                                        Corr half cell
         MAG = 1 + TVZOOM(1)
         IF (MXZOOM.GT.0) MAG = 2 ** TVZOOM(1)
         IX = IX - (MAG-1)/2
         IF (MAG.GT.1) IY = IY - (MAG-1)/2 + MAG
C                                        What quadr. scroll
         ISCRX = 0
         ISCRY = 0
         IF (QUAD.NE.-1) THEN
            QUAD = 4
            IF ((IX.GE.TVSPLT(1)) .AND. (IY.GE.TVSPLT(2))) QUAD = 1
            IF ((IX.LT.TVSPLT(1)) .AND. (IY.GE.TVSPLT(2))) QUAD = 2
            IF ((IX.LT.TVSPLT(1)) .AND. (IY.LT.TVSPLT(2))) QUAD = 3
            NSCR = NGRAY + NGRAPH
            DO 80 I = 1,NSCR
               J = 2 ** (I-1)
               IF (ZAND(J,TVLIMG(QUAD)).NE.0) THEN
                  J = MIN (I, NGRAY+1)
                  ISCRX = TVSCRX(J)
                  ISCRY = TVSCRY(J)
                  GO TO 90
                  END IF
 80            CONTINUE
            END IF
 90      IF ((SCXINC.NE.1) .OR. (SCYINC.NE.1)) THEN
            INC = MAX (1, SCXINC/MAG)
            IF (MAG.EQ.1) INC = 1
            IZ = ((TVZOOM(2)-1)/INC) * INC  +  1
            MODMAG = INC * MAG
            IN = IZ + (IX - IZ + MOD(IZ-1,MODMAG) + MAXXTV(1)) / MAG
     *         - MAXXTV(1) / MAG
            RPOS(1) = IN + REAL(MOD(IX-1,MAG))/REAL(MAG)
            INC = MAX (1, SCYINC/MAG)
            IF (MAG.EQ.1) INC = 1
            IZ = MAXXTV(2) - ((MAXXTV(2)-TVZOOM(3))/INC)*INC
            MODMAG = INC * MAG
            IN = IZ + (IY - IZ - MOD(MAXXTV(2)-IZ,MODMAG) -
     *         MAXXTV(2))/MAG + MAXXTV(2)/MAG
            RPOS(2) = IN - REAL(MOD(MAXXTV(2)-IY,MAG))/REAL(MAG)
            IF (MAG.NE.1) RPOS(2) = RPOS(2) - 1.0/MAG
            IF ((MAXXTV(2).EQ.480) .AND. (MAG.GE.4)) RPOS(2) = RPOS(2) -
     *         1.0/MAG
         ELSE
            RPOS(1) = IX - TVZOOM(2)
            RPOS(1) = TVZOOM(2) + RPOS(1) / REAL (MAG)
            RPOS(2) = IY - TVZOOM(3)
            RPOS(2) = TVZOOM(3) + RPOS(2) / REAL (MAG)
            END IF
C                                       correct for scroll
         RPOS(1) = MOD (RPOS(1) - 1.0 - ISCRX + 10.0*MAXXTV(1),
     *      REAL(MAXXTV(1))) +  1.0
         RPOS(2) = MOD (RPOS(2) - 1.0 - ISCRY + 10.0*MAXXTV(2),
     *      REAL(MAXXTV(2)))  +  1.0
         END IF
      IERR = 0
C
 999  RETURN
      END

      SUBROUTINE ZTPCLR (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C! closes a remote tape device (real or pseudo-tape disk)
C# Tape Z2
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Close the remote tape drive associated with LUN.
C   Inputs:
C      LUN    I   Logical unit number = 30 + DriveNumber for tape
C      FIND   I   Index in FTAB to file control block for LUN
C   Output:
C      IERR   I   Error return code: 0 => no error
C                    1 => close error
C                    2 => non-zero LSERCH error
C                    3 => both 1 and 2
C                    4 => invalid LUN
C   Generic version - calls ZVTPC2.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
C
      INTEGER   IBUF(6), JERR, NBACK, NBACKE
      HOLLERITH HBUF(6)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      EQUIVALENCE (IBUF, HBUF)
      DATA NBACKE /0/
C-----------------------------------------------------------------------
C                                       send tape close
      CALL ZCLC8 (8, 'ZTPCLS  ', 1, HBUF)
      CALL ZILI32 (1, 1, 3, IBUF)
      CALL ZILI32 (1, 0, 4, IBUF)
      CALL ZILI32 (1, 0, 5, IBUF)
C                                       pack buffer: data
      CALL ZILI32 (1, LUN, 6, IBUF)
C
      NBACK = NBACKE
      CALL ZVTPX2 (FTAB(FIND+MOFF), 1, NBACK, IBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (7)
      ELSE
         CALL ZI32IL (1, 5, IBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR
            CALL MSGWRT (7)
            END IF
         END IF
      IF ((IERR.EQ.0) .AND. (NBACK.NE.NBACKE)) THEN
         WRITE (MSGTXT,1015) NBACK, NBACKE
         CALL MSGWRT (6)
         END IF
C                                       Deassign socket
      CALL ZVTPC2 (FTAB(FIND+MOFF), JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1020) JERR
         CALL MSGWRT (7)
         END IF
      IF (IERR.EQ.0) IERR = JERR
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ZTPCLR: ZVTPX2 RETURNS ERROR CODE',I7)
 1010 FORMAT ('ZTPCLR: REMOTE TAPE SYSTEM RETURNS ERROR CODE',I7)
 1015 FORMAT ('ZTPCLR: WARNING - GOT BACK',I3,' WORDS, EXPECTED',I3)
 1020 FORMAT ('ZTPCLR: ZVTPC2 RETURNS ERROR',I4,' DEASSIGNING SOCKET')
      END

      SUBROUTINE GRIDTB (DPARM, IMSIZE, NCHAVG, CHINC, NXANT, NXBASL,
     *   IXANT, IXBASL, DESEL, MSOU, MTIMES, MAXBUF, DIMBUF, IOBUF,
     *   XDOCAT, OUTNAM, OUTCLS, SEQOUT, DISKOU, CNOOUT, NPOINT, NFAIL,
     *   INSNUM, NANTSK, NBUFF, SBUFF, RBUFF, IRET)
C-----------------------------------------------------------------------
C! Makes a gridded image of the UV data in TB order.
C# UV Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2000, 2008-2011, 2013-2017, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GRIDTB makes a gridded image of the UV data in TB order.
C   Inputs:
C      DPARM    R(10)   Control parms:
C                          (1) 0,1,2 => amp, phase, amp rms gridded
C                              3 amp rms/mean gridded
C                              4, 5 => real, imag part of vis
C                              6 => store real and imag for TVFLG
C                          (2) > scalar avg, else vector
C                          (3) > 0 B -> ant. pair (grid twice)
C                          (4) > 0 => divide amp by source flux
C                          (5) x-axis interval
C                          (6) y-axis interval
C      IMSIZE   I(2)    Output image size (x,y)
C      NCHAVG   I       Number channels to average together
C      CHINC    I       Channel increment
C      NXANT    I       # entries in IXANT
C      NXBASL   I       # entries in IXBASL
C      IXANT    I(50)   ANTENNAS adverb values
C      IXBASL   I(50)   BASELINE adverb values
C      DESEL    L       the Antennas/Baselines are deselected
C      MAXBUF   I       Number of buffers to use
C      DIMBUF   I       Size of summing 1 buffer
C      IOBUF    I       Size of 1 IO buffer
C      XDOCAT   R       > 0 => mark the new image as permanent in the
C                       DFIL commons, else as temporary
C   In/out:
C      MSOU     I(*)    source numbers corresponding to time intervals
C                          made = -1 if times set regular
C      MTIMES   R(*)    (* = IMSIZE(2)) start times for each row
C                          MTIMES(2) < MTIMES(1) < 0 => set regular
C                          times from the first datum
C      OUTNAM   C*12    Output image name
C      OUTCLS   C*6     Output image class
C      SEQOUT   I       Output image seq number, if scratch, is DFIL
C                       number of SC file
C      DISKOU   I       Output image disk
C   Output:
C      CNOOUT   I       Output image catalog number
C      NPOINT   D       Vis included in grid  - note double precision!
C      NFAIL    I       Vis included but off the grid
C      NANTSK   I       Vis dropped due to antennas/baseline
C      NBUFF    I(*)    Counting buffer (DIMBUF,MAXBUF)
C      SBUFF    R(*)    Summing buffer (DIMBUF,MAXBUF)
C      RBUFF    R(*)    IO buffer (IOBUF,MAXBUF)
C      IRET     I       Error code: 0 ok, else die
C   Expected:
C      MAXBUF = 8       max. no buffers
C      DIMBUF = 2 * MAXANT * MAXANT     max baselines
C      IOBUF  = 16384   Words of IO buffer
C-----------------------------------------------------------------------
      INTEGER   IMSIZE(2), NCHAVG, CHINC, NXANT, NXBASL, IXANT(50),
     *   IXBASL(50), MSOU(*), MAXBUF, DIMBUF, IOBUF, SEQOUT, DISKOU,
     *   CNOOUT, NFAIL, INSNUM, NANTSK, NBUFF(DIMBUF,MAXBUF), IRET
      DOUBLE PRECISION NPOINT
      REAL      DPARM(10), XDOCAT, MTIMES(*), SBUFF(DIMBUF,MAXBUF),
     *   RBUFF(IOBUF,MAXBUF)
      LOGICAL   DESEL
      CHARACTER OUTNAM*12, OUTCLS*6
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      CHARACTER PHNAME*48, AXTYPE(3)*8, CUNITS(2)*8, CHTEMP*2, TYPTMP*2,
     *   CHSTOK(23)*4
      HOLLERITH CATH(256), CATSH(256), CATIH(256)
      INTEGER   LTYPE(2), I, J, K, IERR, IA, JERR, CATSAV(256), LUNO,
     *   LIF, LCHAN, IBLKOF, NBYT, IDEPTH(5), LBIF, LEIF, LBCHAN, NCOL,
     *   LECHAN, NROW, IROW, ITYP, OLDSOU, IROUND, NUMAN(1025), ITEMP,
     *   CATIMG(256), IANT, JANT, IARR, COLMUL, IJ, KP, KCH, KIF,
     *   NCOL2, LNCFIL, COLUP, LSUNUM, LLSUN, LLARR, LBVIS, LSTSOU, II,
     *   LIMIT, COLCRV, NSTOK, IB, IV, NAXBUF, NUMBUF, MXVIS, NOVIS,
     *   LCHINC, LIFINC, IBUFF, LR, IVIS, LSTINC, IVISO, MROW, INCB,
     *   LNCF, LNCS, LNCIF, IIV, NCHAN, ISOFF(4)
      LOGICAL   T, F, DOTWO, ISINGL, TABLE, EXIST, FITASC, MULTIS,
     *   WASSOU, GOTVIS, ISEOF, FIRST, REQBAS
      REAL      CATR(256), CATSR(256),  FLUXX, VALUE1, VALUE2, VALUE3,
     *   CATIR(256), TIMEND, RMAX, RMIN, TIMLST, RPARM(20), TEMP, WT
      DOUBLE PRECISION    CATD(128), CATSD(128), CATID(128), TSIGMA
C                                       MXVIS = max. no vis in VBUFF
      PARAMETER (MXVIS=100)
      REAL      VBUFF(30*MXVIS), DAFLUX(8), VISSAV(24), DBUFF(UVBFSS)
      INTEGER   MUMBUF, LUN(8), FIND(8), ICOL1(MXVIS), ICOL2(MXVIS),
     *   IBPTR(8), NCOLMX
      SAVE DBUFF
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DSOU.INC'
      COMMON /UVIMGC/ CATIMG
      EQUIVALENCE (CATBLK, CATH, CATR, CATD),
     *   (CATSAV, CATSH, CATSR, CATSD), (CATIMG, CATIH, CATIR, CATID)
      DATA AXTYPE /'ANT PAIR', 'BASELINE', 'TIME    '/
      DATA LUNO/26/
      DATA LUN /16, 17, 18, 19, 20, 21, 22, 23/
      DATA T, F /.TRUE.,.FALSE./
      DATA CUNITS /'DEGREES ','RATIO   '/
      DATA CHSTOK /'I','Q','U','V','IQU','IQUV','IV','QU', 'RR','LL',
     *   'RL','LR','RRLL','RLLR','VV','HH','VH','HV','VVHH','VHHV',
     *   'HALF','FULL','CROS'/
C-----------------------------------------------------------------------
      IRET = 0
C                                        NCOLMX = 2 * MAXANT * MAXANT
      NCOLMX = DIMBUF
      NAXBUF = MIN (8, MAXBUF)
      IF (MAXBUF.GT.8) THEN
         WRITE (MSGTXT,1000) MAXBUF
         CALL MSGWRT (6)
         END IF
      LSTSOU = -1
      WASSOU = .FALSE.
      FIRST = (MTIMES(1).LT.0.0) .AND. (MTIMES(2).LE.MTIMES(1))
      LLSUN = INSNUM
      LLARR = 0
      OLDSOU = 0
      NPOINT = 0.0D0
      NFAIL = 0
      NANTSK = 0
      DO 10 IBUFF = 1,NAXBUF
         DAFLUX(IBUFF) = 1.0
 10      CONTINUE
      ITYP = IROUND (DPARM(1)) + 1
      IF ((ITYP.EQ.1) .AND. (DPARM(2).GT.0.0)) ITYP = 0
C                                       ITYP = output data type:
C                                       0 = amp (scalar average)
C                                       1 = amp, 2 = phase, 3 = rms
C                                       4 = amp rms / mean
C                                       5 = real, 6 = imag,
C                                       7 = real & imag & flag #
      IF (ITYP.EQ.7) THEN
         COLMUL = 3
         COLUP = 3
      ELSE
         COLMUL = 1
         COLUP = 0
         END IF
      LTYPE(1) = 1
      LTYPE(2) = 2
      CALL H2CHR (2, 1, CATBLK(KITYP), CHTEMP)
      IF (CHTEMP(:1).NE.'T') THEN
         WRITE (MSGTXT,1005) CHTEMP
         IRET = 2
         GO TO 990
         END IF
C                                       Open the UV file
      TYPTMP = 'UV'
      CALL MAPOPN ('READ', IUDISK, UNAME, UCLAS, IUSEQ, TYPTMP, NLUSER,
     *   LUN, FIND, IUCNO, CATBLK, VBUFF, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) 'OPEN INPUT UV', IRET
         IRET = 1
         GO TO 990
         END IF
C                                       and close (UVGET does open)
      CALL MAPCLS ('READ', IUDISK, IUCNO, LUN, FIND, CATBLK, F, VBUFF,
     *   IERR)
C                                       Do we want multi-source?
C                                       only for flux scaling here
      EXIST = .FALSE.
      IF (DPARM(4).GT.0.0) CALL ISTAB ('SU', IUDISK, IUCNO, 1, LUN,
     *   VBUFF, TABLE, EXIST, FITASC, IERR)
      ISINGL = (.NOT.EXIST) .OR. (IERR.NE.0)
      ISINGL = ISINGL .OR. ((ILOCSU.LT.0) .AND. (INSNUM.LE.0))
      IF (ISINGL) DPARM(4) = -1.0
      MULTIS = ILOCSU.GE.0
C                                       Get number antennas
      IF ((LTYPE(1).EQ.1) .AND. (DPARM(3).GT.0.0)) LTYPE(1) = 0
      DOTWO = LTYPE(1).EQ.0
      CALL GETNAN (IUDISK, IUCNO, CATBLK, LUN, VBUFF, NUMAN, IRET)
      IF (((IRET.NE.0) .AND. (IRET.NE.10)) .OR. (NUMAN(1).LE.0)) THEN
         WRITE (MSGTXT,1015) IRET, NUMAN(1)
         IRET = 4
         GO TO 990
         END IF
      J = 0
      LIF = NUMAN(1)
      DO 25 I = 1,LIF
         NUMAN(513+I) = J
         IF (DOTWO) THEN
            J = J + NUMAN(1+I) * (NUMAN(1+I) + 1)
         ELSE
            J = J + (NUMAN(1+I) * (NUMAN(1+I) + 3)) / 2
            END IF
 25      CONTINUE
      NUMAN(514+LIF) = J
C                                       Build image header:
C                                       Misc.
      CALL COPY (256, CATBLK, CATSAV)
      CALL UVPGET (IRET)
      IF (ITYP.EQ.2) CALL CHR2H (8, CUNITS(1), 1, CATH(KHBUN))
      IF (ITYP.EQ.4) CALL CHR2H (8, CUNITS(2), 1, CATH(KHBUN))
      CATBLK(KIGCN) = 1
      CATBLK(KIPCN) = 0
      CATR(KRBLK) = FBLANK
      CATBLK(KIIMU) = NLUSER
      CATBLK(KITYP) = 0
      CALL CHR2H (2, 'MA', KHPTYO, CATH(KHPTY))
C                                       Coordinates
      CATBLK(KIDIM) = 7
C                                       FREQ
      NCHAN = (ECHAN - BCHAN) / CHINC + 1
      CATBLK(KINAX+3) = NCHAN
      CATD(KDCRV+3) = CATSD(KDCRV+JLOCF)
      CATR(KRCIC+3) = CATSR(KRCIC+JLOCF) * CHINC
      CATR(KRCRP+3) = (CATSR(KRCRP+JLOCF) - BCHAN - (NCHAVG-1)/2.0) /
     *   CHINC + 1
      CATR(KRCRT+3) = 0.0
      I = JLOCF * 2
      CALL CHCOPY (8, 1, CATSH(KHCTP+I), 1, CATH(KHCTP+6))
C                                       IF
      CATR(KRCRT+4) = 0.0
      IF (JLOCIF.GE.0) THEN
         CATBLK(KINAX+4) = EIF - BIF + 1
         CATD(KDCRV+4) = CATSD(KDCRV+JLOCIF)
         CATR(KRCIC+4) = CATSR(KRCIC+JLOCIF)
         CATR(KRCRP+4) = CATSR(KRCRP+JLOCIF) - BIF + 1
         I = JLOCIF * 2
         CALL CHCOPY (8, 1, CATSH(KHCTP+I), 1, CATH(KHCTP+8))
      ELSE
         CATBLK(KINAX+4) = 1
         CATD(KDCRV+4) = 1.0D0
         CATR(KRCIC+4) = 1.0
         CATR(KRCRP+4) = 1.0
         CALL CHR2H (8, 'IF      ', 1, CATH(KHCTP+8))
         END IF
C                                       Stokes
      J = 0
      DO 35 I = 1,22
         IF (STOKES.EQ.CHSTOK(I)) J = I
 35      CONTINUE
      IF ((J.LE.0) .AND. (ICOR0.LT.-5)) J = 16
      IF ((J.LE.0) .AND. (ICOR0.LT.-4)) J = 19
      IF ((J.LE.0) .AND. (ICOR0.LT.-1)) J = 10
      IF ((J.LE.0) .AND. (ICOR0.LT.0)) J = 13
      IF (NCOR.EQ.1) THEN
         TEMP = CATSD(KDCRV+JLOCS) + (1.0-CATSR(KRCRP+JLOCS)) *
     *      CATSR(KRCIC+JLOCS)
         IF (TEMP.LT.-4.) THEN
            J = 10 - IROUND (TEMP)
         ELSE IF (TEMP.LT.0.) THEN
            J = 8 - IROUND (TEMP)
         ELSE
            J = IROUND (TEMP)
            END IF
      ELSE IF ((NCOR.EQ.2) .AND. (J.EQ.22)) THEN
         IF (ICOR0.LT.-4) THEN
            J = 19
            IF (ICOR0.LT.-6) J = 20
         ELSE IF (ICOR0.LT.0) THEN
            J = 13
            IF (ICOR0.LT.-2) J = 14
         ELSE
            J = 7
            END IF
         END IF
      IF (J.LE.0) J = 1
      IF (ICOR0.LT.-4) THEN
         IF (J.EQ.23) J = 20
         IF (J.EQ.21) J = 19
      ELSE
         IF (J.EQ.23) J = 14
         IF (J.EQ.21) J = 13
         END IF
      ISOFF(1) = 0
      ISOFF(2) = 1
      ISOFF(3) = 2
      ISOFF(4) = 3
      IF (J.LE.4) THEN
         STOKES = CHSTOK(J)
         CATBLK(KINAX+2) = 1
         CATD(KDCRV+2) = J
         CATR(KRCIC+2) = 1.0
         ISOFF(2) = -1
      ELSE IF (J.EQ.5) THEN
         STOKES = CHSTOK(J)
         CATBLK(KINAX+2) = 3
         CATD(KDCRV+2) = 1.0D0
         CATR(KRCIC+2) = 1.0
      ELSE IF (J.EQ.6) THEN
         STOKES = CHSTOK(J)
         CATBLK(KINAX+2) = 4
         CATD(KDCRV+2) = 1.0D0
         CATR(KRCIC+2) = 1.0
      ELSE IF (J.EQ.7) THEN
         STOKES = CHSTOK(J)
         CATBLK(KINAX+2) = 2
         CATD(KDCRV+2) = 1.0D0
         CATR(KRCIC+2) = 3.0
      ELSE IF (J.EQ.8) THEN
         STOKES = CHSTOK(5)
         CATBLK(KINAX+2) = 2
         CATD(KDCRV+2) = 2.0D0
         CATR(KRCIC+2) = 1.0
         ISOFF(1) = 1
         ISOFF(2) = 2
      ELSE IF (J.LE.12) THEN
         STOKES = CHSTOK(J)
         CATBLK(KINAX+2) = 1
         CATD(KDCRV+2) = 8.0D0 - J
         CATR(KRCIC+2) = -1.0
         ISOFF(2) = -1
      ELSE IF (J.EQ.13) THEN
         STOKES = CHSTOK(J)
         CATBLK(KINAX+2) = 2
         CATD(KDCRV+2) = -1.0D0
         CATR(KRCIC+2) = -1.0
      ELSE IF (J.EQ.14) THEN
         STOKES = CHSTOK(14)
         CATBLK(KINAX+2) = 2
         CATD(KDCRV+2) = -3.0D0
         CATR(KRCIC+2) = -1.0
         ISOFF(1) = 2
         ISOFF(2) = 3
      ELSE IF (J.LE.18) THEN
         STOKES = CHSTOK(J)
         CATBLK(KINAX+2) = 1
         CATD(KDCRV+2) = 10.0D0 - J
         CATR(KRCIC+2) = -1.0
         ISOFF(2) = -1
      ELSE IF (J.EQ.19) THEN
         STOKES = CHSTOK(J)
         CATBLK(KINAX+2) = 2
         CATD(KDCRV+2) = -5.0D0
         CATR(KRCIC+2) = -1.0
         ISOFF(2) = 1
      ELSE IF (J.EQ.20) THEN
         STOKES = CHSTOK(20)
         CATBLK(KINAX+2) = 2
         CATD(KDCRV+2) = -7.0D0
         CATR(KRCIC+2) = -1.0
         ISOFF(1) = 2
         ISOFF(2) = 3
      ELSE IF (J.EQ.22) THEN
         STOKES = CHSTOK(22)
         CATBLK(KINAX+2) = 4
         CATD(KDCRV+2) = ICOR0
         CATR(KRCIC+2) = -1.0
         END IF
      NSTOK = CATBLK(KINAX+2)
      CATR(KRCRP+2) = 1.0
      CATR(KRCRT+2) = 0.0
      I = JLOCS * 2
      CALL CHCOPY (8, 1, CATSH(KHCTP+I), 1, CATH(KHCTP+4))
C                                       warning message
      IF ((.NOT.DOCAL) .AND. (ICOR0.LE.0) .AND. (J.LE.8) .AND.
     *   (ILOCSU.GE.0)) THEN
         MSGTXT = 'WARNING: Conversion to Stokes before calibration'
     *      // ' is meaningless'
         CALL MSGWRT (2)
         END IF
C                                       RA, dec
      CATBLK(KINAX+5) = 1
      CATD(KDCRV+5) = CATSD(KDCRV+JLOCR)
      CATR(KRCIC+5) = CATSR(KRCIC+JLOCR)
      CATR(KRCRP+5) = CATSR(KRCRP+JLOCR)
      CATR(KRCRT+5) = CATSR(KRCRT+JLOCR)
      I = JLOCR * 2
      CALL CHCOPY (8, 1, CATSH(KHCTP+I), 1, CATH(KHCTP+10))
      CATBLK(KINAX+6) = 1
      CATD(KDCRV+6) = CATSD(KDCRV+JLOCD)
      CATR(KRCIC+6) = CATSR(KRCIC+JLOCD)
      CATR(KRCRP+6) = CATSR(KRCRP+JLOCD)
      CATR(KRCRT+6) = CATSR(KRCRT+JLOCD)
      I = JLOCD * 2
      CALL CHCOPY (8, 1, CATSH(KHCTP+I), 1, CATH(KHCTP+12))
C                                       First 2 axes
      DO 55 I = 1,2
         CATBLK(KINAX+I-1) = IMSIZE(I)
         IF (DPARM(4+I).EQ.0.0) DPARM(4+I) = 1.0
         CATR(KRCIC+I-1) = ABS (DPARM(4+I))
         IF (LTYPE(I).EQ.2) THEN
            CATR(KRCIC+I-1) = CATR(KRCIC+I-1) / (24. * 3600.)
            TSIGMA = CATR(KRCIC+I-1) / 11.0D0
            END IF
         CATD(KDCRV+I-1) = (MTIMES(1) + MTIMES(2)) / 2.0
         IF (LTYPE(I).LE.1) THEN
            CATR(KRCIC+I-1) = 1.0
            IF (SUBARR.GT.0) THEN
               CATD(KDCRV+I-1) = NUMAN(513+SUBARR) + 1.0D0
               CATBLK(KINAX+I-1) = NUMAN(514+SUBARR) - NUMAN(513+SUBARR)
            ELSE
               CATD(KDCRV+I-1) = 1.0D0
               CATBLK(KINAX+I-1) = NUMAN(514+NUMAN(1))
               END IF
            END IF
         CATR(KRCRP+I-1) = 1.0
         CATR(KRCRT+I-1) = 0.0
         J = (I-1) * 2
         CALL CHR2H (8, AXTYPE(LTYPE(I)+1), 1, CATH(KHCTP+J))
 55      CONTINUE
      IF (CATBLK(KINAX).GT.2*MAXANT*MAXANT) THEN
         IV = 2 * MAXANT * MAXANT
         WRITE (MSGTXT,1055) CATBLK(KINAX), IV
         CALL MSGWRT (8)
         MSGTXT = '        USE ONE SUBARRAY AT A TIME'
         IRET = 6
         GO TO 990
         END IF
      CATBLK(KINAX) = CATBLK(KINAX) * COLMUL + COLUP
      IMSIZE(1) = CATBLK(KINAX)
      IMSIZE(2) = CATBLK(KINAX+1)
      MROW = CATBLK(KINAX+1)
C                                       Create output map file
      LNCFIL = 0
C                                       Cataloged MA file output
      CALL MAKOUT (UNAME, UCLAS, IUSEQ, ' ', OUTNAM, OUTCLS, SEQOUT)
      CALL CHR2H (12, OUTNAM, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, OUTCLS, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       support BADDISK
      IIV = 0
      IF (DISKOU.GT.0) THEN
         IV = DISKOU
         IIV = IV
         CALL MCREAT (IV, CNOOUT, VBUFF, IRET)
      ELSE
         DO 65 IV = 1,NVOL
            DO 60 I = 1,10
               IF (IV.EQ.IBAD(I)) GO TO 65
 60            CONTINUE
            MSGSUP = 32000
            IIV = IV
            CALL MCREAT (IV, CNOOUT, VBUFF, IRET)
            MSGSUP = 0
            IF (IRET.NE.1) GO TO 70
 65         CONTINUE
         IRET = 1
         END IF
 70   SEQOUT = CATBLK(KIIMS)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) 'CREATE OUTPUT IMAGE', IRET
         IF (IRET.EQ.1) THEN
            CALL MSGWRT (8)
            MSGTXT = 'NO DISK SPACE ON ALLOWED DISKS'
            IF (IIV.LE.0) MSGTXT = 'BADDISK LEAVES NO DISKS TO USE'
            END IF
         IRET = 3
         GO TO 990
         END IF
      DISKOU = IV
C                                       mark cataloged
      IF (XDOCAT.GT.0.0) THEN
         IF (NCFILE.LT.FILIST) THEN
            NCFILE = NCFILE + 1
            FVOL(NCFILE) = DISKOU
            FCNO(NCFILE) = CNOOUT
            FRW(NCFILE) = 2
            LNCFIL = NCFILE
         ELSE
            IRET = 9
            MSGTXT = 'GRIDTB: FILE LIST OVERFLOWS'
            END IF
C                                       mark as temporary
      ELSE
         IF (NSCR.LT.SCRLST) THEN
            NSCR = NSCR + 1
            SCRVOL(NSCR) = DISKOU
            SCRCNO(NSCR) = CNOOUT
         ELSE
            IRET = 9
            MSGTXT = 'GRIDTB: FILE LIST OVERFLOWS'
            END IF
         END IF
      IF (IRET.EQ.9) THEN
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL ZPHFIL ('MA', DISKOU, CNOOUT, 1, PHNAME, IERR)
C                                       Loop over IF, freq
      IF (CATSAV(KINAX).EQ.1) THEN
         LNCS = INCS * 3
         LNCF = INCF * 3
         LNCIF = INCIF * 3
      ELSE
         LNCS = INCS
         LNCF = INCF
         LNCIF = INCIF
         ENDIF
      NBYT = 2 * IOBUF
      LBIF = BIF
      LEIF = EIF
      LBCHAN = BCHAN
      LECHAN = BCHAN + (NCHAN-1) * CHINC + NCHAVG - 1
      IF (LECHAN.NE.ECHAN) THEN
         WRITE (MSGTXT,1070) LECHAN, ECHAN
         CALL MSGWRT (6)
         END IF
      NCOL = CATBLK(KINAX)
      NCOL2 = (CATBLK(KINAX) - COLUP) / COLMUL
      CALL COPY (256, CATBLK, CATIMG)
      CALL COPY (256, CATSAV, CATBLK)
      RMAX = -1.E23
      RMIN = 1.E23
      LSTINC = CATIMG(KINAX+2)
      IB = NAXBUF / LSTINC

C                                       use buffers for several ch.
      LCHINC = NCHAN
      LCHINC = MAX (1, MIN (LCHINC, IB))
      LIFINC = 1
C                                       Use buffers for IFs.
      IF (LCHINC.LE.1) THEN
         LIFINC = LEIF - LBIF + 1
         LIFINC = MAX (1, MIN (LIFINC, IB))
         END IF
      NUMBUF = MAX (LCHINC, LIFINC) * LSTINC
      LBVIS = 3 * NUMBUF  + 4
      LIMIT = LBVIS - 4
      COLCRV = CATID(KDCRV) - 0.5001
      INCB = (LIFINC - 1) * LNCIF + (LCHINC - 1) * LNCF
      DO 500 LIF = LBIF,LEIF,LIFINC
         DO 480 LCHAN = 1,NCHAN,LCHINC
C                                       Init i/o to uv file
            IROW = 1
            BIF = LIF
            EIF = LIF + LIFINC - 1
            EIF = MIN (EIF, LEIF)
            BCHAN = (LCHAN-1) * CHINC + LBCHAN
            ECHAN = BCHAN + (LCHINC - 1) * CHINC + NCHAVG - 1
            ECHAN = MIN (ECHAN, LECHAN)
            MUMBUF = (ECHAN - BCHAN + CHINC - NCHAVG) / CHINC + 1
            MUMBUF = MUMBUF * (EIF - BIF + 1) * LSTINC
            IB = MUMBUF / LSTINC
            RPARM(1) = FBLANK
            TIMLST = -1.E10
            CALL UVGET ('INIT', RPARM, DBUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) 'INIT INPUT UV', IRET
               IRET = 5
               GO TO 990
               END IF
            LNCS = INCS
            LNCF = INCF
            LNCIF = INCIF
C                                       init image I/O
            DO 80 IBUFF = 1,MUMBUF
C                                       Open output files on first pass
               IF ((LIF.EQ.LBIF) .AND. (LCHAN.EQ.1)) THEN
                  CALL ZOPEN (LUN(IBUFF), FIND(IBUFF), DISKOU, PHNAME,
     *               T, F, T, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1010) 'OPEN OUTPUT IMAGE', IRET
                     IRET = 4
                     GO TO 990
                     END IF
                  END IF
               IDEPTH(1) = MOD (IBUFF-1, LSTINC) + 1
               IDEPTH(2) = LCHAN
               IDEPTH(3) = LIF - LBIF + 1
               IDEPTH(4) = 1
               IDEPTH(5) = 1
C                                       Several channels
               IF (LCHINC.GT.1) THEN
                  IDEPTH(2) = IDEPTH(2) + (IBUFF-1) / LSTINC
C                                       Several IFs
               ELSE
                  IDEPTH(3) = IDEPTH(3) + (IBUFF-1) / LSTINC
                  END IF
               CALL COMOFF (CATIMG(KIDIM), CATIMG(KINAX), IDEPTH,
     *            IBLKOF, IERR)
               IBLKOF = IBLKOF + 1
               CALL MINIT ('WRIT', LUN(IBUFF), FIND(IBUFF),
     *            CATIMG(KINAX), CATIMG(KINAX+1), 0, RBUFF(1,IBUFF),
     *            NBYT, IBLKOF, IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1010) 'INIT OUTPUT IMAGE', IRET
                  IRET = 4
                  GO TO 990
                  END IF
 80            CONTINUE
C                                       current row = 0
            NROW = 0
            IVIS = 1
            GOTVIS = F
            TIMEND = -1.0E20
C                                       Read first record
 90         IF (.NOT.GOTVIS) THEN
               IRET = 0
               CALL DATGET (RPARM, DBUFF, TIMLST, IRET)
               ISEOF = (IRET.EQ.4)
               IF (ISEOF) GO TO 200
               IF (IRET.NE.0) THEN
                  IF (IRET.EQ.4) THEN
                     MSGTXT = 'NO DATA SELECTED, CHECK ADVERBS'
                  ELSE
                     WRITE (MSGTXT,1010) 'READ INPUT UV', IRET
                     END IF
                  IRET = 5
                  GO TO 990
               ELSE
                  II = IVIS
                  DO 94 KIF = BIF,EIF
                     DO 93 J = 1,LCHINC
                        KCH = BCHAN + (J-1)*CHINC
                        DO 92 KP = 1,NSTOK
                           II = II + 3
                           VBUFF(II+1) = 0.0
                           VBUFF(II+2) = 0.0
                           VBUFF(II+3) = 0.0
                           DO 91 K = KCH,KCH+NCHAVG-1
                              IJ = LNCS * ISOFF(KP) + LNCF * (K-BCHAN)
     *                           + LNCIF * (KIF-BIF)
                              WT = DBUFF(IJ+3)
                              IF (WT.GT.0.0) THEN
                                 VBUFF(II+1) = VBUFF(II+1) + DBUFF(IJ+1)
     *                              * WT
                                 VBUFF(II+2) = VBUFF(II+2) + DBUFF(IJ+2)
     *                              * WT
                                 VBUFF(II+3) = VBUFF(II+3) + WT
                                 END IF
 91                           CONTINUE
                           WT = VBUFF(II+3)
                           IF (WT.GT.0.0) THEN
                              VBUFF(II+1) = VBUFF(II+1) / WT
                              VBUFF(II+2) = VBUFF(II+2) / WT
                              END IF
 92                        CONTINUE
 93                     CONTINUE
 94                  CONTINUE
                  END IF
               END IF
            GOTVIS = T
C                                       set regular times by default
            IF (FIRST) THEN
               II = RPARM(1+ILOCT) / TSIGMA + 0.5D0
               TEMP = II * TSIGMA
               CATID(KDCRV+1) = TEMP
               II = CATIMG(KINAX+1) + 1
               DO 97 I = 1,II
                  MSOU(I) = -1
                  MTIMES(I) = TEMP + (I - 1.5) * CATIR(KRCIC+1)
 97            CONTINUE
               FIRST = .FALSE.
               END IF
C                                       find row for integration
            IF (TIMEND.LT.-1.0E10) THEN
               TEMP = RPARM(1+ILOCT)
               IF ((IROW.LT.1) .OR. (IROW.GT.MROW)) IROW = 1
               DO 95 LR = IROW,MROW
                  IF ((TEMP.GE.MTIMES(LR)) .AND.
     *               (TEMP.LT.MTIMES(LR+1))) GO TO 96
 95               CONTINUE
               NFAIL = NFAIL + MUMBUF
               GOTVIS = F
               GO TO 90
 96            IROW = LR
               TIMEND = MTIMES(IROW+1)
C                                       New row, allow new source
               IF (IROW.GT.NROW) THEN
                  LLSUN = INSNUM
                  LLARR = 0
                  END IF
               END IF
C                                       read uv data loop
 100        CONTINUE
               IF (.NOT.GOTVIS) THEN
                  IRET = 0
                  CALL DATGET (RPARM, DBUFF, TIMLST, IRET)
                  ISEOF = (IRET.EQ.4)
                  IF (ISEOF) GO TO 200
                  IF (IRET.NE.0) THEN
                     IF (IRET.EQ.4) THEN
                        MSGTXT = 'NO DATA SELECTED, CHECK ADVERBS'
                     ELSE
                        WRITE (MSGTXT,1010) 'READ INPUT UV', IRET
                        END IF
                     IRET = 5
                     GO TO 990
                  ELSE
                     II = IVIS
                     DO 104 KIF = BIF,EIF
                        DO 103 J = 1,LCHINC
                           KCH = BCHAN + (J-1)*CHINC
                           DO 102 KP = 1,NSTOK
                              II = II + 3
                              VBUFF(II+1) = 0.0
                              VBUFF(II+2) = 0.0
                              VBUFF(II+3) = 0.0
                              DO 101 K = KCH,KCH+NCHAVG-1
                                 IJ = LNCS * ISOFF(KP) +
     *                              LNCF * (K-BCHAN) + LNCIF * (KIF-BIF)
                                 WT = DBUFF(IJ+3)
                                 IF (WT.GT.0.0) THEN
                                    VBUFF(II+1) = VBUFF(II+1) + WT *
     *                                 DBUFF(IJ+1)
                                    VBUFF(II+2) = VBUFF(II+2) + WT *
     *                                 DBUFF(IJ+2)
                                    VBUFF(II+3) = VBUFF(II+3) + WT
                                    END IF
 101                             CONTINUE
                              WT = VBUFF(II+3)
                              IF (WT.GT.0.0) THEN
                                 VBUFF(II+1) = VBUFF(II+1) / WT
                                 VBUFF(II+2) = VBUFF(II+2) / WT
                                 END IF
 102                          CONTINUE
 103                       CONTINUE
 104                    CONTINUE
                     END IF
                  END IF
C                                       get source number
               IERR = 0
               IRET = 0
               LSUNUM = 1
               IF (MULTIS) THEN
                  IF (ILOCSU.GE.0) THEN
                     LSUNUM = RPARM(ILOCSU+1) + 0.1
                  ELSE
                     IF (NSOUWD.EQ.1) LSUNUM = SOUWAN(1)
                     END IF
                  END IF
               GOTVIS = T
C                                       End of accumulation, save last
C                                       record
               TEMP = RPARM(1+ILOCT)
               IF ((TEMP.GE.TIMEND) .OR. (NOVIS.GE.(MXVIS-1))) THEN
                  DO 105 IA = 1,LIMIT
                     VISSAV(IA) = VBUFF(IVIS+3+IA)
 105                 CONTINUE
                  GO TO 200
                  END IF
               GOTVIS = F
               IF (ILOCB.GE.0) THEN
                  TEMP = RPARM(ILOCB+1)
                  JANT = TEMP + 0.1
                  IARR = 100.0 * (TEMP - JANT) + 1.49
                  IANT = JANT / 256
                  JANT = JANT - 256 * IANT
               ELSE
                  IANT = RPARM(1+ILOCA1) + 0.1
                  JANT = RPARM(1+ILOCA2) + 0.1
                  IARR = RPARM(1+ILOCSA) + 0.1
                  END IF
               IF (IANT.GT.JANT) THEN
                  J = IANT
                  IANT = JANT
                  JANT = J
                  END IF
C                                       Save record, 1=IANT, 2=JANT,
C                                       3=array, 4=time
               VBUFF(IVIS) = IANT
               VBUFF(IVIS+1) = JANT
               VBUFF(IVIS+2) = IARR
               TEMP = RPARM(1+ILOCT)
               VBUFF(IVIS+3) = TEMP
C                                       Do we want it?
               IF (.NOT.REQBAS (IANT, JANT, DESEL, IXANT, NXANT, IXBASL,
     *            NXBASL)) THEN
                  NANTSK = NANTSK + MUMBUF
                  GO TO 100
                  END IF
C                                       Check source
               IF (MULTIS) THEN
                  IF (LLSUN.LE.0) THEN
                     LLSUN = LSUNUM
                     LLARR = IARR
                  ELSE
                     IF (IARR.LT.LLARR) THEN
                        LLSUN = LSUNUM
                        LLARR = IARR
                        END IF
C                                       Different source in integration
                     IF ((IARR.EQ.LLARR) .AND. (LLSUN.NE.LSUNUM)) THEN
                        WASSOU = .TRUE.
                        GO TO 100
                        END IF
                     END IF
                  END IF
C                                       Vis wanted
               NOVIS = NOVIS + 1
               IVIS = IVIS + LBVIS
               GO TO 100
C                                       End of vis buffer reading loop.
 200           IF ((NOVIS.LE.0) .AND. (.NOT.ISEOF)) GO TO 305
               IF ((NOVIS.LE.0) .AND. (ISEOF)) GO TO 450
C                                       Get column numbers
               IVIS = 1
C                                       Data on grid twice
               IF (DOTWO) THEN
                  DO 210 IV = 1,NOVIS
                     ICOL1(IV) = -1
                     ICOL2(IV) = -1
                     IANT = VBUFF(IVIS) + 0.5
                     JANT = VBUFF(IVIS+1) + 0.5
                     IARR = VBUFF(IVIS+2) + 0.5
                     ITEMP = NUMAN(513+IARR) + JANT +
     *                  (IANT-1) * (NUMAN(1+IARR) + 1) - COLCRV
                     IF ((ITEMP.GE.1) .AND.
     *                  (ITEMP.LE.CATIMG(KINAX))) ICOL1(IV) = ITEMP
                     ITEMP = NUMAN(513+IARR) +
     *                  (JANT-1) * (NUMAN(1+IARR) + 1) + IANT - COLCRV
                     IF ((ITEMP.GE.1) .AND.
     *                  (ITEMP.LE.CATIMG(KINAX))) ICOL2(IV) = ITEMP
                     IVIS = IVIS + LBVIS
 210                 CONTINUE
C                                       Data on grid once
               ELSE
                  DO 220 IV = 1,NOVIS
                     ICOL1(IV) = -1
                     ICOL2(IV) = -1
                     IANT = VBUFF(IVIS) + 0.5
                     JANT = VBUFF(IVIS+1) + 0.5
                     IARR = VBUFF(IVIS+2) + 0.5
                     ITEMP = NUMAN(513+IARR) + JANT - IANT  - COLCRV +
     *                  (IANT-1) * (2*NUMAN(1+IARR) + 4 - IANT) / 2 + 1
                     IF ((ITEMP.GE.1) .AND. (ITEMP.LE.CATIMG(KINAX)))
     *                  ICOL1(IV) = ITEMP
                     IVIS = IVIS + LBVIS
 220                 CONTINUE
                  END IF
C                                       row (all data should be on the
C                                       same row)
               IVIS = IVIS - LBVIS
               TEMP = VBUFF(IVIS+3)
               IF ((IROW.LT.1) .OR. (IROW.GT.MROW)) IROW = 1
               DO 225 LR = IROW,MROW
                  IF ((TEMP.GE.MTIMES(LR)) .AND.
     *               (TEMP.LT.MTIMES(LR+1))) GO TO 226
 225              CONTINUE
               NFAIL = NFAIL + NOVIS * MUMBUF
               GO TO 305
 226           IROW = LR
               TIMEND = MTIMES(IROW+1)
C                                       Off grid
               IF ((IROW.LT.1) .OR. (IROW.GE.CATIMG(KINAX+1))) THEN
                  NFAIL = NFAIL + NOVIS * MUMBUF
                  GO TO 305
C                                       Check if some fell off grid in
C                                       baseline.
               ELSE
                  DO 230 IV = 1,NOVIS
                     IF ((ICOL1(IV).LE.0) .AND. (ICOL2(IV).LE.0)) THEN
                        NFAIL = NFAIL + MUMBUF
                     ELSE
                        NPOINT = NPOINT + MUMBUF
                        END IF
 230                 CONTINUE
                  END IF
C                                       Average, write row
               IF (IROW.GT.NROW) THEN
                  CALL GTBWRT (OLDSOU, MSOU, MTIMES, NCOL2, NCOLMX,
     *               IOBUF, ITYP, LUN, FIND, F, IROW, NROW, MUMBUF,
     *               RBUFF, SBUFF, NBUFF, IBPTR, RMAX, RMIN, IRET)
                  IF (IRET.NE.0) THEN
                     WRITE (MSGTXT,1230) IRET
                     IRET = 4
                     GO TO 990
                     END IF
                  TIMEND = -1.0E20
                  END IF
C                                       Get source flux
               IF ((.NOT.ISINGL) .AND. (LSTSOU.NE.LLSUN)) THEN
                  CALL GETSOU (LLSUN, IUDISK, IUCNO, CATSAV, LUNO, IERR)
                  DAFLUX(1) = 1.0
                  FLUXX = FLUX(1,LIF)
                  IF (FLUXX.LE.1.0E-20) FLUXX = 1.0
                  IF (IERR.EQ.0) DAFLUX(1) = 1.0 / FLUXX
                  DO 240 IBUFF = 2,MUMBUF
                     DAFLUX(IBUFF) = 1.0
C                                       Multiple channels
                     IF ((IERR.EQ.0) .AND. (LCHINC.GT.1)) THEN
                        DAFLUX(IBUFF) = 1.0 / FLUXX
                        END IF
C                                       Multiple IFs
                     IF ((IERR.EQ.0) .AND. (LIFINC.GT.1)) THEN
                        FLUXX = FLUX(1,LIF+(IBUFF-1)/LSTINC)
                        IF (FLUXX.LE.1.0E-20) FLUXX = 1.0
                        DAFLUX(IBUFF) = 1.0 / FLUXX
                        END IF
 240                 CONTINUE
                  LSTSOU = LLSUN
                  END IF
C                                       Process visibility data.
C                                       First entry:
C                                       Loop over buffer
               DO 300 IBUFF = 1,MUMBUF
                  IVIS = 5 + (IBUFF-1) * 3
C                                       Divide by source flux
                  IF (ABS (DAFLUX(IBUFF)-1.0).GT.1.0E-5) THEN
                     VALUE1 = DAFLUX(IBUFF)
                     DO 245 IV = 1,NOVIS
                        VBUFF(IVIS) = VBUFF(IVIS) * VALUE1
                        VBUFF(IVIS+1) = VBUFF(IVIS+1) * VALUE1
                        IVIS = IVIS + LBVIS
 245                    CONTINUE
                     END IF
                  IVIS = 5 + (IBUFF-1) * 3
                  IVISO = IVIS - 4
C                                       Amp (scalar avg) or rms
                  IF ((ITYP.EQ.0).OR.(ITYP.EQ.3).OR.(ITYP.EQ.4)) THEN
      DO 250 IV = 1,NOVIS
         IF ((ICOL1(IV).GE.1) .AND. (VBUFF(IVIS+2).GT.0.0)) THEN
            K = ICOL1(IV)
            J = IBPTR(IBUFF) + (ICOL1(IV)-1) * COLMUL + COLUP
            IF (RBUFF(J,IBUFF).EQ.FBLANK) RBUFF(J,IBUFF) = 0.0
            VALUE1 = VBUFF(IVIS)
            VALUE2 = VBUFF(IVIS+1)
            VALUE3 =  SQRT (VALUE1*VALUE1 + VALUE2*VALUE2)
            RBUFF(J,IBUFF) = RBUFF(J,IBUFF) + VALUE3
            SBUFF(K,IBUFF) = SBUFF(K,IBUFF) + VALUE3 * VALUE3
            NBUFF(K,IBUFF) = NBUFF(K,IBUFF) + 1
            END IF
         IVIS = IVIS + LBVIS
 250     CONTINUE
C                                       other data types
                  ELSE
      DO 260 IV = 1,NOVIS
         IF ((ICOL1(IV).GE.1) .AND. (VBUFF(IVIS+2).GT.0.0)) THEN
C                                       time
            J = IBPTR(IBUFF)
            IF (ITYP.EQ.7) THEN
               IF (RBUFF(J,IBUFF).EQ.FBLANK) THEN
                  RBUFF(J,IBUFF) = 0.0
                  RBUFF(J+1,IBUFF) = 0.0
                  END IF
               RBUFF(J,IBUFF) = RBUFF(J,IBUFF) + 1.0
               RBUFF(J+1,IBUFF) = RBUFF(J+1,IBUFF) + VBUFF(IVIS-IVISO)
               END IF
C                                       data
            K = ICOL1(IV)
            J = J + (ICOL1(IV)-1) * COLMUL + COLUP
            IF (RBUFF(J,IBUFF).EQ.FBLANK) RBUFF(J,IBUFF) = 0.0
            RBUFF(J,IBUFF) = RBUFF(J,IBUFF) + VBUFF(IVIS)
            SBUFF(K,IBUFF) = SBUFF(K,IBUFF) + VBUFF(IVIS+1)
            NBUFF(K,IBUFF) = NBUFF(K,IBUFF) + 1
            END IF
         IVIS = IVIS + LBVIS
 260     CONTINUE
                     END IF
C                                       Second entry:
C                                       Loop over buffer
                  IF (DOTWO) THEN
                     IVIS = 5 + (IBUFF-1) * 3
                     IVISO = IVIS - 4
                     IF ((ITYP.EQ.0).OR.(ITYP.EQ.3).OR.(ITYP.EQ.4)) THEN
C                                       Amp (scalar avg) or rms
      DO 270 IV = 1,NOVIS
         IF ((ICOL2(IV).GE.1) .AND. (VBUFF(IVIS+2).GT.0.0)) THEN
            K = ICOL2(IV)
            J = IBPTR(IBUFF) + (ICOL2(IV)-1) * COLMUL + COLUP
            IF (RBUFF(J,IBUFF).EQ.FBLANK) RBUFF(J,IBUFF) = 0.0
            VALUE1 = VBUFF(IVIS)
            VALUE2 = VBUFF(IVIS+1)
            VALUE3 =  SQRT (VALUE1*VALUE1 + VALUE2*VALUE2)
            RBUFF(J,IBUFF) = RBUFF(J,IBUFF) + VALUE3
            SBUFF(K,IBUFF) = SBUFF(K,IBUFF) + VALUE3 * VALUE3
            NBUFF(K,IBUFF) = NBUFF(K,IBUFF) + 1
            END IF
         IVIS = IVIS + LBVIS
 270     CONTINUE
C                                       other data types
                  ELSE
      DO 280 IV = 1,NOVIS
         IF ((ICOL2(IV).GE.1) .AND. (VBUFF(IVIS+2).GT.0.0)) THEN
C                                       time
            J = IBPTR(IBUFF)
            IF (ITYP.EQ.7) THEN
               IF (RBUFF(J,IBUFF).EQ.FBLANK) THEN
                  RBUFF(J,IBUFF) = 0.0
                  RBUFF(J+1,IBUFF) = 0.0
                  END IF
               RBUFF(J,IBUFF) = RBUFF(J,IBUFF) + 1.0
               RBUFF(J+1,IBUFF) = RBUFF(J+1,IBUFF) + VBUFF(IVIS-IVISO)
               END IF
C                                       data
            K = ICOL2(IV)
            J = J + (ICOL2(IV)-1) * COLMUL + COLUP
            IF (RBUFF(J,IBUFF).EQ.FBLANK) RBUFF(J,IBUFF) = 0.0
            RBUFF(J,IBUFF) = RBUFF(J,IBUFF) + VBUFF(IVIS)
            SBUFF(K,IBUFF) = SBUFF(K,IBUFF) + VBUFF(IVIS+1)
            NBUFF(K,IBUFF) = NBUFF(K,IBUFF) + 1
            END IF
         IVIS = IVIS + LBVIS
 280     CONTINUE
                        END IF
                     END IF
 300              CONTINUE
C                                       Restore first record
 305              DO 310 IA = 1,LIMIT
                     VBUFF(4+IA) = VISSAV(IA)
 310                 CONTINUE
C                                       Get next vis buffer load
                  TIMEND = -1.0E20
                  NOVIS = 0
                  IVIS = 1
                  IF (LLSUN.GT.0) OLDSOU = LLSUN
                  IF (.NOT.ISEOF) GO TO 90
C                                       write rest of plane(s)
 450        IROW = CATIMG(KINAX+1)
            CALL GTBWRT (OLDSOU, MSOU, MTIMES, NCOL2, NCOLMX, IOBUF,
     *         ITYP, LUN, FIND, T, IROW, NROW, MUMBUF, RBUFF, SBUFF,
     *         NBUFF, IBPTR, RMAX, RMIN, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1230) IRET
               IRET = 4
               GO TO 990
               END IF
C                                       Close the uv I/O too
            CALL UVGET ('CLOS', RPARM, VBUFF, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1010) 'CLOSE INPUT UV', IRET
               GO TO 990
               END IF
C                                       End of channed loop
 480        CONTINUE
C                                       End of IF loop
 500     CONTINUE
C                                       Restore IF's to input values
      BIF = LBIF
      EIF = LEIF
      BCHAN = LBCHAN
      ECHAN = LECHAN
C                                       Close file(s)
      DO 520 I = 1,NUMBUF
         CALL ZCLOSE (LUN(I), FIND(I), JERR)
 520     CONTINUE
C                                       finish the header
      CALL COPY (256, CATIMG, CATBLK)
      CATR(KRDMX) = RMAX
      CATR(KRDMN) = RMIN
      CATD(KDCRV+1) = CATD(KDCRV+1) * 24.D0 * 3600.D0
      CATR(KRCIC+1) = CATR(KRCIC+1) * 24. * 3600.
      CALL CATIO ('UPDT', DISKOU, CNOOUT, CATBLK, 'REST', VBUFF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1520) IERR
         CALL MSGWRT (6)
         END IF
C                                       Summary messages
      WRITE (MSGTXT,1521) NPOINT
      CALL MSGWRT (4)
      WRITE (MSGTXT,1522) NFAIL
      CALL MSGWRT (4)
      WRITE (MSGTXT,1523) NANTSK
      CALL MSGWRT (4)
      IF (WASSOU) THEN
         MSGTXT = 'Some data were dropped to avoid averaging different'
     *      // ' sources!'
         CALL MSGWRT (4)
         END IF
      IF ((NPOINT.GT.0.0D0) .AND. (LNCFIL.GT.0)) FRW(LNCFIL) = 1
      IF (NPOINT.LE.0.0D0) IRET = 6
      GO TO 999
C                                       Error message print
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('GRIDTB: CALLED WITH NAXBUF =',I3,' > THE 8 SUPPORTED')
 1005 FORMAT ('GRIDTB: SORT ORDER ''',A2,''' NOT FULLY RECOGNIZED',
     *   ' - USE UVSRT')
 1010 FORMAT ('GRIDTB: UNABLE TO ',A,' FILE - ERROR',I5)
 1015 FORMAT ('GRIDTB: UNABLE TO READ ANTENNAS INFO - ERROR',2I5)
 1055 FORMAT ('GRIDTB: GRID REQUIRES',I5,' COLUMNS, ONLY',I5,
     *   ' AVAILABLE.')
 1070 FORMAT ('GRIDTB WARNING: using ECHAN',I5,' not input ECHAN',I5)
 1230 FORMAT ('GRIDTB: ERROR',I5,' FROM GTBWRT')
 1520 FORMAT ('ERROR',I5,' UPDATING THE CATALOG HEADER')
 1521 FORMAT ('Included',F13.0,' points in the grid')
 1522 FORMAT ('Dropped ',I12,'  points off the grid')
 1523 FORMAT ('Dropped ',I12,'  points due to antennas/baseline')
      END

LOCAL INCLUDE 'DQUAL.INC'
C                                       Local include for DQUAL
      INCLUDE 'INCS:ZPBUFSZ.INC'
      INCLUDE 'INCS:PUVD.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XNAMOU(3), XCLAOU(2)
      REAL      XSIN, XDISIN, XSOUT, XDISO, XCENT,
     *   BUFF1(UVBFSS), BUFF2(UVBFSS), DIFPIX
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, NUMHIS, JBUFSZ, ILOCWT,
     *   CATOLD(256), INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO, LRECI,
     *   LRECO, NRPRMI, NRPRMO, OUSU(1000), NSU, IBUFF1(UVBFSS),
     *   IBUFF2(UVBFSS), SCRTCH(512)
      LOGICAL   ISCOMP
      DOUBLE PRECISION UVSCAL
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6, HISCRD(10)*64
      EQUIVALENCE (IBUFF1, BUFF1), (IBUFF2, BUFF2)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XNAMOU, XCLAOU,
     *   XSOUT, XDISO, XCENT
      COMMON /DQUALP/ CATOLD, UVSCAL, SEQIN, SEQOUT, DISKIN, DISKO,
     *   NUMHIS, ILOCWT, INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO,
     *   LRECI, LRECO, NRPRMI, NRPRMO, ISCOMP, NSU, OUSU, DIFPIX
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT, HISCRD
      COMMON /BUFRS/ BUFF1, BUFF2, SCRTCH, JBUFSZ
C                                       End local include for DQUAL
LOCAL END
      PROGRAM DQUAL
C-----------------------------------------------------------------------
C! FUDGE clone - corrects SU table numbers, dropping QUAL
C# Utility UV UV-util VLA VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 2003, 2007-2008, 2012, 2014-2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   DQUAL is a FUDGE clone to drop QUAL numbers from a source list
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'DQUAL.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'DQUAL '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL FUDGIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL SENDUV (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL FUGHIS
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRTCH)
C
 999  STOP
      END
      SUBROUTINE FUDGIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   FUDGIN gets input parameters for DQUAL and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => cannot start
C   Output in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      INCLUDE 'DQUAL.INC'
      CHARACTER STAT*4, BLANK*6, PTYPE*2, SN(1000)*16
      INTEGER   OLDCNO, IROUND, NPARM, IERR, INCX, I, LUN1, LUN2, NUMIF,
     *   IS, ISMAX, ISURNO, VER, FREQID, SUKOLS(MAXSUC), SUNUMV(MAXSUC)
      LOGICAL   T
      DOUBLE PRECISION RAL(1000), DECL(1000)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA BLANK  /'      '/
      DATA T /.TRUE./
      DATA LUN1, LUN2 /26, 27/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      JBUFSZ = UVBFSS * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 15
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRTCH, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', IBUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1011) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
      IF (ISCOMP) THEN
C                                       Find weight and scale.
         CALL AXEFND (8, 'WEIGHT  ', CATBLK(KIPCN), CATH(KHPTP), ILOCWT,
     *      IERR)
         IF (IERR.NE.0) THEN
            MSGTXT = 'ERROR FINDING WEIGHT FOR COMPRESSED DATA'
            JERR = 9
            GO TO 990
            END IF
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
      IF (JLOCF.LT.0) XCENT = -1.
      IF (XCENT.LE.0.0) THEN
         UVSCAL = 1.0D0
         DIFPIX = 0.0
      ELSE
         INCX = CATBLK(KINAX+JLOCF) / 2 + 1
         DIFPIX = INCX - CATR(KRCRP+JLOCF)
         CATD(KDCRV+JLOCF) = CATD(KDCRV+JLOCF) + CATR(KRCIC+JLOCF) *
     *      DIFPIX
         CATR(KRCRP+JLOCF) = INCX
         UVSCAL = CATD(KDCRV+JLOCF) / FREQ
         END IF
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, SCRTCH, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1015) IERR
         GO TO 990
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
C                                       copy keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', SCRTCH, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 5
      SEQOUT = CATBLK(KIIMS)
C                                       Copy/edit source table
      VER = 1
      CALL SOUINI ('READ', IBUFF1, DISKIN, OLDCNO, VER, CATOLD, LUN1,
     *   NUMIF, VELTYP, VELDEF, FREQID, ISURNO, SUKOLS, SUNUMV, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR, 'OPEN READ'
         GO TO 990
         END IF
      CALL SOUINI ('WRIT', IBUFF2, DISKO, CCNO, VER, CATBLK, LUN2,
     *   NUMIF, VELTYP, VELDEF, FREQID, ISURNO, SUKOLS, SUNUMV, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR, 'OPEN WRITE'
         GO TO 990
         END IF
      ISMAX = IBUFF1(5)
      NSU = 0
      DO 100 IS = 1,ISMAX
         ISURNO = IS
         CALL TABSOU ('READ', IBUFF1, ISURNO, SUKOLS, SUNUMV, IDSOUR,
     *      SNAME, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA,
     *      PMDEC, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR, 'READ'
            GO TO 990
            END IF
C                                       match
         DO 50 I = 1,NSU
            IF ((SNAME.EQ.SN(I)) .AND. (ABS(RAEPO-RAL(I)).LT.1.D-5)
     *         .AND. (ABS(DECEPO-DECL(I)).LT.1.D-5)) THEN
               OUSU(IDSOUR) = I
               GO TO 100
               END IF
 50         CONTINUE
C                                       no match - new one
         NSU = NSU + 1
         SN(NSU) = SNAME
         RAL(NSU) = RAEPO
         DECL(NSU) = DECEPO
         OUSU(IDSOUR) = NSU
         ISURNO = NSU
         QUAL = 0
         CALL TABSOU ('WRIT', IBUFF2, ISURNO, SUKOLS, SUNUMV, NSU,
     *      SNAME, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO,
     *      EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA,
     *      PMDEC, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR, 'WRIT'
            GO TO 990
            END IF
 100     CONTINUE
      ISURNO = NSU
      CALL TABSOU ('CLOS', IBUFF2, ISURNO, SUKOLS, SUNUMV, NSU, SNAME,
     *   QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO, EPOCH, RAAPP,
     *   DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA, PMDEC, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR, 'CLOSE WRIT'
         GO TO 990
         END IF
      ISURNO = ISMAX
      CALL TABSOU ('CLOS', IBUFF1, ISURNO, SUKOLS, SUNUMV, IDSOUR,
     *   SNAME, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO, DECEPO, EPOCH,
     *   RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ, PMRA, PMDEC,
     *   IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1050) IERR, 'CLOSE READ'
         GO TO 990
         END IF
      WRITE (HISCRD(1),1100) ISMAX, NSU
      NUMHIS = 1
      JERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FUDGIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1010 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1011 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1015 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1050 FORMAT ('ERROR',I3,' ON SU TABLE ',A)
 1100 FORMAT ('/ Changed',I4,' sources into',I4,' all qual=0')
      END
      SUBROUTINE SENDUV (IRET)
C-----------------------------------------------------------------------
C   SENDUV sends uv data one point at a time to the user supplied
C   routine and then writes the modified data if requested.
C   Input in common:
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48, IFILE*48
      INTEGER   INIO, IPTRI, IPTRO, LUNI, LUNO, INDI, INDO, ILENBU,
     *   KBIND, NIOUT, NIOLIM, IBIND, I, IA1, IA2, INCX, BO, VO,
     *   NUMVIS, XCOUNT, NCORI, NCORO, NCOPY
      LOGICAL   T, F
      INCLUDE 'DQUAL.INC'
      REAL      BASEN, CBUFF(UVBFSS), RESULT(UVBFSS)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUNI, LUNO /16, 17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Dimension of complex axis
      INCX = CATBLK(KINAX)
      IF (ISCOMP) INCX = 3
C                                       Number of visibilities in input
C                                       and output files.
      NCORI = (LRECI - NRPRMI) / CATOLD(KINAX)
      NCORO = (LRECO - NRPRMO) / CATBLK(KINAX)
      NCOPY = LRECO - NRPRMO
C                                       Open and init for read
C                                       visibility file
      CALL ZPHFIL ('UV', DISKIN, FCNO(NCFILE), 1, IFILE, IRET)
      CALL ZOPEN (LUNI, INDI, DISKIN, IFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
C                                       Init vis file for read.
      ILENBU = 0
      CALL UVINIT ('READ', LUNI, INDI, NVIS, VO, LRECI, ILENBU, JBUFSZ,
     *   BUFF1, BO, IBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1030) IRET
         GO TO 990
         END IF
      NUMVIS = 0
      XCOUNT = 0
C                                       Loop
 100  CONTINUE
C                                       Read vis. record.
         CALL UVDISK ('READ', LUNI, INDI, BUFF1, INIO, IBIND, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1100) IRET
            GO TO 990
            END IF
         IPTRI = IBIND
C                                       Out of data?
         IF (INIO.LE.0) GO TO 200
C                                       Loop over buffer
         DO 190 I = 1,INIO
            IF (ILOCB.GE.0) THEN
               BASEN = BUFF1(IPTRI+ILOCB)
               IA1 = BASEN / 256. + 0.1
               IA2 = BASEN - IA1*256. + 0.1
            ELSE
               IA1 = BUFF1(IPTRI+ILOCA1) + 0.1
               IA2 = BUFF1(IPTRI+ILOCA2) + 0.1
               END IF
            BUFF1(IPTRI+ILOCU) = BUFF1(IPTRI+ILOCU) * UVSCAL
            BUFF1(IPTRI+ILOCV) = BUFF1(IPTRI+ILOCV) * UVSCAL
            BUFF1(IPTRI+ILOCW) = BUFF1(IPTRI+ILOCW) * UVSCAL
            NUMVIS = NUMVIS + 1
C                                       Call user routine.
C                                       Compressed data.
            IF (ISCOMP) THEN
               CALL ZUVXPN (NCORI, BUFF1(IPTRI+NRPRMI),
     *            BUFF1(IPTRI+ILOCWT), CBUFF)
               CALL DIDDLE (NUMVIS, CBUFF, BUFF1(IPTRI), INCX, RESULT,
     *            IRET)
C                                       Un compressed data
            ELSE
               CALL DIDDLE (NUMVIS, BUFF1(IPTRI+NRPRMI), BUFF1(IPTRI),
     *            INCX, RESULT, IRET)
               END IF
C                                       Branch on his return
C                                       Error (fatal)
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1120) IRET
               GO TO 990
C                                       Copy to output.
            ELSE IF (IRET.EQ.0) THEN
               XCOUNT = XCOUNT + 1.0D0
               CALL RCOPY (NRPRMO, BUFF1(IPTRI), BUFF2(IPTRO))
               IF (ISCOMP) THEN
C                                       Compressed
                  CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *               BUFF2(IPTRO+NRPRMO))
               ELSE
                  CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
                  END IF
               IPTRO = IPTRO + LRECO
               NIOUT = NIOUT + 1
               END IF
C                                       OK, but no output please
            IPTRI = IPTRI + LRECI
C                                       Write vis record.
            IF (NIOUT.GE.NIOLIM) THEN
               CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND,
     *            IRET)
               IF (IRET.NE.0) THEN
                  WRITE (MSGTXT,1150) IRET
                  GO TO 990
                  END IF
               IPTRO = KBIND
               NIOUT = 0
               END IF
 190        CONTINUE
C                                       Read next buffer.
         GO TO 100
C                                       Final call to DIDDLE.
 200     NUMVIS = -1
         CALL DIDDLE (NUMVIS, BUFF1, BUFF1, INCX, RESULT, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
            END IF
C                                       Finish write
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       Close files
      CALL ZCLOSE (LUNI, INDI, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SENDUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1010 FORMAT ('SENDUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('SENDUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1030 FORMAT ('SENDUV: ERROR',I3,' INIT-FOR-READ VIS FILE')
 1100 FORMAT ('SENDUV: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('SENDUV: DIDDLE ERROR',I3)
 1150 FORMAT ('SENDUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE FUGHIS
C-----------------------------------------------------------------------
C   FUGHIS copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER NOTTYP(1)*2, HILINE*72, LABEL*8
      INTEGER   LUN1, LUN2, IERR, I, NONOT
      LOGICAL   T
      INCLUDE 'DQUAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
      DATA NONOT, NOTTYP /1, 'SU'/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, FCNO(NCFILE),
     *   FCNO(NCFILE-1), CATBLK, BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any other history.
      IF (NUMHIS.LE.0) GO TO 200
         WRITE (LABEL,1010) TSKNAM
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN2, HILINE, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
      CALL ALLTAB (NONOT, NOTTYP, LUN1, LUN2, DISKIN, DISKO,
     *   FCNO(2), FCNO(1), CATBLK, IBUFF1, IBUFF2, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'FUGHIS: ERROR COPYING TABLES'
         CALL MSGWRT (6)
         END IF
C                                       rearrange source numbers
      CALL DSOUTA (LUN1, LUN2, DISKO, FCNO(1), OUSU, IBUFF1, IBUFF2,
     *   IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'FUGHIS: ERROR ADJUSTING SOURCE NUMBERS IN TABLES'
         CALL MSGWRT (6)
         END IF
C                                       correct for FQCENTER
      CALL CENTFQ (DISKO, FCNO(1), DIFPIX, IBUFF1, IBUFF2, IERR)
      IF (IERR.GT.0) THEN
         MSGTXT = 'FUGHIS: ERROR CORRECTING FQ TABLE'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, FCNO(NCFILE-1), CATBLK, 'REST',
     *   SCRTCH, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('FUGHIS: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,' /')
      END
      SUBROUTINE DIDDLE (NUMVIS, VIS, RPARM, INCX, RESULT, IRET)
C-----------------------------------------------------------------------
C   This is a skeleton version of subroutine DIDDLE which allows the
C   user to modify a UV data base.  Visibilities are sent one at a time
C   and when returned are written on the output file if so specified.
C
C   Up to 10 history entries can be written by using WRITE to
C   record up to 64 characters per entry into array HISCRD.  Format:
C          WRITE (HISCRD(entry #),format) history information
C   The history is written after the last call to DIDDLE.
C
C   Messages can be written to the monitor/logfile by WRITEing
C   the message (up to 80 char) into array MSGTXT in COMMON /MSGCOM/
C   and then issuing a call:
C            CALL MSGWRT (priority #)
C
C   Unit 1 is the line printer
C
C   If IRET > 0, then the output file will be destroyed iff
C   it was created in the current execution.
C
C   If the size of the vis record is to be changed, appropriate
C   modifications should be made to CATBLK in FUDGIN before the call
C   to UVCREA.  Pointers and increments are passed in the common to
C   interprete the structure of the input and output data records.
C   See the precursor comments for UVPGET for a description.
C
C   After all data has been processed a final call will be made to
C   DIDDLE with NUMVIS = -1.  This is to allow for the completion of
C   pending operations, i.e. preparation of HIstory cards.
C
C   LUN's 16 and 17 are open and not available to DIDDLE.
C
C   The current contents of CATBLK will be written back to the
C   catalog after the last call to DIDDLE.
C
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      RPARM   R(*) Random parameter array which includes U,V,W etc
C                   but also any other random parameters.
C      VIS     R(INCX,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                   NOTE: INCX may be any value .GE. 2
C   Inputs from COMMON:
C      NAME2      C*12    Name of the aux. file
C      CLAS2      C*6     Class of the aux. file.
C      SEQ2       I       Sequence number of the aux. file.
C      DISK2      I       Volumn number of the aux. file.
C      APARM(10)  R(10)   User array.
C      BPARM(10)  R(10)   User array.
C      BOX(4,10)  R(4,10) User array.
C      RA         D       Right ascension (1950) of phase center. (deg)
C      DEC        D       Declination (1950) of phase center. (deg)
C      FREQ       D       Frequency of observation (Hz)
C      NRPARM     I       # random parameters.
C      NCOR       I       # correlators
C      CATBLK     I(256)  Catalog header record. See Going Aips for
C                         details.
C      LRECI      I    Input file record length
C      NRPRMI     I    Input number of random parameters.
C      INCSI      I    Input Stokes' increment in vis.
C      INCFI      I    Input frequency increment in vis.
C      INCIFI     I    Input IF increment in vis.
C      LRECO      I    Output file record length
C      NRPRMO     I    Output number of random parameters.
C      INCSO      I    Output Stokes' increment in vis.
C      INCFO      I    Output frequency increment in vis.
C      INCIFO     I    Output IF increment in vis.
C   Output:
C      RPARM      R    Modified random parameter array.
C      RESULT  R(INCX,*) Output visibilities selected in frequency.
C      IRET       I    Return code  -1 => don't write
C                                    0 => OK
C                                   >0 => error, terminate.
C
C   Output in COMMON:
C      NUMHIS    I         # history entries (max. 10)
C      HISCRD    C(NUMHIS) History records
C      CATBLK    I         Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, INCX, IRET
      REAL      VIS(INCX,*), RPARM(*), RESULT(INCX,*)
C
      INTEGER   JIF, JF, JS, NIF, NF, NS, INDEXO, INDEXI, I, ISU
      INCLUDE 'DQUAL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
C-----------------------------------------------------------------------
      IRET = 0
      IF (NUMVIS.GT.0) THEN
         NS = 1
         NIF = 1
         NF = 1
         IF (JLOCS.GE.0) NS = CATBLK(KINAX+JLOCS)
         IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
         IF (JLOCF.GE.0) NF = CATBLK(KINAX+JLOCF)
C                                       change source number
         ISU = RPARM(1+ILOCSU) + 0.5
         RPARM(1+ILOCSU) = OUSU(ISU)
C                                       copy data
         DO 40 JIF = 1,NIF
            DO 30 JF = 1,NF
               DO 20 JS = 1,NS
                  INDEXI = (JIF-1) * INCIFI + (JF-1) * INCFI +
     *               (JS-1) * INCSI + 1
                  INDEXO = (JIF-1) * INCIFO + (JF-1) * INCFO +
     *               (JS-1) * INCSO + 1
                  DO 10 I = 1,INCX
                     RESULT(I,INDEXO) = VIS(I,INDEXI)
 10                  CONTINUE
 20               CONTINUE
 30            CONTINUE
 40         CONTINUE
C                                       last call - no vis
      ELSE
C
         END IF
C
 999  RETURN
      END
      SUBROUTINE DSOUTA (LUN1, LUN2, VOL, CNO, OUSU, BUFF1, BUFF2, IRET)
C-----------------------------------------------------------------------
C   DSOUTA re-writes tables correcting the source numbers if any.
C   Inputs:
C      LUN1     I        LUN for read
C      LUN2     I        LUN for write
C      VOL      I        Disk number
C      CNO      I        Catalog slot number
C      ousu     I(*)     Output source number (input source number)
C   Output:
C      BUFF1    I(512)   Work buffer
C      BUFF2    I(512)   Work buffer
C      IRET     I        Return error code  0 => ok
C                           1 => files the same, no copy.
C                           2 => no input files exist
C                           3 => failed
C                           4 => no output files created.
C                           5 => failed to update CATBLK
C-----------------------------------------------------------------------
      INTEGER   LUN1, LUN2, VOL, CNO, OUSU(*), BUFF1(*), BUFF2(*), IRET
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER SIDKEY(2)*24, TYPE*2
      REAL      RECR(XBPRSZ)
      DOUBLE PRECISION RECD(XBPRSZ/2)
      INTEGER   NVERS, NKEY, NREC, NCOL, DATP(128,2,2), IER, SOUKOL,
     *   RECORD(XBPRSZ), SUID, NRECIN, INREC, OUTREC, LOOP, INVER,
     *   OUTVER, ITYPE
      LOGICAL   T, F, TABLE, EXIST, FITASC, OPEN1, OPEN2
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DCAT.INC'
      EQUIVALENCE (RECORD, RECR, RECD)
      DATA SIDKEY /'SOURCE_ID ', 'SOURCE  '/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       loop over types
      DO 100 ITYPE = 1,KIEXTN
         CALL H2CHR (2, 1, CATH(KHEXT+ITYPE-1), TYPE)
         NVERS = CATBLK(KIVER+ITYPE-1)
         DO 90 INVER = 1,NVERS
            OPEN1 = F
            OPEN2 = F
            EXIST = .FALSE.
            IRET = 0
            IF ((TYPE.NE.'HI') .AND. (TYPE.NE.'PL') .AND. (TYPE.NE.'SL')
     *         .AND. (TYPE.NE.' ') .AND. (TYPE.NE.'SU')) CALL ISTAB
     *         (TYPE, VOL, CNO, INVER,LUN1, BUFF1, TABLE, EXIST, FITASC,
     *         IRET)
            IF ((IRET.EQ.0) .AND. (EXIST) .AND. (TABLE)) THEN
C                                       Open first (input) file
               CALL TABINI ('READ', TYPE, VOL, CNO, INVER, CATBLK, LUN1,
     *            NKEY, NREC, NCOL, DATP(1,1,1), BUFF1, IER)
C                                       If not there - quit
               IF (IER.GT.0) GO TO 90
               OPEN1 = T
C                                       Find source id column.
               CALL FNDCOL (1, SIDKEY(1), 10, T, BUFF1, SOUKOL, IER)
               IF (IER.NE.0) CALL FNDCOL (1, SIDKEY(2), 7, T, BUFF1,
     *            SOUKOL, IER)
C                                       quit if no source column
               IF (IER.EQ.0) THEN
C                                       Open second (output) file
                  OUTVER = INVER
                  CALL TABINI ('WRIT', TYPE, VOL, CNO, OUTVER, CATBLK,
     *               LUN2, NKEY, NREC, NCOL, DATP(1,1,2), BUFF2, IER)
                  IF (IER.GT.0) GO TO 80
                  OPEN2 = T
C                                       Get number of records in the
C                                       files.
                  NRECIN = BUFF1(5)
                  OUTREC = 1
C                                       Mark unsorted
                  IF ((ABS(BUFF2(43)).EQ.SOUKOL) .OR.
     *               (ABS(BUFF2(44)).EQ.SOUKOL)) THEN
                     BUFF2(43) = 0
                     BUFF2(44) = 0
                     END IF
C                                       translate to physical plaice in
C                                       record
                  SOUKOL = DATP(SOUKOL,1,1)
C                                       Copy
                  DO 40 LOOP = 1,NRECIN
                     INREC = LOOP
                     CALL TABIO ('READ', 0, INREC, RECORD, BUFF1, IER)
                     IF (IER.GT.0) THEN
                        WRITE (MSGTXT,1070) IER, 'READ', TYPE
                        GO TO 990
                        END IF
C                                       Source translate
                     SUID = RECORD(SOUKOL)
                     IF (SUID.GT.0) RECORD(SOUKOL) = OUSU(SUID)
                     CALL TABIO ('WRIT', 0, OUTREC, RECORD, BUFF2, IER)
                     IF (IER.GT.0) THEN
                        WRITE (MSGTXT,1070) IER, 'WRIT', TYPE
                        GO TO 990
                        END IF
                     OUTREC = OUTREC + 1
 40                  CONTINUE
                  END IF
C                                       Close tables.
 80            IF (OPEN1) THEN
                  CALL TABIO ('CLOS', 0, INREC, RECORD, BUFF1, IER)
                  IF (IER.GT.0) THEN
                     WRITE (MSGTXT,1070) IER, 'CLOS', TYPE
                     GO TO 990
                     END IF
                  END IF
               OPEN1 = F
               IF (OPEN2) THEN
                  CALL TABIO ('CLOS', 0, OUTREC, RECORD, BUFF2, IER)
                  IF (IER.GT.0) THEN
                     WRITE (MSGTXT,1070) IER, 'CLOS', TYPE
                     GO TO 990
                     END IF
                  END IF
               END IF
 90         CONTINUE
 100     CONTINUE
      IRET = 0
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
      IF (OPEN1) CALL TABIO ('CLOS', 0, INREC, RECORD, BUFF1, IER)
      IF (OPEN2) CALL TABIO ('CLOS', 0, OUTREC, RECORD, BUFF2, IER)
C
 999  RETURN
C-----------------------------------------------------------------------
 1070 FORMAT ('DSOUTA: ERROR ',I3,2X,A4,'ING ',A2,' TABLE')
      END

      SUBROUTINE DATCAL (IA1, IA2, ISUBA, ICORID, TIME, TMINT, VIS,
     *   DROP, IERR)
C-----------------------------------------------------------------------
C! Applies calibration to data
C# Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1999, 2007, 2009-2012, 2015, 2018, 2023-2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Applies calibration to data.
C   Inputs:
C      IA1    I      First antenna number
C      IA2    I      Second antenna number
C      ISUBA  I      Subarray number
C      ICORID I      Correlation id.
C      TIME   R      Time of record (days)
C      TMINT  R      Integration time for current vis. rec. (days)
C      VIS    R(*,*) Input visibility array (not yet converted to
C                    output form.
C   Inputs from common /SELCAL/:
C      DOCAL   L     If true do antenna calibration.
C      DOBL    L     If true do baseline calibration.
C      DOWTCL  L     If true calibrate weights.
C      CURCAL  R(*)  Current calibration information.
C                     Values in order:
C                     By antenna (NUMANT)
C                        By IF (EIF-BIF+1)
C                           By Polarization (NUMPOL)
C                               Real part, imaginary part,
C                               cos(delta), sin(delta), rate
C                     Where delta is the phase change between
C                     channels and rate is the fringe rate in
C                     radians/day
C      LCUCAL   I     Number of values in CURCAL per entry (5)
C      POLOFF   I(4,2)Offsets from the beginning of an IF entry in
C                     CURCAL for a given polarization.  The first
C                     dimension is the polarization pixel number and
C                     the second is the antenna number of a baseline
C                     (e.g. first or second = 1 or 2).
C      CALTIM   R(3)  Time of two cal. entries; third value is
C                     current lowest upper time
C      LCALTM    R    Time of current calibration.
C      BLFAC     R(*) Baseline dependent factors including GMMOD.
C                     Indexing scheme: an entry defined by ant1<ant2
C                     starts in element:
C         lentry * (((ant1-1)*numant-((ant1+1)*ant1)/2 + ant2) - 1) + 1
C                       where lentry = 2 * NUMPOL * (EIF-BIF+1)
C                       An entry contains the values in order:
C                       By IF (NUMIF)
C                          By Polarization (NUMPOL)
C                              Real part, imaginary part.
C                     Applied only to cross corelation data if DOBL
C      LAMBDA  R(*)   List of wavelengths (meters) for each channel
C                     and IF
C      NLAMDA  I      Number of entries in LAMBDA for each IF.
C     Output:
C      DROP    L      True if data all flagged.
C      IERR    I      Return code, 0=OK, else CGASET error number.
C     Output to common:
C      CNTREC  I(2,3) Record counts:
C                     (1&2,1) Previously flagged (partly, fully)
C                     (1&2,2) Flagged due to gains (part, full)
C                     (1&2,3) Good selected (part, full)
C-----------------------------------------------------------------------
      INTEGER   IA1, IA2, ISUBA, ICORID, IERR
      REAL      TIME, TMINT, VIS(*)
      LOGICAL   DROP
C
      INTEGER   INDXA1, INDXA2, ASIZE, IIF, IPOL, IFQ, INCPX, IOFF,
     *   JOFF, INDEX, JNDXA1, JNDXA2, BLNDX, LENTRY, BLPNT, MAXPOL,
     *   IDNDX, ITFILT, BLPINC, J1, J2
      LOGICAL   BADBL, SOMFLG, ALLFLG, SMPFLG, ALPFLG, ALLDED,
     *   SOMBAD, CCOR, DODERA, DOVLB, DODISP, BADDSP
      REAL      TVR, TVI, TVR1, GR, GI, DGR, DGI, PHASE, GRD, GID,
     *   CP, SP, GWT, CATUR(256), RATE, ARG, RFACT, DFACT, DPHAS, DELAYD
      DOUBLE PRECISION CATUD(128), DSFACT, DBITS
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PFLG.INC'
      INCLUDE 'INCS:DFLG.INC'
      EQUIVALENCE (CATUV, CATUR, CATUD)
C-----------------------------------------------------------------------
C                                       See if new time - update cal.
      IF (TIME.GT.LCALTM) THEN
         CALL CGASET (TIME, IERR)
         IF (IERR.NE.0) GO TO 999
         END IF
      BLPINC = 0
      IF (DOBL) BLPINC = 2
      IF (BCHANS.LE.0) BCHANS = BCHAN
      IF (ECHANS.LE.0) ECHANS = ECHAN
C                                       Set antenna indices
      ASIZE = NUMPOL * (EIF - BIF + 1) * LCUCAL
      JNDXA1 = (IA1 - 1) * ASIZE + 1
      JNDXA2 = (IA2 - 1) * ASIZE + 1
C                                       Set baseline index
      BLNDX = ((IA1-1)*NUMANT) - (((IA1-1)*IA1)/2) + IA2
      LENTRY = 2 * (EIF - BIF + 1) * NUMPOL
      BLPNT = 1
      IF (DOBL) BLPNT = LENTRY * (BLNDX-1) + 1
C                                       Check if cross correlation
      CCOR = IA1.NE.IA2
C                                       Init. flagged flags
      ALLFLG = .TRUE.
      ALLDED = .TRUE.
      ALPFLG = .TRUE.
      SOMFLG = .FALSE.
      SMPFLG = .FALSE.
C                                       Check if delay or rate
C                                       corrections.
      DODERA = .FALSE.
      DOVLB = .FALSE.
C                                       handle 1 solution for both pols
      MAXPOL = MAX (1, MIN (KNCOR, NUMPOL*NUMPOL))
      DO 25 IIF = BIF,EIF
         DO 20 IPOL = 1,MAXPOL
            INDXA1 = JNDXA1 + POLOFF(IPOL,1)
            INDXA2 = JNDXA2 + POLOFF(IPOL,2)
            IF (DOCAL) DOVLB = (CURCAL(INDXA1+2).NE.0.0) .OR.
     *         (CURCAL(INDXA1+3).NE.0.0) .OR.
     *         (CURCAL(INDXA2+2).NE.0.0) .OR.
     *         (CURCAL(INDXA2+3).NE.0.0)
            IF (DOVLB) DODERA = .TRUE.
 20         CONTINUE
         JNDXA1 = JNDXA1 + LCUCAL * NUMPOL
         JNDXA2 = JNDXA2 + LCUCAL * NUMPOL
 25      CONTINUE
C                                       DODERA is now true if there are
C                                       non-zero delay corrections for
C                                       any selected polarization in
C                                       any selected IF.
      DODISP = (DDELAY(1,IA1).NE.0.0) .OR. (DDELAY(1,IA2).NE.0.0) .OR.
     *   (DDELAY(2,IA1).NE.0.0) .OR. (DDELAY(2,IA2).NE.0.0)
C                                       DODISP is now true if either
C                                       dispersive delay is not zero
      BADDSP = (DDELAY(1,IA1).EQ.FBLANK) .OR. (DDELAY(1,IA2).EQ.FBLANK)
     *   .OR. (DDELAY(2,IA1).EQ.FBLANK) .OR. (DDELAY(2,IA2).EQ.FBLANK)
C                                       BADDSP is now true if either
C                                       dispersive delay is blanked
C
C                                       Reset antenna indices
      JNDXA1 = (IA1 - 1) * ASIZE + 1
      JNDXA2 = (IA2 - 1) * ASIZE + 1
C                                       Set visibility increment
      INCPX = CATUV(KINAX)
C                                       Compressed data expanded
      IF (INCPX.EQ.1) INCPX = 3
C                                       Loop thru IF
      DO 300 IIF = BIF,EIF
         IOFF = (IIF-1) * KNCIF
C                                       Loop thru polarization
         J1 = 0
         J2 = 0
         DO 200 IPOL = 1,KNCOR
            J1 = J1 + 1
            J2 = J2 + 1
            IF (IPOL.EQ.3) THEN
               J1 = 1
               J2 = 2
            ELSE IF (IPOL.EQ.4) THEN
               J1 = 2
               J2 = 1
               END IF
C                                       Check baseline flags
            BADBL = (DOBL) .AND. (BLFAC(BLPNT).EQ.FBLANK) .AND.
     *         (IPOL.LE.2) .AND. (CCOR)
            JOFF = IOFF + (IPOL-1) * KNCS
C                                       Handle 1 Solution for 2 polzns.
            INDXA1 = JNDXA1 + POLOFF(MIN(IPOL,MAXPOL),1)
            INDXA2 = JNDXA2 + POLOFF(MIN(IPOL,MAXPOL),2)
            GR = 1.0
            GI = 0.0
            DGR = 1.0
            DGI = 0.0
            GWT = 0.0
            DELAYD = 0.0
            IF (BADBL) GO TO 60
C                                       Check if baseline only wanted.
            IF (DOCAL) THEN
C                                       Check IF flags
               IF ((CURCAL(INDXA1).EQ.FBLANK) .OR.
     *             (CURCAL(INDXA2).EQ.FBLANK)) GO TO 60
C                                       Set gains
               GR = CURCAL(INDXA1) * CURCAL(INDXA2) +
     *            CURCAL(INDXA1+1) * CURCAL(INDXA2+1)
               GI = CURCAL(INDXA2) * CURCAL(INDXA1+1) -
     *            CURCAL(INDXA1) * CURCAL(INDXA2+1)
               END IF
C                                       Baseline calibration for
C                                       first two poln. only.
            IF ((DOBL) .AND. (IPOL.LE.2) .AND. (CCOR)) THEN
               TVR = GR
               GR = GR * BLFAC(BLPNT) + GI * BLFAC(BLPNT+1)
               GI = GI * BLFAC(BLPNT) - TVR * BLFAC(BLPNT+1)
               END IF
C                                       "Weight" calibration
            IF (DOWTCL) THEN
               GWT = (GR*GR + GI*GI)
               IF (GWT.GT.1.0E-10) GWT = 1.0 / GWT
            ELSE
               GWT = 1.0
               END IF
C                                       See if delay-rate corrections
C                                       wanted.
            IF (DODERA) THEN
C                                       Delay correction
               DELAYD = CURCAL(INDXA1+2) - CURCAL(INDXA2+2)
C               DGR = CURCAL(INDXA1+2) * CURCAL(INDXA2+2) +
C     *            CURCAL(INDXA1+3) * CURCAL(INDXA2+3)
C               DGI = CURCAL(INDXA2+2) * CURCAL(INDXA1+3) -
C     *            CURCAL(INDXA1+2) * CURCAL(INDXA2+3)
               DGR = COS (DELAYD)
               DGI = SIN (DELAYD)
C                                       Apply fringe rate
               RATE = CURCAL(INDXA1+3) - CURCAL(INDXA2+3)
               PHASE = RATE * (TIME - LCALTM)
C                                       Apply decorrelation
C                                       corrections as applicable
               IDNDX = (ICORID - 1) * MAXIF + IIF
               ARG = 0.5 * ATAN2 (DGI, DGR)
C                                       EVLA/VLBA-only corrections
               IF ((DODSM(IDNDX)) .AND. (ICQVBA(ISUBA).GE.1)) THEN
C                                       Spectral averaging correction
                  IF ((ABS (ARG).GT.1.0E-5).AND.
     *               (NXDSM(IDNDX).GT.1)) THEN
                     DFACT = NXDSM(IDNDX) * SIN (ARG / NXDSM(IDNDX)) /
     *                  SIN (ARG)
                     DFACT = ABS (DFACT)
                     GR = GR * DFACT
                     GI = GI * DFACT
                     END IF
C                                       Segmentation loss correction
C                                       Compute residual delay in bits
                  DBITS = (2.0 * ARG) / (DELFAC(IIF) * DBTVBA(IDNDX))
C                                       Segmentation loss
                  CALL FXSEG (LTPVBA(IDNDX), NFTVBA(IDNDX), DBITS,
     *               DSFACT, IERR)
                  IF (IERR.NE.0) DSFACT = 1.0D0
                  IF (DSFACT.LE.0.0D0) DSFACT = 1.0D0
C                                       not EVLA
                  IF (ICQVBA(ISUBA).GT.1) DSFACT = 1.0D0
                  IERR = 0
C                                       Correct gain factors
                  GR = GR / DSFACT
                  GI = GI / DSFACT
C                                       Spectral averaging correction
C                                       all other cases
C                                       needed only when averaging post
C                                       correlation - dont have now
C              ELSE IF (ABS (SIN (ARG)).GT.1.0E-5) THEN
C                 DFACT = ARG / SIN (ARG)
C                 DFACT = ABS (DFACT)
C                 GR = GR * DFACT
C                 GI = GI * DFACT
                  END IF
C                                       Compute rate smearing
C                                       correction (includes
C                                       the VLBA OVLB filters)
               IF (DORSM) THEN
C                                       Default is boxcar smoothing
                  ITFILT = 0
C                                       Check if VLBA filter used
                  IF (DODSM(IDNDX).AND.(ICQVBA(ISUBA).EQ.1)) THEN
                     ITFILT = ITFVBA(IDNDX)
                     END IF
C                                       Compute loss factor
                  CALL TFILTR (ITFILT, RATE, TMINT, RFACT, IERR)
                  IF (IERR.NE.0) GO TO 999
                  GR = GR * RFACT
                  GI = GI * RFACT
                  END IF
C                                       Caution if VLBA corrections
C                                       not possible due to missing CQ
C                                       table or CQ table entries
               IF ((ICQVBA(ISUBA).GE.1) .AND. (.NOT.DODSM(IDNDX)).AND.
     *            (WRNVBA(ISUBA)) .AND.
     *            ((ABS(ARG).GT.0.0) .OR. (ABS(RATE).GT.0.0))) THEN
                  WRITE (MSGTXT,1030) ISUBA
                  CALL MSGWRT (8)
                  WRITE (MSGTXT,1035)
                  CALL MSGWRT (8)
                  WRITE (MSGTXT,1040)
                  CALL MSGWRT (8)
C                                       Only print warning once
                  WRNVBA(ISUBA) = .FALSE.
                  END IF
C                                       Correct for frequency offset.
               IF ((BCHANS.GT.1) .OR. (ABS (CATUR(KRCRP+KLOCFY) - 1.0)
     *            .GT. 0.0001)) THEN
                  DPHAS = DELAYD * (BCHANS-CATUR(KRCRP+KLOCFY))
                  PHASE = PHASE + DPHAS
                  END IF
               CP = COS (PHASE)
               SP = SIN (PHASE)
               TVR = GR * CP - GI * SP
               TVI = GR * SP + GI * CP
               GR = TVR
               GI = TVI
               END IF
   60       CONTINUE
C                                       Loop thru channel.
            DO 80 IFQ = BCHANS,ECHANS
               INDEX = (JOFF + (IFQ-1) * KNCF) * INCPX + 1
               TVR = GR * VIS(INDEX) + GI * VIS(INDEX+1)
               TVI = GR * VIS(INDEX+1) - GI * VIS(INDEX)
C                                       Apply dispersive delay
C                                       correction or kill data point
C                                       dispersive delay is blanked
               IF (DODISP) THEN
                  IF (BADDSP) THEN
                     GWT = 0.0
                  ELSE
                     PHASE = LAMBDA(NLAMDA * (IIF - 1) + IFQ)
     *                       * (DDELAY(J1,IA1) - DDELAY(J2,IA2))
                     GRD = COS (PHASE)
                     GID = SIN (PHASE)
                     TVR1 = TVR
                     TVR = GRD * TVR1 + GID * TVI
                     TVI = GRD * TVI - GID * TVR1
                     END IF
                  END IF
               SMPFLG = SMPFLG .OR. (VIS(INDEX+2) .LE. 0.0)
               ALPFLG = ALPFLG .AND. (VIS(INDEX+2) .LE. 0.0)
               SOMFLG = SOMFLG .OR. (GWT .LE. 0.0)
               ALLFLG = ALLFLG .AND. (GWT .LE. 0.0)
               ALLDED = ALLDED .AND. ((VIS(INDEX+2) .LE. 0.0)
     *                                .OR. (GWT .LE. 0.0))
               VIS(INDEX) = TVR
               VIS(INDEX+1) = TVI
               VIS(INDEX+2) = VIS(INDEX+2) * GWT
C                                       Rotate phase for next if we have
C                                       delay corrections
               IF (DODERA) THEN
                  TVR = (GR * DGR - GI * DGI)
                  TVI = (GR * DGI + GI * DGR)
                  GR = TVR
                  GI = TVI
               END IF
   80       CONTINUE
C                                       Handle 1 solution and 2 polzn
            IF (IPOL.EQ.1.AND.NUMPOL.GT.1) BLPNT = BLPNT + BLPINC
  200    CONTINUE
C                                       Setup for next IF
         JNDXA1 = JNDXA1 + LCUCAL * NUMPOL
         JNDXA2 = JNDXA2 + LCUCAL * NUMPOL
         BLPNT = BLPNT + BLPINC
 300     CONTINUE
C                                       Increment counts of the
C                                       good, bad and the ugly.
      SOMFLG = SOMFLG .AND. (.NOT.ALLFLG)
      SMPFLG = SMPFLG .AND. (.NOT.ALPFLG)
      SOMBAD = (SOMFLG.OR.SMPFLG) .AND. (.NOT.ALLDED)
      IF (SMPFLG) CNTREC(1,1) = CNTREC(1,1) + 1
      IF (SOMFLG) CNTREC(1,2) = CNTREC(1,2) + 1
      IF (SOMBAD) CNTREC(1,3) = CNTREC(1,3) + 1
      IF (ALPFLG) CNTREC(2,1) = CNTREC(2,1) + 1
      IF (ALLFLG) CNTREC(2,2) = CNTREC(2,2) + 1
      IF ((.NOT.ALLDED) .AND. (.NOT.SOMBAD))
     *   CNTREC(2,3) = CNTREC(2,3) + 1
      DROP = ALLDED
      GO TO 999
C
 999  RETURN
C----------------------------------------------------------------------
1030  FORMAT ('** WARNING - Subarray',I4,' contains VLBA/EVLA data,',
     *   ' but there is')
1035  FORMAT ('** a problem with the CQ table.  No decorrelation',
     *   ' corrections')
1040  FORMAT ('** will be implimented.  See EXPLAIN FITLD for',
     *   ' more information.')
      END

      SUBROUTINE TABFO (OPCODE, BUFFER, IFORNO, FOKOLS, FONUMV, TIME,
     *   TIMEI, SOURID, ANTNO, SUBA, FREQID, DOPOFF, IERR)
C-----------------------------------------------------------------------
C! Does I/O to frequency offset (FO) table opened by FOINI
C# EXT-util UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 2009
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Does I/O to frequency offset extension tables. Used after setup
C   by FOINI.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                          'READ' = read entry from table.
C                          'WRIT' = write entry in table.
C                          'CLOS' = close file, flush on write
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                           file if open. Should have been returned by
C                           TABINI or CALINI.
C      IFORNO   I        Next scan number to read or write.
C      FOKOLS   I(7)     The column pointer array in order defined by
C                          the parameters in PCLTAB.INC.
C      FONUMV   I(7)     Element count in each column.
C   Input/output: (written to or read from CAL file)
C      TIME     D        Center time of FO record (Days)
C      TIMEI    R        Time interval covered by record (days)
C      SOURID   I        Source ID as defined in the SoUrce table.
C      ANTNO    I        Antenna number as defined in Antenna table
C      SUBA     I        Subarray number.
C      FREQID   I        Freqid # as defined in FQ table.
C      DOPOFF   R(*)     Doppler offset for each IF (Hz)
C    Output:
C      IFORNO   I        Next CAL number.
C      IERR     I        Error code, 0=>OK else TABIO error.
C                           Note: -1=> read but record deselected.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   MAXFOC, XFORSZ
      PARAMETER (MAXFOC = 7)
      PARAMETER (XFORSZ = 7 + MAXIF)
C
      CHARACTER OPCODE*4
      DOUBLE PRECISION TIME
      REAL      TIMEI, DOPOFF(MAXIF)
      INTEGER   BUFFER(512), FOKOLS(MAXFOC), FONUMV(MAXFOC), SOURID,
     *   ANTNO, SUBA, FREQID, IFORNO, IERR
C
      INTEGER   RECI(XFORSZ)
      LOGICAL   DOREAD, DOCLOS
      REAL      RECORD(XFORSZ)
      DOUBLE PRECISION RECD(XFORSZ/2)
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (RECD, RECORD, RECI)
      DATA RECORD /XFORSZ*0.0D0/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
      DOCLOS = OPCODE.EQ.'CLOS'
C                                       Branch for CLOS
      IF (DOCLOS) GO TO 800
C                                       If write fill RECORD
      IF (.NOT.DOREAD) THEN
         RECD(FOKOLS(1)) = TIME
         RECORD(FOKOLS(2)) = TIMEI
         RECI(FOKOLS(3)) = SOURID
         RECI(FOKOLS(4)) = ANTNO
         RECI(FOKOLS(5)) = SUBA
         IF (FOKOLS(6).GT.0) RECI(FOKOLS(6)) = FREQID
         CALL RCOPY (FONUMV(7), DOPOFF, RECORD(FOKOLS(7)))
         END IF
C                                       Process record.
 50   CALL TABIO (OPCODE, 0, IFORNO, RECORD, BUFFER, IERR)
      IFORNO = IFORNO + 1
      IF (IERR.GT.0) GO TO 990
C                                       If READ pick data from RECORD.
      IF (DOREAD) THEN
         TIME = RECD(FOKOLS(1))
         TIMEI = RECORD(FOKOLS(2))
         SOURID = RECI(FOKOLS(3))
         ANTNO = RECI(FOKOLS(4))
         SUBA = RECI(FOKOLS(5))
         FREQID = -1
         IF (FOKOLS(6).GT.0) FREQID = RECI(FOKOLS(6))
         CALL RCOPY (FONUMV(7), RECORD(FOKOLS(7)), DOPOFF)
         END IF
      GO TO 999
C                                       Close
 800  CALL TABIO ('CLOS', 0, IFORNO, RECORD, BUFFER, IERR)
      IF (IERR.GT.0) GO TO 990
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1800) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1800 FORMAT ('TABFO: TABIO ERROR',I3)
      END

LOCAL INCLUDE 'XLATE.INC'
C                                       Local include for XLATE
C                                       /CHRCOM/ variable declarations
C                                       and definition.
      CHARACTER NAMIN*128, NAMLIS*10, NAMOUT*128, NAMLOG*128,
     *   NAMERR*128, NAMND*128, NAMMOD*16, PGNAME*10, PGTYPE*4,
     *   CXUNIT*8, LININ*80, LINOUT*80
      COMMON /CHRCOM/ NAMIN, NAMLIS, NAMOUT, NAMLOG, NAMERR, NAMND,
     *   NAMMOD, PGNAME, PGTYPE, CXUNIT, LININ, LINOUT
C                                       /OTHCOM/ variable declarations
C                                       and definition.
      INTEGER   LUNIN, LUNLIS, LUNOUT, LUNLOG, LUNERR, LUNND
      LOGICAL   DEBUG, VERBO
      COMMON /OTHCOM/ LUNIN, LUNLIS, LUNOUT, LUNLOG, LUNERR, LUNND,
     *   DEBUG, VERBO
LOCAL END
      PROGRAM XLATE
C-----------------------------------------------------------------------
C! stand-alone, list driven AIPS source code translation program
C# Service
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   XLATE should be portable between operating systems given the
C   following requirements:
C
C   1) must be run from the directory in which the files to be processed
C      reside (the list of files to drive the program must also reside
C      there and must be called XLATE.LIS)
C
C   2) under VMS, the OPEN statement for the translated (i.e., output)
C      source code file should use the non-ANSI standard parameter
C      and keyword CARRIAGECONTROL='LIST' which is desirable (if
C      not absolutely required).
C
C   3) under VMS, the OPEN statement for the input files (i.e., file
C      name list and input source code) should use the non-ANSI standard
C      parameter READONLY which is desirable (if not absolutely
C      required).
C
C   It produces three (3) listings:
C
C      XLATE.LOG which contains all translations performed on the code
C                displaying the untranslated line followed by the
C                translated line
C
C      XLATE.ND  which contains all lines of code involving questionable
C                ENCODE statement translations and all DECODE statement
C                translations which may required further attention to
C                complete the conversion to their equivalent internal
C                WRITEs or READs
C
C      XLATE.ERR all cases of code that may require manual conversion
C                (i.e., suspected pseudo I*4 code) or that has been
C                detected or is suspected as non-ANSI standard (e.g.,
C                non-standard intrinsic functions)
C-----------------------------------------------------------------------
      INCLUDE 'XLATE.INC'
      INTEGER   IDEBUG, IVERBO, IOSVAL, IEXT, I, J, K, LNB, VERIFY
      LOGICAL   EXISTS
      CHARACTER LINTMP*80
C-----------------------------------------------------------------------
C                                       Initialize COMMON variables.
C
C                                       Current XLATE program unit.
      CXUNIT = 'XLATE'
C                                       Debug and/or verbose modes?
      DEBUG = .FALSE.
      VERBO = .FALSE.
      WRITE (6,*) 'ENTER MODES (DEBUG,VERBOSE) (I1,I1):'
      READ (5,'(I1,I1)') IDEBUG, IVERBO
      IF (IDEBUG.EQ.1) DEBUG = .TRUE.
      IF (IVERBO.EQ.1) VERBO = .TRUE.
C                                       Logical unit number for input
C                                       source code module (file names
C                                       read from list of source code
C                                       modules).
      LUNIN = 10
C                                       Logical unit number for list of
C                                       source code modules.
      LUNLIS = 11
C                                       File name containing list of
C                                       source code modules.
      NAMLIS = 'XLATE.LIS'
C                                       Logical unit number for output
C                                       source code module (file name
C                                       formed from input file name,
C                                       i.e., same but with extension
C                                       '.XXX').
      LUNOUT = 12
C                                       Logical unit number for master
C                                       log file.
      LUNLOG = 13
C                                       File name of master log file.
      NAMLOG = 'XLATE.LOG'
C                                       Logical unit number for error
C                                       file.
      LUNERR = 14
C                                       File name of error file.
      NAMERR = 'XLATE.ERR'
C                                       Logical unit number for special
C                                       ENCODE/DECODE log file.
      LUNND = 15
C                                       File name of special
C                                       ENCODE/DECODE log file.
      NAMND = 'XLATE.ND'
C                                       Open list of source code
C                                       modules.
      INQUIRE (FILE=NAMLIS, EXIST=EXISTS)
C                                       Does it exist?
      IF (.NOT.EXISTS) THEN
         WRITE (6,*) 'FILE ',NAMLIS,' NOT FOUND'
         GO TO 999
      ELSE
         OPEN (UNIT=LUNLIS, FILE=NAMLIS, STATUS='OLD', IOSTAT=IOSVAL)
         IF (IOSVAL.NE.0) THEN
            WRITE (6,*) 'FORTRAN OPEN ERROR = ',IOSVAL,
     *         ' ON FILE LIST = ',NAMLIS
            GO TO 999
            END IF
         END IF
C                                       Rewind file list.
      REWIND (LUNLIS)
C                                       Open master log file.
      INQUIRE (FILE=NAMLOG, EXIST=EXISTS)
C                                       Does it exist?
      IF (EXISTS) THEN
         WRITE (6,*) 'FILE ',NAMLOG,' ALREADY EXISTS'
         GO TO 999
      ELSE
         OPEN (UNIT=LUNLOG, FILE=NAMLOG, STATUS='NEW', IOSTAT=IOSVAL)
         IF (IOSVAL.NE.0) THEN
            WRITE (6,*) 'FORTRAN OPEN ERROR = ',IOSVAL,
     *         ' ON MASTER LOG FILE = ',NAMLOG
            GO TO 999
            END IF
         END IF
C                                       Rewind master log file.
      REWIND (LUNLOG)
C                                       Open error file.
      INQUIRE (FILE=NAMERR, EXIST=EXISTS)
C                                       Does it exist?
      IF (EXISTS) THEN
         WRITE (6,*) 'FILE ',NAMERR,' ALREADY EXISTS'
         GO TO 999
      ELSE
         OPEN (UNIT=LUNERR, FILE=NAMERR, STATUS='NEW', IOSTAT=IOSVAL)
         IF (IOSVAL.NE.0) THEN
            WRITE (6,*) 'FORTRAN OPEN ERROR = ',IOSVAL,
     *         ' ON ERROR FILE = ',NAMERR
            GO TO 999
            END IF
         END IF
C                                       Rewind error list.
      REWIND (LUNERR)
C                                       Open special ENCODE/DECODE log
C                                       file.
      INQUIRE (FILE=NAMND, EXIST=EXISTS)
C                                       Does it exist?
      IF (EXISTS) THEN
         WRITE (6,*) 'FILE ',NAMND,' ALREADY EXISTS'
         GO TO 999
      ELSE
         OPEN (UNIT=LUNND, FILE=NAMND, STATUS='NEW', IOSTAT=IOSVAL)
         IF (IOSVAL.NE.0) THEN
            WRITE (6,*) 'FORTRAN OPEN ERROR = ',IOSVAL,
     *         ' ON SPECIAL ENCODE/DECODE LOG FILE = ',NAMND
            GO TO 999
            END IF
         END IF
C                                       Rewind ENCODE/DECODE log file.
      REWIND (LUNND)
C                                       Process modules one at a time.
 10   READ (LUNLIS,'(A)',IOSTAT=IOSVAL) NAMIN
C                                       READ error?
      IF (IOSVAL.EQ.0) GO TO 20
C                                       EOF?
         IF (IOSVAL.LT.0) GO TO 900
C                                       Other error.
            WRITE (6,*) 'FORTRAN READ ERROR = ',IOSVAL,' ON FILE = ',
     *         NAMLIS
            GO TO 900
C                                       Find '.FOR' or '.INC' file name
C                                       extension.
 20   IEXT = INDEX (NAMIN, '.FOR')
      IF (IEXT.GT.0) GO TO 30
C                                       Try '.INC'.
         IEXT = INDEX (NAMIN, '.INC')
         IF (IEXT.GT.0) THEN
            PGTYPE = 'INCL'
            GO TO 30
            END IF
C                                       Valid extension not found.
C                                       Skip it.
         WRITE (6,*) 'SKIPPING FILE NAME = ',NAMIN(1:LNB (NAMIN))
C                                       Get another input source code
C                                       module file name.
         GO TO 10
C                                       OPEN input source code module.
 30   OPEN (UNIT=LUNIN, FILE=NAMIN, STATUS='OLD', IOSTAT=IOSVAL)
C                                       OPEN error?
      IF (IOSVAL.NE.0) THEN
         WRITE (6,*) 'FORTRAN OPEN ERROR = ',IOSVAL
         WRITE (6,*) 'ON INPUT FILE = ',NAMIN(1:LNB (NAMIN))
         GO TO 900
         END IF
C                                       Rewind input source code module.
      REWIND (LUNIN)
      WRITE (6,*) ' PROCESSING ', NAMIN(1:LNB (NAMIN))
C                                       Extract simple file name for
C                                       use in listings.
C      J = LNB (NAMIN)
C      I = IEXT - 1
C 31   I = I - 1
C      IF (I.EQ.0) GO TO 32
C      IF (VERIFY (NAMIN(I:I),
C         'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789').EQ.0) GO TO 31
C 32   IF (I.EQ.0) I = 1
C      NAMMOD = NAMIN(I:J)
      NAMMOD = NAMIN
C                                       Form output source code module
C                                       name from input name.
      NAMOUT = NAMIN(1:IEXT) // 'XXX'
C                                       OPEN output source code module.
      OPEN (UNIT=LUNOUT, FILE=NAMOUT, STATUS='UNKNOWN',
     *   IOSTAT=IOSVAL)
C                                       VMS peculiarity.
C     *   CARRIAGECONTROL='LIST', IOSTAT=IOSVAL)
C                                       OPEN error?
      IF (IOSVAL.NE.0) THEN
         WRITE (6,*) 'FORTRAN OPEN ERROR = ',IOSVAL
         WRITE (6,*) 'ON OUTPUT FILE = ',NAMOUT(1:LNB (NAMOUT))
         GO TO 900
         END IF
C                                       Rewind output source code
C                                       module.
      REWIND (LUNOUT)
C                                       Process one line at a time.
 40   READ (LUNIN,'(A)',IOSTAT=IOSVAL) LININ
C                                       READ error?
      IF (IOSVAL.EQ.0) GO TO 50
C                                       EOF?
         IF (IOSVAL.LT.0) GO TO 800
C                                       Other error.
            WRITE (6,*) 'FORTRAN READ ERROR = ',IOSVAL
            WRITE (6,*) ' ON FILE = ',NAMIN(1:LNB (NAMIN))
            GO TO 800
C                                       Process line.
 50   LINOUT = LININ
C                                       Check for begining of a new
C                                       program unit.
      IF ((INDEX (LINOUT, '      PROGRAM ').GT.0) .OR.
     *   (INDEX (LINOUT, '      SUBROUTINE ').GT.0) .OR.
     *   (INDEX (LINOUT, ' FUNCTION ').GT.0)) THEN
         CALL PGUNIT
         GO TO 90
         END IF
C                                       Comment?
      IF (LINOUT(1:1).EQ.'C') THEN
         CALL COMENT
         GO TO 90
         END IF
C                                       Check INCLUDE statements for
C                                       possible elmination.
      I = LNB (LINOUT)
      IF ((INDEX (LINOUT, '      INCLUDE ').GT.0) .AND.
     *   (LINOUT(I:I).EQ.'''')) THEN
         CALL INCLUD
         GO TO 90
         END IF
C                                       TYPE*N type declaration?
      IF ((INDEX (LINOUT, '      INTEGER*').GT.0) .OR.
     *   (INDEX (LINOUT, '      REAL*').GT.0) .OR.
     *   (INDEX (LINOUT, '      LOGICAL*').GT.0) .OR.
     *   (INDEX (LINOUT, '      BYTE ').GT.0)) THEN
         CALL DECLAR
         END IF
C                                       If this program unit is the
C                                       main program, check for and
C                                       eliminate any declaration of
C                                       the array FTAB, which is now
C                                       declared and dimensioned in
C                                       DDCH.INC.
      IF ((PGTYPE.EQ.'PROG') .AND. (INDEX (LINOUT, 'FTAB(').GT.0))
     *   CALL DEFTAB
C                                       ENCODE or DECODE statement?
      IF ((INDEX (LINOUT, ' ENCODE').GT.0) .OR.
     *   (INDEX (LINOUT, ' DECODE').GT.0)) THEN
         CALL NDCODE
         GO TO 90
         END IF
C                                       NWDPLI used in call to COPY?
      IF ((INDEX (LINOUT, 'NWDPLI').GT.0) .AND.
     *   (INDEX (LINOUT, 'CALL COPY').GT.0)) THEN
         CALL NWDPLI
         GO TO 90
         END IF
C                                       Check for use of non-generic
C                                       intrinsic functions (expensive).
      IF ((INDEX (LINOUT, 'ABS').GT.0) .OR.
     *   (INDEX (LINOUT, 'COS').GT.0) .OR.
     *   (INDEX (LINOUT, 'EXP').GT.0) .OR.
     *   (INDEX (LINOUT, 'FLOAT').GT.0) .OR.
     *   (INDEX (LINOUT, 'INT').GT.0) .OR.
     *   (INDEX (LINOUT, 'FIX').GT.0) .OR.
     *   (INDEX (LINOUT, 'LOG').GT.0) .OR.
     *   (INDEX (LINOUT, 'MAX').GT.0) .OR.
     *   (INDEX (LINOUT, 'MIN').GT.0) .OR.
     *   (INDEX (LINOUT, 'MOD').GT.0) .OR.
     *   (INDEX (LINOUT, 'SIGN').GT.0) .OR.
     *   (INDEX (LINOUT, 'SIN').GT.0) .OR.
     *   (INDEX (LINOUT, 'SQRT').GT.0) .OR.
     *   (INDEX (LINOUT, 'TAN').GT.0)) CALL NONGEN
C                                       Check for CALLs for calls
C                                       to pseudo I*4 routines.
      IF (INDEX (LINOUT, ' CALL ').GT.0) CALL P4CALL
C                                       Check for other things.
      CALL OTHER
C                                       Reset XLATE program unit name.
 90   CXUNIT = 'XLATE'
C                                       Get output line length (i.e.,
C                                       position of last non-blank).
      I = LNB (LINOUT)
C                                       If not totally blank, write the
C                                       processed line to the output
C                                       output source code module.
      IF (LNB (LINOUT).GT.0) WRITE (LUNOUT,'(A)') LINOUT(1:LNB (LINOUT))
C                                       Report long lines (i.e., > 72).
      IF (LNB (LINOUT).GT.72) THEN
         IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         ENDIF
C                                       Get another line.
      GO TO 40
C                                       Close the input and output
C                                       source module files.
 800  CLOSE (LUNIN)
      CLOSE (LUNOUT)
C                                       Get another input file.
      GO TO 10
C                                       Close the module list,
C                                       log, error and special
C                                       ENCODE/DECODE files.
 900  CLOSE (LUNLIS)
      CLOSE (LUNLOG)
      CLOSE (LUNERR)
      CLOSE (LUNND)
C                                       Exit.
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A,/)
      END
      SUBROUTINE PGUNIT
C-----------------------------------------------------------------------
C   Try to detect the beginning of a new program unit (i.e., PROGRAM,
C   SUBROUTINE or FUNCTION).
C
C   Inputs:
C      none
C   Output:
C      none
C-----------------------------------------------------------------------
      INTEGER   I, J, K, FNB, LNB, VERIFY
      CHARACTER LINSAV*80, LINTMP*80
      INCLUDE 'XLATE.INC'
C-----------------------------------------------------------------------
C                                       Set XLATE program unit name.
      CXUNIT = 'PGUNIT'
C                                       Save copy of LINOUT for logging
C                                       changes.
      LINSAV = LINOUT
C                                       Debug print.
      IF (DEBUG) WRITE (6,*) 'PGUNIT: ',LINOUT(1:LNB (LINOUT))
C                                       Check for '      PROGRAM ...'.
      I = INDEX (LINOUT, '      PROGRAM ')
      IF (I.GT.0) THEN
         J = I + LEN ('      PROGRAM ')
         DO 10 I = 1,LEN (LINOUT)
            IF (LINOUT(J:J).NE.' ') GO TO 20
            J = J + 1
 10         CONTINUE
 20      LINTMP = LINOUT(J:)
         J = INDEX (LINTMP, ' ')
         PGNAME = LINTMP(1:J)
         PGTYPE = 'PROG'
      ELSE
C                                       Check for
C                                       '      SUBROUTINE ...'.
         I = INDEX (LINOUT, '      SUBROUTINE ')
         IF (I.GT.0) THEN
            J = I + LEN ('      SUBROUTINE ')
            DO 30 I = 1,LEN (LINOUT)
               IF (LINOUT(J:J).NE.' ') GO TO 40
               J = J + 1
 30            CONTINUE
 40         LINTMP = LINOUT(J:)
            J = INDEX (LINTMP, '(') - 1
            IF (J.LE.0) J = INDEX (LINTMP, ' ')
            PGNAME = LINTMP(1:J)
            PGTYPE = 'SUBR'
         ELSE
C                                       Check for ' FUNCTION ...'.
            I = INDEX (LINOUT, ' FUNCTION ')
            IF (I.GT.0) THEN
               J = I + LEN (' FUNCTION ')
               DO 50 I = 1,LEN (LINOUT)
                  IF (LINOUT(J:J).NE.' ') GO TO 60
                  J = J + 1
 50               CONTINUE
 60            LINTMP = LINOUT(J:)
               J = INDEX (LINTMP, '(') - 1
               IF (J.LE.0) J = INDEX (LINTMP, ' ')
               PGNAME = LINTMP(1:J)
               PGTYPE = 'FUNC'
               END IF
            END IF
         END IF
C                                       Debug print.
      IF (DEBUG) WRITE (6,*) 'PGUNIT: PGTYPE = ',PGTYPE,
     *   ' PGNAME = ',PGNAME
C                                       Exit.
 999  RETURN
      END
      SUBROUTINE COMENT
C-----------------------------------------------------------------------
C   1) make sure all comments of the form 'C------...' consist of 'C'
C      followed by 71 '-'s
C
C   2) convert comments containing:
C
C      'I*2... ' and 'I*4... ' to 'I...   '
C      'R*4... '               to 'R...   '
C      'R*8... '               to 'D...   '
C      'L*2... ' and 'L*4... ' to 'L...   '
C
C   3) report comments containing 'L*1', 'P*4' or I*2(2) (i.e., possible
C      P*4) in the error file
C
C   Inputs:
C      none
C   Output:
C      none
C-----------------------------------------------------------------------
      INTEGER   I, J, K, FNB, LNB, VERIFY
      CHARACTER LINSAV*80, LINTMP*80
      INCLUDE 'XLATE.INC'
C-----------------------------------------------------------------------
C                                       Set XLATE program unit name.
      CXUNIT = 'COMENT'
C                                       Save copy of LINOUT for logging
C                                       changes.
      LINSAV = LINOUT
C                                       Debug print.
      IF (DEBUG) WRITE (6,*) 'COMENT: ',LINOUT(1:LNB (LINOUT))
C                                       Clean up 'C-----...' comments.
      IF (LINOUT(1:8).EQ.'C-------') THEN
C                  0        1         2         3
C                  123456789012345678901234567890123456
         LINOUT = 'C-----------------------------------' //
     *            '------------------------------------'
         GO TO 999
         END IF
C                                       Convert 'I*2' to 'I  '.
 10   I = INDEX (LINOUT, 'I*2')
      IF (I.GT.0) THEN
         J = I + INDEX (LINOUT(I:), ' ') - 1
         LINTMP = LINOUT(1:I-1) // 'I' // LINOUT(I+3:J) // ' ' //
     *      LINOUT(J:)
         LINOUT = LINTMP
         GO TO 10
         END IF
C                                       Convert 'I*4' to 'I  '.
 20   I = INDEX (LINOUT, 'I*4')
      IF (I.GT.0) THEN
         J = I + INDEX (LINOUT(I:), ' ') - 1
         LINTMP = LINOUT(1:I-1) // 'I' // LINOUT(I+3:J) // ' ' //
     *      LINOUT(J:)
         LINOUT = LINTMP
         GO TO 20
         END IF
C                                       Convert 'R*4' to 'R  '.
 30   I = INDEX (LINOUT, 'R*4')
      IF (I.GT.0) THEN
         J = I + INDEX (LINOUT(I:), ' ') - 1
         LINTMP = LINOUT(1:I-1) // 'R' // LINOUT(I+3:J) // ' ' //
     *      LINOUT(J:)
         LINOUT = LINTMP
         GO TO 30
         END IF
C                                       Convert 'R*8' to 'D  '.
 40   I = INDEX (LINOUT, 'R*8')
      IF (I.GT.0) THEN
         J = I + INDEX (LINOUT(I:), ' ') - 1
         LINTMP = LINOUT(1:I-1) // 'D' // LINOUT(I+3:J) // ' ' //
     *      LINOUT(J:)
         LINOUT = LINTMP
         GO TO 40
         END IF
C                                       Convert 'L*2' to 'L  '.
 50   I = INDEX (LINOUT, 'L*2')
      IF (I.GT.0) THEN
         J = I + INDEX (LINOUT(I:), ' ') - 1
         LINTMP = LINOUT(1:I-1) // 'L' // LINOUT(I+3:J) // ' ' //
     *      LINOUT(J:)
         LINOUT = LINTMP
         GO TO 50
         END IF
C                                       Convert 'L*4' to 'L  '.
 60   I = INDEX (LINOUT, 'L*2')
      IF (I.GT.0) THEN
         J = I + INDEX (LINOUT(I:), ' ') - 1
         LINTMP = LINOUT(1:I-1) // 'L' // LINOUT(I+3:J) // ' ' //
     *      LINOUT(J:)
         LINOUT = LINTMP
         GO TO 60
         END IF
C                                       Report 'P*4', 'I(2)' and 'L*1'.
      IF ((INDEX (LINOUT, 'P*4').GT.0) .OR.
     *   (INDEX (LINOUT, 'I(2)').GT.0) .OR.
     *   (INDEX (LINOUT, 'L*1').GT.0)) THEN
C                                       Report comment in error file.
         IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         ENDIF
C                                       Any changes?
      IF (LINOUT.NE.LINSAV) THEN
C                                       Debug print.
         IF (DEBUG) THEN
            WRITE (6,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *         LINSAV(1:LNB (LINSAV))
            WRITE (6,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *         LINOUT(1:LNB (LINOUT))
            END IF
C                                       Log changes.
         WRITE (LUNLOG,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *      LINSAV(1:LNB (LINSAV))
         WRITE (LUNLOG,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         END IF
C                                       Exit.
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A,/)
 2000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A)
      END
      SUBROUTINE INCLUD
C-----------------------------------------------------------------------
C   1) eliminates standard INCLUDEd file names of the form C*.INC and
C      E*.INC (these have been appended to D*.INC)
C
C   2) converts INCLUDEs of IDCH.INC to INCLUDEs of DDCH.INC and
C      eliminates INCLUDEs of ZFT5.INC (i.e., the only place FTAB is
C      declared and dimensioned now is in DDCH.INC)
C
C   3) reports in the error file non-standard INCLUDEd file names (i.e.,
C      missing 'INCS:', file names that don't start with C,D,E,I,P,V or
C      Z and file names > 8 characters)
C
C   Inputs:
C      none
C   Output:
C      none
C-----------------------------------------------------------------------
      INTEGER   I, J, K, FNB, LNB, VERIFY
      CHARACTER LINSAV*80, LINTMP*80
      INCLUDE 'XLATE.INC'
C-----------------------------------------------------------------------
C                                       Set XLATE program unit name.
      CXUNIT = 'INCLUD'
C                                       Save copy of LINOUT for logging
C                                       changes.
      LINSAV = LINOUT
C                                       Debug print.
      IF (DEBUG) WRITE (6,*) 'INCLUD: ',LINOUT(1:LNB (LINOUT))
C                                       Eliminate INCLUDE statements for
C                                       C*.INC and E*.INC files if file
C                                       names are standard (i.e. < 5
C                                       characters not counting '.INC').
      I = INDEX (LINOUT, 'INCS:C')
      IF (I.GT.0) THEN
         J = INDEX (LINOUT, '.INC')
         K = J - I - 5
         IF (K.LE.4) LINOUT = ' '
         GO TO 900
         END IF
C                                       Check for E*.INC.
      I = INDEX (LINOUT, 'INCS:E')
      IF (I.GT.0) THEN
         J = INDEX (LINOUT, '.INC')
         K = J - I - 5
         IF (K.LE.4) LINOUT = ' '
         GO TO 900
         END IF
C                                       Check for IDCH.INC and convert
C                                       it to DDCH.INC which is the only
C                                       place where FTAB is now declared
C                                       and dimensioned.
      I = INDEX (LINOUT, 'IDCH.INC')
      IF (I.GT.0) LINOUT(I:I) = 'D'
C                                       Check for non-standard INCLUDEd
C                                       files.
      I = INDEX (LINOUT, 'INCS:')
      IF (I.GT.0) THEN
C                                       Check for non-standard INCLUDEd
C                                       file name (i.e., not C*.INC,
C                                       D*.INC, E*.INC, I*.INC, P*.INC,
C                                       V*.INC, Z*.INC or *.INC > 8).
         LINTMP = LINOUT(I+5:)
         J = INDEX (LINTMP, '''') - 1
         IF ((J.GT.8) .OR. (VERIFY (LINTMP(1:1), 'CDEIPVZ').GT.0)) THEN
            IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME, CXUNIT,
     *         '>', LINOUT(1:LNB (LINOUT))
            WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *         LINOUT(1:LNB (LINOUT))
            END IF
C                                       Also eliminate ZFT5.INC
         IF (LINTMP(1:J).EQ.'ZFT5.INC') LINOUT = ' '
      ELSE
C                                       'INCS:' missing.
         IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         ENDIF
C                                       Any changes?
 900  IF (LINOUT.NE.LINSAV) THEN
C                                       Debug print.
         IF (DEBUG) THEN
            WRITE (6,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *         LINSAV(1:LNB (LINSAV))
            WRITE (6,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *         LINOUT(1:LNB (LINOUT))
            END IF
C                                       Log changes.
         WRITE (LUNLOG,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *      LINSAV(1:LNB (LINSAV))
         WRITE (LUNLOG,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         END IF
C                                       Exit.
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A,/)
 2000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A)
      END
      SUBROUTINE DECLAR
C-----------------------------------------------------------------------
C   1) convert type and length declarations to ANSI standard type
C      declarations
C
C   2) report in the error file any LOGICAL*1 or BYTE declarations
C
C   Inputs:
C      none
C   Output:
C      none
C-----------------------------------------------------------------------
      INTEGER   I, J, K, FNB, LNB, VERIFY
      CHARACTER LINSAV*80, LINTMP*80
      INCLUDE 'XLATE.INC'
C-----------------------------------------------------------------------
C                                       Set XLATE program unit name.
      CXUNIT = 'DECLAR'
C                                       Save copy of LINOUT for logging
C                                       changes.
      LINSAV = LINOUT
C                                       Debug print.
      IF (DEBUG) WRITE (6,*) 'DECLAR: ',LINOUT(1:LNB (LINOUT))
C                                       Convert 'INTEGER*n' to
C                                       'INTEGER  '.
      I = INDEX (LINOUT, 'INTEGER*')
      IF (I.GT.0) THEN
         IF (INDEX (LINOUT, ' FUNCTION').GT.0) THEN
            LINTMP = LINOUT(1:I-1) // 'INTEGER' // LINOUT(I+9:)
         ELSE
            LINTMP = LINOUT(1:I-1) // 'INTEGER' // '  ' // LINOUT(I+9:)
            END IF
         LINOUT = LINTMP
         GO TO 900
         END IF
C                                       Convert 'REAL*4' to 'REAL  '.
      I = INDEX (LINOUT, 'REAL*4')
      IF (I.GT.0) THEN
         IF (INDEX (LINOUT, ' FUNCTION').GT.0) THEN
            LINTMP = LINOUT(1:I-1) // 'REAL' // LINOUT(I+6:)
         ELSE
            LINTMP = LINOUT(1:I-1) // 'REAL' // '  ' // LINOUT(I+6:)
            END IF
         LINOUT = LINTMP
         GO TO 900
         END IF
C                                       Convert 'REAL*8' to
C                                       'DOUBLE PRECISION' plus
C                                       continuation on next line.
      I = INDEX (LINOUT, 'REAL*8')
      IF (I.GT.0) THEN
         WRITE (LUNOUT,'(A)') '      DOUBLE PRECISION'
         LINTMP = '     *  ' // LINOUT(I+6:)
         LINOUT = LINTMP
         GO TO 900
         END IF
C                                       Convert 'LOGICAL*2' to
C                                       'LOGICAL  '.
      I = INDEX (LINOUT, 'LOGICAL*2')
      IF (I.GT.0) THEN
         IF (INDEX (LINOUT, ' FUNCTION').GT.0) THEN
            LINTMP = LINOUT(1:I-1) // 'LOGICAL' // LINOUT(I+9:)
         ELSE
            LINTMP = LINOUT(1:I-1) // 'LOGICAL' // '  ' // LINOUT(I+9:)
            END IF
         LINOUT = LINTMP
         GO TO 900
         END IF
C                                       Convert 'LOGICAL*4' to
C                                       'LOGICAL  '.
      I = INDEX (LINOUT, 'LOGICAL*4')
      IF (I.GT.0) THEN
         IF (INDEX (LINOUT, ' FUNCTION').GT.0) THEN
            LINTMP = LINOUT(1:I-1) // 'LOGICAL' // LINOUT(I+9:)
         ELSE
            LINTMP = LINOUT(1:I-1) // 'LOGICAL' // '  ' // LINOUT(I+9:)
            END IF
         LINOUT = LINTMP
         GO TO 900
         END IF
C                                       Report LOGICAL*1 and BYTE.
      IF ((INDEX (LINOUT, 'LOGICAL*1').GT.0) .OR.
     *   (INDEX (LINOUT, '      BYTE').GT.0)) THEN
C                                       Report comment in error file.
         IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         ENDIF
C                                       Any changes?
 900  IF (LINOUT.NE.LINSAV) THEN
C                                       Debug print.
         IF (DEBUG) THEN
            WRITE (6,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *         LINSAV(1:LNB (LINSAV))
            WRITE (6,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *         LINOUT(1:LNB (LINOUT))
            END IF
C                                       Log changes.
         WRITE (LUNLOG,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *      LINSAV(1:LNB (LINSAV))
         WRITE (LUNLOG,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         END IF
C                                       Exit.
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A,/)
 2000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A)
      END
      SUBROUTINE DEFTAB
C-----------------------------------------------------------------------
C   Eliminate declarations of the array FTAB which is only declared and
C   dimensioned in DDCH.INC now.
C
C   Inputs:
C      none
C   Output:
C      none
C-----------------------------------------------------------------------
      INTEGER   I, J, K, FNB, LNB, VERIFY
      CHARACTER LINSAV*80, LINTMP*80
      INCLUDE 'XLATE.INC'
C-----------------------------------------------------------------------
C                                       Set XLATE program unit name.
      CXUNIT = 'DEFTAB'
C                                       Save copy of LINOUT for logging
C                                       changes.
      LINSAV = LINOUT
C                                       Debug print.
      IF (DEBUG) WRITE (6,*) 'DEFTAB: ',LINOUT(1:LNB (LINOUT))
C                                       Only eliminate in INTEGER or
C                                       continuation statememts.
      IF ((INDEX (LINOUT, '      INTEGER').GT.0) .OR.
     *   (LINOUT(6:6).NE.' ')) THEN
C                                       Locate 'FTAB(...)' and extract
C                                       '...'.
         I = INDEX (LINOUT, 'FTAB(') - 1
         J = I + INDEX (LINOUT(I:), ')')
         LINTMP = LINOUT (I+6:J-2)
C                                       Verify that '...' is all digits
C                                       (i.e., try to leave non-
C                                       declaration continuation
C                                       statements involving FTAB alone;
C                                       no guarantee, just a good faith
C                                       effort).
         K = LNB (LINTMP)
         IF (VERIFY (LINTMP(1:K), '0123456789').EQ.0) THEN
C                                       Look backward for ','.
            K = LNB (LINOUT(1:I))
            IF (LINOUT(K:K).EQ.',') THEN
               I = K - 1
            ELSE
C                                       Look forward for ','.
               DO 10 K = 1,LEN (LINOUT) - J
                  IF ((LINOUT(J:J).NE.' ') .AND.
     *               (LINOUT(J:J).NE.',')) GO TO 20
                  J = J + 1
 10               CONTINUE
               END IF
 20         LINTMP = LINOUT(1:I) // LINOUT(J:)
            LINOUT = LINTMP
C                                       Zap otherwise empty INTEGER
C                                       or continuation statements.
            I = INDEX (LINOUT, 'INTEGER')
            IF (I.GT.0) THEN
               I = I + 7
            ELSE IF (LINOUT(6:6).NE.' ') THEN
               I = 7
               END IF
            IF (I.GT.0) THEN
               LINTMP = LINOUT(I:)
               IF (VERIFY (LINTMP, ' ,').EQ.0) LINOUT = ' '
               END IF
            END IF
         END IF
C                                       Any changes?
      IF (LINOUT.NE.LINSAV) THEN
C                                       Debug print.
         IF (DEBUG) THEN
            WRITE (6,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *         LINSAV(1:LNB (LINSAV))
            WRITE (6,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *         LINOUT(1:LNB (LINOUT))
            END IF
C                                       Log changes.
         WRITE (LUNLOG,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *      LINSAV(1:LNB (LINSAV))
         WRITE (LUNLOG,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         END IF
C                                       Exit.
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A,/)
 2000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A)
      END
      SUBROUTINE NDCODE
C-----------------------------------------------------------------------
C   Attempts to convert ENCODE/DECODE statements into equivalent Fortran
C   77 internal WRITE/READ statements.
C
C   NOTE: Apart from the conversion of ENCODE statements of the form:
C
C   'ENCODE (80,nnnn,MSGTXT)' to 'WRITE (MSGTXT,nnnn)'
C
C   all other translations MUST be regarded as incomplete and MUST be
C   examined for the additional code conversions that will almost always
C   be required.  For this reason, for all but the simple case cited
C   above, the original ENCODE/DECODE statements are preserved as
C   comments in the output source code module.  Furthermore, the
C   original and translated forms are recorded in a special log file
C   (i.e., XLATE.ND), whereas the original and translated forms of the
C   simple case only recorded in the "catch-all" log file (i.e.,
C   XLATE.LOG).
C
C   Inputs:
C      none
C   Output:
C      none
C-----------------------------------------------------------------------
      INTEGER   I, J, K, FNB, LNB, VERIFY, ICOD, ICHR, JCHR, NCHR,
     *   IFMT, JFMT, NFMT, ITGT, JTGT, KTGT, NTGT
      LOGICAL   DCODE
      CHARACTER LINSAV*80, LINTMP*80, ALPHNU*36, CHARS*16, FRMT*16,
     *   TARGET*32
      INCLUDE 'XLATE.INC'
      DATA ALPHNU /'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
C-----------------------------------------------------------------------
C                                       Set XLATE program unit name.
      CXUNIT = 'NDCODE'
C                                       Save copy of LINOUT for logging
C                                       changes.
      LINSAV = LINOUT
C                                       Assume this is an ENCODE
C                                       statement until proven
C                                       otherwise.
      DCODE = .FALSE.
C                                       Locate the beginning of the
C                                       'ENCODE' or 'DECODE' statement.
      ICOD = INDEX (LINOUT, 'ENCODE')
C                                       ENCODE?
      IF (ICOD.LE.0) THEN
C                                       Try DECODE.
         DCODE = .TRUE.
         ICOD = INDEX (LINOUT, 'DECODE')
         END IF
C                                       Either?
      IF (ICOD.GT.0) THEN
C                                       Locate and extract the number
C                                       of characters to transfer (i.e.,
C                                       first parameter in the ENCODE or
C                                       DECODE statement).  This must be
C                                       '80' to qualify as one of the
C                                       simple cases that should not
C                                       require any further attention,
C                                       e.g.,
C                                       ... ENCODE (80,1000,MSGTXT) ...
C                                       12345678901234567890123456789012
         ICHR = ICOD + INDEX (LINOUT(ICOD:), '(') - 1
C        ICHR = 5    + 8                          - 1 = 12
         ICHR = ICHR + VERIFY (LINOUT(ICHR:), '( ') - 1
C        ICHR = 12   + 2                            - 1 = 13
         JCHR = ICHR + VERIFY (LINOUT(ICHR:), ALPHNU) - 2
C        JCHR = 13   + 3                              - 2 = 14
         CHARS = LINOUT(ICHR:JCHR)
C        CHARS = LINOUT(13  :14  ) = '80'
         NCHR = JCHR - ICHR + 1
C         WRITE (6,*) 'CHARS(1:',NCHR,') = :',CHARS(1:NCHR),':'
C        NCHR = 14   - 13   + 1 = 2
C                                       Locate and extract the format
C                                       statement parameter (computed or
C                                       statement label), e.g., the
C                                       format statemet label '1000' in
C                                       ... ENCODE (80,1000,MSGTXT) ...
C                                       12345678901234567890123456789012
         IFMT = JCHR + INDEX (LINOUT(JCHR:), ',') - 1
C        IFMT = 14   + 2                           - 1 = 15
         IFMT = IFMT + VERIFY (LINOUT(IFMT:), ', ') - 1
C        IFMT = 15     + 2                        - 1 = 16
         JFMT = IFMT + VERIFY (LINOUT(IFMT:), ALPHNU) - 2
C        JFMT = 16   + 5                              - 2 = 19
         FRMT = LINOUT(IFMT:JFMT)
C        FRMT = LINOUT(16  :19  ) = '1000'
         NFMT = JFMT - IFMT + 1
C        NFMT = 19   - 16   + 1 = 4
C         WRITE (6,*) 'FRMT(1:',NFMT,') = :',FRMT(1:NFMT),':'
C                                       Locate and extract the output
C                                       variable, array or array element
C                                       (i.e., what is to become the
C                                       internal file in an internal
C                                       WRITE, only they can't be non-
C                                       CHARACTER arrays, like MSGTXT
C                                       used to be in AIPS), e.g.,
C                                       ... ENCODE (80,1000,MSGTXT) ...
C                                       12345678901234567890123456789012
         ITGT = JFMT + INDEX (LINOUT(JFMT:), ',') - 1
C        ITGT = 19   + 2                          - 1 = 20
         ITGT = ITGT + VERIFY (LINOUT(ITGT:), ', ') - 1
C        ITGT = 20   + 2                            - 1 = 21
C                                       Process only one level of
C                                       parentheses.
         JTGT = ITGT + INDEX (LINOUT(ITGT:), ')') - 1
C        JTGT = 21   + 7                          - 1 = 27
         KTGT = ITGT + INDEX (LINOUT(ITGT:), '(') - 1
C        KTGT = 21   + 0                          - 1 = 20
         IF ((KTGT.GT.ITGT) .AND. (KTGT.LT.JTGT)) THEN
            JTGT = JTGT
C           27   = 27
         ELSE
            JTGT = ITGT + VERIFY (LINOUT(ITGT:), ALPHNU) - 2
C           JTGT = 21   + 7                                - 2 = 26
            END IF
C                                       Error branching sometimes
C                                       follows the target, but these
C                                       will stay intact.
         TARGET = LINOUT(ITGT:JTGT)
C        TARGET = LINOUT(21  :26) = 'MSGTXT'
         NTGT = JTGT - ITGT + 1
C        NTGT = 26   - 21   + 1 = 6
C         WRITE (6,*) 'TARGET(1:',NTGT,') = :',TARGET(1:NTGT),':'
C                                       Finally, form the "equivalent"
C                                       internal WRITE (for ENCODEs) or
C                                       internal READ (for DECODEs).
         IF (DCODE) THEN
            LINTMP = LINOUT (1:ICOD-1) // 'READ (' // TARGET(1:NTGT) //
     *         ',' // FRMT(1:NFMT) // LINOUT(JTGT+1:)
         ELSE
            LINTMP = LINOUT (1:ICOD-1) // 'WRITE (' // TARGET(1:NTGT) //
     *         ',' // FRMT(1:NFMT) // LINOUT(JTGT+1:)
            END IF
C                                       Copy the conversion to the
C                                       output buffer.
         LINOUT = LINTMP
C                                       Debug?
         IF (DEBUG) THEN
            WRITE (6,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *         LINSAV(1:LNB (LINSAV))
            WRITE (6,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *         LINOUT(1:LNB (LINOUT))
            END IF
C                                       Record only the conversions that
C                                       require further attention in the
C                                       special ENCODE/DECODE log file
C                                       (i.e., XLATE.ND).
         IF ((CHARS.EQ.'80') .AND. (TARGET.EQ.'MSGTXT')) GO TO 900
C                                       Insert the orginal line as a
C                                       comment in the output source
C                                       code module.
            LINTMP = 'C ??? ' // LINSAV(7:)
            WRITE (LUNOUT,'(A)') LINTMP(1:LNB (LINTMP))
C                                       Record conversion in XLATE.ND.
            WRITE (LUNND,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *         LINSAV(1:LNB (LINSAV))
            WRITE (LUNND,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *         LINOUT(1:LNB (LINOUT))
C                                       Record ALL conversions in the
C                                       "catch-all" log file.
 900     WRITE (LUNLOG,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *      LINSAV(1:LNB (LINSAV))
         WRITE (LUNLOG,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         END IF
C                                       Exit.
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A,/)
 2000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A)
      END
      SUBROUTINE NWDPLI
C-----------------------------------------------------------------------
C   Looks for calls to COPY using NWDPLI as an argument and converts
C   them into simple assignment statements.
C-----------------------------------------------------------------------
      INTEGER   I, J, K, FNB, LNB, VERIFY
      CHARACTER LINSAV*80, LINTMP*80, KFROM*80, KTO*80
      INCLUDE 'XLATE.INC'
C-----------------------------------------------------------------------
C                                       Set XLATE program unit name.
      CXUNIT = 'NWDPLI'
C                                       Save copy of LINOUT for logging
C                                       changes.
      LINSAV = LINOUT
C                                       Debug print.
      IF (DEBUG) WRITE (6,*) 'NWDPLI: ',LINOUT(1:LNB (LINOUT))
C                                       Locate CALL statement.
      I = INDEX (LINOUT, 'CALL COPY') - 1
C                                       Locate second argument.
      J = I + INDEX (LINOUT(I:), ',') + 1
 10   IF (LINOUT(J:J).NE.' ') GO TO 20
         J = J + 1
         GO TO 10
 20   LINTMP = LINOUT(J:)
      K = INDEX (LINTMP, ' ') - 2
      KFROM = LINTMP(1:K)
C                                       Locate third argument.
      J = J + K + 1
 30   IF (LINOUT(J:J).NE.' ') GO TO 40
         J = J + 1
         GO TO 30
 40   LINTMP = LINOUT(J:)
      K = INDEX (LINTMP, ' ') - 2
      KTO = LINTMP(1:K)
C                                       Replace call with an assignment
C                                       statement.
      LINTMP = LINOUT(1:I) // KTO(1:LNB (KTO)) // ' = ' // KFROM
      LINOUT = LINTMP
C                                       Debug print.
      IF (DEBUG) THEN
         WRITE (6,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *      LINSAV(1:LNB (LINSAV))
         WRITE (6,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         END IF
C                                       Log changes.
      WRITE (LUNLOG,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *   LINSAV(1:LNB (LINSAV))
      WRITE (LUNLOG,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *   LINOUT(1:LNB (LINOUT))
C                                       Exit.
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A,/)
 2000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A)
      END
      SUBROUTINE NONGEN
C-----------------------------------------------------------------------
C   1) convert type-specific to generic intrinsic functions:
C
C      DSQRT                     -> SQRT
C      ALOG, DLOG                -> LOG
C      ALOG10, DLOG10            -> LOG10
C      DEXP                      -> EXP
C      DSIN                      -> SIN
C      DASIN, ARSIN, DARSIN      -> ASIN
C      DCOS                      -> COS
C      DACOS, ARCOS, DARCOS      -> ACOS
C      DTAN                      -> TAN
C      DATAN                     -> ATAN
C      DATAN2                    -> ATAN2
C      IABS, DABS, IIABS, JIABS  -> ABS
C      IFIX, IINT, JINT, IDINT   -> INT
C      FLOAT                     -> REAL
C      ISIGN, DSIGN              -> SIGN
C      MAX0, AMAX1, DMAX1        -> MAX
C      MIN0, AMIN1, DMIN1        -> MIN
C      IMOD, JMOD, AMOD, DMOD    -> MOD
C
C   2) report uses of questionable intrinsic functions:
C
C      MAX1     AMAX0    MIN1     AMIN0    AINT
C
C   2) report uses of non-standard intrinsic functions:
C
C      SIND     ASIND    DASIND   COSD     ACOSD    DACOSD
C      TAND     ATAND    DATAND   ATAN2D   DATAN2D
C
C-----------------------------------------------------------------------
      INTEGER   I, J, K, FNB, LNB, VERIFY
      CHARACTER LINSAV*80, LINTMP*80, PUNCT*9
      LOGICAL   CHANGE
      INCLUDE 'XLATE.INC'
      DATA PUNCT /' +-*/()=,'/
C-----------------------------------------------------------------------
C                                       Set XLATE program unit name.
      CXUNIT = 'NONGEN'
C                                       Save copy of LINOUT for logging
C                                       changes.
      LINSAV = LINOUT
C                                       Debug print.
      IF (DEBUG) WRITE (6,*) 'NONGEN: ',LINOUT(1:LNB (LINOUT))
C                                       Prime main loop.
      CHANGE = .TRUE.
C                                       Loop until no change.
 1    IF (CHANGE) THEN
C                                       Toggle change status.
         CHANGE = .FALSE.
C                                       Check for DSQRT.
         I = INDEX (LINOUT, 'SQRT')
         IF (I.GT.0) THEN
C                                       Convert DSQRT to SQRT.
            I = INDEX (LINOUT, 'DSQRT')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DSQRT')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'SQRT' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
            END IF
C                                       Check for ALOG, DLOG, ALOG10
C                                       and DLOG10.
         I = INDEX (LINOUT, 'LOG')
         IF (I.GT.0) THEN
C                                       Convert ALOG10 to LOG10.
            I = INDEX (LINOUT, 'ALOG10')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('ALOG10')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'LOG10' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert DLOG10 to LOG10.
            I = INDEX (LINOUT, 'DLOG10')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DLOG10')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'LOG10' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
            END IF
C                                       Convert ALOG to LOG.
            I = INDEX (LINOUT, 'ALOG')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('ALOG')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'LOG' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert DLOG to LOG.
            I = INDEX (LINOUT, 'DLOG')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DLOG')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'LOG' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Check for DEXP.
         I = INDEX (LINOUT, 'EXP')
         IF (I.GT.0) THEN
C                                       Convert DEXP to EXP.
            I = INDEX (LINOUT, 'DEXP')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DEXP')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'EXP' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
            END IF
C                                       Check for DSIN, DASIN, ARSIN
C                                       and DARSIN.
         I = INDEX (LINOUT, 'SIN')
         IF (I.GT.0) THEN
C                                       Convert DSIN to SIN.
            I = INDEX (LINOUT, 'DSIN')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DSIN')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'SIN' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert DASIN to ASIN.
            I = INDEX (LINOUT, 'DASIN')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DASIN')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'ASIN' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert ARSIN to ASIN.
            I = INDEX (LINOUT, 'ARSIN')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('ARSIN')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'ASIN' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert DARSIN to ASIN.
            I = INDEX (LINOUT, 'DARSIN')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DARSIN')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'ASIN' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
            END IF
C                                       Check for DCOS, DACOS, ARCOS
C                                       and DARCOS.
         I = INDEX (LINOUT, 'COS')
         IF (I.GT.0) THEN
C                                       Convert DCOS to COS.
            I = INDEX (LINOUT, 'DCOS')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DCOS')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'COS' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert DACOS to ACOS.
            I = INDEX (LINOUT, 'DACOS')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DACOS')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'ACOS' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert ARCOS to ACOS.
            I = INDEX (LINOUT, 'ARCOS')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('ARCOS')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'ACOS' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert DARCOS to ACOS.
            I = INDEX (LINOUT, 'DARCOS')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DARCOS')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'ACOS' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
            END IF
C                                       Check for DTAN, DATAN and
C                                       DATAN2.
         I = INDEX (LINOUT, 'TAN')
         IF (I.GT.0) THEN
C                                       Convert DTAN to TAN.
            I = INDEX (LINOUT, 'DTAN')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DTAN')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'TAN' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert DATAN to ATAN.
            I = INDEX (LINOUT, 'DATAN')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DATAN')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'ATAN' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert DATAN2 to ATAN2.
            I = INDEX (LINOUT, 'DATAN2')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DATAN2')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'ATAN2' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
            END IF
C                                       Check for IABS, DABS, IIABS
C                                       and JIABS.
         I = INDEX (LINOUT, 'ABS')
         IF (I.GT.0) THEN
C                                       Convert IABS to ABS.
            I = INDEX (LINOUT, 'IABS')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('IABS')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'ABS' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert DABS to ABS.
            I = INDEX (LINOUT, 'DABS')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DABS')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'ABS' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert IIABS to ABS.
            I = INDEX (LINOUT, 'IIABS')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('IIABS')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'ABS' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert JIABS to ABS.
            I = INDEX (LINOUT, 'JIABS')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('JIABS')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'ABS' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
            END IF
C                                       Check for IFIX.
         I = INDEX (LINOUT, 'FIX')
         IF (I.GT.0) THEN
C                                       Convert IFIX to INT.
            I = INDEX (LINOUT, 'IFIX')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('IFIX')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'INT' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
            END IF
C                                       Check for IINT, JINT and IDINT.
         I = INDEX (LINOUT, 'INT')
         IF (I.GT.0) THEN
C                                       Convert IINT to INT.
            I = INDEX (LINOUT, 'IINT')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('IINT')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'INT' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert JINT to INT.
            I = INDEX (LINOUT, 'JINT')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('JINT')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'INT' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert IDINT to INT.
            I = INDEX (LINOUT, 'IDINT')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('IDINT')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'INT' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
            END IF
C                                       Check for FLOAT.
         I = INDEX (LINOUT, 'FLOAT')
         IF (I.GT.0) THEN
C                                       Convert FLOAT to REAL.
            I = INDEX (LINOUT, 'FLOAT')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('FLOAT')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'REAL' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
            END IF
C                                       Check for ISIGN and DSIGN.
         I = INDEX (LINOUT, 'SIGN')
         IF (I.GT.0) THEN
C                                       Convert ISIGN to SIGN.
            I = INDEX (LINOUT, 'ISIGN')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('ISIGN')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'SIGN' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert DSIGN to SIGN.
            I = INDEX (LINOUT, 'DSIGN')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DSIGN')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'SIGN' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
            END IF
C                                       Check for MAX0, AMAX1 and DMAX1.
         I = INDEX (LINOUT, 'MAX')
         IF (I.GT.0) THEN
C                                       Convert MAX0 to MAX.
            I = INDEX (LINOUT, 'MAX0')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('MAX0')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'MAX' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert AMAX1 to MAX.
            I = INDEX (LINOUT, 'AMAX1')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('AMAX1')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'MAX' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert DMAX1 to MAX.
            I = INDEX (LINOUT, 'DMAX1')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DMAX1')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'MAX' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
            END IF
C                                       Check for MIN0, AMIN1 and DMIN1.
         I = INDEX (LINOUT, 'MIN')
         IF (I.GT.0) THEN
C                                       Convert MIN0 to MIN.
            I = INDEX (LINOUT, 'MIN0')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('MIN0')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'MIN' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert AMIN1 to MIN.
            I = INDEX (LINOUT, 'AMIN1')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('AMIN1')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'MIN' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert DMIN1 to MIN.
            I = INDEX (LINOUT, 'DMIN1')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DMIN1')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'MIN' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
            END IF
C                                       Check for IMOD, JMOD, AMOD
C                                       and DMOD.
         I = INDEX (LINOUT, 'MOD')
         IF (I.GT.0) THEN
C                                       Convert IMOD to MOD.
            I = INDEX (LINOUT, 'IMOD')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('IMOD')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'MOD' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert JMOD to MOD.
            I = INDEX (LINOUT, 'JMOD')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('JMOD')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'MOD' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert AMOD to MOD.
            I = INDEX (LINOUT, 'AMOD')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('AMOD')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'MOD' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
C                                       Convert DMOD to MOD.
            I = INDEX (LINOUT, 'DMOD')
            IF (I.GT.0) THEN
               IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
                  J = I + LEN ('DMOD')
                  LINTMP = LINOUT(J:)
                  K = VERIFY (LINTMP, ' ')
                  IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
                     LINTMP = LINOUT(1:I-1) // 'MOD' // LINOUT(J:)
                     LINOUT = LINTMP
                     CHANGE = .TRUE.
                     END IF
                  END IF
               END IF
            END IF
C                                       Continue.
         GO TO 1
         END IF
C                                       Any changes?
      IF (LINOUT.NE.LINSAV) THEN
C                                       Debug print.
         IF (DEBUG) THEN
            WRITE (6,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *         LINSAV(1:LNB (LINSAV))
            WRITE (6,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *         LINOUT(1:LNB (LINOUT))
            END IF
C                                       Log changes.
         WRITE (LUNLOG,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *      LINSAV(1:LNB (LINSAV))
         WRITE (LUNLOG,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         END IF
C                                       Report questionable use of
C                                       MAX1.
      I = INDEX (LINOUT, 'MAX1')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('MAX1')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Report questionable use of
C                                       AMAX0.
      I = INDEX (LINOUT, 'AMAX0')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('AMAX0')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Report questionable use of
C                                       MIN1.
      I = INDEX (LINOUT, 'MIN1')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('MIN1')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Report questionable use of
C                                       AMIN0.
      I = INDEX (LINOUT, 'AMIN0')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('AMIN0')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Report questionable use of
C                                       AINT.
      I = INDEX (LINOUT, 'AINT')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('AINT')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Report uses of non-standard
C                                       SIND.
      I = INDEX (LINOUT, 'SIND')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('SIND')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Report uses of non-standard
C                                       ASIND.
      I = INDEX (LINOUT, 'ASIND')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('ASIND')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Report uses of non-standard
C                                       DASIND.
      I = INDEX (LINOUT, 'DASIND')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('DASIND')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Report uses of non-standard
C                                       COSD.
      I = INDEX (LINOUT, 'COSD')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('COSD')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Report uses of non-standard
C                                       ACOSD.
      I = INDEX (LINOUT, 'ACOSD')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('ACOSD')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Report uses of non-standard
C                                       DACOSD.
      I = INDEX (LINOUT, 'DACOSD')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('DACOSD')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Report uses of non-standard
C                                       TAND.
      I = INDEX (LINOUT, 'TAND')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('TAND')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Report uses of non-standard
C                                       ATAND.
      I = INDEX (LINOUT, 'ATAND')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('ATAND')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Report uses of non-standard
C                                       DATAND.
      I = INDEX (LINOUT, 'DATAND')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('DATAND')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Report uses of non-standard
C                                       ATAN2D.
      I = INDEX (LINOUT, 'ATAN2D')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('ATAN2D')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Report uses of non-standard
C                                       DATAN2D.
      I = INDEX (LINOUT, 'DATAN2D')
      IF (I.GT.0) THEN
         IF (VERIFY (LINOUT(I-1:I-1), PUNCT).EQ.0) THEN
            J = I + LEN ('DATAN2D')
            LINTMP = LINOUT(J:)
            K = VERIFY (LINTMP, ' ')
            IF ((K.NE.0) .AND. (LINTMP(K:K).EQ.'(')) THEN
               IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME,
     *            CXUNIT, '>', LINOUT(1:LNB (LINOUT))
               WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *            LINOUT(1:LNB (LINOUT))
               ENDIF
            END IF
         END IF
C                                       Exit.
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A,/)
 2000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A)
      END
      SUBROUTINE P4CALL
C-----------------------------------------------------------------------
C   Checks for calls to routines known to take pseudo I*4 arguments and
C   simply reports them in the error file, except for calls to ZFI3
C   (takes I*2 NREC) which are replaced with calls to ZFIO (takes I*4
C   NREC).
C
C   Inputs:
C      none
C   Output:
C      none
C-----------------------------------------------------------------------
      INTEGER   I, J, K, FNB, LNB, VERIFY
      CHARACTER LINSAV*80, LINTMP*80
      INCLUDE 'XLATE.INC'
C-----------------------------------------------------------------------
C                                       Set XLATE program unit name.
      CXUNIT = 'P4CALL'
C                                       Save copy of LINOUT for logging
C                                       changes.
      LINSAV = LINOUT
C                                       Debug print.
      IF (DEBUG) WRITE (6,*) 'P4CALL: ',LINOUT(1:LNB (LINOUT))
C                                       Check for CALLs to routines that
C                                       take pseudo I*4 arguments.
      IF ((INDEX (LINOUT, 'API3').GT.0) .OR.
     *   (INDEX (LINOUT, 'APXPO3').GT.0) .OR.
     *   (INDEX (LINOUT, 'COMOF3').GT.0) .OR.
     *   (INDEX (LINOUT, 'CONVF3').GT.0) .OR.
     *   (INDEX (LINOUT, 'FSWTC3').GT.0) .OR.
     *   (INDEX (LINOUT, 'GRDTA3').GT.0) .OR.
     *   (INDEX (LINOUT, 'I2TOR4').GT.0) .OR.
     *   (INDEX (LINOUT, 'MDIS3').GT.0) .OR.
     *   (INDEX (LINOUT, 'MINI3').GT.0) .OR.
     *   (INDEX (LINOUT, 'MINS3').GT.0) .OR.
     *   (INDEX (LINOUT, 'MSKI3').GT.0) .OR.
     *   (INDEX (LINOUT, 'ZCREA3').GT.0) .OR.
     *   (INDEX (LINOUT, 'ZMATH4').GT.0) .OR.
     *   (INDEX (LINOUT, 'ZMI3').GT.0) .OR.
     *   (INDEX (LINOUT, 'ZR8P4').GT.0)) THEN
C                                       Report CALL in error file.
         IF (DEBUG) WRITE (6,1000) NAMMOD,  PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         GO TO 999
         END IF
C                                       Replace calls to ZFI3 with
C                                       calls to ZFIO.
      I = INDEX (LINOUT, ' ZFI3')
      IF (I.GT.0) THEN
         I = I + 4
         LINTMP = LINOUT
         LINTMP(I:I) = 'O'
C                                       Debug print.
         IF (DEBUG) THEN
            WRITE (6,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *         LINSAV(1:LNB (LINSAV))
            WRITE (6,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *         LINOUT(1:LNB (LINOUT))
            END IF
C                                       Log changes.
         WRITE (LUNLOG,2000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '<',
     *      LINSAV(1:LNB (LINSAV))
         WRITE (LUNLOG,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         END IF
C                                       Exit.
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A,/)
 2000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A)
      END
      SUBROUTINE OTHER
C-----------------------------------------------------------------------
C   Checks for other things worth noting, but doesn't change anything.
C
C   Inputs:
C      none
C   Output:
C      none
C-----------------------------------------------------------------------
      INTEGER   I, J, K, FNB, LNB, VERIFY
      CHARACTER LINTMP*80
      INCLUDE 'XLATE.INC'
C-----------------------------------------------------------------------
C                                       Set XLATE program unit name.
      CXUNIT = 'OTHER'
C                                       Debug print.
      IF (DEBUG) WRITE (6,*) 'OTHER: ',LINOUT(1:LNB (LINOUT))
C                                       Check for '!' not in FORMAT
C                                       statements (i.e., in-line
C                                       comments).
      IF ((INDEX (LINOUT, 'FORMAT').LE.0) .AND.
     *   (INDEX (LINOUT, '!').GT.0)) THEN
C                                       Debug print.
         IF (DEBUG) WRITE (6,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
C                                       Report probable in-line
C                                       comment in the error file.
         WRITE (LUNERR,1000) NAMMOD, PGTYPE, PGNAME, CXUNIT, '>',
     *      LINOUT(1:LNB (LINOUT))
         END IF
C                                       Exit.
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (1X,A,2X,A,2X,A,2X,A,1X,A,1X,A,/)
      END
      INTEGER FUNCTION FNB (STRING)
C-----------------------------------------------------------------------
C   Locates the position of the first non-blank character in a string.
C
C   Inputs:
C      STRING   C*(*)      String to search
C   Output:
C      none
C-----------------------------------------------------------------------
      CHARACTER STRING*(*)
C
      INTEGER SLEN
      INCLUDE 'XLATE.INC'
C-----------------------------------------------------------------------
      FNB = 0
      SLEN = LEN (STRING) + 1
C                                       Look forwards for first
C                                       non-blank character.
 10   FNB = FNB + 1
      IF (FNB.GT.SLEN) GO TO 999
         IF (STRING(FNB:FNB).EQ.' ') GO TO 10
C                                       Exit.
 999  RETURN
      END
      INTEGER FUNCTION LNB (STRING)
C-----------------------------------------------------------------------
C   Locates the position of the last non-blank character in a string.
C
C   Inputs:
C      STRING   C*(*)      String to search
C   Output:
C      none
C-----------------------------------------------------------------------
      CHARACTER STRING*(*)
C
      INCLUDE 'XLATE.INC'
C-----------------------------------------------------------------------
      LNB = LEN (STRING) + 1
C                                       Look backwards for first
C                                       non-blank character.
 10   LNB = LNB - 1
      IF (LNB.LT.1) GO TO 999
         IF (STRING(LNB:LNB).EQ.' ') GO TO 10
C                                       Exit.
 999  RETURN
      END
      INTEGER FUNCTION VERIFY (STR1, STR2)
C-----------------------------------------------------------------------
C   Finds the first occurence of a character in STR1 that is not in
C   STR2.
C
C   Inputs:
C      STR1     C*(*)      String to verify
C      STR2     C*(*)      String containing characters to verify
C   Output:
C      none
C-----------------------------------------------------------------------
      CHARACTER STR1*(*), STR2*(*)
C
      INTEGER   LSTR1, LSTR2, I, J
      INCLUDE 'XLATE.INC'
C-----------------------------------------------------------------------
      VERIFY = 0
      LSTR1 = LEN (STR1)
      LSTR2 = LEN (STR2)
      IF (DEBUG) WRITE (6,*) 'VERIFY: STR2 = ',STR2,' LSTR2 = ',LSTR2
      I = 0
 10   I = I + 1
      IF (I.GT.LSTR1) GO TO 999
         J = 0
 20      J = J + 1
         IF (J.GT.LSTR2) GO TO 30
            IF (STR1(I:I).EQ.STR2(J:J)) GO TO 10
            GO TO 20
 30      VERIFY = I
C                                       Exit.
 999  RETURN
      END

      SUBROUTINE GETERR (NGAUSS, IPVT, FJAC, PARERR, MPARMS, NDATA,
     *   MDATA, FNORM, WA, TOL)
C-----------------------------------------------------------------------
C! calculates the errors on the fitted parameters
C# Modeling
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   This subroutine for GAUSS calculates the errors on the fitted
C   parameters.
C   Inputs:
C      NGAUSS  I        the no. of gaussian components in the fitted
C                       function.
C      IPVT    I(MPARMS)   Defines a permutation matrix P such that
C                       JAC*P = Q*R, where JAC is the final calculated
C                       Jacobian, Q is
C                   orthogonal (not stored), and R is upper triangular
C                   with diagonal elements of nonincreasing magnitude.
C                   column J of P is column IPVT(J) of the identity
C                   matrix. (See FJAC below).
C           FJAC    D(MDATA,MPARMS)   The upper MPARMS by MPARMS sub-
C                   matrix of FJAC contains an upper triangular matrix
C                   R with diagonal elements of nonincreasing magnitude
C                   such that
C
C                    T     T           T
C                   P *(JAC *JAC)*P = R *R,
C
C                   where P is a permutation matrix and JAC is the final
C                   calculated Jacobian. Column J of P is column IPVT(J)
C                   (see above) of the identity matrix.
C           MPARMS  I Number of parameters in fitted function (adj.
C                   array dim.).
C           NDATA   I   Number of data points fitted.
C           MDATA   I Maximum no. of data points allowed for in
C                   FJAC (adj. array dim.).
C           FNORM   D   Euclidian norm of solution vector.
C           WA      D(MPARMS)   work array.
C  OUTPUT:  PARERR  D(MPARMS)   error in fitted parameters.
C           TOL     D   tolerance used in call to LMDER1.
C-----------------------------------------------------------------------
      INTEGER   NGAUSS, MDATA, MPARMS, NDATA, IPVT(MPARMS)
      DOUBLE PRECISION FJAC(MDATA,MPARMS), PARERR(MPARMS), FNORM,
     *   WA(MPARMS), TOL
C
      INTEGER   IPARMS, J, NPARMS
      DOUBLE PRECISION EPSILN
C-----------------------------------------------------------------------
C                                       Calculate error following
C                                       Argonne write up
      NPARMS = NGAUSS * 3
C                                       Is this right ??????
      EPSILN = FNORM / SQRT(REAL(NDATA-NPARMS))
      IPARMS = NPARMS
      CALL COVAR (IPARMS, FJAC, MDATA, IPVT, TOL, WA)
      DO 10 J = 1,NPARMS
         PARERR(J) = EPSILN * SQRT(FJAC(J,J))
 10      CONTINUE
C
      RETURN
      END

      SUBROUTINE ORIPOL
C-----------------------------------------------------------------------
C! Fills polarization correction table for orientation-elip. model
C# UV EXT-appl Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2010, 2012, 2014, 2017-2018
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Fills polarization correction table for orientation-elip. model
C   Inputs:
C      PANGLE   R(*)   Parallactic angles of the antennas (Rad)
C   Input from common: (DSEL.INC)
C      LAMBDA   R(*)   Wavelength of each channel and IF (m)
C      NLAMDA   I      Number channels in 1-d LAMBDA
C      IFR      R(*)   Faraday rotation of each antenna (rad/m**2)
C      PREFA    I      Polarization reference antenna
C      POLPD    R(*)   'R-L' phase difference (rad)
C   Output:
C      IERR     I      Return error code, 0=>OK else error.
C                        1=table too small, 2=multiple subarrays,
C                        10 = unknown polarization parameterization,
C                        otherwise GETANT error.
C   Output to common DSEL.INC
C      POLCAL   R(2,*)   Polarization correction values in order:
C                        By baseline
C                           By IF (EIF-BIF+1)
C                              A 4x4 complex matrix to be multiplied by
C                                  the observed polarization vector
C                                  (RR,LL,RL,LR) to produce the
C                                  corrected data.
C   Indexing scheme: an entry defined by ant1<ant2 starts in element:
C      (((ant1-1)*numant-((ant1+1)*ant1)/2 + ant2) - 1) + 1
C-----------------------------------------------------------------------
C      REAL      PANGLE(*)
C
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:DPDC.INC'
      INTEGER   IIF, IANT1, IANT2, LIMIT, BLNDX, LIMIT2, I, BLPNT,
     *   LENTRY, LDA, N, INFO, IPVT(4), JOB, LOFF, ICH, IC1, IC2, IFQ,
     *   KR, KL
      REAL      ANG
      DOUBLE PRECISION SR(MAXANT), DR(MAXANT), SL(MAXANT), DL(MAXANT),
     *   ROOT2, PD
      COMPLEX  PA(MAXANT), CPA(MAXANT), PR, PL, RS(MAXANT), RD(MAXANT),
     *   LS(MAXANT), LD(MAXANT), PPSTAR, PRREF, PLREF,  WORK(4), DET(2),
     *   BLMAT(4,4), PDROT, PDROTC
      LONGINT   POLPTR
      LOGICAL FLAGED(MAXANT)
C-----------------------------------------------------------------------
      ROOT2 = 1.0 / SQRT (2.0)
      IF (PDVER.GT.0) THEN
         IC1 = BCHAN
         IC2 = ECHAN
      ELSE
         IC1 = 1
         IC2 = 1
         IFQ = (BCHAN + ECHAN) / 2
         END IF
C                                       Extract parameters and
C                                       precompute some values.
C                                       Loop over IF
      LENTRY = PCLIF * PCLCH * 32
      LIMIT = NSTNS - 1
      DO 500 IIF = BIF,EIF
         DO 490 ICH = IC1,IC2
            CALL LFILL (MAXANT, .FALSE., FLAGED)
            IF (PDVER.GT.0) THEN
               IFQ = ICH
               DO 20 I = 1,NSTNS
                  KR = (4 * PDNUMF * PDNUMI) * (I - 1) +
     *               2 * PDNUMF * (IIF - 1) + 2 * (ICH -1) + 1
                  KL = KR + (2 * PDNUMF * PDNUMI)
                  IF ((DTERMS(PDTERM+KR).EQ.FBLANK) .OR.
     *               (DTERMS(PDTERM+KL).EQ.FBLANK)) THEN
                     FLAGED(I) = .TRUE.
C                                        After some trig manipulations
C                                        factorize the model into
C                                        antenna based factors.
                  ELSE
                     SR(I) = COS (DTERMS(PDTERM+KR)) +
     *                  SIN (DTERMS(PDTERM+KR))
                     DR(I) = COS (DTERMS(PDTERM+KR)) -
     *                  SIN (DTERMS(PDTERM+KR))
                     SL(I) = COS (DTERMS(PDTERM+KL)) +
     *                  SIN (DTERMS(PDTERM+KL))
                     DL(I) = COS (DTERMS(PDTERM+KL)) -
     *                  SIN (DTERMS(PDTERM+KL))
                     PR    = CMPLX (COS (2.0*DTERMS(PDTERM+KR+1)),
     *                  SIN (2.0*DTERMS(PDTERM+KR+1)))
                     PL    = CMPLX (COS (2.0*DTERMS(PDTERM+KL+1)),
     *                  -SIN (2.0*DTERMS(PDTERM+KL+1)))
                     RS(I) = CMPLX (ROOT2*SR(I), 0.0D0)
                     RD(I) = CMPLX (ROOT2*DR(I), 0.0D0) * PR
                     LS(I) = CMPLX (ROOT2*SL(I), 0.0D0) * PL
                     LD(I) = CMPLX (ROOT2*DL(I), 0.0D0)
                     END IF
 20               CONTINUE
C                                       R-L phase difference
               PD = POLPD(ICH+(IIF-1)*PDNUMF)
               IF (FLAGED(PREFA)) THEN
                  PRREF = FBLANK
                  PLREF = FBLANK
               ELSE
                  KR = (4 * PDNUMF * PDNUMI) * (PREFA - 1) +
     *               2 * PDNUMF * (IIF - 1) + 2 * (ICH -1) + 1
                  KL = KR + (2 * PDNUMF * PDNUMI)
                  PRREF = CMPLX (COS (DTERMS(PDTERM+KR+1)),
     *               SIN (DTERMS(PDTERM+KR+1)))
                  PLREF = CMPLX (COS (DTERMS(PDTERM+KL+1)+PD),
     *               -SIN (DTERMS(PDTERM+KL+1)+PD))
                  END IF
            ELSE
               DO 30 I = 1,NSTNS
                  IF ((STNELP(1,IIF,I).EQ.FBLANK) .OR.
     *               (STNELP(2,IIF,I).EQ.FBLANK)) THEN
                     FLAGED(I) = .TRUE.
C                                        After some trig manipulations
C                                        factorize the model into
C                                        antenna based factors.
                  ELSE
                     SR(I) = COS (STNELP(1,IIF,I)) + SIN (STNELP(1,IIF
     *                  ,I))
                     DR(I) = COS (STNELP(1,IIF,I)) - SIN (STNELP(1,IIF
     *                  ,I))
                     SL(I) = COS (STNELP(2,IIF,I)) + SIN (STNELP(2,IIF
     *                  ,I))
                     DL(I) = COS (STNELP(2,IIF,I)) - SIN (STNELP(2,IIF
     *                  ,I))
                     PR    = CMPLX (COS (2.0*STNORI(1,IIF,I)),
     *                  SIN (2.0*STNORI(1,IIF,I)))
                     PL    = CMPLX (COS (2.0*STNORI(2,IIF,I)),
     *                  -SIN (2.0*STNORI(2,IIF,I)))
                     RS(I) = CMPLX (ROOT2*SR(I), 0.0D0)
                     RD(I) = CMPLX (ROOT2*DR(I), 0.0D0) * PR
                     LS(I) = CMPLX (ROOT2*SL(I), 0.0D0) * PL
                     LD(I) = CMPLX (ROOT2*DL(I), 0.0D0)
                     END IF
 30               CONTINUE
C                                       R-L phase difference
               PD = POLPD(IIF)
               IF (FLAGED(PREFA)) THEN
                  PRREF = FBLANK
                  PLREF = FBLANK
               ELSE
                  PRREF = CMPLX (COS (STNORI(1,IIF,PREFA)),
     *               SIN (STNORI(1,IIF,PREFA)))
                  PLREF = CMPLX (COS (STNORI(2,IIF,PREFA)+PD),
     *               -SIN (STNORI(2,IIF,PREFA)+PD))
                  END IF
               END IF
            PDROT = CMPLX (COS (PD), SIN (PD))
            PDROTC = CMPLX (COS (PD), -SIN (PD))
C                                       Paralactic angle, Faraday
C                                       rotation terms
            LOFF = (IIF - 1) * NLAMDA + IFQ
            DO 40 I = 1,NSTNS
               IF (IFR(I).NE.FBLANK) THEN
                  ANG =  -(PANGLE(I) + LAMBDA(LOFF)**2 * IFR(I))
               ELSE
                  ANG = -PANGLE(I)
                  END IF
               PA(I) = CMPLX (COS (2.0*ANG), -SIN (2.0*ANG))
               CPA(I) = CONJG (PA(I))
 40            CONTINUE
C                                       Compute correction matrices.
            LENTRY = 32 * PCLCH * PCLIF
            LIMIT = NSTNS - 1
            DO 480 IANT1 = 1,LIMIT
               LIMIT2 = IANT1 + 1
               DO 470 IANT2 = LIMIT2,NSTNS
                  IF ((FLAGED(IANT1)) .OR. (FLAGED(IANT2))) THEN
                     CALL RFILL (32, FBLANK, BLMAT)
C                                       Set baseline index
                  ELSE
                     BLNDX = ((IANT1-1)*NSTNS) - (((IANT1-1)*IANT1)/2) +
     *                  IANT2
                     BLPNT = LENTRY * (BLNDX-1) + (IIF-BIF)*32*PCLCH + 1
     *                  + (ICH-IC1) * 32
C                                       Matrix terms
                     BLMAT(1,1) = RS(IANT1) * CONJG(RS(IANT2))
                     BLMAT(1,2) = RD(IANT1) * CONJG(RD(IANT2))*PA(IANT1)
     *               * CPA(IANT2)
                     BLMAT(1,3) = RS(IANT1) * CONJG(RD(IANT2)) *
     *                  CPA(IANT2)
                     BLMAT(1,4) = RD(IANT1) * CONJG(RS(IANT2))*PA(IANT1)
                     BLMAT(2,1) = LS(IANT1) * CONJG(LS(IANT2)) *
     *                  CPA(IANT1) * PA(IANT2)
                     BLMAT(2,2) = LD(IANT1) * CONJG(LD(IANT2))
                     BLMAT(2,3) = LS(IANT1) * CONJG(LD(IANT2)) *
     *                  CPA(IANT1)
                     BLMAT(2,4) = LD(IANT1) * CONJG(LS(IANT2))*PA(IANT2)
                     PPSTAR = PRREF * CONJG (PLREF)
                     BLMAT(3,1) = PPSTAR * RS(IANT1) * CONJG(LS(IANT2))
     *                  * PA(IANT2)
                     BLMAT(3,2) = PPSTAR * RD(IANT1) * CONJG(LD(IANT2))
     *                  * PA(IANT1)
                     BLMAT(3,3) = PPSTAR * RS(IANT1) * CONJG(LD(IANT2))
                     BLMAT(3,4) = PPSTAR * RD(IANT1) * CONJG(LS(IANT2))
     *                  * PA(IANT1) * PA(IANT2)
                     PPSTAR = PLREF * CONJG (PRREF)
                     BLMAT(4,1) = PPSTAR * LS(IANT1) * CONJG(RS(IANT2))
     *                  * CPA(IANT1)
                     BLMAT(4,2) = PPSTAR * LD(IANT1) * CONJG(RD(IANT2))
     *                  * CPA(IANT2)
                     BLMAT(4,3) = PPSTAR * LS(IANT1) * CONJG(RD(IANT2))
     *                  * CPA(IANT1) * CPA(IANT2)
                     BLMAT(4,4) = PPSTAR * LD(IANT1) * CONJG(RS(IANT2))
C                                       Invert baseline-IF matrix.
                     LDA = 4
                     N = 4
C                                       Factorize matrix
                     CALL CGEFA (BLMAT, LDA, N, IPVT, INFO)
C                                       Check for singularity
                     IF (INFO.EQ.0) THEN
                        JOB = 1
                        CALL CGEDI (BLMAT, LDA, N, IPVT, DET, WORK, JOB)
C                                       Rotate RL, LR by PD
                        BLMAT(3,1) = PDROT * BLMAT(3,1)
                        BLMAT(3,2) = PDROT * BLMAT(3,2)
                        BLMAT(3,3) = PDROT * BLMAT(3,3)
                        BLMAT(3,4) = PDROT * BLMAT(3,4)
                        BLMAT(4,1) = PDROTC * BLMAT(4,1)
                        BLMAT(4,2) = PDROTC * BLMAT(4,2)
                        BLMAT(4,3) = PDROTC * BLMAT(4,3)
                        BLMAT(4,4) = PDROTC * BLMAT(4,4)
                     ELSE
C                                          Deal with singular matrix
                        WRITE (MSGTXT,1500) IANT1, IANT2, IIF, ICH
                        CALL MSGWRT (8)
C                                       Zero matrix
                        CALL RFILL (32, FBLANK, BLMAT)
                        END IF
                     END IF
                  POLPTR = PPOLCL + BLPNT
                  CALL RCOPY (32, BLMAT, POLCAL(POLPTR))
 470              CONTINUE
 480           CONTINUE
 490        CONTINUE
 500     CONTINUE
C
 999  RETURN
C-----------------------------------------------------------------------
 1500 FORMAT ('SINGULAR MATRIX ON',I3,' -',I3,' IF,CH=',I3,I6,
     *   ' WILL ZERO')
      END

      SUBROUTINE POLISH
C-----------------------------------------------------------------------
C! parses the input text buffer, building stacks; executes pseudoverbs
C# POPS-lang
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   POLISH parses the character string in KARBUF translating to Polish
C   postfix notation.  Result is a sequence of integers representing
C   code for the POPS interpreter.  Negative tokens are operand pointers
C   while positive tokens are operation codes.  The array A (eqiv. to
C   STACK) holds these; AP points to the last entry.
C   POLISH also causes all pseudo verbs to be executed.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   A(100), B(100), POTERR, NOTHNG, JTAG, MODIFY, ENDMOD,
     *   BRANCH, I
      LOGICAL   WASPS
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCON.INC'
      INCLUDE 'INCS:DERR.INC'
      INCLUDE 'INCS:DPOP.INC'
      INCLUDE 'INCS:DSMS.INC'
      INCLUDE 'INCS:DIO.INC'
      EQUIVALENCE (STACK(1), A(1)), (CSTACK(1), B(1))
      DATA NOTHNG /0/
      DATA PRGNAM /'POLISH'/
      DATA MODIFY, ENDMOD / 139, 2/
C-----------------------------------------------------------------------
      LEVEL = 0
      AP = 0
      BP = 0
      IFFLAG = 0
      LAST = NOTHNG
C                                       Parse tokens.
 10   CALL COMPIL
      IF (ERRNUM.NE.0) GO TO 980
      WASPS = .FALSE.
C                                       Pseudo operators.
      IF (SYTYPE.EQ.5) THEN
         JTAG = TAG
C                                       basic operators
         IF (JTAG.LT.120) THEN
            BRANCH = JTAG - 99
            CALL PSEUDO (BRANCH)
            IF (ERRNUM.NE.0) GO TO 980
            GO TO 10
            END IF
C                                       proc editing
         IF (JTAG.GE.130) GO TO 25
            BRANCH = JTAG - 119
            CALL EDITOR (BRANCH)
            IF (ERRNUM.NE.0) GO TO 980
            IF (MODE.NE.3) THEN
               WASPS = .TRUE.
               GO TO 65
               END IF
            JTAG = MODIFY
C                                       store code
 25      IF (JTAG.LT.150) THEN
            BRANCH = JTAG - 129
            CALL STORES (BRANCH)
            IF (ERRNUM.NE.0) GO TO 980
C                                       RESTORE/GET ... only 1 on line
            IF ((MODE.NE.3) .OR. (BRANCH.GT.5)) THEN
               WASPS = .TRUE.
               GO TO 65
               END IF
C                                       friendly verbs (imm. arg.)
         ELSE
            BRANCH = JTAG - 149
            CALL HELPS (BRANCH)
            IF (ERRNUM.NE.0) GO TO 980
C                                       RUN only one on line
            IF (BRANCH.EQ.1) THEN
               WASPS = .TRUE.
               GO TO 65
               END IF
            END IF
         GO TO 10
         END IF
C                                       Add OMEGA operator.
      CALL PUSH (A, AP, 1)
      IF (ERRNUM.NE.0) GO TO 980
      POTERR = 3
      IF (LEVEL.NE.0) GO TO 980
 65   IF ((MODE.NE.0) .AND. (AP.NE.0)) CALL STORES (1)
      IF (ERRNUM.NE.0) GO TO 980
C                                       Finish Modify
      IF (MODE.EQ.3) THEN
         BRANCH = ENDMOD
         CALL EDITOR (BRANCH)
         IF (ERRNUM.NE.0) GO TO 980
         END IF
C                                       block execution after pseudos
      IF ((.NOT.WASPS) .OR. (MODE.NE.0)) GO TO 85
         IF (AP.GT.1) GO TO 80
         IF ((KBPTR.LE.1) .OR. (KBPTR.GT.KARLIM)) GO TO 85
            DO 75 I = KBPTR,KARLIM
               IF ((KARBUF(I:I).NE.' ') .AND. (KARBUF(I:I).NE.';'))
     *            GO TO 80
 75            CONTINUE
            GO TO 85
 80      CONTINUE
            WRITE (MSGTXT,1080)
            CALL MSGWRT (6)
 85   IF (WASPS) AP = 0
      IF (AP.EQ.0) CALL PUSH (A, AP, 1)
      IF (ERRNUM.NE.0) GO TO 980
      GO TO 999
C                                       Error return.
 980  IF (ERRNUM.EQ.0) ERRNUM = POTERR
      ERRLEV = ERRLEV + 1
      IF (ERRLEV.LE.5) PNAME(ERRLEV) = PRGNAM
C
 999  RETURN
C-----------------------------------------------------------------------
 1080 FORMAT ('A PSEUDOVERB HAS CAUSED THE VERBS ON THE LINE TO BE ',
     *   'IGNORED')
      END

LOCAL INCLUDE 'UVBAS.INC'
C                                       Local include for UVBAS
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XSOUR(4,30), XCALC(1), XNAMOU(3),
     *   XCLAOU(2)
      REAL      XSIN, XDISIN, XQUAL, XTIME(8), XBAND, XFREQ, XFQID,
     *   XSUBA, XBIF, XEIF, XDOCAL, XGUSE, XDOPOL, XPDVER, XBLVER,
     *   XFLAG, XDOBND, XBPVER, XSMOTH(3), XDOAC, XSOUT, XDISO, XBCHAN,
     *   XECHAN, APARM(10), BADD(10),  BUFF1(UVBFSS), BUFF2(UVBFSS)
      INTEGER   SEQIN, SEQOUT, DISKIN, DISKO, LBCHAN, LECHAN,
     *   JBUFSZ, ILOCWT, CATOLD(256), INCSI, INCFI, INCIFI, INCSO,
     *   INCFO, INCIFO, LRECI, LRECO, NRPRMI, NRPRMO, OLDCNO, NEWCNO,
     *   LBIF
      LOGICAL   ISCOMP
      CHARACTER NAMEIN*12, CLAIN*6, NAMOUT*12, CLAOUT*6
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XSOUR, XQUAL, XCALC,
     *   XTIME, XBAND, XFREQ, XFQID, XSUBA, XBIF, XEIF, XDOCAL, XGUSE,
     *   XDOPOL, XPDVER, XBLVER, XFLAG, XDOBND, XBPVER, XSMOTH, XDOAC,
     *   XNAMOU, XCLAOU, XSOUT, XDISO, XBCHAN, XECHAN, APARM, BADD
      COMMON /CHARPM/ NAMEIN, CLAIN, NAMOUT, CLAOUT
      COMMON /BUFRS/ BUFF1, BUFF2, JBUFSZ
      COMMON /INFO/ CATOLD, SEQIN, SEQOUT, DISKIN, DISKO, LBCHAN,
     *   LECHAN, ILOCWT, INCSI, INCFI, INCIFI, INCSO, INCFO, INCIFO,
     *   LRECI, LRECO, NRPRMI, NRPRMO, ISCOMP, OLDCNO, NEWCNO, LBIF
LOCAL END
      PROGRAM UVBAS
C-----------------------------------------------------------------------
C! Averages several channels and subtracts from uv data.
C# Utility UV UV-util VLA VLB SPECTRAL
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2000, 2008-2011, 2018, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   UVBAS averages a set of channels and subtracts them from another
C   range of channels.
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C                                   Default output is input file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      BCHAN          LBCHAN         Lowest channel number.
C      ECHAN          LECHAN         Highest channel number.
C      APARM(10)      APARM         Specification of region to average
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER  IRET
      INCLUDE 'UVBAS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA PRGM /'UVBAS '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL UVBAIN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Filter data.
      CALL UVBAUV (IRET)
      IF (IRET.NE.0) GO TO 990
      CALL UVBAHI
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE UVBAIN (PRGN, JERR)
C-----------------------------------------------------------------------
C   UVBAIN gets input parameters for UVBAS and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Output in common:
C      LBCHAN   I  Lowest channel number to write.
C      LECHAN   I  Highest channel number to write.
C      ISCOMP  L  If true data is compressed
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      CHARACTER STAT*4, BLANK*6, PTYPE*2
      INTEGER   IROUND, NPARM, IERR, INCX, I, LUN
      LOGICAL   T, MATCH
      REAL      RPARM(20), CATR(256)
      HOLLERITH CATH(256)
      INCLUDE 'UVBAS.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DSEL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      EQUIVALENCE (CATBLK, CATR, CATH)
      DATA BLANK  /' '/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (T)
      CALL VHDRIN
      CALL SELINI
      JBUFSZ = UVBFSS * 2
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 184
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, BUFF1, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      DO 5 I = 1,10
         IBAD(I) = IROUND(BADD(I))
 5       CONTINUE
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (4, 1, XCALC, SELCOD)
      DO 10 I = 1,30
         CALL H2CHR (16, 1, XSOUR(1,I), SOURCS(I))
 10      CONTINUE
      SELQUA = IROUND (XQUAL)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
      SEQIN = IROUND (XSIN)
      SEQOUT = IROUND (XSOUT)
      DISKIN = IROUND (XDISIN)
      DISKO = IROUND (XDISO)
      DOCAL = XDOCAL.GT.0.0
      DOWTCL = DOCAL .AND. (XDOCAL.LE.99.0)
      DOACOR = XDOAC.GT.0.0
C                                       Info for UVGET:
C                                       Put selection criteria into
C                                       correct common.
      UNAME = NAMEIN
      UCLAS = CLAIN
      UDISK = DISKIN
      USEQ = SEQIN
C                                       Set time range.
      CALL RCOPY (8, XTIME, TIMRNG)
      IF ((TIMRNG(1)+TIMRNG(2)+TIMRNG(3)+TIMRNG(4)) .EQ.0.0)
     *   TIMRNG(1)=-1.0E6
      IF ((TIMRNG(5)+TIMRNG(6)+TIMRNG(7)+TIMRNG(8)) .EQ.0.0)
     *   TIMRNG(5)=1.0E6
      TSTART = TIMRNG(1) + TIMRNG(2) / 24. + TIMRNG(3) / (24. * 60.) +
     *   TIMRNG(4) / (24. * 60. * 60.)
      TEND = TIMRNG(5) + TIMRNG(6) / 24. + TIMRNG(7) / (24. * 60.) +
     *   TIMRNG(8) / (24. * 60. * 60.)
      DOPOL = IROUND(XDOPOL)
      IF (XDOPOL.GT.0.0) DOPOL = MAX (1, DOPOL)
      PDVER = IROUND (XPDVER)
      DOAPPL = .FALSE.
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LT.0) SUBARR = 0
      FGVER = IROUND (XFLAG)
      DOBAND = IROUND (XDOBND)
      BPVER = IROUND (XBPVER)
      CALL RCOPY (3, XSMOTH, SMOOTH)
      CLVER = IROUND (XGUSE)
      CLUSE = IROUND (XGUSE)
      BLVER = IROUND (XBLVER)
C                                       Must specify baseline windows
C                                       (APARM).
      IF ((APARM(1).LE.0.1) .OR. (APARM(2).LE.0.1) .OR.
     *   (APARM(3).LE.0.1) .OR. (APARM(4).LE.0.1)) THEN
         JERR = 9
         MSGTXT = 'YOU MUST FULLY SPECIFY AVERAGING WINDOWS (APARM)'
         GO TO 990
         END IF
C                                       Create new file.
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Save input CATBLK
      CALL COPY (256, CATBLK, CATOLD)
C                                       Compressed data?
      ISCOMP = CATBLK(KINAX).EQ.1
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Channel selection?
      IF (JLOCIF.LT.0) THEN
         BIF = 1
         EIF = 1
      ELSE
         BIF = IROUND (XBIF)
         EIF = IROUND (XEIF)
         BIF = MIN (MAX (1, BIF), CATBLK(KINAX+JLOCIF))
         IF (EIF.LT.BIF) EIF = CATBLK(KINAX+JLOCIF)
         END IF
      LBIF = BIF
C                                       Freq id
      IF (XBAND.GT.0.0) SELBAN = XBAND
      IF (XFREQ.GT.0.0) SELFRQ = XFREQ
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.EQ.0) FRQSEL = -1
      LUN = 28
      CALL FQMATC (DISKIN, OLDCNO, CATBLK, LUN, SELBAN, SELFRQ, MATCH,
     *   FRQSEL, JERR)
      IF (.NOT.MATCH) THEN
         MSGTXT = 'NO MATCH TO SELBAND/SELFREQ ADVERBS - CHECK INPUTS'
         JERR = 1
         GO TO 990
         END IF
      IF (JERR.GT.0) GO TO 999
C                                       Set BCHAN,ECHAN
      LBCHAN = IROUND (XBCHAN)
      LBCHAN = MAX (LBCHAN, 1)
      LBCHAN = MIN (LBCHAN, CATBLK(KINAX+JLOCF))
      LECHAN = IROUND (XECHAN)
      IF (LECHAN.LE.0) LECHAN = CATBLK(KINAX+JLOCF)
      LECHAN = MAX (LECHAN, LBCHAN)
      LECHAN = MIN (LECHAN, CATBLK(KINAX+JLOCF))
C                                       now using cal system -
C                                       UVGET makes header
      CALL UVGET ('INIT', RPARM, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1035) IERR
         GO TO 990
         END IF
      CALL UVGET ('CLOS', RPARM, BUFF1, IERR)
C                                       Save input file info
      INCX = CATBLK(KINAX)
      LRECI = LREC
      NRPRMI = NRPARM
      INCSI = INCS / INCX
      INCFI = INCF / INCX
      INCIFI = INCIF / INCX
C                                       Put new values in CATBLK.
      CALL MAKOUT (NAMEIN, CLAIN, SEQIN, BLANK, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
      CATBLK(KIIMS) = SEQOUT
C                                       read compressed => write compr.
      IF (ISCOMP) THEN
         CATBLK(KINAX) = 1
         I = CATBLK(KIPCN)
         CALL CHR2H (8, 'WEIGHT  ', 1, CATH(KHPTP+2*I))
         CALL CHR2H (8, 'SCALE   ', 1, CATH(KHPTP+2*I+2))
         CATBLK(KIPCN) = I + 2
         ILOCWT = I
         END IF
C                                       Frequency axis
      CATBLK(KINAX+JLOCF) = LECHAN - LBCHAN + 1
      CATR(KRCRP+JLOCF) = CATR(KRCRP+JLOCF) - LBCHAN + 1
      CATR(KRARP) = CATR(KRARP) - LBCHAN + 1
C                                       Create output file.
      CCNO = 1
      FRW(NCFILE+1) = 3
      JERR = 4
      CALL UVCREA (DISKO, CCNO, BUFF1, IERR)
      IF (IERR.NE.0) THEN
         IF (IERR.NE.2) THEN
            WRITE (MSGTXT,1050) IERR
            GO TO 990
            END IF
C                                       Only overwrite Input file
C                                       no destroy existing otherwise
         IF ((CCNO.NE.OLDCNO) .OR. (DISKO.NE.DISKIN)) THEN
            WRITE (MSGTXT,1060)
            GO TO 990
            END IF
C                                       Recover existing CATBLK
         FRW(NCFILE+1) = 2
         CALL CATIO ('READ', DISKO, CCNO, CATBLK, 'WRIT', BUFF1, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1065) IERR
            CALL MSGWRT (6)
            END IF
         END IF
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CCNO
      FRW(NCFILE) = FRW(NCFILE) - 1
      NEWCNO = CCNO
C                                       Save output file info
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
      INCX = CATBLK(KINAX)
      LRECO = LREC
      NRPRMO = NRPARM
      INCSO = INCS / INCX
      INCFO = INCF / INCX
      INCIFO = INCIF / INCX
C                                        Put input file in READ
      PTYPE = 'UV'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, 'READ', BUFF1, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 0
      JERR = 0
      SEQOUT = CATBLK(KIIMS)
C                                       copy header keywords
      CALL KEYCOP (DISKIN, OLDCNO, DISKO, CCNO, IERR)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVBAIN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1035 FORMAT ('UVGET INIT ERROR',I3,' CHECK ADVERBS')
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
 1050 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
 1060 FORMAT ('MAY OVERWRITE INPUT FILE ONLY.  QUITTING')
 1065 FORMAT ('UVBAIN: ERROR',I3,' UPDATING NEW CATBLK')
      END
      SUBROUTINE UVBAUV (IRET)
C-----------------------------------------------------------------------
C   UVBAUV sends uv data one point at a time to the filtering
C   routine and then writes the modified data if requested.
C   Input in common:
C      BCHAN   I  Lowest channel number to write.
C      ECHAN   I  Highest channel number to write.
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C      ISCOMP  L  If true data is compressed
C   Output:
C      IRET    I  Return code, 0 => OK, otherwise abort.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER OFILE*48
      INTEGER   IPTRO, LUNO, INDO, ILENBU, KBIND, NIOUT, NIOLIM, BO, VO,
     *   NUMVIS, XCOUNT, NCORO, NCOPY, CATMP(256), RNXRET
      LOGICAL   T, F
      INCLUDE 'UVBAS.INC'
      REAL      VIS(UVBFSS), RESULT(UVBFSS), RPARM(20)
      DOUBLE PRECISION UVSCAL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (VIS, BUFF1)
      DATA LUNO /17/
      DATA VO, BO /0, 1/
      DATA T, F /.TRUE.,.FALSE./
C-----------------------------------------------------------------------
C                                       Number of visibilities in input
C                                       and output files.
      NCORO = (LRECO - NRPRMO)
      IF (.NOT.ISCOMP) NCORO = NCORO / 3
      NCOPY = LRECO - NRPRMO
C                                       Open and init for read
C                                       defend cat header from UVGET
      CALL COPY (256, CATBLK, CATMP)
      CALL UVGET ('INIT', RPARM, VIS, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
      CALL COPY (256, CATMP, CATBLK)
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CCNO, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      ILENBU = 0
      CALL UVINIT ('WRIT', LUNO, INDO, NVIS, VO, LRECO, ILENBU, JBUFSZ,
     *   BUFF2, BO, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1020) IRET
         GO TO 990
         END IF
      IPTRO = KBIND
      NIOUT = 0
      NIOLIM = ILENBU
      NUMVIS = 0
      XCOUNT = 0
C                                       make an index table
      CALL RNXGET (DISKIN, OLDCNO, CATOLD)
      CALL RNXINI (DISKO, NEWCNO, CATBLK, RNXRET)
      IF ((FREQ.GT.0.0D0) .AND. (UVFREQ.GT.0.0D0)) THEN
         UVSCAL = FREQ / UVFREQ
      ELSE
         UVSCAL = 1.0D0
         END IF
C                                       Loop
C                                       Read vis. record.
 100  CALL UVGET ('READ', RPARM, VIS, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1100) IRET
         GO TO 990
C                                       Loop over
      ELSE IF (IRET.EQ.0) THEN
         NUMVIS = NUMVIS + 1
         RPARM(1+ILOCU) = RPARM(1+ILOCU) * UVSCAL
         RPARM(1+ILOCV) = RPARM(1+ILOCV) * UVSCAL
         RPARM(1+ILOCW) = RPARM(1+ILOCW) * UVSCAL
         CALL UVBASE (NUMVIS, VIS, RESULT, IRET)
C                                       Branch on his return
C                                       Error (fatal)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            GO TO 990
C                                       Copy to output.
         ELSE IF (IRET.EQ.0) THEN
            XCOUNT = XCOUNT + 1.0D0
C                                       update NX table
            CALL RNXUPD (RPARM, RNXRET)
            CALL RCOPY (NRPRMI, RPARM, BUFF2(IPTRO))
            IF (ISCOMP) THEN
               CALL ZUVPAK (NCORO, RESULT, BUFF2(IPTRO+ILOCWT),
     *            BUFF2(IPTRO+NRPRMO))
            ELSE
               CALL RCOPY (NCOPY, RESULT, BUFF2(IPTRO+NRPRMO))
               END IF
            IPTRO = IPTRO + LRECO
            NIOUT = NIOUT + 1
            END IF
C                                       Write vis record.
         IF (NIOUT.GE.NIOLIM) THEN
            CALL UVDISK ('WRIT', LUNO, INDO, BUFF2, NIOLIM, KBIND, IRET)
            IF (IRET.NE.0) THEN
               WRITE (MSGTXT,1150) IRET
               GO TO 990
               END IF
            IPTRO = KBIND
            NIOUT = 0
            END IF
C                                       Read next buffer.
         GO TO 100
         END IF
C                                       flush UV buffers
      NIOUT = - NIOUT
      CALL UVDISK ('FLSH', LUNO, INDO, BUFF2, NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1150) IRET
         GO TO 990
         END IF
C                                       Compress output file.
      NVIS = XCOUNT
      CALL UCMPRS (NVIS, DISKO, CCNO, LUNO, CATBLK, IRET)
C                                       close NX table
      CALL RNXCLS (RNXRET)
C                                       Close files
      CALL UVGET ('CLOS', RPARM, VIS, IRET)
      CALL ZCLOSE (LUNO, INDO, IRET)
      IRET = 0
      IF (RNXRET.NE.0) THEN
         MSGTXT = 'OUTPUT NX TABLE, IF ANY, IS INCOMPLETE'
         GO TO 990
         END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVBAUV: ERROR',I3,' OPEN-FOR-READ VIS FILE')
 1010 FORMAT ('UVBAUV: ERROR',I3,' OPEN-FOR-WRITE VIS FILE')
 1020 FORMAT ('UVBAUV: ERROR',I3,' INIT-FOR-WRITE VIS FILE')
 1100 FORMAT ('UVBAUV: ERROR',I3,' READING VIS FILE')
 1120 FORMAT ('UVBAUV: UVBASE ERROR',I3)
 1150 FORMAT ('UVBAUV: ERROR',I3,' WRITING VIS FILE')
      END
      SUBROUTINE UVBAHI
C-----------------------------------------------------------------------
C   UVBAHI copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72
      INTEGER   LUN1, LUN2, IERR
      LOGICAL   T
      INCLUDE 'UVBAS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      DATA LUN1, LUN2 /27,28/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Copy/open history file.
      CALL HISCOP (LUN1, LUN2, DISKIN, DISKO, OLDCNO, NEWCNO, CATBLK,
     *   BUFF1, BUFF2, IERR)
      IF (IERR.GT.2) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 200
         END IF
C                                       New history
      CALL HENCO1 (TSKNAM, NAMEIN, CLAIN, SEQIN, DISKIN, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN2, BUFF2,
     *   IERR)
      IF (IERR.NE.0) GO TO 200
C                                       calibration adverbs
      CALL CALHIS (LUN2, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       BCHAN,ECHAN
      WRITE (HILINE,2000) TSKNAM, LBCHAN, LECHAN
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       APARM
      WRITE (HILINE,2001) TSKNAM, APARM(1), APARM(2), APARM(3), APARM(4)
      CALL HIADD (LUN2, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Close HI file
 200  CALL HICLOS (LUN2, T, BUFF2, IERR)
C                                        Copy tables
C                                        Copy tables
      CALL COPTAB (DISKIN, OLDCNO, DISKO, NEWCNO, IERR)
      IF (IERR.GT.2) THEN
         MSGTXT = 'UVBAHI: ERROR COPYING TABLES TO OUTPUT'
         CALL MSGWRT (6)
         END IF
C                                        Update CATBLK.
      CALL CATIO ('UPDT', DISKO, NEWCNO, CATBLK, 'REST',
     *   BUFF1, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('UVBAHI: ERROR',I3,' COPY/OPEN HISTORY FILE')
 2000 FORMAT (A6,' BCHAN =',I4,', ECHAN =',I4,' / Channel selection')
 2001 FORMAT (A6,' APARM =',3(F6.0,','),F6.0,' / Baseline windows')
      END
      SUBROUTINE UVBASE (NUMVIS, VIS, RESULT, IRET)
C-----------------------------------------------------------------------
C   Routine to average channels, interpolate and subtract.
C   Inputs:
C      NUMVIS  I    Visibility number, -1 => final call, no data
C                   passed but allows any operations to be completed.
C      VIS     R(3,*)  Visibilities in order real, imaginary, weight
C                   (Jy, Jy, unitless).  Weight <= 0 => flagged.
C                   NOTE: INCX may be any value .GE. 2
C   Inputs from COMMON:
C      APARM   R(10) 1&2, 3&4 give boxes to average.
C      BCHAN   I  Lowest channel number to write.
C      ECHAN   I  Highest channel number to write.
C      LRECI   I  Input file record length
C      NRPRMI  I  Input number of random parameters.
C      INCSI   I  Input Stokes' increment in vis.
C      INCFI   I  Input frequency increment in vis.
C      INCIFI  I  Input IF increment in vis.
C      LRECO   I  Output file record length
C      NRPRMO  I  Output number of random parameters.
C      INCSO   I  Output Stokes' increment in vis.
C      INCFO   I  Output frequency increment in vis.
C      INCIFO  I  Output IF increment in vis.
C   Output:
C      RESULT  R(3,*) Output visibilities selected in frequency.
C      IRET    I  Return code  -1 => don't write
C                               0 => OK
C                              >0 => error, terminate.
C   Output in COMMON:
C      CATBLK    I         Catalog header block
C-----------------------------------------------------------------------
      INTEGER   NUMVIS, IRET
      REAL      VIS(3,*), RESULT(3,*)
C
      INTEGER   LIMIT1, LIMIT2, LOOP, NFREQ, NIF, NPOLN, INDEX, OFF, IS,
     *   IIF, INDEX2
      REAL      SUMRB, SUMIB, COUNTB, SUMRE, SUMIE, COUNTE, COUNT,
     *   AVGR, AVGI, AVGA, AVGP, AVGRB, AVGIB, AVGAB, AVGPB, AVGRE,
     *   AVGIE, AVGAE, AVGPE, WTE, WTB, TWOPI, PHSCHK, CHB, CHE, CHSEP
      LOGICAL   FLGWT
      INCLUDE 'UVBAS.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DCAT.INC'
      SAVE NPOLN, NFREQ, NIF, CHB, CHE, CHSEP, PHSCHK, TWOPI
C-----------------------------------------------------------------------
      IF (NUMVIS.EQ.1) THEN
C                                       Set up on first call
         TWOPI = 8.0 * ATAN (1.0)
         PHSCHK = 4.0 * ATAN (1.0)
         NPOLN = CATBLK(KINAX+JLOCS)
         NFREQ = CATBLK(KINAX+JLOCF)
         IF (JLOCIF.GT.0) THEN
            NIF = CATBLK(KINAX+JLOCIF)
         ELSE
            NIF = 1
            END IF
         CHB = (APARM(2) + APARM(1)) / 2.0
         CHE = (APARM(4) + APARM(3)) / 2.0
         CHSEP = CHE - CHB
         CHSEP = MAX (1.0, CHSEP)
         END IF
      IRET = 0
      IF (NUMVIS.GT.0) THEN
C                                       Loop over IF
         DO 400 IIF = 1,NIF
C                                       Loop over Stokes
            DO 350 IS = 1,NPOLN
C                                       Offset in Stokes and IF
               OFF = (IS - 1) * INCSI + (IIF - 1) * INCIFI + 1
               LIMIT1 = APARM(1) + 0.5
               LIMIT2 = APARM(2) + 0.5
               SUMRB = 0.0
               SUMIB = 0.0
               COUNTB = 0.0
               SUMRE = 0.0
               SUMIE = 0.0
               COUNTE = 0.0
               INDEX = OFF + (LIMIT1-1) * INCFI
C                                       Interpolate in Amp and phase.
C                                       Sum Start patch
               DO 100 LOOP = LIMIT1,LIMIT2
                  IF (VIS(3,INDEX).GT.0.0) THEN
                     SUMRB = SUMRB + VIS(1,INDEX)
                     SUMIB = SUMIB + VIS(2,INDEX)
                     COUNTB = COUNTB + 1.0
                     END IF
                  INDEX = INDEX + INCFI
 100              CONTINUE
               LIMIT1 = APARM(3) + 0.5
               LIMIT2 = APARM(4) + 0.5
               INDEX = OFF + (LIMIT1-1) * INCFI
C                                       Sum end patch
               DO 200 LOOP = LIMIT1,LIMIT2
                  IF (VIS(3,INDEX).GT.0.0) THEN
                     SUMRE = SUMRE + VIS(1,INDEX)
                     SUMIE = SUMIE + VIS(2,INDEX)
                     COUNTE = COUNTE + 1.0
                     END IF
                  INDEX = INDEX + INCFI
 200              CONTINUE
C                                       Beginning average
               AVGRB = 0.0
               AVGIB = 0.0
               COUNT = 0.0
               IF (COUNTB.GT.0.1) THEN
                  AVGRB = SUMRB / COUNTB
                  AVGIB = SUMIB / COUNTB
                  COUNT = 1.0
                  END IF
               AVGAB = SQRT (AVGRB*AVGRB + AVGIB*AVGIB)
               AVGPB = ATAN2 (AVGIB, AVGRB+1.0E-20)
C                                       End average
               AVGRE = 0.0
               AVGIE = 0.0
               IF (COUNTE.GT.0.1) THEN
                  AVGRE = SUMRE / COUNTE
                  AVGIE = SUMIE / COUNTE
                  COUNT = COUNT + 1.0
                  END IF
               AVGAE = SQRT (AVGRE*AVGRE + AVGIE*AVGIE)
               AVGPE = ATAN2 (AVGIE, AVGRE+1.0E-20)
C                                       To interpolate in phase - assume
C                                       difference is less than 180 deg.
               IF (ABS (AVGPE-AVGPB) .GT. PHSCHK) AVGPE = AVGPE - TWOPI
     *            * NINT ((AVGPE-AVGPB) / TWOPI)
               FLGWT = COUNT.LE.0.1
               INDEX = OFF + (LBCHAN - 1) * INCFI
               INDEX2 =  (IS - 1) * INCSO + (IIF - 1) * INCIFO + 1
      INCLUDE 'INCS:ZVND.INC'
               DO 300 LOOP = LBCHAN,LECHAN
C                                       Interpolate correct weights
                  WTB = 0.0
                  IF (LOOP.LE.CHB) THEN
C                                       At beginning
                     WTB = 1.0
                  ELSE IF (LOOP.GE.CHE) THEN
C                                       At end
                     WTB = 0.0
                  ELSE
C                                       Between - interpolate
                     WTB = (CHE-LOOP) / CHSEP
                     END IF
                  WTE = 1.0 - WTB
C                                       Get interpolated value
                  AVGA = WTB * AVGAB + WTE * AVGAE
                  AVGP = WTB * AVGPB + WTE * AVGPE
C                                       Convert to real, imaginary
                  AVGR = AVGA * COS (AVGP)
                  AVGI = AVGA * SIN (AVGP)
C                                       Subtract from vis.
                  RESULT(1,INDEX2) = VIS(1,INDEX) - AVGR
                  RESULT(2,INDEX2) = VIS(2,INDEX) - AVGI
                  RESULT(3,INDEX2) = VIS(3,INDEX)
                  IF (FLGWT) RESULT(3,INDEX2) = - ABS (VIS(3,INDEX))
                  INDEX = INDEX + INCFI
                  INDEX2 = INDEX2 + INCFO
 300              CONTINUE
 350           CONTINUE
 400        CONTINUE
         END IF
C
 999  RETURN
      END

      SUBROUTINE CHWMAT (NPM, PS, IPT, NTS, TS, EQUAL)
C-----------------------------------------------------------------------
C! matches a pattern string having wild-card chars with a test string
C# Character Catalog
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   CHWMAT matches a pattern string containing "wild-card" characters
C   with a test string.  The wild cards '*' for any number and ? for
C   exactly 1 of any character are supported.
C   Inputs: NPM    I         Length of test string (not incl NTS-1
C                            characters)
C           PS     C*(*)     Pattern string
C           IPT    I(NPM)    Pattern array prepared by PSFORM
C           NTS    I         Start char position in TS for testing
C           TS     C*(*)     Test string
C   Output: EQUAL  L         T => they match
C-----------------------------------------------------------------------
      CHARACTER PS*(*), TS*(*)
      INTEGER   NPM, NTS, IPT(*)
      LOGICAL   EQUAL
C
      INTEGER   I, NPA, IP, IT, J, NX, LT, LP, NPX, ITRIM
C-----------------------------------------------------------------------
      IP = 1
      IT = NTS
      NPX = NPM + NTS - 1
      NPA = ITRIM (PS)
      IF (NPA.GT.NPM) NPA = NPM
C                                       LOOP over pattern
C                                       real characters, blanks
 10   IF (IPT(IP).LT.0) GO TO 20
         I = MAX (IPT(IP), 1)
         EQUAL = PS(IP:IP+I-1) .EQ. TS(IT:IT+I-1)
         IF (.NOT.EQUAL) GO TO 999
         IP = IP + I
         IT = IT + I
         IF (IT.GT.NPX) GO TO 970
         GO TO 10
C                                       any 1 character
 20   IF (IPT(IP).EQ.-2) GO TO 30
         IP = IP + 1
         IT = IT + 1
         IF (IT.GT.NPX) GO TO 970
         GO TO 10
C                                       any number of characters
 30   CONTINUE
C                                       any more real ones?
         LP = IP + 1
         DO 35 I = LP,NPA
            IF (IPT(I).GT.0) GO TO 40
 35         CONTINUE
         GO TO 970
C                                       Yes: find 1st blank or other
 40      DO 45 J = LP,NPA
            IF (IPT(J).GE.0) GO TO 50
 45         CONTINUE
C                                       search loop for reals
 50      IP = J
         I = IPT(I) + I - J
         NX = NPX - IT - I + 2
         IF (NX.LT.1) GO TO 980
         DO 55 J = 1,NX
            LT = IT + J - 1
            EQUAL = PS(IP:IP+I-1) .EQ. TS(LT:LT+I-1)
            IF (EQUAL) GO TO 60
 55         CONTINUE
         GO TO 980
C                                       Got one
 60      IT = LT + I
         IP = IP + I
         IF (IT.LE.NPX) GO TO 10
C                                       Answers
 970  EQUAL = .TRUE.
      GO TO 999
 980  EQUAL = .FALSE.
C
 999  RETURN
      END

      PROGRAM AVTP
C-----------------------------------------------------------------------
C! Task to position a tape.
C# Tape,  IO-util
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   AVTP is an AIPS system task to position a tape.
C   AIPS Adverbs:
C      INTAPE    R      Tape drive number: 0 => 1.
C      OPCODE    R      Desired operation: 'REWI' rewind
C                       'EOT '  advance to end of tape
C                       'AVFI'  advance or back files
C      NFILES    R      # files for AVFI: > 0 -> advance
C                          = 0 -> back to start of present file
C                          < 0 -> back even further.
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, TNAME*48, OPCODS(3)*4, OPCODE*4
      INTEGER   NOPCOD, ISCR(256),NPARMS, IERR, IROUND, IOP, IFILES,
     *   TVOL, TLUN, TIND, IRET, I
      REAL      TAPEIN, XFILES
      HOLLERITH XOPCOD
      LOGICAL   T, F, RQUICK
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      COMMON /INPRMS/ TAPEIN, XOPCOD, XFILES
      DATA T, F /.TRUE.,.FALSE./
      DATA PRGM /'AVTP  '/
      DATA NOPCOD, OPCODS /3, 'REWI','AVFI','EOT '/
C-----------------------------------------------------------------------
C                                       Init
      CALL ZDCHIN (.TRUE., ISCR)
      NPARMS = 3
      CALL GTPARM (PRGM, NPARMS, RQUICK, TAPEIN, ISCR, IERR)
      IRET = 8
      IF (IERR.NE.0) GO TO 980
C                                       Tapes allowed?
 10   IF ((NPOPS.LE.NINTRN) .AND. (ISBTCH.NE.32000)) GO TO 20
         WRITE (MSGTXT,1010)
         GO TO 970
C                                       Check inputs
 20   IFILES = IROUND (XFILES)
      TVOL = IROUND (TAPEIN)
      IF ((TVOL.EQ.0) .OR. (NTAPED.EQ.1)) TVOL = 1
      IF ((TVOL.GT.0) .AND. (TVOL.LE.NTAPED)) GO TO 30
         WRITE (MSGTXT,1020) TVOL
         GO TO 970
C                                       Change XOPCOD -> Char.
 30   CALL H2CHR (4, 1, XOPCOD, OPCODE)
      DO 35 IOP = 1,NOPCOD
         IF (OPCODE.EQ.OPCODS(IOP)) GO TO 40
 35      CONTINUE
      WRITE (MSGTXT,1035) OPCODE
      GO TO 970
C                                       Resume AIPS
 40   IF (RQUICK) CALL RELPOP (0, ISCR, IERR)
C                                       Open tape
      TLUN = 129 - TVOL
      CALL ZPHFIL ('MT', TVOL, 1, 1, TNAME, IERR)
      CALL ZTPOPN (TLUN, TIND, TVOL, TNAME, 'READ', IERR)
      IF (IERR.EQ.0) GO TO 50
         WRITE (MSGTXT,1040) IERR
         CALL MSGWRT (8)
         GO TO 990
C                                       Branch to operation
 50   GO TO (100, 200, 300), IOP
C                                       REWInd
 100  CONTINUE
         I = 1
         CALL ZTAPE (OPCODS(1), TLUN, TIND, I, IERR)
         GO TO 900
C                                       Advance files
 200  IF (IFILES.LE.0) GO TO 210
         CALL ZTAPE ('ADVF', TLUN, TIND, IFILES, IERR)
         GO TO 900
C                                       Back up files
 210  CONTINUE
         IFILES = 1 - IFILES
         CALL ZTAPE ('BAKF', TLUN, TIND, IFILES, IERR)
         GO TO 900
C                                       Advance to EOT
 300  CONTINUE
         IFILES = 0
         CALL ZTAPE ('AEOI', TLUN, TIND, IFILES, IERR)
         IF (IERR.EQ.0) THEN
            I = ABS (IFILES) - 1
            IF (IFILES.GT.0) WRITE (MSGTXT,1300) I
            IF (IFILES.LT.0) WRITE (MSGTXT,1301) I
            IF (IFILES.EQ.0) MSGTXT = 'Advanced to EOI after ' //
     *         'unknown number of files'
            CALL MSGWRT (3)
            END IF
         GO TO 900
C                                       Close down
 900  IF (IERR.EQ.0) IRET = 0
      IF (IERR.EQ.0) GO TO 910
         WRITE (MSGTXT,1900) IERR
         CALL MSGWRT (8)
 910  CALL ZTPCLS (TLUN, TIND, IERR)
      GO TO 990
C                                       User errors
 970  CALL MSGWRT (8)
 980  RQUICK = .FALSE.
C                                       AIPS standard quit
 990  CALL DIETSK (IRET, RQUICK, ISCR)
C
 999  STOP
C-----------------------------------------------------------------------
 1010 FORMAT ('TAPES ARE NOT ALLOWED IN BATCH JOBS')
 1020 FORMAT ('ILLEGAL TAPE DRIVE NUMBER',I7)
 1035 FORMAT ('UNRECOGNIZED OPCODE = ''',A4,'''')
 1040 FORMAT ('TAPE OPEN ERROR',I7)
 1300 FORMAT ('Advanced to end-of-information after file',I5)
 1301 FORMAT ('Advanced to end-of-information after skipping',I5,'
     *   files')
 1900 FORMAT ('TAPE IO ERROR',I7)
      END

LOCAL INCLUDE 'LAYER.INC'
C                                       inputs
      HOLLERITH XNAM(3), XCLS(2)
      REAL      XSEQ, XDISK, BLC(7), TRC(7), APARM(10), BPARM(10),
     *   CPARM(10), DPARM(10), EPARM(10), PLCOLR(3,10), DOCOLR, DOWT
      COMMON /INPARM/ XNAM, XCLS, XSEQ, XDISK, BLC, TRC, APARM, BPARM,
     *   CPARM, DPARM, EPARM, PLCOLR, DOCOLR, DOWT
      CHARACTER INFILE*36, OUFILE*36, OUFIL2*36
      COMMON /LAYERC/ INFILE, OUFILE, OUFIL2
C                                       headers
      REAL      NEWR(256), OLDR(256), WRKR(256)
      INTEGER   NEWI(256), OLDI(256), WRKI(256)
      HOLLERITH NEWH(256), OLDH(256), WRKH(256)
      DOUBLE PRECISION NEWD(128), OLDD(128), WRKD(128)
      EQUIVALENCE (NEWR, NEWI, NEWD, NEWH)
      EQUIVALENCE (OLDR, OLDI, OLDD, OLDH)
      EQUIVALENCE (WRKR, WRKI, WRKD, WRKH)
      INCLUDE 'INCS:PMAD.INC'
      REAL      BUFF1(MABFSS), BUFF2(MABFSS)
      INTEGER   AX, NROW
      COMMON /LAYERV/ NEWI, OLDI, WRKI, BUFF1, BUFF2, AX, NROW
LOCAL END
      PROGRAM LAYER
C-----------------------------------------------------------------------
C! Makes red-green-blue image from input images.
C# Map
C-----------------------------------------------------------------------
C;  Copyright (C) 2003, 2008, 2022, 2024
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C  Program LAYER will produce a cubed image with 3 planes, each
C  representing one of the colors red, green, and blue.  Each input
C  image makes a weighted contribution to each of the planes of the
C  output image according to the user's input adverbs.
C  Inputs:  Adverbs from AIPS
C     OUTNAME   R(3)   Name of output image.
C     OUTCLASS  R(2)   Class of the output image.
C     OUTSEQ    R   Sequence number of the output image.
C     OUTDISK   R   Disk number for output image.
C     BLC       R(7)   Bottom left corner of input cube. 0=> 1,1,1
C     TRC       R(7)   Top right corner of input cube. 0=> max.
C     APARM     I(10)  disk numbers
C     BPARM     I(10)  catalog numbers
C     CPARM     R(10)  absorption factors
C     DPARM     R(10)  emission factors
C     PLCOLORS  R(3,10) color factors
C     DOCOLOR   L      absorption colored?
C     DOWEIGHT  L      emission weighted?
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   IERR, INLUN, IOTLUN, IOTLU2, IHINL, IHOTL, I, ID, IS,
     *   IDG, ISG
      INCLUDE 'INCS:DBUF.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'LAYER.INC'
      DATA PRGNAM /'LAYER '/
      DATA INLUN, IOTLUN, IOTLU2, IHINL, IHOTL /16,17,18, 27,28/
C-----------------------------------------------------------------------
C                                       Set up, get parms, open, create
C                                       all files.
      CALL SETUP (PRGNAM, INLUN, IOTLUN, IOTLU2, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Add in an image
      DO 10 I = 1,10
         ID = APARM(I) + 0.5
         IS = BPARM(I) + 0.5
         IF ((ID.GT.0) .AND. (IS.GT.0)) THEN
            IF (I.NE.1) THEN
               CALL FINDIM (ID, IS, INLUN, IERR)
               IF (IERR.NE.0) GO TO 980
               END IF
            CALL ADDIT (I, INLUN, IOTLUN, IOTLU2, IERR)
            IF (IERR.NE.0) GO TO 980
            IDG = ID
            ISG = IS
            END IF
 10      CONTINUE
C                                       transpose
      CALL FIXIT (IOTLUN, IOTLU2, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Create, copy, update hist file.
      CALL FINDIM (IDG, ISG, INLUN, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL HISTRY (INLUN, IOTLUN, IHINL, IHOTL)
C                                       Release AIPS if necessary,
C                                       close, clear files, delete any
C                                       new files if error.
 980  CALL TSKEND (IERR)
C
 999  STOP
      END
      SUBROUTINE SETUP (PRGNAM, INLUN, IOTLUN, IOTLU2, IERR)
C-----------------------------------------------------------------------
C   SETUP will initialize the WAWA IO package, open the 1st input image,
C   create the output images, determine the name strings of the output
C   image and initialize the output image.
C   Inputs:
C      PRGNAM   C*6   Program name.
C      INLUN    I     Input image logical unit number.
C      IOTLUN   I     New image input logical unit number.
C      IOTLU2   I     Output LUN for new image.
C   Outputs:
C      IERR     I     Standard WAWA IO error message.
C-----------------------------------------------------------------------
      CHARACTER PRGNAM*6
      INTEGER   INLUN, IOTLUN, IOTLU2, IERR
C
      CHARACTER AXTYP*8
      REAL      ZBLC(7), ZTRC(7), USER
      HOLLERITH MAP(1), SCLS(2)
      INTEGER   NOPARM, ID, IS, I, J, K
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'LAYER.INC'
C-----------------------------------------------------------------------
      NOPARM = 103
      CALL RFILL (7, 0.0, ZBLC)
      CALL RFILL (7, 0.0, ZTRC)
      CALL TSKBEG (PRGNAM, NOPARM, XNAM, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Fix the output image name string
C
      CALL CHR2H (4, 'MA  ', 1, MAP)
      CALL CHR2H (6, 'SLAYER', 1, SCLS)
      USER = NLUSER
      CALL H2WAWA (XNAM, XCLS, XSEQ, MAP, XDISK, USER, OUFILE)
      CALL H2WAWA (XNAM, SCLS, 0.0, MAP, 0.0, USER, OUFIL2)
C                                       Open the old file. Get header.
      ID = APARM(1) + 0.5
      IS = BPARM(1) + 0.5
      IF ((ID.LE.0) .OR. (IS.LE.0)) THEN
         IERR = 8
         MSGTXT = 'AT LEAST ONE DISK AND CATALOG NUMBER MUST BE GIVEN'
         CALL MSGWRT (8)
         GO TO 999
         END IF
      CALL FINDIM (ID, IS, INLUN, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Fix BLC, TRC.
      CALL COPY (256, OLDI, NEWI)
      CALL HDRWIN (BLC, TRC, NEWI, IERR)
      IF (IERR.NE.0) GO TO 990
      CALL COPY (256, NEWI, WRKI)
C                                       combine RGB axis w 1st axis for
C                                       now
      WRKI(KINAX) = WRKI(KINAX) * 3
C                                       where is new axis?
      NROW = 1
      AX = 0
      J = NEWI(KIDIM)
      DO 10 I = 2,J
         IF (NEWI(KINAX+I-1).GT.1) THEN
            NROW = NROW * NEWI(KINAX+I-1)
         ELSE
            AX = I
            GO TO 20
            END IF
 10      CONTINUE
      AX = J + 1
 20   IF (AX.GT.7) THEN
         MSGTXT = 'TOO MANY REAL AXES - CANNOT ADD ANOTHER'
         CALL MSGWRT (8)
         IERR = 8
         GO TO 999
         END IF
C                                       move axes AX - J by 1.
      K = J
      DO 30 I = AX,J
         NEWI(KINAX+K) = NEWI(KINAX+K-1)
         NEWR(KRCRP+K) = NEWR(KRCRP+K-1)
         NEWR(KRCRT+K) = NEWR(KRCRT+K-1)
         NEWR(KRCIC+K) = NEWR(KRCIC+K-1)
         NEWD(KDCRV+K) = NEWD(KDCRV+K-1)
         NEWH(KHCTP+2*K) = NEWH(KHCTP+2*K-2)
         NEWH(KHCTP+2*K+1) = NEWH(KHCTP+2*K-1)
         K = K - 1
 30      CONTINUE
C                                       insert RGB axis
      NEWI(KIDIM) = NEWI(KIDIM) + 1
      NEWI(KINAX+K) = 3
      NEWR(KRCRP+K) = 1.0
      NEWR(KRCRT+K) = 0.0
      NEWR(KRCIC+K) = 1.0
      NEWD(KDCRV+K) = 1.0D0
      AXTYP = 'RGB'
      CALL CHR2H (8, AXTYP, 1, NEWH(KHCTP+2+K))
      NEWR(KRBLK) = FBLANK
      WRKR(KRBLK) = FBLANK
C                                       create output image
      CALL MAPCR (INFILE, OUFILE, NEWI, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       create work file
      CALL MAPCR (INFILE, OUFIL2, WRKI, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       open work for read & write
      CALL OPENCF (IOTLUN, OUFIL2, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL OPENCF (IOTLU2, OUFIL2, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Get new improved header.
      CALL GETHDR (IOTLU2, WRKI, IERR)
      IF (IERR.NE.0) GO TO 970
C                                       Init output image to blanks
      CALL MAPWIN (IOTLUN, ZBLC, ZTRC, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL MFILL (IOTLUN, FBLANK, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 970
      DO 40 I = 1,10
         IF (EPARM(I).LE.0.0) EPARM(I) = 1.0
 40      CONTINUE
      GO TO 999
C                                       error handling.
 970  CALL PRTERR (IERR, IOTLU2)
      GO TO 999
 990  CALL PRTERR (IERR, 0)
C
 999  RETURN
      END
      SUBROUTINE FINDIM (ID, IS, LUN, IERR)
C-----------------------------------------------------------------------
C   FINDIM finds the image at the specified disk and catalog number and
C   opens it
C   Inputs:
C      ID    I   Disk number
C      IS    I   Catalog number
C      LUN   I   LUN to use
C   Outputs:
C      IERR   I   Error code
C-----------------------------------------------------------------------
      INTEGER   ID, IS, LUN, IERR
C
      CHARACTER NAM*12, CLS*6, PTYPE*2, STAT*4
      INTEGER   SEQ, USID, BUFF(256)
      REAL      USER, ASEQ, ADISK
      HOLLERITH MAP(1), ANAM(3), ACLS(2)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'LAYER.INC'
C-----------------------------------------------------------------------
C                                       use CATDIR;s INFO routine
      CALL CATDIR ('INFO', ID, IS, NAM, CLS, SEQ, PTYPE, USID, STAT,
     *   BUFF, IERR)
      IF (IERR.EQ.6) THEN
         WRITE (MSGTXT,1000) ID, IS
         GO TO 900
      ELSE IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1005) ID, IS, IERR
         GO TO 900
         END IF
C                                       build file name
      CALL CHR2H (12, NAM, 1, ANAM)
      CALL CHR2H (6, CLS, 1, ACLS)
      ASEQ = SEQ
      ADISK = ID
      CALL CHR2H (4, 'MA  ', 1, MAP)
      USER = NLUSER
      CALL H2WAWA (ANAM, ACLS, ASEQ, MAP, ADISK, USER, INFILE)
C                                       open and get header
      CALL OPENCF (LUN, INFILE, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GETHDR (LUN, OLDI, IERR)
      GO TO 999
C
 900  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MAP ON DISK',I3,' CNO,',I6,' NOT FOUND')
 1005 FORMAT ('MAP ON DISK',I3,' CNO,',I6,' CATDIR IERR',I4)
      END
      SUBROUTINE ADDIT (IMG, INLUN, IOTLUN, IOTLU2, IERR)
C-----------------------------------------------------------------------
C   ADDIT will add the current input image to the current sum, doing the
C   appropriate absorption and emission
C   Inputs:
C      INLUN    I   The logical unit number of the old image.
C      IOTLUN   I   The input logical unit no. of the new image.
C      IOTLU2   I   The output logical unit no. of the new image.
C   Outputs:
C      IERR     I   error code. 0 = ok.
C-----------------------------------------------------------------------
      INTEGER   IMG, INLUN, IOTLUN, IOTLU2, IERR
C
      REAL      ZBLC(7), ZTRC(7), TB, RMIN, RMAX, TAU, TAUE(3), TAUA(3)
      INTEGER   NX, IX, I, IROW, J, INSLT2, OUTSLT, OUTVOL, INVOL2,
     *   SCRTCH(256), IPTR, IDUM
      LOGICAL   DOCLR
      CHARACTER DCH*12
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'LAYER.INC'
C-----------------------------------------------------------------------
C                                       Initialize ZBLC & ZTRC to zero.
      CALL RFILL (7, 0.0, ZBLC)
      CALL RFILL (7, 0.0, ZTRC)
      NX = NEWI(KINAX)
      RMIN = OLDR(KRDMN)
      RMAX = OLDR(KRDMX)
      IF (RMAX.LE.RMIN) THEN
         IERR = 8
         WRITE (MSGTXT,1000) IMG, RMIN, RMAX
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       prepare I/O
      CALL MAPWIN (INLUN, BLC, TRC, IERR)
      IF (IERR.NE.0) GO TO 970
      CALL MAPWIN (IOTLUN, ZBLC, ZTRC, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL MAPWIN (IOTLU2, ZBLC, ZTRC, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Figure out if IN/OUT file.
      DO 10 IPTR = 1,EFIL
         IF (FILTAB(POLUN,IPTR).EQ.IOTLUN) THEN
            INSLT2 = FILTAB(POCAT,IPTR)
            INVOL2 = FILTAB(POVOL,IPTR)
            END IF
         IF (FILTAB(POLUN,IPTR).EQ.IOTLU2) THEN
            OUTSLT = FILTAB(POCAT,IPTR)
            OUTVOL = FILTAB(POVOL,IPTR)
            END IF
 10      CONTINUE
C                                       If in equals out we must clear
C                                       READ later on.
      DOCLR = (OUTVOL.EQ.INVOL2) .AND. (OUTSLT.EQ.INSLT2)
C                                       read row loop
      TB = 1.0
      DO 100 IROW = 1,NROW
         CALL MAPIO ('READ', INLUN, BUFF1, IERR)
         IF (IERR.NE.0) GO TO 970
C
         IF (DOCLR) CALL CATDIR ('CSTA', INVOL2, INSLT2, DCH, DCH, IDUM,
     *      DCH, IDUM, 'CLWR', SCRTCH, IERR)
         CALL MAPIO ('READ', IOTLU2, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 980
C                                       If IN2 = OUT we must clear this
C                                       READ so we can set WRIT status.
         IF (DOCLR) THEN
            CALL CATDIR ('CSTA', INVOL2, INSLT2, DCH, DCH, IDUM, DCH,
     *         IDUM, 'CLRD', SCRTCH, IERR)
            DOCLR = .FALSE.
            END IF
C                                       loop through row
         DO 90 IX = 1,NX
            IF (BUFF1(IX).NE.FBLANK) THEN
               TAU = (BUFF1(IX) - RMIN) / (RMAX - RMIN)
               IF (DOWT.GT.0.0) TB = TAU
               TAUE(1) = DPARM(IMG) * PLCOLR(1,IMG) * TAU
               TAUE(2) = DPARM(IMG) * PLCOLR(2,IMG) * TAU
               TAUE(3) = DPARM(IMG) * PLCOLR(3,IMG) * TAU
               IF (DOCOLR.GT.0.0) THEN
                  TAUA(1) = CPARM(IMG) * PLCOLR(1,IMG) * TAU
                  TAUA(2) = CPARM(IMG) * PLCOLR(2,IMG) * TAU
                  TAUA(3) = CPARM(IMG) * PLCOLR(3,IMG) * TAU
               ELSE
                  TAUA(1) = CPARM(IMG) * TAU
                  TAUA(2) = CPARM(IMG) * TAU
                  TAUA(3) = CPARM(IMG) * TAU
                  END IF
               J = 3 * (IX - 1)
               DO 20 I = 1,3
                  J = J + 1
                  IF (BUFF2(J).NE.FBLANK) THEN
                     BUFF2(J) = BUFF2(J) * EXP (-TAUA(I))
                  ELSE
                     BUFF2(J) = 0.0
                     END IF
                  BUFF2(J) = BUFF2(J) + EPARM(IMG) * TB *
     *               (1.0 - EXP (-TAUE(I)))
 20               CONTINUE
               END IF
 90         CONTINUE
         CALL MAPIO ('WRIT', IOTLUN, BUFF2, IERR)
         IF (IERR.NE.0) GO TO 990
 100     CONTINUE
      CALL FILCLS (INLUN)
      GO TO 999
C                                       errors
 970  CALL PRTERR (IERR, INLUN)
      GO TO 999
 980  CALL PRTERR (IERR, IOTLUN)
      GO TO 999
 990  CALL PRTERR (IERR, IOTLU2)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('IMAGE',I3,' MIN/MAX=',2(1PE12.3),' NOT USABLE')
      END
      SUBROUTINE FIXIT (IOTLUN, IOTLU2, IERR)
C-----------------------------------------------------------------------
C   FIXIT determines the max/min of the resulting data and transposes
C   the RGB triplets into 3 output planes
C   Inputs:
C      IOTLUN   I   LUN of output image (starts open to scratch)
C      IOTLU2   I   LUN of scratch image
C   Output:
C      IERR     I   Error code
C-----------------------------------------------------------------------
      INTEGER   IOTLUN, IOTLU2, IERR
C
      REAL      RMAX, RMIN, ZBLC(7), ZTRC(7)
      INTEGER   IROW, I, J, IC, NX
      LOGICAL   BLNKD
      INCLUDE 'LAYER.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL RFILL (7, 0.0, ZBLC)
      CALL RFILL (7, 0.0, ZTRC)
      NX = NEWI(KINAX)
      BLNKD = .FALSE.
C                                       close 2nd scratch LUN
      CALL FILCLS (IOTLUN)
C                                       open output file
      CALL OPENCF (IOTLUN, OUFILE, IERR)
      IF (IERR.NE.0) GO TO 980
      RMAX = -1.E20
      RMIN = 1.E20
C                                       init full output
      CALL MAPWIN (IOTLUN, ZBLC, ZTRC, IERR)
      IF (IERR.NE.0) GO TO 980
      DO 100 IC = 1,3
C                                       reinit each color
         CALL MAPWIN (IOTLU2, ZBLC, ZTRC, IERR)
         IF (IERR.NE.0) GO TO 990
         DO 90 IROW = 1,NROW
            CALL MAPIO ('READ', IOTLU2, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 990
            J = IC
            DO 20 I = 1,NX
               IF (BUFF1(J).EQ.FBLANK) THEN
                  BUFF2(I) = FBLANK
                  BLNKD = .TRUE.
               ELSE
                  BUFF2(I) = BUFF1(J)
                  RMAX = MAX (RMAX, BUFF2(I))
                  RMIN = MIN (RMIN, BUFF2(I))
                  END IF
               J = J + 3
 20            CONTINUE
            CALL MAPIO ('WRIT', IOTLUN, BUFF2, IERR)
            IF (IERR.NE.0) GO TO 980
 90         CONTINUE
 100     CONTINUE
      NEWR(KRDMX) = RMAX
      NEWR(KRDMN) = RMIN
      IF (BLNKD) THEN
         NEWR(KRBLK) = FBLANK
      ELSE
         NEWR(KRBLK) = 0.0
         END IF
C                                       close and delete scratch
      CALL FILCLS (IOTLU2)
      CALL FILDES (OUFIL2, .FALSE., '  ', 0, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'ERROR DELETING SCRATCH IMAGE'
         CALL MSGWRT (6)
         IERR = 0
         END IF
      GO TO 999
C
 980  CALL PRTERR (IERR, IOTLUN)
      GO TO 999
 990  CALL PRTERR (IERR, IOTLU2)
C
 999  RETURN
      END
      SUBROUTINE HISTRY (INLUN, IOTLUN, IHINL, IHOTL)
C-----------------------------------------------------------------------
C   HISTRY will create and write the history file for the new image.
C   Inputs:
C      INLUN    I        the LUN for the input map.
C      IOTLUN   I        the LUN for the output map.
C      IHINL    I        the LUN to use for the input history file.
C      IHOTL    I        the LUN to use for the new output history file.
C-----------------------------------------------------------------------
      INTEGER   INLUN, IOTLUN, IHINL, IHOTL
C
      CHARACTER NAMSTR*36, HILINE*72, NAME*12, CLASS*6, PTYPE*2
      INTEGER   SEQ, VOL, USID, IBLC(7), ITRC(7), INPTR, IOPTR, IPTR,
     *   IERR, I, IERR2, ID, IS
      LOGICAL   UPDATE
      INCLUDE 'INCS:DITB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'LAYER.INC'
      DATA UPDATE /.TRUE./
C-----------------------------------------------------------------------
C                                       Get additional data from commo
      INPTR = 0
      IOPTR = 0
      DO 10 IPTR = 1,EFIL
         IF (INLUN.EQ.FILTAB(POLUN,IPTR)) INPTR = IPTR
         IF (IOTLUN.EQ.FILTAB(POLUN,IPTR)) IOPTR = IPTR
 10      CONTINUE
C                                       Check for file not open error.
      IF ((INPTR.EQ.0) .OR. (IOPTR.EQ.0)) THEN
         MSGTXT = 'HISTRY: IN OR OUT FILE NOT OPEN'
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       copy keywords
      CALL KEYPCP (FILTAB(POVOL,INPTR), FILTAB(POCAT,INPTR),
     *   FILTAB(POVOL,IOPTR), FILTAB(POCAT,IOPTR), 0, ' ', IERR)
C                                       Create history file and
C                                       copy HI of INSEQ
      CALL HIINIT (2)
      CALL HISCOP (IHINL, IHOTL, FILTAB(POVOL,INPTR),
     *   FILTAB(POVOL,IOPTR), FILTAB(POCAT,INPTR), FILTAB(POCAT,IOPTR),
     *   NEWI, BUFF2, BUFF1, IERR)
      IF (IERR.GT.2) GO TO 100
C                                       Add LAYER history.
C                                       Input map.
      CALL GTNAME (INLUN, NAMSTR, IERR)
      IF (IERR.NE.0) GO TO 100
      CALL WAWA2A (NAMSTR, NAME, CLASS, SEQ, PTYPE, VOL, USID)
      CALL HENCO1 (TSKNAM, NAME, CLASS, SEQ, VOL, IHOTL, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       Output map.
      CALL GTNAME (IOTLUN, NAMSTR, IERR)
      IF (IERR.NE.0) GO TO 100
      CALL WAWA2A (NAMSTR, NAME, CLASS, SEQ, PTYPE, VOL, USID)
      CALL HENCOO (TSKNAM, NAME, CLASS, SEQ, VOL, IHOTL, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       BLC, TRC
      DO 20 I = 1,7
         IBLC(I) = BLC(I) + .5
         ITRC(I) = TRC(I) + .5
 20      CONTINUE
      WRITE (HILINE,1020) TSKNAM, 'BLC', IBLC
      CALL HIADD (IHOTL, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1020) TSKNAM, 'TRC', ITRC
      CALL HIADD (IHOTL, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       image parameters
      DO 30 I = 1,10
         ID = APARM(I) + 0.5
         IS = BPARM(I) + 0.5
         IF ((ID.GT.0) .AND. (IS.GT.0)) THEN
            WRITE (HILINE,1030) TSKNAM, I, ID, IS
            CALL HIADD (IHOTL, HILINE, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 100
            WRITE (HILINE,1031) TSKNAM, I, CPARM(I)
            CALL HIADD (IHOTL, HILINE, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 100
            WRITE (HILINE,1032) TSKNAM, I, DPARM(I)
            CALL HIADD (IHOTL, HILINE, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 100
            WRITE (HILINE,1033) TSKNAM, I, EPARM(I)
            CALL HIADD (IHOTL, HILINE, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 100
            WRITE (HILINE,1034) TSKNAM, I, PLCOLR(1,I), PLCOLR(2,I),
     *         PLCOLR(3,I)
            CALL HIADD (IHOTL, HILINE, BUFF1, IERR)
            IF (IERR.NE.0) GO TO 100
            END IF
 30      CONTINUE
      IF (DOCOLR.GT.0.0) THEN
         HILINE = TSKNAM // 'DOCOLOR = 1  / absorption is colored'
      ELSE
         HILINE = TSKNAM // 'DOCOLOR = -1  / absorption is not colored'
         END IF
      CALL HIADD (IHOTL, HILINE, BUFF1, IERR)
      IF (IERR.NE.0) GO TO 100
      IF (DOWT.GT.0.0) THEN
         HILINE = TSKNAM // 'DOWEIGHT = 1  / emission scaled' //
     *      ' by brightness'
      ELSE
         HILINE = TSKNAM // 'DOWEIGHT = -1  / emission not scaled' //
     *      ' by brightness'
         END IF
      CALL HIADD (IHOTL, HILINE, BUFF1, IERR)
C                                       Close HI file
 100  CALL HICLOS (IHOTL, UPDATE, BUFF1, IERR2)
C                                       Report any IERRs
      IF ((IERR.NE.0) .OR. (IERR2.NE.0)) THEN
         MSGTXT = 'WARNING. ERROR WRITING HISTORY FILE'
         CALL MSGWRT (7)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1020 FORMAT (A6,A3,' =',7I6)
 1030 FORMAT (A6,'/IMAGE',I2,' DISK',I3,' CNO',I6)
 1031 FORMAT (A6,'CPARM(',I2,') =',F7.3,'  / absorption factor')
 1032 FORMAT (A6,'DPARM(',I2,') =',F7.3,'  / emission factor')
 1033 FORMAT (A6,'EPARM(',I2,') =',F7.3,'  / scale emitor')
 1034 FORMAT (A6,'PLCOLORS(*,',I2,') =',3F6.3,'  / RGB color')
      END

      PROGRAM DIRECT
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Reads an ADR file and generates AIPS Site Survey Directory for all
C   entries with the "CP" attribute. Actually, the output is the TEX
C   input to generate the directory. The "\h" lines are also recognized
C   and separate entries are generated for "\h1", "\h2", ...
C   A crossreference listing is prepared from the keyword=value pairs
C   in the \h entries.
C   DCW, NRAO-CV, 25Mar86,15Jul86 (based on programs LABEL and SURVEY).
C     08Jan87; improved sort 24Mar87; numerous fixes 20-30Apr87.
C     fix for blank hardware lines 24Nov87.
C   Added 'Telescope' to INSTIT (Institution) DATA list 05Apr89, NDW
C-----------------------------------------------------------------------
      IMPLICIT    NONE
      INTEGER     MXLINS, MXHIGH, MXWIDE, MAXXCL
      PARAMETER   (MXLINS=50, MXHIGH=99, MXWIDE=99, MAXXCL=20)
      INTEGER     L1, L2, L3, L5, L6, ITRIM, J, I, KHIGH, KWIDE, KSKIP,
     *            K1, K2, L, KENTRY, K, MZIPBL, IHN, KE, KB, KK, KC, KF,
     *            ISTAT, KMACH, NMACH, IZ, FKF, L4, NXCL
      CHARACTER   NETSRV*12
      PARAMETER   (MZIPBL=4, IZ=0, NETSRV='Net-Service')
      CHARACTER   INP*30, FNAME*30, YN*1, BLASH*10, LOCAL*30,
     *            LINE*(MXWIDE), ADDR(MXHIGH)*(MXWIDE), CNTRY*30,
     *            ZIPBL*(MZIPBL), LIHN*4, CENTRY*4,
     *            COMMND*100, LSTKEY*20, KEY*20, VALUE*60,
     *            LSTVAL*60, NREF*9, CNMACH*9, CKMACH*9, KVALUE*60,
     *            CLNAME*72, CCNTRY*30, CZIP*30, CCITY*72, CINSTN*72,
     *            CSTRET*72, TEMP*80, TEMP2*80, XCLKEY(MAXXCL)*40,
     *            XCL*30, NETKEY*12
      LOGICAL     RNO, LEOF, LLOCAL, LUPPER, LA, LHN, LHNPRV, ONENET,
     *            AERROR
      DATA        LOCAL /'USA'/, ZIPBL /' '/
C-----------------------------------------------------------------------
      L1 = 1
      L2 = 2
      L3 = 3
      L5 = 5
      L6 = 6
C                                       Open input file:
 110  CONTINUE
      WRITE (L6, 1110)
      READ (L5, 1115, ERR=110) INP
      IF (INP.EQ.' ') INP = 'AIPSWHO:WHOGETS'
      FNAME = INP(:ITRIM(INP)) // '.ADR'
      OPEN (UNIT=L1, FILE=FNAME, STATUS='OLD', ERR=117)
         WRITE (L6, 1116) FNAME
         GO TO 120
 117  CONTINUE
         WRITE (L6, 1117) FNAME
         GO TO 110
 120  CONTINUE
C                                       Open output file:
      I = INDEX (INP, ':')
      IF (I.GT.0) INP = INP(I+1:)
      I = INDEX (INP, ']')
      IF (I.GT.0) INP = INP(I+1:)
      FNAME = INP(:ITRIM(INP)) // '.TEX'
      WRITE (L6, 1150) FNAME
      OPEN (UNIT=L2, FILE=FNAME, STATUS='NEW',
     *      CARRIAGECONTROL='LIST')
C                                       Read xref excludelist file:
 160  CONTINUE
      WRITE (L6, 1160)
      READ (L5, 1115, ERR=160) XCL
      IF (XCL.EQ.' ') XCL = 'AIPSWHO:DRCTALLREF'
      FNAME = XCL(:ITRIM(XCL)) // '.DAT'
      OPEN (UNIT=L4, FILE=FNAME, STATUS='OLD', ERR=167)
         WRITE (L6, 1166) FNAME
         GO TO 170
 167  CONTINUE
         WRITE (L6, 1117) FNAME
         GO TO 160
 170  CONTINUE
      NXCL = 0
 180  READ(L4,*,END=190) XCLKEY(NXCL+1)
         NXCL = NXCL + 1
         IF (NXCL.LT.MAXXCL) GO TO 180
         STOP 'DIRECT 180: NXCL.GE.MAXXCL!'
 190  CLOSE (UNIT=L4)
      WRITE (L6,*) 'cross-reference exclude-list NXCL=', NXCL
C                                       initialize for TEX:
      WRITE (L2, 1180) 'def\SECRET{T}% internal consumption only?'
      WRITE (L2, 1180) 'def\SHORT{F}%  short form for non-CPs?'
      WRITE (L2, 1180) 'def\FINAL{F}%  draft or final? (final date:)'
      WRITE (L2, 1180) 'if T\FINAL     \day=99\month=13\year=2001 \fi'
      WRITE (L2, 1185) 'def\INP{\uppercase{' // INP(:ITRIM(INP))
     *                                          // '}.ADR}%'
      WRITE (L2, 1185) 'input aipswho:drctmac.tex'
      WRITE (L2, 1330) '%  substitute "direct89" for "drctgenerc":'
      WRITE (L2, 1180) 'input aipswho:drctgenerc.tex'
      WRITE (L2, 1185) 'begindirectory'
      KHIGH = MXHIGH
      KWIDE = MXWIDE
      KSKIP = 0
      BLASH = 'atxhn'
C                                       Open scratch file:
      OPEN (UNIT=L3, FILE='UNSORTED.SCR', STATUS='NEW',
     *   CARRIAGECONTROL='LIST')
C-----------------------------------------------------------------------
      LEOF = .FALSE.
      KENTRY = 0
C                                       Read next label:
 310  CONTINUE
      IF (LEOF) GO TO 510
         DO 320 I = 1, MXHIGH
            ADDR(I) = ' '
 320        CONTINUE
         K1 = 0
         K2 = 0
         LLOCAL = .FALSE.
C                                       Read next line of label:
 330     CONTINUE
         IF (LEOF) GO TO 310
         READ (L1, 1330, END=340) LINE
            GO TO 350
 340     CONTINUE
            LINE = ' '
            LEOF = .TRUE.
 350     CONTINUE
C                                       Looping logic:
         IF ((LINE.EQ.' ').AND.(K1.EQ.0)) GO TO 330
         K1 = K1 + 1
         IF ((LINE.EQ.' ').AND.(K1.GT.0)) GO TO 410
C                                       Backslash logic:
C                                       (codes must appear in BLASH!)
         IF (LINE(1:1).NE.'\') GO TO 358
            IF (BLASH.EQ.' ') GO TO 330
            IF (LINE(2:2).NE.' ') GO TO 356
               WRITE (L6, 1354) LINE
               GO TO 330
 356        CONTINUE
            IF (BLASH.EQ.'\') GO TO 358
            IF (INDEX (BLASH, LINE(2:2)).EQ.0) GO TO 330
 358     CONTINUE
C                                       Logic to delete 'LOCAL' lines:
         IF (LINE.NE.LOCAL) GO TO 359
            IF (LLOCAL) WRITE (L6, 1359) LOCAL(:ITRIM (LOCAL)), K1
            LLOCAL = .TRUE.
            GO TO 330
 359     CONTINUE
C                                       Now add the line to ADDR():
C                                       (note special case for first)
C                                       (name line, K1.EQ.2)
         IF (K2.GE.MXHIGH) WRITE (L6, 1385) MXHIGH, LINE
C         IF (K1.NE.2) K2 = MIN0 (K2 + 1, MXHIGH)
         K2 = MIN (K2 + 1, MXHIGH)
         ADDR(K2) = LINE
         IF (ITRIM (ADDR(K2)).GT.KWIDE) WRITE (L6, 1390)
     *            K2, KWIDE, LINE(:ITRIM(LINE))
         GO TO 330
C-----------------------------------------------------------------------
C                                       entry assembled. in directory?
 410  CONTINUE
      LA = .FALSE.
      LHN = .FALSE.
C                                       Is it a CP?
      DO 415   I = 1, K2
         IF ((ADDR(I)(1:3).EQ.'\a ').AND.
     *         (INDEX (ADDR(I)(3:), ' CP ').NE.0)) LA = .TRUE.
 415     CONTINUE
C                                       does it have any "\h" line(s)?
      DO 420 IHN = 1, 9
         WRITE (LIHN, '(''\h'', I1)') IHN
         DO 420 I = 1, K2
            IF (ADDR(I)(1:3).EQ.LIHN) LHN = .TRUE.
            IF ((IHN.EQ.1).AND.(ADDR(I)(1:3).EQ.'\h ')) LHN = .TRUE.
 420     CONTINUE
C                                       Want BOTH CP and \h:
C                                       (but will take either)
      IF (.NOT.LA.AND..NOT.LHN) GO TO 495
      IF ((LA.AND..NOT.LHN).OR.(LHN.AND..NOT.LA))
     *   WRITE (L6, 1420) LA, LHN, ADDR(1)(:ITRIM(ADDR(1)))
C                                       Generate directory entry:
      WRITE (L2, 1430)
C                                       First, fix TEX special cases:
      DO 435 I = 1, K2
         CALL TEXFIX (ADDR(I), '  ', ' ')
C         CALL TEXFIX (ADDR(I), '. ', '.~')
         CALL TEXFIX (ADDR(I), '<', '$<$')
         CALL TEXFIX (ADDR(I), '>', '$>$')
         CALL TEXFIX (ADDR(I), '#', '\#')
         CALL TEXFIX (ADDR(I), '%', '\%')
         CALL TEXFIX (ADDR(I), '_', '\_')
         CALL TEXFIX (ADDR(I), '&', '\&')
         CALL TEXFIX (ADDR(I), '\& ', '\&\ ')
 435     CONTINUE
C                                       now for the address lines:
      J = 0
      DO 440 I = 1, K2
         IF (ADDR(I)(1:1).EQ.'\') GO TO 440
            TEMP = ADDR(I)
            J = J + 1
            IF (J.EQ.2) GO TO 440
            IF (J.GT.2) GO TO 438
C                                       Kluges for first name(s):
               IF (ADDR(2).EQ.'[null]') GO TO 438
                  TEMP2 = ADDR(2)(:ITRIM(ADDR(2))) // ' ' // TEMP
                  TEMP = TEMP2
 438        WRITE (L2, 1440) 'CPaddrline', TEMP(:ITRIM(TEMP))
 440     CONTINUE
C                                       parse ADDR():
      CALL APARSE (L6, K2, ADDR, LOCAL, AERROR,
     *               CLNAME, CCNTRY, CZIP, CCITY, CINSTN, CSTRET)
      IF (AERROR) GO TO 454
C                                       add LOCAL to printed address:
         IF (CCNTRY.NE.LOCAL) GO TO 453
            DO 452 I = 1, K2
               IF (ADDR(I).EQ.LOCAL) GO TO 453
 452           CONTINUE
            WRITE (L2, 1440) 'CPaddrline', LOCAL(:ITRIM(LOCAL))
 453     CONTINUE
C
         WRITE (L2, 1440) 'CPlastname', CLNAME(:ITRIM(CLNAME))
         CALL SRTSUB ('PUT', L3, 'CP Lastname', CLNAME, KENTRY+1)
         WRITE (L2, 1440) 'CPcountry', CCNTRY(:ITRIM(CCNTRY))
         CALL SRTSUB ('PUT', L3, 'Country', CCNTRY, KENTRY+1)
         WRITE (L2, 1440) 'CPzip', CZIP(:ITRIM(CZIP))
         WRITE (L2, 1440) 'CPcity', CCITY(:ITRIM(CCITY))
         WRITE (L2, 1440) 'CPinstitute', CINSTN(:ITRIM(CINSTN))
         CALL SRTSUB ('PUT', L3, 'Institute', CINSTN, KENTRY+1)
         WRITE (L2, 1440) 'CPstreet', CSTRET(:ITRIM(CSTRET))
 454  CONTINUE
C                                       phone,net,attribute lines:
      ONENET = .FALSE.
      DO 458 I = 1, K2
         IF (ADDR(I)(1:3).NE.'\t ') GO TO 455
            WRITE (L2, 1440) 'CPtelephone', ADDR(I)(4:ITRIM(ADDR(I)))
            GO TO 458
 455     IF (ADDR(I)(1:3).NE.'\x ') GO TO 456
            WRITE (L2, 1440) 'CPtelex', ADDR(I)(4:ITRIM(ADDR(I)))
            GO TO 458
 456     IF (ADDR(I)(1:3).NE.'\a ') GO TO 457
            WRITE (L2, 1440) 'CPattribute', ADDR(I)(4:ITRIM(ADDR(I)))
            CALL ATTSRT (L3, ADDR(I)(4:ITRIM(ADDR(I))), KENTRY+1)
            GO TO 458
 457     IF (ADDR(I)(1:3).NE.'\n ') GO TO 458
            WRITE (L2, 1440) 'CPnetaddr', ADDR(I)(4:ITRIM(ADDR(I)))
            CALL NETSRT (L3, ADDR(I)(4:ITRIM(ADDR(I))), KENTRY+1,
     *         NETSRV)
            IF (.NOT.ONENET) CALL SRTSUB ('PUT', L3, NETSRV,
     *         'service-on-at-least-one-net', KENTRY+1)
            ONENET = .TRUE.
 458     CONTINUE
C
      WRITE (L2, 1455)
C                                       now for the hardware lines:
      DO 490 IHN = IZ, 9
         LHNPRV = .FALSE.
         WRITE (LIHN, '(''\h'', I1)') IHN
         DO 480 I = 1, K2
            IF (ADDR(I).EQ.LIHN) ADDR(I) = LIHN // ' ?=?'
            IF ((IHN.EQ.1).AND.(ADDR(I).EQ.'\h'))
     *                           ADDR(I) = LIHN // ' ?=?'
            IF (ADDR(I)(1:3).EQ.LIHN) GO TO 460
            IF ((IHN.EQ.1).AND.(ADDR(I)(1:3).EQ.'\h ')) GO TO 460
               GO TO 480
 460        CONTINUE
C                                       Another machine?
            IF (LHNPRV) GO TO 462
               KENTRY = KENTRY + 1
               WRITE (CENTRY, '(I4)') KENTRY
               KF = 0
 461           KF = KF + 1
               IF (CENTRY(KF:KF).EQ.' ') GO TO 461
               IF (IHN.EQ.0) GO TO 4615
                  WRITE (L2, 1460) 'CPmachine', CENTRY(KF:4)
                  GO TO 4617
 4615          WRITE (L2, 1460) 'CPsitedata', CENTRY(KF:4)
 4617          LHNPRV = .TRUE.
 462        IF (ADDR(I)(1:3).EQ.LIHN)
     *         WRITE (L2, 1465) ADDR(I)(5:MAX(ITRIM(ADDR(I)),5))
            IF ((IHN.EQ.1).AND.(ADDR(I)(1:3).EQ.'\h '))
     *         WRITE (L2, 1465) ADDR(I)(4:MAX(ITRIM(ADDR(I)),4))
            J = 3
 465        CONTINUE
               J = J + 1
               IF (J.GT.MXWIDE) GO TO 480
               IF (ADDR(I)(J:J).EQ.' ') GO TO 465
C                                       non-blank field found:
               KB = INDEX (ADDR(I)(J:MXWIDE), ' ')
               KE = INDEX (ADDR(I)(J:J+KB-2), '=')
               IF ((KE.LT.2).OR.(KB.LT.(KE+1))) GO TO 475
C                                       write the field(s) out:
               KF = KE + 1
 467           CONTINUE
                  KC = INDEX (ADDR(I)(J+KF-1:J+KB-2), ',')
                  IF (KC.EQ.0) KC = KB - KF + 1
                  KVALUE = ADDR(I)(J+KF-1:J+KF+KC-3)
                  CALL SRTSUB ('PUT', L3, ADDR(I)(J:J+KE-2), KVALUE,
     *                                                      KENTRY)
                  KF = KF + KC
                  IF (KF.LT.KB) GO TO 467
               J = J + KB - 1
               GO TO 465
 475        CONTINUE
               WRITE (L6, 1475) J, KE, KB, ADDR(I)(:ITRIM(ADDR(I)))
 480        CONTINUE
         IF (LHNPRV) WRITE (L2, 1455)
         IF (LHNPRV.AND.(IHN.EQ.0)) KENTRY = KENTRY - 1
 490     CONTINUE
      WRITE (L2, 1455)
 495  GO TO 310
C-----------------------------------------------------------------------
 510  CONTINUE
      WRITE (L2, 1185) 'enddirectory'
      CLOSE (UNIT=L1)
      WRITE (L6, 1510) KENTRY
      CLOSE (UNIT=L3)
C                                       Now to produce cross-reference:
      COMMND = 'Sort/Key=(Position:1,Size:72,Ascending)/Stable '
     *               // 'UNSORTED.SCR ' // 'SORTED.SCR'
      CALL DCLCMD (L6, COMMND, ISTAT)
      OPEN (UNIT=L3, FILE='SORTED.SCR', STATUS='OLD')
      WRITE (L2, 1185) 'begincrossref'
      LSTKEY = '[initkey]'
      LSTVAL = '[initval]'
 520  CALL SRTSUB ('GET', L3, KEY, VALUE, KMACH)
      IF (KMACH.EQ.-9999) GO TO 590
C                                       xref excludelist check:
         DO 525 I = 1, NXCL
            IF (KEY.EQ.XCLKEY(I)) GO TO 520
 525        CONTINUE
C
         IF (KEY.EQ.LSTKEY) GO TO 530
            IF (LSTVAL.NE.'[initval]') WRITE (L2, 1520)
     *                                    CNMACH(:ITRIM(CNMACH))
            IF (LSTKEY.NE.'[initkey]') WRITE (L2, 1455)
C                                       kluge suppresses cannisters:
            IF ((LSTKEY.EQ.'CAN').OR.(LSTKEY.EQ.'NAME'))
     *                           WRITE (L2, 1180) 'fi'
            WRITE (L2, '(1X)')
            IF (KEY.EQ.'CAN')    WRITE (L2, 1180) 'if T\SECRET%'
            IF (KEY.EQ.'NAME')   WRITE (L2, 1180) 'if F\SHORT%'
            WRITE (L2, 1460) 'XRkey', KEY(:ITRIM(KEY))
            LSTKEY = KEY
            LSTVAL = '[initval]'
            WRITE (L6, '('' KEY= '', A)') KEY(:ITRIM(KEY))
 530     CONTINUE
         IF (VALUE.EQ.LSTVAL) GO TO 540
            IF (LSTVAL.NE.'[initval]') WRITE (L2, 1520)
     *                                    CNMACH(:ITRIM(CNMACH))
            WRITE (L2, 1460) 'XRvalue', VALUE(:ITRIM(VALUE))
            LSTVAL = VALUE
            NMACH = 0
 540     CONTINUE
         CALL MAKNUM (KMACH, CKMACH)
         NREF = CKMACH
         WRITE (L2, 1440) 'XRmachine', NREF(:ITRIM(NREF))
         NMACH = NMACH + 1
         CALL MAKNUM (NMACH, CNMACH)
         GO TO 520
 590  CONTINUE
      CLOSE (UNIT=L3)
      IF (LSTVAL.NE.'[initval]') WRITE (L2, 1520)
     *                                 CNMACH(:ITRIM(CNMACH))
      IF (LSTKEY.NE.'[initkey]') WRITE (L2, 1455)
      WRITE (L2, 1185) 'endcrossref'
C                                       That's all, folks:
 910  CONTINUE
      WRITE (L2, 1185) 'vfill'
      WRITE (L2, 1185) 'eject'
      WRITE (L2, 1185) 'end'
      CLOSE (UNIT=L2)
      COMMND = 'Delete/Log ' // 'UNSORTED.SCR;*,SORTED.SCR;*'
      CALL DCLCMD (L6, COMMND, ISTAT)
C-----------------------------------------------------------------------
 1110 FORMAT (' Enter input address-list-file (w/o .ADR):', $)
 1115 FORMAT (A72)
 1116 FORMAT (' L1=', A)
 1117 FORMAT (' Cannot open file ', A)
 1150 FORMAT (' L2=', A)
 1160 FORMAT (' Enter input xref-exclude-file (w/o .DAT):', $)
 1166 FORMAT (' L4=', A)
 1180 FORMAT ('\', A)
 1185 FORMAT (/, '\', A)
 1330 FORMAT (A)
 1354 FORMAT (' Poorly formatted backslash line:', /, 1X, A)
 1359 FORMAT (' Extra "', A, '" was seen at line', I3, ' of entry!')
 1385 FORMAT (' More than', I4, ' lines in an entry. Extra line:', /, A)
 1390 FORMAT (' Line', I3, ' of an entry is wider than', I3, ':', /,
     *         1X, A)
 1420 FORMAT (' CP/h mismatch for following entry: (CP=', L2, ', \h=',
     *         L2, ')', /, 1X, A)
 1430 FORMAT (/, '\CP{', /, '\CPaddr{')
 1440 FORMAT ('\', A, '{', A, '}%')
 1455 FORMAT ('}%')
 1460 FORMAT ('\', A, '{', A, '}{%')
 1465 FORMAT (A)
 1475 FORMAT (' Bad key=value field. J,KE,KB=', 3I5, /, 1X, A)
 1510 FORMAT (' Number of machines =', I5)
 1520 FORMAT ('\XRnmach{', A, '}}%')
      END
      INTEGER*4 FUNCTION ITRIM (STRING)
C-----------------------------------------------------------------------
C   Function to determine length of a string. I.e., it trims trailing
C   blanks. Use with calls like:
C         TRIMMED = GROSS(1:ITRIM(GROSS))
C   DCW, NRAO-CV, 30Nov82.
C-----------------------------------------------------------------------
      IMPLICIT  NONE
      CHARACTER STRING*(*)
C
      ITRIM = LEN (STRING) + 1
 10   CONTINUE
         ITRIM = ITRIM - 1
         IF (ITRIM.LT.1) GO TO 999
         IF (STRING(ITRIM:ITRIM).EQ.' ') GO TO 10
 999  RETURN
      END
      SUBROUTINE DCLCMD (L6, COMMND, ISTAT)
C-----------------------------------------------------------------------
C     Execute a DCL command string. Failure signaled by nonzero ISTAT.
C     DCW, NRAO-CV, 07Mar85.
C-----------------------------------------------------------------------
      INTEGER     ISTAT, L6
      CHARACTER   COMMND*(*)
C
      INCLUDE     '($SSDEF)'
      INTEGER     STATUS, LIB$SPAWN, ITRIM
C-----------------------------------------------------------------------
      WRITE (L6, 1010) COMMND(1:MIN0(ITRIM(COMMND),72))
      STATUS = LIB$SPAWN (COMMND,,,,,,,,,)
      ISTAT = 0
      IF (STATUS.EQ.SS$_NORMAL) GO TO 20
         WRITE (L6, '('' STATUS='', Z8)') STATUS
         ISTAT = 1
 20   RETURN
C-----------------------------------------------------------------------
 1010 FORMAT (' DCLCMD: ', A)
      END
      SUBROUTINE TEXFIX (BIGSTR, OLD, NEW)
C-----------------------------------------------------------------------
C     TEXFIX substitutes string NEW for instances of substring OLD in
C     string BIGSTR.
C     DCW, NRAO-CV, 01Apr86,08Jan87.
C-----------------------------------------------------------------------
      CHARACTER   BIGSTR*(*), OLD*(*), NEW*(*)
      INTEGER     I, K, ITRIM
      CHARACTER   TEMP*120
C
      I = 1
 10   K = INDEX (BIGSTR(I:ITRIM(BIGSTR)), OLD)
      IF (K.LE.0) GO TO 20
         TEMP = BIGSTR(1:I+K-2) // NEW // BIGSTR(I+K+LEN(OLD)-1:)
         BIGSTR = TEMP
         I = I + K + LEN(NEW) - 1
         GO TO 10
 20   RETURN
      END
      SUBROUTINE MAKNUM (N, STR)
C-----------------------------------------------------------------------
C     MAKNUM formats integer N into string STR and removes leading
C     blanks. ITRIM can then be used to effectively remove trailing
C     blanks as well. DCW, NRAO-CV, 02Apr86.
C-----------------------------------------------------------------------
      INTEGER     N
      CHARACTER   STR*(*)
      CHARACTER   STRTMP*20
C
      WRITE (STRTMP, '(I10)') N
 10   IF ((STRTMP(1:1).NE.' ').OR.(STRTMP.EQ.' ')) GO TO 20
         STRTMP = STRTMP(2:)
         GO TO 10
 20   STR = STRTMP
      RETURN
      END
      SUBROUTINE SRTSUB (OP, L3, KEY, VALUE, KMACH)
C-----------------------------------------------------------------------
C     routine to write a record into the keyword-value-entry file which
C     gets sorted to produce the crossreference table of the Directory.
C-----------------------------------------------------------------------
      INTEGER     L3, KMACH
      CHARACTER   OP*(*), KEY*(*), VALUE*(*)
C
      INTEGER     KV1, KV2, ITRIM
      CHARACTER   CV1*1, CV2*60, MONTH(12)*3, SRTFMT*20, JUSTFY*100,
     *            LOCAL*100
      DATA        MONTH /'JAN','FEB','MAR','APR','MAY','JUN','JUL',
     *                  'AUG','SEP','OCT','NOV','DEC'/,
     *            SRTFMT /'(A17, A47, I8)'/,
     *            JUSTFY /' '/
C-----------------------------------------------------------------------
      IF (OP.EQ.'GET') GO TO 520
      IF (OP.NE.'PUT') STOP 'SRTSUB: unrec val of OP!'
      LOCAL = VALUE
      KV1 = ITRIM (LOCAL)
C                                       recode the values for sorting:
      DO 468 KV2 = 1, KV1
         CV1 = LOCAL(KV2:KV2)
         IF ((.NOT.((CV1.GE.'0').AND.(CV1.LE.'9')))
     *      .AND.(CV1.NE.'+').AND.(CV1.NE.'-')
     *      .AND.(CV1.NE.'.')) GO TO 469
 468     CONTINUE
C                                       it's a number; justify decimal:
      CV2 = LOCAL
      IF (LOCAL(1:1).EQ.'.') CV2 = '0' // LOCAL
      LOCAL = CV2
      CV2 = ' '
      KV2 = INDEX (LOCAL,'.')
      IF (KV2.LE.0) CV2(20-KV1:) = LOCAL
      IF (KV2.GT.0) CV2(20-KV2+1:) = LOCAL
      LOCAL = '<n>' // CV2
      GO TO 474
C                                       not a number; a date?
 469  CV1 = LOCAL(1:1)
      IF (.NOT.((CV1.GE.'0').AND.(CV1.LE.'9'))) GO TO 473
      CV1 = LOCAL(2:2)
      IF (.NOT.((CV1.GE.'0').AND.(CV1.LE.'9'))) GO TO 473
      CV2 = LOCAL(3:5)
      DO 470 KV2 = 1,12
         IF (CV2.EQ.MONTH(KV2)) GO TO 472
 470     CONTINUE
      GO TO 473
 472  CV1 = LOCAL(6:6)
      IF ((CV1.NE.'8').AND.(CV1.NE.'9')) GO TO 473
      CV1 = LOCAL(7:7)
      IF (.NOT.((CV1.GE.'0').AND.(CV1.LE.'9'))) GO TO 473
C                                       it's a date; recode it:
         WRITE (CV2,'(''<d> '',A,I2.2,A)') LOCAL(6:7), KV2,
     *                                       LOCAL(1:2)
         LOCAL = CV2
         GO TO 474
C                                       just a string:
 473  CV2 = LOCAL
      LOCAL = '<s> ' // CV2
C
 474  WRITE (L3, SRTFMT) KEY // JUSTFY, LOCAL // JUSTFY, KMACH
      GO TO 900
C-----------------------------------------------------------------------
 520  READ (L3, SRTFMT, END=590) KEY, LOCAL, KMACH
C                                       reconstruct values:
         IF (LOCAL(1:3).NE.'<s>') GO TO 522
            CV2 = LOCAL(5:)
            LOCAL = CV2
            GO TO 526
 522     IF (LOCAL(1:3).NE.'<n>') GO TO 524
            CV2 = LOCAL(5:)
 523        LOCAL = CV2
            IF (LOCAL(1:1).NE.' ') GO TO 526
               CV2 = LOCAL(2:)
               GO TO 523
 524     IF (LOCAL(1:3).NE.'<d>') STOP 'unrec value field code!!!'
            READ (LOCAL(7:8),'(I2)') KV1
            CV2 = LOCAL(9:10) // MONTH(KV1) // LOCAL(5:6)
            LOCAL = CV2
 526     CONTINUE
      VALUE = LOCAL
      GO TO 900
 590  KMACH = -9999
C
 900  RETURN
      END
      SUBROUTINE NETSRT (L3, ADDR, KMACH, NETSRV)
C-----------------------------------------------------------------------
C     routine to call SRTSUB with a network address.
C     tries to recognize domains so that cross-ref can have lists of
C     addresses by domain. DCW, 27Mar87.
C-----------------------------------------------------------------------
      IMPLICIT    NONE
      INTEGER     L3, KMACH
      CHARACTER   ADDR*(*), NETSRV*(*)
C
      INTEGER     I, J, K, ITRIM
      CHARACTER   PATTRN*10, KEY*20
C
C-----------------------------------------------------------------------
C
      I = ITRIM (ADDR)
C                                       BITNET?
      PATTRN= '.bitnet'
      J = ITRIM (PATTRN)
      IF (ADDR(I-J+1:I).EQ.PATTRN(:J)) GO TO 15
      IF (INDEX(ADDR(:I),PATTRN(:J)).GT.0) GO TO 15
      PATTRN= '.netnorth'
      J = ITRIM (PATTRN)
      IF (ADDR(I-J+1:I).EQ.PATTRN(:J)) GO TO 15
      PATTRN= '.cdn'
      J = ITRIM (PATTRN)
      IF (ADDR(I-J+1:I).EQ.PATTRN(:J)) GO TO 15
      PATTRN= '@ac.uk'
      J = ITRIM (PATTRN)
      IF (ADDR(I-J+1:I).EQ.PATTRN(:J)) GO TO 15
      GO TO 20
 15      KEY = 'Net=BITNET/EARN'
         CALL SRTSUB ('PUT', L3, NETSRV, 'BITNET/EARN-service', KMACH+1)
         GO TO 80
C                                       Internet?
 20   CONTINUE
      PATTRN = '.arpa'
      J = ITRIM (PATTRN)
      IF (ADDR(I-J+1:I).EQ.PATTRN(:J)) GO TO 25
      PATTRN = '.edu'
      J = ITRIM (PATTRN)
      IF (ADDR(I-J+1:I).EQ.PATTRN(:J)) GO TO 25
      PATTRN = '.com'
      J = ITRIM (PATTRN)
      IF (ADDR(I-J+1:I).EQ.PATTRN(:J)) GO TO 25
      PATTRN = '.net'
      J = ITRIM (PATTRN)
      IF (ADDR(I-J+1:I).EQ.PATTRN(:J)) GO TO 25
      PATTRN = '.gov'
      J = ITRIM (PATTRN)
      IF (ADDR(I-J+1:I).EQ.PATTRN(:J)) GO TO 25
      GO TO 30
 25      KEY = 'Net=ARPA/Internet'
         CALL SRTSUB ('PUT', L3, NETSRV, 'ARPA/Internet-service',
     *                                                      KMACH+1)
         GO TO 80
C                                       UUCP?
 30   CONTINUE
      PATTRN= '.uucp'
      J = ITRIM (PATTRN)
      IF (ADDR(I-J+1:I).EQ.PATTRN(:J)) GO TO 35
      IF (INDEX(ADDR,'!').GT.0) GO TO 35
      GO TO 40
 35      KEY = 'Net=UUCP'
         CALL SRTSUB ('PUT', L3, NETSRV, 'UUCP-service', KMACH+1)
         GO TO 80
C                                       SPAN?
 40   CONTINUE
      IF ((INDEX(ADDR,'::').LE.0) .AND. (INDEX(ADDR,'.SPAN').LE.0)
     *   .AND. (INDEX(ADDR,'.span').LE.0) .AND.
     *   (INDEX(ADDR,'.HEPNET').LE.0) .AND.
     *   (INDEX(ADDR,'.hepnet').LE.0)) GO TO 50
         KEY = 'Net=SPAN/HEPNET'
         CALL SRTSUB ('PUT', L3, NETSRV, 'SPAN/HEPNET-service', KMACH+1)
         GO TO 80
C
 50   CONTINUE
      GO TO 70
C
 70   KEY = 'Net=Miscellaneous'
C
 80   CONTINUE
      CALL SRTSUB ('PUT', L3, KEY, ADDR, KMACH)
C
      RETURN
      END
      SUBROUTINE ATTSRT (L3, ADDR, KMACH)
C-----------------------------------------------------------------------
C     routine to call SRTSUB with attributes for crossref.
C     DCW, 27Mar87.
C-----------------------------------------------------------------------
      INTEGER     L3, KMACH
      CHARACTER   ADDR*(*)
C
      INTEGER     I, J, K, ITRIM
      CHARACTER   KEY*20, LOCAL*80, TEMP*80
C
C-----------------------------------------------------------------------
C
      LOCAL = ADDR
      I = ITRIM (LOCAL)
      KEY = 'Attributes'
      J = 0
 10   J = J + 1
      IF (LOCAL(1:1).NE.' ') GO TO 20
         TEMP = LOCAL(2:)
         LOCAL = TEMP
         GO TO 10
 20   K = INDEX (LOCAL, ' ')
      TEMP = LOCAL(:K-1)
      CALL SRTSUB ('PUT', L3, KEY, TEMP, KMACH)
      TEMP = LOCAL(K+1:)
      LOCAL = TEMP
      IF (LOCAL.NE.' ') GO TO 10
C
      RETURN
      END
      SUBROUTINE APARSE (L6, NADDR, ADDR, LOCAL, AERROR,
     *                     CLNAME, CCNTRY, CZIP, CCITY, CINSTN, CSTRET)
C-----------------------------------------------------------------------
C     routine to parse an ADDR() array of character strings in ADR
C     format to extract selected items (postal code, country,
C     "institution", city, last-name, ...)
C     DCW, NRAO-CV, 30Mar87.
C-----------------------------------------------------------------------
      IMPLICIT    NONE
      INTEGER     L6, NADDR
      LOGICAL     AERROR, LUPPER
      CHARACTER   ADDR(NADDR)*(*), LOCAL*(*), CLNAME*(*), CCNTRY*(*),
     *               CZIP*(*), CCITY*(*), CINSTN*(*), CSTRET*(*)
C
      INTEGER     ECODE, ITRIM, I, J, NINST, L, K, L2
      LOGICAL     DBG
      PARAMETER   (NINST = 60, DBG=.FALSE.)
      CHARACTER   INSTIT(NINST)*14, TEMP*72
C
      DATA  INSTIT /
     *   'Observatory',    'Obs.',  'Osservatorio',   'Observatoire',
     *   'Observatorium',  'Opservatoija',   'Observatories',
     *   'Sterrenwacht',   'Sterrewacht',    'Sternwarte',
     *   'Institute',      'Inst.',    'Institut', 'Instituto',
     *   'College',        'Coll.',
     *   'University',     'Univ.',    'Universite', 'Universidad',
     *   'Corporation',    'Corp.',    'Inc.',  'Ltd.',
     *   'Company',        'Co.',      'Center',   'Ctr.',  'Centre',
     *   'Laboratory',     'Lab.',     'Lab',   'Laboratorium',
     *   'Laboratories',   'Labs.',    'Labs',  'Division', 'Div.',
     *   'Department',     'Dept.',    'Unit',  'Group',
     *   'Systems',        'Society',  'Association', 'Assoc.',
     *   'Found.',         'Administration', 'Admin.',   'Headquarters',
     *   'School',         'Sch.',     'Planetarium',    'Plan.',
     *   'Magazine',       'Museum',   'Service', 'Services', 'Survey',
     *   'Telescope' /
C-----------------------------------------------------------------------
      AERROR = .FALSE.
      CZIP = ' '
      CCNTRY = ' '
      CINSTN = ' '
      CSTRET = ' '
      CCITY = ' '
      CLNAME = ' '
      IF (NADDR.LT.4) WRITE (L6, *) 'APARSE, warning: NADDR.LT.4 !'
      ECODE = 1
      IF (NADDR.LT.2) GO TO 980
      IF (.NOT.DBG) GO TO 4
         DO 3 I = 1, NADDR
 3       WRITE (6,'('' APARSE, ADDR('',I2,'')='',A)')
     *                                 I, ADDR(I)(:ITRIM(ADDR(I)))
 4    CONTINUE
C                                       Last name:
      ECODE = 2
      IF ((ADDR(1)(1:1).EQ.'\').OR.(ADDR(2)(1:1).EQ.'\')) GO TO 980
      CLNAME = ADDR(1)(:ITRIM (ADDR(1))) // ', ' //
     *                                       ADDR(2)(:ITRIM(ADDR(2)))
      IF (DBG) WRITE (6,*) 'CLNAME=', CLNAME(:ITRIM(CLNAME))
C                                       Country:
      J = NADDR
C                                       Look for last non-backslash:
 210  J = J - 1
      IF ((ADDR(J)(1:1).EQ.'\').AND.(J.GT.1)) GO TO 210
      ECODE = 210
      IF (J.LT.3) GO TO 980
C                                       Check for upper case:
C                                       (Default to local country)
      LUPPER = .FALSE.
      CCNTRY = LOCAL
      L = ITRIM (ADDR(J))
      IF (L.LE.0) GO TO 230
         DO 220 I = 1, L
            K = ICHAR (ADDR(J)(I:I))
            IF ( ((K.GE.ICHAR('A')).AND.(K.LE.ICHAR('Z')))
     *      .OR. ((K.GE.ICHAR('0')).AND.(K.LE.ICHAR('9')))
     *      .OR.  (K.EQ.ICHAR(' '))
     *      .OR.  (K.EQ.ICHAR('-')) ) GO TO 220
               GO TO 230
 220        CONTINUE
         LUPPER = .TRUE.
         CCNTRY = ADDR(J)
 230  CONTINUE
      IF (DBG) WRITE (6,*) 'CCNTRY=', CCNTRY
C                                       Postal Code:
      IF (.NOT.LUPPER) GO TO 320
 310     J = J - 1
         IF ((ADDR(J)(1:1).EQ.'\').AND.(J.GT.1)) GO TO 310
 320  ECODE = 320
      IF (J.LT.3) GO TO 980
      CCITY = ADDR(J)
C                                       parse "city, state zip":
      IF ((CCNTRY.NE.'USA').AND.(CCNTRY.NE.'CANADA')) GO TO 322
         I = INDEX (CCITY, ',')
         ECODE = 321
         IF (I.LE.0) GO TO 980
         IF (CCITY(I+1:I+1).NE.' ') GO TO 980
         K = INDEX (CCITY(I+2:), ' ')
         I = I + K + 1
         IF (I.GT.ITRIM(CCITY)) GO TO 980
         CZIP = CCITY(I+1:)
         TEMP = CCITY(:I-1)
         CCITY = TEMP
         GO TO 330
C                                       parse ENGLAND postal code:
 322  IF (CCNTRY.NE.'ENGLAND') GO TO 324
         ECODE = 323
C                                       locate last comma:
         I = INDEX (CCITY, ',')
         IF (I.LE.0) GO TO 980
         I = I + 1
         K = INDEX (CCITY(I:), ',')
         IF (K.GT.0) I = I + K + 1
         IF (INDEX (CCITY(I:), ',').NE.0) GO TO 980
C                                       must be followed by blank:
         IF (CCITY(I:I).NE.' ') GO TO 980
C                                       locate next-to-last blank:
         L2 = ITRIM(CCITY)
         K = 0
 323     L = I
         I = I + K
         K = INDEX (CCITY(I+1:L2), ' ')
         IF ((I.LT.L2).AND.(K.GT.0)) GO TO 323
         CZIP = CCITY(L+1:)
         TEMP = CCITY(:L-1)
         CCITY = TEMP
         GO TO 330
 324  CONTINUE
C                                       strip leading blanks:
 330  IF ((CZIP.EQ.' ').OR.(CZIP(1:1).NE.' ')) GO TO 340
 335     TEMP = CZIP(2:)
         CZIP = TEMP
         IF (CZIP(1:1).EQ.' ') GO TO 335
 340  CONTINUE
      IF (DBG) WRITE (6,*) 'CZIP=', CZIP(:ITRIM(CZIP)), ', CCITY=',
     *                           CCITY(:ITRIM(CCITY))
C                                       Institution:
C                                       (street accumulates leftovers)
      CINSTN = ' '
 410  J = J - 1
      IF ((ADDR(J)(1:1).EQ.'\').AND.(J.GT.0)) GO TO 410
      IF (J.LT.3) GO TO 425
      DO 420 I = 1, NINST
         IF (INDEX (ADDR(J), INSTIT(I)(:ITRIM(INSTIT(I)))).NE.0)
     *                                                GO TO 430
 420     CONTINUE
      IF (CSTRET.NE.' ') GO TO 422
         CSTRET = ADDR(J)
         GO TO 424
 422  TEMP = ADDR(J)(:ITRIM(ADDR(J))) // ', ' // CSTRET
      CSTRET = TEMP
 424  IF (J.GT.2) GO TO 410
 425  CINSTN = '(no institute?)'
      GO TO 490
 430  TEMP = '\N{Inst.}'
      I = ITRIM(TEMP)
      K = INDEX (ADDR(J), TEMP(:I))
      IF (K.EQ.0) GO TO 435
         TEMP = ADDR(J)(:K-1) // ADDR(J)(K+I:)
         ADDR(J) = TEMP
 435  CINSTN = ADDR(J)
 490  CONTINUE
      IF (DBG) WRITE (6,*) 'CINSTN=', CINSTN
C                                       finish off the 'street':
 510  J = J - 1
      IF (J.LT.3) GO TO 590
         IF (CSTRET.NE.' ') GO TO 520
            CSTRET = ADDR(J)(:ITRIM(ADDR(J)))
            GO TO 510
 520     CONTINUE
            TEMP = ADDR(J)(:ITRIM(ADDR(J))) // ', ' // CSTRET
            CSTRET = TEMP
            GO TO 510
 590  CONTINUE
C
      GO TO 990
C                                       oops---error:
 980  WRITE (L6,*) 'APARSE error', ECODE, ' for: "',
     *                                 CLNAME(:ITRIM(CLNAME)), '"'
      AERROR = .TRUE.
C
 990  RETURN
      END

      PROGRAM GR2TEX
C-----------------------------------------------------------------------
C! converts gripe file or GRITP tape to TEX-like grip file on disk
C# Service
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   GR2TEX is a service program to read either the local AIPS Gripe file
C   or the tape prepared by GRITP from other computers.  The input is
C   converted to a Fortran text file suitable for input to TEX. The file
C   is written to a directory which is specified by the value of the
C   logical symbol "TARGET".  Under VMS, TARGET can even include a
C   DECnet specification, e.g.
C        Define TARGET "CVAX""DON""::UMA0:[DON.AIPGRIP]"
C-----------------------------------------------------------------------
      CHARACTER PHNAME*48, IBSL*2, ICR*1, ILF*1, TEXT*80, PRGNAM*6,
     *   STR*12, FNAME*128, LINE*80, CBUF*2880, SAVEIT*80, SAVEID*80,
     *   ANSW*1, MSGBUF*72, ATIME*8, ADATE*12, SBUF*2880, REMHOS*24,
     *   LMSG*80
      HOLLERITH HBUF(720)
      INTEGER   SCR(256), TVOL, TLUN, TIND, DIND, DLUN, IERR, II, I, IC,
     *   IBUF(720), LREC, LPOS, LBYTES, BRTY, NMAX, INPO, ITRIM, TXLUN,
     *   TXIND, ITY, OUPO, LSAVE, ISAVE, NGRIPE, IREC, TTY(2), ITIME(3),
     *   IDATE(3), IDENS, REMTAP, SYSERR
      LOGICAL   T, F, TAPE, QUIT, NOANSW
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      EQUIVALENCE (IBUF, HBUF)
      DATA TXLUN, DLUN /10,27/
      DATA IBSL /'\\'/
      DATA T, F /.TRUE.,.FALSE./
      DATA PRGNAM /'GR2TEX'/
C-----------------------------------------------------------------------
      ICR = CHAR (10)
      ILF = CHAR (13)
C                                       AIPS init
      TIND = 0
      DIND = 0
      TTY(1) = 5
      CALL AIPINI (TTY, PRGNAM, IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Talk to user
 10   WRITE (MSGBUF,1000)
      CALL INQINT (TTY, MSGBUF, 1, TVOL, IERR)
      IF (IERR.GT.0) GO TO 980
      IF (IERR.LT.0) GO TO 10
      TAPE = TVOL.GT.0
      QUIT = .FALSE.
C                                       Open disk
      IF (.NOT.TAPE) THEN
         WRITE (MSGBUF,1010)
         CALL INQSTR (TTY, MSGBUF, 48, PHNAME, IERR)
         IF (IERR.NE.0) GO TO 980
         CALL CHLTOU (48, PHNAME)
         IF (PHNAME.EQ.' ') CALL ZPHFIL ('GR', 1, 0, 0, PHNAME, IERR)
         CALL ZOPEN (DLUN, DIND, 1, PHNAME, F, T, T, IERR)
         IF (IERR.NE.0) THEN
            DIND = 0
            GO TO 980
            END IF
         CALL ZFIO ('READ', DLUN, DIND, 1, IBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         LREC = IBUF(3)
         LPOS = IBUF(4) - 1
         IF (IBUF(2).LE.0) THEN
            WRITE (MSGTXT,1011)
            CALL MSGWRT (2)
            GO TO 980
            END IF
         IREC = 1
         IF (LPOS.LE.0) THEN
            LPOS = 1024
            LREC = LREC - 1
            END IF
C                                       Open tape
      ELSE
         TLUN = 129 - TVOL
         CALL ZPHFIL ('MT', TVOL, 0, 0, PHNAME, IERR)
         CALL ZTPOPN (TLUN, TIND, TVOL, PHNAME, 'READ', IERR)
         IF (IERR.NE.0) THEN
            TIND = 0
            GO TO 980
            END IF
         IREC = 0
C                                       Mount tape
 20      MSGBUF = 'Mount at density = ????;   0 or N => don''t mount'
         CALL INQINT (TTY, MSGBUF, 1, IDENS, IERR)
         IF (IERR.GT.0) GO TO 980
         IF ((IERR.EQ.0) .AND. (IDENS.GT.0)) THEN
           IF ((IDENS.NE.800) .AND. (IDENS.NE.1600) .AND.
     *        (IDENS.NE.6250)) GO TO 20
            MSGBUF = 'Enter remote host name - just hit return if local'
            CALL INQSTR (TTY, MSGBUF, 24, REMHOS, IERR)
            IF (IERR.GT.0) GO TO 980
            IF (REMHOS(1:1).NE.' ') THEN
               MSGBUF = 'Remote host tape drive number:'
               CALL INQINT (TTY, MSGBUF, 1, REMTAP, IERR)
               IF (IERR.GT.0) GO TO 980
               IF (IERR.LT.0) THEN
                  REMHOS = ' '
                  REMTAP = 0
                  END IF
               END IF
C                                       Mount
            CALL ZMOUNT (.TRUE., TVOL, IDENS, REMHOS, REMTAP, LMSG,
     *         SYSERR, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1015) IERR
               CALL MSGWRT (8)
               GO TO 980
               END IF
            END IF
C                                       Position tape
 25      MSGBUF = 'Tape file number to read;  0 => current'
         CALL INQINT (TTY, MSGBUF, 1, I, IERR)
         IF (IERR.LT.0) GO TO 25
         IF (IERR.GT.0) GO TO 980
         IC = 1
         IF (I.GT.0) THEN
            CALL ZTAPE ('REWI', TLUN, TIND, IC, IERR)
            IF (IERR.NE.0) GO TO 980
            I = I - 1
            IF (I.GT.0) CALL ZTAPE ('ADVF', TLUN, TIND, I, IERR)
         ELSE
            CALL ZTAPE ('BAKF', TLUN, TIND, IC, IERR)
            END IF
         IF (IERR.NE.0) GO TO 980
         END IF
C                                       More inits
      BRTY = 1
C                                       Create output file
      MSGBUF = 'Output file name, without the .TEX, <= 12 characters'
      CALL INQSTR (TTY, MSGBUF, 12, STR, IERR)
      IF (IERR.NE.0) GO TO 980
      CALL CHLTOU (12, STR)
      IC = ITRIM (STR)
      FNAME = 'TARGET:' // STR(:IC) // '.TEX'
      CALL ZTXOPN ('WRIT', TXLUN, TXIND, FNAME, .FALSE., IERR)
      IF (IERR.NE.0) THEN
         IC = ITRIM (FNAME)
         IC = MIN (IC, 58)
         WRITE (MSGTXT,1040) IERR, FNAME(:IC)
         CALL MSGWRT (8)
         GO TO 980
         END IF
C                                       TEX initial lines
      NGRIPE = 10000
      TEXT = IBSL(1:1) // 'input docgrip:gripemac5.tex'
      IC = ITRIM (TEXT)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, TEXT(:IC), IERR)
      IF (IERR.NE.0) GO TO 980
      TEXT = IBSL(1:1) // 'def' // IBSL(1:1) // 'finalrun{F}'
      IC = ITRIM (TEXT)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, TEXT(:IC), IERR)
      IF (IERR.NE.0) GO TO 980
C                                       Initialize date string:
      CALL ZTIME (ITIME)
      CALL ZDATE (IDATE)
      CALL TIMDAT (ITIME, IDATE, ATIME, ADATE)
C                                       READ: internal procedure
 50   IREC = IREC + 1
      INPO = 0
      IF (QUIT) GO TO 200
      IF (.NOT.TAPE) THEN
         CALL ZFIO ('READ', DLUN, DIND, IREC, IBUF, IERR)
         IF (IERR.NE.0) GO TO 980
         QUIT = IREC.EQ.LREC
         NMAX = 1024
         IF (QUIT) NMAX = LPOS
         CALL H2CHR (NMAX, 1, HBUF, CBUF)
C                                       Tape read
      ELSE
         CALL ZTPMIO ('READ', TLUN, TIND, 2880, IBUF, 1, IERR)
         IF (IERR.EQ.0) CALL ZTPWAT (TLUN, TIND, 1, LBYTES, IERR)
         IF (IERR.NE.0) GO TO 980
         CALL ZC8CL (2880, 1, IBUF, SBUF)
         NMAX = 0
         DO 80 I = 1,2880,80
            TEXT = SBUF(I:I+79)
            IF (TEXT(1:1).NE.' ') THEN
               QUIT = TEXT(:8).EQ.'END '
               IF ((QUIT) .AND. (NMAX.EQ.0)) GO TO 200
               IF (QUIT) GO TO 90
            ELSE
               DO 70 II = 9,80
                  NMAX = NMAX + 1
                  CBUF(NMAX:NMAX) = TEXT(II:II)
                  IF ((NMAX.EQ.2) .AND. (CBUF(2:2).NE.IBSL(1:1)) .AND.
     *               (CBUF(1:1).EQ.IBSL(1:1))) CBUF(1:1) = ILF
                  IF ((NMAX.GT.1) .AND. (CBUF(NMAX:NMAX).EQ.IBSL(1:1)))
     *               THEN
                     IF ((I+II.EQ.2881) .AND. (CBUF(NMAX-1:NMAX-1)
     *                  .NE.IBSL(1:1))) CBUF(NMAX:NMAX) = ICR
                     IF (CBUF(NMAX-1:NMAX-1).EQ.IBSL(1:1)) THEN
                        CBUF(NMAX-1:NMAX-1) = ICR
                        CBUF(NMAX:NMAX) = ILF
                        END IF
                     END IF
 70               CONTINUE
               END IF
 80         CONTINUE
         END IF
C-----------------------------------------------------------------------
C                                       Branch by type of record out
 90   GO TO (100, 115, 125, 145), BRTY
C                                       New gripe
 100  CONTINUE
         BRTY = 1
         ITY = 0
C                                       New argument
 110     ITY = ITY + 1
         IF (ITY.GE.11) GO TO 100
C                                       Find first char
 115  CONTINUE
         BRTY = 2
         INPO = INPO + 1
         IF (INPO.GT.NMAX) GO TO 50
         IF (CBUF(INPO:INPO).EQ.' ') GO TO 115
         OUPO = 1
         LINE = ' '
         BRTY = 4
         IF (ITY.EQ.7) GO TO 140
         BRTY = 3
C                                       Normal argument
 120     LINE(OUPO:OUPO) = CBUF(INPO:INPO)
         IF (CBUF(INPO:INPO).EQ.'}') GO TO 130
C                                       Advance to next character
 125  CONTINUE
         INPO = INPO + 1
         IF (INPO.GT.NMAX) GO TO 50
         OUPO = MIN (OUPO+1, 80)
         GO TO 120
C                                       write out new gripe
 130  IF (ITY.EQ.1) THEN
         NGRIPE = NGRIPE + 1
         TEXT = ' '
         CALL ZTXIO ('WRIT', TXLUN, TXIND, TEXT(:2), IERR)
         IF (IERR.NE.0) GO TO 980
         WRITE (TEXT,1130) IBSL(1:1) // 'count0=', NGRIPE
         IC = ITRIM (TEXT)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, TEXT(:IC), IERR)
         IF (IERR.NE.0) GO TO 980
         TEXT = IBSL(1:1) // 'def' // IBSL(1:1) // 'rda{' // ADATE(:11)
     *      // '}'
         IC = ITRIM (TEXT)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, TEXT(:IC), IERR)
         IF (IERR.NE.0) GO TO 980
         TEXT = IBSL(1:1) // 'gripe'
         IC = ITRIM (TEXT)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, TEXT(:IC), IERR)
         IF (IERR.NE.0) GO TO 980
         SAVEIT = LINE(:OUPO)
         LSAVE  = OUPO
         END IF
      IF (ITY.EQ.6) THEN
         TEXT = '{' // IBSL(1:1) // 'phone' // LINE(:OUPO) //
     *      SAVEID(:ISAVE) // '}'
         IC = ITRIM (TEXT)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, TEXT(:IC), IERR)
         IF (IERR.NE.0) GO TO 980
         END IF
      NOANSW = (ITY.EQ.10) .AND. (LINE(:OUPO).EQ.'{ }')
      IF ((ITY.NE.3) .AND. (ITY.NE.6) .AND. (.NOT.NOANSW)) THEN
         TEXT = LINE(:OUPO)
         IC = ITRIM (TEXT)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, TEXT(:IC), IERR)
         IF (IERR.NE.0) GO TO 980
         END IF
      IF (NOANSW) THEN
         TEXT = '{' // IBSL(1:1) // 'secret{}%%'
         IC = ITRIM (TEXT)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, TEXT(:IC), IERR)
         IF (IERR.NE.0) GO TO 980
         TEXT = IBSL(1:1) // 'newgripe}'
         IC = ITRIM (TEXT)
         CALL ZTXIO ('WRIT', TXLUN, TXIND, TEXT(:IC), IERR)
         IF (IERR.NE.0) GO TO 980
         END IF
      IF (ITY.EQ.3) THEN
         SAVEID = LINE(:OUPO)
         ISAVE  = OUPO
         END IF
      IF (ITY.EQ.4) THEN
         WRITE (MSGTXT,1131) NGRIPE, SAVEIT(:LSAVE), LINE(:OUPO)
         CALL MSGWRT (4)
         END IF
      GO TO 110
C                                       Gripe text
 140  IF (CBUF(INPO:INPO).EQ.ICR) GO TO 150
      IF (CBUF(INPO:INPO).EQ.ILF) OUPO = OUPO - 1
      IF (CBUF(INPO:INPO).EQ.ILF) GO TO 145
      LINE(OUPO:OUPO) = CBUF(INPO:INPO)
      IF (CBUF(INPO:INPO).EQ.'}') GO TO 150
C                                       advance to next character
 145  IF (OUPO.LT.80) THEN
         INPO = INPO + 1
         IF (INPO.GT.NMAX) GO TO 50
         OUPO = OUPO + 1
         GO TO 140
         END IF
C                                       write text
 150  IF (CBUF(INPO:INPO).EQ.ICR) OUPO = OUPO - 1
      TEXT = LINE(:OUPO)
      IC = ITRIM (TEXT)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, TEXT(:IC), IERR)
      IF (IERR.NE.0) GO TO 980
      IF (CBUF(INPO:INPO).EQ.'}') GO TO 110
         OUPO = 0
         GO TO 145
C                                       Done: \end
 200  TEXT = ' '
      CALL ZTXIO ('WRIT', TXLUN, TXIND, TEXT(:2), IERR)
      IF (IERR.NE.0) GO TO 980
      TEXT = IBSL(1:1) // 'end'
      IC = ITRIM (TEXT)
      CALL ZTXIO ('WRIT', TXLUN, TXIND, TEXT(:IC), IERR)
      IF (IERR.NE.0) GO TO 980
      CALL ZTXCLS (TXLUN, TXIND, IERR)
      IF (IERR.LE.0) THEN
         MSGTXT = 'Gripe output file CLOSEd. Safe to init.'
         CALL MSGWRT (4)
      ELSE
         MSGTXT = 'Error CLOSEing gripe output file; try again.'
         CALL MSGWRT (8)
         GO TO 980
         END IF
C                                       Init disk file?
 300  IF (TAPE) THEN
C                                       Dismount tape
         MSGBUF = 'Do you wish to dismount the tape? Y or y, else => no'
         CALL INQSTR (TTY, MSGBUF, 1, ANSW, IERR)
         CALL CHLTOU (1, ANSW)
         IF ((IERR.EQ.0) .AND. (ANSW.EQ.'Y')) THEN
            CALL ZMOUNT (.FALSE., TVOL, 0, ' ', 0, LMSG, SYSERR, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1300) IERR
               CALL MSGWRT (8)
               END IF
            END IF
      ELSE
         MSGBUF = 'Initialize the disk file? Y or y,' //
     *      '  anything else => no'
         CALL INQSTR (TTY, MSGBUF, 1, ANSW, IERR)
         CALL CHLTOU (1, ANSW)
C                                       require password
         IF ((IERR.EQ.0) .AND. (ANSW.EQ.'Y')) THEN
            CALL PASWRD (SCR, IERR)
            IF (IERR.NE.0) GO TO 980
            CALL ZFIO ('READ', DLUN, DIND, 1, IBUF, IERR)
            IF (IERR.NE.0) GO TO 980
            IBUF(2) = 0
            IBUF(3) = 2
            IBUF(4) = 1
            CALL ZFIO ('WRIT', DLUN, DIND, 1, IBUF, IERR)
            END IF
         END IF
C
 980  IF (TIND.GT.0) CALL ZTPCLS (TLUN, TIND, IERR)
      IF (DIND.GT.0) CALL ZCLOSE (DLUN, DIND, IERR)
      CALL ACOUNT (2)
C
 999  STOP
C-----------------------------------------------------------------------
 1000 FORMAT ('Tape drive number;  0 => disk')
 1010 FORMAT ('Disk file name (default = "DA00:GR100000.;1")')
 1011 FORMAT ('GRIPE FILE IS EMPTY: QUITTING')
 1015 FORMAT ('ZMOUNT RETURNS ERROR',I6)
 1040 FORMAT ('ERROR',I3,' OPENING FILE ',A)
 1130 FORMAT (A,I5.5)
 1131 FORMAT (I5,1X,A,1X,A)
 1300 FORMAT ('ERROR',I5,' DISMOUNTING THE TAPE')
      END

      SUBROUTINE ANINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ, RDATE,
     *   POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME, XYZHAN, TFRAME, NUMORB,
     *   NOPCAL, ANTNIF, ANFQID, IERR)
C-----------------------------------------------------------------------
C! creates and initializes antenna tables
C# EXT-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2000-2001, 2005-2006, 2008-2010,
C;  Copyright (C) 2017-2018, 2021
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes antenna tables.  THIS ROUTINE SHOULD BE
C   CALLED BY ANTINI ONLY - DO NOT CALL IT FROM YOUR OWN CODE.
C   This does the actual file creation and inits the I/O for read or
C   write - but ANTINI takes care of any needed format translation as
C   well.
C   Inputs:
C      OPCODE   C*4      Operation code:
C                           'WRIT' = create/init for write or read
C                           'READ' = open for read only
C      BUFFER   I(512)   I/O buffer and related storage, also defines
C                        file if open.
C      DISK     I        Disk to use.
C      CNO      I        Catalog slot number
C      CATBLK   I(*)     Catalog header block.
C      LUN      I        Logical unit number to use
C   Input (create only) / output (pre-existing file):
C      VER      I        AN file version, actual value set on return
C      ARRAYC   D(3)     Array center X coord. (meters, earth center)
C      GSTIA0   D        GST at time=0 (degrees) on ref. date
C      DEGPDY   D        Earth rotation rate (deg/IAT day)
C      SAFREQ   D        Obs. Reference Frequency for subarray(Hz)
C      RDATE    C*8      Reference date as 'DD/MM/YY'
C      POLRXY   R(2)     Polar position X,Y (src sec) on ref. date
C      UT1UTC   R        UT1-UTC  (time sec.)          "
C      DATUTC   R        data time-UTC  (time sec.)          "
C      TIMSYS   C*8      Time system, 'IAT' or 'UTC'
C      ANAME    C*8      Array name
C      XYZHAN   C*8      Array handedness ('RIGHT' will be forced)
C      TFRAME   C*8      Terrestrial coordinate frame
C      NUMORB   I        Number of orbital parameters
C      NOPCAL   I        Number of polarization calibration constants.
C      ANTNIF   I        Number of IFs.
C      ANFQID   I        Table keyword, denotes the FQ ID for which
C                          the AN parms have been modified. On O/P if
C                          ANFQID = -999 it is not in the table, if
C                          ANFQID = -1 the virgin values still exist,
C                          or the data have no FREQID random parameter
C   Output:
C      IANRNO   I        Next scan number, start of the file if READ,
C                        the last+1 if WRITE
C      ANNUMV   I(*)     Element count in each column size MAXANC
C      ANKOLS   I(*)     The column pointer array in order, ANNAME,
C                        STABXYZ, ORBPARM, NOSTA, MNTSTA, STAXOF,
C                        POLTYA, POLAA, POLCALA, POLTYB, POLAB, POLCALB
C                        - size MAXANC
C      IERR     I        Return error code, 0=>OK, else error
C   Useage NOTE: use the include 'DANT.INC' for the declarations in
C   ANINI and TABAN.  Uses COPY for RCOPY (real -> double) while
C   RCOPY for (double -> real)
C-----------------------------------------------------------------------
      INCLUDE 'INCS:PUVD.INC'
C                                       Any changes here should also be
C                                       made in DANT.INC and ANTINI
      INTEGER   ANKOLS(MAXANC), ANNUMV(MAXANC), NUMORB, NOPCAL, IANRNO,
     *   ANTNIF, ANFQID
      CHARACTER ANAME*8, TIMSYS*8, RDATE*8, XYZHAN*8, TFRAME*8
      REAL      POLRXY(2), UT1UTC, DATUTC
      DOUBLE PRECISION  ARRAYC(3), GSTIA0, DEGPDY, SAFREQ
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, IERR
C
      INTEGER   NK
      PARAMETER (NK = 20)
C
      INTEGER   NKEY, NREC, DATP(128,2), NCOL, NTT, DTYP(MAXANC), NDATA,
     *   KLOCS(NK), KEYVAL(80), IPOINT, KEYTYP(NK), I, ITEMP(6), NKEYRD,
     *   MSGSAV, JERR, NC, ITRIM, IVER
      LOGICAL   DOREAD, NEWFIL
      REAL      KEYVAR(80), XYPOL(2), RADSQ
      HOLLERITH KEYVAH(80), HOLTMP(6)
      DOUBLE PRECISION KEYVAD, JD, UTC, SECS
      CHARACTER KEYW(NK)*8, TTITLE*56, TITLE(MAXANC)*24, DATE*11,
     *   UNITS(MAXANC)*8
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (KEYVAL, KEYVAR, KEYVAH),  (HOLTMP, ITEMP)
      DATA NTT /56/
      DATA TTITLE /'AIPS UV DATA FILE ANTENNA TABLE '/
      DATA DTYP /83, 31, 1, 14, 14, 12, 12, 2, 13, 12, 2, 13, 12, 2/
      DATA TITLE /'ANNAME', 'STABXYZ', 'ORBPARM', 'NOSTA', 'MNTSTA',
     *   'STAXOF', 'DIAMETER', 'BEAMFWHM', 'POLTYA', 'POLAA', 'POLCALA',
     *   'POLTYB', 'POLAB', 'POLCALB'/
      DATA KEYW /'ARRAYX', 'ARRAYY', 'ARRAYZ', 'GSTIA0', 'DEGPDY',
     *   'FREQ', 'RDATE', 'POLARX', 'POLARY', 'UT1UTC', 'DATUTC',
     *   'TIMSYS', 'ARRNAM', 'XYZHAND', 'FRAME', 'NUMORB', 'NOPCAL',
C                                       Leave IATUTC last to look for
C                                       old tables.
     *   'NO_IF', 'FREQID', 'IATUTC'/
      DATA UNITS /' ', 'METERS', 3*' ', 'METERS', 'METERS', 'DEGR/M',
     *   ' ', 'DEGREES',' ', ' ', 'DEGREES', ' '/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NREC = 30
      NCOL = MAXANC
      NDATA = MAXANC
      NKEY = NK
      IVER = VER
C                                       Fill in types, lengths
      IF (.NOT.DOREAD) THEN
         NKEY = NK + ANTNIF + 5
         DO 10 I = 1,NDATA
            DATP(I,2) = DTYP(I)
 10         CONTINUE
         DATP(3,2) = DATP(3,2) + 10 * NUMORB
         DATP(8,2) = DATP(8,2) + 10 * ANTNIF
         DATP(11,2) = DATP(11,2) + 10 * NOPCAL * ANTNIF
         DATP(14,2) = DATP(14,2) + 10 * NOPCAL * ANTNIF
C                                       is this an old file?
         IF (IVER.GT.0) THEN
            MSGSAV = MSGSUP
            MSGSUP = 32000
            CALL TABINI ('READ', 'AN', DISK, CNO, VER, CATBLK, LUN,
     *         NKEY, NREC, NCOL, DATP, BUFFER, IERR)
            IF (IERR.EQ.0) THEN
               CALL TABIO ('CLOS', 0, IANRNO, BUFFER, BUFFER, IERR)
            ELSE
               NKEY = NK + ANTNIF + 5
               END IF
            MSGSUP = MSGSAV
            VER = IVER
            END IF
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'AN', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'ANINI', IERR)
         GO TO 990
         END IF
      NEWFIL = (IERR.LT.0)
      NKEYRD = BUFFER(53)
C                                       Get number of records
      IANRNO = BUFFER(5) + 1
      IF (DOREAD) IANRNO = 1
      NKEY = NK
C                                       File created, initialize
      IF (NEWFIL) THEN
         DO 40 I = 1,NCOL
C                                       Col. labels.
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'ANINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'ANINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       Set keyword values
C                                       Write old 'IATUTC' for
C                                       compatibility.  This should be
C                                       removed after about 1993.
         IPOINT = 1
C                                       Array center
         KLOCS(1) = IPOINT
         KEYTYP(1) = 1
         CALL RCOPY (NWDPDP, ARRAYC(1), KEYVAR(IPOINT))
         IPOINT = IPOINT + NWDPDP
         KLOCS(2) = IPOINT
         KEYTYP(2) = 1
         CALL RCOPY (NWDPDP, ARRAYC(2), KEYVAR(IPOINT))
         IPOINT = IPOINT + NWDPDP
         KLOCS(3) = IPOINT
         KEYTYP(3) = 1
         CALL RCOPY (NWDPDP, ARRAYC(3), KEYVAR(IPOINT))
         IPOINT = IPOINT + NWDPDP
C                                       GST at time=0
         KLOCS(4) = IPOINT
         KEYTYP(4) = 1
         CALL RCOPY (NWDPDP, GSTIA0, KEYVAR(IPOINT))
         IPOINT = IPOINT + NWDPDP
C                                       Earth rotation rate
         KLOCS(5) = IPOINT
         KEYTYP(5) = 1
         CALL RCOPY (NWDPDP, DEGPDY, KEYVAR(IPOINT))
         IPOINT = IPOINT + NWDPDP
C                                       Subarray frequency
         KLOCS(6) = IPOINT
         KEYTYP(6) = 1
         CALL RCOPY (NWDPDP, SAFREQ, KEYVAR(IPOINT))
         IPOINT = IPOINT + NWDPDP
C                                       Reference date
         KLOCS(7) = IPOINT
         KEYTYP(7) = 3
         CALL CHR2H (8, RDATE, 1, KEYVAL(IPOINT))
         IPOINT = IPOINT + 2
C                                       Polar x and y posn.
         XYPOL(1) = POLRXY(1)
         XYPOL(2) = POLRXY(2)
C                                       check for units being meters
         RADSQ = XYPOL(1)*XYPOL(1) + XYPOL(2)*XYPOL(2)
         IF (RADSQ.GT.0.36) THEN
            XYPOL(1) = XYPOL(1) / 30.922
            XYPOL(2) = XYPOL(2) / 30.922
            END IF
         KLOCS(8) = IPOINT
         KEYTYP(8) = 1
         KEYVAD = XYPOL(1)
         CALL RCOPY (NWDPDP, KEYVAD, KEYVAR(IPOINT))
         IPOINT = IPOINT + NWDPDP
         KLOCS(9) = IPOINT
         KEYTYP(9) = 1
         KEYVAD = XYPOL(2)
         CALL RCOPY (NWDPDP, KEYVAD, KEYVAR(IPOINT))
         IPOINT = IPOINT + NWDPDP
C                                       UT1 - UTC
         KLOCS(10) = IPOINT
         KEYTYP(10) = 1
         KEYVAD = UT1UTC
         CALL RCOPY (NWDPDP, KEYVAD, KEYVAR(IPOINT))
         IPOINT = IPOINT + NWDPDP
C                                       Time - UTC
         KLOCS(11) = IPOINT
         KEYTYP(11) = 1
         KEYVAD = DATUTC
         IF (TIMSYS.EQ.'UTC') KEYVAD = 0.0D0
         IF (TIMSYS.EQ.'IAT') THEN
            CALL JULDAY (RDATE, JD)
            UTC = JD - 2400000.5
            CALL LPSEC (UTC, SECS, DATE)
            KEYVAD = SECS
            END IF
         CALL RCOPY (NWDPDP, KEYVAD, KEYVAR(IPOINT))
         IPOINT = IPOINT + NWDPDP
C                                       Time system
         KLOCS(12) = IPOINT
         KEYTYP(12) = 3
         CALL CHR2H (8, TIMSYS, 1, KEYVAL(IPOINT))
         IPOINT = IPOINT + 2
C                                       Array name
         KLOCS(13) = IPOINT
         KEYTYP(13) = 3
         CALL CHR2H (8, ANAME, 1, KEYVAL(IPOINT))
         IPOINT = IPOINT + 2
C                                       XYZ handedness
         KLOCS(14) = IPOINT
         KEYTYP(14) = 3
         CALL CHR2H (8, XYZHAN, 1, KEYVAL(IPOINT))
         IPOINT = IPOINT + 2
C                                       Terrestrial frame
         KLOCS(15) = IPOINT
         KEYTYP(15) = 3
         CALL CHR2H (8, TFRAME, 1, KEYVAL(IPOINT))
         IPOINT = IPOINT + 2
C                                       No. orbital parameters
         KLOCS(16) = IPOINT
         KEYTYP(16) = 4
         KEYVAL(IPOINT) = NUMORB
         IPOINT = IPOINT + 1
C                                       No. polarization cal. parms.
         KLOCS(17) = IPOINT
         KEYTYP(17) = 4
         KEYVAL(IPOINT) = NOPCAL
         IPOINT = IPOINT + 1
C                                       No. IFs
         KLOCS(18) = IPOINT
         KEYTYP(18) = 4
         KEYVAL(IPOINT) = ANTNIF
         IPOINT = IPOINT + 1
C                                       Freqid of AN values
         KLOCS(19) = IPOINT
         KEYTYP(19) = 4
         KEYVAL(IPOINT) = ANFQID
         IPOINT = IPOINT + 1
C                                       Real IAT-UTC
         CALL JULDAY (RDATE, JD)
         UTC = JD - 2400000.5
         CALL LPSEC (UTC, SECS, DATE)
         KLOCS(20) = IPOINT
         KEYTYP(20) = 1
         KEYVAD = SECS
         CALL RCOPY (NWDPDP, KEYVAD, KEYVAR(IPOINT))
         IPOINT = IPOINT + NWDPDP
C                                       Write if just created
         CALL TABKEY (OPCODE, KEYW, NKEY, BUFFER, KLOCS, KEYVAL,
     *      KEYTYP, IERR)
         NKEYRD = NKEY
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'ANINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         MSGSAV = MSGSUP
         MSGSUP = 32000
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         MSGSUP = MSGSAV
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'ANINI', IERR)
            GO TO 990
            END IF
C                                       Retrieve keyword values
C                                       Array center
         IPOINT = KLOCS(1)
         IF (KEYTYP(1).EQ.1) THEN
            CALL COPY (NWDPDP, KEYVAR(IPOINT), ARRAYC(1))
         ELSE
            ARRAYC(1) = KEYVAR(IPOINT)
            END IF
         IPOINT = KLOCS(2)
         IF (KEYTYP(2).EQ.1) THEN
            CALL COPY (NWDPDP, KEYVAR(IPOINT), ARRAYC(2))
         ELSE
            ARRAYC(2) = KEYVAR(IPOINT)
            END IF
         IPOINT = KLOCS(3)
         IF (KEYTYP(3).EQ.1) THEN
            CALL COPY (NWDPDP, KEYVAR(IPOINT), ARRAYC(3))
         ELSE
            ARRAYC(3) = KEYVAR(IPOINT)
            END IF
C                                       GST at IAT=0
         IPOINT = KLOCS(4)
         IF (KEYTYP(4).EQ.1) THEN
            CALL COPY (NWDPDP, KEYVAR(IPOINT), GSTIA0)
         ELSE
            GSTIA0 = KEYVAR(IPOINT)
            END IF
C                                       Earth rotation rate
         IPOINT = KLOCS(5)
         IF (KEYTYP(5).EQ.1) THEN
            CALL COPY (NWDPDP, KEYVAR(IPOINT), DEGPDY)
         ELSE
            DEGPDY = KEYVAR(IPOINT)
            END IF
C                                       Subarray frequency
         IPOINT = KLOCS(6)
         IF (KEYTYP(6).EQ.1) THEN
            CALL COPY (NWDPDP, KEYVAR(IPOINT), SAFREQ)
         ELSE
            SAFREQ = KEYVAR(IPOINT)
            END IF
C                                       Reference date
         IPOINT = KLOCS(7)
         CALL H2CHR (8, 1, KEYVAH(IPOINT), RDATE)
C                                       Polar x and y posn.
         IPOINT = KLOCS(8)
         IF (KEYTYP(8).EQ.1) THEN
            CALL COPY (NWDPDP, KEYVAR(IPOINT), KEYVAD)
            XYPOL(1) = KEYVAD
         ELSE
            XYPOL(1) = KEYVAR(IPOINT)
            END IF
         IPOINT = KLOCS(9)
         IF (KEYTYP(9).EQ.1) THEN
            CALL COPY (NWDPDP, KEYVAR(IPOINT), KEYVAD)
            XYPOL(2) = KEYVAD
         ELSE
            XYPOL(2) = KEYVAR(IPOINT)
            END IF
C                                       check for units being meters
         RADSQ = XYPOL(1)*XYPOL(1) + XYPOL(2)*XYPOL(2)
         IF (RADSQ.GT.0.36) THEN
            XYPOL(1) = XYPOL(1) / 30.922
            XYPOL(2) = XYPOL(2) / 30.922
            END IF
         POLRXY(1) = XYPOL(1)
         POLRXY(2) = XYPOL(2)
C                                       UT1 - UTC
         IPOINT = KLOCS(10)
         IF (KEYTYP(10).EQ.1) THEN
            CALL COPY (NWDPDP, KEYVAR(IPOINT), KEYVAD)
            UT1UTC = KEYVAD
         ELSE
            UT1UTC = KEYVAR(IPOINT)
            END IF
C                                       Time system.
         IF (KLOCS(12).GT.0) THEN
            CALL H2CHR (8, 1, KEYVAH(KLOCS(12)), TIMSYS)
C                                       Defaults to IAT
         ELSE
            TIMSYS = 'IAT'
            END IF
C                                       Time - UTC
         IF (KLOCS(11).GT.0) THEN
C                                       has 'DATUTC'
            IPOINT = KLOCS(11)
            IF (KEYTYP(11).EQ.1) THEN
               CALL COPY (NWDPDP, KEYVAR(IPOINT), KEYVAD)
               DATUTC = KEYVAD
            ELSE
               DATUTC = KEYVAR(IPOINT)
               END IF
C                                       has 'IATUTC'
         ELSE IF ((KLOCS(20).GT.0) .AND. (TIMSYS.NE.'UTC')) THEN
            IPOINT = KLOCS(20)
            IF (KEYTYP(20).EQ.1) THEN
               CALL COPY (NWDPDP, KEYVAR(IPOINT), KEYVAD)
               DATUTC = KEYVAD
            ELSE
               DATUTC = KEYVAR(IPOINT)
               END IF
C                                       no time correction to UTC
         ELSE
            DATUTC = 0.0
            END IF
C                                       Array name
         CALL H2CHR (8, 1, KEYVAH(KLOCS(13)), ANAME)
C                                       handedness
         IF (KLOCS(14).GT.0) THEN
            CALL H2CHR (8, 1, KEYVAH(KLOCS(14)), XYZHAN)
C                                       Defaults to IAT
         ELSE
            XYZHAN = '?????'
            END IF
C                                       Terrestrial frame
         IF (KLOCS(15).GT.0) THEN
            CALL H2CHR (8, 1, KEYVAH(KLOCS(15)), TFRAME)
C                                       Defaults to IAT
         ELSE
            TFRAME = '?????'
            END IF
C                                       No. orbital parameters
         NUMORB = KEYVAL(KLOCS(16))
C                                       No. polarization cal. parms.
         NOPCAL = KEYVAL(KLOCS(17))
C                                       Number IFs
         IF (KLOCS(18).GT.0) THEN
            ANTNIF = KEYVAL(KLOCS(18))
         ELSE
            ANTNIF = 0
            END IF
C                                       ANFQID
         IPOINT = KLOCS(19)
         IF (IPOINT.GT.0) THEN
            ANFQID = KEYVAL(IPOINT)
         ELSE
            ANFQID = -999
            END IF
         END IF
      IERR = 0
C                                       close to flush the buffers and
C                                       then reopen.
      CALL TABIO ('CLOS', 0, IPOINT, ITEMP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'ANINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'AN', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'ANINI', IERR)
         GO TO 990
         END IF
C                                       Get array indices
      CALL FNDCOL (MAXANC, TITLE, 24, .TRUE., BUFFER, ANKOLS, JERR)
C                                       Get array indices and no. values
      DO 150 I = 1,MAXANC
         IPOINT = ANKOLS(I)
         IF (IPOINT.GT.0) THEN
            ANKOLS(I) = DATP(IPOINT,1)
            ANNUMV(I) = DATP(IPOINT,2) / 10
            IF (ANNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               IF ((I.NE.3) .AND. (I.NE.11) .AND. (I.NE.14))
     *            CALL MSGWRT (6)
               END IF
         ELSE
            ANKOLS(I) = -1
            ANNUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            IF (TITLE(I).NE.'ORBPARM') CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) IERR, OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('ANINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('ANINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('ANINI: ERROR',I4,' INITIALIZING ANTENNA TABLE FOR ',A)
      END

      SUBROUTINE ZARGO2 (FCB, PNAME, IERR)
C----------------------------------------------------------------------
C! open ARGS TV device
C# Z2 IO-TV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Opens an ARGS TV device for non-map, single-buffer IO.  Put assigned
C   channel in the appropriate places in the FCB.
C   Inputs:
C      PNAME   C*48   Physical file name: device_name:???
C   Outputs:
C      FCB     I(*)   File control block (part of FTAB).
C      IERR    I      Error return. 0 = success. 1 = failure.
C                        2 = invalid device name.
C                        4 = in use
C   Generic version - stub
C----------------------------------------------------------------------
      INTEGER   FCB(*), IERR
      CHARACTER PNAME*48
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 2
      MSGTXT = 'ZARGO2 REQUIRES LOCAL DEVELOPMENT'
      CALL MSGWRT (9)
C
 999  RETURN
      END

      SUBROUTINE SNINI (OPCODE, BUFFER, DISK, CNO, VER, CATBLK, LUN,
     *   ISNRNO, SNKOLS, SNNUMV, NUMANT, NUMPOL, NUMIF, NUMNOD, GMMOD,
     *   RANOD, DECNOD, ISAPPL, IERR)
C-----------------------------------------------------------------------
C! Create/open/initialize solution (SN) tables.
C# EXT-util UV Calibration
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2000, 2006, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Creates and initializes solution (SN) extension tables.
C   REVISION 10
C   Inputs:
C     OPCODE       C*4 Operation code:
C                      'WRIT' = create/init for write or read
C                      'READ' = open for read only
C     BUFFER(512)  I   I/O buffer and related storage, also defines file
C                      if open.
C     DISK         I   Disk to use.
C     CNO          I   Catalog slot number
C     VER          I   SN file version
C     CATBLK(256)  I   Catalog header block.
C     LUN          I   Logical unit number to use
C   Input (create) / output (pre-existing)
C     NUMANT       I    Number of antennas
C     NUMPOL       I    Number of IFs per group
C     NUMIF        I    Number of IF groups
C     NUMNOD       I    Number of interpolation nodes. Will handle
C                       up to 25 interpolation nodes.
C     GMMOD        R    Mean gain modulus
C     RANOD(*)     R    RA offset of interpolation nodes (deg.)
C     DECNOD(*)    R    Dec. offset of interpolation nodes (deg.)
C     ISAPPL       L    True if this SN table has been applied to
C                       the  CL table.
C   Output:
C     ISNRNO       I   Next scan number, start of the file if 'READ',
C                      the last+1 if WRITE
C     SNKOLS(MAXSNC) I   The column pointer array in order defined by
C                        the parameters given in PSNTAB.INC.
C     SNNUMV(MAXSNC) I   Element count in each column.
C     IERR         I   Return error code, 0=>OK, else TABINI or TABIO
C                      error.
C-----------------------------------------------------------------------
      CHARACTER OPCODE*4
      INTEGER   BUFFER(512), DISK, CNO, VER, CATBLK(256), LUN, ISNRNO,
     *   SNKOLS(*), SNNUMV(*), NUMANT, NUMPOL, NUMIF, NUMNOD, IERR
      REAL      GMMOD, RANOD(25), DECNOD(25)
      LOGICAL   ISAPPL
C
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSNTAB.INC'
      CHARACTER KEYW(57)*8, TTITLE*56, TITLE(MAXSNC)*24, UNITS(MAXSNC)*8
      HOLLERITH HOLTMP(6)
      INTEGER   NKEY, NREC, DATP(128,2), NCOL
      REAL      KEYVAR(120)
      INTEGER   NTT, DTYP(MAXSNC), NDATA, KLOCS(57), KEYVAL(120), NC,
     *   KEYTYP(57), IPOINT, J, JNUM, I, JERR, REVNO, MSGSAV, ITRIM,
     *   ITEMP(6), IAPPL
      DOUBLE PRECISION KEYVAD
      LOGICAL   T, DOREAD, NEWFIL, LAPPL
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      EQUIVALENCE (KEYVAL, KEYVAR), (HOLTMP, ITEMP), (IAPPL, LAPPL)
      DATA T /.TRUE./
      DATA NTT /56/
      DATA TTITLE /'AIPS UV DATA FILE SOLUTION TABLE '/
C                                        Values larger than 10 are
C                                        scalars
      DATA DTYP /11,12,14,14,14,14,12,14,3*12,5*2,4,3*12,5*2,4/
C                                       NOTE: change PSNTAB.INC if the
C                                       columns are changed.
      DATA TITLE /'TIME                    ',
     *   'TIME INTERVAL          ',
     *   'SOURCE ID               ', 'ANTENNA NO.             ',
     *   'SUBARRAY                ', 'FREQ ID                 ',
     *   'I.FAR.ROT               ', 'NODE NO.                ',
     *   'MBDELAY1                ',
     *   'DISP 1                  ', 'DDISP 1                 ',
     *   'REAL1                   ', 'IMAG1                   ',
     *   'DELAY 1                 ', 'RATE 1                  ',
     *   'WEIGHT 1                ', 'REFANT 1                ',
     *   'MBDELAY2                ',
     *   'DISP 2                  ', 'DDISP 2                 ',
     *   'REAL2                   ', 'IMAG2                   ',
     *   'DELAY 2                 ', 'RATE 2                  ',
     *   'WEIGHT 2                ', 'REFANT 2                '/
      DATA KEYW /'NO_ANT  ', 'NO_POL  ', 'NO_IF   ',
     *   'NO_NODES', 'MGMOD   ', 'APPLIED ', 'REVISION',
     *   'RA_OFF1 ', 'DEC_OFF1', 'RA_OFF2 ', 'DEC_OFF2',
     *   'RA_OFF3 ', 'DEC_OFF3', 'RA_OFF4 ', 'DEC_OFF4',
     *   'RA_OFF5 ', 'DEC_OFF5', 'RA_OFF6 ', 'DEC_OFF6',
     *   'RA_OFF7 ', 'DEC_OFF7', 'RA_OFF8 ', 'DEC_OFF8',
     *   'RA_OFF9 ', 'DEC_OFF9', 'RA_OFF10', 'DEC_OF10',
     *   'RA_OFF11', 'DEC_OF11', 'RA_OFF12', 'DEC_OF12',
     *   'RA_OFF13', 'DEC_OF13', 'RA_OFF14', 'DEC_OF14',
     *   'RA_OFF15', 'DEC_OF15', 'RA_OFF16', 'DEC_OF16',
     *   'RA_OFF17', 'DEC_OF17', 'RA_OFF18', 'DEC_OF18',
     *   'RA_OFF19', 'DEC_OF19', 'RA_OFF20', 'DEC_OF20',
     *   'RA_OFF21', 'DEC_OF21', 'RA_OFF22', 'DEC_OF22',
     *   'RA_OFF23', 'DEC_OF23', 'RA_OFF24', 'DEC_OF24',
     *   'RA_OFF25', 'DEC_OF25'/
      DATA UNITS /'DAYS', 'DAYS', 4*' ', 'RAD/M**2',
     *    ' ', 'SECONDS', 'SEC/M**2', 'S/S/M**2', 2*' ', 'SECONDS ',
     *    'SEC/SEC', 2*' ', 'SECONDS', 'SEC/M**2', 'S/S/M**2',
     *    2*' ', 'SECONDS ', 'SEC/SEC', 2*' '/
C-----------------------------------------------------------------------
C                                       Check OPCODE
      DOREAD = OPCODE.EQ.'READ'
C                                       Open file
      NREC = 1000
      NCOL = 8 + NUMPOL * 9
      IF (DOREAD) NCOL = 0
      NKEY = 7 + NUMNOD * 2
      NDATA = MAXSNC
      CALL FILL (NDATA, 0, SNKOLS)
      CALL FILL (NDATA, 0, SNNUMV)
C                                       Fill in types
      IF (.NOT.DOREAD) THEN
         CALL COPY (NDATA, DTYP, DATP(1,2))
         DO 10 J = 1,NDATA
            IF (DTYP(J).LT.10) DATP(J,2) = DTYP(J) + 10 * NUMIF
 10         CONTINUE
         END IF
C                                       Create/open file
      CALL TABINI (OPCODE, 'SN', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'SNINI', IERR)
         GO TO 990
         END IF
      NEWFIL = IERR.LT.0
C                                       Get number of scans
      ISNRNO = BUFFER(5) + 1
      IF (DOREAD) ISNRNO = 1
      NKEY = 7 + NUMNOD * 2
C                                       File created, initialize
      IF (NEWFIL) THEN
C                                       Col. labels.
         DO 40 I = 1,NCOL
            CALL CHR2H (24, TITLE(I), 1, ITEMP)
            CALL TABIO ('WRIT', 3, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'SNINI', IERR)
               GO TO 990
               END IF
C                                       Units
            CALL CHR2H (8, UNITS(I), 1, ITEMP)
            CALL TABIO ('WRIT', 4, I, ITEMP, BUFFER, IERR)
            IF (IERR.GT.0) THEN
               CALL TABERR ('WRIT', 'TABIO', 'SNINI', IERR)
               GO TO 990
               END IF
 40         CONTINUE
C                                       Fill in Table title
         CALL CHR2H (NTT, TTITLE, 1, BUFFER(101))
C                                       Set keyword values
C                                       No. antennas.
         KLOCS(1) = 1
         KEYTYP(1) = 4
         KEYVAL(1) = NUMANT
C                                       No. polarizations
         KLOCS(2) = 2
         KEYTYP(2) = 4
         KEYVAL(2) = NUMPOL
C                                       No. IFs
         KLOCS(3) = 3
         KEYTYP(3) = 4
         KEYVAL(3) = NUMIF
C                                       No. interpolation nodes.
         KLOCS(4) = 4
         KEYTYP(4) = 4
         KEYVAL(4) = NUMNOD
C                                       Gain modulus
         KLOCS(5) = 5
         KEYTYP(5) = 1
         KEYVAD = GMMOD
         IPOINT = KLOCS(5)
         CALL DPCOPY (1, KEYVAD, KEYVAR(IPOINT))
         IPOINT = IPOINT + NWDPDP
C                                       APPLIED flag
         KLOCS(6) = IPOINT
         KEYTYP(6) = 5
         LAPPL = ISAPPL
         ITEMP(1) = IAPPL
         CALL COPY (1, ITEMP, KEYVAL(IPOINT))
         IPOINT = IPOINT + 1
C                                       Revision number from PSNTAB.INC
         REVNO = SNREV
         KLOCS(7) = IPOINT
         KEYTYP(7) = 4
         KEYVAL(IPOINT) = REVNO
         IPOINT = IPOINT + 1
C                                       Interpolation nodes
         IF (NUMNOD.GT.0) THEN
            JNUM = 8
            DO 50 J = 1,NUMNOD
               KLOCS(JNUM) = IPOINT
               KEYTYP(JNUM) = 1
               KEYVAD = RANOD(J)
               CALL DPCOPY (1, KEYVAD, KEYVAR(IPOINT))
               IPOINT = IPOINT + NWDPDP
               JNUM = JNUM + 1
               KLOCS(JNUM) = IPOINT
               KEYTYP(JNUM) = 1
               KEYVAD = DECNOD(J)
               CALL DPCOPY (1, KEYVAD, KEYVAR(IPOINT))
               IPOINT = IPOINT + NWDPDP
               JNUM = JNUM + 1
 50            CONTINUE
            END IF
C                                       Only write if just created.
         CALL TABKEY (OPCODE, KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('WRIT', 'TABKEY', 'SNINI', IERR)
            GO TO 990
            END IF
C                                       Read keywords
      ELSE
         MSGSAV = MSGSUP
         MSGSUP = 32000
         CALL TABKEY ('READ', KEYW, NKEY, BUFFER, KLOCS, KEYVAL, KEYTYP,
     *      IERR)
         MSGSUP = MSGSAV
         IF ((IERR.GE.1) .AND. (IERR.LE.20)) THEN
            CALL TABERR ('READ', 'TABKEY', 'SNINI', IERR)
            GO TO 990
            END IF
C                                       Retrieve keyword values
C                                       No. antennas.
         IPOINT = KLOCS(1)
         IF (IPOINT.GT.0) NUMANT = KEYVAL(IPOINT)
C                                       No. IFs per group.
         IPOINT = KLOCS(2)
         IF (IPOINT.GT.0) NUMPOL = KEYVAL(IPOINT)
C                                       No. IF groups.
         IPOINT = KLOCS(3)
         IF (IPOINT.GT.0) NUMIF = KEYVAL(IPOINT)
C                                       No. interpolation nodes.
         IPOINT = KLOCS(4)
         IF (IPOINT.GT.0) NUMNOD = KEYVAL(IPOINT)
C                                       Gain modulus
         IPOINT = KLOCS(5)
         IF (IPOINT.GT.0) THEN
            IF (KEYTYP(5).EQ.1) THEN
               CALL RCOPY (NWDPDP, KEYVAR(IPOINT), KEYVAD)
               GMMOD = KEYVAD
            ELSE
               GMMOD = KEYVAR(IPOINT)
               END IF
            END IF
C                                       APPLIED flag
         IPOINT = KLOCS(6)
         IF (IPOINT.GT.0) CALL COPY (1, KEYVAL(IPOINT), IAPPL)
         ISAPPL = LAPPL
C                                       Revision level
         IPOINT = KLOCS(7)
         REVNO = -1
         IF (IPOINT.GT.0) REVNO = KEYVAL(IPOINT)
C                                       Interpolation nodes
         IF (NUMNOD.GT.0) THEN
            JNUM = 8
            DO 100 J = 1,NUMNOD
               IPOINT = KLOCS(JNUM)
               IF (IPOINT.GT.0) THEN
                  IF (KEYTYP(JNUM).EQ.1) THEN
                     CALL RCOPY (NWDPDP, KEYVAR(IPOINT), KEYVAD)
                     RANOD(J) = KEYVAD
                  ELSE
                     RANOD(J) = KEYVAR(IPOINT)
                     END IF
                  END IF
               JNUM = JNUM + 1
               IPOINT = KLOCS(JNUM)
               IF (IPOINT.GT.0) THEN
                  IF (KEYTYP(JNUM).EQ.1) THEN
                     CALL RCOPY (NWDPDP, KEYVAR(IPOINT), KEYVAD)
                     DECNOD(J) = KEYVAD
                  ELSE
                     DECNOD(J) = KEYVAR(IPOINT)
                     END IF
                  END IF
               JNUM = JNUM + 1
 100           CONTINUE
            END IF
         END IF
C                                       Get array indices
C                                       Cover your ass from FNDCOL -
C                                       close to flush the buffers and
C                                       then reopen.
      CALL TABIO ('CLOS', 0, ISNRNO, KEYVAL, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR ('CLOS', 'TABIO', 'SNINI', IERR)
         GO TO 990
         END IF
      NKEY = 0
      CALL TABINI (OPCODE, 'SN', DISK, CNO, VER, CATBLK, LUN, NKEY,
     *   NREC, NCOL, DATP, BUFFER, IERR)
      IF (IERR.GT.0) THEN
         CALL TABERR (OPCODE, 'TABINI', 'SNINI', IERR)
         GO TO 990
         END IF
      NCOL = 8 + NUMPOL * 9
      CALL FNDCOL (NCOL, TITLE, 24, T, BUFFER, SNKOLS, JERR)
C                                       no message on DISP, DDISP
      DO 150 I = 1,NCOL
         IPOINT = SNKOLS(I)
         IF (IPOINT.GT.0) THEN
            SNKOLS(I) = DATP(IPOINT,1)
            SNNUMV(I) = DATP(IPOINT,2) / 10
            IF (SNNUMV(I).LE.0) THEN
               NC = ITRIM (TITLE(I))
               WRITE (MSGTXT,1100) TITLE(I)(:NC)
               IF ((I.NE.10) .AND. (I.NE.11) .AND. (I.NE.19). AND.
     *            (I.NE.20)) CALL MSGWRT (6)
               END IF
         ELSE
            SNKOLS(I) = -1
            SNNUMV(I) = 0
            NC = ITRIM (TITLE(I))
            WRITE (MSGTXT,1101) TITLE(I)(:NC)
            IF ((I.NE.10) .AND. (I.NE.11) .AND. (I.NE.19). AND.
     *         (I.NE.20)) CALL MSGWRT (6)
            END IF
 150     CONTINUE
      GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1990) OPCODE
      CALL MSGWRT (7)
C
 999  RETURN
C-----------------------------------------------------------------------
 1100 FORMAT ('SNINI: ''',A,''' COLUMN HAS NO VALUES')
 1101 FORMAT ('SNINI: ''',A,''' COLUMN NOT FOUND')
 1990 FORMAT ('SNINI: ERROR INITIALIZING SOLUTION TABLE FOR ',A4)
      END

      SUBROUTINE BMSHP (IN, IERR)
C-----------------------------------------------------------------------
C! Tim Cornwell routine to fit an elliptical Gaussian to a dirty beam
C# Modeling Map
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 1999, 2002, 2007, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   BMSHP fits an eliptical Gaussian to the dirty beam and checks that
C   the peak of the beam is 1.0.  If peak of beam is too narrow to fit a
C   default circular Gaussian is used.  A grid of up to 5 X 11 points is
C   used for the fit; only points within the half power points are used.
C   To avoid degenerate cases some of the allowed points are ignored.
C   Solution is by least squares to a linearized gaussian.
C   Input:  The beam map centered at (NX/2+1,NY/2+1)
C      IN      I   ?
C      CELLX   R   Grid spacing in RA (asec.)
C      CELLY   R   Grid spacing in Dec (asec.)
C   Output:
C      IERR    I   ?
C      BMAJ    R   Major axis size (FWHP in sec).
C      BMIN    R   Minor axis size (FWHP in sec).
C      BPA     R   Position angle of major axis (degrees).
C-----------------------------------------------------------------------
      INTEGER   WIN(4), IN, TRY, I, IFLIP, IJK, ILAST, LBIND, LFIND,
     *   IROW, J, K, L, LUN
      REAL      X(3,3), Y(3), P(3), DX, DY, XFACT, BABS, BDIF
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DTESS.INC'
      INCLUDE 'INCS:DTCIO.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
      MAP = .TRUE.
      EXCL = .FALSE.
      WAIT = .FALSE.
      TRY = 0
      IFLIP = 1
      XFACT = ABS (CELLX)
      LUN = 16
C                                       Open beam file.
      CALL ZOPEN (LUN, LFIND, VMVOL(IN), VMFILE(IN), MAP,
     *   EXCL, WAIT, IERR)
      IF (IERR.EQ.0) GO TO 10
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         GO TO 999
C                                       Zero work arrays.
 10   DO 20 I = 1,3
         Y(I) = 0.0
         DO 19 J = 1,3
            X(I,J) = 0.0
 19      CONTINUE
 20      CONTINUE
C                                       Set window,only need half map
      WIN(1) = NX / 2 - 5 + 1
      WIN(2) = NY / 2 + 1
      WIN(3) = NX / 2 + 5 + 1
      WIN(4) = NY / 2 + 5 + 1
      CALL MINIT ('READ', LUN, LFIND, NX, NY, WIN, BUFFR1, BUFSZ(1),
     *   VMBO(IN), IERR)
      IF (IERR.EQ.0) GO TO 30
         WRITE (MSGTXT,1020) IERR
         CALL MSGWRT (8)
         GO TO 999
C                                       Loop through rows.
 30   DO 70 I = 1,6
C                                       Read row.
         CALL MDISK ('READ', LUN, LFIND, BUFFR1, LBIND, IERR)
         IF (IERR.EQ.0) GO TO 40
            WRITE (MSGTXT,1030) IERR, I
            CALL MSGWRT (8)
            GO TO 999
C                                       Make sure center is 1.0
 40      IF (I.NE.1) GO TO 41
            BDIF = BUFFR1(LBIND+5) - 1.0
            BABS = ABS (BDIF)
            IF (BABS.GT.0.01) GO TO 980
 41      CONTINUE
C                                       Loop down row doing alternate
C                                       halves. go only to first
C                                       decending 0.35 from center.
         DO 65 IJK = 1,2
            IFLIP = - IFLIP
            ILAST = LBIND + 5 - IFLIP
            DO 60 J = IJK,6
               IROW = LBIND + 5 + (J-1) * IFLIP
               IF ((BUFFR1(IROW).LT.0.35) .AND. (BUFFR1(IROW).LT.
     *            BUFFR1(ILAST))) GO TO 65
               IF (BUFFR1(IROW).GE.0.35) THEN
                  ILAST = IROW
C                                       Compute displacements from
C                                       center.
                  DX = IFLIP * (J-1.0) * CELLX / XFACT
                  DY = (1.0-I) * CELLY / XFACT
C                                       Compute partials WRT C1,C2,C3
                  P(1) = DX * DX
                  P(2) = DY * DY
                  P(3) = DX * DY
C                                       Sum partials into X matrix and
C                                       Y vector.
                  DO 50 K = 1,3
                     Y(K) = Y(K) - LOG (BUFFR1(IROW)) * P(K)
                     DO 49 L = 1,3
                        X(K,L) = X(K,L) + P(K) * P(L)
 49                     CONTINUE
 50                  CONTINUE
                  END IF
 60            CONTINUE
 65         CONTINUE
 70      CONTINUE
C                                       Fit beam
      WRITE (MSGTXT,1070) BMAJ
      CALL MSGWRT (4)
      CALL FITBM (0, X, Y, CELLX, 0.0, BMAJ, BMIN, BPA)
C                                       Close beam file
      CALL ZCLOSE (LUN, LFIND, IERR)
      GO TO 999
C                                       Beam center not 1.000.
 980  WRITE (MSGTXT,1980) BUFFR1(LBIND+5)
      CALL MSGWRT (8)
      CALL ZCLOSE (LUN, LFIND, IERR)
      IERR = 8
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BMSHP: ERROR ',I3,' OPENING FILE ')
 1020 FORMAT ('BMSHP: ERROR ',I3,' INIT FILE ')
 1030 FORMAT ('BMSHP: READ ERROR ',I3,' ROW ',I5)
 1070 FORMAT ('BMAJ BEFORE FITBM  ', F10.1)
 1980 FORMAT ('BMSHP ERROR: CENTER OF BEAM = ',E12.5)
      END

      SUBROUTINE SOUFIL (IERR)
C-----------------------------------------------------------------------
C! Fills in arrays of source numbers to be included or excluded.
C# EXT-appl Calibration UV
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-1996, 1998, 2012-2013
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Fills in arrays of source numbers to be included or excluded.
C   Inputs from common /SELCAL/; also checks antennas to be selected.
C      SOURCS(30)   C*16 Names of up to 30 sources, *=>all
C                        First character of name '-' => all except those
C                        specified. (- no longer removed)
C      CALSOU(30)   C*16 Names of up to 30 calibrators,
C                        '*' or blank =>all, first character of name '-'
C                        => all except those specified. (- no longer
C                        removed)
C      SELQUA       I    Source qualifiers to be selected, -1=>any.
C                        Applied to both SOURCS and CALSOU.
C      SELCOD       C*4  Calibrator codes to select.
C                        '    '  => any,
C                        '*   ' => any non blank calibrator code.
C                        '-CAL' => blank only (no calibrators)
C                        anything else => matching CALcodes.
C                        Applied to SOURCS or CALSOU as controlled by
C                        DOAPPL
C      DOAPPL       L    If true then selection of the sources in
C                        CALSOU is conditioned on SELCOD else
C                        selection of SOURCS is conditioned on SELCOD.
C      ANTENS(50)   I    List of antennas selected, 0=>all,
C                        any negative => all except those specified
C                        (no longer made all positive)
C   Output:
C      IERR         I    Return code, 0=>OK, otherwise source file
C                        exists but cannot be read.
C                        1=TABIO problem, 2=no sources or calibrators
C   Output to common /SELCAL/:
C      NSOUWD       I    Number of sources included or excluded; if
C                        0 all sources are included.
C      DOSWNT       L    If .TRUE. then sources in SOUWAN are included
C                        If .FALSE. then excluded.
C      SOUWAN(30)   I    The source numbers of sources included or
C                        excluded.
C      SOUWTB(30)   I    The SoUrce table row numbers corresponding
C                        to SOUWAN.
C      NCALWD       I    Number of calibrators included or excluded.
C      DOCWNT       L    If .TRUE. then calibrators in CALWAN are
C                        included, if .FALSE. then excluded.
C      CALWAN(30)   I    The source numbers of calibrators included or
C                        excluded.
C      CALWTB(30)   I    The SoUrce table row numbers corresponding
C                        to CALWAN.
C      NANTSL       I    Number of antennas selected/excluded in ANTENS
C                        0 = All included.
C      DOAWNT       L    If .TRUE. then antennas in ANTENS included.
C                        If .FALSE. then excluded.
C   Note: also uses FGBUFF and UBUFF from /SELCAL/
C-----------------------------------------------------------------------
      INTEGER   IERR
C
      INCLUDE 'INCS:PUVD.INC'
      CHARACTER VELTYP*8, VELDEF*8, SOUNAM*16, CALCOD*4
      INTEGER   DATP(128,2), JERR, IBUFF(512), IDSOU, SUKOLS(MAXSUC), J,
     *   K, SUNUMV(MAXSUC), QUAL, INOGRP, NSOU, NCAL, NSOURC, I, ISURNO,
     *   I1, BADCNT, YSTBSZ, SUFQID
      LOGICAL   T, F, TABLE, EXIST, FITASC, ALLSOU, ALLCAL, DOCALC,
     *   DOQUAL, ANYCC, NOCAL, TAOPEN, NMONLY
      DOUBLE PRECISION    BANDW, RAEPO, DECEPO, EPOCH, RAAPP, DECAPP,
     *   PMRA, PMDEC, RAOBS, DECOBS
      REAL      FLUX(4,MAXIF)
      DOUBLE PRECISION    LSRVEL(MAXIF), FREQO(MAXIF), RESTFQ(MAXIF)
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DSEL.INC'
      EQUIVALENCE (DATP, UBUFF)
      DATA T, F /.TRUE.,.FALSE./
      DATA YSTBSZ /XSTBSZ/
C-----------------------------------------------------------------------
C                                       Setup for CALCODE and qualifier
C                                       selection.
      IERR = 0
      DOSWNT = T
      DOCWNT = T
      NSOUWD = 0
      NCALWD = 0
      TAOPEN = .FALSE.
C                                       See if SU file exists.
      CALL ISTAB ('SU', IUDISK, IUCNO, 1, IXLUN, IBUFF, TABLE, EXIST,
     *   FITASC, JERR)
      IF ((.NOT.EXIST) .AND. (JERR.EQ.0)) GO TO 900
      IF ((.NOT.EXIST) .OR. (.NOT.TABLE) .OR. (JERR.NE.0)) THEN
         IERR = 1
         IF (.NOT.EXIST) THEN
            WRITE (MSGTXT,1000) JERR
         ELSE IF (TABLE) THEN
            WRITE (MSGTXT,1001) JERR
         ELSE
            MSGTXT = 'SU FILE DAMAGED - NO LONGER A TABLE'
            END IF
         GO TO 980
         END IF
C                                       Open SU table
      CALL SOUINI ('READ', IBUFF, IUDISK, IUCNO, 1, CATUV, IXLUN,
     *   INOGRP, VELTYP, VELDEF, SUFQID, ISURNO, SUKOLS, SUNUMV,
     *   JERR)
      IF (JERR.NE.0) THEN
         IERR = 1
         WRITE (MSGTXT,1000) JERR
         GO TO 980
         END IF
C                                       Get number of sources.
 20   NSOURC = IBUFF(5)
      TAOPEN = .TRUE.
C                                       Check if empty
      IF (NSOURC.LE.0) GO TO 900
      ALLSOU = F
      ALLCAL = F
      NSOU = 0
      NCAL = 0
C                                       adverb parameters
      DOQUAL = SELQUA.NE.-1
      ANYCC = SELCOD.EQ.'*   '
      DOCALC = (SELCOD.NE.'    ') .AND.
     *   ((SELCOD.NE.'*   ') .AND. (SELCOD.NE.'-CAL'))
      NOCAL = SELCOD.EQ.'-CAL'
      NMONLY = .NOT.DOQUAL
      IF (.NOT.DOAPPL) NMONLY = (.NOT.DOQUAL) .AND. (SELCOD.EQ.' ')
C                                       Check if source/calib excluded
C                                       or if all are included
      DO 30 J = 1,30
C                                       Sources
         ALLSOU = ALLSOU .OR. (SOURCS(J)(1:1).EQ.'*')
C                                       Find number of sources
         IF (SOURCS(J).NE.' ') NSOU = J
         IF (SOURCS(J)(1:1).EQ.'-') DOSWNT = F
C                                       Calibrator
         ALLCAL = ALLCAL .OR. (CALSOU(J)(1:1).EQ.'*')
C                                       Find number of calibrators
         IF (CALSOU(J).NE.' ') NCAL = J
         IF (CALSOU(J)(1:1).EQ.'-') DOCWNT = F
 30      CONTINUE
C                                       Make sure need to look at table
      ALLSOU = ALLSOU .OR. (NSOU.LE.0)
      ALLCAL = ALLCAL .OR. (NCAL.LE.0)
      IF ((ALLSOU.AND.ALLCAL) .AND.
     *   (.NOT.(DOCALC.OR.ANYCC.OR.NOCAL.OR.DOQUAL))) GO TO 900
      IF (NSOU.LE.1) NSOU = 1
      IF (NCAL.LE.1) NCAL = 1
      BADCNT = 0
C                                       Sources
       IF (ALLSOU .AND.
     *   ((.NOT.((.NOT.DOAPPL).AND.(DOCALC.OR.ANYCC.OR.NOCAL)))
     *   .AND. (.NOT.DOQUAL))) GO TO 110
C                                       Loop through records
      DO 100 I = 1,NSOURC
C                                       Read record
         CALL TABSOU ('READ', IBUFF, ISURNO, SUKOLS, SUNUMV,
     *      IDSOU, SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO,
     *      DECEPO, EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ,
     *      PMRA, PMDEC, JERR)
C                                       Check error
         IF (JERR.NE.0) THEN
            IERR = 1
            WRITE (MSGTXT,1001) JERR
            GO TO 980
            END IF
C                                       Search lists
         DO 80 J = 1,NSOU
C                                       Check qualifier
            IF ((DOQUAL) .AND. (QUAL.NE.SELQUA)) GO TO 80
C                                       Check CALCODE
            IF (.NOT.DOAPPL) THEN
               IF ((ANYCC)  .AND. (CALCOD.EQ.' ')) GO TO 80
               IF ((NOCAL)  .AND. (CALCOD.NE.' ')) GO TO 80
               IF ((DOCALC) .AND. (CALCOD.NE.SELCOD)) GO TO 80
               END IF
C                                       Source list
            IF (.NOT.ALLSOU) THEN
               I1 = 1
               IF (SOURCS(J)(1:1).EQ.'-') I1 = 2
               IF (SOURCS(J)(I1:).NE.SOUNAM) THEN
                  IF (DOSWNT .OR. NMONLY) GO TO 80
               ELSE
                  IF (.NOT.(DOSWNT .OR. NMONLY)) GO TO 80
                  END IF
               END IF
C                                       Redundancy check
            IF (NSOUWD.GE.1) THEN
               DO 40 K = 1,NSOUWD
                  IF (SOUWAN(K).EQ.IDSOU) GO TO 80
 40               CONTINUE
               END IF
C                                       Add source
            IF (NSOUWD.LT.YSTBSZ) THEN
               NSOUWD = NSOUWD + 1
               SOUWAN(NSOUWD) = IDSOU
               IF (NSOUWD.LE.30) SOUWTN(NSOUWD) = ISURNO
C                                       Overflowed array
            ELSE
               BADCNT = BADCNT + 1
               END IF
 80         CONTINUE
 100     CONTINUE
      IF (BADCNT.GT.0) THEN
         WRITE (MSGTXT,1100) BADCNT, YSTBSZ
         CALL MSGWRT (6)
         END IF
      IF (.NOT.NMONLY) DOSWNT = .TRUE.
C                                       No sources found
      IF (NSOUWD.LE.0) THEN
         IERR = 2
         WRITE (MSGTXT,1101)
         GO TO 980
         END IF
C                                       Calibrator sources
 110  BADCNT = 0
      IF (ALLCAL .AND. ((.NOT.(DOAPPL.AND.(DOCALC.OR.ANYCC.OR.NOCAL)))
     *   .AND. (.NOT.DOQUAL))) GO TO 900
      NMONLY = .NOT.DOQUAL
      IF (DOAPPL) NMONLY = (.NOT.DOQUAL) .AND. (SELCOD.EQ.' ')
C                                       Loop through records
      ISURNO = 1
      DO 200 I = 1,NSOURC
C                                       Read record
         CALL TABSOU ('READ', IBUFF, ISURNO, SUKOLS, SUNUMV,
     *      IDSOU, SOUNAM, QUAL, CALCOD, FLUX, FREQO, BANDW, RAEPO,
     *      DECEPO, EPOCH, RAAPP, DECAPP, RAOBS, DECOBS, LSRVEL, RESTFQ,
     *      PMRA, PMDEC, JERR)
C                                       Check error
         IF (JERR.NE.0) THEN
            IERR = 1
            WRITE (MSGTXT,1001) JERR
            GO TO 980
            END IF
C                                       Calibrator list
C                                       Search lists
         DO 180 J = 1,NCAL
C                                       Check qualifier
            IF ((DOQUAL) .AND. (QUAL.NE.SELQUA)) GO TO 180
C                                       Check CALCODE
            IF (DOAPPL) THEN
               IF ((ANYCC)  .AND. (CALCOD.EQ.' ')) GO TO 180
               IF ((NOCAL)  .AND. (CALCOD.NE.' ')) GO TO 180
               IF ((DOCALC) .AND. (CALCOD.NE.SELCOD)) GO TO 180
               END IF
            I1 = 1
            IF (CALSOU(J)(1:1).EQ.'-') I1 = 2
            IF (.NOT.ALLCAL) THEN
               IF (CALSOU(J)(I1:).NE.SOUNAM) THEN
                  IF (DOCWNT .OR. NMONLY) GO TO 180
               ELSE
                  IF (.NOT.(DOCWNT .OR. NMONLY)) GO TO 180
                  END IF
               END IF
C                                       Redundancy check
            IF (NCALWD.GE.1) THEN
               DO 160 K = 1,NCALWD
                  IF (CALWAN(K).EQ.IDSOU) GO TO 180
 160              CONTINUE
               END IF
C                                       Add calibrator
            IF (NCALWD.LT.YSTBSZ) THEN
               NCALWD = NCALWD + 1
               CALWAN(NCALWD) = IDSOU
               IF (NCALWD.LE.30) CALWTN(NCALWD) = ISURNO
C                                       Overflowed array
            ELSE
               BADCNT = BADCNT + 1
               END IF
 180        CONTINUE
 200     CONTINUE
      IF (BADCNT.GT.0) THEN
         WRITE (MSGTXT,1200) BADCNT, YSTBSZ
         CALL MSGWRT (6)
         END IF
C                                       No calibrators found
      IF (NCALWD.LE.0) THEN
         IERR = 2
         WRITE (MSGTXT,1201)
         GO TO 980
         END IF
      IF (.NOT.NMONLY) DOCWNT = .TRUE.
      GO TO 900
C                                       No SOURCE file
C                                       Close file
 900  IF (TAOPEN) CALL TABIO ('CLOS', 0, I, UBUFF, IBUFF, JERR)
C                                       Check antennas desired.
      NANTSL = 0
      DOAWNT = T
      DO 930 J = 1,MAXANT
         IF (ANTENS(J).LT.0) DOAWNT = F
         IF (NANTSL.GE.1) THEN
            DO 910 K = 1,NANTSL
               IF (ABS(ANTENS(J)).EQ.ABS(ANTENS(K))) ANTENS(J) = 0
 910           CONTINUE
            END IF
C                                       Check for multiple entries
         IF (ABS(ANTENS(J)).GE.1) NANTSL = J
 930     CONTINUE
C                                       Make sure not too many
      IF (NANTSL.GT.MAXANT) NANTSL = MAXANT
      GO TO 999
C                                       Error
 980  CALL MSGWRT (8)
      IF (TAOPEN) CALL TABIO ('CLOS', 0, I, UBUFF, IBUFF, JERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('SOUFIL OR ISTAB: ERROR',I3,' OPENING SOURCE TABLE')
 1001 FORMAT ('SOUFIL/ISTAB: ERROR',I4,' READING SOURCE TABLE')
 1100 FORMAT ('SOUFIL: ',I5,' MORE SOURCES SELECTED THAN ',I6,
     *   ' ALLOWED')
 1101 FORMAT ('SOUFIL: ALL SOURCES REJECTED BY SELECTION CRITERIA')
 1200 FORMAT ('SOUFIL: ',I5,' MORE CALIBRATORS SELECTED THAN ',I6,
     *   ' ALLOWED')
 1201 FORMAT ('SOUFIL: ALL CALIBRATORS REJECTED BY SELECTION CRITERIA')
      END

      PROGRAM SURVEY
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Reads an ADR file and generates AIPS Site Survey forms for all
C   entries with the "CP" attribute. Actually, the output is the TEX
C   input to generate the forms. The "\h" lines are also recognized
C   and separate forms are generated for "\h1", "\h2", ..., with the
C   fields filled in from the keyword=value pairs in those lines.
C   DCW, NRAO-CV, 25Nov85 (based on program LABEL). mods08Jan87.
C        minor mods 10Dec87.
C   Corrected to not change ". " to ".~" on attribute lines because
C   it was connecting one keyword and it's info. with the next one,
C        12/88 by DCW and NDW.
C-----------------------------------------------------------------------
      IMPLICIT    NONE
      INTEGER     MXLINS, MXHIGH, MXWIDE, MXADDR, MXNET
      PARAMETER   (MXLINS=50, MXHIGH=99, MXWIDE=99, MXADDR=5, MXNET=3)
      INTEGER     L1, L2, L5, L6, ITRIM, J, I, KHIGH, KWIDE, KSKIP,
     *            K1, K2, L, KENTRY, K, MZIPBL, IHN, KE, KB, KK, NNET
      INTEGER     N1
      PARAMETER   (MZIPBL=4)
      CHARACTER   INP*30, FNAME*30, YN*1, BLASH*10, LOCAL*30,
     *            LINE*(MXWIDE), ADDR(MXHIGH)*(MXWIDE), CNTRY*30,
     *            ZIPBL*(MZIPBL), LIHN*4
      LOGICAL     RNO, LEOF, LLOCAL, LUPPER, LA, LHN, LHNONE, LAPREV
      DATA        LOCAL /'USA'/, ZIPBL /' '/
      DATA        N1 /1/
C-----------------------------------------------------------------------
      L1 = 1
      L2 = 2
      L5 = 5
      L6 = 6
C                                       Open input file:
 110  CONTINUE
      WRITE (L6, 1110)
      READ (L5, 1115, ERR=110) INP
      FNAME = INP(:ITRIM(INP)) // '.ADR'
      OPEN (UNIT=L1, FILE=FNAME, STATUS='OLD', ERR=117)
         WRITE (L6, 1116) FNAME
         GO TO 120
 117  CONTINUE
         WRITE (L6, 1117) FNAME
         GO TO 110
 120  CONTINUE
C                                       Open output file:
      FNAME = INP(:ITRIM(INP)) // '.TEX'
      WRITE (L6, 1150) FNAME
      OPEN (UNIT=L2, FILE=FNAME, STATUS='NEW',
     *      CARRIAGECONTROL='LIST')
C                                       initialize for TEX:
      WRITE (L2, 1180)
      KHIGH = MXHIGH
      KWIDE = MXWIDE
      KSKIP = 0
      BLASH = 'athn'
C-----------------------------------------------------------------------
      LEOF = .FALSE.
      KENTRY = 0
C                                       Read next label:
 310  CONTINUE
      IF (LEOF) GO TO 910
         DO 320 I = 1, MXHIGH
            ADDR(I) = ' '
 320        CONTINUE
         K1 = 0
         K2 = 0
         LLOCAL = .FALSE.
C                                       Read next line of label:
 330     CONTINUE
         IF (LEOF) GO TO 310
         READ (L1, 1330, END=340) LINE
            GO TO 350
 340     CONTINUE
            LINE = ' '
            LEOF = .TRUE.
 350     CONTINUE
C                                       Looping logic:
         IF ((LINE.EQ.' ').AND.(K1.EQ.0)) GO TO 330
         K1 = K1 + 1
         IF ((LINE.EQ.' ').AND.(K1.GT.0)) GO TO 410
C                                       Backslash logic:
         IF (LINE(1:1).NE.'\') GO TO 358
            IF (BLASH.EQ.' ') GO TO 330
            IF (LINE(2:2).NE.' ') GO TO 356
               WRITE (L6, 1354) LINE
               GO TO 330
 356        CONTINUE
            IF (BLASH.EQ.'\') GO TO 358
            IF (INDEX (BLASH, LINE(2:2)).EQ.0) GO TO 330
 358     CONTINUE
C                                       Logic to delete 'LOCAL' lines:
         IF (LINE.NE.LOCAL) GO TO 359
            IF (LLOCAL) WRITE (L6, 1359) LOCAL(:ITRIM (LOCAL)), K1
            LLOCAL = .TRUE.
            GO TO 330
 359     CONTINUE
C                                       Kluges for first name(s):
         IF (K1.NE.2) GO TO 380
            IF (LINE.EQ.'[null]') GO TO 360
               LINE = LINE(:ITRIM(LINE)) // ' ' // ADDR(1)
               GO TO 370
 360        CONTINUE
               LINE = ADDR(1)
 370        CONTINUE
 380     CONTINUE
C                                       Transformations for TEX:
         CALL TEXFIX (LINE, '  ', ' ')
         CALL TEXFIX (LINE, ' & ', '~&~')
         CALL TEXFIX (LINE, '~&~', '~|AMPER|~')
         CALL TEXFIX (LINE, '&', '|AMPER|~')
         CALL TEXFIX (LINE, '|AMPER|', '\&')
         CALL TEXFIX (LINE, '%', '\char37 ')
         IF (LINE(1:1).NE.'\') CALL TEXFIX (LINE, '. ', '.~')
         CALL TEXFIX (LINE, '_', '\_')
         CALL TEXFIX (LINE, '#', '\#')
         CALL TEXFIX (LINE, '<', '$<$')
         CALL TEXFIX (LINE, '>', '$>$')
C                                       Now add the line to ADDR():
C                                       (note special case for first)
C                                       (name line, K1.EQ.2)
         IF (K2.GE.MXHIGH) WRITE (L6, 1385) MXHIGH, LINE
         IF (K1.NE.2) K2 = MIN (K2 + N1, MXHIGH)
         ADDR(K2) = LINE
         IF (ITRIM (ADDR(K2)).GT.KWIDE) WRITE (L6, 1390)
     *            K2, KWIDE, LINE(:ITRIM(LINE))
         GO TO 330
C-----------------------------------------------------------------------
C                                       Now to write it all out for TEX:
 410  CONTINUE
C                                       Loop over possible machines:
      LHNONE = .FALSE.
      LAPREV = .FALSE.
      LA = .FALSE.
      DO 490 IHN = 1, 9
         WRITE (LIHN, '(''\h'', I1)') IHN
C                                       will this machine need a form?
         LHN = .FALSE.
         DO 420 I = 1, K2
            IF (ADDR(I)(1:3).EQ.LIHN) LHN = .TRUE.
            IF ((IHN.EQ.1).AND.(ADDR(I)(1:3).EQ.'\h ')) LHN = .TRUE.
            IF ((ADDR(I)(1:3).EQ.'\a ').AND.
     *            (INDEX (ADDR(I)(3:), ' CP ').NE.0)) LA = .TRUE.
 420        CONTINUE
         LHNONE = LHNONE.OR.LHN
         IF (.NOT.LA.AND..NOT.LHN) GO TO 490
         IF (LAPREV.AND..NOT.LHN) GO TO 490
         LAPREV = LAPREV.OR.LA
C                                       yes, it will!
 430     CONTINUE
         KENTRY = KENTRY + 1
         WRITE (L2, 1430) IHN
C                                       First, the address lines:
         J = 0
         DO 440 I = 1, K2
            IF (ADDR(I)(1:1).EQ.'\') GO TO 440
               J = J + 1
               IF (J.GT.(MXADDR+1)) WRITE (L6, 1435) (MXADDR+1), J,
     *                                       ADDR(I)(:ITRIM(ADDR(I)))
               WRITE (L2, 1440) 'ADDR', CHAR(ICHAR('A')-1+J),
     *                                 ADDR(I)(:ITRIM(ADDR(I)))
 440        CONTINUE
C                                       the telephone & network lines:
         NNET = 0
         DO 450 I = 1, K2
            IF (ADDR(I)(1:3).NE.'\t ') GO TO 443
               WRITE (L2, 1450) 'TEL', ADDR(I)(4:ITRIM(ADDR(I)))
               GO TO 450
 443        IF (ADDR(I)(1:3).NE.'\n ') GO TO 450
               NNET = NNET + 1
               IF (NNET.GT.MXNET) WRITE (L6, 1443) MXNET, NNET,
     *                                 ADDR(I)(:ITRIM(ADDR(I)))
               WRITE (L2, 1440) 'NET', CHAR(ICHAR('A')-1+NNET),
     *                                 ADDR(I)(4:ITRIM(ADDR(I)))
 450        CONTINUE
C                                       now for the hardware lines:
         DO 480 I = 1, K2
            IF (ADDR(I)(1:3).EQ.LIHN) GO TO 460
            IF ((IHN.EQ.1).AND.(ADDR(I)(1:3).EQ.'\h ')) GO TO 460
            IF ((IHN.EQ.1).AND.(ADDR(I)(1:4).EQ.'\h0 ')) GO TO 460
               GO TO 480
 460        CONTINUE
            J = 3
 465        CONTINUE
               J = J + 1
               IF (J.GT.MXWIDE) GO TO 480
               IF (ADDR(I)(J:J).EQ.' ') GO TO 465
C                                       non-blank field found:
               KB = INDEX (ADDR(I)(J:MXWIDE), ' ')
               KE = INDEX (ADDR(I)(J:J+KB-1), '=')
               IF ((KE.LT.2).OR.(KB.LT.(KE+1))) GO TO 475
C                                       write the field out:
               WRITE (L2, 1450) ADDR(I)(J:J+KE-2), ADDR(I)(J+KE:J+KB-2)
               J = J + KB - 1
               GO TO 465
 475        CONTINUE
               WRITE (L6, 1475) J, KE, KB, ADDR(I)(:ITRIM(ADDR(I)))
 480        CONTINUE
         WRITE (L2, 1490)
 490     CONTINUE
      IF ((LAPREV.AND..NOT.LHNONE).OR.(LHNONE.AND..NOT.LAPREV))
     *   WRITE (L6, 1420) LAPREV, LHNONE, ADDR(1)(:ITRIM(ADDR(1)))
      GO TO 310
C-----------------------------------------------------------------------
C                                       That's all, folks:
 910  CONTINUE
      CLOSE (UNIT=L1)
      WRITE (L2, 1905)
      CLOSE (UNIT=L2)
      WRITE (L6, 1910) KENTRY
C-----------------------------------------------------------------------
 1110 FORMAT (' Enter input address-list-file (w/o .ADR):', $)
 1115 FORMAT (A72)
 1116 FORMAT (' L1=', A)
 1117 FORMAT (' Cannot open file ', A)
 1130 FORMAT (' Do you want RNO output? (y/n):', $)
 1132 FORMAT (A1)
 1150 FORMAT (' L2=', A)
 1180 FORMAT ('\input aipswho:srvymac.tex', /, '\def\FINAL{T}')
 1330 FORMAT (A72)
 1354 FORMAT (' Poorly formatted backslash line:', /, 1X, A)
 1359 FORMAT (' Extra "', A, '" was seen at line', I3, ' of entry!')
 1385 FORMAT (' More than', I4, ' lines in an entry. Extra line:', /, A)
 1390 FORMAT (' Line', I3, ' of an entry is wider than', I3, ':', /,
     *         1X, A)
 1420 FORMAT (' CP/h mismatch for following entry: (CP=', L2, ', \h=',
     *         L2, ')', /, 1X, A)
 1430 FORMAT (/, '\clearform', /, '\def\IHN{', I1, '}')
 1435 FORMAT (' More than', I2, ' lines in address; J=', I2, ':',
     *         /, 1X, A)
 1440 FORMAT ('\def\', A, A1, '{', A, '}')
 1443 FORMAT (' More than', I2, ' network addresses; NNET=', I2, ':',
     *         /, 1X, A)
 1450 FORMAT ('\def\', A, '{', A, '}')
 1475 FORMAT (' Bad key=value field. J,KE,KB=', 3I5, /, 1X, A)
 1490 FORMAT ('\genform')
 1905 FORMAT (/, '\end')
 1910 FORMAT (' Number of forms generated =', I5)
      END
      INTEGER FUNCTION ITRIM (STRING)
C-----------------------------------------------------------------------
C   Function to determine length of a string. I.e., it trims trailing
C   blanks. Use with calls like:
C         TRIMMED = GROSS(1:ITRIM(GROSS))
C   DCW, NRAO-CV, 30Nov82.
C-----------------------------------------------------------------------
      IMPLICIT  NONE
      CHARACTER STRING*(*)
C
      ITRIM = LEN (STRING) + 1
 10   CONTINUE
         ITRIM = ITRIM - 1
         IF (ITRIM.LT.1) GO TO 999
         IF (STRING(ITRIM:ITRIM).EQ.' ') GO TO 10
 999  RETURN
      END
      SUBROUTINE TEXFIX (BIGSTR, OLD, NEW)
C-----------------------------------------------------------------------
C     TEXFIX substitutes string NEW for instances of substring OLD in
C     string BIGSTR.
C     DCW, NRAO-CV, 01Apr86,08Jan87.
C-----------------------------------------------------------------------
      CHARACTER   BIGSTR*(*), OLD*(*), NEW*(*)
      INTEGER     I, K
      INTEGER     ITRIM
      CHARACTER   TEMP*120
C
      I = 1
 10   K = INDEX (BIGSTR(I:ITRIM(BIGSTR)), OLD)
      IF (K.LE.0) GO TO 20
         TEMP = BIGSTR(1:I+K-2) // NEW // BIGSTR(I+K+LEN(OLD)-1:)
         BIGSTR = TEMP
         I = I + K + LEN(NEW) - 1
         GO TO 10
 20   RETURN
      END

      SUBROUTINE ZTPCLS (LUN, FIND, IERR)
C-----------------------------------------------------------------------
C! closes a tape device (real or pseudo-tape disk)
C# Tape
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2004
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   Close the tape drive associated with LUN as well as its disk control
C   file removing any exclusive use state and clear the corresponding
C   FTAB entries.  ZTPCL2 actually closes the tape drive and ZDACLS is
C   called to close the disk control file.  Also closes sequential type
C   disk files via ZTPCLD.
C   Inputs:
C      LUN    I   Logical unit number = 30 + DriveNumber for tape
C      FIND   I   Index in FTAB to file control block for LUN
C   Output:
C      IERR   I   Error return code: 0 => no error
C                    1 => close error
C                    2 => non-zero LSERCH error
C                    3 => both 1 and 2
C                    4 => invalid LUN
C   Generic version.
C-----------------------------------------------------------------------
      INTEGER   LUN, FIND, IERR
C
      INTEGER   FCBOFF, IMAP, JERR, KERR, MTLUN, MTIND, I, J
      LOGICAL   T, F, TAPE
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DZCH.INC'
      DATA T, F /.TRUE., .FALSE./
      DATA IMAP /0/
C-----------------------------------------------------------------------
C                                       Check inputs.
      TAPE = (LUN.LT.129) .AND. (LUN.GE.129-NTAPED)
      IERR = 4
C                                       Proper device type?
      MTLUN = LUN - NTAPED
      IF ((TAPE) .AND. (DEVTAB(LUN).EQ.2)) GO TO 20
      IF ((.NOT.TAPE) .AND. (DEVTAB(LUN).EQ.0)) GO TO 20
         WRITE (MSGTXT,1010) LUN, DEVTAB(LUN)
         CALL MSGWRT (7)
         GO TO 999
C                                       Locate LUN in FTAB.
 20   CALL LSERCH ('SRCH', LUN, FIND, T, JERR)
      IF (JERR.EQ.0) GO TO 30
         IERR = 2
         WRITE (MSGTXT,1020) JERR, 'SRCH', LUN
         CALL MSGWRT (7)
         GO TO 999
C                                       Close tape drive.
 30   IERR = 0
C                                       Calculate file control block
C                                       offset in FTAB.
      FCBOFF = FIND + MOFF
C                                       Close tapes
      IF (TAPE) THEN
C                                       Remote tape
         IF (TPNAME(129-LUN).NE.'LOCAL') THEN
            CALL ZTPCLR (LUN, FIND, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1030) IERR, 'REMOTE'
               CALL MSGWRT (7)
               END IF
C                                       Local tape
         ELSE
            CALL ZTPCL2 (FTAB(FCBOFF), IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1030) IERR, 'LOCAL'
               CALL MSGWRT (7)
               CALL ZERROR ('ZTPCL2', FTAB(FCBOFF+FCBERR), ' ',
     *            FTAB(FCBOFF), T)
               END IF
            END IF
C                                       Clear FTAB entry for LUN.
         CALL LSERCH ('CLOS', LUN, FIND, T, JERR)
         IF (JERR.NE.0) THEN
            IERR = IERR + 2
            WRITE (MSGTXT,1020) JERR, 'CLOS', LUN
            CALL MSGWRT (7)
            END IF
C                                       Close tape control disk file.
 50      JERR = 0
         CALL LSERCH ('CLOS', MTLUN, MTIND, F, KERR)
         IF (KERR.NE.0) THEN
            JERR = 2
            WRITE (MSGTXT,1050) KERR, 'CLOS', MTLUN
            CALL MSGWRT (7)
            GO TO 900
            END IF
C                                       Close file.
 60      FCBOFF = MTIND + NMOFF
         CALL ZDACLS (FTAB(FCBOFF), IMAP, KERR)
         IF (KERR.NE.0) THEN
            JERR = JERR + 1
            WRITE (MSGTXT,1060) KERR
            CALL MSGWRT (7)
            CALL ZERROR ('ZDACLS', FTAB(FCBOFF+FCBERR), ' ',
     *         FTAB(FCBOFF), F)
            END IF
C                                       close sequential disk files
      ELSE
         IF (TPDNAM.NE.'LOCAL') THEN
            CALL ZTPCLR (LUN, FIND, IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1030) IERR, 'REMOTE'
               CALL MSGWRT (7)
               END IF
            TPDNAM = ' '
         ELSE
            CALL ZTPCLD (LUN, FTAB(FCBOFF), IERR)
            IF (IERR.NE.0) THEN
               WRITE (MSGTXT,1100) IERR
               CALL MSGWRT (7)
               CALL ZERROR ('ZTPCLD', FTAB(FCBOFF+FCBERR), ' ',
     *            FTAB(FCBOFF), T)
               END IF
            END IF
C                                       Clear FTAB entry for LUN.
         CALL LSERCH ('CLOS', LUN, FIND, T, JERR)
         IF (JERR.NE.0) THEN
            IERR = IERR + 2
            WRITE (MSGTXT,1020) JERR, 'CLOS', LUN
            CALL MSGWRT (7)
            END IF
         END IF
C                                       Maximize error return.
 900  IERR = MAX (JERR, IERR)
C                                       clear name
      CALL FSERCH (FIND, I, J, JERR)
      IF (JERR.EQ.0) THEN
         IF (I.EQ.1) DEVNAM(J) = ' '
         IF (I.EQ.2) NONNAM(J) = ' '
         IF (I.EQ.3) MAPNAM(J) = ' '
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ZTPCLS: IMPROPER DEVICE TYPE DEVTAB(',I3,') = ',I1,
     *   'FOR TAPE I/O')
 1020 FORMAT ('ZTPCLS: LSERCH ERROR = ',I3,' ON ',A4,' FOR LUN = ',I3)
 1030 FORMAT ('ZTPCLS: ERROR = ',I3,' CLOSING ',A,' TAPE DEVICE')
 1050 FORMAT ('ZTPCLS: LSERCH ERROR = ',I3,' ON ',A4,' FOR MTLUN = ',I3)
 1060 FORMAT ('ZTPCLS: ZDACLS RETURNS ERROR = ',I3)
 1100 FORMAT ('ZTPCLS: ZTPCLD RETURNS ERROR = ',I3)
      END

      SUBROUTINE ZHEX10 (HVAL, IVAL, IERR)
C-----------------------------------------------------------------------
C! Compute the decimal equivalent of an extended hexadecimal (36) number
C# Z Math
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   ZHEX10 computes the decimal equivalent of an extended hexadecimal
C   (base 36) number.
C   Input:
C      HVAL   C*(*)   String containing hexadecimal value.  May contain
C                     leading or trailing blanks or tabs.
C   Outputs:
C      IVAL   I       Decimal equivalent of HVAL.
C      IERR   I       Error status, 0: success
C                        1: illegal hexadecimal digit
C   Notes: Treats lower case extended hexadecimal digits as equivalent
C   to upper case.
C-----------------------------------------------------------------------
      INTEGER   IERR, IVAL
      CHARACTER HVAL*(*)
C
      INTEGER   J, K, J1, J2
      CHARACTER HC*1, HEXC*36
      DATA HEXC /'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
C-----------------------------------------------------------------------
C                                       Initialize
      IERR = 0
      CALL TXTLEN (HVAL, J1, J2)
C                                       Process the hexadecimal digits
C                                       from left to right
      IVAL = 0
      DO 20 J = J1,J2
         IVAL = 36 * IVAL
         HC = HVAL(J:J)
         CALL CHLTOU (1, HC)
         K = INDEX (HEXC, HC)
C                                       Illegal character
         IF (K.LT.1) THEN
            IVAL = -1
            IERR = 1
            GO TO 999
         ELSE
            IVAL = IVAL + (K-1)
            END IF
 20      CONTINUE
C
 999  RETURN
      END

      SUBROUTINE COMCLR (COMAR, AMPMAX, N, IARRAY)
C-----------------------------------------------------------------------
C! Scale and map complex array intp RBG space, amp=inten. phase=hue.
C# Map Plot-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   Take a complex array, scale it, and map it into RGB space for
C   plotting as AMP = Intensity; PHASE -> Hue; SAT = 100%
C   Inputs: COMAR(N)      C          Input complex array
C           AMPMAX        R          Maximum amplitude in input array
C           N             I          # complex elements in COMAR
C           IARRAY(512,3) I          Output array , RGB colors
C-----------------------------------------------------------------------
      INTEGER   N, IARRAY(512,3)
      COMPLEX   COMAR(N)
      REAL      AMPMAX
      INTEGER   NM, I, ICOLOR
      REAL      COLX(3), COLY(3), COLZ(3), CABS, AMPINV, OFF, A, X, Y, Z
      INCLUDE 'INCS:DTVC.INC'
      DATA COLX / 2.580  , -1.090,  0.125 /,
     *     COLY /-1.150  ,  2.040, -0.295 /,
     *     COLZ /-0.422  ,  0.058,  1.170 /
C-----------------------------------------------------------------------
      NM = MIN (N, 512)
      AMPINV = 1. / (1.16 * AMPMAX)
      OFF = 0.16 / 1.16
      DO 20 I = 1,NM
         A = CABS(COMAR(I))
         Z = A * AMPINV + OFF
         Y = Z ** 3
         X = (Z + 0.2 * REAL(COMAR(I)) / A)
         Z = (Z - .5 * AIMAG(COMAR(I)) / A) ** 3
         DO 10 ICOLOR = 1,3
            Z = X * COLX(ICOLOR) + Y * COLY(ICOLOR) + Z * COLZ(ICOLOR)
            Z = MAX (0.0, MIN (1.0, Z))
            IARRAY(I, ICOLOR) = MAXINT * Z**2 + .01
 10         CONTINUE
 20      CONTINUE
C
 999  RETURN
      END

LOCAL INCLUDE 'CLVLB.INC'
C                                       Local include for CLVLB
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:ZPBUFSZ.INC'
      HOLLERITH XNAMEI(3), XCLAIN(2), XCALIN(12)
      REAL      XSIN, XDISIN, XFQID, XSUBA, XGAINV, XGAINU, XCUT,
     *   DOENNO, XBIF, XANT(50),
     *   SCRBUF(256), BUFF2(UVBFSS), CURTIM, FINC(MAXIF)
      INTEGER   SEQIN, DISKIN, JBUFSZ, OLDCNO, NANT, ICLVER, OCLVER,
     *   NIF, NPOL, CURSOU, SUBARR, FRQSEL, ISBAND(MAXIF), LSTSOU,
     *   DBGIF, DBGANT
      CHARACTER NAMEIN*12, CLAIN*6, CALIN*48
      DOUBLE PRECISION FOFF(MAXIF), RAPOBS, DAPOBS
      INTEGER   ICLBUF(512), OCLBUF(512), ICLRNO, OCLRNO,
     *   CLKOLS(MAXCLC), CLNUMV(MAXCLC)
      COMMON /INPARM/ XNAMEI, XCLAIN, XSIN, XDISIN, XFQID, XSUBA,
     *   XGAINV, XGAINU, XCUT, XCALIN, DOENNO, XBIF, XANT
      COMMON /CLVLBP/ RAPOBS, DAPOBS, FOFF, ICLBUF, OCLBUF, FINC,
     *   ISBAND, SEQIN, DISKIN, OLDCNO, CURTIM, NIF, NPOL, ICLVER,
     *   OCLVER, CURSOU, SUBARR, FRQSEL, CLKOLS, CLNUMV, ICLRNO, OCLRNO,
     *   NANT, LSTSOU, DBGIF, DBGANT
      COMMON /CHARPM/ NAMEIN, CLAIN, CALIN
      COMMON /BUFRS/ SCRBUF, BUFF2, JBUFSZ
C                                       antenna squint
C                                       SQAZ, SQEL radians
C                                       BMFREQ, EFFREQ MHz
C                                       EFFD meters
C                                       EFFRAT m/MHz
      DOUBLE PRECISION SQAZ(MAXANT), SQEL(MAXANT), BMFREQ(MAXANT),
     *   EFFD(MAXANT), EFFREQ(MAXANT), EFFRAT(MAXANT)
      COMMON /SQUINT/ SQAZ, SQEL, BMFREQ, EFFD, EFFREQ, EFFRAT
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
C                                       End local include for CLVLB
LOCAL END
      PROGRAM CLVLB
C-----------------------------------------------------------------------
C! correct VLBI CL tables for offset between the pointing and phase pos.
C# Utility UV Calibration VLBI
C-----------------------------------------------------------------------
C;  Copyright (C) 2013, 2015, 2022
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   CLVLB corrects a CL table amplitudes for the single-dish beam
C   pattern at the phase-stopping position
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INNAME         NAMEIN        Name of input UV data.
C      INCLASS        CLAIN         Class of input UV data.
C      INSEQ          SEQIN         Seq. of input UV data.
C      INDISK         DISKIN        Disk number of input VU data.
C      SUBARRAY       SUBARR        Subarray to do
C      FREQID         FRQSEL        FREQID to do
C      GAINVER        ICLVER        CL table version in
C      GAINUSE        OCLVER        CL table version out
C-----------------------------------------------------------------------
      CHARACTER PRGM*6
      INTEGER   IRET
      INCLUDE 'CLVLB.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      DATA PRGM /'CLVLB '/
C-----------------------------------------------------------------------
C                                       Get input parameters and
C                                       create output file if nec.
      CALL CLVLBI (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Call routine that sends data
C                                       to the user routine.
      CALL CLVLBD (IRET)
      IF (IRET.EQ.0) CALL CLVLBH
C                                       Close down files, etc.
 990  CALL DIE (IRET, SCRBUF)
C
 999  STOP
      END
      SUBROUTINE CLVLBI (PRGN, JERR)
C-----------------------------------------------------------------------
C   CLVLBI gets input parameters for CLVLB and creates an output file
C   if necessary.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      JERR    I    Error code: 0 => ok
C                                5 => catalog troubles
C                                8 => can't start
C   Commons: /INPARM/ all input adverbs in order given by INPUTS
C                     file
C            /MAPHDR/ output file catalog header
C-----------------------------------------------------------------------
      INTEGER   JERR
      CHARACTER PRGN*6
C
      INCLUDE 'CLVLB.INC'
      CHARACTER STAT*4, PTYPE*2, BNDCOD(MAXIF)*8
      INTEGER   IROUND, NPARM, IERR, J, LUN(3), KEY(2,2), IP, IIF,
     *   IANT, VER, KEYSUB(2,2), NTERM
      REAL      FKEY(2,2), GMMOD, NCH2
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA LUN /59,60,61/
      DATA FKEY /1.0,0.0, 1.0,0.0/
      DATA KEYSUB /4*1/
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      CALL SELINI
      CURTIM = -1.E5
      JBUFSZ = UVBFSS * 2
      LSTSOU = -999
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      JERR = 0
C                                       Get input parameters.
      NPARM = 76
      CALL GTPARM (PRGN, NPARM, RQUICK, XNAMEI, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         JERR = 8
         IF (IERR.EQ.1) GO TO 999
            WRITE (MSGTXT,1000) IERR, 'GETTING INPUT ADVERB VALUES'
            CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (JERR, SCRBUF, IERR)
      IF (JERR.NE.0) GO TO 999
      JERR = 5
C                                       Crunch input parameters.
      CALL H2CHR (12, 1, XNAMEI, NAMEIN)
      CALL H2CHR (6, 1, XCLAIN, CLAIN)
      CALL H2CHR (48, 1, XCALIN, CALIN)
      SEQIN = IROUND (XSIN)
      DISKIN = IROUND (XDISIN)
      SUBARR = IROUND (XSUBA)
      IF (SUBARR.LE.0) SUBARR = 1
      DBGIF = IROUND (XBIF)
      DBGANT = IROUND (XANT(1))
C                                       Get CATBLK from old file.
      OLDCNO = 1
      PTYPE = 'UV'
      CALL CATDIR ('SRCH', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1030) IERR, NAMEIN, CLAIN, SEQIN, DISKIN,
     *      NLUSER
         GO TO 990
         END IF
      CALL CATIO ('READ', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1040) IERR
         GO TO 990
         END IF
C                                       Get uv header info.
      CALL UVPGET (JERR)
      IF (JERR.NE.0) GO TO 999
C                                       number antennas
      CALL GETANT (DISKIN, OLDCNO, SUBARR, CATBLK, BUFF2, JERR)
      IF (JERR.NE.0) GO TO 999
      NANT = NSTNS
      NPOL = CATBLK(KINAX+JLOCS)
      NPOL = MIN (2, NPOL)
      NIF = 1
      IF (JLOCIF.GE.0) NIF = CATBLK(KINAX+JLOCIF)
      NCH2 = CATBLK(KINAX+JLOCF) / 2.0
C                                       CL
      ICLVER = IROUND (XGAINV)
      CALL FNDEXT ('CL', CATBLK, J)
      IF (J.LE.0) THEN
         MSGTXT = 'NO CL TABLES: I QUIT'
         JERR = 10
         GO TO 990
         END IF
      IF ((ICLVER.LE.0) .OR. (ICLVER.GT.J)) ICLVER = J
      OCLVER = IROUND (XGAINU)
      IF ((OCLVER.LE.0) .OR. (OCLVER.GT.J+1)) OCLVER = J + 1
C                                       Freq id
      FRQSEL = IROUND (XFQID)
      IF (FRQSEL.LE.0) FRQSEL = 1
C                                       get frequencies
      VER = 1
      CALL CHNDAT ('READ', ICLBUF, DISKIN, OLDCNO, VER, CATBLK, LUN,
     *   NIF, FOFF, ISBAND, FINC, BNDCOD, FRQSEL, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1000) JERR, 'FINDING FREQUENCIES'
         GO TO 990
         END IF
C                                       freqs at center channel
      DO 30 J = 1,NIF
         FOFF(J) = (FOFF(J) + CATD(KDCRV+JLOCF) +
     *      (NCH2 - CATR(KRCRP+JLOCF)) * FINC(J)) / 1.D6
 30      CONTINUE
C                                       get beam parameters
      CALL BMPARM (JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1000) JERR, 'FINDING BEAM PARAMETERS'
         GO TO 990
         END IF
C                                       open and sort CL table
      CALL CALINI ('READ', ICLBUF, DISKIN, OLDCNO, ICLVER, CATBLK,
     *   LUN(2), ICLRNO, CLKOLS, CLNUMV, IANT, IP, IIF, NTERM, GMMOD,
     *   JERR)
      IF (JERR.NE.0) GO TO 999
      KEY(1,2) = 4
      KEY(1,1) = 1
      IF ((ICLBUF(43).NE.KEY(1,1)) .OR. (ICLBUF(44).NE.KEY(1,2)))
     *   THEN
         CALL TABIO ('CLOS', 0, ICLRNO, ICLBUF, ICLBUF, JERR)
         CALL TABSRT (DISKIN, OLDCNO, 'CL', ICLVER, ICLVER, KEY,
     *      KEYSUB, FKEY, ICLBUF, CATBLK, JERR)
         IF (JERR.NE.0) GO TO 999
         CALL CALINI ('READ', ICLBUF, DISKIN, OLDCNO, ICLVER, CATBLK,
     *      LUN(2), ICLRNO, CLKOLS, CLNUMV, IANT, IP, IIF, NTERM, GMMOD,
     *      JERR)
         IF (JERR.NE.0) GO TO 999
         END IF
      IF ((IP.NE.NPOL) .OR. (IIF.NE.NIF)) THEN
         MSGTXT = 'CL TABLE NO MATCH FOR POL AND/OR IFS'
         JERR = 10
         GO TO 999
         END IF
C                                       create open new CL table
      CALL CALINI ('WRIT', OCLBUF, DISKIN, OLDCNO, OCLVER, CATBLK,
     *   LUN(1), OCLRNO, CLKOLS, CLNUMV, IANT, IP, IIF, NTERM, GMMOD,
     *   JERR)
      IF (JERR.NE.0) GO TO 999
C                                       Put input file in READ
      PTYPE = 'UV'
      STAT = 'WRIT'
      CALL CATDIR ('CSTA', DISKIN, OLDCNO, NAMEIN, CLAIN, SEQIN,
     *   PTYPE, NLUSER, STAT, SCRBUF, IERR)
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKIN
      FCNO(NCFILE) = OLDCNO
      FRW(NCFILE) = 1
      JERR = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLVLBI: ERROR',I3,' ON',A)
 1030 FORMAT ('ERROR',I3,' FINDING ',A12,'.',A6,'.',I4,' DISK=',
     *   I3,' USID=',I5)
 1040 FORMAT ('ERROR',I3,' COPYING CATBLK ')
      END
      SUBROUTINE BMPARM (IRET)
C-----------------------------------------------------------------------
C   BMPARM attempts to fill in the antenna squint parameters
C   Outputs:
C      IRET   I   > 0 error code
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'CLVLB.INC'
      CHARACTER VLBANM(30)*8, INLINE*132
      INTEGER   IA, I, LUN, FIND, JT, JTRIM, KBP, ISVLBA, DROUND
      DOUBLE PRECISION X, TEMP, DEFALT(6), VALS(6), VLBPRM(4)
      LOGICAL   WASDEF
      REAL      VLAZEL(2,10)
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DANS.INC'
      DATA VLBANM /'SC','VLBA_SC','SC-VLBA' ,'HN','VLBA_HN','HN-VLBA',
     *   'NL','VLBA_NL','NL-VLBA', 'FD','VLBA_FD','FD-VLBA',
     *   'LA','VLBA_LA','LA-VLBA', 'PT','VLBA_PT','PT-VLBA',
     *   'KP','VLBA_KP','KP-VLBA', 'OV','VLBA_OV','OV-VLBA',
     *   'BR','VLBA_BR','BR-VLBA', 'MK','VLBA_MK','MK-VLBA'/
      DATA VLBPRM /1438.D0, 24.926527565D0, 1500.D0, -1.64665969D-3 /
C      DATA VLBPRM /1438.D0, 24.8276714D0, 1500.D0, 0.0D0 /
      DATA VLAZEL /-1.53, -0.56, -1.35, -0.67,
     *   -1.56, -0.62, -1.56, -0.58,
     *   -1.62, -0.67, -1.59, -0.63,
     *   -1.61, -0.59, -1.76, -0.95,
     *   -1.44, -0.50, -1.56, -0.60/
C-----------------------------------------------------------------------
C                                       what did we get from AN file
      CALL DFILL (6*MAXANT, 0.0D0, SQAZ)
      DO 20 IA = 1,NSTNS
         IF ((ANFWHM(1,IA).GT.0.0) .AND. (ANFWHM(1,IA).NE.FBLANK)) THEN
            EFFD(IA) = 4.43 * 180.0 / PI / PI / ANFWHM(1,IA)
            EFFREQ(IA) = FOFF(1)
            IF ((ANFWHM(NIF,IA).GT.0) .AND. (ANFWHM(NIF,IA).NE.FBLANK))
     *         THEN
               TEMP =  4.43 * 180.0 / PI / PI / ANFWHM(NIF,IA)
               EFFRAT(IA) = (TEMP - EFFD(IA)) / (FOFF(NIF) - FOFF(1))
               END IF
            END IF
C                                       is it a VLBA antenna?
         ISVLBA = 0
         DO 10 I = 1,30
            IF (STNNAM(IA).EQ.VLBANM(I)) ISVLBA = (I+2)/3
 10         CONTINUE
C                                       VLBA antennas
C                                       note these are for L band!
         IF (ISVLBA.GT.0) THEN
            SQAZ(IA) = VLAZEL(1,ISVLBA) * PI / 180.0 / 60.0
            SQEL(IA) = VLAZEL(2,ISVLBA) * PI / 180.0 / 60.0
            BMFREQ(IA) = VLBPRM(1)
            IF (EFFD(IA).EQ.0.0) THEN
               EFFD(IA) =  VLBPRM(2)
               EFFREQ(IA) = VLBPRM(3)
               EFFRAT(IA) = VLBPRM(4)
               END IF
            END IF
 20      CONTINUE
C                                       user text file now
      IF (CALIN.NE.' ') THEN
         LUN = 3
         CALL ZTXOPN ('READ', LUN, FIND, CALIN, .FALSE., IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'OPEN TEXT FILE'
            GO TO 990
            END IF
         WASDEF = .FALSE.
 100     CALL ZTXIO ('READ', LUN, FIND, INLINE, IRET)
         IF (IRET.EQ.0) THEN
            JT = JTRIM (INLINE)
            IF ((INLINE(1:1).EQ.'!') .OR. (INLINE(1:1).EQ.'#'))
     *         GO TO 100
            KBP = 1
            CALL GETNUM (INLINE, JT, KBP, X)
            IF (X.EQ.DBLANK) GO TO 980
            IA = DROUND (X)
            IF ((IA.LT.0) .OR. (IA.GT.NSTNS)) THEN
               WRITE (MSGTXT,1100) IA
               CALL MSGWRT (7)
               GO TO 100
               END IF
            DO 110 I = 1,6
               CALL GETNUM (INLINE, JT, KBP, X)
               IF (X.EQ.DBLANK) GO TO 980
               VALS(I) = X
 110           CONTINUE
            IF (IA.EQ.0) THEN
               WASDEF = .TRUE.
               CALL RCOPY (6, VALS, DEFALT)
               DEFALT(1) = DEFALT(1) * PI / 180.0 / 60.0
               DEFALT(2) = DEFALT(2) * PI / 180.0 / 60.0
            ELSE
               SQAZ(IA) = VALS(1) * PI / 180.0 / 60.0
               SQEL(IA) = VALS(2) * PI / 180.0 / 60.0
               BMFREQ(IA) = VALS(3)
               EFFD(IA) = VALS(4)
               EFFREQ(IA) = VALS(5)
               EFFRAT(IA) = VALS(6)
               END IF
            GO TO 100
         ELSE IF (IRET.NE.2) THEN
            WRITE (MSGTXT,1000) IRET, 'READ TEXT FILE'
            GO TO 990
         ELSE
            IRET = 0
            END IF
         CALL ZTXCLS (LUN, FIND, I)
C                                       fill in default
         IF (WASDEF) THEN
            DO 120 IA = 1,NSTNS
               IF ((SQAZ(IA).EQ.0.0) .AND. (SQEL(IA).EQ.0.0) .AND.
     *            (BMFREQ(IA).EQ.0.0) .AND. (EFFD(IA).EQ.0.0) .AND.
     *            (EFFREQ(IA).EQ.0.0) .AND. (EFFRAT(IA).EQ.0.0)) THEN
                  SQAZ(IA) = DEFALT(1)
                  SQEL(IA) = DEFALT(2)
                  BMFREQ(IA) = DEFALT(3)
                  EFFD(IA) = DEFALT(4)
                  EFFREQ(IA) = DEFALT(5)
                  EFFRAT(IA) = DEFALT(6)
                  END IF
 120           CONTINUE
            END IF
         END IF
      GO TO 999
C
 980  IRET = 10
      MSGTXT = 'ILLEGAL VALUE IN TEXT FILE INPUT'
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('BMPARM: ERROR',I4,' ON ',A)
 1100 FORMAT ('BMPARM IGNORING BAD ANTENNA NUMBER =',I10)
      END
      SUBROUTINE CLVLBD (IRET)
C-----------------------------------------------------------------------
C   CLVLBD reads through the CL table and calls the correction routines
C   Outputs:
C      IRET   I   > 0 => failure
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'CLVLB.INC'
      INTEGER   IREC, SOURID, ANTNO, SUBA, FREQID, I, REFA(2,MAXIF),
     *   LUN, LUNTMP, LSTBAD, CLMAX, DIR, NBAD
      REAL      TIMEI, IFR, DOPOFF(MAXIF), ATMOS(2), DATMOS(2),
     *   MBDELY(2), CLOCK(2), DCLOCK(2), DISP(2), DDISP(2),
     *   CREAL(2,MAXIF), CIMAG(2,MAXIF), DELAY(2,MAXIF), RATE(2,MAXIF),
     *   WEIGHT(2,MAXIF), POLAR(2)
      DOUBLE PRECISION DELDAT, TIME, GEODLY(10), JD, OBSPOS(3)
      LOGICAL   GR
      CHARACTER OBSDAT*8
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:PSTD.INC'
      SAVE LSTBAD
      DATA LSTBAD /0/
      DATA DELDAT, OBSPOS, POLAR /1.D-6, 0.D0, 0.D0, 0.D0, 0., 0./
C-----------------------------------------------------------------------
      CLMAX = ICLBUF(5)
      NBAD = 0
      DO 100 IREC = 1,CLMAX
         ICLRNO = IREC
         CALL TABCAL ('READ', ICLBUF, ICLRNO, CLKOLS, CLNUMV, NPOL,
     *      NIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'READING OLD CL TABLE'
            GO TO 990
            END IF
C                                       match ?
         IF ((SUBARR.GT.0) .AND. (SUBA.GT.0) .AND. (SUBARR.NE.SUBA))
     *      GO TO 100
         IF ((FRQSEL.GT.0) .AND. (FREQID.GT.0) .AND. (FRQSEL.NE.FREQID))
     *      GO TO 100
C                                       source
         CURSOU = SOURID
         IF (CURSOU.NE.LSTSOU) THEN
            LUN = LUNTMP (1)
            CALL GETSOU (CURSOU, DISKIN, OLDCNO, CATBLK, LUN, IRET)
            IF (IRET.EQ.11) THEN
               WRITE (MSGTXT,1010) CURSOU
               IF (CURSOU.NE.LSTBAD) CALL MSGWRT (6)
               LSTBAD = CURSOU
               GO TO 100
            ELSE
               LSTSOU = CURSOU
C                                       Find time of observation
               CALL H2CHR (8, 1, CATH(KHDOB), OBSDAT)
C                                       Find Julian day, JD
               CALL JULDAY (OBSDAT, JD)
               EPOCH = CATR(KREPO)
C                                       Do not trust apparent coords
C                                       recompute for pointing
               GR = .TRUE.
               DIR = 1
               CALL JPRECS (JD, EPOCH, DELDAT, DIR, GR, OBSPOS, POLAR,
     *            RAOBS, DECOBS, RAPOBS, DAPOBS)
               END IF
            END IF
C                                       let's do it
         CALL DOWORK (TIME, ANTNO, CREAL, CIMAG, IRET)
         IF (IRET.NE.0) NBAD = NBAD + 1
C                                       write it
         CALL TABCAL ('WRIT', OCLBUF, OCLRNO, CLKOLS, CLNUMV, NPOL,
     *      NIF, TIME, TIMEI, SOURID, ANTNO, SUBA, FREQID, IFR,
     *      GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY, CLOCK, DCLOCK, DISP,
     *      DDISP, CREAL, CIMAG, DELAY, RATE, WEIGHT, REFA, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'WRITING NEW CL TABLE'
            GO TO 990
            END IF
 100     CONTINUE
      CALL TABIO ('CLOS', 0, OCLRNO, OCLBUF, OCLBUF, I)
      CALL TABIO ('CLOS', 0, ICLRNO, ICLBUF, ICLBUF, I)
      WRITE (MSGTXT,1100) NBAD, CLMAX
      CALL MSGWRT (5)
      GO TO 999
C
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLVLBD: ERROR',I4,' ON ',A)
 1010 FORMAT ('CLVLBD: SOURCE ID',I8,' NOT RECOGNIZED')
 1100 FORMAT ('CLVLBD:',I8,' RECORDS BELOW HORIZON OF',I8)
      END
      SUBROUTINE DOWORK (TIME, ANTNO, CREAL, CIMAG, IRET)
C-----------------------------------------------------------------------
C   Determines the corrections and applies them
C   Inputs:
C      TIME    D        sample time
C      ANTNO   I        antenna number
C   In/out:
C      CREAL   R(2,*)   real part of gain
C      CIMAG   R(2,*)   imag part of gain
C   Outputs:
C      IRET    I        error code: 1 => all blanked (below horizon)
C-----------------------------------------------------------------------
      DOUBLE PRECISION TIME
      INTEGER   ANTNO, IRET
      REAL      CREAL(2,*), CIMAG(2,*)
C
      INCLUDE 'CLVLB.INC'
      INTEGER   LF, PRTS(MAXANT)
      DOUBLE PRECISION PEL, PAZ, TEL, TAZ, LAMBDA, DAZ, DEL, REL, RAZ,
     *   LAZ, LEL, RSEP, LSEP, D, RFAC, LFAC, ANGSEP, BEAM, R, THETA,
     *   SEPAZ, SEPEL, HAVSIN, AZBEAR
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      SAVE PRTS
      DATA PRTS /MAXANT*0/
C-----------------------------------------------------------------------
C                                       get two positions in az/el
      CALL ELVS (ANTNO, TIME, RAPOBS, DAPOBS, PEL, PAZ, TEL, TAZ)
C                                       below horizon
      IF ((PEL.LE.0.0D0) .OR. (TEL.LE.0.0D0)) THEN
         IRET = 1
         LF = 2 * NIF
         CALL RFILL (LF, FBLANK, CREAL)
         CALL RFILL (LF, FBLANK, CIMAG)
C                                       observable
      ELSE
         DO 100 LF = 1,NIF
            LAMBDA = VELITE / (1.D6 * FOFF(LF))
            DAZ = SQAZ(ANTNO) * (BMFREQ(ANTNO) / FOFF(LF))
            DEL = SQEL(ANTNO) * (BMFREQ(ANTNO) / FOFF(LF))
C                                       Eric method:
C                                       add delta EL/AZ to pointing
C                                       position, get separations,
C                                       original signs
            IF (DOENNO.LE.0.0) THEN
               REL = PEL - DEL / 2.0D0
               LEL = PEL + DEL / 2.0D0
               RAZ = PAZ - DAZ / 2.0D0
               LAZ = PAZ + DAZ / 2.0D0
               RSEP = ANGSEP (TEL, TAZ, REL, RAZ)
               LSEP = ANGSEP (TEL, TAZ, LEL, LAZ)
C                                       Enno's method
C                                       compute separation beam to
C                                       target, add delta AZ/EL
            ELSE
               R = HAVSIN (TAZ, TEL, PAZ, PEL)
               THETA = AZBEAR (TAZ, TEL, PAZ, PEL)
               SEPAZ = R * SIN (THETA)
               SEPEL = R * COS (THETA)
C                                       swap R and L
               RAZ = SEPAZ + DAZ / 2.0D0
               LAZ = SEPAZ - DAZ / 2.0D0
               REL = SEPEL + DEL / 2.0D0
               LEL = SEPEL - DEL / 2.0D0
               RSEP = SQRT (RAZ*RAZ + REL*REL)
               LSEP = SQRT (LAZ*LAZ + LEL*LEL)
               END IF
C                                       beam diameter effective
            D = EFFD(ANTNO) + (FOFF(LF) - EFFREQ(ANTNO)) * EFFRAT(ANTNO)
C                                       apply beam factor
            IF (D.GT.0.0D0) THEN
               RFAC = BEAM (RSEP, D, LAMBDA)
               LFAC = BEAM (LSEP, D, LAMBDA)
C                                       DEBUG
               IF ((LF.EQ.DBGIF) .AND. (ANTNO.EQ.DBGANT)) THEN
                  IF (PRTS(ANTNO).LT.CURSOU) THEN
                     WRITE (MSGTXT,1000) ANTNO, 'R', CURSOU, RAD2DG*REL,
     *                  RAD2DG*RAZ, RAD2DG*RSEP, RFAC*RFAC
                     CALL MSGWRT (5)
                     WRITE (MSGTXT,1000) ANTNO, 'L', CURSOU, RAD2DG*LEL,
     *                  RAD2DG*LAZ, RAD2DG*LSEP, LFAC*LFAC
                     CALL MSGWRT (5)
                     PRTS(ANTNO) = PRTS(ANTNO) + 1
                     END IF
                  END IF
               IF (RFAC.LT.XCUT) THEN
                  CREAL(1,LF) = FBLANK
                  CIMAG(1,LF) = FBLANK
               ELSE
                  CREAL(1,LF) = CREAL(1,LF) / (ABS(RFAC))
                  CIMAG(1,LF) = CIMAG(1,LF) / (ABS(RFAC))
                  END IF
               IF (LFAC.LT.XCUT) THEN
                  CREAL(2,LF) = FBLANK
                  CIMAG(2,LF) = FBLANK
               ELSE
                  CREAL(2,LF) = CREAL(2,LF) / (ABS(LFAC))
                  CIMAG(2,LF) = CIMAG(2,LF) / (ABS(LFAC))
                  END IF
               END IF
 100        CONTINUE
         IRET = 0
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT (I2,1X,A,I3,F12.7,F13.7,F11.7,F10.6)
      END
      DOUBLE PRECISION FUNCTION ANGSEP (EL1, AZ1, EL2, AZ2)
C-----------------------------------------------------------------------
C   ANGSEP returns the sine of angular separation between 2 points
C   Inputs:
C      EL1      D   Point 1: elevation
C      AZ1      D            azimuth
C      EL2      D   Point 2: elevation
C      AZ2      D            azimuth
C   Output:
C      ANGSEP   D   sine of the great circle distance between
c                   the 2 points
C-----------------------------------------------------------------------
      DOUBLE PRECISION EL1, AZ1, EL2, AZ2
C
      DOUBLE PRECISION DD
C-----------------------------------------------------------------------
      DD = SIN(EL1) * SIN(EL2) + COS(EL1) * COS(EL2) * COS(AZ1-AZ2)
      DD = MAX (-1.0D0, MIN (1.0D0, DD))
      DD = ACOS (DD)
      ANGSEP = SIN (DD)
C
 999  RETURN
      END
      DOUBLE PRECISION FUNCTION BEAM (SEP, DIAM, LAMBDA)
C-----------------------------------------------------------------------
C   BEAM returns the value of the single-dish VOLTAGE beam of specified
C   effective diameter at specified wavelength and angular separation.
C   Inputs:
C      SEP      D   sine of the angle away from the center of the beam
C      DIAM     D   dish effective diameter (meters)
C      LAMBDA   D   Observation wavelength (meters)
C   Output:
C      BEAM     D   Beam power level - set to 0.01 if less than this
C-----------------------------------------------------------------------
      DOUBLE PRECISION SEP, DIAM, LAMBDA
C
      DOUBLE PRECISION X, BESSJ1
      INCLUDE 'INCS:PSTD.INC'
C-----------------------------------------------------------------------
      X = PI * SEP * DIAM / LAMBDA
C                                       BESSJ1 starts at x/2
      BEAM = 2.0D0 * BESSJ1 (X) / X
C
 999  RETURN
      END
      DOUBLE PRECISION FUNCTION BESSJ1 (X)
C-----------------------------------------------------------------------
C   Compute the J1 Bessel function for a given argument
C   Inputs:
C      X        D    The argument of the J1 Bessel function desired
C   Output:
C      BESSJ1   D   Returns the resultant J1 Bessel function
C   Method
C      from "Numerical Recipes" by Press et al.
C-----------------------------------------------------------------------
      DOUBLE PRECISION X
C
      DOUBLE PRECISION P1, P2, P3, P4, P5, Q1, Q2, Q3, Q4, Q5, R1, R2,
     *   R3, R4, R5, R6, S1, S2, S3, S4, S5, S6, Y, AX, XX, Z
      SAVE P1, P2, P3, P4, P5, Q1, Q2, Q3, Q4, Q5, R1, R2, R3, R4, R5,
     *   R6, S1, S2, S3, S4, S5, S6
      DATA R1, R2, R3, R4, R5, R6 /72362614232.D0, -7895059235.D0,
     *   242396853.1D0, -2972611.439D0, 15704.48260D0, -30.16036606D0/
      DATA S1, S2, S3, S4, S5, S6 /144725228442.D0, 2300535178.D0,
     *   18583304.74D0, 99447.43394D0, 376.9991397D0, 1.D0/
      DATA P1, P2, P3, P4, P5 /1.D0, .183105D-2, -.3516396496D-4,
     *   .2457520174D-5, -.240337019D-6/
      DATA Q1, Q2, Q3, Q4, Q5 /.04687499995D0, -.2002690873D-3,
     *   .8449199096D-5, -.88228987D-6, .105787412D-6/
C-----------------------------------------------------------------------
      IF (ABS(X).LT.8.) THEN
         Y = X**2
         BESSJ1 = X*(R1+Y*(R2+Y*(R3+Y*(R4+Y*(R5+Y*R6))))) /
     *      (S1+Y*(S2+Y*(S3+Y*(S4+Y*(S5+Y*S6)))))
      ELSE
         AX = ABS (X)
         Z = 8. / AX
         Y = Z**2
         XX = AX - 2.356194491D0
         BESSJ1 = SIGN (1.0D0, X) * SQRT (.636619772D0/AX) *
     *      (COS(XX)*(P1+Y*(P2+Y*(P3+Y*(P4+Y*P5)))) -
     *       Z*SIN(XX)*(Q1+Y*(Q2+Y*(Q3+Y*(Q4+Y*Q5)))))
         END IF
C
 999  RETURN
      END
      DOUBLE PRECISION FUNCTION HAVSIN (AZ1, EL1, AZ2, EL2)
C-----------------------------------------------------------------------
C   Returns the distance between two coordinates
C   Inputs:
C      AZ1      D   Position 1: azimuth
C      EL1      D   Position 1: elevation
C      AZ2      D   Position 2: azimuth
C      EL2      D   Position 2: elevation
C   Outputs:
C      HAVSIN   D   Bearing in radians
C-----------------------------------------------------------------------
      DOUBLE PRECISION AZ1, EL1, AZ2, EL2
C
      DOUBLE PRECISION A
C-----------------------------------------------------------------------
      A = SIN((EL1-EL2)/2.D0) ** 2 +
     *   (SIN((AZ1-AZ2)/2.D0) ** 2) * COS (EL1) * COS(EL2)
      HAVSIN = 2.0D0 * ATAN2 (SQRT(A), SQRT(1.0D0-A))
C
 999  RETURN
      END
      DOUBLE PRECISION FUNCTION AZBEAR (AZ1, EL1, AZ2, EL2)
C-----------------------------------------------------------------------
C   Returns the angle between two coordinates
C   Inputs:
C      AZ1      D   Position 1: azimuth
C      EL1      D   Position 1: elevation
C      AZ2      D   Position 2: azimuth
C      EL2      D   Position 2: elevation
C   Outputs:
C      AZBEAR   D   Bearing in radians
C-----------------------------------------------------------------------
      DOUBLE PRECISION AZ1, EL1, AZ2, EL2
C
C-----------------------------------------------------------------------
      AZBEAR = -ATAN2 (SIN(AZ2-AZ1) * COS(EL1),
     *   COS(EL2) * SIN(EL1) - SIN(EL2) * COS(EL1) * COS(AZ2-AZ1))
C
 999  RETURN
      END
      SUBROUTINE CLVLBH
C-----------------------------------------------------------------------
C   CLVLBH copies and updates history file.  It also copies any tables.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72
      INTEGER   LUN, IERR, I
      INCLUDE 'CLVLB.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHIS.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANS.INC'
      INCLUDE 'INCS:PSTD.INC'
      DATA LUN /27/
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       output file written
      CALL HIOPEN (LUN, DISKIN, OLDCNO, BUFF2, IERR)
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1000) IERR, 'OPEN OLD HISTORY FILE'
         CALL MSGWRT (6)
         GO TO 100
         END IF
C                                       versions applied
      WRITE (HILINE,1010) TSKNAM, ICLVER
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
      WRITE (HILINE,1011) TSKNAM, OCLVER
      CALL HIADD (LUN, HILINE, BUFF2, IERR)
      IF (IERR.NE.0) GO TO 100
C                                       parameters used
      WRITE (MSGTXT,1020)
      CALL MSGWRT (4)
      DO 20 I = 1,NSTNS
         SQAZ(I) = SQAZ(I) * 180.0 * 60.0 / PI
         SQEL(I) = SQEL(I) * 180.0 * 60.0 / PI
         WRITE (MSGTXT,1021) I, SQAZ(I), SQEL(I), BMFREQ(I)
         CALL MSGWRT (4)
 20      CONTINUE
      WRITE (MSGTXT,1030)
      CALL MSGWRT (4)
      DO 30 I = 1,NSTNS
         WRITE (MSGTXT,1031) I, EFFD(I), EFFREQ(I), EFFRAT(I)
         CALL MSGWRT (4)
 30      CONTINUE
      MSGTXT = ' IF   FREQ MHz'
      CALL MSGWRT (4)
      DO 40 I = 1,NIF
         WRITE (MSGTXT,1032) I, FOFF(I)
         CALL MSGWRT (4)
 40      CONTINUE
C                                       Close HI file
 100  CALL HICLOS (LUN, .TRUE., BUFF2, IERR)
C                                       Copy tables
      CALL CATIO ('UPDT', DISKIN, OLDCNO, CATBLK, 'REST', SCRBUF, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('CLVLBH: ERROR',I3,' COPY/OPEN HISTORY FILE')
 1010 FORMAT (A6,'GAINVER =',I5,5X,'/ CL file version in')
 1011 FORMAT (A6,'GAINUSE =',I5,5X,'/ CL file version out')
 1020 FORMAT ('ANT  SQAZ    SQEL    SQFREQ')
 1021 FORMAT (I3,2F8.4,F9.2)
 1030 FORMAT ('ANT    BMDIAM    BMFREQ   DBMDIAM')
 1031 FORMAT (I3,F10.5,F9.2,1PE13.5)
 1032 FORMAT (I3,F10.3)
      END
      SUBROUTINE ELVS (ANTNO, TIME, RAPOBS, DAPOBS, PEL, PAZ, TEL, TAZ)
C-----------------------------------------------------------------------
C   Subroutine to compute the apparent source elevations based on source
C   and antenna coordinates in common.  The routines GETANT and GETSOU
C   should be called before this routine to but the correct values in
C   the relevant commons.
C   Inputs:
C      ANTNO      I    Antenna number
C      TIME       D    Current data time (days).
C      RAPOBS     D    Apparent RA of pointing (radians)
C      DAPOBS     D    Apparent Dec of pointing (radians)
C   Input from common:
C      RAAPP      D    Apparent RA of source
C      DECAPP     D    Apparent Declination of source.
C      STNLAT     D(*) Antenna latitude (rad).
C      STNLON     D(*) Antenna east longitudes (rad).
C      GSTIAT     D    GST at IAT=0 of reference day (rad).
C      ROTIAT     D    Rotation of the earth rate in IAT.
C   Output:
C      PEL        D    Pointing elevation (rad)
C      PAZ        D    Pointing azimuth (rad)
C      TEL        D    Target source elevation (rad)
C      TAZ        D    Target source azimuth (rad)
C-----------------------------------------------------------------------
      INTEGER   ANTNO
      DOUBLE PRECISION TIME, RAPOBS, DAPOBS, PEL, PAZ, TEL, TAZ
C
      DOUBLE PRECISION HRANG, ANTLST, DARG, DARG2, DRA, DDEC, DAZ
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PSTD.INC'
      INCLUDE 'INCS:DSOU.INC'
      INCLUDE 'INCS:DANS.INC'
C-----------------------------------------------------------------------
C                                       Antenna LST
      ANTLST = GSTIAT + STNLON(ANTNO) + TIME * ROTIAT
C                                       Source position; if apparent
C                                       position missing use mean
C                                       position.
      DRA = RAAPP
      DDEC = DECAPP
      IF ((DRA.LE.1.0D-5) .AND. (DDEC.LE.1.0D-5)) THEN
         DRA = RAEPO
         DDEC = DECEPO
         END IF
C                                       Hour angle
      HRANG = ANTLST - DRA
C                                       Limit to between 0 and 2pi
      HRANG = DMOD (HRANG, TWOPI)
C                                       Elevation angle
      DARG = SIN (STNLAT(ANTNO)) * SIN (DDEC) + COS (STNLAT(ANTNO))
     *   * COS (DDEC) * COS (HRANG)
      TEL = PI/2.0D0 - ACOS (DARG)
C                                       AZ = ATAN2(SD*CL - CD*SL*CH,
C                                       CD*SH)
      DARG = SIN (DDEC) * COS (STNLAT(ANTNO)) -
     *       COS (DDEC) * SIN (STNLAT(ANTNO)) * COS(HRANG)
      DARG2 = COS (DDEC) * SIN (HRANG)
      DAZ = ATAN2 (DARG, DARG2)
      DAZ = MOD (DAZ - PI/2.0D0, TWOPI)
      IF (DAZ.LT.0.0D0) DAZ = DAZ + TWOPI
      TAZ = DAZ
C                                       pointing position; if apparent
C                                       position missing use mean
C                                       position.
      DRA = RAPOBS
      DDEC = DAPOBS
      IF ((DRA.LE.1.0D-5) .AND. (DDEC.LE.1.0D-5)) THEN
         DRA = RAOBS
         DDEC = DECOBS
         END IF
C                                       Hour angle
      HRANG = ANTLST - DRA
C                                       Limit to between 0 and 2pi
      HRANG = DMOD (HRANG, TWOPI)
C                                       Elevation angle
      DARG = SIN (STNLAT(ANTNO)) * SIN (DDEC) + COS (STNLAT(ANTNO))
     *   * COS (DDEC) * COS (HRANG)
      PEL = PI/2.0D0 - ACOS (DARG)
C                                       AZ = ATAN2(SD*CL - CD*SL*CH,
C                                       CD*SH)
      DARG = SIN (DDEC) * COS (STNLAT(ANTNO)) -
     *       COS (DDEC) * SIN (STNLAT(ANTNO)) * COS(HRANG)
      DARG2 = COS (DDEC) * SIN (HRANG)
      DAZ = ATAN2 (DARG, DARG2)
      DAZ = MOD (DAZ - PI/2.0D0, TWOPI)
      IF (DAZ.LT.0.0D0) DAZ = DAZ + TWOPI
      PAZ = DAZ
C
 999  RETURN
      END

      SUBROUTINE TSKHLP (CHOIC, IC, HNAME, IERR)
C-----------------------------------------------------------------------
C;  Copyright (C) 1995, 2007-2008, 2014, 2024-2025
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C   displays on the user's terminal those rows of the file HLPhname.HLP
C   which correspond to the item selected by CHOIC.  The items are
C   separated in the file by lines with C in column 1 and ----'s in col
C   2-72.  The name of the item is left-justified in the next line of
C   the file and is followed by as many lines of text as are needed to
C   describe the item.  This allows help info to be displayed inside a
C   task selecting only those sections which are needed for the moment
C   and responding to the version string (OLD, NEW TST only) used to
C   start the task.
C   If the name of the item in the HLPhname.HLP file is terminated by
C   "<>" then the item is considered to match if the characters
C   preceding the < match.
C   Inputs:
C      CHOIC    C*(*)   Item name - case-sensitive
C      IC       I       Compare IC characters of CHOIC.  0 => use ITRIM.
C      HNAME    C*(*)   Name to use for help file of name HLPhname.HLP
C                       ' ' => current task name  Uses only 5 chars
C   Output:
C      IERR     I       Error code: 0 => okay, 2 input error, > 0 I/O
C                       -1 CHOIC not found
C-----------------------------------------------------------------------
      CHARACTER CHOIC*(*), HNAME*(*)
      INTEGER   IC, IERR
C
      INTEGER   LUN, FIND, NLINE, JERR, ITRIM, NC, TLUN, TIND, JC,
     *   IP, LP, K, I, K1, K2, N2, M2
      CHARACTER PHNAME*48, HLPNAM*8, VERSON*48, CBUF*72, MNAME*6,
     *   SEP*72, NUMBM*8, NUMBN*8, DBUF*80
      LOGICAL   HDRLST
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUN /11/
C-----------------------------------------------------------------------
C                                       test inputs
      IERR = 2
      NC = IC
      IF (NC.EQ.0) NC = ITRIM (CHOIC)
      IF ((NC.LE.0) .OR. (NC.GT.72)) GO TO 999
      MNAME = HNAME
      IF (MNAME.EQ.' ') MNAME = TSKNAM
      SEP = ' '
      SEP(11:24) = '- - - - - - - '
      SEP(25:38) = '- - - - - - - '
      SEP(39:52) = '- - - - - - - '
      SEP(53:62) = '- - - - - '
C                                       open file
      CALL ZPHFIL ('HE', 1, 0, 0, PHNAME, IERR)
      VERSON = VERNAM
      IF (VERSON.EQ.' ') VERSON = 'TST'
      HLPNAM = 'HLP' // MNAME(:5)
      CALL ZTOPEN (LUN, FIND, 1, PHNAME, HLPNAM, VERSON, .TRUE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, 'OPEN', HLPNAM
         CALL MSGWRT (8)
         GO TO 999
         END IF
      NLINE = 0
      HDRLST = .FALSE.
C                                       read loop: look for section
C                                       demand full match
 10   CALL ZTREAD (LUN, FIND, CBUF, IERR)
         IF (IERR.EQ.2) THEN
            GO TO 20
         ELSE IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, 'READ', HLPNAM
            CALL MSGWRT (8)
            GO TO 990
         ELSE IF (CBUF(:8).EQ.'C-------') THEN
            HDRLST = .TRUE.
         ELSE IF (HDRLST) THEN
            JC = ITRIM (CBUF)
            IF (CBUF(JC-6:JC).EQ.'<m>-<n>') THEN
               JC = JC - 7
               JC = ITRIM (CBUF(:JC))
               NUMBM = CHOIC(JC+1:)
               I = INDEX (NUMBM, '-')
               NUMBN = NUMBM(I+1:)
               NUMBM = NUMBM(:I-1)
               CALL CHPACK (NUMBN, ' ', N2)
               CALL CHPACK (NUMBM, ' ', M2)
            ELSE
               NUMBM = ' '
               END IF
            IF (CBUF(JC-2:JC).EQ.'<n>') THEN
               JC = JC - 3
               NUMBN = CHOIC(JC+1:)
               CALL CHPACK (NUMBN, ' ', N2)
            ELSE
               IF (NUMBM.EQ.' ') NUMBN = ' '
               END IF
            JC = MIN (NC, JC)
            IF (CHOIC(:JC).EQ.CBUF(:JC)) GO TO 40
            HDRLST = .FALSE.
            END IF
         GO TO 10
C                                       close and reopen
 20   CALL ZTCLOS (LUN, FIND, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1010) JERR, 'CLOSE', HLPNAM
         CALL MSGWRT (8)
         END IF
      CALL ZTOPEN (LUN, FIND, 1, PHNAME, HLPNAM, VERSON, .TRUE., IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1010) IERR, 'OPEN', HLPNAM
         CALL MSGWRT (8)
         GO TO 999
         END IF
      NLINE = 0
      HDRLST = .FALSE.
C                                       read loop: look for section
 30   CALL ZTREAD (LUN, FIND, CBUF, IERR)
         IF (IERR.EQ.2) THEN
            IERR = -1
            GO TO 990
         ELSE IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, 'READ', HLPNAM
            CALL MSGWRT (8)
            GO TO 990
         ELSE IF (CBUF(:8).EQ.'C-------') THEN
            HDRLST = .TRUE.
         ELSE IF (HDRLST) THEN
            JC = ITRIM (CBUF)
            IF (CBUF(JC-6:JC).EQ.'<m<-<n>') JC = JC - 7
            IF (CBUF(JC-2:JC).EQ.'<n>') JC = JC - 3
            JC = MIN (NC, JC)
            IF (CHOIC(:JC).EQ.CBUF(:JC)) GO TO 40
            HDRLST = .FALSE.
            END IF
         GO TO 30
C                                       Found it: find or open TTY
 40   TLUN = 5
      CALL LSERCH ('SRCH', TLUN, TIND, .FALSE., IERR)
      IF (IERR.EQ.1) CALL ZTTOPN (TLUN, TIND, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) 'OPENING', IERR
         CALL MSGWRT (7)
         GO TO 990
         END IF
C                                       write the line
 50   NC = ITRIM (CBUF)
         NC = MAX (1, NC)
         IF (NUMBM.NE.' ') THEN
            IP = 1
            LP = 1
 55         K1 = INDEX (CBUF(IP:NC), '<m>')
            K2 = INDEX (CBUF(IP:NC), '<n>')
            IF ((K1.GT.0) .AND. ((K1.LT.K2) .OR. (K2.EQ.0))) THEN
               K = K1
               DBUF(LP:) = CBUF(IP:IP+K-1)
               LP = LP + K - 1
               DBUF(LP:) = NUMBM
               LP = LP + M2
               IP = IP + K + 2
               GO TO 55
            ELSE IF ((K2.GT.0) .AND. ((K2.LT.K1) .OR. (K1.EQ.0))) THEN
               K = K2
               DBUF(LP:) = CBUF(IP:IP+K-1)
               LP = LP + K - 1
               DBUF(LP:) = NUMBN
               LP = LP + N2
               IP = IP + K + 2
               GO TO 55
            ELSE IF (LP.GT.1) THEN
               DBUF(LP:) = CBUF(IP:)
               END IF
            IF (LP.GT.1) CBUF = DBUF
            NC = ITRIM (CBUF)
            NC = MAX (1, NC)
         ELSE IF (NUMBN.NE.' ') THEN
            IP = 1
            LP = 1
 60         K = INDEX (CBUF(IP:NC), '<n>')
            IF (K.GT.0) THEN
               DBUF(LP:) = CBUF(IP:IP+K-1)
               LP = LP + K - 1
               DBUF(LP:) = NUMBN
               LP = LP + N2
               IP = IP + K + 2
               GO TO 60
            ELSE IF (LP.GT.1) THEN
               DBUF(LP:) = CBUF(IP:)
               END IF
            IF (LP.GT.1) CBUF = DBUF
            NC = ITRIM (CBUF)
            NC = MAX (1, NC)
            END IF
         CALL ZTTYIO ('WRIT', TLUN, TIND, NC, CBUF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1020) 'WRITING TO', IERR
            CALL MSGWRT (7)
            GO TO 990
            END IF
C                                       read next line
         CALL ZTREAD (LUN, FIND, CBUF, IERR)
         IF (IERR.EQ.2) THEN
            IERR = 0
            GO TO 980
         ELSE IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1010) IERR, 'READ', HLPNAM
            CALL MSGWRT (8)
            GO TO 990
         ELSE IF (CBUF(:8).EQ.'C-------') THEN
            GO TO 980
            END IF
         GO TO 50
C                                       final separator
 980  NC = ITRIM (SEP)
      CALL ZTTYIO ('WRIT', TLUN, TIND, NC, SEP, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1020) 'WRITING TO', IERR
         CALL MSGWRT (7)
         END IF
C
 990  CALL ZTCLOS (LUN, FIND, JERR)
      IF (JERR.NE.0) THEN
         WRITE (MSGTXT,1010) JERR, 'CLOSE', HLPNAM
         CALL MSGWRT (8)
         END IF
      IF (IERR.EQ.-1) THEN
         MSGTXT = 'NO HELP FOR ' // CHOIC
         CALL MSGWRT (6)
         END IF
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ERROR ',I5,' DOING A ',A,' FOR FILE ',A)
 1020 FORMAT ('ERROR',I5,1X,A,' THE TERMINAL')
      END

      SUBROUTINE DIRADD(I
     *    1,I 2,I 3,I
     *    4)
C-----------------------------------------------------------------------
C! FPS AP 5xxx load module.
C# AP-appl
C-----------------------------------------------------------------------
C;  Copyright (C) 1995
C;  Associated Universities, Inc. Washington DC, USA.
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      INTEGER*2 CODE(  113)
      INTEGER*2 I 1,J 1
      INTEGER*2 I 2,J 2
      INTEGER*2 I 3,J 3
      INTEGER*2 I 4,J 4
      INTEGER*2 N   0
      INTEGER*2 N   4
      INTEGER*2 SLIST(16)
      COMMON /SPARY/SLIST
      EQUIVALENCE (J 1,SLIST( 1))
      EQUIVALENCE (J 2,SLIST( 2))
      EQUIVALENCE (J 3,SLIST( 3))
      EQUIVALENCE (J 4,SLIST( 4))
      DATA CODE(1) /  28/
      DATA CODE(    2),CODE(    3),CODE(    4),CODE(    5)/
     *  Z4000, Z0000, Z0000, Z0030/
      DATA CODE(    6),CODE(    7),CODE(    8),CODE(    9)/
     *  Z0000, Z0000, Z0000, Z0010/
      DATA CODE(   10),CODE(   11),CODE(   12),CODE(   13)/
     *  Z0000, Z0000, Z0000, Z0010/
      DATA CODE(   14),CODE(   15),CODE(   16),CODE(   17)/
     *  Z0390, Z0000, Z0A00, Z0000/
      DATA CODE(   18),CODE(   19),CODE(   20),CODE(   21)/
     *  Z028C, Z0000, Z4A04, Z0000/
      DATA CODE(   22),CODE(   23),CODE(   24),CODE(   25)/
     *  Z0000, Z019E, Z1A00, Z8000/
      DATA CODE(   26),CODE(   27),CODE(   28),CODE(   29)/
     *  Z2090, Z0000, Z0000, Z0030/
      DATA CODE(   30),CODE(   31),CODE(   32),CODE(   33)/
     *  Z0000, Z0000, Z0000, Z0010/
      DATA CODE(   34),CODE(   35),CODE(   36),CODE(   37)/
     *  Z2040, Z0000, Z0000, Z0030/
      DATA CODE(   38),CODE(   39),CODE(   40),CODE(   41)/
     *  Z028D, ZA800, Z0100, Z0010/
      DATA CODE(   42),CODE(   43),CODE(   44),CODE(   45)/
     *  Z4115, ZB996, Z0020, Z0010/
      DATA CODE(   46),CODE(   47),CODE(   48),CODE(   49)/
     *  Z0390, Z0000, Z0A00, Z0000/
      DATA CODE(   50),CODE(   51),CODE(   52),CODE(   53)/
     *  Z4155, Z8000, Z4A04, Z0070/
      DATA CODE(   54),CODE(   55),CODE(   56),CODE(   57)/
     *  Z0000, Z0000, Z1A00, Z8050/
      DATA CODE(   58),CODE(   59),CODE(   60),CODE(   61)/
     *  Z2090, Z0000, Z0000, Z0030/
      DATA CODE(   62),CODE(   63),CODE(   64),CODE(   65)/
     *  Z0000, Z0049, Z0000, Z0010/
      DATA CODE(   66),CODE(   67),CODE(   68),CODE(   69)/
     *  Z0390, Z0000, Z0A00, Z0000/
      DATA CODE(   70),CODE(   71),CODE(   72),CODE(   73)/
     *  Z4155, Z8000, Z4A04, Z0070/
      DATA CODE(   74),CODE(   75),CODE(   76),CODE(   77)/
     *  Z0000, Z0000, Z1A00, Z8050/
      DATA CODE(   78),CODE(   79),CODE(   80),CODE(   81)/
     *  Z2090, Z0000, Z0000, Z0030/
      DATA CODE(   82),CODE(   83),CODE(   84),CODE(   85)/
     *  Z0000, Z0000, Z0000, Z0010/
      DATA CODE(   86),CODE(   87),CODE(   88),CODE(   89)/
     *  Z0000, Z0000, Z0000, Z0000/
      DATA CODE(   90),CODE(   91),CODE(   92),CODE(   93)/
     *  Z0001, ZA800, Z0100, Z0000/
      DATA CODE(   94),CODE(   95),CODE(   96),CODE(   97)/
     *  Z4115, ZB800, Z0020, Z0000/
      DATA CODE(   98),CODE(   99),CODE(  100),CODE(  101)/
     *  Z0000, Z0000, Z0000, Z0000/
      DATA CODE(  102),CODE(  103),CODE(  104),CODE(  105)/
     *  Z4155, Z8000, Z0000, Z0070/
      DATA CODE(  106),CODE(  107),CODE(  108),CODE(  109)/
     *  Z0000, Z0000, Z0000, Z0050/
      DATA CODE(  110),CODE(  111),CODE(  112),CODE(  113)/
     *  Z0000, Z00E0, Z0000, Z0000/
      DATA N   0 /   0/
      DATA N   4 /   4/
C-----------------------------------------------------------------------
      J 1 = I 1
      J 2 = I 2
      J 3 = I 3
      J 4 = I 4
      CALL APEX (CODE, N   0, SLIST, N   4)
      RETURN
      END

#!/bin/sh
#-----------------------------------------------------------------------
#;  Copyright (C) 1995-1998, 2000-2001
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# Usage: . CDVER.SH
#-----------------------------------------------------------------------
# Define the AIPS programming environment variables (aka "logicals").
# The master definitions are in $SYSAIPS/AREAS.DAT, and $SYSUNIX/AREAS
# will generate $SYSUNIX/AREAS.SH and .CSH, usually via a midnight job.
# Normally, this script is only used when $CDOLD, $CDNEW or $CDTST is
# typed (by the programmer interactively, or in a login script).
# Definitions for local, and/or non-standard areas should be defined
# here, not in the other mentioned files.
#
# This script also toggles the search path (i.e., $PATH) to include the
# directories $SYSLOCAL and $SYSUNIX.
#
# Generic Bourne/Korn/Bash shell version.
#-----------------------------------------------------------------------
#                                       Define/redefine standard names
. $AIPS_ROOT/AIPSPATH.SH
#                                       Now get the programming areas.
. $SYSUNIX/AREAS.SH
#
  UPDATE=$AIPS_VERSION/$ARCH/UPDATE
  export UPDATE
#                                       Display AIPS version.
if [ -t 1 ] ; then
   echo AIPS_VERSION=$AIPS_VERSION
fi

#!/bin/sh
#-----------------------------------------------------------------------
#;  Copyright (C) 1995-2000, 2003-2004
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# FCLEVEL.SH
# --------------------------------------------------------------------
# Determines optimization and debug level for an input file
# Input Variables are:
#    FILE    - file name to find optimization
#    AREA    - directory name to find optimization
# Assumes file $SYSUNIX/OPTIMIZE.LIS exists
# Output Variables are:
#    OPTDEF  - Optimization for this file
#    DBGDEF  - Debug level  for this file
# this script must be executed in the following manner
#  OPTHIS=`(. FCLEVEL.SH)`
# then the $OPTHIS variable must be used for all further processing
# Generic version
#--------------------------------------------------------------------
DBGDEF=""
OPTDEF=""
OPTDIR=$SYSUNIX
#                                       Read in local default options ?
[ -f $SYSLOCAL/OPTIMIZE.LIS ] && \
   OPTDIR=$SYSLOCAL
#                                       For each non comment line:
grep -v '^#' $OPTDIR/OPTIMIZE.LIS | \
{
   while read line ; do
#                                       General way of getting params
      set - $line
#                                       Skip blank lines
      [ ! -n "$line" ] && continue
#                                       translate file or logical name
      LOGNAME=`eval echo $1`
      if [ -n "$LOGNAME" ] ; then
         case $LOGNAME in
#                                       default, directory or file?
         DEFAULT | $AREA | $FILE*)
#                                       if the correct Architecture
            if [ \( "$2" = "$ARCH" \) \
              -o \( "$2" = "ALL" \) ] ; then
#                                       decode the optimization
               OPTDEF=\$OPT$3
               OPTDEF=`eval echo $OPTDEF`
#                                       decode the debug level
               if [ $4 -eq 1 ] ; then
                  DBGDEF=$DEBUG
               else
                  DBGDEF=$NODEBUG
               fi
#                                        send result to upper level
               echo $OPTDEF $DBGDEF
               exit 0
#                                        end if correct architecture
            fi
         ;;
         esac
      fi
   done
}
echo $OPTDEF $DBGDEF

#-----------------------------------------------------------------------
#;  Copyright (C) 1995, 2003
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# Usage: . HOSTS.SH
#-----------------------------------------------------------------------
# This file gets particulars about the network setup for AIPS from the
# HOSTS.LIST file.  Do not change this file; edit the HOSTS.LIST
# instead.
# The following environment variables identify each AIPS host or TV
# server in the local network.
#
#    HOST    Name of the machine, uppercase.
#
#    SITE    The local site name, uppercase.
#
#    HOSTS   List of all hosts which run AIPS at this site.
#
#    ARCH    Differentiates executables and libraries for different
#            machine architectures.
#
#-----------------------------------------------------------------------
#                                       Set the AIPS root directory.
AIPS_ROOT=/DEFINE_ME
#
# do not change anything below this line
#
export AIPS_ROOT
if [ ! -d $AIPS_ROOT ] ; then
  echo 'AIPS_ROOT is not correctly defined in the HOSTS.SH script.'
  echo 'You need to run the AIPSROOT.DEFINE script (or get help).'
  exit 2
fi
#                                       Find the hosts file
if [ ! -f $AIPS_ROOT/HOSTS.LIST ] ; then
  echo "HOSTS: Cannot find HOSTS.LIST in $AIPS_ROOT"
  echo 'HOSTS: Cannot proceed.  Help!'
  exit 2
fi
#                                       Set variable HOST.  Strip off
#                                       any domain name, use simple
#                                       hostname.  Also uppercase it.
HOST=`$AIPS_ROOT/SETUNAME`
export HOST
#                                       Now look for this in HOSTS.LIST
xxx=`grep "^[-+]  $HOST" $AIPS_ROOT/HOSTS.LIST`
#
if [ "$xxx" = "" ] ; then
  ARCH="UNKNOWN"; export ARCH
  SITE="UNKNOWN"; export SITE
else
  ARCH=`echo $xxx | awk '{ print $3}'`; export ARCH
  SITE=`echo $xxx | awk '{ print $4}'`; export SITE
  xxx=`grep "^+.*$SITE" $AIPS_ROOT/HOSTS.LIST | awk '{ printf "%s ", $2 }'`
  HOSTS="$xxx"; export HOSTS
fi

#!/usr/bin/echo you_need_to_source_this_file
#-----------------------------------------------------------------------
#;  Copyright (C) 1995-1996, 1998, 2000-2024
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# Usage: source AIPSPATH.CSH
#-----------------------------------------------------------------------
# AIPSPATH defines the version of AIPS in use and redefines $PATH to
# include the AIPS system directories.  It also defines the AIPS
# programmer version selection macro environment variables.
#
#   Version that makes the AIPS areas come after the user's
#-----------------------------------------------------------------------
#                                       Set the AIPS root directory.
setenv AIPS_ROOT /DEFINE_ME
#                                       Define AIPS versions.
setenv OLD $AIPS_ROOT/31DEC23
setenv NEW $AIPS_ROOT/31DEC24
setenv TST $AIPS_ROOT/31DEC25
setenv CVX $AIPS_ROOT/31DEC25
#                                       Assign default version (see
#                                       START_AIPS)
if (! $?VERSION) setenv VERSION TST
#
# --------------- do not change anything below this line ---------------
#
if ( ! -d $AIPS_ROOT ) then
   echo 'AIPSPATH.CSH: AIPS_ROOT is incorrectly defined.'
   echo 'Edit AIPSPATH.CSH (and .SH) to set it for your site.'
else
#                                       Get host info if necessary.
   if (! $?ARCH) source $AIPS_ROOT/HOSTS.CSH
#
#                                       Define AIPS versions.
   switch ($VERSION)
      case OLD:
         setenv AIPS_VERSION $OLD
         breaksw
      case NEW:
         setenv AIPS_VERSION $NEW
         breaksw
      case TST:
         setenv AIPS_VERSION $TST
         breaksw
      case CVX:
         setenv AIPS_VERSION $CVX
         breaksw
      default:
         setenv AIPS_VERSION $TST
         breaksw
   endsw

#                                       Define AIPS procedure areas.
   setenv SYSUNIX $AIPS_VERSION/SYSTEM/UNIX
   if (-d $AIPS_VERSION/$ARCH/SYSTEM/$SITE) then
      setenv SYSLOCAL $AIPS_VERSION/$ARCH/SYSTEM/$SITE
   else
      setenv SYSLOCAL $AIPS_VERSION/$ARCH/SYSTEM
   endif
#                                       LIBRARY_PATH: sync'd systems
   if (-f $SYSLOCAL/RSYNC.ME || -f $SYSLOCAL/RSYNC.MASTER) then
#      if ("$ARCH" == "MACINT" || $ARCH == "MACARM") then
#         set TPATH = `echo $DYLD_LIBRARY_PATH | sed 's/^://' | sed 's/:$//'`
      if ("$ARCH" == "LINUX" || $ARCH == "LNX64") then
         set TPATH = `echo $LD_LIBRARY_PATH | sed 's/^://' | sed 's/:$//'`
      endif
      set local = "${AIPS_VERSION}/${ARCH}/LIBR/INTELCMP"
      set tempath = ""
      foreach d (`echo $TPATH | sed 's/:/ /g'`)
         switch ($d)
            case "$local":
               breaksw
            default:
               set tempath = "${tempath}${d}:"
               breaksw
         endsw
      end
      set tempath = "${tempath}${local}"
#      if ("$ARCH" == "MACINT" || $ARCH == "MACARM") then
#         setenv DYLD_LIBRARY_PATH `echo $tempath | sed 's/:$//'`
       if ("$ARCH" == "LINUX" || $ARCH == "LNX64") then
         setenv LD_LIBRARY_PATH `echo $tempath | sed 's/:$//'`
      endif
   endif
#                                       MANPATH to get $SYSUNIX/manl,
#                                       but always use TST version.
   if ( $?MANPATH ) then
      set tempath = "$TST/SYSTEM/UNIX:"
      foreach d (`echo $MANPATH | sed -e 's/:/ /g'`)
         switch ($d)
	    case "$TST/SYSTEM/UNIX":
               breaksw
            default:
               set tempath = "${tempath}${d}:";;
               breaksw
         endsw
      end
      setenv MANPATH `echo $tempath | sed -e 's/:$//'`
#                                       leave empty ones for man to
#                                       handle by new rules
#  else
#     setenv MANPATH "/usr/man:$TST/SYSTEM/UNIX"
   endif
#                                       Save PATH and redefine it.
#                                       check if it starts with ":"
#                                       Don't rely on existing TPATH
#                                       definition as PATH may have
#                                       changed in the interim!
   set TPATH = `echo $PATH | sed 's/^://' | sed 's/:$//'`
   setenv HAVE_PERL ""
   if ( -f $SYSUNIX/DADEVS.PL ) then
      set perlplace = `head -n 1 $SYSUNIX/DADEVS.PL | sed -e 's/^..//'`
     if ( -f $perlplace ) setenv HAVE_PERL $perlplace
   endif
   set dot   = ".:"
#   set local = "$SYSLOCAL":
#   set unix  = "$SYSUNIX":
#   set tempath = "$dot$local$unix"
   set local = :"$SYSLOCAL"
   set unix  = :"$SYSUNIX"
   set tempath = "$dot"
   foreach d (`echo $TPATH | sed 's/:/ /g'`)
      switch ($d)
         case ".":
            breaksw
         case "$SYSLOCAL":
            breaksw
         case "$SYSUNIX":
            breaksw
         default:
            set tempath = "${tempath}${d}:"
            breaksw
      endsw
   end
   set tempath = "$tempath$local$unix"
   setenv PATH `echo $tempath | sed 's/:$//'`
   unset dot local unix tempath
#                                       Define the AIPS load area.
   setenv LOAD $AIPS_VERSION/$ARCH/LOAD
#                                       Make AIPS version changing
#                                       commands.
   if ( -d $OLD/$ARCH/SYSTEM/$SITE ) then
      setenv CDOLD "eval setenv VERSION OLD; source $OLD/$ARCH/SYSTEM/$SITE/CDVER.CSH"
   else
      setenv CDOLD "eval setenv VERSION OLD; source $OLD/$ARCH/SYSTEM/CDVER.CSH"
   endif
   if ( -d $NEW/$ARCH/SYSTEM/$SITE ) then
      setenv CDNEW "eval setenv VERSION NEW; source $NEW/$ARCH/SYSTEM/$SITE/CDVER.CSH"
   else
      setenv CDNEW "eval setenv VERSION NEW; source $NEW/$ARCH/SYSTEM/CDVER.CSH"
   endif
   if ( -d $TST/$ARCH/SYSTEM/$SITE ) then
      setenv CDTST "eval setenv VERSION TST; source $TST/$ARCH/SYSTEM/$SITE/CDVER.CSH"
   else
      setenv CDTST "eval setenv VERSION TST; source $TST/$ARCH/SYSTEM/CDVER.CSH"
   endif
   if ( -d $CVX/$ARCH/SYSTEM/$SITE ) then
      setenv CDCVX "eval setenv VERSION CVX; source $CVX/$ARCH/SYSTEM/$SITE/CDVER.CSH"
   else
      setenv CDCVX "eval setenv VERSION CVX; source $CVX/$ARCH/SYSTEM/CDVER.CSH"
   endif
endif

#!/bin/sh
# CCOPTS.SH
#-----------------------------------------------------------------------
#;  Copyright (C) 1995-1996, 1998, 2001-2002, 2005, 2009, 2017, 2019,
#;  Copyright (C) 2024
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# Define variables used by $SYSUNIX/AIPSCC.  These include
#    1) command name for the host C compiler, and
#    2) C compiler options and AIPS style options.
# Both can be toggled by, e.g. NODEBUG or DEBUG, NOPURGE or PURGE...
#
# NOTE: These are options for compiling C ONLY (see definition of the
#       environment variable 'COMP' below).  Options applicable to the
#       loader are defined in $SYSLOCAL/LDOPTS.SH.
#
#  NRAO-CV Linux version.
#--------------------------------------------------------------------

#                 COMPILER=/opt/intel/Compiler/11.0/074/bin/intel64/icc
#                 COMPILER=/opt/intel/bin/icc
COMPILER=/usr/bin/gcc
#                                       System specific options.  Debug:
DEBUG="-g"
#                                       Options for static libraries.
#                                       MUST BE CONSISTENT between this,
#                                       LDOPTS.SH and FDEFAULT.SH
#                                       (latter in $SYSUNIX).
#                                       One hopes the 64 won't matter
#                                       to < 2.4.2 kernels

OPT0="-O3 -fomit-frame-pointer -funroll-loops"
COMP="$OPT0 -I$INC -D_FILE_OFFSET_BITS=64"

#                                       For glibc-based systems,
#                                       e.g. Red Hat 5.0 and later.
[ -f /lib/libc.so.6* ] && COMP="$COMP -DHAVE_LINUX_GLIBC"

case $COMPILER in
#                                       GNU g77
    *gcc*)
        COMP="$OPT0 -I$INC -D_FILE_OFFSET_BITS=64 -DHAVE_LINUX_GLIBC"
        ;;
#                                       Intel compiler
    *ifc)
        OPT0="-O2 -unroll"
        COMP="$OPT0 -I$INC -D_FILE_OFFSET_BITS=64 -DHAVE_LINUX_GLIBC"
        ;;
#                                       New Intel compiler
    *icc*)
#                                       OPT0="-O3 -ip -axWPT"
#                                       2017 Intel compiler
        OPT0="-O3 -ip"
        COMP="$OPT0 -I$INC -D_FILE_OFFSET_BITS=64 -DHAVE_LINUX_GLIBC"
        ;;
#                                       Some other compiler.  If f2c,
#                                       set some sensible options.
    *)
        ;;
esac

#                                       Optimizations (safe ones).
OPT1="$OPT0"
OPT2="$OPT1"
OPT3="$OPT2"
OPT4="$OPT3"
OPT5="$OPT4"
OPT6="$OPT5"
OPT7="$OPT6"
OPT8="$OPT7"
OPT9="$OPT8"
#                                       AIPS style options
#                                       Generate source code listing?
LIST=FALSE
#                                       Purge: delete .c, .LOG files.
#                                       if LIST=FALSE, also  .LIS files.
PURGE=TRUE
#                                       End

#!/bin/sh
#-----------------------------------------------------------------------
#;  Copyright (C) 1995-2003, 2006, 2016, 2018-2019, 2022-2024
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# FDEFAULT.SH
# set compiler name, compiler switches to AIPS standard names
# Input Variables
#   ARCH      = Type of CPU (Convex Sun or IBM)
# Variables returned:
#   COMPILER  = Name of fortran Compiler
#   COMPSWIT  = Switches needed to enforce AIPS coding standards
#               IMPORTANT: Within the case statement on $ARCH, the
#               setting of this variable HAS to be on ONE SINGLE LINE!
#               This is for install.pl's use.
#   OPT(0-9)  = Ten compiler optimzation levels
#   DEBUG     = Compiler Debug switch
#
#   Mac INTEL version with Intel compiler
#-----------------------------------------------------------------------
#                                       Set default compiler for POSIX
#                          new Intel compiler
COMPILER="ifort"
#                                       Dirty is a carryover from VMS...
DIRTY=""; NODIRTY=""
#                                       POSIX Fortran 77 debug flag.
DEBUG="-g"; NODEBUG=""
#                                       Profile, architecture dependent.
PROFILE=""
#                                       POSIX compile-only switch
COMPSWIT="-c"
#                                       POSIX "no optimize" directive
NOOPT="-O0"
#                                       Generate source code listing?
LIST=FALSE
#                                       Remove leftover .f, .LOG files
PURGE=FALSE
#                                       Case by case differences from
#                                       the above standard definitions.
case $ARCH in
#                                       --------------------------------
#                                       Mac Intel box.
   MACARM)
#                                       Change location if needed
#      COMPILER=/usr/local/bin/ifort
      COMPILER=/usr/local/bin/gfortran
      COMPSWIT=""
#
      case $COMPILER in
#                                       Check g77 or not...
#                                       GNU gfortran
         *gfortran*)
      COMPSWIT="-fno-automatic -Wunused -Wuninitialized -Wmaybe-uninitialized -finit-local-zero -fimplicit-none"
              COMPSWIT="$COMPSWIT -mmacosx-version-min=13.0"
              OPT0=" " ; OPT1="-O"
              OPT2="-O2"; OPT3=$OPT2
              ;;
#                                       New Intel compiler
         *ifort*)
              COMPSWIT="-ip -save -align all -mmacosx-version-min=10.7"
              OPT0='-O0'; OPT1='-O3'; OPT2='-O3';
              OPT3=$OPT2 ; OPT4=$OPT3 ; OPT5=$OPT4 ; OPT6=$OPT5
              OPT7=$OPT6 ; OPT8=$OPT7 ; OPT9=$OPT8
              ;;
#                                       not recognized
         *)
              echo "Unrocognized compiler" $COMPILER " on " $ARCH
              OPT0="-O0" ; OPT1="-O1" ; OPT2="-O2" ; OPT3=$OPT2
              ;;
      esac
      OPT4=$OPT3 ; OPT5=$OPT4 ; OPT6=$OPT5
      OPT7=$OPT6 ; OPT8=$OPT7 ; OPT9=$OPT8
      NOOPT=$OPT0
      ;;
#                                       --------------------------------
#                                       Other: Assume simple -O settings
#                                       In addition to the defaults.
   *)
      echo "You are using a MacINTEL FDEFAULT.SH on " $ARCH
      OPT0="-O0" ; OPT1="-O1" ; OPT2="-O2"
      OPT3=$OPT2 ; OPT4=$OPT2 ; OPT5=$OPT2 ; OPT6=$OPT2
      OPT7=$OPT2 ; OPT8=$OPT2 ; OPT9=$OPT2
      ;;
esac
#
COMP=$COMPSWIT
#                                       export the defined values
export NODEBUG DEBUG DIRTY NODIRTY PROFILE PURGE
export COMPILER COMPSWIT NOOPT
export OPT0 OPT1 OPT2 OPT3 OPT4 OPT5 OPT6 OPT7 OPT8 OPT9

#-----------------------------------------------------------------------
#;  Copyright (C) 1996, 2000-2002, 2004-2006, 2008
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# Usage: . AIPSASSN.SH
#-----------------------------------------------------------------------
# AIPSASSN defines environment variables required to run AIPS.  It
# relies on assignments made by AIPSPATH.SH, particularly $AIPS_ROOT.
# Normally AIPSASSN.SH is called by LOGIN.SH or other AIPS scripts.
#
# The TAPEn definitions are now in $NET0/TPDEVS.LIST, not here.
# Explanation of some of these variables:
#
#    NET0         Location of network system parameter file NETSP.
#                 Used by ZDCHIN for disk information.
#
#    DATA_ROOT    Root directory of all AIPS data directories
#    DA00         Host-specific directory containing AIPS system files.
#
#    LPDEV        Printer to use (see $AIPS_ROOT/PRDEVS.SH for LP* vars)
#    LPDEVn       List of printer names xx as in "lpr -Pxx"
#    LPTYPEn      Corresponding printer type: PS, QMS, TEXT, or PREVIEW.
#    LPDESCn      Human-readable description of printer (location, etc).
#
#    RUNFIL       Area for "run" files (text).  If RUNFIL is already
#                 defined, it will NOT be overridden.
#
#    RESSTTn      Terminals reserved for AIPSn (if any).  Used by ZSTRTA
#
#    TVTTn        hardware TV for AIPS number n, reserved terminal n.
#                 Restricts access to AIPS n only.  See TVDEVS.SH also.
#
#    TASKTTn      AIPSn task message terminal (if any).  Usually
#                 associated with reserved terminals.  Used by ZTTOPN.
#                 This is NOT the MSGSRV (Message Server) definition!
#
#    TEKTKn       AIPSn Tektronix 4010/4012 compatible terminal (if any)
#                 This is NOT the TEKSRV (Tektronix Server) definition!
#
#    BATCH_OUT    Batch AIPS error file/terminal.
#
#    LPRNTR       Line printer spool directory.  Used by ZLPOPN.
#
#    PLOTTER      Plotter spool directory.  Used by ZLASIO and ZLWIO.
#
#-----------------------------------------------------------------------
#                                       Misc non-version directories
#                                       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#                                       Ionospheric data.
AIPSIONS=$AIPS_ROOT/TEXT/IONS; export AIPSIONS
#                                       Public documents
AIPSPUBL=$AIPS_ROOT/TEXT/PUBL; export AIPSPUBL
#                                       Gripes.  Not for distribution.
AIPSGRIP=$AIPS_ROOT/TEXT/GRIP; export AIPSGRIP
#                                       AIPS user lists.  Ditto.
AIPSWHO=$AIPS_ROOT/TEXT/WHO; export AIPSWHO
#                                       AIPS Star file area
AIPSTARS=$AIPS_ROOT/TEXT/STARS; export AIPSTARS
#                                       AIPS FITS (not user) area.
AIPSFITS=$AIPS_ROOT/BIN/FITS; export AIPSFITS
#                                       Area for fig, etc. files
AIPSFIG=$AIPS_ROOT/TEXT/PUBL/FIG; export AIPSFIG
#                                       HTML files
AIPSHTML=$AIPS_ROOT/TEXT/HTML; export AIPSHTML
#                                       System OFM files.
AIPSOFM=$AIPS_ROOT/TEXT/OFM; export AIPSOFM
#                                       User OFM file area.
OFMFIL=$AIPS_ROOT/OFM; export OFMFIL
#                                       User RUN file area (no override)
if [ "$RUNFIL" = "" ] ; then
  RUNFIL=$AIPS_ROOT/RUN
  export RUNFIL
fi
#                                       PRINT spooling area.
PRTFIL=$AIPS_ROOT/PRINT; export PRTFIL
#                                       PLOT spooling directory.
PLTFIL=$AIPS_ROOT/PLOT; export PLTFIL
#
#                                       System and data areas
#                                       ~~~~~~~~~~~~~~~~~~~~~
NET0=$AIPS_ROOT/DA00; export NET0
#                                       Data root area, normally /DATA
DATA_ROOT=/DEFINE_ME; export DATA_ROOT
DA00=$AIPS_ROOT/DA00/$HOST; export DA00
#                                       These definitions don't get used
#                                       if DADEVS.SH is called (as it is
#                                       from START_AIPS and RUN) unless
#                                       you use "da=default".  To make
#                                       this option work, set these to
#                                       some sensible defaults.
# DA01=$DATA_ROOT/${HOST}_1; export DA01
# DA02=$DATA_ROOT/${HOST}_2; export DA02
# DA03=$DATA_ROOT/${HOST}_3; export DA03
# DA04=$DATA_ROOT/${HOST}_4; export DA04
#                                       FITS disk area.
FITS=$AIPS_ROOT/FITS; export FITS
#                                       Version specific directories
#                                       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#                                       Memory areas.
OLDMEM=$OLD/$ARCH/MEMORY; export OLDMEM
NEWMEM=$NEW/$ARCH/MEMORY; export NEWMEM
TSTMEM=$TST/$ARCH/MEMORY; export TSTMEM
CVXMEM=$CVX/$ARCH/MEMORY; export CVXMEM
#                                       Load areas.
LOAD=$AIPS_VERSION/$ARCH/LOAD; export LOAD
TVLOAD=$LOAD; export TVLOAD
#                                       LIBRDBG area, for DEBUG version
LIBRDBG=$AIPS_VERSION/$ARCH/LIBRDBG; export LIBRDBG
#                                       Pseudo AP areas.
OLDPSAP=$OLD/$ARCH/LOAD/ALT1; export OLDPSAP
NEWPSAP=$NEW/$ARCH/LOAD/ALT1; export NEWPSAP
TSTPSAP=$TST/$ARCH/LOAD/ALT1; export TSTPSAP
CVXPSAP=$CVX/$ARCH/LOAD/ALT1; export CVXPSAP
#                                       Errors area.
ERRORS=$AIPS_VERSION/$ARCH/ERRORS/$HOST; export ERRORS
#                                       System run files.
RUNSYS=$AIPS_VERSION/RUN; export RUNSYS
#
#                                       Device assignments
#                                       ~~~~~~~~~~~~~~~~~~
#                                       (Tapes done in TPDEVS.SH/LIST)
#                                       Set terminal for ZSTRTA.
TASKTT0="`tty 2>/dev/null`"; export TASKTT0
#                                       Printer and plotter definitions.
BATCH_OUT=/dev/console; export BATCH_OUT
LPRNTR=/tmp; export LPRNTR
PLOTTER=/tmp; export PLOTTER
#                                       Number of printers.  Modified by
#                                       PRDEVS.SH (called by START_AIPS)
LPDEVS=1; export LPDEVS
#                                       Host specific definitions
#                                       ~~~~~~~~~~~~~~~~~~~~~~~~~
#                                       Local host specific things
  if [ -f $AIPS_ROOT/LOCALASSN.SH ] ; then
     . $AIPS_ROOT/LOCALASSN.SH
  fi
#                                       below are NRAO spcific as example
#                                       LWPRINTER?, TASKTTn, RESSTTn,
#                                       TEKTKn, TAAC1, and modification
#                                       of any of the foregoing.
if [ "$SITE" = "NRAOCV" -o "$SITE" = VCOARN ] ; then
#                                       NRAO Charlottesville.  These
#                                       definitions are shown here only
#                                       for illustrative purposes.  You
#                                       should delete this section and
#                                       insert definitions appropriate
#                                       for your site.
#                                       --------------------------------
#                                       Architecture-specific details
#                                       For AIX 3.2.5, the following
#                                       changes the behaviour of any
#                                       malloc() calls by ANY
#                                       application.  If this interferes
#                                       with other non-AIPS applications
#                                       in an undesirable way, remove
#                                       this definition and place it in
#                                       the $SYSUNIX/AIPSEXEC file.
#                                       See /usr/lpp/bos/README.PSALLOC.
   if [ "$ARCH" = IBM ] ; then
      PSALLOC="early"; export PSALLOC
#                                       Problem w/SHM on our IBM's...
      if [ "$DISPLAY" != "" ] ; then
         displayhost=`echo $DISPLAY | awk -F: '{print $1}'`
         case $displayhost in
            ""|unix|`hostname`)
               echo "No X11 MIT shared memory (problem with IBM X servers)"
               echo 'AIPStv*useSharedMemory: 0' | xrdb -merge
               ;;
         esac
      fi
   fi
   if [ "$DATA_ROOT" = "/DEFINE_ME" ] ; then
     DATA_ROOT=/DATA; export DATA_ROOT
   fi
#                                       Different place for FITS at AOC.
   PUBFITS=$AIPS_ROOT/FITS; export PUBFITS
   if [ -d $DATA_ROOT/${HOST}_1 ] ; then
      if [ ! -d $DATA_ROOT/${HOST}_1/FITS ] ; then
         if mkdir $DATA_ROOT/${HOST}_1/FITS ; then
            FITS=$DATA_ROOT/${HOST}_1/FITS; export FITS
         else
            echo "AIPSASSN: Tried to create $DATA_ROOT/${HOST}_1/FITS area, failed."
            echo "AIPSASSN: Using $DATA_ROOT/${HOST}_1 itself instead."
            FITS=$DATA_ROOT/${HOST}_1; export FITS
         fi
      else
      FITS=$DATA_ROOT/${HOST}_1/FITS; export FITS
    fi
  fi
#
#
elif [ "$SITE" = NRAOAOC -o "$SITE" = COAOARN ] ; then
#                                       NRAO Array Ops Ctr, Socorro, NM.
#                                       Turn on MSGSRV unless it's set
#                                       already.  Site Preference.
   if [ "$AIPS_MSG_EMULATOR" = "" ] ; then
      AIPS_MSG_EMULATOR=xterm; export AIPS_MSG_EMULATOR
   fi
   if [ "$DATA_ROOT" = "/DEFINE_ME" ] ; then
     DATA_ROOT=/DATA; export DATA_ROOT
   fi
#                                       ONLINE logical for AOC
   ONLINE=$AIPS_ROOT/online/$ARCH; export ONLINE
#                                       Different place for FITS at AOC.
   if [ -d $DATA_ROOT/${HOST}_1 ] ; then
      if [ ! -d $DATA_ROOT/${HOST}_1/FITS ] ; then
         if mkdir $DATA_ROOT/${HOST}_1/FITS ; then
            FITS=$DATA_ROOT/${HOST}_1/FITS; export FITS
         else
            echo "AIPSASSN: Tried to create $DATA_ROOT/${HOST}_1/FITS area, failed."
            echo "AIPSASSN: Using $DATA_ROOT/${HOST}_1 itself instead."
            FITS=$DATA_ROOT/${HOST}_1; export FITS
         fi
      else
      FITS=$DATA_ROOT/${HOST}_1/FITS; export FITS
    fi
  fi
#
elif [ "$SITE" = NRAOVLA -o "$SITE" = ALVOARN  ] ; then
#                                       NRAO Array Ops Ctr, Socorro, NM.
#                                       Turn on MSGSRV unless it's set
#                                       already.  Site Preference.
  if [ "$AIPS_MSG_EMULATOR" = "" ] ; then
    AIPS_MSG_EMULATOR=xterm; export AIPS_MSG_EMULATOR
  fi
  if [ "$DATA_ROOT" = "/DEFINE_ME" ] ; then
    DATA_ROOT=/DATA; export DATA_ROOT
  fi
#                                       OPERATIONS area.
  OPER=/home/banshee/operations/tapelog; export OPER
#                                       ONLINE definition for VLA
  ONLINE=$AIPS_ROOT/online/${ARCH}; export ONLINE
  VISDATADIR=/home/vis-serv/vladata; export VISDATADIR
#                                       FITS definition
#                                       Different place for FITS at AOC.
  if [ -d $DATA_ROOT/${HOST}_1 ] ; then
    if [ ! -d $DATA_ROOT/${HOST}_1/FITS ] ; then
      if mkdir $DATA_ROOT/${HOST}_1/FITS ; then
         FITS=$DATA_ROOT/${HOST}_1/FITS; export FITS
      else
        echo "AIPSASSN: Tried to create $DATA_ROOT/${HOST}_1/FITS area, failed."
        echo "AIPSASSN: Using $DATA_ROOT/${HOST}_1 itself instead."
        FITS=$DATA_ROOT/${HOST}_1; export FITS
      fi
    else
      FITS=$DATA_ROOT/${HOST}_1/FITS; export FITS
    fi
  fi
#                                       Host-specific things.  This
#                                       particular one is left in as an
#                                       example of how to have alternate
#                                       load areas and hardwired AIPS1,
#                                       AIPS2, etc. and graphics
#                                       terminals.
  if [ "$HOST" = YUCCA ] ; then
#                                       Note LOAD4 area for CVEX only....
    LOAD4=$AIPS_VERSION/$ARCH/LOAD/ALT4; export LOAD4
#                                       Reserved terminals etc.  AIPS1:
#                                       terminal on tty0c, iis tv, tek
#                                       graphics terminal on tty0e
    RESSTT1=/dev/tty0c; export RESSTT1
       TVTT1=yucca+iis; export TVTT1
    TEKTK01=/dev/tty0e; export TEKTK01
#                                       AIPS2: terminal on tty0d, ivas
#                                       tv, tek same as AIPS1.
    RESSTT2=/dev/tty0d; export RESSTT2
       TVTT2=yucca+iis; export TVTT2
    TEKTK02=/dev/tty0e; export TEKTK02
#                                       define obsolete TVDEV1 def'n for
#                                       dicomed software.
    TVDEV1=/dev/iis; export TVDEV1
#
  fi
#                                       CfA
elif [ "$SITE" = CFA ] ; then
#                                       Turn off MSGSRV unless it's set
#                                       already.  Site Preference.
   if [ "$AIPS_MSG_EMULATOR" = "" ] ; then
      AIPS_MSG_EMULATOR=none; export AIPS_MSG_EMULATOR
   fi
#
fi
#                                       End of AIPSASSN.SH

#!/bin/sh
#-----------------------------------------------------------------------
#;  Copyright (C) 1995, 2004
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
#-----------------------------------------------------------------------
# PRDEVS.SH -- Define AIPS Printer devices
#-----------------------------------------------------------------------
# This file will do one of two things.  If LPDEV is set to a numeric
# value, it sets the AIPS printer variables LPDEVn, LPDESCn, LPOPTn, and
# LPTYPEn to the appropriate values for n (if it is in range).
# Otherwise, it sets all variables as with older AIPS versions for
# backwards compatibility.
#
# You should NOT need to modify this file.  If there's something wrong
# with it, let us know (email to aipsmail@nrao.edu is best).
#
# The information on the printers is now in the PRDEVS.LIST file in the
# $AIPS_ROOT/DA00 directory.  See the comments therein for details.
#-----------------------------------------------------------------------
if [ "$AIPS_ROOT" = "" ] ; then
  echo "PRDEVS: cannot proceed, AIPS_ROOT not defined"
elif [ ! -f $AIPS_ROOT/DA00/PRDEVS.LIST ] ; then
  echo "PRDEVS: cannot proceed, $AIPS_ROOT/DA00/PRDEVS.LIST not found"
else
#                          Set filename, no. of printers
  PRF=$AIPS_ROOT/DA00/PRDEVS.LIST
  LPDEVS=`grep '^[^# ]' $PRF | wc -l`
  LPDEVS=`eval echo $LPDEVS`
  if [ "$LPDEVS" = "0" ] ; then
    echo "PRDEVS: cannot proceed, no printers found in $PRF"
  elif [ "$LPDEV" != "" ] ; then
    case $LPDEV in
#                          Printer number selected.
      [0-9]*)
        if [ \( $LPDEV -ge 1 \) -a \( $LPDEV -le $LPDEVS \) ] ; then
          k=`grep '^[^# ]' $PRF | awk '(NR == '$LPDEV') {print $0}'`
          eval "LPDEV$LPDEV=`echo $k | awk '{print $1}'`"
          export LPDEV$LPDEV
          eval "LPTYPE$LPDEV=`echo $k | awk '{print $2}'`"
          export LPTYPE$LPDEV
          eval "LPOPT$LPDEV=`echo $k | awk '{print $3}'`"
          export LPOPT$LPDEV
          desc=`echo $k | awk '{for (j=4; j<=NF; j++) printf "%s ", $j}'`
          eval "LPDESC$LPDEV=\"$desc\""; export LPDESC$LPDEV
        else
          echo "PRDEVS: Printer $LPDEV not in range 1-$LPDEVS"
        fi
      ;;
      *) echo "PRDEVS: unexpected value for LPDEV: \"$LPDEV\""
      ;;
    esac
  else
#                          Compatibility mode with old way.
#                          Just set everything in sight.
    i=1
    grep '^[^# ]' $PRF | awk '
    BEGIN {printf "#!/bin/sh\n"}
    {
      printf "LPDEV%d=%s; export LPDEV%d\n",NR,$1,NR;
      printf "LPTYPE%d=%s; export LPTYPE%d\n",NR,$2,NR;
      printf "LPOPT%d=\"%s\"; export LPOPT%d\n",NR,$3,NR;
      printf "LPDESC%d=\"",NR;
      for (j=4; j<=NF; j++) {
        printf "%s ", $j;
      }
      printf "\"; export LPDESC%d\n",NR;
    }
    $3 ~ /.*DEF.*/ { printf "LPDEV=LPDEV%d; export LPDEV\n",NR; }
    END { printf "LPDEVS=%d; export LPDEVS\n",NR}' >/tmp/AIPS.PRDEV.$$
    chmod +x /tmp/AIPS.PRDEV.$$
    . /tmp/AIPS.PRDEV.$$
    rm -f /tmp/AIPS.PRDEV.$$
  fi
fi
#                                       Check for BIG printer...
BIGPRINT=`grep '^[^# ]' $PRF | awk '($3 ~ /BIG=/) { print NR}' | head -n 1`
[ "$BIGPRINT" != "" ] && export BIGPRINT
#                          End of PRDEVS.SH

#!/bin/bash
#-----------------------------------------------------------------------
#;  Copyright (C) 2015-2016, 2019-2020
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
#  Uses sudo to make links to AIPS Intel libraries and X11 libraries
#  in /usr/local/lib for MAC OS 10.11 (El Capitan) which no longer
#  allows DYLD_LIBRARY_PATH.  This is also true of all later revs.

if [ "$USER" = 'root' ]; then
    echo "Please run this script as your normal (admin) user - "
    echo "do not use 'sudo'"
    exit 1
fi
if [ -z "${AIPS_VERSION}" ]; then
    echo "AIPS env not found - did you source your AIPS LOGIN.SH first?" >&2
    exit 1
fi

cat << EOH

This script will attempt to configure an existing AIPS installation
to work properly under OS X 10.11 "El Capitan" and later versions.
You will be prompted for your password so that several commands
can be run as root.

Press enter to continue...
EOH
read foo

if ! sudo mkdir -p /usr/local/lib ; then
    echo "Unable to create /usr/local/lib - do you have admin (sudo) privileges?" >&2
    exit 1
fi

numlibs=0
if [ -d "${AIPS_VERSION}/MACINT" ]; then
#   if sudo ln -sf "${AIPS_VERSION}/MACINT/LIBR/INTELCMP/libsvml.dylib" "/usr/local/lib/libsvml.dylib" ; then
#       numlibs=$((numlibs+1))
#   fi
#   if sudo ln -sf "${AIPS_VERSION}/MACINT/LIBR/INTELCMP/libimf.dylib" "/usr/local/lib/libimf.dylib" ; then
#       numlibs=$((numlibs+1))
#   fi
#   if sudo ln -sf "${AIPS_VERSION}/MACINT/LIBR/INTELCMP/libintlc.dylib" "/usr/local/lib/libintlc.dylib" ; then
#       numlibs=$((numlibs+1))
#   fi
#   if sudo ln -sf "${AIPS_VERSION}/MACINT/LIBR/INTELCMP/libirc.dylib" "/usr/local/lib/libirc.dylib" ; then
#       numlibs=$((numlibs+1))
#   fi
   if sudo ln -sf "${AIPS_VERSION}/MACINT/LIBR/INTELCMP/libgfortran.3.dylib" "/usr/local/lib/libgfortran.3.dylib" ; then
       numlibs=$((numlibs+1))
   fi
   if sudo ln -sf "${AIPS_VERSION}/MACINT/LIBR/INTELCMP/libgcc_s.1.dylib" "/usr/local/lib/libgcc_s.1.dylib" ; then
       numlibs=$((numlibs+1))
   fi
   if sudo ln -sf "${AIPS_VERSION}/MACINT/LIBR/INTELCMP/libquadmath.0.dylib" "/usr/local/lib/libquadmath.0.dylib" ; then
       numlibs=$((numlibs+1))
   fi
#    for lib in "${AIPS_VERSION}/"MACINT/LIBR/INTELCMP/*.dylib; do
#        if sudo ln -sf "$lib" "/usr/local/lib/$(basename $lib)" ; then
#	    numlibs=$((numlibs+1))
#	fi
#    done
else
    echo "ERROR: AIPS for MACINT not found at $AIPS_VERSION" >&2
    exit 1
fi

#               if wrong Xquartz try
#if sudo ln -s "/usr/X11/lib/libX11.6.dylib" "/usr/local/lib/libX11.6.dylib" ; then
#    numlibs=$((numlibs+1))
#fi
#if sudo ln -s "/usr/X11/lib/libXext.6.dylib" "/usr/local/lib/libXext.6.dylib" ; then
#    numlibs=$((numlibs+1))
#fi

xversion=$(defaults read /Applications/Utilities/XQuartz.app/Contents/Info.plist CFBundleShortVersionString)
if [ $? -ne 0 ] ; then
    echo "Error reading XQuartz version. Make sure that XQuartz 2.7.8 or greater is installed" >&2
    exit 1
fi

compver=$( echo $xversion | awk -F. '{ printf("%d%03d%03d", $1,$2,$3); }' )
if [ $compver -lt 2007008 ] ; then
    echo "Error: XQuartz $compver is too old. Upgrade to 2.7.8 or later!" >&2
    exit 1
else
    # Ensure X11 and X11R6 links are present in /usr
    sudo /usr/libexec/x11-select /opt/X11
fi

if [ $numlibs -eq 3 ]; then
    cat << EOS

Three AIPS shared libraries were linked to /usr/local/lib.
Your installation should now be fixed to operate under OS X 10.11-15.

EOS
else
    cat << EOF

$numlibs libraries were linked to /usr/local/lib instead of
the expected three.  Something may have gone wrong, or your
installation may have already been fixed.

EOF
    exit 1
fi

exit 0

#-----------------------------------------------------------------------
#;  Copyright (C) 1995, 1997, 1999
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# Usage: . LDOPTS.SH
#--------------------------------------------------------------------
# Bourne shell commands is used to define the environment variables
# used by $SYSUNIX/LINK.  These include 1) command name for the host
# Fortran compiler (e.g., f77), 2) compiler/loader oriented AIPS-
# style options in terms of the host compiler/loader syntax (e.g.,
# DEBUG="-g"), and 3) locally desired defaults for the non-compiler/
# loader oriented AIPS-style options (e.g., LIST=FALSE).  Both
# compiler/loader and non-compiler/loader oriented options can be
# toggled in $SYSUNIX/LINK by the use of 'option' (e.g., DEBUG) or
# 'NOoption' (e.g., NOMAP) command line arguments to $SYSUNIX/LINK
# or $SYSUNIX/COMLNK which invokes $SYSUNIX/LINK.
#
# NOTE: These are options for linking ONLY (see definition of
#       the environment variable 'LINK' below).  Options applicable
#       to compiling are defined in the $SYSLOCAL files ASOPTS.SH,
#       CCOPTS.SH and FCOPTS.SH (for assembler, 'C' and Fortran
#       compilations, respectively).
#
# HP-UX version.  Does not use POSIX fort77 yet.
#--------------------------------------------------------------------

# Define the host Fortran compiler command name (e.g., f77, fortran,
# fc, etc.).  We invoke the compiler to perform links instead of the
# loader (e.g., 'ld').  Using the loader directly can be messy.

COMPILER="f77"

# Define the $SYSUNIX/LINK AIPS-style compiler oriented options in
# terms of the host Fortran compiler command syntax.

#                                       Any loader option(s) that may
#                                       enhance or may be required for
#                                       the usage of host debuggers.
DEBUG="-g"
NOOPT=""
#                                       Host compiler option(s) for
#                                       defaulting variable/constant
#                                       declarations (this has no
#                                       meaning for the link process).
DIRTY=""
#                                       Host loader option to generate
#                                       a link map.
MAP=""
#                                       Host compiler option(s) for
#                                       various optimization levels
#                                       (this has no meaning for the
#                                       link process.
OPT0=""
OPT1=""
OPT2=""
OPT3=""
OPT4=""
OPT5=""
OPT6=""
OPT7=""
OPT8=""
OPT9=""
#                                       Host loader option for
#                                       execution profiling.
PROFILE="-I"

# Set default loader oriented options applicable to all links.
# These can be either the environment variables defined above or
# hard coded host loader options.
# HP: +ppu means externs have underscore prepended.  This is VITAL.
# HP: if you encounter ANY problems, ADD $DEBUG HERE!!!!
# HP: +U77 to get the getarg() module included (HLPB uses this)

# LINK="-v $DEBUG +ppu"`  use me if there are problems...
LINK="-v +ppu +U77"

# Set default values for other (i.e., non-compiler/loader oriented)
# options.  These are purely a matter of preference, however the
# default settings exported with the UNIX/AIPS installation kits
# seem to make the most sense.

#                                       Generate source code listing
#                                       (this has no meaning for the
#                                       link process).
LIST=FALSE
#                                       Purge, that is, delete any .o
#                                       and .LOG files associated with
#                                       the module after a sucessful
#                                       link.
PURGE=FALSE
#                                       Replace the resulting
#                                       executable module in $LOAD.
REPLACE=TRUE
#                                       Remove symbol table to save space
STRIP=TRUE
#                                       Save old copy of .EXE first and
#                                       then delete it; avoid bus errors
#                                       this way on running tasks.
SAVE=TRUE
#                                       End

#!/bin/csh
#-----------------------------------------------------------------------
#;  Copyright (C) 1995, 1998, 2001
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# Usage: source CDVER.CSH
#-----------------------------------------------------------------------
# This file is used to establish the AIPS programming area logicals
# (environment variables) as defined in $SYSUNIX/AREAS.CSH (created
# from $SYSAIPS/AREAS.DAT by the $SYSUNIX/AREAS script) or toggle
# these definitions between different AIPS versions (i.e., OLD, NEW
# and TST).  Normally, it is only used by the environment variables
# $CDOLD, $CDNEW and $CDTST.  Area logicals for local directories
# should be defined here, not in $SYSUNIX/AREAS.CSH.  This includes
# any directories containing local Q, Y or Z routines.  It also
# toggles the search path for executables (i.e., $PATH) to include
# the directories $SYSLOCAL and $SYSUNIX.
#
# Generic C shell version.
#--------------------------------------------------------------------
#                                       Define/redefine standard AIPS
#                                       programming logicals.
source $AIPS_ROOT/AIPSPATH.CSH
source $SYSUNIX/AREAS.CSH
setenv UPDATE $AIPS_VERSION/$ARCH/UPDATE
#                                       Define any local area logicals
#                                       here (e.g., Q, Y or Z-routine
#                                       directories).  For example,
#
#                                       setenv QLOCAL $QPSAP/LOCAL
#                                       setenv YLOCAL $YIVAS/LOCAL
#                                       setenv ZLOCAL $APLSUN/LOCAL
#
#                                       Be sure to include your local
#                                       area logicals in your
#                                       $SYSLOCAL/LIBR.DAT directory
#                                       search paths.
#
#                                       Display AIPS version.
echo AIPS_VERSION=$AIPS_VERSION

#!/bin/sh
#-----------------------------------------------------------------------
#! Format Encapsulated PostScript (TM) for a 35mm Color Slide printer
## Shell-script
#-----------------------------------------------------------------------
#;  Copyright (C) 1995
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
#-----------------------------------------------------------------------
# This procedure assumes "xgrab" encapsulated PostScript (PS) output.
# The PS is rotated and fills a 35 mm slide image with a zoomed and
# centered rendition of a postscript file.  The slide is assumed to have
# an aspect ratio of 2 to 3 and that the maximum width is 800 units.
# The background of the slide is made black.
#
# A critical assumption is that the PS file contains a line with three
# elements, 1) x size, 2) y size and 3) the word "scale".  When this
# line is found, the PS is modified else the PS file is passed
# unchanged.
#
# Usage: as a filter, e.g. cat <file> | LANDEPS.SH | lpr -Pps35mm
#--------------------------------------------------------------------
#                                       Only modify the scale once
ONCE=0
#                                       For each non comment line:
while read line ; do
#                                       if have not found scaling
   if [ "$ONCE" = "0" ] ; then
#                                       General way of getting params
      set - $line
#                                       translate file or logical name
      THIRD=`eval echo $3`
#                                       if this is the scale line
      if [ "$THIRD" = "scale" ] ; then
         echo %% begin inserted rescaling
         echo %% $line
#                                       make background black
         echo /ymax 800 def          /xmax 533 def

         echo newpath 0 0 moveto
         echo 0 ymax rlineto xmax 0 rlineto
         echo 0 ymax -1 mul rlineto xmax -1 mul 0 rlineto
         echo closepath fill
#                                       determine landscape or port.
         FIRST=`eval echo $1`
         SECOND=`eval echo $2`
         echo /xsize $FIRST def       /ysize $SECOND def
         echo /xlim xmax .95 mul def  /ylim ymax .95 mul def
         if [ $FIRST -lt $SECOND ] ; then
#                                       higher than wide, use port.
            echo /xfact xsize xlim div def
            echo /yfact ysize ylim div def
#                                       chose max factor
            echo /xyfact xfact yfact gt {xfact} {yfact} ifelse def
            echo /xscal xsize xyfact div def
            echo /yscal ysize xyfact div def
            echo /xtran xmax xscal sub 2 div def
            echo /ytran ymax yscal sub 2 div def
            echo xtran ytran translate xscal yscal scale
         else
#                                       wider than high use land
            echo /xfact xsize ylim div def
            echo /yfact ysize xlim div def
#                                       chose max factor
            echo /xyfact xfact yfact gt {xfact} {yfact} ifelse def
            echo /xscal ysize xyfact div def
            echo /yscal xsize xyfact div def
            echo /xtran xmax xmax xscal sub 2 div sub def
            echo /ytran ymax yscal sub 2 div def
            echo xtran ytran translate xscal yscal scale 90 rotate
            fi
         echo %% end inserted rescaling
#                                       flag scaling is done
         ONCE=1
      else
#                                       else just print other lines
         echo $line
      fi
   else
      echo $line
   fi
done

#-----------------------------------------------------------------------
#;  Copyright (C) 1995-1998, 2001-2004, 2013, 2022
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# Usage: . TVDEVS.SH
#-----------------------------------------------------------------------
# Define TV devices and if necessary, start TV servers.
#
# The HOSTS.LIST file specifies which hosts are TV servers, displays.
# This script reads that file and does one of the following:
#
#   *** if the TVOPT environment variable is defined but is not valid,
#       it will be reset to "NONE" before the script exit.
#
#   *** if the TVOPT environment variable is defined and is valid, the
#       appropriate values of TVHOST, TVDISP, TVALT, TVDEV, TVDEVxx,
#       TKDEV, TKDEVxx, TTDEV, and TTDEVxx  will be returned.
#
# A more detailed description of the variables to be set follows:
#
#    TVHOST  Host on which the TV server is to be run, or the host with
#            the hardware tv physically connected to it.  Generated
#            automatically from HOSTS.LIST (hosts with a "+" in col. 1)
#
#    TVDISP  Host on which the TV server is to be displayed (X11), or
#            the hardware device name.
#
#    TVALT   translates to TVALTyz where the "y" digit identifies a
#            possible alternate load area LOADy (now rarely used so this
#            is almost always 0), and the "z" digit identifies the
#            windowing server type (anymore always set to 3 for X11).
#            The original meanings for x and y are:
#             * TVALT00: no windowing system is currently running
#               TVALT01: Sunview/Suntools Screen Server (SSS, obsolete)
#               TVALT02: XView Screen Server (XVSS; also obsolete)
#             * TVALT03: X11 AIPS TV Server (XAS)
#               TVALT04: Hardwired TV that uses default $LOAD binaries
#               TVALT24: As above, use alternate $LOAD2 binaries
#               TVALT44: Likewise except $LOAD4.
#            Information on hard-wired TV's such as the IIS or IVAS or
#            DeAnza must be added here in TVHOSTS and TVALT (note that
#            the latter is now deprecated and unused; this may render
#            such devices unusable).  Asterisks indicate the only
#            values which are likely to work.
#
#    TVDEV   translates to TVDEVxx where xx is the (ehex) TV number.
#
#    TVDEVxx translates to the name of the TV device which has extended
#            hexadecimal unit number xx.  The TV device number
#            corresponds to the order in which the server appears in the
#            TVHOSTS environment variable, i.e. in the HOSTS.LIST file.
#
#    TKDEV   translates to TKDEVxx where xx is the (ehex) TV number.
#
#    TKDEVxx translates to the name of the graphics device which has
#            extended hex number xx.  The TK device number assigned is
#            the same as the TV device number.
#
#    TTDEV   translates to TTDEVxx where xx is the (ehex) TV number.
#
#    TKDEVxx translates to the name of the message window.  The TT
#            device number assigned is the same as the TV device number.
#
#    TVLOK   translates to TVLOKxx where xx is the (ehex) TV number.
#
#    TVLOKxx translates to the name of the lockfile used when using Unix
#            sockets for the TV Lock daemon (TVSERV.EXE, TVSRVx).
#
#    TVN     The Unix socket number to use if relevant.
#
#    AIPSTVS Number of AIPS TVs (TVHOSTS plus TVSERVS)
#
# NOTE: If $AIPS_ROOT/STARTING_TV_NUMBER exists and contains a non-zero
# number, that is taken as the starting TV number for Unix sockets.
# This is for compatibility with earlier multiple TV schemes.
#-----------------------------------------------------------------------
#                                       See 15OCT97 or older versions
#                                       for what this was used for.
TVALTS=""
# -------------- do not change anything below this line ----------------
#
ni2() {
  if [ "`echo -n YES`" = "YES" ] ; then
    echo -n "TVDEVS.SH: $*"
  else
    echo "TVDEVS.SH: $*\c"
  fi
}
ei2() {
  echo "TVDEVS.SH: $*"
}
spc() {
  echo " "
}

#                                       The following will get the
#                                       regular hosts, tv servers and x
#                                       terminals from HOSTS.LIST.
TVHOST2=`grep '^[+]  .*' $AIPS_ROOT/HOSTS.LIST | grep $SITE | \
         awk '{print $2}' | tr '[A-Z]' '[a-z]'`
TVSERVS=`grep '^[-]  .*' $AIPS_ROOT/HOSTS.LIST | grep $SITE | \
         awk '{print $2}' | tr '[A-Z]' '[a-z]'`
XTERMS=`grep '^[=]  .*' $AIPS_ROOT/HOSTS.LIST  | grep $SITE | \
         awk '{printf "%s:%s\n",$2,$5}' | tr '[A-Z]' '[a-z]'`
#                                       No blank at beginning of string
if [ "$TVHOSTS" != "" ] ; then
   TVHOSTS="$TVHOSTS $TVHOST2"
else
   TVHOSTS="$TVHOST2"
fi
AIPSTVS=`echo $TVHOSTS $TVSERVS | wc -w`
#                                       Export everything we can now.
export TVOPT TVHOST TVDISP TVALT TVDEV TKDEV TTDEV AIPSTVS TVN
export TVDEV TTDEV TKDEV TVLOK
#
#                                       Set default values.
TVALT=TVALT00
TVDEV=TVDEV00
TKDEV=TKDEV00
TTDEV=TTDEV00
TVLOK=TVLOK00
#                                       Only do rest if TV is defined
if [ "$TVOPT" != "" ] ; then
#                                       If $TVOPT is "HELP", be kind
#                                       This actually never happens...
  if [ "$TVOPT" = "HELP" ] ; then
    TVOPT="NONE"
    ei2 "You can choose any of the following TV servers or devices."
    spc
    for tv in $TVHOSTS $XTERMS ; do
      case $tv in
        *:*) ei2 "  $tv        (display machine : aips machine)"
             ;;
        *+*) ei2 "  $tv        (hostname + hardware TV device name)"
             ;;
        *)   ei2 "  $tv        (workstation)"
             ;;
      esac
    done
    spc
    ni2 "Enter your choice: "
    read TVOPT
  fi
#                                       Resolve hardwire TV aliases.
  for tvhost in $TVHOSTS ; do
    case $tvhost in
      *+${TVOPT})
        TVOPT=$tvhost
        break;;
    esac
  done
#                                       Check for brainless displays.
  for xterm in $XTERMS ; do
    case $xterm in
      ${TVOPT}:*)
        TVOPT=$xterm
        break;;
    esac
  done
#                                       Parse TVOPT into TVHOST & TVDISP
  case $TVOPT in
    *:)
      TVHOST=`$AIPS_ROOT/SETNAME`
      TVDISP=`echo $TVOPT | sed -e 's/:.*//'`
      TVOPT=${TVDISP}:${TVHOST}
      ;;
#                                       Should never happen, but...
    :*)
      TVHOST=`echo $TVOPT | sed -e 's/://'`
      TVDISP=`$AIPS_ROOT/SETNAME`
      TVOPT=${TVDISP}:${TVHOST}
      ;;
    *:*)
      TVHOST=`echo $TVOPT | sed -e 's/.*://'`
      TVDISP=`echo $TVOPT | sed -e 's/:.*//'`
      TVOPT=${TVDISP}:${TVHOST}
      ;;
    *+*)
      TVHOST=`echo $TVOPT | sed -e 's/+.*//'`
      TVDISP=`echo $TVOPT | sed -e 's/.*+//'`
      TVOPT=${TVHOST}+${TVDISP}
      ei2 "Your hardware (non-workstation) TV is $TVOPT"
      ;;
    *)
      TVHOST="$TVOPT"
      TVDISP="$TVOPT"
      TVOPT=${TVDISP}:${TVHOST}
      ;;
  esac
#                                       Ensure we have a valid TVHOST.
#                                       but skip it if TVHOST=NONE and
#                                       hope there's no NONE.nrao.edu!
  if [ "$TVHOST" = NONE ] ; then
    stat=0
  else
    echo "$TVHOSTS" "$TVSERVS" | grep "$TVHOST" >/dev/null
    stat=$?
  fi
  if [ $stat -ne 0 ] ; then
    if [ "$USEUNIXSOCK" = YES ] ; then
      ei2 "Local TV assigned on $TVHOST for display $DISPLAY"
    elif [ "$TVHOST" = "$TVDISP" ] ; then
      ei2 "Remote TV assigned for TVHOST $TVHOST  ***"
    else
      ei2 "Unrecognized TVHOST; $TVHOST"
    fi
  fi
#                                       Determine TVALT.
  if [ "$TVHOST" != "NONE" ] ; then
    case $TVOPT in
      *:*)
#                                       Colon implies X11 so use XAS.
           TVALT=TVALT03;;
      *+*)
#                                       Hardwired TV.
#                                       Resolve load number from TVALTS
        found=false
        if [ "$TVALTS" != "" ] ; then
          for tvalt in $TVALTS ; do
            digit=`echo $tvalt | awk -F: '{print $2}'`
            if [ "$TVDISP" = "`echo $tvalt | awk -F: '{print $1}'`" ]
            then
              found=true
              break
            fi
          done
          if [ "$found" = true ] ; then
            TVALT="TVALT${digit}4"
          else
            ei2 "There is no entry in TVALTS (TVDEVS.SH) for $TVOPT"
            ei2 "TV related items may not work..."
            TVALT=TVALT04
          fi
        else
#                                       TVALTS not set, assume default
#                                       LOAD.
          TVALT=TVALT04
        fi
        ;;
    esac
#                                       Decode the TV number.
    tvnum=1
#                                       Need to look at full TVOPT for
#                                       hardwired TV's
    tvh=$TVHOST
    case $TVOPT in
      *+*) tvh=$TVOPT;;
    esac
    for tvhost in $TVHOSTS $TVSERVS ; do
      [ "$tvh" = "$tvhost" ] && break
      tvnum=`expr $tvnum + 1`
    done
#                                       Allocate a TV device number.
    tvhex=`EHEX $tvnum`
    case $tvhex in
      [0-9A-Z]) tvhex="0$tvhex";;
    esac
    TVDEV=TVDEV$tvhex
    [ "$DEBUG" = YES ] && \
     ei2 "Debug: TV number initially set to $tvnum ($tvhex)"
#                                       Set device or service name.  If
#                                       a real device, it must be of the
#                                       form "/dev/foo" and "foo" must
#                                       be what appears after the "+" in
#                                       the TV name.
    case $TVALT in
      TVALT?4)
        eval "$TVDEV=/dev/$TVDISP"
        eval "export $TVDEV";;
#                                       TV Servers.  Unix or Inet?
      *)
        if [ "$USEUNIXSOCK" = YES ] ; then
          [ "$AIPSTMP" = "" ] && AIPSTMP=/tmp
#                                       Multiple Unix sockets allowed.
#                                       Figure out which one to use.
          TVN=0
          TVD=""
          if [ "$UNIXTVN" != "0" ] ; then
             OTH=`ls $AIPSTMP/XAS.${UNIXTVN}.* \
                     $AIPSTMP/LOK.${UNIXTVN}.* \
                     $AIPSTMP/TKS.${UNIXTVN}.* \
                     $AIPSTMP/MSS.${UNIXTVN}.* \
                  2>/dev/null | awk -F\. '{print $NF}' | head -n 1`
             if [ "$OTH" != "" ] ; then
                if [ "$ARCH" = "MACINT" ] ; then
                   ei2 "I am assuming the display is what you want"
                   TVD=$UNIXTVN
                elif [ "$ARCH" = "MACARM" ] ; then
                   ei2 "I am assuming the display is what you want"
                   TVD=$UNIXTVN
                elif [ "$OTH" != "$TVDISP" ] ; then
                   ei2 "Sorry, UNIX TV $UNIXTVN in use on display $OTH"
                   ei2 "Will assume you want first available slot"
                else
                   TVD=$UNIXTVN
                fi
             else
                TVD=$UNIXTVN
             fi
             [ "$DEBUG" = YES ] && ei2 "accepting usock number $TVD"
          elif [ "$NEWUNIXSOCK" != YES ] ; then
#                                       See if there's a socket for this
#                                       display already created.  If so,
#                                       use the first available one.
            [ "$DEBUG" = YES ] && ei2 "scanning $AIPSTMP/---.n.$TVDISP"
            TVD=`ls  $AIPSTMP/XAS.?.$TVDISP \
                     $AIPSTMP/LOK.?.$TVDISP \
                     $AIPSTMP/TKS.?.$TVDISP \
                     $AIPSTMP/MSS.?.$TVDISP 2>/dev/null | \
           sed -e "s,$AIPSTMP/[A-Z][A-Z][A-Z]\.\([A-Z0-9]\)\..*,\1,g" | \
                 sort | head -n 1`
            [ "$DEBUG" = YES ] && ei2 "done.  TVD=$TVD"
          else
            TVD=""
          fi
          if [ "$TVD" = "" ] ; then
#                                       Find first free slot for socket.
            [ "$DEBUG" = YES ] &&
             ei2 "no existing socket for $TVDISP, scan..."
            i=1
            if [ -s $AIPS_ROOT/STARTING_TV_NUMBER ] ; then
	       j=`head -n 1 $AIPS_ROOT/STARTING_TV_NUMBER`
               if [ "$j" != "" ] ; then
                  if [ $j -lt 36 -a $j -gt 0 ] ; then
                      i=$j
                  fi
               fi
            fi
            while [ $i -lt 36 ] ; do
              ei=`EHEX $i`
#                                       Not safe for collisions
              OTH=`ls $AIPSTMP/XAS.${ei}.* \
                      $AIPSTMP/LOK.${ei}.* \
                      $AIPSTMP/TKS.${ei}.* \
                      $AIPSTMP/MSS.${ei}.* 2>/dev/null | head -n 1`
              if [ "$OTH" = "" ] ; then
                TVN=$ei
                [ "$DEBUG" = YES ] && ei2 "first free slot is $TVN"
                break
              fi
              i=`expr $i + 1`
            done
#           if [ $TVN -eq 0 ] ; then
            if [ `REHEX $TVN` -eq 0 ] ; then
              ei2 "No free socket slots left!"
              exit 1
            fi
          else
            [ "$DEBUG" = YES ] && ei2 "found existing $TVD socket"
            TVN=$TVD
          fi
	  tvn=`REHEX $TVN`
          tvn=`expr $tvn + $AIPSTVS`
          tvhex=`EHEX $tvn`
          case $tvhex in
            [0-9A-Z]) tvhex="0$tvhex";;
          esac
          TVDEV=TVDEV$tvhex
          TKDEV=TKDEV$tvhex
          TTDEV=TTDEV$tvhex
          TVLOK=TVLOK$tvhex
          eval "$TVDEV=$AIPSTMP/XAS.$TVN.$TVDISP"
          eval "$TTDEV=$AIPSTMP/MSS.$TVN.$TVDISP"
          eval "$TKDEV=$AIPSTMP/TKS.$TVN.$TVDISP"
          eval "$TVLOK=$AIPSTMP/LOK.$TVN.$TVDISP"
          eval "export $TVDEV $TTDEV $TKDEV $TVLOK"
          if [ "$DEBUG" = YES ] ; then
            ni2  "Unix Sockets, overriding TVDEV to be "
            echo "$TVDEV ($AIPSTVS + $TVN = $tvn [$tvhex])"
            ni2 "                                and $TVDEV to be "
            eval "echo \$$TVDEV"
            ni2 "                                and $TKDEV to be "
            eval "echo \$$TKDEV"
            ni2 "                                and $TTDEV to be "
            eval "echo \$$TTDEV"
            ni2 "                                and $TVLOK to be "
            eval "echo \$$TVLOK"
          fi
        else
#                                       Allow for buffered I/O
#                                       This never worked well... needs
#                                       an overhaul?
          socket="sssin"
          [ "$AIPS_TV_BUFFERED" = "YES" ] && socket="sssinb"
#
          eval "TVDEV$tvhex=${socket}:$TVHOST"
          eval "export $TVDEV"
        fi;;
    esac
#                                       Graphics/Message assignment for
#                                       TEKSERVER and MSGSERVER.
    if [ "$USEUNIXSOCK" != YES ] ; then
      TKDEV=TKDEV$tvhex
      eval "$TKDEV=$TVHOST"
      eval "export $TKDEV"
      TTDEV=TTDEV$tvhex
      eval "$TTDEV=$TVHOST"
      eval "export $TTDEV"
#                                       How come TVLOK doesn't need to
#                                       be set for INET sockets?
    fi
  fi
fi

#!/usr/bin/echo you_need_to_dot_this_file
#-----------------------------------------------------------------------
#;  Copyright (C) 1995-1996, 1998, 2000-2020, 2022-2023
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# Usage: . AIPSPATH.SH
#-----------------------------------------------------------------------
# AIPSPATH defines the version of AIPS in use and redefines $PATH to
# include the AIPS system directories.  It also defines the AIPS
# programmer version selection macro environment variables.
#
#   Version that makes the AIPS areas come ahead of the user's
#-----------------------------------------------------------------------
#                                       Set the AIPS root directory.
AIPS_ROOT=/DEFINE_ME
#                                       Define AIPS versions.
OLD=$AIPS_ROOT/31DEC22
NEW=$AIPS_ROOT/31DEC23
#                                       TST always used for TPMONs, and
#                                       for MANPATH.
TST=$AIPS_ROOT/31DEC24
CVX=$AIPS_ROOT/31DEC24
#                                       Set default version (see
#                                       START_AIPS).
[ "$VERSION" = "" ] && VERSION=TST
#
# --------------- do not change anything below this line ---------------
#
export AIPS_ROOT OLD NEW TST CVX VERSION
#
if [ ! -d $AIPS_ROOT ] ; then
   echo 'AIPSPATH.SH: AIPS_ROOT is incorrectly defined.'
   echo 'Edit AIPSPATH.SH (and .CSH) to set it for your site.'
else
#                                       Get host info if necessary.
   [ "$ARCH" = "" ] && . $AIPS_ROOT/HOSTS.SH
#
#                                       Set AIPS_VERSION.
   case $VERSION in
      OLD) AIPS_VERSION=$OLD;;
      NEW) AIPS_VERSION=$NEW;;
      TST) AIPS_VERSION=$TST;;
      CVX) AIPS_VERSION=$CVX;;
      *)   AIPS_VERSION=$TST;;
   esac
   export AIPS_VERSION

#                                       Define AIPS procedure areas.
   SYSUNIX=$AIPS_VERSION/SYSTEM/UNIX; export SYSUNIX
   if [ -d $AIPS_VERSION/$ARCH/SYSTEM/$SITE ] ; then
      SYSLOCAL=$AIPS_VERSION/$ARCH/SYSTEM/$SITE
   else
      SYSLOCAL=$AIPS_VERSION/$ARCH/SYSTEM
   fi
   export SYSLOCAL
#                                       LIBRARY_PATH: sync'd systems
   if [ -f $SYSLOCAL/RSYNC.ME -o -f $SYSLOCAL/RSYNC.MASTER ] ; then
#      if [ $ARCH = "MACINT" ] ; then
#         TPATH=`echo $DYLD_LIBRARY_PATH | sed 's/^://' | sed 's/:$//'`
      if [ $ARCH = "LINUX" -o $ARCH = "LNX64" ] ; then
         TPATH=`echo $LD_LIBRARY_PATH | sed 's/^://' | sed 's/:$//'`
      fi
      export TPATH
      local="$AIPS_VERSION/$ARCH/LIBR/INTELCMP"
      tempath="$local"
      for d in `echo $TPATH | sed 's/:/ /g'` ; do
         case $d in
            ".")
                ;;
            "$local")
                ;;
             *)
                tempath="$tempath:$d"
                ;;
         esac
      done
#      if [ $ARCH = "MACINT" ] ; then
#         DYLD_LIBRARY_PATH=`echo $tempath | sed 's/:$//'`; export DYLD_LIBRARY_PATH
      if [ $ARCH = "LINUX" -o $ARCH = "LNX64" ] ; then
         LD_LIBRARY_PATH=`echo $tempath | sed 's/:$//'`; export LD_LIBRARY_PATH
      fi
   fi
#                                       MANPATH to get $SYSUNIX/manl,
#                                       but always use TST version.
   if [ "$MANPATH" != "" ] ; then
      tempath="$TST/SYSTEM/UNIX:"
      for d in `echo $MANPATH | sed -e 's/:/ /g'` ; do
         case $d in
            "$TST/SYSTEM/UNIX") ;;
            *) tempath="$tempath$d:";;
         esac
      done
      MANPATH=`echo $tempath | sed -e 's/:$//'`; export MANPATH
#                                       leave empty ones for man to
#                                       handle by new rules
#  else
#     MANPATH="/usr/man:$TST/SYSTEM/UNIX"; export MANPATH
   fi
#                                       Save PATH and redefine it.
#                                       check if it starts with ":"
#                                       Don't rely on existing TPATH
#                                       definition as PATH may have
#                                       changed in the interim!
#                                       Also check if we have perl.
   TPATH=`echo $PATH | sed 's/^://' | sed 's/:$//'`
   HAVE_PERL=""
   if [ -f $SYSUNIX/DADEVS.PL ] ; then
      perlplace=`head -n 1 $SYSUNIX/DADEVS.PL | sed -e 's/^..//'`
      [ -f $perlplace ] && HAVE_PERL=$perlplace
   fi
   export TPATH HAVE_PERL
   dot=".:"
   local="$SYSLOCAL":
   unix="$SYSUNIX":
   tempath="$dot$local$unix"
   for d in `echo $TPATH | sed 's/:/ /g'` ; do
      case $d in
         ".")
             ;;
         "$SYSLOCAL")
             ;;
         "$SYSUNIX")
             ;;
         *)
             tempath="$tempath$d:"
             ;;
      esac
   done

   PATH=`echo $tempath | sed 's/:$//'`; export PATH
#                                       Define the AIPS load area.
   LOAD="$AIPS_VERSION/$ARCH/LOAD"; export LOAD
#                                       Make AIPS version changing
#                                       commands.
   if [ -d $OLD/$ARCH/SYSTEM/$SITE ] ; then
      CDOLD="eval VERSION=OLD; export VERSION; . $OLD/$ARCH/SYSTEM/$SITE/CDVER.SH"
   else
      CDOLD="eval VERSION=OLD; export VERSION; . $OLD/$ARCH/SYSTEM/CDVER.SH"
   fi
   if [ -d $NEW/$ARCH/SYSTEM/$SITE ] ; then
      CDNEW="eval VERSION=NEW; export VERSION; . $NEW/$ARCH/SYSTEM/$SITE/CDVER.SH"
   else
      CDNEW="eval VERSION=NEW; export VERSION; . $NEW/$ARCH/SYSTEM/CDVER.SH"
   fi
   if [ -d $TST/$ARCH/SYSTEM/$SITE ] ; then
      CDTST="eval VERSION=TST; export VERSION; . $TST/$ARCH/SYSTEM/$SITE/CDVER.SH"
   else
      CDTST="eval VERSION=TST; export VERSION; . $TST/$ARCH/SYSTEM/CDVER.SH"
   fi
   if [ -d $CVX/$ARCH/SYSTEM/$SITE ] ; then
      CDCVX="eval VERSION=CVX; export VERSION; . $CVX/$ARCH/SYSTEM/$SITE/CDVER.SH"
   else
      CDCVX="eval VERSION=CVX; export VERSION; . $CVX/$ARCH/SYSTEM/CDVER.SH"
   fi
   export CDOLD CDNEW CDTST CDCVX
fi

# --------------------------------------------------------------------
# Usage: . AREAS.SH
# --------------------------------------------------------------------
# ;  Copyright (C) 1995-2000, 2003, 2006, 2009, 2022
# ;  Associated Universities, Inc. Washington DC, USA.
# ;
# ;  This program is free software; you can redistribute it and/or
# ;  modify it under the terms of the GNU General Public License as
# ;  published by the Free Software Foundation; either version 2 of
# ;  the License, or (at your option) any later version.
# ;
# ;  This program is distributed in the hope that it will be useful,
# ;  but WITHOUT ANY WARRANTY; without even the implied warranty of
# ;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# ;  GNU General Public License for more details.
# ;
# ;  You should have received a copy of the GNU General Public
# ;  License along with this program; if not, write to the Free
# ;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
# ;  MA 02139, USA.
# ;
# ;  Correspondence concerning AIPS should be addressed as follows:
# ;         Internet email: aipsmail@nrao.edu.
# ;         Postal address: AIPS Project Office
# ;                         National Radio Astronomy Observatory
# ;                         520 Edgemont Road
# ;                         Charlottesville, VA 22903-2475 USA
# --------------------------------------------------------------------
#  This file defines the entire AIPS directory structure (relative to
#  a 'version' directory node) plus the 'logical' associated with
#  each 'area' (i.e., directory).
#
#  UNIX: The script $SYSUNIX/AREAS uses $SYSAIPS/AREAS.DAT to create
#  $SYSLOCAL/AREAS.CSH and $SYSLOCAL/AREAS.SH, which contain C shell
#  and Bourne/Korn/bash/zsh shell syntax, respectively, to define the
#  area 'logicals' in terms of environment variables.  The definitions
#  are toggled between different versions of AIPS by executing $CDOLD,
#  $CDNEW or $CDTST, which are defined in $AIPS_ROOT/LOGIN.CSH and/or
#  $AIPS_ROOT/LOGIN.SH.  The AREAS.* environment variables are NOT
#  required for the execution of AIPS programs, just for AIPS
#  programming.  In fact, having all the area logicals defined takes
#  up such a large fraction of the available environment space on
#  some systems that the execution of AIPS programs, UNIX commands,
#  AIPS programming tools and system debuggers can be impaired.  To
#  avoid this, it may be necessary to comment out some or all of the
#  definitions that don't apply to the host implementation.
#
#  VMS: AIPS_PROC:ASSNLOCAL.COM uses this file more or less directly
#  to establish the definitions of area logicals.  The definitions
#  are toggled between different versions of AIPS by executing the
#  AIPS defined 'VERSION' command (see AIPS_PROC:AIPSUSER.COM), e.g.,
#  'VERSION NEW'.
# --------------------------------------------------------------------
#  Top level directories of source code areas
# --------------------------------------------------------------------
#
AIP=$AIPS_VERSION/AIPS
export AIP
APL=$AIPS_VERSION/APL
export APL
Q=$AIPS_VERSION/Q
export Q
QY=$AIPS_VERSION/QY
export QY
Y=$AIPS_VERSION/Y
export Y
#
# --------------------------------------------------------------------
#  AIPS program areas
# --------------------------------------------------------------------
#
#                                       Standard programs
AIPPGM=$AIPS_VERSION/AIPS/PGM
export AIPPGM
#                                       Non-standard programs
AIPNOT=$AIPS_VERSION/AIPS/PGM/NOTST
export AIPNOT
#                                       UNIX non-standard programs
AIPGUNIX=$AIPS_VERSION/AIPS/PGM/NOTST/UNIX
export AIPGUNIX
#                                       VMS non-standard programs
AIPGVMS=$AIPS_VERSION/AIPS/PGM/NOTST/VMS
export AIPGVMS
#
# --------------------------------------------------------------------
#  AIP subroutine areas - only referenced by AIP* programs
# --------------------------------------------------------------------
#
AIPSUB=$AIPS_VERSION/AIPS/SUB
export AIPSUB
#
# --------------------------------------------------------------------
#  APL program areas - these reference only APL* routines
# --------------------------------------------------------------------
#
#                                       Standard programs
APLPGM=$AIPS_VERSION/APL/PGM
export APLPGM
#                                       Non-standard programs
APGNOT=$AIPS_VERSION/APL/PGM/NOTST
export APGNOT
#                                       Object-oriented programs
APGOOP=$AIPS_VERSION/APL/PGM/OOP
export APGOOP
#                                       UNIX programs
APGUNIX=$AIPS_VERSION/APL/PGM/NOTST/UNIX
export APGUNIX
#                                       VMS programs
APGVMS=$AIPS_VERSION/APL/PGM/NOTST/VMS
export APGVMS
#                                       Contributed tasks and HELP
#                                       files - not compiled or linked
#                                       by the standard procedures
APLCONTR=$AIPS_VERSION/APL/CONTRIBU
export APLCONTR
#
# --------------------------------------------------------------------
#  APL subroutine areas - nothing here references Q or Y-routines
# --------------------------------------------------------------------
#
#                                       Standard routines
APLSUB=$AIPS_VERSION/APL/SUB
export APLSUB
#                                       Non-standard routines
APLNOT=$AIPS_VERSION/APL/SUB/NOTST
export APLNOT
#                                       Object-oriented routines
APLOOP=$AIPS_VERSION/APL/SUB/OOP
export APLOOP
#                                       VMS non-standard routines
APLNVMS=$AIPS_VERSION/APL/SUB/NOTST/VMS
export APLNVMS
#
# --------------------------------------------------------------------
#  Z-routine areas
# --------------------------------------------------------------------
#
#                                       Generic
APLGEN=$AIPS_VERSION/APL/DEV
export APLGEN
#                                       Generic UNIX
APLUNIX=$AIPS_VERSION/APL/DEV/UNIX
export APLUNIX
#                                       Bell UNIX
APLBELL=$AIPS_VERSION/APL/DEV/UNIX/BELL
export APLBELL
#                                       SunOS 5 (Solaris 2) and later
APLSOL=$AIPS_VERSION/APL/DEV/UNIX/BELL/SOL
export APLSOL
#                                       SunOS 5 on Intel iA86
APLSOL86=$AIPS_VERSION/APL/DEV/UNIX/BELL/SOL/SOL86
export APLSOL86
#                                       Hewlett Packard HP-UX
APLHP=$AIPS_VERSION/APL/DEV/UNIX/BELL/HP
export APLHP
#                                       Linux (Intel port)
APLLINUX=$AIPS_VERSION/APL/DEV/UNIX/BELL/LINUX
export APLLINUX
#                                       Linux (Intel port) 64bit
APLLNX64=$AIPS_VERSION/APL/DEV/UNIX/BELL/LNX64
export APLLNX64
#                                       MacIntosh (Darwin OS/X)
APLMACPP=$AIPS_VERSION/APL/DEV/UNIX/BELL/MACPPC
export APLMACPP
#                                       MacIntosh (Darwin OS/X) Intel
APLMACIN=$AIPS_VERSION/APL/DEV/UNIX/BELL/MACINT
export APLMACIN
#                                       MacIntosh (Darwin OS/X) ARM
APLMACAR=$AIPS_VERSION/APL/DEV/UNIX/BELL/MACARM
export APLMACAR
#                                       Linux (Alpha AXP port)
APLAXLIN=$AIPS_VERSION/APL/DEV/UNIX/BELL/AXLINUX
export APLAXLIN
#                                       Linux (Power PC port)
APLPPLIN=$AIPS_VERSION/APL/DEV/UNIX/BELL/LINUXPPC
export APLPPLIN
#                                       Silicon Graphics IRIX
APLSGI=$AIPS_VERSION/APL/DEV/UNIX/BELL/SGI
export APLSGI
#                                       Cray Research Inc
APLCRI=$AIPS_VERSION/APL/DEV/UNIX/BELL/CRI
export APLCRI
#                                       Masscomp
APLMASC=$AIPS_VERSION/APL/DEV/UNIX/BELL/MASC
export APLMASC
#                                       Berkeley UNIX
APLBERK=$AIPS_VERSION/APL/DEV/UNIX/BERK
export APLBERK
#                                       Alliant
APLALLN=$AIPS_VERSION/APL/DEV/UNIX/BERK/ALLN
export APLALLN
#                                       Convex
APLCVEX=$AIPS_VERSION/APL/DEV/UNIX/BERK/CVEX
export APLCVEX
#                                       Dec Alpha (OSF/1)
APLDEC=$AIPS_VERSION/APL/DEV/UNIX/BERK/DEC
export APLDEC
#                                       Dec Ultrix
APLULTRX=$AIPS_VERSION/APL/DEV/UNIX/BERK/DEC/ULTRIX
export APLULTRX
#                                       IBM RS/6000
APLIBM=$AIPS_VERSION/APL/DEV/UNIX/BERK/IBM
export APLIBM
#                                       IBM 3090 (AIX)
APL3090=$AIPS_VERSION/APL/DEV/UNIX/BERK/IBM/3090
export APL3090
#                                       SunOS 4 (Solaris 1)
APLSUN=$AIPS_VERSION/APL/DEV/UNIX/BERK/SUN
export APLSUN
#                                       VAX
APLVAX=$AIPS_VERSION/APL/DEV/UNIX/BERK/VAX
export APLVAX
#                                       Generic VMS
APLVMS=$AIPS_VERSION/APL/DEV/VMS
export APLVMS
#
# --------------------------------------------------------------------
#  Binary areas
# --------------------------------------------------------------------
#
AIPSBIN=$AIPS_VERSION/BIN
export AIPSBIN
AIPSFITS=$AIPS_VERSION/BIN/FITS
export AIPSFITS
#
# --------------------------------------------------------------------
#  Documentation areas
# --------------------------------------------------------------------
#
DOC=$AIPS_VERSION/DOC
export DOC
DOCTXT=$AIPS_VERSION/DOC/TEXT
export DOCTXT
#
# --------------------------------------------------------------------
#  Core dump area
# --------------------------------------------------------------------
#
ERRORS=$AIPS_VERSION/$ARCH/ERRORS/$HOST
export ERRORS
#
# --------------------------------------------------------------------
#  HELP file area
# --------------------------------------------------------------------
#
HLPFIL=$AIPS_VERSION/HELP
export HLPFIL
#
# --------------------------------------------------------------------
#  History area
# --------------------------------------------------------------------
#
HIST=$AIPS_VERSION/HIST
export HIST
#
# --------------------------------------------------------------------
#  INCLUDE file areas
# --------------------------------------------------------------------
#
#                                       Standard INCLUDEs
INC=$AIPS_VERSION/INC
export INC
#                                       Non-standard INCLUDEs
INCNOT=$AIPS_VERSION/INC/NOTST
export INCNOT
#                                       GNU (readline)
INCGNU=$AIPS_VERSION/INC/NOTST/GNU
export INCGNU
#                                       Local
INCLOC=$AIPS_VERSION/INC/LOCAL
export INCLOC
#                                       Alliant
INCALN=$AIPS_VERSION/INC/NOTST/ALLN
export INCALN
#                                       Alpha AXP Linux
INCAXL=$AIPS_VERSION/INC/NOTST/AXLINUX
export INCAXL
#                                       Power PC Linux
INCPPC=$AIPS_VERSION/INC/NOTST/LINUXPPC
export INCPPC
#                                       Cray Research Inc
INCCRI=$AIPS_VERSION/INC/NOTST/CRI
export INCCRI
#                                       Convex
INCVEX=$AIPS_VERSION/INC/NOTST/CVEX
export INCVEX
#                                       Digital (OSF/1, Ultrix)
INCDEC=$AIPS_VERSION/INC/NOTST/DEC
export INCDEC
#                                       HP-UX
INCHP=$AIPS_VERSION/INC/NOTST/HP
export INCHP
#                                       HP-UX 2 (for PAPC, big AP)
INCHP2=$AIPS_VERSION/INC/NOTST/HP2
export INCHP2
#                                       IBM RS/6000
INCIBM=$AIPS_VERSION/INC/NOTST/IBM
export INCIBM
#                                       IBM 3090 (AIX)
INC3090=$AIPS_VERSION/INC/NOTST/IBM/3090
export INC3090
#                                       Intel Linux
INCLIN=$AIPS_VERSION/INC/NOTST/LINUX
export INCLIN
#                                       Intel Linux 64bit
INCLNX64=$AIPS_VERSION/INC/NOTST/LNX64
export INCLNX64
#                                       MacIntosh (Darwin OS/X)
INCMACPP=$AIPS_VERSION/INC/NOTST/MACPPC
export INCMACPP
#                                       MacIntosh (Darwin OS/X) Intel
INCMACIN=$AIPS_VERSION/INC/NOTST/MACINT
export INCMACIN
#                                       MacIntosh (Darwin OS/X) ARM
INCMACAR=$AIPS_VERSION/INC/NOTST/MACARM
export INCMACAR
#                                       Silicon Graphics IRIX
INCSGI=$AIPS_VERSION/INC/NOTST/SGI
export INCSGI
#                                       SunOS 5 (Solaris 2)
INCSOL=$AIPS_VERSION/INC/NOTST/SOL
export INCSOL
#                                       SunOS 5 (Solaris 2) UltraII
INCSUL=$AIPS_VERSION/INC/NOTST/SUL
export INCSUL
#                                       SunOS 4 (Solaris 1)
INCSUN=$AIPS_VERSION/INC/NOTST/SUN
export INCSUN
#                                       VMS
INCVMS=$AIPS_VERSION/INC/NOTST/VMS
export INCVMS
#
# --------------------------------------------------------------------
#  Object module areas
# --------------------------------------------------------------------
#
#                                       Subroutine object libraries
LIBR=$AIPS_VERSION/$ARCH/LIBR
export LIBR
#                                       Debug version of libraries
LIBRDBG=$AIPS_VERSION/$ARCH/LIBRDBG
export LIBRDBG
#                                       Executable modules
LOAD=$AIPS_VERSION/$ARCH/LOAD
export LOAD
#                                       Alternate executable modules
#                                       commented out; rarely used
#                                       LOAD1 is Pseudo AP w/wo TV 1
#                                        and is LOAD.ALT1
#                                       LOAD2 is for TV 2 w/wo real AP
#                                        and is LOAD.ALT2
#                                       LOAD3 is for TV 2 w Pseudo AP
#                                        and is LOAD.ALT3
#
# --------------------------------------------------------------------
# PREP area for temporary files (unix only)
# --------------------------------------------------------------------
#
PREP=$AIPS_VERSION/$ARCH/PREP
export PREP
#
# --------------------------------------------------------------------
#  POPS memory file area
# --------------------------------------------------------------------
#
MEMORY=$AIPS_VERSION/$ARCH/MEMORY
export MEMORY
#
# --------------------------------------------------------------------
#  Q-routine areas (real and pseudo array processor)
# --------------------------------------------------------------------
#
#                                       Generic
QDEV=$AIPS_VERSION/Q/DEV
export QDEV
#                                       Generic FPS
QFPS=$AIPS_VERSION/Q/DEV/FPS
export QFPS
#                                       16 bit FPS
QFPS16=$AIPS_VERSION/Q/DEV/FPS/16B
export QFPS16
#                                       Model 120B FPS
Q120B=$AIPS_VERSION/Q/DEV/FPS/16B/120B
export Q120B
#                                       Models 5105, 5205 ... FPS
Q5000=$AIPS_VERSION/Q/DEV/FPS/16B/5000
export Q5000
#                                       32 bit FPS
QFPS32=$AIPS_VERSION/Q/DEV/FPS/32B
export QFPS32
#                                       Model 190 FPS
Q190=$AIPS_VERSION/Q/DEV/FPS/32B/190
export Q190
#                                       Generic pseudo AP
QPSAP=$AIPS_VERSION/Q/DEV/PSAP
export QPSAP
#                                       Alliant pseudo AP
QALN=$AIPS_VERSION/Q/DEV/PSAP/ALLN
export QALN
#                                       Cray Research Inc pseudo AP
QCRI=$AIPS_VERSION/Q/DEV/PSAP/CRI
export QCRI
#                                       Convex pseudo AP
QVEX=$AIPS_VERSION/Q/DEV/PSAP/CVEX
export QVEX
#                                       Digital: OSF/1, Ultrix
QDEC=$AIPS_VERSION/Q/DEV/PSAP/DEC
export QDEC
#                                       HP-UX
QHP=$AIPS_VERSION/Q/DEV/PSAP/HP
export QHP
#                                       IBM RS/6000
QIBM=$AIPS_VERSION/Q/DEV/PSAP/IBM
export QIBM
#                                       IBM 3090 (AIX)
Q3090=$AIPS_VERSION/Q/DEV/PSAP/IBM/3090
export Q3090
#                                       Silicon Graphics IRIX PS-AP
QSGI=$AIPS_VERSION/Q/DEV/PSAP/SGI
export QSGI
#                                       SunOS 5 (Solaris 2) pseudo AP
QSOL=$AIPS_VERSION/Q/DEV/PSAP/SOL
export QSOL
#                                       SunOS 4 (Solaris 1) pseudo AP
QSUN=$AIPS_VERSION/Q/DEV/PSAP/SUN
export QSUN
#                                       VMS pseudo AP
QVMS=$AIPS_VERSION/Q/DEV/PSAP/VMS
export QVMS
#
# --------------------------------------------------------------------
#  Programs that reference Q-routines
# --------------------------------------------------------------------
#
#                                       Standard programs
QPGM=$AIPS_VERSION/Q/PGM
export QPGM
#                                       Q-Object Oriented programs
QPGOOP=$AIPS_VERSION/Q/PGM/OOP
export QPGOOP
#                                       Non-standard programs
QPGNOT=$AIPS_VERSION/Q/PGM/NOTST
export QPGNOT
#                                       VMS programs
QPGVMS=$AIPS_VERSION/Q/PGM/NOTST/VMS
export QPGVMS
#
# --------------------------------------------------------------------
#  Subroutines that reference Q-routines
# --------------------------------------------------------------------
#
#                                       Standard routines
QSUB=$AIPS_VERSION/Q/SUB
export QSUB
#                                       Object-oriented Q-routines
QOOP=$AIPS_VERSION/Q/SUB/OOP
export QOOP
#                                       Non-standard routines
QNOT=$AIPS_VERSION/Q/SUB/NOTST
export QNOT
#
# --------------------------------------------------------------------
#  Programs that reference both Q-routines and Y-routines
# --------------------------------------------------------------------
#
#                                       Standard programs
QYPGM=$AIPS_VERSION/QY/PGM
export QYPGM
#                                       Non-standard programs
QYPGNOT=$AIPS_VERSION/QY/PGM/NOTST
export QYPGNOT
#                                       VMS programs
QYPGVMS=$AIPS_VERSION/QY/PGM/NOTST/VMS
export QYPGVMS
#
# --------------------------------------------------------------------
#  System RUN file area - useful procedures for everyone
# --------------------------------------------------------------------
#
RUNSYS=$AIPS_VERSION/RUN
export RUNSYS
#
# --------------------------------------------------------------------
#  System manager areas
# --------------------------------------------------------------------
#
#                                       Generic
SYSAIPS=$AIPS_VERSION/SYSTEM
export SYSAIPS
#                                       Generic UNIX
SYSUNIX=$AIPS_VERSION/SYSTEM/UNIX
export SYSUNIX
#                                       Generic PERL
SYSPERL=$AIPS_VERSION/SYSTEM/UNIX/PERL
export SYSPERL
#                                       (Local) manual pages
SYSMAN=$AIPS_VERSION/SYSTEM/UNIX/manl
export SYSMAN
#                                       Alliant
SYSALLN=$AIPS_VERSION/ALLN/SYSTEM
export SYSALLN
#                                       Cray Research Inc
SYSCRI=$AIPS_VERSION/CRI/SYSTEM
export SYSCRI
#                                       Convex
SYSCVEX=$AIPS_VERSION/CVEX/SYSTEM
export SYSCVEX
#                                       Decstation (Ultrix)
SYSDEC=$AIPS_VERSION/DEC/SYSTEM
export SYSDEC
#                                       Digital Alpha (OSF/1)
SYSALPHA=$AIPS_VERSION/ALPHA/SYSTEM
export SYSALPHA
#                                       HP-UX
SYSHP=$AIPS_VERSION/HP/SYSTEM
export SYSHP
#                                       HP-UX
SYSHP2=$AIPS_VERSION/HP2/SYSTEM
export SYSHP2
#                                       IBM RS/6000
SYSIBM=$AIPS_VERSION/IBM/SYSTEM
export SYSIBM
#                                       IBM 3090 (AIX)
SYS3090=$AIPS_VERSION/IBM3090/SYSTEM
export SYS3090
#                                       Silicon Graphics IRIX
SYSSGI=$AIPS_VERSION/SGI/SYSTEM
export SYSSGI
#                                       Linux/PC
SYSLINUX=$AIPS_VERSION/LINUX/SYSTEM
export SYSLINUX
#                                       Linux/PC 64bit
SYSLNX64=$AIPS_VERSION/LNX64/SYSTEM
export SYSLNX64
#                                       MacIntosh (Darwin OS/X)
SYSMACPP=$AIPS_VERSION/MACPPC/SYSTEM
export SYSMACPP
#                                       MacIntosh (Darwin OS/X) Intel
SYSMACIN=$AIPS_VERSION/MACINT/SYSTEM
export SYSMACIN
#                                       MacIntosh (Darwin OS/X) ARM
SYSMACAR=$AIPS_VERSION/MACARM/SYSTEM
export SYSMACAR
#                                       Linux/Alpha-AXP
SYSAXLIN=$AIPS_VERSION/AXLINUX/SYSTEM
export SYSAXLIN
#                                       Linux/Power-PC
SYSPPLIN=$AIPS_VERSION/LINUXPPC/SYSTEM
export SYSPPLIN
#                                       SunOS 5 (Solaris 2)
SYSSOL=$AIPS_VERSION/SOL/SYSTEM
export SYSSOL
#                                       SunOS 5 (Solaris 2) UltraII
SYSSUL=$AIPS_VERSION/SUL/SYSTEM
export SYSSUL
#                                       SunOS 5 (Solaris 2) iA86
SYSSOL86=$AIPS_VERSION/SOL86/SYSTEM
export SYSSOL86
#                                       SunOS 4 (Solaris 1)
SYSSUN=$AIPS_VERSION/SUN4/SYSTEM
export SYSSUN
#                                       Old 68020/68030 Suns
SYSSUN3=$AIPS_VERSION/SUN3/SYSTEM
export SYSSUN3
#                                       UNIX installation
INSUNIX=$AIPS_VERSION/SYSTEM/UNIX/INSTALL
export INSUNIX
#                                       UNIX midnight job
UPDUNIX=$AIPS_VERSION/SYSTEM/UNIX/UPDATE
export UPDUNIX
#                                       Generic VMS
SYSVMS=$AIPS_VERSION/SYSTEM/VMS
export SYSVMS
#                                       Local VMS
SYSLVAX=$AIPS_VERSION/SYSTEM/VMS/LOCAL
export SYSLVAX
#                                       VMS installation
INSVMS=$AIPS_VERSION/SYSTEM/VMS/INSTALL
export INSVMS
#                                       VMS midnight job
UPDVMS=$AIPS_VERSION/SYSTEM/VMS/UPDATE
export UPDVMS
#
# --------------------------------------------------------------------
#  Y-routine areas
# --------------------------------------------------------------------
#
#                                       Generic
YGEN=$AIPS_VERSION/Y/DEV
export YGEN
#                                       ARGS pipe from M70
YARGS=$AIPS_VERSION/Y/DEV/ARGS
export YARGS
#                                       Deanza
YDEA=$AIPS_VERSION/Y/DEV/DEA
export YDEA
#                                       IIS generic
YIIS=$AIPS_VERSION/Y/DEV/IIS
export YIIS
#                                       IIS Model IVAS
YIVAS=$AIPS_VERSION/Y/DEV/IVAS
export YIVAS
#                                       IIS Model 70
YM70=$AIPS_VERSION/Y/DEV/IIS/M70
export YM70
#                                       IIS Model 75
YM75=$AIPS_VERSION/Y/DEV/IIS/M75
export YM75
#                                       Lexidata
YLEX=$AIPS_VERSION/Y/DEV/LEX
export YLEX
#                                       Lexidata C code
YLEXC=$AIPS_VERSION/Y/DEV/LEX/LEXC
export YLEXC
#                                       Screen Servers SSS, XAS, XVSS
YSS=$AIPS_VERSION/Y/DEV/SS
export YSS
#                                       Stubbed
YSTUB=$AIPS_VERSION/Y/DEV/STUB
export YSTUB
#                                       Comtal Vision 1/20
YV20=$AIPS_VERSION/Y/DEV/V20
export YV20
#                                       Virtual TV
YVTV=$AIPS_VERSION/Y/DEV/VTV
export YVTV
#
# --------------------------------------------------------------------
#  Programs that reference Y-routines
# --------------------------------------------------------------------
#
#                                       Standard programs
YPGM=$AIPS_VERSION/Y/PGM
export YPGM
#                                       Virtual TV program
YPGVDEV=$AIPS_VERSION/Y/PGM/VDEV
export YPGVDEV
#                                       Non-standard programs
YPGNOT=$AIPS_VERSION/Y/PGM/NOTST
export YPGNOT
#                                       VMS programs
YPGVMS=$AIPS_VERSION/Y/PGM/NOTST/VMS
export YPGVMS
#
#
# --------------------------------------------------------------------
#  Screen server programs
# --------------------------------------------------------------------
#
#                                       Servers
YSERV=$AIPS_VERSION/Y/SERVERS
export YSERV
#
# --------------------------------------------------------------------
#  Subroutines that reference Y-routines
# --------------------------------------------------------------------
#
#                                       Standard routines
YSUB=$AIPS_VERSION/Y/SUB
export YSUB
#                                       Non-standard routines
YNOT=$AIPS_VERSION/Y/SUB/NOTST
export YNOT

#!/bin/sh
#-----------------------------------------------------------------------
#;  Copyright (C) 1995-2001
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# FDEFAULT.SH
# set compiler name, compiler switches to AIPS standard names
# Input Variables
#   ARCH      = Type of CPU (Convex Sun or IBM)
# Variables returned:
#   COMPILER  = Name of fortran Compiler
#   COMPSWIT  = Switches needed to enforce AIPS coding standards
#               IMPORTANT: Within the case statement on $ARCH, the
#               setting of this variable HAS to be on ONE SINGLE LINE!
#               This is for install.pl's use.
#   OPT(0-9)  = Ten compiler optimzation levels
#   DEBUG     = Compiler Debug switch
#
# Posix version, with allowances for most AIPS-supported OS versions.
# (based on the 1991 draft 11.2 of Posix 1003.2)
#
#    HP2 version
#
#-----------------------------------------------------------------------
#                                       Set default compiler for POSIX
COMPILER="fort77"
#                                       Dirty is a carryover from VMS...
DIRTY=""; NODIRTY=""
#                                       POSIX Fortran 77 debug flag.
DEBUG="-g"; NODEBUG=""
#                                       Profile, architecture dependent.
PROFILE=""
#                                       POSIX compile-only switch
COMPSWIT="-c"
#                                       POSIX "no optimize" directive
NOOPT="-O0"
#                                       Generate source code listing?
LIST=FALSE
#                                       Remove leftover .f, .LOG files
PURGE=FALSE
#                                       Case by case differences from
#                                       the above standard definitions.
case $ARCH in
   HP2)
#                                       --------------------------------
#                                       Hewlett-Packard 9000/7xx HP-UXv8
      COMPILER="f77"
#     COMPILER="f90" may or may not work; untested, and +E4 not available.
#                    lack of this last item may make printout look wonky.
#                                       -a: ansi compliance
#                                       -u: implicit none checking
#                                       -v: mucho output.
#                                       +ppu: externs "_" postpended
#                                       -K: automatically SAVE variables
#                                       +A: allow real/double EQUIVALENCE
#                                           actually puts variables at
#                                           I*2 addresses (very slow)
#                                       +E4: get leading 0's in F format
      COMPSWIT="+DA2.0 +DS2.0 -c -a -u -v +ppu -K +E4"
      case $COMPILER in
#                                       These are the f90 equivalents
#                                       except for +E4.  Caveat Emptor!
        *f90) COMPSWIT="-c +langlvl +implicit_none -v +ppu -K";;
      esac
#                                       Using shared libs?  +Z => PIC.
      [ -f $SYSLOCAL/USESHARED ] && COMPSWIT="$COMPSWIT +Z"
      NOOPT=""
      OPT0=""; OPT1="+O1"
      OPT2="+O2 +Odataprefetch +Oaggressive";
      OPT3="+O2 +Odataprefetch +Oaggressive"
      OPT4="+O2 +Odataprefetch +Oaggressive"
      OPT5="+O2 +Odataprefetch +Oaggressive"
      OPT6="+O2 +Odataprefetch +Oaggressive"
      OPT7="+O2 +Odataprefetch +Oaggressive"
      OPT8="+O2 +Odataprefetch +Oaggressive"
      OPT9="+O2 +Odataprefetch +Oaggressive"
   ;;
   *)
#                                       --------------------------------
#                                       Other: Assume simple -O settings
#                                       In addition to the defaults.
      echo "You are using an HP2  FDEFAULT.SH on " $ARCH
      OPT0="-O0" ; OPT1="-O1" ; OPT2="-O2"
      OPT3=$OPT2 ; OPT4=$OPT2 ; OPT5=$OPT2 ; OPT6=$OPT2
      OPT7=$OPT2 ; OPT8=$OPT2 ; OPT9=$OPT2
   ;;
esac
#
COMP=$COMPSWIT
#                                       export the defined values
export NODEBUG DEBUG DIRTY NODIRTY PROFILE PURGE
export COMPILER COMPSWIT NOOPT
export OPT0 OPT1 OPT2 OPT3 OPT4 OPT5 OPT6 OPT7 OPT8 OPT9

#!/bin/sh
#-----------------------------------------------------------------------
#;  Copyright (C) 1998
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
#   Usage: DECOMPLIB.SH
#-----------------------------------------------------------------------
#   Rename all QSGI routines that rely on complib so that the AIPS
#   COMRPL script will use more generic versions that do not require
#   this library.
#
#   complib.sgimath and complib.sgimath_mp are libraries containing
#   high-performance numerical routines that may not be available on
#   all machines.
#-----------------------------------------------------------------------
if [ -f $QSGI/QSEARC.FOR ]
then mv $QSGI/QSEARC.FOR $QSGI/QSEARC.SAVED
fi

#-----------------------------------------------------------------------
#;  Copyright (C) 1995-2000
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# Usage: . LDOPTS.SH
#--------------------------------------------------------------------
# Define variables used by $SYSUNIX/LINK.  These include:
#     1) command name for the host Fortran compiler (e.g., f77),
#     2) f77/ld options for linking, and
#     3) AIPS-style options, e.g. LIST=FALSE, SAVE=TRUE.
# See comments in LINK for more details on AIPS options.
#
# NOTE: These are options for linking ONLY (see definition of the
#       environment variable 'LINK' below).  Options for compiling are
#       defined in the $SYSLOCAL files ASOPTS.SH and CCOPTS.SH for
#       assembler and 'C', respectively, and in $SYSUNIX/FDEFAULT.SH for
#       Fortran compilations.
#
# SUN version.  (SunOS 5+)
#--------------------------------------------------------------------
# Set compiler to g77 or pgf77 (Portland Group compiler) here. If
# using the Portland Group compiler with gcc and you have enabled
# large file support then you will also need to change LINK below.

COMPILER="/usr/local/bin/g77"

case "$COMPILER" in

*pgf77)  # Portland Group compiler

         COMPILER="$COMPILER -Kieee"
         ;;

*g77)    # GNU compiler
         ;;

*)       # Unknown compiler

         echo "LDOPTS is no configured for $COMPILER"
         ;;
esac

#                                       Define AIPS-style options.
#                                       Debug and no-optimise flags.
DEBUG="-g"
NOOPT=""
#                                       Not used, but still needed :-(
DIRTY=""
#                                       f77/ld option for a link map.
MAP="-M"
#                                       Not used, but still needed :-(
OPT0=""
OPT1=""
OPT2=""
OPT3=""
OPT4=""
OPT5=""
OPT6=""
OPT7=""
OPT8=""
OPT9=""
#                                       execution profiling.
PROFILE="-p"
#                                       Need socket and nsl libraries
#                                       for Berkeley sockets/networking.
#                                       Use generic target unless
#                                       building for a homogeneous set
#                                       of Sparc systems.
#                                       MUST BE CONSISTENT between this,
#                                       CCOPTS.SH, and FDEFAULT.SH
#                                       (last in $SYSUNIX).
LINK="-lsocket -lnsl"

# IMPORTANT
#
# If you are using gcc as your C compiler and are using a FORTRAN
# compiler other than g77 then you must uncomment the following
# line and change it to reflect your local gcc installation

# LINK="$LINK -L/usr/local/lib/gcc-lib/intel-sun-solaris-2.8/2.95.2 -lgcc"

#                                       AIPS style options.
#                                       LIST not used but still needed
LIST=FALSE
#                                       Delete any .o and .LOG files
PURGE=FALSE
#                                       Replace old .EXE in $LOAD.
REPLACE=TRUE
#                                       Remove symbol tables to save
#                                       space.
STRIP=TRUE
#                                       Save old copy of .EXE first and
#                                       then delete it; avoid bus errors
#                                       this way on running tasks.
SAVE=TRUE
#                                       End

# CCOPTS.SH
#-----------------------------------------------------------------------
#;  Copyright (C) 1995, 1998
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# CCOPTS.SH
#-----------------------------------------------------------------------
# Define variables used by $SYSUNIX/AIPSCC.  These include
#    1) command name for the host C compiler, and
#    2) C compiler options and AIPS style options.
# Both can be toggled by, e.g. NODEBUG or DEBUG, NOPURGE or PURGE...
#
# NOTE: These are options for compiling ONLY (see definition of the
#       environment variable 'COMP' below).  Options applicable to the
#       loader are defined in $SYSLOCAL/LDOPTS.SH.
#
# NRAO-CV IBM RS/6000 (AIX 3.1/3.2) version
#--------------------------------------------------------------------
# For AIX, cc (BSD based) was traditionally used, but xlc may be
# necessary if large files are ever to be supported.  Several APLIBM
# modules will fail (e.g. ZCREA2) if you try, though.
# Also, it's best to leave the PSALLOC code unchanged as the compiler
# under 3.2.5 cannot even compile the "hello world" program if PSALLOC
# is set to "early".

COMPILER="cc"
# COMPILER="xlc"
#                                       as AIPSCC is called as a
#                                       sub-shell, this should not
#                                       affect the parent process.
if [ "$PSALLOC" = "early" ] ; then
   PSALLOC=""; export PSALLOC
fi

# Define AIPSCC compiler oriented options in terms of the host C
# compiler command syntax.

#                                       Any options that may enhance
#                                       or may be required for the
#                                       usage of system debuggers.
DEBUG="-g"
#                                       Any of a wide variety of
#                                       optimization levels available
#                                       for UNIX C compilers and
#                                       combinations thereof.
OPT0="-O"
OPT1=""
OPT2=""
OPT3=""
OPT4=""
OPT5=""
OPT6=""
OPT7=""
OPT8=""
OPT9=""

COMP="-c -DBSD -I$INC"
# COMP="-c -I$INC"

# Set default values for other (i.e., non-compiler oriented) options
# recognized by AIPSCC.  These are a matter of preference, however
# the default settings exported with the UNIX/AIPS installation kits
# seem to make the most sense.

#                                       Generate source code listing?
LIST=FALSE
#                                       Purge, that is, delete any .c
#                                       and .LOG files associated with
#                                       a successful compilation and,
#                                       if LIST=FALSE, any extant .LIS
#                                       file associated with the
#                                       program/subroutine being
#                                       compiled (i.e., keep the AIPS
#                                       source code directories free
#                                       of trash files).
PURGE=TRUE

# "--------------------------------------------------------------------"
# " Usage: source AREAS.CSH                                            "
# "--------------------------------------------------------------------"
# ";  Copyright (C) 1995-2000, 2003, 2006, 2009, 2022                  "
# ";  Associated Universities, Inc. Washington DC, USA.                "
# ";                                                                   "
# ";  This program is free software; you can redistribute it and/or    "
# ";  modify it under the terms of the GNU General Public License as   "
# ";  published by the Free Software Foundation; either version 2 of   "
# ";  the License, or (at your option) any later version.              "
# ";                                                                   "
# ";  This program is distributed in the hope that it will be useful,  "
# ";  but WITHOUT ANY WARRANTY; without even the implied warranty of   "
# ";  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    "
# ";  GNU General Public License for more details.                     "
# ";                                                                   "
# ";  You should have received a copy of the GNU General Public        "
# ";  License along with this program; if not, write to the Free       "
# ";  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     "
# ";  MA 02139, USA.                                                   "
# ";                                                                   "
# ";  Correspondence concerning AIPS should be addressed as follows:   "
# ";         Internet email: aipsmail@nrao.edu.                        "
# ";         Postal address: AIPS Project Office                       "
# ";                         National Radio Astronomy Observatory      "
# ";                         520 Edgemont Road                         "
# ";                         Charlottesville, VA 22903-2475 USA        "
# "--------------------------------------------------------------------"
# " This file defines the entire AIPS directory structure (relative to "
# " a 'version' directory node) plus the 'logical' associated with     "
# " each 'area' (i.e., directory).                                     "
# "                                                                    "
# " UNIX: The script $SYSUNIX/AREAS uses $SYSAIPS/AREAS.DAT to create  "
# " $SYSLOCAL/AREAS.CSH and $SYSLOCAL/AREAS.SH, which contain C shell  "
# " and Bourne/Korn/bash/zsh shell syntax, respectively, to define the "
# " area 'logicals' in terms of environment variables.  The definitions"
# " are toggled between different versions of AIPS by executing $CDOLD,"
# " $CDNEW or $CDTST, which are defined in $AIPS_ROOT/LOGIN.CSH and/or "
# " $AIPS_ROOT/LOGIN.SH.  The AREAS.* environment variables are NOT    "
# " required for the execution of AIPS programs, just for AIPS         "
# " programming.  In fact, having all the area logicals defined takes  "
# " up such a large fraction of the available environment space on     "
# " some systems that the execution of AIPS programs, UNIX commands,   "
# " AIPS programming tools and system debuggers can be impaired.  To   "
# " avoid this, it may be necessary to comment out some or all of the  "
# " definitions that don't apply to the host implementation.           "
# "                                                                    "
# " VMS: AIPS_PROC:ASSNLOCAL.COM uses this file more or less directly  "
# " to establish the definitions of area logicals.  The definitions    "
# " are toggled between different versions of AIPS by executing the    "
# " AIPS defined 'VERSION' command (see AIPS_PROC:AIPSUSER.COM), e.g., "
# " 'VERSION NEW'.                                                     "
# "--------------------------------------------------------------------"
# " Top level directories of source code areas                         "
# "--------------------------------------------------------------------"
#
setenv AIP             $AIPS_VERSION/AIPS
setenv APL             $AIPS_VERSION/APL
setenv Q               $AIPS_VERSION/Q
setenv QY              $AIPS_VERSION/QY
setenv Y               $AIPS_VERSION/Y
#
# "--------------------------------------------------------------------"
# " AIPS program areas                                                 "
# "--------------------------------------------------------------------"
#
#                                       "Standard programs"
setenv AIPPGM          $AIPS_VERSION/AIPS/PGM
#                                       "Non-standard programs"
setenv AIPNOT          $AIPS_VERSION/AIPS/PGM/NOTST
#                                       "UNIX non-standard programs"
setenv AIPGUNIX        $AIPS_VERSION/AIPS/PGM/NOTST/UNIX
#                                       "VMS non-standard programs"
setenv AIPGVMS         $AIPS_VERSION/AIPS/PGM/NOTST/VMS
#
# "--------------------------------------------------------------------"
# " AIP subroutine areas - only referenced by AIP* programs            "
# "--------------------------------------------------------------------"
#
setenv AIPSUB          $AIPS_VERSION/AIPS/SUB
#
# "--------------------------------------------------------------------"
# " APL program areas - these reference only APL* routines             "
# "--------------------------------------------------------------------"
#
#                                       "Standard programs"
setenv APLPGM          $AIPS_VERSION/APL/PGM
#                                       "Non-standard programs"
setenv APGNOT          $AIPS_VERSION/APL/PGM/NOTST
#                                       "Object-oriented programs"
setenv APGOOP          $AIPS_VERSION/APL/PGM/OOP
#                                       "UNIX programs"
setenv APGUNIX         $AIPS_VERSION/APL/PGM/NOTST/UNIX
#                                       "VMS programs"
setenv APGVMS          $AIPS_VERSION/APL/PGM/NOTST/VMS
#                                       "Contributed tasks and HELP "
#                                       "files - not compiled or linked"
#                                       "by the standard procedures"
setenv APLCONTR        $AIPS_VERSION/APL/CONTRIBU
#
# "--------------------------------------------------------------------"
# " APL subroutine areas - nothing here references Q or Y-routines     "
# "--------------------------------------------------------------------"
#
#                                       "Standard routines"
setenv APLSUB          $AIPS_VERSION/APL/SUB
#                                       "Non-standard routines"
setenv APLNOT          $AIPS_VERSION/APL/SUB/NOTST
#                                       "Object-oriented routines"
setenv APLOOP          $AIPS_VERSION/APL/SUB/OOP
#                                       "VMS non-standard routines"
setenv APLNVMS         $AIPS_VERSION/APL/SUB/NOTST/VMS
#
# "--------------------------------------------------------------------"
# " Z-routine areas                                                    "
# "--------------------------------------------------------------------"
#
#                                       "Generic"
setenv APLGEN          $AIPS_VERSION/APL/DEV
#                                       "Generic UNIX"
setenv APLUNIX         $AIPS_VERSION/APL/DEV/UNIX
#                                       "Bell UNIX"
setenv APLBELL         $AIPS_VERSION/APL/DEV/UNIX/BELL
#                                       "SunOS 5 (Solaris 2) and later"
setenv APLSOL          $AIPS_VERSION/APL/DEV/UNIX/BELL/SOL
#                                       "SunOS 5 on Intel iA86"
setenv APLSOL86        $AIPS_VERSION/APL/DEV/UNIX/BELL/SOL/SOL86
#                                       "Hewlett Packard HP-UX"
setenv APLHP           $AIPS_VERSION/APL/DEV/UNIX/BELL/HP
#                                       "Linux (Intel port)"
setenv APLLINUX        $AIPS_VERSION/APL/DEV/UNIX/BELL/LINUX
#                                       "Linux (Intel port) 64bit"
setenv APLLNX64        $AIPS_VERSION/APL/DEV/UNIX/BELL/LNX64
#                                       "MacIntosh (Darwin OS/X)"
setenv APLMACPP        $AIPS_VERSION/APL/DEV/UNIX/BELL/MACPPC
#                                       "MacIntosh (Darwin OS/X) Intel"
setenv APLMACIN        $AIPS_VERSION/APL/DEV/UNIX/BELL/MACINT
#                                       "MacIntosh (Darwin OS/X) ARM"
setenv APLMACAR        $AIPS_VERSION/APL/DEV/UNIX/BELL/MACARM
#                                       "Linux (Alpha AXP port)"
setenv APLAXLIN        $AIPS_VERSION/APL/DEV/UNIX/BELL/AXLINUX
#                                       "Linux (Power PC port)"
setenv APLPPLIN        $AIPS_VERSION/APL/DEV/UNIX/BELL/LINUXPPC
#                                       "Silicon Graphics IRIX"
setenv APLSGI          $AIPS_VERSION/APL/DEV/UNIX/BELL/SGI
#                                       "Cray Research Inc"
setenv APLCRI          $AIPS_VERSION/APL/DEV/UNIX/BELL/CRI
#                                       "Masscomp"
setenv APLMASC         $AIPS_VERSION/APL/DEV/UNIX/BELL/MASC
#                                       "Berkeley UNIX"
setenv APLBERK         $AIPS_VERSION/APL/DEV/UNIX/BERK
#                                       "Alliant"
setenv APLALLN         $AIPS_VERSION/APL/DEV/UNIX/BERK/ALLN
#                                       "Convex"
setenv APLCVEX         $AIPS_VERSION/APL/DEV/UNIX/BERK/CVEX
#                                       "Dec Alpha (OSF/1)"
setenv APLDEC          $AIPS_VERSION/APL/DEV/UNIX/BERK/DEC
#                                       "Dec Ultrix"
setenv APLULTRX        $AIPS_VERSION/APL/DEV/UNIX/BERK/DEC/ULTRIX
#                                       "IBM RS/6000"
setenv APLIBM          $AIPS_VERSION/APL/DEV/UNIX/BERK/IBM
#                                       "IBM 3090 (AIX)"
setenv APL3090         $AIPS_VERSION/APL/DEV/UNIX/BERK/IBM/3090
#                                       "SunOS 4 (Solaris 1)"
setenv APLSUN          $AIPS_VERSION/APL/DEV/UNIX/BERK/SUN
#                                       "VAX"
setenv APLVAX          $AIPS_VERSION/APL/DEV/UNIX/BERK/VAX
#                                       "Generic VMS"
setenv APLVMS          $AIPS_VERSION/APL/DEV/VMS
#
# "--------------------------------------------------------------------"
# " Binary areas                                                       "
# "--------------------------------------------------------------------"
#
setenv AIPSBIN         $AIPS_VERSION/BIN
setenv AIPSFITS        $AIPS_VERSION/BIN/FITS
#
# "--------------------------------------------------------------------"
# " Documentation areas                                                "
# "--------------------------------------------------------------------"
#
setenv DOC             $AIPS_VERSION/DOC
setenv DOCTXT          $AIPS_VERSION/DOC/TEXT
#
# "--------------------------------------------------------------------"
# " Core dump area                                                     "
# "--------------------------------------------------------------------"
#
setenv ERRORS          $AIPS_VERSION/$ARCH/ERRORS/$HOST
#
# "--------------------------------------------------------------------"
# " HELP file area                                                     "
# "--------------------------------------------------------------------"
#
setenv HLPFIL          $AIPS_VERSION/HELP
#
# "--------------------------------------------------------------------"
# " History area                                                       "
# "--------------------------------------------------------------------"
#
setenv HIST            $AIPS_VERSION/HIST
#
# "--------------------------------------------------------------------"
# " INCLUDE file areas                                                 "
# "--------------------------------------------------------------------"
#
#                                       "Standard INCLUDEs"
setenv INC             $AIPS_VERSION/INC
#                                       "Non-standard INCLUDEs"
setenv INCNOT          $AIPS_VERSION/INC/NOTST
#                                       "GNU (readline)"
setenv INCGNU          $AIPS_VERSION/INC/NOTST/GNU
#                                       "Local"
setenv INCLOC          $AIPS_VERSION/INC/LOCAL
#                                       "Alliant"
setenv INCALN          $AIPS_VERSION/INC/NOTST/ALLN
#                                       "Alpha AXP Linux"
setenv INCAXL          $AIPS_VERSION/INC/NOTST/AXLINUX
#                                       "Power PC Linux"
setenv INCPPC          $AIPS_VERSION/INC/NOTST/LINUXPPC
#                                       "Cray Research Inc"
setenv INCCRI          $AIPS_VERSION/INC/NOTST/CRI
#                                       "Convex"
setenv INCVEX          $AIPS_VERSION/INC/NOTST/CVEX
#                                       "Digital (OSF/1, Ultrix)"
setenv INCDEC          $AIPS_VERSION/INC/NOTST/DEC
#                                       "HP-UX"
setenv INCHP           $AIPS_VERSION/INC/NOTST/HP
#                                       "HP-UX 2 (for PAPC, big AP)"
setenv INCHP2          $AIPS_VERSION/INC/NOTST/HP2
#                                       "IBM RS/6000"
setenv INCIBM          $AIPS_VERSION/INC/NOTST/IBM
#                                       "IBM 3090 (AIX)"
setenv INC3090         $AIPS_VERSION/INC/NOTST/IBM/3090
#                                       "Intel Linux"
setenv INCLIN          $AIPS_VERSION/INC/NOTST/LINUX
#                                       "Intel Linux 64bit"
setenv INCLNX64        $AIPS_VERSION/INC/NOTST/LNX64
#                                       "MacIntosh (Darwin OS/X)"
setenv INCMACPP        $AIPS_VERSION/INC/NOTST/MACPPC
#                                       "MacIntosh (Darwin OS/X) Intel"
setenv INCMACIN        $AIPS_VERSION/INC/NOTST/MACINT
#                                       "MacIntosh (Darwin OS/X) ARM"
setenv INCMACAR        $AIPS_VERSION/INC/NOTST/MACAEM
#                                       "Silicon Graphics IRIX"
setenv INCSGI          $AIPS_VERSION/INC/NOTST/SGI
#                                       "SunOS 5 (Solaris 2)"
setenv INCSOL          $AIPS_VERSION/INC/NOTST/SOL
#                                       "SunOS 5 (Solaris 2) UltraII"
setenv INCSUL          $AIPS_VERSION/INC/NOTST/SUL
#                                       "SunOS 4 (Solaris 1)"
setenv INCSUN          $AIPS_VERSION/INC/NOTST/SUN
#                                       "VMS"
setenv INCVMS          $AIPS_VERSION/INC/NOTST/VMS
#
# "--------------------------------------------------------------------"
# " Object module areas                                                "
# "--------------------------------------------------------------------"
#
#                                       "Subroutine object libraries"
setenv LIBR            $AIPS_VERSION/$ARCH/LIBR
#                                       "Debug version of libraries"
setenv LIBRDBG         $AIPS_VERSION/$ARCH/LIBRDBG
#                                       "Executable modules"
setenv LOAD            $AIPS_VERSION/$ARCH/LOAD
#                                       "Alternate executable modules"
#                                       "commented out; rarely used"
#                                       "LOAD1 is Pseudo AP w/wo TV 1"
#                                       " and is LOAD.ALT1"
#                                       "LOAD2 is for TV 2 w/wo real AP"
#                                       " and is LOAD.ALT2"
#                                       "LOAD3 is for TV 2 w Pseudo AP"
#                                       " and is LOAD.ALT3"
#
# "--------------------------------------------------------------------"
# "PREP area for temporary files (unix only)                           "
# "--------------------------------------------------------------------"
#
setenv PREP            $AIPS_VERSION/$ARCH/PREP
#
# "--------------------------------------------------------------------"
# " POPS memory file area                                              "
# "--------------------------------------------------------------------"
#
setenv MEMORY          $AIPS_VERSION/$ARCH/MEMORY
#
# "--------------------------------------------------------------------"
# " Q-routine areas (real and pseudo array processor)                  "
# "--------------------------------------------------------------------"
#
#                                       "Generic"
setenv QDEV            $AIPS_VERSION/Q/DEV
#                                       "Generic FPS"
setenv QFPS            $AIPS_VERSION/Q/DEV/FPS
#                                       "16 bit FPS"
setenv QFPS16          $AIPS_VERSION/Q/DEV/FPS/16B
#                                       "Model 120B FPS"
setenv Q120B           $AIPS_VERSION/Q/DEV/FPS/16B/120B
#                                       "Models 5105, 5205 ... FPS"
setenv Q5000           $AIPS_VERSION/Q/DEV/FPS/16B/5000
#                                       "32 bit FPS"
setenv QFPS32          $AIPS_VERSION/Q/DEV/FPS/32B
#                                       "Model 190 FPS"
setenv Q190            $AIPS_VERSION/Q/DEV/FPS/32B/190
#                                       "Generic pseudo AP"
setenv QPSAP           $AIPS_VERSION/Q/DEV/PSAP
#                                       "Alliant pseudo AP"
setenv QALN            $AIPS_VERSION/Q/DEV/PSAP/ALLN
#                                       "Cray Research Inc pseudo AP"
setenv QCRI            $AIPS_VERSION/Q/DEV/PSAP/CRI
#                                       "Convex pseudo AP"
setenv QVEX            $AIPS_VERSION/Q/DEV/PSAP/CVEX
#                                       "Digital: OSF/1, Ultrix"
setenv QDEC            $AIPS_VERSION/Q/DEV/PSAP/DEC
#                                       "HP-UX"
setenv QHP             $AIPS_VERSION/Q/DEV/PSAP/HP
#                                       "IBM RS/6000"
setenv QIBM            $AIPS_VERSION/Q/DEV/PSAP/IBM
#                                       "IBM 3090 (AIX)"
setenv Q3090           $AIPS_VERSION/Q/DEV/PSAP/IBM/3090
#                                       "Silicon Graphics IRIX PS-AP"
setenv QSGI            $AIPS_VERSION/Q/DEV/PSAP/SGI
#                                       "SunOS 5 (Solaris 2) pseudo AP"
setenv QSOL            $AIPS_VERSION/Q/DEV/PSAP/SOL
#                                       "SunOS 4 (Solaris 1) pseudo AP"
setenv QSUN            $AIPS_VERSION/Q/DEV/PSAP/SUN
#                                       "VMS pseudo AP"
setenv QVMS            $AIPS_VERSION/Q/DEV/PSAP/VMS
#
# "--------------------------------------------------------------------"
# " Programs that reference Q-routines                                 "
# "--------------------------------------------------------------------"
#
#                                       "Standard programs"
setenv QPGM            $AIPS_VERSION/Q/PGM
#                                       "Q-Object Oriented programs"
setenv QPGOOP          $AIPS_VERSION/Q/PGM/OOP
#                                       "Non-standard programs"
setenv QPGNOT          $AIPS_VERSION/Q/PGM/NOTST
#                                       "VMS programs"
setenv QPGVMS          $AIPS_VERSION/Q/PGM/NOTST/VMS
#
# "--------------------------------------------------------------------"
# " Subroutines that reference Q-routines                              "
# "--------------------------------------------------------------------"
#
#                                       "Standard routines"
setenv QSUB            $AIPS_VERSION/Q/SUB
#                                       "Object-oriented Q-routines"
setenv QOOP            $AIPS_VERSION/Q/SUB/OOP
#                                       "Non-standard routines"
setenv QNOT            $AIPS_VERSION/Q/SUB/NOTST
#
# "--------------------------------------------------------------------"
# " Programs that reference both Q-routines and Y-routines             "
# "--------------------------------------------------------------------"
#
#                                       "Standard programs"
setenv QYPGM           $AIPS_VERSION/QY/PGM
#                                       "Non-standard programs"
setenv QYPGNOT         $AIPS_VERSION/QY/PGM/NOTST
#                                       "VMS programs"
setenv QYPGVMS         $AIPS_VERSION/QY/PGM/NOTST/VMS
#
# "--------------------------------------------------------------------"
# " System RUN file area - useful procedures for everyone              "
# "--------------------------------------------------------------------"
#
setenv RUNSYS          $AIPS_VERSION/RUN
#
# "--------------------------------------------------------------------"
# " System manager areas                                               "
# "--------------------------------------------------------------------"
#
#                                       "Generic"
setenv SYSAIPS         $AIPS_VERSION/SYSTEM
#                                       "Generic UNIX"
setenv SYSUNIX         $AIPS_VERSION/SYSTEM/UNIX
#                                       "Generic PERL"
setenv SYSPERL         $AIPS_VERSION/SYSTEM/UNIX/PERL
#                                       "(Local) manual pages"
setenv SYSMAN          $AIPS_VERSION/SYSTEM/UNIX/manl
#                                       "Alliant"
setenv SYSALLN         $AIPS_VERSION/ALLN/SYSTEM
#                                       "Cray Research Inc"
setenv SYSCRI          $AIPS_VERSION/CRI/SYSTEM
#                                       "Convex"
setenv SYSCVEX         $AIPS_VERSION/CVEX/SYSTEM
#                                       "Decstation (Ultrix)"
setenv SYSDEC          $AIPS_VERSION/DEC/SYSTEM
#                                       "Digital Alpha (OSF/1)"
setenv SYSALPHA        $AIPS_VERSION/ALPHA/SYSTEM
#                                       "HP-UX"
setenv SYSHP           $AIPS_VERSION/HP/SYSTEM
#                                       "HP-UX"
setenv SYSHP2          $AIPS_VERSION/HP2/SYSTEM
#                                       "IBM RS/6000"
setenv SYSIBM          $AIPS_VERSION/IBM/SYSTEM
#                                       "IBM 3090 (AIX)"
setenv SYS3090         $AIPS_VERSION/IBM3090/SYSTEM
#                                       "Silicon Graphics IRIX"
setenv SYSSGI          $AIPS_VERSION/SGI/SYSTEM
#                                       "Linux/PC"
setenv SYSLINUX        $AIPS_VERSION/LINUX/SYSTEM
#                                       "Linux/PC 64bit"
setenv SYSLNX64        $AIPS_VERSION/LNX64/SYSTEM
#                                       "MacIntosh (Darwin OS/X)"
setenv SYSMACPP        $AIPS_VERSION/MACPPC/SYSTEM
#                                       "MacIntosh (Darwin OS/X) Intel"
setenv SYSMACIN        $AIPS_VERSION/MACINT/SYSTEM
#                                       "MacIntosh (Darwin OS/X) ARM"
setenv SYSMACAR        $AIPS_VERSION/MACARM/SYSTEM
#                                       "Linux/Alpha-AXP"
setenv SYSAXLIN        $AIPS_VERSION/AXLINUX/SYSTEM
#                                       "Linux/Power-PC"
setenv SYSPPLIN        $AIPS_VERSION/LINUXPPC/SYSTEM
#                                       "SunOS 5 (Solaris 2)"
setenv SYSSOL          $AIPS_VERSION/SOL/SYSTEM
#                                       "SunOS 5 (Solaris 2) UltraII"
setenv SYSSUL          $AIPS_VERSION/SUL/SYSTEM
#                                       "SunOS 5 (Solaris 2) iA86"
setenv SYSSOL86        $AIPS_VERSION/SOL86/SYSTEM
#                                       "SunOS 4 (Solaris 1)"
setenv SYSSUN          $AIPS_VERSION/SUN4/SYSTEM
#                                       "Old 68020/68030 Suns"
setenv SYSSUN3         $AIPS_VERSION/SUN3/SYSTEM
#                                       "UNIX installation"
setenv INSUNIX         $AIPS_VERSION/SYSTEM/UNIX/INSTALL
#                                       "UNIX midnight job"
setenv UPDUNIX         $AIPS_VERSION/SYSTEM/UNIX/UPDATE
#                                       "Generic VMS"
setenv SYSVMS          $AIPS_VERSION/SYSTEM/VMS
#                                       "Local VMS"
setenv SYSLVAX         $AIPS_VERSION/SYSTEM/VMS/LOCAL
#                                       "VMS installation"
setenv INSVMS          $AIPS_VERSION/SYSTEM/VMS/INSTALL
#                                       "VMS midnight job"
setenv UPDVMS          $AIPS_VERSION/SYSTEM/VMS/UPDATE
#
# "--------------------------------------------------------------------"
# " Y-routine areas                                                    "
# "--------------------------------------------------------------------"
#
#                                       "Generic"
setenv YGEN            $AIPS_VERSION/Y/DEV
#                                       "ARGS pipe from M70"
setenv YARGS           $AIPS_VERSION/Y/DEV/ARGS
#                                       "Deanza"
setenv YDEA            $AIPS_VERSION/Y/DEV/DEA
#                                       "IIS generic"
setenv YIIS            $AIPS_VERSION/Y/DEV/IIS
#                                       "IIS Model IVAS"
setenv YIVAS           $AIPS_VERSION/Y/DEV/IVAS
#                                       "IIS Model 70"
setenv YM70            $AIPS_VERSION/Y/DEV/IIS/M70
#                                       "IIS Model 75"
setenv YM75            $AIPS_VERSION/Y/DEV/IIS/M75
#                                       "Lexidata"
setenv YLEX            $AIPS_VERSION/Y/DEV/LEX
#                                       "Lexidata C code"
setenv YLEXC           $AIPS_VERSION/Y/DEV/LEX/LEXC
#                                       "Screen Servers SSS, XAS, XVSS"
setenv YSS             $AIPS_VERSION/Y/DEV/SS
#                                       "Stubbed"
setenv YSTUB           $AIPS_VERSION/Y/DEV/STUB
#                                       "Comtal Vision 1/20"
setenv YV20            $AIPS_VERSION/Y/DEV/V20
#                                       "Virtual TV"
setenv YVTV            $AIPS_VERSION/Y/DEV/VTV
#
# "--------------------------------------------------------------------"
# " Programs that reference Y-routines                                 "
# "--------------------------------------------------------------------"
#
#                                       "Standard programs"
setenv YPGM            $AIPS_VERSION/Y/PGM
#                                       "Virtual TV program"
setenv YPGVDEV         $AIPS_VERSION/Y/PGM/VDEV
#                                       "Non-standard programs"
setenv YPGNOT          $AIPS_VERSION/Y/PGM/NOTST
#                                       "VMS programs"
setenv YPGVMS          $AIPS_VERSION/Y/PGM/NOTST/VMS
#
#
# "--------------------------------------------------------------------"
# " Screen server programs                                             "
# "--------------------------------------------------------------------"
#
#                                       "Servers"
setenv YSERV           $AIPS_VERSION/Y/SERVERS
#
# "--------------------------------------------------------------------"
# " Subroutines that reference Y-routines                              "
# "--------------------------------------------------------------------"
#
#                                       "Standard routines"
setenv YSUB            $AIPS_VERSION/Y/SUB
#                                       "Non-standard routines"
setenv YNOT            $AIPS_VERSION/Y/SUB/NOTST

# CCOPTS.SH
#-----------------------------------------------------------------------
#;  Copyright (C) 1995, 1997
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# This script is used to assign definitions to the environment
# variables used by $SYSUNIX/CC.  These include 1) the name of the
# command name for the host C compiler, 2) the compiler
# oriented $SYSUNIX/CC options in terms of the host C compiler
# option syntax and the locally desired defaults for the other non-
# compiler oriented options of $SYSUNIX/CC.  Both compiler and non-
# compiler oriented options can be toggled by the use of 'option'
# (e.g. DEBUG) or 'NOoption' (e.g., NOPURGE) command line arguments
# to $SYSUNIX/CC or to any of the UNIX/AIPS programming shell
# scripts that invoke $SYS/CC (i.e., $SYSUNIX/COMRPL and
# $SYSUNIX/COMLNK).
#
# NOTE: These are options for compiling ONLY (see definition of
#       the environment variable 'COMP' below).  Options applicable
#       to the loader are defined in $SYSLOCAL/LDOPTS.SH.
#
# HP-UX version.
#--------------------------------------------------------------------

# Define AIPSCC compiler command name as the host C compiler command
# name (e.g., cc).

COMPILER=cc

# Define AIPSCC compiler oriented options in terms of the host C
# compiler command syntax.

#                                       Any options that may enhance
#                                       or may be required for the
#                                       usage of system debuggers.
DEBUG="-g"
#                                       Any of a wide variety of
#                                       optimization levels available
#                                       for UNIX C compilers and
#                                       combinations thereof.
#    Optimizing.  On HP-UX, -O means +O2.  Other meanings:
#    +O1 - basic
#    +O2 - all except inlining
#    +OV - volatile too
#    +O3 - ....
OPT0="-O"
OPT1=""
OPT2=""
OPT3=""
OPT4=""
OPT5=""
OPT6=""
OPT7=""
OPT8=""
OPT9=""

# Set default compiler oriented options .  Always specifiy the local
# compiler option for compile ONLY.  Also specify any options you want
# to apply to all C language compilations either using the environment
# variables defined above or hard coded local compiler option syntax.
# The -I$INC tells the compiler to look for header files in $INC.
# The -I$INC is essential to get the AIPSPROTO.H include file defined.

#  options suitable for version 1.1 systems  "HP"
#  options for newer (1997) version 2.0 systems "HP2"

#                                       Options for shared libraries.
#                                       The +Z enables PIC for Position
#                                       Independent Code (like sun -PIC)
if [ -f $SYSLOCAL/USESHARED ] ; then
   if [ "$ARCH" = "HP2" ] ; then
      COMP="+DA2.0 +DS2.0 -Ae +O2 -v -c -I$INC +Z -D_FILE64"
   else
      COMP="-Ae +O2 -v -c -I$INC +Z"
   fi
#                                       Options for static libraries.
else
   if [ "$ARCH" = "HP2" ] ; then
      COMP="+DA2.0 +DS2.0 -Ae +O2 -v -c -I$INC -D_FILE64"
   else
      COMP="-Ae +O2 -v -c -I$INC"
   fi
fi

# Set default values for other (i.e., non-compiler oriented) options
# recognized by AIPSCC.  These are purely a matter of preference,
# however the default settings exported with the UNIX/AIPS
# installation kits seem to make the most sense.

#                                       Generate source code listing?
LIST=FALSE
#                                       Purge, that is, delete any .c
#                                       and .LOG files associated with
#                                       a successful compilation and,
#                                       if LIST=FALSE, any extant .LIS
#                                       file associated with the
#                                       program/subroutine being
#                                       compiled (i.e., keep the AIPS
#                                       source code directories free
#                                       of trash files).
PURGE=TRUE

#!/bin/sh
#-----------------------------------------------------------------------
#;  Copyright (C) 1995, 1999, 2002
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# Usage: . TPDEVS.SH
#-----------------------------------------------------------------------
# AIPS Tape drive definitions are obtained here.  Set TPDEVS_QUIET to
# stop output.  Otherwise for each tape drive, the descriptive field in
# TPDEVS.LIST is printed, e.g. "Tape 4 is HP 9-track on HOSTNAME".
#
# Environment variables required:
#
#    HOST    The host name of the machine to run AIPS.
#    NET0    Location of TPDEVS.LIST
#
# Environment variables returned:
#
#    TAPEx   The device name of AIPS tape drive x (hex, 1-F)
#    NAIPST  The total number of tape devices, including remote.
#
# The last (NAIPST) is not yet used by AIPS but could be read by ZDCHIN
# in a similar way to NVOL for disks, in the future.
#
# To add a new tape drive, or to change existing definitions, edit the
# $NET0/TPDEVS.LIST file.
#
#-----------------------------------------------------------------------
#                                       Process tape definitions if any.
#                                       If not, just set two remote.
tapeno=1; export tapeno
quiet=0; export quiet
[ "$TPDEVS_QUIET" != "" ] && quiet=1
[ $quiet -eq 0 ] && echo "Tape assignments: "
tmpfil=/tmp/TPDEVS_${HOST}_$$; export tmpfil
[ -f $tmpfil ] && rm -f $tmpfil
if [ -f $NET0/TPDEVS.LIST ] ; then
#                                       Need to scan file to get them.
   touch $tmpfil; chmod +x $tmpfil
   if [ $quiet -eq 1 ] ; then
      grep "^$HOST " $NET0/TPDEVS.LIST | \
         awk '{printf "TAPE%d=%s; export TAPE%d\n",NR,$2,NR}
              END {printf "TAPE%d=REMOTE; export TAPE%d\n",NR+1,NR+1
	           printf "TAPE%d=REMOTE; export TAPE%d\n",NR+2,NR+2
		   printf "NAIPST=%d; export NAIPST\n",NR+2
	          }
             ' >>$tmpfil
   else
      grep "^$HOST " $NET0/TPDEVS.LIST | \
         awk '{printf "TAPE%d=%s; export TAPE%d; echo \"   Tape %d is",NR,$2,NR,NR
               if (NF > 2) {
                  for (i = 3; i <= NF; i++)
                     printf " %s",$i
                  printf "\" on %s\n",$1
                  }
               else
                  printf "\n"
              }
              END {printf "TAPE%d=REMOTE; export TAPE%d\n",NR+1,NR+1
                   printf "echo \"   Tape %d is REMOTE\"\n",NR+1
                   printf "TAPE%d=REMOTE; export TAPE%d\n",NR+2,NR+2
		   printf "echo \"   Tape %d is REMOTE\"\n",NR+2
		   printf "NAIPST=%d; export NAIPST\n",NR+2
		  }
              ' >>$tmpfil
   fi
   [ -s $tmpfil ] && . $tmpfil
else
   TAPE1=REMOTE; export TAPE1
   [ $quiet -eq 0 ] && echo "   Tape 1 is REMOTE"
   TAPE2=REMOTE; export TAPE2
   [ $quiet -eq 0 ] && echo "   Tape 2 is REMOTE"
   NAIPST=2; export NAIPST
fi
#                                       End of TPDEVS.SH, clean up.
[ -f $tmpfil ] && rm -f $tmpfil
[ $quiet -eq 0 ] && echo " "
if [ "$AIPSTP" = "" ] ; then
   AIPSTP="DONE"; export AIPSTP
fi

#-----------------------------------------------------------------------
#;  Copyright (C) 1995, 1998-1999, 2010, 2017
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# Usage: . DADEVS.SH
#-----------------------------------------------------------------------
# AIPS data disk requests are serviced here.  This script can be very
# inefficient, and is a fallback for the DADEVS.PL perl script in case a
# given site does not have perl (perl is significantly faster).
#
# Environment variables given:
#
#    DAOPT         Colon separated list of AIPS hosts whose disks are to
#                  be allocated.  If DAOPT=ALL, all disks will be
#                  allocated.
#
#    DADEVS_QUIET  YES if you want to suppress the disk listing
#
# Environment variables returned:
#
#    NVOL          The total number of data disks (decimal) - overides
#                  the value set in the SP file
#
#    DA0x          Where x is an "extended" hexadecimal digit in the
#                  range 01-1Z
#
# To add a new data disk, add its name to $NET0/DADEVS.LIST in order of
# priority.  Also add an entry to $NET0/NETSP.  Note: see below for the
# order in which list files are used.
#
# Users may control disk assignment via the "da=" option to the AIPS
# startup script.  By default, a user will be assigned all "required"
# disks, plus any attached to the local machine.  Required disks are
# indicated by a "+" in column 1 of DADEVS.LIST.  All other disk entries
# must have a "-" in column 1.
#
# However, if "da=default" is specified instead, the user will be
# assigned whatever disks are set in $AIPS_ROOT/AIPSASSN.CSH or
# $AIPS_ROOT/AIPSASSN.SH instead (depending on the user's shell).  Some
# sites may wish to customize this behaviour by making the string blank
# instead of "default".  Use of the "default" route speeds up the disk
# selection process (though DADEVS.PL is fast enough, if you have perl,
# to make this not matter).
#
# DADEVS.SH searches for list files in the following sequence:
#
#             $HOME/.dadevs.$SITE
#             $HOME/.dadevs
#             $DA00/DADEVS.LIST
#             $AIPS_ROOT/DA00/DADEVS.LIST.$SITE
#             $AIPS_ROOT/DA00/DADEVS.LIST
#
# Whichever file is found first is used EXCLUSIVE OF THE OTHERS.  The
# order in which the disks are listed is significant and is preserved in
# the final disk assignments.  Those with names matching the local host
# are included first, then those indicated as required in the list file,
# and finally any selected via the DA= option are included last.
#
# The first disk is special since it contains the AIPS message,
# save/get, and tput/tget files.  Some sites may choose to ensure that
# the same disk is always "disk 1" so that users have the same message
# files etc. wherever they run AIPS.  The downside of this is reduced
# performance in message writing if this first disk is NFS mounted.
#
# The only requirement for data disk names is that the actual directory
# name be of the form HOSTNAME_n where HOSTNAME must be the name of the
# host on which the disk resides, and n is a number.  The prefix is
# usually /DATA/ but need not be.  This is so the (presumably hostname
# based) selection criteria in DAOPT can be matched against the disks.
#
# All valid AIPS data disks must contain a file called SPACE, which is
# empty.  DADEVS.SH tests for the existence of this file to see if a
# disk is available to the system at the time that AIPS starts up.
#
# The file $AIPS_ROOT/DA00/NETSP has TIMDEST and booking information.
#-----------------------------------------------------------------------
#                                       Find the appropriate list file.
quiet=no
[ "$DADEVS_QUIET" = "YES" ] && quiet=yes
if [ -f "$HOME/.dadevs.$SITE" ] ; then
   LIST="$HOME/.dadevs.$SITE"
   DESC="private $SITE-specific"
elif [ -f "$HOME/.dadevs" ] ; then
   LIST="$HOME/.dadevs"
   DESC="private"
elif [ -f "$DA00/DADEVS.LIST" ] ; then
   LIST="$DA00/DADEVS.LIST"
   DESC="$HOST-specific"
elif [ -f "$NET0/DADEVS.LIST.$SITE" ] ; then
   LIST="$NET0/DADEVS.LIST.$SITE"
   DESC="$SITE-specific default"
elif [ -f "$NET0/DADEVS.LIST" ] ; then
   LIST="$NET0/DADEVS.LIST"
   DESC="global default"
else
   echo "DADEVS.SH error - could not find DADEVS/.dadevs list file."
   echo "This is a FATAL error and NOTHING in AIPS will work."
   LIST=/dev/null
fi
if [ "$LIST" != /dev/null ] ; then
   if [ "$quiet" = no ] ; then
      echo "  (Using $DESC file $LIST)"
   fi
fi
if [ -f "$HOME/.dadevs.always" ] ; then
   LLIST="$HOME/.dadevs.always"
else
   LLIST="/dev/null"
fi
#                                       Convert to uppercase, and
#                                       strip non-alphanumerics.
daopt=`echo $DAOPT | tr '[a-z]' '[A-Z]' | sed -e 's/[^A-Z0-9:]/:/g'`
#                                       Initialize number of volumes
nvol=0
echo "Using DADEVS.SH"
#                                       If options specified, check them
if [ "$daopt" != "DEFAULT" ] ; then
#                                       Process disk requests.
#                                       Solaris awk is brain dead.
   awk=awk
   case $ARCH in
      SUN*|S[OU]L*) awk=nawk;;
   esac
#                                       Faster to use awk than shell
#                                       features.  Accumulate three sets
#                                       of disks: required, local host,
#                                       and others, and define them in
#                                       that order.  4th list always
#                                       file
    ldefs=`egrep '^[-+]' $LLIST | $awk '
    BEGIN { ilus = 0;
          }
    $1 == "+" { ilus++; lus[ilus] = $2; next }
    END {
          for (i=1; i in lus; i++) {
             amatch=0
             for (j=1; j < i; j++) {
                if (lus[j] == lus[i]) {
                   amatch=1;
                }
             }
             for (j=1; j in req; j++) {
                if (lus[i] == req[j]) {
                   amatch=1
                }
                if (lus[i] == hst[j]) {
                   amatch=1
                }
             }
             if (amatch == 0) {
                print lus[i], " "
             }
          }
    }
   '`
    kdefs=`egrep '^[-+]' $LLIST | $awk '
    BEGIN { ikus = 0;
          }
    $1 == "-" { ikus++; kus[ikus] = $2; next }
    END {
          for (i=1; i in kus; i++) {
             amatch=0
             for (j=1; j < i; j++) {
                if (kus[j] == kus[i]) {
                   amatch=1;
                }
             }
             for (j=1; j in req; j++) {
                if (kus[i] == req[j]) {
                   amatch=1
                }
                if (kus[i] == hst[j]) {
                   amatch=1
                }
             }
             if (amatch == 0) {
                print kus[i], " "
             }
          }
    }
   '`
    defs=`egrep '^[-+]' $LIST | $awk '
    BEGIN { ireq = 0; ihost = 0;
            host = "'$HOST'";
          }
    $1 == "+" { ireq++; req[ireq] = $2; next }
    $2 ~ /'$HOST'_/ { ihost++; hst[ihost] = $2; next }
    $2 ~ /'$HOST'$/ { ihost++; hst[ihost] = $2; next }
    END { for (i=1; i in req; i++) {
             amatch=0;
             for (j=1; j < i; j++) {
                if (req[j] == req[i]) {
                   amatch=1;
                }
             }
             if (amatch == 0) {
                print req[i], " "
             }
          }
          for (i=1; i in hst; i++) {
             amatch=0;
             for (j=1; j < i; j++) {
                if (hst[j] == hst[i]) {
                   amatch=1;
                }
             }
             for (j=1; j in req; j++) {
                if (hst[i] == req[j]) {
                   amatch=1;
                }
             }
             if (amatch == 0) {
                print hst[i], " "
             }
          }
    }
   '`
    odefs=`egrep '^[-+]' $LIST | $awk '
    BEGIN { ioth = 0;
            daopt = "'$daopt'";
            split (daopt, arr, ":")
          }
    "'$daopt'" == "ALL" { ioth++; oth[ioth] = $2; next }
    {
       for (i in arr) {
          if ($2 ~ arr[i]) {
             ioth++; oth[ioth] = $2; next
          }
       }
    }
    END { for (i=1; i in oth; i++) {
             amatch=0
             for (j=1; j < i; j++) {
                if (oth[j] == oth[i]) {
                   amatch=1;
                }
             }
             for (j=1; j in req; j++) {
                if (oth[i] == req[j]) {
                   amatch=1
                }
                if (oth[i] == hst[j]) {
                   amatch=1
                }
             }
             if (amatch == 0) {
                print oth[i], " "
             }
          }
    }
   '`
#                                       Assign disks.
   for ENTRY in $ldefs ; do
#                                       Check for too many requests.
      if [ $nvol -lt 71 ] ; then
#                                       Ensure that the disk is mounted.
         if [ ! -f "$ENTRY/SPACE" ] ; then
            if [ $quiet = no ] ; then
               echo "             $ENTRY is currently unavailable."
            fi
         else
#                                       Add this disk.
            nvol=`expr $nvol + 1`
            nhex=`EHEX $nvol`
            if [ $nvol -lt 36 ] ; then
               eval "DA0$nhex=$ENTRY"; export DA0$nhex
            else
               eval "DA$nhex=$ENTRY"; export DA$nhex
               fi
            if [ $quiet = no ] ; then
               echo "   Disk $nvol ($nhex) is $ENTRY"
            fi
         fi
      else
         if [ $quiet = no ] ; then
            echo "             $ENTRY skipped (71 disk limit)"
         fi
      fi
   done
   for ENTRY in $defs ; do
#                                       Check for too many requests.
      if [ $nvol -lt 71 ] ; then
#                                       Ensure that the disk is mounted.
         if [ ! -f "$ENTRY/SPACE" ] ; then
            if [ $quiet = no ] ; then
               echo "             $ENTRY is currently unavailable."
            fi
         else
#                                       Add this disk.
            nvol=`expr $nvol + 1`
            nhex=`EHEX $nvol`
            if [ $nvol -lt 36 ] ; then
               eval "DA0$nhex=$ENTRY"; export DA0$nhex
            else
               eval "DA$nhex=$ENTRY"; export DA$nhex
               fi
            if [ $quiet = no ] ; then
               echo "   Disk $nvol ($nhex) is $ENTRY"
            fi
         fi
      else
         if [ $quiet = no ] ; then
            echo "             $ENTRY skipped (71 disk limit)"
         fi
      fi
   done
   for ENTRY in $kdefs ; do
#                                       Check for too many requests.
      if [ $nvol -lt 71 ] ; then
#                                       Ensure that the disk is mounted.
         if [ ! -f "$ENTRY/SPACE" ] ; then
            if [ $quiet = no ] ; then
               echo "             $ENTRY is currently unavailable."
            fi
         else
#                                       Add this disk.
            nvol=`expr $nvol + 1`
            nhex=`EHEX $nvol`
            if [ $nvol -lt 36 ] ; then
               eval "DA0$nhex=$ENTRY"; export DA0$nhex
            else
               eval "DA$nhex=$ENTRY"; export DA$nhex
               fi
            if [ $quiet = no ] ; then
               echo "   Disk $nvol ($nhex) is $ENTRY"
            fi
         fi
      else
         if [ $quiet = no ] ; then
            echo "             $ENTRY skipped (71 disk limit)"
         fi
      fi
   done
   for ENTRY in $odefs ; do
#                                       Check for too many requests.
      if [ $nvol -lt 71 ] ; then
#                                       Ensure that the disk is mounted.
         if [ ! -f "$ENTRY/SPACE" ] ; then
            if [ $quiet = no ] ; then
               echo "             $ENTRY is currently unavailable."
            fi
         else
#                                       Add this disk.
            nvol=`expr $nvol + 1`
            nhex=`EHEX $nvol`
            if [ $nvol -lt 36 ] ; then
               eval "DA0$nhex=$ENTRY"; export DA0$nhex
            else
               eval "DA$nhex=$ENTRY"; export DA$nhex
               fi
            if [ $quiet = no ] ; then
               echo "   Disk $nvol ($nhex) is $ENTRY"
            fi
         fi
      else
         if [ $quiet = no ] ; then
            echo "             $ENTRY skipped (71 disk limit)"
         fi
      fi
   done
else
#                                       da=default, so use defaults
#                                       as set in AIPSASSN.SH/.CSH
#                                       They are NOT CHECKED HERE for
#                                       performance reasons.
   if [ $quiet = no ] ; then
      echo "   (Use da=host to select other disks)"
   fi
   nhex=0
   while [ $nhex -lt 71 ] ; do
      nhex=`expr $nhex + 1`
      ehex=`EHEX $nhex`
      if [ $nhe -lt 36 ] ; then
         dname="\$DA0$ehex"
      else
         dname="\$DA$ehex"
      fi
      dname=`eval echo $dname`
      if [ "$dname" != "" ] ; then
         if [ $quiet = no ] ; then
            echo "   Disk $nhex ($ehex) is $dname"
         fi
         nvol=$nhex
      fi
   done
fi
if [ $quiet = no ] ; then
   echo " "
fi
#                                       Activate data disks via ZDCHIN
NVOL="$nvol"; export NVOL

#-----------------------------------------------------------------------
#;  Copyright (C) 1995, 2003
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# Usage: source LOGIN.CSH
#-----------------------------------------------------------------------
# Define where the AIPS shell scripts are.  This is usually the aips
# account's login area.  Set the "AIPS_ROOT" string to the correct area.
# This script usually for AIPS installers and programmers only.
#-----------------------------------------------------------------------
setenv AIPS_ROOT /DEFINE_ME
#  set to "YES" for local installation on portable computer
setenv LAPTOP "NO"
#
# Do not change anything below this line
#
if ( -d $AIPS_ROOT ) then
  if ( -f $AIPS_ROOT/HOSTS.CSH ) then
    source $AIPS_ROOT/HOSTS.CSH
  else
    echo "Error: no HOSTS.CSH file found in $AIPS_ROOT"
    echo "       Cannot proceed!"
    exit 2
  endif
  if ( -f $AIPS_ROOT/AIPSPATH.CSH ) then
    source $AIPS_ROOT/AIPSPATH.CSH
    if ( -f $AIPS_ROOT/AIPSASSN.CSH ) then
      source $AIPS_ROOT/AIPSASSN.CSH
    else
      echo "Warning: AIPSASSN.CSH not found in $AIPS_ROOT"
      echo "         Some or all of AIPS may not work"
    endif
  else
    echo "Error: AIPSPATH.CSH not found in $AIPS_ROOT"
    echo "       AIPS will not work"
  endif
else
  echo "Error: $AIPS_ROOT (\$AIPS_ROOT) is not a directory"
  echo "       (Check LOGIN.CSH and change the \$AIPS_ROOT definition there)"
endif

#!/bin/echo you_need_to_dot_this_file,_butthead
#-----------------------------------------------------------------------
#;  Copyright (C) 1999
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
#
# unaips - undefine the AIPS environment.  Useful for installs, etc.
#
if [ "$AIPS_ROOT" = "" ] ; then
  echo "AIPS_ROOT not defined, apparently no AIPS environment to undefine"
elif [ "$SYSUNIX" = "" ] ; then
  echo "SYSUNIX not defined, apparently no AIPS environment to undefine"
else
  newpath=""
  for i in `echo $PATH | sed -e 's/:/ /g'` ; do
    case $i in
      $AIPS_ROOT/*) ;;
      *) if [ "$newpath" = "" ] ; then
           newpath=$i
         else
           newpath="$newpath:$i"
         fi;;
    esac
  done
  PATH=$newpath; export PATH
  newpath=""
  for i in `echo $MANPATH | sed -e 's/:/ /g'` ; do
    case $i in
      $AIPS_ROOT/*) ;;
      *) if [ "$newpath" = "" ] ; then
           newpath=$i
         else
           newpath="$newpath:$i"
         fi;;
    esac
  done
  MANPATH=$newpath
  `cat $AIPS_VERSION/SYSTEM/AREAS.DAT | grep -v ^\! | \
   awk '{printf "unset %s\n", $1}'`
  `cat $AIPS_ROOT/AIPSASSN.SH | grep '^ *[A-Z0-9]*=' | \
   awk -F= '{printf "unset %s\n", $1}'`
  unset CDTST CDNEW CDOLD CDCVX LOAD SYSLOCAL TPATH HAVE_PERL AIPS_VERSION
  unset VERSION TST NEW OLD CVX ARCH HOSTS AIPS_ROOT HOST SITE
  unset DATA_ROOT BATCH_OUT SYSUNIX
fi

: "--------------------------------------------------------------------"
: "--------------------------------------------------------------------"
: ";  Copyright (C) 1995                                               "
: ";  Associated Universities, Inc. Washington DC, USA.                "
: ";                                                                   "
: ";  This program is free software; you can redistribute it and/or    "
: ";  modify it under the terms of the GNU General Public License as   "
: ";  published by the Free Software Foundation; either version 2 of   "
: ";  the License, or (at your option) any later version.              "
: ";                                                                   "
: ";  This program is distributed in the hope that it will be useful,  "
: ";  but WITHOUT ANY WARRANTY; without even the implied warranty of   "
: ";  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    "
: ";  GNU General Public License for more details.                     "
: ";                                                                   "
: ";  You should have received a copy of the GNU General Public        "
: ";  License along with this program; if not, write to the Free       "
: ";  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     "
: ";  MA 02139, USA.                                                   "
: ";                                                                   "
: ";  Correspondence concerning AIPS should be addressed as follows:   "
: ";         Internet email: aipsmail@nrao.edu.                        "
: ";         Postal address: AIPS Project Office                       "
: ";                         National Radio Astronomy Observatory      "
: ";                         520 Edgemont Road                         "
: ";                         Charlottesville, VA 22903-2475 USA        "
: "--------------------------------------------------------------------"
: " Usage: . $SYSLOCAL/INCS.SH                                         "
: "--------------------------------------------------------------------"
: " Bourne shell syntax to define the local include file search path.  "
: " INCS.SH is invoked by the source code preprocessor (PP) prior to   "
: " the execution of the program INCLUDE which processes VMS style     "
: " include statements.  The search path for include files is          "
: " installation dependent and consists of blank separated directory   "
: " names or environment variables defined as such.                    "
: "                                                                    "
: " Generic UNIX version.                                              "
: "--------------------------------------------------------------------"
:                                       "Generic UNIX search path."
: STDINCS="$INCUNIX $INCNOT $INC"
:                                       "But since $INCUNIX and"
:                                       "$INCNOT are currently empty,"
:                                       "speed up the search and skip"
:                                       "them.  Other directories can"
:                                       "be added as desired."
STDINCS="$INCIBM $INC"
export STDINCS

#-----------------------------------------------------------------------
#;  Copyright (C) 1995, 2003
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# Usage: source HOSTS.CSH
#-----------------------------------------------------------------------
# This file gets particulars about the network setup for AIPS from the
# HOSTS.LIST file.  Do not change this file; edit the HOSTS.LIST
# instead.
# The following environment variables identify each AIPS host or TV
# server in the local network.
#
#    HOST    Name of the machine (uppercase).
#
#    SITE    The local site name (uppercase).
#
#    HOSTS   List of all hosts which run AIPS at this site.
#
#    ARCH    Differentiates executables and libraries for different
#            machine architectures.
#
#-----------------------------------------------------------------------
#                                       Set the AIPS root directory.
setenv AIPS_ROOT /DEFINE_ME
#
# do not change anything below this line
#
#                                       Find the hosts file
if (! -d $AIPS_ROOT) then
  echo 'AIPS_ROOT is not correctly defined in the HOSTS.CSH script.'
  echo 'You need to run the AIPSROOT.DEFINE script (or get help).'
  exit 2
endif
#                                       Find the hosts file
if (! -f $AIPS_ROOT/HOSTS.LIST) then
  echo "HOSTS: Cannot find HOSTS.LIST in $AIPS_ROOT"
  echo 'HOSTS: Cannot proceed.  Help!'
  exit 2
endif
#                                       Set variable HOST.  Strip off
#                                       any domain name, use simple
#                                       hostname.  Also uppercase it.
setenv HOST `$AIPS_ROOT/SETUNAME`
#                                       Now look for this in HOSTS.LIST
set xxx = `grep "^[-+]  $HOST" $AIPS_ROOT/HOSTS.LIST`
#
if ( "$xxx" == "" ) then
  setenv ARCH "UNKNOWN"
  setenv SITE "UNKNOWN"
else
  setenv ARCH  $xxx[3]
  setenv SITE  $xxx[4]
  set xxx = `grep "^+.*$SITE" $AIPS_ROOT/HOSTS.LIST | awk '{ print $2 }'`
  setenv HOSTS "$xxx"
endif
unset xxx
exit 0

#!/bin/sh
# CCOPTS.SH
#-----------------------------------------------------------------------
#;  Copyright (C) 1995-2001, 2003, 2006, 2016, 2018-2019, 2022
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# Define variables used by $SYSUNIX/AIPSCC.  These include
#    1) command name for the host C compiler, and
#    2) C compiler options and AIPS style options.
# Both can be toggled by, e.g. NODEBUG or DEBUG, NOPURGE or PURGE...
#
# NOTE: These are options for compiling ONLY (see definition of the
#       environment variable 'COMP' below).  Options applicable to the
#       loader are defined in $SYSLOCAL/LDOPTS.SH.
#
#  Mac/INT version.
#--------------------------------------------------------------------
#                                       GNU gcc/g77
#  COMPILER=/usr/bin/gcc
#                                       IBM xlc/xlf
#  COMPILER=/opt/ibmcmp/vac/6.0/bin/xlc
#					Intel ICC
#  COMPILER=/opt/intel/cc/9.1.024/bin/icc
#  COMPILER=/usr/local/bin/icc
COMPILER=/usr/bin/gcc
#                                       System specific options.  Debug:
DEBUG="-g"
#                                       Optimizations (safe ones).
OPT0="-O1"
COMP="$OPT0 -I$INC -D_FILE_OFFSET_BITS=64"
case $COMPILER in
#                                       GNU g77
    *gcc*)
        OPT0="-O3 -fomit-frame-pointer -funroll-loops -mmacosx-version-min=10.14"
        COMP="$OPT0 -I$INC -D_FILE_OFFSET_BITS=64"
        COMP="$COMP -W -I/Library/Developer/CommandLineTools/SDKs/MacOSX.sdk/usr/include/"
        ;;
#                                       IBM compiler
    *xlc)
#       COMPILER=/opt/ibmcmp/xlf/8.1/bin/xlf
        OPT0="-O3"
#                                       Add for G5 machines w xlf
#       COMP="$COMP -qarch=ppc970 -qtune=ppc970"
        ;;
#                                       Intel compiler
    *ifc)
        OPT0="-O2 -unroll"
        COMP="$OPT0 -I$INC -D_FILE_OFFSET_BITS=64"
        ;;
#                                       New Intel compiler
    *icc*)
        OPT0="-O3 -ip"
        COMP="$OPT0 -I$INC -D_FILE_OFFSET_BITS=64 -mmacosx-version-min=10.7"
        ;;

#                                       Some other compiler.  If f2c,
#                                       set some sensible options.
    *)
        OPT0="-O1"
        ;;
esac
OPT1="$OPT0"
OPT2="$OPT1"
OPT3="$OPT2"
OPT4="$OPT3"
OPT5="$OPT4"
OPT6="$OPT5"
OPT7="$OPT6"
OPT8="$OPT7"
OPT9="$OPT8"
#
#                                       Options for static libraries.
#                                       MUST BE CONSISTENT between this,
#                                       LDOPTS.SH and FDEFAULT.SH
#                                       (latter in $SYSUNIX).
#
#                                       For glibc-based systems,
#                                       e.g. Red Hat 5.0 and later.
[ -f /lib/libc.so.6* ] && COMP="$COMP -DHAVE_LINUX_GLIBC"
#
#                                       AIPS style options
#                                       Generate source code listing?
LIST=FALSE
#                                       Purge: delete .c, .LOG files.
#                                       if LIST=FALSE, also  .LIS files.
PURGE=TRUE
#                                       End

# ASOPTS.SH
#-----------------------------------------------------------------------
#;  Copyright (C) 1995
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
#-----------------------------------------------------------------------
# This file sets values for environment variables used by $SYSUNIX/AS.
# These include the command name for the host assembler, and its options 
# as well as locally desired defaults for AIPS options such as PURGE.
# Both AIPS and assembler options can be negated via "NO", e.g. NOPURGE,
# or NOOPT0.
#
# NOTE: These are options for assembling ONLY (see definition of
#       the environment variable 'COMP' below).  Options applicable
#       to the loader are defined in $SYSLOCAL/LDOPTS.SH.
#
# Generic Unix version.  Most implementations will not need this file.
#-----------------------------------------------------------------------

# Define AIPS assembler command as the host assembler command (e.g., as).

ASSEMBLER="as"

# Define AIPS assembler options in terms of the local syntax
#
#                                       Any options that may enhance
#                                       or may be required for the
#                                       usage of system debuggers.
DEBUG=""
#                                       Any of a wide variety of
#                                       optimization levels available
#                                       for UNIX assemblers and
#                                       combinations thereof.
OPT0=""
OPT1=""
OPT2=""
OPT3=""
OPT4=""
OPT5=""
OPT6=""
OPT7=""
OPT8=""
OPT9=""

# Set default assembler oriented options .  Always specifiy the local
# assembler option for assemble ONLY.  Also specify any options you want
# to apply to all assemblies either using the environment variables
# defined above or hard coded local assembler option syntax.

COMP=""

# Set default values for other (i.e., non-assembler oriented) options
# recognized by AS.  These are purely a matter of preference, however
# the default settings exported with the UNIX/AIPS installation kits
# seem to make the most sense.
#                                       Generate source code listing?
LIST=FALSE
#                                       Purge, that is, delete any .s
#                                       and .LOG files associated with
#                                       a successful assembly and,
#                                       if LIST=FALSE, any extant .LIS
#                                       file associated with the
#                                       program/subroutine being
#                                       assembled (i.e., keep the AIPS
#                                       source code directories free
#                                       of trash files).
PURGE=TRUE

#-----------------------------------------------------------------------
#-----------------------------------------------------------------------
#;  Copyright (C) 1995, 1997
#;  Associated Universities, Inc. Washington DC, USA.
#;
#;  This program is free software; you can redistribute it and/or
#;  modify it under the terms of the GNU General Public License as
#;  published by the Free Software Foundation; either version 2 of
#;  the License, or (at your option) any later version.
#;
#;  This program is distributed in the hope that it will be useful,
#;  but WITHOUT ANY WARRANTY; without even the implied warranty of
#;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;  GNU General Public License for more details.
#;
#;  You should have received a copy of the GNU General Public
#;  License along with this program; if not, write to the Free
#;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
#;  MA 02139, USA.
#;
#;  Correspondence concerning AIPS should be addressed as follows:
#;         Internet email: aipsmail@nrao.edu.
#;         Postal address: AIPS Project Office
#;                         National Radio Astronomy Observatory
#;                         520 Edgemont Road
#;                         Charlottesville, VA 22903-2475 USA
#-----------------------------------------------------------------------
# CCOPTS.SH
#-----------------------------------------------------------------------
# This script is used to assign definitions to the environment variables
# used by $SYSUNIX/AIPSCC.  These include
#    1) the name of the command name for the host C compiler, and
#    2) the compiler oriented AIPSCC options in terms of the host C
#       compiler option syntax and the locally desired defaults for the
#       other non-compiler oriented options of AIPSCC.
# Both compiler and non-compiler oriented options can be toggled by the
# use of 'option' (e.g. DEBUG) or 'NOoption' (e.g., NOPURGE) command
# line arguments to AIPSCC or to any of the UNIX/AIPS programming shell
# scripts that invoke AIPSCC (i.e. COMRPL and COMLNK).
#
# NOTE: These are options for compiling ONLY (see definition of the
#       environment variable 'COMP' below).  Options applicable to the
#       loader are defined in $SYSLOCAL/LDOPTS.SH.
#
# SGI version
#-----------------------------------------------------------------------
# Define compiler command name as the host C compiler command name.

COMPILER="/usr/bin/cc"

# Define compiler oriented options in terms of the host C compiler
# command syntax.

#                                       Any options that may enhance or
#                                       may be required for the usage of
#                                       system debuggers.
DEBUG="-g"
#                                       Any of a wide variety of
#                                       optimization levels available
#                                       for UNIX C compilers and
#                                       combinations thereof.
OPT0="-g"
OPT1=""
OPT2=""
OPT3=""
OPT4=""
OPT5=""
OPT6=""
OPT7=""
OPT8=""
OPT9=""

# Set default compiler oriented options .  Always specify the compiler
# option for compile ONLY (-c usually).  Also set any options you want
# to apply to all C compilations, using the environment variables
# defined above (or hard coded local compiler options if you must).
# SGI version; use Berkeley library.  Note: if SGI's support shared
# libraries, put a test here for $SYSLOCAL/USESHARED and modify the
# qualifiers accordingly (see the SUN or HP versions for an example).
# The -I$INC is essential to enable the AIPSPROTO.H file to be included.

COMP="-c -I$INC -I/usr/include/bsd $OPT0"

# Set default values for other (i.e., non-compiler oriented) options
# recognized by AIPSCC.  These are purely a matter of preference,
# however the default settings exported with the UNIX/AIPS installation
# kits seem to make the most sense.

#                                       Generate source code listing?
LIST=FALSE
#                                       Purge, that is, delete any .c
#                                       and .LOG files associated with a
#                                       successful compilation and, if
#                                       LIST=FALSE, any extant .LIS file
#                                       associated with the program or
#                                       subroutine being compiled (i.e.
#                                       keep the AIPS source code direc-
#                                       tories free of trash files).
PURGE=TRUE
